var Module = {};
var preloadComplete = false;

Module['noInitialRun'] = true;
Module['OpenModelica_readFile'] = function(fname) {
  return intArrayToString(FS.findObject(fname).contents);
};
Module['OpenModelica_readFileBuffer'] = function(fname) {
  return FS.findObject(fname).contents;
};

try { // Try to add an event listener like a webworker thread
  self.addEventListener('message', function(e) {
    var data = e.data;
    if (!data) return;
    if (data.preload) {
      var error = function() {console.log('error...'); /* self.postError({message: "Preload failed"}); */ };
      if (!preloadComplete) {
        FS.createPreloadedFile('/', data.basename + "_init.xml", data.basename + "_init.xml", true, false, function() {
        FS.createLazyFile('/', data.basename + "_info.xml", data.basename + "_info.xml", true, false);
        preloadComplete = true;
        self.postMessage({preloaded:true});
      }, error);
      } else {
        self.postMessage({preloaded:true});
      }
      return;
    }
    var result = {};
    result.status = "Simulation failed"
    try {
      shouldRunNow = true;
      var args = ['-override','outputFormat=csv,stopTime=' +  data.stopTime +',tolerance=' + data.tolerance + ',stepSize=' + data.stepSize];
      Module.callMain(args);
      result.csv = intArrayToString(FS.findObject(data.basename + "_res.csv").contents);
      result.status = "Simulation finished";

  } catch(e) {
  }
  self.postMessage(result);
  }, false);
} catch (e) {
}

// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 536870912;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===
var __ZTVN10__cxxabiv117__class_type_infoE = 122264;
var __ZTVN10__cxxabiv120__si_class_type_infoE = 122304;




STATIC_BASE = 8;

STATICTOP = STATIC_BASE + Runtime.alignMemory(123131);
/* global initializers */ __ATINIT__.push({ func: function() { __GLOBAL__I_a() } });


/* memory initializer */ allocate([0,0,0,0,0,0,0,0,95,112,114,111,102,46,100,97,116,97,0,0,0,0,0,0,119,98,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,111,112,101,110,101,100,58,32,37,115,0,0,0,0,0,0,0,0,111,102,102,115,101,116,32,118,97,108,117,101,32,102,111,114,32,116,104,101,32,110,101,120,116,32,115,116,101,112,58,32,37,46,49,48,102,0,0,0,99,97,108,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,32,40,115,116,101,112,83,105,122,101,58,32,37,103,41,0,0,0,0,0,0,0,0,82,117,110,110,105,110,103,0,37,115,32,101,118,101,110,116,32,97,116,32,116,105,109,101,32,37,46,49,50,103,0,0,116,105,109,101,0,0,0,0,115,116,97,116,101,0,0,0,68,105,115,97,98,108,101,100,32,116,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,98,101,99,97,117,115,101,32,116,104,101,32,111,117,116,112,117,116,32,102,105,108,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,103,101,110,101,114,97,116,101,100,58,32,37,115,0,0,0,83,105,109,117,108,97,116,105,111,110,32,99,97,108,108,32,116,101,114,109,105,110,97,116,101,40,41,32,97,116,32,116,105,109,101,32,37,102,10,77,101,115,115,97,103,101,32,58,32,37,115,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,73,110,116,101,103,114,97,116,111,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,109,105,120,101,100,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,112,114,111,98,97,98,108,121,32,97,32,115,116,114,111,110,103,32,99,111,109,112,111,110,101,110,116,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,102,108,97,103,115,32,45,108,118,32,76,79,71,95,78,76,83,44,32,76,79,71,95,76,83,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,1,0,0,0,246,0,0,0,82,49,49,46,67,97,112,97,99,105,116,111,114,49,46,67,0,0,0,0,0,0,0,0,1,0,0,0,251,0,0,0,82,49,48,46,67,97,112,97,99,105,116,111,114,49,46,67,0,0,0,0,0,0,0,0,1,0,0,0,2,1,0,0,82,55,46,67,97,112,97,99,105,116,111,114,49,46,67,0,1,0,0,0,9,1,0,0,82,112,49,46,67,97,112,97,99,105,116,111,114,49,46,67,0,0,0,0,0,0,0,0,1,0,0,0,14,1,0,0,82,51,46,67,97,112,97,99,105,116,111,114,49,46,67,0,1,0,0,0,20,1,0,0,82,50,46,67,97,112,97,99,105,116,111,114,49,46,67,0,1,0,0,0,29,1,0,0,82,57,46,67,97,112,97,99,105,116,111,114,49,46,67,0,1,0,0,0,34,1,0,0,67,55,46,67,0,0,0,0,1,0,0,0,36,1,0,0,82,56,46,67,97,112,97,99,105,116,111,114,49,46,67,0,1,0,0,0,43,1,0,0,82,53,46,67,97,112,97,99,105,116,111,114,49,46,67,0,1,0,0,0,49,1,0,0,67,51,46,67,0,0,0,0,1,0,0,0,52,1,0,0,82,52,46,67,97,112,97,99,105,116,111,114,49,46,67,0,1,0,0,0,61,1,0,0,82,49,46,67,97,112,97,99,105,116,111,114,49,46,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,1,0,0,0,3,0,0,0,13,0,0,0,4,0,0,0,14,0,0,0,6,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,69,114,114,111,114,32,119,104,105,108,101,32,105,110,105,116,105,97,108,105,122,101,32,68,97,116,97,0,0,0,0,0,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,65,110,97,108,111,103,46,69,120,97,109,112,108,101,115,46,67,97,117,101,114,76,111,119,80,97,115,115,83,67,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,65,110,97,108,111,103,47,69,120,97,109,112,108,101,115,0,123,56,99,52,101,56,49,48,102,45,51,100,102,51,45,52,97,48,48,45,56,50,55,54,45,49,55,54,102,97,51,99,57,102,57,101,48,125,0,0,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,65,110,97,108,111,103,46,69,120,97,109,112,108,101,115,46,67,97,117,101,114,76,111,119,80,97,115,115,83,67,95,105,110,102,111,46,120,109,108,0,0,0,0,0,83,116,97,99,107,32,111,118,101,114,102,108,111,119,32,100,101,116,101,99,116,101,100,32,97,110,100,32,119,97,115,32,110,111,116,32,99,97,117,103,104,116,46,10,83,101,110,100,32,117,115,32,97,32,98,117,103,32,114,101,112,111,114,116,32,97,116,32,104,116,116,112,115,58,47,47,116,114,97,99,46,111,112,101,110,109,111,100,101,108,105,99,97,46,111,114,103,47,79,112,101,110,77,111,100,101,108,105,99,97,47,110,101,119,116,105,99,107,101,116,10,32,32,32,32,73,110,99,108,117,100,101,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,116,114,97,99,101,58,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,115,97,109,112,108,101,45,105,110,116,101,114,118,97,108,32,60,61,32,48,46,48,0,0,216,7,0,0,248,7,0,0,96,8,0,0,200,8,0,0,48,9,0,0,152,9,0,0,0,10,0,0,104,10,0,0,208,10,0,0,56,11,0,0,160,11,0,0,8,12,0,0,116,105,109,101,32,60,32,86,46,115,105,103,110,97,108,83,111,117,114,99,101,46,115,116,97,114,116,84,105,109,101,0,116,105,109,101,32,62,61,32,82,52,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,97,110,100,32,116,105,109,101,32,60,32,82,52,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,43,32,82,52,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,84,119,105,100,116,104,0,0,0,0,0,0,116,105,109,101,32,62,61,32,82,53,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,97,110,100,32,116,105,109,101,32,60,32,82,53,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,43,32,82,53,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,84,119,105,100,116,104,0,0,0,0,0,0,116,105,109,101,32,62,61,32,82,56,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,97,110,100,32,116,105,109,101,32,60,32,82,56,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,43,32,82,56,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,84,119,105,100,116,104,0,0,0,0,0,0,116,105,109,101,32,62,61,32,82,57,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,97,110,100,32,116,105,109,101,32,60,32,82,57,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,43,32,82,57,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,84,119,105,100,116,104,0,0,0,0,0,0,116,105,109,101,32,62,61,32,82,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,97,110,100,32,116,105,109,101,32,60,32,82,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,43,32,82,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,84,119,105,100,116,104,0,0,0,0,0,0,116,105,109,101,32,62,61,32,82,50,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,97,110,100,32,116,105,109,101,32,60,32,82,50,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,43,32,82,50,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,84,119,105,100,116,104,0,0,0,0,0,0,116,105,109,101,32,62,61,32,82,51,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,97,110,100,32,116,105,109,101,32,60,32,82,51,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,43,32,82,51,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,84,119,105,100,116,104,0,0,0,0,0,0,116,105,109,101,32,62,61,32,82,112,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,97,110,100,32,116,105,109,101,32,60,32,82,112,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,43,32,82,112,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,84,119,105,100,116,104,0,0,0,116,105,109,101,32,62,61,32,82,55,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,97,110,100,32,116,105,109,101,32,60,32,82,55,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,43,32,82,55,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,84,119,105,100,116,104,0,0,0,0,0,0,116,105,109,101,32,62,61,32,82,49,48,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,97,110,100,32,116,105,109,101,32,60,32,82,49,48,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,43,32,82,49,48,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,84,119,105,100,116,104,0,0,0,116,105,109,101,32,62,61,32,82,49,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,97,110,100,32,116,105,109,101,32,60,32,82,49,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,43,32,82,49,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,84,119,105,100,116,104,0,0,0,1,0,0,0,54,1,0,0,1,0,0,0,46,1,0,0,1,0,0,0,40,1,0,0,1,0,0,0,31,1,0,0,1,0,0,0,25,1,0,0,1,0,0,0,23,1,0,0,1,0,0,0,17,1,0,0,1,0,0,0,11,1,0,0,1,0,0,0,5,1,0,0,1,0,0,0,255,0,0,0,1,0,0,0,249,0,0,0,1,0,0,0,243,0,0,0,112,12,0,0,120,12,0,0,128,12,0,0,136,12,0,0,144,12,0,0,152,12,0,0,160,12,0,0,168,12,0,0,176,12,0,0,184,12,0,0,192,12,0,0,200,12,0,0,116,105,109,101,32,62,61,32,82,52,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,0,0,0,0,0,0,116,105,109,101,32,60,32,82,52,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,43,32,82,52,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,84,119,105,100,116,104,0,0,0,0,0,116,105,109,101,32,62,61,32,82,53,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,0,0,0,0,0,0,116,105,109,101,32,60,32,82,53,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,43,32,82,53,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,84,119,105,100,116,104,0,0,0,0,0,116,105,109,101,32,62,61,32,82,56,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,0,0,0,0,0,0,116,105,109,101,32,60,32,82,56,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,43,32,82,56,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,84,119,105,100,116,104,0,0,0,0,0,116,105,109,101,32,62,61,32,82,57,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,0,0,0,0,0,0,116,105,109,101,32,60,32,82,57,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,43,32,82,57,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,84,119,105,100,116,104,0,0,0,0,0,116,105,109,101,32,62,61,32,82,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,0,0,0,0,0,0,116,105,109,101,32,60,32,82,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,43,32,82,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,84,119,105,100,116,104,0,0,0,0,0,116,105,109,101,32,62,61,32,82,50,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,0,0,0,0,0,0,116,105,109,101,32,60,32,82,50,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,43,32,82,50,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,84,119,105,100,116,104,0,0,0,0,0,116,105,109,101,32,62,61,32,82,51,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,0,0,0,0,0,0,116,105,109,101,32,60,32,82,51,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,43,32,82,51,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,84,119,105,100,116,104,0,0,0,0,0,116,105,109,101,32,62,61,32,82,112,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,0,0,0,0,0,116,105,109,101,32,60,32,82,112,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,43,32,82,112,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,84,119,105,100,116,104,0,0,0,116,105,109,101,32,62,61,32,82,55,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,0,0,0,0,0,0,116,105,109,101,32,60,32,82,55,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,43,32,82,55,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,84,119,105,100,116,104,0,0,0,0,0,116,105,109,101,32,62,61,32,82,49,48,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,0,0,0,0,0,116,105,109,101,32,60,32,82,49,48,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,43,32,82,49,48,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,84,119,105,100,116,104,0,0,0,116,105,109,101,32,62,61,32,82,49,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,0,0,0,0,0,116,105,109,101,32,60,32,82,49,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,43,32,82,49,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,84,119,105,100,116,104,0,0,0,216,7,0,0,0,13,0,0,40,13,0,0,104,13,0,0,144,13,0,0,208,13,0,0,248,13,0,0,56,14,0,0,96,14,0,0,160,14,0,0,200,14,0,0,8,15,0,0,48,15,0,0,112,15,0,0,152,15,0,0,216,15,0,0,0,16,0,0,64,16,0,0,104,16,0,0,168,16,0,0,208,16,0,0,16,17,0,0,56,17,0,0,0,0,0,0,99,104,101,99,107,32,102,111,114,32,100,105,115,99,114,101,116,101,32,99,104,97,110,103,101,115,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,49,49,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,49,48,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,57,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,56,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,55,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,54,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,53,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,52,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,51,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,50,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,49,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,82,52,46,95,66,111,111,108,101,97,110,80,117,108,115,101,49,46,95,121,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,82,52,46,95,66,111,111,108,101,97,110,80,117,108,115,101,49,46,95,112,117,108,115,83,116,97,114,116,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,82,53,46,95,66,111,111,108,101,97,110,80,117,108,115,101,49,46,95,121,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,82,53,46,95,66,111,111,108,101,97,110,80,117,108,115,101,49,46,95,112,117,108,115,83,116,97,114,116,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,82,56,46,95,66,111,111,108,101,97,110,80,117,108,115,101,49,46,95,121,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,82,56,46,95,66,111,111,108,101,97,110,80,117,108,115,101,49,46,95,112,117,108,115,83,116,97,114,116,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,82,57,46,95,66,111,111,108,101,97,110,80,117,108,115,101,49,46,95,121,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,82,57,46,95,66,111,111,108,101,97,110,80,117,108,115,101,49,46,95,112,117,108,115,83,116,97,114,116,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,82,49,46,95,66,111,111,108,101,97,110,80,117,108,115,101,49,46,95,121,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,82,49,46,95,66,111,111,108,101,97,110,80,117,108,115,101,49,46,95,112,117,108,115,83,116,97,114,116,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,82,50,46,95,66,111,111,108,101,97,110,80,117,108,115,101,49,46,95,121,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,82,50,46,95,66,111,111,108,101,97,110,80,117,108,115,101,49,46,95,112,117,108,115,83,116,97,114,116,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,82,51,46,95,66,111,111,108,101,97,110,80,117,108,115,101,49,46,95,121,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,82,51,46,95,66,111,111,108,101,97,110,80,117,108,115,101,49,46,95,112,117,108,115,83,116,97,114,116,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,82,112,49,46,95,66,111,111,108,101,97,110,80,117,108,115,101,49,46,95,121,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,82,112,49,46,95,66,111,111,108,101,97,110,80,117,108,115,101,49,46,95,112,117,108,115,83,116,97,114,116,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,82,55,46,95,66,111,111,108,101,97,110,80,117,108,115,101,49,46,95,121,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,82,55,46,95,66,111,111,108,101,97,110,80,117,108,115,101,49,46,95,112,117,108,115,83,116,97,114,116,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,82,49,48,46,95,66,111,111,108,101,97,110,80,117,108,115,101,49,46,95,121,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,82,49,48,46,95,66,111,111,108,101,97,110,80,117,108,115,101,49,46,95,112,117,108,115,83,116,97,114,116,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,82,49,49,46,95,66,111,111,108,101,97,110,80,117,108,115,101,49,46,95,121,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,82,49,49,46,95,66,111,111,108,101,97,110,80,117,108,115,101,49,46,95,112,117,108,115,83,116,97,114,116,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,0,0,0,82,52,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,45,32,82,52,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,115,116,97,114,116,84,105,109,101,0,82,53,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,45,32,82,53,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,115,116,97,114,116,84,105,109,101,0,82,56,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,45,32,82,56,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,115,116,97,114,116,84,105,109,101,0,82,57,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,45,32,82,57,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,115,116,97,114,116,84,105,109,101,0,82,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,45,32,82,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,115,116,97,114,116,84,105,109,101,0,82,50,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,45,32,82,50,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,115,116,97,114,116,84,105,109,101,0,82,51,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,45,32,82,51,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,115,116,97,114,116,84,105,109,101,0,82,112,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,45,32,82,112,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,82,55,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,45,32,82,55,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,115,116,97,114,116,84,105,109,101,0,82,49,48,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,45,32,82,49,48,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,82,49,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,117,108,115,83,116,97,114,116,32,45,32,82,49,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,56,26,0,0,112,26,0,0,168,26,0,0,224,26,0,0,24,27,0,0,80,27,0,0,136,27,0,0,192,27,0,0,0,28,0,0,56,28,0,0,120,28,0,0,0,0,0,0,117,112,100,97,116,105,110,103,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,91,37,100,93,58,32,37,115,32,61,32,37,103,0,0,0,1,0,0,0,1,0,0,0,82,49,49,46,82,0,0,0,1,0,0,0,4,0,0,0,82,49,48,46,82,0,0,0,1,0,0,0,7,0,0,0,82,55,46,82,0,0,0,0,1,0,0,0,10,0,0,0,82,112,49,46,82,0,0,0,1,0,0,0,13,0,0,0,82,51,46,82,0,0,0,0,1,0,0,0,16,0,0,0,82,50,46,82,0,0,0,0,1,0,0,0,19,0,0,0,82,49,46,82,0,0,0,0,1,0,0,0,22,0,0,0,82,57,46,82,0,0,0,0,1,0,0,0,25,0,0,0,82,56,46,82,0,0,0,0,1,0,0,0,28,0,0,0,82,53,46,82,0,0,0,0,1,0,0,0,31,0,0,0,82,52,46,82,0,0,0,0,1,0,0,0,39,0,0,0,108,50,32,42,32,49,46,51,57,50,50,55,48,50,48,51,48,50,53,0,0,0,0,0,1,0,0,0,43,0,0,0,108,49,32,42,32,50,46,57,48,54,57,57,55,55,50,48,48,54,52,0,0,0,0,0,1,0,0,0,68,0,0,0,82,49,49,46,67,97,112,97,99,105,116,111,114,49,46,67,0,0,0,0,0,0,0,0,1,0,0,0,75,0,0,0,82,49,48,46,67,97,112,97,99,105,116,111,114,49,46,67,0,0,0,0,0,0,0,0,1,0,0,0,82,0,0,0,82,55,46,67,97,112,97,99,105,116,111,114,49,46,67,0,1,0,0,0,89,0,0,0,82,112,49,46,67,97,112,97,99,105,116,111,114,49,46,67,0,0,0,0,0,0,0,0,1,0,0,0,96,0,0,0,82,51,46,67,97,112,97,99,105,116,111,114,49,46,67,0,1,0,0,0,103,0,0,0,82,50,46,67,97,112,97,99,105,116,111,114,49,46,67,0,1,0,0,0,111,0,0,0,82,49,46,67,97,112,97,99,105,116,111,114,49,46,67,0,1,0,0,0,118,0,0,0,82,57,46,67,97,112,97,99,105,116,111,114,49,46,67,0,1,0,0,0,127,0,0,0,67,55,46,67,0,0,0,0,1,0,0,0,128,0,0,0,82,56,46,67,97,112,97,99,105,116,111,114,49,46,67,0,1,0,0,0,136,0,0,0,82,53,46,67,97,112,97,99,105,116,111,114,49,46,67,0,1,0,0,0,146,0,0,0,67,51,46,67,0,0,0,0,1,0,0,0,147,0,0,0,82,52,46,67,97,112,97,99,105,116,111,114,49,46,67,0,117,112,100,97,116,105,110,103,32,109,105,110,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,97,120,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,110,111,109,105,110,97,108,45,118,97,108,117,101,115,0,117,112,100,97,116,105,110,103,32,115,116,97,114,116,45,118,97,108,117,101,115,0,0,0,1,0,0,0,120,1,0,0,108,49,32,42,32,50,46,57,48,54,57,57,55,55,50,48,48,54,52,0,0,0,0,0,1,0,0,0,121,1,0,0,108,50,32,42,32,49,46,51,57,50,50,55,48,50,48,51,48,50,53,0,0,0,0,0,1,0,0,0,136,1,0,0,82,52,46,82,0,0,0,0,1,0,0,0,139,1,0,0,82,53,46,82,0,0,0,0,1,0,0,0,142,1,0,0,82,56,46,82,0,0,0,0,1,0,0,0,145,1,0,0,82,57,46,82,0,0,0,0,1,0,0,0,148,1,0,0,82,49,46,82,0,0,0,0,1,0,0,0,151,1,0,0,82,50,46,82,0,0,0,0,1,0,0,0,154,1,0,0,82,51,46,82,0,0,0,0,1,0,0,0,157,1,0,0,82,112,49,46,82,0,0,0,1,0,0,0,160,1,0,0,82,55,46,82,0,0,0,0,1,0,0,0,163,1,0,0,82,49,48,46,82,0,0,0,1,0,0,0,166,1,0,0,82,49,49,46,82,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,49,46,67,97,112,97,99,105,116,111,114,49,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,49,46,67,97,112,97,99,105,116,111,114,49,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,65,110,97,108,111,103,47,66,97,115,105,99,46,109,111,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,101,114,105,111,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,101,114,105,111,100,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,66,108,111,99,107,115,47,83,111,117,114,99,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,62,61,32,49,101,45,54,48,32,97,110,100,32,82,49,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,60,61,32,49,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,65,110,97,108,111,103,47,73,100,101,97,108,46,109,111,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,65,110,97,108,111,103,47,73,110,116,101,114,102,97,99,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,49,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,49,46,82,32,62,61,32,49,101,45,49,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,65,110,97,108,111,103,47,69,120,97,109,112,108,101,115,47,67,97,117,101,114,76,111,119,80,97,115,115,83,67,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,48,46,67,97,112,97,99,105,116,111,114,49,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,48,46,67,97,112,97,99,105,116,111,114,49,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,48,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,101,114,105,111,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,48,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,101,114,105,111,100,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,48,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
/* memory initializer */ allocate([32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,48,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,62,61,32,49,101,45,54,48,32,97,110,100,32,82,49,48,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,60,61,32,49,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,48,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,48,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,48,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,48,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,48,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,48,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,48,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,48,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,48,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,48,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,48,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,48,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,48,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,48,46,82,32,62,61,32,49,101,45,49,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,55,46,67,97,112,97,99,105,116,111,114,49,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,55,46,67,97,112,97,99,105,116,111,114,49,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,55,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,101,114,105,111,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,55,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,101,114,105,111,100,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,55,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,55,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,62,61,32,49,101,45,54,48,32,97,110,100,32,82,55,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,60,61,32,49,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,55,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,55,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,55,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,55,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,55,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,55,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,55,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,55,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,55,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,55,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,55,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,55,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,55,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,55,46,82,32,62,61,32,49,101,45,49,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,112,49,46,67,97,112,97,99,105,116,111,114,49,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,112,49,46,67,97,112,97,99,105,116,111,114,49,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,112,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,101,114,105,111,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,112,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,101,114,105,111,100,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,112,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,112,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,62,61,32,49,101,45,54,48,32,97,110,100,32,82,112,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,60,61,32,49,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,112,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,112,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,112,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,112,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,112,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,112,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,112,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,112,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,112,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,112,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,112,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,112,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,112,49,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,112,49,46,82,32,62,61,32,49,101,45,49,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,51,46,67,97,112,97,99,105,116,111,114,49,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,51,46,67,97,112,97,99,105,116,111,114,49,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,51,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,101,114,105,111,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,51,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,101,114,105,111,100,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,51,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,51,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,62,61,32,49,101,45,54,48,32,97,110,100,32,82,51,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,60,61,32,49,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,51,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,51,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,51,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,51,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,51,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,51,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,51,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,51,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,51,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,51,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,51,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,51,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,51,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,51,46,82,32,62,61,32,49,101,45,49,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,50,46,67,97,112,97,99,105,116,111,114,49,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,50,46,67,97,112,97,99,105,116,111,114,49,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,50,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,101,114,105,111,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,50,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,101,114,105,111,100,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,50,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,50,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,62,61,32,49,101,45,54,48,32,97,110,100,32,82,50,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,60,61,32,49,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,50,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,50,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,50,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,50,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,50,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,50,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,50,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,50,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,50,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,50,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,50,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,50,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,50,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,50,46,82,32,62,61,32,49,101,45,49,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,46,67,97,112,97,99,105,116,111,114,49,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,46,67,97,112,97,99,105,116,111,114,49,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,101,114,105,111,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,101,114,105,111,100,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,62,61,32,49,101,45,54,48,32,97,110,100,32,82,49,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,60,61,32,49,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,49,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,49,46,82,32,62,61,32,49,101,45,49,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,152,38,0,0,87,0,0,0,3,0,0,0,88,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,57,46,67,97,112,97,99,105,116,111,114,49,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,57,46,67,97,112,97,99,105,116,111,114,49,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,57,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,101,114,105,111,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,57,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,101,114,105,111,100,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,57,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,57,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,62,61,32,49,101,45,54,48,32,97,110,100,32,82,57,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,60,61,32,49,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,57,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,57,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,57,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,57,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,57,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,57,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,57,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,57,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,57,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,57,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,57,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,57,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,57,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,57,46,82,32,62,61,32,49,101,45,49,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,56,46,67,97,112,97,99,105,116,111,114,49,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,56,46,67,97,112,97,99,105,116,111,114,49,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,56,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,101,114,105,111,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,56,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,101,114,105,111,100,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,56,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,56,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,62,61,32,49,101,45,54,48,32,97,110,100,32,82,56,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,60,61,32,49,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,56,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,56,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,56,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,56,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,56,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,56,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,56,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,56,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,56,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,56,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,56,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,56,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,56,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,56,46,82,32,62,61,32,49,101,45,49,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,53,46,67,97,112,97,99,105,116,111,114,49,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,53,46,67,97,112,97,99,105,116,111,114,49,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,53,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,101,114,105,111,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,53,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,101,114,105,111,100,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,53,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,53,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,62,61,32,49,101,45,54,48,32,97,110,100,32,82,53,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,60,61,32,49,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,53,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,53,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,53,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,53,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,53,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,53,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,53,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,53,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+10240);
/* memory initializer */ allocate([101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,53,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,53,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,53,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,53,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,53,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,53,46,82,32,62,61,32,49,101,45,49,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,52,46,67,97,112,97,99,105,116,111,114,49,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,52,46,67,97,112,97,99,105,116,111,114,49,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,52,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,101,114,105,111,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,52,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,112,101,114,105,111,100,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,208,33,0,0,221,10,0,0,5,0,0,0,222,10,0,0,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,52,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,52,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,62,61,32,49,101,45,54,48,32,97,110,100,32,82,52,46,66,111,111,108,101,97,110,80,117,108,115,101,49,46,119,105,100,116,104,32,60,61,32,49,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,208,33,0,0,218,10,0,0,5,0,0,0,220,10,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,52,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,52,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,52,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,52,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,52,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,52,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,52,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,52,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,48,35,0,0,55,1,0,0,5,0,0,0,56,1,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,52,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,52,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,48,35,0,0,54,1,0,0,5,0,0,0,54,1,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,52,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,52,46,73,100,101,97,108,67,111,109,109,117,116,105,110,103,83,119,105,116,99,104,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,120,36,0,0,50,1,0,0,5,0,0,0,51,1,0,0,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,52,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,52,46,82,32,62,61,32,49,101,45,49,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,152,38,0,0,8,0,0,0,3,0,0,0,9,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,57,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,57,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,56,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,56,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,55,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,55,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,54,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,54,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,53,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,53,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,52,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,52,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,51,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,51,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,50,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,50,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,49,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,49,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,8,33,0,0,27,1,0,0,5,0,0,0,27,1,0,0,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,53,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,53,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,152,38,0,0,170,0,0,0,3,0,0,0,170,0,0,0,75,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,52,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,52,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,152,38,0,0,168,0,0,0,3,0,0,0,169,0,0,0,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,152,38,0,0,167,0,0,0,3,0,0,0,167,0,0,0,74,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,152,38,0,0,165,0,0,0,3,0,0,0,166,0,0,0,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,152,38,0,0,164,0,0,0,3,0,0,0,164,0,0,0,74,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,152,38,0,0,163,0,0,0,3,0,0,0,163,0,0,0,75,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,152,38,0,0,162,0,0,0,3,0,0,0,162,0,0,0,74,0,0,0,0,0,0,0,109,111,100,101,108,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,69,108,101,99,116,114,105,99,97,108,95,65,110,97,108,111,103,95,69,120,97,109,112,108,101,115,95,67,97,117,101,114,76,111,119,80,97,115,115,83,67,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,110,32,61,32,49,54,59,32,47,47,32,115,116,97,116,101,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,107,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,105,110,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,108,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,111,117,116,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,120,48,91,49,54,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,117,48,91,48,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,65,91,49,54,44,49,54,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,66,91,49,54,44,48,93,32,61,32,122,101,114,111,115,40,49,54,44,48,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,67,91,48,44,49,54,93,32,61,32,122,101,114,111,115,40,48,44,49,54,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,68,91,48,44,48,93,32,61,32,122,101,114,111,115,40,48,44,48,41,59,37,115,10,32,32,82,101,97,108,32,120,91,49,54,93,40,115,116,97,114,116,61,120,48,41,59,10,32,32,105,110,112,117,116,32,82,101,97,108,32,117,91,48,93,59,10,32,32,111,117,116,112,117,116,32,82,101,97,108,32,121,91,48,93,59,10,10,32,32,82,101,97,108,32,120,95,80,82,49,49,80,67,97,112,97,99,105,116,111,114,49,80,118,32,61,32,120,91,49,93,59,10,32,32,82,101,97,108,32,120,95,80,82,49,48,80,67,97,112,97,99,105,116,111,114,49,80,118,32,61,32,120,91,50,93,59,10,32,32,82,101,97,108,32,120,95,80,82,55,80,67,97,112,97,99,105,116,111,114,49,80,118,32,61,32,120,91,51,93,59,10,32,32,82,101,97,108,32,120,95,80,82,112,49,80,67,97,112,97,99,105,116,111,114,49,80,118,32,61,32,120,91,52,93,59,10,32,32,82,101,97,108,32,120,95,80,82,51,80,67,97,112,97,99,105,116,111,114,49,80,118,32,61,32,120,91,53,93,59,10,32,32,82,101,97,108,32,120,95,80,82,50,80,67,97,112,97,99,105,116,111,114,49,80,118,32,61,32,120,91,54,93,59,10,32,32,82,101,97,108,32,120,95,80,82,49,80,67,97,112,97,99,105,116,111,114,49,80,118,32,61,32,120,91,55,93,59,10,32,32,82,101,97,108,32,120,95,80,82,57,80,67,97,112,97,99,105,116,111,114,49,80,118,32,61,32,120,91,56,93,59,10,32,32,82,101,97,108,32,120,95,80,82,56,80,67,97,112,97,99,105,116,111,114,49,80,118,32,61,32,120,91,57,93,59,10,32,32,82,101,97,108,32,120,95,80,82,53,80,67,97,112,97,99,105,116,111,114,49,80,118,32,61,32,120,91,49,48,93,59,10,32,32,82,101,97,108,32,120,95,80,82,52,80,67,97,112,97,99,105,116,111,114,49,80,118,32,61,32,120,91,49,49,93,59,10,32,32,82,101,97,108,32,120,95,80,67,55,80,118,32,61,32,120,91,49,50,93,59,10,32,32,82,101,97,108,32,120,95,80,67,52,80,118,32,61,32,120,91,49,51,93,59,10,32,32,82,101,97,108,32,120,95,80,67,51,80,118,32,61,32,120,91,49,52,93,59,10,32,32,82,101,97,108,32,120,95,80,67,50,80,118,32,61,32,120,91,49,53,93,59,10,32,32,82,101,97,108,32,120,95,80,67,49,80,118,32,61,32,120,91,49,54,93,59,10,32,32,32,32,32,32,10,101,113,117,97,116,105,111,110,10,32,32,100,101,114,40,120,41,32,61,32,65,32,42,32,120,32,43,32,66,32,42,32,117,59,10,32,32,121,32,61,32,67,32,42,32,120,32,43,32,68,32,42,32,117,59,10,101,110,100,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,69,108,101,99,116,114,105,99,97,108,95,65,110,97,108,111,103,95,69,120,97,109,112,108,101,115,95,67,97,117,101,114,76,111,119,80,97,115,115,83,67,59,10,0,0,68,71,69,82,32,32,0,0,78,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,68,71,69,77,77,32,0,0,76,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,84,82,83,77,32,0,0,68,71,69,83,86,32,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,68,71,69,84,70,50,0,0,83,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,68,71,69,84,82,70,0,0,1,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,191,78,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,71,69,84,82,83,0,0,1,0,0,0,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,85,112,112,101,114,0,0,0,78,111,110,45,117,110,105,116,0,0,0,0,0,0,0,0,84,114,97,110,115,112,111,115,101,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,71,69,0,0,0,0,0,0,84,82,70,0,0,0,0,0,81,82,70,0,0,0,0,0,82,81,70,0,0,0,0,0,76,81,70,0,0,0,0,0,81,76,70,0,0,0,0,0,72,82,68,0,0,0,0,0,66,82,68,0,0,0,0,0,84,82,73,0,0,0,0,0,80,79,0,0,0,0,0,0,83,89,0,0,0,0,0,0,84,82,68,0,0,0,0,0,71,83,84,0,0,0,0,0,72,69,0,0,0,0,0,0,79,82,0,0,0,0,0,0,81,82,0,0,0,0,0,0,82,81,0,0,0,0,0,0,76,81,0,0,0,0,0,0,81,76,0,0,0,0,0,0,72,82,0,0,0,0,0,0,84,82,0,0,0,0,0,0,66,82,0,0,0,0,0,0,85,78,0,0,0,0,0,0,71,66,0,0,0,0,0,0,80,66,0,0,0,0,0,0,76,65,0,0,0,0,0,0,85,85,77,0,0,0,0,0,83,84,0,0,0,0,0,0,69,66,90,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,99,0,0,176,99,0,0,192,99,0,0,216,99,0,0,248,99,0,0,8,100,0,0,32,100,0,0,48,100,0,0,72,100,0,0,104,100,0,0,144,100,0,0,168,100,0,0,200,100,0,0,224,100,0,0,8,101,0,0,40,101,0,0,88,101,0,0,136,101,0,0,160,101,0,0,216,101,0,0,240,101,0,0,32,102,0,0,64,102,0,0,120,102,0,0,160,102,0,0,216,102,0,0,8,103,0,0,24,103,0,0,56,103,0,0,96,103,0,0,128,103,0,0,168,103,0,0,208,103,0,0,232,103,0,0,0,104,0,0,16,104,0,0,40,104,0,0,88,104,0,0,168,104,0,0,232,104,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,115,121,110,116,97,120,32,101,114,114,111,114,0,0,0,0,110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0,0,0,0,0,0,0,0,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0,117,110,99,108,111,115,101,100,32,116,111,107,101,110,0,0,112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,109,105,115,109,97,116,99,104,101,100,32,116,97,103,0,0,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0,0,0,0,0,0,0,0,114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0,0,101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0,0,0,0,0,0,101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0,0,0,0,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0,0,0,0,117,110,98,111,117,110,100,32,112,114,101,102,105,120,0,0,109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0,0,0,0,0,0,0,105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0,0,0,0,0,0,0,112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0,0,0,0,0,0,0,0,112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0,0,0,0,112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0,112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0,0,0,0,0,0,112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,35,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,89,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,40,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,4,254,255,255,135,254,255,255,7,0,0,0,0,0,0,0,0,255,255,127,255,255,255,127,255,255,255,255,255,255,255,243,127,254,253,255,255,255,255,255,127,255,255,255,255,255,255,255,255,15,224,255,255,255,255,49,252,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,3,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,0,0,0,0,0,0,0,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,254,7,0,0,0,0,254,255,255,255,255,255,255,255,255,124,255,127,47,0,96,0,0,0,224,255,255,255,255,255,255,35,0,0,0,255,3,0,0,0,224,159,249,255,255,253,197,3,0,0,0,176,3,0,3,0,224,135,249,255,255,253,109,3,0,0,0,94,0,0,28,0,224,175,251,255,255,253,237,35,0,0,0,0,1,0,0,0,224,159,249,255,255,253,205,35,0,0,0,176,3,0,0,0,224,199,61,214,24,199,191,3,0,0,0,0,0,0,0,0,224,223,253,255,255,253,239,3,0,0,0,0,3,0,0,0,224,223,253,255,255,253,239,3,0,0,0,64,3,0,0,0,224,223,253,255,255,253,255,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,13,0,63,0,0,0,0,0,0,0,150,37,240,254,174,108,13,32,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,254,255,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,63,0,255,255,255,255,127,0,237,218,7,0,0,0,0,80,1,80,49,130,171,98,44,0,0,0,0,64,0,201,128,245,7,0,0,0,0,8,1,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,3,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,64,76,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,254,3,0,0,254,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,7,224,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,7,254,255,255,135,254,255,255,7,0,0,0,0,0,0,128,0,255,255,127,255,255,255,127,255,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,3,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,3,0,0,0,192,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,123,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,254,255,251,255,255,187,22,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,255,255,7,0,255,3,255,255,255,255,255,255,255,255,255,124,255,127,239,255,255,61,255,3,238,255,255,255,255,255,255,243,255,63,30,255,207,255,0,0,238,159,249,255,255,253,197,211,159,57,128,176,207,255,3,0,228,135,249,255,255,253,109,211,135,57,0,94,192,255,31,0,238,175,251,255,255,253,237,243,191,59,0,0,193,255,0,0,238,159,249,255,255,253,205,243,143,57,192,176,195,255,0,0,236,199,61,214,24,199,191,195,199,61,128,0,128,255,0,0,238,223,253,255,255,253,239,195,223,61,96,0,195,255,0,0,236,223,253,255,255,253,239,195,223,61,96,64,195,255,0,0,236,223,253,255,255,253,255,195,207,61,128,0,195,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,255,7,255,127,255,3,0,0,0,0,150,37,240,254,174,108,255,59,95,63,255,3,0,0,0,0,0,0,0,3,255,3,160,194,255,254,255,255,255,3,254,255,223,15,191,254,255,63,254,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,31,2,0,0,0,160,0,0,0,254,255,62,0,254,255,255,255,255,255,255,255,255,255,31,102,254,255,255,255,255,255,255,255,255,255,255,119,25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,24,119,0,0,168,117,0,0,48,116,0,0,184,114,0,0,184,114,0,0,64,113,0,0,48,116,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+20480);
/* memory initializer */ allocate([28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,224,129,0,0,104,126,0,0,248,124,0,0,136,123,0,0,136,123,0,0,24,122,0,0,248,124,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,101,114,115,105,111,110,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,121,101,115,0,0,0,0,0,110,111,0,0,0,0,0,0,40,128,0,0,56,128,0,0,72,128,0,0,24,113,0,0,80,128,0,0,96,128,0,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,65,84,84,76,73,83,84,0,69,76,69,77,69,78,84,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,69,77,80,84,89,0,0,0,65,78,89,0,0,0,0,0,80,67,68,65,84,65,0,0,192,131,0,0,200,131,0,0,208,131,0,0,216,131,0,0,80,131,0,0,224,131,0,0,240,131,0,0,248,131,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,73,77,80,76,73,69,68,0,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,0,70,73,88,69,68,0,0,0,78,68,65,84,65,0,0,0,73,78,67,76,85,68,69,0,73,71,78,79,82,69,0,0,68,79,67,84,89,80,69,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,76,79,71,95,85,78,75,78,79,87,78,0,0,0,0,0,115,116,100,111,117,116,0,0,97,115,115,101,114,116,0,0,76,79,71,95,68,68,65,83,82,84,0,0,0,0,0,0,76,79,71,95,68,69,66,85,71,0,0,0,0,0,0,0,76,79,71,95,68,83,83,0,76,79,71,95,68,83,83,95,74,65,67,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,0,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,95,86,0,0,0,0,76,79,71,95,73,78,73,84,0,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,95,70,85,76,76,0,0,76,79,71,95,73,80,79,80,84,95,74,65,67,0,0,0,76,79,71,95,73,80,79,80,84,95,72,69,83,83,69,0,76,79,71,95,74,65,67,0,76,79,71,95,76,83,0,0,76,79,71,95,76,83,95,86,0,0,0,0,0,0,0,0,76,79,71,95,78,76,83,0,76,79,71,95,78,76,83,95,86,0,0,0,0,0,0,0,76,79,71,95,78,76,83,95,74,65,67,0,0,0,0,0,76,79,71,95,78,76,83,95,82,69,83,0,0,0,0,0,76,79,71,95,82,69,83,95,73,78,73,84,0,0,0,0,76,79,71,95,83,73,77,85,76,65,84,73,79,78,0,0,76,79,71,95,83,79,76,86,69,82,0,0,0,0,0,0,76,79,71,95,83,79,84,73,0,0,0,0,0,0,0,0,76,79,71,95,83,84,65,84,83,0,0,0,0,0,0,0,76,79,71,95,85,84,73,76,0,0,0,0,0,0,0,0,76,79,71,95,90,69,82,79,67,82,79,83,83,73,78,71,83,0,0,0,0,0,0,0,88,132,0,0,104,132,0,0,112,132,0,0,120,132,0,0,136,132,0,0,152,132,0,0,160,132,0,0,176,132,0,0,192,132,0,0,208,132,0,0,224,132,0,0,240,132,0,0,0,133,0,0,16,133,0,0,32,133,0,0,40,133,0,0,48,133,0,0,64,133,0,0,72,133,0,0,88,133,0,0,104,133,0,0,120,133,0,0,136,133,0,0,152,133,0,0,168,133,0,0,184,133,0,0,200,133,0,0,216,133,0,0,117,110,107,110,111,119,110,0,116,104,105,115,32,115,116,114,101,97,109,32,105,115,32,97,108,119,97,121,115,32,97,99,116,105,118,101,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,97,115,115,108,32,115,111,108,118,101,114,0,0,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,100,101,98,117,103,32,105,110,102,111,114,109,97,116,105,111,110,0,0,0,0,111,117,116,112,117,116,115,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,106,97,99,111,98,105,97,110,32,111,102,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,101,118,101,110,116,32,115,121,115,116,101,109,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,0,0,0,99,104,101,99,107,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,0,0,0,0,0,0,0,99,104,101,99,107,32,104,101,115,115,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,117,115,101,100,32,98,121,32,100,97,115,115,108,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,101,118,101,114,121,32,101,118,97,108,117,97,116,105,111,110,32,111,102,32,116,104,101,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,114,101,115,105,100,117,97,108,115,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,105,109,117,108,97,116,105,111,110,32,112,114,111,99,101,115,115,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,111,108,118,101,114,32,112,114,111,99,101,115,115,0,0,0,0,0,102,105,110,97,108,32,115,111,108,117,116,105,111,110,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,115,116,97,116,105,115,116,105,99,115,32,97,98,111,117,116,32,116,105,109,101,114,47,101,118,101,110,116,115,47,115,111,108,118,101,114,0,63,63,63,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,116,104,101,32,122,101,114,111,99,114,111,115,115,105,110,103,115,0,0,96,134,0,0,104,134,0,0,104,134,0,0,136,134,0,0,184,134,0,0,216,134,0,0,16,135,0,0,64,135,0,0,112,135,0,0,144,135,0,0,192,135,0,0,216,135,0,0,248,135,0,0,32,136,0,0,64,136,0,0,112,136,0,0,144,136,0,0,184,136,0,0,216,136,0,0,0,137,0,0,48,137,0,0,104,137,0,0,144,137,0,0,192,137,0,0,240,137,0,0,24,138,0,0,72,138,0,0,80,138,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91,37,115,58,37,100,58,37,100,45,37,100,58,37,100,58,37,115,93,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,37,45,49,55,115,32,124,32,0,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,37,45,55,115,32,124,32,0,96,134,0,0,80,141,0,0,88,141,0,0,96,141,0,0,112,132,0,0,104,141,0,0,124,32,0,0,0,0,0,0,60,109,101,115,115,97,103,101,32,115,116,114,101,97,109,61,34,37,115,34,32,116,121,112,101,61,34,37,115,34,32,116,101,120,116,61,34,0,0,0,34,62,10,0,0,0,0,0,60,117,115,101,100,32,105,110,100,101,120,61,34,37,100,34,32,47,62,10,0,0,0,0,60,47,109,101,115,115,97,103,101,62,10,0,0,0,0,0,34,32,47,62,10,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,38,97,109,112,59,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,105,110,102,111,0,0,0,0,119,97,114,110,105,110,103,0,101,114,114,111,114,0,0,0,100,101,98,117,103,0,0,0,34,62,0,0,0,0,0,0,115,111,108,118,101,114,32,119,105,108,108,32,116,114,121,32,116,111,32,104,97,110,100,108,101,32,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,58,32,37,115,0,0,0,0,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,44,32,100,105,118,105,115,111,114,58,32,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,101,109,112,116,121,32,108,105,115,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,102,105,115,116,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,110,111,100,101,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,100,97,116,97,32,110,111,100,101,0,0,0,0,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,27,0,0,0,2,0,0,0,2,0,0,0,28,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,105,110,84,114,97,110,115,0,0,0,0,0,0,0,0,192,142,0,0,0,0,0,0,98,105,110,78,111,114,109,97,108,0,0,0,0,0,0,0,216,142,0,0,0,0,0,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,100,97,116,97,95,50,0,0,240,142,0,0,248,142,0,0,0,143,0,0,16,143,0,0,32,143,0,0,40,143,0,0,51,0,0,0,51,0,0,0,51,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,49,41,0,0,0,0,0,0,77,97,116,114,105,120,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,0,0,0,77,97,116,114,105,120,32,117,115,101,115,32,105,109,97,103,105,110,97,114,121,32,110,117,109,98,101,114,115,0,0,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,105,122,101,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,50,41,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,51,41,0,0,0,0,0,0,77,97,116,114,105,120,32,110,97,109,101,32,109,105,115,109,97,116,99,104,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,52,32,114,111,119,115,0,0,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,49,32,99,111,108,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,65,99,108,97,115,115,32,109,97,116,114,105,120,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,98,105,110,84,114,97,110,115,32,111,114,32,98,105,110,78,111,114,109,97,108,32,102,111,114,109,97,116,0,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,110,97,109,101,115,32,109,97,116,114,105,120,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,73,110,102,111,32,109,97,116,114,105,120,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,49,32,118,97,114,105,97,98,108,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,99,111,108,115,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,49,32,109,97,116,114,105,120,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,99,111,110,116,97,105,110,101,100,32,112,97,114,97,109,101,116,101,114,32,116,104,97,116,32,99,104,97,110,103,101,100,32,98,101,116,119,101,101,110,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,45,116,105,109,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,114,111,119,115,0,84,111,111,32,102,101,119,32,114,111,119,115,32,105,110,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,73,109,112,108,101,109,101,110,116,97,116,105,111,110,32,101,114,114,111,114,58,32,85,110,107,110,111,119,110,32,99,97,115,101,0,0,0,0,0,0,97,98,115,86,97,114,73,110,100,101,120,32,62,32,48,32,38,38,32,97,98,115,86,97,114,73,110,100,101,120,32,60,61,32,114,101,97,100,101,114,45,62,110,118,97,114,0,0,117,116,105,108,47,114,101,97,100,95,109,97,116,108,97,98,52,46,99,0,0,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,118,97,108,115,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,115,105,110,103,108,101,95,118,97,108,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,109,112,116,121,32,82,105,110,103,66,117,102,102,101,114,0,0,0,0,0,0,0,0,105,110,100,101,120,32,91,37,100,93,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,100,58,37,100,93,0,0,154,0,0,0,0,0,0,120,153,0,0,0,0,0,0,240,152,0,0,0,0,0,0,104,152,0,0,0,0,0,0,96,151,0,0,0,0,0,0,88,150,0,0,0,0,0,0,80,149,0,0,0,0,0,0,72,148,0,0,0,0,0,0,97,99,99,95,116,112,32,33,61,32,48,0,0,0,0,0,117,116,105,108,47,114,116,99,108,111,99,107,46,99,0,0,114,116,95,105,110,105,116,0,109,97,120,95,116,112,32,33,61,32,48,0,0,0,0,0,116,111,116,97,108,95,116,112,32,33,61,32,48,0,0,0,116,105,99,107,95,116,112,32,33,61,32,48,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,32,33,61,32,48,0,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,105,110,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,97,120,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,116,111,116,97,108,32,33,61,32,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+30720);
/* memory initializer */ allocate([70,76,65,71,95,85,78,75,78,79,87,78,0,0,0,0,99,108,111,99,107,0,0,0,99,112,117,0,0,0,0,0,101,109,105,116,95,112,114,111,116,101,99,116,101,100,0,0,102,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,105,105,102,0,0,0,0,0,105,105,109,0,0,0,0,0,105,105,116,0,0,0,0,0,105,108,115,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,0,0,0,0,0,105,111,109,0,0,0,0,0,105,112,111,112,116,95,104,101,115,115,101,0,0,0,0,0,105,112,111,112,116,95,106,97,99,0,0,0,0,0,0,0,105,112,111,112,116,95,105,110,105,116,0,0,0,0,0,0,108,0,0,0,0,0,0,0,108,111,103,70,111,114,109,97,116,0,0,0,0,0,0,0,108,115,0,0,0,0,0,0,108,115,95,105,112,111,112,116,0,0,0,0,0,0,0,0,108,118,0,0,0,0,0,0,109,101,97,115,117,114,101,84,105,109,101,80,108,111,116,70,111,114,109,97,116,0,0,0,110,108,115,0,0,0,0,0,110,111,101,109,105,116,0,0,110,111,69,118,101,110,116,69,109,105,116,0,0,0,0,0,111,117,116,112,117,116,0,0,111,118,101,114,114,105,100,101,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,70,105,108,101,0,0,0,0,112,111,114,116,0,0,0,0,114,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,136,154,0,0,152,154,0,0,160,154,0,0,168,154,0,0,184,154,0,0,192,154,0,0,200,154,0,0,208,154,0,0,216,154,0,0,224,154,0,0,232,154,0,0,248,154,0,0,0,155,0,0,16,155,0,0,32,155,0,0,48,155,0,0,56,155,0,0,72,155,0,0,80,155,0,0,96,155,0,0,104,155,0,0,128,155,0,0,136,155,0,0,144,155,0,0,160,155,0,0,168,155,0,0,184,155,0,0,200,155,0,0,208,155,0,0,216,155,0,0,224,155,0,0,232,155,0,0,117,110,107,110,111,119,110,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,0,0,0,0,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,115,45,102,105,108,101,0,0,0,0,0,0,0,0,101,109,105,116,115,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,115,101,116,117,112,32,88,77,76,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,110,32,101,120,116,101,114,110,97,108,32,102,105,108,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,0,91,100,111,117,98,108,101,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,91,105,110,116,93,32,100,101,102,97,117,108,116,58,32,49,0,0,0,0,0,0,0,0,115,112,101,99,105,102,121,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,119,104,101,114,101,32,116,104,101,32,108,105,110,101,97,114,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,32,115,104,111,117,108,100,32,98,101,32,112,101,114,102,111,114,109,101,100,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,46,32,45,108,111,103,70,111,114,109,97,116,61,116,101,120,116,32,40,100,101,102,97,117,108,116,41,32,111,114,32,45,108,111,103,70,111,114,109,97,116,61,120,109,108,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,105,112,111,112,116,0,0,0,0,0,0,91,115,116,114,105,110,103,32,108,105,115,116,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,97,110,121,32,114,101,115,117,108,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,101,118,101,110,116,32,112,111,105,110,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,32,112,111,114,116,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,114,101,115,117,108,116,32,102,105,108,101,32,116,104,97,110,32,116,104,101,32,100,101,102,97,117,108,116,32,77,111,100,101,108,95,114,101,115,46,109,97,116,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,115,111,108,118,101,114,0,0,0,0,0,0,115,104,111,119,115,32,97,108,108,32,119,97,114,110,105,110,103,115,32,101,118,101,110,32,105,102,32,97,32,114,101,108,97,116,101,100,32,108,111,103,45,115,116,114,101,97,109,32,105,115,32,105,110,97,99,116,105,118,101,0,0,0,0,0,120,156,0,0,128,156,0,0,200,156,0,0,248,156,0,0,40,157,0,0,112,157,0,0,176,157,0,0,248,157,0,0,40,158,0,0,112,158,0,0,136,158,0,0,168,158,0,0,224,158,0,0,8,159,0,0,48,159,0,0,104,159,0,0,184,159,0,0,24,160,0,0,72,160,0,0,128,160,0,0,176,160,0,0,248,160,0,0,32,161,0,0,80,161,0,0,128,161,0,0,216,161,0,0,32,162,0,0,144,162,0,0,192,162,0,0,8,163,0,0,40,163,0,0,232,155,0,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,10,32,32,82,84,61,109,111,110,111,116,111,110,105,99,32,114,101,97,108,45,116,105,109,101,32,99,108,111,99,107,44,32,67,80,85,61,112,114,111,99,101,115,115,45,98,97,115,101,100,32,67,80,85,45,116,105,109,101,44,32,67,89,67,61,99,112,117,32,99,121,99,108,101,115,32,109,101,97,115,117,114,101,100,32,119,105,116,104,32,82,68,84,83,67,0,0,0,0,0,32,32,45,32,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,10,32,32,45,32,36,99,112,117,84,105,109,101,32,105,115,32,116,104,101,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,105,110,115,105,100,101,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,10,32,32,101,46,103,46,32,45,104,101,108,112,61,102,32,112,114,105,110,116,115,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,32,102,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,102,111,114,32,104,111,109,111,116,111,112,121,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,115,121,109,98,111,108,105,99,41,32,111,114,10,39,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,39,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,110,117,109,101,114,105,99,32,45,105,111,109,61,110,101,108,100,101,114,95,109,101,97,100,95,101,120,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,101,109,97,116,114,105,120,32,102,111,114,32,73,112,111,112,116,40,79,77,67,44,32,66,70,71,83,44,32,99,111,110,115,116,41,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,40,83,89,77,44,32,78,85,77,44,32,78,85,77,68,69,78,83,69,41,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,32,40,115,105,109,44,32,99,111,110,115,116,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,10,32,32,108,97,112,97,99,107,44,32,108,105,115,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,73,112,111,112,116,44,32,100,101,102,97,117,108,116,32,109,117,109,112,115,46,10,32,78,111,116,101,58,32,85,115,101,32,105,102,32,121,111,117,32,98,117,105,108,100,32,105,112,111,112,116,32,119,105,116,104,32,111,116,104,101,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,105,107,101,32,109,97,50,55,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,10,32,32,115,118,103,10,32,32,106,112,103,10,32,32,112,115,10,32,32,103,105,102,10,32,32,46,46,46,0,0,0,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,10,32,32,116,105,109,101,32,61,32,118,97,108,117,101,44,32,97,32,61,32,118,97,108,117,101,44,32,98,32,61,32,118,97,108,117,101,44,32,99,32,61,32,118,97,108,117,101,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,10,32,32,101,46,103,46,32,118,97,114,49,61,115,116,97,114,116,49,44,118,97,114,50,61,115,116,97,114,116,50,44,112,97,114,51,61,115,116,97,114,116,51,44,115,116,97,114,116,84,105,109,101,61,118,97,108,49,44,115,116,111,112,84,105,109,101,61,118,97,108,50,44,115,116,101,112,83,105,122,101,61,118,97,108,51,44,10,32,32,32,32,32,32,32,116,111,108,101,114,97,110,99,101,61,118,97,108,52,44,115,111,108,118,101,114,61,34,115,101,101,32,45,115,34,44,111,117,116,112,117,116,70,111,114,109,97,116,61,34,109,97,116,124,112,108,116,124,99,115,118,124,101,109,112,116,121,34,44,118,97,114,105,97,98,108,101,70,105,108,116,101,114,61,34,102,105,108,116,101,114,34,0,0,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,10,32,32,110,111,116,101,32,116,104,97,116,58,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,67,65,78,78,79,84,32,98,101,32,117,115,101,100,32,119,105,116,104,32,45,111,118,101,114,114,105,100,101,10,32,32,117,115,101,32,119,104,101,110,32,118,97,114,105,97,98,108,101,115,32,102,111,114,32,45,111,118,101,114,114,105,100,101,32,97,114,101,32,116,111,111,32,109,97,110,121,32,97,110,100,32,100,111,32,110,111,116,32,102,105,116,32,105,110,32,99,111,109,109,97,110,100,32,108,105,110,101,32,115,105,122,101,10,32,32,111,118,101,114,114,105,100,101,70,105,108,101,78,97,109,101,32,99,111,110,116,97,105,110,115,32,108,105,110,101,115,32,111,102,32,116,104,101,32,102,111,114,109,58,32,118,97,114,49,61,115,116,97,114,116,49,0,0,0,0,0,0,120,156,0,0,232,163,0,0,144,164,0,0,248,156,0,0,40,157,0,0,248,164,0,0,176,157,0,0,248,157,0,0,128,165,0,0,192,165,0,0,136,158,0,0,168,158,0,0,96,166,0,0,160,166,0,0,224,166,0,0,104,159,0,0,184,159,0,0,32,167,0,0,88,167,0,0,224,167,0,0,8,168,0,0,248,160,0,0,32,161,0,0,80,161,0,0,112,168,0,0,248,168,0,0,248,169,0,0,144,162,0,0,192,162,0,0,8,163,0,0,40,163,0,0,232,155,0,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,49,120,44,56,48,97,49,41,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,41,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,44,51,120,44,2,73,50,32,61,2,44,105,49,48,41,0,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,41,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,44,51,120,44,2,82,50,32,61,2,44,101,50,49,46,49,51,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,175,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,72,69,32,76,65,83,84,32,83,84,69,80,32,84,69,82,77,73,78,65,84,69,68,32,87,73,84,72,32,65,32,78,69,71,65,84,73,86,69,0,0,0,0,0,0,0,49,0,0,0,0,0,0,0,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,86,65,76,85,69,32,40,61,73,49,41,32,79,70,32,73,68,73,68,32,65,78,68,32,78,79,32,65,80,80,82,79,80,82,73,65,84,69,0,47,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,67,84,73,79,78,32,87,65,83,32,84,65,75,69,78,46,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,203,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,67,85,82,82,69,78,84,32,84,32,40,61,82,49,41,32,32,53,48,48,32,83,84,69,80,83,0,0,38,0,0,0,0,0,0,0,98,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,65,75,69,78,32,79,78,32,84,72,73,83,32,67,65,76,76,32,66,69,70,79,82,69,32,82,69,65,67,72,73,78,71,32,84,79,85,84,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,99,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,84,79,79,32,77,85,67,72,32,65,67,67,85,82,65,67,89,32,82,69,81,85,69,83,84,69,68,0,108,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,70,79,82,32,80,82,69,67,73,83,73,79,78,32,79,70,32,77,65,67,72,73,78,69,46,32,82,84,79,76,32,65,78,68,32,65,84,79,76,0,0,0,0,0,0,0,0,109,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,87,69,82,69,32,73,78,67,82,69,65,83,69,68,32,84,79,32,65,80,80,82,79,80,82,73,65,84,69,32,86,65,76,85,69,83,0,0,0,45,0,0,0,0,0,0,0,110,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,0,0,118,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,65,83,32,66,69,67,79,77,69,32,46,76,69,46,32,48,46,48,0,0,0,0,28,0,0,0,0,0,0,0,119,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,32,84,72,69,0,0,0,0,44,0,0,0,0,0,0,0,128,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,129,2,0,0,0,0,0,0,138,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,70,65,73,76,69,68,32,84,79,32,67,79,78,86,69,82,71,69,32,82,69,80,69,65,84,69,68,76,89,0,0,0,0,0,0,0,0,139,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,140,2,0,0,0,0,0,0,148,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,84,69,82,65,84,73,79,78,32,77,65,84,82,73,88,32,73,83,32,83,73,78,71,85,76,65,82,0,0,0,37,0,0,0,0,0,0,0,149,2,0,0,0,0,0,0,158,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,46,32,32,65,76,83,79,44,32,84,72,69,0,0,0,0,0,0,0,159,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,46,0,0,160,2,0,0,0,0,0,0,163,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,32,66,69,67,65,85,83,69,0,0,0,164,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,79,78,69,0,0,0,0,36,0,0,0,0,0,0,0,165,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,0,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,168,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,84,87,79,0,0,0,0,169,2,0,0,0,0,0,0,173,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,73,84,73,65,76,32,89,80,82,73,77,69,32,67,79,85,76,68,32,78,79,84,32,66,69,32,67,79,77,80,85,84,69,68,0,0,0,174,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,73,78,70,79,32,86,69,67,84,79,82,32,73,83,32,78,79,84,32,90,69,82,79,32,79,82,32,79,78,69,0,55,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,69,81,32,40,61,73,49,41,32,46,76,69,46,32,48,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,65,88,79,82,68,32,40,61,73,49,41,32,78,79,84,32,73,78,32,82,65,78,71,69,0,0,0,0,0,0,34,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,82,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,82,87,32,40,61,73,50,41,0,0,0,0,60,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,73,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,73,87,32,40,61,73,50,41,0,0,0,0,5,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,82,84,79,76,32,73,83,32,46,76,84,46,32,48,0,39,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,65,84,79,76,32,73,83,32,46,76,84,46,32,48,0,7,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,76,76,32,69,76,69,77,69,78,84,83,32,79,70,32,82,84,79,76,32,65,78,68,32,65,84,79,76,32,65,82,69,32,90,69,82,79,0,8,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,32,61,32,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,79,85,84,32,40,61,82,50,41,0,0,54,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,77,65,88,32,40,61,82,49,41,32,46,76,84,46,32,48,46,48,0,0,0,0,10,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,11,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,56,41,61,49,32,65,78,68,32,72,48,61,48,46,48,0,0,0,29,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,32,73,83,32,46,76,69,46,32,48,46,48,0,13,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,84,79,85,84,32,40,61,82,49,41,32,84,79,79,32,67,76,79,83,69,32,84,79,32,84,32,40,61,82,50,41,32,84,79,32,83,84,65,82,84,32,73,78,84,69,71,82,65,84,73,79,78,0,0,0,0,14,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,61,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,76,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,52,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,85,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,18,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,73,83,32,69,81,85,65,76,32,84,79,32,84,32,40,61,82,50,41,0,19,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,71,32,40,61,73,49,41,32,46,76,84,46,32,48,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,78,69,32,79,82,32,77,79,82,69,32,67,79,77,80,79,78,69,78,84,83,32,79,70,32,71,32,72,65,83,32,65,32,82,79,79,84,0,32,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,84,79,79,32,78,69,65,82,32,84,79,32,84,72,69,32,73,78,73,84,73,65,76,32,80,79,73,78,84,0,0,68,65,83,83,76,45,45,32,32,82,69,80,69,65,84,69,68,32,79,67,67,85,82,82,69,78,67,69,83,32,79,70,32,73,76,76,69,71,65,76,32,73,78,80,85,84,0,0,46,0,0,0,0,0,0,0,33,3,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,46,32,65,80,80,65,82,69,78,84,32,73,78,70,73,78,73,84,69,32,76,79,79,80,0,34,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,116,32,112,111,105,110,116,32,105,110,32,116,105,109,101,58,32,37,103,0,0,0,0,99,106,58,32,37,103,0,0,115,116,97,116,101,115,0,0,91,37,108,100,93,32,37,103,0,0,0,0,0,0,0,0,97,110,97,108,121,116,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,37,115,37,103,32,0,0,0,37,115,0,0,0,0,0,0,110,117,109,101,114,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,66,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,77,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,76,0,0,0,0,0,0,0,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,47,2,32,87,65,82,78,73,78,71,46,32,84,104,101,32,118,97,108,117,101,32,69,77,73,78,32,109,97,121,32,98,101,32,105,110,99,111,114,114,101,99,116,58,45,2,44,2,32,32,69,77,73,78,32,61,32,2,44,105,56,44,47,2,32,73,102,44,32,97,102,116,101,114,32,105,110,115,112,101,99,116,105,111,110,44,32,116,104,101,32,118,97,108,117,101,32,69,77,73,78,32,108,111,111,107,115,2,44,2,32,97,99,99,101,112,116,97,98,108,101,32,112,108,101,97,115,101,32,99,111,109,109,101,110,116,32,111,117,116,32,2,44,47,2,32,116,104,101,32,73,70,32,98,108,111,99,107,32,97,115,32,109,97,114,107,101,100,32,119,105,116,104,105,110,32,116,104,101,32,99,111,100,101,32,111,102,32,114,111,117,116,105,110,101,2,44,2,32,68,76,65,77,67,50,44,2,44,47,2,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,108,121,32,69,77,73,78,32,101,120,112,108,105,99,105,116,108,121,46,2,44], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+39552);
/* memory initializer */ allocate([47,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,144,193,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,2,32,80,114,111,103,114,101,115,115,32,82,101,112,111,114,116,32,101,118,101,114,121,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,47,44,2,32,69,86,65,76,46,32,32,32,70,85,78,67,46,86,65,76,85,69,46,2,44,49,48,120,44,2,80,65,82,65,77,69,84,69,82,32,86,65,76,85,69,83,2,41,0,0,0,0,40,47,49,120,44,105,52,44,50,120,44,103,49,50,46,53,44,50,120,44,53,103,49,49,46,52,44,51,40,47,50,49,120,44,53,103,49,49,46,52,41,41,0,0,0,0,0,0,40,2,32,78,111,46,32,111,102,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,62,32,2,44,105,53,41,0,0,40,2,32,82,77,83,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,103,49,52,46,54,41,0,0,0,0,0,40,2,32,67,101,110,116,114,111,105,100,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,99,101,110,116,114,111,105,100,32,61,2,44,103,49,52,46,54,41,0,40,47,2,32,69,86,73,68,69,78,67,69,32,79,70,32,67,79,78,86,69,82,71,69,78,67,69,2,41,0,0,0,40,47,47,2,32,77,105,110,105,109,117,109,32,102,111,117,110,100,32,97,102,116,101,114,2,44,105,53,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,41,0,0,0,40,2,32,77,105,110,105,109,117,109,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,54,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,109,105,110,105,109,117,109,32,61,2,44,103,49,52,46,54,41,0,0,40,47,2,32,70,105,116,116,105,110,103,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,97,98,111,117,116,32,115,117,112,112,111,115,101,100,32,109,105,110,105,109,117,109,2,47,41,0,40,47,2,32,77,65,84,82,73,88,32,79,70,32,69,83,84,73,77,65,84,69,68,32,83,69,67,79,78,68,32,68,69,82,73,86,65,84,73,86,69,83,32,78,79,84,32,43,86,69,32,68,69,70,78,46,2,47,2,32,77,73,78,73,77,85,77,32,80,82,79,66,65,66,76,89,32,78,79,84,32,70,79,85,78,68,2,47,41,0,0,0,0,0,0,0,40,47,49,48,120,44,2,83,101,97,114,99,104,32,114,101,115,116,97,114,116,105,110,103,2,47,41,0,0,0,0,0,40,2,32,77,105,110,105,109,117,109,32,111,102,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,61,2,44,103,49,52,46,54,44,2,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,73,70,32,84,72,73,83,32,68,73,70,70,69,82,83,32,66,89,32,77,85,67,72,32,70,82,79,77,32,84,72,69,32,77,73,78,73,77,85,77,32,69,83,84,73,77,65,84,69,68,2,44,49,120,44,2,70,82,79,77,32,84,72,69,32,77,73,78,73,77,73,90,65,84,73,79,78,44,2,47,2,32,84,72,69,32,77,73,78,73,77,85,77,32,77,65,89,32,66,69,32,70,65,76,83,69,32,38,47,79,82,32,84,72,69,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,32,77,65,89,32,66,69,2,44,49,120,44,2,73,78,65,67,67,85,82,65,84,69,2,47,41,0,0,0,0,0,40,2,32,82,97,110,107,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,32,61,2,44,105,51,47,2,32,73,110,118,101,114,115,101,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,58,45,2,41,0,40,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,109,105,110,105,109,105,122,101,100,32,119,97,115,32,45,76,79,71,40,76,73,75,69,76,73,72,79,79,68,41,44,2,47,2,32,116,104,105,115,32,105,115,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,32,111,102,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,46,2,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,119,97,115,32,97,32,115,117,109,32,111,102,32,115,113,117,97,114,101,115,32,111,102,32,114,101,115,105,100,117,97,108,115,44,2,47,2,32,116,104,105,115,32,109,97,116,114,105,120,32,109,117,115,116,32,98,101,32,109,117,108,116,105,112,108,105,101,100,32,98,121,32,116,119,105,99,101,32,116,104,101,32,101,115,116,105,109,97,116,101,100,2,44,49,120,44,2,114,101,115,105,100,117,97,108,32,118,97,114,105,97,110,99,101,2,47,2,32,116,111,32,111,98,116,97,105,110,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,46,2,47,41,0,0,0,0,40,2,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,47,41,0,0,0,0,0,0,40,47,47,2,32,67,79,82,82,69,76,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,41,0,0,0,0,0,40,47,2,32,65,32,102,117,114,116,104,101,114,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,104,97,118,101,32,98,101,101,110,32,117,115,101,100,2,47,41,0,0,0,0,0,0,40,49,120,44,54,103,49,51,46,53,41,0,0,0,0,0,40,47,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+49792);
/* memory initializer */ allocate([216,197,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,202,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,202,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,203,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,203,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,203,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,203,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,78,80,84,32,105,115,32,110,111,116,32,105,110,2,44,2,32,116,104,101,32,114,101,113,117,105,114,101,100,32,105,110,116,101,114,118,97,108,2,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,168,238,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,67,65,76,70,85,78,32,104,97,115,32,98,101,101,110,2,44,2,32,99,97,108,108,101,100,32,77,65,88,70,85,78,32,116,105,109,101,115,46,2,41,0,0,0,0,0,0,40,47,52,120,44,2,70,117,110,99,116,105,111,110,32,110,117,109,98,101,114,2,44,105,54,44,2,32,32,32,32,70,32,61,2,44,49,112,100,49,56,46,49,48,44,2,32,32,32,32,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,97,32,116,114,117,115,116,2,44,2,32,114,101,103,105,111,110,32,115,116,101,112,32,104,97,115,32,102,97,105,108,101,100,32,116,111,32,114,101,100,117,99,101,32,81,46,2,41,0,0,0,0,0,0,0,40,53,120,41,0,0,0,0,40,47,52,120,44,2,78,101,119,32,82,72,79,32,61,2,44,49,112,100,49,49,46,52,44,53,120,44,2,78,117,109,98,101,114,32,111,102,2,44,2,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,40,52,120,44,2,76,101,97,115,116,32,118,97,108,117,101,32,111,102,32,70,32,61,2,44,49,112,100,50,51,46,49,53,44,57,120,44,2,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,0,0,0,0,40,47,52,120,44,2,65,116,32,116,104,101,32,114,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,2,44,53,120,44,2,78,117,109,98,101,114,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,136,239,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,216,239,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,48,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,136,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,144,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,216,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,40,241,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,216,240,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,105,118,111,116,32,33,61,32,48,0,0,0,0,0,0,109,97,116,104,45,115,117,112,112,111,114,116,47,112,105,118,111,116,46,99,0,0,0,0,112,105,118,111,116,0,0,0,80,253,0,0,112,254,0,0,120,254,0,0,136,254,0,0,152,254,0,0,168,254,0,0,192,254,0,0,216,254,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,80,253,0,0,88,253,0,0,160,253,0,0,200,253,0,0,232,253,0,0,8,254,0,0,48,254,0,0,88,254,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,100,97,115,115,108,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,0,0,0,0,0,124,32,115,111,108,118,101,114,32,124,32,85,115,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,9,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,78,111,32,83,112,97,114,115,101,80,97,116,116,101,114,110,44,32,115,105,110,99,101,32,116,104,101,114,101,32,97,114,101,32,110,111,32,115,116,97,116,101,115,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,74,97,99,111,98,105,97,110,32,111,114,32,83,112,97,114,115,101,80,97,116,116,101,114,110,32,105,115,32,110,111,116,32,103,101,110,101,114,97,116,101,100,32,111,114,32,102,97,105,108,101,100,32,116,111,32,105,110,105,116,105,97,108,105,122,101,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,112,97,115,115,101,100,32,116,111,32,68,68,65,83,82,84,0,0,0,0,0,0,68,101,115,105,114,101,100,32,115,116,101,112,32,116,111,32,115,109,97,108,108,32,116,114,121,32,110,101,120,116,32,111,110,101,0,0,0,0,0,0,73,110,116,101,114,112,111,108,97,116,101,32,108,105,110,101,97,114,0,0,0,0,0,0,67,97,108,108,105,110,103,32,68,68,65,83,82,84,32,102,114,111,109,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,83,116,97,114,116,32,115,116,101,112,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,0,65,32,108,97,114,103,101,32,97,109,111,117,110,116,32,111,102,32,119,111,114,107,32,104,97,115,32,98,101,101,110,32,101,120,112,101,110,100,101,100,46,40,65,98,111,117,116,32,53,48,48,32,115,116,101,112,115,41,46,32,84,114,121,105,110,103,32,116,111,32,99,111,110,116,105,110,117,101,32,46,46,46,0,0,0,0,0,0,68,65,83,83,76,32,119,105,108,108,32,116,114,121,32,97,103,97,105,110,46,46,46,0,99,97,110,39,116,32,99,111,110,116,105,110,117,101,46,32,116,105,109,101,32,61,32,37,102,0,0,0,0,0,0,0,100,97,115,115,108,32,99,97,108,108,32,115,116,97,105,115,116,105,99,115,58,32,0,0,118,97,108,117,101,32,111,102,32,105,100,105,100,58,32,37,100,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,105,110,116,101,103,114,97,116,105,111,110,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,115,116,101,112,32,115,105,122,101,32,72,32,116,111,32,98,101,32,97,116,116,101,109,112,116,101,100,32,111,110,32,110,101,120,116,32,115,116,101,112,58,32,37,48,46,52,103,0,115,116,101,112,32,115,105,122,101,32,117,115,101,100,32,111,110,32,108,97,115,116,32,115,117,99,99,101,115,115,102,117,108,32,115,116,101,112,58,32,37,48,46,52,103,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,116,97,107,101,110,32,115,111,32,102,97,114,58,32,37,100,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,40,41,32,58,32,37,100,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,99,117,108,97,116,105,111,110,32,111,102,32,106,97,99,111,98,105,97,110,32,58,32,37,100,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,49,48,32,43,32,117,105,32,60,32,100,97,115,115,108,68,97,116,97,45,62,108,105,119,0,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,100,97,115,115,108,46,99,0,0,0,0,0,0,0,100,97,115,114,116,95,115,116,101,112,0,0,0,0,0,0,70,105,110,105,115,104,101,100,32,68,68,65,83,82,84,32,115,116,101,112,46,0,0,0,84,104,101,32,101,114,114,111,114,32,116,111,108,101,114,97,110,99,101,115,32,97,114,101,32,116,111,111,32,115,116,114,105,110,103,101,110,116,0,0,68,68,65,83,83,76,32,104,97,100,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,111,110,32,116,104,101,32,108,97,115,116,32,97,116,116,101,109,112,116,101,100,32,115,116,101,112,46,0,0,0,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,0,0,0,0,0,0,0,84,104,101,32,109,97,116,114,105,120,32,111,102,32,112,97,114,116,105,97,108,32,100,101,114,105,118,97,116,105,118,101,115,32,105,115,32,115,105,110,103,117,108,97,114,46,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,32,84,104,101,114,101,32,119,101,114,101,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,105,110,32,116,104,105,115,32,115,116,101,112,46,0,65,32,77,111,100,101,108,105,99,97,32,97,115,115,101,114,116,32,112,114,101,118,101,110,116,115,32,116,104,101,32,105,110,116,101,103,114,97,116,111,114,32,116,111,32,99,111,110,116,105,110,117,101,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,45,108,118,32,76,79,71,95,68,68,65,83,82,84,0,0,73,82,69,83,32,101,113,117,97,108,32,116,111,32,45,50,32,119,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,97,110,100,32,99,111,110,116,114,111,108,32,105,115,32,98,101,105,110,103,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,99,97,108,108,105,110,103,32,112,114,111,103,114,97,109,46,0,0,68,68,65,83,83,76,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,116,104,101,32,105,110,105,116,105,97,108,32,89,80,82,73,77,69,46,0,0,0,0,84,104,101,32,99,111,100,101,32,104,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,116,114,111,117,98,108,101,32,102,114,111,109,32,119,104,105,99,104,32,105,116,32,99,97,110,110,111,116,32,114,101,99,111,118,101,114,46,0,0,117,110,107,110,111,119,110,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,84,82,85,69,0,0,0,0,70,65,76,83,69,0,0,0,91,37,108,100,93,32,115,97,109,112,108,101,40,37,103,44,32,37,103,41,0,0,0,0,91,37,108,100,93,32,37,115,0,0,0,0,0,0,0,0,67,104,97,116,116,101,114,105,110,103,32,100,101,116,101,99,116,101,100,32,97,114,111,117,110,100,32,116,105,109,101,32,37,46,49,50,103,46,46,37,46,49,50,103,32,40,37,100,32,115,116,97,116,101,32,101,118,101,110,116,115,32,105,110,32,97,32,114,111,119,32,119,105,116,104,32,97,32,116,111,116,97,108,32,116,105,109,101,32,100,101,108,116,97,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,115,116,101,112,32,115,105,122,101,32,37,46,49,50,103,41,46,32,84,104,105,115,32,99,97,110,32,98,101,32,97,32,112,101,114,102,111,114,109,97,110,99,101,32,98,111,116,116,108,101,110,101,99,107,46,32,85,115,101,32,45,108,118,32,76,79,71,95,69,86,69,78,84,83,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,32,84,104,101,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,119,97,115,58,32,37,115,0,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,114,105,103,104,116,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,101,118,101,110,116,115,46,99,0,0,0,0,0,0,102,105,110,100,82,111,111,116,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,108,101,102,116,0,0,0,0,0,115,101,97,114,99,104,32,102,111,114,32,99,117,114,114,101,110,116,32,101,118,101,110,116,46,32,69,118,101,110,116,115,32,105,110,32,108,105,115,116,58,32,37,108,100,0,0,0,77,105,110,105,109,117,109,32,118,97,108,117,101,58,32,37,101,0,0,0,0,0,0,0,97,100,100,101,100,32,116,109,112,32,101,118,101,110,116,32,58,32,37,108,100,0,0,0,37,108,100,32,0,0,0,0,98,97,99,107,117,112,95,103,111,117,116,0,0,0,0,0,98,105,115,101,99,116,105,111,110,0,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,109,101,116,104,111,100,32,115,116,97,114,116,115,32,105,110,32,105,110,116,101,114,118,97,108,32,91,37,101,44,32,37,101,93,0,0,0,0,84,84,79,76,32,105,115,32,115,101,116,32,116,111,58,32,37,101,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,99,104,101,99,107,115,32,102,111,114,32,99,111,110,100,105,116,105,111,110,32,99,104,97,110,103,101,115,0,0,37,108,100,32,99,104,97,110,103,101,100,32,102,114,111,109,32,37,115,32,116,111,32,99,117,114,114,101,110,116,32,37,115,0,0,0,0,0,0,0,115,97,118,101,32,97,108,108,32,122,101,114,111,99,114,111,115,115,105,110,103,115,32,97,102,116,101,114,32,97,110,32,101,118,101,110,116,0,0,0,69,82,82,79,82,58,32,84,111,111,32,109,97,110,121,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,115,46,32,83,121,115,116,101,109,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,46,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,112,97,114,97,109,101,116,101,114,32,118,97,108,117,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,103,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,108,100,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,115,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,0,0,0,0,115,116,97,116,117,115,32,111,102,32,114,101,108,97,116,105,111,110,115,0,0,0,0,0,91,37,108,100,93,32,37,115,32,61,32,37,99,32,124,32,112,114,101,40,37,115,41,32,61,32,37,99,0,0,0,0,89,111,117,114,32,109,101,109,111,114,121,32,105,115,32,110,111,116,32,115,116,114,111,110,103,32,101,110,111,117,103,104,32,102,111,114,32,111,117,114,32,82,105,110,103,98,117,102,102,101,114,33,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,101,120,116,101,114,110,97,108,32,111,98,106,101,99,116,115,0,0,0,0,0,0,0,187,189,215,217,223,124,219,61,83,101,116,32,116,111,108,101,114,97,110,99,101,32,102,111,114,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,104,121,115,116,101,114,101,115,105,115,32,116,111,58,32,37,101,0,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,109,105,120,101,100,32,115,111,108,118,101,114,0,0,0,0,0,0,0,109,105,120,101,100,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,91,37,100,93,32,37,115,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,101,77,105,120,101,100,83,101,97,114,99,104,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,0,0,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,91,37,100,93,32,37,115,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,97,112,97,99,107,46,0,0,0,0,0,0,0,65,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,0,0,0,0,0,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,37,115,0,0,0,0,0,0,98,32,118,101,99,116,111,114,32,91,37,100,93,0,0,0,69,114,114,111,114,32,115,111,108,118,105,110,103,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,46,32,65,114,103,117,109,101,110,116,32,37,100,32,105,108,108,101,103,97,108,46,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,115,111,108,118,101,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,44,32,115,121,115,116,101,109,32,105,115,32,115,105,110,103,117,108,97,114,32,102,111,114,32,85,91,37,100,44,32,37,100,93,46,0,0,0,0,0,0,0,37,115,37,49,48,103,32,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,76,105,115,46,0,0,45,105,32,102,103,109,114,101,115,32,0,0,0,0,0,0,78,76,83,95,85,78,75,78,79,87,78,0,0,0,0,0,104,121,98,114,105,100,0,0,107,105,110,115,111,108,0,0,110,101,119,116,111,110,0,0,78,76,83,95,77,65,88,0,192,6,1,0,208,6,1,0,216,6,1,0,224,6,1,0,232,6,1,0,0,0,0,0,117,110,107,110,111,119,110,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,78,101,119,116,111,110,32,82,97,112,104,115,111,110,0,0,8,7,1,0,16,7,1,0,32,7,1,0,48,7,1,0,232,6,1,0,0,0,0,0,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,106,97,99,111,98,105,97,110,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,0,0,0,0,112,114,111,112,101,114,32,115,116,97,114,116,45,118,97,108,117,101,115,32,102,111,114,32,115,111,109,101,32,111,102,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,115,32,109,105,103,104,116,32,104,101,108,112,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,63,44,32,110,111,109,105,110,97,108,61,63,41,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,240,63,73,110,105,116,105,97,108,105,122,105,110,103,32,68,65,83,83,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,116,111,114,105,110,103,32,114,101,115,117,108,116,115,32,97,110,100,32,101,120,105,116,105,110,103,46,10,85,115,101,32,45,108,118,61,76,79,71,95,73,78,73,84,32,45,119,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,0,115,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,97,110,32,97,115,115,101,114,116,105,111,110,32,97,116,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,87,114,111,116,101,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,116,104,101,32,102,105,108,101,32,97,102,116,101,114,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,40,102,111,114,32,111,117,116,112,117,116,32,102,111,114,109,97,116,115,32,116,104,97,116,32,115,117,112,112,111,114,116,32,116,104,105,115,41,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,108,32,101,118,101,110,116,32,97,116,32,115,116,111,112,32,116,105,109,101,32,37,103,0,0,70,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,35,35,35,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,0,0,0,0,116,105,109,101,114,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,112,114,101,45,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,116,101,112,115,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,45,102,105,108,101,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,101,118,101,110,116,45,104,97,110,100,108,105,110,103,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,118,101,114,104,101,97,100,0,0,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,105,109,117,108,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,116,111,116,97,108,0,0,0,101,118,101,110,116,115,0,0,37,53,108,100,32,115,116,97,116,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,37,53,108,100,32,116,105,109,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,0,115,111,108,118,101,114,58,32,68,65,83,83,76,0,0,0,37,53,100,32,115,116,101,112,115,32,116,97,107,101,110,0,37,53,100,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,0,0,0,0,0,0,0,0,37,53,100,32,101,118,97,108,117,97,116,105,111,110,115,32,111,102,32,106,97,99,111,98,105,97,110,0,0,0,0,0,37,53,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,37,53,100,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,0,0,115,111,108,118,101,114,0,0,115,111,114,114,121,32,45,32,110,111,32,115,111,108,118,101,114,32,115,116,97,116,105,115,116,105,99,115,32,97,118,97,105,108,97,98,108,101,46,32,91,110,111,116,32,121,101,116,32,105,109,112,108,101,109,101,110,116,101,100,93,0,0,0,35,35,35,32,69,78,68,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,83,117,110,100,105,97,108,47,107,105,110,115,111,108,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,32,80,108,101,97,115,101,32,99,104,111,111,115,101,32,111,116,104,101,114,32,115,111,108,118,101,114,46,0,73,112,111,112,116,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,0,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,101,117,108,101,114,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,69,85,76,69,82,46,0,0,0,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,82,75,46,0,0,0,83,116,97,114,116,32,110,117,109,101,114,105,99,97,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,44,0,0,0,0,0,0,0,116,105,109,101,61,37,46,50,48,103,0,0,0,0,0,0,44,37,115,61,37,46,50,48,103,0,0,0,0,0,0,0,44,37,115,61,37,108,105,0,44,37,115,61,37,105,0,0,44,37,115,61,34,37,115,34,0,0,0,0,0,0,0,0,99,97,110,32,110,111,116,32,105,110,105,116,105,97,108,122,101,32,74,97,99,111,98,105,97,110,115,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,106,97,99,111,98,105,97,110,32,37,100,120,37,100,32,91,105,100,58,32,37,108,100,93,0,0,0,0,0,0,0,0,37,115,37,46,53,101,32,0,37,115,0,0,0,0,0,0,69,114,114,111,114,44,32,115,105,110,103,117,108,97,114,32,74,97,99,111,98,105,97,110,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,32,97,116,32,116,105,109,101,32,37,102,10,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,95,74,65,67,32,116,111,32,103,101,116,32,116,104,101,32,74,97,99,111,98,105,97,110,0,115,101,108,101,99,116,32,110,101,119,32,115,116,97,116,101,115,32,97,116,32,116,105,109,101,32,37,102,0,0,0,0,115,101,108,101,99,116,32,37,115,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,73,110,112,117,116,46,99,115,118,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,37,108,102,0,0,0,0,0,10,69,120,116,101,114,110,97,108,32,73,110,112,117,116,0,10,73,110,112,117,116,58,32,116,61,37,102,32,32,32,9,0,0,0,0,0,0,0,0,117,37,100,40,116,41,61,32,37,102,32,9,0,0,0,0,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,0,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,121,115,116,101,109,32,111,102,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,97,114,101,32,110,111,116,32,99,111,110,115,105,115,116,101,110,116,10,40,108,101,97,115,116,32,115,113,117,97,114,101,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,32,105,115,32,37,103,41,0,0,0,0,0,114,101,115,105,100,117,97,108,91,37,108,100,93,32,61,32,37,103,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,115,116,97,116,117,115,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,32,91,115,99,97,108,101,100,58,32,37,103,93,0,0,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,0,0,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,0,0,0,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,35,35,35,32,83,79,76,85,84,73,79,78,32,79,70,32,84,72,69,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,115,116,97,116,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+60172);
/* memory initializer */ allocate([37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,0,0,100,101,114,105,118,97,116,105,118,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,111,116,104,101,114,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,41,32,61,32,37,108,100,32,40,112,114,101,58,32,37,108,100,41,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,41,32,61,32,37,115,32,40,112,114,101,58,32,37,115,41,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,32,40,112,114,101,58,32,34,37,115,34,41,0,0,35,35,35,32,83,84,65,82,84,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,120,24,1,0,64,26,1,0,72,26,1,0,80,26,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,105,109,32,37,115,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,124,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,120,24,1,0,128,25,1,0,208,25,1,0,0,26,1,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,120,24,1,0,64,25,1,0,72,25,1,0,80,25,1,0,96,25,1,0,104,25,1,0,120,25,1,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,111,109,32,37,115,0,0,0,0,0,120,24,1,0,128,24,1,0,152,24,1,0,168,24,1,0,240,24,1,0,0,25,1,0,32,25,1,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,105,109,0,35,35,35,32,69,78,68,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,37,115,95,104,111,109,111,116,111,112,121,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,108,97,109,98,100,97,0,0,104,111,109,111,116,111,112,121,32,112,114,111,99,101,115,115,0,0,0,0,0,0,0,0,108,97,109,98,100,97,32,61,32,37,103,32,100,111,110,101,0,0,0,0,0,0,0,0,37,46,49,54,103,44,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,117,110,105,113,117,101,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,46,32,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,32,116,111,32,115,101,101,32,116,104,101,32,115,119,105,116,99,104,105,110,103,32,115,116,97,116,101,32,115,101,116,46,0,0,0,110,111,32,118,97,114,105,97,98,108,101,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,0,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,32,40,110,101,105,116,104,101,114,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,110,111,114,32,105,110,105,116,105,97,108,32,97,108,103,111,114,105,116,104,109,115,41,0,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,0,0,0,0,0,0,0,0,115,101,116,116,105,110,103,32,102,105,120,101,100,61,116,114,117,101,32,102,111,114,58,0,37,115,40,102,105,120,101,100,61,116,114,117,101,41,32,61,32,37,103,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,0,0,111,118,101,114,45,100,101,116,101,114,109,105,110,101,100,0,115,116,97,114,116,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,0,0,115,107,105,112,32,119,47,111,32,115,99,97,108,105,110,103,0,0,0,0,0,0,0,0,35,35,35,32,70,73,78,65,76,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,82,69,83,85,76,84,83,32,35,35,35,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,45,110,114,46,32,37,108,100,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,111,109,0,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,110,111,116,32,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,45,99,97,108,108,115,58,32,37,108,100,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,105,109,112,111,114,116,32,115,116,97,114,116,32,118,97,108,117,101,115,10,102,105,108,101,58,32,37,115,10,116,105,109,101,58,32,37,103,0,0,0,117,110,97,98,108,101,32,116,111,32,114,101,97,100,32,105,110,112,117,116,45,102,105,108,101,32,60,37,115,62,32,91,37,115,93,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,103,41,0,0,36,90,69,82,79,46,0,0,36,112,68,69,82,46,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,100,105,115,99,114,101,116,101,0,0,0,0,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,108,100,41,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,115,41,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,100,101,114,40,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,105,116,105,97,108,32,112,114,111,98,108,101,109,58,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,58,32,32,37,108,100,32,40,37,108,100,32,115,116,97,116,101,115,32,43,32,37,108,100,32,112,97,114,97,109,101,116,101,114,115,32,43,32,37,108,100,32,100,105,115,99,114,101,116,101,32,114,101,97,108,115,41,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,91,37,108,100,93,32,100,105,115,99,114,101,116,101,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,58,32,32,37,108,100,32,40,37,108,100,32,101,113,117,97,116,105,111,110,115,32,43,32,37,108,100,32,97,108,103,111,114,105,116,104,109,115,41,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,97,114,116,32,118,97,108,117,101,32,114,101,115,105,100,117,97,108,115,58,32,37,108,100,0,0,0,0,91,37,108,100,93,32,114,101,115,105,100,117,97,108,32,105,115,32,105,110,101,102,102,101,99,116,105,118,101,32,40,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,32,105,115,32,115,101,116,32,116,111,32,49,46,48,41,0,0,0,0,0,0,0,110,111,32,105,112,111,112,116,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,124,32,82,101,115,117,108,116,32,111,102,32,108,101,97,115,116,83,113,117,97,114,101,32,109,101,116,104,111,100,32,61,32,37,103,46,32,84,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,105,116,115,32,116,111,32,116,104,101,32,115,121,115,116,101,109,0,0,0,0,0,0,0,0,108,101,97,115,116,83,113,117,97,114,101,61,37,103,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,111,108,118,101,114,32,105,116,101,114,97,116,101,100,32,37,100,32,116,105,109,101,115,32,119,105,116,104,111,117,116,32,102,105,110,100,105,110,103,32,97,32,115,111,108,117,116,105,111,110,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,99,111,110,115,105,115,116,101,110,116,32,105,110,105,116,105,97,108,32,99,111,110,100,105,116,105,111,110,115,46,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,78,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,32,60,32,49,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,78,76,79,79,80,32,60,32,49,46,0,0,0,0,0,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,105,116,101,114,97,116,105,111,110,115,58,32,37,108,100,0,116,114,121,32,45,105,108,115,32,116,111,32,97,99,116,105,118,97,116,101,32,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,0,0,0,0,0,0,0,37,115,95,105,110,105,116,80,97,116,104,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,105,116,101,114,97,116,105,111,110,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,37,108,100,44,0,0,0,0,37,46,49,54,103,44,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,108,97,109,98,100,97,32,105,115,32,37,45,51,103,32,105,110,32,115,116,101,112,61,37,54,100,32,97,116,32,102,61,37,103,32,91,37,103,93,0,105,110,99,114,101,97,115,105,110,103,32,108,97,109,98,100,97,32,116,111,32,37,45,51,103,32,105,110,32,115,116,101,112,32,37,54,100,32,97,116,32,102,61,37,103,0,0,0,102,120,114,32,61,32,37,103,0,0,0,0,0,0,0,0,102,120,107,32,61,32,37,103,0,0,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,114,114,111,114,32,105,110,32,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,37,46,49,54,103,44,0,0,37,105,44,0,0,0,0,0,34,37,115,34,44,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,116,105,109,101,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,65,49,32,98,116,46,32,105,114,49,32,110,97,32,32,84,106,32,32,114,101,32,32,97,99,32,32,110,116,32,32,115,111,32,32,32,114,32,32,32,121,32,32,32,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,50,0,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,102,105,108,101,32,37,115,0,0,0,0,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,0,0,67,97,110,110,111,116,32,119,114,105,116,101,32,116,111,32,102,105,108,101,32,37,115,0,67,97,110,110,111,116,32,97,108,108,111,99,32,109,101,109,111,114,121,0,0,0,0,0,77,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,119,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,114,43,0,0,0,0,0,0,119,43,0,0,0,0,0,0,97,43,0,0,0,0,0,0,119,98,0,0,0,0,0,0,97,98,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,119,43,98,0,0,0,0,0,97,43,98,0,0,0,0,0,100,101,114,40,0,0,0,0,104,0,0,0,0,0,0,0,40,36,1,0,8,0,0,0,9,0,0,0,152,255,255,255,152,255,255,255,40,36,1,0,10,0,0,0,11,0,0,0,204,35,1,0,68,36,1,0,88,36,1,0,224,35,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,111,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,200,221,1,0,248,35,1,0,80,153,1,0,0,0,0,0,104,0,0,0,0,0,0,0,80,153,1,0,12,0,0,0,13,0,0,0,152,255,255,255,152,255,255,255,80,153,1,0,14,0,0,0,15,0,0,0,0,0,0,0,208,36,1,0,16,0,0,0,17,0,0,0,3,0,0,0,8,0,0,0,2,0,0,0,4,0,0,0,31,0,0,0,32,0,0,0,9,0,0,0,33,0,0,0,34,0,0,0,24,0,0,0,10,0,0,0,25,0,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,200,221,1,0,160,36,1,0,72,152,1,0,0,0,0,0,0,0,0,0,88,37,1,0,96,37,1,0,80,37,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,48,37,1,0,64,37,1,0,80,37,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,99,112,117,32,116,105,109,101,32,91,115,93,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,83,105,109,117,108,97,116,105,111,110,32,116,105,109,101,32,91,115,93,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,0,0,0,0,0,65,117,116,111,109,97,116,105,99,32,111,117,116,112,117,116,32,115,116,101,112,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,79,112,101,110,77,111,100,101,108,105,99,97,32,121,101,116,46,32,83,101,116,32,110,117,109,112,111,105,110,116,115,32,62,61,32,48,46,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,32,102,97,105,108,101,100,0,0,0,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,35,80,116,111,108,101,109,121,32,80,108,111,116,32,102,105,108,101,44,32,103,101,110,101,114,97,116,101,100,32,98,121,32,79,112,101,110,77,111,100,101,108,105,99,97,10,0,0,35,78,117,109,98,101,114,111,102,86,97,114,105,97,98,108,101,115,61,37,100,10,0,0,35,73,110,116,101,114,118,97,108,83,105,122,101,61,37,108,100,10,0,0,0,0,0,0,84,105,116,108,101,84,101,120,116,58,32,79,112,101,110,77,111,100,101,108,105,99,97,32,115,105,109,117,108,97,116,105,111,110,32,112,108,111,116,10,0,0,0,0,0,0,0,0,88,76,97,98,101,108,58,32,116,10,10,0,0,0,0,0,68,97,116,97,83,101,116,58,32,116,105,109,101,10,0,0,68,97,116,97,83,101,116,58,32,36,99,112,117,84,105,109,101,10,0,0,0,0,0,0,68,97,116,97,83,101,116,58,32,37,115,10,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,119,114,105,116,101,32,116,111,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,37,46,49,54,103,44,32,37,46,49,54,103,10,0,0,0,114,101,99,111,110,58,119,97,108,108,58,118,48,49,0,0,0,0,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,112,97,114,97,109,115,0,0,99,111,110,116,105,110,117,111,117,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,101,116,97,0,0,0,116,97,98,115,0,0,0,0,111,98,106,115,0,0,0,0,116,109,101,116,97,0,0,0,115,105,103,115,0,0,0,0,116,105,109,101,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,118,109,101,116,97,0,0,0,84,105,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,97,108,115,0,0,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,105,110,118,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,118,97,108,117,101,82,101,102,101,114,101,110,99,101,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,102,105,108,101,78,97,109,101,0,0,0,0,0,0,0,0,115,116,97,114,116,76,105,110,101,0,0,0,0,0,0,0,115,116,97,114,116,67,111,108,117,109,110,0,0,0,0,0,101,110,100,76,105,110,101,0,101,110,100,67,111,108,117,109,110,0,0,0,0,0,0,0,102,105,108,101,87,114,105,116,97,98,108,101,0,0,0,0,117,115,101,83,116,97,114,116,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,102,105,120,101,100,0,0,0,117,115,101,78,111,109,105,110,97,108,0,0,0,0,0,0,110,111,109,105,110,97,108,0,109,105,110,0,0,0,0,0,109,97,120,0,0,0,0,0,82,101,97,108,32,37,115,40,37,115,115,116,97,114,116,61,37,103,37,115,44,32,102,105,120,101,100,61,37,115,44,32,37,115,110,111,109,105,110,97,108,61,37,103,37,115,44,32,109,105,110,61,37,103,44,32,109,97,120,61,37,103,41,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,116,101,103,101,114,32,37,115,40,37,115,115,116,97,114,116,61,37,108,100,37,115,44,32,102,105,120,101,100,61,37,115,44,32,109,105,110,61,37,108,100,44,32,109,97,120,61,37,108,100,41,0,0,0,66,111,111,108,101,97,110,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,44,32,102,105,120,101,100,61,37,115,41,0,0,0,0,0,0,83,116,114,105,110,103,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,41,0,95,105,110,105,116,46,120,109,108,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,97,110,32,110,111,116,32,114,101,97,100,32,102,105,108,101,32,37,115,32,97,115,32,115,101,116,117,112,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,46,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,88,77,76,32,112,97,114,115,101,114,33,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,37,115,44,32,37,115,32,37,108,117,10,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,103,117,105,100,0,0,0,0,84,104,101,32,77,111,100,101,108,32,71,85,73,68,58,32,37,115,32,105,115,32,110,111,116,32,115,101,116,32,105,110,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,0,69,114,114,111,114,44,32,116,104,101,32,71,85,73,68,58,32,37,115,32,102,114,111,109,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,58,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,71,85,73,68,32,99,111,109,112,105,108,101,100,32,105,110,32,116,104,101,32,109,111,100,101,108,58,32,37,115,0,0,114,101,97,100,32,97,108,108,32,116,104,101,32,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,32,118,97,108,117,101,115,58,0,0,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,115,116,97,114,116,84,105,109,101,32,61,32,37,103,0,0,115,116,111,112,84,105,109,101,0,0,0,0,0,0,0,0,115,116,111,112,84,105,109,101,32,61,32,37,103,0,0,0,115,116,101,112,83,105,122,101,0,0,0,0,0,0,0,0,115,116,101,112,83,105,122,101,32,61,32,37,103,0,0,0,116,111,108,101,114,97,110,99,101,0,0,0,0,0,0,0,116,111,108,101,114,97,110,99,101,32,61,32,37,103,0,0,115,111,108,118,101,114,0,0,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,0,0,0,0,0,0,0,111,117,116,112,117,116,70,111,114,109,97,116,0,0,0,0,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,37,115,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,70,105,108,116,101,114,0,0,118,97,114,105,97,98,108,101,32,102,105,108,116,101,114,58,32,37,115,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,0,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,58,32,37,115,0,0,0,0,110,117,109,98,101,114,79,102,67,111,110,116,105,110,117,111,117,115,83,116,97,116,101,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,82,101,97,108,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,110,117,109,98,101,114,79,102,82,101,97,108,80,97,114,97,109,101,116,101,114,115,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,111,100,101,108,46,0,0,0,0,110,120,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,100,0,0,0,0,0,0,0,110,121,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,112,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,121,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,112,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,37,115,0,0,0,0,114,101,97,108,32,115,116,97,116,101,115,0,0,0,0,0,105,115,80,114,111,116,101,99,116,101,100,0,0,0,0,0,102,105,108,116,101,114,105,110,103,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,32,37,115,0,114,101,97,108,32,115,116,97,116,101,32,100,101,114,105,118,97,116,105,118,101,115,0,0,114,101,97,108,32,97,108,103,101,98,114,97,105,99,115,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,114,101,97,108,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,0,0,97,108,105,97,115,0,0,0,110,101,103,97,116,101,100,65,108,105,97,115,0,0,0,0,114,101,97,100,32,102,111,114,32,37,115,32,110,101,103,97,116,101,100,32,37,100,32,102,114,111,109,32,115,101,116,117,112,32,102,105,108,101,0,0,97,108,105,97,115,86,97,114,105,97,98,108,101,0,0,0,116,105,109,101,0,0,0,0,82,101,97,108,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,0,0,32,110,111,116,32,102,111,117,110,100,46,0,0,0,0,0,37,115,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,105,110,116,101,103,101,114,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,73,110,116,101,103,101,114,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,98,111,111,108,101,97,110,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,66,111,111,108,101,97,110,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,115,116,114,105,110,103,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,83,116,114,105,110,103,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,117,115,97,103,101,32,101,114,114,111,114,32,121,111,117,32,99,97,110,110,111,116,32,104,97,118,101,32,98,111,116,104,32,45,111,118,101,114,114,105,100,101,32,97,110,100,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,97,99,116,105,118,101,32,97,116,32,116,104,101,32,115,97,109,101,32,116,105,109,101,46,32,115,101,101,32,77,111,100,101,108,32,45,63,32,102,111,114,32,109,111,114,101,32,105,110,102,111,33,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,32,102,114,111,109,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,99,111,117,108,100,32,110,111,116,32,111,112,101,110,32,116,104,101,32,102,105,108,101,32,103,105,118,101,110,32,116,111,32,45,111,118,101,114,114,105,100,101,70,105,108,101,61,37,115,0,0,0,0,0,44,0,0,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,58,32,37,115,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,37,115,32,61,32,37,115,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,100,111,110,101,33,0,0,78,79,32,111,118,101,114,114,105,100,101,32,103,105,118,101,110,32,111,110,32,116,104,101,32,99,111,109,109,97,110,100,32,108,105,110,101,46,0,0,108,0,0,0,0,0,0,0,176,53,1,0,18,0,0,0,19,0,0,0,148,255,255,255,148,255,255,255,176,53,1,0,20,0,0,0,21,0,0,0,84,53,1,0,204,53,1,0,224,53,1,0,104,53,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,200,221,1,0,128,53,1,0,192,152,1,0,0,0,0,0,108,0,0,0,0,0,0,0,192,152,1,0,22,0,0,0,23,0,0,0,148,255,255,255,148,255,255,255,192,152,1,0,24,0,0,0,25,0,0,0,101,114,114,111,114,32,114,101,97,100,95,118,97,108,117,101,44,32,110,111,32,100,97,116,97,32,97,108,108,111,99,97,116,101,100,32,102,111,114,32,115,116,111,114,105,110,103,32,115,116,114,105,110,103,0,0,102,109,105,77,111,100,101,108,68,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,0,0,0,0,0,0,0,83,99,97,108,97,114,86,97,114,105,97,98,108,101,0,0,99,108,97,115,115,73,110,100,101,120,0,0,0,0,0,0,99,108,97,115,115,84,121,112,101,0,0,0,0,0,0,0,114,83,116,97,0,0,0,0,114,68,101,114,0,0,0,0,114,65,108,103,0,0,0,0,114,80,97,114,0,0,0,0,114,65,108,105,0,0,0,0,105,65,108,103,0,0,0,0,105,80,97,114,0,0,0,0,105,65,108,105,0,0,0,0,98,65,108,103,0,0,0,0,98,80,97,114,0,0,0,0,98,65,108,105,0,0,0,0,115,65,108,103,0,0,0,0,115,80,97,114,0,0,0,0,115,65,108,105,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,101,114,114,111,114,32,114,101,97,100,105,110,103,32,116,104,101,32,120,109,108,32,102,105,108,101,44,32,102,111,117,110,100,32,117,110,107,110,111,119,110,32,99,108,97,115,115,58,32,37,115,32,32,102,111,114,32,118,97,114,105,97,98,108,101,58,32,37,115,0,82,101,97,108,0,0,0,0,73,110,116,101,103,101,114,0,66,111,111,108,101,97,110,0,83,116,114,105,110,103,0,0,118,97,114,105,97,98,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,79,71,95,65,76,76,0,44,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,37,45,49,56,115,32,91,37,115,93,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,118,32,37,115,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,110,108,115,61,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,108,97,112,97,99,107,0,0,108,105,115,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,115,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,76,105,115,0,0,0,0,0,94,40,0,0,0,0,0,0,41,36,0,0,0,0,0,0,36,100,117,109,109,121,0,0,46,42,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,58,32,0,0,32,119,105,116,104,32,101,114,114,111,114,58,32,0,0,0,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,111,117,116,112,117,116,116,105,110,103,32,97,108,108,32,118,97,114,105,97,98,108,101,115,46,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,114,118,97,108,115,32,61,32,37,108,100,0,67,80,85,0,0,0,0,0,82,84,0,0,0,0,0,0,67,89,67,0,0,0,0,0,91,117,110,107,110,111,119,110,32,99,108,111,99,107,45,116,121,112,101,93,32,103,111,116,32,37,115,44,32,101,120,112,101,99,116,101,100,32,67,80,85,124,82,84,124,67,89,67,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,82,84,46,0,0,0,0,0,67,104,111,115,101,110,32,99,108,111,99,107,45,116,121,112,101,58,32,37,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,114,101,97,108,45,116,105,109,101,46,0,0,76,105,110,101,97,114,105,122,97,116,105,111,110,32,119,105,108,108,32,112,101,114,102,111,114,109,101,100,32,97,116,32,112,111,105,110,116,32,111,102,32,116,105,109,101,58,32,37,102,0,0,0,0,0,0,0,111,118,101,114,119,114,105,116,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,32,91,102,114,111,109,32,99,111,109,109,97,110,100,32,108,105,110,101,93,0,95,114,101,115,46,0,0,0,0,0,0,0,0,0,0,0,76,105,110,101,97,114,32,109,111,100,101,108,32,105,115,32,99,114,101,97,116,101,100,33,0,0,0,0,0,0,0,0,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,95,112,114,111,102,46,112,108,116,0,0,0,0,0,0,0,115,118,103,0,0,0,0,0,101,109,112,116,121,0,0,0,99,115,118,0,0,0,0,0,109,97,116,0,0,0,0,0,119,97,108,108,0,0,0,0,112,108,116,0,0,0,0,0,85,110,107,110,111,119,110,32,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,0,65,108,108,111], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+70412);
/* memory initializer */ allocate([99,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,115,116,111,114,97,103,101,32,102,111,114,32,109,101,116,104,111,100,32,39,37,115,39,32,97,110,100,32,102,105,108,101,61,39,37,115,39,0,0,120,63,1,0,96,65,1,0,104,65,1,0,176,67,1,0,200,65,1,0,216,65,1,0,184,67,1,0,192,67,1,0,200,67,1,0,208,67,1,0,224,67,1,0,240,67,1,0,0,68,1,0,16,68,1,0,32,68,1,0,48,68,1,0,64,68,1,0,88,68,1,0,144,67,1,0,168,67,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,115,32,37,115,0,0,0,0,0,0,0,120,63,1,0,96,65,1,0,104,65,1,0,120,65,1,0,200,65,1,0,216,65,1,0,232,65,1,0,8,66,1,0,40,66,1,0,72,66,1,0,112,66,1,0,152,66,1,0,192,66,1,0,232,66,1,0,0,67,1,0,32,67,1,0,64,67,1,0,104,67,1,0,144,67,1,0,168,67,1,0,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,37,115,0,0,0,117,115,97,103,101,58,32,37,115,0,0,0,0,0,0,0,60,45,37,115,62,10,32,32,37,115,0,0,0,0,0,0,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,32,32,37,115,0,91,117,110,107,110,111,119,110,32,102,108,97,103,45,116,121,112,101,93,32,60,45,37,115,62,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,108,111,103,70,111,114,109,97,116,61,37,115,44,32,101,120,112,101,99,116,101,100,32,116,101,120,116,32,111,114,32,120,109,108,0,0,0,0,0,0,0,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,62,10,37,115,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,37,115,0,0,0,0,120,63,1,0,64,65,1,0,72,65,1,0,80,65,1,0,120,63,1,0,128,64,1,0,208,64,1,0,0,65,1,0,120,63,1,0,64,64,1,0,72,64,1,0,80,64,1,0,96,64,1,0,104,64,1,0,120,64,1,0,0,0,0,0,120,63,1,0,128,63,1,0,152,63,1,0,168,63,1,0,240,63,1,0,0,64,1,0,32,64,1,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,104,101,108,112,61,37,115,0,0,0,117,115,101,32,37,115,32,45,104,101,108,112,32,102,111,114,32,97,32,108,105,115,116,32,111,102,32,97,108,108,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,67,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,103,108,111,98,97,108,32,100,97,116,97,32,115,116,114,117,99,116,117,114,101,32,102,105,108,101,0,0,0,0,0,0,78,111,32,118,97,114,105,97,98,108,101,115,32,105,110,32,116,104,101,32,109,111,100,101,108,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,109,111,100,101,108,62,37,115,60,47,109,111,100,101,108,62,10,0,0,0,0,0,0,60,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,37,103,60,47,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,10,0,0,60,111,108,100,84,105,109,101,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,62,10,0,0,0,0,0,0,0,60,111,108,100,84,105,109,101,50,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,50,62,10,0,0,0,0,0,60,100,105,102,102,79,108,100,84,105,109,101,62,37,103,60,47,100,105,102,102,79,108,100,84,105,109,101,62,10,0,0,60,99,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,99,117,114,114,101,110,116,84,105,109,101,62,10,0,0,60,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,10,0,0,1,0,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,101,117,108,101,114,0,0,0,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,114,97,100,97,117,53,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,51,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,49,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,108,111,98,97,116,116,111,50,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,113,115,115,0,0,0,0,0,100,97,115,115,108,0,0,0,114,97,100,97,117,53,0,0,114,97,100,97,117,51,0,0,114,97,100,97,117,49,0,0,108,111,98,97,116,116,111,50,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,0,0,0,0,0,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,60,115,116,97,116,117,115,62,0,0,0,0,0,0,0,0,60,112,104,97,115,101,62,85,78,75,78,79,87,78,60,47,112,104,97,115,101,62,0,0,60,47,115,116,97,116,117,115,62,0,0,0,0,0,0,0,44,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,115,101,101,100,58,32,100,97,116,97,45,62,115,105,109,117,108,97,116,105,111,110,73,110,102,111,46,97,110,97,108,121,116,105,99,74,97,99,111,98,105,97,110,115,91,105,110,100,101,120,93,46,115,101,101,100,86,97,114,115,91,37,100,93,61,32,37,102,0,0,0,0,119,114,105,116,101,32,105,110,32,106,97,99,91,37,100,93,45,91,37,100,44,37,100,93,61,37,103,32,102,114,111,109,32,114,111,119,91,37,100,93,61,37,103,0,0,0,0,0,80,114,105,110,116,32,106,97,99,58,0,0,0,0,0,0,37,32,46,53,101,32,0,0,99,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,65,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,66,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,67,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,68,32,0,0,0,0,105,32,102,111,114,32,105,32,105,110,32,49,58,48,0,0,108,105,110,101,97,114,95,0,46,109,111,0,0,0,0,0,119,98,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,0,0,0,0,0,56,0,0,0,0,0,0,0,152,70,1,0,26,0,0,0,27,0,0,0,200,255,255,255,200,255,255,255,152,70,1,0,28,0,0,0,29,0,0,0,36,70,1,0,180,70,1,0,200,70,1,0,56,70,1,0,78,83,116,51,95,95,49,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,200,221,1,0,80,70,1,0,80,153,1,0,0,0,0,0,56,0,0,0,0,0,0,0,80,153,1,0,12,0,0,0,13,0,0,0,200,255,255,255,200,255,255,255,80,153,1,0,14,0,0,0,15,0,0,0,0,0,0,0,88,71,1,0,30,0,0,0,31,0,0,0,4,0,0,0,11,0,0,0,3,0,0,0,5,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,36,0,0,0,34,0,0,0,26,0,0,0,10,0,0,0,27,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,200,221,1,0,16,71,1,0,72,152,1,0,0,0,0,0,67,97,108,117,99,117,108,97,116,101,32,111,110,101,32,99,111,108,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,103,110,117,112,108,111,116,0,80,108,111,116,115,32,111,102,32,112,114,111,102,105,108,105,110,103,32,100,97,116,97,32,119,101,114,101,32,100,105,115,97,98,108,101,100,58,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,58,32,37,115,10,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,115,118,103,10,0,0,0,0,0,0,0,115,101,116,32,110,111,107,101,121,10,0,0,0,0,0,0,115,101,116,32,102,111,114,109,97,116,32,121,32,34,37,103,34,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,111,102,32,103,108,111,98,97,108,32,115,116,101,112,115,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,100,111,99,32,91,32,32,60,33,69,76,69,77,69,78,84,32,115,105,109,117,108,97,116,105,111,110,32,40,109,111,100,101,108,105,110,102,111,44,32,118,97,114,105,97,98,108,101,115,44,32,102,117,110,99,116,105,111,110,115,44,32,101,113,117,97,116,105,111,110,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,118,97,114,105,97,98,108,101,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,101,113,117,97,116,105,111,110,32,40,114,101,102,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,101,113,117,97,116,105,111,110,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,115,32,40,112,114,111,102,105,108,101,98,108,111,99,107,42,41,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,32,40,114,101,102,115,44,32,110,99,97,108,108,44,32,116,105,109,101,44,32,109,97,120,84,105,109,101,41,62,32,32,60,33,69,76,69,77,69,78,84,32,114,101,102,115,32,40,114,101,102,42,41,62,32,32,60,33,65,84,84,76,73,83,84,32,114,101,102,32,114,101,102,105,100,32,73,68,82,69,70,32,35,82,69,81,85,73,82,69,68,62,32,32,93,62,10,0,0,0,0,116,105,109,101,40,41,32,102,97,105,108,101,100,58,32,37,115,0,0,0,0,0,0,0,37,89,45,37,109,45,37,100,32,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,115,116,114,102,116,105,109,101,40,41,32,102,97,105,108,101,100,0,0,0,0,0,0,0,60,115,105,109,117,108,97,116,105,111,110,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,62,10,0,0,0,0,60,110,97,109,101,62,0,0,60,47,110,97,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,102,105,120,62,0,0,0,0,0,0,0,0,60,47,112,114,101,102,105,120,62,10,0,0,0,0,0,0,60,100,97,116,101,62,0,0,60,47,100,97,116,101,62,10,0,0,0,0,0,0,0,0,60,109,101,116,104,111,100,62,0,0,0,0,0,0,0,0,60,47,109,101,116,104,111,100,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,111,114,109,97,116,62,0,0,60,47,111,117,116,112,117,116,70,111,114,109,97,116,62,10,0,0,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,0,0,0,0,0,0,0,0,60,47,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,37,108,100,60,47,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,10,0,0,0,60,111,118,101,114,104,101,97,100,84,105,109,101,62,37,102,60,47,111,118,101,114,104,101,97,100,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,105,110,105,116,84,105,109,101,62,37,102,60,47,112,114,101,105,110,105,116,84,105,109,101,62,10,0,0,60,105,110,105,116,84,105,109,101,62,37,102,60,47,105,110,105,116,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,101,118,101,110,116,84,105,109,101,62,37,102,60,47,101,118,101,110,116,84,105,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,84,105,109,101,62,37,102,60,47,111,117,116,112,117,116,84,105,109,101,62,10,0,0,0,0,60,108,105,110,101,97,114,105,122,101,84,105,109,101,62,37,102,60,47,108,105,110,101,97,114,105,122,101,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,84,105,109,101,62,37,102,60,47,116,111,116,97,108,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,37,102,60,47,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,10,0,0,0,0,60,110,117,109,83,116,101,112,62,37,100,60,47,110,117,109,83,116,101,112,62,10,0,0,60,109,97,120,84,105,109,101,62,37,46,57,102,60,47,109,97,120,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,0,60,111,100,101,84,105,109,101,62,37,102,60,47,111,100,101,84,105,109,101,62,10,0,0,60,111,100,101,84,105,109,101,84,105,99,107,115,62,37,108,117,60,47,111,100,101,84,105,109,101,84,105,99,107,115,62,10,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,60,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,0,60,47,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,60,118,97,114,105,97,98,108,101,115,62,10,0,0,0,0,60,47,118,97,114,105,97,98,108,101,115,62,10,0,0,0,60,102,117,110,99,116,105,111,110,115,62,10,0,0,0,0,60,47,102,117,110,99,116,105,111,110,115,62,10,0,0,0,60,101,113,117,97,116,105,111,110,115,62,10,0,0,0,0,60,47,101,113,117,97,116,105,111,110,115,62,10,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,60,47,115,105,109,117,108,97,116,105,111,110,62,10,0,0,98,117,102,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,109,111,100,101,108,105,110,102,111,46,99,0,0,112,114,105,110,116,77,111,100,101,108,73,110,102,111,0,0,87,97,114,110,105,110,103,58,32,80,108,111,116,32,99,111,109,109,97,110,100,32,102,97,105,108,101,100,10,0,0,0,120,115,108,116,112,114,111,99,0,0,0,0,0,0,0,0,37,115,32,45,111,32,37,115,95,112,114,111,102,46,104,116,109,108,32,37,115,47,115,104,97,114,101,47,111,109,99,47,115,99,114,105,112,116,115,47,100,101,102,97,117,108,116,95,112,114,111,102,105,108,105,110,103,46,120,115,108,32,37,115,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,103,101,110,101,114,97,116,101,32,104,116,109,108,32,118,101,114,115,105,111,110,32,111,102,32,112,114,111,102,105,108,105,110,103,32,114,101,115,117,108,116,115,58,32,37,115,10,0,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,97,114,101,32,115,116,111,114,101,100,32,105,110,32,37,115,95,112,114,111,102,46,104,116,109,108,32,40,104,117,109,97,110,45,114,101,97,100,97,98,108,101,41,32,97,110,100,32,37,115,95,112,114,111,102,46,120,109,108,32,40,102,111,114,32,88,83,76,32,116,114,97,110,115,102,111,114,109,115,32,111,114,32,109,111,114,101,32,100,101,116,97,105,108,115,41,0,0,0,0,0,0,101,113,0,0,0,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,101,113,37,100,34,47,62,10,0,0,0,0,60,110,99,97,108,108,62,37,100,60,47,110,99,97,108,108,62,10,0,0,0,0,0,0,60,116,105,109,101,62,37,46,57,102,60,47,116,105,109,101,62,10,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,0,0,0,0,0,0,0,60,101,113,117,97,116,105,111,110,32,105,100,61,34,101,113,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,0,34,62,10,0,0,0,0,0,60,114,101,102,115,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,118,97,114,37,100,34,32,47,62,10,0,0,60,47,114,101,102,115,62,10,0,0,0,0,0,0,0,0,60,99,97,108,99,105,110,102,111,32,116,105,109,101,61,34,37,102,34,32,99,111,117,110,116,61,34,37,108,117,34,47,62,10,0,0,0,0,0,0,60,47,101,113,117,97,116,105,111,110,62,10,0,0,0,0,102,117,110,0,0,0,0,0,60,102,117,110,99,116,105,111,110,32,105,100,61,34,102,117,110,37,100,34,62,10,0,0,60,47,102,117,110,99,116,105,111,110,62,10,0,0,0,0,60,105,110,102,111,32,102,105,108,101,110,97,109,101,61,34,0,0,0,0,0,0,0,0,34,32,115,116,97,114,116,108,105,110,101,61,34,37,100,34,32,115,116,97,114,116,99,111,108,61,34,37,100,34,32,101,110,100,108,105,110,101,61,34,37,100,34,32,101,110,100,99,111,108,61,34,37,100,34,32,114,101,97,100,111,110,108,121,61,34,37,115,34,32,47,62,10,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,60,118,97,114,105,97,98,108,101,32,105,100,61,34,118,97,114,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,34,32,99,111,109,109,101,110,116,61,34,0,0,0,0,0,60,47,118,97,114,105,97,98,108,101,62,10,0,0,0,0,37,115,95,112,114,111,102,46,100,97,116,97,0,0,0,0,60,102,105,108,101,110,97,109,101,62,0,0,0,0,0,0,60,47,102,105,108,101,110,97,109,101,62,10,0,0,0,0,60,102,105,108,101,115,105,122,101,62,37,108,100,60,47,102,105,108,101,115,105,122,101,62,10,0,0,0,0,0,0,0,60,102,111,114,109,97,116,62,10,0,0,0,0,0,0,0,60,117,105,110,116,51,50,62,115,116,101,112,60,47,117,105,110,116,51,50,62,10,0,0,60,100,111,117,98,108,101,62,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,60,100,111,117,98,108,101,62,99,112,117,32,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,0,0,0,0,60,117,105,110,116,51,50,62,0,0,0,0,0,0,0,0,32,40,99,97,108,108,115,41,60,47,117,105,110,116,51,50,62,10,0,0,0,0,0,0,60,100,111,117,98,108,101,62,0,0,0,0,0,0,0,0,32,40,99,112,117,32,116,105,109,101,41,60,47,100,111,117,98,108,101,62,10,0,0,0,60,47,102,111,114,109,97,116,62,10,0,0,0,0,0,0,114,98,0,0,0,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,112,111,115,59,0,0,38,113,117,111,116,59,0,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,50,100,111,117,98,108,101,37,37,42,37,100,117,105,110,116,51,50,37,37,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,49,58,40,36,37,100,62,49,101,45,57,32,63,32,36,37,100,32,58,32,49,101,45,51,48,41,32,119,32,108,32,108,119,32,37,100,10,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,42,50,100,111,117,98,108,101,37,37,37,100,117,105,110,116,51,50,37,37,42,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,37,100,32,119,32,108,32,108,119,32,37,100,10,0,0,0,0,0,0,0,0,117,110,115,101,116,32,120,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,121,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,98,111,114,100,101,114,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,115,101,116,32,116,105,116,108,101,10,0,0,0,0,0,0,115,101,116,32,120,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,108,111,103,32,121,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,37,103,93,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,42,93,10,0,0,0,0,0,0,0,115,101,116,32,110,111,108,111,103,32,120,121,10,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,37,103,58,37,103,93,10,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,0,0,115,101,116,32,121,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,120,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,98,111,114,100,101,114,10,0,0,0,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,37,115,10,0,0,0,0,0,0,0,0,115,101,116,32,116,105,116,108,101,32,34,37,115,34,10,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,97,116,32,116,105,109,101,34,10,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,91,115,93,34,10,0,0,0,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,37,115,34,10,0,0,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,110,117,109,98,101,114,34,10,0,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,99,111,117,110,116,34,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,37,115,58,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,101,120,112,97,116,32,111,98,106,101,99,116,0,0,0,68,117,109,109,121,32,101,113,117,97,116,105,111,110,32,115,111,32,119,101,32,99,97,110,32,105,110,100,101,120,32,102,114,111,109,32,49,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,105,109,117,108,97,116,105,111,110,95,105,110,102,111,95,120,109,108,46,99,0,0,0,0,0,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,120,109,108,45,62,110,69,113,117,97,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,49,93,0,0,0,109,111,100,101,108,73,110,102,111,88,109,108,73,110,105,116,0,0,0,0,0,0,0,0,120,109,108,45,62,110,70,117,110,99,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,51,93,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,119,101,32,111,110,108,121,32,104,97,118,101,32,37,108,100,32,115,117,99,104,32,98,108,111,99,107,115,0,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,105,116,33,0,0,0,0,0,0,118,97,114,105,97,98,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,113,117,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,97,114,0,0,76,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,105,110,100,101,120,32,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,0,110,111,110,108,105,110,101,97,114,0,0,0,0,0,0,0,78,111,110,108,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,114,101,115,105,100,117,97,108,70,117,110,99,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,101,102,105,110,101,115,0,110,97,109,101,0,0,0,0,60,100,101,102,105,110,101,115,62,32,110,101,101,100,115,32,116,111,32,104,97,118,101,32,101,120,97,99,116,108,121,32,111,110,101,32,97,116,116,114,105,98,117,116,101,58,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,0,0,0,0,102,105,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,83,116,97,114,116,0,0,0,0,0,0,0,108,105,110,101,69,110,100,0,99,111,108,83,116,97,114,116,0,0,0,0,0,0,0,0,99,111,108,69,110,100,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,37,115,58,32,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,105,110,32,60,105,110,102,111,62,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,109,111,114,101,32,101,113,117,97,116,105,111,110,115,32,116,104,97,110,32,101,120,112,101,99,116,101,100,32,40,37,108,100,41,0,0,0,0,105,110,100,101,120,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,111,117,116,32,105,110,100,101,120,0,0,0,0,0,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,103,111,116,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,105,110,100,101,120,32,37,108,100,44,32,101,120,112,101,99,116,101,100,32,37,108,100,0,0,0,0,0,0,0,83,79,77,69,32,78,73,67,69,32,69,81,85,65,84,73,79,78,32,78,65,77,69,32,40,116,111,32,98,101,32,115,101,116,32,97,32,108,105,116,116,108,101,32,108,97,116,101,114,41,0,0,0,0,0,0,99,111,109,109,101,110,116,0,60,118,97,114,62,45,116,97,103,32,100,105,100,32,110,111,116,32,115,101,116,32,110,97,109,101,32,97,110,100,32,99,111,109,109,101,110,116,0,0,35,70,73,88,77,69,35,0,84,79,68,79,58,32,83,101,116,32,109,101,32,117,112,33,33,33,0,0,0,0,0,0,100,117,109,109,121,86,97,114,83,116,97,116,101,83,101,116,74,97,99,0,0,0,0,0,255,255,255,255,232,91,1,0,232,91,1,0,232,91,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,100,32,39,37,115,39,32,116,104,97,116,32,119,97,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,97,115,32,60,118,97,114,105,97,98,108,101,62,0,0,0,0,0,63,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,78,65,77,69,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,83,67,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,84,65,73,76,69,68,95,68,69,83,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,97,99,104,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,111,110,99,101,58,32,37,115,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,37,115,0,83,84,79,80,32,0,0,0,32,115,116,97,116,101,109,101,110,116,32,101,120,101,99,117,116,101,100,10,0,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,110,100,102,105,108,101,0,101,114,114,111,114,32,105,110,32,102,111,114,109,97,116,0,105,108,108,101,103,97,108,32,117,110,105,116,32,110,117,109,98,101,114,0,0,0,0,0,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,100,105,114,101,99,116,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,115,101,113,117,101,110,116,105,97,108,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,99,97,110,39,116,32,98,97,99,107,115,112,97,99,101,32,102,105,108,101,0,0,0,0,110,117,108,108,32,102,105,108,101,32,110,97,109,101,0,0,99,97,110,39,116,32,115,116,97,116,32,102,105,108,101,0,117,110,105,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,111,102,102,32,101,110,100,32,111,102,32,114,101,99,111,114,100,0,0,0,0,0,0,0,116,114,117,110,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,101,110,100,102,105,108,101,0,0,0,0,105,110,99,111,109,112,114,101,104,101,110,115,105,98,108,101,32,108,105,115,116,32,105,110,112,117,116,0,0,0,0,0,111,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,0,0,0,0,0,0,0,114,101,97,100,32,117,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,98,97,100,32,108,111,103,105,99,97,108,32,105,110,112,117,116,32,102,105,101,108,100,0,98,97,100,32,118,97,114,105,97,98,108,101,32,116,121,112,101,0,0,0,0,0,0,0,98,97,100,32,110,97,109,101,108,105,115,116,32,110,97,109,101,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,32,110,111,116,32,105,110,32,110,97,109,101,108,105,115,116,0,0,0,0,0,0,0,0,110,111,32,101,110,100,32,114,101,99,111,114,100,0,0,0,118,97,114,105,97,98,108,101,32,99,111,117,110,116,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,32,102,111,114,32,115,99,97,108,97,114,32,118,97,114,105,97,98,108,101,0,0,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,115,101,99,116,105,111,110,0,0,0,115,117,98,115,116,114,105,110,103,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,115,117,98,115,99,114,105,112,116,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,99,97,110,39,116,32,114,101,97,100,32,102,105,108,101,0,99,97,110,39,116,32,119,114,105,116,101,32,102,105,108,101,0,0,0,0,0,0,0,0,39,110,101,119,39,32,102,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,0,0,99,97,110,39,116,32,97,112,112,101,110,100,32,116,111,32,102,105,108,101,0,0,0,0,110,111,110,45,112,111,115,105,116,105,118,101,32,114,101,99,111,114,100,32,110,117,109,98,101,114,0,0,0,0,0,0,110,109,76,98,117,102,32,111,118,101,114,102,108,111,119,0,144,94,1,0,160,94,1,0,184,94,1,0,216,94,1,0,248,94,1,0,16,95,1,0,48,95,1,0,72,95,1,0,88,95,1,0,104,95,1,0,128,95,1,0,152,95,1,0,184,95,1,0,216,95,1,0,104,95,1,0,240,95,1,0,16,96,1,0,40,96,1,0,64,96,1,0,88,96,1,0,120,96,1,0,136,96,1,0,168,96,1,0,200,96,1,0,224,96,1,0,248,96,1,0,16,97,1,0,32,97,1,0,56,97,1,0,80,97,1,0,104,97,1,0,136,97,1,0,37,115,58,32,105,108,108,101,103,97,108,32,101,114,114,111,114,32,110,117,109,98,101,114,32,37,100,10,0,0,0,0,37,115,58,32,101,110,100,32,111,102,32,102,105,108,101,10,0,0,0,0,0,0,0,0,37,115,58,32,37,115,10,0,0,0,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,117,110,105,116,32,37,100,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+80652);
/* memory initializer */ allocate([110,97,109,101,100,32,37,115,10,0,0,0,0,0,0,0,40,117,110,110,97,109,101,100,41,10,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,105,110,116,101,114,110,97,108,32,73,47,79,10,0,0,0,0,0,0,0,0,0,0,0,108,97,115,116,32,102,111,114,109,97,116,58,32,37,115,10,0,0,0,0,0,0,0,0,108,97,116,101,108,121,32,37,115,32,37,115,32,37,115,32,37,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,101,97,100,105,110,103,0,119,114,105,116,105,110,103,0,0,0,0,0,0,0,0,0,115,101,113,117,101,110,116,105,97,108,0,0,0,0,0,0,100,105,114,101,99,116,0,0,0,0,0,0,0,0,0,0,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,105,110,116,101,114,110,97,108,0,0,0,0,0,0,0,0,32,73,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+95544);
/* memory initializer */ allocate([117,110,107,110,111,119,110,32,99,111,100,101,32,105,110,32,100,111,95,102,105,111,58,32,37,100,10,37,115,10,0,0,100,111,95,102,105,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,100,32,115,116,114,105,110,103,0,0,0,0,0,0,102,111,114,109,97,116,32,116,111,111,32,99,111,109,112,108,105,99,97,116,101,100,58,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,0,0,0,0,0,0,0,144,138,1,0,152,138,1,0,119,98,0,0,0,0,0,0,119,0,0,0,0,0,0,0,114,43,98,0,0,0,0,0,114,43,0,0,0,0,0,0,168,138,1,0,176,138,1,0,184,138,1,0,192,138,1,0,144,1,0,0,0,0,0,0,48,139,1,0,0,0,0,0,111,112,101,110,0,0,0,0,102,111,114,116,46,37,108,100,0,0,0,0,0,0,0,0,110,111,32,115,112,97,99,101,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,102,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,117,114,101,0,0,115,116,97,114,116,105,111,0,115,102,101,0,0,0,0,0,37,35,46,42,69,0,0,0,37,43,46,50,100,0,0,0,37,35,46,42,102,0,0,0,119,95,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,0,119,95,110,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,108,101,102,116,32,111,102,102,0,0,0,0,0,0,0,0,114,101,99,101,110,100,0,0,115,116,97,114,116,105,111,0,119,114,105,116,101,32,115,116,97,114,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+100768);
/* memory initializer */ allocate([8,146,1,0,32,0,0,0,33,0,0,0,5,0,0,0,12,0,0,0,4,0,0,0,6,0,0,0,37,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,200,221,1,0,232,145,1,0,136,152,1,0,0,0,0,0,0,0,0,0,112,146,1,0,34,0,0,0,35,0,0,0,6,0,0,0,12,0,0,0,4,0,0,0,6,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,42,0,0,0,43,0,0,0,30,0,0,0,15,0,0,0,31,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,200,221,1,0,88,146,1,0,136,152,1,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,0,0,0,0,8,147,1,0,36,0,0,0,37,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,7,0,0,0,44,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,16,0,0,0,33,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,200,221,1,0,232,146,1,0,72,152,1,0,0,0,0,0,0,0,0,0,112,147,1,0,38,0,0,0,39,0,0,0,8,0,0,0,11,0,0,0,5,0,0,0,7,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,46,0,0,0,47,0,0,0,34,0,0,0,10,0,0,0,35,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,200,221,1,0,88,147,1,0,72,152,1,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,160,221,1,0,128,147,1,0,0,0,0,0,232,147,1,0,40,0,0,0,41,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,144,148,1,0,42,0,0,0,43,0,0,0,49,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,200,221,1,0,216,147,1,0,0,0,0,0,0,0,0,0,0,0,0,0,40,148,1,0,40,0,0,0,44,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,200,221,1,0,16,148,1,0,232,147,1,0,0,0,0,0,0,0,0,0,104,148,1,0,40,0,0,0,45,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,200,221,1,0,80,148,1,0,232,147,1,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,200,221,1,0,120,148,1,0,0,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,0,0,0,0,216,148,1,0,46,0,0,0,47,0,0,0,49,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,200,221,1,0,192,148,1,0,144,148,1,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,160,221,1,0,232,148,1,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,200,221,1,0,16,149,1,0,8,149,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,0,0,0,0,192,151,1,0,48,0,0,0,49,0,0,0,0,0,0,0,72,152,1,0,50,0,0,0,51,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,7,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,10,0,0,0,35,0,0,0,0,0,0,0,136,152,1,0,52,0,0,0,53,0,0,0,9,0,0,0,12,0,0,0,4,0,0,0,6,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,15,0,0,0,31,0,0,0,8,0,0,0,0,0,0,0,192,152,1,0,22,0,0,0,23,0,0,0,248,255,255,255,248,255,255,255,192,152,1,0,24,0,0,0,25,0,0,0,8,0,0,0,0,0,0,0,8,153,1,0,54,0,0,0,55,0,0,0,248,255,255,255,248,255,255,255,8,153,1,0,56,0,0,0,57,0,0,0,4,0,0,0,0,0,0,0,80,153,1,0,12,0,0,0,13,0,0,0,252,255,255,255,252,255,255,255,80,153,1,0,14,0,0,0,15,0,0,0,4,0,0,0,0,0,0,0,152,153,1,0,58,0,0,0,59,0,0,0,252,255,255,255,252,255,255,255,152,153,1,0,60,0,0,0,61,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,151,1,0,62,0,0,0,63,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,136,151,1,0,64,0,0,0,65,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,200,221,1,0,64,151,1,0,216,148,1,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,160,221,1,0,112,151,1,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,200,221,1,0,144,151,1,0,136,151,1,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,200,221,1,0,208,151,1,0,136,151,1,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,160,221,1,0,16,152,1,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,160,221,1,0,80,152,1,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,40,222,1,0,144,152,1,0,0,0,0,0,1,0,0,0,192,151,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,40,222,1,0,216,152,1,0,0,0,0,0,1,0,0,0,0,152,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,40,222,1,0,32,153,1,0,0,0,0,0,1,0,0,0,192,151,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,40,222,1,0,104,153,1,0,0,0,0,0,1,0,0,0,0,152,1,0,3,244,255,255,0,0,0,0,248,153,1,0,66,0,0,0,67,0,0,0,50,0,0,0,2,0,0,0,17,0,0,0,18,0,0,0,3,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,200,221,1,0,216,153,1,0,40,149,1,0,0,0,0,0,0,0,0,0,32,168,1,0,68,0,0,0,69,0,0,0,70,0,0,0,1,0,0,0,8,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,168,1,0,71,0,0,0,72,0,0,0,70,0,0,0,2,0,0,0,9,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,172,1,0,73,0,0,0,74,0,0,0,70,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,144,173,1,0,75,0,0,0,76,0,0,0,70,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,174,1,0,77,0,0,0,78,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,23,0,0,0,8,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,174,1,0,79,0,0,0,80,0,0,0,70,0,0,0,10,0,0,0,11,0,0,0,25,0,0,0,12,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,16,170,1,0,81,0,0,0,82,0,0,0,70,0,0,0,51,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,16,170,1,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,72,58,37,77,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,176,170,1,0,83,0,0,0,84,0,0,0,70,0,0,0,59,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,176,170,1,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,64,171,1,0,85,0,0,0,86,0,0,0,70,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,171,1,0,87,0,0,0,88,0,0,0,70,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,168,1,0,89,0,0,0,90,0,0,0,70,0,0,0,67,0,0,0,68,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,69,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,168,1,0,91,0,0,0,92,0,0,0,70,0,0,0,70,0,0,0,71,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,72,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,169,1,0,93,0,0,0,94,0,0,0,70,0,0,0,73,0,0,0,74,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,75,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,169,1,0,95,0,0,0,96,0,0,0,70,0,0,0,76,0,0,0,77,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,78,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,175,1,0,97,0,0,0,98,0,0,0,70,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,76,102,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,0,0,0,0,8,176,1,0,99,0,0,0,100,0,0,0,70,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,0,0,0,0,152,176,1,0,101,0,0,0,102,0,0,0,70,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,0,0,0,0,40,177,1,0,103,0,0,0,104,0,0,0,70,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,172,1,0,105,0,0,0,106,0,0,0,70,0,0,0,21,0,0,0,14,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,172,1,0,107,0,0,0,108,0,0,0,70,0,0,0,22,0,0,0,15,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,118,101,99,116,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,248,167,1,0,109,0,0,0,110,0,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,164,1,0,111,0,0,0,112,0,0,0,70,0,0,0,36,0,0,0,23,0,0,0,37,0,0,0,24,0,0,0,38,0,0,0,28,0,0,0,25,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,165,1,0,113,0,0,0,114,0,0,0,70,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,79,0,0,0,80,0,0,0,5,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,167,1,0,115,0,0,0,116,0,0,0,70,0,0,0,82,0,0,0,83,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,208,167,1,0,117,0,0,0,118,0,0,0,70,0,0,0,84,0,0,0,85,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,116,114,117,101,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,0,0,0,0,8,164,1,0,119,0,0,0,120,0,0,0,70,0,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,200,221,1,0,240,163,1,0,160,147,1,0,0,0,0,0,0,0,0,0,152,164,1,0,119,0,0,0,121,0,0,0,70,0,0,0,26,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,39,0,0,0,27,0,0,0,40,0,0,0,28,0,0,0,41,0,0,0,32,0,0,0,29,0,0,0,6,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,160,221,1,0,120,164,1,0,40,222,1,0,96,164,1,0,0,0,0,0,2,0,0,0,8,164,1,0,2,0,0,0,144,164,1,0,2,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,40,222,1,0,184,164,1,0,0,0,0,0,2,0,0,0,8,164,1,0,2,0,0,0,144,164,1,0,2,0,0,0,0,0,0,0,104,165,1,0,119,0,0,0,122,0,0,0,70,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,86,0,0,0,87,0,0,0,8,0,0,0,88,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,160,221,1,0,72,165,1,0,40,222,1,0,32,165,1,0,0,0,0,0,2,0,0,0,8,164,1,0,2,0,0,0,96,165,1,0,2,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,40,222,1,0,136,165,1,0,0,0,0,0,2,0,0,0,8,164,1,0,2,0,0,0,96,165,1,0,2,0,0,0,0,0,0,0,40,166,1,0,119,0,0,0,123,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,9,0,0,0,89,0,0,0,90,0,0,0,10,0,0,0,91,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,40,222,1,0,0,166,1,0,0,0,0,0,2,0,0,0,8,164,1,0,2,0,0,0,96,165,1,0,2,0,0,0,0,0,0,0,160,166,1,0,119,0,0,0,124,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,40,222,1,0,120,166,1,0,0,0,0,0,2,0,0,0,8,164,1,0,2,0,0,0,96,165,1,0,2,0,0,0,0,0,0,0,24,167,1,0,119,0,0,0,125,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,200,221,1,0,240,166,1,0,160,166,1,0,0,0,0,0,0,0,0,0,128,167,1,0,119,0,0,0,126,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,200,221,1,0,88,167,1,0,160,166,1,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,200,221,1,0,144,167,1,0,8,164,1,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,200,221,1,0,184,167,1,0,8,164,1,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,200,221,1,0,224,167,1,0,8,164,1,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,200,221,1,0,8,168,1,0,8,164,1,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,200,221,1,0,48,168,1,0,8,164,1,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,160,221,1,0,120,168,1,0,40,222,1,0,88,168,1,0,0,0,0,0,2,0,0,0,8,164,1,0,2,0,0,0,144,168,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,40,222,1,0,184,168,1,0,0,0,0,0,2,0,0,0,8,164,1,0,2,0,0,0,144,168,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,40,222,1,0,248,168,1,0,0,0,0,0,2,0,0,0,8,164,1,0,2,0,0,0,144,168,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,40,222,1,0,56,169,1,0,0,0,0,0,2,0,0,0,8,164,1,0,2,0,0,0,144,168,1,0,2,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,160,221,1,0,192,169,1,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,160,221,1,0,224,169,1,0,40,222,1,0,120,169,1,0,0,0,0,0,3,0,0,0,8,164,1,0,2,0,0,0,216,169,1,0,2,0,0,0,8,170,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,160,221,1,0,128,170,1,0,40,222,1,0,56,170,1,0,0,0,0,0,3,0,0,0,8,164,1,0,2,0,0,0,216,169,1,0,2,0,0,0,168,170,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,160,221,1,0,32,171,1,0,40,222,1,0,216,170,1,0,0,0,0,0,2,0,0,0,8,164,1,0,2,0,0,0,56,171,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,40,222,1,0,96,171,1,0,0,0,0,0,2,0,0,0,8,164,1,0,2,0,0,0,56,171,1,0,0,8,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,160,221,1,0,224,171,1,0,40,222,1,0,200,171,1,0,0,0,0,0,2,0,0,0,8,164,1,0,2,0,0,0,248,171,1,0,2,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,40,222,1,0,32,172,1,0,0,0,0,0,2,0,0,0,8,164,1,0,2,0,0,0,248,171,1,0,2,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,160,221,1,0,184,172,1,0,40,222,1,0,160,172,1,0,0,0,0,0,1,0,0,0,216,172,1,0,0,0,0,0,40,222,1,0,88,172,1,0,0,0,0,0,2,0,0,0,8,164,1,0,2,0,0,0,224,172,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,40,222,1,0,96,173,1,0,0,0,0,0,1,0,0,0,216,172,1,0,0,0,0,0,40,222,1,0,24,173,1,0,0,0,0,0,2,0,0,0,8,164,1,0,2,0,0,0,120,173,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,160,221,1,0,16,174,1,0,40,222,1,0,248,173,1,0,0,0,0,0,1,0,0,0,48,174,1,0,0,0,0,0,40,222,1,0,176,173,1,0,0,0,0,0,2,0,0,0,8,164,1,0,2,0,0,0,56,174,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,40,222,1,0,184,174,1,0,0,0,0,0,1,0,0,0,48,174,1,0,0,0,0,0,40,222,1,0,112,174,1,0,0,0,0,0,2,0,0,0,8,164,1,0,2,0,0,0,208,174,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,160,221,1,0,80,175,1,0,40,222,1,0,8,175,1,0,0,0,0,0,2,0,0,0,8,164,1,0,2,0,0,0,112,175,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,160,221,1,0,224,175,1,0,40,222,1,0,152,175,1,0,0,0,0,0,2,0,0,0,8,164,1,0,2,0,0,0,0,176,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,160,221,1,0,112,176,1,0,40,222,1,0,40,176,1,0,0,0,0,0,2,0,0,0,8,164,1,0,2,0,0,0,144,176,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,160,221,1,0,0,177,1,0,40,222,1,0,184,176,1,0,0,0,0,0,2,0,0,0,8,164,1,0,2,0,0,0,32,177,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+102820);
/* memory initializer */ allocate([74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,77,97,114,99,104,0,0,0,65,112,114,105,108,0,0,0,77,97,121,0,0,0,0,0,74,117,110,101,0,0,0,0,74,117,108,121,0,0,0,0,65,117,103,117,115,116,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,74,97,110,0,0,0,0,0,70,101,98,0,0,0,0,0,77,97,114,0,0,0,0,0,65,112,114,0,0,0,0,0,74,117,110,0,0,0,0,0,74,117,108,0,0,0,0,0,65,117,103,0,0,0,0,0,83,101,112,0,0,0,0,0,79,99,116,0,0,0,0,0,78,111,118,0,0,0,0,0,68,101,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,117,110,100,97,121,0,0,77,111,110,100,97,121,0,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,83,117,110,0,0,0,0,0,77,111,110,0,0,0,0,0,84,117,101,0,0,0,0,0,87,101,100,0,0,0,0,0,84,104,117,0,0,0,0,0,70,114,105,0,0,0,0,0,83,97,116,0,0,0,0,0,18,17,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,17,34,35,36,17,37,38,39,40,41,42,43,44,17,45,46,47,16,16,48,16,16,16,16,16,16,16,49,50,51,16,52,53,16,16,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,54,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,55,17,17,17,17,56,17,57,58,59,60,61,62,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,63,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,64,65,17,66,67,68,69,70,71,72,73,16,16,16,74,75,76,77,78,16,16,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,17,17,17,82,83,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,84,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,17,85,16,16,16,16,86,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,87,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,88,89,90,91,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,92,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,254,255,255,7,254,255,255,7,0,0,0,0,0,4,32,4,255,255,127,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,195,255,3,0,31,80,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,223,60,64,215,255,255,251,255,255,255,255,255,255,255,255,255,191,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,254,255,255,255,127,2,254,255,255,255,255,0,0,0,0,0,255,191,182,0,255,255,255,7,7,0,0,0,255,7,255,255,255,255,255,255,255,254,255,195,255,255,255,255,255,255,255,255,255,255,255,255,239,31,254,225,255,159,0,0,255,255,255,255,255,255,0,224,255,255,255,255,255,255,255,255,255,255,255,255,3,0,255,255,255,255,255,7,48,4,255,255,255,252,255,31,0,0,255,255,255,1,0,0,0,0,0,0,0,0,253,31,0,0,0,0,0,0,240,3,255,127,255,255,255,255,255,255,255,239,255,223,225,255,207,255,254,254,238,159,249,255,255,253,197,227,159,89,128,176,207,255,3,0,238,135,249,255,255,253,109,195,135,25,2,94,192,255,63,0,238,191,251,255,255,253,237,227,191,27,1,0,207,255,0,0,238,159,249,255,255,253,237,227,159,25,192,176,207,255,2,0,236,199,61,214,24,199,255,195,199,29,129,0,192,255,0,0,238,223,253,255,255,253,239,227,223,29,96,3,207,255,0,0,236,223,253,255,255,253,239,227,223,29,96,64,207,255,6,0,236,223,253,255,255,255,255,231,223,93,128,0,207,255,0,252,236,255,127,252,255,255,251,47,127,128,95,255,0,0,12,0,254,255,255,255,255,127,255,7,63,32,255,3,0,0,0,0,150,37,240,254,174,236,255,59,95,32,255,243,0,0,0,0,1,0,0,0,255,3,0,0,255,254,255,255,255,31,254,255,3,255,255,254,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,249,255,3,255,255,231,193,255,255,127,64,255,51,255,255,255,255,191,32,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,61,127,61,255,255,255,255,255,61,255,255,255,255,61,127,61,255,127,255,255,255,255,255,255,255,61,255,255,255,255,255,255,255,255,135,0,0,0,0,255,255,0,0,255,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,159,255,255,254,255,255,7,255,255,255,255,255,255,255,255,255,199,1,0,255,223,15,0,255,255,15,0,255,255,15,0,255,223,13,0,255,255,255,255,255,255,207,255,255,1,128,16,255,3,0,0,0,0,255,3,255,255,255,255,255,255,255,255,255,255,255,0,255,255,255,255,255,7,255,255,255,255,255,255,255,255,63,0,255,255,255,31,255,15,255,1,192,255,255,255,255,63,31,0,255,255,255,255,255,15,255,255,255,3,255,3,0,0,0,0,255,255,255,15,255,255,255,255,255,255,255,127,254,255,31,0,255,3,255,3,128,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,239,255,239,15,255,3,0,0,0,0,255,255,255,255,255,243,255,255,255,255,255,255,191,255,3,0,255,255,255,255,255,255,63,0,255,227,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,222,111,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,0,0,255,31,0,0,0,0,0,0,0,0,0,0,0,0,132,252,47,62,80,189,255,243,224,67,0,0,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,255,255,255,3,0,0,255,255,255,255,255,127,255,255,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,120,12,0,255,255,255,255,191,32,255,255,255,255,255,255,255,128,0,0,255,255,127,0,127,127,127,127,127,127,127,127,255,255,255,255,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,254,3,62,31,254,255,255,255,255,255,255,255,255,255,127,224,254,255,255,255,255,255,255,255,255,255,255,247,224,255,255,255,255,63,254,255,255,255,255,255,255,255,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,63,255,31,255,255,255,15,0,0,255,255,255,255,255,127,240,143,255,255,255,128,255,255,255,255,255,255,255,255,255,255,0,0,0,0,128,255,252,255,255,255,255,255,255,255,255,255,255,255,255,121,15,0,255,7,0,0,0,0,0,0,0,0,0,255,187,247,255,255,255,0,0,0,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,15,0,255,3,0,0,252,8,255,255,255,255,255,7,255,255,255,255,7,0,255,255,255,31,255,255,255,255,255,255,247,255,0,128,255,3,0,0,0,0,255,255,255,255,255,255,127,0,255,63,255,3,255,255,127,4,255,255,255,255,255,255,255,127,5,0,0,56,255,255,60,0,126,126,126,0,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,7,255,3,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,127,248,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,0,127,0,248,224,255,253,127,95,219,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,248,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,255,255,255,255,255,255,255,255,252,255,255,255,255,255,255,0,0,0,0,0,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,255,3,254,255,255,7,254,255,255,7,192,255,255,255,255,255,255,255,255,255,255,127,252,252,252,28,0,0,0,0,255,239,255,255,127,255,255,183,255,63,255,63,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,31,255,255,255,255,255,255,1,0,0,0,0,0,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,63,255,255,255,255,15,255,62,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,3,0,0,0,0,0,0,0,0,0,0,63,253,255,255,255,255,191,145,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,63,0,255,255,255,3,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,192,0,0,0,0,0,0,0,0,111,240,239,254,255,255,15,0,0,0,0,0,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,255,63,0,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,192,255,0,0,252,255,255,255,255,255,255,1,0,0,255,255,255,1,255,3,255,255,255,255,255,255,199,255,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,30,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,3,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,31,0,255,255,255,255,255,127,0,0,248,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,223,100,222,255,235,239,255,255,255,255,255,255,255,191,231,223,223,255,255,255,123,95,252,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,253,255,255,247,255,255,255,247,255,255,223,255,255,255,223,255,255,127,255,255,255,127,255,255,255,253,255,255,255,253,255,255,247,207,255,255,255,255,255,255,239,255,255,255,150,254,247,10,132,234,150,170,150,247,247,94,255,251,255,15,238,251,255,15,0,0,0,0,0,0,0,0,97,108,110,117,109,0,97,108,112,104,97,0,98,108,97,110,107,0,99,110,116,114,108,0,100,105,103,105,116,0,103,114,97,112,104,0,108,111,119,101,114,0,112,114,105,110,116,0,112,117,110,99,116,0,115,112,97,99,101,0,117,112,112,101,114,0,120,100,105,103,105,116,0,0,0,0,0,0,0,0,18,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,16,16,34,35,16,36,37,38,39,40,41,42,43,16,44,45,46,17,47,48,17,17,49,17,17,17,50,51,52,53,54,55,56,57,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,58,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,59,16,60,61,62,63,64,65,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,66,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,67,16,16,68,16,69,70,71,16,72,16,73,16,16,16,16,74,75,76,77,16,16,78,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,16,16,16,16,82,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,83,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,84,85,86,87,16,16,88,89,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,90,16,91,92,93,94,95,96,97,98,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,254,255,0,252,1,0,0,248,1,0,0,120,0,0,0,0,255,251,223,251,0,0,128,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,252,255,224,175,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,32,64,176,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,134,254,255,255,255,0,64,73,0,0,0,0,0,24,0,223,255,0,200,0,0,0,0,0,0,0,1,0,60,0,0,0,0,0,0,0,0,0,0,0,0,16,224,1,30,0,96,255,191,0,0,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,207,3,0,0,0,3,0,32,255,127,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,0,0,0,16,0,32,30,0,48,0,1,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,252,15,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,3,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,253,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,255,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,63,2,0,0,0,0,0,0,0,0,0,4,0,0,0,0,16,0,0,0,0,0,0,128,0,128,192,223,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,254,255,255,255,0,252,255,255,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,192,255,223,255,7,0,0,0,0,0,0,0,0,0,0,128,6,0,252,0,0,24,62,0,0,128,191,0,204,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,31,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,0,0,24,0,0,0,0,0,0,0,0,0,56,0,0,0,0,16,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,254,127,47,0,0,255,3,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,196,255,255,255,255,0,0,0,192,0,0,0,0,0,0,0,0,1,0,224,159,0,0,0,0,127,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,16,0,0,252,255,255,255,31,0,0,0,0,0,12,0,0,0,0,0,0,64,0,12,240,0,0,0,0,0,0,192,248,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,255,0,255,255,255,33,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,127,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,3,224,0,224,0,224,0,96,128,248,255,255,255,252,255,255,255,255,255,127,31,252,241,127,255,127,0,0,255,255,255,3,0,0,255,255,255,255,1,0,123,3,208,193,175,66,0,12,31,188,255,255,0,0,0,0,0,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,127,0,0,0,255,7,0,0,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,252,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,255,15,0,0,0,0,0,0,0,0,255,255,255,251,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,255,15,30,255,255,255,1,252,193,224,0,0,0,0,0,0,0,0,0,0,0,30,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,255,255,255,255,15,0,0,0,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,0,0,0,0,0,0,192,0,224,0,0,0,0,0,0,0,0,0,0,0,128,15,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,255,255,127,0,3,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,8,0,0,0,15,255,3,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,16,192,0,0,255,255,3,7,0,0,0,0,0,248,0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,8,0,255,63,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,128,11,0,0,0,0,0,0,0,128,2,0,0,192,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,255,255,255,3,127,0,255,255,255,255,247,255,127,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,254,255,0,252,1,0,0,248,1,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,0,48,135,255,255,255,255,255,143,255,0,0,0,0,0,0,224,255,255,7,255,15,0,0,0,0,0,0,255,255,255,255,255,63,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,143,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,255,0,255,1,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,63,252,255,63,0,0,0,3,0,0,0,0,0,0,254,3,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,7,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,255,255,255,255,127,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,127,0,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8,0,0,0,8,0,0,32,0,0,0,32,0,0,128,0,0,0,128,0,0,0,2,0,0,0,2,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,127,254,127,254,255,254,255,0,0,0,0,255,7,255,255,255,127,255,255,255,255,255,255,255,15,255,255,255,255,255,7,0,0,0,0,0,0,0,0,192,255,255,255,7,0,255,255,255,255,255,7,255,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,1,0,191,255,255,255,255,255,255,255,255,31,255,255,15,0,255,255,255,255,223,7,0,0,255,255,1,0,255,255,255,255,255,255,255,127,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,30,255,255,255,255,255,255,255,63,15,0,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,255,255,255,255,255,255,255,255,225,255,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,9,0,0,0,10,0,0,0,13,0,0,0,11,0,0,0,12,0,0,0,133,0,0,0,0,32,0,0,1,32,0,0,2,32,0,0,3,32,0,0,4,32,0,0,5,32,0,0,6,32,0,0,8,32,0,0,9,32,0,0,10,32,0,0,40,32,0,0,41,32,0,0,95,32,0,0,0,48,0,0,0,0,0,0,65,0,32,26,192,0,32,31,0,1,1,47,50,1,1,5,57,1,1,15,74,1,1,45,121,1,1,5,112,3,1,3,145,3,32,17,163,3,32,9,0,4,80,16,16,4,32,32,96,4,1,33,138,4,1,53,193,4,1,13,208,4,1,63,20,5,1,19,49,5,48,38,160,1,1,5,179,1,1,3,205,1,1,15,222,1,1,17,248,1,1,39,34,2,1,17,216,3,1,23,0,30,1,149,160,30,1,95,8,31,248,8,24,31,248,6,40,31,248,8,56,31,248,8,72,31,248,6,104,31,248,8,136,31,248,8,152,31,248,8,168,31,248,8,184,31,248,2,186,31,182,2,200,31,170,4,216,31,248,2,218,31,156,2,232,31,248,2,234,31,144,2,248,31,128,2,250,31,130,2,70,2,1,9,16,5,1,3,96,33,16,16,0,44,48,47,103,44,1,5,128,44,1,99,235,44,1,3,64,166,1,45,128,166,1,23,34,167,1,13,50,167,1,61,121,167,1,3,126,167,1,9,144,167,1,3,160,167,1,9,33,255,32,26,0,0,0,0,73,0,49,1,83,0,127,1,48,1,105,0,120,1,255,0,129,1,83,2,130,1,131,1,132,1,133,1,134,1,84,2,135,1,136,1,137,1,86,2,138,1,87,2,139,1,140,1,142,1,221,1,143,1,89,2,144,1,91,2,145,1,146,1,147,1,96,2,148,1,99,2,150,1,105,2,151,1,104,2,152,1,153,1,156,1,111,2,157,1,114,2,159,1,117,2,166,1,128,2,167,1,168,1,169,1,131,2,172,1,173,1,174,1,136,2,175,1,176,1,177,1,138,2,178,1,139,2,183,1,146,2,184,1,185,1,188,1,189,1,196,1,198,1,196,1,197,1,197,1,198,1,199,1,201,1,199,1,200,1,200,1,201,1,202,1,204,1,202,1,203,1,203,1,204,1,241,1,243,1,241,1,242,1,242,1,243,1,244,1,245,1,246,1,149,1,247,1,191,1,32,2,158,1,134,3,172,3,136,3,173,3,137,3,174,3,138,3,175,3,140,3,204,3,142,3,205,3,143,3,206,3,153,3,69,3,153,3,190,31,163,3,194,3,247,3,248,3,250,3,251,3,96,30,155,30,223,0,223,0,158,30,223,0,89,31,81,31,91,31,83,31,93,31,85,31,95,31,87,31,188,31,179,31,204,31,195,31,236,31,229,31,252,31,243,31,58,2,101,44,59,2,60,2,61,2,154,1,62,2,102,44,65,2,66,2,67,2,128,1,68,2,137,2,69,2,140,2,244,3,184,3,249,3,242,3,253,3,123,3,254,3,124,3,255,3,125,3,192,4,207,4,38,33,201,3,42,33,107,0,43,33,229,0,50,33,78,33,131,33,132,33,96,44,97,44,98,44,107,2,99,44,125,29,100,44,125,2,109,44,81,2,110,44,113,2,111,44,80,2,112,44,82,2,114,44,115,44,117,44,118,44,126,44,63,2,127,44,64,2,242,44,243,44,125,167,121,29,139,167,140,167,141,167,101,2,170,167,102,2,199,16,39,45,205,16,45,45,118,3,119,3,156,3,181,0,146,3,208,3,152,3,209,3,166,3,213,3,160,3,214,3,154,3,240,3,161,3,241,3,149,3,245,3,207,3,215,3,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,16,219,1,0,110,0,0,0,24,219,1,0,114,0,0,0,32,219,1,0,102,0,0,0,40,219,1,0,97,0,0,0,48,219,1,0,101,0,0,0,56,219,1,0,119,0,0,0,64,219,1,0,87,0,0,0,80,219,1,0,115,0,0,0,96,219,1,0,83,0,0,0,112,219,1,0,100,0,0,0,128,219,1,0,68,0,0,0,144,219,1,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,27,0,0,0,0,0,0,0,91,91,58,97,108,110,117,109,58,93,95,93,0,0,0,0,91,94,91,58,97,108,110,117,109,58,93,95,93,0,0,0,91,91,58,115,112,97,99,101,58,93,93,0,0,0,0,0,91,94,91,58,115,112,97,99,101,58,93,93,0,0,0,0,91,91,58,100,105,103,105,116,58,93,93,0,0,0,0,0,91,94,91,58,100,105,103,105,116,58,93,93,0,0,0,0,78,111,32,101,114,114,111,114,0,78,111,32,109,97,116,99,104,0,73,110,118,97,108,105,100,32,114,101,103,101,120,112,0,85,110,107,110,111,119,110,32,99,111,108,108,97,116,105,110,103,32,101,108,101,109,101,110,116,0,85,110,107,110,111,119,110,32,99,104,97,114,97,99,116,101,114,32,99,108,97,115,115,32,110,97,109,101,0,84,114,97,105,108,105,110,103,32,98,97,99,107,115,108,97,115,104,0,73,110,118,97,108,105,100,32,98,97,99,107,32,114,101,102,101,114,101,110,99,101,0,77,105,115,115,105,110,103,32,39,93,39,0,77,105,115,115,105,110,103,32,39,41,39,0,77,105,115,115,105,110,103,32,39,125,39,0,73,110,118,97,108,105,100,32,99,111,110,116,101,110,116,115,32,111,102,32,123,125,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,114,97,110,103,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,112,101,116,105,116,105,111,110,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,0,0,0,37,115,0,0,0,0,0,0,0,0,0,0,24,221,1,0,127,0,0,0,128,0,0,0,95,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,160,221,1,0,240,220,1,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,200,221,1,0,8,221,1,0,0,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,200,221,1,0,40,221,1,0,0,221,1,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,200,221,1,0,96,221,1,0,80,221,1,0,0,0,0,0,0,0,0,0,136,221,1,0,129,0,0,0,130,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,16,0,0,0,10,0,0,0,10,0,0,0,0,0,0,0,16,222,1,0,129,0,0,0,133,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,17,0,0,0,11,0,0,0,11,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,200,221,1,0,232,221,1,0,136,221,1,0,0,0,0,0,0,0,0,0,112,222,1,0,129,0,0,0,134,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,18,0,0,0,12,0,0,0,12,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,200,221,1,0,72,222,1,0,136,221,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,224,1,0,135,0,0,0,136,0,0,0,96,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,200,221,1,0,160,224,1,0,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+113160);




var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  function _llvm_lifetime_end() {}

  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function _pthread_mutex_lock() {}

  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
  
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
  
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
  
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }


  function _lis_solver_create() {
  Module['printErr']('missing function: lis_solver_create'); abort(-1);
  }

  var _emscripten_check_longjmp=true;

  
  function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }

  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var fd = _fileno(stream);
      var ret = _write(fd, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }

  
  var ___strtok_state=0;
  
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
  
  
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
  
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
  
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
  
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }

  function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  
  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    } 
  Module["_saveSetjmp"] = _saveSetjmp;

  
   
  Module["_strlen"] = _strlen;function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      var fd = _fileno(stream);
      return _write(fd, s, _strlen(s));
    }

  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};


  
  function _malloc(bytes) {
      /* Over-allocate to make sure it is byte-aligned by 8.
       * This will leak memory, but this is only the dummy
       * implementation (replaced by dlmalloc normally) so
       * not an issue.
       */
      var ptr = Runtime.dynamicAlloc(bytes + 8);
      return (ptr+8) & 0xFFFFFFF8;
    }
  Module["_malloc"] = _malloc;
  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

   
  Module["_bitshift64Ashr"] = _bitshift64Ashr;

  
  var PTHREAD_SPECIFIC={};function _pthread_setspecific(key, value) {
      if (!(key in PTHREAD_SPECIFIC)) {
        return ERRNO_CODES.EINVAL;
      }
      PTHREAD_SPECIFIC[key] = value;
      return 0;
    }

  function _GC_init() {
  Module['printErr']('missing function: GC_init'); abort(-1);
  }

  var _ceil=Math_ceil;

  function _GC_strdup() {
  Module['printErr']('missing function: GC_strdup'); abort(-1);
  }

  function _GC_malloc_atomic() {
  Module['printErr']('missing function: GC_malloc_atomic'); abort(-1);
  }

  
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }function _isxdigit_l(chr) {
      return _isxdigit(chr); // no locale support yet
    }

  
  function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }
  
  
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  
  function ___errno_location() {
      return ___errno_state;
    }function _perror(s) {
      // void perror(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/perror.html
      var stdout = HEAP32[((_stdout)>>2)];
      if (s) {
        _fputs(s, stdout);
        _fputc(58, stdout);
        _fputc(32, stdout);
      }
      var errnum = HEAP32[((___errno_location())>>2)];
      _puts(_strerror(errnum));
    }

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 
  Module["_memcpy"] = _memcpy;


  function _strstr(ptr1, ptr2) {
      var check = 0, start;
      do {
        if (!check) {
          start = ptr1;
          check = ptr2;
        }
        var curr1 = HEAP8[((ptr1++)|0)];
        var curr2 = HEAP8[((check++)|0)];
        if (curr2 == 0) return start;
        if (curr2 != curr1) {
          // rewind to one character after start, to find ez in eeez
          ptr1 = start + 1;
          check = 0;
        }
      } while (curr1);
      return 0;
    }

   
  Module["_memmove"] = _memmove;

  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }

  function _signal(sig, func) {
      // TODO
      return 0;
    }

  
  
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
  
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
  
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
                if (next === 0) return i > 0 ? fields : fields-1; // we failed to read the full length of this field
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
  
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
  
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
  
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
  
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
  
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
  
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
  
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16);
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text);
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text);
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j];
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }
  
  
  
  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }
  
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }function _fscanf(stream, format, varargs) {
      // int fscanf(FILE *restrict stream, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        return -1;
      }
      var buffer = [];
      function get() {
        var c = _fgetc(stream);
        buffer.push(c);
        return c;
      };
      function unget() {
        _ungetc(buffer.pop(), stream);
      };
      return __scanString(format, get, unget, varargs);
    }

  var _emscripten_preinvoke=true;

  function _pthread_cond_wait() {
      return 0;
    }

  
  
  
  var ___cxa_exception_header_size=8;
  
  function _free() {
  }
  Module["_free"] = _free;function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr - ___cxa_exception_header_size);
      } catch(e) { // XXX FIXME
      }
    }
  
  var ___cxa_last_thrown_exception=0;
  
  var ___cxa_caught_exceptions=[];function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Call destructor if one is registered then clear it.
      var ptr = ___cxa_caught_exceptions.pop();
      if (ptr) {
        header = ptr - ___cxa_exception_header_size;
        var destructor = HEAP32[(((header)+(4))>>2)];
        if (destructor) {
          Runtime.dynCall('vi', destructor, [ptr]);
          HEAP32[(((header)+(4))>>2)]=0;
        }
        ___cxa_free_exception(ptr);
        ___cxa_last_thrown_exception = 0;
      }
    }function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      var ptr = ___cxa_caught_exceptions.pop();
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }function _freopen(filename, mode, stream) {
      // FILE *freopen(const char *restrict filename, const char *restrict mode, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/freopen.html
      if (!filename) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (!streamObj) {
          ___setErrNo(ERRNO_CODES.EBADF);
          return 0;
        }
        if (_freopen.buffer) _free(_freopen.buffer);
        filename = intArrayFromString(streamObj.path);
        filename = allocate(filename, 'i8', ALLOC_NORMAL);
      }
      _fclose(stream);
      return _fopen(filename, mode);
    }

  function _round(x) {
      return (x < 0) ? -Math.round(-x) : Math.round(x);
    }

  
  function _emscripten_get_now() {
      if (!_emscripten_get_now.actual) {
        if (ENVIRONMENT_IS_NODE) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() {
            var t = process['hrtime']();
            return t[0] * 1e3 + t[1] / 1e6;
          }
        } else if (typeof dateNow !== 'undefined') {
          _emscripten_get_now.actual = dateNow;
        } else if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() { return window['performance']['now'](); };
        } else {
          _emscripten_get_now.actual = Date.now;
        }
      }
      return _emscripten_get_now.actual();
    }function _clock_gettime(clk_id, tp) {
      // int clock_gettime(clockid_t clk_id, struct timespec *tp);
      var now;
      if (clk_id === 0) {
        now = Date.now();
      } else {
        now = _emscripten_get_now();
      }
      HEAP32[((tp)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((tp)+(4))>>2)]=Math.floor((now % 1000)*1000*1000); // nanoseconds
      return 0;
    }

  
  function _tmpnam(s, dir, prefix) {
      // char *tmpnam(char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpnam.html
      // NOTE: The dir and prefix arguments are for internal use only.
      var folder = FS.findObject(dir || '/tmp');
      if (!folder || !folder.isFolder) {
        dir = '/tmp';
        folder = FS.findObject(dir);
        if (!folder || !folder.isFolder) return 0;
      }
      var name = prefix || 'file';
      do {
        name += String.fromCharCode(65 + Math.floor(Math.random() * 25));
      } while (name in folder.contents);
      var result = dir + '/' + name;
      if (!_tmpnam.buffer) _tmpnam.buffer = _malloc(256);
      if (!s) s = _tmpnam.buffer;
      writeAsciiToMemory(result, s);
      return s;
    }function _tmpfile() {
      // FILE *tmpfile(void);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpfile.html
      // TODO: Delete the created file on closing.
      if (_tmpfile.mode) {
        _tmpfile.mode = allocate(intArrayFromString('w+'), 'i8', ALLOC_NORMAL);
      }
      return _fopen(_tmpnam(0), _tmpfile.mode);
    }

  
  function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }

  
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = (HEAP32[((tempDoublePtr)>>2)]=HEAP32[(((varargs)+(argIndex))>>2)],HEAP32[(((tempDoublePtr)+(4))>>2)]=HEAP32[(((varargs)+((argIndex)+(4)))>>2)],(+(HEAPF64[(tempDoublePtr)>>3])));
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+4))>>2)]];
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Runtime.getNativeFieldSize(type);
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision < 0) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }


  function _pclose(stream) {
      // int pclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/pclose.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.ECHILD);
      return -1;
    }

   
  Module["_memset"] = _memset;

  var _BDtoILow=true;


   
  Module["_bitshift64Shl"] = _bitshift64Shl;

  var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  function ___assert_fail(condition, filename, line, func) {
      ABORT = true;
      throw 'Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'] + ' at ' + stackTrace();
    }

  function _lis_matrix_assemble() {
  Module['printErr']('missing function: lis_matrix_assemble'); abort(-1);
  }

  
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }function _isdigit_l(chr) {
      return _isdigit(chr); // no locale support yet
    }

  var _emscripten_prep_setjmp=true;


  function _access(path, amode) {
      // int access(const char *path, int amode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/access.html
      path = Pointer_stringify(path);
      if (amode & ~7) {
        // need a valid mode
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      }
      var node;
      try {
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
      var perms = '';
      if (amode & 4) perms += 'r';
      if (amode & 2) perms += 'w';
      if (amode & 1) perms += 'x';
      if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      }
      return 0;
    }

  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }

  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }

  var _emscripten_get_longjmp_result=true;

  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i];
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }

  function _freelocale(locale) {
      _free(locale);
    }

  function _catgets(catd, set_id, msg_id, s) {
      // char *catgets (nl_catd catd, int set_id, int msg_id, const char *s)
      return s;
    }

  function _fmod(x, y) {
      return x % y;
    }

  function _fmax(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.max(x, y);
    }

  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }

  function _GC_malloc() {
  Module['printErr']('missing function: GC_malloc'); abort(-1);
  }

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function _lis_vector_destroy() {
  Module['printErr']('missing function: lis_vector_destroy'); abort(-1);
  }

  
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      ___cxa_caught_exceptions.push(___cxa_last_thrown_exception);
      return ptr;
    }

  function _lis_vector_create() {
  Module['printErr']('missing function: lis_vector_create'); abort(-1);
  }

  function _lis_matrix_set_type() {
  Module['printErr']('missing function: lis_matrix_set_type'); abort(-1);
  }


  var _cos=Math_cos;

  function _lis_matrix_set_value() {
  Module['printErr']('missing function: lis_matrix_set_value'); abort(-1);
  }



  function __ZNSt9exceptionD2Ev() {}

  function _lis_solver_destroy() {
  Module['printErr']('missing function: lis_solver_destroy'); abort(-1);
  }

  function _popen(command, mode) {
      // FILE *popen(const char *command, const char *mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/popen.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.EMFILE);
      return 0;
    }

  function _isblank(chr) {
      return chr == 32 || chr == 9;
    }

   
  Module["_strcpy"] = _strcpy;

  function _copysign(a, b) {
      return __reallyNegative(a) === __reallyNegative(b) ? a : -a;
    }

  function _bsearch(key, base, num, size, compar) {
      function cmp(x, y) {
        return Module['dynCall_iii'](compar, x, y);
      };
      var left = 0;
      var right = num;
      var mid, test, addr;
  
      while (left < right) {
        mid = (left + right) >>> 1;
        addr = base + (mid * size);
        test = cmp(key, addr);
        if (test < 0) {
          right = mid;
        } else if (test > 0) {
          left = mid + 1;
        } else {
          return addr;
        }
      }
  
      return 0;
    }

  
  var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key, destructor) {
      if (key == 0) {
        return ERRNO_CODES.EINVAL;
      }
      HEAP32[((key)>>2)]=PTHREAD_SPECIFIC_NEXT_KEY;
      // values start at 0
      PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
      PTHREAD_SPECIFIC_NEXT_KEY++;
      return 0;
    }

  function _lis_vector_get_values() {
  Module['printErr']('missing function: lis_vector_get_values'); abort(-1);
  }


  
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  
  
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
  
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
  
      var pattern = Pointer_stringify(format);
  
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
  
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
  
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
  
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
  
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
  
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
  
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
  
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
  
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
  
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
  
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
  
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
  
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
  
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
  
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }

  
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;

  
   
  Module["_rand_r"] = _rand_r;
  
  var ___rand_seed=allocate([0x0273459b, 0, 0, 0], "i32", ALLOC_STATIC); 
  Module["_rand"] = _rand;

  var _llvm_memset_p0i8_i32=_memset;

   
  Module["_i64Subtract"] = _i64Subtract;

   
  Module["_i64Add"] = _i64Add;

  var _pow=Math_pow;

  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  
  function ___resumeException(ptr) {
      if (!___cxa_last_thrown_exception) { ___cxa_last_thrown_exception = ptr; }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = ___cxa_last_thrown_exception;
      header = thrown - ___cxa_exception_header_size;
      if (throwntype == -1) throwntype = HEAP32[((header)>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
  
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      var header = ptr - ___cxa_exception_header_size;
      HEAP32[((header)>>2)]=type;
      HEAP32[(((header)+(4))>>2)]=destructor;
      ___cxa_last_thrown_exception = ptr;
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  function _lis_vector_set_value() {
  Module['printErr']('missing function: lis_vector_set_value'); abort(-1);
  }


  
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }

  function _htonl(value) {
      return ((value & 0xff) << 24) + ((value & 0xff00) << 8) +
             ((value & 0xff0000) >>> 8) + ((value & 0xff000000) >>> 24);
    }


  function _lis_solve() {
  Module['printErr']('missing function: lis_solve'); abort(-1);
  }

   
  Module["_strncpy"] = _strncpy;

  function _strtoull_l(str, endptr, base) {
      return _strtoull(str, endptr, base); // no locale support yet
    }

  var _log=Math_log;

  var _emscripten_postinvoke=true;

  function _xerbla_() {
  Module['printErr']('missing function: xerbla_'); abort(-1);
  }

  var _copysignl=_copysign;

  
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }function _strtoll_l(str, endptr, base) {
      return _strtoll(str, endptr, base); // no locale support yet
    }

  function _qsort(base, num, size, cmp) {
      if (num == 0 || size == 0) return;
      // forward calls to the JavaScript sort method
      // first, sort the items logically
      var keys = [];
      for (var i = 0; i < num; i++) keys.push(i);
      keys.sort(function(a, b) {
        return Module['dynCall_iii'](cmp, base+a*size, base+b*size);
      });
      // apply the sort
      var temp = _malloc(num*size);
      _memcpy(temp, base, num*size);
      for (var i = 0; i < num; i++) {
        if (keys[i] == i) continue; // already in place
        _memcpy(base+i*size, temp+keys[i]*size, size);
      }
      _free(temp);
    }

  function _system(command) {
      // int system(const char *command);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/system.html
      // Can't call external programs.
      ___setErrNo(ERRNO_CODES.EAGAIN);
      return -1;
    }

  function _lis_matrix_create() {
  Module['printErr']('missing function: lis_matrix_create'); abort(-1);
  }

  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }

   
  Module["_bitshift64Lshr"] = _bitshift64Lshr;

  function _srand(seed) {
      HEAP32[((___rand_seed)>>2)]=seed
    }

  function _isatty(fildes) {
      // int isatty(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/isatty.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      // HACK - implement tcgetattr
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return 0;
      }
      return 1;
    }

  var _putc=_fputc;

  var _BDtoIHigh=true;

  function _pthread_cond_broadcast() {
      return 0;
    }

  
  
   
  Module["_testSetjmp"] = _testSetjmp;function _longjmp(env, value) {
      asm['setThrew'](env, value || 1);
      throw 'longjmp';
    }function _emscripten_longjmp(env, value) {
      _longjmp(env, value);
    }

  function __ZSt9terminatev() {
      _exit(-1234);
    }

  var _fseeko=_fseek;

  function _lis_matrix_set_size() {
  Module['printErr']('missing function: lis_matrix_set_size'); abort(-1);
  }

  function _vfprintf(s, f, va_arg) {
      return _fprintf(s, f, HEAP32[((va_arg)>>2)]);
    }

  
  function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }var _atol=_atoi;

  function _pthread_mutex_unlock() {}

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }



  var _BItoD=true;

  
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000);
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000);
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000);
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fstat(fildes, buf) {
      // int fstat(int fildes, struct stat *buf);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/fstat.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      return _stat(stream.path, buf);
    }

  function _catclose(catd) {
      // int catclose (nl_catd catd)
      return 0;
    }

  function _llvm_lifetime_start() {}

  function ___cxa_guard_release() {}


  
  function _truncate(path, length) {
      // int truncate(const char *path, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/truncate.html
      // NOTE: The path argument may be a string, to simplify ftruncate().
      if (typeof path !== 'string') path = Pointer_stringify(path);
      try {
        FS.truncate(path, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _ftruncate(fildes, length) {
      // int ftruncate(int fildes, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftruncate.html
      try {
        FS.ftruncate(fildes, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  function _uselocale(locale) {
      return 0;
    }

  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }


  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }

  var _llvm_memmove_p0i8_p0i8_i32=_memmove;

  var _ftello=_ftell;

  function _strftime_l(s, maxsize, format, tm) {
      return _strftime(s, maxsize, format, tm); // no locale support yet
    }

  function _abort() {
      Module['abort']();
    }





  function _pthread_getspecific(key) {
      return PTHREAD_SPECIFIC[key] || 0;
    }

  var _fabs=Math_abs;

  var _floor=Math_floor;

  var _getc=_fgetc;

  var _sqrt=Math_sqrt;

  function _rewind(stream) {
      // void rewind(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rewind.html
      _fseek(stream, 0, 0);  // SEEK_SET.
      var streamObj = FS.getStreamFromPtr(stream);
      if (streamObj) streamObj.error = false;
    }

  function ___cxa_allocate_exception(size) {
      var ptr = _malloc(size + ___cxa_exception_header_size);
      return ptr + ___cxa_exception_header_size;
    }

  var _sin=Math_sin;

  var _fmodl=_fmod;



  function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }

  function _catopen(name, oflag) {
      // nl_catd catopen (const char *name, int oflag)
      return -1;
    }

  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_matrix_destroy() {
  Module['printErr']('missing function: lis_matrix_destroy'); abort(-1);
  }

  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_vector_set_size() {
  Module['printErr']('missing function: lis_vector_set_size'); abort(-1);
  }

  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = Pointer_stringify(path);
      try {
        FS.unlink(path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  var _emscripten_setjmp=true;

  function _GC_collect_a_little() {
  Module['printErr']('missing function: GC_collect_a_little'); abort(-1);
  }


  function _lis_solver_set_option() {
  Module['printErr']('missing function: lis_solver_set_option'); abort(-1);
  }

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  var __ZTISt9exception=allocate([allocate([1,0,0,0,0,0,0], "i8", ALLOC_STATIC)+8, 0], "i32", ALLOC_STATIC);

  var ___dso_handle=allocate(1, "i32*", ALLOC_STATIC);



FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
___strtok_state = Runtime.staticAlloc(4);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vd(index,a1) {
  try {
    Module["dynCall_vd"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) {
  try {
    return Module["dynCall_iiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_dii(index,a1,a2) {
  try {
    return Module["dynCall_dii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viidii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.___rand_seed|0;var p=env.__ZTISt9exception|0;var q=env.___dso_handle|0;var r=env._stderr|0;var s=env._stdin|0;var t=env._stdout|0;var u=0;var v=0;var w=0;var x=0;var y=+env.NaN,z=+env.Infinity;var A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=global.Math.floor;var U=global.Math.abs;var V=global.Math.sqrt;var W=global.Math.pow;var X=global.Math.cos;var Y=global.Math.sin;var Z=global.Math.tan;var _=global.Math.acos;var $=global.Math.asin;var aa=global.Math.atan;var ba=global.Math.atan2;var ca=global.Math.exp;var da=global.Math.log;var ea=global.Math.ceil;var fa=global.Math.imul;var ga=env.abort;var ha=env.assert;var ia=env.asmPrintInt;var ja=env.asmPrintFloat;var ka=env.min;var la=env.invoke_iiiiiiii;var ma=env.invoke_viiiii;var na=env.invoke_iiiiidiii;var oa=env.invoke_vd;var pa=env.invoke_vi;var qa=env.invoke_vii;var ra=env.invoke_iiiiiiiiiii;var sa=env.invoke_ii;var ta=env.invoke_iiiiiiiiiiiiii;var ua=env.invoke_iiiiiiiiiiiiiiiiiiiii;var va=env.invoke_iiiiiiiiiiiiiiiiiiiiiii;var wa=env.invoke_iiii;var xa=env.invoke_viiiiid;var ya=env.invoke_viiiiiiii;var za=env.invoke_iiiiiiiii;var Aa=env.invoke_viiiiii;var Ba=env.invoke_iid;var Ca=env.invoke_viiiiiii;var Da=env.invoke_viiiiiid;var Ea=env.invoke_viiiiiiiii;var Fa=env.invoke_iii;var Ga=env.invoke_iiiiii;var Ha=env.invoke_iiiiidi;var Ia=env.invoke_dii;var Ja=env.invoke_i;var Ka=env.invoke_iiiiiiiiii;var La=env.invoke_viii;var Ma=env.invoke_v;var Na=env.invoke_viidii;var Oa=env.invoke_iiiii;var Pa=env.invoke_viiii;var Qa=env._fabs;var Ra=env._lis_matrix_assemble;var Sa=env._strrchr;var Ta=env._pthread_key_create;var Ua=env._vsscanf;var Va=env.__ZSt9terminatev;var Wa=env.___cxa_guard_acquire;var Xa=env.__reallyNegative;var Ya=env._fstat;var Za=env._pclose;var _a=env._lis_solver_create;var $a=env.___assert_fail;var ab=env.__ZSt18uncaught_exceptionv;var bb=env._longjmp;var cb=env._lis_vector_get_values;var db=env._clock_gettime;var eb=env._fsync;var fb=env._signal;var gb=env._GC_collect_a_little;var hb=env._sbrk;var ib=env._strtoull;var jb=env._emscripten_memcpy_big;var kb=env.__parseInt64;var lb=env._close;var mb=env._rewind;var nb=env._cos;var ob=env._fileno;var pb=env._fread;var qb=env._puts;var rb=env._isatty;var sb=env._lis_matrix_set_value;var tb=env._write;var ub=env._isblank;var vb=env._ftell;var wb=env.__ZNSt9exceptionD2Ev;var xb=env._xerbla_;var yb=env._round;var zb=env.___cxa_does_inherit;var Ab=env._strtoll_l;var Bb=env._strstr;var Cb=env.___cxa_rethrow;var Db=env._llvm_lifetime_end;var Eb=env._catclose;var Fb=env._tmpnam;var Gb=env._lis_vector_destroy;var Hb=env._lis_solver_set_option;var Ib=env._tmpfile;var Jb=env._send;var Kb=env._pow;var Lb=env._lis_matrix_set_size;var Mb=env.___cxa_free_exception;var Nb=env.___cxa_find_matching_catch;var Ob=env._isxdigit_l;var Pb=env.___cxa_guard_release;var Qb=env._truncate;var Rb=env._strtol;var Sb=env._sin;var Tb=env._strtok;var Ub=env.___setErrNo;var Vb=env._newlocale;var Wb=env._isdigit_l;var Xb=env.___resumeException;var Yb=env._freelocale;var Zb=env._srand;var _b=env._qsort;var $b=env._putchar;var ac=env._floor;var bc=env._pthread_mutex_unlock;var cc=env._printf;var dc=env._sprintf;var ec=env._fopen;var fc=env._vasprintf;var gc=env._emscripten_get_now;var hc=env._stat;var ic=env._lis_solve;var jc=env._strtoull_l;var kc=env._mkport;var lc=env._read;var mc=env.__addDays;var nc=env._fwrite;var oc=env._time;var pc=env._pthread_mutex_lock;var qc=env._catopen;var rc=env._exit;var sc=env._GC_strdup;var tc=env._freopen;var uc=env.___ctype_b_loc;var vc=env._fmod;var wc=env._strtok_r;var xc=env._lseek;var yc=env._access;var zc=env._vfprintf;var Ac=env.___cxa_allocate_exception;var Bc=env._atoi;var Cc=env.__isLeapYear;var Dc=env._strtoll;var Ec=env._pwrite;var Fc=env._localtime_r;var Gc=env._tzset;var Hc=env._open;var Ic=env._uselocale;var Jc=env._snprintf;var Kc=env.___errno_location;var Lc=env._GC_malloc;var Mc=env.___cxa_end_catch;var Nc=env._perror;var Oc=env.___cxa_begin_catch;var Pc=env._strftime;var Qc=env._ftruncate;var Rc=env._GC_init;var Sc=env._lis_matrix_set_type;var Tc=env._fseek;var Uc=env._isxdigit;var Vc=env._fclose;var Wc=env._vsnprintf;var Xc=env.__parseInt;var Yc=env._log;var Zc=env._pthread_cond_broadcast;var _c=env._popen;var $c=env._recv;var ad=env._fgetc;var bd=env._sysconf;var cd=env.__getFloat;var dd=env._lis_vector_set_value;var ed=env._abort;var fd=env._ceil;var gd=env._isspace;var hd=env._localtime;var id=env._lis_matrix_destroy;var jd=env._pthread_getspecific;var kd=env._pthread_cond_wait;var ld=env._llvm_lifetime_start;var md=env.___cxa_is_number_type;var nd=env._ungetc;var od=env._system;var pd=env._fmax;var qd=env._fflush;var rd=env._strftime_l;var sd=env._fprintf;var td=env._sscanf;var ud=env._catgets;var vd=env._lis_solver_destroy;var wd=env._strdup;var xd=env._asprintf;var yd=env.__exit;var zd=env.___ctype_toupper_loc;var Ad=env._bsearch;var Bd=env.__arraySum;var Cd=env.__formatString;var Dd=env._htonl;var Ed=env.___ctype_tolower_loc;var Fd=env._unlink;var Gd=env._fputs;var Hd=env._GC_malloc_atomic;var Id=env._pread;var Jd=env._lis_vector_set_size;var Kd=env._fscanf;var Ld=env.__scanString;var Md=env._pthread_setspecific;var Nd=env._copysign;var Od=env._fputc;var Pd=env.___cxa_throw;var Qd=env._lis_matrix_create;var Rd=env._isdigit;var Sd=env._strerror;var Td=env._emscripten_longjmp;var Ud=env._lis_vector_create;var Vd=env._atexit;var Wd=env._sqrt;var Xd=env._strerror_r;var Yd=0.0;
// EMSCRIPTEN_START_FUNCS
function Wt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=mt(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 29:{if((c[27416+((d[27160+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=mt(a[g]|0,a[b+1|0]|0)|0}if((n|0)==27){k=Xt(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=Yt(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=_t(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=Zt(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b]|0)==0){p=d[j+76+(d[m+1|0]|0)|0]|0}else{p=mt(a[m]|0,a[b+1|0]|0)|0}switch(p|0){case 11:{o=90;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=mt(a[m]|0,a[b+1|0]|0)|0}switch(q|0){case 29:{if((c[27416+((d[27160+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=57;break b}break};case 7:{o=65;break b;break};case 5:{o=59;break b;break};case 6:{o=62;break b;break};case 24:case 22:{break};default:{o=68;break b}}b=b+2|0;continue b;break};case 29:{if((c[27416+((d[28696+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=37;break b}break};case 10:case 9:case 21:{o=69;break b;break};case 5:{o=39;break b;break};case 17:{break b;break};case 7:{o=45;break b;break};case 6:{o=42;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b]|0)==0){r=d[j+76+(d[q+1|0]|0)|0]|0}else{r=mt(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 11:{o=90;break c;break};case 7:{o=84;break d;break};case 29:{o=75;break d;break};case 10:case 9:case 21:{break};case 6:{o=81;break d;break};case 5:{o=78;break d;break};case 17:{break c;break};case 24:case 22:{break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[27416+((d[27160+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=$t(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function Xt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=mt(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b]|0)!=0){continue b}if((a[b+1|0]|0)==45){l=25;break b}else{continue b}break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function Yt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k]|0)!=0){l=7;break}if((a[g+1|0]|0)!=(a[29736+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function Zt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b]|0)==0){o=d[k+76+(d[n+1|0]|0)|0]|0}else{o=mt(a[n]|0,a[b+1|0]|0)|0}a:do{switch(o|0){case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 24:case 22:{break};case 29:{if((c[27416+((d[27160+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=mt(a[o]|0,a[b+1|0]|0)|0}switch(q|0){case 29:{if((c[27416+((d[28696+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=26;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 15:{p=62;break b;break};case 5:{p=28;break b;break};case 7:{p=34;break b;break};case 10:case 9:case 21:{p=37;break b;break};case 6:{p=31;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((au(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b]|0)==0){r=d[k+76+(d[q+1|0]|0)|0]|0}else{r=mt(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b]|0)!=0){continue c}if((a[b+1|0]|0)==62){p=59;break c}else{continue c}break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((au(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=0){break}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function _t(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=mt(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[27416+((d[27160+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=mt(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 29:{if((c[27416+((d[28696+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 5:{n=28;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 23:{b=b+2|0;continue b;break};case 7:{n=34;break b;break};case 6:{n=31;break b;break};case 10:case 9:case 21:{n=37;break b;break};case 11:{n=48;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=mt(a[o]|0,a[b+1|0]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function $t(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){m=d[k+76+(d[b+1|0]|0)|0]|0}else{m=mt(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b:do{switch(m|0){case 14:{break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){n=d[k+76+(d[b+1|0]|0)|0]|0}else{n=mt(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(n|0){case 29:{if((c[27416+((d[27160+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=28;break a}break};case 6:{l=33;break a;break};case 5:{l=30;break a;break};case 24:case 22:{break};case 7:{l=36;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){o=d[k+76+(d[b+1|0]|0)|0]|0}else{o=mt(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 5:{l=10;break a;break};case 7:{l=16;break a;break};case 6:{l=13;break a;break};case 29:{if((c[27416+((d[28696+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)!=0){l=9}else{l=8;break a}break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){q=d[k+76+(d[p+1|0]|0)|0]|0}else{q=mt(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){s=d[k+76+(d[p+1|0]|0)|0]|0}else{s=mt(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 3:{t=St(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 2:{l=79;break a;break};case 8:case 1:case 0:{l=74;break a;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){u=d[k+76+(d[p+1|0]|0)|0]|0}else{u=mt(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(u|0){case 17:{l=107;break a;break};case 11:{l=106;break a;break};case 10:case 9:case 21:{break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){v=d[k+76+(d[p+1|0]|0)|0]|0}else{v=mt(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(v|0){case 24:case 22:{break d;break};case 29:{l=94;break d;break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};case 7:{l=103;break a;break};case 10:case 9:case 21:{break};case 6:{l=100;break a;break};case 5:{l=97;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[27416+((d[27160+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[c[j>>2]|0]|0)==0){if((a[(c[j>>2]|0)+1|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function au(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g]|0)==0){k=a[g+1|0]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){l=a[g+1|0]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){m=a[g+1|0]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function bu(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e]|0)==0){m=d[b+76+(d[h+1|0]|0)|0]|0}else{m=mt(a[h]|0,a[e+1|0]|0)|0}h=m;switch(h|0){case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e]|0)==0){p=d[b+76+(d[g+1|0]|0)|0]|0}else{p=mt(a[g]|0,a[e+1|0]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function cu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=mt(a[g]|0,a[b+1|0]|0)|0}if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b]|0)==0){o=d[j+76+(d[g+1|0]|0)|0]|0}else{o=mt(a[g]|0,a[b+1|0]|0)|0}switch(o|0){case 10:case 9:case 21:{break a;break};case 30:{n=16;break a;break};case 24:case 22:{break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+2|0]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=mt(a[o]|0,a[b+3|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==27){k=Xt(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function du(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=mt(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[27416+((d[27160+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=mt(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 7:{n=34;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 29:{if((c[27416+((d[28696+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 6:{n=31;break b;break};case 5:{n=28;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function eu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 31:{c[f>>2]=b+1;k=23;l=k;i=h;return l|0};case 9:{if((b+1|0)!=(e|0)){m=15;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{n=19;b=b+1|0;break};case 19:{k=Qu(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}if((re[c[j+348>>2]&63](j,b)|0)!=0){b=b+3|0;n=18;break a}g=b;if((re[c[j+336>>2]&63](j,b)|0)!=0){b=g+3|0;n=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 30:{k=Eu(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 20:{c[f>>2]=b+1;k=25;l=k;i=h;return l|0};case 32:{b=b+1|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 34:{c[f>>2]=b+1;k=37;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 33:{c[f>>2]=b+1;k=36;l=k;i=h;return l|0};case 15:{c[f>>2]=b+1;k=35;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 10:case 21:{m=15;break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}if((re[c[j+352>>2]&63](j,b)|0)!=0){b=b+4|0;n=18;break a}g=b;if((re[c[j+340>>2]&63](j,b)|0)!=0){b=g+4|0;n=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}if((re[c[j+344>>2]&63](j,b)|0)!=0){b=b+2|0;n=18;break a}g=b;if((re[c[j+332>>2]&63](j,b)|0)!=0){b=g+2|0;n=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 12:{k=Ou(12,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 36:{c[f>>2]=b+1;k=21;l=k;i=h;return l|0};case 11:{c[f>>2]=b+1;k=17;l=k;i=h;return l|0};case 2:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 16:{k=Pu(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=Ku(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -1;k=29;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 35:{c[f>>2]=b+1;k=38;l=k;i=h;return l|0};case 24:case 22:{n=18;b=b+1|0;break};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==93){if((b+1|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 13:{k=Ou(13,j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);if((m|0)==15){while(1){m=0;b=b+1|0;o=b;if((b|0)==(e|0)){m=19;break}g=d[j+76+(d[o]|0)|0]|0;if((g|0)==10|(g|0)==21){m=15;continue}else if((g|0)!=9){m=18;break}if((b+1|0)!=(e|0)){m=15}else{m=18;break}}if((m|0)==18){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((m|0)==19){c[f>>2]=o;k=15;l=k;i=h;return l|0}}b:while(1){if((b|0)==(e|0)){m=120;break}switch(d[j+76+(d[b]|0)|0]|0){case 29:{m=69;break b;break};case 33:{m=113;break b;break};case 5:{if((e-b|0)<2){m=72;break b}p=b;if((re[c[j+332>>2]&63](j,b)|0)==0){m=74;break b}b=p+2|0;continue b;break};case 6:{if((e-b|0)<3){m=77;break b}q=b;if((re[c[j+336>>2]&63](j,b)|0)==0){m=79;break b}b=q+3|0;continue b;break};case 23:{b=b+1|0;o=n;if((o|0)==41){n=19;continue b}else if((o|0)!=18){continue b}if((b|0)==(e|0)){m=89;break b}n=41;switch(d[j+76+(d[b]|0)|0]|0){case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 6:{if((e-b|0)<3){m=99;break b}r=b;if((re[c[j+336>>2]&63](j,b)|0)==0){m=101;break b}b=r+3|0;continue b;break};case 7:{if((e-b|0)<4){m=104;break b}s=b;if((re[c[j+340>>2]&63](j,b)|0)==0){m=106;break b}b=s+4|0;continue b;break};case 29:{m=91;break b;break};case 5:{if((e-b|0)<2){m=94;break b}t=b;if((re[c[j+332>>2]&63](j,b)|0)==0){m=96;break b}b=t+2|0;continue b;break};default:{n=19;continue b}}break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{m=86;break b;break};case 34:{m=110;break b;break};case 7:{if((e-b|0)<4){m=82;break b}u=b;if((re[c[j+340>>2]&63](j,b)|0)==0){m=84;break b}b=u+4|0;continue b;break};case 15:{m=116;break b;break};default:{m=119;break b}}}if((m|0)==69){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==72){k=-2;l=k;i=h;return l|0}else if((m|0)==74){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==77){k=-2;l=k;i=h;return l|0}else if((m|0)==79){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==82){k=-2;l=k;i=h;return l|0}else if((m|0)==84){c[f>>2]=u;k=0;l=k;i=h;return l|0}else if((m|0)==86){c[f>>2]=b;k=n;l=k;i=h;return l|0}else if((m|0)==89){k=-1;l=k;i=h;return l|0}else if((m|0)==91){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==94){k=-2;l=k;i=h;return l|0}else if((m|0)==96){c[f>>2]=t;k=0;l=k;i=h;return l|0}else if((m|0)==99){k=-2;l=k;i=h;return l|0}else if((m|0)==101){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-2;l=k;i=h;return l|0}else if((m|0)==106){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==110){s=b;if((n|0)==19){c[f>>2]=s;k=0;l=k;i=h;return l|0}else{c[f>>2]=s+1;k=32;l=k;i=h;return l|0}}else if((m|0)==113){s=b;if((n|0)==19){c[f>>2]=s;k=0;l=k;i=h;return l|0}else{c[f>>2]=s+1;k=31;l=k;i=h;return l|0}}else if((m|0)==116){s=b;if((n|0)==19){c[f>>2]=s;k=0;l=k;i=h;return l|0}else{c[f>>2]=s+1;k=30;l=k;i=h;return l|0}}else if((m|0)==119){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==120){k=0-n|0;l=k;i=h;return l|0}return 0}function fu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((re[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 2:{k=Hu(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((re[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 3:{k=Du(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((re[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=60;break}switch(d[j+76+(d[m]|0)|0]|0){case 5:{if((e-b|0)<2){n=41;break b}if((re[c[j+356>>2]&63](j,b)|0)!=0){n=41;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){n=49;break b}if((re[c[j+364>>2]&63](j,b)|0)!=0){n=49;break b}b=b+4|0;continue b;break};case 6:{if((e-b|0)<3){n=45;break b}if((re[c[j+360>>2]&63](j,b)|0)!=0){n=45;break b}b=b+3|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{n=58;break b;break};case 4:{if((b+1|0)==(e|0)){n=58;break b}g=b;if((a[b+1|0]|0)!=93){b=g+1|0;continue b}if((g+2|0)==(e|0)){n=58;break b}o=b;if((a[b+2|0]|0)==62){n=57;break b}b=o+1|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==41){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==45){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==57){c[f>>2]=o+2;k=0;l=k;i=h;return l|0}else if((n|0)==58){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==60){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function gu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((re[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g+1;k=40;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((re[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((re[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=51;break}switch(d[j+76+(d[m]|0)|0]|0){case 5:{if((e-b|0)<2){n=39;break b}if((re[c[j+356>>2]&63](j,b)|0)!=0){n=39;break b}b=b+2|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{n=49;break b;break};case 7:{if((e-b|0)<4){n=47;break b}if((re[c[j+364>>2]&63](j,b)|0)!=0){n=47;break b}b=b+4|0;continue b;break};case 6:{if((e-b|0)<3){n=43;break b}if((re[c[j+360>>2]&63](j,b)|0)!=0){n=43;break b}b=b+3|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==39){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==43){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==47){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==51){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function hu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;g=0;a:while(1){if((b|0)==(e|0)){k=37;break}switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){k=15;break a}l=b;if((re[c[j+364>>2]&63](j,b)|0)!=0){k=17;break a}b=l+4|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 5:{if((e-b|0)<2){k=5;break a}m=b;if((re[c[j+356>>2]&63](j,b)|0)!=0){k=7;break a}b=m+2|0;continue a;break};case 2:{n=b+1|0;b=n;if((n|0)==(e|0)){k=21;break a}if((a[b]|0)!=33){continue a}n=b+1|0;b=n;if((n|0)==(e|0)){k=24;break a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+1|0;continue a;break};case 4:{n=b+1|0;b=n;if((n|0)==(e|0)){k=28;break a}if((a[b]|0)!=93){continue a}n=b+1|0;b=n;if((n|0)==(e|0)){k=31;break a}if((a[b]|0)!=62){continue a}b=b+1|0;if((g|0)==0){k=34;break a}g=g+ -1|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}o=b;if((re[c[j+360>>2]&63](j,b)|0)!=0){k=12;break a}b=o+3|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){p=-2;q=p;i=h;return q|0}else if((k|0)==7){c[f>>2]=m;p=0;q=p;i=h;return q|0}else if((k|0)==10){p=-2;q=p;i=h;return q|0}else if((k|0)==12){c[f>>2]=o;p=0;q=p;i=h;return q|0}else if((k|0)==15){p=-2;q=p;i=h;return q|0}else if((k|0)==17){c[f>>2]=l;p=0;q=p;i=h;return q|0}else if((k|0)==19){c[f>>2]=b;p=0;q=p;i=h;return q|0}else if((k|0)==21){p=-1;q=p;i=h;return q|0}else if((k|0)==24){p=-1;q=p;i=h;return q|0}else if((k|0)==28){p=-1;q=p;i=h;return q|0}else if((k|0)==31){p=-1;q=p;i=h;return q|0}else if((k|0)==34){c[f>>2]=b;p=42;q=p;i=h;return q|0}else if((k|0)==37){p=-1;q=p;i=h;return q|0}return 0}function iu(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=27;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 3:{m=9;break a;break};case 9:{m=16;break a;break};case 7:{a=a+4|0;continue a;break};case 10:{m=13;break a;break};case 6:{a=a+3|0;continue a;break};case 2:{m=12;break a;break};case 21:{m=23;break a;break};case 5:{a=a+2|0;continue a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=Du(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((m|0)==13){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==16){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==23){h=a;if((a|0)==(f|0)){c[e>>2]=h+1;j=39;k=j;i=g;return k|0}else{c[e>>2]=h;j=6;k=j;i=g;return k|0}}else if((m|0)==27){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function ju(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+56|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=26;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 9:{m=18;break a;break};case 30:{m=12;break a;break};case 7:{a=a+4|0;continue a;break};case 5:{a=a+2|0;continue a;break};case 10:{m=15;break a;break};case 6:{a=a+3|0;continue a;break};case 3:{m=9;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=Du(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){if((a|0)==(f|0)){n=Eu(h,a+1|0,b,e)|0;j=(n|0)==22?0:n;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==15){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==18){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==26){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function ku(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){switch(d[g+76+(d[b]|0)|0]|0){case 6:{h=5;break};case 5:{break};case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){h=4;break a}else{h=5}break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){h=12;break a}else{continue a}break};default:{h=13;break a}}if((h|0)==5){h=0;e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){h=6;break}}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){h=8;break}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){h=10;break}}if((h|0)==4){k=0;l=k;i=f;return l|0}else if((h|0)==6){k=0;l=k;i=f;return l|0}else if((h|0)==8){k=0;l=k;i=f;return l|0}else if((h|0)==10){k=0;l=k;i=f;return l|0}else if((h|0)==12){k=0;l=k;i=f;return l|0}else if((h|0)==13){if((a[b]|0)==(a[c]|0)){k=1;l=k;i=f;return l|0}switch(d[g+76+(d[c]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{k=0;l=k;i=f;return l|0};default:{k=1;l=k;i=f;return l|0}}}return 0}function lu(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=8;break}if(g){h=4;break}if((a[f]|0)!=(a[d]|0)){h=6;break}f=f+1|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==6){j=0;k=j;i=b;return k|0}else if((h|0)==8){j=g&1;k=j;i=b;return k|0}return 0}function mu(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+24|0;e=a;a=b;b=a;a:while(1){switch(d[e+76+(d[a]|0)|0]|0|0){case 5:{a=a+2|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{a=a+1|0;continue a;break};default:{break a}}}i=c;return a-b|0}function nu(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+16|0;e=a;a=b;while(1){b=d[e+76+(d[a]|0)|0]|0;if(!((b|0)==21|(b|0)==9|(b|0)==10)){break}a=a+1|0}i=c;return a|0}function ou(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+1|0;a:while(1){b:do{switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+3|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)!=32){break}if((a[b+1|0]|0)==32){break}if((d[j+76+(d[b+1|0]|0)|0]|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};default:{}}}while(0);b=b+1|0}i=h;return k|0}function pu(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=c;c=0;d=d+2|0;a:do{if((a[d]|0)==120){d=d+1|0;while(1){if(!((a[d]|0)==59^1)){break a}e=a[d]|0;switch(e|0){case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(e-97))|0;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(e-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|e-48;break};default:{}}if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}else{while(1){if(!((a[d]|0)==59^1)){break a}c=c*10|0;c=c+((a[d]|0)-48)|0;if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}}while(0);f=As(c)|0;g=f;i=b;return g|0}function qu(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+32|0;e=c;c=(d-e|0)/1|0;do{if((c|0)==2){if((a[e+1|0]|0)!=116){break}d=a[e]|0;if((d|0)==108){f=60;g=f;i=b;return g|0}else if((d|0)==103){f=62;g=f;i=b;return g|0}else{break}}else if((c|0)==4){d=a[e]|0;if((d|0)==97){e=e+1|0;if((a[e]|0)!=112){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else if((d|0)==113){e=e+1|0;if((a[e]|0)!=117){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else{break}}else if((c|0)==3){if((a[e]|0)!=97){break}e=e+1|0;if((a[e]|0)!=109){break}e=e+1|0;if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}}while(0);f=0;g=f;i=b;return g|0}function ru(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=a;a=b;b=e;e=f;while(1){if(!(a>>>0<b>>>0)){break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{a=a+2|0;break};case 7:{a=a+4|0;break};case 9:{f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;do{if((a|0)!=(b|0)){if((d[h+76+(d[a]|0)|0]|0|0)!=10){break}a=a+1|0}}while(0);c[e+4>>2]=-1;break};case 10:{c[e+4>>2]=-1;f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;break};case 6:{a=a+3|0;break};default:{a=a+1|0}}f=e+4|0;c[f>>2]=(c[f>>2]|0)+1}i=g;return}function su(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+1|0;e=e+ -1|0;a:while(1){if((b|0)==(e|0)){k=10;break}switch(d[j+76+(d[b]|0)|0]|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 22:case 26:{if((a[b]&-128|0)!=0){k=7}break};case 21:{if((a[b]|0)==9){k=5;break a}break};default:{k=7}}if((k|0)==7){k=0;g=a[b]|0;if(!((g|0)==64|(g|0)==36)){k=8;break}}b=b+1|0}if((k|0)==5){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==8){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==10){l=1;m=l;i=h;return m|0}return 0}function tu(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+56|0;h=d;d=e;e=f;f=g;a:do{if((d-(c[h>>2]|0)|0)>(f-(c[e>>2]|0)|0)){d=(c[h>>2]|0)+(f-(c[e>>2]|0))|0;while(1){if(!(d>>>0>(c[h>>2]|0)>>>0)){break a}if((a[d+ -1|0]&192|0)!=128){break a}d=d+ -1|0}}}while(0);f=c[e>>2]|0;g=c[h>>2]|0;while(1){j=g;if((g|0)==(d|0)){break}a[f]=a[j]|0;g=g+1|0;f=f+1|0}c[h>>2]=j;c[e>>2]=f;i=b;return}function uu(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+64|0;l=e;e=f;f=g;g=h;h=j;j=c[g>>2]|0;m=c[e>>2]|0;while(1){if((m|0)==(f|0)){n=10;break}if((j|0)==(h|0)){n=10;break}o=d[l+76+(d[m]|0)|0]|0;if((o|0)==6){p=j;j=p+2|0;b[p>>1]=(a[m]&15)<<12|(a[m+1|0]&63)<<6|a[m+2|0]&63;m=m+3|0;continue}else if((o|0)==7){if((j+2|0)==(h|0)){n=10;break}p=(a[m]&7)<<18|(a[m+1|0]&63)<<12|(a[m+2|0]&63)<<6|a[m+3|0]&63;p=p-65536|0;b[j>>1]=p>>>10|55296;b[j+2>>1]=p&1023|56320;j=j+4|0;m=m+4|0;continue}else if((o|0)==5){o=j;j=o+2|0;b[o>>1]=(a[m]&31)<<6|a[m+1|0]&63;m=m+2|0;continue}else{o=m;m=o+1|0;p=j;j=p+2|0;b[p>>1]=a[o]|0;continue}}if((n|0)==10){c[e>>2]=m;c[g>>2]=j;i=k;return}}function vu(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[27416+(((d[28696+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function wu(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[27416+(((d[28696+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function xu(a,b){a=a|0;b=b|0;b=i;i=i+16|0;i=b;return 0}function yu(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[27416+(((d[27160+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function zu(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[27416+(((d[27160+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function Au(b,c){b=b|0;c=c|0;var e=0,f=0;b=i;i=i+16|0;e=c;do{if((d[e]|0|0)<194){f=1}else{if((a[e+1|0]&128|0)==0){f=1;break}f=(a[e+1|0]&192|0)==192}}while(0);i=b;return f&1|0}function Bu(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}do{if((d[e]|0|0)==239){if((d[e+1|0]|0|0)!=191){h=5;break}if((d[e+2|0]|0|0)>189){f=1}else{break}g=f&1;i=b;return g|0}else{h=5}}while(0);do{if((h|0)==5){if((a[e+2|0]&192|0)==192){f=1}else{break}g=f&1;i=b;return g|0}}while(0);h=d[e+1|0]|0;do{if((d[e]|0|0)==224){if((h|0)<160){j=1;break}j=(a[e+1|0]&192|0)==192}else{if((h&128|0)==0){j=1;break}c=d[e+1|0]|0;if((d[e]|0|0)==237){k=(c|0)>159}else{k=(c&192|0)==192}j=(k&1|0)!=0}}while(0);f=(j&1|0)!=0;g=f&1;i=b;return g|0}function Cu(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+3|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+3|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}c=d[e+1|0]|0;do{if((d[e]|0|0)==240){if((c|0)<144){h=1;break}h=(a[e+1|0]&192|0)==192}else{if((c&128|0)==0){h=1;break}j=d[e+1|0]|0;if((d[e]|0|0)==244){k=(j|0)>143}else{k=(j&192|0)==192}h=(k&1|0)!=0}}while(0);f=(h&1|0)!=0;g=f&1;i=b;return g|0}function Du(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((re[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((re[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 19:{j=Fu(h,a+1|0,b,e)|0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((re[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){l=33;break b}m=a;if((re[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=m+3|0;continue b;break};case 18:{l=42;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 29:{l=25;break b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((re[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 5:{if((b-a|0)<2){l=28;break b}o=a;if((re[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=o+2|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=9;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function Eu(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((re[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((re[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 30:case 9:case 10:case 21:{c[e>>2]=a;j=22;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((re[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){l=33;break b}m=a;if((re[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=m+3|0;continue b;break};case 18:{l=42;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 29:{l=25;break b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((re[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 5:{if((b-a|0)<2){l=28;break b}o=a;if((re[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=o+2|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=28;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function Fu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){if((a[b]|0)==120){k=Gu(j,b+1|0,e,f)|0;l=k;i=h;return l|0}g=b;if((d[j+76+(d[b]|0)|0]|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;while(1){if((b|0)==(e|0)){break a}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==18){m=9;break}else if((g|0)!=25){m=10;break}b=b+1|0}if((m|0)==9){c[f>>2]=b+1;k=10;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function Gu(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;a:do{if((a|0)!=(b|0)){f=a;if(!(((d[h+76+(d[a]|0)|0]|0)+ -24|0)>>>0<2)){c[e>>2]=f;j=0;k=j;i=g;return k|0}a=f+1|0;while(1){if((a|0)==(b|0)){break a}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==18){l=7;break}else if(!((f|0)==24|(f|0)==25)){l=8;break}a=a+1|0}if((l|0)==7){c[e>>2]=a+1;j=10;k=j;i=g;return k|0}else if((l|0)==8){c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);j=-1;k=j;i=g;return k|0}function Hu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 24:case 22:{b=b+1|0;break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((re[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((re[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 17:{k=Lu(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 29:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((re[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 16:{g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==20){k=Ju(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else if((g|0)==27){k=Iu(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=Ku(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);g=0;b:while(1){if((b|0)==(e|0)){m=104;break}switch(d[j+76+(d[b]|0)|0]|0){case 11:{m=97;break b;break};case 29:{m=33;break b;break};case 23:{if((g|0)!=0){m=51;break b}g=1;b=b+1|0;if((b|0)==(e|0)){m=53;break b}switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){m=58;break b}n=b;if((re[c[j+344>>2]&63](j,b)|0)==0){m=60;break b}b=n+2|0;continue b;break};case 6:{if((e-b|0)<3){m=63;break b}o=b;if((re[c[j+348>>2]&63](j,b)|0)==0){m=65;break b}b=o+3|0;continue b;break};case 24:case 22:{b=b+1|0;continue b;break};case 7:{if((e-b|0)<4){m=68;break b}p=b;if((re[c[j+352>>2]&63](j,b)|0)==0){m=70;break b}b=p+4|0;continue b;break};case 29:{m=55;break b;break};default:{m=72;break b}}break};case 6:{if((e-b|0)<3){m=41;break b}q=b;if((re[c[j+336>>2]&63](j,b)|0)==0){m=43;break b}b=q+3|0;continue b;break};case 5:{if((e-b|0)<2){m=36;break b}r=b;if((re[c[j+332>>2]&63](j,b)|0)==0){m=38;break b}b=r+2|0;continue b;break};case 10:case 9:case 21:{m=73;break b;break};case 17:{break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 7:{if((e-b|0)<4){m=46;break b}s=b;if((re[c[j+340>>2]&63](j,b)|0)==0){m=48;break b}b=s+4|0;continue b;break};default:{m=103;break b}}}c:do{if((m|0)==33){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==36){k=-2;l=k;i=h;return l|0}else if((m|0)==38){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==41){k=-2;l=k;i=h;return l|0}else if((m|0)==43){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==46){k=-2;l=k;i=h;return l|0}else if((m|0)==48){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==51){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==53){k=-1;l=k;i=h;return l|0}else if((m|0)==55){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==58){k=-2;l=k;i=h;return l|0}else if((m|0)==60){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==63){k=-2;l=k;i=h;return l|0}else if((m|0)==65){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==68){k=-2;l=k;i=h;return l|0}else if((m|0)==70){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==72){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==73){b=b+1|0;d:while(1){if((b|0)==(e|0)){m=96;break}switch(d[j+76+(d[b]|0)|0]|0){case 7:{m=88;break d;break};case 11:{m=97;break c;break};case 5:{m=78;break d;break};case 6:{m=83;break d;break};case 24:case 22:{m=77;break d;break};case 29:{m=76;break d;break};case 17:{break c;break};case 10:case 9:case 21:{break};default:{m=94;break d}}b=b+1|0}do{if((m|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==77){b=b+1|0}else if((m|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((re[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==83){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((re[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==88){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((re[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==94){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==96){k=-1;l=k;i=h;return l|0}}while(0);k=Mu(j,b,e,f)|0;l=k;i=h;return l|0}else if((m|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-1;l=k;i=h;return l|0}}while(0);if((m|0)==97){c[f>>2]=b+1;k=2;l=k;i=h;return l|0}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}e=b;if((a[b]|0)==62){c[f>>2]=e+1;k=4;l=k;i=h;return l|0}else{c[f>>2]=e;k=0;l=k;i=h;return l|0}return 0}function Iu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)!=45){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;b:while(1){if((b|0)==(e|0)){break a}switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){m=18;break b}n=b;if((re[c[j+364>>2]&63](j,b)|0)!=0){m=20;break b}b=n+4|0;continue b;break};case 6:{if((e-b|0)<3){m=13;break b}o=b;if((re[c[j+360>>2]&63](j,b)|0)!=0){m=15;break b}b=o+3|0;continue b;break};case 27:{g=b+1|0;b=g;if((g|0)==(e|0)){m=24;break b}if((a[b]|0)==45){m=26;break b}else{continue b}break};case 5:{if((e-b|0)<2){m=8;break b}p=b;if((re[c[j+356>>2]&63](j,b)|0)!=0){m=10;break b}b=p+2|0;continue b;break};case 8:case 1:case 0:{m=22;break b;break};default:{b=b+1|0;continue b}}}if((m|0)==8){k=-2;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==13){k=-2;l=k;i=h;return l|0}else if((m|0)==15){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==18){k=-2;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==22){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==24){k=-1;l=k;i=h;return l|0}else if((m|0)==26){g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==62){c[f>>2]=g+1;k=13;l=k;i=h;return l|0}else{c[f>>2]=g;k=0;l=k;i=h;return l|0}}}}while(0);k=-1;l=k;i=h;return l|0}function Ju(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<6){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=8;break}if((a[k]|0)!=(a[30112+e|0]|0)){l=6;break}e=e+1|0;g=g+1|0}if((l|0)==6){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==8){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function Ku(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}a:do{switch(d[k+76+(d[b]|0)|0]|0){case 24:case 22:{b=b+1|0;break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}n=b;if((re[c[k+344>>2]&63](k,b)|0)!=0){b=n+2|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}n=b;if((re[c[k+348>>2]&63](k,b)|0)!=0){b=n+3|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 29:{c[f>>2]=b;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}n=b;if((re[c[k+352>>2]&63](k,b)|0)!=0){b=n+4|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b:while(1){if((b|0)==(e|0)){o=75;break}switch(d[k+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){o=27;break b}p=b;if((re[c[k+332>>2]&63](k,b)|0)==0){o=29;break b}b=p+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 15:{o=68;break b;break};case 7:{if((e-b|0)<4){o=37;break b}q=b;if((re[c[k+340>>2]&63](k,b)|0)==0){o=39;break b}b=q+4|0;continue b;break};case 29:{o=24;break b;break};case 10:case 9:case 21:{o=41;break b;break};case 6:{if((e-b|0)<3){o=32;break b}r=b;if((re[c[k+336>>2]&63](k,b)|0)==0){o=34;break b}b=r+3|0;continue b;break};default:{break b}}}do{if((o|0)==24){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==27){l=-2;m=l;i=h;return m|0}else if((o|0)==29){c[f>>2]=p;l=0;m=l;i=h;return m|0}else if((o|0)==32){l=-2;m=l;i=h;return m|0}else if((o|0)==34){c[f>>2]=r;l=0;m=l;i=h;return m|0}else if((o|0)==37){l=-2;m=l;i=h;return m|0}else if((o|0)==39){c[f>>2]=q;l=0;m=l;i=h;return m|0}else if((o|0)==41){n=b;if((Nu(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;c:while(1){if((b|0)==(e|0)){o=67;break}switch(d[k+76+(d[b]|0)|0]|0){case 8:case 1:case 0:{o=61;break c;break};case 7:{if((e-b|0)<4){o=57;break c}s=b;if((re[c[k+364>>2]&63](k,b)|0)!=0){o=59;break c}b=s+4|0;continue c;break};case 6:{if((e-b|0)<3){o=52;break c}t=b;if((re[c[k+360>>2]&63](k,b)|0)!=0){o=54;break c}b=t+3|0;continue c;break};case 15:{b=b+1|0;if((b|0)==(e|0)){o=63;break c}if((a[b]|0)==62){o=65;break c}else{continue c}break};case 5:{if((e-b|0)<2){o=47;break c}u=b;if((re[c[k+356>>2]&63](k,b)|0)!=0){o=49;break c}b=u+2|0;continue c;break};default:{b=b+1|0;continue c}}}if((o|0)==47){l=-2;m=l;i=h;return m|0}else if((o|0)==49){c[f>>2]=u;l=0;m=l;i=h;return m|0}else if((o|0)==52){l=-2;m=l;i=h;return m|0}else if((o|0)==54){c[f>>2]=t;l=0;m=l;i=h;return m|0}else if((o|0)==57){l=-2;m=l;i=h;return m|0}else if((o|0)==59){c[f>>2]=s;l=0;m=l;i=h;return m|0}else if((o|0)==61){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==63){l=-1;m=l;i=h;return m|0}else if((o|0)==65){c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==67){l=-1;m=l;i=h;return m|0}}else if((o|0)==68){n=b;if((Nu(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=62){break}c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==75){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function Lu(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 24:case 22:{a=a+1|0;break};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((re[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((re[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((re[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=51;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){l=27;break b}m=a;if((re[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=m+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 11:{l=49;break b;break};case 23:{a=a+1|0;continue b;break};case 7:{if((b-a|0)<4){l=37;break b}n=a;if((re[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=n+4|0;continue b;break};case 29:{l=24;break b;break};case 10:case 9:case 21:{l=41;break b;break};case 6:{if((b-a|0)<3){l=32;break b}o=a;if((re[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=o+3|0;continue b;break};default:{l=50;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==41){a=a+1|0;while(1){if((a|0)==(b|0)){l=47;break}n=d[h+76+(d[a]|0)|0]|0;if((n|0)==11){l=44;break}else if(!((n|0)==10|(n|0)==9|(n|0)==21)){l=45;break}a=a+1|0}if((l|0)==44){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==45){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==47){j=-1;k=j;i=g;return k|0}}else if((l|0)==49){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==50){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==51){j=-1;k=j;i=g;return k|0}return 0}function Mu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=114;break}b:do{switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 5:{if((e-(c[j>>2]|0)|0)<2){l=7;break a}b=(re[c[k+332>>2]&63](k,c[j>>2]|0)|0)!=0;m=c[j>>2]|0;if(!b){l=9;break a}c[j>>2]=m+2;continue a;break};case 27:case 26:case 25:case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 14:{break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=45;break a}b=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((b|0)==14){break b}n=b;if(!((n|0)==9|(n|0)==10|(n|0)==21)){l=48;break a}}break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=17;break a}n=(re[c[k+340>>2]&63](k,c[j>>2]|0)|0)!=0;o=c[j>>2]|0;if(!n){l=19;break a}c[j>>2]=o+4;continue a;break};case 23:{if((g|0)!=0){l=22;break a}g=1;c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=24;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 29:{l=26;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=39;break a}n=(re[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;p=c[j>>2]|0;if(!n){l=41;break a}c[j>>2]=p+4;continue a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=29;break a}n=(re[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;q=c[j>>2]|0;if(!n){l=31;break a}c[j>>2]=q+2;continue a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=34;break a}n=(re[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;r=c[j>>2]|0;if(!n){l=36;break a}c[j>>2]=r+3;continue a;break};default:{l=43;break a}}break};case 29:{l=4;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=12;break a}n=(re[c[k+336>>2]&63](k,c[j>>2]|0)|0)!=0;s=c[j>>2]|0;if(!n){l=14;break a}c[j>>2]=s+3;continue a;break};default:{l=113;break a}}}while(0);g=0;while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=51;break a}t=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((t|0)==12|(t|0)==13){break}n=t;if(!((n|0)==9|(n|0)==10|(n|0)==21)){l=54;break a}}c[j>>2]=(c[j>>2]|0)+1;c:while(1){if((c[j>>2]|0)==(e|0)){l=57;break a}n=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((n|0)==(t|0)){break}switch(n|0){case 8:case 1:case 0:{l=75;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=71;break a}n=(re[c[k+364>>2]&63](k,c[j>>2]|0)|0)!=0;u=c[j>>2]|0;if(n){l=73;break a}c[j>>2]=u+4;continue c;break};case 3:{v=Du(k,(c[j>>2]|0)+1|0,e,j)|0;if((v|0)<=0){l=77;break a}else{continue c}break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=66;break a}n=(re[c[k+360>>2]&63](k,c[j>>2]|0)|0)!=0;w=c[j>>2]|0;if(n){l=68;break a}c[j>>2]=w+3;continue c;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=61;break a}n=(re[c[k+356>>2]&63](k,c[j>>2]|0)|0)!=0;x=c[j>>2]|0;if(n){l=63;break a}c[j>>2]=x+2;continue c;break};case 2:{l=80;break a;break};default:{c[j>>2]=(c[j>>2]|0)+1;continue c}}}c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=83;break}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 10:case 9:case 21:{break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};default:{l=85;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=87;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 6:{l=96;break d;break};case 10:case 9:case 21:{break};case 5:{l=91;break d;break};case 7:{l=101;break d;break};case 17:{l=107;break a;break};case 29:{l=89;break a;break};case 11:{l=106;break a;break};case 24:case 22:{l=90;break d;break};default:{l=112;break a}}}if((l|0)==90){l=0;c[j>>2]=(c[j>>2]|0)+1;continue}else if((l|0)==91){l=0;if((e-(c[j>>2]|0)|0)<2){l=92;break}n=(re[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;y=c[j>>2]|0;if(!n){l=94;break}c[j>>2]=y+2;continue}else if((l|0)==96){l=0;if((e-(c[j>>2]|0)|0)<3){l=97;break}n=(re[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;z=c[j>>2]|0;if(!n){l=99;break}c[j>>2]=z+3;continue}else if((l|0)==101){l=0;if((e-(c[j>>2]|0)|0)<4){l=102;break}n=(re[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;A=c[j>>2]|0;if(!n){l=104;break}c[j>>2]=A+4;continue}}if((l|0)==4){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==7){B=-2;C=B;i=h;return C|0}else if((l|0)==9){c[f>>2]=m;B=0;C=B;i=h;return C|0}else if((l|0)==12){B=-2;C=B;i=h;return C|0}else if((l|0)==14){c[f>>2]=s;B=0;C=B;i=h;return C|0}else if((l|0)==17){B=-2;C=B;i=h;return C|0}else if((l|0)==19){c[f>>2]=o;B=0;C=B;i=h;return C|0}else if((l|0)==22){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==24){B=-1;C=B;i=h;return C|0}else if((l|0)==26){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==29){B=-2;C=B;i=h;return C|0}else if((l|0)==31){c[f>>2]=q;B=0;C=B;i=h;return C|0}else if((l|0)==34){B=-2;C=B;i=h;return C|0}else if((l|0)==36){c[f>>2]=r;B=0;C=B;i=h;return C|0}else if((l|0)==39){B=-2;C=B;i=h;return C|0}else if((l|0)==41){c[f>>2]=p;B=0;C=B;i=h;return C|0}else if((l|0)==43){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==45){B=-1;C=B;i=h;return C|0}else if((l|0)==48){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==51){B=-1;C=B;i=h;return C|0}else if((l|0)==54){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==57){B=-1;C=B;i=h;return C|0}else if((l|0)==61){B=-2;C=B;i=h;return C|0}else if((l|0)==63){c[f>>2]=x;B=0;C=B;i=h;return C|0}else if((l|0)==66){B=-2;C=B;i=h;return C|0}else if((l|0)==68){c[f>>2]=w;B=0;C=B;i=h;return C|0}else if((l|0)==71){B=-2;C=B;i=h;return C|0}else if((l|0)==73){c[f>>2]=u;B=0;C=B;i=h;return C|0}else if((l|0)==75){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==77){if((v|0)==0){c[f>>2]=c[j>>2]}B=v;C=B;i=h;return C|0}else if((l|0)==80){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==83){B=-1;C=B;i=h;return C|0}else if((l|0)==85){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==87){B=-1;C=B;i=h;return C|0}else if((l|0)==89){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==92){B=-2;C=B;i=h;return C|0}else if((l|0)==94){c[f>>2]=y;B=0;C=B;i=h;return C|0}else if((l|0)==97){B=-2;C=B;i=h;return C|0}else if((l|0)==99){c[f>>2]=z;B=0;C=B;i=h;return C|0}else if((l|0)==102){B=-2;C=B;i=h;return C|0}else if((l|0)==104){c[f>>2]=A;B=0;C=B;i=h;return C|0}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+1;B=1;C=B;i=h;return C|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){B=-1;C=B;i=h;return C|0}e=c[j>>2]|0;if((a[c[j>>2]|0]|0)==62){c[f>>2]=e+1;B=3;C=B;i=h;return C|0}else{c[f>>2]=e;B=0;C=B;i=h;return C|0}}else if((l|0)==112){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==113){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==114){B=-1;C=B;i=h;return C|0}return 0}function Nu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;do{if((e-g|0)!=3){h=1}else{j=a[g]|0;if((j|0)==88){f=1}else if((j|0)!=120){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==77){f=1}else if((j|0)!=109){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==76){f=1}else if((j|0)!=108){h=1;break}if((f|0)!=0){h=0;break}else{c[d>>2]=12;h=1;break}}}while(0);i=b;return h|0}function Ou(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+56|0;j=a;a=b;b=e;e=f;f=g;a:while(1){if((b|0)==(e|0)){k=27;break}g=d[a+76+(d[b]|0)|0]|0;switch(g|0){case 6:{if((e-b|0)<3){k=10;break a}l=b;if((re[c[a+360>>2]&63](a,b)|0)!=0){k=12;break a}b=l+3|0;continue a;break};case 5:{if((e-b|0)<2){k=5;break a}m=b;if((re[c[a+356>>2]&63](a,b)|0)!=0){k=7;break a}b=m+2|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 7:{if((e-b|0)<4){k=15;break a}n=b;if((re[c[a+364>>2]&63](a,b)|0)!=0){k=17;break a}b=n+4|0;continue a;break};case 13:case 12:{b=b+1|0;if((g|0)!=(j|0)){continue a}else{k=21;break a}break};default:{b=b+1|0;continue a}}}if((k|0)==5){o=-2;p=o;i=h;return p|0}else if((k|0)==7){c[f>>2]=m;o=0;p=o;i=h;return p|0}else if((k|0)==10){o=-2;p=o;i=h;return p|0}else if((k|0)==12){c[f>>2]=l;o=0;p=o;i=h;return p|0}else if((k|0)==15){o=-2;p=o;i=h;return p|0}else if((k|0)==17){c[f>>2]=n;o=0;p=o;i=h;return p|0}else if((k|0)==19){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==21){if((b|0)==(e|0)){o=-27;p=o;i=h;return p|0}c[f>>2]=b;switch(d[a+76+(d[b]|0)|0]|0|0){case 20:case 30:case 11:case 10:case 9:case 21:{o=27;p=o;i=h;return p|0};default:{o=0;p=o;i=h;return p|0}}}else if((k|0)==27){o=-1;p=o;i=h;return p|0}return 0}function Pu(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==20){c[e>>2]=a+1;j=33;k=j;i=g;return k|0}else if((f|0)==24|(f|0)==22){a=a+1|0;a:while(1){if((a|0)==(b|0)){l=17;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 30:{l=10;break a;break};case 24:case 22:{break};case 10:case 9:case 21:{break a;break};default:{l=16;break a}}a=a+1|0}do{if((l|0)==10){if((a+1|0)==(b|0)){j=-1;k=j;i=g;return k|0}m=d[h+76+(d[a+1|0]|0)|0]|0;if(!((m|0)==30|(m|0)==10|(m|0)==9|(m|0)==21)){break}c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==16){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==17){j=-1;k=j;i=g;return k|0}}while(0);c[e>>2]=a;j=16;k=j;i=g;return k|0}else if((f|0)==27){j=Iu(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=0;k=j;i=g;return k|0}return 0}function Qu(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((re[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((re[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((re[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=43;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 6:{if((b-a|0)<3){l=32;break b}m=a;if((re[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=m+3|0;continue b;break};case 5:{if((b-a|0)<2){l=27;break b}n=a;if((re[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=n+2|0;continue b;break};case 29:{l=24;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{l=41;break b;break};case 7:{if((b-a|0)<4){l=37;break b}o=a;if((re[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=o+4|0;continue b;break};default:{l=42;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==41){c[e>>2]=a;j=20;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==43){j=-20;k=j;i=g;return k|0}return 0}function Ru(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+40|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=5;break}if((c[e>>2]|0)==(f|0)){j=5;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g}if((j|0)==5){i=b;return}}function Su(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;a=i;i=i+40|0;j=e;e=f;f=g;g=h;while(1){if((c[j>>2]|0)==(e|0)){k=5;break}if((c[f>>2]|0)==(g|0)){k=5;break}h=j;l=c[h>>2]|0;c[h>>2]=l+1;h=d[l]|0;l=f;m=c[l>>2]|0;c[l>>2]=m+2;b[m>>1]=h}if((k|0)==5){i=a;return}}function Tu(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+48|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=8;break}g=a[c[h>>2]|0]|0;if((g&128|0)!=0){if((f-(c[e>>2]|0)|0)<2){j=8;break}k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=(g&255)>>6|192;l=e;k=c[l>>2]|0;c[l>>2]=k+1;a[k]=g&63|128;g=h;c[g>>2]=(c[g>>2]|0)+1;continue}else{if((c[e>>2]|0)==(f|0)){j=8;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g;continue}}if((j|0)==8){i=b;return}}function Uu(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;i=i+72|0;l=b;b=e;e=f;f=g;g=h;h=j;if((f|0)==(g|0)){m=-4;n=m;i=k;return n|0}j=c[b+76>>2]|0;a:do{if((f+1|0)==(g|0)){if(((a[b+73|0]|0)+ -3|0)>>>0<3){m=-1;n=m;i=k;return n|0}b:do{switch(d[f]|0){case 239:case 255:case 254:{if((a[b+73|0]|0)!=0){break b}if((e|0)==1){break a}break};case 60:case 0:{break};default:{break a}}}while(0);m=-1;n=m;i=k;return n|0}else{o=d[f]<<8|d[f+1|0];if((o|0)==61371){if((e|0)==1){p=a[b+73|0]|0;if((p|0)==0|(p|0)==4|(p|0)==5|(p|0)==3){break}}if((f+2|0)==(g|0)){m=-1;n=m;i=k;return n|0}if((d[f+2|0]|0)!=191){break}c[h>>2]=f+3;c[j>>2]=c[l+8>>2];m=14;n=m;i=k;return n|0}else if((o|0)==65279){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+16>>2];m=14;n=m;i=k;return n|0}else if((o|0)==15360){if((a[b+73|0]|0)==4){q=16}else{if((a[b+73|0]|0)==3){q=16}}if((q|0)==16){if((e|0)==1){break}}c[j>>2]=c[l+20>>2];m=Ae[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else if((o|0)==65534){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+20>>2];m=14;n=m;i=k;return n|0}else{if((a[f]|0)==0){if((e|0)==1){if((a[b+73|0]|0)==5){break}}c[j>>2]=c[l+16>>2];m=Ae[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f+1|0]|0)!=0){break}if((e|0)==1){break}c[j>>2]=c[l+20>>2];m=Ae[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}}}}while(0);c[j>>2]=c[l+(a[b+73|0]<<2)>>2];m=Ae[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}function Vu(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+80|0;k=a;a=b;b=d;d=e;e=f;f=g;g=h;if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}if((Xu(Wu(k,a,b)|0)|0)==0){c[g>>2]=a;l=0;m=l;i=j;return m|0}do{a=a+(c[k+68>>2]|0)|0;}while((Xu(Wu(k,a,b)|0)|0)!=0);if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}c[d>>2]=a;while(1){n=Wu(k,a,b)|0;if((n|0)==-1){o=10;break}if((n|0)==61){o=12;break}if((Xu(n)|0)!=0){o=14;break}a=a+(c[k+68>>2]|0)|0}do{if((o|0)==10){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==12){c[e>>2]=a}else if((o|0)==14){c[e>>2]=a;do{a=a+(c[k+68>>2]|0)|0;h=Wu(k,a,b)|0;n=h;}while((Xu(h)|0)!=0);if((n|0)==61){break}c[g>>2]=a;l=0;m=l;i=j;return m|0}}while(0);if((a|0)==(c[d>>2]|0)){c[g>>2]=a;l=0;m=l;i=j;return m|0}a=a+(c[k+68>>2]|0)|0;n=Wu(k,a,b)|0;while(1){if((Xu(n)|0)==0){break}a=a+(c[k+68>>2]|0)|0;n=Wu(k,a,b)|0}if((n|0)!=34&(n|0)!=39){c[g>>2]=a;l=0;m=l;i=j;return m|0}d=n&255;a=a+(c[k+68>>2]|0)|0;c[f>>2]=a;a:while(1){n=Wu(k,a,b)|0;if((n|0)==(d<<24>>24|0)){o=33;break}do{if(!(97<=(n|0)&(n|0)<=122)){if(65<=(n|0)&(n|0)<=90){break}if((48<=(n|0)&(n|0)<=57^1)&(n|0)!=46&(n|0)!=45&(n|0)!=95){o=31;break a}}}while(0);a=a+(c[k+68>>2]|0)|0}if((o|0)==31){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==33){c[g>>2]=a+(c[k+68>>2]|0);l=1;m=l;i=j;return m|0}return 0}function Wu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f+40|0;k=b;c[g>>2]=d;c[j>>2]=h;_d[c[k+60>>2]&31](k,g,e,j,(c[j>>2]|0)+1|0);if((c[j>>2]|0)==(h|0)){l=-1;m=l;i=f;return m|0}else{l=a[h]|0;m=l;i=f;return m|0}return 0}function Xu(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=a;if((c|0)==9|(c|0)==10|(c|0)==13|(c|0)==32){d=1}else{d=0}i=b;return d|0}function Yu(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d>>2]=13;c[d+16>>2]=1;c[d+12>>2]=0;c[d+20>>2]=0;i=b;return}function Zu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 15:{c[h>>2]=14;j=0;break};case 13:{c[h>>2]=14;j=56;break};case 11:{c[h>>2]=14;j=55;break};case 29:{c[h>>2]=16;j=2;break};case 12:{c[h>>2]=14;j=1;break};case 16:{if((Ae[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,33856)|0)==0){k=10;break a}c[h>>2]=15;j=3;break};case 14:{j=0;break};default:{k=10}}}while(0);if((k|0)==10){j=bv(h,a)|0}i=g;return j|0}function _u(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;a:do{switch(a|0){case 15:{j=0;break};case-4:{if((c[h+12>>2]|0)!=0){k=9;break a}j=0;break};case 26:{k=9;break};case 33:{c[h>>2]=17;j=0;break};case 34:{if((c[h+12>>2]|0)==0){k=9;break a}b=h+12|0;c[b>>2]=(c[b>>2]|0)-1;j=0;break};default:{j=av(h,a,d,e,f)|0}}}while(0);if((k|0)==9){j=bv(h,a)|0}i=g;return j|0}function $u(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==18){j=3}else if((f|0)==15){k=0;l=k;i=g;return l|0}do{if((j|0)==3){if((Ae[c[e+28>>2]&63](e,b,d,33840)|0)!=0){c[h>>2]=18;k=0;l=k;i=g;return l|0}if((Ae[c[e+28>>2]&63](e,b,d,33848)|0)==0){break}c[h>>2]=19;k=0;l=k;i=g;return l|0}}while(0);k=bv(h,a)|0;l=k;i=g;return l|0}function av(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;a:do{switch(a|0){case 11:{j=55;k=j;i=g;return k|0};case-4:{j=0;k=j;i=g;return k|0};case 16:{if((Ae[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,33616)|0)!=0){c[h>>2]=20;j=11;k=j;i=g;return k|0}if((Ae[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,33624)|0)!=0){c[h>>2]=21;j=33;k=j;i=g;return k|0}if((Ae[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,33632)|0)!=0){c[h>>2]=22;j=39;k=j;i=g;return k|0}if((Ae[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,33640)|0)==0){break a}c[h>>2]=23;j=17;k=j;i=g;return k|0};case 15:{j=0;k=j;i=g;return k|0};case 13:{j=56;k=j;i=g;return k|0};case 26:{c[h>>2]=24;j=3;k=j;i=g;return k|0};case 28:{j=60;k=j;i=g;return k|0};default:{}}}while(0);j=bv(h,a)|0;k=j;i=g;return k|0}function bv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=a;do{if((c[e+16>>2]|0)==0){if((b|0)!=28){break}f=59;g=f;i=d;return g|0}}while(0);c[e>>2]=16;f=-1;g=f;i=d;return g|0}function cv(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;i=e;return 0}function dv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=26;g=9}else if((b|0)==22){c[e>>2]=25;g=11}else if((b|0)==15){g=11}else{g=bv(e,a)|0}i=f;return g|0}function ev(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=27;g=34}else{g=bv(e,a)|0}i=f;return g|0}function fv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=28;g=40}else{g=bv(e,a)|0}i=f;return g|0}function gv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==18){c[e>>2]=29;g=18}else{g=bv(e,a)|0}i=f;return g|0}function hv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==15){g=3}else{g=bv(e,a)|0}i=f;return g|0}function iv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0}else if((b|0)==29){c[e>>2]=16;g=2}else if((b|0)==13){g=56}else if((b|0)==11){g=55}else{g=bv(e,a)|0}i=f;return g|0}function jv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==18){j=3}else if((f|0)==15){k=17;l=k;i=g;return l|0}do{if((j|0)==3){if((Ae[c[e+28>>2]&63](e,b,d,33656)|0)!=0){c[h>>2]=31;k=17;l=k;i=g;return l|0}if((Ae[c[e+28>>2]&63](e,b,d,33664)|0)==0){break}c[h>>2]=32;k=17;l=k;i=g;return l|0}}while(0);k=bv(h,a)|0;l=k;i=g;return l|0}function kv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else{g=bv(e,a)|0}i=f;return g|0}function lv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=34;g=21}else if((b|0)==15){g=17}else{g=bv(e,a)|0}i=f;return g|0}function mv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=20}else if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==15){g=17}else{g=bv(e,a)|0}i=f;return g|0}function nv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=c[e+8>>2]|0;h=g;i=f;return h|0}else if((b|0)==15){g=c[e+8>>2]|0;h=g;i=f;return h|0}else{g=bv(e,a)|0;h=g;i=f;return h|0}return 0}function ov(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=39;k=j;i=g;return k|0}else if((f|0)==18){if((Ae[c[e+28>>2]&63](e,b,d,33672)|0)!=0){c[h>>2]=33;c[h+8>>2]=39;j=42;k=j;i=g;return k|0}if((Ae[c[e+28>>2]&63](e,b,d,33680)|0)==0){break}c[h>>2]=33;c[h+8>>2]=39;j=41;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=37;c[h+4>>2]=1;j=44;k=j;i=g;return k|0}}while(0);j=bv(h,a)|0;k=j;i=g;return k|0}function pv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 15:{j=39;break};case 20:{if((Ae[c[b+28>>2]&63](b,d+(c[b+68>>2]|0)|0,e,33688)|0)==0){k=10;break a}c[h>>2]=38;j=43;break};case 41:case 18:{c[h>>2]=40;j=51;break};case 31:{c[h>>2]=40;j=52;break};case 30:{c[h>>2]=40;j=53;break};case 32:{c[h>>2]=40;j=54;break};case 23:{c[h+4>>2]=2;c[h>>2]=39;j=44;break};default:{k=10}}}while(0);if((k|0)==10){j=bv(h,a)|0}i=g;return j|0}function qv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==24){c[e>>2]=33;c[e+8>>2]=39;g=45}else if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else{g=bv(e,a)|0}i=f;return g|0}function rv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 41:case 18:{c[e>>2]=40;g=51;break};case 31:{c[e>>2]=40;g=52;break};case 23:{b=e+4|0;c[b>>2]=(c[b>>2]|0)+1;g=44;break};case 30:{c[e>>2]=40;g=53;break};case 15:{g=39;break};case 32:{c[e>>2]=40;g=54;break};default:{g=bv(e,a)|0}}i=f;return g|0}function sv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 24:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=45;h=g;i=f;return h|0};case 15:{g=39;h=g;i=f;return h|0};case 21:{c[e>>2]=39;g=49;h=g;i=f;return h|0};case 35:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=47;h=g;i=f;return h|0};case 37:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=48;h=g;i=f;return h|0};case 36:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=46;h=g;i=f;return h|0};case 38:{c[e>>2]=39;g=50;h=g;i=f;return h|0};default:{g=bv(e,a)|0;h=g;i=f;return h|0}}return 0}function tv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=42;g=51}else if((b|0)==15){g=39}else{g=bv(e,a)|0}i=f;return g|0}function uv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else{g=bv(e,a)|0}i=f;return g|0}function vv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=43;g=22}else if((b|0)==15){g=33}else{g=bv(e,a)|0}i=f;return g|0}function wv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+56|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==18){l=0;while(1){m=c[e+28>>2]|0;n=e;o=b;p=d;if((l|0)>=8){break}if((Ae[m&63](n,o,p,c[33696+(l<<2)>>2]|0)|0)!=0){q=6;break}l=l+1|0}if((q|0)==6){c[h>>2]=44;j=23+l|0;k=j;i=g;return k|0}if((Ae[m&63](n,o,p,33640)|0)==0){break}c[h>>2]=45;j=33;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=46;j=33;k=j;i=g;return k|0}}while(0);j=bv(h,a)|0;k=j;i=g;return k|0}function xv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==20){if((Ae[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,33800)|0)!=0){c[h>>2]=27;j=35;k=j;i=g;return k|0}if((Ae[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,33808)|0)!=0){c[h>>2]=27;j=36;k=j;i=g;return k|0}if((Ae[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,33824)|0)==0){break}c[h>>2]=47;j=33;k=j;i=g;return k|0}else if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=27;j=37;k=j;i=g;return k|0}}while(0);j=bv(h,a)|0;k=j;i=g;return k|0}function yv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==23){c[e>>2]=48;g=33}else if((b|0)==15){g=33}else{g=bv(e,a)|0}i=f;return g|0}function zv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18|(b|0)==19){c[e>>2]=49;g=31}else if((b|0)==15){g=33}else{g=bv(e,a)|0}i=f;return g|0}function Av(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=46;g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==15){g=33}else{g=bv(e,a)|0}i=f;return g|0}function Bv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==18){c[e>>2]=50;g=32}else{g=bv(e,a)|0}i=f;return g|0}function Cv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==15){g=33}else if((b|0)==21){c[e>>2]=48;g=33}else{g=bv(e,a)|0}i=f;return g|0}function Dv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=27;g=38}else if((b|0)==15){g=33}else{g=bv(e,a)|0}i=f;return g|0}function Ev(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=51;g=10}else if((b|0)==15){g=11}else{g=bv(e,a)|0}i=f;return g|0}function Fv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==18){if((Ae[c[e+28>>2]&63](e,b,d,33656)|0)!=0){c[h>>2]=52;j=11;k=j;i=g;return k|0}if((Ae[c[e+28>>2]&63](e,b,d,33664)|0)==0){break}c[h>>2]=53;j=11;k=j;i=g;return k|0}}while(0);j=bv(h,a)|0;k=j;i=g;return k|0}function Gv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=54;g=13}else if((b|0)==15){g=11}else{g=bv(e,a)|0}i=f;return g|0}function Hv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=52;g=14}else if((b|0)==15){g=11}else{g=bv(e,a)|0}i=f;return g|0}function Iv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((Ae[c[e+28>>2]&63](e,b,d,33832)|0)==0){break}c[h>>2]=55;j=11;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=(c[h+16>>2]|0)!=0?35:36;j=15;k=j;i=g;return k|0}}while(0);j=bv(h,a)|0;k=j;i=g;return k|0}function Jv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=33;c[e+8>>2]=11;g=16}else if((b|0)==15){g=11}else{g=bv(e,a)|0}i=f;return g|0}function Kv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((Ae[c[e+28>>2]&63](e,b,d,33656)|0)!=0){c[h>>2]=56;j=11;k=j;i=g;return k|0}if((Ae[c[e+28>>2]&63](e,b,d,33664)|0)==0){break}c[h>>2]=57;j=11;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}}while(0);j=bv(h,a)|0;k=j;i=g;return k|0}function Lv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=58;g=13}else if((b|0)==15){g=11}else{g=bv(e,a)|0}i=f;return g|0}function Mv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=56;g=14}else if((b|0)==15){g=11}else{g=bv(e,a)|0}i=f;return g|0}function Nv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=15;h=g;i=f;return h|0}else if((b|0)==15){g=11;h=g;i=f;return h|0}else{g=bv(e,a)|0;h=g;i=f;return h|0}return 0}function Ov(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0;h=g;i=f;return h|0}else if((b|0)==25){c[e>>2]=36;b=e+12|0;c[b>>2]=(c[b>>2]|0)+1;g=0;h=g;i=f;return h|0}else{g=bv(e,a)|0;h=g;i=f;return h|0}return 0}function Pv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0}else if((b|0)==25){c[e>>2]=36;g=58}else{g=bv(e,a)|0}i=f;return g|0}function Qv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 15:{j=0;break};case 11:{j=55;break};case 16:{if((Ae[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,33856)|0)==0){k=9;break a}c[h>>2]=15;j=3;break};case 29:{c[h>>2]=16;j=2;break};case 13:{j=56;break};case 14:{j=0;break};default:{k=9}}}while(0);if((k|0)==9){j=bv(h,a)|0}i=g;return j|0}function Rv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=59;g=4}else if((b|0)==15){g=3}else{g=bv(e,a)|0}i=f;return g|0}function Sv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==17){c[h>>2]=30;j=8;k=j;i=g;return k|0}else if((f|0)==15){j=3;k=j;i=g;return k|0}else if((f|0)==25){c[h>>2]=35;j=7;k=j;i=g;return k|0}else if((f|0)==18){if((Ae[c[e+28>>2]&63](e,b,d,33656)|0)!=0){c[h>>2]=60;j=3;k=j;i=g;return k|0}if((Ae[c[e+28>>2]&63](e,b,d,33664)|0)==0){break}c[h>>2]=61;j=3;k=j;i=g;return k|0}}while(0);j=bv(h,a)|0;k=j;i=g;return k|0}function Tv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==27){c[e>>2]=62;g=5}else{g=bv(e,a)|0}i=f;return g|0}function Uv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=60;g=6}else if((b|0)==15){g=3}else{g=bv(e,a)|0}i=f;return g|0}function Vv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==25){c[e>>2]=35;g=7}else{g=bv(e,a)|0}i=f;return g|0}function Wv(){i=i;return}function Xv(){i=i;return}function Yv(){var a=0;a=i;Ta(33864,0)|0;i=a;return}function Zv(){var a=0,b=0,d=0;a=i;b=35584|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=35696|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=35808|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));c[35588>>2]=1;c[35592>>2]=1;i=a;return}function _v(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+24|0;e=d;f=c[b+4>>2]|0;g=c[b+8>>2]|0;h=c[b+12>>2]|0;j=c[b+16>>2]|0;k=(c[b+20>>2]|0)!=0?35944:35960;c[e>>2]=c[b>>2];c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=h;c[e+16>>2]=j;c[e+20>>2]=k;sd(a|0,35920,e|0)|0;i=d;return}function $v(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=35808+(d<<2)|0;o=35696+(d<<2)|0;p=36008+(b<<2)|0;q=34288+(d<<2)|0;r=e;e=f;f=(g|0)!=0;a:while(1){b:do{if(f){c[l>>2]=35992;cc(35976,l|0)|0;s=35992}else{if((c[8892]|0)==(d|0)){if((c[o>>2]|0)>0){t=35992}else{u=5}}else{u=5}if((u|0)==5){u=0;t=c[q>>2]|0}c[m>>2]=t;cc(35976,m|0)|0;do{if((c[8892]|0)==(d|0)){if((c[n>>2]|0)!=(b|0)){break}if((c[o>>2]|0)>0){s=35992;break b}}}while(0);s=c[p>>2]|0}}while(0);c[k>>2]=s;cc(36e3,k|0)|0;c[n>>2]=b;c[8892]=d;if((c[o>>2]|0)>0){g=0;while(1){cc(36032,j|0)|0;v=g+1|0;if((v|0)<(c[o>>2]|0)){g=v}else{w=0;break}}}else{w=0}while(1){x=e+w|0;g=a[x]|0;if(g<<24>>24==0){break a}else if(g<<24>>24==10){break}w=w+1|0}a[x]=0;qb(e|0)|0;r=0;e=e+(w+1)|0;f=1}qb(e|0)|0;qd(0)|0;if((r|0)==0){i=h;return}c[o>>2]=(c[o>>2]|0)+1;i=h;return}function aw(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;h=f;j=i;i=i+8|0;k=c[36008+(a<<2)>>2]|0;c[j>>2]=c[34288+(b<<2)>>2];c[j+4>>2]=k;cc(36040,j|0)|0;bw(e);if((g|0)==0){Gd(((d|0)!=0?36080:36128)|0,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=qd(m|0)|0;i=f;return}qb(36208)|0;if((c[g>>2]|0)>=1){e=1;while(1){c[h>>2]=c[g+(e<<2)>>2];cc(36088,h|0)|0;if((e|0)<(c[g>>2]|0)){e=e+1|0}else{break}}}if((d|0)!=0){l=t;m=c[t>>2]|0;n=qd(m|0)|0;i=f;return}nc(36112,11,1,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=qd(m|0)|0;i=f;return}function bw(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[t>>2]|0;f=b;while(1){b=a[f]|0;if(b<<24>>24==0){break}else if(b<<24>>24==60){nc(36160,4,1,e|0)|0}else if(b<<24>>24==38){nc(36152,5,1,e|0)|0}else if(b<<24>>24==62){nc(36168,4,1,e|0)|0}else{Od(b<<24>>24|0,e|0)|0}f=f+1|0}i=d;return}function cw(a){a=a|0;var b=0;b=35696+(a<<2)|0;c[b>>2]=(c[b>>2]|0)+ -1;i=i;return}function dw(a){a=a|0;var b=0;b=(a|0)==0;c[9036]=b?1:19;c[9034]=b?7:167;i=i;return}function ew(a){a=a|0;var b=0;a=i;b=c[t>>2]|0;nc(36112,11,1,b|0)|0;qd(b|0)|0;i=a;return}function fw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+2064|0;h=g+2048|0;if((c[35584+(a<<2)>>2]|0)==0){i=g;return}j=g;c[h>>2]=f;Wc(j|0,2048,e|0,h|0)|0;me[c[9036]&31](1,a,b,j,0,d);i=g;return}function gw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((c[35584+(a<<2)>>2]|0)==0){i=f;return}h=f;c[g>>2]=e;Wc(h|0,2048,d|0,g|0)|0;me[c[9036]&31](1,a,b,h,0,0);i=f;return}function hw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+2064|0;h=g;j=g+2048|0;do{if((c[8894]|0)==0){if((c[35584+(a<<2)>>2]|0)!=0){break}i=g;return}}while(0);k=h;c[j>>2]=f;Wc(k|0,2048,e|0,j|0)|0;me[c[9036]&31](2,a,b,k,0,d);i=g;return}function iw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f;h=f+2048|0;do{if((c[8894]|0)==0){if((c[35584+(a<<2)>>2]|0)!=0){break}i=f;return}}while(0);j=g;c[h>>2]=e;Wc(j|0,2048,d|0,h|0)|0;me[c[9036]&31](2,a,b,j,0,0);i=f;return}function jw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((b|0)!=0){i=f;return}b=f;c[g>>2]=e;Wc(b|0,2048,d|0,g|0)|0;me[c[9036]&31](4,2,0,b,0,0);if((a|0)==0){h=jd(c[8466]|0)|0}else{h=a}bb(c[h+76>>2]|0,1)}function kw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+2064|0;f=e+2048|0;g=e;c[f>>2]=d;Wc(g|0,2048,b|0,f|0)|0;me[c[9036]&31](5,2,0,g,0,0);if((a|0)==0){h=jd(c[8466]|0)|0}else{h=a}bb(c[h+76>>2]|0,1)}function lw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f+2048|0;h=f;c[g>>2]=e;Wc(h|0,2048,d|0,g|0)|0;me[c[9036]&31](5,2,0,h,0,b);if((a|0)==0){j=jd(c[8466]|0)|0}else{j=a}bb(c[j+76>>2]|0,1)}function mw(a,b,d,e,f,g){a=a|0;b=+b;d=d|0;e=e|0;f=+f;g=g|0;var j=0,l=0,m=0;j=i;i=i+16|0;l=j;m=i;i=i+16|0;if(g<<24>>24==0){g=l;h[k>>3]=f;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[l+8>>2]=d;lw(a,e,36280,l)}else{l=m;h[k>>3]=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[m+8>>2]=d;hw(26,0,e,36216,m);i=j;return+b}return 0.0}function nw(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=VZ(16)|0;jw(0,(d|0)!=0|0,36328,b);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=a;c[d+12>>2]=0;i=b;return d|0}function ow(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)!=0){f=e;while(1){e=c[f+4>>2]|0;WZ(c[f>>2]|0);WZ(f);if((e|0)==0){break}else{f=e}}}c[a+12>>2]=0;c[d>>2]=0;c[a+4>>2]=0;i=b;return}function pw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;jw(0,(a|0)!=0|0,36344,f);f=VZ(8)|0;g=f;jw(0,(f|0)!=0|0,36328,e);e=a+8|0;h=VZ(c[e>>2]|0)|0;c[f>>2]=h;jw(0,(h|0)!=0|0,36328,d);z_(c[f>>2]|0,b|0,c[e>>2]|0)|0;e=a;c[f+4>>2]=c[e>>2];f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=g;e=a+4|0;if((c[e>>2]|0)!=0){i=d;return}c[e>>2]=g;i=d;return}function qw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;jw(0,(a|0)!=0|0,36344,f);f=VZ(8)|0;g=f;jw(0,(f|0)!=0|0,36328,e);e=a+8|0;h=VZ(c[e>>2]|0)|0;c[f>>2]=h;jw(0,(h|0)!=0|0,36328,d);z_(c[f>>2]|0,b|0,c[e>>2]|0)|0;c[f+4>>2]=0;f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;f=a+4|0;e=c[f>>2]|0;if((e|0)!=0){c[e+4>>2]=g}c[f>>2]=g;f=a;if((c[f>>2]|0)!=0){i=d;return}c[f>>2]=g;i=d;return}function rw(a){a=a|0;var b=0;b=i;i=i+8|0;jw(0,(a|0)!=0|0,36344,b);i=b;return c[a+12>>2]|0}function sw(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;jw(0,(a|0)!=0|0,36344,d);d=a;jw(0,(c[d>>2]|0)!=0|0,36368,b);i=b;return c[c[d>>2]>>2]|0}function tw(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=c[e+4>>2]|0;WZ(c[e>>2]|0);WZ(c[d>>2]|0);c[d>>2]=f;d=a+12|0;c[d>>2]=(c[d>>2]|0)+ -1;if((f|0)!=0){i=b;return}c[a+4>>2]=0;i=b;return}function uw(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;jw(0,(a|0)!=0|0,36344,d);d=a;jw(0,(c[d>>2]|0)!=0|0,36384,b);i=b;return c[d>>2]|0}function vw(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=(a|0)!=0;jw(0,d&1,36416,b);if(!d){e=0;i=b;return e|0}e=c[a+4>>2]|0;i=b;return e|0}function ww(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;jw(0,(a|0)!=0|0,36416,d);d=a;jw(0,(c[d>>2]|0)!=0|0,36440,b);i=b;return c[d>>2]|0}function xw(){var a=0,b=0,d=0;a=i;b=VZ(16)|0;c[9128]=b;c[b+4>>2]=0;c[b+8>>2]=2097152;d=VZ(2097152)|0;c[b>>2]=d;c[b+12>>2]=0;i=a;return}function yw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=Aw(a)|0;pc(36520)|0;Bw(d);a=c[9128]|0;e=a+4|0;f=c[e>>2]|0;g=(c[a>>2]|0)+f|0;c[e>>2]=f+d;bc(36520)|0;B_(g|0,0,d|0)|0;i=b;return g|0}function zw(){var a=0,b=0,d=0,e=0;a=i;b=c[9128]|0;d=c[b+12>>2]|0;if((d|0)==0){e=b}else{b=d;while(1){d=c[b+12>>2]|0;WZ(c[b>>2]|0);WZ(b);if((d|0)==0){break}else{b=d}}e=c[9128]|0}c[e+4>>2]=0;c[e+12>>2]=0;i=a;return 0}function Aw(a){a=a|0;i=i;return a+7&-8|0}function Bw(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[9128]|0;e=d+8|0;if(!(((c[e>>2]|0)-(c[d+4>>2]|0)|0)>>>0<a>>>0)){i=b;return}f=VZ(16)|0;c[f+12>>2]=d;c[9128]=f;c[f+4>>2]=0;d=Cw((((c[e>>2]|0)*3|0)>>>1)+a|0)|0;c[f+8>>2]=d;a=VZ(d)|0;c[f>>2]=a;i=b;return}function Cw(a){a=a|0;var b=0;b=a+ -1|0;a=b>>>1|b;b=a>>>2|a;a=b>>>4|b;b=a>>>8|a;i=i;return(b>>>16|b)+1|0}function Dw(a){a=a|0;var b=0,c=0;b=i;c=x_(a|0)|0;i=b;return c|0}function Ew(b,d){b=+b;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;j=i;i=i+400|0;l=g;m=j;a[l]=37;D_(g+1|0,d|0)|0;d=f;h[k>>3]=b;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];dc(m|0,l|0,f|0)|0;f=Fw(m)|0;i=e;return f|0}function Fw(a){a=a|0;var b=0,c=0,d=0;b=i;c=x_(a|0)|0;d=Gw(c)|0;z_(d|0,a|0,c|0)|0;i=b;return d|0}function Gw(b){b=b|0;var d=0,e=0;d=i;e=ee[c[36476>>2]&127](b+1|0)|0;if((e|0)==0){i=d;return e|0}a[e+b|0]=0;i=d;return e|0}function Hw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=i;d=Dw(a)|0;e=Dw(b)|0;f=Gw(e+d|0)|0;z_(f|0,a|0,d|0)|0;z_(f+d|0,b|0,e|0)|0;i=c;return f|0}function Iw(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=t_(c[a>>2]|0,c[b>>2]|0)|0;i=d;return e|0}function Jw(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=(a|0)%100|0;d=(c|0)/10|0;e=(a|0)%10|0;a:do{if((a+999|0)>>>0>1998){f=-1}else{if((((a|0)%1e3|0)+99|0)>>>0>198){f=-1;break}if((e|0)==2){f=-1;break}else if((e|0)==1){if((c+ -50|0)>>>0>9){f=-1;break}}switch(d|0){case 5:{f=1;break a;break};case 0:{f=8;break a;break};case 1:{f=4;break a;break};case 2:{f=4;break a;break};case 4:{f=2;break a;break};case 3:{f=2;break a;break};default:{f=-1;break a}}}}while(0);i=b;return f|0}function Kw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a;e=c[d>>2]|0;if((e|0)!=0){Vc(e|0)|0;c[d>>2]=0}e=a+4|0;f=c[e>>2]|0;if((f|0)!=0){WZ(f);c[e>>2]=0}e=a+8|0;if((c[e>>2]|0)!=0){f=a+12|0;g=0;do{WZ(c[(c[f>>2]|0)+(g<<4)>>2]|0);WZ(c[(c[f>>2]|0)+(g<<4)+4>>2]|0);g=g+1|0;}while(g>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;if((c[d>>2]|0)!=0){d=a+12|0;WZ(c[d>>2]|0);c[d>>2]=0}d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){WZ(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;g=a+40|0;if((e&2147483647|0)!=0){a=e;e=0;while(1){f=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((f|0)==0){h=a}else{WZ(f);h=c[d>>2]|0}f=e+1|0;if(f>>>0<h<<1>>>0){a=h;e=f}else{break}}}c[d>>2]=0;d=c[g>>2]|0;if((d|0)==0){i=b;return}WZ(d);c[g>>2]=0;i=b;return}function Lw(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=i;d=0;e=0;while(1){f=a[b+d|0]|0;if(f<<24>>24==32){g=e}else{a[b+e|0]=f;g=e+1|0}f=d+1|0;if(f>>>0>(x_(b|0)|0)>>>0){break}else{d=f;e=g}}i=c;return}



function qT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;CT(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZP(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ee[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ee[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}ZP(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}ZP(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=ee[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((yT(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){ee[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=qY(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;MV(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=ee[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=ee[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;QP(n);QP(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;QP(n);QP(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;QP(n);QP(m);i=d;return}function rT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];sT(a,0,k,j,f,g,h);i=b;return}function sT(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;DT(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;ZP(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=ee[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=ee[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}ZP(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}ZP(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=ee[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((ET(T,t,u,R,p,B,l,n,h,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){ee[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);g[k>>2]=+pY(L,c[p>>2]|0,j);MV(n,h,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=ee[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=ee[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;QP(o);QP(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;QP(o);QP(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;QP(o);QP(n);i=d;return}function tT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];uT(a,0,k,j,f,g,h);i=b;return}function uT(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;DT(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZP(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=ee[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=ee[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}ZP(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}ZP(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=ee[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((ET(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){ee[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+oY(L,c[p>>2]|0,j);MV(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=ee[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=ee[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;QP(o);QP(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;QP(o);QP(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;QP(o);QP(n);i=d;return}function vT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];wT(a,0,k,j,f,g,h);i=b;return}function wT(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;DT(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZP(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=ee[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=ee[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}ZP(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}ZP(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=ee[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((ET(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){ee[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+nY(L,c[p>>2]|0,j);MV(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=ee[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=ee[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;QP(o);QP(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;QP(o);QP(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;QP(o);QP(n);i=d;return}function xT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+104|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;MQ(o,g);g=o;o=c[g>>2]|0;if(!((c[26642]|0)==-1)){c[l>>2]=106568;c[l+4>>2]=189;c[l+8>>2]=0;BP(106568,l,190)}l=(c[106572>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Ac(4)|0;w=v;AZ(w);x=122136;y=127;Pd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Ac(4)|0;w=v;AZ(w);x=122136;y=127;Pd(v|0,x|0,y|0)}y=m;Ae[c[(c[o>>2]|0)+48>>2]&63](o,105120,105146|0,y)|0;gP(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZP(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0;D=1}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){E=ee[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{E=c[B>>2]|0}if(!((E|0)==-1)){C=m;D=0;break}c[r>>2]=0;C=0;D=1}}while(0);B=c[e>>2]|0;do{if((B|0)==0){F=22}else{v=c[B+12>>2]|0;if((v|0)==(c[B+16>>2]|0)){G=ee[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{G=c[v>>2]|0}if((G|0)==-1){c[e>>2]=0;F=22;break}else{if(D){break}else{H=x;break a}}}}while(0);if((F|0)==22){F=0;if(D){H=x;break}}B=a[p]|0;v=(B&1)==0;if(v){I=(B&255)>>>1}else{I=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(I|0)){if(v){J=(B&255)>>>1;K=(B&255)>>>1}else{B=c[o>>2]|0;J=B;K=B}ZP(p,K<<1,0);if((a[p]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}ZP(p,L,0);if((a[p]&1)==0){M=z}else{M=c[A>>2]|0}c[q>>2]=M+J;N=M}else{N=x}B=C+12|0;v=c[B>>2]|0;w=C+16|0;if((v|0)==(c[w>>2]|0)){O=ee[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{O=c[v>>2]|0}if((yT(O,16,N,q,t,0,n,g,s,y)|0)!=0){H=N;break}v=c[B>>2]|0;if((v|0)==(c[w>>2]|0)){ee[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=N;continue}else{c[B>>2]=v+4;m=C;x=N;continue}}a[H+3|0]=0;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);N=c[26616]|0;c[k>>2]=j;if((aT(H,N,105160,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){P=0;Q=1}else{N=c[k+12>>2]|0;if((N|0)==(c[k+16>>2]|0)){R=ee[c[(c[k>>2]|0)+36>>2]&127](k)|0}else{R=c[N>>2]|0}if(!((R|0)==-1)){P=k;Q=0;break}c[r>>2]=0;P=0;Q=1}}while(0);r=c[e>>2]|0;do{if((r|0)==0){F=60}else{k=c[r+12>>2]|0;if((k|0)==(c[r+16>>2]|0)){S=ee[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{S=c[k>>2]|0}if((S|0)==-1){c[e>>2]=0;F=60;break}if(!Q){break}T=b;U=T;c[U>>2]=P;QP(p);QP(n);i=d;return}}while(0);do{if((F|0)==60){if(Q){break}T=b;U=T;c[U>>2]=P;QP(p);QP(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;T=b;U=T;c[U>>2]=P;QP(p);QP(n);i=d;return}function yT(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(c[m+96>>2]|0)==(b|0);if(!q){if((c[m+100>>2]|0)!=(b|0)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&(b|0)==(h|0)){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+104|0;h=m;while(1){l=h+4|0;if((c[h>>2]|0)==(b|0)){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;m=h>>2;if((h|0)>92){r=-1;i=n;return r|0}do{if((d|0)==16){if((h|0)<88){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;t=a[105120+m|0]|0;c[f>>2]=o+1;a[o]=t;r=0;i=n;return r|0}else if((d|0)==10|(d|0)==8){if((m|0)<(d|0)){break}else{r=-1}i=n;return r|0}}while(0);d=a[105120+m|0]|0;c[f>>2]=o+1;a[o]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function zT(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;MQ(k,d);d=k;k=c[d>>2]|0;if(!((c[26644]|0)==-1)){c[j>>2]=106576;c[j+4>>2]=189;c[j+8>>2]=0;BP(106576,j,190)}j=(c[106580>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Ac(4)|0;n=m;AZ(n);o=122136;p=127;Pd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Ac(4)|0;n=m;AZ(n);o=122136;p=127;Pd(m|0,o|0,p|0)}Ae[c[(c[k>>2]|0)+32>>2]&63](k,105120,105146|0,e)|0;e=c[d>>2]|0;if(!((c[26680]|0)==-1)){c[h>>2]=106720;c[h+4>>2]=189;c[h+8>>2]=0;BP(106720,h,190)}h=(c[106724>>2]|0)+ -1|0;k=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-k>>2>>>0>h>>>0)){q=Ac(4)|0;r=q;AZ(r);s=122136;t=127;Pd(q|0,s|0,t|0)}e=c[k+(h<<2)>>2]|0;if((e|0)==0){q=Ac(4)|0;r=q;AZ(r);s=122136;t=127;Pd(q|0,s|0,t|0)}else{t=e;a[f]=ee[c[(c[e>>2]|0)+16>>2]&127](t)|0;ce[c[(c[e>>2]|0)+20>>2]&127](b,t);gP(c[d>>2]|0)|0;i=g;return}}function AT(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h;k=h+16|0;l=h+32|0;MQ(l,d);d=l;l=c[d>>2]|0;if(!((c[26644]|0)==-1)){c[k>>2]=106576;c[k+4>>2]=189;c[k+8>>2]=0;BP(106576,k,190)}k=(c[106580>>2]|0)+ -1|0;m=c[l+8>>2]|0;if(!((c[l+12>>2]|0)-m>>2>>>0>k>>>0)){n=Ac(4)|0;o=n;AZ(o);p=122136;q=127;Pd(n|0,p|0,q|0)}l=c[m+(k<<2)>>2]|0;if((l|0)==0){n=Ac(4)|0;o=n;AZ(o);p=122136;q=127;Pd(n|0,p|0,q|0)}Ae[c[(c[l>>2]|0)+32>>2]&63](l,105120,105152|0,e)|0;e=c[d>>2]|0;if(!((c[26680]|0)==-1)){c[j>>2]=106720;c[j+4>>2]=189;c[j+8>>2]=0;BP(106720,j,190)}j=(c[106724>>2]|0)+ -1|0;l=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-l>>2>>>0>j>>>0)){r=Ac(4)|0;s=r;AZ(s);t=122136;u=127;Pd(r|0,t|0,u|0)}e=c[l+(j<<2)>>2]|0;if((e|0)==0){r=Ac(4)|0;s=r;AZ(s);t=122136;u=127;Pd(r|0,t|0,u|0)}else{u=e;a[f]=ee[c[(c[e>>2]|0)+12>>2]&127](u)|0;a[g]=ee[c[(c[e>>2]|0)+16>>2]&127](u)|0;ce[c[(c[e>>2]|0)+20>>2]&127](b,u);gP(c[d>>2]|0)|0;i=h;return}}function BT(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if(b<<24>>24==h<<24>>24){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if(b<<24>>24==j<<24>>24){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+32|0;j=o;while(1){r=j+1|0;if((a[j]|0)==b<<24>>24){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;if((j|0)>31){q=-1;i=p;return q|0}o=a[105120+j|0]|0;if((j|0)==23|(j|0)==22){a[e]=80;t=c[g>>2]|0;c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else if((j|0)==24|(j|0)==25){t=c[g>>2]|0;do{if((t|0)!=(f|0)){if((a[t+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else{t=a[e]|0;do{if((o&95|0)==(t<<24>>24|0)){a[e]=t|-128;if((a[d]|0)==0){break}a[d]=0;f=a[k]|0;if((f&1)==0){u=(f&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}f=c[m>>2]|0;if((f-l|0)>=160){break}s=c[n>>2]|0;c[m>>2]=f+4;c[f>>2]=s}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=o;if((j|0)>21){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}return 0}function CT(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+40|0;g=f;h=f+16|0;j=f+32|0;MQ(j,b);b=j;j=c[b>>2]|0;if(!((c[26642]|0)==-1)){c[h>>2]=106568;c[h+4>>2]=189;c[h+8>>2]=0;BP(106568,h,190)}h=(c[106572>>2]|0)+ -1|0;k=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-k>>2>>>0>h>>>0)){l=Ac(4)|0;m=l;AZ(m);n=122136;o=127;Pd(l|0,n|0,o|0)}j=c[k+(h<<2)>>2]|0;if((j|0)==0){l=Ac(4)|0;m=l;AZ(m);n=122136;o=127;Pd(l|0,n|0,o|0)}Ae[c[(c[j>>2]|0)+48>>2]&63](j,105120,105146|0,d)|0;d=c[b>>2]|0;if(!((c[26682]|0)==-1)){c[g>>2]=106728;c[g+4>>2]=189;c[g+8>>2]=0;BP(106728,g,190)}g=(c[106732>>2]|0)+ -1|0;j=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-j>>2>>>0>g>>>0)){p=Ac(4)|0;q=p;AZ(q);r=122136;s=127;Pd(p|0,r|0,s|0)}d=c[j+(g<<2)>>2]|0;if((d|0)==0){p=Ac(4)|0;q=p;AZ(q);r=122136;s=127;Pd(p|0,r|0,s|0)}else{s=d;c[e>>2]=ee[c[(c[d>>2]|0)+16>>2]&127](s)|0;ce[c[(c[d>>2]|0)+20>>2]&127](a,s);gP(c[b>>2]|0)|0;i=f;return}}function DT(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;MQ(k,b);b=k;k=c[b>>2]|0;if(!((c[26642]|0)==-1)){c[j>>2]=106568;c[j+4>>2]=189;c[j+8>>2]=0;BP(106568,j,190)}j=(c[106572>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Ac(4)|0;n=m;AZ(n);o=122136;p=127;Pd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Ac(4)|0;n=m;AZ(n);o=122136;p=127;Pd(m|0,o|0,p|0)}Ae[c[(c[k>>2]|0)+48>>2]&63](k,105120,105152|0,d)|0;d=c[b>>2]|0;if(!((c[26682]|0)==-1)){c[h>>2]=106728;c[h+4>>2]=189;c[h+8>>2]=0;BP(106728,h,190)}h=(c[106732>>2]|0)+ -1|0;k=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-k>>2>>>0>h>>>0)){q=Ac(4)|0;r=q;AZ(r);s=122136;t=127;Pd(q|0,s|0,t|0)}d=c[k+(h<<2)>>2]|0;if((d|0)==0){q=Ac(4)|0;r=q;AZ(r);s=122136;t=127;Pd(q|0,s|0,t|0)}else{t=d;c[e>>2]=ee[c[(c[d>>2]|0)+12>>2]&127](t)|0;c[f>>2]=ee[c[(c[d>>2]|0)+16>>2]&127](t)|0;ce[c[(c[d>>2]|0)+20>>2]&127](a,t);gP(c[b>>2]|0)|0;i=g;return}}function ET(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if((b|0)==(h|0)){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if((b|0)==(j|0)){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+128|0;j=o;while(1){r=j+4|0;if((c[j>>2]|0)==(b|0)){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;o=j>>2;if((j|0)>124){q=-1;i=p;return q|0}t=a[105120+o|0]|0;do{if((o|0)==23|(o|0)==22){a[e]=80}else if((o|0)==24|(o|0)==25){s=c[g>>2]|0;do{if((s|0)!=(f|0)){if((a[s+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=s+1;a[s]=t;q=0;i=p;return q|0}else{b=a[e]|0;if((t&95|0)!=(b<<24>>24|0)){break}a[e]=b|-128;if((a[d]|0)==0){break}a[d]=0;b=a[k]|0;if((b&1)==0){u=(b&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}b=c[m>>2]|0;if((b-l|0)>=160){break}r=c[n>>2]|0;c[m>>2]=b+4;c[b>>2]=r}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=t;if((j|0)>84){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}function FT(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function GT(a){a=a|0;i=i;return}function HT(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];me[p&31](b,d,k,f,g,q);i=j;return}MQ(n,f);f=n;n=c[f>>2]|0;if(!((c[26680]|0)==-1)){c[l>>2]=106720;c[l+4>>2]=189;c[l+8>>2]=0;BP(106720,l,190)}l=(c[106724>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Ac(4)|0;u=t;AZ(u);v=122136;w=127;Pd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Ac(4)|0;u=t;AZ(u);v=122136;w=127;Pd(t|0,v|0,w|0)}w=n;gP(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){ce[c[f+24>>2]&127](o,w)}else{ce[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+1|0;x=f;y=f;z=o+8|0}else{f=o+8|0;x=c[f>>2]|0;y=o+1|0;z=f}f=e;e=o+4|0;h=w;w=x;while(1){if((h&1)==0){A=y;B=(h&255)>>>1}else{A=c[z>>2]|0;B=c[e>>2]|0}if((w|0)==(A+B|0)){break}x=a[w]|0;n=c[f>>2]|0;do{if((n|0)!=0){v=n+24|0;t=c[v>>2]|0;if((t|0)!=(c[n+28>>2]|0)){c[v>>2]=t+1;a[t]=x;break}if(!((re[c[(c[n>>2]|0)+52>>2]&63](n,x&255)|0)==-1)){break}c[f>>2]=0}}while(0);h=a[o]|0;w=w+1|0}c[b>>2]=c[f>>2];QP(o);i=j;return}function IT(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=105368;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=100}}while(0);w=m;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);x=c[26616]|0;c[k>>2]=h;h=JT(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;MQ(q,f);KT(w,y,k,z,o,p,q);gP(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];nM(b,j,z,e,o,f,g);i=d;return}function JT(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;f=Ic(d|0)|0;d=Wc(a|0,b|0,e|0,h|0)|0;if((f|0)==0){i=g;return d|0}Ic(f|0)|0;i=g;return d|0}function KT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[26644]|0)==-1)){c[m>>2]=106576;c[m+4>>2]=189;c[m+8>>2]=0;BP(106576,m,190)}m=(c[106580>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ac(4)|0;r=q;AZ(r);s=122136;t=127;Pd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ac(4)|0;r=q;AZ(r);s=122136;t=127;Pd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[26680]|0)==-1)){c[l>>2]=106720;c[l+4>>2]=189;c[l+8>>2]=0;BP(106720,l,190)}l=(c[106724>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ac(4)|0;v=u;AZ(v);w=122136;x=127;Pd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ac(4)|0;v=u;AZ(v);w=122136;x=127;Pd(u|0,w|0,x|0)}x=s;ce[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){Ae[c[(c[j>>2]|0)+32>>2]&63](t,b,e,f)|0;c[h>>2]=f+(e-b)}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=re[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;z=b+1|0}else{z=b}do{if((e-z|0)>1){if((a[z]|0)!=48){A=z;break}u=z+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){A=z;break}w=re[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+1;a[v]=w;w=re[c[(c[j>>2]|0)+28>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+1;a[u]=w;A=z+2|0}else{A=z}}while(0);do{if((A|0)!=(e|0)){w=e+ -1|0;if(w>>>0>A>>>0){B=A;C=w}else{break}do{w=a[B]|0;a[B]=a[C]|0;a[C]=w;B=B+1|0;C=C+ -1|0;}while(B>>>0<C>>>0)}}while(0);w=ee[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(A>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=A;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){D=o;E=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){D=o;E=q;break}p=c[h>>2]|0;c[h>>2]=p+1;a[p]=w;p=a[n]|0;if((p&1)==0){F=(p&255)>>>1}else{F=c[v>>2]|0}D=0;E=(q>>>0<(F+ -1|0)>>>0)+q|0}}while(0);m=re[c[(c[j>>2]|0)+28>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=m;m=r+1|0;if(m>>>0<e>>>0){o=D+1|0;q=E;r=m}else{break}}}r=f+(A-b)|0;q=c[h>>2]|0;if((r|0)==(q|0)){break}o=q+ -1|0;if(o>>>0>r>>>0){G=r;H=o}else{break}do{o=a[G]|0;a[G]=a[H]|0;a[H]=o;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);if((d|0)==(e|0)){I=c[h>>2]|0;c[g>>2]=I;QP(n);i=k;return}else{I=f+(d-b)|0;c[g>>2]=I;QP(n);i=k;return}}function LT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);y=c[26616]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=JT(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;MQ(r,f);KT(x,z,l,A,p,q,r);gP(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];nM(b,k,A,e,p,f,g);i=d;return}function MT(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=105368;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);v=c[26616]|0;c[k>>2]=h;h=JT(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;MQ(q,f);KT(w,y,k,z,o,p,q);gP(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];nM(b,j,z,e,o,f,g);i=d;return}function NT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);y=c[26616]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=JT(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;MQ(r,f);KT(x,z,l,A,p,q,r);gP(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];nM(b,k,A,e,p,f,g);i=d;return}function OT(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);r=c[26616]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=JT(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=JT(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[106472]|0)==0;if(F){do{if(o){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);r=c[26616]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=PT(s,r,z,n)|0}else{do{if(o){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);o=c[26616]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=PT(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}g_()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=VZ(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}g_()}}while(0);MQ(w,f);QT(N,L,G,P,u,v,w);gP(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];nM(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){WZ(O)}if((J|0)==0){i=d;return}WZ(J);i=d;return}function PT(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Ic(b|0)|0;b=fc(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Ic(e|0)|0;i=f;return b|0}function QT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[26644]|0)==-1)){c[m>>2]=106576;c[m+4>>2]=189;c[m+8>>2]=0;BP(106576,m,190)}m=(c[106580>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ac(4)|0;r=q;AZ(r);s=122136;t=127;Pd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ac(4)|0;r=q;AZ(r);s=122136;t=127;Pd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[26680]|0)==-1)){c[l>>2]=106720;c[l+4>>2]=189;c[l+8>>2]=0;BP(106720,l,190)}l=(c[106724>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ac(4)|0;v=u;AZ(v);w=122136;x=127;Pd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ac(4)|0;v=u;AZ(v);w=122136;x=127;Pd(u|0,w|0,x|0)}x=s;ce[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=re[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=re[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+1;a[l]=v;v=y+2|0;l=re[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);w=A+1|0;if((Uc(l<<24>>24|0,c[26616]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);l=D+1|0;if((Rd(A<<24>>24|0,c[26616]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){Ae[c[(c[j>>2]|0)+32>>2]&63](t,B,C,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(C-B)}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){F=B;G=y}else{break}do{y=a[F]|0;a[F]=a[G]|0;a[G]=y;F=F+1|0;G=G+ -1|0;}while(F>>>0<G>>>0)}}while(0);A=ee[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){H=l;I=v;break}q=c[h>>2]|0;c[h>>2]=q+1;a[q]=A;q=a[n]|0;if((q&1)==0){J=(q&255)>>>1}else{J=c[D>>2]|0}H=0;I=(v>>>0<(J+ -1|0)>>>0)+v|0}else{H=l;I=v}}while(0);o=re[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q]=o;o=w+1|0;if(o>>>0<C>>>0){l=H+1|0;v=I;w=o}else{break}}}w=f+(B-b)|0;v=c[h>>2]|0;if((w|0)==(v|0)){break}l=v+ -1|0;if(l>>>0>w>>>0){K=w;L=l}else{break}do{l=a[K]|0;a[K]=a[L]|0;a[L]=l;K=K+1|0;L=L+ -1|0;}while(K>>>0<L>>>0)}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){K=a[L]|0;if(K<<24>>24==46){break}B=re[c[(c[j>>2]|0)+28>>2]&63](t,K)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;B=L+1|0;if(B>>>0<e>>>0){L=B}else{M=B;break c}}B=ee[c[(c[s>>2]|0)+12>>2]&127](x)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;M=L+1|0}else{M=C}}while(0);Ae[c[(c[j>>2]|0)+32>>2]&63](t,M,e,c[h>>2]|0)|0;t=(c[h>>2]|0)+(u-M)|0;c[h>>2]=t;if((d|0)==(e|0)){N=t;c[g>>2]=N;QP(n);i=k;return}N=f+(d-b)|0;c[g>>2]=N;QP(n);i=k;return}function RT(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);r=c[26616]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=JT(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=JT(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[106472]|0)==0;if(F){do{if(o){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);r=c[26616]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=PT(s,r,z,n)|0}else{do{if(o){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);o=c[26616]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=PT(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}g_()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=VZ(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}g_()}}while(0);MQ(w,f);QT(N,L,G,P,u,v,w);gP(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];nM(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){WZ(O)}if((J|0)==0){i=d;return}WZ(J);i=d;return}function ST(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+40|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=105376;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);s=c[26616]|0;c[k>>2]=h;h=JT(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==32){t=k}else if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else{u=10}}while(0);if((u|0)==10){t=m}u=o;MQ(p,f);r=p;p=c[r>>2]|0;if(!((c[26644]|0)==-1)){c[l>>2]=106576;c[l+4>>2]=189;c[l+8>>2]=0;BP(106576,l,190)}l=(c[106580>>2]|0)+ -1|0;s=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-s>>2>>>0>l>>>0)){v=Ac(4)|0;w=v;AZ(w);x=122136;y=127;Pd(v|0,x|0,y|0)}p=c[s+(l<<2)>>2]|0;if((p|0)==0){v=Ac(4)|0;w=v;AZ(w);x=122136;y=127;Pd(v|0,x|0,y|0)}gP(c[r>>2]|0)|0;Ae[c[(c[p>>2]|0)+32>>2]&63](p,m,k,u)|0;m=o+h|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];nM(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];nM(b,j,u,z,m,f,g);I=j;i=d;return}function TT(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function UT(a){a=a|0;i=i;return}function VT(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];me[p&31](b,d,k,f,g,q);i=j;return}MQ(n,f);f=n;n=c[f>>2]|0;if(!((c[26682]|0)==-1)){c[l>>2]=106728;c[l+4>>2]=189;c[l+8>>2]=0;BP(106728,l,190)}l=(c[106732>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Ac(4)|0;u=t;AZ(u);v=122136;w=127;Pd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Ac(4)|0;u=t;AZ(u);v=122136;w=127;Pd(t|0,v|0,w|0)}w=n;gP(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){ce[c[f+24>>2]&127](o,w)}else{ce[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+4|0;x=f;y=o+8|0;z=f}else{f=o+8|0;x=c[f>>2]|0;y=f;z=o+4|0}f=e;e=w;w=x;while(1){if((e&1)==0){A=z;B=(e&255)>>>1}else{A=c[y>>2]|0;B=c[z>>2]|0}if((w|0)==(A+(B<<2)|0)){break}x=c[w>>2]|0;h=c[f>>2]|0;do{if((h|0)!=0){n=h+24|0;v=c[n>>2]|0;if((v|0)==(c[h+28>>2]|0)){C=re[c[(c[h>>2]|0)+52>>2]&63](h,x)|0}else{c[n>>2]=v+4;c[v>>2]=x;C=x}if(!((C|0)==-1)){break}c[f>>2]=0}}while(0);e=a[o]|0;w=w+4|0}c[b>>2]=c[f>>2];sQ(o);i=j;return}function WT(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=105368;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=100}}while(0);w=m;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);x=c[26616]|0;c[k>>2]=h;h=JT(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;MQ(q,f);XT(w,y,k,z,o,p,q);gP(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];YT(b,j,z,e,o,f,g);i=d;return}function XT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[26642]|0)==-1)){c[m>>2]=106568;c[m+4>>2]=189;c[m+8>>2]=0;BP(106568,m,190)}m=(c[106572>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ac(4)|0;r=q;AZ(r);s=122136;t=127;Pd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ac(4)|0;r=q;AZ(r);s=122136;t=127;Pd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[26682]|0)==-1)){c[l>>2]=106728;c[l+4>>2]=189;c[l+8>>2]=0;BP(106728,l,190)}l=(c[106732>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ac(4)|0;v=u;AZ(v);w=122136;x=127;Pd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ac(4)|0;v=u;AZ(v);w=122136;x=127;Pd(u|0,w|0,x|0)}x=s;ce[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){Ae[c[(c[j>>2]|0)+48>>2]&63](t,b,e,f)|0;w=f+(e-b<<2)|0;c[h>>2]=w;z=w}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=re[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;A=b+1|0}else{A=b}do{if((e-A|0)>1){if((a[A]|0)!=48){B=A;break}u=A+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){B=A;break}w=re[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=w;w=re[c[(c[j>>2]|0)+44>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=w;B=A+2|0}else{B=A}}while(0);do{if((B|0)!=(e|0)){w=e+ -1|0;if(w>>>0>B>>>0){C=B;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D+ -1|0;}while(C>>>0<D>>>0)}}while(0);w=ee[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=B;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){E=o;F=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){E=o;F=q;break}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=w;p=a[n]|0;if((p&1)==0){G=(p&255)>>>1}else{G=c[v>>2]|0}E=0;F=(q>>>0<(G+ -1|0)>>>0)+q|0}}while(0);m=re[c[(c[j>>2]|0)+44>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;H=p+4|0;c[h>>2]=H;c[p>>2]=m;m=r+1|0;if(m>>>0<e>>>0){o=E+1|0;q=F;r=m}else{I=H;break}}}else{I=c[h>>2]|0}r=f+(B-b<<2)|0;if((r|0)==(I|0)){z=I;break}q=I+ -4|0;if(q>>>0>r>>>0){J=r;K=q}else{z=I;break}while(1){q=c[J>>2]|0;c[J>>2]=c[K>>2];c[K>>2]=q;q=J+4|0;r=K+ -4|0;if(q>>>0<r>>>0){K=r;J=q}else{z=I;break}}}}while(0);if((d|0)==(e|0)){L=z;c[g>>2]=L;QP(n);i=k;return}L=f+(d-b<<2)|0;c[g>>2]=L;QP(n);i=k;return}function YT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=d;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if((ie[c[(c[d>>2]|0)+48>>2]&63](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){rQ(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}if((ie[c[(c[d>>2]|0)+48>>2]&63](d,r,q)|0)==(q|0)){sQ(l);break}c[m>>2]=0;c[b>>2]=0;sQ(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if((ie[c[(c[d>>2]|0)+48>>2]&63](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function ZT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+168|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=100}}while(0);x=n;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);w=c[26616]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=JT(x,22,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;MQ(r,f);XT(x,z,l,A,p,q,r);gP(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];YT(b,k,A,e,p,f,g);i=d;return}function _T(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=105368;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);v=c[26616]|0;c[k>>2]=h;h=JT(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;MQ(q,f);XT(w,y,k,z,o,p,q);gP(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];YT(b,j,z,e,o,f,g);i=d;return}function $T(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+176|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=117}}while(0);x=n;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);w=c[26616]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=JT(x,23,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;MQ(r,f);XT(x,z,l,A,p,q,r);gP(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];YT(b,k,A,e,p,f,g);i=d;return}function aU(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);r=c[26616]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=JT(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=JT(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[106472]|0)==0;if(F){do{if(o){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);r=c[26616]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=PT(s,r,z,n)|0}else{do{if(o){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);o=c[26616]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=PT(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}g_()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=VZ(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}g_()}}while(0);MQ(w,f);bU(N,L,G,P,u,v,w);gP(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];YT(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){WZ(O)}if((J|0)==0){i=d;return}WZ(J);i=d;return}function bU(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[26642]|0)==-1)){c[m>>2]=106568;c[m+4>>2]=189;c[m+8>>2]=0;BP(106568,m,190)}m=(c[106572>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ac(4)|0;r=q;AZ(r);s=122136;t=127;Pd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ac(4)|0;r=q;AZ(r);s=122136;t=127;Pd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[26682]|0)==-1)){c[l>>2]=106728;c[l+4>>2]=189;c[l+8>>2]=0;BP(106728,l,190)}l=(c[106732>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ac(4)|0;v=u;AZ(v);w=122136;x=127;Pd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ac(4)|0;v=u;AZ(v);w=122136;x=127;Pd(u|0,w|0,x|0)}x=s;ce[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=re[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=re[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=v;v=y+2|0;l=re[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);w=A+1|0;if((Uc(l<<24>>24|0,c[26616]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);l=D+1|0;if((Rd(A<<24>>24|0,c[26616]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){Ae[c[(c[j>>2]|0)+48>>2]&63](t,B,C,c[h>>2]|0)|0;y=(c[h>>2]|0)+(C-B<<2)|0;c[h>>2]=y;F=y}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){G=B;H=y}else{break}do{y=a[G]|0;a[G]=a[H]|0;a[H]=y;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);A=ee[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){I=l;J=v;break}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=A;q=a[n]|0;if((q&1)==0){K=(q&255)>>>1}else{K=c[D>>2]|0}I=0;J=(v>>>0<(K+ -1|0)>>>0)+v|0}else{I=l;J=v}}while(0);o=re[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;r=q+4|0;c[h>>2]=r;c[q>>2]=o;o=w+1|0;if(o>>>0<C>>>0){l=I+1|0;v=J;w=o}else{L=r;break}}}else{L=c[h>>2]|0}w=f+(B-b<<2)|0;if((w|0)==(L|0)){F=L;break}v=L+ -4|0;if(v>>>0>w>>>0){M=w;N=v}else{F=L;break}while(1){v=c[M>>2]|0;c[M>>2]=c[N>>2];c[N>>2]=v;v=M+4|0;w=N+ -4|0;if(v>>>0<w>>>0){N=w;M=v}else{F=L;break}}}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){M=a[L]|0;if(M<<24>>24==46){break}N=re[c[(c[j>>2]|0)+44>>2]&63](t,M)|0;M=c[h>>2]|0;B=M+4|0;c[h>>2]=B;c[M>>2]=N;N=L+1|0;if(N>>>0<e>>>0){L=N}else{O=B;P=N;break c}}N=ee[c[(c[s>>2]|0)+12>>2]&127](x)|0;B=c[h>>2]|0;M=B+4|0;c[h>>2]=M;c[B>>2]=N;O=M;P=L+1|0}else{O=F;P=C}}while(0);Ae[c[(c[j>>2]|0)+48>>2]&63](t,P,e,O)|0;O=(c[h>>2]|0)+(u-P<<2)|0;c[h>>2]=O;if((d|0)==(e|0)){Q=O;c[g>>2]=Q;QP(n);i=k;return}Q=f+(d-b<<2)|0;c[g>>2]=Q;QP(n);i=k;return}function cU(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);r=c[26616]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=JT(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=JT(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[106472]|0)==0;if(F){do{if(o){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);r=c[26616]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=PT(s,r,z,n)|0}else{do{if(o){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);o=c[26616]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=PT(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}g_()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=VZ(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}g_()}}while(0);MQ(w,f);bU(N,L,G,P,u,v,w);gP(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];YT(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){WZ(O)}if((J|0)==0){i=d;return}WZ(J);i=d;return}function dU(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+152|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=105376;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);s=c[26616]|0;c[k>>2]=h;h=JT(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==32){t=k}else if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else{u=10}}while(0);if((u|0)==10){t=m}MQ(p,f);u=p;p=c[u>>2]|0;if(!((c[26642]|0)==-1)){c[l>>2]=106568;c[l+4>>2]=189;c[l+8>>2]=0;BP(106568,l,190)}l=(c[106572>>2]|0)+ -1|0;r=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-r>>2>>>0>l>>>0)){v=Ac(4)|0;w=v;AZ(w);x=122136;y=127;Pd(v|0,x|0,y|0)}p=c[r+(l<<2)>>2]|0;if((p|0)==0){v=Ac(4)|0;w=v;AZ(w);x=122136;y=127;Pd(v|0,x|0,y|0)}gP(c[u>>2]|0)|0;u=o;Ae[c[(c[p>>2]|0)+48>>2]&63](p,m,k,u)|0;m=o+(h<<2)|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];YT(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n<<2)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];YT(b,j,u,z,m,f,g);I=j;i=d;return}function eU(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;n=i;i=i+64|0;o=n;p=n+8|0;q=n+16|0;r=n+32|0;s=n+40|0;t=n+48|0;u=n+56|0;MQ(r,h);v=r;r=c[v>>2]|0;if(!((c[26644]|0)==-1)){c[q>>2]=106576;c[q+4>>2]=189;c[q+8>>2]=0;BP(106576,q,190)}q=(c[106580>>2]|0)+ -1|0;w=c[r+8>>2]|0;if(!((c[r+12>>2]|0)-w>>2>>>0>q>>>0)){x=Ac(4)|0;y=x;AZ(y);z=122136;A=127;Pd(x|0,z|0,A|0)}r=c[w+(q<<2)>>2]|0;if((r|0)==0){x=Ac(4)|0;y=x;AZ(y);z=122136;A=127;Pd(x|0,z|0,A|0)}A=r;gP(c[v>>2]|0)|0;c[j>>2]=0;v=f;a:do{if((l|0)==(m|0)){B=65}else{z=g;x=r+8|0;y=t;q=u;w=s;C=l;D=0;b:while(1){E=D;while(1){if((E|0)!=0){B=65;break a}F=c[v>>2]|0;do{if((F|0)==0){G=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){G=F;break}if(!((ee[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){G=F;break}c[v>>2]=0;G=0}}while(0);F=(G|0)==0;H=c[z>>2]|0;c:do{if((H|0)==0){B=19}else{do{if((c[H+12>>2]|0)==(c[H+16>>2]|0)){if(!((ee[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1)){break}c[z>>2]=0;B=19;break c}}while(0);if(F){I=H}else{B=20;break b}}}while(0);if((B|0)==19){B=0;if(F){B=20;break b}else{I=0}}if((ie[c[(c[r>>2]|0)+36>>2]&63](A,a[C]|0,0)|0)<<24>>24==37){B=22;break}H=a[C]|0;if(H<<24>>24>-1){J=c[x>>2]|0;if(!((b[J+(H<<24>>24<<1)>>1]&8192)==0)){K=C;B=33;break}}L=G+12|0;H=c[L>>2]|0;M=G+16|0;if((H|0)==(c[M>>2]|0)){N=(ee[c[(c[G>>2]|0)+36>>2]&127](G)|0)&255}else{N=a[H]|0}H=re[c[(c[r>>2]|0)+12>>2]&63](A,N)|0;if(H<<24>>24==(re[c[(c[r>>2]|0)+12>>2]&63](A,a[C]|0)|0)<<24>>24){B=60;break}c[j>>2]=4;E=4}d:do{if((B|0)==22){B=0;E=C+1|0;if((E|0)==(m|0)){B=23;break b}H=ie[c[(c[r>>2]|0)+36>>2]&63](A,a[E]|0,0)|0;if(H<<24>>24==48|H<<24>>24==69){O=C+2|0;if((O|0)==(m|0)){B=26;break b}P=O;Q=ie[c[(c[r>>2]|0)+36>>2]&63](A,a[O]|0,0)|0;R=H}else{P=E;Q=H;R=0}H=c[(c[e>>2]|0)+36>>2]|0;c[y>>2]=G;c[q>>2]=I;E=p;O=t;c[E+0>>2]=c[O+0>>2];O=o;E=u;c[O+0>>2]=c[E+0>>2];qe[H&3](s,e,p,o,h,j,k,Q,R);c[v>>2]=c[w>>2];S=P+1|0}else if((B|0)==33){while(1){B=0;H=K+1|0;if((H|0)==(m|0)){T=m;break}E=a[H]|0;if(!(E<<24>>24>-1)){T=H;break}if((b[J+(E<<24>>24<<1)>>1]&8192)==0){T=H;break}else{K=H;B=33}}F=G;H=I;E=I;while(1){do{if((F|0)==0){U=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){U=F;break}if(!((ee[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){U=F;break}c[v>>2]=0;U=0}}while(0);O=(U|0)==0;do{if((E|0)==0){V=H;B=46}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(O){W=H;X=E;break}else{S=T;break d}}if((ee[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[z>>2]=0;V=0;B=46;break}else{if(O^(H|0)==0){W=H;X=H;break}else{S=T;break d}}}}while(0);if((B|0)==46){B=0;if(O){S=T;break d}else{W=V;X=0}}Y=U+12|0;Z=c[Y>>2]|0;_=U+16|0;if((Z|0)==(c[_>>2]|0)){$=(ee[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{$=a[Z]|0}if(!($<<24>>24>-1)){S=T;break d}if((b[(c[x>>2]|0)+($<<24>>24<<1)>>1]&8192)==0){S=T;break d}Z=c[Y>>2]|0;if((Z|0)==(c[_>>2]|0)){ee[c[(c[U>>2]|0)+40>>2]&127](U)|0;F=U;H=W;E=X;continue}else{c[Y>>2]=Z+1;F=U;H=W;E=X;continue}}}else if((B|0)==60){B=0;E=c[L>>2]|0;if((E|0)==(c[M>>2]|0)){ee[c[(c[G>>2]|0)+40>>2]&127](G)|0}else{c[L>>2]=E+1}S=C+1|0}}while(0);if((S|0)==(m|0)){B=65;break a}C=S;D=c[j>>2]|0}if((B|0)==20){c[j>>2]=4;aa=G;break}else if((B|0)==23){c[j>>2]=4;aa=G;break}else if((B|0)==26){c[j>>2]=4;aa=G;break}}}while(0);if((B|0)==65){aa=c[v>>2]|0}v=f;do{if((aa|0)==0){ba=0}else{if((c[aa+12>>2]|0)!=(c[aa+16>>2]|0)){ba=aa;break}if(!((ee[c[(c[aa>>2]|0)+36>>2]&127](aa)|0)==-1)){ba=aa;break}c[v>>2]=0;ba=0}}while(0);v=(ba|0)==0;aa=g;g=c[aa>>2]|0;e:do{if((g|0)==0){B=75}else{do{if((c[g+12>>2]|0)==(c[g+16>>2]|0)){if(!((ee[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1)){break}c[aa>>2]=0;B=75;break e}}while(0);if(!v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);do{if((B|0)==75){if(v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ca=d;da=ca;c[da>>2]=ba;i=n;return}function fU(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function gU(a){a=a|0;i=i;return}function hU(a){a=a|0;i=i;return 2}function iU(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];eU(a,b,l,k,f,g,h,105480,105488|0);i=j;return}function jU(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=ee[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+1|0;s=q+1|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+t|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];eU(b,d,m,l,g,h,j,s,q);i=k;return}function kU(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;MQ(n,f);f=n;n=c[f>>2]|0;if(!((c[26644]|0)==-1)){c[m>>2]=106576;c[m+4>>2]=189;c[m+8>>2]=0;BP(106576,m,190)}m=(c[106580>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ac(4)|0;q=p;AZ(q);r=122136;s=127;Pd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ac(4)|0;q=p;AZ(q);r=122136;s=127;Pd(p|0,r|0,s|0)}s=n;gP(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ee[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=HS(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function lU(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;MQ(n,f);f=n;n=c[f>>2]|0;if(!((c[26644]|0)==-1)){c[m>>2]=106576;c[m+4>>2]=189;c[m+8>>2]=0;BP(106576,m,190)}m=(c[106580>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ac(4)|0;q=p;AZ(q);r=122136;s=127;Pd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ac(4)|0;q=p;AZ(q);r=122136;s=127;Pd(p|0,r|0,s|0)}s=n;gP(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ee[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=HS(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function mU(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;MQ(m,f);f=m;m=c[f>>2]|0;if(!((c[26644]|0)==-1)){c[l>>2]=106576;c[l+4>>2]=189;c[l+8>>2]=0;BP(106576,l,190)}l=(c[106580>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Ac(4)|0;p=o;AZ(p);q=122136;r=127;Pd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Ac(4)|0;p=o;AZ(p);q=122136;r=127;Pd(o|0,q|0,r|0)}r=m;gP(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=rU(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function nU(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;MQ(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[26644]|0)==-1)){c[ba>>2]=106576;c[ba+4>>2]=189;c[ba+8>>2]=0;BP(106576,ba,190)}ba=(c[106580>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Ac(4)|0;Ga=Fa;AZ(Ga);Ha=122136;Ia=127;Pd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Ac(4)|0;Ga=Fa;AZ(Ga);Ha=122136;Ia=127;Pd(Fa|0,Ha|0,Ia|0)}Ia=ca;gP(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 65:case 97:{Da=c[f>>2]|0;ca=d+8|0;Ha=ee[c[c[ca>>2]>>2]&127](ca)|0;c[aa>>2]=Da;c[Q+0>>2]=c[aa+0>>2];Da=(HS(e,Q,Ha,Ha+168|0,Ia,h,0)|0)-Ha|0;if((Da|0)>=168){break a}c[j+24>>2]=((Da|0)/12|0|0)%7|0;break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=rU(e,w,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=Ha|4;break a}break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Ha=rU(e,D,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Ha|0)<60){c[j+4>>2]=Ha;break a}else{c[h>>2]=Da|4;break a}break};case 82:{Da=e;c[sa>>2]=c[Da>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];eU(ra,d,y,x,g,h,j,105520,105525|0);c[Da>>2]=c[ra>>2];break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Da=rU(e,H,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<24){c[j+8>>2]=Da;break a}else{c[h>>2]=Ha|4;break a}break};case 101:case 100:{Ha=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Da=rU(e,M,h,Ia,2)|0;ca=c[h>>2]|0;do{if((ca&4|0)==0){if(!((Da+ -1|0)>>>0<31)){break}c[Ha>>2]=Da;break a}}while(0);c[h>>2]=ca|4;break};case 70:{Da=e;c[ka>>2]=c[Da>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];eU(ja,d,J,I,g,h,j,105496,105504|0);c[Da>>2]=c[ja>>2];break};case 68:{Da=e;c[ha>>2]=c[Da>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];eU(ga,d,L,K,g,h,j,105488,105496|0);c[Da>>2]=c[ga>>2];break};case 99:{Da=d+8|0;Ha=ee[c[(c[Da>>2]|0)+12>>2]&127](Da)|0;Da=e;c[ea>>2]=c[Da>>2];c[fa>>2]=c[f>>2];Fa=a[Ha]|0;if((Fa&1)==0){Ja=Ha+1|0;Ka=Ha+1|0;La=(Fa&255)>>>1}else{Fa=c[Ha+8>>2]|0;Ja=Fa;Ka=Fa;La=c[Ha+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];eU(da,d,O,N,g,h,j,Ka,Ja+La|0);c[Da>>2]=c[da>>2];break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];Da=rU(e,t,h,Ia,1)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<7){c[j+24>>2]=Da;break a}else{c[h>>2]=Ha|4;break a}break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];oU(0,e,C,h,Ia);break};case 84:{Ha=e;c[va>>2]=c[Ha>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];eU(ua,d,v,u,g,h,j,105528,105536|0);c[Ha>>2]=c[ua>>2];break};case 120:{Ha=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];oe[Ha&63](b,d,s,r,g,h,j);i=l;return};case 88:{Ha=d+8|0;Da=ee[c[(c[Ha>>2]|0)+24>>2]&127](Ha)|0;Ha=e;c[Aa>>2]=c[Ha>>2];c[Ba>>2]=c[f>>2];Fa=a[Da]|0;if((Fa&1)==0){Ma=Da+1|0;Na=Da+1|0;Oa=(Fa&255)>>>1}else{Fa=c[Da+8>>2]|0;Ma=Fa;Na=Fa;Oa=c[Da+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];eU(za,d,q,p,g,h,j,Na,Ma+Oa|0);c[Ha>>2]=c[za>>2];break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];qU(0,e,m,h,Ia);break};case 114:{Ha=e;c[pa>>2]=c[Ha>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];eU(oa,d,A,z,g,h,j,105504,105515|0);c[Ha>>2]=c[oa>>2];break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Ha=rU(e,E,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Ha|0)<13){c[j+16>>2]=Ha+ -1;break a}else{c[h>>2]=Da|4;break a}break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Da=rU(e,F,h,Ia,3)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<366){c[j+28>>2]=Da;break a}else{c[h>>2]=Ha|4;break a}break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];pU(d,j+8|0,e,B,h,Ia);break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Ha=rU(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Ha|0)<69){Pa=Ha+2e3|0}else{Pa=(Ha+ -69|0)>>>0<31?Ha+1900|0:Ha}c[j+20>>2]=Pa+ -1900;break};case 104:case 66:case 98:{Ha=c[f>>2]|0;Da=d+8|0;Fa=ee[c[(c[Da>>2]|0)+4>>2]&127](Da)|0;c[$>>2]=Ha;c[P+0>>2]=c[$+0>>2];Ha=(HS(e,P,Fa,Fa+288|0,Ia,h,0)|0)-Fa|0;if((Ha|0)>=288){break a}c[j+16>>2]=((Ha|0)/12|0|0)%12|0;break};case 73:{Ha=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Fa=rU(e,G,h,Ia,2)|0;Da=c[h>>2]|0;do{if((Da&4|0)==0){if(!((Fa+ -1|0)>>>0<12)){break}c[Ha>>2]=Fa;break a}}while(0);c[h>>2]=Da|4;break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Fa=rU(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Fa+ -1900;break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function oU(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;j=e;e=f;f=h+8|0;a:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if((ee[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;do{if((l|0)==0){m=12}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(h){n=l;break}else{o=l;break a}}if((ee[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;m=12;break}else{if(h){n=l;break}else{o=l;break a}}}}while(0);if((m|0)==12){m=0;if(h){o=0;break}else{n=0}}l=c[j>>2]|0;p=c[l+12>>2]|0;if((p|0)==(c[l+16>>2]|0)){q=(ee[c[(c[l>>2]|0)+36>>2]&127](l)|0)&255}else{q=a[p]|0}if(!(q<<24>>24>-1)){o=n;break}if((b[(c[f>>2]|0)+(q<<24>>24<<1)>>1]&8192)==0){o=n;break}p=c[j>>2]|0;l=p+12|0;r=c[l>>2]|0;if((r|0)==(c[p+16>>2]|0)){ee[c[(c[p>>2]|0)+40>>2]&127](p)|0;continue}else{c[l>>2]=r+1;continue}}n=c[j>>2]|0;do{if((n|0)==0){s=0}else{if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){s=n;break}if((ee[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1){c[j>>2]=0;s=0;break}else{s=c[j>>2]|0;break}}}while(0);j=(s|0)==0;b:do{if((o|0)==0){m=32}else{do{if((c[o+12>>2]|0)==(c[o+16>>2]|0)){if(!((ee[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1)){break}c[e>>2]=0;m=32;break b}}while(0);if(!j){break}i=d;return}}while(0);do{if((m|0)==32){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function pU(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=ee[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=HS(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function qU(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;b=i;h=d;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if((ee[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e;e=c[j>>2]|0;a:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((ee[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[j>>2]=0;k=11;break a}}while(0);if(d){l=e}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){m=(ee[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{m=a[e]|0}if(!((ie[c[(c[g>>2]|0)+36>>2]&63](g,m,0)|0)<<24>>24==37)){c[f>>2]=c[f>>2]|4;i=b;return}m=c[h>>2]|0;g=m+12|0;e=c[g>>2]|0;if((e|0)==(c[m+16>>2]|0)){ee[c[(c[m>>2]|0)+40>>2]&127](m)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){n=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){n=e;break}if((ee[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[h>>2]=0;n=0;break}else{n=c[h>>2]|0;break}}}while(0);h=(n|0)==0;b:do{if((l|0)==0){k=31}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if(!((ee[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){break}c[j>>2]=0;k=31;break b}}while(0);if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function rU(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=d;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if((ee[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e;e=c[l>>2]|0;a:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((ee[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[l>>2]=0;m=11;break a}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=(ee[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>-1){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=(ie[c[(c[g>>2]|0)+36>>2]&63](g,p,0)|0)<<24>>24;q=c[k>>2]|0;r=q+12|0;s=c[r>>2]|0;if((s|0)==(c[q+16>>2]|0)){ee[c[(c[q>>2]|0)+40>>2]&127](q)|0;t=h;u=n;v=n;w=d}else{c[r>>2]=s+1;t=h;u=n;v=n;w=d}while(1){x=w+ -48|0;d=t+ -1|0;s=c[k>>2]|0;do{if((s|0)==0){y=0}else{if((c[s+12>>2]|0)!=(c[s+16>>2]|0)){y=s;break}if((ee[c[(c[s>>2]|0)+36>>2]&127](s)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);s=(y|0)==0;do{if((v|0)==0){z=u;A=0}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){z=u;A=v;break}if(!((ee[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1)){z=u;A=u;break}c[l>>2]=0;z=0;A=0}}while(0);B=c[k>>2]|0;if(!((s^(A|0)==0)&(d|0)>0)){m=40;break}r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){C=(ee[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[r]|0}if(!(C<<24>>24>-1)){o=x;m=52;break}if((b[(c[e>>2]|0)+(C<<24>>24<<1)>>1]&2048)==0){o=x;m=52;break}r=((ie[c[(c[g>>2]|0)+36>>2]&63](g,C,0)|0)<<24>>24)+(x*10|0)|0;q=c[k>>2]|0;D=q+12|0;E=c[D>>2]|0;if((E|0)==(c[q+16>>2]|0)){ee[c[(c[q>>2]|0)+40>>2]&127](q)|0;F=d;u=z;v=A;w=r;t=F;continue}else{c[D>>2]=E+1;F=d;u=z;v=A;w=r;t=F;continue}}if((m|0)==40){do{if((B|0)==0){G=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){G=B;break}if((ee[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);e=(G|0)==0;b:do{if((z|0)==0){m=50}else{do{if((c[z+12>>2]|0)==(c[z+16>>2]|0)){if(!((ee[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1)){break}c[l>>2]=0;m=50;break b}}while(0);if(e){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==50){if(e){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==52){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function sU(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;l=i;i=i+64|0;m=l;n=l+8|0;o=l+16|0;p=l+32|0;q=l+40|0;r=l+48|0;s=l+56|0;MQ(p,f);t=p;p=c[t>>2]|0;if(!((c[26642]|0)==-1)){c[o>>2]=106568;c[o+4>>2]=189;c[o+8>>2]=0;BP(106568,o,190)}o=(c[106572>>2]|0)+ -1|0;u=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-u>>2>>>0>o>>>0)){v=Ac(4)|0;w=v;AZ(w);x=122136;y=127;Pd(v|0,x|0,y|0)}p=c[u+(o<<2)>>2]|0;if((p|0)==0){v=Ac(4)|0;w=v;AZ(w);x=122136;y=127;Pd(v|0,x|0,y|0)}y=p;gP(c[t>>2]|0)|0;c[g>>2]=0;t=d;a:do{if((j|0)==(k|0)){z=69}else{x=e;v=r;w=s;o=q;u=j;A=0;b:while(1){B=A;while(1){if((B|0)!=0){z=69;break a}C=c[t>>2]|0;do{if((C|0)==0){D=0;E=1}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){G=ee[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[F>>2]|0}if(!((G|0)==-1)){D=C;E=0;break}c[t>>2]=0;D=0;E=1}}while(0);C=c[x>>2]|0;do{if((C|0)==0){z=22}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){H=ee[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{H=c[F>>2]|0}if((H|0)==-1){c[x>>2]=0;z=22;break}else{if(E){I=C;break}else{z=24;break b}}}}while(0);if((z|0)==22){z=0;if(E){z=24;break b}else{I=0}}if((ie[c[(c[p>>2]|0)+52>>2]&63](y,c[u>>2]|0,0)|0)<<24>>24==37){z=26;break}if(ie[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[u>>2]|0)|0){J=u;z=36;break}K=D+12|0;C=c[K>>2]|0;L=D+16|0;if((C|0)==(c[L>>2]|0)){M=ee[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{M=c[C>>2]|0}C=re[c[(c[p>>2]|0)+28>>2]&63](y,M)|0;if((C|0)==(re[c[(c[p>>2]|0)+28>>2]&63](y,c[u>>2]|0)|0)){z=64;break}c[g>>2]=4;B=4}c:do{if((z|0)==26){z=0;B=u+4|0;if((B|0)==(k|0)){z=27;break b}C=ie[c[(c[p>>2]|0)+52>>2]&63](y,c[B>>2]|0,0)|0;if(C<<24>>24==48|C<<24>>24==69){F=u+8|0;if((F|0)==(k|0)){z=30;break b}N=F;O=ie[c[(c[p>>2]|0)+52>>2]&63](y,c[F>>2]|0,0)|0;P=C}else{N=B;O=C;P=0}C=c[(c[b>>2]|0)+36>>2]|0;c[v>>2]=D;c[w>>2]=I;B=n;F=r;c[B+0>>2]=c[F+0>>2];F=m;B=s;c[F+0>>2]=c[B+0>>2];qe[C&3](q,b,n,m,f,g,h,O,P);c[t>>2]=c[o>>2];Q=N+4|0}else if((z|0)==36){while(1){z=0;C=J+4|0;if((C|0)==(k|0)){R=k;break}if(ie[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[C>>2]|0)|0){J=C;z=36}else{R=C;break}}C=D;B=I;F=I;while(1){do{if((C|0)==0){S=0;T=1}else{U=c[C+12>>2]|0;if((U|0)==(c[C+16>>2]|0)){V=ee[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{V=c[U>>2]|0}if(!((V|0)==-1)){S=C;T=0;break}c[t>>2]=0;S=0;T=1}}while(0);do{if((F|0)==0){W=B;z=51}else{U=c[F+12>>2]|0;if((U|0)==(c[F+16>>2]|0)){X=ee[c[(c[F>>2]|0)+36>>2]&127](F)|0}else{X=c[U>>2]|0}if((X|0)==-1){c[x>>2]=0;W=0;z=51;break}else{if(T^(B|0)==0){Y=B;Z=B;break}else{Q=R;break c}}}}while(0);if((z|0)==51){z=0;if(T){Q=R;break c}else{Y=W;Z=0}}U=S+12|0;_=c[U>>2]|0;$=S+16|0;if((_|0)==(c[$>>2]|0)){aa=ee[c[(c[S>>2]|0)+36>>2]&127](S)|0}else{aa=c[_>>2]|0}if(!(ie[c[(c[p>>2]|0)+12>>2]&63](y,8192,aa)|0)){Q=R;break c}_=c[U>>2]|0;if((_|0)==(c[$>>2]|0)){ee[c[(c[S>>2]|0)+40>>2]&127](S)|0;C=S;B=Y;F=Z;continue}else{c[U>>2]=_+4;C=S;B=Y;F=Z;continue}}}else if((z|0)==64){z=0;F=c[K>>2]|0;if((F|0)==(c[L>>2]|0)){ee[c[(c[D>>2]|0)+40>>2]&127](D)|0}else{c[K>>2]=F+4}Q=u+4|0}}while(0);if((Q|0)==(k|0)){z=69;break a}u=Q;A=c[g>>2]|0}if((z|0)==24){c[g>>2]=4;ba=D;break}else if((z|0)==27){c[g>>2]=4;ba=D;break}else if((z|0)==30){c[g>>2]=4;ba=D;break}}}while(0);if((z|0)==69){ba=c[t>>2]|0}t=d;do{if((ba|0)==0){ca=0;da=1}else{d=c[ba+12>>2]|0;if((d|0)==(c[ba+16>>2]|0)){ea=ee[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ea=c[d>>2]|0}if(!((ea|0)==-1)){ca=ba;da=0;break}c[t>>2]=0;ca=0;da=1}}while(0);t=e;e=c[t>>2]|0;do{if((e|0)==0){z=82}else{ba=c[e+12>>2]|0;if((ba|0)==(c[e+16>>2]|0)){fa=ee[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{fa=c[ba>>2]|0}if((fa|0)==-1){c[t>>2]=0;z=82;break}if(!da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);do{if((z|0)==82){if(da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;ga=a;ha=ga;c[ha>>2]=ca;i=l;return}function tU(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function uU(a){a=a|0;i=i;return}function vU(a){a=a|0;i=i;return 2}function wU(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];sU(a,b,l,k,f,g,h,105632,105664|0);i=j;return}function xU(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=ee[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+4|0;s=q+4|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+(t<<2)|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];sU(b,d,m,l,g,h,j,s,q);i=k;return}function yU(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;MQ(n,f);f=n;n=c[f>>2]|0;if(!((c[26642]|0)==-1)){c[m>>2]=106568;c[m+4>>2]=189;c[m+8>>2]=0;BP(106568,m,190)}m=(c[106572>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ac(4)|0;q=p;AZ(q);r=122136;s=127;Pd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ac(4)|0;q=p;AZ(q);r=122136;s=127;Pd(p|0,r|0,s|0)}s=n;gP(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ee[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=eT(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function zU(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;MQ(n,f);f=n;n=c[f>>2]|0;if(!((c[26642]|0)==-1)){c[m>>2]=106568;c[m+4>>2]=189;c[m+8>>2]=0;BP(106568,m,190)}m=(c[106572>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ac(4)|0;q=p;AZ(q);r=122136;s=127;Pd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ac(4)|0;q=p;AZ(q);r=122136;s=127;Pd(p|0,r|0,s|0)}s=n;gP(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ee[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=eT(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function AU(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;MQ(m,f);f=m;m=c[f>>2]|0;if(!((c[26642]|0)==-1)){c[l>>2]=106568;c[l+4>>2]=189;c[l+8>>2]=0;BP(106568,l,190)}l=(c[106572>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Ac(4)|0;p=o;AZ(p);q=122136;r=127;Pd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Ac(4)|0;p=o;AZ(p);q=122136;r=127;Pd(o|0,q|0,r|0)}r=m;gP(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=FU(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function BU(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;MQ(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[26642]|0)==-1)){c[ba>>2]=106568;c[ba+4>>2]=189;c[ba+8>>2]=0;BP(106568,ba,190)}ba=(c[106572>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Ac(4)|0;Ga=Fa;AZ(Ga);Ha=122136;Ia=127;Pd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Ac(4)|0;Ga=Fa;AZ(Ga);Ha=122136;Ia=127;Pd(Fa|0,Ha|0,Ia|0)}Ia=ca;gP(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 73:{Da=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];ca=FU(e,G,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((ca+ -1|0)>>>0<12)){break}c[Da>>2]=ca;break a}}while(0);c[h>>2]=Ha|4;break};case 84:{ca=e;c[va>>2]=c[ca>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];sU(ua,d,v,u,g,h,j,105800,105832|0);c[ca>>2]=c[ua>>2];break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];ca=FU(e,w,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<61){c[j>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Da=FU(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<60){c[j+4>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 104:case 66:case 98:{ca=c[f>>2]|0;Da=d+8|0;Fa=ee[c[(c[Da>>2]|0)+4>>2]&127](Da)|0;c[$>>2]=ca;c[P+0>>2]=c[$+0>>2];ca=(eT(e,P,Fa,Fa+288|0,Ia,h,0)|0)-Fa|0;if((ca|0)>=288){break a}c[j+16>>2]=((ca|0)/12|0|0)%12|0;break};case 82:{ca=e;c[sa>>2]=c[ca>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];sU(ra,d,y,x,g,h,j,105776,105796|0);c[ca>>2]=c[ra>>2];break};case 65:case 97:{ca=c[f>>2]|0;Fa=d+8|0;Da=ee[c[c[Fa>>2]>>2]&127](Fa)|0;c[aa>>2]=ca;c[Q+0>>2]=c[aa+0>>2];ca=(eT(e,Q,Da,Da+168|0,Ia,h,0)|0)-Da|0;if((ca|0)>=168){break a}c[j+24>>2]=((ca|0)/12|0|0)%7|0;break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];ca=FU(e,H,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<24){c[j+8>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 99:{Da=d+8|0;ca=ee[c[(c[Da>>2]|0)+12>>2]&127](Da)|0;Da=e;c[ea>>2]=c[Da>>2];c[fa>>2]=c[f>>2];Fa=a[ca]|0;if((Fa&1)==0){Ja=ca+4|0;Ka=ca+4|0;La=(Fa&255)>>>1}else{Fa=c[ca+8>>2]|0;Ja=Fa;Ka=Fa;La=c[ca+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];sU(da,d,O,N,g,h,j,Ka,Ja+(La<<2)|0);c[Da>>2]=c[da>>2];break};case 120:{Da=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];oe[Da&63](b,d,s,r,g,h,j);i=l;return};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];CU(0,e,C,h,Ia);break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];Da=FU(e,t,h,Ia,1)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<7){c[j+24>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 70:{ca=e;c[ka>>2]=c[ca>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];sU(ja,d,J,I,g,h,j,105696,105728|0);c[ca>>2]=c[ja>>2];break};case 88:{ca=d+8|0;Da=ee[c[(c[ca>>2]|0)+24>>2]&127](ca)|0;ca=e;c[Aa>>2]=c[ca>>2];c[Ba>>2]=c[f>>2];Fa=a[Da]|0;if((Fa&1)==0){Ma=Da+4|0;Na=Da+4|0;Oa=(Fa&255)>>>1}else{Fa=c[Da+8>>2]|0;Ma=Fa;Na=Fa;Oa=c[Da+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];sU(za,d,q,p,g,h,j,Na,Ma+(Oa<<2)|0);c[ca>>2]=c[za>>2];break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];ca=FU(e,F,h,Ia,3)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<366){c[j+28>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];EU(0,e,m,h,Ia);break};case 114:{Da=e;c[pa>>2]=c[Da>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];sU(oa,d,A,z,g,h,j,105728,105772|0);c[Da>>2]=c[oa>>2];break};case 68:{Da=e;c[ha>>2]=c[Da>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];sU(ga,d,L,K,g,h,j,105664,105696|0);c[Da>>2]=c[ga>>2];break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Da=FU(e,E,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<13){c[j+16>>2]=Da+ -1;break a}else{c[h>>2]=ca|4;break a}break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];DU(d,j+8|0,e,B,h,Ia);break};case 101:case 100:{ca=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Da=FU(e,M,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Da+ -1|0)>>>0<31)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Fa|4;break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Da=FU(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Da|0)<69){Pa=Da+2e3|0}else{Pa=(Da+ -69|0)>>>0<31?Da+1900|0:Da}c[j+20>>2]=Pa+ -1900;break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Da=FU(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Da+ -1900;break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function CU(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;g=b;b=d;a:while(1){d=c[g>>2]|0;do{if((d|0)==0){h=1}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){k=ee[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);d=c[b>>2]|0;do{if((d|0)==0){l=15}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){m=ee[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[j>>2]|0}if((m|0)==-1){c[b>>2]=0;l=15;break}else{if(h){n=d;break}else{o=d;break a}}}}while(0);if((l|0)==15){l=0;if(h){o=0;break}else{n=0}}d=c[g>>2]|0;j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){p=ee[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{p=c[j>>2]|0}if(!(ie[c[(c[f>>2]|0)+12>>2]&63](f,8192,p)|0)){o=n;break}j=c[g>>2]|0;d=j+12|0;q=c[d>>2]|0;if((q|0)==(c[j+16>>2]|0)){ee[c[(c[j>>2]|0)+40>>2]&127](j)|0;continue}else{c[d>>2]=q+4;continue}}n=c[g>>2]|0;do{if((n|0)==0){r=1}else{p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){s=ee[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{s=c[p>>2]|0}if((s|0)==-1){c[g>>2]=0;r=1;break}else{r=(c[g>>2]|0)==0;break}}}while(0);do{if((o|0)==0){l=37}else{g=c[o+12>>2]|0;if((g|0)==(c[o+16>>2]|0)){t=ee[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{t=c[g>>2]|0}if((t|0)==-1){c[b>>2]=0;l=37;break}if(!r){break}i=a;return}}while(0);do{if((l|0)==37){if(r){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function DU(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=ee[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=eT(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}



function VO(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((a[b+44|0]|0)!=0){h=nc(e|0,1,f|0,c[b+32>>2]|0)|0;i=g;return h|0}if((f|0)>0){j=e;k=0}else{h=0;i=g;return h|0}while(1){if((re[c[(c[b>>2]|0)+52>>2]&63](b,d[j]|0)|0)==-1){h=k;l=6;break}e=k+1|0;if((e|0)<(f|0)){j=j+1|0;k=e}else{h=e;l=6;break}}if((l|0)==6){i=g;return h|0}return 0}function WO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){a[g]=d;if((a[b+44|0]|0)!=0){if((nc(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=le[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((nc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((nc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function XO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=103848;j=b+4|0;wW(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=103200;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;xW(g,j);j=AW(g,106640)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=ee[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(ee[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){IV(103040)}else{yW(g);i=f;return}}function YO(a){a=a|0;var b=0;b=i;c[a>>2]=103848;yW(a+4|0);i=b;return}function ZO(a){a=a|0;var b=0;b=i;c[a>>2]=103848;yW(a+4|0);b_(a);i=b;return}function _O(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=AW(d,106640)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=ee[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(ee[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){IV(103040)}else{i=e;return}}function $O(a){a=a|0;var b=0,c=0;b=i;c=cP(a,0)|0;i=b;return c|0}function aP(a){a=a|0;var b=0,c=0;b=i;c=cP(a,1)|0;i=b;return c|0}function bP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f;q=le[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((nd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function cP(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]|0)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;a:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=ad(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break a}}i=f;return o|0}}while(0);b:do{if((a[b+53|0]|0)==0){m=b+40|0;n=b+36|0;p=g;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=le[c[(c[u>>2]|0)+16>>2]&15](u,t,p,x,j,h,q,k)|0;if((y|0)==2){o=-1;z=23;break}else if((y|0)==3){z=14;break}else if((y|0)!=1){A=s;break b}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=23;break}w=ad(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=23;break}a[x]=w;s=s+1|0}if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==23){i=f;return o|0}}else{a[h]=a[g]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k+ -1|0;if((nd(d[g+j|0]|0,c[l>>2]|0)|0)==-1){o=-1;z=23;break}else{k=j}}if((z|0)==21){B=a[h]|0;break}else if((z|0)==23){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function dP(){var a=0;a=i;BO(0);Vd(188,102464,q|0)|0;i=a;return}function eP(a){a=a|0;i=i;return}function fP(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=1+(c[b>>2]|0);i=i;return}function gP(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=-1+e;if((e|0)!=0){f=0;i=b;return f|0}be[c[(c[a>>2]|0)+8>>2]&255](a);f=1;i=b;return f|0}function hP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=103344;e=x_(b|0)|0;f=a_(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;z_(g|0,b|0,e+1|0)|0;i=d;return}function iP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=103344;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;wb(h|0);j=a;b_(j);i=b;return}c_((c[d>>2]|0)+ -12|0);g=a;h=g;wb(h|0);j=a;b_(j);i=b;return}function jP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=103344;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;wb(h|0);i=b;return}c_((c[d>>2]|0)+ -12|0);g=a;h=g;wb(h|0);i=b;return}function kP(a){a=a|0;i=i;return c[a+4>>2]|0}function lP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;c[b>>2]=103368;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=x_(f|0)|0;g=a_(d+13|0)|0;c[g+4>>2]=d;c[g>>2]=d;h=g+12|0;c[b+4>>2]=h;c[g+8>>2]=0;z_(h|0,f|0,d+1|0)|0;i=e;return}function mP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=103368;e=x_(b|0)|0;f=a_(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;z_(g|0,b|0,e+1|0)|0;i=d;return}function nP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=103368;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;wb(h|0);j=a;b_(j);i=b;return}c_((c[d>>2]|0)+ -12|0);g=a;h=g;wb(h|0);j=a;b_(j);i=b;return}function oP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=103368;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;wb(h|0);i=b;return}c_((c[d>>2]|0)+ -12|0);g=a;h=g;wb(h|0);i=b;return}function pP(a){a=a|0;i=i;return c[a+4>>2]|0}function qP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=103344;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;wb(h|0);j=a;b_(j);i=b;return}c_((c[d>>2]|0)+ -12|0);g=a;h=g;wb(h|0);j=a;b_(j);i=b;return}function rP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=103344;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;wb(h|0);j=a;b_(j);i=b;return}c_((c[d>>2]|0)+ -12|0);g=a;h=g;wb(h|0);j=a;b_(j);i=b;return}function sP(a){a=a|0;i=i;return}function tP(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;i=i;return}function uP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;xe[c[(c[a>>2]|0)+12>>2]&15](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function vP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+4>>2]|0)!=(a|0)){f=0;i=e;return f|0}f=(c[b>>2]|0)==(d|0);i=e;return f|0}function wP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=Sd(e|0)|0;e=x_(f|0)|0;if(e>>>0>4294967279){CP(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0;z_(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}else{l=e+16&-16;m=$Z(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=e;g=m;z_(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}}function xP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=d;j=c[h>>2]|0;k=e;do{if((j|0)!=0){l=a[e]|0;if((l&1)==0){m=(l&255)>>>1}else{m=c[e+4>>2]|0}if((m|0)==0){n=j}else{hQ(e,103584,2)|0;n=c[h>>2]|0}l=c[d+4>>2]|0;xe[c[(c[l>>2]|0)+24>>2]&15](g,l,n);l=a[g]|0;if((l&1)==0){o=g+1|0;p=(l&255)>>>1}else{o=c[g+8>>2]|0;p=c[g+4>>2]|0}hQ(e,o,p)|0;if((a[g]&1)==0){break}b_(c[g+8>>2]|0)}}while(0);g=b;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;i=f;return}function yP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=x_(e|0)|0;if(j>>>0>4294967279){CP(0)}if(j>>>0<11){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=$Z(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}z_(k|0,e|0,j|0)|0;a[k+j|0]=0;xP(g,d,h);lP(b,g);if(!((a[g]&1)==0)){b_(c[g+8>>2]|0)}if(!((a[h]&1)==0)){b_(c[h+8>>2]|0)}c[b>>2]=103600;h=d;d=c[h+4>>2]|0;g=b+8|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;i=f;return}function zP(a){a=a|0;var b=0;b=i;oP(a);b_(a);i=b;return}function AP(a){a=a|0;var b=0;b=i;oP(a);i=b;return}function BP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;pc(103736)|0;if((c[a>>2]|0)==1){do{kd(103760,103736)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)==0){c[a>>2]=1;bc(103736)|0;be[d&255](b);pc(103736)|0;c[a>>2]=-1;bc(103736)|0;Zc(103760)|0;i=e;return}else{bc(103736)|0;i=e;return}}function CP(a){a=a|0;a=Ac(8)|0;hP(a,103808);c[a>>2]=103424;Pd(a|0,103464,40)}function DP(a){a=a|0;a=Ac(8)|0;hP(a,103808);c[a>>2]=103488;Pd(a|0,103528,40)}function EP(a){a=a|0;var b=0,d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function FP(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function GP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d;if((a[d]&1)==0){g=b;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];i=e;return}f=c[d+8>>2]|0;g=c[d+4>>2]|0;if(g>>>0>4294967279){CP(0)}if(g>>>0<11){a[b]=g<<1;h=b+1|0}else{d=g+16&-16;j=$Z(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=g;h=j}z_(h|0,f|0,g|0)|0;a[h+g|0]=0;i=e;return}function HP(b){b=b|0;i=i;return(a[b]&1)!=0|0}function IP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>4294967279){CP(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0}else{h=e+16&-16;j=$Z(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}z_(g|0,d|0,e|0)|0;a[g+e|0]=0;i=f;return}function JP(a){a=a|0;i=i;return a|0}function KP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=x_(d|0)|0;if(f>>>0>4294967279){CP(0)}if(f>>>0<11){a[b]=f<<1;g=b+1|0;z_(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}else{l=f+16&-16;m=$Z(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=f;g=m;z_(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}}function LP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>4294967279){CP(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0}else{h=d+16&-16;j=$Z(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}B_(g|0,e|0,d|0)|0;a[g+d|0]=0;i=f;return}function MP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if(d>>>0>4294967279){CP(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0;B_(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}else{l=d+16&-16;m=$Z(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=d;g=m;B_(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}}function NP(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=a[d]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[d+4>>2]|0}if(k>>>0<e>>>0){DP(0)}if(j){l=d+1|0}else{l=c[d+8>>2]|0}d=l+e|0;l=k-e|0;e=l>>>0<f>>>0?l:f;if(e>>>0>4294967279){CP(0)}if(e>>>0<11){a[b]=e<<1;m=b+1|0;z_(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}else{f=e+16&-16;l=$Z(f)|0;c[b+8>>2]=l;c[b>>2]=f|1;c[b+4>>2]=e;m=l;z_(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}}function OP(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function PP(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function QP(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}b_(c[b+8>>2]|0);i=d;return}function RP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((b|0)==(d|0)){i=e;return b|0}f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=a[b]|0;if((d&1)==0){j=d;k=10}else{d=c[b>>2]|0;j=d&255;k=(d&-2)+ -1|0}d=(j&1)==0;if(k>>>0<h>>>0){if(d){l=(j&255)>>>1}else{l=c[b+4>>2]|0}iQ(b,k,h-k|0,l,0,l,h,g);i=e;return b|0}if(d){m=b+1|0}else{m=c[b+8>>2]|0}A_(m|0,g|0,h|0)|0;a[m+h|0]=0;if((a[b]&1)==0){a[b]=h<<1;i=e;return b|0}else{c[b+4>>2]=h;i=e;return b|0}return 0}function SP(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=TP(a,b)|0;i=c;return d|0}function TP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=x_(d|0)|0;g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}g=(h&1)==0;if(j>>>0<f>>>0){if(g){k=(h&255)>>>1}else{k=c[b+4>>2]|0}iQ(b,j,f-j|0,k,0,k,f,d);i=e;return b|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}A_(l|0,d|0,f|0)|0;a[l+f|0]=0;if((a[b]&1)==0){a[b]=f<<1;i=e;return b|0}else{c[b+4>>2]=f;i=e;return b|0}return 0}function UP(a,b){a=a|0;b=b|0;c[a+4>>2]=b;i=i;return}function VP(a){a=a|0;i=i;return a+1|0}function WP(b,c){b=b|0;c=c|0;a[b]=c<<1;i=i;return}function XP(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function YP(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=10;i=d;return e|0}e=(c[b>>2]&-2)+ -1|0;i=d;return e|0}function ZP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){_P(b,d-j|0,e)|0;i=f;return}if(h){a[b+1+d|0]=0;a[b]=d<<1;i=f;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=f;return}}function _P(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)==0){i=f;return b|0}g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}if((h&1)==0){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if((j-k|0)>>>0<d>>>0){jQ(b,j,d-j+k|0,k,k,0,0);l=a[b]|0}else{l=h}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}B_(m+k|0,e|0,d|0)|0;e=k+d|0;if((a[b]&1)==0){a[b]=e<<1}else{c[b+4>>2]=e}a[m+e|0]=0;i=f;return b|0}function $P(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}if(h>>>0<d>>>0){_P(b,d-h|0,0)|0;i=e;return}if(g){a[b+1+d|0]=0;a[b]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=e;return}}function aQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>4294967279){CP(0)}f=a[b]|0;if((f&1)==0){g=f;h=10}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<11){k=10}else{k=(f+16&-16)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==10){l=b+1|0;m=0;n=c[b+8>>2]|0;o=1}else{f=k+1|0;if(k>>>0>h>>>0){p=$Z(f)|0}else{p=$Z(f)|0}if((g&1)==0){l=p;m=1;n=b+1|0;o=0;break}else{l=p;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}z_(l|0,n|0,q+1|0)|0;if(o){b_(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function bQ(a){a=a|0;var b=0;if(a>>>0<11){b=10}else{b=(a+16&-16)+ -1|0}i=i;return b|0}function cQ(a,b){a=a|0;b=b|0;c[a>>2]=b|1;i=i;return}function dQ(a,b){a=a|0;b=b|0;c[a+8>>2]=b;i=i;return}function eQ(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){a[b+1|0]=0;a[b]=0;i=d;return}else{a[c[b+8>>2]|0]=0;c[b+4>>2]=0;i=d;return}}function fQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=hQ(b,g,h)|0;i=e;return d|0}function gQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=10;j=(f&255)>>>1}if((j|0)==(h|0)){jQ(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+1|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}a[l+j|0]=d;a[l+m|0]=0;i=e;return}function hQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}if((j&1)==0){k=(j&255)>>>1}else{k=c[b+4>>2]|0}if((h-k|0)>>>0<e>>>0){iQ(b,h,e-h+k|0,k,k,0,e,d);i=f;return b|0}if((e|0)==0){i=f;return b|0}if((j&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}z_(l+k|0,d|0,e|0)|0;d=k+e|0;if((a[b]&1)==0){a[b]=d<<1}else{c[b+4>>2]=d}a[l+d|0]=0;i=f;return b|0}function iQ(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((-18-d|0)>>>0<e>>>0){CP(0)}if((a[b]&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}do{if(d>>>0<2147483623){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<11){q=11;break}q=p+16&-16}else{q=-17}}while(0);e=$Z(q)|0;if((g|0)!=0){z_(e|0,m|0,g|0)|0}if((j|0)!=0){z_(e+g|0,k|0,j|0)|0}k=f-h|0;if((k|0)!=(g|0)){z_(e+(j+g)|0,m+(h+g)|0,k-g|0)|0}if((d|0)!=10){b_(m)}c[b+8>>2]=e;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;a[e+q|0]=0;i=l;return}function jQ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((-17-d|0)>>>0<e>>>0){CP(0)}if((a[b]&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}do{if(d>>>0<2147483623){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<11){p=11;break}p=o+16&-16}else{p=-17}}while(0);e=$Z(p)|0;if((g|0)!=0){z_(e|0,l|0,g|0)|0}o=f-h|0;if((o|0)!=(g|0)){z_(e+(j+g)|0,l+(h+g)|0,o-g|0)|0}if((d|0)==10){q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}b_(l);q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function kQ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;NP(a,b,c,d,0);i=e;return}function lQ(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function mQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=x_(d|0)|0;h=a[b]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if(k>>>0<e>>>0|(k-e|0)>>>0<g>>>0){l=-1;i=f;return l|0}if((g|0)==0){l=e;i=f;return l|0}if(j){m=b+1|0}else{m=c[b+8>>2]|0}b=m+e|0;j=m+k|0;h=d+g|0;if((j-b|0)<(g|0)){l=-1;i=f;return l|0}n=k+(1-g)|0;g=m+n|0;if((n|0)==(e|0)){l=-1;i=f;return l|0}e=a[d]|0;n=b;a:while(1){if((a[n]|0)==e<<24>>24){b=n;k=d;do{k=k+1|0;if((k|0)==(h|0)){break a}b=b+1|0;}while((a[b]|0)==(a[k]|0))}k=n+1|0;if((k|0)==(g|0)){l=-1;o=18;break}else{n=k}}if((o|0)==18){i=f;return l|0}if((n|0)==(j|0)){l=-1;i=f;return l|0}l=n-m|0;i=f;return l|0}function nQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}f=a[d]|0;j=(f&1)==0;if(j){k=(f&255)>>>1}else{k=c[d+4>>2]|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}if(j){m=d+1|0}else{m=c[d+8>>2]|0}d=k>>>0<h>>>0;j=s_(l,m,d?k:h)|0;if((j|0)==0){i=e;return(h>>>0<k>>>0?-1:d&1)|0}else{i=e;return j|0}return 0}function oQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=x_(d|0)|0;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if((f|0)==-1){DP(0)}if(h){k=b+1|0}else{k=c[b+8>>2]|0}b=j>>>0>f>>>0;h=s_(k,d,b?f:j)|0;if((h|0)==0){i=e;return(j>>>0<f>>>0?-1:b&1)|0}else{i=e;return h|0}return 0}function pQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(f>>>0>4294967279){CP(0)}if(f>>>0<11){a[b]=e<<1;h=b+1|0;z_(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}else{m=f+16&-16;f=$Z(m)|0;c[b+8>>2]=f;c[b>>2]=m|1;c[b+4>>2]=e;h=f;z_(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}}function qQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>1073741807){CP(0)}if(e>>>0<2){a[b]=e<<1;g=b+4|0}else{h=e+4&-4;j=$Z(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}wZ(g,d,e)|0;c[g+(e<<2)>>2]=0;i=f;return}function rQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>1073741807){CP(0)}if(d>>>0<2){a[b]=d<<1;g=b+4|0}else{h=d+4&-4;j=$Z(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}yZ(g,e,d)|0;c[g+(d<<2)>>2]=0;i=f;return}function sQ(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}b_(c[b+8>>2]|0);i=d;return}function tQ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=uQ(a,b,vZ(b)|0)|0;i=c;return d|0}function uQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=1;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g){k=(j&255)>>>1}else{k=c[b+4>>2]|0}xQ(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g){l=b+4|0}else{l=c[b+8>>2]|0}xZ(l,d,e)|0;c[l+(e<<2)>>2]=0;if((a[b]&1)==0){a[b]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function vQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>1073741807){CP(0)}f=a[b]|0;if((f&1)==0){g=f;h=1}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<2){k=1}else{k=(f+4&-4)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==1){l=b+4|0;m=0;n=c[b+8>>2]|0;o=1}else{f=(k<<2)+4|0;if(k>>>0>h>>>0){p=$Z(f)|0}else{p=$Z(f)|0}f=p;if((g&1)==0){l=f;m=1;n=b+4|0;o=0;break}else{l=f;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}wZ(l,n,q+1|0)|0;if(o){b_(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function wQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=1;j=(f&255)>>>1}if((j|0)==(h|0)){yQ(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+4|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}c[l+(j<<2)>>2]=d;c[l+(m<<2)>>2]=0;i=e;return}function xQ(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((1073741806-d|0)>>>0<e>>>0){CP(0)}if((a[b]&1)==0){m=b+4|0}else{m=c[b+8>>2]|0}do{if(d>>>0<536870887){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<2){q=2;break}q=p+4&-4}else{q=1073741807}}while(0);e=$Z(q<<2)|0;p=e;if((g|0)!=0){wZ(p,m,g)|0}if((j|0)!=0){wZ(e+(g<<2)|0,k,j)|0}k=f-h|0;if((k|0)!=(g|0)){wZ(e+(j+g<<2)|0,m+(h+g<<2)|0,k-g|0)|0}if((d|0)!=1){b_(m)}c[b+8>>2]=p;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;c[e+(q<<2)>>2]=0;i=l;return}function yQ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((1073741807-d|0)>>>0<e>>>0){CP(0)}if((a[b]&1)==0){l=b+4|0}else{l=c[b+8>>2]|0}do{if(d>>>0<536870887){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<2){p=2;break}p=o+4&-4}else{p=1073741807}}while(0);e=$Z(p<<2)|0;o=e;if((g|0)!=0){wZ(o,l,g)|0}m=f-h|0;if((m|0)!=(g|0)){wZ(e+(j+g<<2)|0,l+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}b_(l);q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function zQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;g=x_(d|0)|0;h=a[e]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[e+4>>2]|0}h=j+g|0;if(h>>>0>4294967279){CP(0)}if(h>>>0<11){a[b]=g<<1;k=b+1|0}else{l=h+16&-16;h=$Z(l)|0;c[b+8>>2]=h;c[b>>2]=l|1;c[b+4>>2]=g;k=h}z_(k|0,d|0,g|0)|0;a[k+g|0]=0;if((a[e]&1)==0){m=e+1|0;n=hQ(b,m,j)|0;i=f;return}else{m=c[e+8>>2]|0;n=hQ(b,m,j)|0;i=f;return}}function AQ(a){a=a|0;i=i;return(c[a+16>>2]&5|0)==0|0}function BQ(a){a=a|0;i=i;return(c[a+16>>2]&5|0)!=0|0}function CQ(a,b){a=a|0;b=b|0;var c=0;c=i;DQ(a,b);i=c;return}function DQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(c[b+24>>2]|0)==0;if(h){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((h&1|d)&c[b+20>>2]|0)==0){i=e;return}e=Ac(16)|0;do{if((a[104192]|0)==0){if((Wa(104192)|0)==0){break}c[26046]=104888;Vd(66,104184,q|0)|0;Pb(104192)}}while(0);b=e;d=g;c[d>>2]=1;c[d+4>>2]=104184;d=f;h=g;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];yP(b,f,104240);c[e>>2]=104208;Pd(e|0,104288,62)}function EQ(a,b){a=a|0;b=b|0;var d=0;d=i;DQ(a,c[a+16>>2]|b);i=d;return}function FQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=104232;d=c[a+40>>2]|0;e=a+32|0;f=a+36|0;if((d|0)!=0){g=d;do{g=g+ -1|0;xe[c[(c[e>>2]|0)+(g<<2)>>2]&15](0,a,c[(c[f>>2]|0)+(g<<2)>>2]|0);}while((g|0)!=0)}yW(a+28|0);WZ(c[e>>2]|0);WZ(c[f>>2]|0);WZ(c[a+48>>2]|0);WZ(c[a+60>>2]|0);i=b;return}function GQ(a){a=a|0;var b=0;b=i;FQ(a);b_(a);i=b;return}function HQ(a){a=a|0;var b=0;b=i;FQ(a);i=b;return}function IQ(a){a=a|0;var b=0;b=i;FQ(a);i=b;return}function JQ(a){a=a|0;i=i;return c[a+24>>2]|0}function KQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+76|0;f=c[e>>2]|0;if(!((f|0)==-1)){g=f&255;i=b;return g|0}xW(d,a+28|0);a=AW(d,106576)|0;f=re[c[(c[a>>2]|0)+28>>2]&63](a,32)|0;yW(d);c[e>>2]=f<<24>>24;g=f;i=b;return g|0}function LQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;xW(e,a+28|0);a=AW(e,106576)|0;f=re[c[(c[a>>2]|0)+28>>2]&63](a,b)|0;yW(e);i=d;return f|0}function MQ(a,b){a=a|0;b=b|0;var c=0;c=i;xW(a,b+28|0);i=c;return}function NQ(a){a=a|0;c[a>>2]=103832;i=i;return}function OQ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;e=a+32|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));wW(b);i=d;return}function PQ(a){a=a|0;var b=0;b=i;c[a>>2]=103848;yW(a+4|0);b_(a);i=b;return}function QQ(a){a=a|0;var b=0;b=i;c[a>>2]=103848;yW(a+4|0);i=b;return}function RQ(a){a=a|0;var b=0;b=i;c[a>>2]=103848;yW(a+4|0);i=b;return}function SQ(a,b){a=a|0;b=b|0;var c=0;c=i;xW(a,b+4|0);i=c;return}function TQ(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;e=a+12|0;f=c[e>>2]|0;if((f|0)==(c[a+16>>2]|0)){g=ee[c[(c[a>>2]|0)+40>>2]&127](a)|0;i=b;return g|0}else{c[e>>2]=f+1;g=d[f]|0;i=b;return g|0}return 0}function UQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==(c[b+28>>2]|0)){h=re[c[(c[b>>2]|0)+52>>2]&63](b,d&255)|0;i=e;return h|0}else{c[f>>2]=g+1;a[g]=d;h=d&255;i=e;return h|0}return 0}function VQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=ie[c[(c[a>>2]|0)+48>>2]&63](a,b,d)|0;i=e;return f|0}function WQ(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=103848;wW(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function XQ(a){a=a|0;i=i;return c[a+8>>2]|0}function YQ(a){a=a|0;i=i;return c[a+12>>2]|0}function ZQ(a){a=a|0;i=i;return c[a+16>>2]|0}function _Q(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function $Q(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;i=i;return}function aR(a){a=a|0;i=i;return c[a+20>>2]|0}function bR(a){a=a|0;i=i;return c[a+24>>2]|0}function cR(a){a=a|0;i=i;return c[a+28>>2]|0}function dR(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function eR(a,b,d){a=a|0;b=b|0;d=d|0;c[a+24>>2]=b;c[a+20>>2]=b;c[a+28>>2]=d;i=i;return}function fR(a,b){a=a|0;b=b|0;i=i;return}function gR(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function hR(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function iR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function jR(a){a=a|0;i=i;return 0}function kR(a){a=a|0;i=i;return 0}function lR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((e|0)<=0){g=0;i=f;return g|0}h=b+12|0;j=b+16|0;k=d;d=0;while(1){l=c[h>>2]|0;if(l>>>0<(c[j>>2]|0)>>>0){c[h>>2]=l+1;m=a[l]|0}else{l=ee[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((l|0)==-1){g=d;n=8;break}m=l&255}a[k]=m;l=d+1|0;if((l|0)<(e|0)){k=k+1|0;d=l}else{g=l;n=8;break}}if((n|0)==8){i=f;return g|0}return 0}function mR(a){a=a|0;i=i;return-1}function nR(a){a=a|0;var b=0,e=0,f=0;b=i;if((ee[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){e=-1;i=b;return e|0}f=a+12|0;a=c[f>>2]|0;c[f>>2]=a+1;e=d[a]|0;i=b;return e|0}function oR(a,b){a=a|0;b=b|0;i=i;return-1}function pR(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((f|0)<=0){h=0;i=g;return h|0}j=b+24|0;k=b+28|0;l=e;e=0;while(1){m=c[j>>2]|0;if(m>>>0<(c[k>>2]|0)>>>0){n=a[l]|0;c[j>>2]=m+1;a[m]=n}else{if((re[c[(c[b>>2]|0)+52>>2]&63](b,d[l]|0)|0)==-1){h=e;o=7;break}}n=e+1|0;if((n|0)<(f|0)){l=l+1|0;e=n}else{h=n;o=7;break}}if((o|0)==7){i=g;return h|0}return 0}function qR(a,b){a=a|0;b=b|0;i=i;return-1}function rR(a){a=a|0;var b=0;b=i;c[a>>2]=103912;yW(a+4|0);b_(a);i=b;return}function sR(a){a=a|0;var b=0;b=i;c[a>>2]=103912;yW(a+4|0);i=b;return}function tR(a,b){a=a|0;b=b|0;i=i;return}function uR(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function vR(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function wR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function xR(a){a=a|0;i=i;return 0}function yR(a){a=a|0;i=i;return 0}function zR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+12|0;h=a+16|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[g>>2]=k+4;l=c[k>>2]|0}else{k=ee[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((k|0)==-1){f=b;m=8;break}else{l=k}}c[j>>2]=l;k=b+1|0;if((k|0)>=(d|0)){f=k;m=8;break}j=j+4|0;b=k}if((m|0)==8){i=e;return f|0}return 0}function AR(a){a=a|0;i=i;return-1}function BR(a){a=a|0;var b=0,d=0,e=0;b=i;if((ee[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){d=-1;i=b;return d|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+4;d=c[a>>2]|0;i=b;return d|0}function CR(a,b){a=a|0;b=b|0;i=i;return-1}function DR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;h=a+28|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){l=c[j>>2]|0;c[g>>2]=k+4;c[k>>2]=l}else{if((re[c[(c[a>>2]|0)+52>>2]&63](a,c[j>>2]|0)|0)==-1){f=b;m=8;break}}l=b+1|0;if((l|0)>=(d|0)){f=l;m=8;break}j=j+4|0;b=l}if((m|0)==8){i=e;return f|0}return 0}function ER(a,b){a=a|0;b=b|0;i=i;return-1}function FR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];c[a+4>>2]=0;b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));wW(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function GR(a){a=a|0;var b=0;b=i;FQ(a+8|0);b_(a);i=b;return}function HR(a){a=a|0;var b=0;b=i;FQ(a+8|0);i=b;return}function IR(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;FQ(a+(d+8)|0);b_(a+d|0);i=b;return}function JR(a){a=a|0;var b=0;b=i;FQ(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function KR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;LR(a,b,c);i=d;return}function LR(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;h=g;j=d;a[j]=0;d=c[(c[e>>2]|0)+ -12>>2]|0;k=c[e+(d+16)>>2]|0;if((k|0)!=0){DQ(e+d|0,k|4);i=g;return}k=c[e+(d+72)>>2]|0;if((k|0)!=0){MR(k)|0}a:do{if(!f){k=c[(c[e>>2]|0)+ -12>>2]|0;if((c[e+(k+4)>>2]&4096|0)==0){break}xW(h,e+(k+28)|0);k=AW(h,106576)|0;yW(h);d=k+8|0;k=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;while(1){if((k|0)==0){break}if((c[k+12>>2]|0)==(c[k+16>>2]|0)){l=(ee[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;m=l?0:k;if((m|0)==0){break}else{n=m}}else{n=k}m=n+12|0;l=c[m>>2]|0;o=n+16|0;if((l|0)==(c[o>>2]|0)){p=(ee[c[(c[n>>2]|0)+36>>2]&127](n)|0)&255}else{p=a[l]|0}if(!(p<<24>>24>-1)){q=18;break}if((b[(c[d>>2]|0)+(p<<24>>24<<1)>>1]&8192)==0){q=18;break}l=c[m>>2]|0;if((l|0)==(c[o>>2]|0)){ee[c[(c[n>>2]|0)+40>>2]&127](n)|0;k=n;continue}else{c[m>>2]=l+1;k=n;continue}}do{if((q|0)==18){if((n|0)==0){break}if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){break a}if(!((ee[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1|(n|0)==0)){break a}}}while(0);k=c[(c[e>>2]|0)+ -12>>2]|0;DQ(e+k|0,c[e+(k+16)>>2]|6)}}while(0);a[j]=(c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+16)>>2]|0)==0|0;i=g;return}function MR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{MR(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((ee[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;DQ(b+h|0,c[b+(h+16)>>2]|1)}}while(0);$R(e);i=d;return b|0}function NR(b){b=b|0;i=i;return(a[b]|0)!=0|0}function OR(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){i=i;return}else{Cb()}}function PR(a){a=a|0;var b=0;b=i;FQ(a+8|0);b_(a);i=b;return}function QR(a){a=a|0;var b=0;b=i;FQ(a+8|0);i=b;return}function RR(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;FQ(a+(d+8)|0);b_(a+d|0);i=b;return}function SR(a){a=a|0;var b=0;b=i;FQ(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function TR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{TR(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((ee[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;DQ(b+h|0,c[b+(h+16)>>2]|1)}}while(0);lS(e);i=d;return b|0}function UR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));wW(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function VR(a){a=a|0;var b=0;b=i;FQ(a+4|0);b_(a);i=b;return}function WR(a){a=a|0;var b=0;b=i;FQ(a+4|0);i=b;return}function XR(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;FQ(a+(d+4)|0);b_(a+d|0);i=b;return}function YR(a){a=a|0;var b=0;b=i;FQ(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function ZR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b;a[f]=0;c[b+4>>2]=d;b=c[(c[d>>2]|0)+ -12>>2]|0;if((c[d+(b+16)>>2]|0)!=0){i=e;return}g=c[d+(b+72)>>2]|0;if((g|0)!=0){MR(g)|0}a[f]=1;i=e;return}function _R(a){a=a|0;var b=0;b=i;$R(a);i=b;return}function $R(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(ab()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((ee[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;DQ(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function aS(b){b=b|0;i=i;return(a[b]|0)!=0|0}function bS(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ee[b&127](a)|0;i=c;return d|0}function cS(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=j;a[m]=0;c[j+4>>2]=b;n=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(n+16)>>2]|0)!=0){$R(j);i=e;return b|0}o=c[b+(n+72)>>2]|0;if((o|0)==0){p=n}else{MR(o)|0;p=c[(c[b>>2]|0)+ -12>>2]|0}a[m]=1;xW(k,b+(p+28)|0);p=AW(k,105296)|0;m=p;yW(k);k=c[(c[b>>2]|0)+ -12>>2]|0;o=c[b+(k+24)>>2]|0;n=b+(k+76)|0;q=c[n>>2]|0;if((q|0)==-1){xW(h,b+(k+28)|0);r=AW(h,106576)|0;s=re[c[(c[r>>2]|0)+28>>2]&63](r,32)|0;yW(h);c[n>>2]=s<<24>>24;t=s}else{t=q&255}q=b+k|0;k=c[(c[p>>2]|0)+32>>2]|0;c[g>>2]=o;o=f;p=g;c[o+0>>2]=c[p+0>>2];je[k&7](l,m,f,q,t,d);if((c[l>>2]|0)!=0){$R(j);i=e;return b|0}l=c[(c[b>>2]|0)+ -12>>2]|0;DQ(b+l|0,c[b+(l+16)>>2]|5);$R(j);i=e;return b|0}function dS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=f;a[g]=0;c[f+4>>2]=b;h=c[b>>2]|0;j=c[h+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){$R(f);i=e;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)==0){l=h;m=j}else{MR(k)|0;k=c[b>>2]|0;l=k;m=c[k+ -12>>2]|0}a[g]=1;g=c[b+(m+24)>>2]|0;m=g;do{if((g|0)==0){n=l}else{k=g+24|0;j=c[k>>2]|0;if((j|0)!=(c[g+28>>2]|0)){c[k>>2]=j+1;a[j]=d;$R(f);i=e;return b|0}if((re[c[(c[g>>2]|0)+52>>2]&63](m,d&255)|0)==-1){n=c[b>>2]|0;break}else{$R(f);i=e;return b|0}}}while(0);d=c[n+ -12>>2]|0;DQ(b+d|0,c[b+(d+16)>>2]|1);$R(f);i=e;return b|0}function eS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=g;a[h]=0;c[g+4>>2]=b;j=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){$R(g);i=f;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)!=0){MR(k)|0}a[h]=1;if((e|0)==0){$R(g);i=f;return b|0}h=c[b+((c[(c[b>>2]|0)+ -12>>2]|0)+24)>>2]|0;if((ie[c[(c[h>>2]|0)+48>>2]&63](h,d,e)|0)==(e|0)){$R(g);i=f;return b|0}e=c[(c[b>>2]|0)+ -12>>2]|0;DQ(b+e|0,c[b+(e+16)>>2]|1);$R(g);i=f;return b|0}function fS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(e+16)>>2]&5|0)==0){f=c[b+(e+24)>>2]|0;me[c[(c[f>>2]|0)+16>>2]&31](a,f,0,0,1,16);i=d;return}else{f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;i=d;return}}function gS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=e;g=e+16|0;h=e+32|0;j=e+40|0;k=h;a[k]=0;c[h+4>>2]=b;l=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(l+16)>>2]|0)!=0){$R(h);i=e;return b|0}m=c[b+(l+72)>>2]|0;if((m|0)==0){n=l}else{MR(m)|0;n=c[(c[b>>2]|0)+ -12>>2]|0}a[k]=1;k=c[b+(n+24)>>2]|0;n=k;m=d;d=g;l=c[(c[k>>2]|0)+20>>2]|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];m=f;d=g;c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];Be[l&31](j,n,f,16);f=j+8|0;if(!((c[f>>2]|0)==-1&(c[f+4>>2]|0)==-1)){$R(h);i=e;return b|0}f=c[(c[b>>2]|0)+ -12>>2]|0;DQ(b+f|0,c[b+(f+16)>>2]|4);$R(h);i=e;return b|0}function hS(a){a=a|0;var b=0;b=i;FQ(a+4|0);b_(a);i=b;return}function iS(a){a=a|0;var b=0;b=i;FQ(a+4|0);i=b;return}function jS(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;FQ(a+(d+4)|0);b_(a+d|0);i=b;return}function kS(a){a=a|0;var b=0;b=i;FQ(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function lS(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(ab()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((ee[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;DQ(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function mS(a){a=a|0;i=i;return 104128}function nS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((c|0)==1){IP(a,104144,35);i=d;return}else{wP(a,b,c);i=d;return}}function oS(a){a=a|0;i=i;return}function pS(a){a=a|0;var b=0;b=i;AP(a);b_(a);i=b;return}function qS(a){a=a|0;var b=0;b=i;AP(a);i=b;return}function rS(a){a=a|0;var b=0;b=i;FQ(a);b_(a);i=b;return}function sS(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function tS(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function uS(a){a=a|0;i=i;return}function vS(a){a=a|0;i=i;return}function wS(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;a:do{if((e|0)==(f|0)){g=c;h=6}else{j=e;k=c;while(1){if((k|0)==(d|0)){l=-1;break a}m=a[k]|0;n=a[j]|0;if(m<<24>>24<n<<24>>24){l=-1;break a}if(n<<24>>24<m<<24>>24){l=1;break a}m=k+1|0;n=j+1|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=b;return l|0}function xS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;g=e;h=f-g|0;if(h>>>0>4294967279){CP(b)}if(h>>>0<11){a[b]=h<<1;j=b+1|0}else{k=h+16&-16;l=$Z(k)|0;c[b+8>>2]=l;c[b>>2]=k|1;c[b+4>>2]=h;j=l}if((e|0)==(f|0)){m=j;a[m]=0;i=d;return}else{n=e;o=j}while(1){a[o]=a[n]|0;e=n+1|0;if((e|0)==(f|0)){break}else{o=o+1|0;n=e}}m=j+(f+(0-g))|0;a[m]=0;i=d;return}function yS(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)==(d|0)){e=0;i=b;return e|0}else{f=0;g=c}while(1){c=(a[g]|0)+(f<<4)|0;h=c&-268435456;j=(h>>>24|h)^c;c=g+1|0;if((c|0)==(d|0)){e=j;break}else{g=c;f=j}}i=b;return e|0}function zS(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function AS(a){a=a|0;i=i;return}function BS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;a:do{if((e|0)==(f|0)){g=b;h=6}else{j=e;k=b;while(1){if((k|0)==(d|0)){l=-1;break a}m=c[k>>2]|0;n=c[j>>2]|0;if((m|0)<(n|0)){l=-1;break a}if((n|0)<(m|0)){l=1;break a}m=k+4|0;n=j+4|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=a;return l|0}function CS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;g=e;h=f-g|0;j=h>>2;if(j>>>0>1073741807){CP(b)}if(j>>>0<2){a[b]=h>>>1;k=b+4|0}else{h=j+4&-4;l=$Z(h<<2)|0;c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;k=l}if((e|0)==(f|0)){m=k;c[m>>2]=0;i=d;return}l=f+ -4+(0-g)|0;g=e;e=k;while(1){c[e>>2]=c[g>>2];j=g+4|0;if((j|0)==(f|0)){break}else{e=e+4|0;g=j}}m=k+((l>>>2)+1<<2)|0;c[m>>2]=0;i=d;return}function DS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=0;i=a;return e|0}else{f=0;g=b}while(1){b=(c[g>>2]|0)+(f<<4)|0;h=b&-268435456;j=(h>>>24|h)^b;b=g+4|0;if((b|0)==(d|0)){e=j;break}else{g=b;f=j}}i=a;return e|0}function ES(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function FS(a){a=a|0;i=i;return}function GS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];oe[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==1){a[j]=1}else if((z|0)==0){a[j]=0}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}MQ(u,g);m=u;u=c[m>>2]|0;if(!((c[26644]|0)==-1)){c[p>>2]=106576;c[p+4>>2]=189;c[p+8>>2]=0;BP(106576,p,190)}p=(c[106580>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Ac(4)|0;D=C;AZ(D);E=122136;F=127;Pd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Ac(4)|0;D=C;AZ(D);E=122136;F=127;Pd(C|0,E|0,F|0)}F=u;gP(c[m>>2]|0)|0;MQ(v,g);g=v;v=c[g>>2]|0;if(!((c[26680]|0)==-1)){c[o>>2]=106720;c[o+4>>2]=189;c[o+8>>2]=0;BP(106720,o,190)}o=(c[106724>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Ac(4)|0;H=G;AZ(H);I=122136;J=127;Pd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Ac(4)|0;H=G;AZ(H);I=122136;J=127;Pd(G|0,I|0,J|0)}J=v;gP(c[g>>2]|0)|0;g=w;ce[c[(c[v>>2]|0)+24>>2]&127](g,J);ce[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=HS(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];QP(w+12|0);QP(w);i=k;return}function HS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=VZ(l)|0;if((n|0)!=0){o=n;p=n;break}g_()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){y=r;break}if((ee[c[(c[r>>2]|0)+36>>2]&127](r)|0)==-1){c[l>>2]=0;y=0;break}else{y=c[l>>2]|0;break}}}while(0);r=(y|0)==0;t=c[b>>2]|0;do{if((t|0)==0){z=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){z=t;break}if(!((ee[c[(c[t>>2]|0)+36>>2]&127](t)|0)==-1)){z=t;break}c[b>>2]=0;z=0}}while(0);A=(z|0)==0;B=c[l>>2]|0;if(!((r^A)&(q|0)!=0)){break}t=c[B+12>>2]|0;if((t|0)==(c[B+16>>2]|0)){C=(ee[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[t]|0}if(j){D=C}else{D=re[c[(c[g>>2]|0)+12>>2]&63](g,C)|0}t=d+1|0;if(m){d=t;q=q;x=x;continue}b:do{if(j){w=0;s=e;n=x;v=q;u=p;while(1){do{if((a[u]|0)==1){E=a[s]|0;F=(E&1)==0;if(F){G=s+1|0}else{G=c[s+8>>2]|0}if(!(D<<24>>24==(a[G+d|0]|0))){a[u]=0;H=w;I=n;J=v+ -1|0;break}if(F){K=(E&255)>>>1}else{K=c[s+4>>2]|0}if((K|0)!=(t|0)){H=1;I=n;J=v;break}a[u]=2;H=1;I=n+1|0;J=v+ -1|0}else{H=w;I=n;J=v}}while(0);E=s+12|0;if((E|0)==(f|0)){L=H;M=I;N=J;break b}w=H;s=E;n=I;v=J;u=u+1|0}}else{u=0;v=e;n=x;s=q;w=p;while(1){do{if((a[w]|0)==1){if((a[v]&1)==0){O=v+1|0}else{O=c[v+8>>2]|0}if(!(D<<24>>24==(re[c[(c[g>>2]|0)+12>>2]&63](g,a[O+d|0]|0)|0)<<24>>24)){a[w]=0;P=u;Q=n;R=s+ -1|0;break}E=a[v]|0;if((E&1)==0){S=(E&255)>>>1}else{S=c[v+4>>2]|0}if((S|0)!=(t|0)){P=1;Q=n;R=s;break}a[w]=2;P=1;Q=n+1|0;R=s+ -1|0}else{P=u;Q=n;R=s}}while(0);E=v+12|0;if((E|0)==(f|0)){L=P;M=Q;N=R;break b}u=P;v=E;n=Q;s=R;w=w+1|0}}}while(0);if(!L){d=t;x=M;q=N;continue}r=c[l>>2]|0;w=r+12|0;s=c[w>>2]|0;if((s|0)==(c[r+16>>2]|0)){ee[c[(c[r>>2]|0)+40>>2]&127](r)|0}else{c[w>>2]=s+1}if((N+M|0)>>>0<2){d=t;x=M;q=N;continue}else{T=e;U=M;V=p}while(1){do{if((a[V]|0)==2){s=a[T]|0;if((s&1)==0){W=(s&255)>>>1}else{W=c[T+4>>2]|0}if((W|0)==(t|0)){X=U;break}a[V]=0;X=U+ -1|0}else{X=U}}while(0);s=T+12|0;if((s|0)==(f|0)){d=t;x=X;q=N;continue a}else{T=s;U=X;V=V+1|0}}}do{if((B|0)==0){Y=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){Y=B;break}if((ee[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[l>>2]=0;Y=0;break}else{Y=c[l>>2]|0;break}}}while(0);l=(Y|0)==0;do{if(A){Z=78}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){if(l){break}else{Z=80;break}}if((ee[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1){c[b>>2]=0;Z=78;break}else{if(l){break}else{Z=80;break}}}}while(0);if((Z|0)==78){if(l){Z=80}}if((Z|0)==80){c[h>>2]=c[h>>2]|2}c:do{if(m){Z=85}else{if((a[p]|0)==2){_=e;break}else{$=e;aa=p}while(1){l=$+12|0;b=aa+1|0;if((l|0)==(f|0)){Z=85;break c}if((a[b]|0)==2){_=l;break}else{aa=b;$=l}}}}while(0);if((Z|0)==85){c[h>>2]=c[h>>2]|4;_=f}if((o|0)==0){i=k;return _|0}WZ(o);i=k;return _|0}function IS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];JS(a,0,k,j,f,g,h);i=b;return}function JS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;zT(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZP(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ee[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ee[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}ZP(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}ZP(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(ee[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if(($S(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){ee[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=vY(F,c[o>>2]|0,h,t)|0;MV(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((ee[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;QP(n);QP(m);i=d;return}if((ee[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;QP(n);QP(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;QP(n);QP(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;QP(n);QP(m);i=d;return}function KS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];LS(a,0,k,j,f,g,h);i=b;return}function LS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;zT(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZP(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ee[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ee[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}ZP(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}ZP(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(ee[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if(($S(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){ee[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=uY(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;MV(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((ee[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;QP(n);QP(m);i=d;return}if((ee[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;QP(n);QP(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;QP(n);QP(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;QP(n);QP(m);i=d;return}function MS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];NS(a,0,k,j,f,g,h);i=b;return}function NS(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;l=e;m=e+32|0;n=e+40|0;o=e+56|0;p=e+72|0;q=e+80|0;r=e+240|0;s=e+248|0;t=c[h+4>>2]&74;if((t|0)==64){u=8}else if((t|0)==8){u=16}else if((t|0)==0){u=0}else{u=10}t=l;zT(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;ZP(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=a[m]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){B=m;break}if(!((ee[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){B=m;break}c[l>>2]=0;B=0}}while(0);x=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){D=18}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){if(x){E=C;break}else{F=C;G=A;break a}}if((ee[c[(c[C>>2]|0)+36>>2]&127](C)|0)==-1){c[f>>2]=0;D=18;break}else{if(x){E=C;break}else{F=C;G=A;break a}}}}while(0);if((D|0)==18){D=0;if(x){F=0;G=A;break}else{E=0}}C=a[o]|0;H=(C&1)==0;if(H){I=(C&255)>>>1}else{I=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(I|0)){if(H){J=(C&255)>>>1;K=(C&255)>>>1}else{C=c[y>>2]|0;J=C;K=C}ZP(o,K<<1,0);if((a[o]&1)==0){L=10}else{L=(c[g>>2]&-2)+ -1|0}ZP(o,L,0);if((a[o]&1)==0){M=v}else{M=c[w>>2]|0}c[p>>2]=M+J;N=M}else{N=A}C=B+12|0;H=c[C>>2]|0;O=B+16|0;if((H|0)==(c[O>>2]|0)){P=(ee[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{P=a[H]|0}if(($S(P,u,N,p,s,z,n,h,r,t)|0)!=0){F=E;G=N;break}H=c[C>>2]|0;if((H|0)==(c[O>>2]|0)){ee[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=N;continue}else{c[C>>2]=H+1;m=B;A=N;continue}}N=a[n]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[n+4>>2]|0}do{if((Q|0)!=0){N=c[r>>2]|0;if((N-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=N+4;c[N>>2]=A}}while(0);b[k>>1]=tY(G,c[p>>2]|0,j,u)|0;MV(n,h,c[r>>2]|0,j);do{if((B|0)==0){R=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){R=B;break}if(!((ee[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1)){R=B;break}c[l>>2]=0;R=0}}while(0);l=(R|0)==0;do{if((F|0)==0){D=54}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(!l){break}S=d;T=S;c[T>>2]=R;QP(o);QP(n);i=e;return}if((ee[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1){c[f>>2]=0;D=54;break}if(!(l^(F|0)==0)){break}S=d;T=S;c[T>>2]=R;QP(o);QP(n);i=e;return}}while(0);do{if((D|0)==54){if(l){break}S=d;T=S;c[T>>2]=R;QP(o);QP(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;S=d;T=S;c[T>>2]=R;QP(o);QP(n);i=e;return}function OS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];PS(a,0,k,j,f,g,h);i=b;return}function PS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;zT(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZP(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ee[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ee[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}ZP(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}ZP(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(ee[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if(($S(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){ee[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=sY(F,c[o>>2]|0,h,t)|0;MV(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((ee[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;QP(n);QP(m);i=d;return}if((ee[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;QP(n);QP(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;QP(n);QP(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;QP(n);QP(m);i=d;return}function QS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];RS(a,0,k,j,f,g,h);i=b;return}function RS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;zT(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZP(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ee[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ee[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}ZP(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}ZP(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(ee[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if(($S(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){ee[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=rY(F,c[o>>2]|0,h,t)|0;MV(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((ee[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;QP(n);QP(m);i=d;return}if((ee[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;QP(n);QP(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;QP(n);QP(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;QP(n);QP(m);i=d;return}function SS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];TS(a,0,k,j,f,g,h);i=b;return}function TS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;zT(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZP(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ee[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ee[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}ZP(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}ZP(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(ee[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if(($S(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){ee[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=qY(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;MV(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((ee[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;QP(n);QP(m);i=d;return}if((ee[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;QP(n);QP(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;QP(n);QP(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;QP(n);QP(m);i=d;return}function US(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];VS(a,0,k,j,f,g,h);i=b;return}function VS(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;AT(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;ZP(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((ee[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((ee[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}ZP(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}ZP(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(ee[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((BT(R,t,u,P,p,B,l,n,h,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){ee[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);g[k>>2]=+pY(I,c[p>>2]|0,j);MV(n,h,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((ee[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;QP(o);QP(n);i=d;return}if((ee[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;QP(o);QP(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;QP(o);QP(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;QP(o);QP(n);i=d;return}function WS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];XS(a,0,k,j,f,g,h);i=b;return}function XS(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;AT(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZP(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((ee[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((ee[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}ZP(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}ZP(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(ee[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((BT(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){ee[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+oY(I,c[p>>2]|0,j);MV(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((ee[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;QP(o);QP(n);i=d;return}if((ee[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;QP(o);QP(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;QP(o);QP(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;QP(o);QP(n);i=d;return}function YS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];ZS(a,0,k,j,f,g,h);i=b;return}function ZS(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;AT(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZP(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((ee[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((ee[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}ZP(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}ZP(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(ee[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((BT(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){ee[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+nY(I,c[p>>2]|0,j);MV(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((ee[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;QP(o);QP(n);i=d;return}if((ee[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;QP(o);QP(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;QP(o);QP(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;QP(o);QP(n);i=d;return}function _S(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;MQ(o,g);g=o;o=c[g>>2]|0;if(!((c[26644]|0)==-1)){c[l>>2]=106576;c[l+4>>2]=189;c[l+8>>2]=0;BP(106576,l,190)}l=(c[106580>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Ac(4)|0;w=v;AZ(w);x=122136;y=127;Pd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Ac(4)|0;w=v;AZ(w);x=122136;y=127;Pd(v|0,x|0,y|0)}y=m;Ae[c[(c[o>>2]|0)+32>>2]&63](o,105120,105146|0,y)|0;gP(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZP(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){C=m;break}if(!((ee[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){C=m;break}c[r>>2]=0;C=0}}while(0);B=(C|0)==0;v=c[e>>2]|0;do{if((v|0)==0){D=19}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){if(B){break}else{E=x;break a}}if((ee[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1){c[e>>2]=0;D=19;break}else{if(B){break}else{E=x;break a}}}}while(0);if((D|0)==19){D=0;if(B){E=x;break}}v=a[p]|0;w=(v&1)==0;if(w){F=(v&255)>>>1}else{F=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(F|0)){if(w){G=(v&255)>>>1;H=(v&255)>>>1}else{v=c[o>>2]|0;G=v;H=v}ZP(p,H<<1,0);if((a[p]&1)==0){I=10}else{I=(c[f>>2]&-2)+ -1|0}ZP(p,I,0);if((a[p]&1)==0){J=z}else{J=c[A>>2]|0}c[q>>2]=J+G;K=J}else{K=x}v=C+12|0;w=c[v>>2]|0;l=C+16|0;if((w|0)==(c[l>>2]|0)){L=(ee[c[(c[C>>2]|0)+36>>2]&127](C)|0)&255}else{L=a[w]|0}if(($S(L,16,K,q,t,0,n,g,s,y)|0)!=0){E=K;break}w=c[v>>2]|0;if((w|0)==(c[l>>2]|0)){ee[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=K;continue}else{c[v>>2]=w+1;m=C;x=K;continue}}a[E+3|0]=0;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);K=c[26616]|0;c[k>>2]=j;if((aT(E,K,105160,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){M=0}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){M=k;break}if(!((ee[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1)){M=k;break}c[r>>2]=0;M=0}}while(0);r=(M|0)==0;k=c[e>>2]|0;do{if((k|0)==0){D=54}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){if(!r){break}N=b;O=N;c[O>>2]=M;QP(p);QP(n);i=d;return}if((ee[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1){c[e>>2]=0;D=54;break}if(!(r^(k|0)==0)){break}N=b;O=N;c[O>>2]=M;QP(p);QP(n);i=d;return}}while(0);do{if((D|0)==54){if(r){break}N=b;O=N;c[O>>2]=M;QP(p);QP(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;N=b;O=N;c[O>>2]=M;QP(p);QP(n);i=d;return}function $S(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(a[m+24|0]|0)==b<<24>>24;if(!q){if(!((a[m+25|0]|0)==b<<24>>24)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&b<<24>>24==h<<24>>24){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+26|0;h=m;while(1){l=h+1|0;if((a[h]|0)==b<<24>>24){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;if((h|0)>23){r=-1;i=n;return r|0}do{if((d|0)==10|(d|0)==8){if((h|0)<(d|0)){break}else{r=-1}i=n;return r|0}else if((d|0)==16){if((h|0)<22){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;m=a[105120+h|0]|0;c[f>>2]=o+1;a[o]=m;r=0;i=n;return r|0}}while(0);e=a[105120+h|0]|0;c[f>>2]=o+1;a[o]=e;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function aT(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Ic(b|0)|0;b=Ua(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Ic(e|0)|0;i=f;return b|0}function bT(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function cT(a){a=a|0;i=i;return}function dT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];oe[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}MQ(u,g);m=u;u=c[m>>2]|0;if(!((c[26642]|0)==-1)){c[p>>2]=106568;c[p+4>>2]=189;c[p+8>>2]=0;BP(106568,p,190)}p=(c[106572>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Ac(4)|0;D=C;AZ(D);E=122136;F=127;Pd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Ac(4)|0;D=C;AZ(D);E=122136;F=127;Pd(C|0,E|0,F|0)}F=u;gP(c[m>>2]|0)|0;MQ(v,g);g=v;v=c[g>>2]|0;if(!((c[26682]|0)==-1)){c[o>>2]=106728;c[o+4>>2]=189;c[o+8>>2]=0;BP(106728,o,190)}o=(c[106732>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Ac(4)|0;H=G;AZ(H);I=122136;J=127;Pd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Ac(4)|0;H=G;AZ(H);I=122136;J=127;Pd(G|0,I|0,J|0)}J=v;gP(c[g>>2]|0)|0;g=w;ce[c[(c[v>>2]|0)+24>>2]&127](g,J);ce[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=eT(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];sQ(w+12|0);sQ(w);i=k;return}function eT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=VZ(l)|0;if((n|0)!=0){o=n;p=n;break}g_()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){z=ee[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{z=c[t>>2]|0}if((z|0)==-1){c[l>>2]=0;y=1;break}else{y=(c[l>>2]|0)==0;break}}}while(0);r=c[b>>2]|0;do{if((r|0)==0){A=0;B=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){C=ee[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{C=c[t>>2]|0}if(!((C|0)==-1)){A=r;B=0;break}c[b>>2]=0;A=0;B=1}}while(0);D=c[l>>2]|0;if(!((y^B)&(q|0)!=0)){break}r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){E=ee[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{E=c[r>>2]|0}if(j){F=E}else{F=re[c[(c[g>>2]|0)+28>>2]&63](g,E)|0}r=d+1|0;if(m){d=r;q=q;x=x;continue}b:do{if(j){t=0;w=e;s=x;n=q;v=p;while(1){do{if((a[v]|0)==1){u=a[w]|0;G=(u&1)==0;if(G){H=w+4|0}else{H=c[w+8>>2]|0}if((F|0)!=(c[H+(d<<2)>>2]|0)){a[v]=0;I=t;J=s;K=n+ -1|0;break}if(G){L=(u&255)>>>1}else{L=c[w+4>>2]|0}if((L|0)!=(r|0)){I=1;J=s;K=n;break}a[v]=2;I=1;J=s+1|0;K=n+ -1|0}else{I=t;J=s;K=n}}while(0);u=w+12|0;if((u|0)==(f|0)){M=I;N=J;O=K;break b}t=I;w=u;s=J;n=K;v=v+1|0}}else{v=0;n=e;s=x;w=q;t=p;while(1){do{if((a[t]|0)==1){if((a[n]&1)==0){P=n+4|0}else{P=c[n+8>>2]|0}if((F|0)!=(re[c[(c[g>>2]|0)+28>>2]&63](g,c[P+(d<<2)>>2]|0)|0)){a[t]=0;Q=v;R=s;S=w+ -1|0;break}u=a[n]|0;if((u&1)==0){T=(u&255)>>>1}else{T=c[n+4>>2]|0}if((T|0)!=(r|0)){Q=1;R=s;S=w;break}a[t]=2;Q=1;R=s+1|0;S=w+ -1|0}else{Q=v;R=s;S=w}}while(0);u=n+12|0;if((u|0)==(f|0)){M=Q;N=R;O=S;break b}v=Q;n=u;s=R;w=S;t=t+1|0}}}while(0);if(!M){d=r;x=N;q=O;continue}t=c[l>>2]|0;w=t+12|0;s=c[w>>2]|0;if((s|0)==(c[t+16>>2]|0)){ee[c[(c[t>>2]|0)+40>>2]&127](t)|0}else{c[w>>2]=s+4}if((O+N|0)>>>0<2){d=r;x=N;q=O;continue}else{U=e;V=N;W=p}while(1){do{if((a[W]|0)==2){s=a[U]|0;if((s&1)==0){X=(s&255)>>>1}else{X=c[U+4>>2]|0}if((X|0)==(r|0)){Y=V;break}a[W]=0;Y=V+ -1|0}else{Y=V}}while(0);s=U+12|0;if((s|0)==(f|0)){d=r;x=Y;q=O;continue a}else{U=s;V=Y;W=W+1|0}}}do{if((D|0)==0){Z=1}else{W=c[D+12>>2]|0;if((W|0)==(c[D+16>>2]|0)){_=ee[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{_=c[W>>2]|0}if((_|0)==-1){c[l>>2]=0;Z=1;break}else{Z=(c[l>>2]|0)==0;break}}}while(0);do{if((A|0)==0){$=85}else{l=c[A+12>>2]|0;if((l|0)==(c[A+16>>2]|0)){aa=ee[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{aa=c[l>>2]|0}if((aa|0)==-1){c[b>>2]=0;$=85;break}else{if(Z){break}else{$=87;break}}}}while(0);if(($|0)==85){if(Z){$=87}}if(($|0)==87){c[h>>2]=c[h>>2]|2}c:do{if(m){$=92}else{if((a[p]|0)==2){ba=e;break}else{ca=e;da=p}while(1){Z=ca+12|0;b=da+1|0;if((Z|0)==(f|0)){$=92;break c}if((a[b]|0)==2){ba=Z;break}else{da=b;ca=Z}}}}while(0);if(($|0)==92){c[h>>2]=c[h>>2]|4;ba=f}if((o|0)==0){i=k;return ba|0}WZ(o);i=k;return ba|0}function fT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];gT(a,0,k,j,f,g,h);i=b;return}function gT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;CT(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZP(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ee[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ee[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}ZP(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}ZP(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=ee[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((yT(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){ee[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=vY(I,c[o>>2]|0,h,t)|0;MV(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=ee[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=ee[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;QP(n);QP(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;QP(n);QP(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;QP(n);QP(m);i=d;return}function hT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];iT(a,0,k,j,f,g,h);i=b;return}function iT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;CT(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZP(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ee[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ee[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}ZP(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}ZP(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=ee[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((yT(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){ee[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=uY(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;MV(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=ee[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=ee[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;QP(n);QP(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;QP(n);QP(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;QP(n);QP(m);i=d;return}function jT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];kT(a,0,k,j,f,g,h);i=b;return}function kT(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+328|0;l=e;m=e+104|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+152|0;r=e+312|0;s=e+320|0;t=c[h+4>>2]&74;if((t|0)==0){u=0}else if((t|0)==64){u=8}else if((t|0)==8){u=16}else{u=10}t=l;CT(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;ZP(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=c[m>>2]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0;C=1}else{x=c[m+12>>2]|0;if((x|0)==(c[m+16>>2]|0)){D=ee[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{D=c[x>>2]|0}if(!((D|0)==-1)){B=m;C=0;break}c[l>>2]=0;B=0;C=1}}while(0);x=c[f>>2]|0;do{if((x|0)==0){E=21}else{F=c[x+12>>2]|0;if((F|0)==(c[x+16>>2]|0)){G=ee[c[(c[x>>2]|0)+36>>2]&127](x)|0}else{G=c[F>>2]|0}if((G|0)==-1){c[f>>2]=0;E=21;break}else{if(C){H=x;break}else{I=x;J=A;break a}}}}while(0);if((E|0)==21){E=0;if(C){I=0;J=A;break}else{H=0}}x=a[o]|0;F=(x&1)==0;if(F){K=(x&255)>>>1}else{K=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(K|0)){if(F){L=(x&255)>>>1;M=(x&255)>>>1}else{x=c[y>>2]|0;L=x;M=x}ZP(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[g>>2]&-2)+ -1|0}ZP(o,N,0);if((a[o]&1)==0){O=v}else{O=c[w>>2]|0}c[p>>2]=O+L;P=O}else{P=A}x=B+12|0;F=c[x>>2]|0;Q=B+16|0;if((F|0)==(c[Q>>2]|0)){R=ee[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{R=c[F>>2]|0}if((yT(R,u,P,p,s,z,n,h,r,t)|0)!=0){I=H;J=P;break}F=c[x>>2]|0;if((F|0)==(c[Q>>2]|0)){ee[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=P;continue}else{c[x>>2]=F+4;m=B;A=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){P=c[r>>2]|0;if((P-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=A}}while(0);b[k>>1]=tY(J,c[p>>2]|0,j,u)|0;MV(n,h,c[r>>2]|0,j);do{if((B|0)==0){T=0;U=1}else{r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){V=ee[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{V=c[r>>2]|0}if(!((V|0)==-1)){T=B;U=0;break}c[l>>2]=0;T=0;U=1}}while(0);do{if((I|0)==0){E=60}else{l=c[I+12>>2]|0;if((l|0)==(c[I+16>>2]|0)){W=ee[c[(c[I>>2]|0)+36>>2]&127](I)|0}else{W=c[l>>2]|0}if((W|0)==-1){c[f>>2]=0;E=60;break}if(!U){break}X=d;Y=X;c[Y>>2]=T;QP(o);QP(n);i=e;return}}while(0);do{if((E|0)==60){if(U){break}X=d;Y=X;c[Y>>2]=T;QP(o);QP(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;X=d;Y=X;c[Y>>2]=T;QP(o);QP(n);i=e;return}function lT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];mT(a,0,k,j,f,g,h);i=b;return}function mT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;CT(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZP(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ee[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ee[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}ZP(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}ZP(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=ee[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((yT(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){ee[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=sY(I,c[o>>2]|0,h,t)|0;MV(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=ee[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=ee[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;QP(n);QP(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;QP(n);QP(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;QP(n);QP(m);i=d;return}function nT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];oT(a,0,k,j,f,g,h);i=b;return}function oT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;CT(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZP(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ee[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ee[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}ZP(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}ZP(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=ee[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((yT(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){ee[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=rY(I,c[o>>2]|0,h,t)|0;MV(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=ee[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=ee[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;QP(n);QP(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;QP(n);QP(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;QP(n);QP(m);i=d;return}function pT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];qT(a,0,k,j,f,g,h);i=b;return}



function iM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;e=i;f=i;i=i+168|0;c[f>>2]=0;g=i;i=i+160|0;h=(c[d+536>>2]|0)+76|0;j=c[h>>2]|0;c[h>>2]=g;w_(g,1,f|0)|0;u=0;g=u;u=0;if((g|0)!=0&(v|0)!=0){k=K_(c[g>>2]|0,f)|0;if((k|0)==0){bb(g|0,v|0)}J=v}else{k=-1}if((k|0)==1){l=J}else{l=0}while(1){if((l|0)==0){u=0;k=wa(40,a|0,b|0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){m=K_(c[g>>2]|0,f)|0;if((m|0)==0){bb(g|0,v|0)}J=v}else{m=-1}if((m|0)==1){l=J;continue}if((k|0)!=0){n=1;o=17;break}c[20380]=d;u=0;Fa(57,10,185)|0;k=u;u=0;if((k|0)!=0&(v|0)!=0){p=K_(c[k>>2]|0,f)|0;if((p|0)==0){bb(k|0,v|0)}J=v}else{p=-1}if((p|0)==1){l=J;continue}u=0;k=wa(41,0,0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){q=K_(c[g>>2]|0,f)|0;if((q|0)==0){bb(g|0,v|0)}J=v}else{q=-1}if((q|0)==1){l=J;continue}u=0;sa(108,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){r=K_(c[g>>2]|0,f)|0;if((r|0)==0){bb(g|0,v|0)}J=v}else{r=-1}if((r|0)==1){l=J;continue}u=0;sa(109,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){s=K_(c[g>>2]|0,f)|0;if((s|0)==0){bb(g|0,v|0)}J=v}else{s=-1}if((s|0)==1){l=J;continue}u=0;sa(110,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){t=K_(c[g>>2]|0,f)|0;if((t|0)==0){bb(g|0,v|0)}J=v}else{t=-1}if((t|0)==1){l=J;continue}u=0;pa(c[(c[d+540>>2]|0)+8>>2]|0,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){w=K_(c[g>>2]|0,f)|0;if((w|0)==0){bb(g|0,v|0)}J=v}else{w=-1}if((w|0)==1){l=J;continue}u=0;pa(186,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){x=K_(c[g>>2]|0,f)|0;if((x|0)==0){bb(g|0,v|0)}J=v}else{x=-1}if((x|0)==1){l=J;continue}u=0;sa(99,0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){y=K_(c[g>>2]|0,f)|0;if((y|0)==0){bb(g|0,v|0)}J=v}else{y=-1}if((y|0)==1){l=J;continue}z=k}else{z=-1}c[h>>2]=j;u=0;k=u;u=0;if((k|0)!=0&(v|0)!=0){A=K_(c[k>>2]|0,f)|0;if((A|0)==0){bb(k|0,v|0)}J=v}else{A=-1}if((A|0)==1){l=J}else{break}}if((o|0)==17){i=e;return n|0}n=z;i=e;return n|0}function jM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=d;d=c[r>>2]|0;nc(81768,9,1,d|0)|0;zc(d|0,b|0,e|0)|0;Od(10,d|0)|0;qd(0)|0;i=a;return}function kM(a,b){a=a|0;b=b|0;var c=0;c=i;mM(a,b);i=c;return}function lM(a){a=a|0;i=i;return(c[a>>2]|0)==0|0}function mM(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=JQ(b+(c[(c[b>>2]|0)+ -12>>2]|0)|0)|0;i=d;return}function nM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+8|0;l=j+16|0;m=j+32|0;n=j+40|0;o=b;b=c[o>>2]|0;kB(j);if((b|0)==0){c[a>>2]=0;i=j;return}p=f;f=d;q=p-f|0;r=oM(g)|0;s=(r|0)>(q|0)?r-q|0:0;q=e;r=q-f|0;do{if((r|0)>0){if((VQ(b,d,r)|0)==(r|0)){break}kB(k);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);do{if((s|0)>0){LP(l,s,h);if((VQ(b,PP(l)|0,s)|0)==(s|0)){QP(l);break}kB(m);c[o>>2]=0;c[a>>2]=0;QP(l);i=j;return}}while(0);l=p-q|0;do{if((l|0)>0){if((VQ(b,e,l)|0)==(l|0)){break}kB(n);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);pM(g,0)|0;c[a>>2]=b;i=j;return}function oM(a){a=a|0;i=i;return c[a+12>>2]|0}function pM(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function qM(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+136|0;g=f;rM(g,16);sM(g+(c[(c[g>>2]|0)+ -12>>2]|0)|0,16)|0;if((d|0)<=0){tM(a,g);uM(g);i=f;return}j=e+ -1|0;k=(j|0)>0;l=(e|0)>0;m=g;n=(e|0)==0;e=0;do{if(k){o=0;p=e;while(1){_L(cS(m,+h[b+(p<<3)>>3])|0,83112)|0;q=p+d|0;r=o+1|0;if((r|0)<(j|0)){p=q;o=r}else{s=q;break}}}else{s=e}if(l){cS(m,+h[b+(s<<3)>>3])|0}e=e+1|0;if(!((e|0)==(d|0)|n)){_L(m,83120)|0}}while((e|0)<(d|0));tM(a,g);uM(g);i=f;return}function rM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+56|0;NQ(e);f=a;c[f>>2]=83492;g=e;c[g>>2]=83512;e=a+4|0;UR(a,83524|0,e);c[f>>2]=83492;c[g>>2]=83512;GM(e,b|16);i=d;return}function sM(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function tM(a,b){a=a|0;b=b|0;var c=0;c=i;AM(a,b+4|0);i=c;return}function uM(a){a=a|0;var b=0;b=i;KM(a,83520);IQ(a+56|0);i=b;return}function vM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+120>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[35640>>2]|0)!=0){qb(83816)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];gw(14,0,83128,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ee[c[(c[l>>2]|0)+160>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];gw(14,0,83200,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[35640>>2]|0)==0){i=d;return 0}gw(14,0,83248,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];cc(83264,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}$b(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function wM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+124>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[35640>>2]|0)!=0){qb(83816)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];gw(14,0,83128,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ee[c[(c[l>>2]|0)+164>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];gw(14,0,83200,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[35640>>2]|0)==0){i=d;return 0}gw(14,0,83248,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];cc(83264,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}$b(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function xM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+128>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[35640>>2]|0)!=0){qb(83816)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];gw(14,0,83128,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ee[c[(c[l>>2]|0)+168>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];gw(14,0,83200,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[35640>>2]|0)==0){i=d;return 0}gw(14,0,83248,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];cc(83264,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}$b(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function yM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+132>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[35640>>2]|0)!=0){qb(83816)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];gw(14,0,83128,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ee[c[(c[l>>2]|0)+172>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];gw(14,0,83200,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[35640>>2]|0)==0){i=d;return 0}gw(14,0,83248,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];cc(83264,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}$b(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function zM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+24|0;d=b;e=i;i=i+24|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=c[a+112>>2]|0;G=c[a+152>>2]|0;H=c[a+156>>2]|0;I=XZ(fa(F,F)|0,8)|0;J=I;K=XZ(fa(G,F)|0,8)|0;L=K;M=XZ(fa(H,F)|0,8)|0;N=M;O=XZ(fa(H,G)|0,8)|0;P=O;EP(p);EP(q);EP(r);EP(s);EP(t);EP(u);EP(v);Q=a+536|0;jw(c[Q>>2]|0,(I|0)!=0|0,83272,o);jw(c[Q>>2]|0,(K|0)!=0|0,83272,n);jw(c[Q>>2]|0,(M|0)!=0|0,83272,m);jw(c[Q>>2]|0,(O|0)!=0|0,83272,l);l=a+540|0;m=a;if((ee[c[(c[l>>2]|0)+140>>2]&127](m)|0)==0){n=c[Q>>2]|0;vM(a,J)|0;jw(n,1,83288,k)}qM(w,J,F,F);RP(p,w)|0;QP(w);if((ee[c[(c[l>>2]|0)+144>>2]&127](m)|0)==0){w=c[Q>>2]|0;wM(a,L)|0;jw(w,1,83320,j)}qM(x,L,F,G);RP(q,x)|0;QP(x);if((ee[c[(c[l>>2]|0)+148>>2]&127](m)|0)==0){x=c[Q>>2]|0;xM(a,N)|0;jw(x,1,83352,h)}qM(y,N,H,F);RP(r,y)|0;QP(y);if((ee[c[(c[l>>2]|0)+152>>2]&127](m)|0)==0){m=c[Q>>2]|0;yM(a,P)|0;jw(m,1,83384,g)}qM(z,P,H,G);RP(s,z)|0;QP(z);if((F|0)==0){SP(t,83416)|0}else{qM(A,c[(c[c[a+4>>2]>>2]|0)+8>>2]|0,1,F);RP(t,A)|0;QP(A)}if((G|0)==0){SP(u,83416)|0}else{qM(B,c[a+432>>2]|0,1,G);RP(u,B)|0;QP(B)}WZ(I);WZ(K);WZ(M);WZ(O);KP(E,c[a+84>>2]|0);zQ(D,83432,E);ME(C,D,83440);RP(v,C)|0;QP(C);QP(D);QP(E);E=ec(lQ(v)|0,83448)|0;D=c[Q>>2]|0;c[f>>2]=lQ(v)|0;jw(D,(E|0)!=0|0,83456,f);f=ve[c[(c[l>>2]|0)+176>>2]&7]()|0;D=lQ(t)|0;Q=lQ(u)|0;C=lQ(p)|0;a=lQ(q)|0;O=lQ(r)|0;M=lQ(s)|0;c[e>>2]=D;c[e+4>>2]=Q;c[e+8>>2]=C;c[e+12>>2]=a;c[e+16>>2]=O;c[e+20>>2]=M;sd(E|0,f|0,e|0)|0;if((c[35684>>2]|0)==0){R=qd(E|0)|0;S=Vc(E|0)|0;QP(v);QP(u);QP(t);QP(s);QP(r);QP(q);QP(p);i=b;return 0}e=ve[c[(c[l>>2]|0)+176>>2]&7]()|0;l=lQ(t)|0;f=lQ(u)|0;M=lQ(p)|0;O=lQ(q)|0;a=lQ(r)|0;C=lQ(s)|0;c[d>>2]=l;c[d+4>>2]=f;c[d+8>>2]=M;c[d+12>>2]=O;c[d+16>>2]=a;c[d+20>>2]=C;gw(25,0,e,d);R=qd(E|0)|0;S=Vc(E|0)|0;QP(v);QP(u);QP(t);QP(s);QP(r);QP(q);QP(p);i=b;return 0}function AM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;h=c[b+48>>2]|0;if((h&16|0)!=0){j=b+44|0;k=c[j>>2]|0;l=b;m=bR(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}BM(a,aR(l)|0,n,e);i=d;return}if((h&8|0)==0){FP(a,g);i=d;return}else{g=b;b=XQ(g)|0;BM(a,b,ZQ(g)|0,f);i=d;return}}function BM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;CM(a,b,c,0);i=d;return}function CM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;DM(a,b,c);i=d;return}function DM(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=EM(c,d)|0;if(g>>>0>4294967279){CP(0)}if(g>>>0<11){WP(b,g);h=VP(b)|0}else{j=bQ(g)|0;k=j+1|0;j=wF(JP(b)|0,k)|0;dQ(b,j);cQ(b,k);UP(b,g);h=j}if((c|0)==(d|0)){l=h;a[f]=0;xF(l,f);i=e;return}j=d+(0-c)|0;g=c;c=h;while(1){xF(c,g);b=g+1|0;if((b|0)==(d|0)){break}else{c=c+1|0;g=b}}l=h+j|0;a[f]=0;xF(l,f);i=e;return}function EM(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=FM(b,c,e)|0;i=d;return g|0}function FM(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return b-a|0}function GM(a,b){a=a|0;b=b|0;var c=0;c=i;WM(a,b);i=c;return}function HM(a){a=a|0;var b=0;b=i;uM(a);b_(a);i=b;return}function IM(a){a=a|0;var b=0;b=i;uM(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function JM(a){a=a|0;var b=0;b=i;HM(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function KM(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];LM(a+4|0);i=d;return}function LM(a){a=a|0;var b=0;b=i;MM(a);i=b;return}function MM(a){a=a|0;var b=0;b=i;c[a>>2]=83672;QP(a+32|0);RQ(a);i=b;return}function NM(a){a=a|0;var b=0;b=i;LM(a);b_(a);i=b;return}function OM(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=b+44|0;k=c[j>>2]|0;l=b;m=bR(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}k=g&24;do{if((k|0)==24){if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}yA(a,-1,-1);i=h;return}else if((k|0)==0){yA(a,-1,-1);i=h;return}else{if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}if((g&8|0)==0){m=bR(l)|0;j=m-(aR(l)|0)|0;p=j;q=((j|0)<0)<<31>>31;break}else{j=YQ(l)|0;m=j-(XQ(l)|0)|0;p=m;q=((m|0)<0)<<31>>31;break}}}while(0);if((o|0)==11){f=n-(PP(b+32|0)|0)|0;p=f;q=((f|0)<0)<<31>>31}else if((o|0)==12){yA(a,-1,-1);i=h;return}o=H_(p|0,q|0,d|0,e|0)|0;e=J;do{if(!((e|0)<0|(e|0)==0&o>>>0<0)){d=n-(PP(b+32|0)|0)|0;q=((d|0)<0)<<31>>31;if((q|0)<(e|0)|(q|0)==(e|0)&d>>>0<o>>>0){break}d=g&8;do{if(!((o|0)==0&(e|0)==0)){do{if((d|0)!=0){if((YQ(l)|0)!=0){break}yA(a,-1,-1);i=h;return}}while(0);if((g&16|0)==0){break}if((bR(l)|0)!=0){break}yA(a,-1,-1);i=h;return}}while(0);if((d|0)!=0){q=XQ(l)|0;$Q(l,q,q+o|0,n)}if((g&16|0)!=0){q=aR(l)|0;eR(l,q,cR(l)|0);dR(l,o)}yA(a,o,e);i=h;return}}while(0);yA(a,-1,-1);i=h;return}function PM(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[b>>2]|0)+16>>2]|0;h=MB(d)|0;me[g&31](a,b,h,J,0,e);i=f;return}function QM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+44|0;f=c[e>>2]|0;g=b;h=bR(g)|0;if(f>>>0<h>>>0){c[e>>2]=h;j=h}else{j=f}if((c[b+48>>2]&8|0)==0){k=-1;i=d;return k|0}if((ZQ(g)|0)>>>0<j>>>0){b=XQ(g)|0;$Q(g,b,YQ(g)|0,j)}j=YQ(g)|0;if(!(j>>>0<(ZQ(g)|0)>>>0)){k=-1;i=d;return k|0}k=iC(a[j]|0)|0;i=d;return k|0}function RM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+44|0;g=c[f>>2]|0;h=b;j=bR(h)|0;if(g>>>0<j>>>0){c[f>>2]=j;k=j}else{k=g}g=XQ(h)|0;j=YQ(h)|0;if(!(g>>>0<j>>>0)){l=-1;i=e;return l|0}if(eC(d,-1)|0){$Q(h,g,j+ -1|0,k);l=hC(d)|0;i=e;return l|0}g=(c[b+48>>2]&16|0)==0;b=fC(d)|0;do{if(g){if(jC(b,a[j+ -1|0]|0)|0){break}else{l=-1}i=e;return l|0}}while(0);j=XQ(h)|0;$Q(h,j,(YQ(h)|0)+ -1|0,k);a[YQ(h)|0]=b;l=d;i=e;return l|0}function SM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;if(eC(b,-1)|0){f=hC(b)|0;i=d;return f|0}g=a;h=YQ(g)|0;j=h-(XQ(g)|0)|0;h=bR(g)|0;do{if((h|0)==(cR(g)|0)){k=a+48|0;if((c[k>>2]&16|0)==0){f=-1;i=d;return f|0}else{l=aR(g)|0;m=a+44|0;n=(c[m>>2]|0)-l|0;o=a+32|0;gQ(o,0);$P(o,YP(o)|0);p=PP(o)|0;eR(g,p,p+(OP(o)|0)|0);dR(g,h-l|0);c[m>>2]=(aR(g)|0)+n;q=k;r=m;break}}else{q=a+48|0;r=a+44|0}}while(0);c[e>>2]=(bR(g)|0)+1;h=c[(TM(e,r)|0)>>2]|0;c[r>>2]=h;if((c[q>>2]&8|0)!=0){q=PP(a+32|0)|0;$Q(g,q,q+j|0,h)}f=UQ(g,b&255)|0;i=d;return f|0}function TM(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=UM(b,c,e)|0;i=d;return g|0}function UM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=VM(0,a,b)|0;i=c;return(d?b:a)|0}function VM(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function WM(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;WQ(a);c[a>>2]=83672;EP(a+32|0);c[a+44>>2]=0;c[a+48>>2]=b;EP(e);XM(a,e);QP(e);i=d;return}function XM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+32|0;RP(e,b)|0;b=a+44|0;c[b>>2]=0;f=a+48|0;g=c[f>>2]|0;if((g&8|0)==0){h=g}else{g=PP(e)|0;j=g+(OP(e)|0)|0;c[b>>2]=j;g=PP(e)|0;$Q(a,g,g,j);h=c[f>>2]|0}if((h&16|0)==0){i=d;return}h=OP(e)|0;c[b>>2]=(PP(e)|0)+h;$P(e,YP(e)|0);b=a;a=PP(e)|0;eR(b,a,a+(OP(e)|0)|0);if((c[f>>2]&3|0)==0){i=d;return}dR(b,h);i=d;return}function YM(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0;j=i;i=i+8|0;g=j;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=ec(d|0,84096)|0;J=_c(84104,84096)|0;K=(J|0)!=0;L=Kc()|0;if(K){M=c[b+536>>2]|0;N=Sd(c[L>>2]|0)|0;c[E>>2]=d;c[E+4>>2]=N;jw(M,(I|0)!=0|0,84160,E);nc(84184,17,1,J|0)|0;nc(84208,10,1,J|0)|0;nc(84224,18,1,J|0)|0;ZM(J,f,84248,c[b+88>>2]|0,(c[b+72>>2]|0)+(c[b+64>>2]|0)|0,-1,999,84280)}else{c[G>>2]=Sd(c[L>>2]|0)|0;iw(26,0,84112,G);G=c[b+536>>2]|0;E=Sd(c[L>>2]|0)|0;c[F>>2]=d;c[F+4>>2]=E;jw(G,(I|0)!=0|0,84160,F)}nc(84288,348,1,I|0)|0;if((oc(H|0)|0)<0){c[D>>2]=Sd(c[L>>2]|0)|0;iw(26,0,84640,D);Vc(I|0)|0;Za(J|0)|0;O=1;i=j;return O|0}if((Pc(83840,250,84664,hd(H|0)|0)|0)==0){iw(26,0,84688,C);Vc(I|0)|0;O=1;i=j;return O|0}nc(84712,13,1,I|0)|0;nc(84728,12,1,I|0)|0;_M(I,2);nc(84744,6,1,I|0)|0;$M(I,c[b+84>>2]|0);nc(84752,8,1,I|0)|0;_M(I,2);nc(84768,8,1,I|0)|0;C=b+88|0;$M(I,c[C>>2]|0);nc(84784,10,1,I|0)|0;_M(I,2);nc(84800,6,1,I|0)|0;$M(I,83840);nc(84808,8,1,I|0)|0;_M(I,2);nc(84824,8,1,I|0)|0;$M(I,c[b+280>>2]|0);nc(84840,10,1,I|0)|0;_M(I,2);nc(84856,14,1,I|0)|0;$M(I,c[b+284>>2]|0);nc(84872,16,1,I|0)|0;_M(I,2);nc(84896,16,1,I|0)|0;$M(I,l);nc(84920,18,1,I|0)|0;_M(I,2);c[B>>2]=aN(l)|0;sd(I|0,84944,B|0)|0;_M(I,2);P=+ex(7);B=A;h[k>>3]=P;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];sd(I|0,84984,A|0)|0;_M(I,2);P=+ex(6);A=z;h[k>>3]=P;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];sd(I|0,85024,z|0)|0;_M(I,2);P=+ex(1);z=y;h[k>>3]=P;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];sd(I|0,85056,y|0)|0;_M(I,2);P=+ex(4);y=x;h[k>>3]=P;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];sd(I|0,85088,x|0)|0;_M(I,2);P=+ex(3);x=w;h[k>>3]=P;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];sd(I|0,85120,w|0)|0;_M(I,2);P=+ex(5);w=v;h[k>>3]=P;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];sd(I|0,85152,v|0)|0;_M(I,2);P=+ex(0);v=u;h[k>>3]=P;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];sd(I|0,85192,u|0)|0;_M(I,2);P=+hx(2);u=t;h[k>>3]=P;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];sd(I|0,85224,t|0)|0;_M(I,2);c[s>>2]=cx(2)|0;sd(I|0,85264,s|0)|0;_M(I,2);P=+gx(2);s=r;h[k>>3]=P;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];sd(I|0,85288,r|0)|0;nc(85320,13,1,I|0)|0;nc(85336,16,1,I|0)|0;_M(I,2);P=+ex(8);r=q;h[k>>3]=P;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];sd(I|0,85360,q|0)|0;_M(I,2);c[p>>2]=$w(8)|0;sd(I|0,85384,p|0)|0;nc(85424,17,1,I|0)|0;nc(85448,22,1,I|0)|0;bN(I,b);nc(85472,23,1,I|0)|0;nc(85496,12,1,I|0)|0;p=b+116|0;if((c[p>>2]|0)>0){q=b+8|0;r=0;do{cN(I,(c[q>>2]|0)+(r*112|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+136|0;if((c[p>>2]|0)>0){r=b+24|0;q=0;do{cN(I,(c[r>>2]|0)+(q*112|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+124|0;if((c[p>>2]|0)>0){q=b+12|0;r=0;do{cN(I,(c[q>>2]|0)+(r*60|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+140|0;if((c[p>>2]|0)>0){r=b+28|0;q=0;do{cN(I,(c[r>>2]|0)+(q*60|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+128|0;if((c[p>>2]|0)>0){q=b+16|0;r=0;do{cN(I,(c[q>>2]|0)+(r*48|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+144|0;if((c[p>>2]|0)>0){r=b+32|0;q=0;do{cN(I,(c[r>>2]|0)+(q*48|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+132|0;if((c[p>>2]|0)>0){q=b+20|0;r=0;do{cN(I,(c[q>>2]|0)+(r*52|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+148|0;if((c[p>>2]|0)>0){r=b+36|0;q=0;do{cN(I,(c[r>>2]|0)+(q*52|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}nc(85512,13,1,I|0)|0;nc(85528,12,1,I|0)|0;dN(I,J,f,c[C>>2]|0,b);nc(85544,13,1,I|0)|0;nc(85560,12,1,I|0)|0;eN(I,c[b+68>>2]|0,b+56|0);nc(85576,13,1,I|0)|0;nc(85592,16,1,I|0)|0;fN(I,J,f,b);nc(85616,17,1,I|0)|0;nc(85640,14,1,I|0)|0;Vc(I|0)|0;if(!K){O=0;i=j;return O|0}K=c[b+508>>2]|0;b=((x_(e|0)|0)<<1)+230|0;e=(K|0)!=0;if(e){Q=(x_(K|0)|0)<<1}else{Q=0}I=VZ(b+Q|0)|0;if((I|0)==0){$a(85656,85664,404,85688)}if((Za(J|0)|0)!=0){iw(26,0,85704,o)}if(e){e=c[C>>2]|0;c[n>>2]=85736;c[n+4>>2]=e;c[n+8>>2]=K;c[n+12>>2]=e;dc(I|0,85752,n|0)|0;if((od(I|0)|0)!=0){R=42}}else{n=I+0|0;e=85832|0;K=n+25|0;do{a[n]=a[e]|0;n=n+1|0;e=e+1|0}while((n|0)<(K|0));R=42}if((R|0)==42){c[m>>2]=I;iw(1,0,85864,m)}m=c[C>>2]|0;c[g>>2]=m;c[g+4>>2]=m;gw(1,0,85928,g);WZ(I);O=0;i=j;return O|0}function ZM(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0;m=i;i=i+24|0;n=m;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+24|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+24|0;C=i;i=i+8|0;D=i;i=i+16|0;if((a|0)==0){i=m;return}E=(g|0)>-1;if(E){F=g+9|0;G=ax(F)|0;H=bx(F)|0;if((G|0)==0){I=-.01}else{I=+(G>>>0)*.95}if((H|0)==0){J=.01}else{J=+(H>>>0)*1.05}K=H;L=G;M=+gx(F)*1.01+1.0e-30;N=J;O=I}else{K=0;L=0;M=0.0;N=0.0;O=0.0}nc(84184,17,1,a|0)|0;nc(87096,12,1,a|0)|0;nc(87112,12,1,a|0)|0;nc(87128,13,1,a|0)|0;c[D>>2]=e;c[D+4>>2]=l;c[D+8>>2]=j;sd(a|0,87144,D|0)|0;nc(87184,10,1,a|0)|0;nc(87200,11,1,a|0)|0;nc(87216,11,1,a|0)|0;nc(87232,10,1,a|0)|0;if(E){D=C;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];sd(a|0,87248,C|0)|0}else{nc(87272,17,1,a|0)|0}C=g+3|0;c[B>>2]=e;c[B+4>>2]=f;c[B+8>>2]=f;c[B+12>>2]=C;c[B+16>>2]=C;c[B+20>>2]=4;sd(a|0,86872,B|0)|0;nc(87296,13,1,a|0)|0;if(E){nc(87112,12,1,a|0)|0;if((L|0)==(K|0)){B=A;h[k>>3]=O;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=N;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];sd(a|0,87312,A|0)|0}else{nc(87272,17,1,a|0)|0}c[z>>2]=e;c[z+4>>2]=l;c[z+8>>2]=j;sd(a|0,87336,z|0)|0;c[y>>2]=e;c[y+4>>2]=f;c[y+8>>2]=f;c[y+12>>2]=g+1;c[y+16>>2]=4;sd(a|0,86992,y|0)|0;nc(87384,10,1,a|0)|0;nc(87400,10,1,a|0)|0;nc(87384,10,1,a|0)|0;nc(87416,11,1,a|0)|0;c[x>>2]=b;sd(a|0,87432,x|0)|0;c[w>>2]=d;sd(a|0,87456,w|0)|0;nc(87472,33,1,a|0)|0;nc(87512,32,1,a|0)|0;c[v>>2]=e;c[v+4>>2]=l;c[v+8>>2]=j;c[v+12>>2]=b;sd(a|0,87552,v|0)|0;nc(87232,10,1,a|0)|0;v=u;h[k>>3]=M;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];sd(a|0,87248,u|0)|0}else{nc(87400,10,1,a|0)|0;nc(87384,10,1,a|0)|0;nc(87416,11,1,a|0)|0;c[t>>2]=b;sd(a|0,87432,t|0)|0;c[s>>2]=d;sd(a|0,87456,s|0)|0;nc(87472,33,1,a|0)|0;nc(87512,32,1,a|0)|0;c[r>>2]=e;c[r+4>>2]=l;c[r+8>>2]=j;c[r+12>>2]=b;sd(a|0,87552,r|0)|0;nc(87232,10,1,a|0)|0;nc(87272,17,1,a|0)|0}c[q>>2]=e;c[q+4>>2]=f;c[q+8>>2]=f;c[q+12>>2]=C;c[q+16>>2]=C;c[q+20>>2]=2;sd(a|0,86872,q|0)|0;nc(87296,13,1,a|0)|0;if(!E){i=m;return}if((L|0)==(K|0)){K=p;h[k>>3]=O;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=p+8|0;h[k>>3]=N;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];sd(a|0,87312,p|0)|0}else{nc(87272,17,1,a|0)|0}nc(87584,32,1,a|0)|0;nc(87624,29,1,a|0)|0;c[o>>2]=e;c[o+4>>2]=l;c[o+8>>2]=j;c[o+12>>2]=b;sd(a|0,87656,o|0)|0;c[n>>2]=e;c[n+4>>2]=f;c[n+8>>2]=f;c[n+12>>2]=g+1;c[n+16>>2]=2;sd(a|0,86992,n|0)|0;i=m;return}function _M(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)==0){i=c;return}else{d=b}do{d=d+ -1|0;Od(32,a|0)|0;}while((d|0)!=0);i=c;return}function $M(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;e=a[c]|0;if(e<<24>>24==0){i=d;return}else{f=c;g=e}do{e=g<<24>>24;if((e|0)==39){nc(86856,6,1,b|0)|0}else if((e|0)==34){nc(86864,6,1,b|0)|0}else if((e|0)==60){nc(86840,4,1,b|0)|0}else if((e|0)==62){nc(86848,4,1,b|0)|0}else{Od(e|0,b|0)|0}f=f+1|0;g=a[f]|0;}while(!(g<<24>>24==0));i=d;return}function aN(a){a=a|0;var b=0,c=0,d=0;b=i;c=ec(a|0,86832)|0;if((c|0)==0){d=-1;i=b;return d|0}Tc(c|0,0,2)|0;a=vb(c|0)|0;Vc(c|0)|0;d=a;i=b;return d|0}function bN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;h=i;i=i+24|0;j=i;i=i+32|0;k=i;i=i+24|0;l=c[b+88>>2]|0;m=VZ((x_(l|0)|0)+15|0)|0;c[f>>2]=l;dc(m|0,86560,f|0)|0;_M(a,2);nc(86576,10,1,a|0)|0;$M(a,m);nc(86592,12,1,a|0)|0;_M(a,2);c[e>>2]=aN(m)|0;sd(a|0,86608,e|0)|0;WZ(m);_M(a,2);nc(86640,9,1,a|0)|0;_M(a,4);nc(86656,22,1,a|0)|0;_M(a,4);nc(86680,22,1,a|0)|0;_M(a,4);nc(86704,26,1,a|0)|0;m=b+56|0;e=b+64|0;f=c[e>>2]|0;if((f|0)>0){l=g+4|0;n=0;while(1){hN(g,m,n);o=c[l>>2]|0;_M(a,4);nc(86736,8,1,a|0)|0;$M(a,o);nc(86752,18,1,a|0)|0;o=n+1|0;p=c[e>>2]|0;if((o|0)<(p|0)){n=o}else{q=p;break}}}else{q=f}f=b+72|0;b=c[f>>2]|0;if((b|0)>0){n=h+8|0;l=0;do{mN(h,m,l);g=c[n>>2]|0;_M(a,4);nc(86736,8,1,a|0)|0;$M(a,g);nc(86752,18,1,a|0)|0;l=l+1|0;r=c[f>>2]|0;}while((l|0)<(r|0));s=r;t=c[e>>2]|0}else{s=b;t=q}if((t|0)>0){t=j+4|0;q=0;do{hN(j,m,q);b=c[t>>2]|0;_M(a,4);nc(86776,8,1,a|0)|0;$M(a,b);nc(86792,21,1,a|0)|0;q=q+1|0;}while((q|0)<(c[e>>2]|0));u=c[f>>2]|0}else{u=s}if((u|0)<=0){_M(a,2);v=86816;w=v;x=nc(w|0,10,1,a|0)|0;i=d;return}u=k+8|0;s=0;do{mN(k,m,s);e=c[u>>2]|0;_M(a,4);nc(86776,8,1,a|0)|0;$M(a,e);nc(86792,21,1,a|0)|0;s=s+1|0;}while((s|0)<(c[f>>2]|0));_M(a,2);v=86816;w=v;x=nc(w|0,10,1,a|0)|0;i=d;return}function cN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+24|0;_M(a,2);c[f>>2]=c[b>>2];sd(a|0,86496,f|0)|0;$M(a,c[b+4>>2]|0);nc(86528,11,1,a|0)|0;$M(a,c[b+8>>2]|0);nc(86200,3,1,a|0)|0;f=e;g=b+12|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];gN(a,4,e);_M(a,2);nc(86544,12,1,a|0)|0;i=d;return}function dN(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+32|0;q=f+64|0;if((c[q>>2]|0)<=0){i=g;return}r=f+56|0;s=p+4|0;t=f+72|0;f=p;u=p+8|0;v=0;do{hN(p,r,v);ZM(b,d,c[s>>2]|0,e,(c[t>>2]|0)+(c[q>>2]|0)|0,v,c[f>>2]|0,86312);w=v+9|0;kx(w);_M(a,2);c[o>>2]=c[f>>2];sd(a|0,86320,o|0)|0;_M(a,4);nc(84744,6,1,a|0)|0;$M(a,c[s>>2]|0);nc(84752,8,1,a|0)|0;_M(a,4);c[n>>2]=cx(w)|0;sd(a|0,86096,n|0)|0;_M(a,4);x=+hx(w);y=m;h[k>>3]=x;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];sd(a|0,86120,m|0)|0;_M(a,4);x=+gx(w);w=l;h[k>>3]=x;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];sd(a|0,85288,l|0)|0;w=j;y=u;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];gN(a,6,j);_M(a,2);nc(86344,12,1,a|0)|0;v=v+1|0;}while((v|0)<(c[q>>2]|0));i=g;return}function eN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;if((b|0)<=0){i=e;return}q=l;r=m+8|0;s=n+12|0;t=d+8|0;u=d+16|0;v=o;w=p;x=0;do{_M(a,2);lN(l,d,x);c[j>>2]=c[q>>2];sd(a|0,86168,j|0)|0;lN(m,d,x);$M(a,c[r>>2]|0);nc(86200,3,1,a|0)|0;_M(a,4);nc(86208,7,1,a|0)|0;lN(n,d,x);if((c[s>>2]|0)>0){y=0;do{_M(a,6);c[g>>2]=0;sd(a|0,86216,g|0)|0;y=y+1|0;lN(n,d,x);}while((y|0)<(c[s>>2]|0))}_M(a,4);nc(86240,8,1,a|0)|0;_M(a,4);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;lN(o,d,x);z=+ex(y+(c[v>>2]|0)|0);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;lN(p,d,x);A=$w(y+(c[w>>2]|0)|0)|0;y=f;h[k>>3]=z;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[f+8>>2]=A;sd(a|0,86256,f|0)|0;_M(a,2);nc(86296,12,1,a|0)|0;x=x+1|0;}while((x|0)<(b|0));i=e;return}function fN(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=e+56|0;p=e+64|0;q=c[p>>2]|0;r=e+72|0;if((c[r>>2]|0)<=0){i=f;return}s=n+8|0;t=e+88|0;e=n;u=q;v=q;do{mN(n,o,v-u|0);ZM(b,d,c[s>>2]|0,c[t>>2]|0,(c[r>>2]|0)+(c[p>>2]|0)|0,v,c[e>>2]|0,86048);q=v+9|0;kx(q);_M(a,2);nc(86056,15,1,a|0)|0;_M(a,4);c[m>>2]=c[e>>2];sd(a|0,86072,m|0)|0;_M(a,4);c[l>>2]=cx(q)|0;sd(a|0,86096,l|0)|0;_M(a,4);w=+hx(q);x=j;h[k>>3]=w;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];sd(a|0,86120,j|0)|0;_M(a,4);w=+gx(q);q=g;h[k>>3]=w;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];sd(a|0,85288,g|0)|0;_M(a,2);nc(86144,16,1,a|0)|0;v=v+1|0;u=c[p>>2]|0;}while((v|0)<((c[r>>2]|0)+u|0));i=f;return}function gN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;_M(a,b);nc(86360,16,1,a|0)|0;$M(a,c[d>>2]|0);b=c[d+8>>2]|0;g=c[d+12>>2]|0;h=c[d+16>>2]|0;j=(c[d+20>>2]|0)!=0?86464:86480;c[f>>2]=c[d+4>>2];c[f+4>>2]=b;c[f+8>>2]=g;c[f+12>>2]=h;c[f+16>>2]=j;sd(a|0,86384,f|0)|0;i=e;return}function hN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+24>>2]|0)==0){iN(b)}f=a;a=(c[b+20>>2]|0)+(d<<5)|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];i=e;return}function iN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+1024|0;c[h>>2]=a;k=h+4|0;c[k>>2]=1;l=h+8|0;c[l>>2]=0;m=h+12|0;c[m>>2]=0;n=a+4|0;do{if((c[n>>2]|0)==0){o=a;p=ec(c[o>>2]|0,87696)|0;if((p|0)!=0){q=p;break}p=Sd(c[(Kc()|0)>>2]|0)|0;c[g>>2]=c[o>>2];c[g+4>>2]=p;kw(0,87704,g)}else{q=0}}while(0);g=hr(0)|0;if((g|0)==0){kw(0,87736,f)}f=a+8|0;c[a+20>>2]=XZ(c[f>>2]|0,32)|0;p=a+12|0;o=XZ((c[p>>2]|0)+1|0,20)|0;c[a+24>>2]=o;c[o>>2]=0;c[o+4>>2]=-1;c[o+8>>2]=87768;c[o+12>>2]=0;c[o+16>>2]=0;sr(g,h);tr(g,8,107);h=c[n>>2]|0;do{if((h|0)==0){o=j;B_(o|0,0,1024)|0;while(1){r=pb(o|0,1,1024,q|0)|0;s=r>>>0<1024;if((ur(g,o,r,s&1)|0)==0){t=9;break}if(s){t=11;break}}if((t|0)==9){o=Cr(zr(g)|0)|0;s=Ar(g)|0;Vc(q|0)|0;or(g);r=c[a>>2]|0;c[e>>2]=87872;c[e+4>>2]=r;c[e+8>>2]=o;c[e+12>>2]=s;kw(0,87808,e)}else if((t|0)==11){Vc(q|0)|0;break}}else{if((ur(g,h,x_(h|0)|0,1)|0)!=0){break}s=Cr(zr(g)|0)|0;o=Ar(g)|0;or(g);r=c[n>>2]|0;c[d>>2]=87872;c[d+4>>2]=r;c[d+8>>2]=s;c[d+12>>2]=o;kw(0,87912,d)}}while(0);if((c[p>>2]|0)!=(c[k>>2]|0)){$a(87976,87872,295,88016)}c[a+16>>2]=c[l>>2];if((c[f>>2]|0)==(c[m>>2]|0)){i=b;return}else{$a(88040,87872,297,88016)}}function jN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=c[a>>2]|0;n=c[a+4>>2]|0;o=c[a+12>>2]|0;if((t_(88448,b)|0)==0){if((t_(c[d>>2]|0,88456)|0)==0){p=(c[d+8>>2]|0)==0|0}else{p=0}jw(0,p,88464,l);l=c[22076]|0;p=c[22130]|0;do{if((l|0)==0|(p|0)==0){c[22130]=32;a=VZ(1152)|0;c[22076]=a;q=m+24|0;r=a}else{a=m+24|0;s=a;if(((c[(c[a>>2]|0)+(n*20|0)+12>>2]|0)+2|0)<(p|0)){q=s;r=l;break}c[22130]=p<<1;a=YZ(l,p*72|0)|0;c[22076]=a;q=s;r=a}}while(0);p=(c[q>>2]|0)+(n*20|0)+12|0;q=c[p>>2]|0;c[p>>2]=q+1;p=r+(q*36|0)+0|0;q=(pN(c[d+4>>2]|0)|0)+0|0;r=p+36|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=e;return}if((t_(88528,b)|0)==0){q=c[d>>2]|0;if((q|0)==0){i=e;return}else{t=d;u=q}a:while(1){do{if((t_(88536,u)|0)==0){c[22136]=wd(c[t+4>>2]|0)|0}else{if((t_(88568,u)|0)==0){c[88548>>2]=Rb(c[t+4>>2]|0,0,10)|0;break}if((t_(88584,u)|0)==0){c[88556>>2]=Rb(c[t+4>>2]|0,0,10)|0;break}if((t_(88592,u)|0)==0){c[88552>>2]=Rb(c[t+4>>2]|0,0,10)|0;break}if((t_(88608,u)|0)==0){c[88560>>2]=Rb(c[t+4>>2]|0,0,10)|0;break}if((t_(88616,u)|0)!=0){v=23;break a}c[88564>>2]=(t_(c[t+4>>2]|0,88632)|0)==0}}while(0);q=t+8|0;p=c[q>>2]|0;if((p|0)==0){v=45;break}else{t=q;u=p}}if((v|0)==23){c[k>>2]=c[m>>2];kw(0,88640,k)}else if((v|0)==45){i=e;return}}if((t_(88288,b)|0)==0){v=c[m+12>>2]|0;if((n|0)>(v|0)){k=c[m>>2]|0;c[j>>2]=87872;c[j+4>>2]=k;c[j+8>>2]=v;kw(0,88672,j)}if((t_(88736,c[d>>2]|0)|0)!=0){j=c[m>>2]|0;c[h>>2]=87872;c[h+4>>2]=j;kw(0,88744,h)}h=Rb(c[d+4>>2]|0,0,10)|0;if((n|0)!=(h|0)){j=c[m>>2]|0;c[g>>2]=87872;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=n;kw(0,88800,g)}g=m+24|0;h=c[g>>2]|0;c[h+(n*20|0)>>2]=n;c[h+(n*20|0)+4>>2]=-1;c[h+(n*20|0)+8>>2]=88864;h=c[g>>2]|0;c[h+(n*20|0)+12>>2]=0;c[h+(n*20|0)+16>>2]=0;i=e;return}if((t_(88232,b)|0)!=0){if((t_(88424,b)|0)!=0){i=e;return}b=m+20|0;m=c[b>>2]|0;c[m+(o<<5)>>2]=o;c[m+(o<<5)+4>>2]=88968;m=wd(c[d+4>>2]|0)|0;c[(c[b>>2]|0)+(o<<5)+4>>2]=m;c[(c[b>>2]|0)+(o<<5)+8>>2]=88976;i=e;return}c[88252>>2]=0;c[88256>>2]=0;o=c[d>>2]|0;do{if((o|0)==0){w=0}else{b=d;m=o;do{do{if((t_(m,88456)|0)==0){c[88252>>2]=wd(c[b+4>>2]|0)|0}else{if((t_(m,88920)|0)!=0){break}c[88256>>2]=wd(c[b+4>>2]|0)|0}}while(0);b=b+8|0;m=c[b>>2]|0;}while((m|0)!=0);if((c[88252>>2]|0)==0){w=0;break}w=(c[88256>>2]|0)!=0|0}}while(0);jw(0,w,88928,f);c[22062]=-1;f=88260|0;w=88544;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[f+20>>2]=c[w+20>>2];i=e;return}function kN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d;f=d+40|0;g=i;i=i+8|0;h=c[a>>2]|0;j=a+4|0;k=c[j>>2]|0;l=a+8|0;m=c[l>>2]|0;n=a+12|0;a=c[n>>2]|0;if((t_(88232,b)|0)==0){o=e+0|0;p=88248|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));oN(e);i=d;return}if((t_(88288,b)|0)==0){e=h+24|0;r=VZ((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)*36|0)|0;c[(c[e>>2]|0)+(k*20|0)+16>>2]=r;if((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)>0){r=0;do{s=VZ(36)|0;t=s;o=s+0|0;p=(c[22076]|0)+(r*36|0)+0|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));c[(c[(c[e>>2]|0)+(k*20|0)+16>>2]|0)+(r<<2)>>2]=t;r=r+1|0;}while((r|0)<(c[(c[e>>2]|0)+(k*20|0)+12>>2]|0))}c[j>>2]=k+1;i=d;return}if((t_(88312,b)|0)==0){j=h+24|0;e=c[j>>2]|0;r=c[e+(k*20|0)+12>>2]|0;c[g>>2]=k;c[g+4>>2]=r;xd(e+(k*20|0)+8|0,88320,g|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((t_(88360,b)|0)==0){j=h+24|0;h=c[j>>2]|0;g=c[h+(k*20|0)+12>>2]|0;c[f>>2]=k;c[f+4>>2]=g;xd(h+(k*20|0)+8|0,88376,f|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((t_(88424,b)|0)!=0){i=d;return}c[n>>2]=a+1;i=d;return}function lN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==0){iN(b);h=c[f>>2]|0}else{h=g}g=a;a=h+(d*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}function mN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=b+24|0;if((c[h>>2]|0)==0){iN(b)}j=c[b+16>>2]|0;if(j>>>0<d>>>0){c[g>>2]=d;c[g+4>>2]=j;kw(0,88080,g)}g=c[b+12>>2]|0;if((g|0)<=0){k=f;l=k;c[l>>2]=d;m=4;n=m;o=88160;p=o;kw(0,p,f)}b=c[h>>2]|0;h=0;while(1){j=h+1|0;if((c[b+(h*20|0)+4>>2]|0)==(d|0)){q=9;break}if((j|0)<(g|0)){h=j}else{q=10;break}}if((q|0)==9){g=a;a=b+(h*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}else if((q|0)==10){k=f;l=k;c[l>>2]=d;m=4;n=m;o=88160;p=o;kw(0,p,f)}}function nN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){WZ(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=a+12|0;if((c[f>>2]|0)>0){a=e;g=0;while(1){WZ(c[a+(g*20|0)+16>>2]|0);c[(c[d>>2]|0)+(g*20|0)+16>>2]=0;h=g+1|0;j=c[d>>2]|0;if((h|0)<(c[f>>2]|0)){g=h;a=j}else{k=j;break}}}else{k=e}WZ(k);c[d>>2]=0;i=b;return}function oN(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;b=i;e=VZ(72)|0;f=c[a+4>>2]|0;c[e>>2]=f;g=e+4|0;h=a+0|0;a=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(a|0));h=e+40|0;j=h;c[e+48>>2]=0;c[e+60>>2]=f;k=x_(f|0)|0;c[e+64>>2]=k;k=c[22110]|0;do{if((k|0)==0){c[22110]=e;c[e+44>>2]=0;l=VZ(44)|0;m=l;c[e+40>>2]=m;if((l|0)==0){rc(-1)}g=l+0|0;a=g+44|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(a|0));c[l+16>>2]=e+40;c[l+4>>2]=32;c[l+8>>2]=5;c[l+20>>2]=40;n=VZ(384)|0;c[l>>2]=n;if((n|0)==0){rc(-1)}else{B_(n|0,0,384)|0;c[l+40>>2]=-1609490463;o=f;p=m;break}}else{c[(c[(c[k+40>>2]|0)+16>>2]|0)+8>>2]=e;n=(c[22110]|0)+40|0;q=c[n>>2]|0;c[e+44>>2]=(c[q+16>>2]|0)+(0-(c[q+20>>2]|0));c[(c[n>>2]|0)+16>>2]=j;o=c[e>>2]|0;p=c[(c[22110]|0)+40>>2]|0}}while(0);k=p+12|0;c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=p;p=e+68|0;c[p>>2]=-17973521;k=x_(o|0)|0;if(k>>>0>11){f=-17973521;g=-1640531527;a=-1640531527;n=k;q=o;do{r=((d[q+5|0]|0)<<8|(d[q+4|0]|0)|(d[q+6|0]|0)<<16|(d[q+7|0]|0)<<24)+a|0;s=((d[q+9|0]|0)<<8|(d[q+8|0]|0)|(d[q+10|0]|0)<<16|(d[q+11|0]|0)<<24)+f|0;t=((d[q+1|0]|0)<<8|(d[q]|0)|(d[q+2|0]|0)<<16|(d[q+3|0]|0)<<24)+g-r-s^s>>>13;u=r-s-t^t<<8;r=s-t-u^u>>>13;s=t-u-r^r>>>12;t=u-r-s^s<<16;u=r-s-t^t>>>5;g=s-t-u^u>>>3;a=t-u-g^g<<10;f=u-g-a^a>>>15;c[p>>2]=f;q=q+12|0;n=n+ -12|0;}while(n>>>0>11);v=f;w=c[e>>2]|0;x=g;y=a;z=n;A=q}else{v=-17973521;w=o;x=-1640531527;y=-1640531527;z=k;A=o}o=v+(x_(w|0)|0)|0;c[p>>2]=o;switch(z|0){case 7:{B=o;C=y;D=16;break};case 1:{E=o;F=x;G=y;D=22;break};case 11:{z=((d[A+10|0]|0)<<24)+o|0;c[p>>2]=z;H=z;D=13;break};case 2:{I=o;J=x;K=y;D=21;break};case 10:{H=o;D=13;break};case 5:{L=o;M=y;D=18;break};case 8:{N=o;D=15;break};case 4:{O=o;P=y;D=19;break};case 9:{Q=o;D=14;break};case 6:{R=o;S=y;D=17;break};case 3:{T=o;U=x;V=y;D=20;break};default:{W=o;X=x;Y=y}}if((D|0)==13){o=((d[A+9|0]|0)<<16)+H|0;c[p>>2]=o;Q=o;D=14}if((D|0)==14){o=((d[A+8|0]|0)<<8)+Q|0;c[p>>2]=o;N=o;D=15}if((D|0)==15){B=N;C=((d[A+7|0]|0)<<24)+y|0;D=16}if((D|0)==16){R=B;S=((d[A+6|0]|0)<<16)+C|0;D=17}if((D|0)==17){L=R;M=((d[A+5|0]|0)<<8)+S|0;D=18}if((D|0)==18){O=L;P=(d[A+4|0]|0)+M|0;D=19}if((D|0)==19){T=O;U=((d[A+3|0]|0)<<24)+x|0;V=P;D=20}if((D|0)==20){I=T;J=((d[A+2|0]|0)<<16)+U|0;K=V;D=21}if((D|0)==21){E=I;F=((d[A+1|0]|0)<<8)+J|0;G=K;D=22}if((D|0)==22){W=E;X=(d[A]|0)+F|0;Y=G}G=X-Y-W^W>>>13;X=Y-W-G^G<<8;Y=W-G-X^X>>>13;W=G-X-Y^Y>>>12;G=X-Y-W^W<<16;X=Y-W-G^G>>>5;Y=W-G-X^X>>>3;W=G-X-Y^Y<<10;G=X-Y-W^W>>>15;c[p>>2]=G;p=(c[22110]|0)+40|0;W=c[p>>2]|0;Y=G&(c[W+4>>2]|0)+ -1;G=c[W>>2]|0;W=G+(Y*12|0)+4|0;c[W>>2]=(c[W>>2]|0)+1;c[e+56>>2]=c[G+(Y*12|0)>>2];c[e+52>>2]=0;e=c[c[p>>2]>>2]|0;p=c[e+(Y*12|0)>>2]|0;if((p|0)==0){Z=e}else{c[p+12>>2]=j;Z=c[c[(c[22110]|0)+40>>2]>>2]|0}c[Z+(Y*12|0)>>2]=j;j=c[c[(c[22110]|0)+40>>2]>>2]|0;if((c[j+(Y*12|0)+4>>2]|0)>>>0<(((c[j+(Y*12|0)+8>>2]|0)*10|0)+10|0)>>>0){i=b;return}Y=c[h>>2]|0;if((c[Y+36>>2]|0)==1){i=b;return}j=Y+4|0;Z=VZ((c[j>>2]|0)*24|0)|0;p=Z;if((Z|0)==0){rc(-1)}B_(Z|0,0,(c[j>>2]|0)*24|0)|0;e=c[Y+12>>2]|0;G=c[j>>2]|0;c[Y+24>>2]=(((G<<1)+ -1&e|0)!=0)+(e>>>((c[Y+8>>2]|0)+1|0));c[Y+28>>2]=0;e=c[Y>>2]|0;if((G|0)==0){_=e}else{G=Y;Y=e;e=0;while(1){j=c[Y+(e*12|0)>>2]|0;if((j|0)==0){$=G}else{W=G;X=j;while(1){j=X+16|0;F=c[j>>2]|0;A=(c[W+4>>2]<<1)+ -1&c[X+28>>2];E=Z+(A*12|0)+4|0;D=(c[E>>2]|0)+1|0;c[E>>2]=D;K=c[W+24>>2]|0;if(D>>>0>K>>>0){D=W+28|0;c[D>>2]=(c[D>>2]|0)+1;c[Z+(A*12|0)+8>>2]=((c[E>>2]|0)>>>0)/(K>>>0)|0}c[X+12>>2]=0;K=Z+(A*12|0)|0;c[j>>2]=c[K>>2];j=c[K>>2]|0;if((j|0)!=0){c[j+12>>2]=X}c[K>>2]=X;K=c[h>>2]|0;if((F|0)==0){$=K;break}else{W=K;X=F}}}X=e+1|0;W=c[$>>2]|0;if(X>>>0<(c[$+4>>2]|0)>>>0){G=$;Y=W;e=X}else{_=W;break}}}WZ(_);_=c[h>>2]|0;e=_+4|0;c[e>>2]=c[e>>2]<<1;e=_+8|0;c[e>>2]=(c[e>>2]|0)+1;c[_>>2]=p;p=c[h>>2]|0;h=p+32|0;if(!((c[p+28>>2]|0)>>>0>(c[p+12>>2]|0)>>>1>>>0)){c[h>>2]=0;i=b;return}_=(c[h>>2]|0)+1|0;c[h>>2]=_;if(!(_>>>0>1)){i=b;return}c[p+36>>2]=1;i=b;return}function pN(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+8|0;e=b;a:do{if((c[22110]|0)==0){f=24}else{g=x_(a|0)|0;if(g>>>0>11){h=-17973521;j=-1640531527;k=-1640531527;l=g;m=a;while(1){n=((d[m+5|0]|0)<<8|(d[m+4|0]|0)|(d[m+6|0]|0)<<16|(d[m+7|0]|0)<<24)+k|0;o=((d[m+9|0]|0)<<8|(d[m+8|0]|0)|(d[m+10|0]|0)<<16|(d[m+11|0]|0)<<24)+h|0;p=((d[m+1|0]|0)<<8|(d[m]|0)|(d[m+2|0]|0)<<16|(d[m+3|0]|0)<<24)+j-n-o^o>>>13;q=n-o-p^p<<8;n=o-p-q^q>>>13;o=p-q-n^n>>>12;p=q-n-o^o<<16;q=n-o-p^p>>>5;n=o-p-q^q>>>3;o=p-q-n^n<<10;p=q-n-o^o>>>15;q=m+12|0;r=l+ -12|0;if(r>>>0>11){m=q;l=r;k=o;j=n;h=p}else{s=p;t=n;u=o;v=r;w=q;break}}}else{s=-17973521;t=-1640531527;u=-1640531527;v=g;w=a}h=(x_(a|0)|0)+s|0;switch(v|0){case 3:{x=h;y=t;z=u;f=13;break};case 9:{A=h;f=7;break};case 7:{B=h;C=u;f=9;break};case 1:{D=h;E=t;F=u;f=15;break};case 11:{G=((d[w+10|0]|0)<<24)+h|0;f=6;break};case 6:{H=h;I=u;f=10;break};case 8:{J=h;f=8;break};case 10:{G=h;f=6;break};case 2:{K=h;L=t;M=u;f=14;break};case 5:{N=h;O=u;f=11;break};case 4:{P=h;Q=u;f=12;break};default:{R=h;S=t;T=u}}if((f|0)==6){A=((d[w+9|0]|0)<<16)+G|0;f=7}if((f|0)==7){J=((d[w+8|0]|0)<<8)+A|0;f=8}if((f|0)==8){B=J;C=((d[w+7|0]|0)<<24)+u|0;f=9}if((f|0)==9){H=B;I=((d[w+6|0]|0)<<16)+C|0;f=10}if((f|0)==10){N=H;O=((d[w+5|0]|0)<<8)+I|0;f=11}if((f|0)==11){P=N;Q=(d[w+4|0]|0)+O|0;f=12}if((f|0)==12){x=P;y=((d[w+3|0]|0)<<24)+t|0;z=Q;f=13}if((f|0)==13){K=x;L=((d[w+2|0]|0)<<16)+y|0;M=z;f=14}if((f|0)==14){D=K;E=((d[w+1|0]|0)<<8)+L|0;F=M;f=15}if((f|0)==15){R=D;S=(d[w]|0)+E|0;T=F}h=S-R-T^R>>>13;j=T-R-h^h<<8;k=R-h-j^j>>>13;l=h-j-k^k>>>12;h=j-k-l^l<<16;j=k-l-h^h>>>5;k=l-h-j^j>>>3;l=h-j-k^k<<10;h=c[(c[22110]|0)+40>>2]|0;m=c[(c[h>>2]|0)+(((j-k-l^l>>>15)&(c[h+4>>2]|0)+ -1)*12|0)>>2]|0;if((m|0)==0){f=24;break}l=m+(0-(c[h+20>>2]|0))|0;if((l|0)==0){f=24;break}m=x_(a|0)|0;k=l;while(1){U=k;if((c[k+64>>2]|0)==(m|0)){if((s_(c[k+60>>2]|0,a,m)|0)==0){break}}l=c[k+56>>2]|0;if((l|0)==0){f=24;break a}j=l+(0-(c[h+20>>2]|0))|0;if((j|0)==0){f=24;break a}else{k=j}}if((k|0)==0){f=24}else{V=U}}}while(0);do{if((f|0)==24){if((Bb(a|0,89e3)|0)==0){V=0;break}else{W=89024}i=b;return W|0}}while(0);c[e>>2]=a;jw(0,(V|0)!=0|0,89072,e);W=V+4|0;i=b;return W|0}function qN(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((rN(89128,a,b)|0)!=0){d=1;i=c;return d|0}d=(rN(89136,a,b)|0)!=0|0;i=c;return d|0}function rN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)>0){g=0}else{h=0;i=f;return h|0}while(1){j=c[e+(g<<2)>>2]|0;if((a[j]|0)==45){if((t_(b,j+1|0)|0)==0){h=1;k=5;break}}j=g+1|0;if((j|0)<(d|0)){g=j}else{h=0;k=5;break}}if((k|0)==5){i=f;return h|0}return 0}function sN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=(t_(c[40052>>2]|0,89144)|0)==0|0;jw(0,m,89160,l);l=(t_(c[41956>>2]|0,89144)|0)==0|0;jw(0,l,89216,k);k=(t_(c[43948>>2]|0,89144)|0)==0|0;jw(0,k,89272,j);j=89336|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=89464|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((a|0)>1){n=1}else{o=0;i=d;return o|0}a:while(1){p=b+(n<<2)|0;j=n+1|0;k=1;while(1){l=c[43952+(k<<2)>>2]|0;if((l|0)==1){if((rN(c[39928+(k<<2)>>2]|0,1,p)|0)!=0){q=5;break}}else if((l|0)==2){r=c[39928+(k<<2)>>2]|0;if(!((rN(r,1,p)|0)==0|(j|0)>=(a|0))){q=9;break}s=c[39928+(k<<2)>>2]|0;if((uN(s,p)|0)!=0){q=13;break}}l=k+1|0;if((l|0)<31){k=l}else{q=17;break a}}if((q|0)==5){q=0;l=89336+(k<<2)|0;if((c[l>>2]|0)!=0){q=6;break}c[l>>2]=1;t=n}else if((q|0)==9){q=0;l=89336+(k<<2)|0;if((c[l>>2]|0)!=0){q=10;break}c[l>>2]=1;c[89464+(k<<2)>>2]=tN(r,p)|0;t=j}else if((q|0)==13){q=0;l=89336+(k<<2)|0;if((c[l>>2]|0)!=0){q=14;break}c[l>>2]=1;c[89464+(k<<2)>>2]=vN(s,p)|0;t=n}l=t+1|0;if((l|0)<(a|0)){n=l}else{o=0;q=19;break}}if((q|0)==6){c[h>>2]=c[p>>2];iw(1,0,89592,h);o=1;i=d;return o|0}else if((q|0)==10){c[g>>2]=c[p>>2];iw(1,0,89592,g);o=1;i=d;return o|0}else if((q|0)==14){c[f>>2]=c[p>>2];iw(1,0,89592,f);o=1;i=d;return o|0}else if((q|0)==17){c[e>>2]=c[p>>2];iw(1,0,89648,e);o=1;i=d;return o|0}else if((q|0)==19){i=d;return o|0}return 0}function tN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;do{if((a[f]|0)==45){if((t_(b,f+1|0)|0)!=0){g=0;break}g=c[d+4>>2]|0}else{g=0}}while(0);i=e;return g|0}function uN(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(vN(a,b)|0)!=0|0;i=c;return d|0}function vN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=x_(b|0)|0;g=c[d>>2]|0;if((a[g]|0)!=45){h=0;i=e;return h|0}if((u_(b,g+1|0,f)|0)!=0){h=0;i=e;return h|0}if((a[g+(f+1)|0]|0)!=61){h=0;i=e;return h|0}h=g+(f+2)|0;i=e;return h|0}function wN(){i=i;return}function xN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)<=0){rc(0)}e=c[r>>2]|0;nc(89680,5,1,e|0)|0;f=b;b=0;while(1){Od(a[f]|0,e|0)|0;g=b+1|0;if((g|0)<(d|0)){b=g;f=f+1|0}else{break}}nc(89688,20,1,e|0)|0;rc(0);return 0}function yN(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;e=d;d=c[r>>2]|0;c[e>>2]=a;sd(d|0,89712,e|0)|0;if((b|0)==0){rc(1)}else{qd(d|0)|0;GN();qd(d|0)|0;fb(6,0)|0;ed()}}function zN(a,b){a=a|0;b=b|0;var c=0.0;c=+W(+(+h[a>>3]),+(+h[b>>3]));i=i;return+c}function AN(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0.0,g=0.0,j=0,k=0.0,l=0.0;d=i;e=+h[a>>3];a=c[b>>2]|0;if((a|0)==0){f=1.0;i=d;return+f}if((a|0)<0){g=1.0;j=0-a|0;k=1.0/e}else{g=1.0;j=a;k=e}while(1){if((j&1|0)==0){l=g}else{l=g*k}a=j>>>1;if((a|0)==0){f=l;break}g=l;j=a;k=k*k}i=d;return+f}function BN(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0;c=i;d=+h[a>>3];if(!(d>=0.0)){e=-d}else{e=d}if(+h[b>>3]>=0.0){f=e;i=c;return+f}f=-e;i=c;return+f}function CN(a){a=a|0;var b=0.0,c=0.0,d=0.0;b=+g[a>>2];c=b;if(!(b>=0.0)){d=-+T(+(.5-c))}else{d=+T(+(c+.5))}i=i;return~~d|0}function DN(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=b+d|0;h=c+e|0;if((d|0)>(e|0)){a:do{if((e|0)>0){j=b;k=c;while(1){l=a[j]|0;m=a[k]|0;if(!(l<<24>>24==m<<24>>24)){break}n=j+1|0;o=k+1|0;if(o>>>0<h>>>0){j=n;k=o}else{p=n;break a}}q=(l&255)-(m&255)|0;i=f;return q|0}else{p=b}}while(0);if(p>>>0<g>>>0){r=p}else{q=0;i=f;return q|0}while(1){s=a[r]|0;p=r+1|0;if(!(s<<24>>24==32)){break}if(p>>>0<g>>>0){r=p}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=(s&255)+ -32|0;i=f;return q|0}else{b:do{if((d|0)>0){s=b;r=c;while(1){u=a[s]|0;v=a[r]|0;if(!(u<<24>>24==v<<24>>24)){break}p=s+1|0;m=r+1|0;if(p>>>0<g>>>0){s=p;r=m}else{w=m;break b}}q=(u&255)-(v&255)|0;i=f;return q|0}else{w=c}}while(0);if(w>>>0<h>>>0){x=w}else{q=0;i=f;return q|0}while(1){y=a[x]|0;w=x+1|0;if(!(y<<24>>24==32)){break}if(w>>>0<h>>>0){x=w}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=32-(y&255)|0;i=f;return q|0}return 0}function EN(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=c;h=b+d|0;if((d|0)<=(e|0)){do{if(b>>>0>c>>>0){j=c+d|0;if(!(j>>>0>b>>>0)){break}if((d|0)>0){k=j;l=h}else{i=f;return}do{k=k+ -1|0;l=l+ -1|0;a[l]=a[k]|0;}while(l>>>0>b>>>0);i=f;return}}while(0);if((d|0)>0){m=c;n=b}else{i=f;return}while(1){l=n+1|0;a[n]=a[m]|0;if(l>>>0<h>>>0){n=l;m=m+1|0}else{break}}i=f;return}m=c+e|0;do{if(b>>>0>c>>>0&m>>>0>b>>>0){n=b+e|0;if((e|0)>0){l=0-g-e|0;k=~g;j=~(c+(l>>>0>k>>>0?l:k));k=n;l=m;do{l=l+ -1|0;k=k+ -1|0;a[k]=a[l]|0;}while(l>>>0>c>>>0);o=b+j|0}else{o=n}p=o+e|0}else{if((e|0)<=0){p=b;break}l=c+1|0;k=(m>>>0>l>>>0?m:l)+(0-g)|0;l=b;q=c;while(1){r=q+1|0;a[l]=a[q]|0;if(r>>>0<m>>>0){q=r;l=l+1|0}else{break}}p=b+k|0}}while(0);if(!(p>>>0<h>>>0)){i=f;return}B_(p|0,32,b+(d-p)|0)|0;i=f;return}function FN(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+4>>2]|0;if((e|0)>99){i=d;return 0}f=90752+(e*48|0)|0;g=c[f>>2]|0;if((g|0)!=0){do{if((c[90796+(e*48|0)>>2]|0)==1){h=10}else{j=c[b+8>>2]|0;if((j|0)!=0){k=a[j]|0;if((k|0)==100|(k|0)==68){h=10;break}}if((c[90792+(e*48|0)>>2]|0)==1){HN(b)|0}k=90756+(e*48|0)|0;if((c[k>>2]|0)==0){break}Vc(c[f>>2]|0)|0;WZ(c[k>>2]|0)}}while(0);do{if((h|0)==10){Vc(g|0)|0;b=90756+(e*48|0)|0;k=c[b>>2]|0;if((k|0)==0){break}Fd(k|0)|0;WZ(c[b>>2]|0)}}while(0);c[f>>2]=0}c[90788+(e*48|0)>>2]=0;c[90756+(e*48|0)>>2]=0;i=d;return 0}function GN(){var a=0,b=0;a=i;if((c[22430]|0)!=0){i=a;return}c[22430]=1;c[89728>>2]=0;b=0;do{c[89724>>2]=b;FN(89720)|0;b=b+1|0;}while((b|0)<100);i=a;return}function HN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+4>>2]|0;if((c[90768+(d*48|0)>>2]|0)!=0){e=0;i=b;return e|0}f=90752+(d*48|0)|0;g=c[f>>2]|0;h=vb(g|0)|0;Tc(g|0,0,2)|0;if((h|0)>=(vb(g|0)|0)){e=0;i=b;return e|0}if((c[90772+(d*48|0)>>2]|0)==0){e=0;i=b;return e|0}if((c[90780+(d*48|0)>>2]&2|0)!=0){qd(c[f>>2]|0)|0}d=Qc(ob(c[f>>2]|0)|0,h|0)|0;Tc(c[f>>2]|0,0,2)|0;if((d|0)==0){e=0;i=b;return e|0}if((c[a>>2]|0)==0){JN(111,89736);e=111;i=b;return e|0}else{c[(Kc()|0)>>2]=111;e=111;i=b;return e|0}return 0}function IN(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+80|0;d=b;do{if((Ya(ob(a|0)|0,d|0)|0)<0){e=0}else{f=c[d+12>>2]&61440;if((f|0)==24576){e=1;break}else if((f|0)==8192){e=(rb(ob(a|0)|0)|0)==0|0;break}else if((f|0)==32768|(f|0)==16384){e=(c[d+16>>2]|0)!=0|0;break}else{e=0;break}}}while(0);i=b;return e|0}function JN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;d=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;do{if(a>>>0<100){Nc(b|0);l=c[r>>2]|0}else{if((a+1|0)>>>0>132){m=c[r>>2]|0;c[k>>2]=b;c[k+4>>2]=a;sd(m|0,90648,k|0)|0;l=m;break}m=c[r>>2]|0;if((a|0)==-1){c[j>>2]=b;sd(m|0,90680,j|0)|0;l=m;break}else{n=c[90520+(a+ -100<<2)>>2]|0;c[h>>2]=b;c[h+4>>2]=n;sd(m|0,90704,h|0)|0;l=m;break}}}while(0);h=c[22678]|0;do{if((h|0)==0){nc(95584,29,1,l|0)|0}else{c[g>>2]=(h-90752|0)/48|0;sd(l|0,90720,g|0)|0;b=c[(c[22678]|0)+4>>2]|0;if((b|0)==0){nc(95568,10,1,l|0)|0;break}else{c[f>>2]=b;sd(l|0,95552,f|0)|0;break}}}while(0);f=c[23904]|0;if((f|0)!=0){c[d>>2]=f;sd(l|0,95624,d|0)|0}d=(c[23924]|0)!=0?95704:95720;f=(c[23932]|0)!=0?95736:95752;g=(c[23942]|0)!=0?95776:95792;c[e>>2]=(c[23918]|0)!=0?95680:95688;c[e+4>>2]=d;c[e+8>>2]=f;c[e+12>>2]=g;sd(l|0,95648,e|0)|0;yN(95808,1)}function KN(){var a=0,b=0;a=i;c[23954]=1;b=c[r>>2]|0;c[22688]=b;c[90772>>2]=IN(b)|0;c[90776>>2]=1;c[90792>>2]=1;b=c[s>>2]|0;c[90992>>2]=b;c[91012>>2]=IN(b)|0;c[91016>>2]=1;c[91032>>2]=0;b=c[t>>2]|0;c[91040>>2]=b;c[91060>>2]=IN(b)|0;c[91064>>2]=1;c[91080>>2]=1;i=a;return}function LN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+28|0;e=c[d>>2]|0;a:do{if((e&2|0)==0){f=a+4|0;g=c[f>>2]|0;do{if((g|0)!=0){if((c[a+16>>2]|0)==0){h=c[a+24>>2]|0}else{h=0}if((c[a+40>>2]|0)==3){j=a;k=tc(g|0,c[101064+(h<<2)>>2]|0,c[j>>2]|0)|0;c[j>>2]=k;c[23956]=k;if((k|0)==0){break}c[d>>2]=2;break a}k=a;j=vb(c[k>>2]|0)|0;l=tc(c[f>>2]|0,c[101064+((h|2)<<2)>>2]|0,c[k>>2]|0)|0;c[k>>2]=l;c[23956]=l;if((l|0)==0){c[k>>2]=0;break}else{c[d>>2]=3;Tc(c[k>>2]|0,j|0,0)|0;break a}}}while(0);c[(Kc()|0)>>2]=127;m=1;i=b;return m|0}else{if((e&1|0)==0){break}Tc(c[a>>2]|0,0,1)|0}}while(0);c[a+40>>2]=1;m=0;i=b;return m|0}function MN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((a|0)==0){JN(b,d)}d=c[23958]|0;if((d|0)!=0){ve[d&7]()|0}c[(Kc()|0)>>2]=b;i=e;return b|0}function NN(a){a=a|0;var b=0,d=0;b=i;c[23988]=0;c[23990]=0;c[23992]=0;d=((ON(a,0)|0)==0)<<31>>31;i=b;return d|0}function ON(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b;while(1){b=a[f]|0;g=f+1|0;if(b<<24>>24==32){f=g}else if(b<<24>>24==40){break}else{h=0;j=8;break}}if((j|0)==8){i=e;return h|0}j=c[23992]|0;c[23992]=j+1;if((j|0)==1){c[23990]=d}if((TN(1,d,0,0)|0)<0){h=0;i=e;return h|0}d=UN(g)|0;if((d|0)==0){h=0;i=e;return h|0}else{k=d}while(1){if((a[k]|0)==32){k=k+1|0}else{h=k;break}}i=e;return h|0}function PN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;e=i;i=i+8|0;f=e;if((c[a>>2]|0)>0){g=b;h=0}else{j=0;i=e;return j|0}a:while(1){b=(g|0)==0;b:while(1){k=c[23988]|0;l=95976+(k<<4)|0;m=c[l>>2]|0;switch(QN(m)|0){case 6:{n=c[95980+(k<<4)>>2]|0;o=(c[25204]|0)+1|0;c[25204]=o;c[100824+(o<<2)>>2]=n;c[23988]=k+1;continue b;break};case 33:{c[25232]=1;c[23988]=k+1;continue b;break};case 1:{n=c[95980+(k<<4)>>2]|0;o=(c[25220]|0)+1|0;c[25220]=o;c[100888+(o<<2)>>2]=n;c[23988]=k+1;continue b;break};case 19:case 17:{c[23964]=0;c[23988]=k+1;continue b;break};case 20:{c[23984]=c[95980+(k<<4)>>2];c[23988]=k+1;continue b;break};case 2:{c[25204]=0;c[25220]=0;c[23988]=c[95980+(k<<4)>>2];if(b){p=24;break a}if((c[25216]|0)==0){j=0;p=37;break a}n=ve[c[23974]&7]()|0;if((n|0)==0){continue b}else{j=n;p=37;break a}break};case 16:{if(b){p=28;break a}c[23988]=k+1;continue b;break};case 8:{n=c[25204]|0;q=100824+(n<<2)|0;s=c[q>>2]|0;if((s|0)>=1){p=10;break b}c[25204]=n+ -1;c[23988]=k+1;continue b;break};case 3:{n=c[25204]|0;o=100824+(n<<2)|0;t=c[o>>2]|0;c[o>>2]=t+ -1;if((t|0)<2){c[25204]=n+ -1;c[25220]=(c[25220]|0)+ -1;c[23988]=k+1;continue b}else{n=c[25220]|0;c[25220]=n+ -1;c[23988]=(c[100888+(n<<2)>>2]|0)+1;continue b}break};case 22:{c[23966]=1;c[23988]=k+1;continue b;break};case 21:{c[23966]=0;c[23988]=k+1;continue b;break};case 9:{n=(ee[c[23972]&127](l)|0)==0;c[23988]=(c[23988]|0)+1;if(n){break b}else{continue b}break};case 18:{c[23964]=1;c[23988]=k+1;continue b;break};default:{p=4;break a}}}if((p|0)==10){p=0;if(b){p=11;break}c[q>>2]=s+ -1;c[25216]=1;k=ie[c[23970]&63](l,g,d)|0;if((k|0)>0){p=13;break}if((k|0)<0){p=15;break}}k=h+1|0;if((k|0)<(c[a>>2]|0)){g=g+d|0;h=k}else{j=0;p=37;break}}if((p|0)==4){h=c[r>>2]|0;d=c[23904]|0;c[f>>2]=m;c[f+4>>2]=d;sd(h|0,100776,f|0)|0;if((c[c[23960]>>2]|0)==0){JN(100,100808);j=100;i=e;return j|0}else{c[(Kc()|0)>>2]=100;j=100;i=e;return j|0}}else if((p|0)==11){j=ve[c[23958]&7]()|0;i=e;return j|0}else if((p|0)==13){f=c[c[23960]>>2]|0;j=MN(f,c[(Kc()|0)>>2]|0,100872)|0;i=e;return j|0}else if((p|0)==15){if((c[(c[23960]|0)+8>>2]|0)==0){JN(-1,100872);j=-1;i=e;return j|0}else{c[(Kc()|0)>>2]=-1;j=-1;i=e;return j|0}}else if((p|0)==24){j=ve[c[23958]&7]()|0;i=e;return j|0}else if((p|0)==28){j=ve[c[23958]&7]()|0;i=e;return j|0}else if((p|0)==37){i=e;return j|0}return 0}function QN(a){a=a|0;var b=0;switch(a|0){case 26:case 25:case 24:case 29:case 34:case 32:case 31:case 30:case 10:case 7:case 23:case 27:case 28:case 35:case 36:{b=8;break};case 14:case 13:case 15:case 12:case 11:case 5:case 4:{b=9;break};default:{b=a}}i=i;return b|0}function RN(){var a=0,b=0,d=0;a=i;i=i+8|0;b=a;c[b>>2]=1;d=PN(b,0,0)|0;i=a;return d|0}function SN(){c[23980]=0;c[23988]=0;c[25220]=0;c[25204]=0;c[25216]=0;c[25222]=0;c[25206]=0;i=i;return}function TN(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[23988]|0;if((g|0)>299){nc(100952,24,1,c[r>>2]|0)|0;yN(c[23904]|0,1)}else{c[95976+(g<<4)>>2]=a;c[95980+(g<<4)>>2]=b;c[95984+(g<<4)>>2]=d;c[95988+(g<<4)>>2]=e;c[23988]=g+1;i=f;return g|0}return 0}function UN(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a[b]|0;if(e<<24>>24==0){f=0;i=d;return f|0}else{g=b;h=e}a:while(1){e=g+1|0;if(h<<24>>24==32){h=a[e]|0;g=e;continue}e=VN(g)|0;if((e|0)==0){f=0;j=12;break}else{k=e}while(1){e=a[k]|0;if(e<<24>>24==41){j=9;break a}else if(e<<24>>24==44){j=7;break}else if(!(e<<24>>24==32)){l=k;break}k=k+1|0}if((j|0)==7){j=0;l=k+1|0}e=a[l]|0;if(e<<24>>24==0){f=0;j=12;break}else{g=l;h=e}}if((j|0)==9){h=(c[23992]|0)+ -1|0;c[23992]=h;if((h|0)==0){TN(2,c[23990]|0,0,0)|0;f=k+1|0;i=d;return f|0}else{TN(3,0,0,0)|0;f=k+1|0;i=d;return f|0}}else if((j|0)==12){i=d;return f|0}return 0}function VN(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;do{if((a[b]|0)==41){g=b}else{if((WN(b,e)|0)!=0){g=c[e>>2]|0;break}if((XN(b,e)|0)!=0){g=c[e>>2]|0;break}h=YN(b,f,1)|0;j=TN(6,c[f>>2]|0,0,0)|0;if((j|0)<0){g=0;break}g=ON(h,j)|0}}while(0);i=d;return g|0}function WN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;a:do{switch(a[b]|0){case 112:case 80:{TN(20,1,0,0)|0;g=b;h=30;break};case 47:{TN(5,0,0,0)|0;g=b;h=30;break};case 58:{TN(16,0,0,0)|0;g=b;h=30;break};case 115:case 83:{j=b+1|0;k=a[j]|0;if(k<<24>>24==80|k<<24>>24==112){l=j;m=18}else if(k<<24>>24==83|k<<24>>24==115){l=j;m=19}else{l=b;m=17}TN(m,0,0,0)|0;g=l;h=30;break};case 45:{n=1;h=13;break};case 39:case 34:case 2:{c[95984+((TN(11,0,0,0)|0)<<4)>>2]=b;j=ZN(b)|0;c[d>>2]=j;o=(j|0)!=0|0;i=e;return o|0};case 98:case 66:{j=b+1|0;k=a[j]|0;if(k<<24>>24==90|k<<24>>24==122){TN(22,0,0,0)|0;g=j;h=30;break a}else{TN(21,0,0,0)|0;g=j;h=30;break a}break};case 120:case 88:{TN(4,1,0,0)|0;g=b;h=30;break};case 36:{TN(33,0,0,0)|0;g=b;h=30;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{p=b;q=0;h=14;break};case 43:{n=0;h=13;break};case 116:case 84:{j=b+1|0;k=a[j]|0;if(k<<24>>24==76|k<<24>>24==108){r=j;s=13}else if(k<<24>>24==82|k<<24>>24==114){r=j;s=14}else{r=b;s=15}j=YN(r+1|0,f,0)|0;if((j|0)==0){h=15;break a}TN(s,c[f>>2]|0,0,0)|0;g=j+ -1|0;h=30;break};default:{o=0;i=e;return o|0}}}while(0);if((h|0)==13){p=b+1|0;q=n;h=14}b:do{if((h|0)==14){n=YN(p,f,0)|0;if((n|0)==0){h=15;break}switch(a[n]|0){case 120:case 88:{TN(4,c[f>>2]|0,0,0)|0;g=n;h=30;break b;break};case 104:case 72:{b=c[f>>2]|0;c[95984+((TN(12,b,0,0)|0)<<4)>>2]=n+1;g=n+b|0;h=30;break b;break};case 112:case 80:{b=c[f>>2]|0;if((q|0)==0){t=b}else{s=0-b|0;c[f>>2]=s;t=s}TN(20,t,0,0)|0;g=n;h=30;break b;break};default:{o=0;i=e;return o|0}}}}while(0);if((h|0)==15){c[d>>2]=0;o=1;i=e;return o|0}else if((h|0)==30){c[d>>2]=g+1;o=1;i=e;return o|0}return 0}function XN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=YN(b,f,1)|0;TN(6,c[f>>2]|0,0,0)|0;f=k+1|0;a:do{switch(a[k]|0){case 111:case 79:{l=32;m=34;n=38;break};case 97:case 65:{o=f;while(1){p=a[o]|0;if(p<<24>>24==32){o=o+1|0}else{break}}if(!((p+ -48<<24>>24&255)<10)){TN(30,0,0,0)|0;q=o;n=45;break a}r=YN(o,g,1)|0;s=c[g>>2]|0;if((s|0)==0){q=r;n=45;break a}TN(31,s,0,0)|0;q=r;n=45;break};case 105:case 73:{l=7;m=10;n=38;break};case 103:case 71:{t=0;n=3;break};case 102:case 70:{r=YN(f,g,0)|0;if((r|0)==0){n=4;break a}s=c[g>>2]|0;if((s|0)==0){q=r;n=45;break a}if((a[r]|0)==46){u=YN(r+1|0,h,0)|0;if((u|0)==0){n=4;break a}v=u;w=c[h>>2]|0}else{c[h>>2]=0;v=r;w=0}TN(23,s,w,0)|0;q=v;n=45;break};case 122:case 90:{l=35;m=36;n=38;break};case 101:case 69:{t=1;n=3;break};case 108:case 76:{s=YN(f,g,0)|0;if((s|0)==0){n=4;break a}r=c[g>>2]|0;if((r|0)==0){q=s;n=45;break a}TN(29,r,0,0)|0;q=s;n=45;break};case 100:case 68:{s=YN(f,g,0)|0;if((s|0)==0){n=4;break a}r=c[g>>2]|0;if((r|0)==0){q=s;n=45;break a}if((a[s]|0)==46){u=YN(s+1|0,h,0)|0;if((u|0)==0){n=4;break a}x=u;y=c[h>>2]|0}else{c[h>>2]=0;x=s;y=0}TN(26,r,y,0)|0;q=x;n=45;break};default:{c[23988]=(c[23988]|0)+ -1;c[d>>2]=b;z=0;i=e;return z|0}}}while(0);do{if((n|0)==3){b=YN(f,g,0)|0;if((b|0)==0){n=4;break}x=c[g>>2]|0;if((x|0)==0){q=b;n=45;break}y=a[b]|0;if(y<<24>>24==46){v=YN(b+1|0,h,0)|0;if((v|0)==0){n=4;break}A=v;B=a[v]|0}else{c[h>>2]=0;A=b;B=y}if(!(B<<24>>24==101|B<<24>>24==69)){TN((t|0)==1?24:27,x,c[h>>2]|0,0)|0;q=A;n=45;break}y=YN(A+1|0,j,0)|0;if((y|0)==0){n=4;break}TN((t|0)==1?25:28,x,c[h>>2]|0,c[j>>2]|0)|0;q=y;n=45}else if((n|0)==38){y=YN(f,g,0)|0;if((y|0)==0){n=4;break}x=c[g>>2]|0;if((x|0)==0){q=y;n=45;break}if((a[y]|0)!=46){TN(l,x,0,0)|0;q=y;n=45;break}b=YN(y+1|0,h,0)|0;if((b|0)==0){n=4;break}TN(m,x,c[h>>2]|0,0)|0;q=b;n=45}}while(0);if((n|0)==4){c[d>>2]=0;z=1;i=e;return z|0}else if((n|0)==45){c[d>>2]=q;z=1;i=e;return z|0}return 0}function YN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b;b=0;h=0;while(1){j=a[g]|0;k=j<<24>>24;if(j<<24>>24==32){l=b;m=h}else{if((j+ -48<<24>>24&255)>9){break}l=b+1|0;m=(h*10|0)+ -48+k|0}g=g+1|0;b=l;h=m}if((b|0)!=0){n=g;o=h;c[d>>2]=o;i=f;return n|0}n=(e|0)==0?0:g;o=e;c[d>>2]=o;i=f;return n|0}function ZN(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a[b]|0;f=b+1|0;g=a[f]|0;a:do{if(!(g<<24>>24==0)){h=f;j=g;k=b;while(1){if(j<<24>>24==e<<24>>24){l=k+2|0;if((a[l]|0)==e<<24>>24){m=l}else{n=l;break}}else{m=h}l=m+1|0;o=a[l]|0;if(o<<24>>24==0){break a}else{h=l;j=o;k=m}}i=d;return n|0}}while(0);if((c[c[23960]>>2]|0)==0){JN(100,100936);n=0;i=d;return n|0}else{c[(Kc()|0)>>2]=100;n=0;i=d;return n|0}return 0}function _N(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;do{if((b|0)>0){h=0;j=b}else{if((b|0)<0){h=1;j=0-b|0;break}c[e>>2]=0;c[d>>2]=1;a[101006|0]=48;k=101006|0;i=g;return k|0}}while(0);c[e>>2]=h;h=23;e=j;while(1){j=h+ -1|0;l=100984+j|0;a[l]=((e>>>0)%(f>>>0)|0)+48;b=(e>>>0)/(f>>>0)|0;if((b|0)==0){break}else{e=b;h=j}}c[d>>2]=24-h;k=l;i=g;return k|0}function $N(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[23982]|0;f=c[23978]|0;if((e|0)>(f|0)){c[23978]=e;g=e}else{g=f}f=g+1|0;if((f|0)<(c[25270]|0)){h=g}else{aO(f,g);h=c[23978]|0}g=c[25272]|0;f=g+h|0;if((b|0)==0){j=f}else{a[f]=b;j=g+(h+1)|0}a[j]=0;Gd(g|0,c[23956]|0)|0;h=x_(g|0)|0;b=g+h|0;if(b>>>0<j>>>0){k=b;l=h;m=g}else{i=d;return 0}while(1){g=l+1|0;h=m+g|0;Od(a[k]|0,c[23956]|0)|0;Gd(h|0,c[23956]|0)|0;b=x_(h|0)|0;f=m+(g+b)|0;if(f>>>0<j>>>0){m=h;l=b;k=f}else{break}}i=d;return 0}function aO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[25272]|0;if((f|0)==101168){c[25270]=1024;g=1024}else{g=c[25270]|0}if((g|0)>(b|0)){h=g}else{j=g;do{j=j<<1;}while((j|0)<=(b|0));c[25270]=j;h=j}j=VZ(h)|0;if((j|0)==0){JN(113,101568);k=c[25272]|0}else{k=f}f=k+d|0;if((d|0)>0){d=j;h=k;while(1){b=h+1|0;a[d]=a[h]|0;if(b>>>0<f>>>0){h=b;d=d+1|0}else{break}}l=c[25272]|0}else{l=k}if((l|0)==101168){m=101088;c[25272]=j;i=e;return}WZ(l);m=101088;c[25272]=j;i=e;return}function bO(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[23978]|0;f=c[25270]|0;if((e|0)<(f|0)){g=e}else{aO(e,f);g=c[23978]|0}c[23978]=g+1;a[(c[25272]|0)+g|0]=b;i=d;return}function cO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d;f=i;i=i+256|0;g=i;i=i+16|0;h=i;i=i+8|0;j=f;c[23942]=1;f=b+4|0;k=c[f>>2]|0;if(k>>>0>99){if((c[b>>2]|0)==0){JN(101,101096);l=101;i=d;return l|0}else{c[(Kc()|0)>>2]=101;l=101;i=d;return l|0}}if((c[23954]|0)==0){KN();m=c[f>>2]|0}else{m=k}k=90752+(m*48|0)|0;c[22678]=k;n=k;a:do{if((c[n>>2]|0)!=0){k=c[b+8>>2]|0;do{if((k|0)!=0){hO(k,c[b+12>>2]|0,j);o=iO(j,h)|0;if((o|0)==(c[90760+(m*48|0)>>2]|0)){if((c[h>>2]|0)==(c[90764+(m*48|0)>>2]|0)){break}}c[g+4>>2]=c[f>>2];c[g+8>>2]=0;c[g>>2]=c[b>>2];o=FN(g)|0;if((o|0)==0){break a}else{l=o}i=d;return l|0}}while(0);k=c[b+32>>2]|0;if((k|0)==0){l=0;i=d;return l|0}o=a[k]|0;if(o<<24>>24==122){p=1}else{p=o<<24>>24==90|0}c[90784+(m*48|0)>>2]=p;l=0;i=d;return l|0}}while(0);p=b+28|0;g=c[p>>2]|0;h=90768+(m*48|0)|0;c[h>>2]=g;o=c[b+32>>2]|0;do{if((o|0)==0){q=0}else{k=a[o]|0;if(k<<24>>24==122){q=1;break}q=k<<24>>24==90|0}}while(0);c[90784+(m*48|0)>>2]=q;q=c[b+24>>2]|0;do{if((q|0)==0){o=90776+(m*48|0)|0;if((g|0)>0){c[o>>2]=0;r=0;break}else{c[o>>2]=1;r=1;break}}else{o=a[q]|0;if(o<<24>>24==70|o<<24>>24==102){c[90776+(m*48|0)>>2]=1;r=1;break}else{c[90776+(m*48|0)>>2]=0;r=0;break}}}while(0);q=c[b+8>>2]|0;do{if((q|0)==0){c[e>>2]=c[f>>2];dc(j|0,101104,e|0)|0}else{hO(q,c[b+12>>2]|0,j);if((a[j]|0)!=0){break}if((c[b>>2]|0)==0){dO(107,101096,b);l=107;i=d;return l|0}else{c[(Kc()|0)>>2]=107;l=107;i=d;return l|0}}}while(0);q=90796+(m*48|0)|0;c[q>>2]=0;c[90788+(m*48|0)>>2]=0;e=90792+(m*48|0)|0;c[e>>2]=0;c[n>>2]=0;f=90780+(m*48|0)|0;c[f>>2]=3;g=c[b+16>>2]|0;b:do{if((g|0)!=0){c:do{switch(a[g]|0){case 82:case 114:{break};case 78:case 110:{if((yc(j|0,0)|0)!=0){break c}if((c[b>>2]|0)==0){dO(128,101096,b);l=128;i=d;return l|0}else{c[(Kc()|0)>>2]=128;l=128;i=d;return l|0}break};case 79:case 111:{if((yc(j|0,0)|0)==0){break b}o=(c[b>>2]|0)==0;k=Kc()|0;s=c[k>>2]|0;if(o){dO(s,101096,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=s;l=s;i=d;return l|0}break};case 83:case 115:{c[q>>2]=1;s=Ib()|0;c[n>>2]=s;if((s|0)!=0){c[90756+(m*48|0)>>2]=0;c[90764+(m*48|0)>>2]=-1;c[90760+(m*48|0)>>2]=-1;c[90772+(m*48|0)>>2]=1;l=0;i=d;return l|0}s=(c[b>>2]|0)==0;k=Kc()|0;o=c[k>>2]|0;if(s){dO(o,101096,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=o;l=o;i=d;return l|0}break};default:{break b}}}while(0);o=ec(j|0,c[25266]|0)|0;if((o|0)==0){break}Vc(o|0)|0}}while(0);q=VZ((x_(j|0)|0)+1|0)|0;c[90756+(m*48|0)>>2]=q;if((q|0)==0){if((c[b>>2]|0)==0){dO(113,101120,b);l=113;i=d;return l|0}else{c[(Kc()|0)>>2]=113;l=113;i=d;return l|0}}D_(q|0,j|0)|0;q=b+20|0;if((c[q>>2]|0)==0){t=r}else{t=(c[h>>2]|0)==0?r:0}r=ec(j|0,c[101064+((t|2)<<2)>>2]|0)|0;do{if((r|0)==0){h=ec(j|0,c[101024+(t<<2)>>2]|0)|0;if((h|0)!=0){c[f>>2]=1;u=h;break}h=ec(j|0,c[101064+(t<<2)>>2]|0)|0;if((h|0)!=0){c[e>>2]=1;c[f>>2]=2;u=h;break}h=(c[b>>2]|0)==0;g=Kc()|0;o=c[g>>2]|0;if(h){JN(o,101096);l=c[g>>2]|0;i=d;return l|0}else{c[g>>2]=o;l=o;i=d;return l|0}}else{u=r}}while(0);c[n>>2]=u;r=90772+(m*48|0)|0;c[r>>2]=IN(u)|0;u=iO(j,90764+(m*48|0)|0)|0;c[90760+(m*48|0)>>2]=u;if((u|0)==-1){if((c[b>>2]|0)==0){dO(108,101096,b);l=108;i=d;return l|0}else{c[(Kc()|0)>>2]=108;l=108;i=d;return l|0}}if((c[r>>2]|0)==0){l=0;i=d;return l|0}if((c[p>>2]|0)!=0){mb(c[n>>2]|0);l=0;i=d;return l|0}p=c[q>>2]|0;if((p|0)==0){l=0;i=d;return l|0}q=a[p]|0;if(!(q<<24>>24==65|q<<24>>24==97)){l=0;i=d;return l|0}if((Tc(c[n>>2]|0,0,2)|0)==0){l=0;i=d;return l|0}if((c[b>>2]|0)==0){dO(129,101096,b);l=129;i=d;return l|0}else{c[(Kc()|0)>>2]=129;l=129;i=d;return l|0}return 0}function dO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d+8|0;g=c[f>>2]|0;if((g|0)==0){JN(a,b);i=e;return}h=d+12|0;d=c[h>>2]|0;if((d|0)<(c[25270]|0)){j=d;k=g}else{aO(d,0);j=c[h>>2]|0;k=c[f>>2]|0}f=c[25272]|0;c[(c[22678]|0)+4>>2]=f;hO(k,j,f);JN(a,b);i=e;return}function eO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+40|0;j=g;c[f>>2]=d;dc(j|0,101104,f|0)|0;c[h>>2]=1;c[h+4>>2]=d;c[h+8>>2]=j;c[h+12>>2]=x_(j|0)|0;c[h+16>>2]=0;c[h+20>>2]=(a|0)==3?101136:101144;c[h+24>>2]=(b|0)==5?101152:101160;c[h+28>>2]=(a|0)==4;c[h+32>>2]=0;a=cO(h)|0;i=e;return a|0}function fO(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=90752+(d*48|0)|0;c[22678]=e;if(d>>>0>99){if((c[a>>2]|0)==0){JN(101,101584);f=101;i=b;return f|0}else{c[(Kc()|0)>>2]=101;f=101;i=b;return f|0}}do{if((c[e>>2]|0)==0){if((eO(3,5,d)|0)==0){break}if((c[a>>2]|0)==0){JN(114,101592);f=114;i=b;return f|0}else{c[(Kc()|0)>>2]=114;f=114;i=b;return f|0}}}while(0);if((c[90776+(d*48|0)>>2]|0)!=0){f=0;i=b;return f|0}if((c[a>>2]|0)==0){JN(102,101592);f=102;i=b;return f|0}else{c[(Kc()|0)>>2]=102;f=102;i=b;return f|0}return 0}function gO(){var a=0,b=0;a=i;b=RN()|0;c[23904]=0;i=a;return b|0}function hO(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+c|0;g=d+c|0;while(1){if(!(f>>>0>b>>>0)){h=3;break}j=f+ -1|0;k=g+ -1|0;if((a[j]|0)==32){f=j;g=k}else{break}}if((h|0)==3){a[d]=0;i=e;return}a[g]=0;g=j;j=k;while(1){a[j]=a[g]|0;if(g>>>0>b>>>0){j=j+ -1|0;g=g+ -1|0}else{break}}i=e;return}function iO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+80|0;e=d;if((hc(a|0,e|0)|0)<0){f=-1;i=d;return f|0}c[b>>2]=c[e>>2];f=c[e+72>>2]|0;i=d;return f|0}function jO(b,d,e,f,j){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=i;i=i+56|0;p=o;q=(f|0)<1?2:f;r=c[23984]|0;if((r|0)==0){s=3}else{if((r|0)<(e+2|0)&(r|0)>(0-e|0)){s=3}}a:do{if((s|0)==3){t=(((r|0)<1)<<31>>31)+e|0;if((j|0)==4){u=+g[b>>2]}else{u=+h[b>>3]}do{if(u<0.0){v=-u;w=1;x=1}else{y=c[23964]|0;if(u!=0.0){v=u;w=0;x=y;break}v=0.0;w=0;x=y}}while(0);y=d+ -4-q-t-x|0;if((y|0)<0){break}z=((r|0)<0?r:0)+t|0;A=(z|0)>40;B=A?40:z;C=A?z+ -40|0:0;c[n>>2]=B;z=n+4|0;h[k>>3]=v;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];dc(p|0,101600,n|0)|0;z=a[p]|0;if(!((z+ -48|0)>>>0<10)){if((z|0)==78|(z|0)==110){D=0}else{D=x}z=d-(x_(p|0)|0)-D|0;if((z|0)<0){break}if((z|0)>0){A=z;do{A=A+ -1|0;be[c[23968]&255](32);}while((A|0)>0)}if((D|0)!=0){be[c[23968]&255]((w|0)!=0?45:43)}A=a[p]|0;if(A<<24>>24==0){i=l;return 0}else{E=A;F=p}do{be[c[23968]&255](E<<24>>24);F=F+1|0;E=a[F]|0;}while(!(E<<24>>24==0));i=l;return 0}A=o+(B+3)|0;if(v!=0.0){t=(Bc(A|0)|0)+1|0;c[m>>2]=t-(c[23984]|0);dc(A|0,101608,m|0)|0}else{t=A;a[t]=3158059;a[t+1|0]=12336;a[t+2|0]=48;a[t+3|0]=0}t=o+(B+4)|0;A=(q|0)<2;if(A){if((a[t]|0)!=48){break}}z=o+(B+6)|0;G=(a[z]|0)==0;b:do{if(G){H=2}else{if((f|0)==0){I=o+(B+2)|0;while(1){J=I+1|0;K=a[J]|0;a[I]=K;if(K<<24>>24==0){H=2;break b}else{I=J}}}I=(f|0)<0;if(I|G){H=I?q:2;break}else{L=2;M=z}while(1){if((L|0)>=(q|0)){break a}I=L+1|0;J=M+1|0;if((a[J]|0)==0){H=I;break}else{L=I;M=J}}}}while(0);if((y|0)>0){z=y;do{z=z+ -1|0;be[c[23968]&255](32);}while((z|0)>0)}if((x|0)!=0){be[c[23968]&255]((w|0)!=0?45:43)}z=c[23984]|0;do{if((z|0)<1){be[c[23968]&255](46);y=c[23968]|0;if((z|0)<0){G=y;J=z;while(1){be[G&255](48);I=J+1|0;K=c[23968]|0;if((I|0)<0){J=I;G=K}else{N=K;break}}}else{N=y}be[N&255](a[p]|0);O=o+2|0}else{if((z|0)<=1){O=p;break}be[c[23968]&255](a[p]|0);G=o+2|0;J=z+ -1|0;K=c[23968]|0;if((J|0)>0){I=z+1|0;P=K;Q=J;J=G;while(1){be[P&255](a[J]|0);R=Q+ -1|0;S=c[23968]|0;if((R|0)>0){J=J+1|0;Q=R;P=S}else{break}}T=S;U=o+I|0}else{T=K;U=G}be[T&255](46);O=U}}while(0);if((C|0)==0){V=O}else{z=o+(B+2)|0;if(O>>>0<z>>>0){P=O;while(1){Q=P+1|0;be[c[23968]&255](a[P]|0);if(Q>>>0<z>>>0){P=Q}else{W=Q;break}}}else{W=O}P=C;while(1){be[c[23968]&255](48);z=P+ -1|0;if((z|0)>0){P=z}else{V=W;break}}}if(V>>>0<t>>>0){P=V;while(1){C=P+1|0;be[c[23968]&255](a[P]|0);if(C>>>0<t>>>0){P=C}else{X=C;break}}}else{X=V}if(A){be[c[23968]&255](a[X+1|0]|0);i=l;return 0}if((H|0)<(q|0)){P=H;do{P=P+1|0;be[c[23968]&255](48);}while((P|0)<(q|0))}P=a[X]|0;if(P<<24>>24==0){i=l;return 0}else{Y=P;Z=X}do{Z=Z+1|0;be[c[23968]&255](Y<<24>>24);Y=a[Z]|0;}while(!(Y<<24>>24==0));i=l;return 0}}while(0);if((d|0)>0){_=d}else{i=l;return 0}do{_=_+ -1|0;be[c[23968]&255](42);}while((_|0)>0);i=l;return 0}function kO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;l=j;m=i;i=i+656|0;n=m;if((f|0)==4){o=+g[b>>2]}else{o=+h[b>>3]}b=(e|0)<344;f=b?e:344;p=b?0:e+ -344|0;do{if(o<0.0){q=1;r=-o}else{if(o!=0.0){q=0;r=o;break}q=0;r=0.0}}while(0);e=c[23984]|0;if((e|0)==0){s=r}else{if((e|0)>0){b=e;o=r;while(1){t=o*10.0;u=b+ -1|0;if((u|0)>0){o=t;b=u}else{s=t;break}}}else{b=e;o=r;while(1){r=o*.1;e=b+1|0;if((e|0)<0){o=r;b=e}else{s=r;break}}}}c[l>>2]=f;b=l+4|0;h[k>>3]=s;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=(dc(n|0,101616,l|0)|0)+p|0;if((a[n]|0)!=48|(f|0)==0){v=n;w=b}else{v=m+1|0;w=b+ -1|0}a:do{if((q|0)==1){b=v;while(1){m=a[b]|0;if(!(m<<24>>24==48)){n=m<<24>>24;if((n|0)==0){x=0;break a}else if((n|0)!=46){break}}b=b+1|0}x=1}else{x=q}}while(0);q=(x|0)==0;b=((c[23964]|x|0)!=0)+w|0;if((b|0)>(d|0)){if((d|0)>0){y=d}else{i=j;return 0}do{y=y+ -1|0;be[c[23968]&255](42);}while((y|0)>0);i=j;return 0}y=d-b|0;if((y|0)>0){b=y;do{b=b+ -1|0;be[c[23968]&255](32);}while((b|0)>0)}do{if(q){if((c[23964]|0)==0){break}be[c[23968]&255](43)}else{be[c[23968]&255](45)}}while(0);q=a[v]|0;if(!(q<<24>>24==0)){b=q;q=v;do{q=q+1|0;be[c[23968]&255](b<<24>>24);b=a[q]|0;}while(!(b<<24>>24==0))}if((p|0)>0){z=p}else{i=j;return 0}do{z=z+ -1|0;be[c[23968]&255](48);}while((z|0)>0);i=j;return 0}function lO(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((f|0)==1){h=a[d]|0}else if((f|0)==4){h=c[d>>2]|0}else{h=b[d>>1]|0}d=e+ -1|0;if((d|0)>0){e=0;do{be[c[23968]&255](32);e=e+1|0;}while((e|0)<(d|0))}d=c[23968]|0;if((h|0)==0){be[d&255](70);i=g;return 0}else{be[d&255](84);i=g;return 0}return 0}function mO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;do{if((c[23980]|0)!=0){g=nO()|0;if((g|0)==0){break}else{h=g}i=e;return h|0}}while(0);g=c[a>>2]|0;switch(g|0){case 23:{h=kO(b,c[a+4>>2]|0,c[a+8>>2]|0,d)|0;i=e;return h|0};case 7:{oO(b,c[a+4>>2]|0,d,10);h=0;i=e;return h|0};case 34:{pO(b,c[a+4>>2]|0,c[a+8>>2]|0,d,8);h=0;i=e;return h|0};case 10:{pO(b,c[a+4>>2]|0,c[a+8>>2]|0,d,10);h=0;i=e;return h|0};case 29:{lO(b,c[a+4>>2]|0,d)|0;h=0;i=e;return h|0};case 25:case 24:case 26:{h=jO(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 35:{tO(b,c[a+4>>2]|0,0,d);h=0;i=e;return h|0};case 36:{tO(b,c[a+4>>2]|0,c[a+8>>2]|0,d);h=0;i=e;return h|0};case 30:{qO(b,d);h=0;i=e;return h|0};case 31:{rO(b,c[a+4>>2]|0,d);h=0;i=e;return h|0};case 32:{oO(b,c[a+4>>2]|0,d,8);h=0;i=e;return h|0};case 28:case 27:{h=sO(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};default:{h=c[r>>2]|0;c[f>>2]=g;sd(h|0,101624,f|0)|0;yN(c[23904]|0,1)}}return 0}function nO(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=c[23980]|0;c[23980]=0;if((c[23942]|0)!=0){if((b|0)>0){d=c[23982]|0;e=c[23978]|0;if((d|0)<=(e|0)){f=b;while(1){be[c[23968]&255](32);g=f+ -1|0;if((g|0)>0){f=g}else{h=0;break}}i=a;return h|0}f=e+b|0;if((d|0)>(f|0)){c[23978]=f;h=0;i=a;return h|0}f=b-d+e|0;c[23978]=d;if((f|0)>0){j=f}else{h=0;i=a;return h|0}while(1){be[c[23968]&255](32);f=j+ -1|0;if((f|0)>0){j=f}else{h=0;break}}i=a;return h|0}if((b|0)>=0){h=0;i=a;return h|0}j=c[23978]|0;f=j+b|0;if((f|0)>=0){if((c[23982]|0)<(j|0)){c[23982]=j}c[23978]=f;h=0;i=a;return h|0}if((c[c[23960]>>2]|0)==0){JN(110,101712);h=110;i=a;return h|0}else{c[(Kc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<0){f=c[23978]|0;if((c[23982]|0)<(f|0)){c[23982]=f}j=f+b|0;c[23978]=j;c[23986]=(c[23986]|0)+b;if((j|0)>=0){h=0;i=a;return h|0}if((c[c[23960]>>2]|0)==0){JN(110,101712);h=110;i=a;return h|0}else{c[(Kc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<=0){h=0;i=a;return h|0}j=c[23978]|0;f=j+b|0;if((f|0)>=(c[(c[23962]|0)+16>>2]|0)){if((c[c[23960]>>2]|0)==0){JN(110,101728);h=110;i=a;return h|0}else{c[(Kc()|0)>>2]=110;h=110;i=a;return h|0}}d=c[23982]|0;if((d|0)<=(j|0)){e=b;while(1){be[c[23968]&255](32);g=e+ -1|0;if((g|0)>0){e=g}else{h=0;break}}i=a;return h|0}if((d|0)>(f|0)){c[23986]=(c[23986]|0)+b;c[23978]=f;h=0;i=a;return h|0}f=d-j|0;j=b-f|0;c[23986]=(c[23986]|0)+f;c[23978]=d;if((j|0)>0){k=j}else{h=0;i=a;return h|0}while(1){be[c[23968]&255](32);j=k+ -1|0;if((j|0)>0){k=j}else{h=0;break}}i=a;return h|0}function oO(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;k=h+8|0;if((f|0)==1){l=a[d]|0}else if((f|0)==4){l=c[d>>2]|0}else{l=b[d>>1]|0}d=_N(l,j,k,g)|0;g=c[k>>2]|0;l=(((c[23964]|g|0)!=0)<<31>>31)+(e-(c[j>>2]|0))|0;if((l|0)<0){if((e|0)>0){m=0}else{i=h;return}do{be[c[23968]&255](42);m=m+1|0;}while((m|0)<(e|0));i=h;return}if((l|0)>0){e=0;do{be[c[23968]&255](32);e=e+1|0;}while((e|0)<(l|0));n=c[k>>2]|0}else{n=g}do{if((n|0)==0){if((c[23964]|0)==0){break}be[c[23968]&255](43)}else{be[c[23968]&255](45)}}while(0);if((c[j>>2]|0)>0){o=d;p=0}else{i=h;return}while(1){be[c[23968]&255](a[o]|0);d=p+1|0;if((d|0)<(c[j>>2]|0)){p=d;o=o+1|0}else{break}}i=h;return}function pO(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;l=j+8|0;if((g|0)==4){m=c[d>>2]|0}else if((g|0)==1){m=a[d]|0}else{m=b[d>>1]|0}d=_N(m,k,l,h)|0;h=c[l>>2]|0;g=(c[23964]|h|0)!=0;n=g&1;o=c[k>>2]|0;do{if((n+o|0)<=(e|0)){if((n+f|0)>(e|0)){break}if((m|f|0)==0){if((e|0)>0){p=0}else{i=j;return}do{be[c[23968]&255](32);p=p+1|0;}while((p|0)<(e|0));i=j;return}q=e-((o|0)<(f|0)?f:o)+(g<<31>>31)|0;if((q|0)>0){r=0;do{be[c[23968]&255](32);r=r+1|0;}while((r|0)<(q|0));s=c[l>>2]|0}else{s=h}do{if((s|0)==0){if((c[23964]|0)==0){break}be[c[23968]&255](43)}else{be[c[23968]&255](45)}}while(0);q=c[k>>2]|0;if((f-q|0)>0){r=0;while(1){be[c[23968]&255](48);t=r+1|0;u=c[k>>2]|0;if((t|0)<(f-u|0)){r=t}else{v=u;break}}}else{v=q}if((v|0)>0){w=d;x=0}else{i=j;return}while(1){be[c[23968]&255](a[w]|0);r=x+1|0;if((r|0)<(c[k>>2]|0)){x=r;w=w+1|0}else{break}}i=j;return}}while(0);if((e|0)>0){y=0}else{i=j;return}do{be[c[23968]&255](42);y=y+1|0;}while((y|0)<(e|0));i=j;return}function qO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)>0){f=b;g=d}else{i=e;return}while(1){d=g+ -1|0;be[c[23968]&255](a[f]|0);if((d|0)>0){g=d;f=f+1|0}else{break}}i=e;return}function rO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if((d|0)>(e|0)){g=d;while(1){h=g+ -1|0;be[c[23968]&255](32);if((h|0)>(e|0)){g=h}else{j=e;break}}}else{j=d}if((j|0)>0){k=b;l=j}else{i=f;return}while(1){j=l+ -1|0;be[c[23968]&255](a[k]|0);if((j|0)>0){l=j;k=k+1|0}else{break}}i=f;return}function sO(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0,n=0,o=0,p=0;j=i;if((f|0)==4){k=+g[a>>2]}else{k=+h[a>>3]}if(k<0.0){l=-k}else{l=k}a:do{if(l<.1){if(!(l!=0.0)){m=1;break}n=jO(a,b,d,e,f)|0;i=j;return n|0}else{if((d|0)>=0){o=0;k=1.0;while(1){if(!(l>=k)){m=o;break a}if((o|0)<(d|0)){o=o+1|0;k=k*10.0}else{break}}}n=jO(a,b,d,e,f)|0;i=j;return n|0}}while(0);o=c[23984]|0;c[23984]=0;p=(e|0)==0?4:e+2|0;e=kO(a,b-p|0,d-m|0,f)|0;if((p|0)>0){f=0;do{be[c[23968]&255](32);f=f+1|0;}while((f|0)<(p|0))}c[23984]=o;n=e;i=j;return n|0}function tO(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;k=b+(g+ -1)|0;a:do{if((k|0)==(j|0)){l=1;m=j}else{g=k;while(1){n=g+ -1|0;if((a[g]|0)!=0){l=0;m=g;break a}if((n|0)==(j|0)){l=1;m=j;break}else{g=n}}}}while(0);k=((d[m]|0)>15)+(m-b<<1|1)|0;if((k|0)>(e|0)){if((e|0)>0){o=0}else{i=h;return}do{be[c[23968]&255](42);o=o+1|0;}while((o|0)<(e|0));i=h;return}o=f-k|0;b=(o|0)>0;g=b?f:k;if((g|0)<(e|0)){k=e;do{k=k+ -1|0;be[c[23968]&255](32);}while((k|0)>(g|0))}if(b){b=o;do{b=b+ -1|0;be[c[23968]&255](48);}while((b|0)>0)}b=a[m]|0;do{if((b&240|0)==0){be[c[23968]&255](a[101688+(b&15)|0]|0);if(l){i=h;return}else{p=m+ -1|0;break}}else{p=m}}while(0);while(1){be[c[23968]&255](a[101688+((d[p]|0)>>>4)|0]|0);be[c[23968]&255](a[101688+(a[p]&15)|0]|0);if((p|0)==(j|0)){break}p=p+ -1|0}i=h;return}function uO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[a>>2]|0;switch(e|0){case 4:case 14:{c[23980]=(c[23980]|0)+(c[a+4>>2]|0);f=1;i=b;return f|0};case 11:{f=vO(c[a+8>>2]|0)|0;i=b;return f|0};case 5:{f=ve[c[23976]&7]()|0;i=b;return f|0};case 12:{f=wO(c[a+4>>2]|0,c[a+8>>2]|0)|0;i=b;return f|0};case 13:{g=(c[23980]|0)-(c[a+4>>2]|0)|0;h=0-(c[23978]|0)|0;c[23980]=(g|0)<(h|0)?h:g;f=1;i=b;return f|0};case 15:{c[23980]=(c[a+4>>2]|0)+ -1-(c[23978]|0);f=1;i=b;return f|0};default:{f=c[r>>2]|0;c[d>>2]=e;sd(f|0,101656,d|0)|0;yN(c[23904]|0,1)}}return 0}function vO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;do{if((c[23980]|0)!=0){e=nO()|0;if((e|0)==0){break}else{f=e}i=d;return f|0}}while(0);e=a[b]|0;g=b+1|0;h=a[g]|0;if(h<<24>>24==0){f=1;i=d;return f|0}else{j=g;k=h;l=b}while(1){if(k<<24>>24==e<<24>>24){b=l+2|0;if(!((a[b]|0)==e<<24>>24)){f=1;m=9;break}be[c[23968]&255](e<<24>>24);n=b}else{be[c[23968]&255](k<<24>>24);n=j}b=n+1|0;h=a[b]|0;if(h<<24>>24==0){f=1;m=9;break}else{j=b;k=h;l=n}}if((m|0)==9){i=d;return f|0}return 0}function wO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;do{if((c[23980]|0)!=0){f=nO()|0;if((f|0)==0){break}else{g=f}i=e;return g|0}}while(0);if((b|0)==0){g=1;i=e;return g|0}else{h=d;j=b}while(1){b=j+ -1|0;be[c[23968]&255](a[h]|0);if((b|0)==0){g=1;break}else{j=b;h=h+1|0}}i=e;return g|0}function xO(){var a=0,b=0;a=i;b=$N(10)|0;c[23980]=0;c[23978]=0;c[23982]=0;i=a;return(b|0)==0|0}function yO(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((c[23954]|0)==0){KN()}c[23918]=0;c[23924]=1;c[23932]=1;c[23942]=1;d=fO(a)|0;if((d|0)!=0){e=d;i=b;return e|0}c[23960]=a;c[23978]=0;c[23980]=0;c[23982]=0;c[25232]=0;c[23984]=0;d=c[a+12>>2]|0;c[23904]=d;c[23956]=c[c[22678]>>2];if((NN(d)|0)<0){if((c[a>>2]|0)==0){JN(100,101736);e=100;i=b;return e|0}else{c[(Kc()|0)>>2]=100;e=100;i=b;return e|0}}c[23968]=187;c[23970]=43;c[23972]=111;c[23958]=4;c[23974]=5;c[23976]=6;SN();c[23964]=0;d=c[22678]|0;c[23966]=c[d+32>>2];if((c[d+40>>2]|0)==1){e=0;i=b;return e|0}if((LN(d)|0)==0){e=0;i=b;return e|0}d=(c[a>>2]|0)==0;a=Kc()|0;f=c[a>>2]|0;if(d){JN(f,101744);e=c[a>>2]|0;i=b;return e|0}else{c[a>>2]=f;e=f;i=b;return e|0}return 0}function zO(){var a=0,b=0;a=i;if((c[25232]|0)==0){b=$N(10)|0}else{$N(0)|0;qd(c[23956]|0)|0;b=0}c[23980]=0;c[23978]=0;c[23982]=0;i=a;return b|0}function AO(){var a=0,b=0,d=0;a=i;if((c[25216]|0)==0){b=0}else{d=$N(10)|0;c[25216]=0;b=d}c[23980]=0;c[23978]=0;c[23982]=0;i=a;return b|0}function BO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;XO(102472,h,102528);c[25440]=103980;c[101768>>2]=104e3;c[101764>>2]=0;OQ(101768|0,102472);c[101840>>2]=0;c[101844>>2]=-1;j=c[t>>2]|0;c[25644]=103848;wW(102580|0);k=102584|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[25644]=103088;c[102608>>2]=j;xW(g,102580|0);k=AW(g,106640)|0;l=k;yW(g);c[102612>>2]=l;c[102616>>2]=102536;a[102620|0]=(ee[c[(c[k>>2]|0)+28>>2]&127](l)|0)&1;c[25462]=104060;c[101852>>2]=104080;OQ(101852|0,102576);c[101924>>2]=0;c[101928>>2]=-1;l=c[r>>2]|0;c[25656]=103848;wW(102628|0);k=102632|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[25656]=103088;c[102656>>2]=l;xW(f,102628|0);k=AW(f,106640)|0;g=k;yW(f);c[102660>>2]=g;c[102664>>2]=102544;a[102668|0]=(ee[c[(c[k>>2]|0)+28>>2]&127](g)|0)&1;c[25484]=104060;c[101940>>2]=104080;OQ(101940|0,102624);c[102012>>2]=0;c[102016>>2]=-1;g=c[(c[(c[25484]|0)+ -12>>2]|0)+101960>>2]|0;c[25506]=104060;c[102028>>2]=104080;OQ(102028|0,g);c[102100>>2]=0;c[102104>>2]=-1;c[(c[(c[25440]|0)+ -12>>2]|0)+101832>>2]=101848;g=(c[(c[25484]|0)+ -12>>2]|0)+101940|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[25484]|0)+ -12>>2]|0)+102008>>2]=101848;JO(102672,h,102552|0);c[25528]=104020;c[102120>>2]=104040;c[102116>>2]=0;OQ(102120|0,102672);c[102192>>2]=0;c[102196>>2]=-1;c[25682]=103912;wW(102732|0);h=102736|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[25682]=102832;c[102760>>2]=j;xW(e,102732|0);j=AW(e,106648)|0;h=j;yW(e);c[102764>>2]=h;c[102768>>2]=102560;a[102772|0]=(ee[c[(c[j>>2]|0)+28>>2]&127](h)|0)&1;c[25550]=104100;c[102204>>2]=104120;OQ(102204|0,102728);c[102276>>2]=0;c[102280>>2]=-1;c[25694]=103912;wW(102780|0);h=102784|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[25694]=102832;c[102808>>2]=l;xW(d,102780|0);l=AW(d,106648)|0;h=l;yW(d);c[102812>>2]=h;c[102816>>2]=102568;a[102820|0]=(ee[c[(c[l>>2]|0)+28>>2]&127](h)|0)&1;c[25572]=104100;c[102292>>2]=104120;OQ(102292|0,102776);c[102364>>2]=0;c[102368>>2]=-1;h=c[(c[(c[25572]|0)+ -12>>2]|0)+102312>>2]|0;c[25594]=104100;c[102380>>2]=104120;OQ(102380|0,h);c[102452>>2]=0;c[102456>>2]=-1;c[(c[(c[25528]|0)+ -12>>2]|0)+102184>>2]=102200;h=(c[(c[25572]|0)+ -12>>2]|0)+102292|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[25572]|0)+ -12>>2]|0)+102360>>2]=102200;i=b;return}function CO(a){a=a|0;a=i;MR(101848)|0;MR(102024)|0;TR(102200)|0;TR(102376)|0;i=a;return}function DO(a){a=a|0;var b=0;b=i;c[a>>2]=103912;yW(a+4|0);i=b;return}function EO(a){a=a|0;var b=0;b=i;c[a>>2]=103912;yW(a+4|0);b_(a);i=b;return}function FO(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;ee[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=AW(d,106648)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(ee[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function GO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=se[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((nc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((qd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function HO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((a[b+44|0]|0)!=0){g=nc(d|0,4,e|0,c[b+32>>2]|0)|0;i=f;return g|0}if((e|0)>0){h=d;j=0}else{g=0;i=f;return g|0}while(1){if((re[c[(c[b>>2]|0)+52>>2]&63](b,c[h>>2]|0)|0)==-1){g=j;k=6;break}d=j+1|0;if((d|0)<(e|0)){h=h+4|0;j=d}else{g=d;k=6;break}}if((k|0)==6){i=f;return g|0}return 0}function IO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){c[g>>2]=d;if((a[b+44|0]|0)!=0){if((nc(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=le[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((nc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((nc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function JO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=103912;j=b+4|0;wW(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=102944;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;xW(g,j);j=AW(g,106648)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=ee[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(ee[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){IV(103040)}else{yW(g);i=f;return}}function KO(a){a=a|0;var b=0;b=i;c[a>>2]=103912;yW(a+4|0);i=b;return}function LO(a){a=a|0;var b=0;b=i;c[a>>2]=103912;yW(a+4|0);b_(a);i=b;return}function MO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=AW(d,106648)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=ee[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(ee[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){IV(103040)}else{i=e;return}}function NO(a){a=a|0;var b=0,c=0;b=i;c=QO(a,0)|0;i=b;return c|0}function OO(a){a=a|0;var b=0,c=0;b=i;c=QO(a,1)|0;i=b;return c|0}function PO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f;q=le[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((nd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function QO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]|0)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;a:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=ad(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break a}}i=e;return n|0}}while(0);b:do{if((a[b+53|0]|0)==0){l=b+40|0;m=b+36|0;o=f;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=le[c[(c[t>>2]|0)+16>>2]&15](t,s,o,w,h,g,p,j)|0;if((x|0)==2){n=-1;y=22;break}else if((x|0)==3){y=14;break}else if((x|0)!=1){z=r;break b}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=22;break}v=ad(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=22;break}a[w]=v;r=r+1|0}if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==22){i=e;return n|0}}else{c[g>>2]=a[f]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b+ -1|0;if((nd(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=22;break}else{b=z}}if((y|0)==22){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function RO(a){a=a|0;var b=0;b=i;c[a>>2]=103848;yW(a+4|0);i=b;return}function SO(a){a=a|0;var b=0;b=i;c[a>>2]=103848;yW(a+4|0);b_(a);i=b;return}function TO(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;ee[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=AW(d,106640)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(ee[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function UO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=se[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((nc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((qd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}



function EU(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;g=b;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=ee[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=ee[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{if(h){n=d;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){o=ee[c[(c[h>>2]|0)+36>>2]&127](h)|0}else{o=c[d>>2]|0}if(!((ie[c[(c[f>>2]|0)+52>>2]&63](f,o,0)|0)<<24>>24==37)){c[e>>2]=c[e>>2]|4;i=a;return}o=c[g>>2]|0;f=o+12|0;d=c[f>>2]|0;if((d|0)==(c[o+16>>2]|0)){ee[c[(c[o>>2]|0)+40>>2]&127](o)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){p=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){q=ee[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{q=c[f>>2]|0}if((q|0)==-1){c[g>>2]=0;p=1;break}else{p=(c[g>>2]|0)==0;break}}}while(0);do{if((n|0)==0){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){r=ee[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{r=c[g>>2]|0}if((r|0)==-1){c[k>>2]=0;l=38;break}if(!p){break}i=a;return}}while(0);do{if((l|0)==38){if(p){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function FU(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;h=a;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=ee[c[(c[a>>2]|0)+36>>2]&127](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=ee[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=ee[c[(c[j>>2]|0)+36>>2]&127](j)|0}else{q=c[b>>2]|0}if(!(ie[c[(c[e>>2]|0)+12>>2]&63](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}b=(ie[c[(c[e>>2]|0)+52>>2]&63](e,q,0)|0)<<24>>24;q=c[h>>2]|0;j=q+12|0;n=c[j>>2]|0;if((n|0)==(c[q+16>>2]|0)){ee[c[(c[q>>2]|0)+40>>2]&127](q)|0;r=f;s=o;t=o;u=b}else{c[j>>2]=n+4;r=f;s=o;t=o;u=b}while(1){v=u+ -48|0;b=r+ -1|0;o=c[h>>2]|0;do{if((o|0)==0){w=1}else{f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0)){x=ee[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{x=c[f>>2]|0}if((x|0)==-1){c[h>>2]=0;w=1;break}else{w=(c[h>>2]|0)==0;break}}}while(0);do{if((t|0)==0){y=s;z=0;A=1}else{o=c[t+12>>2]|0;if((o|0)==(c[t+16>>2]|0)){B=ee[c[(c[t>>2]|0)+36>>2]&127](t)|0}else{B=c[o>>2]|0}if((B|0)==-1){c[l>>2]=0;y=0;z=0;A=1;break}else{y=s;z=s;A=(s|0)==0;break}}}while(0);C=c[h>>2]|0;if(!((w^A)&(b|0)>0)){break}o=c[C+12>>2]|0;if((o|0)==(c[C+16>>2]|0)){D=ee[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{D=c[o>>2]|0}if(!(ie[c[(c[e>>2]|0)+12>>2]&63](e,2048,D)|0)){p=v;m=63;break}o=((ie[c[(c[e>>2]|0)+52>>2]&63](e,D,0)|0)<<24>>24)+(v*10|0)|0;f=c[h>>2]|0;n=f+12|0;j=c[n>>2]|0;if((j|0)==(c[f+16>>2]|0)){ee[c[(c[f>>2]|0)+40>>2]&127](f)|0;E=b;s=y;t=z;u=o;r=E;continue}else{c[n>>2]=j+4;E=b;s=y;t=z;u=o;r=E;continue}}if((m|0)==63){i=g;return p|0}do{if((C|0)==0){F=1}else{E=c[C+12>>2]|0;if((E|0)==(c[C+16>>2]|0)){G=ee[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[h>>2]=0;F=1;break}else{F=(c[h>>2]|0)==0;break}}}while(0);do{if((y|0)==0){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){H=ee[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{H=c[h>>2]|0}if((H|0)==-1){c[l>>2]=0;m=60;break}if(F){p=v}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(F){break}else{p=v}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=v;i=g;return p|0}function GU(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);if((f|0)==(c[26616]|0)){g=b;b_(g);i=d;return}Yb(c[e>>2]|0);g=b;b_(g);i=d;return}function HU(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);if((b|0)==(c[26616]|0)){i=d;return}Yb(c[e>>2]|0);i=d;return}function IU(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;f=g;l=g+8|0;m=l;n=f;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(!(k<<24>>24==0)){a[o]=k;a[p]=j}j=Pc(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b;s=r;c[s>>2]=q;i=g;return}else{t=m;u=l;v=l}while(1){l=a[t]|0;do{if((v|0)==0){w=u;x=0}else{m=v+24|0;j=c[m>>2]|0;if((j|0)==(c[v+28>>2]|0)){e=(re[c[(c[v>>2]|0)+52>>2]&63](v,l&255)|0)==-1;w=e?0:u;x=e?0:v;break}else{c[m>>2]=j+1;a[j]=l;w=u;x=v;break}}}while(0);l=t+1|0;if((l|0)==(d|0)){q=w;break}else{t=l;u=w;v=x}}r=b;s=r;c[s>>2]=q;i=g;return}function JU(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);if((f|0)==(c[26616]|0)){g=b;b_(g);i=d;return}Yb(c[e>>2]|0);g=b;b_(g);i=d;return}function KU(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);if((b|0)==(c[26616]|0)){i=d;return}Yb(c[e>>2]|0);i=d;return}function LU(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+408|0;e=f;k=f+400|0;l=e;c[k>>2]=e+400;MU(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a;o=n;c[o>>2]=m;i=f;return}else{p=l;q=k;r=k}while(1){k=c[p>>2]|0;if((q|0)==0){s=r;t=0}else{l=q+24|0;d=c[l>>2]|0;if((d|0)==(c[q+28>>2]|0)){u=re[c[(c[q>>2]|0)+52>>2]&63](q,k)|0}else{c[l>>2]=d+4;c[d>>2]=k;u=k}k=(u|0)==-1;s=k?0:r;t=k?0:q}k=p+4|0;if((k|0)==(j|0)){m=s;break}else{p=k;q=t;r=s}}n=a;o=n;c[o>>2]=m;i=f;return}function MU(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j;l=j+112|0;m=i;i=i+8|0;n=j+8|0;o=k;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(!(h<<24>>24==0)){a[p]=h;a[q]=g}g=b;Pc(n|0,100,o|0,f|0,c[g>>2]|0)|0;f=l;c[f>>2]=0;c[f+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=Ic(c[g>>2]|0)|0;g=YY(d,m,n,l)|0;if((f|0)!=0){Ic(f|0)|0}if((g|0)==-1){IV(107456)}else{c[e>>2]=d+(g<<2);i=j;return}}function NU(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function OU(a){a=a|0;i=i;return}function PU(a){a=a|0;i=i;return 127}function QU(a){a=a|0;i=i;return 127}function RU(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function SU(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function TU(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function UU(a,b){a=a|0;b=b|0;b=i;MP(a,1,45);i=b;return}function VU(a){a=a|0;i=i;return 0}function WU(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function XU(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function YU(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function ZU(a){a=a|0;i=i;return}function _U(a){a=a|0;i=i;return 127}function $U(a){a=a|0;i=i;return 127}function aV(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function bV(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function cV(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function dV(a,b){a=a|0;b=b|0;b=i;MP(a,1,45);i=b;return}function eV(a){a=a|0;i=i;return 0}function fV(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function gV(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function hV(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function iV(a){a=a|0;i=i;return}function jV(a){a=a|0;i=i;return 2147483647}function kV(a){a=a|0;i=i;return 2147483647}function lV(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function mV(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function nV(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function oV(a,b){a=a|0;b=b|0;b=i;rQ(a,1,45);i=b;return}function pV(a){a=a|0;i=i;return 0}function qV(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function rV(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function sV(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function tV(a){a=a|0;i=i;return}function uV(a){a=a|0;i=i;return 2147483647}function vV(a){a=a|0;i=i;return 2147483647}function wV(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function xV(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function yV(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function zV(a,b){a=a|0;b=b|0;b=i;rQ(a,1,45);i=b;return}function AV(a){a=a|0;i=i;return 0}function BV(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function CV(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function DV(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function EV(a){a=a|0;i=i;return}function FV(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+104|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=191;y=o+100|0;MQ(r,h);o=r;z=c[o>>2]|0;if(!((c[26644]|0)==-1)){c[n>>2]=106576;c[n+4>>2]=189;c[n+8>>2]=0;BP(106576,n,190)}n=(c[106580>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Ac(4)|0;C=B;AZ(C);D=122136;E=127;Pd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Ac(4)|0;C=B;AZ(C);D=122136;E=127;Pd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=HV(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;Ae[c[(c[z>>2]|0)+32>>2]&63](E,106192,106202|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>98){l=VZ(g+2|0)|0;if((l|0)!=0){F=l;G=l;break}g_()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+10|0;l=u;h=H;t=r;while(1){C=a[t]|0;n=y;while(1){A=n+1|0;if((a[n]|0)==C<<24>>24){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[106192+(I-l)|0]|0;n=t+1|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((td(p|0,106208,m|0)|0)!=1){t=Ac(8)|0;mP(t,106216);Pd(t|0,103568,42)}if((F|0)==0){break}WZ(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){K=e;break}if(!((ee[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){K=e;break}c[F>>2]=0;K=0}}while(0);F=(K|0)==0;e=c[D>>2]|0;do{if((e|0)==0){L=31}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){if(F){break}else{L=33;break}}if((ee[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[D>>2]=0;L=31;break}else{if(F){break}else{L=33;break}}}}while(0);if((L|0)==31){if(F){L=33}}if((L|0)==33){c[j>>2]=c[j>>2]|2}c[b>>2]=K;gP(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}be[c[x>>2]&255](o);i=d;return}function GV(a){a=a|0;i=i;return}function HV(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0;q=i;i=i+408|0;r=q;s=q+400|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=r;c[s>>2]=0;E=w;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=x;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=y;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=z;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=A;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;LV(g,h,t,u,v,w,x,y,z,B);t=n;c[o>>2]=c[t>>2];h=e;e=f;f=m+8|0;m=z+1|0;g=z+4|0;E=z+8|0;F=y+1|0;G=y+4|0;H=y+8|0;I=(j&512|0)!=0;j=x+1|0;J=x+8|0;K=x+4|0;L=A+1|0;M=A+8|0;N=A+4|0;O=s+3|0;P=n+4|0;n=w+4|0;Q=r+400|0;r=D;R=D;D=p;p=0;S=0;T=191;a:while(1){U=c[h>>2]|0;do{if((U|0)==0){V=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){V=U;break}if((ee[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;V=0;break}else{V=c[h>>2]|0;break}}}while(0);U=(V|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=12}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}if((ee[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=12;break}else{if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}}}while(0);if((X|0)==12){X=0;if(U){Z=R;_=r;$=S;aa=T;X=269;break}else{Y=0}}b:do{switch(a[s+p|0]|0){case 3:{W=a[y]|0;ba=(W&1)==0;if(ba){ca=(W&255)>>>1}else{ca=c[G>>2]|0}da=a[z]|0;ea=(da&1)==0;if(ea){fa=(da&255)>>>1}else{fa=c[g>>2]|0}if((ca|0)==(0-fa|0)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}if(ba){ma=(W&255)>>>1}else{ma=c[G>>2]|0}do{if((ma|0)!=0){if(ea){na=(da&255)>>>1}else{na=c[g>>2]|0}if((na|0)==0){break}oa=c[h>>2]|0;pa=c[oa+12>>2]|0;qa=c[oa+16>>2]|0;if((pa|0)==(qa|0)){ra=(ee[c[(c[oa>>2]|0)+36>>2]&127](oa)|0)&255;sa=c[h>>2]|0;ta=ra;ua=c[sa+16>>2]|0;va=c[sa+12>>2]|0;wa=sa;xa=a[y]|0}else{ta=a[pa]|0;ua=qa;va=pa;wa=oa;xa=W}oa=wa+12|0;pa=(va|0)==(ua|0);if(ta<<24>>24==(a[(xa&1)==0?F:c[H>>2]|0]|0)){if(pa){ee[c[(c[wa>>2]|0)+40>>2]&127](wa)|0}else{c[oa>>2]=va+1}oa=a[y]|0;if((oa&1)==0){ya=(oa&255)>>>1}else{ya=c[G>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=ya>>>0>1?y:S;la=T;break b}if(pa){za=(ee[c[(c[wa>>2]|0)+36>>2]&127](wa)|0)&255}else{za=a[va]|0}if(!(za<<24>>24==(a[(a[z]&1)==0?m:c[E>>2]|0]|0))){X=112;break a}pa=c[h>>2]|0;oa=pa+12|0;qa=c[oa>>2]|0;if((qa|0)==(c[pa+16>>2]|0)){ee[c[(c[pa>>2]|0)+40>>2]&127](pa)|0}else{c[oa>>2]=qa+1}a[l]=1;qa=a[z]|0;if((qa&1)==0){Aa=(qa&255)>>>1}else{Aa=c[g>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Aa>>>0>1?z:S;la=T;break b}}while(0);if(ba){Ba=(W&255)>>>1}else{Ba=c[G>>2]|0}ea=c[h>>2]|0;qa=c[ea+12>>2]|0;oa=(qa|0)==(c[ea+16>>2]|0);if((Ba|0)==0){if(oa){pa=(ee[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)&255;Ca=pa;Da=a[z]|0}else{Ca=a[qa]|0;Da=da}if(!(Ca<<24>>24==(a[(Da&1)==0?m:c[E>>2]|0]|0))){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}pa=c[h>>2]|0;sa=pa+12|0;ra=c[sa>>2]|0;if((ra|0)==(c[pa+16>>2]|0)){ee[c[(c[pa>>2]|0)+40>>2]&127](pa)|0}else{c[sa>>2]=ra+1}a[l]=1;ra=a[z]|0;if((ra&1)==0){Ea=(ra&255)>>>1}else{Ea=c[g>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Ea>>>0>1?z:S;la=T;break b}if(oa){oa=(ee[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)&255;Fa=oa;Ga=a[y]|0}else{Fa=a[qa]|0;Ga=W}if(!(Fa<<24>>24==(a[(Ga&1)==0?F:c[H>>2]|0]|0))){a[l]=1;ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}qa=c[h>>2]|0;oa=qa+12|0;ea=c[oa>>2]|0;if((ea|0)==(c[qa+16>>2]|0)){ee[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[oa>>2]=ea+1}ea=a[y]|0;if((ea&1)==0){Ha=(ea&255)>>>1}else{Ha=c[G>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Ha>>>0>1?y:S;la=T;break};case 2:{if(!((S|0)!=0|p>>>0<2)){if((p|0)==2){Ia=(a[O]|0)!=0}else{Ia=0}if(!(I|Ia)){ga=D;ha=R;ia=r;ja=Q;ka=0;la=T;break b}}ea=a[x]|0;oa=(ea&1)==0;qa=oa?j:c[J>>2]|0;c:do{if((p|0)==0){Ja=Y;Ka=Y;La=ea;Ma=qa}else{if((d[s+(p+ -1)|0]|0)>=2){Ja=Y;Ka=Y;La=ea;Ma=qa;break}ra=qa+(oa?(ea&255)>>>1:c[K>>2]|0)|0;sa=qa;while(1){if((sa|0)==(ra|0)){Na=ra;break}pa=a[sa]|0;if(!(pa<<24>>24>-1)){Na=sa;break}if((b[(c[f>>2]|0)+(pa<<24>>24<<1)>>1]&8192)==0){Na=sa;break}else{sa=sa+1|0}}sa=Na-qa|0;ra=a[A]|0;pa=(ra&1)==0;if(pa){Oa=(ra&255)>>>1}else{Oa=c[N>>2]|0}if(sa>>>0>Oa>>>0){Ja=Y;Ka=Y;La=ea;Ma=qa;break}if(pa){pa=(ra&255)>>>1;Pa=A+1+(pa-sa)|0;Qa=L;Ra=pa}else{pa=c[M>>2]|0;ra=c[N>>2]|0;Pa=pa+(ra-sa)|0;Qa=pa;Ra=ra}ra=Qa+Ra|0;if((Pa|0)==(ra|0)){Ja=Y;Ka=Y;La=ea;Ma=Na;break}else{Sa=qa;Ta=Pa}while(1){if((a[Ta]|0)!=(a[Sa]|0)){Ja=Y;Ka=Y;La=ea;Ma=qa;break c}pa=Ta+1|0;if((pa|0)==(ra|0)){Ja=Y;Ka=Y;La=ea;Ma=Na;break}else{Sa=Sa+1|0;Ta=pa}}}}while(0);d:while(1){if((La&1)==0){Ua=j;Va=(La&255)>>>1}else{Ua=c[J>>2]|0;Va=c[K>>2]|0}if((Ma|0)==(Ua+Va|0)){break}ea=c[h>>2]|0;do{if((ea|0)==0){Wa=0}else{if((c[ea+12>>2]|0)!=(c[ea+16>>2]|0)){Wa=ea;break}if((ee[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)==-1){c[h>>2]=0;Wa=0;break}else{Wa=c[h>>2]|0;break}}}while(0);ea=(Wa|0)==0;do{if((Ka|0)==0){Xa=Ja;X=147}else{if((c[Ka+12>>2]|0)!=(c[Ka+16>>2]|0)){if(ea){Ya=Ja;Za=Ka;break}else{break d}}if((ee[c[(c[Ka>>2]|0)+36>>2]&127](Ka)|0)==-1){c[e>>2]=0;Xa=0;X=147;break}else{if(ea^(Ja|0)==0){Ya=Ja;Za=Ja;break}else{break d}}}}while(0);if((X|0)==147){X=0;if(ea){break}else{Ya=Xa;Za=0}}qa=c[h>>2]|0;oa=c[qa+12>>2]|0;if((oa|0)==(c[qa+16>>2]|0)){_a=(ee[c[(c[qa>>2]|0)+36>>2]&127](qa)|0)&255}else{_a=a[oa]|0}if(!(_a<<24>>24==(a[Ma]|0))){break}oa=c[h>>2]|0;qa=oa+12|0;W=c[qa>>2]|0;if((W|0)==(c[oa+16>>2]|0)){ee[c[(c[oa>>2]|0)+40>>2]&127](oa)|0}else{c[qa>>2]=W+1}Ja=Ya;Ka=Za;La=a[x]|0;Ma=Ma+1|0}if(!I){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}W=a[x]|0;if((W&1)==0){$a=j;ab=(W&255)>>>1}else{$a=c[J>>2]|0;ab=c[K>>2]|0}if((Ma|0)==($a+ab|0)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T}else{X=162;break a}break};case 0:{X=26;break};case 4:{W=D;qa=R;oa=r;da=Q;ba=0;ra=T;e:while(1){pa=c[h>>2]|0;do{if((pa|0)==0){bb=0}else{if((c[pa+12>>2]|0)!=(c[pa+16>>2]|0)){bb=pa;break}if((ee[c[(c[pa>>2]|0)+36>>2]&127](pa)|0)==-1){c[h>>2]=0;bb=0;break}else{bb=c[h>>2]|0;break}}}while(0);pa=(bb|0)==0;ea=c[e>>2]|0;do{if((ea|0)==0){X=173}else{if((c[ea+12>>2]|0)!=(c[ea+16>>2]|0)){if(pa){break}else{break e}}if((ee[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)==-1){c[e>>2]=0;X=173;break}else{if(pa){break}else{break e}}}}while(0);if((X|0)==173){X=0;if(pa){break}}ea=c[h>>2]|0;sa=c[ea+12>>2]|0;if((sa|0)==(c[ea+16>>2]|0)){cb=(ee[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)&255}else{cb=a[sa]|0}do{if(cb<<24>>24>-1){if((b[(c[f>>2]|0)+(cb<<24>>24<<1)>>1]&2048)==0){X=189;break}sa=c[o>>2]|0;if((sa|0)==(W|0)){ea=(c[P>>2]|0)!=191;db=c[t>>2]|0;eb=W-db|0;fb=eb>>>0<2147483647?eb<<1:-1;gb=YZ(ea?db:0,fb)|0;if((gb|0)==0){X=182;break a}do{if(ea){c[t>>2]=gb;hb=gb}else{db=c[t>>2]|0;c[t>>2]=gb;if((db|0)==0){hb=gb;break}be[c[P>>2]&255](db);hb=c[t>>2]|0}}while(0);c[P>>2]=166;gb=hb+eb|0;c[o>>2]=gb;ib=gb;jb=(c[t>>2]|0)+fb|0}else{ib=sa;jb=W}c[o>>2]=ib+1;a[ib]=cb;kb=jb;lb=qa;mb=oa;nb=da;ob=ba+1|0;pb=ra}else{X=189}}while(0);if((X|0)==189){X=0;pa=a[w]|0;if((pa&1)==0){qb=(pa&255)>>>1}else{qb=c[n>>2]|0}if((qb|0)==0|(ba|0)==0){break}if(!(cb<<24>>24==(a[v]|0))){break}if((oa|0)==(da|0)){pa=oa-qa|0;gb=pa>>>0<2147483647?pa<<1:-1;if((ra|0)==191){rb=0}else{rb=qa}ea=YZ(rb,gb)|0;if((ea|0)==0){X=198;break a}sb=ea;tb=ea+(pa>>2<<2)|0;ub=ea+(gb>>>2<<2)|0;vb=166}else{sb=qa;tb=oa;ub=da;vb=ra}c[tb>>2]=ba;kb=W;lb=sb;mb=tb+4|0;nb=ub;ob=0;pb=vb}gb=c[h>>2]|0;ea=gb+12|0;pa=c[ea>>2]|0;if((pa|0)==(c[gb+16>>2]|0)){ee[c[(c[gb>>2]|0)+40>>2]&127](gb)|0;W=kb;qa=lb;oa=mb;da=nb;ba=ob;ra=pb;continue}else{c[ea>>2]=pa+1;W=kb;qa=lb;oa=mb;da=nb;ba=ob;ra=pb;continue}}if((qa|0)==(oa|0)|(ba|0)==0){wb=qa;xb=oa;yb=da;zb=ra}else{if((oa|0)==(da|0)){pa=oa-qa|0;ea=pa>>>0<2147483647?pa<<1:-1;if((ra|0)==191){Ab=0}else{Ab=qa}gb=YZ(Ab,ea)|0;if((gb|0)==0){X=209;break a}Bb=gb;Cb=gb+(pa>>2<<2)|0;Db=gb+(ea>>>2<<2)|0;Eb=166}else{Bb=qa;Cb=oa;Db=da;Eb=ra}c[Cb>>2]=ba;wb=Bb;xb=Cb+4|0;yb=Db;zb=Eb}if((c[B>>2]|0)>0){ea=c[h>>2]|0;do{if((ea|0)==0){Fb=0}else{if((c[ea+12>>2]|0)!=(c[ea+16>>2]|0)){Fb=ea;break}if((ee[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)==-1){c[h>>2]=0;Fb=0;break}else{Fb=c[h>>2]|0;break}}}while(0);ea=(Fb|0)==0;ba=c[e>>2]|0;do{if((ba|0)==0){X=223}else{if((c[ba+12>>2]|0)!=(c[ba+16>>2]|0)){if(ea){Gb=ba;break}else{X=229;break a}}if((ee[c[(c[ba>>2]|0)+36>>2]&127](ba)|0)==-1){c[e>>2]=0;X=223;break}else{if(ea){Gb=ba;break}else{X=229;break a}}}}while(0);if((X|0)==223){X=0;if(ea){X=229;break a}else{Gb=0}}ba=c[h>>2]|0;ra=c[ba+12>>2]|0;if((ra|0)==(c[ba+16>>2]|0)){Hb=(ee[c[(c[ba>>2]|0)+36>>2]&127](ba)|0)&255}else{Hb=a[ra]|0}if(!(Hb<<24>>24==(a[u]|0))){X=229;break a}ra=c[h>>2]|0;ba=ra+12|0;da=c[ba>>2]|0;if((da|0)==(c[ra+16>>2]|0)){ee[c[(c[ra>>2]|0)+40>>2]&127](ra)|0;Ib=Gb;Jb=Gb;Kb=W}else{c[ba>>2]=da+1;Ib=Gb;Jb=Gb;Kb=W}while(1){da=c[h>>2]|0;do{if((da|0)==0){Lb=0}else{if((c[da+12>>2]|0)!=(c[da+16>>2]|0)){Lb=da;break}if((ee[c[(c[da>>2]|0)+36>>2]&127](da)|0)==-1){c[h>>2]=0;Lb=0;break}else{Lb=c[h>>2]|0;break}}}while(0);da=(Lb|0)==0;do{if((Jb|0)==0){Mb=Ib;X=243}else{if((c[Jb+12>>2]|0)!=(c[Jb+16>>2]|0)){if(da){Nb=Ib;Ob=Jb;break}else{X=250;break a}}if((ee[c[(c[Jb>>2]|0)+36>>2]&127](Jb)|0)==-1){c[e>>2]=0;Mb=0;X=243;break}else{if(da^(Ib|0)==0){Nb=Ib;Ob=Ib;break}else{X=250;break a}}}}while(0);if((X|0)==243){X=0;if(da){X=250;break a}else{Nb=Mb;Ob=0}}ba=c[h>>2]|0;ra=c[ba+12>>2]|0;if((ra|0)==(c[ba+16>>2]|0)){Pb=(ee[c[(c[ba>>2]|0)+36>>2]&127](ba)|0)&255}else{Pb=a[ra]|0}if(!(Pb<<24>>24>-1)){X=250;break a}if((b[(c[f>>2]|0)+(Pb<<24>>24<<1)>>1]&2048)==0){X=250;break a}ra=c[o>>2]|0;if((ra|0)==(Kb|0)){ba=(c[P>>2]|0)!=191;oa=c[t>>2]|0;qa=Kb-oa|0;gb=qa>>>0<2147483647?qa<<1:-1;pa=YZ(ba?oa:0,gb)|0;if((pa|0)==0){X=253;break a}do{if(ba){c[t>>2]=pa;Qb=pa}else{oa=c[t>>2]|0;c[t>>2]=pa;if((oa|0)==0){Qb=pa;break}be[c[P>>2]&255](oa);Qb=c[t>>2]|0}}while(0);c[P>>2]=166;pa=Qb+qa|0;c[o>>2]=pa;Rb=pa;Sb=(c[t>>2]|0)+gb|0}else{Rb=ra;Sb=Kb}pa=c[h>>2]|0;ba=c[pa+12>>2]|0;if((ba|0)==(c[pa+16>>2]|0)){da=(ee[c[(c[pa>>2]|0)+36>>2]&127](pa)|0)&255;Tb=da;Ub=c[o>>2]|0}else{Tb=a[ba]|0;Ub=Rb}c[o>>2]=Ub+1;a[Ub]=Tb;ba=(c[B>>2]|0)+ -1|0;c[B>>2]=ba;da=c[h>>2]|0;pa=da+12|0;oa=c[pa>>2]|0;if((oa|0)==(c[da+16>>2]|0)){ee[c[(c[da>>2]|0)+40>>2]&127](da)|0}else{c[pa>>2]=oa+1}if((ba|0)>0){Ib=Nb;Jb=Ob;Kb=Sb}else{Vb=Sb;break}}}else{Vb=W}if((c[o>>2]|0)==(c[t>>2]|0)){X=267;break a}else{ga=Vb;ha=wb;ia=xb;ja=yb;ka=S;la=zb}break};case 1:{if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}ea=c[h>>2]|0;ba=c[ea+12>>2]|0;if((ba|0)==(c[ea+16>>2]|0)){Wb=(ee[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)&255}else{Wb=a[ba]|0}if(!(Wb<<24>>24>-1)){X=25;break a}if((b[(c[f>>2]|0)+(Wb<<24>>24<<1)>>1]&8192)==0){X=25;break a}ba=c[h>>2]|0;ea=ba+12|0;oa=c[ea>>2]|0;if((oa|0)==(c[ba+16>>2]|0)){Xb=(ee[c[(c[ba>>2]|0)+40>>2]&127](ba)|0)&255}else{c[ea>>2]=oa+1;Xb=a[oa]|0}gQ(A,Xb);X=26;break};default:{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T}}}while(0);f:do{if((X|0)==26){X=0;if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}else{Yb=Y;Zb=Y}while(1){U=c[h>>2]|0;do{if((U|0)==0){_b=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){_b=U;break}if((ee[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;_b=0;break}else{_b=c[h>>2]|0;break}}}while(0);U=(_b|0)==0;do{if((Zb|0)==0){$b=Yb;X=37}else{if((c[Zb+12>>2]|0)!=(c[Zb+16>>2]|0)){if(U){ac=Yb;bc=Zb;break}else{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}}if((ee[c[(c[Zb>>2]|0)+36>>2]&127](Zb)|0)==-1){c[e>>2]=0;$b=0;X=37;break}else{if(U^(Yb|0)==0){ac=Yb;bc=Yb;break}else{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}}}}while(0);if((X|0)==37){X=0;if(U){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}else{ac=$b;bc=0}}ra=c[h>>2]|0;gb=c[ra+12>>2]|0;if((gb|0)==(c[ra+16>>2]|0)){cc=(ee[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)&255}else{cc=a[gb]|0}if(!(cc<<24>>24>-1)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}if((b[(c[f>>2]|0)+(cc<<24>>24<<1)>>1]&8192)==0){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}gb=c[h>>2]|0;ra=gb+12|0;qa=c[ra>>2]|0;if((qa|0)==(c[gb+16>>2]|0)){dc=(ee[c[(c[gb>>2]|0)+40>>2]&127](gb)|0)&255}else{c[ra>>2]=qa+1;dc=a[qa]|0}gQ(A,dc);Yb=ac;Zb=bc}}}while(0);W=p+1|0;if(W>>>0<4){Q=ja;r=ia;R=ha;D=ga;p=W;S=ka;T=la}else{Z=ha;_=ia;$=ka;aa=la;X=269;break}}g:do{if((X|0)==25){c[k>>2]=c[k>>2]|4;ec=0;fc=R;gc=T}else if((X|0)==112){c[k>>2]=c[k>>2]|4;ec=0;fc=R;gc=T}else if((X|0)==162){c[k>>2]=c[k>>2]|4;ec=0;fc=R;gc=T}else if((X|0)==182){g_()}else if((X|0)==198){g_()}else if((X|0)==209){g_()}else if((X|0)==229){c[k>>2]=c[k>>2]|4;ec=0;fc=wb;gc=zb}else if((X|0)==250){c[k>>2]=c[k>>2]|4;ec=0;fc=wb;gc=zb}else if((X|0)==253){g_()}else if((X|0)==267){c[k>>2]=c[k>>2]|4;ec=0;fc=wb;gc=zb}else if((X|0)==269){h:do{if(($|0)!=0){la=$+1|0;ka=$+8|0;ia=$+4|0;ha=1;i:while(1){S=a[$]|0;if((S&1)==0){hc=(S&255)>>>1}else{hc=c[ia>>2]|0}if(!(ha>>>0<hc>>>0)){break h}S=c[h>>2]|0;do{if((S|0)==0){ic=0}else{if((c[S+12>>2]|0)!=(c[S+16>>2]|0)){ic=S;break}if((ee[c[(c[S>>2]|0)+36>>2]&127](S)|0)==-1){c[h>>2]=0;ic=0;break}else{ic=c[h>>2]|0;break}}}while(0);S=(ic|0)==0;U=c[e>>2]|0;do{if((U|0)==0){X=285}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){if(S){break}else{break i}}if((ee[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[e>>2]=0;X=285;break}else{if(S){break}else{break i}}}}while(0);if((X|0)==285){X=0;if(S){break}}U=c[h>>2]|0;p=c[U+12>>2]|0;if((p|0)==(c[U+16>>2]|0)){jc=(ee[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{jc=a[p]|0}if((a[$]&1)==0){kc=la}else{kc=c[ka>>2]|0}if(!(jc<<24>>24==(a[kc+ha|0]|0))){break}p=ha+1|0;U=c[h>>2]|0;ga=U+12|0;D=c[ga>>2]|0;if((D|0)==(c[U+16>>2]|0)){ee[c[(c[U>>2]|0)+40>>2]&127](U)|0;ha=p;continue}else{c[ga>>2]=D+1;ha=p;continue}}c[k>>2]=c[k>>2]|4;ec=0;fc=Z;gc=aa;break g}}while(0);if((Z|0)==(_|0)){ec=1;fc=_;gc=aa;break}c[C>>2]=0;MV(w,Z,_,C);if((c[C>>2]|0)==0){ec=1;fc=Z;gc=aa;break}c[k>>2]=c[k>>2]|4;ec=0;fc=Z;gc=aa}}while(0);QP(A);QP(z);QP(y);QP(x);QP(w);if((fc|0)==0){i=q;return ec|0}be[gc&255](fc);i=q;return ec|0}function IV(a){a=a|0;var b=0;b=Ac(8)|0;mP(b,a);Pd(b|0,103568,42)}function JV(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+168|0;l=d;m=d+8|0;n=d+24|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=191;v=n+100|0;MQ(q,h);n=q;w=c[n>>2]|0;if(!((c[26644]|0)==-1)){c[m>>2]=106576;c[m+4>>2]=189;c[m+8>>2]=0;BP(106576,m,190)}m=(c[106580>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Ac(4)|0;z=y;AZ(z);A=122136;B=127;Pd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Ac(4)|0;z=y;AZ(z);A=122136;B=127;Pd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=HV(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}if((a[r]|0)!=0){gQ(k,re[c[(c[w>>2]|0)+28>>2]&63](B,45)|0)}r=re[c[(c[w>>2]|0)+28>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -1|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+1|0;if(!((a[z]|0)==r<<24>>24)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);KV(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){D=e;break}if(!((ee[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){D=e;break}c[w>>2]=0;D=0}}while(0);w=(D|0)==0;do{if((f|0)==0){E=25}else{if((c[f+12>>2]|0)!=(c[f+16>>2]|0)){if(w){break}else{E=27;break}}if((ee[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1){c[A>>2]=0;E=25;break}else{if(w^(f|0)==0){break}else{E=27;break}}}}while(0);if((E|0)==25){if(w){E=27}}if((E|0)==27){c[j>>2]=c[j>>2]|2}c[b>>2]=D;gP(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}be[c[u>>2]&255](n);i=d;return}function KV(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=10}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g|0;if((e|0)==(d|0)){i=f;return b|0}if((l-j|0)>>>0<h>>>0){jQ(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;k=g+1|0;if((k|0)==(e|0)){break}else{d=d+1|0;g=k}}a[n+m|0]=0;m=j+h|0;if((a[b]&1)==0){a[b]=m<<1;i=f;return b|0}else{c[b+4>>2]=m;i=f;return b|0}return 0}function LV(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[26504]|0)==-1)){c[p>>2]=106016;c[p+4>>2]=189;c[p+8>>2]=0;BP(106016,p,190)}p=(c[106020>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Ac(4)|0;C=B;AZ(C);D=122136;E=127;Pd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Ac(4)|0;C=B;AZ(C);D=122136;E=127;Pd(B|0,D|0,E|0)}E=b;ce[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;ce[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}aQ(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;QP(r);ce[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}aQ(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;QP(s);a[f]=ee[c[(c[b>>2]|0)+12>>2]&127](E)|0;a[g]=ee[c[(c[b>>2]|0)+16>>2]&127](E)|0;ce[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}aQ(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;QP(t);ce[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}aQ(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;QP(u);F=ee[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[26488]|0)==-1)){c[o>>2]=105952;c[o+4>>2]=189;c[o+8>>2]=0;BP(105952,o,190)}o=(c[105956>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Ac(4)|0;H=G;AZ(H);I=122136;J=127;Pd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Ac(4)|0;H=G;AZ(H);I=122136;J=127;Pd(G|0,I|0,J|0)}J=E;ce[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;ce[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}aQ(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;QP(w);ce[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}aQ(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;QP(x);a[f]=ee[c[(c[E>>2]|0)+12>>2]&127](J)|0;a[g]=ee[c[(c[E>>2]|0)+16>>2]&127](J)|0;ce[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}aQ(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;QP(y);ce[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}aQ(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;QP(z);F=ee[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function MV(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[b+4>>2]|0}if((j|0)==0){i=g;return}do{if((d|0)==(e|0)){k=h}else{j=e+ -4|0;if(j>>>0>d>>>0){l=d;m=j}else{k=h;break}do{j=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=j;l=l+4|0;m=m+ -4|0;}while(l>>>0<m>>>0);k=a[b]|0}}while(0);if((k&1)==0){n=b+1|0;o=(k&255)>>>1}else{n=c[b+8>>2]|0;o=c[b+4>>2]|0}b=e+ -4|0;e=a[n]|0;k=e<<24>>24<1|e<<24>>24==127;a:do{if(b>>>0>d>>>0){m=n+o|0;l=e;h=n;j=d;p=k;while(1){if(!p){if((l<<24>>24|0)!=(c[j>>2]|0)){break}}q=(m-h|0)>1?h+1|0:h;r=j+4|0;s=a[q]|0;t=s<<24>>24<1|s<<24>>24==127;if(r>>>0<b>>>0){l=s;h=q;j=r;p=t}else{u=s;v=t;break a}}c[f>>2]=4;i=g;return}else{u=e;v=k}}while(0);if(v){i=g;return}v=c[b>>2]|0;if(!(u<<24>>24>>>0<v>>>0|(v|0)==0)){i=g;return}c[f>>2]=4;i=g;return}function NV(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function OV(a){a=a|0;i=i;return}function PV(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+400|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+40|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=191;y=o+400|0;MQ(r,h);o=r;z=c[o>>2]|0;if(!((c[26642]|0)==-1)){c[n>>2]=106568;c[n+4>>2]=189;c[n+8>>2]=0;BP(106568,n,190)}n=(c[106572>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Ac(4)|0;C=B;AZ(C);D=122136;E=127;Pd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Ac(4)|0;C=B;AZ(C);D=122136;E=127;Pd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=QV(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;Ae[c[(c[z>>2]|0)+48>>2]&63](E,106272,106282|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>392){l=VZ((g>>2)+2|0)|0;if((l|0)!=0){F=l;G=l;break}g_()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+40|0;l=u;h=H;t=r;while(1){C=c[t>>2]|0;n=y;while(1){A=n+4|0;if((c[n>>2]|0)==(C|0)){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[106272+(I-l>>2)|0]|0;n=t+4|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((td(p|0,106208,m|0)|0)!=1){t=Ac(8)|0;mP(t,106216);Pd(t|0,103568,42)}if((F|0)==0){break}WZ(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=1}else{m=c[e+12>>2]|0;if((m|0)==(c[e+16>>2]|0)){L=ee[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{L=c[m>>2]|0}if((L|0)==-1){c[F>>2]=0;K=1;break}else{K=(c[F>>2]|0)==0;break}}}while(0);L=c[D>>2]|0;do{if((L|0)==0){M=35}else{e=c[L+12>>2]|0;if((e|0)==(c[L+16>>2]|0)){N=ee[c[(c[L>>2]|0)+36>>2]&127](L)|0}else{N=c[e>>2]|0}if((N|0)==-1){c[D>>2]=0;M=35;break}else{if(K){break}else{M=37;break}}}}while(0);if((M|0)==35){if(K){M=37}}if((M|0)==37){c[j>>2]=c[j>>2]|2}c[b>>2]=c[F>>2];gP(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}be[c[x>>2]&255](o);i=d;return}function QV(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0;p=i;i=i+416|0;q=p;r=p+8|0;s=p+408|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;c[q>>2]=o;o=r;c[s>>2]=0;D=w;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=x;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=y;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=z;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=A;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;TV(f,g,t,u,v,w,x,y,z,B);t=m;c[n>>2]=c[t>>2];g=b;b=e;e=z+4|0;f=z+8|0;D=y+4|0;E=y+8|0;F=(h&512|0)!=0;h=x+4|0;G=x+8|0;H=A+4|0;I=A+8|0;J=s+3|0;K=w+4|0;L=r+400|0;r=o;M=o;o=0;N=0;O=191;a:while(1){P=c[g>>2]|0;do{if((P|0)==0){Q=1}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=ee[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{S=c[R>>2]|0}if((S|0)==-1){c[g>>2]=0;Q=1;break}else{Q=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=15}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){U=ee[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{U=c[R>>2]|0}if((U|0)==-1){c[b>>2]=0;T=15;break}else{if(Q){V=P;break}else{W=M;X=r;Y=N;Z=O;T=276;break a}}}}while(0);if((T|0)==15){T=0;if(Q){W=M;X=r;Y=N;Z=O;T=276;break}else{V=0}}b:do{switch(a[s+o|0]|0){case 1:{if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}P=c[g>>2]|0;R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){_=ee[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{_=c[R>>2]|0}if(!(ie[c[(c[l>>2]|0)+12>>2]&63](l,8192,_)|0)){T=27;break a}R=c[g>>2]|0;P=R+12|0;$=c[P>>2]|0;if(($|0)==(c[R+16>>2]|0)){aa=ee[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[P>>2]=$+4;aa=c[$>>2]|0}wQ(A,aa);T=28;break};case 3:{$=a[y]|0;P=($&1)==0;if(P){ba=($&255)>>>1}else{ba=c[D>>2]|0}R=a[z]|0;ca=(R&1)==0;if(ca){da=(R&255)>>>1}else{da=c[e>>2]|0}if((ba|0)==(0-da|0)){ea=M;fa=r;ga=L;ha=N;ia=O;break b}if(P){ja=($&255)>>>1}else{ja=c[D>>2]|0}do{if((ja|0)!=0){if(ca){ka=(R&255)>>>1}else{ka=c[e>>2]|0}if((ka|0)==0){break}la=c[g>>2]|0;ma=c[la+12>>2]|0;if((ma|0)==(c[la+16>>2]|0)){na=ee[c[(c[la>>2]|0)+36>>2]&127](la)|0;oa=na;pa=a[y]|0}else{oa=c[ma>>2]|0;pa=$}ma=c[g>>2]|0;na=ma+12|0;la=c[na>>2]|0;qa=(la|0)==(c[ma+16>>2]|0);if((oa|0)==(c[((pa&1)==0?D:c[E>>2]|0)>>2]|0)){if(qa){ee[c[(c[ma>>2]|0)+40>>2]&127](ma)|0}else{c[na>>2]=la+4}na=a[y]|0;if((na&1)==0){ra=(na&255)>>>1}else{ra=c[D>>2]|0}ea=M;fa=r;ga=L;ha=ra>>>0>1?y:N;ia=O;break b}if(qa){sa=ee[c[(c[ma>>2]|0)+36>>2]&127](ma)|0}else{sa=c[la>>2]|0}if((sa|0)!=(c[((a[z]&1)==0?e:c[f>>2]|0)>>2]|0)){T=116;break a}la=c[g>>2]|0;ma=la+12|0;qa=c[ma>>2]|0;if((qa|0)==(c[la+16>>2]|0)){ee[c[(c[la>>2]|0)+40>>2]&127](la)|0}else{c[ma>>2]=qa+4}a[k]=1;qa=a[z]|0;if((qa&1)==0){ta=(qa&255)>>>1}else{ta=c[e>>2]|0}ea=M;fa=r;ga=L;ha=ta>>>0>1?z:N;ia=O;break b}}while(0);if(P){ua=($&255)>>>1}else{ua=c[D>>2]|0}ca=c[g>>2]|0;qa=c[ca+12>>2]|0;ma=(qa|0)==(c[ca+16>>2]|0);if((ua|0)==0){if(ma){la=ee[c[(c[ca>>2]|0)+36>>2]&127](ca)|0;va=la;wa=a[z]|0}else{va=c[qa>>2]|0;wa=R}if((va|0)!=(c[((wa&1)==0?e:c[f>>2]|0)>>2]|0)){ea=M;fa=r;ga=L;ha=N;ia=O;break b}la=c[g>>2]|0;na=la+12|0;xa=c[na>>2]|0;if((xa|0)==(c[la+16>>2]|0)){ee[c[(c[la>>2]|0)+40>>2]&127](la)|0}else{c[na>>2]=xa+4}a[k]=1;xa=a[z]|0;if((xa&1)==0){ya=(xa&255)>>>1}else{ya=c[e>>2]|0}ea=M;fa=r;ga=L;ha=ya>>>0>1?z:N;ia=O;break b}if(ma){ma=ee[c[(c[ca>>2]|0)+36>>2]&127](ca)|0;za=ma;Aa=a[y]|0}else{za=c[qa>>2]|0;Aa=$}if((za|0)!=(c[((Aa&1)==0?D:c[E>>2]|0)>>2]|0)){a[k]=1;ea=M;fa=r;ga=L;ha=N;ia=O;break b}qa=c[g>>2]|0;ma=qa+12|0;ca=c[ma>>2]|0;if((ca|0)==(c[qa+16>>2]|0)){ee[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[ma>>2]=ca+4}ca=a[y]|0;if((ca&1)==0){Ba=(ca&255)>>>1}else{Ba=c[D>>2]|0}ea=M;fa=r;ga=L;ha=Ba>>>0>1?y:N;ia=O;break};case 0:{T=28;break};case 4:{ca=M;ma=r;qa=L;xa=0;na=O;c:while(1){la=c[g>>2]|0;do{if((la|0)==0){Ca=1}else{Da=c[la+12>>2]|0;if((Da|0)==(c[la+16>>2]|0)){Ea=ee[c[(c[la>>2]|0)+36>>2]&127](la)|0}else{Ea=c[Da>>2]|0}if((Ea|0)==-1){c[g>>2]=0;Ca=1;break}else{Ca=(c[g>>2]|0)==0;break}}}while(0);la=c[b>>2]|0;do{if((la|0)==0){T=188}else{Da=c[la+12>>2]|0;if((Da|0)==(c[la+16>>2]|0)){Fa=ee[c[(c[la>>2]|0)+36>>2]&127](la)|0}else{Fa=c[Da>>2]|0}if((Fa|0)==-1){c[b>>2]=0;T=188;break}else{if(Ca){break}else{break c}}}}while(0);if((T|0)==188){T=0;if(Ca){break}}la=c[g>>2]|0;Da=c[la+12>>2]|0;if((Da|0)==(c[la+16>>2]|0)){Ga=ee[c[(c[la>>2]|0)+36>>2]&127](la)|0}else{Ga=c[Da>>2]|0}if(ie[c[(c[l>>2]|0)+12>>2]&63](l,2048,Ga)|0){Da=c[n>>2]|0;if((Da|0)==(c[q>>2]|0)){UV(m,n,q);Ha=c[n>>2]|0}else{Ha=Da}c[n>>2]=Ha+4;c[Ha>>2]=Ga;Ia=ca;Ja=ma;Ka=qa;La=xa+1|0;Ma=na}else{Da=a[w]|0;if((Da&1)==0){Na=(Da&255)>>>1}else{Na=c[K>>2]|0}if((Na|0)==0|(xa|0)==0){break}if((Ga|0)!=(c[v>>2]|0)){break}if((ma|0)==(qa|0)){Da=ma-ca|0;la=Da>>>0<2147483647?Da<<1:-1;if((na|0)!=191){Oa=ca}else{Oa=0}Pa=YZ(Oa,la)|0;if((Pa|0)==0){T=206;break a}Qa=Pa;Ra=Pa+(Da>>2<<2)|0;Sa=Pa+(la>>>2<<2)|0;Ta=166}else{Qa=ca;Ra=ma;Sa=qa;Ta=na}c[Ra>>2]=xa;Ia=Qa;Ja=Ra+4|0;Ka=Sa;La=0;Ma=Ta}la=c[g>>2]|0;Pa=la+12|0;Da=c[Pa>>2]|0;if((Da|0)==(c[la+16>>2]|0)){ee[c[(c[la>>2]|0)+40>>2]&127](la)|0;ca=Ia;ma=Ja;qa=Ka;xa=La;na=Ma;continue}else{c[Pa>>2]=Da+4;ca=Ia;ma=Ja;qa=Ka;xa=La;na=Ma;continue}}if((ca|0)==(ma|0)|(xa|0)==0){Ua=ca;Va=ma;Wa=qa;Xa=na}else{if((ma|0)==(qa|0)){$=ma-ca|0;R=$>>>0<2147483647?$<<1:-1;if((na|0)!=191){Ya=ca}else{Ya=0}P=YZ(Ya,R)|0;if((P|0)==0){T=217;break a}Za=P;_a=P+($>>2<<2)|0;$a=P+(R>>>2<<2)|0;ab=166}else{Za=ca;_a=ma;$a=qa;ab=na}c[_a>>2]=xa;Ua=Za;Va=_a+4|0;Wa=$a;Xa=ab}R=c[B>>2]|0;if((R|0)>0){P=c[g>>2]|0;do{if((P|0)==0){bb=1}else{$=c[P+12>>2]|0;if(($|0)==(c[P+16>>2]|0)){cb=ee[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{cb=c[$>>2]|0}if((cb|0)==-1){c[g>>2]=0;bb=1;break}else{bb=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=234}else{xa=c[P+12>>2]|0;if((xa|0)==(c[P+16>>2]|0)){db=ee[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{db=c[xa>>2]|0}if((db|0)==-1){c[b>>2]=0;T=234;break}else{if(bb){eb=P;break}else{T=240;break a}}}}while(0);if((T|0)==234){T=0;if(bb){T=240;break a}else{eb=0}}P=c[g>>2]|0;xa=c[P+12>>2]|0;if((xa|0)==(c[P+16>>2]|0)){fb=ee[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{fb=c[xa>>2]|0}if((fb|0)!=(c[u>>2]|0)){T=240;break a}xa=c[g>>2]|0;P=xa+12|0;na=c[P>>2]|0;if((na|0)==(c[xa+16>>2]|0)){ee[c[(c[xa>>2]|0)+40>>2]&127](xa)|0;gb=eb;hb=R;ib=eb}else{c[P>>2]=na+4;gb=eb;hb=R;ib=eb}while(1){na=c[g>>2]|0;do{if((na|0)==0){jb=1}else{P=c[na+12>>2]|0;if((P|0)==(c[na+16>>2]|0)){kb=ee[c[(c[na>>2]|0)+36>>2]&127](na)|0}else{kb=c[P>>2]|0}if((kb|0)==-1){c[g>>2]=0;jb=1;break}else{jb=(c[g>>2]|0)==0;break}}}while(0);do{if((ib|0)==0){lb=gb;T=257}else{na=c[ib+12>>2]|0;if((na|0)==(c[ib+16>>2]|0)){mb=ee[c[(c[ib>>2]|0)+36>>2]&127](ib)|0}else{mb=c[na>>2]|0}if((mb|0)==-1){c[b>>2]=0;lb=0;T=257;break}else{if(jb^(gb|0)==0){nb=gb;ob=gb;break}else{T=263;break a}}}}while(0);if((T|0)==257){T=0;if(jb){T=263;break a}else{nb=lb;ob=0}}na=c[g>>2]|0;P=c[na+12>>2]|0;if((P|0)==(c[na+16>>2]|0)){pb=ee[c[(c[na>>2]|0)+36>>2]&127](na)|0}else{pb=c[P>>2]|0}if(!(ie[c[(c[l>>2]|0)+12>>2]&63](l,2048,pb)|0)){T=263;break a}if((c[n>>2]|0)==(c[q>>2]|0)){UV(m,n,q)}P=c[g>>2]|0;na=c[P+12>>2]|0;if((na|0)==(c[P+16>>2]|0)){qb=ee[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{qb=c[na>>2]|0}na=c[n>>2]|0;c[n>>2]=na+4;c[na>>2]=qb;na=hb+ -1|0;c[B>>2]=na;P=c[g>>2]|0;xa=P+12|0;qa=c[xa>>2]|0;if((qa|0)==(c[P+16>>2]|0)){ee[c[(c[P>>2]|0)+40>>2]&127](P)|0}else{c[xa>>2]=qa+4}if((na|0)>0){gb=nb;hb=na;ib=ob}else{break}}}if((c[n>>2]|0)==(c[t>>2]|0)){T=274;break a}else{ea=Ua;fa=Va;ga=Wa;ha=N;ia=Xa}break};case 2:{if(!((N|0)!=0|o>>>0<2)){if((o|0)==2){rb=(a[J]|0)!=0}else{rb=0}if(!(F|rb)){ea=M;fa=r;ga=L;ha=0;ia=O;break b}}R=a[x]|0;na=(R&1)==0?h:c[G>>2]|0;d:do{if((o|0)==0){sb=V;tb=V;ub=R;vb=na}else{if((d[s+(o+ -1)|0]|0)<2){wb=R;xb=na}else{sb=V;tb=V;ub=R;vb=na;break}while(1){if((wb&1)==0){yb=h;zb=(wb&255)>>>1}else{yb=c[G>>2]|0;zb=c[h>>2]|0}if((xb|0)==(yb+(zb<<2)|0)){Ab=wb;break}if(!(ie[c[(c[l>>2]|0)+12>>2]&63](l,8192,c[xb>>2]|0)|0)){T=129;break}wb=a[x]|0;xb=xb+4|0}if((T|0)==129){T=0;Ab=a[x]|0}qa=(Ab&1)==0;xa=xb-(qa?h:c[G>>2]|0)>>2;P=a[A]|0;ma=(P&1)==0;if(ma){Bb=(P&255)>>>1}else{Bb=c[H>>2]|0}e:do{if(!(xa>>>0>Bb>>>0)){if(ma){Cb=H+(((P&255)>>>1)-xa<<2)|0;Db=H;Eb=(P&255)>>>1}else{ca=c[I>>2]|0;$=c[H>>2]|0;Cb=ca+($-xa<<2)|0;Db=ca;Eb=$}$=Db+(Eb<<2)|0;if((Cb|0)==($|0)){sb=V;tb=V;ub=Ab;vb=xb;break d}else{Fb=qa?h:c[G>>2]|0;Gb=Cb}while(1){if((c[Gb>>2]|0)!=(c[Fb>>2]|0)){break e}ca=Gb+4|0;if((ca|0)==($|0)){sb=V;tb=V;ub=Ab;vb=xb;break d}Fb=Fb+4|0;Gb=ca}}}while(0);sb=V;tb=V;ub=Ab;vb=qa?h:c[G>>2]|0}}while(0);f:while(1){if((ub&1)==0){Hb=h;Ib=(ub&255)>>>1}else{Hb=c[G>>2]|0;Ib=c[h>>2]|0}if((vb|0)==(Hb+(Ib<<2)|0)){break}na=c[g>>2]|0;do{if((na|0)==0){Jb=1}else{R=c[na+12>>2]|0;if((R|0)==(c[na+16>>2]|0)){Kb=ee[c[(c[na>>2]|0)+36>>2]&127](na)|0}else{Kb=c[R>>2]|0}if((Kb|0)==-1){c[g>>2]=0;Jb=1;break}else{Jb=(c[g>>2]|0)==0;break}}}while(0);do{if((tb|0)==0){Lb=sb;T=159}else{na=c[tb+12>>2]|0;if((na|0)==(c[tb+16>>2]|0)){Mb=ee[c[(c[tb>>2]|0)+36>>2]&127](tb)|0}else{Mb=c[na>>2]|0}if((Mb|0)==-1){c[b>>2]=0;Lb=0;T=159;break}else{if(Jb^(sb|0)==0){Nb=sb;Ob=sb;break}else{break f}}}}while(0);if((T|0)==159){T=0;if(Jb){break}else{Nb=Lb;Ob=0}}na=c[g>>2]|0;qa=c[na+12>>2]|0;if((qa|0)==(c[na+16>>2]|0)){Pb=ee[c[(c[na>>2]|0)+36>>2]&127](na)|0}else{Pb=c[qa>>2]|0}if((Pb|0)!=(c[vb>>2]|0)){break}qa=c[g>>2]|0;na=qa+12|0;R=c[na>>2]|0;if((R|0)==(c[qa+16>>2]|0)){ee[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[na>>2]=R+4}sb=Nb;tb=Ob;ub=a[x]|0;vb=vb+4|0}if(!F){ea=M;fa=r;ga=L;ha=N;ia=O;break b}R=a[x]|0;if((R&1)==0){Qb=h;Rb=(R&255)>>>1}else{Qb=c[G>>2]|0;Rb=c[h>>2]|0}if((vb|0)==(Qb+(Rb<<2)|0)){ea=M;fa=r;ga=L;ha=N;ia=O}else{T=174;break a}break};default:{ea=M;fa=r;ga=L;ha=N;ia=O}}}while(0);g:do{if((T|0)==28){T=0;if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}else{Sb=V;Tb=V}while(1){R=c[g>>2]|0;do{if((R|0)==0){Ub=1}else{na=c[R+12>>2]|0;if((na|0)==(c[R+16>>2]|0)){Vb=ee[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Vb=c[na>>2]|0}if((Vb|0)==-1){c[g>>2]=0;Ub=1;break}else{Ub=(c[g>>2]|0)==0;break}}}while(0);do{if((Tb|0)==0){Wb=Sb;T=42}else{R=c[Tb+12>>2]|0;if((R|0)==(c[Tb+16>>2]|0)){Xb=ee[c[(c[Tb>>2]|0)+36>>2]&127](Tb)|0}else{Xb=c[R>>2]|0}if((Xb|0)==-1){c[b>>2]=0;Wb=0;T=42;break}else{if(Ub^(Sb|0)==0){Yb=Sb;Zb=Sb;break}else{ea=M;fa=r;ga=L;ha=N;ia=O;break g}}}}while(0);if((T|0)==42){T=0;if(Ub){ea=M;fa=r;ga=L;ha=N;ia=O;break g}else{Yb=Wb;Zb=0}}R=c[g>>2]|0;na=c[R+12>>2]|0;if((na|0)==(c[R+16>>2]|0)){_b=ee[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{_b=c[na>>2]|0}if(!(ie[c[(c[l>>2]|0)+12>>2]&63](l,8192,_b)|0)){ea=M;fa=r;ga=L;ha=N;ia=O;break g}na=c[g>>2]|0;R=na+12|0;qa=c[R>>2]|0;if((qa|0)==(c[na+16>>2]|0)){$b=ee[c[(c[na>>2]|0)+40>>2]&127](na)|0}else{c[R>>2]=qa+4;$b=c[qa>>2]|0}wQ(A,$b);Sb=Yb;Tb=Zb}}}while(0);qa=o+1|0;if(qa>>>0<4){L=ga;r=fa;M=ea;o=qa;N=ha;O=ia}else{W=ea;X=fa;Y=ha;Z=ia;T=276;break}}h:do{if((T|0)==27){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==116){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==174){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==206){g_()}else if((T|0)==217){g_()}else if((T|0)==240){c[j>>2]=c[j>>2]|4;ac=0;bc=Ua;cc=Xa}else if((T|0)==263){c[j>>2]=c[j>>2]|4;ac=0;bc=Ua;cc=Xa}else if((T|0)==274){c[j>>2]=c[j>>2]|4;ac=0;bc=Ua;cc=Xa}else if((T|0)==276){i:do{if((Y|0)!=0){ia=Y+4|0;ha=Y+8|0;fa=1;j:while(1){ea=a[Y]|0;if((ea&1)==0){dc=(ea&255)>>>1}else{dc=c[ia>>2]|0}if(!(fa>>>0<dc>>>0)){break i}ea=c[g>>2]|0;do{if((ea|0)==0){ec=1}else{N=c[ea+12>>2]|0;if((N|0)==(c[ea+16>>2]|0)){fc=ee[c[(c[ea>>2]|0)+36>>2]&127](ea)|0}else{fc=c[N>>2]|0}if((fc|0)==-1){c[g>>2]=0;ec=1;break}else{ec=(c[g>>2]|0)==0;break}}}while(0);ea=c[b>>2]|0;do{if((ea|0)==0){T=295}else{N=c[ea+12>>2]|0;if((N|0)==(c[ea+16>>2]|0)){gc=ee[c[(c[ea>>2]|0)+36>>2]&127](ea)|0}else{gc=c[N>>2]|0}if((gc|0)==-1){c[b>>2]=0;T=295;break}else{if(ec){break}else{break j}}}}while(0);if((T|0)==295){T=0;if(ec){break}}ea=c[g>>2]|0;N=c[ea+12>>2]|0;if((N|0)==(c[ea+16>>2]|0)){hc=ee[c[(c[ea>>2]|0)+36>>2]&127](ea)|0}else{hc=c[N>>2]|0}if((a[Y]&1)==0){ic=ia}else{ic=c[ha>>2]|0}if((hc|0)!=(c[ic+(fa<<2)>>2]|0)){break}N=fa+1|0;ea=c[g>>2]|0;o=ea+12|0;r=c[o>>2]|0;if((r|0)==(c[ea+16>>2]|0)){ee[c[(c[ea>>2]|0)+40>>2]&127](ea)|0;fa=N;continue}else{c[o>>2]=r+4;fa=N;continue}}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z;break h}}while(0);if((W|0)==(X|0)){ac=1;bc=X;cc=Z;break}c[C>>2]=0;MV(w,W,X,C);if((c[C>>2]|0)==0){ac=1;bc=W;cc=Z;break}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z}}while(0);sQ(A);sQ(z);sQ(y);sQ(x);QP(w);if((bc|0)==0){i=p;return ac|0}be[cc&255](bc);i=p;return ac|0}function RV(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+464|0;l=d;m=d+8|0;n=d+24|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=191;v=n+400|0;MQ(q,h);n=q;w=c[n>>2]|0;if(!((c[26642]|0)==-1)){c[m>>2]=106568;c[m+4>>2]=189;c[m+8>>2]=0;BP(106568,m,190)}m=(c[106572>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Ac(4)|0;z=y;AZ(z);A=122136;B=127;Pd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Ac(4)|0;z=y;AZ(z);A=122136;B=127;Pd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=QV(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}if((a[r]|0)!=0){wQ(k,re[c[(c[w>>2]|0)+44>>2]&63](B,45)|0)}r=re[c[(c[w>>2]|0)+44>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -4|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+4|0;if((c[z>>2]|0)!=(r|0)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);SV(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=1}else{C=c[e+12>>2]|0;if((C|0)==(c[e+16>>2]|0)){E=ee[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{E=c[C>>2]|0}if((E|0)==-1){c[w>>2]=0;D=1;break}else{D=(c[w>>2]|0)==0;break}}}while(0);do{if((f|0)==0){F=29}else{E=c[f+12>>2]|0;if((E|0)==(c[f+16>>2]|0)){G=ee[c[(c[f>>2]|0)+36>>2]&127](f)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[A>>2]=0;F=29;break}else{if(D){break}else{F=31;break}}}}while(0);if((F|0)==29){if(D){F=31}}if((F|0)==31){c[j>>2]=c[j>>2]|2}c[b>>2]=c[w>>2];gP(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}be[c[u>>2]&255](n);i=d;return}function SV(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=1}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g>>2;if((h|0)==0){i=f;return b|0}if((l-j|0)>>>0<h>>>0){yQ(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{k=j+((e+ -4+(0-g)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{d=d+4|0;g=m}}o=n+(k<<2)|0}c[o>>2]=0;o=j+h|0;if((a[b]&1)==0){a[b]=o<<1;i=f;return b|0}else{c[b+4>>2]=o;i=f;return b|0}return 0}function TV(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[26536]|0)==-1)){c[p>>2]=106144;c[p+4>>2]=189;c[p+8>>2]=0;BP(106144,p,190)}p=(c[106148>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Ac(4)|0;C=B;AZ(C);D=122136;E=127;Pd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Ac(4)|0;C=B;AZ(C);D=122136;E=127;Pd(B|0,D|0,E|0)}E=b;ce[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;ce[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}vQ(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;sQ(r);ce[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}vQ(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;sQ(s);c[f>>2]=ee[c[(c[b>>2]|0)+12>>2]&127](E)|0;c[g>>2]=ee[c[(c[b>>2]|0)+16>>2]&127](E)|0;ce[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}aQ(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;QP(t);ce[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}vQ(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;sQ(u);F=ee[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[26520]|0)==-1)){c[o>>2]=106080;c[o+4>>2]=189;c[o+8>>2]=0;BP(106080,o,190)}o=(c[106084>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Ac(4)|0;H=G;AZ(H);I=122136;J=127;Pd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Ac(4)|0;H=G;AZ(H);I=122136;J=127;Pd(G|0,I|0,J|0)}J=E;ce[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;ce[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}vQ(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;sQ(w);ce[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}vQ(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;sQ(x);c[f>>2]=ee[c[(c[E>>2]|0)+12>>2]&127](J)|0;c[g>>2]=ee[c[(c[E>>2]|0)+16>>2]&127](J)|0;ce[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}aQ(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;QP(y);ce[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}vQ(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;sQ(z);F=ee[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function UV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=191;h=a;a=c[h>>2]|0;j=a;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;if(g){m=a}else{m=0}a=YZ(m,l)|0;m=a;if((a|0)==0){g_()}do{if(g){c[h>>2]=m;n=m}else{a=c[h>>2]|0;c[h>>2]=m;if((a|0)==0){n=m;break}be[c[f>>2]&255](a);n=c[h>>2]|0}}while(0);c[f>>2]=166;c[b>>2]=n+(k<<2);c[d>>2]=(c[h>>2]|0)+(l>>>2<<2);i=e;return}function VV(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function WV(a){a=a|0;i=i;return}function XV(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+104|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+104|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Jc(G|0,100,106328,o|0)|0;do{if(s>>>0>99){do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);o=c[26616]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=PT(r,o,106328,n)|0;o=c[r>>2]|0;if((o|0)==0){g_()}H=VZ(G)|0;if((H|0)!=0){I=o;J=H;K=H;L=G;break}g_()}else{I=0;J=0;K=q;L=s}}while(0);MQ(t,g);s=t;q=c[s>>2]|0;if(!((c[26644]|0)==-1)){c[p>>2]=106576;c[p+4>>2]=189;c[p+8>>2]=0;BP(106576,p,190)}p=(c[106580>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){M=Ac(4)|0;N=M;AZ(N);O=122136;P=127;Pd(M|0,O|0,P|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){M=Ac(4)|0;N=M;AZ(N);O=122136;P=127;Pd(M|0,O|0,P|0)}P=q;O=c[r>>2]|0;Ae[c[(c[q>>2]|0)+32>>2]&63](P,O,O+L|0,K)|0;if((L|0)==0){Q=0}else{Q=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;YV(f,Q,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((L|0)>(C|0)){B=a[A]|0;if((B&1)==0){R=(B&255)>>>1}else{R=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[z+4>>2]|0}T=R+(L-C<<1|1)+S|0}else{S=a[A]|0;if((S&1)==0){U=(S&255)>>>1}else{U=c[A+4>>2]|0}S=a[z]|0;if((S&1)==0){V=(S&255)>>>1}else{V=c[z+4>>2]|0}T=U+2+V|0}V=T+C|0;do{if(V>>>0>100){T=VZ(V)|0;if((T|0)!=0){W=T;X=T;break}g_()}else{W=0;X=t}}while(0);ZV(X,D,E,c[g+4>>2]|0,K,K+L|0,P,Q,v,a[w]|0,a[x]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];nM(b,m,X,e,D,g,j);if((W|0)!=0){WZ(W)}QP(A);QP(z);QP(y);gP(c[s>>2]|0)|0;if((J|0)!=0){WZ(J)}if((I|0)==0){i=d;return}WZ(I);i=d;return}function YV(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[26504]|0)==-1)){c[p>>2]=106016;c[p+4>>2]=189;c[p+8>>2]=0;BP(106016,p,190)}p=(c[106020>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Ac(4)|0;I=H;AZ(I);J=122136;K=127;Pd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Ac(4)|0;I=H;AZ(I);J=122136;K=127;Pd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){ce[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;ce[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}aQ(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;QP(s)}else{ce[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;ce[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}aQ(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;QP(v)}a[g]=ee[c[(c[e>>2]|0)+12>>2]&127](K)|0;a[h]=ee[c[(c[e>>2]|0)+16>>2]&127](K)|0;ce[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}aQ(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;QP(w);ce[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}aQ(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;QP(x);L=ee[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[26488]|0)==-1)){c[o>>2]=105952;c[o+4>>2]=189;c[o+8>>2]=0;BP(105952,o,190)}o=(c[105956>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Ac(4)|0;N=M;AZ(N);O=122136;P=127;Pd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Ac(4)|0;N=M;AZ(N);O=122136;P=127;Pd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){ce[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;ce[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}aQ(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;QP(A)}else{ce[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;ce[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}aQ(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;QP(D)}a[g]=ee[c[(c[G>>2]|0)+12>>2]&127](P)|0;a[h]=ee[c[(c[G>>2]|0)+16>>2]&127](P)|0;ce[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}aQ(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;QP(E);ce[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}aQ(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;QP(F);L=ee[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function ZV(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;t=i;c[f>>2]=d;u=r+1|0;v=r+8|0;w=r+4|0;x=(g&512|0)==0;y=q+1|0;z=q+8|0;A=q+4|0;B=(s|0)>0;C=p+1|0;D=p+8|0;E=p+4|0;F=k+8|0;G=0-s|0;H=h;h=0;while(1){a:do{switch(a[m+h|0]|0){case 2:{I=a[q]|0;J=(I&1)==0;if(J){K=(I&255)>>>1}else{K=c[A>>2]|0}if((K|0)==0|x){L=H;break a}if(J){M=y;N=(I&255)>>>1}else{M=c[z>>2]|0;N=c[A>>2]|0}I=M+N|0;J=c[f>>2]|0;if((M|0)==(I|0)){O=J}else{P=J;J=M;while(1){a[P]=a[J]|0;Q=J+1|0;R=P+1|0;if((Q|0)==(I|0)){O=R;break}else{J=Q;P=R}}}c[f>>2]=O;L=H;break};case 4:{P=c[f>>2]|0;J=l?H+1|0:H;b:do{if(J>>>0<j>>>0){I=J;while(1){R=a[I]|0;if(!(R<<24>>24>-1)){S=I;break b}Q=I+1|0;if((b[(c[F>>2]|0)+(R<<24>>24<<1)>>1]&2048)==0){S=I;break b}if(Q>>>0<j>>>0){I=Q}else{S=Q;break}}}else{S=J}}while(0);I=S;if(B){if(S>>>0>J>>>0){Q=J+(0-I)|0;I=Q>>>0<G>>>0?G:Q;Q=I+s|0;R=P;T=S;U=s;while(1){V=T+ -1|0;W=a[V]|0;c[f>>2]=R+1;a[R]=W;W=U+ -1|0;X=(W|0)>0;if(!(V>>>0>J>>>0&X)){break}R=c[f>>2]|0;U=W;T=V}T=S+I|0;if(X){Y=T;Z=Q;_=32}else{$=0;aa=T;ba=Q}}else{Y=S;Z=s;_=32}if((_|0)==32){_=0;$=re[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;aa=Y;ba=Z}T=c[f>>2]|0;c[f>>2]=T+1;if((ba|0)>0){U=T;R=ba;while(1){a[U]=$;V=R+ -1|0;W=c[f>>2]|0;c[f>>2]=W+1;if((V|0)>0){R=V;U=W}else{ca=W;break}}}else{ca=T}a[ca]=n;da=aa}else{da=S}if((da|0)==(J|0)){U=re[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;R=c[f>>2]|0;c[f>>2]=R+1;a[R]=U}else{U=a[p]|0;R=(U&1)==0;if(R){ea=(U&255)>>>1}else{ea=c[E>>2]|0}if((ea|0)==0){fa=da;ga=-1;ha=0;ia=0}else{if(R){ja=C}else{ja=c[D>>2]|0}fa=da;ga=a[ja]|0;ha=0;ia=0}while(1){do{if((ia|0)==(ga|0)){R=c[f>>2]|0;c[f>>2]=R+1;a[R]=o;R=ha+1|0;U=a[p]|0;Q=(U&1)==0;if(Q){ka=(U&255)>>>1}else{ka=c[E>>2]|0}if(!(R>>>0<ka>>>0)){la=ga;ma=R;na=0;break}if(Q){oa=C}else{oa=c[D>>2]|0}if((a[oa+R|0]|0)==127){la=-1;ma=R;na=0;break}if(Q){pa=C}else{pa=c[D>>2]|0}la=a[pa+R|0]|0;ma=R;na=0}else{la=ga;ma=ha;na=ia}}while(0);R=fa+ -1|0;Q=a[R]|0;U=c[f>>2]|0;c[f>>2]=U+1;a[U]=Q;if((R|0)==(J|0)){break}else{fa=R;ga=la;ha=ma;ia=na+1|0}}}T=c[f>>2]|0;if((P|0)==(T|0)){L=J;break a}R=T+ -1|0;if(R>>>0>P>>>0){qa=P;ra=R}else{L=J;break a}while(1){R=a[qa]|0;a[qa]=a[ra]|0;a[ra]=R;R=qa+1|0;T=ra+ -1|0;if(R>>>0<T>>>0){ra=T;qa=R}else{L=J;break}}break};case 3:{J=a[r]|0;P=(J&1)==0;if(P){sa=(J&255)>>>1}else{sa=c[w>>2]|0}if((sa|0)==0){L=H;break a}if(P){ta=u}else{ta=c[v>>2]|0}P=a[ta]|0;J=c[f>>2]|0;c[f>>2]=J+1;a[J]=P;L=H;break};case 1:{c[e>>2]=c[f>>2];P=re[c[(c[k>>2]|0)+28>>2]&63](k,32)|0;J=c[f>>2]|0;c[f>>2]=J+1;a[J]=P;L=H;break};case 0:{c[e>>2]=c[f>>2];L=H;break};default:{L=H}}}while(0);P=h+1|0;if(P>>>0<4){H=L;h=P}else{break}}h=a[r]|0;r=(h&1)==0;if(r){ua=(h&255)>>>1}else{ua=c[w>>2]|0}if(ua>>>0>1){if(r){va=u;wa=(h&255)>>>1}else{va=c[v>>2]|0;wa=c[w>>2]|0}w=va+1|0;v=va+wa|0;wa=c[f>>2]|0;if((w|0)==(v|0)){xa=wa}else{va=wa;wa=w;while(1){a[va]=a[wa]|0;w=wa+1|0;h=va+1|0;if((w|0)==(v|0)){xa=h;break}else{wa=w;va=h}}}c[f>>2]=xa}xa=g&176;if((xa|0)==16){i=t;return}else if((xa|0)==32){c[e>>2]=c[f>>2];i=t;return}else{c[e>>2]=d;i=t;return}}function _V(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+104|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;MQ(m,g);z=m;A=c[z>>2]|0;if(!((c[26644]|0)==-1)){c[l>>2]=106576;c[l+4>>2]=189;c[l+8>>2]=0;BP(106576,l,190)}l=(c[106580>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Ac(4)|0;D=C;AZ(D);E=122136;F=127;Pd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Ac(4)|0;D=C;AZ(D);E=122136;F=127;Pd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+1|0}else{I=c[j+8>>2]|0}C=a[I]|0;H=C<<24>>24==(re[c[(c[A>>2]|0)+28>>2]&63](F,45)|0)<<24>>24}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;YV(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=VZ(P)|0;if((N|0)!=0){Q=N;R=N;break}g_()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+1|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}ZV(R,w,x,c[g+4>>2]|0,S,S+T|0,F,H,o,a[p]|0,a[q]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];nM(b,k,R,e,w,g,h);if((Q|0)==0){QP(t);QP(s);QP(r);U=c[z>>2]|0;V=U;W=V;X=gP(W)|0;i=d;return}WZ(Q);QP(t);QP(s);QP(r);U=c[z>>2]|0;V=U;W=V;X=gP(W)|0;i=d;return}function $V(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function aW(a){a=a|0;i=i;return}function bW(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+400|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+400|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Jc(G|0,100,106328,o|0)|0;do{if(s>>>0>99){do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);o=c[26616]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=PT(r,o,106328,n)|0;o=c[r>>2]|0;if((o|0)==0){g_()}H=VZ(G<<2)|0;I=H;if((H|0)!=0){J=o;K=I;L=I;M=G;break}g_()}else{J=0;K=0;L=q;M=s}}while(0);MQ(t,g);s=t;q=c[s>>2]|0;if(!((c[26642]|0)==-1)){c[p>>2]=106568;c[p+4>>2]=189;c[p+8>>2]=0;BP(106568,p,190)}p=(c[106572>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){N=Ac(4)|0;O=N;AZ(O);P=122136;Q=127;Pd(N|0,P|0,Q|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){N=Ac(4)|0;O=N;AZ(O);P=122136;Q=127;Pd(N|0,P|0,Q|0)}Q=q;P=c[r>>2]|0;Ae[c[(c[q>>2]|0)+48>>2]&63](Q,P,P+M|0,L)|0;if((M|0)==0){R=0}else{R=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;cW(f,R,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((M|0)>(C|0)){B=a[A]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){T=(B&255)>>>1}else{T=c[z+4>>2]|0}U=S+(M-C<<1|1)+T|0}else{T=a[A]|0;if((T&1)==0){V=(T&255)>>>1}else{V=c[A+4>>2]|0}T=a[z]|0;if((T&1)==0){W=(T&255)>>>1}else{W=c[z+4>>2]|0}U=V+2+W|0}W=U+C|0;do{if(W>>>0>100){U=VZ(W<<2)|0;V=U;if((U|0)!=0){X=V;Y=V;break}g_()}else{X=0;Y=t}}while(0);dW(Y,D,E,c[g+4>>2]|0,L,L+(M<<2)|0,Q,R,v,c[w>>2]|0,c[x>>2]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];YT(b,m,Y,e,D,g,j);if((X|0)!=0){WZ(X)}sQ(A);sQ(z);QP(y);gP(c[s>>2]|0)|0;if((K|0)!=0){WZ(K)}if((J|0)==0){i=d;return}WZ(J);i=d;return}function cW(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[26536]|0)==-1)){c[p>>2]=106144;c[p+4>>2]=189;c[p+8>>2]=0;BP(106144,p,190)}p=(c[106148>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Ac(4)|0;I=H;AZ(I);J=122136;K=127;Pd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Ac(4)|0;I=H;AZ(I);J=122136;K=127;Pd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){ce[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;ce[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}vQ(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;sQ(s)}else{ce[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;ce[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}vQ(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;sQ(v)}c[g>>2]=ee[c[(c[e>>2]|0)+12>>2]&127](K)|0;c[h>>2]=ee[c[(c[e>>2]|0)+16>>2]&127](K)|0;ce[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}aQ(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;QP(w);ce[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}vQ(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;sQ(x);L=ee[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[26520]|0)==-1)){c[o>>2]=106080;c[o+4>>2]=189;c[o+8>>2]=0;BP(106080,o,190)}o=(c[106084>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Ac(4)|0;N=M;AZ(N);O=122136;P=127;Pd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Ac(4)|0;N=M;AZ(N);O=122136;P=127;Pd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){ce[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;ce[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}vQ(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;sQ(A)}else{ce[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;ce[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}vQ(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;sQ(D)}c[g>>2]=ee[c[(c[G>>2]|0)+12>>2]&127](P)|0;c[h>>2]=ee[c[(c[G>>2]|0)+16>>2]&127](P)|0;ce[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}aQ(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;QP(E);ce[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}vQ(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;sQ(F);L=ee[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function dW(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;s=i;c[e>>2]=b;t=q+4|0;u=q+8|0;v=(f&512|0)==0;w=p+4|0;x=p+8|0;y=(r|0)>0;z=o+1|0;A=o+8|0;B=o+4|0;C=g;g=0;while(1){a:do{switch(a[l+g|0]|0){case 0:{c[d>>2]=c[e>>2];D=C;break};case 1:{c[d>>2]=c[e>>2];E=re[c[(c[j>>2]|0)+44>>2]&63](j,32)|0;F=c[e>>2]|0;c[e>>2]=F+4;c[F>>2]=E;D=C;break};case 4:{E=c[e>>2]|0;F=k?C+4|0:C;b:do{if(F>>>0<h>>>0){G=F;while(1){H=G+4|0;if(!(ie[c[(c[j>>2]|0)+12>>2]&63](j,2048,c[G>>2]|0)|0)){I=G;break b}if(H>>>0<h>>>0){G=H}else{I=H;break}}}else{I=F}}while(0);if(y){do{if(I>>>0>F>>>0){G=c[e>>2]|0;H=I;J=r;while(1){K=H+ -4|0;L=G+4|0;c[G>>2]=c[K>>2];M=J+ -1|0;N=(M|0)>0;if(K>>>0>F>>>0&N){J=M;H=K;G=L}else{break}}c[e>>2]=L;if(N){O=K;P=M;Q=34;break}G=c[e>>2]|0;c[e>>2]=G+4;R=G;S=K}else{O=I;P=r;Q=34}}while(0);do{if((Q|0)==34){Q=0;G=re[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;H=c[e>>2]|0;J=H+4|0;c[e>>2]=J;if((P|0)>0){T=J;U=H;V=P}else{R=H;S=O;break}while(1){c[U>>2]=G;J=V+ -1|0;if((J|0)>0){V=J;U=T;T=T+4|0}else{break}}c[e>>2]=H+(P+1<<2);R=H+(P<<2)|0;S=O}}while(0);c[R>>2]=m;W=S}else{W=I}if((W|0)==(F|0)){G=re[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;J=c[e>>2]|0;X=J+4|0;c[e>>2]=X;c[J>>2]=G;Y=X}else{X=a[o]|0;G=(X&1)==0;if(G){Z=(X&255)>>>1}else{Z=c[B>>2]|0}if((Z|0)==0){_=W;$=-1;aa=0;ba=0}else{if(G){ca=z}else{ca=c[A>>2]|0}_=W;$=a[ca]|0;aa=0;ba=0}while(1){G=c[e>>2]|0;do{if((ba|0)==($|0)){X=G+4|0;c[e>>2]=X;c[G>>2]=n;J=aa+1|0;da=a[o]|0;ea=(da&1)==0;if(ea){fa=(da&255)>>>1}else{fa=c[B>>2]|0}if(!(J>>>0<fa>>>0)){ga=X;ha=$;ia=J;ja=0;break}if(ea){ka=z}else{ka=c[A>>2]|0}if((a[ka+J|0]|0)==127){ga=X;ha=-1;ia=J;ja=0;break}if(ea){la=z}else{la=c[A>>2]|0}ga=X;ha=a[la+J|0]|0;ia=J;ja=0}else{ga=G;ha=$;ia=aa;ja=ba}}while(0);G=_+ -4|0;H=c[G>>2]|0;J=ga+4|0;c[e>>2]=J;c[ga>>2]=H;if((G|0)==(F|0)){Y=J;break}else{_=G;$=ha;aa=ia;ba=ja+1|0}}}if((E|0)==(Y|0)){D=F;break a}G=Y+ -4|0;if(G>>>0>E>>>0){ma=E;na=G}else{D=F;break a}while(1){G=c[ma>>2]|0;c[ma>>2]=c[na>>2];c[na>>2]=G;G=ma+4|0;J=na+ -4|0;if(G>>>0<J>>>0){na=J;ma=G}else{D=F;break}}break};case 3:{F=a[q]|0;E=(F&1)==0;if(E){oa=(F&255)>>>1}else{oa=c[t>>2]|0}if((oa|0)==0){D=C;break a}if(E){pa=t}else{pa=c[u>>2]|0}E=c[pa>>2]|0;F=c[e>>2]|0;c[e>>2]=F+4;c[F>>2]=E;D=C;break};case 2:{E=a[p]|0;F=(E&1)==0;if(F){qa=(E&255)>>>1}else{qa=c[w>>2]|0}if((qa|0)==0|v){D=C;break a}if(F){ra=w;sa=(E&255)>>>1}else{ra=c[x>>2]|0;sa=c[w>>2]|0}E=ra+(sa<<2)|0;F=c[e>>2]|0;if((ra|0)==(E|0)){ta=F}else{G=(ra+(sa+ -1<<2)+(0-ra)|0)>>>2;J=F;H=ra;while(1){c[J>>2]=c[H>>2];X=H+4|0;if((X|0)==(E|0)){break}J=J+4|0;H=X}ta=F+(G+1<<2)|0}c[e>>2]=ta;D=C;break};default:{D=C}}}while(0);H=g+1|0;if(H>>>0<4){C=D;g=H}else{break}}g=a[q]|0;q=(g&1)==0;if(q){ua=(g&255)>>>1}else{ua=c[t>>2]|0}if(ua>>>0>1){if(q){va=t;wa=(g&255)>>>1}else{va=c[u>>2]|0;wa=c[t>>2]|0}t=va+4|0;u=va+(wa<<2)|0;g=c[e>>2]|0;if((t|0)==(u|0)){xa=g}else{q=(va+(wa+ -1<<2)+(0-t)|0)>>>2;wa=g;va=t;while(1){c[wa>>2]=c[va>>2];t=va+4|0;if((t|0)==(u|0)){break}else{va=t;wa=wa+4|0}}xa=g+(q+1<<2)|0}c[e>>2]=xa}xa=f&176;if((xa|0)==16){i=s;return}else if((xa|0)==32){c[d>>2]=c[e>>2];i=s;return}else{c[d>>2]=b;i=s;return}}function eW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+400|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;MQ(m,g);z=m;A=c[z>>2]|0;if(!((c[26642]|0)==-1)){c[l>>2]=106568;c[l+4>>2]=189;c[l+8>>2]=0;BP(106568,l,190)}l=(c[106572>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Ac(4)|0;D=C;AZ(D);E=122136;F=127;Pd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Ac(4)|0;D=C;AZ(D);E=122136;F=127;Pd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+4|0}else{I=c[j+8>>2]|0}C=c[I>>2]|0;H=(C|0)==(re[c[(c[A>>2]|0)+44>>2]&63](F,45)|0)}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;cW(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=VZ(P<<2)|0;O=N;if((N|0)!=0){Q=O;R=O;break}g_()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+4|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}dW(R,w,x,c[g+4>>2]|0,S,S+(T<<2)|0,F,H,o,c[p>>2]|0,c[q>>2]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];YT(b,k,R,e,w,g,h);if((Q|0)==0){sQ(t);sQ(s);QP(r);U=c[z>>2]|0;V=U;W=V;X=gP(W)|0;i=d;return}WZ(Q);sQ(t);sQ(s);QP(r);U=c[z>>2]|0;V=U;W=V;X=gP(W)|0;i=d;return}function fW(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function gW(a){a=a|0;i=i;return}function hW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=qc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function iW(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;j=d;k=j;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;k=a[h]|0;if((k&1)==0){l=h+1|0;m=h+1|0;n=(k&255)>>>1}else{k=c[h+8>>2]|0;l=k;m=k;n=c[h+4>>2]|0}h=l+n|0;do{if(m>>>0<h>>>0){n=m;do{gQ(j,a[n]|0);n=n+1|0;}while(n>>>0<h>>>0);n=(e|0)==-1?-1:e<<1;if((a[j]&1)==0){o=n;p=9;break}q=n;r=c[j+8>>2]|0}else{o=(e|0)==-1?-1:e<<1;p=9}}while(0);if((p|0)==9){q=o;r=j+1|0}o=ud(q|0,f|0,g|0,r|0)|0;r=b;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;r=x_(o|0)|0;g=o+r|0;if((r|0)>0){s=o}else{QP(j);i=d;return}do{gQ(b,a[s]|0);s=s+1|0;}while(s>>>0<g>>>0);QP(j);i=d;return}function jW(a,b){a=a|0;b=b|0;a=i;Eb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function kW(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function lW(a){a=a|0;i=i;return}function mW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=qc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function nW(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+240|0;j=d;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=d+224|0;t=d+232|0;u=r;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[s+4>>2]=0;c[s>>2]=108232;u=a[h]|0;if((u&1)==0){v=h+4|0;w=h+4|0;x=(u&255)>>>1}else{u=c[h+8>>2]|0;v=u;w=u;x=c[h+4>>2]|0}h=v+(x<<2)|0;x=k;v=j;u=j;c[u>>2]=0;c[u+4>>2]=0;a:do{if(w>>>0<h>>>0){u=s;j=k+32|0;y=w;z=108232|0;while(1){c[m>>2]=y;A=(le[c[z+12>>2]&15](u,v,y,h,m,x,j,l)|0)==2;B=c[m>>2]|0;if(A|(B|0)==(y|0)){break}if(x>>>0<(c[l>>2]|0)>>>0){A=x;do{gQ(r,a[A]|0);A=A+1|0;}while(A>>>0<(c[l>>2]|0)>>>0);C=c[m>>2]|0}else{C=B}if(!(C>>>0<h>>>0)){break a}y=C;z=c[s>>2]|0}IV(107456)}}while(0);if((a[r]&1)==0){D=r+1|0}else{D=c[r+8>>2]|0}s=ud(((e|0)==-1?-1:e<<1)|0,f|0,g|0,D|0)|0;D=b;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[t+4>>2]=0;c[t>>2]=108336;D=x_(s|0)|0;g=s+D|0;f=n;e=n;c[e>>2]=0;c[e+4>>2]=0;if((D|0)<=0){QP(r);i=d;return}D=t;e=g;n=o;C=o+128|0;o=s;s=108336|0;while(1){c[q>>2]=o;h=(le[c[s+16>>2]&15](D,f,o,(e-o|0)>32?o+32|0:g,q,n,C,p)|0)==2;m=c[q>>2]|0;if(h|(m|0)==(o|0)){E=20;break}if(n>>>0<(c[p>>2]|0)>>>0){h=n;do{wQ(b,c[h>>2]|0);h=h+4|0;}while(h>>>0<(c[p>>2]|0)>>>0);F=c[q>>2]|0}else{F=m}if(!(F>>>0<g>>>0)){E=25;break}o=F;s=c[t>>2]|0}if((E|0)==20){IV(107456)}else if((E|0)==25){QP(r);i=d;return}}function oW(a,b){a=a|0;b=b|0;a=i;Eb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function pW(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=106664;e=b+8|0;b=c[e>>2]|0;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);if((b|0)==(c[26616]|0)){i=d;return}Yb(c[e>>2]|0);i=d;return}function qW(a){a=a|0;a=Ac(8)|0;hP(a,106456);c[a>>2]=103424;Pd(a|0,103464,40)}function rW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+448|0;f=e;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;z=e+304|0;A=e+320|0;B=e+336|0;C=e+352|0;D=e+368|0;E=e+384|0;F=e+400|0;G=e+416|0;H=e+432|0;c[b+4>>2]=d+ -1;c[b>>2]=106496;d=b+8|0;I=b+12|0;J=b+136|0;a[J]=1;K=b+24|0;c[I>>2]=K;c[d>>2]=K;c[b+16>>2]=J;J=28;L=K;do{if((L|0)==0){M=0}else{c[L>>2]=0;M=c[I>>2]|0}L=M+4|0;c[I>>2]=L;J=J+ -1|0;}while((J|0)!=0);IP(b+144|0,106480,1);J=c[d>>2]|0;d=c[I>>2]|0;if((d|0)!=(J|0)){c[I>>2]=d+(~((d+ -4+(0-J)|0)>>>2)<<2)}c[111388>>2]=0;c[27846]=104976;if(!((c[26250]|0)==-1)){c[G>>2]=105e3;c[G+4>>2]=189;c[G+8>>2]=0;BP(105e3,G,190)}sW(b,111384,(c[105004>>2]|0)+ -1|0);c[111380>>2]=0;c[27844]=105016;if(!((c[26260]|0)==-1)){c[F>>2]=105040;c[F+4>>2]=189;c[F+8>>2]=0;BP(105040,F,190)}sW(b,111376,(c[105044>>2]|0)+ -1|0);c[111364>>2]=0;c[27840]=106592;c[111368>>2]=0;a[111372|0]=0;F=c[(uc()|0)>>2]|0;c[111368>>2]=F;if(!((c[26644]|0)==-1)){c[E>>2]=106576;c[E+4>>2]=189;c[E+8>>2]=0;BP(106576,E,190)}sW(b,111360,(c[106580>>2]|0)+ -1|0);c[111356>>2]=0;c[27838]=107552;if(!((c[26642]|0)==-1)){c[D>>2]=106568;c[D+4>>2]=189;c[D+8>>2]=0;BP(106568,D,190)}sW(b,111352,(c[106572>>2]|0)+ -1|0);c[111348>>2]=0;c[27836]=107768;if(!((c[26660]|0)==-1)){c[C>>2]=106640;c[C+4>>2]=189;c[C+8>>2]=0;BP(106640,C,190)}sW(b,111344,(c[106644>>2]|0)+ -1|0);c[111332>>2]=0;c[27832]=106664;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);c[111336>>2]=c[26616];if(!((c[26662]|0)==-1)){c[B>>2]=106648;c[B+4>>2]=189;c[B+8>>2]=0;BP(106648,B,190)}sW(b,111328,(c[106652>>2]|0)+ -1|0);c[111324>>2]=0;c[27830]=107992;if(!((c[26676]|0)==-1)){c[A>>2]=106704;c[A+4>>2]=189;c[A+8>>2]=0;BP(106704,A,190)}sW(b,111320,(c[106708>>2]|0)+ -1|0);c[111316>>2]=0;c[27828]=108112;if(!((c[26678]|0)==-1)){c[z>>2]=106712;c[z+4>>2]=189;c[z+8>>2]=0;BP(106712,z,190)}sW(b,111312,(c[106716>>2]|0)+ -1|0);c[111292>>2]=0;c[27822]=106744;a[111296|0]=46;a[111297|0]=44;z=111300|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;if(!((c[26680]|0)==-1)){c[y>>2]=106720;c[y+4>>2]=189;c[y+8>>2]=0;BP(106720,y,190)}sW(b,111288,(c[106724>>2]|0)+ -1|0);c[111260>>2]=0;c[27814]=106784;c[111264>>2]=46;c[111268>>2]=44;y=111272|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(!((c[26682]|0)==-1)){c[x>>2]=106728;c[x+4>>2]=189;c[x+8>>2]=0;BP(106728,x,190)}sW(b,111256,(c[106732>>2]|0)+ -1|0);c[111252>>2]=0;c[27812]=105056;if(!((c[26278]|0)==-1)){c[w>>2]=105112;c[w+4>>2]=189;c[w+8>>2]=0;BP(105112,w,190)}sW(b,111248,(c[105116>>2]|0)+ -1|0);c[111244>>2]=0;c[27810]=105176;if(!((c[26308]|0)==-1)){c[v>>2]=105232;c[v+4>>2]=189;c[v+8>>2]=0;BP(105232,v,190)}sW(b,111240,(c[105236>>2]|0)+ -1|0);c[111236>>2]=0;c[27808]=105248;if(!((c[26324]|0)==-1)){c[u>>2]=105296;c[u+4>>2]=189;c[u+8>>2]=0;BP(105296,u,190)}sW(b,111232,(c[105300>>2]|0)+ -1|0);c[111228>>2]=0;c[27806]=105312;if(!((c[26340]|0)==-1)){c[t>>2]=105360;c[t+4>>2]=189;c[t+8>>2]=0;BP(105360,t,190)}sW(b,111224,(c[105364>>2]|0)+ -1|0);c[111220>>2]=0;c[27804]=105904;if(!((c[26488]|0)==-1)){c[s>>2]=105952;c[s+4>>2]=189;c[s+8>>2]=0;BP(105952,s,190)}sW(b,111216,(c[105956>>2]|0)+ -1|0);c[111212>>2]=0;c[27802]=105968;if(!((c[26504]|0)==-1)){c[r>>2]=106016;c[r+4>>2]=189;c[r+8>>2]=0;BP(106016,r,190)}sW(b,111208,(c[106020>>2]|0)+ -1|0);c[111204>>2]=0;c[27800]=106032;if(!((c[26520]|0)==-1)){c[q>>2]=106080;c[q+4>>2]=189;c[q+8>>2]=0;BP(106080,q,190)}sW(b,111200,(c[106084>>2]|0)+ -1|0);c[111196>>2]=0;c[27798]=106096;if(!((c[26536]|0)==-1)){c[p>>2]=106144;c[p+4>>2]=189;c[p+8>>2]=0;BP(106144,p,190)}sW(b,111192,(c[106148>>2]|0)+ -1|0);c[111188>>2]=0;c[27796]=106160;if(!((c[26546]|0)==-1)){c[o>>2]=106184;c[o+4>>2]=189;c[o+8>>2]=0;BP(106184,o,190)}sW(b,111184,(c[106188>>2]|0)+ -1|0);c[111180>>2]=0;c[27794]=106240;if(!((c[26566]|0)==-1)){c[n>>2]=106264;c[n+4>>2]=189;c[n+8>>2]=0;BP(106264,n,190)}sW(b,111176,(c[106268>>2]|0)+ -1|0);c[111172>>2]=0;c[27792]=106296;if(!((c[26580]|0)==-1)){c[m>>2]=106320;c[m+4>>2]=189;c[m+8>>2]=0;BP(106320,m,190)}sW(b,111168,(c[106324>>2]|0)+ -1|0);c[111164>>2]=0;c[27790]=106344;if(!((c[26592]|0)==-1)){c[l>>2]=106368;c[l+4>>2]=189;c[l+8>>2]=0;BP(106368,l,190)}sW(b,111160,(c[106372>>2]|0)+ -1|0);c[111148>>2]=0;c[27786]=105392;c[111152>>2]=105440;if(!((c[26368]|0)==-1)){c[k>>2]=105472;c[k+4>>2]=189;c[k+8>>2]=0;BP(105472,k,190)}sW(b,111144,(c[105476>>2]|0)+ -1|0);c[111132>>2]=0;c[27782]=105544;c[111136>>2]=105592;if(!((c[26406]|0)==-1)){c[j>>2]=105624;c[j+4>>2]=189;c[j+8>>2]=0;BP(105624,j,190)}sW(b,111128,(c[105628>>2]|0)+ -1|0);c[111116>>2]=0;c[27778]=107488;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);c[111120>>2]=c[26616];c[27778]=105840;if(!((c[26464]|0)==-1)){c[h>>2]=105856;c[h+4>>2]=189;c[h+8>>2]=0;BP(105856,h,190)}sW(b,111112,(c[105860>>2]|0)+ -1|0);c[111100>>2]=0;c[27774]=107488;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);c[111104>>2]=c[26616];c[27774]=105872;if(!((c[26472]|0)==-1)){c[g>>2]=105888;c[g+4>>2]=189;c[g+8>>2]=0;BP(105888,g,190)}sW(b,111096,(c[105892>>2]|0)+ -1|0);c[111092>>2]=0;c[27772]=106384;if(!((c[26602]|0)==-1)){c[f>>2]=106408;c[f+4>>2]=189;c[f+8>>2]=0;BP(106408,f,190)}sW(b,111088,(c[106412>>2]|0)+ -1|0);c[111084>>2]=0;c[27770]=106424;if((c[26612]|0)==-1){N=106448;O=106448;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=111080;sW(b,T,S);i=e;return}c[H>>2]=106448;c[H+4>>2]=189;c[H+8>>2]=0;BP(106448,H,190);N=106448;O=106448;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=111080;sW(b,T,S);i=e;return}function sW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;fP(b);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f;j=c[h>>2]|0;k=a-j>>2;do{if(k>>>0>d>>>0){l=j}else{m=d+1|0;if(k>>>0<m>>>0){xY(f,m-k|0);l=c[h>>2]|0;break}if(!(k>>>0>m>>>0)){l=j;break}n=j+(m<<2)|0;if((a|0)==(n|0)){l=j;break}c[g>>2]=a+(~((a+ -4+(0-n)|0)>>>2)<<2);l=j}}while(0);j=c[l+(d<<2)>>2]|0;if((j|0)==0){o=l;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}gP(j)|0;o=c[h>>2]|0;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}function tW(a){a=a|0;var b=0;b=i;uW(a);b_(a);i=b;return}function uW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[b>>2]=106496;e=b+12|0;f=c[e>>2]|0;g=b+8|0;h=c[g>>2]|0;if((f|0)!=(h|0)){j=f;f=h;h=0;while(1){k=c[f+(h<<2)>>2]|0;if((k|0)==0){l=f;m=j}else{gP(k)|0;l=c[g>>2]|0;m=c[e>>2]|0}k=h+1|0;if(k>>>0<m-l>>2>>>0){j=m;f=l;h=k}else{break}}}QP(b+144|0);h=c[g>>2]|0;if((h|0)==0){i=d;return}g=c[e>>2]|0;if((g|0)!=(h|0)){c[e>>2]=g+(~((g+ -4+(0-h)|0)>>>2)<<2)}if((b+24|0)==(h|0)){a[b+136|0]=0;i=d;return}else{b_(h);i=d;return}}function vW(){var b=0,d=0,e=0,f=0;b=i;if((a[106552]|0)!=0){d=106544;e=c[26636]|0;i=b;return e|0}if((Wa(106552)|0)==0){d=106544;e=c[26636]|0;i=b;return e|0}do{if((a[106528]|0)==0){if((Wa(106528)|0)==0){break}rW(110920,1);c[26628]=110920;c[26630]=106512;Pb(106528)}}while(0);f=c[c[26630]>>2]|0;c[26634]=f;fP(f);c[26636]=106536;Pb(106552);d=106544;e=c[26636]|0;i=b;return e|0}function wW(a){a=a|0;var b=0,d=0;b=i;d=c[(vW()|0)>>2]|0;c[a>>2]=d;fP(d);i=b;return}function xW(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;fP(e);i=d;return}function yW(a){a=a|0;var b=0;b=i;gP(c[a>>2]|0)|0;i=b;return}function zW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=189;c[e+8>>2]=0;BP(a,e,190)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function AW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=189;c[e+8>>2]=0;BP(a,e,190)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=Ac(4)|0;h=g;AZ(h);j=122136;k=127;Pd(g|0,j|0,k|0)}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=Ac(4)|0;h=g;AZ(h);j=122136;k=127;Pd(g|0,j|0,k|0)}else{i=d;return f|0}return 0}function BW(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function CW(a){a=a|0;var b=0;b=i;if((a|0)==0){i=b;return}be[c[(c[a>>2]|0)+4>>2]&255](a);i=b;return}function DW(a){a=a|0;var b=0;b=c[26640]|0;c[26640]=1+b;c[a+4>>2]=b+1;i=i;return}function EW(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function FW(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;a=i;if(!(e>>>0<128)){f=0;i=a;return f|0}f=(b[(c[(uc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;i=a;return f|0}function GW(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;if((d|0)==(e|0)){g=d;i=a;return g|0}else{h=d;j=f}while(1){f=c[h>>2]|0;if(f>>>0<128){k=b[(c[(uc()|0)>>2]|0)+(f<<1)>>1]|0}else{k=0}b[j>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;break}else{h=f;j=j+2|0}}i=a;return g|0}function HW(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;if((e|0)==(f|0)){g=e;i=a;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128){if(!((b[(c[(uc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16==0)){g=h;j=5;break}}e=h+4|0;if((e|0)==(f|0)){g=f;j=5;break}else{h=e}}if((j|0)==5){i=a;return g|0}return 0}function IW(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;a:do{if((e|0)==(f|0)){g=e}else{h=e;while(1){j=c[h>>2]|0;if(!(j>>>0<128)){g=h;break a}k=h+4|0;if((b[(c[(uc()|0)>>2]|0)+(j<<1)>>1]&d)<<16>>16==0){g=h;break a}if((k|0)==(f|0)){g=f;break}else{h=k}}}}while(0);i=a;return g|0}function JW(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(zd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function KW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(zd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function LW(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Ed()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function MW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Ed()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function NW(a,b){a=a|0;b=b|0;i=i;return b<<24>>24|0}



function zs(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+64|0;k=e;e=f;f=g;g=h;h=k;l=0;while(1){if((l|0)>=368){break}a[k+l|0]=a[33248+l|0]|0;l=l+1|0}l=0;a:while(1){if((l|0)>=128){break}do{if((d[33324+l|0]|0|0)!=28){if((d[33324+l|0]|0|0)==0){break}if((c[e+(l<<2)>>2]|0)!=(l|0)){m=9;break a}}}while(0);l=l+1|0}if((m|0)==9){n=0;o=n;i=j;return o|0}l=0;b:while(1){if((l|0)>=256){m=36;break}k=c[e+(l<<2)>>2]|0;do{if((k|0)==-1){a[h+76+l|0]=1;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0}else{p=k;if((k|0)<0){if((p|0)<-4){m=17;break b}a[h+76+l|0]=5-(k+2);a[h+888+(l<<2)|0]=0;b[h+376+(l<<1)>>1]=0;break}q=k;if((p|0)<128){do{if((d[33324+q|0]|0|0)!=28){if((d[33324+k|0]|0|0)==0){break}if((k|0)!=(l|0)){m=23;break b}}}while(0);a[h+76+l|0]=a[33324+k|0]|0;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=k;b[h+376+(l<<1)>>1]=(k|0)==0?65535:k;break}if((As(q)|0)<0){a[h+76+l|0]=0;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0;break}if((k|0)>65535){m=28;break b}do{if((c[27416+(((d[27160+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[h+76+l|0]=22}else{p=h+76+l|0;if((c[27416+(((d[28696+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[p]=26;break}else{a[p]=28;break}}}while(0);a[h+888+(l<<2)|0]=xs(k,h+888+(l<<2)+1|0)|0;b[h+376+(l<<1)>>1]=k}}while(0);l=l+1|0}if((m|0)==17){n=0;o=n;i=j;return o|0}else if((m|0)==23){n=0;o=n;i=j;return o|0}else if((m|0)==28){n=0;o=n;i=j;return o|0}else if((m|0)==36){c[h+372>>2]=g;c[h+368>>2]=f;if((f|0)!=0){c[h+332>>2]=49;c[h+336>>2]=49;c[h+340>>2]=49;c[h+344>>2]=50;c[h+348>>2]=50;c[h+352>>2]=50;c[h+356>>2]=51;c[h+360>>2]=51;c[h+364>>2]=51}c[h+60>>2]=13;c[h+64>>2]=14;n=h;o=n;i=j;return o|0}return 0}function As(a){a=a|0;var b=0,c=0,e=0,f=0;b=i;i=i+16|0;c=a;a:do{switch(c>>8|0){case 255:{if(!((c|0)==65534|(c|0)==65535)){e=7;break a}f=-1;break};case 0:{if((d[33324+c|0]|0|0)!=0){e=7;break a}f=-1;break};case 223:case 222:case 221:case 220:case 219:case 218:case 217:case 216:{f=-1;break};default:{e=7}}}while(0);if((e|0)==7){f=c}i=b;return f|0}function Bs(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=re[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[27416+(((d[28696+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function Cs(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=re[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[27416+(((d[27160+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function Ds(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=a;a=re[c[e+368>>2]&63](c[e+372>>2]|0,b)|0;if((a&-65536|0)!=0){f=1;g=f&1;i=d;return g|0}f=(As(a)|0)<0;g=f&1;i=d;return g|0}function Es(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+80|0;k=j+48|0;l=b;b=e;e=f;f=g;g=h;h=l;a:while(1){if((c[b>>2]|0)==(e|0)){m=9;break}n=h+888+(d[c[b>>2]|0]<<2)|0;o=n;n=o+1|0;p=a[o]|0;if((p|0)==0){p=xs(re[c[h+368>>2]&63](c[h+372>>2]|0,c[b>>2]|0)|0,k)|0;if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}n=k;o=b;c[o>>2]=(c[o>>2]|0)+((d[l+76+(d[c[b>>2]|0]|0)|0]|0)-3)}else{if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}o=b;c[o>>2]=(c[o>>2]|0)+1}while(1){o=n;n=o+1|0;q=a[o]|0;o=f;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;q=p+ -1|0;p=q;if((q|0)==0){continue a}}}if((m|0)==9){i=j;return}}function Fs(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+56|0;k=a;a=e;e=f;f=g;g=h;h=k;while(1){if((c[a>>2]|0)==(e|0)){l=8;break}if((c[f>>2]|0)==(g|0)){l=8;break}m=b[h+376+((d[c[a>>2]|0]|0)<<1)>>1]|0;if((m&65535|0)==0){m=(re[c[h+368>>2]&63](c[h+372>>2]|0,c[a>>2]|0)|0)&65535;n=a;c[n>>2]=(c[n>>2]|0)+((d[k+76+(d[c[a>>2]|0]|0)|0]|0)-3)}else{n=a;c[n>>2]=(c[n>>2]|0)+1}n=f;o=c[n>>2]|0;c[n>>2]=o+2;b[o>>1]=m}if((l|0)==8){i=j;return}}function Gs(){i=i;return 32880}function Hs(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=Is(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=47;c[g+4>>2]=48;c[g+52>>2]=18;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function Is(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+24|0;d=a;if((d|0)==0){e=6;f=e;i=b;return f|0}a=0;while(1){if((a|0)>=6){g=8;break}h=a;if((Ws(d,c[32784+(a<<2)>>2]|0)|0)!=0){g=6;break}a=h+1|0}if((g|0)==6){e=h;f=e;i=b;return f|0}else if((g|0)==8){e=-1;f=e;i=b;return f|0}return 0}function Js(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=Uu(31224,a,0,b,c,d)|0;i=e;return f|0}function Ks(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=Uu(31224,a,1,b,c,d)|0;i=e;return f|0}function Ls(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;i=i+32|0;ru(31992,b,c,d);i=a;return}function Ms(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=Ns(34,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function Ns(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+128|0;o=n+32|0;p=n+96|0;q=n+104|0;r=n+112|0;s=a;a=b;b=d;c[o>>2]=e;e=f;f=g;g=h;h=j;j=k;k=l;l=m;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[o>>2]=(c[o>>2]|0)+((c[b+68>>2]|0)*5|0);e=e+(0-(c[b+68>>2]<<1))|0;m=(Vu(b,c[o>>2]|0,e,q,r,p,o)|0)!=0;if(!(m&(c[q>>2]|0)!=0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}do{if((Ae[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,32728)|0)!=0){if((g|0)!=0){c[g>>2]=c[p>>2]}if((h|0)!=0){c[h>>2]=c[o>>2]}if((Vu(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}if((a|0)!=0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}else{if((a|0)!=0){break}c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}}while(0);do{if((Ae[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,32736)|0)!=0){h=Wu(b,c[p>>2]|0,e)|0;do{if(!(97<=(h|0)&(h|0)<=122)){if(65<=(h|0)&(h|0)<=90){break}c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}while(0);if((j|0)!=0){c[j>>2]=c[p>>2]}if((k|0)!=0){c[k>>2]=ie[s&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0)|0}if((Vu(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}t=1;u=t;i=n;return u|0}}while(0);do{if((Ae[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,32752)|0)!=0){if((a|0)!=0){break}do{if((Ae[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,32768)|0)!=0){if((l|0)==0){break}c[l>>2]=1}else{if((Ae[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,32776)|0)!=0){if((l|0)==0){break}c[l>>2]=0;break}else{c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}}while(0);while(1){if((Xu(Wu(b,c[o>>2]|0,e)|0)|0)==0){break}c[o>>2]=(c[o>>2]|0)+(c[b+68>>2]|0)}if((c[o>>2]|0)!=(e|0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}}while(0);c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}function Os(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;_d[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((Ws(h,28952)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=Is(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[31224+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function Ps(){i=i;return 30856}function Qs(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=Is(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=49;c[g+4>>2]=50;c[g+52>>2]=18;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function Rs(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=Uu(28960,a,0,b,c,d)|0;i=e;return f|0}function Ss(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=Uu(28960,a,1,b,c,d)|0;i=e;return f|0}function Ts(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=Ns(35,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function Us(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;_d[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((Ws(h,28952)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=Is(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[28960+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function Vs(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+40|0;g=zs(b,c,d,e)|0;if((g|0)==0){h=g;i=f;return h|0}a[g+134|0]=23;h=g;i=f;return h|0}function Ws(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+40|0;e=b;b=c;while(1){c=e;e=c+1|0;f=a[c]|0;c=b;b=c+1|0;g=a[c]|0;do{if(97<=(f<<24>>24|0)){if((f<<24>>24|0)>122){break}f=(f<<24>>24)+ -32&255}}while(0);do{if(97<=(g<<24>>24|0)){if((g<<24>>24|0)>122){break}g=(g<<24>>24)+ -32&255}}while(0);if((f<<24>>24|0)!=(g<<24>>24|0)){h=9;break}if(!(f<<24>>24!=0)){h=11;break}}if((h|0)==9){j=0;k=j;i=d;return k|0}else if((h|0)==11){j=1;k=j;i=d;return k|0}return 0}function Xs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=mt(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 10:case 21:{n=25;break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 9:{if((b+2|0)!=(e|0)){n=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=mt(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 15:{k=ut(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 16:{k=zt(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 29:{g=b;if((c[27416+((d[27160+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){b=g+2|0;p=18;n=77;break a}if((c[27416+((d[28696+(d[g+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=76;break a}b=b+2|0;p=19;n=77;break};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 30:{k=ot(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[g]|0)|0]|0}else{q=mt(a[g+1|0]|0,a[b]|0)|0}switch(q|0){case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{p=19;b=b+2|0;n=77;break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 24:case 22:{p=18;b=b+2|0;n=77;break};case 19:{k=At(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 12:{k=yt(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 13:{k=yt(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+3|0]|0)!=0){break}if((a[b+2|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};default:{n=76}}}while(0);if((n|0)==25){while(1){n=0;b=b+2|0;r=b;if((b|0)==(e|0)){n=32;break}q=b;if((a[r+1|0]|0)==0){s=d[j+76+(d[q]|0)|0]|0}else{s=mt(a[q+1|0]|0,a[b]|0)|0}if((s|0)==10|(s|0)==21){n=25;continue}else if((s|0)!=9){n=31;break}if((b+2|0)!=(e|0)){n=25}else{n=31;break}}if((n|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((n|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==77){b:while(1){n=0;if((b|0)==(e|0)){n=126;break}r=b;if((a[b+1|0]|0)==0){t=d[j+76+(d[r]|0)|0]|0}else{t=mt(a[r+1|0]|0,a[b]|0)|0}switch(t|0){case 33:{n=119;break b;break};case 23:{b=b+2|0;r=p;if((r|0)==41){p=19;n=77;continue b}else if((r|0)!=18){n=77;continue b}if((b|0)==(e|0)){n=97;break b}p=41;r=b;if((a[b+1|0]|0)==0){u=d[j+76+(d[r]|0)|0]|0}else{u=mt(a[r+1|0]|0,a[b]|0)|0}switch(u|0){case 7:{n=111;break b;break};case 6:{n=108;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[27416+((d[28696+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=103;break b}break};case 5:{n=105;break b;break};default:{p=19;n=77;continue b}}b=b+2|0;n=77;continue b;break};case 6:{n=88;break b;break};case 7:{n=91;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=94;break b;break};case 5:{n=85;break b;break};case 34:{n=116;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 15:{n=122;break b;break};case 29:{if((c[27416+((d[28696+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=83;break b}break};default:{n=125;break b}}b=b+2|0;n=77}if((n|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==94){c[f>>2]=b;k=p;l=k;i=h;return l|0}else if((n|0)==97){k=-1;l=k;i=h;return l|0}else if((n|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==116){e=b;if((p|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((n|0)==119){e=b;if((p|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((n|0)==122){e=b;if((p|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((n|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==126){k=0-p|0;l=k;i=h;return l|0}}return 0}function Ys(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=mt(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 3:{k=nt(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 2:{k=rt(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=mt(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=mt(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 6:{r=b;if((e-b|0)<3){p=52;break b}b=r+3|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+3|0]|0)==0){if((a[b+2|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+5|0]|0)==0){if((a[b+4|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 7:{s=b;if((e-b|0)<4){p=55;break b}b=s+4|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=49;break b}b=t+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Zs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=mt(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=mt(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=mt(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 6:{r=b;if((e-b|0)<3){p=50;break b}b=r+3|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=53;break b}b=s+4|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=47;break b}b=t+2|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function _s(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[k]|0)|0]|0}else{m=mt(a[k+1|0]|0,a[b]|0)|0}switch(m|0){case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function $s(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=mt(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 3:{n=12;break a;break};case 2:{n=15;break a;break};case 10:{n=16;break a;break};case 21:{n=29;break a;break};case 7:{b=b+4|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 9:{n=19;break a;break};case 5:{b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=nt(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=mt(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function at(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=mt(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 3:{n=12;break a;break};case 30:{n=15;break a;break};case 7:{b=b+4|0;continue a;break};case 9:{n=21;break a;break};case 6:{b=b+3|0;continue a;break};case 10:{n=18;break a;break};case 5:{b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=nt(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=ot(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=mt(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function bt(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b+1|0]|0)==0){h=d[g+76+(d[e]|0)|0]|0}else{h=mt(a[e+1|0]|0,a[b]|0)|0}switch(h|0){case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};case 6:{k=8;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=15;break a}e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=17;break a}else{continue a}break};case 5:{break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c+1|0]|0)==0){n=d[g+76+(d[k]|0)|0]|0}else{n=mt(a[k+1|0]|0,a[c]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function ct(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f+1|0]|0)!=0){h=7;break}if((a[f]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function dt(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b+1|0]|0)==0){h=d[f+76+(d[g]|0)|0]|0}else{h=mt(a[g+1|0]|0,a[b]|0)|0}switch(h|0){case 7:{b=b+4|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function et(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b+1|0]|0)==0){g=d[f+76+(d[c]|0)|0]|0}else{g=mt(a[c+1|0]|0,a[b]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function ft(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[m]|0)|0]|0}else{n=mt(a[m+1|0]|0,a[b]|0)|0}b:do{switch(n|0){case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b+1|0]|0)==0){o=a[b]|0}else{o=-1}if((o|0)!=32){break}if((a[b+3|0]|0)==0){p=a[b+2|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+3|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=mt(a[m+1|0]|0,a[b+2|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function gt(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d+1|0]|0)==0){if((a[d]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d+1|0]|0)==0){f=(a[d]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d+1|0]|0)==0){g=a[d]|0}else{g=-1}h=g;switch(h|0){case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d+1|0]|0)==0){l=(a[d]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d+1|0]|0)==0){m=a[d]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=As(c)|0;k=j;i=b;return k|0}function ht(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==2){if((a[e+3|0]|0)!=0){break}if((a[e+2|0]|0)!=116){break}if((a[e+1|0]|0)==0){f=a[e]|0}else{f=-1}if((f|0)==108){g=60;h=g;i=b;return h|0}else if((f|0)==103){g=62;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=97){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=109){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}g=38;h=g;i=b;return h|0}else if((c|0)==4){if((a[e+1|0]|0)==0){j=a[e]|0}else{j=-1}if((j|0)==113){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=117){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=116){break}g=34;h=g;i=b;return h|0}else if((j|0)==97){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=115){break}g=39;h=g;i=b;return h|0}else{break}}}while(0);g=0;h=g;i=b;return h|0}function it(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=mt(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 5:{b=b+2|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=mt(a[g+1|0]|0,a[b]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 6:{b=b+3|0;break};case 7:{b=b+4|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function jt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=mt(a[g+1|0]|0,a[b]|0)|0}b:do{switch(l|0){case 22:case 26:{if((a[b+1|0]|0)==0){m=a[b]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 21:{if((a[b+1|0]|0)!=0){break b}if((a[b]|0)==9){k=9;break a}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b+1|0]|0)==0){n=a[b]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function kt(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j]|0;m=a[g+1|0]|0;b:do{switch(m&255|0){case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}n=((m&3)<<2|(l&255)>>6&3)+1|0;o=e;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n>>2|240;p=e;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=(l&255)>>2&15|(n&3)<<4|128;g=g+2|0;n=a[g]|0;o=((l&3)<<4|(a[g+1|0]&3)<<2|(n&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=o;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=n&63|128;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=l;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=(m&255)>>4|224;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(m&15)<<2|(l&255)>>6|128;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(l&255)>>6|(m&255)<<2|192;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function lt(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2+1|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[(c[k>>2]|0)+1|0]|0)<<8|(d[c[k>>2]|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function mt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+24|0;a:do{switch(a&255|0){case 255:{if(!(((b&255)+ -254|0)>>>0<2)){d=6;break a}e=0;break};case 219:case 218:case 217:case 216:{e=7;break};case 223:case 222:case 221:case 220:{e=8;break};default:{d=6}}}while(0);if((d|0)==6){e=29}i=c;return e|0}function nt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=mt(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 29:{if((c[27416+((d[27160+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=pt(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=mt(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 18:{n=38;break b;break};case 6:{n=32;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=29;break b;break};case 29:{if((c[27416+((d[28696+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 7:{n=35;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function ot(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=mt(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 29:{if((c[27416+((d[27160+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=mt(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 18:{n=38;break b;break};case 5:{n=29;break b;break};case 29:{if((c[27416+((d[28696+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 7:{n=35;break b;break};case 6:{n=32;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function pt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=120){break}k=qt(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=mt(a[g+1|0]|0,a[b]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=mt(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function qt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=mt(a[g+1|0]|0,a[b]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=mt(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function rt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=mt(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 17:{k=vt(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{if((c[27416+((d[27160+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=mt(a[g+1|0]|0,a[b]|0)|0}if((n|0)==20){k=tt(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==27){k=st(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=ut(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[m]|0)|0]|0}else{p=mt(a[m+1|0]|0,a[b]|0)|0}switch(p|0){case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=mt(a[m+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{o=59;break b;break};case 29:{if((c[27416+((d[27160+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=57;break b}break};case 24:case 22:{break};case 7:{o=65;break b;break};case 6:{o=62;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[27416+((d[28696+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=37;break b}break};case 10:case 9:case 21:{o=69;break b;break};case 17:{break b;break};case 5:{o=39;break b;break};case 7:{o=45;break b;break};case 11:{o=90;break b;break};case 6:{o=42;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b+1|0]|0)==0){r=d[j+76+(d[q]|0)|0]|0}else{r=mt(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 24:case 22:{break d;break};case 29:{o=75;break d;break};case 5:{o=78;break d;break};case 17:{break c;break};case 10:case 9:case 21:{break};case 7:{o=84;break d;break};case 11:{o=90;break c;break};case 6:{o=81;break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[27416+((d[27160+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=wt(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function st(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=mt(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b+1|0]|0)!=0){continue b}if((a[b]|0)==45){l=25;break b}else{continue b}break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function tt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k+1|0]|0)!=0){l=7;break}if((a[g]|0)!=(a[29360+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function ut(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b+1|0]|0)==0){o=d[k+76+(d[n]|0)|0]|0}else{o=mt(a[n+1|0]|0,a[b]|0)|0}a:do{switch(o|0){case 24:case 22:{break};case 29:{if((c[27416+((d[27160+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=mt(a[o+1|0]|0,a[b]|0)|0}switch(q|0){case 7:{p=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[27416+((d[28696+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=26;break b}break};case 6:{p=31;break b;break};case 10:case 9:case 21:{p=37;break b;break};case 5:{p=28;break b;break};case 15:{p=62;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((xt(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b+1|0]|0)==0){r=d[k+76+(d[q]|0)|0]|0}else{r=mt(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 8:case 1:case 0:{p=54;break c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b+1|0]|0)!=0){continue c}if((a[b]|0)==62){p=59;break c}else{continue c}break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((xt(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b+1|0]|0)!=0){break}if((a[b]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function vt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=mt(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 29:{if((c[27416+((d[27160+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=mt(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 10:case 9:case 21:{n=37;break b;break};case 6:{n=31;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 23:{b=b+2|0;continue b;break};case 7:{n=34;break b;break};case 5:{n=28;break b;break};case 29:{if((c[27416+((d[28696+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 11:{n=48;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=mt(a[o+1|0]|0,a[b]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function wt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){m=d[k+76+(d[b]|0)|0]|0}else{m=mt(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b:do{switch(m|0){case 29:{if((c[27416+((d[28696+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 5:{l=10;break a;break};case 14:{break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){n=d[k+76+(d[b]|0)|0]|0}else{n=mt(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b=n;if((b|0)==14){break b}o=b;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=47;break a}}break};case 6:{l=13;break a;break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){p=d[k+76+(d[o]|0)|0]|0}else{p=mt(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(p|0){case 29:{if((c[27416+((d[27160+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=28;break a}break};case 7:{l=36;break a;break};case 24:case 22:{break};case 6:{l=33;break a;break};case 5:{l=30;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 7:{l=16;break a;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=mt(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}o=r;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){s=d[k+76+(d[o]|0)|0]|0}else{s=mt(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}o=s;if((o|0)==(r|0)){break}switch(o|0){case 8:case 1:case 0:{l=74;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 3:{t=nt(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 2:{l=79;break a;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){u=d[k+76+(d[o]|0)|0]|0}else{u=mt(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(u|0){case 10:case 9:case 21:{break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){v=d[k+76+(d[o]|0)|0]|0}else{v=mt(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(v|0){case 5:{l=97;break a;break};case 24:case 22:{break d;break};case 10:case 9:case 21:{break};case 6:{l=100;break a;break};case 17:{l=107;break a;break};case 29:{l=94;break d;break};case 7:{l=103;break a;break};case 11:{l=106;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[27416+((d[27160+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[(c[j>>2]|0)+1|0]|0)==0){if((a[c[j>>2]|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function xt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g+1|0]|0)==0){k=a[g]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){l=a[g]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){m=a[g]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function yt(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e+1|0]|0)==0){m=d[b+76+(d[h]|0)|0]|0}else{m=mt(a[h+1|0]|0,a[e]|0)|0}h=m;switch(h|0){case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e+1|0]|0)==0){p=d[b+76+(d[g]|0)|0]|0}else{p=mt(a[g+1|0]|0,a[e]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function zt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=mt(a[g+1|0]|0,a[b]|0)|0}if((m|0)==27){k=st(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=mt(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 10:case 9:case 21:{break a;break};case 30:{n=16;break a;break};case 24:case 22:{break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+3|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=mt(a[o+1|0]|0,a[b+2|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function At(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=mt(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 29:{if((c[27416+((d[27160+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=mt(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 7:{n=34;break b;break};case 6:{n=31;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 5:{n=28;break b;break};case 29:{if((c[27416+((d[28696+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function Bt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=mt(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=mt(a[g]|0,a[b+1|0]|0)|0}switch(n|0){case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+2|0]|0)!=0){break}if((a[b+3|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 13:{k=bu(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{g=b;if((c[27416+((d[27160+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){b=g+2|0;o=18;p=77;break a}if((c[27416+((d[28696+(d[g]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=76;break a}b=b+2|0;o=19;p=77;break};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){q=d[j+76+(d[g+1|0]|0)|0]|0}else{q=mt(a[g]|0,a[b+1|0]|0)|0}switch(q|0){case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 16:{k=cu(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=Zt(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 12:{k=bu(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 19:{k=du(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 30:{k=Tt(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 10:case 21:{p=25;break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 23:case 27:case 26:case 25:{o=19;b=b+2|0;p=77;break};case 24:case 22:{o=18;b=b+2|0;p=77;break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 9:{if((b+2|0)!=(e|0)){p=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};default:{p=76}}}while(0);if((p|0)==25){while(1){p=0;b=b+2|0;r=b;if((b|0)==(e|0)){p=32;break}q=b;if((a[r]|0)==0){s=d[j+76+(d[q+1|0]|0)|0]|0}else{s=mt(a[q]|0,a[b+1|0]|0)|0}if((s|0)==10|(s|0)==21){p=25;continue}else if((s|0)!=9){p=31;break}if((b+2|0)!=(e|0)){p=25}else{p=31;break}}if((p|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((p|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((p|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==77){b:while(1){p=0;if((b|0)==(e|0)){p=126;break}r=b;if((a[b]|0)==0){t=d[j+76+(d[r+1|0]|0)|0]|0}else{t=mt(a[r]|0,a[b+1|0]|0)|0}switch(t|0){case 33:{p=119;break b;break};case 6:{p=88;break b;break};case 7:{p=91;break b;break};case 5:{p=85;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{p=94;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 34:{p=116;break b;break};case 29:{if((c[27416+((d[28696+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=83;break b}break};case 23:{b=b+2|0;r=o;if((r|0)==41){o=19;p=77;continue b}else if((r|0)!=18){p=77;continue b}if((b|0)==(e|0)){p=97;break b}o=41;r=b;if((a[b]|0)==0){u=d[j+76+(d[r+1|0]|0)|0]|0}else{u=mt(a[r]|0,a[b+1|0]|0)|0}switch(u|0){case 27:case 26:case 25:case 24:case 22:{break};case 5:{p=105;break b;break};case 29:{if((c[27416+((d[28696+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=103;break b}break};case 6:{p=108;break b;break};case 7:{p=111;break b;break};default:{o=19;p=77;continue b}}b=b+2|0;p=77;continue b;break};case 15:{p=122;break b;break};default:{p=125;break b}}b=b+2|0;p=77}if((p|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==94){c[f>>2]=b;k=o;l=k;i=h;return l|0}else if((p|0)==97){k=-1;l=k;i=h;return l|0}else if((p|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==116){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((p|0)==119){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((p|0)==122){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((p|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==126){k=0-o|0;l=k;i=h;return l|0}}return 0}function Ct(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=mt(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 2:{k=Wt(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 3:{k=St(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=mt(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=mt(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 5:{r=b;if((e-b|0)<2){p=49;break b}b=r+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 7:{s=b;if((e-b|0)<4){p=55;break b}b=s+4|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=52;break b}b=t+3|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+2|0]|0)==0){if((a[b+3|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+4|0]|0)==0){if((a[b+5|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Dt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=mt(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=mt(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=mt(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 5:{r=b;if((e-b|0)<2){p=47;break b}b=r+2|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=53;break b}b=s+4|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=50;break b}b=t+3|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Et(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b]|0)==0){m=d[j+76+(d[k+1|0]|0)|0]|0}else{m=mt(a[k]|0,a[b+1|0]|0)|0}switch(m|0){case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function Ft(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=mt(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 6:{b=b+3|0;continue a;break};case 9:{n=19;break a;break};case 21:{n=29;break a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 2:{n=15;break a;break};case 3:{n=12;break a;break};case 10:{n=16;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=St(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=mt(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Gt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=mt(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 6:{b=b+3|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 10:{n=18;break a;break};case 30:{n=15;break a;break};case 3:{n=12;break a;break};case 9:{n=21;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=St(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=Tt(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=mt(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Ht(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b]|0)==0){h=d[g+76+(d[e+1|0]|0)|0]|0}else{h=mt(a[e]|0,a[b+1|0]|0)|0}switch(h|0){case 6:{j=8;break};case 5:{break};case 7:{e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=7;break a}else{j=8}break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{k=c;c=k+1|0;e=b;b=e+1|0;if((a[k]|0)!=(a[e]|0)){j=15;break a}e=c;c=e+1|0;k=b;b=k+1|0;if((a[e]|0)!=(a[k]|0)){j=17;break a}else{continue a}break};default:{j=18;break a}}if((j|0)==8){j=0;k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=9;break}}e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=11;break}k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=13;break}}if((j|0)==7){l=0;m=l;i=f;return m|0}else if((j|0)==9){l=0;m=l;i=f;return m|0}else if((j|0)==11){l=0;m=l;i=f;return m|0}else if((j|0)==13){l=0;m=l;i=f;return m|0}else if((j|0)==15){l=0;m=l;i=f;return m|0}else if((j|0)==17){l=0;m=l;i=f;return m|0}else if((j|0)==18){j=c;if((a[c]|0)==0){n=d[g+76+(d[j+1|0]|0)|0]|0}else{n=mt(a[j]|0,a[c+1|0]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function It(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f]|0)!=0){h=7;break}if((a[f+1|0]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function Jt(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b]|0)==0){h=d[f+76+(d[g+1|0]|0)|0]|0}else{h=mt(a[g]|0,a[b+1|0]|0)|0}switch(h|0){case 7:{b=b+4|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};default:{break a}}}i=e;return b-c|0}function Kt(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b]|0)==0){g=d[f+76+(d[c+1|0]|0)|0]|0}else{g=mt(a[c]|0,a[b+1|0]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function Lt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b]|0)==0){n=d[j+76+(d[m+1|0]|0)|0]|0}else{n=mt(a[m]|0,a[b+1|0]|0)|0}b:do{switch(n|0){case 17:case 11:{if((g|0)!=2){break a}break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)==0){o=a[b+1|0]|0}else{o=-1}if((o|0)!=32){break}if((a[b+2|0]|0)==0){p=a[b+3|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+2|0]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=mt(a[m]|0,a[b+3|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function Mt(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d]|0)==0){if((a[d+1|0]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d]|0)==0){f=(a[d+1|0]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d]|0)==0){g=a[d+1|0]|0}else{g=-1}h=g;switch(h|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d]|0)==0){l=(a[d+1|0]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d]|0)==0){m=a[d+1|0]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=As(c)|0;k=j;i=b;return k|0}function Nt(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==2){if((a[e+2|0]|0)!=0){break}if((a[e+3|0]|0)!=116){break}if((a[e]|0)==0){f=a[e+1|0]|0}else{f=-1}if((f|0)==103){g=62;h=g;i=b;return h|0}else if((f|0)==108){g=60;h=g;i=b;return h|0}else{break}}else if((c|0)==4){if((a[e]|0)==0){j=a[e+1|0]|0}else{j=-1}if((j|0)==113){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=117){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=116){break}g=34;h=g;i=b;return h|0}else if((j|0)==97){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=115){break}g=39;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=97){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=109){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}g=38;h=g;i=b;return h|0}}while(0);g=0;h=g;i=b;return h|0}function Ot(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=mt(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 6:{b=b+3|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=mt(a[g]|0,a[b+1|0]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 5:{b=b+2|0;break};case 7:{b=b+4|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function Pt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=mt(a[g]|0,a[b+1|0]|0)|0}b:do{switch(l|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 21:{if((a[b]|0)!=0){break b}if((a[b+1|0]|0)==9){k=9;break a}break};case 22:case 26:{if((a[b]|0)==0){m=a[b+1|0]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b]|0)==0){n=a[b+1|0]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function Qt(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j+1|0]|0;m=a[g]|0;b:do{switch(m&255|0){case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}n=((m&3)<<2|(l&255)>>6&3)+1|0;o=e;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n>>2|240;p=e;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=(l&255)>>2&15|(n&3)<<4|128;g=g+2|0;n=a[g+1|0]|0;o=((l&3)<<4|(a[g]&3)<<2|(n&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=o;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=n&63|128;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=l;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=(m&255)>>4|224;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(m&15)<<2|(l&255)>>6|128;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(l&255)>>6|(m&255)<<2|192;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function Rt(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[c[k>>2]|0]|0)<<8|(d[(c[k>>2]|0)+1|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function St(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=mt(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 19:{k=Ut(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{if((c[27416+((d[27160+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=mt(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=32;break b;break};case 18:{n=38;break b;break};case 5:{n=29;break b;break};case 7:{n=35;break b;break};case 29:{if((c[27416+((d[28696+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Tt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=mt(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 29:{if((c[27416+((d[27160+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=mt(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 29:{if((c[27416+((d[28696+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 6:{n=32;break b;break};case 18:{n=38;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=29;break b;break};case 7:{n=35;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Ut(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=120){break}k=Vt(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=mt(a[g]|0,a[b+1|0]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=mt(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function Vt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=mt(a[g]|0,a[b+1|0]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=mt(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}



function Zx(b,d,e,f,g,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0,R=0;o=i;p=c[d>>2]|0;q=~p;r=c[j>>2]|0;j=~r;h[7860]=1.0;s=p-(c[b>>2]|0)|0;t=s+ -1|0;c[15726]=t;c[15716]=1;c[15710]=2;if((s|0)<3){u=1}else{s=2;v=1;while(1){do{if((s|0)==(c[g>>2]|0)){c[15716]=s;w=s}else{x=c[m>>2]|0;y=fa(s,p)|0;z=+h[f+(y+q+x<<3)>>3];if(!(z!=0.0)){w=v;break}A=fa(v,p)|0;B=x+q|0;x=f+(B+A<<3)|0;C=+h[x>>3];D=+V(+(z*z+C*C));h[7862]=D;C=+h[x>>3]/D;h[7869]=C;z=+h[f+(B+y<<3)>>3]/D;h[7870]=z;B=c[d>>2]|0;c[15708]=1;if((B|0)>=1){D=z;z=C;x=1;while(1){E=x+q|0;h[7862]=z*+h[f+(E+A<<3)>>3]+D*+h[f+(E+y<<3)>>3];E=x+q|0;F=f+(E+y<<3)|0;G=f+(E+A<<3)|0;h[F>>3]=z*+h[F>>3]-D*+h[G>>3];h[G>>3]=+h[7862];if((x|0)>=(B|0)){break}D=+h[7870];z=+h[7869];x=x+1|0}c[15708]=B+1}h[f+((c[m>>2]|0)+q+y<<3)>>3]=0.0;w=v}}while(0);x=s+1|0;c[15710]=x;if((s|0)<(t|0)){s=x;v=w}else{u=w;break}}}w=c[m>>2]|0;z=+h[f+(w+ -1<<3)>>3];h[7869]=z;if((c[g>>2]|0)>1){D=-z;h[7869]=D;H=D}else{H=z}v=(u|0)>1;if(v){h[7870]=+h[f+((fa(u,p)|0)+q+w<<3)>>3]}w=c[d>>2]|0;c[15708]=1;if((w|0)>=1){s=(fa(u,p)|0)+q|0;z=H;t=1;x=0;while(1){h[n+(x<<3)>>3]=z*+h[f+(x<<3)>>3];if(v){A=n+(t+ -1<<3)|0;h[A>>3]=+h[A>>3]+ +h[7870]*+h[f+(s+t<<3)>>3]}if((t|0)>=(w|0)){break}A=t;z=+h[7869];t=t+1|0;x=A}c[15708]=w+1}w=(c[m>>2]|0)+ -1|0;z=+h[n+(w<<3)>>3];h[7867]=z;x=k+(w<<3)|0;H=+h[x>>3];h[7861]=H;D=H*H;h[7871]=D;h[7868]=D+z*+h[l>>3];h[x>>3]=+h[x>>3]- +h[7860];a[62912]=0;do{if((u|0)==1){z=+h[7868];if(!(z>=0.0)){I=-z}else{I=z}z=+V(+I);h[7862]=z;D=+h[7869]/z;h[7870]=D;H=+h[7861]/z;h[7869]=H;x=c[d>>2]|0;c[15708]=1;if((x|0)<1){J=z}else{z=D;D=H;w=1;t=0;while(1){s=f+(t<<3)|0;h[s>>3]=D*+h[s>>3]-z*+h[k+(t<<3)>>3];if((w|0)>=(x|0)){break}s=w;z=+h[7870];D=+h[7869];w=w+1|0;t=s}c[15708]=x+1;J=+h[7862]}t=c[g>>2]|0;if((t|0)==1&J<0.0){c[g>>2]=2;K=2}else{K=t}if(!((K|0)<2|!(J>=0.0))){L=46}}else{c[15712]=1;if(!(+h[l>>3]>=0.0)){M=1}else{c[15712]=u;M=u}t=u+1-M|0;c[15714]=t;w=fa(t,p)|0;t=(c[m>>2]|0)+q|0;D=+h[7868];z=+h[f+(t+w<<3)>>3]/D;h[7862]=z;h[7869]=z*+h[l>>3];H=+h[7861];h[7870]=z*H;s=fa(M,p)|0;z=+h[f+(t+s<<3)>>3];h[7862]=z;C=+h[l>>3];if(!(C>=0.0)){N=-C}else{N=C}C=+h[7860]/+V(+(+h[7871]+z*N*z));h[7865]=C;if(!(D>=0.0)){O=-D}else{O=D}h[7866]=C*+V(+O);t=c[d>>2]|0;c[15708]=1;if((t|0)<1){P=D}else{D=z;z=H;H=C;v=1;while(1){A=f+(v+q+s<<3)|0;h[A>>3]=H*(z*+h[A>>3]-D*+h[k+(v+ -1<<3)>>3]);A=f+(v+q+w<<3)|0;G=v+ -1|0;h[A>>3]=+h[7866]*(+h[A>>3]- +h[7869]*+h[n+(G<<3)>>3]- +h[7870]*+h[k+(G<<3)>>3]);if((v|0)>=(t|0)){break}D=+h[7862];z=+h[7861];H=+h[7865];v=v+1|0}c[15708]=t+1;P=+h[7868]}if(!(P<=0.0)){break}H=+h[l>>3];if(H<0.0){c[g>>2]=(c[g>>2]|0)+1}if(H>=0.0){L=46}}}while(0);do{if((L|0)==46){a[62912]=1;c[g>>2]=(c[g>>2]|0)+ -1;M=c[d>>2]|0;c[15708]=1;if((M|0)<1){break}else{Q=1}while(1){u=f+(Q+ -1<<3)|0;h[7862]=+h[u>>3];K=f+(Q+q+(fa(c[g>>2]|0,p)|0)<<3)|0;h[u>>3]=+h[K>>3];h[K>>3]=+h[7862];K=Q+1|0;c[15708]=K;if((Q|0)<(M|0)){Q=K}else{break}}}}while(0);Q=c[b>>2]|0;c[15710]=1;if((Q|0)<1){i=o;return 0}else{R=1}while(1){b=(c[d>>2]|0)+R|0;c[15718]=b;p=fa(R,r)|0;P=+h[e+((c[m>>2]|0)+j+p<<3)>>3];g=b+ -1|0;q=n+(g<<3)|0;h[q>>3]=P;f=k+(g<<3)|0;O=+h[7861];N=+h[7868];J=(+h[7867]*+h[f>>3]-O*P)/N;h[7869]=J;P=(-(+h[l>>3]*+h[q>>3])-O*+h[f>>3])/N;h[7870]=P;c[15708]=1;a:do{if((b|0)>=1){N=P;O=J;f=1;while(1){q=e+(f+j+p<<3)|0;g=f+ -1|0;I=+h[q>>3]+O*+h[k+(g<<3)>>3]+N*+h[n+(g<<3)>>3];h[q>>3]=I;q=c[d>>2]|0;if((f|0)>(q|0)){h[e+((fa(f-q|0,r)|0)+j+b<<3)>>3]=I}q=f+1|0;c[15708]=q;if((f|0)>=(b|0)){break a}N=+h[7870];O=+h[7869];f=q}}}while(0);b=R+1|0;c[15710]=b;if((R|0)<(Q|0)){R=b}else{break}}i=o;return 0}function _x(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0;m=i;if((b|0)<(d|0)){n=(b|0)<(e|0);o=0.0;p=-1;q=-1;r=b;while(1){if(n){s=c[f+(r<<2)>>2]|0;t=b;u=o;v=p;w=q;while(1){x=+U(+(+h[a+((fa(c[g+(t<<2)>>2]|0,d)|0)+s<<3)>>3]));y=x>u;z=y?r:w;A=y?t:v;B=y?x:u;y=t+1|0;if((y|0)<(e|0)){w=z;v=A;u=B;t=y}else{C=B;D=A;E=z;break}}}else{C=o;D=p;E=q}t=r+1|0;if((t|0)<(d|0)){o=C;p=D;q=E;r=t}else{F=C;G=D;H=E;break}}}else{F=0.0;G=-1;H=-1}if((G|H|0)<0){I=-1;i=m;return I|0}c[j>>2]=H;c[k>>2]=G;h[l>>3]=F;I=0;i=m;return I|0}function $x(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;m=(b|0)<=(d|0)?b:d;if((m|0)>0){n=0}else{o=0;i=g;return o|0}while(1){p=e+(n<<2)|0;q=f+(n<<2)|0;r=+h[a+((fa(c[q>>2]|0,b)|0)+(c[p>>2]|0)<<3)>>3];if((_x(a,n,b,d,e,f,j,k,l)|0)!=0){o=-1;s=14;break}t=+U(+r);if(+h[l>>3]>t*1.125){u=c[p>>2]|0;v=e+(c[j>>2]<<2)|0;c[p>>2]=c[v>>2];c[v>>2]=u;u=c[q>>2]|0;v=f+(c[k>>2]<<2)|0;c[q>>2]=c[v>>2];c[v>>2]=u}u=c[p>>2]|0;p=fa(c[q>>2]|0,b)|0;t=+h[a+(p+u<<3)>>3];if(!(t!=0.0)){s=7;break}q=n+1|0;if((q|0)<(b|0)){v=(q|0)<(d|0);w=q;do{x=c[e+(w<<2)>>2]|0;y=a+(p+x<<3)|0;r=+h[y>>3];do{if(r!=0.0){z=-r/t;h[y>>3]=0.0;if(v){A=q}else{break}do{B=fa(c[f+(A<<2)>>2]|0,b)|0;C=a+(B+x<<3)|0;h[C>>3]=+h[C>>3]+z*+h[a+(u+B<<3)>>3];A=A+1|0;}while((A|0)<(d|0))}}while(0);w=w+1|0;}while((w|0)<(b|0))}if((q|0)<(m|0)){n=q}else{o=0;s=14;break}}if((s|0)==7){$a(62976,62992,116,63016)}else if((s|0)==14){i=g;return o|0}return 0}function ay(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=e;c[u>>2]=0;v=b+280|0;w=c[v>>2]|0;x=1;while(1){y=x+1|0;if((t_(w,c[63024+(x<<2)>>2]|0)|0)==0){z=4;break}if((y|0)<8){x=y}else{break}}do{if((z|0)==4){c[u>>2]=x;if((x|0)==0){break}y=c[63128+(x<<2)>>2]|0;c[q>>2]=c[63024+(x<<2)>>2];c[q+4>>2]=y;gw(23,0,63200,q);y=b+112|0;A=e+28|0;c[A>>2]=(c[y>>2]|0)+20;B=c[y>>2]|0;C=b+160|0;D=((c[C>>2]|0)*3|0)+50+(fa(B+9|0,B)|0)|0;c[e+32>>2]=D;B=XZ(D,8)|0;c[e+40>>2]=B;D=b+536|0;jw(c[D>>2]|0,(B|0)!=0|0,63240,p);B=XZ(c[A>>2]|0,4)|0;c[e+36>>2]=B;jw(c[D>>2]|0,(B|0)!=0|0,63240,o);c[e+56>>2]=c[C>>2];c[e+52>>2]=0;c[e+60>>2]=XZ(c[C>>2]|0,4)|0;c[e+24>>2]=VZ(8)|0;C=VZ(4)|0;c[e+20>>2]=C;c[C>>2]=c[35640>>2];jw(c[D>>2]|0,(C|0)!=0|0,63240,n);C=c[y>>2]<<3;B=e+48|0;c[B>>2]=VZ(C)|0;A=e+44|0;c[A>>2]=VZ(C)|0;C=XZ(15,4)|0;E=e+12|0;c[E>>2]=C;jw(c[D>>2]|0,(C|0)!=0|0,63240,m);C=XZ(5,4)|0;c[e+4>>2]=C;jw(c[D>>2]|0,(C|0)!=0|0,63240,l);C=XZ(5,4)|0;c[e+8>>2]=C;jw(c[D>>2]|0,(C|0)!=0|0,63240,k);c[e+16>>2]=0;h[e+64>>3]=1.4901161193847656e-8;C=c[y>>2]<<3;c[e+72>>2]=VZ(C)|0;c[e+76>>2]=VZ(C)|0;c[e+80>>2]=VZ(C)|0;C=c[E>>2]|0;c[C+8>>2]=1;D=c[u>>2]|0;a:do{switch(D|0){case 7:case 1:case 2:case 4:case 5:case 3:{if((ee[c[(c[b+540>>2]|0)+140>>2]&127](b)|0)==0){F=c[E>>2]|0;c[F+16>>2]=1;G=F;H=c[u>>2]|0;z=17;break a}if((c[y>>2]|0)==1){gw(23,0,63256,j)}else{gw(1,0,63328,g)}c[u>>2]=6;z=18;break};default:{G=C;H=D;z=17}}}while(0);if((z|0)==17){if((H|0)==2){I=G}else{z=18}}if((z|0)==18){a[d+28|0]=1;I=c[E>>2]|0}c[I+4>>2]=1;D=c[y>>2]|0;if((D|0)<=0){i=f;return 0}C=b+272|0;F=c[A>>2]|0;J=c[b+8>>2]|0;K=c[B>>2]|0;L=0;do{h[F+(L<<3)>>3]=+h[C>>3];h[K+(L<<3)>>3]=+h[C>>3]*+h[J+(L*112|0)+80>>3];L=L+1|0;}while((L|0)<(D|0));i=f;return 0}}while(0);if((c[35676>>2]|c[8894]|0)==0){M=w;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=4;U=T;V=63160;W=V;kw(Q,W,r)}c[t>>2]=w;iw(23,1,63056,t);t=1;do{w=c[63128+(t<<2)>>2]|0;c[s>>2]=c[63024+(t<<2)>>2];c[s+4>>2]=w;iw(23,0,63112,s);t=t+1|0;}while((t|0)<8);be[c[9034]&255](23);M=c[v>>2]|0;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=4;U=T;V=63160;W=V;kw(Q,W,r);return 0}function by(a){a=a|0;var b=0;b=i;WZ(c[a+40>>2]|0);WZ(c[a+36>>2]|0);WZ(c[a+20>>2]|0);WZ(c[a+12>>2]|0);WZ(c[a+4>>2]|0);WZ(c[a+8>>2]|0);WZ(a);i=b;return 0}function cy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;h[D>>3]=0.0;E=a+4|0;F=c[E>>2]|0;G=c[F>>2]|0;H=c[b+48>>2]|0;I=(c[F+4>>2]|0)+8|0;F=c[I>>2]|0;J=a+112|0;K=c[J>>2]|0;L=F+(K<<3)|0;M=H+24|0;c[c[M>>2]>>2]=a;c[(c[M>>2]|0)+4>>2]=H;N=a+536|0;jw(c[N>>2]|0,(c[M>>2]|0)!=0|0,63424,C);if((c[b+36>>2]|0)!=0){c[c[H+12>>2]>>2]=0;c[H+16>>2]=0}C=b;O=+h[C>>3];P=b+8|0;Q=O+ +h[P>>3];h[D>>3]=Q;if(O-Q>=-1.0e-13){gw(3,0,63456,B);gw(3,0,63496,A);A=c[J>>2]|0;if((A|0)>0){B=c[I>>2]|0;I=c[G+8>>2]|0;R=0;do{h[I+(R<<3)>>3]=+h[B+(R<<3)>>3]+ +h[F+(R+K<<3)>>3]*+h[P>>3];R=R+1|0;}while((R|0)<(A|0))}h[G>>3]=+h[D>>3];ee[c[(c[a+540>>2]|0)+28>>2]&127](a)|0;h[C>>3]=+h[D>>3];S=0;i=d;return S|0}A=z;h[k>>3]=O;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];gw(3,0,63520,z);z=H+16|0;A=z;R=a;P=b+24|0;b=H+12|0;K=H+44|0;F=H+48|0;B=H+40|0;I=H+32|0;T=H+36|0;U=H+28|0;V=U;W=H+20|0;X=H+52|0;Y=H+56|0;Z=H+60|0;_=c[r>>2]|0;$=c[t>>2]|0;aa=a+248|0;ba=a+540|0;ca=G;G=L;a:while(1){Q=+h[D>>3];L=y;h[k>>3]=+h[C>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=y+8|0;h[k>>3]=Q;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];gw(23,0,63560,y);if((c[z>>2]|0)==1){_w(c[R>>2]|0,1,c[E>>2]|0);L=c[E>>2]|0;da=c[L>>2]|0;ea=(c[(c[L+4>>2]|0)+8>>2]|0)+(c[J>>2]<<3)|0;h[da>>3]=+h[C>>3];fa=da;ga=ea}else{fa=ca;ga=G}if((c[P>>2]|0)!=5){Nz(a)|0;ee[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ea=c[H>>2]|0;b:do{switch(ea|0){case 5:{tx(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,5,2,Y,c[Z>>2]|0)|0;break};case 3:{tx(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,3,2,Y,c[Z>>2]|0)|0;break};case 4:{tx(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,4,2,Y,c[Z>>2]|0)|0;break};case 6:{tx(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,6,2,Y,c[Z>>2]|0)|0;break};case 7:{tx(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,7,3,X,0)|0;break};default:{da=c[fa+8>>2]|0;L=c[b>>2]|0;ha=c[K>>2]|0;ia=c[F>>2]|0;ja=c[B>>2]|0;ka=c[T>>2]|0;la=c[M>>2]|0;ma=c[W>>2]|0;if((ea|0)==2){tx(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,3,X,0)|0;break b}else{tx(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,2,Y,c[Z>>2]|0)|0;break b}}}}while(0);ea=c[z>>2]|0;do{if((ea|0)==-1){qd(_|0)|0;qd($|0)|0;iw(3,0,63592,x);gw(3,0,63680,w);c[c[b>>2]>>2]=1}else{if((ea|0)<0){na=25;break a}if((ea|0)!=4){break}c[(c[N>>2]|0)+84>>2]=4}}while(0);ea=c[z>>2]|0;if((ea|0)==1){ca=fa;G=ga;continue}else if(!((ea|0)==-1)){na=31;break}Q=+h[C>>3];if(!(Q<=+h[aa>>3])){oa=Q;break}else{ca=fa;G=ga}}if((na|0)==25){qd(_|0)|0;qd($|0)|0;$=ly(c[z>>2]|0)|0;if((c[P>>2]|0)!=5){Nz(a)|0;ee[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ee[c[(c[ba>>2]|0)+28>>2]&127](a)|0;a=v;h[k>>3]=+h[fa>>3];c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];iw(1,0,63704,v);S=$;i=d;return S|0}else if((na|0)==31){oa=+h[C>>3]}h[fa>>3]=oa;if((c[35596>>2]|0)!=0){gw(3,1,63736,u);c[s>>2]=c[z>>2];gw(3,0,63760,s);s=q;h[k>>3]=+h[C>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];gw(3,0,63784,q);q=p;h[k>>3]=+h[(c[B>>2]|0)+24>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gw(3,0,63816,p);p=o;h[k>>3]=+h[(c[B>>2]|0)+16>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gw(3,0,63856,o);o=n;h[k>>3]=+h[(c[B>>2]|0)+48>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];gw(3,0,63904,n);c[m>>2]=c[(c[T>>2]|0)+40>>2];gw(3,0,63952,m);c[l>>2]=c[(c[T>>2]|0)+44>>2];gw(3,0,63992,l);c[j>>2]=c[(c[T>>2]|0)+48>>2];gw(3,0,64032,j);c[g>>2]=c[(c[T>>2]|0)+52>>2];gw(3,0,64072,g);c[f>>2]=c[(c[T>>2]|0)+56>>2];gw(3,0,64120,f);be[c[9034]&255](3)}f=c[U>>2]|0;U=H+8|0;H=0;do{g=H+10|0;if(!(g>>>0<f>>>0)){na=37;break}c[(c[U>>2]|0)+(H<<2)>>2]=c[(c[T>>2]|0)+(g<<2)>>2];H=H+1|0;}while(H>>>0<5);if((na|0)==37){$a(64160,64192,410,64224)}gw(3,0,64240,e);S=0;i=d;return S|0}function dy(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;f=c[g>>2]|0;g=f;b=f+536|0;k=f+4|0;l=c[c[k>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[a>>3];a=(c[b>>2]|0)+84|0;l=c[a>>2]|0;c[a>>2]=2;Nz(g)|0;a=f+540|0;ee[c[(c[a>>2]|0)+40>>2]&127](g)|0;ee[c[(c[a>>2]|0)+28>>2]&127](g)|0;g=c[f+112>>2]|0;if((g|0)<=0){n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;a=0;do{h[e+(a<<3)>>3]=+h[f+(g+a<<3)>>3]- +h[d+(a<<3)>>3];a=a+1|0;}while((a|0)<(g|0));n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}function ey(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;Nz(l)|0;b=k+540|0;ee[c[(c[b>>2]|0)+40>>2]&127](l)|0;ee[c[(c[b>>2]|0)+28>>2]&127](l)|0;ny(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function fy(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0;j=i;e=c[g>>2]|0;g=e;d=e+536|0;a=(c[d>>2]|0)+84|0;k=c[a>>2]|0;c[a>>2]=4;a=e+4|0;l=c[c[a>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[b>>3];Nz(g)|0;l=e+540|0;ee[c[(c[l>>2]|0)+40>>2]&127](g)|0;ee[c[(c[l>>2]|0)+28>>2]&127](g)|0;ee[c[(c[l>>2]|0)+32>>2]&127](g)|0;ie[c[(c[l>>2]|0)+92>>2]&63](g,f,b)|0;c[(c[d>>2]|0)+84>>2]=k;h[c[c[a>>2]>>2]>>3]=m;i=j;return 0}function gy(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;oy(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function hy(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;Nz(l)|0;b=k+540|0;ee[c[(c[b>>2]|0)+40>>2]&127](l)|0;ee[c[(c[b>>2]|0)+28>>2]&127](l)|0;my(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function iy(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;i=i;return 0}function jy(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;py(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function ky(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i;return 0}function ly(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;c=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;switch(a|0){case-8:{iw(1,0,64416,g);m=-8;i=b;return m|0};case-7:{iw(1,0,64376,h);m=-7;i=b;return m|0};case-33:{iw(1,0,64784,b);m=-33;i=b;return m|0};case-3:{m=-3;i=b;return m|0};case-6:{iw(1,0,64304,j);m=-6;i=b;return m|0};case-1:{iw(3,0,63592,l);m=1;i=b;return m|0};case-9:{iw(1,0,64464,f);m=-9;i=b;return m|0};case-10:{iw(1,0,64552,e);m=-10;i=b;return m|0};case-2:{iw(1,0,64264,k);m=-2;i=b;return m|0};case-11:{iw(1,0,64648,d);m=-11;i=b;return m|0};case-12:{iw(1,0,64736,c);m=-12;i=b;return m|0};default:{m=-1;i=b;return m|0}}return 0}function my(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+540|0;f=c[(c[e>>2]|0)+120>>2]|0;g=a+464|0;j=c[g>>2]|0;if((c[j+(f*44|0)+24>>2]|0)==0){i=d;return 0}k=a;a=c[j+(f*44|0)>>2]|0;l=j;j=0;do{if((a|0)!=0){m=0;do{if(((c[(c[l+(f*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}ee[c[(c[e>>2]|0)+160>>2]&127](k)|0;l=c[g>>2]|0;a=c[l+(f*44|0)>>2]|0;do{if((a|0)!=0){m=c[l+(f*44|0)+28>>2]|0;n=0;do{do{if(+h[m+(n<<3)>>3]==1.0){if((n|0)==0){o=l+(f*44|0)+8|0;p=0}else{q=l+(f*44|0)+8|0;o=q;p=c[(c[q>>2]|0)+(n+ -1<<2)>>2]|0}q=c[(c[o>>2]|0)+(n<<2)>>2]|0;if(!(p>>>0<q>>>0)){break}r=c[l+(f*44|0)+12>>2]|0;s=c[l+(f*44|0)+4>>2]|0;t=c[l+(f*44|0)+36>>2]|0;u=p;do{v=c[r+(u<<2)>>2]|0;w=(fa(s,n)|0)+v|0;h[b+(w<<3)>>3]=+h[t+(v<<3)>>3];u=u+1|0;}while(u>>>0<q>>>0)}}while(0);n=n+1|0;}while(n>>>0<a>>>0);if((a|0)==0){break}n=c[l+(f*44|0)+20>>2]|0;m=0;do{if(((c[n+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=0.0}m=m+1|0;}while(m>>>0<a>>>0)}}while(0);j=j+1|0;}while(j>>>0<(c[l+(f*44|0)+24>>2]|0)>>>0);i=d;return 0}function ny(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+540|0;f=c[e>>2]|0;g=c[f+120>>2]|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)>>2]|0)==0){i=d;return 0}l=a;a=f;f=c[k+(g*44|0)+28>>2]|0;k=0;m=0;while(1){h[f+(k<<3)>>3]=1.0;ee[c[a+160>>2]&127](l)|0;n=c[j>>2]|0;o=c[n+(g*44|0)+4>>2]|0;if((o|0)==0){p=m}else{q=o>>>0>1?o:1;r=c[n+(g*44|0)+36>>2]|0;s=0;t=m;while(1){h[b+(t<<3)>>3]=+h[r+(s<<3)>>3];u=s+1|0;if(u>>>0<o>>>0){t=t+1|0;s=u}else{break}}p=m+q|0}s=c[n+(g*44|0)+28>>2]|0;h[s+(k<<3)>>3]=0.0;t=k+1|0;if(!(t>>>0<(c[n+(g*44|0)>>2]|0)>>>0)){break}a=c[e>>2]|0;f=s;k=t;m=p}i=d;return 0}function oy(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;n=i;j=c[m+4>>2]|0;o=+h[j+64>>3];p=a+112|0;a=c[p>>2]|0;if((a|0)<=0){i=n;return 0}q=j+80|0;j=a;do{j=j+ -1|0;r=+h[k>>3]*+h[e+(j<<3)>>3];a=d+(j<<3)|0;s=+h[a>>3];if(!(s>=0.0)){t=-s}else{t=s}u=r>=0.0;if(u){v=r}else{v=-r}r=+pd(+t,+v);w=+h[l+(j<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}w=o*+pd(+r,+x);if(u){y=w}else{y=-w}w=y+s-s;r=1.0/w;h[a>>3]=s+w;dy(b,0,e,c[q>>2]|0,0,m,0)|0;u=c[p>>2]|0;if((u|0)>0){z=c[q>>2]|0;A=fa(u,j)|0;B=u;do{B=B+ -1|0;h[g+(A+B<<3)>>3]=r*(+h[z+(B<<3)>>3]- +h[f+(B<<3)>>3]);}while((B|0)>0)}h[a>>3]=s;}while((j|0)>0);i=n;return 0}function py(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;n=i;j=c[(c[a+540>>2]|0)+120>>2]|0;o=c[m+4>>2]|0;p=+h[o+64>>3];q=c[o+76>>2]|0;r=c[o+72>>2]|0;s=a+464|0;a=c[s>>2]|0;if((c[a+(j*44|0)+24>>2]|0)==0){i=n;return 0}t=o+80|0;o=c[a+(j*44|0)>>2]|0;u=a;a=0;do{if((o|0)!=0){v=0;do{if(((c[(c[u+(j*44|0)+20>>2]|0)+(v<<2)>>2]|0)+ -1|0)==(a|0)){w=+h[k>>3]*+h[e+(v<<3)>>3];x=d+(v<<3)|0;y=+h[x>>3];if(!(y>=0.0)){z=-y}else{z=y}A=w>=0.0;if(A){B=w}else{B=-w}w=+pd(+z,+B);y=+h[l+(v<<3)>>3];if(!(y>=0.0)){C=-y}else{C=y}y=p*+pd(+w,+C);D=q+(v<<3)|0;h[D>>3]=y;if(A){E=y}else{E=-y}h[D>>3]=E;y=+h[x>>3];h[D>>3]=E+y-y;h[r+(v<<3)>>3]=+h[x>>3];h[x>>3]=+h[D>>3]+ +h[x>>3];h[D>>3]=1.0/+h[D>>3]}v=v+1|0;}while(v>>>0<o>>>0)}dy(b,0,e,c[t>>2]|0,0,m,0)|0;u=c[s>>2]|0;o=c[u+(j*44|0)>>2]|0;if((o|0)!=0){v=c[u+(j*44|0)+20>>2]|0;D=0;do{if(((c[v+(D<<2)>>2]|0)+ -1|0)==(a|0)){if((D|0)==0){F=u+(j*44|0)+8|0;G=0}else{x=u+(j*44|0)+8|0;F=x;G=c[(c[x>>2]|0)+(D+ -1<<2)>>2]|0}x=c[(c[F>>2]|0)+(D<<2)>>2]|0;if(G>>>0<x>>>0){A=c[t>>2]|0;H=q+(D<<3)|0;I=c[u+(j*44|0)+12>>2]|0;J=c[u+(j*44|0)+4>>2]|0;K=G;do{L=c[I+(K<<2)>>2]|0;M=(fa(J,D)|0)+L|0;h[g+(M<<3)>>3]=(+h[A+(L<<3)>>3]- +h[f+(L<<3)>>3])*+h[H>>3];K=K+1|0;}while(K>>>0<x>>>0)}h[d+(D<<3)>>3]=+h[r+(D<<3)>>3]}D=D+1|0;}while(D>>>0<o>>>0)}a=a+1|0;}while(a>>>0<(c[u+(j*44|0)+24>>2]|0)>>>0);i=n;return 0}function qy(a,b){a=a|0;b=+b;h[a+496>>3]=b;i=i;return}function ry(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0;e=i;be[c[(c[a+540>>2]|0)+112>>2]&255](a);f=a+328|0;h[f>>3]=d+1.0;g=c[a+104>>2]|0;if((g|0)<=0){i=e;return}j=c[a+108>>2]|0;k=a+336|0;a=0;do{d=+h[j+(a*24|0)+8>>3];if(d>b){h[(c[k>>2]|0)+(a<<3)>>3]=d;l=d}else{m=+h[j+(a*24|0)+16>>3];n=d+m*+ea(+((b-d)/m));h[(c[k>>2]|0)+(a<<3)>>3]=n;l=n}if((a|0)==0){o=8}else{if(l<+h[f>>3]){o=8}}if((o|0)==8){o=0;h[f>>3]=l}a=a+1|0;}while((a|0)<(g|0));i=e;return}function sy(b,c){b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0;d=i;e=+h[c>>3];f=c+8|0;g=+h[b+328>>3];if(!(g<=e+ +h[f>>3]+1.0e-14)){i=d;return}h[f>>3]=g-e;a[b+317|0]=1;i=d;return}function ty(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;d=i;i=i+8|0;e=d;f=a+160|0;if((c[f>>2]|0)<=0){g=rw(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}l=a+540|0;m=a+344|0;n=a+348|0;o=a+368|0;a=0;do{re[c[(c[l>>2]|0)+104>>2]&63](a,e)|0;p=+h[(c[m>>2]|0)+(a<<3)>>3];if(p==1.0){if(+h[(c[n>>2]|0)+(a<<3)>>3]==-1.0){q=7}else{q=5}}else{q=5}do{if((q|0)==5){q=0;if(!(p==-1.0)){break}if(+h[(c[n>>2]|0)+(a<<3)>>3]==1.0){q=7}}}while(0);if((q|0)==7){q=0;pw(b,(c[o>>2]|0)+(a<<2)|0)}a=a+1|0;}while((a|0)<(c[f>>2]|0));g=rw(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}function uy(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;e=i;g=f+32|0;do{if((ty(b,c[g>>2]|0)|0)!=0){if((a[f+28|0]|0)!=0){break}vy(b,c[g>>2]|0,f)}}while(0);if((a[b+317|0]|0)==1){h=1;i=e;return h|0}b=(rw(d)|0)>0;h=b?2:0;i=e;return h|0}function vy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=a+112|0;q=c[p>>2]<<3;r=VZ(q)|0;s=r;t=VZ(q)|0;q=t;h[n>>3]=+h[a+376>>3];u=a+4|0;h[o>>3]=+h[c[c[u>>2]>>2]>>3];c[16386]=nw(4)|0;if((r|0)==0){$a(65552,65568,308,65600)}if((t|0)==0){$a(65616,65568,309,65600)}v=uw(b)|0;if((v|0)!=0){w=v;do{v=ww(w)|0;c[l>>2]=c[v>>2];gw(27,0,65632,l);w=vw(w)|0;}while((w|0)!=0)}w=c[p>>2]|0;if((w|0)>0){l=c[(c[c[u>>2]>>2]|0)+8>>2]|0;v=(w|0)>1?w<<3:8;z_(t|0,c[a+384>>2]|0,v|0)|0;z_(r|0,l|0,v|0)|0}h[d>>3]=+yy(a,n,o,q,s,c[16386]|0,b);do{if((rw(c[16386]|0)|0)==0){s=sw(b)|0;q=a+344|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));s=uw(b)|0;if((s|0)==0){y=x}else{v=s;z=x;while(1){s=ww(v)|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));A=z>x?x:z;s=vw(v)|0;if((s|0)==0){y=A;break}else{z=A;v=s}}}v=j;h[k>>3]=y;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gw(27,0,65680,j);v=uw(b)|0;if((v|0)==0){break}else{B=v}do{v=ww(B)|0;if(y==+U(+(+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]))){v=c[16386]|0;qw(v,ww(B)|0);v=ww(B)|0;c[g>>2]=c[v>>2];gw(27,0,65704,g)}B=vw(B)|0;}while((B|0)!=0)}}while(0);ow(b);if((c[35612>>2]|0)!=0){rw(c[16386]|0)|0}if((rw(c[16386]|0)|0)>0){B=m;do{g=sw(c[16386]|0)|0;c[m>>2]=c[g>>2];tw(c[16386]|0);c[f>>2]=c[m>>2];gw(7,0,65728,f);pw(b,B);}while((rw(c[16386]|0)|0)>0)}h[d>>3]=+h[o>>3];o=c[c[u>>2]>>2]|0;h[o>>3]=+h[n>>3];n=c[p>>2]|0;if((n|0)>0){z_(c[o+8>>2]|0,t|0,((n|0)>1?n<<3:8)|0)|0}Se(a);By(a);a=c[c[u>>2]>>2]|0;h[a>>3]=+h[d>>3];d=c[p>>2]|0;if((d|0)<=0){WZ(t);WZ(r);i=e;return}z_(c[a+8>>2]|0,r|0,((d|0)>1?d<<3:8)|0)|0;WZ(t);WZ(r);i=e;return}function wy(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0;g=i;i=i+32|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+8|0;p=b+4|0;q=+h[c[c[p>>2]>>2]>>3];r=b+317|0;do{if((a[r]|0)!=0){Fy(b);s=b+104|0;t=c[s>>2]|0;if((t|0)<=0){break}u=b+336|0;v=q+1.0e-14;w=b+340|0;x=b+108|0;y=t;t=0;while(1){if(!(+h[(c[u>>2]|0)+(t<<3)>>3]<=v)){z=y}else{a[(c[w>>2]|0)+t|0]=1;A=c[x>>2]|0;B=+h[A+(t*24|0)+8>>3];C=+h[A+(t*24|0)+16>>3];c[m>>2]=c[A+(t*24|0)>>2];A=m+4|0;h[k>>3]=B;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=m+12|0;h[k>>3]=C;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];gw(7,0,65272,m);z=c[s>>2]|0}A=t+1|0;if((A|0)<(z|0)){y=z;t=A}else{break}}}}while(0);z=b+512|0;m=b+524|0;t=b+516|0;y=b+528|0;c[y>>2]=(c[y>>2]|0)-(c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]|0);if((rw(d)|0)>0){h[c[c[p>>2]>>2]>>3]=+h[e>>3];do{if((c[35612>>2]|0)!=0){e=uw(d)|0;if((e|0)==0){break}p=b+540|0;s=e;do{e=ww(s)|0;x=c[e>>2]|0;e=re[c[(c[p>>2]|0)+104>>2]&63](x,n)|0;w=c[n>>2]|0;c[l>>2]=x;c[l+4>>2]=e;fw(7,0,w,65296,l);s=vw(s)|0;}while((s|0)!=0)}}while(0);l=f+40|0;c[l>>2]=(c[l>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+1;c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=1;l=c[m>>2]|0;n=c[b+520>>2]|0;h[n+(l<<3)>>3]=q;s=b+532|0;do{if((c[s>>2]|0)==0){p=c[y>>2]|0;if((p|0)!=(c[z>>2]|0)){break}v=+h[n+(((l+1|0)%(p|0)|0)<<3)>>3];w=b+264|0;if(!(q-v<+h[w>>3])){break}e=ww(uw(d)|0)|0;x=re[c[(c[b+540>>2]|0)+104>>2]&63](c[e>>2]|0,o)|0;e=c[o>>2]|0;C=+h[w>>3];w=j;h[k>>3]=v;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=j+8|0;h[k>>3]=q;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[j+16>>2]=p;p=j+20|0;h[k>>3]=C;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[j+28>>2]=x;fw(1,0,e,65312,j);c[s>>2]=1}}while(0);ow(d)}else{c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=0}c[m>>2]=((c[m>>2]|0)+1|0)%(c[z>>2]|0)|0;Ay(b);xy(b);if((a[r]|0)==0){i=g;return}z=b+104|0;m=c[z>>2]|0;do{if((m|0)>0){t=b+340|0;d=b+108|0;s=b+336|0;j=m;o=0;while(1){l=(c[t>>2]|0)+o|0;if((a[l]|0)==0){D=j}else{a[l]=0;l=(c[s>>2]|0)+(o<<3)|0;h[l>>3]=+h[(c[d>>2]|0)+(o*24|0)+16>>3]+ +h[l>>3];D=c[z>>2]|0}l=o+1|0;if((l|0)<(D|0)){j=D;o=l}else{break}}if((D|0)<=0){break}o=b+336|0;j=b+328|0;d=0;do{s=c[o>>2]|0;if((d|0)==0){E=+h[s>>3];F=29}else{q=+h[s+(d<<3)>>3];if(q<+h[j>>3]){E=q;F=29}}if((F|0)==29){F=0;h[j>>3]=E}d=d+1|0;}while((d|0)<(D|0))}}while(0);a[r]=0;r=f+44|0;c[r>>2]=(c[r>>2]|0)+1;i=g;return}function xy(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;gw(27,0,65920,b);d=a+344|0;ie[c[(c[a+540>>2]|0)+92>>2]&63](a,c[d>>2]|0,c[c[a+4>>2]>>2]|0)|0;e=c[a+160>>2]|0;if((e|0)<=0){i=b;return}f=c[d>>2]|0;d=c[a+348>>2]|0;a=0;do{h[d+(a<<3)>>3]=+h[f+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=b;return}function yy(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=a+160|0;p=c[o>>2]|0;q=VZ(p<<3)|0;if((q|0)==0){$a(65736,65568,409,65752)}if((p|0)>0){z_(q|0,c[a+344>>2]|0,((p|0)>1?p<<3:8)|0)|0}r=+h[d>>3];p=n;h[k>>3]=+h[b>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=r;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gw(27,0,65768,n);n=m;h[k>>3]=1.0e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];gw(27,0,65816,m);r=+h[d>>3];s=+h[b>>3];if(!(+U(+(r-s))>1.0e-9)){WZ(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}m=a+4|0;n=a+112|0;p=a+540|0;x=a+344|0;y=a+348|0;z=c[n>>2]|0;A=s;s=r;while(1){r=(s+A)*.5;B=c[c[m>>2]>>2]|0;h[B>>3]=r;if((z|0)>0){C=c[B+8>>2]|0;B=0;do{h[C+(B<<3)>>3]=(+h[e+(B<<3)>>3]+ +h[f+(B<<3)>>3])*.5;B=B+1|0;}while((B|0)<(z|0))}Nz(a)|0;ee[c[(c[p>>2]|0)+40>>2]&127](a)|0;ee[c[(c[p>>2]|0)+28>>2]&127](a)|0;ee[c[(c[p>>2]|0)+32>>2]&127](a)|0;ie[c[(c[p>>2]|0)+92>>2]&63](a,c[x>>2]|0,c[c[m>>2]>>2]|0)|0;B=(zy(a,g,j)|0)==0;C=c[n>>2]|0;D=(C|0)>0;do{if(B){if(D){E=c[(c[c[m>>2]>>2]|0)+8>>2]|0;F=0;do{h[e+(F<<3)>>3]=+h[E+(F<<3)>>3];F=F+1|0;}while((F|0)<(C|0))}h[b>>3]=r;F=c[o>>2]|0;if((F|0)>0){E=c[x>>2]|0;G=c[y>>2]|0;H=0;do{I=E+(H<<3)|0;h[G+(H<<3)>>3]=+h[I>>3];h[I>>3]=+h[q+(H<<3)>>3];H=H+1|0;}while((H|0)<(F|0))}J=+h[d>>3]}else{if(D){F=c[(c[c[m>>2]>>2]|0)+8>>2]|0;H=0;do{h[f+(H<<3)>>3]=+h[F+(H<<3)>>3];H=H+1|0;}while((H|0)<(C|0))}h[d>>3]=r;H=c[o>>2]|0;if((H|0)<=0){J=r;break}z_(q|0,c[x>>2]|0,((H|0)>1?H<<3:8)|0)|0;J=r}}while(0);r=+h[b>>3];if(+U(+(J-r))>1.0e-9){z=C;A=r;s=J}else{break}}WZ(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}function zy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;ow(b);gw(27,0,65840,g);g=uw(d)|0;if((g|0)==0){j=rw(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}d=a+344|0;m=a+348|0;a=g;do{g=ww(a)|0;if(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){g=ww(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==1.0){n=7}else{n=5}}else{n=5}do{if((n|0)==5){n=0;g=ww(a)|0;if(!(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==1.0)){break}g=ww(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){n=7}}}while(0);if((n|0)==7){n=0;g=ww(a)|0;o=c[g>>2]|0;g=ww(a)|0;p=+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]>0.0?65256:65264;g=ww(a)|0;q=+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]>0.0?65256:65264;c[f>>2]=o;c[f+4>>2]=p;c[f+8>>2]=q;gw(27,0,65880,f);pw(b,ww(a)|0)}a=vw(a)|0;}while((a|0)!=0);j=rw(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}function Ay(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+8|0;e=d;f=b+315|0;a[f]=0;g=b+540|0;re[c[(c[g>>2]|0)+96>>2]&63](b,1)|0;By(b);Cy(b);ee[c[(c[g>>2]|0)+36>>2]&127](b)|0;Dy(b,8);h=Ey(b)|0;j=ee[c[(c[g>>2]|0)+100>>2]&127](b)|0;k=b+312|0;if((a[k]|0)==0){l=1;m=j;n=h}else{Cy(b);i=d;return}while(1){if((m|0)==0){if((a[f]|n)<<24>>24==0){o=7;break}}Fy(b);By(b);Dy(b,8);ee[c[(c[g>>2]|0)+36>>2]&127](b)|0;if((l|0)>200){o=5;break}h=Ey(b)|0;j=ee[c[(c[g>>2]|0)+100>>2]&127](b)|0;if((a[k]|0)==0){l=l+1|0;m=j;n=h}else{o=7;break}}if((o|0)==5){kw(c[b+536>>2]|0,65960,e)}else if((o|0)==7){Cy(b);i=d;return}}function By(a){a=a|0;var b=0;b=i;z_(c[a+356>>2]|0,c[a+352>>2]|0,c[a+164>>2]|0)|0;i=b;return}function Cy(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+164|0;if((c[e>>2]|0)<=0){i=d;return}f=b+352|0;g=b+360|0;b=0;do{a[(c[g>>2]|0)+b|0]=(a[(c[f>>2]|0)+b|0]|0)!=0|0;b=b+1|0;}while((b|0)<(c[e>>2]|0));i=d;return}function Dy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+8|0;if((c[35584+(d<<2)>>2]|0)==0){i=e;return}gw(d,1,66384,g);g=b+164|0;if((c[g>>2]|0)>0){h=b+540|0;j=b+352|0;k=b+356|0;b=0;do{l=ee[c[(c[h>>2]|0)+108>>2]&127](b)|0;m=(a[(c[j>>2]|0)+b|0]|0)!=0?84:70;n=ee[c[(c[h>>2]|0)+108>>2]&127](b)|0;o=(a[(c[k>>2]|0)+b|0]|0)!=0?84:70;c[f>>2]=b;c[f+4>>2]=l;c[f+8>>2]=m;c[f+12>>2]=n;c[f+16>>2]=o;gw(d,0,66408,f);b=b+1|0;}while((b|0)<(c[g>>2]|0))}be[c[9034]&255](d);i=e;return}function Ey(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+164>>2]|0;if((e|0)<=0){f=0;i=d;return f|0}g=c[b+356>>2]|0;h=c[b+352>>2]|0;b=0;while(1){j=b+1|0;if((a[g+b|0]|0)!=(a[h+b|0]|0)){f=1;k=5;break}if((j|0)<(e|0)){b=j}else{f=0;k=5;break}}if((k|0)==5){i=d;return f|0}return 0}function Fy(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;z_(c[a+400>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;z_(c[a+404>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;z_(c[a+408>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;z_(c[a+412>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function Gy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+160>>2]|0;e=c[a+344>>2]|0;if((d|0)>0){f=c[a+348>>2]|0;g=0;do{h[f+(g<<3)>>3]=+h[e+(g<<3)>>3];g=g+1|0;}while((g|0)<(d|0))}ie[c[(c[a+540>>2]|0)+92>>2]&63](a,e,c[c[a+4>>2]>>2]|0)|0;i=b;return}function Hy(a){a=a|0;var b=0;b=i;Iy(a);Jy(a);Fy(a);Ky(a);i=b;return}function Iy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+136>>2]|0;if((e|0)>0){f=c[b+24>>2]|0;g=c[b+416>>2]|0;j=0;do{h[g+(j<<3)>>3]=+h[f+(j*112|0)+96>>3];j=j+1|0;}while((j|0)<(e|0))}e=b+140|0;if((c[e>>2]|0)>0){j=c[b+28>>2]|0;f=c[b+420>>2]|0;g=0;do{c[f+(g<<2)>>2]=c[j+(g*60|0)+52>>2];g=g+1|0;}while((g|0)<(c[e>>2]|0))}e=b+144|0;if((c[e>>2]|0)>0){g=b+32|0;j=b+424|0;f=0;do{a[(c[j>>2]|0)+f|0]=a[(c[g>>2]|0)+(f*48|0)+42|0]|0;f=f+1|0;}while((f|0)<(c[e>>2]|0))}e=c[b+148>>2]|0;if((e|0)<=0){i=d;return}f=b+36|0;g=b+428|0;b=0;do{c[(c[g>>2]|0)+(b<<2)>>2]=c[(c[f>>2]|0)+(b*52|0)+44>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function Jy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[b+8>>2]|0;j=c[e+8>>2]|0;k=0;do{h[j+(k<<3)>>3]=+h[g+(k*112|0)+96>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[b+12>>2]|0;g=c[e+12>>2]|0;j=0;do{c[g+(j<<2)>>2]=c[k+(j*60|0)+52>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=b+16|0;k=e+16|0;g=0;do{a[(c[k>>2]|0)+g|0]=a[(c[j>>2]|0)+(g*48|0)+42|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=b+20|0;b=e+20|0;e=0;do{c[(c[b>>2]|0)+(e<<2)>>2]=c[(c[g>>2]|0)+(e*52|0)+44>>2];e=e+1|0;}while((e|0)<(f|0));i=d;return}function Ky(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((Zw(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=a+ -1|0;m=c[e>>2]|0;n=c[m+(l<<2)>>2]|0;o=c[m+(a<<2)>>2]|0;h[o>>3]=+h[n>>3];z_(c[o+8>>2]|0,c[n+8>>2]|0,c[f>>2]<<3|0)|0;n=c[e>>2]|0;z_(c[(c[n+(a<<2)>>2]|0)+12>>2]|0,c[(c[n+(l<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;n=c[e>>2]|0;z_(c[(c[n+(a<<2)>>2]|0)+16>>2]|0,c[(c[n+(l<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;n=c[e>>2]|0;z_(c[(c[n+(a<<2)>>2]|0)+20>>2]|0,c[(c[n+(l<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(Zw(c[d>>2]|0)|0));i=b;return}function Ly(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[35584+(d<<2)>>2]|0)==0){i=e;return}gw(d,1,66056,q);q=b+136|0;if((c[q>>2]|0)>0){gw(d,1,66080,p);if((c[q>>2]|0)>0){p=b+24|0;r=b+416|0;s=0;while(1){t=s+1|0;u=c[p>>2]|0;v=c[u+(s*112|0)+4>>2]|0;w=+h[u+(s*112|0)+96>>3];x=(a[u+(s*112|0)+72|0]|0)!=0?66040:66048;y=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=t;c[o+4>>2]=v;v=o+8|0;h[k>>3]=w;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[o+16>>2]=x;x=o+20|0;h[k>>3]=y;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];gw(d,0,66096,o);if((t|0)<(c[q>>2]|0)){s=t}else{break}}}be[c[9034]&255](d)}s=b+140|0;if((c[s>>2]|0)>0){gw(d,1,66152,n);if((c[s>>2]|0)>0){n=b+28|0;q=b+420|0;o=0;while(1){r=o+1|0;p=c[n>>2]|0;t=c[p+(o*60|0)+4>>2]|0;x=c[p+(o*60|0)+52>>2]|0;v=(a[p+(o*60|0)+48|0]|0)!=0?66040:66048;p=c[(c[q>>2]|0)+(o<<2)>>2]|0;c[m>>2]=r;c[m+4>>2]=t;c[m+8>>2]=x;c[m+12>>2]=v;c[m+16>>2]=p;gw(d,0,66176,m);if((r|0)<(c[s>>2]|0)){o=r}else{break}}}be[c[9034]&255](d)}o=b+144|0;if((c[o>>2]|0)>0){gw(d,1,66232,l);if((c[o>>2]|0)>0){l=b+32|0;s=b+424|0;m=0;while(1){q=m+1|0;n=c[l>>2]|0;r=c[n+(m*48|0)+4>>2]|0;p=(a[n+(m*48|0)+42|0]|0)!=0?66040:66048;v=(a[n+(m*48|0)+40|0]|0)!=0?66040:66048;n=(a[(c[s>>2]|0)+m|0]|0)!=0?66040:66048;c[j>>2]=q;c[j+4>>2]=r;c[j+8>>2]=p;c[j+12>>2]=v;c[j+16>>2]=n;gw(d,0,66256,j);if((q|0)<(c[o>>2]|0)){m=q}else{break}}}be[c[9034]&255](d)}m=b+148|0;if((c[m>>2]|0)>0){gw(d,1,66312,g);if((c[m>>2]|0)>0){g=b+36|0;o=b+428|0;b=0;while(1){j=b+1|0;s=c[g>>2]|0;l=c[s+(b*52|0)+4>>2]|0;q=c[s+(b*52|0)+44>>2]|0;s=c[(c[o>>2]|0)+(b<<2)>>2]|0;c[f>>2]=j;c[f+4>>2]=l;c[f+8>>2]=q;c[f+12>>2]=s;gw(d,0,66336,f);if((j|0)<(c[m>>2]|0)){b=j}else{break}}}be[c[9034]&255](d)}be[c[9034]&255](d);i=e;return}function My(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((Zw(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=c[e>>2]|0;m=c[l+(a<<2)>>2]|0;n=a+ -1|0;o=c[l+(n<<2)>>2]|0;h[o>>3]=+h[m>>3];z_(c[o+8>>2]|0,c[m+8>>2]|0,c[f>>2]<<3|0)|0;m=c[e>>2]|0;z_(c[(c[m+(n<<2)>>2]|0)+12>>2]|0,c[(c[m+(a<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;m=c[e>>2]|0;z_(c[(c[m+(n<<2)>>2]|0)+16>>2]|0,c[(c[m+(a<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;m=c[e>>2]|0;z_(c[(c[m+(n<<2)>>2]|0)+20>>2]|0,c[(c[m+(a<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(Zw(c[d>>2]|0)|0));i=b;return}function Ny(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[e+8>>2]|0;j=c[b+8>>2]|0;k=0;do{h[j+(k*112|0)+96>>3]=+h[g+(k<<3)>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[e+12>>2]|0;g=c[b+12>>2]|0;j=0;do{c[g+(j*60|0)+52>>2]=c[k+(j<<2)>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=e+16|0;k=b+16|0;g=0;do{a[(c[k>>2]|0)+(g*48|0)+42|0]=a[(c[j>>2]|0)+g|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=e+20|0;e=b+20|0;b=0;do{c[(c[e>>2]|0)+(b*52|0)+44>>2]=c[(c[g>>2]|0)+(b<<2)>>2];b=b+1|0;}while((b|0)<(f|0));i=d;return}function Oy(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;h[a+376>>3]=+h[d>>3];z_(c[a+384>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;z_(c[a+388>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;z_(c[a+392>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;z_(c[a+396>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function Py(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+32|0;o=b;c[o>>2]=0;p=Uw(3,32)|0;c[o>>2]=p;if((p|0)==0){kw(c[b+536>>2]|0,66440,m)}m=n;p=b+116|0;q=n+8|0;r=b+536|0;s=b+124|0;t=n+12|0;u=b+128|0;v=n+16|0;w=b+132|0;x=n+20|0;y=n;n=0;do{h[m>>3]=0.0;z=XZ(c[p>>2]|0,8)|0;c[q>>2]=z;jw(c[r>>2]|0,(z|0)!=0|0,66496,l);z=XZ(c[s>>2]|0,4)|0;c[t>>2]=z;jw(c[r>>2]|0,(z|0)!=0|0,66496,k);z=XZ(c[u>>2]|0,1)|0;c[v>>2]=z;jw(c[r>>2]|0,(z|0)!=0|0,66496,j);z=XZ(c[w>>2]|0,4)|0;c[x>>2]=z;jw(c[r>>2]|0,(z|0)!=0|0,66496,g);Yw(c[o>>2]|0,y);n=n+1|0;}while(n>>>0<3);n=XZ(3,4)|0;c[b+4>>2]=n;_w(c[o>>2]|0,0,n);c[b+8>>2]=XZ(c[p>>2]|0,112)|0;c[b+12>>2]=XZ(c[s>>2]|0,60)|0;c[b+16>>2]=XZ(c[u>>2]|0,48)|0;c[b+20>>2]=XZ(c[w>>2]|0,52)|0;n=b+136|0;c[b+24>>2]=XZ(c[n>>2]|0,112)|0;o=c[b+140>>2]|0;c[b+28>>2]=XZ(o,60)|0;y=c[b+144>>2]|0;c[b+32>>2]=XZ(y,48)|0;g=c[b+148>>2]|0;c[b+36>>2]=XZ(g,52)|0;c[b+40>>2]=XZ(c[b+216>>2]|0,52)|0;c[b+44>>2]=XZ(c[b+220>>2]|0,52)|0;c[b+48>>2]=XZ(c[b+224>>2]|0,52)|0;c[b+52>>2]=XZ(c[b+228>>2]|0,52)|0;x=c[b+104>>2]|0;c[b+108>>2]=XZ(x,24)|0;h[b+328>>3]=+h[b+240>>3];c[b+336>>2]=XZ(x,8)|0;c[b+340>>2]=XZ(x,1)|0;c[b+300>>2]=1;c[b+292>>2]=1;c[b+296>>2]=1;x=c[b+160>>2]|0;c[b+344>>2]=XZ(x,8)|0;c[b+348>>2]=XZ(x,8)|0;j=c[b+164>>2]|0;c[b+352>>2]=XZ(j,1)|0;c[b+356>>2]=XZ(j,1)|0;c[b+360>>2]=XZ(j,1)|0;j=VZ(x<<2)|0;c[b+368>>2]=j;c[b+364>>2]=VZ(c[b+168>>2]<<3)|0;if((x|0)!=0){v=0;do{c[j+(v<<2)>>2]=v;v=v+1|0;}while(v>>>0<x>>>0)}x=c[p>>2]|0;c[b+384>>2]=XZ(x,8)|0;p=c[s>>2]|0;c[b+388>>2]=XZ(p,4)|0;s=c[u>>2]|0;c[b+392>>2]=XZ(s,1)|0;u=c[w>>2]|0;c[b+396>>2]=XZ(u,4)|0;c[b+400>>2]=XZ(x,8)|0;c[b+404>>2]=XZ(p,4)|0;c[b+408>>2]=XZ(s,1)|0;c[b+412>>2]=XZ(u,4)|0;c[b+416>>2]=XZ(c[n>>2]|0,8)|0;c[b+420>>2]=XZ(o,4)|0;c[b+424>>2]=XZ(y,1)|0;c[b+428>>2]=XZ(g,4)|0;c[b+432>>2]=XZ(c[b+152>>2]|0,8)|0;c[b+436>>2]=XZ(c[b+156>>2]|0,8)|0;g=VZ((c[b+192>>2]|0)*40|0)|0;c[b+484>>2]=g;y=b+540|0;be[c[(c[y>>2]|0)+20>>2]&255](g);g=VZ((c[b+196>>2]|0)*80|0)|0;c[b+476>>2]=g;be[c[(c[y>>2]|0)+16>>2]&255](g);g=VZ((c[b+200>>2]|0)*80|0)|0;c[b+468>>2]=g;be[c[(c[y>>2]|0)+12>>2]&255](g);g=VZ((c[b+204>>2]|0)*48|0)|0;c[b+488>>2]=g;ce[c[(c[y>>2]|0)+24>>2]&127](g,b);c[b+464>>2]=VZ((c[b+232>>2]|0)*44|0)|0;c[b+76>>2]=0;c[b+80>>2]=0;g=XZ(c[b+188>>2]|0,4)|0;c[b+320>>2]=g;jw(c[r>>2]|0,(g|0)!=0|0,66512,f);c[b+512>>2]=100;c[b+516>>2]=XZ(100,4)|0;c[b+520>>2]=XZ(100,8)|0;c[b+524>>2]=0;c[b+528>>2]=0;c[b+532>>2]=0;h[b+304>>3]=1.0;a[b+313|0]=0;a[b+312|0]=0;a[b+314|0]=0;f=b+172|0;g=b+316|0;a[g]=0;a[g+1|0]=0;a[g+2|0]=0;a[g+3|0]=0;g=VZ(c[f>>2]<<2)|0;y=b+504|0;c[y>>2]=g;jw(c[r>>2]|0,(g|0)!=0|0,66496,e);if((c[f>>2]|0)==0){i=d;return}else{A=0}do{e=Uw(1024,16)|0;c[(c[y>>2]|0)+(A<<2)>>2]=e;A=A+1|0;}while(A>>>0<(c[f>>2]|0)>>>0);i=d;return}function Qy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;d=a+4|0;e=c[d>>2]|0;f=0;do{g=c[e+(f<<2)>>2]|0;WZ(c[g+8>>2]|0);WZ(c[g+12>>2]|0);WZ(c[g+16>>2]|0);WZ(c[g+20>>2]|0);f=f+1|0;e=c[d>>2]|0}while(f>>>0<3);WZ(e);Vw(c[a>>2]|0);e=a+116|0;f=a+8|0;d=c[f>>2]|0;if((c[e>>2]|0)==0){h=d}else{g=d;d=0;while(1){px(g+(d*112|0)|0);j=d+1|0;k=c[f>>2]|0;if(j>>>0<(c[e>>2]|0)>>>0){d=j;g=k}else{h=k;break}}}WZ(h);h=a+124|0;g=a+12|0;d=c[g>>2]|0;if((c[h>>2]|0)==0){l=d}else{e=d;d=0;while(1){px(e+(d*60|0)|0);f=d+1|0;k=c[g>>2]|0;if(f>>>0<(c[h>>2]|0)>>>0){d=f;e=k}else{l=k;break}}}WZ(l);l=a+128|0;e=a+16|0;d=c[e>>2]|0;if((c[l>>2]|0)==0){m=d}else{h=d;d=0;while(1){px(h+(d*48|0)|0);g=d+1|0;k=c[e>>2]|0;if(g>>>0<(c[l>>2]|0)>>>0){d=g;h=k}else{m=k;break}}}WZ(m);m=a+132|0;h=a+20|0;d=c[h>>2]|0;if((c[m>>2]|0)==0){n=d}else{l=d;d=0;while(1){px(l+(d*52|0)|0);e=d+1|0;k=c[h>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){d=e;l=k}else{n=k;break}}}WZ(n);n=a+136|0;l=a+24|0;d=c[l>>2]|0;if((c[n>>2]|0)==0){o=d}else{m=d;d=0;while(1){px(m+(d*112|0)|0);h=d+1|0;k=c[l>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){d=h;m=k}else{o=k;break}}}WZ(o);o=a+140|0;m=a+28|0;d=c[m>>2]|0;if((c[o>>2]|0)==0){p=d}else{n=d;d=0;while(1){px(n+(d*60|0)|0);l=d+1|0;k=c[m>>2]|0;if(l>>>0<(c[o>>2]|0)>>>0){d=l;n=k}else{p=k;break}}}WZ(p);p=a+144|0;n=a+32|0;d=c[n>>2]|0;if((c[p>>2]|0)==0){q=d}else{o=d;d=0;while(1){px(o+(d*48|0)|0);m=d+1|0;k=c[n>>2]|0;if(m>>>0<(c[p>>2]|0)>>>0){d=m;o=k}else{q=k;break}}}WZ(q);q=a+148|0;o=a+36|0;d=c[o>>2]|0;if((c[q>>2]|0)==0){r=d}else{p=d;d=0;while(1){px(p+(d*52|0)|0);n=d+1|0;k=c[o>>2]|0;if(n>>>0<(c[q>>2]|0)>>>0){d=n;p=k}else{r=k;break}}}WZ(r);r=a+216|0;p=a+40|0;d=c[p>>2]|0;if((c[r>>2]|0)==0){s=d}else{q=d;d=0;while(1){px(q+(d*52|0)+12|0);o=d+1|0;k=c[p>>2]|0;if(o>>>0<(c[r>>2]|0)>>>0){d=o;q=k}else{s=k;break}}}WZ(s);s=a+220|0;q=a+44|0;d=c[q>>2]|0;if((c[s>>2]|0)==0){t=d}else{r=d;d=0;while(1){px(r+(d*52|0)+12|0);p=d+1|0;k=c[q>>2]|0;if(p>>>0<(c[s>>2]|0)>>>0){d=p;r=k}else{t=k;break}}}WZ(t);t=a+224|0;r=a+48|0;d=c[r>>2]|0;if((c[t>>2]|0)==0){u=d}else{s=d;d=0;while(1){px(s+(d*52|0)+12|0);q=d+1|0;k=c[r>>2]|0;if(q>>>0<(c[t>>2]|0)>>>0){d=q;s=k}else{u=k;break}}}WZ(u);u=a+228|0;s=a+52|0;d=c[s>>2]|0;if((c[u>>2]|0)==0){v=d}else{t=d;d=0;while(1){px(t+(d*52|0)+12|0);r=d+1|0;k=c[s>>2]|0;if(r>>>0<(c[u>>2]|0)>>>0){d=r;t=k}else{v=k;break}}}WZ(v);WZ(c[a+108>>2]|0);WZ(c[a+336>>2]|0);WZ(c[a+340>>2]|0);WZ(c[a+344>>2]|0);WZ(c[a+348>>2]|0);WZ(c[a+352>>2]|0);WZ(c[a+356>>2]|0);WZ(c[a+360>>2]|0);WZ(c[a+368>>2]|0);WZ(c[a+384>>2]|0);WZ(c[a+388>>2]|0);WZ(c[a+392>>2]|0);WZ(c[a+396>>2]|0);WZ(c[a+400>>2]|0);WZ(c[a+404>>2]|0);WZ(c[a+408>>2]|0);WZ(c[a+412>>2]|0);WZ(c[a+416>>2]|0);WZ(c[a+420>>2]|0);WZ(c[a+424>>2]|0);WZ(c[a+428>>2]|0);WZ(c[a+488>>2]|0);WZ(c[a+484>>2]|0);WZ(c[a+476>>2]|0);WZ(c[a+468>>2]|0);WZ(c[a+464>>2]|0);WZ(c[a+432>>2]|0);WZ(c[a+436>>2]|0);WZ(c[a+320>>2]|0);WZ(c[a+516>>2]|0);WZ(c[a+520>>2]|0);nN(a+56|0);v=a+172|0;t=a+504|0;a=c[t>>2]|0;if((c[v>>2]|0)==0){w=a;x=w;WZ(x);i=b;return}else{y=a;z=0}while(1){Vw(c[y+(z<<2)>>2]|0);a=z+1|0;d=c[t>>2]|0;if(a>>>0<(c[v>>2]|0)>>>0){z=a;y=d}else{w=d;break}}x=w;WZ(x);i=b;return}function Ry(a){a=+a;var b=0,d=0,e=0.0,f=0;b=i;i=i+8|0;d=b;e=a*1.0e-4;h[8319]=e;f=d;h[k>>3]=e;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];gw(8,0,66560,d);i=b;return}function Sy(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;d=c<<24>>24!=0;e=+h[8319];f=e+e*+U(+(d?b:a));if(d){g=f}else{g=-f}i=i;return a-b<=g|0}function Ty(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0;d=i;e=(Sy(a,b,c<<24>>24==0|0)|0)<<24>>24==0|0;i=d;return e|0}function Uy(a,b){a=+a;b=+b;i=i;return a<b|0}function Vy(a,b){a=+a;b=+b;i=i;return a<=b|0}function Wy(a,b){a=+a;b=+b;i=i;return a>=b|0}function Xy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){j=c[e+(h*40|0)>>2]|0;k=j<<2;c[e+(h*40|0)+20>>2]=VZ(k)|0;c[e+(h*40|0)+24>>2]=VZ(k)|0;if((c[g>>2]|0)!=1){l=5;break}_y(j,e+(h*40|0)+28|0)|0;j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{l=6;break}}if((l|0)==5){kw(c[a+536>>2]|0,66616,d)}else if((l|0)==6){i=b;return 0}return 0}function Yy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){WZ(c[e+(h*40|0)+20>>2]|0);WZ(c[e+(h*40|0)+24>>2]|0);if((c[g>>2]|0)!=1){j=5;break}k=e+(h*40|0)+28|0;$y(k)|0;WZ(c[k>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{j=6;break}}if((j|0)==5){kw(c[a+536>>2]|0,66616,d)}else if((j|0)==6){i=b;return 0}return 0}function Zy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+484>>2]|0;o=b+192|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+4|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p*40|0)+36|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[35652>>2]|c[8894]|0)==0){z=w;A=1;break}lN(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];iw(17,1,66648,g);lN(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;lN(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;iw(17,0,66680,f);lN(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}be[c[9034]&255](17);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function _y(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=VZ(20)|0;c[b>>2]=f;jw(0,(f|0)!=0|0,66688,e);e=VZ(a)|0;c[f>>2]=e;e=VZ(a)|0;c[f+4>>2]=e;e=VZ(a)|0;c[f+8>>2]=e;e=VZ(a)|0;c[f+16>>2]=e;jw(0,(c[b>>2]|0)!=0|0,66720,d);i=d;return 0}function $y(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;WZ(c[d>>2]|0);WZ(c[d+4>>2]|0);WZ(c[d+8>>2]|0);WZ(c[d+16>>2]|0);i=b;return 0}function az(a,b){a=a|0;b=b|0;b=i;i=i+8|0;kw(c[a+536>>2]|0,66768,b);return 0}function bz(a){a=a|0;a=i;i=i+8|0;kw(0,66768,a);return 0}function cz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){j=c[e+(h<<6)+16>>2]|0;k=c[e+(h<<6)+12>>2]|0;l=j<<3;c[e+(h<<6)+28>>2]=VZ(l)|0;c[e+(h<<6)+36>>2]=VZ(l)|0;m=c[g>>2]|0;if((m|0)==2){c[e+(h<<6)+8>>2]=2;lz(j,j,k,e+(h<<6)+24|0)|0}else if((m|0)==1){c[e+(h<<6)+32>>2]=VZ(fa(l,j)|0)|0;c[e+(h<<6)+8>>2]=1;iz(j,e+(h<<6)+24|0)|0}else{n=6;break}j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{n=8;break}}if((n|0)==6){kw(c[a+536>>2]|0,66808,d)}else if((n|0)==8){i=b;return 0}return 0}function dz(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=(fa(c[f+16>>2]|0,b)|0)+a|0;h[(c[f+32>>2]|0)+(e<<3)>>3]=d;i=i;return}function ez(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=i;sb(0,a|0,b|0,+d,c[c[f+24>>2]>>2]|0)|0;i=e;return}function fz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){WZ(c[e+(h<<6)+28>>2]|0);WZ(c[e+(h<<6)+36>>2]|0);j=c[g>>2]|0;if((j|0)==1){jz(e+(h<<6)+24|0)|0;WZ(c[e+(h<<6)+32>>2]|0)}else if((j|0)==2){mz(e+(h<<6)+24|0)|0}else{k=6;break}WZ(c[e+(h<<6)+24>>2]|0);j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{k=8;break}}if((k|0)==6){kw(c[a+536>>2]|0,66808,d)}else if((k|0)==8){i=b;return 0}return 0}function gz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[b+476>>2]|0;h=c[b+292>>2]|0;if((h|0)==1){j=kz(b,d)|0}else if((h|0)==2){j=nz(b,d)|0}else{kw(c[b+536>>2]|0,66808,f)}a[g+(d<<6)+56|0]=j;i=e;return 0}function hz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+476>>2]|0;o=b+196|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+20|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p<<6)+56|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[35644>>2]|c[8894]|0)==0){z=w;A=1;break}lN(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];iw(15,1,66840,g);lN(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;lN(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;iw(15,0,66872,f);lN(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}be[c[9034]&255](15);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function iz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=VZ(12)|0;f=VZ(a<<2)|0;c[e>>2]=f;jw(0,(f|0)!=0|0,66880,d);c[e+4>>2]=1;c[e+8>>2]=0;c[b>>2]=e;i=d;return 0}function jz(a){a=a|0;var b=0;b=i;WZ(c[c[a>>2]>>2]|0);i=b;return 0}function kz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16384|0;v=i;i=i+4096|0;w=c[b+476>>2]|0;x=w+(d<<6)|0;y=c[w+(d<<6)+24>>2]|0;z=w+(d<<6)+16|0;A=c[z>>2]|0;B=w+(d<<6)+32|0;B_(c[B>>2]|0,0,fa(A<<3,A)|0)|0;C=b;D=x;ce[c[x>>2]&127](C,D);ce[c[w+(d<<6)+4>>2]&127](C,D);if((c[35648>>2]|0)!=0){D=u;c[t>>2]=A;c[t+4>>2]=A;gw(16,1,66936,t);t=(A|0)>0;do{if(t){u=0;do{a[D]=0;C=0;do{x=(fa(C,A)|0)+u|0;E=+h[(c[B>>2]|0)+(x<<3)>>3];c[r>>2]=D;x=r+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];dc(D|0,66960,r|0)|0;C=C+1|0;}while((C|0)<(A|0));c[q>>2]=D;gw(16,0,66976,q);u=u+1|0;}while((u|0)<(A|0));c[p>>2]=A;gw(16,1,66984,p);if(!t){break}u=w+(d<<6)+36|0;C=0;do{a[D]=0;E=+h[(c[u>>2]|0)+(C<<3)>>3];c[o>>2]=D;x=o+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];dc(D|0,66960,o|0)|0;c[n>>2]=D;gw(16,0,66976,n);C=C+1|0;}while((C|0)<(A|0))}else{c[s>>2]=A;gw(16,1,66984,s)}}while(0);be[c[9034]&255](16)}s=w+(d<<6)+36|0;A=y+8|0;$q(z,y+4|0,c[B>>2]|0,z,c[y>>2]|0,c[s>>2]|0,z,A)|0;y=c[A>>2]|0;if((y|0)<0){E=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[w+(d<<6)+20>>2];A=m+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];c[m+12>>2]=y;iw(1,0,67e3,m);F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;z_(M|0,O|0,Q|0)|0;i=e;return F|0}if((y|0)<=0){F=1;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;z_(M|0,O|0,Q|0)|0;i=e;return F|0}E=+h[c[c[b+4>>2]>>2]>>3];b=y+1|0;c[l>>2]=c[w+(d<<6)+20>>2];y=l+4|0;h[k>>3]=E;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[l+12>>2]=b;c[l+16>>2]=b;iw(1,0,67088,l);if((c[35644>>2]|0)==0){F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;z_(M|0,O|0,Q|0)|0;i=e;return F|0}l=v;v=(c[z>>2]|0)>0;a[l]=0;if(v){v=0;do{b=c[z>>2]|0;if((b|0)>0){y=b;m=0;while(1){A=(fa(y,m)|0)+v|0;E=+h[(c[B>>2]|0)+(A<<3)>>3];c[j>>2]=l;A=j+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];dc(l|0,67192,j|0)|0;A=m+1|0;n=c[z>>2]|0;if((A|0)<(n|0)){m=A;y=n}else{R=n;break}}}else{R=b}v=v+1|0;a[l]=0}while((v|0)<(R|0))}if((c[z>>2]|0)>0){R=0;do{E=+h[(c[s>>2]|0)+(R<<3)>>3];c[g>>2]=l;v=g+4|0;h[k>>3]=E;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];dc(l|0,67192,g|0)|0;R=R+1|0;}while((R|0)<(c[z>>2]|0))}a[l]=0;if((c[z>>2]|0)>0){S=0}else{F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;z_(M|0,O|0,Q|0)|0;i=e;return F|0}while(1){E=+h[(c[s>>2]|0)+(S<<3)>>3];c[f>>2]=l;R=f+4|0;h[k>>3]=E;c[R>>2]=c[k>>2];c[R+4>>2]=c[k+4>>2];dc(l|0,67192,f|0)|0;R=S+1|0;if((R|0)<(c[z>>2]|0)){S=R}else{F=0;break}}G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;z_(M|0,O|0,Q|0)|0;i=e;return F|0}function lz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=VZ(32)|0;jw(0,(g|0)!=0|0,67200,f);c[g+20>>2]=b;b=g+24|0;c[b>>2]=a;c[g+28>>2]=d;d=g+8|0;Ud(0,d|0)|0;Jd(c[d>>2]|0,c[b>>2]|0,0)|0;Ud(0,g+4|0)|0;Jd(c[d>>2]|0,c[b>>2]|0,0)|0;b=g+12|0;_a(b|0)|0;Hb(67248,c[b>>2]|0)|0;c[e>>2]=g;i=f;return 0}function mz(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;vd(c[d+12>>2]|0)|0;Gb(c[d+8>>2]|0)|0;Gb(c[d+4>>2]|0)|0;i=b;return 0}function nz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[a+476>>2]|0;f=e+(b<<6)|0;g=c[e+(b<<6)+24>>2]|0;id(c[g>>2]|0)|0;Qd(0,g|0)|0;j=g+24|0;Lb(c[g>>2]|0,c[j>>2]|0,0)|0;k=a;a=f;ce[c[f>>2]&127](k,a);Sc(c[g>>2]|0,1)|0;Ra(c[g>>2]|0)|0;ce[c[e+(b<<6)+4>>2]&127](k,a);if((c[j>>2]|0)>0){a=e+(b<<6)+36|0;k=g+8|0;f=k;l=0;while(1){dd(0,l|0,+(+h[(c[a>>2]|0)+(l<<3)>>3]),c[k>>2]|0)|0;m=l+1|0;if((m|0)<(c[j>>2]|0)){l=m}else{n=f;break}}}else{n=g+8|0}f=g+4|0;l=(ic(c[g>>2]|0,c[n>>2]|0,c[f>>2]|0,c[g+12>>2]|0)|0)==0|0;cb(c[f>>2]|0,0,c[g+20>>2]|0,c[e+(b<<6)+28>>2]|0)|0;id(c[g>>2]|0)|0;i=d;return l|0}function oz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=c[a+468>>2]|0;h=a+200|0;if((c[h>>2]|0)<=0){i=b;return 0}j=a+536|0;k=a;l=a+300|0;m=0;a:while(1){n=g+(m*80|0)|0;o=c[n>>2]|0;jw(c[j>>2]|0,(c[g+(m*80|0)+32>>2]|0)!=0|0,67416,f);p=g+(m*80|0)+28|0;do{if(!((c[p>>2]|0)==-1)){jw(c[j>>2]|0,(c[g+(m*80|0)+20>>2]|0)!=0|0,67456,e);if((ee[c[g+(m*80|0)+24>>2]&127](k)|0)==0){break}c[p>>2]=-1}}while(0);p=o<<3;c[g+(m*80|0)+44>>2]=VZ(p)|0;c[g+(m*80|0)+52>>2]=VZ(p)|0;c[g+(m*80|0)+48>>2]=VZ(p)|0;c[g+(m*80|0)+16>>2]=VZ(p)|0;c[g+(m*80|0)+8>>2]=VZ(p)|0;c[g+(m*80|0)+12>>2]=VZ(p)|0;ce[c[g+(m*80|0)+36>>2]&127](k,n);do{if((c[g+(m*80|0)+56>>2]|0)==1){tz(o,g+(m*80|0)+40|0)|0}else{p=c[l>>2]|0;if((p|0)==2){az(a,n)|0;break}else if((p|0)==3){tz(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==1){rz(o,g+(m*80|0)+40|0)|0;break}else{q=12;break a}}}while(0);o=m+1|0;if((o|0)<(c[h>>2]|0)){m=o}else{q=14;break}}if((q|0)==12){kw(c[j>>2]|0,67496,d)}else if((q|0)==14){i=b;return 0}return 0}function pz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+468>>2]|0;f=a+200|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+300|0;h=0;a:while(1){j=e+(h*80|0)|0;WZ(c[e+(h*80|0)+44>>2]|0);WZ(c[e+(h*80|0)+52>>2]|0);WZ(c[e+(h*80|0)+48>>2]|0);WZ(c[e+(h*80|0)+16>>2]|0);WZ(c[e+(h*80|0)+8>>2]|0);WZ(c[e+(h*80|0)+12>>2]|0);do{if((c[e+(h*80|0)+56>>2]|0)==1){k=e+(h*80|0)+40|0;uz(k)|0;l=k}else{k=c[g>>2]|0;if((k|0)==3){m=e+(h*80|0)+40|0;uz(m)|0;l=m;break}else if((k|0)==1){m=e+(h*80|0)+40|0;sz(m)|0;l=m;break}else if((k|0)==2){n=7;break a}else{n=9;break a}}}while(0);WZ(c[l>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{n=11;break}}if((n|0)==7){bz(j)|0}else if((n|0)==9){kw(c[a+536>>2]|0,67496,d)}else if((n|0)==11){i=b;return 0}return 0}function qz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=c[b+468>>2]|0;v=c[b+200>>2]|0;if((v|0)>0){w=0}else{x=0;i=e;return x|0}while(1){y=w+1|0;if((a[u+(w*80|0)+72|0]|0)==0){break}if((y|0)<(v|0)){w=y}else{x=0;z=22;break}}if((z|0)==22){i=e;return x|0}v=u+(w*80|0)+4|0;w=c[v>>2]|0;u=n;c[u>>2]=1;c[n+4>>2]=w;if((d|0)==0){x=1;i=e;return x|0}d=b+56|0;lN(o,d,w);A=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[o+8>>2];o=m+4|0;h[k>>3]=A;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];hw(17,1,u,67528,m);do{if((a[b+312|0]|0)==0){lN(s,d,c[v>>2]|0);m=s+12|0;if((c[m>>2]|0)<=0){break}u=t+16|0;o=0;while(1){w=o+1|0;lN(t,d,c[v>>2]|0);n=c[(c[(c[u>>2]|0)+(o<<2)>>2]|0)+4>>2]|0;c[f>>2]=w;c[f+4>>2]=n;iw(17,0,67728,f);lN(s,d,c[v>>2]|0);if((w|0)<(c[m>>2]|0)){o=w}else{break}}}else{iw(17,1,67568,l);lN(p,d,c[v>>2]|0);o=p+12|0;if((c[o>>2]|0)>0){m=b+116|0;u=r+16|0;w=b+8|0;n=q+16|0;y=0;while(1){a:do{if((c[m>>2]|0)>0){B=y+1|0;C=0;while(1){D=c[(c[w>>2]|0)+(C*112|0)+4>>2]|0;lN(q,d,c[v>>2]|0);if((t_(D,c[(c[(c[n>>2]|0)+(y<<2)>>2]|0)+4>>2]|0)|0)==0){break}D=C+1|0;if((D|0)<(c[m>>2]|0)){C=D}else{z=15;break a}}D=c[w>>2]|0;E=c[D+(C*112|0)+4>>2]|0;A=+h[D+(C*112|0)+96>>3];F=+h[D+(C*112|0)+80>>3];c[j>>2]=B;c[j+4>>2]=E;E=j+8|0;h[k>>3]=A;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=j+16|0;h[k>>3]=F;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];iw(17,0,67648,j);G=y+1|0}else{z=15}}while(0);if((z|0)==15){z=0;E=y+1|0;lN(r,d,c[v>>2]|0);D=c[(c[(c[u>>2]|0)+(y<<2)>>2]|0)+4>>2]|0;c[g>>2]=E;c[g+4>>2]=D;iw(17,0,67688,g);G=E}lN(p,d,c[v>>2]|0);if((G|0)<(c[o>>2]|0)){y=G}else{break}}}if((c[35652>>2]|c[8894]|0)==0){break}be[c[9034]&255](17)}}while(0);if((c[35652>>2]|c[8894]|0)==0){x=1;i=e;return x|0}be[c[9034]&255](17);x=1;i=e;return x|0}function rz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=i;i=i+8|0;f=VZ(144)|0;c[b>>2]=f;jw(0,(f|0)!=0|0,67744,e);c[f>>2]=0;e=a<<3;g=VZ(e)|0;c[f+4>>2]=g;g=VZ(e)|0;c[f+16>>2]=g;c[f+8>>2]=1;g=VZ(e)|0;c[f+12>>2]=g;c[f+20>>2]=a;g=VZ(e)|0;c[f+24>>2]=g;g=XZ(a,8)|0;c[f+28>>2]=g;h[f+32>>3]=1.0e-12;c[f+40>>2]=a*1e4;g=a+ -1|0;c[f+44>>2]=g;c[f+48>>2]=g;h[f+56>>3]=1.0e-12;g=VZ(e)|0;c[f+64>>2]=g;g=VZ(e)|0;c[f+68>>2]=g;c[f+72>>2]=1;h[f+80>>3]=100.0;c[f+88>>2]=-1;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;g=fa(a,a)|0;j=XZ(g,8)|0;c[f+104>>2]=j;j=XZ(g,8)|0;c[f+108>>2]=j;c[f+112>>2]=a;j=(fa(a+1|0,a)|0)/2|0;a=VZ(j<<3)|0;c[f+116>>2]=a;c[f+120>>2]=j;j=VZ(e)|0;c[f+124>>2]=j;j=VZ(e)|0;c[f+128>>2]=j;j=VZ(e)|0;c[f+132>>2]=j;j=VZ(e)|0;c[f+136>>2]=j;j=VZ(e)|0;c[f+140>>2]=j;jw(0,(c[b>>2]|0)!=0|0,67776,d);i=d;return 0}function sz(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;WZ(c[d+4>>2]|0);WZ(c[d+16>>2]|0);WZ(c[d+12>>2]|0);WZ(c[d+24>>2]|0);WZ(c[d+28>>2]|0);WZ(c[d+64>>2]|0);WZ(c[d+68>>2]|0);WZ(c[d+104>>2]|0);WZ(c[d+108>>2]|0);WZ(c[d+116>>2]|0);WZ(c[d+124>>2]|0);WZ(c[d+128>>2]|0);WZ(c[d+132>>2]|0);WZ(c[d+136>>2]|0);WZ(c[d+140>>2]|0);i=b;return 0}function tz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=i;i=i+8|0;f=VZ(80)|0;c[b>>2]=f;jw(0,(f|0)!=0|0,67816,e);c[f>>2]=0;e=a<<3;g=VZ(e)|0;c[f+4>>2]=g;g=VZ(e)|0;c[f+8>>2]=g;c[f+12>>2]=a;g=VZ(e)|0;c[f+16>>2]=g;g=XZ(a,8)|0;c[f+20>>2]=g;h[f+24>>3]=1.0e-8;h[f+32>>3]=1.0e-8;c[f+44>>2]=a*100;h[f+56>>3]=2.220446049250313e-16;g=VZ(fa(e,a)|0)|0;c[f+64>>2]=g;g=VZ(e)|0;c[f+68>>2]=g;g=VZ(a<<2)|0;c[f+72>>2]=g;jw(0,(c[b>>2]|0)!=0|0,67848,d);i=d;return 0}function uz(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;WZ(c[d+4>>2]|0);WZ(c[d+8>>2]|0);WZ(c[d+16>>2]|0);WZ(c[d+20>>2]|0);WZ(c[d+64>>2]|0);WZ(c[d+68>>2]|0);WZ(c[d+72>>2]|0);i=b;return 0}function vz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+24>>2]|0;if((e|0)==3){f=cy(a,b)|0;i=d;return f|0}else if((e|0)==4){ne[c[(c[a+540>>2]|0)+56>>2]&1](a,+h[b+8>>3])|0;h[b>>3]=+h[c[c[a+4>>2]>>2]>>3];f=0;i=d;return f|0}else if((e|0)==1){g=c[a+4>>2]|0;j=c[g+4>>2]|0;xz(c[g>>2]|0,+h[j>>3],c[j+8>>2]|0,c[a+112>>2]|0,b);f=0;i=d;return f|0}else if((e|0)==2){wz(a,b);f=0;i=d;return f|0}else{f=1;i=d;return f|0}return 0}function wz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0;d=i;e=c[c[b+48>>2]>>2]|0;f=c[a+4>>2]|0;g=c[f>>2]|0;j=c[f+4>>2]|0;f=g+8|0;k=c[f>>2]|0;l=a+112|0;m=c[l>>2]|0;n=j+8|0;o=c[n>>2]|0;p=j;j=b+8|0;q=b;h[q>>3]=+h[p>>3]+ +h[j>>3];if((m|0)>0){b=c[e>>2]|0;r=0;do{h[b+(r<<3)>>3]=+h[o+(r+m<<3)>>3];r=r+1|0;}while((r|0)<(m|0))}r=g;g=a+540|0;o=m;b=1;do{if((o|0)>0){s=c[n>>2]|0;t=+h[67888+(b<<3)>>3];u=c[e+(b+ -1<<2)>>2]|0;v=c[f>>2]|0;w=0;while(1){h[v+(w<<3)>>3]=+h[s+(w<<3)>>3]+ +h[j>>3]*t*+h[u+(w<<3)>>3];x=w+1|0;if((x|0)<(o|0)){w=x}else{y=t;break}}}else{y=+h[67888+(b<<3)>>3]}h[r>>3]=+h[p>>3]+y*+h[j>>3];ee[c[(c[g>>2]|0)+28>>2]&127](a)|0;o=c[l>>2]|0;z=(o|0)>0;if(z){w=c[e+(b<<2)>>2]|0;u=0;do{h[w+(u<<3)>>3]=+h[k+(u+m<<3)>>3];u=u+1|0;}while((u|0)<(o|0))}b=b+1|0;}while((b|0)<4);if(!z){A=+h[q>>3];h[r>>3]=A;i=d;return}z=c[n>>2]|0;n=c[f>>2]|0;f=c[e>>2]|0;b=c[e+4>>2]|0;m=c[e+8>>2]|0;k=c[e+12>>2]|0;e=0;do{h[n+(e<<3)>>3]=+h[z+(e<<3)>>3]+(+h[f+(e<<3)>>3]*.16666666666666666+0.0+ +h[b+(e<<3)>>3]*.3333333333333333+ +h[m+(e<<3)>>3]*.3333333333333333+ +h[k+(e<<3)>>3]*.16666666666666666)*+h[j>>3];e=e+1|0;}while((e|0)<(o|0));A=+h[q>>3];h[r>>3]=A;i=d;return}function xz(a,b,d,e,f){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0;g=i;j=f+8|0;k=+h[j>>3];l=k+b;m=f;h[m>>3]=l;if((e|0)<=0){n=l;o=a;p=o;h[p>>3]=n;i=g;return}f=c[a+8>>2]|0;l=k;q=0;while(1){h[f+(q<<3)>>3]=+h[d+(q<<3)>>3]+ +h[d+(q+e<<3)>>3]*l;r=q+1|0;if((r|0)>=(e|0)){break}l=+h[j>>3];q=r}n=+h[m>>3];o=a;p=o;h[p>>3]=n;i=g;return}function yz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+8|0;f=e;h[d>>3]=+h[b+240>>3];h[d+8>>3]=+h[b+264>>3];h[d+16>>3]=0.0;a[d+28|0]=0;c[d+32>>2]=nw(4)|0;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;g=c[d+24>>2]|0;a:do{if((g|0)==4){j=c[298]|0;k=VZ(j<<2)|0;c[16986]=k;if((j|0)<=0){l=0;break}m=c[b+116>>2]|0;n=k;k=0;while(1){c[n+(k<<2)>>2]=XZ(m,8)|0;o=k+1|0;if((o|0)>=(j|0)){l=0;break a}n=c[16986]|0;k=o}}else if((g|0)==2){k=VZ(8)|0;c[k+4>>2]=4;n=VZ(20)|0;c[k>>2]=n;j=c[b+112>>2]|0;m=n;n=0;while(1){c[m+(n<<2)>>2]=XZ(j,8)|0;if((n|0)>=4){break}m=c[k>>2]|0;n=n+1|0}c[d+48>>2]=k;l=0}else if((g|0)==3){n=VZ(88)|0;gw(23,0,67920,f);m=ay(b,d,n)|0;c[d+48>>2]=n;l=m}else{l=0}}while(0);Lz(b)|0;if((c[2]|0)==0){i=e;return l|0}mx(6);jx(1);i=e;return l|0}function zz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+24>>2]|0;if((e|0)==3){by(c[b+48>>2]|0)|0}else if((e|0)==2){f=b+48|0;b=c[f>>2]|0;g=c[b>>2]|0;if((c[b+4>>2]|0)>-1){b=g;h=0;while(1){WZ(c[b+(h<<2)>>2]|0);j=c[f>>2]|0;k=c[j>>2]|0;if((h|0)<(c[j+4>>2]|0)){h=h+1|0;b=k}else{l=k;break}}}else{l=g}WZ(l);WZ(c[f>>2]|0)}else if((e|0)==4){e=c[298]|0;f=c[16986]|0;if((e|0)>0){l=f;g=0;while(1){WZ(c[l+(g<<2)>>2]|0);b=g+1|0;h=c[16986]|0;if((b|0)<(e|0)){g=b;l=h}else{m=h;break}}}else{m=f}WZ(m)}Mz(a)|0;Gz(a);i=d;return 0}function Az(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+168|0;c[o>>2]=0;p=i;i=i+160|0;q=b+536|0;r=c[q>>2]|0;u=0;pa(173,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){t=K_(c[s>>2]|0,o)|0;if((t|0)==0){bb(s|0,v|0)}J=v}else{t=-1}do{if((t|0)==1){w=0;x=0;y=0;z=0;A=J}else{u=0;sa(97,b|0)|0;s=u;u=0;if((s|0)!=0&(v|0)!=0){B=K_(c[s>>2]|0,o)|0;if((B|0)==0){bb(s|0,v|0)}J=v}else{B=-1}if((B|0)==1){w=0;x=0;y=0;z=0;A=J;break}s=b+540|0;u=0;sa(c[(c[s>>2]|0)+40>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){D=K_(c[C>>2]|0,o)|0;if((D|0)==0){bb(C|0,v|0)}J=v}else{D=-1}if((D|0)==1){w=0;x=0;y=0;z=0;A=J;break}if((a[b+440|0]|0)!=0){u=0;sa(c[(c[s>>2]|0)+44>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){E=K_(c[C>>2]|0,o)|0;if((E|0)==0){bb(C|0,v|0)}J=v}else{E=-1}if((E|0)==1){w=0;x=0;y=0;z=0;A=J;break}}C=b+240|0;h[c[c[b+4>>2]>>2]>>3]=+h[C>>3];u=0;pa(c[(c[s>>2]|0)+4>>2]|0,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){F=K_(c[s>>2]|0,o)|0;if((F|0)==0){bb(s|0,v|0)}J=v}else{F=-1}if((F|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;pa(174,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){G=K_(c[s>>2]|0,o)|0;if((G|0)==0){bb(s|0,v|0)}J=v}else{G=-1}if((G|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;oa(1,+(+h[b+272>>3]));s=u;u=0;if((s|0)!=0&(v|0)!=0){H=K_(c[s>>2]|0,o)|0;if((H|0)==0){bb(s|0,v|0)}J=v}else{H=-1}if((H|0)==1){w=0;x=0;y=0;z=C;A=J;break}c[(c[q>>2]|0)+84>>2]=1;s=p;I=r+80|0;K=c[I>>2]|0;c[I>>2]=p;w_(p,1,o|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=K_(c[L>>2]|0,o)|0;if((M|0)==0){bb(L|0,v|0)}J=v}else{M=-1}if((M|0)==1){w=K;x=I;y=s;z=C;A=J;break}w=K;x=I;y=s;z=C;A=0}}while(0);a:while(1){do{if((A|0)==0){u=0;M=Ha(1,b|0,d|0,e|0,f|0,+g,j|0)|0;p=u;u=0;if((p|0)!=0&(v|0)!=0){N=K_(c[p>>2]|0,o)|0;if((N|0)==0){bb(p|0,v|0)}J=v}else{N=-1}if((N|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}if((M|0)==0){S=0;T=1;break}u=0;Pa(13,1,0,67952,n|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){U=K_(c[M>>2]|0,o)|0;if((U|0)==0){bb(M|0,v|0)}J=v}else{U=-1}if((U|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}h[b+248>>3]=+h[z>>3];S=-1;T=1}else{S=0;T=0}}while(0);c[x>>2]=w;u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){V=K_(c[M>>2]|0,o)|0;if((V|0)==0){bb(M|0,v|0)}J=v}else{V=-1}if((V|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if(T){W=S}else{u=0;Pa(14,2,0,68048,m|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){X=K_(c[M>>2]|0,o)|0;if((X|0)==0){bb(M|0,v|0)}J=v}else{X=-1}if((X|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}W=-1}u=0;qa(c[74168>>2]|0,74144,b|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Y=K_(c[M>>2]|0,o)|0;if((Y|0)==0){bb(M|0,v|0)}J=v}else{Y=-1}if((Y|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}u=0;Pa(14,23,0,68104,l|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Z=K_(c[M>>2]|0,o)|0;if((Z|0)==0){bb(M|0,v|0)}J=v}else{Z=-1}if((Z|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if((c[2]|0)==0){_=26;break}u=0;pa(175,1);M=u;u=0;if((M|0)!=0&(v|0)!=0){$=K_(c[M>>2]|0,o)|0;if(($|0)==0){bb(M|0,v|0)}J=v}else{$=-1}if(($|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R}else{break}}if((_|0)==26){i=k;return W|0}i=k;return W|0}function Bz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=+h[d>>3];do{if(H>=+h[b+248>>3]){if((c[d+24>>2]|0)==5){break}I=G;h[k>>3]=H;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];gw(8,0,68200,G);I=b+313|0;a[I]=1;Ay(b);if((c[89428>>2]|0)==0){ce[c[74164>>2]&127](74144,b)}a[I]=0}}while(0);if((e|0)!=0){Cz(wd(e|0)|0,b)}if((c[35684>>2]|0)==0){i=f;return 0}mx(0);gw(25,0,68248,F);gw(25,1,68272,E);H=+ex(6);J=+ex(6);K=J/+ex(0)*100.0;E=D;h[k>>3]=H;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=K;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];gw(25,0,68280,D);K=+ex(1);H=+ex(1);J=H/+ex(0)*100.0;D=C;h[k>>3]=K;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=J;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];gw(25,0,68320,C);J=+ex(2);K=+ex(2);H=K/+ex(0)*100.0;C=B;h[k>>3]=J;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+8|0;h[k>>3]=H;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];gw(25,0,68352,B);H=+ex(3);J=+ex(3);K=J/+ex(0)*100.0;B=A;h[k>>3]=H;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=K;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];gw(25,0,68376,A);K=+ex(4);H=+ex(4);J=H/+ex(0)*100.0;A=z;h[k>>3]=K;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=J;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];gw(25,0,68416,z);J=+ex(7);K=+ex(7);H=K/+ex(0)*100.0;z=y;h[k>>3]=J;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];gw(25,0,68448,y);y=d+24|0;z=(c[y>>2]|0)==5;H=+ex(0);J=H- +ex(7);H=J- +ex(4);J=H- +ex(3);H=J- +ex(2);J=H- +ex(1);H=J- +ex(6);J=+ex(0);K=J- +ex(7);J=K- +ex(4);K=J- +ex(3);J=K- +ex(2);K=J- +ex(1);J=K- +ex(6);K=J/+ex(0)*100.0;if(z){z=w;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=w+8|0;h[k>>3]=K;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];gw(25,0,68512,w)}else{w=x;h[k>>3]=H;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=x+8|0;h[k>>3]=K;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];gw(25,0,68480,x)}K=+ex(0);H=+ex(0);J=H/+ex(0)*100.0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=v+8|0;h[k>>3]=J;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];gw(25,0,68544,v);be[c[9034]&255](25);gw(25,1,68568,u);c[t>>2]=c[d+40>>2];gw(25,0,68576,t);c[s>>2]=c[d+44>>2];gw(25,0,68600,s);be[c[9034]&255](25);s=c[y>>2]|0;if((s|0)==3){y=d+48|0;d=c[y>>2]|0;t=c[d+8>>2]|0;u=c[d+4>>2]|0;c[u>>2]=(c[u>>2]|0)+(c[t>>2]|0);d=u+4|0;c[d>>2]=(c[d>>2]|0)+(c[t+4>>2]|0);d=u+8|0;c[d>>2]=(c[d>>2]|0)+(c[t+8>>2]|0);d=u+12|0;c[d>>2]=(c[d>>2]|0)+(c[t+12>>2]|0);d=u+16|0;c[d>>2]=(c[d>>2]|0)+(c[t+16>>2]|0);gw(25,1,68624,r);c[q>>2]=c[c[(c[y>>2]|0)+4>>2]>>2];gw(25,0,68640,q);c[p>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+4>>2];gw(25,0,68656,p);c[o>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+8>>2];gw(25,0,68688,o);c[n>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+12>>2];gw(25,0,68720,n);c[m>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+16>>2];gw(25,0,68744,m);be[c[9034]&255](25)}else if((s|0)!=5){gw(25,1,68776,l);gw(25,0,68784,j);be[c[9034]&255](25)}gw(25,0,68848,g);jx(0);i=f;return 0}function Cz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+16|0;y=i;i=i+8|0;z=Tb(b|0,69320)|0;b=c[t>>2]|0;A=d+4|0;B=y;h[k>>3]=+h[c[c[A>>2]>>2]>>3];c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];sd(b|0,69328,y|0)|0;if((z|0)==0){C=Od(10,b|0)|0;D=qd(b|0)|0;i=e;return}y=d+116|0;B=d+124|0;E=d+128|0;F=d+132|0;G=d+216|0;H=d+220|0;I=d+224|0;J=d+228|0;K=d+136|0;L=d+140|0;M=d+144|0;N=d+148|0;O=d+36|0;P=d+428|0;Q=d+32|0;R=d+424|0;S=d+28|0;T=d+420|0;U=d+24|0;V=d+416|0;W=d+52|0;X=d+48|0;Y=d+44|0;Z=d+40|0;_=d+20|0;$=d+16|0;aa=d+12|0;ba=d+8|0;d=z;do{z=c[y>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((t_(d,c[(c[ba>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];c[x>>2]=d;ea=x+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];sd(b|0,69344,x|0)|0;fa=c[y>>2]|0}else{fa=ca}ea=z+1|0;if((ea|0)<(fa|0)){ca=fa;z=ea}else{break}}}z=c[B>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((t_(d,c[(c[aa>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(z<<2)>>2]|0;c[w>>2]=d;c[w+4>>2]=ea;sd(b|0,69360,w|0)|0;ga=c[B>>2]|0}else{ga=ca}ea=z+1|0;if((ea|0)<(ga|0)){ca=ga;z=ea}else{break}}}z=c[E>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((t_(d,c[(c[$>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+z|0]|0;c[v>>2]=d;c[v+4>>2]=ea;sd(b|0,69368,v|0)|0;ha=c[E>>2]|0}else{ha=ca}ea=z+1|0;if((ea|0)<(ha|0)){ca=ha;z=ea}else{break}}}z=c[F>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((t_(d,c[(c[_>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(z<<2)>>2]|0;c[u>>2]=d;c[u+4>>2]=ea;sd(b|0,69376,u|0)|0;ia=c[F>>2]|0}else{ia=ca}ea=z+1|0;if((ea|0)<(ia|0)){ca=ia;z=ea}else{break}}}if((c[G>>2]|0)>0){z=0;do{ca=c[Z>>2]|0;do{if((t_(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(c[ca+(z*52|0)+4>>2]<<3)>>3];if((c[ca+(z*52|0)>>2]|0)==0){c[r>>2]=d;ea=r+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];sd(b|0,69344,r|0)|0;break}else{c[s>>2]=d;ea=s+4|0;h[k>>3]=-da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];sd(b|0,69344,s|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[G>>2]|0))}if((c[H>>2]|0)>0){z=0;do{ca=c[Y>>2]|0;do{if((t_(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(c[ca+(z*52|0)+4>>2]<<2)>>2]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[p>>2]=d;c[p+4>>2]=ea;sd(b|0,69360,p|0)|0;break}else{c[q>>2]=d;c[q+4>>2]=0-ea;sd(b|0,69360,q|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[H>>2]|0))}if((c[I>>2]|0)>0){z=0;do{ca=c[X>>2]|0;do{if((t_(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+(c[ca+(z*52|0)+4>>2]|0)|0]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[n>>2]=d;c[n+4>>2]=ea;sd(b|0,69368,n|0)|0;break}else{c[o>>2]=d;c[o+4>>2]=0-ea;sd(b|0,69368,o|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[I>>2]|0))}z=c[J>>2]|0;if((z|0)>0){ca=z;z=0;while(1){ea=c[W>>2]|0;if((t_(d,c[ea+(z*52|0)+16>>2]|0)|0)==0){ja=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(c[ea+(z*52|0)+4>>2]<<2)>>2]|0;c[m>>2]=d;c[m+4>>2]=ja;sd(b|0,69376,m|0)|0;ka=c[J>>2]|0}else{ka=ca}ja=z+1|0;if((ja|0)<(ka|0)){ca=ka;z=ja}else{break}}}z=c[K>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((t_(d,c[(c[U>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[V>>2]|0)+(z<<3)>>3];c[l>>2]=d;ja=l+4|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];sd(b|0,69344,l|0)|0;la=c[K>>2]|0}else{la=ca}ja=z+1|0;if((ja|0)<(la|0)){ca=la;z=ja}else{break}}}z=c[L>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((t_(d,c[(c[S>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ja=c[(c[T>>2]|0)+(z<<2)>>2]|0;c[j>>2]=d;c[j+4>>2]=ja;sd(b|0,69360,j|0)|0;ma=c[L>>2]|0}else{ma=ca}ja=z+1|0;if((ja|0)<(ma|0)){ca=ma;z=ja}else{break}}}z=c[M>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((t_(d,c[(c[Q>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ja=a[(c[R>>2]|0)+z|0]|0;c[g>>2]=d;c[g+4>>2]=ja;sd(b|0,69368,g|0)|0;na=c[M>>2]|0}else{na=ca}ja=z+1|0;if((ja|0)<(na|0)){ca=na;z=ja}else{break}}}z=c[N>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((t_(d,c[(c[O>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ja=c[(c[P>>2]|0)+(z<<2)>>2]|0;c[f>>2]=d;c[f+4>>2]=ja;sd(b|0,69376,f|0)|0;oa=c[N>>2]|0}else{oa=ca}ja=z+1|0;if((ja|0)<(oa|0)){ca=oa;z=ja}else{break}}}d=Tb(0,69320)|0;}while((d|0)!=0);C=Od(10,b|0)|0;D=qd(b|0)|0;i=e;return}function Dz(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;m=i;i=i+16|0;n=m;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+56|0;t=s;u=s+24|0;c[u>>2]=j;a:do{switch(j|0){case 5:{iw(1,0,68944,q);v=1;i=m;return v|0};case 4:{w=c[296]|0;if((w|0)!=0){if((t_(w,68984)|0)==0){break a}}gw(23,0,69e3,p);v=1;i=m;return v|0};case 11:case 10:case 9:case 6:case 7:case 8:{iw(1,0,68872,r);v=1;i=m;return v|0};case 17:case 16:case 15:case 14:case 13:case 12:{c[u>>2]=3;break};case 18:{w=c[296]|0;do{if((w|0)!=0){if((t_(w,69128)|0)!=0){break}c[u>>2]=4;break a}}while(0);gw(23,0,69152,o);v=1;i=m;return v|0};default:{}}}while(0);o=yz(a,s)|0;ve[c[36484>>2]&7]()|0;do{if((o|0)==0){r=Az(a,b,d,e,f,g)|0;ve[c[36484>>2]&7]()|0;if((r|0)!=0){x=r;break}if((c[u>>2]|0)!=5){ce[c[74164>>2]&127](74144,a);Ky(a)}y=+h[a+248>>3];r=n;h[k>>3]=+h[a+240>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+8|0;h[k>>3]=y;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];gw(23,0,69280,n);r=re[c[c[a+540>>2]>>2]&63](a,t)|0;ve[c[36484>>2]&7]()|0;Bz(a,s,l)|0;ve[c[36484>>2]&7]()|0;x=r}else{ve[c[36484>>2]&7]()|0;x=o}}while(0);zz(a,s)|0;v=x;i=m;return v|0}function Ez(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=a+204|0;if((c[e>>2]|0)<=0){Fz(a);i=b;return}f=a+488|0;g=a;h=0;while(1){j=h+1|0;if((ee[c[(c[f>>2]|0)+(h*48|0)+40>>2]&127](g)|0)!=0){k=5;break}if((j|0)<(c[e>>2]|0)){h=j}else{k=6;break}}if((k|0)==5){kw(c[a+536>>2]|0,69392,d)}else if((k|0)==6){Fz(a);i=b;return}}function Fz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;f=a+12|0;g=a+4|0;a=0;do{h=c[e>>2]|0;j=(c[c[h+(a*48|0)+12>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0;k=c[(c[c[g>>2]>>2]|0)+12>>2]|0;l=h+(a*48|0)|0;m=h+(a*48|0)+4|0;B_(k+(j<<2)|0,0,fa(c[l>>2]<<2,c[m>>2]|0)|0)|0;n=h+(a*48|0)+8|0;if((c[n>>2]|0)>0){o=c[h+(a*48|0)+16>>2]|0;p=0;do{c[o+(p<<2)>>2]=p;p=p+1|0;}while((p|0)<(c[n>>2]|0))}n=c[l>>2]|0;if((n|0)>0){p=c[h+(a*48|0)+20>>2]|0;o=n;n=0;do{c[p+(n<<2)>>2]=o+~n;n=n+1|0;o=c[l>>2]|0;}while((n|0)<(o|0))}o=c[m>>2]|0;if((o|0)>0){n=o;o=0;do{c[k+(o+j+(fa(n,o)|0)<<2)>>2]=1;o=o+1|0;n=c[m>>2]|0;}while((o|0)<(n|0))}a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function Gz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;a=0;do{f=c[e>>2]|0;WZ(c[f+(a*48|0)+28>>2]|0);WZ(c[f+(a*48|0)+32>>2]|0);WZ(c[f+(a*48|0)+16>>2]|0);WZ(c[f+(a*48|0)+20>>2]|0);WZ(c[f+(a*48|0)+24>>2]|0);a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function Hz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+4096|0;p=b+204|0;if((c[p>>2]|0)<=0){q=0;i=f;return q|0}r=b+488|0;s=d<<24>>24==0;d=(e|0)==0;t=0;u=0;while(1){v=c[r>>2]|0;w=v+(u*48|0)|0;x=VZ(c[w>>2]<<2)|0;y=v+(u*48|0)+8|0;z=VZ(c[y>>2]<<2)|0;Iz(b,u);A=v+(u*48|0)+20|0;B=c[A>>2]|0;C=c[w>>2]|0;z_(x|0,B|0,C<<2|0)|0;D=v+(u*48|0)+16|0;E=c[D>>2]|0;F=c[y>>2]|0;z_(z|0,E|0,F<<2|0)|0;G=v+(u*48|0)+24|0;if(!(($x(c[G>>2]|0,F,C,E,B)|0)==0|s)){break}B=Jz(x,c[A>>2]|0,c[w>>2]|0,c[y>>2]|0,c[v+(u*48|0)+4>>2]|0,c[v+(u*48|0)+12>>2]|0,c[v+(u*48|0)+28>>2]|0,c[v+(u*48|0)+32>>2]|0,b,e)|0;if(d){z_(c[A>>2]|0,x|0,c[w>>2]<<2|0)|0;z_(c[D>>2]|0,z|0,c[y>>2]<<2|0)|0}y=(B|0)==0?t:1;WZ(x);WZ(z);z=u+1|0;if((z|0)<(c[p>>2]|0)){t=y;u=z}else{q=y;H=15;break}}if((H|0)==15){i=f;return q|0}q=o;o=v+(u*48|0)+44|0;f=c[o>>2]|0;H=b+464|0;t=c[H>>2]|0;p=c[t+(f*44|0)>>2]|0;c[n>>2]=c[t+(f*44|0)+4>>2];c[n+4>>2]=p;c[n+8>>2]=f;iw(5,1,69448,n);n=c[H>>2]|0;if((c[n+((c[o>>2]|0)*44|0)+4>>2]|0)!=0){f=n;n=0;do{a[q]=0;p=c[f+((c[o>>2]|0)*44|0)>>2]|0;if((p|0)!=0){t=p;p=0;do{d=(fa(t,n)|0)+p|0;I=+h[(c[G>>2]|0)+(d<<3)>>3];c[m>>2]=q;d=m+4|0;h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];dc(q|0,69480,m|0)|0;p=p+1|0;t=c[(c[H>>2]|0)+((c[o>>2]|0)*44|0)>>2]|0;}while(p>>>0<t>>>0)}c[l>>2]=q;iw(5,0,69488,l);n=n+1|0;f=c[H>>2]|0;}while(n>>>0<(c[f+((c[o>>2]|0)*44|0)+4>>2]|0)>>>0)}if((c[w>>2]|0)<=0){J=36136;K=c[9034]|0;be[K&255](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=4;_=Z;$=69496;aa=$;kw(O,aa,g)}o=v+(u*48|0)+32|0;u=0;do{c[j>>2]=c[(c[(c[o>>2]|0)+(u<<2)>>2]|0)+4>>2];iw(5,0,69488,j);u=u+1|0;}while((u|0)<(c[w>>2]|0));J=36136;K=c[9034]|0;be[K&255](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=4;_=Z;$=69496;aa=$;kw(O,aa,g);return 0}function Iz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+488|0;f=c[e>>2]|0;g=c[f+(b*48|0)+44>>2]|0;j=a+464|0;k=c[j>>2]|0;l=c[f+(b*48|0)+24>>2]|0;B_(l|0,0,fa(c[k+(g*44|0)+4>>2]<<3,c[k+(g*44|0)>>2]|0)|0)|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=d;return}f=a;a=c[k+(g*44|0)>>2]|0;m=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[m+(g*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}ee[c[(c[e>>2]|0)+(b*48|0)+36>>2]&127](f)|0;m=c[j>>2]|0;a=c[m+(g*44|0)>>2]|0;do{if((a|0)!=0){n=c[m+(g*44|0)+28>>2]|0;o=0;do{do{if(+h[n+(o<<3)>>3]==1.0){if((o|0)==0){p=m+(g*44|0)+8|0;q=0}else{r=m+(g*44|0)+8|0;p=r;q=c[(c[r>>2]|0)+(o+ -1<<2)>>2]|0}r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if(!(q>>>0<r>>>0)){break}s=c[m+(g*44|0)+12>>2]|0;t=c[m+(g*44|0)+4>>2]|0;u=c[m+(g*44|0)+36>>2]|0;v=q;do{w=c[s+(v<<2)>>2]|0;x=(fa(t,o)|0)+w|0;h[l+(x<<3)>>3]=+h[u+(w<<3)>>3];v=v+1|0;}while(v>>>0<r>>>0)}}while(0);o=o+1|0;}while(o>>>0<a>>>0);if((a|0)==0){break}o=c[m+(g*44|0)+20>>2]|0;n=0;do{if(((c[o+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=0.0}n=n+1|0;}while(n>>>0<a>>>0)}}while(0);k=k+1|0;}while(k>>>0<(c[m+(g*44|0)+24>>2]|0)>>>0);i=d;return}function Jz(a,b,d,e,f,g,j,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;o=i;i=i+8|0;p=o;q=XZ(d,4)|0;r=XZ(d,4)|0;s=r;t=(d|0)>0;if(t){u=0}else{v=0;WZ(q);WZ(r);i=o;return v|0}do{w=(u|0)<(e|0)?1:2;c[r+(c[b+(u<<2)>>2]<<2)>>2]=w;c[q+(c[a+(u<<2)>>2]<<2)>>2]=w;u=u+1|0;}while((u|0)<(d|0));if(t){x=0}else{v=0;WZ(q);WZ(r);i=o;return v|0}while(1){t=x+1|0;if((c[r+(x<<2)>>2]|0)!=(c[q+(x<<2)>>2]|0)){break}if((t|0)<(d|0)){x=t}else{v=0;y=9;break}}if((y|0)==9){WZ(q);WZ(r);i=o;return v|0}if((n|0)==0){v=-1;WZ(q);WZ(r);i=o;return v|0}n=p;h[k>>3]=+h[c[c[m+4>>2]>>2]>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];gw(5,1,69600,p);Kz(s,d,f,c[g>>2]|0,j,l,m);if((c[35604>>2]|0)==0){v=-1;WZ(q);WZ(r);i=o;return v|0}be[c[9034]&255](5);v=-1;WZ(q);WZ(r);i=o;return v|0}



function OW(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((d|0)==(e|0)){g=d;i=b;return g|0}else{h=d;j=f}while(1){c[j>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{j=j+4|0;h=f}}i=b;return g|0}function PW(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b>>>0<128?b&255:c)|0}function QW(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;if((d|0)==(e|0)){h=d;i=b;return h|0}j=((e+ -4+(0-d)|0)>>>2)+1|0;k=d;l=g;while(1){g=c[k>>2]|0;a[l]=g>>>0<128?g&255:f;g=k+4|0;if((g|0)==(e|0)){break}else{l=l+1|0;k=g}}h=d+(j<<2)|0;i=b;return h|0}function RW(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=106592;e=c[b+8>>2]|0;do{if((e|0)!=0){if((a[b+12|0]|0)==0){break}c_(e)}}while(0);b_(b);i=d;return}function SW(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=106592;e=c[b+8>>2]|0;if((e|0)==0){i=d;return}if((a[b+12|0]|0)==0){i=d;return}c_(e);i=d;return}function TW(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(zd()|0)>>2]|0)+((b&255)<<2)>>2]&255;i=a;return d|0}function UW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(zd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function VW(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Ed()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;i=a;return d|0}function WW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Ed()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function XW(a,b){a=a|0;b=b|0;i=i;return b|0}function YW(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((c|0)==(d|0)){f=c;i=b;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{h=h+1|0;g=e}}i=b;return f|0}function ZW(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b<<24>>24>-1?b:c)|0}function _W(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((c|0)==(d|0)){g=c;i=b;return g|0}else{h=c;j=f}while(1){f=a[h]|0;a[j]=f<<24>>24>-1?f:e;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{j=j+1|0;h=f}}i=b;return g|0}function $W(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function aX(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function bX(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function cX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function dX(a){a=a|0;i=i;return 1}function eX(a){a=a|0;i=i;return 1}function fX(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;i=i;return(b>>>0<e>>>0?b:e)|0}function gX(a){a=a|0;i=i;return 1}function hX(a){a=a|0;var b=0;b=i;pW(a);b_(a);i=b;return}function iX(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+8|0;m=l;n=m;o=i;i=i+8|0;p=(e|0)==(f|0);a:do{if(p){c[k>>2]=h;c[g>>2]=e;q=e}else{r=e;while(1){s=r+4|0;if((c[r>>2]|0)==0){t=r;break}if((s|0)==(f|0)){t=f;break}else{r=s}}c[k>>2]=h;c[g>>2]=e;if(p|(h|0)==(j|0)){q=e;break}r=j;s=b+8|0;u=o;v=e;w=h;x=t;while(1){y=d;z=c[y+4>>2]|0;A=m;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=Ic(c[s>>2]|0)|0;A=$Y(w,g,x-v>>2,r-w|0,d)|0;if((z|0)!=0){Ic(z|0)|0}if((A|0)==-1){B=10;break}else if((A|0)==0){C=1;B=33;break}z=(c[k>>2]|0)+A|0;c[k>>2]=z;if((z|0)==(j|0)){B=31;break}if((x|0)==(f|0)){D=c[g>>2]|0;E=z;F=f}else{z=Ic(c[s>>2]|0)|0;A=_Y(u,0,d)|0;if((z|0)!=0){Ic(z|0)|0}if((A|0)==-1){C=2;B=33;break}z=c[k>>2]|0;if(A>>>0>(r-z|0)>>>0){C=1;B=33;break}b:do{if((A|0)!=0){y=z;G=A;H=u;while(1){I=a[H]|0;c[k>>2]=y+1;a[y]=I;I=G+ -1|0;if((I|0)==0){break b}y=c[k>>2]|0;H=H+1|0;G=I}}}while(0);A=(c[g>>2]|0)+4|0;c[g>>2]=A;c:do{if((A|0)==(f|0)){J=f}else{z=A;while(1){G=z+4|0;if((c[z>>2]|0)==0){J=z;break c}if((G|0)==(f|0)){J=f;break}else{z=G}}}}while(0);D=A;E=c[k>>2]|0;F=J}if((D|0)==(f|0)|(E|0)==(j|0)){q=D;break a}else{v=D;w=E;x=F}}if((B|0)==10){c[k>>2]=w;d:do{if((v|0)==(c[g>>2]|0)){K=v}else{x=v;u=w;while(1){r=c[x>>2]|0;z=Ic(c[s>>2]|0)|0;G=_Y(u,r,n)|0;if((z|0)!=0){Ic(z|0)|0}if((G|0)==-1){K=x;break d}z=(c[k>>2]|0)+G|0;c[k>>2]=z;G=x+4|0;if((G|0)==(c[g>>2]|0)){K=G;break}else{x=G;u=z}}}}while(0);c[g>>2]=K;C=2;i=l;return C|0}else if((B|0)==31){q=c[g>>2]|0;break}else if((B|0)==33){i=l;return C|0}}}while(0);C=(q|0)!=(f|0)|0;i=l;return C|0}function jX(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=i;i=i+8|0;m=l;n=m;o=(e|0)==(f|0);a:do{if(o){c[k>>2]=h;c[g>>2]=e;p=e}else{q=e;while(1){r=q+1|0;if((a[q]|0)==0){s=q;break}if((r|0)==(f|0)){s=f;break}else{q=r}}c[k>>2]=h;c[g>>2]=e;if(o|(h|0)==(j|0)){p=e;break}q=j;r=b+8|0;t=e;u=h;v=s;while(1){w=d;x=c[w+4>>2]|0;y=m;c[y>>2]=c[w>>2];c[y+4>>2]=x;z=v;x=Ic(c[r>>2]|0)|0;y=XY(u,g,z-t|0,q-u>>2,d)|0;if((x|0)!=0){Ic(x|0)|0}if((y|0)==-1){A=10;break}else if((y|0)==0){B=2;A=32;break}x=(c[k>>2]|0)+(y<<2)|0;c[k>>2]=x;if((x|0)==(j|0)){A=30;break}y=c[g>>2]|0;if((v|0)==(f|0)){C=y;D=x;E=f}else{w=Ic(c[r>>2]|0)|0;F=WY(x,y,1,d)|0;if((w|0)!=0){Ic(w|0)|0}if((F|0)!=0){B=2;A=32;break}c[k>>2]=(c[k>>2]|0)+4;F=(c[g>>2]|0)+1|0;c[g>>2]=F;b:do{if((F|0)==(f|0)){G=f}else{w=F;while(1){y=w+1|0;if((a[w]|0)==0){G=w;break b}if((y|0)==(f|0)){G=f;break}else{w=y}}}}while(0);C=F;D=c[k>>2]|0;E=G}if((C|0)==(f|0)|(D|0)==(j|0)){p=C;break a}else{t=C;u=D;v=E}}if((A|0)==10){c[k>>2]=u;c:do{if((t|0)==(c[g>>2]|0)){H=t}else{v=t;q=u;while(1){w=Ic(c[r>>2]|0)|0;y=WY(q,v,z-v|0,n)|0;if((w|0)!=0){Ic(w|0)|0}if((y|0)==-1){A=15;break}else if((y|0)==-2){A=16;break}else if((y|0)==0){I=v+1|0}else{I=v+y|0}y=(c[k>>2]|0)+4|0;c[k>>2]=y;if((I|0)==(c[g>>2]|0)){H=I;break c}else{v=I;q=y}}if((A|0)==15){c[g>>2]=v;B=2;i=l;return B|0}else if((A|0)==16){c[g>>2]=v;B=1;i=l;return B|0}}}while(0);c[g>>2]=H;B=(H|0)!=(f|0)|0;i=l;return B|0}else if((A|0)==30){p=c[g>>2]|0;break}else if((A|0)==32){i=l;return B|0}}}while(0);B=(p|0)!=(f|0)|0;i=l;return B|0}function kX(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h;j=Ic(c[b+8>>2]|0)|0;b=_Y(e,0,d)|0;if((j|0)!=0){Ic(j|0)|0}if((b|0)==0|(b|0)==-1){k=2;i=h;return k|0}j=b+ -1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=b;m=j;n=e}while(1){e=a[n]|0;c[g>>2]=l+1;a[l]=e;e=m+ -1|0;if((e|0)==0){k=0;break}l=c[g>>2]|0;n=n+1|0;m=e}i=h;return k|0}function lX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+8|0;a=Ic(c[d>>2]|0)|0;e=ZY(0,0,4)|0;if((a|0)!=0){Ic(a|0)|0}do{if((e|0)==0){a=c[d>>2]|0;if((a|0)==0){f=1;break}g=Ic(a|0)|0;if((g|0)==0){f=0;break}Ic(g|0)|0;f=0}else{f=-1}}while(0);i=b;return f|0}function mX(a){a=a|0;i=i;return 0}function nX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((f|0)==0|(d|0)==(e|0)){h=0;i=g;return h|0}j=e;k=a+8|0;a=d;d=0;l=0;while(1){m=Ic(c[k>>2]|0)|0;n=VY(a,j-a|0,b)|0;if((m|0)!=0){Ic(m|0)|0}if((n|0)==-2|(n|0)==-1){h=d;o=9;break}else if((n|0)==0){p=a+1|0;q=1}else{p=a+n|0;q=n}n=q+d|0;m=l+1|0;if(m>>>0>=f>>>0|(p|0)==(e|0)){h=n;o=9;break}else{a=p;d=n;l=m}}if((o|0)==9){i=g;return h|0}return 0}function oX(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;do{if((d|0)==0){e=1}else{a=Ic(d|0)|0;if((a|0)==0){e=4;break}Ic(a|0)|0;e=4}}while(0);i=b;return e|0}function pX(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function qX(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=rX(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function rX(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;c[g>>2]=d;c[k>>2]=h;do{if((m&2|0)!=0){if((j-h|0)<3){o=1;i=n;return o|0}else{c[k>>2]=h+1;a[h]=-17;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-69;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-65;break}}}while(0);h=f;m=c[g>>2]|0;if(!(m>>>0<f>>>0)){o=0;i=n;return o|0}d=j;j=m;a:while(1){m=b[j>>1]|0;p=m&65535;if(p>>>0>l>>>0){o=2;q=26;break}do{if((m&65535)<128){r=c[k>>2]|0;if((d-r|0)<1){o=1;q=26;break a}c[k>>2]=r+1;a[r]=m}else{if((m&65535)<2048){r=c[k>>2]|0;if((d-r|0)<2){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>6|192;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((m&65535)<55296){r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if(!((m&65535)<56320)){if((m&65535)<57344){o=2;q=26;break a}r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((h-j|0)<4){o=1;q=26;break a}r=j+2|0;s=e[r>>1]|0;if((s&64512|0)!=56320){o=2;q=26;break a}if((d-(c[k>>2]|0)|0)<4){o=1;q=26;break a}t=p&960;if(((t<<10)+65536|p<<10&64512|s&1023)>>>0>l>>>0){o=2;q=26;break a}c[g>>2]=r;r=(t>>>6)+1|0;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=r>>>2|240;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=p>>>2&15|r<<4&48|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p<<4&48|s>>>6&15|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=s&63|128}}while(0);p=(c[g>>2]|0)+2|0;c[g>>2]=p;if(p>>>0<f>>>0){j=p}else{o=0;q=26;break}}if((q|0)==26){i=n;return o|0}return 0}function sX(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=tX(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function tX(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;c[g>>2]=e;c[k>>2]=h;h=c[g>>2]|0;do{if((m&4|0)==0){o=h}else{if((f-h|0)<=2){o=h;break}if(!((a[h]|0)==-17)){o=h;break}if(!((a[h+1|0]|0)==-69)){o=h;break}if(!((a[h+2|0]|0)==-65)){o=h;break}e=h+3|0;c[g>>2]=e;o=e}}while(0);a:do{if(o>>>0<f>>>0){h=f;m=j;e=o;p=c[k>>2]|0;b:while(1){if(!(p>>>0<j>>>0)){q=e;break a}r=a[e]|0;s=r&255;if(s>>>0>l>>>0){t=2;u=41;break}do{if(r<<24>>24>-1){b[p>>1]=r&255;c[g>>2]=e+1}else{if((r&255)<194){t=2;u=41;break b}if((r&255)<224){if((h-e|0)<2){t=1;u=41;break b}v=d[e+1|0]|0;if((v&192|0)!=128){t=2;u=41;break b}w=v&63|s<<6&1984;if(w>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=w;c[g>>2]=e+2;break}if((r&255)<240){if((h-e|0)<3){t=1;u=41;break b}w=a[e+1|0]|0;v=a[e+2|0]|0;if((s|0)==224){if(!((w&-32)<<24>>24==-96)){t=2;u=41;break b}}else if((s|0)==237){if(!((w&-32)<<24>>24==-128)){t=2;u=41;break b}}else{if(!((w&-64)<<24>>24==-128)){t=2;u=41;break b}}x=v&255;if((x&192|0)!=128){t=2;u=41;break b}v=(w&255)<<6&4032|s<<12|x&63;if((v&65535)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=v;c[g>>2]=e+3;break}if(!((r&255)<245)){t=2;u=41;break b}if((h-e|0)<4){t=1;u=41;break b}v=a[e+1|0]|0;x=a[e+2|0]|0;w=a[e+3|0]|0;if((s|0)==244){if(!((v&-16)<<24>>24==-128)){t=2;u=41;break b}}else if((s|0)==240){if(!((v+112<<24>>24&255)<48)){t=2;u=41;break b}}else{if(!((v&-64)<<24>>24==-128)){t=2;u=41;break b}}y=x&255;if((y&192|0)!=128){t=2;u=41;break b}x=w&255;if((x&192|0)!=128){t=2;u=41;break b}if((m-p|0)<4){t=1;u=41;break b}w=s&7;z=v&255;v=y<<6;A=x&63;if((z<<12&258048|w<<18|v&4032|A)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=z<<2&60|y>>>4&3|((z>>>4&3|w<<2)<<6)+16320|55296;w=p+2|0;c[k>>2]=w;b[w>>1]=A|v&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);s=(c[k>>2]|0)+2|0;c[k>>2]=s;r=c[g>>2]|0;if(r>>>0<f>>>0){e=r;p=s}else{q=r;break a}}if((u|0)==41){i=n;return t|0}}else{q=o}}while(0);t=q>>>0<f>>>0|0;i=n;return t|0}function uX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function vX(a){a=a|0;i=i;return 0}function wX(a){a=a|0;i=i;return 0}function xX(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=yX(c,d,e,1114111,0)|0;i=b;return a|0}function yX(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k]|0;n=m&255;if(n>>>0>f>>>0){o=k;break a}do{if(m<<24>>24>-1){p=k+1|0;q=l}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}r=d[k+1|0]|0;if((r&192|0)!=128){o=k;break a}if((r&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;q=l;break}if((m&255)<240){s=k;if((g-s|0)<3){o=k;break a}r=a[k+1|0]|0;t=a[k+2|0]|0;if((n|0)==237){if(!((r&-32)<<24>>24==-128)){u=23;break b}}else if((n|0)==224){if(!((r&-32)<<24>>24==-96)){u=21;break b}}else{if(!((r&-64)<<24>>24==-128)){u=25;break b}}v=t&255;if((v&192|0)!=128){o=k;break a}if(((r&255)<<6&4032|n<<12&61440|v&63)>>>0>f>>>0){o=k;break a}p=k+3|0;q=l;break}if(!((m&255)<245)){o=k;break a}w=k;if((g-w|0)<4){o=k;break a}if((e-l|0)>>>0<2){o=k;break a}v=a[k+1|0]|0;r=a[k+2|0]|0;t=a[k+3|0]|0;if((n|0)==240){if(!((v+112<<24>>24&255)<48)){u=34;break b}}else if((n|0)==244){if(!((v&-16)<<24>>24==-128)){u=36;break b}}else{if(!((v&-64)<<24>>24==-128)){u=38;break b}}x=r&255;if((x&192|0)!=128){o=k;break a}r=t&255;if((r&192|0)!=128){o=k;break a}if(((v&255)<<12&258048|n<<18&1835008|x<<6&4032|r&63)>>>0>f>>>0){o=k;break a}p=k+4|0;q=l+1|0}}while(0);n=q+1|0;if(p>>>0<c>>>0&n>>>0<e>>>0){k=p;l=n}else{o=p;break a}}if((u|0)==21){y=s-b|0;i=h;return y|0}else if((u|0)==23){y=s-b|0;i=h;return y|0}else if((u|0)==25){y=s-b|0;i=h;return y|0}else if((u|0)==34){y=w-b|0;i=h;return y|0}else if((u|0)==36){y=w-b|0;i=h;return y|0}else if((u|0)==38){y=w-b|0;i=h;return y|0}}else{o=j}}while(0);y=o-b|0;i=h;return y|0}function zX(a){a=a|0;i=i;return 4}function AX(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function BX(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=CX(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function CX(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;c[e>>2]=b;c[h>>2]=f;do{if((k&2|0)!=0){if((g-f|0)<3){m=1;i=l;return m|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(!(f>>>0<d>>>0)){m=0;i=l;return m|0}k=g;g=f;a:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>j>>>0){m=2;n=19;break}do{if(f>>>0<128){b=c[h>>2]|0;if((k-b|0)<1){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048){b=c[h>>2]|0;if((k-b|0)<2){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;o=k-b|0;if(f>>>0<65536){if((o|0)<3){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>12|224;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f>>>6&63|128;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f&63|128;break}else{if((o|0)<4){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{m=0;n=19;break}}if((n|0)==19){i=l;return m|0}return 0}function DX(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=EX(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function EX(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;c[f>>2]=b;c[j>>2]=g;g=c[f>>2]|0;do{if((l&4|0)==0){n=g}else{if((e-g|0)<=2){n=g;break}if(!((a[g]|0)==-17)){n=g;break}if(!((a[g+1|0]|0)==-69)){n=g;break}if(!((a[g+2|0]|0)==-65)){n=g;break}b=g+3|0;c[f>>2]=b;n=b}}while(0);a:do{if(n>>>0<e>>>0){g=e;l=n;b=c[j>>2]|0;b:while(1){if(!(b>>>0<h>>>0)){o=l;break a}p=a[l]|0;q=p&255;do{if(p<<24>>24>-1){if(q>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=q;c[f>>2]=l+1}else{if((p&255)<194){r=2;s=40;break b}if((p&255)<224){if((g-l|0)<2){r=1;s=40;break b}t=d[l+1|0]|0;if((t&192|0)!=128){r=2;s=40;break b}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+2;break}if((p&255)<240){if((g-l|0)<3){r=1;s=40;break b}u=a[l+1|0]|0;t=a[l+2|0]|0;if((q|0)==237){if(!((u&-32)<<24>>24==-128)){r=2;s=40;break b}}else if((q|0)==224){if(!((u&-32)<<24>>24==-96)){r=2;s=40;break b}}else{if(!((u&-64)<<24>>24==-128)){r=2;s=40;break b}}v=t&255;if((v&192|0)!=128){r=2;s=40;break b}t=(u&255)<<6&4032|q<<12&61440|v&63;if(t>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=t;c[f>>2]=l+3;break}if(!((p&255)<245)){r=2;s=40;break b}if((g-l|0)<4){r=1;s=40;break b}t=a[l+1|0]|0;v=a[l+2|0]|0;u=a[l+3|0]|0;if((q|0)==240){if(!((t+112<<24>>24&255)<48)){r=2;s=40;break b}}else if((q|0)==244){if(!((t&-16)<<24>>24==-128)){r=2;s=40;break b}}else{if(!((t&-64)<<24>>24==-128)){r=2;s=40;break b}}w=v&255;if((w&192|0)!=128){r=2;s=40;break b}v=u&255;if((v&192|0)!=128){r=2;s=40;break b}u=(t&255)<<12&258048|q<<18&1835008|w<<6&4032|v&63;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+4}}while(0);q=(c[j>>2]|0)+4|0;c[j>>2]=q;p=c[f>>2]|0;if(p>>>0<e>>>0){l=p;b=q}else{o=p;break a}}if((s|0)==40){i=m;return r|0}}else{o=n}}while(0);r=o>>>0<e>>>0|0;i=m;return r|0}function FX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function GX(a){a=a|0;i=i;return 0}function HX(a){a=a|0;i=i;return 0}function IX(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=JX(c,d,e,1114111,0)|0;i=b;return a|0}function JX(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=1;b:while(1){m=a[k]|0;n=m&255;do{if(m<<24>>24>-1){if(n>>>0>f>>>0){o=k;break a}p=k+1|0}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}q=d[k+1|0]|0;if((q&192|0)!=128){o=k;break a}if((q&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;break}if((m&255)<240){r=k;if((g-r|0)<3){o=k;break a}q=a[k+1|0]|0;s=a[k+2|0]|0;if((n|0)==224){if(!((q&-32)<<24>>24==-96)){t=21;break b}}else if((n|0)==237){if(!((q&-32)<<24>>24==-128)){t=23;break b}}else{if(!((q&-64)<<24>>24==-128)){t=25;break b}}u=s&255;if((u&192|0)!=128){o=k;break a}if(((q&255)<<6&4032|n<<12&61440|u&63)>>>0>f>>>0){o=k;break a}p=k+3|0;break}if(!((m&255)<245)){o=k;break a}v=k;if((g-v|0)<4){o=k;break a}u=a[k+1|0]|0;q=a[k+2|0]|0;s=a[k+3|0]|0;if((n|0)==240){if(!((u+112<<24>>24&255)<48)){t=33;break b}}else if((n|0)==244){if(!((u&-16)<<24>>24==-128)){t=35;break b}}else{if(!((u&-64)<<24>>24==-128)){t=37;break b}}w=q&255;if((w&192|0)!=128){o=k;break a}q=s&255;if((q&192|0)!=128){o=k;break a}if(((u&255)<<12&258048|n<<18&1835008|w<<6&4032|q&63)>>>0>f>>>0){o=k;break a}p=k+4|0}}while(0);if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}k=p;l=l+1|0}if((t|0)==21){x=r-b|0;i=h;return x|0}else if((t|0)==23){x=r-b|0;i=h;return x|0}else if((t|0)==25){x=r-b|0;i=h;return x|0}else if((t|0)==33){x=v-b|0;i=h;return x|0}else if((t|0)==35){x=v-b|0;i=h;return x|0}else if((t|0)==37){x=v-b|0;i=h;return x|0}}else{o=j}}while(0);x=o-b|0;i=h;return x|0}function KX(a){a=a|0;i=i;return 4}function LX(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function MX(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function NX(a){a=a|0;var b=0;b=i;c[a>>2]=106744;QP(a+12|0);b_(a);i=b;return}function OX(a){a=a|0;var b=0;b=i;c[a>>2]=106744;QP(a+12|0);i=b;return}function PX(a){a=a|0;var b=0;b=i;c[a>>2]=106784;QP(a+16|0);b_(a);i=b;return}function QX(a){a=a|0;var b=0;b=i;c[a>>2]=106784;QP(a+16|0);i=b;return}function RX(b){b=b|0;i=i;return a[b+8|0]|0}function SX(a){a=a|0;i=i;return c[a+8>>2]|0}function TX(b){b=b|0;i=i;return a[b+9|0]|0}function UX(a){a=a|0;i=i;return c[a+12>>2]|0}function VX(a,b){a=a|0;b=b|0;var c=0;c=i;GP(a,b+12|0);i=c;return}function WX(a,b){a=a|0;b=b|0;var c=0;c=i;GP(a,b+16|0);i=c;return}function XX(a,b){a=a|0;b=b|0;b=i;IP(a,106816,4);i=b;return}function YX(a,b){a=a|0;b=b|0;b=i;qQ(a,106824,vZ(106824)|0);i=b;return}function ZX(a,b){a=a|0;b=b|0;b=i;IP(a,106848,5);i=b;return}function _X(a,b){a=a|0;b=b|0;b=i;qQ(a,106856,vZ(106856)|0);i=b;return}function $X(b){b=b|0;var d=0,e=0;b=i;if((a[106888]|0)!=0){d=106880;e=c[26720]|0;i=b;return e|0}if((Wa(106888)|0)==0){d=106880;e=c[26720]|0;i=b;return e|0}do{if((a[114088]|0)==0){if((Wa(114088)|0)==0){break}B_(113920,0,168)|0;Vd(192,0,q|0)|0;Pb(114088)}}while(0);TP(113920,114096)|0;TP(113932|0,114104)|0;TP(113944|0,114112)|0;TP(113956|0,114120)|0;TP(113968|0,114136)|0;TP(113980|0,114152)|0;TP(113992|0,114160)|0;TP(114004|0,114176)|0;TP(114016|0,114184)|0;TP(114028|0,114192)|0;TP(114040|0,114200)|0;TP(114052|0,114208)|0;TP(114064|0,114216)|0;TP(114076|0,114224)|0;c[26720]=113920;Pb(106888);d=106880;e=c[26720]|0;i=b;return e|0}function aY(b){b=b|0;var d=0,e=0;b=i;if((a[106904]|0)!=0){d=106896;e=c[26724]|0;i=b;return e|0}if((Wa(106904)|0)==0){d=106896;e=c[26724]|0;i=b;return e|0}do{if((a[113552]|0)==0){if((Wa(113552)|0)==0){break}B_(113384,0,168)|0;Vd(193,0,q|0)|0;Pb(113552)}}while(0);tQ(113384,113560)|0;tQ(113396|0,113592)|0;tQ(113408|0,113624)|0;tQ(113420|0,113656)|0;tQ(113432|0,113696)|0;tQ(113444|0,113736)|0;tQ(113456|0,113768)|0;tQ(113468|0,113808)|0;tQ(113480|0,113824)|0;tQ(113492|0,113840)|0;tQ(113504|0,113856)|0;tQ(113516|0,113872)|0;tQ(113528|0,113888)|0;tQ(113540|0,113904)|0;c[26724]=113384;Pb(106904);d=106896;e=c[26724]|0;i=b;return e|0}function bY(b){b=b|0;var d=0,e=0;b=i;if((a[106920]|0)!=0){d=106912;e=c[26728]|0;i=b;return e|0}if((Wa(106920)|0)==0){d=106912;e=c[26728]|0;i=b;return e|0}do{if((a[113160]|0)==0){if((Wa(113160)|0)==0){break}B_(112872,0,288)|0;Vd(194,0,q|0)|0;Pb(113160)}}while(0);TP(112872,113168)|0;TP(112884|0,113176)|0;TP(112896|0,113192)|0;TP(112908|0,113200)|0;TP(112920|0,113208)|0;TP(112932|0,113216)|0;TP(112944|0,113224)|0;TP(112956|0,113232)|0;TP(112968|0,113240)|0;TP(112980|0,113256)|0;TP(112992|0,113264)|0;TP(113004|0,113280)|0;TP(113016|0,113296)|0;TP(113028|0,113304)|0;TP(113040|0,113312)|0;TP(113052|0,113320)|0;TP(113064|0,113208)|0;TP(113076|0,113328)|0;TP(113088|0,113336)|0;TP(113100|0,113344)|0;TP(113112|0,113352)|0;TP(113124|0,113360)|0;TP(113136|0,113368)|0;TP(113148|0,113376)|0;c[26728]=112872;Pb(106920);d=106912;e=c[26728]|0;i=b;return e|0}function cY(b){b=b|0;var d=0,e=0;b=i;if((a[106936]|0)!=0){d=106928;e=c[26732]|0;i=b;return e|0}if((Wa(106936)|0)==0){d=106928;e=c[26732]|0;i=b;return e|0}do{if((a[112320]|0)==0){if((Wa(112320)|0)==0){break}B_(112032,0,288)|0;Vd(195,0,q|0)|0;Pb(112320)}}while(0);tQ(112032,112328)|0;tQ(112044|0,112360)|0;tQ(112056|0,112400)|0;tQ(112068|0,112424)|0;tQ(112080|0,112744)|0;tQ(112092|0,112448)|0;tQ(112104|0,112472)|0;tQ(112116|0,112496)|0;tQ(112128|0,112528)|0;tQ(112140|0,112568)|0;tQ(112152|0,112600)|0;tQ(112164|0,112640)|0;tQ(112176|0,112680)|0;tQ(112188|0,112696)|0;tQ(112200|0,112712)|0;tQ(112212|0,112728)|0;tQ(112224|0,112744)|0;tQ(112236|0,112760)|0;tQ(112248|0,112776)|0;tQ(112260|0,112792)|0;tQ(112272|0,112808)|0;tQ(112284|0,112824)|0;tQ(112296|0,112840)|0;tQ(112308|0,112856)|0;c[26732]=112032;Pb(106936);d=106928;e=c[26732]|0;i=b;return e|0}function dY(b){b=b|0;var d=0,e=0;b=i;if((a[106952]|0)!=0){d=106944;e=c[26736]|0;i=b;return e|0}if((Wa(106952)|0)==0){d=106944;e=c[26736]|0;i=b;return e|0}do{if((a[112008]|0)==0){if((Wa(112008)|0)==0){break}B_(111720,0,288)|0;Vd(196,0,q|0)|0;Pb(112008)}}while(0);TP(111720,112016)|0;TP(111732|0,112024)|0;c[26736]=111720;Pb(106952);d=106944;e=c[26736]|0;i=b;return e|0}function eY(b){b=b|0;var d=0,e=0;b=i;if((a[106968]|0)!=0){d=106960;e=c[26740]|0;i=b;return e|0}if((Wa(106968)|0)==0){d=106960;e=c[26740]|0;i=b;return e|0}do{if((a[111680]|0)==0){if((Wa(111680)|0)==0){break}B_(111392,0,288)|0;Vd(197,0,q|0)|0;Pb(111680)}}while(0);tQ(111392,111688)|0;tQ(111404|0,111704)|0;c[26740]=111392;Pb(106968);d=106960;e=c[26740]|0;i=b;return e|0}function fY(b){b=b|0;var c=0;b=i;if((a[106992]|0)!=0){c=106976;i=b;return c|0}if((Wa(106992)|0)==0){c=106976;i=b;return c|0}IP(106976,107e3,8);Vd(198,106976,q|0)|0;Pb(106992);c=106976;i=b;return c|0}function gY(b){b=b|0;var c=0;b=i;if((a[107032]|0)!=0){c=107016;i=b;return c|0}if((Wa(107032)|0)==0){c=107016;i=b;return c|0}qQ(107016,107040,vZ(107040)|0);Vd(199,107016,q|0)|0;Pb(107032);c=107016;i=b;return c|0}function hY(b){b=b|0;var c=0;b=i;if((a[107096]|0)!=0){c=107080;i=b;return c|0}if((Wa(107096)|0)==0){c=107080;i=b;return c|0}IP(107080,107104,8);Vd(198,107080,q|0)|0;Pb(107096);c=107080;i=b;return c|0}function iY(b){b=b|0;var c=0;b=i;if((a[107136]|0)!=0){c=107120;i=b;return c|0}if((Wa(107136)|0)==0){c=107120;i=b;return c|0}qQ(107120,107144,vZ(107144)|0);Vd(199,107120,q|0)|0;Pb(107136);c=107120;i=b;return c|0}function jY(b){b=b|0;var c=0;b=i;if((a[107200]|0)!=0){c=107184;i=b;return c|0}if((Wa(107200)|0)==0){c=107184;i=b;return c|0}IP(107184,107208,20);Vd(198,107184,q|0)|0;Pb(107200);c=107184;i=b;return c|0}function kY(b){b=b|0;var c=0;b=i;if((a[107248]|0)!=0){c=107232;i=b;return c|0}if((Wa(107248)|0)==0){c=107232;i=b;return c|0}qQ(107232,107256,vZ(107256)|0);Vd(199,107232,q|0)|0;Pb(107248);c=107232;i=b;return c|0}function lY(b){b=b|0;var c=0;b=i;if((a[107360]|0)!=0){c=107344;i=b;return c|0}if((Wa(107360)|0)==0){c=107344;i=b;return c|0}IP(107344,107368,11);Vd(198,107344,q|0)|0;Pb(107360);c=107344;i=b;return c|0}function mY(b){b=b|0;var c=0;b=i;if((a[107400]|0)!=0){c=107384;i=b;return c|0}if((Wa(107400)|0)==0){c=107384;i=b;return c|0}qQ(107384,107408,vZ(107408)|0);Vd(199,107384,q|0)|0;Pb(107400);c=107384;i=b;return c|0}function nY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Kc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);l=+r_(b,g,c[26616]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function oY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Kc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);l=+r_(b,g,c[26616]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function pY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Kc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);l=+r_(b,g,c[26616]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=l;i=f;return+h}function qY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Kc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);n=ib(b|0,h|0,f|0,c[26616]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)!=34){j=n;k=f;J=k;i=g;return j|0}c[e>>2]=4;j=-1;k=-1;J=k;i=g;return j|0}function rY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Kc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);m=ib(b|0,h|0,f|0,c[26616]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function sY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Kc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);m=ib(b|0,h|0,f|0,c[26616]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function tY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Kc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);m=ib(b|0,h|0,f|0,c[26616]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>65535)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function uY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Kc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);n=Dc(b|0,h|0,f|0,c[26616]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)==34){c[e>>2]=4;e=(f|0)>0|(f|0)==0&n>>>0>0;J=e?2147483647:-2147483648;i=g;return(e?-1:0)|0}else{j=n;k=f;J=k;i=g;return j|0}return 0}function vY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=Kc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[106472]|0)==0){if((Wa(106472)|0)==0){break}c[26616]=Vb(2147483647,106480,0)|0;Pb(106472)}}while(0);m=Dc(b|0,h|0,f|0,c[26616]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}do{if((b|0)==34){c[e>>2]=4;if((f|0)>0|(f|0)==0&m>>>0>0){j=2147483647}else{break}i=g;return j|0}else{if((f|0)<-1|(f|0)==-1&m>>>0<2147483648){c[e>>2]=4;break}if((f|0)>0|(f|0)==0&m>>>0>2147483647){c[e>>2]=4;j=2147483647;i=g;return j|0}else{j=m;i=g;return j|0}}}while(0);j=-2147483648;i=g;return j|0}function wY(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;e=a+4|0;f=e;g=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=e+4|0;e=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=(c[a>>2]|0)+(e>>1)|0;a=f;if((e&1|0)==0){h=g;be[h&255](a);i=b;return}else{h=c[(c[f>>2]|0)+g>>2]|0;be[h&255](a);i=b;return}}function xY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b+8|0;g=b+4|0;h=c[g>>2]|0;j=c[f>>2]|0;k=h;if(!(j-k>>2>>>0<d>>>0)){l=d;m=h;do{if((m|0)==0){n=0}else{c[m>>2]=0;n=c[g>>2]|0}m=n+4|0;c[g>>2]=m;l=l+ -1|0;}while((l|0)!=0);i=e;return}l=b+16|0;m=b;n=c[m>>2]|0;h=k-n>>2;k=h+d|0;if(k>>>0>1073741823){qW(0)}o=j-n|0;do{if(o>>2>>>0<536870911){n=o>>1;j=n>>>0<k>>>0?k:n;if((j|0)==0){p=0;q=0;break}n=b+128|0;if(!((a[n]|0)==0&j>>>0<29)){r=j;s=11;break}a[n]=1;p=j;q=l}else{r=1073741823;s=11}}while(0);if((s|0)==11){p=r;q=$Z(r<<2)|0}r=d;d=q+(h<<2)|0;do{if((d|0)==0){t=0}else{c[d>>2]=0;t=d}d=t+4|0;r=r+ -1|0;}while((r|0)!=0);r=c[m>>2]|0;t=(c[g>>2]|0)-r|0;s=q+(h-(t>>2)<<2)|0;h=r;z_(s|0,h|0,t|0)|0;c[m>>2]=s;c[g>>2]=d;c[f>>2]=q+(p<<2);if((r|0)==0){i=e;return}if((l|0)==(r|0)){a[b+128|0]=0;i=e;return}else{b_(h);i=e;return}}function yY(a){a=a|0;a=i;sQ(111668|0);sQ(111656|0);sQ(111644|0);sQ(111632|0);sQ(111620|0);sQ(111608|0);sQ(111596|0);sQ(111584|0);sQ(111572|0);sQ(111560|0);sQ(111548|0);sQ(111536|0);sQ(111524|0);sQ(111512|0);sQ(111500|0);sQ(111488|0);sQ(111476|0);sQ(111464|0);sQ(111452|0);sQ(111440|0);sQ(111428|0);sQ(111416|0);sQ(111404|0);sQ(111392);i=a;return}function zY(a){a=a|0;a=i;QP(111996|0);QP(111984|0);QP(111972|0);QP(111960|0);QP(111948|0);QP(111936|0);QP(111924|0);QP(111912|0);QP(111900|0);QP(111888|0);QP(111876|0);QP(111864|0);QP(111852|0);QP(111840|0);QP(111828|0);QP(111816|0);QP(111804|0);QP(111792|0);QP(111780|0);QP(111768|0);QP(111756|0);QP(111744|0);QP(111732|0);QP(111720);i=a;return}function AY(a){a=a|0;a=i;sQ(112308|0);sQ(112296|0);sQ(112284|0);sQ(112272|0);sQ(112260|0);sQ(112248|0);sQ(112236|0);sQ(112224|0);sQ(112212|0);sQ(112200|0);sQ(112188|0);sQ(112176|0);sQ(112164|0);sQ(112152|0);sQ(112140|0);sQ(112128|0);sQ(112116|0);sQ(112104|0);sQ(112092|0);sQ(112080|0);sQ(112068|0);sQ(112056|0);sQ(112044|0);sQ(112032);i=a;return}function BY(a){a=a|0;a=i;QP(113148|0);QP(113136|0);QP(113124|0);QP(113112|0);QP(113100|0);QP(113088|0);QP(113076|0);QP(113064|0);QP(113052|0);QP(113040|0);QP(113028|0);QP(113016|0);QP(113004|0);QP(112992|0);QP(112980|0);QP(112968|0);QP(112956|0);QP(112944|0);QP(112932|0);QP(112920|0);QP(112908|0);QP(112896|0);QP(112884|0);QP(112872);i=a;return}function CY(a){a=a|0;a=i;sQ(113540|0);sQ(113528|0);sQ(113516|0);sQ(113504|0);sQ(113492|0);sQ(113480|0);sQ(113468|0);sQ(113456|0);sQ(113444|0);sQ(113432|0);sQ(113420|0);sQ(113408|0);sQ(113396|0);sQ(113384);i=a;return}function DY(a){a=a|0;a=i;QP(114076|0);QP(114064|0);QP(114052|0);QP(114040|0);QP(114028|0);QP(114016|0);QP(114004|0);QP(113992|0);QP(113980|0);QP(113968|0);QP(113956|0);QP(113944|0);QP(113932|0);QP(113920);i=a;return}function EY(a){a=a|0;var b=0,c=0;b=i;if((KY(a)|0)==0){c=(FY(a)|0)!=0|0}else{c=1}i=b;return c|0}function FY(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<131072){c=(d[114232+((d[114232+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}else{c=a>>>0<196606|0;i=b;return c|0}return 0}function GY(a){a=a|0;var b=0,c=0;b=i;c=ub(a|0)|0;i=b;return c|0}function HY(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<32|(a+ -127|0)>>>0<33|(a+ -8232|0)>>>0<2){c=1;i=b;return c|0}c=(a+ -65529|0)>>>0<3|0;i=b;return c|0}function IY(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;switch(b|0){case 10:{d=PY(a)|0;break};case 3:{d=GY(a)|0;break};case 4:{d=HY(a)|0;break};case 8:{d=NY(a)|0;break};case 11:{d=QY(a)|0;break};case 9:{d=OY(a)|0;break};case 1:{d=EY(a)|0;break};case 7:{d=MY(a)|0;break};case 6:{d=LY(a)|0;break};case 5:{d=KY(a)|0;break};case 12:{d=RY(a)|0;break};case 2:{d=FY(a)|0;break};default:{d=0}}i=c;return d|0}function JY(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;c=i;d=a[b]|0;e=97;f=1;g=117208;while(1){if(d<<24>>24==e<<24>>24){if((t_(b,g)|0)==0){h=f;j=5;break}}k=g+6|0;l=a[k]|0;if(l<<24>>24==0){h=0;j=5;break}else{e=l;f=f+1|0;g=k}}if((j|0)==5){i=c;return h|0}return 0}function KY(a){a=a|0;i=i;return(a+ -48|0)>>>0<10|0}function LY(a){a=a|0;var b=0,c=0;b=i;if((PY(a)|0)==0){c=(NY(a)|0)!=0|0}else{c=0}i=b;return c|0}function MY(a){a=a|0;var b=0,c=0;b=i;if((SY(a)|0)==(a|0)){c=(a|0)==223|0}else{c=1}i=b;return c|0}function NY(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<255){c=(a+1&127)>>>0>32|0;i=b;return c|0}if(a>>>0<8232|(a+ -8234|0)>>>0<47062|(a+ -57344|0)>>>0<8185){c=1;i=b;return c|0}else{i=b;return((a+ -65532|0)>>>0>1048579|(a&65534|0)==65534)&1^1|0}return 0}function OY(a){a=a|0;var b=0,c=0;b=i;if(!(a>>>0<131072)){c=0;i=b;return c|0}c=(d[117288+((d[117288+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}function PY(a){a=a|0;var b=0,c=0;b=i;c=(uZ(120456,a)|0)!=0|0;i=b;return c|0}function QY(a){a=a|0;var b=0,c=0;b=i;c=(UY(a)|0)!=(a|0)|0;i=b;return c|0}function RY(a){a=a|0;var b=0,c=0;b=i;if((a+ -48|0)>>>0<10){c=1;i=b;return c|0}c=((a|32)+ -97|0)>>>0<6|0;i=b;return c|0}function SY(a){a=a|0;var b=0,c=0;b=i;c=TY(a,0)|0;i=b;return c|0}function TY(c,f){c=c|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=(f<<1)+ -1|0;j=f+ -1|0;if((FY(c)|0)==0|(c+ -1536|0)>>>0<2560|(c+ -11776|0)>>>0<30784|(c+ -43008|0)>>>0<22272){k=c;i=g;return k|0}do{if((f|0)==0){if(!((c+ -11520|0)>>>0<38)){l=0;break}k=c+ -7264|0;i=g;return k|0}else{if(!((c+ -4256|0)>>>0<46)){l=0;break}do{if((c|0)>4293){if((c|0)==4295|(c|0)==4301){break}else{k=c}i=g;return k|0}}while(0);k=c+7264|0;i=g;return k|0}}while(0);while(1){m=a[120546+(l<<2)|0]|0;n=m<<24>>24;o=c-(e[120544+(l<<2)>>1]|0)|0;p=l+1|0;if((o-(n&j)|0)>>>0<(d[120547+(l<<2)|0]|0)>>>0){q=12;break}if((p|0)==61){break}else{l=p}}if((q|0)==12){if(m<<24>>24==1){k=f+c-(o&1)|0;i=g;return k|0}else{k=(fa(n,h)|0)+c|0;i=g;return k|0}}h=1-f|0;n=b[120792+(h<<1)>>1]|0;a:do{if(!(n<<16>>16==0)){o=n;m=0;while(1){q=m+1|0;if((o&65535|0)==(c|0)){break}l=b[120792+(q<<2)+(h<<1)>>1]|0;if(l<<16>>16==0){break a}else{o=l;m=q}}k=e[120792+(m<<2)+(f<<1)>>1]|0;i=g;return k|0}}while(0);if(!((c+ -66600+(f*40|0)|0)>>>0<40)){k=c;i=g;return k|0}k=c+ -40+(f*80|0)|0;i=g;return k|0}function UY(a){a=a|0;var b=0,c=0;b=i;c=TY(a,1)|0;i=b;return c|0}function VY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=WY(0,a,b,(c|0)!=0?c:121496)|0;i=d;return e|0}function WY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+8|0;h=g;c[h>>2]=b;j=(f|0)==0?121504:f;f=c[j>>2]|0;a:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n+ -194|0;if(l>>>0>50){break a}o=e+ -1|0;p=c[121288+(l<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}}while(0);b:do{if((o|0)==0){r=p}else{l=a[q]|0;n=(l&255)>>>3;if((n+ -16|n+(p>>26))>>>0>7){break a}else{s=o;t=l;u=p;v=q}while(1){v=v+1|0;u=(t&255)+ -128|u<<6;s=s+ -1|0;if((u|0)>=0){break}if((s|0)==0){r=u;break b}t=a[v]|0;if(((t&255)+ -128|0)>>>0>63){break a}}c[j>>2]=0;c[m>>2]=u;k=e-s|0;i=g;return k|0}}while(0);c[j>>2]=r;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(Kc()|0)>>2]=84;k=-1;i=g;return k|0}function XY(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+1032|0;h=g+1024|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=g;m=k?e:256;e=k?a:l;a:do{if((j|0)==0|(m|0)==0){n=d;o=m;p=j;q=0;r=e}else{a=d;s=m;t=j;u=0;v=e;while(1){w=a>>>2;x=w>>>0>=s>>>0;if(!(x|a>>>0>131)){n=a;o=s;p=t;q=u;r=v;break a}y=x?s:w;z=a-y|0;w=YY(v,h,y,f)|0;if((w|0)==-1){break}if((v|0)==(l|0)){A=s;B=l}else{A=s-w|0;B=v+(w<<2)|0}y=w+u|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){n=z;o=A;p=w;q=y;r=B;break a}else{a=z;s=A;t=w;u=y;v=B}}n=z;o=0;p=c[h>>2]|0;q=-1;r=v}}while(0);b:do{if((p|0)==0){C=q}else{if((o|0)==0|(n|0)==0){C=q;break}else{D=n;E=o;F=p;G=q;H=r}while(1){I=WY(H,F,D,f)|0;if((I+2|0)>>>0<3){break}z=(c[h>>2]|0)+I|0;c[h>>2]=z;B=E+ -1|0;A=G+1|0;if((B|0)==0|(D|0)==(I|0)){C=A;break b}else{D=D-I|0;E=B;F=z;G=A;H=H+4|0}}if((I|0)==0){c[h>>2]=0;C=G;break}else if((I|0)==-1){C=-1;break}else{c[f>>2]=0;C=G;break}}}while(0);if(!k){i=g;return C|0}c[b>>2]=c[h>>2];i=g;return C|0}function YY(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;h=i;j=c[e>>2]|0;do{if((g|0)==0){k=5}else{l=g;m=c[l>>2]|0;if((m|0)==0){k=5;break}if((b|0)==0){n=f;o=m;p=j;k=16;break}c[l>>2]=0;q=b;r=f;s=m;t=j;k=36}}while(0);if((k|0)==5){if((b|0)==0){u=f;v=j;k=7}else{w=b;x=f;y=j;k=6}}a:while(1){if((k|0)==6){k=0;if((x|0)==0){z=f;k=53;break}else{A=w;B=x;C=y}while(1){j=a[C]|0;do{if(((j&255)+ -1|0)>>>0<127){if((C&3|0)==0&B>>>0>3){D=A;E=B;F=C}else{G=A;H=B;I=j;J=C;break}while(1){K=c[F>>2]|0;if(((K+ -16843009|K)&-2139062144|0)!=0){k=30;break}c[D>>2]=K&255;c[D+4>>2]=d[F+1|0]|0;c[D+8>>2]=d[F+2|0]|0;L=F+4|0;M=D+16|0;c[D+12>>2]=d[F+3|0]|0;N=E+ -4|0;if(N>>>0>3){D=M;E=N;F=L}else{k=31;break}}if((k|0)==30){k=0;G=D;H=E;I=K&255;J=F;break}else if((k|0)==31){k=0;G=M;H=N;I=a[L]|0;J=L;break}}else{G=A;H=B;I=j;J=C}}while(0);O=I&255;if(!((O+ -1|0)>>>0<127)){break}c[G>>2]=O;j=H+ -1|0;if((j|0)==0){z=f;k=53;break a}else{A=G+4|0;B=j;C=J+1|0}}j=O+ -194|0;if(j>>>0>50){P=G;Q=H;R=J;k=47;break}q=G;r=H;s=c[121288+(j<<2)>>2]|0;t=J+1|0;k=36;continue}else if((k|0)==7){k=0;j=a[v]|0;do{if(((j&255)+ -1|0)>>>0<127){if((v&3|0)!=0){S=u;T=j;U=v;break}g=c[v>>2]|0;if(((g+ -16843009|g)&-2139062144|0)==0){V=u;W=v}else{S=u;T=g&255;U=v;break}do{W=W+4|0;V=V+ -4|0;X=c[W>>2]|0;}while(((X+ -16843009|X)&-2139062144|0)==0);S=V;T=X&255;U=W}else{S=u;T=j;U=v}}while(0);j=T&255;if((j+ -1|0)>>>0<127){u=S+ -1|0;v=U+1|0;k=7;continue}g=j+ -194|0;if(g>>>0>50){P=b;Q=S;R=U;k=47;break}n=S;o=c[121288+(g<<2)>>2]|0;p=U+1|0;k=16;continue}else if((k|0)==16){k=0;g=(d[p]|0)>>>3;if((g+ -16|g+(o>>26))>>>0>7){k=17;break}g=p+1|0;do{if((o&33554432|0)==0){Y=g}else{if(((d[g]|0)+ -128|0)>>>0>63){k=20;break a}j=p+2|0;if((o&524288|0)==0){Y=j;break}if(((d[j]|0)+ -128|0)>>>0>63){k=23;break a}Y=p+3|0}}while(0);u=n+ -1|0;v=Y;k=7;continue}else if((k|0)==36){k=0;g=d[t]|0;j=g>>>3;if((j+ -16|j+(s>>26))>>>0>7){k=37;break}j=t+1|0;Z=g+ -128|s<<6;do{if((Z|0)<0){g=(d[j]|0)+ -128|0;if(g>>>0>63){k=40;break a}m=t+2|0;_=g|Z<<6;if((_|0)>=0){$=_;aa=m;break}g=(d[m]|0)+ -128|0;if(g>>>0>63){k=43;break a}$=g|_<<6;aa=t+3|0}else{$=Z;aa=j}}while(0);c[q>>2]=$;w=q+4|0;x=r+ -1|0;y=aa;k=6;continue}}if((k|0)==17){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==20){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==23){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==37){ba=q;ca=r;da=s;ea=t+ -1|0;k=46}else if((k|0)==40){ba=q;ca=r;da=Z;ea=t+ -1|0;k=46}else if((k|0)==43){ba=q;ca=r;da=_;ea=t+ -1|0;k=46}else if((k|0)==53){i=h;return z|0}if((k|0)==46){if((da|0)==0){P=ba;Q=ca;R=ea;k=47}else{fa=ba;ga=ea}}do{if((k|0)==47){if((a[R]|0)!=0){fa=P;ga=R;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}z=f-Q|0;i=h;return z|0}}while(0);c[(Kc()|0)>>2]=84;if((fa|0)==0){z=-1;i=h;return z|0}c[e>>2]=ga;z=-1;i=h;return z|0}function ZY(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m+ -194|0;if(k>>>0>50){break}m=e+1|0;n=c[121288+(k<<2)>>2]|0;if(f>>>0<4){if((n&-2147483648>>>((f*6|0)+ -6|0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m+ -16|m+(n>>26))>>>0>7){break}m=k+ -128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)+ -128|0;if(n>>>0>63){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)+ -128|0;if(m>>>0>63){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(Kc()|0)>>2]=84;j=-1;i=g;return j|0}function _Y(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((b|0)==0){f=1;i=e;return f|0}if(d>>>0<128){a[b]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d+ -57344|0)>>>0<8192){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;i=e;return f|0}if((d+ -65536|0)>>>0<1048576){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;i=e;return f|0}else{c[(Kc()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function $Y(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+264|0;g=f+256|0;h=f;j=c[b>>2]|0;c[g>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:h;a:do{if((j|0)==0|(l|0)==0){m=d;n=l;o=j;p=0;q=e}else{a=d;r=l;s=j;t=0;u=e;while(1){v=a>>>0>=r>>>0;if(!(v|a>>>0>32)){m=a;n=r;o=s;p=t;q=u;break a}w=v?r:a;x=a-w|0;v=aZ(u,g,w,0)|0;if((v|0)==-1){break}if((u|0)==(h|0)){y=r;z=h}else{y=r-v|0;z=u+v|0}w=v+t|0;v=c[g>>2]|0;if((v|0)==0|(y|0)==0){m=x;n=y;o=v;p=w;q=z;break a}else{a=x;r=y;s=v;t=w;u=z}}m=x;n=0;o=c[g>>2]|0;p=-1;q=u}}while(0);b:do{if((o|0)==0){A=p}else{if((n|0)==0|(m|0)==0){A=p;break}else{B=m;C=n;D=o;E=p;F=q}while(1){G=_Y(F,c[D>>2]|0,0)|0;if((G+1|0)>>>0<2){break}x=(c[g>>2]|0)+4|0;c[g>>2]=x;z=B+ -1|0;y=E+1|0;if((C|0)==(G|0)|(z|0)==0){A=y;break b}else{B=z;C=C-G|0;D=x;E=y;F=F+G|0}}if((G|0)!=0){A=-1;break}c[g>>2]=0;A=E}}while(0);if(!k){i=f;return A|0}c[b>>2]=c[g>>2];i=f;return A|0}function aZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f;if((b|0)==0){h=c[d>>2]|0;j=g;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=k;o=h}while(1){if(n>>>0>127){h=_Y(j,n,0)|0;if((h|0)==-1){l=-1;p=26;break}else{q=h}}else{q=1}h=q+m|0;k=o+4|0;r=c[k>>2]|0;if((r|0)==0){l=h;p=26;break}else{m=h;n=r;o=k}}if((p|0)==26){i=f;return l|0}}a:do{if(e>>>0>3){o=b;n=e;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break a}if(q>>>0>127){j=_Y(o,q,0)|0;if((j|0)==-1){l=-1;break}u=o+j|0;v=n-j|0;w=m}else{a[o]=q;u=o+1|0;v=n+ -1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3){o=u;n=v;m=q}else{s=u;t=v;break a}}i=f;return l|0}else{s=b;t=e}}while(0);b:do{if((t|0)==0){x=0}else{b=g;v=s;u=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127){n=_Y(b,m,0)|0;if((n|0)==-1){l=-1;p=26;break}if(n>>>0>u>>>0){p=20;break}_Y(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u+ -1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break b}else{v=y;u=z;w=m}}if((p|0)==20){l=e-u|0;i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}else if((p|0)==26){i=f;return l|0}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}function bZ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;f=i;i=i+104|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=VZ(20)|0;q=p;if((p|0)==0){r=12;i=f;return r|0}s=VZ(2048)|0;c[p+16>>2]=s;if((s|0)==0){WZ(p);r=12;i=f;return r|0}c[p>>2]=512;c[p+4>>2]=10240;c[p+8>>2]=128;c[p+12>>2]=0;s=rZ(0,0)|0;if((s|0)==0){WZ(c[p+16>>2]|0);WZ(p);r=12;i=f;return r|0}t=o+0|0;u=t+44|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));c[o>>2]=s;c[o+4>>2]=q;c[o+12>>2]=d;c[o+36>>2]=e;d=o+28|0;c[d>>2]=-1;t=cZ(o)|0;a:do{if((t|0)==0){u=o+20|0;v=c[u>>2]|0;w=v+ -1|0;c[b>>2]=w;x=c[o+8>>2]|0;y=c[d>>2]|0;if((y|0)>-1){if((c[o+32>>2]|0)!=0){z=0;A=2;B=0;C=0;break}}if((y|0)>(w|0)){z=0;A=6;B=0;C=0;break}w=XZ(1,68)|0;D=w;if((w|0)==0){z=0;A=12;B=0;C=D;break}E=y>>>31;c[w+60>>2]=E^1;c[w+64>>2]=c[o+32>>2];c[w+28>>2]=v;if((E|0)==1){if((e&8|0)==0){F=13}else{G=0}}else{F=13}if((F|0)==13){E=dZ(0,q,x,D)|0;if((E|0)!=0){z=0;A=E;B=0;C=D;break}E=c[w+40>>2]|0;if((E|0)>0){v=(E<<2)+4|0;y=VZ(v)|0;H=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[w+32>>2]=H;B_(y|0,-1,v|0)|0;I=H}else{I=0}H=XZ(E<<1|1,4)|0;c[w+36>>2]=H;if((H|0)==0){z=0;A=12;B=0;C=D;break}H=XZ(c[u>>2]|0,12)|0;if((H|0)==0){z=0;A=12;B=0;C=D;break}c[w+16>>2]=H;H=dZ(s,q,x,D)|0;if((H|0)==0){G=I}else{z=0;A=H;B=0;C=D;break}}H=o+24|0;u=p+12|0;E=c[u>>2]|0;c[j>>2]=0;c[k>>2]=0;v=jZ(q,x)|0;b:do{if((v|0)==0){y=jZ(q,0)|0;if((y|0)!=0){J=y;break}y=p+16|0;K=c[u>>2]|0;c:do{if((K|0)>(E|0)){L=0;M=0;N=0;O=K;d:while(1){P=O+ -1|0;c[u>>2]=P;Q=c[y>>2]|0;R=c[Q+(P<<2)>>2]|0;P=O+ -2|0;c[u>>2]=P;S=c[Q+(P<<2)>>2]|0;do{if((R|0)==1){P=S+4|0;T=c[P>>2]|0;U=O+ -3|0;c[u>>2]=U;V=c[Q+(U<<2)>>2]|0;c[j>>2]=V;U=T+4|0;W=c[U>>2]|0;do{if((W|0)>1){c[l>>2]=0;X=T;F=51}else{if((c[T+8>>2]|0)<=1){Y=V;break}c[l>>2]=0;Z=T;if((W|0)>0){X=Z;F=51}else{_=W;$=Z;aa=V;ba=0;F=60}}}while(0);e:do{if((F|0)==51){F=0;Z=V;ca=W;da=1;ea=0;while(1){fa=kZ(s,q,c[X>>2]|0,(da|0)<(ca|0)?1:2,j,G,m,k)|0;if((fa|0)!=0){J=fa;break b}fa=c[m>>2]|0;if((ea|0)==0){ga=fa}else{ha=tZ(s,0,0,1,32)|0;if((ha|0)==0){J=12;break b}ia=tZ(s,0,0,1,8)|0;ja=ha+4|0;c[ja>>2]=ia;if((ia|0)==0){J=12;break b}c[ha>>2]=1;c[ha+8>>2]=-1;c[ha+12>>2]=-1;c[ia>>2]=ea;c[(c[ja>>2]|0)+4>>2]=fa;c[ha+16>>2]=(c[fa+16>>2]|0)+(c[ea+16>>2]|0);ga=ha}if((ga|0)==0){J=12;break b}ha=c[U>>2]|0;if((da|0)>=(ha|0)){_=ha;$=X;aa=Z;ba=ga;F=60;break e}Z=c[j>>2]|0;ca=ha;da=da+1|0;ea=ga}}}while(0);if((F|0)==60){F=0;U=T+8|0;W=c[U>>2]|0;do{if((W|0)==-1){ea=c[j>>2]|0;da=kZ(s,q,c[$>>2]|0,0,j,0,l,k)|0;if((da|0)!=0){J=da;break b}da=c[l>>2]|0;ca=tZ(s,0,0,1,32)|0;Z=ca;if((ca|0)==0){F=65;break d}ha=tZ(s,0,0,1,16)|0;c[ca+4>>2]=ha;if((ha|0)==0){F=65;break d}c[ca>>2]=2;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[ha>>2]=da;c[ha+4>>2]=0;c[ha+8>>2]=-1;fa=ha+12|0;a[fa]=a[fa]&-2;c[ca+16>>2]=c[da+16>>2];c[l>>2]=Z;ka=Z;la=ea}else{if((_|0)<(W|0)){ma=0;na=_}else{ka=0;la=aa;break}while(1){ea=c[j>>2]|0;Z=kZ(s,q,c[$>>2]|0,0,j,0,n,k)|0;if((Z|0)!=0){J=Z;break b}Z=c[n>>2]|0;if((ma|0)==0){oa=Z}else{da=tZ(s,0,0,1,32)|0;if((da|0)==0){F=73;break d}ca=tZ(s,0,0,1,8)|0;fa=da+4|0;c[fa>>2]=ca;if((ca|0)==0){F=73;break d}c[da>>2]=1;c[da+8>>2]=-1;c[da+12>>2]=-1;c[ca>>2]=Z;c[(c[fa>>2]|0)+4>>2]=ma;c[da+16>>2]=(c[ma+16>>2]|0)+(c[Z+16>>2]|0);oa=da}c[l>>2]=oa;if((oa|0)==0){J=12;break b}da=tZ(s,0,0,1,32)|0;if((da|0)==0){J=12;break b}Z=tZ(s,0,0,1,20)|0;c[da+4>>2]=Z;if((Z|0)==0){J=12;break b}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[Z>>2]=-1;c[Z+4>>2]=-1;c[Z+8>>2]=-1;Z=tZ(s,0,0,1,32)|0;fa=Z;if((Z|0)==0){F=79;break d}ca=tZ(s,0,0,1,8)|0;ha=Z+4|0;c[ha>>2]=ca;if((ca|0)==0){F=79;break d}c[Z>>2]=3;c[Z+8>>2]=-1;c[Z+12>>2]=-1;c[ca>>2]=da;c[(c[ha>>2]|0)+4>>2]=oa;c[Z+16>>2]=(c[oa+16>>2]|0)+(c[da+16>>2]|0);c[l>>2]=fa;da=na+1|0;if((da|0)<(c[U>>2]|0)){ma=fa;na=da}else{ka=fa;la=ea;break}}}}while(0);c[j>>2]=la;do{if((ba|0)==0){pa=ka;F=85}else{if((ka|0)==0){qa=ba;break}U=tZ(s,0,0,1,32)|0;if((U|0)==0){J=12;break b}W=tZ(s,0,0,1,8)|0;T=U+4|0;c[T>>2]=W;if((W|0)==0){J=12;break b}c[U>>2]=1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[W>>2]=ba;c[(c[T>>2]|0)+4>>2]=ka;c[U+16>>2]=(c[ka+16>>2]|0)+(c[ba+16>>2]|0);pa=U;F=85}}while(0);if((F|0)==85){F=0;if((pa|0)==0){J=12;break b}else{qa=pa}}c[P>>2]=c[qa+4>>2];c[S>>2]=c[qa>>2];Y=la}U=M+ -1|0;T=Y-V+N|0;if((U|0)!=0){ra=Y;sa=U;ta=T;break}c[j>>2]=T;ra=T;sa=0;ta=T}else if((R|0)==0){T=c[S>>2]|0;if((T|0)==1){U=c[S+4>>2]|0;W=jZ(q,c[U+4>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}W=jZ(q,0)|0;if((W|0)!=0){ua=N;va=W;break c}W=jZ(q,c[U>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}wa=jZ(q,0)|0}else if((T|0)==3){W=c[S+4>>2]|0;U=jZ(q,c[W+4>>2]|0)|0;if((U|0)!=0){ua=N;va=U;break c}U=jZ(q,0)|0;if((U|0)!=0){ua=N;va=U;break c}U=jZ(q,c[W>>2]|0)|0;if((U|0)!=0){ua=N;va=U;break c}wa=jZ(q,0)|0}else if((T|0)==2){U=c[S+4>>2]|0;W=jZ(q,L)|0;if((W|0)!=0){ua=N;va=W;break c}W=jZ(q,S)|0;if((W|0)!=0){ua=N;va=W;break c}W=jZ(q,1)|0;if((W|0)!=0){ua=N;va=W;break c}W=jZ(q,c[U>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}W=jZ(q,0)|0;if((W|0)!=0){ua=N;va=W;break c}if((c[U+4>>2]|0)>1){F=45}else{if((c[U+8>>2]|0)>1){F=45}else{xa=L}}if((F|0)==45){F=0;c[j>>2]=0;xa=0}ra=xa;sa=M+1|0;ta=N;break}else if((T|0)==0){T=c[S+4>>2]|0;U=c[T>>2]|0;if(!((U|0)>-1|(U|0)==-4)){ra=L;sa=M;ta=N;break}U=T+8|0;T=(c[U>>2]|0)+L|0;c[U>>2]=T;if((T|0)<=(c[k>>2]|0)){ra=L;sa=M;ta=N;break}c[k>>2]=T;ra=L;sa=M;ta=N;break}else{ra=L;sa=M;ta=N;break}if((wa|0)==0){ra=L;sa=M;ta=N}else{ua=N;va=wa;break c}}else{ra=L;sa=M;ta=N}}while(0);S=c[u>>2]|0;if((S|0)>(E|0)){L=ra;M=sa;N=ta;O=S}else{ua=ta;va=0;break c}}if((F|0)==65){c[l>>2]=0;J=12;break b}else if((F|0)==73){c[l>>2]=0;J=12;break b}else if((F|0)==79){c[l>>2]=0;J=12;break b}}else{ua=0;va=0}}while(0);y=(c[H>>2]|0)+ua|0;K=c[k>>2]|0;c[H>>2]=(K|0)>(y|0)?K:y;J=va}else{J=v}}while(0);if((J|0)!=0){z=0;A=J;B=0;C=D;break}v=c[H>>2]|0;c[H>>2]=v+1;E=tZ(s,0,0,1,32)|0;if((E|0)==0){z=0;A=12;B=0;C=D;break}y=tZ(s,0,0,1,20)|0;c[E+4>>2]=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[E>>2]=0;c[E+8>>2]=-1;c[E+12>>2]=-1;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=v;v=tZ(s,0,0,1,32)|0;y=v;if((v|0)==0){z=0;A=12;B=0;C=D;break}K=tZ(s,0,0,1,8)|0;O=v+4|0;c[O>>2]=K;if((K|0)==0){z=0;A=12;B=0;C=D;break}c[v>>2]=1;c[v+8>>2]=-1;c[v+12>>2]=-1;c[K>>2]=x;c[(c[O>>2]|0)+4>>2]=E;c[v+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);E=c[u>>2]|0;O=jZ(q,v)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=jZ(q,0)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=c[u>>2]|0;f:do{if((O|0)>(E|0)){K=p+16|0;N=O;g:while(1){M=N+ -1|0;c[u>>2]=M;L=c[K>>2]|0;S=c[L+(M<<2)>>2]|0;M=N+ -2|0;c[u>>2]=M;ya=c[L+(M<<2)>>2]|0;do{if((S|0)==2){M=c[ya+4>>2]|0;L=c[M>>2]|0;R=L+8|0;if((c[R>>2]|0)==0){za=0}else{za=(c[(c[M+4>>2]|0)+8>>2]|0)!=0|0}c[ya+8>>2]=za;if((c[R>>2]|0)==0){c[ya+24>>2]=c[L+24>>2];Aa=M+4|0}else{R=iZ(q,L,0,0,g)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}Ba=VZ((c[g>>2]<<2)+4|0)|0;R=Ba;if((Ba|0)==0){z=0;A=12;B=0;C=D;break a}c[Ba>>2]=-1;c[h>>2]=0;Ca=iZ(q,c[M>>2]|0,R,h,0)|0;if((Ca|0)!=0){F=150;break g}L=M+4|0;Q=hZ(s,c[(c[L>>2]|0)+24>>2]|0,c[(c[M>>2]|0)+24>>2]|0,R,c[h>>2]|0)|0;R=ya+24|0;c[R>>2]=Q;WZ(Ba);if((c[R>>2]|0)==0){z=0;A=12;B=0;C=D;break a}else{Aa=L}}L=c[Aa>>2]|0;if((c[L+8>>2]|0)==0){c[ya+28>>2]=c[L+28>>2];break}R=iZ(q,L,0,0,g)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}Da=VZ((c[g>>2]<<2)+4|0)|0;R=Da;if((Da|0)==0){z=0;A=12;B=0;C=D;break a}c[Da>>2]=-1;c[h>>2]=0;Ea=iZ(q,c[Aa>>2]|0,R,h,0)|0;if((Ea|0)!=0){F=157;break g}L=hZ(s,c[(c[M>>2]|0)+28>>2]|0,c[(c[Aa>>2]|0)+28>>2]|0,R,c[h>>2]|0)|0;R=ya+28|0;c[R>>2]=L;WZ(Da);if((c[R>>2]|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==1){R=c[ya+4>>2]|0;L=c[R>>2]|0;M=R+4|0;Q=c[M>>2]|0;if((c[L+8>>2]|0)==0){Fa=(c[Q+8>>2]|0)!=0|0}else{Fa=1}c[ya+8>>2]=Fa;T=hZ(s,c[L+24>>2]|0,c[Q+24>>2]|0,0,0)|0;c[ya+24>>2]=T;if((T|0)==0){z=0;A=12;B=0;C=D;break a}T=hZ(s,c[(c[R>>2]|0)+28>>2]|0,c[(c[M>>2]|0)+28>>2]|0,0,0)|0;c[ya+28>>2]=T;if((T|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==3){T=c[ya+4>>2]|0;M=c[T>>2]|0;do{if((c[T+4>>2]|0)==0){F=141}else{if((c[M+8>>2]|0)!=0){F=141;break}c[ya+8>>2]=0}}while(0);if((F|0)==141){F=0;c[ya+8>>2]=1}c[ya+24>>2]=c[M+24>>2];c[ya+28>>2]=c[(c[T>>2]|0)+28>>2]}else if((S|0)==0){R=c[ya>>2]|0;if((R|0)==3){Q=jZ(q,ya)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=jZ(q,1)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=ya+4|0;L=jZ(q,c[(c[Q>>2]|0)+4>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=jZ(q,0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=jZ(q,c[c[Q>>2]>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=jZ(q,0)|0;if((L|0)==0){break}else{z=0;A=L;B=0;C=D;break a}}else if((R|0)==2){L=jZ(q,ya)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=jZ(q,3)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=jZ(q,c[c[ya+4>>2]>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=jZ(q,0)|0;if((L|0)==0){break}else{z=0;A=L;B=0;C=D;break a}}else if((R|0)==1){L=jZ(q,ya)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=jZ(q,2)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=ya+4|0;Q=jZ(q,c[(c[L>>2]|0)+4>>2]|0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=jZ(q,0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=jZ(q,c[c[L>>2]>>2]|0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=jZ(q,0)|0;if((Q|0)==0){break}else{z=0;A=Q;B=0;C=D;break a}}else if((R|0)==0){R=c[ya+4>>2]|0;Q=c[R>>2]|0;if((Q|0)==-4){c[ya+8>>2]=0;L=R+8|0;U=c[L>>2]|0;W=tZ(s,0,0,1,64)|0;if((W|0)==0){F=104;break g}ea=W;c[W>>2]=U;c[W+4>>2]=0;c[W+8>>2]=1114111;c[W+20>>2]=0;c[W+24>>2]=0;U=W+28|0;W=ya+24|0;c[U+0>>2]=-1;c[U+4>>2]=-1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[W>>2]=ea;ea=c[L>>2]|0;L=c[R+4>>2]|0;W=tZ(s,0,0,1,64)|0;if((W|0)==0){F=106;break g}c[W>>2]=ea;c[W+4>>2]=0;c[W+8>>2]=1114111;c[W+20>>2]=0;c[W+24>>2]=0;c[W+28>>2]=L;c[W+32>>2]=-1;c[W+36>>2]=-1;c[W+40>>2]=-1;c[ya+28>>2]=W;break}W=ya+8|0;if((Q|0)<0){c[W>>2]=1;L=tZ(s,0,0,1,32)|0;if((L|0)==0){F=110;break g}c[L>>2]=-1;c[L+4>>2]=-1;c[L+8>>2]=-1;c[ya+24>>2]=L;L=tZ(s,0,0,1,32)|0;if((L|0)==0){F=112;break g}c[L>>2]=-1;c[L+4>>2]=-1;c[L+8>>2]=-1;c[ya+28>>2]=L;break}else{c[W>>2]=0;W=R+8|0;L=c[W>>2]|0;ea=R+4|0;U=c[ea>>2]|0;fa=tZ(s,0,0,1,64)|0;if((fa|0)==0){F=115;break g}da=fa;c[fa>>2]=L;c[fa+4>>2]=Q;c[fa+8>>2]=U;c[fa+20>>2]=0;c[fa+24>>2]=0;U=fa+28|0;fa=ya+24|0;c[U+0>>2]=-1;c[U+4>>2]=-1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[fa>>2]=da;da=c[W>>2]|0;W=c[R>>2]|0;fa=c[ea>>2]|0;ea=c[R+12>>2]|0;U=c[R+16>>2]|0;R=tZ(s,0,0,1,64)|0;if((R|0)==0){F=117;break g}Q=R;c[R>>2]=da;c[R+4>>2]=W;c[R+8>>2]=fa;c[R+20>>2]=ea;c[R+24>>2]=U;U=R+28|0;R=ya+28|0;c[U+0>>2]=-1;c[U+4>>2]=-1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[R>>2]=Q;break}}else{break}}}while(0);N=c[u>>2]|0;if((N|0)<=(E|0)){break f}}if((F|0)==104){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==106){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==110){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==112){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==115){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==117){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==150){WZ(Ba);z=0;A=Ca;B=0;C=D;break a}else if((F|0)==157){WZ(Da);z=0;A=Ea;B=0;C=D;break a}}}while(0);E=c[H>>2]|0;u=E<<2;O=VZ(u)|0;x=O;if((O|0)==0){z=x;A=12;B=0;C=D;break}N=VZ(u)|0;u=N;if((N|0)==0){z=x;A=12;B=u;C=D;break}if((E|0)>0){B_(O|0,0,((E|0)>1?E<<2:4)|0)|0}eZ(y,0,x,0)|0;E=c[H>>2]|0;if((E|0)>0){K=0;S=0;while(1){c[N+(S<<2)>>2]=K;Q=O+(S<<2)|0;R=K+1+(c[Q>>2]|0)|0;c[Q>>2]=0;Q=S+1|0;if((Q|0)<(E|0)){S=Q;K=R}else{Ga=R;break}}}else{Ga=0}K=XZ(Ga+1|0,32)|0;S=K;if((K|0)==0){z=x;A=12;B=u;C=D;break}c[w>>2]=S;E=w+4|0;c[E>>2]=Ga;R=eZ(y,S,x,u)|0;if((R|0)!=0){z=x;A=R;B=u;C=D;break}c[w+20>>2]=0;R=v+24|0;S=c[R>>2]|0;if((c[S>>2]|0)>-1){Q=1;U=S;while(1){S=U+32|0;ea=Q+1|0;if((c[S>>2]|0)>-1){U=S;Q=ea}else{Ha=ea;break}}}else{Ha=1}Q=XZ(Ha,32)|0;if((Q|0)==0){z=x;A=12;B=u;C=D;break}c[w+8>>2]=Q;U=c[R>>2]|0;y=c[U>>2]|0;if((y|0)>-1){ea=y;y=U;U=0;while(1){c[Q+(U<<5)+8>>2]=K+(c[N+(ea<<2)>>2]<<5);c[Q+(U<<5)+12>>2]=ea;S=Q+(U<<5)+16|0;c[S>>2]=0;fa=y+12|0;W=c[fa>>2]|0;if((W|0)!=0){da=0;while(1){Ia=da+1|0;if((c[W+(da<<2)>>2]|0)>-1){da=Ia}else{break}}da=Ia<<2;W=VZ(da)|0;c[S>>2]=W;if((W|0)==0){z=x;A=12;B=u;C=D;break a}z_(W|0,c[fa>>2]|0,da|0)|0}c[Q+(U<<5)+20>>2]=c[y+16>>2];da=U+1|0;W=y+32|0;L=c[W>>2]|0;if((L|0)>-1){ea=L;y=W;U=da}else{Ja=da;break}}}else{Ja=0}c[Q+(Ja<<5)+8>>2]=0;c[E>>2]=Ga;c[w+12>>2]=K+(c[N+(c[c[v+28>>2]>>2]<<2)>>2]<<5);c[w+52>>2]=c[H>>2];c[w+56>>2]=e;sZ(s);WZ(c[p+16>>2]|0);WZ(p);WZ(O);WZ(N);c[b+4>>2]=w;r=0;i=f;return r|0}else{z=0;A=t;B=0;C=0}}while(0);sZ(s);WZ(c[p+16>>2]|0);WZ(p);if((z|0)!=0){WZ(z)}if((B|0)!=0){WZ(B)}c[b+4>>2]=C;fZ(b);r=A;i=f;return r|0}function cZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0;d=i;i=i+424|0;e=d;f=d+8|0;g=d+72|0;h=d+328|0;j=d+336|0;k=d+384|0;l=d+392|0;m=c[b+4>>2]|0;n=m+12|0;o=c[n>>2]|0;if((c[b+40>>2]|0)==0){p=b+20|0;jZ(m,c[p>>2]|0)|0;jZ(m,2)|0;c[p>>2]=(c[p>>2]|0)+1}p=jZ(m,0)|0;q=b+12|0;r=b+16|0;c[r>>2]=c[q>>2];s=c[n>>2]|0;t=(p|0)==0;a:do{if((s|0)>(o|0)&t){u=m+16|0;v=b+36|0;w=b;x=b+24|0;y=b+20|0;z=g;A=f;B=b+28|0;C=l;D=k;E=k+1|0;F=j;G=b;H=j+12|0;I=j+40|0;J=j+24|0;K=j+8|0;L=s;M=0;N=0;b:while(1){O=L+ -1|0;c[n>>2]=O;P=c[u>>2]|0;c:do{switch(c[P+(O<<2)>>2]|0){case 0:{if((c[v>>2]&1|0)!=0){Q=jZ(m,7)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}}U=M;V=N;W=jZ(m,3)|0;break};case 3:{Q=jZ(m,5)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}U=M;V=N;W=jZ(m,4)|0;break};case 7:{Q=c[q>>2]|0;X=a[Q]|0;if((X|0)==41){c[q>>2]=Q+1;U=M;V=N;W=0;break c}else if((X|0)!=124){U=M;V=N;W=0;break c}X=jZ(m,7)|0;if((X|0)!=0){R=M;S=X;T=6;break b}X=jZ(m,N)|0;if((X|0)!=0){R=M;S=X;T=6;break b}X=jZ(m,8)|0;if((X|0)!=0){R=M;S=X;T=6;break b}X=jZ(m,3)|0;if((X|0)!=0){R=M;S=X;T=6;break b}c[q>>2]=(c[q>>2]|0)+1;U=M;V=N;W=0;break};case 8:{X=L+ -2|0;c[n>>2]=X;Q=c[P+(X<<2)>>2]|0;X=c[w>>2]|0;Y=tZ(X,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}_=tZ(X,0,0,1,8)|0;X=Y+4|0;c[X>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[Y>>2]=3;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[_>>2]=Q;c[(c[X>>2]|0)+4>>2]=N;c[Y+16>>2]=(c[N+16>>2]|0)+(c[Q+16>>2]|0);U=M;V=Y;W=0;break};case 9:{Y=c[q>>2]|0;Q=a[Y]|0;switch(Q<<24>>24|0){case 63:case 43:{if((c[v>>2]&1|0)==0){U=M;V=N;W=0;break c}else{T=41}break};case 42:{T=41;break};case 92:{X=c[v>>2]|0;if((X&1|0)!=0){U=M;V=N;W=0;break c}_=Y+1|0;if((a[_]|0)!=123){U=M;V=N;W=0;break c}c[q>>2]=_;$=X;aa=_;break};case 123:{_=c[v>>2]|0;if((_&1|0)==0){U=M;V=N;W=0;break c}else{$=_;aa=Y}break};default:{U=M;V=N;W=0;break c}}if((T|0)==41){T=0;c[q>>2]=Y+1;Y=c[w>>2]|0;_=tZ(Y,0,0,1,32)|0;if((_|0)==0){Z=12;T=294;break b}X=tZ(Y,0,0,1,16)|0;c[_+4>>2]=X;if((X|0)==0){Z=12;T=294;break b}c[_>>2]=2;c[_+8>>2]=-1;c[_+12>>2]=-1;c[X>>2]=N;c[X+4>>2]=Q<<24>>24==43;c[X+8>>2]=Q<<24>>24==63?1:-1;Q=X+12|0;a[Q]=a[Q]&-2;c[_+16>>2]=c[N+16>>2];U=M;V=_;W=jZ(m,9)|0;break c}_=aa+1|0;c[q>>2]=_;Q=a[_]|0;if((Q+ -48<<24>>24&255)<10){X=Q<<24>>24;if((X+ -48|0)>>>0<10){ba=X;ca=-1;da=_}else{Z=10;T=294;break b}while(1){X=((ca|0)<0?-48:(ca*10|0)+ -48|0)+ba|0;Y=da+1|0;ea=a[Y]|0;fa=ea<<24>>24;if((fa+ -48|0)>>>0<10){da=Y;ca=X;ba=fa}else{ga=ea;ha=X;ia=Y;break}}}else{ga=Q;ha=-1;ia=_}do{if(ga<<24>>24==44){Y=ia+1|0;X=a[Y]|0;ea=X<<24>>24;if((ea+ -48|0)>>>0<10){ja=ea;ka=-1;la=Y}else{ma=X;na=-1;oa=Y;break}while(1){Y=((ka|0)<0?-48:(ka*10|0)+ -48|0)+ja|0;X=la+1|0;ea=a[X]|0;fa=ea<<24>>24;if((fa+ -48|0)>>>0<10){la=X;ka=Y;ja=fa}else{pa=ea;qa=Y;ra=X;T=54;break}}}else{pa=ga;qa=ha;ra=ia;T=54}}while(0);do{if((T|0)==54){T=0;if(!((qa|0)>-1)){ma=pa;na=qa;oa=ra;break}if((ha|0)>(qa|0)|(qa|0)>255){Z=10;T=294;break b}else{ma=pa;na=qa;oa=ra}}}while(0);if(ma<<24>>24==0){Z=9;T=294;break b}if((oa|0)==(_|0)){Z=10;T=294;break b}if(($&1|0)==0){if(!(ma<<24>>24==92)){Z=10;T=294;break b}if((a[oa+1|0]|0)!=125){Z=10;T=294;break b}sa=oa+2|0}else{if(!(ma<<24>>24==125)){Z=10;T=294;break b}sa=oa+1|0}if((na|ha|0)==0){Q=c[w>>2]|0;X=tZ(Q,0,0,1,32)|0;if((X|0)==0){Z=12;T=294;break b}Y=tZ(Q,0,0,1,20)|0;c[X+4>>2]=Y;if((Y|0)==0){Z=12;T=294;break b}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[Y>>2]=-1;c[Y+4>>2]=-1;c[Y+8>>2]=-1;ta=X}else{X=(na&ha|0)<0;Y=c[w>>2]|0;Q=tZ(Y,0,0,1,32)|0;if((Q|0)==0){Z=12;T=294;break b}ea=tZ(Y,0,0,1,16)|0;c[Q+4>>2]=ea;if((ea|0)==0){Z=12;T=294;break b}c[Q>>2]=2;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[ea>>2]=N;c[ea+4>>2]=X?1:ha;c[ea+8>>2]=X?1:na;X=ea+12|0;a[X]=a[X]&-2;c[Q+16>>2]=c[N+16>>2];ta=Q}c[q>>2]=sa;U=M;V=ta;W=jZ(m,9)|0;break};case 2:{Q=L+ -2|0;c[n>>2]=Q;X=c[P+(Q<<2)>>2]|0;if((c[N+12>>2]|0)>-1){Q=c[w>>2]|0;ea=tZ(Q,0,0,1,32)|0;if((ea|0)==0){Z=12;T=294;break b}Y=tZ(Q,0,0,1,20)|0;c[ea+4>>2]=Y;if((Y|0)==0){Z=12;T=294;break b}c[ea>>2]=0;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[Y>>2]=-1;c[Y+4>>2]=-1;c[Y+8>>2]=-1;Y=c[w>>2]|0;Q=tZ(Y,0,0,1,32)|0;if((Q|0)==0){Z=12;T=294;break b}fa=tZ(Y,0,0,1,8)|0;Y=Q+4|0;c[Y>>2]=fa;if((fa|0)==0){Z=12;T=294;break b}c[Q>>2]=1;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[fa>>2]=ea;c[(c[Y>>2]|0)+4>>2]=N;Y=N+16|0;fa=Q+16|0;c[fa>>2]=(c[Y>>2]|0)+(c[ea+16>>2]|0);c[fa>>2]=c[Y>>2];ua=Q}else{ua=N}c[ua+12>>2]=X;X=ua+16|0;c[X>>2]=(c[X>>2]|0)+1;U=M;V=ua;W=0;break};case 6:{X=L+ -2|0;c[n>>2]=X;Q=c[P+(X<<2)>>2]|0;X=c[w>>2]|0;Y=tZ(X,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}fa=tZ(X,0,0,1,8)|0;X=Y+4|0;c[X>>2]=fa;if((fa|0)==0){Z=12;T=294;break b}c[Y>>2]=1;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[fa>>2]=Q;c[(c[X>>2]|0)+4>>2]=N;c[Y+16>>2]=(c[N+16>>2]|0)+(c[Q+16>>2]|0);U=M;V=Y;W=0;break};case 1:{Y=c[q>>2]|0;d:do{switch(a[Y]|0){case 40:{if((c[v>>2]&1|0)!=0){va=Y;T=74}break};case 92:{Q=Y+1|0;X=a[Q]|0;do{if((c[v>>2]&1|0)==0){if(X<<24>>24==40){c[q>>2]=Q;va=Q;T=74;break d}else{fa=a[Y+1|0]|0;if(fa<<24>>24==41){T=265;break d}else{wa=fa;break}}}else{wa=X}}while(0);X=Y+1|0;Q=wa<<24>>24==0;if(Q){Z=5;T=294;break b}else{xa=121516|0;ya=0}while(1){fa=ya+1|0;if((a[121512+(ya<<3)|0]|0)==wa<<24>>24){za=xa;break}ea=121516+(fa<<3)|0;if((fa|0)==12){za=ea;break}else{xa=ea;ya=fa}}fa=c[za>>2]|0;if((fa|0)!=0){ea=F+0|0;Aa=G+0|0;Ba=ea+40|0;do{c[ea>>2]=c[Aa>>2];ea=ea+4|0;Aa=Aa+4|0}while((ea|0)<(Ba|0));c[H>>2]=fa;c[I>>2]=1;Aa=cZ(j)|0;if((Aa|0)!=0){Z=Aa;T=294;break b}c[q>>2]=(c[q>>2]|0)+2;c[x>>2]=c[J>>2];U=M;V=c[K>>2]|0;W=0;break c}if(Q){Z=5;T=294;break b}c[q>>2]=X;Aa=a[X]|0;e:do{switch(Aa|0){case 98:{ea=c[w>>2]|0;Ba=tZ(ea,0,0,1,32)|0;Ca=Ba;do{if((Ba|0)==0){Da=0}else{Ea=tZ(ea,0,0,1,20)|0;c[Ba+4>>2]=Ea;if((Ea|0)==0){Da=0;break}c[Ba>>2]=0;c[Ba+8>>2]=-1;c[Ba+12>>2]=-1;c[Ea>>2]=-2;c[Ea+4>>2]=64;c[Ea+8>>2]=-1;Da=Ca}}while(0);c[q>>2]=(c[q>>2]|0)+1;Fa=Da;break};case 60:{Ca=c[w>>2]|0;Ba=tZ(Ca,0,0,1,32)|0;ea=Ba;do{if((Ba|0)==0){Ga=0}else{Ea=tZ(Ca,0,0,1,20)|0;c[Ba+4>>2]=Ea;if((Ea|0)==0){Ga=0;break}c[Ba>>2]=0;c[Ba+8>>2]=-1;c[Ba+12>>2]=-1;c[Ea>>2]=-2;c[Ea+4>>2]=16;c[Ea+8>>2]=-1;Ga=ea}}while(0);c[q>>2]=(c[q>>2]|0)+1;Fa=Ga;break};case 66:{ea=c[w>>2]|0;Ba=tZ(ea,0,0,1,32)|0;Ca=Ba;do{if((Ba|0)==0){Ha=0}else{Ea=tZ(ea,0,0,1,20)|0;c[Ba+4>>2]=Ea;if((Ea|0)==0){Ha=0;break}c[Ba>>2]=0;c[Ba+8>>2]=-1;c[Ba+12>>2]=-1;c[Ea>>2]=-2;c[Ea+4>>2]=128;c[Ea+8>>2]=-1;Ha=Ca}}while(0);c[q>>2]=(c[q>>2]|0)+1;Fa=Ha;break};case 62:{Ca=c[w>>2]|0;Ba=tZ(Ca,0,0,1,32)|0;ea=Ba;do{if((Ba|0)==0){Ia=0}else{Ea=tZ(Ca,0,0,1,20)|0;c[Ba+4>>2]=Ea;if((Ea|0)==0){Ia=0;break}c[Ba>>2]=0;c[Ba+8>>2]=-1;c[Ba+12>>2]=-1;c[Ea>>2]=-2;c[Ea+4>>2]=32;c[Ea+8>>2]=-1;Ia=ea}}while(0);c[q>>2]=(c[q>>2]|0)+1;Fa=Ia;break};case 120:{ea=Y+2|0;c[q>>2]=ea;Ba=a[ea]|0;if(Ba<<24>>24==123){ea=Y+3|0;c[q>>2]=ea;Ca=ea;ea=0;while(1){Ea=a[Ca]|0;if(Ea<<24>>24==0|Ea<<24>>24==125){Ja=ea;Ka=Ca;break}if((RY(Ea<<24>>24)|0)==0){Z=9;T=294;break b}Ea=c[q>>2]|0;a[l+ea|0]=a[Ea]|0;La=ea+1|0;Ma=Ea+1|0;c[q>>2]=Ma;if(La>>>0>31){Ja=La;Ka=Ma;break}else{Ca=Ma;ea=La}}c[q>>2]=Ka+1;a[l+Ja|0]=0;ea=Rb(C|0,0,16)|0;Ca=c[w>>2]|0;La=c[x>>2]|0;Ma=tZ(Ca,0,0,1,32)|0;Ea=Ma;do{if((Ma|0)==0){Na=0}else{Oa=tZ(Ca,0,0,1,20)|0;c[Ma+4>>2]=Oa;if((Oa|0)==0){Na=0;break}c[Ma>>2]=0;c[Ma+8>>2]=-1;c[Ma+12>>2]=-1;c[Oa>>2]=ea;c[Oa+4>>2]=ea;c[Oa+8>>2]=La;Na=Ea}}while(0);c[x>>2]=(c[x>>2]|0)+1;Fa=Na;break e}else{a[D+0|0]=0;a[D+1|0]=0;a[D+2|0]=0;Ea=(RY(Ba<<24>>24)|0)==0;La=c[q>>2]|0;if(Ea){Pa=La}else{a[D]=a[La]|0;Ea=La+1|0;c[q>>2]=Ea;Pa=Ea}if((RY(a[Pa]|0)|0)!=0){Ea=c[q>>2]|0;a[E]=a[Ea]|0;c[q>>2]=Ea+1}Ea=Rb(D|0,0,16)|0;La=c[w>>2]|0;ea=c[x>>2]|0;Ma=tZ(La,0,0,1,32)|0;Ca=Ma;do{if((Ma|0)==0){Qa=0}else{Oa=tZ(La,0,0,1,20)|0;c[Ma+4>>2]=Oa;if((Oa|0)==0){Qa=0;break}c[Ma>>2]=0;c[Ma+8>>2]=-1;c[Ma+12>>2]=-1;c[Oa>>2]=Ea;c[Oa+4>>2]=Ea;c[Oa+8>>2]=ea;Qa=Ca}}while(0);c[x>>2]=(c[x>>2]|0)+1;Fa=Qa;break e}break};default:{if((KY(Aa)|0)!=0){Ca=(a[c[q>>2]|0]|0)+ -48|0;ea=c[w>>2]|0;Ea=c[x>>2]|0;Ma=tZ(ea,0,0,1,32)|0;if((Ma|0)==0){Z=12;T=294;break b}La=tZ(ea,0,0,1,20)|0;c[Ma+4>>2]=La;if((La|0)==0){Z=12;T=294;break b}c[Ma>>2]=0;c[Ma+8>>2]=-1;c[Ma+12>>2]=-1;c[La>>2]=-4;c[La+4>>2]=Ca;c[La+8>>2]=Ea;c[x>>2]=(c[x>>2]|0)+1;Ea=c[B>>2]|0;c[B>>2]=(Ca|0)<(Ea|0)?Ea:Ca;c[q>>2]=(c[q>>2]|0)+1;U=M;V=Ma;W=0;break c}Ma=c[w>>2]|0;Ca=a[c[q>>2]|0]|0;Ea=c[x>>2]|0;La=tZ(Ma,0,0,1,32)|0;ea=La;do{if((La|0)==0){Ra=0}else{Ba=tZ(Ma,0,0,1,20)|0;c[La+4>>2]=Ba;if((Ba|0)==0){Ra=0;break}c[La>>2]=0;c[La+8>>2]=-1;c[La+12>>2]=-1;c[Ba>>2]=Ca;c[Ba+4>>2]=Ca;c[Ba+8>>2]=Ea;Ra=ea}}while(0);c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1;Fa=Ra}}}while(0);if((Fa|0)==0){Z=12;T=294;break b}else{U=M;V=Fa;W=0;break c}break};case 46:{Aa=(c[v>>2]&4|0)==0;X=c[w>>2]|0;Q=c[x>>2]|0;fa=tZ(X,0,0,1,32)|0;ea=fa;Ea=(fa|0)==0;if(Aa){if(Ea){Z=12;T=294;break b}Aa=tZ(X,0,0,1,20)|0;c[fa+4>>2]=Aa;if((Aa|0)==0){Z=12;T=294;break b}c[fa>>2]=0;c[fa+8>>2]=-1;c[fa+12>>2]=-1;c[Aa>>2]=0;c[Aa+4>>2]=1114111;c[Aa+8>>2]=Q;Sa=ea;Ta=(c[x>>2]|0)+1|0}else{if(Ea){Z=12;T=294;break b}Ea=tZ(X,0,0,1,20)|0;c[fa+4>>2]=Ea;if((Ea|0)==0){Z=12;T=294;break b}c[fa>>2]=0;c[fa+8>>2]=-1;c[fa+12>>2]=-1;c[Ea>>2]=0;c[Ea+4>>2]=9;c[Ea+8>>2]=Q;Q=c[w>>2]|0;Ea=(c[x>>2]|0)+1|0;X=tZ(Q,0,0,1,32)|0;if((X|0)==0){Z=12;T=294;break b}Aa=tZ(Q,0,0,1,20)|0;c[X+4>>2]=Aa;if((Aa|0)==0){Z=12;T=294;break b}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[Aa>>2]=11;c[Aa+4>>2]=1114111;c[Aa+8>>2]=Ea;Ea=c[w>>2]|0;Aa=tZ(Ea,0,0,1,32)|0;if((Aa|0)==0){Z=12;T=294;break b}Q=tZ(Ea,0,0,1,8)|0;Ea=Aa+4|0;c[Ea>>2]=Q;if((Q|0)==0){Z=12;T=294;break b}c[Aa>>2]=3;c[Aa+8>>2]=-1;c[Aa+12>>2]=-1;c[Q>>2]=ea;c[(c[Ea>>2]|0)+4>>2]=X;c[Aa+16>>2]=(c[X+16>>2]|0)+(c[fa+16>>2]|0);Sa=Aa;Ta=(c[x>>2]|0)+2|0}c[x>>2]=Ta;c[q>>2]=(c[q>>2]|0)+1;U=M;V=Sa;W=0;break c;break};case 36:{if((c[v>>2]&1|0)==0){if((a[Y+1|0]|0)!=0){break d}}Aa=c[w>>2]|0;fa=tZ(Aa,0,0,1,32)|0;if((fa|0)==0){Z=12;T=294;break b}X=tZ(Aa,0,0,1,20)|0;c[fa+4>>2]=X;if((X|0)==0){Z=12;T=294;break b}c[fa>>2]=0;c[fa+8>>2]=-1;c[fa+12>>2]=-1;c[X>>2]=-2;c[X+4>>2]=2;c[X+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=fa;W=0;break c;break};case 63:case 43:case 123:case 124:case 42:{T=264;break};case 0:{T=265;break};case 94:{if((c[v>>2]&1|0)==0){if((Y|0)!=(c[r>>2]|0)){break d}fa=jZ(m,5)|0;if((fa|0)!=0){R=M;S=fa;T=6;break b}}fa=c[w>>2]|0;X=tZ(fa,0,0,1,32)|0;if((X|0)==0){Z=12;T=294;break b}Aa=tZ(fa,0,0,1,20)|0;c[X+4>>2]=Aa;if((Aa|0)==0){Z=12;T=294;break b}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[Aa>>2]=-2;c[Aa+4>>2]=1;c[Aa+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=X;W=0;break c;break};case 41:{if((M|0)!=0){T=264}break};case 91:{X=Y+1|0;c[q>>2]=X;Aa=VZ(128)|0;if((Aa|0)==0){Z=12;T=294;break b}if((a[X]|0)==94){fa=Y+2|0;c[q>>2]=fa;Ua=fa;Va=1}else{Ua=X;Va=0}X=(Va|0)==0;fa=Aa;Aa=0;Ea=0;ea=32;Q=Ua;f:while(1){Ca=a[Q]|0;if(Ca<<24>>24==93){if(Q>>>0>(c[q>>2]|0)>>>0){T=85;break}}else if(Ca<<24>>24==0){Wa=fa;Xa=Q;Ya=7;T=140;break}Ca=ZY(e,Q,-1)|0;if((Ca|0)<0){c[e>>2]=-1;Za=1}else{Za=Ca}Ca=Q+Za|0;do{if((a[Ca]|0)==45){La=Za+1|0;Ma=Q+La|0;if((a[Ma]|0)==93){T=94;break}Ba=c[e>>2]|0;Oa=ZY(e,Ma,-1)|0;if((Oa|0)<0){c[e>>2]=-1;_a=-1;$a=1}else{_a=c[e>>2]|0;$a=Oa}ab=0;bb=_a;cb=Ba;db=Q+($a+La)|0;eb=Ba>>>0>_a>>>0?11:0}else{T=94}}while(0);g:do{if((T|0)==94){T=0;Ba=a[Q]|0;do{if(Ba<<24>>24==91){La=a[Q+1|0]|0;if(La<<24>>24==61|La<<24>>24==46){Wa=fa;Xa=Q;Ya=3;T=140;break f}else if(!(La<<24>>24==58)){fb=0;break}La=Q+2|0;Oa=La;while(1){Ma=a[Oa]|0;gb=Ma<<24>>24==0;if(Ma<<24>>24!=58&(gb^1)){Oa=Oa+1|0}else{break}}if(gb){Wa=fa;Xa=Q;Ya=4;T=140;break f}Ma=Oa-Q+ -2|0;hb=(Ma|0)>63?63:Ma;I_(A|0,La|0,hb|0)|0;a[f+hb|0]=0;hb=JY(A)|0;ab=hb;bb=1114111;cb=0;db=Oa+2|0;eb=(hb|0)==0?4:0;break g}else if(Ba<<24>>24==45){if((a[Q+1|0]|0)==93){fb=0;break}fb=(c[q>>2]|0)==(Q|0)?0:11}else{fb=0}}while(0);Ba=c[e>>2]|0;ab=0;bb=Ba;cb=Ba;db=Ca;eb=fb}}while(0);if((eb|0)!=0){Wa=fa;Xa=db;Ya=eb;T=140;break}Ca=(ab|0)!=0;do{if(X|Ca^1){Ba=c[w>>2]|0;if((Ea|0)<(ea|0)){ib=fa;jb=ea}else{if((ea|0)>1024){Wa=fa;Xa=db;Ya=12;T=140;break f}hb=YZ(fa,ea<<3)|0;if((hb|0)==0){Wa=fa;Xa=db;Ya=12;T=140;break f}else{ib=hb;jb=ea<<1}}hb=tZ(Ba,0,0,1,32)|0;if((hb|0)==0){T=112;break f}Ma=tZ(Ba,0,0,1,20)|0;Ba=hb+4|0;c[Ba>>2]=Ma;if((Ma|0)==0){T=112;break f}c[hb>>2]=0;c[hb+8>>2]=-1;c[hb+12>>2]=-1;c[Ma>>2]=cb;c[Ma+4>>2]=bb;c[Ma+8>>2]=-1;c[ib+(Ea<<2)>>2]=hb;c[(c[Ba>>2]|0)+12>>2]=ab;kb=ib;lb=Aa;mb=Ea+1|0;nb=jb;ob=0}else{if((Aa|0)>63){kb=fa;lb=Aa;mb=Ea;nb=ea;ob=12;break}c[g+(Aa<<2)>>2]=ab;kb=fa;lb=Aa+1|0;mb=Ea;nb=ea;ob=0}}while(0);Ba=(ob|0)==0;if(Ba&(((c[v>>2]&2|0)==0|Ca)^1)){pb=kb;qb=mb;rb=nb;sb=cb}else{if(Ba){fa=kb;Aa=lb;Ea=mb;ea=nb;Q=db;continue}else{Wa=kb;Xa=db;Ya=ob;T=140;break}}while(1){Ba=sb;while(1){if(Ba>>>0>bb>>>0){fa=pb;Aa=lb;Ea=qb;ea=rb;Q=db;continue f}if((MY(Ba)|0)!=0){T=118;break}tb=Ba+1|0;if((QY(Ba)|0)==0){Ba=tb}else{T=129;break}}if((T|0)==118){T=0;hb=SY(Ba)|0;Ma=Ba+1|0;h:do{if((MY(Ma)|0)==0){ub=hb;vb=Ma}else{wb=hb;xb=Ma;while(1){if((SY(xb)|0)!=(wb+1|0)|xb>>>0>bb>>>0){ub=wb;vb=xb;break h}yb=SY(xb)|0;zb=xb+1|0;if((MY(zb)|0)==0){ub=yb;vb=zb;break}else{wb=yb;xb=zb}}}}while(0);Ma=c[w>>2]|0;if((qb|0)<(rb|0)){Ab=pb;Bb=rb}else{if((rb|0)>1024){Wa=pb;Xa=db;Ya=12;T=140;break f}xb=YZ(pb,rb<<3)|0;if((xb|0)==0){Wa=pb;Xa=db;Ya=12;T=140;break f}else{Ab=xb;Bb=rb<<1}}xb=tZ(Ma,0,0,1,32)|0;wb=xb;do{if((xb|0)==0){Cb=0}else{Oa=tZ(Ma,0,0,1,20)|0;c[xb+4>>2]=Oa;if((Oa|0)==0){Cb=0;break}c[xb>>2]=0;c[xb+8>>2]=-1;c[xb+12>>2]=-1;c[Oa>>2]=hb;c[Oa+4>>2]=ub;c[Oa+8>>2]=-1;Cb=wb}}while(0);c[Ab+(qb<<2)>>2]=Cb;Db=Cb;Eb=Ab;Fb=Bb;Gb=vb}else if((T|0)==129){T=0;wb=UY(Ba)|0;i:do{if((QY(tb)|0)==0){Hb=wb;Ib=tb}else{hb=wb;xb=tb;while(1){if((UY(xb)|0)!=(hb+1|0)|xb>>>0>bb>>>0){Hb=hb;Ib=xb;break i}Ma=xb+1|0;Oa=UY(xb)|0;if((QY(Ma)|0)==0){Hb=Oa;Ib=Ma;break}else{hb=Oa;xb=Ma}}}}while(0);Ba=c[w>>2]|0;if((qb|0)<(rb|0)){Jb=pb;Kb=rb}else{if((rb|0)>1024){Wa=pb;Xa=db;Ya=12;T=140;break f}xb=YZ(pb,rb<<3)|0;if((xb|0)==0){Wa=pb;Xa=db;Ya=12;T=140;break f}else{Jb=xb;Kb=rb<<1}}xb=tZ(Ba,0,0,1,32)|0;hb=xb;do{if((xb|0)==0){Lb=0}else{Ma=tZ(Ba,0,0,1,20)|0;c[xb+4>>2]=Ma;if((Ma|0)==0){Lb=0;break}c[xb>>2]=0;c[xb+8>>2]=-1;c[xb+12>>2]=-1;c[Ma>>2]=wb;c[Ma+4>>2]=Hb;c[Ma+8>>2]=-1;Lb=hb}}while(0);c[Jb+(qb<<2)>>2]=Lb;Db=Lb;Eb=Jb;Fb=Kb;Gb=Ib}if((Db|0)==0){T=141;break f}else{pb=Eb;qb=qb+1|0;rb=Fb;sb=Gb}}}j:do{if((T|0)==85){T=0;c[q>>2]=Q+1;ea=(Va|0)!=0;if(ea){_b(fa|0,Ea|0,4,58)}k:do{if((Ea|0)>0){X=(Aa|0)>0;Ca=Aa<<2;hb=Ca+4|0;if(ea){Mb=0;Nb=0;Ob=0;Pb=0}else{wb=0;xb=0;while(1){Ba=fa+(wb<<2)|0;Ma=c[(c[Ba>>2]|0)+4>>2]|0;do{if((Ma|0)==0){Qb=xb;Sb=0}else{c[Ma+8>>2]=c[x>>2];if(X){Oa=tZ(c[w>>2]|0,0,0,0,hb)|0;La=Ma+16|0;c[La>>2]=Oa;if((Oa|0)==0){Tb=fa;Ub=xb;Vb=12;break j}z_(Oa|0,z|0,Ca|0)|0;c[(c[La>>2]|0)+(Aa<<2)>>2]=0}else{c[Ma+16>>2]=0}if((xb|0)==0){Qb=c[Ba>>2]|0;Sb=0;break}La=c[w>>2]|0;Oa=c[Ba>>2]|0;zb=tZ(La,0,0,1,32)|0;yb=zb;do{if((zb|0)==0){Wb=0}else{Xb=tZ(La,0,0,1,8)|0;Yb=zb+4|0;c[Yb>>2]=Xb;if((Xb|0)==0){Wb=0;break}c[zb>>2]=3;c[zb+8>>2]=-1;c[zb+12>>2]=-1;c[Xb>>2]=xb;c[(c[Yb>>2]|0)+4>>2]=Oa;c[zb+16>>2]=(c[Oa+16>>2]|0)+(c[xb+16>>2]|0);Wb=yb}}while(0);Qb=Wb;Sb=(Wb|0)==0?12:0}}while(0);Ba=wb+1|0;if((Ba|0)<(Ea|0)&(Sb|0)==0){wb=Ba;xb=Qb}else{Zb=0;$b=Qb;ac=Sb;break k}}}while(1){xb=fa+(Ob<<2)|0;wb=c[(c[xb>>2]|0)+4>>2]|0;Ba=c[wb>>2]|0;Ma=wb+4|0;yb=c[Ma>>2]|0;do{if((Ba|0)<(Mb|0)){Oa=yb+1|0;bc=(Oa|0)<(Mb|0)?Mb:Oa;cc=Nb;dc=Pb;ec=0}else{if((Ba|0)<=(Nb|0)){Oa=yb+1|0;bc=Oa;cc=Oa;dc=Pb;ec=0;break}c[wb>>2]=Nb;c[Ma>>2]=Ba+ -1;Oa=yb+1|0;if((wb|0)==0){bc=Oa;cc=Oa;dc=Pb;ec=0;break}c[wb+8>>2]=c[x>>2];if(X){zb=tZ(c[w>>2]|0,0,0,0,hb)|0;La=wb+16|0;c[La>>2]=zb;if((zb|0)==0){Tb=fa;Ub=Pb;Vb=12;break j}z_(zb|0,z|0,Ca|0)|0;c[(c[La>>2]|0)+(Aa<<2)>>2]=0}else{c[wb+16>>2]=0}if((Pb|0)==0){bc=Oa;cc=Oa;dc=c[xb>>2]|0;ec=0;break}La=c[w>>2]|0;zb=c[xb>>2]|0;Yb=tZ(La,0,0,1,32)|0;Xb=Yb;do{if((Yb|0)==0){fc=0}else{gc=tZ(La,0,0,1,8)|0;hc=Yb+4|0;c[hc>>2]=gc;if((gc|0)==0){fc=0;break}c[Yb>>2]=3;c[Yb+8>>2]=-1;c[Yb+12>>2]=-1;c[gc>>2]=Pb;c[(c[hc>>2]|0)+4>>2]=zb;c[Yb+16>>2]=(c[zb+16>>2]|0)+(c[Pb+16>>2]|0);fc=Xb}}while(0);bc=Oa;cc=Oa;dc=fc;ec=(fc|0)==0?12:0}}while(0);xb=Ob+1|0;if((xb|0)<(Ea|0)&(ec|0)==0){Mb=bc;Nb=cc;Ob=xb;Pb=dc}else{Zb=cc;$b=dc;ac=ec;break}}}else{Zb=0;$b=0;ac=0}}while(0);if((ac|0)!=0|ea^1){Tb=fa;Ub=$b;Vb=ac;break}Ca=c[w>>2]|0;hb=c[x>>2]|0;X=tZ(Ca,0,0,1,32)|0;xb=X;if((X|0)==0){Tb=fa;Ub=$b;Vb=12;break}wb=tZ(Ca,0,0,1,20)|0;c[X+4>>2]=wb;if((wb|0)==0){Tb=fa;Ub=$b;Vb=12;break}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[wb>>2]=Zb;c[wb+4>>2]=1114111;c[wb+8>>2]=hb;if((Aa|0)>0){hb=Aa<<2;Ca=tZ(c[w>>2]|0,0,0,0,hb+4|0)|0;yb=wb+16|0;c[yb>>2]=Ca;if((Ca|0)==0){Tb=fa;Ub=$b;Vb=12;break}z_(Ca|0,z|0,hb|0)|0;c[(c[yb>>2]|0)+(Aa<<2)>>2]=0}else{c[wb+16>>2]=0}if(($b|0)==0){Tb=fa;Ub=xb;Vb=0;break}wb=c[w>>2]|0;yb=tZ(wb,0,0,1,32)|0;hb=yb;do{if((yb|0)==0){ic=0}else{Ca=tZ(wb,0,0,1,8)|0;Ba=yb+4|0;c[Ba>>2]=Ca;if((Ca|0)==0){ic=0;break}c[yb>>2]=3;c[yb+8>>2]=-1;c[yb+12>>2]=-1;c[Ca>>2]=$b;c[(c[Ba>>2]|0)+4>>2]=xb;c[yb+16>>2]=(c[X+16>>2]|0)+(c[$b+16>>2]|0);ic=hb}}while(0);Tb=fa;Ub=ic;Vb=(ic|0)==0?12:0}else if((T|0)==112){T=0;c[ib+(Ea<<2)>>2]=0;Wa=ib;Xa=db;Ya=12;T=140}else if((T|0)==141){T=0;c[q>>2]=db;Tb=Eb;Ub=0;Vb=12}}while(0);if((T|0)==140){T=0;c[q>>2]=Xa;Tb=Wa;Ub=0;Vb=Ya}WZ(Tb);c[x>>2]=(c[x>>2]|0)+1;if((Vb|0)==0){U=M;V=Ub;W=0;break c}else{Z=Vb;T=294;break b}break};default:{}}}while(0);if((T|0)==74){T=0;_=M+1|0;c[q>>2]=va+1;Ea=jZ(m,c[y>>2]|0)|0;if((Ea|0)!=0){R=_;S=Ea;T=6;break b}Ea=jZ(m,2)|0;if((Ea|0)!=0){R=_;S=Ea;T=6;break b}Ea=jZ(m,0)|0;if((Ea|0)!=0){R=_;S=Ea;T=6;break b}c[y>>2]=(c[y>>2]|0)+1;U=_;V=N;W=0;break c}else if((T|0)==264){T=0;if((c[v>>2]&1|0)!=0){T=265}}if((T|0)==265){T=0;_=c[w>>2]|0;Ea=tZ(_,0,0,1,32)|0;if((Ea|0)==0){Z=12;T=294;break b}fa=tZ(_,0,0,1,20)|0;c[Ea+4>>2]=fa;if((fa|0)==0){Z=12;T=294;break b}c[Ea>>2]=0;c[Ea+8>>2]=-1;c[Ea+12>>2]=-1;c[fa>>2]=-1;c[fa+4>>2]=-1;c[fa+8>>2]=-1;U=M;V=Ea;W=0;break c}Ea=ZY(h,Y,-1)|0;if((Ea|0)<0){c[h>>2]=-1;jc=1}else{jc=Ea}do{if((c[v>>2]&2|0)==0){T=280}else{if((QY(c[h>>2]|0)|0)==0){if((MY(c[h>>2]|0)|0)==0){T=280;break}}Ea=c[w>>2]|0;fa=SY(c[h>>2]|0)|0;_=SY(c[h>>2]|0)|0;Aa=c[x>>2]|0;Q=tZ(Ea,0,0,1,32)|0;if((Q|0)==0){Z=12;T=294;break b}hb=tZ(Ea,0,0,1,20)|0;c[Q+4>>2]=hb;if((hb|0)==0){Z=12;T=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[hb>>2]=fa;c[hb+4>>2]=_;c[hb+8>>2]=Aa;Aa=c[w>>2]|0;hb=UY(c[h>>2]|0)|0;_=UY(c[h>>2]|0)|0;fa=c[x>>2]|0;Ea=tZ(Aa,0,0,1,32)|0;if((Ea|0)==0){Z=12;T=294;break b}X=tZ(Aa,0,0,1,20)|0;c[Ea+4>>2]=X;if((X|0)==0){Z=12;T=294;break b}c[Ea>>2]=0;c[Ea+8>>2]=-1;c[Ea+12>>2]=-1;c[X>>2]=hb;c[X+4>>2]=_;c[X+8>>2]=fa;fa=c[w>>2]|0;X=tZ(fa,0,0,1,32)|0;if((X|0)==0){Z=12;T=294;break b}_=tZ(fa,0,0,1,8)|0;fa=X+4|0;c[fa>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[X>>2]=3;c[X+8>>2]=-1;c[X+12>>2]=-1;c[_>>2]=Q;c[(c[fa>>2]|0)+4>>2]=Ea;c[X+16>>2]=(c[Ea+16>>2]|0)+(c[Q+16>>2]|0);kc=X}}while(0);if((T|0)==280){T=0;Y=c[w>>2]|0;X=c[h>>2]|0;Q=c[x>>2]|0;Ea=tZ(Y,0,0,1,32)|0;if((Ea|0)==0){Z=12;T=294;break b}fa=tZ(Y,0,0,1,20)|0;c[Ea+4>>2]=fa;if((fa|0)==0){Z=12;T=294;break b}c[Ea>>2]=0;c[Ea+8>>2]=-1;c[Ea+12>>2]=-1;c[fa>>2]=X;c[fa+4>>2]=X;c[fa+8>>2]=Q;kc=Ea}c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+jc;U=M;V=kc;W=0;break};case 10:{Ea=L+ -2|0;c[n>>2]=Ea;c[v>>2]=c[P+(Ea<<2)>>2];U=M;V=N;W=0;break};case 4:{Ea=jZ(m,9)|0;if((Ea|0)!=0){R=M;S=Ea;T=6;break b}U=M;V=N;W=jZ(m,1)|0;break};case 5:{Ea=c[q>>2]|0;Q=a[Ea]|0;if(Q<<24>>24==0){U=M;V=N;W=0;break c}fa=c[v>>2]&1;X=(fa|0)!=0;if(X&Q<<24>>24==124){U=M;V=N;W=0;break c}do{if(!(X&Q<<24>>24==41&(M|0)>0)){if((fa|0)==0&Q<<24>>24==92){if((a[Ea+1|0]|0)==41){break}}Y=jZ(m,5)|0;if((Y|0)!=0){R=M;S=Y;T=6;break b}Y=jZ(m,N)|0;if((Y|0)!=0){R=M;S=Y;T=6;break b}Y=jZ(m,6)|0;if((Y|0)!=0){R=M;S=Y;T=6;break b}U=M;V=N;W=jZ(m,4)|0;break c}}while(0);Q=(fa|M|0)==0?8:0;X=M+ -1|0;if((fa|0)!=0){U=X;V=N;W=Q;break c}c[q>>2]=Ea+2;U=X;V=N;W=Q;break};default:{U=M;V=N;W=0}}}while(0);P=c[n>>2]|0;O=(W|0)==0;if((P|0)>(o|0)&O){L=P;M=U;N=V}else{lc=O;mc=U;nc=V;oc=W;break a}}if((T|0)==6){lc=(S|0)==0;mc=R;nc=N;oc=S;break}else if((T|0)==294){i=d;return Z|0}}else{lc=t;mc=0;nc=0;oc=p}}while(0);p=(mc|0)>0;if(p|lc^1){Z=p?8:oc;i=d;return Z|0}c[b+8>>2]=nc;Z=0;i=d;return Z|0}



function Bx(b,d,e,f,g,j,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0.0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+16|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;c[m>>2]=0;O=c[q+12>>2]|0;a:do{if((O|0)==5){P=q+4|0;Q=(c[P>>2]|0)+(c[q>>2]|0)|0;R=Q+1|0;c[12254]=R;S=c[b>>2]|0;c[12244]=(Q|0)<(S|0)?R:S;S=c[q>>2]|0;c[12262]=R+S;c[12248]=S+Q;Q=(c[b>>2]|0)/(R|0)|0;c[12258]=Q+1;R=c[x>>2]|0;c[12256]=R+ -1;c[12266]=R+Q;c[s>>2]=0;h[6126]=+V(+(+h[t>>3]));Q=c[12244]|0;c[12230]=1;if((Q|0)<1){T=75;break}R=r;S=1;while(1){U=c[b>>2]|0;W=c[12254]|0;c[12236]=S;X=(W|0)<0;b:do{if(X?(S|0)>=(U|0):(S|0)<=(U|0)){Y=W;Z=S;_=S;while(1){$=(_-Z|0)/(Y|0)|0;c[12232]=$+1;aa=_+ -1|0;ba=e+(aa<<3)|0;h[p+((c[12256]|0)+$<<3)>>3]=+h[ba>>3];ca=f+(aa<<3)|0;h[p+((c[12266]|0)+$<<3)>>3]=+h[ca>>3];da=+h[ba>>3];h[N>>3]=da;if(!(da>=0.0)){ea=-da}else{ea=da}da=+h[l>>3]*+h[ca>>3];if(!(da>=0.0)){ga=-da}else{ga=da}da=ea>=ga?ea:ga;ha=+h[n+(aa<<3)>>3];if(!(ha>=0.0)){ia=-ha}else{ia=ha}h[6123]=+h[6126]*(da>=ia?da:ia);h[N>>3]=+h[l>>3]*+h[ca>>3];da=+BN(48984,N);h[6123]=da;ca=c[12236]|0;aa=ca+ -1|0;ba=e+(aa<<3)|0;ha=+h[ba>>3];ja=da+ha-ha;h[6123]=ja;h[ba>>3]=+h[ba>>3]+ja;ba=f+(aa<<3)|0;h[ba>>3]=+h[j>>3]*+h[6123]+ +h[ba>>3];ba=ca+W|0;c[12236]=ba;if(!(X?(ba|0)>=(U|0):(ba|0)<=(U|0))){break b}Y=c[12254]|0;Z=c[12230]|0;_=ba}}}while(0);Zd[R&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}U=c[b>>2]|0;X=c[12254]|0;W=c[12230]|0;c[12236]=W;_=(X|0)<0;c:do{if(_?(W|0)>=(U|0):(W|0)<=(U|0)){Z=X;Y=W;ba=W;while(1){ca=(ba-Y|0)/(Z|0)|0;c[12232]=ca+1;aa=ba+ -1|0;$=e+(aa<<3)|0;h[$>>3]=+h[p+((c[12256]|0)+ca<<3)>>3];ja=+h[p+((c[12266]|0)+ca<<3)>>3];ca=f+(aa<<3)|0;h[ca>>3]=ja;ha=+h[$>>3];h[N>>3]=ha;if(!(ha>=0.0)){ka=-ha}else{ka=ha}ha=+h[l>>3]*ja;if(!(ha>=0.0)){la=-ha}else{la=ha}ha=ka>=la?ka:la;ja=+h[n+(aa<<3)>>3];if(!(ja>=0.0)){ma=-ja}else{ma=ja}h[6123]=+h[6126]*(ha>=ma?ha:ma);h[N>>3]=+h[l>>3]*+h[ca>>3];ha=+BN(48984,N);h[6123]=ha;ca=c[12236]|0;ja=+h[e+(ca+ -1<<3)>>3];da=ha+ja-ja;h[6123]=da;ja=1.0/da;h[6132]=ja;aa=ca-(c[P>>2]|0)|0;$=(aa|0)>1?aa:1;c[12238]=$;aa=c[b>>2]|0;na=(c[q>>2]|0)+ca|0;oa=(aa|0)<=(na|0)?aa:na;c[12240]=oa;pa=fa(c[12248]|0,ca)|0;qa=pa-(c[q>>2]|0)|0;c[12242]=qa;c[12228]=$;if(($|0)<=(oa|0)){pa=~aa;aa=~na;na=~((pa|0)>(aa|0)?pa:aa);aa=($|0)>(na|0)?$:na;da=ja;na=$;while(1){$=na+ -1|0;h[p+($+qa<<3)>>3]=(+h[o+($<<3)>>3]- +h[g+($<<3)>>3])*da;if((na|0)>=(oa|0)){break}da=+h[6132];na=na+1|0}c[12228]=aa+1}na=ca+X|0;c[12236]=na;oa=c[12230]|0;if(!(_?(na|0)>=(U|0):(na|0)<=(U|0))){ra=oa;break c}Z=c[12254]|0;Y=oa;ba=na}}else{ra=W}}while(0);W=ra+1|0;c[12230]=W;if((ra|0)<(Q|0)){S=W}else{T=75;break a}}i=y;return 0}else if((O|0)==2){c[s>>2]=0;c[12250]=0;h[6126]=+V(+(+h[t>>3]));S=c[b>>2]|0;c[12228]=1;d:do{if((S|0)>=1){Q=r;P=1;while(1){R=P+ -1|0;da=+h[e+(R<<3)>>3];h[N>>3]=da;if(!(da>=0.0)){sa=-da}else{sa=da}W=f+(R<<3)|0;da=+h[l>>3]*+h[W>>3];if(!(da>=0.0)){ta=-da}else{ta=da}da=sa>=ta?sa:ta;ja=+h[n+(R<<3)>>3];if(!(ja>=0.0)){ua=-ja}else{ua=ja}h[6123]=+h[6126]*(da>=ua?da:ua);h[N>>3]=+h[l>>3]*+h[W>>3];da=+BN(48984,N);h[6123]=da;W=(c[12228]|0)+ -1|0;R=e+(W<<3)|0;ja=+h[R>>3];ha=da+ja-ja;h[6123]=ha;h[6130]=+h[R>>3];U=f+(W<<3)|0;h[6134]=+h[U>>3];h[R>>3]=ha+ +h[R>>3];h[U>>3]=+h[j>>3]*+h[6123]+ +h[U>>3];Zd[Q&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}ha=1.0/+h[6123];h[6132]=ha;U=c[b>>2]|0;c[12234]=1;R=c[12250]|0;if((U|0)>=1){ja=ha;W=1;_=0;while(1){h[p+(_+R<<3)>>3]=(+h[o+(_<<3)>>3]- +h[g+(_<<3)>>3])*ja;if((W|0)>=(U|0)){break}X=W;ja=+h[6132];W=W+1|0;_=X}c[12234]=U+1}c[12250]=R+(c[b>>2]|0);_=c[12228]|0;W=_+ -1|0;h[e+(W<<3)>>3]=+h[6130];h[f+(W<<3)>>3]=+h[6134];P=_+1|0;c[12228]=P;if((_|0)>=(S|0)){break d}}i=y;return 0}}while(0);if((c[w>>2]|0)==0){T=42;break}c[12250]=0;S=c[b>>2]|0;if((c[35640>>2]|0)==0){T=42;break}P=VZ(S*20|0)|0;Q=F;h[k>>3]=+h[d>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];gw(14,1,49080,F);Q=E;h[k>>3]=+h[j>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];gw(14,0,49104,E);gw(14,1,49112,D);c[12232]=0;if((c[b>>2]|0)>0){Q=0;do{ja=+h[e+(Q<<3)>>3];c[C>>2]=Q+1;_=C+4|0;h[k>>3]=ja;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];gw(14,0,49120,C);Q=(c[12232]|0)+1|0;c[12232]=Q;}while((Q|0)<(c[b>>2]|0))}be[c[9034]&255](14);gw(14,1,49176,B);c[12228]=1;if((S|0)>=1){Q=P+1|0;_=c[12250]|0;W=1;do{X=p+(W+ -1+_<<3)|0;h[X>>3]=+h[j>>3]+ +h[X>>3];a[P]=0;a[Q]=0;c[12234]=1;X=_;ba=0;while(1){ja=+h[p+(ba+X<<3)>>3];c[A>>2]=P;Y=A+4|0;h[k>>3]=ja;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];dc(P|0,49160,A|0)|0;Y=c[12234]|0;c[12234]=Y+1;if((Y|0)>=(S|0)){break}X=c[12250]|0;ba=Y}c[z>>2]=P;gw(14,0,49168,z);ba=c[12250]|0;X=c[12228]|0;Y=p+(ba+ -1+X<<3)|0;h[Y>>3]=+h[Y>>3]- +h[j>>3];_=ba+(c[b>>2]|0)|0;c[12250]=_;W=X+1|0;c[12228]=W;}while((X|0)<(S|0))}be[c[9034]&255](14);be[c[9034]&255](14);WZ(P);T=42}else if((O|0)==3){i=y;return 0}else if((O|0)==4){S=c[q>>2]|0;W=q+4|0;_=c[W>>2]|0;Q=c[b>>2]|0;X=fa(_+1+(S<<1)|0,Q)|0;c[12228]=1;if((X|0)>=1){ba=fa(Q,_+(S<<1)+1|0)|0;S=(ba|0)<1;_=1;while(1){h[p+(_+ -1<<3)>>3]=0.0;if((_|0)<(X|0)){_=_+1|0}else{break}}c[12228]=S?2:ba+1|0}de[u&7](d,e,f,g,p,j,l,n,v,w)|0;c[12262]=(c[W>>2]|0)+1+(c[q>>2]<<1);T=75}else{_=c[b>>2]|0;X=fa(_,_)|0;c[12228]=1;if((X|0)!=0){_=(X|0)<1;P=1;while(1){h[p+(P+ -1<<3)>>3]=0.0;if((P|0)<(X|0)){P=P+1|0}else{break}}c[12228]=_?2:X+1|0}de[u&7](d,e,f,g,p,j,l,n,v,w)|0;if((c[w>>2]|0)==0){T=42;break}c[12250]=0;P=c[b>>2]|0;if((c[35640>>2]|0)==0){T=42;break}W=VZ(P*20|0)|0;ba=M;h[k>>3]=+h[d>>3];c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];gw(14,1,49080,M);ba=L;h[k>>3]=+h[j>>3];c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];gw(14,0,49104,L);gw(14,1,49112,K);c[12232]=0;if((c[b>>2]|0)>0){ba=0;do{ja=+h[e+(ba<<3)>>3];c[J>>2]=ba+1;S=J+4|0;h[k>>3]=ja;c[S>>2]=c[k>>2];c[S+4>>2]=c[k+4>>2];gw(14,0,49120,J);ba=(c[12232]|0)+1|0;c[12232]=ba;}while((ba|0)<(c[b>>2]|0))}be[c[9034]&255](14);gw(14,1,49136,I);c[12228]=1;if((P|0)>=1){ba=W+1|0;X=c[12250]|0;_=1;do{S=p+(_+ -1+X<<3)|0;h[S>>3]=+h[j>>3]+ +h[S>>3];a[W]=0;a[ba]=0;c[12234]=1;S=X;Q=0;while(1){ja=+h[p+(Q+S<<3)>>3];c[H>>2]=W;Y=H+4|0;h[k>>3]=ja;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];dc(W|0,49160,H|0)|0;Y=c[12234]|0;c[12234]=Y+1;if((Y|0)>=(P|0)){break}S=c[12250]|0;Q=Y}c[G>>2]=W;gw(14,0,49168,G);Q=c[12250]|0;S=c[12228]|0;Y=p+(Q+ -1+S<<3)|0;h[Y>>3]=+h[Y>>3]- +h[j>>3];X=Q+(c[b>>2]|0)|0;c[12250]=X;_=S+1|0;c[12228]=_;}while((S|0)<(P|0))}be[c[9034]&255](14);be[c[9034]&255](14);WZ(W);T=42}}while(0);if((T|0)==42){Jx(p,b,b,q+80|0,m)|0;i=y;return 0}else if((T|0)==75){Px(p,49048,b,q,q+4|0,q+80|0,m)|0;i=y;return 0}return 0}function Cx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[e+12>>2]|0;if((g|0)==4|(g|0)==5){h=e+4|0;c[12300]=(c[h>>2]|0)+1+(c[e>>2]<<1);Qx(d,49200,a,e,h,e+80|0,b,49208)|0;i=f;return 0}else if((g|0)==3){i=f;return 0}else{Nx(d,a,a,e+80|0,b,49208)|0;i=f;return 0}return 0}function Dx(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0;d=i;i=i+8|0;e=d;do{if(!(a[49216]&1)){a[49216]=1;Ex(49264,49232,49312,49248,49296,49320,49304,49328)|0;h[6157]=+(c[12316]|0);f=c[12308]|0;h[6153]=+(f|0);if((c[12328]|0)==0){h[6155]=0.0;c[e>>2]=1-f;g=+AN(49256,e)}else{h[6155]=1.0;c[e>>2]=1-f;g=+AN(49256,e)*.5}h[6156]=g;h[6160]=g*+h[6157];h[6159]=+(c[12324]|0);h[6161]=+(c[12326]|0);j=+h[6165];h[6168]=j;k=1.0/+h[6166];if(!(k>=j)){break}h[6168]=k*(g+1.0)}}while(0);if((Sx(b,49352,1,1)|0)!=0){g=+h[6156];h[6167]=g;l=g;i=d;return+l}if((Sx(b,49360,1,1)|0)!=0){g=+h[6168];h[6167]=g;l=g;i=d;return+l}if((Sx(b,49368,1,1)|0)!=0){g=+h[6157];h[6167]=g;l=g;i=d;return+l}if((Sx(b,49376,1,1)|0)!=0){g=+h[6160];h[6167]=g;l=g;i=d;return+l}if((Sx(b,49384,1,1)|0)!=0){g=+h[6153];h[6167]=g;l=g;i=d;return+l}if((Sx(b,49392,1,1)|0)!=0){g=+h[6155];h[6167]=g;l=g;i=d;return+l}if((Sx(b,49400,1,1)|0)!=0){g=+h[6159];h[6167]=g;l=g;i=d;return+l}if((Sx(b,49408,1,1)|0)!=0){g=+h[6165];h[6167]=g;l=g;i=d;return+l}if((Sx(b,49416,1,1)|0)!=0){g=+h[6161];h[6167]=g;l=g;i=d;return+l}if((Sx(b,49424,1,1)|0)==0){l=+h[6167];i=d;return+l}else{g=+h[6166];h[6167]=g;l=g;i=d;return+l}return 0.0}function Ex(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;m=i;i=i+24|0;n=m;o=m+8|0;p=m+16|0;if(a[49536]&1){q=49904;r=c[12476]|0;c[b>>2]=r;s=49840;t=c[12460]|0;c[d>>2]=t;u=49880;v=c[12470]|0;c[e>>2]=v;w=49888;x=+h[6236];h[f>>3]=x;y=49920;z=c[12480]|0;c[g>>2]=z;A=49968;B=+h[6246];h[j>>3]=B;C=49928;D=c[12482]|0;c[k>>2]=D;E=49976;F=+h[6247];h[l>>3]=F;i=m;return 0}a[49536]=1;h[6237]=0.0;h[6231]=1.0;h[6232]=2.0;Fx(49904,49840,49880,49992)|0;h[6227]=+(c[12476]|0);c[n>>2]=0-(c[12460]|0);G=+AN(49816,n);h[6226]=G;h[6236]=G;H=+h[6232];h[6227]=H/3.0;I=+h[6231];J=I*.5;h[6234]=J;K=-J;h[o>>3]=K;h[6248]=+Gx(49816,o);L=49984;h[6245]=+Gx(L,L);h[o>>3]=K;h[6227]=+Gx(49960,o);K=+Gx(49816,49984);h[6227]=K;if(!(K>=0.0)){M=-K}else{M=K}K=M<G?G:M;h[6227]=K;h[6236]=1.0;M=+h[6237];if(K<1.0&K>M){N=K;while(1){h[6236]=N;h[o>>3]=N*J;K=H*H;h[p>>3]=N*N*H*K*K;K=+Gx(o,p);h[6228]=K;h[o>>3]=-K;h[6228]=+Gx(49872,o);K=+Gx(49872,49824);h[6227]=K;h[o>>3]=-K;h[6228]=+Gx(49872,o);K=+Gx(49872,49824);h[6227]=K;if(N>K&K>M){N=K}else{O=N;break}}}else{O=1.0}if(G<O){h[6236]=G}G=I/+(c[12476]|0);h[6239]=G;h[6243]=I;c[12458]=1;p=1;O=I;do{h[o>>3]=O*G;O=+Gx(o,49896);h[6243]=O;p=p+1|0;c[12458]=p;}while((p|0)<4);h[6226]=+Gx(49848,49944);Hx(50008,49848,49904)|0;h[o>>3]=-+h[6231];Hx(5e4,o,49904)|0;Hx(49952,49808,49904)|0;h[o>>3]=-+h[6226];Hx(49936,o,49904)|0;c[12466]=0;p=c[12502]|0;L=c[12500]|0;P=c[12488]|0;Q=(p|0)==(P|0);do{if((p|0)==(L|0)&(P|0)==(c[12484]|0)){if(Q){c[12480]=p;R=0;S=25;break}if((P-p|0)==3){c[12480]=p+ -1+(c[12460]|0);c[12466]=1;R=1;S=25;break}else{c[12480]=(p|0)<=(P|0)?p:P;a[49544]=1;S=26;break}}else{T=Q&(L|0)==(c[12484]|0);U=p-L|0;c[n>>2]=U;V=(((U|0)>-1?U:0-U|0)|0)==1;if(T){if(V){c[12480]=(p|0)>=(L|0)?p:L;R=0;S=25;break}else{c[12480]=(p|0)<=(L|0)?p:L;a[49544]=1;S=26;break}}T=c[12484]|0;U=(p|0)<=(L|0)?p:L;if(!(V&(P|0)==(T|0))){V=(U|0)<=(P|0)?U:P;c[n>>2]=V;c[12480]=(V|0)<=(T|0)?V:T;a[49544]=1;S=26;break}if((P-U|0)==3){c[12480]=((p|0)>=(L|0)?p:L)+ -1+(c[12460]|0);R=0;S=25;break}else{c[12480]=U;a[49544]=1;S=26;break}}}while(0);if((S|0)==25){if(a[49544]&1){S=26}else{W=R}}if((S|0)==26){a[49536]=0;yO(50016)|0;PN(50040,49920,4)|0;gO()|0;W=c[12466]|0}if((W|0)==0){X=(c[12498]|0)!=0|0}else{X=1}c[12466]=X;h[6246]=1.0;X=c[12480]|0;W=1-X|0;c[n>>2]=W;c[12458]=1;if((X|0)<=0){O=+h[6239];X=1;G=1.0;while(1){h[o>>3]=G*O;I=+Gx(o,49896);h[6246]=I;n=X+1|0;c[12458]=n;if((X|0)<(W|0)){G=I;X=n}else{break}}}Ix(49904,49840,49920,49864,49928,49976)|0;q=49904;r=c[12476]|0;c[b>>2]=r;s=49840;t=c[12460]|0;c[d>>2]=t;u=49880;v=c[12470]|0;c[e>>2]=v;w=49888;x=+h[6236];h[f>>3]=x;y=49920;z=c[12480]|0;c[g>>2]=z;A=49968;B=+h[6246];h[j>>3]=B;C=49928;D=c[12482]|0;c[k>>2]=D;E=49976;F=+h[6247];h[l>>3]=F;i=m;return 0}function Fx(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;if(a[49432]&1){l=a[49504]&1;m=c[12378]|0;c[b>>2]=m;n=49480;o=c[12370]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=49528;r=c[12382]|0;c[f>>2]=r;i=g;return 0}a[49432]=1;h[6186]=1.0;h[6180]=1.0;h[6182]=1.0;s=1.0;do{s=s*2.0;h[6180]=s;h[6182]=+Gx(49440,49488);h[j>>3]=-s;t=+Gx(49456,j);h[6182]=t;}while(t==1.0);h[6181]=1.0;t=+Gx(49440,49448);h[6182]=t;if(t==s){u=1.0;while(1){v=u*2.0;h[6181]=v;w=+Gx(49440,49448);h[6182]=w;if(w==s){u=v}else{x=w;break}}}else{x=t}h[6187]=.25;h[6190]=x;h[j>>3]=-s;t=+Gx(49456,j);h[6182]=t;y=~~(t+.25);c[12378]=y;t=+(y|0);h[6181]=t;u=t*.5;h[j>>3]=u;h[k>>3]=-t/100.0;h[6183]=+Gx(j,k);w=+Gx(49464,49440);h[6182]=w;z=w==s;a[49504]=z&1;h[j>>3]=u;h[k>>3]=t/100.0;h[6183]=+Gx(j,k);w=+Gx(49464,49440);h[6182]=w;if(z&w==s){a[49504]=0;A=0}else{A=z}h[j>>3]=u;w=+Gx(j,49440);h[6184]=w;h[j>>3]=u;z=w==s&+Gx(j,49520)>x;c[12382]=z?A&1:0;c[12370]=0;h[6180]=1.0;h[6182]=1.0;x=1.0;z=0;while(1){k=z+1|0;c[12370]=k;s=x*t;h[6180]=s;h[6182]=+Gx(49440,49488);h[j>>3]=-s;w=+Gx(49456,j);h[6182]=w;if(w==1.0){z=k;x=s}else{l=A;m=y;break}}c[b>>2]=m;n=49480;o=c[12370]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=49528;r=c[12382]|0;c[f>>2]=r;i=g;return 0}function Gx(a,b){a=a|0;b=b|0;i=i;return+(+h[a>>3]+ +h[b>>3])}function Hx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];h[6256]=g;j=1.0/+(c[d>>2]|0);h[6265]=j;h[6264]=0.0;c[a>>2]=1;h[f>>3]=g*j;k=+Gx(f,50112);h[6258]=k;h[6260]=g;h[6261]=g;h[6262]=g;h[6263]=g;if(g==g&0.0==0.0){l=0;m=k}else{i=e;return 0}while(1){c[a>>2]=l;h[6256]=m;b=c[d>>2]|0;k=+(b|0);h[f>>3]=m/k;g=+Gx(f,50112);h[6258]=g;h[f>>3]=g*k;k=+Gx(f,50112);h[6260]=k;h[6262]=0.0;c[12514]=1;if((b|0)<1){n=0.0}else{o=1;p=0.0;while(1){q=g+p;if((o|0)<(b|0)){p=q;o=o+1|0}else{break}}h[6262]=q;c[12514]=b+1;n=q}h[f>>3]=m*j;p=+Gx(f,50112);h[6259]=p;h[f>>3]=p/j;r=+Gx(f,50112);h[6261]=r;h[6263]=0.0;o=c[d>>2]|0;c[12514]=1;if((o|0)<1){s=0.0}else{t=1;u=0.0;while(1){v=p+u;if((t|0)<(o|0)){u=v;t=t+1|0}else{break}}h[6263]=v;c[12514]=o+1;s=v}if(!(k==m&r==m&n==m&s==m)){break}l=(c[a>>2]|0)+ -1|0;m=g}i=e;return 0}function Ix(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0;j=i;i=i+8|0;k=j;c[12538]=1;c[12546]=1;l=0-(c[d>>2]|0)|0;if((l|0)<2){m=2;n=l;o=2;p=1}else{l=1;q=2;while(1){c[12538]=q;r=l+1|0;c[12546]=r;s=q<<1;t=0-(c[d>>2]|0)|0;if((s|0)>(t|0)){break}else{q=s;l=r}}m=s;n=t;o=l+2|0;p=q}if((p|0)==(n|0)){c[12542]=n;u=n}else{c[12542]=m;c[12546]=o;u=m}m=c[d>>2]|0;o=((m+u|0)>(0-(p+m)|0)?p:u)<<1;c[12548]=o;u=o+(c[d>>2]|0)|0;d=u+ -1|0;c[f>>2]=d;do{if((((c[12546]|0)+1+(c[b>>2]|0)|0)%2|0|0)==1){if((c[a>>2]|0)!=2){v=d;break}o=u+ -2|0;c[f>>2]=o;v=o}else{v=d}}while(0);if((c[e>>2]|0)!=0){c[f>>2]=v+ -1}w=+(c[a>>2]|0);x=1.0/w;h[6272]=x;y=w+-1.0;h[6268]=y;h[6267]=0.0;v=c[b>>2]|0;c[12532]=1;do{if((v|0)<1){z=0.0}else{b=1;w=0.0;A=y;while(1){B=x*A;h[6268]=B;if(w<1.0){h[6270]=w}C=+Gx(50136,50144);h[6267]=C;e=b+1|0;c[12532]=e;if((b|0)<(v|0)){b=e;w=C;A=B}else{break}}if(!(C>=1.0)){z=C;break}A=+h[6270];h[6267]=A;z=A}}while(0);v=c[f>>2]|0;c[12532]=1;if((v|0)<1){D=z;h[g>>3]=D;i=j;return 0}else{E=1;F=z}while(1){h[k>>3]=F*+(c[a>>2]|0);z=+Gx(k,50200);h[6267]=z;f=E+1|0;c[12532]=f;if((E|0)<(v|0)){F=z;E=f}else{D=z;break}}h[g>>3]=D;i=j;return 0}function Jx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;l=c[b>>2]|0;b=~l;c[f>>2]=0;m=c[d>>2]|0;n=m+ -1|0;if((m|0)<2){o=m}else{c[12554]=1;m=1;do{c[12560]=m+1;c[j>>2]=(c[d>>2]|0)+1-m;p=Kx(j,a+(m+b+(fa(m,l)|0)<<3)|0,50248)|0;q=c[12554]|0;r=p+ -1+q|0;c[12556]=r;c[e+(q+ -1<<2)>>2]=r;r=c[12556]|0;q=c[12554]|0;p=fa(q,l)|0;s=+h[a+(r+b+p<<3)>>3];do{if(s==0.0){c[f>>2]=q}else{if((r|0)==(q|0)){t=r}else{h[6279]=s;u=a+(q+b+p<<3)|0;h[a+(p+b+r<<3)>>3]=+h[u>>3];h[u>>3]=+h[6279];t=q}u=fa(t,l)|0;h[6279]=-1.0/+h[a+(t+b+u<<3)>>3];c[j>>2]=(c[d>>2]|0)-t;Lx(j,50232,a+(t-l+u<<3)|0,50248)|0;u=c[d>>2]|0;c[j>>2]=u;v=c[12560]|0;c[12552]=v;if((v|0)>(u|0)){break}else{w=v}do{v=c[12556]|0;x=fa(w,l)|0;h[6279]=+h[a+(x+b+v<<3)>>3];y=c[12554]|0;if((v|0)==(y|0)){z=v}else{A=a+(y+b+x<<3)|0;h[a+(v+b+x<<3)>>3]=+h[A>>3];h[A>>3]=+h[6279];z=y}c[k>>2]=(c[d>>2]|0)-z;y=z+1|0;A=50248;Mx(k,50232,a+((fa(z,l)|0)+b+y<<3)|0,A,a+(y+b+x<<3)|0,A)|0;A=c[12552]|0;w=A+1|0;c[12552]=w;}while((A|0)<(u|0))}}while(0);q=c[12554]|0;m=q+1|0;c[12554]=m;}while((q|0)<(n|0));o=c[d>>2]|0}c[e+(o+ -1<<2)>>2]=o;o=c[d>>2]|0;if(!(+h[a+(o+b+(fa(o,l)|0)<<3)>>3]==0.0)){i=g;return 0}c[f>>2]=o;i=g;return 0}function Kx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}if((c[d>>2]|0)!=1){c[12652]=1;j=+h[b>>3];if(!(j>=0.0)){k=-j}else{k=j}h[6327]=k;l=(c[d>>2]|0)+1|0;c[12652]=l;m=c[a>>2]|0;c[12650]=2;if((m|0)<2){g=1;i=e;return g|0}else{n=2;o=k;p=l;q=1}while(1){k=+h[b+(p+ -1<<3)>>3];l=!(k>=0.0);if(l){r=-k}else{r=k}if(!(r<=o)){if(l){s=-k}else{s=k}h[6327]=s;t=s;u=n}else{t=o;u=q}l=p+(c[d>>2]|0)|0;c[12652]=l;a=n+1|0;c[12650]=a;if((n|0)<(m|0)){n=a;o=t;p=l;q=u}else{g=u;break}}i=e;return g|0}t=+h[b>>3];if(!(t>=0.0)){v=-t}else{v=t}h[6327]=v;c[12650]=2;if((f|0)<2){g=1;i=e;return g|0}else{w=v;x=2;y=1}while(1){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){z=-v}else{z=v}if(!(z<=w)){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){A=-v}else{A=v}h[6327]=A;B=A;C=x}else{B=w;C=y}if((x|0)<(f|0)){w=B;x=x+1|0;y=C}else{break}}c[12650]=f+1;g=C;i=e;return g|0}function Lx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)!=1){e=fa(j,g)|0;c[12636]=1;k=(j|0)<0;if(k?(e|0)<2:(e|0)>0){l=1}else{i=f;return 0}do{m=d+(l+ -1<<3)|0;h[m>>3]=+h[b>>3]*+h[m>>3];l=l+j|0;}while(k?(l|0)>=(e|0):(l|0)<=(e|0));c[12636]=l;i=f;return 0}l=(g|0)%5|0;c[12638]=l;do{if((l|0)==0){n=c[a>>2]|0}else{c[12636]=1;if((l|0)>=1){g=1;while(1){e=d+(g+ -1<<3)|0;h[e>>3]=+h[b>>3]*+h[e>>3];if((g|0)<(l|0)){g=g+1|0}else{break}}c[12636]=l+1}g=c[a>>2]|0;if((g|0)>=5){n=g;break}i=f;return 0}}while(0);a=l+1|0;c[12636]=a;if((l|0)<(n|0)){o=a}else{i=f;return 0}do{a=d+(o+ -1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+2<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+3<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];o=o+5|0;}while((o|0)<=(n|0));c[12636]=o;i=f;return 0}function Mx(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0;j=i;k=c[a>>2]|0;if((k|0)<1){i=j;return 0}l=+h[b>>3];if(l==0.0){i=j;return 0}do{if((c[e>>2]|0)==1){if((c[g>>2]|0)!=1){break}m=(k|0)%4|0;c[12622]=m;do{if((m|0)==0){n=c[a>>2]|0}else{c[12620]=1;if((m|0)>=1){o=l;p=1;q=0;while(1){r=f+(q<<3)|0;h[r>>3]=+h[r>>3]+o*+h[d+(q<<3)>>3];if((p|0)>=(m|0)){break}r=p;o=+h[b>>3];p=p+1|0;q=r}c[12620]=m+1}q=c[a>>2]|0;if((q|0)>=4){n=q;break}i=j;return 0}}while(0);q=m+1|0;c[12620]=q;if((m|0)<(n|0)){s=q}else{i=j;return 0}do{q=s+ -1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=f+(s<<3)|0;h[q>>3]=+h[q>>3]+ +h[b>>3]*+h[d+(s<<3)>>3];q=s+1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=s+2|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];s=s+4|0;}while((s|0)<=(n|0));c[12620]=s;i=j;return 0}}while(0);c[12624]=1;c[12626]=1;s=c[e>>2]|0;if((s|0)<0){n=(fa(1-(c[a>>2]|0)|0,s)|0)+1|0;c[12624]=n;t=n}else{t=1}n=c[g>>2]|0;if((n|0)<0){s=(fa(1-(c[a>>2]|0)|0,n)|0)+1|0;c[12626]=s;u=s}else{u=1}s=c[a>>2]|0;c[12620]=1;if((s|0)<1){i=j;return 0}else{v=l;w=1;x=u;y=t}while(1){t=f+(x+ -1<<3)|0;h[t>>3]=v*+h[d+(y+ -1<<3)>>3]+ +h[t>>3];t=y+(c[e>>2]|0)|0;c[12624]=t;u=x+(c[g>>2]|0)|0;c[12626]=u;a=w+1|0;c[12620]=a;if((w|0)>=(s|0)){break}v=+h[b>>3];y=t;x=u;w=a}i=j;return 0}function Nx(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;j=i;i=i+8|0;k=j;l=c[b>>2]|0;b=~l;m=c[d>>2]|0;n=m+ -1|0;c[12572]=n;if((c[g>>2]|0)==0){if((m|0)>=2){c[12564]=1;m=1;do{g=m+ -1|0;o=c[e+(g<<2)>>2]|0;c[12566]=o;p=f+(o+ -1<<3)|0;h[6284]=+h[p>>3];if((o|0)!=(m|0)){o=f+(g<<3)|0;h[p>>3]=+h[o>>3];h[o>>3]=+h[6284]}c[k>>2]=(c[d>>2]|0)-m;o=50248;Mx(k,50272,a+(m-l+(fa(m,l)|0)<<3)|0,o,f+(m<<3)|0,o)|0;o=c[12564]|0;m=o+1|0;c[12564]=m;}while((o|0)<(n|0))}m=c[d>>2]|0;c[12570]=1;if((m|0)<1){i=j;return 0}else{q=1}do{o=1-q+(c[d>>2]|0)|0;c[12564]=o;p=fa(o,l)|0;g=o+ -1|0;r=f+(g<<3)|0;s=+h[r>>3]/+h[a+(o+b+p<<3)>>3];h[r>>3]=s;h[6284]=-s;c[k>>2]=g;g=50248;Mx(k,50272,a+(p-l<<3)|0,g,f,g)|0;g=c[12570]|0;q=g+1|0;c[12570]=q;}while((g|0)<(m|0));i=j;return 0}m=c[d>>2]|0;c[12564]=1;if((m|0)<1){t=n}else{n=1;do{c[k>>2]=n+ -1;q=50248;s=+Ox(k,a+((fa(n,l)|0)-l<<3)|0,q,f,q);h[6284]=s;q=c[12564]|0;g=f+(q+ -1<<3)|0;h[g>>3]=(+h[g>>3]-s)/+h[a+(q+b+(fa(q,l)|0)<<3)>>3];n=q+1|0;c[12564]=n;}while((q|0)<(m|0));t=c[12572]|0}if((t|0)<1){i=j;return 0}c[12570]=1;m=1;do{n=(c[d>>2]|0)-m|0;c[12564]=n;c[k>>2]=(c[d>>2]|0)-n;b=50248;s=+Ox(k,a+(n-l+(fa(n,l)|0)<<3)|0,b,f+(n<<3)|0,b);b=c[12564]|0;n=b+ -1|0;q=f+(n<<3)|0;h[q>>3]=s+ +h[q>>3];g=c[e+(n<<2)>>2]|0;c[12566]=g;if((g|0)!=(b|0)){b=f+(g+ -1<<3)|0;h[6284]=+h[b>>3];h[b>>3]=+h[q>>3];h[q>>3]=+h[6284]}q=c[12570]|0;m=q+1|0;c[12570]=m;}while((q|0)<(t|0));i=j;return 0}function Ox(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0;g=i;h[6324]=0.0;j=c[a>>2]|0;if((j|0)<1){k=0.0;i=g;return+k}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}l=(j|0)%5|0;c[12642]=l;do{if((l|0)==0){m=c[a>>2]|0;n=0.0}else{c[12640]=1;if((l|0)<1){o=0.0}else{p=0.0;q=1;while(1){r=q+ -1|0;s=p+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3];h[6324]=s;if((q|0)<(l|0)){q=q+1|0;p=s}else{break}}c[12640]=l+1;o=s}q=c[a>>2]|0;if((q|0)<5){k=o}else{m=q;n=o;break}i=g;return+k}}while(0);q=l+1|0;c[12640]=q;if((l|0)<(m|0)){t=n;u=q}else{k=n;i=g;return+k}do{q=u+ -1|0;r=u+1|0;v=u+2|0;w=u+3|0;t=t+ +h[b+(q<<3)>>3]*+h[e+(q<<3)>>3]+ +h[b+(u<<3)>>3]*+h[e+(u<<3)>>3]+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3]+ +h[b+(v<<3)>>3]*+h[e+(v<<3)>>3]+ +h[b+(w<<3)>>3]*+h[e+(w<<3)>>3];h[6324]=t;u=u+5|0;}while((u|0)<=(m|0));c[12640]=u;k=t;i=g;return+k}}while(0);c[12644]=1;c[12646]=1;u=c[d>>2]|0;if((u|0)<0){m=(fa(1-(c[a>>2]|0)|0,u)|0)+1|0;c[12644]=m;x=m}else{x=1}m=c[f>>2]|0;if((m|0)<0){u=(fa(1-(c[a>>2]|0)|0,m)|0)+1|0;c[12646]=u;y=u}else{y=1}u=c[a>>2]|0;c[12640]=1;if((u|0)<1){k=0.0;i=g;return+k}else{z=1;A=0.0;B=y;C=x}while(1){t=A+ +h[b+(C+ -1<<3)>>3]*+h[e+(B+ -1<<3)>>3];h[6324]=t;x=C+(c[d>>2]|0)|0;c[12644]=x;y=B+(c[f>>2]|0)|0;c[12646]=y;a=z+1|0;c[12640]=a;if((z|0)<(u|0)){C=x;B=y;A=t;z=a}else{k=t;break}}i=g;return+k}function Px(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+8|0;l=k;m=c[b>>2]|0;b=~m;c[12582]=(c[e>>2]|0)+1+(c[f>>2]|0);c[j>>2]=0;n=(c[f>>2]|0)+2|0;c[12588]=n;o=c[d>>2]|0;p=c[12582]|0;q=(o|0)>(p|0)?p:o;o=q+ -1|0;c[12590]=o;do{if((q|0)>(n|0)){c[12598]=n;if((n|0)>(o|0)){break}else{r=n}while(1){s=1-r+p|0;c[12586]=s;t=c[e>>2]|0;c[12574]=s;if((s|0)<=(t|0)){u=s;while(1){h[a+(u+b+(fa(r,m)|0)<<3)>>3]=0.0;if((u|0)<(t|0)){u=u+1|0}else{break}}c[12574]=t+1}u=r+1|0;c[12598]=u;if((r|0)<(o|0)){r=u}else{break}}c[l>>2]=t}}while(0);c[12598]=o;c[12596]=0;t=c[d>>2]|0;r=t+ -1|0;if((t|0)<2){v=t}else{c[12578]=1;t=o;o=1;while(1){c[12600]=o+1;p=t+1|0;c[12598]=p;n=c[d>>2]|0;do{if((t|0)<(n|0)){q=c[e>>2]|0;if((q|0)<1){w=n;break}c[l>>2]=q;c[12574]=1;u=fa(p,m)|0;s=1;while(1){h[a+(s+b+u<<3)>>3]=0.0;if((s|0)<(q|0)){s=s+1|0}else{break}}c[12574]=q+1;w=c[d>>2]|0}else{w=n}}while(0);n=c[e>>2]|0;p=w-o|0;s=(n|0)<=(p|0)?n:p;c[12592]=s;c[l>>2]=s+1;s=Kx(l,a+((c[12582]|0)+b+(fa(o,m)|0)<<3)|0,50248)|0;p=s+ -1|0;c[12580]=p+(c[12582]|0);s=c[12578]|0;c[g+(s+ -1<<2)>>2]=p+s;s=c[12580]|0;p=c[12578]|0;n=fa(p,m)|0;x=+h[a+(s+b+n<<3)>>3];a:do{if(x==0.0){c[j>>2]=p}else{u=c[12582]|0;if((s|0)==(u|0)){y=s}else{h[6292]=x;z=a+(u+b+n<<3)|0;h[a+(n+b+s<<3)>>3]=+h[z>>3];h[z>>3]=+h[6292];y=u}h[6292]=-1.0/+h[a+(y+b+n<<3)>>3];Lx(50368,50336,a+(y-m+n<<3)|0,50248)|0;u=c[12596]|0;z=(c[g+((c[12578]|0)+ -1<<2)>>2]|0)+(c[f>>2]|0)|0;A=(u|0)>=(z|0)?u:z;c[l>>2]=A;z=c[d>>2]|0;u=(A|0)>(z|0)?z:A;c[12596]=u;A=c[12582]|0;c[12594]=A;z=c[12600]|0;if((u|0)<(z|0)){break}c[l>>2]=u;c[12576]=z;B=z;z=A;while(1){A=(c[12580]|0)+ -1|0;c[12580]=A;C=z+ -1|0;c[12594]=C;D=fa(B,m)|0;E=a+(A+b+D<<3)|0;h[6292]=+h[E>>3];if((A|0)==(C|0)){F=A}else{A=a+(C+b+D<<3)|0;h[E>>3]=+h[A>>3];h[A>>3]=+h[6292];F=C}C=50248;Mx(50368,50336,a+((c[12582]|0)-m+(fa(c[12578]|0,m)|0)<<3)|0,C,a+(F-m+D<<3)|0,C)|0;C=c[12576]|0;D=C+1|0;c[12576]=D;if((C|0)>=(u|0)){break a}B=D;z=c[12594]|0}}}while(0);n=c[12578]|0;s=n+1|0;c[12578]=s;if((n|0)>=(r|0)){break}t=c[12598]|0;o=s}v=c[d>>2]|0}c[g+(v+ -1<<2)>>2]=v;v=c[d>>2]|0;if(!(+h[a+((c[12582]|0)+b+(fa(v,m)|0)<<3)>>3]==0.0)){i=k;return 0}c[j>>2]=v;i=k;return 0}function Qx(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0;l=i;m=c[b>>2]|0;b=~m;n=(c[f>>2]|0)+1+(c[e>>2]|0)|0;c[12606]=n;f=c[d>>2]|0;o=f+ -1|0;c[12618]=o;if((c[k>>2]|0)==0){if(!((c[e>>2]|0)==0|(f|0)<2)){c[12602]=1;f=1;do{k=c[e>>2]|0;p=(c[d>>2]|0)-f|0;c[12616]=(k|0)<=(p|0)?k:p;p=f+ -1|0;k=c[g+(p<<2)>>2]|0;c[12604]=k;q=j+(k+ -1<<3)|0;h[6304]=+h[q>>3];if((k|0)!=(f|0)){k=j+(p<<3)|0;h[q>>3]=+h[k>>3];h[k>>3]=+h[6304]}k=50248;Mx(50464,50432,a+((c[12606]|0)-m+(fa(f,m)|0)<<3)|0,k,j+(f<<3)|0,k)|0;k=c[12602]|0;f=k+1|0;c[12602]=f;}while((k|0)<(o|0))}f=c[d>>2]|0;c[12610]=1;if((f|0)<1){i=l;return 0}else{r=1}do{k=1-r+(c[d>>2]|0)|0;c[12602]=k;q=c[12606]|0;p=fa(k,m)|0;s=j+(k+ -1<<3)|0;t=+h[s>>3]/+h[a+(q+b+p<<3)>>3];h[s>>3]=t;s=((k|0)<=(q|0)?k:q)+ -1|0;c[12616]=s;u=q-s|0;c[12612]=u;q=k-s|0;c[12614]=q;h[6304]=-t;s=50248;Mx(50464,50432,a+(u+b+p<<3)|0,s,j+(q+ -1<<3)|0,s)|0;s=c[12610]|0;r=s+1|0;c[12610]=r;}while((s|0)<(f|0));i=l;return 0}f=c[d>>2]|0;c[12602]=1;if((f|0)<1){v=n;w=o}else{o=n;n=1;do{r=((n|0)<=(o|0)?n:o)+ -1|0;c[12616]=r;s=o-r|0;c[12612]=s;q=n-r|0;c[12614]=q;r=50248;t=+Ox(50464,a+((fa(n,m)|0)+b+s<<3)|0,r,j+(q+ -1<<3)|0,r);h[6304]=t;r=c[12602]|0;q=j+(r+ -1<<3)|0;o=c[12606]|0;h[q>>3]=(+h[q>>3]-t)/+h[a+((fa(r,m)|0)+b+o<<3)>>3];n=r+1|0;c[12602]=n;}while((r|0)<(f|0));v=o;w=c[12618]|0}if((c[e>>2]|0)==0|(w|0)<1){i=l;return 0}c[12610]=1;o=v;v=1;while(1){f=(c[d>>2]|0)-v|0;c[12602]=f;n=c[e>>2]|0;b=(c[d>>2]|0)-f|0;c[12616]=(n|0)<=(b|0)?n:b;b=50248;t=+Ox(50464,a+(o-m+(fa(f,m)|0)<<3)|0,b,j+(f<<3)|0,b);b=c[12602]|0;f=b+ -1|0;n=j+(f<<3)|0;h[n>>3]=t+ +h[n>>3];r=c[g+(f<<2)>>2]|0;c[12604]=r;if((r|0)!=(b|0)){b=j+(r+ -1<<3)|0;h[6304]=+h[b>>3];h[b>>3]=+h[n>>3];h[n>>3]=+h[6304]}n=c[12610]|0;b=n+1|0;c[12610]=b;if((n|0)>=(w|0)){break}o=c[12606]|0;v=b}i=l;return 0}function Rx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}k=(j|0)%7|0;c[12630]=k;do{if((k|0)==0){l=c[a>>2]|0}else{c[12628]=1;if((k|0)>=1){m=1;while(1){n=m+ -1|0;h[e+(n<<3)>>3]=+h[b+(n<<3)>>3];if((m|0)<(k|0)){m=m+1|0}else{break}}c[12628]=k+1}m=c[a>>2]|0;if((m|0)>=7){l=m;break}i=g;return 0}}while(0);m=k+1|0;c[12628]=m;if((k|0)<(l|0)){o=m}else{i=g;return 0}do{m=o+ -1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];h[e+(o<<3)>>3]=+h[b+(o<<3)>>3];m=o+1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+2|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+3|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+4|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+5|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];o=o+7|0;}while((o|0)<=(l|0));c[12628]=o;i=g;return 0}}while(0);c[12632]=1;c[12634]=1;o=c[d>>2]|0;if((o|0)<0){l=(fa(1-(c[a>>2]|0)|0,o)|0)+1|0;c[12632]=l;p=l}else{p=1}l=c[f>>2]|0;if((l|0)<0){o=(fa(1-(c[a>>2]|0)|0,l)|0)+1|0;c[12634]=o;q=o}else{q=1}o=c[a>>2]|0;c[12628]=1;if((o|0)<1){i=g;return 0}else{r=1;s=q;t=p}while(1){h[e+(s+ -1<<3)>>3]=+h[b+(t+ -1<<3)>>3];p=t+(c[d>>2]|0)|0;c[12632]=p;q=s+(c[f>>2]|0)|0;c[12634]=q;a=r+1|0;c[12628]=a;if((r|0)<(o|0)){t=p;s=q;r=a}else{break}}i=g;return 0}function Sx(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;if((a[b]|0)==(a[e]|0)){h=1;i=g;return h|0}a[50640]=1;f=d[b]|0;c[12656]=f;b=d[e]|0;c[12658]=b;if((f+ -97|0)>>>0<26){e=f+ -32|0;c[12656]=e;j=e}else{j=f}if((b+ -97|0)>>>0<26){f=b+ -32|0;c[12658]=f;k=f}else{k=b}h=(j|0)==(k|0)|0;i=g;return h|0}function Tx(b,d,e,f,g,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0.0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;r=i;if((c[j>>2]|0)>0){c[60172>>2]=6;yO(60168)|0;PN(60912,j,4)|0;gO()|0}c[q>>2]=0;s=(c[e>>2]|0)<1?3:0;c[q>>2]=s;t=(c[l>>2]|0)<1?4:s;c[q>>2]=t;if((t|0)!=0){i=r;return 0}c[14344]=0;c[14950]=0;c[14938]=0;a[59776]=0;t=c[e>>2]|0;c[13898]=1;do{if((t|0)>=1){s=0;u=1;while(1){if(+h[d+(u+ -1<<3)>>3]!=0.0){v=s+1|0;c[14344]=v;w=v}else{w=s}if((u|0)<(t|0)){s=w;u=u+1|0}else{break}}c[13898]=t+1;if((w|0)<=0){break}u=p;s=f;a:while(1){v=c[e>>2]|0;c[13898]=1;if((v|0)>=1){x=1;while(1){h[52064+((x*21|0)+ -21<<3)>>3]=+h[b+(x+ -1<<3)>>3];if((x|0)<(v|0)){x=x+1|0}else{break}}c[13898]=v+1}c[14942]=2;x=c[e>>2]|0;c[13898]=1;if((x|0)>=1){y=2;z=1;while(1){A=z+ -1|0;B=d+(A<<3)|0;C=+h[B>>3];if(C==0.0){D=y}else{E=c[e>>2]|0;c[13900]=1;if((E|0)<1){F=C}else{G=1;while(1){h[52064+((G*21|0)+ -22+y<<3)>>3]=+h[b+(G+ -1<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[13900]=E+1;F=+h[B>>3]}h[52064+((z*21|0)+ -22+y<<3)>>3]=+h[b+(A<<3)>>3]+F;G=y+1|0;c[14942]=G;D=G}G=z+1|0;c[13898]=G;if((z|0)<(x|0)){y=D;z=G}else{break}}}z=c[14344]|0;y=z+1|0;c[14340]=y;c[13898]=1;if((z|0)>=0){z=1;do{x=c[e>>2]|0;c[13900]=1;if((x|0)>=1){v=1;while(1){h[b+(v+ -1<<3)>>3]=+h[52064+((v*21|0)+ -22+z<<3)>>3];if((v|0)<(x|0)){v=v+1|0}else{break}}c[13900]=x+1}ie[u&63](e,b,55424+(z+ -1<<3)|0)|0;c[14950]=(c[14950]|0)+1;if((c[j>>2]|0)>=1){c[60196>>2]=6;yO(60192)|0;PN(60912,59800,4)|0;PN(60912,55424+((c[13898]|0)+ -1<<3)|0,8)|0;v=c[e>>2]|0;c[13900]=1;if((v|0)>=1){A=1;do{PN(60912,b+(A+ -1<<3)|0,8)|0;B=c[13900]|0;A=B+1|0;c[13900]=A;}while((B|0)<(v|0))}gO()|0}v=c[13898]|0;z=v+1|0;c[13898]=z;}while((v|0)<(y|0))}y=c[14938]|0;b:while(1){c[14938]=y+1;c[14850]=1;c[14846]=1;C=+h[6928];h[7424]=C;h[7426]=C;z=c[14340]|0;c[13898]=2;if((z|0)<2){H=1}else{I=C;K=C;v=1;A=2;while(1){C=+h[55424+(A+ -1<<3)>>3];do{if(!(C<=K)){c[14850]=A;L=+h[55424+(A+ -1<<3)>>3];h[7424]=L;M=I;N=L;O=A}else{if(C>=I){M=I;N=K;O=v;break}c[14846]=A;L=+h[55424+(A+ -1<<3)>>3];h[7426]=L;M=L;N=K;O=v}}while(0);if((A|0)<(z|0)){I=M;K=N;v=O;A=A+1|0}else{break}}c[13898]=z+1;H=O}A=c[e>>2]|0;c[13898]=1;if((A|0)>=1){v=1;while(1){h[57544+(v+ -1<<3)>>3]=0.0;if((v|0)<(A|0)){v=v+1|0}else{break}}c[13898]=A+1}c[13898]=1;if((z|0)>=1){v=1;do{do{if((v|0)==(H|0)){P=H}else{x=c[e>>2]|0;c[13900]=1;if((x|0)<1){P=v;break}else{Q=1}while(1){B=57544+(Q+ -1<<3)|0;h[B>>3]=+h[52064+((Q*21|0)+ -22+v<<3)>>3]+ +h[B>>3];if((Q|0)<(x|0)){Q=Q+1|0}else{break}}c[13900]=x+1;P=v}}while(0);v=P+1|0;c[13898]=v;}while((P|0)<(z|0))}z=c[e>>2]|0;c[13900]=1;if((z|0)>=1){K=+(c[14344]|0);v=1;while(1){A=57544+(v+ -1<<3)|0;h[A>>3]=+h[A>>3]/K;if((v|0)<(z|0)){v=v+1|0}else{break}}c[13900]=z+1}v=c[e>>2]|0;c[13898]=1;if((v|0)>=1){A=1;while(1){B=A+ -1|0;K=+h[57544+(B<<3)>>3];h[59824+(B<<3)>>3]=K+(K- +h[52064+((A*21|0)+ -22+H<<3)>>3]);if((A|0)<(v|0)){A=A+1|0}else{break}}c[13898]=v+1}ie[u&63](e,59824,59816)|0;A=(c[14950]|0)+1|0;c[14950]=A;z=c[j>>2]|0;do{if((z|0)>=1){if(((A|0)%(z|0)|0|0)!=0){break}c[60220>>2]=6;yO(60216)|0;PN(60912,59800,4)|0;PN(60912,59816,8)|0;B=c[e>>2]|0;c[13900]=1;if((B|0)>=1){E=1;do{PN(60912,59824+(E+ -1<<3)|0,8)|0;G=c[13900]|0;E=G+1|0;c[13900]=E;}while((G|0)<(B|0))}gO()|0}}while(0);K=+h[7477];c:do{if(!(K>=+h[7426])){z=c[e>>2]|0;c[13898]=1;if((z|0)>=1){A=1;while(1){v=A+ -1|0;I=+h[57544+(v<<3)>>3];h[59992+(v<<3)>>3]=I+(+h[59824+(v<<3)>>3]-I)*2.0;if((A|0)<(z|0)){A=A+1|0}else{break}}c[13898]=z+1}ie[u&63](e,59992,59984)|0;A=(c[14950]|0)+1|0;c[14950]=A;v=c[j>>2]|0;do{if((v|0)>=1){if(((A|0)%(v|0)|0|0)!=0){break}c[60244>>2]=6;yO(60240)|0;PN(60912,59800,4)|0;PN(60912,59984,8)|0;B=c[e>>2]|0;c[13900]=1;if((B|0)>=1){E=1;do{PN(60912,59992+(E+ -1<<3)|0,8)|0;G=c[13900]|0;E=G+1|0;c[13900]=E;}while((G|0)<(B|0))}gO()|0}}while(0);I=+h[7498];if(I>=+h[7426]){R=118;break}v=c[e>>2]|0;c[13898]=1;A=c[14850]|0;if((v|0)>=1){z=1;while(1){B=z+ -1|0;if(+h[d+(B<<3)>>3]!=0.0){h[52064+((z*21|0)+ -22+A<<3)>>3]=+h[59992+(B<<3)>>3]}if((z|0)<(v|0)){z=z+1|0}else{break}}c[13898]=v+1}h[55424+(A+ -1<<3)>>3]=I}else{z=c[14340]|0;c[13898]=1;if((z|0)>=1){B=c[14850]|0;E=1;while(1){if((E|0)!=(B|0)){if(K<+h[55424+(E+ -1<<3)>>3]){R=118;break c}}x=E+1|0;c[13898]=x;if((E|0)<(z|0)){E=x}else{break}}}if(!(K>+h[7424])){E=c[e>>2]|0;c[13898]=1;z=c[14850]|0;if((E|0)>=1){B=1;while(1){A=B+ -1|0;if(+h[d+(A<<3)>>3]!=0.0){h[52064+((B*21|0)+ -22+z<<3)>>3]=+h[59824+(A<<3)>>3]}if((B|0)<(E|0)){B=B+1|0}else{break}}c[13898]=E+1}h[7424]=K;h[55424+(z+ -1<<3)>>3]=K}B=c[e>>2]|0;c[13898]=1;if((B|0)>=1){A=c[14850]|0;v=1;while(1){x=v+ -1|0;h[59992+(x<<3)>>3]=+h[52064+((v*21|0)+ -22+A<<3)>>3]*.5+ +h[57544+(x<<3)>>3]*.5;if((v|0)<(B|0)){v=v+1|0}else{break}}c[13898]=B+1}ie[u&63](e,59992,59984)|0;v=(c[14950]|0)+1|0;c[14950]=v;A=c[j>>2]|0;do{if((A|0)>=1){if(((v|0)%(A|0)|0|0)!=0){break}c[60268>>2]=6;yO(60264)|0;PN(60912,59800,4)|0;PN(60912,59984,8)|0;z=c[e>>2]|0;c[13900]=1;if((z|0)>=1){E=1;do{PN(60912,59992+(E+ -1<<3)|0,8)|0;x=c[13900]|0;E=x+1|0;c[13900]=E;}while((x|0)<(z|0))}gO()|0}}while(0);I=+h[7498];if(!(I>+h[7424])){A=c[e>>2]|0;c[13898]=1;v=c[14850]|0;if((A|0)>=1){B=1;while(1){z=B+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[52064+((B*21|0)+ -22+v<<3)>>3]=+h[59992+(z<<3)>>3]}if((B|0)<(A|0)){B=B+1|0}else{break}}c[13898]=A+1}h[55424+(v+ -1<<3)>>3]=I;break}B=c[14340]|0;c[13898]=1;if((B|0)<1){break}else{S=1}do{z=c[14846]|0;do{if((S|0)!=(z|0)){E=c[e>>2]|0;c[13900]=1;if((E|0)>=1){x=S+ -22|0;G=1;while(1){if(+h[d+(G+ -1<<3)>>3]!=0.0){T=(G*21|0)+ -22|0;U=52064+(T+S<<3)|0;h[U>>3]=(+h[U>>3]+ +h[52064+(T+z<<3)>>3])*.5}h[b+(G+ -1<<3)>>3]=+h[52064+(x+(G*21|0)<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[13900]=E+1}ie[u&63](e,b,55424+(S+ -1<<3)|0)|0;G=(c[14950]|0)+1|0;c[14950]=G;x=c[j>>2]|0;if((x|0)<1){break}if(((G|0)%(x|0)|0|0)!=0){break}c[60292>>2]=6;yO(60288)|0;PN(60912,59800,4)|0;PN(60912,55424+((c[13898]|0)+ -1<<3)|0,8)|0;x=c[e>>2]|0;c[13900]=1;if((x|0)>=1){G=1;do{PN(60912,b+(G+ -1<<3)|0,8)|0;T=c[13900]|0;G=T+1|0;c[13900]=G;}while((T|0)<(x|0))}gO()|0}}while(0);z=c[13898]|0;S=z+1|0;c[13898]=S;}while((z|0)<(B|0))}}while(0);if((R|0)==118){R=0;B=c[e>>2]|0;c[13898]=1;v=c[14850]|0;if((B|0)>=1){A=1;while(1){z=A+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[52064+((A*21|0)+ -22+v<<3)>>3]=+h[59824+(z<<3)>>3]}if((A|0)<(B|0)){A=A+1|0}else{break}}c[13898]=B+1}h[55424+(v+ -1<<3)>>3]=+h[7477]}A=c[14938]|0;if((A|0)<(c[l>>2]|0)){y=A;continue}h[7427]=0.0;h[7473]=0.0;A=c[14340]|0;c[13898]=1;z=(A|0)<1;do{if(z){K=+(A|0);h[7473]=0.0/K;c[13898]=1;W=K;X=0.0}else{x=1;K=0.0;while(1){Y=+h[55424+(x+ -1<<3)>>3]+K;if((x|0)<(A|0)){K=Y;x=x+1|0}else{break}}K=+(A|0);I=Y/K;h[7473]=I;c[13898]=1;if(z){W=K;X=0.0;break}else{Z=1;_=0.0}while(1){C=+h[55424+(Z+ -1<<3)>>3]-I;$=_+C*C;if((Z|0)<(A|0)){_=$;Z=Z+1|0}else{break}}h[7427]=$;c[13898]=A+1;W=K;X=$}}while(0);I=+V(+(X/W));h[7427]=I;do{if(!(I<=+h[k>>3])){if((c[14950]|0)>(c[g>>2]|0)){break}a[59776]=0;c[14938]=0;y=0;continue b}}while(0);v=c[e>>2]|0;c[13898]=1;if((v|0)>=1){B=1;while(1){x=B+ -1|0;if(!(+h[d+(x<<3)>>3]==0.0)){h[b+(x<<3)>>3]=0.0;c[13900]=1;if(z){aa=b+(B+ -1<<3)|0}else{x=B*21|0;G=b+(B+ -1<<3)|0;I=+h[G>>3];E=1;while(1){C=+h[52064+(E+ -22+x<<3)>>3]+I;h[G>>3]=C;if((E|0)<(A|0)){E=E+1|0;I=C}else{break}}c[13900]=A+1;aa=G}h[aa>>3]=+h[aa>>3]/W}if((B|0)<(v|0)){B=B+1|0}else{break}}c[13898]=v+1}ie[u&63](e,b,f)|0;B=(c[14950]|0)+1|0;c[14950]=B;A=c[j>>2]|0;do{if((A|0)<1){ba=B}else{if(((B|0)%(A|0)|0|0)!=0){ba=B;break}c[60316>>2]=6;yO(60312)|0;PN(60912,59800,4)|0;PN(60912,s,8)|0;z=c[e>>2]|0;c[13900]=1;if((z|0)>=1){E=1;do{PN(60912,b+(E+ -1<<3)|0,8)|0;x=c[13900]|0;E=x+1|0;c[13900]=E;}while((x|0)<(z|0))}gO()|0;ba=c[14950]|0}}while(0);if((ba|0)>(c[g>>2]|0)){R=150;break a}if((c[j>>2]|0)>=0){c[60436>>2]=6;yO(60432)|0;gO()|0;c[60460>>2]=6;yO(60456)|0;B=c[e>>2]|0;c[13898]=1;if((B|0)>=1){A=1;do{PN(60912,b+(A+ -1<<3)|0,8)|0;v=c[13898]|0;A=v+1|0;c[13898]=A;}while((v|0)<(B|0))}gO()|0;c[60484>>2]=6;yO(60480)|0;PN(60912,s,8)|0;gO()|0}if(a[59776]&1){I=+h[7473];K=+h[7519]-I;if(!(K>=0.0)){ca=-K}else{ca=K}if(!(ca>=+h[k>>3])){break}else{da=I}}else{a[59776]=1;da=+h[7473]}h[7519]=da;c[14938]=0;y=0}if((c[j>>2]|0)>=0){c[60508>>2]=6;yO(60504)|0;PN(60912,59800,4)|0;gO()|0;c[60532>>2]=6;yO(60528)|0;y=c[e>>2]|0;c[13898]=1;if((y|0)>=1){B=1;do{PN(60912,b+(B+ -1<<3)|0,8)|0;A=c[13898]|0;B=A+1|0;c[13898]=B;}while((A|0)<(y|0))}gO()|0;c[60556>>2]=6;yO(60552)|0;PN(60912,s,8)|0;gO()|0}if((c[m>>2]|0)<1){R=312;break}if((c[j>>2]|0)>-1){c[60580>>2]=6;yO(60576)|0;gO()|0}h[7426]=+h[f>>3];c[14952]=0;y=c[14340]|0;c[13898]=1;if((y|0)>=1){B=1;while(1){A=55424+(B+ -1<<3)|0;I=+h[A>>3]- +h[f>>3];if(!(I>=0.0)){ea=-I}else{ea=I}if(ea>=+h[n>>3]){v=B+1|0;c[13898]=v;if((B|0)<(y|0)){B=v;continue}else{break}}v=c[e>>2]|0;c[13900]=1;if((v|0)>=1){z=B+ -22|0;E=1;while(1){G=E+ -1|0;if(+h[d+(G<<3)>>3]!=0.0){x=52064+((E*21|0)+ -22+B<<3)|0;I=+h[x>>3];h[x>>3]=I+(I- +h[b+(G<<3)>>3])}h[59992+(E+ -1<<3)>>3]=+h[52064+(z+(E*21|0)<<3)>>3];if((E|0)<(v|0)){E=E+1|0}else{break}}c[13900]=v+1}ie[u&63](e,59992,A)|0;c[14952]=(c[14952]|0)+1;c[14950]=(c[14950]|0)+1;E=c[13898]|0;I=+h[55424+(E+ -1<<3)>>3];if(I>=+h[7426]){B=E;continue}h[7426]=I;if(!((c[j>>2]|0)>-1)){B=E;continue}c[60604>>2]=6;yO(60600)|0;PN(60912,59800,4)|0;PN(60912,59408,8)|0;E=c[e>>2]|0;c[13900]=1;if((E|0)>=1){z=1;do{PN(60912,59992+(z+ -1<<3)|0,8)|0;G=c[13900]|0;z=G+1|0;c[13900]=z;}while((G|0)<(E|0))}gO()|0;B=c[13898]|0}}B=c[14344]|0;c[13898]=1;do{if((B|0)<1){h[6953]=+h[6928];c[13898]=1;ga=B;R=202}else{y=1;do{E=y+1|0;c[13908]=E;z=c[e>>2]|0;c[13900]=1;if((z|0)>=1){A=1;while(1){v=A*21|0;h[59824+(A+ -1<<3)>>3]=(+h[52064+(v+ -21<<3)>>3]+ +h[52064+(v+ -22+E<<3)>>3])*.5;if((A|0)<(z|0)){A=A+1|0}else{break}}c[13900]=z+1}ie[u&63](e,59824,57384+(y+ -1<<3)|0)|0;c[14952]=(c[14952]|0)+1;c[14950]=(c[14950]|0)+1;A=c[13898]|0;y=A+1|0;c[13898]=y;}while((A|0)<(B|0));y=c[14344]|0;I=+h[6928];h[6953]=I;c[13898]=1;if((y|0)<1){ga=y;R=202;break}else{ha=I;ia=1}while(1){A=ia+ -1|0;c[13908]=A;c[13910]=ia+1;if((ia|0)<2){ja=ia;ka=ha}else{c[13900]=1;E=1;while(1){v=E+1|0;c[13912]=v;G=c[e>>2]|0;c[13902]=1;if((G|0)>=1){x=c[13910]|0;T=1;while(1){U=(T*21|0)+ -22|0;h[59992+(T+ -1<<3)>>3]=(+h[52064+(U+x<<3)>>3]+ +h[52064+(U+v<<3)>>3])*.5;if((T|0)<(G|0)){T=T+1|0}else{break}}c[13902]=G+1}ie[u&63](e,59992,59984)|0;c[14952]=(c[14952]|0)+1;c[14950]=(c[14950]|0)+1;T=c[13898]|0;v=T+ -1|0;x=(fa(v,T)|0)/2|0;U=c[13900]|0;la=U+x|0;c[13904]=la;I=+h[6953];h[57704+(la+ -1<<3)>>3]=(+h[7498]+I- +h[57384+(v<<3)>>3]- +h[57384+(U+ -1<<3)>>3])*2.0;v=U+1|0;c[13900]=v;if((U|0)<(A|0)){E=v}else{ja=T;ka=I;break}}}E=ja+1|0;c[13898]=E;if((ja|0)<(y|0)){ha=ka;ia=E}else{break}}y=c[14344]|0;c[13904]=0;c[13898]=1;E=(y|0)<1;if(E){c[13898]=1;ma=1;na=y;break}A=y+ -1|0;z=A<<1;T=Q_(A|0,0,y+ -2|0,0)|0;A=J_(T|0,J&1|0,1)|0;T=0;v=1;while(1){U=T+v|0;h[57704+(U+ -1<<3)>>3]=(+h[55424+(v<<3)>>3]+ka- +h[57384+(v+ -1<<3)>>3]*2.0)*2.0;if((v|0)<(y|0)){v=v+1|0;T=U}else{break}}c[13908]=v+1;c[13904]=(z|1)+A;c[13898]=1;if(E){ma=1;na=y;break}I=ka*3.0;T=1;while(1){U=57384+(T+ -1<<3)|0;h[U>>3]=+h[U>>3]*2.0-(+h[55424+(T<<3)>>3]+I)*.5;if((T|0)<(y|0)){T=T+1|0}else{break}}c[13908]=T+1;c[13898]=y+1;ma=E;na=y}}while(0);if((R|0)==202){R=0;c[13904]=0;c[13898]=1;ma=(ga|0)<1;na=ga}B=c[e>>2]|0;c[13898]=1;if((B|0)>=1){A=1;while(1){h[59424+(A+ -1<<3)>>3]=+h[52064+((A*21|0)+ -21<<3)>>3];if((A|0)<(B|0)){A=A+1|0}else{break}}c[13898]=B+1}c[13898]=1;do{if(ma){c[13898]=1}else{A=1;while(1){z=A+1|0;c[13908]=z;v=c[e>>2]|0;c[13900]=1;if((v|0)>=1){U=1;while(1){la=U*21|0;x=52064+(la+ -22+z<<3)|0;h[x>>3]=+h[x>>3]- +h[52064+(la+ -21<<3)>>3];if((U|0)<(v|0)){U=U+1|0}else{break}}c[13900]=v+1}c[13898]=z;if((A|0)<(na|0)){A=z}else{break}}c[13898]=1;if(ma){break}else{oa=1}while(1){A=oa+1|0;c[13908]=A;y=c[e>>2]|0;c[13900]=1;if((y|0)>=1){E=1;while(1){T=(E*21|0)+ -22|0;h[52064+(T+oa<<3)>>3]=+h[52064+(T+A<<3)>>3];if((E|0)<(y|0)){E=E+1|0}else{break}}c[13900]=y+1}c[13898]=A;if((oa|0)<(na|0)){oa=A}else{break}}}}while(0);B=57704;Ux(B,57376,B,59584,60160,q,59744)|0;if((c[q>>2]|0)==0){R=226;break}if((c[j>>2]|0)>-1){c[60628>>2]=6;yO(60624)|0;gO()|0}c[q>>2]=2;if((c[14950]|0)>(c[g>>2]|0)){R=312;break}c[60652>>2]=6;yO(60648)|0;gO()|0;B=c[e>>2]|0;c[13898]=1;if((B|0)<1){continue}else{pa=1}while(1){E=d+(pa+ -1<<3)|0;h[E>>3]=+h[E>>3]*.5;if((pa|0)<(B|0)){pa=pa+1|0}else{break}}c[13898]=B+1}if((R|0)==150){c[q>>2]=1;if((c[j>>2]|0)<0){i=r;return 0}c[60340>>2]=6;yO(60336)|0;PN(60912,g,4)|0;gO()|0;c[60364>>2]=6;yO(60360)|0;PN(60912,59416,8)|0;gO()|0;c[60388>>2]=6;yO(60384)|0;u=c[e>>2]|0;c[13898]=1;if((u|0)>=1){E=1;do{PN(60912,b+(E+ -1<<3)|0,8)|0;z=c[13898]|0;E=z+1|0;c[13898]=E;}while((z|0)<(u|0))}gO()|0;c[60412>>2]=6;yO(60408)|0;PN(60912,s,8)|0;gO()|0;i=r;return 0}else if((R|0)==226){u=c[14344]|0;c[14948]=u-(c[15040]|0);c[13898]=1;E=(u|0)<1;do{if(E){h[7470]=0.0;c[13898]=1;qa=0.0}else{z=u+1|0;v=1;while(1){h[55424+(v+ -1<<3)>>3]=0.0;T=v+ -1|0;U=55424+(T<<3)|0;I=+h[U>>3];la=1;while(1){if((la|0)>(v|0)){x=la+ -1|0;ra=x;sa=((fa(x,la)|0)/2|0)+v|0}else{ra=la+ -1|0;sa=((fa(T,v)|0)/2|0)+la|0}ta=+h[57704+(sa+ -1<<3)>>3]*+h[57384+(ra<<3)>>3]+I;if((la|0)<(u|0)){I=ta;la=la+1|0}else{break}}c[13904]=sa;h[U>>3]=ta;if((v|0)<(u|0)){v=v+1|0}else{break}}c[13900]=z;h[7470]=0.0;c[13898]=1;if(E){qa=0.0;break}else{ua=1;va=0.0}while(1){v=ua+ -1|0;wa=va+ +h[55424+(v<<3)>>3]*+h[57384+(v<<3)>>3];if((ua|0)<(u|0)){va=wa;ua=ua+1|0}else{break}}h[7470]=wa;c[13898]=u+1;qa=wa}}while(0);h[7470]=+h[6953]-qa;s=c[e>>2]|0;c[13898]=1;if((s|0)>=1){z=u+1|0;v=1;while(1){h[59992+(v+ -1<<3)>>3]=0.0;if(E){xa=1}else{B=v*21|0;la=59992+(v+ -1<<3)|0;T=1;I=+h[la>>3];while(1){ya=I+ +h[55424+(T+ -1<<3)>>3]*+h[52064+(T+ -22+B<<3)>>3];if((T|0)<(u|0)){I=ya;T=T+1|0}else{break}}h[la>>3]=ya;xa=z}if((v|0)<(s|0)){v=v+1|0}else{break}}c[13898]=s+1;c[13900]=xa}v=c[e>>2]|0;c[13898]=1;if((v|0)>=1){z=1;while(1){u=z+ -1|0;E=59424+(u<<3)|0;h[E>>3]=+h[E>>3]- +h[59992+(u<<3)>>3];if((z|0)<(v|0)){z=z+1|0}else{break}}c[13898]=v+1}if((c[j>>2]|0)>=0){c[60676>>2]=6;yO(60672)|0;PN(60912,59760,8)|0;z=c[e>>2]|0;c[13898]=1;if((z|0)>=1){s=1;do{PN(60912,59424+(s+ -1<<3)|0,8)|0;u=c[13898]|0;s=u+1|0;c[13898]=s;}while((u|0)<(z|0))}gO()|0;c[60700>>2]=6;yO(60696)|0;gO()|0}z=c[e>>2]|0;c[13898]=1;if((z|0)>=1){s=c[14344]|0;v=1;while(1){c[13900]=1;if((s|0)>=1){u=v*21|0;E=s+1|0;T=1;while(1){h[55424+(T+ -1<<3)>>3]=0.0;B=T+ -1|0;x=55424+(B<<3)|0;I=+h[x>>3];za=1;while(1){if((za|0)>(T|0)){Aa=((fa(za+ -1|0,za)|0)/2|0)+T|0}else{Aa=((fa(B,T)|0)/2|0)+za|0}Ba=I+ +h[57704+(Aa+ -1<<3)>>3]*+h[52064+(za+ -22+u<<3)>>3]*.5;if((za|0)<(s|0)){I=Ba;za=za+1|0}else{break}}c[13904]=Aa;h[x>>3]=Ba;if((T|0)<(s|0)){T=T+1|0}else{break}}c[13902]=E;c[13900]=s+1}T=c[e>>2]|0;c[13900]=v;if((v|0)<=(T|0)){u=(s|0)<1;la=s+1|0;za=v;while(1){Ca=v+((fa(za+ -1|0,za)|0)/2|0)|0;B=55680+(Ca+ -1<<3)|0;h[B>>3]=0.0;if(u){Da=1}else{U=za*21|0;Ea=1;I=0.0;while(1){Fa=+h[55424+(Ea+ -1<<3)>>3]*+h[52064+(Ea+ -22+U<<3)>>3]+I;if((Ea|0)<(s|0)){I=Fa;Ea=Ea+1|0}else{break}}h[B>>3]=Fa;Da=la}if((za|0)<(T|0)){za=za+1|0}else{break}}c[13900]=T+1;c[13904]=Ca;c[13902]=Da}za=v+1|0;c[13898]=za;if((v|0)<(z|0)){v=za}else{break}}}c[13900]=0;v=c[e>>2]|0;c[13898]=1;if((v|0)>=1){z=1;s=0;while(1){Ga=s+z|0;h[o+(z+ -1<<3)>>3]=+h[55680+(Ga+ -1<<3)>>3];if((z|0)<(v|0)){s=Ga;z=z+1|0}else{break}}c[13900]=Ga;c[13898]=v+1}if((c[j>>2]|0)<0){i=r;return 0}c[60724>>2]=6;yO(60720)|0;PN(60912,59792,4)|0;gO()|0;c[14342]=1;z=1;d:while(1){c[13904]=z;do{if((z|0)>(c[e>>2]|0)){s=c[14342]|0;if((s|0)==1){c[60748>>2]=6;yO(60744)|0;gO()|0;Ux(55680,57376,57704,59584,60160,q,59744)|0;c[60772>>2]=6;yO(60768)|0;gO()|0;c[14342]=3;z=1;continue d}else if((s|0)==2){break d}else if((s|0)!=3){break}c[14342]=2;c[13914]=0;c[13916]=0;s=c[e>>2]|0;c[13898]=1;if((s|0)>=1){za=0;la=1;u=0;E=0;while(1){Ea=(E|0)>1?E:1;U=Ea+1|0;x=Q_(Ea+ -1|0,0,Ea+ -2|0,0)|0;Ha=J_(x|0,J&1|0,1)|0;x=(Ea<<1)+ -1+Ha|0;Ia=u+la|0;Ha=55680+(Ia+ -1<<3)|0;I=+h[Ha>>3];if(I>0.0){Ja=1.0/+V(+I)}else{Ja=0.0}h[Ha>>3]=Ja;Ka=la+ -1|0;if((la|0)<2){La=za;Ma=1;Na=0}else{I=Ja;Oa=1;Pa=za;Qa=0;while(1){Ra=Qa+Oa|0;Sa=55680+(Pa<<3)|0;h[Sa>>3]=+h[Sa>>3]*I*+h[55680+(Ra+ -1<<3)>>3];if((Oa|0)>=(Ka|0)){break}I=+h[Ha>>3];Oa=Oa+1|0;Pa=Pa+1|0;Qa=Ra}La=za+Ea|0;Ma=U;Na=x}Ta=La+1|0;if((la|0)<(s|0)){za=Ta;la=la+1|0;E=E+1|0;u=Ia}else{break}}c[13918]=Na;c[13916]=Ta;c[13914]=Ia;c[13900]=Ma;c[13898]=s+1}c[60796>>2]=6;yO(60792)|0;gO()|0;c[13914]=0;u=c[e>>2]|0;c[13898]=1;if((u|0)<1){z=1;continue d}else{Ua=1;Va=0}while(1){Wa=Va+Ua|0;E=55680+(Wa+ -1<<3)|0;if(+h[E>>3]!=0.0){h[E>>3]=1.0}if((Ua|0)<(u|0)){Ua=Ua+1|0;Va=Wa}else{break}}c[13914]=Wa;c[13898]=u+1;z=1;continue d}}while(0);T=(fa(z+ -1|0,z)|0)/2|0;c[13914]=T;s=c[e>>2]|0;c[13898]=z;e:do{if((z|0)<=(s|0)){E=z;la=T;za=z;while(1){B=E+la|0;c[13908]=B;Qa=za+la|0;c[13914]=Qa;Pa=B+5|0;c[13910]=(Qa|0)<=(Pa|0)?Qa:Pa;if((c[14342]|0)==3){c[60868>>2]=6;yO(60864)|0;Pa=c[13910]|0;Qa=c[13908]|0;c[13900]=Qa;if((Qa|0)<=(Pa|0)){B=Qa;do{PN(60912,57704+(B+ -1<<3)|0,8)|0;Qa=c[13900]|0;B=Qa+1|0;c[13900]=B;}while((Qa|0)<(Pa|0))}gO()|0}else{c[60844>>2]=6;yO(60840)|0;Pa=c[13910]|0;B=c[13908]|0;c[13900]=B;if((B|0)<=(Pa|0)){x=B;do{PN(60912,55680+(x+ -1<<3)|0,8)|0;B=c[13900]|0;x=B+1|0;c[13900]=x;}while((B|0)<(Pa|0))}gO()|0}Pa=c[13898]|0;x=Pa+1|0;c[13898]=x;if((Pa|0)>=(s|0)){break e}E=c[13904]|0;la=c[13914]|0;za=x}}}while(0);c[60892>>2]=6;yO(60888)|0;gO()|0;z=(c[13904]|0)+6|0}c[60820>>2]=6;yO(60816)|0;PN(60912,59808,4)|0;gO()|0;i=r;return 0}else if((R|0)==312){i=r;return 0}}}while(0);ie[p&63](e,b,f)|0;i=r;return 0}function Ux(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0;k=i;c[15248]=c[b>>2];c[g>>2]=1;if((c[15248]|0)<1){i=k;return 0}c[g>>2]=0;Vx(a,60992,d,f,g,j,e)|0;if((c[g>>2]|0)!=0){i=k;return 0}g=c[15248]|0;j=g+1|0;f=(fa(j,g)|0)/2|0;c[15240]=f;c[15246]=g;c[15252]=f;a=g+ -1|0;b=f+(fa(a,1-g|0)|0)|0;l=Q_(a|0,0,g+ -2|0,0)|0;m=J_(l|0,J&1|0,1)|0;l=b+m|0;m=0-g|0;b=f;n=g;while(1){if(+h[d+(b+ -1<<3)>>3]==0.0){c[15232]=n;if((n|0)>(g|0)){o=b}else{p=g-n|0;q=fa(p,n+1|0)|0;r=Q_(p|0,0,a-n|0,0)|0;p=J_(r|0,J&1|0,1)|0;r=n;s=b;while(1){h[d+(s+ -1<<3)>>3]=0.0;if((r|0)<(g|0)){s=s+r|0;r=r+1|0}else{break}}c[15232]=j;o=n+b+q+p|0}t=o;u=n+ -1|0}else{c[15230]=n;if((n|0)<=(g|0)){r=n;s=b;while(1){h[e+(r+ -1<<3)>>3]=+h[d+(s+ -1<<3)>>3];if((r|0)>=(g|0)){break}v=s+r|0;r=r+1|0;s=v}c[15230]=j}c[15242]=g;c[15244]=f;c[15250]=f;s=n+ -1|0;r=e+(s<<3)|0;p=(g|0)==(n|0);q=f;v=g;w=f;while(1){h[7619]=0.0;x=(v|0)==(n|0);if(x){y=1.0/+h[r>>3];h[7619]=y;z=y}else{z=0.0}if(p){A=g;B=w;C=z}else{y=z;D=g;E=w;while(1){F=D+ -1|0;G=E+ -1|0;H=y- +h[e+(F<<3)>>3]*+h[d+(G<<3)>>3];h[7619]=H;if((G|0)>(q|0)){I=E+(1-D)|0}else{I=G}if((F|0)==(n|0)){A=n;B=I;C=H;break}else{E=I;D=F;y=H}}}h[d+(B+ -1<<3)>>3]=C/+h[r>>3];if(x){break}D=q-v|0;c[15250]=D;E=v+ -1|0;c[15242]=E;F=w+ -1|0;c[15244]=F;q=D;v=E;w=F}c[15234]=A;t=B;u=s}w=b+m|0;if((u|0)==0){break}else{m=m+1|0;b=w;n=u}}c[15236]=t;c[15246]=0;c[15252]=l-g;i=k;return 0}function Vx(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0;k=i;h[7633]=.5;l=.5;do{l=l*.5;}while(l+1.0>1.0);m=l*2.0;h[7633]=m;c[f>>2]=1;if((c[b>>2]|0)<1){i=k;return 0}c[f>>2]=2;c[e>>2]=0;h[g>>3]=m;h[j>>3]=+h[7633];c[15256]=1;c[15258]=0;n=c[b>>2]|0;c[15270]=1;a:do{if((n|0)>=1){b=1;o=1;b:while(1){c[15260]=0;c[15272]=1;do{if((o|0)>=1){p=1;q=c[15258]|0;r=0;while(1){s=q+1|0;t=a+(q<<3)|0;m=+h[t>>3];h[7632]=m;u=(p|0)==(o|0);if(u){l=m*+h[7633];h[7634]=l*l}do{if((p|0)<1){v=m;w=r;x=b;y=1}else{l=m;z=b;A=1;B=r;while(1){C=B+1|0;if((A|0)==(p|0)){D=14;break}E=d+(B<<3)|0;F=l- +h[E>>3]*+h[d+(z+ -1<<3)>>3];h[7632]=F;if(u){G=+h[E>>3];H=G*G*+h[j+(A+ -1<<3)>>3];h[7634]=+h[7634]+H*H}I=z+1|0;J=A+1|0;if((A|0)<(p|0)){l=F;z=I;A=J;B=C}else{D=15;break}}if((D|0)==14){D=0;c[15260]=C;v=l;w=C;x=z;y=p;break}else if((D|0)==15){D=0;c[15260]=C;v=F;w=C;x=I;y=J;break}}}while(0);if(u){D=25;break}m=+h[d+(w+ -1<<3)>>3];if(m==0.0){h[d+(q<<3)>>3]=0.0;H=+h[7632];if(!(H>=0.0)){K=-H}else{K=H}H=+h[g>>3]*+h[t>>3];if(!(H>=0.0)){L=-H}else{L=H}if(K>L){break b}}else{h[d+(q<<3)>>3]=v/m}B=p+1|0;c[15272]=B;if((p|0)<(o|0)){p=B;r=w;q=s}else{D=26;break}}if((D|0)==25){D=0;c[15254]=y;c[15262]=x;c[15258]=s;break}else if((D|0)==26){D=0;c[15254]=y;c[15262]=x;c[15258]=s;break}}}while(0);m=+V(+(+h[7634]));h[7634]=m;H=+h[7632];if(!(H>=0.0)){M=-H}else{M=H}do{if(!(M<=m*5.0)){if(H<0.0){D=37;break b}G=+V(+H);h[d+((c[15258]|0)+ -1<<3)>>3]=G;G=+h[7634]/+h[7632];h[j+((c[15254]|0)+ -1<<3)>>3]=G;if(!(G>+h[g>>3])){N=b;O=o;break}h[g>>3]=G;N=b;O=o}else{h[d+((c[15258]|0)+ -1<<3)>>3]=0.0;c[e>>2]=(c[e>>2]|0)+1;N=c[15256]|0;O=c[15270]|0}}while(0);b=N+O|0;c[15256]=b;o=O+1|0;c[15270]=o;if((O|0)>=(n|0)){break a}}if((D|0)==37){i=k;return 0}c[15254]=y;c[15262]=x;c[15258]=s;i=k;return 0}}while(0);c[f>>2]=0;i=k;return 0}function Wx(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;n=(c[b>>2]|0)+1|0;c[15296]=n;o=(c[d>>2]|0)-n|0;c[15318]=o;p=c[d>>2]|0;q=c[b>>2]|0;r=q+2|0;do{if((p|0)>=(r|0)){if((p|0)>((fa(n,r)|0)/2|0|0)){break}s=q+p|0;c[15316]=s;a[61208]=1;t=c[b>>2]|0;u=t+1|0;c[15312]=u;v=c[b>>2]|0;w=u+v|0;c[15310]=w;u=w+(c[b>>2]|0)|0;c[15314]=u;w=(fa(c[d>>2]|0,c[b>>2]|0)|0)+u|0;c[15304]=w;x=w+(c[d>>2]|0)|0;c[15298]=x;y=x+(c[b>>2]|0)|0;c[15300]=y;z=((fa(n,c[b>>2]|0)|0)/2|0)+y|0;c[15306]=z;A=z+(c[d>>2]|0)|0;c[15320]=A;B=(fa(c[b>>2]|0,s)|0)+A|0;c[15322]=B;C=(fa(o,c[d>>2]|0)|0)+B|0;c[15294]=C;D=C+(c[b>>2]|0)|0;c[15308]=D;Xx(b,d,e,f,g,h,j,k,k+(t<<3)|0,k+(t+v<<3)|0,k+(u+ -1<<3)|0,k+(w+ -1<<3)|0,k+(x+ -1<<3)|0,k+(y+ -1<<3)|0,k+(z+ -1<<3)|0,k+(A+ -1<<3)|0,k+(B+ -1<<3)|0,61264,k+(C+ -1<<3)|0,k+(D+ -1<<3)|0,k+(s+ -1+D<<3)|0,l)|0;i=m;return 0}}while(0);yO(61296)|0;gO()|0;i=m;return 0}function Xx(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0.0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0;z=i;i=i+8|0;A=z;B=c[b>>2]|0;C=~B;D=c[u>>2]|0;E=~D;h[7747]=.5;h[7738]=1.0;h[7778]=.1;F=(c[a>>2]|0)+1|0;c[15472]=F;G=fa(c[a>>2]|0,F)|0;H=(G|0)/2|0;c[15464]=H;I=(c[b>>2]|0)-F|0;c[15518]=I;F=c[j>>2]|0;c[15572]=(F|0)<1?1:F;F=c[a>>2]|0;c[15456]=1;if((F|0)>=1){j=1;while(1){J=j+ -1|0;h[k+(J<<3)>>3]=+h[d+(J<<3)>>3];J=c[b>>2]|0;c[15458]=1;if((J|0)>=1){K=fa(j,B)|0;L=1;while(1){h[n+(L+C+K<<3)>>3]=0.0;if((L|0)<(J|0)){L=L+1|0}else{break}}c[15458]=J+1}L=c[u>>2]|0;c[15454]=1;if((L|0)>=1){K=1;while(1){h[s+(K+E+(fa(j,D)|0)<<3)>>3]=0.0;if((K|0)<(L|0)){K=K+1|0}else{break}}c[15454]=L+1}K=j+1|0;c[15456]=K;if((j|0)<(F|0)){j=K}else{break}}}c[15460]=1;if((G|0)>=2){G=1;while(1){h[q+(G+ -1<<3)>>3]=0.0;if((G|0)<(H|0)){G=G+1|0}else{break}}c[15460]=H+1}H=c[b>>2]|0;c[15458]=1;if((H|0)>=1){G=(I|0)<1;j=I+1|0;F=1;while(1){h[r+(F+ -1<<3)>>3]=0.0;if(G){M=1}else{K=1;while(1){h[t+((fa(K,B)|0)+C+F<<3)>>3]=0.0;if((K|0)<(I|0)){K=K+1|0}else{M=j;break}}}if((F|0)<(H|0)){F=F+1|0}else{break}}c[15456]=M;c[15458]=H+1}N=+h[e>>3];O=N*N;h[7783]=O;h[7769]=+h[7738]/O;h[7770]=+V(+(+h[7747]))/O;c[15462]=0;H=y;y=A;M=0;a:while(1){c[15474]=M;F=M-(c[a>>2]|0)|0;c[15498]=F;j=M+1|0;c[15462]=j;I=c[a>>2]|0;do{if((M|0)>(I<<1|0)){G=(F+ -1|0)/(I|0)|0;c[15548]=G;K=c[a>>2]|0;L=M-(fa(K,G)|0)-K|0;c[15486]=L;K=L+G|0;c[15484]=K;if((K|0)>(c[a>>2]|0)){c[15548]=L;G=K-(c[a>>2]|0)|0;c[15486]=G;c[15484]=L;P=L;Q=G}else{P=K;Q=L}O=+h[e>>3];h[7760]=O;L=c[15472]|0;if(+h[o+(P+ -1+L<<3)>>3]<+h[o+(P<<3)>>3]){N=-O;h[7760]=N;R=N}else{R=O}O=+h[e>>3];h[7761]=O;if(+h[o+(Q+ -1+L<<3)>>3]<+h[o+(Q<<3)>>3]){h[7761]=-O}L=j+C|0;h[n+(L+(fa(P,B)|0)<<3)>>3]=R;h[n+(L+(fa(Q,B)|0)<<3)>>3]=+h[7761];S=c[a>>2]|0}else{L=(M|0)>(I|0);if(!((M|0)<1|L)){h[n+((fa(M,B)|0)+C+j<<3)>>3]=+h[e>>3];S=I;break}if(!L){S=I;break}h[n+(j+C+(fa(F,B)|0)<<3)>>3]=-+h[e>>3];S=I}}while(0);c[15456]=1;if((S|0)>=1){I=1;while(1){O=+h[n+((fa(I,B)|0)+C+j<<3)>>3];F=I+ -1|0;h[d+(F<<3)>>3]=O+ +h[k+(F<<3)>>3];if((I|0)<(S|0)){I=I+1|0}else{break}}c[15456]=S+1}if((M|0)>=(c[15572]|0)){T=j;U=159;break}while(1){ie[H&63](a,d,61808)|0;if((c[g>>2]|0)==3){yO(62336)|0;PN(62504,61848,4)|0;PN(62504,61808,8)|0;I=c[a>>2]|0;c[15454]=1;if((I|0)>=1){F=1;do{PN(62504,d+(F+ -1<<3)|0,8)|0;L=c[15454]|0;F=L+1|0;c[15454]=F;}while((L|0)<(I|0))}gO()|0}I=c[15462]|0;do{if((I|0)>(c[b>>2]|0)){F=c[15502]|0;if((F|0)==-1){break a}h[7779]=0.0;c[15460]=0;L=c[a>>2]|0;c[15456]=1;if((L|0)<1){W=0.0}else{O=0.0;K=2;G=1;J=0;while(1){X=G+ -1|0;N=O+ +h[v+(X<<3)>>3]*+h[p+(X<<3)>>3];h[7779]=N;if((G|0)<1){Y=1;Z=N;_=J}else{X=G+ -1|0;$=m+(X<<3)|0;aa=v+(X<<3)|0;ba=N;X=1;ca=J;while(1){da=X+ -1|0;N=+h[v+(da<<3)>>3]*+h[$>>3]+ +h[aa>>3]*+h[l+(da<<3)>>3];h[7752]=N;if((X|0)==(G|0)){ea=N*+h[7747];h[7752]=ea;ga=ea}else{ga=N}ha=ba+ga*+h[q+(ca<<3)>>3];h[7779]=ha;if((X|0)<(G|0)){ba=ha;X=X+1|0;ca=ca+1|0}else{break}}ca=J+G|0;c[15460]=ca;Y=K;Z=ha;_=ca}if((G|0)<(L|0)){O=Z;K=K+1|0;G=G+1|0;J=_}else{break}}c[15454]=Y;c[15456]=L+1;W=Z}J=c[b>>2]|0;c[15458]=1;if((J|0)<1){ia=W}else{O=W;G=1;while(1){K=G+ -1|0;ja=O+ +h[r+(K<<3)>>3]*+h[x+(K<<3)>>3];h[7779]=ja;if((G|0)<(J|0)){G=G+1|0;O=ja}else{break}}c[15458]=J+1;ia=ja}O=+h[7726];ba=+h[7755];N=O-ba-ia;h[7746]=N;h[7765]=+h[7764];h[7764]=+h[7763];if(!(N>=0.0)){ka=-N}else{ka=N}h[7763]=ka;if(+h[7775]>+h[7741]){c[15546]=I}h[7771]=ba;do{if(O<ba){h[7755]=O;h[7788]=0.0;G=c[a>>2]|0;c[15454]=1;if((G|0)<1){break}else{la=1}while(1){L=la+ -1|0;h[l+(L<<3)>>3]=+h[m+(L<<3)>>3];ma=+h[l+(la+ -1<<3)>>3];h[7788]=+h[7788]+ma*ma;if((la|0)<(G|0)){la=la+1|0}else{break}}c[15454]=G+1;h[A>>3]=ma}}while(0);c[15544]=F;if((F|0)<=0){O=+h[7779];if(O>=0.0){U=190;break a}ba=+h[7726];N=+h[7771];ea=(ba-N)/O;h[7776]=ea;O=+h[7778];do{if(!(ea<=O)){na=+h[7747]*+h[7768];h[A>>3]=na;oa=+h[7775];if(!(ea<=.7)){pa=oa+oa;qa=na>=pa?na:pa;h[7768]=qa;ra=qa;break}else{qa=na>=oa?na:oa;h[7768]=qa;ra=qa;break}}else{qa=+h[7747]*+h[7775];h[7768]=qa;ra=qa}}while(0);ea=+h[7741];if(!(ra<=ea*1.5)){sa=ra}else{h[7768]=ea;sa=ea}qa=O*sa;oa=qa>=ea?qa:ea;h[A>>3]=oa;ea=oa*oa;h[7783]=ea;c[15560]=0;h[7784]=0.0;if(!(ba>=N)){ta=0;ua=0.0}else{J=c[15516]|0;c[15560]=J;oa=+h[7738];h[7784]=oa;ta=J;ua=oa}J=c[b>>2]|0;c[15458]=1;if((J|0)<1){va=F}else{L=c[15518]|0;oa=ua;K=1;ca=F;while(1){h[7766]=0.0;c[15456]=1;if((L|0)<1){wa=0.0}else{X=c[15478]|0;aa=K+C|0;qa=+h[7738];na=0.0;$=1;while(1){if(($|0)<(X|0)){xa=-qa}else{xa=qa}h[7752]=xa;pa=+h[t+(aa+(fa($,B)|0)<<3)>>3];ya=na+xa*pa*pa;h[7766]=ya;if(($|0)<(L|0)){na=ya;$=$+1|0}else{break}}c[15456]=L+1;wa=ya}na=+h[w+(K+ -1<<3)>>3];qa=na*na+ +h[7748]*wa;if(!(qa>=0.0)){za=-qa}else{za=qa}h[7752]=za;h[7787]=0.0;$=c[a>>2]|0;c[15456]=1;if(($|0)<1){Aa=qa;Ba=0.0}else{qa=0.0;aa=1;while(1){na=+h[n+((fa(aa,B)|0)+C+K<<3)>>3];Ca=na- +h[l+(aa+ -1<<3)>>3];Da=qa+Ca*Ca;h[7787]=Da;if((aa|0)<($|0)){aa=aa+1|0;qa=Da}else{break}}c[15456]=$+1;Aa=Ca;Ba=Da}if(Ba>ea){qa=Ba/ea;na=za*qa*qa*qa;h[7752]=na;Ea=qa;Fa=na}else{Ea=Aa;Fa=za}if(!(Fa>oa)|(K|0)==(ta|0)){Ga=oa;Ha=ca}else{h[7784]=Fa;c[15502]=K;Ga=Fa;Ha=K}aa=K+1|0;c[15458]=aa;if((K|0)<(J|0)){oa=Ga;K=aa;ca=Ha}else{break}}h[A>>3]=Ea;va=Ha}if((va|0)==0){Ia=0;Ja=sa;Ka=O;U=286;break}}Zx(a,b,s,t,61912,u,w,61984,62008,x)|0;ca=c[15502]|0;K=ca+ -1|0;h[o+(K<<3)>>3]=+h[7726];c[15460]=0;J=c[a>>2]|0;c[15454]=1;L=r+(K<<3)|0;if((J|0)>=1){K=ca+C|0;F=2;aa=1;X=0;while(1){oa=+h[L>>3]*+h[n+((fa(aa,B)|0)+C+ca<<3)>>3];h[7752]=oa;if((aa|0)<1){La=1;Ma=X}else{ea=oa;G=1;da=X;while(1){oa=ea*+h[n+(K+(fa(G,B)|0)<<3)>>3];Na=q+(da<<3)|0;h[Na>>3]=+h[Na>>3]+oa;if((G|0)>=(aa|0)){break}ea=+h[7752];G=G+1|0;da=da+1|0}da=X+aa|0;c[15460]=da;La=F;Ma=da}if((aa|0)<(J|0)){F=F+1|0;aa=aa+1|0;X=Ma}else{break}}c[15456]=La;c[15454]=J+1}h[L>>3]=0.0;X=c[15518]|0;c[15456]=1;aa=(X|0)<1;if(!aa){F=c[15478]|0;K=1;while(1){da=fa(K,B)|0;O=+h[7746]*+h[t+(da+C+ca<<3)>>3];if((K|0)<(F|0)){Oa=-O}else{Oa=O}h[7752]=Oa;G=c[b>>2]|0;c[15458]=1;if((G|0)>=1){O=Oa;$=1;while(1){Na=r+($+ -1<<3)|0;h[Na>>3]=+h[Na>>3]+O*+h[t+($+C+da<<3)>>3];if(($|0)>=(G|0)){break}O=+h[7752];$=$+1|0}c[15458]=G+1}$=K+1|0;c[15456]=$;if((K|0)<(X|0)){K=$}else{break}}}h[7757]=0.0;K=c[a>>2]|0;c[15454]=1;if((K|0)>=1){F=1;while(1){O=+h[7746]*+h[s+((fa(F,D)|0)+E+ca<<3)>>3];L=p+(F+ -1<<3)|0;h[L>>3]=+h[L>>3]+O;L=F+ -1|0;Pa=+h[p+(L<<3)>>3];h[7757]=+h[7757]+Pa*Pa;h[n+((fa(F,B)|0)+C+ca<<3)>>3]=+h[m+(L<<3)>>3];if((F|0)<(K|0)){F=F+1|0}else{break}}c[15454]=K+1;h[A>>3]=Pa}F=c[15544]|0;do{if((F|0)==0){if(!(+h[7768]==+h[7741])){break}O=+h[7776];if(!(O>=0.0)){Qa=-O}else{Qa=O}if(Qa>.01){c[15564]=0;break}L=c[b>>2]|0;c[15458]=1;if((L|0)>=1){J=o+((c[15516]|0)+ -1<<3)|0;$=1;while(1){da=$+ -1|0;h[w+(da<<3)>>3]=+h[o+(da<<3)>>3]- +h[J>>3];if(($|0)<(L|0)){$=$+1|0}else{break}}c[15458]=L+1}h[7750]=0.0;$=c[a>>2]|0;c[15454]=1;if(($|0)<1){Ra=0.0}else{J=1;while(1){h[7744]=0.0;G=c[b>>2]|0;c[15458]=1;if((G|0)<1){Sa=0.0}else{da=fa(J,D)|0;O=0.0;Na=1;while(1){Ta=O+ +h[s+(Na+E+da<<3)>>3]*+h[w+(Na+ -1<<3)>>3];h[7744]=Ta;if((Na|0)<(G|0)){Na=Na+1|0;O=Ta}else{break}}c[15458]=G+1;Sa=Ta}h[7750]=+h[7750]+Sa*Sa;h[x+(J+ -1<<3)>>3]=Sa;Na=J+1|0;c[15454]=Na;if((J|0)<($|0)){J=Na}else{break}}Ra=+h[7750]*100.0}J=c[15564]|0;c[15564]=J+1;if(+h[7757]<Ra){c[15564]=0;break}if((J|0)<=1){break}J=c[a>>2]|0;c[15454]=1;if((J|0)>=1){$=1;while(1){L=$+ -1|0;h[p+(L<<3)>>3]=+h[x+(L<<3)>>3];if(($|0)<(J|0)){$=$+1|0}else{break}}c[15454]=J+1}$=c[15464]|0;c[15460]=1;if(($|0)>=1){L=1;while(1){h[q+(L+ -1<<3)>>3]=0.0;if((L|0)<($|0)){L=L+1|0}else{break}}c[15460]=$+1}c[15456]=1;if(!aa){L=1;while(1){J=x+(L+ -1<<3)|0;h[J>>3]=0.0;Na=c[b>>2]|0;c[15458]=1;if((Na|0)<1){Ua=0.0}else{da=fa(L,B)|0;O=0.0;Va=1;while(1){Wa=O+ +h[w+(Va+ -1<<3)>>3]*+h[t+(Va+C+da<<3)>>3];h[J>>3]=Wa;if((Va|0)<(Na|0)){Va=Va+1|0;O=Wa}else{break}}c[15458]=Na+1;Ua=Wa}if((L|0)<(c[15478]|0)){h[J>>3]=-Ua}Va=L+1|0;c[15456]=Va;if((L|0)<(X|0)){L=Va}else{break}}}L=c[b>>2]|0;c[15458]=1;if((L|0)>=1){$=X+1|0;Va=1;while(1){h[r+(Va+ -1<<3)>>3]=0.0;if(aa){Xa=1}else{da=1;while(1){O=+h[t+((fa(da,B)|0)+C+Va<<3)>>3];G=r+(Va+ -1<<3)|0;h[G>>3]=+h[G>>3]+O*+h[x+(da+ -1<<3)>>3];if((da|0)<(X|0)){da=da+1|0}else{Xa=$;break}}}if((Va|0)<(L|0)){Va=Va+1|0}else{break}}c[15456]=Xa;c[15458]=L+1}c[15564]=0}}while(0);O=+h[7726];ea=+h[7771];if(O<ea){c[15516]=ca}oa=+h[7778];if(O<=ea+oa*+h[7779]|(F|0)>0){U=54;break}c[15502]=0;Ia=0;Ja=+h[7768];Ka=oa;U=286}else{h[o+(I+ -1<<3)>>3]=+h[7726];oa=+h[7726];do{if((I|0)==1){h[7745]=oa;h[7755]=oa;c[15516]=1;Ya=1}else{if(!(oa<+h[7755])){Ya=I;break}h[7755]=oa;c[15516]=I;Ya=I}}while(0);F=c[15474]|0;ca=c[a>>2]|0;do{if((F|0)>(ca<<1|0)){X=c[15484]|0;aa=(fa(X+ -1|0,X)|0)/2|0;K=c[15486]|0;Va=K+aa|0;c[15460]=Va;if(+h[7760]<0.0){aa=X+(c[a>>2]|0)|0;c[15484]=aa;Za=aa}else{Za=X}if(+h[7761]<0.0){X=K+(c[a>>2]|0)|0;c[15486]=X;_a=X}else{_a=K}K=fa(c[15498]|0,B)|0;h[t+(K-B<<3)>>3]=+h[7769];h[t+(Ya+C+K<<3)>>3]=+h[7769];h[t+(Za-B+K<<3)>>3]=-+h[7769];h[t+(_a-B+K<<3)>>3]=-+h[7769];h[q+(Va+ -1<<3)>>3]=(+h[7745]- +h[o+(Za<<3)>>3]- +h[o+(_a<<3)>>3]+ +h[7726])/(+h[7760]*+h[7761])}else{Va=(F|0)>(ca|0);if((F|0)<1|Va){if(!Va){break}Va=c[15498]|0;K=fa(Va,D)|0;h[s+(E-ca+Ya+K<<3)>>3]=+h[7747]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=-+h[7747]/+h[e>>3];ea=+h[7770];K=fa(Va,B)|0;h[t+(K-B<<3)>>3]=-ea-ea;X=Ya+C|0;h[t+(X-ca+K<<3)>>3]=+h[7770];h[t+(X+K<<3)>>3]=+h[7770];K=(fa(Va+1|0,Va)|0)/2|0;c[15460]=K;ea=(+h[7745]- +h[7726])/+h[e>>3];h[7752]=ea;X=p+(Va+ -1<<3)|0;h[q+(K+ -1<<3)>>3]=(+h[X>>3]-ea)/+h[e>>3];h[X>>3]=+h[7747]*(+h[X>>3]+ +h[7752]);break}else{h[p+(F+ -1<<3)>>3]=(oa- +h[7745])/+h[e>>3];X=c[b>>2]|0;if((X|0)>=(ca+Ya|0)){break}K=fa(F,D)|0;h[s+(K-D<<3)>>3]=-+h[7738]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=+h[7738]/+h[e>>3];h[s+(X+E+F+K<<3)>>3]=-(+h[7747]*+h[7783]);break}}}while(0);if((Ya|0)<(c[b>>2]|0)){M=Ya;continue a}oa=+h[e>>3];h[7741]=oa;h[7768]=oa;c[15478]=1;h[7763]=0.0;h[7764]=0.0;c[15564]=0;h[7788]=0.0;F=c[a>>2]|0;c[15454]=1;if((F|0)<1){U=53;break}ca=c[15516]|0;K=1;while(1){h[l+(K+ -1<<3)>>3]=+h[n+((fa(K,B)|0)+C+ca<<3)>>3];$a=+h[l+(K+ -1<<3)>>3];h[7788]=+h[7788]+$a*$a;if((K|0)<(F|0)){K=K+1|0}else{break}}c[15454]=F+1;h[A>>3]=$a;U=53}}while(0);while(1){if((U|0)==53){U=0;c[15546]=c[15462];U=54;continue}else if((U|0)==54){U=0;c[15502]=0;I=(c[15472]|0)+ -1|0;K=c[a>>2]|0;Yx(a,b,l,n,p,q,r,62144,v,x,x+(I<<3)|0,x+(I+K<<3)|0,x+(I+(K<<1)<<3)|0,62280)|0;h[7740]=0.0;K=c[a>>2]|0;c[15454]=1;if((K|0)<1){ab=0.0}else{oa=0.0;I=1;while(1){bb=+h[v+(I+ -1<<3)>>3];cb=oa+bb*bb;h[7740]=cb;if((I|0)<(K|0)){I=I+1|0;oa=cb}else{break}}h[A>>3]=bb;c[15454]=K+1;ab=cb}oa=+h[7768];h[A>>3]=oa;ea=+V(+ab);O=oa<=ea?oa:ea;h[7775]=O;ea=+h[7741];if(!(O<+h[7747]*ea)){db=ab;U=62;break}c[15502]=-1;O=+h[7778];N=O*oa;h[7768]=N;h[7776]=-1.0;if(!(N<=ea*1.5)){eb=N}else{h[7768]=ea;eb=ea}if((c[15462]|0)<=((c[15546]|0)+2|0)){Ia=-1;Ja=eb;Ka=O;U=286;continue}N=ea*+h[7785]*.125*ea;h[7752]=N;oa=+h[7763];ba=+h[7764];na=oa>=ba?oa:ba;h[A>>3]=na;ba=+h[7765];if(!(N<=(na>=ba?na:ba))){fb=-1;gb=O;hb=ea}else{Ia=-1;Ja=eb;Ka=O;U=286;continue}}else if((U|0)==286){U=0;O=Ja*Ja*4.0;h[7787]=O;I=c[b>>2]|0;c[15458]=1;if((I|0)<1){ib=Ia}else{F=1;ea=O;ca=Ia;while(1){h[7744]=0.0;X=c[a>>2]|0;c[15456]=1;if((X|0)<1){jb=0.0}else{O=0.0;Va=1;while(1){ba=+h[n+((fa(Va,B)|0)+C+F<<3)>>3];kb=ba- +h[l+(Va+ -1<<3)>>3];lb=O+kb*kb;h[7744]=lb;if((Va|0)<(X|0)){Va=Va+1|0;O=lb}else{break}}h[A>>3]=kb;c[15456]=X+1;jb=lb}if(jb>ea){c[15502]=F;h[7787]=jb;mb=jb;nb=F}else{mb=ea;nb=ca}Va=F+1|0;c[15458]=Va;if((F|0)<(I|0)){F=Va;ea=mb;ca=nb}else{break}}if((nb|0)>0){U=294;break}else{ib=nb}}if(+h[7776]>0.0){U=54;continue}ea=+h[7775];O=+h[7741];if((Ja>=ea?Ja:ea)>O){U=54;continue}else{fb=ib;gb=Ka;hb=O}}if(!(hb>+h[f>>3])){U=309;break}O=hb*+h[7747];h[7768]=O;ea=hb/+h[f>>3];h[7776]=ea;do{if(!(ea<=16.0)){if(!(ea<=250.0)){ba=gb*hb;h[7741]=ba;ob=ba;break}else{ba=+V(+ea);na=ba*+h[f>>3];h[7741]=na;ob=na;break}}else{na=+h[f>>3];h[7741]=na;ob=na}}while(0);h[7768]=O>=ob?O:ob;ca=c[g>>2]|0;if((ca|0)<=1){U=53;continue}if((ca|0)>2){yO(62384)|0;gO()|0}yO(62408)|0;PN(62504,61928,8)|0;PN(62504,61848,4)|0;gO()|0;yO(62432)|0;PN(62504,62040,8)|0;ca=c[a>>2]|0;c[15454]=1;if((ca|0)>=1){F=1;do{I=F+ -1|0;h[A>>3]=+h[k+(I<<3)>>3]+ +h[l+(I<<3)>>3];PN(62504,y,8)|0;I=c[15454]|0;F=I+1|0;c[15454]=F;}while((I|0)<(ca|0))}gO()|0;U=53}if((U|0)==294){U=0;O=Ka*+V(+mb);ea=+h[7747]*Ja;na=O<=ea?O:ea;h[A>>3]=na;ea=+h[7741];O=na>=ea?na:ea;h[7777]=O;ea=O*O;h[7740]=ea;db=ea;U=62}else if((U|0)==309){U=0;if(!((fb|0)==-1)){break a}}do{if((U|0)==62){U=0;ea=+h[7788];if(db<=ea*.001){h[7781]=ea*.25;ca=c[b>>2]|0;c[15458]=1;if((ca|0)>=1){F=1;while(1){h[7744]=0.0;I=c[a>>2]|0;c[15454]=1;if((I|0)<1){pb=0.0}else{ea=0.0;K=1;while(1){O=+h[n+((fa(K,B)|0)+C+F<<3)>>3];qb=ea+O*+h[l+(K+ -1<<3)>>3];h[7744]=qb;if((K|0)<(I|0)){K=K+1|0;ea=qb}else{break}}c[15454]=I+1;pb=qb}h[7752]=+h[r+(F+ -1<<3)>>3]*pb;ea=pb- +h[7747]*+h[7788];h[7744]=ea;h[x+((c[b>>2]|0)+ -1+F<<3)>>3]=ea;K=c[a>>2]|0;c[15454]=1;if((K|0)>=1){X=1;while(1){Va=fa(X,B)|0;L=n+(Va+C+F<<3)|0;aa=X+ -1|0;$=p+(aa<<3)|0;h[$>>3]=+h[$>>3]+ +h[7752]*+h[L>>3];$=l+(aa<<3)|0;h[L>>3]=+h[L>>3]- +h[7747]*+h[$>>3];L=w+(aa<<3)|0;h[L>>3]=+h[s+(F+E+(fa(X,D)|0)<<3)>>3];ea=+h[7744]*+h[n+(F+C+Va<<3)>>3]+ +h[7781]*+h[$>>3];$=x+(aa<<3)|0;h[$>>3]=ea;aa=X+(c[b>>2]|0)|0;c[15466]=aa;c[15456]=1;if((X|0)<1){rb=X+1|0}else{O=ea;Va=1;while(1){da=s+((fa(Va,D)|0)+E+aa<<3)|0;J=Va+ -1|0;h[da>>3]=+h[da>>3]+ +h[L>>3]*+h[x+(J<<3)>>3]+O*+h[w+(J<<3)>>3];if((Va|0)>=(X|0)){break}O=+h[$>>3];Va=Va+1|0}Va=X+1|0;c[15456]=Va;rb=Va}c[15454]=rb;if((X|0)<(K|0)){X=rb}else{break}}}X=F+1|0;c[15458]=X;if((F|0)<(ca|0)){F=X}else{break}}}F=c[15518]|0;c[15458]=1;if((F|0)>=1){ca=1;while(1){h[7762]=0.0;X=c[b>>2]|0;c[15454]=1;b:do{if((X|0)>=1){O=0.0;K=1;while(1){I=t+(K+C+(fa(ca,B)|0)<<3)|0;h[7762]=+h[I>>3]+O;h[x+(K+ -1<<3)>>3]=+h[x+((c[b>>2]|0)+ -1+K<<3)>>3]*+h[I>>3];I=K+1|0;c[15454]=I;if((K|0)>=(X|0)){break b}O=+h[7762];K=I}}}while(0);X=c[a>>2]|0;c[15456]=1;if((X|0)>=1){K=1;while(1){I=K+ -1|0;O=+h[7781]*+h[7762]*+h[l+(I<<3)>>3];h[7744]=O;Va=c[b>>2]|0;c[15454]=1;if((Va|0)<1){sb=O}else{$=fa(K,B)|0;ea=O;L=1;while(1){tb=ea+ +h[x+(L+ -1<<3)>>3]*+h[n+(L+C+$<<3)>>3];h[7744]=tb;if((L|0)<(Va|0)){L=L+1|0;ea=tb}else{break}}c[15454]=Va+1;sb=tb}h[w+(I<<3)>>3]=sb;if((ca|0)<(c[15478]|0)){h[7744]=-+h[7744]}L=c[b>>2]|0;c[15454]=1;if((L|0)>=1){$=fa(ca,B)|0;aa=fa(K,D)|0;J=1;while(1){da=s+(J+E+aa<<3)|0;h[da>>3]=+h[7744]*+h[t+(J+C+$<<3)>>3]+ +h[da>>3];if((J|0)<(L|0)){J=J+1|0}else{break}}c[15454]=L+1}J=K+1|0;c[15456]=J;if((K|0)<(X|0)){K=J}else{break}}}K=c[a>>2]|0;c[15454]=1;if((K|0)>=1){X=c[15478]|0;J=1;while(1){$=(c[b>>2]|0)+J|0;c[15466]=$;ea=+h[w+(J+ -1<<3)>>3];if((ca|0)<(X|0)){ub=-ea}else{ub=ea}h[7752]=ub;c[15456]=1;if((J|0)<1){vb=J+1|0}else{ea=ub;aa=1;while(1){I=s+((fa(aa,D)|0)+E+$<<3)|0;h[I>>3]=ea*+h[w+(aa+ -1<<3)>>3]+ +h[I>>3];if((aa|0)>=(J|0)){break}ea=+h[7752];aa=aa+1|0}aa=J+1|0;c[15456]=aa;vb=aa}c[15454]=vb;if((J|0)<(K|0)){J=vb}else{break}}}J=ca+1|0;c[15458]=J;if((ca|0)<(F|0)){ca=J}else{break}}}c[15460]=0;ca=c[a>>2]|0;c[15456]=1;if((ca|0)>=1){F=0;J=1;while(1){K=J+ -1|0;X=x+(K<<3)|0;h[X>>3]=0.0;aa=c[b>>2]|0;c[15458]=1;if((aa|0)>=1){$=fa(J,B)|0;L=l+(K<<3)|0;I=$+C|0;ea=0.0;Va=1;while(1){h[X>>3]=ea+ +h[r+(Va+ -1<<3)>>3]*+h[n+(Va+C+$<<3)>>3];da=n+(I+Va<<3)|0;h[da>>3]=+h[da>>3]- +h[7747]*+h[L>>3];if((Va|0)>=(aa|0)){break}ea=+h[X>>3];Va=Va+1|0}c[15458]=aa+1}c[15454]=1;if((J|0)<1){wb=F}else{Va=1;L=F;while(1){I=L+1|0;c[15460]=I;$=(Va|0)<(J|0);da=q+(L<<3)|0;if($){Na=Va+ -1|0;G=l+(Na<<3)|0;xb=p+(K<<3)|0;h[xb>>3]=+h[xb>>3]+ +h[da>>3]*+h[G>>3];yb=G;zb=Na}else{Na=Va+ -1|0;yb=l+(Na<<3)|0;zb=Na}Na=l+(K<<3)|0;G=p+(zb<<3)|0;h[G>>3]=+h[da>>3]*+h[Na>>3]+ +h[G>>3];h[da>>3]=+h[da>>3]+ +h[x+(zb<<3)>>3]*+h[Na>>3]+ +h[yb>>3]*+h[X>>3];Na=(c[b>>2]|0)+E|0;h[s+(Na+Va+(fa(J,D)|0)<<3)>>3]=+h[s+(Na+J+(fa(Va,D)|0)<<3)>>3];Na=Va+1|0;c[15454]=Na;if($){Va=Na;L=I}else{wb=I;break}}}L=J+1|0;c[15456]=L;if((J|0)<(ca|0)){F=wb;J=L}else{break}}}J=c[a>>2]|0;c[15456]=1;if((J|0)>=1){F=1;while(1){ca=F+ -1|0;L=k+(ca<<3)|0;h[L>>3]=+h[l+(ca<<3)>>3]+ +h[L>>3];h[l+(F+ -1<<3)>>3]=0.0;if((F|0)<(J|0)){F=F+1|0}else{break}}c[15456]=J+1}h[7788]=0.0}if((c[15502]|0)>0){F=(c[15472]|0)+ -1|0;rx(a,b,l,n,s,t,61912,u,62008,62216,v,62136,w,w+(c[b>>2]<<3)|0,x,x+(F<<3)|0,x+(F+(c[a>>2]|0)<<3)|0)|0}F=c[b>>2]|0;c[15458]=1;if((F|0)>=1){L=1;while(1){h[7753]=0.0;h[7754]=0.0;h[7744]=0.0;ca=c[a>>2]|0;c[15456]=1;if((ca|0)<1){Ab=0.0;Bb=0.0}else{Va=L+C|0;X=L+E|0;ea=0.0;O=0.0;na=0.0;K=1;while(1){ba=+h[n+((fa(K,B)|0)+C+L<<3)>>3];Cb=na+ba*+h[v+(K+ -1<<3)>>3];h[7753]=Cb;ba=+h[n+(Va+(fa(K,B)|0)<<3)>>3];aa=K+ -1|0;Db=O+ba*+h[l+(aa<<3)>>3];h[7754]=Db;ba=+h[s+(X+(fa(K,D)|0)<<3)>>3];N=ea+ba*+h[v+(aa<<3)>>3];h[7744]=N;if((K|0)<(ca|0)){K=K+1|0;na=Cb;O=Db;ea=N}else{break}}c[15456]=ca+1;Ab=Db;Bb=Cb}K=L+ -1|0;h[x+(K<<3)>>3]=Bb*(Bb*+h[7747]+Ab);h[w+(K<<3)>>3]=+h[7744];K=L+1|0;c[15458]=K;if((L|0)<(F|0)){L=K}else{break}}}h[7748]=0.0;L=c[15518]|0;c[15458]=1;if((L|0)>=1){F=1;while(1){h[7744]=0.0;J=c[b>>2]|0;c[15454]=1;if((J|0)<1){Eb=0.0}else{ea=0.0;K=1;while(1){O=+h[t+(K+C+(fa(F,B)|0)<<3)>>3];Fb=ea+O*+h[x+(K+ -1<<3)>>3];h[7744]=Fb;if((K|0)<(J|0)){K=K+1|0;ea=Fb}else{break}}c[15454]=J+1;Eb=Fb}ea=Eb*Eb;O=+h[7748];if((F|0)<(c[15478]|0)){h[7748]=O+ea;na=-Eb;h[7744]=na;Gb=na}else{h[7748]=O-ea;Gb=Eb}K=c[b>>2]|0;c[15454]=1;if((K|0)>=1){ca=fa(F,B)|0;ea=Gb;X=1;while(1){Va=w+(X+ -1<<3)|0;h[Va>>3]=+h[Va>>3]+ea*+h[t+(X+C+ca<<3)>>3];if((X|0)>=(K|0)){break}ea=+h[7744];X=X+1|0}c[15454]=K+1}X=F+1|0;c[15458]=X;if((F|0)<(L|0)){F=X}else{break}}}h[7756]=0.0;h[7735]=0.0;F=c[a>>2]|0;c[15456]=1;if((F|0)<1){Hb=0.0;Ib=0.0}else{ea=0.0;L=1;while(1){h[7744]=0.0;X=c[b>>2]|0;c[15454]=1;if((X|0)<1){Jb=0.0}else{ca=fa(L,D)|0;O=0.0;J=1;while(1){Kb=O+ +h[x+(J+ -1<<3)>>3]*+h[s+(J+E+ca<<3)>>3];h[7744]=Kb;if((J|0)<(X|0)){J=J+1|0;O=Kb}else{break}}c[15454]=X+1;Jb=Kb}J=L+ -1|0;ca=v+(J<<3)|0;h[7756]=ea+Jb*+h[ca>>3];K=L+(c[b>>2]|0)|0;c[15468]=K;Va=c[a>>2]|0;c[15458]=1;if((Va|0)<1){Lb=Jb}else{O=Jb;aa=1;while(1){na=+h[s+((fa(aa,D)|0)+E+K<<3)>>3];Mb=O+na*+h[v+(aa+ -1<<3)>>3];h[7744]=Mb;if((aa|0)<(Va|0)){aa=aa+1|0;O=Mb}else{break}}c[15458]=Va+1;Lb=Mb}h[w+(K+ -1<<3)>>3]=Lb;O=+h[7756]+ +h[7744]*+h[ca>>3];h[7756]=O;na=+h[7735]+ +h[ca>>3]*+h[l+(J<<3)>>3];h[7735]=na;aa=L+1|0;c[15456]=aa;if((L|0)<(F|0)){ea=O;L=aa}else{Hb=O;Ib=na;break}}}ea=+h[7740];h[7748]=+h[7748]+(Ib*Ib+ea*(Ib+(Ib+ +h[7788])+ea*+h[7747]))-Hb;L=w+((c[15516]|0)+ -1<<3)|0;h[L>>3]=+h[7738]+ +h[L>>3];L=c[15502]|0;if((L|0)<=0){break}ea=+h[w+(L+ -1<<3)>>3];h[A>>3]=ea;na=+h[7738]+ +h[7767]*+h[7748]/(ea*ea);h[7752]=na;if(!(na>=0.0)){Nb=-na}else{Nb=na}if(!(Nb<=.8)){break}L=c[u>>2]|0;qx(a,b,l,n,s,t,61912,u,62064,62008,v,x,w,61984,m,x+(L<<3)|0,x+((L*6|1)+ -1<<3)|0)|0}}while(0);L=c[a>>2]|0;c[15454]=1;if((L|0)>=1){F=1;while(1){aa=F+ -1|0;h[m+(aa<<3)>>3]=+h[l+(aa<<3)>>3]+ +h[v+(aa<<3)>>3];aa=F+ -1|0;h[d+(aa<<3)>>3]=+h[k+(aa<<3)>>3]+ +h[m+(aa<<3)>>3];if((F|0)<(L|0)){F=F+1|0}else{break}}c[15454]=L+1}F=c[15462]|0;aa=F+1|0;c[15462]=aa;if((F|0)>=(c[15572]|0)){T=aa;U=159;break a}}}do{if((U|0)==159){c[15462]=T+ -1;if((c[g>>2]|0)<=0){break}yO(62312)|0;gO()|0}else if((U|0)==190){if((c[g>>2]|0)<=0){break}yO(62360)|0;gO()|0}}while(0);Nb=+h[7755];if(Nb<=+h[7726]){U=c[a>>2]|0;c[15454]=1;if((U|0)<1){Ob=Nb}else{T=1;while(1){m=T+ -1|0;h[d+(m<<3)>>3]=+h[k+(m<<3)>>3]+ +h[l+(m<<3)>>3];if((T|0)<(U|0)){T=T+1|0}else{break}}c[15454]=U+1;Ob=+h[7755]}h[7726]=Ob}if((c[g>>2]|0)<=0){i=z;return 0}yO(62456)|0;PN(62504,61848,4)|0;gO()|0;yO(62480)|0;PN(62504,61808,8)|0;g=c[a>>2]|0;c[15454]=1;if((g|0)>=1){a=1;do{PN(62504,d+(a+ -1<<3)|0,8)|0;U=c[15454]|0;a=U+1|0;c[15454]=a;}while((U|0)<(g|0))}gO()|0;i=z;return 0}function Yx(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0;s=i;t=c[d>>2]|0;u=~t;h[7833]=.5;h[7851]=6.283185307179586;v=+h[l>>3];h[7846]=v*v;c[15688]=0;l=c[b>>2]|0;c[15706]=l;c[15704]=l;w=c[b>>2]|0;c[15628]=1;if((w|0)<1){x=l;y=0}else{z=1;while(1){A=z+ -1|0;h[n+(A<<3)>>3]=+h[e+(A<<3)>>3];if((z|0)<(w|0)){z=z+1|0}else{break}}c[15628]=w+1;x=l;y=0}a:while(1){w=c[b>>2]|0;c[15628]=1;if((w|0)>=1){z=1;while(1){h[p+(z+ -1<<3)>>3]=0.0;if((z|0)<(w|0)){z=z+1|0}else{break}}c[15628]=w+1}z=c[d>>2]|0;c[15632]=1;if((z|0)>=1){e=1;while(1){h[7837]=0.0;A=c[b>>2]|0;c[15630]=1;if((A|0)<1){B=0.0}else{v=0.0;C=1;while(1){D=+h[f+((fa(C,t)|0)+u+e<<3)>>3];E=v+D*+h[n+(C+ -1<<3)>>3];h[7837]=E;if((C|0)<(A|0)){C=C+1|0;v=E}else{break}}c[15630]=A+1;B=E}v=+h[k+(e+ -1<<3)>>3]*B;h[7837]=v;C=c[b>>2]|0;c[15628]=1;if((C|0)>=1){D=v;F=1;while(1){v=D*+h[f+((fa(F,t)|0)+u+e<<3)>>3];G=p+(F+ -1<<3)|0;h[G>>3]=+h[G>>3]+v;if((F|0)>=(C|0)){break}D=+h[7837];F=F+1|0}c[15628]=C+1}F=e+1|0;c[15632]=F;if((e|0)<(z|0)){e=F}else{break}}}c[15642]=0;e=c[b>>2]|0;c[15630]=1;if((e|0)>=1){z=1;w=0;while(1){if((z|0)<1){H=1;I=w}else{F=z+ -1|0;A=p+(F<<3)|0;G=n+(F<<3)|0;F=z+1|0;J=1;K=w;while(1){L=j+(K<<3)|0;if((J|0)<(z|0)){M=J+ -1|0;h[A>>3]=+h[A>>3]+ +h[L>>3]*+h[n+(M<<3)>>3];N=M}else{N=J+ -1|0}M=p+(N<<3)|0;h[M>>3]=+h[L>>3]*+h[G>>3]+ +h[M>>3];if((J|0)<(z|0)){J=J+1|0;K=K+1|0}else{break}}K=z+w|0;c[15642]=K;H=F;I=K}if((z|0)<(e|0)){z=z+1|0;w=I}else{break}}c[15628]=H;c[15630]=e+1}do{if((y|0)==0){h[7835]=0.0;h[7817]=0.0;w=c[b>>2]|0;c[15628]=1;if((w|0)>=1){z=1;while(1){h[m+(z+ -1<<3)>>3]=0.0;K=z+ -1|0;h[q+(K<<3)>>3]=0.0;D=+h[g+(K<<3)>>3]+ +h[p+(K<<3)>>3];h[o+(K<<3)>>3]=D;h[n+(K<<3)>>3]=-D;h[7817]=+h[7817]+D*D;if((z|0)<(w|0)){z=z+1|0}else{break}}c[15628]=w+1}h[r>>3]=0.0;D=+h[7817];if(D==0.0){O=55;break a}h[7822]=0.0;h[7825]=0.0;h[7820]=D;h[7840]=D;P=D;Q=0.0;R=0.0;S=+h[7846];T=0}else{if((y|0)>(x|0)){h[7819]=0.0;h[7826]=0.0;h[7827]=0.0;z=c[b>>2]|0;c[15628]=1;if((z|0)<1){U=0.0;W=0.0;Z=0.0}else{D=0.0;v=0.0;_=0.0;F=1;while(1){K=F+ -1|0;$=_+ +h[n+(K<<3)>>3]*+h[o+(K<<3)>>3];h[7819]=$;K=F+ -1|0;J=p+(K<<3)|0;aa=v+ +h[J>>3]*+h[n+(K<<3)>>3];h[7826]=aa;ba=D+ +h[J>>3]*+h[m+(K<<3)>>3];h[7827]=ba;if((F|0)<(z|0)){F=F+1|0;_=$;v=aa;D=ba}else{break}}c[15628]=z+1;U=ba;W=$;Z=aa}D=+h[7833];v=D*(+h[7830]-Z);h[7818]=v;_=+h[7823];ca=_+v;h[7834]=ca;h[7838]=ca;h[7836]=ca;c[15698]=0;a[62592]=1;da=+h[7851]/50.0;h[7837]=da;c[15628]=1;F=0;ea=ca;ga=ca;w=1;while(1){ha=+(w|0)*da;ia=+X(+ha);ja=+Y(+ha);ka=ia*(_+ia*v)+ja*(W+ia*U);do{if(ka<ea){h[7836]=ka;c[15698]=w;h[7847]=ga;la=w;ma=ka}else{if((w|0)!=(F+1|0)){la=F;ma=ea;break}h[7848]=ka;la=F;ma=ea}}while(0);K=w+1|0;if((K|0)<50){F=la;ea=ma;w=K;ga=ka}else{break}}h[7842]=ha;h[7828]=ia;h[7831]=ja;h[7839]=ka;c[15628]=50;h[7838]=ka;if((la|0)==0){h[7847]=ka;O=46}else if((la|0)==49){h[7848]=ca;na=ca}else{O=46}if((O|0)==46){O=0;na=+h[7848]}h[7842]=0.0;ga=+h[7847];if(ga!=na){ea=ga-ma;h[7847]=ea;ga=na-ma;h[7848]=ga;oa=D*(ea-ga)/(ea+ga);h[7842]=oa;pa=oa}else{pa=0.0}oa=da*(+(la|0)+pa);h[7842]=oa;ga=+X(+oa);h[7828]=ga;ea=+Y(+oa);h[7831]=ea;oa=ca-ga*(_+ga*v)-ea*(W+ga*U);h[7843]=oa;h[7820]=0.0;w=c[b>>2]|0;c[15628]=1;if((w|0)<1){qa=0.0;ra=oa}else{oa=ea;ea=ga;F=1;z=0;while(1){K=m+(z<<3)|0;h[K>>3]=ea*+h[K>>3]+oa*+h[n+(z<<3)>>3];K=F+ -1|0;J=q+(K<<3)|0;ga=+h[7828]*+h[J>>3]+ +h[7831]*+h[p+(K<<3)>>3];h[J>>3]=ga;sa=+h[o+(K<<3)>>3]+ga;ta=+h[7820]+sa*sa;h[7820]=ta;if((F|0)>=(w|0)){break}K=F;oa=+h[7831];ea=+h[7828];F=F+1|0;z=K}c[15628]=w+1;qa=ta;ra=+h[7843]}ea=ra+ +h[7835];h[7835]=ea;if((y|0)<(l|0)&ra/ea>.01){ua=qa;va=x}else{O=55;break a}}else{h[7826]=0.0;z=c[b>>2]|0;c[15630]=1;do{if((z|0)<1){ea=+h[7850];h[7841]=ea;wa=ea;xa=0.0;O=11}else{ea=0.0;F=1;while(1){K=F+ -1|0;ya=ea+ +h[n+(K<<3)>>3]*+h[p+(K<<3)>>3];h[7826]=ya;if((F|0)<(z|0)){F=F+1|0;ea=ya}else{break}}c[15630]=z+1;ea=+h[7850];h[7841]=ea;if(!(ya>0.0)){wa=ea;xa=ya;O=11;break}ea=ya/+h[7817];h[7837]=ea;if((y|0)==1){h[r>>3]=ea;za=ea;Aa=+h[7837]}else{za=+h[r>>3];Aa=ea}h[r>>3]=!(za<=Aa)?Aa:za;ea=+h[7841];oa=+h[7820];v=+h[7826];_=oa/v;ca=ea<=_?ea:_;h[7841]=ca;Ba=oa;Ca=v;Da=ca}}while(0);if((O|0)==11){O=0;Ba=+h[7820];Ca=xa;Da=wa}ca=Da*(Ba-Da*+h[7833]*Ca);h[7832]=ca;h[7835]=+h[7835]+ca;h[7845]=Ba;h[7820]=0.0;z=c[b>>2]|0;c[15628]=1;if((z|0)<1){Ea=Da;Fa=0.0}else{w=1;ca=Da;while(1){F=w+ -1|0;K=m+(F<<3)|0;h[K>>3]=+h[K>>3]+ca*+h[n+(F<<3)>>3];F=w+ -1|0;K=q+(F<<3)|0;v=+h[K>>3]+ +h[7841]*+h[p+(F<<3)>>3];h[K>>3]=v;oa=+h[o+(F<<3)>>3]+v;Ga=+h[7820]+oa*oa;h[7820]=Ga;Ha=+h[7841];if((w|0)<(z|0)){ca=Ha;w=w+1|0}else{break}}c[15628]=z+1;Ea=Ha;Fa=Ga}if(Ea<+h[7850]){if(+h[7832]<=+h[7835]*.01){O=55;break a}if(Fa<=+h[7840]*1.0e-4|(y|0)==(l|0)){O=55;break a}ca=Fa/+h[7845];h[7837]=ca;h[7817]=0.0;h[7822]=0.0;h[7825]=0.0;w=c[b>>2]|0;c[15628]=1;if((w|0)<1){O=55;break a}else{Ia=ca;Ja=1;Ka=0}while(1){F=n+(Ka<<3)|0;h[F>>3]=Ia*+h[F>>3]- +h[o+(Ka<<3)>>3]- +h[q+(Ka<<3)>>3];F=Ja+ -1|0;K=n+(F<<3)|0;ca=+h[K>>3];La=+h[7817]+ca*ca;h[7817]=La;J=m+(F<<3)|0;Ma=+h[7822]+ +h[K>>3]*+h[J>>3];h[7822]=Ma;ca=+h[J>>3];Na=+h[7825]+ca*ca;h[7825]=Na;if((Ja|0)>=(w|0)){break}J=Ja;Ia=+h[7837];Ja=Ja+1|0;Ka=J}c[15628]=w+1;if(Ma<=0.0){O=55;break a}ca=+h[7846];if(Na<ca){P=La;Q=Ma;R=Na;S=ca;T=y;break}}h[r>>3]=0.0;c[15704]=y;ua=+h[7820];va=y}if(ua<=+h[7840]*1.0e-4){O=55;break a}h[7823]=0.0;h[7830]=0.0;z=c[b>>2]|0;c[15628]=1;if((z|0)<1){Oa=0.0;Pa=0.0}else{ca=0.0;oa=0.0;J=1;while(1){K=J+ -1|0;Qa=oa+ +h[m+(K<<3)>>3]*+h[o+(K<<3)>>3];h[7823]=Qa;K=J+ -1|0;Ra=ca+ +h[m+(K<<3)>>3]*+h[q+(K<<3)>>3];h[7830]=Ra;if((J|0)<(z|0)){J=J+1|0;oa=Qa;ca=Ra}else{break}}c[15628]=z+1;Oa=Ra;Pa=Qa}ca=Pa+Oa;h[7829]=ca;oa=+h[7846];v=ua*oa;if(ca/+V(+v)<=-.99){O=55;break a}J=y+1|0;c[15688]=J;_=+V(+(v-ca*ca));h[7837]=_;v=oa/_;h[7847]=v;oa=ca/_;h[7848]=oa;w=c[b>>2]|0;c[15628]=1;if((w|0)<1){x=va;y=J;continue a}else{Sa=oa;Ta=v;Ua=1;Va=0}while(1){h[n+(Va<<3)>>3]=Ta*(+h[o+(Va<<3)>>3]+ +h[q+(Va<<3)>>3])-Sa*+h[m+(Va<<3)>>3];if((Ua|0)>=(w|0)){break}K=Ua;Sa=+h[7848];Ta=+h[7847];Ua=Ua+1|0;Va=K}c[15628]=w+1;x=va;y=J;continue a}}while(0);e=T+1|0;c[15688]=e;v=S-R;h[7837]=v;h[7850]=v/(Q+ +V(+(Q*Q+v*P)));y=e;x=x}if((O|0)==55){i=s;return 0}return 0}



function Kz(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+8|0;l=k;m=e-(c[c[j+12>>2]>>2]|0)|0;e=j+4|0;n=c[(c[c[e>>2]>>2]|0)+12>>2]|0;B_(n+(m<<2)|0,0,fa(b<<2,d)|0)|0;if((b|0)<=0){i=k;return}o=j+8|0;j=0;p=0;while(1){if((c[a+(j<<2)>>2]|0)==2){q=c[c[o>>2]>>2]|0;r=c[g+(j<<2)>>2]|0;s=(c[r>>2]|0)-q|0;t=(c[c[f+(p<<2)>>2]>>2]|0)-q|0;c[l>>2]=c[r+4>>2];gw(5,0,69632,l);c[n+(p+m+(fa(j,d)|0)<<2)>>2]=1;r=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[r+(t<<3)>>3]=+h[r+(s<<3)>>3];u=p+1|0}else{u=p}s=j+1|0;if((s|0)<(b|0)){j=s;p=u}else{break}}i=k;return}function Lz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=ec(69648,69672)|0;o=(n|0)!=0;a[b+440|0]=o&1;if(o){p=0}else{i=d;return 0}a:while(1){while(1){o=ad(n|0)|0;if((o|0)==10){break}else if((o|0)==-1){break a}}p=p+1|0}o=p+ -1|0;p=b+456|0;c[p>>2]=o;c[b+452>>2]=o;mb(n|0);do{}while((ad(n|0)|0)!=10);q=c[b+152>>2]|0;r=XZ(o,4)|0;o=b+444|0;c[o>>2]=r;s=c[p>>2]|0;t=(s|0)>0;b:do{if(t){u=r;v=0;while(1){c[u+(v<<2)>>2]=XZ(q,8)|0;w=v+1|0;if((w|0)>=(s|0)){break}u=c[o>>2]|0;v=w}v=XZ(s,8)|0;u=b+448|0;c[u>>2]=v;if(!t){x=u;break}w=(q|0)>0;y=v;v=0;while(1){c[m>>2]=y+(v<<3);z=Kd(n|0,69680,m|0)|0;if(w){A=0;while(1){c[l>>2]=(c[(c[o>>2]|0)+(v<<2)>>2]|0)+(A<<3);B=Kd(n|0,69680,l|0)|0;C=A+1|0;if((C|0)<(q|0)){A=C}else{D=B;break}}}else{D=z}if((D|0)<0){c[p>>2]=v;E=v}else{E=c[p>>2]|0}A=v+1|0;if((A|0)>=(E|0)){x=u;break b}y=c[u>>2]|0;v=A}}else{v=b+448|0;c[v>>2]=XZ(s,8)|0;x=v}}while(0);cc(69688,j|0)|0;cc(69744,g|0)|0;if((c[p>>2]|0)>0){g=(q|0)>0;j=0;do{s=f;h[k>>3]=+h[(c[x>>2]|0)+(j<<3)>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];cc(69704,f|0)|0;if(g){s=0;while(1){E=s+1|0;F=+h[(c[(c[o>>2]|0)+(j<<2)>>2]|0)+(s<<3)>>3];c[e>>2]=E;D=e+4|0;h[k>>3]=F;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];cc(69728,e|0)|0;if((E|0)<(q|0)){s=E}else{break}}}j=j+1|0;}while((j|0)<(c[p>>2]|0))}qb(69744)|0;Vc(n|0)|0;c[b+460>>2]=0;i=d;return 0}function Mz(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((a[b+440|0]|0)==0){i=d;return 0}WZ(c[b+448>>2]|0);e=b+452|0;f=b+444|0;b=c[f>>2]|0;if((c[e>>2]|0)>0){g=b;h=0;while(1){WZ(c[g+(h<<2)>>2]|0);j=h+1|0;k=c[f>>2]|0;if((j|0)<(c[e>>2]|0)){h=j;g=k}else{l=k;break}}}else{l=b}WZ(l);i=d;return 0}function Nz(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;d=i;if((a[b+440|0]|0)==0){e=-1;i=d;return e|0}f=+h[c[c[b+4>>2]>>2]>>3];g=b+460|0;j=c[g>>2]|0;k=c[b+448>>2]|0;l=+h[k+(j<<3)>>3];if(f==l){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;p=0;while(1){h[o+(p<<3)>>3]=+h[n+(p<<3)>>3];q=p+1|0;if((q|0)<(m|0)){p=q}else{e=1;break}}i=d;return e|0}p=j+1|0;r=+h[k+(p<<3)>>3];if(f==r){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;q=0;while(1){s=q+1|0;h[o+(q<<3)>>3]=+h[n+(s<<3)>>3];if((s|0)<(m|0)){q=s}else{e=1;break}}i=d;return e|0}a:do{if(f>r){q=(c[b+456>>2]|0)+ -1|0;m=j;n=p;while(1){if((n|0)>=(q|0)){t=m;break a}c[g>>2]=n;o=n+1|0;if(f>+h[k+(o<<3)>>3]){s=n;n=o;m=s}else{t=n;break}}}else{t=j}}while(0);j=t+1|0;r=+h[k+(j<<3)>>3]- +h[k+(t<<3)>>3];k=c[b+152>>2]|0;if((k|0)<=0){e=0;i=d;return e|0}g=c[b+444>>2]|0;p=c[g+(t<<2)>>2]|0;t=c[g+(j<<2)>>2]|0;u=l+r;j=b+432|0;v=u-f;w=f-l;b=0;while(1){x=+h[p+(b<<3)>>3];y=+h[t+(b<<3)>>3];do{if(x!=y){if(x>0.0){z=1}else{z=(x<0.0)<<31>>31}if(y>0.0){A=1}else{A=(y<0.0)<<31>>31}if((z|0)==(A|0)){h[(c[j>>2]|0)+(b<<3)>>3]=(u*x+f*y-(f*x+l*y))/r;break}else{h[(c[j>>2]|0)+(b<<3)>>3]=(v*x+w*y)/r;break}}else{h[(c[j>>2]|0)+(b<<3)>>3]=x}}while(0);g=b+1|0;if((g|0)<(k|0)){b=g}else{e=0;break}}i=d;return e|0}function Oz(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=+Pz(a,1.0);if(!(f>1.0e-5)){g=0;i=b;return g|0}if((c[35620>>2]|0)==0){g=1;i=b;return g|0}j=e;h[k>>3]=f;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];gw(9,1,69808,e);e=a+16|0;j=c[e>>2]|0;if((j|0)>0){l=a+48|0;a=j;j=0;while(1){f=+h[(c[l>>2]|0)+(j<<3)>>3];m=j+1|0;if(+U(+f)>1.0e-5){c[d>>2]=m;n=d+4|0;h[k>>3]=f;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];gw(9,0,69920,d);o=c[e>>2]|0}else{o=a}if((m|0)<(o|0)){a=o;j=m}else{break}}}be[c[9034]&255](9);g=1;i=b;return g|0}function Pz(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0,K=0,L=0.0;e=i;f=c[b+60>>2]|0;cA(b);g=f+540|0;ee[c[(c[g>>2]|0)+84>>2]&127](f)|0;ee[c[(c[g>>2]|0)+36>>2]&127](f)|0;ee[c[(c[g>>2]|0)+32>>2]&127](f)|0;j=b+48|0;re[c[(c[g>>2]|0)+68>>2]&63](f,c[j>>2]|0)|0;g=f+8|0;k=c[f+184>>2]|0;if((k|0)>0){l=c[b+52>>2]|0;m=(l|0)==0;n=c[j>>2]|0;o=0.0;j=0;while(1){if(m){p=1.0}else{p=+h[l+(j<<3)>>3]}q=+h[n+(j<<3)>>3]/p;r=o+q*q;s=j+1|0;if((s|0)<(k|0)){o=r;j=s}else{t=r;break}}}else{t=0.0}if(!(d<1.0)){u=t;i=e;return+u}o=t*d;j=c[f+116>>2]|0;if((j|0)>0){k=c[g>>2]|0;n=b+56|0;t=1.0-d;l=f+4|0;p=o;m=0;s=0;while(1){if((a[k+(m*112|0)+88|0]|0)==0){v=p;w=s}else{x=c[n>>2]|0;if((x|0)==0){y=s;z=1.0}else{y=s+1|0;z=+h[x+(s<<3)>>3]}r=(+h[k+(m*112|0)+96>>3]- +h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+(m<<3)>>3])/z;v=p+r*t*r;w=y}x=m+1|0;if((x|0)<(j|0)){p=v;m=x;s=w}else{A=v;B=w;break}}}else{A=o;B=0}w=c[f+136>>2]|0;if((w|0)>0){s=c[f+24>>2]|0;m=b+56|0;o=1.0-d;y=f+416|0;v=A;l=0;k=B;while(1){do{if((a[s+(l*112|0)+88|0]|0)==0){C=v;D=k}else{if((a[s+(l*112|0)+72|0]|0)!=0){C=v;D=k;break}n=c[m>>2]|0;if((n|0)==0){E=k;F=1.0}else{E=k+1|0;F=+h[n+(k<<3)>>3]}p=(+h[s+(l*112|0)+96>>3]- +h[(c[y>>2]|0)+(l<<3)>>3])/F;C=v+p*o*p;D=E}}while(0);n=l+1|0;if((n|0)<(w|0)){v=C;l=n;k=D}else{G=C;H=D;break}}}else{G=A;H=B}B=c[f+120>>2]|0;D=j-B|0;if((D|0)>=(B|0)){u=G;i=e;return+u}j=c[g>>2]|0;g=b+56|0;A=1.0-d;b=f+416|0;d=G;f=D;D=H;while(1){do{if((a[j+(f*112|0)+88|0]|0)==0){I=d;J=D}else{if((a[j+(f*112|0)+72|0]|0)!=0){I=d;J=D;break}H=c[g>>2]|0;if((H|0)==0){K=D;L=1.0}else{K=D+1|0;L=+h[H+(D<<3)>>3]}G=(+h[j+(f*112|0)+96>>3]- +h[(c[b>>2]|0)+(f<<3)>>3])/L;I=d+G*A*G;J=K}}while(0);H=f+1|0;if((H|0)<(B|0)){d=I;f=H;D=J}else{u=I;break}}i=e;return+u}function Qz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+16|0;e=d;f=i;i=i+24|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+16|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;u=+Pz(b,1.0);if((c[35620>>2]|0)==0){i=d;return}v=b+16|0;w=c[v>>2]|0;if((w|0)>0){x=c[b+48>>2]|0;y=0.0;z=0;while(1){A=+h[x+(z<<3)>>3];B=y+A*A;C=z+1|0;if((C|0)<(w|0)){z=C;y=B}else{D=B;break}}}else{D=0.0}gw(9,1,69944,t);t=b+52|0;if((c[t>>2]|0)==0){z=r;h[k>>3]=D;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];gw(9,0,70008,r)}else{r=s;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=s+8|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];gw(9,0,69968,s)}gw(9,1,70032,q);q=b+4|0;s=c[q>>2]|0;if((s|0)>0){r=b+40|0;z=b+24|0;w=b+44|0;x=0;while(1){C=c[r>>2]|0;E=x+1|0;u=+h[(c[z>>2]|0)+(x<<3)>>3];F=c[(c[w>>2]|0)+(x<<2)>>2]|0;if((C|0)==0){c[o>>2]=E;G=o+4|0;h[k>>3]=u;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];c[o+12>>2]=F;gw(9,0,70104,o)}else{D=+h[C+(x<<3)>>3];c[p>>2]=E;C=p+4|0;h[k>>3]=u;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[p+12>>2]=F;F=p+16|0;h[k>>3]=D;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];gw(9,0,70056,p)}F=c[q>>2]|0;if((E|0)<(F|0)){x=E}else{H=F;I=E;break}}}else{H=s;I=0}s=b+8|0;if((I|0)<((c[s>>2]|0)+H|0)){H=b+40|0;x=b+24|0;p=b+44|0;o=I;while(1){w=c[H>>2]|0;z=o+1|0;D=+h[(c[x>>2]|0)+(o<<3)>>3];r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if((w|0)==0){c[m>>2]=z;E=m+4|0;h[k>>3]=D;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];c[m+12>>2]=r;gw(9,0,70192,m)}else{u=+h[w+(o<<3)>>3];c[n>>2]=z;w=n+4|0;h[k>>3]=D;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[n+12>>2]=r;r=n+16|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];gw(9,0,70128,n)}if((z|0)<((c[s>>2]|0)+(c[q>>2]|0)|0)){o=z}else{J=z;break}}}else{J=I}I=b;if((J|0)<(c[I>>2]|0)){o=b+40|0;q=b+24|0;s=b+44|0;n=J;while(1){J=c[o>>2]|0;m=n+1|0;u=+h[(c[q>>2]|0)+(n<<3)>>3];p=c[(c[s>>2]|0)+(n<<2)>>2]|0;if((J|0)==0){c[j>>2]=m;x=j+4|0;h[k>>3]=u;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];c[j+12>>2]=p;gw(9,0,70280,j)}else{D=+h[J+(n<<3)>>3];c[l>>2]=m;J=l+4|0;h[k>>3]=u;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];c[l+12>>2]=p;p=l+16|0;h[k>>3]=D;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gw(9,0,70224,l)}if((m|0)<(c[I>>2]|0)){n=m}else{break}}}be[c[9034]&255](9);gw(9,1,70312,g);if((c[v>>2]|0)>0){g=b+48|0;b=a+540|0;a=0;while(1){n=(c[t>>2]|0)==0;I=a+1|0;D=+h[(c[g>>2]|0)+(a<<3)>>3];l=ee[c[(c[b>>2]|0)+64>>2]&127](a)|0;if(n){c[e>>2]=I;n=e+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[e+12>>2]=l;gw(9,0,70104,e)}else{u=+h[(c[t>>2]|0)+(a<<3)>>3];c[f>>2]=I;n=f+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[f+12>>2]=l;l=f+16|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];gw(9,0,70056,f)}if((I|0)<(c[v>>2]|0)){a=I}else{break}}}be[c[9034]&255](9);be[c[9034]&255](9);i=d;return}function Rz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0;d=i;i=i+24|0;e=d;f=i;i=i+8|0;g=i;i=i+24|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+8|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+40|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b+8|0;if((c[35620>>2]|0)!=0){Ly(b,9)}if((c[35680>>2]|0)==0){i=d;return}gw(24,1,70336,t);t=b+112|0;v=c[t>>2]|0;do{if((v|0)>0){gw(24,1,70376,s);if((c[t>>2]|0)>0){w=u;x=b+4|0;y=b+400|0;z=0;while(1){A=z+1|0;B=c[w>>2]|0;C=c[B+(z*112|0)+4>>2]|0;D=+h[B+(z*112|0)+96>>3];E=+h[B+(z*112|0)+80>>3];F=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];G=+h[(c[y>>2]|0)+(z<<3)>>3];c[r>>2]=A;c[r+4>>2]=C;C=r+8|0;h[k>>3]=D;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+16|0;h[k>>3]=E;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+24|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+32|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];gw(24,0,70400,r);if((A|0)<(c[t>>2]|0)){z=A}else{break}}}be[c[9034]&255](24);z=c[t>>2]|0;if((z|0)<=0){H=z;break}gw(24,1,70456,q);z=c[t>>2]|0;if((z|0)<(z<<1|0)){y=u;x=b+4|0;w=b+400|0;A=z;while(1){z=A+1|0;C=c[(c[y>>2]|0)+(A*112|0)+4>>2]|0;G=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];F=+h[(c[w>>2]|0)+(A<<3)>>3];c[p>>2]=z;c[p+4>>2]=C;C=p+8|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=p+16|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];gw(24,0,70480,p);if((z|0)<(c[t>>2]<<1|0)){A=z}else{break}}}be[c[9034]&255](24);H=c[t>>2]|0}else{H=v}}while(0);v=b+116|0;if((H<<1|0)<(c[v>>2]|0)){gw(24,1,70512,o);o=c[t>>2]<<1;if((o|0)<(c[v>>2]|0)){t=u;u=b+4|0;H=b+400|0;p=o;while(1){o=p+1|0;q=c[t>>2]|0;r=c[q+(p*112|0)+4>>2]|0;F=+h[q+(p*112|0)+96>>3];G=+h[q+(p*112|0)+80>>3];E=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+(p<<3)>>3];D=+h[(c[H>>2]|0)+(p<<3)>>3];c[n>>2]=o;c[n+4>>2]=r;r=n+8|0;h[k>>3]=F;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+16|0;h[k>>3]=G;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+24|0;h[k>>3]=E;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+32|0;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];gw(24,0,70400,n);if((o|0)<(c[v>>2]|0)){p=o}else{break}}}be[c[9034]&255](24)}p=b+124|0;if((c[p>>2]|0)>0){gw(24,1,70536,m);if((c[p>>2]|0)>0){m=b+12|0;v=b+4|0;n=b+404|0;H=0;while(1){u=H+1|0;t=c[m>>2]|0;o=c[t+(H*60|0)+4>>2]|0;r=c[t+(H*60|0)+52>>2]|0;t=c[(c[(c[c[v>>2]>>2]|0)+12>>2]|0)+(H<<2)>>2]|0;q=c[(c[n>>2]|0)+(H<<2)>>2]|0;c[l>>2]=u;c[l+4>>2]=o;c[l+8>>2]=r;c[l+12>>2]=t;c[l+16>>2]=q;gw(24,0,70560,l);if((u|0)<(c[p>>2]|0)){H=u}else{break}}}be[c[9034]&255](24)}H=b+128|0;if((c[H>>2]|0)>0){gw(24,1,70608,j);if((c[H>>2]|0)>0){j=b+16|0;p=b+4|0;l=b+408|0;n=0;while(1){v=n+1|0;m=c[j>>2]|0;u=c[m+(n*48|0)+4>>2]|0;q=(a[m+(n*48|0)+42|0]|0)!=0?70680:70688;m=(a[(c[(c[c[p>>2]>>2]|0)+16>>2]|0)+n|0]|0)!=0?70680:70688;t=(a[(c[l>>2]|0)+n|0]|0)!=0?70680:70688;c[g>>2]=v;c[g+4>>2]=u;c[g+8>>2]=q;c[g+12>>2]=m;c[g+16>>2]=t;gw(24,0,70632,g);if((v|0)<(c[H>>2]|0)){n=v}else{break}}}be[c[9034]&255](24)}n=b+132|0;if((c[n>>2]|0)>0){gw(24,1,70696,f);if((c[n>>2]|0)>0){f=b+20|0;H=b+4|0;g=b+412|0;b=0;while(1){l=b+1|0;p=c[f>>2]|0;j=c[p+(b*52|0)+4>>2]|0;v=c[p+(b*52|0)+44>>2]|0;p=c[(c[(c[c[H>>2]>>2]|0)+20>>2]|0)+(b<<2)>>2]|0;t=c[(c[g>>2]|0)+(b<<2)>>2]|0;c[e>>2]=l;c[e+4>>2]=j;c[e+8>>2]=v;c[e+12>>2]=p;c[e+16>>2]=t;gw(24,0,70720,e);if((l|0)<(c[n>>2]|0)){b=l}else{break}}}be[c[9034]&255](24)}be[c[9034]&255](24);i=d;return}function Sz(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=b+540|0;B=(c[(c[A>>2]|0)+72>>2]|0)!=0?3:2;gw(9,0,70768,z);if((f|0)==0){Iy(b);Jy(b);C=6}else{if((a[f]|0)!=0){Tz(b,f,g)}Iy(b);Jy(b);if((a[f]|0)==0){C=6}}if((C|0)==6){ee[c[(c[A>>2]|0)+84>>2]&127](b)|0;ee[c[(c[A>>2]|0)+60>>2]&127](b)|0}do{if((d|0)==0){D=B}else{if((a[d]|0)==0){D=B;break}C=(t_(d,72256)|0)==0|0;f=(t_(d,72264)|0)==0;z=(t_(d,72272)|0)==0;E=z?3:f?2:C;if((E|0)!=0){D=E;break}c[y>>2]=d;iw(1,0,70816,y);iw(1,0,70848,x);c[w>>2]=72256;c[w+4>>2]=72064;iw(1,0,70872,w);c[v>>2]=72264;c[v+4>>2]=72144;iw(1,0,70872,v);c[u>>2]=72272;c[u+4>>2]=72192;iw(1,0,70872,u);kw(c[b+536>>2]|0,70904,t)}}while(0);do{if((e|0)==0){F=3}else{if((a[e]|0)==0){F=3;break}else{G=1;H=0}do{t=(t_(e,c[70928+(G<<2)>>2]|0)|0)==0;H=t?G:H;G=G+1|0;}while((G|0)<7);if((H|0)!=0){F=H;break}c[s>>2]=e;iw(1,0,70960,s);iw(1,0,70848,r);t=1;do{u=c[70992+(t<<2)>>2]|0;c[q>>2]=c[70928+(t<<2)>>2];c[q+4>>2]=u;iw(1,0,70872,q);t=t+1|0;}while((t|0)<7);kw(c[b+536>>2]|0,70904,p)}}while(0);p=c[70888+(D<<2)>>2]|0;c[o>>2]=c[70800+(D<<2)>>2];c[o+4>>2]=p;gw(9,0,71024,o);o=(D|0)==2;if(o){p=c[70992+(F<<2)>>2]|0;c[n>>2]=c[70928+(F<<2)>>2];c[n+4>>2]=p;gw(9,0,71064,n)}n=b+312|0;a[n]=1;p=b+200|0;if((c[p>>2]|0)>0){q=b+468|0;r=0;do{a[(c[q>>2]|0)+(r*80|0)+72|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+196|0;if((c[p>>2]|0)>0){r=b+476|0;q=0;do{a[(c[r>>2]|0)+(q<<6)+56|0]=1;q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+192|0;if((c[p>>2]|0)>0){q=b+484|0;r=0;do{a[(c[q>>2]|0)+(r*40|0)+36|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}do{if((D|0)==1){I=0}else{if(o){I=Uz(b,F,j)|0;break}if((D|0)==3){Vz(b,j);I=0;break}else{kw(c[b+536>>2]|0,71104,m)}}}while(0);if((qz(b,1)|0)!=0){J=-2;Rz(b);K=14;L=K;M=71128;N=M;gw(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];ry(b,R,V);W=170;Fy(b);X=176;Ky(b);Y=171;Ay(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=ee[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=re[ha&63](b,1)|0;ja=179;Gy(b);i=k;return J|0}if((hz(b,1)|0)!=0){J=-3;Rz(b);K=14;L=K;M=71128;N=M;gw(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];ry(b,R,V);W=170;Fy(b);X=176;Ky(b);Y=171;Ay(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=ee[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=re[ha&63](b,1)|0;ja=179;Gy(b);i=k;return J|0}m=(Zy(b,1)|0)==0;J=m?I:-4;Rz(b);K=14;L=K;M=71128;N=M;gw(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];ry(b,R,V);W=170;Fy(b);X=176;Ky(b);Y=171;Ay(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=ee[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=re[ha&63](b,1)|0;ja=179;Gy(b);i=k;return J|0}function Tz(b,d,e){b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+48|0;B=i;i=i+8|0;c[z>>2]=d;C=z+4|0;h[k>>3]=e;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];gw(9,0,72288,z);z=Mw(d,A)|0;if((z|0)!=0){C=c[b+536>>2]|0;c[y>>2]=d;c[y+4>>2]=z;kw(C,72328,y)}gw(9,0,72368,x);x=b+116|0;if((c[x>>2]|0)>0){y=b+8|0;C=0;do{z=Nw(A,c[(c[y>>2]|0)+(C*112|0)+4>>2]|0)|0;d=c[y>>2]|0;do{if((z|0)==0){D=Yz(c[d+(C*112|0)+4>>2]|0)|0;E=Nw(A,D)|0;WZ(D);D=c[y>>2]|0;if((E|0)!=0){F=D;G=E;H=7;break}E=c[D+(C*112|0)+4>>2]|0;if((u_(E,72408,6)|0)==0){if((c[35620>>2]|0)==0){break}}else{D=u_(E,72416,6)|0;if((c[35620>>2]|D|0)==0){break}}c[v>>2]=E;iw(9,0,72424,v)}else{F=d;G=z;H=7}}while(0);if((H|0)==7){H=0;Tw(F+(C*112|0)+96|0,A,G,e)|0;z=c[y>>2]|0;I=+h[z+(C*112|0)+96>>3];c[w>>2]=c[z+(C*112|0)+4>>2];z=w+4|0;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];gw(9,0,72392,w)}C=C+1|0;}while((C|0)<(c[x>>2]|0))}gw(9,0,72480,u);u=b+136|0;if((c[u>>2]|0)>0){C=b+24|0;w=0;do{y=Nw(A,c[(c[C>>2]|0)+(w*112|0)+4>>2]|0)|0;G=c[C>>2]|0;do{if((y|0)==0){F=Yz(c[G+(w*112|0)+4>>2]|0)|0;v=Nw(A,F)|0;WZ(F);F=c[C>>2]|0;if((v|0)!=0){J=F;K=v;H=17;break}c[s>>2]=c[F+(w*112|0)+4>>2];iw(9,0,72504,s)}else{J=G;K=y;H=17}}while(0);if((H|0)==17){H=0;Tw(J+(w*112|0)+96|0,A,K,e)|0;y=c[C>>2]|0;I=+h[y+(w*112|0)+96>>3];c[t>>2]=c[y+(w*112|0)+4>>2];y=t+4|0;h[k>>3]=I;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];gw(9,0,72392,t)}w=w+1|0;}while((w|0)<(c[u>>2]|0))}gw(9,0,72560,r);r=b+120|0;u=c[r>>2]|0;w=(c[x>>2]|0)-u|0;if((w|0)<(u|0)){u=b+24|0;x=w;do{w=Nw(A,c[(c[u>>2]|0)+(x*112|0)+4>>2]|0)|0;t=c[u>>2]|0;do{if((w|0)==0){C=Yz(c[t+(x*112|0)+4>>2]|0)|0;K=Nw(A,C)|0;WZ(C);C=c[u>>2]|0;if((K|0)!=0){L=C;M=K;H=24;break}c[p>>2]=c[C+(x*112|0)+4>>2];iw(9,0,72504,p)}else{L=t;M=w;H=24}}while(0);if((H|0)==24){H=0;Tw(L+(x*112|0)+96|0,A,M,e)|0;w=c[u>>2]|0;I=+h[w+(x*112|0)+96>>3];c[q>>2]=c[w+(x*112|0)+4>>2];w=q+4|0;h[k>>3]=I;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];gw(9,0,72392,q)}x=x+1|0;}while((x|0)<(c[r>>2]|0))}gw(9,0,72584,o);o=b+140|0;if((c[o>>2]|0)>0){r=b+28|0;x=0;do{q=Nw(A,c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;do{if((q|0)==0){u=Yz(c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;M=Nw(A,u)|0;WZ(u);if((M|0)!=0){N=M;H=31;break}c[m>>2]=c[(c[r>>2]|0)+(x*60|0)+4>>2];iw(9,0,72632,m)}else{N=q;H=31}}while(0);if((H|0)==31){H=0;Tw(B,A,N,e)|0;q=~~+h[B>>3];M=c[r>>2]|0;c[M+(x*60|0)+52>>2]=q;c[n>>2]=c[M+(x*60|0)+4>>2];c[n+4>>2]=q;gw(9,0,72616,n)}x=x+1|0;}while((x|0)<(c[o>>2]|0))}gw(9,0,72688,l);l=b+144|0;if((c[l>>2]|0)<=0){Kw(A);i=f;return}o=b+32|0;b=0;do{x=Nw(A,c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;do{if((x|0)==0){n=Yz(c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;r=Nw(A,n)|0;WZ(n);if((r|0)!=0){O=r;H=38;break}c[g>>2]=c[(c[o>>2]|0)+(b*48|0)+4>>2];iw(9,0,72736,g)}else{O=x;H=38}}while(0);if((H|0)==38){H=0;Tw(B,A,O,e)|0;a[(c[o>>2]|0)+(b*48|0)+42|0]=~~+h[B>>3];x=c[o>>2]|0;r=(a[x+(b*48|0)+42|0]|0)!=0?70680:70688;c[j>>2]=c[x+(b*48|0)+4>>2];c[j+4>>2]=r;gw(9,0,72720,j)}b=b+1|0;}while((b|0)<(c[l>>2]|0));Kw(A);i=f;return}function Uz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;qy(a,+h[a+240>>3]);Fy(a);Ky(a);Ay(a);My(a);Fz(a);By(a);Fy(a);e=Wz(a,b,c)|0;Ky(a);Ay(a);Gy(a);Ky(a);i=d;return e|0}function Vz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+4096|0;qy(b,+h[b+240>>3]);Fy(b);Ky(b);Hz(b,0,1)|0;v=b+540|0;w=c[v>>2]|0;if((c[w+76>>2]|0)!=0&(d|0)>1){x=u;u=b+8|0;y=b+116|0;z=XZ(c[y>>2]|0,8)|0;A=b+124|0;B=XZ(c[A>>2]|0,4)|0;C=b+128|0;D=XZ(c[C>>2]|0,1)|0;E=b+132|0;F=XZ(c[E>>2]|0,4)|0;G=b+536|0;jw(c[G>>2]|0,(z|0)!=0|0,71160,t);jw(c[G>>2]|0,(B|0)!=0|0,71160,s);jw(c[G>>2]|0,(D|0)!=0|0,71160,r);jw(c[G>>2]|0,(F|0)!=0|0,71160,q);q=c[y>>2]|0;if((q|0)>0){G=c[u>>2]|0;r=0;do{h[z+(r<<3)>>3]=+h[G+(r*112|0)+96>>3];r=r+1|0;}while((r|0)<(q|0))}q=c[A>>2]|0;if((q|0)>0){r=c[b+12>>2]|0;G=0;do{c[B+(G<<2)>>2]=c[r+(G*60|0)+52>>2];G=G+1|0;}while((G|0)<(q|0))}q=c[C>>2]|0;if((q|0)>0){G=c[b+16>>2]|0;r=0;do{a[D+r|0]=a[G+(r*48|0)+42|0]|0;r=r+1|0;}while((r|0)<(q|0))}q=c[E>>2]|0;if((q|0)>0){r=c[b+20>>2]|0;G=0;do{c[F+(G<<2)>>2]=c[r+(G*52|0)+44>>2];G=G+1|0;}while((G|0)<(q|0))}if((c[35620>>2]|0)==0){H=0}else{c[p>>2]=c[b+88>>2];dc(x|0,71176,p|0)|0;p=ec(x|0,71192)|0;c[o>>2]=71208;sd(p|0,71200,o|0)|0;if((c[y>>2]|0)>0){o=u;x=0;do{c[n>>2]=c[(c[o>>2]|0)+(x*112|0)+4>>2];sd(p|0,71200,n|0)|0;x=x+1|0;}while((x|0)<(c[y>>2]|0))}Od(10,p|0)|0;H=p}gw(9,1,71216,m);a:do{if((d|0)>0){I=+(d+ -1|0);m=b+304|0;p=b+4|0;x=0;do{J=+(x|0)/I;h[m>>3]=J>1.0?1.0:J;ee[c[(c[v>>2]|0)+80>>2]&127](b)|0;n=l;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];gw(9,0,71240,l);if((c[35620>>2]|0)!=0){n=j;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];sd(H|0,71264,j|0)|0;if((c[y>>2]|0)>0){n=0;do{o=g;h[k>>3]=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+(n<<3)>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];sd(H|0,71264,g|0)|0;n=n+1|0;}while((n|0)<(c[y>>2]|0))}Od(10,H|0)|0}if((qz(b,0)|0)!=0){break a}if((hz(b,0)|0)!=0){break a}if((Zy(b,0)|0)!=0){break a}Ny(b);x=x+1|0;}while((x|0)<(d|0))}}while(0);be[c[9034]&255](9);if((c[35620>>2]|0)!=0){Vc(H|0)|0}H=c[y>>2]|0;if((H|0)>0){y=c[u>>2]|0;u=0;do{h[y+(u*112|0)+96>>3]=+h[z+(u<<3)>>3];u=u+1|0;}while((u|0)<(H|0))}if((c[A>>2]|0)>0){H=c[b+12>>2]|0;u=0;do{c[H+(u*60|0)+52>>2]=c[B+(u<<2)>>2];u=u+1|0;}while((u|0)<(c[A>>2]|0))}if((c[C>>2]|0)>0){A=b+16|0;u=0;do{a[(c[A>>2]|0)+(u*48|0)+42|0]=a[D+u|0]|0;u=u+1|0;}while((u|0)<(c[C>>2]|0))}C=c[E>>2]|0;if((C|0)>0){E=b+20|0;u=0;do{c[(c[E>>2]|0)+(u*52|0)+44>>2]=c[F+(u<<2)>>2];u=u+1|0;}while((u|0)<(C|0))}WZ(z);WZ(B);WZ(D);WZ(F)}else{h[b+304>>3]=1.0;ee[c[w+80>>2]&127](b)|0}Cy(b);if((Hz(b,1,1)|0)!=1){i=e;return}ee[c[(c[v>>2]|0)+80>>2]&127](b)|0;Cy(b);if((Hz(b,1,1)|0)!=1){i=e;return}iw(1,0,71272,f);i=e;return}function Wz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=Zz(b)|0;w=v;x=c[w>>2]|0;if((x|0)==0){gw(9,0,71376,u);if((c[b+184>>2]|0)==0){re[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0}WZ(v);y=0;i=f;return y|0}u=b+184|0;z=c[u>>2]|0;if((z|0)==0){gw(9,0,71408,t);re[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0;WZ(v);y=0;i=f;return y|0}do{if((c[v+16>>2]|0)<(x|0)){gw(9,1,71480,s);t=VZ(c[w>>2]<<3)|0;A=v+40|0;B=c[A>>2]|0;c[A>>2]=0;C=+Pz(v,1.0);c[A>>2]=B;D=c[w>>2]|0;if((D|0)>0){E=v+24|0;F=c[E>>2]|0;G=0;while(1){H=F+(G<<3)|0;h[H>>3]=+h[H>>3]+1.0e-6;c[A>>2]=0;h[t+(G<<3)>>3]=+U(+(+Pz(v,1.0)-C))/1.0e-6;c[A>>2]=B;H=c[E>>2]|0;I=H+(G<<3)|0;h[I>>3]=+h[I>>3]+-1.0e-6;I=G+1|0;J=c[w>>2]|0;if((I|0)<(J|0)){G=I;F=H}else{K=J;break}}}else{K=D}F=c[u>>2]|0;if((F|0)>0){G=(K|0)>1;E=0;do{if(G){B=1;A=0;while(1){J=+h[t+(B<<3)>>3]>+h[t+(A<<3)>>3]?B:A;H=B+1|0;if((H|0)<(K|0)){A=J;B=H}else{L=J;break}}}else{L=0}h[t+(L<<3)>>3]=-1.0;E=E+1|0;}while((E|0)<(F|0))}gw(9,1,71504,r);F=b+112|0;E=c[F>>2]|0;if((E|0)>0){G=b+8|0;D=v+44|0;B=v+24|0;A=E;E=0;J=0;while(1){H=(c[G>>2]|0)+(E*112|0)+72|0;if((a[H]|0)==0){if(!(+h[t+(J<<3)>>3]>=0.0)){M=A}else{a[H]=1;C=+h[(c[B>>2]|0)+(J<<3)>>3];c[q>>2]=c[(c[D>>2]|0)+(J<<2)>>2];H=q+4|0;h[k>>3]=C;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];gw(9,0,71528,q);M=c[F>>2]|0}N=M;O=J+1|0}else{N=A;O=J}H=E+1|0;if((H|0)<(N|0)){A=N;E=H;J=O}else{P=O;break}}}else{P=0}J=b+136|0;if((c[J>>2]|0)>0){E=b+24|0;A=v+44|0;F=v+24|0;D=b+116|0;B=b+120|0;G=0;H=P;while(1){I=(c[E>>2]|0)+(G*112|0)+72|0;if((a[I]|0)==0){if(+h[t+(H<<3)>>3]>=0.0){a[I]=1;C=+h[(c[F>>2]|0)+(H<<3)>>3];c[p>>2]=c[(c[A>>2]|0)+(H<<2)>>2];I=p+4|0;h[k>>3]=C;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];gw(9,0,71528,p)}Q=H+1|0}else{Q=H}I=c[B>>2]|0;R=(c[D>>2]|0)-I|0;if((R|0)<(I|0)){S=I;I=R;T=Q;while(1){V=(c[E>>2]|0)+(I*112|0)+72|0;if((a[V]|0)==0){if(!(+h[t+(T<<3)>>3]>=0.0)){W=S}else{a[V]=1;C=+h[(c[F>>2]|0)+(T<<3)>>3];c[o>>2]=c[(c[A>>2]|0)+(T<<2)>>2];V=o+4|0;h[k>>3]=C;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];gw(9,0,71528,o);W=c[B>>2]|0}X=W;Y=T+1|0}else{X=S;Y=T}V=I+1|0;if((V|0)<(X|0)){S=X;I=V;T=Y}else{Z=V;_=Y;break}}}else{Z=R;_=Q}T=Z+1|0;if((T|0)<(c[J>>2]|0)){G=T;H=_}else{break}}}if((c[35620>>2]|0)!=0){be[c[9034]&255](9);be[c[9034]&255](9)}WZ(t);_z(v);H=Zz(b)|0;if((c[H>>2]|0)!=0){$=H;break}gw(9,0,71552,n);WZ(H);y=0;i=f;return y|0}else{if((z|0)<=(x|0)){$=v;break}gw(9,0,71584,m);$=v}}while(0);do{if((d|0)==3|(d|0)==5){gw(9,0,71600,l);Xz($,d,1,e);Qz(b,$);v=c[$>>2]|0;if((v|0)<=0){break}m=c[$+24>>2]|0;x=c[$+28>>2]|0;z=0;do{h[x+(z<<3)>>3]=+h[m+(z<<3)>>3];z=z+1|0;}while((z|0)<(v|0))}}while(0);if(+Pz($,1.0)>1.0e-9){l=$+40|0;v=c[l>>2]|0;if((v|0)!=0){WZ(v);c[l>>2]=0}l=$+52|0;v=c[l>>2]|0;if((v|0)!=0){WZ(v);c[l>>2]=0}l=$+56|0;v=c[l>>2]|0;if((v|0)!=0){WZ(v);c[l>>2]=0}Xz($,d,0,e);Qz(b,$);+Pz($,1.0)}else{gw(9,0,71624,j)}gw(9,1,71648,g);Qz(b,$);b=Oz($)|0;if((c[35620>>2]|0)!=0){be[c[9034]&255](9)}_z($);y=b;i=f;return y|0}function Xz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=c[a+60>>2]|0;h[n>>3]=0.0;p=a;q=VZ(c[p>>2]<<3)|0;r=q;s=+Pz(a,1.0);t=c[p>>2]|0;if((t|0)>0){u=c[a+28>>2]|0;v=c[a+24>>2]|0;w=0;do{x=+h[u+(w<<3)>>3];h[v+(w<<3)>>3]=x;h[q+(w<<3)>>3]=x;w=w+1|0;}while((w|0)<(t|0))}if(!(s>1.0e-12)){y=1;aA(a,r);WZ(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=14;D=C;E=71776;F=E;gw(9,0,F,g);i=f;return}t=(d|0)==0;d=a+24|0;x=s;w=1;a:while(1){c[m>>2]=w;gw(9,0,71688,m);if(!t){$z(a)}switch(b|0){case 5:{G=13;break a;break};case 6:{G=14;break a;break};case 3:{H=jA(a,n,e)|0;break};case 2:{H=fA(a)|0;break};case 1:{H=hA(a)|0;break};case 4:{G=12;break a;break};default:{G=15;break a}}Ky(o);Ay(o);Gy(o);Ky(o);s=+Pz(a,1.0);v=(H|0)>-1;if(v&s<x){u=c[p>>2]|0;if((u|0)>0){I=c[d>>2]|0;J=0;do{h[q+(J<<3)>>3]=+h[I+(J<<3)>>3];J=J+1|0;}while((J|0)<(u|0))}gw(9,0,71736,k);Qz(o,a);K=s}else{gw(9,0,71752,j);if(v&s==x){y=w;G=23;break}else{K=x}}u=w+1|0;if((u|0)<201&s>1.0e-12){x=K;w=u}else{y=u;G=23;break}}if((G|0)==12){eA(a)|0}else if((G|0)==13){eA(a)|0}else if((G|0)==14){dA(o,a,0)|0}else if((G|0)==15){kw(c[o+536>>2]|0,71712,l)}else if((G|0)==23){aA(a,r);WZ(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=14;D=C;E=71776;F=E;gw(9,0,F,g);i=f;return}}function Yz(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=i;d=x_(b|0)|0;do{if((d|0)==0){e=VZ(1)|0;f=0}else{g=0;h=0;j=d;while(1){k=a[b+g|0]|0;if(k<<24>>24==91){l=h+1|0}else if(k<<24>>24==93){l=h+ -1|0}else{l=h}if((l|0)!=0&k<<24>>24==44){m=((a[b+(g+1)|0]|0)!=32)+j|0}else{m=j}k=g+1|0;if(k>>>0<d>>>0){g=k;h=l;j=m}else{break}}j=VZ(m+1|0)|0;if((m|0)==0){e=j;f=0;break}else{n=0;o=0;p=l}while(1){h=a[b+o|0]|0;if(h<<24>>24==93){q=p+ -1|0}else if(h<<24>>24==91){q=p+1|0}else{q=p}a[j+n|0]=h;do{if((q|0)!=0&h<<24>>24==44){if((a[b+(o+1)|0]|0)==32){r=n;break}g=n+1|0;a[j+g|0]=32;r=g}else{r=n}}while(0);h=r+1|0;if(h>>>0<m>>>0){n=h;o=o+1|0;p=q}else{e=j;f=m;break}}}}while(0);a[e+f|0]=0;if((s_(e,72792,4)|0)!=0){i=c;return e|0}m=f>>>0>3;q=e+4|0;while(1){a:do{if(m){p=f;while(1){o=p+ -1|0;if((a[e+p|0]|0)==46){s=p;break a}if(o>>>0>3){p=o}else{s=o;break}}}else{s=f}}while(0);if((s|0)==3){t=24;break}p=s+ -3|0;z_(e|0,q|0,p|0)|0;o=e+p|0;a[o]=678585700;a[o+1|0]=2650725;a[o+2|0]=10354;a[o+3|0]=40;if((s_(e,72792,4)|0)!=0){t=24;break}}if((t|0)==24){i=c;return e|0}return 0}function Zz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+32|0;o=i;i=i+32|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=VZ(64)|0;z=y;jw(0,(y|0)!=0|0,72800,x);x=y+4|0;A=y+8|0;B=y+12|0;C=y+16|0;D=y+20|0;E=y+24|0;F=y+28|0;G=y+32|0;H=y+36|0;I=y+40|0;J=y+44|0;K=y+48|0;L=y+52|0;M=y+56|0;N=y+60|0;O=y+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));c[N>>2]=b;N=b+8|0;O=b+112|0;P=c[O>>2]|0;if((P|0)>0){Q=c[N>>2]|0;R=0;S=0;while(1){if((a[Q+(S*112|0)+72|0]|0)==0){T=R+1|0;c[x>>2]=T;V=T}else{V=R}T=S+1|0;if((T|0)<(P|0)){R=V;S=T}else{W=V;break}}}else{W=0}V=b+136|0;S=c[V>>2]|0;if((S|0)>0){R=c[b+24>>2]|0;P=0;x=0;while(1){if((a[R+(x*112|0)+72|0]|0)==0){Q=P+1|0;c[A>>2]=Q;X=Q}else{X=P}Q=x+1|0;if((Q|0)<(S|0)){P=X;x=Q}else{Y=X;break}}}else{Y=0}X=b+116|0;x=b+120|0;P=c[x>>2]|0;if((P|0)>0){S=c[X>>2]|0;A=c[N>>2]|0;R=0;Q=S-P|0;while(1){if((a[A+(Q*112|0)+72|0]|0)==0){P=R+1|0;c[B>>2]=P;Z=P}else{Z=R}P=Q+1|0;if((P|0)<(S|0)){R=Z;Q=P}else{_=Z;break}}}else{_=0}Z=Y+W+_|0;c[y>>2]=Z;if((Z|0)==0){i=d;return z|0}y=XZ(Z,8)|0;c[E>>2]=y;jw(0,(y|0)!=0|0,72800,w);w=XZ(Z,8)|0;c[F>>2]=w;jw(0,(w|0)!=0|0,72800,v);v=XZ(Z,8)|0;c[G>>2]=v;jw(0,(v|0)!=0|0,72800,u);u=XZ(Z,8)|0;c[H>>2]=u;jw(0,(u|0)!=0|0,72800,t);t=XZ(Z,8)|0;c[I>>2]=t;jw(0,(t|0)!=0|0,72800,s);s=XZ(Z,4)|0;t=s;c[J>>2]=t;jw(0,(s|0)!=0|0,72800,r);gw(9,0,72816,q);c[p>>2]=Z;c[p+4>>2]=W;c[p+8>>2]=Y;c[p+12>>2]=_;gw(9,0,72840,p);p=c[O>>2]|0;if((p|0)>0){_=N;Y=p;p=t;W=0;Z=0;while(1){q=c[_>>2]|0;if((a[q+(W*112|0)+72|0]|0)==0){c[p+(Z<<2)>>2]=c[q+(W*112|0)+4>>2];q=c[_>>2]|0;do{if((a[q+(W*112|0)+73|0]|0)==0){$=(c[I>>2]|0)+(Z<<3)|0;aa=1.0}else{ba=+h[q+(W*112|0)+80>>3];ca=+U(+ba);r=(c[I>>2]|0)+(Z<<3)|0;if(!(ba==0.0)){$=r;aa=ca;break}$=r;aa=1.0}}while(0);h[$>>3]=aa;r=q+(W*112|0)+96|0;s=(c[E>>2]|0)+(Z<<3)|0;h[s>>3]=+h[r>>3];u=(c[F>>2]|0)+(Z<<3)|0;h[u>>3]=+h[r>>3];h[(c[G>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+56>>3];h[(c[H>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+64>>3];r=Z+1|0;v=c[J>>2]|0;w=c[v+(Z<<2)>>2]|0;ca=+h[u>>3];ba=+h[$>>3];da=+h[s>>3];c[o>>2]=r;c[o+4>>2]=w;w=o+8|0;h[k>>3]=ca;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+16|0;h[k>>3]=ba;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+24|0;h[k>>3]=da;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];gw(9,0,72928,o);ea=c[O>>2]|0;fa=v;ga=r}else{ea=Y;fa=p;ga=Z}r=W+1|0;if((r|0)<(ea|0)){Y=ea;p=fa;W=r;Z=ga}else{ha=fa;ia=ga;break}}}else{ha=t;ia=0}t=c[V>>2]|0;if((t|0)>0){ga=b+24|0;fa=t;t=ha;Z=0;W=ia;while(1){p=c[ga>>2]|0;if((a[p+(Z*112|0)+72|0]|0)==0){c[t+(W<<2)>>2]=c[p+(Z*112|0)+4>>2];p=c[ga>>2]|0;aa=+h[p+(Z*112|0)+80>>3];da=+U(+aa);ea=(c[I>>2]|0)+(W<<3)|0;h[ea>>3]=aa==0.0?1.0:da;Y=p+(Z*112|0)+96|0;O=(c[E>>2]|0)+(W<<3)|0;h[O>>3]=+h[Y>>3];o=(c[F>>2]|0)+(W<<3)|0;h[o>>3]=+h[Y>>3];h[(c[G>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+56>>3];h[(c[H>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+64>>3];p=W+1|0;Y=c[J>>2]|0;$=c[Y+(W<<2)>>2]|0;da=+h[o>>3];aa=+h[ea>>3];ba=+h[O>>3];c[n>>2]=p;c[n+4>>2]=$;$=n+8|0;h[k>>3]=da;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+16|0;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+24|0;h[k>>3]=ba;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];gw(9,0,72976,n);ja=c[V>>2]|0;ka=Y;la=p}else{ja=fa;ka=t;la=W}p=Z+1|0;if((p|0)<(ja|0)){fa=ja;t=ka;Z=p;W=la}else{ma=ka;na=la;break}}}else{ma=ha;na=ia}ia=c[x>>2]|0;if((ia|0)>0){ha=c[X>>2]|0;la=N;ka=ha;W=ma;ma=ha-ia|0;ia=na;while(1){na=c[la>>2]|0;if((a[na+(ma*112|0)+72|0]|0)==0){c[W+(ia<<2)>>2]=c[na+(ma*112|0)+4>>2];na=c[la>>2]|0;do{if((a[na+(ma*112|0)+73|0]|0)==0){oa=(c[I>>2]|0)+(ia<<3)|0;pa=1.0}else{ba=+h[na+(ma*112|0)+80>>3];aa=+U(+ba);ha=(c[I>>2]|0)+(ia<<3)|0;if(!(ba==0.0)){oa=ha;pa=aa;break}oa=ha;pa=1.0}}while(0);h[oa>>3]=pa;q=na+(ma*112|0)+96|0;ha=(c[E>>2]|0)+(ia<<3)|0;h[ha>>3]=+h[q>>3];Z=(c[F>>2]|0)+(ia<<3)|0;h[Z>>3]=+h[q>>3];h[(c[G>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+56>>3];h[(c[H>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+64>>3];q=ia+1|0;t=c[J>>2]|0;ja=c[t+(ia<<2)>>2]|0;aa=+h[Z>>3];ba=+h[oa>>3];da=+h[ha>>3];c[m>>2]=q;c[m+4>>2]=ja;ja=m+8|0;h[k>>3]=aa;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+16|0;h[k>>3]=ba;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+24|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];gw(9,0,73032,m);qa=c[X>>2]|0;ra=t;sa=q}else{qa=ka;ra=W;sa=ia}q=ma+1|0;if((q|0)<(qa|0)){ka=qa;W=ra;ma=q;ia=sa}else{break}}}sa=c[b+184>>2]|0;c[C>>2]=sa;c[D>>2]=0;C=c[X>>2]|0;if((C|0)>0){X=c[N>>2]|0;ia=0;ma=0;while(1){if((a[X+(ma*112|0)+88|0]|0)==0){ta=ia}else{ra=ia+1|0;c[D>>2]=ra;ta=ra}ra=ma+1|0;if((ra|0)<(C|0)){ia=ta;ma=ra}else{ua=ta;break}}}else{ua=0}ta=c[V>>2]|0;if((ta|0)>0){V=c[b+24>>2]|0;ma=ua;ia=0;while(1){do{if((a[V+(ia*112|0)+88|0]|0)==0){va=ma}else{if((a[V+(ia*112|0)+72|0]|0)!=0){va=ma;break}X=ma+1|0;c[D>>2]=X;va=X}}while(0);na=ia+1|0;if((na|0)<(ta|0)){ma=va;ia=na}else{wa=va;break}}}else{wa=ua}ua=c[x>>2]|0;if((ua|0)>0){x=c[N>>2]|0;N=wa;va=C-ua|0;while(1){do{if((a[x+(va*112|0)+88|0]|0)==0){xa=N}else{if((a[x+(va*112|0)+72|0]|0)!=0){xa=N;break}ua=N+1|0;c[D>>2]=ua;xa=ua}}while(0);ua=va+1|0;if((ua|0)<(C|0)){N=xa;va=ua}else{ya=xa;break}}}else{ya=wa}wa=c[b+176>>2]|0;xa=c[b+180>>2]|0;c[l>>2]=sa;c[l+4>>2]=wa;c[l+8>>2]=xa;gw(9,0,73088,l);c[j>>2]=ya;gw(9,0,73160,j);j=XZ(sa,8)|0;c[K>>2]=j;jw(0,(j|0)!=0|0,72800,g);g=VZ(sa<<3)|0;c[L>>2]=g;jw(0,(g|0)!=0|0,72800,f);f=VZ(ya<<3)|0;c[M>>2]=f;jw(0,(f|0)!=0|0,72800,e);if((sa|0)>0){e=0;do{h[g+(e<<3)>>3]=1.0;e=e+1|0;}while((e|0)<(sa|0))}if((ya|0)>0){za=0}else{i=d;return z|0}do{h[f+(za<<3)>>3]=1.0;za=za+1|0;}while((za|0)<(ya|0));i=d;return z|0}function _z(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;if((d|0)!=0){WZ(d)}d=c[a+28>>2]|0;if((d|0)!=0){WZ(d)}d=c[a+32>>2]|0;if((d|0)!=0){WZ(d)}d=c[a+36>>2]|0;if((d|0)!=0){WZ(d)}d=c[a+40>>2]|0;if((d|0)!=0){WZ(d)}d=c[a+44>>2]|0;if((d|0)!=0){WZ(d)}d=c[a+48>>2]|0;if((d|0)!=0){WZ(d)}d=c[a+52>>2]|0;if((d|0)!=0){WZ(d)}d=c[a+56>>2]|0;if((d|0)==0){e=a;WZ(e);i=b;return}WZ(d);e=a;WZ(e);i=b;return}function $z(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0,W=0;d=i;i=i+8|0;e=d;f=c[b+60>>2]|0;g=b+40|0;if((c[g>>2]|0)==0){i=d;return}j=b+52|0;k=c[j>>2]|0;if((k|0)==0){i=d;return}l=b+56|0;m=c[l>>2]|0;if((m|0)==0){i=d;return}n=b+16|0;o=c[n>>2]|0;p=XZ(o,8)|0;q=XZ(o,8)|0;r=b+20|0;s=c[r>>2]|0;t=XZ(s,8)|0;u=XZ(s,8)|0;v=XZ(o,8)|0;w=XZ(s,8)|0;if((o|0)>0){x=0;do{h[k+(x<<3)>>3]=1.0;x=x+1|0;}while((x|0)<(o|0))}if((s|0)>0){o=0;do{h[m+(o<<3)>>3]=1.0;o=o+1|0;}while((o|0)<(s|0))}+Pz(b,1.0);s=c[n>>2]|0;if((s|0)>0){z_(p|0,c[b+48>>2]|0,((s|0)>1?s<<3:8)|0)|0}o=f+8|0;m=f+116|0;x=c[m>>2]|0;if((x|0)>0){k=c[o>>2]|0;y=f+4|0;z=0;A=0;while(1){if((a[k+(z*112|0)+88|0]|0)==0){B=A}else{h[t+(A<<3)>>3]=+h[k+(z*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];B=A+1|0}C=z+1|0;if((C|0)<(x|0)){z=C;A=B}else{D=B;break}}}else{D=0}B=f+136|0;A=c[B>>2]|0;if((A|0)>0){z=c[f+24>>2]|0;y=f+4|0;k=0;C=D;while(1){do{if((a[z+(k*112|0)+88|0]|0)==0){E=C}else{if((a[z+(k*112|0)+72|0]|0)!=0){E=C;break}h[t+(C<<3)>>3]=+h[z+(k*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3];E=C+1|0}}while(0);F=k+1|0;if((F|0)<(A|0)){k=F;C=E}else{G=E;break}}}else{G=D}D=f+120|0;E=c[D>>2]|0;if((E|0)>0){C=c[o>>2]|0;k=f+4|0;A=x-E|0;E=G;while(1){do{if((a[C+(A*112|0)+88|0]|0)==0){H=E}else{if((a[C+(A*112|0)+72|0]|0)!=0){H=E;break}h[t+(E<<3)>>3]=+h[C+(A*112|0)+96>>3]- +h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];H=E+1|0}}while(0);G=A+1|0;if((G|0)<(x|0)){A=G;E=H}else{break}}}H=b;if((c[H>>2]|0)>0){E=b+24|0;A=o;o=f+4|0;x=f+24|0;f=b+48|0;k=c[E>>2]|0;C=0;while(1){G=k+(C<<3)|0;h[G>>3]=+h[G>>3]+1.0e-6;+Pz(b,1.0);G=c[n>>2]|0;y=(G|0)>0;if(y){z_(q|0,c[f>>2]|0,((G|0)>1?G<<3:8)|0)|0}z=c[m>>2]|0;if((z|0)>0){F=c[A>>2]|0;I=0;J=0;while(1){if((a[F+(J*112|0)+88|0]|0)==0){K=I}else{h[u+(I<<3)>>3]=+h[F+(J*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(J<<3)>>3];K=I+1|0}L=J+1|0;if((L|0)<(z|0)){I=K;J=L}else{M=K;break}}}else{M=0}J=c[B>>2]|0;if((J|0)>0){I=c[x>>2]|0;F=M;L=0;while(1){do{if((a[I+(L*112|0)+88|0]|0)==0){N=F}else{if((a[I+(L*112|0)+72|0]|0)!=0){N=F;break}h[u+(F<<3)>>3]=+h[I+(L*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(L<<3)>>3];N=F+1|0}}while(0);O=L+1|0;if((O|0)<(J|0)){F=N;L=O}else{P=N;break}}}else{P=M}L=c[D>>2]|0;if((L|0)>0){F=c[A>>2]|0;J=P;I=z-L|0;while(1){do{if((a[F+(I*112|0)+88|0]|0)==0){Q=J}else{if((a[F+(I*112|0)+72|0]|0)!=0){Q=J;break}h[u+(J<<3)>>3]=+h[F+(I*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(I<<3)>>3];Q=J+1|0}}while(0);L=I+1|0;if((L|0)<(z|0)){J=Q;I=L}else{break}}}if(y){R=+h[(c[g>>2]|0)+(C<<3)>>3];I=0;do{S=+U(+(R*(+h[q+(I<<3)>>3]- +h[p+(I<<3)>>3])/1.0e-6));J=v+(I<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}I=I+1|0;}while((I|0)<(G|0))}I=c[r>>2]|0;if((I|0)>0){R=+h[(c[g>>2]|0)+(C<<3)>>3];y=0;do{S=+U(+(R*(+h[u+(y<<3)>>3]- +h[t+(y<<3)>>3])/1.0e-6));J=w+(y<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}y=y+1|0;}while((y|0)<(I|0))}I=c[E>>2]|0;y=I+(C<<3)|0;h[y>>3]=+h[y>>3]+-1.0e-6;y=C+1|0;if((y|0)<(c[H>>2]|0)){k=I;C=y}else{T=G;break}}}else{T=s}if((T|0)>0){s=T;T=0;while(1){R=+h[v+(T<<3)>>3];C=(c[j>>2]|0)+(T<<3)|0;if(R<1.0e-42){h[C>>3]=1.0;k=T+1|0;c[e>>2]=k;gw(9,0,73200,e);V=k;W=c[n>>2]|0}else{h[C>>3]=R;V=T+1|0;W=s}if((V|0)<(W|0)){s=W;T=V}else{break}}}V=c[r>>2]|0;if((V|0)>0){r=c[l>>2]|0;l=0;do{R=+h[w+(l<<3)>>3];h[r+(l<<3)>>3]=R<1.0e-42?1.0:R;l=l+1|0;}while((l|0)<(V|0))}WZ(p);WZ(q);WZ(t);WZ(u);WZ(v);WZ(w);i=d;return}function aA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+24>>2]|0;a=0;do{h[f+(a<<3)>>3]=+h[b+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=d;return}function bA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+40>>2]|0;g=(f|0)==0;j=c[a+24>>2]|0;a=0;do{k=+h[b+(a<<3)>>3];if(g){l=k}else{l=k*+h[f+(a<<3)>>3]}h[j+(a<<3)>>3]=l;a=a+1|0;}while((a|0)<(e|0));i=d;return}function cA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=c[b+60>>2]|0;f=c[e+112>>2]|0;if((f|0)>0){g=b+24|0;j=c[e+8>>2]|0;k=0;l=0;while(1){if((a[j+(k*112|0)+72|0]|0)==0){h[(c[(c[c[e+4>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3]=+h[(c[g>>2]|0)+(l<<3)>>3];m=l+1|0}else{m=l}n=k+1|0;if((n|0)<(f|0)){k=n;l=m}else{o=m;break}}}else{o=0}m=c[e+136>>2]|0;if((m|0)>0){l=b+24|0;k=c[e+24>>2]|0;f=0;g=o;while(1){if((a[k+(f*112|0)+72|0]|0)==0){h[(c[e+416>>2]|0)+(f<<3)>>3]=+h[(c[l>>2]|0)+(g<<3)>>3];p=g+1|0}else{p=g}j=f+1|0;if((j|0)<(m|0)){f=j;g=p}else{q=p;break}}}else{q=o}o=c[e+116>>2]|0;p=c[e+120>>2]|0;if((p|0)<=0){i=d;return}g=b+24|0;b=c[e+8>>2]|0;f=o-p|0;p=q;while(1){if((a[b+(f*112|0)+72|0]|0)==0){h[(c[e+400>>2]|0)+(f<<3)>>3]=+h[(c[g>>2]|0)+(p<<3)>>3];r=p+1|0}else{r=p}q=f+1|0;if((q|0)<(o|0)){f=q;p=r}else{break}}i=d;return}function dA(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+8|0;kw(c[a+536>>2]|0,73272,d);return 0}function eA(a){a=a|0;a=i;i=i+8|0;kw(0,73304,a);return 0}function fA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;c[d>>2]=(c[35620>>2]|0)!=0?1e3:0;k=a;l=c[k>>2]|0;c[e>>2]=l*1e3;h[f>>3]=1.0e-12;h[g>>3]=10.0;m=l<<1|1;c[j>>2]=m;n=XZ((fa(m+13|0,m+l|0)|0)+((fa(l*3|0,l+3|0)|0)/2|0)|0,8)|0;jw(0,(n|0)!=0|0,73344,b);c[18340]=c[a+60>>2];c[18342]=c[a+48>>2];Wx(k,j,c[a+24>>2]|0,g,f,d,e,n,5)|0;WZ(n);c[18340]=0;c[18342]=0;n=Oz(a)|0;i=b;return n|0}function gA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[18342];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[18340];h[d>>3]=+Pz(f,1.0);i=e;return}function hA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;h[o>>3]=0.0;h[p>>3]=0.0;h[q>>3]=0.0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;w=a;x=c[w>>2]<<3;y=VZ(x)|0;z=y;A=VZ(x)|0;x=A;jw(0,(y|0)!=0|0,73376,n);jw(0,(A|0)!=0|0,73376,m);m=c[w>>2]|0;if((m|0)>0){n=c[a+24>>2]|0;B=0;do{C=+h[n+(B<<3)>>3];if(C!=0.0){D=+U(+C)/1.0e3}else{D=1.0}h[y+(B<<3)>>3]=D;h[A+(B<<3)>>3]=0.0;B=B+1|0;}while((B|0)<(m|0))}B=m*1e3|0;c[v>>2]=B;if((c[35620>>2]|0)==0){E=-1}else{E=(B|0)/10|0}c[r>>2]=E;h[p>>3]=1.0e-12;c[s>>2]=m;c[t>>2]=0;h[q>>3]=1.0e-12;D=+Pz(a,1.0);h[o>>3]=D;if(D!=0.0){c[18348]=c[a+60>>2];c[18350]=c[a+48>>2];Tx(c[a+24>>2]|0,z,w,o,v,r,p,s,t,q,x,6,u)|0;c[18348]=0;c[18350]=0}else{x=l;h[k>>3]=D;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];gw(9,0,73408,l)}D=+Pz(a,1.0);h[o>>3]=D;l=j;h[k>>3]=D;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];gw(9,0,73512,j);j=c[u>>2]|0;do{if((j|0)==4){iw(9,0,73744,d);F=-4;i=b;return F|0}else if((j|0)==1){if(!(+h[q>>3]<+h[o>>3])){break}c[g>>2]=c[v>>2];iw(9,0,73528,g);F=-1;i=b;return F|0}else if((j|0)==2){iw(9,0,73608,f);F=-2;i=b;return F|0}else if((j|0)==3){iw(9,0,73672,e);F=-3;i=b;return F|0}}while(0);F=Oz(a)|0;i=b;return F|0}function iA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[18350];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[18348];h[d>>3]=+Pz(f,1.0);i=e;return}function jA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=fa(d*1e3|0,c[a>>2]|0)|0;c[j>>2]=0;gw(9,1,73800,g);if((c[35620>>2]|0)==0){l=0}else{l=(k|0)/10|0}kA(a,d,k,l,b,j);c[f>>2]=c[j>>2];gw(9,0,73824,f);be[c[9034]&255](9);if(+h[b>>3]<1.0){m=-1;i=e;return m|0}b=Oz(a)|0;if((b|0)==0){m=0;i=e;return m|0}iw(9,0,73840,e);m=b;i=e;return m|0}function kA(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0;j=i;i=i+8|0;l=j;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+24|0;v=i;i=i+32|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+4096|0;K=a;L=c[K>>2]|0;M=L+1|0;N=L<<3;O=VZ(fa(N,M)|0)|0;P=VZ(M<<3)|0;Q=VZ(N)|0;R=Q;S=VZ(N)|0;T=S;V=VZ(N)|0;W=V;X=VZ(N)|0;Y=+h[f>>3];if((c[35620>>2]|0)!=0&Y<1.0){N=J;c[I>>2]=c[(c[a+60>>2]|0)+88>>2];dc(N|0,73888,I|0)|0;I=ec(N|0,73904)|0;c[H>>2]=73920;sd(I|0,73912,H|0)|0;c[G>>2]=73936;sd(I|0,73912,G|0)|0;if((c[K>>2]|0)>0){G=a+44|0;H=0;do{c[F>>2]=c[(c[G>>2]|0)+(H<<2)>>2];sd(I|0,73912,F|0)|0;H=H+1|0;}while((H|0)<(c[K>>2]|0))}Od(10,I|0)|0;c[E>>2]=0;sd(I|0,73944,E|0)|0;E=D;h[k>>3]=Y;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];sd(I|0,73952,D|0)|0;if((c[K>>2]|0)>0){D=a+24|0;E=0;do{H=C;h[k>>3]=+h[(c[D>>2]|0)+(E<<3)>>3];c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];sd(I|0,73952,C|0)|0;E=E+1|0;}while((E|0)<(c[K>>2]|0))}Od(10,I|0)|0;Z=I}else{Z=0}jw(0,(O|0)!=0|0,73960,B);jw(0,(P|0)!=0|0,73960,A);jw(0,(Q|0)!=0|0,73960,z);jw(0,(S|0)!=0|0,73960,y);jw(0,(V|0)!=0|0,73960,x);jw(0,(X|0)!=0|0,73960,w);w=c[a+40>>2]|0;x=(L|0)>0;do{if((w|0)==0){if(!x){_=0;break}y=a+24|0;z=0;while(1){A=(c[y>>2]|0)+(z<<3)|0;B=0;do{h[O+((fa(B,L)|0)+z<<3)>>3]=+h[A>>3];B=B+1|0;}while((B|0)<(M|0));B=z+1|0;if((B|0)<(L|0)){z=B}else{$=14;break}}}else{if(!x){_=0;break}z=c[a+24>>2]|0;y=0;while(1){aa=+h[z+(y<<3)>>3]/+h[w+(y<<3)>>3];B=0;do{h[O+((fa(B,L)|0)+y<<3)>>3]=aa;B=B+1|0;}while((B|0)<(M|0));B=y+1|0;if((B|0)<(L|0)){y=B}else{$=14;break}}}}while(0);do{if(($|0)==14){w=(L|0)>0;if(w){ba=0}else{_=0;break}while(1){x=O+((fa(ba,L)|0)+ba<<3)|0;h[x>>3]=+h[x>>3]+1.0;x=ba+1|0;if((x|0)<(L|0)){ba=x}else{_=w;break}}}}while(0);ba=(L|0)>-1;w=a+16|0;aa=+(M|0);ca=+(L|0);x=(e|0)==0;y=a+48|0;da=1.0/+(b+ -1|0);b=(Z|0)==0;z=a+24|0;B=L<<3;ea=0.0;A=0;ga=Y;a:while(1){I=!(ga>=1.0);E=ga<1.0;ha=ea;C=A;b:while(1){D=C;c:while(1){ia=D+1|0;if(ba){H=0;do{bA(a,O+((fa(H,L)|0)<<3)|0);h[P+(H<<3)>>3]=+Pz(a,ga);H=H+1|0;}while((H|0)<(M|0))}if(_){H=1;F=0;while(1){G=+h[P+(H<<3)>>3]<+h[P+(F<<3)>>3]?H:F;N=H+1|0;if((N|0)<(M|0)){F=G;H=N}else{ja=G;break}}}else{ja=0}ka=fa(ja,L)|0;la=O+(ka<<3)|0;bA(a,la);+Pz(a,ga);H=c[w>>2]|0;if((H|0)>0){F=c[y>>2]|0;Y=0.0;G=0;do{ma=+U(+(+h[F+(G<<3)>>3]));Y=ma>Y?ma:Y;G=G+1|0;}while((G|0)<(H|0));na=!(Y<1.0e-12)}else{na=0}if(!((na|I)&(D|0)<(d|0))){break a}do{if(ba){H=0;G=ja;F=ja;while(1){ma=+h[P+(H<<3)>>3];N=ma>+h[P+(G<<3)>>3];oa=N?H:G;J=N?G:F;pa=!(ma>+h[P+(J<<3)>>3])|(H|0)==(oa|0)?J:H;J=H+1|0;if((J|0)<(M|0)){F=pa;G=oa;H=J}else{break}}if(ba){qa=0.0;ra=0}else{sa=0.0;ta=oa;ua=pa;break}do{qa=qa+ +h[P+(ra<<3)>>3];ra=ra+1|0;}while((ra|0)<(M|0));ma=qa/aa;if(ba){va=0.0;wa=0}else{sa=0.0;ta=oa;ua=pa;break}while(1){xa=+h[P+(wa<<3)>>3]-ma;ya=va+xa*xa;H=wa+1|0;if((H|0)<(M|0)){wa=H;va=ya}else{sa=ya;ta=oa;ua=pa;break}}}else{sa=0.0;ta=ja;ua=ja}}while(0);Y=sa/ca;do{if(!x){if(((ia|0)%(e|0)|0|0)!=0){break}ma=+h[P+(ja<<3)>>3];ya=+h[P+(ta<<3)>>3];H=v;h[k>>3]=ga;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];c[v+8>>2]=ia;H=v+12|0;h[k>>3]=ma;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=v+20|0;h[k>>3]=ya;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];gw(9,0,73976,v)}}while(0);if(Y<1.0e-8&E){break b}if(_){B_(X|0,0,B|0)|0}if(ba){H=0;do{if(!((H|0)==(ta|0)|_^1)){G=fa(H,L)|0;F=0;do{J=X+(F<<3)|0;h[J>>3]=+h[O+(F+G<<3)>>3]+ +h[J>>3];F=F+1|0;}while((F|0)<(L|0))}H=H+1|0;}while((H|0)<(M|0))}do{if(_){H=0;do{F=X+(H<<3)|0;h[F>>3]=+h[F>>3]/ca;H=H+1|0;}while((H|0)<(L|0));if(!_){break}H=fa(ta,L)|0;F=0;do{Y=+h[X+(F<<3)>>3];h[Q+(F<<3)>>3]=Y+(Y- +h[O+(F+H<<3)>>3]);F=F+1|0;}while((F|0)<(L|0))}}while(0);bA(a,R);za=+Pz(a,ga);Y=+h[P+(ja<<3)>>3];do{if(Y<=za){if(!(za<=+h[P+(ua<<3)>>3])){break}if(!_){Aa=ia;D=Aa;continue c}z_(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue c}}while(0);if(!(za<=Y)){break}if(_){F=0;do{ya=+h[X+(F<<3)>>3];h[S+(F<<3)>>3]=ya+(+h[Q+(F<<3)>>3]-ya)*2.0;F=F+1|0;}while((F|0)<(L|0))}bA(a,T);if(+Pz(a,ga)<za){if(!_){Aa=ia;D=Aa;continue}z_(O+(fa(B,ta)|0)|0,S|0,B|0)|0;Aa=ia;D=Aa;continue}else{if(!_){Aa=ia;D=Aa;continue}z_(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue}}if(!(+h[P+(ua<<3)>>3]<=za)){$=89;break a}Y=+h[P+(ta<<3)>>3];if(!(za>=Y)){if(_){D=0;do{ya=+h[X+(D<<3)>>3];h[V+(D<<3)>>3]=ya+(+h[Q+(D<<3)>>3]-ya)*.5;D=D+1|0;}while((D|0)<(L|0))}bA(a,W);Ba=+Pz(a,ga)}else{if(_){D=fa(ta,L)|0;F=0;do{ya=+h[X+(F<<3)>>3];h[V+(F<<3)>>3]=ya+(+h[O+(F+D<<3)>>3]-ya)*.5;F=F+1|0;}while((F|0)<(L|0))}bA(a,W);Ba=+Pz(a,ga)}if(Ba<Y){if(!_){ha=Ba;C=ia;continue}z_(O+(fa(B,ta)|0)|0,V|0,B|0)|0;ha=Ba;C=ia;continue}if(ba){Ca=0}else{ha=Ba;C=ia;continue}while(1){if(_){F=fa(Ca,L)|0;D=0;do{H=O+(D+F<<3)|0;h[H>>3]=(+h[H>>3]+ +h[O+(D+ka<<3)>>3])*.5;D=D+1|0;}while((D|0)<(L|0))}D=Ca+1|0;if((D|0)<(M|0)){Ca=D}else{ha=Ba;C=ia;continue b}}}Y=ga+da;ya=Y>1.0?1.0:Y;Y=+h[P+(ja<<3)>>3];C=u;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[u+8>>2]=ia;C=u+12|0;h[k>>3]=Y;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];gw(9,0,74016,u);if(b){ea=ha;A=ia;ga=ya;continue}c[t>>2]=ia;sd(Z|0,73944,t|0)|0;C=s;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];sd(Z|0,73952,s|0)|0;if((c[K>>2]|0)>0){C=0;do{E=r;h[k>>3]=+h[(c[z>>2]|0)+(C<<3)>>3];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];sd(Z|0,73952,r|0)|0;C=C+1|0;}while((C|0)<(c[K>>2]|0))}Od(10,Z|0)|0;ea=ha;A=ia;ga=ya}if(($|0)==89){$=q;h[k>>3]=za;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];iw(9,0,74064,q);q=p;h[k>>3]=ha;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];iw(9,0,74080,p);kw(0,74096,o)}bA(a,la);if((f|0)!=0){h[f>>3]=ga}if((g|0)!=0){c[g>>2]=ia}if(b){WZ(S);WZ(Q);WZ(V);WZ(X);WZ(P);WZ(O);i=j;return}c[n>>2]=ia;sd(Z|0,73944,n|0)|0;n=m;h[k>>3]=ga;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];sd(Z|0,73952,m|0)|0;if((c[K>>2]|0)>0){m=0;do{n=l;h[k>>3]=+h[(c[z>>2]|0)+(m<<3)>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];sd(Z|0,73952,l|0)|0;m=m+1|0;}while((m|0)<(c[K>>2]|0))}Od(10,Z|0)|0;Vc(Z|0)|0;WZ(S);WZ(Q);WZ(V);WZ(X);WZ(P);WZ(O);i=j;return}function lA(a,b){a=a|0;b=b|0;i=i;return}function mA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=c[b+12>>2]|0;jx(3);mx(0);w=+ex(0);jx(0);x=d+4|0;y=u;h[k>>3]=+h[c[c[x>>2]>>2]>>3];c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];sd(v|0,74176,u|0)|0;if((c[b+8>>2]|0)!=0){b=t;h[k>>3]=w;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];sd(v|0,74176,t|0)|0}t=d+116|0;b=c[t>>2]|0;if((b|0)>0){u=d+8|0;y=b;b=0;while(1){if((a[(c[u>>2]|0)+(b*112|0)+104|0]|0)==0){z=s;h[k>>3]=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(b<<3)>>3];c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];sd(v|0,74176,s|0)|0;A=c[t>>2]|0}else{A=y}z=b+1|0;if((z|0)<(A|0)){y=A;b=z}else{break}}}b=d+124|0;A=c[b>>2]|0;if((A|0)>0){y=d+12|0;t=A;A=0;while(1){if((a[(c[y>>2]|0)+(A*60|0)+56|0]|0)==0){c[r>>2]=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(A<<2)>>2];sd(v|0,74184,r|0)|0;B=c[b>>2]|0}else{B=t}s=A+1|0;if((s|0)<(B|0)){t=B;A=s}else{break}}}A=d+128|0;B=c[A>>2]|0;if((B|0)>0){t=d+16|0;b=B;B=0;while(1){if((a[(c[t>>2]|0)+(B*48|0)+44|0]|0)==0){c[q>>2]=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+B|0]|0;sd(v|0,74184,q|0)|0;C=c[A>>2]|0}else{C=b}r=B+1|0;if((r|0)<(C|0)){b=C;B=r}else{break}}}B=d+132|0;C=c[B>>2]|0;if((C|0)>0){b=d+20|0;A=C;C=0;while(1){if((a[(c[b>>2]|0)+(C*52|0)+48|0]|0)==0){c[p>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(C<<2)>>2];sd(v|0,74192,p|0)|0;D=c[B>>2]|0}else{D=A}q=C+1|0;if((q|0)<(D|0)){A=D;C=q}else{break}}}C=d+216|0;if((c[C>>2]|0)>0){D=d+40|0;A=0;do{B=c[D>>2]|0;do{if((a[B+(A*52|0)+48|0]|0)==0){p=a[B+(A*52|0)+8|0]|0;if(p<<24>>24==2){E=c[c[x>>2]>>2]|0}else if(p<<24>>24==1){break}else{E=(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(c[B+(A*52|0)+4>>2]<<3)|0}w=+h[E>>3];if((c[B+(A*52|0)>>2]|0)==0){p=n;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];sd(v|0,74176,n|0)|0;break}else{p=o;h[k>>3]=-w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];sd(v|0,74176,o|0)|0;break}}}while(0);A=A+1|0;}while((A|0)<(c[C>>2]|0))}C=d+220|0;if((c[C>>2]|0)>0){A=d+44|0;o=0;do{n=c[A>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){if((a[n+(o*52|0)+8|0]|0)==1){break}E=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(c[n+(o*52|0)+4>>2]<<2)>>2]|0;if((c[n+(o*52|0)>>2]|0)==0){c[l>>2]=E;sd(v|0,74184,l|0)|0;break}else{c[m>>2]=0-E;sd(v|0,74184,m|0)|0;break}}}while(0);o=o+1|0;}while((o|0)<(c[C>>2]|0))}C=d+224|0;if((c[C>>2]|0)>0){o=d+48|0;m=0;do{l=c[o>>2]|0;do{if((a[l+(m*52|0)+48|0]|0)==0){if((a[l+(m*52|0)+8|0]|0)==1){break}A=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+(c[l+(m*52|0)+4>>2]|0)|0]|0;if((c[l+(m*52|0)>>2]|0)==0){c[g>>2]=A<<24>>24;sd(v|0,74184,g|0)|0;break}else{c[j>>2]=A<<24>>24!=1;sd(v|0,74184,j|0)|0;break}}}while(0);m=m+1|0;}while((m|0)<(c[C>>2]|0))}C=d+228|0;m=c[C>>2]|0;if((m|0)<=0){F=Od(10,v|0)|0;mx(3);i=e;return}j=d+52|0;d=m;m=0;while(1){g=c[j>>2]|0;do{if((a[g+(m*52|0)+48|0]|0)==0){if((a[g+(m*52|0)+8|0]|0)==1){G=d;break}c[f>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(c[g+(m*52|0)+4>>2]<<2)>>2];sd(v|0,74192,f|0)|0;G=c[C>>2]|0}else{G=d}}while(0);g=m+1|0;if((g|0)<(G|0)){d=G;m=g}else{break}}F=Od(10,v|0)|0;mx(3);i=e;return}function nA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b;s=ec(c[r>>2]|0,74200)|0;t=c[d+536>>2]|0;u=c[r>>2]|0;r=Sd(c[(Kc()|0)>>2]|0)|0;c[q>>2]=u;c[q+4>>2]=r;jw(t,(s|0)!=0|0,74208,q);c[p>>2]=74264;sd(s|0,74192,p|0)|0;if((c[b+8>>2]|0)!=0){c[o>>2]=74272;sd(s|0,74192,o|0)|0}o=d+116|0;p=c[o>>2]|0;if((p|0)>0){q=d+8|0;t=p;p=0;while(1){r=c[q>>2]|0;if((a[r+(p*112|0)+104|0]|0)==0){c[n>>2]=c[r+(p*112|0)+4>>2];sd(s|0,74192,n|0)|0;v=c[o>>2]|0}else{v=t}r=p+1|0;if((r|0)<(v|0)){t=v;p=r}else{break}}}p=d+124|0;v=c[p>>2]|0;if((v|0)>0){t=d+12|0;o=v;v=0;while(1){n=c[t>>2]|0;if((a[n+(v*60|0)+56|0]|0)==0){c[m>>2]=c[n+(v*60|0)+4>>2];sd(s|0,74192,m|0)|0;w=c[p>>2]|0}else{w=o}n=v+1|0;if((n|0)<(w|0)){o=w;v=n}else{break}}}v=d+128|0;w=c[v>>2]|0;if((w|0)>0){o=d+16|0;p=w;w=0;while(1){m=c[o>>2]|0;if((a[m+(w*48|0)+44|0]|0)==0){c[l>>2]=c[m+(w*48|0)+4>>2];sd(s|0,74192,l|0)|0;x=c[v>>2]|0}else{x=p}m=w+1|0;if((m|0)<(x|0)){p=x;w=m}else{break}}}w=d+132|0;x=c[w>>2]|0;if((x|0)>0){p=d+20|0;v=x;x=0;while(1){l=c[p>>2]|0;if((a[l+(x*52|0)+48|0]|0)==0){c[k>>2]=c[l+(x*52|0)+4>>2];sd(s|0,74192,k|0)|0;y=c[w>>2]|0}else{y=v}l=x+1|0;if((l|0)<(y|0)){v=y;x=l}else{break}}}x=d+216|0;y=c[x>>2]|0;if((y|0)>0){v=d+40|0;w=y;y=0;while(1){k=c[v>>2]|0;do{if((a[k+(y*52|0)+48|0]|0)==0){if((a[k+(y*52|0)+8|0]|0)==1){z=w;break}c[j>>2]=c[k+(y*52|0)+16>>2];sd(s|0,74192,j|0)|0;z=c[x>>2]|0}else{z=w}}while(0);k=y+1|0;if((k|0)<(z|0)){w=z;y=k}else{break}}}y=d+220|0;z=c[y>>2]|0;if((z|0)>0){w=d+44|0;x=z;z=0;while(1){j=c[w>>2]|0;do{if((a[j+(z*52|0)+48|0]|0)==0){if((a[j+(z*52|0)+8|0]|0)==1){A=x;break}c[h>>2]=c[j+(z*52|0)+16>>2];sd(s|0,74192,h|0)|0;A=c[y>>2]|0}else{A=x}}while(0);j=z+1|0;if((j|0)<(A|0)){x=A;z=j}else{break}}}z=d+224|0;A=c[z>>2]|0;if((A|0)>0){x=d+48|0;y=A;A=0;while(1){h=c[x>>2]|0;do{if((a[h+(A*52|0)+48|0]|0)==0){if((a[h+(A*52|0)+8|0]|0)==1){B=y;break}c[g>>2]=c[h+(A*52|0)+16>>2];sd(s|0,74192,g|0)|0;B=c[z>>2]|0}else{B=y}}while(0);h=A+1|0;if((h|0)<(B|0)){y=B;A=h}else{break}}}A=d+228|0;B=c[A>>2]|0;if((B|0)<=0){C=Od(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}y=d+52|0;d=B;B=0;while(1){z=c[y>>2]|0;do{if((a[z+(B*52|0)+48|0]|0)==0){if((a[z+(B*52|0)+8|0]|0)==1){H=d;break}c[f>>2]=c[z+(B*52|0)+16>>2];sd(s|0,74192,f|0)|0;H=c[A>>2]|0}else{H=d}}while(0);z=B+1|0;if((z|0)<(H|0)){d=H;B=z}else{break}}C=Od(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}function oA(a,b){a=a|0;b=b|0;var d=0;b=i;d=c[a+12>>2]|0;jx(3);Vc(d|0)|0;mx(3);i=b;return}function pA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d;f=d+16|0;g=d+32|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+88|0;o=c[a+12>>2]|0;c[k>>2]=0;p=o;fS(l,p);q=o+184|0;r=m;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=f;r=m;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];gS(p,f)|0;qA(b,k,g,j,+h[o+224>>3],+h[o+232>>3]);o=c[k>>2]|0;rA(a,b,74288,c[j>>2]|0,c[g>>2]|0,o,8);WZ(o);c[k>>2]=0;k=n;o=l;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=e;k=n;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];gS(p,e)|0;i=d;return}function qA(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+8|0;c[e>>2]=2;l=b+136|0;m=b+140|0;n=b+144|0;o=(c[l>>2]|0)+1+(c[m>>2]|0)+(c[n>>2]|0)|0;c[f>>2]=o;p=XZ(fa(c[e>>2]|0,o)|0,8)|0;c[d>>2]=p;jw(c[b+536>>2]|0,(p|0)!=0|0,74568,k);p=c[d>>2]|0;h[p>>3]=g;d=c[f>>2]|0;h[p+(d<<3)>>3]=j;f=c[l>>2]|0;if((f|0)>0){l=c[b+416>>2]|0;o=0;do{e=l+(o<<3)|0;o=o+1|0;h[p+(o<<3)>>3]=+h[e>>3];h[p+(d+o<<3)>>3]=+h[e>>3];}while((o|0)<(f|0))}o=f+1|0;f=c[m>>2]|0;if((f|0)>0){m=c[b+420>>2]|0;l=0;do{j=+(c[m+(l<<2)>>2]|0);e=l+o|0;h[p+(e<<3)>>3]=j;h[p+(d+e<<3)>>3]=j;l=l+1|0;}while((l|0)<(f|0))}l=f+o|0;o=c[n>>2]|0;if((o|0)<=0){i=k;return}n=c[b+424>>2]|0;b=0;do{f=n+b|0;m=l+b|0;h[p+(m<<3)>>3]=+(a[f]|0);h[p+(d+m<<3)>>3]=+(a[f]|0);b=b+1|0;}while((b|0)<(o|0));i=k;return}function rA(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+8|0;k=j;l=c[a+12>>2]|0;CA(a,b,d,e,f,h);eS(l,g,fa(fa(f,e)|0,h)|0)|0;if(BQ(l+(c[(c[l>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];kw(l,74520,k)}else{i=j;return}}function sA(a){a=a|0;var b=0;b=i;if((uB(a+4|0)|0)!=0){i=b;return}EQ(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function tA(a){a=a|0;Oc(a|0)|0;Va()}function uA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=$Z(320)|0;B_(q|0,0,320)|0;vA(q);r=a+12|0;c[r>>2]=q;s=(c[b+140>>2]|0)+(c[b+136>>2]|0)+(c[b+144>>2]|0)|0;c[f>>2]=0;c[k>>2]=0;c[l>>2]=0;jx(3);t=a+8|0;u=wA(c[t>>2]|0,c[r>>2]|0,b)|0;r=q+316|0;c[r>>2]=u;v=xA(a,b,u+s|0)|0;u=q+184|0;yA(m,-1,-1);w=m;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];w=q+200|0;yA(n,-1,-1);m=n;c[w+0>>2]=c[m+0>>2];c[w+4>>2]=c[m+4>>2];c[w+8>>2]=c[m+8>>2];c[w+12>>2]=c[m+12>>2];c[q+216>>2]=0;m=q+224|0;h[m>>3]=+h[b+240>>3];n=q+232|0;h[n>>3]=+h[b+248>>3];x=a;zA(q,c[x>>2]|0,36);if(BQ(q+(c[(c[q>>2]|0)+ -12>>2]|0)|0)|0){y=c[b+536>>2]|0;c[e>>2]=c[x>>2];kw(y,74344,e)}else{rA(a,b,74376,4,11,74296,1);AA((c[r>>2]|0)+s|0,v,f,g,j,0,0)|0;e=c[f>>2]|0;rA(a,b,74384,c[g>>2]|0,c[j>>2]|0,e,1);WZ(e);c[f>>2]=0;AA((c[r>>2]|0)+s|0,v,f,g,j,0,1)|0;e=c[f>>2]|0;rA(a,b,74392,c[g>>2]|0,c[j>>2]|0,e,1);WZ(e);c[f>>2]=0;BA(a,b,k,g,j,c[r>>2]|0,s);rA(a,b,74408,c[j>>2]|0,c[g>>2]|0,c[k>>2]|0,4);s=q;fS(o,s);r=o;c[u+0>>2]=c[r+0>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];qA(b,l,g,j,+h[m>>3],+h[n>>3]);n=c[l>>2]|0;rA(a,b,74288,c[j>>2]|0,c[g>>2]|0,n,8);fS(p,s);g=p;c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2];c[w+12>>2]=c[g+12>>2];g=DA(q+240|0)|0;w=DA(q+264|0)|0;p=DA(q+288|0)|0;CA(a,b,74424,g+1+w+p+(c[q+312>>2]|0)+(c[t>>2]|0)|0,0,8);WZ(n);WZ(c[k>>2]|0);c[l>>2]=0;c[k>>2]=0;MR(s)|0;WZ(v);mx(3);i=d;return}}function vA(a){a=a|0;var b=0;b=i;ED(a);i=b;return}function wA(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=(b|0)==0?1:2;c[g>>2]=0;b=e+116|0;l=c[b>>2]|0;if((l|0)>0){m=e+8|0;n=d+240|0;o=l;l=0;p=k;while(1){if((a[(c[m>>2]|0)+(l*112|0)+104|0]|0)==0){c[(IC(n,g)|0)>>2]=p;q=c[b>>2]|0;r=c[g>>2]|0;s=p+1|0}else{q=o;r=l;s=p}t=r+1|0;c[g>>2]=t;if((t|0)<(q|0)){o=q;l=t;p=s}else{u=s;break}}}else{u=k}c[h>>2]=0;k=e+124|0;s=c[k>>2]|0;if((s|0)>0){p=e+12|0;l=d+264|0;q=s;s=0;o=u;while(1){if((a[(c[p>>2]|0)+(s*60|0)+56|0]|0)==0){c[(IC(l,h)|0)>>2]=o;v=c[k>>2]|0;w=c[h>>2]|0;x=o+1|0}else{v=q;w=s;x=o}g=w+1|0;c[h>>2]=g;if((g|0)<(v|0)){q=v;s=g;o=x}else{y=x;break}}}else{y=u}c[j>>2]=0;u=e+128|0;x=c[u>>2]|0;if((x|0)>0){o=e+16|0;s=d+288|0;v=x;x=0;q=y;while(1){if((a[(c[o>>2]|0)+(x*48|0)+44|0]|0)==0){c[(IC(s,j)|0)>>2]=q;z=c[u>>2]|0;A=c[j>>2]|0;B=q+1|0}else{z=v;A=x;B=q}h=A+1|0;c[j>>2]=h;if((h|0)<(z|0)){v=z;x=h;q=B}else{C=B;break}}}else{C=y}y=c[e+216>>2]|0;if((y|0)>0){B=c[e+40>>2]|0;q=0;x=C;while(1){z=((a[B+(q*52|0)+48|0]|0)==0)+x|0;v=q+1|0;if((v|0)<(y|0)){x=z;q=v}else{D=z;break}}}else{D=C}C=c[e+220>>2]|0;if((C|0)>0){q=c[e+44>>2]|0;x=0;y=D;while(1){B=((a[q+(x*52|0)+48|0]|0)==0)+y|0;z=x+1|0;if((z|0)<(C|0)){y=B;x=z}else{E=B;break}}}else{E=D}D=d+312|0;c[D>>2]=0;d=c[e+224>>2]|0;if((d|0)<=0){F=E;i=f;return F|0}x=c[e+48>>2]|0;e=0;y=0;C=E;while(1){if((a[x+(y*52|0)+48|0]|0)==0){if((c[x+(y*52|0)>>2]|0)==0){G=e}else{E=e+1|0;c[D>>2]=E;G=E}H=G;I=C+1|0}else{H=e;I=C}E=y+1|0;if((E|0)<(d|0)){e=H;y=E;C=I}else{F=I;break}}i=f;return F|0}function xA(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=c[b+12>>2]|0;l=VZ(e<<2)|0;e=l;c[l>>2]=74976;if((c[b+8>>2]|0)==0){m=1}else{c[l+4>>2]=75016;m=2}b=c[d+116>>2]|0;if((b|0)>0){n=c[d+8>>2]|0;o=m;p=0;while(1){if((a[n+(p*112|0)+104|0]|0)==0){c[l+(o<<2)>>2]=n+(p*112|0);q=o+1|0}else{q=o}r=p+1|0;if((r|0)<(b|0)){o=q;p=r}else{s=q;break}}}else{s=m}m=c[d+124>>2]|0;if((m|0)>0){q=c[d+12>>2]|0;p=s;o=0;while(1){if((a[q+(o*60|0)+56|0]|0)==0){c[l+(p<<2)>>2]=q+(o*60|0);t=p+1|0}else{t=p}b=o+1|0;if((b|0)<(m|0)){p=t;o=b}else{u=t;break}}}else{u=s}s=c[d+128>>2]|0;if((s|0)>0){t=c[d+16>>2]|0;o=u;p=0;while(1){if((a[t+(p*48|0)+44|0]|0)==0){c[l+(o<<2)>>2]=t+(p*48|0);v=o+1|0}else{v=o}m=p+1|0;if((m|0)<(s|0)){o=v;p=m}else{w=v;break}}}else{w=u}u=c[d+216>>2]|0;if((u|0)>0){v=c[d+40>>2]|0;p=w;o=0;while(1){if((a[v+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=v+(o*52|0)+12;x=p+1|0}else{x=p}s=o+1|0;if((s|0)<(u|0)){p=x;o=s}else{y=x;break}}}else{y=w}w=c[d+220>>2]|0;if((w|0)>0){x=c[d+44>>2]|0;o=y;p=0;while(1){if((a[x+(p*52|0)+48|0]|0)==0){c[l+(o<<2)>>2]=x+(p*52|0)+12;z=o+1|0}else{z=o}u=p+1|0;if((u|0)<(w|0)){o=z;p=u}else{A=z;break}}}else{A=y}y=c[d+224>>2]|0;if((y|0)>0){z=c[d+48>>2]|0;p=A;o=0;while(1){if((a[z+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=z+(o*52|0)+12;B=p+1|0}else{B=p}w=o+1|0;if((w|0)<(y|0)){p=B;o=w}else{C=B;break}}}else{C=A}c[g>>2]=0;A=d+136|0;if((c[A>>2]|0)>0){B=d+24|0;o=k+252|0;p=C;y=0;z=1;while(1){w=p+1|0;c[l+(p<<2)>>2]=(c[B>>2]|0)+(y*112|0);c[(IC(o,g)|0)>>2]=z;x=z+1|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;if((u|0)<(c[A>>2]|0)){z=x;y=u;p=w}else{D=w;E=x;break}}}else{D=C;E=1}c[h>>2]=0;C=d+140|0;if((c[C>>2]|0)>0){p=d+28|0;y=k+276|0;z=D;A=0;g=E;while(1){o=z+1|0;c[l+(z<<2)>>2]=(c[p>>2]|0)+(A*60|0);c[(IC(y,h)|0)>>2]=g;B=g+1|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;if((x|0)<(c[C>>2]|0)){g=B;A=x;z=o}else{F=o;G=B;break}}}else{F=D;G=E}c[j>>2]=0;E=d+144|0;if((c[E>>2]|0)<=0){i=f;return e|0}D=d+32|0;d=k+300|0;k=F;F=0;z=G;while(1){c[l+(k<<2)>>2]=(c[D>>2]|0)+(F*48|0);c[(IC(d,j)|0)>>2]=z;G=(c[j>>2]|0)+1|0;c[j>>2]=G;if((G|0)<(c[E>>2]|0)){z=z+1|0;F=G;k=k+1|0}else{break}}i=f;return e|0}function yA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;tB(a,b,c);i=d;return}function zA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(sB(a+4|0,b,d|16)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){EQ(d,4);i=e;return}else{CQ(d,0);i=e;return}}function AA(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+8|0;k=j;l=i;i=i+8|0;c[f>>2]=a;c[e>>2]=0;m=(a|0)>0;do{if(m){n=0;o=0;while(1){p=c[b+(o<<2)>>2]|0;q=x_(c[(h?p+8|0:p+4|0)>>2]|0)|0;if((q|0)>(n|0)){c[e>>2]=q;r=q}else{r=n}q=o+1|0;if((q|0)<(a|0)){n=r;o=q}else{break}}o=XZ((fa(c[f>>2]|0,r)|0)+1|0,1)|0;c[d>>2]=o;jw(0,(o|0)!=0|0,74496,l);if(!m){break}o=c[e>>2]|0;n=0;q=c[d>>2]|0;while(1){p=b+(n<<2)|0;s=c[p>>2]|0;I_(q|0,c[(h?s+8|0:s+4|0)>>2]|0,o+1|0)|0;if(g){s=c[p>>2]|0;HA(q,x_(c[(h?s+8|0:s+4|0)>>2]|0)|0)}s=c[e>>2]|0;p=n+1|0;if((p|0)<(a|0)){o=s;n=p;q=q+s|0}else{t=s;break}}u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}else{q=XZ(1,1)|0;c[d>>2]=q;jw(0,(q|0)!=0|0,74496,k)}}while(0);t=c[e>>2]|0;u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}function BA(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=c[b+12>>2]|0;c[f>>2]=j+h;c[g>>2]=4;g=XZ(c[f>>2]<<2,4)|0;c[e>>2]=g;jw(c[d+536>>2]|0,(g|0)!=0|0,74544,k);g=s+240|0;f=DA(g)|0;h=s+264|0;t=DA(h)|0;u=s+288|0;v=DA(u)|0;w=b+8|0;if((f+1+t+v|0)==(0-(c[w>>2]|0)|0)){x=0;y=1}else{v=c[e>>2]|0;t=0;f=0;b=1;while(1){c[v+(t<<2)>>2]=2;c[v+((t|1)<<2)>>2]=b;c[v+((t|2)<<2)>>2]=0;z=t+4|0;c[v+((t|3)<<2)>>2]=-1;A=b+1|0;B=f+1|0;C=DA(g)|0;D=DA(h)|0;E=DA(u)|0;if(B>>>0<(C+1+D+E+(c[w>>2]|0)|0)>>>0){b=A;f=B;t=z}else{x=z;y=A;break}}}t=d+216|0;if((c[t>>2]|0)>0){f=d+40|0;b=s+252|0;w=x;v=0;while(1){A=c[f>>2]|0;do{if((a[A+(v*52|0)+48|0]|0)==0){z=a[A+(v*52|0)+8|0]|0;if(z<<24>>24==1){IA(l,b,A+(v*52|0)+4|0);KA(n,b);if(!(JA(l,n)|0)){F=w;break}G=(c[(LA(l)|0)+4>>2]|0)+1|0;H=1}else if(z<<24>>24==0){IA(l,g,A+(v*52|0)+4|0);KA(m,g);if(!(JA(l,m)|0)){F=w;break}G=(c[(LA(l)|0)+4>>2]|0)+1|0;H=2}else if(z<<24>>24==2){G=1;H=2}else{F=w;break}z=c[e>>2]|0;c[z+(w<<2)>>2]=H;if((c[(c[f>>2]|0)+(v*52|0)>>2]|0)==0){c[z+(w+1<<2)>>2]=G}else{c[z+(w+1<<2)>>2]=0-G}c[z+(w+2<<2)>>2]=0;c[z+(w+3<<2)>>2]=-1;F=w+4|0}else{F=w}}while(0);A=v+1|0;if((A|0)<(c[t>>2]|0)){w=F;v=A}else{I=F;break}}}else{I=x}x=d+220|0;if((c[x>>2]|0)>0){F=d+44|0;v=s+276|0;w=I;t=0;while(1){G=c[F>>2]|0;do{if((a[G+(t*52|0)+48|0]|0)==0){f=a[G+(t*52|0)+8|0]|0;if(f<<24>>24==1){IA(l,v,G+(t*52|0)+4|0);KA(p,v);J=(JA(l,p)|0)&1}else if(f<<24>>24==0){IA(l,h,G+(t*52|0)+4|0);KA(o,h);f=JA(l,o)|0;J=f?2:0}else{K=w;break}if((J|0)==0){K=w;break}f=c[e>>2]|0;c[f+(w<<2)>>2]=J;H=(c[(c[F>>2]|0)+(t*52|0)>>2]|0)==0;m=c[(LA(l)|0)+4>>2]|0;if(H){c[f+(w+1<<2)>>2]=m+1}else{c[f+(w+1<<2)>>2]=~m}c[f+(w+2<<2)>>2]=0;c[f+(w+3<<2)>>2]=-1;K=w+4|0}else{K=w}}while(0);G=t+1|0;if((G|0)<(c[x>>2]|0)){w=K;t=G}else{L=K;break}}}else{L=I}I=d+224|0;if((c[I>>2]|0)>0){K=d+48|0;d=s+300|0;s=L;t=0;w=y;while(1){y=c[K>>2]|0;do{if((a[y+(t*52|0)+48|0]|0)==0){if((c[y+(t*52|0)>>2]|0)==0){x=a[y+(t*52|0)+8|0]|0;if(x<<24>>24==1){IA(l,d,y+(t*52|0)+4|0);KA(r,d);M=(JA(l,r)|0)&1}else if(x<<24>>24==0){IA(l,u,y+(t*52|0)+4|0);KA(q,u);x=JA(l,q)|0;M=x?2:0}else{N=s;O=w;break}if((M|0)==0){N=s;O=w;break}P=c[K>>2]|0;Q=M}else{P=y;Q=2}x=c[e>>2]|0;c[x+(s<<2)>>2]=Q;if((c[P+(t*52|0)>>2]|0)==0){c[x+(s+1<<2)>>2]=(c[(LA(l)|0)+4>>2]|0)+1;R=w}else{c[x+(s+1<<2)>>2]=w;R=w+1|0}c[x+(s+2<<2)>>2]=0;c[x+(s+3<<2)>>2]=-1;N=s+4|0;O=R}else{N=s;O=w}}while(0);y=t+1|0;if((y|0)<(c[I>>2]|0)){s=N;t=y;w=O}else{S=N;break}}}else{S=L}if((j|0)==0){i=k;return}L=c[e>>2]|0;e=0;do{N=(e<<2)+S|0;c[L+(N<<2)>>2]=1;c[L+(N+1<<2)>>2]=e+2;c[L+(N+2<<2)>>2]=0;c[L+(N+3<<2)>>2]=0;e=e+1|0;}while(e>>>0<j>>>0);i=k;return}function CA(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+24|0;m=c[a+12>>2]|0;c[l>>2]=(g|0)==4?20:(g|0)==1?51:0;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;f=l+16|0;c[f>>2]=(x_(d|0)|0)+1;e=m;eS(e,l,20)|0;if(BQ(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];kw(l,74520,k)}eS(e,d,c[f>>2]|0)|0;if(BQ(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){m=c[b+536>>2]|0;c[j>>2]=c[a>>2];kw(m,74520,j)}else{i=h;return}}function DA(a){a=a|0;var b=0,d=0;b=i;d=c[(pB(a)|0)>>2]|0;i=b;return d|0}function EA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=a+12|0;h=c[g>>2]|0;j=h;jx(3);do{if(AQ(h+(c[(c[h>>2]|0)+ -12>>2]|0)|0)|0){k=h;l=h+200|0;m=f;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];l=e;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];gS(k,e)|0;k=DA(h+240|0)|0;m=DA(h+264|0)|0;l=DA(h+288|0)|0;CA(a,b,74424,k+1+m+l+(c[h+312>>2]|0)+(c[a+8>>2]|0)|0,c[h+216>>2]|0,8);sA(h)}else{if((h|0)!=0){break}c[g>>2]=0;mx(3);i=d;return}}while(0);FA(j);b_(h);c[g>>2]=0;mx(3);i=d;return}function FA(a){a=a|0;var b=0;b=i;NB(a);i=b;return}function GA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=c[b+12>>2]|0;h[g>>3]=0.0;jx(3);mx(0);h[j>>3]=+ex(0);jx(0);l=k;m=d+4|0;eS(l,c[c[m>>2]>>2]|0,8)|0;if((c[b+8>>2]|0)!=0){eS(l,j,8)|0}j=d+116|0;n=c[j>>2]|0;if((n|0)>0){o=d+8|0;p=n;n=0;while(1){if((a[(c[o>>2]|0)+(n*112|0)+104|0]|0)==0){eS(l,(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+(n<<3)|0,8)|0;q=c[j>>2]|0}else{q=p}r=n+1|0;if((r|0)<(q|0)){p=q;n=r}else{break}}}n=d+124|0;q=c[n>>2]|0;if((q|0)>0){p=d+12|0;j=g;o=q;q=0;while(1){if((a[(c[p>>2]|0)+(q*60|0)+56|0]|0)==0){h[g>>3]=+(c[(c[(c[c[m>>2]>>2]|0)+12>>2]|0)+(q<<2)>>2]|0);eS(l,j,8)|0;s=c[n>>2]|0}else{s=o}r=q+1|0;if((r|0)<(s|0)){o=s;q=r}else{break}}}q=d+128|0;s=c[q>>2]|0;if((s|0)>0){o=d+16|0;n=g;j=s;s=0;while(1){if((a[(c[o>>2]|0)+(s*48|0)+44|0]|0)==0){h[g>>3]=+(a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+s|0]|0);eS(l,n,8)|0;t=c[q>>2]|0}else{t=j}p=s+1|0;if((p|0)<(t|0)){j=t;s=p}else{break}}}s=d+224|0;t=c[s>>2]|0;if((t|0)>0){j=d+48|0;q=g;n=t;t=0;while(1){o=c[j>>2]|0;do{if((a[o+(t*52|0)+48|0]|0)==0){if((c[o+(t*52|0)>>2]|0)==0){u=n;break}h[g>>3]=+((a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+(c[o+(t*52|0)+4>>2]|0)|0]|0)!=1|0);eS(l,q,8)|0;u=c[s>>2]|0}else{u=n}}while(0);o=t+1|0;if((o|0)<(u|0)){n=u;t=o}else{break}}}if(BQ(k+(c[(c[k>>2]|0)+ -12>>2]|0)|0)|0){t=c[d+536>>2]|0;c[f>>2]=c[b>>2];kw(t,74464,f)}else{f=k+216|0;c[f>>2]=(c[f>>2]|0)+1;mx(3);i=e;return}}function HA(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(c>>>0<6){i=d;return}if((u_(b,74680,4)|0)!=0){i=d;return}c=b;while(1){e=Sa(b|0,46)|0;if((e|0)==0){f=8;break}g=e-c|0;e=g+1|0;if(e>>>0>4){h=4;do{a[b+(h+ -4)|0]=a[b+h|0]|0;h=h+1|0;}while(h>>>0<e>>>0)}e=b+(g+ -3)|0;a[e]=678585700;a[e+1|0]=2650725;a[e+2|0]=10354;a[e+3|0]=40;if((u_(b,74680,4)|0)!=0){f=8;break}}if((f|0)==8){i=d;return}}function IA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;bB(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];TA(a,f);i=e;return}function JA(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=RA(a,b)|0;i=c;return d|0}function KA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;UA(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];TA(a,e);i=d;return}function LA(a){a=a|0;var b=0,c=0;b=i;c=MA(NA(a)|0)|0;i=b;return c|0}function MA(a){a=a|0;var b=0,c=0;b=i;c=QA(a)|0;i=b;return c|0}function NA(a){a=a|0;var b=0,d=0;b=i;d=OA((c[a>>2]|0)+16|0)|0;i=b;return d|0}function OA(a){a=a|0;var b=0,c=0;b=i;c=PA(a)|0;i=b;return c|0}function PA(a){a=a|0;i=i;return a|0}function QA(a){a=a|0;i=i;return a|0}function RA(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(SA(a,b)|0)^1;i=c;return d|0}function SA(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function TA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];aB(a,e);i=d;return}function UA(a,b){a=a|0;b=b|0;var c=0;c=i;VA(a,WA(b)|0);i=c;return}function VA(a,b){a=a|0;b=b|0;var c=0;c=i;$A(a,b);i=c;return}function WA(a){a=a|0;var b=0,c=0;b=i;c=XA(YA(a+4|0)|0)|0;i=b;return c|0}function XA(a){a=a|0;var b=0,c=0;b=i;c=_A(a)|0;i=b;return c|0}function YA(a){a=a|0;var b=0,c=0;b=i;c=ZA(a)|0;i=b;return c|0}function ZA(a){a=a|0;i=i;return a|0}function _A(a){a=a|0;i=i;return a|0}function $A(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function aB(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function bB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=dB(b)|0;cB(f,b,d,h,WA(b)|0);UA(g,b);do{if(RA(f,g)|0){h=eB(b)|0;if(fB(h,d,gB(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);UA(a,b);i=e;return}function cB(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;kB(h);a:do{if((e|0)==0){j=f}else{k=eB(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(lB(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;kB(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;kB(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);VA(a,j);i=g;return}function dB(a){a=a|0;var b=0,d=0;b=i;d=c[(WA(a)|0)>>2]|0;i=b;return d|0}function eB(a){a=a|0;var b=0,c=0;b=i;c=iB(a+8|0)|0;i=b;return c|0}function fB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=hB(0,b,c)|0;i=a;return d|0}function gB(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function hB(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function iB(a){a=a|0;var b=0,c=0;b=i;c=jB(a)|0;i=b;return c|0}function jB(a){a=a|0;i=i;return a|0}function kB(a){a=a|0;var b=0;b=i;mB(a,-1);i=b;return}function lB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=hB(0,b,c)|0;i=a;return d|0}function mB(a,b){a=a|0;b=b|0;b=i;nB(a,0);i=b;return}function nB(a,b){a=a|0;b=b|0;c[a>>2]=0;i=i;return}function oB(a){a=a|0;i=i;return c[a+4>>2]|0}function pB(a){a=a|0;var b=0,c=0;b=i;c=qB(a+8|0)|0;i=b;return c|0}function qB(a){a=a|0;var b=0,c=0;b=i;c=rB(a)|0;i=b;return c|0}function rB(a){a=a|0;i=i;return a|0}function sB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+64|0;if((c[f>>2]|0)!=0){g=0;i=e;return g|0}switch(d&-3|0){case 13:case 29:{h=74672;break};case 12:{h=74648;break};case 52:case 20:{h=74632;break};case 8:{h=74600;break};case 28:{h=74656;break};case 5:case 21:{h=74640;break};case 9:case 25:{h=74624;break};case 48:case 16:{h=74584;break};case 56:{h=74616;break};case 24:{h=74608;break};case 1:case 17:{h=74592;break};case 60:{h=74664;break};default:{g=0;i=e;return g|0}}if((a|0)==0){g=0;i=e;return g|0}j=ec(b|0,h|0)|0;c[f>>2]=j;if((j|0)==0){g=0;i=e;return g|0}c[a+88>>2]=d;if((d&2|0)==0){g=a;i=e;return g|0}if((Tc(j|0,0,2)|0)==0){g=a;i=e;return g|0}Vc(c[f>>2]|0)|0;c[f>>2]=0;g=0;i=e;return g|0}function tB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=b;c[e+4>>2]=d;i=i;return}function uB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+64|0;f=c[e>>2]|0;if((f|0)==0){g=0;i=b;return g|0}vB(d,f,102);f=ee[c[(c[a>>2]|0)+24>>2]&127](a)|0;if((Vc(wB(d)|0)|0)==0){c[e>>2]=0;h=(f|0)==0?a:0}else{h=0}xB(d);g=h;i=b;return g|0}function vB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;EB(a,b,c);i=d;return}function wB(a){a=a|0;var b=0,d=0;b=i;d=AB(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function xB(a){a=a|0;var b=0;b=i;yB(a);i=b;return}function yB(a){a=a|0;var b=0;b=i;zB(a,0);i=b;return}function zB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=AB(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}ee[c[(BB(e)|0)>>2]&127](f)|0;i=d;return}function AB(a){a=a|0;var b=0,c=0;b=i;c=DB(a)|0;i=b;return c|0}function BB(a){a=a|0;var b=0,c=0;b=i;c=CB(a)|0;i=b;return c|0}function CB(a){a=a|0;i=i;return a+4|0}function DB(a){a=a|0;i=i;return a|0}function EB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(GB(f)|0)>>2]|0;FB(a,d,c[(HB(g)|0)>>2]|0);i=e;return}function FB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;IB(a,b,c);i=d;return}function GB(a){a=a|0;i=i;return a|0}function HB(a){a=a|0;i=i;return a|0}function IB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(KB(f)|0)>>2]|0;JB(a,d,c[(LB(g)|0)>>2]|0);i=e;return}function JB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;c[a>>2]=c[(KB(f)|0)>>2];c[a+4>>2]=c[(LB(g)|0)>>2];i=e;return}function KB(a){a=a|0;i=i;return a|0}function LB(a){a=a|0;i=i;return a|0}function MB(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;J=c[d+4>>2]|0;i=b;return c[d>>2]|0}function NB(a){a=a|0;var b=0;b=i;OB(a+300|0);OB(a+288|0);OB(a+276|0);OB(a+264|0);OB(a+252|0);OB(a+240|0);PB(a);i=b;return}function OB(a){a=a|0;var b=0;b=i;zC(a);i=b;return}function PB(a){a=a|0;var b=0;b=i;QB(a,74728);IQ(a+104|0);i=b;return}function QB(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];UB(a+4|0);i=d;return}function RB(a){a=a|0;var b=0;b=i;PB(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function SB(a){a=a|0;var b=0;b=i;PB(a);b_(a);i=b;return}function TB(a){a=a|0;var b=0;b=i;SB(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function UB(a){a=a|0;var b=0;b=i;VB(a);i=b;return}function VB(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=74856;uB(b)|0;do{if((a[b+96|0]|0)!=0){e=c[b+32>>2]|0;if((e|0)==0){break}c_(e)}}while(0);do{if((a[b+97|0]|0)!=0){e=c[b+56>>2]|0;if((e|0)==0){break}c_(e)}}while(0);RQ(b);i=d;return}function WB(a){a=a|0;var b=0;b=i;UB(a);b_(a);i=b;return}function XB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;ee[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=xC(d)|0;c[b+68>>2]=f;d=b+98|0;g=a[d]|0;h=yC(f)|0;a[d]=h&1;if((g&255|0)==(h&1|0)){i=e;return}h=b;$Q(h,0,0,0);eR(h,0,0);h=b+96|0;g=(a[h]|0)!=0;if((a[d]|0)!=0){d=b+32|0;do{if(g){f=c[d>>2]|0;if((f|0)==0){break}c_(f)}}while(0);f=b+97|0;a[h]=a[f]|0;j=b+60|0;c[b+52>>2]=c[j>>2];k=b+56|0;c[d>>2]=c[k>>2];c[j>>2]=0;c[k>>2]=0;a[f]=0;i=e;return}do{if(!g){f=b+32|0;k=c[f>>2]|0;if((k|0)==(b+44|0)){break}j=c[b+52>>2]|0;c[b+60>>2]=j;c[b+56>>2]=k;a[b+97|0]=0;c[f>>2]=a_(j)|0;a[h]=1;i=e;return}}while(0);h=c[b+52>>2]|0;c[b+60>>2]=h;c[b+56>>2]=a_(h)|0;a[b+97|0]=1;i=e;return}function YB(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=f+8|0;c[g>>2]=e;e=b;$Q(e,0,0,0);eR(e,0,0);j=b+96|0;do{if((a[j]|0)!=0){k=c[b+32>>2]|0;if((k|0)==0){break}c_(k)}}while(0);k=b+97|0;do{if((a[k]|0)!=0){l=c[b+56>>2]|0;if((l|0)==0){break}c_(l)}}while(0);l=c[g>>2]|0;m=b+52|0;c[m>>2]=l;do{if(l>>>0>8){n=a[b+98|0]|0;if(n<<24>>24==0|(d|0)==0){c[b+32>>2]=a_(l)|0;a[j]=1;o=n;break}else{c[b+32>>2]=d;a[j]=0;o=n;break}}else{c[b+32>>2]=b+44;c[m>>2]=8;a[j]=0;o=a[b+98|0]|0}}while(0);if(!(o<<24>>24==0)){c[b+60>>2]=0;c[b+56>>2]=0;a[k]=0;i=f;return e|0}c[h>>2]=8;o=c[(uC(g,h)|0)>>2]|0;c[b+60>>2]=o;if((d|0)!=0&o>>>0>7){c[b+56>>2]=d;a[k]=0;i=f;return e|0}else{c[b+56>>2]=a_(o)|0;a[k]=1;i=f;return e|0}return 0}function ZB(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g;j=g+8|0;k=g+24|0;l=k;m=c[b+68>>2]|0;if((m|0)==0){n=Ac(4)|0;AZ(n);Pd(n|0,122136,127)}n=qC(m)|0;m=b+64|0;do{if((c[m>>2]|0)!=0){o=(n|0)>0;if(!(o|(d|0)==0&(e|0)==0)){break}if((ee[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}if(!(f>>>0<3)){yA(a,-1,-1);i=g;return}p=c[m>>2]|0;if(o){o=Q_(n|0,((n|0)<0)<<31>>31|0,d|0,e|0)|0;q=o}else{q=0}if((Tc(p|0,q|0,f|0)|0)==0){p=vb(c[m>>2]|0)|0;yA(j,p,((p|0)<0)<<31>>31);p=b+72|0;o=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=o;o=h;r=l;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];tC(j,h);r=a;o=j;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];i=g;return}else{yA(a,-1,-1);i=g;return}}}while(0);yA(a,-1,-1);i=g;return}function _B(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=f;h=b+64|0;do{if((c[h>>2]|0)!=0){if((ee[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}j=c[h>>2]|0;k=MB(d)|0;if((Tc(j|0,k|0,0)|0)==0){sC(g,d);k=f;j=c[k+4>>2]|0;l=b+72|0;c[l>>2]=c[k>>2];c[l+4>>2]=j;j=a;l=d;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=e;return}else{yA(a,-1,-1);i=e;return}}}while(0);yA(a,-1,-1);i=e;return}



function Mw(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+88|0;f=e;j=e+24|0;k=e+72|0;l=d+0|0;m=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=ec(b|0,36704)|0;m=d;c[m>>2]=l;if((l|0)==0){n=Sd(c[(Kc()|0)>>2]|0)|0;i=e;return n|0}c[d+4>>2]=wd(b|0)|0;c[d+36>>2]=0;b=f;l=d+44|0;o=f;p=f+12|0;q=f+16|0;r=f+4|0;s=f+8|0;f=j;t=k;u=d+8|0;v=d+12|0;w=d+16|0;x=d+20|0;y=d+28|0;z=d+24|0;A=d+32|0;B=d+40|0;d=1;C=0;a:while(1){D=pb(b|0,20,1,c[m>>2]|0)|0;a[l]=1;if((D|0)!=1){n=36712;E=131;break}D=c[o>>2]|0;if((D|0)!=(c[36680+(C<<2)>>2]|0)){if(!((C|0)>3&(D|0)==10)){n=36736;E=131;break}a[l]=0}F=c[p>>2]|0;if(F>>>0>1){n=36760;E=131;break}G=Jw(D)|0;if((G|0)==-1){n=36792;E=131;break}D=c[q>>2]|0;H=VZ(D)|0;if((pb(H|0,D|0,1,c[m>>2]|0)|0)!=1){n=36840;E=131;break}if((a[H+(D+ -1)|0]|0)!=0){n=36864;E=131;break}D=c[r>>2]|0;I=c[s>>2]|0;J=fa(fa(fa(D,G)|0,I)|0,F+1|0)|0;if((t_(H,c[36656+(C<<2)>>2]|0)|0)!=0){n=36888;E=131;break}WZ(H);H=37464;b:do{switch(C|0){case 3:{F=fa(I<<2,D)|0;K=VZ(F)|0;if((pb(K|0,F|0,1,c[m>>2]|0)|0)!=1){E=52;break a}do{if(d<<24>>24==1){if((I|0)==0){break}F=c[v>>2]|0;G=0;do{L=fa(D,G)|0;c[F+(G<<4)+8>>2]=(c[K+(L<<2)>>2]|0)==1;c[F+(G<<4)+12>>2]=c[K+(L+1<<2)>>2];G=G+1|0;}while(G>>>0<I>>>0)}else if(d<<24>>24==0){if((D|0)==0){break}G=c[v>>2]|0;F=0;do{c[G+(F<<4)+8>>2]=(c[K+(F<<2)>>2]|0)==1;c[G+(F<<4)+12>>2]=c[K+(D+F<<2)>>2];F=F+1|0;}while(F>>>0<D>>>0)}}while(0);WZ(K);_b(c[v>>2]|0,c[u>>2]|0,16,53);M=d;E=130;break};case 4:{if(d<<24>>24==1){if((D|0)==0){n=37152;E=131;break a}if(!((I+ -1|0)>>>0<2)){n=37208;E=131;break a}c[w>>2]=D;F=fa(I,D)|0;if((a[l]|0)==1){G=VZ(F<<3)|0;c[x>>2]=G;if((pb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=37248;E=131;break a}}else{G=VZ(F<<2)|0;c[x>>2]=VZ(fa(D<<3,I)|0)|0;if((pb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=37248;E=131;break a}if((F|0)!=0){L=c[x>>2]|0;N=0;do{h[L+(N<<3)>>3]=+g[G+(N<<2)>>2];N=N+1|0;}while(N>>>0<F>>>0)}WZ(G)}F=c[w>>2]|0;if(!(F>>>0>1)){M=1;E=130;break b}N=(I|0)==2;L=1;while(1){if(N){O=c[x>>2]|0;if(+h[O+(L<<3)>>3]!=+h[O+(F+L<<3)>>3]){n=37280;E=131;break a}}O=L+1|0;if(O>>>0<F>>>0){L=O}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){P=d;E=129;break b}if((I|0)==0){n=37152;E=131;break a}if(!((D+ -1|0)>>>0<2)){n=37360;E=131;break a}c[w>>2]=I;L=fa(I,D)|0;if((a[l]|0)==1){F=VZ(L<<3)|0;c[x>>2]=VZ(fa(D<<3,I)|0)|0;if((pb(F|0,J|0,1,c[m>>2]|0)|0)!=1){n=37248;E=131;break a}if((D|0)!=0){N=0;do{G=c[x>>2]|0;O=0;do{h[G+((fa(I,N)|0)+O<<3)>>3]=+h[F+((fa(D,O)|0)+N<<3)>>3];O=O+1|0;}while(O>>>0<I>>>0);N=N+1|0;}while(N>>>0<D>>>0)}WZ(F)}else{N=VZ(L<<2)|0;c[x>>2]=VZ(fa(D<<3,I)|0)|0;if((pb(N|0,J|0,1,c[m>>2]|0)|0)!=1){n=37248;E=131;break a}if((D|0)!=0){O=0;do{G=c[x>>2]|0;Q=0;do{h[G+((fa(I,O)|0)+Q<<3)>>3]=+g[N+((fa(D,Q)|0)+O<<2)>>2];Q=Q+1|0;}while(Q>>>0<I>>>0);O=O+1|0;}while(O>>>0<D>>>0)}WZ(N)}O=c[w>>2]|0;if(!(O>>>0>1)){M=d;E=130;break b}L=(D|0)==2;F=1;while(1){if(L){Q=c[x>>2]|0;if(+h[Q+(F<<3)>>3]!=+h[Q+(O+F<<3)>>3]){n=37280;E=131;break a}}Q=F+1|0;if(Q>>>0<O>>>0){F=Q}else{M=d;E=130;break}}break};case 1:{F=d<<24>>24==0;c[u>>2]=F?D:I;O=VZ((F?D:I)<<4)|0;c[v>>2]=O;c:do{if(d<<24>>24==1){if((I|0)==0){R=0;break}L=D+1|0;N=O;Q=0;while(1){c[N+(Q<<4)>>2]=VZ(L)|0;if((pb(c[(c[v>>2]|0)+(Q<<4)>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=37088;E=131;break a}a[(c[(c[v>>2]|0)+(Q<<4)>>2]|0)+D|0]=0;G=c[v>>2]|0;c[G+(Q<<4)+8>>2]=-1;c[G+(Q<<4)+12>>2]=-1;Lw(c[G+(Q<<4)>>2]|0);G=Q+1|0;if(!(G>>>0<I>>>0)){R=I;break c}N=c[v>>2]|0;Q=G}}else{R=I}}while(0);if(!F){M=d;E=130;break b}O=fa(D,R)|0;S=VZ(O+1|0)|0;if((pb(S|0,O|0,1,c[m>>2]|0)|0)!=1){E=33;break a}if((D|0)!=0){O=R+1|0;Q=(R|0)==0;N=0;do{L=VZ(O)|0;c[(c[v>>2]|0)+(N<<4)>>2]=L;if(!Q){L=0;do{G=a[S+((fa(D,L)|0)+N)|0]|0;a[(c[(c[v>>2]|0)+(N<<4)>>2]|0)+L|0]=G;L=L+1|0;}while(L>>>0<R>>>0)}a[(c[(c[v>>2]|0)+(N<<4)>>2]|0)+R|0]=0;L=c[v>>2]|0;c[L+(N<<4)+8>>2]=-1;c[L+(N<<4)+12>>2]=-1;Lw(c[L+(N<<4)>>2]|0);N=N+1|0;}while(N>>>0<D>>>0)}WZ(S);M=0;E=130;break};case 5:{if(d<<24>>24==1){c[y>>2]=I;if(I>>>0<2){n=37400;E=131;break a}c[z>>2]=D;c[A>>2]=vb(c[m>>2]|0)|0;c[B>>2]=XZ(c[z>>2]<<1,4)|0;if((Tc(c[m>>2]|0,J|0,1)|0)==-1){n=37432;E=131;break a}else{M=1;E=130;break b}}else if(!(d<<24>>24==0)){n=0;E=131;break a}c[y>>2]=D;if(D>>>0<2){n=37400;E=131;break a}c[z>>2]=I;c[A>>2]=vb(c[m>>2]|0)|0;c[B>>2]=XZ(c[z>>2]<<1,4)|0;N=fa(I,D)|0;if((a[l]|0)==1){Q=VZ(N<<3)|0;if((pb(Q|0,J|0,1,c[m>>2]|0)|0)!=1){n=37432;E=131;break a}if((I|0)!=0){O=D<<3;F=(D|0)==0;L=D<<3;G=0;do{T=VZ(O)|0;c[(c[B>>2]|0)+(G<<2)>>2]=T;if(!F){T=Q+(fa(L,G)|0)|0;z_(c[(c[B>>2]|0)+(G<<2)>>2]|0,T|0,L|0)|0}G=G+1|0;}while(G>>>0<I>>>0)}G=c[z>>2]|0;L=G<<1;if(G>>>0<L>>>0){F=D<<3;O=(D|0)==0;T=G;do{U=VZ(F)|0;c[(c[B>>2]|0)+(T<<2)>>2]=U;if(!O){U=c[B>>2]|0;V=c[U+(T-G<<2)>>2]|0;W=c[U+(T<<2)>>2]|0;U=0;do{h[W+(U<<3)>>3]=-+h[V+(U<<3)>>3];U=U+1|0;}while(U>>>0<D>>>0)}T=T+1|0;}while(T>>>0<L>>>0)}WZ(Q)}else{L=VZ(N<<2)|0;if((pb(L|0,J|0,1,c[m>>2]|0)|0)!=1){n=37432;E=131;break a}if((I|0)!=0){T=D<<3;G=(D|0)==0;O=0;do{F=VZ(T)|0;c[(c[B>>2]|0)+(O<<2)>>2]=F;if(!G){F=c[(c[B>>2]|0)+(O<<2)>>2]|0;U=0;do{h[F+(U<<3)>>3]=+g[L+((fa(D,O)|0)+U<<2)>>2];U=U+1|0;}while(U>>>0<D>>>0)}O=O+1|0;}while(O>>>0<I>>>0)}O=c[z>>2]|0;G=O<<1;if(O>>>0<G>>>0){T=D<<3;N=(D|0)==0;Q=O;do{U=VZ(T)|0;c[(c[B>>2]|0)+(Q<<2)>>2]=U;if(!N){U=c[B>>2]|0;F=c[U+(Q-O<<2)>>2]|0;V=c[U+(Q<<2)>>2]|0;U=0;do{h[V+(U<<3)>>3]=-+h[F+(U<<3)>>3];U=U+1|0;}while(U>>>0<D>>>0)}Q=Q+1|0;}while(Q>>>0<G>>>0)}WZ(L)}if((Tc(c[m>>2]|0,J|0,1)|0)==-1){n=37432;E=131;break a}else{M=d;E=130}break};case 0:{if((D|0)!=4){n=36912;E=131;break a}if((I|0)!=11){n=36952;E=131;break a}if((pb(f|0,44,1,c[m>>2]|0)|0)==1){X=0}else{n=36992;E=131;break a}while(1){G=0;do{a[k+G|0]=a[j+((G<<2)+X)|0]|0;G=G+1|0;}while(G>>>0<11);a[k+11|0]=0;if((X|0)==3){break}G=X+1|0;if(G>>>0<4){X=G}else{M=d;E=130;break b}}if((u_(t,c[9140]|0,8)|0)==0){M=1;E=130;break b}if((u_(t,c[9146]|0,9)|0)==0){M=0;E=130}else{n=37024;E=131;break a}break};case 2:{if(d<<24>>24==1){if((I|0)==0){P=1;E=129;break b}L=D+1|0;G=0;while(1){Q=VZ(L)|0;c[(c[v>>2]|0)+(G<<4)+4>>2]=Q;if((pb(c[(c[v>>2]|0)+(G<<4)+4>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=37088;E=131;break a}a[(c[(c[v>>2]|0)+(G<<4)+4>>2]|0)+D|0]=0;Q=G+1|0;if(Q>>>0<I>>>0){G=Q}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){P=d;E=129;break b}G=fa(D,I)|0;Y=VZ(G+1|0)|0;if((pb(Y|0,G|0,1,c[m>>2]|0)|0)!=1){E=46;break a}if((D|0)!=0){G=I+1|0;L=(I|0)==0;Q=0;do{O=VZ(G)|0;c[(c[v>>2]|0)+(Q<<4)+4>>2]=O;if(!L){O=0;do{N=a[Y+((fa(D,O)|0)+Q)|0]|0;a[(c[(c[v>>2]|0)+(Q<<4)+4>>2]|0)+O|0]=N;O=O+1|0;}while(O>>>0<I>>>0)}a[(c[(c[v>>2]|0)+(Q<<4)+4>>2]|0)+I|0]=0;Q=Q+1|0;}while(Q>>>0<D>>>0)}WZ(Y);M=0;E=130;break};default:{n=H;E=131;break a}}}while(0);if((E|0)==129){E=0;d=P;C=C+1|0;continue}else if((E|0)==130){E=0;H=C+1|0;if((H|0)<6){d=M;C=H;continue}else{n=0;E=131;break}}}if((E|0)==33){WZ(S);n=37088;i=e;return n|0}else if((E|0)==46){WZ(Y);n=37088;i=e;return n|0}else if((E|0)==52){WZ(K);n=37120;i=e;return n|0}else if((E|0)==131){i=e;return n|0}return 0}function Nw(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=Ad(e|0,c[a+12>>2]|0,c[a+8>>2]|0,16,53)|0;i=d;return b|0}function Ow(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=(d|0)>-1?d:0-d|0;j=(d|0)<0;do{if(j){k=c[b+24>>2]|0;l=k+f|0;m=k}else{if((d|0)==0){n=37504;o=n;p=37552;q=p;r=37576;s=r;$a(o|0,q|0,399,s|0)}else{l=f;m=c[b+24>>2]|0;break}}}while(0);d=l+ -1|0;l=b+24|0;if(f>>>0>m>>>0){n=37504;o=n;p=37552;q=p;r=37576;s=r;$a(o|0,q|0,399,s|0)}s=b+40|0;q=c[(c[s>>2]|0)+(d<<2)>>2]|0;if((q|0)!=0){t=q;i=e;return t|0}q=b+28|0;o=c[q>>2]|0;r=VZ(o<<3)|0;p=r;a:do{if((a[b+44|0]|0)==1){if((o|0)==0){break}n=b;m=b+32|0;k=0;while(1){Tc(c[n>>2]|0,(c[m>>2]|0)+ -8+((fa(c[l>>2]|0,k)|0)+f<<3)|0,0)|0;u=r+(k<<3)|0;if((pb(u|0,8,1,c[n>>2]|0)|0)!=1){break}if(j){h[u>>3]=-+h[u>>3]}k=k+1|0;if(!(k>>>0<(c[q>>2]|0)>>>0)){break a}}WZ(r);t=0;i=e;return t|0}else{k=VZ(o<<2)|0;b:do{if((o|0)==0){v=0}else{n=b;m=b+32|0;u=0;while(1){Tc(c[n>>2]|0,(c[m>>2]|0)+ -4+((fa(c[l>>2]|0,u)|0)+f<<2)|0,0)|0;w=u+1|0;if((pb(k+(u<<2)|0,4,1,c[n>>2]|0)|0)!=1){break}x=c[q>>2]|0;if(w>>>0<x>>>0){u=w}else{v=x;break b}}WZ(k);WZ(r);t=0;i=e;return t|0}}while(0);u=(v|0)==0;do{if(j){if(u){break}else{y=0}do{h[r+(y<<3)>>3]=-+g[k+(y<<2)>>2];y=y+1|0;}while(y>>>0<v>>>0)}else{if(u){break}else{z=0}do{h[r+(z<<3)>>3]=+g[k+(z<<2)>>2];z=z+1|0;}while(z>>>0<v>>>0)}}while(0);WZ(k)}}while(0);c[(c[s>>2]|0)+(d<<2)>>2]=p;t=c[(c[s>>2]|0)+(d<<2)>>2]|0;i=e;return t|0}function Pw(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;j=i;i=i+8|0;k=j;l=(e|0)>-1?e:0-e|0;m=(e|0)<0;do{if(m){n=c[d+24>>2]|0;o=n+l|0;p=n}else{if((e|0)==0){q=37504;r=q;s=37552;t=s;u=37600;v=u;$a(r|0,t|0,519,v|0)}else{o=l;p=c[d+24>>2]|0;break}}}while(0);if(l>>>0>p>>>0){q=37504;r=q;s=37552;t=s;u=37600;v=u;$a(r|0,t|0,519,v|0)}v=c[(c[d+40>>2]|0)+(o+ -1<<2)>>2]|0;if((v|0)!=0){h[b>>3]=+h[v+(f<<3)>>3];w=0.0;i=j;return+w}v=d;o=c[v>>2]|0;t=c[d+32>>2]|0;r=l+ -1+(fa(p,f)|0)|0;do{if((a[d+44|0]|0)==1){Tc(o|0,t+(r<<3)|0,0)|0;f=(pb(b|0,8,1,c[v>>2]|0)|0)!=1;if(f|m^1){w=f?1.0:0.0;i=j;return+w}else{x=+h[b>>3];break}}else{Tc(o|0,t+(r<<2)|0,0)|0;if((pb(k|0,4,1,c[v>>2]|0)|0)!=1){w=1.0;i=j;return+w}y=+g[k>>2];h[b>>3]=y;if(m){x=y;break}else{w=0.0}i=j;return+w}}while(0);h[b>>3]=-x;w=0.0;i=j;return+w}function Qw(a,b,d,e,f,g,j){a=+a;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0;k=i;l=d+ -1|0;d=0;while(1){m=((l-d|0)/2|0)+d|0;n=+h[b+(m<<3)>>3];if(n==a){o=n;p=m;q=3;break}r=n<a;s=r?m+1|0:d;t=r?l:m+ -1|0;if((t|0)>(s|0)){l=t;d=s}else{break}}if((q|0)==3){while(1){q=0;if((p|0)>=(l|0)){break}d=p+1|0;n=+h[b+(d<<3)>>3];if(o==n){o=n;p=d;q=3}else{break}}c[e>>2]=p;h[f>>3]=1.0;c[g>>2]=-1;u=0.0;h[j>>3]=u;i=k;return}do{if((t|0)==(s|0)){if(+h[b+(s<<3)>>3]<a){v=s+1|0;w=s;break}else{v=s;w=s+ -1|0;break}}else{v=t;w=s}}while(0);c[e>>2]=v;c[g>>2]=w;o=+h[b+(w<<3)>>3];n=(a-o)/(+h[b+(v<<3)>>3]-o);h[f>>3]=n;u=1.0-n;h[j>>3]=u;i=k;return}function Rw(a){a=a|0;i=i;return+(+h[c[a+20>>2]>>3])}function Sw(a){a=a|0;i=i;return+(+h[(c[a+20>>2]|0)+(c[a+16>>2]<<3)>>3])}function Tw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;f=i;i=i+48|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;if((c[d+8>>2]|0)!=0){o=c[d+12>>2]|0;if((o|0)<0){p=-+h[(c[b+20>>2]|0)+(~o<<3)>>3]}else{p=+h[(c[b+20>>2]|0)+(o+ -1<<3)>>3]}h[a>>3]=p;q=0;i=f;return q|0}if(+Sw(b)<e){q=1;i=f;return q|0}if(+Rw(b)>e){q=1;i=f;return q|0}if((Ow(b,1)|0)==0){q=1;i=f;return q|0}Qw(e,c[c[b+40>>2]>>2]|0,c[b+28>>2]|0,m,g,n,j);o=c[n>>2]|0;if((o|0)==-1){q=~~+Pw(a,b,c[d+12>>2]|0,c[m>>2]|0);i=f;return q|0}n=c[m>>2]|0;m=d+12|0;d=c[m>>2]|0;if((n|0)==-1){q=~~+Pw(a,b,d,o);i=f;return q|0}if(+Pw(k,b,d,n)!=0.0){q=1;i=f;return q|0}if(+Pw(l,b,c[m>>2]|0,o)!=0.0){q=1;i=f;return q|0}h[a>>3]=+h[g>>3]*+h[k>>3]+ +h[j>>3]*+h[l>>3];q=0;i=f;return q|0}function Uw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=VZ(20)|0;jw(0,(f|0)!=0|0,37632,e);c[f+8>>2]=0;c[f+12>>2]=0;e=(a|0)<1?1:a;c[f+16>>2]=e;c[f+4>>2]=b;a=XZ(e,b)|0;c[f>>2]=a;jw(0,(a|0)!=0|0,37632,d);i=d;return f|0}function Vw(a){a=a|0;var b=0;b=i;WZ(c[a>>2]|0);WZ(a);i=b;return}function Ww(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=a+12|0;jw(0,(c[h>>2]|0)>0|0,37648,g);g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=1-g;c[f+8>>2]=g+ -1;jw(0,(g|0)>(b|0)|0,37672,f);f=c[h>>2]|0;c[e>>2]=b;c[e+4>>2]=1-f;c[e+8>>2]=f+ -1;jw(0,(0-f|0)<(b|0)|0,37672,e);e=(c[a>>2]|0)+(fa(c[a+4>>2]|0,((c[a+8>>2]|0)+b|0)%(c[a+16>>2]|0)|0)|0)|0;i=d;return e|0}function Xw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=a+16|0;e=a+4|0;f=XZ(c[d>>2]<<1,c[e>>2]|0)|0;jw(0,(f|0)!=0|0,37632,b);g=a+12|0;if((c[g>>2]|0)>0){h=c[e>>2]|0;j=0;do{k=f+(fa(h,j)|0)|0;l=Ww(a,j)|0;h=c[e>>2]|0;z_(k|0,l|0,h|0)|0;j=j+1|0;}while((j|0)<(c[g>>2]|0))}g=a;WZ(c[g>>2]|0);c[g>>2]=f;c[d>>2]=c[d>>2]<<1;c[a+8>>2]=0;i=b;return}function Yw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+16|0;f=c[e>>2]|0;g=a+12|0;h=c[g>>2]|0;if((f|0)<(h+1|0)){Xw(a);j=c[e>>2]|0;k=c[g>>2]|0}else{j=f;k=h}h=c[a+4>>2]|0;z_((c[a>>2]|0)+(fa(h,(k+(c[a+8>>2]|0)|0)%(j|0)|0)|0)|0,b|0,h|0)|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function Zw(a){a=a|0;i=i;return c[a+12>>2]|0}function _w(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=a+12|0;jw(0,(c[j>>2]|0)>0|0,37648,h);h=c[j>>2]|0;c[g>>2]=b;c[g+4>>2]=0;c[g+8>>2]=h+ -1;jw(0,(h|0)>(b|0)|0,37672,g);g=(c[j>>2]|0)+ -1|0;c[f>>2]=b;c[f+4>>2]=0;c[f+8>>2]=g;jw(0,b>>>31^1,37672,f);f=a+8|0;g=c[a+16>>2]|0;c[f>>2]=((fa(g+ -1|0,b)|0)+(c[f>>2]|0)|0)%(g|0)|0;if((d|0)==0){i=e;return}if((c[j>>2]|0)>0){k=0}else{i=e;return}do{c[d+(k<<2)>>2]=Ww(a,k)|0;k=k+1|0;}while((k|0)<(c[j>>2]|0));i=e;return}function $w(a){a=a|0;i=i;return c[(c[9426]|0)+(a<<2)>>2]|0}function ax(a){a=a|0;i=i;return c[(c[9428]|0)+(a<<2)>>2]|0}function bx(a){a=a|0;i=i;return c[(c[9430]|0)+(a<<2)>>2]|0}function cx(a){a=a|0;i=i;return c[(c[9432]|0)+(a<<2)>>2]|0}function dx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=(c[9428]|0)+(a<<2)|0;e=c[d>>2]|0;f=(c[9430]|0)+(a<<2)|0;g=c[f>>2]|0;h=c[(c[9426]|0)+(a<<2)>>2]|0;if((h|0)==0){i=b;return}c[d>>2]=(e|0)!=0&e>>>0<h>>>0?e:h;c[f>>2]=g>>>0>h>>>0?g:h;i=b;return}function ex(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[9434]|0;e=+fx(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function fx(a,b){a=a|0;b=b|0;i=i;return+(+(a|0)+ +(b|0)*1.0e-9)}function gx(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[9436]|0;e=+fx(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function hx(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[9438]|0;e=+fx(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function ix(a){a=a|0;i=i;return 0}function jx(a){a=a|0;var b=0,d=0;b=i;db(4,(c[9440]|0)+(a<<3)|0)|0;d=(c[9426]|0)+(a<<2)|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function kx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[9434]|0;f=e+(a<<3)|0;g=c[9438]|0;h=g+(a<<3)|0;c[h>>2]=(c[h>>2]|0)+(c[f>>2]|0);h=e+(a<<3)+4|0;e=g+(a<<3)+4|0;c[e>>2]=(c[e>>2]|0)+(c[h>>2]|0);e=(c[9432]|0)+(a<<2)|0;c[e>>2]=(c[e>>2]|0)+(c[(c[9426]|0)+(a<<2)>>2]|0);e=c[9436]|0;g=e+(a<<3)|0;lx(d,c[g>>2]|0,c[e+(a<<3)+4>>2]|0,c[f>>2]|0,c[h>>2]|0);h=d;d=c[h+4>>2]|0;f=g;c[f>>2]=c[h>>2];c[f+4>>2]=d;dx(a);d=c[9434]|0;c[d+(a<<3)>>2]=0;c[d+(a<<3)+4>>2]=0;c[(c[9426]|0)+(a<<2)>>2]=0;i=b;return}function lx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(ox(b,d,e,f)|0)<0;if(h){j=e;k=f}else{j=b;k=d}d=a;c[d>>2]=j;c[d+4>>2]=k;i=g;return}function mx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+8|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;db(4,d|0)|0;e=c[9440]|0;f=c[9434]|0;g=f+(a<<3)|0;h=(c[d>>2]|0)-(c[e+(a<<3)>>2]|0)+(c[g>>2]|0)|0;c[g>>2]=h;j=f+(a<<3)+4|0;f=(c[d+4>>2]|0)-(c[e+(a<<3)+4>>2]|0)+(c[j>>2]|0)|0;c[j>>2]=f;if((f|0)<=999999999){i=b;return}c[g>>2]=h+1;c[j>>2]=~~(+(f|0)+-1.0e9);i=b;return}function nx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((a|0)<33){i=b;return}d=XZ(a,8)|0;c[9434]=d;e=XZ(a,8)|0;c[9436]=e;f=XZ(a,8)|0;c[9438]=f;g=XZ(a,8)|0;c[9440]=g;h=XZ(a,4)|0;c[9426]=h;j=XZ(a,4)|0;c[9432]=j;k=a<<2;l=VZ(k)|0;c[9428]=l;m=XZ(a,4)|0;c[9430]=m;B_(l|0,-1,k|0)|0;if((d|0)==0){$a(37768,37784,393,37800)}if((e|0)==0){$a(37808,37784,394,37800)}if((f|0)==0){$a(37824,37784,395,37800)}if((g|0)==0){$a(37840,37784,396,37800)}if((h|0)==0){$a(37856,37784,397,37800)}if((l|0)==0){$a(37880,37784,398,37800)}if((m|0)==0){$a(37904,37784,399,37800)}if((j|0)==0){$a(37928,37784,400,37800)}else{i=b;return}}function ox(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;i=i;return((a|0)==(c|0)?b-d|0:a-c|0)|0}function px(a){a=a|0;var b=0;b=i;WZ(c[a+12>>2]|0);WZ(c[a+4>>2]|0);WZ(c[a+8>>2]|0);i=b;return}function qx(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;z=~y;h[5543]=.5;h[5529]=1.0;h[5566]=.25;h[5541]=2.0;h[5568]=6.283185307179586;A=w+ -1-(c[b>>2]|0)|0;c[11094]=A;B=c[d>>2]|0;c[11024]=1;if((B|0)>=1){C=1;while(1){h[p+(C+ -1+(c[b>>2]|0)<<3)>>3]=0.0;D=C+1|0;c[11024]=D;if((C|0)<(B|0)){C=D}else{break}}}c[11022]=1;if((A|0)>=1){C=1;while(1){B=fa(C,w)|0;E=+h[j+(B+x+(c[n>>2]|0)<<3)>>3];h[5544]=E;if((C|0)<(c[k>>2]|0)){F=-E;h[5544]=F;G=F}else{G=E}D=c[d>>2]|0;c[11024]=1;a:do{if((D|0)>=1){E=G;H=1;while(1){I=p+(H+ -1+(c[b>>2]|0)<<3)|0;h[I>>3]=E*+h[j+(H+x+B<<3)>>3]+ +h[I>>3];I=H+1|0;c[11024]=I;if((H|0)>=(D|0)){break a}E=+h[5544];H=I}}}while(0);D=C+1|0;c[11022]=D;if((C|0)<(A|0)){C=D}else{break}}}C=c[b>>2]|0;h[5548]=+h[p+(C+ -1+(c[n>>2]|0)<<3)>>3];h[5513]=0.0;h[5515]=0.0;h[5519]=0.0;h[5576]=0.0;c[11020]=1;if((C|0)<1){J=0.0;K=0.0;L=0.0}else{G=0.0;A=1;while(1){D=A+ -1|0;B=o+(D<<3)|0;E=+h[B>>3];h[5513]=G+E*E;E=+h[f+((c[n>>2]|0)+x+(fa(A,w)|0)<<3)>>3];H=e+(D<<3)|0;F=E- +h[H>>3];I=s+(D<<3)|0;h[I>>3]=F;E=+h[5515]+ +h[B>>3]*F;h[5515]=E;F=+h[I>>3];M=+h[5519]+F*F;h[5519]=M;F=+h[H>>3];h[5576]=+h[5576]+F*F;H=A+1|0;c[11020]=H;F=+h[5513];if((A|0)<(C|0)){A=H;G=F}else{J=M;K=F;L=E;break}}}G=L*L;do{if(G>K*.99*J){A=c[n>>2]|0;c[11090]=A;E=G/J;h[5565]=E;C=c[d>>2]|0;c[11024]=1;if((C|0)<1){N=J;O=L;P=A}else{F=J;M=L;Q=E;H=A;A=1;while(1){do{if((A|0)==(c[m>>2]|0)){R=F;S=M;T=Q;U=H}else{h[5573]=0.0;h[5575]=0.0;I=c[b>>2]|0;c[11020]=1;if((I|0)<1){W=0.0;Z=0.0}else{E=0.0;_=0.0;B=1;while(1){$=+h[f+((fa(B,w)|0)+x+A<<3)>>3];aa=$- +h[e+(B+ -1<<3)>>3];h[5542]=aa;ba=_+aa*+h[o+(B+ -1<<3)>>3];h[5573]=ba;ca=E+aa*aa;h[5575]=ca;if((B|0)<(I|0)){B=B+1|0;_=ba;E=ca}else{break}}c[11020]=I+1;W=ca;Z=ba}E=Z*Z/W;if(!(E<Q)){R=F;S=M;T=Q;U=H;break}c[11090]=A;h[5565]=E;h[5515]=Z;h[5519]=W;R=W;S=Z;T=E;U=A}}while(0);B=A+1|0;c[11024]=B;if((A|0)<(C|0)){F=R;M=S;Q=T;H=U;A=B}else{N=R;O=S;P=U;break}}}A=c[b>>2]|0;c[11020]=1;if((A|0)<1){da=O;ea=N;ga=K;break}else{ha=1}while(1){Q=+h[f+((fa(ha,w)|0)+x+P<<3)>>3];H=ha+ -1|0;h[s+(H<<3)>>3]=Q- +h[e+(H<<3)>>3];if((ha|0)<(A|0)){ha=ha+1|0}else{break}}c[11020]=A+1;da=+h[5515];ea=+h[5519];ga=+h[5513]}else{da=L;ea=J;ga=K}}while(0);K=ga*ea-da*da;h[5564]=K;c[11118]=0;h[5572]=0.0;ha=(y<<1)+z|0;P=(y<<2)+z|0;U=(y*3|0)+z|0;H=(y*5|0)+z|0;ea=da;da=ga;ga=K;C=1;while(1){c[11118]=C;K=+h[5529]/+V(+ga);h[5544]=K;h[5567]=0.0;h[5569]=0.0;B=c[b>>2]|0;c[11020]=1;if((B|0)<1){ia=da;ja=0.0;ka=0.0}else{J=ea;L=da;N=K;D=1;la=0;while(1){ma=s+(la<<3)|0;h[ma>>3]=N*(L*+h[ma>>3]-J*+h[o+(la<<3)>>3]);ma=D+ -1|0;na=e+(ma<<3)|0;oa=+h[5567]+ +h[na>>3]*+h[o+(ma<<3)>>3];h[5567]=oa;pa=+h[5569]+ +h[na>>3]*+h[s+(ma<<3)>>3];h[5569]=pa;if((D|0)>=(B|0)){break}ma=D;J=+h[5515];L=+h[5513];N=+h[5544];D=D+1|0;la=ma}c[11020]=B+1;ia=+h[5513];ja=pa;ka=oa}N=+h[5543];L=ka*N*ka;h[5560]=L;J=ja*N*ja;h[5561]=J;h[5520]=J+(L+ia*(+h[5576]+ia*N));N=+h[5541];h[44168>>3]=N*ka*ia;h[44176>>3]=N*ja*ia;h[44184>>3]=L-J;h[44192>>3]=ka*ja;la=44200|0;c[la+0>>2]=0;c[la+4>>2]=0;c[la+8>>2]=0;c[la+12>>2]=0;c[la+16>>2]=0;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=0;c[11020]=10;la=c[d>>2]|0;c[11024]=1;if((la|0)>=1){D=1;while(1){h[5560]=0.0;h[5561]=0.0;h[5562]=0.0;A=c[b>>2]|0;c[11020]=1;if((A|0)<1){qa=0.0;ra=0.0}else{ma=D+x|0;J=0.0;L=0.0;N=0.0;na=1;while(1){K=+h[f+((fa(na,w)|0)+x+D<<3)>>3];sa=N+K*+h[o+(na+ -1<<3)>>3];h[5560]=sa;ta=f+(ma+(fa(na,w)|0)<<3)|0;ua=na+ -1|0;va=L+ +h[ta>>3]*+h[s+(ua<<3)>>3];h[5561]=va;K=J+ +h[ta>>3]*+h[e+(ua<<3)>>3];h[5562]=K;if((na|0)<(A|0)){na=na+1|0;N=sa;L=va;J=K}else{break}}c[11020]=A+1;qa=va;ra=sa}h[t+(D+ -1<<3)>>3]=+h[5566]*(ra*ra+qa*qa);h[t+(ha+D<<3)>>3]=+h[5560]*+h[5562];h[t+(U+D<<3)>>3]=+h[5561]*+h[5562];J=+h[5560];L=+h[5561];h[t+(P+D<<3)>>3]=+h[5566]*(J*J-L*L);h[t+(H+D<<3)>>3]=+h[5543]*+h[5560]*+h[5561];na=D+1|0;c[11024]=na;if((D|0)<(la|0)){D=na}else{break}}}D=c[b>>2]|0;c[11020]=1;if((D|0)>=1){la=1;while(1){B=(c[d>>2]|0)+la|0;c[11032]=B;h[t+(B+ -1<<3)>>3]=0.0;na=la+ -1|0;h[t+(ha+B<<3)>>3]=+h[o+(na<<3)>>3];h[t+(U+B<<3)>>3]=+h[s+(na<<3)>>3];h[t+(P+B<<3)>>3]=0.0;h[t+(H+B<<3)>>3]=0.0;B=la+1|0;c[11020]=B;if((la|0)<(D|0)){la=B}else{break}}}c[11028]=1;la=1;do{D=c[d>>2]|0;c[11036]=D;if((la&-2|0)==2){B=c[l>>2]|0;c[11036]=B;wa=B}else{wa=D}D=c[d>>2]|0;c[11024]=1;if((D|0)>=1){B=fa(la,y)|0;na=1;while(1){h[u+(na+z+B<<3)>>3]=0.0;if((na|0)<(D|0)){na=na+1|0}else{break}}c[11024]=D+1}na=c[11094]|0;c[11022]=1;if((na|0)<1){xa=la}else{B=1;A=la;while(1){h[5540]=0.0;ma=c[d>>2]|0;c[11024]=1;if((ma|0)<1){ya=0.0;za=A}else{ua=fa(la,y)|0;L=0.0;ta=1;while(1){J=+h[j+(ta+x+(fa(B,w)|0)<<3)>>3];Aa=L+J*+h[t+(ta+z+ua<<3)>>3];h[5540]=Aa;if((ta|0)<(ma|0)){ta=ta+1|0;L=Aa}else{break}}c[11024]=ma+1;ya=Aa;za=la}if((B|0)<(c[k>>2]|0)){L=-ya;h[5540]=L;Ba=L}else{Ba=ya}ta=c[d>>2]|0;c[11024]=1;if((ta|0)>=1){ua=fa(B,w)|0;I=fa(za,y)|0;L=Ba;Ca=1;while(1){Da=u+(Ca+z+I<<3)|0;h[Da>>3]=L*+h[j+(Ca+x+ua<<3)>>3]+ +h[Da>>3];if((Ca|0)>=(ta|0)){break}L=+h[5540];Ca=Ca+1|0}c[11024]=ta+1}Ca=B+1|0;c[11022]=Ca;if((B|0)<(na|0)){B=Ca;A=za}else{xa=za;break}}}do{if((wa|0)==(c[l>>2]|0)){A=c[d>>2]|0;c[11024]=1;if((A|0)<1){break}else{Ea=1}while(1){h[5540]=0.0;B=c[b>>2]|0;c[11022]=1;if((B|0)<1){Fa=fa(xa,y)|0;Ga=0.0}else{L=0.0;na=1;while(1){J=+h[g+((fa(na,y)|0)+z+Ea<<3)>>3];D=fa(xa,y)|0;N=L+J*+h[t+(na+z+(c[d>>2]|0)+D<<3)>>3];h[5540]=N;Ca=na+1|0;c[11022]=Ca;if((na|0)<(B|0)){na=Ca;L=N}else{Fa=D;Ga=N;break}}}na=u+(Ea+z+Fa<<3)|0;h[na>>3]=Ga+ +h[na>>3];na=Ea+1|0;c[11024]=na;if((Ea|0)<(A|0)){Ea=na}else{break}}}}while(0);A=c[b>>2]|0;c[11022]=1;if((A|0)>=1){ta=1;while(1){h[5540]=0.0;c[11020]=1;if((wa|0)<1){Ha=fa(xa,y)|0;Ia=0.0}else{na=fa(ta,y)|0;B=fa(xa,y)|0;L=0.0;D=1;while(1){Ca=D+z|0;Ja=L+ +h[g+(Ca+na<<3)>>3]*+h[t+(Ca+B<<3)>>3];h[5540]=Ja;if((D|0)<(wa|0)){D=D+1|0;L=Ja}else{break}}c[11020]=wa+1;Ha=B;Ia=Ja}h[u+((c[d>>2]|0)+z+ta+Ha<<3)>>3]=Ia;D=ta+1|0;c[11022]=D;if((ta|0)<(A|0)){ta=D}else{break}}}la=xa+1|0;c[11028]=la;}while((la|0)<6);la=c[l>>2]|0;c[11024]=1;h[5540]=0.0;c[11020]=1;L=+h[5543];if((la|0)<1){Ka=L}else{N=L;ta=1;while(1){L=0.0;A=1;do{D=(fa(A,y)|0)+z+ta|0;h[44240+(A+ -1<<3)>>3]=N*+h[u+(D<<3)>>3]*+h[t+(D<<3)>>3];L=+h[44240+(A+ -1<<3)>>3]+L;h[5540]=L;A=A+1|0;}while((A|0)<6);h[5520]=+h[5520]- +h[5530]-L;A=ta+ -1|0;D=u+(A<<3)|0;na=ha+ta|0;Ca=t+(na<<3)|0;ua=u+(na<<3)|0;na=t+(A<<3)|0;J=+h[D>>3]*+h[Ca>>3]+ +h[ua>>3]*+h[na>>3];h[5560]=J;A=P+ta|0;I=t+(A<<3)|0;ma=u+(A<<3)|0;K=+h[ua>>3]*+h[I>>3]+ +h[ma>>3]*+h[Ca>>3];h[5561]=K;A=U+ta|0;Da=u+(A<<3)|0;La=H+ta|0;Ma=t+(La<<3)|0;Na=u+(La<<3)|0;La=t+(A<<3)|0;O=+h[Da>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[La>>3];h[5562]=O;h[44168>>3]=+h[44168>>3]-J-N*(O+K);h[44200>>3]=+h[44200>>3]-N*(K-O);O=+h[D>>3]*+h[La>>3]+ +h[Da>>3]*+h[na>>3];h[5560]=O;K=+h[ua>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[Ca>>3];h[5561]=K;J=+h[Da>>3]*+h[I>>3]+ +h[ma>>3]*+h[La>>3];h[5562]=J;h[44176>>3]=+h[44176>>3]-O-N*(K-J);h[44208>>3]=+h[44208>>3]-N*(K+J);J=+h[D>>3]*+h[I>>3]+ +h[ma>>3]*+h[na>>3];h[5560]=J;h[44184>>3]=+h[44256>>3]+(+h[44184>>3]-J- +h[44248>>3]);J=+h[D>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[na>>3];h[5560]=J;K=+h[ua>>3]*+h[La>>3]+ +h[Da>>3]*+h[Ca>>3];h[5561]=K;Oa=+h[5543];h[44192>>3]=+h[44192>>3]-J-K*Oa;h[44216>>3]=+h[44216>>3]- +h[44264>>3]+ +h[44272>>3];K=+h[ma>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[I>>3];h[5560]=K;h[44224>>3]=+h[44224>>3]-Oa*K;h[5540]=0.0;if((ta|0)<(la|0)){N=Oa;ta=ta+1|0}else{break}}c[11024]=la+1;c[11020]=1;Ka=Oa}N=0.0;ta=1;do{K=+h[u+((fa(ta,y)|0)+z+(c[n>>2]|0)<<3)>>3];h[44240+(ta+ -1<<3)>>3]=Ka*K*K;N=+h[44240+(ta+ -1<<3)>>3]+N;h[5540]=N;ta=ta+1|0;c[11020]=ta;}while((ta|0)<6);K=+h[5548];h[5550]=K*+h[5520]+ +h[5530]+N;J=+h[5541];ta=c[n>>2]|0;la=u+(ta+ -1<<3)|0;I=u+(ha+ta<<3)|0;O=J*+h[la>>3]*+h[I>>3];h[5560]=O;Na=u+(P+ta<<3)|0;S=+h[I>>3]*+h[Na>>3];h[5561]=S;Ma=u+(U+ta<<3)|0;ma=u+(H+ta<<3)|0;R=+h[Ma>>3]*+h[ma>>3];h[5562]=R;T=R+(K*+h[44168>>3]+O+S);h[44408>>3]=T;O=K*+h[44200>>3]+S-R;h[44440>>3]=O;R=J*+h[la>>3]*+h[Ma>>3];h[5560]=R;S=+h[I>>3]*+h[ma>>3];h[5561]=S;Z=+h[Ma>>3]*+h[Na>>3];h[5562]=Z;h[44416>>3]=K*+h[44176>>3]+R+S-Z;h[44448>>3]=K*+h[44208>>3]+S+Z;Z=J*+h[la>>3]*+h[Na>>3];h[5560]=Z;R=+h[44248>>3]+(Z+K*+h[44184>>3])- +h[44256>>3];h[44424>>3]=R;Z=J*+h[la>>3]*+h[ma>>3];h[5560]=Z;h[44432>>3]=Z+K*+h[44192>>3]+ +h[I>>3]*+h[Ma>>3];J=K*+h[44216>>3]+ +h[44264>>3]- +h[44272>>3];h[44456>>3]=J;h[44464>>3]=+h[5548]*+h[44224>>3]+ +h[Na>>3]*+h[ma>>3];K=+h[5550]+T+R+O+J;h[5540]=K;h[5570]=K;h[5571]=K;c[11126]=0;J=+h[5568]/50.0;h[5544]=J;h[5530]=+h[5529];c[11020]=1;O=K;ma=0;R=K;T=S;S=Z;Na=1;while(1){Pa=+(Na|0)*J;Z=+X(+Pa);h[44248>>3]=Z;W=+Y(+Pa);h[44256>>3]=W;ba=W;ca=Z;G=W;W=Z;Ma=4;while(1){Z=ca*W-ba*G;h[44240+(Ma+ -1<<3)>>3]=Z;Q=+h[44248>>3]*G+ +h[44256>>3]*W;h[44240+(Ma<<3)>>3]=Q;I=Ma+2|0;if((I|0)>=9){Qa=1;Ra=0.0;break}ba=+h[44256>>3];ca=+h[44248>>3];Ma=I;W=Z;G=Q}do{Ma=Qa+ -1|0;Ra=Ra+ +h[44400+(Ma<<3)>>3]*+h[44240+(Ma<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<10);if(!(Ra>=0.0)){Sa=-Ra}else{Sa=Ra}if(!(R>=0.0)){Ta=-R}else{Ta=R}do{if(Sa>Ta){h[5571]=Ra;c[11126]=Na;h[5560]=O;Ua=Ra;Va=T;Wa=O;Xa=Na}else{if((Na|0)!=(ma+1|0)){Ua=R;Va=T;Wa=S;Xa=ma;break}h[5561]=Ra;Ua=R;Va=Ra;Wa=S;Xa=ma}}while(0);if((Na|0)>48){break}else{O=Ra;ma=Xa;R=Ua;T=Va;S=Wa;Na=Na+1|0}}c[11022]=10;h[5540]=Ra;h[5549]=Pa;h[5574]=O;c[11020]=50;if((Xa|0)==49){h[5561]=K;Ya=Wa;Za=K}else if((Xa|0)==0){h[5560]=Ra;Ya=Ra;Za=Va}else{Ya=Wa;Za=Va}h[5546]=0.0;if(Ya!=Za){S=Ya-Ua;h[5560]=S;T=Za-Ua;h[5561]=T;R=+h[5543]*(S-T)/(S+T);h[5546]=R;_a=R}else{_a=0.0}R=J*(+(Xa|0)+_a);h[5549]=R;T=+X(+R);h[44248>>3]=T;S=+Y(+R);h[44256>>3]=S;c[11022]=4;R=S;N=T;G=S;S=T;Na=4;while(1){T=N*S-R*G;h[44240+(Na+ -1<<3)>>3]=T;W=+h[44248>>3]*G+ +h[44256>>3]*S;h[44240+(Na<<3)>>3]=W;ma=Na+2|0;if((ma|0)>=9){break}R=+h[44256>>3];N=+h[44248>>3];Na=ma;S=T;G=W}h[r>>3]=0.0;h[5571]=0.0;c[11022]=1;Na=1;do{ma=Na+ -1|0;Ma=44240+(ma<<3)|0;h[r>>3]=+h[r>>3]+ +h[44160+(ma<<3)>>3]*+h[Ma>>3];h[5571]=+h[5571]+ +h[44400+(ma<<3)>>3]*+h[Ma>>3];Na=Na+1|0;}while((Na|0)<10);c[11022]=10;Na=c[l>>2]|0;c[11024]=1;if((Na|0)>=1){Ma=1;while(1){h[q+(Ma+ -1<<3)>>3]=0.0;ma=1;do{G=+h[u+((fa(ma,y)|0)+z+Ma<<3)>>3];I=q+(Ma+ -1<<3)|0;h[I>>3]=+h[I>>3]+G*+h[44240+(ma+ -1<<3)>>3];ma=ma+1|0;}while((ma|0)<6);if((Ma|0)<(Na|0)){Ma=Ma+1|0}else{break}}c[11022]=6;c[11024]=Na+1}h[5539]=+h[q+((c[n>>2]|0)+ -1<<3)>>3];h[5513]=0.0;h[5560]=0.0;h[5561]=0.0;Ma=c[b>>2]|0;c[11020]=1;if((Ma|0)<1){$a=0.0;ab=0.0}else{ma=1;while(1){I=ma+ -1|0;la=o+(I<<3)|0;h[la>>3]=+h[44248>>3]*+h[la>>3]+ +h[44256>>3]*+h[s+(I<<3)>>3];I=ma+ -1|0;la=o+(I<<3)|0;ta=p+(I<<3)|0;h[ta>>3]=+h[e+(I<<3)>>3]+ +h[la>>3];G=+h[la>>3];h[5513]=+h[5513]+G*G;bb=+h[5560]+ +h[la>>3]*+h[ta>>3];h[5560]=bb;G=+h[ta>>3];cb=+h[5561]+G*G;h[5561]=cb;if((ma|0)<(Ma|0)){ma=ma+1|0}else{break}}c[11020]=Ma+1;$a=cb;ab=bb}ma=c[11118]|0;Na=c[b>>2]|0;if((ma|0)>=(Na|0)){break}if((ma|0)>1){G=+h[5572];S=+h[5570];h[5572]=G>=S?G:S}S=+h[5571];if(!(S>=0.0)){db=-S}else{db=S}G=+h[5572];if(!(G>=0.0)){eb=-G}else{eb=G}if(db<=eb*1.1){break}h[5572]=S;c[11020]=1;b:do{if((Na|0)>=1){S=$a;G=ab;ta=1;while(1){la=ta+ -1|0;N=G*+h[e+(la<<3)>>3]+S*+h[o+(la<<3)>>3]- +h[q+(la+(c[d>>2]|0)<<3)>>3];h[5544]=N;R=+h[5539]*+h[g+((c[n>>2]|0)+z+(fa(ta,y)|0)<<3)>>3];h[s+(la<<3)>>3]=R+N*+h[5548];la=ta+1|0;c[11020]=la;if((ta|0)>=(Na|0)){break b}S=+h[5561];G=+h[5560];ta=la}}}while(0);Na=c[d>>2]|0;c[11024]=1;if((Na|0)>=1){Ma=1;while(1){h[5540]=0.0;ta=c[b>>2]|0;c[11022]=1;if((ta|0)<1){fb=0.0}else{G=0.0;la=1;while(1){S=+h[f+((fa(la,w)|0)+x+Ma<<3)>>3];gb=G+S*+h[p+(la+ -1<<3)>>3];h[5540]=gb;if((la|0)<(ta|0)){la=la+1|0;G=gb}else{break}}c[11022]=ta+1;fb=gb}la=c[b>>2]|0;G=fb*(+h[5539]*+h[p+(la+ -1+Ma<<3)>>3]- +h[5548]*+h[q+(Ma+ -1<<3)>>3]);h[5544]=G;c[11020]=1;if((la|0)>=1){S=G;I=1;while(1){G=S*+h[f+((fa(I,w)|0)+x+Ma<<3)>>3];Ca=s+(I+ -1<<3)|0;h[Ca>>3]=+h[Ca>>3]+G;if((I|0)>=(la|0)){break}S=+h[5544];I=I+1|0}c[11020]=la+1}I=Ma+1|0;c[11024]=I;if((Ma|0)<(Na|0)){Ma=I}else{break}}}h[5519]=0.0;h[5515]=0.0;Ma=c[b>>2]|0;c[11020]=1;if((Ma|0)<1){hb=0.0;ib=0.0}else{S=0.0;G=0.0;Na=1;while(1){N=+h[s+(Na+ -1<<3)>>3];jb=G+N*N;h[5519]=jb;I=Na+ -1|0;kb=S+ +h[o+(I<<3)>>3]*+h[s+(I<<3)>>3];h[5515]=kb;if((Na|0)<(Ma|0)){Na=Na+1|0;G=jb;S=kb}else{break}}c[11020]=Ma+1;hb=kb;ib=jb}S=+h[5513];G=S*ib-hb*hb;h[5564]=G;if(!(G>=S*1.0e-8*ib)){break}ea=hb;da=S;ga=G;C=ma+1|0}a[44136]=1;C=c[l>>2]|0;c[11024]=1;if((C|0)<1){lb=44232;mb=+h[5529];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}else{vb=1}while(1){h[p+(vb+ -1<<3)>>3]=0.0;l=1;do{ga=+h[t+((fa(l,y)|0)+z+vb<<3)>>3];s=p+(vb+ -1<<3)|0;h[s>>3]=+h[s>>3]+ga*+h[44240+(l+ -1<<3)>>3];l=l+1|0;}while((l|0)<6);if((vb|0)<(C|0)){vb=vb+1|0}else{break}}c[11022]=6;c[11024]=C+1;lb=44232;mb=+h[5529];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}function rx(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;l=~y;h[5596]=.5;h[5592]=1.0;h[5608]=6.283185307179586;z=+h[n>>3];h[5605]=z*z;A=w+ -1-(c[b>>2]|0)|0;c[11198]=A;c[11206]=0;B=c[d>>2]|0;c[11158]=1;if((B|0)>=1){C=1;while(1){h[q+(C+ -1<<3)>>3]=0.0;if((C|0)<(B|0)){C=C+1|0}else{break}}c[11158]=B+1}c[11156]=1;B=c[m>>2]|0;if((A|0)<1){D=B}else{C=B;B=1;while(1){E=fa(B,w)|0;z=+h[j+(E+x+C<<3)>>3];h[5597]=z;if((B|0)<(c[k>>2]|0)){F=-z;h[5597]=F;G=F}else{G=z}H=c[d>>2]|0;c[11158]=1;if((H|0)>=1){z=G;I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]+z*+h[j+(I+x+E<<3)>>3];if((I|0)>=(H|0)){break}z=+h[5597];I=I+1|0}c[11158]=H+1}I=B+1|0;c[11156]=I;E=c[m>>2]|0;if((B|0)<(A|0)){C=E;B=I}else{D=E;break}}}h[p>>3]=+h[q+(D+ -1<<3)>>3];h[5580]=0.0;D=c[b>>2]|0;c[11154]=1;if((D|0)>=1){p=1;while(1){B=c[m>>2]|0;G=+h[f+((fa(p,w)|0)+x+B<<3)>>3];C=p+ -1|0;A=o+(C<<3)|0;h[A>>3]=G- +h[e+(C<<3)>>3];h[r+(C<<3)>>3]=+h[g+(B+l+(fa(p,y)|0)<<3)>>3];h[s+(C<<3)>>3]=0.0;G=+h[A>>3];h[5580]=+h[5580]+G*G;A=p+1|0;c[11154]=A;if((p|0)<(D|0)){p=A}else{break}}}p=c[d>>2]|0;c[11158]=1;if((p|0)>=1){D=1;while(1){h[5597]=0.0;h[5595]=0.0;y=c[b>>2]|0;c[11156]=1;if((y|0)<1){K=0.0;L=0.0}else{l=D+x|0;G=0.0;z=0.0;g=1;while(1){F=+h[f+((fa(g,w)|0)+x+D<<3)>>3];M=z+F*+h[e+(g+ -1<<3)>>3];h[5597]=M;F=+h[f+(l+(fa(g,w)|0)<<3)>>3];N=G+F*+h[o+(g+ -1<<3)>>3];h[5595]=N;if((g|0)<(y|0)){g=g+1|0;z=M;G=N}else{break}}c[11156]=y+1;K=M;L=N}g=q+(D+ -1<<3)|0;G=+h[g>>3]*K;h[5597]=G;h[5595]=+h[g>>3]*L;g=c[b>>2]|0;c[11154]=1;if((g|0)>=1){l=D+x|0;z=G;H=1;while(1){G=z*+h[f+((fa(H,w)|0)+x+D<<3)>>3];m=r+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;G=+h[5595]*+h[f+(l+(fa(H,w)|0)<<3)>>3];m=s+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;if((H|0)>=(g|0)){break}z=+h[5597];H=H+1|0}c[11154]=g+1}H=D+1|0;c[11158]=H;if((D|0)<(p|0)){D=H}else{break}}}h[5581]=0.0;h[5583]=0.0;h[5590]=0.0;D=c[b>>2]|0;c[11154]=1;if((D|0)<1){O=0.0;P=0.0;Q=0.0}else{L=0.0;K=0.0;N=0.0;p=1;while(1){M=+h[r+(p+ -1<<3)>>3];R=N+M*M;h[5581]=R;e=p+ -1|0;H=o+(e<<3)|0;S=K+ +h[H>>3]*+h[r+(e<<3)>>3];h[5583]=S;T=L+ +h[H>>3]*+h[s+(e<<3)>>3];h[5590]=T;if((p|0)<(D|0)){p=p+1|0;N=R;K=S;L=T}else{break}}c[11154]=D+1;O=R;P=T;Q=S}S=+h[5580];T=+h[n>>3]/+V(+S);if(Q*P<0.0){U=-T}else{U=T}h[5601]=U;h[5597]=0.0;if(Q*Q>S*.99*O){h[5597]=+h[5592]}if(!(Q>=0.0)){W=-Q}else{W=Q}if(!(P>=0.0)){Z=-P}else{Z=P}P=U*(W+ +h[5596]*U*Z);h[5593]=P;if(O*+h[5605]<P*P*.01){h[5597]=+h[5592]}n=c[b>>2]|0;c[11154]=1;if((n|0)<1){_=0}else{P=U;D=1;p=0;while(1){e=o+(p<<3)|0;h[e>>3]=P*+h[e>>3];e=D+ -1|0;H=s+(e<<3)|0;U=+h[5601]*+h[H>>3];h[H>>3]=U;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+ +h[5597]*U;if((D|0)>=(n|0)){break}e=D;P=+h[5601];D=D+1|0;p=e}c[11154]=n+1;_=0}while(1){n=_+1|0;c[11206]=n;h[5580]=0.0;h[5583]=0.0;h[5584]=0.0;p=c[b>>2]|0;c[11154]=1;if((p|0)<1){$=0.0;aa=0.0;ba=0.0}else{P=0.0;U=0.0;O=0.0;D=1;while(1){Z=+h[o+(D+ -1<<3)>>3];ca=O+Z*Z;h[5580]=ca;e=D+ -1|0;H=t+(e<<3)|0;da=U+ +h[o+(e<<3)>>3]*+h[H>>3];h[5583]=da;Z=+h[H>>3];ea=P+Z*Z;h[5584]=ea;if((D|0)<(p|0)){D=D+1|0;O=ca;U=da;P=ea}else{break}}c[11154]=p+1;$=da;aa=ea;ba=ca}P=ba*aa-$*$;h[5597]=P;if(P<=ba*1.0e-8*aa){ga=88;break}U=+V(+P);h[5602]=U;D=c[b>>2]|0;c[11154]=1;if((D|0)>=1){P=U;U=$;O=ba;g=1;H=0;while(1){e=t+(H<<3)|0;h[e>>3]=(O*+h[e>>3]-U*+h[o+(H<<3)>>3])/P;h[u+(g+ -1<<3)>>3]=0.0;if((g|0)>=(D|0)){break}e=g;P=+h[5602];U=+h[5583];O=+h[5580];g=g+1|0;H=e}c[11154]=D+1}H=c[d>>2]|0;c[11158]=1;if((H|0)>=1){g=1;while(1){h[5595]=0.0;p=c[b>>2]|0;c[11156]=1;if((p|0)<1){ha=0.0}else{O=0.0;e=1;while(1){U=+h[f+((fa(e,w)|0)+x+g<<3)>>3];ia=O+U*+h[t+(e+ -1<<3)>>3];h[5595]=ia;if((e|0)<(p|0)){e=e+1|0;O=ia}else{break}}c[11156]=p+1;ha=ia}O=+h[q+(g+ -1<<3)>>3]*ha;h[5595]=O;e=c[b>>2]|0;c[11154]=1;if((e|0)>=1){U=O;l=1;while(1){O=U*+h[f+((fa(l,w)|0)+x+g<<3)>>3];y=u+(l+ -1<<3)|0;h[y>>3]=+h[y>>3]+O;if((l|0)>=(e|0)){break}U=+h[5595];l=l+1|0}c[11154]=e+1}l=g+1|0;c[11158]=l;if((g|0)<(H|0)){g=l}else{break}}}h[5585]=0.0;h[5586]=0.0;h[5587]=0.0;h[5588]=0.0;h[5589]=0.0;g=c[b>>2]|0;c[11154]=1;if((g|0)<1){ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0}else{U=0.0;O=0.0;P=0.0;Z=0.0;W=0.0;H=1;while(1){D=H+ -1|0;oa=W+ +h[t+(D<<3)>>3]*+h[u+(D<<3)>>3];h[5585]=oa;D=H+ -1|0;l=o+(D<<3)|0;p=r+(D<<3)|0;pa=Z+ +h[l>>3]*+h[p>>3];h[5586]=pa;y=t+(D<<3)|0;qa=P+ +h[y>>3]*+h[p>>3];h[5587]=qa;p=s+(D<<3)|0;ra=O+ +h[l>>3]*+h[p>>3];h[5588]=ra;sa=U+ +h[y>>3]*+h[p>>3];h[5589]=sa;if((H|0)<(g|0)){H=H+1|0;W=oa;Z=pa;P=qa;O=ra;U=sa}else{break}}c[11154]=g+1;ja=sa;ka=qa;la=pa;ma=ra;na=oa}U=+h[5596];O=U*na;h[5585]=O;P=U*ma-O;h[5588]=P;Z=O+la+P;h[5609]=Z;h[5611]=Z;h[5610]=Z;c[11208]=0;a[44656]=1;W=+h[5608]/50.0;h[5597]=W;c[11154]=1;H=0;Q=Z;S=Z;p=1;while(1){ta=+(p|0)*W;ua=+X(+ta);va=+Y(+ta);wa=O+ua*(la+ua*P)+va*(ka+ua*ja);if(!(wa>=0.0)){xa=-wa}else{xa=wa}if(!(Q>=0.0)){ya=-Q}else{ya=Q}do{if(xa>ya){h[5611]=wa;c[11208]=p;h[5606]=S;za=p;Aa=wa}else{if((p|0)!=(H+1|0)){za=H;Aa=Q;break}h[5607]=wa;za=H;Aa=Q}}while(0);e=p+1|0;if((e|0)<50){H=za;Q=Aa;p=e;S=wa}else{break}}h[5600]=ta;h[5591]=ua;h[5594]=va;h[5593]=wa;c[11154]=50;h[5610]=wa;if((za|0)==0){h[5606]=wa;ga=74}else if((za|0)==49){h[5607]=Z;Ba=Z}else{ga=74}if((ga|0)==74){ga=0;Ba=+h[5607]}h[5598]=0.0;S=+h[5606];if(S!=Ba){Q=S-Aa;h[5606]=Q;S=Ba-Aa;h[5607]=S;T=U*(Q-S)/(Q+S);h[5598]=T;Ca=T}else{Ca=0.0}T=W*(+(za|0)+Ca);h[5600]=T;S=+X(+T);h[5591]=S;Q=+Y(+T);h[5594]=Q;T=O+S*(la+S*P)+Q*(ka+S*ja);h[5593]=T;p=c[b>>2]|0;c[11154]=1;if((p|0)<1){Da=T}else{T=Q;Q=S;H=1;g=0;while(1){e=o+(g<<3)|0;h[e>>3]=Q*+h[e>>3]+T*+h[t+(g<<3)>>3];e=H+ -1|0;y=s+(e<<3)|0;S=+h[5591]*+h[y>>3]+ +h[5594]*+h[u+(e<<3)>>3];h[y>>3]=S;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+S;if((H|0)>=(p|0)){break}e=H;T=+h[5594];Q=+h[5591];H=H+1|0;g=e}c[11154]=p+1;Da=+h[5593]}if(!(Da>=0.0)){Ea=-Da}else{Ea=Da}Q=+h[5609];if(!(Q>=0.0)){Fa=-Q}else{Fa=Q}if(Ea<=Fa*1.1){ga=88;break}if((n|0)<(c[b>>2]|0)){_=n}else{ga=88;break}}if((ga|0)==88){i=v;return 0}return 0}function sx(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;n=i;a[45112]=1;a[45104]=1;c[45124>>2]=6;yO(45120)|0;e=c[d>>2]|0;c[11274]=1;if((e|0)>=1){d=1;do{PN(45240,b+(d+ -1)|0,1)|0;o=c[11274]|0;d=o+1|0;c[11274]=d;}while((o|0)<(e|0))}gO()|0;e=c[g>>2]|0;if((e|0)==1){c[45148>>2]=a[45104]&1?6:0;yO(45144)|0;PN(45240,h,4)|0;gO()|0;p=c[g>>2]|0}else{p=e}if((p|0)==2){c[45172>>2]=a[45104]&1?6:0;yO(45168)|0;PN(45240,h,4)|0;PN(45240,j,4)|0;gO()|0}j=c[k>>2]|0;if((j|0)==1){c[45196>>2]=a[45104]&1?6:0;yO(45192)|0;PN(45240,l,8)|0;gO()|0;q=c[k>>2]|0}else{q=j}if((q|0)==2){c[45220>>2]=a[45104]&1?6:0;yO(45216)|0;PN(45240,l,8)|0;PN(45240,m,8)|0;gO()|0}if((c[f>>2]|0)==2){xN(45248,0)|0}else{i=n;return 0}return 0}function tx(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0;y=i;i=i+8|0;z=y;A=c[k>>2]|0;a:do{if((A|0)==-1){EN(45320,45552,80,49);B=45624;C=45632;sx(45320,45608,45616,B,B,B,B,B,C,C,80)|0;EN(45320,45640,80,47);C=45624;B=45632;sx(45320,45688,45696,C,45704,n,C,C,B,B,80)|0;EN(45320,45712,80,41);B=45624;C=45632;sx(45320,45760,45768,45704,B,B,B,B,C,C,80)|0;i=y;return 0}else if((A|0)==1){c[q+36>>2]=c[q+40>>2];D=27}else if((A|0)==0){c[11316]=2;C=2;while(1){B=C+1|0;if(!((c[k+(C+ -1<<2)>>2]|0)>>>0<2)){D=210;break a}c[11316]=B;if((B|0)<12){C=B}else{break}}if((c[d>>2]|0)<1){EN(45320,47016,80,25);C=45624;B=45632;sx(45320,47048,45800,C,45704,d,C,C,B,B,80)|0;break}c[11380]=5;B=q+8|0;do{if((c[k+32>>2]|0)==0){E=5}else{C=c[B>>2]|0;c[11380]=C;if(!((C+ -1|0)>>>0>4)){E=C;break}EN(45320,47056,80,34);C=45624;F=45632;sx(45320,47096,45792,C,45704,45520,C,C,F,F,80)|0;break a}}while(0);c[B>>2]=E;b:do{if((c[k+20>>2]|0)==0){F=c[d>>2]|0;C=fa(F,F)|0;c[11366]=C;c[11378]=C+50+(fa((c[B>>2]|0)+4|0,c[d>>2]|0)|0);C=q+12|0;if((c[k+16>>2]|0)==0){c[C>>2]=2;break}else{c[C>>2]=1;break}}else{C=c[q>>2]|0;do{if((C|0)>=0){F=c[d>>2]|0;if((C|0)>=(F|0)){break}G=q+4|0;H=c[G>>2]|0;if(!((H|0)>-1&(H|0)<(F|0))){EN(45320,47880,80,52);I=45624;J=45632;sx(45320,47864,47936,I,45704,G,I,I,J,J,80)|0;break a}c[11366]=fa((C<<1|1)+H|0,F)|0;F=q+12|0;if((c[k+16>>2]|0)==0){c[F>>2]=5;H=c[d>>2]|0;J=fa((c[B>>2]|0)+4|0,H)|0;c[11378]=(((H|0)/((c[q>>2]|0)+1+(c[G>>2]|0)|0)|0)<<1)+52+(c[11366]|0)+J;break b}else{c[F>>2]=4;F=(fa((c[B>>2]|0)+4|0,c[d>>2]|0)|0)+50|0;c[11378]=F+(c[11366]|0);break b}}}while(0);EN(45320,47808,80,52);C=45624;F=45632;sx(45320,47864,47872,C,45704,q,C,C,F,F,80)|0;break a}}while(0);c[11370]=(c[d>>2]|0)+20;c[q+64>>2]=c[11366];if((c[p>>2]|0)<(c[11378]|0)){EN(45320,47104,80,60);B=45624;F=45632;sx(45320,47168,47176,B,45800,45512,p,B,F,F,80)|0;break}if((c[r>>2]|0)<(c[11370]|0)){EN(45320,47184,80,60);F=45624;B=45632;sx(45320,47168,47248,F,45800,45480,r,F,B,B,80)|0;break}if(+h[j>>3]==+h[e>>3]){D=227;break}if((c[w>>2]|0)<0){EN(45320,47992,80,24);B=45704;F=45624;C=45632;sx(45320,48024,48032,B,B,w,F,F,C,C,80)|0;break}do{if((c[k+24>>2]|0)!=0){K=+h[o+8>>3];h[5680]=K;if(!(K<=0.0)){break}EN(45320,47488,80,28);C=45624;sx(45320,46200,47520,C,C,C,C,45704,45440,45632,80)|0;break a}}while(0);c[q+60>>2]=0;C=q+36|0;c[C+0>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;c[C+12>>2]=0;c[n>>2]=1;D=27}else{D=210}}while(0);c:do{if((D|0)==27){a[45496]=0;K=+h[l>>3];h[5691]=K;L=+h[m>>3];h[5684]=L;r=c[d>>2]|0;c[11316]=1;do{if((r|0)>=1){p=k+4|0;E=0;A=1;M=L;N=K;while(1){if((c[p>>2]|0)==1){C=A+ -1|0;O=+h[l+(C<<3)>>3];h[5691]=O;P=+h[m+(C<<3)>>3];h[5684]=P;Q=O;R=P}else{Q=N;R=M}if(Q>0.0|R>0.0){a[45496]=1;S=1}else{S=E}if(Q<0.0){D=215;break}if(R<0.0){D=216;break}C=A+1|0;c[11316]=C;if((A|0)<(r|0)){E=S;A=C;M=R;N=Q}else{D=36;break}}if((D|0)==36){if(!S){break}A=c[d>>2]|0;E=A+51|0;c[11326]=E;p=E+(c[w>>2]|0)|0;c[11328]=p;E=p+(c[w>>2]|0)|0;c[11350]=E;C=E+(c[w>>2]|0)|0;c[11320]=C;F=C+(c[d>>2]|0)|0;c[11356]=F;B=F+(c[d>>2]|0)|0;c[11362]=B;c[11352]=(fa((c[q+8>>2]|0)+1|0,c[d>>2]|0)|0)+B;c[11376]=(c[q+64>>2]|0)+1;d:do{if((c[k>>2]|0)==1){F=o+64|0;h[5693]=+h[F>>3];a[45432]=0;h[5662]=+h[o+24>>3];J=o+16|0;h[5657]=+h[J>>3];do{if((c[w>>2]|0)!=0){ux(45800,v,w,d,45296,j,f,o+(C+ -1<<3)|0,o+(B+ -1<<3)|0,o+224|0,q+28|0,o+(A+50<<3)|0,o+(p+ -1<<3)|0,o+(E+ -1<<3)|0,x,45416,F,0,o,q,s,t)|0;if((c[11446]|0)>0){i=y;return 0}if((c[11354]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];G=45704;Rx(d,o+((c[11320]|0)+ -1<<3)|0,G,g,G)|0;a[45432]=1;D=197;break d}}while(0);do{if((c[k+24>>2]|0)!=0){N=+h[5657];if(!(N>=0.0)){T=-N}else{T=N}M=T/+h[o+8>>3];if(!(M>1.0)){break}h[5657]=N/M}}while(0);M=+h[e>>3];N=+h[j>>3];if(M==N){D=227;break c}P=+h[5657];if((M-N)*P>0.0){D=220;break}F=(c[k+8>>2]|0)==1;do{if((c[k+12>>2]|0)==1){O=+h[o>>3];h[5692]=O;U=+h[5662];V=U-O;G=V*P>0.0;do{if(F){if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U- +h[e>>3])<=0.0){break}H=q+28|0;I=o+((c[11362]|0)+ -1<<3)|0;X=o+224|0;if(P*(U-W)>0.0){zx(45296,j,f,g,d,H,I,X)|0;if((c[11446]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[45432]=1;D=197;break d}}else{Y=45296;zx(Y,Y,f,g,d,H,I,X)|0;if((c[11446]|0)>0){i=y;return 0}else{h[e>>3]=+h[5662];c[n>>2]=1;a[45432]=1;D=197;break d}}}else{if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U-W)<0.0){break}zx(45296,j,f,g,d,q+28|0,o+((c[11362]|0)+ -1<<3)|0,o+224|0)|0;if((c[11446]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[45432]=1;D=197;break d}}}while(0);h[z>>3]=V;if(!(V>=0.0)){Z=-V}else{Z=V}if(!(U>=0.0)){_=-U}else{_=U}if(!(P>=0.0)){$=-P}else{$=P}if(Z>+h[5693]*100.0*(_+$)){if(P*(U+P-O)<=0.0){break}W=O-U;h[5657]=W;h[J>>3]=W;break}zx(45296,45536,f,g,d,q+28|0,o+((c[11362]|0)+ -1<<3)|0,o+224|0)|0;if((c[11446]|0)>0){i=y;return 0}else{c[n>>2]=2;h[e>>3]=+h[5692];a[45432]=1;D=197;break d}}else{W=+h[5662];if(!F){if(P*(W-N)<0.0){break}zx(45296,j,f,g,d,q+28|0,o+((c[11362]|0)+ -1<<3)|0,o+224|0)|0;if((c[11446]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[45432]=1;D=197;break d}}if(P*(W-M)<=0.0){break}G=q+28|0;X=o+((c[11362]|0)+ -1<<3)|0;I=o+224|0;if(P*(W-N)>0.0){zx(45296,j,f,g,d,G,X,I)|0;if((c[11446]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[45432]=1;D=197;break d}}else{H=45296;zx(H,H,f,g,d,G,X,I)|0;if((c[11446]|0)>0){i=y;return 0}else{h[e>>3]=+h[5662];c[n>>2]=1;a[45432]=1;D=197;break d}}}}while(0);if(a[45432]&1){D=197}else{D=128}}else{h[5662]=+h[e>>3];c[n>>2]=1;wx(d,k+4|0,l,m,f,o+((c[11356]|0)+ -1<<3)|0,s,t)|0;F=c[d>>2]|0;c[11316]=1;e:do{if((F|0)>=1){J=c[11356]|0;I=1;while(1){X=I+1|0;if(+h[o+(I+ -2+J<<3)>>3]<=0.0){break}c[11316]=X;if((I|0)<(F|0)){I=X}else{break e}}EN(45320,47624,80,39);I=45624;J=45632;sx(45320,47296,47664,I,I,I,I,I,J,J,80)|0;break c}}while(0);U=+Dx(45776,1);h[5693]=U;F=o+64|0;h[F>>3]=U;U=+h[e>>3];if(!(U>=0.0)){aa=-U}else{aa=U}h[z>>3]=aa;U=+h[j>>3];if(!(U>=0.0)){ba=-U}else{ba=U}U=+h[5693]*4.0*(aa>=ba?aa:ba);h[5682]=U;O=+h[j>>3]- +h[e>>3];h[z>>3]=O;if(!(O>=0.0)){ca=-O}else{ca=O}if(ca<U){EN(45320,47672,80,60);J=45624;sx(45320,47168,47736,J,J,J,J,45800,j,e,80)|0;break c}do{if((c[k+28>>2]|0)==0){h[5661]=ca*.001;U=+xx(d,g,o+((c[11356]|0)+ -1<<3)|0,s,t);if(U>.5/+h[5661]){h[5661]=.5/U}h[z>>3]=+h[j>>3]- +h[e>>3];U=+BN(45288,z);h[5661]=U;da=U}else{U=+h[o+16>>3];h[5661]=U;if(U*(+h[j>>3]- +h[e>>3])<0.0){D=220;break d}if(!(U==0.0)){da=U;break}EN(45320,47576,80,29);J=45624;I=45632;sx(45320,47608,47616,J,J,J,J,J,I,I,80)|0;break c}}while(0);do{if((c[k+24>>2]|0)==0){ea=da}else{if(!(da>=0.0)){ga=-da}else{ga=da}U=ga/+h[o+8>>3];if(!(U>1.0)){ea=da;break}O=da/U;h[5661]=O;ea=O}}while(0);if((c[k+12>>2]|0)==0){ha=ea}else{O=+h[o>>3];h[5692]=O;U=+h[e>>3];V=O-U;if(V*ea<0.0){D=224;break}if(ea*(U+ea-O)>0.0){h[5661]=V;ia=V}else{ia=ea}if((O- +h[j>>3])*ia<0.0){D=218;break}else{ha=ia}}I=k+40|0;if((c[I>>2]|0)==0){ja=ha}else{yx(45296,f,g,d,b,u,45288,o+((c[11356]|0)+ -1<<3)|0,n,s,t,o+((c[11362]|0)+ -1<<3)|0,o+400|0,o+((c[11320]|0)+ -1<<3)|0,o+((c[11352]|0)+ -1<<3)|0,q,45456,F,k+36|0,45504)|0;if((c[11446]|0)>0){i=y;return 0}J=c[n>>2]|0;if((J|0)<0){ka=J;D=129;break}ja=+h[5661]}h[5657]=ja;h[o+16>>3]=ja;J=c[11362]|0;X=(c[d>>2]|0)+J|0;c[11372]=X;G=c[d>>2]|0;c[11316]=1;if((G|0)>=1){H=1;while(1){h[o+(H+ -2+J<<3)>>3]=+h[f+(H+ -1<<3)>>3];h[o+(H+ -2+X<<3)>>3]=+h[5657]*+h[g+(H+ -1<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[11316]=G+1}H=o+320|0;h[H>>3]=+h[e>>3];X=q+68|0;c[X>>2]=0;J=o+224|0;h[J>>3]=+h[5657];h[o+232>>3]=+h[5657]*2.0;Y=q+28|0;c[Y>>2]=1;if((c[w>>2]|0)==0){D=128;break}ux(45704,v,w,d,e,j,f,o+((c[11320]|0)+ -1<<3)|0,o+((c[11362]|0)+ -1<<3)|0,J,Y,o+((c[11326]|0)+ -1<<3)|0,o+((c[11328]|0)+ -1<<3)|0,o+((c[11350]|0)+ -1<<3)|0,x,45416,F,0,o,q,s,t)|0;if((c[11446]|0)>0){i=y;return 0}if((c[11354]|0)!=0){EN(45320,48040,80,47);la=45624;ma=45632;sx(45320,45688,48088,45704,la,la,la,la,ma,ma,80)|0;EN(45320,48096,80,38);ma=45624;la=45632;sx(45320,45848,48088,45704,ma,ma,ma,ma,la,la,80)|0;break c}if((c[w>>2]|0)==0){D=128;break}if((c[I>>2]|0)==0){D=128;break}ux(45792,v,w,d,45296,j,f,o+((c[11320]|0)+ -1<<3)|0,o+((c[11362]|0)+ -1<<3)|0,J,Y,o+((c[11326]|0)+ -1<<3)|0,o+((c[11328]|0)+ -1<<3)|0,o+((c[11350]|0)+ -1<<3)|0,x,45416,F,0,o,q,s,t)|0;if((c[11446]|0)>0){i=y;return 0}if((c[11354]|0)!=1){D=128;break}c[X>>2]=1;c[n>>2]=4;h[e>>3]=+h[H>>3];H=45704;Rx(d,o+((c[11320]|0)+ -1<<3)|0,H,g,H)|0;D=197}}while(0);if((D|0)==218){EN(45320,47416,80,54);E=45624;sx(45320,47472,47480,E,E,E,E,45800,45536,j,80)|0;break c}else if((D|0)==220){EN(45320,47528,80,34);E=45624;sx(45320,47096,47568,E,E,E,E,45800,j,e,80)|0;break c}else if((D|0)==224){EN(45320,47744,80,49);E=45624;sx(45320,45608,47800,E,E,E,E,45800,45536,e,80)|0;break c}f:while(1){if((D|0)==128){D=0;ka=c[n>>2]|0;D=129;continue}else if((D|0)==129){D=0;if((ka|0)==-12){na=-12;break}if(((c[q+40>>2]|0)-(c[q+36>>2]|0)|0)>=500){D=131;break}oa=k+4|0;wx(d,oa,l,m,o+((c[11362]|0)+ -1<<3)|0,o+((c[11356]|0)+ -1<<3)|0,s,t)|0;if((c[11446]|0)>0){D=233;break}E=c[d>>2]|0;c[11316]=1;p=c[11356]|0;if((E|0)>=1){A=1;while(1){B=A+1|0;if(!(+h[o+(A+ -2+p<<3)>>3]>0.0)){D=136;break f}c[11316]=B;if((A|0)<(E|0)){A=B}else{break}}}O=+xx(d,o+((c[11362]|0)+ -1<<3)|0,o+(p+ -1<<3)|0,s,t)*100.0;V=+h[5693];pa=O*V;h[5659]=pa;if(!(pa<=1.0)){D=138;break}O=+h[5662];if(!(O>=0.0)){qa=-O}else{qa=O}h[z>>3]=qa;O=+h[j>>3];if(!(O>=0.0)){ra=-O}else{ra=O}h[5682]=V*4.0*(qa>=ra?qa:ra);do{if((c[k+24>>2]|0)!=0){V=+h[5657];if(!(V>=0.0)){sa=-V}else{sa=V}O=sa/+h[o+8>>3];if(!(O>1.0)){break}h[5657]=V/O}}while(0);Ax(45296,f,g,d,b,u,45256,o+((c[11356]|0)+ -1<<3)|0,k,n,s,t,o+((c[11362]|0)+ -1<<3)|0,o+400|0,o+((c[11320]|0)+ -1<<3)|0,o+((c[11352]|0)+ -1<<3)|0,q,o+80|0,o+128|0,o+176|0,o+224|0,o+272|0,o+32|0,o+40|0,o+48|0,o+56|0,45456,o+64|0,q+20|0,q+16|0,q+24|0,q+28|0,q+32|0,k+36|0,45504)|0;if((c[11446]|0)>0){D=233;break}p=c[n>>2]|0;if((p|0)<0){na=p;break}do{if((c[w>>2]|0)!=0){ux(45792,v,w,d,45296,j,f,o+((c[11320]|0)+ -1<<3)|0,o+((c[11362]|0)+ -1<<3)|0,o+224|0,q+28|0,o+((c[11326]|0)+ -1<<3)|0,o+((c[11328]|0)+ -1<<3)|0,o+((c[11350]|0)+ -1<<3)|0,x,45416,o+64|0,0,o,q,s,t)|0;if((c[11446]|0)>0){D=233;break f}if((c[11354]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];p=45704;Rx(d,o+((c[11320]|0)+ -1<<3)|0,p,g,p)|0;D=197;continue f}}while(0);p=(c[k+8>>2]|0)!=0;O=+h[5662];V=+h[5657];U=(O- +h[j>>3])*V;if((c[k+12>>2]|0)==0){if(!p){if(U<0.0){D=128;continue}zx(45296,j,f,g,d,q+28|0,o+((c[11362]|0)+ -1<<3)|0,o+224|0)|0;if((c[11446]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(!(U>=0.0)){h[e>>3]=O;c[n>>2]=1;D=197;continue}zx(45296,j,f,g,d,q+28|0,o+((c[11362]|0)+ -1<<3)|0,o+224|0)|0;if((c[11446]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(p){if(U>=0.0){zx(45296,j,f,g,d,q+28|0,o+((c[11362]|0)+ -1<<3)|0,o+224|0)|0;if((c[11446]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}N=O- +h[5692];h[z>>3]=N;if(!(N>=0.0)){ta=-N}else{ta=N}if(!(O>=0.0)){ua=-O}else{ua=O}if(!(V>=0.0)){va=-V}else{va=V}if(!(ta<=+h[5693]*100.0*(ua+va))){h[e>>3]=O;c[n>>2]=1;D=197;continue}zx(45296,45536,f,g,d,q+28|0,o+((c[11362]|0)+ -1<<3)|0,o+224|0)|0;if((c[11446]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[5692];D=197;continue}if(!(U<0.0)){zx(45296,j,f,g,d,q+28|0,o+((c[11362]|0)+ -1<<3)|0,o+224|0)|0;if((c[11446]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}U=+h[5692];N=O-U;h[z>>3]=N;if(!(N>=0.0)){wa=-N}else{wa=N}if(!(O>=0.0)){xa=-O}else{xa=O}if(!(V>=0.0)){ya=-V}else{ya=V}if(!(wa<=+h[5693]*100.0*(xa+ya))){if(V*(O+V-U)<=0.0){D=128;continue}h[5657]=U-O;D=128;continue}else{zx(45296,45536,f,g,d,q+28|0,o+((c[11362]|0)+ -1<<3)|0,o+224|0)|0;if((c[11446]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[5692];D=197;continue}}else if((D|0)==197){D=0;h[o+24>>3]=+h[5662];h[o+16>>3]=+h[5657];h[o+328>>3]=+h[e>>3];D=233;break}}do{if((D|0)==131){c[n>>2]=-1;na=-1}else if((D|0)==136){c[n>>2]=-3;na=-3}else if((D|0)==138){if((c[oa>>2]|0)!=1){h[l>>3]=pa*+h[l>>3];h[m>>3]=+h[5659]*+h[m>>3];c[n>>2]=-2;na=-2;break}p=c[d>>2]|0;c[11316]=1;if((p|0)>=1){O=pa;A=1;E=0;while(1){F=l+(E<<3)|0;h[F>>3]=O*+h[F>>3];F=m+(A+ -1<<3)|0;h[F>>3]=+h[5659]*+h[F>>3];if((A|0)>=(p|0)){break}F=A;O=+h[5659];A=A+1|0;E=F}c[11316]=p+1}c[n>>2]=-2;na=-2}else if((D|0)==233){i=y;return 0}}while(0);E=0-na|0;c[11372]=E;switch(E|0){case 2:{EN(45320,45936,80,47);E=45624;sx(45320,45688,45984,E,E,E,E,45704,45296,45632,80)|0;EN(45320,45992,80,48);E=45624;A=45632;sx(45320,45920,46048,E,E,E,E,E,A,A,80)|0;EN(45320,46056,80,45);A=45624;E=45632;sx(45320,46104,46112,A,A,A,A,A,E,E,80)|0;break};case 3:{EN(45320,46120,80,38);E=45624;sx(45320,45848,46160,E,E,E,E,45704,45296,45632,80)|0;EN(45320,46168,80,28);E=45624;A=45632;sx(45320,46200,46208,E,E,E,E,E,A,A,80)|0;break};case 6:{EN(45320,46216,80,44);A=45624;sx(45320,46264,46272,A,A,A,A,45800,45296,45256,80)|0;EN(45320,46280,80,57);A=45624;E=45632;sx(45320,46344,46352,A,A,A,A,A,E,E,80)|0;break};case 7:{EN(45320,46216,80,44);E=45624;sx(45320,46264,46360,E,E,E,E,45800,45296,45256,80)|0;EN(45320,46368,80,48);E=45624;A=45632;sx(45320,45920,46424,E,E,E,E,E,A,A,80)|0;EN(45320,46432,80,28);A=45624;E=45632;sx(45320,46200,46464,A,A,A,A,A,E,E,80)|0;break};case 8:{EN(45320,46216,80,44);E=45624;sx(45320,46264,46472,E,E,E,E,45800,45296,45256,80)|0;EN(45320,46480,80,37);E=45624;A=45632;sx(45320,46520,46528,E,E,E,E,E,A,A,80)|0;break};case 9:{EN(45320,46216,80,44);A=45624;sx(45320,46264,46536,A,A,A,A,45800,45296,45256,80)|0;EN(45320,46544,80,49);A=45624;E=45632;sx(45320,45608,46600,A,A,A,A,A,E,E,80)|0;EN(45320,46608,80,38);E=45624;A=45632;sx(45320,45848,46648,E,E,E,E,E,A,A,80)|0;break};case 10:{EN(45320,46216,80,44);A=45624;sx(45320,46264,46656,A,A,A,A,45800,45296,45256,80)|0;EN(45320,46664,80,45);A=45624;E=45632;sx(45320,46104,46712,A,A,A,A,A,E,E,80)|0;EN(45320,46720,80,36);E=45624;A=45632;sx(45320,46760,46768,E,E,E,E,E,A,A,80)|0;break};case 11:{EN(45320,46776,80,40);A=45624;sx(45320,46824,46832,A,A,A,A,45800,45296,45256,80)|0;EN(45320,46840,80,36);A=45624;E=45632;sx(45320,46760,46880,A,A,A,A,A,E,E,80)|0;break};case 12:{EN(45320,46216,80,44);E=45624;sx(45320,46264,46888,E,E,E,E,45800,45296,45288,80)|0;EN(45320,46896,80,45);E=45624;A=45632;sx(45320,46104,46944,E,E,E,E,E,A,A,80)|0;break};case 5:case 4:{break};default:{EN(45320,45808,80,38);A=45624;sx(45320,45848,45856,A,A,A,A,45704,45296,45632,80)|0;EN(45320,45864,80,48);A=45624;E=45632;sx(45320,45920,45928,A,A,A,A,A,E,E,80)|0}}c[k>>2]=-1;h[e>>3]=+h[5662];h[o+24>>3]=+h[5662];h[o+16>>3]=+h[5657];i=y;return 0}else if((D|0)==215){EN(45320,47256,80,39);E=45624;A=45632;sx(45320,47296,47304,E,E,E,E,E,A,A,80)|0;break c}else if((D|0)==216){EN(45320,47312,80,39);A=45624;E=45632;sx(45320,47296,47352,A,A,A,A,A,E,E,80)|0;break c}}}while(0);EN(45320,47360,80,47);r=45624;E=45632;sx(45320,45688,47408,r,r,r,r,r,E,E,80)|0}else if((D|0)==210){EN(45320,46952,80,55);E=45624;r=45632;sx(45320,47008,45704,E,E,E,E,E,r,r,80)|0}}while(0);if((D|0)==227){EN(45320,47944,80,39);D=45624;sx(45320,47296,47984,D,D,D,D,45800,j,e,80)|0}if((c[k>>2]|0)==-1){EN(45320,48136,80,46);e=45624;j=45632;sx(45320,48184,48192,e,e,e,e,e,j,j,80)|0;EN(45320,48200,80,47);j=45624;e=45632;sx(45320,45688,48248,45704,j,j,j,j,e,e,80)|0;i=y;return 0}else{c[k>>2]=-1;c[n>>2]=-33;i=y;return 0}return 0}function ux(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;var A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0.0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0;v=i;A=c[f>>2]|0;B=~A;C=+h[n>>3];h[6032]=C;c[t>>2]=0;D=c[e>>2]|0;c[12066]=1;if((D|0)>=1){E=1;do{c[s+(E+ -1<<2)>>2]=0;F=c[12066]|0;E=F+1|0;c[12066]=E;}while((F|0)<(D|0))}G=+h[g>>3];if(!(G>=0.0)){H=-G}else{H=G}if(!(C>=0.0)){I=-C}else{I=C}h[6039]=(H+I)*+h[u>>3]*100.0;u=c[b>>2]|0;do{if((u|0)==3){J=C;K=+h[g>>3]}else if((u|0)==2){do{if((c[x+68>>2]|0)!=0){b=w+320|0;zx(g,b,k,l,f,o,m,n)|0;if((c[11446]|0)>0){i=v;return 0}D=d;Zd[D&7](f,b,k,e,p,y,z)|0;if((c[11446]|0)>0){i=v;return 0}E=x+60|0;c[E>>2]=(c[E>>2]|0)+1;a[48320]=0;F=c[e>>2]|0;c[12066]=1;if((F|0)<1){break}else{L=0;M=1}while(1){I=+h[p+(M+ -1<<3)>>3];if(!(I>=0.0)){N=-I}else{N=I}if(!(N<=0.0)){O=L}else{a[48320]=1;O=1}if((M|0)<(F|0)){L=O;M=M+1|0}else{break}}c[12066]=F+1;if(!O){break}I=+BN(48312,48256);h[6036]=I;H=I+ +h[b>>3];h[b>>3]=H;I=+h[6032];do{if((H- +h[g>>3])*I<0.0){zx(g,b,k,l,f,o,m,n)|0;if((c[11446]|0)<=0){break}i=v;return 0}else{G=+h[6036]/I;h[6037]=G;P=c[f>>2]|0;c[12066]=1;if((P|0)<1){break}Q=(A<<1)+B|0;R=G;S=1;while(1){T=k+(S+ -1<<3)|0;h[T>>3]=+h[T>>3]+R*+h[m+(Q+S<<3)>>3];if((S|0)>=(P|0)){break}R=+h[6037];S=S+1|0}c[12066]=P+1}}while(0);Zd[D&7](f,b,k,e,p,y,z)|0;if((c[11446]|0)>0){i=v;return 0}c[E>>2]=(c[E>>2]|0)+1;a[48320]=0;F=c[e>>2]|0;c[12066]=1;if((F|0)<1){break}else{U=0;V=1}while(1){S=V+ -1|0;I=+h[p+(S<<3)>>3];if(!(I>=0.0)){W=-I}else{W=I}if(W>0.0){X=U;Y=V}else{c[s+(S<<2)>>2]=1;a[48320]=1;X=1;Y=c[12066]|0}S=Y+1|0;c[12066]=S;if((Y|0)<(F|0)){U=X;V=S}else{break}}if(!X){break}c[t>>2]=1;i=v;return 0}}while(0);I=+h[g>>3];if(I==+h[w+328>>3]){i=v;return 0}else{J=+h[6032];K=I;break}}else{F=w+320|0;zx(g,F,k,l,f,o,m,n)|0;if((c[11446]|0)>0){i=v;return 0}E=d;Zd[E&7](f,F,k,e,p,y,z)|0;if((c[11446]|0)>0){i=v;return 0}b=x+60|0;c[b>>2]=1;a[48320]=0;D=c[e>>2]|0;c[12066]=1;if((D|0)<1){i=v;return 0}else{Z=0;_=1}while(1){I=+h[p+(_+ -1<<3)>>3];if(!(I>=0.0)){$=-I}else{$=I}if(!($<=0.0)){aa=Z}else{a[48320]=1;aa=1}if((_|0)<(D|0)){Z=aa;_=_+1|0}else{break}}c[12066]=D+1;if(!aa){i=v;return 0}I=+BN(48312,48256);h[6036]=I;h[F>>3]=I+ +h[F>>3];I=+h[6036]/+h[6032];h[6037]=I;S=c[f>>2]|0;c[12066]=1;if((S|0)>=1){Q=(A<<1)+B|0;H=I;T=1;while(1){ba=k+(T+ -1<<3)|0;h[ba>>3]=+h[ba>>3]+H*+h[m+(Q+T<<3)>>3];if((T|0)>=(S|0)){break}H=+h[6037];T=T+1|0}c[12066]=S+1}Zd[E&7](f,F,k,e,p,y,z)|0;if((c[11446]|0)>0){i=v;return 0}c[b>>2]=(c[b>>2]|0)+1;a[48320]=0;T=c[e>>2]|0;c[12066]=1;if((T|0)<1){i=v;return 0}else{ca=0;da=1}while(1){H=+h[p+(da+ -1<<3)>>3];if(!(H>=0.0)){ea=-H}else{ea=H}if(!(ea<=0.0)){fa=ca}else{a[48320]=1;fa=1}if((da|0)<(T|0)){ca=fa;da=da+1|0}else{break}}c[12066]=T+1;if(!fa){i=v;return 0}c[t>>2]=-1;i=v;return 0}}while(0);ea=+h[j>>3];do{if(!((ea-K)*J>=0.0)){h[6035]=ea;if((ea- +h[w+320>>3])*J<=0.0){i=v;return 0}zx(g,48280,k,l,f,o,m,n)|0;if((c[11446]|0)<=0){break}i=v;return 0}else{h[6035]=K;j=c[f>>2]|0;c[12066]=1;if((j|0)<1){break}else{ga=1}while(1){fa=ga+ -1|0;h[k+(fa<<3)>>3]=+h[m+(fa<<3)>>3];if((ga|0)<(j|0)){ga=ga+1|0}else{break}}c[12066]=j+1}}while(0);ga=d;Zd[ga&7](f,48280,k,e,q,y,z)|0;if((c[11446]|0)>0){i=v;return 0}d=x+60|0;c[d>>2]=(c[d>>2]|0)+1;c[12076]=0;T=w+320|0;fa=x+76|0;da=x+72|0;x=w+336|0;ca=w+344|0;while(1){vx(e,48312,48304,T,48280,p,q,r,48272,s,fa,da,x,ca)|0;if((c[11446]|0)>0){ha=76;break}if((c[12076]|0)>1){ha=73;break}zx(g,48272,k,l,f,o,m,n)|0;if((c[11446]|0)>0){ha=76;break}Zd[ga&7](f,48272,k,e,r,y,z)|0;if((c[11446]|0)>0){ha=76;break}c[d>>2]=(c[d>>2]|0)+1}if((ha|0)==73){h[T>>3]=+h[6034];T=45704;Rx(e,r,T,p,T)|0;if((c[12076]|0)==4){i=v;return 0}zx(g,48272,k,l,f,o,m,n)|0;if((c[11446]|0)>0){i=v;return 0}c[t>>2]=1;i=v;return 0}else if((ha|0)==76){i=v;return 0}return 0}function vx(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;s=i;do{if((c[e>>2]|0)==1){c[12092]=c[o>>2];c[o>>2]=0;h[6042]=0.0;a[48352]=0;t=c[b>>2]|0;c[12082]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;w=+h[l+(v<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}do{if(x>0.0){w=+BN(48384,j+(v<<3)|0);if(w==+BN(48384,l+((c[12082]|0)+ -1<<3)|0)){break}y=c[12082]|0;z=y+ -1|0;w=+h[l+(z<<3)>>3];A=w/(w- +h[j+(z<<3)>>3]);if(!(A>=0.0)){B=-A}else{B=A}if(B<=+h[6042]){break}h[6042]=B;c[o>>2]=y}else{a[48352]=1}}while(0);v=c[12082]|0;u=v+1|0;c[12082]=u;}while((v|0)<(t|0))}do{if((c[o>>2]|0)>0){a[48360]=1;c[12094]=c[p>>2];h[g>>3]=+h[r>>3];t=45704;Rx(b,l,t,k,t)|0;c[p>>2]=1;a[48344]=0;C=0}else{a[48360]=0;c[o>>2]=c[12092];c[12094]=c[p>>2];if(a[48352]&1){h[g>>3]=+h[r>>3];t=45704;Rx(b,l,t,k,t)|0;a[48344]=1;C=1;break}else{t=45704;Rx(b,l,t,j,t)|0;h[f>>3]=+h[r>>3];c[p>>2]=0;a[48344]=0;C=0;break}}}while(0);A=+h[g>>3];w=A- +h[f>>3];if(!(w>=0.0)){D=-w}else{D=w}if(!(D<=+h[d>>3])){if(!C){break}E=+h[g>>3]}else{a[48344]=1;E=A}c[e>>2]=2;h[m>>3]=E;t=45704;Rx(b,k,t,l,t)|0;t=c[b>>2]|0;c[12082]=1;if((t|0)<1){i=s;return 0}else{F=1}do{c[n+(F+ -1<<2)>>2]=0;u=(c[12082]|0)+ -1|0;A=+h[k+(u<<3)>>3];if(!(A>=0.0)){G=-A}else{G=A}do{if(G>0.0){A=+BN(48384,j+(u<<3)|0);if(!(A!=+BN(48384,k+((c[12082]|0)+ -1<<3)|0))){break}c[n+((c[12082]|0)+ -1<<2)>>2]=1}else{c[n+(u<<2)>>2]=1}}while(0);u=c[12082]|0;F=u+1|0;c[12082]=F;}while((u|0)<(t|0));i=s;return 0}else{c[o>>2]=0;h[6042]=0.0;a[48352]=0;t=c[b>>2]|0;c[12082]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;A=+h[k+(v<<3)>>3];if(!(A>=0.0)){H=-A}else{H=A}do{if(H>0.0){A=+BN(48384,j+(v<<3)|0);if(A==+BN(48384,k+((c[12082]|0)+ -1<<3)|0)){break}y=c[12082]|0;z=y+ -1|0;A=+h[k+(z<<3)>>3];w=A/(A- +h[j+(z<<3)>>3]);if(!(w>=0.0)){I=-w}else{I=w}if(I<=+h[6042]){break}h[6042]=I;c[o>>2]=y}else{a[48352]=1}}while(0);v=c[12082]|0;u=v+1|0;c[12082]=u;}while((v|0)<(t|0))}t=(c[o>>2]|0)>0;a[48360]=t&1;if(t){a[48344]=0;c[12094]=0;c[p>>2]=1;break}if(!(a[48352]&1)){t=45704;Rx(b,k,t,l,t)|0;h[m>>3]=+h[g>>3];c[e>>2]=4;i=s;return 0}h[m>>3]=+h[g>>3];t=45704;Rx(b,k,t,l,t)|0;t=c[b>>2]|0;c[12082]=1;if((t|0)>=1){u=1;do{c[n+(u+ -1<<2)>>2]=0;v=c[12082]|0;y=v+ -1|0;w=+h[k+(y<<3)>>3];if(!(w>=0.0)){J=-w}else{J=w}if(!(J<=0.0)){K=v}else{c[n+(y<<2)>>2]=1;K=c[12082]|0}u=K+1|0;c[12082]=u;}while((K|0)<(t|0))}c[e>>2]=3;i=s;return 0}}while(0);K=c[12094]|0;do{if((K|0)==(c[p>>2]|0)){J=+h[q>>3];if((K|0)==0){I=J*2.0;h[q>>3]=I;L=I;break}else{I=J*.5;h[q>>3]=I;L=I;break}}else{h[q>>3]=1.0;L=1.0}}while(0);I=+h[g>>3];q=(c[o>>2]|0)+ -1|0;J=+h[k+(q<<3)>>3];H=I-(I- +h[f>>3])*J/(J-L*+h[j+(q<<3)>>3]);h[r>>3]=H;L=+h[f>>3];J=H-L;if(!(J>=0.0)){M=-J}else{M=J}J=+h[d>>3];do{if(M<J){I=+h[g>>3]-L;if(!(I>=0.0)){N=-I}else{N=I}if(!(N>J*10.0)){O=H;break}G=L+I*.1;h[r>>3]=G;O=G}else{O=H}}while(0);c[e>>2]=1;h[m>>3]=O;i=s;return 0}function wx(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0.0,o=0.0,p=0.0;k=i;h[6051]=+h[d>>3];h[6050]=+h[e>>3];j=c[a>>2]|0;c[12098]=1;if((j|0)<1){i=k;return 0}else{l=1}while(1){if((c[b>>2]|0)==0){m=l+ -1|0;n=+h[6051]}else{a=l+ -1|0;o=+h[d+(a<<3)>>3];h[6051]=o;h[6050]=+h[e+(a<<3)>>3];m=a;n=o}o=+h[f+(m<<3)>>3];if(!(o>=0.0)){p=-o}else{p=o}h[g+(m<<3)>>3]=n*p+ +h[6050];a=l+1|0;c[12098]=a;if((l|0)<(j|0)){l=a}else{break}}i=k;return 0}function xx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;f=i;h[6054]=0.0;e=c[a>>2]|0;c[12104]=1;if((e|0)<1){g=0.0;i=f;return+g}else{j=0.0;k=1}while(1){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){n=-m}else{n=m}if(n>j){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){o=-m}else{o=m}h[6054]=o;p=o}else{p=j}if((k|0)<(e|0)){j=p;k=k+1|0}else{break}}c[12104]=e+1;if(p<=0.0){g=0.0;i=f;return+g}h[6053]=0.0;e=c[a>>2]|0;c[12104]=1;if((e|0)<1){q=0.0}else{j=0.0;k=1;while(1){l=k+ -1|0;o=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3]/p;r=j+o*o;h[6053]=r;if((k|0)<(e|0)){k=k+1|0;j=r}else{break}}c[12104]=e+1;q=r}g=p*+V(+(q/+(c[a>>2]|0)));i=f;return+g}function yx(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;y=i;i=i+16|0;z=y;A=y+8|0;B=c[f>>2]|0;c[m>>2]=1;c[12122]=0;c[12120]=0;c[12126]=0;h[6066]=+h[b>>3];h[6068]=+xx(f,d,l,0,0);C=c[f>>2]|0;c[12110]=1;D=(B<<1)+~B|0;if((C|0)>=1){B=1;while(1){E=B+ -1|0;h[p+(E<<3)>>3]=+h[d+(E<<3)>>3];h[p+(D+B<<3)>>3]=+h[e+(B+ -1<<3)>>3];if((B|0)<(C|0)){B=B+1|0}else{break}}c[12110]=C+1}C=t+44|0;B=g;E=t+48|0;F=+h[k>>3];a:while(1){h[6059]=1.0/F;h[b>>3]=+h[k>>3]+ +h[b>>3];G=c[f>>2]|0;c[12110]=1;if((G|0)>=1){H=1;while(1){I=H+ -1|0;J=d+(I<<3)|0;h[J>>3]=+h[J>>3]+ +h[k>>3]*+h[e+(I<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[12110]=G+1}a[48536]=1;c[12112]=0;a[48552]=1;c[C>>2]=(c[C>>2]|0)+1;c[12130]=0;Zd[B&7](b,d,e,q,48520,n,o)|0;b:do{if((c[12130]|0)<0){K=35}else{while(1){if(a[48536]&1){c[E>>2]=(c[E>>2]|0)+1;a[48536]=0;Bx(f,b,d,e,q,48472,k,48496,l,r,s,t,g,48520,v,j,n,o,x)|0;h[6058]=1.0e6;if((c[12130]|0)<0|(c[12124]|0)!=0){K=35;break b}c[12126]=0}H=c[f>>2]|0;c[12110]=1;if((H|0)>=1){I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]*.75;if((I|0)<(H|0)){I=I+1|0}else{break}}c[12110]=H+1}Cx(f,q,s,t)|0;I=c[f>>2]|0;c[12110]=1;if((I|0)>=1){J=1;while(1){L=J+ -1|0;M=d+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[q+(L<<3)>>3];L=J+ -1|0;M=e+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[6059]*+h[q+(L<<3)>>3];if((J|0)<(I|0)){J=J+1|0}else{break}}c[12110]=I+1}N=+xx(f,q,l,0,0);h[6070]=N;if(N<=+h[v>>3]*100.0*+h[6068]){break}J=c[12112]|0;if((J|0)>0){h[z>>3]=N/+h[6071];h[A>>3]=1.0/+(J|0);O=+zN(z,A);if(O>.9){K=35;break b}P=O/(1.0-O);h[6058]=P;Q=+h[6070];R=P}else{h[6071]=N;Q=N;R=+h[6058]}if(R*Q<=.33){break}J=c[12112]|0;H=J+1|0;c[12112]=H;if((J|0)>8){K=35;break b}if(((H|0)%5|0|0)==0){a[48536]=1}c[C>>2]=(c[C>>2]|0)+1;c[12130]=0;Zd[B&7](b,d,e,q,48520,n,o)|0;if((c[12130]|0)<0){K=35;break b}}do{if((c[w>>2]|0)!=0){H=c[f>>2]|0;c[12110]=1;if((H|0)>=1){J=1;while(1){S=+h[d+(J+ -1<<3)>>3];h[q+(J+ -1<<3)>>3]=S<=0.0?S:0.0;if((J|0)<(H|0)){J=J+1|0}else{break}}h[z>>3]=S;c[12110]=H+1}N=+xx(f,q,l,0,0);h[6070]=N;if(N>.33){K=35;break b}J=c[f>>2]|0;c[12110]=1;if((J|0)<1){break}else{T=1}while(1){I=T+ -1|0;L=d+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[q+(I<<3)>>3];I=T+ -1|0;L=e+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[6059]*+h[q+(I<<3)>>3];if((T|0)<(J|0)){T=T+1|0}else{break}}c[12110]=J+1}}while(0);if(!(a[48552]&1)){break}H=c[f>>2]|0;c[12110]=1;if((H|0)>=1){I=1;while(1){L=I+ -1|0;h[r+(L<<3)>>3]=+h[d+(L<<3)>>3]- +h[p+(L<<3)>>3];if((I|0)<(H|0)){I=I+1|0}else{break}}c[12110]=H+1}N=+xx(f,r,l,0,0);h[6064]=N;if(N<=1.0){K=63;break a}}}while(0);if((K|0)==35){K=0;a[48552]=0}h[b>>3]=+h[6066];G=c[f>>2]|0;c[12110]=1;if((G|0)>=1){I=1;while(1){L=I+ -1|0;h[d+(L<<3)>>3]=+h[p+(L<<3)>>3];h[e+(I+ -1<<3)>>3]=+h[p+(D+I<<3)>>3];if((I|0)<(G|0)){I=I+1|0}else{break}}c[12110]=G+1}if(a[48552]&1){I=(c[12122]|0)+1|0;c[12122]=I;N=.9/(+h[6064]*2.0+1.0e-4);h[z>>3]=.1;P=N>=.5?.5:N;h[A>>3]=P;N=P<=.1?.1:P;h[6057]=N;P=+h[k>>3]*N;h[k>>3]=P;if(!(P>=0.0)){U=-P}else{U=P}if(U>=+h[u>>3]&(I|0)<10){F=P;continue}else{K=62;break}}if((c[12124]|0)!=0){I=(c[12126]|0)+1|0;c[12126]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=3){K=51;break}if(!(P>=0.0)){V=-P}else{V=P}if(!(V>=+h[u>>3])){K=51;break}else{F=P;continue}}if(!((c[12130]|0)>-2)){K=53;break}I=(c[12120]|0)+1|0;c[12120]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=10){K=58;break}if(!(P>=0.0)){W=-P}else{W=P}if(!(W>=+h[u>>3])){K=58;break}else{F=P}}if((K|0)==51){c[m>>2]=-12;i=y;return 0}else if((K|0)==53){c[m>>2]=-12;i=y;return 0}else if((K|0)==58){c[m>>2]=-12;i=y;return 0}else if((K|0)==62){c[m>>2]=-12;i=y;return 0}else if((K|0)==63){i=y;return 0}return 0}function zx(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;l=i;m=c[f>>2]|0;n=~m;o=(c[g>>2]|0)+1|0;c[12156]=o;p=+h[b>>3]- +h[a>>3];h[6076]=p;a=c[f>>2]|0;c[12148]=1;if((a|0)<1){q=p}else{b=1;while(1){g=b+ -1|0;h[d+(g<<3)>>3]=+h[j+(g<<3)>>3];h[e+(b+ -1<<3)>>3]=0.0;if((b|0)<(a|0)){b=b+1|0}else{break}}c[12148]=a+1;q=+h[6076]}h[6072]=1.0;h[6073]=0.0;p=q/+h[k>>3];h[6077]=p;c[12150]=2;if((o|0)<2){i=l;return 0}else{r=q;s=1.0;t=p;u=0.0;v=2}while(1){a=k+(v+ -2<<3)|0;h[6073]=u*t+s/+h[a>>3];p=t*s;h[6072]=p;h[6077]=(r+ +h[a>>3])/+h[k+(v+ -1<<3)>>3];a=c[f>>2]|0;c[12148]=1;if((a|0)>=1){b=fa(v,m)|0;q=p;g=1;while(1){w=d+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+q*+h[j+(g+n+b<<3)>>3];w=e+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+ +h[6073]*+h[j+(g+n+b<<3)>>3];if((g|0)>=(a|0)){break}q=+h[6072];g=g+1|0}c[12148]=a+1}g=v+1|0;c[12150]=g;if((v|0)>=(o|0)){break}r=+h[6076];s=+h[6072];t=+h[6077];u=+h[6073];v=g}i=l;return 0}function Ax(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;F=F|0;G=G|0;H=H|0;I=I|0;J=J|0;K=K|0;L=L|0;M=M|0;var N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0;N=i;i=i+16|0;O=N;P=N+8|0;Q=c[f>>2]|0;R=~Q;c[n>>2]=1;h[6099]=+h[b>>3];c[12176]=0;c[12184]=0;c[12178]=0;S=u+52|0;if((c[m>>2]|0)==0){c[S>>2]=0;T=u+56|0;c[T>>2]=0;c[I>>2]=1;c[J>>2]=0;h[C>>3]=0.0;c[m>>2]=1;h[y>>3]=+h[k>>3];U=1.0/+h[k>>3];h[B>>3]=U;h[A>>3]=U;h[D>>3]=100.0;c[H>>2]=-1;h[6111]=1.0;c[G>>2]=0;c[K>>2]=0;V=T}else{V=u+56|0}T=u+44|0;m=g;W=u+48|0;while(1){c[12172]=(c[I>>2]|0)+1;c[12174]=(c[I>>2]|0)+2;c[12170]=(c[I>>2]|0)+ -1;h[6099]=+h[b>>3];do{if(+h[k>>3]!=+h[C>>3]){X=8}else{Y=c[I>>2]|0;if((Y|0)!=(c[J>>2]|0)){X=8;break}Z=(c[K>>2]|0)+1|0;_=Y}}while(0);if((X|0)==8){X=0;c[K>>2]=0;Z=1;_=c[J>>2]|0}Y=_+2|0;$=(Z|0)<=(Y|0)?Z:Y;c[K>>2]=$;c[12188]=$+1;$=c[12172]|0;if(($|0)>=(c[K>>2]|0)){h[w>>3]=1.0;h[v>>3]=1.0;h[6102]=+h[k>>3];h[x>>3]=0.0;h[z>>3]=1.0;c[12158]=2;if(($|0)>=2){Y=2;while(1){h[6103]=+h[y+(Y+ -2<<3)>>3];U=+h[6102];aa=Y+ -2|0;h[y+(aa<<3)>>3]=U;ba=Y+ -1|0;h[w+(ba<<3)>>3]=+h[w+(aa<<3)>>3]*U/+h[6103];U=+h[6103]+ +h[k>>3];h[6102]=U;ca=+h[k>>3]/U;h[v+(ba<<3)>>3]=ca;h[z+(ba<<3)>>3]=ca*+h[z+(aa<<3)>>3]*+(ba|0);h[x+(ba<<3)>>3]=+h[x+(aa<<3)>>3]+ +h[v+(aa<<3)>>3]/+h[k>>3];if((Y|0)<($|0)){Y=Y+1|0}else{break}}c[12158]=$+1}h[y+($+ -1<<3)>>3]=+h[6102]}h[6109]=0.0;h[6107]=0.0;Y=c[I>>2]|0;c[12158]=1;if((Y|0)<1){da=0.0}else{ca=0.0;U=0.0;aa=1;while(1){ea=U-1.0/+(aa|0);h[6109]=ea;ga=ca- +h[v+(aa+ -1<<3)>>3];h[6107]=ga;if((aa|0)<(Y|0)){aa=aa+1|0;U=ea;ca=ga}else{break}}c[12158]=Y+1;da=ea}h[6110]=+h[A>>3];h[A>>3]=-da/+h[k>>3];aa=v+($+ -1<<3)|0;ca=+h[aa>>3]+ +h[6109]- +h[6107];h[O>>3]=ca;if(!(ca>=0.0)){ha=-ca}else{ha=ca}h[6084]=ha;h[O>>3]=ha;ca=+h[aa>>3];h[P>>3]=ca;h[6084]=ha>=ca?ha:ca;h[6102]=.6;h[6103]=1.6666666666666667;ca=+h[A>>3];U=ca/+h[B>>3];if(U<.6|U>1.6666666666666667){c[H>>2]=-1}if(ca!=+h[6110]){h[D>>3]=100.0}aa=c[12172]|0;ba=c[12188]|0;if((aa|0)>=(ba|0)){c[12160]=ba;ia=ba;while(1){ba=c[f>>2]|0;c[12158]=1;if((ba|0)>=1){ja=1;while(1){ka=q+(ja+R+(fa(ia,Q)|0)<<3)|0;h[ka>>3]=+h[w+(ia+ -1<<3)>>3]*+h[ka>>3];if((ja|0)<(ba|0)){ja=ja+1|0}else{break}}c[12158]=ba+1}ja=ia+1|0;c[12160]=ja;if((ia|0)<(aa|0)){ia=ja}else{break}}}h[b>>3]=+h[k>>3]+ +h[b>>3];a:while(1){ia=c[f>>2]|0;c[12158]=1;if((ia|0)>=1){aa=1;while(1){$=aa+ -1|0;h[d+($<<3)>>3]=+h[q+($<<3)>>3];h[e+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ia|0)){aa=aa+1|0}else{break}}c[12158]=ia+1}aa=c[12172]|0;c[12160]=2;if((aa|0)>=2){ba=2;while(1){$=c[f>>2]|0;c[12158]=1;if(($|0)>=1){Y=x+(ba+ -1<<3)|0;ja=fa(ba,Q)|0;ka=ja+R|0;la=1;while(1){ma=d+(la+ -1<<3)|0;h[ma>>3]=+h[q+(la+R+ja<<3)>>3]+ +h[ma>>3];ma=e+(la+ -1<<3)|0;h[ma>>3]=+h[ma>>3]+ +h[Y>>3]*+h[q+(ka+la<<3)>>3];if((la|0)<($|0)){la=la+1|0}else{break}}c[12158]=$+1}la=ba+1|0;c[12160]=la;if((ba|0)<(aa|0)){ba=la}else{break}}}h[6106]=+xx(f,d,l,0,0);a[48896]=1;c[12162]=0;c[T>>2]=(c[T>>2]|0)+1;c[12192]=0;Zd[m&7](b,d,e,r,48768,o,p)|0;if((c[12192]|0)<0){X=70;break}if((c[H>>2]|0)==-1){c[W>>2]=(c[W>>2]|0)+1;c[H>>2]=0;Bx(f,b,d,e,r,A,k,48720,l,s,t,u,g,48768,F,j,o,p,M)|0;h[B>>3]=+h[A>>3];h[D>>3]=100.0;if((c[12192]|0)<0|(c[12180]|0)!=0){X=70;break}c[12184]=0}ba=c[f>>2]|0;c[12158]=1;if((ba|0)>=1){aa=1;while(1){h[s+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[12158]=ba+1}while(1){ca=2.0/(+h[A>>3]/+h[B>>3]+1.0);h[6102]=ca;aa=c[f>>2]|0;c[12158]=1;if((aa|0)>=1){U=ca;ia=1;la=0;while(1){ka=r+(la<<3)|0;h[ka>>3]=U*+h[ka>>3];if((ia|0)>=(aa|0)){break}ka=ia;U=+h[6102];ia=ia+1|0;la=ka}c[12158]=aa+1}Cx(f,r,t,u)|0;la=c[f>>2]|0;c[12158]=1;if((la|0)>=1){ia=1;while(1){$=ia+ -1|0;ka=d+($<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+($<<3)>>3];$=ia+ -1|0;ka=r+($<<3)|0;Y=s+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[ka>>3];Y=e+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[A>>3]*+h[ka>>3];if((ia|0)<(la|0)){ia=ia+1|0}else{break}}c[12158]=la+1}U=+xx(f,r,l,0,0);h[6111]=U;if(U<=+h[F>>3]*100.0*+h[6106]){X=63;break a}ia=c[12162]|0;if((ia|0)>0){h[O>>3]=U/+h[6113];h[P>>3]=1.0/+(ia|0);ca=+zN(O,P);if(ca>.9){break}ga=ca/(1.0-ca);h[D>>3]=ga;na=+h[6111];oa=ga}else{h[6113]=U;na=U;oa=+h[D>>3]}if(oa*na<=.33){X=63;break a}ia=c[12162]|0;c[12162]=ia+1;if((ia|0)>2){break}c[T>>2]=(c[T>>2]|0)+1;c[12192]=0;Zd[m&7](b,d,e,r,48768,o,p)|0;if((c[12192]|0)<0){X=70;break a}}if((c[H>>2]|0)==0){X=70;break}c[H>>2]=-1}do{if((X|0)==63){X=0;if((c[L>>2]|0)==0){break}ba=c[f>>2]|0;c[12158]=1;if((ba|0)>=1){ia=1;while(1){pa=+h[d+(ia+ -1<<3)>>3];h[r+(ia+ -1<<3)>>3]=pa<=0.0?pa:0.0;if((ia|0)<(ba|0)){ia=ia+1|0}else{break}}h[O>>3]=pa;c[12158]=ba+1}U=+xx(f,r,l,0,0);h[6111]=U;if(U>.33){X=70;break}ia=c[f>>2]|0;c[12158]=1;if((ia|0)<1){break}else{qa=1}while(1){aa=qa+ -1|0;ka=s+(aa<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+(aa<<3)>>3];if((qa|0)<(ia|0)){qa=qa+1|0}else{break}}c[12158]=ia+1}}while(0);if((X|0)==70){X=0;a[48896]=0}c[H>>2]=1;if(a[48896]&1){U=+xx(f,s,l,0,0);h[6105]=U;ba=c[I>>2]|0;ga=U*+h[z+(ba<<3)>>3];h[6091]=ga;h[6098]=ga*+(ba+1|0);h[6093]=ga;c[12194]=ba;do{if((c[I>>2]|0)!=1){ba=c[f>>2]|0;c[12158]=1;if((ba|0)>=1){aa=fa(c[12172]|0,Q)|0;ka=1;while(1){Y=ka+ -1|0;h[r+(Y<<3)>>3]=+h[q+(ka+R+aa<<3)>>3]+ +h[s+(Y<<3)>>3];if((ka|0)<(ba|0)){ka=ka+1|0}else{break}}c[12158]=ba+1}ga=+h[z+((c[I>>2]|0)+ -1<<3)>>3];U=ga*+xx(f,r,l,0,0);h[6100]=U;ka=c[I>>2]|0;ga=U*+(ka|0);h[6108]=ga;if((ka|0)>2){aa=c[f>>2]|0;c[12158]=1;ia=c[I>>2]|0;if((aa|0)<1){ra=ia}else{Y=ia;ia=1;while(1){ca=+h[q+(ia+R+(fa(Y,Q)|0)<<3)>>3];$=r+(ia+ -1<<3)|0;h[$>>3]=ca+ +h[$>>3];$=ia+1|0;c[12158]=$;ja=c[I>>2]|0;if((ia|0)<(aa|0)){ia=$;Y=ja}else{ra=ja;break}}}ca=+h[z+(ra+ -2<<3)>>3];sa=ca*+xx(f,r,l,0,0);Y=c[I>>2]|0;ca=sa*+(Y+ -1|0);sa=+h[6108];if((sa>=ca?sa:ca)>+h[6098]){break}ta=+h[6100];ua=Y}else{if(!(ga<=+h[6098]*.5)){break}else{ta=U;ua=ka}}c[12194]=ua+ -1;h[6093]=ta}}while(0);if(!(+h[6084]*+h[6105]>1.0)){X=86;break}}c[G>>2]=1;h[b>>3]=+h[6099];Y=c[12172]|0;ia=c[12188]|0;if((Y|0)>=(ia|0)){c[12160]=ia;aa=ia;while(1){ca=1.0/+h[w+(aa+ -1<<3)>>3];h[6102]=ca;ia=c[f>>2]|0;c[12158]=1;if((ia|0)>=1){ba=fa(aa,Q)|0;sa=ca;ja=1;while(1){$=q+(ja+R+ba<<3)|0;h[$>>3]=sa*+h[$>>3];if((ja|0)>=(ia|0)){break}sa=+h[6102];ja=ja+1|0}c[12158]=ia+1}ja=aa+1|0;c[12160]=ja;if((aa|0)<(Y|0)){aa=ja}else{break}}}c[12158]=2;if((Y|0)>=2){aa=2;while(1){h[y+(aa+ -2<<3)>>3]=+h[y+(aa+ -1<<3)>>3]- +h[k>>3];if((aa|0)<(Y|0)){aa=aa+1|0}else{break}}c[12158]=Y+1}if(!(a[48896]&1)){c[V>>2]=(c[V>>2]|0)+1;if((c[12180]|0)!=0){aa=(c[12184]|0)+1|0;c[12184]=aa;h[6082]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=3){X=144;break}if(!(sa>=0.0)){va=-sa}else{va=sa}if(!(va>=+h[E>>3])){X=144;break}else{continue}}if(!((c[12192]|0)>-2)){X=146;break}aa=(c[12176]|0)+1|0;c[12176]=aa;h[6082]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=10){X=151;break}if(!(sa>=0.0)){wa=-sa}else{wa=sa}if(!(wa>=+h[E>>3])){X=151;break}else{continue}}c[12178]=(c[12178]|0)+1;c[S>>2]=(c[S>>2]|0)+1;aa=c[12178]|0;if((aa|0)<=1){ja=c[12194]|0;c[I>>2]=ja;sa=+(ja+1|0);h[6103]=sa;h[O>>3]=+h[6093]*2.0+1.0e-4;h[P>>3]=-1.0/sa;sa=+zN(O,P)*.9;h[O>>3]=.25;U=sa>=.9?.9:sa;h[P>>3]=U;sa=U<=.25?.25:U;h[6082]=sa;U=+h[k>>3]*sa;h[k>>3]=U;if(!(U>=0.0)){xa=-U}else{xa=U}if(!(xa>=+h[E>>3])){X=156;break}else{continue}}if((aa|0)>2){c[I>>2]=1;U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){ya=-U}else{ya=U}if(!(ya>=+h[E>>3])){X=165;break}else{continue}}else{c[I>>2]=c[12194];U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){za=-U}else{za=U}if(!(za>=+h[E>>3])){X=161;break}else{continue}}}if((X|0)==86){c[n>>2]=1;E=u+40|0;c[E>>2]=(c[E>>2]|0)+1;c[12208]=(c[I>>2]|0)-(c[J>>2]|0);c[J>>2]=c[I>>2];h[C>>3]=+h[k>>3];C=c[12194]|0;E=c[12170]|0;do{if((C|0)==(E|0)){X=88}else{S=u+8|0;if((c[I>>2]|0)==(c[S>>2]|0)){X=88;break}if((c[G>>2]|0)!=0){Aa=E;Ba=C;X=90;break}c[I>>2]=c[12172];za=+h[k>>3]*2.0;h[6095]=za;Ca=S;Da=za}}while(0);if((X|0)==88){c[G>>2]=1;Aa=c[12170]|0;Ba=c[12194]|0;X=90}if((X|0)==90){do{if((Ba|0)==(Aa|0)){Ea=Aa;X=104}else{G=c[I>>2]|0;C=u+8|0;if((G|0)==(c[C>>2]|0)){Fa=G;break}if((c[12172]|0)>=(c[K>>2]|0)|(c[12208]|0)==1){Fa=G;break}G=c[f>>2]|0;c[12158]=1;if((G|0)>=1){E=fa(c[12174]|0,Q)|0;S=1;while(1){V=S+ -1|0;h[r+(V<<3)>>3]=+h[s+(V<<3)>>3]- +h[q+(S+R+E<<3)>>3];if((S|0)<(G|0)){S=S+1|0}else{break}}c[12158]=G+1}za=1.0/+((c[I>>2]|0)+2|0);ya=za*+xx(f,r,l,0,0);h[6101]=ya;S=c[I>>2]|0;za=ya*+(S+2|0);if((S|0)>1){xa=+h[6098];E=xa<=za;if(+h[6108]<=(E?xa:za)){Ea=c[12170]|0;X=104;break}if(E){Fa=S;break}if((S|0)==(c[C>>2]|0)){Fa=S;break}}else{if(za>=+h[6098]*.5){Fa=S;break}}S=c[12172]|0;c[I>>2]=S;h[6093]=ya;Fa=S}}while(0);if((X|0)==104){c[I>>2]=Ea;h[6093]=+h[6100];Fa=Ea}h[6095]=+h[k>>3];ya=+(Fa+1|0);h[6103]=ya;h[O>>3]=+h[6093]*2.0+1.0e-4;h[P>>3]=-1.0/ya;ya=+zN(O,P);h[6082]=ya;do{if(ya<2.0){if(ya>1.0){Ga=+h[6095];break}else{h[O>>3]=.5;za=ya>=.9?.9:ya;h[P>>3]=za;xa=za<=.5?.5:za;h[6082]=xa;za=+h[k>>3]*xa;h[6095]=za;Ga=za;break}}else{za=+h[k>>3]*2.0;h[6095]=za;Ga=za}}while(0);Ca=u+8|0;Da=Ga}h[k>>3]=Da;do{if((c[J>>2]|0)!=(c[Ca>>2]|0)){k=c[f>>2]|0;c[12158]=1;if((k|0)<1){break}u=fa(c[12174]|0,Q)|0;P=1;while(1){h[q+(P+R+u<<3)>>3]=+h[s+(P+ -1<<3)>>3];if((P|0)<(k|0)){P=P+1|0}else{break}}c[12158]=k+1}}while(0);Ca=c[f>>2]|0;c[12158]=1;if((Ca|0)>=1){J=fa(c[12172]|0,Q)|0;P=1;while(1){u=q+(P+R+J<<3)|0;h[u>>3]=+h[s+(P+ -1<<3)>>3]+ +h[u>>3];if((P|0)<(Ca|0)){P=P+1|0}else{break}}c[12158]=Ca+1}Ca=c[12172]|0;c[12166]=2;if((Ca|0)<2){i=N;return 0}else{Ha=2}while(1){P=1-Ha+Ca|0;c[12160]=P;s=c[f>>2]|0;c[12158]=1;if((s|0)>=1){J=fa(P+1|0,Q)|0;u=fa(P,Q)|0;P=1;while(1){C=P+R|0;G=q+(C+u<<3)|0;h[G>>3]=+h[q+(C+J<<3)>>3]+ +h[G>>3];if((P|0)<(s|0)){P=P+1|0}else{break}}c[12158]=s+1}P=Ha+1|0;c[12166]=P;if((Ha|0)<(Ca|0)){Ha=P}else{break}}i=N;return 0}else if((X|0)==144){c[n>>2]=-8}else if((X|0)==146){c[n>>2]=-11}else if((X|0)==151){c[n>>2]=-7;Ha=(c[12192]>>31&-3)+ -7|0;c[n>>2]=Ha;c[n>>2]=(c[12178]|0)>2?-9:Ha}else if((X|0)==156){c[n>>2]=-6}else if((X|0)==161){c[n>>2]=-6}else if((X|0)==165){c[n>>2]=-6}zx(b,b,d,e,f,I,q,y)|0;i=N;return 0}



function Ce(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function De(){return i|0}function Ee(a){a=a|0;i=a}function Fe(a,b){a=a|0;b=b|0;if((u|0)==0){u=a;v=b}}function Ge(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function He(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function Ie(a){a=a|0;J=a}function Je(a){a=a|0;K=a}function Ke(a){a=a|0;L=a}function Le(a){a=a|0;M=a}function Me(a){a=a|0;N=a}function Ne(a){a=a|0;O=a}function Oe(a){a=a|0;P=a}function Pe(a){a=a|0;Q=a}function Qe(a){a=a|0;R=a}function Re(a){a=a|0;S=a}function Se(a){a=a|0;var b=0,d=0;b=i;Nz(a)|0;d=a+540|0;ee[c[(c[d>>2]|0)+40>>2]&127](a)|0;ee[c[(c[d>>2]|0)+28>>2]&127](a)|0;ee[c[(c[d>>2]|0)+32>>2]&127](a)|0;ee[c[(c[d>>2]|0)+48>>2]&127](a)|0;ee[c[(c[d>>2]|0)+52>>2]&127](a)|0;Fy(a);i=b;return}function Te(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+24|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[v>>2]=0;y=b+240|0;z=d;h[z>>3]=+h[y>>3];if((c[2]|0)==0){A=0}else{B=c[b+88>>2]|0;C=x_(B|0)|0;D=VZ(C+11|0)|0;I_(D|0,B|0,C|0)|0;B=D+C+0|0;C=16|0;E=B+11|0;do{a[B]=a[C]|0;B=B+1|0;C=C+1|0}while((B|0)<(E|0));C=ec(D|0,32)|0;if((C|0)==0){B=Sd(c[(Kc()|0)>>2]|0)|0;c[u>>2]=D;c[u+4>>2]=B;iw(23,0,40,u);Vc(0)|0;F=0}else{F=C}WZ(D);A=F}F=b+248|0;D=b+536|0;C=b;u=b+4|0;B=d+36|0;E=d+16|0;G=b+256|0;H=d+8|0;I=d+24|0;J=d+32|0;K=b+540|0;L=d+48|0;M=c[t>>2]|0;N=v;O=w;P=b+64|0;Q=b+72|0;R=x;S=0;T=A;while(1){if(!(+h[z>>3]<+h[F>>3])){U=T;V=0;break}ve[c[36484>>2]&7]()|0;c[(c[D>>2]|0)+84>>2]=1;if((c[2]|0)!=0){if(((c[Q>>2]|0)+(c[P>>2]|0)|0)>0){A=0;do{kx(A+9|0);A=A+1|0;}while((A|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0))}kx(2);jx(2)}_w(c[C>>2]|0,1,c[u>>2]|0);if((c[B>>2]|0)==1){A=s;h[k>>3]=+h[z>>3]- +h[E>>3];c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];gw(23,0,104,s);W=S}else{W=S+1|0}X=+h[y>>3];h[H>>3]=X+ +(W>>>0)*(+h[F>>3]-X)/+(c[G>>2]|0)- +h[z>>3];sy(b,d);X=+h[z>>3];Y=+h[H>>3];A=r;h[k>>3]=X;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+8|0;h[k>>3]=X+Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+16|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];gw(23,1,144,r);Z=vz(b,d)|0;if((c[I>>2]|0)==5){U=T;V=0;break}Se(b);Gy(b);if((c[35676>>2]|0)!=0){be[c[9034]&255](23)}if((c[2]|0)!=0){jx(4)}A=uy(b,c[J>>2]|0,z,d)|0;if((A|0)>0){c[(c[D>>2]|0)+84>>2]=4;Y=+h[z>>3];c[q>>2]=(A|0)==1?224:232;A=q+4|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];gw(7,1,200,q);if((c[89428>>2]|0)==0){ce[c[74164>>2]&127](74144,b)}wy(b,c[J>>2]|0,z,d);if((c[35612>>2]|0)!=0){be[c[9034]&255](7)}c[(c[D>>2]|0)+84>>2]=1;c[B>>2]=1;Ky(b)}else{h[E>>3]=+h[z>>3];c[B>>2]=0}if((c[2]|0)!=0){mx(4)}if((Hz(b,1,1)|0)!=0){c[B>>2]=1;Ky(b)}ee[c[(c[K>>2]|0)+88>>2]&127](b)|0;Fy(b);Oy(b);Gy(b);do{if((T|0)==0){_=0}else{jx(7);mx(2);A=(nc(N|0,4,1,T|0)|0)==1;c[v>>2]=(c[v>>2]|0)+1;do{if(A){$=(nc(c[c[u>>2]>>2]|0,8,1,T|0)|0)==1;h[w>>3]=+ex(2);if(!$){aa=0;break}aa=(nc(O|0,8,1,T|0)|0)==1|0}else{h[w>>3]=+ex(2);aa=0}}while(0);A=c[P>>2]|0;$=c[Q>>2]|0;if(($+A|0)>0){ba=aa;ca=0;while(1){c[x>>2]=$w(ca+9|0)|0;if((ba|0)==0){da=0}else{da=(nc(R|0,4,1,T|0)|0)==1|0}ea=ca+1|0;fa=c[P>>2]|0;ga=c[Q>>2]|0;if((ea|0)<(ga+fa|0)){ba=da;ca=ea}else{ha=ga;ia=fa;ja=da;break}}}else{ha=$;ia=A;ja=aa}if((ha+ia|0)>0){ca=ja;ba=0;while(1){h[w>>3]=+ex(ba+9|0);if((ca|0)==0){ka=0}else{ka=(nc(O|0,8,1,T|0)|0)==1|0}fa=ba+1|0;if((fa|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0)){ca=ka;ba=fa}else{la=ka;break}}}else{la=ja}mx(7);if((la|0)!=0){_=T;break}c[p>>2]=Sd(c[(Kc()|0)>>2]|0)|0;iw(23,0,240,p);Vc(T|0)|0;_=0}}while(0);if((c[89428>>2]|0)==0){ma=47}else{ba=c[B>>2]|0;if((ba|0)==0){ma=47}else{na=ba}}if((ma|0)==47){ma=0;ce[c[74164>>2]&127](74144,b);na=c[B>>2]|0}do{if((na|0)==1){if((c[I>>2]|0)!=3){break}ba=c[L>>2]|0;ca=c[ba+8>>2]|0;A=c[ba+4>>2]|0;c[A>>2]=(c[A>>2]|0)+(c[ca>>2]|0);ba=A+4|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+4>>2]|0);ba=A+8|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+8>>2]|0);ba=A+12|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+12>>2]|0);ba=A+16|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+16>>2]|0)}}while(0);if((c[19936]|0)!=0){ca=f;ba=79752;c[ca+0>>2]=c[ba+0>>2];c[ca+4>>2]=c[ba+4>>2];c[ca+8>>2]=c[ba+8>>2];c[ca+12>>2]=c[ba+12>>2];c[ca+16>>2]=c[ba+16>>2];c[ca+20>>2]=c[ba+20>>2];_v(M,f);Od(10,M|0)|0;ba=c[19944]|0;ca=o;h[k>>3]=+h[c[c[u>>2]>>2]>>3];c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];c[o+8>>2]=ba;gw(1,0,320,o);h[F>>3]=+h[z>>3]}if((Z|0)!=0){ma=57;break}if((qz(b,0)|0)!=0){ma=58;break}if((hz(b,0)|0)!=0){ma=58;break}if((Zy(b,0)|0)==0){S=W;T=_}else{ma=58;break}}do{if((ma|0)==57){T=n;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];gw(1,0,376,n);U=_;V=Z+ -1|0}else if((ma|0)==58){if((qz(b,0)|0)!=0){T=m;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];gw(1,0,448,m);U=_;V=-2;break}if((hz(b,0)|0)!=0){T=l;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];gw(1,0,536,l);U=_;V=-3;break}T=(Zy(b,0)|0)==0;Y=+h[z>>3];if(T){T=g;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];gw(1,0,712,g);U=_;V=-1;break}else{T=j;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];gw(1,0,624,j);U=_;V=-3;break}}}while(0);if((U|0)==0){i=e;return V|0}Vc(U|0)|0;i=e;return V|0}function Ue(a){a=a|0;i=i;return 0}function Ve(a){a=a|0;i=i;return 0}function We(a){a=a|0;i=i;return 0}function Xe(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+21|0]=a[(c[b+340>>2]|0)+10|0]|0;i=i;return}function Ye(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+20|0]=a[(c[b+340>>2]|0)+9|0]|0;i=i;return}function Ze(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+19|0]=a[(c[b+340>>2]|0)+8|0]|0;i=i;return}function _e(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+18|0]=a[(c[b+340>>2]|0)+7|0]|0;i=i;return}function $e(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+17|0]=a[(c[b+340>>2]|0)+6|0]|0;i=i;return}function af(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+16|0]=a[(c[b+340>>2]|0)+5|0]|0;i=i;return}function bf(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+15|0]=a[(c[b+340>>2]|0)+4|0]|0;i=i;return}function cf(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+14|0]=a[(c[b+340>>2]|0)+3|0]|0;i=i;return}function df(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+13|0]=a[(c[b+340>>2]|0)+2|0]|0;i=i;return}function ef(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+12|0]=a[(c[b+340>>2]|0)+1|0]|0;i=i;return}function ff(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+11|0]=a[c[b+340>>2]|0]|0;i=i;return}function gf(b){b=b|0;var d=0,e=0;d=i;if((a[b+312|0]|0)!=0){h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+280>>3]=+h[(c[b+400>>2]|0)+280>>3];i=d;return}e=c[c[b+4>>2]>>2]|0;do{if((a[(c[e+16>>2]|0)+21|0]|0)!=0){if((a[(c[b+408>>2]|0)+21|0]|0)!=0){break}h[(c[e+8>>2]|0)+280>>3]=+h[e>>3];i=d;return}}while(0);h[(c[e+8>>2]|0)+280>>3]=+h[(c[b+400>>2]|0)+280>>3];i=d;return}function hf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+21|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+21|0]|0;k=c[c[b+4>>2]>>2]|0;l=Ty(+h[k>>3],+h[(c[k+8>>2]|0)+280>>3],a[(c[b+360>>2]|0)+21|0]|0)|0;a[(c[b+352>>2]|0)+21|0]=l;f=j;break}else{j=c[c[b+4>>2]>>2]|0;l=Ty(+h[j>>3],+h[(c[j+8>>2]|0)+280>>3],a[(c[b+360>>2]|0)+21|0]|0)|0;a[(c[b+352>>2]|0)+21|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+21|0]|0;l=c[c[b+4>>2]>>2]|0;j=Wy(+h[l>>3],+h[(c[l+8>>2]|0)+280>>3])|0;a[(c[b+352>>2]|0)+21|0]=j;f=g;break}else{g=c[c[b+4>>2]>>2]|0;j=Wy(+h[g>>3],+h[(c[g+8>>2]|0)+280>>3])|0;a[(c[b+352>>2]|0)+21|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+22|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+22|0]|0;l=c[c[b+4>>2]>>2]|0;k=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+280>>3]+ +h[(c[b+416>>2]|0)+1304>>3],a[(c[b+360>>2]|0)+22|0]|0)|0;a[(c[b+352>>2]|0)+22|0]=k;m=g;break}else{g=c[c[b+4>>2]>>2]|0;k=Sy(+h[g>>3],+h[(c[g+8>>2]|0)+280>>3]+ +h[(c[b+416>>2]|0)+1304>>3],a[(c[b+360>>2]|0)+22|0]|0)|0;a[(c[b+352>>2]|0)+22|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+22|0]|0;k=c[c[b+4>>2]>>2]|0;g=Uy(+h[k>>3],+h[(c[k+8>>2]|0)+280>>3]+ +h[(c[b+416>>2]|0)+1304>>3])|0;a[(c[b+352>>2]|0)+22|0]=g;m=j;break}else{j=c[c[b+4>>2]>>2]|0;g=Uy(+h[j>>3],+h[(c[j+8>>2]|0)+280>>3]+ +h[(c[b+416>>2]|0)+1304>>3])|0;a[(c[b+352>>2]|0)+22|0]=g;m=g;break}}}}while(0);if(f<<24>>24==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;a[w]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;a[w]=n;i=d;return}function jf(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,12)|0;d=c[(c[a+476>>2]|0)+796>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+352>>3]=+h[d>>3];h[e+336>>3]=+h[d+8>>3];h[e+288>>3]=+h[d+16>>3];h[e+312>>3]=+h[d+24>>3];h[e+272>>3]=+h[d+32>>3];h[e+320>>3]=+h[d+40>>3];h[e+304>>3]=+h[d+48>>3];h[e+256>>3]=+h[d+56>>3];h[e+264>>3]=+h[d+64>>3];h[e+344>>3]=+h[d+72>>3];h[e+296>>3]=+h[d+80>>3];i=b;return}function kf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+360>>3]=-(+h[b+272>>3]*+h[b+264>>3]);i=i;return}function lf(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+1312>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+272>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+128|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+128|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,872,864,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+128|0;p=o;h[p>>3]=m;i=d;return}function mf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+328>>3]=+h[b+272>>3]*+h[b+256>>3]+ +h[b+288>>3]*+h[b+96>>3];i=i;return}function nf(b){b=b|0;var d=0,e=0;d=i;if((a[b+312|0]|0)!=0){h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+392>>3]=+h[(c[b+400>>2]|0)+392>>3];i=d;return}e=c[c[b+4>>2]>>2]|0;do{if((a[(c[e+16>>2]|0)+20|0]|0)!=0){if((a[(c[b+408>>2]|0)+20|0]|0)!=0){break}h[(c[e+8>>2]|0)+392>>3]=+h[e>>3];i=d;return}}while(0);h[(c[e+8>>2]|0)+392>>3]=+h[(c[b+400>>2]|0)+392>>3];i=d;return}function of(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+19|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+19|0]|0;k=c[c[b+4>>2]>>2]|0;l=Ty(+h[k>>3],+h[(c[k+8>>2]|0)+392>>3],a[(c[b+360>>2]|0)+19|0]|0)|0;a[(c[b+352>>2]|0)+19|0]=l;f=j;break}else{j=c[c[b+4>>2]>>2]|0;l=Ty(+h[j>>3],+h[(c[j+8>>2]|0)+392>>3],a[(c[b+360>>2]|0)+19|0]|0)|0;a[(c[b+352>>2]|0)+19|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+19|0]|0;l=c[c[b+4>>2]>>2]|0;j=Wy(+h[l>>3],+h[(c[l+8>>2]|0)+392>>3])|0;a[(c[b+352>>2]|0)+19|0]=j;f=g;break}else{g=c[c[b+4>>2]>>2]|0;j=Wy(+h[g>>3],+h[(c[g+8>>2]|0)+392>>3])|0;a[(c[b+352>>2]|0)+19|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+20|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+20|0]|0;l=c[c[b+4>>2]>>2]|0;k=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+392>>3]+ +h[(c[b+416>>2]|0)+1200>>3],a[(c[b+360>>2]|0)+20|0]|0)|0;a[(c[b+352>>2]|0)+20|0]=k;m=g;break}else{g=c[c[b+4>>2]>>2]|0;k=Sy(+h[g>>3],+h[(c[g+8>>2]|0)+392>>3]+ +h[(c[b+416>>2]|0)+1200>>3],a[(c[b+360>>2]|0)+20|0]|0)|0;a[(c[b+352>>2]|0)+20|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+20|0]|0;k=c[c[b+4>>2]>>2]|0;g=Uy(+h[k>>3],+h[(c[k+8>>2]|0)+392>>3]+ +h[(c[b+416>>2]|0)+1200>>3])|0;a[(c[b+352>>2]|0)+20|0]=g;m=j;break}else{j=c[c[b+4>>2]>>2]|0;g=Uy(+h[j>>3],+h[(c[j+8>>2]|0)+392>>3]+ +h[(c[b+416>>2]|0)+1200>>3])|0;a[(c[b+352>>2]|0)+20|0]=g;m=g;break}}}}while(0);if(f<<24>>24==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+1|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+1|0;z=y;a[z]=n;i=d;return}function pf(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,13)|0;d=c[(c[a+476>>2]|0)+860>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+464>>3]=+h[d>>3];h[e+448>>3]=+h[d+8>>3];h[e+400>>3]=+h[d+16>>3];h[e+424>>3]=+h[d+24>>3];h[e+384>>3]=+h[d+32>>3];h[e+432>>3]=+h[d+40>>3];h[e+416>>3]=+h[d+48>>3];h[e+368>>3]=+h[d+56>>3];h[e+376>>3]=+h[d+64>>3];h[e+456>>3]=+h[d+72>>3];h[e+408>>3]=+h[d+80>>3];i=b;return}function qf(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+1208>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+384>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+136|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+136|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,904,896,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+136|0;p=o;h[p>>3]=m;i=d;return}function rf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+440>>3]=+h[b+384>>3]*+h[b+368>>3];i=i;return}function sf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+472>>3]=-(+h[b+408>>3]*+h[b+88>>3])- +h[b+384>>3]*+h[b+376>>3];i=i;return}function tf(b){b=b|0;var d=0,e=0;d=i;if((a[b+312|0]|0)!=0){h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+504>>3]=+h[(c[b+400>>2]|0)+504>>3];i=d;return}e=c[c[b+4>>2]>>2]|0;do{if((a[(c[e+16>>2]|0)+19|0]|0)!=0){if((a[(c[b+408>>2]|0)+19|0]|0)!=0){break}h[(c[e+8>>2]|0)+504>>3]=+h[e>>3];i=d;return}}while(0);h[(c[e+8>>2]|0)+504>>3]=+h[(c[b+400>>2]|0)+504>>3];i=d;return}function uf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+17|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+17|0]|0;k=c[c[b+4>>2]>>2]|0;l=Ty(+h[k>>3],+h[(c[k+8>>2]|0)+504>>3],a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=l;f=j;break}else{j=c[c[b+4>>2]>>2]|0;l=Ty(+h[j>>3],+h[(c[j+8>>2]|0)+504>>3],a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+17|0]|0;l=c[c[b+4>>2]>>2]|0;j=Wy(+h[l>>3],+h[(c[l+8>>2]|0)+504>>3])|0;a[(c[b+352>>2]|0)+17|0]=j;f=g;break}else{g=c[c[b+4>>2]>>2]|0;j=Wy(+h[g>>3],+h[(c[g+8>>2]|0)+504>>3])|0;a[(c[b+352>>2]|0)+17|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+18|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+18|0]|0;l=c[c[b+4>>2]>>2]|0;k=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+504>>3]+ +h[(c[b+416>>2]|0)+1096>>3],a[(c[b+360>>2]|0)+18|0]|0)|0;a[(c[b+352>>2]|0)+18|0]=k;m=g;break}else{g=c[c[b+4>>2]>>2]|0;k=Sy(+h[g>>3],+h[(c[g+8>>2]|0)+504>>3]+ +h[(c[b+416>>2]|0)+1096>>3],a[(c[b+360>>2]|0)+18|0]|0)|0;a[(c[b+352>>2]|0)+18|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+18|0]|0;k=c[c[b+4>>2]>>2]|0;g=Uy(+h[k>>3],+h[(c[k+8>>2]|0)+504>>3]+ +h[(c[b+416>>2]|0)+1096>>3])|0;a[(c[b+352>>2]|0)+18|0]=g;m=j;break}else{j=c[c[b+4>>2]>>2]|0;g=Uy(+h[j>>3],+h[(c[j+8>>2]|0)+504>>3]+ +h[(c[b+416>>2]|0)+1096>>3])|0;a[(c[b+352>>2]|0)+18|0]=g;m=g;break}}}}while(0);if(f<<24>>24==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+2|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+2|0;z=y;a[z]=n;i=d;return}function vf(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,14)|0;d=c[(c[a+476>>2]|0)+924>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+520>>3]=+h[d>>3];h[e+568>>3]=+h[d+8>>3];h[e+512>>3]=+h[d+16>>3];h[e+536>>3]=+h[d+24>>3];h[e+496>>3]=+h[d+32>>3];h[e+544>>3]=+h[d+40>>3];h[e+528>>3]=+h[d+48>>3];h[e+480>>3]=+h[d+56>>3];h[e+488>>3]=+h[d+64>>3];h[e+560>>3]=+h[d+72>>3];h[e+576>>3]=+h[d+80>>3];i=b;return}function wf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+584>>3]=-(+h[b+520>>3]*+h[b+104>>3])- +h[b+496>>3]*+h[b+488>>3];i=i;return}function xf(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+1104>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+496>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+144|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+144|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,936,928,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+144|0;p=o;h[p>>3]=m;i=d;return}function yf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+552>>3]=+h[b+496>>3]*+h[b+480>>3];i=i;return}function zf(b){b=b|0;var d=0,e=0;d=i;if((a[b+312|0]|0)!=0){h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+616>>3]=+h[(c[b+400>>2]|0)+616>>3];i=d;return}e=c[c[b+4>>2]>>2]|0;do{if((a[(c[e+16>>2]|0)+18|0]|0)!=0){if((a[(c[b+408>>2]|0)+18|0]|0)!=0){break}h[(c[e+8>>2]|0)+616>>3]=+h[e>>3];i=d;return}}while(0);h[(c[e+8>>2]|0)+616>>3]=+h[(c[b+400>>2]|0)+616>>3];i=d;return}function Af(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+15|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+15|0]|0;k=c[c[b+4>>2]>>2]|0;l=Ty(+h[k>>3],+h[(c[k+8>>2]|0)+616>>3],a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=l;f=j;break}else{j=c[c[b+4>>2]>>2]|0;l=Ty(+h[j>>3],+h[(c[j+8>>2]|0)+616>>3],a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+15|0]|0;l=c[c[b+4>>2]>>2]|0;j=Wy(+h[l>>3],+h[(c[l+8>>2]|0)+616>>3])|0;a[(c[b+352>>2]|0)+15|0]=j;f=g;break}else{g=c[c[b+4>>2]>>2]|0;j=Wy(+h[g>>3],+h[(c[g+8>>2]|0)+616>>3])|0;a[(c[b+352>>2]|0)+15|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+16|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+16|0]|0;l=c[c[b+4>>2]>>2]|0;k=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+616>>3]+ +h[(c[b+416>>2]|0)+992>>3],a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=k;m=g;break}else{g=c[c[b+4>>2]>>2]|0;k=Sy(+h[g>>3],+h[(c[g+8>>2]|0)+616>>3]+ +h[(c[b+416>>2]|0)+992>>3],a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+16|0]|0;k=c[c[b+4>>2]>>2]|0;g=Uy(+h[k>>3],+h[(c[k+8>>2]|0)+616>>3]+ +h[(c[b+416>>2]|0)+992>>3])|0;a[(c[b+352>>2]|0)+16|0]=g;m=j;break}else{j=c[c[b+4>>2]>>2]|0;g=Uy(+h[j>>3],+h[(c[j+8>>2]|0)+616>>3]+ +h[(c[b+416>>2]|0)+992>>3])|0;a[(c[b+352>>2]|0)+16|0]=g;m=g;break}}}}while(0);if(f<<24>>24==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+3|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+3|0;z=y;a[z]=n;i=d;return}function Bf(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,15)|0;d=c[(c[a+476>>2]|0)+988>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+656>>3]=+h[d>>3];h[e+640>>3]=+h[d+8>>3];h[e+632>>3]=+h[d+16>>3];h[e+680>>3]=+h[d+24>>3];h[e+688>>3]=+h[d+32>>3];h[e+672>>3]=+h[d+40>>3];h[e+600>>3]=+h[d+48>>3];h[e+592>>3]=+h[d+56>>3];h[e+648>>3]=+h[d+64>>3];h[e+624>>3]=+h[d+72>>3];h[e+608>>3]=+h[d+80>>3];i=b;return}function Cf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+696>>3]=-(+h[b+632>>3]*+h[b+88>>3])- +h[b+608>>3]*+h[b+600>>3];i=i;return}function Df(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+664>>3]=+h[b+608>>3]*+h[b+592>>3];i=i;return}function Ef(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+1e3>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+608>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+152|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+152|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,960,952,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+152|0;p=o;h[p>>3]=m;i=d;return}function Ff(b){b=b|0;var d=0,e=0;d=i;if((a[b+312|0]|0)!=0){h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+728>>3]=+h[(c[b+400>>2]|0)+728>>3];i=d;return}e=c[c[b+4>>2]>>2]|0;do{if((a[(c[e+16>>2]|0)+17|0]|0)!=0){if((a[(c[b+408>>2]|0)+17|0]|0)!=0){break}h[(c[e+8>>2]|0)+728>>3]=+h[e>>3];i=d;return}}while(0);h[(c[e+8>>2]|0)+728>>3]=+h[(c[b+400>>2]|0)+728>>3];i=d;return}function Gf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+13|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+13|0]|0;k=c[c[b+4>>2]>>2]|0;l=Ty(+h[k>>3],+h[(c[k+8>>2]|0)+728>>3],a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=l;f=j;break}else{j=c[c[b+4>>2]>>2]|0;l=Ty(+h[j>>3],+h[(c[j+8>>2]|0)+728>>3],a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+13|0]|0;l=c[c[b+4>>2]>>2]|0;j=Wy(+h[l>>3],+h[(c[l+8>>2]|0)+728>>3])|0;a[(c[b+352>>2]|0)+13|0]=j;f=g;break}else{g=c[c[b+4>>2]>>2]|0;j=Wy(+h[g>>3],+h[(c[g+8>>2]|0)+728>>3])|0;a[(c[b+352>>2]|0)+13|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+14|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+14|0]|0;l=c[c[b+4>>2]>>2]|0;k=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+728>>3]+ +h[(c[b+416>>2]|0)+888>>3],a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=k;m=g;break}else{g=c[c[b+4>>2]>>2]|0;k=Sy(+h[g>>3],+h[(c[g+8>>2]|0)+728>>3]+ +h[(c[b+416>>2]|0)+888>>3],a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+14|0]|0;k=c[c[b+4>>2]>>2]|0;g=Uy(+h[k>>3],+h[(c[k+8>>2]|0)+728>>3]+ +h[(c[b+416>>2]|0)+888>>3])|0;a[(c[b+352>>2]|0)+14|0]=g;m=j;break}else{j=c[c[b+4>>2]>>2]|0;g=Uy(+h[j>>3],+h[(c[j+8>>2]|0)+728>>3]+ +h[(c[b+416>>2]|0)+888>>3])|0;a[(c[b+352>>2]|0)+14|0]=g;m=g;break}}}}while(0);if(f<<24>>24==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+4|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+4|0;z=y;a[z]=n;i=d;return}function Hf(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,16)|0;d=c[(c[a+476>>2]|0)+1052>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+800>>3]=+h[d>>3];h[e+784>>3]=+h[d+8>>3];h[e+736>>3]=+h[d+16>>3];h[e+760>>3]=+h[d+24>>3];h[e+720>>3]=+h[d+32>>3];h[e+768>>3]=+h[d+40>>3];h[e+752>>3]=+h[d+48>>3];h[e+704>>3]=+h[d+56>>3];h[e+712>>3]=+h[d+64>>3];h[e+792>>3]=+h[d+72>>3];h[e+744>>3]=+h[d+80>>3];i=b;return}function If(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+808>>3]=-(+h[b+720>>3]*+h[b+712>>3]);i=i;return}function Jf(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+896>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+720>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+160|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+160|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,992,984,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+160|0;p=o;h[p>>3]=m;i=d;return}function Kf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+776>>3]=+h[b+720>>3]*+h[b+704>>3]- +h[b+736>>3]*+h[b+120>>3];i=i;return}function Lf(b){b=b|0;var d=0,e=0;d=i;if((a[b+312|0]|0)!=0){h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+840>>3]=+h[(c[b+400>>2]|0)+840>>3];i=d;return}e=c[c[b+4>>2]>>2]|0;do{if((a[(c[e+16>>2]|0)+16|0]|0)!=0){if((a[(c[b+408>>2]|0)+16|0]|0)!=0){break}h[(c[e+8>>2]|0)+840>>3]=+h[e>>3];i=d;return}}while(0);h[(c[e+8>>2]|0)+840>>3]=+h[(c[b+400>>2]|0)+840>>3];i=d;return}function Mf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+11|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+11|0]|0;k=c[c[b+4>>2]>>2]|0;l=Ty(+h[k>>3],+h[(c[k+8>>2]|0)+840>>3],a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=l;f=j;break}else{j=c[c[b+4>>2]>>2]|0;l=Ty(+h[j>>3],+h[(c[j+8>>2]|0)+840>>3],a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+11|0]|0;l=c[c[b+4>>2]>>2]|0;j=Wy(+h[l>>3],+h[(c[l+8>>2]|0)+840>>3])|0;a[(c[b+352>>2]|0)+11|0]=j;f=g;break}else{g=c[c[b+4>>2]>>2]|0;j=Wy(+h[g>>3],+h[(c[g+8>>2]|0)+840>>3])|0;a[(c[b+352>>2]|0)+11|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+12|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+12|0]|0;l=c[c[b+4>>2]>>2]|0;k=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+840>>3]+ +h[(c[b+416>>2]|0)+784>>3],a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=k;m=g;break}else{g=c[c[b+4>>2]>>2]|0;k=Sy(+h[g>>3],+h[(c[g+8>>2]|0)+840>>3]+ +h[(c[b+416>>2]|0)+784>>3],a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+12|0]|0;k=c[c[b+4>>2]>>2]|0;g=Uy(+h[k>>3],+h[(c[k+8>>2]|0)+840>>3]+ +h[(c[b+416>>2]|0)+784>>3])|0;a[(c[b+352>>2]|0)+12|0]=g;m=j;break}else{j=c[c[b+4>>2]>>2]|0;g=Uy(+h[j>>3],+h[(c[j+8>>2]|0)+840>>3]+ +h[(c[b+416>>2]|0)+784>>3])|0;a[(c[b+352>>2]|0)+12|0]=g;m=g;break}}}}while(0);if(f<<24>>24==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+5|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+5|0;z=y;a[z]=n;i=d;return}function Nf(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,17)|0;d=c[(c[a+476>>2]|0)+1116>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+856>>3]=+h[d>>3];h[e+904>>3]=+h[d+8>>3];h[e+848>>3]=+h[d+16>>3];h[e+872>>3]=+h[d+24>>3];h[e+832>>3]=+h[d+32>>3];h[e+880>>3]=+h[d+40>>3];h[e+864>>3]=+h[d+48>>3];h[e+816>>3]=+h[d+56>>3];h[e+824>>3]=+h[d+64>>3];h[e+896>>3]=+h[d+72>>3];h[e+912>>3]=+h[d+80>>3];i=b;return}function Of(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+920>>3]=-(+h[b+856>>3]*+h[b+104>>3])- +h[b+832>>3]*+h[b+824>>3];i=i;return}function Pf(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+792>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+832>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+168|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+168|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,1016,1008,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+168|0;p=o;h[p>>3]=m;i=d;return}function Qf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+888>>3]=+h[b+832>>3]*+h[b+816>>3];i=i;return}function Rf(b){b=b|0;var d=0,e=0;d=i;if((a[b+312|0]|0)!=0){h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+952>>3]=+h[(c[b+400>>2]|0)+952>>3];i=d;return}e=c[c[b+4>>2]>>2]|0;do{if((a[(c[e+16>>2]|0)+15|0]|0)!=0){if((a[(c[b+408>>2]|0)+15|0]|0)!=0){break}h[(c[e+8>>2]|0)+952>>3]=+h[e>>3];i=d;return}}while(0);h[(c[e+8>>2]|0)+952>>3]=+h[(c[b+400>>2]|0)+952>>3];i=d;return}function Sf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+9|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+9|0]|0;k=c[c[b+4>>2]>>2]|0;l=Ty(+h[k>>3],+h[(c[k+8>>2]|0)+952>>3],a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=l;f=j;break}else{j=c[c[b+4>>2]>>2]|0;l=Ty(+h[j>>3],+h[(c[j+8>>2]|0)+952>>3],a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+9|0]|0;l=c[c[b+4>>2]>>2]|0;j=Wy(+h[l>>3],+h[(c[l+8>>2]|0)+952>>3])|0;a[(c[b+352>>2]|0)+9|0]=j;f=g;break}else{g=c[c[b+4>>2]>>2]|0;j=Wy(+h[g>>3],+h[(c[g+8>>2]|0)+952>>3])|0;a[(c[b+352>>2]|0)+9|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+10|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+10|0]|0;l=c[c[b+4>>2]>>2]|0;k=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+952>>3]+ +h[(c[b+416>>2]|0)+680>>3],a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=k;m=g;break}else{g=c[c[b+4>>2]>>2]|0;k=Sy(+h[g>>3],+h[(c[g+8>>2]|0)+952>>3]+ +h[(c[b+416>>2]|0)+680>>3],a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+10|0]|0;k=c[c[b+4>>2]>>2]|0;g=Uy(+h[k>>3],+h[(c[k+8>>2]|0)+952>>3]+ +h[(c[b+416>>2]|0)+680>>3])|0;a[(c[b+352>>2]|0)+10|0]=g;m=j;break}else{j=c[c[b+4>>2]>>2]|0;g=Uy(+h[j>>3],+h[(c[j+8>>2]|0)+952>>3]+ +h[(c[b+416>>2]|0)+680>>3])|0;a[(c[b+352>>2]|0)+10|0]=g;m=g;break}}}}while(0);if(f<<24>>24==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+6|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+6|0;z=y;a[z]=n;i=d;return}function Tf(b){b=b|0;var d=0,e=0;d=i;if((a[b+312|0]|0)!=0){h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+1056>>3]=+h[(c[b+400>>2]|0)+1056>>3];i=d;return}e=c[c[b+4>>2]>>2]|0;do{if((a[(c[e+16>>2]|0)+14|0]|0)!=0){if((a[(c[b+408>>2]|0)+14|0]|0)!=0){break}h[(c[e+8>>2]|0)+1056>>3]=+h[e>>3];i=d;return}}while(0);h[(c[e+8>>2]|0)+1056>>3]=+h[(c[b+400>>2]|0)+1056>>3];i=d;return}function Uf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+7|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+7|0]|0;k=c[c[b+4>>2]>>2]|0;l=Ty(+h[k>>3],+h[(c[k+8>>2]|0)+1056>>3],a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=l;f=j;break}else{j=c[c[b+4>>2]>>2]|0;l=Ty(+h[j>>3],+h[(c[j+8>>2]|0)+1056>>3],a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+7|0]|0;l=c[c[b+4>>2]>>2]|0;j=Wy(+h[l>>3],+h[(c[l+8>>2]|0)+1056>>3])|0;a[(c[b+352>>2]|0)+7|0]=j;f=g;break}else{g=c[c[b+4>>2]>>2]|0;j=Wy(+h[g>>3],+h[(c[g+8>>2]|0)+1056>>3])|0;a[(c[b+352>>2]|0)+7|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+8|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+8|0]|0;l=c[c[b+4>>2]>>2]|0;k=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+1056>>3]+ +h[(c[b+416>>2]|0)+576>>3],a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=k;m=g;break}else{g=c[c[b+4>>2]>>2]|0;k=Sy(+h[g>>3],+h[(c[g+8>>2]|0)+1056>>3]+ +h[(c[b+416>>2]|0)+576>>3],a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+8|0]|0;k=c[c[b+4>>2]>>2]|0;g=Uy(+h[k>>3],+h[(c[k+8>>2]|0)+1056>>3]+ +h[(c[b+416>>2]|0)+576>>3])|0;a[(c[b+352>>2]|0)+8|0]=g;m=j;break}else{j=c[c[b+4>>2]>>2]|0;g=Uy(+h[j>>3],+h[(c[j+8>>2]|0)+1056>>3]+ +h[(c[b+416>>2]|0)+576>>3])|0;a[(c[b+352>>2]|0)+8|0]=g;m=g;break}}}}while(0);if(f<<24>>24==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+7|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+7|0;z=y;a[z]=n;i=d;return}function Vf(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,18)|0;d=c[(c[a+476>>2]|0)+1180>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1096>>3]=+h[d>>3];h[e+1080>>3]=+h[d+8>>3];h[e+1128>>3]=+h[d+16>>3];h[e+1120>>3]=+h[d+24>>3];h[e+1072>>3]=+h[d+32>>3];h[e+1112>>3]=+h[d+40>>3];h[e+1040>>3]=+h[d+48>>3];h[e+1032>>3]=+h[d+56>>3];h[e+1088>>3]=+h[d+64>>3];h[e+1064>>3]=+h[d+72>>3];h[e+1048>>3]=+h[d+80>>3];i=b;return}function Wf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1136>>3]=+h[b+1072>>3]*+h[b+112>>3]- +h[b+1048>>3]*+h[b+1040>>3];i=i;return}function Xf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1104>>3]=+h[b+1048>>3]*+h[b+1032>>3];i=i;return}function Yf(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+584>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1048>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+184|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+184|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,1040,1032,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+184|0;p=o;h[p>>3]=m;i=d;return}function Zf(b){b=b|0;var d=0,e=0;d=i;if((a[b+312|0]|0)!=0){h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+1168>>3]=+h[(c[b+400>>2]|0)+1168>>3];i=d;return}e=c[c[b+4>>2]>>2]|0;do{if((a[(c[e+16>>2]|0)+13|0]|0)!=0){if((a[(c[b+408>>2]|0)+13|0]|0)!=0){break}h[(c[e+8>>2]|0)+1168>>3]=+h[e>>3];i=d;return}}while(0);h[(c[e+8>>2]|0)+1168>>3]=+h[(c[b+400>>2]|0)+1168>>3];i=d;return}function _f(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+5|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+5|0]|0;k=c[c[b+4>>2]>>2]|0;l=Ty(+h[k>>3],+h[(c[k+8>>2]|0)+1168>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=l;f=j;break}else{j=c[c[b+4>>2]>>2]|0;l=Ty(+h[j>>3],+h[(c[j+8>>2]|0)+1168>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+5|0]|0;l=c[c[b+4>>2]>>2]|0;j=Wy(+h[l>>3],+h[(c[l+8>>2]|0)+1168>>3])|0;a[(c[b+352>>2]|0)+5|0]=j;f=g;break}else{g=c[c[b+4>>2]>>2]|0;j=Wy(+h[g>>3],+h[(c[g+8>>2]|0)+1168>>3])|0;a[(c[b+352>>2]|0)+5|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+6|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+6|0]|0;l=c[c[b+4>>2]>>2]|0;k=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+1168>>3]+ +h[(c[b+416>>2]|0)+472>>3],a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=k;m=g;break}else{g=c[c[b+4>>2]>>2]|0;k=Sy(+h[g>>3],+h[(c[g+8>>2]|0)+1168>>3]+ +h[(c[b+416>>2]|0)+472>>3],a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+6|0]|0;k=c[c[b+4>>2]>>2]|0;g=Uy(+h[k>>3],+h[(c[k+8>>2]|0)+1168>>3]+ +h[(c[b+416>>2]|0)+472>>3])|0;a[(c[b+352>>2]|0)+6|0]=g;m=j;break}else{j=c[c[b+4>>2]>>2]|0;g=Uy(+h[j>>3],+h[(c[j+8>>2]|0)+1168>>3]+ +h[(c[b+416>>2]|0)+472>>3])|0;a[(c[b+352>>2]|0)+6|0]=g;m=g;break}}}}while(0);if(f<<24>>24==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+8|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+8|0;z=y;a[z]=n;i=d;return}function $f(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,19)|0;d=c[(c[a+476>>2]|0)+1244>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1240>>3]=+h[d>>3];h[e+1232>>3]=+h[d+8>>3];h[e+1176>>3]=+h[d+16>>3];h[e+1200>>3]=+h[d+24>>3];h[e+1160>>3]=+h[d+32>>3];h[e+1208>>3]=+h[d+40>>3];h[e+1192>>3]=+h[d+48>>3];h[e+1144>>3]=+h[d+56>>3];h[e+1152>>3]=+h[d+64>>3];h[e+1224>>3]=+h[d+72>>3];h[e+1184>>3]=+h[d+80>>3];i=b;return}function ag(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1512>>3]=-+h[b+1176>>3]- +h[b+1064>>3];i=i;return}function bg(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+104>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1512>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+216|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+216|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,1064,1056,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+216|0;p=o;h[p>>3]=m;i=d;return}function cg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1528>>3]=+h[b+1512>>3]- +h[b+408>>3]- +h[b+632>>3];i=i;return}function dg(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+480>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1160>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+192|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+192|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,1080,1072,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+192|0;p=o;h[p>>3]=m;i=d;return}function eg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1216>>3]=+h[b+1160>>3]*+h[b+1144>>3];i=i;return}function fg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1248>>3]=+h[b+1184>>3]*+h[b+96>>3]- +h[b+1160>>3]*+h[b+1152>>3];i=i;return}function gg(b){b=b|0;var d=0,e=0;d=i;if((a[b+312|0]|0)!=0){h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+1280>>3]=+h[(c[b+400>>2]|0)+1280>>3];i=d;return}e=c[c[b+4>>2]>>2]|0;do{if((a[(c[e+16>>2]|0)+12|0]|0)!=0){if((a[(c[b+408>>2]|0)+12|0]|0)!=0){break}h[(c[e+8>>2]|0)+1280>>3]=+h[e>>3];i=d;return}}while(0);h[(c[e+8>>2]|0)+1280>>3]=+h[(c[b+400>>2]|0)+1280>>3];i=d;return}function hg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+3|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+3|0]|0;k=c[c[b+4>>2]>>2]|0;l=Ty(+h[k>>3],+h[(c[k+8>>2]|0)+1280>>3],a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=l;f=j;break}else{j=c[c[b+4>>2]>>2]|0;l=Ty(+h[j>>3],+h[(c[j+8>>2]|0)+1280>>3],a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+3|0]|0;l=c[c[b+4>>2]>>2]|0;j=Wy(+h[l>>3],+h[(c[l+8>>2]|0)+1280>>3])|0;a[(c[b+352>>2]|0)+3|0]=j;f=g;break}else{g=c[c[b+4>>2]>>2]|0;j=Wy(+h[g>>3],+h[(c[g+8>>2]|0)+1280>>3])|0;a[(c[b+352>>2]|0)+3|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+4|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+4|0]|0;l=c[c[b+4>>2]>>2]|0;k=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+1280>>3]+ +h[(c[b+416>>2]|0)+368>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=k;m=g;break}else{g=c[c[b+4>>2]>>2]|0;k=Sy(+h[g>>3],+h[(c[g+8>>2]|0)+1280>>3]+ +h[(c[b+416>>2]|0)+368>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+4|0]|0;k=c[c[b+4>>2]>>2]|0;g=Uy(+h[k>>3],+h[(c[k+8>>2]|0)+1280>>3]+ +h[(c[b+416>>2]|0)+368>>3])|0;a[(c[b+352>>2]|0)+4|0]=g;m=j;break}else{j=c[c[b+4>>2]>>2]|0;g=Uy(+h[j>>3],+h[(c[j+8>>2]|0)+1280>>3]+ +h[(c[b+416>>2]|0)+368>>3])|0;a[(c[b+352>>2]|0)+4|0]=g;m=g;break}}}}while(0);if(f<<24>>24==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+9|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+9|0;z=y;a[z]=n;i=d;return}function ig(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,20)|0;d=c[(c[a+476>>2]|0)+1308>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1296>>3]=+h[d>>3];h[e+1336>>3]=+h[d+8>>3];h[e+1288>>3]=+h[d+16>>3];h[e+1312>>3]=+h[d+24>>3];h[e+1272>>3]=+h[d+32>>3];h[e+1320>>3]=+h[d+40>>3];h[e+1304>>3]=+h[d+48>>3];h[e+1256>>3]=+h[d+56>>3];h[e+1264>>3]=+h[d+64>>3];h[e+1344>>3]=+h[d+72>>3];h[e+1352>>3]=+h[d+80>>3];i=b;return}function jg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1360>>3]=+h[b+1296>>3]*+h[b+112>>3]- +h[b+1272>>3]*+h[b+1264>>3];i=i;return}function kg(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+376>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1272>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+200|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+200|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,1104,1096,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+200|0;p=o;h[p>>3]=m;i=d;return}function lg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1328>>3]=+h[b+1272>>3]*+h[b+1256>>3];i=i;return}function mg(b){b=b|0;var d=0,e=0;d=i;if((a[b+312|0]|0)!=0){h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+1392>>3]=+h[(c[b+400>>2]|0)+1392>>3];i=d;return}e=c[c[b+4>>2]>>2]|0;do{if((a[(c[e+16>>2]|0)+11|0]|0)!=0){if((a[(c[b+408>>2]|0)+11|0]|0)!=0){break}h[(c[e+8>>2]|0)+1392>>3]=+h[e>>3];i=d;return}}while(0);h[(c[e+8>>2]|0)+1392>>3]=+h[(c[b+400>>2]|0)+1392>>3];i=d;return}function ng(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+1|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+1|0]|0;k=c[c[b+4>>2]>>2]|0;l=Ty(+h[k>>3],+h[(c[k+8>>2]|0)+1392>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=l;f=j;break}else{j=c[c[b+4>>2]>>2]|0;l=Ty(+h[j>>3],+h[(c[j+8>>2]|0)+1392>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+1|0]|0;l=c[c[b+4>>2]>>2]|0;j=Wy(+h[l>>3],+h[(c[l+8>>2]|0)+1392>>3])|0;a[(c[b+352>>2]|0)+1|0]=j;f=g;break}else{g=c[c[b+4>>2]>>2]|0;j=Wy(+h[g>>3],+h[(c[g+8>>2]|0)+1392>>3])|0;a[(c[b+352>>2]|0)+1|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+2|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+2|0]|0;l=c[c[b+4>>2]>>2]|0;k=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+1392>>3]+ +h[(c[b+416>>2]|0)+264>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=k;m=g;break}else{g=c[c[b+4>>2]>>2]|0;k=Sy(+h[g>>3],+h[(c[g+8>>2]|0)+1392>>3]+ +h[(c[b+416>>2]|0)+264>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+2|0]|0;k=c[c[b+4>>2]>>2]|0;g=Uy(+h[k>>3],+h[(c[k+8>>2]|0)+1392>>3]+ +h[(c[b+416>>2]|0)+264>>3])|0;a[(c[b+352>>2]|0)+2|0]=g;m=j;break}else{j=c[c[b+4>>2]>>2]|0;g=Uy(+h[j>>3],+h[(c[j+8>>2]|0)+1392>>3]+ +h[(c[b+416>>2]|0)+264>>3])|0;a[(c[b+352>>2]|0)+2|0]=g;m=g;break}}}}while(0);if(f<<24>>24==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+10|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+10|0;z=y;a[z]=n;i=d;return}function og(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,21)|0;d=c[(c[a+476>>2]|0)+1372>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1408>>3]=+h[d>>3];h[e+1448>>3]=+h[d+8>>3];h[e+1400>>3]=+h[d+16>>3];h[e+1424>>3]=+h[d+24>>3];h[e+1384>>3]=+h[d+32>>3];h[e+1432>>3]=+h[d+40>>3];h[e+1416>>3]=+h[d+48>>3];h[e+1368>>3]=+h[d+56>>3];h[e+1376>>3]=+h[d+64>>3];h[e+1456>>3]=+h[d+72>>3];h[e+1464>>3]=+h[d+80>>3];i=b;return}function pg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1584>>3]=-+h[b+1400>>3]- +h[b+1288>>3];i=i;return}function qg(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+72>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1584>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+232|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+232|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,1128,1120,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+232|0;p=o;h[p>>3]=m;i=d;return}function rg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1552>>3]=+h[b+1584>>3]- +h[b+520>>3]- +h[b+856>>3];i=i;return}function sg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1472>>3]=-(+h[b+1408>>3]*+h[b+120>>3])- +h[b+1384>>3]*+h[b+1376>>3];i=i;return}function tg(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+272>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1384>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+208|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+208|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,1144,1136,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+208|0;p=o;h[p>>3]=m;i=d;return}function ug(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1440>>3]=+h[b+1384>>3]*+h[b+1368>>3];i=i;return}function vg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;do{if((a[b+314|0]|0)==0){e=b+416|0;f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=b+416|0;l=Sy(+h[c[c[b+4>>2]>>2]>>3],+h[(c[k>>2]|0)+160>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=l;e=k;f=j;break}else{j=b+416|0;k=Sy(+h[c[c[b+4>>2]>>2]>>3],+h[(c[j>>2]|0)+160>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;e=j;f=k;break}}else{if(g){g=a[c[b+356>>2]|0]|0;k=b+416|0;j=Uy(+h[c[c[b+4>>2]>>2]>>3],+h[(c[k>>2]|0)+160>>3])|0;a[c[b+352>>2]|0]=j;e=k;f=g;break}else{g=b+416|0;k=Uy(+h[c[c[b+4>>2]>>2]>>3],+h[(c[g>>2]|0)+160>>3])|0;a[c[b+352>>2]|0]=k;e=g;f=k;break}}}}while(0);k=c[e>>2]|0;m=+h[k+152>>3];if(!(f<<24>>24==0)){n=0.0;o=m+n;p=b;q=p+4|0;r=q;s=c[r>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;x=c[w>>2]|0;y=x;z=y+1488|0;A=z;h[A>>3]=o;i=d;return}n=+h[k+168>>3];o=m+n;p=b;q=p+4|0;r=q;s=c[r>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;x=c[w>>2]|0;y=x;z=y+1488|0;A=z;h[A>>3]=o;i=d;return}function wg(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,22)|0;d=c[(c[a+476>>2]|0)+1436>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+984>>3]=+h[d>>3];h[e+968>>3]=+h[d+8>>3];h[e+1016>>3]=+h[d+16>>3];h[e+1e3>>3]=+h[d+24>>3];h[e+936>>3]=+h[d+32>>3];h[e+928>>3]=+h[d+40>>3];h[e+976>>3]=+h[d+48>>3];h[e+960>>3]=+h[d+56>>3];h[e+944>>3]=+h[d+64>>3];h[e+1480>>3]=+h[d+72>>3];h[e+1008>>3]=+h[d+80>>3];i=b;return}function xg(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,23)|0;d=c[(c[a+476>>2]|0)+1500>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1536>>3]=+h[d>>3];h[e+1600>>3]=+h[d+8>>3];h[e+248>>3]=+h[d+16>>3];h[e+1568>>3]=+h[d+24>>3];h[e+1576>>3]=+h[d+32>>3];h[e+224>>3]=+h[d+40>>3];h[e+1496>>3]=+h[d+48>>3];h[e+1504>>3]=+h[d+56>>3];h[e+240>>3]=+h[d+64>>3];h[e+1592>>3]=+h[d+72>>3];i=b;return}function yg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1560>>3]=+h[b+1600>>3]- +h[b+1568>>3]- +h[b+736>>3]- +h[b+1408>>3];i=i;return}function zg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1520>>3]=+h[b+1496>>3]- +h[b+1576>>3]- +h[b+288>>3]- +h[b+1184>>3];i=i;return}function Ag(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1544>>3]=+h[b+1536>>3]- +h[b+1504>>3]- +h[b+1592>>3]- +h[b+1072>>3]- +h[b+1296>>3];i=i;return}function Bg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+992>>3]=+h[b+944>>3]*+h[b+928>>3];i=i;return}function Cg(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+688>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+944>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+176|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+176|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,1168,1160,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+176|0;p=o;h[p>>3]=m;i=d;return}function Dg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1024>>3]=-(+h[b+1480>>3]*+h[b+1488>>3])- +h[b+944>>3]*+h[b+936>>3];i=i;return}function Eg(b){b=b|0;var c=0;c=i;a[b+315|0]=0;a[b+314|0]=1;Xe(b);Ye(b);Ze(b);_e(b);$e(b);af(b);bf(b);cf(b);df(b);ef(b);ff(b);gf(b);hf(b);jf(b);kf(b);lf(b);mf(b);nf(b);of(b);pf(b);qf(b);rf(b);sf(b);tf(b);uf(b);vf(b);wf(b);xf(b);yf(b);zf(b);Af(b);Bf(b);Cf(b);Df(b);Ef(b);Ff(b);Gf(b);Hf(b);If(b);Jf(b);Kf(b);Lf(b);Mf(b);Nf(b);Of(b);Pf(b);Qf(b);Rf(b);Sf(b);Tf(b);Uf(b);Vf(b);Wf(b);Xf(b);Yf(b);Zf(b);_f(b);$f(b);ag(b);bg(b);cg(b);dg(b);eg(b);fg(b);gg(b);hg(b);ig(b);jg(b);kg(b);lg(b);mg(b);ng(b);og(b);pg(b);qg(b);rg(b);sg(b);tg(b);ug(b);vg(b);wg(b);xg(b);yg(b);zg(b);Ag(b);Bg(b);Cg(b);Dg(b);i=c;return 0}function Fg(b){b=b|0;var c=0;c=i;a[b+314|0]=0;Gg(b);i=c;return 0}function Gg(a){a=a|0;var b=0;b=i;Xe(a);Ye(a);Ze(a);_e(a);$e(a);af(a);bf(a);cf(a);df(a);ef(a);ff(a);hf(a);jf(a);lf(a);of(a);pf(a);qf(a);uf(a);vf(a);xf(a);Af(a);Bf(a);Ef(a);Gf(a);Hf(a);Jf(a);Mf(a);Nf(a);Pf(a);Sf(a);Uf(a);Vf(a);Yf(a);_f(a);$f(a);ag(a);bg(a);dg(a);hg(a);ig(a);kg(a);ng(a);og(a);pg(a);qg(a);tg(a);vg(a);wg(a);xg(a);Cg(a);i=b;return}function Hg(a,b){a=a|0;b=+b;i=i;return 0}function Ig(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;jw(c[a+536>>2]|0,(a|0)!=0|0,1392,b);c[a+540>>2]=1200;c[a+84>>2]=1424;c[a+88>>2]=1424;c[a+92>>2]=1480;c[a+96>>2]=1560;c[a+100>>2]=0;c[a+60>>2]=0;c[a+112>>2]=16;c[a+116>>2]=258;c[a+120>>2]=11;c[a+124>>2]=0;c[a+128>>2]=22;c[a+132>>2]=0;c[a+136>>2]=165;c[a+140>>2]=0;c[a+144>>2]=22;c[a+148>>2]=0;c[a+152>>2]=0;c[a+156>>2]=0;c[a+232>>2]=5;c[a+216>>2]=284;c[a+220>>2]=0;c[a+224>>2]=22;c[a+228>>2]=0;c[a+160>>2]=12;c[a+104>>2]=11;c[a+164>>2]=23;c[a+168>>2]=0;c[a+176>>2]=11;c[a+180>>2]=0;c[a+184>>2]=11;c[a+188>>2]=0;c[a+56>>2]=1600;c[a+64>>2]=0;c[a+72>>2]=0;c[a+68>>2]=549;c[a+192>>2]=0;c[a+196>>2]=24;c[a+172>>2]=0;d=a+200|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;i=b;return}function Jg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=i;e=i;i=i+168|0;c[e>>2]=0;f=i;i=i+544|0;g=i;i=i+88|0;h=i;i=i+160|0;j=i;i=i+160|0;u=0;Ma(3);k=u;u=0;if((k|0)!=0&(v|0)!=0){l=K_(c[k>>2]|0,e)|0;if((l|0)==0){bb(k|0,v|0)}J=v}else{l=-1}k=J;do{if((l|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=k}else if((l|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=k;D=7}else{E=36464;F=36488;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[E+12>>2]=c[F+12>>2];c[E+16>>2]=c[F+16>>2];c[E+20>>2]=c[F+20>>2];u=0;Ma(c[9116]|0);F=u;u=0;if((F|0)!=0&(v|0)!=0){G=K_(c[F>>2]|0,e)|0;if((G|0)==0){bb(F|0,v|0)}J=v}else{G=-1}F=J;if((G|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=F;break}else if((G|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=F;D=7;break}F=g;E=F+0|0;H=E+88|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(H|0));u=0;E=sa(98,c[8466]|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){I=K_(c[H>>2]|0,e)|0;if((I|0)==0){bb(H|0,v|0)}J=v}else{I=-1}H=J;if((I|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((I|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}u=0;Fa(47,c[8466]|0,F|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){K=K_(c[H>>2]|0,e)|0;if((K|0)==0){bb(H|0,v|0)}J=v}else{K=-1}H=J;if((K|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((K|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}H=h;c[g>>2]=h;w_(h,2,e|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=K_(c[L>>2]|0,e)|0;if((M|0)==0){bb(L|0,v|0)}J=v}else{M=-1}L=J;if((M|0)==1){m=0;n=0;o=0;p=H;q=E;s=F;t=L;break}else if((M|0)==2){w=0;x=0;y=0;z=H;A=E;B=F;C=L;D=7;break}w=0;x=0;y=0;z=H;A=E;B=F;C=0;D=7}}while(0);while(1){if((D|0)==7){D=0;if((C|0)==0){M=j;h=g+4|0;K=c[h>>2]|0;c[h>>2]=j;w_(j,1,e|0)|0;u=0;I=u;u=0;if((I|0)!=0&(v|0)!=0){N=K_(c[I>>2]|0,e)|0;if((N|0)==0){bb(I|0,v|0)}J=v}else{N=-1}I=J;if((N|0)==1){m=K;n=h;o=M;p=z;q=A;s=B;t=I;continue}else if((N|0)==2){O=B;P=A;Q=z;w=K;x=h;y=M;C=I;B=O;A=P;z=Q;D=7;continue}m=K;n=h;o=M;p=z;q=A;s=B;t=0;continue}else{u=0;Fa(47,c[8466]|0,A|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){R=K_(c[M>>2]|0,e)|0;if((R|0)==0){bb(M|0,v|0)}J=v}else{R=-1}M=J;if((R|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((R|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}u=0;Ma(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){V=K_(c[M>>2]|0,e)|0;if((V|0)==0){bb(M|0,v|0)}J=v}else{V=-1}M=J;if((V|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((V|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}else{D=18;break}}}if((t|0)!=0){u=0;Ma(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){W=K_(c[M>>2]|0,e)|0;if((W|0)==0){bb(M|0,v|0)}J=v}else{W=-1}M=J;if((W|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((W|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}M=c[r>>2]|0;u=0;Oa(34,1664,154,1,M|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ba=K_(c[M>>2]|0,e)|0;if((ba|0)==0){bb(M|0,v|0)}J=v}else{ba=-1}M=J;if((ba|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ba|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ca=K_(c[M>>2]|0,e)|0;if((ca|0)==0){bb(M|0,v|0)}J=v}else{ca=-1}M=J;if((ca|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ca|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;sa(99,0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){da=K_(c[M>>2]|0,e)|0;if((da|0)==0){bb(M|0,v|0)}J=v}else{da=-1}M=J;if((da|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((da|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}else{D=15;break}}u=0;pa(137,f|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ea=K_(c[M>>2]|0,e)|0;if((ea|0)==0){bb(M|0,v|0)}J=v}else{ea=-1}M=J;if((ea|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ea|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}c[f+536>>2]=g;u=0;M=wa(31,a|0,b|0,f|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){fa=K_(c[h>>2]|0,e)|0;if((fa|0)==0){bb(h|0,v|0)}J=v}else{fa=-1}h=J;if((fa|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((fa|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}c[n>>2]=m;u=0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ga=K_(c[h>>2]|0,e)|0;if((ga|0)==0){bb(h|0,v|0)}J=v}else{ga=-1}h=J;if((ga|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ga|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;Fa(47,c[8466]|0,q|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ha=K_(c[h>>2]|0,e)|0;if((ha|0)==0){bb(h|0,v|0)}J=v}else{ha=-1}h=J;if((ha|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ha|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ia=K_(c[h>>2]|0,e)|0;if((ia|0)==0){bb(h|0,v|0)}J=v}else{ia=-1}h=J;if((ia|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ia|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ja=K_(c[h>>2]|0,e)|0;if((ja|0)==0){bb(h|0,v|0)}J=v}else{ja=-1}h=J;if((ja|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ja|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;pa(138,M|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ka=K_(c[M>>2]|0,e)|0;if((ka|0)==0){bb(M|0,v|0)}J=v}else{ka=-1}M=J;if((ka|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa}else if((ka|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7}else{D=26;break}}if((D|0)==15){la=p;ma=s;i=d;return 1}else if((D|0)==18){la=z;ma=B;i=d;return 1}return 0}function Kg(){var a=0;a=i;qd(0)|0;nc(1824,18,1,c[r>>2]|0)|0;qd(0)|0;i=a;return}function Lg(a){a=a|0;var b=0;a=i;i=i+8|0;b=i;i=i+8|0;gw(4,0,1848,b);gw(4,0,1888,a);i=a;return}function Mg(a){a=a|0;var b=0,d=0;b=i;d=a+320|0;a=c[d>>2]|0;if((a|0)==0){i=b;return}WZ(a);c[d>>2]=0;i=b;return}function Ng(a){a=a|0;i=i;return}function Og(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,6,1.0,0,d);g=b+4|0;if((a[c[(c[c[g>>2]>>2]|0)+16>>2]|0]|0)==0){j=+h[(c[b+416>>2]|0)+1240>>3]}else{j=1.0}ze[c[f>>2]&3](0,10,-j,1,d);ze[c[f>>2]&3](1,9,1.0,2,d);if((a[c[(c[c[g>>2]>>2]|0)+16>>2]|0]|0)==0){k=1.0}else{k=+h[(c[b+416>>2]|0)+1248>>3]}ze[c[f>>2]&3](1,10,k,3,d);ze[c[f>>2]&3](2,2,1.0,4,d);ze[c[f>>2]&3](2,8,-1.0,5,d);ze[c[f>>2]&3](2,9,-1.0,6,d);if((a[c[(c[c[g>>2]>>2]|0)+16>>2]|0]|0)==0){l=+h[(c[b+416>>2]|0)+1248>>3]}else{l=1.0}ze[c[f>>2]&3](3,7,l,7,d);ze[c[f>>2]&3](3,8,1.0,8,d);ze[c[f>>2]&3](4,6,1.0,9,d);if((a[c[(c[c[g>>2]>>2]|0)+16>>2]|0]|0)==0){m=1.0}else{m=+h[(c[b+416>>2]|0)+1240>>3]}ze[c[f>>2]&3](4,7,-m,10,d);ze[c[f>>2]&3](5,5,1.0,11,d);ze[c[f>>2]&3](5,6,-1.0,12,d);if((a[c[(c[c[g>>2]>>2]|0)+16>>2]|0]|0)==0){n=+h[(c[b+416>>2]|0)+1264>>3]}else{n=1.0}ze[c[f>>2]&3](6,4,-n,13,d);ze[c[f>>2]&3](6,5,1.0,14,d);ze[c[f>>2]&3](7,3,1.0,15,d);if((a[c[(c[c[g>>2]>>2]|0)+16>>2]|0]|0)==0){o=1.0}else{o=+h[(c[b+416>>2]|0)+1272>>3]}ze[c[f>>2]&3](7,4,o,16,d);ze[c[f>>2]&3](8,0,-1.0,17,d);ze[c[f>>2]&3](8,2,-1.0,18,d);ze[c[f>>2]&3](8,3,-1.0,19,d);if((a[c[(c[c[g>>2]>>2]|0)+16>>2]|0]|0)==0){p=1.0}else{p=+h[(c[b+416>>2]|0)+1264>>3]}ze[c[f>>2]&3](9,1,-p,20,d);ze[c[f>>2]&3](9,5,1.0,21,d);ze[c[f>>2]&3](10,0,1.0,22,d);q=c[f>>2]|0;if((a[c[(c[c[g>>2]>>2]|0)+16>>2]|0]|0)!=0){r=1.0;ze[q&3](10,1,r,23,d);i=e;return}r=+h[(c[b+416>>2]|0)+1272>>3];ze[q&3](10,1,r,23,d);i=e;return}function Pg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[b+36>>2]|0;b=a+4|0;a=e+0|0;f=a+40|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(f|0));a=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[e+40>>3]=-+h[a>>3];h[e+48>>3]=+h[a+96>>3];a=e+56|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=0;i=d;return}function Qg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,2,1.0,0,d);g=b+4|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+1|0]|0)==0){j=+h[(c[b+416>>2]|0)+1136>>3]}else{j=1.0}ze[c[f>>2]&3](0,10,-j,1,d);ze[c[f>>2]&3](1,9,1.0,2,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+1|0]|0)==0){k=1.0}else{k=+h[(c[b+416>>2]|0)+1144>>3]}ze[c[f>>2]&3](1,10,k,3,d);ze[c[f>>2]&3](2,0,-1.0,4,d);ze[c[f>>2]&3](2,8,1.0,5,d);ze[c[f>>2]&3](2,9,-1.0,6,d);ze[c[f>>2]&3](3,3,-1.0,7,d);ze[c[f>>2]&3](3,7,-1.0,8,d);ze[c[f>>2]&3](3,8,-1.0,9,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+1|0]|0)==0){l=1.0}else{l=+h[(c[b+416>>2]|0)+1168>>3]}ze[c[f>>2]&3](4,6,l,10,d);ze[c[f>>2]&3](4,7,1.0,11,d);ze[c[f>>2]&3](5,5,1.0,12,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+1|0]|0)==0){m=+h[(c[b+416>>2]|0)+1160>>3]}else{m=1.0}ze[c[f>>2]&3](5,6,-m,13,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+1|0]|0)==0){n=1.0}else{n=+h[(c[b+416>>2]|0)+1160>>3]}ze[c[f>>2]&3](6,4,-n,14,d);ze[c[f>>2]&3](6,5,1.0,15,d);ze[c[f>>2]&3](7,3,1.0,16,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+1|0]|0)==0){o=+h[(c[b+416>>2]|0)+1168>>3]}else{o=1.0}ze[c[f>>2]&3](7,4,o,17,d);ze[c[f>>2]&3](8,2,-1.0,18,d);ze[c[f>>2]&3](8,5,1.0,19,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+1|0]|0)==0){p=1.0}else{p=+h[(c[b+416>>2]|0)+1136>>3]}ze[c[f>>2]&3](9,1,-p,20,d);ze[c[f>>2]&3](9,2,1.0,21,d);ze[c[f>>2]&3](10,0,1.0,22,d);q=c[f>>2]|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+1|0]|0)!=0){r=1.0;ze[q&3](10,1,r,23,d);i=e;return}r=+h[(c[b+416>>2]|0)+1144>>3];ze[q&3](10,1,r,23,d);i=e;return}function Rg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=-+h[e+88>>3];b=e+8|0;e=a+8|0;f=e+56|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));h[a+64>>3]=-+h[b>>3];b=a+72|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;i=d;return}function Sg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,2,1.0,0,d);g=b+4|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+2|0]|0)==0){j=+h[(c[b+416>>2]|0)+1032>>3]}else{j=1.0}ze[c[f>>2]&3](0,10,-j,1,d);ze[c[f>>2]&3](1,9,1.0,2,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+2|0]|0)==0){k=1.0}else{k=+h[(c[b+416>>2]|0)+1040>>3]}ze[c[f>>2]&3](1,10,k,3,d);ze[c[f>>2]&3](2,0,-1.0,4,d);ze[c[f>>2]&3](2,8,1.0,5,d);ze[c[f>>2]&3](2,9,-1.0,6,d);ze[c[f>>2]&3](3,3,-1.0,7,d);ze[c[f>>2]&3](3,7,-1.0,8,d);ze[c[f>>2]&3](3,8,-1.0,9,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+2|0]|0)==0){l=+h[(c[b+416>>2]|0)+1064>>3]}else{l=1.0}ze[c[f>>2]&3](4,6,l,10,d);ze[c[f>>2]&3](4,7,1.0,11,d);ze[c[f>>2]&3](5,5,1.0,12,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+2|0]|0)==0){m=1.0}else{m=+h[(c[b+416>>2]|0)+1056>>3]}ze[c[f>>2]&3](5,6,-m,13,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+2|0]|0)==0){n=+h[(c[b+416>>2]|0)+1056>>3]}else{n=1.0}ze[c[f>>2]&3](6,4,-n,14,d);ze[c[f>>2]&3](6,5,1.0,15,d);ze[c[f>>2]&3](7,3,1.0,16,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+2|0]|0)==0){o=1.0}else{o=+h[(c[b+416>>2]|0)+1064>>3]}ze[c[f>>2]&3](7,4,o,17,d);ze[c[f>>2]&3](8,2,-1.0,18,d);ze[c[f>>2]&3](8,5,1.0,19,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+2|0]|0)==0){p=1.0}else{p=+h[(c[b+416>>2]|0)+1032>>3]}ze[c[f>>2]&3](9,1,-p,20,d);ze[c[f>>2]&3](9,2,1.0,21,d);ze[c[f>>2]&3](10,0,1.0,22,d);q=c[f>>2]|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+2|0]|0)!=0){r=1.0;ze[q&3](10,1,r,23,d);i=e;return}r=+h[(c[b+416>>2]|0)+1040>>3];ze[q&3](10,1,r,23,d);i=e;return}function Tg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=-+h[e+104>>3];b=e+16|0;e=a+8|0;f=e+56|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));h[a+64>>3]=-+h[b>>3];b=a+72|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;i=d;return}function Ug(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0;e=i;f=d+8|0;g=b+4|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+3|0]|0)==0){j=+h[(c[b+416>>2]|0)+928>>3]}else{j=1.0}ze[c[f>>2]&3](0,6,-j,0,d);ze[c[f>>2]&3](0,10,1.0,1,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+3|0]|0)==0){k=1.0}else{k=+h[(c[b+416>>2]|0)+928>>3]}ze[c[f>>2]&3](1,9,-k,2,d);ze[c[f>>2]&3](1,10,1.0,3,d);ze[c[f>>2]&3](2,8,1.0,4,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+3|0]|0)==0){l=+h[(c[b+416>>2]|0)+936>>3]}else{l=1.0}ze[c[f>>2]&3](2,9,l,5,d);ze[c[f>>2]&3](3,2,1.0,6,d);ze[c[f>>2]&3](3,7,-1.0,7,d);ze[c[f>>2]&3](3,8,-1.0,8,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+3|0]|0)==0){m=1.0}else{m=+h[(c[b+416>>2]|0)+936>>3]}ze[c[f>>2]&3](4,6,m,9,d);ze[c[f>>2]&3](4,7,1.0,10,d);ze[c[f>>2]&3](5,5,1.0,11,d);ze[c[f>>2]&3](5,10,-1.0,12,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+3|0]|0)==0){n=+h[(c[b+416>>2]|0)+952>>3]}else{n=1.0}ze[c[f>>2]&3](6,4,-n,13,d);ze[c[f>>2]&3](6,5,1.0,14,d);ze[c[f>>2]&3](7,3,1.0,15,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+3|0]|0)==0){o=1.0}else{o=+h[(c[b+416>>2]|0)+960>>3]}ze[c[f>>2]&3](7,4,o,16,d);ze[c[f>>2]&3](8,0,-1.0,17,d);ze[c[f>>2]&3](8,2,-1.0,18,d);ze[c[f>>2]&3](8,3,-1.0,19,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+3|0]|0)==0){p=1.0}else{p=+h[(c[b+416>>2]|0)+952>>3]}ze[c[f>>2]&3](9,1,-p,20,d);ze[c[f>>2]&3](9,5,1.0,21,d);ze[c[f>>2]&3](10,0,1.0,22,d);q=c[f>>2]|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+3|0]|0)!=0){r=1.0;ze[q&3](10,1,r,23,d);i=e;return}r=+h[(c[b+416>>2]|0)+960>>3];ze[q&3](10,1,r,23,d);i=e;return}function Vg(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=-+h[e+88>>3];b=e+24|0;e=a+8|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;c[e+28>>2]=0;h[a+40>>3]=-+h[b>>3];b=a+48|0;a=b+40|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));i=d;return}function Wg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0;e=i;f=d+8|0;g=b+4|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+4|0]|0)==0){j=+h[(c[b+416>>2]|0)+824>>3]}else{j=1.0}ze[c[f>>2]&3](0,6,-j,0,d);ze[c[f>>2]&3](0,10,1.0,1,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+4|0]|0)==0){k=1.0}else{k=+h[(c[b+416>>2]|0)+824>>3]}ze[c[f>>2]&3](1,9,-k,2,d);ze[c[f>>2]&3](1,10,1.0,3,d);ze[c[f>>2]&3](2,8,1.0,4,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+4|0]|0)==0){l=+h[(c[b+416>>2]|0)+832>>3]}else{l=1.0}ze[c[f>>2]&3](2,9,l,5,d);ze[c[f>>2]&3](3,2,1.0,6,d);ze[c[f>>2]&3](3,7,-1.0,7,d);ze[c[f>>2]&3](3,8,-1.0,8,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+4|0]|0)==0){m=1.0}else{m=+h[(c[b+416>>2]|0)+832>>3]}ze[c[f>>2]&3](4,6,m,9,d);ze[c[f>>2]&3](4,7,1.0,10,d);ze[c[f>>2]&3](5,5,1.0,11,d);ze[c[f>>2]&3](5,10,-1.0,12,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+4|0]|0)==0){n=+h[(c[b+416>>2]|0)+848>>3]}else{n=1.0}ze[c[f>>2]&3](6,4,-n,13,d);ze[c[f>>2]&3](6,5,1.0,14,d);ze[c[f>>2]&3](7,3,1.0,15,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+4|0]|0)==0){o=1.0}else{o=+h[(c[b+416>>2]|0)+856>>3]}ze[c[f>>2]&3](7,4,o,16,d);ze[c[f>>2]&3](8,0,-1.0,17,d);ze[c[f>>2]&3](8,2,-1.0,18,d);ze[c[f>>2]&3](8,3,-1.0,19,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+4|0]|0)==0){p=1.0}else{p=+h[(c[b+416>>2]|0)+848>>3]}ze[c[f>>2]&3](9,1,-p,20,d);ze[c[f>>2]&3](9,5,1.0,21,d);ze[c[f>>2]&3](10,0,1.0,22,d);q=c[f>>2]|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+4|0]|0)!=0){r=1.0;ze[q&3](10,1,r,23,d);i=e;return}r=+h[(c[b+416>>2]|0)+856>>3];ze[q&3](10,1,r,23,d);i=e;return}function Xg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[b+36>>2]|0;b=a+4|0;a=e+0|0;f=a+40|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(f|0));a=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[e+40>>3]=-+h[a+32>>3];h[e+48>>3]=-+h[a+120>>3];a=e+56|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=0;i=d;return}function Yg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,2,1.0,0,d);g=b+4|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+5|0]|0)==0){j=+h[(c[b+416>>2]|0)+720>>3]}else{j=1.0}ze[c[f>>2]&3](0,10,-j,1,d);ze[c[f>>2]&3](1,9,1.0,2,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+5|0]|0)==0){k=1.0}else{k=+h[(c[b+416>>2]|0)+728>>3]}ze[c[f>>2]&3](1,10,k,3,d);ze[c[f>>2]&3](2,0,-1.0,4,d);ze[c[f>>2]&3](2,8,1.0,5,d);ze[c[f>>2]&3](2,9,-1.0,6,d);ze[c[f>>2]&3](3,3,-1.0,7,d);ze[c[f>>2]&3](3,7,-1.0,8,d);ze[c[f>>2]&3](3,8,-1.0,9,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+5|0]|0)==0){l=1.0}else{l=+h[(c[b+416>>2]|0)+752>>3]}ze[c[f>>2]&3](4,6,l,10,d);ze[c[f>>2]&3](4,7,1.0,11,d);ze[c[f>>2]&3](5,5,1.0,12,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+5|0]|0)==0){m=+h[(c[b+416>>2]|0)+744>>3]}else{m=1.0}ze[c[f>>2]&3](5,6,-m,13,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+5|0]|0)==0){n=1.0}else{n=+h[(c[b+416>>2]|0)+744>>3]}ze[c[f>>2]&3](6,4,-n,14,d);ze[c[f>>2]&3](6,5,1.0,15,d);ze[c[f>>2]&3](7,3,1.0,16,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+5|0]|0)==0){o=+h[(c[b+416>>2]|0)+752>>3]}else{o=1.0}ze[c[f>>2]&3](7,4,o,17,d);ze[c[f>>2]&3](8,2,-1.0,18,d);ze[c[f>>2]&3](8,5,1.0,19,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+5|0]|0)==0){p=1.0}else{p=+h[(c[b+416>>2]|0)+720>>3]}ze[c[f>>2]&3](9,1,-p,20,d);ze[c[f>>2]&3](9,2,1.0,21,d);ze[c[f>>2]&3](10,0,1.0,22,d);q=c[f>>2]|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+5|0]|0)!=0){r=1.0;ze[q&3](10,1,r,23,d);i=e;return}r=+h[(c[b+416>>2]|0)+728>>3];ze[q&3](10,1,r,23,d);i=e;return}function Zg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=-+h[e+104>>3];b=e+40|0;e=a+8|0;f=e+56|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));h[a+64>>3]=-+h[b>>3];b=a+72|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;i=d;return}function _g(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,6,1.0,0,d);g=b+4|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+6|0]|0)==0){j=+h[(c[b+416>>2]|0)+616>>3]}else{j=1.0}ze[c[f>>2]&3](0,10,-j,1,d);ze[c[f>>2]&3](1,9,1.0,2,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+6|0]|0)==0){k=1.0}else{k=+h[(c[b+416>>2]|0)+624>>3]}ze[c[f>>2]&3](1,10,k,3,d);ze[c[f>>2]&3](2,2,1.0,4,d);ze[c[f>>2]&3](2,8,-1.0,5,d);ze[c[f>>2]&3](2,9,-1.0,6,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+6|0]|0)==0){l=+h[(c[b+416>>2]|0)+624>>3]}else{l=1.0}ze[c[f>>2]&3](3,7,l,7,d);ze[c[f>>2]&3](3,8,1.0,8,d);ze[c[f>>2]&3](4,6,1.0,9,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+6|0]|0)==0){m=1.0}else{m=+h[(c[b+416>>2]|0)+616>>3]}ze[c[f>>2]&3](4,7,-m,10,d);ze[c[f>>2]&3](5,5,1.0,11,d);ze[c[f>>2]&3](5,6,-1.0,12,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+6|0]|0)==0){n=+h[(c[b+416>>2]|0)+640>>3]}else{n=1.0}ze[c[f>>2]&3](6,4,-n,13,d);ze[c[f>>2]&3](6,5,1.0,14,d);ze[c[f>>2]&3](7,3,1.0,15,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+6|0]|0)==0){o=1.0}else{o=+h[(c[b+416>>2]|0)+648>>3]}ze[c[f>>2]&3](7,4,o,16,d);ze[c[f>>2]&3](8,0,-1.0,17,d);ze[c[f>>2]&3](8,2,-1.0,18,d);ze[c[f>>2]&3](8,3,-1.0,19,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+6|0]|0)==0){p=1.0}else{p=+h[(c[b+416>>2]|0)+640>>3]}ze[c[f>>2]&3](9,1,-p,20,d);ze[c[f>>2]&3](9,5,1.0,21,d);ze[c[f>>2]&3](10,0,1.0,22,d);q=c[f>>2]|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+6|0]|0)!=0){r=1.0;ze[q&3](10,1,r,23,d);i=e;return}r=+h[(c[b+416>>2]|0)+648>>3];ze[q&3](10,1,r,23,d);i=e;return}function $g(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=-+h[e+1488>>3];b=e+48|0;e=a+8|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;c[e+28>>2]=0;h[a+40>>3]=-+h[b>>3];b=a+48|0;a=b+40|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));i=d;return}function ah(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;ze[c[e>>2]&3](0,4,1.0,0,b);ze[c[e>>2]&3](0,9,-1.0,1,b);f=a+416|0;ze[c[e>>2]&3](1,8,-+h[(c[f>>2]|0)+64>>3],2,b);ze[c[e>>2]&3](1,9,1.0,3,b);ze[c[e>>2]&3](2,7,1.0,4,b);ze[c[e>>2]&3](2,8,+h[(c[f>>2]|0)+96>>3],5,b);ze[c[e>>2]&3](3,0,-1.0,6,b);ze[c[e>>2]&3](3,6,-1.0,7,b);ze[c[e>>2]&3](3,7,1.0,8,b);ze[c[e>>2]&3](4,5,+h[(c[f>>2]|0)+88>>3],9,b);ze[c[e>>2]&3](4,6,1.0,10,b);ze[c[e>>2]&3](5,4,1.0,11,b);ze[c[e>>2]&3](5,5,-+h[(c[f>>2]|0)+56>>3],12,b);ze[c[e>>2]&3](6,3,1.0,13,b);ze[c[e>>2]&3](6,8,-+h[(c[f>>2]|0)+112>>3],14,b);ze[c[e>>2]&3](7,2,1.0,15,b);ze[c[e>>2]&3](7,3,-1.0,16,b);ze[c[e>>2]&3](8,1,+h[(c[f>>2]|0)+120>>3],17,b);ze[c[e>>2]&3](8,2,1.0,18,b);ze[c[e>>2]&3](9,0,1.0,19,b);ze[c[e>>2]&3](9,1,-+h[(c[f>>2]|0)+80>>3],20,b);i=d;return}function bh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=-+h[e+744>>3]- +h[e+960>>3]- +h[e+848>>3];b=e+624|0;f=a+8|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;h[a+24>>3]=-+h[b>>3]- +h[e+512>>3];b=e+400|0;f=a+32|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;h[a+56>>3]=-+h[b>>3]- +h[e+296>>3];e=a+64|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;i=d;return}function ch(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0;e=i;f=d+8|0;g=b+4|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+7|0]|0)==0){j=+h[(c[b+416>>2]|0)+512>>3]}else{j=1.0}ze[c[f>>2]&3](0,6,-j,0,d);ze[c[f>>2]&3](0,10,1.0,1,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+7|0]|0)==0){k=1.0}else{k=+h[(c[b+416>>2]|0)+512>>3]}ze[c[f>>2]&3](1,9,-k,2,d);ze[c[f>>2]&3](1,10,1.0,3,d);ze[c[f>>2]&3](2,8,1.0,4,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+7|0]|0)==0){l=+h[(c[b+416>>2]|0)+520>>3]}else{l=1.0}ze[c[f>>2]&3](2,9,l,5,d);ze[c[f>>2]&3](3,2,1.0,6,d);ze[c[f>>2]&3](3,7,-1.0,7,d);ze[c[f>>2]&3](3,8,-1.0,8,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+7|0]|0)==0){m=1.0}else{m=+h[(c[b+416>>2]|0)+520>>3]}ze[c[f>>2]&3](4,6,m,9,d);ze[c[f>>2]&3](4,7,1.0,10,d);ze[c[f>>2]&3](5,5,1.0,11,d);ze[c[f>>2]&3](5,10,-1.0,12,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+7|0]|0)==0){n=+h[(c[b+416>>2]|0)+536>>3]}else{n=1.0}ze[c[f>>2]&3](6,4,-n,13,d);ze[c[f>>2]&3](6,5,1.0,14,d);ze[c[f>>2]&3](7,3,1.0,15,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+7|0]|0)==0){o=1.0}else{o=+h[(c[b+416>>2]|0)+544>>3]}ze[c[f>>2]&3](7,4,o,16,d);ze[c[f>>2]&3](8,0,-1.0,17,d);ze[c[f>>2]&3](8,2,-1.0,18,d);ze[c[f>>2]&3](8,3,-1.0,19,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+7|0]|0)==0){p=1.0}else{p=+h[(c[b+416>>2]|0)+536>>3]}ze[c[f>>2]&3](9,1,-p,20,d);ze[c[f>>2]&3](9,5,1.0,21,d);ze[c[f>>2]&3](10,0,1.0,22,d);q=c[f>>2]|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+7|0]|0)!=0){r=1.0;ze[q&3](10,1,r,23,d);i=e;return}r=+h[(c[b+416>>2]|0)+544>>3];ze[q&3](10,1,r,23,d);i=e;return}function dh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;h[e>>3]=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+8>>3]=+h[b+112>>3];a=b+56|0;b=e+16|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;h[e+40>>3]=-+h[a>>3];a=e+48|0;e=a+40|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(e|0));i=d;return}function eh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0;e=i;f=d+8|0;g=b+4|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+8|0]|0)==0){j=+h[(c[b+416>>2]|0)+408>>3]}else{j=1.0}ze[c[f>>2]&3](0,6,-j,0,d);ze[c[f>>2]&3](0,10,1.0,1,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+8|0]|0)==0){k=1.0}else{k=+h[(c[b+416>>2]|0)+408>>3]}ze[c[f>>2]&3](1,9,-k,2,d);ze[c[f>>2]&3](1,10,1.0,3,d);ze[c[f>>2]&3](2,8,1.0,4,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+8|0]|0)==0){l=+h[(c[b+416>>2]|0)+416>>3]}else{l=1.0}ze[c[f>>2]&3](2,9,l,5,d);ze[c[f>>2]&3](3,2,1.0,6,d);ze[c[f>>2]&3](3,7,-1.0,7,d);ze[c[f>>2]&3](3,8,-1.0,8,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+8|0]|0)==0){m=1.0}else{m=+h[(c[b+416>>2]|0)+416>>3]}ze[c[f>>2]&3](4,6,m,9,d);ze[c[f>>2]&3](4,7,1.0,10,d);ze[c[f>>2]&3](5,5,1.0,11,d);ze[c[f>>2]&3](5,10,-1.0,12,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+8|0]|0)==0){n=+h[(c[b+416>>2]|0)+432>>3]}else{n=1.0}ze[c[f>>2]&3](6,4,-n,13,d);ze[c[f>>2]&3](6,5,1.0,14,d);ze[c[f>>2]&3](7,3,1.0,15,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+8|0]|0)==0){o=1.0}else{o=+h[(c[b+416>>2]|0)+440>>3]}ze[c[f>>2]&3](7,4,o,16,d);ze[c[f>>2]&3](8,0,-1.0,17,d);ze[c[f>>2]&3](8,2,-1.0,18,d);ze[c[f>>2]&3](8,3,-1.0,19,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+8|0]|0)==0){p=1.0}else{p=+h[(c[b+416>>2]|0)+432>>3]}ze[c[f>>2]&3](9,1,-p,20,d);ze[c[f>>2]&3](9,5,1.0,21,d);ze[c[f>>2]&3](10,0,1.0,22,d);q=c[f>>2]|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+8|0]|0)!=0){r=1.0;ze[q&3](10,1,r,23,d);i=e;return}r=+h[(c[b+416>>2]|0)+440>>3];ze[q&3](10,1,r,23,d);i=e;return}function fh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;h[e>>3]=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+8>>3]=+h[b+96>>3];a=b+64|0;b=e+16|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;h[e+40>>3]=-+h[a>>3];a=e+48|0;e=a+40|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(e|0));i=d;return}function gh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,2,1.0,0,d);g=b+4|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+9|0]|0)==0){j=+h[(c[b+416>>2]|0)+304>>3]}else{j=1.0}ze[c[f>>2]&3](0,10,-j,1,d);ze[c[f>>2]&3](1,9,1.0,2,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+9|0]|0)==0){k=1.0}else{k=+h[(c[b+416>>2]|0)+312>>3]}ze[c[f>>2]&3](1,10,k,3,d);ze[c[f>>2]&3](2,0,-1.0,4,d);ze[c[f>>2]&3](2,8,1.0,5,d);ze[c[f>>2]&3](2,9,-1.0,6,d);ze[c[f>>2]&3](3,3,-1.0,7,d);ze[c[f>>2]&3](3,7,-1.0,8,d);ze[c[f>>2]&3](3,8,-1.0,9,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+9|0]|0)==0){l=1.0}else{l=+h[(c[b+416>>2]|0)+336>>3]}ze[c[f>>2]&3](4,6,l,10,d);ze[c[f>>2]&3](4,7,1.0,11,d);ze[c[f>>2]&3](5,5,1.0,12,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+9|0]|0)==0){m=+h[(c[b+416>>2]|0)+328>>3]}else{m=1.0}ze[c[f>>2]&3](5,6,-m,13,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+9|0]|0)==0){n=1.0}else{n=+h[(c[b+416>>2]|0)+328>>3]}ze[c[f>>2]&3](6,4,-n,14,d);ze[c[f>>2]&3](6,5,1.0,15,d);ze[c[f>>2]&3](7,3,1.0,16,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+9|0]|0)==0){o=+h[(c[b+416>>2]|0)+336>>3]}else{o=1.0}ze[c[f>>2]&3](7,4,o,17,d);ze[c[f>>2]&3](8,2,-1.0,18,d);ze[c[f>>2]&3](8,5,1.0,19,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+9|0]|0)==0){p=1.0}else{p=+h[(c[b+416>>2]|0)+304>>3]}ze[c[f>>2]&3](9,1,-p,20,d);ze[c[f>>2]&3](9,2,1.0,21,d);ze[c[f>>2]&3](10,0,1.0,22,d);q=c[f>>2]|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+9|0]|0)!=0){r=1.0;ze[q&3](10,1,r,23,d);i=e;return}r=+h[(c[b+416>>2]|0)+312>>3];ze[q&3](10,1,r,23,d);i=e;return}function hh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[b+36>>2]|0;b=a+4|0;a=e+0|0;f=a+64|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(f|0));a=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[e+64>>3]=-+h[a+72>>3];h[e+72>>3]=+h[a+112>>3];h[e+80>>3]=0.0;i=d;return}function ih(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0;e=i;f=d+8|0;g=b+4|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+10|0]|0)==0){j=+h[(c[b+416>>2]|0)+200>>3]}else{j=1.0}ze[c[f>>2]&3](0,6,-j,0,d);ze[c[f>>2]&3](0,10,1.0,1,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+10|0]|0)==0){k=1.0}else{k=+h[(c[b+416>>2]|0)+200>>3]}ze[c[f>>2]&3](1,9,-k,2,d);ze[c[f>>2]&3](1,10,1.0,3,d);ze[c[f>>2]&3](2,8,1.0,4,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+10|0]|0)==0){l=+h[(c[b+416>>2]|0)+208>>3]}else{l=1.0}ze[c[f>>2]&3](2,9,l,5,d);ze[c[f>>2]&3](3,2,1.0,6,d);ze[c[f>>2]&3](3,7,-1.0,7,d);ze[c[f>>2]&3](3,8,-1.0,8,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+10|0]|0)==0){m=1.0}else{m=+h[(c[b+416>>2]|0)+208>>3]}ze[c[f>>2]&3](4,6,m,9,d);ze[c[f>>2]&3](4,7,1.0,10,d);ze[c[f>>2]&3](5,5,1.0,11,d);ze[c[f>>2]&3](5,10,-1.0,12,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+10|0]|0)==0){n=+h[(c[b+416>>2]|0)+224>>3]}else{n=1.0}ze[c[f>>2]&3](6,4,-n,13,d);ze[c[f>>2]&3](6,5,1.0,14,d);ze[c[f>>2]&3](7,3,1.0,15,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+10|0]|0)==0){o=1.0}else{o=+h[(c[b+416>>2]|0)+232>>3]}ze[c[f>>2]&3](7,4,o,16,d);ze[c[f>>2]&3](8,0,-1.0,17,d);ze[c[f>>2]&3](8,2,-1.0,18,d);ze[c[f>>2]&3](8,3,-1.0,19,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+10|0]|0)==0){p=1.0}else{p=+h[(c[b+416>>2]|0)+224>>3]}ze[c[f>>2]&3](9,1,-p,20,d);ze[c[f>>2]&3](9,5,1.0,21,d);ze[c[f>>2]&3](10,0,1.0,22,d);q=c[f>>2]|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+10|0]|0)!=0){r=1.0;ze[q&3](10,1,r,23,d);i=e;return}r=+h[(c[b+416>>2]|0)+232>>3];ze[q&3](10,1,r,23,d);i=e;return}function jh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;h[e>>3]=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+8>>3]=-+h[b+120>>3];a=b+80|0;b=e+16|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;h[e+40>>3]=-+h[a>>3];a=e+48|0;e=a+40|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(e|0));i=d;return}



function Bp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19168]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+416>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(19176,Ew(+h[(c[g>>2]|0)+416>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[19168]=1;i=d;return}function Cp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19296]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+408>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(19304,Ew(+h[(c[g>>2]|0)+408>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[19296]=1;i=d;return}function Dp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19424]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+400>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(19432,Ew(+h[(c[g>>2]|0)+400>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[19424]=1;i=d;return}function Ep(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19544]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+392>>3],1.0e-15)|0)<<24>>24==0)){i=d;return}b=Hw(19552,Ew(+h[(c[g>>2]|0)+392>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[19544]=1;i=d;return}function Fp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19624]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+376>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(19632,Ew(+h[(c[g>>2]|0)+376>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[19624]=1;i=d;return}function Gp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19720]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+352>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=Hw(19728,Ew(+h[(c[g>>2]|0)+352>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[19720]=1;i=d;return}function Hp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19840]&1){i=d;return}g=b+416|0;b=Wy(+h[(c[g>>2]|0)+344>>3],1.0e-60)|0;if(!(b<<24>>24==0|(Vy(+h[(c[g>>2]|0)+344>>3],100.0)|0)<<24>>24==0)){i=d;return}b=Hw(19848,Ew(+h[(c[g>>2]|0)+344>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21216;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[19840]=1;i=d;return}function Ip(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19992]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(2e4,Ew(+h[(c[g>>2]|0)+336>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[19992]=1;i=d;return}function Jp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20120]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(20128,Ew(+h[(c[g>>2]|0)+328>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[20120]=1;i=d;return}function Kp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20248]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(20256,Ew(+h[(c[g>>2]|0)+320>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[20248]=1;i=d;return}function Lp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20368]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(20376,Ew(+h[(c[g>>2]|0)+312>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[20368]=1;i=d;return}function Mp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20496]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(20504,Ew(+h[(c[g>>2]|0)+304>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[20496]=1;i=d;return}function Np(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20624]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(20632,Ew(+h[(c[g>>2]|0)+296>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[20624]=1;i=d;return}function Op(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20744]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+288>>3],1.0e-15)|0)<<24>>24==0)){i=d;return}b=Hw(20752,Ew(+h[(c[g>>2]|0)+288>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[20744]=1;i=d;return}function Pp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20824]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(20832,Ew(+h[(c[g>>2]|0)+272>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[20824]=1;i=d;return}function Qp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20920]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+248>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=Hw(20928,Ew(+h[(c[g>>2]|0)+248>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[20920]=1;i=d;return}function Rp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21064]&1){i=d;return}g=b+416|0;b=Wy(+h[(c[g>>2]|0)+240>>3],1.0e-60)|0;if(!(b<<24>>24==0|(Vy(+h[(c[g>>2]|0)+240>>3],100.0)|0)<<24>>24==0)){i=d;return}b=Hw(21072,Ew(+h[(c[g>>2]|0)+240>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21216;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[21064]=1;i=d;return}function Sp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21240]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+232>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(21248,Ew(+h[(c[g>>2]|0)+232>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[21240]=1;i=d;return}function Tp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21368]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(21376,Ew(+h[(c[g>>2]|0)+224>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[21368]=1;i=d;return}function Up(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21496]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(21504,Ew(+h[(c[g>>2]|0)+216>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[21496]=1;i=d;return}function Vp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21616]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(21624,Ew(+h[(c[g>>2]|0)+208>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[21616]=1;i=d;return}function Wp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21768]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(21776,Ew(+h[(c[g>>2]|0)+200>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[21768]=1;i=d;return}function Xp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21920]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+192>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(21928,Ew(+h[(c[g>>2]|0)+192>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[21920]=1;i=d;return}function Yp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22064]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+184>>3],1.0e-15)|0)<<24>>24==0)){i=d;return}b=Hw(22072,Ew(+h[(c[g>>2]|0)+184>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[22064]=1;i=d;return}function Zp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22168]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+120>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(22176,Ew(+h[(c[g>>2]|0)+120>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[22168]=1;i=d;return}function _p(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22248]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+112>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(22256,Ew(+h[(c[g>>2]|0)+112>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[22248]=1;i=d;return}function $p(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22328]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+104>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(22336,Ew(+h[(c[g>>2]|0)+104>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[22328]=1;i=d;return}function aq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22408]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+96>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(22416,Ew(+h[(c[g>>2]|0)+96>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[22408]=1;i=d;return}function bq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22488]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+88>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(22496,Ew(+h[(c[g>>2]|0)+88>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[22488]=1;i=d;return}function cq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22568]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+80>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(22576,Ew(+h[(c[g>>2]|0)+80>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[22568]=1;i=d;return}function dq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22648]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+72>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(22656,Ew(+h[(c[g>>2]|0)+72>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[22648]=1;i=d;return}function eq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22728]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+64>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(22736,Ew(+h[(c[g>>2]|0)+64>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[22728]=1;i=d;return}function fq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22808]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+56>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(22816,Ew(+h[(c[g>>2]|0)+56>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[22808]=1;i=d;return}function gq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22912]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+48>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(22920,Ew(+h[(c[g>>2]|0)+48>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[22912]=1;i=d;return}function hq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23008]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+40>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(23016,Ew(+h[(c[g>>2]|0)+40>>3],8352)|0)|0;g=c[20440]|0;j=e;k=23080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[23008]=1;i=d;return}function iq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23104]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+32>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(23112,Ew(+h[(c[g>>2]|0)+32>>3],8352)|0)|0;g=c[20440]|0;j=e;k=23176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[23104]=1;i=d;return}function jq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23200]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+24>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(23208,Ew(+h[(c[g>>2]|0)+24>>3],8352)|0)|0;g=c[20440]|0;j=e;k=23272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[23200]=1;i=d;return}function kq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23296]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+16>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(23304,Ew(+h[(c[g>>2]|0)+16>>3],8352)|0)|0;g=c[20440]|0;j=e;k=23368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[23296]=1;i=d;return}function lq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23392]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+8>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(23400,Ew(+h[(c[g>>2]|0)+8>>3],8352)|0)|0;g=c[20440]|0;j=e;k=23464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[23392]=1;i=d;return}function mq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23488]&1){i=d;return}g=b+416|0;if(!((Wy(+h[c[g>>2]>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(23496,Ew(+h[c[g>>2]>>3],8352)|0)|0;g=c[20440]|0;j=e;k=23560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[23488]=1;i=d;return}function nq(a){a=a|0;var b=0;b=i;Zl(a);_l(a);$l(a);am(a);bm(a);cm(a);dm(a);em(a);fm(a);gm(a);hm(a);im(a);jm(a);km(a);lm(a);mm(a);nm(a);om(a);pm(a);qm(a);rm(a);sm(a);tm(a);um(a);vm(a);wm(a);xm(a);ym(a);zm(a);Am(a);Bm(a);Cm(a);Dm(a);Em(a);Fm(a);Gm(a);Hm(a);Im(a);Jm(a);Km(a);Lm(a);Mm(a);Nm(a);Om(a);Pm(a);Qm(a);Rm(a);Sm(a);Tm(a);Um(a);Vm(a);Wm(a);Xm(a);Ym(a);Zm(a);_m(a);$m(a);an(a);bn(a);cn(a);dn(a);en(a);fn(a);gn(a);hn(a);jn(a);kn(a);ln(a);mn(a);nn(a);on(a);pn(a);qn(a);rn(a);sn(a);tn(a);un(a);vn(a);wn(a);xn(a);yn(a);zn(a);An(a);Bn(a);Cn(a);Dn(a);En(a);Fn(a);Gn(a);Hn(a);In(a);Jn(a);Kn(a);Ln(a);Mn(a);Nn(a);On(a);Pn(a);Qn(a);Rn(a);Sn(a);Tn(a);Un(a);Vn(a);Wn(a);Xn(a);Yn(a);Zn(a);_n(a);$n(a);ao(a);bo(a);co(a);eo(a);fo(a);go(a);ho(a);io(a);jo(a);ko(a);lo(a);mo(a);no(a);oo(a);po(a);qo(a);ro(a);so(a);to(a);uo(a);vo(a);wo(a);xo(a);yo(a);zo(a);Ao(a);Bo(a);Co(a);Do(a);Eo(a);Fo(a);Go(a);Ho(a);Io(a);Jo(a);Ko(a);Lo(a);Mo(a);No(a);Oo(a);Po(a);Qo(a);Ro(a);So(a);To(a);Uo(a);Vo(a);Wo(a);Xo(a);Yo(a);Zo(a);_o(a);$o(a);ap(a);bp(a);cp(a);dp(a);ep(a);fp(a);gp(a);hp(a);ip(a);jp(a);kp(a);lp(a);mp(a);np(a);op(a);pp(a);qp(a);rp(a);sp(a);tp(a);up(a);vp(a);wp(a);xp(a);yp(a);zp(a);Ap(a);Bp(a);Cp(a);Dp(a);Ep(a);Fp(a);Gp(a);Hp(a);Ip(a);Jp(a);Kp(a);Lp(a);Mp(a);Np(a);Op(a);Pp(a);Qp(a);Rp(a);Sp(a);Tp(a);Up(a);Vp(a);Wp(a);Xp(a);Yp(a);Zp(a);_p(a);$p(a);aq(a);bq(a);cq(a);dq(a);eq(a);fq(a);gq(a);hq(a);iq(a);jq(a);kq(a);lq(a);mq(a);i=b;return 0}function oq(b){b=b|0;var c=0;c=i;a[b+314|0]=0;pq(b);i=c;return 0}function pq(a){a=a|0;var b=0;b=i;kf(a);mf(a);rf(a);sf(a);wf(a);yf(a);Cf(a);Df(a);If(a);Kf(a);Of(a);Qf(a);Wf(a);Xf(a);cg(a);eg(a);fg(a);jg(a);lg(a);rg(a);sg(a);ug(a);yg(a);zg(a);Ag(a);Bg(a);Dg(a);i=b;return}function qq(a){a=a|0;i=i;return 0}function rq(a){a=a|0;i=i;return 1}function sq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+464|0;a=c[d>>2]|0;c[a+44>>2]=16;c[a+48>>2]=16;c[a+72>>2]=XZ(16,8)|0;a=XZ(16,8)|0;c[(c[d>>2]|0)+80>>2]=a;a=XZ(0,8)|0;c[(c[d>>2]|0)+76>>2]=a;a=VZ(64)|0;c[(c[d>>2]|0)+52>>2]=a;a=VZ(248)|0;c[(c[d>>2]|0)+56>>2]=a;a=VZ(64)|0;c[(c[d>>2]|0)+64>>2]=a;a=c[d>>2]|0;c[a+68>>2]=11;c[a+84>>2]=0;a=c[d>>2]|0;e=c[a+52>>2]|0;c[e+60>>2]=6;c[e+56>>2]=4;c[e+52>>2]=5;c[e+48>>2]=6;c[e+44>>2]=5;c[e+40>>2]=2;c[e+36>>2]=2;c[e+32>>2]=2;c[e+28>>2]=2;c[e+24>>2]=4;c[e+20>>2]=4;c[e+16>>2]=4;c[e+12>>2]=4;c[e+8>>2]=4;c[e+4>>2]=4;c[e>>2]=4;f=4;g=4;h=1;while(1){j=f+g|0;c[e+(h<<2)>>2]=j;k=h+1|0;if((k|0)>=16){break}f=c[e+(k<<2)>>2]|0;h=k;g=j}tq(e,c[a+56>>2]|0);a=c[d>>2]|0;uq(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;vq(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;wq(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;xq(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;yq(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;zq(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Aq(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Bq(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Cq(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Dq(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Eq(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Fq(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Gq(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Hq(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Iq(c[a+52>>2]|0,c[a+56>>2]|0);a=c[(c[d>>2]|0)+64>>2]|0;c[a+60>>2]=1;c[a+32>>2]=1;c[a+56>>2]=2;c[a+52>>2]=2;c[a+48>>2]=3;c[a+40>>2]=3;c[a+44>>2]=4;c[a+36>>2]=4;c[a+28>>2]=4;c[a+24>>2]=5;c[a+20>>2]=6;c[a+16>>2]=7;c[a+12>>2]=8;c[a+8>>2]=9;c[a+4>>2]=10;c[a>>2]=11;i=b;return 0}function tq(a,b){a=a|0;b=b|0;var d=0;d=a+60|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=4;c[b+((c[d>>2]|0)+ -5<<2)>>2]=10;c[b+((c[d>>2]|0)+ -4<<2)>>2]=12;c[b+((c[d>>2]|0)+ -3<<2)>>2]=13;c[b+((c[d>>2]|0)+ -2<<2)>>2]=14;c[b+((c[d>>2]|0)+ -1<<2)>>2]=15;i=i;return}function uq(a,b){a=a|0;b=b|0;var d=0;d=a+56|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=7;c[b+((c[d>>2]|0)+ -3<<2)>>2]=9;c[b+((c[d>>2]|0)+ -2<<2)>>2]=11;c[b+((c[d>>2]|0)+ -1<<2)>>2]=13;i=i;return}function vq(a,b){a=a|0;b=b|0;var d=0;d=a+52|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=2;c[b+((c[d>>2]|0)+ -4<<2)>>2]=5;c[b+((c[d>>2]|0)+ -3<<2)>>2]=12;c[b+((c[d>>2]|0)+ -2<<2)>>2]=14;c[b+((c[d>>2]|0)+ -1<<2)>>2]=15;i=i;return}function wq(a,b){a=a|0;b=b|0;var d=0;d=a+48|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=8;c[b+((c[d>>2]|0)+ -4<<2)>>2]=11;c[b+((c[d>>2]|0)+ -3<<2)>>2]=12;c[b+((c[d>>2]|0)+ -2<<2)>>2]=14;c[b+((c[d>>2]|0)+ -1<<2)>>2]=15;i=i;return}function xq(a,b){a=a|0;b=b|0;var d=0;d=a+44|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=1;c[b+((c[d>>2]|0)+ -4<<2)>>2]=3;c[b+((c[d>>2]|0)+ -3<<2)>>2]=12;c[b+((c[d>>2]|0)+ -2<<2)>>2]=14;c[b+((c[d>>2]|0)+ -1<<2)>>2]=15;i=i;return}function yq(a,b){a=a|0;b=b|0;var d=0;d=a+40|0;c[b+((c[d>>2]|0)+ -2<<2)>>2]=10;c[b+((c[d>>2]|0)+ -1<<2)>>2]=13;i=i;return}function zq(a,b){a=a|0;b=b|0;var d=0;d=a+36|0;c[b+((c[d>>2]|0)+ -2<<2)>>2]=9;c[b+((c[d>>2]|0)+ -1<<2)>>2]=13;i=i;return}function Aq(a,b){a=a|0;b=b|0;var d=0;d=a+32|0;c[b+((c[d>>2]|0)+ -2<<2)>>2]=8;c[b+((c[d>>2]|0)+ -1<<2)>>2]=11;i=i;return}function Bq(a,b){a=a|0;b=b|0;var d=0;d=a+28|0;c[b+((c[d>>2]|0)+ -2<<2)>>2]=7;c[b+((c[d>>2]|0)+ -1<<2)>>2]=11;i=i;return}function Cq(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=6;c[b+((c[d>>2]|0)+ -3<<2)>>2]=12;c[b+((c[d>>2]|0)+ -2<<2)>>2]=14;c[b+((c[d>>2]|0)+ -1<<2)>>2]=15;i=i;return}function Dq(a,b){a=a|0;b=b|0;var d=0;d=a+20|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=5;c[b+((c[d>>2]|0)+ -3<<2)>>2]=12;c[b+((c[d>>2]|0)+ -2<<2)>>2]=14;c[b+((c[d>>2]|0)+ -1<<2)>>2]=15;i=i;return}function Eq(a,b){a=a|0;b=b|0;var d=0;d=a+16|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=4;c[b+((c[d>>2]|0)+ -3<<2)>>2]=12;c[b+((c[d>>2]|0)+ -2<<2)>>2]=14;c[b+((c[d>>2]|0)+ -1<<2)>>2]=15;i=i;return}function Fq(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=3;c[b+((c[d>>2]|0)+ -3<<2)>>2]=12;c[b+((c[d>>2]|0)+ -2<<2)>>2]=14;c[b+((c[d>>2]|0)+ -1<<2)>>2]=15;i=i;return}function Gq(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=2;c[b+((c[d>>2]|0)+ -3<<2)>>2]=12;c[b+((c[d>>2]|0)+ -2<<2)>>2]=14;c[b+((c[d>>2]|0)+ -1<<2)>>2]=15;i=i;return}function Hq(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=1;c[b+((c[d>>2]|0)+ -3<<2)>>2]=12;c[b+((c[d>>2]|0)+ -2<<2)>>2]=14;c[b+((c[d>>2]|0)+ -1<<2)>>2]=15;i=i;return}function Iq(a,b){a=a|0;b=b|0;c[b+((c[a>>2]|0)+ -4<<2)>>2]=0;c[b+((c[a>>2]|0)+ -3<<2)>>2]=12;c[b+((c[a>>2]|0)+ -2<<2)>>2]=14;c[b+((c[a>>2]|0)+ -1<<2)>>2]=15;i=i;return}function Jq(a){a=a|0;i=i;return 1}function Kq(a){a=a|0;i=i;return 1}function Lq(a){a=a|0;i=i;return 1}function Mq(a){a=a|0;i=i;return 0}function Nq(a){a=a|0;i=i;return 0}function Oq(a){a=a|0;i=i;return 0}function Pq(a){a=a|0;i=i;return 0}function Qq(a){a=a|0;i=i;return 0}function Rq(a,b){a=a|0;b=b|0;i=i;return-1}function Sq(a,b){a=a|0;b=b|0;i=i;return-1}function Tq(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i;return-1}function Uq(){i=i;return 23584}function Vq(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}a=c[d>>2]|0;if((a|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}j=+h[b>>3];d=!(j>=0.0);if((a|0)==1){if(d){k=-j}else{k=j}if((f|0)<2){g=1;i=e;return g|0}else{l=k;m=2;n=1}while(1){k=+h[b+(m+ -1<<3)>>3];o=!(k>=0.0);if(o){p=-k}else{p=k}q=p<=l;if(q|o^1){r=q?l:k;s=q?n:m}else{r=-k;s=m}q=m+1|0;if((q|0)>(f|0)){g=s;break}else{l=r;m=q;n=s}}i=e;return g|0}if(d){t=-j}else{t=j}if((f|0)<2){g=1;i=e;return g|0}j=t;d=2;s=a+1|0;n=1;while(1){t=+h[b+(s+ -1<<3)>>3];m=!(t>=0.0);if(m){u=-t}else{u=t}q=u<=j;if(q|m^1){v=q?j:t;w=q?n:d}else{v=-t;w=d}q=d+1|0;if((q|0)>(f|0)){g=w;break}else{j=v;d=q;s=a+s|0;n=w}}i=e;return g|0}function Wq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)<1){i=f;return 0}if((j|0)!=1){e=fa(j,g)|0;if((e|0)>0){k=1}else{i=f;return 0}do{l=d+(k+ -1<<3)|0;h[l>>3]=+h[b>>3]*+h[l>>3];k=k+j|0;}while((k|0)<=(e|0));i=f;return 0}e=(g|0)%5|0;do{if((e|0)==0){m=g}else{if((e|0)<1){n=g}else{k=1;do{j=d+(k+ -1<<3)|0;h[j>>3]=+h[b>>3]*+h[j>>3];k=k+1|0;}while((k|0)<=(e|0));n=c[a>>2]|0}if((n|0)>=5){m=n;break}i=f;return 0}}while(0);n=e+1|0;if((n|0)>(m|0)){i=f;return 0}else{o=n}do{n=d+(o+ -1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+2<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+3<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];o=o+5|0;}while((o|0)<=(m|0));i=f;return 0}function Xq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}k=c[d>>2]|0;do{if((k|0)==1){l=c[f>>2]|0;if((l|0)!=1){m=l;n=1;break}l=(j|0)%3|0;do{if((l|0)==0){o=j}else{if((l|0)<1){p=j}else{q=1;do{r=q+ -1|0;s=b+(r<<3)|0;t=+h[s>>3];u=e+(r<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;q=q+1|0;}while((q|0)<=(l|0));p=c[a>>2]|0}if((p|0)>=3){o=p;break}i=g;return 0}}while(0);q=l+1|0;if((q|0)>(o|0)){i=g;return 0}else{v=q}do{q=v+ -1|0;u=b+(q<<3)|0;t=+h[u>>3];s=e+(q<<3)|0;h[u>>3]=+h[s>>3];h[s>>3]=t;s=b+(v<<3)|0;t=+h[s>>3];u=e+(v<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;u=v+1|0;s=b+(u<<3)|0;t=+h[s>>3];q=e+(u<<3)|0;h[s>>3]=+h[q>>3];h[q>>3]=t;v=v+3|0;}while((v|0)<=(o|0));i=g;return 0}else{if((k|0)<0){w=(fa(1-j|0,k)|0)+1|0}else{w=1}m=c[f>>2]|0;n=w}}while(0);if((m|0)<0){x=1;y=n;z=(fa(1-j|0,m)|0)+1|0}else{x=1;y=n;z=1}while(1){n=b+(y+ -1<<3)|0;t=+h[n>>3];m=e+(z+ -1<<3)|0;h[n>>3]=+h[m>>3];h[m>>3]=t;m=x+1|0;if((m|0)>(j|0)){break}else{z=(c[f>>2]|0)+z|0;y=(c[d>>2]|0)+y|0;x=m}}i=g;return 0}function Yq(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+8|0;n=m;o=c[l>>2]|0;l=~o;c[n>>2]=0;p=c[a>>2]|0;do{if((p|0)<0){c[n>>2]=1}else{q=c[b>>2]|0;if((q|0)<0){c[n>>2]=2;break}r=c[f>>2]|0;if((r|0)==0){c[n>>2]=5;break}s=c[j>>2]|0;if((s|0)==0){c[n>>2]=7;break}if((o|0)<(((p|0)>1?p:1)|0)){c[n>>2]=9;break}if((p|0)==0|(q|0)==0){i=m;return 0}if(+h[d>>3]==0.0){i=m;return 0}if((s|0)>0){t=1}else{t=1-(fa(s,q+ -1|0)|0)|0}if((r|0)==1){if((q|0)<1){i=m;return 0}else{u=s;v=1;w=t}while(1){x=+h[g+(w+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){A=u;break}B=(fa(v,o)|0)+l|0;C=1;do{D=k+(B+C<<3)|0;h[D>>3]=+h[D>>3]+y*+h[e+(C+ -1<<3)>>3];C=C+1|0;}while((C|0)<=(z|0));A=c[j>>2]|0}else{A=u}}while(0);z=v+1|0;if((z|0)>(q|0)){break}else{u=A;v=z;w=A+w|0}}i=m;return 0}if((r|0)>0){E=1}else{E=1-(fa(p+ -1|0,r)|0)|0}if((q|0)<1){i=m;return 0}else{F=s;G=1;H=t}while(1){x=+h[g+(H+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){I=F;break}C=(fa(G,o)|0)+l|0;B=1;D=E;while(1){J=k+(C+B<<3)|0;h[J>>3]=+h[J>>3]+y*+h[e+(D+ -1<<3)>>3];J=B+1|0;if((J|0)>(z|0)){break}else{D=(c[f>>2]|0)+D|0;B=J}}I=c[j>>2]|0}else{I=F}}while(0);B=G+1|0;if((B|0)>(q|0)){break}else{F=I;G=B;H=I+H|0}}i=m;return 0}}while(0);xb(24696,n|0)|0;i=m;return 0}function Zq(a,b,d,e,f,g,j,k,l,m,n,o,p){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0,da=0;q=i;i=i+8|0;r=q;s=c[k>>2]|0;t=~s;u=c[m>>2]|0;v=~u;w=c[p>>2]|0;x=~w;y=Sx(a,24704)|0;z=Sx(b,24704)|0;A=(y|0)!=0;y=c[(A?d:f)>>2]|0;B=(z|0)!=0;z=c[(B?f:e)>>2]|0;c[r>>2]=0;do{if(A){C=5}else{if((Sx(a,24712)|0)!=0){C=5;break}if((Sx(a,24720)|0)!=0){C=5;break}c[r>>2]=1}}while(0);a:do{if((C|0)==5){do{if(!B){if((Sx(b,24712)|0)!=0){break}if((Sx(b,24720)|0)!=0){break}c[r>>2]=2;break a}}while(0);a=c[d>>2]|0;if((a|0)<0){c[r>>2]=3;break}D=c[e>>2]|0;if((D|0)<0){c[r>>2]=4;break}E=c[f>>2]|0;if((E|0)<0){c[r>>2]=5;break}if((c[k>>2]|0)<(((y|0)>1?y:1)|0)){c[r>>2]=8;break}if((c[m>>2]|0)<(((z|0)>1?z:1)|0)){c[r>>2]=10;break}if((c[p>>2]|0)<(((a|0)>1?a:1)|0)){c[r>>2]=13;break}if((c[r>>2]|0)!=0){break}if((a|0)==0|(D|0)==0){i=q;return 0}F=+h[g>>3]==0.0;do{if(F|(E|0)==0){if(+h[n>>3]==1.0){i=q;return 0}if(!F){break}G=(D|0)<1;if(+h[n>>3]==0.0){if(G){i=q;return 0}else{H=a;I=0;J=2}while(1){if((H|0)>=1){B_(o+((fa(w,I)|0)<<3)|0,0,H<<3|0)|0}if((J|0)>(D|0)){break}H=c[d>>2]|0;I=I+1|0;J=J+1|0}i=q;return 0}if(G){i=q;return 0}else{K=a;L=1}while(1){if((K|0)>=1){M=(fa(L,w)|0)+x|0;N=1;do{O=o+(M+N<<3)|0;h[O>>3]=+h[n>>3]*+h[O>>3];N=N+1|0;}while((N|0)<=(K|0))}N=L+1|0;if((N|0)>(D|0)){break}K=c[d>>2]|0;L=N}i=q;return 0}}while(0);F=(D|0)<1;if(B){if(!A){if(F){i=q;return 0}else{P=a;Q=1}while(1){if((P|0)>=1){E=(fa(Q,w)|0)+x|0;G=(fa(Q,u)|0)+v|0;N=1;do{M=c[f>>2]|0;if((M|0)<1){R=0.0}else{O=(fa(N,s)|0)+t|0;S=1;T=0.0;while(1){U=T+ +h[j+(O+S<<3)>>3]*+h[l+(G+S<<3)>>3];V=S+1|0;if((V|0)>(M|0)){R=U;break}else{T=U;S=V}}}T=+h[n>>3];U=R*+h[g>>3];S=o+(E+N<<3)|0;if(T==0.0){W=U}else{W=U+T*+h[S>>3]}h[S>>3]=W;N=N+1|0;}while((N|0)<=(P|0))}N=Q+1|0;if((N|0)>(D|0)){break}P=c[d>>2]|0;Q=N}i=q;return 0}if(F){i=q;return 0}else{X=0;Y=1}while(1){N=o+((fa(w,X)|0)<<3)|0;T=+h[n>>3];b:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}B_(N|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}G=(fa(Y,w)|0)+x|0;U=T;S=1;while(1){M=o+(G+S<<3)|0;h[M>>3]=U*+h[M>>3];M=S+1|0;if((M|0)>(E|0)){break b}U=+h[n>>3];S=M}}}while(0);N=c[f>>2]|0;if((N|0)>=1){S=(fa(Y,u)|0)+v|0;E=(fa(Y,w)|0)+x|0;G=1;do{T=+h[l+(S+G<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];M=c[d>>2]|0;if((M|0)<1){break}O=(fa(G,s)|0)+t|0;V=1;do{Z=o+(E+V<<3)|0;h[Z>>3]=+h[Z>>3]+U*+h[j+(O+V<<3)>>3];V=V+1|0;}while((V|0)<=(M|0))}}while(0);G=G+1|0;}while((G|0)<=(N|0))}N=Y+1|0;if((N|0)>(D|0)){break}X=X+1|0;Y=N}i=q;return 0}else{if(!A){if(F){i=q;return 0}else{_=a;$=1}while(1){if((_|0)>=1){N=(fa($,w)|0)+x|0;G=$+v|0;E=1;do{S=c[f>>2]|0;if((S|0)<1){aa=0.0}else{M=(fa(E,s)|0)+t|0;V=1;T=0.0;while(1){U=T+ +h[j+(M+V<<3)>>3]*+h[l+(G+(fa(V,u)|0)<<3)>>3];O=V+1|0;if((O|0)>(S|0)){aa=U;break}else{T=U;V=O}}}T=+h[n>>3];U=aa*+h[g>>3];V=o+(N+E<<3)|0;if(T==0.0){ba=U}else{ba=U+T*+h[V>>3]}h[V>>3]=ba;E=E+1|0;}while((E|0)<=(_|0))}E=$+1|0;if((E|0)>(D|0)){break}_=c[d>>2]|0;$=E}i=q;return 0}if(F){i=q;return 0}else{ca=0;da=1}while(1){a=o+((fa(w,ca)|0)<<3)|0;T=+h[n>>3];c:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}B_(a|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}N=(fa(da,w)|0)+x|0;U=T;G=1;while(1){V=o+(N+G<<3)|0;h[V>>3]=U*+h[V>>3];V=G+1|0;if((V|0)>(E|0)){break c}U=+h[n>>3];G=V}}}while(0);a=c[f>>2]|0;if((a|0)>=1){G=da+v|0;E=(fa(da,w)|0)+x|0;N=1;do{T=+h[l+(G+(fa(N,u)|0)<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];V=c[d>>2]|0;if((V|0)<1){break}S=(fa(N,s)|0)+t|0;M=1;do{O=o+(E+M<<3)|0;h[O>>3]=+h[O>>3]+U*+h[j+(S+M<<3)>>3];M=M+1|0;}while((M|0)<=(V|0))}}while(0);N=N+1|0;}while((N|0)<=(a|0))}a=da+1|0;if((a|0)>(D|0)){break}ca=ca+1|0;da=a}i=q;return 0}}}while(0);xb(24728,r|0)|0;i=q;return 0}function _q(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0,X=0.0,Y=0,Z=0,_=0;o=i;i=i+8|0;p=o;q=c[l>>2]|0;r=~q;s=c[n>>2]|0;t=~s;u=(Sx(a,24736)|0)!=0;v=c[(u?f:g)>>2]|0;w=Sx(e,24744)|0;x=Sx(b,24752)|0;c[p>>2]=0;do{if(u){y=4}else{if((Sx(a,24760)|0)!=0){y=4;break}c[p>>2]=1}}while(0);a:do{if((y|0)==4){do{if((x|0)==0){if((Sx(b,24736)|0)!=0){break}c[p>>2]=2;break a}}while(0);do{if((Sx(d,24744)|0)==0){if((Sx(d,24768)|0)!=0){break}if((Sx(d,24776)|0)!=0){break}c[p>>2]=3;break a}}while(0);do{if((Sx(e,24752)|0)==0){if((Sx(e,24744)|0)!=0){break}c[p>>2]=4;break a}}while(0);a=c[f>>2]|0;if((a|0)<0){c[p>>2]=5;break}z=c[g>>2]|0;if((z|0)<0){c[p>>2]=6;break}if((c[l>>2]|0)<(((v|0)>1?v:1)|0)){c[p>>2]=9;break}if((c[n>>2]|0)<(((a|0)>1?a:1)|0)){c[p>>2]=11;break}if((c[p>>2]|0)!=0){break}if((a|0)==0|(z|0)==0){i=o;return 0}if(+h[j>>3]==0.0){if((z|0)<1){i=o;return 0}else{A=a;B=0;C=2}while(1){if((A|0)>=1){B_(m+((fa(s,B)|0)<<3)|0,0,A<<3|0)|0}if((C|0)>(z|0)){break}A=c[f>>2]|0;B=B+1|0;C=C+1|0}i=o;return 0}z=(Sx(d,24744)|0)!=0;a=(x|0)!=0;D=c[g>>2]|0;if(u){E=(D|0)<1;if(!z){if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{H=c[f>>2]|0;if((H|0)>=1){I=(fa(G,s)|0)+t|0;J=1;do{K=m+(I+J<<3)|0;L=+h[j>>3]*+h[K>>3];M=J+ -1|0;if((M|0)<1){N=L}else{O=(fa(J,q)|0)+r|0;P=1;Q=L;while(1){L=Q- +h[k+(O+P<<3)>>3]*+h[m+(I+P<<3)>>3];R=P+1|0;if((R|0)>(M|0)){N=L;break}else{Q=L;P=R}}}if(F){S=N}else{S=N/+h[k+(J+r+(fa(J,q)|0)<<3)>>3]}h[K>>3]=S;J=J+1|0;}while((J|0)<=(H|0))}G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{H=c[f>>2]|0;b:do{if((H|0)>0){J=(fa(F,s)|0)+t|0;I=H;P=H;while(1){M=m+(J+P<<3)|0;Q=+h[j>>3]*+h[M>>3];O=P+1|0;if((O|0)>(I|0)){T=Q}else{R=(fa(P,q)|0)+r|0;U=O;L=Q;while(1){Q=L- +h[k+(R+U<<3)>>3]*+h[m+(J+U<<3)>>3];O=U+1|0;if((O|0)>(I|0)){T=Q;break}else{L=Q;U=O}}}if(G){V=T}else{V=T/+h[k+(P+r+(fa(P,q)|0)<<3)>>3]}h[M>>3]=V;U=P+ -1|0;if((U|0)<=0){break b}I=c[f>>2]|0;P=U}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];c:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}P=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){J=m+(P+I<<3)|0;h[J>>3]=Q*+h[J>>3];J=I+1|0;if((J|0)>(H|0)){y=43;break c}Q=+h[j>>3];I=J}}else{y=43}}while(0);d:do{if((y|0)==43){y=0;I=c[f>>2]|0;if((I|0)<=0){break}H=(fa(G,s)|0)+t|0;if(F){P=I;while(1){J=m+(H+P<<3)|0;L=+h[J>>3];K=P+ -1|0;e:do{if(L!=0.0){if((K|0)<1){break d}U=(fa(P,q)|0)+r|0;Q=L;R=1;while(1){O=m+(H+R<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(U+R<<3)>>3];O=R+1|0;if((O|0)>(K|0)){break e}Q=+h[J>>3];R=O}}}while(0);if((K|0)>0){P=K}else{break d}}}else{W=I}while(1){P=m+(H+W<<3)|0;L=+h[P>>3];f:do{if(L!=0.0){Q=L/+h[k+(W+r+(fa(W,q)|0)<<3)>>3];h[P>>3]=Q;J=W+ -1|0;if((J|0)<1){break d}M=(fa(W,q)|0)+r|0;X=Q;R=1;while(1){U=m+(H+R<<3)|0;h[U>>3]=+h[U>>3]-X*+h[k+(M+R<<3)>>3];U=R+1|0;if((U|0)>(J|0)){Y=J;break f}X=+h[P>>3];R=U}}else{Y=W+ -1|0}}while(0);if((Y|0)>0){W=Y}else{break}}}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{L=+h[j>>3];g:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(F,s)|0)+t|0;X=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=X*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){y=64;break g}X=+h[j>>3];P=K}}else{y=64}}while(0);do{if((y|0)==64){y=0;P=c[f>>2]|0;if((P|0)<1){break}H=(fa(F,s)|0)+t|0;if(G){I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];h:do{if(L!=0.0){R=c[f>>2]|0;J=I+1|0;if((J|0)>(R|0)){Z=J;break}M=(fa(I,q)|0)+r|0;X=L;U=J;while(1){O=m+(H+U<<3)|0;h[O>>3]=+h[O>>3]-X*+h[k+(M+U<<3)>>3];O=U+1|0;if((O|0)>(R|0)){Z=J;break h}X=+h[K>>3];U=O}}else{Z=I+1|0}}while(0);if((Z|0)>(P|0)){break}else{I=Z}}}else{I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];i:do{if(L!=0.0){X=L/+h[k+(I+r+(fa(I,q)|0)<<3)>>3];h[K>>3]=X;U=c[f>>2]|0;J=I+1|0;if((J|0)>(U|0)){_=J;break}R=(fa(I,q)|0)+r|0;Q=X;M=J;while(1){O=m+(H+M<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(R+M<<3)>>3];O=M+1|0;if((O|0)>(U|0)){_=J;break i}Q=+h[K>>3];M=O}}else{_=I+1|0}}while(0);if((_|0)>(P|0)){break}else{I=_}}}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(!z){if(a){if((D|0)<=0){i=o;return 0}F=(w|0)==0;G=D;while(1){do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];E=c[f>>2]|0;if((E|0)<1){break}I=(fa(G,s)|0)+t|0;P=1;do{H=m+(I+P<<3)|0;h[H>>3]=L*+h[H>>3];P=P+1|0;}while((P|0)<=(E|0))}}while(0);E=G+ -1|0;if((E|0)>=1){P=(fa(G,q)|0)+r|0;I=(fa(G,s)|0)+t|0;H=1;do{L=+h[k+(P+H<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(H,s)|0)+t|0;J=1;do{U=m+(M+J<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(I+J<<3)>>3];J=J+1|0;}while((J|0)<=(K|0))}}while(0);H=H+1|0;}while((H|0)<=(E|0))}L=+h[j>>3];j:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(G,s)|0)+t|0;Q=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=Q*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){break j}Q=+h[j>>3];P=K}}}while(0);if((E|0)>0){G=E}else{break}}i=o;return 0}else{if((D|0)<1){i=o;return 0}G=(w|0)==0;F=1;while(1){do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}P=(fa(F,s)|0)+t|0;H=1;do{I=m+(P+H<<3)|0;h[I>>3]=L*+h[I>>3];H=H+1|0;}while((H|0)<=(z|0))}}while(0);E=c[g>>2]|0;z=F+1|0;if((z|0)<=(E|0)){H=(fa(F,q)|0)+r|0;P=(fa(F,s)|0)+t|0;I=z;do{L=+h[k+(H+I<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}J=(fa(I,s)|0)+t|0;M=1;do{U=m+(J+M<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(P+M<<3)>>3];M=M+1|0;}while((M|0)<=(K|0))}}while(0);I=I+1|0;}while((I|0)<=(E|0))}L=+h[j>>3];k:do{if(L!=1.0){E=c[f>>2]|0;if((E|0)<1){break}I=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){H=m+(I+P<<3)|0;h[H>>3]=Q*+h[H>>3];H=P+1|0;if((H|0)>(E|0)){break k}Q=+h[j>>3];P=H}}}while(0);if((z|0)>(D|0)){break}else{F=z}}i=o;return 0}}if(a){if((D|0)<1){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];l:do{if(L!=1.0){P=c[f>>2]|0;if((P|0)<1){break}E=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){H=m+(E+I<<3)|0;h[H>>3]=Q*+h[H>>3];H=I+1|0;if((H|0)>(P|0)){break l}Q=+h[j>>3];I=H}}}while(0);z=G+ -1|0;if((z|0)>=1){I=(fa(G,q)|0)+r|0;P=(fa(G,s)|0)+t|0;E=1;do{H=k+(I+E<<3)|0;L=+h[H>>3];m:do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(E,s)|0)+t|0;Q=L;J=1;while(1){U=m+(P+J<<3)|0;h[U>>3]=+h[U>>3]-Q*+h[m+(M+J<<3)>>3];U=J+1|0;if((U|0)>(K|0)){break m}Q=+h[H>>3];J=U}}}while(0);E=E+1|0;}while((E|0)<=(z|0))}do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}E=(fa(G,s)|0)+t|0;P=1;do{I=m+(E+P<<3)|0;h[I>>3]=L*+h[I>>3];P=P+1|0;}while((P|0)<=(z|0))}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}else{if((D|0)<=0){i=o;return 0}G=(w|0)==0;F=D;do{L=+h[j>>3];n:do{if(L!=1.0){a=c[f>>2]|0;if((a|0)<1){break}z=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){E=m+(z+P<<3)|0;h[E>>3]=Q*+h[E>>3];E=P+1|0;if((E|0)>(a|0)){break n}Q=+h[j>>3];P=E}}}while(0);P=c[g>>2]|0;a=F+1|0;if((a|0)<=(P|0)){z=(fa(F,q)|0)+r|0;E=(fa(F,s)|0)+t|0;I=a;do{a=k+(z+I<<3)|0;L=+h[a>>3];o:do{if(L!=0.0){H=c[f>>2]|0;if((H|0)<1){break}J=(fa(I,s)|0)+t|0;Q=L;K=1;while(1){M=m+(E+K<<3)|0;h[M>>3]=+h[M>>3]-Q*+h[m+(J+K<<3)>>3];M=K+1|0;if((M|0)>(H|0)){break o}Q=+h[a>>3];K=M}}}while(0);I=I+1|0;}while((I|0)<=(P|0))}do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];P=c[f>>2]|0;if((P|0)<1){break}I=(fa(F,s)|0)+t|0;E=1;do{z=m+(I+E<<3)|0;h[z>>3]=L*+h[z>>3];E=E+1|0;}while((E|0)<=(P|0))}}while(0);F=F+ -1|0;}while((F|0)>0);i=o;return 0}}}while(0);xb(24784,p|0)|0;i=o;return 0}function $q(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;i=i+8|0;l=k;c[j>>2]=0;m=c[a>>2]|0;do{if((m|0)<0){c[j>>2]=-1;n=-1}else{if((c[b>>2]|0)<0){c[j>>2]=-2;n=-2;break}o=(m|0)>1?m:1;if((c[e>>2]|0)<(o|0)){c[j>>2]=-4;n=-4;break}if((c[h>>2]|0)<(o|0)){c[j>>2]=-7;n=-7;break}br(a,a,d,e,f,j)|0;if((c[j>>2]|0)!=0){i=k;return 0}cr(24800,a,b,d,e,f,g,h,j)|0;i=k;return 0}}while(0);c[l>>2]=0-n;xb(24792,l|0)|0;i=k;return 0}function ar(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;o=c[e>>2]|0;p=~o;c[g>>2]=0;q=c[a>>2]|0;do{if((q|0)<0){c[g>>2]=-1;r=-1}else{s=c[b>>2]|0;if((s|0)<0){c[g>>2]=-2;r=-2;break}if((c[e>>2]|0)<(((q|0)>1?q:1)|0)){c[g>>2]=-4;r=-4;break}if((q|0)==0|(s|0)==0){i=j;return 0}t=+Dx(24824);s=c[a>>2]|0;u=c[b>>2]|0;v=(s|0)>(u|0)?u:s;c[k>>2]=v;if((v|0)<1){i=j;return 0}else{w=s;x=1}while(1){c[l>>2]=1-x+w;s=x+ -1|0;v=fa(x,o)|0;u=x+p|0;y=u+v|0;z=d+(y<<3)|0;A=s+(Vq(l,z,24832)|0)|0;c[f+(s<<2)>>2]=A;B=v+p|0;a:do{if(+h[d+(B+A<<3)>>3]!=0.0){if((A|0)!=(x|0)){Xq(b,d+(s<<3)|0,e,d+(A+ -1<<3)|0,e)|0}C=c[a>>2]|0;if((x|0)>=(C|0)){break}D=+h[z>>3];h[n>>3]=D;if(!(D>=0.0)){E=-D}else{E=D}F=C-x|0;c[l>>2]=F;if(E>=t){h[n>>3]=1.0/D;Wq(l,n,d+(x-o+v<<3)|0,24832)|0;break}if((F|0)<1){break}else{G=D;H=1}while(1){C=d+(y+H<<3)|0;h[C>>3]=+h[C>>3]/G;C=H+1|0;if((C|0)>(F|0)){break a}G=+h[z>>3];H=C}}else{if((c[g>>2]|0)!=0){break}c[g>>2]=x}}while(0);z=c[a>>2]|0;y=c[b>>2]|0;if((x|0)<(((z|0)>(y|0)?y:z)|0)){c[l>>2]=z-x;c[m>>2]=y-x;y=x+1|0;z=fa(y,o)|0;Yq(l,m,24840,d+(B+y<<3)|0,24832,d+(u+z<<3)|0,e,d+(y+p+z<<3)|0,e)|0;I=y}else{I=x+1|0}if((I|0)>(c[k>>2]|0)){break}w=c[a>>2]|0;x=I}i=j;return 0}}while(0);c[k>>2]=0-r;xb(24816,k|0)|0;i=j;return 0}function br(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;i=i+48|0;j=h;k=h+8|0;l=h+16|0;m=h+24|0;n=h+32|0;o=h+40|0;p=c[e>>2]|0;q=~p;c[g>>2]=0;r=c[a>>2]|0;do{if((r|0)<0){c[g>>2]=-1;s=-1}else{t=c[b>>2]|0;if((t|0)<0){c[g>>2]=-2;s=-2;break}if((c[e>>2]|0)<(((r|0)>1?r:1)|0)){c[g>>2]=-4;s=-4;break}if((r|0)==0|(t|0)==0){i=h;return 0}t=24872;u=er(24856,24848,24864,a,b,t,t)|0;do{if((u|0)>=2){t=c[a>>2]|0;v=c[b>>2]|0;w=(t|0)>(v|0)?v:t;if((u|0)>=(w|0)){break}c[j>>2]=w;c[m>>2]=1;if((w|0)>0){x=v;y=t;z=1}else{i=h;return 0}while(1){t=((y|0)>(x|0)?x:y)-z+1|0;c[n>>2]=(t|0)<=(u|0)?t:u;c[k>>2]=y+1-z;ar(k,n,d+(z+q+(fa(z,p)|0)<<3)|0,e,f+(z+ -1<<2)|0,o)|0;do{if((c[g>>2]|0)==0){t=c[o>>2]|0;if((t|0)<=0){break}c[g>>2]=t+ -1+(c[m>>2]|0)}}while(0);t=c[a>>2]|0;c[l>>2]=t;v=c[m>>2]|0;w=v+ -1|0;A=w+(c[n>>2]|0)|0;B=(t|0)<=(A|0)?t:A;c[k>>2]=B;if((v|0)<=(B|0)){t=v;do{v=f+(t+ -1<<2)|0;c[v>>2]=(c[v>>2]|0)+w;t=t+1|0;}while((t|0)<=(B|0))}c[k>>2]=w;c[l>>2]=A;dr(k,d,e,m,l,f,24856)|0;B=c[m>>2]|0;t=c[n>>2]|0;v=t+B|0;C=c[b>>2]|0;do{if((v|0)>(C|0)){D=B}else{c[k>>2]=1-B-t+C;c[l>>2]=v+ -1;dr(k,d+((fa(v,p)|0)-p<<3)|0,e,m,l,f,24856)|0;E=c[m>>2]|0;F=c[n>>2]|0;c[k>>2]=(c[b>>2]|0)+1-E-F;G=E+q|0;_q(24880,24888,24896,24912,n,k,24920,d+(G+(fa(E,p)|0)<<3)|0,e,d+(G+(fa(F+E|0,p)|0)<<3)|0,e)|0;E=c[m>>2]|0;F=c[n>>2]|0;G=F+E|0;H=c[a>>2]|0;if((G|0)>(H|0)){D=E;break}c[k>>2]=1-E-F+H;c[l>>2]=(c[b>>2]|0)+1-E-F;F=fa(G,p)|0;H=24896;Zq(H,H,k,l,n,24928,d+((fa(E,p)|0)+q+G<<3)|0,e,d+(E+q+F<<3)|0,e,24920,d+(G+q+F<<3)|0,e)|0;D=c[m>>2]|0}}while(0);v=D+u|0;c[m>>2]=v;if((v|0)>(c[j>>2]|0)){break}x=c[b>>2]|0;y=c[a>>2]|0;z=v}i=h;return 0}}while(0);ar(a,b,d,e,f,g)|0;i=h;return 0}}while(0);c[j>>2]=0-s;xb(24848,j|0)|0;i=h;return 0}function cr(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;l=i;i=i+8|0;m=l;c[k>>2]=0;n=(Sx(a,24936)|0)!=0;do{if(n){o=5}else{if((Sx(a,24944)|0)!=0){o=5;break}if((Sx(a,24952)|0)!=0){o=5;break}c[k>>2]=-1;p=-1}}while(0);do{if((o|0)==5){a=c[b>>2]|0;if((a|0)<0){c[k>>2]=-2;p=-2;break}q=c[d>>2]|0;if((q|0)<0){c[k>>2]=-3;p=-3;break}r=(a|0)>1?a:1;if((c[f>>2]|0)<(r|0)){c[k>>2]=-5;p=-5;break}if((c[j>>2]|0)<(r|0)){c[k>>2]=-8;p=-8;break}r=c[k>>2]|0;if((r|0)!=0){p=r;break}if((a|0)==0|(q|0)==0){i=l;return 0}if(n){q=24968;dr(d,h,j,q,b,g,q)|0;_q(24976,24984,24992,25008,b,d,25016,e,f,h,j)|0;_q(24976,25024,24992,25032,b,d,25016,e,f,h,j)|0;i=l;return 0}else{_q(24976,25024,25048,25032,b,d,25016,e,f,h,j)|0;_q(24976,24984,25048,25008,b,d,25016,e,f,h,j)|0;dr(d,h,j,24968,b,g,25064)|0;i=l;return 0}}}while(0);c[m>>2]=0-p;xb(24960,m|0)|0;i=l;return 0}function dr(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0;k=i;l=c[d>>2]|0;d=~l;m=c[j>>2]|0;do{if((m|0)>0){n=c[e>>2]|0;o=n;p=f;q=1;r=n}else{if((m|0)<0){n=c[f>>2]|0;o=n;p=e;q=-1;r=(fa(1-n|0,m)|0)+1|0;break}else{i=k;return 0}}}while(0);e=c[p>>2]|0;p=c[a>>2]|0;f=((p|0)/32|0)<<5;if((f|0)<1){s=m;t=p}else{p=(q|0)<0;n=p?(o|0)>=(e|0):(o|0)<=(e|0);u=m;m=1;while(1){if(n){v=m+31|0;if(p){w=u;x=o;y=r;while(1){z=c[g+(y+ -1<<2)>>2]|0;if((z|0)==(x|0)){A=w}else{B=x+d|0;C=z+d|0;z=m;do{D=fa(z,l)|0;E=b+(B+D<<3)|0;F=+h[E>>3];G=b+(C+D<<3)|0;h[E>>3]=+h[G>>3];h[G>>3]=F;z=z+1|0;}while((z|0)<=(v|0));A=c[j>>2]|0}z=x+q|0;if((z|0)<(e|0)){H=A;break}else{w=A;x=z;y=A+y|0}}}else{y=u;x=o;w=r;while(1){z=c[g+(w+ -1<<2)>>2]|0;if((z|0)==(x|0)){I=y}else{C=x+d|0;B=z+d|0;z=m;do{G=fa(z,l)|0;E=b+(C+G<<3)|0;F=+h[E>>3];D=b+(B+G<<3)|0;h[E>>3]=+h[D>>3];h[D>>3]=F;z=z+1|0;}while((z|0)<=(v|0));I=c[j>>2]|0}z=x+q|0;if((z|0)>(e|0)){H=I;break}else{y=I;x=z;w=I+w|0}}}}else{H=u}w=m+32|0;if((w|0)>(f|0)){break}else{u=H;m=w}}s=H;t=c[a>>2]|0}if((f|0)==(t|0)){i=k;return 0}t=f|1;f=(q|0)<0;if(!(f?(o|0)>=(e|0):(o|0)<=(e|0))){i=k;return 0}if(f){f=s;H=o;m=r;while(1){u=c[g+(m+ -1<<2)>>2]|0;do{if((u|0)==(H|0)){J=f}else{I=c[a>>2]|0;if((t|0)>(I|0)){J=f;break}A=H+d|0;p=u+d|0;n=t;do{w=fa(n,l)|0;x=b+(A+w<<3)|0;F=+h[x>>3];y=b+(p+w<<3)|0;h[x>>3]=+h[y>>3];h[y>>3]=F;n=n+1|0;}while((n|0)<=(I|0));J=c[j>>2]|0}}while(0);u=H+q|0;if((u|0)<(e|0)){break}else{f=J;H=u;m=J+m|0}}i=k;return 0}else{m=s;s=o;o=r;while(1){r=c[g+(o+ -1<<2)>>2]|0;do{if((r|0)==(s|0)){K=m}else{J=c[a>>2]|0;if((t|0)>(J|0)){K=m;break}H=s+d|0;f=r+d|0;u=t;do{I=fa(u,l)|0;n=b+(H+I<<3)|0;F=+h[n>>3];p=b+(f+I<<3)|0;h[n>>3]=+h[p>>3];h[p>>3]=F;u=u+1|0;}while((u|0)<=(J|0));K=c[j>>2]|0}}while(0);r=s+q|0;if((r|0)>(e|0)){break}else{m=K;s=r;o=K+o|0}}i=k;return 0}return 0}function er(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=x_(d|0)|0;switch(c[b>>2]|0){case 10:{q=fr(25304,25312,25320)|0;i=k;return q|0};case 4:{q=6;i=k;return q|0};case 5:{q=2;i=k;return q|0};case 6:{r=c[f>>2]|0;s=c[g>>2]|0;q=~~(+(((r|0)>(s|0)?s:r)|0)*1.600000023841858);i=k;return q|0};case 7:{q=1;i=k;return q|0};case 8:{q=50;i=k;return q|0};case 9:{q=25;i=k;return q|0};case 11:{q=fr(25328,25312,25320)|0;i=k;return q|0};case 16:case 15:case 14:case 13:case 12:{q=gr(b,d,e,f,g,h,j)|0;i=k;return q|0};case 3:case 2:case 1:{h=o;EN(h,d,1,p);p=a[h]|0;do{if((p+ -97<<24>>24&255)<26){d=p+ -32<<24>>24;a[h]=d;f=o+1|0;e=a[f]|0;if((e+ -97<<24>>24&255)<26){a[f]=e+ -32<<24>>24}e=o+2|0;f=a[e]|0;if((f+ -97<<24>>24&255)<26){a[e]=f+ -32<<24>>24}f=o+3|0;e=a[f]|0;if((e+ -97<<24>>24&255)<26){a[f]=e+ -32<<24>>24}e=o+4|0;f=a[e]|0;if((f+ -97<<24>>24&255)<26){a[e]=f+ -32<<24>>24}f=o+5|0;e=a[f]|0;if(!((e+ -97<<24>>24&255)<26)){t=d;break}a[f]=e+ -32<<24>>24;t=d}else{t=p}}while(0);p=t<<24>>24==83;h=t<<24>>24==68;d=p|h;if(!(t<<24>>24==67|t<<24>>24==68|t<<24>>24==83|t<<24>>24==90)){q=1;i=k;return q|0}e=l;EN(e,o+1|0,1,2);l=m;EN(l,o+3|0,1,3);o=n;EN(o,m+1|0,1,2);m=c[b>>2]|0;if((m|0)==3){if((DN(e,25072,1,2)|0)==0){if((DN(l,25088,1,3)|0)==0){q=128;i=k;return q|0}if((DN(l,25096,1,3)|0)==0){q=128;i=k;return q|0}if((DN(l,25104,1,3)|0)==0){q=128;i=k;return q|0}if((DN(l,25112,1,3)|0)==0){q=128;i=k;return q|0}if((DN(l,25120,1,3)|0)==0){q=128;i=k;return q|0}b=(DN(l,25128,1,3)|0)==0;q=b?128:0;i=k;return q|0}if((DN(e,25152,1,2)|0)==0){if(!(t<<24>>24==68|t<<24>>24==83)){q=0;i=k;return q|0}b=(DN(l,25160,1,3)|0)==0;q=b?32:0;i=k;return q|0}if(t<<24>>24==68|t<<24>>24==83){u=141}else if(t<<24>>24==67|t<<24>>24==90){u=138}else{q=0;i=k;return q|0}do{if((u|0)==138){if((DN(e,25176,1,2)|0)==0){b=(DN(l,25160,1,3)|0)==0;q=b?32:0;i=k;return q|0}else{if(t<<24>>24==67|t<<24>>24==90){break}else if(t<<24>>24==68|t<<24>>24==83){u=141;break}else{q=0}i=k;return q|0}}}while(0);do{if((u|0)==141){if((DN(e,25184,1,2)|0)!=0){if(t<<24>>24==67|t<<24>>24==90){break}else{q=0}i=k;return q|0}if((a[l]|0)!=71){q=0;i=k;return q|0}do{if((DN(o,25192,1,2)|0)!=0){if((DN(o,25200,1,2)|0)==0){break}if((DN(o,25208,1,2)|0)==0){break}if((DN(o,25216,1,2)|0)==0){break}if((DN(o,25224,1,2)|0)==0){break}if((DN(o,25232,1,2)|0)==0){break}if((DN(o,25240,1,2)|0)==0){break}else{q=0}i=k;return q|0}}while(0);q=128;i=k;return q|0}}while(0);if((DN(e,25248,1,2)|0)!=0){q=0;i=k;return q|0}if((a[l]|0)!=71){q=0;i=k;return q|0}do{if((DN(o,25192,1,2)|0)!=0){if((DN(o,25200,1,2)|0)==0){break}if((DN(o,25208,1,2)|0)==0){break}if((DN(o,25216,1,2)|0)==0){break}if((DN(o,25224,1,2)|0)==0){break}if((DN(o,25232,1,2)|0)==0){break}if((DN(o,25240,1,2)|0)==0){break}else{q=0}i=k;return q|0}}while(0);q=128;i=k;return q|0}else if((m|0)==2){if((DN(e,25072,1,2)|0)==0){if((DN(l,25088,1,3)|0)==0){q=2;i=k;return q|0}if((DN(l,25096,1,3)|0)==0){q=2;i=k;return q|0}if((DN(l,25104,1,3)|0)==0){q=2;i=k;return q|0}if((DN(l,25112,1,3)|0)==0){q=2;i=k;return q|0}if((DN(l,25120,1,3)|0)==0){q=2;i=k;return q|0}if((DN(l,25128,1,3)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}if((DN(e,25152,1,2)|0)==0){m=(DN(l,25080,1,3)|0)==0;if(m|(p|h)^1){q=m?8:2;i=k;return q|0}q=2;i=k;return q|0}if(t<<24>>24==67|t<<24>>24==90){u=91}else if(t<<24>>24==68|t<<24>>24==83){u=94}else{q=2;i=k;return q|0}do{if((u|0)==91){if((DN(e,25176,1,2)|0)==0){q=2;i=k;return q|0}else{if(t<<24>>24==67|t<<24>>24==90){break}else if(t<<24>>24==68|t<<24>>24==83){u=94;break}else{q=2}i=k;return q|0}}}while(0);do{if((u|0)==94){if((DN(e,25184,1,2)|0)!=0){if(t<<24>>24==67|t<<24>>24==90){break}else{q=2}i=k;return q|0}m=a[l]|0;if(m<<24>>24==77){if((DN(o,25192,1,2)|0)==0){q=2;i=k;return q|0}if((DN(o,25200,1,2)|0)==0){q=2;i=k;return q|0}if((DN(o,25208,1,2)|0)==0){q=2;i=k;return q|0}if((DN(o,25216,1,2)|0)==0){q=2;i=k;return q|0}if((DN(o,25224,1,2)|0)==0){q=2;i=k;return q|0}if((DN(o,25232,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else if(m<<24>>24==71){if((DN(o,25192,1,2)|0)==0){q=2;i=k;return q|0}if((DN(o,25200,1,2)|0)==0){q=2;i=k;return q|0}if((DN(o,25208,1,2)|0)==0){q=2;i=k;return q|0}if((DN(o,25216,1,2)|0)==0){q=2;i=k;return q|0}if((DN(o,25224,1,2)|0)==0){q=2;i=k;return q|0}if((DN(o,25232,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else{q=2;i=k;return q|0}}}while(0);if((DN(e,25248,1,2)|0)!=0){q=2;i=k;return q|0}m=a[l]|0;if(m<<24>>24==77){if((DN(o,25192,1,2)|0)==0){q=2;i=k;return q|0}if((DN(o,25200,1,2)|0)==0){q=2;i=k;return q|0}if((DN(o,25208,1,2)|0)==0){q=2;i=k;return q|0}if((DN(o,25216,1,2)|0)==0){q=2;i=k;return q|0}if((DN(o,25224,1,2)|0)==0){q=2;i=k;return q|0}if((DN(o,25232,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else if(m<<24>>24==71){if((DN(o,25192,1,2)|0)==0){q=2;i=k;return q|0}if((DN(o,25200,1,2)|0)==0){q=2;i=k;return q|0}if((DN(o,25208,1,2)|0)==0){q=2;i=k;return q|0}if((DN(o,25216,1,2)|0)==0){q=2;i=k;return q|0}if((DN(o,25224,1,2)|0)==0){q=2;i=k;return q|0}if((DN(o,25232,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else{q=2;i=k;return q|0}}else{if((DN(e,25072,1,2)|0)==0){if((DN(l,25080,1,3)|0)==0){q=64;i=k;return q|0}if((DN(l,25088,1,3)|0)==0){q=32;i=k;return q|0}if((DN(l,25096,1,3)|0)==0){q=32;i=k;return q|0}if((DN(l,25104,1,3)|0)==0){q=32;i=k;return q|0}if((DN(l,25112,1,3)|0)==0){q=32;i=k;return q|0}if((DN(l,25120,1,3)|0)==0){q=32;i=k;return q|0}if((DN(l,25128,1,3)|0)==0){q=32;i=k;return q|0}m=(DN(l,25136,1,3)|0)==0;q=m?64:1;i=k;return q|0}if((DN(e,25144,1,2)|0)==0){m=(DN(l,25080,1,3)|0)==0;q=m?64:1;i=k;return q|0}if((DN(e,25152,1,2)|0)==0){m=(DN(l,25080,1,3)|0)==0;if(m|d^1){q=m?64:1;i=k;return q|0}m=(DN(l,25160,1,3)|0)==0;if(m){q=m?32:1;i=k;return q|0}m=(DN(l,25168,1,3)|0)==0;q=m?64:1;i=k;return q|0}do{if(t<<24>>24==67|t<<24>>24==90){if((DN(e,25176,1,2)|0)!=0){if(t<<24>>24==67|t<<24>>24==90){u=48;break}else if(t<<24>>24==68|t<<24>>24==83){u=29;break}else{break}}if((DN(l,25080,1,3)|0)==0){q=64;i=k;return q|0}if((DN(l,25160,1,3)|0)==0){q=32;i=k;return q|0}m=(DN(l,25168,1,3)|0)==0;q=m?64:1;i=k;return q|0}else if(t<<24>>24==68|t<<24>>24==83){u=29}}while(0);do{if((u|0)==29){if((DN(e,25184,1,2)|0)!=0){if(t<<24>>24==67|t<<24>>24==90){u=48;break}else{break}}m=a[l]|0;if(m<<24>>24==71){do{if((DN(o,25192,1,2)|0)!=0){if((DN(o,25200,1,2)|0)==0){break}if((DN(o,25208,1,2)|0)==0){break}if((DN(o,25216,1,2)|0)==0){break}if((DN(o,25224,1,2)|0)==0){break}if((DN(o,25232,1,2)|0)==0){break}if((DN(o,25240,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else if(m<<24>>24==77){do{if((DN(o,25192,1,2)|0)!=0){if((DN(o,25200,1,2)|0)==0){break}if((DN(o,25208,1,2)|0)==0){break}if((DN(o,25216,1,2)|0)==0){break}if((DN(o,25224,1,2)|0)==0){break}if((DN(o,25232,1,2)|0)==0){break}if((DN(o,25240,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else{q=1;i=k;return q|0}}}while(0);do{if((u|0)==48){if((DN(e,25248,1,2)|0)!=0){break}m=a[l]|0;if(m<<24>>24==71){do{if((DN(o,25192,1,2)|0)!=0){if((DN(o,25200,1,2)|0)==0){break}if((DN(o,25208,1,2)|0)==0){break}if((DN(o,25216,1,2)|0)==0){break}if((DN(o,25224,1,2)|0)==0){break}if((DN(o,25232,1,2)|0)==0){break}if((DN(o,25240,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else if(m<<24>>24==77){do{if((DN(o,25192,1,2)|0)!=0){if((DN(o,25200,1,2)|0)==0){break}if((DN(o,25208,1,2)|0)==0){break}if((DN(o,25216,1,2)|0)==0){break}if((DN(o,25224,1,2)|0)==0){break}if((DN(o,25232,1,2)|0)==0){break}if((DN(o,25240,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else{q=1;i=k;return q|0}}}while(0);if((DN(e,25256,1,2)|0)==0){if((DN(l,25080,1,3)|0)!=0){q=1;i=k;return q|0}q=(c[j>>2]|0)<65?1:32;i=k;return q|0}if((DN(e,25264,1,2)|0)==0){if((DN(l,25080,1,3)|0)!=0){q=1;i=k;return q|0}q=(c[g>>2]|0)<65?1:32;i=k;return q|0}if((DN(e,25232,1,2)|0)==0){g=(DN(l,25136,1,3)|0)==0;q=g?64:1;i=k;return q|0}if((DN(e,25272,1,2)|0)==0){g=(DN(l,25280,1,3)|0)==0;q=g?64:1;i=k;return q|0}if(!(t<<24>>24==68|t<<24>>24==83)){q=1;i=k;return q|0}if((DN(e,25288,1,2)|0)==0){i=k;return 1}else{q=1;i=k;return q|0}}break};default:{q=-1;i=k;return q|0}}return 0}function fr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0.0,h=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=+g[d>>2];h=+g[b>>2];do{if(!(f/h<=f)){j=-f/h;if(j>=h){k=0;break}l=f/(f+j);if(l!=h){k=0;break}j=f/l;if(j>=h){k=0;break}m=h+l;if(m!=h){k=0;break}n=f/m;if(n<=f){k=0;break}m=j*n;if(m>=h){k=0;break}j=n*n;if(j<=f){k=0;break}if((c[a>>2]|0)==0){k=1;break}n=j+m;o=j/j;p=h*j;q=l*m;l=j/m;if(n==n&0.0==0.0|l==l&0.0==0.0|o==o&0.0==0.0|p==p&0.0==0.0|q==q&0.0==0.0){k=0;break}p=q*0.0;k=(p!=p|0.0!=0.0)&1}else{k=0}}while(0);i=e;return k|0}function gr(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+8|0;e=j;d=c[a>>2]|0;if((d|0)==16|(d|0)==13|(d|0)==15){b=(c[h>>2]|0)-(c[f>>2]|0)+1|0;if((b|0)>149){g[e>>2]=+da(+(+(b|0)))/.6931471805599453;f=(b|0)/(CN(e)|0)|0;k=c[a>>2]|0;l=(f|0)>10?f:10}else{k=d;l=(b|0)>59?10:(b|0)>29?4:2}f=(b|0)>5999?256:(b|0)>2999?128:(b|0)>589?64:l;l=f-((f|0)%2|0)|0;m=k;n=b;o=(l|0)>2?l:2}else{m=d;n=0;o=0}switch(m|0){case 16:{m=(o|0)>13;i=j;return(m?2:m&1)|0};case 15:{p=o;i=j;return p|0};case 12:{p=75;i=j;return p|0};case 13:{if((n|0)<501){p=o;i=j;return p|0}p=(o*3|0)/2|0;i=j;return p|0};case 14:{p=14;i=j;return p|0};default:{p=-1;i=j;return p|0}}return 0}function hr(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=ir(a,0,0)|0;i=b;return c|0}function ir(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=jr(a,b,c,0)|0;i=d;return e|0}function jr(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+64|0;h=b;b=d;d=e;e=f;do{if((b|0)!=0){j=ee[c[b>>2]&127](500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}else{j=VZ(500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=29;c[f+4>>2]=48;c[f+8>>2]=166}}while(0);b=j;if((j|0)==0){k=b;l=k;i=g;return l|0}c[b+8>>2]=0;c[j+32>>2]=0;c[j+380>>2]=16;c[j+392>>2]=ee[c[j+12>>2]&127](c[j+380>>2]<<4)|0;b=j+12|0;if((c[j+392>>2]|0)==0){be[c[b+8>>2]&255](j);k=0;l=k;i=g;return l|0}c[j+44>>2]=ee[c[b>>2]&127](1024)|0;b=j;if((c[j+44>>2]|0)==0){be[c[b+20>>2]&255](c[j+392>>2]|0);be[c[j+20>>2]&255](j);k=0;l=k;i=g;return l|0}c[j+48>>2]=(c[b+44>>2]|0)+1024;do{if((e|0)!=0){c[j+356>>2]=e}else{c[j+356>>2]=us(j+12|0)|0;if((c[j+356>>2]|0)!=0){break}be[c[j+20>>2]&255](c[j+44>>2]|0);be[c[j+20>>2]&255](c[j+392>>2]|0);be[c[j+20>>2]&255](j);k=0;l=k;i=g;return l|0}}while(0);c[j+376>>2]=0;c[j+368>>2]=0;c[j+304>>2]=0;c[j+468>>2]=0;c[j+464>>2]=0;c[j+124>>2]=0;c[j+248>>2]=0;a[j+472|0]=33;a[j+236|0]=0;a[j+237|0]=0;c[j+396>>2]=0;c[j+400>>2]=0;a[j+404|0]=0;vs(j+416|0,j+12|0);vs(j+440|0,j+12|0);lr(j,h);do{if((h|0)!=0){if((c[j+232>>2]|0)!=0){break}or(j);k=0;l=k;i=g;return l|0}}while(0);if((d|0)!=0){a[j+236|0]=1;c[j+228>>2]=Ps()|0;a[j+472|0]=a[d]|0}else{c[j+228>>2]=Gs()|0}k=j;l=k;i=g;return l|0}function kr(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;a=c[d>>2]|0;a:do{if((c[d+4>>2]|0)!=0){e=a;while(1){if((e|0)==0){break a}f=c[e>>2]|0;c[e>>2]=c[d+4>>2];c[d+4>>2]=e;e=f}}else{c[d+4>>2]=a}}while(0);c[d>>2]=0;c[d+16>>2]=0;c[d+12>>2]=0;c[d+8>>2]=0;i=b;return}function lr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=d;c[f+280>>2]=36;Yu(f+256|0);if((b|0)!=0){g=mr(f+416|0,b)|0}else{g=0}c[f+232>>2]=g;c[f+360>>2]=0;Hs(f+148|0,f+144|0,0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=0;c[f+64>>2]=0;c[f+68>>2]=0;c[f+72>>2]=0;c[f+76>>2]=0;c[f+80>>2]=0;c[f+84>>2]=0;c[f+88>>2]=0;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;c[f+104>>2]=0;c[f+108>>2]=0;c[f+112>>2]=0;c[f+116>>2]=f;c[f+120>>2]=0;c[f+128>>2]=0;c[f+132>>2]=0;c[f+136>>2]=0;c[f+140>>2]=0;c[f+24>>2]=c[f+8>>2];c[f+28>>2]=c[f+8>>2];c[f+36>>2]=0;c[f+40>>2]=0;c[f+344>>2]=0;c[f+348>>2]=0;c[f+316>>2]=0;c[f+320>>2]=0;c[f+324>>2]=0;c[f+328>>2]=0;c[f+332>>2]=0;c[f+336>>2]=0;c[f+340>>2]=0;a[f+352|0]=0;a[f+353|0]=0;g=f+408|0;c[g+0>>2]=0;c[g+4>>2]=0;c[f+284>>2]=0;c[f+288>>2]=0;c[f+292>>2]=0;c[f+296>>2]=0;c[f+300>>2]=0;a[f+308|0]=1;c[f+312>>2]=0;c[f+364>>2]=0;c[f+372>>2]=0;c[f+384>>2]=0;c[f+240>>2]=0;c[f+252>>2]=0;c[f+244>>2]=0;c[f+476>>2]=0;c[f+480>>2]=0;a[f+488|0]=0;a[f+489|0]=0;c[f+492>>2]=0;c[f+496>>2]=0;i=e;return}function mr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+24|0;f=b;b=d;while(1){if((c[f+12>>2]|0)==(c[f+8>>2]|0)){if(!((Dr(f)|0)<<24>>24!=0)){g=5;break}}d=a[b]|0;h=f+12|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j]=d;d=b;b=d+1|0;if((a[d]|0)==0){g=6;break}}if((g|0)==5){k=0;l=k;i=e;return l|0}else if((g|0)==6){b=c[f+16>>2]|0;c[f+16>>2]=c[f+12>>2];k=b;l=k;i=e;return l|0}return 0}function nr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=b;a:while(1){if((a[b]|0)==0){h=45;break}do{if((a[g]|0)!=12){if((a[g]|0)==0){break}j=c[f+428>>2]|0;k=f+416|0;if((a[g]|0)!=61){if((j|0)==(c[k+8>>2]|0)){if(!((Dr(f+416|0)|0)<<24>>24!=0)){h=44;break a}}l=a[g]|0;m=f+428|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;g=g+1|0;continue a}if((j-(c[k+16>>2]|0)|0)==0){o=d+152|0}else{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Dr(f+416|0)|0)<<24>>24!=0)){h=19;break a}}k=f+428|0;j=c[k>>2]|0;c[k>>2]=j+1;a[j]=0;o=Gr(f,d+60|0,c[f+432>>2]|0,8)|0;if((o|0)==0){h=20;break a}if((c[o>>2]|0)==(c[f+432>>2]|0)){c[o>>2]=mr(d+80|0,c[o>>2]|0)|0;if((c[o>>2]|0)==0){h=23;break a}}c[f+428>>2]=c[f+432>>2]}b=g+1|0;while(1){if((a[b]|0)!=12){p=(a[b]|0)!=0}else{p=0}q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if(!p){break}if(q){if(!((Dr(f+416|0)|0)<<24>>24!=0)){h=32;break a}}j=a[b]|0;k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=j;b=b+1|0}if(q){if(!((Dr(f+416|0)|0)<<24>>24!=0)){h=36;break a}}j=f+428|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;if((Kr(f,o,0,c[f+432>>2]|0,f+372|0)|0)!=0){h=37;break a}c[f+428>>2]=c[f+432>>2];if((a[b]|0)!=0){b=b+1|0}g=b;continue a}}while(0);if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Dr(f+416|0)|0)<<24>>24!=0)){h=8;break}}l=f+428|0;j=c[l>>2]|0;c[l>>2]=j+1;a[j]=0;j=Gr(f,d,c[f+432>>2]|0,0)|0;if((j|0)!=0){a[j+32|0]=1}if((a[g]|0)!=0){g=g+1|0}b=g;c[f+428>>2]=c[f+432>>2]}if((h|0)==8){r=0;s=r;i=e;return s|0}else if((h|0)==19){r=0;s=r;i=e;return s|0}else if((h|0)==20){r=0;s=r;i=e;return s|0}else if((h|0)==23){r=0;s=r;i=e;return s|0}else if((h|0)==32){r=0;s=r;i=e;return s|0}else if((h|0)==36){r=0;s=r;i=e;return s|0}else if((h|0)==37){r=0;s=r;i=e;return s|0}else if((h|0)==44){r=0;s=r;i=e;return s|0}else if((h|0)==45){r=1;s=r;i=e;return s|0}return 0}function or(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=b;if((e|0)==0){i=d;return}b=c[e+364>>2]|0;while(1){if((b|0)==0){f=e;if((c[e+368>>2]|0)==0){break}b=c[f+368>>2]|0;c[e+368>>2]=0}g=b;b=c[b>>2]|0;be[c[e+20>>2]&255](c[g+36>>2]|0);pr(c[g+44>>2]|0,e);be[c[e+20>>2]&255](g)}b=c[f+300>>2]|0;while(1){if((b|0)==0){h=e;if((c[e+304>>2]|0)==0){break}b=c[h+304>>2]|0;c[e+304>>2]=0}f=b;b=c[b+8>>2]|0;be[c[e+20>>2]&255](f)}pr(c[h+376>>2]|0,e);pr(c[e+372>>2]|0,e);qr(e+416|0);qr(e+440|0);do{if((a[e+488|0]|0)==0){if((c[e+356>>2]|0)==0){break}rr(c[e+356>>2]|0,((c[e+476>>2]|0)!=0^1)&1,e+12|0)}}while(0);be[c[e+20>>2]&255](c[e+392>>2]|0);be[c[e+20>>2]&255](c[e+464>>2]|0);be[c[e+20>>2]&255](c[e+8>>2]|0);be[c[e+20>>2]&255](c[e+44>>2]|0);be[c[e+20>>2]&255](c[e+396>>2]|0);be[c[e+20>>2]&255](c[e+240>>2]|0);if((c[e+252>>2]|0)!=0){be[c[e+252>>2]&255](c[e+244>>2]|0)}be[c[e+20>>2]&255](e);i=d;return}function pr(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+24|0;e=a;a=b;while(1){b=e;if((b|0)==0){break}e=c[b+4>>2]|0;be[c[a+20>>2]&255](c[b+16>>2]|0);be[c[a+20>>2]&255](b)}i=d;return}function qr(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=a;a=c[d>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;be[c[(c[d+20>>2]|0)+8>>2]&255](a);a=e}a=c[d+4>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;be[c[(c[d+20>>2]|0)+8>>2]&255](a);a=e}i=b;return}function rr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+40|0;f=e+24|0;g=a;a=b;b=d;Er(f,g+20|0);while(1){d=Fr(f)|0;if((d|0)==0){break}if((c[d+16>>2]|0)==0){continue}be[c[b+8>>2]&255](c[d+20>>2]|0)}Jr(g);Jr(g+132|0);Jr(g+20|0);Jr(g+40|0);Jr(g+60|0);qr(g+80|0);qr(g+104|0);if(!(a<<24>>24!=0)){h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;be[m&255](o);i=e;return}be[c[b+8>>2]&255](c[g+184>>2]|0);be[c[b+8>>2]&255](c[g+164>>2]|0);h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;be[m&255](o);i=e;return}function sr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a;a=(c[e+4>>2]|0)==(c[e>>2]|0);f=b;c[e>>2]=f;if(!a){i=d;return}c[e+4>>2]=f;i=d;return}function tr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+24|0;f=a;c[f+52>>2]=b;c[f+56>>2]=d;i=e;return}function ur(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=d;d=e;e=f;f=c[h+480>>2]|0;do{if((f|0)==0){if((c[h+476>>2]|0)!=0){break}if((vr(h)|0)<<24>>24!=0){break}c[h+284>>2]=1;j=0;k=j;i=g;return k|0}else if((f|0)==3){c[h+284>>2]=33;j=0;k=j;i=g;return k|0}else if((f|0)==2){c[h+284>>2]=36;j=0;k=j;i=g;return k|0}}while(0);c[h+480>>2]=1;if((d|0)!=0){f=xr(h,d)|0;if((f|0)==0){j=0;k=j;i=g;return k|0}else{z_(f|0,b|0,d|0)|0;j=yr(h,d,e)|0;k=j;i=g;return k|0}}a[h+484|0]=e;if((e|0)==0){j=1;k=j;i=g;return k|0}c[h+296>>2]=c[h+24>>2];c[h+40>>2]=c[h+28>>2];c[h+284>>2]=Ae[c[h+280>>2]&63](h,c[h+24>>2]|0,c[h+40>>2]|0,h+24|0)|0;e=h;if((c[h+284>>2]|0)!=0){c[h+292>>2]=c[e+288>>2];c[h+280>>2]=37;j=0;k=j;i=g;return k|0}d=c[e+480>>2]|0;if((d|0)==1|(d|0)==0){c[h+480>>2]=2}else if((d|0)==3){Be[c[(c[h+144>>2]|0)+52>>2]&31](c[h+144>>2]|0,c[h+296>>2]|0,c[h+24>>2]|0,h+408|0);c[h+296>>2]=c[h+24>>2];j=2;k=j;i=g;return k|0}j=1;k=j;i=g;return k|0}function vr(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=b;if((c[e+496>>2]|0)==0){c[e+496>>2]=ss()|0}if((a[e+236|0]|0)!=0){f=nr(e,27112)|0;g=f;i=d;return g|0}else{f=1;g=f;i=d;return g|0}return 0}function wr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+32|0;i=e;return c[a+284>>2]|0}function xr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+72|0;e=a;a=b;b=c[e+480>>2]|0;if((b|0)==2){c[e+284>>2]=36;f=0;g=f;i=d;return g|0}else if((b|0)==3){c[e+284>>2]=33;f=0;g=f;i=d;return g|0}else{if((a|0)>((c[e+32>>2]|0)-(c[e+28>>2]|0)|0)){b=a+((c[e+28>>2]|0)-(c[e+24>>2]|0))|0;a=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;h=a;h=(h|0)>1024?1024:a;b=b+h|0;do{if((b|0)<=((c[e+32>>2]|0)-(c[e+8>>2]|0)|0)){if((h|0)>=((c[e+24>>2]|0)-(c[e+8>>2]|0)|0)){break}a=(c[e+24>>2]|0)-(c[e+8>>2]|0)-h|0;A_(c[e+8>>2]|0,(c[e+8>>2]|0)+a|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+h|0)|0;j=e+28|0;c[j>>2]=(c[j>>2]|0)+(0-a);j=e+24|0;c[j>>2]=(c[j>>2]|0)+(0-a)}else{a=(c[e+32>>2]|0)-(c[e+24>>2]|0)|0;j=a;j=(j|0)==0?1024:a;do{j=j<<1;}while((j|0)<(b|0));a=ee[c[e+12>>2]&127](j)|0;if((a|0)==0){c[e+284>>2]=1;f=0;g=f;i=d;return g|0}c[e+32>>2]=a+j;if((c[e+24>>2]|0)!=0){k=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;l=k;l=(l|0)>1024?1024:k;z_(a|0,(c[e+24>>2]|0)+(0-l)|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+l|0)|0;be[c[e+20>>2]&255](c[e+8>>2]|0);c[e+8>>2]=a;c[e+28>>2]=(c[e+8>>2]|0)+((c[e+28>>2]|0)-(c[e+24>>2]|0))+l;c[e+24>>2]=(c[e+8>>2]|0)+l;break}else{c[e+28>>2]=a+((c[e+28>>2]|0)-(c[e+24>>2]|0));l=a;c[e+8>>2]=l;c[e+24>>2]=l;break}}}while(0);c[e+292>>2]=0;c[e+288>>2]=0;c[e+296>>2]=0}f=c[e+28>>2]|0;g=f;i=d;return g|0}return 0}function yr(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=b;b=d;d=e;e=1;h=c[g+480>>2]|0;do{if((h|0)==2){c[g+284>>2]=36;j=0;k=j;i=f;return k|0}else if((h|0)==0){if((c[g+476>>2]|0)!=0){break}if((vr(g)|0)<<24>>24!=0){break}c[g+284>>2]=1;j=0;k=j;i=f;return k|0}else if((h|0)==3){c[g+284>>2]=33;j=0;k=j;i=f;return k|0}}while(0);c[g+480>>2]=1;h=c[g+24>>2]|0;c[g+296>>2]=h;l=g+28|0;c[l>>2]=(c[l>>2]|0)+b;c[g+40>>2]=c[g+28>>2];l=g+36|0;c[l>>2]=(c[l>>2]|0)+b;a[g+484|0]=d;c[g+284>>2]=Ae[c[g+280>>2]&63](g,h,c[g+40>>2]|0,g+24|0)|0;h=g;if((c[g+284>>2]|0)!=0){c[g+292>>2]=c[h+288>>2];c[g+280>>2]=37;j=0;k=j;i=f;return k|0}b=c[h+480>>2]|0;do{if((b|0)==1|(b|0)==0){if((d|0)==0){break}c[g+480>>2]=2;j=e;k=j;i=f;return k|0}else if((b|0)==3){e=2}}while(0);Be[c[(c[g+144>>2]|0)+52>>2]&31](c[g+144>>2]|0,c[g+296>>2]|0,c[g+24>>2]|0,g+408|0);c[g+296>>2]=c[g+24>>2];j=e;k=j;i=f;return k|0}function zr(a){a=a|0;var b=0;b=i;i=i+8|0;i=b;return c[a+284>>2]|0}function Ar(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;do{if((c[d+288>>2]|0)!=0){if(!((c[d+288>>2]|0)>>>0>=(c[d+296>>2]|0)>>>0)){break}Be[c[(c[d+144>>2]|0)+52>>2]&31](c[d+144>>2]|0,c[d+296>>2]|0,c[d+288>>2]|0,d+408|0);c[d+296>>2]=c[d+288>>2]}}while(0);i=b;return(c[d+408>>2]|0)+1|0}function Br(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+16|0;j=g+48|0;k=b;b=d;c[h>>2]=e;e=f;if((a[b+72|0]|0)!=0){xe[c[k+80>>2]&15](c[k+4>>2]|0,c[h>>2]|0,e-(c[h>>2]|0)|0);i=g;return}f=k;if((b|0)==(c[k+144>>2]|0)){l=f+288|0;m=k+292|0}else{l=c[f+300>>2]|0;m=(c[k+300>>2]|0)+4|0}do{c[j>>2]=c[k+44>>2];_d[c[b+60>>2]&31](b,h,e,j,c[k+48>>2]|0);c[m>>2]=c[h>>2];xe[c[k+80>>2]&15](c[k+4>>2]|0,c[k+44>>2]|0,(c[j>>2]|0)-(c[k+44>>2]|0)|0);c[l>>2]=c[h>>2];}while((c[h>>2]|0)!=(e|0));i=g;return}function Cr(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;if(d>>>0>0&d>>>0<41){e=c[25336+(d<<2)>>2]|0;f=e;i=b;return f|0}else{e=0;f=e;i=b;return f|0}return 0}function Dr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;do{if((c[d+4>>2]|0)!=0){a=d;if((c[d+16>>2]|0)==0){c[d>>2]=c[a+4>>2];c[d+4>>2]=c[c[d+4>>2]>>2];c[c[d>>2]>>2]=0;c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);c[d+12>>2]=c[d+16>>2];e=1;f=e;i=b;return f|0}if(((c[a+8>>2]|0)-(c[d+16>>2]|0)|0)>=(c[(c[d+4>>2]|0)+4>>2]|0)){break}a=c[c[d+4>>2]>>2]|0;c[c[d+4>>2]>>2]=c[d>>2];c[d>>2]=c[d+4>>2];c[d+4>>2]=a;z_((c[d>>2]|0)+8|0,c[d+16>>2]|0,(c[d+8>>2]|0)-(c[d+16>>2]|0)|0)|0;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);e=1;f=e;i=b;return f|0}}while(0);do{if((c[d>>2]|0)!=0){if((c[d+16>>2]|0)!=((c[d>>2]|0)+8|0)){g=11;break}a=(c[d+8>>2]|0)-(c[d+16>>2]|0)<<1;h=re[c[(c[d+20>>2]|0)+4>>2]&63](c[d>>2]|0,8+a|0)|0;if((h|0)!=0){c[d>>2]=h;c[(c[d>>2]|0)+4>>2]=a;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+a;break}e=0;f=e;i=b;return f|0}else{g=11}}while(0);if((g|0)==11){g=(c[d+8>>2]|0)-(c[d+16>>2]|0)|0;if((g|0)<1024){g=1024}else{g=g<<1}a=ee[c[c[d+20>>2]>>2]&127](8+g|0)|0;if((a|0)==0){e=0;f=e;i=b;return f|0}c[a+4>>2]=g;c[a>>2]=c[d>>2];c[d>>2]=a;if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){z_(a+8|0,c[d+16>>2]|0,(c[d+12>>2]|0)-(c[d+16>>2]|0)|0)|0}c[d+12>>2]=a+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=a+8;c[d+8>>2]=a+8+g}e=1;f=e;i=b;return f|0}function Er(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;a=b;c[e>>2]=c[a>>2];c[e+4>>2]=(c[e>>2]|0)+(c[a+8>>2]<<2);i=d;return}function Fr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+24|0;d=a;while(1){if((c[d>>2]|0)==(c[d+4>>2]|0)){e=5;break}a=d;f=c[a>>2]|0;c[a>>2]=f+4;g=c[f>>2]|0;if((g|0)!=0){e=4;break}}if((e|0)==4){h=g;j=h;i=b;return j|0}else if((e|0)==5){h=0;j=h;i=b;return j|0}return 0}function Gr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+136|0;j=b;b=e;e=f;f=g;a:do{if((c[b+8>>2]|0)==0){if((f|0)==0){k=0;l=k;i=h;return l|0}a[b+4|0]=6;c[b+8>>2]=64;g=c[b+8>>2]<<2;c[b>>2]=ee[c[c[b+16>>2]>>2]&127](g)|0;m=b;if((c[b>>2]|0)!=0){B_(c[m>>2]|0,0,g|0)|0;g=Hr(j,e)|0;n=g&(c[b+8>>2]|0)-1;break}c[m+8>>2]=0;k=0;l=k;i=h;return l|0}else{m=Hr(j,e)|0;g=(c[b+8>>2]|0)-1|0;o=0;n=m&g;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break}if((Ir(e,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0)<<24>>24!=0){p=10;break}if(!(o<<24>>24!=0)){o=((m&~g)>>>((d[b+4|0]|0)-1|0)&g>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+((c[b+8>>2]|0)-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}if((p|0)==10){k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}if((f|0)==0){k=0;l=k;i=h;return l|0}if(((c[b+12>>2]|0)>>>((d[b+4|0]|0)-1|0)|0)==0){break}g=(d[b+4|0]|0)+1&255;q=1<<(g&255);r=q-1|0;s=q<<2;t=ee[c[c[b+16>>2]>>2]&127](s)|0;if((t|0)==0){k=0;l=k;i=h;return l|0}B_(t|0,0,s|0)|0;n=0;while(1){if(!(n>>>0<(c[b+8>>2]|0)>>>0)){break}if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){s=Hr(j,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0;u=s&r;o=0;while(1){if((c[t+(u<<2)>>2]|0)==0){break}if(!(o<<24>>24!=0)){o=((s&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(u>>>0<(o&255)>>>0){u=u+(q-(o&255))|0;continue}else{u=u-(o&255)|0;continue}}c[t+(u<<2)>>2]=c[(c[b>>2]|0)+(n<<2)>>2]}n=n+1|0}be[c[(c[b+16>>2]|0)+8>>2]&255](c[b>>2]|0);c[b>>2]=t;a[b+4|0]=g;c[b+8>>2]=q;n=m&r;o=0;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break a}if(!(o<<24>>24!=0)){o=((m&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+(q-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}}}while(0);j=ee[c[c[b+16>>2]>>2]&127](f)|0;c[(c[b>>2]|0)+(n<<2)>>2]=j;if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){B_(c[(c[b>>2]|0)+(n<<2)>>2]|0,0,f|0)|0;c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]=e;e=b+12|0;c[e>>2]=(c[e>>2]|0)+1;k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}else{k=0;l=k;i=h;return l|0}return 0}function Hr(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+24|0;g=e;e=c[b+496>>2]|0;while(1){h=e;if((a[g]|0)==0){break}b=g;g=b+1|0;e=h*1000003^d[b]}i=f;return h|0}function Ir(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;while(1){if((a[e]|0)!=(a[b]|0)){f=6;break}if((a[e]|0)==0){f=4;break}e=e+1|0;b=b+1|0}if((f|0)==4){g=1;h=g;i=d;return h|0}else if((f|0)==6){g=0;h=g;i=d;return h|0}return 0}function Jr(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;a=0;while(1){e=c[(c[d+16>>2]|0)+8>>2]|0;if(!(a>>>0<(c[d+8>>2]|0)>>>0)){break}be[e&255](c[(c[d>>2]|0)+(a<<2)>>2]|0);a=a+1|0}be[e&255](c[d>>2]|0);i=b;return}function Kr(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+96|0;j=b;b=d;d=e;e=f;f=g;g=0;k=1;l=1;do{if((a[e]|0)==0){if((c[b>>2]|0)==0){break}m=28;n=m;i=h;return n|0}}while(0);do{if((c[b>>2]|0)!=0){if((a[c[b>>2]|0]|0)!=120){break}if((a[(c[b>>2]|0)+1|0]|0)!=109){break}if((a[(c[b>>2]|0)+2|0]|0)!=108){break}do{if((a[(c[b>>2]|0)+3|0]|0)==110){if((a[(c[b>>2]|0)+4|0]|0)!=115){break}if((a[(c[b>>2]|0)+5|0]|0)!=0){break}m=39;n=m;i=h;return n|0}}while(0);if((a[(c[b>>2]|0)+3|0]|0)!=0){break}g=1}}while(0);o=0;while(1){p=(k&255|0)!=0;if((a[e+o|0]|0)==0){break}do{if(p){if((o|0)<=36){if((a[e+o|0]|0)==(a[26920+o|0]|0)){break}}k=0}}while(0);do{if(!(g<<24>>24!=0)){if((l&255|0)==0){break}if((o|0)<=29){if((a[e+o|0]|0)==(a[26960+o|0]|0)){break}}l=0}}while(0);o=o+1|0}if(p){q=(o|0)==36}else{q=0}k=q&1;if((l&255|0)!=0){r=(o|0)==29}else{r=0}l=r&1;if((g&255|0)!=(k&255|0)){m=(g&255|0)!=0?38:40;n=m;i=h;return n|0}if(l<<24>>24!=0){m=40;n=m;i=h;return n|0}if((a[j+472|0]|0)!=0){o=o+1|0}l=j;do{if((c[j+376>>2]|0)!=0){s=c[l+376>>2]|0;do{if((o|0)>(c[s+24>>2]|0)){g=re[c[j+16>>2]&63](c[s+16>>2]|0,o+24|0)|0;if((g|0)!=0){c[s+16>>2]=g;c[s+24>>2]=o+24;break}m=1;n=m;i=h;return n|0}}while(0);c[j+376>>2]=c[s+4>>2]}else{s=ee[c[l+12>>2]&127](28)|0;if((s|0)==0){m=1;n=m;i=h;return n|0}c[s+16>>2]=ee[c[j+12>>2]&127](o+24|0)|0;if((c[s+16>>2]|0)!=0){c[s+24>>2]=o+24;break}be[c[j+20>>2]&255](s);m=1;n=m;i=h;return n|0}}while(0);c[s+20>>2]=o;z_(c[s+16>>2]|0,e|0,o|0)|0;if((a[j+472|0]|0)!=0){a[(c[s+16>>2]|0)+(o-1)|0]=a[j+472|0]|0}c[s>>2]=b;c[s+12>>2]=d;c[s+8>>2]=c[b+4>>2];do{if((a[e]|0)==0){if((b|0)!=((c[j+356>>2]|0)+152|0)){t=52;break}c[b+4>>2]=0}else{t=52}}while(0);if((t|0)==52){c[b+4>>2]=s}c[s+4>>2]=c[f>>2];c[f>>2]=s;do{if((d|0)!=0){if((c[j+100>>2]|0)==0){break}xe[c[j+100>>2]&15](c[j+4>>2]|0,c[b>>2]|0,(c[b+4>>2]|0)!=0?e:0)}}while(0);m=0;n=m;i=h;return n|0}function Lr(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=b;if((ie[((a[e+236|0]&255|0)!=0?32:33)&63](e+148|0,e+144|0,c[e+232>>2]|0)|0)!=0){f=0;g=f;i=d;return g|0}else{f=rs(e,c[e+232>>2]|0)|0;g=f;i=d;return g|0}return 0}function Mr(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+32|0;j=b;b=d;d=e;c[h>>2]=b;e=Ae[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=Nr(j,c[j+144>>2]|0,b,d,e,c[h>>2]|0,f,((a[j+484|0]|0)!=0^1)&1)|0;i=g;return k|0}



function Rj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+9|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+9|0]|0;k=c[c[b+4>>2]>>2]|0;l=Ty(+h[k>>3],+h[(c[k+8>>2]|0)+952>>3],a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=l;f=j;break}else{j=c[c[b+4>>2]>>2]|0;l=Ty(+h[j>>3],+h[(c[j+8>>2]|0)+952>>3],a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+9|0]|0;l=c[c[b+4>>2]>>2]|0;j=Wy(+h[l>>3],+h[(c[l+8>>2]|0)+952>>3])|0;a[(c[b+352>>2]|0)+9|0]=j;f=g;break}else{g=c[c[b+4>>2]>>2]|0;j=Wy(+h[g>>3],+h[(c[g+8>>2]|0)+952>>3])|0;a[(c[b+352>>2]|0)+9|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+10|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+10|0]|0;l=c[c[b+4>>2]>>2]|0;k=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+952>>3]+ +h[(c[b+416>>2]|0)+680>>3],a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=k;m=g;break}else{g=c[c[b+4>>2]>>2]|0;k=Sy(+h[g>>3],+h[(c[g+8>>2]|0)+952>>3]+ +h[(c[b+416>>2]|0)+680>>3],a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+10|0]|0;k=c[c[b+4>>2]>>2]|0;g=Uy(+h[k>>3],+h[(c[k+8>>2]|0)+952>>3]+ +h[(c[b+416>>2]|0)+680>>3])|0;a[(c[b+352>>2]|0)+10|0]=g;m=j;break}else{j=c[c[b+4>>2]>>2]|0;g=Uy(+h[j>>3],+h[(c[j+8>>2]|0)+952>>3]+ +h[(c[b+416>>2]|0)+680>>3])|0;a[(c[b+352>>2]|0)+10|0]=g;m=g;break}}}}while(0);if(f<<24>>24==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+6|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+6|0;z=y;a[z]=n;i=d;return}function Sj(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,6)|0;d=c[(c[a+476>>2]|0)+412>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+984>>3]=+h[d>>3];h[e+968>>3]=+h[d+8>>3];h[e+944>>3]=+h[d+16>>3];h[e+960>>3]=+h[d+24>>3];h[e+976>>3]=+h[d+32>>3];h[e+928>>3]=+h[d+40>>3];h[e+936>>3]=+h[d+48>>3];h[e+1e3>>3]=+h[d+56>>3];h[e+1016>>3]=+h[d+64>>3];h[e+1480>>3]=+h[d+72>>3];h[e+1008>>3]=+h[d+80>>3];i=b;return}function Tj(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,7)|0;d=c[(c[a+476>>2]|0)+476>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1576>>3]=+h[d>>3];h[e+224>>3]=+h[d+8>>3];h[e+1496>>3]=+h[d+16>>3];h[e+1504>>3]=+h[d+24>>3];h[e+1600>>3]=+h[d+32>>3];h[e+248>>3]=+h[d+40>>3];h[e+1568>>3]=+h[d+48>>3];h[e+1536>>3]=+h[d+56>>3];h[e+240>>3]=+h[d+64>>3];h[e+1592>>3]=+h[d+72>>3];i=b;return}function Uj(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+688>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+944>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+176|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+176|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,7864,7856,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+176|0;p=o;h[p>>3]=m;i=d;return}function Vj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+992>>3]=+h[b+944>>3]*+h[b+928>>3];i=i;return}function Wj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1024>>3]=-(+h[b+1480>>3]*+h[b+1488>>3])- +h[b+944>>3]*+h[b+936>>3];i=i;return}function Xj(a){a=a|0;h[(c[a+400>>2]|0)+952>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+952>>3];i=i;return}function Yj(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1056>>3]=+h[(c[a+416>>2]|0)+568>>3];i=i;return}function Zj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+7|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+7|0]|0;k=c[c[b+4>>2]>>2]|0;l=Ty(+h[k>>3],+h[(c[k+8>>2]|0)+1056>>3],a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=l;f=j;break}else{j=c[c[b+4>>2]>>2]|0;l=Ty(+h[j>>3],+h[(c[j+8>>2]|0)+1056>>3],a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+7|0]|0;l=c[c[b+4>>2]>>2]|0;j=Wy(+h[l>>3],+h[(c[l+8>>2]|0)+1056>>3])|0;a[(c[b+352>>2]|0)+7|0]=j;f=g;break}else{g=c[c[b+4>>2]>>2]|0;j=Wy(+h[g>>3],+h[(c[g+8>>2]|0)+1056>>3])|0;a[(c[b+352>>2]|0)+7|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+8|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+8|0]|0;l=c[c[b+4>>2]>>2]|0;k=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+1056>>3]+ +h[(c[b+416>>2]|0)+576>>3],a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=k;m=g;break}else{g=c[c[b+4>>2]>>2]|0;k=Sy(+h[g>>3],+h[(c[g+8>>2]|0)+1056>>3]+ +h[(c[b+416>>2]|0)+576>>3],a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+8|0]|0;k=c[c[b+4>>2]>>2]|0;g=Uy(+h[k>>3],+h[(c[k+8>>2]|0)+1056>>3]+ +h[(c[b+416>>2]|0)+576>>3])|0;a[(c[b+352>>2]|0)+8|0]=g;m=j;break}else{j=c[c[b+4>>2]>>2]|0;g=Uy(+h[j>>3],+h[(c[j+8>>2]|0)+1056>>3]+ +h[(c[b+416>>2]|0)+576>>3])|0;a[(c[b+352>>2]|0)+8|0]=g;m=g;break}}}}while(0);if(f<<24>>24==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+7|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+7|0;z=y;a[z]=n;i=d;return}function _j(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,8)|0;d=c[(c[a+476>>2]|0)+540>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1096>>3]=+h[d>>3];h[e+1080>>3]=+h[d+8>>3];h[e+1048>>3]=+h[d+16>>3];h[e+1064>>3]=+h[d+24>>3];h[e+1088>>3]=+h[d+32>>3];h[e+1032>>3]=+h[d+40>>3];h[e+1120>>3]=+h[d+48>>3];h[e+1128>>3]=+h[d+56>>3];h[e+1072>>3]=+h[d+64>>3];h[e+1112>>3]=+h[d+72>>3];h[e+1040>>3]=+h[d+80>>3];i=b;return}function $j(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+584>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1048>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+184|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+184|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,7888,7880,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+184|0;p=o;h[p>>3]=m;i=d;return}function ak(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1104>>3]=+h[b+1048>>3]*+h[b+1032>>3];i=i;return}function bk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1136>>3]=+h[b+1072>>3]*+h[b+112>>3]- +h[b+1048>>3]*+h[b+1040>>3];i=i;return}function ck(a){a=a|0;h[(c[a+400>>2]|0)+1056>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1056>>3];i=i;return}function dk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1168>>3]=+h[(c[a+416>>2]|0)+464>>3];i=i;return}function ek(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+5|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+5|0]|0;k=c[c[b+4>>2]>>2]|0;l=Ty(+h[k>>3],+h[(c[k+8>>2]|0)+1168>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=l;f=j;break}else{j=c[c[b+4>>2]>>2]|0;l=Ty(+h[j>>3],+h[(c[j+8>>2]|0)+1168>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+5|0]|0;l=c[c[b+4>>2]>>2]|0;j=Wy(+h[l>>3],+h[(c[l+8>>2]|0)+1168>>3])|0;a[(c[b+352>>2]|0)+5|0]=j;f=g;break}else{g=c[c[b+4>>2]>>2]|0;j=Wy(+h[g>>3],+h[(c[g+8>>2]|0)+1168>>3])|0;a[(c[b+352>>2]|0)+5|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+6|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+6|0]|0;l=c[c[b+4>>2]>>2]|0;k=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+1168>>3]+ +h[(c[b+416>>2]|0)+472>>3],a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=k;m=g;break}else{g=c[c[b+4>>2]>>2]|0;k=Sy(+h[g>>3],+h[(c[g+8>>2]|0)+1168>>3]+ +h[(c[b+416>>2]|0)+472>>3],a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+6|0]|0;k=c[c[b+4>>2]>>2]|0;g=Uy(+h[k>>3],+h[(c[k+8>>2]|0)+1168>>3]+ +h[(c[b+416>>2]|0)+472>>3])|0;a[(c[b+352>>2]|0)+6|0]=g;m=j;break}else{j=c[c[b+4>>2]>>2]|0;g=Uy(+h[j>>3],+h[(c[j+8>>2]|0)+1168>>3]+ +h[(c[b+416>>2]|0)+472>>3])|0;a[(c[b+352>>2]|0)+6|0]=g;m=g;break}}}}while(0);if(f<<24>>24==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+8|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+8|0;z=y;a[z]=n;i=d;return}function fk(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,9)|0;d=c[(c[a+476>>2]|0)+604>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1208>>3]=+h[d>>3];h[e+1192>>3]=+h[d+8>>3];h[e+1160>>3]=+h[d+16>>3];h[e+1176>>3]=+h[d+24>>3];h[e+1200>>3]=+h[d+32>>3];h[e+1144>>3]=+h[d+40>>3];h[e+1232>>3]=+h[d+48>>3];h[e+1240>>3]=+h[d+56>>3];h[e+1184>>3]=+h[d+64>>3];h[e+1224>>3]=+h[d+72>>3];h[e+1152>>3]=+h[d+80>>3];i=b;return}function gk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1512>>3]=-+h[b+1176>>3]- +h[b+1064>>3];i=i;return}function hk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1528>>3]=+h[b+1512>>3]- +h[b+408>>3]- +h[b+632>>3];i=i;return}function ik(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+104>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1512>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+216|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+216|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,7912,7904,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+216|0;p=o;h[p>>3]=m;i=d;return}function jk(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+480>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1160>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+192|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+192|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,7928,7920,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+192|0;p=o;h[p>>3]=m;i=d;return}function kk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1216>>3]=+h[b+1160>>3]*+h[b+1144>>3];i=i;return}function lk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1520>>3]=+h[b+1496>>3]- +h[b+1576>>3]- +h[b+288>>3]- +h[b+1184>>3];i=i;return}function mk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1248>>3]=+h[b+1184>>3]*+h[b+96>>3]- +h[b+1160>>3]*+h[b+1152>>3];i=i;return}function nk(a){a=a|0;h[(c[a+400>>2]|0)+1168>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1168>>3];i=i;return}function ok(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1280>>3]=+h[(c[a+416>>2]|0)+360>>3];i=i;return}function pk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+3|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+3|0]|0;k=c[c[b+4>>2]>>2]|0;l=Ty(+h[k>>3],+h[(c[k+8>>2]|0)+1280>>3],a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=l;f=j;break}else{j=c[c[b+4>>2]>>2]|0;l=Ty(+h[j>>3],+h[(c[j+8>>2]|0)+1280>>3],a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+3|0]|0;l=c[c[b+4>>2]>>2]|0;j=Wy(+h[l>>3],+h[(c[l+8>>2]|0)+1280>>3])|0;a[(c[b+352>>2]|0)+3|0]=j;f=g;break}else{g=c[c[b+4>>2]>>2]|0;j=Wy(+h[g>>3],+h[(c[g+8>>2]|0)+1280>>3])|0;a[(c[b+352>>2]|0)+3|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+4|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+4|0]|0;l=c[c[b+4>>2]>>2]|0;k=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+1280>>3]+ +h[(c[b+416>>2]|0)+368>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=k;m=g;break}else{g=c[c[b+4>>2]>>2]|0;k=Sy(+h[g>>3],+h[(c[g+8>>2]|0)+1280>>3]+ +h[(c[b+416>>2]|0)+368>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+4|0]|0;k=c[c[b+4>>2]>>2]|0;g=Uy(+h[k>>3],+h[(c[k+8>>2]|0)+1280>>3]+ +h[(c[b+416>>2]|0)+368>>3])|0;a[(c[b+352>>2]|0)+4|0]=g;m=j;break}else{j=c[c[b+4>>2]>>2]|0;g=Uy(+h[j>>3],+h[(c[j+8>>2]|0)+1280>>3]+ +h[(c[b+416>>2]|0)+368>>3])|0;a[(c[b+352>>2]|0)+4|0]=g;m=g;break}}}}while(0);if(f<<24>>24==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+9|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+9|0;z=y;a[z]=n;i=d;return}function qk(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,10)|0;d=c[(c[a+476>>2]|0)+668>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1296>>3]=+h[d>>3];h[e+1336>>3]=+h[d+8>>3];h[e+1264>>3]=+h[d+16>>3];h[e+1320>>3]=+h[d+24>>3];h[e+1304>>3]=+h[d+32>>3];h[e+1256>>3]=+h[d+40>>3];h[e+1312>>3]=+h[d+48>>3];h[e+1288>>3]=+h[d+56>>3];h[e+1272>>3]=+h[d+64>>3];h[e+1352>>3]=+h[d+72>>3];h[e+1344>>3]=+h[d+80>>3];i=b;return}function rk(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+376>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1272>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+200|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+200|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,7952,7944,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+200|0;p=o;h[p>>3]=m;i=d;return}function sk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1544>>3]=+h[b+1536>>3]- +h[b+1504>>3]- +h[b+1592>>3]- +h[b+1072>>3]- +h[b+1296>>3];i=i;return}function tk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1328>>3]=+h[b+1272>>3]*+h[b+1256>>3];i=i;return}function uk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1360>>3]=+h[b+1296>>3]*+h[b+112>>3]- +h[b+1272>>3]*+h[b+1264>>3];i=i;return}function vk(a){a=a|0;h[(c[a+400>>2]|0)+1280>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1280>>3];i=i;return}function wk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1392>>3]=+h[(c[a+416>>2]|0)+256>>3];i=i;return}function xk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+1|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+1|0]|0;k=c[c[b+4>>2]>>2]|0;l=Ty(+h[k>>3],+h[(c[k+8>>2]|0)+1392>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=l;f=j;break}else{j=c[c[b+4>>2]>>2]|0;l=Ty(+h[j>>3],+h[(c[j+8>>2]|0)+1392>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+1|0]|0;l=c[c[b+4>>2]>>2]|0;j=Wy(+h[l>>3],+h[(c[l+8>>2]|0)+1392>>3])|0;a[(c[b+352>>2]|0)+1|0]=j;f=g;break}else{g=c[c[b+4>>2]>>2]|0;j=Wy(+h[g>>3],+h[(c[g+8>>2]|0)+1392>>3])|0;a[(c[b+352>>2]|0)+1|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+2|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+2|0]|0;l=c[c[b+4>>2]>>2]|0;k=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+1392>>3]+ +h[(c[b+416>>2]|0)+264>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=k;m=g;break}else{g=c[c[b+4>>2]>>2]|0;k=Sy(+h[g>>3],+h[(c[g+8>>2]|0)+1392>>3]+ +h[(c[b+416>>2]|0)+264>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+2|0]|0;k=c[c[b+4>>2]>>2]|0;g=Uy(+h[k>>3],+h[(c[k+8>>2]|0)+1392>>3]+ +h[(c[b+416>>2]|0)+264>>3])|0;a[(c[b+352>>2]|0)+2|0]=g;m=j;break}else{j=c[c[b+4>>2]>>2]|0;g=Uy(+h[j>>3],+h[(c[j+8>>2]|0)+1392>>3]+ +h[(c[b+416>>2]|0)+264>>3])|0;a[(c[b+352>>2]|0)+2|0]=g;m=g;break}}}}while(0);if(f<<24>>24==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+10|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+10|0;z=y;a[z]=n;i=d;return}function yk(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,11)|0;d=c[(c[a+476>>2]|0)+732>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1432>>3]=+h[d>>3];h[e+1416>>3]=+h[d+8>>3];h[e+1384>>3]=+h[d+16>>3];h[e+1400>>3]=+h[d+24>>3];h[e+1424>>3]=+h[d+32>>3];h[e+1368>>3]=+h[d+40>>3];h[e+1456>>3]=+h[d+48>>3];h[e+1464>>3]=+h[d+56>>3];h[e+1408>>3]=+h[d+64>>3];h[e+1448>>3]=+h[d+72>>3];h[e+1376>>3]=+h[d+80>>3];i=b;return}function zk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1584>>3]=-+h[b+1400>>3]- +h[b+1288>>3];i=i;return}function Ak(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1552>>3]=+h[b+1584>>3]- +h[b+520>>3]- +h[b+856>>3];i=i;return}function Bk(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+72>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1584>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+232|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+232|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,7976,7968,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+232|0;p=o;h[p>>3]=m;i=d;return}function Ck(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+272>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1384>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+208|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+208|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,7992,7984,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+208|0;p=o;h[p>>3]=m;i=d;return}function Dk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1440>>3]=+h[b+1384>>3]*+h[b+1368>>3];i=i;return}function Ek(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1560>>3]=+h[b+1600>>3]- +h[b+1568>>3]- +h[b+736>>3]- +h[b+1408>>3];i=i;return}function Fk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1472>>3]=-(+h[b+1408>>3]*+h[b+120>>3])- +h[b+1384>>3]*+h[b+1376>>3];i=i;return}function Gk(a){a=a|0;h[(c[a+400>>2]|0)+1392>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1392>>3];i=i;return}function Hk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2056>>3]=0.0;i=i;return}function Ik(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2048>>3]=0.0;i=i;return}function Jk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2040>>3]=0.0;i=i;return}function Kk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2032>>3]=0.0;i=i;return}function Lk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2024>>3]=0.0;i=i;return}function Mk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2016>>3]=0.0;i=i;return}function Nk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2008>>3]=0.0;i=i;return}function Ok(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2e3>>3]=0.0;i=i;return}function Pk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1992>>3]=0.0;i=i;return}function Qk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1984>>3]=0.0;i=i;return}function Rk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1976>>3]=0.0;i=i;return}function Sk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1968>>3]=0.0;i=i;return}function Tk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1960>>3]=0.0;i=i;return}function Uk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1952>>3]=0.0;i=i;return}function Vk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1944>>3]=0.0;i=i;return}function Wk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1936>>3]=0.0;i=i;return}function Xk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1928>>3]=0.0;i=i;return}function Yk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1920>>3]=0.0;i=i;return}function Zk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1912>>3]=0.0;i=i;return}function _k(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1904>>3]=0.0;i=i;return}function $k(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1896>>3]=0.0;i=i;return}function al(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1888>>3]=0.0;i=i;return}function bl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1880>>3]=0.0;i=i;return}function cl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1872>>3]=0.0;i=i;return}function dl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1864>>3]=0.0;i=i;return}function el(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1856>>3]=0.0;i=i;return}function fl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1848>>3]=0.0;i=i;return}function gl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1840>>3]=0.0;i=i;return}function hl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1832>>3]=0.0;i=i;return}function il(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1824>>3]=0.0;i=i;return}function jl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1816>>3]=0.0;i=i;return}function kl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1808>>3]=0.0;i=i;return}function ll(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1800>>3]=0.0;i=i;return}function ml(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1792>>3]=0.0;i=i;return}function nl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1784>>3]=0.0;i=i;return}function ol(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1776>>3]=0.0;i=i;return}function pl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1768>>3]=0.0;i=i;return}function ql(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1760>>3]=0.0;i=i;return}function rl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1752>>3]=0.0;i=i;return}function sl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1744>>3]=0.0;i=i;return}function tl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1736>>3]=0.0;i=i;return}function ul(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1728>>3]=0.0;i=i;return}function vl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1720>>3]=0.0;i=i;return}function wl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1712>>3]=0.0;i=i;return}function xl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1704>>3]=0.0;i=i;return}function yl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1696>>3]=0.0;i=i;return}function zl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1688>>3]=0.0;i=i;return}function Al(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1680>>3]=0.0;i=i;return}function Bl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1672>>3]=0.0;i=i;return}function Cl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1664>>3]=0.0;i=i;return}function Dl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1656>>3]=0.0;i=i;return}function El(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1648>>3]=0.0;i=i;return}function Fl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1640>>3]=0.0;i=i;return}function Gl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1632>>3]=0.0;i=i;return}function Hl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1624>>3]=0.0;i=i;return}function Il(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1616>>3]=0.0;i=i;return}function Jl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1608>>3]=0.0;i=i;return}function Kl(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+11|0]=0;i=i;return}function Ll(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+12|0]=0;i=i;return}function Ml(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+13|0]=0;i=i;return}function Nl(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+14|0]=0;i=i;return}function Ol(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+15|0]=0;i=i;return}function Pl(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+16|0]=0;i=i;return}function Ql(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+17|0]=0;i=i;return}function Rl(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+18|0]=0;i=i;return}function Sl(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+19|0]=0;i=i;return}function Tl(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+20|0]=0;i=i;return}function Ul(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+21|0]=0;i=i;return}function Vl(b){b=b|0;var c=0,d=0;c=i;d=b+314|0;a[d]=1;Sh(b);Th(b);Uh(b);Vh(b);Wh(b);Xh(b);Yh(b);Zh(b);_h(b);$h(b);ai(b);bi(b);ci(b);di(b);ei(b);fi(b);gi(b);hi(b);ii(b);ji(b);ki(b);li(b);mi(b);ni(b);oi(b);pi(b);qi(b);ri(b);si(b);ti(b);ui(b);vi(b);wi(b);xi(b);yi(b);zi(b);Ai(b);Bi(b);Ci(b);Di(b);Ei(b);Fi(b);Gi(b);Hi(b);Ii(b);Ji(b);Ki(b);Li(b);Mi(b);Ni(b);Oi(b);Pi(b);Qi(b);Ri(b);Si(b);Ti(b);Ui(b);Vi(b);Wi(b);Xi(b);Yi(b);Zi(b);_i(b);$i(b);aj(b);bj(b);cj(b);dj(b);ej(b);fj(b);gj(b);hj(b);ij(b);jj(b);kj(b);lj(b);mj(b);nj(b);oj(b);pj(b);qj(b);rj(b);sj(b);tj(b);uj(b);vj(b);wj(b);xj(b);yj(b);zj(b);Aj(b);Bj(b);Cj(b);Dj(b);Ej(b);Fj(b);Gj(b);Hj(b);Ij(b);Jj(b);Kj(b);Lj(b);Mj(b);Nj(b);Oj(b);Pj(b);Qj(b);Rj(b);Sj(b);Tj(b);Uj(b);Vj(b);Wj(b);Xj(b);Yj(b);Zj(b);_j(b);$j(b);ak(b);bk(b);ck(b);dk(b);ek(b);fk(b);gk(b);hk(b);ik(b);jk(b);kk(b);lk(b);mk(b);nk(b);ok(b);pk(b);qk(b);rk(b);sk(b);tk(b);uk(b);vk(b);wk(b);xk(b);yk(b);zk(b);Ak(b);Bk(b);Ck(b);Dk(b);Ek(b);Fk(b);Gk(b);Hk(b);Ik(b);Jk(b);Kk(b);Lk(b);Mk(b);Nk(b);Ok(b);Pk(b);Qk(b);Rk(b);Sk(b);Tk(b);Uk(b);Vk(b);Wk(b);Xk(b);Yk(b);Zk(b);_k(b);$k(b);al(b);bl(b);cl(b);dl(b);el(b);fl(b);gl(b);hl(b);il(b);jl(b);kl(b);ll(b);ml(b);nl(b);ol(b);pl(b);ql(b);rl(b);sl(b);tl(b);ul(b);vl(b);wl(b);xl(b);yl(b);zl(b);Al(b);Bl(b);Cl(b);Dl(b);El(b);Fl(b);Gl(b);Hl(b);Il(b);Jl(b);Kl(b);Ll(b);Ml(b);Nl(b);Ol(b);Pl(b);Ql(b);Rl(b);Sl(b);Tl(b);Ul(b);a[d]=0;i=c;return 0}function Wl(a){a=a|0;i=i;return}function Xl(a){a=a|0;i=i;return 0}function Yl(a){a=a|0;var b=0,d=0,e=0;a=i;i=i+8|0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;gw(9,1,8008,e);if((c[35620>>2]|0)!=0){be[c[9034]&255](9)}gw(9,1,8032,d);if((c[35620>>2]|0)!=0){be[c[9034]&255](9)}gw(9,1,8056,b);if((c[35620>>2]|0)!=0){be[c[9034]&255](9)}gw(9,1,8080,a);if((c[35620>>2]|0)==0){i=a;return 0}be[c[9034]&255](9);i=a;return 0}function Zl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1608>>3]=0.0;i=i;return}function _l(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1616>>3]=0.0;i=i;return}function $l(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1624>>3]=0.0;i=i;return}function am(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1632>>3]=0.0;i=i;return}function bm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1640>>3]=0.0;i=i;return}function cm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1648>>3]=0.0;i=i;return}function dm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1656>>3]=0.0;i=i;return}function em(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1664>>3]=0.0;i=i;return}function fm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1672>>3]=0.0;i=i;return}function gm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1680>>3]=0.0;i=i;return}function hm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1688>>3]=0.0;i=i;return}function im(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1696>>3]=0.0;i=i;return}function jm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1704>>3]=0.0;i=i;return}function km(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1712>>3]=0.0;i=i;return}function lm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1720>>3]=0.0;i=i;return}function mm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1728>>3]=0.0;i=i;return}function nm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1736>>3]=0.0;i=i;return}function om(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1744>>3]=0.0;i=i;return}function pm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1752>>3]=0.0;i=i;return}function qm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1760>>3]=0.0;i=i;return}function rm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1768>>3]=0.0;i=i;return}function sm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1776>>3]=0.0;i=i;return}function tm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1784>>3]=0.0;i=i;return}function um(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1792>>3]=0.0;i=i;return}function vm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1800>>3]=0.0;i=i;return}function wm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1808>>3]=0.0;i=i;return}function xm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1816>>3]=0.0;i=i;return}function ym(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1824>>3]=0.0;i=i;return}function zm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1832>>3]=0.0;i=i;return}function Am(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1840>>3]=0.0;i=i;return}function Bm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1848>>3]=0.0;i=i;return}function Cm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1856>>3]=0.0;i=i;return}function Dm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1864>>3]=0.0;i=i;return}function Em(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1872>>3]=0.0;i=i;return}function Fm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1880>>3]=0.0;i=i;return}function Gm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1888>>3]=0.0;i=i;return}function Hm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1896>>3]=0.0;i=i;return}function Im(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1904>>3]=0.0;i=i;return}function Jm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1912>>3]=0.0;i=i;return}function Km(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1920>>3]=0.0;i=i;return}function Lm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1928>>3]=0.0;i=i;return}function Mm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1936>>3]=0.0;i=i;return}function Nm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1944>>3]=0.0;i=i;return}function Om(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1952>>3]=0.0;i=i;return}function Pm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1960>>3]=0.0;i=i;return}function Qm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1968>>3]=0.0;i=i;return}function Rm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1976>>3]=0.0;i=i;return}function Sm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1984>>3]=0.0;i=i;return}function Tm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1992>>3]=0.0;i=i;return}function Um(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2e3>>3]=0.0;i=i;return}function Vm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2008>>3]=0.0;i=i;return}function Wm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2016>>3]=0.0;i=i;return}function Xm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2024>>3]=0.0;i=i;return}function Ym(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2032>>3]=0.0;i=i;return}function Zm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2040>>3]=0.0;i=i;return}function _m(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2048>>3]=0.0;i=i;return}function $m(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2056>>3]=0.0;i=i;return}function an(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f>>3]*2.906997720064;if(g!=0.0){j=g;k=f;l=1.0/j;m=k;n=m+24|0;o=n;h[o>>3]=l;i=d;return}p=+mw(c[b+536>>2]|0,g,8112,8104,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=p;k=c[e>>2]|0;l=1.0/j;m=k;n=m+24|0;o=n;h[o>>3]=l;i=d;return}function bn(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+8>>3]*1.392270203025;if(g!=0.0){j=g;k=f;l=1.0/j;m=k;n=m+40|0;o=n;h[o>>3]=l;i=d;return}p=+mw(c[b+536>>2]|0,g,8144,8136,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=p;k=c[e>>2]|0;l=1.0/j;m=k;n=m+40|0;o=n;h[o>>3]=l;i=d;return}function cn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+56>>3]=+h[b+16>>3]+ +h[b+24>>3];i=i;return}function dn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+64>>3]=+h[b+24>>3];i=i;return}function en(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+72>>3]=+h[b>>3];i=i;return}function fn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+80>>3]=+h[b+40>>3];i=i;return}function gn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+88>>3]=+h[b+24>>3];i=i;return}function hn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+96>>3]=+h[b+24>>3]+(+h[b+32>>3]+ +h[b+40>>3]);i=i;return}function jn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+104>>3]=+h[b+8>>3];i=i;return}function kn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+112>>3]=+h[b+40>>3];i=i;return}function ln(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+120>>3]=+h[b+40>>3]+ +h[b+48>>3];i=i;return}function mn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+152>>3]=+h[b+128>>3];i=i;return}function nn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+160>>3]=+h[b+136>>3];i=i;return}function on(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+168>>3]=+h[b+144>>3];i=i;return}function pn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+248>>3]=+h[b+176>>3];i=i;return}function qn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+264>>3]=+h[b+248>>3]*+h[b+240>>3]*.01;i=i;return}function rn(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+184>>3];j=+h[f+176>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+mw(c[b+536>>2]|0,g,8176,8168,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+272>>3]=l;i=d;return}function sn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+352>>3]=+h[b+280>>3];i=i;return}function tn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+368>>3]=+h[b+352>>3]*+h[b+344>>3]*.01;i=i;return}function un(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+288>>3];j=+h[f+280>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+mw(c[b+536>>2]|0,g,8192,8184,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+376>>3]=l;i=d;return}function vn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+456>>3]=+h[b+384>>3];i=i;return}function wn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+472>>3]=+h[b+456>>3]*+h[b+448>>3]*.01;i=i;return}function xn(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+392>>3];j=+h[f+384>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+mw(c[b+536>>2]|0,g,8208,8200,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+480>>3]=l;i=d;return}function yn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+560>>3]=+h[b+488>>3];i=i;return}function zn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+576>>3]=+h[b+560>>3]*+h[b+552>>3]*.01;i=i;return}function An(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+496>>3];j=+h[f+488>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+mw(c[b+536>>2]|0,g,8224,8216,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+584>>3]=l;i=d;return}function Bn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+664>>3]=+h[b+592>>3];i=i;return}function Cn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+680>>3]=+h[b+664>>3]*+h[b+656>>3]*.01;i=i;return}function Dn(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+600>>3];j=+h[f+592>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+mw(c[b+536>>2]|0,g,8240,8232,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+688>>3]=l;i=d;return}function En(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+768>>3]=+h[b+696>>3];i=i;return}function Fn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+784>>3]=+h[b+768>>3]*+h[b+760>>3]*.01;i=i;return}function Gn(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+704>>3];j=+h[f+696>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+mw(c[b+536>>2]|0,g,8256,8248,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+792>>3]=l;i=d;return}function Hn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+872>>3]=+h[b+800>>3];i=i;return}function In(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+888>>3]=+h[b+872>>3]*+h[b+864>>3]*.01;i=i;return}function Jn(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+808>>3];j=+h[f+800>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+mw(c[b+536>>2]|0,g,8272,8264,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+896>>3]=l;i=d;return}function Kn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+976>>3]=+h[b+904>>3];i=i;return}function Ln(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+992>>3]=+h[b+976>>3]*+h[b+968>>3]*.01;i=i;return}function Mn(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+912>>3];j=+h[f+904>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+mw(c[b+536>>2]|0,g,8288,8280,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1e3>>3]=l;i=d;return}function Nn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1080>>3]=+h[b+1008>>3];i=i;return}function On(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1096>>3]=+h[b+1080>>3]*+h[b+1072>>3]*.01;i=i;return}function Pn(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1016>>3];j=+h[f+1008>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+mw(c[b+536>>2]|0,g,8304,8296,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1104>>3]=l;i=d;return}function Qn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1184>>3]=+h[b+1112>>3];i=i;return}function Rn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1200>>3]=+h[b+1184>>3]*+h[b+1176>>3]*.01;i=i;return}function Sn(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1120>>3];j=+h[f+1112>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+mw(c[b+536>>2]|0,g,8320,8312,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1208>>3]=l;i=d;return}function Tn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1288>>3]=+h[b+1216>>3];i=i;return}function Un(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1304>>3]=+h[b+1288>>3]*+h[b+1280>>3]*.01;i=i;return}function Vn(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1224>>3];j=+h[f+1216>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+mw(c[b+536>>2]|0,g,8336,8328,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1312>>3]=l;i=d;return}function Wn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8344]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(8360,Ew(+h[(c[g>>2]|0)+1312>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[8344]=1;i=d;return}function Xn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8536]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1288>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=Hw(8544,Ew(+h[(c[g>>2]|0)+1288>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[8536]=1;i=d;return}function Yn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8728]&1){i=d;return}g=b+416|0;b=Wy(+h[(c[g>>2]|0)+1280>>3],1.0e-60)|0;if(!(b<<24>>24==0|(Vy(+h[(c[g>>2]|0)+1280>>3],100.0)|0)<<24>>24==0)){i=d;return}b=Hw(8736,Ew(+h[(c[g>>2]|0)+1280>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21216;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[8728]=1;i=d;return}function Zn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8880]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(8888,Ew(+h[(c[g>>2]|0)+1272>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[8880]=1;i=d;return}function _n(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9088]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1264>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(9096,Ew(+h[(c[g>>2]|0)+1264>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[9088]=1;i=d;return}function $n(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9216]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1256>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(9224,Ew(+h[(c[g>>2]|0)+1256>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[9216]=1;i=d;return}function ao(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9424]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(9432,Ew(+h[(c[g>>2]|0)+1248>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[9424]=1;i=d;return}function bo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9552]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(9560,Ew(+h[(c[g>>2]|0)+1240>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[9552]=1;i=d;return}function co(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9680]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1232>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(9688,Ew(+h[(c[g>>2]|0)+1232>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[9680]=1;i=d;return}function eo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9800]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1224>>3],1.0e-15)|0)<<24>>24==0)){i=d;return}b=Hw(9808,Ew(+h[(c[g>>2]|0)+1224>>3],8352)|0)|0;g=c[20440]|0;j=e;k=17200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[9800]=1;i=d;return}function fo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9984]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(9992,Ew(+h[(c[g>>2]|0)+1208>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[9984]=1;i=d;return}function go(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10088]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1184>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=Hw(10096,Ew(+h[(c[g>>2]|0)+1184>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[10088]=1;i=d;return}function ho(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10208]&1){i=d;return}g=b+416|0;b=Wy(+h[(c[g>>2]|0)+1176>>3],1.0e-60)|0;if(!(b<<24>>24==0|(Vy(+h[(c[g>>2]|0)+1176>>3],100.0)|0)<<24>>24==0)){i=d;return}b=Hw(10216,Ew(+h[(c[g>>2]|0)+1176>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21216;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[10208]=1;i=d;return}function io(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10360]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(10368,Ew(+h[(c[g>>2]|0)+1168>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[10360]=1;i=d;return}function jo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10488]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1160>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(10496,Ew(+h[(c[g>>2]|0)+1160>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[10488]=1;i=d;return}function ko(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10616]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1152>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(10624,Ew(+h[(c[g>>2]|0)+1152>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[10616]=1;i=d;return}function lo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10736]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1144>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(10744,Ew(+h[(c[g>>2]|0)+1144>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[10736]=1;i=d;return}function mo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10864]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1136>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(10872,Ew(+h[(c[g>>2]|0)+1136>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[10864]=1;i=d;return}function no(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10992]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(11e3,Ew(+h[(c[g>>2]|0)+1128>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[10992]=1;i=d;return}function oo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11112]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1120>>3],1.0e-15)|0)<<24>>24==0)){i=d;return}b=Hw(11120,Ew(+h[(c[g>>2]|0)+1120>>3],8352)|0)|0;g=c[20440]|0;j=e;k=17200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[11112]=1;i=d;return}function po(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11192]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1104>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(11200,Ew(+h[(c[g>>2]|0)+1104>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[11192]=1;i=d;return}function qo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11288]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1080>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=Hw(11296,Ew(+h[(c[g>>2]|0)+1080>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[11288]=1;i=d;return}function ro(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11408]&1){i=d;return}g=b+416|0;b=Wy(+h[(c[g>>2]|0)+1072>>3],1.0e-60)|0;if(!(b<<24>>24==0|(Vy(+h[(c[g>>2]|0)+1072>>3],100.0)|0)<<24>>24==0)){i=d;return}b=Hw(11416,Ew(+h[(c[g>>2]|0)+1072>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21216;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[11408]=1;i=d;return}function so(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11560]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1064>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(11568,Ew(+h[(c[g>>2]|0)+1064>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[11560]=1;i=d;return}function to(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11688]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1056>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(11696,Ew(+h[(c[g>>2]|0)+1056>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[11688]=1;i=d;return}function uo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11816]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1048>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(11824,Ew(+h[(c[g>>2]|0)+1048>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[11816]=1;i=d;return}function vo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11936]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1040>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(11944,Ew(+h[(c[g>>2]|0)+1040>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[11936]=1;i=d;return}function wo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12064]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1032>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(12072,Ew(+h[(c[g>>2]|0)+1032>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[12064]=1;i=d;return}function xo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12192]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1024>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(12200,Ew(+h[(c[g>>2]|0)+1024>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[12192]=1;i=d;return}function yo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12312]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1016>>3],1.0e-15)|0)<<24>>24==0)){i=d;return}b=Hw(12320,Ew(+h[(c[g>>2]|0)+1016>>3],8352)|0)|0;g=c[20440]|0;j=e;k=17200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[12312]=1;i=d;return}function zo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12392]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+1e3>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(12400,Ew(+h[(c[g>>2]|0)+1e3>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[12392]=1;i=d;return}function Ao(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12496]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+976>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=Hw(12504,Ew(+h[(c[g>>2]|0)+976>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[12496]=1;i=d;return}function Bo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12616]&1){i=d;return}g=b+416|0;b=Wy(+h[(c[g>>2]|0)+968>>3],1.0e-60)|0;if(!(b<<24>>24==0|(Vy(+h[(c[g>>2]|0)+968>>3],100.0)|0)<<24>>24==0)){i=d;return}b=Hw(12624,Ew(+h[(c[g>>2]|0)+968>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21216;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[12616]=1;i=d;return}function Co(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12768]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+960>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(12776,Ew(+h[(c[g>>2]|0)+960>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[12768]=1;i=d;return}function Do(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12896]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+952>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(12904,Ew(+h[(c[g>>2]|0)+952>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[12896]=1;i=d;return}function Eo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13024]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+944>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(13032,Ew(+h[(c[g>>2]|0)+944>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[13024]=1;i=d;return}function Fo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13144]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+936>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(13152,Ew(+h[(c[g>>2]|0)+936>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[13144]=1;i=d;return}function Go(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13272]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(13280,Ew(+h[(c[g>>2]|0)+928>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[13272]=1;i=d;return}function Ho(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13400]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+920>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(13408,Ew(+h[(c[g>>2]|0)+920>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[13400]=1;i=d;return}function Io(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13520]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+912>>3],1.0e-15)|0)<<24>>24==0)){i=d;return}b=Hw(13528,Ew(+h[(c[g>>2]|0)+912>>3],8352)|0)|0;g=c[20440]|0;j=e;k=17200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[13520]=1;i=d;return}function Jo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13600]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+896>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(13608,Ew(+h[(c[g>>2]|0)+896>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[13600]=1;i=d;return}function Ko(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13696]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+872>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=Hw(13704,Ew(+h[(c[g>>2]|0)+872>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[13696]=1;i=d;return}function Lo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13816]&1){i=d;return}g=b+416|0;b=Wy(+h[(c[g>>2]|0)+864>>3],1.0e-60)|0;if(!(b<<24>>24==0|(Vy(+h[(c[g>>2]|0)+864>>3],100.0)|0)<<24>>24==0)){i=d;return}b=Hw(13824,Ew(+h[(c[g>>2]|0)+864>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21216;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[13816]=1;i=d;return}function Mo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13968]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+856>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(13976,Ew(+h[(c[g>>2]|0)+856>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[13968]=1;i=d;return}function No(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14096]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+848>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(14104,Ew(+h[(c[g>>2]|0)+848>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[14096]=1;i=d;return}function Oo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14224]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(14232,Ew(+h[(c[g>>2]|0)+840>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[14224]=1;i=d;return}function Po(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14344]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(14352,Ew(+h[(c[g>>2]|0)+832>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[14344]=1;i=d;return}function Qo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14472]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+824>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(14480,Ew(+h[(c[g>>2]|0)+824>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[14472]=1;i=d;return}function Ro(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14600]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+816>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(14608,Ew(+h[(c[g>>2]|0)+816>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[14600]=1;i=d;return}function So(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14720]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+808>>3],1.0e-15)|0)<<24>>24==0)){i=d;return}b=Hw(14728,Ew(+h[(c[g>>2]|0)+808>>3],8352)|0)|0;g=c[20440]|0;j=e;k=17200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[14720]=1;i=d;return}function To(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14800]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+792>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(14808,Ew(+h[(c[g>>2]|0)+792>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[14800]=1;i=d;return}function Uo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14896]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+768>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=Hw(14904,Ew(+h[(c[g>>2]|0)+768>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[14896]=1;i=d;return}function Vo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15016]&1){i=d;return}g=b+416|0;b=Wy(+h[(c[g>>2]|0)+760>>3],1.0e-60)|0;if(!(b<<24>>24==0|(Vy(+h[(c[g>>2]|0)+760>>3],100.0)|0)<<24>>24==0)){i=d;return}b=Hw(15024,Ew(+h[(c[g>>2]|0)+760>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21216;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[15016]=1;i=d;return}function Wo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15168]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+752>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(15176,Ew(+h[(c[g>>2]|0)+752>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[15168]=1;i=d;return}function Xo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15296]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+744>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(15304,Ew(+h[(c[g>>2]|0)+744>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[15296]=1;i=d;return}function Yo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15424]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(15432,Ew(+h[(c[g>>2]|0)+736>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[15424]=1;i=d;return}function Zo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15544]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+728>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(15552,Ew(+h[(c[g>>2]|0)+728>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[15544]=1;i=d;return}function _o(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15672]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+720>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(15680,Ew(+h[(c[g>>2]|0)+720>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[15672]=1;i=d;return}function $o(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15800]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+712>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(15808,Ew(+h[(c[g>>2]|0)+712>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[15800]=1;i=d;return}function ap(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15920]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+704>>3],1.0e-15)|0)<<24>>24==0)){i=d;return}b=Hw(15928,Ew(+h[(c[g>>2]|0)+704>>3],8352)|0)|0;g=c[20440]|0;j=e;k=17200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[15920]=1;i=d;return}function bp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16e3]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(16008,Ew(+h[(c[g>>2]|0)+688>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[16e3]=1;i=d;return}function cp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16096]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+664>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=Hw(16104,Ew(+h[(c[g>>2]|0)+664>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[16096]=1;i=d;return}function dp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16216]&1){i=d;return}g=b+416|0;b=Wy(+h[(c[g>>2]|0)+656>>3],1.0e-60)|0;if(!(b<<24>>24==0|(Vy(+h[(c[g>>2]|0)+656>>3],100.0)|0)<<24>>24==0)){i=d;return}b=Hw(16224,Ew(+h[(c[g>>2]|0)+656>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21216;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[16216]=1;i=d;return}function ep(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16368]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+648>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(16376,Ew(+h[(c[g>>2]|0)+648>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[16368]=1;i=d;return}function fp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16496]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+640>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(16504,Ew(+h[(c[g>>2]|0)+640>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[16496]=1;i=d;return}function gp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16624]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+632>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(16632,Ew(+h[(c[g>>2]|0)+632>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[16624]=1;i=d;return}function hp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16744]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+624>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(16752,Ew(+h[(c[g>>2]|0)+624>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[16744]=1;i=d;return}function ip(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16872]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+616>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(16880,Ew(+h[(c[g>>2]|0)+616>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[16872]=1;i=d;return}function jp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17e3]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+608>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(17008,Ew(+h[(c[g>>2]|0)+608>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[17e3]=1;i=d;return}function kp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17120]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+600>>3],1.0e-15)|0)<<24>>24==0)){i=d;return}b=Hw(17128,Ew(+h[(c[g>>2]|0)+600>>3],8352)|0)|0;g=c[20440]|0;j=e;k=17200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[17120]=1;i=d;return}function lp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17224]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+584>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(17232,Ew(+h[(c[g>>2]|0)+584>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[17224]=1;i=d;return}function mp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17320]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+560>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=Hw(17328,Ew(+h[(c[g>>2]|0)+560>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[17320]=1;i=d;return}function np(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17440]&1){i=d;return}g=b+416|0;b=Wy(+h[(c[g>>2]|0)+552>>3],1.0e-60)|0;if(!(b<<24>>24==0|(Vy(+h[(c[g>>2]|0)+552>>3],100.0)|0)<<24>>24==0)){i=d;return}b=Hw(17448,Ew(+h[(c[g>>2]|0)+552>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21216;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[17440]=1;i=d;return}function op(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17592]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+544>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(17600,Ew(+h[(c[g>>2]|0)+544>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[17592]=1;i=d;return}function pp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17720]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+536>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(17728,Ew(+h[(c[g>>2]|0)+536>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[17720]=1;i=d;return}function qp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17848]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+528>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(17856,Ew(+h[(c[g>>2]|0)+528>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[17848]=1;i=d;return}function rp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17968]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+520>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(17976,Ew(+h[(c[g>>2]|0)+520>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[17968]=1;i=d;return}function sp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18096]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+512>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(18104,Ew(+h[(c[g>>2]|0)+512>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[18096]=1;i=d;return}function tp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18224]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+504>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(18232,Ew(+h[(c[g>>2]|0)+504>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[18224]=1;i=d;return}function up(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18344]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+496>>3],1.0e-15)|0)<<24>>24==0)){i=d;return}b=Hw(18352,Ew(+h[(c[g>>2]|0)+496>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[18344]=1;i=d;return}function vp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18424]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+480>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(18432,Ew(+h[(c[g>>2]|0)+480>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[18424]=1;i=d;return}function wp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18520]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+456>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=Hw(18528,Ew(+h[(c[g>>2]|0)+456>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[18520]=1;i=d;return}function xp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18640]&1){i=d;return}g=b+416|0;b=Wy(+h[(c[g>>2]|0)+448>>3],1.0e-60)|0;if(!(b<<24>>24==0|(Vy(+h[(c[g>>2]|0)+448>>3],100.0)|0)<<24>>24==0)){i=d;return}b=Hw(18648,Ew(+h[(c[g>>2]|0)+448>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21216;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[18640]=1;i=d;return}function yp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18792]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+440>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(18800,Ew(+h[(c[g>>2]|0)+440>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[18792]=1;i=d;return}function zp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18920]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+432>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(18928,Ew(+h[(c[g>>2]|0)+432>>3],8352)|0)|0;g=c[20440]|0;j=e;k=21896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[18920]=1;i=d;return}function Ap(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19048]&1){i=d;return}g=b+416|0;if(!((Wy(+h[(c[g>>2]|0)+424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hw(19056,Ew(+h[(c[g>>2]|0)+424>>3],8352)|0)|0;g=c[20440]|0;j=e;k=22040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];xe[g&15](e,b,f);a[19048]=1;i=d;return}



function kh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);ze[c[f>>2]&3](0,4,1.0,1,d);ze[c[f>>2]&3](0,10,-1.0,2,d);g=b+4|0;if((a[c[(c[c[g>>2]>>2]|0)+16>>2]|0]|0)==0){j=1.0}else{j=+h[(c[b+416>>2]|0)+1248>>3]}ze[c[f>>2]&3](1,9,j,3,d);ze[c[f>>2]&3](1,10,1.0,4,d);ze[c[f>>2]&3](2,8,1.0,5,d);if((a[c[(c[c[g>>2]>>2]|0)+16>>2]|0]|0)==0){k=+h[(c[b+416>>2]|0)+1240>>3]}else{k=1.0}ze[c[f>>2]&3](2,9,-k,6,d);ze[c[f>>2]&3](3,7,1.0,7,d);ze[c[f>>2]&3](3,8,-1.0,8,d);if((a[c[(c[c[g>>2]>>2]|0)+16>>2]|0]|0)==0){l=1.0}else{l=+h[(c[b+416>>2]|0)+1264>>3]}ze[c[f>>2]&3](4,6,-l,9,d);ze[c[f>>2]&3](4,7,1.0,10,d);ze[c[f>>2]&3](5,5,1.0,11,d);if((a[c[(c[c[g>>2]>>2]|0)+16>>2]|0]|0)==0){m=+h[(c[b+416>>2]|0)+1272>>3]}else{m=1.0}ze[c[f>>2]&3](5,6,m,12,d);ze[c[f>>2]&3](6,2,-1.0,13,d);ze[c[f>>2]&3](6,4,-1.0,14,d);ze[c[f>>2]&3](6,5,-1.0,15,d);if((a[c[(c[c[g>>2]>>2]|0)+16>>2]|0]|0)==0){n=+h[(c[b+416>>2]|0)+1264>>3]}else{n=1.0}ze[c[f>>2]&3](7,3,-n,16,d);ze[c[f>>2]&3](7,7,1.0,17,d);ze[c[f>>2]&3](8,2,1.0,18,d);if((a[c[(c[c[g>>2]>>2]|0)+16>>2]|0]|0)==0){o=1.0}else{o=+h[(c[b+416>>2]|0)+1272>>3]}ze[c[f>>2]&3](8,3,o,19,d);if((a[c[(c[c[g>>2]>>2]|0)+16>>2]|0]|0)==0){p=1.0}else{p=+h[(c[b+416>>2]|0)+1240>>3]}ze[c[f>>2]&3](9,1,-p,20,d);ze[c[f>>2]&3](9,8,1.0,21,d);ze[c[f>>2]&3](10,0,1.0,22,d);q=c[f>>2]|0;if((a[c[(c[c[g>>2]>>2]|0)+16>>2]|0]|0)!=0){r=1.0;ze[q&3](10,1,r,23,d);i=e;return}r=+h[(c[b+416>>2]|0)+1248>>3];ze[q&3](10,1,r,23,d);i=e;return}function lh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;b=a+4|0;a=e;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;a=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[e+24>>3]=-+h[a>>3];b=a+96|0;a=e+32|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;h[e+56>>3]=+h[b>>3];b=e+64|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;i=d;return}function mh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);ze[c[f>>2]&3](0,4,1.0,1,d);ze[c[f>>2]&3](0,10,-1.0,2,d);g=b+4|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+1|0]|0)==0){j=1.0}else{j=+h[(c[b+416>>2]|0)+1144>>3]}ze[c[f>>2]&3](1,9,j,3,d);ze[c[f>>2]&3](1,10,1.0,4,d);ze[c[f>>2]&3](2,8,1.0,5,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+1|0]|0)==0){k=+h[(c[b+416>>2]|0)+1136>>3]}else{k=1.0}ze[c[f>>2]&3](2,9,-k,6,d);ze[c[f>>2]&3](3,7,1.0,7,d);ze[c[f>>2]&3](3,8,-1.0,8,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+1|0]|0)==0){l=1.0}else{l=+h[(c[b+416>>2]|0)+1160>>3]}ze[c[f>>2]&3](4,6,-l,9,d);ze[c[f>>2]&3](4,7,1.0,10,d);ze[c[f>>2]&3](5,5,1.0,11,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+1|0]|0)==0){m=+h[(c[b+416>>2]|0)+1168>>3]}else{m=1.0}ze[c[f>>2]&3](5,6,m,12,d);ze[c[f>>2]&3](6,2,-1.0,13,d);ze[c[f>>2]&3](6,4,-1.0,14,d);ze[c[f>>2]&3](6,5,-1.0,15,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+1|0]|0)==0){n=+h[(c[b+416>>2]|0)+1160>>3]}else{n=1.0}ze[c[f>>2]&3](7,3,-n,16,d);ze[c[f>>2]&3](7,7,1.0,17,d);ze[c[f>>2]&3](8,2,1.0,18,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+1|0]|0)==0){o=1.0}else{o=+h[(c[b+416>>2]|0)+1168>>3]}ze[c[f>>2]&3](8,3,o,19,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+1|0]|0)==0){p=1.0}else{p=+h[(c[b+416>>2]|0)+1136>>3]}ze[c[f>>2]&3](9,1,-p,20,d);ze[c[f>>2]&3](9,8,1.0,21,d);ze[c[f>>2]&3](10,0,1.0,22,d);q=c[f>>2]|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+1|0]|0)!=0){r=1.0;ze[q&3](10,1,r,23,d);i=e;return}r=+h[(c[b+416>>2]|0)+1144>>3];ze[q&3](10,1,r,23,d);i=e;return}function nh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;b=a+4|0;a=e;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;a=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[e+16>>3]=-+h[a+88>>3];h[e+24>>3]=-+h[a+8>>3];a=e+32|0;e=a+56|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(e|0));i=d;return}function oh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);ze[c[f>>2]&3](0,4,1.0,1,d);ze[c[f>>2]&3](0,10,-1.0,2,d);g=b+4|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+2|0]|0)==0){j=+h[(c[b+416>>2]|0)+1040>>3]}else{j=1.0}ze[c[f>>2]&3](1,9,j,3,d);ze[c[f>>2]&3](1,10,1.0,4,d);ze[c[f>>2]&3](2,8,1.0,5,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+2|0]|0)==0){k=1.0}else{k=+h[(c[b+416>>2]|0)+1032>>3]}ze[c[f>>2]&3](2,9,-k,6,d);ze[c[f>>2]&3](3,7,1.0,7,d);ze[c[f>>2]&3](3,8,-1.0,8,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+2|0]|0)==0){l=1.0}else{l=+h[(c[b+416>>2]|0)+1056>>3]}ze[c[f>>2]&3](4,6,-l,9,d);ze[c[f>>2]&3](4,7,1.0,10,d);ze[c[f>>2]&3](5,5,1.0,11,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+2|0]|0)==0){m=+h[(c[b+416>>2]|0)+1064>>3]}else{m=1.0}ze[c[f>>2]&3](5,6,m,12,d);ze[c[f>>2]&3](6,2,-1.0,13,d);ze[c[f>>2]&3](6,4,-1.0,14,d);ze[c[f>>2]&3](6,5,-1.0,15,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+2|0]|0)==0){n=+h[(c[b+416>>2]|0)+1056>>3]}else{n=1.0}ze[c[f>>2]&3](7,3,-n,16,d);ze[c[f>>2]&3](7,7,1.0,17,d);ze[c[f>>2]&3](8,2,1.0,18,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+2|0]|0)==0){o=1.0}else{o=+h[(c[b+416>>2]|0)+1064>>3]}ze[c[f>>2]&3](8,3,o,19,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+2|0]|0)==0){p=+h[(c[b+416>>2]|0)+1032>>3]}else{p=1.0}ze[c[f>>2]&3](9,1,-p,20,d);ze[c[f>>2]&3](9,8,1.0,21,d);ze[c[f>>2]&3](10,0,1.0,22,d);q=c[f>>2]|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+2|0]|0)==0){r=1.0;ze[q&3](10,1,r,23,d);i=e;return}r=+h[(c[b+416>>2]|0)+1040>>3];ze[q&3](10,1,r,23,d);i=e;return}function ph(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[b+36>>2]|0;b=a+4|0;a=e;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;a=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[e+24>>3]=-+h[a+16>>3];b=a+104|0;a=e+32|0;f=a+40|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(f|0));h[e+72>>3]=-+h[b>>3];h[e+80>>3]=0.0;i=d;return}function qh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,2,-1.0,0,d);ze[c[f>>2]&3](0,4,-1.0,1,d);ze[c[f>>2]&3](0,10,1.0,2,d);ze[c[f>>2]&3](1,0,-1.0,3,d);ze[c[f>>2]&3](1,9,-1.0,4,d);ze[c[f>>2]&3](1,10,-1.0,5,d);g=b+4|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+3|0]|0)==0){j=1.0}else{j=+h[(c[b+416>>2]|0)+960>>3]}ze[c[f>>2]&3](2,8,j,6,d);ze[c[f>>2]&3](2,9,1.0,7,d);ze[c[f>>2]&3](3,7,1.0,8,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+3|0]|0)==0){k=+h[(c[b+416>>2]|0)+952>>3]}else{k=1.0}ze[c[f>>2]&3](3,8,-k,9,d);ze[c[f>>2]&3](4,6,-1.0,10,d);ze[c[f>>2]&3](4,7,1.0,11,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+3|0]|0)==0){l=1.0}else{l=+h[(c[b+416>>2]|0)+928>>3]}ze[c[f>>2]&3](5,5,-l,12,d);ze[c[f>>2]&3](5,6,1.0,13,d);ze[c[f>>2]&3](6,4,1.0,14,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+3|0]|0)==0){m=+h[(c[b+416>>2]|0)+936>>3]}else{m=1.0}ze[c[f>>2]&3](6,5,m,15,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+3|0]|0)==0){n=+h[(c[b+416>>2]|0)+928>>3]}else{n=1.0}ze[c[f>>2]&3](7,3,-n,16,d);ze[c[f>>2]&3](7,6,1.0,17,d);ze[c[f>>2]&3](8,2,1.0,18,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+3|0]|0)==0){o=1.0}else{o=+h[(c[b+416>>2]|0)+936>>3]}ze[c[f>>2]&3](8,3,o,19,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+3|0]|0)==0){p=1.0}else{p=+h[(c[b+416>>2]|0)+952>>3]}ze[c[f>>2]&3](9,1,-p,20,d);ze[c[f>>2]&3](9,7,1.0,21,d);ze[c[f>>2]&3](10,0,1.0,22,d);q=c[f>>2]|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+3|0]|0)!=0){r=1.0;ze[q&3](10,1,r,23,d);i=e;return}r=+h[(c[b+416>>2]|0)+960>>3];ze[q&3](10,1,r,23,d);i=e;return}function rh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;b=a+4|0;a=e;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=0;a=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[e+32>>3]=-+h[a+24>>3];b=a+88|0;a=e+40|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;h[e+56>>3]=-+h[b>>3];b=e+64|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;i=d;return}function sh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);ze[c[f>>2]&3](0,4,1.0,1,d);ze[c[f>>2]&3](0,10,-1.0,2,d);g=b+4|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+4|0]|0)==0){j=1.0}else{j=+h[(c[b+416>>2]|0)+832>>3]}ze[c[f>>2]&3](1,9,j,3,d);ze[c[f>>2]&3](1,10,1.0,4,d);ze[c[f>>2]&3](2,8,1.0,5,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+4|0]|0)==0){k=+h[(c[b+416>>2]|0)+824>>3]}else{k=1.0}ze[c[f>>2]&3](2,9,-k,6,d);ze[c[f>>2]&3](3,7,1.0,7,d);ze[c[f>>2]&3](3,8,-1.0,8,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+4|0]|0)==0){l=1.0}else{l=+h[(c[b+416>>2]|0)+848>>3]}ze[c[f>>2]&3](4,6,-l,9,d);ze[c[f>>2]&3](4,7,1.0,10,d);ze[c[f>>2]&3](5,5,1.0,11,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+4|0]|0)==0){m=+h[(c[b+416>>2]|0)+856>>3]}else{m=1.0}ze[c[f>>2]&3](5,6,m,12,d);ze[c[f>>2]&3](6,2,-1.0,13,d);ze[c[f>>2]&3](6,4,-1.0,14,d);ze[c[f>>2]&3](6,5,-1.0,15,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+4|0]|0)==0){n=+h[(c[b+416>>2]|0)+848>>3]}else{n=1.0}ze[c[f>>2]&3](7,3,-n,16,d);ze[c[f>>2]&3](7,7,1.0,17,d);ze[c[f>>2]&3](8,2,1.0,18,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+4|0]|0)==0){o=1.0}else{o=+h[(c[b+416>>2]|0)+856>>3]}ze[c[f>>2]&3](8,3,o,19,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+4|0]|0)==0){p=1.0}else{p=+h[(c[b+416>>2]|0)+824>>3]}ze[c[f>>2]&3](9,1,-p,20,d);ze[c[f>>2]&3](9,8,1.0,21,d);ze[c[f>>2]&3](10,0,1.0,22,d);q=c[f>>2]|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+4|0]|0)!=0){r=1.0;ze[q&3](10,1,r,23,d);i=e;return}r=+h[(c[b+416>>2]|0)+832>>3];ze[q&3](10,1,r,23,d);i=e;return}function th(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;b=a+4|0;a=e;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;a=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[e+24>>3]=-+h[a+32>>3];b=a+120|0;a=e+32|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;h[e+56>>3]=-+h[b>>3];b=e+64|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;i=d;return}function uh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);ze[c[f>>2]&3](0,4,1.0,1,d);ze[c[f>>2]&3](0,10,-1.0,2,d);g=b+4|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+5|0]|0)==0){j=+h[(c[b+416>>2]|0)+728>>3]}else{j=1.0}ze[c[f>>2]&3](1,9,j,3,d);ze[c[f>>2]&3](1,10,1.0,4,d);ze[c[f>>2]&3](2,8,1.0,5,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+5|0]|0)==0){k=1.0}else{k=+h[(c[b+416>>2]|0)+720>>3]}ze[c[f>>2]&3](2,9,-k,6,d);ze[c[f>>2]&3](3,7,1.0,7,d);ze[c[f>>2]&3](3,8,-1.0,8,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+5|0]|0)==0){l=1.0}else{l=+h[(c[b+416>>2]|0)+744>>3]}ze[c[f>>2]&3](4,6,-l,9,d);ze[c[f>>2]&3](4,7,1.0,10,d);ze[c[f>>2]&3](5,5,1.0,11,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+5|0]|0)==0){m=+h[(c[b+416>>2]|0)+752>>3]}else{m=1.0}ze[c[f>>2]&3](5,6,m,12,d);ze[c[f>>2]&3](6,2,-1.0,13,d);ze[c[f>>2]&3](6,4,-1.0,14,d);ze[c[f>>2]&3](6,5,-1.0,15,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+5|0]|0)==0){n=+h[(c[b+416>>2]|0)+744>>3]}else{n=1.0}ze[c[f>>2]&3](7,3,-n,16,d);ze[c[f>>2]&3](7,7,1.0,17,d);ze[c[f>>2]&3](8,2,1.0,18,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+5|0]|0)==0){o=1.0}else{o=+h[(c[b+416>>2]|0)+752>>3]}ze[c[f>>2]&3](8,3,o,19,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+5|0]|0)==0){p=+h[(c[b+416>>2]|0)+720>>3]}else{p=1.0}ze[c[f>>2]&3](9,1,-p,20,d);ze[c[f>>2]&3](9,8,1.0,21,d);ze[c[f>>2]&3](10,0,1.0,22,d);q=c[f>>2]|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+5|0]|0)==0){r=1.0;ze[q&3](10,1,r,23,d);i=e;return}r=+h[(c[b+416>>2]|0)+728>>3];ze[q&3](10,1,r,23,d);i=e;return}function vh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[b+36>>2]|0;b=a+4|0;a=e;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;a=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[e+24>>3]=-+h[a+40>>3];b=a+104|0;a=e+32|0;f=a+40|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(f|0));h[e+72>>3]=-+h[b>>3];h[e+80>>3]=0.0;i=d;return}function wh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,2,-1.0,0,d);ze[c[f>>2]&3](0,4,-1.0,1,d);ze[c[f>>2]&3](0,10,1.0,2,d);ze[c[f>>2]&3](1,0,-1.0,3,d);ze[c[f>>2]&3](1,9,-1.0,4,d);ze[c[f>>2]&3](1,10,-1.0,5,d);g=b+4|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+7|0]|0)==0){j=1.0}else{j=+h[(c[b+416>>2]|0)+544>>3]}ze[c[f>>2]&3](2,8,j,6,d);ze[c[f>>2]&3](2,9,1.0,7,d);ze[c[f>>2]&3](3,7,1.0,8,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+7|0]|0)==0){k=+h[(c[b+416>>2]|0)+536>>3]}else{k=1.0}ze[c[f>>2]&3](3,8,-k,9,d);ze[c[f>>2]&3](4,6,-1.0,10,d);ze[c[f>>2]&3](4,7,1.0,11,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+7|0]|0)==0){l=1.0}else{l=+h[(c[b+416>>2]|0)+512>>3]}ze[c[f>>2]&3](5,5,-l,12,d);ze[c[f>>2]&3](5,6,1.0,13,d);ze[c[f>>2]&3](6,4,1.0,14,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+7|0]|0)==0){m=+h[(c[b+416>>2]|0)+520>>3]}else{m=1.0}ze[c[f>>2]&3](6,5,m,15,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+7|0]|0)==0){n=+h[(c[b+416>>2]|0)+512>>3]}else{n=1.0}ze[c[f>>2]&3](7,3,-n,16,d);ze[c[f>>2]&3](7,6,1.0,17,d);ze[c[f>>2]&3](8,2,1.0,18,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+7|0]|0)==0){o=1.0}else{o=+h[(c[b+416>>2]|0)+520>>3]}ze[c[f>>2]&3](8,3,o,19,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+7|0]|0)==0){p=1.0}else{p=+h[(c[b+416>>2]|0)+536>>3]}ze[c[f>>2]&3](9,1,-p,20,d);ze[c[f>>2]&3](9,7,1.0,21,d);ze[c[f>>2]&3](10,0,1.0,22,d);q=c[f>>2]|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+7|0]|0)!=0){r=1.0;ze[q&3](10,1,r,23,d);i=e;return}r=+h[(c[b+416>>2]|0)+544>>3];ze[q&3](10,1,r,23,d);i=e;return}function xh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;b=a+4|0;a=e;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=0;a=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[e+32>>3]=-+h[a+56>>3];h[e+40>>3]=+h[a+112>>3];a=e+48|0;e=a+40|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(e|0));i=d;return}function yh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);ze[c[f>>2]&3](0,4,1.0,1,d);ze[c[f>>2]&3](0,10,-1.0,2,d);g=b+4|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+8|0]|0)==0){j=+h[(c[b+416>>2]|0)+416>>3]}else{j=1.0}ze[c[f>>2]&3](1,9,j,3,d);ze[c[f>>2]&3](1,10,1.0,4,d);ze[c[f>>2]&3](2,8,1.0,5,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+8|0]|0)==0){k=1.0}else{k=+h[(c[b+416>>2]|0)+408>>3]}ze[c[f>>2]&3](2,9,-k,6,d);ze[c[f>>2]&3](3,7,1.0,7,d);ze[c[f>>2]&3](3,8,-1.0,8,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+8|0]|0)==0){l=1.0}else{l=+h[(c[b+416>>2]|0)+432>>3]}ze[c[f>>2]&3](4,6,-l,9,d);ze[c[f>>2]&3](4,7,1.0,10,d);ze[c[f>>2]&3](5,5,1.0,11,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+8|0]|0)==0){m=+h[(c[b+416>>2]|0)+440>>3]}else{m=1.0}ze[c[f>>2]&3](5,6,m,12,d);ze[c[f>>2]&3](6,2,-1.0,13,d);ze[c[f>>2]&3](6,4,-1.0,14,d);ze[c[f>>2]&3](6,5,-1.0,15,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+8|0]|0)==0){n=+h[(c[b+416>>2]|0)+432>>3]}else{n=1.0}ze[c[f>>2]&3](7,3,-n,16,d);ze[c[f>>2]&3](7,7,1.0,17,d);ze[c[f>>2]&3](8,2,1.0,18,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+8|0]|0)==0){o=1.0}else{o=+h[(c[b+416>>2]|0)+440>>3]}ze[c[f>>2]&3](8,3,o,19,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+8|0]|0)==0){p=+h[(c[b+416>>2]|0)+408>>3]}else{p=1.0}ze[c[f>>2]&3](9,1,-p,20,d);ze[c[f>>2]&3](9,8,1.0,21,d);ze[c[f>>2]&3](10,0,1.0,22,d);q=c[f>>2]|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+8|0]|0)==0){r=1.0;ze[q&3](10,1,r,23,d);i=e;return}r=+h[(c[b+416>>2]|0)+416>>3];ze[q&3](10,1,r,23,d);i=e;return}function zh(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;b=a+4|0;a=e;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;a=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[e+16>>3]=+h[a+96>>3];h[e+24>>3]=-+h[a+64>>3];a=e+32|0;e=a+56|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(e|0));i=d;return}function Ah(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);ze[c[f>>2]&3](0,4,1.0,1,d);ze[c[f>>2]&3](0,10,-1.0,2,d);g=b+4|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+9|0]|0)==0){j=1.0}else{j=+h[(c[b+416>>2]|0)+312>>3]}ze[c[f>>2]&3](1,9,j,3,d);ze[c[f>>2]&3](1,10,1.0,4,d);ze[c[f>>2]&3](2,8,1.0,5,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+9|0]|0)==0){k=+h[(c[b+416>>2]|0)+304>>3]}else{k=1.0}ze[c[f>>2]&3](2,9,-k,6,d);ze[c[f>>2]&3](3,7,1.0,7,d);ze[c[f>>2]&3](3,8,-1.0,8,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+9|0]|0)==0){l=1.0}else{l=+h[(c[b+416>>2]|0)+328>>3]}ze[c[f>>2]&3](4,6,-l,9,d);ze[c[f>>2]&3](4,7,1.0,10,d);ze[c[f>>2]&3](5,5,1.0,11,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+9|0]|0)==0){m=+h[(c[b+416>>2]|0)+336>>3]}else{m=1.0}ze[c[f>>2]&3](5,6,m,12,d);ze[c[f>>2]&3](6,2,-1.0,13,d);ze[c[f>>2]&3](6,4,-1.0,14,d);ze[c[f>>2]&3](6,5,-1.0,15,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+9|0]|0)==0){n=+h[(c[b+416>>2]|0)+328>>3]}else{n=1.0}ze[c[f>>2]&3](7,3,-n,16,d);ze[c[f>>2]&3](7,7,1.0,17,d);ze[c[f>>2]&3](8,2,1.0,18,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+9|0]|0)==0){o=1.0}else{o=+h[(c[b+416>>2]|0)+336>>3]}ze[c[f>>2]&3](8,3,o,19,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+9|0]|0)==0){p=1.0}else{p=+h[(c[b+416>>2]|0)+304>>3]}ze[c[f>>2]&3](9,1,-p,20,d);ze[c[f>>2]&3](9,8,1.0,21,d);ze[c[f>>2]&3](10,0,1.0,22,d);q=c[f>>2]|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+9|0]|0)!=0){r=1.0;ze[q&3](10,1,r,23,d);i=e;return}r=+h[(c[b+416>>2]|0)+312>>3];ze[q&3](10,1,r,23,d);i=e;return}function Bh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[b+36>>2]|0;b=a+4|0;a=e;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;a=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[e+24>>3]=-+h[a+72>>3];b=a+112|0;a=e+32|0;f=a+40|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(f|0));h[e+72>>3]=+h[b>>3];h[e+80>>3]=0.0;i=d;return}function Ch(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,0,-1.0,0,d);ze[c[f>>2]&3](0,4,1.0,1,d);ze[c[f>>2]&3](0,10,-1.0,2,d);g=b+4|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+10|0]|0)==0){j=1.0}else{j=+h[(c[b+416>>2]|0)+208>>3]}ze[c[f>>2]&3](1,9,j,3,d);ze[c[f>>2]&3](1,10,1.0,4,d);ze[c[f>>2]&3](2,8,1.0,5,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+10|0]|0)==0){k=+h[(c[b+416>>2]|0)+200>>3]}else{k=1.0}ze[c[f>>2]&3](2,9,-k,6,d);ze[c[f>>2]&3](3,7,1.0,7,d);ze[c[f>>2]&3](3,8,-1.0,8,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+10|0]|0)==0){l=1.0}else{l=+h[(c[b+416>>2]|0)+224>>3]}ze[c[f>>2]&3](4,6,-l,9,d);ze[c[f>>2]&3](4,7,1.0,10,d);ze[c[f>>2]&3](5,5,1.0,11,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+10|0]|0)==0){m=+h[(c[b+416>>2]|0)+232>>3]}else{m=1.0}ze[c[f>>2]&3](5,6,m,12,d);ze[c[f>>2]&3](6,2,-1.0,13,d);ze[c[f>>2]&3](6,4,-1.0,14,d);ze[c[f>>2]&3](6,5,-1.0,15,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+10|0]|0)==0){n=+h[(c[b+416>>2]|0)+224>>3]}else{n=1.0}ze[c[f>>2]&3](7,3,-n,16,d);ze[c[f>>2]&3](7,7,1.0,17,d);ze[c[f>>2]&3](8,2,1.0,18,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+10|0]|0)==0){o=1.0}else{o=+h[(c[b+416>>2]|0)+232>>3]}ze[c[f>>2]&3](8,3,o,19,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+10|0]|0)==0){p=1.0}else{p=+h[(c[b+416>>2]|0)+200>>3]}ze[c[f>>2]&3](9,1,-p,20,d);ze[c[f>>2]&3](9,8,1.0,21,d);ze[c[f>>2]&3](10,0,1.0,22,d);q=c[f>>2]|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+10|0]|0)!=0){r=1.0;ze[q&3](10,1,r,23,d);i=e;return}r=+h[(c[b+416>>2]|0)+208>>3];ze[q&3](10,1,r,23,d);i=e;return}function Dh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[b+36>>2]|0;b=a+4|0;a=e;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;a=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[e+24>>3]=-+h[a+80>>3];b=a+120|0;a=e+32|0;f=a+40|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(f|0));h[e+72>>3]=-+h[b>>3];h[e+80>>3]=0.0;i=d;return}function Eh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0;e=i;f=d+8|0;ze[c[f>>2]&3](0,4,1.0,0,d);g=b+4|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+6|0]|0)==0){j=+h[(c[b+416>>2]|0)+616>>3]}else{j=1.0}ze[c[f>>2]&3](0,10,-j,1,d);ze[c[f>>2]&3](1,9,1.0,2,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+6|0]|0)==0){k=1.0}else{k=+h[(c[b+416>>2]|0)+624>>3]}ze[c[f>>2]&3](1,10,k,3,d);ze[c[f>>2]&3](2,2,-1.0,4,d);ze[c[f>>2]&3](2,8,1.0,5,d);ze[c[f>>2]&3](2,9,-1.0,6,d);ze[c[f>>2]&3](3,0,-1.0,7,d);ze[c[f>>2]&3](3,7,-1.0,8,d);ze[c[f>>2]&3](3,8,-1.0,9,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+6|0]|0)==0){l=1.0}else{l=+h[(c[b+416>>2]|0)+648>>3]}ze[c[f>>2]&3](4,6,l,10,d);ze[c[f>>2]&3](4,7,1.0,11,d);ze[c[f>>2]&3](5,5,1.0,12,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+6|0]|0)==0){m=+h[(c[b+416>>2]|0)+640>>3]}else{m=1.0}ze[c[f>>2]&3](5,6,-m,13,d);ze[c[f>>2]&3](6,4,-1.0,14,d);ze[c[f>>2]&3](6,5,1.0,15,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+6|0]|0)==0){n=1.0}else{n=+h[(c[b+416>>2]|0)+616>>3]}ze[c[f>>2]&3](7,3,-n,16,d);ze[c[f>>2]&3](7,4,1.0,17,d);ze[c[f>>2]&3](8,2,1.0,18,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+6|0]|0)==0){o=+h[(c[b+416>>2]|0)+624>>3]}else{o=1.0}ze[c[f>>2]&3](8,3,o,19,d);if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+6|0]|0)==0){p=1.0}else{p=+h[(c[b+416>>2]|0)+640>>3]}ze[c[f>>2]&3](9,1,-p,20,d);ze[c[f>>2]&3](9,5,1.0,21,d);ze[c[f>>2]&3](10,0,1.0,22,d);q=c[f>>2]|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+6|0]|0)!=0){r=1.0;ze[q&3](10,1,r,23,d);i=e;return}r=+h[(c[b+416>>2]|0)+648>>3];ze[q&3](10,1,r,23,d);i=e;return}function Fh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=-+h[e+1488>>3];b=e+48|0;e=a+8|0;f=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));h[a+48>>3]=-+h[b>>3];b=a+56|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[b+28>>2]=0;i=d;return}function Gh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;ze[c[e>>2]&3](0,1,1.0,0,b);ze[c[e>>2]&3](0,9,-1.0,1,b);f=a+416|0;ze[c[e>>2]&3](1,8,-+h[(c[f>>2]|0)+64>>3],2,b);ze[c[e>>2]&3](1,9,1.0,3,b);ze[c[e>>2]&3](2,7,1.0,4,b);ze[c[e>>2]&3](2,8,-+h[(c[f>>2]|0)+112>>3],5,b);ze[c[e>>2]&3](3,6,1.0,6,b);ze[c[e>>2]&3](3,7,-1.0,7,b);ze[c[e>>2]&3](4,5,+h[(c[f>>2]|0)+120>>3],8,b);ze[c[e>>2]&3](4,6,1.0,9,b);ze[c[e>>2]&3](5,4,1.0,10,b);ze[c[e>>2]&3](5,5,-+h[(c[f>>2]|0)+80>>3],11,b);ze[c[e>>2]&3](6,0,1.0,12,b);ze[c[e>>2]&3](6,3,-1.0,13,b);ze[c[e>>2]&3](6,4,-1.0,14,b);ze[c[e>>2]&3](7,2,+h[(c[f>>2]|0)+88>>3],15,b);ze[c[e>>2]&3](7,3,1.0,16,b);ze[c[e>>2]&3](8,1,1.0,17,b);ze[c[e>>2]&3](8,2,-+h[(c[f>>2]|0)+56>>3],18,b);ze[c[e>>2]&3](9,0,1.0,19,b);ze[c[e>>2]&3](9,8,+h[(c[f>>2]|0)+96>>3],20,b);i=d;return}function Hh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=-+h[e+744>>3]- +h[e+960>>3]- +h[e+848>>3];b=e+400|0;f=a+8|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;h[a+24>>3]=-+h[b>>3]- +h[e+296>>3];b=e+624|0;f=a+32|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;h[a+48>>3]=-+h[b>>3]- +h[e+512>>3];e=a+56|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;i=d;return}function Ih(a){a=a|0;c[a+20>>2]=67;c[a+16>>2]=11;c[a+12>>2]=24;c[a>>2]=43;c[a+4>>2]=44;c[a+84>>2]=74;c[a+80>>2]=11;c[a+76>>2]=24;c[a+64>>2]=45;c[a+68>>2]=46;c[a+148>>2]=81;c[a+144>>2]=11;c[a+140>>2]=24;c[a+128>>2]=47;c[a+132>>2]=48;c[a+212>>2]=88;c[a+208>>2]=11;c[a+204>>2]=24;c[a+192>>2]=49;c[a+196>>2]=50;c[a+276>>2]=95;c[a+272>>2]=11;c[a+268>>2]=24;c[a+256>>2]=51;c[a+260>>2]=52;c[a+340>>2]=102;c[a+336>>2]=11;c[a+332>>2]=24;c[a+320>>2]=53;c[a+324>>2]=54;c[a+404>>2]=109;c[a+400>>2]=11;c[a+396>>2]=24;c[a+384>>2]=55;c[a+388>>2]=56;c[a+468>>2]=110;c[a+464>>2]=10;c[a+460>>2]=21;c[a+448>>2]=57;c[a+452>>2]=58;c[a+532>>2]=117;c[a+528>>2]=11;c[a+524>>2]=24;c[a+512>>2]=59;c[a+516>>2]=60;c[a+596>>2]=124;c[a+592>>2]=11;c[a+588>>2]=24;c[a+576>>2]=61;c[a+580>>2]=62;c[a+660>>2]=135;c[a+656>>2]=11;c[a+652>>2]=24;c[a+640>>2]=63;c[a+644>>2]=64;c[a+724>>2]=143;c[a+720>>2]=11;c[a+716>>2]=24;c[a+704>>2]=65;c[a+708>>2]=66;c[a+788>>2]=244;c[a+784>>2]=11;c[a+780>>2]=24;c[a+768>>2]=67;c[a+772>>2]=68;c[a+852>>2]=250;c[a+848>>2]=11;c[a+844>>2]=24;c[a+832>>2]=69;c[a+836>>2]=70;c[a+916>>2]=256;c[a+912>>2]=11;c[a+908>>2]=24;c[a+896>>2]=71;c[a+900>>2]=72;c[a+980>>2]=262;c[a+976>>2]=11;c[a+972>>2]=24;c[a+960>>2]=73;c[a+964>>2]=74;c[a+1044>>2]=268;c[a+1040>>2]=11;c[a+1036>>2]=24;c[a+1024>>2]=75;c[a+1028>>2]=76;c[a+1108>>2]=274;c[a+1104>>2]=11;c[a+1100>>2]=24;c[a+1088>>2]=77;c[a+1092>>2]=78;c[a+1172>>2]=282;c[a+1168>>2]=11;c[a+1164>>2]=24;c[a+1152>>2]=79;c[a+1156>>2]=80;c[a+1236>>2]=288;c[a+1232>>2]=11;c[a+1228>>2]=24;c[a+1216>>2]=81;c[a+1220>>2]=82;c[a+1300>>2]=297;c[a+1296>>2]=11;c[a+1292>>2]=24;c[a+1280>>2]=83;c[a+1284>>2]=84;c[a+1364>>2]=303;c[a+1360>>2]=11;c[a+1356>>2]=24;c[a+1344>>2]=85;c[a+1348>>2]=86;c[a+1428>>2]=311;c[a+1424>>2]=11;c[a+1420>>2]=24;c[a+1408>>2]=87;c[a+1412>>2]=88;c[a+1492>>2]=312;c[a+1488>>2]=10;c[a+1484>>2]=21;c[a+1472>>2]=89;c[a+1476>>2]=90;i=i;return}function Jh(a,b){a=a|0;b=b|0;i=i;return}function Kh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=a+108|0;q=c[p>>2]|0;c[q>>2]=1;r=a+416|0;s=c[r>>2]|0;h[q+8>>3]=+h[s+256>>3];t=+h[s+248>>3];h[q+16>>3]=t;q=a+536|0;jw(c[q>>2]|0,t>0.0|0,1936,o);o=c[p>>2]|0;c[o+24>>2]=2;a=c[r>>2]|0;h[o+32>>3]=+h[a+360>>3];t=+h[a+352>>3];h[o+40>>3]=t;jw(c[q>>2]|0,t>0.0|0,1936,n);n=c[p>>2]|0;c[n+48>>2]=3;o=c[r>>2]|0;h[n+56>>3]=+h[o+464>>3];t=+h[o+456>>3];h[n+64>>3]=t;jw(c[q>>2]|0,t>0.0|0,1936,m);m=c[p>>2]|0;c[m+72>>2]=4;n=c[r>>2]|0;h[m+80>>3]=+h[n+568>>3];t=+h[n+560>>3];h[m+88>>3]=t;jw(c[q>>2]|0,t>0.0|0,1936,l);l=c[p>>2]|0;c[l+96>>2]=5;m=c[r>>2]|0;h[l+104>>3]=+h[m+672>>3];t=+h[m+664>>3];h[l+112>>3]=t;jw(c[q>>2]|0,t>0.0|0,1936,k);k=c[p>>2]|0;c[k+120>>2]=6;l=c[r>>2]|0;h[k+128>>3]=+h[l+776>>3];t=+h[l+768>>3];h[k+136>>3]=t;jw(c[q>>2]|0,t>0.0|0,1936,j);j=c[p>>2]|0;c[j+144>>2]=7;k=c[r>>2]|0;h[j+152>>3]=+h[k+880>>3];t=+h[k+872>>3];h[j+160>>3]=t;jw(c[q>>2]|0,t>0.0|0,1936,g);g=c[p>>2]|0;c[g+168>>2]=8;j=c[r>>2]|0;h[g+176>>3]=+h[j+984>>3];t=+h[j+976>>3];h[g+184>>3]=t;jw(c[q>>2]|0,t>0.0|0,1936,f);f=c[p>>2]|0;c[f+192>>2]=9;g=c[r>>2]|0;h[f+200>>3]=+h[g+1088>>3];t=+h[g+1080>>3];h[f+208>>3]=t;jw(c[q>>2]|0,t>0.0|0,1936,e);e=c[p>>2]|0;c[e+216>>2]=10;f=c[r>>2]|0;h[e+224>>3]=+h[f+1192>>3];t=+h[f+1184>>3];h[e+232>>3]=t;jw(c[q>>2]|0,t>0.0|0,1936,d);d=c[p>>2]|0;c[d+240>>2]=11;p=c[r>>2]|0;h[d+248>>3]=+h[p+1296>>3];t=+h[p+1288>>3];h[d+256>>3]=t;jw(c[q>>2]|0,t>0.0|0,1936,b);i=b;return}function Lh(a,b){a=a|0;b=b|0;c[b>>2]=c[3280+(a<<2)>>2];i=i;return c[1960+(a<<2)>>2]|0}function Mh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;e=i;f=b+4|0;g=b+416|0;j=b+360|0;b=(Sy(+h[c[c[f>>2]>>2]>>3],+h[(c[g>>2]|0)+160>>3],a[c[j>>2]|0]|0)|0)<<24>>24!=0;h[d>>3]=b?1.0:-1.0;b=c[c[f>>2]>>2]|0;k=Ty(+h[b>>3],+h[(c[b+8>>2]|0)+1392>>3],a[(c[j>>2]|0)+1|0]|0)|0;b=c[c[f>>2]>>2]|0;l=Sy(+h[b>>3],+h[(c[b+8>>2]|0)+1392>>3]+ +h[(c[g>>2]|0)+264>>3],a[(c[j>>2]|0)+2|0]|0)|0;if(k<<24>>24==0){m=-1.0}else{m=l<<24>>24!=0?1.0:-1.0}h[d+8>>3]=m;l=c[c[f>>2]>>2]|0;k=Ty(+h[l>>3],+h[(c[l+8>>2]|0)+1280>>3],a[(c[j>>2]|0)+3|0]|0)|0;l=c[c[f>>2]>>2]|0;b=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+1280>>3]+ +h[(c[g>>2]|0)+368>>3],a[(c[j>>2]|0)+4|0]|0)|0;if(k<<24>>24==0){n=-1.0}else{n=b<<24>>24!=0?1.0:-1.0}h[d+16>>3]=n;b=c[c[f>>2]>>2]|0;k=Ty(+h[b>>3],+h[(c[b+8>>2]|0)+1168>>3],a[(c[j>>2]|0)+5|0]|0)|0;b=c[c[f>>2]>>2]|0;l=Sy(+h[b>>3],+h[(c[b+8>>2]|0)+1168>>3]+ +h[(c[g>>2]|0)+472>>3],a[(c[j>>2]|0)+6|0]|0)|0;if(k<<24>>24==0){o=-1.0}else{o=l<<24>>24!=0?1.0:-1.0}h[d+24>>3]=o;l=c[c[f>>2]>>2]|0;k=Ty(+h[l>>3],+h[(c[l+8>>2]|0)+1056>>3],a[(c[j>>2]|0)+7|0]|0)|0;l=c[c[f>>2]>>2]|0;b=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+1056>>3]+ +h[(c[g>>2]|0)+576>>3],a[(c[j>>2]|0)+8|0]|0)|0;if(k<<24>>24==0){p=-1.0}else{p=b<<24>>24!=0?1.0:-1.0}h[d+32>>3]=p;b=c[c[f>>2]>>2]|0;k=Ty(+h[b>>3],+h[(c[b+8>>2]|0)+952>>3],a[(c[j>>2]|0)+9|0]|0)|0;b=c[c[f>>2]>>2]|0;l=Sy(+h[b>>3],+h[(c[b+8>>2]|0)+952>>3]+ +h[(c[g>>2]|0)+680>>3],a[(c[j>>2]|0)+10|0]|0)|0;if(k<<24>>24==0){q=-1.0}else{q=l<<24>>24!=0?1.0:-1.0}h[d+40>>3]=q;l=c[c[f>>2]>>2]|0;k=Ty(+h[l>>3],+h[(c[l+8>>2]|0)+840>>3],a[(c[j>>2]|0)+11|0]|0)|0;l=c[c[f>>2]>>2]|0;b=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+840>>3]+ +h[(c[g>>2]|0)+784>>3],a[(c[j>>2]|0)+12|0]|0)|0;if(k<<24>>24==0){r=-1.0}else{r=b<<24>>24!=0?1.0:-1.0}h[d+48>>3]=r;b=c[c[f>>2]>>2]|0;k=Ty(+h[b>>3],+h[(c[b+8>>2]|0)+728>>3],a[(c[j>>2]|0)+13|0]|0)|0;b=c[c[f>>2]>>2]|0;l=Sy(+h[b>>3],+h[(c[b+8>>2]|0)+728>>3]+ +h[(c[g>>2]|0)+888>>3],a[(c[j>>2]|0)+14|0]|0)|0;if(k<<24>>24==0){s=-1.0}else{s=l<<24>>24!=0?1.0:-1.0}h[d+56>>3]=s;l=c[c[f>>2]>>2]|0;k=Ty(+h[l>>3],+h[(c[l+8>>2]|0)+616>>3],a[(c[j>>2]|0)+15|0]|0)|0;l=c[c[f>>2]>>2]|0;b=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+616>>3]+ +h[(c[g>>2]|0)+992>>3],a[(c[j>>2]|0)+16|0]|0)|0;if(k<<24>>24==0){t=-1.0}else{t=b<<24>>24!=0?1.0:-1.0}h[d+64>>3]=t;b=c[c[f>>2]>>2]|0;k=Ty(+h[b>>3],+h[(c[b+8>>2]|0)+504>>3],a[(c[j>>2]|0)+17|0]|0)|0;b=c[c[f>>2]>>2]|0;l=Sy(+h[b>>3],+h[(c[b+8>>2]|0)+504>>3]+ +h[(c[g>>2]|0)+1096>>3],a[(c[j>>2]|0)+18|0]|0)|0;if(k<<24>>24==0){u=-1.0}else{u=l<<24>>24!=0?1.0:-1.0}h[d+72>>3]=u;l=c[c[f>>2]>>2]|0;k=Ty(+h[l>>3],+h[(c[l+8>>2]|0)+392>>3],a[(c[j>>2]|0)+19|0]|0)|0;l=c[c[f>>2]>>2]|0;b=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+392>>3]+ +h[(c[g>>2]|0)+1200>>3],a[(c[j>>2]|0)+20|0]|0)|0;if(k<<24>>24==0){v=-1.0}else{v=b<<24>>24!=0?1.0:-1.0}h[d+80>>3]=v;b=c[c[f>>2]>>2]|0;k=Ty(+h[b>>3],+h[(c[b+8>>2]|0)+280>>3],a[(c[j>>2]|0)+21|0]|0)|0;b=c[c[f>>2]>>2]|0;f=Sy(+h[b>>3],+h[(c[b+8>>2]|0)+280>>3]+ +h[(c[g>>2]|0)+1304>>3],a[(c[j>>2]|0)+22|0]|0)|0;if(k<<24>>24==0){w=-1.0;x=d;y=x+88|0;z=y;h[z>>3]=w;i=e;return 0}w=f<<24>>24!=0?1.0:-1.0;x=d;y=x+88|0;z=y;h[z>>3]=w;i=e;return 0}function Nh(a){a=a|0;i=i;return c[4472+(a<<2)>>2]|0}function Oh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0,k=0.0,l=0,m=0;e=i;f=b+4|0;g=+h[c[c[f>>2]>>2]>>3];j=b+416|0;k=+h[(c[j>>2]|0)+160>>3];if((d|0)==0){d=b+352|0;a[c[d>>2]|0]=g<k|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+1|0]=+h[l>>3]>=+h[(c[l+8>>2]|0)+1392>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+2|0]=+h[l>>3]<+h[(c[l+8>>2]|0)+1392>>3]+ +h[(c[j>>2]|0)+264>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+3|0]=+h[l>>3]>=+h[(c[l+8>>2]|0)+1280>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+4|0]=+h[l>>3]<+h[(c[l+8>>2]|0)+1280>>3]+ +h[(c[j>>2]|0)+368>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+5|0]=+h[l>>3]>=+h[(c[l+8>>2]|0)+1168>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+6|0]=+h[l>>3]<+h[(c[l+8>>2]|0)+1168>>3]+ +h[(c[j>>2]|0)+472>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+7|0]=+h[l>>3]>=+h[(c[l+8>>2]|0)+1056>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+8|0]=+h[l>>3]<+h[(c[l+8>>2]|0)+1056>>3]+ +h[(c[j>>2]|0)+576>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+9|0]=+h[l>>3]>=+h[(c[l+8>>2]|0)+952>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+10|0]=+h[l>>3]<+h[(c[l+8>>2]|0)+952>>3]+ +h[(c[j>>2]|0)+680>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+11|0]=+h[l>>3]>=+h[(c[l+8>>2]|0)+840>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+12|0]=+h[l>>3]<+h[(c[l+8>>2]|0)+840>>3]+ +h[(c[j>>2]|0)+784>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+13|0]=+h[l>>3]>=+h[(c[l+8>>2]|0)+728>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+14|0]=+h[l>>3]<+h[(c[l+8>>2]|0)+728>>3]+ +h[(c[j>>2]|0)+888>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+15|0]=+h[l>>3]>=+h[(c[l+8>>2]|0)+616>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+16|0]=+h[l>>3]<+h[(c[l+8>>2]|0)+616>>3]+ +h[(c[j>>2]|0)+992>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+17|0]=+h[l>>3]>=+h[(c[l+8>>2]|0)+504>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+18|0]=+h[l>>3]<+h[(c[l+8>>2]|0)+504>>3]+ +h[(c[j>>2]|0)+1096>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+19|0]=+h[l>>3]>=+h[(c[l+8>>2]|0)+392>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+20|0]=+h[l>>3]<+h[(c[l+8>>2]|0)+392>>3]+ +h[(c[j>>2]|0)+1200>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+21|0]=+h[l>>3]>=+h[(c[l+8>>2]|0)+280>>3]|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+22|0]=+h[l>>3]<+h[(c[l+8>>2]|0)+280>>3]+ +h[(c[j>>2]|0)+1304>>3]|0;i=e;return 0}else{l=b+360|0;d=Sy(g,k,a[c[l>>2]|0]|0)|0;m=b+352|0;a[c[m>>2]|0]=d;d=c[c[f>>2]>>2]|0;b=Ty(+h[d>>3],+h[(c[d+8>>2]|0)+1392>>3],a[(c[l>>2]|0)+1|0]|0)|0;a[(c[m>>2]|0)+1|0]=b;b=c[c[f>>2]>>2]|0;d=Sy(+h[b>>3],+h[(c[b+8>>2]|0)+1392>>3]+ +h[(c[j>>2]|0)+264>>3],a[(c[l>>2]|0)+2|0]|0)|0;a[(c[m>>2]|0)+2|0]=d;d=c[c[f>>2]>>2]|0;b=Ty(+h[d>>3],+h[(c[d+8>>2]|0)+1280>>3],a[(c[l>>2]|0)+3|0]|0)|0;a[(c[m>>2]|0)+3|0]=b;b=c[c[f>>2]>>2]|0;d=Sy(+h[b>>3],+h[(c[b+8>>2]|0)+1280>>3]+ +h[(c[j>>2]|0)+368>>3],a[(c[l>>2]|0)+4|0]|0)|0;a[(c[m>>2]|0)+4|0]=d;d=c[c[f>>2]>>2]|0;b=Ty(+h[d>>3],+h[(c[d+8>>2]|0)+1168>>3],a[(c[l>>2]|0)+5|0]|0)|0;a[(c[m>>2]|0)+5|0]=b;b=c[c[f>>2]>>2]|0;d=Sy(+h[b>>3],+h[(c[b+8>>2]|0)+1168>>3]+ +h[(c[j>>2]|0)+472>>3],a[(c[l>>2]|0)+6|0]|0)|0;a[(c[m>>2]|0)+6|0]=d;d=c[c[f>>2]>>2]|0;b=Ty(+h[d>>3],+h[(c[d+8>>2]|0)+1056>>3],a[(c[l>>2]|0)+7|0]|0)|0;a[(c[m>>2]|0)+7|0]=b;b=c[c[f>>2]>>2]|0;d=Sy(+h[b>>3],+h[(c[b+8>>2]|0)+1056>>3]+ +h[(c[j>>2]|0)+576>>3],a[(c[l>>2]|0)+8|0]|0)|0;a[(c[m>>2]|0)+8|0]=d;d=c[c[f>>2]>>2]|0;b=Ty(+h[d>>3],+h[(c[d+8>>2]|0)+952>>3],a[(c[l>>2]|0)+9|0]|0)|0;a[(c[m>>2]|0)+9|0]=b;b=c[c[f>>2]>>2]|0;d=Sy(+h[b>>3],+h[(c[b+8>>2]|0)+952>>3]+ +h[(c[j>>2]|0)+680>>3],a[(c[l>>2]|0)+10|0]|0)|0;a[(c[m>>2]|0)+10|0]=d;d=c[c[f>>2]>>2]|0;b=Ty(+h[d>>3],+h[(c[d+8>>2]|0)+840>>3],a[(c[l>>2]|0)+11|0]|0)|0;a[(c[m>>2]|0)+11|0]=b;b=c[c[f>>2]>>2]|0;d=Sy(+h[b>>3],+h[(c[b+8>>2]|0)+840>>3]+ +h[(c[j>>2]|0)+784>>3],a[(c[l>>2]|0)+12|0]|0)|0;a[(c[m>>2]|0)+12|0]=d;d=c[c[f>>2]>>2]|0;b=Ty(+h[d>>3],+h[(c[d+8>>2]|0)+728>>3],a[(c[l>>2]|0)+13|0]|0)|0;a[(c[m>>2]|0)+13|0]=b;b=c[c[f>>2]>>2]|0;d=Sy(+h[b>>3],+h[(c[b+8>>2]|0)+728>>3]+ +h[(c[j>>2]|0)+888>>3],a[(c[l>>2]|0)+14|0]|0)|0;a[(c[m>>2]|0)+14|0]=d;d=c[c[f>>2]>>2]|0;b=Ty(+h[d>>3],+h[(c[d+8>>2]|0)+616>>3],a[(c[l>>2]|0)+15|0]|0)|0;a[(c[m>>2]|0)+15|0]=b;b=c[c[f>>2]>>2]|0;d=Sy(+h[b>>3],+h[(c[b+8>>2]|0)+616>>3]+ +h[(c[j>>2]|0)+992>>3],a[(c[l>>2]|0)+16|0]|0)|0;a[(c[m>>2]|0)+16|0]=d;d=c[c[f>>2]>>2]|0;b=Ty(+h[d>>3],+h[(c[d+8>>2]|0)+504>>3],a[(c[l>>2]|0)+17|0]|0)|0;a[(c[m>>2]|0)+17|0]=b;b=c[c[f>>2]>>2]|0;d=Sy(+h[b>>3],+h[(c[b+8>>2]|0)+504>>3]+ +h[(c[j>>2]|0)+1096>>3],a[(c[l>>2]|0)+18|0]|0)|0;a[(c[m>>2]|0)+18|0]=d;d=c[c[f>>2]>>2]|0;b=Ty(+h[d>>3],+h[(c[d+8>>2]|0)+392>>3],a[(c[l>>2]|0)+19|0]|0)|0;a[(c[m>>2]|0)+19|0]=b;b=c[c[f>>2]>>2]|0;d=Sy(+h[b>>3],+h[(c[b+8>>2]|0)+392>>3]+ +h[(c[j>>2]|0)+1200>>3],a[(c[l>>2]|0)+20|0]|0)|0;a[(c[m>>2]|0)+20|0]=d;d=c[c[f>>2]>>2]|0;b=Ty(+h[d>>3],+h[(c[d+8>>2]|0)+280>>3],a[(c[l>>2]|0)+21|0]|0)|0;a[(c[m>>2]|0)+21|0]=b;b=c[c[f>>2]>>2]|0;f=Sy(+h[b>>3],+h[(c[b+8>>2]|0)+280>>3]+ +h[(c[j>>2]|0)+1304>>3],a[(c[l>>2]|0)+22|0]|0)|0;a[(c[m>>2]|0)+22|0]=f;i=e;return 0}return 0}function Ph(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0.0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+16|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+8|0;x=i;i=i+16|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+16|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;gw(8,1,4568,O);O=b+4|0;P=c[c[O>>2]>>2]|0;Q=c[P+16>>2]|0;R=a[Q+21|0]|0;S=b+408|0;T=c[S>>2]|0;U=a[T+21|0]|0;if(R<<24>>24==U<<24>>24){V=T;W=Q;X=P;Y=0}else{c[N>>2]=U<<24>>24;c[N+4>>2]=R<<24>>24;gw(8,0,4600,N);N=c[c[O>>2]>>2]|0;V=c[S>>2]|0;W=c[N+16>>2]|0;X=N;Y=1}N=a[W+20|0]|0;R=a[V+20|0]|0;if(N<<24>>24==R<<24>>24){Z=V;_=W;$=X;aa=Y}else{c[M>>2]=R<<24>>24;c[M+4>>2]=N<<24>>24;gw(8,0,4656,M);M=c[c[O>>2]>>2]|0;Z=c[S>>2]|0;_=c[M+16>>2]|0;$=M;aa=1}M=a[_+19|0]|0;N=a[Z+19|0]|0;if(M<<24>>24==N<<24>>24){ba=Z;ca=_;da=$;ea=aa}else{c[L>>2]=N<<24>>24;c[L+4>>2]=M<<24>>24;gw(8,0,4712,L);L=c[c[O>>2]>>2]|0;ba=c[S>>2]|0;ca=c[L+16>>2]|0;da=L;ea=1}L=a[ca+18|0]|0;M=a[ba+18|0]|0;if(L<<24>>24==M<<24>>24){fa=ba;ga=ca;ha=da;ia=ea}else{c[K>>2]=M<<24>>24;c[K+4>>2]=L<<24>>24;gw(8,0,4768,K);K=c[c[O>>2]>>2]|0;fa=c[S>>2]|0;ga=c[K+16>>2]|0;ha=K;ia=1}K=a[ga+17|0]|0;L=a[fa+17|0]|0;if(K<<24>>24==L<<24>>24){ja=fa;ka=ga;la=ha;ma=ia}else{c[J>>2]=L<<24>>24;c[J+4>>2]=K<<24>>24;gw(8,0,4824,J);J=c[c[O>>2]>>2]|0;ja=c[S>>2]|0;ka=c[J+16>>2]|0;la=J;ma=1}J=a[ka+16|0]|0;K=a[ja+16|0]|0;if(J<<24>>24==K<<24>>24){na=ja;oa=ka;pa=la;qa=ma}else{c[I>>2]=K<<24>>24;c[I+4>>2]=J<<24>>24;gw(8,0,4880,I);I=c[c[O>>2]>>2]|0;na=c[S>>2]|0;oa=c[I+16>>2]|0;pa=I;qa=1}I=a[oa+15|0]|0;J=a[na+15|0]|0;if(I<<24>>24==J<<24>>24){ra=na;sa=oa;ta=pa;ua=qa}else{c[H>>2]=J<<24>>24;c[H+4>>2]=I<<24>>24;gw(8,0,4936,H);H=c[c[O>>2]>>2]|0;ra=c[S>>2]|0;sa=c[H+16>>2]|0;ta=H;ua=1}H=a[sa+14|0]|0;I=a[ra+14|0]|0;if(H<<24>>24==I<<24>>24){va=ra;wa=sa;xa=ta;ya=ua}else{c[G>>2]=I<<24>>24;c[G+4>>2]=H<<24>>24;gw(8,0,4992,G);G=c[c[O>>2]>>2]|0;va=c[S>>2]|0;wa=c[G+16>>2]|0;xa=G;ya=1}G=a[wa+13|0]|0;H=a[va+13|0]|0;if(G<<24>>24==H<<24>>24){za=va;Aa=wa;Ba=xa;Ca=ya}else{c[F>>2]=H<<24>>24;c[F+4>>2]=G<<24>>24;gw(8,0,5048,F);F=c[c[O>>2]>>2]|0;za=c[S>>2]|0;Aa=c[F+16>>2]|0;Ba=F;Ca=1}F=a[Aa+12|0]|0;G=a[za+12|0]|0;if(F<<24>>24==G<<24>>24){Da=za;Ea=Aa;Fa=Ba;Ga=Ca}else{c[E>>2]=G<<24>>24;c[E+4>>2]=F<<24>>24;gw(8,0,5104,E);E=c[c[O>>2]>>2]|0;Da=c[S>>2]|0;Ea=c[E+16>>2]|0;Fa=E;Ga=1}E=a[Ea+11|0]|0;F=a[Da+11|0]|0;if(E<<24>>24==F<<24>>24){Ha=Da;Ia=Ea;Ja=Fa;Ka=Ga}else{c[D>>2]=F<<24>>24;c[D+4>>2]=E<<24>>24;gw(8,0,5160,D);D=c[c[O>>2]>>2]|0;Ha=c[S>>2]|0;Ia=c[D+16>>2]|0;Ja=D;Ka=1}D=a[Ia+10|0]|0;Ia=a[Ha+10|0]|0;if(D<<24>>24==Ia<<24>>24){La=Ja;Ma=Ka}else{c[C>>2]=Ia<<24>>24;c[C+4>>2]=D<<24>>24;gw(8,0,5216,C);La=c[c[O>>2]>>2]|0;Ma=1}Na=+h[(c[La+8>>2]|0)+1392>>3];C=b+400|0;Oa=+h[(c[C>>2]|0)+1392>>3];if(Na!=Oa){b=B;h[k>>3]=Oa;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=B+8|0;h[k>>3]=Na;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];gw(8,0,5280,B);Pa=c[c[O>>2]>>2]|0;Qa=1}else{Pa=La;Qa=Ma}Ma=a[(c[Pa+16>>2]|0)+9|0]|0;La=a[(c[S>>2]|0)+9|0]|0;if(Ma<<24>>24==La<<24>>24){Ra=Pa;Sa=Qa}else{c[A>>2]=La<<24>>24;c[A+4>>2]=Ma<<24>>24;gw(8,0,5352,A);Ra=c[c[O>>2]>>2]|0;Sa=1}Na=+h[(c[Ra+8>>2]|0)+1280>>3];Oa=+h[(c[C>>2]|0)+1280>>3];if(Na!=Oa){A=z;h[k>>3]=Oa;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Na;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];gw(8,0,5416,z);Ta=c[c[O>>2]>>2]|0;Ua=1}else{Ta=Ra;Ua=Sa}Sa=a[(c[Ta+16>>2]|0)+8|0]|0;Ra=a[(c[S>>2]|0)+8|0]|0;if(Sa<<24>>24==Ra<<24>>24){Va=Ta;Wa=Ua}else{c[y>>2]=Ra<<24>>24;c[y+4>>2]=Sa<<24>>24;gw(8,0,5488,y);Va=c[c[O>>2]>>2]|0;Wa=1}Na=+h[(c[Va+8>>2]|0)+1168>>3];Oa=+h[(c[C>>2]|0)+1168>>3];if(Na!=Oa){y=x;h[k>>3]=Oa;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];y=x+8|0;h[k>>3]=Na;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];gw(8,0,5552,x);Xa=c[c[O>>2]>>2]|0;Ya=1}else{Xa=Va;Ya=Wa}Wa=a[(c[Xa+16>>2]|0)+7|0]|0;Va=a[(c[S>>2]|0)+7|0]|0;if(Wa<<24>>24==Va<<24>>24){Za=Xa;_a=Ya}else{c[w>>2]=Va<<24>>24;c[w+4>>2]=Wa<<24>>24;gw(8,0,5624,w);Za=c[c[O>>2]>>2]|0;_a=1}Na=+h[(c[Za+8>>2]|0)+1056>>3];Oa=+h[(c[C>>2]|0)+1056>>3];if(Na!=Oa){w=v;h[k>>3]=Oa;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=v+8|0;h[k>>3]=Na;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];gw(8,0,5688,v);$a=c[c[O>>2]>>2]|0;ab=1}else{$a=Za;ab=_a}_a=a[(c[$a+16>>2]|0)+6|0]|0;Za=a[(c[S>>2]|0)+6|0]|0;if(_a<<24>>24==Za<<24>>24){bb=$a;cb=ab}else{c[u>>2]=Za<<24>>24;c[u+4>>2]=_a<<24>>24;gw(8,0,5760,u);bb=c[c[O>>2]>>2]|0;cb=1}Na=+h[(c[bb+8>>2]|0)+952>>3];Oa=+h[(c[C>>2]|0)+952>>3];if(Na!=Oa){u=t;h[k>>3]=Oa;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];u=t+8|0;h[k>>3]=Na;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];gw(8,0,5824,t);db=c[c[O>>2]>>2]|0;eb=1}else{db=bb;eb=cb}cb=a[(c[db+16>>2]|0)+5|0]|0;bb=a[(c[S>>2]|0)+5|0]|0;if(cb<<24>>24==bb<<24>>24){fb=db;gb=eb}else{c[s>>2]=bb<<24>>24;c[s+4>>2]=cb<<24>>24;gw(8,0,5896,s);fb=c[c[O>>2]>>2]|0;gb=1}Na=+h[(c[fb+8>>2]|0)+840>>3];Oa=+h[(c[C>>2]|0)+840>>3];if(Na!=Oa){s=r;h[k>>3]=Oa;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=r+8|0;h[k>>3]=Na;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];gw(8,0,5960,r);hb=c[c[O>>2]>>2]|0;ib=1}else{hb=fb;ib=gb}gb=a[(c[hb+16>>2]|0)+4|0]|0;fb=a[(c[S>>2]|0)+4|0]|0;if(gb<<24>>24==fb<<24>>24){jb=hb;kb=ib}else{c[q>>2]=fb<<24>>24;c[q+4>>2]=gb<<24>>24;gw(8,0,6032,q);jb=c[c[O>>2]>>2]|0;kb=1}Na=+h[(c[jb+8>>2]|0)+728>>3];Oa=+h[(c[C>>2]|0)+728>>3];if(Na!=Oa){q=p;h[k>>3]=Oa;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];q=p+8|0;h[k>>3]=Na;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gw(8,0,6096,p);lb=c[c[O>>2]>>2]|0;mb=1}else{lb=jb;mb=kb}kb=a[(c[lb+16>>2]|0)+3|0]|0;jb=a[(c[S>>2]|0)+3|0]|0;if(kb<<24>>24==jb<<24>>24){nb=lb;ob=mb}else{c[o>>2]=jb<<24>>24;c[o+4>>2]=kb<<24>>24;gw(8,0,6168,o);nb=c[c[O>>2]>>2]|0;ob=1}Na=+h[(c[nb+8>>2]|0)+616>>3];Oa=+h[(c[C>>2]|0)+616>>3];if(Na!=Oa){o=n;h[k>>3]=Oa;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=Na;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];gw(8,0,6232,n);pb=c[c[O>>2]>>2]|0;qb=1}else{pb=nb;qb=ob}ob=a[(c[pb+16>>2]|0)+2|0]|0;nb=a[(c[S>>2]|0)+2|0]|0;if(ob<<24>>24==nb<<24>>24){rb=pb;sb=qb}else{c[m>>2]=nb<<24>>24;c[m+4>>2]=ob<<24>>24;gw(8,0,6304,m);rb=c[c[O>>2]>>2]|0;sb=1}Na=+h[(c[rb+8>>2]|0)+504>>3];Oa=+h[(c[C>>2]|0)+504>>3];if(Na!=Oa){m=l;h[k>>3]=Oa;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=l+8|0;h[k>>3]=Na;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];gw(8,0,6368,l);tb=c[c[O>>2]>>2]|0;ub=1}else{tb=rb;ub=sb}sb=a[(c[tb+16>>2]|0)+1|0]|0;rb=a[(c[S>>2]|0)+1|0]|0;if(sb<<24>>24==rb<<24>>24){vb=tb;wb=ub}else{c[j>>2]=rb<<24>>24;c[j+4>>2]=sb<<24>>24;gw(8,0,6440,j);vb=c[c[O>>2]>>2]|0;wb=1}Na=+h[(c[vb+8>>2]|0)+392>>3];Oa=+h[(c[C>>2]|0)+392>>3];if(Na!=Oa){j=g;h[k>>3]=Oa;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=g+8|0;h[k>>3]=Na;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];gw(8,0,6504,g);xb=c[c[O>>2]>>2]|0;yb=1}else{xb=vb;yb=wb}wb=a[c[xb+16>>2]|0]|0;vb=a[c[S>>2]|0]|0;if(wb<<24>>24==vb<<24>>24){zb=xb;Ab=yb}else{c[f>>2]=vb<<24>>24;c[f+4>>2]=wb<<24>>24;gw(8,0,6576,f);zb=c[c[O>>2]>>2]|0;Ab=1}Na=+h[(c[zb+8>>2]|0)+280>>3];Oa=+h[(c[C>>2]|0)+280>>3];if(Na!=Oa){C=e;h[k>>3]=Oa;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=e+8|0;h[k>>3]=Na;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];gw(8,0,6640,e);Bb=1}else{Bb=Ab}if((c[35616>>2]|0)==0){i=d;return Bb|0}be[c[9034]&255](8);i=d;return Bb|0}function Qh(a){a=a|0;i=i;return c[7352+(a<<2)>>2]|0}function Rh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+8|0;gw(21,1,7400,s);s=a+4|0;t=a+416|0;u=+h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+1392>>3]- +h[(c[t>>2]|0)+256>>3];h[b>>3]=u;a=Qh(0)|0;c[r>>2]=1;c[r+4>>2]=a;a=r+8|0;h[k>>3]=u;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];gw(21,0,7432,r);u=+h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+1280>>3]- +h[(c[t>>2]|0)+360>>3];h[b+8>>3]=u;r=Qh(1)|0;c[q>>2]=2;c[q+4>>2]=r;r=q+8|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];gw(21,0,7432,q);u=+h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+1168>>3]- +h[(c[t>>2]|0)+464>>3];h[b+16>>3]=u;q=Qh(2)|0;c[p>>2]=3;c[p+4>>2]=q;q=p+8|0;h[k>>3]=u;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gw(21,0,7432,p);u=+h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+1056>>3]- +h[(c[t>>2]|0)+568>>3];h[b+24>>3]=u;p=Qh(3)|0;c[o>>2]=4;c[o+4>>2]=p;p=o+8|0;h[k>>3]=u;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];gw(21,0,7432,o);u=+h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+952>>3]- +h[(c[t>>2]|0)+672>>3];h[b+32>>3]=u;o=Qh(4)|0;c[n>>2]=5;c[n+4>>2]=o;o=n+8|0;h[k>>3]=u;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];gw(21,0,7432,n);u=+h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+840>>3]- +h[(c[t>>2]|0)+776>>3];h[b+40>>3]=u;n=Qh(5)|0;c[m>>2]=6;c[m+4>>2]=n;n=m+8|0;h[k>>3]=u;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];gw(21,0,7432,m);u=+h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+728>>3]- +h[(c[t>>2]|0)+880>>3];h[b+48>>3]=u;m=Qh(6)|0;c[l>>2]=7;c[l+4>>2]=m;m=l+8|0;h[k>>3]=u;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];gw(21,0,7432,l);u=+h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+616>>3]- +h[(c[t>>2]|0)+984>>3];h[b+56>>3]=u;l=Qh(7)|0;c[j>>2]=8;c[j+4>>2]=l;l=j+8|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];gw(21,0,7432,j);u=+h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+504>>3]- +h[(c[t>>2]|0)+1088>>3];h[b+64>>3]=u;j=Qh(8)|0;c[g>>2]=9;c[g+4>>2]=j;j=g+8|0;h[k>>3]=u;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];gw(21,0,7432,g);u=+h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+392>>3]- +h[(c[t>>2]|0)+1192>>3];h[b+72>>3]=u;g=Qh(9)|0;c[f>>2]=10;c[f+4>>2]=g;g=f+8|0;h[k>>3]=u;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];gw(21,0,7432,f);u=+h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+280>>3]- +h[(c[t>>2]|0)+1296>>3];h[b+80>>3]=u;b=Qh(10)|0;c[e>>2]=11;c[e+4>>2]=b;b=e+8|0;h[k>>3]=u;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];gw(21,0,7432,e);if((c[35668>>2]|0)==0){i=d;return 0}be[c[9034]&255](21);i=d;return 0}function Sh(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1224>>3];j=+h[f+1216>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+mw(c[b+536>>2]|0,g,7456,7448,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1312>>3]=l;i=d;return}function Th(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1288>>3]=+h[b+1216>>3];i=i;return}function Uh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1304>>3]=+h[b+1288>>3]*+h[b+1280>>3]*.01;i=i;return}function Vh(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1120>>3];j=+h[f+1112>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+mw(c[b+536>>2]|0,g,7472,7464,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1208>>3]=l;i=d;return}function Wh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1184>>3]=+h[b+1112>>3];i=i;return}function Xh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1200>>3]=+h[b+1184>>3]*+h[b+1176>>3]*.01;i=i;return}function Yh(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1016>>3];j=+h[f+1008>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+mw(c[b+536>>2]|0,g,7488,7480,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1104>>3]=l;i=d;return}function Zh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1080>>3]=+h[b+1008>>3];i=i;return}function _h(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1096>>3]=+h[b+1080>>3]*+h[b+1072>>3]*.01;i=i;return}function $h(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+912>>3];j=+h[f+904>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+mw(c[b+536>>2]|0,g,7504,7496,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1e3>>3]=l;i=d;return}function ai(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+976>>3]=+h[b+904>>3];i=i;return}function bi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+992>>3]=+h[b+976>>3]*+h[b+968>>3]*.01;i=i;return}function ci(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+808>>3];j=+h[f+800>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+mw(c[b+536>>2]|0,g,7520,7512,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+896>>3]=l;i=d;return}function di(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+872>>3]=+h[b+800>>3];i=i;return}function ei(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+888>>3]=+h[b+872>>3]*+h[b+864>>3]*.01;i=i;return}function fi(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+704>>3];j=+h[f+696>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+mw(c[b+536>>2]|0,g,7536,7528,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+792>>3]=l;i=d;return}function gi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+768>>3]=+h[b+696>>3];i=i;return}function hi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+784>>3]=+h[b+768>>3]*+h[b+760>>3]*.01;i=i;return}function ii(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+600>>3];j=+h[f+592>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+mw(c[b+536>>2]|0,g,7552,7544,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+688>>3]=l;i=d;return}function ji(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+664>>3]=+h[b+592>>3];i=i;return}function ki(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+680>>3]=+h[b+664>>3]*+h[b+656>>3]*.01;i=i;return}function li(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+496>>3];j=+h[f+488>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+mw(c[b+536>>2]|0,g,7568,7560,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+584>>3]=l;i=d;return}function mi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+560>>3]=+h[b+488>>3];i=i;return}function ni(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+576>>3]=+h[b+560>>3]*+h[b+552>>3]*.01;i=i;return}function oi(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+392>>3];j=+h[f+384>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+mw(c[b+536>>2]|0,g,7584,7576,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+480>>3]=l;i=d;return}function pi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+456>>3]=+h[b+384>>3];i=i;return}function qi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+472>>3]=+h[b+456>>3]*+h[b+448>>3]*.01;i=i;return}function ri(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+288>>3];j=+h[f+280>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+mw(c[b+536>>2]|0,g,7600,7592,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+376>>3]=l;i=d;return}function si(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+352>>3]=+h[b+280>>3];i=i;return}function ti(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+368>>3]=+h[b+352>>3]*+h[b+344>>3]*.01;i=i;return}function ui(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+184>>3];j=+h[f+176>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+mw(c[b+536>>2]|0,g,7616,7608,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+272>>3]=l;i=d;return}function vi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+248>>3]=+h[b+176>>3];i=i;return}function wi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+264>>3]=+h[b+248>>3]*+h[b+240>>3]*.01;i=i;return}function xi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+168>>3]=+h[b+144>>3];i=i;return}function yi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+160>>3]=+h[b+136>>3];i=i;return}function zi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+152>>3]=+h[b+128>>3];i=i;return}function Ai(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+104>>3]=+h[b+8>>3];i=i;return}function Bi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+72>>3]=+h[b>>3];i=i;return}function Ci(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+8>>3]*1.392270203025;if(g!=0.0){j=g;k=f;l=1.0/j;m=k;n=m+40|0;o=n;h[o>>3]=l;i=d;return}p=+mw(c[b+536>>2]|0,g,7632,7624,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=p;k=c[e>>2]|0;l=1.0/j;m=k;n=m+40|0;o=n;h[o>>3]=l;i=d;return}function Di(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+80>>3]=+h[b+40>>3];i=i;return}function Ei(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+112>>3]=+h[b+40>>3];i=i;return}function Fi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+120>>3]=+h[b+40>>3]+ +h[b+48>>3];i=i;return}function Gi(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f>>3]*2.906997720064;if(g!=0.0){j=g;k=f;l=1.0/j;m=k;n=m+24|0;o=n;h[o>>3]=l;i=d;return}p=+mw(c[b+536>>2]|0,g,7664,7656,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=p;k=c[e>>2]|0;l=1.0/j;m=k;n=m+24|0;o=n;h[o>>3]=l;i=d;return}function Hi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+56>>3]=+h[b+16>>3]+ +h[b+24>>3];i=i;return}function Ii(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+64>>3]=+h[b+24>>3];i=i;return}function Ji(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+88>>3]=+h[b+24>>3];i=i;return}function Ki(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+96>>3]=+h[b+24>>3]+(+h[b+32>>3]+ +h[b+40>>3]);i=i;return}function Li(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;do{if((a[b+314|0]|0)==0){e=b+416|0;f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=b+416|0;l=Sy(+h[c[c[b+4>>2]>>2]>>3],+h[(c[k>>2]|0)+160>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=l;e=k;f=j;break}else{j=b+416|0;k=Sy(+h[c[c[b+4>>2]>>2]>>3],+h[(c[j>>2]|0)+160>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;e=j;f=k;break}}else{if(g){g=a[c[b+356>>2]|0]|0;k=b+416|0;j=Uy(+h[c[c[b+4>>2]>>2]>>3],+h[(c[k>>2]|0)+160>>3])|0;a[c[b+352>>2]|0]=j;e=k;f=g;break}else{g=b+416|0;k=Uy(+h[c[c[b+4>>2]>>2]>>3],+h[(c[g>>2]|0)+160>>3])|0;a[c[b+352>>2]|0]=k;e=g;f=k;break}}}}while(0);k=c[e>>2]|0;m=+h[k+152>>3];if(!(f<<24>>24==0)){n=0.0;o=m+n;p=b;q=p+4|0;r=q;s=c[r>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;x=c[w>>2]|0;y=x;z=y+1488|0;A=z;h[A>>3]=o;i=d;return}n=+h[k+168>>3];o=m+n;p=b;q=p+4|0;r=q;s=c[r>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;x=c[w>>2]|0;y=x;z=y+1488|0;A=z;h[A>>3]=o;i=d;return}function Mi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+120>>3]=0.0;i=i;return}function Ni(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+112>>3]=0.0;i=i;return}function Oi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+104>>3]=0.0;i=i;return}function Pi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+96>>3]=0.0;i=i;return}function Qi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+88>>3]=0.0;i=i;return}function Ri(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+80>>3]=0.0;i=i;return}function Si(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+72>>3]=0.0;i=i;return}function Ti(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+64>>3]=0.0;i=i;return}function Ui(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+56>>3]=0.0;i=i;return}function Vi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+48>>3]=0.0;i=i;return}function Wi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+40>>3]=0.0;i=i;return}function Xi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+32>>3]=0.0;i=i;return}function Yi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24>>3]=0.0;i=i;return}function Zi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16>>3]=0.0;i=i;return}function _i(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8>>3]=0.0;i=i;return}function $i(a){a=a|0;h[c[(c[c[a+4>>2]>>2]|0)+8>>2]>>3]=0.0;i=i;return}function aj(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+280>>3]=+h[(c[a+416>>2]|0)+1296>>3];i=i;return}function bj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+21|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+21|0]|0;k=c[c[b+4>>2]>>2]|0;l=Ty(+h[k>>3],+h[(c[k+8>>2]|0)+280>>3],a[(c[b+360>>2]|0)+21|0]|0)|0;a[(c[b+352>>2]|0)+21|0]=l;f=j;break}else{j=c[c[b+4>>2]>>2]|0;l=Ty(+h[j>>3],+h[(c[j+8>>2]|0)+280>>3],a[(c[b+360>>2]|0)+21|0]|0)|0;a[(c[b+352>>2]|0)+21|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+21|0]|0;l=c[c[b+4>>2]>>2]|0;j=Wy(+h[l>>3],+h[(c[l+8>>2]|0)+280>>3])|0;a[(c[b+352>>2]|0)+21|0]=j;f=g;break}else{g=c[c[b+4>>2]>>2]|0;j=Wy(+h[g>>3],+h[(c[g+8>>2]|0)+280>>3])|0;a[(c[b+352>>2]|0)+21|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+22|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+22|0]|0;l=c[c[b+4>>2]>>2]|0;k=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+280>>3]+ +h[(c[b+416>>2]|0)+1304>>3],a[(c[b+360>>2]|0)+22|0]|0)|0;a[(c[b+352>>2]|0)+22|0]=k;m=g;break}else{g=c[c[b+4>>2]>>2]|0;k=Sy(+h[g>>3],+h[(c[g+8>>2]|0)+280>>3]+ +h[(c[b+416>>2]|0)+1304>>3],a[(c[b+360>>2]|0)+22|0]|0)|0;a[(c[b+352>>2]|0)+22|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+22|0]|0;k=c[c[b+4>>2]>>2]|0;g=Uy(+h[k>>3],+h[(c[k+8>>2]|0)+280>>3]+ +h[(c[b+416>>2]|0)+1304>>3])|0;a[(c[b+352>>2]|0)+22|0]=g;m=j;break}else{j=c[c[b+4>>2]>>2]|0;g=Uy(+h[j>>3],+h[(c[j+8>>2]|0)+280>>3]+ +h[(c[b+416>>2]|0)+1304>>3])|0;a[(c[b+352>>2]|0)+22|0]=g;m=g;break}}}}while(0);if(f<<24>>24==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;a[w]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;a[w]=n;i=d;return}function cj(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,0)|0;d=c[(c[a+476>>2]|0)+28>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+320>>3]=+h[d>>3];h[e+304>>3]=+h[d+8>>3];h[e+272>>3]=+h[d+16>>3];h[e+288>>3]=+h[d+24>>3];h[e+312>>3]=+h[d+32>>3];h[e+256>>3]=+h[d+40>>3];h[e+264>>3]=+h[d+48>>3];h[e+336>>3]=+h[d+56>>3];h[e+352>>3]=+h[d+64>>3];h[e+296>>3]=+h[d+72>>3];h[e+344>>3]=+h[d+80>>3];i=b;return}function dj(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+1312>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+272>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+128|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+128|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,7696,7688,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+128|0;p=o;h[p>>3]=m;i=d;return}function ej(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+328>>3]=+h[b+272>>3]*+h[b+256>>3]+ +h[b+288>>3]*+h[b+96>>3];i=i;return}function fj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+360>>3]=-(+h[b+272>>3]*+h[b+264>>3]);i=i;return}function gj(a){a=a|0;h[(c[a+400>>2]|0)+280>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+280>>3];i=i;return}function hj(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+392>>3]=+h[(c[a+416>>2]|0)+1192>>3];i=i;return}function ij(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+19|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+19|0]|0;k=c[c[b+4>>2]>>2]|0;l=Ty(+h[k>>3],+h[(c[k+8>>2]|0)+392>>3],a[(c[b+360>>2]|0)+19|0]|0)|0;a[(c[b+352>>2]|0)+19|0]=l;f=j;break}else{j=c[c[b+4>>2]>>2]|0;l=Ty(+h[j>>3],+h[(c[j+8>>2]|0)+392>>3],a[(c[b+360>>2]|0)+19|0]|0)|0;a[(c[b+352>>2]|0)+19|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+19|0]|0;l=c[c[b+4>>2]>>2]|0;j=Wy(+h[l>>3],+h[(c[l+8>>2]|0)+392>>3])|0;a[(c[b+352>>2]|0)+19|0]=j;f=g;break}else{g=c[c[b+4>>2]>>2]|0;j=Wy(+h[g>>3],+h[(c[g+8>>2]|0)+392>>3])|0;a[(c[b+352>>2]|0)+19|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+20|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+20|0]|0;l=c[c[b+4>>2]>>2]|0;k=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+392>>3]+ +h[(c[b+416>>2]|0)+1200>>3],a[(c[b+360>>2]|0)+20|0]|0)|0;a[(c[b+352>>2]|0)+20|0]=k;m=g;break}else{g=c[c[b+4>>2]>>2]|0;k=Sy(+h[g>>3],+h[(c[g+8>>2]|0)+392>>3]+ +h[(c[b+416>>2]|0)+1200>>3],a[(c[b+360>>2]|0)+20|0]|0)|0;a[(c[b+352>>2]|0)+20|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+20|0]|0;k=c[c[b+4>>2]>>2]|0;g=Uy(+h[k>>3],+h[(c[k+8>>2]|0)+392>>3]+ +h[(c[b+416>>2]|0)+1200>>3])|0;a[(c[b+352>>2]|0)+20|0]=g;m=j;break}else{j=c[c[b+4>>2]>>2]|0;g=Uy(+h[j>>3],+h[(c[j+8>>2]|0)+392>>3]+ +h[(c[b+416>>2]|0)+1200>>3])|0;a[(c[b+352>>2]|0)+20|0]=g;m=g;break}}}}while(0);if(f<<24>>24==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+1|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+1|0;z=y;a[z]=n;i=d;return}function jj(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,1)|0;d=c[(c[a+476>>2]|0)+92>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+464>>3]=+h[d>>3];h[e+448>>3]=+h[d+8>>3];h[e+376>>3]=+h[d+16>>3];h[e+432>>3]=+h[d+24>>3];h[e+416>>3]=+h[d+32>>3];h[e+368>>3]=+h[d+40>>3];h[e+424>>3]=+h[d+48>>3];h[e+400>>3]=+h[d+56>>3];h[e+384>>3]=+h[d+64>>3];h[e+408>>3]=+h[d+72>>3];h[e+456>>3]=+h[d+80>>3];i=b;return}function kj(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+1208>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+384>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+136|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+136|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,7728,7720,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+136|0;p=o;h[p>>3]=m;i=d;return}function lj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+440>>3]=+h[b+384>>3]*+h[b+368>>3];i=i;return}function mj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+472>>3]=-(+h[b+408>>3]*+h[b+88>>3])- +h[b+384>>3]*+h[b+376>>3];i=i;return}function nj(a){a=a|0;h[(c[a+400>>2]|0)+392>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+392>>3];i=i;return}function oj(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+504>>3]=+h[(c[a+416>>2]|0)+1088>>3];i=i;return}function pj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+17|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+17|0]|0;k=c[c[b+4>>2]>>2]|0;l=Ty(+h[k>>3],+h[(c[k+8>>2]|0)+504>>3],a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=l;f=j;break}else{j=c[c[b+4>>2]>>2]|0;l=Ty(+h[j>>3],+h[(c[j+8>>2]|0)+504>>3],a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+17|0]|0;l=c[c[b+4>>2]>>2]|0;j=Wy(+h[l>>3],+h[(c[l+8>>2]|0)+504>>3])|0;a[(c[b+352>>2]|0)+17|0]=j;f=g;break}else{g=c[c[b+4>>2]>>2]|0;j=Wy(+h[g>>3],+h[(c[g+8>>2]|0)+504>>3])|0;a[(c[b+352>>2]|0)+17|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+18|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+18|0]|0;l=c[c[b+4>>2]>>2]|0;k=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+504>>3]+ +h[(c[b+416>>2]|0)+1096>>3],a[(c[b+360>>2]|0)+18|0]|0)|0;a[(c[b+352>>2]|0)+18|0]=k;m=g;break}else{g=c[c[b+4>>2]>>2]|0;k=Sy(+h[g>>3],+h[(c[g+8>>2]|0)+504>>3]+ +h[(c[b+416>>2]|0)+1096>>3],a[(c[b+360>>2]|0)+18|0]|0)|0;a[(c[b+352>>2]|0)+18|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+18|0]|0;k=c[c[b+4>>2]>>2]|0;g=Uy(+h[k>>3],+h[(c[k+8>>2]|0)+504>>3]+ +h[(c[b+416>>2]|0)+1096>>3])|0;a[(c[b+352>>2]|0)+18|0]=g;m=j;break}else{j=c[c[b+4>>2]>>2]|0;g=Uy(+h[j>>3],+h[(c[j+8>>2]|0)+504>>3]+ +h[(c[b+416>>2]|0)+1096>>3])|0;a[(c[b+352>>2]|0)+18|0]=g;m=g;break}}}}while(0);if(f<<24>>24==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+2|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+2|0;z=y;a[z]=n;i=d;return}function qj(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,2)|0;d=c[(c[a+476>>2]|0)+156>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+576>>3]=+h[d>>3];h[e+560>>3]=+h[d+8>>3];h[e+488>>3]=+h[d+16>>3];h[e+512>>3]=+h[d+24>>3];h[e+536>>3]=+h[d+32>>3];h[e+480>>3]=+h[d+40>>3];h[e+528>>3]=+h[d+48>>3];h[e+544>>3]=+h[d+56>>3];h[e+496>>3]=+h[d+64>>3];h[e+520>>3]=+h[d+72>>3];h[e+568>>3]=+h[d+80>>3];i=b;return}function rj(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+1104>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+496>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+144|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+144|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,7760,7752,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+144|0;p=o;h[p>>3]=m;i=d;return}function sj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+552>>3]=+h[b+496>>3]*+h[b+480>>3];i=i;return}function tj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+584>>3]=-(+h[b+520>>3]*+h[b+104>>3])- +h[b+496>>3]*+h[b+488>>3];i=i;return}function uj(a){a=a|0;h[(c[a+400>>2]|0)+504>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+504>>3];i=i;return}function vj(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+616>>3]=+h[(c[a+416>>2]|0)+984>>3];i=i;return}function wj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+15|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+15|0]|0;k=c[c[b+4>>2]>>2]|0;l=Ty(+h[k>>3],+h[(c[k+8>>2]|0)+616>>3],a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=l;f=j;break}else{j=c[c[b+4>>2]>>2]|0;l=Ty(+h[j>>3],+h[(c[j+8>>2]|0)+616>>3],a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+15|0]|0;l=c[c[b+4>>2]>>2]|0;j=Wy(+h[l>>3],+h[(c[l+8>>2]|0)+616>>3])|0;a[(c[b+352>>2]|0)+15|0]=j;f=g;break}else{g=c[c[b+4>>2]>>2]|0;j=Wy(+h[g>>3],+h[(c[g+8>>2]|0)+616>>3])|0;a[(c[b+352>>2]|0)+15|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+16|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+16|0]|0;l=c[c[b+4>>2]>>2]|0;k=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+616>>3]+ +h[(c[b+416>>2]|0)+992>>3],a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=k;m=g;break}else{g=c[c[b+4>>2]>>2]|0;k=Sy(+h[g>>3],+h[(c[g+8>>2]|0)+616>>3]+ +h[(c[b+416>>2]|0)+992>>3],a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+16|0]|0;k=c[c[b+4>>2]>>2]|0;g=Uy(+h[k>>3],+h[(c[k+8>>2]|0)+616>>3]+ +h[(c[b+416>>2]|0)+992>>3])|0;a[(c[b+352>>2]|0)+16|0]=g;m=j;break}else{j=c[c[b+4>>2]>>2]|0;g=Uy(+h[j>>3],+h[(c[j+8>>2]|0)+616>>3]+ +h[(c[b+416>>2]|0)+992>>3])|0;a[(c[b+352>>2]|0)+16|0]=g;m=g;break}}}}while(0);if(f<<24>>24==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+3|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+3|0;z=y;a[z]=n;i=d;return}function xj(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,3)|0;d=c[(c[a+476>>2]|0)+220>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+656>>3]=+h[d>>3];h[e+640>>3]=+h[d+8>>3];h[e+608>>3]=+h[d+16>>3];h[e+624>>3]=+h[d+24>>3];h[e+648>>3]=+h[d+32>>3];h[e+592>>3]=+h[d+40>>3];h[e+680>>3]=+h[d+48>>3];h[e+632>>3]=+h[d+56>>3];h[e+688>>3]=+h[d+64>>3];h[e+672>>3]=+h[d+72>>3];h[e+600>>3]=+h[d+80>>3];i=b;return}function yj(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+1e3>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+608>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+152|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+152|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,7784,7776,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+152|0;p=o;h[p>>3]=m;i=d;return}function zj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+664>>3]=+h[b+608>>3]*+h[b+592>>3];i=i;return}function Aj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+696>>3]=-(+h[b+632>>3]*+h[b+88>>3])- +h[b+608>>3]*+h[b+600>>3];i=i;return}function Bj(a){a=a|0;h[(c[a+400>>2]|0)+616>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+616>>3];i=i;return}function Cj(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+728>>3]=+h[(c[a+416>>2]|0)+880>>3];i=i;return}function Dj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+13|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+13|0]|0;k=c[c[b+4>>2]>>2]|0;l=Ty(+h[k>>3],+h[(c[k+8>>2]|0)+728>>3],a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=l;f=j;break}else{j=c[c[b+4>>2]>>2]|0;l=Ty(+h[j>>3],+h[(c[j+8>>2]|0)+728>>3],a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+13|0]|0;l=c[c[b+4>>2]>>2]|0;j=Wy(+h[l>>3],+h[(c[l+8>>2]|0)+728>>3])|0;a[(c[b+352>>2]|0)+13|0]=j;f=g;break}else{g=c[c[b+4>>2]>>2]|0;j=Wy(+h[g>>3],+h[(c[g+8>>2]|0)+728>>3])|0;a[(c[b+352>>2]|0)+13|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+14|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+14|0]|0;l=c[c[b+4>>2]>>2]|0;k=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+728>>3]+ +h[(c[b+416>>2]|0)+888>>3],a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=k;m=g;break}else{g=c[c[b+4>>2]>>2]|0;k=Sy(+h[g>>3],+h[(c[g+8>>2]|0)+728>>3]+ +h[(c[b+416>>2]|0)+888>>3],a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+14|0]|0;k=c[c[b+4>>2]>>2]|0;g=Uy(+h[k>>3],+h[(c[k+8>>2]|0)+728>>3]+ +h[(c[b+416>>2]|0)+888>>3])|0;a[(c[b+352>>2]|0)+14|0]=g;m=j;break}else{j=c[c[b+4>>2]>>2]|0;g=Uy(+h[j>>3],+h[(c[j+8>>2]|0)+728>>3]+ +h[(c[b+416>>2]|0)+888>>3])|0;a[(c[b+352>>2]|0)+14|0]=g;m=g;break}}}}while(0);if(f<<24>>24==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+4|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+4|0;z=y;a[z]=n;i=d;return}function Ej(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,4)|0;d=c[(c[a+476>>2]|0)+284>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+768>>3]=+h[d>>3];h[e+752>>3]=+h[d+8>>3];h[e+720>>3]=+h[d+16>>3];h[e+736>>3]=+h[d+24>>3];h[e+760>>3]=+h[d+32>>3];h[e+704>>3]=+h[d+40>>3];h[e+792>>3]=+h[d+48>>3];h[e+744>>3]=+h[d+56>>3];h[e+800>>3]=+h[d+64>>3];h[e+784>>3]=+h[d+72>>3];h[e+712>>3]=+h[d+80>>3];i=b;return}function Fj(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+896>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+720>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+160|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+160|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,7816,7808,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+160|0;p=o;h[p>>3]=m;i=d;return}function Gj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+776>>3]=+h[b+720>>3]*+h[b+704>>3]- +h[b+736>>3]*+h[b+120>>3];i=i;return}function Hj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+808>>3]=-(+h[b+720>>3]*+h[b+712>>3]);i=i;return}function Ij(a){a=a|0;h[(c[a+400>>2]|0)+728>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+728>>3];i=i;return}function Jj(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+840>>3]=+h[(c[a+416>>2]|0)+776>>3];i=i;return}function Kj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+11|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+11|0]|0;k=c[c[b+4>>2]>>2]|0;l=Ty(+h[k>>3],+h[(c[k+8>>2]|0)+840>>3],a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=l;f=j;break}else{j=c[c[b+4>>2]>>2]|0;l=Ty(+h[j>>3],+h[(c[j+8>>2]|0)+840>>3],a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+11|0]|0;l=c[c[b+4>>2]>>2]|0;j=Wy(+h[l>>3],+h[(c[l+8>>2]|0)+840>>3])|0;a[(c[b+352>>2]|0)+11|0]=j;f=g;break}else{g=c[c[b+4>>2]>>2]|0;j=Wy(+h[g>>3],+h[(c[g+8>>2]|0)+840>>3])|0;a[(c[b+352>>2]|0)+11|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+12|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+12|0]|0;l=c[c[b+4>>2]>>2]|0;k=Sy(+h[l>>3],+h[(c[l+8>>2]|0)+840>>3]+ +h[(c[b+416>>2]|0)+784>>3],a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=k;m=g;break}else{g=c[c[b+4>>2]>>2]|0;k=Sy(+h[g>>3],+h[(c[g+8>>2]|0)+840>>3]+ +h[(c[b+416>>2]|0)+784>>3],a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+12|0]|0;k=c[c[b+4>>2]>>2]|0;g=Uy(+h[k>>3],+h[(c[k+8>>2]|0)+840>>3]+ +h[(c[b+416>>2]|0)+784>>3])|0;a[(c[b+352>>2]|0)+12|0]=g;m=j;break}else{j=c[c[b+4>>2]>>2]|0;g=Uy(+h[j>>3],+h[(c[j+8>>2]|0)+840>>3]+ +h[(c[b+416>>2]|0)+784>>3])|0;a[(c[b+352>>2]|0)+12|0]=g;m=g;break}}}}while(0);if(f<<24>>24==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+5|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+5|0;z=y;a[z]=n;i=d;return}function Lj(a){a=a|0;var b=0,d=0,e=0;b=i;gz(a,5)|0;d=c[(c[a+476>>2]|0)+348>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+912>>3]=+h[d>>3];h[e+896>>3]=+h[d+8>>3];h[e+824>>3]=+h[d+16>>3];h[e+880>>3]=+h[d+24>>3];h[e+864>>3]=+h[d+32>>3];h[e+816>>3]=+h[d+40>>3];h[e+872>>3]=+h[d+48>>3];h[e+848>>3]=+h[d+56>>3];h[e+832>>3]=+h[d+64>>3];h[e+856>>3]=+h[d+72>>3];h[e+904>>3]=+h[d+80>>3];i=b;return}function Mj(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+792>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+832>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+168|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+168|0;p=o;h[p>>3]=m;i=d;return}q=k/+mw(c[b+536>>2]|0,e,7840,7832,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+168|0;p=o;h[p>>3]=m;i=d;return}function Nj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+888>>3]=+h[b+832>>3]*+h[b+816>>3];i=i;return}function Oj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+920>>3]=-(+h[b+856>>3]*+h[b+104>>3])- +h[b+832>>3]*+h[b+824>>3];i=i;return}function Pj(a){a=a|0;h[(c[a+400>>2]|0)+840>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+840>>3];i=i;return}function Qj(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+952>>3]=+h[(c[a+416>>2]|0)+672>>3];i=i;return}



function dZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;g=i;h=d+12|0;j=c[h>>2]|0;k=(b|0)==0|(f|0)==0;if(!k){c[f+48>>2]=0;c[c[f+36>>2]>>2]=-1}l=c[f+28>>2]|0;m=VZ((l<<3)+8|0)|0;n=m;if((m|0)==0){o=12;i=g;return o|0}c[m>>2]=-1;p=VZ((l<<2)+4|0)|0;if((p|0)==0){WZ(m);o=12;i=g;return o|0}c[p>>2]=-1;q=0;while(1){if(q>>>0>l>>>0){break}else{q=q+1|0}}jZ(d,e)|0;e=jZ(d,0)|0;q=c[h>>2]|0;a:do{if((q|0)>(j|0)&(e|0)==0){l=d+16|0;r=f+32|0;s=f+16|0;t=f+36|0;u=q;v=0;w=-1;x=1;y=0;z=0;A=n;B=0;while(1){C=u+ -1|0;c[h>>2]=C;D=c[l>>2]|0;b:do{switch(c[D+(C<<2)>>2]|0){case 1:{E=u+ -2|0;c[h>>2]=E;F=c[D+(E<<2)>>2]|0;if(k){E=c[(c[c[F+4>>2]>>2]|0)+20>>2]|0;G=u+ -3|0;c[h>>2]=G;c[F+20>>2]=(c[D+(G<<2)>>2]|0)+E;H=v;I=-1;J=x;K=y;L=z;M=A;N=0;O=B;break b}else{E=u+ -3|0;c[h>>2]=E;G=c[D+(E<<2)>>2]|0;E=u+ -4|0;c[h>>2]=E;F=(G|0)==0;H=F&1;I=F?w:c[D+(E<<2)>>2]|0;J=x;K=y;L=z;M=A;N=0;O=B;break b}break};case 0:{E=u+ -2|0;c[h>>2]=E;F=c[D+(E<<2)>>2]|0;E=F;G=F+12|0;P=c[G>>2]|0;if((P|0)>-1){Q=0;do{R=A+(Q<<2)|0;Q=Q+1|0}while((c[R>>2]|0)>-1);c[R>>2]=P<<1;c[A+(Q<<2)>>2]=-1;do{if(!k){S=0;while(1){if((c[p+(S<<2)>>2]|0)>-1){S=S+1|0}else{break}}c[(c[s>>2]|0)+(P*12|0)+8>>2]=0;if((S|0)<=0){break}T=VZ((S<<2)+4|0)|0;U=T;if((T|0)==0){V=w;W=y;X=z;Y=A;Z=12;_=B;break a}c[(c[s>>2]|0)+(P*12|0)+8>>2]=U;$=c[p>>2]|0;if(($|0)>-1){aa=U;ba=$;$=0;while(1){c[aa>>2]=ba;ca=$+1|0;da=c[p+(ca<<2)>>2]|0;ea=T+(ca<<2)|0;if((da|0)>-1){$=ca;ba=da;aa=ea}else{fa=ea;break}}}else{fa=U}c[fa>>2]=-1}}while(0);P=jZ(d,c[G>>2]|0)|0;if((P|0)!=0){V=w;W=y;X=z;Y=A;Z=P;_=B;break a}P=jZ(d,6)|0;if((P|0)!=0){V=w;W=y;X=z;Y=A;Z=P;_=B;break a}}P=c[F>>2]|0;do{if((P|0)==0){Q=c[c[F+4>>2]>>2]|0;if(!((Q|0)>-1|(Q|0)==-4)){ga=v;ha=w;ia=x;ja=y;ka=z;la=0;ma=B;break}if(!((c[A>>2]|0)>-1)){ga=v;ha=w;ia=x;ja=y;ka=z;la=0;ma=B;break}if(k){c[F+20>>2]=1;na=w;oa=y;pa=0}else{Q=lZ(b,E,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){aa=c[t>>2]|0;ba=0;while(1){qa=aa+(ba<<2)|0;ra=ba+1|0;if((c[qa>>2]|0)>-1){ba=ra}else{break}}c[qa>>2]=B;c[aa+(ra<<2)>>2]=w;c[aa+(ba+2<<2)>>2]=-1;sa=-1;ta=y+1|0}else{sa=w;ta=y}U=c[A>>2]|0;if((U|0)>-1){$=c[s>>2]|0;T=U;U=0;do{S=(T|0)/2|0;if((T&1|0)==0){c[$+(S*12|0)>>2]=B}else{c[$+(S*12|0)+4>>2]=B}U=U+1|0;T=c[A+(U<<2)>>2]|0;}while((T|0)>-1)}c[A>>2]=-1;na=sa;oa=ta;pa=Q}c[A>>2]=-1;ga=v;ha=na;ia=x+1|0;ja=oa;ka=z+1|0;la=pa;ma=x}else if((P|0)==2){T=c[F+4>>2]|0;if(k){if((c[A>>2]|0)>-1){ua=1}else{ua=a[T+12|0]&1}U=jZ(d,ua)|0;if((U|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=U;ma=B;break}}else{U=jZ(d,B)|0;if((U|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=U;ma=B;break}U=jZ(d,a[T+12|0]&1)|0;if((U|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=U;ma=B;break}}U=jZ(d,F)|0;if((U|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=U;ma=B;break}U=jZ(d,1)|0;if((U|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=U;ma=B;break}U=jZ(d,c[T>>2]|0)|0;if((U|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=U;ma=B;break}U=jZ(d,0)|0;if((U|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=U;ma=B;break}if(!((c[A>>2]|0)>-1)){if((a[T+12|0]&1)==0){ga=0;ha=w;ia=x;ja=y;ka=z;la=0;ma=B;break}}if(k){va=w;wa=y;xa=0}else{U=lZ(b,E,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=(a[T+12|0]&1)==0?v:1;if((w|0)>-1){T=c[t>>2]|0;$=0;while(1){ya=T+($<<2)|0;za=$+1|0;if((c[ya>>2]|0)>-1){$=za}else{break}}c[ya>>2]=B;c[T+(za<<2)>>2]=w;c[T+($+2<<2)>>2]=-1;Aa=-1;Ba=y+1|0}else{Aa=w;Ba=y}Q=c[A>>2]|0;if((Q|0)>-1){ba=c[s>>2]|0;aa=Q;Q=0;do{S=(aa|0)/2|0;if((aa&1|0)==0){c[ba+(S*12|0)>>2]=B}else{c[ba+(S*12|0)+4>>2]=B}Q=Q+1|0;aa=c[A+(Q<<2)>>2]|0;}while((aa|0)>-1)}c[A>>2]=-1;va=Aa;wa=Ba;xa=U}c[A>>2]=-1;ga=0;ha=va;ia=x+1|0;ja=wa;ka=z+1|0;la=xa;ma=x}else if((P|0)==1){aa=c[F+4>>2]|0;Q=c[aa>>2]|0;ba=c[aa+4>>2]|0;aa=jZ(d,F)|0;if((aa|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=aa;ma=B;break}aa=jZ(d,5)|0;if((aa|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=aa;ma=B;break}aa=jZ(d,ba)|0;if((aa|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=aa;ma=B;break}aa=jZ(d,0)|0;if((aa|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=aa;ma=B;break}aa=Q+20|0;$=jZ(d,(c[aa>>2]|0)+x|0)|0;if(($|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=$;ma=B;break}if((c[aa>>2]|0)>0){aa=(c[ba+20>>2]|0)>0;Ca=(aa&1)+x|0;Da=aa?x:-1}else{Ca=x;Da=-1}aa=jZ(d,Da)|0;if((aa|0)!=0){ga=v;ha=w;ia=Ca;ja=y;ka=z;la=aa;ma=B;break}aa=jZ(d,4)|0;if((aa|0)!=0){ga=v;ha=w;ia=Ca;ja=y;ka=z;la=aa;ma=B;break}aa=jZ(d,Q)|0;if((aa|0)!=0){ga=v;ha=w;ia=Ca;ja=y;ka=z;la=aa;ma=B;break}ga=v;ha=w;ia=Ca;ja=y;ka=z;la=jZ(d,0)|0;ma=B}else if((P|0)==3){aa=c[F+4>>2]|0;Q=c[aa>>2]|0;ba=c[aa+4>>2]|0;aa=(c[A>>2]|0)>-1;$=x+1|0;T=jZ(d,aa?$:x)|0;if((T|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=T;ma=B;break}T=jZ(d,aa?x:B)|0;if((T|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=T;ma=B;break}T=jZ(d,A)|0;if((T|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=T;ma=B;break}T=jZ(d,(c[A>>2]|0)>>>31^1)|0;if((T|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=T;ma=B;break}T=jZ(d,F)|0;if((T|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=T;ma=B;break}T=ba;ba=jZ(d,T)|0;if((ba|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=ba;ma=B;break}ba=Q;Q=jZ(d,ba)|0;if((Q|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=Q;ma=B;break}Q=jZ(d,3)|0;if((Q|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=Q;ma=B;break}Q=jZ(d,T)|0;if((Q|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=Q;ma=B;break}Q=jZ(d,0)|0;if((Q|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=Q;ma=B;break}Q=jZ(d,2)|0;if((Q|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=Q;ma=B;break}Q=jZ(d,ba)|0;if((Q|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=Q;ma=B;break}Q=jZ(d,0)|0;if((Q|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=Q;ma=B;break}if((c[A>>2]|0)>-1){if(k){Ea=w;Fa=y;Ga=0}else{Q=lZ(b,E,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){ba=c[t>>2]|0;T=0;while(1){Ha=ba+(T<<2)|0;Ia=T+1|0;if((c[Ha>>2]|0)>-1){T=Ia}else{break}}c[Ha>>2]=B;c[ba+(Ia<<2)>>2]=w;c[ba+(T+2<<2)>>2]=-1;Ja=-1;Ka=y+1|0}else{Ja=w;Ka=y}U=c[A>>2]|0;if((U|0)>-1){aa=c[s>>2]|0;S=U;U=0;do{ea=(S|0)/2|0;if((S&1|0)==0){c[aa+(ea*12|0)>>2]=B}else{c[aa+(ea*12|0)+4>>2]=B}U=U+1|0;S=c[A+(U<<2)>>2]|0;}while((S|0)>-1)}c[A>>2]=-1;Ea=Ja;Fa=Ka;Ga=Q}c[A>>2]=-1;La=Ea;Ma=$;Na=Fa;Oa=z+1|0;Pa=Ga;Qa=x}else{La=w;Ma=x;Na=y;Oa=z;Pa=0;Qa=B}if((c[F+16>>2]|0)<=0){ga=v;ha=La;ia=Ma;ja=Na;ka=Oa;la=Pa;ma=Qa;break}ga=v;ha=La;ia=Ma+2|0;ja=Na;ka=Oa;la=Pa;ma=Ma+1|0}else{ga=v;ha=w;ia=x;ja=y;ka=z;la=0;ma=B}}while(0);F=c[G>>2]|0;if((F|0)>-1){Ra=0}else{H=ga;I=ha;J=ia;K=ja;L=ka;M=A;N=la;O=ma;break b}do{Sa=p+(Ra<<2)|0;Ra=Ra+1|0}while((c[Sa>>2]|0)>-1);c[Sa>>2]=F;c[p+(Ra<<2)>>2]=-1;H=ga;I=ha;J=ia;K=ja;L=ka;M=A;N=la;O=ma;break};case 6:{G=u+ -2|0;c[h>>2]=G;E=c[D+(G<<2)>>2]|0;G=0;do{Ta=A+(G<<2)|0;G=G+1|0}while((c[Ta>>2]|0)>-1);c[Ta>>2]=E<<1|1;c[A+(G<<2)>>2]=-1;F=0;while(1){if((c[p+(F<<2)>>2]|0)>-1){F=F+1|0}else{break}}c[p+(F+ -1<<2)>>2]=-1;H=v;I=w;J=x;K=y;L=z;M=A;N=0;O=B;break};case 3:{G=c[D+(u+ -2<<2)>>2]|0;E=c[D+(u+ -3<<2)>>2]|0;P=c[D+(u+ -4<<2)>>2]|0;S=u+ -5|0;c[h>>2]=S;if(k){U=c[P+4>>2]|0;aa=P+16|0;c[P+20>>2]=(c[(c[U>>2]|0)+20>>2]|0)+(c[D+(S<<2)>>2]|0)+(c[(c[U+4>>2]|0)+20>>2]|0)+((c[aa>>2]|0)>0?2:0);Ua=aa;Va=c[h>>2]|0}else{Ua=P+16|0;Va=S}S=c[D+(Va+ -1<<2)>>2]|0;P=Va+ -2|0;c[h>>2]=P;aa=c[D+(P<<2)>>2]|0;P=Va+ -3|0;c[h>>2]=P;U=c[D+(P<<2)>>2]|0;if((c[Ua>>2]|0)<=0){H=1;I=w;J=x;K=y;L=z;M=S;N=0;O=B;break b}if(k){Wa=0}else{mZ(b,G,aa)|0;c[(c[r>>2]|0)+(aa<<2)>>2]=1;aa=mZ(b,E,U)|0;c[(c[r>>2]|0)+(U<<2)>>2]=1;Wa=aa}H=1;I=w;J=x;K=y;L=z+2|0;M=S;N=Wa;O=B;break};case 4:{S=u+ -2|0;c[h>>2]=S;aa=c[D+(S<<2)>>2]|0;S=u+ -3|0;c[h>>2]=S;H=v;I=w;J=c[D+(S<<2)>>2]|0;K=y;L=z;M=A;N=0;O=(aa|0)>-1?aa:B;break};case 5:{aa=u+ -2|0;c[h>>2]=aa;S=c[D+(aa<<2)>>2]|0;if(!k){H=v;I=w;J=x;K=y;L=z;M=A;N=0;O=B;break b}aa=c[S+4>>2]|0;c[S+20>>2]=(c[(c[aa+4>>2]|0)+20>>2]|0)+(c[(c[aa>>2]|0)+20>>2]|0);H=v;I=w;J=x;K=y;L=z;M=A;N=0;O=B;break};case 2:{aa=A;while(1){if((c[aa>>2]|0)>-1){aa=aa+4|0}else{H=v;I=w;J=x;K=y;L=z;M=aa;N=0;O=B;break}}break};default:{H=v;I=w;J=x;K=y;L=z;M=A;N=0;O=B}}}while(0);D=c[h>>2]|0;if((D|0)>(j|0)&(N|0)==0){u=D;v=H;w=I;x=J;y=K;z=L;A=M;B=O}else{V=I;W=K;X=L;Y=M;Z=N;_=O;break a}}}else{V=-1;W=0;X=0;Y=n;Z=e;_=0}}while(0);do{if(k){Xa=W}else{e=c[Y>>2]|0;if((e|0)>-1){n=c[f+16>>2]|0;O=e;e=0;do{N=(O|0)/2|0;if((O&1|0)==0){c[n+(N*12|0)>>2]=_}else{c[n+(N*12|0)+4>>2]=_}e=e+1|0;O=c[Y+(e<<2)>>2]|0;}while((O|0)>-1)}c[Y>>2]=-1;if(!((V|0)>-1)){Xa=W;break}O=c[f+36>>2]|0;e=0;while(1){Ya=O+(e<<2)|0;Za=e+1|0;if((c[Ya>>2]|0)>-1){e=Za}else{break}}c[Ya>>2]=_;c[O+(Za<<2)>>2]=V;c[O+(e+2<<2)>>2]=-1;Xa=W+1|0}}while(0);c[f+48>>2]=X;c[f+40>>2]=X;c[f+44>>2]=Xa;WZ(m);WZ(p);o=Z;i=g;return o|0}function eZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a;a:while(1){a=c[g>>2]|0;do{if((a|0)==1){h=c[g+4>>2]|0;j=h+4|0;k=gZ(c[(c[h>>2]|0)+28>>2]|0,c[(c[j>>2]|0)+24>>2]|0,b,d,e)|0;if((k|0)!=0){l=k;m=10;break a}k=eZ(c[h>>2]|0,b,d,e)|0;if((k|0)==0){n=j}else{l=k;m=10;break a}}else if((a|0)==3){k=c[g+4>>2]|0;j=eZ(c[k>>2]|0,b,d,e)|0;if((j|0)!=0){l=j;m=10;break a}n=k+4|0}else if((a|0)==2){k=c[g+4>>2]|0;j=k;if(!((c[k+8>>2]|0)==-1)){n=j;break}h=c[k>>2]|0;k=gZ(c[h+28>>2]|0,c[h+24>>2]|0,b,d,e)|0;if((k|0)==0){n=j}else{l=k;m=10;break a}}else{l=0;m=10;break a}}while(0);g=c[n>>2]|0}if((m|0)==10){i=f;return l|0}return 0}function fZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+4>>2]|0;if((d|0)==0){i=b;return}a=d+4|0;e=c[d>>2]|0;if((c[a>>2]|0)==0){f=e}else{g=e;e=0;while(1){do{if((c[g+(e<<5)+8>>2]|0)==0){h=g}else{j=c[g+(e<<5)+16>>2]|0;if((j|0)==0){k=g}else{WZ(j);k=c[d>>2]|0}j=c[k+(e<<5)+28>>2]|0;if((j|0)==0){h=k;break}WZ(j);h=c[d>>2]|0}}while(0);j=e+1|0;if(j>>>0<(c[a>>2]|0)>>>0){g=h;e=j}else{f=h;break}}}if((f|0)!=0){WZ(f)}f=d+8|0;h=c[f>>2]|0;if((h|0)!=0){if((c[h+8>>2]|0)==0){l=h}else{e=h;while(1){h=c[e+16>>2]|0;if((h|0)!=0){WZ(h)}if((c[e+40>>2]|0)==0){break}else{e=e+32|0}}l=c[f>>2]|0}WZ(l)}l=d+16|0;f=c[l>>2]|0;if((f|0)!=0){e=d+28|0;h=c[e>>2]|0;if((h|0)==0){m=f}else{g=h;h=f;f=0;while(1){a=c[h+(f*12|0)+8>>2]|0;if((a|0)==0){n=h;o=g}else{WZ(a);n=c[l>>2]|0;o=c[e>>2]|0}a=f+1|0;if(a>>>0<o>>>0){g=o;h=n;f=a}else{m=n;break}}}WZ(m)}m=c[d+32>>2]|0;if((m|0)!=0){WZ(m)}m=c[d+20>>2]|0;if((m|0)!=0){WZ(m)}m=c[d+36>>2]|0;if((m|0)!=0){WZ(m)}WZ(d);i=b;return}function gZ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;h=a;a=c[h>>2]|0;j=(a|0)>-1;if((d|0)==0){if(!j){k=0;i=g;return k|0}l=b;m=a;a=h;while(1){a:do{if((c[l>>2]|0)>-1){n=b;o=m;while(1){p=e+(o<<2)|0;c[p>>2]=(c[p>>2]|0)+1;p=n+32|0;if(!((c[p>>2]|0)>-1)){break a}o=c[a>>2]|0;n=p}}}while(0);n=a+32|0;o=c[n>>2]|0;if((o|0)>-1){m=o;a=n}else{k=0;break}}i=g;return k|0}if(!j){k=0;i=g;return k|0}j=b;a=h;b:while(1){h=c[j>>2]|0;c:do{if((h|0)>-1){m=a+4|0;e=a+8|0;l=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+12|0;r=b;s=h;t=j;u=-1;while(1){v=r;w=s;x=t;while(1){y=v+32|0;if((w|0)!=(u|0)){break}z=y;A=c[z>>2]|0;if((A|0)>-1){w=A;x=z;v=y}else{break c}}z=d+(c[f+(c[a>>2]<<2)>>2]<<5)|0;while(1){B=z+8|0;if((c[B>>2]|0)==0){break}else{z=z+32|0}}c[z+40>>2]=0;c[z>>2]=c[m>>2];c[z+4>>2]=c[e>>2];A=c[x>>2]|0;c[B>>2]=d+(c[f+(A<<2)>>2]<<5);c[z+12>>2]=A;A=c[n>>2]|0;C=c[o>>2]|0;D=c[v+16>>2]|c[l>>2]|((A|0)!=0?4:0)|((C|0)!=0?8:0);E=z+20|0;c[E>>2]=D;F=c[p>>2]|0;G=z+24|0;if((F|0)>-1){c[G>>2]=F;c[E>>2]=D|256}else{c[G>>2]=A}if((C|0)==0){c[z+28>>2]=0}else{A=0;while(1){H=A+1|0;if((c[C+(A<<2)>>2]|0)==0){break}else{A=H}}A=VZ(H<<2)|0;C=A;c[z+28>>2]=C;if((A|0)==0){k=12;I=49;break b}x=c[o>>2]|0;G=c[x>>2]|0;if((G|0)==0){J=C}else{D=C;C=G;G=0;while(1){c[D>>2]=C;E=G+1|0;F=c[x+(E<<2)>>2]|0;K=A+(E<<2)|0;if((F|0)==0){J=K;break}else{G=E;C=F;D=K}}}c[J>>2]=0}D=c[q>>2]|0;if((D|0)==0){L=0}else{C=0;while(1){if((c[D+(C<<2)>>2]|0)>-1){C=C+1|0}else{L=C;break}}}C=v+12|0;D=c[C>>2]|0;if((D|0)==0){M=0}else{G=0;while(1){if((c[D+(G<<2)>>2]|0)>-1){G=G+1|0}else{M=G;break}}}G=z+16|0;D=c[G>>2]|0;if((D|0)!=0){WZ(D)}c[G>>2]=0;D=M+L|0;if((D|0)>0){v=VZ((D<<2)+4|0)|0;c[G>>2]=v;if((v|0)==0){k=12;I=49;break b}G=c[q>>2]|0;do{if((G|0)==0){N=0}else{D=c[G>>2]|0;if((D|0)>-1){O=D;P=0}else{N=0;break}while(1){c[v+(P<<2)>>2]=O;D=P+1|0;A=c[G+(D<<2)>>2]|0;if((A|0)>-1){P=D;O=A}else{N=D;break}}}}while(0);G=c[C>>2]|0;do{if((G|0)==0){Q=N}else{z=c[G>>2]|0;if(!((z|0)>-1)){Q=N;break}D=(N|0)>0;A=z;z=0;x=N;while(1){d:do{if(D){K=0;while(1){F=K+1|0;if((c[v+(K<<2)>>2]|0)==(A|0)){R=x;break d}if((F|0)<(N|0)){K=F}else{I=40;break}}}else{I=40}}while(0);if((I|0)==40){I=0;c[v+(x<<2)>>2]=A;R=x+1|0}K=z+1|0;F=c[G+(K<<2)>>2]|0;if((F|0)>-1){A=F;z=K;x=R}else{Q=R;break}}}}while(0);c[v+(Q<<2)>>2]=-1}G=y;C=c[G>>2]|0;if((C|0)>-1){r=y;s=C;t=G;u=w}else{break}}}}while(0);h=a+32|0;if((c[h>>2]|0)>-1){a=h}else{k=0;I=49;break}}if((I|0)==49){i=g;return k|0}return 0}function hZ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=(e|0)==0;a:do{if(h){j=0}else{k=0;while(1){if(!((c[e+(k<<2)>>2]|0)>-1)){j=k;break a}k=k+1|0}}}while(0);k=0;while(1){if((c[b+(k<<5)>>2]|0)>-1){k=k+1|0}else{l=0;break}}while(1){if((c[d+(l<<5)>>2]|0)>-1){l=l+1|0}else{break}}m=tZ(a,0,0,1,(l+k<<5)+32|0)|0;k=m;if((m|0)==0){n=0;i=g;return n|0}l=c[b>>2]|0;b:do{if((l|0)>-1){o=(j|0)>0;p=l;q=0;while(1){c[m+(q<<5)>>2]=p;c[m+(q<<5)+4>>2]=c[b+(q<<5)+4>>2];c[m+(q<<5)+8>>2]=c[b+(q<<5)+8>>2];c[m+(q<<5)+16>>2]=c[b+(q<<5)+16>>2]|f;c[m+(q<<5)+20>>2]=c[b+(q<<5)+20>>2];c[m+(q<<5)+24>>2]=c[b+(q<<5)+24>>2];c[m+(q<<5)+28>>2]=c[b+(q<<5)+28>>2];r=b+(q<<5)+12|0;s=c[r>>2]|0;t=(s|0)==0;if(t&h){c[m+(q<<5)+12>>2]=0}else{c:do{if(t){u=0}else{v=0;while(1){if(!((c[s+(v<<2)>>2]|0)>-1)){u=v;break c}v=v+1|0}}}while(0);s=tZ(a,0,0,0,(u+j<<2)+4|0)|0;t=s;if((s|0)==0){n=0;break}if((u|0)>0){v=c[r>>2]|0;w=0;while(1){c[s+(w<<2)>>2]=c[v+(w<<2)>>2];x=w+1|0;if((x|0)<(u|0)){w=x}else{y=u;break}}}else{y=0}if(o){w=0;while(1){c[s+(w+y<<2)>>2]=c[e+(w<<2)>>2];v=w+1|0;if((v|0)<(j|0)){w=v}else{z=j;break}}}else{z=0}c[s+(z+y<<2)>>2]=-1;c[m+(q<<5)+12>>2]=t}w=q+1|0;v=c[b+(w<<5)>>2]|0;if((v|0)>-1){p=v;q=w}else{A=w;break b}}i=g;return n|0}else{A=0}}while(0);b=c[d>>2]|0;y=m+(A<<5)|0;d:do{if((b|0)>-1){z=y;j=A;e=b;u=0;while(1){c[z>>2]=e;c[m+(j<<5)+4>>2]=c[d+(u<<5)+4>>2];c[m+(j<<5)+8>>2]=c[d+(u<<5)+8>>2];c[m+(j<<5)+16>>2]=c[d+(u<<5)+16>>2];c[m+(j<<5)+20>>2]=c[d+(u<<5)+20>>2];c[m+(j<<5)+24>>2]=c[d+(u<<5)+24>>2];c[m+(j<<5)+28>>2]=c[d+(u<<5)+28>>2];h=d+(u<<5)+12|0;f=c[h>>2]|0;if((f|0)==0){c[m+(j<<5)+12>>2]=0}else{l=0;while(1){if((c[f+(l<<2)>>2]|0)>-1){l=l+1|0}else{break}}f=tZ(a,0,0,0,(l<<2)+4|0)|0;t=f;if((f|0)==0){n=0;break}if((l|0)>0){s=c[h>>2]|0;q=0;while(1){c[f+(q<<2)>>2]=c[s+(q<<2)>>2];p=q+1|0;if((p|0)<(l|0)){q=p}else{B=l;break}}}else{B=0}c[f+(B<<2)>>2]=-1;c[m+(j<<5)+12>>2]=t}l=u+1|0;q=c[d+(l<<5)>>2]|0;s=l+A|0;h=m+(s<<5)|0;if((q|0)>-1){z=h;j=s;e=q;u=l}else{C=h;break d}}i=g;return n|0}else{C=y}}while(0);c[C>>2]=-1;n=k;i=g;return n|0}function iZ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=a+12|0;j=c[h>>2]|0;k=(f|0)!=0;if(k){c[f>>2]=0}l=jZ(a,b)|0;if((l|0)!=0){m=l;i=g;return m|0}l=a+16|0;b=(d|0)==0;n=(e|0)==0;a:while(1){o=c[h>>2]|0;if((o|0)<=(j|0)){m=0;p=28;break}q=o+ -1|0;c[h>>2]=q;o=c[(c[l>>2]|0)+(q<<2)>>2]|0;q=c[o>>2]|0;do{if((q|0)==0){r=c[o+4>>2]|0;s=c[r>>2]|0;if((s|0)==-2){if(n){continue a}c[e>>2]=c[e>>2]|c[r+4>>2];continue a}else if(!((s|0)==-3)){continue a}s=c[r+4>>2]|0;if(!((s|0)>-1)){continue a}b:do{if(!b){r=c[d>>2]|0;c:do{if((r|0)>-1){t=r;u=d;v=0;while(1){w=v+1|0;if((t|0)==(s|0)){break}x=d+(w<<2)|0;y=c[x>>2]|0;if((y|0)>-1){t=y;u=x;v=w}else{z=x;A=w;break c}}if((s|0)<0){z=u;A=v}else{break b}}else{z=d;A=0}}while(0);c[z>>2]=s;c[d+(A+1<<2)>>2]=-1}}while(0);if(!k){continue a}c[f>>2]=(c[f>>2]|0)+1;continue a}else if((q|0)==1){s=c[o+4>>2]|0;r=jZ(a,c[s>>2]|0)|0;if((r|0)!=0){m=r;p=28;break a}B=jZ(a,c[s+4>>2]|0)|0}else if((q|0)==3){s=c[o+4>>2]|0;r=c[s>>2]|0;if((c[r+8>>2]|0)!=0){B=jZ(a,r)|0;break}r=c[s+4>>2]|0;if((c[r+8>>2]|0)==0){continue a}B=jZ(a,r)|0}else if((q|0)==2){r=c[c[o+4>>2]>>2]|0;if((c[r+8>>2]|0)==0){continue a}B=jZ(a,r)|0}else{continue a}}while(0);if((B|0)!=0){m=B;p=28;break}}if((p|0)==28){i=g;return m|0}return 0}function jZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a;h=c[g>>2]|0;if((f|0)<(h|0)){c[(c[a+16>>2]|0)+(f<<2)>>2]=b;c[e>>2]=(c[e>>2]|0)+1;j=0;i=d;return j|0}e=c[a+4>>2]|0;if((h|0)>=(e|0)){j=12;i=d;return j|0}f=(c[a+8>>2]|0)+h|0;h=(f|0)>(e|0)?e:f;f=a+16|0;e=YZ(c[f>>2]|0,h<<2)|0;if((e|0)==0){j=12;i=d;return j|0}else{c[g>>2]=h;c[f>>2]=e;jZ(a,b)|0;i=d;return 0}return 0}function kZ(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;l=i;m=d+12|0;n=c[m>>2]|0;jZ(d,e)|0;e=jZ(d,0)|0;a:do{if((e|0)==0){o=d+16|0;p=(f&1|0)==0;q=(f&2|0)==0;r=1;s=0;t=j;b:while(1){u=c[m>>2]|0;if((u|0)<=(n|0)){v=s;w=0;break a}x=u+ -1|0;c[m>>2]=x;y=c[o>>2]|0;z=c[y+(x<<2)>>2]|0;if((z|0)==1){x=u+ -2|0;c[m>>2]=x;A=s;B=r;t=c[y+(x<<2)>>2]|0;s=A;r=B;continue}else if((z|0)!=0){C=t;A=s;B=r;t=C;s=A;r=B;continue}z=u+ -2|0;c[m>>2]=z;u=c[y+(z<<2)>>2]|0;z=c[u>>2]|0;do{if((z|0)==1){y=c[u+4>>2]|0;x=c[y>>2]|0;D=y+4|0;E=c[D>>2]|0;F=tZ(b,0,0,1,32)|0;if((F|0)==0){G=29;break b}H=tZ(b,0,0,1,8)|0;I=F+4|0;c[I>>2]=H;if((H|0)==0){G=29;break b}c[F>>2]=1;c[F+8>>2]=-1;c[F+12>>2]=-1;c[H>>2]=x;c[(c[I>>2]|0)+4>>2]=E;c[F+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);c[t>>2]=F;F=c[I>>2]|0;c[F>>2]=0;I=F+4|0;c[I>>2]=0;x=jZ(d,c[D>>2]|0)|0;if((x|0)!=0){v=s;w=x;break a}x=jZ(d,0)|0;if((x|0)!=0){v=s;w=x;break a}x=jZ(d,I)|0;if((x|0)!=0){v=s;w=x;break a}x=jZ(d,1)|0;if((x|0)!=0){v=s;w=x;break a}x=jZ(d,c[y>>2]|0)|0;if((x|0)!=0){v=s;w=x;break a}J=r;K=s;L=F;M=jZ(d,0)|0}else if((z|0)==0){F=c[u+4>>2]|0;x=c[F+8>>2]|0;y=c[F>>2]|0;I=c[F+4>>2]|0;do{if((y|0)>-1|(y|0)==-4){N=r;O=I;P=y;Q=s+1|0;R=(c[g>>2]|0)+x|0}else{if(!((y|0)==-3)){N=r;O=I;P=y;Q=s;R=x;break}if(!p){N=r;O=-1;P=-1;Q=s;R=-1;break}if(q|(r|0)==0){N=r;O=I;P=-3;Q=s;R=x;break}c[h+(I<<2)>>2]=1;N=0;O=I;P=-3;Q=s;R=x}}while(0);x=tZ(b,0,0,1,32)|0;I=x;do{if((x|0)==0){S=0}else{y=tZ(b,0,0,1,20)|0;c[x+4>>2]=y;if((y|0)==0){S=0;break}c[x>>2]=0;c[x+8>>2]=-1;c[x+12>>2]=-1;c[y>>2]=P;c[y+4>>2]=O;c[y+8>>2]=R;S=I}}while(0);c[t>>2]=S;I=(S|0)==0?12:0;if((R|0)<=(c[k>>2]|0)){J=N;K=Q;L=t;M=I;break}c[k>>2]=R;J=N;K=Q;L=t;M=I}else if((z|0)==2){I=c[u+4>>2]|0;x=jZ(d,c[I>>2]|0)|0;if((x|0)!=0){v=s;w=x;break a}x=jZ(d,0)|0;if((x|0)!=0){v=s;w=x;break a}x=c[I>>2]|0;y=c[I+4>>2]|0;F=c[I+8>>2]|0;D=a[I+12|0]|0;I=tZ(b,0,0,1,32)|0;if((I|0)==0){G=40;break b}E=tZ(b,0,0,1,16)|0;H=I+4|0;c[H>>2]=E;if((E|0)==0){G=40;break b}c[I>>2]=2;c[I+8>>2]=-1;c[I+12>>2]=-1;c[E>>2]=x;c[E+4>>2]=y;c[E+8>>2]=F;F=E+12|0;a[F]=a[F]&-2|D&1;c[I+16>>2]=c[x+16>>2];c[t>>2]=I;A=s;B=r;t=c[H>>2]|0;s=A;r=B;continue b}else if((z|0)==3){H=c[u+4>>2]|0;I=c[H>>2]|0;x=H+4|0;D=c[x>>2]|0;F=tZ(b,0,0,1,32)|0;if((F|0)==0){G=20;break b}E=tZ(b,0,0,1,8)|0;y=F+4|0;c[y>>2]=E;if((E|0)==0){G=20;break b}c[F>>2]=3;c[F+8>>2]=-1;c[F+12>>2]=-1;c[E>>2]=I;c[(c[y>>2]|0)+4>>2]=D;c[F+16>>2]=(c[D+16>>2]|0)+(c[I+16>>2]|0);c[t>>2]=F;F=c[y>>2]|0;y=jZ(d,c[x>>2]|0)|0;if((y|0)!=0){v=s;w=y;break a}y=jZ(d,0)|0;if((y|0)!=0){v=s;w=y;break a}y=jZ(d,F+4|0)|0;if((y|0)!=0){v=s;w=y;break a}y=jZ(d,1)|0;if((y|0)!=0){v=s;w=y;break a}y=jZ(d,c[H>>2]|0)|0;if((y|0)!=0){v=s;w=y;break a}J=r;K=s;L=F;M=jZ(d,0)|0}else{C=t;A=s;B=r;t=C;s=A;r=B;continue b}}while(0);if((M|0)==0){r=J;s=K;t=L}else{v=K;w=M;break a}}if((G|0)==20){c[t>>2]=0;v=s;w=12;break}else if((G|0)==29){c[t>>2]=0;v=s;w=12;break}else if((G|0)==40){c[t>>2]=0;v=s;w=12;break}}else{v=0;w=e}}while(0);c[g>>2]=(c[g>>2]|0)+v;i=l;return w|0}function lZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=tZ(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=tZ(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=tZ(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f>>2]=j;k=tZ(a,0,0,0,32)|0;l=f+4|0;c[l>>2]=k;if((k|0)==0){g=12;i=e;return g|0}m=b+4|0;c[k+4>>2]=c[m>>2];k=b;c[c[l>>2]>>2]=c[k>>2];n=c[l>>2]|0;c[n+8>>2]=-1;c[n+12>>2]=-1;c[n+24>>2]=0;c[(c[l>>2]|0)+28>>2]=0;c[(c[l>>2]|0)+20>>2]=0;c[m>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f>>2]=0;g=12;i=e;return g|0}function mZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=tZ(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=tZ(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=tZ(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f+4>>2]=j;k=tZ(a,0,0,0,32)|0;c[f>>2]=k;if((k|0)==0){g=12;i=e;return g|0}l=b+4|0;c[k+4>>2]=c[l>>2];k=b;c[c[f>>2]>>2]=c[k>>2];m=c[f>>2]|0;c[m+8>>2]=-1;c[m+12>>2]=-1;c[m+24>>2]=0;c[(c[f>>2]|0)+28>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[l>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f+4>>2]=0;g=12;i=e;return g|0}function nZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[c[(c[b>>2]|0)+4>>2]>>2]|0;if((e|0)<(a|0)){f=-1;i=d;return f|0}f=(e|0)>(a|0)|0;i=d;return f|0}function oZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;g=d;a:do{if((b|0)==0){h=121760}else{j=b;k=121760;while(1){if((a[k]|0)==0){h=k;break a}l=j+ -1|0;m=k+((x_(k|0)|0)+1)|0;if((l|0)==0){h=m;break}else{j=l;k=m}}}}while(0);c[g>>2]=(a[h]|0)==0?h+1|0:h;h=(Jc(e|0,f|0,122048,g|0)|0)+1|0;i=d;return h|0}function pZ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0;g=i;i=i+16|0;h=g;j=g+8|0;k=c[a+4>>2]|0;a=k;l=k+40|0;m=c[l>>2]|0;do{if((m|0)<1|(d|0)==0){n=0}else{o=VZ(m<<2)|0;if((o|0)==0){p=12}else{n=o;break}i=g;return p|0}}while(0);m=n;a:do{if((c[k+60>>2]|0)==0){c[h>>2]=0;o=f&1;q=f&2;r=k+56|0;s=c[r>>2]&4;if((n|0)==0){t=0}else{t=c[l>>2]|0}u=t<<2;v=c[k+52>>2]|0;w=v<<3;x=w+8|0;y=u+12+w+(x+(fa(u,v)|0)<<1)|0;z=VZ(y)|0;if((z|0)==0){A=12;break}B_(z|0,0,y|0)|0;y=z;B=z+u&3;C=((B|0)==0?0:4-B|0)+u|0;B=z+C|0;D=B;E=C+x|0;C=z+E&3;F=((C|0)==0?0:4-C|0)+E|0;E=z+F|0;C=E;G=F+x|0;x=z+G&3;F=((x|0)==0?0:4-x|0)+G|0;G=z+F|0;x=F+w|0;w=z+x&3;if((v|0)>0){F=t<<3;H=0;I=z+(((w|0)==0?0:4-w|0)+x)|0;while(1){c[E+(H<<3)+4>>2]=I;c[B+(H<<3)+4>>2]=I+u;x=H+1|0;if((x|0)<(v|0)){I=I+F|0;H=x}else{J=0;break}}do{c[G+(J<<3)>>2]=-1;J=J+1|0;}while((J|0)<(v|0))}v=ZY(h,b,4)|0;if((v|0)<1){if((v|0)<0){A=1;break}K=v+1|0}else{K=v}v=k+8|0;H=(s|0)==0;F=(o|0)==0;I=(t|0)>0;B=k+12|0;E=k+44|0;x=k+32|0;w=k+36|0;L=(t|0)==0;M=I^1;N=-1;O=0;P=0;Q=K;R=0;S=C;T=D;U=D;V=b+K|0;W=y;while(1){if((N|0)<0){X=c[v>>2]|0;Y=X+8|0;b:do{if((c[Y>>2]|0)==0){Z=N;_=O;$=U}else{aa=(P|0)==0;ba=(R|0)==95;ca=(P|0)<1&F;da=((R|0)!=10|H)^1;ea=Y;ga=N;ha=O;ia=U;ja=X;while(1){ka=ea;la=ja;c:while(1){ma=la+12|0;if((c[G+(c[ma>>2]<<3)>>2]|0)>=(P|0)){na=ga;oa=ha;pa=ia;break}qa=la+20|0;ra=c[qa>>2]|0;if((ra|0)==0){sa=260;break}d:do{if((ra&1|0)==0|ca|da){if((ra&2|0)!=0){ta=c[h>>2]|0;if((ta|q|0)!=0&((ta|0)!=10|H)){break}}do{if((ra&16|0)!=0){if(ba){break d}if((EY(R)|0)!=0){break d}ta=c[h>>2]|0;if((ta|0)==95){break}if((EY(ta)|0)==0){break d}}}while(0);ta=c[qa>>2]|0;if((ta&32|0)==0){ua=ta}else{if(!ba){if((EY(R)|0)==0){break}}ta=c[h>>2]|0;if((ta|0)==95){break}if((EY(ta)|0)!=0){break}ua=c[qa>>2]|0}do{if((ua&64|0)==0|aa){va=ua}else{ta=c[h>>2]|0;if((ta|0)==0){va=ua;break}if(ba){wa=ta;xa=1}else{ta=(EY(R)|0)!=0|0;wa=c[h>>2]|0;xa=ta}if((wa|0)==95){ya=1}else{ya=(EY(wa)|0)!=0|0}if((xa|0)==(ya|0)){break d}va=c[qa>>2]|0}}while(0);if((va&128|0)==0){sa=260;break c}if(aa){break}ta=c[h>>2]|0;if((ta|0)==0){break}if(ba){za=ta;Aa=1}else{ta=(EY(R)|0)!=0|0;za=c[h>>2]|0;Aa=ta}if((za|0)==95){Ba=1}else{Ba=(EY(za)|0)!=0|0}if((Aa|0)==(Ba|0)){sa=260;break c}}}while(0);qa=la+40|0;if((c[qa>>2]|0)==0){Z=ga;_=ha;$=ia;break b}else{ka=qa;la=la+32|0}}if((sa|0)==260){sa=0;qa=ia;c[qa>>2]=c[ka>>2];if(I){B_(c[ia+4>>2]|0,-1,u|0)|0}ra=c[la+16>>2]|0;do{if((ra|0)!=0){ta=c[ra>>2]|0;if(!((ta|0)>-1)){break}Ca=ia+4|0;Da=ta;ta=ra;do{if((Da|0)<(t|0)){c[(c[Ca>>2]|0)+(Da<<2)>>2]=P}ta=ta+4|0;Da=c[ta>>2]|0;}while((Da|0)>-1)}}while(0);ra=(c[qa>>2]|0)!=(c[B>>2]|0);if(ra|M){Ea=ia+4|0;Fa=ra?ga:P;Ga=ra?ha:1}else{ra=ia+4|0;ka=c[ra>>2]|0;Da=0;while(1){c[n+(Da<<2)>>2]=c[ka+(Da<<2)>>2];ta=Da+1|0;if((ta|0)<(t|0)){Da=ta}else{Ea=ra;Fa=P;Ga=1;break}}}c[G+(c[ma>>2]<<3)>>2]=P;c[G+(c[ma>>2]<<3)+4>>2]=Ea;na=Fa;oa=Ga;pa=ia+8|0}ra=la+40|0;if((c[ra>>2]|0)==0){Z=na;_=oa;$=pa;break}else{ea=ra;ga=na;ha=oa;ia=pa;ja=la+32|0}}}}while(0);c[$>>2]=0;Ha=Z;Ia=_}else{if(L|(U|0)==(T|0)){Ja=N;break}else{Ha=N;Ia=O}}X=c[h>>2]|0;if((X|0)==0){Ja=Ha;break}Y=P+Q|0;ja=ZY(h,V,4)|0;if((ja|0)<1){if((ja|0)<0){A=1;break a}Ka=ja+1|0}else{Ka=ja}ja=V+Ka|0;if((c[E>>2]|0)==0|(Ia|0)==0){La=Ia;Ma=T;Na=S}else{ia=T;ha=c[ia>>2]|0;if((ha|0)==0){Oa=S}else{ga=ha;ha=ia;ia=S;while(1){ea=c[w>>2]|0;ba=c[ea>>2]|0;aa=ha+4|0;e:do{if((ba|0)>-1){da=ba;ca=0;while(1){ra=c[ea+((ca|1)<<2)>>2]|0;if((da|0)>=(t|0)){Pa=ia;break e}Da=c[aa>>2]|0;if((c[Da+(ra<<2)>>2]|0)==(c[n+(ra<<2)>>2]|0)){if((c[Da+(da<<2)>>2]|0)<(c[n+(da<<2)>>2]|0)){Pa=ia;break e}}Da=ca+2|0;ra=c[ea+(Da<<2)>>2]|0;if((ra|0)>-1){da=ra;ca=Da}else{sa=287;break}}}else{sa=287}}while(0);if((sa|0)==287){sa=0;c[ia>>2]=ga;ea=ia+4|0;ba=c[ea>>2]|0;c[ea>>2]=c[aa>>2];c[aa>>2]=ba;Pa=ia+8|0}ba=ha+8|0;ea=c[ba>>2]|0;if((ea|0)==0){Oa=Pa;break}else{ga=ea;ha=ba;ia=Pa}}}c[Oa>>2]=0;La=0;Ma=S;Na=T}ia=c[Ma>>2]|0;if((ia|0)==0){Qa=Ha;Ra=La;Sa=Na;Ta=W}else{ha=(Y|0)==0;ga=(X|0)==95;ba=(Y|0)<1&F;ea=((X|0)!=10|H)^1;ca=ia;ia=Ha;da=La;la=Ma;Da=Na;ra=W;while(1){ka=ca+8|0;if((c[ka>>2]|0)==0){Ua=ia;Va=da;Wa=Da;Xa=ra}else{qa=la+4|0;ta=ka;ka=ia;Ca=da;Ya=Da;Za=ra;_a=ca;while(1){f:do{if((c[_a>>2]|0)>>>0>X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za}else{if((c[_a+4>>2]|0)>>>0<X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za;break}db=_a+20|0;eb=c[db>>2]|0;g:do{if((eb|0)!=0){if(!((eb&1|0)==0|ba|ea)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((eb&2|0)!=0){fb=c[h>>2]|0;if((fb|q|0)!=0&((fb|0)!=10|H)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}do{if((eb&16|0)!=0){if(ga){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((EY(X)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==95){break}if((EY(fb)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);fb=c[db>>2]|0;if((fb&32|0)==0){gb=fb}else{if(!ga){if((EY(X)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}fb=c[h>>2]|0;if((fb|0)==95){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((EY(fb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}gb=c[db>>2]|0}do{if((gb&64|0)==0|ha){hb=gb}else{fb=c[h>>2]|0;if((fb|0)==0){hb=gb;break}if(ga){ib=fb;jb=1}else{fb=(EY(X)|0)!=0|0;ib=c[h>>2]|0;jb=fb}if((ib|0)==95){kb=1}else{kb=(EY(ib)|0)!=0|0}if((jb|0)==(kb|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}hb=c[db>>2]|0}}while(0);if((hb&128|0)==0){lb=hb}else{if(ha){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if(ga){mb=fb;nb=1}else{fb=(EY(X)|0)!=0|0;mb=c[h>>2]|0;nb=fb}if((mb|0)==95){ob=1}else{ob=(EY(mb)|0)!=0|0}if((nb|0)!=(ob|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}lb=c[db>>2]|0}do{if((lb&4|0)==0){pb=lb}else{if((c[r>>2]&2|0)!=0){pb=lb;break}if((IY(X,c[_a+24>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}pb=c[db>>2]|0}}while(0);do{if((pb&4|0)!=0){if((c[r>>2]&2|0)==0){break}fb=UY(X)|0;qb=_a+24|0;if((IY(fb,c[qb>>2]|0)|0)!=0){break}fb=SY(X)|0;if((IY(fb,c[qb>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);if((c[db>>2]&8|0)==0){break}qb=c[_a+28>>2]|0;fb=c[qb>>2]|0;if((fb|0)==0){break}if((c[r>>2]&2|0)==0){rb=qb;sb=fb;while(1){if((IY(X,sb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}rb=rb+4|0;sb=c[rb>>2]|0;if((sb|0)==0){break g}}}else{tb=qb}do{sb=SY(X)|0;if((IY(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}sb=UY(X)|0;if((IY(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}tb=tb+4|0;}while((c[tb>>2]|0)!=0)}}while(0);if(I){db=c[qa>>2]|0;eb=0;do{c[Za+(eb<<2)>>2]=c[db+(eb<<2)>>2];eb=eb+1|0;}while((eb|0)<(t|0))}eb=c[_a+16>>2]|0;do{if((eb|0)!=0){db=c[eb>>2]|0;if((db|0)>-1){ub=db;vb=eb}else{break}do{if((ub|0)<(t|0)){c[Za+(ub<<2)>>2]=Y}vb=vb+4|0;ub=c[vb>>2]|0;}while((ub|0)>-1)}}while(0);eb=_a+12|0;db=c[eb>>2]|0;qb=G+(db<<3)|0;if((c[qb>>2]|0)<(Y|0)){sb=Ya;c[sb>>2]=c[ta>>2];rb=Ya+4|0;fb=c[rb>>2]|0;c[rb>>2]=Za;c[qb>>2]=Y;c[G+(c[eb>>2]<<3)+4>>2]=rb;do{if((c[sb>>2]|0)==(c[B>>2]|0)){if((ka|0)==-1){if(!I){wb=Y;xb=1;break}yb=c[rb>>2]|0}else{if(!I){wb=ka;xb=Ca;break}eb=c[rb>>2]|0;if((c[eb>>2]|0)>(c[n>>2]|0)){wb=ka;xb=Ca;break}else{yb=eb}}eb=0;while(1){c[n+(eb<<2)>>2]=c[yb+(eb<<2)>>2];qb=eb+1|0;if((qb|0)<(t|0)){eb=qb}else{wb=Y;xb=1;break}}}else{wb=ka;xb=Ca}}while(0);$a=wb;ab=xb;bb=Ya+8|0;cb=fb;break}else{rb=c[x>>2]|0;sb=c[G+(db<<3)+4>>2]|0;eb=c[sb>>2]|0;if(I){zb=0}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break}while(1){qb=c[Za+(zb<<2)>>2]|0;Ab=c[eb+(zb<<2)>>2]|0;if((c[rb+(zb<<2)>>2]|0)==0){if((qb|0)<(Ab|0)){break}if((qb|0)>(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}else{if((qb|0)>(Ab|0)){break}if((qb|0)<(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}Ab=zb+1|0;if((Ab|0)<(t|0)){zb=Ab}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}c[sb>>2]=Za;if((c[ta>>2]|0)==(c[B>>2]|0)){Bb=0}else{$a=ka;ab=Ca;bb=Ya;cb=eb;break}while(1){c[n+(Bb<<2)>>2]=c[Za+(Bb<<2)>>2];rb=Bb+1|0;if((rb|0)<(t|0)){Bb=rb}else{$a=Y;ab=1;bb=Ya;cb=eb;break}}}}}while(0);eb=_a+40|0;if((c[eb>>2]|0)==0){Ua=$a;Va=ab;Wa=bb;Xa=cb;break}else{ta=eb;ka=$a;Ca=ab;Ya=bb;Za=cb;_a=_a+32|0}}}_a=la+8|0;Za=c[_a>>2]|0;if((Za|0)==0){Qa=Ua;Ra=Va;Sa=Wa;Ta=Xa;break}else{ca=Za;ia=Ua;da=Va;la=_a;Da=Wa;ra=Xa}}}c[Sa>>2]=0;N=Qa;O=Ra;P=Y;Q=Ka;R=X;S=Ma;T=Na;U=Sa;V=ja;W=Ta}WZ(z);Cb=Ja;Db=Ja>>>31;sa=375}else{c[j>>2]=0;W=f&1;V=f&2;U=k+56|0;T=c[U>>2]&4;S=rZ(0,0)|0;if((S|0)==0){A=12;break}R=tZ(S,0,0,0,32)|0;Q=R;if((R|0)==0){sZ(S);A=12;break}c[R+24>>2]=0;c[R+28>>2]=0;R=c[l>>2]|0;if((R|0)==0){Eb=0;sa=9}else{P=VZ(R<<2)|0;O=P;if((P|0)==0){Fb=0;Gb=0;Hb=12;Ib=0;Jb=O}else{Eb=O;sa=9}}do{if((sa|0)==9){O=Eb;P=c[k+28>>2]|0;if((P|0)==0){Kb=0}else{N=VZ(P<<3)|0;P=N;if((N|0)==0){Fb=0;Gb=P;Hb=12;Ib=0;Jb=Eb;break}else{Kb=P}}P=k+52|0;N=c[P>>2]|0;if((N|0)==0){Lb=0}else{B=VZ(N<<2)|0;N=B;if((B|0)==0){Fb=0;Gb=Kb;Hb=12;Ib=N;Jb=Eb;break}else{Lb=N}}N=Lb;B=(n|0)==0;I=k+8|0;G=k+12|0;x=k+32|0;r=(T|0)==0;H=(W|0)==0;q=R;F=-1;w=1;E=-1;L=Q;M=b;h:while(1){do{if((q|0)>0){if(B){B_(O|0,-1,q<<2|0)|0;break}else{u=0;do{c[Eb+(u<<2)>>2]=-1;c[n+(u<<2)>>2]=-1;u=u+1|0;}while((u|0)<(c[l>>2]|0))}}}while(0);u=c[P>>2]|0;if((u|0)>0){B_(N|0,0,u<<2|0)|0}u=c[j>>2]|0;v=w+E|0;y=ZY(j,M,4)|0;if((y|0)<1){if((y|0)<0){A=1;break a}Mb=y+1|0}else{Mb=y}y=M+Mb|0;D=c[j>>2]|0;C=c[I>>2]|0;o=C+8|0;if((c[o>>2]|0)==0){Nb=F;Ob=0;Pb=Mb;Qb=L;sa=196}else{s=(v|0)==0;ra=(u|0)==95;Da=(v|0)<1&H;la=((u|0)!=10|r)^1;da=o;o=0;ia=L;ca=0;ga=C;while(1){C=ga+20|0;ha=c[C>>2]|0;i:do{if((ha|0)==0){sa=56}else{if(!((ha&1|0)==0|Da|la)){Rb=o;Sb=ia;Tb=ca;break}if((ha&2|0)!=0){ea=c[j>>2]|0;if((ea|V|0)!=0&((ea|0)!=10|r)){Rb=o;Sb=ia;Tb=ca;break}}do{if((ha&16|0)!=0){if(ra){Rb=o;Sb=ia;Tb=ca;break i}if((EY(u)|0)!=0){Rb=o;Sb=ia;Tb=ca;break i}ea=c[j>>2]|0;if((ea|0)==95){break}if((EY(ea)|0)==0){Rb=o;Sb=ia;Tb=ca;break i}}}while(0);ea=c[C>>2]|0;if((ea&32|0)==0){Ub=ea}else{if(!ra){if((EY(u)|0)==0){Rb=o;Sb=ia;Tb=ca;break}}ea=c[j>>2]|0;if((ea|0)==95){Rb=o;Sb=ia;Tb=ca;break}if((EY(ea)|0)!=0){Rb=o;Sb=ia;Tb=ca;break}Ub=c[C>>2]|0}do{if((Ub&64|0)==0|s){Vb=Ub}else{ea=c[j>>2]|0;if((ea|0)==0){Vb=Ub;break}if(ra){Wb=ea;Xb=1}else{ea=(EY(u)|0)!=0|0;Wb=c[j>>2]|0;Xb=ea}if((Wb|0)==95){Yb=1}else{Yb=(EY(Wb)|0)!=0|0}if((Xb|0)==(Yb|0)){Rb=o;Sb=ia;Tb=ca;break i}Vb=c[C>>2]|0}}while(0);if((Vb&128|0)==0){sa=56;break}if(s){Rb=o;Sb=ia;Tb=ca;break}ea=c[j>>2]|0;if((ea|0)==0){Rb=o;Sb=ia;Tb=ca;break}if(ra){Zb=ea;_b=1}else{ea=(EY(u)|0)!=0|0;Zb=c[j>>2]|0;_b=ea}if((Zb|0)==95){$b=1}else{$b=(EY(Zb)|0)!=0|0}if((_b|0)==($b|0)){sa=56}else{Rb=o;Sb=ia;Tb=ca}}}while(0);do{if((sa|0)==56){sa=0;if((ca|0)==0){Rb=c[ga+16>>2]|0;Sb=ia;Tb=c[da>>2]|0;break}C=ia+28|0;ha=c[C>>2]|0;if((ha|0)==0){ea=tZ(S,0,0,0,32)|0;ba=ea;if((ea|0)==0){sa=60;break h}c[ea+24>>2]=ia;c[ea+28>>2]=0;_a=tZ(S,0,0,0,c[l>>2]<<2)|0;c[ea+20>>2]=_a;if((_a|0)==0){sa=67;break h}c[C>>2]=ba;ac=ba}else{ac=ha}c[ac>>2]=v;c[ac+4>>2]=y;c[ac+8>>2]=c[da>>2];c[ac+12>>2]=c[ga+12>>2];c[ac+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ha=c[ac+20>>2]|0;ba=0;do{c[ha+(ba<<2)>>2]=c[Eb+(ba<<2)>>2];ba=ba+1|0;}while((ba|0)<(c[l>>2]|0))}ba=c[ga+16>>2]|0;if((ba|0)==0){Rb=o;Sb=ac;Tb=ca;break}ha=c[ba>>2]|0;if(!((ha|0)>-1)){Rb=o;Sb=ac;Tb=ca;break}C=c[ac+20>>2]|0;_a=ha;ha=ba;while(1){ba=ha+4|0;c[C+(_a<<2)>>2]=v;ea=c[ba>>2]|0;if((ea|0)>-1){ha=ba;_a=ea}else{Rb=o;Sb=ac;Tb=ca;break}}}}while(0);_a=ga+40|0;if((c[_a>>2]|0)==0){break}else{da=_a;o=Rb;ia=Sb;ca=Tb;ga=ga+32|0}}do{if((Rb|0)==0){bc=0}else{ga=c[Rb>>2]|0;if((ga|0)>-1){cc=ga;dc=Rb}else{bc=Rb;break}while(1){c[Eb+(cc<<2)>>2]=v;ga=dc+4|0;ca=c[ga>>2]|0;if((ca|0)>-1){dc=ga;cc=ca}else{bc=ga;break}}}}while(0);if((Tb|0)==0){Nb=F;Ob=bc;Pb=Mb;Qb=Sb;sa=196}else{ec=F;fc=bc;gc=v;hc=Mb;ic=Sb;jc=Tb;kc=y}}j:while(1){if((sa|0)==196){sa=0;ga=c[Qb+24>>2]|0;if((ga|0)==0){break}ca=c[Qb+8>>2]|0;if((c[ca+20>>2]&256|0)!=0){c[Lb+(c[Qb+12>>2]<<2)>>2]=0}ia=c[Qb>>2]|0;o=c[Qb+4>>2]|0;c[j>>2]=c[Qb+16>>2];da=c[l>>2]|0;if((da|0)<=0){ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue}u=c[Qb+20>>2]|0;ra=0;while(1){c[Eb+(ra<<2)>>2]=c[u+(ra<<2)>>2];s=ra+1|0;if((s|0)<(da|0)){ra=s}else{ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue j}}}if((jc|0)==(c[G>>2]|0)){lc=fc;mc=gc;nc=hc;oc=ic}else{o=fc;ca=gc;ga=hc;ia=ic;ra=jc;da=kc;while(1){u=ra+8|0;do{if((c[u>>2]|0)==0){sa=109}else{if((c[ra+20>>2]&256|0)==0){sa=109;break}s=c[ra+24>>2]|0;qZ(s+1|0,Kb,c[U>>2]&-9,a,Eb,ca);la=c[Kb+(s<<3)>>2]|0;Da=c[Kb+(s<<3)+4>>2]|0;s=Da-la|0;if((u_(b+la|0,da+ -1|0,s)|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}_a=(Da|0)==(la|0);la=_a&1;Da=Lb+(c[ra+12>>2]<<2)|0;if(_a){if((c[Da>>2]|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}}c[Da>>2]=la;la=s+ -1|0;s=la+ca|0;Da=c[j>>2]|0;_a=ZY(j,da+la|0,4)|0;if((_a|0)<1){if((_a|0)<0){A=1;break a}pc=_a+1|0}else{pc=_a}qc=s;rc=pc+la|0;sc=pc;tc=Da}}while(0);do{if((sa|0)==109){sa=0;Da=c[j>>2]|0;if((Da|0)==0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}la=ZY(j,da,4)|0;if((la|0)>=1){qc=ca;rc=la;sc=la;tc=Da;break}if((la|0)<0){A=1;break a}s=la+1|0;qc=ca;rc=s;sc=s;tc=Da}}while(0);Da=da+rc|0;s=qc+ga|0;if((c[u>>2]|0)==0){Nb=ec;Ob=o;Pb=sc;Qb=ia;sa=196;continue j}la=(s|0)==0;_a=(tc|0)==95;ha=(s|0)<1&H;C=((tc|0)!=10|r)^1;ea=u;ba=0;Za=o;Ya=ia;Ca=ra;while(1){k:do{if((c[Ca>>2]|0)>>>0>tc>>>0){uc=ba;vc=Za;wc=Ya}else{if((c[Ca+4>>2]|0)>>>0<tc>>>0){uc=ba;vc=Za;wc=Ya;break}ka=Ca+20|0;ta=c[ka>>2]|0;l:do{if((ta|0)!=0){if(!((ta&1|0)==0|ha|C)){uc=ba;vc=Za;wc=Ya;break k}if((ta&2|0)!=0){qa=c[j>>2]|0;if((qa|V|0)!=0&((qa|0)!=10|r)){uc=ba;vc=Za;wc=Ya;break k}}do{if((ta&16|0)!=0){if(_a){uc=ba;vc=Za;wc=Ya;break k}if((EY(tc)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==95){break}if((EY(qa)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);qa=c[ka>>2]|0;if((qa&32|0)==0){xc=qa}else{if(!_a){if((EY(tc)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}qa=c[j>>2]|0;if((qa|0)==95){uc=ba;vc=Za;wc=Ya;break k}if((EY(qa)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}xc=c[ka>>2]|0}do{if((xc&64|0)==0|la){yc=xc}else{qa=c[j>>2]|0;if((qa|0)==0){yc=xc;break}if(_a){zc=qa;Ac=1}else{qa=(EY(tc)|0)!=0|0;zc=c[j>>2]|0;Ac=qa}if((zc|0)==95){Bc=1}else{Bc=(EY(zc)|0)!=0|0}if((Ac|0)==(Bc|0)){uc=ba;vc=Za;wc=Ya;break k}yc=c[ka>>2]|0}}while(0);if((yc&128|0)==0){Cc=yc}else{if(la){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==0){uc=ba;vc=Za;wc=Ya;break k}if(_a){Dc=qa;Ec=1}else{qa=(EY(tc)|0)!=0|0;Dc=c[j>>2]|0;Ec=qa}if((Dc|0)==95){Fc=1}else{Fc=(EY(Dc)|0)!=0|0}if((Ec|0)!=(Fc|0)){uc=ba;vc=Za;wc=Ya;break k}Cc=c[ka>>2]|0}do{if((Cc&4|0)==0){Gc=Cc}else{if((c[U>>2]&2|0)!=0){Gc=Cc;break}if((IY(tc,c[Ca+24>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}Gc=c[ka>>2]|0}}while(0);do{if((Gc&4|0)!=0){if((c[U>>2]&2|0)==0){break}qa=UY(tc)|0;aa=Ca+24|0;if((IY(qa,c[aa>>2]|0)|0)!=0){break}qa=SY(tc)|0;if((IY(qa,c[aa>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);if((c[ka>>2]&8|0)==0){break}aa=c[Ca+28>>2]|0;qa=c[aa>>2]|0;if((qa|0)==0){break}if((c[U>>2]&2|0)==0){eb=aa;sb=qa;while(1){if((IY(tc,sb)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}eb=eb+4|0;sb=c[eb>>2]|0;if((sb|0)==0){break l}}}else{Hc=aa}do{sb=SY(tc)|0;if((IY(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}sb=UY(tc)|0;if((IY(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}Hc=Hc+4|0;}while((c[Hc>>2]|0)!=0)}}while(0);if((ba|0)==0){uc=c[ea>>2]|0;vc=c[Ca+16>>2]|0;wc=Ya;break}ka=Ya+28|0;ta=c[ka>>2]|0;if((ta|0)==0){aa=tZ(S,0,0,0,32)|0;sb=aa;if((aa|0)==0){sa=169;break h}c[aa+24>>2]=Ya;c[aa+28>>2]=0;eb=tZ(S,0,0,0,c[l>>2]<<2)|0;c[aa+20>>2]=eb;if((eb|0)==0){sa=176;break h}c[ka>>2]=sb;Ic=sb}else{Ic=ta}c[Ic>>2]=s;c[Ic+4>>2]=Da;c[Ic+8>>2]=c[ea>>2];c[Ic+12>>2]=c[Ca+12>>2];c[Ic+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ta=c[Ic+20>>2]|0;sb=0;do{c[ta+(sb<<2)>>2]=c[Eb+(sb<<2)>>2];sb=sb+1|0;}while((sb|0)<(c[l>>2]|0))}sb=c[Ca+16>>2]|0;if((sb|0)==0){uc=ba;vc=Za;wc=Ic;break}ta=c[sb>>2]|0;if(!((ta|0)>-1)){uc=ba;vc=Za;wc=Ic;break}ka=c[Ic+20>>2]|0;eb=ta;ta=sb;while(1){c[ka+(eb<<2)>>2]=s;sb=ta+4|0;aa=c[sb>>2]|0;if((aa|0)>-1){ta=sb;eb=aa}else{uc=ba;vc=Za;wc=Ic;break}}}}while(0);eb=Ca+40|0;if((c[eb>>2]|0)==0){break}else{ea=eb;ba=uc;Za=vc;Ya=wc;Ca=Ca+32|0}}if((uc|0)==0){Nb=ec;Ob=vc;Pb=sc;Qb=wc;sa=196;continue j}do{if((vc|0)==0){Jc=0}else{Ca=c[vc>>2]|0;if((Ca|0)>-1){Kc=Ca;Lc=vc}else{Jc=vc;break}while(1){Ca=Lc+4|0;c[Eb+(Kc<<2)>>2]=s;Ya=c[Ca>>2]|0;if((Ya|0)>-1){Lc=Ca;Kc=Ya}else{Jc=Ca;break}}}}while(0);if((uc|0)==(c[G>>2]|0)){lc=Jc;mc=s;nc=sc;oc=wc;break}else{o=Jc;ca=s;ga=sc;ia=wc;ra=uc;da=Da}}}m:do{if((ec|0)<(mc|0)){sa=96}else{if((ec|0)!=(mc|0)|B){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}da=c[l>>2]|0;ra=c[x>>2]|0;if((da|0)>0){Mc=0}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}while(1){ia=c[Eb+(Mc<<2)>>2]|0;ga=c[n+(Mc<<2)>>2]|0;if((c[ra+(Mc<<2)>>2]|0)==0){if((ia|0)<(ga|0)){sa=96;break m}if((ia|0)>(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}else{if((ia|0)>(ga|0)){Nc=da;break m}if((ia|0)<(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}ga=Mc+1|0;if((ga|0)<(da|0)){Mc=ga}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}}while(0);if((sa|0)==96){sa=0;if(B){Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}Nc=c[l>>2]|0}if((Nc|0)>0){Oc=0}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}while(1){c[n+(Oc<<2)>>2]=c[Eb+(Oc<<2)>>2];da=Oc+1|0;if((da|0)<(c[l>>2]|0)){Oc=da}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}if((Nb|0)>=0){sa=205;break}if((c[j>>2]|0)==0){sa=205;break}c[j>>2]=D;q=c[l>>2]|0;F=Nb;w=Pb;E=v;L=Qb;M=y}if((sa|0)==60){sZ(S);if((Eb|0)!=0){WZ(O)}if((Kb|0)!=0){WZ(Kb)}if((Lb|0)==0){A=12;break a}WZ(N);A=12;break a}else if((sa|0)==67){sZ(S);if((Eb|0)!=0){WZ(O)}if((Kb|0)!=0){WZ(Kb)}if((Lb|0)==0){A=12;break a}WZ(N);A=12;break a}else if((sa|0)==169){sZ(S);if((Eb|0)!=0){WZ(O)}if((Kb|0)!=0){WZ(Kb)}if((Lb|0)==0){A=12;break a}WZ(N);A=12;break a}else if((sa|0)==176){sZ(S);if((Eb|0)!=0){WZ(O)}if((Kb|0)!=0){WZ(Kb)}if((Lb|0)==0){A=12;break a}WZ(N);A=12;break a}else if((sa|0)==205){Fb=Nb;Gb=Kb;Hb=Nb>>>31;Ib=Lb;Jb=Eb;break}}}while(0);sZ(S);if((Jb|0)!=0){WZ(Jb)}if((Gb|0)!=0){WZ(Gb)}if((Ib|0)==0){Cb=Fb;Db=Hb;sa=375;break}WZ(Ib);Cb=Fb;Db=Hb;sa=375}}while(0);do{if((sa|0)==375){if((Db|0)!=0){A=Db;break}qZ(d,e,c[k+56>>2]|0,a,n,Cb);A=0}}while(0);if((n|0)==0){p=A;i=g;return p|0}WZ(m);p=A;i=g;return p|0}function qZ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;do{if((g|0)>-1){if((d&8|0)!=0){j=0;break}k=c[e+16>>2]|0;l=e+28|0;m=c[l>>2]|0;n=(a|0)!=0;if((m|0)!=0&n){o=e+48|0;p=0;while(1){q=c[k+(p*12|0)>>2]|0;if((q|0)==(c[o>>2]|0)){c[b+(p<<3)>>2]=g;r=g}else{s=c[f+(q<<2)>>2]|0;c[b+(p<<3)>>2]=s;r=s}s=c[k+(p*12|0)+4>>2]|0;if((s|0)==(c[o>>2]|0)){c[b+(p<<3)+4>>2]=g;t=g}else{q=c[f+(s<<2)>>2]|0;c[b+(p<<3)+4>>2]=q;t=q}if((r|0)==-1|(t|0)==-1){c[b+(p<<3)+4>>2]=-1;c[b+(p<<3)>>2]=-1}q=p+1|0;s=c[l>>2]|0;if(q>>>0<s>>>0&q>>>0<a>>>0){p=q}else{u=s;break}}}else{u=m}if((u|0)!=0&n){v=u;w=0}else{j=0;break}while(1){p=b+(w<<3)+4|0;o=c[k+(w*12|0)+8>>2]|0;do{if((o|0)==0){x=v}else{s=c[o>>2]|0;if(!((s|0)>-1)){x=v;break}q=b+(w<<3)|0;y=c[q>>2]|0;z=s;s=0;while(1){if((y|0)<(c[b+(z<<3)>>2]|0)){A=21}else{if((c[p>>2]|0)>(c[b+(z<<3)+4>>2]|0)){A=21}else{B=y}}if((A|0)==21){A=0;c[p>>2]=-1;c[q>>2]=-1;B=-1}C=s+1|0;D=c[o+(C<<2)>>2]|0;if((D|0)>-1){y=B;z=D;s=C}else{break}}x=c[l>>2]|0}}while(0);o=w+1|0;if(o>>>0<x>>>0&o>>>0<a>>>0){v=x;w=o}else{j=o;break}}}else{j=0}}while(0);if(j>>>0<a>>>0){E=j}else{i=h;return}do{c[b+(E<<3)>>2]=-1;c[b+(E<<3)+4>>2]=-1;E=E+1|0;}while(E>>>0<a>>>0);i=h;return}function rZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)==0){e=XZ(1,24)|0}else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;e=b}if((e|0)==0){f=0;i=d;return f|0}f=e;i=d;return f|0}function sZ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;if((d|0)==0){e=a;WZ(e);i=b;return}else{f=d}while(1){WZ(c[f>>2]|0);d=c[f+4>>2]|0;WZ(f);if((d|0)==0){break}else{f=d}}e=a;WZ(e);i=b;return}function tZ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=a+16|0;if((c[h>>2]|0)!=0){j=0;i=g;return j|0}k=a+12|0;l=c[k>>2]|0;do{if(l>>>0<f>>>0){if((b|0)!=0){if((d|0)!=0){c[a+8>>2]=d;c[k>>2]=1024;m=d;n=1024;break}c[h>>2]=1;j=0;i=g;return j|0}o=f<<3;p=o>>>0>1024?o:1024;o=VZ(8)|0;q=o;if((o|0)==0){c[h>>2]=1;j=0;i=g;return j|0}r=VZ(p)|0;c[o>>2]=r;if((r|0)==0){WZ(o);c[h>>2]=1;j=0;i=g;return j|0}c[o+4>>2]=0;r=a+4|0;s=c[r>>2]|0;if((s|0)!=0){c[s+4>>2]=q}s=a;if((c[s>>2]|0)==0){c[s>>2]=q}c[r>>2]=q;q=c[o>>2]|0;c[a+8>>2]=q;c[k>>2]=p;m=q;n=p}else{m=c[a+8>>2]|0;n=l}}while(0);l=m+f&3;h=((l|0)==0?0:4-l|0)+f|0;c[a+8>>2]=m+h;c[k>>2]=n-h;if((e|0)==0){j=m;i=g;return j|0}B_(m|0,0,h|0)|0;j=m;i=g;return j|0}function uZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==0){e=a+((vZ(a)|0)<<2)|0;i=d;return e|0}else{f=a}while(1){g=c[f>>2]|0;if((g|0)==0|(g|0)==(b|0)){break}else{f=f+4|0}}e=(g|0)!=0?f:0;i=d;return e|0}function vZ(a){a=a|0;var b=0,d=0;b=i;d=a;while(1){if((c[d>>2]|0)==0){break}else{d=d+4|0}}i=b;return d-a>>2|0}function wZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=b;h=a}while(1){b=f+ -1|0;c[h>>2]=c[g>>2];if((b|0)==0){break}else{h=h+4|0;g=g+4|0;f=b}}i=e;return a|0}function xZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(f){i=e;return a|0}else{g=d}do{g=g+ -1|0;c[a+(g<<2)>>2]=c[b+(g<<2)>>2];}while((g|0)!=0);i=e;return a|0}else{if(f){i=e;return a|0}else{h=b;j=a;k=d}while(1){d=k+ -1|0;c[j>>2]=c[h>>2];if((d|0)==0){break}else{k=d;j=j+4|0;h=h+4|0}}i=e;return a|0}return 0}function yZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=a}while(1){d=f+ -1|0;c[g>>2]=b;if((d|0)==0){break}else{g=g+4|0;f=d}}i=e;return a|0}function zZ(a){a=a|0;i=i;return}function AZ(a){a=a|0;c[a>>2]=122064;i=i;return}function BZ(a){a=a|0;var b=0;b=i;wb(a|0);b_(a);i=b;return}function CZ(a){a=a|0;var b=0;b=i;wb(a|0);i=b;return}function DZ(a){a=a|0;i=i;return 122080}function EZ(a){a=a|0;i=i;return}function FZ(a){a=a|0;i=i;return}function GZ(a){a=a|0;i=i;return}function HZ(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function IZ(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function JZ(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function KZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+56|0;f=e;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=OZ(b,122192,122248,0)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}j=f+0|0;k=j+56|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;Be[c[(c[h>>2]|0)+28>>2]&31](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function LZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((c[d+8>>2]|0)!=(b|0)){i=g;return}b=d+16|0;h=c[b>>2]|0;if((h|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function MZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((b|0)!=(c[d+8>>2]|0)){h=c[b+8>>2]|0;Be[c[(c[h>>2]|0)+28>>2]&31](h,d,e,f);i=g;return}h=d+16|0;b=c[h>>2]|0;if((b|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function NZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((b|0)==(c[d+8>>2]|0)){h=d+16|0;j=c[h>>2]|0;if((j|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((j|0)!=(e|0)){j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}j=d+24|0;if((c[j>>2]|0)!=2){i=g;return}c[j>>2]=f;i=g;return}j=c[b+12>>2]|0;h=b+16+(j<<3)|0;k=c[b+20>>2]|0;l=k>>8;if((k&1|0)==0){m=l}else{m=c[(c[e>>2]|0)+l>>2]|0}l=c[b+16>>2]|0;Be[c[(c[l>>2]|0)+28>>2]&31](l,d,e+m|0,(k&2|0)!=0?f:2);if((j|0)<=1){i=g;return}j=d+54|0;k=b+24|0;while(1){b=c[k+4>>2]|0;m=b>>8;if((b&1|0)==0){n=m}else{n=c[(c[e>>2]|0)+m>>2]|0}m=c[k>>2]|0;Be[c[(c[m>>2]|0)+28>>2]&31](m,d,e+n|0,(b&2|0)!=0?f:2);if((a[j]|0)!=0){o=16;break}b=k+8|0;if(b>>>0<h>>>0){k=b}else{o=16;break}}if((o|0)==16){i=g;return}}function OZ(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+56|0;j=h;k=c[d>>2]|0;l=d+(c[k+ -8>>2]|0)|0;m=c[k+ -4>>2]|0;k=m;c[j>>2]=f;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=g;g=j+16|0;e=j+20|0;d=j+24|0;n=j+28|0;o=j+32|0;p=j+40|0;q=(m|0)==(f|0);f=g;r=f+0|0;s=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));b[f+36>>1]=0;a[f+38|0]=0;if(q){c[j+48>>2]=1;me[c[(c[m>>2]|0)+20>>2]&31](k,j,l,l,1,0);t=(c[d>>2]|0)==1?l:0;i=h;return t|0}_d[c[(c[m>>2]|0)+24>>2]&31](k,j,l,1,0);l=c[j+36>>2]|0;if((l|0)==1){do{if((c[d>>2]|0)!=1){if((c[p>>2]|0)!=0){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}if((c[o>>2]|0)==1){break}else{t=0}i=h;return t|0}}while(0);t=c[g>>2]|0;i=h;return t|0}else if((l|0)==0){if((c[p>>2]|0)!=1){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}t=(c[o>>2]|0)==1?c[e>>2]|0:0;i=h;return t|0}else{t=0;i=h;return t|0}return 0}function PZ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=c[b+12>>2]|0;m=b+16+(l<<3)|0;a:do{if((l|0)>0){n=d+52|0;o=d+53|0;p=d+54|0;q=b+8|0;r=d+24|0;s=0;t=0;u=b+16|0;b:while(1){a[n]=0;a[o]=0;v=c[u+4>>2]|0;w=v>>8;if((v&1|0)==0){x=w}else{x=c[(c[e>>2]|0)+w>>2]|0}w=c[u>>2]|0;me[c[(c[w>>2]|0)+20>>2]&31](w,d,e,e+x|0,2-(v>>>1&1)|0,g);if((a[p]|0)!=0){y=s;z=t;break}do{if((a[o]|0)==0){A=s;B=t}else{if((a[n]|0)==0){if((c[q>>2]&1|0)==0){y=s;z=1;break b}else{A=s;B=1;break}}if((c[r>>2]|0)==1){C=27;break a}if((c[q>>2]&2|0)==0){C=27;break a}else{A=1;B=1}}}while(0);v=u+8|0;if(v>>>0<m>>>0){s=A;t=B;u=v}else{y=A;z=B;break}}if(y){D=z;C=26}else{E=z;C=23}}else{E=0;C=23}}while(0);do{if((C|0)==23){c[j>>2]=e;m=d+40|0;c[m>>2]=(c[m>>2]|0)+1;if((c[d+36>>2]|0)!=1){D=E;C=26;break}if((c[d+24>>2]|0)!=2){D=E;C=26;break}a[d+54|0]=1;if(E){C=27}else{C=28}}}while(0);if((C|0)==26){if(D){C=27}else{C=28}}if((C|0)==27){c[k>>2]=3;i=h;return}else if((C|0)==28){c[k>>2]=4;i=h;return}}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}D=c[b+12>>2]|0;E=b+16+(D<<3)|0;z=c[b+20>>2]|0;y=z>>8;if((z&1|0)==0){F=y}else{F=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;_d[c[(c[y>>2]|0)+24>>2]&31](y,d,e+F|0,(z&2|0)!=0?f:2,g);z=b+24|0;if((D|0)<=1){i=h;return}D=c[b+8>>2]|0;do{if((D&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((D&1|0)==0){F=d+54|0;y=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){C=53;break}B=c[y+4>>2]|0;A=B>>8;if((B&1|0)==0){G=A}else{G=c[(c[e>>2]|0)+A>>2]|0}A=c[y>>2]|0;_d[c[(c[A>>2]|0)+24>>2]&31](A,d,e+G|0,(B&2|0)!=0?f:2,g);B=y+8|0;if(B>>>0<E>>>0){y=B}else{C=53;break}}if((C|0)==53){i=h;return}}y=d+24|0;F=d+54|0;k=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){if((c[y>>2]|0)==1){C=53;break}}B=c[k+4>>2]|0;A=B>>8;if((B&1|0)==0){H=A}else{H=c[(c[e>>2]|0)+A>>2]|0}A=c[k>>2]|0;_d[c[(c[A>>2]|0)+24>>2]&31](A,d,e+H|0,(B&2|0)!=0?f:2,g);B=k+8|0;if(B>>>0<E>>>0){k=B}else{C=53;break}}if((C|0)==53){i=h;return}}}while(0);H=d+54|0;G=z;while(1){if((a[H]|0)!=0){C=53;break}z=c[G+4>>2]|0;D=z>>8;if((z&1|0)==0){I=D}else{I=c[(c[e>>2]|0)+D>>2]|0}D=c[G>>2]|0;_d[c[(c[D>>2]|0)+24>>2]&31](D,d,e+I|0,(z&2|0)!=0?f:2,g);z=G+8|0;if(z>>>0<E>>>0){G=z}else{C=53;break}}if((C|0)==53){i=h;return}}function QZ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;_d[c[(c[j>>2]|0)+24>>2]&31](j,d,e,f,g);i=h;return}do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=d+52|0;a[l]=0;m=d+53|0;a[m]=0;n=c[b+8>>2]|0;me[c[(c[n>>2]|0)+20>>2]&31](n,d,e,e,1,g);if((a[m]|0)==0){o=0;p=13}else{if((a[l]|0)==0){o=1;p=13}}a:do{if((p|0)==13){c[j>>2]=e;l=d+40|0;c[l>>2]=(c[l>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){p=16;break}a[d+54|0]=1;if(o){break a}}else{p=16}}while(0);if((p|0)==16){if(o){break}}c[k>>2]=4;i=h;return}}while(0);c[k>>2]=3;i=h;return}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function RZ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){i=g;return}h=d+28|0;if((c[h>>2]|0)==1){i=g;return}c[h>>2]=f;i=g;return}if((c[d>>2]|0)!=(b|0)){i=g;return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;i=g;return}}while(0);if((f|0)!=1){i=g;return}c[d+32>>2]=1;i=g;return}function SZ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=d+52|0;l=a[k]|0;m=d+53|0;n=a[m]|0;o=c[b+12>>2]|0;p=b+16+(o<<3)|0;a[k]=0;a[m]=0;q=c[b+20>>2]|0;r=q>>8;if((q&1|0)==0){s=r}else{s=c[(c[f>>2]|0)+r>>2]|0}r=c[b+16>>2]|0;me[c[(c[r>>2]|0)+20>>2]&31](r,d,e,f+s|0,(q&2|0)!=0?g:2,h);a:do{if((o|0)>1){q=d+24|0;s=b+8|0;r=d+54|0;t=b+24|0;do{if((a[r]|0)!=0){break a}do{if((a[k]|0)==0){if((a[m]|0)==0){break}if((c[s>>2]&1|0)==0){break a}}else{if((c[q>>2]|0)==1){break a}if((c[s>>2]&2|0)==0){break a}}}while(0);a[k]=0;a[m]=0;u=c[t+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[f>>2]|0)+v>>2]|0}v=c[t>>2]|0;me[c[(c[v>>2]|0)+20>>2]&31](v,d,e,f+w|0,(u&2|0)!=0?g:2,h);t=t+8|0;}while(t>>>0<p>>>0)}}while(0);a[k]=l;a[m]=n;i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;n=c[f>>2]|0;if((n|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((n|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;n=c[e>>2]|0;if((n|0)==2){c[e>>2]=g;x=g}else{x=n}if(!((c[d+48>>2]|0)==1&(x|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function TZ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=c[b+8>>2]|0;me[c[(c[k>>2]|0)+20>>2]&31](k,d,e,f,g,h);i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;l=g}else{l=h}if(!((c[d+48>>2]|0)==1&(l|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function UZ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;if((c[d+8>>2]|0)!=(b|0)){i=h;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=h;return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=h;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;j=g}else{j=b}if(!((c[d+48>>2]|0)==1&(j|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}function VZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;b=i;do{if(a>>>0<245){if(a>>>0<11){d=16}else{d=a+11&-8}e=d>>>3;f=c[30624]|0;g=f>>>e;if((g&3|0)!=0){h=(g&1^1)+e|0;j=h<<1;k=122536+(j<<2)|0;l=122536+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do{if((k|0)==(n|0)){c[30624]=f&~(1<<h)}else{if(n>>>0<(c[122512>>2]|0)>>>0){ed()}o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else{ed()}}}while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}if(!(d>>>0>(c[122504>>2]|0)>>>0)){q=d;break}if((g|0)!=0){l=2<<e;n=g<<e&(l|0-l);l=(n&0-n)+ -1|0;n=l>>>12&16;k=l>>>n;l=k>>>5&8;o=k>>>l;k=o>>>2&4;r=o>>>k;o=r>>>1&2;s=r>>>o;r=s>>>1&1;t=(l|n|k|o|r)+(s>>>r)|0;r=t<<1;s=122536+(r<<2)|0;o=122536+(r+2<<2)|0;r=c[o>>2]|0;k=r+8|0;n=c[k>>2]|0;do{if((s|0)==(n|0)){c[30624]=f&~(1<<t)}else{if(n>>>0<(c[122512>>2]|0)>>>0){ed()}l=n+12|0;if((c[l>>2]|0)==(r|0)){c[l>>2]=s;c[o>>2]=n;break}else{ed()}}}while(0);n=t<<3;o=n-d|0;c[r+4>>2]=d|3;s=r+d|0;c[r+(d|4)>>2]=o|1;c[r+n>>2]=o;n=c[122504>>2]|0;if((n|0)!=0){f=c[122516>>2]|0;e=n>>>3;n=e<<1;g=122536+(n<<2)|0;m=c[30624]|0;j=1<<e;do{if((m&j|0)==0){c[30624]=m|j;u=122536+(n+2<<2)|0;v=g}else{e=122536+(n+2<<2)|0;h=c[e>>2]|0;if(!(h>>>0<(c[122512>>2]|0)>>>0)){u=e;v=h;break}ed()}}while(0);c[u>>2]=f;c[v+12>>2]=f;c[f+8>>2]=v;c[f+12>>2]=g}c[122504>>2]=o;c[122516>>2]=s;p=k;i=b;return p|0}n=c[122500>>2]|0;if((n|0)==0){q=d;break}j=(n&0-n)+ -1|0;n=j>>>12&16;m=j>>>n;j=m>>>5&8;r=m>>>j;m=r>>>2&4;t=r>>>m;r=t>>>1&2;h=t>>>r;t=h>>>1&1;e=c[122800+((j|n|m|r|t)+(h>>>t)<<2)>>2]|0;t=(c[e+4>>2]&-8)-d|0;h=e;r=e;while(1){e=c[h+16>>2]|0;if((e|0)==0){m=c[h+20>>2]|0;if((m|0)==0){break}else{w=m}}else{w=e}e=(c[w+4>>2]&-8)-d|0;m=e>>>0<t>>>0;t=m?e:t;h=w;r=m?w:r}h=r;k=c[122512>>2]|0;if(h>>>0<k>>>0){ed()}s=r+d|0;o=s;if(!(h>>>0<s>>>0)){ed()}s=c[r+24>>2]|0;h=c[r+12>>2]|0;do{if((h|0)==(r|0)){g=r+20|0;f=c[g>>2]|0;if((f|0)==0){m=r+16|0;e=c[m>>2]|0;if((e|0)==0){x=0;break}else{y=e;z=m}}else{y=f;z=g}while(1){g=y+20|0;f=c[g>>2]|0;if((f|0)!=0){z=g;y=f;continue}f=y+16|0;g=c[f>>2]|0;if((g|0)==0){break}else{y=g;z=f}}if(z>>>0<k>>>0){ed()}else{c[z>>2]=0;x=y;break}}else{f=c[r+8>>2]|0;if(f>>>0<k>>>0){ed()}g=f+12|0;if((c[g>>2]|0)!=(r|0)){ed()}m=h+8|0;if((c[m>>2]|0)==(r|0)){c[g>>2]=h;c[m>>2]=f;x=h;break}else{ed()}}}while(0);a:do{if((s|0)!=0){h=c[r+28>>2]|0;k=122800+(h<<2)|0;do{if((r|0)==(c[k>>2]|0)){c[k>>2]=x;if((x|0)!=0){break}c[122500>>2]=c[122500>>2]&~(1<<h);break a}else{if(s>>>0<(c[122512>>2]|0)>>>0){ed()}f=s+16|0;if((c[f>>2]|0)==(r|0)){c[f>>2]=x}else{c[s+20>>2]=x}if((x|0)==0){break a}}}while(0);if(x>>>0<(c[122512>>2]|0)>>>0){ed()}c[x+24>>2]=s;h=c[r+16>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[122512>>2]|0)>>>0){ed()}else{c[x+16>>2]=h;c[h+24>>2]=x;break}}}while(0);h=c[r+20>>2]|0;if((h|0)==0){break}if(h>>>0<(c[122512>>2]|0)>>>0){ed()}else{c[x+20>>2]=h;c[h+24>>2]=x;break}}}while(0);if(t>>>0<16){s=t+d|0;c[r+4>>2]=s|3;h=r+(s+4)|0;c[h>>2]=c[h>>2]|1}else{c[r+4>>2]=d|3;c[r+(d|4)>>2]=t|1;c[r+(t+d)>>2]=t;h=c[122504>>2]|0;if((h|0)!=0){s=c[122516>>2]|0;k=h>>>3;h=k<<1;f=122536+(h<<2)|0;m=c[30624]|0;g=1<<k;do{if((m&g|0)==0){c[30624]=m|g;A=122536+(h+2<<2)|0;B=f}else{k=122536+(h+2<<2)|0;e=c[k>>2]|0;if(!(e>>>0<(c[122512>>2]|0)>>>0)){A=k;B=e;break}ed()}}while(0);c[A>>2]=s;c[B+12>>2]=s;c[s+8>>2]=B;c[s+12>>2]=f}c[122504>>2]=t;c[122516>>2]=o}p=r+8|0;i=b;return p|0}else{if(a>>>0>4294967231){q=-1;break}h=a+11|0;g=h&-8;m=c[122500>>2]|0;if((m|0)==0){q=g;break}e=0-g|0;k=h>>>8;do{if((k|0)==0){C=0}else{if(g>>>0>16777215){C=31;break}h=(k+1048320|0)>>>16&8;n=k<<h;j=(n+520192|0)>>>16&4;l=n<<j;n=(l+245760|0)>>>16&2;D=14-(j|h|n)+(l<<n>>>15)|0;C=g>>>(D+7|0)&1|D<<1}}while(0);k=c[122800+(C<<2)>>2]|0;b:do{if((k|0)==0){E=e;F=0;G=0}else{if((C|0)==31){H=0}else{H=25-(C>>>1)|0}r=e;o=0;t=g<<H;f=k;s=0;while(1){D=c[f+4>>2]&-8;n=D-g|0;if(n>>>0<r>>>0){if((D|0)==(g|0)){E=n;F=f;G=f;break b}else{I=n;J=f}}else{I=r;J=s}n=c[f+20>>2]|0;D=c[f+16+(t>>>31<<2)>>2]|0;l=(n|0)==0|(n|0)==(D|0)?o:n;if((D|0)==0){E=I;F=l;G=J;break}else{r=I;o=l;t=t<<1;f=D;s=J}}}}while(0);if((F|0)==0&(G|0)==0){k=2<<C;e=m&(k|0-k);if((e|0)==0){q=g;break}k=(e&0-e)+ -1|0;e=k>>>12&16;s=k>>>e;k=s>>>5&8;f=s>>>k;s=f>>>2&4;t=f>>>s;f=t>>>1&2;o=t>>>f;t=o>>>1&1;K=c[122800+((k|e|s|f|t)+(o>>>t)<<2)>>2]|0}else{K=F}if((K|0)==0){L=E;M=G}else{t=E;o=K;f=G;while(1){s=(c[o+4>>2]&-8)-g|0;e=s>>>0<t>>>0;k=e?s:t;s=e?o:f;e=c[o+16>>2]|0;if((e|0)!=0){N=s;O=k;f=N;o=e;t=O;continue}e=c[o+20>>2]|0;if((e|0)==0){L=k;M=s;break}else{N=s;O=k;o=e;f=N;t=O}}}if((M|0)==0){q=g;break}if(!(L>>>0<((c[122504>>2]|0)-g|0)>>>0)){q=g;break}t=M;f=c[122512>>2]|0;if(t>>>0<f>>>0){ed()}o=M+g|0;m=o;if(!(t>>>0<o>>>0)){ed()}t=c[M+24>>2]|0;e=c[M+12>>2]|0;do{if((e|0)==(M|0)){k=M+20|0;s=c[k>>2]|0;if((s|0)==0){r=M+16|0;D=c[r>>2]|0;if((D|0)==0){P=0;break}else{Q=D;R=r}}else{Q=s;R=k}while(1){k=Q+20|0;s=c[k>>2]|0;if((s|0)!=0){R=k;Q=s;continue}s=Q+16|0;k=c[s>>2]|0;if((k|0)==0){break}else{Q=k;R=s}}if(R>>>0<f>>>0){ed()}else{c[R>>2]=0;P=Q;break}}else{s=c[M+8>>2]|0;if(s>>>0<f>>>0){ed()}k=s+12|0;if((c[k>>2]|0)!=(M|0)){ed()}r=e+8|0;if((c[r>>2]|0)==(M|0)){c[k>>2]=e;c[r>>2]=s;P=e;break}else{ed()}}}while(0);c:do{if((t|0)!=0){e=c[M+28>>2]|0;f=122800+(e<<2)|0;do{if((M|0)==(c[f>>2]|0)){c[f>>2]=P;if((P|0)!=0){break}c[122500>>2]=c[122500>>2]&~(1<<e);break c}else{if(t>>>0<(c[122512>>2]|0)>>>0){ed()}s=t+16|0;if((c[s>>2]|0)==(M|0)){c[s>>2]=P}else{c[t+20>>2]=P}if((P|0)==0){break c}}}while(0);if(P>>>0<(c[122512>>2]|0)>>>0){ed()}c[P+24>>2]=t;e=c[M+16>>2]|0;do{if((e|0)!=0){if(e>>>0<(c[122512>>2]|0)>>>0){ed()}else{c[P+16>>2]=e;c[e+24>>2]=P;break}}}while(0);e=c[M+20>>2]|0;if((e|0)==0){break}if(e>>>0<(c[122512>>2]|0)>>>0){ed()}else{c[P+20>>2]=e;c[e+24>>2]=P;break}}}while(0);d:do{if(L>>>0<16){t=L+g|0;c[M+4>>2]=t|3;e=M+(t+4)|0;c[e>>2]=c[e>>2]|1}else{c[M+4>>2]=g|3;c[M+(g|4)>>2]=L|1;c[M+(L+g)>>2]=L;e=L>>>3;if(L>>>0<256){t=e<<1;f=122536+(t<<2)|0;s=c[30624]|0;r=1<<e;do{if((s&r|0)==0){c[30624]=s|r;S=122536+(t+2<<2)|0;T=f}else{e=122536+(t+2<<2)|0;k=c[e>>2]|0;if(!(k>>>0<(c[122512>>2]|0)>>>0)){S=e;T=k;break}ed()}}while(0);c[S>>2]=m;c[T+12>>2]=m;c[M+(g+8)>>2]=T;c[M+(g+12)>>2]=f;break}t=o;r=L>>>8;do{if((r|0)==0){U=0}else{if(L>>>0>16777215){U=31;break}s=(r+1048320|0)>>>16&8;k=r<<s;e=(k+520192|0)>>>16&4;D=k<<e;k=(D+245760|0)>>>16&2;l=14-(e|s|k)+(D<<k>>>15)|0;U=L>>>(l+7|0)&1|l<<1}}while(0);r=122800+(U<<2)|0;c[M+(g+28)>>2]=U;c[M+(g+20)>>2]=0;c[M+(g+16)>>2]=0;f=c[122500>>2]|0;l=1<<U;if((f&l|0)==0){c[122500>>2]=f|l;c[r>>2]=t;c[M+(g+24)>>2]=r;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break}l=c[r>>2]|0;if((U|0)==31){V=0}else{V=25-(U>>>1)|0}e:do{if((c[l+4>>2]&-8|0)==(L|0)){W=l}else{r=L<<V;f=l;while(1){X=f+16+(r>>>31<<2)|0;k=c[X>>2]|0;if((k|0)==0){break}if((c[k+4>>2]&-8|0)==(L|0)){W=k;break e}else{r=r<<1;f=k}}if(X>>>0<(c[122512>>2]|0)>>>0){ed()}else{c[X>>2]=t;c[M+(g+24)>>2]=f;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break d}}}while(0);l=W+8|0;r=c[l>>2]|0;k=c[122512>>2]|0;if(W>>>0<k>>>0){ed()}if(r>>>0<k>>>0){ed()}else{c[r+12>>2]=t;c[l>>2]=t;c[M+(g+8)>>2]=r;c[M+(g+12)>>2]=W;c[M+(g+24)>>2]=0;break}}}while(0);p=M+8|0;i=b;return p|0}}while(0);M=c[122504>>2]|0;if(!(q>>>0>M>>>0)){W=M-q|0;X=c[122516>>2]|0;if(W>>>0>15){c[122516>>2]=X+q;c[122504>>2]=W;c[X+(q+4)>>2]=W|1;c[X+M>>2]=W;c[X+4>>2]=q|3}else{c[122504>>2]=0;c[122516>>2]=0;c[X+4>>2]=M|3;W=X+(M+4)|0;c[W>>2]=c[W>>2]|1}p=X+8|0;i=b;return p|0}X=c[122508>>2]|0;if(q>>>0<X>>>0){W=X-q|0;c[122508>>2]=W;X=c[122520>>2]|0;c[122520>>2]=X+q;c[X+(q+4)>>2]=W|1;c[X+4>>2]=q|3;p=X+8|0;i=b;return p|0}do{if((c[30742]|0)==0){X=bd(30)|0;if((X+ -1&X|0)==0){c[122976>>2]=X;c[122972>>2]=X;c[122980>>2]=-1;c[122984>>2]=-1;c[122988>>2]=0;c[122940>>2]=0;c[30742]=(oc(0)|0)&-16^1431655768;break}else{ed()}}}while(0);X=q+48|0;W=c[122976>>2]|0;M=q+47|0;L=W+M|0;V=0-W|0;W=L&V;if(!(W>>>0>q>>>0)){p=0;i=b;return p|0}U=c[122936>>2]|0;do{if((U|0)!=0){T=c[122928>>2]|0;S=T+W|0;if(S>>>0<=T>>>0|S>>>0>U>>>0){p=0}else{break}i=b;return p|0}}while(0);f:do{if((c[122940>>2]&4|0)==0){U=c[122520>>2]|0;g:do{if((U|0)==0){Y=182}else{S=U;T=122944|0;while(1){Z=T;P=c[Z>>2]|0;if(!(P>>>0>S>>>0)){_=T+4|0;if((P+(c[_>>2]|0)|0)>>>0>S>>>0){break}}P=c[T+8>>2]|0;if((P|0)==0){Y=182;break g}else{T=P}}if((T|0)==0){Y=182;break}S=L-(c[122508>>2]|0)&V;if(!(S>>>0<2147483647)){$=0;break}t=hb(S|0)|0;P=(t|0)==((c[Z>>2]|0)+(c[_>>2]|0)|0);aa=t;ba=S;ca=P?t:-1;da=P?S:0;Y=191}}while(0);do{if((Y|0)==182){U=hb(0)|0;if((U|0)==(-1|0)){$=0;break}S=U;P=c[122972>>2]|0;t=P+ -1|0;if((t&S|0)==0){ea=W}else{ea=W-S+(t+S&0-P)|0}P=c[122928>>2]|0;S=P+ea|0;if(!(ea>>>0>q>>>0&ea>>>0<2147483647)){$=0;break}t=c[122936>>2]|0;if((t|0)!=0){if(S>>>0<=P>>>0|S>>>0>t>>>0){$=0;break}}t=hb(ea|0)|0;S=(t|0)==(U|0);aa=t;ba=ea;ca=S?U:-1;da=S?ea:0;Y=191}}while(0);h:do{if((Y|0)==191){S=0-ba|0;if((ca|0)!=(-1|0)){fa=ca;ga=da;Y=202;break f}do{if((aa|0)!=(-1|0)&ba>>>0<2147483647&ba>>>0<X>>>0){U=c[122976>>2]|0;t=M-ba+U&0-U;if(!(t>>>0<2147483647)){ha=ba;break}if((hb(t|0)|0)==(-1|0)){hb(S|0)|0;$=da;break h}else{ha=t+ba|0;break}}else{ha=ba}}while(0);if((aa|0)==(-1|0)){$=da}else{fa=aa;ga=ha;Y=202;break f}}}while(0);c[122940>>2]=c[122940>>2]|4;ia=$;Y=199}else{ia=0;Y=199}}while(0);do{if((Y|0)==199){if(!(W>>>0<2147483647)){break}$=hb(W|0)|0;ha=hb(0)|0;if(!((ha|0)!=(-1|0)&($|0)!=(-1|0)&$>>>0<ha>>>0)){break}aa=ha-$|0;ha=aa>>>0>(q+40|0)>>>0;if(ha){fa=$;ga=ha?aa:ia;Y=202}}}while(0);do{if((Y|0)==202){ia=(c[122928>>2]|0)+ga|0;c[122928>>2]=ia;if(ia>>>0>(c[122932>>2]|0)>>>0){c[122932>>2]=ia}ia=c[122520>>2]|0;W=122944|0;i:do{if((ia|0)==0){aa=c[122512>>2]|0;if((aa|0)==0|fa>>>0<aa>>>0){c[122512>>2]=fa}c[122944>>2]=fa;c[122948>>2]=ga;c[122956>>2]=0;c[122532>>2]=c[30742];c[122528>>2]=-1;aa=0;do{ha=aa<<1;$=122536+(ha<<2)|0;c[122536+(ha+3<<2)>>2]=$;c[122536+(ha+2<<2)>>2]=$;aa=aa+1|0;}while(aa>>>0<32);aa=fa+8|0;if((aa&7|0)==0){ja=0}else{ja=0-aa&7}aa=ga+ -40-ja|0;c[122520>>2]=fa+ja;c[122508>>2]=aa;c[fa+(ja+4)>>2]=aa|1;c[fa+(ga+ -36)>>2]=40;c[122524>>2]=c[122984>>2]}else{aa=W;while(1){ka=c[aa>>2]|0;la=aa+4|0;ma=c[la>>2]|0;if((fa|0)==(ka+ma|0)){Y=214;break}$=c[aa+8>>2]|0;if(($|0)==0){break}else{aa=$}}do{if((Y|0)==214){if((c[aa+12>>2]&8|0)!=0){break}$=ia;if(!($>>>0>=ka>>>0&$>>>0<fa>>>0)){break}c[la>>2]=ma+ga;$=(c[122508>>2]|0)+ga|0;ha=ia+8|0;if((ha&7|0)==0){na=0}else{na=0-ha&7}ha=$-na|0;c[122520>>2]=ia+na;c[122508>>2]=ha;c[ia+(na+4)>>2]=ha|1;c[ia+($+4)>>2]=40;c[122524>>2]=c[122984>>2];break i}}while(0);if(fa>>>0<(c[122512>>2]|0)>>>0){c[122512>>2]=fa}aa=fa+ga|0;$=122944|0;while(1){oa=$;if((c[oa>>2]|0)==(aa|0)){Y=224;break}ha=c[$+8>>2]|0;if((ha|0)==0){break}else{$=ha}}do{if((Y|0)==224){if((c[$+12>>2]&8|0)!=0){break}c[oa>>2]=fa;aa=$+4|0;c[aa>>2]=(c[aa>>2]|0)+ga;aa=fa+8|0;if((aa&7|0)==0){pa=0}else{pa=0-aa&7}aa=fa+(ga+8)|0;if((aa&7|0)==0){qa=0}else{qa=0-aa&7}aa=fa+(qa+ga)|0;ha=aa;da=pa+q|0;ba=fa+da|0;M=ba;X=aa-(fa+pa)-q|0;c[fa+(pa+4)>>2]=q|3;j:do{if((ha|0)==(c[122520>>2]|0)){ca=(c[122508>>2]|0)+X|0;c[122508>>2]=ca;c[122520>>2]=M;c[fa+(da+4)>>2]=ca|1}else{if((ha|0)==(c[122516>>2]|0)){ca=(c[122504>>2]|0)+X|0;c[122504>>2]=ca;c[122516>>2]=M;c[fa+(da+4)>>2]=ca|1;c[fa+(ca+da)>>2]=ca;break}ca=ga+4|0;ea=c[fa+(ca+qa)>>2]|0;if((ea&3|0)==1){_=ea&-8;Z=ea>>>3;k:do{if(ea>>>0<256){V=c[fa+((qa|8)+ga)>>2]|0;L=c[fa+(ga+12+qa)>>2]|0;S=122536+(Z<<1<<2)|0;do{if((V|0)!=(S|0)){if(V>>>0<(c[122512>>2]|0)>>>0){ed()}if((c[V+12>>2]|0)==(ha|0)){break}ed()}}while(0);if((L|0)==(V|0)){c[30624]=c[30624]&~(1<<Z);break}do{if((L|0)==(S|0)){ra=L+8|0}else{if(L>>>0<(c[122512>>2]|0)>>>0){ed()}T=L+8|0;if((c[T>>2]|0)==(ha|0)){ra=T;break}ed()}}while(0);c[V+12>>2]=L;c[ra>>2]=V}else{S=aa;T=c[fa+((qa|24)+ga)>>2]|0;t=c[fa+(ga+12+qa)>>2]|0;do{if((t|0)==(S|0)){U=qa|16;P=fa+(ca+U)|0;Q=P;R=c[P>>2]|0;if((R|0)==0){P=fa+(U+ga)|0;U=c[P>>2]|0;if((U|0)==0){sa=0;break}else{ta=U;ua=P}}else{ta=R;ua=Q}while(1){Q=ta+20|0;R=c[Q>>2]|0;if((R|0)!=0){ua=Q;ta=R;continue}R=ta+16|0;Q=c[R>>2]|0;if((Q|0)==0){break}else{ta=Q;ua=R}}if(ua>>>0<(c[122512>>2]|0)>>>0){ed()}else{c[ua>>2]=0;sa=ta;break}}else{R=c[fa+((qa|8)+ga)>>2]|0;if(R>>>0<(c[122512>>2]|0)>>>0){ed()}Q=R+12|0;if((c[Q>>2]|0)!=(S|0)){ed()}P=t+8|0;if((c[P>>2]|0)==(S|0)){c[Q>>2]=t;c[P>>2]=R;sa=t;break}else{ed()}}}while(0);if((T|0)==0){break}t=c[fa+(ga+28+qa)>>2]|0;V=122800+(t<<2)|0;do{if((S|0)==(c[V>>2]|0)){c[V>>2]=sa;if((sa|0)!=0){break}c[122500>>2]=c[122500>>2]&~(1<<t);break k}else{if(T>>>0<(c[122512>>2]|0)>>>0){ed()}L=T+16|0;if((c[L>>2]|0)==(S|0)){c[L>>2]=sa}else{c[T+20>>2]=sa}if((sa|0)==0){break k}}}while(0);if(sa>>>0<(c[122512>>2]|0)>>>0){ed()}c[sa+24>>2]=T;S=qa|16;t=c[fa+(S+ga)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[122512>>2]|0)>>>0){ed()}else{c[sa+16>>2]=t;c[t+24>>2]=sa;break}}}while(0);t=c[fa+(ca+S)>>2]|0;if((t|0)==0){break}if(t>>>0<(c[122512>>2]|0)>>>0){ed()}else{c[sa+20>>2]=t;c[t+24>>2]=sa;break}}}while(0);va=fa+((_|qa)+ga)|0;wa=_+X|0}else{va=ha;wa=X}ca=va+4|0;c[ca>>2]=c[ca>>2]&-2;c[fa+(da+4)>>2]=wa|1;c[fa+(wa+da)>>2]=wa;ca=wa>>>3;if(wa>>>0<256){Z=ca<<1;ea=122536+(Z<<2)|0;t=c[30624]|0;T=1<<ca;do{if((t&T|0)==0){c[30624]=t|T;xa=122536+(Z+2<<2)|0;ya=ea}else{ca=122536+(Z+2<<2)|0;V=c[ca>>2]|0;if(!(V>>>0<(c[122512>>2]|0)>>>0)){xa=ca;ya=V;break}ed()}}while(0);c[xa>>2]=M;c[ya+12>>2]=M;c[fa+(da+8)>>2]=ya;c[fa+(da+12)>>2]=ea;break}Z=ba;T=wa>>>8;do{if((T|0)==0){za=0}else{if(wa>>>0>16777215){za=31;break}t=(T+1048320|0)>>>16&8;_=T<<t;V=(_+520192|0)>>>16&4;ca=_<<V;_=(ca+245760|0)>>>16&2;L=14-(V|t|_)+(ca<<_>>>15)|0;za=wa>>>(L+7|0)&1|L<<1}}while(0);T=122800+(za<<2)|0;c[fa+(da+28)>>2]=za;c[fa+(da+20)>>2]=0;c[fa+(da+16)>>2]=0;ea=c[122500>>2]|0;L=1<<za;if((ea&L|0)==0){c[122500>>2]=ea|L;c[T>>2]=Z;c[fa+(da+24)>>2]=T;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break}L=c[T>>2]|0;if((za|0)==31){Aa=0}else{Aa=25-(za>>>1)|0}l:do{if((c[L+4>>2]&-8|0)==(wa|0)){Ba=L}else{T=wa<<Aa;ea=L;while(1){Ca=ea+16+(T>>>31<<2)|0;_=c[Ca>>2]|0;if((_|0)==0){break}if((c[_+4>>2]&-8|0)==(wa|0)){Ba=_;break l}else{T=T<<1;ea=_}}if(Ca>>>0<(c[122512>>2]|0)>>>0){ed()}else{c[Ca>>2]=Z;c[fa+(da+24)>>2]=ea;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break j}}}while(0);L=Ba+8|0;T=c[L>>2]|0;S=c[122512>>2]|0;if(Ba>>>0<S>>>0){ed()}if(T>>>0<S>>>0){ed()}else{c[T+12>>2]=Z;c[L>>2]=Z;c[fa+(da+8)>>2]=T;c[fa+(da+12)>>2]=Ba;c[fa+(da+24)>>2]=0;break}}}while(0);p=fa+(pa|8)|0;i=b;return p|0}}while(0);$=ia;da=122944|0;while(1){Da=c[da>>2]|0;if(!(Da>>>0>$>>>0)){Ea=c[da+4>>2]|0;Fa=Da+Ea|0;if(Fa>>>0>$>>>0){break}}da=c[da+8>>2]|0}da=Da+(Ea+ -39)|0;if((da&7|0)==0){Ga=0}else{Ga=0-da&7}da=Da+(Ea+ -47+Ga)|0;ba=da>>>0<(ia+16|0)>>>0?$:da;da=ba+8|0;M=da;X=fa+8|0;if((X&7|0)==0){Ha=0}else{Ha=0-X&7}X=ga+ -40-Ha|0;c[122520>>2]=fa+Ha;c[122508>>2]=X;c[fa+(Ha+4)>>2]=X|1;c[fa+(ga+ -36)>>2]=40;c[122524>>2]=c[122984>>2];c[ba+4>>2]=27;X=122944|0;c[da+0>>2]=c[X+0>>2];c[da+4>>2]=c[X+4>>2];c[da+8>>2]=c[X+8>>2];c[da+12>>2]=c[X+12>>2];c[122944>>2]=fa;c[122948>>2]=ga;c[122956>>2]=0;c[122952>>2]=M;M=ba+28|0;c[M>>2]=7;if((ba+32|0)>>>0<Fa>>>0){X=M;while(1){M=X+4|0;c[M>>2]=7;if((X+8|0)>>>0<Fa>>>0){X=M}else{break}}}if((ba|0)==($|0)){break}X=ba-ia|0;M=ia+(X+4)|0;c[M>>2]=c[M>>2]&-2;c[ia+4>>2]=X|1;c[ia+X>>2]=X;M=X>>>3;if(X>>>0<256){da=M<<1;ha=122536+(da<<2)|0;aa=c[30624]|0;f=1<<M;do{if((aa&f|0)==0){c[30624]=aa|f;Ia=122536+(da+2<<2)|0;Ja=ha}else{M=122536+(da+2<<2)|0;T=c[M>>2]|0;if(!(T>>>0<(c[122512>>2]|0)>>>0)){Ia=M;Ja=T;break}ed()}}while(0);c[Ia>>2]=ia;c[Ja+12>>2]=ia;c[ia+8>>2]=Ja;c[ia+12>>2]=ha;break}da=ia;f=X>>>8;do{if((f|0)==0){Ka=0}else{if(X>>>0>16777215){Ka=31;break}aa=(f+1048320|0)>>>16&8;ba=f<<aa;$=(ba+520192|0)>>>16&4;T=ba<<$;ba=(T+245760|0)>>>16&2;M=14-($|aa|ba)+(T<<ba>>>15)|0;Ka=X>>>(M+7|0)&1|M<<1}}while(0);f=122800+(Ka<<2)|0;c[ia+28>>2]=Ka;c[ia+20>>2]=0;c[ia+16>>2]=0;ha=c[122500>>2]|0;M=1<<Ka;if((ha&M|0)==0){c[122500>>2]=ha|M;c[f>>2]=da;c[ia+24>>2]=f;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break}M=c[f>>2]|0;if((Ka|0)==31){La=0}else{La=25-(Ka>>>1)|0}m:do{if((c[M+4>>2]&-8|0)==(X|0)){Ma=M}else{f=X<<La;ha=M;while(1){Na=ha+16+(f>>>31<<2)|0;ba=c[Na>>2]|0;if((ba|0)==0){break}if((c[ba+4>>2]&-8|0)==(X|0)){Ma=ba;break m}else{f=f<<1;ha=ba}}if(Na>>>0<(c[122512>>2]|0)>>>0){ed()}else{c[Na>>2]=da;c[ia+24>>2]=ha;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break i}}}while(0);X=Ma+8|0;M=c[X>>2]|0;f=c[122512>>2]|0;if(Ma>>>0<f>>>0){ed()}if(M>>>0<f>>>0){ed()}else{c[M+12>>2]=da;c[X>>2]=da;c[ia+8>>2]=M;c[ia+12>>2]=Ma;c[ia+24>>2]=0;break}}}while(0);ia=c[122508>>2]|0;if(!(ia>>>0>q>>>0)){break}W=ia-q|0;c[122508>>2]=W;ia=c[122520>>2]|0;c[122520>>2]=ia+q;c[ia+(q+4)>>2]=W|1;c[ia+4>>2]=q|3;p=ia+8|0;i=b;return p|0}}while(0);c[(Kc()|0)>>2]=12;p=0;i=b;return p|0}



function SE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+192|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+8|0;$=i;i=i+16|0;aa=i;i=i+8|0;ba=i;i=i+16|0;ca=i;i=i+8|0;da=i;i=i+16|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+16|0;qa=i;i=i+8|0;ra=i;i=i+16|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+16|0;wa=i;i=i+8|0;xa=i;i=i+16|0;ya=i;i=i+8|0;za=i;i=i+16|0;Aa=i;i=i+8|0;Ba=i;i=i+16|0;Ca=i;i=i+8|0;Da=i;i=i+16|0;Ea=i;i=i+8|0;Fa=i;i=i+16|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;Ka=i;i=i+8|0;La=i;i=i+16|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+16|0;Sa=i;i=i+8|0;Ta=i;i=i+16|0;Ua=i;i=i+8|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;Ya=i;i=i+8|0;Za=i;i=i+16|0;_a=i;i=i+8|0;$a=i;i=i+16|0;ab=i;i=i+8|0;bb=i;i=i+16|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+8|0;fb=i;i=i+16|0;gb=i;i=i+8|0;hb=i;i=i+16|0;ib=i;i=i+8|0;jb=i;i=i+16|0;kb=i;i=i+8|0;lb=i;i=i+16|0;mb=i;i=i+8|0;nb=i;i=i+16|0;ob=i;i=i+8|0;pb=i;i=i+16|0;qb=i;i=i+8|0;rb=i;i=i+16|0;sb=i;i=i+8|0;tb=i;i=i+16|0;ub=i;i=i+8|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+8|0;zb=i;i=i+16|0;Ab=i;i=i+8|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;Gb=i;i=i+8|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+8|0;Lb=i;i=i+16|0;Mb=i;i=i+8|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+8|0;Rb=i;i=i+16|0;Sb=i;i=i+8|0;Ub=i;i=i+16|0;Vb=i;i=i+8|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+8|0;_b=i;i=i+16|0;$b=i;i=i+8|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;aF(o,p);p=(d|0)!=0;dc=(e|0)==0;if(!(dc|p^1)){kw(0,78784,n)}if(p){ec=wd(d|0)|0}else{ec=0}if(dc){fc=ec}else{c[m>>2]=e;gw(23,0,78928,m);bF(q);cF(q,e,8);if(!(dF(q)|0)){c[l>>2]=e;kw(0,78968,l)}EP(r);l=q;eF(l,r)|0;GP(s,r);while(1){e=eF(l,r)|0;if(!(AQ(e+(c[(c[e>>2]|0)+ -12>>2]|0)|0)|0)){break}zQ(t,79048,r);fQ(s,t)|0;QP(t)}t=wd(lQ(s)|0)|0;fF(q);QP(s);QP(r);gF(q);fc=t}if((fc|0)==0){gw(23,0,79136,g);iF(o);i=f;return}EP(u);EP(v);c[k>>2]=fc;gw(23,0,79056,k);k=Tb(fc|0,79048)|0;if((k|0)!=0){g=k;do{k=$Z(12)|0;KP(k,g);t=mQ(k,79088,0)|0;kQ(w,k,0,t);RP(u,w)|0;QP(w);kQ(x,k,t+1|0,(XP(k)|0)+~t|0);RP(v,x)|0;QP(x);RP(AE(o,u)|0,v)|0;t=lQ(u)|0;k=lQ(v)|0;c[j>>2]=t;c[j+4>>2]=k;gw(23,0,79096,j);g=Tb(0,79048)|0;}while((g|0)!=0)}WZ(fc);fc=a+12|0;KP(y,77184);g=AE(fc,y)|0;KP(z,77184);if((hF(o,z)|0)==0){KP(B,77184);gc=1;hc=0;ic=AE(fc,B)|0}else{KP(A,77184);gc=0;hc=1;ic=AE(o,A)|0}RP(g,ic)|0;if(gc){QP(B)}if(hc){QP(A)}QP(z);QP(y);KP(C,77056);y=AE(fc,C)|0;KP(D,77056);if((hF(o,D)|0)==0){KP(F,77056);jc=1;kc=0;lc=AE(fc,F)|0}else{KP(E,77056);jc=0;kc=1;lc=AE(o,E)|0}RP(y,lc)|0;if(jc){QP(F)}if(kc){QP(E)}QP(D);QP(C);KP(G,77088);C=AE(fc,G)|0;KP(H,77088);if((hF(o,H)|0)==0){KP(J,77088);mc=1;nc=0;oc=AE(fc,J)|0}else{KP(I,77088);mc=0;nc=1;oc=AE(o,I)|0}RP(C,oc)|0;if(mc){QP(J)}if(nc){QP(I)}QP(H);QP(G);KP(K,77120);G=AE(fc,K)|0;KP(L,77120);if((hF(o,L)|0)==0){KP(N,77120);pc=0;qc=1;rc=AE(fc,N)|0}else{KP(M,77120);pc=1;qc=0;rc=AE(o,M)|0}RP(G,rc)|0;if(qc){QP(N)}if(pc){QP(M)}QP(L);QP(K);KP(O,77152);K=AE(fc,O)|0;KP(P,77152);if((hF(o,P)|0)==0){KP(R,77152);sc=1;tc=0;uc=AE(fc,R)|0}else{KP(Q,77152);sc=0;tc=1;uc=AE(o,Q)|0}RP(K,uc)|0;if(sc){QP(R)}if(tc){QP(Q)}QP(P);QP(O);KP(S,77216);O=AE(fc,S)|0;KP(T,77216);if((hF(o,T)|0)==0){KP(V,77216);vc=1;wc=0;xc=AE(fc,V)|0}else{KP(U,77216);vc=0;wc=1;xc=AE(o,U)|0}RP(O,xc)|0;if(vc){QP(V)}if(wc){QP(U)}QP(T);QP(S);KP(W,77256);S=AE(fc,W)|0;KP(X,77256);if((hF(o,X)|0)==0){KP(Z,77256);yc=1;zc=0;Ac=AE(fc,Z)|0}else{KP(Y,77256);yc=0;zc=1;Ac=AE(o,Y)|0}RP(S,Ac)|0;if(yc){QP(Z)}if(zc){QP(Y)}QP(X);QP(W);W=b+104|0;X=c[W>>2]|0;if((X|0)>0){Y=a+24|0;zc=a+36|0;Z=0;while(1){c[_>>2]=Z;yc=TE(Y,_)|0;KP($,76160);Ac=AE(yc,$)|0;c[aa>>2]=Z;yc=TE(Y,aa)|0;KP(ba,76016);if((hF(o,AE(yc,ba)|0)|0)==0){c[ea>>2]=Z;yc=TE(Y,ea)|0;KP(fa,76160);Bc=1;Cc=0;Dc=AE(yc,fa)|0}else{c[ca>>2]=Z;yc=TE(Y,ca)|0;KP(da,76016);Bc=0;Cc=1;Dc=AE(o,AE(yc,da)|0)|0}RP(Ac,Dc)|0;if(Bc){QP(fa)}if(Cc){QP(da)}QP(ba);QP($);c[ga>>2]=Z;Ac=TE(zc,ga)|0;KP(ha,76160);yc=AE(Ac,ha)|0;c[ia>>2]=Z;Ac=TE(zc,ia)|0;KP(ja,76016);if((hF(o,AE(Ac,ja)|0)|0)==0){c[ma>>2]=Z;Ac=TE(zc,ma)|0;KP(na,76160);Ec=1;Fc=0;Gc=AE(Ac,na)|0}else{c[ka>>2]=Z;Ac=TE(zc,ka)|0;KP(la,76016);Ec=0;Fc=1;Gc=AE(o,AE(Ac,la)|0)|0}RP(yc,Gc)|0;if(Ec){QP(na)}if(Fc){QP(la)}QP(ja);QP(ha);yc=Z+1|0;Ac=c[W>>2]|0;if((yc|0)<(Ac|0)){Z=yc}else{Hc=Ac;break}}}else{Hc=X}X=b+108|0;if(((c[X>>2]|0)-(Hc<<1)|0)>0){Hc=a+48|0;Z=0;do{c[oa>>2]=Z;ha=TE(Hc,oa)|0;KP(pa,76160);ja=AE(ha,pa)|0;c[qa>>2]=Z;ha=TE(Hc,qa)|0;KP(ra,76016);if((hF(o,AE(ha,ra)|0)|0)==0){c[ua>>2]=Z;ha=TE(Hc,ua)|0;KP(va,76160);Ic=1;Jc=0;Kc=AE(ha,va)|0}else{c[sa>>2]=Z;ha=TE(Hc,sa)|0;KP(ta,76016);Ic=0;Jc=1;Kc=AE(o,AE(ha,ta)|0)|0}RP(ja,Kc)|0;if(Ic){QP(va)}if(Jc){QP(ta)}QP(ra);QP(pa);Z=Z+1|0;}while((Z|0)<((c[X>>2]|0)-(c[W>>2]<<1)|0))}W=b+116|0;if((c[W>>2]|0)>0){X=a+84|0;Z=0;do{c[wa>>2]=Z;pa=TE(X,wa)|0;KP(xa,76160);ra=AE(pa,xa)|0;c[ya>>2]=Z;pa=TE(X,ya)|0;KP(za,76016);if((hF(o,AE(pa,za)|0)|0)==0){c[Ca>>2]=Z;pa=TE(X,Ca)|0;KP(Da,76160);Lc=1;Mc=0;Nc=AE(pa,Da)|0}else{c[Aa>>2]=Z;pa=TE(X,Aa)|0;KP(Ba,76016);Lc=0;Mc=1;Nc=AE(o,AE(pa,Ba)|0)|0}RP(ra,Nc)|0;if(Lc){QP(Da)}if(Mc){QP(Ba)}QP(za);QP(xa);Z=Z+1|0;}while((Z|0)<(c[W>>2]|0))}W=b+120|0;if((c[W>>2]|0)>0){Z=a+120|0;xa=0;do{c[Ea>>2]=xa;za=TE(Z,Ea)|0;KP(Fa,76160);Ba=AE(za,Fa)|0;c[Ga>>2]=xa;za=TE(Z,Ga)|0;KP(Ha,76016);if((hF(o,AE(za,Ha)|0)|0)==0){c[Ka>>2]=xa;za=TE(Z,Ka)|0;KP(La,76160);Oc=1;Pc=0;Qc=AE(za,La)|0}else{c[Ia>>2]=xa;za=TE(Z,Ia)|0;KP(Ja,76016);Oc=0;Pc=1;Qc=AE(o,AE(za,Ja)|0)|0}RP(Ba,Qc)|0;if(Oc){QP(La)}if(Pc){QP(Ja)}QP(Ha);QP(Fa);xa=xa+1|0;}while((xa|0)<(c[W>>2]|0))}W=b+124|0;if((c[W>>2]|0)>0){xa=a+156|0;Fa=0;do{c[Ma>>2]=Fa;Ha=TE(xa,Ma)|0;KP(Na,76160);Ja=AE(Ha,Na)|0;c[Oa>>2]=Fa;Ha=TE(xa,Oa)|0;KP(Pa,76016);if((hF(o,AE(Ha,Pa)|0)|0)==0){c[Sa>>2]=Fa;Ha=TE(xa,Sa)|0;KP(Ta,76160);Rc=1;Sc=0;Tc=AE(Ha,Ta)|0}else{c[Qa>>2]=Fa;Ha=TE(xa,Qa)|0;KP(Ra,76016);Rc=0;Sc=1;Tc=AE(o,AE(Ha,Ra)|0)|0}RP(Ja,Tc)|0;if(Rc){QP(Ta)}if(Sc){QP(Ra)}QP(Pa);QP(Na);Fa=Fa+1|0;}while((Fa|0)<(c[W>>2]|0))}W=b+128|0;if((c[W>>2]|0)>0){Fa=a+60|0;Na=0;do{c[Ua>>2]=Na;Pa=TE(Fa,Ua)|0;KP(Va,76160);Ra=AE(Pa,Va)|0;c[Wa>>2]=Na;Pa=TE(Fa,Wa)|0;KP(Xa,76016);if((hF(o,AE(Pa,Xa)|0)|0)==0){c[_a>>2]=Na;Pa=TE(Fa,_a)|0;KP($a,76160);Uc=1;Vc=0;Wc=AE(Pa,$a)|0}else{c[Ya>>2]=Na;Pa=TE(Fa,Ya)|0;KP(Za,76016);Uc=0;Vc=1;Wc=AE(o,AE(Pa,Za)|0)|0}RP(Ra,Wc)|0;if(Uc){QP($a)}if(Vc){QP(Za)}QP(Xa);QP(Va);Na=Na+1|0;}while((Na|0)<(c[W>>2]|0))}W=b+132|0;if((c[W>>2]|0)>0){Na=a+96|0;Va=0;do{c[ab>>2]=Va;Xa=TE(Na,ab)|0;KP(bb,76160);Za=AE(Xa,bb)|0;c[cb>>2]=Va;Xa=TE(Na,cb)|0;KP(db,76016);if((hF(o,AE(Xa,db)|0)|0)==0){c[gb>>2]=Va;Xa=TE(Na,gb)|0;KP(hb,76160);Xc=1;Yc=0;Zc=AE(Xa,hb)|0}else{c[eb>>2]=Va;Xa=TE(Na,eb)|0;KP(fb,76016);Xc=0;Yc=1;Zc=AE(o,AE(Xa,fb)|0)|0}RP(Za,Zc)|0;if(Xc){QP(hb)}if(Yc){QP(fb)}QP(db);QP(bb);Va=Va+1|0;}while((Va|0)<(c[W>>2]|0))}W=b+136|0;if((c[W>>2]|0)>0){Va=a+132|0;bb=0;do{c[ib>>2]=bb;db=TE(Va,ib)|0;KP(jb,76160);fb=AE(db,jb)|0;c[kb>>2]=bb;db=TE(Va,kb)|0;KP(lb,76016);if((hF(o,AE(db,lb)|0)|0)==0){c[ob>>2]=bb;db=TE(Va,ob)|0;KP(pb,76160);_c=1;$c=0;ad=AE(db,pb)|0}else{c[mb>>2]=bb;db=TE(Va,mb)|0;KP(nb,76016);_c=0;$c=1;ad=AE(o,AE(db,nb)|0)|0}RP(fb,ad)|0;if(_c){QP(pb)}if($c){QP(nb)}QP(lb);QP(jb);bb=bb+1|0;}while((bb|0)<(c[W>>2]|0))}W=b+140|0;if((c[W>>2]|0)>0){bb=a+168|0;jb=0;do{c[qb>>2]=jb;lb=TE(bb,qb)|0;KP(rb,76160);nb=AE(lb,rb)|0;c[sb>>2]=jb;lb=TE(bb,sb)|0;KP(tb,76016);if((hF(o,AE(lb,tb)|0)|0)==0){c[wb>>2]=jb;lb=TE(bb,wb)|0;KP(xb,76160);bd=1;cd=0;dd=AE(lb,xb)|0}else{c[ub>>2]=jb;lb=TE(bb,ub)|0;KP(vb,76016);bd=0;cd=1;dd=AE(o,AE(lb,vb)|0)|0}RP(nb,dd)|0;if(bd){QP(xb)}if(cd){QP(vb)}QP(tb);QP(rb);jb=jb+1|0;}while((jb|0)<(c[W>>2]|0))}W=b+208|0;if((c[W>>2]|0)>0){jb=a+72|0;rb=0;do{c[yb>>2]=rb;tb=TE(jb,yb)|0;KP(zb,76160);vb=AE(tb,zb)|0;c[Ab>>2]=rb;tb=TE(jb,Ab)|0;KP(Bb,76016);if((hF(o,AE(tb,Bb)|0)|0)==0){c[Eb>>2]=rb;tb=TE(jb,Eb)|0;KP(Fb,76160);ed=1;fd=0;gd=AE(tb,Fb)|0}else{c[Cb>>2]=rb;tb=TE(jb,Cb)|0;KP(Db,76016);ed=0;fd=1;gd=AE(o,AE(tb,Db)|0)|0}RP(vb,gd)|0;if(ed){QP(Fb)}if(fd){QP(Db)}QP(Bb);QP(zb);rb=rb+1|0;}while((rb|0)<(c[W>>2]|0))}W=b+212|0;if((c[W>>2]|0)>0){rb=a+108|0;zb=0;do{c[Gb>>2]=zb;Bb=TE(rb,Gb)|0;KP(Hb,76160);Db=AE(Bb,Hb)|0;c[Ib>>2]=zb;Bb=TE(rb,Ib)|0;KP(Jb,76016);if((hF(o,AE(Bb,Jb)|0)|0)==0){c[Mb>>2]=zb;Bb=TE(rb,Mb)|0;KP(Nb,76160);hd=0;id=1;jd=AE(Bb,Nb)|0}else{c[Kb>>2]=zb;Bb=TE(rb,Kb)|0;KP(Lb,76016);hd=1;id=0;jd=AE(o,AE(Bb,Lb)|0)|0}RP(Db,jd)|0;if(id){QP(Nb)}if(hd){QP(Lb)}QP(Jb);QP(Hb);zb=zb+1|0;}while((zb|0)<(c[W>>2]|0))}W=b+216|0;if((c[W>>2]|0)>0){zb=a+144|0;Hb=0;do{c[Ob>>2]=Hb;Jb=TE(zb,Ob)|0;KP(Pb,76160);Lb=AE(Jb,Pb)|0;c[Qb>>2]=Hb;Jb=TE(zb,Qb)|0;KP(Rb,76016);if((hF(o,AE(Jb,Rb)|0)|0)==0){c[Vb>>2]=Hb;Jb=TE(zb,Vb)|0;KP(Wb,76160);kd=1;ld=0;md=AE(Jb,Wb)|0}else{c[Sb>>2]=Hb;Jb=TE(zb,Sb)|0;KP(Ub,76016);kd=0;ld=1;md=AE(o,AE(Jb,Ub)|0)|0}RP(Lb,md)|0;if(kd){QP(Wb)}if(ld){QP(Ub)}QP(Rb);QP(Pb);Hb=Hb+1|0;}while((Hb|0)<(c[W>>2]|0))}W=b+220|0;if((c[W>>2]|0)>0){b=a+180|0;a=0;do{c[Xb>>2]=a;Hb=TE(b,Xb)|0;KP(Yb,76160);Pb=AE(Hb,Yb)|0;c[Zb>>2]=a;Hb=TE(b,Zb)|0;KP(_b,76016);if((hF(o,AE(Hb,_b)|0)|0)==0){c[bc>>2]=a;Hb=TE(b,bc)|0;KP(cc,76160);nd=1;od=0;pd=AE(Hb,cc)|0}else{c[$b>>2]=a;Hb=TE(b,$b)|0;KP(ac,76016);nd=0;od=1;pd=AE(o,AE(Hb,ac)|0)|0}RP(Pb,pd)|0;if(nd){QP(cc)}if(od){QP(ac)}QP(_b);QP(Yb);a=a+1|0;}while((a|0)<(c[W>>2]|0))}gw(23,0,79120,h);QP(v);QP(u);iF(o);i=f;return}function TE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=yH(a,f,b)|0;l=c[k>>2]|0;kB(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}AH(j,a,b);BH(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];zH(g,e);CH(j);j=c[f>>2]|0;DH(a,j,k,EH(g)|0);k=FH(g)|0;CH(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function UE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=aG(a,f,b)|0;l=c[k>>2]|0;kB(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}cG(j,a,b);dG(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];bG(g,e);eG(j);j=c[f>>2]|0;fG(a,j,k,gG(g)|0);k=hG(g)|0;eG(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function VE(a,b){a=a|0;b=b|0;var c=0;c=i;RP(b,a)|0;i=c;return}function WE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;TF(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];LF(a,f);i=e;return}function XE(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=JF(a,b)|0;i=c;return d|0}function YE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;MF(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];LF(a,e);i=d;return}function ZE(a){a=a|0;var b=0,c=0;b=i;c=GF(a)|0;i=b;return c|0}function _E(a){a=a|0;var b=0;b=i;dK(a);i=b;return}function $E(a){a=a|0;var b=0;b=i;SJ(a);i=b;return}function aF(a,b){a=a|0;b=b|0;b=i;zI(a,0);i=b;return}function bF(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+108|0;NQ(d);e=a;c[e>>2]=79188;f=d;c[f>>2]=79208;d=a+8|0;FR(a,79220|0,d);c[e>>2]=79188;c[f>>2]=79208;TD(d);i=b;return}function cF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(sB(a+8|0,b,d|8)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){EQ(d,4);i=e;return}else{CQ(d,0);i=e;return}}function dF(a){a=a|0;var b=0,c=0;b=i;c=BF(a+8|0)|0;i=b;return c|0}function eF(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=AF(a,b,LQ(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;i=d;return e|0}function fF(a){a=a|0;var b=0;b=i;if((uB(a+8|0)|0)!=0){i=b;return}EQ(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function gF(a){a=a|0;var b=0;b=i;FF(a,79216);IQ(a+108|0);i=b;return}function hF(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=jF(a,b)|0;i=c;return d|0}function iF(a){a=a|0;var b=0;b=i;HJ(a);i=b;return}function jF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d;f=lF(a)|0;kB(e);if((f|0)==0){g=0;i=d;return g|0}h=mF(a)|0;a=f;while(1){f=a+16|0;if(nF(h,b,f)|0){j=a}else{if(!(oF(h,f,b)|0)){g=1;k=8;break}j=a+4|0}f=c[j>>2]|0;kB(e);if((f|0)==0){g=0;k=8;break}else{a=f}}if((k|0)==8){i=d;return g|0}return 0}function kF(a){a=a|0;var b=0,c=0;b=i;c=XA(uF(a+4|0)|0)|0;i=b;return c|0}function lF(a){a=a|0;var b=0,d=0;b=i;d=c[(kF(a)|0)>>2]|0;i=b;return d|0}function mF(a){a=a|0;var b=0,c=0;b=i;c=sF(a+8|0)|0;i=b;return c|0}function nF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=pF(0,b,c)|0;i=a;return d|0}function oF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=pF(0,b,c)|0;i=a;return d|0}function pF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=qF(b,c)|0;i=a;return d|0}function qF(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(nQ(a,b)|0)<0;i=c;return d|0}function rF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=s_(a,b,c)|0;i=d;return e|0}function sF(a){a=a|0;var b=0,c=0;b=i;c=tF(a)|0;i=b;return c|0}function tF(a){a=a|0;i=i;return a|0}function uF(a){a=a|0;var b=0,c=0;b=i;c=vF(a)|0;i=b;return c|0}function vF(a){a=a|0;i=i;return a|0}function wF(a,b){a=a|0;b=b|0;var c=0;a=i;c=yF(0,b,0)|0;i=a;return c|0}function xF(b,c){b=b|0;c=c|0;a[b]=a[c]|0;i=i;return}function yF(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=$Z(b)|0;i=c;return a|0}function zF(a){a=a|0;var b=0,c=0;b=i;c=x_(a|0)|0;i=b;return c|0}function AF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;KR(f,a,1);if(!(NR(f)|0)){i=e;return a|0}eQ(b);f=0;while(1){g=TQ(JQ(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0)|0)|0;if(eC(g,-1)|0){h=2;j=f;break}k=f+1|0;l=fC(g)|0;if(jC(l,d)|0){h=0;j=k;break}gQ(b,l);if((OP(b)|0)==-17){h=4;j=k;break}else{f=k}}EQ(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,(j|0)==0?h|4:h);i=e;return a|0}function BF(a){a=a|0;i=i;return(c[a+64>>2]|0)!=0|0}function CF(a){a=a|0;var b=0;b=i;gF(a);b_(a);i=b;return}function DF(a){a=a|0;var b=0;b=i;gF(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function EF(a){a=a|0;var b=0;b=i;CF(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function FF(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];UB(a+8|0);i=d;return}function GF(a){a=a|0;var b=0,d=0;b=i;d=HF((c[a>>2]|0)+16|0)|0;i=b;return d|0}function HF(a){a=a|0;var b=0,c=0;b=i;c=IF(a)|0;i=b;return c|0}function IF(a){a=a|0;i=i;return a|0}function JF(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(KF(a,b)|0)^1;i=c;return d|0}function KF(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function LF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];SF(a,e);i=d;return}function MF(a,b){a=a|0;b=b|0;var c=0;c=i;NF(a,OF(b)|0);i=c;return}function NF(a,b){a=a|0;b=b|0;var c=0;c=i;RF(a,b);i=c;return}function OF(a){a=a|0;var b=0,c=0;b=i;c=XA(PF(a+4|0)|0)|0;i=b;return c|0}function PF(a){a=a|0;var b=0,c=0;b=i;c=QF(a)|0;i=b;return c|0}function QF(a){a=a|0;i=i;return a|0}function RF(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function SF(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function TF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=VF(b)|0;UF(f,b,d,h,OF(b)|0);MF(g,b);do{if(JF(f,g)|0){h=WF(b)|0;if(XF(h,d,YF(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);MF(a,b);i=e;return}function UF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;kB(h);a:do{if((e|0)==0){j=f}else{k=WF(b)|0;l=f;m=e;while(1){n=m;while(1){if(!($F(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;kB(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;kB(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);NF(a,j);i=g;return}function VF(a){a=a|0;var b=0,d=0;b=i;d=c[(OF(a)|0)>>2]|0;i=b;return d|0}function WF(a){a=a|0;var b=0,c=0;b=i;c=ZF(a+8|0)|0;i=b;return c|0}function XF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=pF(0,b,c)|0;i=a;return d|0}function YF(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function ZF(a){a=a|0;var b=0,c=0;b=i;c=_F(a)|0;i=b;return c|0}function _F(a){a=a|0;i=i;return a|0}function $F(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=pF(0,b,c)|0;i=a;return d|0}function aG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=VF(h)|0;kB(e);if((a|0)==0){j=OF(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(pF(0,d,a)|0){m=l;j=c[m>>2]|0;kB(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(pF(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;kB(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function bG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];YG(a,e);i=d;return}function cG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=DG(d)|0;d=FG(n,1)|0;GG(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];EG(j,d,h);HG(0,wG((IG(j)|0)+16|0)|0,e);e=JG(j)|0;a[e+4|0]=1;KG(0,uG((IG(j)|0)+28|0)|0);a[e+5|0]=1;LG(m,j);dG(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];bG(b,g);eG(m);eG(j);i=f;return}function dG(a,b){a=a|0;b=b|0;var c=0;c=i;BG(a,b);i=c;return}function eG(a){a=a|0;var b=0;b=i;qG(a);i=b;return}function fG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;kB(f);c[e>>2]=0;kB(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=mG(a)|0;b=c[c[e>>2]>>2]|0;kB(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(OF(a)|0)>>2]|0;WC(e,c[d>>2]|0);d=nG(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function gG(a){a=a|0;var b=0,d=0;b=i;d=c[(kG(a)|0)>>2]|0;i=b;return d|0}function hG(a){a=a|0;var b=0,d=0;b=i;d=iG(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function iG(a){a=a|0;var b=0,c=0;b=i;c=jG(a)|0;i=b;return c|0}function jG(a){a=a|0;i=i;return a|0}function kG(a){a=a|0;var b=0,c=0;b=i;c=lG(a)|0;i=b;return c|0}function lG(a){a=a|0;i=i;return a|0}function mG(a){a=a|0;i=i;return a|0}function nG(a){a=a|0;var b=0,c=0;b=i;c=oG(a+8|0)|0;i=b;return c|0}function oG(a){a=a|0;var b=0,c=0;b=i;c=pG(a)|0;i=b;return c|0}function pG(a){a=a|0;i=i;return a|0}function qG(a){a=a|0;var b=0;b=i;rG(a,0);i=b;return}function rG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=iG(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}tG(sG(e)|0,f);i=d;return}function sG(a){a=a|0;var b=0,c=0;b=i;c=AG(a)|0;i=b;return c|0}function tG(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;vG(f,wG(d+16|0)|0)}if((d|0)==0){i=e;return}xG(c[b>>2]|0,d,1);i=e;return}function uG(a){a=a|0;i=i;return a|0}function vG(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;zG(d,0,c);i=b;return}function wG(a){a=a|0;i=i;return a|0}function xG(a,b,c){a=a|0;b=b|0;c=c|0;c=i;yG(0,b,0);i=c;return}function yG(a,b,c){a=a|0;b=b|0;c=c|0;c=i;b_(b);i=c;return}function zG(a,b,c){a=a|0;b=b|0;c=c|0;b=i;QP(c);i=b;return}function AG(a){a=a|0;i=i;return a+4|0}function BG(a,b){a=a|0;b=b|0;var c=0;c=i;CG(a,b);i=c;return}function CG(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function DG(a){a=a|0;var b=0,c=0;b=i;c=WG(a+4|0)|0;i=b;return c|0}function EG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];OG(a,b,f);i=e;return}function FG(a,b){a=a|0;b=b|0;var c=0;a=i;c=NG(0,b,0)|0;i=a;return c|0}function GG(a,b){a=a|0;b=b|0;var c=0;c=i;MG(a,b);i=c;return}function HG(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}GP(b,c);i=a;return}function IG(a){a=a|0;var b=0,d=0;b=i;d=c[(kG(a)|0)>>2]|0;i=b;return d|0}function JG(a){a=a|0;var b=0,c=0;b=i;c=sG(a)|0;i=b;return c|0}function KG(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function LG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;BG(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];bG(h,f);dG(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];bG(a,e);eG(h);i=d;return}function MG(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function NG(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=$Z(b<<5)|0;i=c;return a|0}function OG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(QG(g)|0)>>2]|0;g=RG(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];PG(b,a,f);i=e;return}function PG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];SG(a,b,f);i=e;return}function QG(a){a=a|0;i=i;return a|0}function RG(a){a=a|0;i=i;return a|0}function SG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(UG(g)|0)>>2]|0;g=VG(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];TG(b,a,f);i=e;return}function TG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(UG(f)|0)>>2];f=VG(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function UG(a){a=a|0;i=i;return a|0}function VG(a){a=a|0;i=i;return a|0}function WG(a){a=a|0;var b=0,c=0;b=i;c=XG(a)|0;i=b;return c|0}function XG(a){a=a|0;i=i;return a|0}function YG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=hG(ZG(b)|0)|0;h=VG(JG(ZG(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];PG(g,a,e);i=d;return}function ZG(a){a=a|0;i=i;return c[a>>2]|0}function _G(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function $G(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];gH(a,e);i=d;return}function aH(a,b){a=a|0;b=b|0;var c=0;c=i;bH(a,cH(b)|0);i=c;return}function bH(a,b){a=a|0;b=b|0;var c=0;c=i;fH(a,b);i=c;return}function cH(a){a=a|0;var b=0,c=0;b=i;c=XA(dH(a+4|0)|0)|0;i=b;return c|0}function dH(a){a=a|0;var b=0,c=0;b=i;c=eH(a)|0;i=b;return c|0}function eH(a){a=a|0;i=i;return a|0}function fH(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function gH(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function hH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=jH(b)|0;iH(f,b,d,h,cH(b)|0);aH(g,b);do{if(kH(f,g)|0){h=lH(b)|0;if(nF(h,d,mH(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);aH(a,b);i=e;return}function iH(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;kB(h);a:do{if((e|0)==0){j=f}else{k=lH(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(oF(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;kB(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;kB(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);bH(a,j);i=g;return}function jH(a){a=a|0;var b=0,d=0;b=i;d=c[(cH(a)|0)>>2]|0;i=b;return d|0}function kH(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(_G(a,b)|0)^1;i=c;return d|0}function lH(a){a=a|0;var b=0,c=0;b=i;c=nH(a+8|0)|0;i=b;return c|0}function mH(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function nH(a){a=a|0;var b=0,c=0;b=i;c=oH(a)|0;i=b;return c|0}function oH(a){a=a|0;i=i;return a|0}function pH(a,b){a=a|0;b=b|0;b=i;i=i+8|0;qH(a,b);i=b;return}function qH(a,b){a=a|0;b=b|0;b=i;rH(a,0);i=b;return}function rH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;sH(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;tH(f,0,e);e=OF(b)|0;c[(mG(b)|0)>>2]=e;i=d;return}function sH(a){a=a|0;var b=0;b=i;wH(a);i=b;return}function tH(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;uH(b,c,f);i=e;return}function uH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(OD(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;vH(d,b,f);i=e;return}function vH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(OD(e)|0)>>2];i=d;return}function wH(a){a=a|0;var b=0;b=i;xH(a);i=b;return}function xH(a){a=a|0;var b=0;b=i;RD(a);i=b;return}function yH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=yI(h)|0;kB(e);if((a|0)==0){j=LH(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(hB(0,d,a)|0){m=l;j=c[m>>2]|0;kB(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(hB(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;kB(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function zH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];wI(a,e);i=d;return}function AH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=bI(d)|0;d=dI(n,1)|0;eI(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];cI(j,d,h);fI(0,gD((gI(j)|0)+16|0)|0,e);e=hI(j)|0;a[e+4|0]=1;iI(0,WH((gI(j)|0)+20|0)|0);a[e+5|0]=1;jI(m,j);BH(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];zH(b,g);CH(m);CH(j);i=f;return}function BH(a,b){a=a|0;b=b|0;var c=0;c=i;$H(a,b);i=c;return}function CH(a){a=a|0;var b=0;b=i;RH(a);i=b;return}function DH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;kB(f);c[e>>2]=0;kB(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=KH(a)|0;b=c[c[e>>2]>>2]|0;kB(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(LH(a)|0)>>2]|0;WC(e,c[d>>2]|0);d=MH(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function EH(a){a=a|0;var b=0,d=0;b=i;d=c[(IH(a)|0)>>2]|0;i=b;return d|0}function FH(a){a=a|0;var b=0,d=0;b=i;d=GH(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function GH(a){a=a|0;var b=0,c=0;b=i;c=HH(a)|0;i=b;return c|0}function HH(a){a=a|0;i=i;return a|0}function IH(a){a=a|0;var b=0,c=0;b=i;c=JH(a)|0;i=b;return c|0}function JH(a){a=a|0;i=i;return a|0}function KH(a){a=a|0;i=i;return a|0}function LH(a){a=a|0;var b=0,c=0;b=i;c=XA(PH(a+4|0)|0)|0;i=b;return c|0}function MH(a){a=a|0;var b=0,c=0;b=i;c=NH(a+8|0)|0;i=b;return c|0}function NH(a){a=a|0;var b=0,c=0;b=i;c=OH(a)|0;i=b;return c|0}function OH(a){a=a|0;i=i;return a|0}function PH(a){a=a|0;var b=0,c=0;b=i;c=QH(a)|0;i=b;return c|0}function QH(a){a=a|0;i=i;return a|0}function RH(a){a=a|0;var b=0;b=i;SH(a,0);i=b;return}function SH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=GH(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}UH(TH(e)|0,f);i=d;return}function TH(a){a=a|0;var b=0,c=0;b=i;c=_H(a)|0;i=b;return c|0}function UH(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;VH(f,WH(d+20|0)|0)}if((d|0)==0){i=e;return}XH(c[b>>2]|0,d,1);i=e;return}function VH(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;ZH(d,0,c);i=b;return}function WH(a){a=a|0;i=i;return a|0}function XH(a,b,c){a=a|0;b=b|0;c=c|0;c=i;YH(0,b,0);i=c;return}function YH(a,b,c){a=a|0;b=b|0;c=c|0;c=i;b_(b);i=c;return}function ZH(a,b,c){a=a|0;b=b|0;c=c|0;b=i;iF(c);i=b;return}function _H(a){a=a|0;i=i;return a+4|0}function $H(a,b){a=a|0;b=b|0;var c=0;c=i;aI(a,b);i=c;return}function aI(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function bI(a){a=a|0;var b=0,c=0;b=i;c=uI(a+4|0)|0;i=b;return c|0}function cI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];mI(a,b,f);i=e;return}function dI(a,b){a=a|0;b=b|0;var c=0;a=i;c=lI(0,b,0)|0;i=a;return c|0}function eI(a,b){a=a|0;b=b|0;var c=0;c=i;kI(a,b);i=c;return}function fI(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function gI(a){a=a|0;var b=0,d=0;b=i;d=c[(IH(a)|0)>>2]|0;i=b;return d|0}function hI(a){a=a|0;var b=0,c=0;b=i;c=TH(a)|0;i=b;return c|0}function iI(a,b){a=a|0;b=b|0;a=i;i=i+8|0;if((b|0)==0){i=a;return}aF(b,a);i=a;return}function jI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;$H(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];zH(h,f);BH(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];zH(a,e);CH(h);i=d;return}function kI(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function lI(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=$Z(b<<5)|0;i=c;return a|0}function mI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(oI(g)|0)>>2]|0;g=pI(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];nI(b,a,f);i=e;return}function nI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];qI(a,b,f);i=e;return}function oI(a){a=a|0;i=i;return a|0}function pI(a){a=a|0;i=i;return a|0}function qI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(sI(g)|0)>>2]|0;g=tI(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];rI(b,a,f);i=e;return}function rI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(sI(f)|0)>>2];f=tI(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function sI(a){a=a|0;i=i;return a|0}function tI(a){a=a|0;i=i;return a|0}function uI(a){a=a|0;var b=0,c=0;b=i;c=vI(a)|0;i=b;return c|0}function vI(a){a=a|0;i=i;return a|0}function wI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=FH(xI(b)|0)|0;h=tI(hI(xI(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];nI(g,a,e);i=d;return}function xI(a){a=a|0;i=i;return c[a>>2]|0}function yI(a){a=a|0;var b=0,d=0;b=i;d=c[(LH(a)|0)>>2]|0;i=b;return d|0}function zI(a,b){a=a|0;b=b|0;b=i;i=i+8|0;AI(a,b);i=b;return}function AI(a,b){a=a|0;b=b|0;b=i;BI(a,0);i=b;return}function BI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;CI(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;DI(f,0,e);e=cH(b)|0;c[(EI(b)|0)>>2]=e;i=d;return}function CI(a){a=a|0;var b=0;b=i;HI(a);i=b;return}function DI(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;FI(b,c,f);i=e;return}function EI(a){a=a|0;i=i;return a|0}function FI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(OD(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;GI(d,b,f);i=e;return}function GI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(OD(e)|0)>>2];i=d;return}function HI(a){a=a|0;var b=0;b=i;II(a);i=b;return}function II(a){a=a|0;var b=0;b=i;RD(a);i=b;return}function JI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=jH(h)|0;kB(e);if((a|0)==0){j=cH(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(pF(0,d,a)|0){m=l;j=c[m>>2]|0;kB(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(pF(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;kB(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function KI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];FJ(a,e);i=d;return}function LI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=kJ(d)|0;d=mJ(n,1)|0;nJ(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];lJ(j,d,h);oJ(0,wG((pJ(j)|0)+16|0)|0,e);e=qJ(j)|0;a[e+4|0]=1;rJ(0,bJ((pJ(j)|0)+28|0)|0);a[e+5|0]=1;sJ(m,j);MI(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];KI(b,g);NI(m);NI(j);i=f;return}function MI(a,b){a=a|0;b=b|0;var c=0;c=i;iJ(a,b);i=c;return}function NI(a){a=a|0;var b=0;b=i;YI(a);i=b;return}function OI(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;kB(f);c[e>>2]=0;kB(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=EI(a)|0;b=c[c[e>>2]>>2]|0;kB(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(cH(a)|0)>>2]|0;WC(e,c[d>>2]|0);d=VI(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function PI(a){a=a|0;var b=0,d=0;b=i;d=c[(TI(a)|0)>>2]|0;i=b;return d|0}function QI(a){a=a|0;var b=0,d=0;b=i;d=RI(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function RI(a){a=a|0;var b=0,c=0;b=i;c=SI(a)|0;i=b;return c|0}function SI(a){a=a|0;i=i;return a|0}function TI(a){a=a|0;var b=0,c=0;b=i;c=UI(a)|0;i=b;return c|0}function UI(a){a=a|0;i=i;return a|0}function VI(a){a=a|0;var b=0,c=0;b=i;c=WI(a+8|0)|0;i=b;return c|0}function WI(a){a=a|0;var b=0,c=0;b=i;c=XI(a)|0;i=b;return c|0}function XI(a){a=a|0;i=i;return a|0}function YI(a){a=a|0;var b=0;b=i;ZI(a,0);i=b;return}function ZI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=RI(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}$I(_I(e)|0,f);i=d;return}function _I(a){a=a|0;var b=0,c=0;b=i;c=hJ(a)|0;i=b;return c|0}function $I(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;aJ(f,bJ(d+28|0)|0)}if((a[b+4|0]|0)!=0){f=c[b>>2]|0;cJ(f,wG(d+16|0)|0)}if((d|0)==0){i=e;return}dJ(c[b>>2]|0,d,1);i=e;return}function aJ(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;gJ(d,0,c);i=b;return}function bJ(a){a=a|0;i=i;return a|0}function cJ(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;fJ(d,0,c);i=b;return}function dJ(a,b,c){a=a|0;b=b|0;c=c|0;c=i;eJ(0,b,0);i=c;return}function eJ(a,b,c){a=a|0;b=b|0;c=c|0;c=i;b_(b);i=c;return}function fJ(a,b,c){a=a|0;b=b|0;c=c|0;b=i;QP(c);i=b;return}function gJ(a,b,c){a=a|0;b=b|0;c=c|0;b=i;QP(c);i=b;return}function hJ(a){a=a|0;i=i;return a+4|0}function iJ(a,b){a=a|0;b=b|0;var c=0;c=i;jJ(a,b);i=c;return}function jJ(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function kJ(a){a=a|0;var b=0,c=0;b=i;c=DJ(a+4|0)|0;i=b;return c|0}function lJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];vJ(a,b,f);i=e;return}function mJ(a,b){a=a|0;b=b|0;var c=0;a=i;c=uJ(0,b,0)|0;i=a;return c|0}function nJ(a,b){a=a|0;b=b|0;var c=0;c=i;tJ(a,b);i=c;return}function oJ(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}GP(b,c);i=a;return}function pJ(a){a=a|0;var b=0,d=0;b=i;d=c[(TI(a)|0)>>2]|0;i=b;return d|0}function qJ(a){a=a|0;var b=0,c=0;b=i;c=_I(a)|0;i=b;return c|0}function rJ(a,b){a=a|0;b=b|0;a=i;if((b|0)==0){i=a;return}EP(b);i=a;return}function sJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;iJ(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];KI(h,f);MI(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];KI(a,e);NI(h);i=d;return}function tJ(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function uJ(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=$Z(b*40|0)|0;i=c;return a|0}function vJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(xJ(g)|0)>>2]|0;g=yJ(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];wJ(b,a,f);i=e;return}function wJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];zJ(a,b,f);i=e;return}function xJ(a){a=a|0;i=i;return a|0}function yJ(a){a=a|0;i=i;return a|0}function zJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(BJ(g)|0)>>2]|0;g=CJ(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];AJ(b,a,f);i=e;return}function AJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(BJ(f)|0)>>2];f=CJ(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function BJ(a){a=a|0;i=i;return a|0}function CJ(a){a=a|0;i=i;return a|0}function DJ(a){a=a|0;var b=0,c=0;b=i;c=EJ(a)|0;i=b;return c|0}function EJ(a){a=a|0;i=i;return a|0}function FJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=QI(GJ(b)|0)|0;h=CJ(qJ(GJ(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];wJ(g,a,e);i=d;return}function GJ(a){a=a|0;i=i;return c[a>>2]|0}function HJ(a){a=a|0;var b=0;b=i;IJ(a);i=b;return}function IJ(a){a=a|0;var b=0;b=i;JJ(a);i=b;return}function JJ(a){a=a|0;var b=0;b=i;KJ(a,jH(a)|0);i=b;return}function KJ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;kB(d);if((b|0)==0){i=d;return}KJ(a,c[b>>2]|0);KJ(a,c[b+4>>2]|0);e=kJ(a)|0;LJ(e,MJ(b+16|0)|0);dJ(e,b,1);i=d;return}function LJ(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;NJ(d,0,c);i=b;return}function MJ(a){a=a|0;i=i;return a|0}function NJ(a,b,c){a=a|0;b=b|0;c=c|0;b=i;OJ(c);i=b;return}function OJ(a){a=a|0;var b=0;b=i;PJ(a);i=b;return}function PJ(a){a=a|0;var b=0;b=i;QJ(a);i=b;return}function QJ(a){a=a|0;var b=0;b=i;RJ(a);i=b;return}function RJ(a){a=a|0;var b=0;b=i;QP(a+12|0);QP(a);i=b;return}function SJ(a){a=a|0;var b=0;b=i;TJ(a+180|0);TJ(a+168|0);TJ(a+156|0);TJ(a+144|0);TJ(a+132|0);TJ(a+120|0);TJ(a+108|0);TJ(a+96|0);TJ(a+84|0);TJ(a+72|0);TJ(a+60|0);TJ(a+48|0);TJ(a+36|0);TJ(a+24|0);iF(a+12|0);iF(a);i=b;return}function TJ(a){a=a|0;var b=0;b=i;UJ(a);i=b;return}function UJ(a){a=a|0;var b=0;b=i;VJ(a);i=b;return}function VJ(a){a=a|0;var b=0;b=i;WJ(a);i=b;return}function WJ(a){a=a|0;var b=0;b=i;XJ(a,yI(a)|0);i=b;return}function XJ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;kB(d);if((b|0)==0){i=d;return}XJ(a,c[b>>2]|0);XJ(a,c[b+4>>2]|0);e=bI(a)|0;YJ(e,ZJ(b+16|0)|0);XH(e,b,1);i=d;return}function YJ(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;_J(d,0,c);i=b;return}function ZJ(a){a=a|0;i=i;return a|0}function _J(a,b,c){a=a|0;b=b|0;c=c|0;b=i;$J(c);i=b;return}function $J(a){a=a|0;var b=0;b=i;aK(a);i=b;return}function aK(a){a=a|0;var b=0;b=i;bK(a);i=b;return}function bK(a){a=a|0;var b=0;b=i;cK(a);i=b;return}function cK(a){a=a|0;var b=0;b=i;iF(a+4|0);i=b;return}function dK(a){a=a|0;var b=0;b=i;eK(a);i=b;return}function eK(a){a=a|0;var b=0;b=i;fK(a);i=b;return}function fK(a){a=a|0;var b=0;b=i;gK(a,VF(a)|0);i=b;return}function gK(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;kB(d);if((b|0)==0){i=d;return}gK(a,c[b>>2]|0);gK(a,c[b+4>>2]|0);e=DG(a)|0;hK(e,IF(b+16|0)|0);xG(e,b,1);i=d;return}function hK(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;iK(d,0,c);i=b;return}function iK(a,b,c){a=a|0;b=b|0;c=c|0;b=i;jK(c);i=b;return}function jK(a){a=a|0;var b=0;b=i;kK(a);i=b;return}function kK(a){a=a|0;var b=0;b=i;lK(a);i=b;return}function lK(a){a=a|0;var b=0;b=i;mK(a);i=b;return}function mK(a){a=a|0;var b=0;b=i;QP(a);i=b;return}function nK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;oK(a);qK(g,b);rK(h,b);b=f;j=g;c[b+0>>2]=c[j+0>>2];j=e;b=h;c[j+0>>2]=c[b+0>>2];pK(a,f,e);i=d;return a|0}function oK(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;KJ(a,jH(a)|0);c[(VI(a)|0)>>2]=0;d=cH(a)|0;c[(EI(a)|0)>>2]=d;kB(b);c[d>>2]=0;i=b;return}function pK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;zK(h,a);if(!(AK(b,d)|0)){i=e;return}m=c[h>>2]|0;h=k;do{c[h>>2]=m;n=g;o=k;c[n+0>>2]=c[o+0>>2];sK(j,g);o=CK(b)|0;n=f;p=j;c[n+0>>2]=c[p+0>>2];BK(l,a,f,o);DK(b)|0;}while(AK(b,d)|0);i=e;return}function qK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;xK(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];sK(a,e);i=d;return}function rK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;tK(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];sK(a,e);i=d;return}function sK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];wK(a,e);i=d;return}function tK(a,b){a=a|0;b=b|0;var c=0;c=i;uK(a,kF(b)|0);i=c;return}function uK(a,b){a=a|0;b=b|0;var c=0;c=i;vK(a,b);i=c;return}function vK(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function wK(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function xK(a,b){a=a|0;b=b|0;var d=0;d=i;uK(a,c[(yK(b)|0)>>2]|0);i=d;return}function yK(a){a=a|0;i=i;return a|0}function zK(a,b){a=a|0;b=b|0;var c=0;c=i;rK(a,b);i=c;return}function AK(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=JL(a,b)|0;i=c;return d|0}function BK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+56|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=b;c[k>>2]=c[d>>2];LK(l,e);e=h;d=k;c[e+0>>2]=c[d+0>>2];KK(j,m,h,l);h=g;m=j;c[h+0>>2]=c[m+0>>2];$G(a,g);OJ(l);i=f;return}function CK(a){a=a|0;var b=0,c=0;b=i;c=HK(a)|0;i=b;return c|0}function DK(a){a=a|0;var b=0;b=i;EK(a)|0;i=b;return a|0}function EK(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=FK(c[d>>2]|0)|0;i=b;return a|0}function FK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;kB(b);if((e|0)==0){e=a;while(1){a=_C(e)|0;f=c[e+8>>2]|0;if(a){g=f;break}else{e=f}}i=b;return g|0}else{g=GK(c[d>>2]|0)|0;i=b;return g|0}return 0}function GK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a;f=c[e>>2]|0;kB(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e;f=c[a>>2]|0;kB(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function HK(a){a=a|0;var b=0,d=0;b=i;d=IK((c[a>>2]|0)+16|0)|0;i=b;return d|0}function IK(a){a=a|0;var b=0,c=0;b=i;c=JK(a)|0;i=b;return c|0}function JK(a){a=a|0;i=i;return a|0}function KK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+56|0;o=f+64|0;c[k>>2]=c[d>>2];d=h;p=k;c[d+0>>2]=c[p+0>>2];p=PK(b,h,j,e)|0;h=c[p>>2]|0;kB(l);if((h|0)!=0){q=h;bH(a,q);i=f;return}RK(o,b,e);SK(n,o);e=g;h=n;c[e+0>>2]=c[h+0>>2];QK(m,g);TK(o);o=c[j>>2]|0;OI(b,o,p,UK(m)|0);p=VK(m)|0;TK(m);q=p;bH(a,q);i=f;return}function LK(a,b){a=a|0;b=b|0;var c=0;c=i;MK(a,b);i=c;return}function MK(a,b){a=a|0;b=b|0;var c=0;c=i;NK(a,b);i=c;return}function NK(a,b){a=a|0;b=b|0;var c=0;c=i;OK(a,b);i=c;return}function OK(a,b){a=a|0;b=b|0;var c=0;c=i;GP(a,b);GP(a+12|0,b+12|0);i=c;return}function PK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+120|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=f+64|0;q=f+72|0;r=f+80|0;s=f+88|0;t=f+96|0;u=f+104|0;v=f+112|0;aH(m,a);w=k;x=m;c[w+0>>2]=c[x+0>>2];xL(l,k);do{if(!(wL(b,l)|0)){k=lH(a)|0;x=zL(b)|0;if(yL(k,e,x)|0){break}w=yL(k,x,e)|0;x=c[b>>2]|0;if(!w){c[d>>2]=x;y=d;i=f;return y|0}c[s>>2]=x;w=h;m=s;c[w+0>>2]=c[m+0>>2];DL(r,h,1,0);aH(u,a);m=g;w=u;c[m+0>>2]=c[w+0>>2];xL(t,g);do{if(!(wL(r,t)|0)){if(yL(k,e,zL(r)|0)|0){break}y=CL(a,d,e)|0;i=f;return y|0}}while(0);k=x+4|0;w=c[k>>2]|0;kB(v);if((w|0)==0){c[d>>2]=x;y=k;i=f;return y|0}else{k=c[r>>2]|0;c[d>>2]=k;y=k;i=f;return y|0}}}while(0);r=c[b>>2]|0;b=n;c[b>>2]=r;AL(p,a);v=j;t=p;c[v+0>>2]=c[t+0>>2];xL(o,j);do{if(!(wL(n,o)|0)){j=lH(a)|0;if(yL(j,zL(BL(n)|0)|0,e)|0){break}y=CL(a,d,e)|0;i=f;return y|0}}while(0);e=r;a=c[e>>2]|0;kB(q);if((a|0)==0){c[d>>2]=r;y=e;i=f;return y|0}else{e=c[b>>2]|0;c[d>>2]=e;y=e+4|0;i=f;return y|0}return 0}function QK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];uL(a,e);i=d;return}function RK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=kJ(d)|0;d=mJ(n,1)|0;gL(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];fL(j,d,h);hL(0,MJ((iL(j)|0)+16|0)|0,e);a[(jL(j)|0)+4|0]=1;kL(m,j);SK(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];QK(b,g);TK(m);TK(j);i=f;return}function SK(a,b){a=a|0;b=b|0;var c=0;c=i;dL(a,b);i=c;return}function TK(a){a=a|0;var b=0;b=i;_K(a);i=b;return}function UK(a){a=a|0;var b=0,d=0;b=i;d=c[(YK(a)|0)>>2]|0;i=b;return d|0}function VK(a){a=a|0;var b=0,d=0;b=i;d=WK(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function WK(a){a=a|0;var b=0,c=0;b=i;c=XK(a)|0;i=b;return c|0}function XK(a){a=a|0;i=i;return a|0}function YK(a){a=a|0;var b=0,c=0;b=i;c=ZK(a)|0;i=b;return c|0}function ZK(a){a=a|0;i=i;return a|0}function _K(a){a=a|0;var b=0;b=i;$K(a,0);i=b;return}function $K(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=WK(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}bL(aL(e)|0,f);i=d;return}function aL(a){a=a|0;var b=0,c=0;b=i;c=cL(a)|0;i=b;return c|0}function bL(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;LJ(f,MJ(d+16|0)|0)}if((d|0)==0){i=e;return}dJ(c[b>>2]|0,d,1);i=e;return}function cL(a){a=a|0;i=i;return a+4|0}function dL(a,b){a=a|0;b=b|0;var c=0;c=i;eL(a,b);i=c;return}function eL(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function fL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];oL(a,b,f);i=e;return}function gL(a,b){a=a|0;b=b|0;var c=0;c=i;nL(a,b);i=c;return}function hL(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}lL(b,c);i=a;return}function iL(a){a=a|0;var b=0,d=0;b=i;d=c[(YK(a)|0)>>2]|0;i=b;return d|0}function jL(a){a=a|0;var b=0,c=0;b=i;c=aL(a)|0;i=b;return c|0}function kL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;dL(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];QK(h,f);SK(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];QK(a,e);TK(h);i=d;return}function lL(a,b){a=a|0;b=b|0;var c=0;c=i;mL(a,b);i=c;return}function mL(a,b){a=a|0;b=b|0;var c=0;c=i;NK(a,b);i=c;return}function nL(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;i=i;return}function oL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(xJ(g)|0)>>2]|0;g=qL(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];pL(b,a,f);i=e;return}function pL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];rL(a,b,f);i=e;return}function qL(a){a=a|0;i=i;return a|0}function rL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(BJ(g)|0)>>2]|0;g=tL(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];sL(b,a,f);i=e;return}function sL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(BJ(f)|0)>>2];f=tL(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function tL(a){a=a|0;i=i;return a|0}function uL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=VK(vL(b)|0)|0;h=tL(jL(vL(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];pL(g,a,e);i=d;return}function vL(a){a=a|0;i=i;return c[a>>2]|0}function wL(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function xL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];IL(a,e);i=d;return}function yL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=pF(0,b,c)|0;i=a;return d|0}function zL(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function AL(a,b){a=a|0;b=b|0;var d=0;d=i;bH(a,c[(EI(b)|0)>>2]|0);i=d;return}function BL(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=GL(c[d>>2]|0)|0;i=b;return a|0}function CL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=jH(a)|0;kB(e);if((h|0)==0){j=cH(a)|0;c[b>>2]=j;k=j;i=e;return k|0}j=lH(a)|0;a=h;while(1){h=a+16|0;if(yL(j,d,h)|0){l=a;m=c[l>>2]|0;kB(f);if((m|0)==0){n=5;break}else{o=l}}else{p=a;if(!(yL(j,h,d)|0)){n=10;break}q=a+4|0;h=c[q>>2]|0;kB(g);if((h|0)==0){n=9;break}else{o=q}}a=c[o>>2]|0}if((n|0)==5){c[b>>2]=a;k=l;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==10){c[b>>2]=p;k=b;i=e;return k|0}return 0}function DL(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;EL(b,d);c[a>>2]=c[b>>2];i=e;return}function EL(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;FL(b,c,e);i=d;return}function FL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;if(!((b|0)>-1)){d=b;do{BL(a)|0;d=d+1|0;}while((d|0)<0);i=c;return}if((b|0)>0){e=b}else{i=c;return}do{EK(a)|0;e=e+ -1|0;}while((e|0)>0);i=c;return}function GL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;kB(b);if((e|0)==0){e=a;while(1){a=_C(e)|0;f=c[e+8>>2]|0;if(a){e=f}else{g=f;break}}i=b;return g|0}else{g=HL(c[d>>2]|0)|0;i=b;return g|0}return 0}function HL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[e>>2]|0;kB(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e+4|0;f=c[a>>2]|0;kB(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function IL(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function JL(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(wL(a,b)|0)^1;i=c;return d|0}function KL(a){a=a|0;var b=0;b=i;i=i+128|0;aF(a,b);aF(a+12|0,b+8|0);LL(a+24|0,b+16|0);LL(a+36|0,b+24|0);LL(a+48|0,b+32|0);LL(a+60|0,b+40|0);LL(a+72|0,b+48|0);LL(a+84|0,b+56|0);LL(a+96|0,b+64|0);LL(a+108|0,b+72|0);LL(a+120|0,b+80|0);LL(a+132|0,b+88|0);LL(a+144|0,b+96|0);LL(a+156|0,b+104|0);LL(a+168|0,b+112|0);LL(a+180|0,b+120|0);i=b;return}function LL(a,b){a=a|0;b=b|0;b=i;ML(a,0);i=b;return}function ML(a,b){a=a|0;b=b|0;b=i;i=i+8|0;NL(a,b);i=b;return}function NL(a,b){a=a|0;b=b|0;b=i;OL(a,0);i=b;return}function OL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;PL(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;QL(f,0,e);e=LH(b)|0;c[(KH(b)|0)>>2]=e;i=d;return}function PL(a){a=a|0;var b=0;b=i;TL(a);i=b;return}function QL(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;RL(b,c,f);i=e;return}function RL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(OD(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;SL(d,b,f);i=e;return}function SL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(OD(e)|0)>>2];i=d;return}function TL(a){a=a|0;var b=0;b=i;UL(a);i=b;return}function UL(a){a=a|0;var b=0;b=i;RD(a);i=b;return}function VL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=c[89540>>2]|0;if((m|0)==0){n=0}else{o=$Z(12)|0;KP(o,m);n=o}if((c[89456>>2]|0)!=0){c[8894]=1}if((n|0)==0){c[35588>>2]=1;c[35592>>2]=1;i=b;return}do{if((mQ(n,79792,0)|0)==-1){GP(g,n);EP(h);o=c[8468]|0;m=(o|0)<28;while(1){p=mQ(g,79800,0)|0;q=(p|0)!=-1;if(q){kQ(j,g,0,p);RP(h,j)|0;QP(j);kQ(k,g,p+1|0,-1);RP(g,k)|0;QP(k)}else{RP(h,g)|0}if(m){r=1;s=o}else{t=20;break}while(1){KP(l,c[34288+(s<<2)>>2]|0);p=WL(h,l)|0;QP(l);if(p){c[35584+(s<<2)>>2]=1;u=0}else{u=r}p=s+1|0;if((p|0)<28){r=u;s=p}else{break}}if((u|0)!=0){t=18;break}if(!q){t=23;break}}if((t|0)==18){iw(1,1,79808,f);if(m){v=o}else{w=36136;x=c[9034]|0;be[x&255](1);y=lQ(n)|0;z=a;A=z;c[A>>2]=y;B=4;C=B;D=79848;E=D;kw(0,E,a)}do{p=c[35456+(v<<2)>>2]|0;c[e>>2]=c[34288+(v<<2)>>2];c[e+4>>2]=p;iw(1,0,79832,e);v=v+1|0;}while((v|0)<28);w=36136;x=c[9034]|0;be[x&255](1);y=lQ(n)|0;z=a;A=z;c[A>>2]=y;B=4;C=B;D=79848;E=D;kw(0,E,a)}else if((t|0)==20){iw(1,1,79808,d);w=36136;x=c[9034]|0;be[x&255](1);y=lQ(n)|0;z=a;A=z;c[A>>2]=y;B=4;C=B;D=79848;E=D;kw(0,E,a)}else if((t|0)==23){QP(h);QP(g);break}}else{o=1;do{c[35584+(o<<2)>>2]=1;o=o+1|0;}while((o|0)<28)}}while(0);c[35588>>2]=1;c[35592>>2]=1;if((c[35620>>2]|0)!=0){c[35680>>2]=1}if((c[35676>>2]|0)==1){c[35684>>2]=1}if((c[35656>>2]|0)!=0){c[35652>>2]=1}if((c[35664>>2]|0)!=0){c[35652>>2]=1}if((c[35616>>2]|0)!=0){c[35612>>2]=1}if((c[35660>>2]|0)!=0){c[35652>>2]=1}if((c[35608>>2]|0)!=0){c[35604>>2]=1}QP(n);b_(n);i=b;return}function WL(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=OP(b)|0;if((e|0)!=(OP(c)|0)){f=0;i=d;return f|0}g=PP(b)|0;h=PP(c)|0;if(HP(b)|0){f=(rF(g,h,e)|0)==0;i=d;return f|0}if((e|0)==0){f=1;i=d;return f|0}else{j=e;k=g;l=h}while(1){if((a[k]|0)!=(a[l]|0)){f=0;m=7;break}h=j+ -1|0;if((h|0)==0){f=1;m=7;break}else{j=h;k=k+1|0;l=l+1|0}}if((m|0)==7){i=d;return f|0}return 0}function XL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=c[89548>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=$Z(12)|0;l=k;KP(l,h);if((k|0)==0){j=1;i=b;return j|0}else{m=1}while(1){k=m+1|0;if(YL(l,c[67312+(m<<2)>>2]|0)|0){j=m;n=6;break}if((k|0)<4){m=k}else{n=5;break}}if((n|0)==5){c[g>>2]=lQ(l)|0;iw(1,1,79880,g);g=c[67396>>2]|0;c[f>>2]=c[67316>>2];c[f+4>>2]=g;iw(1,0,79832,f);f=c[67400>>2]|0;c[e>>2]=c[67320>>2];c[e+4>>2]=f;iw(1,0,79832,e);e=c[67404>>2]|0;c[d>>2]=c[67324>>2];c[d+4>>2]=e;iw(1,0,79832,d);be[c[9034]&255](1);kw(0,79936,a)}else if((n|0)==6){i=b;return j|0}return 0}function YL(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(oQ(a,b)|0)==0;i=c;return d|0}function ZL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;a=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+16|0;g=i;i=i+16|0;h=c[89532>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=$Z(12)|0;l=k;KP(l,h);if((k|0)==0){j=1;i=b;return j|0}KP(f,79960);k=WL(l,f)|0;QP(f);if(k){j=1;i=b;return j|0}KP(g,79968);k=WL(l,g)|0;QP(g);if(k){j=2;i=b;return j|0}else{c[e>>2]=lQ(l)|0;iw(1,1,79976,e);c[d>>2]=79960;c[d+4>>2]=80032;iw(1,0,79832,d);c[a>>2]=79968;c[a+4>>2]=80048;iw(1,0,79832,a);be[c[9034]&255](1);kw(0,79936,b)}return 0}function _L(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;ZR(f,a);if(!(aS(f)|0)){_R(f);i=d;return a|0}j=zF(b)|0;kM(g,a);k=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;l=k;if(((oB(l)|0)&176|0)==32){m=b+j|0}else{m=b}n=KQ(k)|0;k=b+j|0;j=e;o=g;c[j+0>>2]=c[o+0>>2];nM(h,e,b,m,k,l,n);if(!(lM(h)|0)){_R(f);i=d;return a|0}EQ(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,5);_R(f);i=d;return a|0}function $L(a){a=a|0;var b=0;b=i;dS(a,LQ(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;MR(a)|0;i=b;return a|0}function aM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+2128|0;g=f;h=f+32|0;j=f+48|0;k=f+64|0;l=f+80|0;KP(h,d);zQ(k,80056,h);ME(j,k,80064);QP(k);k=lQ(j)|0;d=b+104|0;do{if((c[d>>2]|0)>0){m=b;n=c[m>>2]|0;if((t_(c[n+4>>2]|0,80072)|0)!=0){break}a[n+104|0]=1;a[(c[m>>2]|0)+((c[d>>2]|0)*112|0)+104|0]=1}}while(0);if((t_(k,80080)|0)==0){QP(j);QP(h);i=f;return}d=bZ(g,k,1)|0;if((d|0)!=0){m=l;B_(m|0,0,2048)|0;oZ(d,g,m,2048)|0;bS(_L(_L(_L(_L(_L(101936,80088)|0,k)|0,80128)|0,m)|0,80144)|0,103)|0;QP(j);QP(h);i=f;return}m=b+108|0;k=c[m>>2]|0;if((k|0)>0){d=b;l=k;k=0;while(1){n=c[d>>2]|0;if((a[n+(k*112|0)+104|0]|0)==0){o=(pZ(g,c[n+(k*112|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(k*112|0)+104|0]=o;p=c[m>>2]|0}else{p=l}o=k+1|0;if((o|0)<(p|0)){l=p;k=o}else{break}}}k=b+208|0;if((c[k>>2]|0)>0){p=b+32|0;l=b;m=(e|0)==0;d=b+16|0;o=0;do{n=c[p>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){q=a[n+(o*52|0)+8|0]|0;if(q<<24>>24==1){r=(pZ(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=r;r=c[p>>2]|0;if((a[r+(o*52|0)+48|0]|0)!=0|m){break}a[(c[d>>2]|0)+((c[r+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else if(q<<24>>24==0){q=(pZ(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=q;q=c[p>>2]|0;if((a[q+(o*52|0)+48|0]|0)!=0){break}a[(c[l>>2]|0)+((c[q+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else{break}}}while(0);o=o+1|0;}while((o|0)<(c[k>>2]|0))}k=b+116|0;o=c[k>>2]|0;if((o|0)>0){l=b+4|0;p=o;o=0;while(1){d=c[l>>2]|0;if((a[d+(o*60|0)+56|0]|0)==0){m=(pZ(g,c[d+(o*60|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(o*60|0)+56|0]=m;s=c[k>>2]|0}else{s=p}m=o+1|0;if((m|0)<(s|0)){p=s;o=m}else{break}}}o=b+212|0;if((c[o>>2]|0)>0){s=b+36|0;p=b+4|0;k=(e|0)==0;l=b+20|0;m=0;do{d=c[s>>2]|0;do{if((a[d+(m*52|0)+48|0]|0)==0){n=a[d+(m*52|0)+8|0]|0;if(n<<24>>24==1){q=(pZ(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=q;q=c[s>>2]|0;if((a[q+(m*52|0)+48|0]|0)!=0|k){break}a[(c[l>>2]|0)+((c[q+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else if(n<<24>>24==0){n=(pZ(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=n;n=c[s>>2]|0;if((a[n+(m*52|0)+48|0]|0)!=0){break}a[(c[p>>2]|0)+((c[n+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else{break}}}while(0);m=m+1|0;}while((m|0)<(c[o>>2]|0))}o=b+120|0;m=c[o>>2]|0;if((m|0)>0){p=b+8|0;s=m;m=0;while(1){l=c[p>>2]|0;if((a[l+(m*48|0)+44|0]|0)==0){k=(pZ(g,c[l+(m*48|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(m*48|0)+44|0]=k;t=c[o>>2]|0}else{t=s}k=m+1|0;if((k|0)<(t|0)){s=t;m=k}else{break}}}m=b+216|0;if((c[m>>2]|0)>0){t=b+40|0;s=b+8|0;o=(e|0)==0;p=b+24|0;k=0;do{l=c[t>>2]|0;do{if((a[l+(k*52|0)+48|0]|0)==0){d=a[l+(k*52|0)+8|0]|0;if(d<<24>>24==1){n=(pZ(g,c[l+(k*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(k*52|0)+48|0]=n;n=c[t>>2]|0;if((a[n+(k*52|0)+48|0]|0)!=0|o){break}a[(c[p>>2]|0)+((c[n+(k*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else if(d<<24>>24==0){d=(pZ(g,c[l+(k*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(k*52|0)+48|0]=d;d=c[t>>2]|0;if((a[d+(k*52|0)+48|0]|0)!=0){break}a[(c[s>>2]|0)+((c[d+(k*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else{break}}}while(0);k=k+1|0;}while((k|0)<(c[m>>2]|0))}m=b+124|0;k=c[m>>2]|0;if((k|0)>0){s=b+12|0;t=k;k=0;while(1){p=c[s>>2]|0;if((a[p+(k*52|0)+48|0]|0)==0){o=(pZ(g,c[p+(k*52|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(k*52|0)+48|0]=o;u=c[m>>2]|0}else{u=t}o=k+1|0;if((o|0)<(u|0)){t=u;k=o}else{break}}}k=b+220|0;if((c[k>>2]|0)>0){u=b+44|0;t=b+12|0;m=(e|0)==0;e=b+28|0;b=0;do{s=c[u>>2]|0;do{if((a[s+(b*52|0)+48|0]|0)==0){o=a[s+(b*52|0)+8|0]|0;if(o<<24>>24==0){p=(pZ(g,c[s+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=p;p=c[u>>2]|0;if((a[p+(b*52|0)+48|0]|0)!=0){break}a[(c[t>>2]|0)+((c[p+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else if(o<<24>>24==1){o=(pZ(g,c[s+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=o;o=c[u>>2]|0;if((a[o+(b*52|0)+48|0]|0)!=0|m){break}a[(c[e>>2]|0)+((c[o+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else{break}}}while(0);b=b+1|0;}while((b|0)<(c[k>>2]|0))}fZ(g);QP(j);QP(h);i=f;return}function bM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0;b=i;i=i+8|0;a=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[89396>>2]|0;H=c[89524>>2]|0;I=c[2]|0;if((c[35684>>2]|0)==0){if(!((c[89344>>2]|0)==0|(I|0)!=0)){J=3}}else{J=3}if((J|0)==3){c[2]=1}J=d+248|0;K=d+240|0;L=~~+yb(+((+h[J>>3]- +h[K>>3])/+h[d+264>>3]));c[d+256>>2]=L;c[l>>2]=L;gw(23,0,80192,l);l=c[89468>>2]|0;do{if((l|0)==0){M=0}else{if((t_(l,80216)|0)==0){M=1;break}if((t_(l,80224)|0)==0){M=0;break}if((t_(l,80232)|0)==0){M=2;break}c[j>>2]=l;iw(1,0,80240,j);M=0}}while(0);if((ix(M)|0)!=0){c[g>>2]=l;iw(1,0,80312,g)}if((c[2]|0)!=0){iN(d+56|0);nx((c[d+64>>2]|0)+13+(c[d+68>>2]|0)+(c[d+72>>2]|0)|0);jx(0);jx(6);kx(3);kx(4);kx(1)}g=(G|0)!=0;if(g){if((H|0)==0){N=+h[K>>3]}else{N=+p_(H)}h[J>>3]=N;J=f;h[k>>3]=N;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];gw(1,0,80400,f)}do{if((c[89452>>2]|0)!=0){f=$Z(12)|0;J=f;KP(J,c[89580>>2]|0);if((f|0)==0){break}f=lQ(J)|0;c[d+280>>2]=f;c[e>>2]=f;gw(23,0,80456,e)}}while(0);e=c[89576>>2]|0;EP(m);if((e|0)==0){KP(p,c[d+88>>2]|0);KP(q,80504);cM(o,p,q);ME(n,o,c[d+284>>2]|0);RP(m,n)|0;QP(n);QP(o);QP(q);QP(p)}else{SP(m,e)|0}KP(r,80512);KP(s,80512);KP(t,80512);KP(u,80512);KP(v,80512);KP(w,80512);e=c[89344>>2]|0;if((c[89364>>2]|0)!=0){SP(r,c[89492>>2]|0)|0}if((c[89380>>2]|0)!=0){SP(s,c[89508>>2]|0)|0}if((c[89360>>2]|0)!=0){SP(t,c[89488>>2]|0)|0}if((c[89368>>2]|0)==0){O=0.0}else{SP(u,c[89496>>2]|0)|0;O=+p_(lQ(u)|0)}if((c[89372>>2]|0)==0){P=1}else{SP(v,c[89500>>2]|0)|0;P=Bc(lQ(v)|0)|0}if((c[89432>>2]|0)!=0){SP(w,c[89560>>2]|0)|0}GP(x,m);GP(y,r);GP(z,s);GP(A,t);GP(B,w);p=dM(d,x,y,z,A,O,P,B,e)|0;QP(B);QP(A);QP(z);QP(y);QP(x);if((p|0)!=0|g^1){Q=p}else{jx(5);p=zM(d)|0;mx(5);gw(1,0,80520,a);Q=p}c[2]=I;if(!((Q|0)==0&(I|0)!=0)){R=Q;QP(w);QP(v);QP(u);QP(t);QP(s);QP(r);QP(m);i=b;return R|0}Q=d+88|0;KP(D,c[Q>>2]|0);ME(C,D,80552);QP(D);KP(F,c[Q>>2]|0);ME(E,F,80568);QP(F);mx(0);F=c[89544>>2]|0;Q=lQ(C)|0;D=lQ(E)|0;I=c[d+280>>2]|0;p=c[d+284>>2]|0;YM(d,Q,D,(F|0)!=0?F:80584,I,p,lQ(m)|0)|0;QP(E);QP(C);R=0;QP(w);QP(v);QP(u);QP(t);QP(s);QP(r);QP(m);i=b;return R|0}function cM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;FP(a,d);e=OP(b)|0;f=OP(c)|0;pQ(a,PP(b)|0,e,f+e|0);hQ(a,PP(c)|0,f)|0;i=d;return}function dM(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;if((OP(j)|0)==0){u=0}else{u=lQ(j)|0}GP(r,b);b=(eM(a,r,k)|0)==0;QP(r);if(!b){v=-1;i=l;return v|0}KP(s,80512);b=a+280|0;r=YL(s,c[b>>2]|0)|0;QP(s);do{if(r){w=3}else{s=1;k=0;do{KP(t,c[80728+(s<<2)>>2]|0);j=YL(t,c[b>>2]|0)|0;QP(t);k=j?s:k;s=s+1|0;}while((s|0)<20);if((k|0)!=0){w=k;break}c[q>>2]=c[b>>2];iw(1,0,80808,q);iw(1,0,79808,p);s=1;do{j=c[80840+(s<<2)>>2]|0;c[o>>2]=c[80728+(s<<2)>>2];c[o+4>>2]=j;iw(1,0,79832,o);s=s+1|0;}while((s|0)<20);kw(c[a+536>>2]|0,79936,n)}}while(0);c[m>>2]=c[80728+(w<<2)>>2];gw(23,0,80920,m);m=lQ(d)|0;d=lQ(e)|0;e=Dz(a,m,d,lQ(f)|0,g,h,w,u)|0;ce[c[74172>>2]&127](74144,a);v=e;i=l;return v|0}function eM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[a+256>>2]<<2;c[18536]=wd(lQ(b)|0)|0;c[74148>>2]=g;c[74152>>2]=d;d=a+284|0;do{if((c[19946]|0)==0){g=c[d>>2]|0;if((t_(80592,g)|0)==0){h=0;break}if((t_(80600,g)|0)==0){c[74160>>2]=93;c[74164>>2]=94;c[74172>>2]=95;h=0;break}if((t_(80608,g)|0)==0){c[74160>>2]=96;c[74164>>2]=97;c[74168>>2]=98;c[74172>>2]=99;h=1;break}if((t_(80616,g)|0)==0){c[74160>>2]=100;c[74164>>2]=101;c[74168>>2]=102;c[74172>>2]=103;h=1;break}if((t_(80624,g)|0)==0){c[74160>>2]=104;c[74164>>2]=105;c[74172>>2]=106;h=0;break}g=_L(101936,80632)|0;bS(_L(g,c[d>>2]|0)|0,103)|0;j=1;i=e;return j|0}else{h=0}}while(0);aM(a+8|0,c[a+288>>2]|0,h);ce[c[74160>>2]&127](74144,a);a=c[18536]|0;c[f>>2]=c[d>>2];c[f+4>>2]=a;gw(23,0,80656,f);j=0;i=e;return j|0}function fM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;Zv();do{if((qN(a,b)|0)==0){if((sN(a,b)|0)!=0){break}do{if((c[89400>>2]|0)!=0){w=c[89528>>2]|0;if((t_(w,81040)|0)==0){dw(1);break}if((t_(w,81048)|0)==0){dw(0);break}else{c[p>>2]=w;iw(1,0,81056,p);qd(0)|0;yd(0)}}}while(0);if((c[89356>>2]|0)==0){VL(0,0);Py(d);if((d|0)==0){bS(_L(101936,81424)|0,103)|0}c[d+300>>2]=XL(0,0)|0;c[d+292>>2]=ZL(0,0)|0;JE(d+8|0,d+240|0);Xy(d)|0;cz(d)|0;oz(d)|0;do{if((c[d+116>>2]|0)==0){if((c[d+124>>2]|0)==0){break}if((c[d+128>>2]|0)==0){break}bS(_L(101936,81488)|0,103)|0;x=1;i=e;return x|0}}while(0);c[19946]=c[89424>>2];x=0;i=e;return x|0}KP(u,c[89484>>2]|0);w=1;while(1){y=39928+(w<<2)|0;KP(v,c[y>>2]|0);z=WL(u,v)|0;QP(v);A=w+1|0;if(z){break}if((A|0)<31){w=A}else{B=33;break}}if((B|0)==33){c[g>>2]=lQ(u)|0;iw(1,0,81328,g);c[f>>2]=c[b>>2];iw(1,0,81368,f);qd(0)|0;yd(0)}A=c[43952+(w<<2)>>2]|0;do{if((A|0)==1){z=c[43824+(w<<2)>>2]|0;c[o>>2]=c[y>>2];c[o+4>>2]=z;gw(1,1,81128,o)}else{z=c[y>>2]|0;if((A|0)==2){C=c[43824+(w<<2)>>2]|0;c[n>>2]=z;c[n+4>>2]=z;c[n+8>>2]=C;gw(1,1,81168,n);break}else{c[m>>2]=z;iw(1,1,81008,m);break}}}while(0);if((w|0)==7){A=1;do{z=c[81248+(A<<2)>>2]|0;c[k>>2]=c[81232+(A<<2)>>2];c[k+4>>2]=z;gw(1,0,79832,k);A=A+1|0;}while((A|0)<4);D=36136;E=c[9034]|0;be[E&255](1);F=qd(0)|0;yd(0)}else if((w|0)==29){A=1;do{z=c[80840+(A<<2)>>2]|0;c[h>>2]=c[80728+(A<<2)>>2];c[h+4>>2]=z;gw(1,0,79832,h);A=A+1|0;}while((A|0)<20);D=36136;E=c[9034]|0;be[E&255](1);F=qd(0)|0;yd(0)}else if((w|0)==11){A=1;do{z=c[81296+(A<<2)>>2]|0;c[j>>2]=c[81264+(A<<2)>>2];c[j+4>>2]=z;gw(1,0,79832,j);A=A+1|0;}while((A|0)<7);D=36136;E=c[9034]|0;be[E&255](1);F=qd(0)|0;yd(0)}else if((w|0)==19){A=c[8468]|0;if((A|0)<28){G=A}else{D=36136;E=c[9034]|0;be[E&255](1);F=qd(0)|0;yd(0)}do{A=c[35456+(G<<2)>>2]|0;c[l>>2]=c[34288+(G<<2)>>2];c[l+4>>2]=A;gw(1,0,79832,l);G=G+1|0;}while((G|0)<28);D=36136;E=c[9034]|0;be[E&255](1);F=qd(0)|0;yd(0)}else{D=36136;E=c[9034]|0;be[E&255](1);F=qd(0)|0;yd(0)}}}while(0);c[t>>2]=c[b>>2];gw(1,1,80944,t);t=1;do{b=c[43952+(t<<2)>>2]|0;do{if((b|0)==1){F=c[41832+(t<<2)>>2]|0;c[s>>2]=c[39928+(t<<2)>>2];c[s+4>>2]=F;gw(1,0,80960,s)}else{F=c[39928+(t<<2)>>2]|0;if((b|0)==2){E=c[41832+(t<<2)>>2]|0;c[r>>2]=F;c[r+4>>2]=F;c[r+8>>2]=E;gw(1,0,80976,r);break}else{c[q>>2]=F;iw(1,0,81008,q);break}}}while(0);t=t+1|0;}while((t|0)<31);be[c[9034]&255](1);qd(0)|0;yd(0);return 0}function gM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0;a=i;i=i+8|0;b=a;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=c[20380]|0;qb(83056)|0;c[l>>2]=c[m+88>>2];cc(81528,l|0)|0;qb(83072)|0;l=j;h[k>>3]=+h[m+264>>3];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];cc(81552,j|0)|0;j=m+4|0;m=g;h[k>>3]=+h[c[(c[j>>2]|0)+4>>2]>>3];c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];cc(81592,g|0)|0;g=f;h[k>>3]=+h[c[(c[j>>2]|0)+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];cc(81624,f|0)|0;f=c[j>>2]|0;g=e;h[k>>3]=+h[c[f+4>>2]>>3]- +h[c[f+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];cc(81656,e|0)|0;e=d;h[k>>3]=+h[c[c[j>>2]>>2]>>3];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];cc(81688,d|0)|0;d=c[j>>2]|0;j=b;h[k>>3]=+h[c[d>>2]>>3]- +h[c[d+4>>2]>>3];c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];cc(81720,b|0)|0;qb(83096)|0;i=a;return}function hM(a,b){a=a|0;b=+b;i=i;return}



function Nr(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+368|0;n=m+48|0;o=b;b=e;e=f;f=g;g=h;c[n>>2]=j;j=k;k=l;l=c[o+356>>2]|0;h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}a:while(1){h=1;c[p>>2]=e;c[q>>2]=c[n>>2];b:do{if((g|0)<=0){if((k&255|0)!=0){if((g|0)!=0){r=7;break a}}switch(g|0){case 0:{r=9;break a;break};case-1:{r=10;break a;break};case-2:{r=11;break a;break};case-15:{g=0-g|0;break b;break};case-4:{r=13;break a;break};default:{g=0-g|0;c[n>>2]=f;break b}}}}while(0);s=se[c[o+256>>2]&63](o+256|0,g,e,c[n>>2]|0,b)|0;c:do{switch(s|0){case 4:{if((c[o+84>>2]|0)!=0){c[o+320>>2]=Pr(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+320>>2]|0)==0){r=29;break a}c[o+432>>2]=c[o+428>>2];c[o+328>>2]=0;h=0}c[o+324>>2]=0;break};case 1:{t=Or(o,0,e,c[n>>2]|0)|0;if((t|0)!=0){r=25;break a}b=c[o+144>>2]|0;h=0;break};case 6:{a[o+489|0]=0;c[o+316>>2]=Gr(o,l+132|0,26992,36)|0;if((c[o+316>>2]|0)==0){r=38;break a}a[l+129|0]=1;if((c[o+84>>2]|0)==0){r=45;break c}if((Ae[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=41;break a}u=Pr(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((u|0)==0){r=43;break a}Qr(u);c[o+432>>2]=c[o+428>>2];c[o+328>>2]=u;h=0;r=47;break};case 7:{if((c[o+84>>2]|0)==0){break c}_d[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,1);c[o+320>>2]=0;kr(o+416|0);h=0;break};case 57:{v=Or(o,1,e,c[n>>2]|0)|0;if((v|0)!=0){r=35;break a}b=c[o+144>>2]|0;h=0;break};case 22:{c[o+348>>2]=Tr(o,b,e,c[n>>2]|0)|0;if((c[o+348>>2]|0)==0){r=92;break a}a[o+352|0]=0;c[o+332>>2]=0;a[o+353|0]=0;r=102;break};case 14:{r=45;break};case 8:{if((c[o+320>>2]|0)!=0){_d[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,0);kr(o+416|0);h=0}if((c[o+324>>2]|0)!=0){r=57}else{if((d[o+489|0]|0)!=0){r=57}}if((r|0)==57){r=0;u=a[l+129|0]|0;a[l+129|0]=1;do{if((c[o+492>>2]|0)!=0){if((c[o+112>>2]|0)==0){break}w=Gr(o,l+132|0,26992,36)|0;if((w|0)==0){r=60;break a}if((a[o+489|0]|0)!=0){c[w+20>>2]=c[o+360>>2]}a[l+131|0]=0;if((se[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)==0){r=64;break a}if((a[l+131|0]|0)==0){if((c[o+324>>2]|0)!=0){break}a[l+129|0]=u;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((ee[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=69;break a}}}while(0);a[o+489|0]=0}if((c[o+88>>2]|0)==0){break c}be[c[o+88>>2]&255](c[o+4>>2]|0);h=0;break};case 2:{r=75;break a;break};case 34:{c[o+344>>2]=Sr(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)!=0){r=102}else{r=90;break a}break};case 32:case 31:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)!=0){x=27096}else{x=(s|0)==32?27080:27104}if((Ur(o+416|0,x)|0)==0){r=111;break a}if((Vr(o+416|0,b,e,c[n>>2]|0)|0)==0){r=113;break a}c[o+332>>2]=c[o+432>>2];h=0;break};case 23:{a[o+352|0]=1;c[o+332>>2]=27e3;r=102;break};case 24:{a[o+353|0]=1;c[o+332>>2]=27008;r=102;break};case 25:{c[o+332>>2]=27016;r=102;break};case 26:{c[o+332>>2]=27024;r=102;break};case 27:{c[o+332>>2]=27032;r=102;break};case 28:{c[o+332>>2]=27040;r=102;break};case 29:{c[o+332>>2]=27056;r=102;break};case 30:{c[o+332>>2]=27064;r=102;break};case 36:case 35:{if((a[l+128|0]|0)==0){break c}if((Wr(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,a[o+353|0]|0,0,o)|0)==0){r=117;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=123}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=123}}}while(0);if((r|0)==123){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Dr(o+416|0)|0)<<24>>24!=0)){r=128;break a}}u=o+428|0;w=c[u>>2]|0;c[u>>2]=w+1;a[w]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Dr(o+416|0)|0)<<24>>24!=0)){r=128;break a}}w=o+428|0;u=c[w>>2]|0;c[w>>2]=u+1;a[u]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;me[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,0,(s|0)==36|0);kr(o+416|0);h=0;break};case 5:{a[o+489|0]=0;a[l+129|0]=1;u=o;if((c[o+84>>2]|0)!=0){c[o+324>>2]=Pr(u+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((c[o+324>>2]|0)==0){r=156;break a}c[o+432>>2]=c[o+428>>2];h=0}else{c[u+324>>2]=26992}do{if((a[l+130|0]|0)==0){if((c[o+492>>2]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((ee[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=163;break a}}}while(0);if((c[o+316>>2]|0)!=0){r=168;break c}c[o+316>>2]=Gr(o,l+132|0,26992,36)|0;if((c[o+316>>2]|0)==0){r=166;break a}c[(c[o+316>>2]|0)+24>>2]=0;r=168;break};case 38:case 37:{if((a[l+128|0]|0)==0){break c}y=Xr(o,b,a[o+352|0]|0,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0,l+80|0)|0;if((y|0)!=0){r=132;break a}u=c[l+96>>2]|0;c[l+96>>2]=c[l+92>>2];if((Wr(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,0,u,o)|0)==0){r=134;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=140}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=140}}}while(0);if((r|0)==140){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Dr(o+416|0)|0)<<24>>24!=0)){r=145;break a}}w=o+428|0;z=c[w>>2]|0;c[w>>2]=z+1;a[z]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Dr(o+416|0)|0)<<24>>24!=0)){r=145;break a}}z=o+428|0;w=c[z>>2]|0;c[z>>2]=w+1;a[w]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;me[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,u,(s|0)==38|0);kr(o+416|0);h=0;break};case 12:{if((a[l+128|0]|0)==0){break c}A=Yr(o,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;w=c[l+120>>2]|0;do{if((c[o+316>>2]|0)!=0){c[(c[o+316>>2]|0)+4>>2]=w;c[(c[o+316>>2]|0)+8>>2]=(c[l+116>>2]|0)-(c[l+120>>2]|0);c[l+120>>2]=c[l+116>>2];if((c[o+136>>2]|0)==0){break}c[q>>2]=e;qe[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,c[(c[o+316>>2]|0)+4>>2]|0,c[(c[o+316>>2]|0)+8>>2]|0,c[o+360>>2]|0,0,0,0);h=0}else{c[l+116>>2]=w}}while(0);if((A|0)!=0){r=153;break a}break};case 13:{r=168;break};case 15:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;qe[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,0);h=0;break};case 16:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}w=Pr(l+80|0,b,e,c[n>>2]|0)|0;c[(c[o+316>>2]|0)+28>>2]=w;if((c[(c[o+316>>2]|0)+28>>2]|0)==0){r=181;break a}c[l+96>>2]=c[l+92>>2];if((c[o+92>>2]|0)!=0){c[q>>2]=e;me[c[o+92>>2]&31](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;qe[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break};case 9:{if((ie[c[b+48>>2]&63](b,e,c[n>>2]|0)|0)!=0){c[o+316>>2]=0;break c}w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=Pr(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=190;break a}c[o+316>>2]=Gr(o,l,u,36)|0;if((c[o+316>>2]|0)==0){r=192;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=0;if((c[o+476>>2]|0)!=0){B=1}else{B=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(B^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 10:{w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=Pr(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=202;break a}c[o+316>>2]=Gr(o,l+132|0,u,36)|0;if((c[o+316>>2]|0)==0){r=204;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=1;if((c[o+476>>2]|0)!=0){C=1}else{C=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(C^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 18:{c[o+340>>2]=0;c[o+336>>2]=0;if((c[o+96>>2]|0)==0){break c}c[o+336>>2]=Pr(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+336>>2]|0)==0){r=214;break a}c[o+432>>2]=c[o+428>>2];h=0;break};case 58:{if((c[o+80>>2]|0)!=0){Br(o,b,e,c[n>>2]|0)}h=0;D=Zr(o,b,n,f,j,k)|0;if((D|0)!=0){r=239;break a}if((c[n>>2]|0)==0){r=241;break a}break};case 21:{if((Ae[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=217;break a}if((c[o+336>>2]|0)==0){break c}w=Pr(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=220;break a}Qr(w);c[o+340>>2]=w;c[o+432>>2]=c[o+428>>2];h=0;break};case 19:{do{if((c[o+336>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}w=Pr(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=225;break a}c[q>>2]=e;_d[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,w,c[o+340>>2]|0);h=0}}while(0);kr(o+416|0);break};case 20:{do{if((c[o+340>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}c[q>>2]=e;_d[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,0,c[o+340>>2]|0);h=0}}while(0);kr(o+416|0);break};case-1:{r=232;break a;break};case 44:{do{if((c[o+260>>2]|0)>>>0>=(c[o+468>>2]|0)>>>0){w=o+12|0;if((c[o+468>>2]|0)==0){u=c[w>>2]|0;c[o+468>>2]=32;c[o+464>>2]=ee[u&127](32)|0;if((c[o+464>>2]|0)!=0){break}else{r=251;break a}}u=c[w+4>>2]|0;w=c[o+464>>2]|0;z=o+468|0;E=c[z>>2]<<1;c[z>>2]=E;z=re[u&63](w,E)|0;if((z|0)==0){r=245;break a}c[o+464>>2]=z;if((c[l+184>>2]|0)==0){break}z=re[c[o+16>>2]&63](c[l+184>>2]|0,c[o+468>>2]<<2)|0;if((z|0)==0){r=248;break a}c[l+184>>2]=z}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=0;if((a[l+160|0]|0)==0){break c}z=$r(o)|0;if((z|0)<0){r=254;break a}c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]=z;E=l+180|0;c[E>>2]=(c[E>>2]|0)+1;c[(c[l+164>>2]|0)+(z*28|0)>>2]=6;if((c[o+128>>2]|0)==0){break c}h=0;break};case 50:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==124){r=258;break a}a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=44;if((d[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)==0){break c}h=0;break};case 49:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==44){r=263;break a}do{if((d[l+160|0]|0)!=0){if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)!=0){break}if((c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]|0)==3){break}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=5;if((c[o+128>>2]|0)==0){break}h=0}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=124;break};case 59:case 60:{a[l+129|0]=1;z=l;do{if((c[o+492>>2]|0)!=0){E=Pr(z+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=273;break a}w=Gr(o,l+132|0,E,0)|0;c[l+92>>2]=c[l+96>>2];do{if((c[o+272>>2]|0)!=0){if((d[l+130|0]|0)!=0){if((c[o+300>>2]|0)!=0){r=282;break}}else{if((a[l+129|0]|0)!=0){r=282;break}}if((w|0)==0){r=279;break a}if((a[w+34|0]|0)==0){r=281;break a}}else{r=282}}while(0);do{if((r|0)==282){r=0;if((w|0)!=0){break}a[l+128|0]=a[l+130|0]|0;if((s|0)!=60){break c}if((c[o+120>>2]|0)==0){break c}xe[c[o+120>>2]&15](c[o+4>>2]|0,E,1);h=0;break c}}while(0);if((a[w+32|0]|0)!=0){r=287;break a}if((c[w+4>>2]|0)!=0){F=as(o,w,((s|0)==60?1:0)&255)|0;if((F|0)!=0){r=290;break a}h=0;break c}E=l;if((c[o+112>>2]|0)==0){a[l+128|0]=a[E+130|0]|0;break c}a[E+131|0]=0;a[w+32|0]=1;E=(se[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)!=0;a[w+32|0]=0;if(!E){r=294;break a}h=0;if((a[l+131|0]|0)!=0){break}a[l+128|0]=a[l+130|0]|0;break c}else{a[l+128|0]=a[z+130|0]|0}}while(0);if((a[l+130|0]|0)!=0){break c}if((c[o+108>>2]|0)==0){break c}if((ee[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=301;break a}break};case 53:{G=1;r=319;break};case 52:{G=2;r=319;break};case 54:{G=3;r=319;break};case 40:{if((c[o+128>>2]|0)==0){break c}c[o+344>>2]=Sr(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)==0){r=304;break a}c[l+180>>2]=0;c[l+176>>2]=0;a[l+160|0]=1;h=0;break};case 42:case 41:{if((a[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)!=0){z=ee[c[o+12>>2]&127](20)|0;if((z|0)==0){r=309;break a}c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;c[z+16>>2]=0;c[z>>2]=(s|0)==41?2:1;c[q>>2]=e;xe[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,z);h=0}a[l+160|0]=0;break};case 43:{if((a[l+160|0]|0)==0){break c}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=3;if((c[o+128>>2]|0)==0){break c}h=0;break};case 51:{G=0;r=319;break};case 47:{G=1;r=334;break};case 46:{G=2;r=334;break};case 48:{G=3;r=334;break};case 45:{G=0;r=334;break};case 56:{if((ds(o,b,e,c[n>>2]|0)|0)==0){r=347;break a}h=0;break};case 0:{if((g|0)!=14){break c}h=0;break};case 3:{if((c[o+84>>2]|0)==0){break c}h=0;break};case 11:{if((d[l+128|0]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}h=0;break};case 55:{if((cs(o,b,e,c[n>>2]|0)|0)==0){r=344;break a}h=0;break};case 17:{if((c[o+96>>2]|0)==0){break c}h=0;break};case 33:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}h=0;break};case 39:{if((c[o+128>>2]|0)==0){break c}h=0;break};default:{}}}while(0);do{if((r|0)==45){r=0;if((Ae[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)!=0){r=47}else{r=46;break a}}else if((r|0)==102){r=0;if((d[l+128|0]|0)==0){break}if((c[o+132>>2]|0)==0){break}h=0}else if((r|0)==168){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}s=Pr(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;c[(c[o+316>>2]|0)+16>>2]=s;if((c[(c[o+316>>2]|0)+16>>2]|0)==0){r=171;break a}c[(c[o+316>>2]|0)+20>>2]=c[o+360>>2];c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}else if((r|0)==319){r=0;if((a[l+160|0]|0)==0){break}s=c[n>>2]|0;if((G|0)==0){H=s}else{H=s+(0-(c[b+68>>2]|0))|0}s=$r(o)|0;if((s|0)<0){r=323;break a}c[(c[l+164>>2]|0)+(s*28|0)>>2]=4;c[(c[l+164>>2]|0)+(s*28|0)+4>>2]=G;z=Sr(o,b,e,H)|0;if((z|0)==0){r=325;break a}E=c[z>>2]|0;c[(c[l+164>>2]|0)+(s*28|0)+8>>2]=E;s=0;do{z=s;s=z+1|0;}while((a[E+z|0]|0)!=0);E=l+168|0;c[E>>2]=(c[E>>2]|0)+s;if((c[o+128>>2]|0)==0){break}h=0}else if((r|0)==334){r=0;if((a[l+160|0]|0)==0){break}if((c[o+128>>2]|0)!=0){h=0}E=l+180|0;c[E>>2]=(c[E>>2]|0)+ -1;c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]|0)*28|0)+4>>2]=G;if((c[l+180>>2]|0)!=0){break}if(!(h<<24>>24!=0)){E=bs(o)|0;if((E|0)==0){r=340;break a}c[q>>2]=e;xe[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,E)}a[l+160|0]=0;c[l+168>>2]=0}}while(0);do{if((r|0)==47){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}E=Pr(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=50;break a}Qr(E);c[(c[o+316>>2]|0)+24>>2]=E;c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}}while(0);do{if((h&255|0)!=0){if((c[o+80>>2]|0)==0){break}Br(o,b,e,c[n>>2]|0)}}while(0);h=c[o+480>>2]|0;if((h|0)==3){r=367;break}else if((h|0)==2){r=368;break}e=c[n>>2]|0;g=Ae[c[b>>2]&63](b,e,f,n)|0}if((r|0)==7){c[j>>2]=e;I=0;J=I;i=m;return J|0}else if((r|0)==9){c[p>>2]=c[n>>2];I=4;J=I;i=m;return J|0}else if((r|0)==10){I=5;J=I;i=m;return J|0}else if((r|0)==11){I=6;J=I;i=m;return J|0}else if((r|0)==13){do{if((b|0)!=(c[o+144>>2]|0)){if((a[(c[o+300>>2]|0)+20|0]|0)!=0){break}c[j>>2]=e;I=0;J=I;i=m;return J|0}}while(0);do{if((d[o+488|0]|0)==0){if((b|0)!=(c[o+144>>2]|0)){break}I=3;J=I;i=m;return J|0}}while(0);if((se[c[o+256>>2]&63](o+256|0,-4,f,f,b)|0)==-1){I=29;J=I;i=m;return J|0}else{c[j>>2]=e;I=0;J=I;i=m;return J|0}}else if((r|0)==25){I=t;J=I;i=m;return J|0}else if((r|0)==29){I=1;J=I;i=m;return J|0}else if((r|0)==35){I=v;J=I;i=m;return J|0}else if((r|0)==38){I=1;J=I;i=m;return J|0}else if((r|0)==41){I=32;J=I;i=m;return J|0}else if((r|0)==43){I=1;J=I;i=m;return J|0}else if((r|0)==46){I=32;J=I;i=m;return J|0}else if((r|0)==50){I=1;J=I;i=m;return J|0}else if((r|0)==60){I=1;J=I;i=m;return J|0}else if((r|0)==64){I=21;J=I;i=m;return J|0}else if((r|0)==69){I=22;J=I;i=m;return J|0}else if((r|0)==75){do{if((a[o+489|0]|0)!=0){v=a[l+129|0]|0;a[l+129|0]=1;if((c[o+492>>2]|0)==0){break}if((c[o+112>>2]|0)==0){break}t=Gr(o,l+132|0,26992,36)|0;if((t|0)==0){I=1;J=I;i=m;return J|0}c[t+20>>2]=c[o+360>>2];a[l+131|0]=0;if((se[c[o+112>>2]&63](c[o+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)==0){I=21;J=I;i=m;return J|0}if((a[l+131|0]|0)==0){a[l+129|0]=v;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((ee[c[o+108>>2]&127](c[o+4>>2]|0)|0)!=0){break}I=22;J=I;i=m;return J|0}}while(0);c[o+280>>2]=38;I=Rr(o,e,f,j)|0;J=I;i=m;return J|0}else if((r|0)==90){I=1;J=I;i=m;return J|0}else if((r|0)==92){I=1;J=I;i=m;return J|0}else if((r|0)==111){I=1;J=I;i=m;return J|0}else if((r|0)==113){I=1;J=I;i=m;return J|0}else if((r|0)==117){I=1;J=I;i=m;return J|0}else if((r|0)==128){I=1;J=I;i=m;return J|0}else if((r|0)==132){I=y;J=I;i=m;return J|0}else if((r|0)==134){I=1;J=I;i=m;return J|0}else if((r|0)==145){I=1;J=I;i=m;return J|0}else if((r|0)==153){I=A;J=I;i=m;return J|0}else if((r|0)==156){I=1;J=I;i=m;return J|0}else if((r|0)==163){I=22;J=I;i=m;return J|0}else if((r|0)==166){I=1;J=I;i=m;return J|0}else if((r|0)==171){I=1;J=I;i=m;return J|0}else if((r|0)==181){I=1;J=I;i=m;return J|0}else if((r|0)==190){I=1;J=I;i=m;return J|0}else if((r|0)==192){I=1;J=I;i=m;return J|0}else if((r|0)==202){I=1;J=I;i=m;return J|0}else if((r|0)==204){I=1;J=I;i=m;return J|0}else if((r|0)==214){I=1;J=I;i=m;return J|0}else if((r|0)==217){I=32;J=I;i=m;return J|0}else if((r|0)==220){I=1;J=I;i=m;return J|0}else if((r|0)==225){I=1;J=I;i=m;return J|0}else if((r|0)==232){A=g;if((A|0)==28){I=10;J=I;i=m;return J|0}else if((A|0)==12){I=17;J=I;i=m;return J|0}else{I=2;J=I;i=m;return J|0}}else if((r|0)==239){I=D;J=I;i=m;return J|0}else if((r|0)==241){c[o+280>>2]=39;I=D;J=I;i=m;return J|0}else if((r|0)==245){I=1;J=I;i=m;return J|0}else if((r|0)==248){I=1;J=I;i=m;return J|0}else if((r|0)==251){I=1;J=I;i=m;return J|0}else if((r|0)==254){I=1;J=I;i=m;return J|0}else if((r|0)==258){I=2;J=I;i=m;return J|0}else if((r|0)==263){I=2;J=I;i=m;return J|0}else if((r|0)==273){I=1;J=I;i=m;return J|0}else if((r|0)==279){I=11;J=I;i=m;return J|0}else if((r|0)==281){I=24;J=I;i=m;return J|0}else if((r|0)==287){I=12;J=I;i=m;return J|0}else if((r|0)==290){I=F;J=I;i=m;return J|0}else if((r|0)==294){I=21;J=I;i=m;return J|0}else if((r|0)==301){I=22;J=I;i=m;return J|0}else if((r|0)==304){I=1;J=I;i=m;return J|0}else if((r|0)==309){I=1;J=I;i=m;return J|0}else if((r|0)==323){I=1;J=I;i=m;return J|0}else if((r|0)==325){I=1;J=I;i=m;return J|0}else if((r|0)==340){I=1;J=I;i=m;return J|0}else if((r|0)==344){I=1;J=I;i=m;return J|0}else if((r|0)==347){I=1;J=I;i=m;return J|0}else if((r|0)==367){c[j>>2]=c[n>>2];I=0;J=I;i=m;return J|0}else if((r|0)==368){I=35;J=I;i=m;return J|0}return 0}function Or(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+104|0;h=g+40|0;j=g+56|0;k=g+64|0;l=g+72|0;m=g+88|0;n=b;b=d;d=e;e=f;c[h>>2]=0;f=0;c[j>>2]=0;c[k>>2]=0;o=0;c[m>>2]=-1;p=(b|0)!=0;if((de[((a[n+236|0]&255|0)!=0?1:2)&7](b,c[n+144>>2]|0,d,e,n+288|0,k,l,h,j,m)|0)==0){if(p){q=31;r=q;i=g;return r|0}else{q=30;r=q;i=g;return r|0}}do{if(!p){if((c[m>>2]|0)!=1){break}a[(c[n+356>>2]|0)+130|0]=1;if((c[n+492>>2]|0)!=1){break}c[n+492>>2]=0}}while(0);do{if((c[n+140>>2]|0)!=0){do{if((c[h>>2]|0)!=0){p=c[n+144>>2]|0;b=c[h>>2]|0;s=c[h>>2]|0;f=Pr(n+440|0,p,b,s+(re[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){c[n+456>>2]=c[n+452>>2];break}q=1;r=q;i=g;return r|0}}while(0);do{if((c[k>>2]|0)!=0){o=Pr(n+440|0,c[n+144>>2]|0,c[k>>2]|0,(c[l>>2]|0)+(0-(c[(c[n+144>>2]|0)+68>>2]|0))|0)|0;if((o|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);Be[c[n+140>>2]&31](c[n+4>>2]|0,o,f,c[m>>2]|0)}else{if((c[n+80>>2]|0)==0){break}Br(n,c[n+144>>2]|0,d,e)}}while(0);do{if((c[n+232>>2]|0)==0){if((c[j>>2]|0)!=0){if((c[(c[j>>2]|0)+68>>2]|0)==(c[(c[n+144>>2]|0)+68>>2]|0)){c[n+144>>2]=c[j>>2];break}c[n+288>>2]=c[h>>2];q=19;r=q;i=g;return r|0}if((c[h>>2]|0)==0){break}do{if((f|0)==0){e=c[n+144>>2]|0;d=c[h>>2]|0;m=c[h>>2]|0;f=Pr(n+440|0,e,d,m+(re[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);m=rs(n,f)|0;kr(n+440|0);if((m|0)==18){c[n+288>>2]=c[h>>2]}q=m;r=q;i=g;return r|0}}while(0);if((f|0)!=0){t=34}else{if((o|0)!=0){t=34}}if((t|0)==34){kr(n+440|0)}q=0;r=q;i=g;return r|0}function Pr(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+40|0;h=b;if((Vr(h,d,e,f)|0)==0){j=0;k=j;i=g;return k|0}do{if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if((Dr(h)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);f=h+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e]=0;j=c[h+16>>2]|0;k=j;i=g;return k|0}function Qr(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;i=i+24|0;d=b;b=d;e=d;while(1){if((a[e]|0)==0){break}f=a[e]|0;do{if((f|0)==10|(f|0)==13|(f|0)==32){if((b|0)==(d|0)){break}if((a[b+ -1|0]|0)==32){break}g=b;b=g+1|0;a[g]=32}else{g=b;b=g+1|0;a[g]=a[e]|0}}while(0);e=e+1|0}if((b|0)==(d|0)){h=b;a[h]=0;i=c;return}if((a[b+ -1|0]|0)!=32){h=b;a[h]=0;i=c;return}b=b+ -1|0;h=b;a[h]=0;i=c;return}function Rr(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=gs(h,0,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((os(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function Sr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=c[g+356>>2]|0;h=Pr(a+80|0,b,d,e)|0;if((h|0)==0){j=0;k=j;i=f;return k|0}e=Gr(g,a+20|0,h,24)|0;if((e|0)==0){j=0;k=j;i=f;return k|0}d=a+80|0;do{if((c[e>>2]|0)!=(h|0)){c[a+92>>2]=c[d+16>>2]}else{c[a+96>>2]=c[d+12>>2];if((ps(g,e)|0)!=0){break}j=0;k=j;i=f;return k|0}}while(0);j=e;k=j;i=f;return k|0}function Tr(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=b;b=d;d=e;e=f;f=c[h+356>>2]|0;do{if((c[f+92>>2]|0)==(c[f+88>>2]|0)){if((Dr(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m]=0;m=Pr(f+80|0,b,d,e)|0;if((m|0)==0){j=0;k=j;i=g;return k|0}m=m+1|0;e=Gr(h,f+40|0,m,12)|0;if((e|0)==0){j=0;k=j;i=g;return k|0}d=f+80|0;a:do{if((c[e>>2]|0)!=(m|0)){c[f+92>>2]=c[d+16>>2]}else{c[f+96>>2]=c[d+12>>2];if((a[h+236|0]|0)==0){break}do{if((a[m]|0)==120){if((a[m+1|0]|0)!=109){break}if((a[m+2|0]|0)!=108){break}if((a[m+3|0]|0)!=110){break}if((a[m+4|0]|0)!=115){break}if((a[m+5|0]|0)!=0){if((a[m+5|0]|0)!=58){break}}if((a[m+5|0]|0)==0){c[e+4>>2]=f+152}else{c[e+4>>2]=Gr(h,f+60|0,m+6|0,8)|0}a[e+9|0]=1;break a}}while(0);b=0;while(1){if((a[m+b|0]|0)==0){break a}if((a[m+b|0]|0)==58){break}b=b+1|0}l=0;while(1){n=(c[f+92>>2]|0)==(c[f+88>>2]|0);if((l|0)>=(b|0)){break}if(n){if(!((Dr(f+80|0)|0)<<24>>24!=0)){o=30;break}}p=a[m+l|0]|0;q=f+92|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;l=l+1|0}if((o|0)==30){j=0;k=j;i=g;return k|0}do{if(n){if((Dr(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;b=c[l>>2]|0;c[l>>2]=b+1;a[b]=0;c[e+4>>2]=Gr(h,f+60|0,c[f+96>>2]|0,8)|0;b=f+80|0;if((c[c[e+4>>2]>>2]|0)==(c[f+96>>2]|0)){c[f+96>>2]=c[b+12>>2];break}else{c[f+92>>2]=c[b+16>>2];break}}}while(0);j=e;k=j;i=g;return k|0}function Ur(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=b;b=d;while(1){g=f;if((a[b]|0)==0){h=7;break}if((c[g+12>>2]|0)==(c[f+8>>2]|0)){if(!((Dr(f)|0)<<24>>24!=0)){h=6;break}}d=a[b]|0;j=f+12|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k]=d;b=b+1|0}if((h|0)==6){l=0;m=l;i=e;return m|0}else if((h|0)==7){l=c[g+16>>2]|0;m=l;i=e;return m|0}return 0}function Vr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=f+24|0;h=a;a=b;c[g>>2]=d;d=e;do{if((c[h+12>>2]|0)==0){if((Dr(h)|0)<<24>>24!=0){break}j=0;k=j;i=f;return k|0}}while(0);while(1){_d[c[a+60>>2]&31](a,g,d,h+12|0,c[h+8>>2]|0);l=h;if((c[g>>2]|0)==(d|0)){m=7;break}if(!((Dr(l)|0)<<24>>24!=0)){m=6;break}}if((m|0)==6){j=0;k=j;i=f;return k|0}else if((m|0)==7){j=c[l+16>>2]|0;k=j;i=f;return k|0}return 0}function Wr(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+88|0;k=b;b=d;d=e;e=f;f=g;g=h;if((f|0)!=0){l=3}else{if((e&255|0)!=0){l=3}}do{if((l|0)==3){h=0;while(1){if((h|0)>=(c[k+12>>2]|0)){break}if((b|0)==(c[(c[k+20>>2]|0)+(h*12|0)>>2]|0)){l=6;break}h=h+1|0}if((l|0)==6){m=1;n=m;i=j;return n|0}if((e&255|0)==0){break}if((c[k+8>>2]|0)!=0){break}if((a[b+9|0]|0)!=0){break}c[k+8>>2]=b}}while(0);do{if((c[k+12>>2]|0)==(c[k+16>>2]|0)){e=k+16|0;if((c[k+16>>2]|0)==0){c[e>>2]=8;c[k+20>>2]=ee[c[g+12>>2]&127]((c[k+16>>2]|0)*12|0)|0;if((c[k+20>>2]|0)!=0){break}m=0;n=m;i=j;return n|0}l=c[e>>2]<<1;e=re[c[g+16>>2]&63](c[k+20>>2]|0,l*12|0)|0;if((e|0)!=0){c[k+16>>2]=l;c[k+20>>2]=e;break}m=0;n=m;i=j;return n|0}}while(0);g=(c[k+20>>2]|0)+((c[k+12>>2]|0)*12|0)|0;c[g>>2]=b;c[g+8>>2]=f;a[g+4|0]=d;if(!(d<<24>>24!=0)){a[b+8|0]=1}b=k+12|0;c[b>>2]=(c[b>>2]|0)+1;m=1;n=m;i=j;return n|0}function Xr(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+64|0;k=e;e=h;h=qs(b,d,k,f,g,e)|0;if((h|0)!=0){l=h;m=l;i=j;return m|0}do{if(!(k<<24>>24!=0)){if(((c[e+12>>2]|0)-(c[e+16>>2]|0)|0)==0){break}if((a[(c[e+12>>2]|0)+ -1|0]|0)!=32){break}h=e+12|0;c[h>>2]=(c[h>>2]|0)+ -1}}while(0);do{if((c[e+12>>2]|0)==(c[e+8>>2]|0)){if((Dr(e)|0)<<24>>24!=0){break}l=1;m=l;i=j;return m|0}}while(0);k=e+12|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e]=0;l=0;m=l;i=j;return m|0}function Yr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+128|0;j=h+72|0;k=h+104|0;l=b;b=e;e=f;f=g;g=c[l+356>>2]|0;m=g+104|0;n=0;o=c[l+276>>2]|0;c[l+276>>2]=1;do{if((c[m>>2]|0)==0){if((Dr(m)|0)<<24>>24!=0){break}p=1;q=p;i=h;return q|0}}while(0);a:while(1){b:do{switch(Ae[c[b+20>>2]&63](b,e,f,j)|0){case 6:case 9:{if((Vr(m,b,e,c[j>>2]|0)|0)==0){r=26;break a}break};case-3:{c[j>>2]=e+(c[b+68>>2]|0);r=28;break};case 10:{s=re[c[b+44>>2]&63](b,e)|0;if((s|0)<0){r=33;break a}s=xs(s,k)|0;if((s|0)==0){r=37;break a}t=0;while(1){if((t|0)>=(s|0)){break b}if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((Dr(m)|0)<<24>>24!=0)){r=44;break a}}u=a[k+t|0]|0;v=m+12|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=u;t=t+1|0}break};case-4:{r=24;break a;break};case 28:{if((d[l+488|0]|0)==0){if((b|0)==(c[l+144>>2]|0)){r=23;break a}}t=Pr(l+416|0,b,e+(c[b+68>>2]|0)|0,(c[j>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((t|0)==0){r=8;break a}s=Gr(l,g+132|0,t,0)|0;c[l+428>>2]=c[l+432>>2];if((s|0)==0){r=10;break a}if((a[s+32|0]|0)!=0){r=12;break a}if((c[s+16>>2]|0)==0){a[s+32|0]=1;n=Yr(l,c[l+228>>2]|0,c[s+4>>2]|0,(c[s+4>>2]|0)+(c[s+8>>2]|0)|0)|0;a[s+32|0]=0;if((n|0)!=0){break a}else{break b}}t=g;if((c[l+112>>2]|0)==0){a[g+128|0]=a[t+130|0]|0;break b}a[t+131|0]=0;a[s+32|0]=1;t=(se[c[l+112>>2]&63](c[l+116>>2]|0,0,c[s+20>>2]|0,c[s+16>>2]|0,c[s+24>>2]|0)|0)!=0;a[s+32|0]=0;if(!t){r=18;break a}if((a[g+131|0]|0)!=0){break b}a[g+128|0]=a[g+130|0]|0;break};case 0:{r=49;break a;break};case 7:{r=28;break};case-1:{r=46;break a;break};default:{r=52;break a}}}while(0);if((r|0)==28){r=0;if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((Dr(m)|0)<<24>>24!=0)){r=30;break}}t=m+12|0;s=c[t>>2]|0;c[t>>2]=s+1;a[s]=10}e=c[j>>2]|0}if((r|0)==8){n=1}else if((r|0)==10){a[g+128|0]=a[g+130|0]|0}else if((r|0)==12){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=12}else if((r|0)==18){n=21}else if((r|0)==23){c[l+288>>2]=e;n=10}else if((r|0)==24){n=0}else if((r|0)==26){n=1}else if((r|0)==30){n=1}else if((r|0)==33){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==37){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==44){n=1}else if((r|0)==46){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=4}else if((r|0)==49){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=c[j>>2]}n=4}else if((r|0)==52){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=23}c[l+276>>2]=o;p=n;q=p;i=h;return q|0}function Zr(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+96|0;j=h+56|0;k=a;a=b;b=d;d=f;f=g;g=c[b>>2]|0;l=k;if((a|0)==(c[k+144>>2]|0)){m=l+288|0;c[m>>2]=g;n=k+292|0}else{m=c[l+300>>2]|0;n=(c[k+300>>2]|0)+4|0}c[m>>2]=g;c[b>>2]=0;l=Ae[c[a+12>>2]&63](a,g,e,j)|0;c[n>>2]=c[j>>2];switch(l|0){case-2:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=6;p=o;i=h;return p|0}break};case 42:{if((c[k+80>>2]|0)!=0){Br(k,a,g,c[j>>2]|0)}c[b>>2]=c[j>>2];c[d>>2]=c[j>>2];if((c[k+480>>2]|0)==2){o=35;p=o;i=h;return p|0}else{o=0;p=o;i=h;return p|0}break};case 0:{c[m>>2]=c[j>>2];o=4;p=o;i=h;return p|0};case-4:case-1:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=2;p=o;i=h;return p|0}break};default:{c[m>>2]=c[j>>2];o=23;p=o;i=h;return p|0}}return 0}function _r(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=Zr(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)!=0){c[j+280>>2]=40;k=Mr(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{k=f;l=k;i=g;return l|0}return 0}function $r(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;a=c[d+356>>2]|0;do{if((c[a+184>>2]|0)==0){c[a+184>>2]=ee[c[d+12>>2]&127](c[d+468>>2]<<2)|0;if((c[a+184>>2]|0)!=0){c[c[a+184>>2]>>2]=0;break}e=-1;f=e;i=b;return f|0}}while(0);if((c[a+176>>2]|0)>>>0>=(c[a+172>>2]|0)>>>0){g=d+12|0;do{if((c[a+164>>2]|0)!=0){h=re[c[g+4>>2]&63](c[a+164>>2]|0,(c[a+172>>2]<<1)*28|0)|0;if((h|0)!=0){d=a+172|0;c[d>>2]=c[d>>2]<<1;break}e=-1;f=e;i=b;return f|0}else{h=ee[c[g>>2]&127](896)|0;if((h|0)!=0){c[a+172>>2]=32;break}e=-1;f=e;i=b;return f|0}}while(0);c[a+164>>2]=h}h=a+176|0;g=c[h>>2]|0;c[h>>2]=g+1;h=g;g=(c[a+164>>2]|0)+(h*28|0)|0;if((c[a+180>>2]|0)!=0){d=(c[a+164>>2]|0)+((c[(c[a+184>>2]|0)+((c[a+180>>2]|0)-1<<2)>>2]|0)*28|0)|0;if((c[d+16>>2]|0)!=0){c[(c[a+164>>2]|0)+((c[d+16>>2]|0)*28|0)+24>>2]=h}if((c[d+20>>2]|0)==0){c[d+12>>2]=h}c[d+16>>2]=h;a=d+20|0;c[a>>2]=(c[a>>2]|0)+1}c[g+24>>2]=0;c[g+20>>2]=0;c[g+16>>2]=0;c[g+12>>2]=0;e=h;f=e;i=b;return f|0}function as(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+80|0;g=f+48|0;h=b;b=d;d=e;e=h;do{if((c[h+304>>2]|0)!=0){j=c[e+304>>2]|0;c[h+304>>2]=c[j+8>>2]}else{j=ee[c[e+12>>2]&127](24)|0;if((j|0)!=0){break}k=1;l=k;i=f;return l|0}}while(0);a[b+32|0]=1;c[b+12>>2]=0;c[j+8>>2]=c[h+300>>2];c[h+300>>2]=j;c[j+12>>2]=b;c[j+16>>2]=c[h+312>>2];a[j+20|0]=d;c[j>>2]=0;c[j+4>>2]=0;d=c[b+4>>2]|0;e=(c[b+4>>2]|0)+(c[b+8>>2]|0)|0;m=h;if((a[b+33|0]|0)!=0){n=Ae[c[c[m+228>>2]>>2]&63](c[h+228>>2]|0,d,e,g)|0;o=Nr(h,c[h+228>>2]|0,d,e,n,c[g>>2]|0,g,0)|0}else{o=gs(m,c[h+312>>2]|0,c[h+228>>2]|0,d,e,g,0)|0}a:do{if((o|0)==0){do{if((e|0)!=(c[g>>2]|0)){if((c[h+480>>2]|0)!=3){break}c[b+12>>2]=(c[g>>2]|0)-d;c[h+280>>2]=41;break a}}while(0);a[b+32|0]=0;c[h+300>>2]=c[j+8>>2];c[j+8>>2]=c[h+304>>2];c[h+304>>2]=j}}while(0);k=o;l=k;i=f;return l|0}function bs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+56|0;d=b+32|0;e=b+40|0;f=a;a=c[f+356>>2]|0;g=ee[c[f+12>>2]&127](((c[a+176>>2]|0)*20|0)+(c[a+168>>2]|0)|0)|0;if((g|0)!=0){c[e>>2]=g+((c[a+176>>2]|0)*20|0);c[d>>2]=g+20;fs(f,0,g,d,e);h=g;j=h;i=b;return j|0}else{h=0;j=h;i=b;return j|0}return 0}function cs(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=b;b=d;d=e;if((c[g+64>>2]|0)==0){if((c[g+80>>2]|0)!=0){Br(g,a,b,d)}h=1;j=h;i=f;return j|0}b=b+(c[a+68>>2]<<1)|0;e=b+(re[c[a+32>>2]&63](a,b)|0)|0;k=Pr(g+416|0,a,b,e)|0;if((k|0)==0){h=0;j=h;i=f;return j|0}c[g+432>>2]=c[g+428>>2];b=re[c[a+36>>2]&63](a,e)|0;e=Pr(g+416|0,a,b,d+(0-(c[a+68>>2]<<1))|0)|0;if((e|0)!=0){es(e);xe[c[g+64>>2]&15](c[g+4>>2]|0,k,e);kr(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function ds(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=a;a=b;b=d;d=e;e=g;if((c[g+68>>2]|0)==0){if((c[e+80>>2]|0)!=0){Br(g,a,b,d)}h=1;j=h;i=f;return j|0}k=Pr(e+416|0,a,b+(c[a+68>>2]<<2)|0,d+(0-((c[a+68>>2]|0)*3|0))|0)|0;if((k|0)!=0){es(k);ce[c[g+68>>2]&127](c[g+4>>2]|0,k);kr(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function es(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=b;while(1){if((a[d]|0)==0){e=12;break}f=d;if((a[d]|0)==13){break}d=f+1|0}if((e|0)==12){i=c;return}e=f;do{do{if((a[d]|0)==13){f=e;e=f+1|0;a[f]=10;f=d+1|0;d=f;if((a[f]|0)!=10){break}d=d+1|0}else{f=d;d=f+1|0;b=e;e=b+1|0;a[b]=a[f]|0}}while(0);}while((a[d]|0)!=0);a[e]=0;i=c;return}function fs(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+72|0;j=b;b=d;d=e;e=f;f=g;g=c[j+356>>2]|0;c[d>>2]=c[(c[g+164>>2]|0)+(b*28|0)>>2];c[d+4>>2]=c[(c[g+164>>2]|0)+(b*28|0)+4>>2];if((c[d>>2]|0)==4){c[d+8>>2]=c[f>>2];k=c[(c[g+164>>2]|0)+(b*28|0)+8>>2]|0;while(1){l=a[k]|0;m=f;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;if((a[k]|0)==0){break}k=k+1|0}c[d+12>>2]=0;c[d+16>>2]=0;i=h;return}else{c[d+12>>2]=c[(c[g+164>>2]|0)+(b*28|0)+20>>2];c[d+16>>2]=c[e>>2];k=e;c[k>>2]=(c[k>>2]|0)+((c[d+12>>2]|0)*20|0);k=0;l=c[(c[g+164>>2]|0)+(b*28|0)+12>>2]|0;while(1){if(!(k>>>0<(c[d+12>>2]|0)>>>0)){break}fs(j,l,(c[d+16>>2]|0)+(k*20|0)|0,e,f);k=k+1|0;l=c[(c[g+164>>2]|0)+(l*28|0)+24>>2]|0}c[d+8>>2]=0;i=h;return}}function gs(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;l=i;i=i+392|0;m=l+32|0;n=l+88|0;o=l+104|0;p=l+128|0;q=l+168|0;r=l+184|0;s=l+232|0;t=l+248|0;u=l+344|0;v=l+352|0;w=l+368|0;x=l+384|0;y=b;b=e;e=f;c[m>>2]=g;g=h;h=j;j=k;k=c[y+356>>2]|0;f=y;if((e|0)==(c[y+144>>2]|0)){z=f+288|0;A=y+292|0}else{z=c[f+300>>2]|0;A=(c[y+300>>2]|0)+4|0}c[z>>2]=c[m>>2];a:while(1){c[n>>2]=c[m>>2];f=Ae[c[e+4>>2]&63](e,c[m>>2]|0,g,n)|0;c[A>>2]=c[n>>2];b:do{switch(f|0){case 5:{if((c[y+312>>2]|0)==(b|0)){B=109;break a}C=c[y+364>>2]|0;c[y+364>>2]=c[C>>2];c[C>>2]=c[y+368>>2];c[y+368>>2]=C;D=(c[m>>2]|0)+(c[e+68>>2]<<1)|0;E=re[c[e+32>>2]&63](e,D)|0;if((E|0)!=(c[C+8>>2]|0)){B=112;break a}if((s_(c[C+4>>2]|0,D,E)|0)!=0){B=112;break a}E=y+312|0;c[E>>2]=(c[E>>2]|0)+ -1;do{if((c[y+56>>2]|0)!=0){E=c[C+16>>2]|0;do{if((d[y+236|0]|0)!=0){if((E|0)==0){break}F=(c[C+12>>2]|0)+(c[C+28>>2]|0)|0;while(1){if((a[E]|0)==0){break}G=E;E=G+1|0;H=F;F=H+1|0;a[H]=a[G]|0}G=c[C+20>>2]|0;c:do{if((d[y+237|0]|0)!=0){if((G|0)==0){break}H=F;F=H+1|0;a[H]=a[y+472|0]|0;while(1){if((a[G]|0)==0){break c}H=G;G=H+1|0;I=F;F=I+1|0;a[I]=a[H]|0}}}while(0);a[F]=0}}while(0);ce[c[y+56>>2]&127](c[y+4>>2]|0,c[C+12>>2]|0)}else{if((c[y+80>>2]|0)==0){break}Br(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);while(1){if((c[C+44>>2]|0)==0){break}E=c[C+44>>2]|0;if((c[y+104>>2]|0)!=0){ce[c[y+104>>2]&127](c[y+4>>2]|0,c[c[E>>2]>>2]|0)}c[C+44>>2]=c[(c[C+44>>2]|0)+4>>2];c[E+4>>2]=c[y+376>>2];c[y+376>>2]=E;c[(c[E>>2]|0)+4>>2]=c[E+8>>2]}if((c[y+312>>2]|0)==0){B=133;break a}break};case-2:{B=28;break a;break};case 3:case 4:{C=(c[m>>2]|0)+(c[e+68>>2]|0)|0;c[s>>2]=0;E=1;c[t>>2]=Pr(y+416|0,e,C,C+(re[c[e+32>>2]&63](e,C)|0)|0)|0;if((c[t>>2]|0)==0){B=89;break a}c[y+432>>2]=c[y+428>>2];J=js(y,e,c[m>>2]|0,t,s)|0;if((J|0)!=0){B=91;break a}c[y+432>>2]=c[y+428>>2];if((c[y+52>>2]|0)!=0){xe[c[y+52>>2]&15](c[y+4>>2]|0,c[t>>2]|0,c[y+392>>2]|0);E=0}if((c[y+56>>2]|0)!=0){if((c[y+52>>2]|0)!=0){c[z>>2]=c[A>>2]}ce[c[y+56>>2]&127](c[y+4>>2]|0,c[t>>2]|0);E=0}do{if((E&255|0)!=0){if((c[y+80>>2]|0)==0){break}Br(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);kr(y+416|0);while(1){if((c[s>>2]|0)==0){break}E=c[s>>2]|0;if((c[y+104>>2]|0)!=0){ce[c[y+104>>2]&127](c[y+4>>2]|0,c[c[E>>2]>>2]|0)}c[s>>2]=c[(c[s>>2]|0)+4>>2];c[E+4>>2]=c[y+376>>2];c[y+376>>2]=E;c[(c[E>>2]|0)+4>>2]=c[E+8>>2]}if((c[y+312>>2]|0)==0){B=107;break a}break};case-4:{B=17;break a;break};case 12:{B=140;break a;break};case 7:{if((c[y+60>>2]|0)!=0){a[v]=10;xe[c[y+60>>2]&15](c[y+4>>2]|0,v,1);break b}if((c[y+80>>2]|0)==0){break b}Br(y,e,c[m>>2]|0,c[n>>2]|0);break};case 10:{E=re[c[e+44>>2]&63](e,c[m>>2]|0)|0;if((E|0)<0){B=135;break a}C=y;if((c[y+60>>2]|0)!=0){G=c[C+60>>2]|0;H=c[y+4>>2]|0;I=xs(E,u)|0;xe[G&15](H,u,I);break b}if((c[C+80>>2]|0)==0){break b}Br(y,e,c[m>>2]|0,c[n>>2]|0);break};case 8:{C=y;do{if((c[y+72>>2]|0)!=0){be[c[C+72>>2]&255](c[y+4>>2]|0)}else{if((c[C+80>>2]|0)==0){break}Br(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);K=ls(y,e,n,g,h,j)|0;if((K|0)!=0){B=150;break a}if((c[n>>2]|0)==0){B=152;break a}break};case-5:{B=153;break a;break};case 6:{C=c[y+60>>2]|0;if((C|0)==0){if((c[y+80>>2]|0)==0){break b}Br(y,e,c[m>>2]|0,c[n>>2]|0);break b}if((a[e+72|0]|0)!=0){xe[C&15](c[y+4>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0);break b}while(1){c[x>>2]=c[y+44>>2];_d[c[e+60>>2]&31](e,m,c[n>>2]|0,x,c[y+48>>2]|0);c[A>>2]=c[m>>2];xe[C&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[x>>2]|0)-(c[y+44>>2]|0)|0);if((c[m>>2]|0)==(c[n>>2]|0)){break b}c[z>>2]=c[m>>2]}break};case 11:{if((cs(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=174;break a}break};case 13:{if((ds(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=176;break a}break};case-3:{B=6;break a;break};case 1:case 2:{C=y;if((c[y+368>>2]|0)!=0){L=c[C+368>>2]|0;c[y+368>>2]=c[c[y+368>>2]>>2]}else{L=ee[c[C+12>>2]&127](48)|0;if((L|0)==0){B=72;break a}c[L+36>>2]=ee[c[y+12>>2]&127](32)|0;if((c[L+36>>2]|0)==0){B=74;break a}c[L+40>>2]=(c[L+36>>2]|0)+32}c[L+44>>2]=0;c[L>>2]=c[y+364>>2];c[y+364>>2]=L;c[L+16>>2]=0;c[L+20>>2]=0;c[L+4>>2]=(c[m>>2]|0)+(c[e+68>>2]|0);c[L+8>>2]=re[c[e+32>>2]&63](e,c[L+4>>2]|0)|0;C=y+312|0;c[C>>2]=(c[C>>2]|0)+1;C=(c[L+4>>2]|0)+(c[L+8>>2]|0)|0;c[r>>2]=c[L+4>>2];c[q>>2]=c[L+36>>2];while(1){_d[c[e+60>>2]&31](e,r,C,q,(c[L+40>>2]|0)+ -1|0);M=(c[q>>2]|0)-(c[L+36>>2]|0)|0;if((c[r>>2]|0)==(C|0)){break}I=(c[L+40>>2]|0)-(c[L+36>>2]|0)<<1;H=re[c[y+16>>2]&63](c[L+36>>2]|0,I)|0;if((H|0)==0){B=80;break a}c[L+36>>2]=H;c[L+40>>2]=H+I;c[q>>2]=H+M}c[L+24>>2]=M;c[L+12>>2]=c[L+36>>2];a[c[q>>2]|0]=0;N=js(y,e,c[m>>2]|0,L+12|0,L+44|0)|0;if((N|0)!=0){B=82;break a}C=y;do{if((c[y+52>>2]|0)!=0){xe[c[C+52>>2]&15](c[y+4>>2]|0,c[L+12>>2]|0,c[y+392>>2]|0)}else{if((c[C+80>>2]|0)==0){break}Br(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);kr(y+416|0);break};case 9:{a[p]=ie[c[e+48>>2]&63](e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((a[p]|0)!=0){C=y;if((c[y+60>>2]|0)!=0){xe[c[C+60>>2]&15](c[y+4>>2]|0,p,1);break b}if((c[C+80>>2]|0)==0){break b}Br(y,e,c[m>>2]|0,c[n>>2]|0);break b}C=Pr(k+80|0,e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((C|0)==0){B=37;break a}H=Gr(y,k,C,0)|0;c[k+92>>2]=c[k+96>>2];do{if((a[k+129|0]|0)!=0){if((d[k+130|0]|0)!=0){B=40;break}if((H|0)!=0){break}I=y;if((c[y+120>>2]|0)!=0){xe[c[I+120>>2]&15](c[y+4>>2]|0,C,0);break b}if((c[I+80>>2]|0)==0){break b}Br(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{B=40}}while(0);if((B|0)==40){B=0;if((H|0)==0){B=41;break a}if((a[H+34|0]|0)==0){B=43;break a}}if((a[H+32|0]|0)!=0){B=50;break a}if((c[H+28>>2]|0)!=0){B=52;break a}C=y;if((c[H+4>>2]|0)!=0){I=y;if((a[C+308|0]|0)!=0){O=as(I,H,0)|0;if((O|0)!=0){B=60;break a}else{break b}}G=y;if((c[I+120>>2]|0)!=0){xe[c[G+120>>2]&15](c[y+4>>2]|0,c[H>>2]|0,0);break b}if((c[G+80>>2]|0)==0){break b}Br(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{if((c[C+112>>2]|0)==0){if((c[y+80>>2]|0)==0){break b}Br(y,e,c[m>>2]|0,c[n>>2]|0);break b}a[H+32|0]=1;C=is(y)|0;a[H+32|0]=0;if((C|0)==0){B=63;break a}if((se[c[y+112>>2]&63](c[y+116>>2]|0,C,c[H+20>>2]|0,c[H+16>>2]|0,c[H+24>>2]|0)|0)==0){B=65;break a}c[y+428>>2]=c[y+432>>2];break b}break};case 0:{B=24;break a;break};case-1:{B=25;break a;break};default:{if((c[y+80>>2]|0)==0){break b}Br(y,e,c[m>>2]|0,c[n>>2]|0)}}}while(0);f=c[n>>2]|0;c[m>>2]=f;c[z>>2]=f;f=c[y+480>>2]|0;if((f|0)==3){B=180;break}else if((f|0)==2){B=181;break}}if((B|0)==6){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}c[A>>2]=g;do{if((c[y+60>>2]|0)!=0){a[o]=10;xe[c[y+60>>2]&15](c[y+4>>2]|0,o,1)}else{if((c[y+80>>2]|0)==0){break}Br(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=g;P=0;Q=P;i=l;return Q|0}}else if((B|0)==17){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}if((b|0)<=0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}}else if((B|0)==24){c[z>>2]=c[n>>2];P=4;Q=P;i=l;return Q|0}else if((B|0)==25){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=5;Q=P;i=l;return Q|0}}else if((B|0)==28){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=6;Q=P;i=l;return Q|0}}else if((B|0)==37){P=1;Q=P;i=l;return Q|0}else if((B|0)==41){P=11;Q=P;i=l;return Q|0}else if((B|0)==43){P=24;Q=P;i=l;return Q|0}else if((B|0)==50){P=12;Q=P;i=l;return Q|0}else if((B|0)==52){P=15;Q=P;i=l;return Q|0}else if((B|0)==60){P=O;Q=P;i=l;return Q|0}else if((B|0)==63){P=1;Q=P;i=l;return Q|0}else if((B|0)==65){P=21;Q=P;i=l;return Q|0}else if((B|0)==72){P=1;Q=P;i=l;return Q|0}else if((B|0)==74){be[c[y+20>>2]&255](L);P=1;Q=P;i=l;return Q|0}else if((B|0)==80){P=1;Q=P;i=l;return Q|0}else if((B|0)==82){P=N;Q=P;i=l;return Q|0}else if((B|0)==89){P=1;Q=P;i=l;return Q|0}else if((B|0)==91){P=J;Q=P;i=l;return Q|0}else if((B|0)==107){P=ks(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==109){P=13;Q=P;i=l;return Q|0}else if((B|0)==112){c[z>>2]=D;P=7;Q=P;i=l;return Q|0}else if((B|0)==133){P=ks(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==135){P=14;Q=P;i=l;return Q|0}else if((B|0)==140){P=17;Q=P;i=l;return Q|0}else if((B|0)==150){P=K;Q=P;i=l;return Q|0}else if((B|0)==152){c[y+280>>2]=42;P=K;Q=P;i=l;return Q|0}else if((B|0)==153){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}do{if((c[y+60>>2]|0)!=0){j=y;if((a[e+72|0]|0)!=0){xe[c[j+60>>2]&15](c[y+4>>2]|0,c[m>>2]|0,g-(c[m>>2]|0)|0);break}else{c[w>>2]=c[j+44>>2];_d[c[e+60>>2]&31](e,m,g,w,c[y+48>>2]|0);xe[c[y+60>>2]&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[w>>2]|0)-(c[y+44>>2]|0)|0);break}}else{if((c[y+80>>2]|0)==0){break}Br(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){c[z>>2]=g;P=3;Q=P;i=l;return Q|0}m=g;if((c[y+312>>2]|0)!=(b|0)){c[z>>2]=m;P=13;Q=P;i=l;return Q|0}else{c[h>>2]=m;P=0;Q=P;i=l;return Q|0}}else if((B|0)==174){P=1;Q=P;i=l;return Q|0}else if((B|0)==176){P=1;Q=P;i=l;return Q|0}else if((B|0)==180){c[h>>2]=c[n>>2];P=0;Q=P;i=l;return Q|0}else if((B|0)==181){P=35;Q=P;i=l;return Q|0}return 0}function hs(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+104|0;h=g+64|0;j=b;b=d;d=e;e=f;f=c[j+300>>2]|0;if((f|0)==0){k=23;l=k;i=g;return l|0}m=c[f+12>>2]|0;n=(c[m+4>>2]|0)+(c[m+12>>2]|0)|0;o=(c[m+4>>2]|0)+(c[m+8>>2]|0)|0;p=j;if((a[m+33|0]|0)!=0){q=Ae[c[c[p+228>>2]>>2]&63](c[j+228>>2]|0,n,o,h)|0;r=Nr(j,c[j+228>>2]|0,n,o,q,c[h>>2]|0,h,0)|0}else{r=gs(p,c[f+16>>2]|0,c[j+228>>2]|0,n,o,h,0)|0}if((r|0)!=0){k=r;l=k;i=g;return l|0}do{if((o|0)!=(c[h>>2]|0)){if((c[j+480>>2]|0)!=3){break}c[m+12>>2]=(c[h>>2]|0)-(c[m+4>>2]|0);k=r;l=k;i=g;return l|0}}while(0);a[m+32|0]=0;c[j+300>>2]=c[f+8>>2];c[f+8>>2]=c[j+304>>2];c[j+304>>2]=f;f=j+280|0;if((a[m+33|0]|0)!=0){c[f>>2]=40;m=Ae[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=Nr(j,c[j+144>>2]|0,b,d,m,c[h>>2]|0,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=gs(j,(c[j+476>>2]|0)!=0?1:0,c[j+144>>2]|0,b,d,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}return 0}function is(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d+24|0;f=b;b=c[f+356>>2]|0;g=0;do{if((c[b+156>>2]|0)!=0){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((Dr(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=61;l=c[(c[b+156>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}k=0;while(1){if((k|0)>=(l|0)){m=13;break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Dr(f+416|0)|0)<<24>>24!=0)){break}}n=a[(c[(c[b+156>>2]|0)+16>>2]|0)+k|0]|0;o=f+428|0;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n;k=k+1|0}if((m|0)==13){g=1;break}h=0;j=h;i=d;return j|0}}while(0);Er(e,b+60|0);a:while(1){k=Fr(e)|0;if((k|0)==0){m=40;break}if((c[k+4>>2]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Dr(f+416|0)|0)<<24>>24!=0)){m=21;break}}l=f+428|0;n=c[l>>2]|0;c[l>>2]=n+1;a[n]=12}n=c[k>>2]|0;while(1){q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if((a[n]|0)==0){break}if(q){if(!((Dr(f+416|0)|0)<<24>>24!=0)){m=27;break a}}l=a[n]|0;p=f+428|0;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=l;n=n+1|0}if(q){if(!((Dr(f+416|0)|0)<<24>>24!=0)){m=31;break}}n=f+428|0;l=c[n>>2]|0;c[n>>2]=l+1;a[l]=61;l=c[(c[k+4>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}n=0;while(1){if((n|0)>=(l|0)){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Dr(f+416|0)|0)<<24>>24!=0)){m=38;break a}}o=a[(c[(c[k+4>>2]|0)+16>>2]|0)+n|0]|0;p=f+428|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=o;n=n+1|0}g=1}if((m|0)==21){h=0;j=h;i=d;return j|0}else if((m|0)==27){h=0;j=h;i=d;return j|0}else if((m|0)==31){h=0;j=h;i=d;return j|0}else if((m|0)==38){h=0;j=h;i=d;return j|0}else if((m|0)==40){Er(e,b);b:while(1){b=Fr(e)|0;if((b|0)==0){m=55;break}if((a[b+32|0]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Dr(f+416|0)|0)<<24>>24!=0)){m=47;break}}q=f+428|0;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=12}n=c[b>>2]|0;while(1){if((a[n]|0)==0){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Dr(f+416|0)|0)<<24>>24!=0)){m=53;break b}}b=a[n]|0;q=f+428|0;k=c[q>>2]|0;c[q>>2]=k+1;a[k]=b;n=n+1|0}g=1}if((m|0)==47){h=0;j=h;i=d;return j|0}else if((m|0)==53){h=0;j=h;i=d;return j|0}else if((m|0)==55){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((Dr(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);m=f+428|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g]=0;h=c[f+432>>2]|0;j=h;i=d;return j|0}}return 0}function js(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+352|0;k=b;b=e;e=f;f=g;g=h;h=c[k+356>>2]|0;l=0;m=0;n=Gr(k,h+20|0,c[f>>2]|0,0)|0;do{if((n|0)==0){o=mr(h+80|0,c[f>>2]|0)|0;if((o|0)==0){p=1;q=p;i=j;return q|0}n=Gr(k,h+20|0,o,24)|0;if((n|0)==0){p=1;q=p;i=j;return q|0}if((d[k+236|0]|0)==0){break}if((ps(k,n)|0)!=0){break}p=1;q=p;i=j;return q|0}}while(0);o=c[n+12>>2]|0;r=Ae[c[b+40>>2]&63](b,e,c[k+380>>2]|0,c[k+392>>2]|0)|0;do{if((r+o|0)>(c[k+380>>2]|0)){s=c[k+380>>2]|0;c[k+380>>2]=r+o+16;t=re[c[k+16>>2]&63](c[k+392>>2]|0,c[k+380>>2]<<4)|0;if((t|0)==0){p=1;q=p;i=j;return q|0}else{c[k+392>>2]=t;if((r|0)<=(s|0)){break}Ae[c[b+40>>2]&63](b,e,r,c[k+392>>2]|0)|0;break}}}while(0);e=c[k+392>>2]|0;s=0;a:while(1){if((s|0)>=(r|0)){u=43;break}t=(c[k+392>>2]|0)+(s<<4)|0;v=c[t>>2]|0;w=c[t>>2]|0;x=Tr(k,b,v,w+(re[c[b+32>>2]&63](b,c[t>>2]|0)|0)|0)|0;if((x|0)==0){u=17;break}if((a[(c[x>>2]|0)+ -1|0]|0)!=0){u=19;break}a[(c[x>>2]|0)+ -1|0]=1;t=l;l=t+1|0;c[e+(t<<2)>>2]=c[x>>2];if((a[(c[k+392>>2]|0)+(s<<4)+12|0]|0)!=0){c[e+(l<<2)>>2]=Pr(k+416|0,b,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0)|0;if((c[e+(l<<2)>>2]|0)==0){u=33;break}c[k+432>>2]=c[k+428>>2]}else{t=1;b:do{if((a[x+8|0]|0)!=0){w=0;while(1){if((w|0)>=(o|0)){break b}y=w;if((x|0)==(c[(c[n+20>>2]|0)+(w*12|0)>>2]|0)){break}w=y+1|0}t=a[(c[n+20>>2]|0)+(y*12|0)+4|0]|0}}while(0);z=Xr(k,b,t,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0,k+416|0)|0;if((z|0)!=0){u=30;break}c[e+(l<<2)>>2]=c[k+432>>2];c[k+432>>2]=c[k+428>>2]}do{if((c[x+4>>2]|0)!=0){if((a[x+9|0]|0)==0){l=l+1|0;m=m+1|0;a[(c[x>>2]|0)+ -1|0]=2;break}A=Kr(k,c[x+4>>2]|0,x,c[e+(l<<2)>>2]|0,g)|0;if((A|0)!=0){u=38;break a}l=l+ -1|0}else{l=l+1|0}}while(0);s=s+1|0}if((u|0)==17){p=1;q=p;i=j;return q|0}else if((u|0)==19){if((b|0)==(c[k+144>>2]|0)){c[k+288>>2]=c[(c[k+392>>2]|0)+(s<<4)>>2]}p=8;q=p;i=j;return q|0}else if((u|0)==30){p=z;q=p;i=j;return q|0}else if((u|0)==33){p=1;q=p;i=j;return q|0}else if((u|0)==38){p=A;q=p;i=j;return q|0}else if((u|0)==43){c[k+384>>2]=l;c:do{if((c[n+8>>2]|0)!=0){if((a[(c[c[n+8>>2]>>2]|0)+ -1|0]|0)==0){u=50;break}s=0;while(1){if((s|0)>=(l|0)){break c}B=s;if((c[e+(s<<2)>>2]|0)==(c[c[n+8>>2]>>2]|0)){break}s=B+2|0}c[k+388>>2]=B}else{u=50}}while(0);if((u|0)==50){c[k+388>>2]=-1}s=0;d:while(1){if((s|0)>=(o|0)){break}B=(c[n+20>>2]|0)+(s*12|0)|0;do{if((a[(c[c[B>>2]>>2]|0)+ -1|0]|0)==0){if((c[B+8>>2]|0)==0){break}A=c[B>>2]|0;if((c[(c[B>>2]|0)+4>>2]|0)==0){a[(c[A>>2]|0)+ -1|0]=1;z=l;l=z+1|0;c[e+(z<<2)>>2]=c[c[B>>2]>>2];z=l;l=z+1|0;c[e+(z<<2)>>2]=c[B+8>>2];break}if((a[A+9|0]|0)!=0){C=Kr(k,c[(c[B>>2]|0)+4>>2]|0,c[B>>2]|0,c[B+8>>2]|0,g)|0;if((C|0)!=0){u=58;break d}else{break}}else{a[(c[c[B>>2]>>2]|0)+ -1|0]=2;m=m+1|0;A=l;l=A+1|0;c[e+(A<<2)>>2]=c[c[B>>2]>>2];A=l;l=A+1|0;c[e+(A<<2)>>2]=c[B+8>>2];break}}}while(0);s=s+1|0}if((u|0)==58){p=C;q=p;i=j;return q|0}c[e+(l<<2)>>2]=0;s=0;e:do{if((m|0)!=0){C=c[k+400>>2]|0;o=1<<d[k+404|0];do{if((m<<1>>d[k+404|0]|0)!=0){do{B=k+404|0;A=a[B]|0;a[B]=A+1<<24>>24;}while((m>>(A&255)|0)!=0);if((d[k+404|0]|0)<3){a[k+404|0]=3}o=1<<d[k+404|0];A=re[c[k+16>>2]&63](c[k+396>>2]|0,o*12|0)|0;if((A|0)!=0){c[k+396>>2]=A;C=0;break}p=1;q=p;i=j;return q|0}}while(0);f:do{if((C|0)==0){C=-1;D=o;while(1){if((D|0)==0){break f}A=D+ -1|0;D=A;c[(c[k+396>>2]|0)+(A*12|0)>>2]=C}}}while(0);A=C+ -1|0;C=A;c[k+400>>2]=A;g:while(1){if((s|0)>=(l|0)){break e}A=c[e+(s<<2)>>2]|0;if((a[A+ -1|0]|0)==2){B=c[k+496>>2]|0;a[A+ -1|0]=0;z=c[(c[(Gr(k,h+40|0,A,0)|0)+4>>2]|0)+4>>2]|0;if((z|0)==0){u=78;break}D=0;while(1){if((D|0)>=(c[z+20>>2]|0)){break}b=a[(c[z+16>>2]|0)+D|0]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Dr(k+416|0)|0)<<24>>24!=0)){u=84;break g}}y=k+428|0;x=c[y>>2]|0;c[y>>2]=x+1;a[x]=b;B=B*1000003^b&255;D=D+1|0}do{b=A;A=b+1|0;}while((a[b]|0)!=58);do{b=a[A]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Dr(k+416|0)|0)<<24>>24!=0)){u=89;break g}}x=a[A]|0;y=k+428|0;t=c[y>>2]|0;c[y>>2]=t+1;a[t]=x;B=B*1000003^b&255;b=A;A=b+1|0;}while((a[b]|0)!=0);b=0;x=o-1|0;D=B&x;while(1){if((c[(c[k+396>>2]|0)+(D*12|0)>>2]|0)!=(C|0)){break}if((B|0)==(c[(c[k+396>>2]|0)+(D*12|0)+4>>2]|0)){t=c[k+432>>2]|0;y=c[(c[k+396>>2]|0)+(D*12|0)+8>>2]|0;while(1){if((a[t]|0)!=(a[y]|0)){break}if((a[t]|0)==0){break}t=t+1|0;y=y+1|0}if((a[t]|0)==0){u=98;break g}}if(!(b<<24>>24!=0)){b=((B&~x)>>>((d[k+404|0]|0)-1|0)&x>>>2|1)&255}if((D|0)<(b&255|0)){D=D+(o-(b&255))|0;continue}else{D=D-(b&255)|0;continue}}if((a[k+237|0]|0)!=0){a[(c[k+428>>2]|0)+ -1|0]=a[k+472|0]|0;A=c[c[z>>2]>>2]|0;do{if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Dr(k+416|0)|0)<<24>>24!=0)){u=109;break g}}b=a[A]|0;x=k+428|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=b;b=A;A=b+1|0;}while((a[b]|0)!=0)}A=c[k+432>>2]|0;c[k+432>>2]=c[k+428>>2];c[e+(s<<2)>>2]=A;c[(c[k+396>>2]|0)+(D*12|0)>>2]=C;c[(c[k+396>>2]|0)+(D*12|0)+4>>2]=B;c[(c[k+396>>2]|0)+(D*12|0)+8>>2]=A;z=m+ -1|0;m=z;if((z|0)==0){u=111;break}}else{a[A+ -1|0]=0}s=s+2|0}if((u|0)==78){p=27;q=p;i=j;return q|0}else if((u|0)==84){p=1;q=p;i=j;return q|0}else if((u|0)==89){p=1;q=p;i=j;return q|0}else if((u|0)==98){p=8;q=p;i=j;return q|0}else if((u|0)==109){p=1;q=p;i=j;return q|0}else if((u|0)==111){s=s+2|0;break}}}while(0);while(1){if((s|0)>=(l|0)){break}a[(c[e+(s<<2)>>2]|0)+ -1|0]=0;s=s+2|0}e=c[g>>2]|0;while(1){if((e|0)==0){break}a[(c[c[e+12>>2]>>2]|0)+ -1|0]=0;e=c[e+4>>2]|0}if((a[k+236|0]|0)==0){p=0;q=p;i=j;return q|0}do{if((c[n+4>>2]|0)!=0){e=c[(c[n+4>>2]|0)+4>>2]|0;if((e|0)!=0){E=c[f>>2]|0;do{g=E;E=g+1|0;}while((a[g]|0)!=58)}else{p=27;q=p;i=j;return q|0}}else{if((c[h+156>>2]|0)!=0){e=c[h+156>>2]|0;E=c[f>>2]|0;break}p=0;q=p;i=j;return q|0}}while(0);h=0;do{if((d[k+237|0]|0)!=0){if((c[c[e>>2]>>2]|0)==0){break}do{n=h;h=n+1|0;}while((a[(c[c[e>>2]>>2]|0)+n|0]|0)!=0)}}while(0);c[f+4>>2]=E;c[f+16>>2]=c[e+20>>2];c[f+8>>2]=c[c[e>>2]>>2];c[f+20>>2]=h;s=0;do{n=s;s=n+1|0;}while((a[E+n|0]|0)!=0);r=s+(c[e+20>>2]|0)+h|0;if((r|0)>(c[e+24>>2]|0)){F=ee[c[k+12>>2]&127](r+24|0)|0;if((F|0)==0){p=1;q=p;i=j;return q|0}c[e+24>>2]=r+24;z_(F|0,c[e+16>>2]|0,c[e+20>>2]|0)|0;r=c[k+364>>2]|0;while(1){if((r|0)==0){break}if((c[r+12>>2]|0)==(c[e+16>>2]|0)){c[r+12>>2]=F}r=c[r>>2]|0}be[c[k+20>>2]&255](c[e+16>>2]|0);c[e+16>>2]=F}F=(c[e+16>>2]|0)+(c[e+20>>2]|0)|0;z_(F|0,E|0,s|0)|0;if((h|0)!=0){F=F+(s-1)|0;a[F]=a[k+472|0]|0;z_(F+1|0,c[c[e>>2]>>2]|0,h|0)|0}c[f>>2]=c[e+16>>2];p=0;q=p;i=j;return q|0}return 0}function ks(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+40|0;j=b;b=d;d=e;e=f;c[j+280>>2]=43;c[j+288>>2]=b;a:while(1){c[h>>2]=0;f=Ae[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;c[j+292>>2]=c[h>>2];b:do{switch(f|0){case-15:{k=3;break a;break};case 15:{if((c[j+80>>2]|0)==0){break b}Br(j,c[j+144>>2]|0,b,c[h>>2]|0);break};case 11:{if((cs(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=11;break a}break};case 0:{k=14;break a;break};case-2:{k=18;break a;break};case-4:{k=7;break a;break};case 13:{if((ds(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=13;break a}break};case-1:{k=15;break a;break};default:{k=21;break a}}}while(0);f=c[h>>2]|0;b=f;c[j+288>>2]=f;f=c[j+480>>2]|0;if((f|0)==2){k=24;break}else if((f|0)==3){k=23;break}}if((k|0)==3){do{if((c[j+80>>2]|0)!=0){Br(j,c[j+144>>2]|0,b,c[h>>2]|0);if((c[j+480>>2]|0)!=2){break}l=35;m=l;i=g;return m|0}}while(0);c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==7){c[e>>2]=b;l=0;m=l;i=g;return m|0}else if((k|0)==11){l=1;m=l;i=g;return m|0}else if((k|0)==13){l=1;m=l;i=g;return m|0}else if((k|0)==14){c[j+288>>2]=c[h>>2];l=4;m=l;i=g;return m|0}else if((k|0)==15){if((a[j+484|0]|0)!=0){l=5;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==18){if((a[j+484|0]|0)!=0){l=6;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==21){l=9;m=l;i=g;return m|0}else if((k|0)==23){c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==24){l=35;m=l;i=g;return m|0}return 0}function ls(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+120|0;k=j+56|0;l=j+80|0;m=j+96|0;n=j+112|0;o=b;b=d;d=e;e=f;f=g;g=h;c[k>>2]=c[d>>2];h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;c[p>>2]=c[k>>2];q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}c[p>>2]=c[k>>2];c[d>>2]=0;a:while(1){h=Ae[c[b+8>>2]&63](b,c[k>>2]|0,e,l)|0;c[q>>2]=c[l>>2];b:do{switch(h|0){case-2:{r=25;break a;break};case 0:{r=24;break a;break};case-4:case-1:{r=28;break a;break};case 7:{if((c[o+60>>2]|0)!=0){a[m]=10;xe[c[o+60>>2]&15](c[o+4>>2]|0,m,1);break b}if((c[o+80>>2]|0)==0){break b}Br(o,b,c[k>>2]|0,c[l>>2]|0);break};case 6:{s=c[o+60>>2]|0;if((s|0)==0){if((c[o+80>>2]|0)==0){break b}Br(o,b,c[k>>2]|0,c[l>>2]|0);break b}if((a[b+72|0]|0)!=0){xe[s&15](c[o+4>>2]|0,c[k>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0);break b}while(1){c[n>>2]=c[o+44>>2];_d[c[b+60>>2]&31](b,k,c[l>>2]|0,n,c[o+48>>2]|0);c[q>>2]=c[l>>2];xe[s&15](c[o+4>>2]|0,c[o+44>>2]|0,(c[n>>2]|0)-(c[o+44>>2]|0)|0);if((c[k>>2]|0)==(c[l>>2]|0)){break b}c[p>>2]=c[k>>2]}break};case 40:{r=6;break a;break};default:{r=31;break a}}}while(0);h=c[l>>2]|0;c[k>>2]=h;c[p>>2]=h;h=c[o+480>>2]|0;if((h|0)==2){r=34;break}else if((h|0)==3){r=33;break}}if((r|0)==6){n=o;do{if((c[o+76>>2]|0)!=0){be[c[n+76>>2]&255](c[o+4>>2]|0)}else{if((c[n+80>>2]|0)==0){break}Br(o,b,c[k>>2]|0,c[l>>2]|0)}}while(0);c[d>>2]=c[l>>2];c[f>>2]=c[l>>2];if((c[o+480>>2]|0)==2){t=35;u=t;i=j;return u|0}else{t=0;u=t;i=j;return u|0}}else if((r|0)==24){c[p>>2]=c[l>>2];t=4;u=t;i=j;return u|0}else if((r|0)==25){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=6;u=t;i=j;return u|0}}else if((r|0)==28){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=20;u=t;i=j;return u|0}}else if((r|0)==31){c[p>>2]=c[l>>2];t=23;u=t;i=j;return u|0}else if((r|0)==33){c[f>>2]=c[l>>2];t=0;u=t;i=j;return u|0}else if((r|0)==34){t=35;u=t;i=j;return u|0}return 0}function ms(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=ls(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)==0){k=f;l=k;i=g;return l|0}f=j+280|0;if((c[j+476>>2]|0)!=0){c[f>>2]=44;k=ns(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=Rr(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}return 0}function ns(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=gs(h,1,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((os(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function os(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+56|0;d=a;a=c[d+364>>2]|0;while(1){if((a|0)==0){e=13;break}f=(c[a+24>>2]|0)+1|0;g=(c[a+36>>2]|0)+f|0;if((c[a+4>>2]|0)==(g|0)){e=13;break}h=f+((c[a+8>>2]|0)+0)|0;if((h|0)>((c[a+40>>2]|0)-(c[a+36>>2]|0)|0)){j=re[c[d+16>>2]&63](c[a+36>>2]|0,h)|0;if((j|0)==0){e=6;break}if((c[a+12>>2]|0)==(c[a+36>>2]|0)){c[a+12>>2]=j}if((c[a+16>>2]|0)!=0){c[a+16>>2]=j+((c[a+16>>2]|0)-(c[a+36>>2]|0))}c[a+36>>2]=j;c[a+40>>2]=j+h;g=j+f|0}z_(g|0,c[a+4>>2]|0,c[a+8>>2]|0)|0;c[a+4>>2]=g;a=c[a>>2]|0}if((e|0)==6){k=0;l=k;i=b;return l|0}else if((e|0)==13){k=1;l=k;i=b;return l|0}return 0}function ps(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=c[b>>2]|0;a:while(1){if((a[g]|0)==0){h=20;break}if((a[g]|0)==58){j=c[b>>2]|0;while(1){k=(c[d+92>>2]|0)==(c[d+88>>2]|0);if((j|0)==(g|0)){break}if(k){if(!((Dr(d+80|0)|0)<<24>>24!=0)){h=9;break a}}l=a[j]|0;m=d+92|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;j=j+1|0}if(k){if(!((Dr(d+80|0)|0)<<24>>24!=0)){h=13;break}}j=d+92|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;l=Gr(f,d+60|0,c[d+96>>2]|0,8)|0;if((l|0)==0){h=14;break}j=d+80|0;if((c[l>>2]|0)==(c[d+96>>2]|0)){c[d+96>>2]=c[j+12>>2]}else{c[d+92>>2]=c[j+16>>2]}c[b+4>>2]=l}g=g+1|0}if((h|0)==9){o=0;p=o;i=e;return p|0}else if((h|0)==13){o=0;p=o;i=e;return p|0}else if((h|0)==14){o=0;p=o;i=e;return p|0}else if((h|0)==20){o=1;p=o;i=e;return p|0}return 0}function qs(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+152|0;l=k+64|0;m=k+80|0;n=b;b=e;e=f;f=g;g=h;h=j;j=c[n+356>>2]|0;a:while(1){b:do{switch(Ae[c[b+16>>2]&63](b,f,g,l)|0){case-4:{o=3;break a;break};case-3:{c[l>>2]=f+(c[b+68>>2]|0);o=31;break};case-1:{o=7;break a;break};case 10:{p=re[c[b+44>>2]&63](b,f)|0;if((p|0)<0){o=11;break a}do{if(!(e<<24>>24!=0)){if((p|0)!=32){break}if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break b}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break b}}}while(0);p=xs(p,m)|0;if((p|0)==0){o=19;break a}q=0;while(1){if((q|0)>=(p|0)){break b}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Dr(h)|0)<<24>>24!=0)){o=27;break a}}r=a[m+q|0]|0;s=h+12|0;t=c[s>>2]|0;c[s>>2]=t+1;a[t]=r;q=q+1|0}break};case 9:{q=(ie[c[b+48>>2]&63](b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0)&255;if(q<<24>>24!=0){if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Dr(h)|0)<<24>>24!=0)){o=42;break a}}p=h+12|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=q;break b}q=Pr(n+440|0,b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((q|0)==0){o=44;break a}r=Gr(n,j,q,0)|0;c[n+452>>2]=c[n+456>>2];if((h|0)==(j+80|0)){if((c[n+272>>2]|0)!=0){if((d[j+130|0]|0)!=0){u=(c[n+300>>2]|0)!=0}else{u=(a[j+129|0]|0)!=0}v=((u^1)&1|0)!=0}else{v=0}w=v&1}else{if((a[j+129|0]|0)!=0){x=(d[j+130|0]|0)!=0}else{x=1}w=x&1}q=(r|0)!=0;if(w<<24>>24!=0){if(!q){o=57;break a}if((a[r+34|0]|0)==0){o=59;break a}}else{if(!q){break b}}if((a[r+32|0]|0)!=0){o=62;break a}if((c[r+28>>2]|0)!=0){o=66;break a}if((c[r+4>>2]|0)==0){o=70;break a}q=(c[r+4>>2]|0)+(c[r+8>>2]|0)|0;a[r+32|0]=1;y=qs(n,c[n+228>>2]|0,e,c[r+4>>2]|0,q,h)|0;a[r+32|0]=0;if((y|0)!=0){o=74;break a}break};case 0:{o=4;break a;break};case 6:{if((Vr(h,b,f,c[l>>2]|0)|0)==0){o=29;break a}break};case 7:case 39:{o=31;break};default:{o=75;break a}}}while(0);do{if((o|0)==31){o=0;if(!(e<<24>>24!=0)){if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break}}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Dr(h)|0)<<24>>24!=0)){o=37;break a}}r=h+12|0;q=c[r>>2]|0;c[r>>2]=q+1;a[q]=32}}while(0);f=c[l>>2]|0}if((o|0)==3){z=0;A=z;i=k;return A|0}else if((o|0)==4){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=c[l>>2]}z=4;A=z;i=k;return A|0}else if((o|0)==7){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=4;A=z;i=k;return A|0}else if((o|0)==11){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==19){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==27){z=1;A=z;i=k;return A|0}else if((o|0)==29){z=1;A=z;i=k;return A|0}else if((o|0)==37){z=1;A=z;i=k;return A|0}else if((o|0)==42){z=1;A=z;i=k;return A|0}else if((o|0)==44){z=1;A=z;i=k;return A|0}else if((o|0)==57){z=11;A=z;i=k;return A|0}else if((o|0)==59){z=24;A=z;i=k;return A|0}else if((o|0)==62){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=12;A=z;i=k;return A|0}else if((o|0)==66){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=15;A=z;i=k;return A|0}else if((o|0)==70){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=16;A=z;i=k;return A|0}else if((o|0)==74){z=y;A=z;i=k;return A|0}else if((o|0)==75){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=23;A=z;i=k;return A|0}return 0}function rs(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1080|0;f=e+24|0;g=b;b=d;do{if((c[g+124>>2]|0)!=0){d=0;while(1){if((d|0)>=256){break}c[f+(d<<2)>>2]=-1;d=d+1|0}c[f+1028>>2]=0;c[f+1024>>2]=0;c[f+1032>>2]=0;do{if((ie[c[g+124>>2]&63](c[g+248>>2]|0,b,f)|0)!=0){d=c[g+12>>2]|0;h=ys()|0;c[g+240>>2]=ee[d&127](h)|0;if((c[g+240>>2]|0)!=0){h=Ae[((a[g+236|0]&255|0)!=0?45:46)&63](c[g+240>>2]|0,f,c[f+1028>>2]|0,c[f+1024>>2]|0)|0;if((h|0)==0){break}c[g+244>>2]=c[f+1024>>2];c[g+252>>2]=c[f+1032>>2];c[g+144>>2]=h;j=0;k=j;i=e;return k|0}if((c[f+1032>>2]|0)!=0){be[c[f+1032>>2]&255](c[f+1024>>2]|0)}j=1;k=j;i=e;return k|0}}while(0);if((c[f+1032>>2]|0)==0){break}be[c[f+1032>>2]&255](c[f+1024>>2]|0)}}while(0);j=18;k=j;i=e;return k|0}function ss(){var a=0,b=0;a=i;i=i+8|0;Zb(((oc(0)|0)>>>0)%4294967295|0|0);b=F_()|0;i=a;return b|0}function ts(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+48|0;g=a;a=Lr(g)|0;if((a|0)!=0){h=a;j=h;i=f;return j|0}else{c[g+280>>2]=40;h=Mr(g,b,d,e)|0;j=h;i=f;return j|0}return 0}function us(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=ee[c[e>>2]&127](188)|0;f=b;if((b|0)==0){g=f;h=g;i=d;return h|0}else{vs(f+80|0,e);vs(b+104|0,e);ws(b,e);ws(b+20|0,e);ws(b+40|0,e);ws(b+60|0,e);a[b+131|0]=0;ws(b+132|0,e);c[b+152>>2]=0;c[b+156>>2]=0;a[b+160|0]=0;c[b+184>>2]=0;c[b+164>>2]=0;c[b+180>>2]=0;c[b+172>>2]=0;c[b+176>>2]=0;c[b+168>>2]=0;a[b+128|0]=1;a[b+129|0]=0;a[b+130|0]=0;g=b;h=g;i=d;return h|0}return 0}function vs(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;c[e>>2]=0;c[e+4>>2]=0;c[e+16>>2]=0;c[e+12>>2]=0;c[e+8>>2]=0;c[e+20>>2]=b;i=d;return}function ws(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=b;a[f+4|0]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f>>2]=0;c[f+16>>2]=d;i=e;return}function xs(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;if((e|0)<0){f=0;g=f;i=d;return g|0}c=e;if((e|0)<128){a[b]=c;f=1;g=f;i=d;return g|0}h=e;if((c|0)<2048){a[b]=h>>6|192;a[b+1|0]=e&63|128;f=2;g=f;i=d;return g|0}c=e;if((h|0)<65536){a[b]=c>>12|224;a[b+1|0]=e>>6&63|128;a[b+2|0]=e&63|128;f=3;g=f;i=d;return g|0}if((c|0)<1114112){a[b]=e>>18|240;a[b+1|0]=e>>12&63|128;a[b+2|0]=e>>6&63|128;a[b+3|0]=e&63|128;f=4;g=f;i=d;return g|0}else{f=0;g=f;i=d;return g|0}return 0}function ys(){i=i;return 1912}



function $B(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=Ac(4)|0;AZ(m);Pd(m|0,122136,127)}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;do{if((a[b+98|0]|0)==0){p=qC(l)|0;q=b+36|0;o=c[q>>2]|0;r=(c[b+40>>2]|0)-o|0;s=b;if((p|0)>0){t=ZQ(s)|0;u=(fa(t-(YQ(s)|0)|0,p)|0)+r|0;v=0;break}p=YQ(s)|0;if((p|0)==(ZQ(s)|0)){u=r;v=0;break}t=c[k>>2]|0;w=b+32|0;x=c[w>>2]|0;y=rC(t,g,x,o,p-(XQ(s)|0)|0)|0;u=r-y+(c[q>>2]|0)-(c[w>>2]|0)|0;v=1}else{w=b;q=ZQ(w)|0;u=q-(YQ(w)|0)|0;v=0}}while(0);if((Tc(c[h>>2]|0,0-u|0,1)|0)!=0){j=-1;i=d;return j|0}if(v){w=f;q=c[w+4>>2]|0;y=b+72|0;c[y>>2]=c[w>>2];c[y+4>>2]=q}q=c[b+32>>2]|0;c[b+40>>2]=q;c[b+36>>2]=q;$Q(b,0,0,0);c[m>>2]=0}else{q=b;y=bR(q)|0;do{if((y|0)!=(aR(q)|0)){if((re[c[(c[b>>2]|0)+52>>2]&63](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);q=b+72|0;y=b+32|0;w=b+52|0;while(1){r=c[y>>2]|0;s=pC(c[k>>2]|0,q,r,r+(c[w>>2]|0)|0,e)|0;r=c[y>>2]|0;p=(c[e>>2]|0)-r|0;if((nc(r|0,1,p|0,c[h>>2]|0)|0)!=(p|0)){j=-1;z=23;break}if((s|0)==2){j=-1;z=23;break}else if((s|0)!=1){z=10;break}}if((z|0)==10){if((qd(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((z|0)==23){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function aC(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=b+64|0;if((c[l>>2]|0)==0){m=-1;i=d;return m|0}n=kC(b)|0;o=b;if((YQ(o)|0)==0){p=e+1|0;$Q(o,e,p,p)}if(n){q=0}else{n=ZQ(o)|0;c[f>>2]=(n-(XQ(o)|0)|0)/2|0;c[g>>2]=4;q=c[(lC(f,g)|0)>>2]|0}g=YQ(o)|0;do{if((g|0)==(ZQ(o)|0)){A_(XQ(o)|0,g+(0-q)|0,q|0)|0;if((a[b+98|0]|0)!=0){f=ZQ(o)|0;n=XQ(o)|0;p=pb(n+q|0,1,f-q-n|0,c[l>>2]|0)|0;if((p|0)==0){r=-1;break}n=XQ(o)|0;$Q(o,n,n+q|0,n+(p+q)|0);r=iC(a[YQ(o)|0]|0)|0;break}p=b+32|0;n=b+36|0;f=c[n>>2]|0;s=b+40|0;A_(c[p>>2]|0,f|0,(c[s>>2]|0)-f|0)|0;f=c[p>>2]|0;t=f+((c[s>>2]|0)-(c[n>>2]|0))|0;c[n>>2]=t;if((f|0)==(b+44|0)){u=8}else{u=c[b+52>>2]|0}v=f+u|0;c[s>>2]=v;f=b+60|0;c[h>>2]=(c[f>>2]|0)-q;c[j>>2]=v-t;v=c[(lC(h,j)|0)>>2]|0;w=b+72|0;x=w;y=c[x+4>>2]|0;z=b+80|0;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=pb(t|0,1,v|0,c[l>>2]|0)|0;if((y|0)==0){r=-1;break}v=c[b+68>>2]|0;if((v|0)==0){t=Ac(4)|0;AZ(t);Pd(t|0,122136,127)}t=(c[n>>2]|0)+y|0;c[s>>2]=t;y=c[p>>2]|0;z=XQ(o)|0;if((mC(v,w,y,t,n,z+q|0,z+(c[f>>2]|0)|0,k)|0)==3){f=c[p>>2]|0;$Q(o,f,f,c[s>>2]|0);r=iC(a[YQ(o)|0]|0)|0;break}s=c[k>>2]|0;f=XQ(o)|0;p=f+q|0;if((s|0)==(p|0)){r=-1;break}$Q(o,f,p,s);r=iC(a[YQ(o)|0]|0)|0}else{r=iC(a[g]|0)|0}}while(0);if((XQ(o)|0)!=(e|0)){m=r;i=d;return m|0}$Q(o,0,0,0);m=r;i=d;return m|0}function bC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[b+64>>2]|0)==0){f=-1;i=e;return f|0}g=b;h=XQ(g)|0;j=YQ(g)|0;if(!(h>>>0<j>>>0)){f=-1;i=e;return f|0}if(eC(d,-1)|0){_Q(g,-1);f=hC(d)|0;i=e;return f|0}h=(c[b+88>>2]&16|0)==0;b=fC(d)|0;do{if(h){if(jC(b,a[j+ -1|0]|0)|0){break}else{f=-1}i=e;return f|0}}while(0);_Q(g,-1);a[YQ(g)|0]=b;f=d;i=e;return f|0}function cC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}dC(b);l=b;m=aR(l)|0;n=cR(l)|0;if(!(eC(d,-1)|0)){if((bR(l)|0)==0){eR(l,f,f+1|0)}f=fC(d)|0;a[bR(l)|0]=f;dR(l,1)}f=bR(l)|0;o=aR(l)|0;if((f|0)!=(o|0)){a:do{if((a[b+98|0]|0)==0){p=b+32|0;q=c[p>>2]|0;c[g>>2]=q;r=b+68|0;s=c[r>>2]|0;if((s|0)==0){t=Ac(4)|0;u=t;AZ(u);v=122136;w=127;Pd(t|0,v|0,w|0)}x=b+72|0;y=b+52|0;z=q;q=s;while(1){s=aR(l)|0;A=bR(l)|0;B=gC(q,x,s,A,h,z,z+(c[y>>2]|0)|0,g)|0;A=c[h>>2]|0;C=aR(l)|0;if((A|0)==(C|0)){k=-1;D=22;break}if((B|0)==3){D=14;break}if(!(B>>>0<2)){k=-1;D=22;break}A=c[p>>2]|0;s=(c[g>>2]|0)-A|0;if((nc(A|0,1,s|0,c[j>>2]|0)|0)!=(s|0)){k=-1;D=22;break}if((B|0)!=1){break a}B=c[h>>2]|0;eR(l,B,bR(l)|0);B=cR(l)|0;dR(l,B-(aR(l)|0)|0);B=c[r>>2]|0;if((B|0)==0){D=11;break}z=c[p>>2]|0;q=B}if((D|0)==11){t=Ac(4)|0;u=t;AZ(u);v=122136;w=127;Pd(t|0,v|0,w|0)}else if((D|0)==14){q=(bR(l)|0)-C|0;if((nc(C|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((D|0)==22){i=e;return k|0}}else{q=f-o|0;if((nc(o|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);eR(l,m,n)}k=hC(d)|0;i=e;return k|0}function dC(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+92|0;if((c[e>>2]&16|0)!=0){i=d;return}f=b;$Q(f,0,0,0);g=c[b+52>>2]|0;do{if(g>>>0>8){if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;eR(f,h,h+((c[b+60>>2]|0)+ -1)|0);break}else{h=c[b+32>>2]|0;eR(f,h,h+(g+ -1)|0);break}}else{eR(f,0,0)}}while(0);c[e>>2]=16;i=d;return}function eC(a,b){a=a|0;b=b|0;i=i;return(a|0)==(b|0)|0}function fC(a){a=a|0;i=i;return a&255|0}function gC(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=le[c[(c[a>>2]|0)+12>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function hC(a){a=a|0;var b=0,c=0;b=i;c=eC(a,-1)|0;i=b;return(c?0:a)|0}function iC(a){a=a|0;i=i;return a&255|0}function jC(a,b){a=a|0;b=b|0;i=i;return a<<24>>24==b<<24>>24|0}function kC(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+92|0;if((c[e>>2]&8|0)!=0){f=0;i=d;return f|0}g=b;eR(g,0,0);if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;j=h+(c[b+60>>2]|0)|0;$Q(g,h,j,j)}else{j=c[b+32>>2]|0;h=j+(c[b+52>>2]|0)|0;$Q(g,j,h,h)}c[e>>2]=8;f=1;i=d;return f|0}function lC(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=nC(b,c,e)|0;i=d;return g|0}function mC(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=le[c[(c[a>>2]|0)+16>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function nC(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=oC(0,b,a)|0;i=c;return(d?b:a)|0}function oC(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function pC(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=se[c[(c[a>>2]|0)+20>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function qC(a){a=a|0;var b=0,d=0;b=i;d=ee[c[(c[a>>2]|0)+24>>2]&127](a)|0;i=b;return d|0}function rC(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=se[c[(c[a>>2]|0)+32>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function sC(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function tC(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function uC(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=vC(b,c,e)|0;i=d;return g|0}function vC(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=wC(0,a,b)|0;i=c;return(d?b:a)|0}function wC(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function xC(a){a=a|0;var b=0,c=0;b=i;c=AW(a,106640)|0;i=b;return c|0}function yC(a){a=a|0;var b=0,d=0;b=i;d=ee[c[(c[a>>2]|0)+28>>2]&127](a)|0;i=b;return d|0}function zC(a){a=a|0;var b=0;b=i;AC(a);i=b;return}function AC(a){a=a|0;var b=0;b=i;BC(a);i=b;return}function BC(a){a=a|0;var b=0;b=i;CC(a,dB(a)|0);i=b;return}function CC(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;kB(d);if((b|0)==0){i=d;return}CC(a,c[b>>2]|0);CC(a,c[b+4>>2]|0);EC(DC(a)|0,b,1);i=d;return}function DC(a){a=a|0;var b=0,c=0;b=i;c=GC(a+4|0)|0;i=b;return c|0}function EC(a,b,c){a=a|0;b=b|0;c=c|0;c=i;FC(0,b,0);i=c;return}function FC(a,b,c){a=a|0;b=b|0;c=c|0;c=i;b_(b);i=c;return}function GC(a){a=a|0;var b=0,c=0;b=i;c=HC(a)|0;i=b;return c|0}function HC(a){a=a|0;i=i;return a|0}function IC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=JC(a,f,b)|0;l=c[k>>2]|0;kB(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}LC(j,a,b);MC(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];KC(g,e);NC(j);j=c[f>>2]|0;OC(a,j,k,PC(g)|0);k=QC(g)|0;NC(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function JC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=dB(h)|0;kB(e);if((a|0)==0){j=WA(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(hB(0,d,a)|0){m=l;j=c[m>>2]|0;kB(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(hB(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;kB(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function KC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];CD(a,e);i=d;return}function LC(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=DC(d)|0;d=lD(n,1)|0;mD(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];kD(j,d,h);nD(0,gD((oD(j)|0)+16|0)|0,e);e=pD(j)|0;a[e+4|0]=1;qD(0,fD((oD(j)|0)+20|0)|0);a[e+5|0]=1;rD(m,j);MC(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];KC(b,g);NC(m);NC(j);i=f;return}function MC(a,b){a=a|0;b=b|0;var c=0;c=i;iD(a,b);i=c;return}function NC(a){a=a|0;var b=0;b=i;bD(a);i=b;return}function OC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;kB(f);c[e>>2]=0;kB(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=VC(a)|0;b=c[c[e>>2]>>2]|0;kB(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(WA(a)|0)>>2]|0;WC(e,c[d>>2]|0);d=XC(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function PC(a){a=a|0;var b=0,d=0;b=i;d=c[(TC(a)|0)>>2]|0;i=b;return d|0}function QC(a){a=a|0;var b=0,d=0;b=i;d=RC(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function RC(a){a=a|0;var b=0,c=0;b=i;c=SC(a)|0;i=b;return c|0}function SC(a){a=a|0;i=i;return a|0}function TC(a){a=a|0;var b=0,c=0;b=i;c=UC(a)|0;i=b;return c|0}function UC(a){a=a|0;i=i;return a|0}function VC(a){a=a|0;i=i;return a|0}function WC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(d|0)==(b|0);a[d+12|0]=h&1;if(h){i=e;return}else{j=d}while(1){k=j+8|0;d=c[k>>2]|0;if((a[d+12|0]|0)!=0){l=17;break}h=_C(d)|0;m=c[d+8>>2]|0;if(h){h=c[m+4>>2]|0;kB(f);if((h|0)==0){l=7;break}d=h+12|0;if((a[d]|0)!=0){l=7;break}h=c[k>>2]|0;a[h+12|0]=1;n=c[h+8>>2]|0;a[n+12|0]=(n|0)==(b|0)|0;a[d]=1;o=n}else{n=c[m>>2]|0;kB(g);if((n|0)==0){l=14;break}m=n+12|0;if((a[m]|0)!=0){l=14;break}n=c[k>>2]|0;a[n+12|0]=1;d=c[n+8>>2]|0;a[d+12|0]=(d|0)==(b|0)|0;a[m]=1;o=d}if((o|0)==(b|0)){l=17;break}else{j=o}}if((l|0)==7){if(_C(j)|0){p=j}else{o=c[k>>2]|0;$C(o);p=o}o=c[p+8>>2]|0;a[o+12|0]=1;p=c[o+8>>2]|0;a[p+12|0]=0;aD(p);i=e;return}else if((l|0)==14){if(_C(j)|0){p=c[k>>2]|0;aD(p);q=p}else{q=j}j=c[q+8>>2]|0;a[j+12|0]=1;q=c[j+8>>2]|0;a[q+12|0]=0;$C(q);i=e;return}else if((l|0)==17){i=e;return}}function XC(a){a=a|0;var b=0,c=0;b=i;c=YC(a+8|0)|0;i=b;return c|0}function YC(a){a=a|0;var b=0,c=0;b=i;c=ZC(a)|0;i=b;return c|0}function ZC(a){a=a|0;i=i;return a|0}function _C(a){a=a|0;i=i;return(c[c[a+8>>2]>>2]|0)==(a|0)|0}function $C(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;f=e;g=c[f>>2]|0;c[d>>2]=g;kB(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=_C(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function aD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;f=e+4|0;g=c[f>>2]|0;c[d>>2]=g;kB(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=_C(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function bD(a){a=a|0;var b=0;b=i;cD(a,0);i=b;return}function cD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=RC(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}eD(dD(e)|0,f);i=d;return}function dD(a){a=a|0;var b=0,c=0;b=i;c=hD(a)|0;i=b;return c|0}function eD(a,b){a=a|0;b=b|0;var d=0;d=i;if((b|0)==0){i=d;return}EC(c[a>>2]|0,b,1);i=d;return}function fD(a){a=a|0;i=i;return a|0}function gD(a){a=a|0;i=i;return a|0}function hD(a){a=a|0;i=i;return a+4|0}function iD(a,b){a=a|0;b=b|0;var c=0;c=i;jD(a,b);i=c;return}function jD(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function kD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];uD(a,b,f);i=e;return}function lD(a,b){a=a|0;b=b|0;var c=0;a=i;c=tD(0,b,0)|0;i=a;return c|0}function mD(a,b){a=a|0;b=b|0;var c=0;c=i;sD(a,b);i=c;return}function nD(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function oD(a){a=a|0;var b=0,d=0;b=i;d=c[(TC(a)|0)>>2]|0;i=b;return d|0}function pD(a){a=a|0;var b=0,c=0;b=i;c=dD(a)|0;i=b;return c|0}function qD(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function rD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;iD(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];KC(h,f);MC(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];KC(a,e);NC(h);i=d;return}function sD(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function tD(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=$Z(b*24|0)|0;i=c;return a|0}function uD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(wD(g)|0)>>2]|0;g=xD(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];vD(b,a,f);i=e;return}function vD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];yD(a,b,f);i=e;return}function wD(a){a=a|0;i=i;return a|0}function xD(a){a=a|0;i=i;return a|0}function yD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(AD(g)|0)>>2]|0;g=BD(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];zD(b,a,f);i=e;return}function zD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(AD(f)|0)>>2];f=BD(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function AD(a){a=a|0;i=i;return a|0}function BD(a){a=a|0;i=i;return a|0}function CD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=QC(DD(b)|0)|0;h=BD(pD(DD(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];vD(g,a,e);i=d;return}function DD(a){a=a|0;i=i;return c[a>>2]|0}function ED(a){a=a|0;var b=0;b=i;i=i+48|0;FD(a);yA(a+184|0,0,0);yA(a+200|0,0,0);GD(a+240|0,b);GD(a+252|0,b+8|0);GD(a+264|0,b+16|0);GD(a+276|0,b+24|0);GD(a+288|0,b+32|0);GD(a+300|0,b+40|0);i=b;return}function FD(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+104|0;NQ(d);e=a;c[e>>2]=74700;f=d;c[f>>2]=74720;d=a+4|0;UR(a,74732|0,d);c[e>>2]=74700;c[f>>2]=74720;TD(d);i=b;return}function GD(a,b){a=a|0;b=b|0;b=i;HD(a,0);i=b;return}function HD(a,b){a=a|0;b=b|0;b=i;i=i+8|0;ID(a,b);i=b;return}function ID(a,b){a=a|0;b=b|0;b=i;JD(a,0);i=b;return}function JD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;KD(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;LD(f,0,e);e=WA(b)|0;c[(VC(b)|0)>>2]=e;i=d;return}function KD(a){a=a|0;var b=0;b=i;PD(a);i=b;return}function LD(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;MD(b,c,f);i=e;return}function MD(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(OD(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;ND(d,b,f);i=e;return}function ND(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(OD(e)|0)>>2];i=d;return}function OD(a){a=a|0;i=i;return a|0}function PD(a){a=a|0;var b=0;b=i;QD(a);i=b;return}function QD(a){a=a|0;var b=0;b=i;RD(a);i=b;return}function RD(a){a=a|0;var b=0;b=i;SD(a);i=b;return}function SD(a){a=a|0;c[a>>2]=0;i=i;return}function TD(a){a=a|0;var b=0;b=i;UD(a);i=b;return}function UD(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=d;WQ(j);c[d>>2]=74856;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;k=d+68|0;l=d+52|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;kB(f);f=d+98|0;l=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;b[l+28>>1]=0;a[l+30|0]=0;SQ(g,j);l=VD(g)|0;yW(g);if(!l){m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=ie[r&63](d,0,4096)|0;i=e;return}SQ(h,j);c[k>>2]=xC(h)|0;yW(h);a[f]=(yC(c[k>>2]|0)|0)&1;m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=ie[r&63](d,0,4096)|0;i=e;return}function VD(a){a=a|0;var b=0,c=0;b=i;c=zW(a,106640)|0;i=b;return c|0}function WD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+8|0;e=d;f=c[a+12>>2]|0;jx(3);g=f+8|0;h=g;j=c[g>>2]|0;g=f+12|0;k=c[g>>2]|0;if((j|0)<(k|0)){XD(a,b,c[f>>2]|0,h);mx(3);i=d;return}l=~~(+(k|0)*1.4+ +(k-j|0)+2.0e3);c[g>>2]=l;j=f+16|0;k=YZ(c[f>>2]|0,fa(l<<3,c[j>>2]|0)|0)|0;l=k;c[f>>2]=l;if((k|0)==0){k=c[b+536>>2]|0;c[e>>2]=fa(c[j>>2]|0,c[g>>2]|0)|0;kw(k,75128,e)}XD(a,b,l,h);mx(3);i=d;return}function XD(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;j=c[b+12>>2]|0;mx(0);k=+ex(0);jx(0);l=c[c[d+4>>2]>>2]|0;m=l;n=+h[m>>3];o=j+4|0;j=c[o>>2]|0;p=j+1|0;c[o>>2]=p;h[e+(j<<3)>>3]=n;if((c[b+8>>2]|0)==0){q=p}else{b=j+2|0;c[o>>2]=b;h[e+(p<<3)>>3]=k;q=b}b=d+116|0;p=c[b>>2]|0;if((p|0)>0){j=c[d+8>>2]|0;r=p;p=q;s=0;while(1){if((a[j+(s*112|0)+104|0]|0)==0){k=+h[(c[l+8>>2]|0)+(s<<3)>>3];t=p+1|0;c[o>>2]=t;h[e+(p<<3)>>3]=k;u=c[b>>2]|0;v=t}else{u=r;v=p}t=s+1|0;if((t|0)<(u|0)){r=u;p=v;s=t}else{w=v;break}}}else{w=q}q=d+124|0;v=c[q>>2]|0;if((v|0)>0){s=c[d+12>>2]|0;p=v;v=w;u=0;while(1){if((a[s+(u*60|0)+56|0]|0)==0){k=+(c[(c[l+12>>2]|0)+(u<<2)>>2]|0);r=v+1|0;c[o>>2]=r;h[e+(v<<3)>>3]=k;x=c[q>>2]|0;y=r}else{x=p;y=v}r=u+1|0;if((r|0)<(x|0)){p=x;v=y;u=r}else{z=y;break}}}else{z=w}w=d+128|0;y=c[w>>2]|0;if((y|0)>0){u=c[d+16>>2]|0;v=y;y=z;x=0;while(1){if((a[u+(x*48|0)+44|0]|0)==0){k=+(a[(c[l+16>>2]|0)+x|0]|0);p=y+1|0;c[o>>2]=p;h[e+(y<<3)>>3]=k;A=c[w>>2]|0;B=p}else{A=v;B=y}p=x+1|0;if((p|0)<(A|0)){v=A;y=B;x=p}else{C=B;break}}}else{C=z}z=d+216|0;if((c[z>>2]|0)>0){B=d+416|0;x=c[d+40>>2]|0;y=C;A=0;while(1){do{if((a[x+(A*52|0)+48|0]|0)==0){v=a[x+(A*52|0)+8|0]|0;do{if(v<<24>>24==2){D=m}else{w=c[x+(A*52|0)+4>>2]|0;if(v<<24>>24==1){D=(c[B>>2]|0)+(w<<3)|0;break}else{D=(c[l+8>>2]|0)+(w<<3)|0;break}}}while(0);k=+h[D>>3];if((c[x+(A*52|0)>>2]|0)==0){v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=k;E=v;break}else{v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=-k;E=v;break}}else{E=y}}while(0);v=A+1|0;if((v|0)<(c[z>>2]|0)){y=E;A=v}else{F=E;break}}}else{F=C}C=d+220|0;if((c[C>>2]|0)>0){E=d+40|0;A=d+420|0;y=c[d+44>>2]|0;z=F;x=0;while(1){do{if((a[y+(x*52|0)+48|0]|0)==0){D=c[(c[((a[y+(x*52|0)+8|0]|0)==1?A:l+12|0)>>2]|0)+(c[(c[E>>2]|0)+(x*52|0)+4>>2]<<2)>>2]|0;if((c[y+(x*52|0)>>2]|0)==0){B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(D|0);G=B;break}else{B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(0-D|0);G=B;break}}else{G=z}}while(0);B=x+1|0;if((B|0)<(c[C>>2]|0)){z=G;x=B}else{H=G;break}}}else{H=F}F=d+224|0;if((c[F>>2]|0)<=0){I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}G=d+44|0;x=d+40|0;z=d+424|0;C=c[d+48>>2]|0;d=H;H=0;while(1){do{if((a[C+(H*52|0)+48|0]|0)==0){y=a[(c[((a[(c[G>>2]|0)+(H*52|0)+8|0]|0)==1?z:l+16|0)>>2]|0)+(c[(c[x>>2]|0)+(H*52|0)+4>>2]|0)|0]|0;if((c[C+(H*52|0)>>2]|0)==0){E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24);K=E;break}else{E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24!=1|0);K=E;break}}else{K=d}}while(0);E=H+1|0;if((E|0)<(c[F>>2]|0)){d=K;H=E}else{break}}I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}function YD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=VZ(24)|0;jx(3);c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=g+16|0;c[j>>2]=0;k=a+4|0;l=c[k>>2]|0;c[g+12>>2]=l;m=b+536|0;jw(c[m>>2]|0,l>>>31^1,75184,f);f=b+8|0;b=c[a+8>>2]|0;l=ZD(b,f)|0;c[g+20>>2]=l;l=ZD(b,f)|0;c[j>>2]=l;j=c[k>>2]|0;k=VZ(fa(l<<3,j)|0)|0;c[g>>2]=k;if((k|0)==0){k=c[m>>2]|0;c[e>>2]=fa(l,j)|0;kw(k,75264,e)}else{c[h>>2]=0;c[a+12>>2]=g;mx(3);i=d;return}}function ZD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=(b|0)==0?1:2;b=c[d+108>>2]|0;if((b|0)>0){g=c[d>>2]|0;h=0;j=f;while(1){k=((a[g+(h*112|0)+104|0]|0)==0)+j|0;l=h+1|0;if((l|0)<(b|0)){j=k;h=l}else{m=k;break}}}else{m=f}f=c[d+116>>2]|0;if((f|0)>0){h=c[d+4>>2]|0;j=0;b=m;while(1){g=((a[h+(j*60|0)+56|0]|0)==0)+b|0;k=j+1|0;if((k|0)<(f|0)){b=g;j=k}else{n=g;break}}}else{n=m}m=c[d+120>>2]|0;if((m|0)>0){j=c[d+8>>2]|0;b=0;f=n;while(1){h=((a[j+(b*48|0)+44|0]|0)==0)+f|0;g=b+1|0;if((g|0)<(m|0)){f=h;b=g}else{o=h;break}}}else{o=n}n=c[d+208>>2]|0;if((n|0)>0){b=c[d+32>>2]|0;f=0;m=o;while(1){j=((a[b+(f*52|0)+48|0]|0)==0)+m|0;h=f+1|0;if((h|0)<(n|0)){m=j;f=h}else{p=j;break}}}else{p=o}o=c[d+212>>2]|0;if((o|0)>0){f=c[d+36>>2]|0;m=0;n=p;while(1){b=((a[f+(m*52|0)+48|0]|0)==0)+n|0;j=m+1|0;if((j|0)<(o|0)){n=b;m=j}else{q=b;break}}}else{q=p}p=c[d+216>>2]|0;if((p|0)<=0){r=q;i=e;return r|0}m=c[d+40>>2]|0;d=0;n=q;while(1){q=((a[m+(d*52|0)+48|0]|0)==0)+n|0;o=d+1|0;if((o|0)<(p|0)){n=q;d=o}else{r=q;break}}i=e;return r|0}function _D(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b+12|0;s=c[r>>2]|0;t=s;jx(3);u=b;v=ec(c[u>>2]|0,75328)|0;if((v|0)==0){$D(t);w=c[d+536>>2]|0;x=c[u>>2]|0;y=Sd(c[(Kc()|0)>>2]|0)|0;c[q>>2]=x;c[q+4>>2]=y;kw(w,75336,q)}nc(75392,46,1,v|0)|0;q=s+20|0;c[p>>2]=c[q>>2];sd(v|0,75440,p|0)|0;p=s+8|0;c[o>>2]=c[p>>2];sd(v|0,75464,o|0)|0;nc(75488,40,1,v|0)|0;nc(75536,11,1,v|0)|0;nc(75552,14,1,v|0)|0;if((c[p>>2]|0)>0){o=0;do{w=fa(c[q>>2]|0,o)|0;z=+h[(c[s>>2]|0)+(w<<3)>>3];aE(v,z,z);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Od(10,v|0)|0;if((c[b+8>>2]|0)==0){A=1}else{nc(75568,18,1,v|0)|0;if((c[p>>2]|0)>0){b=0;do{o=fa(c[q>>2]|0,b)|0;w=c[s>>2]|0;aE(v,+h[w+(o<<3)>>3],+h[w+(o+1<<3)>>3]);b=b+1|0;}while((b|0)<(c[p>>2]|0))}Od(10,v|0)|0;A=2}b=d+116|0;o=c[b>>2]|0;if((o|0)>0){w=d+8|0;y=o;o=0;x=A;while(1){B=c[w>>2]|0;if((a[B+(o*112|0)+104|0]|0)==0){c[n>>2]=c[B+(o*112|0)+4>>2];sd(v|0,75592,n|0)|0;if((c[p>>2]|0)>0){B=0;do{C=fa(c[q>>2]|0,B)|0;D=c[s>>2]|0;aE(v,+h[D+(C<<3)>>3],+h[D+(C+x<<3)>>3]);B=B+1|0;}while((B|0)<(c[p>>2]|0))}Od(10,v|0)|0;E=c[b>>2]|0;F=x+1|0}else{E=y;F=x}B=o+1|0;if((B|0)<(E|0)){y=E;o=B;x=F}else{G=F;break}}}else{G=A}A=d+124|0;F=c[A>>2]|0;if((F|0)>0){x=d+12|0;o=F;F=0;E=G;while(1){y=c[x>>2]|0;if((a[y+(F*60|0)+56|0]|0)==0){c[m>>2]=c[y+(F*60|0)+4>>2];sd(v|0,75592,m|0)|0;if((c[p>>2]|0)>0){y=0;do{b=fa(c[q>>2]|0,y)|0;n=c[s>>2]|0;aE(v,+h[n+(b<<3)>>3],+h[n+(b+E<<3)>>3]);y=y+1|0;}while((y|0)<(c[p>>2]|0))}Od(10,v|0)|0;H=c[A>>2]|0;I=E+1|0}else{H=o;I=E}y=F+1|0;if((y|0)<(H|0)){o=H;F=y;E=I}else{J=I;break}}}else{J=G}G=d+128|0;I=c[G>>2]|0;if((I|0)>0){E=d+16|0;F=I;I=0;H=J;while(1){o=c[E>>2]|0;if((a[o+(I*48|0)+44|0]|0)==0){c[l>>2]=c[o+(I*48|0)+4>>2];sd(v|0,75592,l|0)|0;if((c[p>>2]|0)>0){o=0;do{A=fa(c[q>>2]|0,o)|0;m=c[s>>2]|0;aE(v,+h[m+(A<<3)>>3],+h[m+(A+H<<3)>>3]);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Od(10,v|0)|0;K=c[G>>2]|0;L=H+1|0}else{K=F;L=H}o=I+1|0;if((o|0)<(K|0)){F=K;I=o;H=L}else{M=L;break}}}else{M=J}J=d+216|0;L=c[J>>2]|0;if((L|0)>0){H=d+40|0;I=L;L=0;K=M;while(1){F=c[H>>2]|0;if((a[F+(L*52|0)+48|0]|0)==0){c[k>>2]=c[F+(L*52|0)+16>>2];sd(v|0,75592,k|0)|0;if((c[p>>2]|0)>0){F=0;do{G=fa(c[q>>2]|0,F)|0;l=c[s>>2]|0;aE(v,+h[l+(G<<3)>>3],+h[l+(G+K<<3)>>3]);F=F+1|0;}while((F|0)<(c[p>>2]|0))}Od(10,v|0)|0;N=c[J>>2]|0;O=K+1|0}else{N=I;O=K}F=L+1|0;if((F|0)<(N|0)){I=N;L=F;K=O}else{P=O;break}}}else{P=M}M=d+220|0;O=c[M>>2]|0;if((O|0)>0){K=d+44|0;L=O;O=0;N=P;while(1){I=c[K>>2]|0;if((a[I+(O*52|0)+48|0]|0)==0){c[j>>2]=c[I+(O*52|0)+16>>2];sd(v|0,75592,j|0)|0;if((c[p>>2]|0)>0){I=0;do{J=fa(c[q>>2]|0,I)|0;k=c[s>>2]|0;aE(v,+h[k+(J<<3)>>3],+h[k+(J+N<<3)>>3]);I=I+1|0;}while((I|0)<(c[p>>2]|0))}Od(10,v|0)|0;Q=c[M>>2]|0;R=N+1|0}else{Q=L;R=N}I=O+1|0;if((I|0)<(Q|0)){L=Q;O=I;N=R}else{S=R;break}}}else{S=P}P=d+224|0;R=c[P>>2]|0;if((R|0)>0){N=d+48|0;O=R;R=0;Q=S;while(1){S=c[N>>2]|0;if((a[S+(R*52|0)+48|0]|0)==0){c[g>>2]=c[S+(R*52|0)+16>>2];sd(v|0,75592,g|0)|0;if((c[p>>2]|0)>0){S=0;do{L=fa(c[q>>2]|0,S)|0;M=c[s>>2]|0;aE(v,+h[M+(L<<3)>>3],+h[M+(L+Q<<3)>>3]);S=S+1|0;}while((S|0)<(c[p>>2]|0))}Od(10,v|0)|0;T=c[P>>2]|0;U=Q+1|0}else{T=O;U=Q}S=R+1|0;if((S|0)<(T|0)){O=T;R=S;Q=U}else{break}}}$D(t);if((Vc(v|0)|0)==0){WZ(c[r>>2]|0);c[r>>2]=0;mx(3);i=e;return}else{e=c[d+536>>2]|0;c[f>>2]=c[u>>2];kw(e,75608,f)}}function $D(a){a=a|0;var b=0,d=0;b=i;d=a;a=c[d>>2]|0;if((a|0)==0){i=b;return}WZ(a);c[d>>2]=0;i=b;return}function aE(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=f;h[k>>3]=b;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];sd(a|0,75656,f|0)|0;i=e;return}function bE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=$Z(192)|0;B_(m|0,0,192)|0;cE(m);c[a+12>>2]=m;n=m;o=a;zA(n,c[o>>2]|0,36);if(BQ(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){a=c[b+536>>2]|0;c[g>>2]=c[o>>2];kw(a,75696,g)}else{g=m;eS(g,75672,14)|0;fS(h,g);a=MB(h)|0;h=m+184|0;c[h>>2]=a;eS(g,75688,4)|0;dE(n,b+8|0);fS(j,g);b=MB(j)|0;j=m+188|0;c[j>>2]=b;m=c[h>>2]|0;yA(k,m,((m|0)<0)<<31>>31);h=f;a=k;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];gS(g,f)|0;eE(n,-4-m+b|0);b=c[j>>2]|0;yA(l,b,((b|0)<0)<<31>>31);b=e;j=l;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];gS(g,e)|0;mx(3);i=d;return}}function cE(a){a=a|0;var b=0;b=i;xE(a);i=b;return}function dE(a,b){a=a|0;b=b|0;var c=0;c=i;gE(a,3);hE(a,75872);gE(a,0);hE(a,75880);gE(a,2);sE(a,b);tE(a,b);hE(a,75888);gE(a,0);i=c;return}function eE(a,b){a=a|0;b=b|0;var d=0;d=i;c[18966]=Dd(b|0)|0;eS(a,75864,4)|0;i=d;return}function fE(b,d,e,f){b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=b;fS(l,q);r=MB(l)|0;eE(b,0);fS(m,q);l=MB(m)|0;gE(b,1);hE(b,75760);m=e+128|0;s=e+132|0;t=e+136|0;u=e+140|0;iE(b,(c[m>>2]|0)+1+(c[s>>2]|0)+(c[t>>2]|0)+(c[u>>2]|0)|0);jE(b,d);if((c[m>>2]|0)>0){e=f+176|0;v=0;do{jE(b,+h[(c[e>>2]|0)+(v<<3)>>3]);v=v+1|0;}while((v|0)<(c[m>>2]|0))}if((c[s>>2]|0)>0){m=f+180|0;v=0;do{kE(b,c[(c[m>>2]|0)+(v<<2)>>2]|0);v=v+1|0;}while((v|0)<(c[s>>2]|0))}if((c[t>>2]|0)>0){s=f+184|0;v=0;do{lE(b,(a[(c[s>>2]|0)+v|0]|0)!=0);v=v+1|0;}while((v|0)<(c[t>>2]|0))}if((c[u>>2]|0)>0){t=f+188|0;f=0;do{hE(b,c[(c[t>>2]|0)+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(c[u>>2]|0))}fS(n,q);u=MB(n)|0;n=y_(0,r|0,32)|0;yA(o,n,J);n=k;r=o;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];gS(q,k)|0;eE(b,u-l|0);yA(p,u,((u|0)<0)<<31>>31);u=j;l=p;c[u+0>>2]=c[l+0>>2];c[u+4>>2]=c[l+4>>2];c[u+8>>2]=c[l+8>>2];c[u+12>>2]=c[l+12>>2];gS(q,j)|0;i=g;return}function gE(b,d){b=b|0;d=d|0;var e=0;e=i;a[75848]=-33;c[18964]=Dd(d|0)|0;d=b;eS(d,75848,1)|0;eS(d,75856,4)|0;i=e;return}function hE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;c[f>>2]=Dd(x_(d|0)|0)|0;a[75840]=-37;g=b;eS(g,75840,1)|0;eS(g,f,4)|0;eS(g,d,x_(d|0)|0)|0;i=e;return}function iE(b,d){b=b|0;d=d|0;var e=0;e=i;a[75824]=-35;c[18958]=Dd(d|0)|0;d=b;eS(d,75824,1)|0;eS(d,75832,4)|0;i=e;return}function jE(b,c){b=b|0;c=+c;var d=0,e=0;d=i;a[75808]=-53;rE(c);e=b;eS(e,75808,1)|0;eS(e,75816,8)|0;i=d;return}function kE(b,d){b=b|0;d=d|0;var e=0;e=i;a[75792]=-46;c[18950]=Dd(d|0)|0;d=b;eS(d,75792,1)|0;eS(d,75800,4)|0;i=e;return}function lE(b,c){b=b|0;c=c|0;var d=0;d=i;a[75784]=c?-61:-62;eS(b,75784,1)|0;i=d;return}function mE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+12>>2]|0;a=b+8|0;f=b+240|0;fE(e,+h[f>>3],a,f);fE(e,+h[b+248>>3],a,f);i=d;return}function nE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=c[b+12>>2]|0;b=o;p=o;fS(j,p);o=MB(j)|0;eE(b,0);fS(k,p);j=MB(k)|0;gE(b,1);hE(b,75768);k=d+116|0;q=d+124|0;r=d+128|0;s=d+132|0;iE(b,(c[k>>2]|0)+1+(c[q>>2]|0)+(c[r>>2]|0)+(c[s>>2]|0)|0);t=d+4|0;jE(b,+h[c[c[t>>2]>>2]>>3]);if((c[k>>2]|0)>0){d=0;do{jE(b,+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+(d<<3)>>3]);d=d+1|0;}while((d|0)<(c[k>>2]|0))}if((c[q>>2]|0)>0){k=0;do{kE(b,c[(c[(c[c[t>>2]>>2]|0)+12>>2]|0)+(k<<2)>>2]|0);k=k+1|0;}while((k|0)<(c[q>>2]|0))}if((c[r>>2]|0)>0){q=0;do{lE(b,(a[(c[(c[c[t>>2]>>2]|0)+16>>2]|0)+q|0]|0)!=0);q=q+1|0;}while((q|0)<(c[r>>2]|0))}if((c[s>>2]|0)>0){r=0;do{hE(b,c[(c[(c[c[t>>2]>>2]|0)+20>>2]|0)+(r<<2)>>2]|0);r=r+1|0;}while((r|0)<(c[s>>2]|0))}fS(l,p);s=MB(l)|0;l=y_(0,o|0,32)|0;yA(m,l,J);l=g;o=m;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];gS(p,g)|0;eE(b,s-j|0);yA(n,s,((s|0)<0)<<31>>31);s=f;j=n;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];gS(p,f)|0;i=e;return}function oE(a,b){a=a|0;b=b|0;var d=0;b=i;d=a+12|0;a=c[d>>2]|0;sA(a);jx(3);if((a|0)!=0){pE(a);b_(a)}c[d>>2]=0;mx(3);i=b;return}function pE(a){a=a|0;var b=0;b=i;qE(a);i=b;return}function qE(a){a=a|0;var b=0;b=i;PB(a);i=b;return}function rE(b){b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=d;h[e>>3]=b;if((Dd(1)|0)==1){f=e;g=c[f+4>>2]|0;j=75816;c[j>>2]=c[f>>2];c[j+4>>2]=g;i=d;return}h[k>>3]=b;g=c[k>>2]&255;j=0;while(1){a[75816+(7-j)|0]=g;f=j+1|0;if((f|0)>=8){break}g=a[e+f|0]|0;j=f}i=d;return}function sE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;hE(a,75760);gE(a,4);hE(a,75896);gE(a,0);hE(a,75904);f=b+128|0;g=b+132|0;h=b+136|0;j=b+140|0;iE(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);hE(a,75912);if((c[f>>2]|0)>0){k=b+16|0;l=0;do{hE(a,c[(c[k>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){l=b+20|0;k=0;do{hE(a,c[(c[l>>2]|0)+(k*60|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){k=b+24|0;l=0;do{hE(a,c[(c[k>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)>0){l=b+28|0;k=0;do{hE(a,c[(c[l>>2]|0)+(k*52|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[j>>2]|0))}k=e;l=76e3;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];uE(a,b,e);hE(a,75936);gE(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);vE(a,75912,75944);if((c[f>>2]|0)>0){e=b+16|0;l=0;do{k=c[e>>2]|0;vE(a,c[k+(l*112|0)+4>>2]|0,c[k+(l*112|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=b+20|0;l=0;do{e=c[f>>2]|0;vE(a,c[e+(l*60|0)+4>>2]|0,c[e+(l*60|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){g=b+24|0;l=0;do{f=c[g>>2]|0;vE(a,c[f+(l*48|0)+4>>2]|0,c[f+(l*48|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)<=0){i=d;return}h=b+28|0;b=0;do{l=c[h>>2]|0;vE(a,c[l+(b*52|0)+4>>2]|0,c[l+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[j>>2]|0));i=d;return}function tE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=b+108|0;g=c[f>>2]|0;h=b+116|0;j=c[h>>2]|0;k=b+120|0;l=c[k>>2]|0;m=b+124|0;n=c[m>>2]|0;hE(a,75768);gE(a,4);hE(a,75896);gE(a,0);hE(a,75904);o=g+1+j+l+n|0;iE(a,o);hE(a,75912);if((c[f>>2]|0)>0){n=b;l=0;do{hE(a,c[(c[n>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){l=b+4|0;n=0;do{hE(a,c[(c[l>>2]|0)+(n*60|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){n=b+8|0;l=0;do{hE(a,c[(c[n>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[k>>2]|0))}if((c[m>>2]|0)>0){l=b+12|0;n=0;do{hE(a,c[(c[l>>2]|0)+(n*52|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[m>>2]|0))}n=e;l=75920;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];uE(a,b,e);hE(a,75936);gE(a,o);vE(a,75912,75944);if((c[f>>2]|0)>0){o=b;e=0;do{l=c[o>>2]|0;vE(a,c[l+(e*112|0)+4>>2]|0,c[l+(e*112|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){f=b+4|0;e=0;do{o=c[f>>2]|0;vE(a,c[o+(e*60|0)+4>>2]|0,c[o+(e*60|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){h=b+8|0;e=0;do{f=c[h>>2]|0;vE(a,c[f+(e*48|0)+4>>2]|0,c[f+(e*48|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[k>>2]|0))}if((c[m>>2]|0)<=0){i=d;return}k=b+12|0;b=0;do{e=c[k>>2]|0;vE(a,c[e+(b*52|0)+4>>2]|0,c[e+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[m>>2]|0));i=d;return}function uE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;hE(b,75968);g=d+208|0;h=c[g>>2]|0;if((h|0)>0){j=c[d+32>>2]|0;k=0;l=0;while(1){m=(c[e+(a[j+(k*52|0)+8|0]<<2)>>2]|0)+l|0;n=k+1|0;if((n|0)<(h|0)){l=m;k=n}else{o=m;break}}}else{o=0}k=d+212|0;l=c[k>>2]|0;if((l|0)>0){h=c[d+36>>2]|0;j=0;m=o;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{q=n;break}}}else{q=o}o=d+216|0;j=c[o>>2]|0;if((j|0)>0){m=c[d+40>>2]|0;l=0;h=q;while(1){n=(c[e+(a[m+(l*52|0)+8|0]<<2)>>2]|0)+h|0;p=l+1|0;if((p|0)<(j|0)){h=n;l=p}else{r=n;break}}}else{r=q}q=d+220|0;l=c[q>>2]|0;if((l|0)>0){h=c[d+44>>2]|0;j=0;m=r;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{s=n;break}}}else{s=r}gE(b,s);s=c[g>>2]|0;if((s|0)>0){r=d+32|0;j=d+16|0;m=d;l=s;s=0;h=0;while(1){n=c[r>>2]|0;p=a[n+(s*52|0)+8|0]|0;if((c[e+(p<<24>>24<<2)>>2]|0)==0){t=l;u=h}else{v=p<<24>>24==2?75912:h;if(p<<24>>24==0){w=c[(c[m>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else if(p<<24>>24==1){w=c[(c[j>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else{w=v}wE(b,c[n+(s*52|0)+16>>2]|0,w,(c[n+(s*52|0)>>2]|0)!=0);t=c[g>>2]|0;u=w}n=s+1|0;if((n|0)<(t|0)){l=t;s=n;h=u}else{x=u;break}}}else{x=0}u=c[k>>2]|0;if((u|0)>0){h=d+36|0;s=d+20|0;t=d+4|0;l=u;u=0;w=x;while(1){g=c[h>>2]|0;j=a[g+(u*52|0)+8|0]|0;if((c[e+(j<<24>>24<<2)>>2]|0)==0){y=l;z=w}else{m=j<<24>>24==2?75912:w;if(j<<24>>24==1){A=c[(c[s>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else if(j<<24>>24==0){A=c[(c[t>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else{A=m}wE(b,c[g+(u*52|0)+16>>2]|0,A,(c[g+(u*52|0)>>2]|0)!=0);y=c[k>>2]|0;z=A}g=u+1|0;if((g|0)<(y|0)){l=y;u=g;w=z}else{B=z;break}}}else{B=x}x=c[o>>2]|0;if((x|0)>0){z=d+40|0;w=d+24|0;u=d+8|0;y=x;x=0;l=B;while(1){A=c[z>>2]|0;k=a[A+(x*52|0)+8|0]|0;if((c[e+(k<<24>>24<<2)>>2]|0)==0){C=y;D=l}else{t=k<<24>>24==2?75912:l;if(k<<24>>24==0){E=c[(c[u>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else if(k<<24>>24==1){E=c[(c[w>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else{E=t}wE(b,c[A+(x*52|0)+16>>2]|0,E,(c[A+(x*52|0)>>2]|0)!=0);C=c[o>>2]|0;D=E}A=x+1|0;if((A|0)<(C|0)){y=C;x=A;l=D}else{F=D;break}}}else{F=B}B=c[q>>2]|0;if((B|0)<=0){i=f;return}D=d+44|0;l=d+28|0;x=d+12|0;d=B;B=0;C=F;while(1){F=c[D>>2]|0;y=a[F+(B*52|0)+8|0]|0;if((c[e+(y<<24>>24<<2)>>2]|0)==0){G=d;H=C}else{E=y<<24>>24==2?75912:C;if(y<<24>>24==0){I=c[(c[x>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else if(y<<24>>24==1){I=c[(c[l>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else{I=E}wE(b,c[F+(B*52|0)+16>>2]|0,I,(c[F+(B*52|0)>>2]|0)!=0);G=c[q>>2]|0;H=I}F=B+1|0;if((F|0)<(G|0)){d=G;B=F;C=H}else{break}}i=f;return}function vE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;hE(a,b);gE(a,1);hE(a,75952);hE(a,c);i=d;return}function wE(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;hE(a,b);gE(a,d?2:1);hE(a,75976);hE(a,c);if(!d){i=e;return}hE(a,75984);hE(a,75992);i=e;return}function xE(a){a=a|0;var b=0;b=i;FD(a);i=b;return}function yE(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=i;i=i+288|0;d=c;e=c+16|0;f=c+32|0;g=c+48|0;h=c+64|0;j=c+80|0;k=c+96|0;l=c+112|0;m=c+128|0;n=c+144|0;o=c+160|0;p=c+176|0;q=c+192|0;r=c+208|0;s=c+224|0;t=c+240|0;u=c+256|0;v=c+272|0;KP(e,76016);GP(d,AE(a,e)|0);zE(d,b+4|0);QP(d);QP(e);KP(g,76024);GP(f,AE(a,g)|0);BE(f,b);QP(f);QP(g);KP(j,76040);GP(h,AE(a,j)|0);zE(h,b+8|0);QP(h);QP(j);KP(l,76056);GP(k,AE(a,l)|0);zE(k,b+12|0);QP(k);QP(l);KP(n,76072);GP(m,AE(a,n)|0);CE(m,b+16|0,0);QP(m);QP(n);KP(p,76088);GP(o,AE(a,p)|0);CE(o,b+20|0,0);QP(o);QP(p);KP(r,76104);GP(q,AE(a,r)|0);CE(q,b+24|0,0);QP(q);QP(r);KP(t,76112);GP(s,AE(a,t)|0);CE(s,b+28|0,0);QP(s);QP(t);KP(v,76128);GP(u,AE(a,v)|0);CE(u,b+32|0,0);QP(u);QP(v);i=c;return}function zE(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;if((b|0)==0){iw(22,0,79336,d);i=d;return}else{c[b>>2]=wd(lQ(a)|0)|0;i=d;return}}function AE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=JI(a,f,b)|0;l=c[k>>2]|0;kB(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}LI(j,a,b);MI(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];KI(g,e);NI(j);j=c[f>>2]|0;OI(a,j,k,PI(g)|0);k=QI(g)|0;NI(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function BE(a,b){a=a|0;b=b|0;var d=0;d=i;if((oQ(a,76304)|0)==0){c[b>>2]=1;i=d;return}if((oQ(a,76312)|0)==0){c[b>>2]=0;i=d;return}else{c[b>>2]=Bc(lQ(a)|0)|0;i=d;return}}function CE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((oQ(a,76280)|0)==0){c[b>>2]=d}if((oQ(a,76304)|0)==0){c[b>>2]=1;i=e;return}if((oQ(a,76312)|0)==0){c[b>>2]=0;i=e;return}else{c[b>>2]=Bc(lQ(a)|0)|0;i=e;return}}function DE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;e=i;i=i+56|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;KP(j,76144);GP(g,AE(b,j)|0);y=d+48|0;EE(g,y);QP(g);QP(j);KP(m,76160);GP(l,AE(b,m)|0);j=d+56|0;FE(l,j,0.0);QP(l);QP(m);KP(o,76168);GP(n,AE(b,o)|0);m=d+32|0;EE(n,m);QP(n);QP(o);KP(q,76176);GP(p,AE(b,q)|0);o=d+33|0;EE(p,o);QP(p);QP(q);KP(s,76192);GP(r,AE(b,s)|0);q=d+40|0;FE(r,q,1.0);QP(r);QP(s);KP(u,76200);GP(t,AE(b,u)|0);s=d+16|0;FE(t,s,-1.7976931348623157e+308);QP(t);QP(u);KP(w,76208);GP(v,AE(b,w)|0);u=d+24|0;FE(v,u,1.7976931348623157e+308);QP(v);QP(w);KP(x,76016);w=lQ(AE(b,x)|0)|0;b=(a[y]|0)!=0;z=+h[j>>3];j=(a[m]|0)!=0?76304:76312;m=(a[o]|0)!=0;A=+h[q>>3];B=+h[s>>3];C=+h[u>>3];c[f>>2]=w;c[f+4>>2]=b?76280:76288;w=f+8|0;h[k>>3]=z;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[f+16>>2]=b?76280:76296;c[f+20>>2]=j;c[f+24>>2]=m?76280:76288;j=f+28|0;h[k>>3]=A;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[f+36>>2]=m?76280:76296;m=f+40|0;h[k>>3]=B;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=f+48|0;h[k>>3]=C;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];gw(4,0,76216,f);QP(x);i=e;return}function EE(b,c){b=b|0;c=c|0;var d=0;d=i;a[c]=(oQ(b,76304)|0)==0|0;i=d;return}function FE(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;if((oQ(a,76280)|0)==0){h[b>>3]=c;i=d;return}if((oQ(a,76304)|0)==0){h[b>>3]=1.0;i=d;return}if((oQ(a,76312)|0)==0){h[b>>3]=0.0;i=d;return}else{h[b>>3]=+p_(lQ(a)|0);i=d;return}}function GE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;KP(h,76144);GP(g,AE(b,h)|0);s=d+13|0;EE(g,s);QP(g);QP(h);KP(k,76160);GP(j,AE(b,k)|0);h=d+16|0;CE(j,h,0);QP(j);QP(k);KP(m,76168);GP(l,AE(b,m)|0);k=d+12|0;EE(l,k);QP(l);QP(m);KP(o,76200);GP(n,AE(b,o)|0);m=d+4|0;CE(n,m,-2147483648);QP(n);QP(o);KP(q,76208);GP(p,AE(b,q)|0);o=d+8|0;CE(p,o,2147483647);QP(p);QP(q);KP(r,76016);q=lQ(AE(b,r)|0)|0;b=(a[s]|0)!=0;s=c[h>>2]|0;h=(a[k]|0)!=0?76304:76312;k=c[m>>2]|0;m=c[o>>2]|0;c[f>>2]=q;c[f+4>>2]=b?76280:76288;c[f+8>>2]=s;c[f+12>>2]=b?76280:76296;c[f+16>>2]=h;c[f+20>>2]=k;c[f+24>>2]=m;gw(4,0,76320,f);QP(r);i=e;return}function HE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;KP(h,76144);GP(g,AE(b,h)|0);o=d+5|0;EE(g,o);QP(g);QP(h);KP(k,76160);GP(j,AE(b,k)|0);h=d+6|0;EE(j,h);QP(j);QP(k);KP(m,76168);GP(l,AE(b,m)|0);k=d+4|0;EE(l,k);QP(l);QP(m);KP(n,76016);m=lQ(AE(b,n)|0)|0;b=(a[o]|0)!=0;o=(a[h]|0)!=0?76304:76312;h=(a[k]|0)!=0?76304:76312;c[f>>2]=m;c[f+4>>2]=b?76280:76288;c[f+8>>2]=o;c[f+12>>2]=b?76280:76296;c[f+16>>2]=h;gw(4,0,76376,f);QP(n);i=e;return}function IE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;KP(h,76144);GP(g,AE(b,h)|0);m=d+4|0;EE(g,m);QP(g);QP(h);KP(k,76160);GP(j,AE(b,k)|0);h=d+8|0;zE(j,h);QP(j);QP(k);KP(l,76016);k=lQ(AE(b,l)|0)|0;b=(a[m]|0)!=0;m=c[h>>2]|0;c[f>>2]=k;c[f+4>>2]=b?76280:76288;c[f+8>>2]=m;c[f+12>>2]=b?76280:76296;gw(4,0,76416,f);QP(l);i=e;return}function JE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Wc=0,Xc=0,Yc=0,Zc=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+200|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+16|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+1024|0;Ba=i;i=i+8|0;Ca=i;i=i+16|0;Da=i;i=i+8|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;sb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+8|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+8|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+8|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+8|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;dc=i;i=i+16|0;fc=i;i=i+8|0;gc=i;i=i+16|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+8|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+8|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+8|0;sc=i;i=i+16|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+8|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+8|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+8|0;Ec=i;i=i+16|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+8|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+8|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+8|0;Qc=i;i=i+16|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Wc=qa;KE(qa);EP(ra);LE(sa,ta);LE(ua,va);va=b+92|0;do{if((c[va>>2]|0)==0){if((c[89352>>2]|0)==0){KP(za,c[b+80>>2]|0);ME(ya,za,76440);RP(ra,ya)|0;QP(ya);QP(za)}else{SP(ra,c[89480>>2]|0)|0}ta=ec(lQ(ra)|0,76456)|0;if((ta|0)!=0){Xc=ta;break}c[pa>>2]=lQ(ra)|0;kw(0,76464,pa)}else{Xc=0}}while(0);pa=hr(0)|0;if((pa|0)==0){Vc(Xc|0)|0;kw(0,76568,oa)}sr(pa,Wc);tr(pa,7,92);Wc=c[va>>2]|0;do{if((Wc|0)==0){oa=Aa;B_(oa|0,0,1024)|0;while(1){za=pb(oa|0,1,1024,Xc|0)|0;ya=za>>>0<1024;if((ur(pa,oa,za,ya&1)|0)==0){Yc=12;break}if(ya){Yc=14;break}}if((Yc|0)==12){Vc(Xc|0)|0;oa=lQ(ra)|0;ya=Cr(zr(pa)|0)|0;za=Ar(pa)|0;c[na>>2]=oa;c[na+4>>2]=ya;c[na+8>>2]=za;iw(1,0,76648,na);or(pa);kw(0,76736,ma)}else if((Yc|0)==14){Vc(Xc|0)|0;break}}else{if((ur(pa,Wc,x_(Wc|0)|0,1)|0)!=0){break}za=c[r>>2]|0;ya=c[va>>2]|0;oa=Cr(zr(pa)|0)|0;ta=Ar(pa)|0;c[la>>2]=ya;c[la+4>>2]=oa;c[la+8>>2]=ta;sd(za|0,76760,la|0)|0;za=c[va>>2]|0;ta=Cr(zr(pa)|0)|0;oa=Ar(pa)|0;c[ka>>2]=za;c[ka+4>>2]=ta;c[ka+8>>2]=oa;iw(1,0,76776,ka);or(pa);kw(0,76736,ja)}}while(0);ja=qa;KP(Ca,76864);QE(Ba,ja,Ca);RE(Da,ja);ka=PE(Ba,Da)|0;QP(Ca);Ca=b+88|0;Da=c[Ca>>2]|0;do{if(ka){Ba=lQ(ra)|0;c[ia>>2]=Da;c[ia+4>>2]=Ba;iw(1,0,76872,ia)}else{KP(Ea,76864);Ba=t_(Da,lQ(AE(ja,Ea)|0)|0)|0;QP(Ea);if((Ba|0)==0){break}or(pa);KP(Fa,76864);Ba=lQ(AE(ja,Fa)|0)|0;va=lQ(ra)|0;la=c[Ca>>2]|0;c[ha>>2]=Ba;c[ha+4>>2]=va;c[ha+8>>2]=la;iw(1,0,76920,ha);QP(Fa);kw(0,76736,ga)}}while(0);SE(qa,b,c[89564>>2]|0,c[89568>>2]|0);gw(23,1,77016,fa);fa=qa+12|0;KP(Ha,77056);GP(Ga,AE(fa,Ha)|0);ga=d;FE(Ga,ga,0.0);QP(Ga);QP(Ha);Ha=ea;h[k>>3]=+h[ga>>3];c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];gw(23,0,77072,ea);KP(Ja,77088);GP(Ia,AE(fa,Ja)|0);ea=d+8|0;FE(Ia,ea,1.0);QP(Ia);QP(Ja);Ja=da;h[k>>3]=+h[ea>>3];c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];gw(23,0,77104,da);KP(La,77120);GP(Ka,AE(fa,La)|0);da=d+24|0;FE(Ka,da,(+h[ea>>3]- +h[ga>>3])/500.0);QP(Ka);QP(La);La=ca;h[k>>3]=+h[da>>3];c[La>>2]=c[k>>2];c[La+4>>2]=c[k+4>>2];gw(23,0,77136,ca);KP(Na,77152);GP(Ma,AE(fa,Na)|0);ca=d+32|0;FE(Ma,ca,1.0e-5);QP(Ma);QP(Na);Na=ba;h[k>>3]=+h[ca>>3];c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];gw(23,0,77168,ba);KP(Pa,77184);GP(Oa,AE(fa,Pa)|0);ba=d+40|0;zE(Oa,ba);QP(Oa);QP(Pa);c[aa>>2]=c[ba>>2];gw(23,0,77192,aa);KP(Ra,77216);GP(Qa,AE(fa,Ra)|0);aa=d+44|0;zE(Qa,aa);QP(Qa);QP(Ra);c[$>>2]=c[aa>>2];gw(23,0,77232,$);KP(Ta,77256);GP(Sa,AE(fa,Ta)|0);fa=d+48|0;zE(Sa,fa);QP(Sa);QP(Ta);c[_>>2]=c[fa>>2];gw(23,0,77272,_);KP(Va,77296);GP(Ua,AE(ja,Va)|0);_=d+268|0;zE(Ua,_);QP(Ua);QP(Va);c[Z>>2]=c[_>>2];gw(23,0,77320,Z);if((c[35676>>2]|0)!=0){be[c[9034]&255](23)}KP(eb,77344);GP(db,AE(ja,eb)|0);CE(db,Wa,0);QP(db);QP(eb);KP(gb,77376);GP(fb,AE(ja,gb)|0);CE(fb,Xa,0);QP(fb);QP(gb);KP(ib,77408);GP(hb,AE(ja,ib)|0);CE(hb,Ya,0);QP(hb);QP(ib);KP(kb,77432);GP(jb,AE(ja,kb)|0);CE(jb,_a,0);QP(jb);QP(kb);KP(mb,77464);GP(lb,AE(ja,mb)|0);CE(lb,Za,0);QP(lb);QP(mb);KP(ob,77504);GP(nb,AE(ja,ob)|0);CE(nb,ab,0);QP(nb);QP(ob);KP(rb,77536);GP(qb,AE(ja,rb)|0);CE(qb,$a,0);QP(qb);QP(rb);KP(tb,77576);GP(sb,AE(ja,tb)|0);CE(sb,cb,0);QP(sb);QP(tb);KP(vb,77608);GP(ub,AE(ja,vb)|0);CE(ub,bb,0);QP(ub);QP(vb);vb=c[Wa>>2]|0;Wa=b+104|0;do{if((vb|0)==(c[Wa>>2]|0)){ub=b+108|0;if((c[Xa>>2]|0)!=((c[ub>>2]|0)-(vb<<1)|0)){break}ja=b+128|0;if((c[Ya>>2]|0)!=(c[ja>>2]|0)){break}tb=b+132|0;if((c[_a>>2]|0)!=(c[tb>>2]|0)){break}sb=b+116|0;if((c[Za>>2]|0)!=(c[sb>>2]|0)){break}rb=b+136|0;if((c[ab>>2]|0)!=(c[rb>>2]|0)){break}qb=b+120|0;if((c[$a>>2]|0)!=(c[qb>>2]|0)){break}ob=b+140|0;if((c[cb>>2]|0)!=(c[ob>>2]|0)){break}nb=b+124|0;if((c[bb>>2]|0)!=(c[nb>>2]|0)){break}c[O>>2]=78152;gw(4,1,78128,O);if((c[Wa>>2]|0)>0){mb=b;lb=qa+24|0;kb=0;do{jb=c[mb>>2]|0;c[wb>>2]=kb;ib=TE(lb,wb)|0;yE(ib,jb+(kb*112|0)|0);DE(ib,jb+(kb*112|0)+40|0);hb=jb+(kb*112|0)+4|0;do{if((a[c[hb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}else{if((c[89348>>2]|0)!=0){break}KP(xb,78168);jb=(oQ(AE(ib,xb)|0,76304)|0)==0;QP(xb);if(!jb){break}c[N>>2]=c[hb>>2];gw(4,0,78184,N);a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}}while(0);KP(yb,c[hb>>2]|0);c[(UE(sa,yb)|0)>>2]=kb;QP(yb);kb=kb+1|0;}while((kb|0)<(c[Wa>>2]|0))}if((c[35600>>2]|0)!=0){be[c[9034]&255](4)}c[M>>2]=78216;gw(4,1,78128,M);kb=c[Wa>>2]|0;if((kb|0)>0){mb=b;lb=qa+36|0;ib=kb;kb=0;do{jb=ib+kb|0;gb=c[mb>>2]|0;c[zb>>2]=kb;fb=TE(lb,zb)|0;yE(fb,gb+(jb*112|0)|0);DE(fb,gb+(jb*112|0)+40|0);eb=gb+(jb*112|0)+4|0;do{if((a[c[eb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}else{if((c[89348>>2]|0)!=0){break}KP(Ab,78168);gb=(oQ(AE(fb,Ab)|0,76304)|0)==0;QP(Ab);if(!gb){break}c[L>>2]=c[eb>>2];gw(4,0,78184,L);a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}}while(0);KP(Bb,c[eb>>2]|0);c[(UE(sa,Bb)|0)>>2]=jb;QP(Bb);kb=kb+1|0;ib=c[Wa>>2]|0;}while((kb|0)<(ib|0))}if((c[35600>>2]|0)!=0){be[c[9034]&255](4)}c[K>>2]=78240;gw(4,1,78128,K);ib=c[Wa>>2]<<1;if(((c[ub>>2]|0)-ib|0)>0){kb=b;mb=qa+48|0;lb=ib;ib=0;do{fb=lb+ib|0;hb=c[kb>>2]|0;c[Cb>>2]=ib;gb=TE(mb,Cb)|0;yE(gb,hb+(fb*112|0)|0);DE(gb,hb+(fb*112|0)+40|0);db=hb+(fb*112|0)+4|0;do{if((a[c[db>>2]|0]|0)==36){a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}else{if((c[89348>>2]|0)!=0){break}KP(Db,78168);hb=(oQ(AE(gb,Db)|0,76304)|0)==0;QP(Db);if(!hb){break}c[J>>2]=c[db>>2];gw(4,0,78184,J);a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}}while(0);KP(Eb,c[db>>2]|0);c[(UE(sa,Eb)|0)>>2]=fb;QP(Eb);ib=ib+1|0;lb=c[Wa>>2]<<1;}while((ib|0)<((c[ub>>2]|0)-lb|0))}if((c[35600>>2]|0)!=0){be[c[9034]&255](4)}c[I>>2]=78256;gw(4,1,78128,I);if((c[sb>>2]|0)>0){lb=b+4|0;ub=qa+84|0;ib=0;do{kb=c[lb>>2]|0;c[Fb>>2]=ib;mb=TE(ub,Fb)|0;yE(mb,kb+(ib*60|0)|0);GE(mb,kb+(ib*60|0)+36|0);gb=kb+(ib*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}else{if((c[89348>>2]|0)!=0){break}KP(Gb,78168);kb=(oQ(AE(mb,Gb)|0,76304)|0)==0;QP(Gb);if(!kb){break}c[H>>2]=c[gb>>2];gw(4,0,78184,H);a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}}while(0);KP(Hb,c[gb>>2]|0);c[(UE(sa,Hb)|0)>>2]=ib;QP(Hb);ib=ib+1|0;}while((ib|0)<(c[sb>>2]|0))}if((c[35600>>2]|0)!=0){be[c[9034]&255](4)}c[G>>2]=78280;gw(4,1,78128,G);if((c[qb>>2]|0)>0){sb=b+8|0;ib=qa+120|0;lb=0;do{ub=c[sb>>2]|0;c[Ib>>2]=lb;mb=TE(ib,Ib)|0;yE(mb,ub+(lb*48|0)|0);HE(mb,ub+(lb*48|0)+36|0);fb=ub+(lb*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[sb>>2]|0)+(lb*48|0)+44|0]=1}else{if((c[89348>>2]|0)!=0){break}KP(Jb,78168);ub=(oQ(AE(mb,Jb)|0,76304)|0)==0;QP(Jb);if(!ub){break}c[F>>2]=c[fb>>2];gw(4,0,78184,F);a[(c[sb>>2]|0)+(lb*48|0)+44|0]=1}}while(0);KP(Kb,c[fb>>2]|0);c[(UE(sa,Kb)|0)>>2]=lb;QP(Kb);lb=lb+1|0;}while((lb|0)<(c[qb>>2]|0))}if((c[35600>>2]|0)!=0){be[c[9034]&255](4)}c[E>>2]=78304;gw(4,1,78128,E);if((c[nb>>2]|0)>0){qb=b+12|0;lb=qa+156|0;sb=0;do{ib=c[qb>>2]|0;c[Lb>>2]=sb;mb=TE(lb,Lb)|0;yE(mb,ib+(sb*52|0)|0);IE(mb,ib+(sb*52|0)+36|0);gb=ib+(sb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[qb>>2]|0)+(sb*52|0)+48|0]=1}else{if((c[89348>>2]|0)!=0){break}KP(Mb,78168);ib=(oQ(AE(mb,Mb)|0,76304)|0)==0;QP(Mb);if(!ib){break}c[D>>2]=c[gb>>2];gw(4,0,78184,D);a[(c[qb>>2]|0)+(sb*52|0)+48|0]=1}}while(0);KP(Nb,c[gb>>2]|0);c[(UE(sa,Nb)|0)>>2]=sb;QP(Nb);sb=sb+1|0;}while((sb|0)<(c[nb>>2]|0))}if((c[35600>>2]|0)!=0){be[c[9034]&255](4)}c[C>>2]=78328;gw(4,1,78128,C);if((c[ja>>2]|0)>0){nb=b+16|0;sb=qa+60|0;qb=0;do{lb=c[nb>>2]|0;c[Ob>>2]=qb;mb=TE(sb,Ob)|0;yE(mb,lb+(qb*112|0)|0);DE(mb,lb+(qb*112|0)+40|0);fb=lb+(qb*112|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[nb>>2]|0)+(qb*112|0)+104|0]=1}else{if((c[89348>>2]|0)!=0){break}KP(Pb,78168);lb=(oQ(AE(mb,Pb)|0,76304)|0)==0;QP(Pb);if(!lb){break}c[B>>2]=c[fb>>2];gw(4,0,78184,B);a[(c[nb>>2]|0)+(qb*112|0)+104|0]=1}}while(0);KP(Qb,c[fb>>2]|0);c[(UE(ua,Qb)|0)>>2]=qb;QP(Qb);qb=qb+1|0;}while((qb|0)<(c[ja>>2]|0))}if((c[35600>>2]|0)!=0){be[c[9034]&255](4)}c[A>>2]=78344;gw(4,1,78128,A);if((c[tb>>2]|0)>0){ja=b+20|0;qb=qa+96|0;nb=0;do{sb=c[ja>>2]|0;c[Rb>>2]=nb;mb=TE(qb,Rb)|0;yE(mb,sb+(nb*60|0)|0);GE(mb,sb+(nb*60|0)+36|0);gb=sb+(nb*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}else{if((c[89348>>2]|0)!=0){break}KP(Sb,78168);sb=(oQ(AE(mb,Sb)|0,76304)|0)==0;QP(Sb);if(!sb){break}c[z>>2]=c[gb>>2];gw(4,0,78184,z);a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}}while(0);KP(Tb,c[gb>>2]|0);c[(UE(ua,Tb)|0)>>2]=nb;QP(Tb);nb=nb+1|0;}while((nb|0)<(c[tb>>2]|0))}if((c[35600>>2]|0)!=0){be[c[9034]&255](4)}c[y>>2]=78368;gw(4,1,78128,y);if((c[rb>>2]|0)>0){tb=b+24|0;nb=qa+132|0;ja=0;do{qb=c[tb>>2]|0;c[Ub>>2]=ja;mb=TE(nb,Ub)|0;yE(mb,qb+(ja*48|0)|0);HE(mb,qb+(ja*48|0)+36|0);fb=qb+(ja*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}else{if((c[89348>>2]|0)!=0){break}KP(Vb,78168);qb=(oQ(AE(mb,Vb)|0,76304)|0)==0;QP(Vb);if(!qb){break}c[x>>2]=c[fb>>2];gw(4,0,78184,x);a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}}while(0);KP(Wb,c[fb>>2]|0);c[(UE(ua,Wb)|0)>>2]=ja;QP(Wb);ja=ja+1|0;}while((ja|0)<(c[rb>>2]|0))}if((c[35600>>2]|0)!=0){be[c[9034]&255](4)}c[w>>2]=78392;gw(4,1,78128,w);if((c[ob>>2]|0)>0){rb=b+28|0;ja=qa+168|0;tb=0;do{nb=c[rb>>2]|0;c[Xb>>2]=tb;mb=TE(ja,Xb)|0;yE(mb,nb+(tb*52|0)|0);IE(mb,nb+(tb*52|0)+36|0);gb=nb+(tb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[rb>>2]|0)+(tb*52|0)+48|0]=1}else{if((c[89348>>2]|0)!=0){break}KP(Yb,78168);nb=(oQ(AE(mb,Yb)|0,76304)|0)==0;QP(Yb);if(!nb){break}c[v>>2]=c[gb>>2];gw(4,0,78184,v);a[(c[rb>>2]|0)+(tb*52|0)+48|0]=1}}while(0);KP(Zb,c[gb>>2]|0);c[(UE(ua,Zb)|0)>>2]=tb;QP(Zb);tb=tb+1|0;}while((tb|0)<(c[ob>>2]|0))}if((c[35600>>2]|0)!=0){be[c[9034]&255](4)}gw(4,1,78416,u);ob=b+208|0;a:do{if((c[ob>>2]|0)>0){tb=qa+72|0;rb=b+32|0;ja=0;b:while(1){c[_b>>2]=ja;mb=TE(tb,_b)|0;yE(mb,(c[rb>>2]|0)+(ja*52|0)+12|0);EP($b);c[bc>>2]=ja;mb=TE(tb,bc)|0;KP(cc,78456);GP(ac,AE(mb,cc)|0);VE(ac,$b);QP(ac);QP(cc);mb=(oQ($b,78464)|0)==0;fb=c[rb>>2]|0;nb=mb&1;c[fb+(ja*52|0)>>2]=nb;c[t>>2]=c[fb+(ja*52|0)+16>>2];c[t+4>>2]=nb;gw(4,0,78480,t);nb=c[rb>>2]|0;if((a[c[nb+(ja*52|0)+16>>2]|0]|0)==36){a[nb+(ja*52|0)+48|0]=1}c[fc>>2]=ja;nb=TE(tb,fc)|0;KP(gc,78520);GP(dc,AE(nb,gc)|0);VE(dc,$b);QP(dc);QP(gc);WE(wa,sa,$b);WE(xa,ua,$b);YE(hc,sa);do{if(XE(wa,hc)|0){nb=c[(ZE(wa)|0)+12>>2]|0;fb=c[rb>>2]|0;c[fb+(ja*52|0)+4>>2]=nb;a[fb+(ja*52|0)+8|0]=0}else{YE(ic,ua);if(XE(xa,ic)|0){fb=c[(ZE(xa)|0)+12>>2]|0;nb=c[rb>>2]|0;c[nb+(ja*52|0)+4>>2]=fb;a[nb+(ja*52|0)+8|0]=1;break}if((oQ($b,78536)|0)!=0){break b}a[(c[rb>>2]|0)+(ja*52|0)+8|0]=2}}while(0);QP($b);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break a}}zQ(kc,78544,$b);ME(jc,kc,78568);QP(kc);c[s>>2]=lQ(jc)|0;kw(0,78584,s)}}while(0);if((c[35600>>2]|0)!=0){be[c[9034]&255](4)}gw(4,1,78592,q);ob=b+212|0;c:do{if((c[ob>>2]|0)>0){ja=qa+108|0;rb=b+36|0;tb=0;while(1){c[lc>>2]=tb;gb=TE(ja,lc)|0;yE(gb,(c[rb>>2]|0)+(tb*52|0)+12|0);EP(mc);c[oc>>2]=tb;gb=TE(ja,oc)|0;KP(pc,78456);GP(nc,AE(gb,pc)|0);VE(nc,mc);QP(nc);QP(pc);gb=(oQ(mc,78464)|0)==0;nb=c[rb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[p>>2]=c[nb+(tb*52|0)+16>>2];c[p+4>>2]=fb;gw(4,0,78480,p);fb=c[rb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[rc>>2]=tb;fb=TE(ja,rc)|0;KP(sc,78520);GP(qc,AE(fb,sc)|0);VE(qc,mc);QP(qc);QP(sc);WE(wa,sa,mc);WE(xa,ua,mc);YE(tc,sa);if(XE(wa,tc)|0){fb=c[(ZE(wa)|0)+12>>2]|0;nb=c[rb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{YE(uc,ua);if(!(XE(xa,uc)|0)){break}nb=c[(ZE(xa)|0)+12>>2]|0;fb=c[rb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}QP(mc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break c}}zQ(wc,78632,mc);ME(vc,wc,78568);QP(wc);c[o>>2]=lQ(vc)|0;kw(0,78584,o)}}while(0);if((c[35600>>2]|0)!=0){be[c[9034]&255](4)}gw(4,1,78656,n);ob=b+216|0;d:do{if((c[ob>>2]|0)>0){tb=qa+144|0;rb=b+40|0;ja=0;while(1){c[xc>>2]=ja;fb=TE(tb,xc)|0;yE(fb,(c[rb>>2]|0)+(ja*52|0)+12|0);EP(yc);c[Ac>>2]=ja;fb=TE(tb,Ac)|0;KP(Bc,78456);GP(zc,AE(fb,Bc)|0);VE(zc,yc);QP(zc);QP(Bc);fb=(oQ(yc,78464)|0)==0;nb=c[rb>>2]|0;gb=fb&1;c[nb+(ja*52|0)>>2]=gb;c[m>>2]=c[nb+(ja*52|0)+16>>2];c[m+4>>2]=gb;gw(4,0,78480,m);gb=c[rb>>2]|0;if((a[c[gb+(ja*52|0)+16>>2]|0]|0)==36){a[gb+(ja*52|0)+48|0]=1}c[Dc>>2]=ja;gb=TE(tb,Dc)|0;KP(Ec,78520);GP(Cc,AE(gb,Ec)|0);VE(Cc,yc);QP(Cc);QP(Ec);WE(wa,sa,yc);WE(xa,ua,yc);YE(Fc,sa);if(XE(wa,Fc)|0){gb=c[(ZE(wa)|0)+12>>2]|0;nb=c[rb>>2]|0;c[nb+(ja*52|0)+4>>2]=gb;a[nb+(ja*52|0)+8|0]=0}else{YE(Gc,ua);if(!(XE(xa,Gc)|0)){break}nb=c[(ZE(xa)|0)+12>>2]|0;gb=c[rb>>2]|0;c[gb+(ja*52|0)+4>>2]=nb;a[gb+(ja*52|0)+8|0]=1}QP(yc);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break d}}zQ(Ic,78696,yc);ME(Hc,Ic,78568);QP(Ic);c[l>>2]=lQ(Hc)|0;kw(0,78584,l)}}while(0);if((c[35600>>2]|0)!=0){be[c[9034]&255](4)}gw(4,1,78720,j);ob=b+220|0;e:do{if((c[ob>>2]|0)>0){ja=qa+180|0;rb=b+44|0;tb=0;while(1){c[Jc>>2]=tb;gb=TE(ja,Jc)|0;yE(gb,(c[rb>>2]|0)+(tb*52|0)+12|0);EP(Kc);c[Mc>>2]=tb;gb=TE(ja,Mc)|0;KP(Nc,78456);GP(Lc,AE(gb,Nc)|0);VE(Lc,Kc);QP(Lc);QP(Nc);gb=(oQ(Kc,78464)|0)==0;nb=c[rb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[g>>2]=c[nb+(tb*52|0)+16>>2];c[g+4>>2]=fb;gw(4,0,78480,g);fb=c[rb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[Pc>>2]=tb;fb=TE(ja,Pc)|0;KP(Qc,78520);GP(Oc,AE(fb,Qc)|0);VE(Oc,Kc);QP(Oc);QP(Qc);WE(wa,sa,Kc);WE(xa,ua,Kc);YE(Rc,sa);if(XE(wa,Rc)|0){fb=c[(ZE(wa)|0)+12>>2]|0;nb=c[rb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{YE(Sc,ua);if(!(XE(xa,Sc)|0)){break}nb=c[(ZE(xa)|0)+12>>2]|0;fb=c[rb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}QP(Kc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break e}}zQ(Uc,78760,Kc);ME(Tc,Uc,78568);QP(Uc);c[f>>2]=lQ(Tc)|0;kw(0,78584,f)}}while(0);if((c[35600>>2]|0)==0){or(pa);_E(ua);_E(sa);QP(ra);$E(qa);i=e;return}be[c[9034]&255](4);or(pa);_E(ua);_E(sa);QP(ra);$E(qa);i=e;return}}while(0);if((c[35672>>2]|c[8894]|0)==0){or(pa);Zc=qd(0)|0;yd(-1)}iw(22,1,77648,Y);Y=c[Wa>>2]|0;c[X>>2]=vb;c[X+4>>2]=Y;iw(22,0,77696,X);X=(c[b+108>>2]|0)-(c[Wa>>2]<<1)|0;c[W>>2]=c[Xa>>2];c[W+4>>2]=X;iw(22,0,77744,W);W=c[b+128>>2]|0;c[V>>2]=c[Ya>>2];c[V+4>>2]=W;iw(22,0,77792,V);V=c[b+132>>2]|0;c[U>>2]=c[_a>>2];c[U+4>>2]=V;iw(22,0,77840,U);U=c[b+116>>2]|0;c[T>>2]=c[Za>>2];c[T+4>>2]=U;iw(22,0,77888,T);T=c[b+136>>2]|0;c[S>>2]=c[ab>>2];c[S+4>>2]=T;iw(22,0,77936,S);S=c[b+120>>2]|0;c[R>>2]=c[$a>>2];c[R+4>>2]=S;iw(22,0,77984,R);R=c[b+140>>2]|0;c[Q>>2]=c[cb>>2];c[Q+4>>2]=R;iw(22,0,78032,Q);Q=c[b+124>>2]|0;c[P>>2]=c[bb>>2];c[P+4>>2]=Q;iw(22,0,78080,P);be[c[9034]&255](22);or(pa);Zc=qd(0)|0;yd(-1)}function KE(a){a=a|0;var b=0;b=i;KL(a);i=b;return}function LE(a,b){a=a|0;b=b|0;b=i;pH(a,0);i=b;return}function ME(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;FP(a,d);e=OP(b)|0;f=zF(c)|0;pQ(a,PP(b)|0,e,f+e|0);hQ(a,c,f)|0;i=d;return}function NE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;if((t_(b,79392)|0)==0){t=c[d>>2]|0;if((t|0)==0){i=e;return}u=a;v=t;t=0;do{KP(g,v);w=AE(u,g)|0;SP(w,c[d+((t|1)<<2)>>2]|0)|0;QP(g);t=t+2|0;v=c[d+(t<<2)>>2]|0;}while((v|0)!=0);i=e;return}if((t_(b,79416)|0)==0){v=c[d>>2]|0;if((v|0)==0){i=e;return}t=a+12|0;g=v;v=0;do{KP(h,g);u=AE(t,h)|0;SP(u,c[d+((v|1)<<2)>>2]|0)|0;QP(h);v=v+2|0;g=c[d+(v<<2)>>2]|0;}while((g|0)!=0);i=e;return}if((t_(b,79440)|0)!=0){do{if((t_(b,79696)|0)!=0){if((t_(b,79704)|0)==0){break}if((t_(b,79712)|0)==0){break}if((t_(b,79720)|0)==0){break}i=e;return}}while(0);g=(c[d>>2]|0)==0;v=a+196|0;h=a+192|0;t=TE(c[v>>2]|0,h)|0;if(g){x=t}else{g=t;t=d;u=0;while(1){KP(r,c[t>>2]|0);w=AE(g,r)|0;SP(w,c[d+((u|1)<<2)>>2]|0)|0;QP(r);w=u+2|0;y=d+(w<<2)|0;z=(c[y>>2]|0)==0;A=TE(c[v>>2]|0,h)|0;if(z){x=A;break}else{u=w;t=y;g=A}}}KP(s,79728);SP(AE(x,s)|0,b)|0;QP(s);i=e;return}aF(j,k);EP(l);EP(m);k=a+192|0;s=k;c[k>>2]=-1;b=a+196|0;c[b>>2]=0;x=c[d>>2]|0;if((x|0)!=0){g=x;x=0;do{KP(n,g);t=AE(j,n)|0;SP(t,c[d+((x|1)<<2)>>2]|0)|0;QP(n);x=x+2|0;g=c[d+(x<<2)>>2]|0;}while((g|0)!=0)}KP(o,79456);RP(l,AE(j,o)|0)|0;QP(o);KP(p,79472);RP(m,AE(j,p)|0)|0;QP(p);c[k>>2]=Bc(lQ(l)|0)|0;if((oQ(m,79488)|0)==0){B=a+24|0}else{B=c[b>>2]|0}c[b>>2]=B;if((oQ(m,79496)|0)==0){C=a+36|0}else{C=c[b>>2]|0}c[b>>2]=C;if((oQ(m,79504)|0)==0){D=a+48|0}else{D=c[b>>2]|0}c[b>>2]=D;if((oQ(m,79512)|0)==0){E=a+60|0}else{E=c[b>>2]|0}c[b>>2]=E;if((oQ(m,79520)|0)==0){F=a+72|0}else{F=c[b>>2]|0}c[b>>2]=F;if((oQ(m,79528)|0)==0){G=a+84|0}else{G=c[b>>2]|0}c[b>>2]=G;if((oQ(m,79536)|0)==0){H=a+96|0}else{H=c[b>>2]|0}c[b>>2]=H;if((oQ(m,79544)|0)==0){I=a+108|0}else{I=c[b>>2]|0}c[b>>2]=I;if((oQ(m,79552)|0)==0){J=a+120|0}else{J=c[b>>2]|0}c[b>>2]=J;if((oQ(m,79560)|0)==0){K=a+132|0}else{K=c[b>>2]|0}c[b>>2]=K;if((oQ(m,79568)|0)==0){L=a+144|0}else{L=c[b>>2]|0}c[b>>2]=L;if((oQ(m,79576)|0)==0){M=a+156|0}else{M=c[b>>2]|0}c[b>>2]=M;if((oQ(m,79584)|0)==0){N=a+168|0}else{N=c[b>>2]|0}c[b>>2]=N;if((oQ(m,79592)|0)==0){O=a+180|0}else{O=c[b>>2]|0}c[b>>2]=O;a=lQ(m)|0;KP(q,76016);N=lQ(AE(j,q)|0)|0;c[f>>2]=a;c[f+4>>2]=N;jw(0,(O|0)!=0|0,79600,f);QP(q);nK(TE(c[b>>2]|0,s)|0,j)|0;QP(m);QP(l);iF(j);i=e;return}function OE(a,b){a=a|0;b=b|0;i=i;return}function PE(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=_G(a,b)|0;i=c;return d|0}function QE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;hH(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];$G(a,f);i=e;return}function RE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;aH(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];$G(a,e);i=d;return}



function WZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=i;if((a|0)==0){i=b;return}d=a+ -8|0;e=d;f=c[122512>>2]|0;if(d>>>0<f>>>0){ed()}g=c[a+ -4>>2]|0;h=g&3;if((h|0)==1){ed()}j=g&-8;k=a+(j+ -8)|0;l=k;a:do{if((g&1|0)==0){m=c[d>>2]|0;if((h|0)==0){i=b;return}n=-8-m|0;o=a+n|0;p=o;q=m+j|0;if(o>>>0<f>>>0){ed()}if((p|0)==(c[122516>>2]|0)){r=a+(j+ -4)|0;if((c[r>>2]&3|0)!=3){s=p;t=q;break}c[122504>>2]=q;c[r>>2]=c[r>>2]&-2;c[a+(n+4)>>2]=q|1;c[k>>2]=q;i=b;return}r=m>>>3;if(m>>>0<256){m=c[a+(n+8)>>2]|0;u=c[a+(n+12)>>2]|0;v=122536+(r<<1<<2)|0;do{if((m|0)!=(v|0)){if(m>>>0<f>>>0){ed()}if((c[m+12>>2]|0)==(p|0)){break}ed()}}while(0);if((u|0)==(m|0)){c[30624]=c[30624]&~(1<<r);s=p;t=q;break}do{if((u|0)==(v|0)){w=u+8|0}else{if(u>>>0<f>>>0){ed()}x=u+8|0;if((c[x>>2]|0)==(p|0)){w=x;break}ed()}}while(0);c[m+12>>2]=u;c[w>>2]=m;s=p;t=q;break}v=o;r=c[a+(n+24)>>2]|0;x=c[a+(n+12)>>2]|0;do{if((x|0)==(v|0)){y=a+(n+20)|0;z=y;A=c[y>>2]|0;if((A|0)==0){y=a+(n+16)|0;B=c[y>>2]|0;if((B|0)==0){C=0;break}else{D=B;E=y}}else{D=A;E=z}while(1){z=D+20|0;A=c[z>>2]|0;if((A|0)!=0){E=z;D=A;continue}A=D+16|0;z=c[A>>2]|0;if((z|0)==0){break}else{D=z;E=A}}if(E>>>0<f>>>0){ed()}else{c[E>>2]=0;C=D;break}}else{A=c[a+(n+8)>>2]|0;if(A>>>0<f>>>0){ed()}z=A+12|0;if((c[z>>2]|0)!=(v|0)){ed()}y=x+8|0;if((c[y>>2]|0)==(v|0)){c[z>>2]=x;c[y>>2]=A;C=x;break}else{ed()}}}while(0);if((r|0)==0){s=p;t=q;break}x=c[a+(n+28)>>2]|0;o=122800+(x<<2)|0;do{if((v|0)==(c[o>>2]|0)){c[o>>2]=C;if((C|0)!=0){break}c[122500>>2]=c[122500>>2]&~(1<<x);s=p;t=q;break a}else{if(r>>>0<(c[122512>>2]|0)>>>0){ed()}m=r+16|0;if((c[m>>2]|0)==(v|0)){c[m>>2]=C}else{c[r+20>>2]=C}if((C|0)==0){s=p;t=q;break a}}}while(0);if(C>>>0<(c[122512>>2]|0)>>>0){ed()}c[C+24>>2]=r;v=c[a+(n+16)>>2]|0;do{if((v|0)!=0){if(v>>>0<(c[122512>>2]|0)>>>0){ed()}else{c[C+16>>2]=v;c[v+24>>2]=C;break}}}while(0);v=c[a+(n+20)>>2]|0;if((v|0)==0){s=p;t=q;break}if(v>>>0<(c[122512>>2]|0)>>>0){ed()}else{c[C+20>>2]=v;c[v+24>>2]=C;s=p;t=q;break}}else{s=e;t=j}}while(0);if(!(s>>>0<k>>>0)){ed()}e=a+(j+ -4)|0;C=c[e>>2]|0;if((C&1|0)==0){ed()}do{if((C&2|0)==0){if((l|0)==(c[122520>>2]|0)){f=(c[122508>>2]|0)+t|0;c[122508>>2]=f;c[122520>>2]=s;c[s+4>>2]=f|1;if((s|0)!=(c[122516>>2]|0)){i=b;return}c[122516>>2]=0;c[122504>>2]=0;i=b;return}if((l|0)==(c[122516>>2]|0)){f=(c[122504>>2]|0)+t|0;c[122504>>2]=f;c[122516>>2]=s;c[s+4>>2]=f|1;c[s+f>>2]=f;i=b;return}f=(C&-8)+t|0;D=C>>>3;b:do{if(C>>>0<256){E=c[a+j>>2]|0;w=c[a+(j|4)>>2]|0;h=122536+(D<<1<<2)|0;do{if((E|0)!=(h|0)){if(E>>>0<(c[122512>>2]|0)>>>0){ed()}if((c[E+12>>2]|0)==(l|0)){break}ed()}}while(0);if((w|0)==(E|0)){c[30624]=c[30624]&~(1<<D);break}do{if((w|0)==(h|0)){F=w+8|0}else{if(w>>>0<(c[122512>>2]|0)>>>0){ed()}d=w+8|0;if((c[d>>2]|0)==(l|0)){F=d;break}ed()}}while(0);c[E+12>>2]=w;c[F>>2]=E}else{h=k;d=c[a+(j+16)>>2]|0;g=c[a+(j|4)>>2]|0;do{if((g|0)==(h|0)){v=a+(j+12)|0;r=v;x=c[v>>2]|0;if((x|0)==0){v=a+(j+8)|0;o=c[v>>2]|0;if((o|0)==0){G=0;break}else{H=o;I=v}}else{H=x;I=r}while(1){r=H+20|0;x=c[r>>2]|0;if((x|0)!=0){I=r;H=x;continue}x=H+16|0;r=c[x>>2]|0;if((r|0)==0){break}else{H=r;I=x}}if(I>>>0<(c[122512>>2]|0)>>>0){ed()}else{c[I>>2]=0;G=H;break}}else{x=c[a+j>>2]|0;if(x>>>0<(c[122512>>2]|0)>>>0){ed()}r=x+12|0;if((c[r>>2]|0)!=(h|0)){ed()}v=g+8|0;if((c[v>>2]|0)==(h|0)){c[r>>2]=g;c[v>>2]=x;G=g;break}else{ed()}}}while(0);if((d|0)==0){break}g=c[a+(j+20)>>2]|0;E=122800+(g<<2)|0;do{if((h|0)==(c[E>>2]|0)){c[E>>2]=G;if((G|0)!=0){break}c[122500>>2]=c[122500>>2]&~(1<<g);break b}else{if(d>>>0<(c[122512>>2]|0)>>>0){ed()}w=d+16|0;if((c[w>>2]|0)==(h|0)){c[w>>2]=G}else{c[d+20>>2]=G}if((G|0)==0){break b}}}while(0);if(G>>>0<(c[122512>>2]|0)>>>0){ed()}c[G+24>>2]=d;h=c[a+(j+8)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[122512>>2]|0)>>>0){ed()}else{c[G+16>>2]=h;c[h+24>>2]=G;break}}}while(0);h=c[a+(j+12)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[122512>>2]|0)>>>0){ed()}else{c[G+20>>2]=h;c[h+24>>2]=G;break}}}while(0);c[s+4>>2]=f|1;c[s+f>>2]=f;if((s|0)!=(c[122516>>2]|0)){J=f;break}c[122504>>2]=f;i=b;return}else{c[e>>2]=C&-2;c[s+4>>2]=t|1;c[s+t>>2]=t;J=t}}while(0);t=J>>>3;if(J>>>0<256){C=t<<1;e=122536+(C<<2)|0;G=c[30624]|0;j=1<<t;do{if((G&j|0)==0){c[30624]=G|j;K=122536+(C+2<<2)|0;L=e}else{t=122536+(C+2<<2)|0;a=c[t>>2]|0;if(!(a>>>0<(c[122512>>2]|0)>>>0)){K=t;L=a;break}ed()}}while(0);c[K>>2]=s;c[L+12>>2]=s;c[s+8>>2]=L;c[s+12>>2]=e;i=b;return}e=s;L=J>>>8;do{if((L|0)==0){M=0}else{if(J>>>0>16777215){M=31;break}K=(L+1048320|0)>>>16&8;C=L<<K;j=(C+520192|0)>>>16&4;G=C<<j;C=(G+245760|0)>>>16&2;a=14-(j|K|C)+(G<<C>>>15)|0;M=J>>>(a+7|0)&1|a<<1}}while(0);L=122800+(M<<2)|0;c[s+28>>2]=M;c[s+20>>2]=0;c[s+16>>2]=0;a=c[122500>>2]|0;C=1<<M;c:do{if((a&C|0)==0){c[122500>>2]=a|C;c[L>>2]=e;c[s+24>>2]=L;c[s+12>>2]=s;c[s+8>>2]=s}else{G=c[L>>2]|0;if((M|0)==31){N=0}else{N=25-(M>>>1)|0}d:do{if((c[G+4>>2]&-8|0)==(J|0)){O=G}else{K=J<<N;j=G;while(1){P=j+16+(K>>>31<<2)|0;t=c[P>>2]|0;if((t|0)==0){break}if((c[t+4>>2]&-8|0)==(J|0)){O=t;break d}else{K=K<<1;j=t}}if(P>>>0<(c[122512>>2]|0)>>>0){ed()}else{c[P>>2]=e;c[s+24>>2]=j;c[s+12>>2]=s;c[s+8>>2]=s;break c}}}while(0);G=O+8|0;f=c[G>>2]|0;K=c[122512>>2]|0;if(O>>>0<K>>>0){ed()}if(f>>>0<K>>>0){ed()}else{c[f+12>>2]=e;c[G>>2]=e;c[s+8>>2]=f;c[s+12>>2]=O;c[s+24>>2]=0;break}}}while(0);s=(c[122528>>2]|0)+ -1|0;c[122528>>2]=s;if((s|0)==0){Q=122952|0}else{i=b;return}while(1){s=c[Q>>2]|0;if((s|0)==0){break}else{Q=s+8|0}}c[122528>>2]=-1;i=b;return}function XZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{if((a|0)==0){e=0}else{f=fa(b,a)|0;if(!((b|a)>>>0>65535)){e=f;break}e=((f>>>0)/(a>>>0)|0|0)==(b|0)?f:-1}}while(0);b=VZ(e)|0;if((b|0)==0){i=d;return b|0}if((c[b+ -4>>2]&3|0)==0){i=d;return b|0}B_(b|0,0,e|0)|0;i=d;return b|0}function YZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if((a|0)==0){e=VZ(b)|0;i=d;return e|0}if(b>>>0>4294967231){c[(Kc()|0)>>2]=12;e=0;i=d;return e|0}if(b>>>0<11){f=16}else{f=b+11&-8}g=ZZ(a+ -8|0,f)|0;if((g|0)!=0){e=g+8|0;i=d;return e|0}g=VZ(b)|0;if((g|0)==0){e=0;i=d;return e|0}f=c[a+ -4>>2]|0;h=(f&-8)-((f&3|0)==0?8:4)|0;z_(g|0,a|0,(h>>>0<b>>>0?h:b)|0)|0;WZ(a);e=g;i=d;return e|0}function ZZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a;j=a+g|0;k=j;l=c[122512>>2]|0;if(h>>>0<l>>>0){ed()}m=f&3;if(!((m|0)!=1&h>>>0<j>>>0)){ed()}h=a+(g|4)|0;n=c[h>>2]|0;if((n&1|0)==0){ed()}if((m|0)==0){if(b>>>0<256){o=0;i=d;return o|0}do{if(!(g>>>0<(b+4|0)>>>0)){if((g-b|0)>>>0>c[122976>>2]<<1>>>0){break}else{o=a}i=d;return o|0}}while(0);o=0;i=d;return o|0}if(!(g>>>0<b>>>0)){m=g-b|0;if(!(m>>>0>15)){o=a;i=d;return o|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|3;c[h>>2]=c[h>>2]|1;_Z(a+b|0,m);o=a;i=d;return o|0}if((k|0)==(c[122520>>2]|0)){m=(c[122508>>2]|0)+g|0;if(!(m>>>0>b>>>0)){o=0;i=d;return o|0}h=m-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=h|1;c[122520>>2]=a+b;c[122508>>2]=h;o=a;i=d;return o|0}if((k|0)==(c[122516>>2]|0)){h=(c[122504>>2]|0)+g|0;if(h>>>0<b>>>0){o=0;i=d;return o|0}m=h-b|0;if(m>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|1;c[a+h>>2]=m;p=a+(h+4)|0;c[p>>2]=c[p>>2]&-2;q=a+b|0;r=m}else{c[e>>2]=f&1|h|2;f=a+(h+4)|0;c[f>>2]=c[f>>2]|1;q=0;r=0}c[122504>>2]=r;c[122516>>2]=q;o=a;i=d;return o|0}if((n&2|0)!=0){o=0;i=d;return o|0}q=(n&-8)+g|0;if(q>>>0<b>>>0){o=0;i=d;return o|0}r=q-b|0;f=n>>>3;a:do{if(n>>>0<256){h=c[a+(g+8)>>2]|0;m=c[a+(g+12)>>2]|0;p=122536+(f<<1<<2)|0;do{if((h|0)!=(p|0)){if(h>>>0<l>>>0){ed()}if((c[h+12>>2]|0)==(k|0)){break}ed()}}while(0);if((m|0)==(h|0)){c[30624]=c[30624]&~(1<<f);break}do{if((m|0)==(p|0)){s=m+8|0}else{if(m>>>0<l>>>0){ed()}t=m+8|0;if((c[t>>2]|0)==(k|0)){s=t;break}ed()}}while(0);c[h+12>>2]=m;c[s>>2]=h}else{p=j;t=c[a+(g+24)>>2]|0;u=c[a+(g+12)>>2]|0;do{if((u|0)==(p|0)){v=a+(g+20)|0;w=v;x=c[v>>2]|0;if((x|0)==0){v=a+(g+16)|0;y=c[v>>2]|0;if((y|0)==0){z=0;break}else{A=y;B=v}}else{A=x;B=w}while(1){w=A+20|0;x=c[w>>2]|0;if((x|0)!=0){B=w;A=x;continue}x=A+16|0;w=c[x>>2]|0;if((w|0)==0){break}else{A=w;B=x}}if(B>>>0<l>>>0){ed()}else{c[B>>2]=0;z=A;break}}else{x=c[a+(g+8)>>2]|0;if(x>>>0<l>>>0){ed()}w=x+12|0;if((c[w>>2]|0)!=(p|0)){ed()}v=u+8|0;if((c[v>>2]|0)==(p|0)){c[w>>2]=u;c[v>>2]=x;z=u;break}else{ed()}}}while(0);if((t|0)==0){break}u=c[a+(g+28)>>2]|0;h=122800+(u<<2)|0;do{if((p|0)==(c[h>>2]|0)){c[h>>2]=z;if((z|0)!=0){break}c[122500>>2]=c[122500>>2]&~(1<<u);break a}else{if(t>>>0<(c[122512>>2]|0)>>>0){ed()}m=t+16|0;if((c[m>>2]|0)==(p|0)){c[m>>2]=z}else{c[t+20>>2]=z}if((z|0)==0){break a}}}while(0);if(z>>>0<(c[122512>>2]|0)>>>0){ed()}c[z+24>>2]=t;p=c[a+(g+16)>>2]|0;do{if((p|0)!=0){if(p>>>0<(c[122512>>2]|0)>>>0){ed()}else{c[z+16>>2]=p;c[p+24>>2]=z;break}}}while(0);p=c[a+(g+20)>>2]|0;if((p|0)==0){break}if(p>>>0<(c[122512>>2]|0)>>>0){ed()}else{c[z+20>>2]=p;c[p+24>>2]=z;break}}}while(0);if(r>>>0<16){c[e>>2]=q|c[e>>2]&1|2;z=a+(q|4)|0;c[z>>2]=c[z>>2]|1;o=a;i=d;return o|0}else{c[e>>2]=c[e>>2]&1|b|2;c[a+(b+4)>>2]=r|3;e=a+(q|4)|0;c[e>>2]=c[e>>2]|1;_Z(a+b|0,r);o=a;i=d;return o|0}return 0}function _Z(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+b|0;f=e;g=c[a+4>>2]|0;a:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){i=d;return}j=a+(0-h)|0;k=j;l=h+b|0;m=c[122512>>2]|0;if(j>>>0<m>>>0){ed()}if((k|0)==(c[122516>>2]|0)){n=a+(b+4)|0;if((c[n>>2]&3|0)!=3){o=k;p=l;break}c[122504>>2]=l;c[n>>2]=c[n>>2]&-2;c[a+(4-h)>>2]=l|1;c[e>>2]=l;i=d;return}n=h>>>3;if(h>>>0<256){q=c[a+(8-h)>>2]|0;r=c[a+(12-h)>>2]|0;s=122536+(n<<1<<2)|0;do{if((q|0)!=(s|0)){if(q>>>0<m>>>0){ed()}if((c[q+12>>2]|0)==(k|0)){break}ed()}}while(0);if((r|0)==(q|0)){c[30624]=c[30624]&~(1<<n);o=k;p=l;break}do{if((r|0)==(s|0)){t=r+8|0}else{if(r>>>0<m>>>0){ed()}u=r+8|0;if((c[u>>2]|0)==(k|0)){t=u;break}ed()}}while(0);c[q+12>>2]=r;c[t>>2]=q;o=k;p=l;break}s=j;n=c[a+(24-h)>>2]|0;u=c[a+(12-h)>>2]|0;do{if((u|0)==(s|0)){v=16-h|0;w=a+(v+4)|0;x=w;y=c[w>>2]|0;if((y|0)==0){w=a+v|0;v=c[w>>2]|0;if((v|0)==0){z=0;break}else{A=v;B=w}}else{A=y;B=x}while(1){x=A+20|0;y=c[x>>2]|0;if((y|0)!=0){B=x;A=y;continue}y=A+16|0;x=c[y>>2]|0;if((x|0)==0){break}else{A=x;B=y}}if(B>>>0<m>>>0){ed()}else{c[B>>2]=0;z=A;break}}else{y=c[a+(8-h)>>2]|0;if(y>>>0<m>>>0){ed()}x=y+12|0;if((c[x>>2]|0)!=(s|0)){ed()}w=u+8|0;if((c[w>>2]|0)==(s|0)){c[x>>2]=u;c[w>>2]=y;z=u;break}else{ed()}}}while(0);if((n|0)==0){o=k;p=l;break}u=c[a+(28-h)>>2]|0;m=122800+(u<<2)|0;do{if((s|0)==(c[m>>2]|0)){c[m>>2]=z;if((z|0)!=0){break}c[122500>>2]=c[122500>>2]&~(1<<u);o=k;p=l;break a}else{if(n>>>0<(c[122512>>2]|0)>>>0){ed()}j=n+16|0;if((c[j>>2]|0)==(s|0)){c[j>>2]=z}else{c[n+20>>2]=z}if((z|0)==0){o=k;p=l;break a}}}while(0);if(z>>>0<(c[122512>>2]|0)>>>0){ed()}c[z+24>>2]=n;s=16-h|0;u=c[a+s>>2]|0;do{if((u|0)!=0){if(u>>>0<(c[122512>>2]|0)>>>0){ed()}else{c[z+16>>2]=u;c[u+24>>2]=z;break}}}while(0);u=c[a+(s+4)>>2]|0;if((u|0)==0){o=k;p=l;break}if(u>>>0<(c[122512>>2]|0)>>>0){ed()}else{c[z+20>>2]=u;c[u+24>>2]=z;o=k;p=l;break}}else{o=a;p=b}}while(0);z=c[122512>>2]|0;if(e>>>0<z>>>0){ed()}A=a+(b+4)|0;B=c[A>>2]|0;do{if((B&2|0)==0){if((f|0)==(c[122520>>2]|0)){t=(c[122508>>2]|0)+p|0;c[122508>>2]=t;c[122520>>2]=o;c[o+4>>2]=t|1;if((o|0)!=(c[122516>>2]|0)){i=d;return}c[122516>>2]=0;c[122504>>2]=0;i=d;return}if((f|0)==(c[122516>>2]|0)){t=(c[122504>>2]|0)+p|0;c[122504>>2]=t;c[122516>>2]=o;c[o+4>>2]=t|1;c[o+t>>2]=t;i=d;return}t=(B&-8)+p|0;g=B>>>3;b:do{if(B>>>0<256){u=c[a+(b+8)>>2]|0;h=c[a+(b+12)>>2]|0;n=122536+(g<<1<<2)|0;do{if((u|0)!=(n|0)){if(u>>>0<z>>>0){ed()}if((c[u+12>>2]|0)==(f|0)){break}ed()}}while(0);if((h|0)==(u|0)){c[30624]=c[30624]&~(1<<g);break}do{if((h|0)==(n|0)){C=h+8|0}else{if(h>>>0<z>>>0){ed()}m=h+8|0;if((c[m>>2]|0)==(f|0)){C=m;break}ed()}}while(0);c[u+12>>2]=h;c[C>>2]=u}else{n=e;m=c[a+(b+24)>>2]|0;j=c[a+(b+12)>>2]|0;do{if((j|0)==(n|0)){q=a+(b+20)|0;r=q;y=c[q>>2]|0;if((y|0)==0){q=a+(b+16)|0;w=c[q>>2]|0;if((w|0)==0){D=0;break}else{E=w;F=q}}else{E=y;F=r}while(1){r=E+20|0;y=c[r>>2]|0;if((y|0)!=0){F=r;E=y;continue}y=E+16|0;r=c[y>>2]|0;if((r|0)==0){break}else{E=r;F=y}}if(F>>>0<z>>>0){ed()}else{c[F>>2]=0;D=E;break}}else{y=c[a+(b+8)>>2]|0;if(y>>>0<z>>>0){ed()}r=y+12|0;if((c[r>>2]|0)!=(n|0)){ed()}q=j+8|0;if((c[q>>2]|0)==(n|0)){c[r>>2]=j;c[q>>2]=y;D=j;break}else{ed()}}}while(0);if((m|0)==0){break}j=c[a+(b+28)>>2]|0;u=122800+(j<<2)|0;do{if((n|0)==(c[u>>2]|0)){c[u>>2]=D;if((D|0)!=0){break}c[122500>>2]=c[122500>>2]&~(1<<j);break b}else{if(m>>>0<(c[122512>>2]|0)>>>0){ed()}h=m+16|0;if((c[h>>2]|0)==(n|0)){c[h>>2]=D}else{c[m+20>>2]=D}if((D|0)==0){break b}}}while(0);if(D>>>0<(c[122512>>2]|0)>>>0){ed()}c[D+24>>2]=m;n=c[a+(b+16)>>2]|0;do{if((n|0)!=0){if(n>>>0<(c[122512>>2]|0)>>>0){ed()}else{c[D+16>>2]=n;c[n+24>>2]=D;break}}}while(0);n=c[a+(b+20)>>2]|0;if((n|0)==0){break}if(n>>>0<(c[122512>>2]|0)>>>0){ed()}else{c[D+20>>2]=n;c[n+24>>2]=D;break}}}while(0);c[o+4>>2]=t|1;c[o+t>>2]=t;if((o|0)!=(c[122516>>2]|0)){G=t;break}c[122504>>2]=t;i=d;return}else{c[A>>2]=B&-2;c[o+4>>2]=p|1;c[o+p>>2]=p;G=p}}while(0);p=G>>>3;if(G>>>0<256){B=p<<1;A=122536+(B<<2)|0;D=c[30624]|0;b=1<<p;do{if((D&b|0)==0){c[30624]=D|b;H=122536+(B+2<<2)|0;I=A}else{p=122536+(B+2<<2)|0;a=c[p>>2]|0;if(!(a>>>0<(c[122512>>2]|0)>>>0)){H=p;I=a;break}ed()}}while(0);c[H>>2]=o;c[I+12>>2]=o;c[o+8>>2]=I;c[o+12>>2]=A;i=d;return}A=o;I=G>>>8;do{if((I|0)==0){J=0}else{if(G>>>0>16777215){J=31;break}H=(I+1048320|0)>>>16&8;B=I<<H;b=(B+520192|0)>>>16&4;D=B<<b;B=(D+245760|0)>>>16&2;a=14-(b|H|B)+(D<<B>>>15)|0;J=G>>>(a+7|0)&1|a<<1}}while(0);I=122800+(J<<2)|0;c[o+28>>2]=J;c[o+20>>2]=0;c[o+16>>2]=0;a=c[122500>>2]|0;B=1<<J;if((a&B|0)==0){c[122500>>2]=a|B;c[I>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}B=c[I>>2]|0;if((J|0)==31){K=0}else{K=25-(J>>>1)|0}c:do{if((c[B+4>>2]&-8|0)==(G|0)){L=B}else{J=G<<K;I=B;while(1){M=I+16+(J>>>31<<2)|0;a=c[M>>2]|0;if((a|0)==0){break}if((c[a+4>>2]&-8|0)==(G|0)){L=a;break c}else{J=J<<1;I=a}}if(M>>>0<(c[122512>>2]|0)>>>0){ed()}c[M>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}}while(0);M=L+8|0;G=c[M>>2]|0;B=c[122512>>2]|0;if(L>>>0<B>>>0){ed()}if(G>>>0<B>>>0){ed()}c[G+12>>2]=A;c[M>>2]=A;c[o+8>>2]=G;c[o+12>>2]=L;c[o+24>>2]=0;i=d;return}function $Z(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(a|0)==0?1:a;while(1){e=VZ(d)|0;if((e|0)!=0){f=6;break}a=c[30748]|0;c[30748]=0+a;if((a|0)==0){f=5;break}ye[a&7]()}if((f|0)==5){d=Ac(4)|0;c[d>>2]=123008;Pd(d|0,123056,135)}else if((f|0)==6){i=b;return e|0}return 0}function a_(a){a=a|0;var b=0,c=0;b=i;c=$Z(a)|0;i=b;return c|0}function b_(a){a=a|0;var b=0;b=i;if((a|0)!=0){WZ(a)}i=b;return}function c_(a){a=a|0;var b=0;b=i;b_(a);i=b;return}function d_(a){a=a|0;var b=0;b=i;wb(a|0);b_(a);i=b;return}function e_(a){a=a|0;var b=0;b=i;wb(a|0);i=b;return}function f_(a){a=a|0;i=i;return 123024}function g_(){var a=0;a=Ac(4)|0;c[a>>2]=123008;Pd(a|0,123056,135)}function h_(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0.0,tc=0,uc=0,wc=0.0,xc=0.0,yc=0.0,zc=0.0,Ac=0.0,Bc=0.0,Cc=0,Dc=0,Ec=0.0,Fc=0,Gc=0.0,Hc=0,Ic=0,Jc=0,Lc=0,Mc=0;g=i;i=i+512|0;h=g;if((e|0)==2){j=53;k=-1074}else if((e|0)==0){j=24;k=-149}else if((e|0)==1){j=53;k=-1074}else{l=0.0;i=g;return+l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n]|0}else{o=k_(b)|0}}while((gd(o|0)|0)!=0);do{if((o|0)==43|(o|0)==45){n=1-(((o|0)==45)<<1)|0;p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;q=d[p]|0;r=n;break}else{q=k_(b)|0;r=n;break}}else{q=o;r=1}}while(0);o=q;q=0;while(1){if((o|32|0)!=(a[123072+q|0]|0)){s=o;t=q;break}do{if(q>>>0<7){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;u=d[n]|0;break}else{u=k_(b)|0;break}}else{u=o}}while(0);n=q+1|0;if(n>>>0<8){o=u;q=n}else{s=u;t=n;break}}do{if((t|0)==3){v=23}else if((t|0)!=8){u=(f|0)==0;if(!(t>>>0<4|u)){if((t|0)==8){break}else{v=23;break}}a:do{if((t|0)==0){q=s;o=0;while(1){if((q|32|0)!=(a[123088+o|0]|0)){w=q;x=o;break a}do{if(o>>>0<2){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;A=d[n]|0;break}else{A=k_(b)|0;break}}else{A=q}}while(0);n=o+1|0;if(n>>>0<3){q=A;o=n}else{w=A;x=n;break}}}else{w=s;x=t}}while(0);if((x|0)==0){do{if((w|0)==48){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;B=d[o]|0}else{B=k_(b)|0}if((B|32|0)!=120){if((c[m>>2]|0)==0){C=48;break}c[e>>2]=(c[e>>2]|0)+ -1;C=48;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=0}else{D=k_(b)|0;E=0}while(1){if((D|0)==46){v=70;break}else if((D|0)!=48){F=0;G=0;H=0;I=0;K=D;L=E;M=0;N=0;O=1.0;P=0;Q=0.0;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=1;continue}else{D=k_(b)|0;E=1;continue}}b:do{if((v|0)==70){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;R=d[o]|0}else{R=k_(b)|0}if((R|0)==48){S=-1;T=-1}else{F=0;G=0;H=0;I=0;K=R;L=E;M=1;N=0;O=1.0;P=0;Q=0.0;break}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;V=d[o]|0}else{V=k_(b)|0}if((V|0)!=48){F=S;G=T;H=0;I=0;K=V;L=1;M=1;N=0;O=1.0;P=0;Q=0.0;break b}o=H_(S|0,T|0,-1,-1)|0;S=o;T=J}}}while(0);c:while(1){o=K+ -48|0;do{if(o>>>0<10){W=o;v=84}else{q=K|32;n=(K|0)==46;if(!((q+ -97|0)>>>0<6|n)){X=K;break c}if(n){if((M|0)==0){Y=H;Z=I;_=H;$=I;aa=L;ba=1;ca=N;da=O;ea=P;ga=Q;break}else{X=46;break c}}else{W=(K|0)>57?q+ -87|0:o;v=84;break}}}while(0);if((v|0)==84){v=0;do{if((I|0)<0|(I|0)==0&H>>>0<8){ha=N;ia=O;ja=W+(P<<4)|0;ka=Q}else{if((I|0)<0|(I|0)==0&H>>>0<14){la=O*.0625;ha=N;ia=la;ja=P;ka=Q+la*+(W|0);break}if(!((W|0)!=0&(N|0)==0)){ha=N;ia=O;ja=P;ka=Q;break}ha=1;ia=O;ja=P;ka=Q+O*.5}}while(0);o=H_(H|0,I|0,1,0)|0;Y=F;Z=G;_=o;$=J;aa=1;ba=M;ca=ha;da=ia;ea=ja;ga=ka}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;F=Y;G=Z;H=_;I=$;K=d[o]|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}else{F=Y;G=Z;H=_;I=$;K=k_(b)|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}}if((L|0)==0){o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}do{if(u){j_(b,0)}else{if(o){break}q=c[e>>2]|0;c[e>>2]=q+ -1;if((M|0)==0){break}c[e>>2]=q+ -2}}while(0);l=+(r|0)*0.0;i=g;return+l}o=(M|0)==0;q=o?H:F;n=o?I:G;if((I|0)<0|(I|0)==0&H>>>0<8){o=H;p=I;ma=P;while(1){na=ma<<4;oa=H_(o|0,p|0,1,0)|0;pa=J;if((pa|0)<0|(pa|0)==0&oa>>>0<8){ma=na;p=pa;o=oa}else{qa=na;break}}}else{qa=P}do{if((X|32|0)==112){o=i_(b,f)|0;p=J;if(!((o|0)==0&(p|0)==-2147483648)){ra=o;sa=p;break}if(u){j_(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0;break}}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0}}while(0);p=C_(q|0,n|0,2)|0;o=H_(p|0,J|0,-32,-1)|0;p=H_(o|0,J|0,ra|0,sa|0)|0;o=J;if((qa|0)==0){l=+(r|0)*0.0;i=g;return+l}if((o|0)>0|(o|0)==0&p>>>0>(0-k|0)>>>0){c[(Kc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}ma=k+ -106|0;na=((ma|0)<0)<<31>>31;if((o|0)<(na|0)|(o|0)==(na|0)&p>>>0<ma>>>0){c[(Kc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((qa|0)>-1){ma=p;na=o;oa=qa;la=Q;while(1){pa=oa<<1;if(!(la>=.5)){ta=la;ua=pa}else{ta=la+-1.0;ua=pa|1}va=la+ta;pa=H_(ma|0,na|0,-1,-1)|0;wa=J;if((ua|0)>-1){ma=pa;na=wa;oa=ua;la=va}else{xa=pa;ya=wa;za=ua;Aa=va;break}}}else{xa=p;ya=o;za=qa;Aa=Q}oa=G_(32,0,k|0,((k|0)<0)<<31>>31|0)|0;na=H_(xa|0,ya|0,oa|0,J|0)|0;oa=J;if(0>(oa|0)|0==(oa|0)&j>>>0>na>>>0){Ba=(na|0)<0?0:na}else{Ba=j}do{if((Ba|0)<53){la=+(r|0);va=+Nd(+(+l_(1.0,84-Ba|0)),+la);if(!((Ba|0)<32&Aa!=0.0)){Ca=la;Da=va;Ea=za;Fa=Aa;break}na=za&1;Ca=la;Da=va;Ea=(na^1)+za|0;Fa=(na|0)==0?0.0:Aa}else{Ca=+(r|0);Da=0.0;Ea=za;Fa=Aa}}while(0);va=Ca*Fa+(Da+Ca*+(Ea>>>0))-Da;if(!(va!=0.0)){c[(Kc()|0)>>2]=34}l=+m_(va,xa);i=g;return+l}else{C=w}}while(0);o=k+j|0;p=0-o|0;na=C;oa=0;while(1){if((na|0)==46){v=139;break}else if((na|0)!=48){Ga=na;Ha=0;Ia=0;Ja=oa;Ka=0;break}ma=c[e>>2]|0;if(ma>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ma+1;na=d[ma]|0;oa=1;continue}else{na=k_(b)|0;oa=1;continue}}d:do{if((v|0)==139){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;La=d[na]|0}else{La=k_(b)|0}if((La|0)==48){Ma=-1;Na=-1}else{Ga=La;Ha=0;Ia=0;Ja=oa;Ka=1;break}while(1){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;Oa=d[na]|0}else{Oa=k_(b)|0}if((Oa|0)!=48){Ga=Oa;Ha=Ma;Ia=Na;Ja=1;Ka=1;break d}na=H_(Ma|0,Na|0,-1,-1)|0;Ma=na;Na=J}}}while(0);oa=h;c[oa>>2]=0;na=Ga+ -48|0;ma=(Ga|0)==46;e:do{if(na>>>0<10|ma){n=h+496|0;q=Ga;wa=ma;pa=na;Pa=0;Qa=0;Ra=Ha;Sa=Ia;Ta=Ja;Ua=Ka;Va=0;Wa=0;Xa=0;while(1){do{if(wa){if((Ua|0)==0){Ya=Pa;Za=Qa;_a=Pa;$a=Qa;ab=Ta;bb=1;cb=Va;db=Wa;eb=Xa}else{fb=q;gb=Pa;hb=Qa;ib=Ra;jb=Sa;kb=Ta;lb=Va;mb=Wa;nb=Xa;break e}}else{ob=H_(Pa|0,Qa|0,1,0)|0;pb=J;qb=(q|0)!=48;if((Wa|0)>=125){if(!qb){Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}c[n>>2]=c[n>>2]|1;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}rb=h+(Wa<<2)|0;if((Va|0)==0){sb=pa}else{sb=q+ -48+((c[rb>>2]|0)*10|0)|0}c[rb>>2]=sb;rb=Va+1|0;tb=(rb|0)==9;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=1;bb=Ua;cb=tb?0:rb;db=(tb&1)+Wa|0;eb=qb?ob:Xa}}while(0);ob=c[e>>2]|0;if(ob>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ob+1;ub=d[ob]|0}else{ub=k_(b)|0}ob=ub+ -48|0;qb=(ub|0)==46;if(ob>>>0<10|qb){q=ub;wa=qb;pa=ob;Pa=_a;Qa=$a;Ra=Ya;Sa=Za;Ta=ab;Ua=bb;Va=cb;Wa=db;Xa=eb}else{vb=ub;wb=_a;xb=$a;yb=Ya;zb=Za;Ab=ab;Bb=bb;Cb=cb;Db=db;Eb=eb;v=162;break}}}else{vb=Ga;wb=0;xb=0;yb=Ha;zb=Ia;Ab=Ja;Bb=Ka;Cb=0;Db=0;Eb=0;v=162}}while(0);if((v|0)==162){na=(Bb|0)==0;fb=vb;gb=wb;hb=xb;ib=na?wb:yb;jb=na?xb:zb;kb=Ab;lb=Cb;mb=Db;nb=Eb}na=(kb|0)!=0;do{if(na){if((fb|32|0)!=101){v=171;break}ma=i_(b,f)|0;Xa=J;do{if((ma|0)==0&(Xa|0)==-2147483648){if(u){j_(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){Fb=0;Gb=0;break}c[e>>2]=(c[e>>2]|0)+ -1;Fb=0;Gb=0;break}}else{Fb=ma;Gb=Xa}}while(0);Xa=H_(Fb|0,Gb|0,ib|0,jb|0)|0;Hb=Xa;Ib=J}else{v=171}}while(0);do{if((v|0)==171){if(!((fb|0)>-1)){Hb=ib;Ib=jb;break}if((c[m>>2]|0)==0){Hb=ib;Ib=jb;break}c[e>>2]=(c[e>>2]|0)+ -1;Hb=ib;Ib=jb}}while(0);if(!na){c[(Kc()|0)>>2]=22;j_(b,0);l=0.0;i=g;return+l}Xa=c[oa>>2]|0;if((Xa|0)==0){l=+(r|0)*0.0;i=g;return+l}do{if((Hb|0)==(gb|0)&(Ib|0)==(hb|0)&((hb|0)<0|(hb|0)==0&gb>>>0<10)){if(!(j>>>0>30)){if((Xa>>>j|0)!=0){break}}l=+(r|0)*+(Xa>>>0);i=g;return+l}}while(0);Xa=(k|0)/-2|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)>(na|0)|(Ib|0)==(na|0)&Hb>>>0>Xa>>>0){c[(Kc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}Xa=k+ -106|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)<(na|0)|(Ib|0)==(na|0)&Hb>>>0<Xa>>>0){c[(Kc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((lb|0)==0){Jb=mb}else{if((lb|0)<9){Xa=h+(mb<<2)|0;na=c[Xa>>2]|0;ma=lb;do{na=na*10|0;ma=ma+1|0;}while((ma|0)<9);c[Xa>>2]=na}Jb=mb+1|0}do{if((nb|0)<9){if(!((nb|0)<=(Hb|0)&(Hb|0)<18)){break}if((Hb|0)==9){l=+(r|0)*+((c[oa>>2]|0)>>>0);i=g;return+l}if((Hb|0)<9){l=+(r|0)*+((c[oa>>2]|0)>>>0)/+(c[123104+(8-Hb<<2)>>2]|0);i=g;return+l}ma=j+27+(fa(Hb,-3)|0)|0;Wa=c[oa>>2]|0;if((ma|0)<=30){if((Wa>>>ma|0)!=0){break}}l=+(r|0)*+(Wa>>>0)*+(c[123104+(Hb+ -10<<2)>>2]|0);i=g;return+l}}while(0);oa=(Hb|0)%9|0;if((oa|0)==0){Kb=0;Lb=0;Mb=Hb;Nb=Jb}else{na=(Hb|0)>-1?oa:oa+9|0;oa=c[123104+(8-na<<2)>>2]|0;do{if((Jb|0)==0){Ob=0;Pb=Hb;Qb=0}else{Xa=1e9/(oa|0)|0;Wa=0;ma=0;Va=0;Ua=Hb;while(1){Ta=h+(Va<<2)|0;Sa=c[Ta>>2]|0;Ra=((Sa>>>0)/(oa>>>0)|0)+ma|0;c[Ta>>2]=Ra;Rb=fa((Sa>>>0)%(oa>>>0)|0,Xa)|0;Sa=Va+1|0;if((Va|0)==(Wa|0)&(Ra|0)==0){Sb=Sa&127;Tb=Ua+ -9|0}else{Sb=Wa;Tb=Ua}if((Sa|0)==(Jb|0)){break}else{Wa=Sb;Ua=Tb;Va=Sa;ma=Rb}}if((Rb|0)==0){Ob=Sb;Pb=Tb;Qb=Jb;break}c[h+(Jb<<2)>>2]=Rb;Ob=Sb;Pb=Tb;Qb=Jb+1|0}}while(0);Kb=Ob;Lb=0;Mb=9-na+Pb|0;Nb=Qb}f:while(1){oa=h+(Kb<<2)|0;if((Mb|0)<18){ma=Lb;Va=Nb;while(1){Ua=0;Wa=Va+127|0;Xa=Va;while(1){Sa=Wa&127;Ra=h+(Sa<<2)|0;Ta=C_(c[Ra>>2]|0,0,29)|0;Qa=H_(Ta|0,J|0,Ua|0,0)|0;Ta=J;if(Ta>>>0>0|(Ta|0)==0&Qa>>>0>1e9){Pa=R_(Qa|0,Ta|0,1e9,0)|0;pa=S_(Qa|0,Ta|0,1e9,0)|0;Ub=pa;Vb=Pa}else{Ub=Qa;Vb=0}c[Ra>>2]=Ub;Ra=(Sa|0)==(Kb|0);if((Sa|0)!=(Xa+127&127|0)|Ra){Wb=Xa}else{Wb=(Ub|0)==0?Sa:Xa}if(Ra){break}else{Ua=Vb;Wa=Sa+ -1|0;Xa=Wb}}Xa=ma+ -29|0;if((Vb|0)==0){ma=Xa;Va=Wb}else{Xb=Xa;Yb=Vb;Zb=Wb;break}}}else{if((Mb|0)==18){_b=Lb;$b=Nb}else{ac=Kb;bc=Lb;cc=Mb;dc=Nb;break}while(1){if(!((c[oa>>2]|0)>>>0<9007199)){ac=Kb;bc=_b;cc=18;dc=$b;break f}Va=0;ma=$b+127|0;Xa=$b;while(1){Wa=ma&127;Ua=h+(Wa<<2)|0;Sa=C_(c[Ua>>2]|0,0,29)|0;Ra=H_(Sa|0,J|0,Va|0,0)|0;Sa=J;if(Sa>>>0>0|(Sa|0)==0&Ra>>>0>1e9){Qa=R_(Ra|0,Sa|0,1e9,0)|0;Pa=S_(Ra|0,Sa|0,1e9,0)|0;ec=Pa;fc=Qa}else{ec=Ra;fc=0}c[Ua>>2]=ec;Ua=(Wa|0)==(Kb|0);if((Wa|0)!=(Xa+127&127|0)|Ua){gc=Xa}else{gc=(ec|0)==0?Wa:Xa}if(Ua){break}else{Va=fc;ma=Wa+ -1|0;Xa=gc}}Xa=_b+ -29|0;if((fc|0)==0){_b=Xa;$b=gc}else{Xb=Xa;Yb=fc;Zb=gc;break}}}oa=Kb+127&127;if((oa|0)==(Zb|0)){Xa=Zb+127&127;ma=h+((Zb+126&127)<<2)|0;c[ma>>2]=c[ma>>2]|c[h+(Xa<<2)>>2];hc=Xa}else{hc=Zb}c[h+(oa<<2)>>2]=Yb;Kb=oa;Lb=Xb;Mb=Mb+9|0;Nb=hc}g:while(1){ic=dc+1&127;na=h+((dc+127&127)<<2)|0;oa=ac;Xa=bc;ma=cc;while(1){Va=(ma|0)==18;Wa=(ma|0)>27?9:1;jc=oa;kc=Xa;while(1){Ua=0;while(1){Ra=Ua+jc&127;if((Ra|0)==(dc|0)){lc=2;break}Qa=c[h+(Ra<<2)>>2]|0;Ra=c[123096+(Ua<<2)>>2]|0;if(Qa>>>0<Ra>>>0){lc=2;break}Pa=Ua+1|0;if(Qa>>>0>Ra>>>0){lc=Ua;break}if((Pa|0)<2){Ua=Pa}else{lc=Pa;break}}if((lc|0)==2&Va){break g}mc=Wa+kc|0;if((jc|0)==(dc|0)){jc=dc;kc=mc}else{break}}Va=(1<<Wa)+ -1|0;Ua=1e9>>>Wa;nc=jc;oc=0;Pa=jc;pc=ma;do{Ra=h+(Pa<<2)|0;Qa=c[Ra>>2]|0;Sa=(Qa>>>Wa)+oc|0;c[Ra>>2]=Sa;oc=fa(Qa&Va,Ua)|0;Qa=(Pa|0)==(nc|0)&(Sa|0)==0;Pa=Pa+1&127;pc=Qa?pc+ -9|0:pc;nc=Qa?Pa:nc;}while((Pa|0)!=(dc|0));if((oc|0)==0){oa=nc;Xa=mc;ma=pc;continue}if((ic|0)!=(nc|0)){break}c[na>>2]=c[na>>2]|1;oa=nc;Xa=mc;ma=pc}c[h+(dc<<2)>>2]=oc;ac=nc;bc=mc;cc=pc;dc=ic}ma=jc&127;if((ma|0)==(dc|0)){c[h+(ic+ -1<<2)>>2]=0;qc=ic}else{qc=dc}va=+((c[h+(ma<<2)>>2]|0)>>>0);ma=jc+1&127;if((ma|0)==(qc|0)){Xa=qc+1&127;c[h+(Xa+ -1<<2)>>2]=0;rc=Xa}else{rc=qc}la=+(r|0);sc=la*(va*1.0e9+ +((c[h+(ma<<2)>>2]|0)>>>0));ma=kc+53|0;Xa=ma-k|0;if((Xa|0)<(j|0)){tc=(Xa|0)<0?0:Xa;uc=1}else{tc=j;uc=0}if((tc|0)<53){va=+Nd(+(+l_(1.0,105-tc|0)),+sc);wc=+vc(+sc,+(+l_(1.0,53-tc|0)));xc=va;yc=wc;zc=va+(sc-wc)}else{xc=0.0;yc=0.0;zc=sc}oa=jc+2&127;do{if((oa|0)==(rc|0)){Ac=yc}else{na=c[h+(oa<<2)>>2]|0;do{if(na>>>0<5e8){if((na|0)==0){if((jc+3&127|0)==(rc|0)){Bc=yc;break}}Bc=la*.25+yc}else{if(na>>>0>5e8){Bc=la*.75+yc;break}if((jc+3&127|0)==(rc|0)){Bc=la*.5+yc;break}else{Bc=la*.75+yc;break}}}while(0);if((53-tc|0)<=1){Ac=Bc;break}if(+vc(+Bc,1.0)!=0.0){Ac=Bc;break}Ac=Bc+1.0}}while(0);la=zc+Ac-xc;do{if((ma&2147483647|0)>(-2-o|0)){if(!(+U(+la)>=9007199254740992.0)){Cc=uc;Dc=kc;Ec=la}else{Cc=(uc|0)!=0&(tc|0)==(Xa|0)?0:uc;Dc=kc+1|0;Ec=la*.5}if((Dc+50|0)<=(p|0)){if(!((Cc|0)!=0&Ac!=0.0)){Fc=Dc;Gc=Ec;break}}c[(Kc()|0)>>2]=34;Fc=Dc;Gc=Ec}else{Fc=kc;Gc=la}}while(0);l=+m_(Gc,Fc);i=g;return+l}else if((x|0)==3){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Hc=d[p]|0}else{Hc=k_(b)|0}if((Hc|0)==40){Ic=1}else{if((c[m>>2]|0)==0){l=+y;i=g;return+l}c[e>>2]=(c[e>>2]|0)+ -1;l=+y;i=g;return+l}while(1){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Jc=d[p]|0}else{Jc=k_(b)|0}if(!((Jc+ -48|0)>>>0<10|(Jc+ -65|0)>>>0<26)){if(!((Jc+ -97|0)>>>0<26|(Jc|0)==95)){break}}Ic=Ic+1|0}if((Jc|0)==41){l=+y;i=g;return+l}p=(c[m>>2]|0)==0;if(!p){c[e>>2]=(c[e>>2]|0)+ -1}if(u){c[(Kc()|0)>>2]=22;j_(b,0);l=0.0;i=g;return+l}if((Ic|0)==0|p){l=+y;i=g;return+l}else{Lc=Ic}while(1){p=Lc+ -1|0;c[e>>2]=(c[e>>2]|0)+ -1;if((p|0)==0){l=+y;break}else{Lc=p}}i=g;return+l}else{if((c[m>>2]|0)!=0){c[e>>2]=(c[e>>2]|0)+ -1}c[(Kc()|0)>>2]=22;j_(b,0);l=0.0;i=g;return+l}}}while(0);do{if((v|0)==23){b=(c[m>>2]|0)==0;if(!b){c[e>>2]=(c[e>>2]|0)+ -1}if(t>>>0<4|(f|0)==0|b){break}else{Mc=t}do{c[e>>2]=(c[e>>2]|0)+ -1;Mc=Mc+ -1|0;}while(Mc>>>0>3)}}while(0);l=+(r|0)*+z;i=g;return+l}function i_(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g]|0}else{j=k_(a)|0}do{if((j|0)==43|(j|0)==45){g=(j|0)==45|0;k=c[f>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[f>>2]=k+1;l=d[k]|0}else{l=k_(a)|0}if((l+ -48|0)>>>0<10|(b|0)==0){m=l;n=g;break}if((c[h>>2]|0)==0){m=l;n=g;break}c[f>>2]=(c[f>>2]|0)+ -1;m=l;n=g}else{m=j;n=0}}while(0);if((m+ -48|0)>>>0>9){if((c[h>>2]|0)==0){o=0;p=-2147483648;J=p;i=e;return o|0}c[f>>2]=(c[f>>2]|0)+ -1;o=0;p=-2147483648;J=p;i=e;return o|0}else{q=m;r=0}while(1){s=q+ -48+r|0;m=c[f>>2]|0;if(m>>>0<(c[h>>2]|0)>>>0){c[f>>2]=m+1;t=d[m]|0}else{t=k_(a)|0}if(!((t+ -48|0)>>>0<10&(s|0)<214748364)){break}q=t;r=s*10|0}r=((s|0)<0)<<31>>31;if((t+ -48|0)>>>0<10){q=s;m=r;j=t;while(1){l=Q_(q|0,m|0,10,0)|0;b=J;g=H_(j|0,((j|0)<0)<<31>>31|0,-48,-1)|0;k=H_(g|0,J|0,l|0,b|0)|0;b=J;l=c[f>>2]|0;if(l>>>0<(c[h>>2]|0)>>>0){c[f>>2]=l+1;u=d[l]|0}else{u=k_(a)|0}if((u+ -48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&k>>>0<2061584302)){j=u;m=b;q=k}else{v=k;w=b;x=u;break}}}else{v=s;w=r;x=t}if((x+ -48|0)>>>0<10){do{x=c[f>>2]|0;if(x>>>0<(c[h>>2]|0)>>>0){c[f>>2]=x+1;y=d[x]|0}else{y=k_(a)|0}}while((y+ -48|0)>>>0<10)}if((c[h>>2]|0)!=0){c[f>>2]=(c[f>>2]|0)+ -1}f=(n|0)!=0;n=G_(0,0,v|0,w|0)|0;o=f?n:v;p=f?J:w;J=p;i=e;return o|0}function j_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if((b|0)!=0&(g|0)>(b|0)){c[a+100>>2]=f+b;i=d;return}else{c[a+100>>2]=e;i=d;return}}function k_(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+104|0;g=c[f>>2]|0;if((g|0)==0){h=3}else{if((c[b+108>>2]|0)<(g|0)){h=3}}do{if((h|0)==3){g=o_(b)|0;if((g|0)<0){break}j=c[f>>2]|0;k=c[b+8>>2]|0;do{if((j|0)==0){h=8}else{l=c[b+4>>2]|0;m=j-(c[b+108>>2]|0)+ -1|0;if((k-l|0)<=(m|0)){h=8;break}c[b+100>>2]=l+m}}while(0);if((h|0)==8){c[b+100>>2]=k}j=c[b+4>>2]|0;if((k|0)!=0){m=b+108|0;c[m>>2]=k+1-j+(c[m>>2]|0)}m=j+ -1|0;if((d[m]|0|0)==(g|0)){n=g;i=e;return n|0}a[m]=g;n=g;i=e;return n|0}}while(0);c[b+100>>2]=0;n=-1;i=e;return n|0}function l_(a,b){a=+a;b=b|0;var d=0,e=0.0,f=0,g=0,j=0.0;d=i;do{if((b|0)>1023){e=a*8.98846567431158e+307;f=b+ -1023|0;if((f|0)<=1023){g=f;j=e;break}f=b+ -2046|0;g=(f|0)>1023?1023:f;j=e*8.98846567431158e+307}else{if(!((b|0)<-1022)){g=b;j=a;break}e=a*1.2882297539194267e-231;f=b+1022|0;if(!((f|0)<-1022)){g=f;j=e;break}f=b+2044|0;g=(f|0)<-1022?-1022:f;j=e*1.2882297539194267e-231}}while(0);b=C_(g+1023|0,0,52)|0;g=J;c[k>>2]=b;c[k+4>>2]=g;a=j*+h[k>>3];i=d;return+a}function m_(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+l_(a,b);i=c;return+d}function n_(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+74|0;f=a[e]|0;a[e]=f+ -1<<24>>24|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0){ie[c[b+36>>2]&63](b,0,0)|0}c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=b;g=c[f>>2]|0;if((g&20|0)==0){h=c[e>>2]|0;c[b+8>>2]=h;c[b+4>>2]=h;j=0;i=d;return j|0}if((g&4|0)==0){j=-1;i=d;return j|0}c[f>>2]=g|32;j=-1;i=d;return j|0}function o_(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+8|0;e=b;do{if((c[a+8>>2]|0)==0){if((n_(a)|0)==0){break}else{f=-1}i=b;return f|0}}while(0);if((ie[c[a+32>>2]&63](a,e,1)|0)!=1){f=-1;i=b;return f|0}f=d[e]|0;i=b;return f|0}function p_(a){a=a|0;var b=0,c=0.0;b=i;c=+q_(a,0);i=b;return+c}function q_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;j_(e,0);h=+h_(e,1,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function r_(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;j_(e,0);h=+h_(e,2,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function s_(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)==0){f=0;i=e;return f|0}else{g=d;h=b;j=c}while(1){k=a[h]|0;l=a[j]|0;if(!(k<<24>>24==l<<24>>24)){break}c=g+ -1|0;if((c|0)==0){f=0;m=5;break}else{g=c;h=h+1|0;j=j+1|0}}if((m|0)==5){i=e;return f|0}f=(k&255)-(l&255)|0;i=e;return f|0}function t_(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a[b]|0;f=a[c]|0;if(e<<24>>24!=f<<24>>24|e<<24>>24==0|f<<24>>24==0){g=e;h=f;j=g&255;k=h&255;l=j-k|0;i=d;return l|0}else{m=b;n=c}while(1){c=m+1|0;b=n+1|0;f=a[c]|0;e=a[b]|0;if(f<<24>>24!=e<<24>>24|f<<24>>24==0|e<<24>>24==0){g=f;h=e;break}else{n=b;m=c}}j=g&255;k=h&255;l=j-k|0;i=d;return l|0}function u_(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;if((e|0)==0){g=0;i=f;return g|0}h=a[b]|0;a:do{if(h<<24>>24==0){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){p=l+ -1|0;q=a[o]|0;if(!((p|0)!=0&q<<24>>24!=0&m<<24>>24==q<<24>>24)){j=m;k=o;break a}q=n+1|0;r=o+1|0;s=a[q]|0;if(s<<24>>24==0){j=0;k=r;break}else{m=s;n=q;o=r;l=p}}}}while(0);g=(j&255)-(d[k]|0)|0;i=f;return g|0}function v_(){c[25852]=p;c[25894]=p;c[30536]=p;c[30766]=p}function w_(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;w=w+1|0;c[a>>2]=w;while((e|0)<40){if((c[d+(e<<2)>>2]|0)==0){c[d+(e<<2)>>2]=w;c[d+((e<<2)+4)>>2]=b;c[d+((e<<2)+8)>>2]=0;return 0}e=e+2|0}$b(116);$b(111);$b(111);$b(32);$b(109);$b(97);$b(110);$b(121);$b(32);$b(115);$b(101);$b(116);$b(106);$b(109);$b(112);$b(115);$b(32);$b(105);$b(110);$b(32);$b(97);$b(32);$b(102);$b(117);$b(110);$b(99);$b(116);$b(105);$b(111);$b(110);$b(32);$b(99);$b(97);$b(108);$b(108);$b(44);$b(32);$b(98);$b(117);$b(105);$b(108);$b(100);$b(32);$b(119);$b(105);$b(116);$b(104);$b(32);$b(97);$b(32);$b(104);$b(105);$b(103);$b(104);$b(101);$b(114);$b(32);$b(118);$b(97);$b(108);$b(117);$b(101);$b(32);$b(102);$b(111);$b(114);$b(32);$b(77);$b(65);$b(88);$b(95);$b(83);$b(69);$b(84);$b(74);$b(77);$b(80);$b(83);$b(10);ga(0);return 0}function x_(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function y_(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function z_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return jb(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function A_(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{z_(b,c,d)|0}return b|0}function B_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function C_(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function D_(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function E_(a){a=a|0;var b=0;b=(fa(c[a>>2]|0,31010991)|0)+1735287159&2147483647;c[a>>2]=b;return b|0}function F_(){return E_(o)|0}function G_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(J=e,a-c>>>0|0)|0}function H_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function I_(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e|0]=f?0:a[c+e|0]|0;f=f?1:(a[c+e|0]|0)==0;e=e+1|0}return b|0}function J_(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function K_(a,b){a=a|0;b=b|0;var d=0,e=0;while((d|0)<20){e=c[b+(d<<2)>>2]|0;if((e|0)==0)break;if((e|0)==(a|0)){return c[b+((d<<2)+4)>>2]|0}d=d+2|0}return 0}function L_(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function M_(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function N_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=fa(d,c)|0;f=a>>>16;a=(e>>>16)+(fa(d,f)|0)|0;d=b>>>16;b=fa(d,c)|0;return(J=(a>>>16)+(fa(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function O_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=G_(e^a,f^b,e,f)|0;b=J;a=g^e;e=h^f;f=G_((T_(i,b,G_(g^c,h^d,g,h)|0,J,0)|0)^a,J^e,a,e)|0;return(J=J,f)|0}function P_(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=G_(h^a,j^b,h,j)|0;b=J;T_(m,b,G_(k^d,l^e,k,l)|0,J,g)|0;l=G_(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=J;i=f;return(J=j,l)|0}function Q_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=N_(e,a)|0;f=J;return(J=(fa(b,a)|0)+(fa(d,e)|0)+f|f&0,c|0|0)|0}function R_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=T_(a,b,c,d,0)|0;return(J=J,e)|0}function S_(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;T_(a,b,d,e,g)|0;i=f;return(J=c[g+4>>2]|0,c[g>>2]|0)|0}function T_(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(J=n,o)|0}else{if(!m){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(J=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(J=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(J=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((M_(l|0)|0)>>>0);return(J=n,o)|0}p=(L_(l|0)|0)-(L_(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}else{if(!m){r=(L_(l|0)|0)-(L_(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(L_(j|0)|0)+33-(L_(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(J=n,o)|0}else{p=M_(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(J=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=H_(g,d,-1,-1)|0;k=J;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;G_(e,k,j,a)|0;b=J;h=b>>31|((b|0)<0?-1:0)<<1;K=h&1;L=G_(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=J;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=K}}B=H;C=I;D=M;E=L;F=0;G=K}K=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(K|0)>>>31|(B|C)<<1|(C<<1|K>>>31)&0|F;o=(K<<1|0>>>31)&-2|G;return(J=n,o)|0}function U_(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Zd[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function V_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;_d[a&31](b|0,c|0,d|0,e|0,f|0)}function W_(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return $d[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function X_(a,b){a=a|0;b=+b;ae[a&1](+b)}function Y_(a,b){a=a|0;b=b|0;be[a&255](b|0)}function Z_(a,b,c){a=a|0;b=b|0;c=c|0;ce[a&127](b|0,c|0)}function __(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return de[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function $_(a,b){a=a|0;b=b|0;return ee[a&127](b|0)|0}function a$(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;return fe[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0)|0}function b$(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;return ge[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0)|0}function c$(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;return he[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0)|0}function d$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ie[a&63](b|0,c|0,d|0)|0}function e$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;je[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function f$(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ke[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function g$(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return le[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function h$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;me[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function i$(a,b,c){a=a|0;b=b|0;c=+c;return ne[a&1](b|0,+c)|0}function j$(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;oe[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function k$(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;pe[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function l$(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;qe[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function m$(a,b,c){a=a|0;b=b|0;c=c|0;return re[a&63](b|0,c|0)|0}function n$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return se[a&63](b|0,c|0,d|0,e|0,f|0)|0}function o$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return te[a&1](b|0,c|0,d|0,e|0,+f,g|0)|0}function p$(a,b,c){a=a|0;b=b|0;c=c|0;return+ue[a&1](b|0,c|0)}function q$(a){a=a|0;return ve[a&7]()|0}function r$(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return we[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function s$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;xe[a&15](b|0,c|0,d|0)}function t$(a){a=a|0;ye[a&7]()}function u$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;ze[a&3](b|0,c|0,+d,e|0,f|0)}function v$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Ae[a&63](b|0,c|0,d|0,e|0)|0}function w$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Be[a&31](b|0,c|0,d|0,e|0)}function x$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(0);return 0}function y$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(1)}function z$(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ga(2);return 0}function A$(a){a=+a;ga(3)}function B$(a){a=a|0;ga(4)}function C$(a){a=a|0;yd(a|0)}function D$(a,b){a=a|0;b=b|0;ga(5)}function E$(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ga(6);return 0}function F$(a){a=a|0;ga(7);return 0}function G$(a){a=a|0;return Lc(a|0)|0}function H$(a){a=a|0;return Hd(a|0)|0}function I$(a){a=a|0;return sc(a|0)|0}function J$(a){a=a|0;return wd(a|0)|0}function K$(a){a=a|0;return jd(a|0)|0}function L$(a){a=a|0;return qd(a|0)|0}function M$(a){a=a|0;return Vc(a|0)|0}function N$(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;ga(8);return 0}function O$(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;ga(9);return 0}function P$(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;ga(10);return 0}function Q$(a,b,c){a=a|0;b=b|0;c=c|0;ga(11);return 0}function R$(a,b,c){a=a|0;b=b|0;c=c|0;return sd(a|0,b|0,c|0)|0}function S$(a,b,c){a=a|0;b=b|0;c=c|0;return dc(a|0,b|0,c|0)|0}function T$(a,b,c){a=a|0;b=b|0;c=c|0;return Kd(a|0,b|0,c|0)|0}function U$(a,b,c){a=a|0;b=b|0;c=c|0;return xd(a|0,b|0,c|0)|0}function V$(a,b,c){a=a|0;b=b|0;c=c|0;return td(a|0,b|0,c|0)|0}function W$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ga(12)}function X$(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(13)}function Y$(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(14);return 0}function Z$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ga(15)}function _$(a,b){a=a|0;b=+b;ga(16);return 0}function $$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(17)}function a0(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ga(18)}function b0(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(19)}function c0(a,b){a=a|0;b=b|0;ga(20);return 0}function d0(a,b){a=a|0;b=b|0;return Md(a|0,b|0)|0}function e0(a,b){a=a|0;b=b|0;return cc(a|0,b|0)|0}function f0(a,b){a=a|0;b=b|0;return fb(a|0,b|0)|0}function g0(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(21);return 0}function h0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ga(22);return 0}function i0(a,b){a=a|0;b=b|0;ga(23);return 0.0}function j0(){ga(24);return 0}function k0(){return gb()|0}function l0(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(25);return 0}function m0(a,b,c){a=a|0;b=b|0;c=c|0;ga(26)}function n0(){ga(27)}function o0(){Rc()}function p0(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ga(28)}function q0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(29);return 0}function r0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return nc(a|0,b|0,c|0,d|0)|0}function s0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Jc(a|0,b|0,c|0,d|0)|0}function t0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(30)}




// EMSCRIPTEN_END_FUNCS
var Zd=[x$,dy,fy,ky,YM,x$,x$,x$];var _d=[y$,kt,lt,Qt,Rt,tu,uu,Ru,Su,Tu,RZ,QZ,PZ,Es,Fs,hw,fw,y$,y$,y$,y$,y$,y$,y$,y$,y$,y$,y$,y$,y$,y$,y$];var $d=[z$,Dz];var ae=[A$,Ry];var be=[B$,Lg,Mg,Ng,Ih,Wl,Kh,cw,PB,SB,RB,TB,WR,VR,YR,XR,UB,WB,gF,CF,DF,EF,HR,GR,JR,IR,uM,HM,IM,JM,LM,NM,DO,EO,KO,LO,RO,SO,YO,ZO,jP,iP,oP,nP,qP,rP,AP,zP,HQ,GQ,QQ,PQ,sR,rR,QR,PR,SR,RR,iS,hS,kS,jS,qS,pS,FQ,rS,oS,sS,uS,tS,CW,AS,zS,FS,ES,cT,bT,GT,FT,UT,TT,gU,fU,uU,tU,HU,GU,KU,JU,OU,NU,ZU,YU,iV,hV,tV,sV,EV,DV,OV,NV,WV,VV,aW,$V,gW,fW,lW,kW,uW,tW,SW,RW,pW,hX,OX,NX,QX,PX,vS,BW,EW,$W,pX,AX,LX,MX,CZ,BZ,EZ,HZ,FZ,GZ,IZ,JZ,e_,d_,Ig,C$,kf,mf,rf,sf,wf,yf,Cf,Df,If,Kf,Of,Qf,Wf,Xf,cg,eg,fg,jg,lg,rg,sg,ug,yg,zg,Ag,Bg,Dg,WZ,ew,Se,By,Fy,Ay,Gz,Hy,Ez,mx,Ky,Iy,Jy,Gy,My,Fz,Ny,Cy,Py,gM,Qy,bO,CO,DW,wY,GV,DY,CY,BY,AY,zY,yY,QP,sQ,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$,B$];var ce=[D$,Jh,lA,XB,fR,FO,MO,TO,_O,tR,RU,SU,TU,UU,WU,XU,aV,bV,cV,dV,fV,gV,lV,mV,nV,oV,qV,rV,wV,xV,yV,zV,BV,CV,jW,oW,VX,XX,ZX,WX,YX,_X,sy,Og,Pg,Qg,Rg,Sg,Tg,Ug,Vg,Wg,Xg,Yg,Zg,_g,$g,ah,bh,ch,dh,eh,fh,gh,hh,ih,jh,kh,lh,mh,nh,oh,ph,qh,rh,sh,th,uh,vh,wh,xh,yh,zh,Ah,Bh,Ch,Dh,Eh,Fh,Gh,Hh,Ly,OE,nA,mA,oA,uA,GA,pA,EA,bE,nE,mE,oE,YD,WD,_D,kN,D$,D$,D$,D$,D$,D$,D$,D$,D$,D$,D$,D$,D$,D$,D$,D$,D$,D$,D$,D$];var de=[E$,Ts,Ms,ey,gy,hy,iy,jy];var ee=[F$,Fg,oq,Eg,Ue,Ve,We,Xl,Yl,Qh,Vl,nq,qq,Ph,Nh,rq,sq,Jq,Kq,Lq,Mq,Nq,Oq,Pq,Qq,G$,H$,I$,yw,VZ,J$,$B,kR,aC,nR,jR,QM,GO,yR,AR,BR,xR,NO,OO,UO,mR,$O,aP,kP,pP,mS,hU,$X,bY,dY,jY,lY,fY,hY,vU,aY,cY,eY,kY,mY,gY,iY,PU,QU,VU,_U,$U,eV,jV,kV,pV,uV,vV,AV,lX,mX,oX,RX,TX,SX,UX,dX,eX,gX,vX,wX,zX,GX,HX,KX,DZ,f_,Nz,K$,L$,Lz,Mz,M$,$L,zM,Xy,cz,oz,Yy,fz,pz,uO,o_,F$,F$,F$,F$,F$,F$,F$,F$,F$,F$,F$,F$,F$,F$,F$];var fe=[N$,Tx];var ge=[O$,tx];var he=[P$,Xx];var ie=[Q$,Mh,bt,ht,Ht,Nt,ku,qu,YB,lR,pR,gR,uR,zR,HO,DR,VO,uP,vP,yS,DS,hW,mW,UW,WW,ZW,FW,KW,MW,PW,KZ,iM,Qs,Hs,Os,Us,R$,S$,T$,Hz,fM,bM,U$,mO,V$,Q$,Q$,Q$,Q$,Q$,Q$,Q$,Q$,Q$,Q$,Q$,Q$,Q$,Q$,Q$,Q$,Q$,Q$,Q$];var je=[W$,OT,RT,aU,cU,W$,W$,W$];var ke=[X$,IU,LU,FV,JV,PV,RV,X$];var le=[Y$,Tq,iX,jX,aX,bX,qX,sX,BX,DX,Y$,Y$,Y$,Y$,Y$,Y$];var me=[Z$,$v,ZB,OM,vR,hR,HT,IT,MT,ST,VT,WT,_T,dU,iW,nW,UZ,TZ,SZ,aw,Z$,Z$,Z$,Z$,Z$,Z$,Z$,Z$,Z$,Z$,Z$,Z$];var ne=[_$,Hg];var oe=[$$,GS,IS,KS,MS,OS,QS,SS,US,WS,YS,_S,dT,fT,hT,jT,lT,nT,pT,rT,tT,vT,xT,LT,NT,ZT,$T,iU,jU,kU,lU,mU,wU,xU,yU,zU,AU,_V,eW,$$,$$,$$,$$,$$,$$,$$,$$,$$,$$,$$,$$,$$,$$,$$,$$,$$,$$,$$,$$,$$,$$,$$,$$,$$];var pe=[a0,XV,bW,a0];var qe=[b0,nU,BU,b0];var re=[c0,Te,Rh,Oh,Lh,Rq,Sq,dt,et,gt,Jt,Kt,Mt,mu,nu,pu,vu,wu,xu,yu,zu,Au,Bu,Cu,bC,cC,RM,SM,CR,IO,PO,ER,oR,WO,bP,qR,TW,VW,XW,JW,LW,NW,vz,qz,hz,Zy,gz,d0,YZ,Bs,Cs,Ds,e0,Iw,kz,nz,az,f0,nZ,c0,c0,c0,c0,c0];var se=[g0,wS,BS,_W,kX,nX,QW,cX,fX,uX,xX,FX,IX,Zu,Qv,Rv,cv,$u,Ov,Pv,dv,ev,fv,gv,hv,Ev,Fv,vv,ov,jv,iv,kv,lv,nv,mv,av,_u,pv,qv,rv,sv,tv,uv,wv,xv,yv,zv,Dv,Bv,Av,Cv,Kv,Gv,Hv,Iv,Jv,Lv,Mv,Nv,Sv,Tv,Uv,Vv,JT];var te=[h0,Sz];var ue=[i0,Dx];var ve=[j0,Uq,k0,zw,zO,AO,xO,j0];var we=[l0,Wx];var xe=[m0,jM,tP,nS,kw,gA,iA,NE,jN,m0,m0,m0,m0,m0,m0,m0];var ye=[n0,o0,xw,Yv,Kg,n0,n0,n0];var ze=[p0,dz,ez,p0];var Ae=[q0,Xs,Ys,Zs,_s,$s,at,ct,ft,jt,Bt,Ct,Dt,Et,Ft,Gt,It,Lt,Pt,eu,fu,gu,hu,iu,ju,lu,ou,su,YW,GW,HW,IW,OW,uy,r0,Sx,ts,wr,Rr,_r,Mr,hs,ms,ks,ns,Vs,zs,Js,Ks,Rs,Ss,aT,PT,s0,q0,q0,q0,q0,q0,q0,q0,q0,q0,q0];var Be=[t0,it,Ot,ru,_B,PM,wR,iR,xS,CS,LZ,MZ,NZ,iw,gw,wy,jw,EN,Ls,lw,t0,t0,t0,t0,t0,t0,t0,t0,t0,t0,t0,t0];return{_testSetjmp:K_,_saveSetjmp:w_,_free:WZ,_main:Jg,_rand_r:E_,_realloc:YZ,_i64Add:H_,_memmove:A_,_bitshift64Ashr:y_,_memset:B_,_malloc:VZ,_strncpy:I_,_memcpy:z_,_strlen:x_,_bitshift64Lshr:J_,_bitshift64Shl:C_,_i64Subtract:G_,_strcpy:D_,_calloc:XZ,_rand:F_,__GLOBAL__I_a:dP,runPostSets:v_,stackAlloc:Ce,stackSave:De,stackRestore:Ee,setThrew:Fe,setTempRet0:Ie,setTempRet1:Je,setTempRet2:Ke,setTempRet3:Le,setTempRet4:Me,setTempRet5:Ne,setTempRet6:Oe,setTempRet7:Pe,setTempRet8:Qe,setTempRet9:Re,dynCall_iiiiiiii:U_,dynCall_viiiii:V_,dynCall_iiiiidiii:W_,dynCall_vd:X_,dynCall_vi:Y_,dynCall_vii:Z_,dynCall_iiiiiiiiiii:__,dynCall_ii:$_,dynCall_iiiiiiiiiiiiii:a$,dynCall_iiiiiiiiiiiiiiiiiiiii:b$,dynCall_iiiiiiiiiiiiiiiiiiiiiii:c$,dynCall_iiii:d$,dynCall_viiiiid:e$,dynCall_viiiiiiii:f$,dynCall_iiiiiiiii:g$,dynCall_viiiiii:h$,dynCall_iid:i$,dynCall_viiiiiii:j$,dynCall_viiiiiid:k$,dynCall_viiiiiiiii:l$,dynCall_iii:m$,dynCall_iiiiii:n$,dynCall_iiiiidi:o$,dynCall_dii:p$,dynCall_i:q$,dynCall_iiiiiiiiii:r$,dynCall_viii:s$,dynCall_v:t$,dynCall_viidii:u$,dynCall_iiiii:v$,dynCall_viiii:w$}})


// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_viiiii": invoke_viiiii, "invoke_iiiiidiii": invoke_iiiiidiii, "invoke_vd": invoke_vd, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiiiiiii": invoke_iiiiiiiiiii, "invoke_ii": invoke_ii, "invoke_iiiiiiiiiiiiii": invoke_iiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiii, "invoke_iiii": invoke_iiii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_iii": invoke_iii, "invoke_iiiiii": invoke_iiiiii, "invoke_iiiiidi": invoke_iiiiidi, "invoke_dii": invoke_dii, "invoke_i": invoke_i, "invoke_iiiiiiiiii": invoke_iiiiiiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_viidii": invoke_viidii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_fabs": _fabs, "_lis_matrix_assemble": _lis_matrix_assemble, "_strrchr": _strrchr, "_pthread_key_create": _pthread_key_create, "_vsscanf": _vsscanf, "__ZSt9terminatev": __ZSt9terminatev, "___cxa_guard_acquire": ___cxa_guard_acquire, "__reallyNegative": __reallyNegative, "_fstat": _fstat, "_pclose": _pclose, "_lis_solver_create": _lis_solver_create, "___assert_fail": ___assert_fail, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "_longjmp": _longjmp, "_lis_vector_get_values": _lis_vector_get_values, "_clock_gettime": _clock_gettime, "_fsync": _fsync, "_signal": _signal, "_GC_collect_a_little": _GC_collect_a_little, "_sbrk": _sbrk, "_strtoull": _strtoull, "_emscripten_memcpy_big": _emscripten_memcpy_big, "__parseInt64": __parseInt64, "_close": _close, "_rewind": _rewind, "_cos": _cos, "_fileno": _fileno, "_fread": _fread, "_puts": _puts, "_isatty": _isatty, "_lis_matrix_set_value": _lis_matrix_set_value, "_write": _write, "_isblank": _isblank, "_ftell": _ftell, "__ZNSt9exceptionD2Ev": __ZNSt9exceptionD2Ev, "_xerbla_": _xerbla_, "_round": _round, "___cxa_does_inherit": ___cxa_does_inherit, "_strtoll_l": _strtoll_l, "_strstr": _strstr, "___cxa_rethrow": ___cxa_rethrow, "_llvm_lifetime_end": _llvm_lifetime_end, "_catclose": _catclose, "_tmpnam": _tmpnam, "_lis_vector_destroy": _lis_vector_destroy, "_lis_solver_set_option": _lis_solver_set_option, "_tmpfile": _tmpfile, "_send": _send, "_pow": _pow, "_lis_matrix_set_size": _lis_matrix_set_size, "___cxa_free_exception": ___cxa_free_exception, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_isxdigit_l": _isxdigit_l, "___cxa_guard_release": ___cxa_guard_release, "_truncate": _truncate, "_strtol": _strtol, "_sin": _sin, "_strtok": _strtok, "___setErrNo": ___setErrNo, "_newlocale": _newlocale, "_isdigit_l": _isdigit_l, "___resumeException": ___resumeException, "_freelocale": _freelocale, "_srand": _srand, "_qsort": _qsort, "_putchar": _putchar, "_floor": _floor, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_printf": _printf, "_sprintf": _sprintf, "_fopen": _fopen, "_vasprintf": _vasprintf, "_emscripten_get_now": _emscripten_get_now, "_stat": _stat, "_lis_solve": _lis_solve, "_strtoull_l": _strtoull_l, "_mkport": _mkport, "_read": _read, "__addDays": __addDays, "_fwrite": _fwrite, "_time": _time, "_pthread_mutex_lock": _pthread_mutex_lock, "_catopen": _catopen, "_exit": _exit, "_GC_strdup": _GC_strdup, "_freopen": _freopen, "___ctype_b_loc": ___ctype_b_loc, "_fmod": _fmod, "_strtok_r": _strtok_r, "_lseek": _lseek, "_access": _access, "_vfprintf": _vfprintf, "___cxa_allocate_exception": ___cxa_allocate_exception, "_atoi": _atoi, "__isLeapYear": __isLeapYear, "_strtoll": _strtoll, "_pwrite": _pwrite, "_localtime_r": _localtime_r, "_tzset": _tzset, "_open": _open, "_uselocale": _uselocale, "_snprintf": _snprintf, "___errno_location": ___errno_location, "_GC_malloc": _GC_malloc, "___cxa_end_catch": ___cxa_end_catch, "_perror": _perror, "___cxa_begin_catch": ___cxa_begin_catch, "_strftime": _strftime, "_ftruncate": _ftruncate, "_GC_init": _GC_init, "_lis_matrix_set_type": _lis_matrix_set_type, "_fseek": _fseek, "_isxdigit": _isxdigit, "_fclose": _fclose, "_vsnprintf": _vsnprintf, "__parseInt": __parseInt, "_log": _log, "_pthread_cond_broadcast": _pthread_cond_broadcast, "_popen": _popen, "_recv": _recv, "_fgetc": _fgetc, "_sysconf": _sysconf, "__getFloat": __getFloat, "_lis_vector_set_value": _lis_vector_set_value, "_abort": _abort, "_ceil": _ceil, "_isspace": _isspace, "_localtime": _localtime, "_lis_matrix_destroy": _lis_matrix_destroy, "_pthread_getspecific": _pthread_getspecific, "_pthread_cond_wait": _pthread_cond_wait, "_llvm_lifetime_start": _llvm_lifetime_start, "___cxa_is_number_type": ___cxa_is_number_type, "_ungetc": _ungetc, "_system": _system, "_fmax": _fmax, "_fflush": _fflush, "_strftime_l": _strftime_l, "_fprintf": _fprintf, "_sscanf": _sscanf, "_catgets": _catgets, "_lis_solver_destroy": _lis_solver_destroy, "_strdup": _strdup, "_asprintf": _asprintf, "__exit": __exit, "___ctype_toupper_loc": ___ctype_toupper_loc, "_bsearch": _bsearch, "__arraySum": __arraySum, "__formatString": __formatString, "_htonl": _htonl, "___ctype_tolower_loc": ___ctype_tolower_loc, "_unlink": _unlink, "_fputs": _fputs, "_GC_malloc_atomic": _GC_malloc_atomic, "_pread": _pread, "_lis_vector_set_size": _lis_vector_set_size, "_fscanf": _fscanf, "__scanString": __scanString, "_pthread_setspecific": _pthread_setspecific, "_copysign": _copysign, "_fputc": _fputc, "___cxa_throw": ___cxa_throw, "_lis_matrix_create": _lis_matrix_create, "_isdigit": _isdigit, "_strerror": _strerror, "_emscripten_longjmp": _emscripten_longjmp, "_lis_vector_create": _lis_vector_create, "_atexit": _atexit, "_sqrt": _sqrt, "_strerror_r": _strerror_r, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "___rand_seed": ___rand_seed, "NaN": NaN, "Infinity": Infinity, "__ZTISt9exception": __ZTISt9exception, "___dso_handle": ___dso_handle, "_stderr": _stderr, "_stdin": _stdin, "_stdout": _stdout }, buffer);
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _rand_r = Module["_rand_r"] = asm["_rand_r"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _rand = Module["_rand"] = asm["_rand"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_iiiiidiii = Module["dynCall_iiiiidiii"] = asm["dynCall_iiiiidiii"];
var dynCall_vd = Module["dynCall_vd"] = asm["dynCall_vd"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiiiiiii = Module["dynCall_iiiiiiiiiii"] = asm["dynCall_iiiiiiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_iiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiidi = Module["dynCall_iiiiidi"] = asm["dynCall_iiiiidi"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_viidii = Module["dynCall_viidii"] = asm["dynCall_viidii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];

Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };


// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======



// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}






