var Module = {};
var preloadComplete = false;

Module['noInitialRun'] = true;
Module['OpenModelica_readFile'] = function(fname) {
  return intArrayToString(FS.findObject(fname).contents);
};
Module['OpenModelica_readFileBuffer'] = function(fname) {
  return FS.findObject(fname).contents;
};

try { // Try to add an event listener like a webworker thread
  self.addEventListener('message', function(e) {
    var data = e.data;
    if (!data) return;
    if (data.preload) {
      var error = function() {console.log('error...'); /* self.postError({message: "Preload failed"}); */ };
      if (!preloadComplete) {
        FS.createPreloadedFile('/', data.basename + "_init.xml", data.basename + "_init.xml", true, false, function() {
        FS.createLazyFile('/', data.basename + "_info.xml", data.basename + "_info.xml", true, false);
        preloadComplete = true;
        self.postMessage({preloaded:true});
      }, error);
      } else {
        self.postMessage({preloaded:true});
      }
      return;
    }
    var result = {};
    result.status = "Simulation failed"
    try {
      shouldRunNow = true;
      var args = ['-override','outputFormat=csv,stopTime=' +  data.stopTime +',tolerance=' + data.tolerance + ',stepSize=' + data.stepSize];
      Module.callMain(args);
      result.csv = intArrayToString(FS.findObject(data.basename + "_res.csv").contents);
      result.status = "Simulation finished";

  } catch(e) {
  }
  self.postMessage(result);
  }, false);
} catch (e) {
}

// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 536870912;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===
var __ZTVN10__cxxabiv117__class_type_infoE = 110544;
var __ZTVN10__cxxabiv120__si_class_type_infoE = 110584;




STATIC_BASE = 8;

STATICTOP = STATIC_BASE + Runtime.alignMemory(111411);
/* global initializers */ __ATINIT__.push({ func: function() { __GLOBAL__I_a() } });


/* memory initializer */ allocate([0,0,0,0,0,0,0,0,95,112,114,111,102,46,100,97,116,97,0,0,0,0,0,0,119,98,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,111,112,101,110,101,100,58,32,37,115,0,0,0,0,0,0,0,0,111,102,102,115,101,116,32,118,97,108,117,101,32,102,111,114,32,116,104,101,32,110,101,120,116,32,115,116,101,112,58,32,37,46,49,48,102,0,0,0,99,97,108,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,32,40,115,116,101,112,83,105,122,101,58,32,37,103,41,0,0,0,0,0,0,0,0,82,117,110,110,105,110,103,0,37,115,32,101,118,101,110,116,32,97,116,32,116,105,109,101,32,37,46,49,50,103,0,0,116,105,109,101,0,0,0,0,115,116,97,116,101,0,0,0,68,105,115,97,98,108,101,100,32,116,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,98,101,99,97,117,115,101,32,116,104,101,32,111,117,116,112,117,116,32,102,105,108,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,103,101,110,101,114,97,116,101,100,58,32,37,115,0,0,0,83,105,109,117,108,97,116,105,111,110,32,99,97,108,108,32,116,101,114,109,105,110,97,116,101,40,41,32,97,116,32,116,105,109,101,32,37,102,10,77,101,115,115,97,103,101,32,58,32,37,115,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,73,110,116,101,103,114,97,116,111,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,109,105,120,101,100,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,112,114,111,98,97,98,108,121,32,97,32,115,116,114,111,110,103,32,99,111,109,112,111,110,101,110,116,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,102,108,97,103,115,32,45,108,118,32,76,79,71,95,78,76,83,44,32,76,79,71,95,76,83,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,1,0,0,0,74,0,0,0,112,117,108,115,101,67,117,114,114,101,110,116,46,115,105,103,110,97,108,83,111,117,114,99,101,46,112,101,114,105,111,100,0,0,0,0,0,0,0,0,1,0,0,0,100,0,0,0,105,102,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,118,67,111,110,116,111,116,32,45,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,118,67,111,110,116,114,111,108,32,62,32,48,46,48,32,116,104,101,110,32,49,46,56,55,32,42,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,84,79,78,32,101,108,115,101,32,48,46,54,51,56,32,42,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,84,79,70,70,0,0,0,1,0,0,0,105,0,0,0,105,102,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,118,67,111,110,116,111,116,32,45,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,118,67,111,110,116,114,111,108,32,62,32,48,46,48,32,116,104,101,110,32,49,46,56,55,32,42,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,84,79,78,32,101,108,115,101,32,48,46,54,51,56,32,42,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,84,79,70,70,0,0,0,0,0,0,0,1,0,0,0,113,0,0,0,76,46,76,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,65,110,97,108,111,103,47,66,97,115,105,99,46,109,111,0,232,4,0,0,74,0,0,0,3,0,0,0,74,0,0,0,108,0,0,0,0,0,0,0,84,101,109,112,101,114,97,116,117,114,101,32,111,117,116,115,105,100,101,32,115,99,111,112,101,32,111,102,32,109,111,100,101,108,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,1,0,0,0,3,0,0,0,13,0,0,0,4,0,0,0,14,0,0,0,6,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,69,114,114,111,114,32,119,104,105,108,101,32,105,110,105,116,105,97,108,105,122,101,32,68,97,116,97,0,0,0,0,0,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,65,110,97,108,111,103,46,69,120,97,109,112,108,101,115,46,83,105,109,112,108,101,84,114,105,97,99,67,105,114,99,117,105,116,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,65,110,97,108,111,103,47,69,120,97,109,112,108,101,115,0,123,56,99,52,101,56,49,48,102,45,51,100,102,51,45,52,97,48,48,45,56,50,55,54,45,49,55,54,102,97,51,99,57,102,57,101,48,125,0,0,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,65,110,97,108,111,103,46,69,120,97,109,112,108,101,115,46,83,105,109,112,108,101,84,114,105,97,99,67,105,114,99,117,105,116,95,105,110,102,111,46,120,109,108,0,83,116,97,99,107,32,111,118,101,114,102,108,111,119,32,100,101,116,101,99,116,101,100,32,97,110,100,32,119,97,115,32,110,111,116,32,99,97,117,103,104,116,46,10,83,101,110,100,32,117,115,32,97,32,98,117,103,32,114,101,112,111,114,116,32,97,116,32,104,116,116,112,115,58,47,47,116,114,97,99,46,111,112,101,110,109,111,100,101,108,105,99,97,46,111,114,103,47,79,112,101,110,77,111,100,101,108,105,99,97,47,110,101,119,116,105,99,107,101,116,10,32,32,32,32,73,110,99,108,117,100,101,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,116,114,97,99,101,58,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,34,0,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,86,116,32,42,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,78,98,118,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,82,111,102,102,0,0,0,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,86,111,110,32,45,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,86,111,102,102,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,82,111,110,32,42,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,82,111,102,102,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,115,113,114,116,40,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,82,111,110,32,42,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,82,111,102,102,41,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,82,111,110,0,0,0,0,0,0,1,0,0,0,35,0,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,86,116,32,42,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,78,98,118,0,0,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,82,111,102,102,0,0,0,0,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,86,111,110,32,45,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,86,111,102,102,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,82,111,110,32,42,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,82,111,102,102,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,115,113,114,116,40,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,82,111,110,32,42,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,82,111,102,102,41,0,0,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,82,111,110,0,0,0,0,0,0,0,1,0,0,0,48,0,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,73,71,84,0,0,0,0,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,86,71,84,0,0,0,0,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,73,71,84,0,0,0,0,0,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,86,71,84,0,0,0,0,0,0,0,1,0,0,0,81,0,0,0,1,0,0,0,83,0,0,0,104,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,94,0,0,0,48,12,0,0,80,12,0,0,112,12,0,0,144,12,0,0,216,12,0,0,80,13,0,0,152,13,0,0,24,14,0,0,112,14,0,0,192,14,0,0,64,15,0,0,0,0,0,0,116,105,109,101,32,60,32,86,46,115,105,103,110,97,108,83,111,117,114,99,101,46,115,116,97,114,116,84,105,109,101,0,115,105,109,112,108,101,84,114,105,97,99,46,105,100,101,97,108,68,105,111,100,101,46,115,32,60,32,48,46,48,0,0,115,105,109,112,108,101,84,114,105,97,99,46,105,100,101,97,108,68,105,111,100,101,49,46,115,32,60,32,48,46,48,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,118,67,111,110,116,111,116,32,45,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,118,67,111,110,116,114,111,108,32,62,32,48,46,48,0,0,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,65,110,111,100,101,46,105,32,62,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,73,72,32,111,114,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,118,65,75,32,62,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,86,68,82,77,0,0,0,0,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,118,67,111,110,116,111,116,32,45,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,118,67,111,110,116,114,111,108,32,62,32,48,46,48,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,65,110,111,100,101,46,105,32,62,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,73,72,32,111,114,32,40,45,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,118,65,75,41,32,62,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,86,68,82,77,0,0,0,0,0,0,0,0,116,105,109,101,32,60,32,112,117,108,115,101,67,117,114,114,101,110,116,46,115,105,103,110,97,108,83,111,117,114,99,101,46,115,116,97,114,116,84,105,109,101,32,111,114,32,112,117,108,115,101,67,117,114,114,101,110,116,46,115,105,103,110,97,108,83,111,117,114,99,101,46,110,112,101,114,105,111,100,32,61,61,32,48,0,0,0,0,116,105,109,101,32,60,32,112,117,108,115,101,67,117,114,114,101,110,116,46,115,105,103,110,97,108,83,111,117,114,99,101,46,84,95,115,116,97,114,116,32,43,32,112,117,108,115,101,67,117,114,114,101,110,116,46,115,105,103,110,97,108,83,111,117,114,99,101,46,84,95,119,105,100,116,104,0,0,0,0,105,110,116,101,103,101,114,40,40,116,105,109,101,32,45,32,112,117,108,115,101,67,117,114,114,101,110,116,46,115,105,103,110,97,108,83,111,117,114,99,101,46,115,116,97,114,116,84,105,109,101,41,32,47,32,112,117,108,115,101,67,117,114,114,101,110,116,46,115,105,103,110,97,108,83,111,117,114,99,101,46,112,101,114,105,111,100,41,32,62,32,112,114,101,40,112,117,108,115,101,67,117,114,114,101,110,116,46,115,105,103,110,97,108,83,111,117,114,99,101,46,99,111,117,110,116,41,0,105,110,116,101,103,101,114,40,40,116,105,109,101,32,45,32,112,117,108,115,101,67,117,114,114,101,110,116,46,115,105,103,110,97,108,83,111,117,114,99,101,46,115,116,97,114,116,84,105,109,101,41,32,47,32,112,117,108,115,101,67,117,114,114,101,110,116,46,115,105,103,110,97,108,83,111,117,114,99,101,46,112,101,114,105,111,100,44,32,48,41,0,0,0,0,0,1,0,0,0,108,0,0,0,1,0,0,0,255,255,255,255,1,0,0,0,255,255,255,255,1,0,0,0,100,0,0,0,1,0,0,0,98,0,0,0,1,0,0,0,105,0,0,0,1,0,0,0,101,0,0,0,1,0,0,0,77,0,0,0,1,0,0,0,77,0,0,0,1,0,0,0,74,0,0,0,1,0,0,0,74,0,0,0,160,15,0,0,168,15,0,0,176,15,0,0,184,15,0,0,192,15,0,0,200,15,0,0,208,15,0,0,216,15,0,0,224,15,0,0,232,15,0,0,240,15,0,0,0,0,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,65,110,111,100,101,46,105,32,62,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,73,72,0,0,0,0,0,0,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,118,65,75,32,62,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,86,68,82,77,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,65,110,111,100,101,46,105,32,62,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,73,72,0,0,0,0,0,0,40,45,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,118,65,75,41,32,62,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,86,68,82,77,0,0,0,0,0,0,116,105,109,101,32,60,32,112,117,108,115,101,67,117,114,114,101,110,116,46,115,105,103,110,97,108,83,111,117,114,99,101,46,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,48,12,0,0,80,12,0,0,112,12,0,0,144,12,0,0,40,16,0,0,104,16,0,0,80,13,0,0,160,16,0,0,224,16,0,0,32,17,0,0,112,14,0,0,192,14,0,0,99,104,101,99,107,32,102,111,114,32,100,105,115,99,114,101,116,101,32,99,104,97,110,103,101,115,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,49,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,115,105,109,112,108,101,84,114,105,97,99,46,95,105,100,101,97,108,68,105,111,100,101,46,95,111,102,102,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,115,105,109,112,108,101,84,114,105,97,99,46,95,105,100,101,97,108,68,105,111,100,101,49,46,95,111,102,102,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,112,117,108,115,101,67,117,114,114,101,110,116,46,95,115,105,103,110,97,108,83,111,117,114,99,101,46,95,84,95,115,116,97,114,116,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,112,117,108,115,101,67,117,114,114,101,110,116,46,95,115,105,103,110,97,108,83,111,117,114,99,101,46,95,99,111,117,110,116,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,118,67,111,110,116,114,111,108,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,118,67,111,110,116,114,111,108,0,112,117,108,115,101,67,117,114,114,101,110,116,46,115,105,103,110,97,108,83,111,117,114,99,101,46,99,111,117,110,116,32,45,32,36,84,77,80,95,112,117,108,115,101,67,117,114,114,101,110,116,36,80,115,105,103,110,97,108,83,111,117,114,99,101,36,80,99,111,117,110,116,95,54,57,0,0,0,0,0,112,117,108,115,101,67,117,114,114,101,110,116,46,115,105,103,110,97,108,83,111,117,114,99,101,46,84,95,115,116,97,114,116,32,45,32,36,84,77,80,95,112,117,108,115,101,67,117,114,114,101,110,116,36,80,115,105,103,110,97,108,83,111,117,114,99,101,36,80,84,95,115,116,97,114,116,95,54,57,0,248,18,0,0,24,19,0,0,56,19,0,0,136,19,0,0,117,112,100,97,116,105,110,103,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,91,37,100,93,58,32,37,115,32,61,32,37,103,0,0,0,1,0,0,0,6,0,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,73,84,77,0,0,0,0,0,0,1,0,0,0,9,0,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,73,72,32,42,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,86,84,77,0,0,1,0,0,0,10,0,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,73,84,77,0,0,0,0,0,0,0,1,0,0,0,13,0,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,73,72,32,42,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,86,84,77,0,0,0,0,1,0,0,0,51,0,0,0,105,102,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,118,67,111,110,116,111,116,32,45,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,118,67,111,110,116,114,111,108,32,62,32,48,46,48,32,116,104,101,110,32,49,46,56,55,32,42,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,84,79,78,32,101,108,115,101,32,48,46,54,51,56,32,42,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,84,79,70,70,0,0,0,0,0,0,0,1,0,0,0,54,0,0,0,76,46,76,0,0,0,0,0,1,0,0,0,57,0,0,0,105,102,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,118,67,111,110,116,111,116,32,45,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,118,67,111,110,116,114,111,108,32,62,32,48,46,48,32,116,104,101,110,32,49,46,56,55,32,42,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,84,79,78,32,101,108,115,101,32,48,46,54,51,56,32,42,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,84,79,70,70,0,0,0,1,0,0,0,65,0,0,0,112,117,108,115,101,67,117,114,114,101,110,116,46,115,105,103,110,97,108,83,111,117,114,99,101,46,112,101,114,105,111,100,0,0,0,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,105,110,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,97,120,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,110,111,109,105,110,97,108,45,118,97,108,117,101,115,0,117,112,100,97,116,105,110,103,32,115,116,97,114,116,45,118,97,108,117,101,115,0,0,0,1,0,0,0,126,0,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,73,72,32,42,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,86,84,77,0,0,0,0,1,0,0,0,127,0,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,73,84,77,0,0,0,0,0,0,0,1,0,0,0,131,0,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,73,72,32,42,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,86,84,77,0,0,1,0,0,0,132,0,0,0,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,73,84,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,108,115,101,67,117,114,114,101,110,116,46,115,105,103,110,97,108,83,111,117,114,99,101,46,112,101,114,105,111,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,108,115,101,67,117,114,114,101,110,116,46,115,105,103,110,97,108,83,111,117,114,99,101,46,112,101,114,105,111,100,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,66,108,111,99,107,115,47,83,111,117,114,99,101,115,46,109,111,0,0,48,24,0,0,24,4,0,0,5,0,0,0,25,4,0,0,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,108,115,101,67,117,114,114,101,110,116,46,115,105,103,110,97,108,83,111,117,114,99,101,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,108,115,101,67,117,114,114,101,110,116,46,115,105,103,110,97,108,83,111,117,114,99,101,46,119,105,100,116,104,32,62,61,32,49,101,45,54,48,32,97,110,100,32,112,117,108,115,101,67,117,114,114,101,110,116,46,115,105,103,110,97,108,83,111,117,114,99,101,46,119,105,100,116,104,32,60,61,32,49,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,48,24,0,0,21,4,0,0,5,0,0,0,23,4,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,108,115,101,67,117,114,114,101,110,116,46,112,101,114,105,111,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,108,115,101,67,117,114,114,101,110,116,46,112,101,114,105,111,100,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,65,110,97,108,111,103,47,83,111,117,114,99,101,115,46,109,111,0,0,0,0,0,0,0,200,25,0,0,166,8,0,0,5,0,0,0,167,8,0,0,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,108,115,101,67,117,114,114,101,110,116,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,108,115,101,67,117,114,114,101,110,116,46,119,105,100,116,104,32,62,61,32,49,101,45,54,48,32,97,110,100,32,112,117,108,115,101,67,117,114,114,101,110,116,46,119,105,100,116,104,32,60,61,32,49,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,200,25,0,0,163,8,0,0,5,0,0,0,165,8,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,86,82,82,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,86,82,82,77,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,65,110,97,108,111,103,47,83,101,109,105,99,111,110,100,117,99,116,111,114,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,86,68,82,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,86,68,82,77,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,65,110,97,108,111,103,47,73,110,116,101,114,102,97,99,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,86,82,82,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,86,82,82,77,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,80,27,0,0,242,5,0,0,5,0,0,0,243,5,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,86,68,82,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,86,68,82,77,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,80,27,0,0,240,5,0,0,5,0,0,0,241,5,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,84,114,105,97,99,46,116,104,121,114,105,115,116,111,114,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,84,114,105,97,99,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,84,114,105,97,99,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,80,27,0,0,211,6,0,0,3,0,0,0,212,6,0,0,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,84,114,105,97,99,46,105,100,101,97,108,68,105,111,100,101,49,46,86,107,110,101,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,84,114,105,97,99,46,105,100,101,97,108,68,105,111,100,101,49,46,86,107,110,101,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,65,110,97,108,111,103,47,73,100,101,97,108,46,109,111,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,84,114,105,97,99,46,105,100,101,97,108,68,105,111,100,101,49,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,84,114,105,97,99,46,105,100,101,97,108,68,105,111,100,101,49,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,84,114,105,97,99,46,105,100,101,97,108,68,105,111,100,101,49,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,84,114,105,97,99,46,105,100,101,97,108,68,105,111,100,101,49,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,84,114,105,97,99,46,105,100,101,97,108,68,105,111,100,101,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,84,114,105,97,99,46,105,100,101,97,108,68,105,111,100,101,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,84,114,105,97,99,46,105,100,101,97,108,68,105,111,100,101,46,86,107,110,101,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,84,114,105,97,99,46,105,100,101,97,108,68,105,111,100,101,46,86,107,110,101,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,128,31,0,0,19,4,0,0,11,0,0,0,20,4,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,84,114,105,97,99,46,105,100,101,97,108,68,105,111,100,101,46,71,111,102,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,84,114,105,97,99,46,105,100,101,97,108,68,105,111,100,101,46,71,111,102,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,128,31,0,0,17,4,0,0,11,0,0,0,18,4,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,84,114,105,97,99,46,105,100,101,97,108,68,105,111,100,101,46,82,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,84,114,105,97,99,46,105,100,101,97,108,68,105,111,100,101,46,82,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,128,31,0,0,15,4,0,0,11,0,0,0,16,4,0,0,75,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,84,114,105,97,99,46,105,100,101,97,108,68,105,111,100,101,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,84,114,105,97,99,46,105,100,101,97,108,68,105,111,100,101,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,84,114,105,97,99,46,86,82,82,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,84,114,105,97,99,46,86,82,82,77,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,80,27,0,0,171,6,0,0,5,0,0,0,172,6,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,84,114,105,97,99,46,86,68,82,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,84,114,105,97,99,46,86,68,82,77,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,80,27,0,0,169,6,0,0,5,0,0,0,170,6,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,160,28,0,0,50,1,0,0,5,0,0,0,51,1,0,0,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,82,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,82,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,65,110,97,108,111,103,47,66,97,115,105,99,46,109,111,0,32,37,0,0,64,0,0,0,3,0,0,0,64,0,0,0,78,0,0,0,0,0,0,0,109,111,100,101,108,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,69,108,101,99,116,114,105,99,97,108,95,65,110,97,108,111,103,95,69,120,97,109,112,108,101,115,95,83,105,109,112,108,101,84,114,105,97,99,67,105,114,99,117,105,116,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,110,32,61,32,51,59,32,47,47,32,115,116,97,116,101,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,107,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,105,110,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,108,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,111,117,116,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,120,48,91,51,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,117,48,91,48,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,65,91,51,44,51,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,66,91,51,44,48,93,32,61,32,122,101,114,111,115,40,51,44,48,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,67,91,48,44,51,93,32,61,32,122,101,114,111,115,40,48,44,51,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,68,91,48,44,48,93,32,61,32,122,101,114,111,115,40,48,44,48,41,59,37,115,10,32,32,82,101,97,108,32,120,91,51,93,40,115,116,97,114,116,61,120,48,41,59,10,32,32,105,110,112,117,116,32,82,101,97,108,32,117,91,48,93,59,10,32,32,111,117,116,112,117,116,32,82,101,97,108,32,121,91,48,93,59,10,10,32,32,82,101,97,108,32,120,95,80,115,105,109,112,108,101,84,114,105,97,99,80,116,104,121,114,105,115,116,111,114,49,80,118,67,111,110,116,114,111,108,32,61,32,120,91,49,93,59,10,32,32,82,101,97,108,32,120,95,80,115,105,109,112,108,101,84,114,105,97,99,80,116,104,121,114,105,115,116,111,114,80,118,67,111,110,116,114,111,108,32,61,32,120,91,50,93,59,10,32,32,82,101,97,108,32,120,95,80,76,80,105,32,61,32,120,91,51,93,59,10,32,32,32,32,32,32,10,101,113,117,97,116,105,111,110,10,32,32,100,101,114,40,120,41,32,61,32,65,32,42,32,120,32,43,32,66,32,42,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
/* memory initializer */ allocate([117,59,10,32,32,121,32,61,32,67,32,42,32,120,32,43,32,68,32,42,32,117,59,10,101,110,100,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,69,108,101,99,116,114,105,99,97,108,95,65,110,97,108,111,103,95,69,120,97,109,112,108,101,115,95,83,105,109,112,108,101,84,114,105,97,99,67,105,114,99,117,105,116,59,10,0,0,0,0,0,68,71,69,82,32,32,0,0,78,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,68,71,69,77,77,32,0,0,76,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,84,82,83,77,32,0,0,68,71,69,83,86,32,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,68,71,69,84,70,50,0,0,83,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,68,71,69,84,82,70,0,0,1,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,191,78,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,71,69,84,82,83,0,0,1,0,0,0,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,85,112,112,101,114,0,0,0,78,111,110,45,117,110,105,116,0,0,0,0,0,0,0,0,84,114,97,110,115,112,111,115,101,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,71,69,0,0,0,0,0,0,84,82,70,0,0,0,0,0,81,82,70,0,0,0,0,0,82,81,70,0,0,0,0,0,76,81,70,0,0,0,0,0,81,76,70,0,0,0,0,0,72,82,68,0,0,0,0,0,66,82,68,0,0,0,0,0,84,82,73,0,0,0,0,0,80,79,0,0,0,0,0,0,83,89,0,0,0,0,0,0,84,82,68,0,0,0,0,0,71,83,84,0,0,0,0,0,72,69,0,0,0,0,0,0,79,82,0,0,0,0,0,0,81,82,0,0,0,0,0,0,82,81,0,0,0,0,0,0,76,81,0,0,0,0,0,0,81,76,0,0,0,0,0,0,72,82,0,0,0,0,0,0,84,82,0,0,0,0,0,0,66,82,0,0,0,0,0,0,85,78,0,0,0,0,0,0,71,66,0,0,0,0,0,0,80,66,0,0,0,0,0,0,76,65,0,0,0,0,0,0,85,85,77,0,0,0,0,0,83,84,0,0,0,0,0,0,69,66,90,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,43,0,0,160,43,0,0,176,43,0,0,200,43,0,0,232,43,0,0,248,43,0,0,16,44,0,0,32,44,0,0,56,44,0,0,88,44,0,0,128,44,0,0,152,44,0,0,184,44,0,0,208,44,0,0,248,44,0,0,24,45,0,0,72,45,0,0,120,45,0,0,144,45,0,0,200,45,0,0,224,45,0,0,16,46,0,0,48,46,0,0,104,46,0,0,144,46,0,0,200,46,0,0,248,46,0,0,8,47,0,0,40,47,0,0,80,47,0,0,112,47,0,0,152,47,0,0,192,47,0,0,216,47,0,0,240,47,0,0,0,48,0,0,24,48,0,0,72,48,0,0,152,48,0,0,216,48,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,115,121,110,116,97,120,32,101,114,114,111,114,0,0,0,0,110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0,0,0,0,0,0,0,0,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0,117,110,99,108,111,115,101,100,32,116,111,107,101,110,0,0,112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,109,105,115,109,97,116,99,104,101,100,32,116,97,103,0,0,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0,0,0,0,0,0,0,0,114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0,0,101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0,0,0,0,0,0,101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0,0,0,0,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0,0,0,0,117,110,98,111,117,110,100,32,112,114,101,102,105,120,0,0,109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0,0,0,0,0,0,0,105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0,0,0,0,0,0,0,112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0,0,0,0,0,0,0,0,112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0,0,0,0,112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0,112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0,0,0,0,0,0,112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,35,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,89,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,40,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,4,254,255,255,135,254,255,255,7,0,0,0,0,0,0,0,0,255,255,127,255,255,255,127,255,255,255,255,255,255,255,243,127,254,253,255,255,255,255,255,127,255,255,255,255,255,255,255,255,15,224,255,255,255,255,49,252,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,3,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,0,0,0,0,0,0,0,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,254,7,0,0,0,0,254,255,255,255,255,255,255,255,255,124,255,127,47,0,96,0,0,0,224,255,255,255,255,255,255,35,0,0,0,255,3,0,0,0,224,159,249,255,255,253,197,3,0,0,0,176,3,0,3,0,224,135,249,255,255,253,109,3,0,0,0,94,0,0,28,0,224,175,251,255,255,253,237,35,0,0,0,0,1,0,0,0,224,159,249,255,255,253,205,35,0,0,0,176,3,0,0,0,224,199,61,214,24,199,191,3,0,0,0,0,0,0,0,0,224,223,253,255,255,253,239,3,0,0,0,0,3,0,0,0,224,223,253,255,255,253,239,3,0,0,0,64,3,0,0,0,224,223,253,255,255,253,255,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,13,0,63,0,0,0,0,0,0,0,150,37,240,254,174,108,13,32,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,254,255,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,63,0,255,255,255,255,127,0,237,218,7,0,0,0,0,80,1,80,49,130,171,98,44,0,0,0,0,64,0,201,128,245,7,0,0,0,0,8,1,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,3,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,64,76,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,254,3,0,0,254,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,7,224,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,7,254,255,255,135,254,255,255,7,0,0,0,0,0,0,128,0,255,255,127,255,255,255,127,255,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,3,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,3,0,0,0,192,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,123,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,254,255,251,255,255,187,22,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,255,255,7,0,255,3,255,255,255,255,255,255,255,255,255,124,255,127,239,255,255,61,255,3,238,255,255,255,255,255,255,243,255,63,30,255,207,255,0,0,238,159,249,255,255,253,197,211,159,57,128,176,207,255,3,0,228,135,249,255,255,253,109,211,135,57,0,94,192,255,31,0,238,175,251,255,255,253,237,243,191,59,0,0,193,255,0,0,238,159,249,255,255,253,205,243,143,57,192,176,195,255,0,0,236,199,61,214,24,199,191,195,199,61,128,0,128,255,0,0,238,223,253,255,255,253,239,195,223,61,96,0,195,255,0,0,236,223,253,255,255,253,239,195,223,61,96,64,195,255,0,0,236,223,253,255,255,253,255,195,207,61,128,0,195,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,255,7,255,127,255,3,0,0,0,0,150,37,240,254,174,108,255,59,95,63,255,3,0,0,0,0,0,0,0,3,255,3,160,194,255,254,255,255,255,3,254,255,223,15,191,254,255,63,254,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,31,2,0,0,0,160,0,0,0,254,255,62,0,254,255,255,255,255,255,255,255,255,255,31,102,254,255,255,255,255,255,255,255,255,255,255,119,25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,8,63,0,0,152,61,0,0,32,60,0,0,168,58,0,0,168,58,0,0,48,57,0,0,32,60,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,208,73,0,0,88,70,0,0,232,68,0,0,120,67,0,0,120,67,0,0,8,66,0,0,232,68,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,101,114,115,105,111,110,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,121,101,115,0,0,0,0,0,110,111,0,0,0,0,0,0,24,72,0,0,40,72,0,0,56,72,0,0,8,57,0,0,64,72,0,0,80,72,0,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,65,84,84,76,73,83,84,0,69,76,69,77,69,78,84,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,69,77,80,84,89,0,0,0,65,78,89,0,0,0,0,0,80,67,68,65,84,65,0,0,176,75,0,0,184,75,0,0,192,75,0,0,200,75,0,0,64,75,0,0,208,75,0,0,224,75,0,0,232,75,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,73,77,80,76,73,69,68,0,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,0,70,73,88,69,68,0,0,0,78,68,65,84,65,0,0,0,73,78,67,76,85,68,69,0,73,71,78,79,82,69,0,0,68,79,67,84,89,80,69,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,76,79,71,95,85,78,75,78,79,87,78,0,0,0,0,0,115,116,100,111,117,116,0,0,97,115,115,101,114,116,0,0,76,79,71,95,68,68,65,83,82,84,0,0,0,0,0,0,76,79,71,95,68,69,66,85,71,0,0,0,0,0,0,0,76,79,71,95,68,83,83,0,76,79,71,95,68,83,83,95,74,65,67,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,0,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,95,86,0,0,0,0,76,79,71,95,73,78,73,84,0,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,95,70,85,76,76,0,0,76,79,71,95,73,80,79,80,84,95,74,65,67,0,0,0,76,79,71,95,73,80,79,80,84,95,72,69,83,83,69,0,76,79,71,95,74,65,67,0,76,79,71,95,76,83,0,0,76,79,71,95,76,83,95,86,0,0,0,0,0,0,0,0,76,79,71,95,78,76,83,0,76,79,71,95,78,76,83,95,86,0,0,0,0,0,0,0,76,79,71,95,78,76,83,95,74,65,67,0,0,0,0,0,76,79,71,95,78,76,83,95,82,69,83,0,0,0,0,0,76,79,71,95,82,69,83,95,73,78,73,84,0,0,0,0,76,79,71,95,83,73,77,85,76,65,84,73,79,78,0,0,76,79,71,95,83,79,76,86,69,82,0,0,0,0,0,0,76,79,71,95,83,79,84,73,0,0,0,0,0,0,0,0,76,79,71,95,83,84,65,84,83,0,0,0,0,0,0,0,76,79,71,95,85,84,73,76,0,0,0,0,0,0,0,0,76,79,71,95,90,69,82,79,67,82,79,83,83,73,78,71,83,0,0,0,0,0,0,0,72,76,0,0,88,76,0,0,96,76,0,0,104,76,0,0,120,76,0,0,136,76,0,0,144,76,0,0,160,76,0,0,176,76,0,0,192,76,0,0,208,76,0,0,224,76,0,0,240,76,0,0,0,77,0,0,16,77,0,0,24,77,0,0,32,77,0,0,48,77,0,0,56,77,0,0,72,77,0,0,88,77,0,0,104,77,0,0,120,77,0,0,136,77,0,0,152,77,0,0,168,77,0,0,184,77,0,0,200,77,0,0,117,110,107,110,111,119,110,0,116,104,105,115,32,115,116,114,101,97,109,32,105,115,32,97,108,119,97,121,115,32,97,99,116,105,118,101,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,97,115,115,108,32,115,111,108,118,101,114,0,0,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,100,101,98,117,103,32,105,110,102,111,114,109,97,116,105,111,110,0,0,0,0,111,117,116,112,117,116,115,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,106,97,99,111,98,105,97,110,32,111,102,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,101,118,101,110,116,32,115,121,115,116,101,109,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,0,0,0,99,104,101,99,107,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+10240);
/* memory initializer */ allocate([0,0,0,0,0,0,0,0,99,104,101,99,107,32,104,101,115,115,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,117,115,101,100,32,98,121,32,100,97,115,115,108,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,101,118,101,114,121,32,101,118,97,108,117,97,116,105,111,110,32,111,102,32,116,104,101,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,114,101,115,105,100,117,97,108,115,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,105,109,117,108,97,116,105,111,110,32,112,114,111,99,101,115,115,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,111,108,118,101,114,32,112,114,111,99,101,115,115,0,0,0,0,0,102,105,110,97,108,32,115,111,108,117,116,105,111,110,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,115,116,97,116,105,115,116,105,99,115,32,97,98,111,117,116,32,116,105,109,101,114,47,101,118,101,110,116,115,47,115,111,108,118,101,114,0,63,63,63,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,116,104,101,32,122,101,114,111,99,114,111,115,115,105,110,103,115,0,0,80,78,0,0,88,78,0,0,88,78,0,0,120,78,0,0,168,78,0,0,200,78,0,0,0,79,0,0,48,79,0,0,96,79,0,0,128,79,0,0,176,79,0,0,200,79,0,0,232,79,0,0,16,80,0,0,48,80,0,0,96,80,0,0,128,80,0,0,168,80,0,0,200,80,0,0,240,80,0,0,32,81,0,0,88,81,0,0,128,81,0,0,176,81,0,0,224,81,0,0,8,82,0,0,56,82,0,0,64,82,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91,37,115,58,37,100,58,37,100,45,37,100,58,37,100,58,37,115,93,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,37,45,49,55,115,32,124,32,0,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,37,45,55,115,32,124,32,0,80,78,0,0,64,85,0,0,72,85,0,0,80,85,0,0,96,76,0,0,88,85,0,0,124,32,0,0,0,0,0,0,60,109,101,115,115,97,103,101,32,115,116,114,101,97,109,61,34,37,115,34,32,116,121,112,101,61,34,37,115,34,32,116,101,120,116,61,34,0,0,0,34,62,10,0,0,0,0,0,60,117,115,101,100,32,105,110,100,101,120,61,34,37,100,34,32,47,62,10,0,0,0,0,60,47,109,101,115,115,97,103,101,62,10,0,0,0,0,0,34,32,47,62,10,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,38,97,109,112,59,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,105,110,102,111,0,0,0,0,119,97,114,110,105,110,103,0,101,114,114,111,114,0,0,0,100,101,98,117,103,0,0,0,34,62,0,0,0,0,0,0,115,111,108,118,101,114,32,119,105,108,108,32,116,114,121,32,116,111,32,104,97,110,100,108,101,32,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,58,32,37,115,0,0,0,0,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,44,32,100,105,118,105,115,111,114,58,32,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,101,109,112,116,121,32,108,105,115,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,102,105,115,116,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,110,111,100,101,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,100,97,116,97,32,110,111,100,101,0,0,0,0,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,27,0,0,0,2,0,0,0,2,0,0,0,28,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,105,110,84,114,97,110,115,0,0,0,0,0,0,0,0,176,86,0,0,0,0,0,0,98,105,110,78,111,114,109,97,108,0,0,0,0,0,0,0,200,86,0,0,0,0,0,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,100,97,116,97,95,50,0,0,224,86,0,0,232,86,0,0,240,86,0,0,0,87,0,0,16,87,0,0,24,87,0,0,51,0,0,0,51,0,0,0,51,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,49,41,0,0,0,0,0,0,77,97,116,114,105,120,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,0,0,0,77,97,116,114,105,120,32,117,115,101,115,32,105,109,97,103,105,110,97,114,121,32,110,117,109,98,101,114,115,0,0,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,105,122,101,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,50,41,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,51,41,0,0,0,0,0,0,77,97,116,114,105,120,32,110,97,109,101,32,109,105,115,109,97,116,99,104,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,52,32,114,111,119,115,0,0,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,49,32,99,111,108,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,65,99,108,97,115,115,32,109,97,116,114,105,120,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,98,105,110,84,114,97,110,115,32,111,114,32,98,105,110,78,111,114,109,97,108,32,102,111,114,109,97,116,0,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,110,97,109,101,115,32,109,97,116,114,105,120,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,73,110,102,111,32,109,97,116,114,105,120,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,49,32,118,97,114,105,97,98,108,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,99,111,108,115,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,49,32,109,97,116,114,105,120,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,99,111,110,116,97,105,110,101,100,32,112,97,114,97,109,101,116,101,114,32,116,104,97,116,32,99,104,97,110,103,101,100,32,98,101,116,119,101,101,110,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,45,116,105,109,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,114,111,119,115,0,84,111,111,32,102,101,119,32,114,111,119,115,32,105,110,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,73,109,112,108,101,109,101,110,116,97,116,105,111,110,32,101,114,114,111,114,58,32,85,110,107,110,111,119,110,32,99,97,115,101,0,0,0,0,0,0,97,98,115,86,97,114,73,110,100,101,120,32,62,32,48,32,38,38,32,97,98,115,86,97,114,73,110,100,101,120,32,60,61,32,114,101,97,100,101,114,45,62,110,118,97,114,0,0,117,116,105,108,47,114,101,97,100,95,109,97,116,108,97,98,52,46,99,0,0,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,118,97,108,115,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,115,105,110,103,108,101,95,118,97,108,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,109,112,116,121,32,82,105,110,103,66,117,102,102,101,114,0,0,0,0,0,0,0,0,105,110,100,101,120,32,91,37,100,93,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,100,58,37,100,93,0,240,97,0,0,0,0,0,0,104,97,0,0,0,0,0,0,224,96,0,0,0,0,0,0,88,96,0,0,0,0,0,0,80,95,0,0,0,0,0,0,72,94,0,0,0,0,0,0,64,93,0,0,0,0,0,0,56,92,0,0,0,0,0,0,97,99,99,95,116,112,32,33,61,32,48,0,0,0,0,0,117,116,105,108,47,114,116,99,108,111,99,107,46,99,0,0,114,116,95,105,110,105,116,0,109,97,120,95,116,112,32,33,61,32,48,0,0,0,0,0,116,111,116,97,108,95,116,112,32,33,61,32,48,0,0,0,116,105,99,107,95,116,112,32,33,61,32,48,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,32,33,61,32,48,0,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,105,110,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,97,120,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,116,111,116,97,108,32,33,61,32,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+20480);
/* memory initializer */ allocate([69,114,114,111,114,32,115,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,119,105,116,104,32,100,105,102,102,101,114,101,110,116,32,115,116,97,114,116,105,110,103,32,112,111,105,110,116,115,32,40,43,37,103,41,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,116,111,32,100,101,99,114,101,97,115,101,32,102,97,99,116,111,114,32,116,111,32,37,103,0,0,0,0,0,105,109,112,114,111,112,101,114,32,105,110,112,117,116,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,110,111,110,108,105,110,101,97,114,32,101,113,46,32,115,121,115,116,58,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,85,110,107,110,111,119,110,32,101,113,117,97,116,105,111,110,32,115,121,115,116,101,109,32,101,114,114,111,114,58,32,37,100,32,37,115,32,37,103,0,70,76,65,71,95,85,78,75,78,79,87,78,0,0,0,0,99,108,111,99,107,0,0,0,99,112,117,0,0,0,0,0,101,109,105,116,95,112,114,111,116,101,99,116,101,100,0,0,102,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,105,105,102,0,0,0,0,0,105,105,109,0,0,0,0,0,105,105,116,0,0,0,0,0,105,108,115,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,0,0,0,0,0,105,111,109,0,0,0,0,0,105,112,111,112,116,95,104,101,115,115,101,0,0,0,0,0,105,112,111,112,116,95,106,97,99,0,0,0,0,0,0,0,105,112,111,112,116,95,105,110,105,116,0,0,0,0,0,0,108,0,0,0,0,0,0,0,108,111,103,70,111,114,109,97,116,0,0,0,0,0,0,0,108,115,0,0,0,0,0,0,108,115,95,105,112,111,112,116,0,0,0,0,0,0,0,0,108,118,0,0,0,0,0,0,109,101,97,115,117,114,101,84,105,109,101,80,108,111,116,70,111,114,109,97,116,0,0,0,110,108,115,0,0,0,0,0,110,111,101,109,105,116,0,0,110,111,69,118,101,110,116,69,109,105,116,0,0,0,0,0,111,117,116,112,117,116,0,0,111,118,101,114,114,105,100,101,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,70,105,108,101,0,0,0,0,112,111,114,116,0,0,0,0,114,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,216,99,0,0,232,99,0,0,240,99,0,0,248,99,0,0,8,100,0,0,16,100,0,0,24,100,0,0,32,100,0,0,40,100,0,0,48,100,0,0,56,100,0,0,72,100,0,0,80,100,0,0,96,100,0,0,112,100,0,0,128,100,0,0,136,100,0,0,152,100,0,0,160,100,0,0,176,100,0,0,184,100,0,0,208,100,0,0,216,100,0,0,224,100,0,0,240,100,0,0,248,100,0,0,8,101,0,0,24,101,0,0,32,101,0,0,40,101,0,0,48,101,0,0,56,101,0,0,117,110,107,110,111,119,110,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,0,0,0,0,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,115,45,102,105,108,101,0,0,0,0,0,0,0,0,101,109,105,116,115,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,115,101,116,117,112,32,88,77,76,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,110,32,101,120,116,101,114,110,97,108,32,102,105,108,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,0,91,100,111,117,98,108,101,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,91,105,110,116,93,32,100,101,102,97,117,108,116,58,32,49,0,0,0,0,0,0,0,0,115,112,101,99,105,102,121,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,119,104,101,114,101,32,116,104,101,32,108,105,110,101,97,114,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,32,115,104,111,117,108,100,32,98,101,32,112,101,114,102,111,114,109,101,100,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,46,32,45,108,111,103,70,111,114,109,97,116,61,116,101,120,116,32,40,100,101,102,97,117,108,116,41,32,111,114,32,45,108,111,103,70,111,114,109,97,116,61,120,109,108,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,105,112,111,112,116,0,0,0,0,0,0,91,115,116,114,105,110,103,32,108,105,115,116,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,97,110,121,32,114,101,115,117,108,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,101,118,101,110,116,32,112,111,105,110,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,32,112,111,114,116,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,114,101,115,117,108,116,32,102,105,108,101,32,116,104,97,110,32,116,104,101,32,100,101,102,97,117,108,116,32,77,111,100,101,108,95,114,101,115,46,109,97,116,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,115,111,108,118,101,114,0,0,0,0,0,0,115,104,111,119,115,32,97,108,108,32,119,97,114,110,105,110,103,115,32,101,118,101,110,32,105,102,32,97,32,114,101,108,97,116,101,100,32,108,111,103,45,115,116,114,101,97,109,32,105,115,32,105,110,97,99,116,105,118,101,0,0,0,0,0,200,101,0,0,208,101,0,0,24,102,0,0,72,102,0,0,120,102,0,0,192,102,0,0,0,103,0,0,72,103,0,0,120,103,0,0,192,103,0,0,216,103,0,0,248,103,0,0,48,104,0,0,88,104,0,0,128,104,0,0,184,104,0,0,8,105,0,0,104,105,0,0,152,105,0,0,208,105,0,0,0,106,0,0,72,106,0,0,112,106,0,0,160,106,0,0,208,106,0,0,40,107,0,0,112,107,0,0,224,107,0,0,16,108,0,0,88,108,0,0,120,108,0,0,56,101,0,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,10,32,32,82,84,61,109,111,110,111,116,111,110,105,99,32,114,101,97,108,45,116,105,109,101,32,99,108,111,99,107,44,32,67,80,85,61,112,114,111,99,101,115,115,45,98,97,115,101,100,32,67,80,85,45,116,105,109,101,44,32,67,89,67,61,99,112,117,32,99,121,99,108,101,115,32,109,101,97,115,117,114,101,100,32,119,105,116,104,32,82,68,84,83,67,0,0,0,0,0,32,32,45,32,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,10,32,32,45,32,36,99,112,117,84,105,109,101,32,105,115,32,116,104,101,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,105,110,115,105,100,101,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,10,32,32,101,46,103,46,32,45,104,101,108,112,61,102,32,112,114,105,110,116,115,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,32,102,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,102,111,114,32,104,111,109,111,116,111,112,121,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,115,121,109,98,111,108,105,99,41,32,111,114,10,39,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,39,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,110,117,109,101,114,105,99,32,45,105,111,109,61,110,101,108,100,101,114,95,109,101,97,100,95,101,120,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,101,109,97,116,114,105,120,32,102,111,114,32,73,112,111,112,116,40,79,77,67,44,32,66,70,71,83,44,32,99,111,110,115,116,41,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,40,83,89,77,44,32,78,85,77,44,32,78,85,77,68,69,78,83,69,41,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,32,40,115,105,109,44,32,99,111,110,115,116,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,10,32,32,108,97,112,97,99,107,44,32,108,105,115,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,73,112,111,112,116,44,32,100,101,102,97,117,108,116,32,109,117,109,112,115,46,10,32,78,111,116,101,58,32,85,115,101,32,105,102,32,121,111,117,32,98,117,105,108,100,32,105,112,111,112,116,32,119,105,116,104,32,111,116,104,101,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,105,107,101,32,109,97,50,55,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,10,32,32,115,118,103,10,32,32,106,112,103,10,32,32,112,115,10,32,32,103,105,102,10,32,32,46,46,46,0,0,0,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,10,32,32,116,105,109,101,32,61,32,118,97,108,117,101,44,32,97,32,61,32,118,97,108,117,101,44,32,98,32,61,32,118,97,108,117,101,44,32,99,32,61,32,118,97,108,117,101,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,10,32,32,101,46,103,46,32,118,97,114,49,61,115,116,97,114,116,49,44,118,97,114,50,61,115,116,97,114,116,50,44,112,97,114,51,61,115,116,97,114,116,51,44,115,116,97,114,116,84,105,109,101,61,118,97,108,49,44,115,116,111,112,84,105,109,101,61,118,97,108,50,44,115,116,101,112,83,105,122,101,61,118,97,108,51,44,10,32,32,32,32,32,32,32,116,111,108,101,114,97,110,99,101,61,118,97,108,52,44,115,111,108,118,101,114,61,34,115,101,101,32,45,115,34,44,111,117,116,112,117,116,70,111,114,109,97,116,61,34,109,97,116,124,112,108,116,124,99,115,118,124,101,109,112,116,121,34,44,118,97,114,105,97,98,108,101,70,105,108,116,101,114,61,34,102,105,108,116,101,114,34,0,0,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,10,32,32,110,111,116,101,32,116,104,97,116,58,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,67,65,78,78,79,84,32,98,101,32,117,115,101,100,32,119,105,116,104,32,45,111,118,101,114,114,105,100,101,10,32,32,117,115,101,32,119,104,101,110,32,118,97,114,105,97,98,108,101,115,32,102,111,114,32,45,111,118,101,114,114,105,100,101,32,97,114,101,32,116,111,111,32,109,97,110,121,32,97,110,100,32,100,111,32,110,111,116,32,102,105,116,32,105,110,32,99,111,109,109,97,110,100,32,108,105,110,101,32,115,105,122,101,10,32,32,111,118,101,114,114,105,100,101,70,105,108,101,78,97,109,101,32,99,111,110,116,97,105,110,115,32,108,105,110,101,115,32,111,102,32,116,104,101,32,102,111,114,109,58,32,118,97,114,49,61,115,116,97,114,116,49,0,0,0,0,0,0,200,101,0,0,56,109,0,0,224,109,0,0,72,102,0,0,120,102,0,0,72,110,0,0,0,103,0,0,72,103,0,0,208,110,0,0,16,111,0,0,216,103,0,0,248,103,0,0,176,111,0,0,240,111,0,0,48,112,0,0,184,104,0,0,8,105,0,0,112,112,0,0,168,112,0,0,48,113,0,0,88,113,0,0,72,106,0,0,112,106,0,0,160,106,0,0,192,113,0,0,72,114,0,0,72,115,0,0,224,107,0,0,16,108,0,0,88,108,0,0,120,108,0,0,56,101,0,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,49,120,44,56,48,97,49,41,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,41,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,44,51,120,44,2,73,50,32,61,2,44,105,49,48,41,0,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,41,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,44,51,120,44,2,82,50,32,61,2,44,101,50,49,46,49,51,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,121,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,72,69,32,76,65,83,84,32,83,84,69,80,32,84,69,82,77,73,78,65,84,69,68,32,87,73,84,72,32,65,32,78,69,71,65,84,73,86,69,0,0,0,0,0,0,0,49,0,0,0,0,0,0,0,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,86,65,76,85,69,32,40,61,73,49,41,32,79,70,32,73,68,73,68,32,65,78,68,32,78,79,32,65,80,80,82,79,80,82,73,65,84,69,0,47,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,67,84,73,79,78,32,87,65,83,32,84,65,75,69,78,46,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,203,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,67,85,82,82,69,78,84,32,84,32,40,61,82,49,41,32,32,53,48,48,32,83,84,69,80,83,0,0,38,0,0,0,0,0,0,0,98,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,65,75,69,78,32,79,78,32,84,72,73,83,32,67,65,76,76,32,66,69,70,79,82,69,32,82,69,65,67,72,73,78,71,32,84,79,85,84,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,99,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,84,79,79,32,77,85,67,72,32,65,67,67,85,82,65,67,89,32,82,69,81,85,69,83,84,69,68,0,108,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,70,79,82,32,80,82,69,67,73,83,73,79,78,32,79,70,32,77,65,67,72,73,78,69,46,32,82,84,79,76,32,65,78,68,32,65,84,79,76,0,0,0,0,0,0,0,0,109,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,87,69,82,69,32,73,78,67,82,69,65,83,69,68,32,84,79,32,65,80,80,82,79,80,82,73,65,84,69,32,86,65,76,85,69,83,0,0,0,45,0,0,0,0,0,0,0,110,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,0,0,118,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,65,83,32,66,69,67,79,77,69,32,46,76,69,46,32,48,46,48,0,0,0,0,28,0,0,0,0,0,0,0,119,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,32,84,72,69,0,0,0,0,44,0,0,0,0,0,0,0,128,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,129,2,0,0,0,0,0,0,138,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,70,65,73,76,69,68,32,84,79,32,67,79,78,86,69,82,71,69,32,82,69,80,69,65,84,69,68,76,89,0,0,0,0,0,0,0,0,139,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,140,2,0,0,0,0,0,0,148,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,84,69,82,65,84,73,79,78,32,77,65,84,82,73,88,32,73,83,32,83,73,78,71,85,76,65,82,0,0,0,37,0,0,0,0,0,0,0,149,2,0,0,0,0,0,0,158,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,46,32,32,65,76,83,79,44,32,84,72,69,0,0,0,0,0,0,0,159,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,46,0,0,160,2,0,0,0,0,0,0,163,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,32,66,69,67,65,85,83,69,0,0,0,164,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,79,78,69,0,0,0,0,36,0,0,0,0,0,0,0,165,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,0,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,168,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,84,87,79,0,0,0,0,169,2,0,0,0,0,0,0,173,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,73,84,73,65,76,32,89,80,82,73,77,69,32,67,79,85,76,68,32,78,79,84,32,66,69,32,67,79,77,80,85,84,69,68,0,0,0,174,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,73,78,70,79,32,86,69,67,84,79,82,32,73,83,32,78,79,84,32,90,69,82,79,32,79,82,32,79,78,69,0,55,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,69,81,32,40,61,73,49,41,32,46,76,69,46,32,48,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,65,88,79,82,68,32,40,61,73,49,41,32,78,79,84,32,73,78,32,82,65,78,71,69,0,0,0,0,0,0,34,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,82,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,82,87,32,40,61,73,50,41,0,0,0,0,60,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,73,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,73,87,32,40,61,73,50,41,0,0,0,0,5,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,82,84,79,76,32,73,83,32,46,76,84,46,32,48,0,39,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,65,84,79,76,32,73,83,32,46,76,84,46,32,48,0,7,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,76,76,32,69,76,69,77,69,78,84,83,32,79,70,32,82,84,79,76,32,65,78,68,32,65,84,79,76,32,65,82,69,32,90,69,82,79,0,8,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,32,61,32,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,79,85,84,32,40,61,82,50,41,0,0,54,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,77,65,88,32,40,61,82,49,41,32,46,76,84,46,32,48,46,48,0,0,0,0,10,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,11,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,56,41,61,49,32,65,78,68,32,72,48,61,48,46,48,0,0,0,29,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,32,73,83,32,46,76,69,46,32,48,46,48,0,13,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,84,79,85,84,32,40,61,82,49,41,32,84,79,79,32,67,76,79,83,69,32,84,79,32,84,32,40,61,82,50,41,32,84,79,32,83,84,65,82,84,32,73,78,84,69,71,82,65,84,73,79,78,0,0,0,0,14,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,61,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,76,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,52,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,85,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,18,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,73,83,32,69,81,85,65,76,32,84,79,32,84,32,40,61,82,50,41,0,19,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,71,32,40,61,73,49,41,32,46,76,84,46,32,48,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,78,69,32,79,82,32,77,79,82,69,32,67,79,77,80,79,78,69,78,84,83,32,79,70,32,71,32,72,65,83,32,65,32,82,79,79,84,0,32,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,84,79,79,32,78,69,65,82,32,84,79,32,84,72,69,32,73,78,73,84,73,65,76,32,80,79,73,78,84,0,0,68,65,83,83,76,45,45,32,32,82,69,80,69,65,84,69,68,32,79,67,67,85,82,82,69,78,67,69,83,32,79,70,32,73,76,76,69,71,65,76,32,73,78,80,85,84,0,0,46,0,0,0,0,0,0,0,33,3,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,46,32,65,80,80,65,82,69,78,84,32,73,78,70,73,78,73,84,69,32,76,79,79,80,0,34,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,116,32,112,111,105,110,116,32,105,110,32,116,105,109,101,58,32,37,103,0,0,0,0,99,106,58,32,37,103,0,0,115,116,97,116,101,115,0,0,91,37,108,100,93,32,37,103,0,0,0,0,0,0,0,0,97,110,97,108,121,116,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,37,115,37,103,32,0,0,0,37,115,0,0,0,0,0,0,110,117,109,101,114,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,66,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,77,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,76,0,0,0,0,0,0,0,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+25200);
/* memory initializer */ allocate([40,47,47,2,32,87,65,82,78,73,78,71,46,32,84,104,101,32,118,97,108,117,101,32,69,77,73,78,32,109,97,121,32,98,101,32,105,110,99,111,114,114,101,99,116,58,45,2,44,2,32,32,69,77,73,78,32,61,32,2,44,105,56,44,47,2,32,73,102,44,32,97,102,116,101,114,32,105,110,115,112,101,99,116,105,111,110,44,32,116,104,101,32,118,97,108,117,101,32,69,77,73,78,32,108,111,111,107,115,2,44,2,32,97,99,99,101,112,116,97,98,108,101,32,112,108,101,97,115,101,32,99,111,109,109,101,110,116,32,111,117,116,32,2,44,47,2,32,116,104,101,32,73,70,32,98,108,111,99,107,32,97,115,32,109,97,114,107,101,100,32,119,105,116,104,105,110,32,116,104,101,32,99,111,100,101,32,111,102,32,114,111,117,116,105,110,101,2,44,2,32,68,76,65,77,67,50,44,2,44,47,2,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,108,121,32,69,77,73,78,32,101,120,112,108,105,99,105,116,108,121,46,2,44,47,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,224,138,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,191,76,0,0,0,0,176,60,49,101,0,0,0,0,16,0,244,14,255,255,255,255,239,127,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,2,32,80,114,111,103,114,101,115,115,32,82,101,112,111,114,116,32,101,118,101,114,121,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,47,44,2,32,69,86,65,76,46,32,32,32,70,85,78,67,46,86,65,76,85,69,46,2,44,49,48,120,44,2,80,65,82,65,77,69,84,69,82,32,86,65,76,85,69,83,2,41,0,0,0,0,40,47,49,120,44,105,52,44,50,120,44,103,49,50,46,53,44,50,120,44,53,103,49,49,46,52,44,51,40,47,50,49,120,44,53,103,49,49,46,52,41,41,0,0,0,0,0,0,40,2,32,78,111,46,32,111,102,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,62,32,2,44,105,53,41,0,0,40,2,32,82,77,83,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,103,49,52,46,54,41,0,0,0,0,0,40,2,32,67,101,110,116,114,111,105,100,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,99,101,110,116,114,111,105,100,32,61,2,44,103,49,52,46,54,41,0,40,47,2,32,69,86,73,68,69,78,67,69,32,79,70,32,67,79,78,86,69,82,71,69,78,67,69,2,41,0,0,0,40,47,47,2,32,77,105,110,105,109,117,109,32,102,111,117,110,100,32,97,102,116,101,114,2,44,105,53,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,41,0,0,0,40,2,32,77,105,110,105,109,117,109,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,54,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,109,105,110,105,109,117,109,32,61,2,44,103,49,52,46,54,41,0,0,40,47,2,32,70,105,116,116,105,110,103,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,97,98,111,117,116,32,115,117,112,112,111,115,101,100,32,109,105,110,105,109,117,109,2,47,41,0,40,47,2,32,77,65,84,82,73,88,32,79,70,32,69,83,84,73,77,65,84,69,68,32,83,69,67,79,78,68,32,68,69,82,73,86,65,84,73,86,69,83,32,78,79,84,32,43,86,69,32,68,69,70,78,46,2,47,2,32,77,73,78,73,77,85,77,32,80,82,79,66,65,66,76,89,32,78,79,84,32,70,79,85,78,68,2,47,41,0,0,0,0,0,0,0,40,47,49,48,120,44,2,83,101,97,114,99,104,32,114,101,115,116,97,114,116,105,110,103,2,47,41,0,0,0,0,0,40,2,32,77,105,110,105,109,117,109,32,111,102,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,61,2,44,103,49,52,46,54,44,2,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,73,70,32,84,72,73,83,32,68,73,70,70,69,82,83,32,66,89,32,77,85,67,72,32,70,82,79,77,32,84,72,69,32,77,73,78,73,77,85,77,32,69,83,84,73,77,65,84,69,68,2,44,49,120,44,2,70,82,79,77,32,84,72,69,32,77,73,78,73,77,73,90,65,84,73,79,78,44,2,47,2,32,84,72,69,32,77,73,78,73,77,85,77,32,77,65,89,32,66,69,32,70,65,76,83,69,32,38,47,79,82,32,84,72,69,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,32,77,65,89,32,66,69,2,44,49,120,44,2,73,78,65,67,67,85,82,65,84,69,2,47,41,0,0,0,0,0,40,2,32,82,97,110,107,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,32,61,2,44,105,51,47,2,32,73,110,118,101,114,115,101,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,58,45,2,41,0,40,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,109,105,110,105,109,105,122,101,100,32,119,97,115,32,45,76,79,71,40,76,73,75,69,76,73,72,79,79,68,41,44,2,47,2,32,116,104,105,115,32,105,115,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,32,111,102,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,46,2,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,119,97,115,32,97,32,115,117,109,32,111,102,32,115,113,117,97,114,101,115,32,111,102,32,114,101,115,105,100,117,97,108,115,44,2,47,2,32,116,104,105,115,32,109,97,116,114,105,120,32,109,117,115,116,32,98,101,32,109,117,108,116,105,112,108,105,101,100,32,98,121,32,116,119,105,99,101,32,116,104,101,32,101,115,116,105,109,97,116,101,100,2,44,49,120,44,2,114,101,115,105,100,117,97,108,32,118,97,114,105,97,110,99,101,2,47,2,32,116,111,32,111,98,116,97,105,110,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,46,2,47,41,0,0,0,0,40,2,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,47,41,0,0,0,0,0,0,40,47,47,2,32,67,79,82,82,69,76,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,41,0,0,0,0,0,40,47,2,32,65,32,102,117,114,116,104,101,114,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,104,97,118,101,32,98,101,101,110,32,117,115,101,100,2,47,41,0,0,0,0,0,0,40,49,120,44,54,103,49,51,46,53,41,0,0,0,0,0,40,47,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+35544);
/* memory initializer */ allocate([96,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,146,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,146,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,146,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,147,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,148,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,148,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,148,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,148,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,148,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,148,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,78,80,84,32,105,115,32,110,111,116,32,105,110,2,44,2,32,116,104,101,32,114,101,113,117,105,114,101,100,32,105,110,116,101,114,118,97,108,2,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,48,184,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,67,65,76,70,85,78,32,104,97,115,32,98,101,101,110,2,44,2,32,99,97,108,108,101,100,32,77,65,88,70,85,78,32,116,105,109,101,115,46,2,41,0,0,0,0,0,0,40,47,52,120,44,2,70,117,110,99,116,105,111,110,32,110,117,109,98,101,114,2,44,105,54,44,2,32,32,32,32,70,32,61,2,44,49,112,100,49,56,46,49,48,44,2,32,32,32,32,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,97,32,116,114,117,115,116,2,44,2,32,114,101,103,105,111,110,32,115,116,101,112,32,104,97,115,32,102,97,105,108,101,100,32,116,111,32,114,101,100,117,99,101,32,81,46,2,41,0,0,0,0,0,0,0,40,53,120,41,0,0,0,0,40,47,52,120,44,2,78,101,119,32,82,72,79,32,61,2,44,49,112,100,49,49,46,52,44,53,120,44,2,78,117,109,98,101,114,32,111,102,2,44,2,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,40,52,120,44,2,76,101,97,115,116,32,118,97,108,117,101,32,111,102,32,70,32,61,2,44,49,112,100,50,51,46,49,53,44,57,120,44,2,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,0,0,0,0,40,47,52,120,44,2,65,116,32,116,104,101,32,114,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,2,44,53,120,44,2,78,117,109,98,101,114,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,16,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,96,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,184,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,16,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,24,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,96,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,176,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,96,186,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,105,118,111,116,32,33,61,32,48,0,0,0,0,0,0,109,97,116,104,45,115,117,112,112,111,114,116,47,112,105,118,111,116,46,99,0,0,0,0,112,105,118,111,116,0,0,0,232,198,0,0,8,200,0,0,16,200,0,0,32,200,0,0,48,200,0,0,64,200,0,0,88,200,0,0,112,200,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,232,198,0,0,240,198,0,0,56,199,0,0,96,199,0,0,128,199,0,0,160,199,0,0,200,199,0,0,240,199,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,100,97,115,115,108,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,0,0,0,0,0,124,32,115,111,108,118,101,114,32,124,32,85,115,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,9,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,78,111,32,83,112,97,114,115,101,80,97,116,116,101,114,110,44,32,115,105,110,99,101,32,116,104,101,114,101,32,97,114,101,32,110,111,32,115,116,97,116,101,115,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,74,97,99,111,98,105,97,110,32,111,114,32,83,112,97,114,115,101,80,97,116,116,101,114,110,32,105,115,32,110,111,116,32,103,101,110,101,114,97,116,101,100,32,111,114,32,102,97,105,108,101,100,32,116,111,32,105,110,105,116,105,97,108,105,122,101,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,112,97,115,115,101,100,32,116,111,32,68,68,65,83,82,84,0,0,0,0,0,0,68,101,115,105,114,101,100,32,115,116,101,112,32,116,111,32,115,109,97,108,108,32,116,114,121,32,110,101,120,116,32,111,110,101,0,0,0,0,0,0,73,110,116,101,114,112,111,108,97,116,101,32,108,105,110,101,97,114,0,0,0,0,0,0,67,97,108,108,105,110,103,32,68,68,65,83,82,84,32,102,114,111,109,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,83,116,97,114,116,32,115,116,101,112,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,0,65,32,108,97,114,103,101,32,97,109,111,117,110,116,32,111,102,32,119,111,114,107,32,104,97,115,32,98,101,101,110,32,101,120,112,101,110,100,101,100,46,40,65,98,111,117,116,32,53,48,48,32,115,116,101,112,115,41,46,32,84,114,121,105,110,103,32,116,111,32,99,111,110,116,105,110,117,101,32,46,46,46,0,0,0,0,0,0,68,65,83,83,76,32,119,105,108,108,32,116,114,121,32,97,103,97,105,110,46,46,46,0,99,97,110,39,116,32,99,111,110,116,105,110,117,101,46,32,116,105,109,101,32,61,32,37,102,0,0,0,0,0,0,0,100,97,115,115,108,32,99,97,108,108,32,115,116,97,105,115,116,105,99,115,58,32,0,0,118,97,108,117,101,32,111,102,32,105,100,105,100,58,32,37,100,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,105,110,116,101,103,114,97,116,105,111,110,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,115,116,101,112,32,115,105,122,101,32,72,32,116,111,32,98,101,32,97,116,116,101,109,112,116,101,100,32,111,110,32,110,101,120,116,32,115,116,101,112,58,32,37,48,46,52,103,0,115,116,101,112,32,115,105,122,101,32,117,115,101,100,32,111,110,32,108,97,115,116,32,115,117,99,99,101,115,115,102,117,108,32,115,116,101,112,58,32,37,48,46,52,103,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,116,97,107,101,110,32,115,111,32,102,97,114,58,32,37,100,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,40,41,32,58,32,37,100,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,99,117,108,97,116,105,111,110,32,111,102,32,106,97,99,111,98,105,97,110,32,58,32,37,100,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,49,48,32,43,32,117,105,32,60,32,100,97,115,115,108,68,97,116,97,45,62,108,105,119,0,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,100,97,115,115,108,46,99,0,0,0,0,0,0,0,100,97,115,114,116,95,115,116,101,112,0,0,0,0,0,0,70,105,110,105,115,104,101,100,32,68,68,65,83,82,84,32,115,116,101,112,46,0,0,0,84,104,101,32,101,114,114,111,114,32,116,111,108,101,114,97,110,99,101,115,32,97,114,101,32,116,111,111,32,115,116,114,105,110,103,101,110,116,0,0,68,68,65,83,83,76,32,104,97,100,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,111,110,32,116,104,101,32,108,97,115,116,32,97,116,116,101,109,112,116,101,100,32,115,116,101,112,46,0,0,0,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,0,0,0,0,0,0,0,84,104,101,32,109,97,116,114,105,120,32,111,102,32,112,97,114,116,105,97,108,32,100,101,114,105,118,97,116,105,118,101,115,32,105,115,32,115,105,110,103,117,108,97,114,46,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,32,84,104,101,114,101,32,119,101,114,101,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,105,110,32,116,104,105,115,32,115,116,101,112,46,0,65,32,77,111,100,101,108,105,99,97,32,97,115,115,101,114,116,32,112,114,101,118,101,110,116,115,32,116,104,101,32,105,110,116,101,103,114,97,116,111,114,32,116,111,32,99,111,110,116,105,110,117,101,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,45,108,118,32,76,79,71,95,68,68,65,83,82,84,0,0,73,82,69,83,32,101,113,117,97,108,32,116,111,32,45,50,32,119,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,97,110,100,32,99,111,110,116,114,111,108,32,105,115,32,98,101,105,110,103,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,99,97,108,108,105,110,103,32,112,114,111,103,114,97,109,46,0,0,68,68,65,83,83,76,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,116,104,101,32,105,110,105,116,105,97,108,32,89,80,82,73,77,69,46,0,0,0,0,84,104,101,32,99,111,100,101,32,104,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,116,114,111,117,98,108,101,32,102,114,111,109,32,119,104,105,99,104,32,105,116,32,99,97,110,110,111,116,32,114,101,99,111,118,101,114,46,0,0,117,110,107,110,111,119,110,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,84,82,85,69,0,0,0,0,70,65,76,83,69,0,0,0,91,37,108,100,93,32,115,97,109,112,108,101,40,37,103,44,32,37,103,41,0,0,0,0,91,37,108,100,93,32,37,115,0,0,0,0,0,0,0,0,67,104,97,116,116,101,114,105,110,103,32,100,101,116,101,99,116,101,100,32,97,114,111,117,110,100,32,116,105,109,101,32,37,46,49,50,103,46,46,37,46,49,50,103,32,40,37,100,32,115,116,97,116,101,32,101,118,101,110,116,115,32,105,110,32,97,32,114,111,119,32,119,105,116,104,32,97,32,116,111,116,97,108,32,116,105,109,101,32,100,101,108,116,97,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,115,116,101,112,32,115,105,122,101,32,37,46,49,50,103,41,46,32,84,104,105,115,32,99,97,110,32,98,101,32,97,32,112,101,114,102,111,114,109,97,110,99,101,32,98,111,116,116,108,101,110,101,99,107,46,32,85,115,101,32,45,108,118,32,76,79,71,95,69,86,69,78,84,83,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,32,84,104,101,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,119,97,115,58,32,37,115,0,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,114,105,103,104,116,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,101,118,101,110,116,115,46,99,0,0,0,0,0,0,102,105,110,100,82,111,111,116,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,108,101,102,116,0,0,0,0,0,115,101,97,114,99,104,32,102,111,114,32,99,117,114,114,101,110,116,32,101,118,101,110,116,46,32,69,118,101,110,116,115,32,105,110,32,108,105,115,116,58,32,37,108,100,0,0,0,77,105,110,105,109,117,109,32,118,97,108,117,101,58,32,37,101,0,0,0,0,0,0,0,97,100,100,101,100,32,116,109,112,32,101,118,101,110,116,32,58,32,37,108,100,0,0,0,37,108,100,32,0,0,0,0,98,97,99,107,117,112,95,103,111,117,116,0,0,0,0,0,98,105,115,101,99,116,105,111,110,0,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,109,101,116,104,111,100,32,115,116,97,114,116,115,32,105,110,32,105,110,116,101,114,118,97,108,32,91,37,101,44,32,37,101,93,0,0,0,0,84,84,79,76,32,105,115,32,115,101,116,32,116,111,58,32,37,101,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,99,104,101,99,107,115,32,102,111,114,32,99,111,110,100,105,116,105,111,110,32,99,104,97,110,103,101,115,0,0,37,108,100,32,99,104,97,110,103,101,100,32,102,114,111,109,32,37,115,32,116,111,32,99,117,114,114,101,110,116,32,37,115,0,0,0,0,0,0,0,115,97,118,101,32,97,108,108,32,122,101,114,111,99,114,111,115,115,105,110,103,115,32,97,102,116,101,114,32,97,110,32,101,118,101,110,116,0,0,0,69,82,82,79,82,58,32,84,111,111,32,109,97,110,121,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,115,46,32,83,121,115,116,101,109,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,46,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,112,97,114,97,109,101,116,101,114,32,118,97,108,117,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,103,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,108,100,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,115,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,0,0,0,0,115,116,97,116,117,115,32,111,102,32,114,101,108,97,116,105,111,110,115,0,0,0,0,0,91,37,108,100,93,32,37,115,32,61,32,37,99,32,124,32,112,114,101,40,37,115,41,32,61,32,37,99,0,0,0,0,89,111,117,114,32,109,101,109,111,114,121,32,105,115,32,110,111,116,32,115,116,114,111,110,103,32,101,110,111,117,103,104,32,102,111,114,32,111,117,114,32,82,105,110,103,98,117,102,102,101,114,33,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,101,120,116,101,114,110,97,108,32,111,98,106,101,99,116,115,0,0,0,0,0,0,0,187,189,215,217,223,124,219,61,83,101,116,32,116,111,108,101,114,97,110,99,101,32,102,111,114,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,104,121,115,116,101,114,101,115,105,115,32,116,111,58,32,37,101,0,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,109,105,120,101,100,32,115,111,108,118,101,114,0,0,0,0,0,0,0,109,105,120,101,100,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,91,37,100,93,32,37,115,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,101,77,105,120,101,100,83,101,97,114,99,104,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,0,0,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,91,37,100,93,32,37,115,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,97,112,97,99,107,46,0,0,0,0,0,0,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,76,105,115,46,0,0,45,105,32,102,103,109,114,101,115,32,0,0,0,0,0,0,78,76,83,95,85,78,75,78,79,87,78,0,0,0,0,0,104,121,98,114,105,100,0,0,107,105,110,115,111,108,0,0,110,101,119,116,111,110,0,0,78,76,83,95,77,65,88,0,80,207,0,0,96,207,0,0,104,207,0,0,112,207,0,0,120,207,0,0,0,0,0,0,117,110,107,110,111,119,110,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,78,101,119,116,111,110,32,82,97,112,104,115,111,110,0,0,152,207,0,0,160,207,0,0,176,207,0,0,192,207,0,0,120,207,0,0,0,0,0,0,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,106,97,99,111,98,105,97,110,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,0,0,0,0,112,114,111,112,101,114,32,115,116,97,114,116,45,118,97,108,117,101,115,32,102,111,114,32,115,111,109,101,32,111,102,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,115,32,109,105,103,104,116,32,104,101,108,112,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,63,44,32,110,111,109,105,110,97,108,61,63,41,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,115,116,97,114,116,32,115,111,108,118,105,110,103,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,62,62,37,115,60,60,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,102,0,0,0,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,10,111,108,100,32,61,32,37,102,10,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,102,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,32,40,115,99,97,108,101,100,41,0,0,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,102,111,114,32,114,101,115,105,100,117,97,108,32,118,101,99,116,111,114,0,0,0,0,0,115,99,97,108,101,100,32,114,101,115,105,100,117,97,108,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,115,121,115,116,101,109,32,115,111,108,118,101,100,0,0,0,37,100,32,114,101,116,114,105,101,115,10,37,100,32,114,101,115,116,97,114,116,115,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,101,99,114,101,97,115,105,110,103,32,105,110,105,116,105,97,108,32,115,116,101,112,32,98,111,117,110,100,32,116,111,32,37,102,46,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,32,97,115,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,111,117,116,32,115,99,97,108,105,110,103,32,97,116,32,97,108,108,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,116,111,32,115,111,108,118,101,32,97,32,100,105,115,99,111,110,116,105,110,117,111,117,115,32,115,121,115,116,101,109,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,117,115,101,32,111,108,100,32,118,97,108,117,101,115,32,105,110,115,116,101,97,100,32,101,120,116,114,97,112,111,108,97,116,101,100,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,97,100,100,105,110,103,32,49,37,37,46,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,45,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,97,115,32,105,110,105,116,105,97,108,32,112,111,105,110,116,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,32,111,119,110,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,105,115,97,98,108,101,32,115,111,108,118,101,114,32,105,110,116,101,114,110,97,108,32,115,99,97,108,105,110,103,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,114,101,100,117,99,101,32,116,104,101,32,116,111,108,101,114,97,110,99,101,32,115,108,105,103,104,116,108,121,32,116,111,32,37,101,46,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,110,108,115,32,115,116,97,116,117,115,0,0,0,0,0,0,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,0,0,102,117,110,99,116,105,111,110,115,0,0,0,0,0,0,0,114,101,115,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,115,116,97,116,105,115,116,105,99,115,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,10,101,114,114,111,114,32,61,32,37,46,50,48,101,10,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,50,48,101,0,0,0,91,37,50,100,93,32,37,50,48,46,49,50,103,0,0,0,45,45,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,45,45,32,101,110,100,32,111,102,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,0,45,45,32,98,101,103,105,110,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,0,0,0,0,0,0,45,45,32,101,110,100,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,87,101,108,108,44,32,116,104,105,115,32,105,115,32,101,109,98,97,114,114,97,115,105,110,103,46,32,84,104,101,32,110,111,110,45,108,105,110,101,97,114,32,115,111,108,118,101,114,32,115,104,111,117,108,100,32,110,101,118,101,114,32,99,97,108,108,32,116,104,105,115,32,99,97,115,101,46,37,100,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,83,116,97,114,116,32,115,111,108,118,105,110,103,32,78,111,110,45,76,105,110,101,97,114,32,83,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,32,119,105,116,104,32,78,101,119,116,111,110,32,83,111,108,118,101,114,0,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,32,43,43,43,32,111,108,100,32,61,32,37,101,32,43,43,43,32,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,101,0,42,42,42,32,83,121,115,116,101,109,32,115,111,108,118,101,100,32,42,42,42,10,37,100,32,114,101,115,116,97,114,116,115,0,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,32,43,43,43,32,101,114,114,111,114,32,61,32,37,46,49,53,101,32,43,43,43,32,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,49,53,101,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,10,9,114,101,115,105,100,117,97,108,32,61,32,37,101,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,46,0,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,110,111,109,105,110,97,108,32,118,97,108,117,101,115,32,97,115,32,105,110,105,116,105,97,108,32,115,111,108,117,116,105,111,110,46,0,0,0,0,0,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,35,35,35,35,35,35,35,35,35,32,83,116,97,114,116,32,78,101,119,116,111,110,32,109,97,120,102,101,118,58,32,37,100,32,35,35,35,35,35,35,35,35,35,0,0,0,0,0,120,91,37,100,93,58,32,37,101,32,0,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,74,97,99,111,98,105,97,110,32,77,97,116,114,105,120,32,115,105,110,103,117,108,97,114,33,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,32,105,110,112,117,116,32,105,110,32,97,114,103,117,109,101,110,116,32,37,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,240,63,73,110,105,116,105,97,108,105,122,105,110,103,32,68,65,83,83,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,116,111,114,105,110,103,32,114,101,115,117,108,116,115,32,97,110,100,32,101,120,105,116,105,110,103,46,10,85,115,101,32,45,108,118,61,76,79,71,95,73,78,73,84,32,45,119,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,0,115,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,97,110,32,97,115,115,101,114,116,105,111,110,32,97,116,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,87,114,111,116,101,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,116,104,101,32,102,105,108,101,32,97,102,116,101,114,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,40,102,111,114,32,111,117,116,112,117,116,32,102,111,114,109,97,116,115,32,116,104,97,116,32,115,117,112,112,111,114,116,32,116,104,105,115,41,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,108,32,101,118,101,110,116,32,97,116,32,115,116,111,112,32,116,105,109,101,32,37,103,0,0,70,105,110,105,115,104,101,100], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+46228);
/* memory initializer */ allocate([35,35,35,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,0,0,0,0,116,105,109,101,114,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,112,114,101,45,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,116,101,112,115,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,45,102,105,108,101,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,101,118,101,110,116,45,104,97,110,100,108,105,110,103,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,118,101,114,104,101,97,100,0,0,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,105,109,117,108,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,116,111,116,97,108,0,0,0,101,118,101,110,116,115,0,0,37,53,108,100,32,115,116,97,116,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,37,53,108,100,32,116,105,109,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,0,115,111,108,118,101,114,58,32,68,65,83,83,76,0,0,0,37,53,100,32,115,116,101,112,115,32,116,97,107,101,110,0,37,53,100,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,0,0,0,0,0,0,0,0,37,53,100,32,101,118,97,108,117,97,116,105,111,110,115,32,111,102,32,106,97,99,111,98,105,97,110,0,0,0,0,0,37,53,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,37,53,100,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,0,0,115,111,108,118,101,114,0,0,115,111,114,114,121,32,45,32,110,111,32,115,111,108,118,101,114,32,115,116,97,116,105,115,116,105,99,115,32,97,118,97,105,108,97,98,108,101,46,32,91,110,111,116,32,121,101,116,32,105,109,112,108,101,109,101,110,116,101,100,93,0,0,0,35,35,35,32,69,78,68,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,83,117,110,100,105,97,108,47,107,105,110,115,111,108,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,32,80,108,101,97,115,101,32,99,104,111,111,115,101,32,111,116,104,101,114,32,115,111,108,118,101,114,46,0,73,112,111,112,116,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,0,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,101,117,108,101,114,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,69,85,76,69,82,46,0,0,0,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,82,75,46,0,0,0,83,116,97,114,116,32,110,117,109,101,114,105,99,97,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,44,0,0,0,0,0,0,0,116,105,109,101,61,37,46,50,48,103,0,0,0,0,0,0,44,37,115,61,37,46,50,48,103,0,0,0,0,0,0,0,44,37,115,61,37,108,105,0,44,37,115,61,37,105,0,0,44,37,115,61,34,37,115,34,0,0,0,0,0,0,0,0,99,97,110,32,110,111,116,32,105,110,105,116,105,97,108,122,101,32,74,97,99,111,98,105,97,110,115,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,106,97,99,111,98,105,97,110,32,37,100,120,37,100,32,91,105,100,58,32,37,108,100,93,0,0,0,0,0,0,0,0,37,115,37,46,53,101,32,0,37,115,0,0,0,0,0,0,69,114,114,111,114,44,32,115,105,110,103,117,108,97,114,32,74,97,99,111,98,105,97,110,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,32,97,116,32,116,105,109,101,32,37,102,10,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,95,74,65,67,32,116,111,32,103,101,116,32,116,104,101,32,74,97,99,111,98,105,97,110,0,115,101,108,101,99,116,32,110,101,119,32,115,116,97,116,101,115,32,97,116,32,116,105,109,101,32,37,102,0,0,0,0,115,101,108,101,99,116,32,37,115,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,73,110,112,117,116,46,99,115,118,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,37,108,102,0,0,0,0,0,10,69,120,116,101,114,110,97,108,32,73,110,112,117,116,0,10,73,110,112,117,116,58,32,116,61,37,102,32,32,32,9,0,0,0,0,0,0,0,0,117,37,100,40,116,41,61,32,37,102,32,9,0,0,0,0,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,0,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,121,115,116,101,109,32,111,102,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,97,114,101,32,110,111,116,32,99,111,110,115,105,115,116,101,110,116,10,40,108,101,97,115,116,32,115,113,117,97,114,101,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,32,105,115,32,37,103,41,0,0,0,0,0,114,101,115,105,100,117,97,108,91,37,108,100,93,32,61,32,37,103,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,115,116,97,116,117,115,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,32,91,115,99,97,108,101,100,58,32,37,103,93,0,0,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,0,0,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,0,0,0,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,35,35,35,32,83,79,76,85,84,73,79,78,32,79,70,32,84,72,69,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,115,116,97,116,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,0,0,100,101,114,105,118,97,116,105,118,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,111,116,104,101,114,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,41,32,61,32,37,108,100,32,40,112,114,101,58,32,37,108,100,41,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,41,32,61,32,37,115,32,40,112,114,101,58,32,37,115,41,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,32,40,112,114,101,58,32,34,37,115,34,41,0,0,35,35,35,32,83,84,65,82,84,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,128,234,0,0,72,236,0,0,80,236,0,0,88,236,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,105,109,32,37,115,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,124,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,128,234,0,0,136,235,0,0,216,235,0,0,8,236,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,128,234,0,0,72,235,0,0,80,235,0,0,88,235,0,0,104,235,0,0,112,235,0,0,128,235,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,111,109,32,37,115,0,0,0,0,0,128,234,0,0,136,234,0,0,160,234,0,0,176,234,0,0,248,234,0,0,8,235,0,0,40,235,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,105,109,0,35,35,35,32,69,78,68,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,37,115,95,104,111,109,111,116,111,112,121,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,108,97,109,98,100,97,0,0,104,111,109,111,116,111,112,121,32,112,114,111,99,101,115,115,0,0,0,0,0,0,0,0,108,97,109,98,100,97,32,61,32,37,103,32,100,111,110,101,0,0,0,0,0,0,0,0,37,46,49,54,103,44,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,117,110,105,113,117,101,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,46,32,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,32,116,111,32,115,101,101,32,116,104,101,32,115,119,105,116,99,104,105,110,103,32,115,116,97,116,101,32,115,101,116,46,0,0,0,110,111,32,118,97,114,105,97,98,108,101,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,0,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,32,40,110,101,105,116,104,101,114,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,110,111,114,32,105,110,105,116,105,97,108,32,97,108,103,111,114,105,116,104,109,115,41,0,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,0,0,0,0,0,0,0,0,115,101,116,116,105,110,103,32,102,105,120,101,100,61,116,114,117,101,32,102,111,114,58,0,37,115,40,102,105,120,101,100,61,116,114,117,101,41,32,61,32,37,103,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,0,0,111,118,101,114,45,100,101,116,101,114,109,105,110,101,100,0,115,116,97,114,116,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,0,0,115,107,105,112,32,119,47,111,32,115,99,97,108,105,110,103,0,0,0,0,0,0,0,0,35,35,35,32,70,73,78,65,76,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,82,69,83,85,76,84,83,32,35,35,35,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,45,110,114,46,32,37,108,100,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,111,109,0,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,110,111,116,32,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,45,99,97,108,108,115,58,32,37,108,100,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,105,109,112,111,114,116,32,115,116,97,114,116,32,118,97,108,117,101,115,10,102,105,108,101,58,32,37,115,10,116,105,109,101,58,32,37,103,0,0,0,117,110,97,98,108,101,32,116,111,32,114,101,97,100,32,105,110,112,117,116,45,102,105,108,101,32,60,37,115,62,32,91,37,115,93,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,103,41,0,0,36,90,69,82,79,46,0,0,36,112,68,69,82,46,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,100,105,115,99,114,101,116,101,0,0,0,0,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,108,100,41,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,115,41,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,100,101,114,40,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,105,116,105,97,108,32,112,114,111,98,108,101,109,58,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,58,32,32,37,108,100,32,40,37,108,100,32,115,116,97,116,101,115,32,43,32,37,108,100,32,112,97,114,97,109,101,116,101,114,115,32,43,32,37,108,100,32,100,105,115,99,114,101,116,101,32,114,101,97,108,115,41,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,91,37,108,100,93,32,100,105,115,99,114,101,116,101,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,58,32,32,37,108,100,32,40,37,108,100,32,101,113,117,97,116,105,111,110,115,32,43,32,37,108,100,32,97,108,103,111,114,105,116,104,109,115,41,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,97,114,116,32,118,97,108,117,101,32,114,101,115,105,100,117,97,108,115,58,32,37,108,100,0,0,0,0,91,37,108,100,93,32,114,101,115,105,100,117,97,108,32,105,115,32,105,110,101,102,102,101,99,116,105,118,101,32,40,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,32,105,115,32,115,101,116,32,116,111,32,49,46,48,41,0,0,0,0,0,0,0,110,111,32,105,112,111,112,116,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,124,32,82,101,115,117,108,116,32,111,102,32,108,101,97,115,116,83,113,117,97,114,101,32,109,101,116,104,111,100,32,61,32,37,103,46,32,84,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,105,116,115,32,116,111,32,116,104,101,32,115,121,115,116,101,109,0,0,0,0,0,0,0,0,108,101,97,115,116,83,113,117,97,114,101,61,37,103,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,111,108,118,101,114,32,105,116,101,114,97,116,101,100,32,37,100,32,116,105,109,101,115,32,119,105,116,104,111,117,116,32,102,105,110,100,105,110,103,32,97,32,115,111,108,117,116,105,111,110,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,99,111,110,115,105,115,116,101,110,116,32,105,110,105,116,105,97,108,32,99,111,110,100,105,116,105,111,110,115,46,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,78,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,32,60,32,49,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,78,76,79,79,80,32,60,32,49,46,0,0,0,0,0,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,105,116,101,114,97,116,105,111,110,115,58,32,37,108,100,0,116,114,121,32,45,105,108,115,32,116,111,32,97,99,116,105,118,97,116,101,32,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,0,0,0,0,0,0,0,37,115,95,105,110,105,116,80,97,116,104,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,105,116,101,114,97,116,105,111,110,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,37,108,100,44,0,0,0,0,37,46,49,54,103,44,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,108,97,109,98,100,97,32,105,115,32,37,45,51,103,32,105,110,32,115,116,101,112,61,37,54,100,32,97,116,32,102,61,37,103,32,91,37,103,93,0,105,110,99,114,101,97,115,105,110,103,32,108,97,109,98,100,97,32,116,111,32,37,45,51,103,32,105,110,32,115,116,101,112,32,37,54,100,32,97,116,32,102,61,37,103,0,0,0,102,120,114,32,61,32,37,103,0,0,0,0,0,0,0,0,102,120,107,32,61,32,37,103,0,0,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,114,114,111,114,32,105,110,32,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,37,46,49,54,103,44,0,0,37,105,44,0,0,0,0,0,34,37,115,34,44,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,116,105,109,101,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,65,49,32,98,116,46,32,105,114,49,32,110,97,32,32,84,106,32,32,114,101,32,32,97,99,32,32,110,116,32,32,115,111,32,32,32,114,32,32,32,121,32,32,32,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,50,0,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,102,105,108,101,32,37,115,0,0,0,0,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,0,0,67,97,110,110,111,116,32,119,114,105,116,101,32,116,111,32,102,105,108,101,32,37,115,0,67,97,110,110,111,116,32,97,108,108,111,99,32,109,101,109,111,114,121,0,0,0,0,0,77,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,119,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,114,43,0,0,0,0,0,0,119,43,0,0,0,0,0,0,97,43,0,0,0,0,0,0,119,98,0,0,0,0,0,0,97,98,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,119,43,98,0,0,0,0,0,97,43,98,0,0,0,0,0,100,101,114,40,0,0,0,0,104,0,0,0,0,0,0,0,48,246,0,0,8,0,0,0,9,0,0,0,152,255,255,255,152,255,255,255,48,246,0,0,10,0,0,0,11,0,0,0,212,245,0,0,76,246,0,0,96,246,0,0,232,245,0,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,111,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,176,1,0,0,246,0,0,136,107,1,0,0,0,0,0,104,0,0,0,0,0,0,0,136,107,1,0,12,0,0,0,13,0,0,0,152,255,255,255,152,255,255,255,136,107,1,0,14,0,0,0,15,0,0,0,0,0,0,0,216,246,0,0,16,0,0,0,17,0,0,0,3,0,0,0,8,0,0,0,2,0,0,0,4,0,0,0,31,0,0,0,32,0,0,0,9,0,0,0,33,0,0,0,34,0,0,0,24,0,0,0,10,0,0,0,25,0,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,176,1,0,168,246,0,0,128,106,1,0,0,0,0,0,0,0,0,0,96,247,0,0,104,247,0,0,88,247,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,56,247,0,0,72,247,0,0,88,247,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,99,112,117,32,116,105,109,101,32,91,115,93,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,83,105,109,117,108,97,116,105,111,110,32,116,105,109,101,32,91,115,93,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,0,0,0,0,0,65,117,116,111,109,97,116,105,99,32,111,117,116,112,117,116,32,115,116,101,112,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,79,112,101,110,77,111,100,101,108,105,99,97,32,121,101,116,46,32,83,101,116,32,110,117,109,112,111,105,110,116,115,32,62,61,32,48,46,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,32,102,97,105,108,101,100,0,0,0,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,35,80,116,111,108,101,109,121,32,80,108,111,116,32,102,105,108,101,44,32,103,101,110,101,114,97,116,101,100,32,98,121,32,79,112,101,110,77,111,100,101,108,105,99,97,10,0,0,35,78,117,109,98,101,114,111,102,86,97,114,105,97,98,108,101,115,61,37,100,10,0,0,35,73,110,116,101,114,118,97,108,83,105,122,101,61,37,108,100,10,0,0,0,0,0,0,84,105,116,108,101,84,101,120,116,58,32,79,112,101,110,77,111,100,101,108,105,99,97,32,115,105,109,117,108,97,116,105,111,110,32,112,108,111,116,10,0,0,0,0,0,0,0,0,88,76,97,98,101,108,58,32,116,10,10,0,0,0,0,0,68,97,116,97,83,101,116,58,32,116,105,109,101,10,0,0,68,97,116,97,83,101,116,58,32,36,99,112,117,84,105,109,101,10,0,0,0,0,0,0,68,97,116,97,83,101,116,58,32,37,115,10,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,119,114,105,116,101,32,116,111,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,37,46,49,54,103,44,32,37,46,49,54,103,10,0,0,0,114,101,99,111,110,58,119,97,108,108,58,118,48,49,0,0,0,0,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,112,97,114,97,109,115,0,0,99,111,110,116,105,110,117,111,117,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,101,116,97,0,0,0,116,97,98,115,0,0,0,0,111,98,106,115,0,0,0,0,116,109,101,116,97,0,0,0,115,105,103,115,0,0,0,0,116,105,109,101,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,118,109,101,116,97,0,0,0,84,105,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,97,108,115,0,0,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,105,110,118,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,118,97,108,117,101,82,101,102,101,114,101,110,99,101,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,102,105,108,101,78,97,109,101,0,0,0,0,0,0,0,0,115,116,97,114,116,76,105,110,101,0,0,0,0,0,0,0,115,116,97,114,116,67,111,108,117,109,110,0,0,0,0,0,101,110,100,76,105,110,101,0,101,110,100,67,111,108,117,109,110,0,0,0,0,0,0,0,102,105,108,101,87,114,105,116,97,98,108,101,0,0,0,0,117,115,101,83,116,97,114,116,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,102,105,120,101,100,0,0,0,117,115,101,78,111,109,105,110,97,108,0,0,0,0,0,0,110,111,109,105,110,97,108,0,109,105,110,0,0,0,0,0,109,97,120,0,0,0,0,0,82,101,97,108,32,37,115,40,37,115,115,116,97,114,116,61,37,103,37,115,44,32,102,105,120,101,100,61,37,115,44,32,37,115,110,111,109,105,110,97,108,61,37,103,37,115,44,32,109,105,110,61,37,103,44,32,109,97,120,61,37,103,41,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,116,101,103,101,114,32,37,115,40,37,115,115,116,97,114,116,61,37,108,100,37,115,44,32,102,105,120,101,100,61,37,115,44,32,109,105,110,61,37,108,100,44,32,109,97,120,61,37,108,100,41,0,0,0,66,111,111,108,101,97,110,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,44,32,102,105,120,101,100,61,37,115,41,0,0,0,0,0,0,83,116,114,105,110,103,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,41,0,95,105,110,105,116,46,120,109,108,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,97,110,32,110,111,116,32,114,101,97,100,32,102,105,108,101,32,37,115,32,97,115,32,115,101,116,117,112,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,46,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,88,77,76,32,112,97,114,115,101,114,33,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,37,115,44,32,37,115,32,37,108,117,10,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,103,117,105,100,0,0,0,0,84,104,101,32,77,111,100,101,108,32,71,85,73,68,58,32,37,115,32,105,115,32,110,111,116,32,115,101,116,32,105,110,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,0,69,114,114,111,114,44,32,116,104,101,32,71,85,73,68,58,32,37,115,32,102,114,111,109,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,58,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,71,85,73,68,32,99,111,109,112,105,108,101,100,32,105,110,32,116,104,101,32,109,111,100,101,108,58,32,37,115,0,0,114,101,97,100,32,97,108,108,32,116,104,101,32,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,32,118,97,108,117,101,115,58,0,0,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,115,116,97,114,116,84,105,109,101,32,61,32,37,103,0,0,115,116,111,112,84,105,109,101,0,0,0,0,0,0,0,0,115,116,111,112,84,105,109,101,32,61,32,37,103,0,0,0,115,116,101,112,83,105,122,101,0,0,0,0,0,0,0,0,115,116,101,112,83,105,122,101,32,61,32,37,103,0,0,0,116,111,108,101,114,97,110,99,101,0,0,0,0,0,0,0,116,111,108,101,114,97,110,99,101,32,61,32,37,103,0,0,115,111,108,118,101,114,0,0,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,0,0,0,0,0,0,0,111,117,116,112,117,116,70,111,114,109,97,116,0,0,0,0,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,37,115,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,70,105,108,116,101,114,0,0,118,97,114,105,97,98,108,101,32,102,105,108,116,101,114,58,32,37,115,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,0,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,58,32,37,115,0,0,0,0,110,117,109,98,101,114,79,102,67,111,110,116,105,110,117,111,117,115,83,116,97,116,101,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,82,101,97,108,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,110,117,109,98,101,114,79,102,82,101,97,108,80,97,114,97,109,101,116,101,114,115,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,111,100,101,108,46,0,0,0,0,110,120,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,100,0,0,0,0,0,0,0,110,121,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,112,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,121,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,112,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,37,115,0,0,0,0,114,101,97,108,32,115,116,97,116,101,115,0,0,0,0,0,105,115,80,114,111,116,101,99,116,101,100,0,0,0,0,0,102,105,108,116,101,114,105,110,103,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,32,37,115,0,114,101,97,108,32,115,116,97,116,101,32,100,101,114,105,118,97,116,105,118,101,115,0,0,114,101,97,108,32,97,108,103,101,98,114,97,105,99,115,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,114,101,97,108,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,0,0,97,108,105,97,115,0,0,0,110,101,103,97,116,101,100,65,108,105,97,115,0,0,0,0,114,101,97,100,32,102,111,114], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+56472);
/* memory initializer */ allocate([32,37,115,32,110,101,103,97,116,101,100,32,37,100,32,102,114,111,109,32,115,101,116,117,112,32,102,105,108,101,0,0,97,108,105,97,115,86,97,114,105,97,98,108,101,0,0,0,116,105,109,101,0,0,0,0,82,101,97,108,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,0,0,32,110,111,116,32,102,111,117,110,100,46,0,0,0,0,0,37,115,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,105,110,116,101,103,101,114,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,73,110,116,101,103,101,114,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,98,111,111,108,101,97,110,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,66,111,111,108,101,97,110,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,115,116,114,105,110,103,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,83,116,114,105,110,103,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,117,115,97,103,101,32,101,114,114,111,114,32,121,111,117,32,99,97,110,110,111,116,32,104,97,118,101,32,98,111,116,104,32,45,111,118,101,114,114,105,100,101,32,97,110,100,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,97,99,116,105,118,101,32,97,116,32,116,104,101,32,115,97,109,101,32,116,105,109,101,46,32,115,101,101,32,77,111,100,101,108,32,45,63,32,102,111,114,32,109,111,114,101,32,105,110,102,111,33,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,32,102,114,111,109,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,99,111,117,108,100,32,110,111,116,32,111,112,101,110,32,116,104,101,32,102,105,108,101,32,103,105,118,101,110,32,116,111,32,45,111,118,101,114,114,105,100,101,70,105,108,101,61,37,115,0,0,0,0,0,44,0,0,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,58,32,37,115,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,37,115,32,61,32,37,115,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,100,111,110,101,33,0,0,78,79,32,111,118,101,114,114,105,100,101,32,103,105,118,101,110,32,111,110,32,116,104,101,32,99,111,109,109,97,110,100,32,108,105,110,101,46,0,0,108,0,0,0,0,0,0,0,184,7,1,0,18,0,0,0,19,0,0,0,148,255,255,255,148,255,255,255,184,7,1,0,20,0,0,0,21,0,0,0,92,7,1,0,212,7,1,0,232,7,1,0,112,7,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,176,1,0,136,7,1,0,248,106,1,0,0,0,0,0,108,0,0,0,0,0,0,0,248,106,1,0,22,0,0,0,23,0,0,0,148,255,255,255,148,255,255,255,248,106,1,0,24,0,0,0,25,0,0,0,101,114,114,111,114,32,114,101,97,100,95,118,97,108,117,101,44,32,110,111,32,100,97,116,97,32,97,108,108,111,99,97,116,101,100,32,102,111,114,32,115,116,111,114,105,110,103,32,115,116,114,105,110,103,0,0,102,109,105,77,111,100,101,108,68,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,0,0,0,0,0,0,0,83,99,97,108,97,114,86,97,114,105,97,98,108,101,0,0,99,108,97,115,115,73,110,100,101,120,0,0,0,0,0,0,99,108,97,115,115,84,121,112,101,0,0,0,0,0,0,0,114,83,116,97,0,0,0,0,114,68,101,114,0,0,0,0,114,65,108,103,0,0,0,0,114,80,97,114,0,0,0,0,114,65,108,105,0,0,0,0,105,65,108,103,0,0,0,0,105,80,97,114,0,0,0,0,105,65,108,105,0,0,0,0,98,65,108,103,0,0,0,0,98,80,97,114,0,0,0,0,98,65,108,105,0,0,0,0,115,65,108,103,0,0,0,0,115,80,97,114,0,0,0,0,115,65,108,105,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,101,114,114,111,114,32,114,101,97,100,105,110,103,32,116,104,101,32,120,109,108,32,102,105,108,101,44,32,102,111,117,110,100,32,117,110,107,110,111,119,110,32,99,108,97,115,115,58,32,37,115,32,32,102,111,114,32,118,97,114,105,97,98,108,101,58,32,37,115,0,82,101,97,108,0,0,0,0,73,110,116,101,103,101,114,0,66,111,111,108,101,97,110,0,83,116,114,105,110,103,0,0,118,97,114,105,97,98,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,79,71,95,65,76,76,0,44,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,37,45,49,56,115,32,91,37,115,93,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,118,32,37,115,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,110,108,115,61,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,108,97,112,97,99,107,0,0,108,105,115,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,115,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,76,105,115,0,0,0,0,0,94,40,0,0,0,0,0,0,41,36,0,0,0,0,0,0,36,100,117,109,109,121,0,0,46,42,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,58,32,0,0,32,119,105,116,104,32,101,114,114,111,114,58,32,0,0,0,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,111,117,116,112,117,116,116,105,110,103,32,97,108,108,32,118,97,114,105,97,98,108,101,115,46,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,114,118,97,108,115,32,61,32,37,108,100,0,67,80,85,0,0,0,0,0,82,84,0,0,0,0,0,0,67,89,67,0,0,0,0,0,91,117,110,107,110,111,119,110,32,99,108,111,99,107,45,116,121,112,101,93,32,103,111,116,32,37,115,44,32,101,120,112,101,99,116,101,100,32,67,80,85,124,82,84,124,67,89,67,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,82,84,46,0,0,0,0,0,67,104,111,115,101,110,32,99,108,111,99,107,45,116,121,112,101,58,32,37,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,114,101,97,108,45,116,105,109,101,46,0,0,76,105,110,101,97,114,105,122,97,116,105,111,110,32,119,105,108,108,32,112,101,114,102,111,114,109,101,100,32,97,116,32,112,111,105,110,116,32,111,102,32,116,105,109,101,58,32,37,102,0,0,0,0,0,0,0,111,118,101,114,119,114,105,116,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,32,91,102,114,111,109,32,99,111,109,109,97,110,100,32,108,105,110,101,93,0,95,114,101,115,46,0,0,0,0,0,0,0,0,0,0,0,76,105,110,101,97,114,32,109,111,100,101,108,32,105,115,32,99,114,101,97,116,101,100,33,0,0,0,0,0,0,0,0,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,95,112,114,111,102,46,112,108,116,0,0,0,0,0,0,0,115,118,103,0,0,0,0,0,101,109,112,116,121,0,0,0,99,115,118,0,0,0,0,0,109,97,116,0,0,0,0,0,119,97,108,108,0,0,0,0,112,108,116,0,0,0,0,0,85,110,107,110,111,119,110,32,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,0,65,108,108,111,99,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,115,116,111,114,97,103,101,32,102,111,114,32,109,101,116,104,111,100,32,39,37,115,39,32,97,110,100,32,102,105,108,101,61,39,37,115,39,0,0,176,17,1,0,152,19,1,0,160,19,1,0,232,21,1,0,0,20,1,0,16,20,1,0,240,21,1,0,248,21,1,0,0,22,1,0,8,22,1,0,24,22,1,0,40,22,1,0,56,22,1,0,72,22,1,0,88,22,1,0,104,22,1,0,120,22,1,0,144,22,1,0,200,21,1,0,224,21,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,115,32,37,115,0,0,0,0,0,0,0,176,17,1,0,152,19,1,0,160,19,1,0,176,19,1,0,0,20,1,0,16,20,1,0,32,20,1,0,64,20,1,0,96,20,1,0,128,20,1,0,168,20,1,0,208,20,1,0,248,20,1,0,32,21,1,0,56,21,1,0,88,21,1,0,120,21,1,0,160,21,1,0,200,21,1,0,224,21,1,0,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,37,115,0,0,0,117,115,97,103,101,58,32,37,115,0,0,0,0,0,0,0,60,45,37,115,62,10,32,32,37,115,0,0,0,0,0,0,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,32,32,37,115,0,91,117,110,107,110,111,119,110,32,102,108,97,103,45,116,121,112,101,93,32,60,45,37,115,62,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,108,111,103,70,111,114,109,97,116,61,37,115,44,32,101,120,112,101,99,116,101,100,32,116,101,120,116,32,111,114,32,120,109,108,0,0,0,0,0,0,0,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,62,10,37,115,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,37,115,0,0,0,0,176,17,1,0,120,19,1,0,128,19,1,0,136,19,1,0,176,17,1,0,184,18,1,0,8,19,1,0,56,19,1,0,176,17,1,0,120,18,1,0,128,18,1,0,136,18,1,0,152,18,1,0,160,18,1,0,176,18,1,0,0,0,0,0,176,17,1,0,184,17,1,0,208,17,1,0,224,17,1,0,40,18,1,0,56,18,1,0,88,18,1,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,104,101,108,112,61,37,115,0,0,0,117,115,101,32,37,115,32,45,104,101,108,112,32,102,111,114,32,97,32,108,105,115,116,32,111,102,32,97,108,108,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,67,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,103,108,111,98,97,108,32,100,97,116,97,32,115,116,114,117,99,116,117,114,101,32,102,105,108,101,0,0,0,0,0,0,78,111,32,118,97,114,105,97,98,108,101,115,32,105,110,32,116,104,101,32,109,111,100,101,108,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,109,111,100,101,108,62,37,115,60,47,109,111,100,101,108,62,10,0,0,0,0,0,0,60,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,37,103,60,47,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,10,0,0,60,111,108,100,84,105,109,101,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,62,10,0,0,0,0,0,0,0,60,111,108,100,84,105,109,101,50,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,50,62,10,0,0,0,0,0,60,100,105,102,102,79,108,100,84,105,109,101,62,37,103,60,47,100,105,102,102,79,108,100,84,105,109,101,62,10,0,0,60,99,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,99,117,114,114,101,110,116,84,105,109,101,62,10,0,0,60,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,10,0,0,5,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,69,114,114,111,114,58,32,0,85,110,104,97,110,100,108,101,100,32,65,115,115,101,114,116,105,111,110,45,69,114,114,111,114,0,0,0,0,0,0,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,101,117,108,101,114,0,0,0,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,114,97,100,97,117,53,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,51,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,49,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,108,111,98,97,116,116,111,50,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,113,115,115,0,0,0,0,0,100,97,115,115,108,0,0,0,114,97,100,97,117,53,0,0,114,97,100,97,117,51,0,0,114,97,100,97,117,49,0,0,108,111,98,97,116,116,111,50,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,0,0,0,0,0,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,60,115,116,97,116,117,115,62,0,0,0,0,0,0,0,0,60,112,104,97,115,101,62,85,78,75,78,79,87,78,60,47,112,104,97,115,101,62,0,0,60,47,115,116,97,116,117,115,62,0,0,0,0,0,0,0,44,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,115,101,101,100,58,32,100,97,116,97,45,62,115,105,109,117,108,97,116,105,111,110,73,110,102,111,46,97,110,97,108,121,116,105,99,74,97,99,111,98,105,97,110,115,91,105,110,100,101,120,93,46,115,101,101,100,86,97,114,115,91,37,100,93,61,32,37,102,0,0,0,0,119,114,105,116,101,32,105,110,32,106,97,99,91,37,100,93,45,91,37,100,44,37,100,93,61,37,103,32,102,114,111,109,32,114,111,119,91,37,100,93,61,37,103,0,0,0,0,0,80,114,105,110,116,32,106,97,99,58,0,0,0,0,0,0,37,32,46,53,101,32,0,0,99,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,65,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,66,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,67,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,68,32,0,0,0,0,105,32,102,111,114,32,105,32,105,110,32,49,58,48,0,0,108,105,110,101,97,114,95,0,46,109,111,0,0,0,0,0,119,98,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,0,0,0,0,0,56,0,0,0,0,0,0,0,208,24,1,0,26,0,0,0,27,0,0,0,200,255,255,255,200,255,255,255,208,24,1,0,28,0,0,0,29,0,0,0,92,24,1,0,236,24,1,0,0,25,1,0,112,24,1,0,78,83,116,51,95,95,49,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,176,1,0,136,24,1,0,136,107,1,0,0,0,0,0,56,0,0,0,0,0,0,0,136,107,1,0,12,0,0,0,13,0,0,0,200,255,255,255,200,255,255,255,136,107,1,0,14,0,0,0,15,0,0,0,0,0,0,0,144,25,1,0,30,0,0,0,31,0,0,0,4,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,36,0,0,0,34,0,0,0,26,0,0,0,10,0,0,0,27,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,0,176,1,0,72,25,1,0,128,106,1,0,0,0,0,0,67,97,108,117,99,117,108,97,116,101,32,111,110,101,32,99,111,108,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,103,110,117,112,108,111,116,0,80,108,111,116,115,32,111,102,32,112,114,111,102,105,108,105,110,103,32,100,97,116,97,32,119,101,114,101,32,100,105,115,97,98,108,101,100,58,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,58,32,37,115,10,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,115,118,103,10,0,0,0,0,0,0,0,115,101,116,32,110,111,107,101,121,10,0,0,0,0,0,0,115,101,116,32,102,111,114,109,97,116,32,121,32,34,37,103,34,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,111,102,32,103,108,111,98,97,108,32,115,116,101,112,115,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,100,111,99,32,91,32,32,60,33,69,76,69,77,69,78,84,32,115,105,109,117,108,97,116,105,111,110,32,40,109,111,100,101,108,105,110,102,111,44,32,118,97,114,105,97,98,108,101,115,44,32,102,117,110,99,116,105,111,110,115,44,32,101,113,117,97,116,105,111,110,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,118,97,114,105,97,98,108,101,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,101,113,117,97,116,105,111,110,32,40,114,101,102,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,101,113,117,97,116,105,111,110,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,115,32,40,112,114,111,102,105,108,101,98,108,111,99,107,42,41,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,32,40,114,101,102,115,44,32,110,99,97,108,108,44,32,116,105,109,101,44,32,109,97,120,84,105,109,101,41,62,32,32,60,33,69,76,69,77,69,78,84,32,114,101,102,115,32,40,114,101,102,42,41,62,32,32,60,33,65,84,84,76,73,83,84,32,114,101,102,32,114,101,102,105,100,32,73,68,82,69,70,32,35,82,69,81,85,73,82,69,68,62,32,32,93,62,10,0,0,0,0,116,105,109,101,40,41,32,102,97,105,108,101,100,58,32,37,115,0,0,0,0,0,0,0,37,89,45,37,109,45,37,100,32,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,115,116,114,102,116,105,109,101,40,41,32,102,97,105,108,101,100,0,0,0,0,0,0,0,60,115,105,109,117,108,97,116,105,111,110,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,62,10,0,0,0,0,60,110,97,109,101,62,0,0,60,47,110,97,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,102,105,120,62,0,0,0,0,0,0,0,0,60,47,112,114,101,102,105,120,62,10,0,0,0,0,0,0,60,100,97,116,101,62,0,0,60,47,100,97,116,101,62,10,0,0,0,0,0,0,0,0,60,109,101,116,104,111,100,62,0,0,0,0,0,0,0,0,60,47,109,101,116,104,111,100,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,111,114,109,97,116,62,0,0,60,47,111,117,116,112,117,116,70,111,114,109,97,116,62,10,0,0,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,0,0,0,0,0,0,0,0,60,47,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,37,108,100,60,47,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,10,0,0,0,60,111,118,101,114,104,101,97,100,84,105,109,101,62,37,102,60,47,111,118,101,114,104,101,97,100,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,105,110,105,116,84,105,109,101,62,37,102,60,47,112,114,101,105,110,105,116,84,105,109,101,62,10,0,0,60,105,110,105,116,84,105,109,101,62,37,102,60,47,105,110,105,116,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,101,118,101,110,116,84,105,109,101,62,37,102,60,47,101,118,101,110,116,84,105,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,84,105,109,101,62,37,102,60,47,111,117,116,112,117,116,84,105,109,101,62,10,0,0,0,0,60,108,105,110,101,97,114,105,122,101,84,105,109,101,62,37,102,60,47,108,105,110,101,97,114,105,122,101,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,84,105,109,101,62,37,102,60,47,116,111,116,97,108,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,37,102,60,47,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,10,0,0,0,0,60,110,117,109,83,116,101,112,62,37,100,60,47,110,117,109,83,116,101,112,62,10,0,0,60,109,97,120,84,105,109,101,62,37,46,57,102,60,47,109,97,120,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,0,60,111,100,101,84,105,109,101,62,37,102,60,47,111,100,101,84,105,109,101,62,10,0,0,60,111,100,101,84,105,109,101,84,105,99,107,115,62,37,108,117,60,47,111,100,101,84,105,109,101,84,105,99,107,115,62,10,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,60,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,0,60,47,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,60,118,97,114,105,97,98,108,101,115,62,10,0,0,0,0,60,47,118,97,114,105,97,98,108,101,115,62,10,0,0,0,60,102,117,110,99,116,105,111,110,115,62,10,0,0,0,0,60,47,102,117,110,99,116,105,111,110,115,62,10,0,0,0,60,101,113,117,97,116,105,111,110,115,62,10,0,0,0,0,60,47,101,113,117,97,116,105,111,110,115,62,10,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,60,47,115,105,109,117,108,97,116,105,111,110,62,10,0,0,98,117,102,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,109,111,100,101,108,105,110,102,111,46,99,0,0,112,114,105,110,116,77,111,100,101,108,73,110,102,111,0,0,87,97,114,110,105,110,103,58,32,80,108,111,116,32,99,111,109,109,97,110,100,32,102,97,105,108,101,100,10,0,0,0,120,115,108,116,112,114,111,99,0,0,0,0,0,0,0,0,37,115,32,45,111,32,37,115,95,112,114,111,102,46,104,116,109,108,32,37,115,47,115,104,97,114,101,47,111,109,99,47,115,99,114,105,112,116,115,47,100,101,102,97,117,108,116,95,112,114,111,102,105,108,105,110,103,46,120,115,108,32,37,115,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,103,101,110,101,114,97,116,101,32,104,116,109,108,32,118,101,114,115,105,111,110,32,111,102,32,112,114,111,102,105,108,105,110,103,32,114,101,115,117,108,116,115,58,32,37,115,10,0,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,97,114,101,32,115,116,111,114,101,100,32,105,110,32,37,115,95,112,114,111,102,46,104,116,109,108,32,40,104,117,109,97,110,45,114,101,97,100,97,98,108,101,41,32,97,110,100,32,37,115,95,112,114,111,102,46,120,109,108,32,40,102,111,114,32,88,83,76,32,116,114,97,110,115,102,111,114,109,115,32,111,114,32,109,111,114,101,32,100,101,116,97,105,108,115,41,0,0,0,0,0,0,101,113,0,0,0,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,101,113,37,100,34,47,62,10,0,0,0,0,60,110,99,97,108,108,62,37,100,60,47,110,99,97,108,108,62,10,0,0,0,0,0,0,60,116,105,109,101,62,37,46,57,102,60,47,116,105,109,101,62,10,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,0,0,0,0,0,0,0,60,101,113,117,97,116,105,111,110,32,105,100,61,34,101,113,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,0,34,62,10,0,0,0,0,0,60,114,101,102,115,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,118,97,114,37,100,34,32,47,62,10,0,0,60,47,114,101,102,115,62,10,0,0,0,0,0,0,0,0,60,99,97,108,99,105,110,102,111,32,116,105,109,101,61,34,37,102,34,32,99,111,117,110,116,61,34,37,108,117,34,47,62,10,0,0,0,0,0,0,60,47,101,113,117,97,116,105,111,110,62,10,0,0,0,0,102,117,110,0,0,0,0,0,60,102,117,110,99,116,105,111,110,32,105,100,61,34,102,117,110,37,100,34,62,10,0,0,60,47,102,117,110,99,116,105,111,110,62,10,0,0,0,0,60,105,110,102,111,32,102,105,108,101,110,97,109,101,61,34,0,0,0,0,0,0,0,0,34,32,115,116,97,114,116,108,105,110,101,61,34,37,100,34,32,115,116,97,114,116,99,111,108,61,34,37,100,34,32,101,110,100,108,105,110,101,61,34,37,100,34,32,101,110,100,99,111,108,61,34,37,100,34,32,114,101,97,100,111,110,108,121,61,34,37,115,34,32,47,62,10,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,60,118,97,114,105,97,98,108,101,32,105,100,61,34,118,97,114,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,34,32,99,111,109,109,101,110,116,61,34,0,0,0,0,0,60,47,118,97,114,105,97,98,108,101,62,10,0,0,0,0,37,115,95,112,114,111,102,46,100,97,116,97,0,0,0,0,60,102,105,108,101,110,97,109,101,62,0,0,0,0,0,0,60,47,102,105,108,101,110,97,109,101,62,10,0,0,0,0,60,102,105,108,101,115,105,122,101,62,37,108,100,60,47,102,105,108,101,115,105,122,101,62,10,0,0,0,0,0,0,0,60,102,111,114,109,97,116,62,10,0,0,0,0,0,0,0,60,117,105,110,116,51,50,62,115,116,101,112,60,47,117,105,110,116,51,50,62,10,0,0,60,100,111,117,98,108,101,62,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,60,100,111,117,98,108,101,62,99,112,117,32,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,0,0,0,0,60,117,105,110,116,51,50,62,0,0,0,0,0,0,0,0,32,40,99,97,108,108,115,41,60,47,117,105,110,116,51,50,62,10,0,0,0,0,0,0,60,100,111,117,98,108,101,62,0,0,0,0,0,0,0,0,32,40,99,112,117,32,116,105,109,101,41,60,47,100,111,117,98,108,101,62,10,0,0,0,60,47,102,111,114,109,97,116,62,10,0,0,0,0,0,0,114,98,0,0,0,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,112,111,115,59,0,0,38,113,117,111,116,59,0,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,50,100,111,117,98,108,101,37,37,42,37,100,117,105,110,116,51,50,37,37,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,49,58,40,36,37,100,62,49,101,45,57,32,63,32,36,37,100,32,58,32,49,101,45,51,48,41,32,119,32,108,32,108,119,32,37,100,10,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,42,50,100,111,117,98,108,101,37,37,37,100,117,105,110,116,51,50,37,37,42,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,37,100,32,119,32,108,32,108,119,32,37,100,10,0,0,0,0,0,0,0,0,117,110,115,101,116,32,120,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,121,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,98,111,114,100,101,114,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,115,101,116,32,116,105,116,108,101,10,0,0,0,0,0,0,115,101,116,32,120,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,108,111,103,32,121,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,37,103,93,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,42,93,10,0,0,0,0,0,0,0,115,101,116,32,110,111,108,111,103,32,120,121,10,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,37,103,58,37,103,93,10,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,0,0,115,101,116,32,121,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,120,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,98,111,114,100,101,114,10,0,0,0,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,37,115,10,0,0,0,0,0,0,0,0,115,101,116,32,116,105,116,108,101,32,34,37,115,34,10,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,97,116,32,116,105,109,101,34,10,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,91,115,93,34,10,0,0,0,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,37,115,34,10,0,0,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,110,117,109,98,101,114,34,10,0,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,99,111,117,110,116,34,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,37,115,58,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,101,120,112,97,116,32,111,98,106,101,99,116,0,0,0,68,117,109,109,121,32,101,113,117,97,116,105,111,110,32,115,111,32,119,101,32,99,97,110,32,105,110,100,101,120,32,102,114,111,109,32,49,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,105,109,117,108,97,116,105,111,110,95,105,110,102,111,95,120,109,108,46,99,0,0,0,0,0,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,120,109,108,45,62,110,69,113,117,97,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,49,93,0,0,0,109,111,100,101,108,73,110,102,111,88,109,108,73,110,105,116,0,0,0,0,0,0,0,0,120,109,108,45,62,110,70,117,110,99,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,51,93,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,119,101,32,111,110,108,121,32,104,97,118,101,32,37,108,100,32,115,117,99,104,32,98,108,111,99,107,115,0,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,105,116,33,0,0,0,0,0,0,118,97,114,105,97,98,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,113,117,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,97,114,0,0,76,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,105,110,100,101,120,32,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,0,110,111,110,108,105,110,101,97,114,0,0,0,0,0,0,0,78,111,110,108,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,114,101,115,105,100,117,97,108,70,117,110,99,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,101,102,105,110,101,115,0,110,97,109,101,0,0,0,0,60,100,101,102,105,110,101,115,62,32,110,101,101,100,115,32,116,111,32,104,97,118,101,32,101,120,97,99,116,108,121,32,111,110,101,32,97,116,116,114,105,98,117,116,101,58,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,0,0,0,0,102,105,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,83,116,97,114,116,0,0,0,0,0,0,0,108,105,110,101,69,110,100,0,99,111,108,83,116,97,114,116,0,0,0,0,0,0,0,0,99,111,108,69,110,100,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,37,115,58,32,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,105,110,32,60,105,110,102,111,62,0,37,115,58,32,73,110,102,111], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+66712);
/* memory initializer */ allocate([32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,109,111,114,101,32,101,113,117,97,116,105,111,110,115,32,116,104,97,110,32,101,120,112,101,99,116,101,100,32,40,37,108,100,41,0,0,0,0,105,110,100,101,120,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,111,117,116,32,105,110,100,101,120,0,0,0,0,0,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,103,111,116,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,105,110,100,101,120,32,37,108,100,44,32,101,120,112,101,99,116,101,100,32,37,108,100,0,0,0,0,0,0,0,83,79,77,69,32,78,73,67,69,32,69,81,85,65,84,73,79,78,32,78,65,77,69,32,40,116,111,32,98,101,32,115,101,116,32,97,32,108,105,116,116,108,101,32,108,97,116,101,114,41,0,0,0,0,0,0,99,111,109,109,101,110,116,0,60,118,97,114,62,45,116,97,103,32,100,105,100,32,110,111,116,32,115,101,116,32,110,97,109,101,32,97,110,100,32,99,111,109,109,101,110,116,0,0,35,70,73,88,77,69,35,0,84,79,68,79,58,32,83,101,116,32,109,101,32,117,112,33,33,33,0,0,0,0,0,0,100,117,109,109,121,86,97,114,83,116,97,116,101,83,101,116,74,97,99,0,0,0,0,0,255,255,255,255,32,46,1,0,32,46,1,0,32,46,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,100,32,39,37,115,39,32,116,104,97,116,32,119,97,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,97,115,32,60,118,97,114,105,97,98,108,101,62,0,0,0,0,0,63,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,78,65,77,69,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,83,67,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,84,65,73,76,69,68,95,68,69,83,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,97,99,104,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,111,110,99,101,58,32,37,115,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,37,115,0,83,84,79,80,32,0,0,0,32,115,116,97,116,101,109,101,110,116,32,101,120,101,99,117,116,101,100,10,0,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,110,100,102,105,108,101,0,101,114,114,111,114,32,105,110,32,102,111,114,109,97,116,0,105,108,108,101,103,97,108,32,117,110,105,116,32,110,117,109,98,101,114,0,0,0,0,0,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,100,105,114,101,99,116,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,115,101,113,117,101,110,116,105,97,108,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,99,97,110,39,116,32,98,97,99,107,115,112,97,99,101,32,102,105,108,101,0,0,0,0,110,117,108,108,32,102,105,108,101,32,110,97,109,101,0,0,99,97,110,39,116,32,115,116,97,116,32,102,105,108,101,0,117,110,105,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,111,102,102,32,101,110,100,32,111,102,32,114,101,99,111,114,100,0,0,0,0,0,0,0,116,114,117,110,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,101,110,100,102,105,108,101,0,0,0,0,105,110,99,111,109,112,114,101,104,101,110,115,105,98,108,101,32,108,105,115,116,32,105,110,112,117,116,0,0,0,0,0,111,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,0,0,0,0,0,0,0,114,101,97,100,32,117,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,98,97,100,32,108,111,103,105,99,97,108,32,105,110,112,117,116,32,102,105,101,108,100,0,98,97,100,32,118,97,114,105,97,98,108,101,32,116,121,112,101,0,0,0,0,0,0,0,98,97,100,32,110,97,109,101,108,105,115,116,32,110,97,109,101,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,32,110,111,116,32,105,110,32,110,97,109,101,108,105,115,116,0,0,0,0,0,0,0,0,110,111,32,101,110,100,32,114,101,99,111,114,100,0,0,0,118,97,114,105,97,98,108,101,32,99,111,117,110,116,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,32,102,111,114,32,115,99,97,108,97,114,32,118,97,114,105,97,98,108,101,0,0,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,115,101,99,116,105,111,110,0,0,0,115,117,98,115,116,114,105,110,103,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,115,117,98,115,99,114,105,112,116,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,99,97,110,39,116,32,114,101,97,100,32,102,105,108,101,0,99,97,110,39,116,32,119,114,105,116,101,32,102,105,108,101,0,0,0,0,0,0,0,0,39,110,101,119,39,32,102,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,0,0,99,97,110,39,116,32,97,112,112,101,110,100,32,116,111,32,102,105,108,101,0,0,0,0,110,111,110,45,112,111,115,105,116,105,118,101,32,114,101,99,111,114,100,32,110,117,109,98,101,114,0,0,0,0,0,0,110,109,76,98,117,102,32,111,118,101,114,102,108,111,119,0,200,48,1,0,216,48,1,0,240,48,1,0,16,49,1,0,48,49,1,0,72,49,1,0,104,49,1,0,128,49,1,0,144,49,1,0,160,49,1,0,184,49,1,0,208,49,1,0,240,49,1,0,16,50,1,0,160,49,1,0,40,50,1,0,72,50,1,0,96,50,1,0,120,50,1,0,144,50,1,0,176,50,1,0,192,50,1,0,224,50,1,0,0,51,1,0,24,51,1,0,48,51,1,0,72,51,1,0,88,51,1,0,112,51,1,0,136,51,1,0,160,51,1,0,192,51,1,0,37,115,58,32,105,108,108,101,103,97,108,32,101,114,114,111,114,32,110,117,109,98,101,114,32,37,100,10,0,0,0,0,37,115,58,32,101,110,100,32,111,102,32,102,105,108,101,10,0,0,0,0,0,0,0,0,37,115,58,32,37,115,10,0,0,0,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,117,110,105,116,32,37,100,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+76952);
/* memory initializer */ allocate([110,97,109,101,100,32,37,115,10,0,0,0,0,0,0,0,40,117,110,110,97,109,101,100,41,10,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,105,110,116,101,114,110,97,108,32,73,47,79,10,0,0,0,0,0,0,0,0,0,0,0,108,97,115,116,32,102,111,114,109,97,116,58,32,37,115,10,0,0,0,0,0,0,0,0,108,97,116,101,108,121,32,37,115,32,37,115,32,37,115,32,37,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,101,97,100,105,110,103,0,119,114,105,116,105,110,103,0,0,0,0,0,0,0,0,0,115,101,113,117,101,110,116,105,97,108,0,0,0,0,0,0,100,105,114,101,99,116,0,0,0,0,0,0,0,0,0,0,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,105,110,116,101,114,110,97,108,0,0,0,0,0,0,0,0,32,73,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+83824);
/* memory initializer */ allocate([117,110,107,110,111,119,110,32,99,111,100,101,32,105,110,32,100,111,95,102,105,111,58,32,37,100,10,37,115,10,0,0,100,111,95,102,105,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,100,32,115,116,114,105,110,103,0,0,0,0,0,0,102,111,114,109,97,116,32,116,111,111,32,99,111,109,112,108,105,99,97,116,101,100,58,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,0,0,0,0,0,0,0,200,92,1,0,208,92,1,0,119,98,0,0,0,0,0,0,119,0,0,0,0,0,0,0,114,43,98,0,0,0,0,0,114,43,0,0,0,0,0,0,224,92,1,0,232,92,1,0,240,92,1,0,248,92,1,0,144,1,0,0,0,0,0,0,104,93,1,0,0,0,0,0,111,112,101,110,0,0,0,0,102,111,114,116,46,37,108,100,0,0,0,0,0,0,0,0,110,111,32,115,112,97,99,101,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,102,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,117,114,101,0,0,115,116,97,114,116,105,111,0,115,102,101,0,0,0,0,0,37,35,46,42,69,0,0,0,37,43,46,50,100,0,0,0,37,35,46,42,102,0,0,0,119,95,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,0,119,95,110,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,108,101,102,116,32,111,102,102,0,0,0,0,0,0,0,0,114,101,99,101,110,100,0,0,115,116,97,114,116,105,111,0,119,114,105,116,101,32,115,116,97,114,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+89048);
/* memory initializer */ allocate([64,100,1,0,32,0,0,0,33,0,0,0,5,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,37,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,0,176,1,0,32,100,1,0,192,106,1,0,0,0,0,0,0,0,0,0,168,100,1,0,34,0,0,0,35,0,0,0,6,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,42,0,0,0,43,0,0,0,30,0,0,0,15,0,0,0,31,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,0,176,1,0,144,100,1,0,192,106,1,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,0,0,0,0,64,101,1,0,36,0,0,0,37,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,44,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,16,0,0,0,33,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,0,176,1,0,32,101,1,0,128,106,1,0,0,0,0,0,0,0,0,0,168,101,1,0,38,0,0,0,39,0,0,0,8,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,46,0,0,0,47,0,0,0,34,0,0,0,10,0,0,0,35,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,0,176,1,0,144,101,1,0,128,106,1,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,216,175,1,0,184,101,1,0,0,0,0,0,32,102,1,0,40,0,0,0,41,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,200,102,1,0,42,0,0,0,43,0,0,0,49,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,0,176,1,0,16,102,1,0,0,0,0,0,0,0,0,0,0,0,0,0,96,102,1,0,40,0,0,0,44,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,0,176,1,0,72,102,1,0,32,102,1,0,0,0,0,0,0,0,0,0,160,102,1,0,40,0,0,0,45,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,0,176,1,0,136,102,1,0,32,102,1,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,0,176,1,0,176,102,1,0,0,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,0,0,0,0,16,103,1,0,46,0,0,0,47,0,0,0,49,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,0,176,1,0,248,102,1,0,200,102,1,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,216,175,1,0,32,103,1,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,0,176,1,0,72,103,1,0,64,103,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,0,0,0,0,248,105,1,0,48,0,0,0,49,0,0,0,0,0,0,0,128,106,1,0,50,0,0,0,51,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,10,0,0,0,35,0,0,0,0,0,0,0,192,106,1,0,52,0,0,0,53,0,0,0,9,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,15,0,0,0,31,0,0,0,8,0,0,0,0,0,0,0,248,106,1,0,22,0,0,0,23,0,0,0,248,255,255,255,248,255,255,255,248,106,1,0,24,0,0,0,25,0,0,0,8,0,0,0,0,0,0,0,64,107,1,0,54,0,0,0,55,0,0,0,248,255,255,255,248,255,255,255,64,107,1,0,56,0,0,0,57,0,0,0,4,0,0,0,0,0,0,0,136,107,1,0,12,0,0,0,13,0,0,0,252,255,255,255,252,255,255,255,136,107,1,0,14,0,0,0,15,0,0,0,4,0,0,0,0,0,0,0,208,107,1,0,58,0,0,0,59,0,0,0,252,255,255,255,252,255,255,255,208,107,1,0,60,0,0,0,61,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,105,1,0,62,0,0,0,63,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,192,105,1,0,64,0,0,0,65,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,0,176,1,0,120,105,1,0,16,103,1,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,216,175,1,0,168,105,1,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,176,1,0,200,105,1,0,192,105,1,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,176,1,0,8,106,1,0,192,105,1,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,216,175,1,0,72,106,1,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,216,175,1,0,136,106,1,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,96,176,1,0,200,106,1,0,0,0,0,0,1,0,0,0,248,105,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,96,176,1,0,16,107,1,0,0,0,0,0,1,0,0,0,56,106,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,96,176,1,0,88,107,1,0,0,0,0,0,1,0,0,0,248,105,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,96,176,1,0,160,107,1,0,0,0,0,0,1,0,0,0,56,106,1,0,3,244,255,255,0,0,0,0,48,108,1,0,66,0,0,0,67,0,0,0,50,0,0,0,2,0,0,0,17,0,0,0,18,0,0,0,3,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,0,176,1,0,16,108,1,0,96,103,1,0,0,0,0,0,0,0,0,0,88,122,1,0,68,0,0,0,69,0,0,0,70,0,0,0,1,0,0,0,9,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,122,1,0,71,0,0,0,72,0,0,0,70,0,0,0,2,0,0,0,10,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,127,1,0,73,0,0,0,74,0,0,0,70,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,200,127,1,0,75,0,0,0,76,0,0,0,70,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,128,1,0,77,0,0,0,78,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,23,0,0,0,8,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,129,1,0,79,0,0,0,80,0,0,0,70,0,0,0,10,0,0,0,11,0,0,0,25,0,0,0,12,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,72,124,1,0,81,0,0,0,82,0,0,0,70,0,0,0,51,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,72,124,1,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,72,58,37,77,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,232,124,1,0,83,0,0,0,84,0,0,0,70,0,0,0,59,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,232,124,1,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,120,125,1,0,85,0,0,0,86,0,0,0,70,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,125,1,0,87,0,0,0,88,0,0,0,70,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,122,1,0,89,0,0,0,90,0,0,0,70,0,0,0,67,0,0,0,68,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,69,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,123,1,0,91,0,0,0,92,0,0,0,70,0,0,0,70,0,0,0,71,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,72,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,123,1,0,93,0,0,0,94,0,0,0,70,0,0,0,73,0,0,0,74,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,75,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,123,1,0,95,0,0,0,96,0,0,0,70,0,0,0,76,0,0,0,77,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,78,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,129,1,0,97,0,0,0,98,0,0,0,70,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,76,102,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,0,0,0,0,64,130,1,0,99,0,0,0,100,0,0,0,70,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,0,0,0,0,208,130,1,0,101,0,0,0,102,0,0,0,70,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,0,0,0,0,96,131,1,0,103,0,0,0,104,0,0,0,70,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,126,1,0,105,0,0,0,106,0,0,0,70,0,0,0,21,0,0,0,14,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,126,1,0,107,0,0,0,108,0,0,0,70,0,0,0,22,0,0,0,15,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,118,101,99,116,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,48,122,1,0,109,0,0,0,110,0,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,119,1,0,111,0,0,0,112,0,0,0,70,0,0,0,36,0,0,0,23,0,0,0,37,0,0,0,24,0,0,0,38,0,0,0,28,0,0,0,25,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,119,1,0,113,0,0,0,114,0,0,0,70,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,79,0,0,0,80,0,0,0,5,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,121,1,0,115,0,0,0,116,0,0,0,70,0,0,0,82,0,0,0,83,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,8,122,1,0,117,0,0,0,118,0,0,0,70,0,0,0,84,0,0,0,85,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,116,114,117,101,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,0,0,0,0,64,118,1,0,119,0,0,0,120,0,0,0,70,0,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,0,176,1,0,40,118,1,0,216,101,1,0,0,0,0,0,0,0,0,0,208,118,1,0,119,0,0,0,121,0,0,0,70,0,0,0,26,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,39,0,0,0,27,0,0,0,40,0,0,0,28,0,0,0,41,0,0,0,32,0,0,0,29,0,0,0,6,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,216,175,1,0,176,118,1,0,96,176,1,0,152,118,1,0,0,0,0,0,2,0,0,0,64,118,1,0,2,0,0,0,200,118,1,0,2,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,96,176,1,0,240,118,1,0,0,0,0,0,2,0,0,0,64,118,1,0,2,0,0,0,200,118,1,0,2,0,0,0,0,0,0,0,160,119,1,0,119,0,0,0,122,0,0,0,70,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,86,0,0,0,87,0,0,0,8,0,0,0,88,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,216,175,1,0,128,119,1,0,96,176,1,0,88,119,1,0,0,0,0,0,2,0,0,0,64,118,1,0,2,0,0,0,152,119,1,0,2,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,96,176,1,0,192,119,1,0,0,0,0,0,2,0,0,0,64,118,1,0,2,0,0,0,152,119,1,0,2,0,0,0,0,0,0,0,96,120,1,0,119,0,0,0,123,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,9,0,0,0,89,0,0,0,90,0,0,0,10,0,0,0,91,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,96,176,1,0,56,120,1,0,0,0,0,0,2,0,0,0,64,118,1,0,2,0,0,0,152,119,1,0,2,0,0,0,0,0,0,0,216,120,1,0,119,0,0,0,124,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,96,176,1,0,176,120,1,0,0,0,0,0,2,0,0,0,64,118,1,0,2,0,0,0,152,119,1,0,2,0,0,0,0,0,0,0,80,121,1,0,119,0,0,0,125,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,0,176,1,0,40,121,1,0,216,120,1,0,0,0,0,0,0,0,0,0,184,121,1,0,119,0,0,0,126,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,176,1,0,144,121,1,0,216,120,1,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,0,176,1,0,200,121,1,0,64,118,1,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,0,176,1,0,240,121,1,0,64,118,1,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,0,176,1,0,24,122,1,0,64,118,1,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,0,176,1,0,64,122,1,0,64,118,1,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,0,176,1,0,104,122,1,0,64,118,1,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,216,175,1,0,176,122,1,0,96,176,1,0,144,122,1,0,0,0,0,0,2,0,0,0,64,118,1,0,2,0,0,0,200,122,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,96,176,1,0,240,122,1,0,0,0,0,0,2,0,0,0,64,118,1,0,2,0,0,0,200,122,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,96,176,1,0,48,123,1,0,0,0,0,0,2,0,0,0,64,118,1,0,2,0,0,0,200,122,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,96,176,1,0,112,123,1,0,0,0,0,0,2,0,0,0,64,118,1,0,2,0,0,0,200,122,1,0,2,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,216,175,1,0,248,123,1,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,216,175,1,0,24,124,1,0,96,176,1,0,176,123,1,0,0,0,0,0,3,0,0,0,64,118,1,0,2,0,0,0,16,124,1,0,2,0,0,0,64,124,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,216,175,1,0,184,124,1,0,96,176,1,0,112,124,1,0,0,0,0,0,3,0,0,0,64,118,1,0,2,0,0,0,16,124,1,0,2,0,0,0,224,124,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,216,175,1,0,88,125,1,0,96,176,1,0,16,125,1,0,0,0,0,0,2,0,0,0,64,118,1,0,2,0,0,0,112,125,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,96,176,1,0,152,125,1,0,0,0,0,0,2,0,0,0,64,118,1,0,2,0,0,0,112,125,1,0,0,8,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,216,175,1,0,24,126,1,0,96,176,1,0,0,126,1,0,0,0,0,0,2,0,0,0,64,118,1,0,2,0,0,0,48,126,1,0,2,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,96,176,1,0,88,126,1,0,0,0,0,0,2,0,0,0,64,118,1,0,2,0,0,0,48,126,1,0,2,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,216,175,1,0,240,126,1,0,96,176,1,0,216,126,1,0,0,0,0,0,1,0,0,0,16,127,1,0,0,0,0,0,96,176,1,0,144,126,1,0,0,0,0,0,2,0,0,0,64,118,1,0,2,0,0,0,24,127,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,96,176,1,0,152,127,1,0,0,0,0,0,1,0,0,0,16,127,1,0,0,0,0,0,96,176,1,0,80,127,1,0,0,0,0,0,2,0,0,0,64,118,1,0,2,0,0,0,176,127,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,216,175,1,0,72,128,1,0,96,176,1,0,48,128,1,0,0,0,0,0,1,0,0,0,104,128,1,0,0,0,0,0,96,176,1,0,232,127,1,0,0,0,0,0,2,0,0,0,64,118,1,0,2,0,0,0,112,128,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,96,176,1,0,240,128,1,0,0,0,0,0,1,0,0,0,104,128,1,0,0,0,0,0,96,176,1,0,168,128,1,0,0,0,0,0,2,0,0,0,64,118,1,0,2,0,0,0,8,129,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,216,175,1,0,136,129,1,0,96,176,1,0,64,129,1,0,0,0,0,0,2,0,0,0,64,118,1,0,2,0,0,0,168,129,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,216,175,1,0,24,130,1,0,96,176,1,0,208,129,1,0,0,0,0,0,2,0,0,0,64,118,1,0,2,0,0,0,56,130,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,216,175,1,0,168,130,1,0,96,176,1,0,96,130,1,0,0,0,0,0,2,0,0,0,64,118,1,0,2,0,0,0,200,130,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,216,175,1,0,56,131,1,0,96,176,1,0,240,130,1,0,0,0,0,0,2,0,0,0,64,118,1,0,2,0,0,0,88,131,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+91100);
/* memory initializer */ allocate([74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,77,97,114,99,104,0,0,0,65,112,114,105,108,0,0,0,77,97,121,0,0,0,0,0,74,117,110,101,0,0,0,0,74,117,108,121,0,0,0,0,65,117,103,117,115,116,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,74,97,110,0,0,0,0,0,70,101,98,0,0,0,0,0,77,97,114,0,0,0,0,0,65,112,114,0,0,0,0,0,74,117,110,0,0,0,0,0,74,117,108,0,0,0,0,0,65,117,103,0,0,0,0,0,83,101,112,0,0,0,0,0,79,99,116,0,0,0,0,0,78,111,118,0,0,0,0,0,68,101,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,117,110,100,97,121,0,0,77,111,110,100,97,121,0,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,83,117,110,0,0,0,0,0,77,111,110,0,0,0,0,0,84,117,101,0,0,0,0,0,87,101,100,0,0,0,0,0,84,104,117,0,0,0,0,0,70,114,105,0,0,0,0,0,83,97,116,0,0,0,0,0,18,17,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,17,34,35,36,17,37,38,39,40,41,42,43,44,17,45,46,47,16,16,48,16,16,16,16,16,16,16,49,50,51,16,52,53,16,16,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,54,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,55,17,17,17,17,56,17,57,58,59,60,61,62,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,63,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,64,65,17,66,67,68,69,70,71,72,73,16,16,16,74,75,76,77,78,16,16,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,17,17,17,82,83,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,84,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,17,85,16,16,16,16,86,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,87,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,88,89,90,91,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,92,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,254,255,255,7,254,255,255,7,0,0,0,0,0,4,32,4,255,255,127,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,195,255,3,0,31,80,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,223,60,64,215,255,255,251,255,255,255,255,255,255,255,255,255,191,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,254,255,255,255,127,2,254,255,255,255,255,0,0,0,0,0,255,191,182,0,255,255,255,7,7,0,0,0,255,7,255,255,255,255,255,255,255,254,255,195,255,255,255,255,255,255,255,255,255,255,255,255,239,31,254,225,255,159,0,0,255,255,255,255,255,255,0,224,255,255,255,255,255,255,255,255,255,255,255,255,3,0,255,255,255,255,255,7,48,4,255,255,255,252,255,31,0,0,255,255,255,1,0,0,0,0,0,0,0,0,253,31,0,0,0,0,0,0,240,3,255,127,255,255,255,255,255,255,255,239,255,223,225,255,207,255,254,254,238,159,249,255,255,253,197,227,159,89,128,176,207,255,3,0,238,135,249,255,255,253,109,195,135,25,2,94,192,255,63,0,238,191,251,255,255,253,237,227,191,27,1,0,207,255,0,0,238,159,249,255,255,253,237,227,159,25,192,176,207,255,2,0,236,199,61,214,24,199,255,195,199,29,129,0,192,255,0,0,238,223,253,255,255,253,239,227,223,29,96,3,207,255,0,0,236,223,253,255,255,253,239,227,223,29,96,64,207,255,6,0,236,223,253,255,255,255,255,231,223,93,128,0,207,255,0,252,236,255,127,252,255,255,251,47,127,128,95,255,0,0,12,0,254,255,255,255,255,127,255,7,63,32,255,3,0,0,0,0,150,37,240,254,174,236,255,59,95,32,255,243,0,0,0,0,1,0,0,0,255,3,0,0,255,254,255,255,255,31,254,255,3,255,255,254,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,249,255,3,255,255,231,193,255,255,127,64,255,51,255,255,255,255,191,32,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,61,127,61,255,255,255,255,255,61,255,255,255,255,61,127,61,255,127,255,255,255,255,255,255,255,61,255,255,255,255,255,255,255,255,135,0,0,0,0,255,255,0,0,255,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,159,255,255,254,255,255,7,255,255,255,255,255,255,255,255,255,199,1,0,255,223,15,0,255,255,15,0,255,255,15,0,255,223,13,0,255,255,255,255,255,255,207,255,255,1,128,16,255,3,0,0,0,0,255,3,255,255,255,255,255,255,255,255,255,255,255,0,255,255,255,255,255,7,255,255,255,255,255,255,255,255,63,0,255,255,255,31,255,15,255,1,192,255,255,255,255,63,31,0,255,255,255,255,255,15,255,255,255,3,255,3,0,0,0,0,255,255,255,15,255,255,255,255,255,255,255,127,254,255,31,0,255,3,255,3,128,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,239,255,239,15,255,3,0,0,0,0,255,255,255,255,255,243,255,255,255,255,255,255,191,255,3,0,255,255,255,255,255,255,63,0,255,227,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,222,111,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,0,0,255,31,0,0,0,0,0,0,0,0,0,0,0,0,132,252,47,62,80,189,255,243,224,67,0,0,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,255,255,255,3,0,0,255,255,255,255,255,127,255,255,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,120,12,0,255,255,255,255,191,32,255,255,255,255,255,255,255,128,0,0,255,255,127,0,127,127,127,127,127,127,127,127,255,255,255,255,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,254,3,62,31,254,255,255,255,255,255,255,255,255,255,127,224,254,255,255,255,255,255,255,255,255,255,255,247,224,255,255,255,255,63,254,255,255,255,255,255,255,255,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,63,255,31,255,255,255,15,0,0,255,255,255,255,255,127,240,143,255,255,255,128,255,255,255,255,255,255,255,255,255,255,0,0,0,0,128,255,252,255,255,255,255,255,255,255,255,255,255,255,255,121,15,0,255,7,0,0,0,0,0,0,0,0,0,255,187,247,255,255,255,0,0,0,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,15,0,255,3,0,0,252,8,255,255,255,255,255,7,255,255,255,255,7,0,255,255,255,31,255,255,255,255,255,255,247,255,0,128,255,3,0,0,0,0,255,255,255,255,255,255,127,0,255,63,255,3,255,255,127,4,255,255,255,255,255,255,255,127,5,0,0,56,255,255,60,0,126,126,126,0,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,7,255,3,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,127,248,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,0,127,0,248,224,255,253,127,95,219,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,248,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,255,255,255,255,255,255,255,255,252,255,255,255,255,255,255,0,0,0,0,0,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,255,3,254,255,255,7,254,255,255,7,192,255,255,255,255,255,255,255,255,255,255,127,252,252,252,28,0,0,0,0,255,239,255,255,127,255,255,183,255,63,255,63,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,31,255,255,255,255,255,255,1,0,0,0,0,0,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,63,255,255,255,255,15,255,62,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,3,0,0,0,0,0,0,0,0,0,0,63,253,255,255,255,255,191,145,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,63,0,255,255,255,3,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,192,0,0,0,0,0,0,0,0,111,240,239,254,255,255,15,0,0,0,0,0,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,255,63,0,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,192,255,0,0,252,255,255,255,255,255,255,1,0,0,255,255,255,1,255,3,255,255,255,255,255,255,199,255,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,30,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,3,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,31,0,255,255,255,255,255,127,0,0,248,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,223,100,222,255,235,239,255,255,255,255,255,255,255,191,231,223,223,255,255,255,123,95,252,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,253,255,255,247,255,255,255,247,255,255,223,255,255,255,223,255,255,127,255,255,255,127,255,255,255,253,255,255,255,253,255,255,247,207,255,255,255,255,255,255,239,255,255,255,150,254,247,10,132,234,150,170,150,247,247,94,255,251,255,15,238,251,255,15,0,0,0,0,0,0,0,0,97,108,110,117,109,0,97,108,112,104,97,0,98,108,97,110,107,0,99,110,116,114,108,0,100,105,103,105,116,0,103,114,97,112,104,0,108,111,119,101,114,0,112,114,105,110,116,0,112,117,110,99,116,0,115,112,97,99,101,0,117,112,112,101,114,0,120,100,105,103,105,116,0,0,0,0,0,0,0,0,18,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,16,16,34,35,16,36,37,38,39,40,41,42,43,16,44,45,46,17,47,48,17,17,49,17,17,17,50,51,52,53,54,55,56,57,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,58,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,59,16,60,61,62,63,64,65,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,66,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,67,16,16,68,16,69,70,71,16,72,16,73,16,16,16,16,74,75,76,77,16,16,78,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,16,16,16,16,82,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,83,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,84,85,86,87,16,16,88,89,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,90,16,91,92,93,94,95,96,97,98,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,254,255,0,252,1,0,0,248,1,0,0,120,0,0,0,0,255,251,223,251,0,0,128,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,252,255,224,175,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,32,64,176,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,134,254,255,255,255,0,64,73,0,0,0,0,0,24,0,223,255,0,200,0,0,0,0,0,0,0,1,0,60,0,0,0,0,0,0,0,0,0,0,0,0,16,224,1,30,0,96,255,191,0,0,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,207,3,0,0,0,3,0,32,255,127,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,0,0,0,16,0,32,30,0,48,0,1,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,252,15,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,3,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,253,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,255,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,63,2,0,0,0,0,0,0,0,0,0,4,0,0,0,0,16,0,0,0,0,0,0,128,0,128,192,223,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,254,255,255,255,0,252,255,255,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,192,255,223,255,7,0,0,0,0,0,0,0,0,0,0,128,6,0,252,0,0,24,62,0,0,128,191,0,204,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,31,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,0,0,24,0,0,0,0,0,0,0,0,0,56,0,0,0,0,16,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,254,127,47,0,0,255,3,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,196,255,255,255,255,0,0,0,192,0,0,0,0,0,0,0,0,1,0,224,159,0,0,0,0,127,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,16,0,0,252,255,255,255,31,0,0,0,0,0,12,0,0,0,0,0,0,64,0,12,240,0,0,0,0,0,0,192,248,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,255,0,255,255,255,33,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,127,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,3,224,0,224,0,224,0,96,128,248,255,255,255,252,255,255,255,255,255,127,31,252,241,127,255,127,0,0,255,255,255,3,0,0,255,255,255,255,1,0,123,3,208,193,175,66,0,12,31,188,255,255,0,0,0,0,0,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,127,0,0,0,255,7,0,0,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,252,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,255,15,0,0,0,0,0,0,0,0,255,255,255,251,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,255,15,30,255,255,255,1,252,193,224,0,0,0,0,0,0,0,0,0,0,0,30,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,255,255,255,255,15,0,0,0,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,0,0,0,0,0,0,192,0,224,0,0,0,0,0,0,0,0,0,0,0,128,15,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,255,255,127,0,3,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,8,0,0,0,15,255,3,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,16,192,0,0,255,255,3,7,0,0,0,0,0,248,0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,8,0,255,63,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,128,11,0,0,0,0,0,0,0,128,2,0,0,192,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,255,255,255,3,127,0,255,255,255,255,247,255,127,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,254,255,0,252,1,0,0,248,1,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,0,48,135,255,255,255,255,255,143,255,0,0,0,0,0,0,224,255,255,7,255,15,0,0,0,0,0,0,255,255,255,255,255,63,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,143,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,255,0,255,1,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,63,252,255,63,0,0,0,3,0,0,0,0,0,0,254,3,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,7,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,255,255,255,255,127,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,127,0,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8,0,0,0,8,0,0,32,0,0,0,32,0,0,128,0,0,0,128,0,0,0,2,0,0,0,2,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,127,254,127,254,255,254,255,0,0,0,0,255,7,255,255,255,127,255,255,255,255,255,255,255,15,255,255,255,255,255,7,0,0,0,0,0,0,0,0,192,255,255,255,7,0,255,255,255,255,255,7,255,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,1,0,191,255,255,255,255,255,255,255,255,31,255,255,15,0,255,255,255,255,223,7,0,0,255,255,1,0,255,255,255,255,255,255,255,127,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,30,255,255,255,255,255,255,255,63,15,0,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,255,255,255,255,255,255,255,255,225,255,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,9,0,0,0,10,0,0,0,13,0,0,0,11,0,0,0,12,0,0,0,133,0,0,0,0,32,0,0,1,32,0,0,2,32,0,0,3,32,0,0,4,32,0,0,5,32,0,0,6,32,0,0,8,32,0,0,9,32,0,0,10,32,0,0,40,32,0,0,41,32,0,0,95,32,0,0,0,48,0,0,0,0,0,0,65,0,32,26,192,0,32,31,0,1,1,47,50,1,1,5,57,1,1,15,74,1,1,45,121,1,1,5,112,3,1,3,145,3,32,17,163,3,32,9,0,4,80,16,16,4,32,32,96,4,1,33,138,4,1,53,193,4,1,13,208,4,1,63,20,5,1,19,49,5,48,38,160,1,1,5,179,1,1,3,205,1,1,15,222,1,1,17,248,1,1,39,34,2,1,17,216,3,1,23,0,30,1,149,160,30,1,95,8,31,248,8,24,31,248,6,40,31,248,8,56,31,248,8,72,31,248,6,104,31,248,8,136,31,248,8,152,31,248,8,168,31,248,8,184,31,248,2,186,31,182,2,200,31,170,4,216,31,248,2,218,31,156,2,232,31,248,2,234,31,144,2,248,31,128,2,250,31,130,2,70,2,1,9,16,5,1,3,96,33,16,16,0,44,48,47,103,44,1,5,128,44,1,99,235,44,1,3,64,166,1,45,128,166,1,23,34,167,1,13,50,167,1,61,121,167,1,3,126,167,1,9,144,167,1,3,160,167,1,9,33,255,32,26,0,0,0,0,73,0,49,1,83,0,127,1,48,1,105,0,120,1,255,0,129,1,83,2,130,1,131,1,132,1,133,1,134,1,84,2,135,1,136,1,137,1,86,2,138,1,87,2,139,1,140,1,142,1,221,1,143,1,89,2,144,1,91,2,145,1,146,1,147,1,96,2,148,1,99,2,150,1,105,2,151,1,104,2,152,1,153,1,156,1,111,2,157,1,114,2,159,1,117,2,166,1,128,2,167,1,168,1,169,1,131,2,172,1,173,1,174,1,136,2,175,1,176,1,177,1,138,2,178,1,139,2,183,1,146,2,184,1,185,1,188,1,189,1,196,1,198,1,196,1,197,1,197,1,198,1,199,1,201,1,199,1,200,1,200,1,201,1,202,1,204,1,202,1,203,1,203,1,204,1,241,1,243,1,241,1,242,1,242,1,243,1,244,1,245,1,246,1,149,1,247,1,191,1,32,2,158,1,134,3,172,3,136,3,173,3,137,3,174,3,138,3,175,3,140,3,204,3,142,3,205,3,143,3,206,3,153,3,69,3,153,3,190,31,163,3,194,3,247,3,248,3,250,3,251,3,96,30,155,30,223,0,223,0,158,30,223,0,89,31,81,31,91,31,83,31,93,31,85,31,95,31,87,31,188,31,179,31,204,31,195,31,236,31,229,31,252,31,243,31,58,2,101,44,59,2,60,2,61,2,154,1,62,2,102,44,65,2,66,2,67,2,128,1,68,2,137,2,69,2,140,2,244,3,184,3,249,3,242,3,253,3,123,3,254,3,124,3,255,3,125,3,192,4,207,4,38,33,201,3,42,33,107,0,43,33,229,0,50,33,78,33,131,33,132,33,96,44,97,44,98,44,107,2,99,44,125,29,100,44,125,2,109,44,81,2,110,44,113,2,111,44,80,2,112,44,82,2,114,44,115,44,117,44,118,44,126,44,63,2,127,44,64,2,242,44,243,44,125,167,121,29,139,167,140,167,141,167,101,2,170,167,102,2,199,16,39,45,205,16,45,45,118,3,119,3,156,3,181,0,146,3,208,3,152,3,209,3,166,3,213,3,160,3,214,3,154,3,240,3,161,3,241,3,149,3,245,3,207,3,215,3,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,72,173,1,0,110,0,0,0,80,173,1,0,114,0,0,0,88,173,1,0,102,0,0,0,96,173,1,0,97,0,0,0,104,173,1,0,101,0,0,0,112,173,1,0,119,0,0,0,120,173,1,0,87,0,0,0,136,173,1,0,115,0,0,0,152,173,1,0,83,0,0,0,168,173,1,0,100,0,0,0,184,173,1,0,68,0,0,0,200,173,1,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,27,0,0,0,0,0,0,0,91,91,58,97,108,110,117,109,58,93,95,93,0,0,0,0,91,94,91,58,97,108,110,117,109,58,93,95,93,0,0,0,91,91,58,115,112,97,99,101,58,93,93,0,0,0,0,0,91,94,91,58,115,112,97,99,101,58,93,93,0,0,0,0,91,91,58,100,105,103,105,116,58,93,93,0,0,0,0,0,91,94,91,58,100,105,103,105,116,58,93,93,0,0,0,0,78,111,32,101,114,114,111,114,0,78,111,32,109,97,116,99,104,0,73,110,118,97,108,105,100,32,114,101,103,101,120,112,0,85,110,107,110,111,119,110,32,99,111,108,108,97,116,105,110,103,32,101,108,101,109,101,110,116,0,85,110,107,110,111,119,110,32,99,104,97,114,97,99,116,101,114,32,99,108,97,115,115,32,110,97,109,101,0,84,114,97,105,108,105,110,103,32,98,97,99,107,115,108,97,115,104,0,73,110,118,97,108,105,100,32,98,97,99,107,32,114,101,102,101,114,101,110,99,101,0,77,105,115,115,105,110,103,32,39,93,39,0,77,105,115,115,105,110,103,32,39,41,39,0,77,105,115,115,105,110,103,32,39,125,39,0,73,110,118,97,108,105,100,32,99,111,110,116,101,110,116,115,32,111,102,32,123,125,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,114,97,110,103,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,112,101,116,105,116,105,111,110,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,0,0,0,37,115,0,0,0,0,0,0,0,0,0,0,80,175,1,0,127,0,0,0,128,0,0,0,95,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,216,175,1,0,40,175,1,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,0,176,1,0,64,175,1,0,0,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,0,176,1,0,96,175,1,0,56,175,1,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,176,1,0,152,175,1,0,136,175,1,0,0,0,0,0,0,0,0,0,192,175,1,0,129,0,0,0,130,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,72,176,1,0,129,0,0,0,133,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,17,0,0,0,11,0,0,0,12,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,176,1,0,32,176,1,0,192,175,1,0,0,0,0,0,0,0,0,0,168,176,1,0,129,0,0,0,134,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,18,0,0,0,12,0,0,0,13,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,176,1,0,128,176,1,0,192,175,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,178,1,0,135,0,0,0,136,0,0,0,96,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,0,176,1,0,216,178,1,0,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+101440);




var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  function _llvm_lifetime_end() {}

  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function _pthread_mutex_lock() {}

  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
  
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
  
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
  
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }


  function _lis_solver_create() {
  Module['printErr']('missing function: lis_solver_create'); abort(-1);
  }

  var _emscripten_check_longjmp=true;

  
  function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }

  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var fd = _fileno(stream);
      var ret = _write(fd, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }

  
  var ___strtok_state=0;
  
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
  
  
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
  
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
  
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
  
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }

  function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  
  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    } 
  Module["_saveSetjmp"] = _saveSetjmp;

  
   
  Module["_strlen"] = _strlen;function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      var fd = _fileno(stream);
      return _write(fd, s, _strlen(s));
    }

  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};


  
  function _malloc(bytes) {
      /* Over-allocate to make sure it is byte-aligned by 8.
       * This will leak memory, but this is only the dummy
       * implementation (replaced by dlmalloc normally) so
       * not an issue.
       */
      var ptr = Runtime.dynamicAlloc(bytes + 8);
      return (ptr+8) & 0xFFFFFFF8;
    }
  Module["_malloc"] = _malloc;
  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

   
  Module["_bitshift64Ashr"] = _bitshift64Ashr;

  
  var PTHREAD_SPECIFIC={};function _pthread_setspecific(key, value) {
      if (!(key in PTHREAD_SPECIFIC)) {
        return ERRNO_CODES.EINVAL;
      }
      PTHREAD_SPECIFIC[key] = value;
      return 0;
    }

  function _GC_init() {
  Module['printErr']('missing function: GC_init'); abort(-1);
  }

  var _ceil=Math_ceil;

  function _GC_strdup() {
  Module['printErr']('missing function: GC_strdup'); abort(-1);
  }

  function _GC_malloc_atomic() {
  Module['printErr']('missing function: GC_malloc_atomic'); abort(-1);
  }

  
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }function _isxdigit_l(chr) {
      return _isxdigit(chr); // no locale support yet
    }

  
  function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }
  
  
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  
  function ___errno_location() {
      return ___errno_state;
    }function _perror(s) {
      // void perror(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/perror.html
      var stdout = HEAP32[((_stdout)>>2)];
      if (s) {
        _fputs(s, stdout);
        _fputc(58, stdout);
        _fputc(32, stdout);
      }
      var errnum = HEAP32[((___errno_location())>>2)];
      _puts(_strerror(errnum));
    }

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 
  Module["_memcpy"] = _memcpy;


  function _strstr(ptr1, ptr2) {
      var check = 0, start;
      do {
        if (!check) {
          start = ptr1;
          check = ptr2;
        }
        var curr1 = HEAP8[((ptr1++)|0)];
        var curr2 = HEAP8[((check++)|0)];
        if (curr2 == 0) return start;
        if (curr2 != curr1) {
          // rewind to one character after start, to find ez in eeez
          ptr1 = start + 1;
          check = 0;
        }
      } while (curr1);
      return 0;
    }

   
  Module["_memmove"] = _memmove;

  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }

  function _signal(sig, func) {
      // TODO
      return 0;
    }

  
  
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
  
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
  
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
                if (next === 0) return i > 0 ? fields : fields-1; // we failed to read the full length of this field
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
  
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
  
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
  
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
  
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
  
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
  
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
  
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16);
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text);
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text);
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j];
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }
  
  
  
  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }
  
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }function _fscanf(stream, format, varargs) {
      // int fscanf(FILE *restrict stream, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        return -1;
      }
      var buffer = [];
      function get() {
        var c = _fgetc(stream);
        buffer.push(c);
        return c;
      };
      function unget() {
        _ungetc(buffer.pop(), stream);
      };
      return __scanString(format, get, unget, varargs);
    }

  var _emscripten_preinvoke=true;

  function _pthread_cond_wait() {
      return 0;
    }

  
  
  
  var ___cxa_exception_header_size=8;
  
  function _free() {
  }
  Module["_free"] = _free;function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr - ___cxa_exception_header_size);
      } catch(e) { // XXX FIXME
      }
    }
  
  var ___cxa_last_thrown_exception=0;
  
  var ___cxa_caught_exceptions=[];function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Call destructor if one is registered then clear it.
      var ptr = ___cxa_caught_exceptions.pop();
      if (ptr) {
        header = ptr - ___cxa_exception_header_size;
        var destructor = HEAP32[(((header)+(4))>>2)];
        if (destructor) {
          Runtime.dynCall('vi', destructor, [ptr]);
          HEAP32[(((header)+(4))>>2)]=0;
        }
        ___cxa_free_exception(ptr);
        ___cxa_last_thrown_exception = 0;
      }
    }function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      var ptr = ___cxa_caught_exceptions.pop();
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }function _freopen(filename, mode, stream) {
      // FILE *freopen(const char *restrict filename, const char *restrict mode, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/freopen.html
      if (!filename) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (!streamObj) {
          ___setErrNo(ERRNO_CODES.EBADF);
          return 0;
        }
        if (_freopen.buffer) _free(_freopen.buffer);
        filename = intArrayFromString(streamObj.path);
        filename = allocate(filename, 'i8', ALLOC_NORMAL);
      }
      _fclose(stream);
      return _fopen(filename, mode);
    }

  function _round(x) {
      return (x < 0) ? -Math.round(-x) : Math.round(x);
    }

  
  function _emscripten_get_now() {
      if (!_emscripten_get_now.actual) {
        if (ENVIRONMENT_IS_NODE) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() {
            var t = process['hrtime']();
            return t[0] * 1e3 + t[1] / 1e6;
          }
        } else if (typeof dateNow !== 'undefined') {
          _emscripten_get_now.actual = dateNow;
        } else if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() { return window['performance']['now'](); };
        } else {
          _emscripten_get_now.actual = Date.now;
        }
      }
      return _emscripten_get_now.actual();
    }function _clock_gettime(clk_id, tp) {
      // int clock_gettime(clockid_t clk_id, struct timespec *tp);
      var now;
      if (clk_id === 0) {
        now = Date.now();
      } else {
        now = _emscripten_get_now();
      }
      HEAP32[((tp)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((tp)+(4))>>2)]=Math.floor((now % 1000)*1000*1000); // nanoseconds
      return 0;
    }

  
  function _tmpnam(s, dir, prefix) {
      // char *tmpnam(char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpnam.html
      // NOTE: The dir and prefix arguments are for internal use only.
      var folder = FS.findObject(dir || '/tmp');
      if (!folder || !folder.isFolder) {
        dir = '/tmp';
        folder = FS.findObject(dir);
        if (!folder || !folder.isFolder) return 0;
      }
      var name = prefix || 'file';
      do {
        name += String.fromCharCode(65 + Math.floor(Math.random() * 25));
      } while (name in folder.contents);
      var result = dir + '/' + name;
      if (!_tmpnam.buffer) _tmpnam.buffer = _malloc(256);
      if (!s) s = _tmpnam.buffer;
      writeAsciiToMemory(result, s);
      return s;
    }function _tmpfile() {
      // FILE *tmpfile(void);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpfile.html
      // TODO: Delete the created file on closing.
      if (_tmpfile.mode) {
        _tmpfile.mode = allocate(intArrayFromString('w+'), 'i8', ALLOC_NORMAL);
      }
      return _fopen(_tmpnam(0), _tmpfile.mode);
    }

  
  function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }

  
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = (HEAP32[((tempDoublePtr)>>2)]=HEAP32[(((varargs)+(argIndex))>>2)],HEAP32[(((tempDoublePtr)+(4))>>2)]=HEAP32[(((varargs)+((argIndex)+(4)))>>2)],(+(HEAPF64[(tempDoublePtr)>>3])));
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+4))>>2)]];
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Runtime.getNativeFieldSize(type);
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision < 0) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }


  function _pclose(stream) {
      // int pclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/pclose.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.ECHILD);
      return -1;
    }

   
  Module["_memset"] = _memset;

  var _BDtoILow=true;


   
  Module["_bitshift64Shl"] = _bitshift64Shl;

  var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  function ___assert_fail(condition, filename, line, func) {
      ABORT = true;
      throw 'Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'] + ' at ' + stackTrace();
    }

  
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }function _isdigit_l(chr) {
      return _isdigit(chr); // no locale support yet
    }

  var _emscripten_prep_setjmp=true;


  function _access(path, amode) {
      // int access(const char *path, int amode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/access.html
      path = Pointer_stringify(path);
      if (amode & ~7) {
        // need a valid mode
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      }
      var node;
      try {
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
      var perms = '';
      if (amode & 4) perms += 'r';
      if (amode & 2) perms += 'w';
      if (amode & 1) perms += 'x';
      if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      }
      return 0;
    }

  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }

  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }

  var _emscripten_get_longjmp_result=true;

  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i];
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }

  function _freelocale(locale) {
      _free(locale);
    }

  function _catgets(catd, set_id, msg_id, s) {
      // char *catgets (nl_catd catd, int set_id, int msg_id, const char *s)
      return s;
    }

  function _fmod(x, y) {
      return x % y;
    }

  function _fmax(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.max(x, y);
    }

  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }

  function _GC_malloc() {
  Module['printErr']('missing function: GC_malloc'); abort(-1);
  }

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function _lis_vector_destroy() {
  Module['printErr']('missing function: lis_vector_destroy'); abort(-1);
  }

  
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      ___cxa_caught_exceptions.push(___cxa_last_thrown_exception);
      return ptr;
    }

  function _lis_vector_create() {
  Module['printErr']('missing function: lis_vector_create'); abort(-1);
  }


  var _cos=Math_cos;

  var _fseeko=_fseek;



  function __ZNSt9exceptionD2Ev() {}

  function _lis_solver_destroy() {
  Module['printErr']('missing function: lis_solver_destroy'); abort(-1);
  }

  function _popen(command, mode) {
      // FILE *popen(const char *command, const char *mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/popen.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.EMFILE);
      return 0;
    }

  function _isblank(chr) {
      return chr == 32 || chr == 9;
    }

   
  Module["_strcpy"] = _strcpy;

  function _copysign(a, b) {
      return __reallyNegative(a) === __reallyNegative(b) ? a : -a;
    }

  function _bsearch(key, base, num, size, compar) {
      function cmp(x, y) {
        return Module['dynCall_iii'](compar, x, y);
      };
      var left = 0;
      var right = num;
      var mid, test, addr;
  
      while (left < right) {
        mid = (left + right) >>> 1;
        addr = base + (mid * size);
        test = cmp(key, addr);
        if (test < 0) {
          right = mid;
        } else if (test > 0) {
          left = mid + 1;
        } else {
          return addr;
        }
      }
  
      return 0;
    }

  
  var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key, destructor) {
      if (key == 0) {
        return ERRNO_CODES.EINVAL;
      }
      HEAP32[((key)>>2)]=PTHREAD_SPECIFIC_NEXT_KEY;
      // values start at 0
      PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
      PTHREAD_SPECIFIC_NEXT_KEY++;
      return 0;
    }


  
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  
  
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
  
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
  
      var pattern = Pointer_stringify(format);
  
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
  
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
  
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
  
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
  
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
  
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
  
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
  
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
  
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
  
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
  
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
  
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
  
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
  
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
  
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }

  
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;

  
   
  Module["_rand_r"] = _rand_r;
  
  var ___rand_seed=allocate([0x0273459b, 0, 0, 0], "i32", ALLOC_STATIC); 
  Module["_rand"] = _rand;

  var _llvm_memset_p0i8_i32=_memset;

   
  Module["_i64Subtract"] = _i64Subtract;

   
  Module["_i64Add"] = _i64Add;

  var _pow=Math_pow;

  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  
  function ___resumeException(ptr) {
      if (!___cxa_last_thrown_exception) { ___cxa_last_thrown_exception = ptr; }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = ___cxa_last_thrown_exception;
      header = thrown - ___cxa_exception_header_size;
      if (throwntype == -1) throwntype = HEAP32[((header)>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
  
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      var header = ptr - ___cxa_exception_header_size;
      HEAP32[((header)>>2)]=type;
      HEAP32[(((header)+(4))>>2)]=destructor;
      ___cxa_last_thrown_exception = ptr;
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }


  
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }

  function _htonl(value) {
      return ((value & 0xff) << 24) + ((value & 0xff00) << 8) +
             ((value & 0xff0000) >>> 8) + ((value & 0xff000000) >>> 24);
    }


   
  Module["_strncpy"] = _strncpy;

  function _strtoull_l(str, endptr, base) {
      return _strtoull(str, endptr, base); // no locale support yet
    }

  var _log=Math_log;

  var _emscripten_postinvoke=true;

  function _xerbla_() {
  Module['printErr']('missing function: xerbla_'); abort(-1);
  }

  var _copysignl=_copysign;

  
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }function _strtoll_l(str, endptr, base) {
      return _strtoll(str, endptr, base); // no locale support yet
    }

  function _qsort(base, num, size, cmp) {
      if (num == 0 || size == 0) return;
      // forward calls to the JavaScript sort method
      // first, sort the items logically
      var keys = [];
      for (var i = 0; i < num; i++) keys.push(i);
      keys.sort(function(a, b) {
        return Module['dynCall_iii'](cmp, base+a*size, base+b*size);
      });
      // apply the sort
      var temp = _malloc(num*size);
      _memcpy(temp, base, num*size);
      for (var i = 0; i < num; i++) {
        if (keys[i] == i) continue; // already in place
        _memcpy(base+i*size, temp+keys[i]*size, size);
      }
      _free(temp);
    }

  function _system(command) {
      // int system(const char *command);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/system.html
      // Can't call external programs.
      ___setErrNo(ERRNO_CODES.EAGAIN);
      return -1;
    }

  var _putc=_fputc;

  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }

   
  Module["_bitshift64Lshr"] = _bitshift64Lshr;

  function _srand(seed) {
      HEAP32[((___rand_seed)>>2)]=seed
    }

  function _isatty(fildes) {
      // int isatty(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/isatty.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      // HACK - implement tcgetattr
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return 0;
      }
      return 1;
    }

  var _BDtoIHigh=true;

  function _pthread_cond_broadcast() {
      return 0;
    }

  
  
   
  Module["_testSetjmp"] = _testSetjmp;function _longjmp(env, value) {
      asm['setThrew'](env, value || 1);
      throw 'longjmp';
    }function _emscripten_longjmp(env, value) {
      _longjmp(env, value);
    }

  function __ZSt9terminatev() {
      _exit(-1234);
    }

  function _lis_matrix_set_value() {
  Module['printErr']('missing function: lis_matrix_set_value'); abort(-1);
  }

  function _vfprintf(s, f, va_arg) {
      return _fprintf(s, f, HEAP32[((va_arg)>>2)]);
    }

  
  function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }var _atol=_atoi;

  function _pthread_mutex_unlock() {}

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }



  var _BItoD=true;

  
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000);
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000);
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000);
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fstat(fildes, buf) {
      // int fstat(int fildes, struct stat *buf);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/fstat.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      return _stat(stream.path, buf);
    }

  function _catclose(catd) {
      // int catclose (nl_catd catd)
      return 0;
    }

  function _llvm_lifetime_start() {}

  function ___cxa_guard_release() {}


  
  function _truncate(path, length) {
      // int truncate(const char *path, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/truncate.html
      // NOTE: The path argument may be a string, to simplify ftruncate().
      if (typeof path !== 'string') path = Pointer_stringify(path);
      try {
        FS.truncate(path, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _ftruncate(fildes, length) {
      // int ftruncate(int fildes, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftruncate.html
      try {
        FS.ftruncate(fildes, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  function _uselocale(locale) {
      return 0;
    }

  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }


  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }

  var _llvm_memmove_p0i8_p0i8_i32=_memmove;

  var _ftello=_ftell;

  function _strftime_l(s, maxsize, format, tm) {
      return _strftime(s, maxsize, format, tm); // no locale support yet
    }

  function _abort() {
      Module['abort']();
    }





  function _pthread_getspecific(key) {
      return PTHREAD_SPECIFIC[key] || 0;
    }

  var _fabs=Math_abs;

  var _floor=Math_floor;

  var _getc=_fgetc;

  var _sqrt=Math_sqrt;

  function _rewind(stream) {
      // void rewind(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rewind.html
      _fseek(stream, 0, 0);  // SEEK_SET.
      var streamObj = FS.getStreamFromPtr(stream);
      if (streamObj) streamObj.error = false;
    }

  function ___cxa_allocate_exception(size) {
      var ptr = _malloc(size + ___cxa_exception_header_size);
      return ptr + ___cxa_exception_header_size;
    }

  var _sin=Math_sin;

  var _fmodl=_fmod;



  function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }

  function _catopen(name, oflag) {
      // nl_catd catopen (const char *name, int oflag)
      return -1;
    }

  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_vector_set_size() {
  Module['printErr']('missing function: lis_vector_set_size'); abort(-1);
  }

  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = Pointer_stringify(path);
      try {
        FS.unlink(path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  var _emscripten_setjmp=true;

  function _GC_collect_a_little() {
  Module['printErr']('missing function: GC_collect_a_little'); abort(-1);
  }


  function _lis_solver_set_option() {
  Module['printErr']('missing function: lis_solver_set_option'); abort(-1);
  }

  var _exp=Math_exp;

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  var __ZTISt9exception=allocate([allocate([1,0,0,0,0,0,0], "i8", ALLOC_STATIC)+8, 0], "i32", ALLOC_STATIC);

  var ___dso_handle=allocate(1, "i32*", ALLOC_STATIC);



FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
___strtok_state = Runtime.staticAlloc(4);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vd(index,a1) {
  try {
    Module["dynCall_vd"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) {
  try {
    return Module["dynCall_iiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viidii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_didd(index,a1,a2,a3) {
  try {
    return Module["dynCall_didd"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_dii(index,a1,a2) {
  try {
    return Module["dynCall_dii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.___rand_seed|0;var p=env.__ZTISt9exception|0;var q=env.___dso_handle|0;var r=env._stderr|0;var s=env._stdin|0;var t=env._stdout|0;var u=0;var v=0;var w=0;var x=0;var y=+env.NaN,z=+env.Infinity;var A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=global.Math.floor;var U=global.Math.abs;var V=global.Math.sqrt;var W=global.Math.pow;var X=global.Math.cos;var Y=global.Math.sin;var Z=global.Math.tan;var _=global.Math.acos;var $=global.Math.asin;var aa=global.Math.atan;var ba=global.Math.atan2;var ca=global.Math.exp;var da=global.Math.log;var ea=global.Math.ceil;var fa=global.Math.imul;var ga=env.abort;var ha=env.assert;var ia=env.asmPrintInt;var ja=env.asmPrintFloat;var ka=env.min;var la=env.invoke_iiiiiiii;var ma=env.invoke_viiiii;var na=env.invoke_iiiiidiii;var oa=env.invoke_vd;var pa=env.invoke_vi;var qa=env.invoke_vii;var ra=env.invoke_iiiiiiiiiii;var sa=env.invoke_ii;var ta=env.invoke_iiiiiiiiiiiiii;var ua=env.invoke_iiii;var va=env.invoke_iiiiiiiiiiiiiiiiiiiiiii;var wa=env.invoke_iiiiiiiiiiiiiiiiiiiii;var xa=env.invoke_viiiiid;var ya=env.invoke_viiiiiiii;var za=env.invoke_iiiiiiiiiiiiiiiiiiiiiiiii;var Aa=env.invoke_viiiiii;var Ba=env.invoke_viidii;var Ca=env.invoke_iid;var Da=env.invoke_viiiiiii;var Ea=env.invoke_viiiiiid;var Fa=env.invoke_viiiiiiiii;var Ga=env.invoke_iii;var Ha=env.invoke_iiiiii;var Ia=env.invoke_iiiiidi;var Ja=env.invoke_didd;var Ka=env.invoke_dii;var La=env.invoke_i;var Ma=env.invoke_iiiiiiiiii;var Na=env.invoke_viii;var Oa=env.invoke_v;var Pa=env.invoke_iiiiiiiii;var Qa=env.invoke_iiiii;var Ra=env.invoke_viiii;var Sa=env._fabs;var Ta=env._exp;var Ua=env._strrchr;var Va=env._pthread_key_create;var Wa=env._vsscanf;var Xa=env.__ZSt9terminatev;var Ya=env.___cxa_guard_acquire;var Za=env.__reallyNegative;var _a=env._fstat;var $a=env._pclose;var ab=env._lis_solver_create;var bb=env.___assert_fail;var cb=env.__ZSt18uncaught_exceptionv;var db=env._longjmp;var eb=env.__isLeapYear;var fb=env._clock_gettime;var gb=env._fsync;var hb=env._signal;var ib=env._GC_collect_a_little;var jb=env._sbrk;var kb=env._strtoull;var lb=env._emscripten_memcpy_big;var mb=env.__parseInt64;var nb=env._close;var ob=env._rewind;var pb=env._cos;var qb=env._fileno;var rb=env._fread;var sb=env._puts;var tb=env._isatty;var ub=env._lis_matrix_set_value;var vb=env._write;var wb=env._isblank;var xb=env._ftell;var yb=env.__ZNSt9exceptionD2Ev;var zb=env._xerbla_;var Ab=env._round;var Bb=env.___cxa_does_inherit;var Cb=env._strtoll_l;var Db=env._strstr;var Eb=env.___cxa_rethrow;var Fb=env._llvm_lifetime_end;var Gb=env._catclose;var Hb=env._tmpnam;var Ib=env._lis_vector_destroy;var Jb=env._lis_solver_set_option;var Kb=env._tmpfile;var Lb=env._send;var Mb=env._pow;var Nb=env.___cxa_is_number_type;var Ob=env.___cxa_free_exception;var Pb=env.___cxa_find_matching_catch;var Qb=env._isxdigit_l;var Rb=env.___cxa_guard_release;var Sb=env._truncate;var Tb=env._strtol;var Ub=env._sin;var Vb=env._strtok;var Wb=env.___setErrNo;var Xb=env._newlocale;var Yb=env._isdigit_l;var Zb=env.___resumeException;var _b=env._freelocale;var $b=env._srand;var ac=env._fscanf;var bc=env._qsort;var cc=env._putchar;var dc=env._floor;var ec=env._pthread_mutex_unlock;var fc=env._printf;var gc=env._sprintf;var hc=env._fopen;var ic=env._vasprintf;var jc=env._emscripten_get_now;var kc=env._stat;var lc=env._vsnprintf;var mc=env._strtoull_l;var nc=env._read;var oc=env.__addDays;var pc=env._fwrite;var qc=env._time;var rc=env._pthread_mutex_lock;var sc=env._catopen;var tc=env._exit;var uc=env._GC_strdup;var vc=env._freopen;var wc=env.___ctype_b_loc;var xc=env._fmod;var yc=env._strtok_r;var zc=env._lseek;var Ac=env._access;var Bc=env._vfprintf;var Cc=env.___cxa_allocate_exception;var Dc=env._atoi;var Ec=env._strtoll;var Fc=env._pwrite;var Gc=env._localtime_r;var Hc=env._tzset;var Ic=env._open;var Jc=env._uselocale;var Kc=env._snprintf;var Lc=env.___errno_location;var Mc=env._GC_malloc;var Nc=env.___cxa_end_catch;var Oc=env._perror;var Pc=env.___cxa_begin_catch;var Qc=env._strftime;var Rc=env._ftruncate;var Sc=env._GC_init;var Tc=env._fseek;var Uc=env._isxdigit;var Vc=env._fclose;var Wc=env.__parseInt;var Xc=env._log;var Yc=env._pthread_cond_broadcast;var Zc=env._popen;var _c=env._recv;var $c=env._fgetc;var ad=env._sysconf;var bd=env.__getFloat;var cd=env._abort;var dd=env._ceil;var ed=env._isspace;var fd=env._localtime;var gd=env._pthread_getspecific;var hd=env._pthread_cond_wait;var id=env._llvm_lifetime_start;var jd=env._ungetc;var kd=env._system;var ld=env._fmax;var md=env._fflush;var nd=env._strftime_l;var od=env._fprintf;var pd=env._sscanf;var qd=env._catgets;var rd=env._strdup;var sd=env._asprintf;var td=env.__exit;var ud=env.___ctype_toupper_loc;var vd=env._bsearch;var wd=env.__arraySum;var xd=env.__formatString;var yd=env._htonl;var zd=env.___ctype_tolower_loc;var Ad=env._unlink;var Bd=env._fputs;var Cd=env._GC_malloc_atomic;var Dd=env._pread;var Ed=env._lis_vector_set_size;var Fd=env._mkport;var Gd=env.__scanString;var Hd=env._pthread_setspecific;var Id=env._copysign;var Jd=env._fputc;var Kd=env.___cxa_throw;var Ld=env._lis_solver_destroy;var Md=env._isdigit;var Nd=env._strerror;var Od=env._emscripten_longjmp;var Pd=env._lis_vector_create;var Qd=env._atexit;var Rd=env._sqrt;var Sd=env._strerror_r;var Td=0.0;
// EMSCRIPTEN_START_FUNCS
function El(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Wk(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=Il(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=Hl(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Wk(a[g]|0,a[b+1|0]|0)|0}if((n|0)==27){k=Fl(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=Gl(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[13064+((d[12808+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b]|0)==0){p=d[j+76+(d[m+1|0]|0)|0]|0}else{p=Wk(a[m]|0,a[b+1|0]|0)|0}switch(p|0){case 11:{o=90;break b;break};case 6:{o=42;break b;break};case 5:{o=39;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{o=45;break b;break};case 10:case 9:case 21:{o=69;break b;break};case 29:{if((c[13064+((d[14344+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=37;break b}break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=Wk(a[m]|0,a[b+1|0]|0)|0}switch(q|0){case 5:{o=59;break b;break};case 6:{o=62;break b;break};case 7:{o=65;break b;break};case 24:case 22:{break};case 29:{if((c[13064+((d[12808+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=57;break b}break};default:{o=68;break b}}b=b+2|0;continue b;break};case 17:{break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b]|0)==0){r=d[j+76+(d[q+1|0]|0)|0]|0}else{r=Wk(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 24:case 22:{break d;break};case 11:{o=90;break c;break};case 6:{o=81;break d;break};case 7:{o=84;break d;break};case 5:{o=78;break d;break};case 29:{o=75;break d;break};case 17:{break c;break};case 10:case 9:case 21:{break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[13064+((d[12808+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=Jl(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function Fl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=Wk(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b]|0)!=0){continue b}if((a[b+1|0]|0)==45){l=25;break b}else{continue b}break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function Gl(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k]|0)!=0){l=7;break}if((a[g+1|0]|0)!=(a[15384+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function Hl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b]|0)==0){o=d[k+76+(d[n+1|0]|0)|0]|0}else{o=Wk(a[n]|0,a[b+1|0]|0)|0}a:do{switch(o|0){case 24:case 22:{break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[13064+((d[12808+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=Wk(a[o]|0,a[b+1|0]|0)|0}switch(q|0){case 10:case 9:case 21:{p=37;break b;break};case 6:{p=31;break b;break};case 15:{p=62;break b;break};case 5:{p=28;break b;break};case 29:{if((c[13064+((d[14344+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=26;break b}break};case 7:{p=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((Kl(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b]|0)==0){r=d[k+76+(d[q+1|0]|0)|0]|0}else{r=Wk(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 8:case 1:case 0:{p=54;break c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b]|0)!=0){continue c}if((a[b+1|0]|0)==62){p=59;break c}else{continue c}break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((Kl(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=0){break}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function Il(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Wk(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[13064+((d[12808+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Wk(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 23:{b=b+2|0;continue b;break};case 11:{n=48;break b;break};case 5:{n=28;break b;break};case 7:{n=34;break b;break};case 10:case 9:case 21:{n=37;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[13064+((d[14344+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 6:{n=31;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Wk(a[o]|0,a[b+1|0]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function Jl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){m=d[k+76+(d[b+1|0]|0)|0]|0}else{m=Wk(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b:do{switch(m|0){case 7:{l=16;break a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){n=d[k+76+(d[b+1|0]|0)|0]|0}else{n=Wk(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b=n;if((b|0)==14){break b}o=b;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=47;break a}}break};case 29:{if((c[13064+((d[14344+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){p=d[k+76+(d[o+1|0]|0)|0]|0}else{p=Wk(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(p|0){case 6:{l=33;break a;break};case 7:{l=36;break a;break};case 29:{if((c[13064+((d[12808+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=28;break a}break};case 24:case 22:{break};case 5:{l=30;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 5:{l=10;break a;break};case 6:{l=13;break a;break};case 14:{break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=Wk(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}o=r;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){s=d[k+76+(d[o+1|0]|0)|0]|0}else{s=Wk(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}o=s;if((o|0)==(r|0)){break}switch(o|0){case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 2:{l=79;break a;break};case 3:{t=Al(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 8:case 1:case 0:{l=74;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){u=d[k+76+(d[o+1|0]|0)|0]|0}else{u=Wk(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(u|0){case 10:case 9:case 21:{break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){v=d[k+76+(d[o+1|0]|0)|0]|0}else{v=Wk(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(v|0){case 6:{l=100;break a;break};case 24:case 22:{break d;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};case 7:{l=103;break a;break};case 5:{l=97;break a;break};case 11:{l=106;break a;break};case 29:{l=94;break d;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[13064+((d[12808+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[c[j>>2]|0]|0)==0){if((a[(c[j>>2]|0)+1|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function Kl(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g]|0)==0){k=a[g+1|0]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){l=a[g+1|0]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){m=a[g+1|0]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function Ll(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e]|0)==0){m=d[b+76+(d[h+1|0]|0)|0]|0}else{m=Wk(a[h]|0,a[e+1|0]|0)|0}h=m;switch(h|0){case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 8:case 1:case 0:{l=16;break a;break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e]|0)==0){p=d[b+76+(d[g+1|0]|0)|0]|0}else{p=Wk(a[g]|0,a[e+1|0]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function Ml(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Wk(a[g]|0,a[b+1|0]|0)|0}if((m|0)==27){k=Fl(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b]|0)==0){o=d[j+76+(d[g+1|0]|0)|0]|0}else{o=Wk(a[g]|0,a[b+1|0]|0)|0}switch(o|0){case 24:case 22:{break};case 30:{n=16;break a;break};case 10:case 9:case 21:{break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+2|0]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Wk(a[o]|0,a[b+3|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function Nl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Wk(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[13064+((d[12808+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Wk(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 7:{n=34;break b;break};case 5:{n=28;break b;break};case 29:{if((c[13064+((d[14344+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=31;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function Ol(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 11:{c[f>>2]=b+1;k=17;l=k;i=h;return l|0};case 31:{c[f>>2]=b+1;k=23;l=k;i=h;return l|0};case 19:{k=ym(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 12:{k=wm(12,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}if((ne[c[j+352>>2]&63](j,b)|0)!=0){b=b+4|0;m=18;break a}g=b;if((ne[c[j+340>>2]&63](j,b)|0)!=0){b=g+4|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:case 21:{n=15;break};case 13:{k=wm(13,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{m=18;b=b+1|0;break};case 32:{b=b+1|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 34:{c[f>>2]=b+1;k=37;l=k;i=h;return l|0};case 15:{c[f>>2]=b+1;k=35;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 33:{c[f>>2]=b+1;k=36;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 9:{if((b+1|0)!=(e|0)){n=15;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 36:{c[f>>2]=b+1;k=21;l=k;i=h;return l|0};case 30:{k=mm(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}if((ne[c[j+348>>2]&63](j,b)|0)!=0){b=b+3|0;m=18;break a}g=b;if((ne[c[j+336>>2]&63](j,b)|0)!=0){b=g+3|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 20:{c[f>>2]=b+1;k=25;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}if((ne[c[j+344>>2]&63](j,b)|0)!=0){b=b+2|0;m=18;break a}g=b;if((ne[c[j+332>>2]&63](j,b)|0)!=0){b=g+2|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==93){if((b+1|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 2:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -1;k=29;l=k;i=h;return l|0};case 15:{k=sm(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 16:{k=xm(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 23:case 27:case 26:case 25:{m=19;b=b+1|0;break};case 35:{c[f>>2]=b+1;k=38;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);if((n|0)==15){while(1){n=0;b=b+1|0;o=b;if((b|0)==(e|0)){n=19;break}g=d[j+76+(d[o]|0)|0]|0;if((g|0)==10|(g|0)==21){n=15;continue}else if((g|0)!=9){n=18;break}if((b+1|0)!=(e|0)){n=15}else{n=18;break}}if((n|0)==18){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==19){c[f>>2]=o;k=15;l=k;i=h;return l|0}}b:while(1){if((b|0)==(e|0)){n=120;break}switch(d[j+76+(d[b]|0)|0]|0){case 33:{n=113;break b;break};case 6:{if((e-b|0)<3){n=77;break b}p=b;if((ne[c[j+336>>2]&63](j,b)|0)==0){n=79;break b}b=p+3|0;continue b;break};case 7:{if((e-b|0)<4){n=82;break b}q=b;if((ne[c[j+340>>2]&63](j,b)|0)==0){n=84;break b}b=q+4|0;continue b;break};case 15:{n=116;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 5:{if((e-b|0)<2){n=72;break b}r=b;if((ne[c[j+332>>2]&63](j,b)|0)==0){n=74;break b}b=r+2|0;continue b;break};case 29:{n=69;break b;break};case 23:{b=b+1|0;o=m;if((o|0)==41){m=19;continue b}else if((o|0)!=18){continue b}if((b|0)==(e|0)){n=89;break b}m=41;switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){n=99;break b}s=b;if((ne[c[j+336>>2]&63](j,b)|0)==0){n=101;break b}b=s+3|0;continue b;break};case 29:{n=91;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 5:{if((e-b|0)<2){n=94;break b}t=b;if((ne[c[j+332>>2]&63](j,b)|0)==0){n=96;break b}b=t+2|0;continue b;break};case 7:{if((e-b|0)<4){n=104;break b}u=b;if((ne[c[j+340>>2]&63](j,b)|0)==0){n=106;break b}b=u+4|0;continue b;break};default:{m=19;continue b}}break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=86;break b;break};case 34:{n=110;break b;break};default:{n=119;break b}}}if((n|0)==69){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==72){k=-2;l=k;i=h;return l|0}else if((n|0)==74){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((n|0)==77){k=-2;l=k;i=h;return l|0}else if((n|0)==79){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((n|0)==82){k=-2;l=k;i=h;return l|0}else if((n|0)==84){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((n|0)==86){c[f>>2]=b;k=m;l=k;i=h;return l|0}else if((n|0)==89){k=-1;l=k;i=h;return l|0}else if((n|0)==91){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==94){k=-2;l=k;i=h;return l|0}else if((n|0)==96){c[f>>2]=t;k=0;l=k;i=h;return l|0}else if((n|0)==99){k=-2;l=k;i=h;return l|0}else if((n|0)==101){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((n|0)==104){k=-2;l=k;i=h;return l|0}else if((n|0)==106){c[f>>2]=u;k=0;l=k;i=h;return l|0}else if((n|0)==110){u=b;if((m|0)==19){c[f>>2]=u;k=0;l=k;i=h;return l|0}else{c[f>>2]=u+1;k=32;l=k;i=h;return l|0}}else if((n|0)==113){u=b;if((m|0)==19){c[f>>2]=u;k=0;l=k;i=h;return l|0}else{c[f>>2]=u+1;k=31;l=k;i=h;return l|0}}else if((n|0)==116){u=b;if((m|0)==19){c[f>>2]=u;k=0;l=k;i=h;return l|0}else{c[f>>2]=u+1;k=30;l=k;i=h;return l|0}}else if((n|0)==119){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==120){k=0-m|0;l=k;i=h;return l|0}return 0}function Pl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 2:{k=pm(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 3:{k=lm(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((ne[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((ne[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((ne[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=60;break}switch(d[j+76+(d[m]|0)|0]|0){case 7:{if((e-b|0)<4){n=49;break b}if((ne[c[j+364>>2]&63](j,b)|0)!=0){n=49;break b}b=b+4|0;continue b;break};case 5:{if((e-b|0)<2){n=41;break b}if((ne[c[j+356>>2]&63](j,b)|0)!=0){n=41;break b}b=b+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{n=58;break b;break};case 4:{if((b+1|0)==(e|0)){n=58;break b}g=b;if((a[b+1|0]|0)!=93){b=g+1|0;continue b}if((g+2|0)==(e|0)){n=58;break b}o=b;if((a[b+2|0]|0)==62){n=57;break b}b=o+1|0;continue b;break};case 6:{if((e-b|0)<3){n=45;break b}if((ne[c[j+360>>2]&63](j,b)|0)!=0){n=45;break b}b=b+3|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==41){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==45){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==57){c[f>>2]=o+2;k=0;l=k;i=h;return l|0}else if((n|0)==58){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==60){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Ql(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g+1;k=40;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((ne[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((ne[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((ne[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=51;break}switch(d[j+76+(d[m]|0)|0]|0){case 4:case 10:case 9:case 8:case 1:case 0:{n=49;break b;break};case 7:{if((e-b|0)<4){n=47;break b}if((ne[c[j+364>>2]&63](j,b)|0)!=0){n=47;break b}b=b+4|0;continue b;break};case 5:{if((e-b|0)<2){n=39;break b}if((ne[c[j+356>>2]&63](j,b)|0)!=0){n=39;break b}b=b+2|0;continue b;break};case 6:{if((e-b|0)<3){n=43;break b}if((ne[c[j+360>>2]&63](j,b)|0)!=0){n=43;break b}b=b+3|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==39){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==43){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==47){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==51){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Rl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;g=0;a:while(1){if((b|0)==(e|0)){k=37;break}switch(d[j+76+(d[b]|0)|0]|0){case 4:{l=b+1|0;b=l;if((l|0)==(e|0)){k=28;break a}if((a[b]|0)!=93){continue a}l=b+1|0;b=l;if((l|0)==(e|0)){k=31;break a}if((a[b]|0)!=62){continue a}b=b+1|0;if((g|0)==0){k=34;break a}g=g+ -1|0;continue a;break};case 5:{if((e-b|0)<2){k=5;break a}m=b;if((ne[c[j+356>>2]&63](j,b)|0)!=0){k=7;break a}b=m+2|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}n=b;if((ne[c[j+364>>2]&63](j,b)|0)!=0){k=17;break a}b=n+4|0;continue a;break};case 2:{l=b+1|0;b=l;if((l|0)==(e|0)){k=21;break a}if((a[b]|0)!=33){continue a}l=b+1|0;b=l;if((l|0)==(e|0)){k=24;break a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+1|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}o=b;if((ne[c[j+360>>2]&63](j,b)|0)!=0){k=12;break a}b=o+3|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){p=-2;q=p;i=h;return q|0}else if((k|0)==7){c[f>>2]=m;p=0;q=p;i=h;return q|0}else if((k|0)==10){p=-2;q=p;i=h;return q|0}else if((k|0)==12){c[f>>2]=o;p=0;q=p;i=h;return q|0}else if((k|0)==15){p=-2;q=p;i=h;return q|0}else if((k|0)==17){c[f>>2]=n;p=0;q=p;i=h;return q|0}else if((k|0)==19){c[f>>2]=b;p=0;q=p;i=h;return q|0}else if((k|0)==21){p=-1;q=p;i=h;return q|0}else if((k|0)==24){p=-1;q=p;i=h;return q|0}else if((k|0)==28){p=-1;q=p;i=h;return q|0}else if((k|0)==31){p=-1;q=p;i=h;return q|0}else if((k|0)==34){c[f>>2]=b;p=42;q=p;i=h;return q|0}else if((k|0)==37){p=-1;q=p;i=h;return q|0}return 0}function Sl(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=27;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 3:{m=9;break a;break};case 5:{a=a+2|0;continue a;break};case 10:{m=13;break a;break};case 21:{m=23;break a;break};case 2:{m=12;break a;break};case 7:{a=a+4|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 9:{m=16;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=lm(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((m|0)==13){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==16){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==23){h=a;if((a|0)==(f|0)){c[e>>2]=h+1;j=39;k=j;i=g;return k|0}else{c[e>>2]=h;j=6;k=j;i=g;return k|0}}else if((m|0)==27){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function Tl(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+56|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=26;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 30:{m=12;break a;break};case 9:{m=18;break a;break};case 7:{a=a+4|0;continue a;break};case 10:{m=15;break a;break};case 5:{a=a+2|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 3:{m=9;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=lm(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){if((a|0)==(f|0)){n=mm(h,a+1|0,b,e)|0;j=(n|0)==22?0:n;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==15){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==18){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==26){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function Ul(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){switch(d[g+76+(d[b]|0)|0]|0){case 6:{h=5;break};case 5:{break};case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){h=4;break a}else{h=5}break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){h=12;break a}else{continue a}break};default:{h=13;break a}}if((h|0)==5){h=0;e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){h=6;break}}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){h=8;break}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){h=10;break}}if((h|0)==4){k=0;l=k;i=f;return l|0}else if((h|0)==6){k=0;l=k;i=f;return l|0}else if((h|0)==8){k=0;l=k;i=f;return l|0}else if((h|0)==10){k=0;l=k;i=f;return l|0}else if((h|0)==12){k=0;l=k;i=f;return l|0}else if((h|0)==13){if((a[b]|0)==(a[c]|0)){k=1;l=k;i=f;return l|0}switch(d[g+76+(d[c]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{k=0;l=k;i=f;return l|0};default:{k=1;l=k;i=f;return l|0}}}return 0}function Vl(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=8;break}if(g){h=4;break}if((a[f]|0)!=(a[d]|0)){h=6;break}f=f+1|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==6){j=0;k=j;i=b;return k|0}else if((h|0)==8){j=g&1;k=j;i=b;return k|0}return 0}function Wl(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+24|0;e=a;a=b;b=a;a:while(1){switch(d[e+76+(d[a]|0)|0]|0|0){case 6:{a=a+3|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{a=a+1|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 5:{a=a+2|0;continue a;break};default:{break a}}}i=c;return a-b|0}function Xl(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+16|0;e=a;a=b;while(1){b=d[e+76+(d[a]|0)|0]|0;if(!((b|0)==21|(b|0)==9|(b|0)==10)){break}a=a+1|0}i=c;return a|0}function Yl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+1|0;a:while(1){b:do{switch(d[j+76+(d[b]|0)|0]|0){case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)!=32){break}if((a[b+1|0]|0)==32){break}if((d[j+76+(d[b+1|0]|0)|0]|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+3|0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+1|0}i=h;return k|0}function Zl(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=c;c=0;d=d+2|0;a:do{if((a[d]|0)==120){d=d+1|0;while(1){if(!((a[d]|0)==59^1)){break a}e=a[d]|0;switch(e|0){case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(e-97))|0;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(e-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|e-48;break};default:{}}if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}else{while(1){if(!((a[d]|0)==59^1)){break a}c=c*10|0;c=c+((a[d]|0)-48)|0;if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}}while(0);f=ik(c)|0;g=f;i=b;return g|0}function _l(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+32|0;e=c;c=(d-e|0)/1|0;do{if((c|0)==3){if((a[e]|0)!=97){break}e=e+1|0;if((a[e]|0)!=109){break}e=e+1|0;if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}else if((c|0)==2){if((a[e+1|0]|0)!=116){break}d=a[e]|0;if((d|0)==108){f=60;g=f;i=b;return g|0}else if((d|0)==103){f=62;g=f;i=b;return g|0}else{break}}else if((c|0)==4){d=a[e]|0;if((d|0)==113){e=e+1|0;if((a[e]|0)!=117){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else if((d|0)==97){e=e+1|0;if((a[e]|0)!=112){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else{break}}}while(0);f=0;g=f;i=b;return g|0}function $l(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=a;a=b;b=e;e=f;while(1){if(!(a>>>0<b>>>0)){break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{a=a+2|0;break};case 6:{a=a+3|0;break};case 9:{f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;do{if((a|0)!=(b|0)){if((d[h+76+(d[a]|0)|0]|0|0)!=10){break}a=a+1|0}}while(0);c[e+4>>2]=-1;break};case 10:{c[e+4>>2]=-1;f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;break};case 7:{a=a+4|0;break};default:{a=a+1|0}}f=e+4|0;c[f>>2]=(c[f>>2]|0)+1}i=g;return}function am(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+1|0;e=e+ -1|0;a:while(1){if((b|0)==(e|0)){k=10;break}switch(d[j+76+(d[b]|0)|0]|0){case 21:{if((a[b]|0)==9){k=5;break a}break};case 22:case 26:{if((a[b]&-128|0)!=0){k=7}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=7}}if((k|0)==7){k=0;g=a[b]|0;if(!((g|0)==64|(g|0)==36)){k=8;break}}b=b+1|0}if((k|0)==5){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==8){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==10){l=1;m=l;i=h;return m|0}return 0}function bm(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+56|0;h=d;d=e;e=f;f=g;a:do{if((d-(c[h>>2]|0)|0)>(f-(c[e>>2]|0)|0)){d=(c[h>>2]|0)+(f-(c[e>>2]|0))|0;while(1){if(!(d>>>0>(c[h>>2]|0)>>>0)){break a}if((a[d+ -1|0]&192|0)!=128){break a}d=d+ -1|0}}}while(0);f=c[e>>2]|0;g=c[h>>2]|0;while(1){j=g;if((g|0)==(d|0)){break}a[f]=a[j]|0;g=g+1|0;f=f+1|0}c[h>>2]=j;c[e>>2]=f;i=b;return}function cm(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+64|0;l=e;e=f;f=g;g=h;h=j;j=c[g>>2]|0;m=c[e>>2]|0;while(1){if((m|0)==(f|0)){n=10;break}if((j|0)==(h|0)){n=10;break}o=d[l+76+(d[m]|0)|0]|0;if((o|0)==7){if((j+2|0)==(h|0)){n=10;break}p=(a[m]&7)<<18|(a[m+1|0]&63)<<12|(a[m+2|0]&63)<<6|a[m+3|0]&63;p=p-65536|0;b[j>>1]=p>>>10|55296;b[j+2>>1]=p&1023|56320;j=j+4|0;m=m+4|0;continue}else if((o|0)==6){p=j;j=p+2|0;b[p>>1]=(a[m]&15)<<12|(a[m+1|0]&63)<<6|a[m+2|0]&63;m=m+3|0;continue}else if((o|0)==5){o=j;j=o+2|0;b[o>>1]=(a[m]&31)<<6|a[m+1|0]&63;m=m+2|0;continue}else{o=m;m=o+1|0;p=j;j=p+2|0;b[p>>1]=a[o]|0;continue}}if((n|0)==10){c[e>>2]=m;c[g>>2]=j;i=k;return}}function dm(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[13064+(((d[14344+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function em(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[13064+(((d[14344+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function fm(a,b){a=a|0;b=b|0;b=i;i=i+16|0;i=b;return 0}function gm(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[13064+(((d[12808+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function hm(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[13064+(((d[12808+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function im(b,c){b=b|0;c=c|0;var e=0,f=0;b=i;i=i+16|0;e=c;do{if((d[e]|0|0)<194){f=1}else{if((a[e+1|0]&128|0)==0){f=1;break}f=(a[e+1|0]&192|0)==192}}while(0);i=b;return f&1|0}function jm(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}do{if((d[e]|0|0)==239){if((d[e+1|0]|0|0)!=191){h=5;break}if((d[e+2|0]|0|0)>189){f=1}else{break}g=f&1;i=b;return g|0}else{h=5}}while(0);do{if((h|0)==5){if((a[e+2|0]&192|0)==192){f=1}else{break}g=f&1;i=b;return g|0}}while(0);h=d[e+1|0]|0;do{if((d[e]|0|0)==224){if((h|0)<160){j=1;break}j=(a[e+1|0]&192|0)==192}else{if((h&128|0)==0){j=1;break}c=d[e+1|0]|0;if((d[e]|0|0)==237){k=(c|0)>159}else{k=(c&192|0)==192}j=(k&1|0)!=0}}while(0);f=(j&1|0)!=0;g=f&1;i=b;return g|0}function km(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+3|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+3|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}c=d[e+1|0]|0;do{if((d[e]|0|0)==240){if((c|0)<144){h=1;break}h=(a[e+1|0]&192|0)==192}else{if((c&128|0)==0){h=1;break}j=d[e+1|0]|0;if((d[e]|0|0)==244){k=(j|0)>143}else{k=(j&192|0)==192}h=(k&1|0)!=0}}while(0);f=(h&1|0)!=0;g=f&1;i=b;return g|0}function lm(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((ne[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((ne[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 19:{j=nm(h,a+1|0,b,e)|0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((ne[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){l=28;break b}m=a;if((ne[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=m+2|0;continue b;break};case 29:{l=25;break b;break};case 6:{if((b-a|0)<3){l=33;break b}n=a;if((ne[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=n+3|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}o=a;if((ne[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=o+4|0;continue b;break};case 18:{l=42;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=9;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function mm(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((ne[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((ne[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 30:case 9:case 10:case 21:{c[e>>2]=a;j=22;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((ne[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){l=28;break b}m=a;if((ne[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=m+2|0;continue b;break};case 29:{l=25;break b;break};case 6:{if((b-a|0)<3){l=33;break b}n=a;if((ne[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=n+3|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}o=a;if((ne[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=o+4|0;continue b;break};case 18:{l=42;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=28;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function nm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){if((a[b]|0)==120){k=om(j,b+1|0,e,f)|0;l=k;i=h;return l|0}g=b;if((d[j+76+(d[b]|0)|0]|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;while(1){if((b|0)==(e|0)){break a}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==18){m=9;break}else if((g|0)!=25){m=10;break}b=b+1|0}if((m|0)==9){c[f>>2]=b+1;k=10;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function om(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;a:do{if((a|0)!=(b|0)){f=a;if(!(((d[h+76+(d[a]|0)|0]|0)+ -24|0)>>>0<2)){c[e>>2]=f;j=0;k=j;i=g;return k|0}a=f+1|0;while(1){if((a|0)==(b|0)){break a}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==18){l=7;break}else if(!((f|0)==24|(f|0)==25)){l=8;break}a=a+1|0}if((l|0)==7){c[e>>2]=a+1;j=10;k=j;i=g;return k|0}else if((l|0)==8){c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);j=-1;k=j;i=g;return k|0}function pm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 24:case 22:{b=b+1|0;break};case 15:{k=sm(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((ne[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((ne[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 16:{g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==27){k=qm(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else if((g|0)==20){k=rm(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((ne[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 29:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 17:{k=tm(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);g=0;b:while(1){if((b|0)==(e|0)){m=104;break}switch(d[j+76+(d[b]|0)|0]|0){case 23:{if((g|0)!=0){m=51;break b}g=1;b=b+1|0;if((b|0)==(e|0)){m=53;break b}switch(d[j+76+(d[b]|0)|0]|0){case 29:{m=55;break b;break};case 5:{if((e-b|0)<2){m=58;break b}n=b;if((ne[c[j+344>>2]&63](j,b)|0)==0){m=60;break b}b=n+2|0;continue b;break};case 6:{if((e-b|0)<3){m=63;break b}o=b;if((ne[c[j+348>>2]&63](j,b)|0)==0){m=65;break b}b=o+3|0;continue b;break};case 24:case 22:{b=b+1|0;continue b;break};case 7:{if((e-b|0)<4){m=68;break b}p=b;if((ne[c[j+352>>2]&63](j,b)|0)==0){m=70;break b}b=p+4|0;continue b;break};default:{m=72;break b}}break};case 5:{if((e-b|0)<2){m=36;break b}q=b;if((ne[c[j+332>>2]&63](j,b)|0)==0){m=38;break b}b=q+2|0;continue b;break};case 17:{break b;break};case 7:{if((e-b|0)<4){m=46;break b}r=b;if((ne[c[j+340>>2]&63](j,b)|0)==0){m=48;break b}b=r+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 29:{m=33;break b;break};case 11:{m=97;break b;break};case 6:{if((e-b|0)<3){m=41;break b}s=b;if((ne[c[j+336>>2]&63](j,b)|0)==0){m=43;break b}b=s+3|0;continue b;break};case 10:case 9:case 21:{m=73;break b;break};default:{m=103;break b}}}c:do{if((m|0)==33){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==36){k=-2;l=k;i=h;return l|0}else if((m|0)==38){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==41){k=-2;l=k;i=h;return l|0}else if((m|0)==43){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==46){k=-2;l=k;i=h;return l|0}else if((m|0)==48){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==51){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==53){k=-1;l=k;i=h;return l|0}else if((m|0)==55){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==58){k=-2;l=k;i=h;return l|0}else if((m|0)==60){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==63){k=-2;l=k;i=h;return l|0}else if((m|0)==65){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==68){k=-2;l=k;i=h;return l|0}else if((m|0)==70){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==72){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==73){b=b+1|0;d:while(1){if((b|0)==(e|0)){m=96;break}switch(d[j+76+(d[b]|0)|0]|0){case 24:case 22:{m=77;break d;break};case 17:{break c;break};case 10:case 9:case 21:{break};case 7:{m=88;break d;break};case 6:{m=83;break d;break};case 11:{m=97;break c;break};case 29:{m=76;break d;break};case 5:{m=78;break d;break};default:{m=94;break d}}b=b+1|0}do{if((m|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==77){b=b+1|0}else if((m|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((ne[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==83){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((ne[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==88){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((ne[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==94){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==96){k=-1;l=k;i=h;return l|0}}while(0);k=um(j,b,e,f)|0;l=k;i=h;return l|0}else if((m|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-1;l=k;i=h;return l|0}}while(0);if((m|0)==97){c[f>>2]=b+1;k=2;l=k;i=h;return l|0}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}e=b;if((a[b]|0)==62){c[f>>2]=e+1;k=4;l=k;i=h;return l|0}else{c[f>>2]=e;k=0;l=k;i=h;return l|0}return 0}function qm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)!=45){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;b:while(1){if((b|0)==(e|0)){break a}switch(d[j+76+(d[b]|0)|0]|0){case 8:case 1:case 0:{m=22;break b;break};case 27:{g=b+1|0;b=g;if((g|0)==(e|0)){m=24;break b}if((a[b]|0)==45){m=26;break b}else{continue b}break};case 5:{if((e-b|0)<2){m=8;break b}n=b;if((ne[c[j+356>>2]&63](j,b)|0)!=0){m=10;break b}b=n+2|0;continue b;break};case 7:{if((e-b|0)<4){m=18;break b}o=b;if((ne[c[j+364>>2]&63](j,b)|0)!=0){m=20;break b}b=o+4|0;continue b;break};case 6:{if((e-b|0)<3){m=13;break b}p=b;if((ne[c[j+360>>2]&63](j,b)|0)!=0){m=15;break b}b=p+3|0;continue b;break};default:{b=b+1|0;continue b}}}if((m|0)==8){k=-2;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==13){k=-2;l=k;i=h;return l|0}else if((m|0)==15){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==18){k=-2;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==22){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==24){k=-1;l=k;i=h;return l|0}else if((m|0)==26){g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==62){c[f>>2]=g+1;k=13;l=k;i=h;return l|0}else{c[f>>2]=g;k=0;l=k;i=h;return l|0}}}}while(0);k=-1;l=k;i=h;return l|0}function rm(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<6){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=8;break}if((a[k]|0)!=(a[15760+e|0]|0)){l=6;break}e=e+1|0;g=g+1|0}if((l|0)==6){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==8){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function sm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}a:do{switch(d[k+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}n=b;if((ne[c[k+348>>2]&63](k,b)|0)!=0){b=n+3|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 24:case 22:{b=b+1|0;break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}n=b;if((ne[c[k+344>>2]&63](k,b)|0)!=0){b=n+2|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 29:{c[f>>2]=b;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}n=b;if((ne[c[k+352>>2]&63](k,b)|0)!=0){b=n+4|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b:while(1){if((b|0)==(e|0)){o=75;break}switch(d[k+76+(d[b]|0)|0]|0){case 15:{o=68;break b;break};case 5:{if((e-b|0)<2){o=27;break b}p=b;if((ne[c[k+332>>2]&63](k,b)|0)==0){o=29;break b}b=p+2|0;continue b;break};case 6:{if((e-b|0)<3){o=32;break b}q=b;if((ne[c[k+336>>2]&63](k,b)|0)==0){o=34;break b}b=q+3|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 29:{o=24;break b;break};case 10:case 9:case 21:{o=41;break b;break};case 7:{if((e-b|0)<4){o=37;break b}r=b;if((ne[c[k+340>>2]&63](k,b)|0)==0){o=39;break b}b=r+4|0;continue b;break};default:{break b}}}do{if((o|0)==24){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==27){l=-2;m=l;i=h;return m|0}else if((o|0)==29){c[f>>2]=p;l=0;m=l;i=h;return m|0}else if((o|0)==32){l=-2;m=l;i=h;return m|0}else if((o|0)==34){c[f>>2]=q;l=0;m=l;i=h;return m|0}else if((o|0)==37){l=-2;m=l;i=h;return m|0}else if((o|0)==39){c[f>>2]=r;l=0;m=l;i=h;return m|0}else if((o|0)==41){n=b;if((vm(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;c:while(1){if((b|0)==(e|0)){o=67;break}switch(d[k+76+(d[b]|0)|0]|0){case 15:{b=b+1|0;if((b|0)==(e|0)){o=63;break c}if((a[b]|0)==62){o=65;break c}else{continue c}break};case 6:{if((e-b|0)<3){o=52;break c}s=b;if((ne[c[k+360>>2]&63](k,b)|0)!=0){o=54;break c}b=s+3|0;continue c;break};case 7:{if((e-b|0)<4){o=57;break c}t=b;if((ne[c[k+364>>2]&63](k,b)|0)!=0){o=59;break c}b=t+4|0;continue c;break};case 5:{if((e-b|0)<2){o=47;break c}u=b;if((ne[c[k+356>>2]&63](k,b)|0)!=0){o=49;break c}b=u+2|0;continue c;break};case 8:case 1:case 0:{o=61;break c;break};default:{b=b+1|0;continue c}}}if((o|0)==47){l=-2;m=l;i=h;return m|0}else if((o|0)==49){c[f>>2]=u;l=0;m=l;i=h;return m|0}else if((o|0)==52){l=-2;m=l;i=h;return m|0}else if((o|0)==54){c[f>>2]=s;l=0;m=l;i=h;return m|0}else if((o|0)==57){l=-2;m=l;i=h;return m|0}else if((o|0)==59){c[f>>2]=t;l=0;m=l;i=h;return m|0}else if((o|0)==61){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==63){l=-1;m=l;i=h;return m|0}else if((o|0)==65){c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==67){l=-1;m=l;i=h;return m|0}}else if((o|0)==68){n=b;if((vm(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=62){break}c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==75){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function tm(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((ne[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((ne[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((ne[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=51;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){l=27;break b}m=a;if((ne[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=m+2|0;continue b;break};case 23:{a=a+1|0;continue b;break};case 6:{if((b-a|0)<3){l=32;break b}n=a;if((ne[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=n+3|0;continue b;break};case 11:{l=49;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 29:{l=24;break b;break};case 10:case 9:case 21:{l=41;break b;break};case 7:{if((b-a|0)<4){l=37;break b}o=a;if((ne[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=o+4|0;continue b;break};default:{l=50;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==41){a=a+1|0;while(1){if((a|0)==(b|0)){l=47;break}o=d[h+76+(d[a]|0)|0]|0;if((o|0)==11){l=44;break}else if(!((o|0)==10|(o|0)==9|(o|0)==21)){l=45;break}a=a+1|0}if((l|0)==44){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==45){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==47){j=-1;k=j;i=g;return k|0}}else if((l|0)==49){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==50){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==51){j=-1;k=j;i=g;return k|0}return 0}function um(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=114;break}b:do{switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=12;break a}b=(ne[c[k+336>>2]&63](k,c[j>>2]|0)|0)!=0;m=c[j>>2]|0;if(!b){l=14;break a}c[j>>2]=m+3;continue a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=17;break a}b=(ne[c[k+340>>2]&63](k,c[j>>2]|0)|0)!=0;n=c[j>>2]|0;if(!b){l=19;break a}c[j>>2]=n+4;continue a;break};case 14:{break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=7;break a}b=(ne[c[k+332>>2]&63](k,c[j>>2]|0)|0)!=0;o=c[j>>2]|0;if(!b){l=9;break a}c[j>>2]=o+2;continue a;break};case 27:case 26:case 25:case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 23:{if((g|0)!=0){l=22;break a}g=1;c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=24;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=29;break a}b=(ne[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;p=c[j>>2]|0;if(!b){l=31;break a}c[j>>2]=p+2;continue a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=34;break a}b=(ne[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;q=c[j>>2]|0;if(!b){l=36;break a}c[j>>2]=q+3;continue a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=39;break a}b=(ne[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;r=c[j>>2]|0;if(!b){l=41;break a}c[j>>2]=r+4;continue a;break};case 29:{l=26;break a;break};default:{l=43;break a}}break};case 29:{l=4;break a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=45;break a}b=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((b|0)==14){break b}s=b;if(!((s|0)==9|(s|0)==10|(s|0)==21)){l=48;break a}}break};default:{l=113;break a}}}while(0);g=0;while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=51;break a}t=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((t|0)==12|(t|0)==13){break}s=t;if(!((s|0)==9|(s|0)==10|(s|0)==21)){l=54;break a}}c[j>>2]=(c[j>>2]|0)+1;c:while(1){if((c[j>>2]|0)==(e|0)){l=57;break a}s=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((s|0)==(t|0)){break}switch(s|0){case 5:{if((e-(c[j>>2]|0)|0)<2){l=61;break a}s=(ne[c[k+356>>2]&63](k,c[j>>2]|0)|0)!=0;u=c[j>>2]|0;if(s){l=63;break a}c[j>>2]=u+2;continue c;break};case 8:case 1:case 0:{l=75;break a;break};case 2:{l=80;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=66;break a}s=(ne[c[k+360>>2]&63](k,c[j>>2]|0)|0)!=0;v=c[j>>2]|0;if(s){l=68;break a}c[j>>2]=v+3;continue c;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=71;break a}s=(ne[c[k+364>>2]&63](k,c[j>>2]|0)|0)!=0;w=c[j>>2]|0;if(s){l=73;break a}c[j>>2]=w+4;continue c;break};case 3:{x=lm(k,(c[j>>2]|0)+1|0,e,j)|0;if((x|0)<=0){l=77;break a}else{continue c}break};default:{c[j>>2]=(c[j>>2]|0)+1;continue c}}}c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=83;break}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 17:{l=107;break a;break};case 11:{l=106;break a;break};case 10:case 9:case 21:{break};default:{l=85;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=87;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 17:{l=107;break a;break};case 24:case 22:{l=90;break d;break};case 6:{l=96;break d;break};case 11:{l=106;break a;break};case 29:{l=89;break a;break};case 10:case 9:case 21:{break};case 5:{l=91;break d;break};case 7:{l=101;break d;break};default:{l=112;break a}}}if((l|0)==90){l=0;c[j>>2]=(c[j>>2]|0)+1;continue}else if((l|0)==91){l=0;if((e-(c[j>>2]|0)|0)<2){l=92;break}s=(ne[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;y=c[j>>2]|0;if(!s){l=94;break}c[j>>2]=y+2;continue}else if((l|0)==96){l=0;if((e-(c[j>>2]|0)|0)<3){l=97;break}s=(ne[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;z=c[j>>2]|0;if(!s){l=99;break}c[j>>2]=z+3;continue}else if((l|0)==101){l=0;if((e-(c[j>>2]|0)|0)<4){l=102;break}s=(ne[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;A=c[j>>2]|0;if(!s){l=104;break}c[j>>2]=A+4;continue}}if((l|0)==4){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==7){B=-2;C=B;i=h;return C|0}else if((l|0)==9){c[f>>2]=o;B=0;C=B;i=h;return C|0}else if((l|0)==12){B=-2;C=B;i=h;return C|0}else if((l|0)==14){c[f>>2]=m;B=0;C=B;i=h;return C|0}else if((l|0)==17){B=-2;C=B;i=h;return C|0}else if((l|0)==19){c[f>>2]=n;B=0;C=B;i=h;return C|0}else if((l|0)==22){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==24){B=-1;C=B;i=h;return C|0}else if((l|0)==26){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==29){B=-2;C=B;i=h;return C|0}else if((l|0)==31){c[f>>2]=p;B=0;C=B;i=h;return C|0}else if((l|0)==34){B=-2;C=B;i=h;return C|0}else if((l|0)==36){c[f>>2]=q;B=0;C=B;i=h;return C|0}else if((l|0)==39){B=-2;C=B;i=h;return C|0}else if((l|0)==41){c[f>>2]=r;B=0;C=B;i=h;return C|0}else if((l|0)==43){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==45){B=-1;C=B;i=h;return C|0}else if((l|0)==48){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==51){B=-1;C=B;i=h;return C|0}else if((l|0)==54){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==57){B=-1;C=B;i=h;return C|0}else if((l|0)==61){B=-2;C=B;i=h;return C|0}else if((l|0)==63){c[f>>2]=u;B=0;C=B;i=h;return C|0}else if((l|0)==66){B=-2;C=B;i=h;return C|0}else if((l|0)==68){c[f>>2]=v;B=0;C=B;i=h;return C|0}else if((l|0)==71){B=-2;C=B;i=h;return C|0}else if((l|0)==73){c[f>>2]=w;B=0;C=B;i=h;return C|0}else if((l|0)==75){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==77){if((x|0)==0){c[f>>2]=c[j>>2]}B=x;C=B;i=h;return C|0}else if((l|0)==80){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==83){B=-1;C=B;i=h;return C|0}else if((l|0)==85){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==87){B=-1;C=B;i=h;return C|0}else if((l|0)==89){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==92){B=-2;C=B;i=h;return C|0}else if((l|0)==94){c[f>>2]=y;B=0;C=B;i=h;return C|0}else if((l|0)==97){B=-2;C=B;i=h;return C|0}else if((l|0)==99){c[f>>2]=z;B=0;C=B;i=h;return C|0}else if((l|0)==102){B=-2;C=B;i=h;return C|0}else if((l|0)==104){c[f>>2]=A;B=0;C=B;i=h;return C|0}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+1;B=1;C=B;i=h;return C|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){B=-1;C=B;i=h;return C|0}e=c[j>>2]|0;if((a[c[j>>2]|0]|0)==62){c[f>>2]=e+1;B=3;C=B;i=h;return C|0}else{c[f>>2]=e;B=0;C=B;i=h;return C|0}}else if((l|0)==112){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==113){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==114){B=-1;C=B;i=h;return C|0}return 0}function vm(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;do{if((e-g|0)!=3){h=1}else{j=a[g]|0;if((j|0)==88){f=1}else if((j|0)!=120){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==77){f=1}else if((j|0)!=109){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==76){f=1}else if((j|0)!=108){h=1;break}if((f|0)!=0){h=0;break}else{c[d>>2]=12;h=1;break}}}while(0);i=b;return h|0}function wm(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+56|0;j=a;a=b;b=e;e=f;f=g;a:while(1){if((b|0)==(e|0)){k=27;break}g=d[a+76+(d[b]|0)|0]|0;switch(g|0){case 8:case 1:case 0:{k=19;break a;break};case 5:{if((e-b|0)<2){k=5;break a}l=b;if((ne[c[a+356>>2]&63](a,b)|0)!=0){k=7;break a}b=l+2|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}m=b;if((ne[c[a+364>>2]&63](a,b)|0)!=0){k=17;break a}b=m+4|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}n=b;if((ne[c[a+360>>2]&63](a,b)|0)!=0){k=12;break a}b=n+3|0;continue a;break};case 13:case 12:{b=b+1|0;if((g|0)!=(j|0)){continue a}else{k=21;break a}break};default:{b=b+1|0;continue a}}}if((k|0)==5){o=-2;p=o;i=h;return p|0}else if((k|0)==7){c[f>>2]=l;o=0;p=o;i=h;return p|0}else if((k|0)==10){o=-2;p=o;i=h;return p|0}else if((k|0)==12){c[f>>2]=n;o=0;p=o;i=h;return p|0}else if((k|0)==15){o=-2;p=o;i=h;return p|0}else if((k|0)==17){c[f>>2]=m;o=0;p=o;i=h;return p|0}else if((k|0)==19){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==21){if((b|0)==(e|0)){o=-27;p=o;i=h;return p|0}c[f>>2]=b;switch(d[a+76+(d[b]|0)|0]|0|0){case 20:case 30:case 11:case 10:case 9:case 21:{o=27;p=o;i=h;return p|0};default:{o=0;p=o;i=h;return p|0}}}else if((k|0)==27){o=-1;p=o;i=h;return p|0}return 0}function xm(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==24|(f|0)==22){a=a+1|0;a:while(1){if((a|0)==(b|0)){l=17;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 10:case 9:case 21:{break a;break};case 30:{l=10;break a;break};case 24:case 22:{break};default:{l=16;break a}}a=a+1|0}do{if((l|0)==10){if((a+1|0)==(b|0)){j=-1;k=j;i=g;return k|0}m=d[h+76+(d[a+1|0]|0)|0]|0;if(!((m|0)==30|(m|0)==10|(m|0)==9|(m|0)==21)){break}c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==16){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==17){j=-1;k=j;i=g;return k|0}}while(0);c[e>>2]=a;j=16;k=j;i=g;return k|0}else if((f|0)==20){c[e>>2]=a+1;j=33;k=j;i=g;return k|0}else if((f|0)==27){j=qm(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=0;k=j;i=g;return k|0}return 0}function ym(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 24:case 22:{a=a+1|0;break};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((ne[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((ne[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((ne[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=43;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){l=27;break b}m=a;if((ne[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=m+2|0;continue b;break};case 7:{if((b-a|0)<4){l=37;break b}n=a;if((ne[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=n+4|0;continue b;break};case 6:{if((b-a|0)<3){l=32;break b}o=a;if((ne[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=o+3|0;continue b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{l=41;break b;break};case 29:{l=24;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};default:{l=42;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==41){c[e>>2]=a;j=20;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==43){j=-20;k=j;i=g;return k|0}return 0}function zm(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+40|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=5;break}if((c[e>>2]|0)==(f|0)){j=5;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g}if((j|0)==5){i=b;return}}function Am(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;a=i;i=i+40|0;j=e;e=f;f=g;g=h;while(1){if((c[j>>2]|0)==(e|0)){k=5;break}if((c[f>>2]|0)==(g|0)){k=5;break}h=j;l=c[h>>2]|0;c[h>>2]=l+1;h=d[l]|0;l=f;m=c[l>>2]|0;c[l>>2]=m+2;b[m>>1]=h}if((k|0)==5){i=a;return}}function Bm(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+48|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=8;break}g=a[c[h>>2]|0]|0;if((g&128|0)!=0){if((f-(c[e>>2]|0)|0)<2){j=8;break}k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=(g&255)>>6|192;l=e;k=c[l>>2]|0;c[l>>2]=k+1;a[k]=g&63|128;g=h;c[g>>2]=(c[g>>2]|0)+1;continue}else{if((c[e>>2]|0)==(f|0)){j=8;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g;continue}}if((j|0)==8){i=b;return}}function Cm(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+72|0;l=b;b=e;e=f;f=g;g=h;h=j;if((f|0)==(g|0)){m=-4;n=m;i=k;return n|0}j=c[b+76>>2]|0;a:do{if((f+1|0)==(g|0)){if(((a[b+73|0]|0)+ -3|0)>>>0<3){m=-1;n=m;i=k;return n|0}b:do{switch(d[f]|0){case 60:case 0:{break};case 239:case 255:case 254:{if((a[b+73|0]|0)!=0){break b}if((e|0)==1){break a}break};default:{break a}}}while(0);m=-1;n=m;i=k;return n|0}else{o=d[f]<<8|d[f+1|0];if((o|0)==65279){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+16>>2];m=14;n=m;i=k;return n|0}else if((o|0)==15360){if((a[b+73|0]|0)==4){p=16}else{if((a[b+73|0]|0)==3){p=16}}if((p|0)==16){if((e|0)==1){break}}c[j>>2]=c[l+20>>2];m=xe[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else if((o|0)==65534){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+20>>2];m=14;n=m;i=k;return n|0}else if((o|0)==61371){if((e|0)==1){o=a[b+73|0]|0;if((o|0)==0|(o|0)==4|(o|0)==5|(o|0)==3){break}}if((f+2|0)==(g|0)){m=-1;n=m;i=k;return n|0}if((d[f+2|0]|0)!=191){break}c[h>>2]=f+3;c[j>>2]=c[l+8>>2];m=14;n=m;i=k;return n|0}else{if((a[f]|0)==0){if((e|0)==1){if((a[b+73|0]|0)==5){break}}c[j>>2]=c[l+16>>2];m=xe[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f+1|0]|0)!=0){break}if((e|0)==1){break}c[j>>2]=c[l+20>>2];m=xe[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}}}}while(0);c[j>>2]=c[l+(a[b+73|0]<<2)>>2];m=xe[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}function Dm(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+80|0;k=a;a=b;b=d;d=e;e=f;f=g;g=h;if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}if((Fm(Em(k,a,b)|0)|0)==0){c[g>>2]=a;l=0;m=l;i=j;return m|0}do{a=a+(c[k+68>>2]|0)|0;}while((Fm(Em(k,a,b)|0)|0)!=0);if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}c[d>>2]=a;while(1){n=Em(k,a,b)|0;if((n|0)==-1){o=10;break}if((n|0)==61){o=12;break}if((Fm(n)|0)!=0){o=14;break}a=a+(c[k+68>>2]|0)|0}do{if((o|0)==10){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==12){c[e>>2]=a}else if((o|0)==14){c[e>>2]=a;do{a=a+(c[k+68>>2]|0)|0;h=Em(k,a,b)|0;n=h;}while((Fm(h)|0)!=0);if((n|0)==61){break}c[g>>2]=a;l=0;m=l;i=j;return m|0}}while(0);if((a|0)==(c[d>>2]|0)){c[g>>2]=a;l=0;m=l;i=j;return m|0}a=a+(c[k+68>>2]|0)|0;n=Em(k,a,b)|0;while(1){if((Fm(n)|0)==0){break}a=a+(c[k+68>>2]|0)|0;n=Em(k,a,b)|0}if((n|0)!=34&(n|0)!=39){c[g>>2]=a;l=0;m=l;i=j;return m|0}d=n&255;a=a+(c[k+68>>2]|0)|0;c[f>>2]=a;a:while(1){n=Em(k,a,b)|0;if((n|0)==(d<<24>>24|0)){o=33;break}do{if(!(97<=(n|0)&(n|0)<=122)){if(65<=(n|0)&(n|0)<=90){break}if((48<=(n|0)&(n|0)<=57^1)&(n|0)!=46&(n|0)!=45&(n|0)!=95){o=31;break a}}}while(0);a=a+(c[k+68>>2]|0)|0}if((o|0)==31){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==33){c[g>>2]=a+(c[k+68>>2]|0);l=1;m=l;i=j;return m|0}return 0}function Em(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f+40|0;k=b;c[g>>2]=d;c[j>>2]=h;Vd[c[k+60>>2]&31](k,g,e,j,(c[j>>2]|0)+1|0);if((c[j>>2]|0)==(h|0)){l=-1;m=l;i=f;return m|0}else{l=a[h]|0;m=l;i=f;return m|0}return 0}function Fm(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=a;if((c|0)==9|(c|0)==10|(c|0)==13|(c|0)==32){d=1}else{d=0}i=b;return d|0}function Gm(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d>>2]=13;c[d+16>>2]=1;c[d+12>>2]=0;c[d+20>>2]=0;i=b;return}function Hm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 14:{j=0;break};case 29:{c[h>>2]=16;j=2;break};case 11:{c[h>>2]=14;j=55;break};case 15:{c[h>>2]=14;j=0;break};case 12:{c[h>>2]=14;j=1;break};case 16:{if((xe[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,19504)|0)==0){k=10;break a}c[h>>2]=15;j=3;break};case 13:{c[h>>2]=14;j=56;break};default:{k=10}}}while(0);if((k|0)==10){j=Lm(h,a)|0}i=g;return j|0}function Im(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;a:do{switch(a|0){case 33:{c[h>>2]=17;j=0;break};case-4:{if((c[h+12>>2]|0)!=0){k=9;break a}j=0;break};case 26:{k=9;break};case 15:{j=0;break};case 34:{if((c[h+12>>2]|0)==0){k=9;break a}b=h+12|0;c[b>>2]=(c[b>>2]|0)-1;j=0;break};default:{j=Km(h,a,d,e,f)|0}}}while(0);if((k|0)==9){j=Lm(h,a)|0}i=g;return j|0}function Jm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=0;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((xe[c[e+28>>2]&63](e,b,d,19488)|0)!=0){c[h>>2]=18;j=0;k=j;i=g;return k|0}if((xe[c[e+28>>2]&63](e,b,d,19496)|0)==0){break}c[h>>2]=19;j=0;k=j;i=g;return k|0}}while(0);j=Lm(h,a)|0;k=j;i=g;return k|0}function Km(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;a:do{switch(a|0){case 11:{j=55;k=j;i=g;return k|0};case 15:{j=0;k=j;i=g;return k|0};case-4:{j=0;k=j;i=g;return k|0};case 16:{if((xe[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,19264)|0)!=0){c[h>>2]=20;j=11;k=j;i=g;return k|0}if((xe[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,19272)|0)!=0){c[h>>2]=21;j=33;k=j;i=g;return k|0}if((xe[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,19280)|0)!=0){c[h>>2]=22;j=39;k=j;i=g;return k|0}if((xe[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,19288)|0)==0){break a}c[h>>2]=23;j=17;k=j;i=g;return k|0};case 28:{j=60;k=j;i=g;return k|0};case 26:{c[h>>2]=24;j=3;k=j;i=g;return k|0};case 13:{j=56;k=j;i=g;return k|0};default:{}}}while(0);j=Lm(h,a)|0;k=j;i=g;return k|0}function Lm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=a;do{if((c[e+16>>2]|0)==0){if((b|0)!=28){break}f=59;g=f;i=d;return g|0}}while(0);c[e>>2]=16;f=-1;g=f;i=d;return g|0}function Mm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;i=e;return 0}function Nm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==22){c[e>>2]=25;g=11}else if((b|0)==18){c[e>>2]=26;g=9}else{g=Lm(e,a)|0}i=f;return g|0}function Om(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=27;g=34}else{g=Lm(e,a)|0}i=f;return g|0}function Pm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=28;g=40}else if((b|0)==15){g=39}else{g=Lm(e,a)|0}i=f;return g|0}function Qm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==18){c[e>>2]=29;g=18}else{g=Lm(e,a)|0}i=f;return g|0}function Rm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==15){g=3}else{g=Lm(e,a)|0}i=f;return g|0}function Sm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==29){c[e>>2]=16;g=2}else if((b|0)==11){g=55}else if((b|0)==13){g=56}else if((b|0)==15){g=0}else{g=Lm(e,a)|0}i=f;return g|0}function Tm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=17;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((xe[c[e+28>>2]&63](e,b,d,19304)|0)!=0){c[h>>2]=31;j=17;k=j;i=g;return k|0}if((xe[c[e+28>>2]&63](e,b,d,19312)|0)==0){break}c[h>>2]=32;j=17;k=j;i=g;return k|0}}while(0);j=Lm(h,a)|0;k=j;i=g;return k|0}function Um(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==15){g=17}else{g=Lm(e,a)|0}i=f;return g|0}function Vm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=34;g=21}else{g=Lm(e,a)|0}i=f;return g|0}function Wm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=20}else if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else{g=Lm(e,a)|0}i=f;return g|0}function Xm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=c[e+8>>2]|0;h=g;i=f;return h|0}else if((b|0)==15){g=c[e+8>>2]|0;h=g;i=f;return h|0}else{g=Lm(e,a)|0;h=g;i=f;return h|0}return 0}function Ym(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=39;k=j;i=g;return k|0}else if((f|0)==18){if((xe[c[e+28>>2]&63](e,b,d,19320)|0)!=0){c[h>>2]=33;c[h+8>>2]=39;j=42;k=j;i=g;return k|0}if((xe[c[e+28>>2]&63](e,b,d,19328)|0)==0){break}c[h>>2]=33;c[h+8>>2]=39;j=41;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=37;c[h+4>>2]=1;j=44;k=j;i=g;return k|0}}while(0);j=Lm(h,a)|0;k=j;i=g;return k|0}function Zm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 20:{if((xe[c[b+28>>2]&63](b,d+(c[b+68>>2]|0)|0,e,19336)|0)==0){j=10;break a}c[h>>2]=38;k=43;break};case 31:{c[h>>2]=40;k=52;break};case 23:{c[h+4>>2]=2;c[h>>2]=39;k=44;break};case 15:{k=39;break};case 30:{c[h>>2]=40;k=53;break};case 41:case 18:{c[h>>2]=40;k=51;break};case 32:{c[h>>2]=40;k=54;break};default:{j=10}}}while(0);if((j|0)==10){k=Lm(h,a)|0}i=g;return k|0}function _m(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==24){c[e>>2]=33;c[e+8>>2]=39;g=45}else if((b|0)==15){g=39}else{g=Lm(e,a)|0}i=f;return g|0}function $m(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 32:{c[e>>2]=40;g=54;break};case 30:{c[e>>2]=40;g=53;break};case 23:{b=e+4|0;c[b>>2]=(c[b>>2]|0)+1;g=44;break};case 31:{c[e>>2]=40;g=52;break};case 15:{g=39;break};case 41:case 18:{c[e>>2]=40;g=51;break};default:{g=Lm(e,a)|0}}i=f;return g|0}function an(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 37:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=48;h=g;i=f;return h|0};case 36:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=46;h=g;i=f;return h|0};case 24:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=45;h=g;i=f;return h|0};case 15:{g=39;h=g;i=f;return h|0};case 21:{c[e>>2]=39;g=49;h=g;i=f;return h|0};case 35:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=47;h=g;i=f;return h|0};case 38:{c[e>>2]=39;g=50;h=g;i=f;return h|0};default:{g=Lm(e,a)|0;h=g;i=f;return h|0}}return 0}function bn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=42;g=51}else if((b|0)==15){g=39}else{g=Lm(e,a)|0}i=f;return g|0}function cn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==15){g=39}else if((b|0)==21){c[e>>2]=41;g=39}else{g=Lm(e,a)|0}i=f;return g|0}function dn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=43;g=22}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=33}else{g=Lm(e,a)|0}i=f;return g|0}function en(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+56|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){j=0;while(1){k=c[e+28>>2]|0;l=e;m=b;n=d;if((j|0)>=8){break}if((xe[k&63](l,m,n,c[19344+(j<<2)>>2]|0)|0)!=0){o=6;break}j=j+1|0}if((o|0)==6){c[h>>2]=44;p=23+j|0;q=p;i=g;return q|0}if((xe[k&63](l,m,n,19288)|0)==0){break}c[h>>2]=45;p=33;q=p;i=g;return q|0}else if((f|0)==15){p=33;q=p;i=g;return q|0}else if((f|0)==23){c[h>>2]=46;p=33;q=p;i=g;return q|0}}while(0);p=Lm(h,a)|0;q=p;i=g;return q|0}function fn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==27){c[h>>2]=27;j=37;k=j;i=g;return k|0}else if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==20){if((xe[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,19448)|0)!=0){c[h>>2]=27;j=35;k=j;i=g;return k|0}if((xe[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,19456)|0)!=0){c[h>>2]=27;j=36;k=j;i=g;return k|0}if((xe[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,19472)|0)==0){break}c[h>>2]=47;j=33;k=j;i=g;return k|0}}while(0);j=Lm(h,a)|0;k=j;i=g;return k|0}function gn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==23){c[e>>2]=48;g=33}else if((b|0)==15){g=33}else{g=Lm(e,a)|0}i=f;return g|0}function hn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18|(b|0)==19){c[e>>2]=49;g=31}else if((b|0)==15){g=33}else{g=Lm(e,a)|0}i=f;return g|0}function jn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=46;g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==15){g=33}else{g=Lm(e,a)|0}i=f;return g|0}function kn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==18){c[e>>2]=50;g=32}else{g=Lm(e,a)|0}i=f;return g|0}function ln(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==21){c[e>>2]=48;g=33}else{g=Lm(e,a)|0}i=f;return g|0}function mn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=27;g=38}else if((b|0)==15){g=33}else{g=Lm(e,a)|0}i=f;return g|0}function nn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=51;g=10}else{g=Lm(e,a)|0}i=f;return g|0}function on(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((xe[c[e+28>>2]&63](e,b,d,19304)|0)!=0){c[h>>2]=52;j=11;k=j;i=g;return k|0}if((xe[c[e+28>>2]&63](e,b,d,19312)|0)==0){break}c[h>>2]=53;j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}}while(0);j=Lm(h,a)|0;k=j;i=g;return k|0}function pn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=54;g=13}else if((b|0)==15){g=11}else{g=Lm(e,a)|0}i=f;return g|0}function qn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=52;g=14}else if((b|0)==15){g=11}else{g=Lm(e,a)|0}i=f;return g|0}function rn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==17){c[h>>2]=(c[h+16>>2]|0)!=0?35:36;j=15;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((xe[c[e+28>>2]&63](e,b,d,19480)|0)==0){break}c[h>>2]=55;j=11;k=j;i=g;return k|0}}while(0);j=Lm(h,a)|0;k=j;i=g;return k|0}function sn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=33;c[e+8>>2]=11;g=16}else{g=Lm(e,a)|0}i=f;return g|0}function tn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((xe[c[e+28>>2]&63](e,b,d,19304)|0)!=0){c[h>>2]=56;j=11;k=j;i=g;return k|0}if((xe[c[e+28>>2]&63](e,b,d,19312)|0)==0){break}c[h>>2]=57;j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=Lm(h,a)|0;k=j;i=g;return k|0}function un(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=58;g=13}else if((b|0)==15){g=11}else{g=Lm(e,a)|0}i=f;return g|0}function vn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=56;g=14}else{g=Lm(e,a)|0}i=f;return g|0}function wn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=15;h=g;i=f;return h|0}else if((b|0)==15){g=11;h=g;i=f;return h|0}else{g=Lm(e,a)|0;h=g;i=f;return h|0}return 0}function xn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0;h=g;i=f;return h|0}else if((b|0)==25){c[e>>2]=36;b=e+12|0;c[b>>2]=(c[b>>2]|0)+1;g=0;h=g;i=f;return h|0}else{g=Lm(e,a)|0;h=g;i=f;return h|0}return 0}function yn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0}else if((b|0)==25){c[e>>2]=36;g=58}else{g=Lm(e,a)|0}i=f;return g|0}function zn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 14:{j=0;break};case 11:{j=55;break};case 13:{j=56;break};case 15:{j=0;break};case 29:{c[h>>2]=16;j=2;break};case 16:{if((xe[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,19504)|0)==0){k=9;break a}c[h>>2]=15;j=3;break};default:{k=9}}}while(0);if((k|0)==9){j=Lm(h,a)|0}i=g;return j|0}function An(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==41|(b|0)==18){c[e>>2]=59;g=4}else{g=Lm(e,a)|0}i=f;return g|0}function Bn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==17){c[h>>2]=30;j=8;k=j;i=g;return k|0}else if((f|0)==25){c[h>>2]=35;j=7;k=j;i=g;return k|0}else if((f|0)==18){if((xe[c[e+28>>2]&63](e,b,d,19304)|0)!=0){c[h>>2]=60;j=3;k=j;i=g;return k|0}if((xe[c[e+28>>2]&63](e,b,d,19312)|0)==0){break}c[h>>2]=61;j=3;k=j;i=g;return k|0}else if((f|0)==15){j=3;k=j;i=g;return k|0}}while(0);j=Lm(h,a)|0;k=j;i=g;return k|0}function Cn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==27){c[e>>2]=62;g=5}else{g=Lm(e,a)|0}i=f;return g|0}function Dn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==27){c[e>>2]=60;g=6}else{g=Lm(e,a)|0}i=f;return g|0}function En(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==25){c[e>>2]=35;g=7}else if((b|0)==15){g=3}else{g=Lm(e,a)|0}i=f;return g|0}function Fn(){i=i;return}function Gn(){i=i;return}function Hn(){var a=0;a=i;Va(19512,0)|0;i=a;return}function In(){var a=0,b=0,d=0;a=i;b=21232|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=21344|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=21456|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));c[21236>>2]=1;c[21240>>2]=1;i=a;return}function Jn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+24|0;e=d;f=c[b+4>>2]|0;g=c[b+8>>2]|0;h=c[b+12>>2]|0;j=c[b+16>>2]|0;k=(c[b+20>>2]|0)!=0?21592:21608;c[e>>2]=c[b>>2];c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=h;c[e+16>>2]=j;c[e+20>>2]=k;od(a|0,21568,e|0)|0;i=d;return}function Kn(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=21456+(d<<2)|0;o=21344+(d<<2)|0;p=21656+(b<<2)|0;q=19936+(d<<2)|0;r=e;e=f;f=(g|0)!=0;a:while(1){b:do{if(f){c[l>>2]=21640;fc(21624,l|0)|0;s=21640}else{if((c[5304]|0)==(d|0)){if((c[o>>2]|0)>0){t=21640}else{u=5}}else{u=5}if((u|0)==5){u=0;t=c[q>>2]|0}c[m>>2]=t;fc(21624,m|0)|0;do{if((c[5304]|0)==(d|0)){if((c[n>>2]|0)!=(b|0)){break}if((c[o>>2]|0)>0){s=21640;break b}}}while(0);s=c[p>>2]|0}}while(0);c[k>>2]=s;fc(21648,k|0)|0;c[n>>2]=b;c[5304]=d;if((c[o>>2]|0)>0){g=0;while(1){fc(21680,j|0)|0;v=g+1|0;if((v|0)<(c[o>>2]|0)){g=v}else{w=0;break}}}else{w=0}while(1){x=e+w|0;g=a[x]|0;if(g<<24>>24==10){break}else if(g<<24>>24==0){break a}w=w+1|0}a[x]=0;sb(e|0)|0;r=0;e=e+(w+1)|0;f=1}sb(e|0)|0;md(0)|0;if((r|0)==0){i=h;return}c[o>>2]=(c[o>>2]|0)+1;i=h;return}function Ln(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;h=f;j=i;i=i+8|0;k=c[21656+(a<<2)>>2]|0;c[j>>2]=c[19936+(b<<2)>>2];c[j+4>>2]=k;fc(21688,j|0)|0;Mn(e);if((g|0)==0){Bd(((d|0)!=0?21728:21776)|0,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=md(m|0)|0;i=f;return}sb(21856)|0;if((c[g>>2]|0)>=1){e=1;while(1){c[h>>2]=c[g+(e<<2)>>2];fc(21736,h|0)|0;if((e|0)<(c[g>>2]|0)){e=e+1|0}else{break}}}if((d|0)!=0){l=t;m=c[t>>2]|0;n=md(m|0)|0;i=f;return}pc(21760,11,1,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=md(m|0)|0;i=f;return}function Mn(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[t>>2]|0;f=b;while(1){b=a[f]|0;if(b<<24>>24==60){pc(21808,4,1,e|0)|0}else if(b<<24>>24==0){break}else if(b<<24>>24==62){pc(21816,4,1,e|0)|0}else if(b<<24>>24==38){pc(21800,5,1,e|0)|0}else{Jd(b<<24>>24|0,e|0)|0}f=f+1|0}i=d;return}function Nn(a){a=a|0;var b=0;b=21344+(a<<2)|0;c[b>>2]=(c[b>>2]|0)+ -1;i=i;return}function On(a){a=a|0;var b=0;b=(a|0)==0;c[5448]=b?1:19;c[5446]=b?7:149;i=i;return}function Pn(a){a=a|0;var b=0;a=i;b=c[t>>2]|0;pc(21760,11,1,b|0)|0;md(b|0)|0;i=a;return}function Qn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+2064|0;h=g+2048|0;if((c[21232+(a<<2)>>2]|0)==0){i=g;return}j=g;c[h>>2]=f;lc(j|0,2048,e|0,h|0)|0;he[c[5448]&31](1,a,b,j,0,d);i=g;return}function Rn(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((c[21232+(a<<2)>>2]|0)==0){i=f;return}h=f;c[g>>2]=e;lc(h|0,2048,d|0,g|0)|0;he[c[5448]&31](1,a,b,h,0,0);i=f;return}function Sn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+2064|0;h=g;j=g+2048|0;do{if((c[5306]|0)==0){if((c[21232+(a<<2)>>2]|0)!=0){break}i=g;return}}while(0);k=h;c[j>>2]=f;lc(k|0,2048,e|0,j|0)|0;he[c[5448]&31](2,a,b,k,0,d);i=g;return}function Tn(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f;h=f+2048|0;do{if((c[5306]|0)==0){if((c[21232+(a<<2)>>2]|0)!=0){break}i=f;return}}while(0);j=g;c[h>>2]=e;lc(j|0,2048,d|0,h|0)|0;he[c[5448]&31](2,a,b,j,0,0);i=f;return}function Un(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((b|0)!=0){i=f;return}b=f;c[g>>2]=e;lc(b|0,2048,d|0,g|0)|0;he[c[5448]&31](4,2,0,b,0,0);if((a|0)==0){h=gd(c[4878]|0)|0}else{h=a}db(c[h+76>>2]|0,1)}function Vn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+2064|0;f=e+2048|0;g=e;c[f>>2]=d;lc(g|0,2048,b|0,f|0)|0;he[c[5448]&31](5,2,0,g,0,0);if((a|0)==0){h=gd(c[4878]|0)|0}else{h=a}db(c[h+76>>2]|0,1)}function Wn(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f+2048|0;h=f;c[g>>2]=e;lc(h|0,2048,d|0,g|0)|0;he[c[5448]&31](5,2,0,h,0,b);if((a|0)==0){j=gd(c[4878]|0)|0}else{j=a}db(c[j+76>>2]|0,1)}function Xn(a,b,d,e,f,g){a=a|0;b=+b;d=d|0;e=e|0;f=+f;g=g|0;var j=0,l=0,m=0;j=i;i=i+16|0;l=j;m=i;i=i+16|0;if(g<<24>>24==0){g=l;h[k>>3]=f;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[l+8>>2]=d;Wn(a,e,21928,l)}else{l=m;h[k>>3]=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[m+8>>2]=d;Sn(26,0,e,21864,m);i=j;return+b}return 0.0}function Yn(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=aS(16)|0;Un(0,(d|0)!=0|0,21976,b);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=a;c[d+12>>2]=0;i=b;return d|0}function Zn(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)!=0){f=e;while(1){e=c[f+4>>2]|0;bS(c[f>>2]|0);bS(f);if((e|0)==0){break}else{f=e}}}c[a+12>>2]=0;c[d>>2]=0;c[a+4>>2]=0;i=b;return}function _n(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;Un(0,(a|0)!=0|0,21992,f);f=aS(8)|0;g=f;Un(0,(f|0)!=0|0,21976,e);e=a+8|0;h=aS(c[e>>2]|0)|0;c[f>>2]=h;Un(0,(h|0)!=0|0,21976,d);GS(c[f>>2]|0,b|0,c[e>>2]|0)|0;e=a;c[f+4>>2]=c[e>>2];f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=g;e=a+4|0;if((c[e>>2]|0)!=0){i=d;return}c[e>>2]=g;i=d;return}function $n(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;Un(0,(a|0)!=0|0,21992,f);f=aS(8)|0;g=f;Un(0,(f|0)!=0|0,21976,e);e=a+8|0;h=aS(c[e>>2]|0)|0;c[f>>2]=h;Un(0,(h|0)!=0|0,21976,d);GS(c[f>>2]|0,b|0,c[e>>2]|0)|0;c[f+4>>2]=0;f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;f=a+4|0;e=c[f>>2]|0;if((e|0)!=0){c[e+4>>2]=g}c[f>>2]=g;f=a;if((c[f>>2]|0)!=0){i=d;return}c[f>>2]=g;i=d;return}function ao(a){a=a|0;var b=0;b=i;i=i+8|0;Un(0,(a|0)!=0|0,21992,b);i=b;return c[a+12>>2]|0}function bo(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;Un(0,(a|0)!=0|0,21992,d);d=a;Un(0,(c[d>>2]|0)!=0|0,22016,b);i=b;return c[c[d>>2]>>2]|0}function co(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=c[e+4>>2]|0;bS(c[e>>2]|0);bS(c[d>>2]|0);c[d>>2]=f;d=a+12|0;c[d>>2]=(c[d>>2]|0)+ -1;if((f|0)!=0){i=b;return}c[a+4>>2]=0;i=b;return}function eo(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;Un(0,(a|0)!=0|0,21992,d);d=a;Un(0,(c[d>>2]|0)!=0|0,22032,b);i=b;return c[d>>2]|0}function fo(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=(a|0)!=0;Un(0,d&1,22064,b);if(!d){e=0;i=b;return e|0}e=c[a+4>>2]|0;i=b;return e|0}function go(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;Un(0,(a|0)!=0|0,22064,d);d=a;Un(0,(c[d>>2]|0)!=0|0,22088,b);i=b;return c[d>>2]|0}function ho(){var a=0,b=0,d=0;a=i;b=aS(16)|0;c[5540]=b;c[b+4>>2]=0;c[b+8>>2]=2097152;d=aS(2097152)|0;c[b>>2]=d;c[b+12>>2]=0;i=a;return}function io(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=ko(a)|0;rc(22168)|0;lo(d);a=c[5540]|0;e=a+4|0;f=c[e>>2]|0;g=(c[a>>2]|0)+f|0;c[e>>2]=f+d;ec(22168)|0;IS(g|0,0,d|0)|0;i=b;return g|0}function jo(){var a=0,b=0,d=0,e=0;a=i;b=c[5540]|0;d=c[b+12>>2]|0;if((d|0)==0){e=b}else{b=d;while(1){d=c[b+12>>2]|0;bS(c[b>>2]|0);bS(b);if((d|0)==0){break}else{b=d}}e=c[5540]|0}c[e+4>>2]=0;c[e+12>>2]=0;i=a;return 0}function ko(a){a=a|0;i=i;return a+7&-8|0}function lo(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[5540]|0;e=d+8|0;if(!(((c[e>>2]|0)-(c[d+4>>2]|0)|0)>>>0<a>>>0)){i=b;return}f=aS(16)|0;c[f+12>>2]=d;c[5540]=f;c[f+4>>2]=0;d=mo((((c[e>>2]|0)*3|0)>>>1)+a|0)|0;c[f+8>>2]=d;a=aS(d)|0;c[f>>2]=a;i=b;return}function mo(a){a=a|0;var b=0;b=a+ -1|0;a=b>>>1|b;b=a>>>2|a;a=b>>>4|b;b=a>>>8|a;i=i;return(b>>>16|b)+1|0}function no(a){a=a|0;var b=0,c=0;b=i;c=ES(a|0)|0;i=b;return c|0}function oo(b,d){b=+b;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;j=i;i=i+400|0;l=g;m=j;a[l]=37;KS(g+1|0,d|0)|0;d=f;h[k>>3]=b;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];gc(m|0,l|0,f|0)|0;f=po(m)|0;i=e;return f|0}function po(a){a=a|0;var b=0,c=0,d=0;b=i;c=ES(a|0)|0;d=qo(c)|0;GS(d|0,a|0,c|0)|0;i=b;return d|0}function qo(b){b=b|0;var d=0,e=0;d=i;e=$d[c[22124>>2]&127](b+1|0)|0;if((e|0)==0){i=d;return e|0}a[e+b|0]=0;i=d;return e|0}function ro(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=i;d=no(a)|0;e=no(b)|0;f=qo(e+d|0)|0;GS(f|0,a|0,d|0)|0;GS(f+d|0,b|0,e|0)|0;i=c;return f|0}function so(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=AS(c[a>>2]|0,c[b>>2]|0)|0;i=d;return e|0}function to(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=(a|0)%100|0;d=(c|0)/10|0;e=(a|0)%10|0;a:do{if((a+999|0)>>>0>1998){f=-1}else{if((((a|0)%1e3|0)+99|0)>>>0>198){f=-1;break}if((e|0)==2){f=-1;break}else if((e|0)==1){if((c+ -50|0)>>>0>9){f=-1;break}}switch(d|0){case 0:{f=8;break a;break};case 5:{f=1;break a;break};case 4:{f=2;break a;break};case 2:{f=4;break a;break};case 3:{f=2;break a;break};case 1:{f=4;break a;break};default:{f=-1;break a}}}}while(0);i=b;return f|0}function uo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a;e=c[d>>2]|0;if((e|0)!=0){Vc(e|0)|0;c[d>>2]=0}e=a+4|0;f=c[e>>2]|0;if((f|0)!=0){bS(f);c[e>>2]=0}e=a+8|0;if((c[e>>2]|0)!=0){f=a+12|0;g=0;do{bS(c[(c[f>>2]|0)+(g<<4)>>2]|0);bS(c[(c[f>>2]|0)+(g<<4)+4>>2]|0);g=g+1|0;}while(g>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;if((c[d>>2]|0)!=0){d=a+12|0;bS(c[d>>2]|0);c[d>>2]=0}d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){bS(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;g=a+40|0;if((e&2147483647|0)!=0){a=e;e=0;while(1){f=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((f|0)==0){h=a}else{bS(f);h=c[d>>2]|0}f=e+1|0;if(f>>>0<h<<1>>>0){a=h;e=f}else{break}}}c[d>>2]=0;d=c[g>>2]|0;if((d|0)==0){i=b;return}bS(d);c[g>>2]=0;i=b;return}function vo(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=i;d=0;e=0;while(1){f=a[b+d|0]|0;if(f<<24>>24==32){g=e}else{a[b+e|0]=f;g=e+1|0}f=d+1|0;if(f>>>0>(ES(b|0)|0)>>>0){break}else{d=f;e=g}}i=c;return}



function pF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+1024|0;c[h>>2]=a;k=h+4|0;c[k>>2]=1;l=h+8|0;c[l>>2]=0;m=h+12|0;c[m>>2]=0;n=a+4|0;do{if((c[n>>2]|0)==0){o=a;p=hc(c[o>>2]|0,75976)|0;if((p|0)!=0){q=p;break}p=Nd(c[(Lc()|0)>>2]|0)|0;c[g>>2]=c[o>>2];c[g+4>>2]=p;Vn(0,75984,g)}else{q=0}}while(0);g=Ri(0)|0;if((g|0)==0){Vn(0,76016,f)}f=a+8|0;c[a+20>>2]=cS(c[f>>2]|0,32)|0;p=a+12|0;o=cS((c[p>>2]|0)+1|0,20)|0;c[a+24>>2]=o;c[o>>2]=0;c[o+4>>2]=-1;c[o+8>>2]=76048;c[o+12>>2]=0;c[o+16>>2]=0;aj(g,h);bj(g,8,61);h=c[n>>2]|0;do{if((h|0)==0){o=j;IS(o|0,0,1024)|0;while(1){r=rb(o|0,1,1024,q|0)|0;s=r>>>0<1024;if((cj(g,o,r,s&1)|0)==0){t=9;break}if(s){t=11;break}}if((t|0)==9){o=kj(hj(g)|0)|0;s=ij(g)|0;Vc(q|0)|0;Yi(g);r=c[a>>2]|0;c[e>>2]=76152;c[e+4>>2]=r;c[e+8>>2]=o;c[e+12>>2]=s;Vn(0,76088,e)}else if((t|0)==11){Vc(q|0)|0;break}}else{if((cj(g,h,ES(h|0)|0,1)|0)!=0){break}s=kj(hj(g)|0)|0;o=ij(g)|0;Yi(g);r=c[n>>2]|0;c[d>>2]=76152;c[d+4>>2]=r;c[d+8>>2]=s;c[d+12>>2]=o;Vn(0,76192,d)}}while(0);if((c[p>>2]|0)!=(c[k>>2]|0)){bb(76256,76152,295,76296)}c[a+16>>2]=c[l>>2];if((c[f>>2]|0)==(c[m>>2]|0)){i=b;return}else{bb(76320,76152,297,76296)}}function qF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=c[a>>2]|0;n=c[a+4>>2]|0;o=c[a+12>>2]|0;if((AS(76728,b)|0)==0){if((AS(c[d>>2]|0,76736)|0)==0){p=(c[d+8>>2]|0)==0|0}else{p=0}Un(0,p,76744,l);l=c[19146]|0;p=c[19200]|0;do{if((l|0)==0|(p|0)==0){c[19200]=32;a=aS(1152)|0;c[19146]=a;q=m+24|0;r=a}else{a=m+24|0;s=a;if(((c[(c[a>>2]|0)+(n*20|0)+12>>2]|0)+2|0)<(p|0)){q=s;r=l;break}c[19200]=p<<1;a=dS(l,p*72|0)|0;c[19146]=a;q=s;r=a}}while(0);p=(c[q>>2]|0)+(n*20|0)+12|0;q=c[p>>2]|0;c[p>>2]=q+1;p=r+(q*36|0)+0|0;q=(wF(c[d+4>>2]|0)|0)+0|0;r=p+36|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=e;return}if((AS(76808,b)|0)==0){q=c[d>>2]|0;if((q|0)==0){i=e;return}else{t=d;u=q}a:while(1){do{if((AS(76816,u)|0)==0){c[19206]=rd(c[t+4>>2]|0)|0}else{if((AS(76848,u)|0)==0){c[76828>>2]=Tb(c[t+4>>2]|0,0,10)|0;break}if((AS(76864,u)|0)==0){c[76836>>2]=Tb(c[t+4>>2]|0,0,10)|0;break}if((AS(76872,u)|0)==0){c[76832>>2]=Tb(c[t+4>>2]|0,0,10)|0;break}if((AS(76888,u)|0)==0){c[76840>>2]=Tb(c[t+4>>2]|0,0,10)|0;break}if((AS(76896,u)|0)!=0){v=23;break a}c[76844>>2]=(AS(c[t+4>>2]|0,76912)|0)==0}}while(0);q=t+8|0;p=c[q>>2]|0;if((p|0)==0){v=45;break}else{t=q;u=p}}if((v|0)==23){c[k>>2]=c[m>>2];Vn(0,76920,k)}else if((v|0)==45){i=e;return}}if((AS(76568,b)|0)==0){v=c[m+12>>2]|0;if((n|0)>(v|0)){k=c[m>>2]|0;c[j>>2]=76152;c[j+4>>2]=k;c[j+8>>2]=v;Vn(0,76952,j)}if((AS(77016,c[d>>2]|0)|0)!=0){j=c[m>>2]|0;c[h>>2]=76152;c[h+4>>2]=j;Vn(0,77024,h)}h=Tb(c[d+4>>2]|0,0,10)|0;if((n|0)!=(h|0)){j=c[m>>2]|0;c[g>>2]=76152;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=n;Vn(0,77080,g)}g=m+24|0;h=c[g>>2]|0;c[h+(n*20|0)>>2]=n;c[h+(n*20|0)+4>>2]=-1;c[h+(n*20|0)+8>>2]=77144;h=c[g>>2]|0;c[h+(n*20|0)+12>>2]=0;c[h+(n*20|0)+16>>2]=0;i=e;return}if((AS(76512,b)|0)!=0){if((AS(76704,b)|0)!=0){i=e;return}b=m+20|0;m=c[b>>2]|0;c[m+(o<<5)>>2]=o;c[m+(o<<5)+4>>2]=77248;m=rd(c[d+4>>2]|0)|0;c[(c[b>>2]|0)+(o<<5)+4>>2]=m;c[(c[b>>2]|0)+(o<<5)+8>>2]=77256;i=e;return}c[76532>>2]=0;c[76536>>2]=0;o=c[d>>2]|0;do{if((o|0)==0){w=0}else{b=d;m=o;do{do{if((AS(m,76736)|0)==0){c[76532>>2]=rd(c[b+4>>2]|0)|0}else{if((AS(m,77200)|0)!=0){break}c[76536>>2]=rd(c[b+4>>2]|0)|0}}while(0);b=b+8|0;m=c[b>>2]|0;}while((m|0)!=0);if((c[76532>>2]|0)==0){w=0;break}w=(c[76536>>2]|0)!=0|0}}while(0);Un(0,w,77208,f);c[19132]=-1;f=76540|0;w=76824;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[f+20>>2]=c[w+20>>2];i=e;return}function rF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d;f=d+40|0;g=i;i=i+8|0;h=c[a>>2]|0;j=a+4|0;k=c[j>>2]|0;l=a+8|0;m=c[l>>2]|0;n=a+12|0;a=c[n>>2]|0;if((AS(76512,b)|0)==0){o=e+0|0;p=76528|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));vF(e);i=d;return}if((AS(76568,b)|0)==0){e=h+24|0;r=aS((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)*36|0)|0;c[(c[e>>2]|0)+(k*20|0)+16>>2]=r;if((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)>0){r=0;do{s=aS(36)|0;t=s;o=s+0|0;p=(c[19146]|0)+(r*36|0)+0|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));c[(c[(c[e>>2]|0)+(k*20|0)+16>>2]|0)+(r<<2)>>2]=t;r=r+1|0;}while((r|0)<(c[(c[e>>2]|0)+(k*20|0)+12>>2]|0))}c[j>>2]=k+1;i=d;return}if((AS(76592,b)|0)==0){j=h+24|0;e=c[j>>2]|0;r=c[e+(k*20|0)+12>>2]|0;c[g>>2]=k;c[g+4>>2]=r;sd(e+(k*20|0)+8|0,76600,g|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((AS(76640,b)|0)==0){j=h+24|0;h=c[j>>2]|0;g=c[h+(k*20|0)+12>>2]|0;c[f>>2]=k;c[f+4>>2]=g;sd(h+(k*20|0)+8|0,76656,f|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((AS(76704,b)|0)!=0){i=d;return}c[n>>2]=a+1;i=d;return}function sF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==0){pF(b);h=c[f>>2]|0}else{h=g}g=a;a=h+(d*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}function tF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=b+24|0;if((c[h>>2]|0)==0){pF(b)}j=c[b+16>>2]|0;if(j>>>0<d>>>0){c[g>>2]=d;c[g+4>>2]=j;Vn(0,76360,g)}g=c[b+12>>2]|0;if((g|0)<=0){k=f;l=k;c[l>>2]=d;m=4;n=m;o=76440;p=o;Vn(0,p,f)}b=c[h>>2]|0;h=0;while(1){j=h+1|0;if((c[b+(h*20|0)+4>>2]|0)==(d|0)){q=9;break}if((j|0)<(g|0)){h=j}else{q=10;break}}if((q|0)==9){g=a;a=b+(h*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}else if((q|0)==10){k=f;l=k;c[l>>2]=d;m=4;n=m;o=76440;p=o;Vn(0,p,f)}}function uF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){bS(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=a+12|0;if((c[f>>2]|0)>0){a=e;g=0;while(1){bS(c[a+(g*20|0)+16>>2]|0);c[(c[d>>2]|0)+(g*20|0)+16>>2]=0;h=g+1|0;j=c[d>>2]|0;if((h|0)<(c[f>>2]|0)){g=h;a=j}else{k=j;break}}}else{k=e}bS(k);c[d>>2]=0;i=b;return}function vF(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;b=i;e=aS(72)|0;f=c[a+4>>2]|0;c[e>>2]=f;g=e+4|0;h=a+0|0;a=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(a|0));h=e+40|0;j=h;c[e+48>>2]=0;c[e+60>>2]=f;k=ES(f|0)|0;c[e+64>>2]=k;k=c[19180]|0;do{if((k|0)==0){c[19180]=e;c[e+44>>2]=0;l=aS(44)|0;m=l;c[e+40>>2]=m;if((l|0)==0){tc(-1)}g=l+0|0;a=g+44|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(a|0));c[l+16>>2]=e+40;c[l+4>>2]=32;c[l+8>>2]=5;c[l+20>>2]=40;n=aS(384)|0;c[l>>2]=n;if((n|0)==0){tc(-1)}else{IS(n|0,0,384)|0;c[l+40>>2]=-1609490463;o=f;p=m;break}}else{c[(c[(c[k+40>>2]|0)+16>>2]|0)+8>>2]=e;n=(c[19180]|0)+40|0;q=c[n>>2]|0;c[e+44>>2]=(c[q+16>>2]|0)+(0-(c[q+20>>2]|0));c[(c[n>>2]|0)+16>>2]=j;o=c[e>>2]|0;p=c[(c[19180]|0)+40>>2]|0}}while(0);k=p+12|0;c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=p;p=e+68|0;c[p>>2]=-17973521;k=ES(o|0)|0;if(k>>>0>11){f=-17973521;g=-1640531527;a=-1640531527;n=k;q=o;do{r=((d[q+5|0]|0)<<8|(d[q+4|0]|0)|(d[q+6|0]|0)<<16|(d[q+7|0]|0)<<24)+a|0;s=((d[q+9|0]|0)<<8|(d[q+8|0]|0)|(d[q+10|0]|0)<<16|(d[q+11|0]|0)<<24)+f|0;t=((d[q+1|0]|0)<<8|(d[q]|0)|(d[q+2|0]|0)<<16|(d[q+3|0]|0)<<24)+g-r-s^s>>>13;u=r-s-t^t<<8;r=s-t-u^u>>>13;s=t-u-r^r>>>12;t=u-r-s^s<<16;u=r-s-t^t>>>5;g=s-t-u^u>>>3;a=t-u-g^g<<10;f=u-g-a^a>>>15;c[p>>2]=f;q=q+12|0;n=n+ -12|0;}while(n>>>0>11);v=f;w=c[e>>2]|0;x=g;y=a;z=n;A=q}else{v=-17973521;w=o;x=-1640531527;y=-1640531527;z=k;A=o}o=v+(ES(w|0)|0)|0;c[p>>2]=o;switch(z|0){case 1:{B=o;C=x;D=y;E=22;break};case 8:{F=o;E=15;break};case 10:{G=o;E=13;break};case 2:{H=o;I=x;J=y;E=21;break};case 6:{K=o;L=y;E=17;break};case 3:{M=o;N=x;O=y;E=20;break};case 5:{P=o;Q=y;E=18;break};case 9:{R=o;E=14;break};case 4:{S=o;T=y;E=19;break};case 11:{z=((d[A+10|0]|0)<<24)+o|0;c[p>>2]=z;G=z;E=13;break};case 7:{U=o;V=y;E=16;break};default:{W=o;X=x;Y=y}}if((E|0)==13){o=((d[A+9|0]|0)<<16)+G|0;c[p>>2]=o;R=o;E=14}if((E|0)==14){o=((d[A+8|0]|0)<<8)+R|0;c[p>>2]=o;F=o;E=15}if((E|0)==15){U=F;V=((d[A+7|0]|0)<<24)+y|0;E=16}if((E|0)==16){K=U;L=((d[A+6|0]|0)<<16)+V|0;E=17}if((E|0)==17){P=K;Q=((d[A+5|0]|0)<<8)+L|0;E=18}if((E|0)==18){S=P;T=(d[A+4|0]|0)+Q|0;E=19}if((E|0)==19){M=S;N=((d[A+3|0]|0)<<24)+x|0;O=T;E=20}if((E|0)==20){H=M;I=((d[A+2|0]|0)<<16)+N|0;J=O;E=21}if((E|0)==21){B=H;C=((d[A+1|0]|0)<<8)+I|0;D=J;E=22}if((E|0)==22){W=B;X=(d[A]|0)+C|0;Y=D}D=X-Y-W^W>>>13;X=Y-W-D^D<<8;Y=W-D-X^X>>>13;W=D-X-Y^Y>>>12;D=X-Y-W^W<<16;X=Y-W-D^D>>>5;Y=W-D-X^X>>>3;W=D-X-Y^Y<<10;D=X-Y-W^W>>>15;c[p>>2]=D;p=(c[19180]|0)+40|0;W=c[p>>2]|0;Y=D&(c[W+4>>2]|0)+ -1;D=c[W>>2]|0;W=D+(Y*12|0)+4|0;c[W>>2]=(c[W>>2]|0)+1;c[e+56>>2]=c[D+(Y*12|0)>>2];c[e+52>>2]=0;e=c[c[p>>2]>>2]|0;p=c[e+(Y*12|0)>>2]|0;if((p|0)==0){Z=e}else{c[p+12>>2]=j;Z=c[c[(c[19180]|0)+40>>2]>>2]|0}c[Z+(Y*12|0)>>2]=j;j=c[c[(c[19180]|0)+40>>2]>>2]|0;if((c[j+(Y*12|0)+4>>2]|0)>>>0<(((c[j+(Y*12|0)+8>>2]|0)*10|0)+10|0)>>>0){i=b;return}Y=c[h>>2]|0;if((c[Y+36>>2]|0)==1){i=b;return}j=Y+4|0;Z=aS((c[j>>2]|0)*24|0)|0;p=Z;if((Z|0)==0){tc(-1)}IS(Z|0,0,(c[j>>2]|0)*24|0)|0;e=c[Y+12>>2]|0;D=c[j>>2]|0;c[Y+24>>2]=(((D<<1)+ -1&e|0)!=0)+(e>>>((c[Y+8>>2]|0)+1|0));c[Y+28>>2]=0;e=c[Y>>2]|0;if((D|0)==0){_=e}else{D=Y;Y=e;e=0;while(1){j=c[Y+(e*12|0)>>2]|0;if((j|0)==0){$=D}else{W=D;X=j;while(1){j=X+16|0;C=c[j>>2]|0;A=(c[W+4>>2]<<1)+ -1&c[X+28>>2];B=Z+(A*12|0)+4|0;E=(c[B>>2]|0)+1|0;c[B>>2]=E;J=c[W+24>>2]|0;if(E>>>0>J>>>0){E=W+28|0;c[E>>2]=(c[E>>2]|0)+1;c[Z+(A*12|0)+8>>2]=((c[B>>2]|0)>>>0)/(J>>>0)|0}c[X+12>>2]=0;J=Z+(A*12|0)|0;c[j>>2]=c[J>>2];j=c[J>>2]|0;if((j|0)!=0){c[j+12>>2]=X}c[J>>2]=X;J=c[h>>2]|0;if((C|0)==0){$=J;break}else{W=J;X=C}}}X=e+1|0;W=c[$>>2]|0;if(X>>>0<(c[$+4>>2]|0)>>>0){D=$;Y=W;e=X}else{_=W;break}}}bS(_);_=c[h>>2]|0;e=_+4|0;c[e>>2]=c[e>>2]<<1;e=_+8|0;c[e>>2]=(c[e>>2]|0)+1;c[_>>2]=p;p=c[h>>2]|0;h=p+32|0;if(!((c[p+28>>2]|0)>>>0>(c[p+12>>2]|0)>>>1>>>0)){c[h>>2]=0;i=b;return}_=(c[h>>2]|0)+1|0;c[h>>2]=_;if(!(_>>>0>1)){i=b;return}c[p+36>>2]=1;i=b;return}function wF(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+8|0;e=b;a:do{if((c[19180]|0)==0){f=24}else{g=ES(a|0)|0;if(g>>>0>11){h=-17973521;j=-1640531527;k=-1640531527;l=g;m=a;while(1){n=((d[m+5|0]|0)<<8|(d[m+4|0]|0)|(d[m+6|0]|0)<<16|(d[m+7|0]|0)<<24)+k|0;o=((d[m+9|0]|0)<<8|(d[m+8|0]|0)|(d[m+10|0]|0)<<16|(d[m+11|0]|0)<<24)+h|0;p=((d[m+1|0]|0)<<8|(d[m]|0)|(d[m+2|0]|0)<<16|(d[m+3|0]|0)<<24)+j-n-o^o>>>13;q=n-o-p^p<<8;n=o-p-q^q>>>13;o=p-q-n^n>>>12;p=q-n-o^o<<16;q=n-o-p^p>>>5;n=o-p-q^q>>>3;o=p-q-n^n<<10;p=q-n-o^o>>>15;q=m+12|0;r=l+ -12|0;if(r>>>0>11){m=q;l=r;k=o;j=n;h=p}else{s=p;t=n;u=o;v=r;w=q;break}}}else{s=-17973521;t=-1640531527;u=-1640531527;v=g;w=a}h=(ES(a|0)|0)+s|0;switch(v|0){case 7:{x=h;y=u;f=9;break};case 6:{z=h;A=u;f=10;break};case 1:{B=h;C=t;D=u;f=15;break};case 11:{E=((d[w+10|0]|0)<<24)+h|0;f=6;break};case 9:{F=h;f=7;break};case 4:{G=h;H=u;f=12;break};case 5:{I=h;J=u;f=11;break};case 3:{K=h;L=t;M=u;f=13;break};case 10:{E=h;f=6;break};case 8:{N=h;f=8;break};case 2:{O=h;P=t;Q=u;f=14;break};default:{R=h;S=t;T=u}}if((f|0)==6){F=((d[w+9|0]|0)<<16)+E|0;f=7}if((f|0)==7){N=((d[w+8|0]|0)<<8)+F|0;f=8}if((f|0)==8){x=N;y=((d[w+7|0]|0)<<24)+u|0;f=9}if((f|0)==9){z=x;A=((d[w+6|0]|0)<<16)+y|0;f=10}if((f|0)==10){I=z;J=((d[w+5|0]|0)<<8)+A|0;f=11}if((f|0)==11){G=I;H=(d[w+4|0]|0)+J|0;f=12}if((f|0)==12){K=G;L=((d[w+3|0]|0)<<24)+t|0;M=H;f=13}if((f|0)==13){O=K;P=((d[w+2|0]|0)<<16)+L|0;Q=M;f=14}if((f|0)==14){B=O;C=((d[w+1|0]|0)<<8)+P|0;D=Q;f=15}if((f|0)==15){R=B;S=(d[w]|0)+C|0;T=D}h=S-R-T^R>>>13;j=T-R-h^h<<8;k=R-h-j^j>>>13;l=h-j-k^k>>>12;h=j-k-l^l<<16;j=k-l-h^h>>>5;k=l-h-j^j>>>3;l=h-j-k^k<<10;h=c[(c[19180]|0)+40>>2]|0;m=c[(c[h>>2]|0)+(((j-k-l^l>>>15)&(c[h+4>>2]|0)+ -1)*12|0)>>2]|0;if((m|0)==0){f=24;break}l=m+(0-(c[h+20>>2]|0))|0;if((l|0)==0){f=24;break}m=ES(a|0)|0;k=l;while(1){U=k;if((c[k+64>>2]|0)==(m|0)){if((zS(c[k+60>>2]|0,a,m)|0)==0){break}}l=c[k+56>>2]|0;if((l|0)==0){f=24;break a}j=l+(0-(c[h+20>>2]|0))|0;if((j|0)==0){f=24;break a}else{k=j}}if((k|0)==0){f=24}else{V=U}}}while(0);do{if((f|0)==24){if((Db(a|0,77280)|0)==0){V=0;break}else{W=77304}i=b;return W|0}}while(0);c[e>>2]=a;Un(0,(V|0)!=0|0,77352,e);W=V+4|0;i=b;return W|0}function xF(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((yF(77408,a,b)|0)!=0){d=1;i=c;return d|0}d=(yF(77416,a,b)|0)!=0|0;i=c;return d|0}function yF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)>0){g=0}else{h=0;i=f;return h|0}while(1){j=c[e+(g<<2)>>2]|0;if((a[j]|0)==45){if((AS(b,j+1|0)|0)==0){h=1;k=5;break}}j=g+1|0;if((j|0)<(d|0)){g=j}else{h=0;k=5;break}}if((k|0)==5){i=f;return h|0}return 0}function zF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=(AS(c[26052>>2]|0,77424)|0)==0|0;Un(0,m,77440,l);l=(AS(c[27956>>2]|0,77424)|0)==0|0;Un(0,l,77496,k);k=(AS(c[29948>>2]|0,77424)|0)==0|0;Un(0,k,77552,j);j=77616|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=77744|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((a|0)>1){n=1}else{o=0;i=d;return o|0}a:while(1){p=b+(n<<2)|0;j=n+1|0;k=1;while(1){l=c[29952+(k<<2)>>2]|0;if((l|0)==1){if((yF(c[25928+(k<<2)>>2]|0,1,p)|0)!=0){q=5;break}}else if((l|0)==2){r=c[25928+(k<<2)>>2]|0;if(!((yF(r,1,p)|0)==0|(j|0)>=(a|0))){q=9;break}s=c[25928+(k<<2)>>2]|0;if((BF(s,p)|0)!=0){q=13;break}}l=k+1|0;if((l|0)<31){k=l}else{q=17;break a}}if((q|0)==5){q=0;l=77616+(k<<2)|0;if((c[l>>2]|0)!=0){q=6;break}c[l>>2]=1;t=n}else if((q|0)==9){q=0;l=77616+(k<<2)|0;if((c[l>>2]|0)!=0){q=10;break}c[l>>2]=1;c[77744+(k<<2)>>2]=AF(r,p)|0;t=j}else if((q|0)==13){q=0;l=77616+(k<<2)|0;if((c[l>>2]|0)!=0){q=14;break}c[l>>2]=1;c[77744+(k<<2)>>2]=CF(s,p)|0;t=n}l=t+1|0;if((l|0)<(a|0)){n=l}else{o=0;q=19;break}}if((q|0)==6){c[h>>2]=c[p>>2];Tn(1,0,77872,h);o=1;i=d;return o|0}else if((q|0)==10){c[g>>2]=c[p>>2];Tn(1,0,77872,g);o=1;i=d;return o|0}else if((q|0)==14){c[f>>2]=c[p>>2];Tn(1,0,77872,f);o=1;i=d;return o|0}else if((q|0)==17){c[e>>2]=c[p>>2];Tn(1,0,77928,e);o=1;i=d;return o|0}else if((q|0)==19){i=d;return o|0}return 0}function AF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;do{if((a[f]|0)==45){if((AS(b,f+1|0)|0)!=0){g=0;break}g=c[d+4>>2]|0}else{g=0}}while(0);i=e;return g|0}function BF(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(CF(a,b)|0)!=0|0;i=c;return d|0}function CF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=ES(b|0)|0;g=c[d>>2]|0;if((a[g]|0)!=45){h=0;i=e;return h|0}if((BS(b,g+1|0,f)|0)!=0){h=0;i=e;return h|0}if((a[g+(f+1)|0]|0)!=61){h=0;i=e;return h|0}h=g+(f+2)|0;i=e;return h|0}function DF(){i=i;return}function EF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)<=0){tc(0)}e=c[r>>2]|0;pc(77960,5,1,e|0)|0;f=b;b=0;while(1){Jd(a[f]|0,e|0)|0;g=b+1|0;if((g|0)<(d|0)){b=g;f=f+1|0}else{break}}pc(77968,20,1,e|0)|0;tc(0);return 0}function FF(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;e=d;d=c[r>>2]|0;c[e>>2]=a;od(d|0,77992,e|0)|0;if((b|0)==0){tc(1)}else{md(d|0)|0;NF();md(d|0)|0;hb(6,0)|0;cd()}}function GF(a,b){a=a|0;b=b|0;var c=0.0;c=+W(+(+h[a>>3]),+(+h[b>>3]));i=i;return+c}function HF(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0.0,g=0.0,j=0,k=0.0,l=0.0;d=i;e=+h[a>>3];a=c[b>>2]|0;if((a|0)==0){f=1.0;i=d;return+f}if((a|0)<0){g=1.0;j=0-a|0;k=1.0/e}else{g=1.0;j=a;k=e}while(1){if((j&1|0)==0){l=g}else{l=g*k}a=j>>>1;if((a|0)==0){f=l;break}g=l;j=a;k=k*k}i=d;return+f}function IF(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0;c=i;d=+h[a>>3];if(!(d>=0.0)){e=-d}else{e=d}if(+h[b>>3]>=0.0){f=e;i=c;return+f}f=-e;i=c;return+f}function JF(a){a=a|0;var b=0.0,c=0.0,d=0.0;b=+g[a>>2];c=b;if(!(b>=0.0)){d=-+T(+(.5-c))}else{d=+T(+(c+.5))}i=i;return~~d|0}function KF(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=b+d|0;h=c+e|0;if((d|0)>(e|0)){a:do{if((e|0)>0){j=b;k=c;while(1){l=a[j]|0;m=a[k]|0;if(!(l<<24>>24==m<<24>>24)){break}n=j+1|0;o=k+1|0;if(o>>>0<h>>>0){j=n;k=o}else{p=n;break a}}q=(l&255)-(m&255)|0;i=f;return q|0}else{p=b}}while(0);if(p>>>0<g>>>0){r=p}else{q=0;i=f;return q|0}while(1){s=a[r]|0;p=r+1|0;if(!(s<<24>>24==32)){break}if(p>>>0<g>>>0){r=p}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=(s&255)+ -32|0;i=f;return q|0}else{b:do{if((d|0)>0){s=b;r=c;while(1){u=a[s]|0;v=a[r]|0;if(!(u<<24>>24==v<<24>>24)){break}p=s+1|0;m=r+1|0;if(p>>>0<g>>>0){s=p;r=m}else{w=m;break b}}q=(u&255)-(v&255)|0;i=f;return q|0}else{w=c}}while(0);if(w>>>0<h>>>0){x=w}else{q=0;i=f;return q|0}while(1){y=a[x]|0;w=x+1|0;if(!(y<<24>>24==32)){break}if(w>>>0<h>>>0){x=w}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=32-(y&255)|0;i=f;return q|0}return 0}function LF(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=c;h=b+d|0;if((d|0)<=(e|0)){do{if(b>>>0>c>>>0){j=c+d|0;if(!(j>>>0>b>>>0)){break}if((d|0)>0){k=j;l=h}else{i=f;return}do{k=k+ -1|0;l=l+ -1|0;a[l]=a[k]|0;}while(l>>>0>b>>>0);i=f;return}}while(0);if((d|0)>0){m=c;n=b}else{i=f;return}while(1){l=n+1|0;a[n]=a[m]|0;if(l>>>0<h>>>0){n=l;m=m+1|0}else{break}}i=f;return}m=c+e|0;do{if(b>>>0>c>>>0&m>>>0>b>>>0){n=b+e|0;if((e|0)>0){l=0-g-e|0;k=~g;j=~(c+(l>>>0>k>>>0?l:k));k=n;l=m;do{l=l+ -1|0;k=k+ -1|0;a[k]=a[l]|0;}while(l>>>0>c>>>0);o=b+j|0}else{o=n}p=o+e|0}else{if((e|0)<=0){p=b;break}l=c+1|0;k=(m>>>0>l>>>0?m:l)+(0-g)|0;l=b;q=c;while(1){r=q+1|0;a[l]=a[q]|0;if(r>>>0<m>>>0){q=r;l=l+1|0}else{break}}p=b+k|0}}while(0);if(!(p>>>0<h>>>0)){i=f;return}IS(p|0,32,b+(d-p)|0)|0;i=f;return}function MF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+4>>2]|0;if((e|0)>99){i=d;return 0}f=79032+(e*48|0)|0;g=c[f>>2]|0;if((g|0)!=0){do{if((c[79076+(e*48|0)>>2]|0)==1){h=10}else{j=c[b+8>>2]|0;if((j|0)!=0){k=a[j]|0;if((k|0)==100|(k|0)==68){h=10;break}}if((c[79072+(e*48|0)>>2]|0)==1){OF(b)|0}k=79036+(e*48|0)|0;if((c[k>>2]|0)==0){break}Vc(c[f>>2]|0)|0;bS(c[k>>2]|0)}}while(0);do{if((h|0)==10){Vc(g|0)|0;b=79036+(e*48|0)|0;k=c[b>>2]|0;if((k|0)==0){break}Ad(k|0)|0;bS(c[b>>2]|0)}}while(0);c[f>>2]=0}c[79068+(e*48|0)>>2]=0;c[79036+(e*48|0)>>2]=0;i=d;return 0}function NF(){var a=0,b=0;a=i;if((c[19500]|0)!=0){i=a;return}c[19500]=1;c[78008>>2]=0;b=0;do{c[78004>>2]=b;MF(78e3)|0;b=b+1|0;}while((b|0)<100);i=a;return}function OF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+4>>2]|0;if((c[79048+(d*48|0)>>2]|0)!=0){e=0;i=b;return e|0}f=79032+(d*48|0)|0;g=c[f>>2]|0;h=xb(g|0)|0;Tc(g|0,0,2)|0;if((h|0)>=(xb(g|0)|0)){e=0;i=b;return e|0}if((c[79052+(d*48|0)>>2]|0)==0){e=0;i=b;return e|0}if((c[79060+(d*48|0)>>2]&2|0)!=0){md(c[f>>2]|0)|0}d=Rc(qb(c[f>>2]|0)|0,h|0)|0;Tc(c[f>>2]|0,0,2)|0;if((d|0)==0){e=0;i=b;return e|0}if((c[a>>2]|0)==0){QF(111,78016);e=111;i=b;return e|0}else{c[(Lc()|0)>>2]=111;e=111;i=b;return e|0}return 0}function PF(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+80|0;d=b;do{if((_a(qb(a|0)|0,d|0)|0)<0){e=0}else{f=c[d+12>>2]&61440;if((f|0)==32768|(f|0)==16384){e=(c[d+16>>2]|0)!=0|0;break}else if((f|0)==8192){e=(tb(qb(a|0)|0)|0)==0|0;break}else if((f|0)==24576){e=1;break}else{e=0;break}}}while(0);i=b;return e|0}function QF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;d=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;do{if(a>>>0<100){Oc(b|0);l=c[r>>2]|0}else{if((a+1|0)>>>0>132){m=c[r>>2]|0;c[k>>2]=b;c[k+4>>2]=a;od(m|0,78928,k|0)|0;l=m;break}m=c[r>>2]|0;if((a|0)==-1){c[j>>2]=b;od(m|0,78960,j|0)|0;l=m;break}else{n=c[78800+(a+ -100<<2)>>2]|0;c[h>>2]=b;c[h+4>>2]=n;od(m|0,78984,h|0)|0;l=m;break}}}while(0);h=c[19748]|0;do{if((h|0)==0){pc(83864,29,1,l|0)|0}else{c[g>>2]=(h-79032|0)/48|0;od(l|0,79e3,g|0)|0;b=c[(c[19748]|0)+4>>2]|0;if((b|0)==0){pc(83848,10,1,l|0)|0;break}else{c[f>>2]=b;od(l|0,83832,f|0)|0;break}}}while(0);f=c[20974]|0;if((f|0)!=0){c[d>>2]=f;od(l|0,83904,d|0)|0}d=(c[20994]|0)!=0?83984:84e3;f=(c[21002]|0)!=0?84016:84032;g=(c[21012]|0)!=0?84056:84072;c[e>>2]=(c[20988]|0)!=0?83960:83968;c[e+4>>2]=d;c[e+8>>2]=f;c[e+12>>2]=g;od(l|0,83928,e|0)|0;FF(84088,1)}function RF(){var a=0,b=0;a=i;c[21024]=1;b=c[r>>2]|0;c[19758]=b;c[79052>>2]=PF(b)|0;c[79056>>2]=1;c[79072>>2]=1;b=c[s>>2]|0;c[79272>>2]=b;c[79292>>2]=PF(b)|0;c[79296>>2]=1;c[79312>>2]=0;b=c[t>>2]|0;c[79320>>2]=b;c[79340>>2]=PF(b)|0;c[79344>>2]=1;c[79360>>2]=1;i=a;return}function SF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+28|0;e=c[d>>2]|0;a:do{if((e&2|0)==0){f=a+4|0;g=c[f>>2]|0;do{if((g|0)!=0){if((c[a+16>>2]|0)==0){h=c[a+24>>2]|0}else{h=0}if((c[a+40>>2]|0)==3){j=a;k=vc(g|0,c[89344+(h<<2)>>2]|0,c[j>>2]|0)|0;c[j>>2]=k;c[21026]=k;if((k|0)==0){break}c[d>>2]=2;break a}k=a;j=xb(c[k>>2]|0)|0;l=vc(c[f>>2]|0,c[89344+((h|2)<<2)>>2]|0,c[k>>2]|0)|0;c[k>>2]=l;c[21026]=l;if((l|0)==0){c[k>>2]=0;break}else{c[d>>2]=3;Tc(c[k>>2]|0,j|0,0)|0;break a}}}while(0);c[(Lc()|0)>>2]=127;m=1;i=b;return m|0}else{if((e&1|0)==0){break}Tc(c[a>>2]|0,0,1)|0}}while(0);c[a+40>>2]=1;m=0;i=b;return m|0}function TF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((a|0)==0){QF(b,d)}d=c[21028]|0;if((d|0)!=0){se[d&7]()|0}c[(Lc()|0)>>2]=b;i=e;return b|0}function UF(a){a=a|0;var b=0,d=0;b=i;c[21058]=0;c[21060]=0;c[21062]=0;d=((VF(a,0)|0)==0)<<31>>31;i=b;return d|0}function VF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b;while(1){b=a[f]|0;g=f+1|0;if(b<<24>>24==32){f=g}else if(b<<24>>24==40){break}else{h=0;j=8;break}}if((j|0)==8){i=e;return h|0}j=c[21062]|0;c[21062]=j+1;if((j|0)==1){c[21060]=d}if((_F(1,d,0,0)|0)<0){h=0;i=e;return h|0}d=$F(g)|0;if((d|0)==0){h=0;i=e;return h|0}else{k=d}while(1){if((a[k]|0)==32){k=k+1|0}else{h=k;break}}i=e;return h|0}function WF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;e=i;i=i+8|0;f=e;if((c[a>>2]|0)>0){g=b;h=0}else{j=0;i=e;return j|0}a:while(1){b=(g|0)==0;b:while(1){k=c[21058]|0;l=84256+(k<<4)|0;m=c[l>>2]|0;switch(XF(m)|0){case 22:{c[21036]=1;c[21058]=k+1;continue b;break};case 20:{c[21054]=c[84260+(k<<4)>>2];c[21058]=k+1;continue b;break};case 9:{n=($d[c[21042]&127](l)|0)==0;c[21058]=(c[21058]|0)+1;if(n){break b}else{continue b}break};case 18:{c[21034]=1;c[21058]=k+1;continue b;break};case 1:{n=c[84260+(k<<4)>>2]|0;o=(c[22290]|0)+1|0;c[22290]=o;c[89168+(o<<2)>>2]=n;c[21058]=k+1;continue b;break};case 6:{n=c[84260+(k<<4)>>2]|0;o=(c[22274]|0)+1|0;c[22274]=o;c[89104+(o<<2)>>2]=n;c[21058]=k+1;continue b;break};case 21:{c[21036]=0;c[21058]=k+1;continue b;break};case 2:{c[22274]=0;c[22290]=0;c[21058]=c[84260+(k<<4)>>2];if(b){p=24;break a}if((c[22286]|0)==0){j=0;p=37;break a}n=se[c[21044]&7]()|0;if((n|0)==0){continue b}else{j=n;p=37;break a}break};case 3:{n=c[22274]|0;o=89104+(n<<2)|0;q=c[o>>2]|0;c[o>>2]=q+ -1;if((q|0)<2){c[22274]=n+ -1;c[22290]=(c[22290]|0)+ -1;c[21058]=k+1;continue b}else{n=c[22290]|0;c[22290]=n+ -1;c[21058]=(c[89168+(n<<2)>>2]|0)+1;continue b}break};case 16:{if(b){p=28;break a}c[21058]=k+1;continue b;break};case 33:{c[22302]=1;c[21058]=k+1;continue b;break};case 8:{n=c[22274]|0;s=89104+(n<<2)|0;t=c[s>>2]|0;if((t|0)>=1){p=10;break b}c[22274]=n+ -1;c[21058]=k+1;continue b;break};case 19:case 17:{c[21034]=0;c[21058]=k+1;continue b;break};default:{p=4;break a}}}if((p|0)==10){p=0;if(b){p=11;break}c[s>>2]=t+ -1;c[22286]=1;k=be[c[21040]&63](l,g,d)|0;if((k|0)>0){p=13;break}if((k|0)<0){p=15;break}}k=h+1|0;if((k|0)<(c[a>>2]|0)){g=g+d|0;h=k}else{j=0;p=37;break}}if((p|0)==4){h=c[r>>2]|0;d=c[20974]|0;c[f>>2]=m;c[f+4>>2]=d;od(h|0,89056,f|0)|0;if((c[c[21030]>>2]|0)==0){QF(100,89088);j=100;i=e;return j|0}else{c[(Lc()|0)>>2]=100;j=100;i=e;return j|0}}else if((p|0)==11){j=se[c[21028]&7]()|0;i=e;return j|0}else if((p|0)==13){f=c[c[21030]>>2]|0;j=TF(f,c[(Lc()|0)>>2]|0,89152)|0;i=e;return j|0}else if((p|0)==15){if((c[(c[21030]|0)+8>>2]|0)==0){QF(-1,89152);j=-1;i=e;return j|0}else{c[(Lc()|0)>>2]=-1;j=-1;i=e;return j|0}}else if((p|0)==24){j=se[c[21028]&7]()|0;i=e;return j|0}else if((p|0)==28){j=se[c[21028]&7]()|0;i=e;return j|0}else if((p|0)==37){i=e;return j|0}return 0}function XF(a){a=a|0;var b=0;switch(a|0){case 26:case 25:case 24:case 29:case 34:case 32:case 31:case 30:case 10:case 7:case 23:case 27:case 28:case 35:case 36:{b=8;break};case 14:case 13:case 15:case 12:case 11:case 5:case 4:{b=9;break};default:{b=a}}i=i;return b|0}function YF(){var a=0,b=0,d=0;a=i;i=i+8|0;b=a;c[b>>2]=1;d=WF(b,0,0)|0;i=a;return d|0}function ZF(){c[21050]=0;c[21058]=0;c[22290]=0;c[22274]=0;c[22286]=0;c[22292]=0;c[22276]=0;i=i;return}function _F(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[21058]|0;if((g|0)>299){pc(89232,24,1,c[r>>2]|0)|0;FF(c[20974]|0,1)}else{c[84256+(g<<4)>>2]=a;c[84260+(g<<4)>>2]=b;c[84264+(g<<4)>>2]=d;c[84268+(g<<4)>>2]=e;c[21058]=g+1;i=f;return g|0}return 0}function $F(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a[b]|0;if(e<<24>>24==0){f=0;i=d;return f|0}else{g=b;h=e}a:while(1){e=g+1|0;if(h<<24>>24==32){h=a[e]|0;g=e;continue}e=aG(g)|0;if((e|0)==0){f=0;j=12;break}else{k=e}while(1){e=a[k]|0;if(e<<24>>24==44){j=7;break}else if(e<<24>>24==41){j=9;break a}else if(!(e<<24>>24==32)){l=k;break}k=k+1|0}if((j|0)==7){j=0;l=k+1|0}e=a[l]|0;if(e<<24>>24==0){f=0;j=12;break}else{g=l;h=e}}if((j|0)==9){h=(c[21062]|0)+ -1|0;c[21062]=h;if((h|0)==0){_F(2,c[21060]|0,0,0)|0;f=k+1|0;i=d;return f|0}else{_F(3,0,0,0)|0;f=k+1|0;i=d;return f|0}}else if((j|0)==12){i=d;return f|0}return 0}function aG(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;do{if((a[b]|0)==41){g=b}else{if((bG(b,e)|0)!=0){g=c[e>>2]|0;break}if((cG(b,e)|0)!=0){g=c[e>>2]|0;break}h=dG(b,f,1)|0;j=_F(6,c[f>>2]|0,0,0)|0;if((j|0)<0){g=0;break}g=VF(h,j)|0}}while(0);i=d;return g|0}function bG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;a:do{switch(a[b]|0){case 47:{_F(5,0,0,0)|0;g=b;h=30;break};case 112:case 80:{_F(20,1,0,0)|0;g=b;h=30;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{j=b;k=0;h=14;break};case 116:case 84:{l=b+1|0;m=a[l]|0;if(m<<24>>24==82|m<<24>>24==114){n=l;o=14}else if(m<<24>>24==76|m<<24>>24==108){n=l;o=13}else{n=b;o=15}l=dG(n+1|0,f,0)|0;if((l|0)==0){h=15;break a}_F(o,c[f>>2]|0,0,0)|0;g=l+ -1|0;h=30;break};case 120:case 88:{_F(4,1,0,0)|0;g=b;h=30;break};case 115:case 83:{l=b+1|0;m=a[l]|0;if(m<<24>>24==80|m<<24>>24==112){p=l;q=18}else if(m<<24>>24==83|m<<24>>24==115){p=l;q=19}else{p=b;q=17}_F(q,0,0,0)|0;g=p;h=30;break};case 58:{_F(16,0,0,0)|0;g=b;h=30;break};case 39:case 34:case 2:{c[84264+((_F(11,0,0,0)|0)<<4)>>2]=b;l=eG(b)|0;c[d>>2]=l;r=(l|0)!=0|0;i=e;return r|0};case 36:{_F(33,0,0,0)|0;g=b;h=30;break};case 98:case 66:{l=b+1|0;m=a[l]|0;if(m<<24>>24==90|m<<24>>24==122){_F(22,0,0,0)|0;g=l;h=30;break a}else{_F(21,0,0,0)|0;g=l;h=30;break a}break};case 43:{s=0;h=13;break};case 45:{s=1;h=13;break};default:{r=0;i=e;return r|0}}}while(0);if((h|0)==13){j=b+1|0;k=s;h=14}b:do{if((h|0)==14){s=dG(j,f,0)|0;if((s|0)==0){h=15;break}switch(a[s]|0){case 112:case 80:{b=c[f>>2]|0;if((k|0)==0){t=b}else{p=0-b|0;c[f>>2]=p;t=p}_F(20,t,0,0)|0;g=s;h=30;break b;break};case 104:case 72:{p=c[f>>2]|0;c[84264+((_F(12,p,0,0)|0)<<4)>>2]=s+1;g=s+p|0;h=30;break b;break};case 120:case 88:{_F(4,c[f>>2]|0,0,0)|0;g=s;h=30;break b;break};default:{r=0;i=e;return r|0}}}}while(0);if((h|0)==15){c[d>>2]=0;r=1;i=e;return r|0}else if((h|0)==30){c[d>>2]=g+1;r=1;i=e;return r|0}return 0}function cG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=dG(b,f,1)|0;_F(6,c[f>>2]|0,0,0)|0;f=k+1|0;a:do{switch(a[k]|0){case 102:case 70:{l=dG(f,g,0)|0;if((l|0)==0){m=4;break a}n=c[g>>2]|0;if((n|0)==0){o=l;m=45;break a}if((a[l]|0)==46){p=dG(l+1|0,h,0)|0;if((p|0)==0){m=4;break a}q=p;r=c[h>>2]|0}else{c[h>>2]=0;q=l;r=0}_F(23,n,r,0)|0;o=q;m=45;break};case 105:case 73:{s=7;t=10;m=38;break};case 97:case 65:{n=f;while(1){u=a[n]|0;if(u<<24>>24==32){n=n+1|0}else{break}}if(!((u+ -48<<24>>24&255)<10)){_F(30,0,0,0)|0;o=n;m=45;break a}l=dG(n,g,1)|0;p=c[g>>2]|0;if((p|0)==0){o=l;m=45;break a}_F(31,p,0,0)|0;o=l;m=45;break};case 122:case 90:{s=35;t=36;m=38;break};case 101:case 69:{v=1;m=3;break};case 108:case 76:{l=dG(f,g,0)|0;if((l|0)==0){m=4;break a}p=c[g>>2]|0;if((p|0)==0){o=l;m=45;break a}_F(29,p,0,0)|0;o=l;m=45;break};case 103:case 71:{v=0;m=3;break};case 111:case 79:{s=32;t=34;m=38;break};case 100:case 68:{l=dG(f,g,0)|0;if((l|0)==0){m=4;break a}p=c[g>>2]|0;if((p|0)==0){o=l;m=45;break a}if((a[l]|0)==46){w=dG(l+1|0,h,0)|0;if((w|0)==0){m=4;break a}x=w;y=c[h>>2]|0}else{c[h>>2]=0;x=l;y=0}_F(26,p,y,0)|0;o=x;m=45;break};default:{c[21058]=(c[21058]|0)+ -1;c[d>>2]=b;z=0;i=e;return z|0}}}while(0);do{if((m|0)==3){b=dG(f,g,0)|0;if((b|0)==0){m=4;break}x=c[g>>2]|0;if((x|0)==0){o=b;m=45;break}y=a[b]|0;if(y<<24>>24==46){u=dG(b+1|0,h,0)|0;if((u|0)==0){m=4;break}A=u;B=a[u]|0}else{c[h>>2]=0;A=b;B=y}if(!(B<<24>>24==101|B<<24>>24==69)){_F((v|0)==1?24:27,x,c[h>>2]|0,0)|0;o=A;m=45;break}y=dG(A+1|0,j,0)|0;if((y|0)==0){m=4;break}_F((v|0)==1?25:28,x,c[h>>2]|0,c[j>>2]|0)|0;o=y;m=45}else if((m|0)==38){y=dG(f,g,0)|0;if((y|0)==0){m=4;break}x=c[g>>2]|0;if((x|0)==0){o=y;m=45;break}if((a[y]|0)!=46){_F(s,x,0,0)|0;o=y;m=45;break}b=dG(y+1|0,h,0)|0;if((b|0)==0){m=4;break}_F(t,x,c[h>>2]|0,0)|0;o=b;m=45}}while(0);if((m|0)==4){c[d>>2]=0;z=1;i=e;return z|0}else if((m|0)==45){c[d>>2]=o;z=1;i=e;return z|0}return 0}function dG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b;b=0;h=0;while(1){j=a[g]|0;k=j<<24>>24;if(j<<24>>24==32){l=b;m=h}else{if((j+ -48<<24>>24&255)>9){break}l=b+1|0;m=(h*10|0)+ -48+k|0}g=g+1|0;b=l;h=m}if((b|0)!=0){n=g;o=h;c[d>>2]=o;i=f;return n|0}n=(e|0)==0?0:g;o=e;c[d>>2]=o;i=f;return n|0}function eG(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a[b]|0;f=b+1|0;g=a[f]|0;a:do{if(!(g<<24>>24==0)){h=f;j=g;k=b;while(1){if(j<<24>>24==e<<24>>24){l=k+2|0;if((a[l]|0)==e<<24>>24){m=l}else{n=l;break}}else{m=h}l=m+1|0;o=a[l]|0;if(o<<24>>24==0){break a}else{h=l;j=o;k=m}}i=d;return n|0}}while(0);if((c[c[21030]>>2]|0)==0){QF(100,89216);n=0;i=d;return n|0}else{c[(Lc()|0)>>2]=100;n=0;i=d;return n|0}return 0}function fG(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;do{if((b|0)>0){h=0;j=b}else{if((b|0)<0){h=1;j=0-b|0;break}c[e>>2]=0;c[d>>2]=1;a[89286|0]=48;k=89286|0;i=g;return k|0}}while(0);c[e>>2]=h;h=23;e=j;while(1){j=h+ -1|0;l=89264+j|0;a[l]=((e>>>0)%(f>>>0)|0)+48;b=(e>>>0)/(f>>>0)|0;if((b|0)==0){break}else{e=b;h=j}}c[d>>2]=24-h;k=l;i=g;return k|0}function gG(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[21052]|0;f=c[21048]|0;if((e|0)>(f|0)){c[21048]=e;g=e}else{g=f}f=g+1|0;if((f|0)<(c[22340]|0)){h=g}else{hG(f,g);h=c[21048]|0}g=c[22342]|0;f=g+h|0;if((b|0)==0){j=f}else{a[f]=b;j=g+(h+1)|0}a[j]=0;Bd(g|0,c[21026]|0)|0;h=ES(g|0)|0;b=g+h|0;if(b>>>0<j>>>0){k=b;l=h;m=g}else{i=d;return 0}while(1){g=l+1|0;h=m+g|0;Jd(a[k]|0,c[21026]|0)|0;Bd(h|0,c[21026]|0)|0;b=ES(h|0)|0;f=m+(g+b)|0;if(f>>>0<j>>>0){m=h;l=b;k=f}else{break}}i=d;return 0}function hG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[22342]|0;if((f|0)==89448){c[22340]=1024;g=1024}else{g=c[22340]|0}if((g|0)>(b|0)){h=g}else{j=g;do{j=j<<1;}while((j|0)<=(b|0));c[22340]=j;h=j}j=aS(h)|0;if((j|0)==0){QF(113,89848);k=c[22342]|0}else{k=f}f=k+d|0;if((d|0)>0){d=j;h=k;while(1){b=h+1|0;a[d]=a[h]|0;if(b>>>0<f>>>0){h=b;d=d+1|0}else{break}}l=c[22342]|0}else{l=k}if((l|0)==89448){m=89368;c[22342]=j;i=e;return}bS(l);m=89368;c[22342]=j;i=e;return}function iG(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[21048]|0;f=c[22340]|0;if((e|0)<(f|0)){g=e}else{hG(e,f);g=c[21048]|0}c[21048]=g+1;a[(c[22342]|0)+g|0]=b;i=d;return}function jG(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d;f=i;i=i+256|0;g=i;i=i+16|0;h=i;i=i+8|0;j=f;c[21012]=1;f=b+4|0;k=c[f>>2]|0;if(k>>>0>99){if((c[b>>2]|0)==0){QF(101,89376);l=101;i=d;return l|0}else{c[(Lc()|0)>>2]=101;l=101;i=d;return l|0}}if((c[21024]|0)==0){RF();m=c[f>>2]|0}else{m=k}k=79032+(m*48|0)|0;c[19748]=k;n=k;a:do{if((c[n>>2]|0)!=0){k=c[b+8>>2]|0;do{if((k|0)!=0){oG(k,c[b+12>>2]|0,j);o=pG(j,h)|0;if((o|0)==(c[79040+(m*48|0)>>2]|0)){if((c[h>>2]|0)==(c[79044+(m*48|0)>>2]|0)){break}}c[g+4>>2]=c[f>>2];c[g+8>>2]=0;c[g>>2]=c[b>>2];o=MF(g)|0;if((o|0)==0){break a}else{l=o}i=d;return l|0}}while(0);k=c[b+32>>2]|0;if((k|0)==0){l=0;i=d;return l|0}o=a[k]|0;if(o<<24>>24==122){p=1}else{p=o<<24>>24==90|0}c[79064+(m*48|0)>>2]=p;l=0;i=d;return l|0}}while(0);p=b+28|0;g=c[p>>2]|0;h=79048+(m*48|0)|0;c[h>>2]=g;o=c[b+32>>2]|0;do{if((o|0)==0){q=0}else{k=a[o]|0;if(k<<24>>24==122){q=1;break}q=k<<24>>24==90|0}}while(0);c[79064+(m*48|0)>>2]=q;q=c[b+24>>2]|0;do{if((q|0)==0){o=79056+(m*48|0)|0;if((g|0)>0){c[o>>2]=0;r=0;break}else{c[o>>2]=1;r=1;break}}else{o=a[q]|0;if(o<<24>>24==70|o<<24>>24==102){c[79056+(m*48|0)>>2]=1;r=1;break}else{c[79056+(m*48|0)>>2]=0;r=0;break}}}while(0);q=c[b+8>>2]|0;do{if((q|0)==0){c[e>>2]=c[f>>2];gc(j|0,89384,e|0)|0}else{oG(q,c[b+12>>2]|0,j);if((a[j]|0)!=0){break}if((c[b>>2]|0)==0){kG(107,89376,b);l=107;i=d;return l|0}else{c[(Lc()|0)>>2]=107;l=107;i=d;return l|0}}}while(0);q=79076+(m*48|0)|0;c[q>>2]=0;c[79068+(m*48|0)>>2]=0;e=79072+(m*48|0)|0;c[e>>2]=0;c[n>>2]=0;f=79060+(m*48|0)|0;c[f>>2]=3;g=c[b+16>>2]|0;b:do{if((g|0)!=0){c:do{switch(a[g]|0){case 78:case 110:{if((Ac(j|0,0)|0)!=0){break c}if((c[b>>2]|0)==0){kG(128,89376,b);l=128;i=d;return l|0}else{c[(Lc()|0)>>2]=128;l=128;i=d;return l|0}break};case 83:case 115:{c[q>>2]=1;o=Kb()|0;c[n>>2]=o;if((o|0)!=0){c[79036+(m*48|0)>>2]=0;c[79044+(m*48|0)>>2]=-1;c[79040+(m*48|0)>>2]=-1;c[79052+(m*48|0)>>2]=1;l=0;i=d;return l|0}o=(c[b>>2]|0)==0;k=Lc()|0;s=c[k>>2]|0;if(o){kG(s,89376,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=s;l=s;i=d;return l|0}break};case 79:case 111:{if((Ac(j|0,0)|0)==0){break b}s=(c[b>>2]|0)==0;k=Lc()|0;o=c[k>>2]|0;if(s){kG(o,89376,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=o;l=o;i=d;return l|0}break};case 82:case 114:{break};default:{break b}}}while(0);o=hc(j|0,c[22336]|0)|0;if((o|0)==0){break}Vc(o|0)|0}}while(0);q=aS((ES(j|0)|0)+1|0)|0;c[79036+(m*48|0)>>2]=q;if((q|0)==0){if((c[b>>2]|0)==0){kG(113,89400,b);l=113;i=d;return l|0}else{c[(Lc()|0)>>2]=113;l=113;i=d;return l|0}}KS(q|0,j|0)|0;q=b+20|0;if((c[q>>2]|0)==0){t=r}else{t=(c[h>>2]|0)==0?r:0}r=hc(j|0,c[89344+((t|2)<<2)>>2]|0)|0;do{if((r|0)==0){h=hc(j|0,c[89304+(t<<2)>>2]|0)|0;if((h|0)!=0){c[f>>2]=1;u=h;break}h=hc(j|0,c[89344+(t<<2)>>2]|0)|0;if((h|0)!=0){c[e>>2]=1;c[f>>2]=2;u=h;break}h=(c[b>>2]|0)==0;g=Lc()|0;o=c[g>>2]|0;if(h){QF(o,89376);l=c[g>>2]|0;i=d;return l|0}else{c[g>>2]=o;l=o;i=d;return l|0}}else{u=r}}while(0);c[n>>2]=u;r=79052+(m*48|0)|0;c[r>>2]=PF(u)|0;u=pG(j,79044+(m*48|0)|0)|0;c[79040+(m*48|0)>>2]=u;if((u|0)==-1){if((c[b>>2]|0)==0){kG(108,89376,b);l=108;i=d;return l|0}else{c[(Lc()|0)>>2]=108;l=108;i=d;return l|0}}if((c[r>>2]|0)==0){l=0;i=d;return l|0}if((c[p>>2]|0)!=0){ob(c[n>>2]|0);l=0;i=d;return l|0}p=c[q>>2]|0;if((p|0)==0){l=0;i=d;return l|0}q=a[p]|0;if(!(q<<24>>24==65|q<<24>>24==97)){l=0;i=d;return l|0}if((Tc(c[n>>2]|0,0,2)|0)==0){l=0;i=d;return l|0}if((c[b>>2]|0)==0){kG(129,89376,b);l=129;i=d;return l|0}else{c[(Lc()|0)>>2]=129;l=129;i=d;return l|0}return 0}function kG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d+8|0;g=c[f>>2]|0;if((g|0)==0){QF(a,b);i=e;return}h=d+12|0;d=c[h>>2]|0;if((d|0)<(c[22340]|0)){j=d;k=g}else{hG(d,0);j=c[h>>2]|0;k=c[f>>2]|0}f=c[22342]|0;c[(c[19748]|0)+4>>2]=f;oG(k,j,f);QF(a,b);i=e;return}function lG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+40|0;j=g;c[f>>2]=d;gc(j|0,89384,f|0)|0;c[h>>2]=1;c[h+4>>2]=d;c[h+8>>2]=j;c[h+12>>2]=ES(j|0)|0;c[h+16>>2]=0;c[h+20>>2]=(a|0)==3?89416:89424;c[h+24>>2]=(b|0)==5?89432:89440;c[h+28>>2]=(a|0)==4;c[h+32>>2]=0;a=jG(h)|0;i=e;return a|0}function mG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=79032+(d*48|0)|0;c[19748]=e;if(d>>>0>99){if((c[a>>2]|0)==0){QF(101,89864);f=101;i=b;return f|0}else{c[(Lc()|0)>>2]=101;f=101;i=b;return f|0}}do{if((c[e>>2]|0)==0){if((lG(3,5,d)|0)==0){break}if((c[a>>2]|0)==0){QF(114,89872);f=114;i=b;return f|0}else{c[(Lc()|0)>>2]=114;f=114;i=b;return f|0}}}while(0);if((c[79056+(d*48|0)>>2]|0)!=0){f=0;i=b;return f|0}if((c[a>>2]|0)==0){QF(102,89872);f=102;i=b;return f|0}else{c[(Lc()|0)>>2]=102;f=102;i=b;return f|0}return 0}function nG(){var a=0,b=0;a=i;b=YF()|0;c[20974]=0;i=a;return b|0}function oG(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+c|0;g=d+c|0;while(1){if(!(f>>>0>b>>>0)){h=3;break}j=f+ -1|0;k=g+ -1|0;if((a[j]|0)==32){f=j;g=k}else{break}}if((h|0)==3){a[d]=0;i=e;return}a[g]=0;g=j;j=k;while(1){a[j]=a[g]|0;if(g>>>0>b>>>0){j=j+ -1|0;g=g+ -1|0}else{break}}i=e;return}function pG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+80|0;e=d;if((kc(a|0,e|0)|0)<0){f=-1;i=d;return f|0}c[b>>2]=c[e>>2];f=c[e+72>>2]|0;i=d;return f|0}function qG(b,d,e,f,j){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=i;i=i+56|0;p=o;q=(f|0)<1?2:f;r=c[21054]|0;if((r|0)==0){s=3}else{if((r|0)<(e+2|0)&(r|0)>(0-e|0)){s=3}}a:do{if((s|0)==3){t=(((r|0)<1)<<31>>31)+e|0;if((j|0)==4){u=+g[b>>2]}else{u=+h[b>>3]}do{if(u<0.0){v=-u;w=1;x=1}else{y=c[21034]|0;if(u!=0.0){v=u;w=0;x=y;break}v=0.0;w=0;x=y}}while(0);y=d+ -4-q-t-x|0;if((y|0)<0){break}z=((r|0)<0?r:0)+t|0;A=(z|0)>40;B=A?40:z;C=A?z+ -40|0:0;c[n>>2]=B;z=n+4|0;h[k>>3]=v;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];gc(p|0,89880,n|0)|0;z=a[p]|0;if(!((z+ -48|0)>>>0<10)){if((z|0)==78|(z|0)==110){D=0}else{D=x}z=d-(ES(p|0)|0)-D|0;if((z|0)<0){break}if((z|0)>0){A=z;do{A=A+ -1|0;Yd[c[21038]&255](32);}while((A|0)>0)}if((D|0)!=0){Yd[c[21038]&255]((w|0)!=0?45:43)}A=a[p]|0;if(A<<24>>24==0){i=l;return 0}else{E=A;F=p}do{Yd[c[21038]&255](E<<24>>24);F=F+1|0;E=a[F]|0;}while(!(E<<24>>24==0));i=l;return 0}A=o+(B+3)|0;if(v!=0.0){t=(Dc(A|0)|0)+1|0;c[m>>2]=t-(c[21054]|0);gc(A|0,89888,m|0)|0}else{t=A;a[t]=3158059;a[t+1|0]=12336;a[t+2|0]=48;a[t+3|0]=0}t=o+(B+4)|0;A=(q|0)<2;if(A){if((a[t]|0)!=48){break}}z=o+(B+6)|0;G=(a[z]|0)==0;b:do{if(G){H=2}else{if((f|0)==0){I=o+(B+2)|0;while(1){J=I+1|0;K=a[J]|0;a[I]=K;if(K<<24>>24==0){H=2;break b}else{I=J}}}I=(f|0)<0;if(I|G){H=I?q:2;break}else{L=2;M=z}while(1){if((L|0)>=(q|0)){break a}I=L+1|0;J=M+1|0;if((a[J]|0)==0){H=I;break}else{L=I;M=J}}}}while(0);if((y|0)>0){z=y;do{z=z+ -1|0;Yd[c[21038]&255](32);}while((z|0)>0)}if((x|0)!=0){Yd[c[21038]&255]((w|0)!=0?45:43)}z=c[21054]|0;do{if((z|0)<1){Yd[c[21038]&255](46);y=c[21038]|0;if((z|0)<0){G=y;J=z;while(1){Yd[G&255](48);I=J+1|0;K=c[21038]|0;if((I|0)<0){J=I;G=K}else{N=K;break}}}else{N=y}Yd[N&255](a[p]|0);O=o+2|0}else{if((z|0)<=1){O=p;break}Yd[c[21038]&255](a[p]|0);G=o+2|0;J=z+ -1|0;K=c[21038]|0;if((J|0)>0){I=z+1|0;P=K;Q=J;J=G;while(1){Yd[P&255](a[J]|0);R=Q+ -1|0;S=c[21038]|0;if((R|0)>0){J=J+1|0;Q=R;P=S}else{break}}T=S;U=o+I|0}else{T=K;U=G}Yd[T&255](46);O=U}}while(0);if((C|0)==0){V=O}else{z=o+(B+2)|0;if(O>>>0<z>>>0){P=O;while(1){Q=P+1|0;Yd[c[21038]&255](a[P]|0);if(Q>>>0<z>>>0){P=Q}else{W=Q;break}}}else{W=O}P=C;while(1){Yd[c[21038]&255](48);z=P+ -1|0;if((z|0)>0){P=z}else{V=W;break}}}if(V>>>0<t>>>0){P=V;while(1){C=P+1|0;Yd[c[21038]&255](a[P]|0);if(C>>>0<t>>>0){P=C}else{X=C;break}}}else{X=V}if(A){Yd[c[21038]&255](a[X+1|0]|0);i=l;return 0}if((H|0)<(q|0)){P=H;do{P=P+1|0;Yd[c[21038]&255](48);}while((P|0)<(q|0))}P=a[X]|0;if(P<<24>>24==0){i=l;return 0}else{Y=P;Z=X}do{Z=Z+1|0;Yd[c[21038]&255](Y<<24>>24);Y=a[Z]|0;}while(!(Y<<24>>24==0));i=l;return 0}}while(0);if((d|0)>0){_=d}else{i=l;return 0}do{_=_+ -1|0;Yd[c[21038]&255](42);}while((_|0)>0);i=l;return 0}function rG(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;l=j;m=i;i=i+656|0;n=m;if((f|0)==4){o=+g[b>>2]}else{o=+h[b>>3]}b=(e|0)<344;f=b?e:344;p=b?0:e+ -344|0;do{if(o<0.0){q=1;r=-o}else{if(o!=0.0){q=0;r=o;break}q=0;r=0.0}}while(0);e=c[21054]|0;if((e|0)==0){s=r}else{if((e|0)>0){b=e;o=r;while(1){t=o*10.0;u=b+ -1|0;if((u|0)>0){o=t;b=u}else{s=t;break}}}else{b=e;o=r;while(1){r=o*.1;e=b+1|0;if((e|0)<0){o=r;b=e}else{s=r;break}}}}c[l>>2]=f;b=l+4|0;h[k>>3]=s;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=(gc(n|0,89896,l|0)|0)+p|0;if((a[n]|0)!=48|(f|0)==0){v=n;w=b}else{v=m+1|0;w=b+ -1|0}a:do{if((q|0)==1){b=v;while(1){m=a[b]|0;if(!(m<<24>>24==48)){n=m<<24>>24;if((n|0)==0){x=0;break a}else if((n|0)!=46){break}}b=b+1|0}x=1}else{x=q}}while(0);q=(x|0)==0;b=((c[21034]|x|0)!=0)+w|0;if((b|0)>(d|0)){if((d|0)>0){y=d}else{i=j;return 0}do{y=y+ -1|0;Yd[c[21038]&255](42);}while((y|0)>0);i=j;return 0}y=d-b|0;if((y|0)>0){b=y;do{b=b+ -1|0;Yd[c[21038]&255](32);}while((b|0)>0)}do{if(q){if((c[21034]|0)==0){break}Yd[c[21038]&255](43)}else{Yd[c[21038]&255](45)}}while(0);q=a[v]|0;if(!(q<<24>>24==0)){b=q;q=v;do{q=q+1|0;Yd[c[21038]&255](b<<24>>24);b=a[q]|0;}while(!(b<<24>>24==0))}if((p|0)>0){z=p}else{i=j;return 0}do{z=z+ -1|0;Yd[c[21038]&255](48);}while((z|0)>0);i=j;return 0}function sG(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((f|0)==4){h=c[d>>2]|0}else if((f|0)==1){h=a[d]|0}else{h=b[d>>1]|0}d=e+ -1|0;if((d|0)>0){e=0;do{Yd[c[21038]&255](32);e=e+1|0;}while((e|0)<(d|0))}d=c[21038]|0;if((h|0)==0){Yd[d&255](70);i=g;return 0}else{Yd[d&255](84);i=g;return 0}return 0}function tG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;do{if((c[21050]|0)!=0){g=uG()|0;if((g|0)==0){break}else{h=g}i=e;return h|0}}while(0);g=c[a>>2]|0;switch(g|0){case 31:{yG(b,c[a+4>>2]|0,d);h=0;i=e;return h|0};case 10:{wG(b,c[a+4>>2]|0,c[a+8>>2]|0,d,10);h=0;i=e;return h|0};case 30:{xG(b,d);h=0;i=e;return h|0};case 36:{AG(b,c[a+4>>2]|0,c[a+8>>2]|0,d);h=0;i=e;return h|0};case 7:{vG(b,c[a+4>>2]|0,d,10);h=0;i=e;return h|0};case 29:{sG(b,c[a+4>>2]|0,d)|0;h=0;i=e;return h|0};case 34:{wG(b,c[a+4>>2]|0,c[a+8>>2]|0,d,8);h=0;i=e;return h|0};case 32:{vG(b,c[a+4>>2]|0,d,8);h=0;i=e;return h|0};case 35:{AG(b,c[a+4>>2]|0,0,d);h=0;i=e;return h|0};case 25:case 24:case 26:{h=qG(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 23:{h=rG(b,c[a+4>>2]|0,c[a+8>>2]|0,d)|0;i=e;return h|0};case 28:case 27:{h=zG(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};default:{h=c[r>>2]|0;c[f>>2]=g;od(h|0,89904,f|0)|0;FF(c[20974]|0,1)}}return 0}function uG(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=c[21050]|0;c[21050]=0;if((c[21012]|0)!=0){if((b|0)>0){d=c[21052]|0;e=c[21048]|0;if((d|0)<=(e|0)){f=b;while(1){Yd[c[21038]&255](32);g=f+ -1|0;if((g|0)>0){f=g}else{h=0;break}}i=a;return h|0}f=e+b|0;if((d|0)>(f|0)){c[21048]=f;h=0;i=a;return h|0}f=b-d+e|0;c[21048]=d;if((f|0)>0){j=f}else{h=0;i=a;return h|0}while(1){Yd[c[21038]&255](32);f=j+ -1|0;if((f|0)>0){j=f}else{h=0;break}}i=a;return h|0}if((b|0)>=0){h=0;i=a;return h|0}j=c[21048]|0;f=j+b|0;if((f|0)>=0){if((c[21052]|0)<(j|0)){c[21052]=j}c[21048]=f;h=0;i=a;return h|0}if((c[c[21030]>>2]|0)==0){QF(110,89992);h=110;i=a;return h|0}else{c[(Lc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<0){f=c[21048]|0;if((c[21052]|0)<(f|0)){c[21052]=f}j=f+b|0;c[21048]=j;c[21056]=(c[21056]|0)+b;if((j|0)>=0){h=0;i=a;return h|0}if((c[c[21030]>>2]|0)==0){QF(110,89992);h=110;i=a;return h|0}else{c[(Lc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<=0){h=0;i=a;return h|0}j=c[21048]|0;f=j+b|0;if((f|0)>=(c[(c[21032]|0)+16>>2]|0)){if((c[c[21030]>>2]|0)==0){QF(110,90008);h=110;i=a;return h|0}else{c[(Lc()|0)>>2]=110;h=110;i=a;return h|0}}d=c[21052]|0;if((d|0)<=(j|0)){e=b;while(1){Yd[c[21038]&255](32);g=e+ -1|0;if((g|0)>0){e=g}else{h=0;break}}i=a;return h|0}if((d|0)>(f|0)){c[21056]=(c[21056]|0)+b;c[21048]=f;h=0;i=a;return h|0}f=d-j|0;j=b-f|0;c[21056]=(c[21056]|0)+f;c[21048]=d;if((j|0)>0){k=j}else{h=0;i=a;return h|0}while(1){Yd[c[21038]&255](32);j=k+ -1|0;if((j|0)>0){k=j}else{h=0;break}}i=a;return h|0}function vG(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;k=h+8|0;if((f|0)==4){l=c[d>>2]|0}else if((f|0)==1){l=a[d]|0}else{l=b[d>>1]|0}d=fG(l,j,k,g)|0;g=c[k>>2]|0;l=(((c[21034]|g|0)!=0)<<31>>31)+(e-(c[j>>2]|0))|0;if((l|0)<0){if((e|0)>0){m=0}else{i=h;return}do{Yd[c[21038]&255](42);m=m+1|0;}while((m|0)<(e|0));i=h;return}if((l|0)>0){e=0;do{Yd[c[21038]&255](32);e=e+1|0;}while((e|0)<(l|0));n=c[k>>2]|0}else{n=g}do{if((n|0)==0){if((c[21034]|0)==0){break}Yd[c[21038]&255](43)}else{Yd[c[21038]&255](45)}}while(0);if((c[j>>2]|0)>0){o=d;p=0}else{i=h;return}while(1){Yd[c[21038]&255](a[o]|0);d=p+1|0;if((d|0)<(c[j>>2]|0)){p=d;o=o+1|0}else{break}}i=h;return}function wG(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;l=j+8|0;if((g|0)==4){m=c[d>>2]|0}else if((g|0)==1){m=a[d]|0}else{m=b[d>>1]|0}d=fG(m,k,l,h)|0;h=c[l>>2]|0;g=(c[21034]|h|0)!=0;n=g&1;o=c[k>>2]|0;do{if((n+o|0)<=(e|0)){if((n+f|0)>(e|0)){break}if((m|f|0)==0){if((e|0)>0){p=0}else{i=j;return}do{Yd[c[21038]&255](32);p=p+1|0;}while((p|0)<(e|0));i=j;return}q=e-((o|0)<(f|0)?f:o)+(g<<31>>31)|0;if((q|0)>0){r=0;do{Yd[c[21038]&255](32);r=r+1|0;}while((r|0)<(q|0));s=c[l>>2]|0}else{s=h}do{if((s|0)==0){if((c[21034]|0)==0){break}Yd[c[21038]&255](43)}else{Yd[c[21038]&255](45)}}while(0);q=c[k>>2]|0;if((f-q|0)>0){r=0;while(1){Yd[c[21038]&255](48);t=r+1|0;u=c[k>>2]|0;if((t|0)<(f-u|0)){r=t}else{v=u;break}}}else{v=q}if((v|0)>0){w=d;x=0}else{i=j;return}while(1){Yd[c[21038]&255](a[w]|0);r=x+1|0;if((r|0)<(c[k>>2]|0)){x=r;w=w+1|0}else{break}}i=j;return}}while(0);if((e|0)>0){y=0}else{i=j;return}do{Yd[c[21038]&255](42);y=y+1|0;}while((y|0)<(e|0));i=j;return}function xG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)>0){f=b;g=d}else{i=e;return}while(1){d=g+ -1|0;Yd[c[21038]&255](a[f]|0);if((d|0)>0){g=d;f=f+1|0}else{break}}i=e;return}function yG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if((d|0)>(e|0)){g=d;while(1){h=g+ -1|0;Yd[c[21038]&255](32);if((h|0)>(e|0)){g=h}else{j=e;break}}}else{j=d}if((j|0)>0){k=b;l=j}else{i=f;return}while(1){j=l+ -1|0;Yd[c[21038]&255](a[k]|0);if((j|0)>0){l=j;k=k+1|0}else{break}}i=f;return}function zG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0,n=0,o=0,p=0;j=i;if((f|0)==4){k=+g[a>>2]}else{k=+h[a>>3]}if(k<0.0){l=-k}else{l=k}a:do{if(l<.1){if(!(l!=0.0)){m=1;break}n=qG(a,b,d,e,f)|0;i=j;return n|0}else{if((d|0)>=0){o=0;k=1.0;while(1){if(!(l>=k)){m=o;break a}if((o|0)<(d|0)){o=o+1|0;k=k*10.0}else{break}}}n=qG(a,b,d,e,f)|0;i=j;return n|0}}while(0);o=c[21054]|0;c[21054]=0;p=(e|0)==0?4:e+2|0;e=rG(a,b-p|0,d-m|0,f)|0;if((p|0)>0){f=0;do{Yd[c[21038]&255](32);f=f+1|0;}while((f|0)<(p|0))}c[21054]=o;n=e;i=j;return n|0}function AG(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;k=b+(g+ -1)|0;a:do{if((k|0)==(j|0)){l=1;m=j}else{g=k;while(1){n=g+ -1|0;if((a[g]|0)!=0){l=0;m=g;break a}if((n|0)==(j|0)){l=1;m=j;break}else{g=n}}}}while(0);k=((d[m]|0)>15)+(m-b<<1|1)|0;if((k|0)>(e|0)){if((e|0)>0){o=0}else{i=h;return}do{Yd[c[21038]&255](42);o=o+1|0;}while((o|0)<(e|0));i=h;return}o=f-k|0;b=(o|0)>0;g=b?f:k;if((g|0)<(e|0)){k=e;do{k=k+ -1|0;Yd[c[21038]&255](32);}while((k|0)>(g|0))}if(b){b=o;do{b=b+ -1|0;Yd[c[21038]&255](48);}while((b|0)>0)}b=a[m]|0;do{if((b&240|0)==0){Yd[c[21038]&255](a[89968+(b&15)|0]|0);if(l){i=h;return}else{p=m+ -1|0;break}}else{p=m}}while(0);while(1){Yd[c[21038]&255](a[89968+((d[p]|0)>>>4)|0]|0);Yd[c[21038]&255](a[89968+(a[p]&15)|0]|0);if((p|0)==(j|0)){break}p=p+ -1|0}i=h;return}function BG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[a>>2]|0;switch(e|0){case 11:{f=CG(c[a+8>>2]|0)|0;i=b;return f|0};case 12:{f=DG(c[a+4>>2]|0,c[a+8>>2]|0)|0;i=b;return f|0};case 5:{f=se[c[21046]&7]()|0;i=b;return f|0};case 13:{g=(c[21050]|0)-(c[a+4>>2]|0)|0;h=0-(c[21048]|0)|0;c[21050]=(g|0)<(h|0)?h:g;f=1;i=b;return f|0};case 4:case 14:{c[21050]=(c[21050]|0)+(c[a+4>>2]|0);f=1;i=b;return f|0};case 15:{c[21050]=(c[a+4>>2]|0)+ -1-(c[21048]|0);f=1;i=b;return f|0};default:{f=c[r>>2]|0;c[d>>2]=e;od(f|0,89936,d|0)|0;FF(c[20974]|0,1)}}return 0}function CG(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;do{if((c[21050]|0)!=0){e=uG()|0;if((e|0)==0){break}else{f=e}i=d;return f|0}}while(0);e=a[b]|0;g=b+1|0;h=a[g]|0;if(h<<24>>24==0){f=1;i=d;return f|0}else{j=g;k=h;l=b}while(1){if(k<<24>>24==e<<24>>24){b=l+2|0;if(!((a[b]|0)==e<<24>>24)){f=1;m=9;break}Yd[c[21038]&255](e<<24>>24);n=b}else{Yd[c[21038]&255](k<<24>>24);n=j}b=n+1|0;h=a[b]|0;if(h<<24>>24==0){f=1;m=9;break}else{j=b;k=h;l=n}}if((m|0)==9){i=d;return f|0}return 0}function DG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;do{if((c[21050]|0)!=0){f=uG()|0;if((f|0)==0){break}else{g=f}i=e;return g|0}}while(0);if((b|0)==0){g=1;i=e;return g|0}else{h=d;j=b}while(1){b=j+ -1|0;Yd[c[21038]&255](a[h]|0);if((b|0)==0){g=1;break}else{j=b;h=h+1|0}}i=e;return g|0}function EG(){var a=0,b=0;a=i;b=gG(10)|0;c[21050]=0;c[21048]=0;c[21052]=0;i=a;return(b|0)==0|0}function FG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((c[21024]|0)==0){RF()}c[20988]=0;c[20994]=1;c[21002]=1;c[21012]=1;d=mG(a)|0;if((d|0)!=0){e=d;i=b;return e|0}c[21030]=a;c[21048]=0;c[21050]=0;c[21052]=0;c[22302]=0;c[21054]=0;d=c[a+12>>2]|0;c[20974]=d;c[21026]=c[c[19748]>>2];if((UF(d)|0)<0){if((c[a>>2]|0)==0){QF(100,90016);e=100;i=b;return e|0}else{c[(Lc()|0)>>2]=100;e=100;i=b;return e|0}}c[21038]=169;c[21040]=43;c[21042]=111;c[21028]=4;c[21044]=5;c[21046]=6;ZF();c[21034]=0;d=c[19748]|0;c[21036]=c[d+32>>2];if((c[d+40>>2]|0)==1){e=0;i=b;return e|0}if((SF(d)|0)==0){e=0;i=b;return e|0}d=(c[a>>2]|0)==0;a=Lc()|0;f=c[a>>2]|0;if(d){QF(f,90024);e=c[a>>2]|0;i=b;return e|0}else{c[a>>2]=f;e=f;i=b;return e|0}return 0}function GG(){var a=0,b=0;a=i;if((c[22302]|0)==0){b=gG(10)|0}else{gG(0)|0;md(c[21026]|0)|0;b=0}c[21050]=0;c[21048]=0;c[21052]=0;i=a;return b|0}function HG(){var a=0,b=0,d=0;a=i;if((c[22286]|0)==0){b=0}else{d=gG(10)|0;c[22286]=0;b=d}c[21050]=0;c[21048]=0;c[21052]=0;i=a;return b|0}function IG(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;cH(90752,h,90808);c[22510]=92260;c[90048>>2]=92280;c[90044>>2]=0;VI(90048|0,90752);c[90120>>2]=0;c[90124>>2]=-1;j=c[t>>2]|0;c[22714]=92128;DO(90860|0);k=90864|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[22714]=91368;c[90888>>2]=j;EO(g,90860|0);k=HO(g,94920)|0;l=k;FO(g);c[90892>>2]=l;c[90896>>2]=90816;a[90900|0]=($d[c[(c[k>>2]|0)+28>>2]&127](l)|0)&1;c[22532]=92340;c[90132>>2]=92360;VI(90132|0,90856);c[90204>>2]=0;c[90208>>2]=-1;l=c[r>>2]|0;c[22726]=92128;DO(90908|0);k=90912|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[22726]=91368;c[90936>>2]=l;EO(f,90908|0);k=HO(f,94920)|0;g=k;FO(f);c[90940>>2]=g;c[90944>>2]=90824;a[90948|0]=($d[c[(c[k>>2]|0)+28>>2]&127](g)|0)&1;c[22554]=92340;c[90220>>2]=92360;VI(90220|0,90904);c[90292>>2]=0;c[90296>>2]=-1;g=c[(c[(c[22554]|0)+ -12>>2]|0)+90240>>2]|0;c[22576]=92340;c[90308>>2]=92360;VI(90308|0,g);c[90380>>2]=0;c[90384>>2]=-1;c[(c[(c[22510]|0)+ -12>>2]|0)+90112>>2]=90128;g=(c[(c[22554]|0)+ -12>>2]|0)+90220|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[22554]|0)+ -12>>2]|0)+90288>>2]=90128;QG(90952,h,90832|0);c[22598]=92300;c[90400>>2]=92320;c[90396>>2]=0;VI(90400|0,90952);c[90472>>2]=0;c[90476>>2]=-1;c[22752]=92192;DO(91012|0);h=91016|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[22752]=91112;c[91040>>2]=j;EO(e,91012|0);j=HO(e,94928)|0;h=j;FO(e);c[91044>>2]=h;c[91048>>2]=90840;a[91052|0]=($d[c[(c[j>>2]|0)+28>>2]&127](h)|0)&1;c[22620]=92380;c[90484>>2]=92400;VI(90484|0,91008);c[90556>>2]=0;c[90560>>2]=-1;c[22764]=92192;DO(91060|0);h=91064|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[22764]=91112;c[91088>>2]=l;EO(d,91060|0);l=HO(d,94928)|0;h=l;FO(d);c[91092>>2]=h;c[91096>>2]=90848;a[91100|0]=($d[c[(c[l>>2]|0)+28>>2]&127](h)|0)&1;c[22642]=92380;c[90572>>2]=92400;VI(90572|0,91056);c[90644>>2]=0;c[90648>>2]=-1;h=c[(c[(c[22642]|0)+ -12>>2]|0)+90592>>2]|0;c[22664]=92380;c[90660>>2]=92400;VI(90660|0,h);c[90732>>2]=0;c[90736>>2]=-1;c[(c[(c[22598]|0)+ -12>>2]|0)+90464>>2]=90480;h=(c[(c[22642]|0)+ -12>>2]|0)+90572|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[22642]|0)+ -12>>2]|0)+90640>>2]=90480;i=b;return}function JG(a){a=a|0;a=i;TJ(90128)|0;TJ(90304)|0;_J(90480)|0;_J(90656)|0;i=a;return}function KG(a){a=a|0;var b=0;b=i;c[a>>2]=92192;FO(a+4|0);i=b;return}function LG(a){a=a|0;var b=0;b=i;c[a>>2]=92192;FO(a+4|0);iS(a);i=b;return}function MG(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;$d[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=HO(d,94928)|0;d=f;c[b+36>>2]=d;a[b+44|0]=($d[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function NG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=oe[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((pc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((md(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function OG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((a[b+44|0]|0)!=0){g=pc(d|0,4,e|0,c[b+32>>2]|0)|0;i=f;return g|0}if((e|0)>0){h=d;j=0}else{g=0;i=f;return g|0}while(1){if((ne[c[(c[b>>2]|0)+52>>2]&63](b,c[h>>2]|0)|0)==-1){g=j;k=6;break}d=j+1|0;if((d|0)<(e|0)){h=h+4|0;j=d}else{g=d;k=6;break}}if((k|0)==6){i=f;return g|0}return 0}function PG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){c[g>>2]=d;if((a[b+44|0]|0)!=0){if((pc(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=we[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((pc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((pc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function QG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=92192;j=b+4|0;DO(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=91224;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;EO(g,j);j=HO(g,94928)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=$d[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=($d[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){PN(91320)}else{FO(g);i=f;return}}function RG(a){a=a|0;var b=0;b=i;c[a>>2]=92192;FO(a+4|0);i=b;return}function SG(a){a=a|0;var b=0;b=i;c[a>>2]=92192;FO(a+4|0);iS(a);i=b;return}function TG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=HO(d,94928)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=$d[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=($d[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){PN(91320)}else{i=e;return}}function UG(a){a=a|0;var b=0,c=0;b=i;c=XG(a,0)|0;i=b;return c|0}function VG(a){a=a|0;var b=0,c=0;b=i;c=XG(a,1)|0;i=b;return c|0}function WG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f;q=we[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((jd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function XG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]|0)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;a:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=$c(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break a}}i=e;return n|0}}while(0);b:do{if((a[b+53|0]|0)==0){l=b+40|0;m=b+36|0;o=f;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=we[c[(c[t>>2]|0)+16>>2]&15](t,s,o,w,h,g,p,j)|0;if((x|0)==2){n=-1;y=22;break}else if((x|0)==3){y=14;break}else if((x|0)!=1){z=r;break b}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=22;break}v=$c(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=22;break}a[w]=v;r=r+1|0}if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==22){i=e;return n|0}}else{c[g>>2]=a[f]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b+ -1|0;if((jd(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=22;break}else{b=z}}if((y|0)==22){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function YG(a){a=a|0;var b=0;b=i;c[a>>2]=92128;FO(a+4|0);i=b;return}function ZG(a){a=a|0;var b=0;b=i;c[a>>2]=92128;FO(a+4|0);iS(a);i=b;return}function _G(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;$d[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=HO(d,94920)|0;d=f;c[b+36>>2]=d;a[b+44|0]=($d[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function $G(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=oe[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((pc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((md(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function aH(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((a[b+44|0]|0)!=0){h=pc(e|0,1,f|0,c[b+32>>2]|0)|0;i=g;return h|0}if((f|0)>0){j=e;k=0}else{h=0;i=g;return h|0}while(1){if((ne[c[(c[b>>2]|0)+52>>2]&63](b,d[j]|0)|0)==-1){h=k;l=6;break}e=k+1|0;if((e|0)<(f|0)){j=j+1|0;k=e}else{h=e;l=6;break}}if((l|0)==6){i=g;return h|0}return 0}function bH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){a[g]=d;if((a[b+44|0]|0)!=0){if((pc(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=we[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((pc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((pc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function cH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=92128;j=b+4|0;DO(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=91480;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;EO(g,j);j=HO(g,94920)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=$d[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=($d[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){PN(91320)}else{FO(g);i=f;return}}function dH(a){a=a|0;var b=0;b=i;c[a>>2]=92128;FO(a+4|0);i=b;return}function eH(a){a=a|0;var b=0;b=i;c[a>>2]=92128;FO(a+4|0);iS(a);i=b;return}function fH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=HO(d,94920)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=$d[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=($d[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){PN(91320)}else{i=e;return}}function gH(a){a=a|0;var b=0,c=0;b=i;c=jH(a,0)|0;i=b;return c|0}function hH(a){a=a|0;var b=0,c=0;b=i;c=jH(a,1)|0;i=b;return c|0}function iH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f;q=we[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((jd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function jH(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]|0)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;a:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=$c(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break a}}i=f;return o|0}}while(0);b:do{if((a[b+53|0]|0)==0){m=b+40|0;n=b+36|0;p=g;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=we[c[(c[u>>2]|0)+16>>2]&15](u,t,p,x,j,h,q,k)|0;if((y|0)==2){o=-1;z=23;break}else if((y|0)==3){z=14;break}else if((y|0)!=1){A=s;break b}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=23;break}w=$c(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=23;break}a[x]=w;s=s+1|0}if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==23){i=f;return o|0}}else{a[h]=a[g]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k+ -1|0;if((jd(d[g+j|0]|0,c[l>>2]|0)|0)==-1){o=-1;z=23;break}else{k=j}}if((z|0)==21){B=a[h]|0;break}else if((z|0)==23){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function kH(){var a=0;a=i;IG(0);Qd(170,90744,q|0)|0;i=a;return}function lH(a){a=a|0;i=i;return}function mH(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=1+(c[b>>2]|0);i=i;return}function nH(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=-1+e;if((e|0)!=0){f=0;i=b;return f|0}Yd[c[(c[a>>2]|0)+8>>2]&255](a);f=1;i=b;return f|0}function oH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=91624;e=ES(b|0)|0;f=hS(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;GS(g|0,b|0,e+1|0)|0;i=d;return}function pH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=91624;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;yb(h|0);j=a;iS(j);i=b;return}jS((c[d>>2]|0)+ -12|0);g=a;h=g;yb(h|0);j=a;iS(j);i=b;return}function qH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=91624;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;yb(h|0);i=b;return}jS((c[d>>2]|0)+ -12|0);g=a;h=g;yb(h|0);i=b;return}function rH(a){a=a|0;i=i;return c[a+4>>2]|0}function sH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;c[b>>2]=91648;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=ES(f|0)|0;g=hS(d+13|0)|0;c[g+4>>2]=d;c[g>>2]=d;h=g+12|0;c[b+4>>2]=h;c[g+8>>2]=0;GS(h|0,f|0,d+1|0)|0;i=e;return}function tH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=91648;e=ES(b|0)|0;f=hS(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;GS(g|0,b|0,e+1|0)|0;i=d;return}function uH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=91648;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;yb(h|0);j=a;iS(j);i=b;return}jS((c[d>>2]|0)+ -12|0);g=a;h=g;yb(h|0);j=a;iS(j);i=b;return}function vH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=91648;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;yb(h|0);i=b;return}jS((c[d>>2]|0)+ -12|0);g=a;h=g;yb(h|0);i=b;return}function wH(a){a=a|0;i=i;return c[a+4>>2]|0}function xH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=91624;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;yb(h|0);j=a;iS(j);i=b;return}jS((c[d>>2]|0)+ -12|0);g=a;h=g;yb(h|0);j=a;iS(j);i=b;return}function yH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=91624;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;yb(h|0);j=a;iS(j);i=b;return}jS((c[d>>2]|0)+ -12|0);g=a;h=g;yb(h|0);j=a;iS(j);i=b;return}function zH(a){a=a|0;i=i;return}function AH(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;i=i;return}function BH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;ue[c[(c[a>>2]|0)+12>>2]&15](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function CH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+4>>2]|0)!=(a|0)){f=0;i=e;return f|0}f=(c[b>>2]|0)==(d|0);i=e;return f|0}function DH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=Nd(e|0)|0;e=ES(f|0)|0;if(e>>>0>4294967279){JH(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0;GS(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}else{l=e+16&-16;m=gS(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=e;g=m;GS(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}}function EH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=d;j=c[h>>2]|0;k=e;do{if((j|0)!=0){l=a[e]|0;if((l&1)==0){m=(l&255)>>>1}else{m=c[e+4>>2]|0}if((m|0)==0){n=j}else{oI(e,91864,2)|0;n=c[h>>2]|0}l=c[d+4>>2]|0;ue[c[(c[l>>2]|0)+24>>2]&15](g,l,n);l=a[g]|0;if((l&1)==0){o=g+1|0;p=(l&255)>>>1}else{o=c[g+8>>2]|0;p=c[g+4>>2]|0}oI(e,o,p)|0;if((a[g]&1)==0){break}iS(c[g+8>>2]|0)}}while(0);g=b;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;i=f;return}function FH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=ES(e|0)|0;if(j>>>0>4294967279){JH(0)}if(j>>>0<11){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=gS(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}GS(k|0,e|0,j|0)|0;a[k+j|0]=0;EH(g,d,h);sH(b,g);if(!((a[g]&1)==0)){iS(c[g+8>>2]|0)}if(!((a[h]&1)==0)){iS(c[h+8>>2]|0)}c[b>>2]=91880;h=d;d=c[h+4>>2]|0;g=b+8|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;i=f;return}function GH(a){a=a|0;var b=0;b=i;vH(a);iS(a);i=b;return}function HH(a){a=a|0;var b=0;b=i;vH(a);i=b;return}function IH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;rc(92016)|0;if((c[a>>2]|0)==1){do{hd(92040,92016)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)==0){c[a>>2]=1;ec(92016)|0;Yd[d&255](b);rc(92016)|0;c[a>>2]=-1;ec(92016)|0;Yc(92040)|0;i=e;return}else{ec(92016)|0;i=e;return}}function JH(a){a=a|0;a=Cc(8)|0;oH(a,92088);c[a>>2]=91704;Kd(a|0,91744,40)}function KH(a){a=a|0;a=Cc(8)|0;oH(a,92088);c[a>>2]=91768;Kd(a|0,91808,40)}function LH(a){a=a|0;var b=0,d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function MH(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function NH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d;if((a[d]&1)==0){g=b;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];i=e;return}f=c[d+8>>2]|0;g=c[d+4>>2]|0;if(g>>>0>4294967279){JH(0)}if(g>>>0<11){a[b]=g<<1;h=b+1|0}else{d=g+16&-16;j=gS(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=g;h=j}GS(h|0,f|0,g|0)|0;a[h+g|0]=0;i=e;return}function OH(b){b=b|0;i=i;return(a[b]&1)!=0|0}function PH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>4294967279){JH(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0}else{h=e+16&-16;j=gS(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}GS(g|0,d|0,e|0)|0;a[g+e|0]=0;i=f;return}function QH(a){a=a|0;i=i;return a|0}function RH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=ES(d|0)|0;if(f>>>0>4294967279){JH(0)}if(f>>>0<11){a[b]=f<<1;g=b+1|0;GS(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}else{l=f+16&-16;m=gS(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=f;g=m;GS(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}}function SH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>4294967279){JH(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0}else{h=d+16&-16;j=gS(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}IS(g|0,e|0,d|0)|0;a[g+d|0]=0;i=f;return}function TH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if(d>>>0>4294967279){JH(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0;IS(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}else{l=d+16&-16;m=gS(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=d;g=m;IS(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}}function UH(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=a[d]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[d+4>>2]|0}if(k>>>0<e>>>0){KH(0)}if(j){l=d+1|0}else{l=c[d+8>>2]|0}d=l+e|0;l=k-e|0;e=l>>>0<f>>>0?l:f;if(e>>>0>4294967279){JH(0)}if(e>>>0<11){a[b]=e<<1;m=b+1|0;GS(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}else{f=e+16&-16;l=gS(f)|0;c[b+8>>2]=l;c[b>>2]=f|1;c[b+4>>2]=e;m=l;GS(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}}function VH(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function WH(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function XH(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}iS(c[b+8>>2]|0);i=d;return}function YH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((b|0)==(d|0)){i=e;return b|0}f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=a[b]|0;if((d&1)==0){j=d;k=10}else{d=c[b>>2]|0;j=d&255;k=(d&-2)+ -1|0}d=(j&1)==0;if(k>>>0<h>>>0){if(d){l=(j&255)>>>1}else{l=c[b+4>>2]|0}pI(b,k,h-k|0,l,0,l,h,g);i=e;return b|0}if(d){m=b+1|0}else{m=c[b+8>>2]|0}HS(m|0,g|0,h|0)|0;a[m+h|0]=0;if((a[b]&1)==0){a[b]=h<<1;i=e;return b|0}else{c[b+4>>2]=h;i=e;return b|0}return 0}function ZH(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=_H(a,b)|0;i=c;return d|0}function _H(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=ES(d|0)|0;g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}g=(h&1)==0;if(j>>>0<f>>>0){if(g){k=(h&255)>>>1}else{k=c[b+4>>2]|0}pI(b,j,f-j|0,k,0,k,f,d);i=e;return b|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}HS(l|0,d|0,f|0)|0;a[l+f|0]=0;if((a[b]&1)==0){a[b]=f<<1;i=e;return b|0}else{c[b+4>>2]=f;i=e;return b|0}return 0}function $H(a,b){a=a|0;b=b|0;c[a+4>>2]=b;i=i;return}function aI(a){a=a|0;i=i;return a+1|0}function bI(b,c){b=b|0;c=c|0;a[b]=c<<1;i=i;return}function cI(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function dI(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=10;i=d;return e|0}e=(c[b>>2]&-2)+ -1|0;i=d;return e|0}function eI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){fI(b,d-j|0,e)|0;i=f;return}if(h){a[b+1+d|0]=0;a[b]=d<<1;i=f;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=f;return}}function fI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)==0){i=f;return b|0}g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}if((h&1)==0){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if((j-k|0)>>>0<d>>>0){qI(b,j,d-j+k|0,k,k,0,0);l=a[b]|0}else{l=h}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}IS(m+k|0,e|0,d|0)|0;e=k+d|0;if((a[b]&1)==0){a[b]=e<<1}else{c[b+4>>2]=e}a[m+e|0]=0;i=f;return b|0}function gI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}if(h>>>0<d>>>0){fI(b,d-h|0,0)|0;i=e;return}if(g){a[b+1+d|0]=0;a[b]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=e;return}}function hI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>4294967279){JH(0)}f=a[b]|0;if((f&1)==0){g=f;h=10}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<11){k=10}else{k=(f+16&-16)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==10){l=b+1|0;m=0;n=c[b+8>>2]|0;o=1}else{f=k+1|0;if(k>>>0>h>>>0){p=gS(f)|0}else{p=gS(f)|0}if((g&1)==0){l=p;m=1;n=b+1|0;o=0;break}else{l=p;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}GS(l|0,n|0,q+1|0)|0;if(o){iS(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function iI(a){a=a|0;var b=0;if(a>>>0<11){b=10}else{b=(a+16&-16)+ -1|0}i=i;return b|0}function jI(a,b){a=a|0;b=b|0;c[a>>2]=b|1;i=i;return}function kI(a,b){a=a|0;b=b|0;c[a+8>>2]=b;i=i;return}function lI(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){a[b+1|0]=0;a[b]=0;i=d;return}else{a[c[b+8>>2]|0]=0;c[b+4>>2]=0;i=d;return}}function mI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=oI(b,g,h)|0;i=e;return d|0}function nI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=10;j=(f&255)>>>1}if((j|0)==(h|0)){qI(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+1|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}a[l+j|0]=d;a[l+m|0]=0;i=e;return}function oI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}if((j&1)==0){k=(j&255)>>>1}else{k=c[b+4>>2]|0}if((h-k|0)>>>0<e>>>0){pI(b,h,e-h+k|0,k,k,0,e,d);i=f;return b|0}if((e|0)==0){i=f;return b|0}if((j&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}GS(l+k|0,d|0,e|0)|0;d=k+e|0;if((a[b]&1)==0){a[b]=d<<1}else{c[b+4>>2]=d}a[l+d|0]=0;i=f;return b|0}function pI(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((-18-d|0)>>>0<e>>>0){JH(0)}if((a[b]&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}do{if(d>>>0<2147483623){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<11){q=11;break}q=p+16&-16}else{q=-17}}while(0);e=gS(q)|0;if((g|0)!=0){GS(e|0,m|0,g|0)|0}if((j|0)!=0){GS(e+g|0,k|0,j|0)|0}k=f-h|0;if((k|0)!=(g|0)){GS(e+(j+g)|0,m+(h+g)|0,k-g|0)|0}if((d|0)!=10){iS(m)}c[b+8>>2]=e;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;a[e+q|0]=0;i=l;return}function qI(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((-17-d|0)>>>0<e>>>0){JH(0)}if((a[b]&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}do{if(d>>>0<2147483623){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<11){p=11;break}p=o+16&-16}else{p=-17}}while(0);e=gS(p)|0;if((g|0)!=0){GS(e|0,l|0,g|0)|0}o=f-h|0;if((o|0)!=(g|0)){GS(e+(j+g)|0,l+(h+g)|0,o-g|0)|0}if((d|0)==10){q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}iS(l);q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function rI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;UH(a,b,c,d,0);i=e;return}function sI(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function tI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=ES(d|0)|0;h=a[b]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if(k>>>0<e>>>0|(k-e|0)>>>0<g>>>0){l=-1;i=f;return l|0}if((g|0)==0){l=e;i=f;return l|0}if(j){m=b+1|0}else{m=c[b+8>>2]|0}b=m+e|0;j=m+k|0;h=d+g|0;if((j-b|0)<(g|0)){l=-1;i=f;return l|0}n=k+(1-g)|0;g=m+n|0;if((n|0)==(e|0)){l=-1;i=f;return l|0}e=a[d]|0;n=b;a:while(1){if((a[n]|0)==e<<24>>24){b=n;k=d;do{k=k+1|0;if((k|0)==(h|0)){break a}b=b+1|0;}while((a[b]|0)==(a[k]|0))}k=n+1|0;if((k|0)==(g|0)){l=-1;o=18;break}else{n=k}}if((o|0)==18){i=f;return l|0}if((n|0)==(j|0)){l=-1;i=f;return l|0}l=n-m|0;i=f;return l|0}function uI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}f=a[d]|0;j=(f&1)==0;if(j){k=(f&255)>>>1}else{k=c[d+4>>2]|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}if(j){m=d+1|0}else{m=c[d+8>>2]|0}d=k>>>0<h>>>0;j=zS(l,m,d?k:h)|0;if((j|0)==0){i=e;return(h>>>0<k>>>0?-1:d&1)|0}else{i=e;return j|0}return 0}function vI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=ES(d|0)|0;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if((f|0)==-1){KH(0)}if(h){k=b+1|0}else{k=c[b+8>>2]|0}b=j>>>0>f>>>0;h=zS(k,d,b?f:j)|0;if((h|0)==0){i=e;return(j>>>0<f>>>0?-1:b&1)|0}else{i=e;return h|0}return 0}function wI(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(f>>>0>4294967279){JH(0)}if(f>>>0<11){a[b]=e<<1;h=b+1|0;GS(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}else{m=f+16&-16;f=gS(m)|0;c[b+8>>2]=f;c[b>>2]=m|1;c[b+4>>2]=e;h=f;GS(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}}function xI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>1073741807){JH(0)}if(e>>>0<2){a[b]=e<<1;g=b+4|0}else{h=e+4&-4;j=gS(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}DR(g,d,e)|0;c[g+(e<<2)>>2]=0;i=f;return}function yI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>1073741807){JH(0)}if(d>>>0<2){a[b]=d<<1;g=b+4|0}else{h=d+4&-4;j=gS(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}FR(g,e,d)|0;c[g+(d<<2)>>2]=0;i=f;return}function zI(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}iS(c[b+8>>2]|0);i=d;return}function AI(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BI(a,b,CR(b)|0)|0;i=c;return d|0}function BI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=1;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g){k=(j&255)>>>1}else{k=c[b+4>>2]|0}EI(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g){l=b+4|0}else{l=c[b+8>>2]|0}ER(l,d,e)|0;c[l+(e<<2)>>2]=0;if((a[b]&1)==0){a[b]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function CI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>1073741807){JH(0)}f=a[b]|0;if((f&1)==0){g=f;h=1}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<2){k=1}else{k=(f+4&-4)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==1){l=b+4|0;m=0;n=c[b+8>>2]|0;o=1}else{f=(k<<2)+4|0;if(k>>>0>h>>>0){p=gS(f)|0}else{p=gS(f)|0}f=p;if((g&1)==0){l=f;m=1;n=b+4|0;o=0;break}else{l=f;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}DR(l,n,q+1|0)|0;if(o){iS(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function DI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=1;j=(f&255)>>>1}if((j|0)==(h|0)){FI(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+4|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}c[l+(j<<2)>>2]=d;c[l+(m<<2)>>2]=0;i=e;return}function EI(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((1073741806-d|0)>>>0<e>>>0){JH(0)}if((a[b]&1)==0){m=b+4|0}else{m=c[b+8>>2]|0}do{if(d>>>0<536870887){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<2){q=2;break}q=p+4&-4}else{q=1073741807}}while(0);e=gS(q<<2)|0;p=e;if((g|0)!=0){DR(p,m,g)|0}if((j|0)!=0){DR(e+(g<<2)|0,k,j)|0}k=f-h|0;if((k|0)!=(g|0)){DR(e+(j+g<<2)|0,m+(h+g<<2)|0,k-g|0)|0}if((d|0)!=1){iS(m)}c[b+8>>2]=p;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;c[e+(q<<2)>>2]=0;i=l;return}function FI(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((1073741807-d|0)>>>0<e>>>0){JH(0)}if((a[b]&1)==0){l=b+4|0}else{l=c[b+8>>2]|0}do{if(d>>>0<536870887){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<2){p=2;break}p=o+4&-4}else{p=1073741807}}while(0);e=gS(p<<2)|0;o=e;if((g|0)!=0){DR(o,l,g)|0}m=f-h|0;if((m|0)!=(g|0)){DR(e+(j+g<<2)|0,l+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}iS(l);q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function GI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;g=ES(d|0)|0;h=a[e]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[e+4>>2]|0}h=j+g|0;if(h>>>0>4294967279){JH(0)}if(h>>>0<11){a[b]=g<<1;k=b+1|0}else{l=h+16&-16;h=gS(l)|0;c[b+8>>2]=h;c[b>>2]=l|1;c[b+4>>2]=g;k=h}GS(k|0,d|0,g|0)|0;a[k+g|0]=0;if((a[e]&1)==0){m=e+1|0;n=oI(b,m,j)|0;i=f;return}else{m=c[e+8>>2]|0;n=oI(b,m,j)|0;i=f;return}}function HI(a){a=a|0;i=i;return(c[a+16>>2]&5|0)==0|0}function II(a){a=a|0;i=i;return(c[a+16>>2]&5|0)!=0|0}function JI(a,b){a=a|0;b=b|0;var c=0;c=i;KI(a,b);i=c;return}function KI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(c[b+24>>2]|0)==0;if(h){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((h&1|d)&c[b+20>>2]|0)==0){i=e;return}e=Cc(16)|0;do{if((a[92472]|0)==0){if((Ya(92472)|0)==0){break}c[23116]=93168;Qd(66,92464,q|0)|0;Rb(92472)}}while(0);b=e;d=g;c[d>>2]=1;c[d+4>>2]=92464;d=f;h=g;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];FH(b,f,92520);c[e>>2]=92488;Kd(e|0,92568,62)}function LI(a,b){a=a|0;b=b|0;var d=0;d=i;KI(a,c[a+16>>2]|b);i=d;return}function MI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=92512;d=c[a+40>>2]|0;e=a+32|0;f=a+36|0;if((d|0)!=0){g=d;do{g=g+ -1|0;ue[c[(c[e>>2]|0)+(g<<2)>>2]&15](0,a,c[(c[f>>2]|0)+(g<<2)>>2]|0);}while((g|0)!=0)}FO(a+28|0);bS(c[e>>2]|0);bS(c[f>>2]|0);bS(c[a+48>>2]|0);bS(c[a+60>>2]|0);i=b;return}function NI(a){a=a|0;var b=0;b=i;MI(a);iS(a);i=b;return}function OI(a){a=a|0;var b=0;b=i;MI(a);i=b;return}function PI(a){a=a|0;var b=0;b=i;MI(a);i=b;return}function QI(a){a=a|0;i=i;return c[a+24>>2]|0}function RI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+76|0;f=c[e>>2]|0;if(!((f|0)==-1)){g=f&255;i=b;return g|0}EO(d,a+28|0);a=HO(d,94856)|0;f=ne[c[(c[a>>2]|0)+28>>2]&63](a,32)|0;FO(d);c[e>>2]=f<<24>>24;g=f;i=b;return g|0}function SI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;EO(e,a+28|0);a=HO(e,94856)|0;f=ne[c[(c[a>>2]|0)+28>>2]&63](a,b)|0;FO(e);i=d;return f|0}function TI(a,b){a=a|0;b=b|0;var c=0;c=i;EO(a,b+28|0);i=c;return}function UI(a){a=a|0;c[a>>2]=92112;i=i;return}function VI(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;e=a+32|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));DO(b);i=d;return}function WI(a){a=a|0;var b=0;b=i;c[a>>2]=92128;FO(a+4|0);iS(a);i=b;return}function XI(a){a=a|0;var b=0;b=i;c[a>>2]=92128;FO(a+4|0);i=b;return}function YI(a){a=a|0;var b=0;b=i;c[a>>2]=92128;FO(a+4|0);i=b;return}function ZI(a,b){a=a|0;b=b|0;var c=0;c=i;EO(a,b+4|0);i=c;return}function _I(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;e=a+12|0;f=c[e>>2]|0;if((f|0)==(c[a+16>>2]|0)){g=$d[c[(c[a>>2]|0)+40>>2]&127](a)|0;i=b;return g|0}else{c[e>>2]=f+1;g=d[f]|0;i=b;return g|0}return 0}function $I(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==(c[b+28>>2]|0)){h=ne[c[(c[b>>2]|0)+52>>2]&63](b,d&255)|0;i=e;return h|0}else{c[f>>2]=g+1;a[g]=d;h=d&255;i=e;return h|0}return 0}function aJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=be[c[(c[a>>2]|0)+48>>2]&63](a,b,d)|0;i=e;return f|0}function bJ(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=92128;DO(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function cJ(a){a=a|0;i=i;return c[a+8>>2]|0}function dJ(a){a=a|0;i=i;return c[a+12>>2]|0}function eJ(a){a=a|0;i=i;return c[a+16>>2]|0}function fJ(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function gJ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;i=i;return}function hJ(a){a=a|0;i=i;return c[a+20>>2]|0}function iJ(a){a=a|0;i=i;return c[a+24>>2]|0}function jJ(a){a=a|0;i=i;return c[a+28>>2]|0}function kJ(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function lJ(a,b,d){a=a|0;b=b|0;d=d|0;c[a+24>>2]=b;c[a+20>>2]=b;c[a+28>>2]=d;i=i;return}function mJ(a,b){a=a|0;b=b|0;i=i;return}function nJ(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function oJ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function pJ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function qJ(a){a=a|0;i=i;return 0}function rJ(a){a=a|0;i=i;return 0}function sJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((e|0)<=0){g=0;i=f;return g|0}h=b+12|0;j=b+16|0;k=d;d=0;while(1){l=c[h>>2]|0;if(l>>>0<(c[j>>2]|0)>>>0){c[h>>2]=l+1;m=a[l]|0}else{l=$d[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((l|0)==-1){g=d;n=8;break}m=l&255}a[k]=m;l=d+1|0;if((l|0)<(e|0)){k=k+1|0;d=l}else{g=l;n=8;break}}if((n|0)==8){i=f;return g|0}return 0}function tJ(a){a=a|0;i=i;return-1}function uJ(a){a=a|0;var b=0,e=0,f=0;b=i;if(($d[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){e=-1;i=b;return e|0}f=a+12|0;a=c[f>>2]|0;c[f>>2]=a+1;e=d[a]|0;i=b;return e|0}function vJ(a,b){a=a|0;b=b|0;i=i;return-1}function wJ(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((f|0)<=0){h=0;i=g;return h|0}j=b+24|0;k=b+28|0;l=e;e=0;while(1){m=c[j>>2]|0;if(m>>>0<(c[k>>2]|0)>>>0){n=a[l]|0;c[j>>2]=m+1;a[m]=n}else{if((ne[c[(c[b>>2]|0)+52>>2]&63](b,d[l]|0)|0)==-1){h=e;o=7;break}}n=e+1|0;if((n|0)<(f|0)){l=l+1|0;e=n}else{h=n;o=7;break}}if((o|0)==7){i=g;return h|0}return 0}function xJ(a,b){a=a|0;b=b|0;i=i;return-1}function yJ(a){a=a|0;var b=0;b=i;c[a>>2]=92192;FO(a+4|0);iS(a);i=b;return}function zJ(a){a=a|0;var b=0;b=i;c[a>>2]=92192;FO(a+4|0);i=b;return}function AJ(a,b){a=a|0;b=b|0;i=i;return}function BJ(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function CJ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function DJ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function EJ(a){a=a|0;i=i;return 0}function FJ(a){a=a|0;i=i;return 0}function GJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+12|0;h=a+16|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[g>>2]=k+4;l=c[k>>2]|0}else{k=$d[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((k|0)==-1){f=b;m=8;break}else{l=k}}c[j>>2]=l;k=b+1|0;if((k|0)>=(d|0)){f=k;m=8;break}j=j+4|0;b=k}if((m|0)==8){i=e;return f|0}return 0}function HJ(a){a=a|0;i=i;return-1}function IJ(a){a=a|0;var b=0,d=0,e=0;b=i;if(($d[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){d=-1;i=b;return d|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+4;d=c[a>>2]|0;i=b;return d|0}function JJ(a,b){a=a|0;b=b|0;i=i;return-1}function KJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;h=a+28|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){l=c[j>>2]|0;c[g>>2]=k+4;c[k>>2]=l}else{if((ne[c[(c[a>>2]|0)+52>>2]&63](a,c[j>>2]|0)|0)==-1){f=b;m=8;break}}l=b+1|0;if((l|0)>=(d|0)){f=l;m=8;break}j=j+4|0;b=l}if((m|0)==8){i=e;return f|0}return 0}function LJ(a,b){a=a|0;b=b|0;i=i;return-1}function MJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];c[a+4>>2]=0;b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));DO(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function NJ(a){a=a|0;var b=0;b=i;MI(a+8|0);iS(a);i=b;return}function OJ(a){a=a|0;var b=0;b=i;MI(a+8|0);i=b;return}function PJ(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;MI(a+(d+8)|0);iS(a+d|0);i=b;return}function QJ(a){a=a|0;var b=0;b=i;MI(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function RJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;SJ(a,b,c);i=d;return}function SJ(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;h=g;j=d;a[j]=0;d=c[(c[e>>2]|0)+ -12>>2]|0;k=c[e+(d+16)>>2]|0;if((k|0)!=0){KI(e+d|0,k|4);i=g;return}k=c[e+(d+72)>>2]|0;if((k|0)!=0){TJ(k)|0}a:do{if(!f){k=c[(c[e>>2]|0)+ -12>>2]|0;if((c[e+(k+4)>>2]&4096|0)==0){break}EO(h,e+(k+28)|0);k=HO(h,94856)|0;FO(h);d=k+8|0;k=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;while(1){if((k|0)==0){break}if((c[k+12>>2]|0)==(c[k+16>>2]|0)){l=($d[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;m=l?0:k;if((m|0)==0){break}else{n=m}}else{n=k}m=n+12|0;l=c[m>>2]|0;o=n+16|0;if((l|0)==(c[o>>2]|0)){p=($d[c[(c[n>>2]|0)+36>>2]&127](n)|0)&255}else{p=a[l]|0}if(!(p<<24>>24>-1)){q=18;break}if((b[(c[d>>2]|0)+(p<<24>>24<<1)>>1]&8192)==0){q=18;break}l=c[m>>2]|0;if((l|0)==(c[o>>2]|0)){$d[c[(c[n>>2]|0)+40>>2]&127](n)|0;k=n;continue}else{c[m>>2]=l+1;k=n;continue}}do{if((q|0)==18){if((n|0)==0){break}if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){break a}if(!(($d[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1|(n|0)==0)){break a}}}while(0);k=c[(c[e>>2]|0)+ -12>>2]|0;KI(e+k|0,c[e+(k+16)>>2]|6)}}while(0);a[j]=(c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+16)>>2]|0)==0|0;i=g;return}function TJ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{TJ(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!(($d[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;KI(b+h|0,c[b+(h+16)>>2]|1)}}while(0);gK(e);i=d;return b|0}function UJ(b){b=b|0;i=i;return(a[b]|0)!=0|0}function VJ(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){i=i;return}else{Eb()}}function WJ(a){a=a|0;var b=0;b=i;MI(a+8|0);iS(a);i=b;return}function XJ(a){a=a|0;var b=0;b=i;MI(a+8|0);i=b;return}function YJ(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;MI(a+(d+8)|0);iS(a+d|0);i=b;return}function ZJ(a){a=a|0;var b=0;b=i;MI(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function _J(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{_J(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!(($d[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;KI(b+h|0,c[b+(h+16)>>2]|1)}}while(0);sK(e);i=d;return b|0}function $J(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));DO(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function aK(a){a=a|0;var b=0;b=i;MI(a+4|0);iS(a);i=b;return}function bK(a){a=a|0;var b=0;b=i;MI(a+4|0);i=b;return}function cK(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;MI(a+(d+4)|0);iS(a+d|0);i=b;return}function dK(a){a=a|0;var b=0;b=i;MI(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function eK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b;a[f]=0;c[b+4>>2]=d;b=c[(c[d>>2]|0)+ -12>>2]|0;if((c[d+(b+16)>>2]|0)!=0){i=e;return}g=c[d+(b+72)>>2]|0;if((g|0)!=0){TJ(g)|0}a[f]=1;i=e;return}function fK(a){a=a|0;var b=0;b=i;gK(a);i=b;return}function gK(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(cb()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!(($d[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;KI(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function hK(b){b=b|0;i=i;return(a[b]|0)!=0|0}function iK(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=$d[b&127](a)|0;i=c;return d|0}function jK(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=j;a[m]=0;c[j+4>>2]=b;n=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(n+16)>>2]|0)!=0){gK(j);i=e;return b|0}o=c[b+(n+72)>>2]|0;if((o|0)==0){p=n}else{TJ(o)|0;p=c[(c[b>>2]|0)+ -12>>2]|0}a[m]=1;EO(k,b+(p+28)|0);p=HO(k,93576)|0;m=p;FO(k);k=c[(c[b>>2]|0)+ -12>>2]|0;o=c[b+(k+24)>>2]|0;n=b+(k+76)|0;q=c[n>>2]|0;if((q|0)==-1){EO(h,b+(k+28)|0);r=HO(h,94856)|0;s=ne[c[(c[r>>2]|0)+28>>2]&63](r,32)|0;FO(h);c[n>>2]=s<<24>>24;t=s}else{t=q&255}q=b+k|0;k=c[(c[p>>2]|0)+32>>2]|0;c[g>>2]=o;o=f;p=g;c[o+0>>2]=c[p+0>>2];ee[k&7](l,m,f,q,t,d);if((c[l>>2]|0)!=0){gK(j);i=e;return b|0}l=c[(c[b>>2]|0)+ -12>>2]|0;KI(b+l|0,c[b+(l+16)>>2]|5);gK(j);i=e;return b|0}function kK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=f;a[g]=0;c[f+4>>2]=b;h=c[b>>2]|0;j=c[h+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){gK(f);i=e;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)==0){l=h;m=j}else{TJ(k)|0;k=c[b>>2]|0;l=k;m=c[k+ -12>>2]|0}a[g]=1;g=c[b+(m+24)>>2]|0;m=g;do{if((g|0)==0){n=l}else{k=g+24|0;j=c[k>>2]|0;if((j|0)!=(c[g+28>>2]|0)){c[k>>2]=j+1;a[j]=d;gK(f);i=e;return b|0}if((ne[c[(c[g>>2]|0)+52>>2]&63](m,d&255)|0)==-1){n=c[b>>2]|0;break}else{gK(f);i=e;return b|0}}}while(0);d=c[n+ -12>>2]|0;KI(b+d|0,c[b+(d+16)>>2]|1);gK(f);i=e;return b|0}



function lK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=g;a[h]=0;c[g+4>>2]=b;j=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){gK(g);i=f;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)!=0){TJ(k)|0}a[h]=1;if((e|0)==0){gK(g);i=f;return b|0}h=c[b+((c[(c[b>>2]|0)+ -12>>2]|0)+24)>>2]|0;if((be[c[(c[h>>2]|0)+48>>2]&63](h,d,e)|0)==(e|0)){gK(g);i=f;return b|0}e=c[(c[b>>2]|0)+ -12>>2]|0;KI(b+e|0,c[b+(e+16)>>2]|1);gK(g);i=f;return b|0}function mK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(e+16)>>2]&5|0)==0){f=c[b+(e+24)>>2]|0;he[c[(c[f>>2]|0)+16>>2]&31](a,f,0,0,1,16);i=d;return}else{f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;i=d;return}}function nK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=e;g=e+16|0;h=e+32|0;j=e+40|0;k=h;a[k]=0;c[h+4>>2]=b;l=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(l+16)>>2]|0)!=0){gK(h);i=e;return b|0}m=c[b+(l+72)>>2]|0;if((m|0)==0){n=l}else{TJ(m)|0;n=c[(c[b>>2]|0)+ -12>>2]|0}a[k]=1;k=c[b+(n+24)>>2]|0;n=k;m=d;d=g;l=c[(c[k>>2]|0)+20>>2]|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];m=f;d=g;c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];ye[l&31](j,n,f,16);f=j+8|0;if(!((c[f>>2]|0)==-1&(c[f+4>>2]|0)==-1)){gK(h);i=e;return b|0}f=c[(c[b>>2]|0)+ -12>>2]|0;KI(b+f|0,c[b+(f+16)>>2]|4);gK(h);i=e;return b|0}function oK(a){a=a|0;var b=0;b=i;MI(a+4|0);iS(a);i=b;return}function pK(a){a=a|0;var b=0;b=i;MI(a+4|0);i=b;return}function qK(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;MI(a+(d+4)|0);iS(a+d|0);i=b;return}function rK(a){a=a|0;var b=0;b=i;MI(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function sK(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(cb()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!(($d[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;KI(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function tK(a){a=a|0;i=i;return 92408}function uK(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((c|0)==1){PH(a,92424,35);i=d;return}else{DH(a,b,c);i=d;return}}function vK(a){a=a|0;i=i;return}function wK(a){a=a|0;var b=0;b=i;HH(a);iS(a);i=b;return}function xK(a){a=a|0;var b=0;b=i;HH(a);i=b;return}function yK(a){a=a|0;var b=0;b=i;MI(a);iS(a);i=b;return}function zK(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function AK(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function BK(a){a=a|0;i=i;return}function CK(a){a=a|0;i=i;return}function DK(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;a:do{if((e|0)==(f|0)){g=c;h=6}else{j=e;k=c;while(1){if((k|0)==(d|0)){l=-1;break a}m=a[k]|0;n=a[j]|0;if(m<<24>>24<n<<24>>24){l=-1;break a}if(n<<24>>24<m<<24>>24){l=1;break a}m=k+1|0;n=j+1|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=b;return l|0}function EK(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;g=e;h=f-g|0;if(h>>>0>4294967279){JH(b)}if(h>>>0<11){a[b]=h<<1;j=b+1|0}else{k=h+16&-16;l=gS(k)|0;c[b+8>>2]=l;c[b>>2]=k|1;c[b+4>>2]=h;j=l}if((e|0)==(f|0)){m=j;a[m]=0;i=d;return}else{n=e;o=j}while(1){a[o]=a[n]|0;e=n+1|0;if((e|0)==(f|0)){break}else{o=o+1|0;n=e}}m=j+(f+(0-g))|0;a[m]=0;i=d;return}function FK(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)==(d|0)){e=0;i=b;return e|0}else{f=0;g=c}while(1){c=(a[g]|0)+(f<<4)|0;h=c&-268435456;j=(h>>>24|h)^c;c=g+1|0;if((c|0)==(d|0)){e=j;break}else{g=c;f=j}}i=b;return e|0}function GK(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function HK(a){a=a|0;i=i;return}function IK(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;a:do{if((e|0)==(f|0)){g=b;h=6}else{j=e;k=b;while(1){if((k|0)==(d|0)){l=-1;break a}m=c[k>>2]|0;n=c[j>>2]|0;if((m|0)<(n|0)){l=-1;break a}if((n|0)<(m|0)){l=1;break a}m=k+4|0;n=j+4|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=a;return l|0}function JK(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;g=e;h=f-g|0;j=h>>2;if(j>>>0>1073741807){JH(b)}if(j>>>0<2){a[b]=h>>>1;k=b+4|0}else{h=j+4&-4;l=gS(h<<2)|0;c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;k=l}if((e|0)==(f|0)){m=k;c[m>>2]=0;i=d;return}l=f+ -4+(0-g)|0;g=e;e=k;while(1){c[e>>2]=c[g>>2];j=g+4|0;if((j|0)==(f|0)){break}else{e=e+4|0;g=j}}m=k+((l>>>2)+1<<2)|0;c[m>>2]=0;i=d;return}function KK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=0;i=a;return e|0}else{f=0;g=b}while(1){b=(c[g>>2]|0)+(f<<4)|0;h=b&-268435456;j=(h>>>24|h)^b;b=g+4|0;if((b|0)==(d|0)){e=j;break}else{g=b;f=j}}i=a;return e|0}function LK(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function MK(a){a=a|0;i=i;return}function NK(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];ke[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}TI(u,g);m=u;u=c[m>>2]|0;if(!((c[23714]|0)==-1)){c[p>>2]=94856;c[p+4>>2]=171;c[p+8>>2]=0;IH(94856,p,172)}p=(c[94860>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Cc(4)|0;D=C;HR(D);E=110416;F=127;Kd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Cc(4)|0;D=C;HR(D);E=110416;F=127;Kd(C|0,E|0,F|0)}F=u;nH(c[m>>2]|0)|0;TI(v,g);g=v;v=c[g>>2]|0;if(!((c[23750]|0)==-1)){c[o>>2]=95e3;c[o+4>>2]=171;c[o+8>>2]=0;IH(95e3,o,172)}o=(c[95004>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Cc(4)|0;H=G;HR(H);I=110416;J=127;Kd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Cc(4)|0;H=G;HR(H);I=110416;J=127;Kd(G|0,I|0,J|0)}J=v;nH(c[g>>2]|0)|0;g=w;Zd[c[(c[v>>2]|0)+24>>2]&63](g,J);Zd[c[(c[v>>2]|0)+28>>2]&63](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=OK(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];XH(w+12|0);XH(w);i=k;return}function OK(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=aS(l)|0;if((n|0)!=0){o=n;p=n;break}nS()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){y=r;break}if(($d[c[(c[r>>2]|0)+36>>2]&127](r)|0)==-1){c[l>>2]=0;y=0;break}else{y=c[l>>2]|0;break}}}while(0);r=(y|0)==0;t=c[b>>2]|0;do{if((t|0)==0){z=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){z=t;break}if(!(($d[c[(c[t>>2]|0)+36>>2]&127](t)|0)==-1)){z=t;break}c[b>>2]=0;z=0}}while(0);A=(z|0)==0;B=c[l>>2]|0;if(!((r^A)&(q|0)!=0)){break}t=c[B+12>>2]|0;if((t|0)==(c[B+16>>2]|0)){C=($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[t]|0}if(j){D=C}else{D=ne[c[(c[g>>2]|0)+12>>2]&63](g,C)|0}t=d+1|0;if(m){d=t;q=q;x=x;continue}b:do{if(j){w=0;s=e;n=x;v=q;u=p;while(1){do{if((a[u]|0)==1){E=a[s]|0;F=(E&1)==0;if(F){G=s+1|0}else{G=c[s+8>>2]|0}if(!(D<<24>>24==(a[G+d|0]|0))){a[u]=0;H=w;I=n;J=v+ -1|0;break}if(F){K=(E&255)>>>1}else{K=c[s+4>>2]|0}if((K|0)!=(t|0)){H=1;I=n;J=v;break}a[u]=2;H=1;I=n+1|0;J=v+ -1|0}else{H=w;I=n;J=v}}while(0);E=s+12|0;if((E|0)==(f|0)){L=H;M=I;N=J;break b}w=H;s=E;n=I;v=J;u=u+1|0}}else{u=0;v=e;n=x;s=q;w=p;while(1){do{if((a[w]|0)==1){if((a[v]&1)==0){O=v+1|0}else{O=c[v+8>>2]|0}if(!(D<<24>>24==(ne[c[(c[g>>2]|0)+12>>2]&63](g,a[O+d|0]|0)|0)<<24>>24)){a[w]=0;P=u;Q=n;R=s+ -1|0;break}E=a[v]|0;if((E&1)==0){S=(E&255)>>>1}else{S=c[v+4>>2]|0}if((S|0)!=(t|0)){P=1;Q=n;R=s;break}a[w]=2;P=1;Q=n+1|0;R=s+ -1|0}else{P=u;Q=n;R=s}}while(0);E=v+12|0;if((E|0)==(f|0)){L=P;M=Q;N=R;break b}u=P;v=E;n=Q;s=R;w=w+1|0}}}while(0);if(!L){d=t;x=M;q=N;continue}r=c[l>>2]|0;w=r+12|0;s=c[w>>2]|0;if((s|0)==(c[r+16>>2]|0)){$d[c[(c[r>>2]|0)+40>>2]&127](r)|0}else{c[w>>2]=s+1}if((N+M|0)>>>0<2){d=t;x=M;q=N;continue}else{T=e;U=M;V=p}while(1){do{if((a[V]|0)==2){s=a[T]|0;if((s&1)==0){W=(s&255)>>>1}else{W=c[T+4>>2]|0}if((W|0)==(t|0)){X=U;break}a[V]=0;X=U+ -1|0}else{X=U}}while(0);s=T+12|0;if((s|0)==(f|0)){d=t;x=X;q=N;continue a}else{T=s;U=X;V=V+1|0}}}do{if((B|0)==0){Y=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){Y=B;break}if(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[l>>2]=0;Y=0;break}else{Y=c[l>>2]|0;break}}}while(0);l=(Y|0)==0;do{if(A){Z=78}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){if(l){break}else{Z=80;break}}if(($d[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1){c[b>>2]=0;Z=78;break}else{if(l){break}else{Z=80;break}}}}while(0);if((Z|0)==78){if(l){Z=80}}if((Z|0)==80){c[h>>2]=c[h>>2]|2}c:do{if(m){Z=85}else{if((a[p]|0)==2){_=e;break}else{$=e;aa=p}while(1){l=$+12|0;b=aa+1|0;if((l|0)==(f|0)){Z=85;break c}if((a[b]|0)==2){_=l;break}else{aa=b;$=l}}}}while(0);if((Z|0)==85){c[h>>2]=c[h>>2]|4;_=f}if((o|0)==0){i=k;return _|0}bS(o);i=k;return _|0}function PK(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];QK(a,0,k,j,f,g,h);i=b;return}function QK(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;GL(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eI(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!(($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}eI(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}eI(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((gL(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=CQ(F,c[o>>2]|0,h,t)|0;TN(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!(($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;XH(n);XH(m);i=d;return}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;XH(n);XH(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;XH(n);XH(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;XH(n);XH(m);i=d;return}function RK(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];SK(a,0,k,j,f,g,h);i=b;return}function SK(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;GL(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eI(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!(($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}eI(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}eI(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((gL(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=BQ(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;TN(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!(($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;XH(n);XH(m);i=d;return}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;XH(n);XH(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;XH(n);XH(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;XH(n);XH(m);i=d;return}function TK(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];UK(a,0,k,j,f,g,h);i=b;return}function UK(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;l=e;m=e+32|0;n=e+40|0;o=e+56|0;p=e+72|0;q=e+80|0;r=e+240|0;s=e+248|0;t=c[h+4>>2]&74;if((t|0)==8){u=16}else if((t|0)==0){u=0}else if((t|0)==64){u=8}else{u=10}t=l;GL(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;eI(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=a[m]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){B=m;break}if(!(($d[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){B=m;break}c[l>>2]=0;B=0}}while(0);x=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){D=18}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){if(x){E=C;break}else{F=C;G=A;break a}}if(($d[c[(c[C>>2]|0)+36>>2]&127](C)|0)==-1){c[f>>2]=0;D=18;break}else{if(x){E=C;break}else{F=C;G=A;break a}}}}while(0);if((D|0)==18){D=0;if(x){F=0;G=A;break}else{E=0}}C=a[o]|0;H=(C&1)==0;if(H){I=(C&255)>>>1}else{I=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(I|0)){if(H){J=(C&255)>>>1;K=(C&255)>>>1}else{C=c[y>>2]|0;J=C;K=C}eI(o,K<<1,0);if((a[o]&1)==0){L=10}else{L=(c[g>>2]&-2)+ -1|0}eI(o,L,0);if((a[o]&1)==0){M=v}else{M=c[w>>2]|0}c[p>>2]=M+J;N=M}else{N=A}C=B+12|0;H=c[C>>2]|0;O=B+16|0;if((H|0)==(c[O>>2]|0)){P=($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{P=a[H]|0}if((gL(P,u,N,p,s,z,n,h,r,t)|0)!=0){F=E;G=N;break}H=c[C>>2]|0;if((H|0)==(c[O>>2]|0)){$d[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=N;continue}else{c[C>>2]=H+1;m=B;A=N;continue}}N=a[n]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[n+4>>2]|0}do{if((Q|0)!=0){N=c[r>>2]|0;if((N-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=N+4;c[N>>2]=A}}while(0);b[k>>1]=AQ(G,c[p>>2]|0,j,u)|0;TN(n,h,c[r>>2]|0,j);do{if((B|0)==0){R=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){R=B;break}if(!(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1)){R=B;break}c[l>>2]=0;R=0}}while(0);l=(R|0)==0;do{if((F|0)==0){D=54}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(!l){break}S=d;T=S;c[T>>2]=R;XH(o);XH(n);i=e;return}if(($d[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1){c[f>>2]=0;D=54;break}if(!(l^(F|0)==0)){break}S=d;T=S;c[T>>2]=R;XH(o);XH(n);i=e;return}}while(0);do{if((D|0)==54){if(l){break}S=d;T=S;c[T>>2]=R;XH(o);XH(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;S=d;T=S;c[T>>2]=R;XH(o);XH(n);i=e;return}function VK(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];WK(a,0,k,j,f,g,h);i=b;return}function WK(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;GL(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eI(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!(($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}eI(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}eI(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((gL(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=zQ(F,c[o>>2]|0,h,t)|0;TN(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!(($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;XH(n);XH(m);i=d;return}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;XH(n);XH(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;XH(n);XH(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;XH(n);XH(m);i=d;return}function XK(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];YK(a,0,k,j,f,g,h);i=b;return}function YK(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;GL(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eI(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!(($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}eI(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}eI(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((gL(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=yQ(F,c[o>>2]|0,h,t)|0;TN(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!(($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;XH(n);XH(m);i=d;return}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;XH(n);XH(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;XH(n);XH(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;XH(n);XH(m);i=d;return}function ZK(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];_K(a,0,k,j,f,g,h);i=b;return}function _K(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;GL(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eI(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!(($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}eI(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}eI(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((gL(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=xQ(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;TN(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!(($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;XH(n);XH(m);i=d;return}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;XH(n);XH(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;XH(n);XH(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;XH(n);XH(m);i=d;return}function $K(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];aL(a,0,k,j,f,g,h);i=b;return}function aL(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;HL(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;eI(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!(($d[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}eI(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}eI(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=($d[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((IL(R,t,u,P,p,B,l,n,h,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){$d[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);g[k>>2]=+wQ(I,c[p>>2]|0,j);TN(n,h,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!(($d[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;XH(o);XH(n);i=d;return}if(($d[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;XH(o);XH(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;XH(o);XH(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;XH(o);XH(n);i=d;return}function bL(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];cL(a,0,k,j,f,g,h);i=b;return}function cL(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;HL(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eI(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!(($d[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}eI(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}eI(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=($d[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((IL(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){$d[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+vQ(I,c[p>>2]|0,j);TN(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!(($d[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;XH(o);XH(n);i=d;return}if(($d[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;XH(o);XH(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;XH(o);XH(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;XH(o);XH(n);i=d;return}function dL(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];eL(a,0,k,j,f,g,h);i=b;return}function eL(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;HL(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eI(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!(($d[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}eI(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}eI(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=($d[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((IL(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){$d[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+uQ(I,c[p>>2]|0,j);TN(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!(($d[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;XH(o);XH(n);i=d;return}if(($d[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;XH(o);XH(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;XH(o);XH(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;XH(o);XH(n);i=d;return}function fL(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;TI(o,g);g=o;o=c[g>>2]|0;if(!((c[23714]|0)==-1)){c[l>>2]=94856;c[l+4>>2]=171;c[l+8>>2]=0;IH(94856,l,172)}l=(c[94860>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Cc(4)|0;w=v;HR(w);x=110416;y=127;Kd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Cc(4)|0;w=v;HR(w);x=110416;y=127;Kd(v|0,x|0,y|0)}y=m;xe[c[(c[o>>2]|0)+32>>2]&63](o,93400,93426|0,y)|0;nH(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eI(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){C=m;break}if(!(($d[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){C=m;break}c[r>>2]=0;C=0}}while(0);B=(C|0)==0;v=c[e>>2]|0;do{if((v|0)==0){D=19}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){if(B){break}else{E=x;break a}}if(($d[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1){c[e>>2]=0;D=19;break}else{if(B){break}else{E=x;break a}}}}while(0);if((D|0)==19){D=0;if(B){E=x;break}}v=a[p]|0;w=(v&1)==0;if(w){F=(v&255)>>>1}else{F=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(F|0)){if(w){G=(v&255)>>>1;H=(v&255)>>>1}else{v=c[o>>2]|0;G=v;H=v}eI(p,H<<1,0);if((a[p]&1)==0){I=10}else{I=(c[f>>2]&-2)+ -1|0}eI(p,I,0);if((a[p]&1)==0){J=z}else{J=c[A>>2]|0}c[q>>2]=J+G;K=J}else{K=x}v=C+12|0;w=c[v>>2]|0;l=C+16|0;if((w|0)==(c[l>>2]|0)){L=($d[c[(c[C>>2]|0)+36>>2]&127](C)|0)&255}else{L=a[w]|0}if((gL(L,16,K,q,t,0,n,g,s,y)|0)!=0){E=K;break}w=c[v>>2]|0;if((w|0)==(c[l>>2]|0)){$d[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=K;continue}else{c[v>>2]=w+1;m=C;x=K;continue}}a[E+3|0]=0;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);K=c[23686]|0;c[k>>2]=j;if((hL(E,K,93440,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){M=0}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){M=k;break}if(!(($d[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1)){M=k;break}c[r>>2]=0;M=0}}while(0);r=(M|0)==0;k=c[e>>2]|0;do{if((k|0)==0){D=54}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){if(!r){break}N=b;O=N;c[O>>2]=M;XH(p);XH(n);i=d;return}if(($d[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1){c[e>>2]=0;D=54;break}if(!(r^(k|0)==0)){break}N=b;O=N;c[O>>2]=M;XH(p);XH(n);i=d;return}}while(0);do{if((D|0)==54){if(r){break}N=b;O=N;c[O>>2]=M;XH(p);XH(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;N=b;O=N;c[O>>2]=M;XH(p);XH(n);i=d;return}function gL(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(a[m+24|0]|0)==b<<24>>24;if(!q){if(!((a[m+25|0]|0)==b<<24>>24)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&b<<24>>24==h<<24>>24){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+26|0;h=m;while(1){l=h+1|0;if((a[h]|0)==b<<24>>24){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;if((h|0)>23){r=-1;i=n;return r|0}do{if((d|0)==16){if((h|0)<22){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;m=a[93400+h|0]|0;c[f>>2]=o+1;a[o]=m;r=0;i=n;return r|0}else if((d|0)==10|(d|0)==8){if((h|0)<(d|0)){break}else{r=-1}i=n;return r|0}}while(0);d=a[93400+h|0]|0;c[f>>2]=o+1;a[o]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function hL(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Jc(b|0)|0;b=Wa(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Jc(e|0)|0;i=f;return b|0}function iL(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function jL(a){a=a|0;i=i;return}function kL(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];ke[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==1){a[j]=1}else if((z|0)==0){a[j]=0}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}TI(u,g);m=u;u=c[m>>2]|0;if(!((c[23712]|0)==-1)){c[p>>2]=94848;c[p+4>>2]=171;c[p+8>>2]=0;IH(94848,p,172)}p=(c[94852>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Cc(4)|0;D=C;HR(D);E=110416;F=127;Kd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Cc(4)|0;D=C;HR(D);E=110416;F=127;Kd(C|0,E|0,F|0)}F=u;nH(c[m>>2]|0)|0;TI(v,g);g=v;v=c[g>>2]|0;if(!((c[23752]|0)==-1)){c[o>>2]=95008;c[o+4>>2]=171;c[o+8>>2]=0;IH(95008,o,172)}o=(c[95012>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Cc(4)|0;H=G;HR(H);I=110416;J=127;Kd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Cc(4)|0;H=G;HR(H);I=110416;J=127;Kd(G|0,I|0,J|0)}J=v;nH(c[g>>2]|0)|0;g=w;Zd[c[(c[v>>2]|0)+24>>2]&63](g,J);Zd[c[(c[v>>2]|0)+28>>2]&63](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=lL(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];zI(w+12|0);zI(w);i=k;return}function lL(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=aS(l)|0;if((n|0)!=0){o=n;p=n;break}nS()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){z=$d[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{z=c[t>>2]|0}if((z|0)==-1){c[l>>2]=0;y=1;break}else{y=(c[l>>2]|0)==0;break}}}while(0);r=c[b>>2]|0;do{if((r|0)==0){A=0;B=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){C=$d[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{C=c[t>>2]|0}if(!((C|0)==-1)){A=r;B=0;break}c[b>>2]=0;A=0;B=1}}while(0);D=c[l>>2]|0;if(!((y^B)&(q|0)!=0)){break}r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){E=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{E=c[r>>2]|0}if(j){F=E}else{F=ne[c[(c[g>>2]|0)+28>>2]&63](g,E)|0}r=d+1|0;if(m){d=r;q=q;x=x;continue}b:do{if(j){t=0;w=e;s=x;n=q;v=p;while(1){do{if((a[v]|0)==1){u=a[w]|0;G=(u&1)==0;if(G){H=w+4|0}else{H=c[w+8>>2]|0}if((F|0)!=(c[H+(d<<2)>>2]|0)){a[v]=0;I=t;J=s;K=n+ -1|0;break}if(G){L=(u&255)>>>1}else{L=c[w+4>>2]|0}if((L|0)!=(r|0)){I=1;J=s;K=n;break}a[v]=2;I=1;J=s+1|0;K=n+ -1|0}else{I=t;J=s;K=n}}while(0);u=w+12|0;if((u|0)==(f|0)){M=I;N=J;O=K;break b}t=I;w=u;s=J;n=K;v=v+1|0}}else{v=0;n=e;s=x;w=q;t=p;while(1){do{if((a[t]|0)==1){if((a[n]&1)==0){P=n+4|0}else{P=c[n+8>>2]|0}if((F|0)!=(ne[c[(c[g>>2]|0)+28>>2]&63](g,c[P+(d<<2)>>2]|0)|0)){a[t]=0;Q=v;R=s;S=w+ -1|0;break}u=a[n]|0;if((u&1)==0){T=(u&255)>>>1}else{T=c[n+4>>2]|0}if((T|0)!=(r|0)){Q=1;R=s;S=w;break}a[t]=2;Q=1;R=s+1|0;S=w+ -1|0}else{Q=v;R=s;S=w}}while(0);u=n+12|0;if((u|0)==(f|0)){M=Q;N=R;O=S;break b}v=Q;n=u;s=R;w=S;t=t+1|0}}}while(0);if(!M){d=r;x=N;q=O;continue}t=c[l>>2]|0;w=t+12|0;s=c[w>>2]|0;if((s|0)==(c[t+16>>2]|0)){$d[c[(c[t>>2]|0)+40>>2]&127](t)|0}else{c[w>>2]=s+4}if((O+N|0)>>>0<2){d=r;x=N;q=O;continue}else{U=e;V=N;W=p}while(1){do{if((a[W]|0)==2){s=a[U]|0;if((s&1)==0){X=(s&255)>>>1}else{X=c[U+4>>2]|0}if((X|0)==(r|0)){Y=V;break}a[W]=0;Y=V+ -1|0}else{Y=V}}while(0);s=U+12|0;if((s|0)==(f|0)){d=r;x=Y;q=O;continue a}else{U=s;V=Y;W=W+1|0}}}do{if((D|0)==0){Z=1}else{W=c[D+12>>2]|0;if((W|0)==(c[D+16>>2]|0)){_=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{_=c[W>>2]|0}if((_|0)==-1){c[l>>2]=0;Z=1;break}else{Z=(c[l>>2]|0)==0;break}}}while(0);do{if((A|0)==0){$=85}else{l=c[A+12>>2]|0;if((l|0)==(c[A+16>>2]|0)){aa=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{aa=c[l>>2]|0}if((aa|0)==-1){c[b>>2]=0;$=85;break}else{if(Z){break}else{$=87;break}}}}while(0);if(($|0)==85){if(Z){$=87}}if(($|0)==87){c[h>>2]=c[h>>2]|2}c:do{if(m){$=92}else{if((a[p]|0)==2){ba=e;break}else{ca=e;da=p}while(1){Z=ca+12|0;b=da+1|0;if((Z|0)==(f|0)){$=92;break c}if((a[b]|0)==2){ba=Z;break}else{da=b;ca=Z}}}}while(0);if(($|0)==92){c[h>>2]=c[h>>2]|4;ba=f}if((o|0)==0){i=k;return ba|0}bS(o);i=k;return ba|0}function mL(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];nL(a,0,k,j,f,g,h);i=b;return}function nL(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;JL(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eI(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=$d[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=$d[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}eI(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}eI(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((FL(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=CQ(I,c[o>>2]|0,h,t)|0;TN(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=$d[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;XH(n);XH(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;XH(n);XH(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;XH(n);XH(m);i=d;return}function oL(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];pL(a,0,k,j,f,g,h);i=b;return}function pL(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;JL(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eI(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=$d[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=$d[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}eI(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}eI(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((FL(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=BQ(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;TN(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=$d[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;XH(n);XH(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;XH(n);XH(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;XH(n);XH(m);i=d;return}function qL(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];rL(a,0,k,j,f,g,h);i=b;return}function rL(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+328|0;l=e;m=e+104|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+152|0;r=e+312|0;s=e+320|0;t=c[h+4>>2]&74;if((t|0)==64){u=8}else if((t|0)==0){u=0}else if((t|0)==8){u=16}else{u=10}t=l;JL(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;eI(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=c[m>>2]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0;C=1}else{x=c[m+12>>2]|0;if((x|0)==(c[m+16>>2]|0)){D=$d[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{D=c[x>>2]|0}if(!((D|0)==-1)){B=m;C=0;break}c[l>>2]=0;B=0;C=1}}while(0);x=c[f>>2]|0;do{if((x|0)==0){E=21}else{F=c[x+12>>2]|0;if((F|0)==(c[x+16>>2]|0)){G=$d[c[(c[x>>2]|0)+36>>2]&127](x)|0}else{G=c[F>>2]|0}if((G|0)==-1){c[f>>2]=0;E=21;break}else{if(C){H=x;break}else{I=x;J=A;break a}}}}while(0);if((E|0)==21){E=0;if(C){I=0;J=A;break}else{H=0}}x=a[o]|0;F=(x&1)==0;if(F){K=(x&255)>>>1}else{K=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(K|0)){if(F){L=(x&255)>>>1;M=(x&255)>>>1}else{x=c[y>>2]|0;L=x;M=x}eI(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[g>>2]&-2)+ -1|0}eI(o,N,0);if((a[o]&1)==0){O=v}else{O=c[w>>2]|0}c[p>>2]=O+L;P=O}else{P=A}x=B+12|0;F=c[x>>2]|0;Q=B+16|0;if((F|0)==(c[Q>>2]|0)){R=$d[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{R=c[F>>2]|0}if((FL(R,u,P,p,s,z,n,h,r,t)|0)!=0){I=H;J=P;break}F=c[x>>2]|0;if((F|0)==(c[Q>>2]|0)){$d[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=P;continue}else{c[x>>2]=F+4;m=B;A=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){P=c[r>>2]|0;if((P-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=A}}while(0);b[k>>1]=AQ(J,c[p>>2]|0,j,u)|0;TN(n,h,c[r>>2]|0,j);do{if((B|0)==0){T=0;U=1}else{r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){V=$d[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{V=c[r>>2]|0}if(!((V|0)==-1)){T=B;U=0;break}c[l>>2]=0;T=0;U=1}}while(0);do{if((I|0)==0){E=60}else{l=c[I+12>>2]|0;if((l|0)==(c[I+16>>2]|0)){W=$d[c[(c[I>>2]|0)+36>>2]&127](I)|0}else{W=c[l>>2]|0}if((W|0)==-1){c[f>>2]=0;E=60;break}if(!U){break}X=d;Y=X;c[Y>>2]=T;XH(o);XH(n);i=e;return}}while(0);do{if((E|0)==60){if(U){break}X=d;Y=X;c[Y>>2]=T;XH(o);XH(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;X=d;Y=X;c[Y>>2]=T;XH(o);XH(n);i=e;return}function sL(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];tL(a,0,k,j,f,g,h);i=b;return}function tL(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;JL(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eI(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=$d[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=$d[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}eI(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}eI(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((FL(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=zQ(I,c[o>>2]|0,h,t)|0;TN(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=$d[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;XH(n);XH(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;XH(n);XH(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;XH(n);XH(m);i=d;return}function uL(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];vL(a,0,k,j,f,g,h);i=b;return}function vL(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;JL(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eI(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=$d[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=$d[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}eI(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}eI(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((FL(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=yQ(I,c[o>>2]|0,h,t)|0;TN(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=$d[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;XH(n);XH(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;XH(n);XH(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;XH(n);XH(m);i=d;return}function wL(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];xL(a,0,k,j,f,g,h);i=b;return}function xL(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;JL(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eI(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=$d[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=$d[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}eI(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}eI(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((FL(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=xQ(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;TN(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=$d[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;XH(n);XH(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;XH(n);XH(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;XH(n);XH(m);i=d;return}function yL(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];zL(a,0,k,j,f,g,h);i=b;return}function zL(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;KL(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;eI(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=$d[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=$d[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}eI(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}eI(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((LL(T,t,u,R,p,B,l,n,h,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){$d[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);g[k>>2]=+wQ(L,c[p>>2]|0,j);TN(n,h,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=$d[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;XH(o);XH(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;XH(o);XH(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;XH(o);XH(n);i=d;return}function AL(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];BL(a,0,k,j,f,g,h);i=b;return}function BL(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;KL(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eI(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=$d[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=$d[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}eI(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}eI(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((LL(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){$d[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+vQ(L,c[p>>2]|0,j);TN(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=$d[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;XH(o);XH(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;XH(o);XH(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;XH(o);XH(n);i=d;return}function CL(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];DL(a,0,k,j,f,g,h);i=b;return}function DL(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;KL(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eI(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=$d[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=$d[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}eI(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}eI(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((LL(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){$d[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+uQ(L,c[p>>2]|0,j);TN(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=$d[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;XH(o);XH(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;XH(o);XH(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;XH(o);XH(n);i=d;return}function EL(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+104|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;TI(o,g);g=o;o=c[g>>2]|0;if(!((c[23712]|0)==-1)){c[l>>2]=94848;c[l+4>>2]=171;c[l+8>>2]=0;IH(94848,l,172)}l=(c[94852>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Cc(4)|0;w=v;HR(w);x=110416;y=127;Kd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Cc(4)|0;w=v;HR(w);x=110416;y=127;Kd(v|0,x|0,y|0)}y=m;xe[c[(c[o>>2]|0)+48>>2]&63](o,93400,93426|0,y)|0;nH(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eI(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0;D=1}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){E=$d[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{E=c[B>>2]|0}if(!((E|0)==-1)){C=m;D=0;break}c[r>>2]=0;C=0;D=1}}while(0);B=c[e>>2]|0;do{if((B|0)==0){F=22}else{v=c[B+12>>2]|0;if((v|0)==(c[B+16>>2]|0)){G=$d[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{G=c[v>>2]|0}if((G|0)==-1){c[e>>2]=0;F=22;break}else{if(D){break}else{H=x;break a}}}}while(0);if((F|0)==22){F=0;if(D){H=x;break}}B=a[p]|0;v=(B&1)==0;if(v){I=(B&255)>>>1}else{I=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(I|0)){if(v){J=(B&255)>>>1;K=(B&255)>>>1}else{B=c[o>>2]|0;J=B;K=B}eI(p,K<<1,0);if((a[p]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}eI(p,L,0);if((a[p]&1)==0){M=z}else{M=c[A>>2]|0}c[q>>2]=M+J;N=M}else{N=x}B=C+12|0;v=c[B>>2]|0;w=C+16|0;if((v|0)==(c[w>>2]|0)){O=$d[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{O=c[v>>2]|0}if((FL(O,16,N,q,t,0,n,g,s,y)|0)!=0){H=N;break}v=c[B>>2]|0;if((v|0)==(c[w>>2]|0)){$d[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=N;continue}else{c[B>>2]=v+4;m=C;x=N;continue}}a[H+3|0]=0;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);N=c[23686]|0;c[k>>2]=j;if((hL(H,N,93440,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){P=0;Q=1}else{N=c[k+12>>2]|0;if((N|0)==(c[k+16>>2]|0)){R=$d[c[(c[k>>2]|0)+36>>2]&127](k)|0}else{R=c[N>>2]|0}if(!((R|0)==-1)){P=k;Q=0;break}c[r>>2]=0;P=0;Q=1}}while(0);r=c[e>>2]|0;do{if((r|0)==0){F=60}else{k=c[r+12>>2]|0;if((k|0)==(c[r+16>>2]|0)){S=$d[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{S=c[k>>2]|0}if((S|0)==-1){c[e>>2]=0;F=60;break}if(!Q){break}T=b;U=T;c[U>>2]=P;XH(p);XH(n);i=d;return}}while(0);do{if((F|0)==60){if(Q){break}T=b;U=T;c[U>>2]=P;XH(p);XH(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;T=b;U=T;c[U>>2]=P;XH(p);XH(n);i=d;return}function FL(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(c[m+96>>2]|0)==(b|0);if(!q){if((c[m+100>>2]|0)!=(b|0)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&(b|0)==(h|0)){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+104|0;h=m;while(1){l=h+4|0;if((c[h>>2]|0)==(b|0)){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;m=h>>2;if((h|0)>92){r=-1;i=n;return r|0}do{if((d|0)==16){if((h|0)<88){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;t=a[93400+m|0]|0;c[f>>2]=o+1;a[o]=t;r=0;i=n;return r|0}else if((d|0)==10|(d|0)==8){if((m|0)<(d|0)){break}else{r=-1}i=n;return r|0}}while(0);d=a[93400+m|0]|0;c[f>>2]=o+1;a[o]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function GL(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;TI(k,d);d=k;k=c[d>>2]|0;if(!((c[23714]|0)==-1)){c[j>>2]=94856;c[j+4>>2]=171;c[j+8>>2]=0;IH(94856,j,172)}j=(c[94860>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Cc(4)|0;n=m;HR(n);o=110416;p=127;Kd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Cc(4)|0;n=m;HR(n);o=110416;p=127;Kd(m|0,o|0,p|0)}xe[c[(c[k>>2]|0)+32>>2]&63](k,93400,93426|0,e)|0;e=c[d>>2]|0;if(!((c[23750]|0)==-1)){c[h>>2]=95e3;c[h+4>>2]=171;c[h+8>>2]=0;IH(95e3,h,172)}h=(c[95004>>2]|0)+ -1|0;k=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-k>>2>>>0>h>>>0)){q=Cc(4)|0;r=q;HR(r);s=110416;t=127;Kd(q|0,s|0,t|0)}e=c[k+(h<<2)>>2]|0;if((e|0)==0){q=Cc(4)|0;r=q;HR(r);s=110416;t=127;Kd(q|0,s|0,t|0)}else{t=e;a[f]=$d[c[(c[e>>2]|0)+16>>2]&127](t)|0;Zd[c[(c[e>>2]|0)+20>>2]&63](b,t);nH(c[d>>2]|0)|0;i=g;return}}function HL(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h;k=h+16|0;l=h+32|0;TI(l,d);d=l;l=c[d>>2]|0;if(!((c[23714]|0)==-1)){c[k>>2]=94856;c[k+4>>2]=171;c[k+8>>2]=0;IH(94856,k,172)}k=(c[94860>>2]|0)+ -1|0;m=c[l+8>>2]|0;if(!((c[l+12>>2]|0)-m>>2>>>0>k>>>0)){n=Cc(4)|0;o=n;HR(o);p=110416;q=127;Kd(n|0,p|0,q|0)}l=c[m+(k<<2)>>2]|0;if((l|0)==0){n=Cc(4)|0;o=n;HR(o);p=110416;q=127;Kd(n|0,p|0,q|0)}xe[c[(c[l>>2]|0)+32>>2]&63](l,93400,93432|0,e)|0;e=c[d>>2]|0;if(!((c[23750]|0)==-1)){c[j>>2]=95e3;c[j+4>>2]=171;c[j+8>>2]=0;IH(95e3,j,172)}j=(c[95004>>2]|0)+ -1|0;l=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-l>>2>>>0>j>>>0)){r=Cc(4)|0;s=r;HR(s);t=110416;u=127;Kd(r|0,t|0,u|0)}e=c[l+(j<<2)>>2]|0;if((e|0)==0){r=Cc(4)|0;s=r;HR(s);t=110416;u=127;Kd(r|0,t|0,u|0)}else{u=e;a[f]=$d[c[(c[e>>2]|0)+12>>2]&127](u)|0;a[g]=$d[c[(c[e>>2]|0)+16>>2]&127](u)|0;Zd[c[(c[e>>2]|0)+20>>2]&63](b,u);nH(c[d>>2]|0)|0;i=h;return}}function IL(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if(b<<24>>24==h<<24>>24){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if(b<<24>>24==j<<24>>24){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+32|0;j=o;while(1){r=j+1|0;if((a[j]|0)==b<<24>>24){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;if((j|0)>31){q=-1;i=p;return q|0}o=a[93400+j|0]|0;if((j|0)==23|(j|0)==22){a[e]=80;t=c[g>>2]|0;c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else if((j|0)==24|(j|0)==25){t=c[g>>2]|0;do{if((t|0)!=(f|0)){if((a[t+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else{t=a[e]|0;do{if((o&95|0)==(t<<24>>24|0)){a[e]=t|-128;if((a[d]|0)==0){break}a[d]=0;f=a[k]|0;if((f&1)==0){u=(f&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}f=c[m>>2]|0;if((f-l|0)>=160){break}s=c[n>>2]|0;c[m>>2]=f+4;c[f>>2]=s}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=o;if((j|0)>21){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}return 0}function JL(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+40|0;g=f;h=f+16|0;j=f+32|0;TI(j,b);b=j;j=c[b>>2]|0;if(!((c[23712]|0)==-1)){c[h>>2]=94848;c[h+4>>2]=171;c[h+8>>2]=0;IH(94848,h,172)}h=(c[94852>>2]|0)+ -1|0;k=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-k>>2>>>0>h>>>0)){l=Cc(4)|0;m=l;HR(m);n=110416;o=127;Kd(l|0,n|0,o|0)}j=c[k+(h<<2)>>2]|0;if((j|0)==0){l=Cc(4)|0;m=l;HR(m);n=110416;o=127;Kd(l|0,n|0,o|0)}xe[c[(c[j>>2]|0)+48>>2]&63](j,93400,93426|0,d)|0;d=c[b>>2]|0;if(!((c[23752]|0)==-1)){c[g>>2]=95008;c[g+4>>2]=171;c[g+8>>2]=0;IH(95008,g,172)}g=(c[95012>>2]|0)+ -1|0;j=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-j>>2>>>0>g>>>0)){p=Cc(4)|0;q=p;HR(q);r=110416;s=127;Kd(p|0,r|0,s|0)}d=c[j+(g<<2)>>2]|0;if((d|0)==0){p=Cc(4)|0;q=p;HR(q);r=110416;s=127;Kd(p|0,r|0,s|0)}else{s=d;c[e>>2]=$d[c[(c[d>>2]|0)+16>>2]&127](s)|0;Zd[c[(c[d>>2]|0)+20>>2]&63](a,s);nH(c[b>>2]|0)|0;i=f;return}}function KL(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;TI(k,b);b=k;k=c[b>>2]|0;if(!((c[23712]|0)==-1)){c[j>>2]=94848;c[j+4>>2]=171;c[j+8>>2]=0;IH(94848,j,172)}j=(c[94852>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Cc(4)|0;n=m;HR(n);o=110416;p=127;Kd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Cc(4)|0;n=m;HR(n);o=110416;p=127;Kd(m|0,o|0,p|0)}xe[c[(c[k>>2]|0)+48>>2]&63](k,93400,93432|0,d)|0;d=c[b>>2]|0;if(!((c[23752]|0)==-1)){c[h>>2]=95008;c[h+4>>2]=171;c[h+8>>2]=0;IH(95008,h,172)}h=(c[95012>>2]|0)+ -1|0;k=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-k>>2>>>0>h>>>0)){q=Cc(4)|0;r=q;HR(r);s=110416;t=127;Kd(q|0,s|0,t|0)}d=c[k+(h<<2)>>2]|0;if((d|0)==0){q=Cc(4)|0;r=q;HR(r);s=110416;t=127;Kd(q|0,s|0,t|0)}else{t=d;c[e>>2]=$d[c[(c[d>>2]|0)+12>>2]&127](t)|0;c[f>>2]=$d[c[(c[d>>2]|0)+16>>2]&127](t)|0;Zd[c[(c[d>>2]|0)+20>>2]&63](a,t);nH(c[b>>2]|0)|0;i=g;return}}function LL(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if((b|0)==(h|0)){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if((b|0)==(j|0)){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+128|0;j=o;while(1){r=j+4|0;if((c[j>>2]|0)==(b|0)){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;o=j>>2;if((j|0)>124){q=-1;i=p;return q|0}t=a[93400+o|0]|0;do{if((o|0)==23|(o|0)==22){a[e]=80}else if((o|0)==24|(o|0)==25){s=c[g>>2]|0;do{if((s|0)!=(f|0)){if((a[s+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=s+1;a[s]=t;q=0;i=p;return q|0}else{b=a[e]|0;if((t&95|0)!=(b<<24>>24|0)){break}a[e]=b|-128;if((a[d]|0)==0){break}a[d]=0;b=a[k]|0;if((b&1)==0){u=(b&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}b=c[m>>2]|0;if((b-l|0)>=160){break}r=c[n>>2]|0;c[m>>2]=b+4;c[b>>2]=r}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=t;if((j|0)>84){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}function ML(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function NL(a){a=a|0;i=i;return}function OL(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];he[p&31](b,d,k,f,g,q);i=j;return}TI(n,f);f=n;n=c[f>>2]|0;if(!((c[23750]|0)==-1)){c[l>>2]=95e3;c[l+4>>2]=171;c[l+8>>2]=0;IH(95e3,l,172)}l=(c[95004>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Cc(4)|0;u=t;HR(u);v=110416;w=127;Kd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Cc(4)|0;u=t;HR(u);v=110416;w=127;Kd(t|0,v|0,w|0)}w=n;nH(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){Zd[c[f+24>>2]&63](o,w)}else{Zd[c[f+28>>2]&63](o,w)}w=a[o]|0;if((w&1)==0){f=o+1|0;x=f;y=f;z=o+8|0}else{f=o+8|0;x=c[f>>2]|0;y=o+1|0;z=f}f=e;e=o+4|0;h=w;w=x;while(1){if((h&1)==0){A=y;B=(h&255)>>>1}else{A=c[z>>2]|0;B=c[e>>2]|0}if((w|0)==(A+B|0)){break}x=a[w]|0;n=c[f>>2]|0;do{if((n|0)!=0){v=n+24|0;t=c[v>>2]|0;if((t|0)!=(c[n+28>>2]|0)){c[v>>2]=t+1;a[t]=x;break}if(!((ne[c[(c[n>>2]|0)+52>>2]&63](n,x&255)|0)==-1)){break}c[f>>2]=0}}while(0);h=a[o]|0;w=w+1|0}c[b>>2]=c[f>>2];XH(o);i=j;return}function PL(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=93648;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=100}}while(0);w=m;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);v=c[23686]|0;c[k>>2]=h;h=QL(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;TI(q,f);RL(w,y,k,z,o,p,q);nH(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];uE(b,j,z,e,o,f,g);i=d;return}function QL(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;f=Jc(d|0)|0;d=lc(a|0,b|0,e|0,h|0)|0;if((f|0)==0){i=g;return d|0}Jc(f|0)|0;i=g;return d|0}function RL(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[23714]|0)==-1)){c[m>>2]=94856;c[m+4>>2]=171;c[m+8>>2]=0;IH(94856,m,172)}m=(c[94860>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Cc(4)|0;r=q;HR(r);s=110416;t=127;Kd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Cc(4)|0;r=q;HR(r);s=110416;t=127;Kd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[23750]|0)==-1)){c[l>>2]=95e3;c[l+4>>2]=171;c[l+8>>2]=0;IH(95e3,l,172)}l=(c[95004>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Cc(4)|0;v=u;HR(v);w=110416;x=127;Kd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Cc(4)|0;v=u;HR(v);w=110416;x=127;Kd(u|0,w|0,x|0)}x=s;Zd[c[(c[s>>2]|0)+20>>2]&63](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){xe[c[(c[j>>2]|0)+32>>2]&63](t,b,e,f)|0;c[h>>2]=f+(e-b)}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=ne[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;z=b+1|0}else{z=b}do{if((e-z|0)>1){if((a[z]|0)!=48){A=z;break}u=z+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){A=z;break}w=ne[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+1;a[v]=w;w=ne[c[(c[j>>2]|0)+28>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+1;a[u]=w;A=z+2|0}else{A=z}}while(0);do{if((A|0)!=(e|0)){w=e+ -1|0;if(w>>>0>A>>>0){B=A;C=w}else{break}do{w=a[B]|0;a[B]=a[C]|0;a[C]=w;B=B+1|0;C=C+ -1|0;}while(B>>>0<C>>>0)}}while(0);w=$d[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(A>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=A;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){D=o;E=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){D=o;E=q;break}p=c[h>>2]|0;c[h>>2]=p+1;a[p]=w;p=a[n]|0;if((p&1)==0){F=(p&255)>>>1}else{F=c[v>>2]|0}D=0;E=(q>>>0<(F+ -1|0)>>>0)+q|0}}while(0);m=ne[c[(c[j>>2]|0)+28>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=m;m=r+1|0;if(m>>>0<e>>>0){o=D+1|0;q=E;r=m}else{break}}}r=f+(A-b)|0;q=c[h>>2]|0;if((r|0)==(q|0)){break}o=q+ -1|0;if(o>>>0>r>>>0){G=r;H=o}else{break}do{o=a[G]|0;a[G]=a[H]|0;a[H]=o;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);if((d|0)==(e|0)){I=c[h>>2]|0;c[g>>2]=I;XH(n);i=k;return}else{I=f+(d-b)|0;c[g>>2]=I;XH(n);i=k;return}}function SL(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);y=c[23686]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=QL(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;TI(r,f);RL(x,z,l,A,p,q,r);nH(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];uE(b,k,A,e,p,f,g);i=d;return}function TL(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=93648;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);v=c[23686]|0;c[k>>2]=h;h=QL(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;TI(q,f);RL(w,y,k,z,o,p,q);nH(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];uE(b,j,z,e,o,f,g);i=d;return}function UL(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);y=c[23686]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=QL(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;TI(r,f);RL(x,z,l,A,p,q,r);nH(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];uE(b,k,A,e,p,f,g);i=d;return}function VL(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);r=c[23686]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=QL(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=QL(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[94752]|0)==0;if(F){do{if(o){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);r=c[23686]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=WL(s,r,z,n)|0}else{do{if(o){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);o=c[23686]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=WL(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}nS()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=aS(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}nS()}}while(0);TI(w,f);XL(N,L,G,P,u,v,w);nH(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];uE(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){bS(O)}if((J|0)==0){i=d;return}bS(J);i=d;return}function WL(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Jc(b|0)|0;b=ic(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Jc(e|0)|0;i=f;return b|0}function XL(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[23714]|0)==-1)){c[m>>2]=94856;c[m+4>>2]=171;c[m+8>>2]=0;IH(94856,m,172)}m=(c[94860>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Cc(4)|0;r=q;HR(r);s=110416;t=127;Kd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Cc(4)|0;r=q;HR(r);s=110416;t=127;Kd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[23750]|0)==-1)){c[l>>2]=95e3;c[l+4>>2]=171;c[l+8>>2]=0;IH(95e3,l,172)}l=(c[95004>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Cc(4)|0;v=u;HR(v);w=110416;x=127;Kd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Cc(4)|0;v=u;HR(v);w=110416;x=127;Kd(u|0,w|0,x|0)}x=s;Zd[c[(c[s>>2]|0)+20>>2]&63](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=ne[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=ne[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+1;a[l]=v;v=y+2|0;l=ne[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);w=A+1|0;if((Uc(l<<24>>24|0,c[23686]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);l=D+1|0;if((Md(A<<24>>24|0,c[23686]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){xe[c[(c[j>>2]|0)+32>>2]&63](t,B,C,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(C-B)}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){F=B;G=y}else{break}do{y=a[F]|0;a[F]=a[G]|0;a[G]=y;F=F+1|0;G=G+ -1|0;}while(F>>>0<G>>>0)}}while(0);A=$d[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){H=l;I=v;break}q=c[h>>2]|0;c[h>>2]=q+1;a[q]=A;q=a[n]|0;if((q&1)==0){J=(q&255)>>>1}else{J=c[D>>2]|0}H=0;I=(v>>>0<(J+ -1|0)>>>0)+v|0}else{H=l;I=v}}while(0);o=ne[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q]=o;o=w+1|0;if(o>>>0<C>>>0){l=H+1|0;v=I;w=o}else{break}}}w=f+(B-b)|0;v=c[h>>2]|0;if((w|0)==(v|0)){break}l=v+ -1|0;if(l>>>0>w>>>0){K=w;L=l}else{break}do{l=a[K]|0;a[K]=a[L]|0;a[L]=l;K=K+1|0;L=L+ -1|0;}while(K>>>0<L>>>0)}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){K=a[L]|0;if(K<<24>>24==46){break}B=ne[c[(c[j>>2]|0)+28>>2]&63](t,K)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;B=L+1|0;if(B>>>0<e>>>0){L=B}else{M=B;break c}}B=$d[c[(c[s>>2]|0)+12>>2]&127](x)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;M=L+1|0}else{M=C}}while(0);xe[c[(c[j>>2]|0)+32>>2]&63](t,M,e,c[h>>2]|0)|0;t=(c[h>>2]|0)+(u-M)|0;c[h>>2]=t;if((d|0)==(e|0)){N=t;c[g>>2]=N;XH(n);i=k;return}N=f+(d-b)|0;c[g>>2]=N;XH(n);i=k;return}



function YL(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);r=c[23686]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=QL(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=QL(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[94752]|0)==0;if(F){do{if(o){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);r=c[23686]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=WL(s,r,z,n)|0}else{do{if(o){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);o=c[23686]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=WL(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}nS()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=aS(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}nS()}}while(0);TI(w,f);XL(N,L,G,P,u,v,w);nH(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];uE(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){bS(O)}if((J|0)==0){i=d;return}bS(J);i=d;return}function ZL(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+40|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=93656;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);s=c[23686]|0;c[k>>2]=h;h=QL(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else if((r|0)==32){t=k}else{u=10}}while(0);if((u|0)==10){t=m}u=o;TI(p,f);r=p;p=c[r>>2]|0;if(!((c[23714]|0)==-1)){c[l>>2]=94856;c[l+4>>2]=171;c[l+8>>2]=0;IH(94856,l,172)}l=(c[94860>>2]|0)+ -1|0;s=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-s>>2>>>0>l>>>0)){v=Cc(4)|0;w=v;HR(w);x=110416;y=127;Kd(v|0,x|0,y|0)}p=c[s+(l<<2)>>2]|0;if((p|0)==0){v=Cc(4)|0;w=v;HR(w);x=110416;y=127;Kd(v|0,x|0,y|0)}nH(c[r>>2]|0)|0;xe[c[(c[p>>2]|0)+32>>2]&63](p,m,k,u)|0;m=o+h|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];uE(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];uE(b,j,u,z,m,f,g);I=j;i=d;return}function _L(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function $L(a){a=a|0;i=i;return}function aM(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];he[p&31](b,d,k,f,g,q);i=j;return}TI(n,f);f=n;n=c[f>>2]|0;if(!((c[23752]|0)==-1)){c[l>>2]=95008;c[l+4>>2]=171;c[l+8>>2]=0;IH(95008,l,172)}l=(c[95012>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Cc(4)|0;u=t;HR(u);v=110416;w=127;Kd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Cc(4)|0;u=t;HR(u);v=110416;w=127;Kd(t|0,v|0,w|0)}w=n;nH(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){Zd[c[f+24>>2]&63](o,w)}else{Zd[c[f+28>>2]&63](o,w)}w=a[o]|0;if((w&1)==0){f=o+4|0;x=f;y=o+8|0;z=f}else{f=o+8|0;x=c[f>>2]|0;y=f;z=o+4|0}f=e;e=w;w=x;while(1){if((e&1)==0){A=z;B=(e&255)>>>1}else{A=c[y>>2]|0;B=c[z>>2]|0}if((w|0)==(A+(B<<2)|0)){break}x=c[w>>2]|0;h=c[f>>2]|0;do{if((h|0)!=0){n=h+24|0;v=c[n>>2]|0;if((v|0)==(c[h+28>>2]|0)){C=ne[c[(c[h>>2]|0)+52>>2]&63](h,x)|0}else{c[n>>2]=v+4;c[v>>2]=x;C=x}if(!((C|0)==-1)){break}c[f>>2]=0}}while(0);e=a[o]|0;w=w+4|0}c[b>>2]=c[f>>2];zI(o);i=j;return}function bM(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=93648;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=100}}while(0);w=m;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);x=c[23686]|0;c[k>>2]=h;h=QL(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;TI(q,f);cM(w,y,k,z,o,p,q);nH(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];dM(b,j,z,e,o,f,g);i=d;return}function cM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[23712]|0)==-1)){c[m>>2]=94848;c[m+4>>2]=171;c[m+8>>2]=0;IH(94848,m,172)}m=(c[94852>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Cc(4)|0;r=q;HR(r);s=110416;t=127;Kd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Cc(4)|0;r=q;HR(r);s=110416;t=127;Kd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[23752]|0)==-1)){c[l>>2]=95008;c[l+4>>2]=171;c[l+8>>2]=0;IH(95008,l,172)}l=(c[95012>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Cc(4)|0;v=u;HR(v);w=110416;x=127;Kd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Cc(4)|0;v=u;HR(v);w=110416;x=127;Kd(u|0,w|0,x|0)}x=s;Zd[c[(c[s>>2]|0)+20>>2]&63](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){xe[c[(c[j>>2]|0)+48>>2]&63](t,b,e,f)|0;w=f+(e-b<<2)|0;c[h>>2]=w;z=w}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=ne[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;A=b+1|0}else{A=b}do{if((e-A|0)>1){if((a[A]|0)!=48){B=A;break}u=A+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){B=A;break}w=ne[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=w;w=ne[c[(c[j>>2]|0)+44>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=w;B=A+2|0}else{B=A}}while(0);do{if((B|0)!=(e|0)){w=e+ -1|0;if(w>>>0>B>>>0){C=B;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D+ -1|0;}while(C>>>0<D>>>0)}}while(0);w=$d[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=B;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){E=o;F=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){E=o;F=q;break}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=w;p=a[n]|0;if((p&1)==0){G=(p&255)>>>1}else{G=c[v>>2]|0}E=0;F=(q>>>0<(G+ -1|0)>>>0)+q|0}}while(0);m=ne[c[(c[j>>2]|0)+44>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;H=p+4|0;c[h>>2]=H;c[p>>2]=m;m=r+1|0;if(m>>>0<e>>>0){o=E+1|0;q=F;r=m}else{I=H;break}}}else{I=c[h>>2]|0}r=f+(B-b<<2)|0;if((r|0)==(I|0)){z=I;break}q=I+ -4|0;if(q>>>0>r>>>0){J=r;K=q}else{z=I;break}while(1){q=c[J>>2]|0;c[J>>2]=c[K>>2];c[K>>2]=q;q=J+4|0;r=K+ -4|0;if(q>>>0<r>>>0){K=r;J=q}else{z=I;break}}}}while(0);if((d|0)==(e|0)){L=z;c[g>>2]=L;XH(n);i=k;return}L=f+(d-b<<2)|0;c[g>>2]=L;XH(n);i=k;return}function dM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=d;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if((be[c[(c[d>>2]|0)+48>>2]&63](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){yI(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}if((be[c[(c[d>>2]|0)+48>>2]&63](d,r,q)|0)==(q|0)){zI(l);break}c[m>>2]=0;c[b>>2]=0;zI(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if((be[c[(c[d>>2]|0)+48>>2]&63](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function eM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+168|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);y=c[23686]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=QL(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;TI(r,f);cM(x,z,l,A,p,q,r);nH(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];dM(b,k,A,e,p,f,g);i=d;return}function fM(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=93648;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=117}}while(0);w=m;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);x=c[23686]|0;c[k>>2]=h;h=QL(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;TI(q,f);cM(w,y,k,z,o,p,q);nH(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];dM(b,j,z,e,o,f,g);i=d;return}function gM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+176|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);y=c[23686]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=QL(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;TI(r,f);cM(x,z,l,A,p,q,r);nH(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];dM(b,k,A,e,p,f,g);i=d;return}function hM(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);r=c[23686]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=QL(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=QL(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[94752]|0)==0;if(F){do{if(o){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);r=c[23686]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=WL(s,r,z,n)|0}else{do{if(o){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);o=c[23686]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=WL(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}nS()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=aS(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}nS()}}while(0);TI(w,f);iM(N,L,G,P,u,v,w);nH(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];dM(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){bS(O)}if((J|0)==0){i=d;return}bS(J);i=d;return}function iM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[23712]|0)==-1)){c[m>>2]=94848;c[m+4>>2]=171;c[m+8>>2]=0;IH(94848,m,172)}m=(c[94852>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Cc(4)|0;r=q;HR(r);s=110416;t=127;Kd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Cc(4)|0;r=q;HR(r);s=110416;t=127;Kd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[23752]|0)==-1)){c[l>>2]=95008;c[l+4>>2]=171;c[l+8>>2]=0;IH(95008,l,172)}l=(c[95012>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Cc(4)|0;v=u;HR(v);w=110416;x=127;Kd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Cc(4)|0;v=u;HR(v);w=110416;x=127;Kd(u|0,w|0,x|0)}x=s;Zd[c[(c[s>>2]|0)+20>>2]&63](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=ne[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=ne[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=v;v=y+2|0;l=ne[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);w=A+1|0;if((Uc(l<<24>>24|0,c[23686]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);l=D+1|0;if((Md(A<<24>>24|0,c[23686]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){xe[c[(c[j>>2]|0)+48>>2]&63](t,B,C,c[h>>2]|0)|0;y=(c[h>>2]|0)+(C-B<<2)|0;c[h>>2]=y;F=y}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){G=B;H=y}else{break}do{y=a[G]|0;a[G]=a[H]|0;a[H]=y;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);A=$d[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){I=l;J=v;break}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=A;q=a[n]|0;if((q&1)==0){K=(q&255)>>>1}else{K=c[D>>2]|0}I=0;J=(v>>>0<(K+ -1|0)>>>0)+v|0}else{I=l;J=v}}while(0);o=ne[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;r=q+4|0;c[h>>2]=r;c[q>>2]=o;o=w+1|0;if(o>>>0<C>>>0){l=I+1|0;v=J;w=o}else{L=r;break}}}else{L=c[h>>2]|0}w=f+(B-b<<2)|0;if((w|0)==(L|0)){F=L;break}v=L+ -4|0;if(v>>>0>w>>>0){M=w;N=v}else{F=L;break}while(1){v=c[M>>2]|0;c[M>>2]=c[N>>2];c[N>>2]=v;v=M+4|0;w=N+ -4|0;if(v>>>0<w>>>0){N=w;M=v}else{F=L;break}}}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){M=a[L]|0;if(M<<24>>24==46){break}N=ne[c[(c[j>>2]|0)+44>>2]&63](t,M)|0;M=c[h>>2]|0;B=M+4|0;c[h>>2]=B;c[M>>2]=N;N=L+1|0;if(N>>>0<e>>>0){L=N}else{O=B;P=N;break c}}N=$d[c[(c[s>>2]|0)+12>>2]&127](x)|0;B=c[h>>2]|0;M=B+4|0;c[h>>2]=M;c[B>>2]=N;O=M;P=L+1|0}else{O=F;P=C}}while(0);xe[c[(c[j>>2]|0)+48>>2]&63](t,P,e,O)|0;O=(c[h>>2]|0)+(u-P<<2)|0;c[h>>2]=O;if((d|0)==(e|0)){Q=O;c[g>>2]=Q;XH(n);i=k;return}Q=f+(d-b<<2)|0;c[g>>2]=Q;XH(n);i=k;return}function jM(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);r=c[23686]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=QL(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=QL(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[94752]|0)==0;if(F){do{if(o){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);r=c[23686]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=WL(s,r,z,n)|0}else{do{if(o){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);o=c[23686]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=WL(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}nS()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=aS(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}nS()}}while(0);TI(w,f);iM(N,L,G,P,u,v,w);nH(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];dM(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){bS(O)}if((J|0)==0){i=d;return}bS(J);i=d;return}function kM(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+152|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=93656;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);s=c[23686]|0;c[k>>2]=h;h=QL(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==32){t=k}else if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else{u=10}}while(0);if((u|0)==10){t=m}TI(p,f);u=p;p=c[u>>2]|0;if(!((c[23712]|0)==-1)){c[l>>2]=94848;c[l+4>>2]=171;c[l+8>>2]=0;IH(94848,l,172)}l=(c[94852>>2]|0)+ -1|0;r=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-r>>2>>>0>l>>>0)){v=Cc(4)|0;w=v;HR(w);x=110416;y=127;Kd(v|0,x|0,y|0)}p=c[r+(l<<2)>>2]|0;if((p|0)==0){v=Cc(4)|0;w=v;HR(w);x=110416;y=127;Kd(v|0,x|0,y|0)}nH(c[u>>2]|0)|0;u=o;xe[c[(c[p>>2]|0)+48>>2]&63](p,m,k,u)|0;m=o+(h<<2)|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];dM(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n<<2)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];dM(b,j,u,z,m,f,g);I=j;i=d;return}function lM(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;n=i;i=i+64|0;o=n;p=n+8|0;q=n+16|0;r=n+32|0;s=n+40|0;t=n+48|0;u=n+56|0;TI(r,h);v=r;r=c[v>>2]|0;if(!((c[23714]|0)==-1)){c[q>>2]=94856;c[q+4>>2]=171;c[q+8>>2]=0;IH(94856,q,172)}q=(c[94860>>2]|0)+ -1|0;w=c[r+8>>2]|0;if(!((c[r+12>>2]|0)-w>>2>>>0>q>>>0)){x=Cc(4)|0;y=x;HR(y);z=110416;A=127;Kd(x|0,z|0,A|0)}r=c[w+(q<<2)>>2]|0;if((r|0)==0){x=Cc(4)|0;y=x;HR(y);z=110416;A=127;Kd(x|0,z|0,A|0)}A=r;nH(c[v>>2]|0)|0;c[j>>2]=0;v=f;a:do{if((l|0)==(m|0)){B=65}else{z=g;x=r+8|0;y=t;q=u;w=s;C=l;D=0;b:while(1){E=D;while(1){if((E|0)!=0){B=65;break a}F=c[v>>2]|0;do{if((F|0)==0){G=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){G=F;break}if(!(($d[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){G=F;break}c[v>>2]=0;G=0}}while(0);F=(G|0)==0;H=c[z>>2]|0;c:do{if((H|0)==0){B=19}else{do{if((c[H+12>>2]|0)==(c[H+16>>2]|0)){if(!(($d[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1)){break}c[z>>2]=0;B=19;break c}}while(0);if(F){I=H}else{B=20;break b}}}while(0);if((B|0)==19){B=0;if(F){B=20;break b}else{I=0}}if((be[c[(c[r>>2]|0)+36>>2]&63](A,a[C]|0,0)|0)<<24>>24==37){B=22;break}H=a[C]|0;if(H<<24>>24>-1){J=c[x>>2]|0;if(!((b[J+(H<<24>>24<<1)>>1]&8192)==0)){K=C;B=33;break}}L=G+12|0;H=c[L>>2]|0;M=G+16|0;if((H|0)==(c[M>>2]|0)){N=($d[c[(c[G>>2]|0)+36>>2]&127](G)|0)&255}else{N=a[H]|0}H=ne[c[(c[r>>2]|0)+12>>2]&63](A,N)|0;if(H<<24>>24==(ne[c[(c[r>>2]|0)+12>>2]&63](A,a[C]|0)|0)<<24>>24){B=60;break}c[j>>2]=4;E=4}d:do{if((B|0)==22){B=0;E=C+1|0;if((E|0)==(m|0)){B=23;break b}H=be[c[(c[r>>2]|0)+36>>2]&63](A,a[E]|0,0)|0;if(H<<24>>24==48|H<<24>>24==69){O=C+2|0;if((O|0)==(m|0)){B=26;break b}P=O;Q=be[c[(c[r>>2]|0)+36>>2]&63](A,a[O]|0,0)|0;R=H}else{P=E;Q=H;R=0}H=c[(c[e>>2]|0)+36>>2]|0;c[y>>2]=G;c[q>>2]=I;E=p;O=t;c[E+0>>2]=c[O+0>>2];O=o;E=u;c[O+0>>2]=c[E+0>>2];me[H&3](s,e,p,o,h,j,k,Q,R);c[v>>2]=c[w>>2];S=P+1|0}else if((B|0)==33){while(1){B=0;H=K+1|0;if((H|0)==(m|0)){T=m;break}E=a[H]|0;if(!(E<<24>>24>-1)){T=H;break}if((b[J+(E<<24>>24<<1)>>1]&8192)==0){T=H;break}else{K=H;B=33}}F=G;H=I;E=I;while(1){do{if((F|0)==0){U=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){U=F;break}if(!(($d[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){U=F;break}c[v>>2]=0;U=0}}while(0);O=(U|0)==0;do{if((E|0)==0){V=H;B=46}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(O){W=H;X=E;break}else{S=T;break d}}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[z>>2]=0;V=0;B=46;break}else{if(O^(H|0)==0){W=H;X=H;break}else{S=T;break d}}}}while(0);if((B|0)==46){B=0;if(O){S=T;break d}else{W=V;X=0}}Y=U+12|0;Z=c[Y>>2]|0;_=U+16|0;if((Z|0)==(c[_>>2]|0)){$=($d[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{$=a[Z]|0}if(!($<<24>>24>-1)){S=T;break d}if((b[(c[x>>2]|0)+($<<24>>24<<1)>>1]&8192)==0){S=T;break d}Z=c[Y>>2]|0;if((Z|0)==(c[_>>2]|0)){$d[c[(c[U>>2]|0)+40>>2]&127](U)|0;F=U;H=W;E=X;continue}else{c[Y>>2]=Z+1;F=U;H=W;E=X;continue}}}else if((B|0)==60){B=0;E=c[L>>2]|0;if((E|0)==(c[M>>2]|0)){$d[c[(c[G>>2]|0)+40>>2]&127](G)|0}else{c[L>>2]=E+1}S=C+1|0}}while(0);if((S|0)==(m|0)){B=65;break a}C=S;D=c[j>>2]|0}if((B|0)==20){c[j>>2]=4;aa=G;break}else if((B|0)==23){c[j>>2]=4;aa=G;break}else if((B|0)==26){c[j>>2]=4;aa=G;break}}}while(0);if((B|0)==65){aa=c[v>>2]|0}v=f;do{if((aa|0)==0){ba=0}else{if((c[aa+12>>2]|0)!=(c[aa+16>>2]|0)){ba=aa;break}if(!(($d[c[(c[aa>>2]|0)+36>>2]&127](aa)|0)==-1)){ba=aa;break}c[v>>2]=0;ba=0}}while(0);v=(ba|0)==0;aa=g;g=c[aa>>2]|0;e:do{if((g|0)==0){B=75}else{do{if((c[g+12>>2]|0)==(c[g+16>>2]|0)){if(!(($d[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1)){break}c[aa>>2]=0;B=75;break e}}while(0);if(!v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);do{if((B|0)==75){if(v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ca=d;da=ca;c[da>>2]=ba;i=n;return}function mM(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function nM(a){a=a|0;i=i;return}function oM(a){a=a|0;i=i;return 2}function pM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];lM(a,b,l,k,f,g,h,93760,93768|0);i=j;return}function qM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=$d[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+1|0;s=q+1|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+t|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];lM(b,d,m,l,g,h,j,s,q);i=k;return}function rM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;TI(n,f);f=n;n=c[f>>2]|0;if(!((c[23714]|0)==-1)){c[m>>2]=94856;c[m+4>>2]=171;c[m+8>>2]=0;IH(94856,m,172)}m=(c[94860>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Cc(4)|0;q=p;HR(q);r=110416;s=127;Kd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Cc(4)|0;q=p;HR(q);r=110416;s=127;Kd(p|0,r|0,s|0)}s=n;nH(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=$d[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=OK(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function sM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;TI(n,f);f=n;n=c[f>>2]|0;if(!((c[23714]|0)==-1)){c[m>>2]=94856;c[m+4>>2]=171;c[m+8>>2]=0;IH(94856,m,172)}m=(c[94860>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Cc(4)|0;q=p;HR(q);r=110416;s=127;Kd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Cc(4)|0;q=p;HR(q);r=110416;s=127;Kd(p|0,r|0,s|0)}s=n;nH(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=$d[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=OK(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function tM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;TI(m,f);f=m;m=c[f>>2]|0;if(!((c[23714]|0)==-1)){c[l>>2]=94856;c[l+4>>2]=171;c[l+8>>2]=0;IH(94856,l,172)}l=(c[94860>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Cc(4)|0;p=o;HR(p);q=110416;r=127;Kd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Cc(4)|0;p=o;HR(p);q=110416;r=127;Kd(o|0,q|0,r|0)}r=m;nH(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=yM(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function uM(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;TI(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[23714]|0)==-1)){c[ba>>2]=94856;c[ba+4>>2]=171;c[ba+8>>2]=0;IH(94856,ba,172)}ba=(c[94860>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Cc(4)|0;Ga=Fa;HR(Ga);Ha=110416;Ia=127;Kd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Cc(4)|0;Ga=Fa;HR(Ga);Ha=110416;Ia=127;Kd(Fa|0,Ha|0,Ia|0)}Ia=ca;nH(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 70:{Da=e;c[ka>>2]=c[Da>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];lM(ja,d,J,I,g,h,j,93776,93784|0);c[Da>>2]=c[ja>>2];break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];wM(d,j+8|0,e,B,h,Ia);break};case 99:{Da=d+8|0;ca=$d[c[(c[Da>>2]|0)+12>>2]&127](Da)|0;Da=e;c[ea>>2]=c[Da>>2];c[fa>>2]=c[f>>2];Ha=a[ca]|0;if((Ha&1)==0){Ja=ca+1|0;Ka=ca+1|0;La=(Ha&255)>>>1}else{Ha=c[ca+8>>2]|0;Ja=Ha;Ka=Ha;La=c[ca+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];lM(da,d,O,N,g,h,j,Ka,Ja+La|0);c[Da>>2]=c[da>>2];break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Da=yM(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Da+ -1900;break};case 104:case 66:case 98:{Da=c[f>>2]|0;ca=d+8|0;Ha=$d[c[(c[ca>>2]|0)+4>>2]&127](ca)|0;c[$>>2]=Da;c[P+0>>2]=c[$+0>>2];Da=(OK(e,P,Ha,Ha+288|0,Ia,h,0)|0)-Ha|0;if((Da|0)>=288){break a}c[j+16>>2]=((Da|0)/12|0|0)%12|0;break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Da=yM(e,D,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<60){c[j+4>>2]=Da;break a}else{c[h>>2]=Ha|4;break a}break};case 114:{Ha=e;c[pa>>2]=c[Ha>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];lM(oa,d,A,z,g,h,j,93784,93795|0);c[Ha>>2]=c[oa>>2];break};case 88:{Ha=d+8|0;Da=$d[c[(c[Ha>>2]|0)+24>>2]&127](Ha)|0;Ha=e;c[Aa>>2]=c[Ha>>2];c[Ba>>2]=c[f>>2];ca=a[Da]|0;if((ca&1)==0){Ma=Da+1|0;Na=Da+1|0;Oa=(ca&255)>>>1}else{ca=c[Da+8>>2]|0;Ma=ca;Na=ca;Oa=c[Da+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];lM(za,d,q,p,g,h,j,Na,Ma+Oa|0);c[Ha>>2]=c[za>>2];break};case 84:{Ha=e;c[va>>2]=c[Ha>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];lM(ua,d,v,u,g,h,j,93808,93816|0);c[Ha>>2]=c[ua>>2];break};case 68:{Ha=e;c[ha>>2]=c[Ha>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];lM(ga,d,L,K,g,h,j,93768,93776|0);c[Ha>>2]=c[ga>>2];break};case 82:{Ha=e;c[sa>>2]=c[Ha>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];lM(ra,d,y,x,g,h,j,93800,93805|0);c[Ha>>2]=c[ra>>2];break};case 120:{Ha=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];ke[Ha&63](b,d,s,r,g,h,j);i=l;return};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Ha=yM(e,w,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Ha|0)<61){c[j>>2]=Ha;break a}else{c[h>>2]=Da|4;break a}break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Da=yM(e,F,h,Ia,3)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<366){c[j+28>>2]=Da;break a}else{c[h>>2]=Ha|4;break a}break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];vM(0,e,C,h,Ia);break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Ha=yM(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Ha|0)<69){Pa=Ha+2e3|0}else{Pa=(Ha+ -69|0)>>>0<31?Ha+1900|0:Ha}c[j+20>>2]=Pa+ -1900;break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Ha=yM(e,H,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Ha|0)<24){c[j+8>>2]=Ha;break a}else{c[h>>2]=Da|4;break a}break};case 65:case 97:{Da=c[f>>2]|0;Ha=d+8|0;ca=$d[c[c[Ha>>2]>>2]&127](Ha)|0;c[aa>>2]=Da;c[Q+0>>2]=c[aa+0>>2];Da=(OK(e,Q,ca,ca+168|0,Ia,h,0)|0)-ca|0;if((Da|0)>=168){break a}c[j+24>>2]=((Da|0)/12|0|0)%7|0;break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];Da=yM(e,t,h,Ia,1)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<7){c[j+24>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];xM(0,e,m,h,Ia);break};case 101:case 100:{ca=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Da=yM(e,M,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((Da+ -1|0)>>>0<31)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Ha|4;break};case 73:{Da=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];ca=yM(e,G,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((ca+ -1|0)>>>0<12)){break}c[Da>>2]=ca;break a}}while(0);c[h>>2]=Fa|4;break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];ca=yM(e,E,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<13){c[j+16>>2]=ca+ -1;break a}else{c[h>>2]=Da|4;break a}break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function vM(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;j=e;e=f;f=h+8|0;a:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if(($d[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;do{if((l|0)==0){m=12}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(h){n=l;break}else{o=l;break a}}if(($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;m=12;break}else{if(h){n=l;break}else{o=l;break a}}}}while(0);if((m|0)==12){m=0;if(h){o=0;break}else{n=0}}l=c[j>>2]|0;p=c[l+12>>2]|0;if((p|0)==(c[l+16>>2]|0)){q=($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)&255}else{q=a[p]|0}if(!(q<<24>>24>-1)){o=n;break}if((b[(c[f>>2]|0)+(q<<24>>24<<1)>>1]&8192)==0){o=n;break}p=c[j>>2]|0;l=p+12|0;r=c[l>>2]|0;if((r|0)==(c[p+16>>2]|0)){$d[c[(c[p>>2]|0)+40>>2]&127](p)|0;continue}else{c[l>>2]=r+1;continue}}n=c[j>>2]|0;do{if((n|0)==0){s=0}else{if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){s=n;break}if(($d[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1){c[j>>2]=0;s=0;break}else{s=c[j>>2]|0;break}}}while(0);j=(s|0)==0;b:do{if((o|0)==0){m=32}else{do{if((c[o+12>>2]|0)==(c[o+16>>2]|0)){if(!(($d[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1)){break}c[e>>2]=0;m=32;break b}}while(0);if(!j){break}i=d;return}}while(0);do{if((m|0)==32){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function wM(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=$d[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=OK(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function xM(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;b=i;h=d;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if(($d[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e;e=c[j>>2]|0;a:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!(($d[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[j>>2]=0;k=11;break a}}while(0);if(d){l=e}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){m=($d[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{m=a[e]|0}if(!((be[c[(c[g>>2]|0)+36>>2]&63](g,m,0)|0)<<24>>24==37)){c[f>>2]=c[f>>2]|4;i=b;return}m=c[h>>2]|0;g=m+12|0;e=c[g>>2]|0;if((e|0)==(c[m+16>>2]|0)){$d[c[(c[m>>2]|0)+40>>2]&127](m)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){n=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){n=e;break}if(($d[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[h>>2]=0;n=0;break}else{n=c[h>>2]|0;break}}}while(0);h=(n|0)==0;b:do{if((l|0)==0){k=31}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if(!(($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){break}c[j>>2]=0;k=31;break b}}while(0);if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function yM(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=d;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if(($d[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e;e=c[l>>2]|0;a:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!(($d[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[l>>2]=0;m=11;break a}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=($d[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>-1){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=(be[c[(c[g>>2]|0)+36>>2]&63](g,p,0)|0)<<24>>24;q=c[k>>2]|0;r=q+12|0;s=c[r>>2]|0;if((s|0)==(c[q+16>>2]|0)){$d[c[(c[q>>2]|0)+40>>2]&127](q)|0;t=h;u=n;v=n;w=d}else{c[r>>2]=s+1;t=h;u=n;v=n;w=d}while(1){x=w+ -48|0;d=t+ -1|0;s=c[k>>2]|0;do{if((s|0)==0){y=0}else{if((c[s+12>>2]|0)!=(c[s+16>>2]|0)){y=s;break}if(($d[c[(c[s>>2]|0)+36>>2]&127](s)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);s=(y|0)==0;do{if((v|0)==0){z=u;A=0}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){z=u;A=v;break}if(!(($d[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1)){z=u;A=u;break}c[l>>2]=0;z=0;A=0}}while(0);B=c[k>>2]|0;if(!((s^(A|0)==0)&(d|0)>0)){m=40;break}r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){C=($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[r]|0}if(!(C<<24>>24>-1)){o=x;m=52;break}if((b[(c[e>>2]|0)+(C<<24>>24<<1)>>1]&2048)==0){o=x;m=52;break}r=((be[c[(c[g>>2]|0)+36>>2]&63](g,C,0)|0)<<24>>24)+(x*10|0)|0;q=c[k>>2]|0;D=q+12|0;E=c[D>>2]|0;if((E|0)==(c[q+16>>2]|0)){$d[c[(c[q>>2]|0)+40>>2]&127](q)|0;F=d;u=z;v=A;w=r;t=F;continue}else{c[D>>2]=E+1;F=d;u=z;v=A;w=r;t=F;continue}}if((m|0)==40){do{if((B|0)==0){G=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){G=B;break}if(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);e=(G|0)==0;b:do{if((z|0)==0){m=50}else{do{if((c[z+12>>2]|0)==(c[z+16>>2]|0)){if(!(($d[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1)){break}c[l>>2]=0;m=50;break b}}while(0);if(e){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==50){if(e){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==52){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function zM(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;l=i;i=i+64|0;m=l;n=l+8|0;o=l+16|0;p=l+32|0;q=l+40|0;r=l+48|0;s=l+56|0;TI(p,f);t=p;p=c[t>>2]|0;if(!((c[23712]|0)==-1)){c[o>>2]=94848;c[o+4>>2]=171;c[o+8>>2]=0;IH(94848,o,172)}o=(c[94852>>2]|0)+ -1|0;u=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-u>>2>>>0>o>>>0)){v=Cc(4)|0;w=v;HR(w);x=110416;y=127;Kd(v|0,x|0,y|0)}p=c[u+(o<<2)>>2]|0;if((p|0)==0){v=Cc(4)|0;w=v;HR(w);x=110416;y=127;Kd(v|0,x|0,y|0)}y=p;nH(c[t>>2]|0)|0;c[g>>2]=0;t=d;a:do{if((j|0)==(k|0)){z=69}else{x=e;v=r;w=s;o=q;u=j;A=0;b:while(1){B=A;while(1){if((B|0)!=0){z=69;break a}C=c[t>>2]|0;do{if((C|0)==0){D=0;E=1}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){G=$d[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[F>>2]|0}if(!((G|0)==-1)){D=C;E=0;break}c[t>>2]=0;D=0;E=1}}while(0);C=c[x>>2]|0;do{if((C|0)==0){z=22}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){H=$d[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{H=c[F>>2]|0}if((H|0)==-1){c[x>>2]=0;z=22;break}else{if(E){I=C;break}else{z=24;break b}}}}while(0);if((z|0)==22){z=0;if(E){z=24;break b}else{I=0}}if((be[c[(c[p>>2]|0)+52>>2]&63](y,c[u>>2]|0,0)|0)<<24>>24==37){z=26;break}if(be[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[u>>2]|0)|0){J=u;z=36;break}K=D+12|0;C=c[K>>2]|0;L=D+16|0;if((C|0)==(c[L>>2]|0)){M=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{M=c[C>>2]|0}C=ne[c[(c[p>>2]|0)+28>>2]&63](y,M)|0;if((C|0)==(ne[c[(c[p>>2]|0)+28>>2]&63](y,c[u>>2]|0)|0)){z=64;break}c[g>>2]=4;B=4}c:do{if((z|0)==26){z=0;B=u+4|0;if((B|0)==(k|0)){z=27;break b}C=be[c[(c[p>>2]|0)+52>>2]&63](y,c[B>>2]|0,0)|0;if(C<<24>>24==48|C<<24>>24==69){F=u+8|0;if((F|0)==(k|0)){z=30;break b}N=F;O=be[c[(c[p>>2]|0)+52>>2]&63](y,c[F>>2]|0,0)|0;P=C}else{N=B;O=C;P=0}C=c[(c[b>>2]|0)+36>>2]|0;c[v>>2]=D;c[w>>2]=I;B=n;F=r;c[B+0>>2]=c[F+0>>2];F=m;B=s;c[F+0>>2]=c[B+0>>2];me[C&3](q,b,n,m,f,g,h,O,P);c[t>>2]=c[o>>2];Q=N+4|0}else if((z|0)==36){while(1){z=0;C=J+4|0;if((C|0)==(k|0)){R=k;break}if(be[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[C>>2]|0)|0){J=C;z=36}else{R=C;break}}C=D;B=I;F=I;while(1){do{if((C|0)==0){S=0;T=1}else{U=c[C+12>>2]|0;if((U|0)==(c[C+16>>2]|0)){V=$d[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{V=c[U>>2]|0}if(!((V|0)==-1)){S=C;T=0;break}c[t>>2]=0;S=0;T=1}}while(0);do{if((F|0)==0){W=B;z=51}else{U=c[F+12>>2]|0;if((U|0)==(c[F+16>>2]|0)){X=$d[c[(c[F>>2]|0)+36>>2]&127](F)|0}else{X=c[U>>2]|0}if((X|0)==-1){c[x>>2]=0;W=0;z=51;break}else{if(T^(B|0)==0){Y=B;Z=B;break}else{Q=R;break c}}}}while(0);if((z|0)==51){z=0;if(T){Q=R;break c}else{Y=W;Z=0}}U=S+12|0;_=c[U>>2]|0;$=S+16|0;if((_|0)==(c[$>>2]|0)){aa=$d[c[(c[S>>2]|0)+36>>2]&127](S)|0}else{aa=c[_>>2]|0}if(!(be[c[(c[p>>2]|0)+12>>2]&63](y,8192,aa)|0)){Q=R;break c}_=c[U>>2]|0;if((_|0)==(c[$>>2]|0)){$d[c[(c[S>>2]|0)+40>>2]&127](S)|0;C=S;B=Y;F=Z;continue}else{c[U>>2]=_+4;C=S;B=Y;F=Z;continue}}}else if((z|0)==64){z=0;F=c[K>>2]|0;if((F|0)==(c[L>>2]|0)){$d[c[(c[D>>2]|0)+40>>2]&127](D)|0}else{c[K>>2]=F+4}Q=u+4|0}}while(0);if((Q|0)==(k|0)){z=69;break a}u=Q;A=c[g>>2]|0}if((z|0)==24){c[g>>2]=4;ba=D;break}else if((z|0)==27){c[g>>2]=4;ba=D;break}else if((z|0)==30){c[g>>2]=4;ba=D;break}}}while(0);if((z|0)==69){ba=c[t>>2]|0}t=d;do{if((ba|0)==0){ca=0;da=1}else{d=c[ba+12>>2]|0;if((d|0)==(c[ba+16>>2]|0)){ea=$d[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ea=c[d>>2]|0}if(!((ea|0)==-1)){ca=ba;da=0;break}c[t>>2]=0;ca=0;da=1}}while(0);t=e;e=c[t>>2]|0;do{if((e|0)==0){z=82}else{ba=c[e+12>>2]|0;if((ba|0)==(c[e+16>>2]|0)){fa=$d[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{fa=c[ba>>2]|0}if((fa|0)==-1){c[t>>2]=0;z=82;break}if(!da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);do{if((z|0)==82){if(da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;ga=a;ha=ga;c[ha>>2]=ca;i=l;return}function AM(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function BM(a){a=a|0;i=i;return}function CM(a){a=a|0;i=i;return 2}function DM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];zM(a,b,l,k,f,g,h,93912,93944|0);i=j;return}function EM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=$d[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+4|0;s=q+4|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+(t<<2)|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];zM(b,d,m,l,g,h,j,s,q);i=k;return}function FM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;TI(n,f);f=n;n=c[f>>2]|0;if(!((c[23712]|0)==-1)){c[m>>2]=94848;c[m+4>>2]=171;c[m+8>>2]=0;IH(94848,m,172)}m=(c[94852>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Cc(4)|0;q=p;HR(q);r=110416;s=127;Kd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Cc(4)|0;q=p;HR(q);r=110416;s=127;Kd(p|0,r|0,s|0)}s=n;nH(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=$d[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=lL(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function GM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;TI(n,f);f=n;n=c[f>>2]|0;if(!((c[23712]|0)==-1)){c[m>>2]=94848;c[m+4>>2]=171;c[m+8>>2]=0;IH(94848,m,172)}m=(c[94852>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Cc(4)|0;q=p;HR(q);r=110416;s=127;Kd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Cc(4)|0;q=p;HR(q);r=110416;s=127;Kd(p|0,r|0,s|0)}s=n;nH(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=$d[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=lL(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function HM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;TI(m,f);f=m;m=c[f>>2]|0;if(!((c[23712]|0)==-1)){c[l>>2]=94848;c[l+4>>2]=171;c[l+8>>2]=0;IH(94848,l,172)}l=(c[94852>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Cc(4)|0;p=o;HR(p);q=110416;r=127;Kd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Cc(4)|0;p=o;HR(p);q=110416;r=127;Kd(o|0,q|0,r|0)}r=m;nH(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=MM(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function IM(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;TI(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[23712]|0)==-1)){c[ba>>2]=94848;c[ba+4>>2]=171;c[ba+8>>2]=0;IH(94848,ba,172)}ba=(c[94852>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Cc(4)|0;Ga=Fa;HR(Ga);Ha=110416;Ia=127;Kd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Cc(4)|0;Ga=Fa;HR(Ga);Ha=110416;Ia=127;Kd(Fa|0,Ha|0,Ia|0)}Ia=ca;nH(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Da=MM(e,H,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<24){c[j+8>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 70:{ca=e;c[ka>>2]=c[ca>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];zM(ja,d,J,I,g,h,j,93976,94008|0);c[ca>>2]=c[ja>>2];break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];ca=MM(e,w,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<61){c[j>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];LM(0,e,m,h,Ia);break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];JM(0,e,C,h,Ia);break};case 65:case 97:{Da=c[f>>2]|0;ca=d+8|0;Ha=$d[c[c[ca>>2]>>2]&127](ca)|0;c[aa>>2]=Da;c[Q+0>>2]=c[aa+0>>2];Da=(lL(e,Q,Ha,Ha+168|0,Ia,h,0)|0)-Ha|0;if((Da|0)>=168){break a}c[j+24>>2]=((Da|0)/12|0|0)%7|0;break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Da=MM(e,D,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<60){c[j+4>>2]=Da;break a}else{c[h>>2]=Ha|4;break a}break};case 99:{Ha=d+8|0;Da=$d[c[(c[Ha>>2]|0)+12>>2]&127](Ha)|0;Ha=e;c[ea>>2]=c[Ha>>2];c[fa>>2]=c[f>>2];ca=a[Da]|0;if((ca&1)==0){Ja=Da+4|0;Ka=Da+4|0;La=(ca&255)>>>1}else{ca=c[Da+8>>2]|0;Ja=ca;Ka=ca;La=c[Da+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];zM(da,d,O,N,g,h,j,Ka,Ja+(La<<2)|0);c[Ha>>2]=c[da>>2];break};case 84:{Ha=e;c[va>>2]=c[Ha>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];zM(ua,d,v,u,g,h,j,94080,94112|0);c[Ha>>2]=c[ua>>2];break};case 114:{Ha=e;c[pa>>2]=c[Ha>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];zM(oa,d,A,z,g,h,j,94008,94052|0);c[Ha>>2]=c[oa>>2];break};case 68:{Ha=e;c[ha>>2]=c[Ha>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];zM(ga,d,L,K,g,h,j,93944,93976|0);c[Ha>>2]=c[ga>>2];break};case 82:{Ha=e;c[sa>>2]=c[Ha>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];zM(ra,d,y,x,g,h,j,94056,94076|0);c[Ha>>2]=c[ra>>2];break};case 88:{Ha=d+8|0;Da=$d[c[(c[Ha>>2]|0)+24>>2]&127](Ha)|0;Ha=e;c[Aa>>2]=c[Ha>>2];c[Ba>>2]=c[f>>2];ca=a[Da]|0;if((ca&1)==0){Ma=Da+4|0;Na=Da+4|0;Oa=(ca&255)>>>1}else{ca=c[Da+8>>2]|0;Ma=ca;Na=ca;Oa=c[Da+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];zM(za,d,q,p,g,h,j,Na,Ma+(Oa<<2)|0);c[Ha>>2]=c[za>>2];break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Ha=MM(e,E,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Ha|0)<13){c[j+16>>2]=Ha+ -1;break a}else{c[h>>2]=Da|4;break a}break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Da=MM(e,F,h,Ia,3)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<366){c[j+28>>2]=Da;break a}else{c[h>>2]=Ha|4;break a}break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];KM(d,j+8|0,e,B,h,Ia);break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Ha=MM(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Ha+ -1900;break};case 104:case 66:case 98:{Ha=c[f>>2]|0;Da=d+8|0;ca=$d[c[(c[Da>>2]|0)+4>>2]&127](Da)|0;c[$>>2]=Ha;c[P+0>>2]=c[$+0>>2];Ha=(lL(e,P,ca,ca+288|0,Ia,h,0)|0)-ca|0;if((Ha|0)>=288){break a}c[j+16>>2]=((Ha|0)/12|0|0)%12|0;break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Ha=MM(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Ha|0)<69){Pa=Ha+2e3|0}else{Pa=(Ha+ -69|0)>>>0<31?Ha+1900|0:Ha}c[j+20>>2]=Pa+ -1900;break};case 120:{Ha=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];ke[Ha&63](b,d,s,r,g,h,j);i=l;return};case 101:case 100:{Ha=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];ca=MM(e,M,h,Ia,2)|0;Da=c[h>>2]|0;do{if((Da&4|0)==0){if(!((ca+ -1|0)>>>0<31)){break}c[Ha>>2]=ca;break a}}while(0);c[h>>2]=Da|4;break};case 73:{ca=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Ha=MM(e,G,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Ha+ -1|0)>>>0<12)){break}c[ca>>2]=Ha;break a}}while(0);c[h>>2]=Fa|4;break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];Ha=MM(e,t,h,Ia,1)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Ha|0)<7){c[j+24>>2]=Ha;break a}else{c[h>>2]=ca|4;break a}break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function JM(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;g=b;b=d;a:while(1){d=c[g>>2]|0;do{if((d|0)==0){h=1}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){k=$d[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);d=c[b>>2]|0;do{if((d|0)==0){l=15}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){m=$d[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[j>>2]|0}if((m|0)==-1){c[b>>2]=0;l=15;break}else{if(h){n=d;break}else{o=d;break a}}}}while(0);if((l|0)==15){l=0;if(h){o=0;break}else{n=0}}d=c[g>>2]|0;j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){p=$d[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{p=c[j>>2]|0}if(!(be[c[(c[f>>2]|0)+12>>2]&63](f,8192,p)|0)){o=n;break}j=c[g>>2]|0;d=j+12|0;q=c[d>>2]|0;if((q|0)==(c[j+16>>2]|0)){$d[c[(c[j>>2]|0)+40>>2]&127](j)|0;continue}else{c[d>>2]=q+4;continue}}n=c[g>>2]|0;do{if((n|0)==0){r=1}else{p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){s=$d[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{s=c[p>>2]|0}if((s|0)==-1){c[g>>2]=0;r=1;break}else{r=(c[g>>2]|0)==0;break}}}while(0);do{if((o|0)==0){l=37}else{g=c[o+12>>2]|0;if((g|0)==(c[o+16>>2]|0)){t=$d[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{t=c[g>>2]|0}if((t|0)==-1){c[b>>2]=0;l=37;break}if(!r){break}i=a;return}}while(0);do{if((l|0)==37){if(r){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function KM(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=$d[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=lL(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function LM(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;g=b;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=$d[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=$d[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{if(h){n=d;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){o=$d[c[(c[h>>2]|0)+36>>2]&127](h)|0}else{o=c[d>>2]|0}if(!((be[c[(c[f>>2]|0)+52>>2]&63](f,o,0)|0)<<24>>24==37)){c[e>>2]=c[e>>2]|4;i=a;return}o=c[g>>2]|0;f=o+12|0;d=c[f>>2]|0;if((d|0)==(c[o+16>>2]|0)){$d[c[(c[o>>2]|0)+40>>2]&127](o)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){p=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){q=$d[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{q=c[f>>2]|0}if((q|0)==-1){c[g>>2]=0;p=1;break}else{p=(c[g>>2]|0)==0;break}}}while(0);do{if((n|0)==0){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){r=$d[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{r=c[g>>2]|0}if((r|0)==-1){c[k>>2]=0;l=38;break}if(!p){break}i=a;return}}while(0);do{if((l|0)==38){if(p){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function MM(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;h=a;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=$d[c[(c[a>>2]|0)+36>>2]&127](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=$d[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=$d[c[(c[j>>2]|0)+36>>2]&127](j)|0}else{q=c[b>>2]|0}if(!(be[c[(c[e>>2]|0)+12>>2]&63](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}b=(be[c[(c[e>>2]|0)+52>>2]&63](e,q,0)|0)<<24>>24;q=c[h>>2]|0;j=q+12|0;n=c[j>>2]|0;if((n|0)==(c[q+16>>2]|0)){$d[c[(c[q>>2]|0)+40>>2]&127](q)|0;r=f;s=o;t=o;u=b}else{c[j>>2]=n+4;r=f;s=o;t=o;u=b}while(1){v=u+ -48|0;b=r+ -1|0;o=c[h>>2]|0;do{if((o|0)==0){w=1}else{f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0)){x=$d[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{x=c[f>>2]|0}if((x|0)==-1){c[h>>2]=0;w=1;break}else{w=(c[h>>2]|0)==0;break}}}while(0);do{if((t|0)==0){y=s;z=0;A=1}else{o=c[t+12>>2]|0;if((o|0)==(c[t+16>>2]|0)){B=$d[c[(c[t>>2]|0)+36>>2]&127](t)|0}else{B=c[o>>2]|0}if((B|0)==-1){c[l>>2]=0;y=0;z=0;A=1;break}else{y=s;z=s;A=(s|0)==0;break}}}while(0);C=c[h>>2]|0;if(!((w^A)&(b|0)>0)){break}o=c[C+12>>2]|0;if((o|0)==(c[C+16>>2]|0)){D=$d[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{D=c[o>>2]|0}if(!(be[c[(c[e>>2]|0)+12>>2]&63](e,2048,D)|0)){p=v;m=63;break}o=((be[c[(c[e>>2]|0)+52>>2]&63](e,D,0)|0)<<24>>24)+(v*10|0)|0;f=c[h>>2]|0;n=f+12|0;j=c[n>>2]|0;if((j|0)==(c[f+16>>2]|0)){$d[c[(c[f>>2]|0)+40>>2]&127](f)|0;E=b;s=y;t=z;u=o;r=E;continue}else{c[n>>2]=j+4;E=b;s=y;t=z;u=o;r=E;continue}}if((m|0)==63){i=g;return p|0}do{if((C|0)==0){F=1}else{E=c[C+12>>2]|0;if((E|0)==(c[C+16>>2]|0)){G=$d[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[h>>2]=0;F=1;break}else{F=(c[h>>2]|0)==0;break}}}while(0);do{if((y|0)==0){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){H=$d[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{H=c[h>>2]|0}if((H|0)==-1){c[l>>2]=0;m=60;break}if(F){p=v}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(F){break}else{p=v}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=v;i=g;return p|0}function NM(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);if((f|0)==(c[23686]|0)){g=b;iS(g);i=d;return}_b(c[e>>2]|0);g=b;iS(g);i=d;return}function OM(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);if((b|0)==(c[23686]|0)){i=d;return}_b(c[e>>2]|0);i=d;return}function PM(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;f=g;l=g+8|0;m=l;n=f;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(!(k<<24>>24==0)){a[o]=k;a[p]=j}j=Qc(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b;s=r;c[s>>2]=q;i=g;return}else{t=m;u=l;v=l}while(1){l=a[t]|0;do{if((v|0)==0){w=u;x=0}else{m=v+24|0;j=c[m>>2]|0;if((j|0)==(c[v+28>>2]|0)){e=(ne[c[(c[v>>2]|0)+52>>2]&63](v,l&255)|0)==-1;w=e?0:u;x=e?0:v;break}else{c[m>>2]=j+1;a[j]=l;w=u;x=v;break}}}while(0);l=t+1|0;if((l|0)==(d|0)){q=w;break}else{t=l;u=w;v=x}}r=b;s=r;c[s>>2]=q;i=g;return}function QM(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);if((f|0)==(c[23686]|0)){g=b;iS(g);i=d;return}_b(c[e>>2]|0);g=b;iS(g);i=d;return}function RM(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);if((b|0)==(c[23686]|0)){i=d;return}_b(c[e>>2]|0);i=d;return}function SM(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+408|0;e=f;k=f+400|0;l=e;c[k>>2]=e+400;TM(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a;o=n;c[o>>2]=m;i=f;return}else{p=l;q=k;r=k}while(1){k=c[p>>2]|0;if((q|0)==0){s=r;t=0}else{l=q+24|0;d=c[l>>2]|0;if((d|0)==(c[q+28>>2]|0)){u=ne[c[(c[q>>2]|0)+52>>2]&63](q,k)|0}else{c[l>>2]=d+4;c[d>>2]=k;u=k}k=(u|0)==-1;s=k?0:r;t=k?0:q}k=p+4|0;if((k|0)==(j|0)){m=s;break}else{p=k;q=t;r=s}}n=a;o=n;c[o>>2]=m;i=f;return}function TM(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j;l=j+112|0;m=i;i=i+8|0;n=j+8|0;o=k;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(!(h<<24>>24==0)){a[p]=h;a[q]=g}g=b;Qc(n|0,100,o|0,f|0,c[g>>2]|0)|0;f=l;c[f>>2]=0;c[f+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=Jc(c[g>>2]|0)|0;g=dR(d,m,n,l)|0;if((f|0)!=0){Jc(f|0)|0}if((g|0)==-1){PN(95736)}else{c[e>>2]=d+(g<<2);i=j;return}}function UM(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function VM(a){a=a|0;i=i;return}function WM(a){a=a|0;i=i;return 127}function XM(a){a=a|0;i=i;return 127}function YM(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function ZM(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function _M(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function $M(a,b){a=a|0;b=b|0;b=i;TH(a,1,45);i=b;return}function aN(a){a=a|0;i=i;return 0}function bN(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function cN(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function dN(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function eN(a){a=a|0;i=i;return}function fN(a){a=a|0;i=i;return 127}function gN(a){a=a|0;i=i;return 127}function hN(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function iN(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function jN(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function kN(a,b){a=a|0;b=b|0;b=i;TH(a,1,45);i=b;return}function lN(a){a=a|0;i=i;return 0}function mN(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function nN(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function oN(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function pN(a){a=a|0;i=i;return}function qN(a){a=a|0;i=i;return 2147483647}function rN(a){a=a|0;i=i;return 2147483647}function sN(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function tN(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function uN(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function vN(a,b){a=a|0;b=b|0;b=i;yI(a,1,45);i=b;return}function wN(a){a=a|0;i=i;return 0}function xN(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function yN(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function zN(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function AN(a){a=a|0;i=i;return}function BN(a){a=a|0;i=i;return 2147483647}function CN(a){a=a|0;i=i;return 2147483647}function DN(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function EN(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function FN(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function GN(a,b){a=a|0;b=b|0;b=i;yI(a,1,45);i=b;return}function HN(a){a=a|0;i=i;return 0}function IN(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function JN(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function KN(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function LN(a){a=a|0;i=i;return}function MN(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+104|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=173;y=o+100|0;TI(r,h);o=r;z=c[o>>2]|0;if(!((c[23714]|0)==-1)){c[n>>2]=94856;c[n+4>>2]=171;c[n+8>>2]=0;IH(94856,n,172)}n=(c[94860>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Cc(4)|0;C=B;HR(C);D=110416;E=127;Kd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Cc(4)|0;C=B;HR(C);D=110416;E=127;Kd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=ON(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;xe[c[(c[z>>2]|0)+32>>2]&63](E,94472,94482|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>98){l=aS(g+2|0)|0;if((l|0)!=0){F=l;G=l;break}nS()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+10|0;l=u;h=H;t=r;while(1){C=a[t]|0;n=y;while(1){A=n+1|0;if((a[n]|0)==C<<24>>24){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[94472+(I-l)|0]|0;n=t+1|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((pd(p|0,94488,m|0)|0)!=1){t=Cc(8)|0;tH(t,94496);Kd(t|0,91848,42)}if((F|0)==0){break}bS(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){K=e;break}if(!(($d[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){K=e;break}c[F>>2]=0;K=0}}while(0);F=(K|0)==0;e=c[D>>2]|0;do{if((e|0)==0){L=31}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){if(F){break}else{L=33;break}}if(($d[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[D>>2]=0;L=31;break}else{if(F){break}else{L=33;break}}}}while(0);if((L|0)==31){if(F){L=33}}if((L|0)==33){c[j>>2]=c[j>>2]|2}c[b>>2]=K;nH(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}Yd[c[x>>2]&255](o);i=d;return}function NN(a){a=a|0;i=i;return}function ON(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;q=i;i=i+408|0;r=q;s=q+400|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=r;c[s>>2]=0;E=w;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=x;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=y;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=z;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=A;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;SN(g,h,t,u,v,w,x,y,z,B);t=n;c[o>>2]=c[t>>2];h=e;e=f;f=m+8|0;m=z+1|0;g=z+4|0;E=z+8|0;F=y+1|0;G=y+4|0;H=y+8|0;I=(j&512|0)!=0;j=x+1|0;J=x+8|0;K=x+4|0;L=A+1|0;M=A+8|0;N=A+4|0;O=s+3|0;P=n+4|0;n=w+4|0;Q=r+400|0;r=D;R=D;D=p;p=0;S=0;T=173;a:while(1){U=c[h>>2]|0;do{if((U|0)==0){V=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){V=U;break}if(($d[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;V=0;break}else{V=c[h>>2]|0;break}}}while(0);U=(V|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=12}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}if(($d[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=12;break}else{if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}}}while(0);if((X|0)==12){X=0;if(U){Z=R;_=r;$=S;aa=T;X=269;break}else{Y=0}}b:do{switch(a[s+p|0]|0){case 1:{if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}W=c[h>>2]|0;ba=c[W+12>>2]|0;if((ba|0)==(c[W+16>>2]|0)){ca=($d[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255}else{ca=a[ba]|0}if(!(ca<<24>>24>-1)){X=25;break a}if((b[(c[f>>2]|0)+(ca<<24>>24<<1)>>1]&8192)==0){X=25;break a}ba=c[h>>2]|0;W=ba+12|0;da=c[W>>2]|0;if((da|0)==(c[ba+16>>2]|0)){ea=($d[c[(c[ba>>2]|0)+40>>2]&127](ba)|0)&255}else{c[W>>2]=da+1;ea=a[da]|0}nI(A,ea);X=26;break};case 2:{if(!((S|0)!=0|p>>>0<2)){if((p|0)==2){fa=(a[O]|0)!=0}else{fa=0}if(!(I|fa)){ga=D;ha=R;ia=r;ja=Q;ka=0;la=T;break b}}da=a[x]|0;W=(da&1)==0;ba=W?j:c[J>>2]|0;c:do{if((p|0)==0){ma=Y;na=Y;oa=da;pa=ba}else{if((d[s+(p+ -1)|0]|0)>=2){ma=Y;na=Y;oa=da;pa=ba;break}qa=ba+(W?(da&255)>>>1:c[K>>2]|0)|0;ra=ba;while(1){if((ra|0)==(qa|0)){sa=qa;break}ta=a[ra]|0;if(!(ta<<24>>24>-1)){sa=ra;break}if((b[(c[f>>2]|0)+(ta<<24>>24<<1)>>1]&8192)==0){sa=ra;break}else{ra=ra+1|0}}ra=sa-ba|0;qa=a[A]|0;ta=(qa&1)==0;if(ta){ua=(qa&255)>>>1}else{ua=c[N>>2]|0}if(ra>>>0>ua>>>0){ma=Y;na=Y;oa=da;pa=ba;break}if(ta){ta=(qa&255)>>>1;va=A+1+(ta-ra)|0;wa=L;xa=ta}else{ta=c[M>>2]|0;qa=c[N>>2]|0;va=ta+(qa-ra)|0;wa=ta;xa=qa}qa=wa+xa|0;if((va|0)==(qa|0)){ma=Y;na=Y;oa=da;pa=sa;break}else{ya=ba;za=va}while(1){if((a[za]|0)!=(a[ya]|0)){ma=Y;na=Y;oa=da;pa=ba;break c}ta=za+1|0;if((ta|0)==(qa|0)){ma=Y;na=Y;oa=da;pa=sa;break}else{ya=ya+1|0;za=ta}}}}while(0);d:while(1){if((oa&1)==0){Aa=j;Ba=(oa&255)>>>1}else{Aa=c[J>>2]|0;Ba=c[K>>2]|0}if((pa|0)==(Aa+Ba|0)){break}da=c[h>>2]|0;do{if((da|0)==0){Ca=0}else{if((c[da+12>>2]|0)!=(c[da+16>>2]|0)){Ca=da;break}if(($d[c[(c[da>>2]|0)+36>>2]&127](da)|0)==-1){c[h>>2]=0;Ca=0;break}else{Ca=c[h>>2]|0;break}}}while(0);da=(Ca|0)==0;do{if((na|0)==0){Da=ma;X=147}else{if((c[na+12>>2]|0)!=(c[na+16>>2]|0)){if(da){Ea=ma;Fa=na;break}else{break d}}if(($d[c[(c[na>>2]|0)+36>>2]&127](na)|0)==-1){c[e>>2]=0;Da=0;X=147;break}else{if(da^(ma|0)==0){Ea=ma;Fa=ma;break}else{break d}}}}while(0);if((X|0)==147){X=0;if(da){break}else{Ea=Da;Fa=0}}ba=c[h>>2]|0;W=c[ba+12>>2]|0;if((W|0)==(c[ba+16>>2]|0)){Ga=($d[c[(c[ba>>2]|0)+36>>2]&127](ba)|0)&255}else{Ga=a[W]|0}if(!(Ga<<24>>24==(a[pa]|0))){break}W=c[h>>2]|0;ba=W+12|0;qa=c[ba>>2]|0;if((qa|0)==(c[W+16>>2]|0)){$d[c[(c[W>>2]|0)+40>>2]&127](W)|0}else{c[ba>>2]=qa+1}ma=Ea;na=Fa;oa=a[x]|0;pa=pa+1|0}if(!I){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}qa=a[x]|0;if((qa&1)==0){Ha=j;Ia=(qa&255)>>>1}else{Ha=c[J>>2]|0;Ia=c[K>>2]|0}if((pa|0)==(Ha+Ia|0)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T}else{X=162;break a}break};case 4:{qa=D;ba=R;W=r;ta=Q;ra=0;Ja=T;e:while(1){Ka=c[h>>2]|0;do{if((Ka|0)==0){La=0}else{if((c[Ka+12>>2]|0)!=(c[Ka+16>>2]|0)){La=Ka;break}if(($d[c[(c[Ka>>2]|0)+36>>2]&127](Ka)|0)==-1){c[h>>2]=0;La=0;break}else{La=c[h>>2]|0;break}}}while(0);Ka=(La|0)==0;da=c[e>>2]|0;do{if((da|0)==0){X=173}else{if((c[da+12>>2]|0)!=(c[da+16>>2]|0)){if(Ka){break}else{break e}}if(($d[c[(c[da>>2]|0)+36>>2]&127](da)|0)==-1){c[e>>2]=0;X=173;break}else{if(Ka){break}else{break e}}}}while(0);if((X|0)==173){X=0;if(Ka){break}}da=c[h>>2]|0;Ma=c[da+12>>2]|0;if((Ma|0)==(c[da+16>>2]|0)){Na=($d[c[(c[da>>2]|0)+36>>2]&127](da)|0)&255}else{Na=a[Ma]|0}do{if(Na<<24>>24>-1){if((b[(c[f>>2]|0)+(Na<<24>>24<<1)>>1]&2048)==0){X=189;break}Ma=c[o>>2]|0;if((Ma|0)==(qa|0)){da=(c[P>>2]|0)!=173;Oa=c[t>>2]|0;Pa=qa-Oa|0;Qa=Pa>>>0<2147483647?Pa<<1:-1;Ra=dS(da?Oa:0,Qa)|0;if((Ra|0)==0){X=182;break a}do{if(da){c[t>>2]=Ra;Sa=Ra}else{Oa=c[t>>2]|0;c[t>>2]=Ra;if((Oa|0)==0){Sa=Ra;break}Yd[c[P>>2]&255](Oa);Sa=c[t>>2]|0}}while(0);c[P>>2]=148;Ra=Sa+Pa|0;c[o>>2]=Ra;Ta=Ra;Ua=(c[t>>2]|0)+Qa|0}else{Ta=Ma;Ua=qa}c[o>>2]=Ta+1;a[Ta]=Na;Va=Ua;Wa=ba;Xa=W;Ya=ta;Za=ra+1|0;_a=Ja}else{X=189}}while(0);if((X|0)==189){X=0;Ka=a[w]|0;if((Ka&1)==0){$a=(Ka&255)>>>1}else{$a=c[n>>2]|0}if(($a|0)==0|(ra|0)==0){break}if(!(Na<<24>>24==(a[v]|0))){break}if((W|0)==(ta|0)){Ka=W-ba|0;Ra=Ka>>>0<2147483647?Ka<<1:-1;if((Ja|0)==173){ab=0}else{ab=ba}da=dS(ab,Ra)|0;if((da|0)==0){X=198;break a}bb=da;cb=da+(Ka>>2<<2)|0;db=da+(Ra>>>2<<2)|0;eb=148}else{bb=ba;cb=W;db=ta;eb=Ja}c[cb>>2]=ra;Va=qa;Wa=bb;Xa=cb+4|0;Ya=db;Za=0;_a=eb}Ra=c[h>>2]|0;da=Ra+12|0;Ka=c[da>>2]|0;if((Ka|0)==(c[Ra+16>>2]|0)){$d[c[(c[Ra>>2]|0)+40>>2]&127](Ra)|0;qa=Va;ba=Wa;W=Xa;ta=Ya;ra=Za;Ja=_a;continue}else{c[da>>2]=Ka+1;qa=Va;ba=Wa;W=Xa;ta=Ya;ra=Za;Ja=_a;continue}}if((ba|0)==(W|0)|(ra|0)==0){fb=ba;gb=W;hb=ta;ib=Ja}else{if((W|0)==(ta|0)){Ka=W-ba|0;da=Ka>>>0<2147483647?Ka<<1:-1;if((Ja|0)==173){jb=0}else{jb=ba}Ra=dS(jb,da)|0;if((Ra|0)==0){X=209;break a}kb=Ra;lb=Ra+(Ka>>2<<2)|0;mb=Ra+(da>>>2<<2)|0;nb=148}else{kb=ba;lb=W;mb=ta;nb=Ja}c[lb>>2]=ra;fb=kb;gb=lb+4|0;hb=mb;ib=nb}if((c[B>>2]|0)>0){da=c[h>>2]|0;do{if((da|0)==0){ob=0}else{if((c[da+12>>2]|0)!=(c[da+16>>2]|0)){ob=da;break}if(($d[c[(c[da>>2]|0)+36>>2]&127](da)|0)==-1){c[h>>2]=0;ob=0;break}else{ob=c[h>>2]|0;break}}}while(0);da=(ob|0)==0;ra=c[e>>2]|0;do{if((ra|0)==0){X=223}else{if((c[ra+12>>2]|0)!=(c[ra+16>>2]|0)){if(da){pb=ra;break}else{X=229;break a}}if(($d[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)==-1){c[e>>2]=0;X=223;break}else{if(da){pb=ra;break}else{X=229;break a}}}}while(0);if((X|0)==223){X=0;if(da){X=229;break a}else{pb=0}}ra=c[h>>2]|0;Ja=c[ra+12>>2]|0;if((Ja|0)==(c[ra+16>>2]|0)){qb=($d[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)&255}else{qb=a[Ja]|0}if(!(qb<<24>>24==(a[u]|0))){X=229;break a}Ja=c[h>>2]|0;ra=Ja+12|0;ta=c[ra>>2]|0;if((ta|0)==(c[Ja+16>>2]|0)){$d[c[(c[Ja>>2]|0)+40>>2]&127](Ja)|0;rb=pb;sb=pb;tb=qa}else{c[ra>>2]=ta+1;rb=pb;sb=pb;tb=qa}while(1){ta=c[h>>2]|0;do{if((ta|0)==0){ub=0}else{if((c[ta+12>>2]|0)!=(c[ta+16>>2]|0)){ub=ta;break}if(($d[c[(c[ta>>2]|0)+36>>2]&127](ta)|0)==-1){c[h>>2]=0;ub=0;break}else{ub=c[h>>2]|0;break}}}while(0);ta=(ub|0)==0;do{if((sb|0)==0){vb=rb;X=243}else{if((c[sb+12>>2]|0)!=(c[sb+16>>2]|0)){if(ta){wb=rb;xb=sb;break}else{X=250;break a}}if(($d[c[(c[sb>>2]|0)+36>>2]&127](sb)|0)==-1){c[e>>2]=0;vb=0;X=243;break}else{if(ta^(rb|0)==0){wb=rb;xb=rb;break}else{X=250;break a}}}}while(0);if((X|0)==243){X=0;if(ta){X=250;break a}else{wb=vb;xb=0}}ra=c[h>>2]|0;Ja=c[ra+12>>2]|0;if((Ja|0)==(c[ra+16>>2]|0)){yb=($d[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)&255}else{yb=a[Ja]|0}if(!(yb<<24>>24>-1)){X=250;break a}if((b[(c[f>>2]|0)+(yb<<24>>24<<1)>>1]&2048)==0){X=250;break a}Ja=c[o>>2]|0;if((Ja|0)==(tb|0)){ra=(c[P>>2]|0)!=173;W=c[t>>2]|0;ba=tb-W|0;Ra=ba>>>0<2147483647?ba<<1:-1;Ka=dS(ra?W:0,Ra)|0;if((Ka|0)==0){X=253;break a}do{if(ra){c[t>>2]=Ka;zb=Ka}else{W=c[t>>2]|0;c[t>>2]=Ka;if((W|0)==0){zb=Ka;break}Yd[c[P>>2]&255](W);zb=c[t>>2]|0}}while(0);c[P>>2]=148;Ka=zb+ba|0;c[o>>2]=Ka;Ab=Ka;Bb=(c[t>>2]|0)+Ra|0}else{Ab=Ja;Bb=tb}Ka=c[h>>2]|0;ra=c[Ka+12>>2]|0;if((ra|0)==(c[Ka+16>>2]|0)){ta=($d[c[(c[Ka>>2]|0)+36>>2]&127](Ka)|0)&255;Cb=ta;Db=c[o>>2]|0}else{Cb=a[ra]|0;Db=Ab}c[o>>2]=Db+1;a[Db]=Cb;ra=(c[B>>2]|0)+ -1|0;c[B>>2]=ra;ta=c[h>>2]|0;Ka=ta+12|0;W=c[Ka>>2]|0;if((W|0)==(c[ta+16>>2]|0)){$d[c[(c[ta>>2]|0)+40>>2]&127](ta)|0}else{c[Ka>>2]=W+1}if((ra|0)>0){rb=wb;sb=xb;tb=Bb}else{Eb=Bb;break}}}else{Eb=qa}if((c[o>>2]|0)==(c[t>>2]|0)){X=267;break a}else{ga=Eb;ha=fb;ia=gb;ja=hb;ka=S;la=ib}break};case 0:{X=26;break};case 3:{da=a[y]|0;ra=(da&1)==0;if(ra){Fb=(da&255)>>>1}else{Fb=c[G>>2]|0}W=a[z]|0;Ka=(W&1)==0;if(Ka){Gb=(W&255)>>>1}else{Gb=c[g>>2]|0}if((Fb|0)==(0-Gb|0)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}if(ra){Hb=(da&255)>>>1}else{Hb=c[G>>2]|0}do{if((Hb|0)!=0){if(Ka){Ib=(W&255)>>>1}else{Ib=c[g>>2]|0}if((Ib|0)==0){break}ta=c[h>>2]|0;Oa=c[ta+12>>2]|0;Jb=c[ta+16>>2]|0;if((Oa|0)==(Jb|0)){Kb=($d[c[(c[ta>>2]|0)+36>>2]&127](ta)|0)&255;Lb=c[h>>2]|0;Mb=Kb;Nb=c[Lb+16>>2]|0;Ob=c[Lb+12>>2]|0;Pb=Lb;Qb=a[y]|0}else{Mb=a[Oa]|0;Nb=Jb;Ob=Oa;Pb=ta;Qb=da}ta=Pb+12|0;Oa=(Ob|0)==(Nb|0);if(Mb<<24>>24==(a[(Qb&1)==0?F:c[H>>2]|0]|0)){if(Oa){$d[c[(c[Pb>>2]|0)+40>>2]&127](Pb)|0}else{c[ta>>2]=Ob+1}ta=a[y]|0;if((ta&1)==0){Rb=(ta&255)>>>1}else{Rb=c[G>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Rb>>>0>1?y:S;la=T;break b}if(Oa){Sb=($d[c[(c[Pb>>2]|0)+36>>2]&127](Pb)|0)&255}else{Sb=a[Ob]|0}if(!(Sb<<24>>24==(a[(a[z]&1)==0?m:c[E>>2]|0]|0))){X=112;break a}Oa=c[h>>2]|0;ta=Oa+12|0;Jb=c[ta>>2]|0;if((Jb|0)==(c[Oa+16>>2]|0)){$d[c[(c[Oa>>2]|0)+40>>2]&127](Oa)|0}else{c[ta>>2]=Jb+1}a[l]=1;Jb=a[z]|0;if((Jb&1)==0){Tb=(Jb&255)>>>1}else{Tb=c[g>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Tb>>>0>1?z:S;la=T;break b}}while(0);if(ra){Ub=(da&255)>>>1}else{Ub=c[G>>2]|0}Ka=c[h>>2]|0;qa=c[Ka+12>>2]|0;Jb=(qa|0)==(c[Ka+16>>2]|0);if((Ub|0)==0){if(Jb){ta=($d[c[(c[Ka>>2]|0)+36>>2]&127](Ka)|0)&255;Vb=ta;Wb=a[z]|0}else{Vb=a[qa]|0;Wb=W}if(!(Vb<<24>>24==(a[(Wb&1)==0?m:c[E>>2]|0]|0))){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}ta=c[h>>2]|0;Oa=ta+12|0;Lb=c[Oa>>2]|0;if((Lb|0)==(c[ta+16>>2]|0)){$d[c[(c[ta>>2]|0)+40>>2]&127](ta)|0}else{c[Oa>>2]=Lb+1}a[l]=1;Lb=a[z]|0;if((Lb&1)==0){Xb=(Lb&255)>>>1}else{Xb=c[g>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Xb>>>0>1?z:S;la=T;break b}if(Jb){Jb=($d[c[(c[Ka>>2]|0)+36>>2]&127](Ka)|0)&255;Yb=Jb;Zb=a[y]|0}else{Yb=a[qa]|0;Zb=da}if(!(Yb<<24>>24==(a[(Zb&1)==0?F:c[H>>2]|0]|0))){a[l]=1;ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}qa=c[h>>2]|0;Jb=qa+12|0;Ka=c[Jb>>2]|0;if((Ka|0)==(c[qa+16>>2]|0)){$d[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[Jb>>2]=Ka+1}Ka=a[y]|0;if((Ka&1)==0){_b=(Ka&255)>>>1}else{_b=c[G>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=_b>>>0>1?y:S;la=T;break};default:{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T}}}while(0);f:do{if((X|0)==26){X=0;if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}else{$b=Y;ac=Y}while(1){U=c[h>>2]|0;do{if((U|0)==0){bc=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){bc=U;break}if(($d[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;bc=0;break}else{bc=c[h>>2]|0;break}}}while(0);U=(bc|0)==0;do{if((ac|0)==0){cc=$b;X=37}else{if((c[ac+12>>2]|0)!=(c[ac+16>>2]|0)){if(U){dc=$b;ec=ac;break}else{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}}if(($d[c[(c[ac>>2]|0)+36>>2]&127](ac)|0)==-1){c[e>>2]=0;cc=0;X=37;break}else{if(U^($b|0)==0){dc=$b;ec=$b;break}else{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}}}}while(0);if((X|0)==37){X=0;if(U){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}else{dc=cc;ec=0}}Ja=c[h>>2]|0;Ra=c[Ja+12>>2]|0;if((Ra|0)==(c[Ja+16>>2]|0)){fc=($d[c[(c[Ja>>2]|0)+36>>2]&127](Ja)|0)&255}else{fc=a[Ra]|0}if(!(fc<<24>>24>-1)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}if((b[(c[f>>2]|0)+(fc<<24>>24<<1)>>1]&8192)==0){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}Ra=c[h>>2]|0;Ja=Ra+12|0;ba=c[Ja>>2]|0;if((ba|0)==(c[Ra+16>>2]|0)){gc=($d[c[(c[Ra>>2]|0)+40>>2]&127](Ra)|0)&255}else{c[Ja>>2]=ba+1;gc=a[ba]|0}nI(A,gc);$b=dc;ac=ec}}}while(0);da=p+1|0;if(da>>>0<4){Q=ja;r=ia;R=ha;D=ga;p=da;S=ka;T=la}else{Z=ha;_=ia;$=ka;aa=la;X=269;break}}g:do{if((X|0)==25){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==112){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==162){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==182){nS()}else if((X|0)==198){nS()}else if((X|0)==209){nS()}else if((X|0)==229){c[k>>2]=c[k>>2]|4;hc=0;ic=fb;jc=ib}else if((X|0)==250){c[k>>2]=c[k>>2]|4;hc=0;ic=fb;jc=ib}else if((X|0)==253){nS()}else if((X|0)==267){c[k>>2]=c[k>>2]|4;hc=0;ic=fb;jc=ib}else if((X|0)==269){h:do{if(($|0)!=0){la=$+1|0;ka=$+8|0;ia=$+4|0;ha=1;i:while(1){S=a[$]|0;if((S&1)==0){kc=(S&255)>>>1}else{kc=c[ia>>2]|0}if(!(ha>>>0<kc>>>0)){break h}S=c[h>>2]|0;do{if((S|0)==0){lc=0}else{if((c[S+12>>2]|0)!=(c[S+16>>2]|0)){lc=S;break}if(($d[c[(c[S>>2]|0)+36>>2]&127](S)|0)==-1){c[h>>2]=0;lc=0;break}else{lc=c[h>>2]|0;break}}}while(0);S=(lc|0)==0;U=c[e>>2]|0;do{if((U|0)==0){X=285}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){if(S){break}else{break i}}if(($d[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[e>>2]=0;X=285;break}else{if(S){break}else{break i}}}}while(0);if((X|0)==285){X=0;if(S){break}}U=c[h>>2]|0;p=c[U+12>>2]|0;if((p|0)==(c[U+16>>2]|0)){mc=($d[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{mc=a[p]|0}if((a[$]&1)==0){nc=la}else{nc=c[ka>>2]|0}if(!(mc<<24>>24==(a[nc+ha|0]|0))){break}p=ha+1|0;U=c[h>>2]|0;ga=U+12|0;D=c[ga>>2]|0;if((D|0)==(c[U+16>>2]|0)){$d[c[(c[U>>2]|0)+40>>2]&127](U)|0;ha=p;continue}else{c[ga>>2]=D+1;ha=p;continue}}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa;break g}}while(0);if((Z|0)==(_|0)){hc=1;ic=_;jc=aa;break}c[C>>2]=0;TN(w,Z,_,C);if((c[C>>2]|0)==0){hc=1;ic=Z;jc=aa;break}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa}}while(0);XH(A);XH(z);XH(y);XH(x);XH(w);if((ic|0)==0){i=q;return hc|0}Yd[jc&255](ic);i=q;return hc|0}function PN(a){a=a|0;var b=0;b=Cc(8)|0;tH(b,a);Kd(b|0,91848,42)}function QN(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+168|0;l=d;m=d+8|0;n=d+24|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=173;v=n+100|0;TI(q,h);n=q;w=c[n>>2]|0;if(!((c[23714]|0)==-1)){c[m>>2]=94856;c[m+4>>2]=171;c[m+8>>2]=0;IH(94856,m,172)}m=(c[94860>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Cc(4)|0;z=y;HR(z);A=110416;B=127;Kd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Cc(4)|0;z=y;HR(z);A=110416;B=127;Kd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=ON(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}if((a[r]|0)!=0){nI(k,ne[c[(c[w>>2]|0)+28>>2]&63](B,45)|0)}r=ne[c[(c[w>>2]|0)+28>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -1|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+1|0;if(!((a[z]|0)==r<<24>>24)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);RN(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){D=e;break}if(!(($d[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){D=e;break}c[w>>2]=0;D=0}}while(0);w=(D|0)==0;do{if((f|0)==0){E=25}else{if((c[f+12>>2]|0)!=(c[f+16>>2]|0)){if(w){break}else{E=27;break}}if(($d[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1){c[A>>2]=0;E=25;break}else{if(w^(f|0)==0){break}else{E=27;break}}}}while(0);if((E|0)==25){if(w){E=27}}if((E|0)==27){c[j>>2]=c[j>>2]|2}c[b>>2]=D;nH(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}Yd[c[u>>2]&255](n);i=d;return}function RN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=10}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g|0;if((e|0)==(d|0)){i=f;return b|0}if((l-j|0)>>>0<h>>>0){qI(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;k=g+1|0;if((k|0)==(e|0)){break}else{d=d+1|0;g=k}}a[n+m|0]=0;m=j+h|0;if((a[b]&1)==0){a[b]=m<<1;i=f;return b|0}else{c[b+4>>2]=m;i=f;return b|0}return 0}function SN(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[23574]|0)==-1)){c[p>>2]=94296;c[p+4>>2]=171;c[p+8>>2]=0;IH(94296,p,172)}p=(c[94300>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Cc(4)|0;C=B;HR(C);D=110416;E=127;Kd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Cc(4)|0;C=B;HR(C);D=110416;E=127;Kd(B|0,D|0,E|0)}E=b;Zd[c[(c[b>>2]|0)+44>>2]&63](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;Zd[c[(c[b>>2]|0)+32>>2]&63](r,E);B=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}hI(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;XH(r);Zd[c[(c[b>>2]|0)+28>>2]&63](s,E);r=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}hI(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;XH(s);a[f]=$d[c[(c[b>>2]|0)+12>>2]&127](E)|0;a[g]=$d[c[(c[b>>2]|0)+16>>2]&127](E)|0;Zd[c[(c[b>>2]|0)+20>>2]&63](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}hI(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;XH(t);Zd[c[(c[b>>2]|0)+24>>2]&63](u,E);t=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}hI(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;XH(u);F=$d[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[23558]|0)==-1)){c[o>>2]=94232;c[o+4>>2]=171;c[o+8>>2]=0;IH(94232,o,172)}o=(c[94236>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Cc(4)|0;H=G;HR(H);I=110416;J=127;Kd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Cc(4)|0;H=G;HR(H);I=110416;J=127;Kd(G|0,I|0,J|0)}J=E;Zd[c[(c[E>>2]|0)+44>>2]&63](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;Zd[c[(c[E>>2]|0)+32>>2]&63](w,J);e=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}hI(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;XH(w);Zd[c[(c[E>>2]|0)+28>>2]&63](x,J);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}hI(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;XH(x);a[f]=$d[c[(c[E>>2]|0)+12>>2]&127](J)|0;a[g]=$d[c[(c[E>>2]|0)+16>>2]&127](J)|0;Zd[c[(c[E>>2]|0)+20>>2]&63](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}hI(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;XH(y);Zd[c[(c[E>>2]|0)+24>>2]&63](z,J);y=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}hI(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;XH(z);F=$d[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function TN(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[b+4>>2]|0}if((j|0)==0){i=g;return}do{if((d|0)==(e|0)){k=h}else{j=e+ -4|0;if(j>>>0>d>>>0){l=d;m=j}else{k=h;break}do{j=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=j;l=l+4|0;m=m+ -4|0;}while(l>>>0<m>>>0);k=a[b]|0}}while(0);if((k&1)==0){n=b+1|0;o=(k&255)>>>1}else{n=c[b+8>>2]|0;o=c[b+4>>2]|0}b=e+ -4|0;e=a[n]|0;k=e<<24>>24<1|e<<24>>24==127;a:do{if(b>>>0>d>>>0){m=n+o|0;l=e;h=n;j=d;p=k;while(1){if(!p){if((l<<24>>24|0)!=(c[j>>2]|0)){break}}q=(m-h|0)>1?h+1|0:h;r=j+4|0;s=a[q]|0;t=s<<24>>24<1|s<<24>>24==127;if(r>>>0<b>>>0){l=s;h=q;j=r;p=t}else{u=s;v=t;break a}}c[f>>2]=4;i=g;return}else{u=e;v=k}}while(0);if(v){i=g;return}v=c[b>>2]|0;if(!(u<<24>>24>>>0<v>>>0|(v|0)==0)){i=g;return}c[f>>2]=4;i=g;return}function UN(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function VN(a){a=a|0;i=i;return}function WN(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+400|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+40|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=173;y=o+400|0;TI(r,h);o=r;z=c[o>>2]|0;if(!((c[23712]|0)==-1)){c[n>>2]=94848;c[n+4>>2]=171;c[n+8>>2]=0;IH(94848,n,172)}n=(c[94852>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Cc(4)|0;C=B;HR(C);D=110416;E=127;Kd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Cc(4)|0;C=B;HR(C);D=110416;E=127;Kd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=XN(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;xe[c[(c[z>>2]|0)+48>>2]&63](E,94552,94562|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>392){l=aS((g>>2)+2|0)|0;if((l|0)!=0){F=l;G=l;break}nS()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+40|0;l=u;h=H;t=r;while(1){C=c[t>>2]|0;n=y;while(1){A=n+4|0;if((c[n>>2]|0)==(C|0)){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[94552+(I-l>>2)|0]|0;n=t+4|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((pd(p|0,94488,m|0)|0)!=1){t=Cc(8)|0;tH(t,94496);Kd(t|0,91848,42)}if((F|0)==0){break}bS(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=1}else{m=c[e+12>>2]|0;if((m|0)==(c[e+16>>2]|0)){L=$d[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{L=c[m>>2]|0}if((L|0)==-1){c[F>>2]=0;K=1;break}else{K=(c[F>>2]|0)==0;break}}}while(0);L=c[D>>2]|0;do{if((L|0)==0){M=35}else{e=c[L+12>>2]|0;if((e|0)==(c[L+16>>2]|0)){N=$d[c[(c[L>>2]|0)+36>>2]&127](L)|0}else{N=c[e>>2]|0}if((N|0)==-1){c[D>>2]=0;M=35;break}else{if(K){break}else{M=37;break}}}}while(0);if((M|0)==35){if(K){M=37}}if((M|0)==37){c[j>>2]=c[j>>2]|2}c[b>>2]=c[F>>2];nH(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}Yd[c[x>>2]&255](o);i=d;return}



function XN(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0;p=i;i=i+416|0;q=p;r=p+8|0;s=p+408|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;c[q>>2]=o;o=r;c[s>>2]=0;D=w;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=x;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=y;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=z;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=A;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;_N(f,g,t,u,v,w,x,y,z,B);t=m;c[n>>2]=c[t>>2];g=b;b=e;e=z+4|0;f=z+8|0;D=y+4|0;E=y+8|0;F=(h&512|0)!=0;h=x+4|0;G=x+8|0;H=A+4|0;I=A+8|0;J=s+3|0;K=w+4|0;L=r+400|0;r=o;M=o;o=0;N=0;O=173;a:while(1){P=c[g>>2]|0;do{if((P|0)==0){Q=1}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=$d[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{S=c[R>>2]|0}if((S|0)==-1){c[g>>2]=0;Q=1;break}else{Q=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=15}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){U=$d[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{U=c[R>>2]|0}if((U|0)==-1){c[b>>2]=0;T=15;break}else{if(Q){V=P;break}else{W=M;X=r;Y=N;Z=O;T=276;break a}}}}while(0);if((T|0)==15){T=0;if(Q){W=M;X=r;Y=N;Z=O;T=276;break}else{V=0}}b:do{switch(a[s+o|0]|0){case 1:{if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}P=c[g>>2]|0;R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){_=$d[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{_=c[R>>2]|0}if(!(be[c[(c[l>>2]|0)+12>>2]&63](l,8192,_)|0)){T=27;break a}R=c[g>>2]|0;P=R+12|0;$=c[P>>2]|0;if(($|0)==(c[R+16>>2]|0)){aa=$d[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[P>>2]=$+4;aa=c[$>>2]|0}DI(A,aa);T=28;break};case 3:{$=a[y]|0;P=($&1)==0;if(P){ba=($&255)>>>1}else{ba=c[D>>2]|0}R=a[z]|0;ca=(R&1)==0;if(ca){da=(R&255)>>>1}else{da=c[e>>2]|0}if((ba|0)==(0-da|0)){ea=M;fa=r;ga=L;ha=N;ia=O;break b}if(P){ja=($&255)>>>1}else{ja=c[D>>2]|0}do{if((ja|0)!=0){if(ca){ka=(R&255)>>>1}else{ka=c[e>>2]|0}if((ka|0)==0){break}la=c[g>>2]|0;ma=c[la+12>>2]|0;if((ma|0)==(c[la+16>>2]|0)){na=$d[c[(c[la>>2]|0)+36>>2]&127](la)|0;oa=na;pa=a[y]|0}else{oa=c[ma>>2]|0;pa=$}ma=c[g>>2]|0;na=ma+12|0;la=c[na>>2]|0;qa=(la|0)==(c[ma+16>>2]|0);if((oa|0)==(c[((pa&1)==0?D:c[E>>2]|0)>>2]|0)){if(qa){$d[c[(c[ma>>2]|0)+40>>2]&127](ma)|0}else{c[na>>2]=la+4}na=a[y]|0;if((na&1)==0){ra=(na&255)>>>1}else{ra=c[D>>2]|0}ea=M;fa=r;ga=L;ha=ra>>>0>1?y:N;ia=O;break b}if(qa){sa=$d[c[(c[ma>>2]|0)+36>>2]&127](ma)|0}else{sa=c[la>>2]|0}if((sa|0)!=(c[((a[z]&1)==0?e:c[f>>2]|0)>>2]|0)){T=116;break a}la=c[g>>2]|0;ma=la+12|0;qa=c[ma>>2]|0;if((qa|0)==(c[la+16>>2]|0)){$d[c[(c[la>>2]|0)+40>>2]&127](la)|0}else{c[ma>>2]=qa+4}a[k]=1;qa=a[z]|0;if((qa&1)==0){ta=(qa&255)>>>1}else{ta=c[e>>2]|0}ea=M;fa=r;ga=L;ha=ta>>>0>1?z:N;ia=O;break b}}while(0);if(P){ua=($&255)>>>1}else{ua=c[D>>2]|0}ca=c[g>>2]|0;qa=c[ca+12>>2]|0;ma=(qa|0)==(c[ca+16>>2]|0);if((ua|0)==0){if(ma){la=$d[c[(c[ca>>2]|0)+36>>2]&127](ca)|0;va=la;wa=a[z]|0}else{va=c[qa>>2]|0;wa=R}if((va|0)!=(c[((wa&1)==0?e:c[f>>2]|0)>>2]|0)){ea=M;fa=r;ga=L;ha=N;ia=O;break b}la=c[g>>2]|0;na=la+12|0;xa=c[na>>2]|0;if((xa|0)==(c[la+16>>2]|0)){$d[c[(c[la>>2]|0)+40>>2]&127](la)|0}else{c[na>>2]=xa+4}a[k]=1;xa=a[z]|0;if((xa&1)==0){ya=(xa&255)>>>1}else{ya=c[e>>2]|0}ea=M;fa=r;ga=L;ha=ya>>>0>1?z:N;ia=O;break b}if(ma){ma=$d[c[(c[ca>>2]|0)+36>>2]&127](ca)|0;za=ma;Aa=a[y]|0}else{za=c[qa>>2]|0;Aa=$}if((za|0)!=(c[((Aa&1)==0?D:c[E>>2]|0)>>2]|0)){a[k]=1;ea=M;fa=r;ga=L;ha=N;ia=O;break b}qa=c[g>>2]|0;ma=qa+12|0;ca=c[ma>>2]|0;if((ca|0)==(c[qa+16>>2]|0)){$d[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[ma>>2]=ca+4}ca=a[y]|0;if((ca&1)==0){Ba=(ca&255)>>>1}else{Ba=c[D>>2]|0}ea=M;fa=r;ga=L;ha=Ba>>>0>1?y:N;ia=O;break};case 0:{T=28;break};case 4:{ca=M;ma=r;qa=L;xa=0;na=O;c:while(1){la=c[g>>2]|0;do{if((la|0)==0){Ca=1}else{Da=c[la+12>>2]|0;if((Da|0)==(c[la+16>>2]|0)){Ea=$d[c[(c[la>>2]|0)+36>>2]&127](la)|0}else{Ea=c[Da>>2]|0}if((Ea|0)==-1){c[g>>2]=0;Ca=1;break}else{Ca=(c[g>>2]|0)==0;break}}}while(0);la=c[b>>2]|0;do{if((la|0)==0){T=188}else{Da=c[la+12>>2]|0;if((Da|0)==(c[la+16>>2]|0)){Fa=$d[c[(c[la>>2]|0)+36>>2]&127](la)|0}else{Fa=c[Da>>2]|0}if((Fa|0)==-1){c[b>>2]=0;T=188;break}else{if(Ca){break}else{break c}}}}while(0);if((T|0)==188){T=0;if(Ca){break}}la=c[g>>2]|0;Da=c[la+12>>2]|0;if((Da|0)==(c[la+16>>2]|0)){Ga=$d[c[(c[la>>2]|0)+36>>2]&127](la)|0}else{Ga=c[Da>>2]|0}if(be[c[(c[l>>2]|0)+12>>2]&63](l,2048,Ga)|0){Da=c[n>>2]|0;if((Da|0)==(c[q>>2]|0)){$N(m,n,q);Ha=c[n>>2]|0}else{Ha=Da}c[n>>2]=Ha+4;c[Ha>>2]=Ga;Ia=ca;Ja=ma;Ka=qa;La=xa+1|0;Ma=na}else{Da=a[w]|0;if((Da&1)==0){Na=(Da&255)>>>1}else{Na=c[K>>2]|0}if((Na|0)==0|(xa|0)==0){break}if((Ga|0)!=(c[v>>2]|0)){break}if((ma|0)==(qa|0)){Da=ma-ca|0;la=Da>>>0<2147483647?Da<<1:-1;if((na|0)!=173){Oa=ca}else{Oa=0}Pa=dS(Oa,la)|0;if((Pa|0)==0){T=206;break a}Qa=Pa;Ra=Pa+(Da>>2<<2)|0;Sa=Pa+(la>>>2<<2)|0;Ta=148}else{Qa=ca;Ra=ma;Sa=qa;Ta=na}c[Ra>>2]=xa;Ia=Qa;Ja=Ra+4|0;Ka=Sa;La=0;Ma=Ta}la=c[g>>2]|0;Pa=la+12|0;Da=c[Pa>>2]|0;if((Da|0)==(c[la+16>>2]|0)){$d[c[(c[la>>2]|0)+40>>2]&127](la)|0;ca=Ia;ma=Ja;qa=Ka;xa=La;na=Ma;continue}else{c[Pa>>2]=Da+4;ca=Ia;ma=Ja;qa=Ka;xa=La;na=Ma;continue}}if((ca|0)==(ma|0)|(xa|0)==0){Ua=ca;Va=ma;Wa=qa;Xa=na}else{if((ma|0)==(qa|0)){$=ma-ca|0;R=$>>>0<2147483647?$<<1:-1;if((na|0)!=173){Ya=ca}else{Ya=0}P=dS(Ya,R)|0;if((P|0)==0){T=217;break a}Za=P;_a=P+($>>2<<2)|0;$a=P+(R>>>2<<2)|0;ab=148}else{Za=ca;_a=ma;$a=qa;ab=na}c[_a>>2]=xa;Ua=Za;Va=_a+4|0;Wa=$a;Xa=ab}R=c[B>>2]|0;if((R|0)>0){P=c[g>>2]|0;do{if((P|0)==0){bb=1}else{$=c[P+12>>2]|0;if(($|0)==(c[P+16>>2]|0)){cb=$d[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{cb=c[$>>2]|0}if((cb|0)==-1){c[g>>2]=0;bb=1;break}else{bb=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=234}else{xa=c[P+12>>2]|0;if((xa|0)==(c[P+16>>2]|0)){db=$d[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{db=c[xa>>2]|0}if((db|0)==-1){c[b>>2]=0;T=234;break}else{if(bb){eb=P;break}else{T=240;break a}}}}while(0);if((T|0)==234){T=0;if(bb){T=240;break a}else{eb=0}}P=c[g>>2]|0;xa=c[P+12>>2]|0;if((xa|0)==(c[P+16>>2]|0)){fb=$d[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{fb=c[xa>>2]|0}if((fb|0)!=(c[u>>2]|0)){T=240;break a}xa=c[g>>2]|0;P=xa+12|0;na=c[P>>2]|0;if((na|0)==(c[xa+16>>2]|0)){$d[c[(c[xa>>2]|0)+40>>2]&127](xa)|0;gb=eb;hb=R;ib=eb}else{c[P>>2]=na+4;gb=eb;hb=R;ib=eb}while(1){na=c[g>>2]|0;do{if((na|0)==0){jb=1}else{P=c[na+12>>2]|0;if((P|0)==(c[na+16>>2]|0)){kb=$d[c[(c[na>>2]|0)+36>>2]&127](na)|0}else{kb=c[P>>2]|0}if((kb|0)==-1){c[g>>2]=0;jb=1;break}else{jb=(c[g>>2]|0)==0;break}}}while(0);do{if((ib|0)==0){lb=gb;T=257}else{na=c[ib+12>>2]|0;if((na|0)==(c[ib+16>>2]|0)){mb=$d[c[(c[ib>>2]|0)+36>>2]&127](ib)|0}else{mb=c[na>>2]|0}if((mb|0)==-1){c[b>>2]=0;lb=0;T=257;break}else{if(jb^(gb|0)==0){nb=gb;ob=gb;break}else{T=263;break a}}}}while(0);if((T|0)==257){T=0;if(jb){T=263;break a}else{nb=lb;ob=0}}na=c[g>>2]|0;P=c[na+12>>2]|0;if((P|0)==(c[na+16>>2]|0)){pb=$d[c[(c[na>>2]|0)+36>>2]&127](na)|0}else{pb=c[P>>2]|0}if(!(be[c[(c[l>>2]|0)+12>>2]&63](l,2048,pb)|0)){T=263;break a}if((c[n>>2]|0)==(c[q>>2]|0)){$N(m,n,q)}P=c[g>>2]|0;na=c[P+12>>2]|0;if((na|0)==(c[P+16>>2]|0)){qb=$d[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{qb=c[na>>2]|0}na=c[n>>2]|0;c[n>>2]=na+4;c[na>>2]=qb;na=hb+ -1|0;c[B>>2]=na;P=c[g>>2]|0;xa=P+12|0;qa=c[xa>>2]|0;if((qa|0)==(c[P+16>>2]|0)){$d[c[(c[P>>2]|0)+40>>2]&127](P)|0}else{c[xa>>2]=qa+4}if((na|0)>0){gb=nb;hb=na;ib=ob}else{break}}}if((c[n>>2]|0)==(c[t>>2]|0)){T=274;break a}else{ea=Ua;fa=Va;ga=Wa;ha=N;ia=Xa}break};case 2:{if(!((N|0)!=0|o>>>0<2)){if((o|0)==2){rb=(a[J]|0)!=0}else{rb=0}if(!(F|rb)){ea=M;fa=r;ga=L;ha=0;ia=O;break b}}R=a[x]|0;na=(R&1)==0?h:c[G>>2]|0;d:do{if((o|0)==0){sb=V;tb=V;ub=R;vb=na}else{if((d[s+(o+ -1)|0]|0)<2){wb=R;xb=na}else{sb=V;tb=V;ub=R;vb=na;break}while(1){if((wb&1)==0){yb=h;zb=(wb&255)>>>1}else{yb=c[G>>2]|0;zb=c[h>>2]|0}if((xb|0)==(yb+(zb<<2)|0)){Ab=wb;break}if(!(be[c[(c[l>>2]|0)+12>>2]&63](l,8192,c[xb>>2]|0)|0)){T=129;break}wb=a[x]|0;xb=xb+4|0}if((T|0)==129){T=0;Ab=a[x]|0}qa=(Ab&1)==0;xa=xb-(qa?h:c[G>>2]|0)>>2;P=a[A]|0;ma=(P&1)==0;if(ma){Bb=(P&255)>>>1}else{Bb=c[H>>2]|0}e:do{if(!(xa>>>0>Bb>>>0)){if(ma){Cb=H+(((P&255)>>>1)-xa<<2)|0;Db=H;Eb=(P&255)>>>1}else{ca=c[I>>2]|0;$=c[H>>2]|0;Cb=ca+($-xa<<2)|0;Db=ca;Eb=$}$=Db+(Eb<<2)|0;if((Cb|0)==($|0)){sb=V;tb=V;ub=Ab;vb=xb;break d}else{Fb=qa?h:c[G>>2]|0;Gb=Cb}while(1){if((c[Gb>>2]|0)!=(c[Fb>>2]|0)){break e}ca=Gb+4|0;if((ca|0)==($|0)){sb=V;tb=V;ub=Ab;vb=xb;break d}Fb=Fb+4|0;Gb=ca}}}while(0);sb=V;tb=V;ub=Ab;vb=qa?h:c[G>>2]|0}}while(0);f:while(1){if((ub&1)==0){Hb=h;Ib=(ub&255)>>>1}else{Hb=c[G>>2]|0;Ib=c[h>>2]|0}if((vb|0)==(Hb+(Ib<<2)|0)){break}na=c[g>>2]|0;do{if((na|0)==0){Jb=1}else{R=c[na+12>>2]|0;if((R|0)==(c[na+16>>2]|0)){Kb=$d[c[(c[na>>2]|0)+36>>2]&127](na)|0}else{Kb=c[R>>2]|0}if((Kb|0)==-1){c[g>>2]=0;Jb=1;break}else{Jb=(c[g>>2]|0)==0;break}}}while(0);do{if((tb|0)==0){Lb=sb;T=159}else{na=c[tb+12>>2]|0;if((na|0)==(c[tb+16>>2]|0)){Mb=$d[c[(c[tb>>2]|0)+36>>2]&127](tb)|0}else{Mb=c[na>>2]|0}if((Mb|0)==-1){c[b>>2]=0;Lb=0;T=159;break}else{if(Jb^(sb|0)==0){Nb=sb;Ob=sb;break}else{break f}}}}while(0);if((T|0)==159){T=0;if(Jb){break}else{Nb=Lb;Ob=0}}na=c[g>>2]|0;qa=c[na+12>>2]|0;if((qa|0)==(c[na+16>>2]|0)){Pb=$d[c[(c[na>>2]|0)+36>>2]&127](na)|0}else{Pb=c[qa>>2]|0}if((Pb|0)!=(c[vb>>2]|0)){break}qa=c[g>>2]|0;na=qa+12|0;R=c[na>>2]|0;if((R|0)==(c[qa+16>>2]|0)){$d[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[na>>2]=R+4}sb=Nb;tb=Ob;ub=a[x]|0;vb=vb+4|0}if(!F){ea=M;fa=r;ga=L;ha=N;ia=O;break b}R=a[x]|0;if((R&1)==0){Qb=h;Rb=(R&255)>>>1}else{Qb=c[G>>2]|0;Rb=c[h>>2]|0}if((vb|0)==(Qb+(Rb<<2)|0)){ea=M;fa=r;ga=L;ha=N;ia=O}else{T=174;break a}break};default:{ea=M;fa=r;ga=L;ha=N;ia=O}}}while(0);g:do{if((T|0)==28){T=0;if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}else{Sb=V;Tb=V}while(1){R=c[g>>2]|0;do{if((R|0)==0){Ub=1}else{na=c[R+12>>2]|0;if((na|0)==(c[R+16>>2]|0)){Vb=$d[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Vb=c[na>>2]|0}if((Vb|0)==-1){c[g>>2]=0;Ub=1;break}else{Ub=(c[g>>2]|0)==0;break}}}while(0);do{if((Tb|0)==0){Wb=Sb;T=42}else{R=c[Tb+12>>2]|0;if((R|0)==(c[Tb+16>>2]|0)){Xb=$d[c[(c[Tb>>2]|0)+36>>2]&127](Tb)|0}else{Xb=c[R>>2]|0}if((Xb|0)==-1){c[b>>2]=0;Wb=0;T=42;break}else{if(Ub^(Sb|0)==0){Yb=Sb;Zb=Sb;break}else{ea=M;fa=r;ga=L;ha=N;ia=O;break g}}}}while(0);if((T|0)==42){T=0;if(Ub){ea=M;fa=r;ga=L;ha=N;ia=O;break g}else{Yb=Wb;Zb=0}}R=c[g>>2]|0;na=c[R+12>>2]|0;if((na|0)==(c[R+16>>2]|0)){_b=$d[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{_b=c[na>>2]|0}if(!(be[c[(c[l>>2]|0)+12>>2]&63](l,8192,_b)|0)){ea=M;fa=r;ga=L;ha=N;ia=O;break g}na=c[g>>2]|0;R=na+12|0;qa=c[R>>2]|0;if((qa|0)==(c[na+16>>2]|0)){$b=$d[c[(c[na>>2]|0)+40>>2]&127](na)|0}else{c[R>>2]=qa+4;$b=c[qa>>2]|0}DI(A,$b);Sb=Yb;Tb=Zb}}}while(0);qa=o+1|0;if(qa>>>0<4){L=ga;r=fa;M=ea;o=qa;N=ha;O=ia}else{W=ea;X=fa;Y=ha;Z=ia;T=276;break}}h:do{if((T|0)==27){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==116){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==174){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==206){nS()}else if((T|0)==217){nS()}else if((T|0)==240){c[j>>2]=c[j>>2]|4;ac=0;bc=Ua;cc=Xa}else if((T|0)==263){c[j>>2]=c[j>>2]|4;ac=0;bc=Ua;cc=Xa}else if((T|0)==274){c[j>>2]=c[j>>2]|4;ac=0;bc=Ua;cc=Xa}else if((T|0)==276){i:do{if((Y|0)!=0){ia=Y+4|0;ha=Y+8|0;fa=1;j:while(1){ea=a[Y]|0;if((ea&1)==0){dc=(ea&255)>>>1}else{dc=c[ia>>2]|0}if(!(fa>>>0<dc>>>0)){break i}ea=c[g>>2]|0;do{if((ea|0)==0){ec=1}else{N=c[ea+12>>2]|0;if((N|0)==(c[ea+16>>2]|0)){fc=$d[c[(c[ea>>2]|0)+36>>2]&127](ea)|0}else{fc=c[N>>2]|0}if((fc|0)==-1){c[g>>2]=0;ec=1;break}else{ec=(c[g>>2]|0)==0;break}}}while(0);ea=c[b>>2]|0;do{if((ea|0)==0){T=295}else{N=c[ea+12>>2]|0;if((N|0)==(c[ea+16>>2]|0)){gc=$d[c[(c[ea>>2]|0)+36>>2]&127](ea)|0}else{gc=c[N>>2]|0}if((gc|0)==-1){c[b>>2]=0;T=295;break}else{if(ec){break}else{break j}}}}while(0);if((T|0)==295){T=0;if(ec){break}}ea=c[g>>2]|0;N=c[ea+12>>2]|0;if((N|0)==(c[ea+16>>2]|0)){hc=$d[c[(c[ea>>2]|0)+36>>2]&127](ea)|0}else{hc=c[N>>2]|0}if((a[Y]&1)==0){ic=ia}else{ic=c[ha>>2]|0}if((hc|0)!=(c[ic+(fa<<2)>>2]|0)){break}N=fa+1|0;ea=c[g>>2]|0;o=ea+12|0;r=c[o>>2]|0;if((r|0)==(c[ea+16>>2]|0)){$d[c[(c[ea>>2]|0)+40>>2]&127](ea)|0;fa=N;continue}else{c[o>>2]=r+4;fa=N;continue}}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z;break h}}while(0);if((W|0)==(X|0)){ac=1;bc=X;cc=Z;break}c[C>>2]=0;TN(w,W,X,C);if((c[C>>2]|0)==0){ac=1;bc=W;cc=Z;break}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z}}while(0);zI(A);zI(z);zI(y);zI(x);XH(w);if((bc|0)==0){i=p;return ac|0}Yd[cc&255](bc);i=p;return ac|0}function YN(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+464|0;l=d;m=d+8|0;n=d+24|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=173;v=n+400|0;TI(q,h);n=q;w=c[n>>2]|0;if(!((c[23712]|0)==-1)){c[m>>2]=94848;c[m+4>>2]=171;c[m+8>>2]=0;IH(94848,m,172)}m=(c[94852>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Cc(4)|0;z=y;HR(z);A=110416;B=127;Kd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Cc(4)|0;z=y;HR(z);A=110416;B=127;Kd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=XN(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}if((a[r]|0)!=0){DI(k,ne[c[(c[w>>2]|0)+44>>2]&63](B,45)|0)}r=ne[c[(c[w>>2]|0)+44>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -4|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+4|0;if((c[z>>2]|0)!=(r|0)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);ZN(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=1}else{C=c[e+12>>2]|0;if((C|0)==(c[e+16>>2]|0)){E=$d[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{E=c[C>>2]|0}if((E|0)==-1){c[w>>2]=0;D=1;break}else{D=(c[w>>2]|0)==0;break}}}while(0);do{if((f|0)==0){F=29}else{E=c[f+12>>2]|0;if((E|0)==(c[f+16>>2]|0)){G=$d[c[(c[f>>2]|0)+36>>2]&127](f)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[A>>2]=0;F=29;break}else{if(D){break}else{F=31;break}}}}while(0);if((F|0)==29){if(D){F=31}}if((F|0)==31){c[j>>2]=c[j>>2]|2}c[b>>2]=c[w>>2];nH(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}Yd[c[u>>2]&255](n);i=d;return}function ZN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=1}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g>>2;if((h|0)==0){i=f;return b|0}if((l-j|0)>>>0<h>>>0){FI(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{k=j+((e+ -4+(0-g)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{d=d+4|0;g=m}}o=n+(k<<2)|0}c[o>>2]=0;o=j+h|0;if((a[b]&1)==0){a[b]=o<<1;i=f;return b|0}else{c[b+4>>2]=o;i=f;return b|0}return 0}function _N(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[23606]|0)==-1)){c[p>>2]=94424;c[p+4>>2]=171;c[p+8>>2]=0;IH(94424,p,172)}p=(c[94428>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Cc(4)|0;C=B;HR(C);D=110416;E=127;Kd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Cc(4)|0;C=B;HR(C);D=110416;E=127;Kd(B|0,D|0,E|0)}E=b;Zd[c[(c[b>>2]|0)+44>>2]&63](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;Zd[c[(c[b>>2]|0)+32>>2]&63](r,E);B=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}CI(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;zI(r);Zd[c[(c[b>>2]|0)+28>>2]&63](s,E);r=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}CI(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;zI(s);c[f>>2]=$d[c[(c[b>>2]|0)+12>>2]&127](E)|0;c[g>>2]=$d[c[(c[b>>2]|0)+16>>2]&127](E)|0;Zd[c[(c[b>>2]|0)+20>>2]&63](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}hI(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;XH(t);Zd[c[(c[b>>2]|0)+24>>2]&63](u,E);t=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}CI(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;zI(u);F=$d[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[23590]|0)==-1)){c[o>>2]=94360;c[o+4>>2]=171;c[o+8>>2]=0;IH(94360,o,172)}o=(c[94364>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Cc(4)|0;H=G;HR(H);I=110416;J=127;Kd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Cc(4)|0;H=G;HR(H);I=110416;J=127;Kd(G|0,I|0,J|0)}J=E;Zd[c[(c[E>>2]|0)+44>>2]&63](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;Zd[c[(c[E>>2]|0)+32>>2]&63](w,J);e=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}CI(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;zI(w);Zd[c[(c[E>>2]|0)+28>>2]&63](x,J);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}CI(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;zI(x);c[f>>2]=$d[c[(c[E>>2]|0)+12>>2]&127](J)|0;c[g>>2]=$d[c[(c[E>>2]|0)+16>>2]&127](J)|0;Zd[c[(c[E>>2]|0)+20>>2]&63](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}hI(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;XH(y);Zd[c[(c[E>>2]|0)+24>>2]&63](z,J);y=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}CI(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;zI(z);F=$d[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function $N(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=173;h=a;a=c[h>>2]|0;j=a;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;if(g){m=a}else{m=0}a=dS(m,l)|0;m=a;if((a|0)==0){nS()}do{if(g){c[h>>2]=m;n=m}else{a=c[h>>2]|0;c[h>>2]=m;if((a|0)==0){n=m;break}Yd[c[f>>2]&255](a);n=c[h>>2]|0}}while(0);c[f>>2]=148;c[b>>2]=n+(k<<2);c[d>>2]=(c[h>>2]|0)+(l>>>2<<2);i=e;return}function aO(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function bO(a){a=a|0;i=i;return}function cO(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+104|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+104|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Kc(G|0,100,94608,o|0)|0;do{if(s>>>0>99){do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);o=c[23686]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=WL(r,o,94608,n)|0;o=c[r>>2]|0;if((o|0)==0){nS()}H=aS(G)|0;if((H|0)!=0){I=o;J=H;K=H;L=G;break}nS()}else{I=0;J=0;K=q;L=s}}while(0);TI(t,g);s=t;q=c[s>>2]|0;if(!((c[23714]|0)==-1)){c[p>>2]=94856;c[p+4>>2]=171;c[p+8>>2]=0;IH(94856,p,172)}p=(c[94860>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){M=Cc(4)|0;N=M;HR(N);O=110416;P=127;Kd(M|0,O|0,P|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){M=Cc(4)|0;N=M;HR(N);O=110416;P=127;Kd(M|0,O|0,P|0)}P=q;O=c[r>>2]|0;xe[c[(c[q>>2]|0)+32>>2]&63](P,O,O+L|0,K)|0;if((L|0)==0){Q=0}else{Q=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;dO(f,Q,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((L|0)>(C|0)){B=a[A]|0;if((B&1)==0){R=(B&255)>>>1}else{R=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[z+4>>2]|0}T=R+(L-C<<1|1)+S|0}else{S=a[A]|0;if((S&1)==0){U=(S&255)>>>1}else{U=c[A+4>>2]|0}S=a[z]|0;if((S&1)==0){V=(S&255)>>>1}else{V=c[z+4>>2]|0}T=U+2+V|0}V=T+C|0;do{if(V>>>0>100){T=aS(V)|0;if((T|0)!=0){W=T;X=T;break}nS()}else{W=0;X=t}}while(0);eO(X,D,E,c[g+4>>2]|0,K,K+L|0,P,Q,v,a[w]|0,a[x]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];uE(b,m,X,e,D,g,j);if((W|0)!=0){bS(W)}XH(A);XH(z);XH(y);nH(c[s>>2]|0)|0;if((J|0)!=0){bS(J)}if((I|0)==0){i=d;return}bS(I);i=d;return}function dO(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[23574]|0)==-1)){c[p>>2]=94296;c[p+4>>2]=171;c[p+8>>2]=0;IH(94296,p,172)}p=(c[94300>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Cc(4)|0;I=H;HR(I);J=110416;K=127;Kd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Cc(4)|0;I=H;HR(I);J=110416;K=127;Kd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){Zd[c[J+44>>2]&63](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;Zd[c[(c[e>>2]|0)+32>>2]&63](s,K);H=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}hI(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;XH(s)}else{Zd[c[J+40>>2]&63](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;Zd[c[(c[e>>2]|0)+28>>2]&63](v,K);J=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}hI(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;XH(v)}a[g]=$d[c[(c[e>>2]|0)+12>>2]&127](K)|0;a[h]=$d[c[(c[e>>2]|0)+16>>2]&127](K)|0;Zd[c[(c[e>>2]|0)+20>>2]&63](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}hI(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;XH(w);Zd[c[(c[e>>2]|0)+24>>2]&63](x,K);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}hI(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;XH(x);L=$d[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[23558]|0)==-1)){c[o>>2]=94232;c[o+4>>2]=171;c[o+8>>2]=0;IH(94232,o,172)}o=(c[94236>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Cc(4)|0;N=M;HR(N);O=110416;P=127;Kd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Cc(4)|0;N=M;HR(N);O=110416;P=127;Kd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){Zd[c[O+44>>2]&63](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;Zd[c[(c[G>>2]|0)+32>>2]&63](A,P);d=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}hI(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;XH(A)}else{Zd[c[O+40>>2]&63](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;Zd[c[(c[G>>2]|0)+28>>2]&63](D,P);f=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}hI(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;XH(D)}a[g]=$d[c[(c[G>>2]|0)+12>>2]&127](P)|0;a[h]=$d[c[(c[G>>2]|0)+16>>2]&127](P)|0;Zd[c[(c[G>>2]|0)+20>>2]&63](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}hI(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;XH(E);Zd[c[(c[G>>2]|0)+24>>2]&63](F,P);E=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}hI(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;XH(F);L=$d[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function eO(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;t=i;c[f>>2]=d;u=r+1|0;v=r+8|0;w=r+4|0;x=(g&512|0)==0;y=q+1|0;z=q+8|0;A=q+4|0;B=(s|0)>0;C=p+1|0;D=p+8|0;E=p+4|0;F=k+8|0;G=0-s|0;H=h;h=0;while(1){a:do{switch(a[m+h|0]|0){case 4:{I=c[f>>2]|0;J=l?H+1|0:H;b:do{if(J>>>0<j>>>0){K=J;while(1){L=a[K]|0;if(!(L<<24>>24>-1)){M=K;break b}N=K+1|0;if((b[(c[F>>2]|0)+(L<<24>>24<<1)>>1]&2048)==0){M=K;break b}if(N>>>0<j>>>0){K=N}else{M=N;break}}}else{M=J}}while(0);K=M;if(B){if(M>>>0>J>>>0){N=J+(0-K)|0;K=N>>>0<G>>>0?G:N;N=K+s|0;L=I;O=M;P=s;while(1){Q=O+ -1|0;R=a[Q]|0;c[f>>2]=L+1;a[L]=R;R=P+ -1|0;S=(R|0)>0;if(!(Q>>>0>J>>>0&S)){break}L=c[f>>2]|0;P=R;O=Q}O=M+K|0;if(S){T=O;U=N;V=32}else{W=0;X=O;Y=N}}else{T=M;U=s;V=32}if((V|0)==32){V=0;W=ne[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;X=T;Y=U}O=c[f>>2]|0;c[f>>2]=O+1;if((Y|0)>0){P=O;L=Y;while(1){a[P]=W;Q=L+ -1|0;R=c[f>>2]|0;c[f>>2]=R+1;if((Q|0)>0){L=Q;P=R}else{Z=R;break}}}else{Z=O}a[Z]=n;_=X}else{_=M}if((_|0)==(J|0)){P=ne[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;L=c[f>>2]|0;c[f>>2]=L+1;a[L]=P}else{P=a[p]|0;L=(P&1)==0;if(L){$=(P&255)>>>1}else{$=c[E>>2]|0}if(($|0)==0){aa=_;ba=-1;ca=0;da=0}else{if(L){ea=C}else{ea=c[D>>2]|0}aa=_;ba=a[ea]|0;ca=0;da=0}while(1){do{if((da|0)==(ba|0)){L=c[f>>2]|0;c[f>>2]=L+1;a[L]=o;L=ca+1|0;P=a[p]|0;N=(P&1)==0;if(N){fa=(P&255)>>>1}else{fa=c[E>>2]|0}if(!(L>>>0<fa>>>0)){ga=ba;ha=L;ia=0;break}if(N){ja=C}else{ja=c[D>>2]|0}if((a[ja+L|0]|0)==127){ga=-1;ha=L;ia=0;break}if(N){ka=C}else{ka=c[D>>2]|0}ga=a[ka+L|0]|0;ha=L;ia=0}else{ga=ba;ha=ca;ia=da}}while(0);L=aa+ -1|0;N=a[L]|0;P=c[f>>2]|0;c[f>>2]=P+1;a[P]=N;if((L|0)==(J|0)){break}else{aa=L;ba=ga;ca=ha;da=ia+1|0}}}O=c[f>>2]|0;if((I|0)==(O|0)){la=J;break a}L=O+ -1|0;if(L>>>0>I>>>0){ma=I;na=L}else{la=J;break a}while(1){L=a[ma]|0;a[ma]=a[na]|0;a[na]=L;L=ma+1|0;O=na+ -1|0;if(L>>>0<O>>>0){na=O;ma=L}else{la=J;break}}break};case 2:{J=a[q]|0;I=(J&1)==0;if(I){oa=(J&255)>>>1}else{oa=c[A>>2]|0}if((oa|0)==0|x){la=H;break a}if(I){pa=y;qa=(J&255)>>>1}else{pa=c[z>>2]|0;qa=c[A>>2]|0}J=pa+qa|0;I=c[f>>2]|0;if((pa|0)==(J|0)){ra=I}else{L=I;I=pa;while(1){a[L]=a[I]|0;O=I+1|0;N=L+1|0;if((O|0)==(J|0)){ra=N;break}else{I=O;L=N}}}c[f>>2]=ra;la=H;break};case 1:{c[e>>2]=c[f>>2];L=ne[c[(c[k>>2]|0)+28>>2]&63](k,32)|0;I=c[f>>2]|0;c[f>>2]=I+1;a[I]=L;la=H;break};case 3:{L=a[r]|0;I=(L&1)==0;if(I){sa=(L&255)>>>1}else{sa=c[w>>2]|0}if((sa|0)==0){la=H;break a}if(I){ta=u}else{ta=c[v>>2]|0}I=a[ta]|0;L=c[f>>2]|0;c[f>>2]=L+1;a[L]=I;la=H;break};case 0:{c[e>>2]=c[f>>2];la=H;break};default:{la=H}}}while(0);I=h+1|0;if(I>>>0<4){H=la;h=I}else{break}}h=a[r]|0;r=(h&1)==0;if(r){ua=(h&255)>>>1}else{ua=c[w>>2]|0}if(ua>>>0>1){if(r){va=u;wa=(h&255)>>>1}else{va=c[v>>2]|0;wa=c[w>>2]|0}w=va+1|0;v=va+wa|0;wa=c[f>>2]|0;if((w|0)==(v|0)){xa=wa}else{va=wa;wa=w;while(1){a[va]=a[wa]|0;w=wa+1|0;h=va+1|0;if((w|0)==(v|0)){xa=h;break}else{wa=w;va=h}}}c[f>>2]=xa}xa=g&176;if((xa|0)==32){c[e>>2]=c[f>>2];i=t;return}else if((xa|0)==16){i=t;return}else{c[e>>2]=d;i=t;return}}function fO(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+104|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;TI(m,g);z=m;A=c[z>>2]|0;if(!((c[23714]|0)==-1)){c[l>>2]=94856;c[l+4>>2]=171;c[l+8>>2]=0;IH(94856,l,172)}l=(c[94860>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Cc(4)|0;D=C;HR(D);E=110416;F=127;Kd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Cc(4)|0;D=C;HR(D);E=110416;F=127;Kd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+1|0}else{I=c[j+8>>2]|0}C=a[I]|0;H=C<<24>>24==(ne[c[(c[A>>2]|0)+28>>2]&63](F,45)|0)<<24>>24}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;dO(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=aS(P)|0;if((N|0)!=0){Q=N;R=N;break}nS()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+1|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}eO(R,w,x,c[g+4>>2]|0,S,S+T|0,F,H,o,a[p]|0,a[q]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];uE(b,k,R,e,w,g,h);if((Q|0)==0){XH(t);XH(s);XH(r);U=c[z>>2]|0;V=U;W=V;X=nH(W)|0;i=d;return}bS(Q);XH(t);XH(s);XH(r);U=c[z>>2]|0;V=U;W=V;X=nH(W)|0;i=d;return}function gO(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function hO(a){a=a|0;i=i;return}function iO(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+400|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+400|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Kc(G|0,100,94608,o|0)|0;do{if(s>>>0>99){do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);o=c[23686]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=WL(r,o,94608,n)|0;o=c[r>>2]|0;if((o|0)==0){nS()}H=aS(G<<2)|0;I=H;if((H|0)!=0){J=o;K=I;L=I;M=G;break}nS()}else{J=0;K=0;L=q;M=s}}while(0);TI(t,g);s=t;q=c[s>>2]|0;if(!((c[23712]|0)==-1)){c[p>>2]=94848;c[p+4>>2]=171;c[p+8>>2]=0;IH(94848,p,172)}p=(c[94852>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){N=Cc(4)|0;O=N;HR(O);P=110416;Q=127;Kd(N|0,P|0,Q|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){N=Cc(4)|0;O=N;HR(O);P=110416;Q=127;Kd(N|0,P|0,Q|0)}Q=q;P=c[r>>2]|0;xe[c[(c[q>>2]|0)+48>>2]&63](Q,P,P+M|0,L)|0;if((M|0)==0){R=0}else{R=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;jO(f,R,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((M|0)>(C|0)){B=a[A]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){T=(B&255)>>>1}else{T=c[z+4>>2]|0}U=S+(M-C<<1|1)+T|0}else{T=a[A]|0;if((T&1)==0){V=(T&255)>>>1}else{V=c[A+4>>2]|0}T=a[z]|0;if((T&1)==0){W=(T&255)>>>1}else{W=c[z+4>>2]|0}U=V+2+W|0}W=U+C|0;do{if(W>>>0>100){U=aS(W<<2)|0;V=U;if((U|0)!=0){X=V;Y=V;break}nS()}else{X=0;Y=t}}while(0);kO(Y,D,E,c[g+4>>2]|0,L,L+(M<<2)|0,Q,R,v,c[w>>2]|0,c[x>>2]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];dM(b,m,Y,e,D,g,j);if((X|0)!=0){bS(X)}zI(A);zI(z);XH(y);nH(c[s>>2]|0)|0;if((K|0)!=0){bS(K)}if((J|0)==0){i=d;return}bS(J);i=d;return}function jO(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[23606]|0)==-1)){c[p>>2]=94424;c[p+4>>2]=171;c[p+8>>2]=0;IH(94424,p,172)}p=(c[94428>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Cc(4)|0;I=H;HR(I);J=110416;K=127;Kd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Cc(4)|0;I=H;HR(I);J=110416;K=127;Kd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){Zd[c[J+44>>2]&63](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;Zd[c[(c[e>>2]|0)+32>>2]&63](s,K);H=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}CI(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;zI(s)}else{Zd[c[J+40>>2]&63](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;Zd[c[(c[e>>2]|0)+28>>2]&63](v,K);J=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}CI(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;zI(v)}c[g>>2]=$d[c[(c[e>>2]|0)+12>>2]&127](K)|0;c[h>>2]=$d[c[(c[e>>2]|0)+16>>2]&127](K)|0;Zd[c[(c[e>>2]|0)+20>>2]&63](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}hI(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;XH(w);Zd[c[(c[e>>2]|0)+24>>2]&63](x,K);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}CI(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;zI(x);L=$d[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[23590]|0)==-1)){c[o>>2]=94360;c[o+4>>2]=171;c[o+8>>2]=0;IH(94360,o,172)}o=(c[94364>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Cc(4)|0;N=M;HR(N);O=110416;P=127;Kd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Cc(4)|0;N=M;HR(N);O=110416;P=127;Kd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){Zd[c[O+44>>2]&63](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;Zd[c[(c[G>>2]|0)+32>>2]&63](A,P);d=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}CI(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;zI(A)}else{Zd[c[O+40>>2]&63](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;Zd[c[(c[G>>2]|0)+28>>2]&63](D,P);f=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}CI(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;zI(D)}c[g>>2]=$d[c[(c[G>>2]|0)+12>>2]&127](P)|0;c[h>>2]=$d[c[(c[G>>2]|0)+16>>2]&127](P)|0;Zd[c[(c[G>>2]|0)+20>>2]&63](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}hI(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;XH(E);Zd[c[(c[G>>2]|0)+24>>2]&63](F,P);E=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}CI(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;zI(F);L=$d[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function kO(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;s=i;c[e>>2]=b;t=q+4|0;u=q+8|0;v=(f&512|0)==0;w=p+4|0;x=p+8|0;y=(r|0)>0;z=o+1|0;A=o+8|0;B=o+4|0;C=g;g=0;while(1){a:do{switch(a[l+g|0]|0){case 1:{c[d>>2]=c[e>>2];D=ne[c[(c[j>>2]|0)+44>>2]&63](j,32)|0;E=c[e>>2]|0;c[e>>2]=E+4;c[E>>2]=D;F=C;break};case 4:{D=c[e>>2]|0;E=k?C+4|0:C;b:do{if(E>>>0<h>>>0){G=E;while(1){H=G+4|0;if(!(be[c[(c[j>>2]|0)+12>>2]&63](j,2048,c[G>>2]|0)|0)){I=G;break b}if(H>>>0<h>>>0){G=H}else{I=H;break}}}else{I=E}}while(0);if(y){do{if(I>>>0>E>>>0){G=c[e>>2]|0;H=I;J=r;while(1){K=H+ -4|0;L=G+4|0;c[G>>2]=c[K>>2];M=J+ -1|0;N=(M|0)>0;if(K>>>0>E>>>0&N){J=M;H=K;G=L}else{break}}c[e>>2]=L;if(N){O=K;P=M;Q=34;break}G=c[e>>2]|0;c[e>>2]=G+4;R=G;S=K}else{O=I;P=r;Q=34}}while(0);do{if((Q|0)==34){Q=0;G=ne[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;H=c[e>>2]|0;J=H+4|0;c[e>>2]=J;if((P|0)>0){T=J;U=H;V=P}else{R=H;S=O;break}while(1){c[U>>2]=G;J=V+ -1|0;if((J|0)>0){V=J;U=T;T=T+4|0}else{break}}c[e>>2]=H+(P+1<<2);R=H+(P<<2)|0;S=O}}while(0);c[R>>2]=m;W=S}else{W=I}if((W|0)==(E|0)){G=ne[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;J=c[e>>2]|0;X=J+4|0;c[e>>2]=X;c[J>>2]=G;Y=X}else{X=a[o]|0;G=(X&1)==0;if(G){Z=(X&255)>>>1}else{Z=c[B>>2]|0}if((Z|0)==0){_=W;$=-1;aa=0;ba=0}else{if(G){ca=z}else{ca=c[A>>2]|0}_=W;$=a[ca]|0;aa=0;ba=0}while(1){G=c[e>>2]|0;do{if((ba|0)==($|0)){X=G+4|0;c[e>>2]=X;c[G>>2]=n;J=aa+1|0;da=a[o]|0;ea=(da&1)==0;if(ea){fa=(da&255)>>>1}else{fa=c[B>>2]|0}if(!(J>>>0<fa>>>0)){ga=X;ha=$;ia=J;ja=0;break}if(ea){ka=z}else{ka=c[A>>2]|0}if((a[ka+J|0]|0)==127){ga=X;ha=-1;ia=J;ja=0;break}if(ea){la=z}else{la=c[A>>2]|0}ga=X;ha=a[la+J|0]|0;ia=J;ja=0}else{ga=G;ha=$;ia=aa;ja=ba}}while(0);G=_+ -4|0;H=c[G>>2]|0;J=ga+4|0;c[e>>2]=J;c[ga>>2]=H;if((G|0)==(E|0)){Y=J;break}else{_=G;$=ha;aa=ia;ba=ja+1|0}}}if((D|0)==(Y|0)){F=E;break a}G=Y+ -4|0;if(G>>>0>D>>>0){ma=D;na=G}else{F=E;break a}while(1){G=c[ma>>2]|0;c[ma>>2]=c[na>>2];c[na>>2]=G;G=ma+4|0;J=na+ -4|0;if(G>>>0<J>>>0){na=J;ma=G}else{F=E;break}}break};case 0:{c[d>>2]=c[e>>2];F=C;break};case 3:{E=a[q]|0;D=(E&1)==0;if(D){oa=(E&255)>>>1}else{oa=c[t>>2]|0}if((oa|0)==0){F=C;break a}if(D){pa=t}else{pa=c[u>>2]|0}D=c[pa>>2]|0;E=c[e>>2]|0;c[e>>2]=E+4;c[E>>2]=D;F=C;break};case 2:{D=a[p]|0;E=(D&1)==0;if(E){qa=(D&255)>>>1}else{qa=c[w>>2]|0}if((qa|0)==0|v){F=C;break a}if(E){ra=w;sa=(D&255)>>>1}else{ra=c[x>>2]|0;sa=c[w>>2]|0}D=ra+(sa<<2)|0;E=c[e>>2]|0;if((ra|0)==(D|0)){ta=E}else{G=(ra+(sa+ -1<<2)+(0-ra)|0)>>>2;J=E;H=ra;while(1){c[J>>2]=c[H>>2];X=H+4|0;if((X|0)==(D|0)){break}J=J+4|0;H=X}ta=E+(G+1<<2)|0}c[e>>2]=ta;F=C;break};default:{F=C}}}while(0);H=g+1|0;if(H>>>0<4){C=F;g=H}else{break}}g=a[q]|0;q=(g&1)==0;if(q){ua=(g&255)>>>1}else{ua=c[t>>2]|0}if(ua>>>0>1){if(q){va=t;wa=(g&255)>>>1}else{va=c[u>>2]|0;wa=c[t>>2]|0}t=va+4|0;u=va+(wa<<2)|0;g=c[e>>2]|0;if((t|0)==(u|0)){xa=g}else{q=(va+(wa+ -1<<2)+(0-t)|0)>>>2;wa=g;va=t;while(1){c[wa>>2]=c[va>>2];t=va+4|0;if((t|0)==(u|0)){break}else{va=t;wa=wa+4|0}}xa=g+(q+1<<2)|0}c[e>>2]=xa}xa=f&176;if((xa|0)==16){i=s;return}else if((xa|0)==32){c[d>>2]=c[e>>2];i=s;return}else{c[d>>2]=b;i=s;return}}function lO(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+400|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;TI(m,g);z=m;A=c[z>>2]|0;if(!((c[23712]|0)==-1)){c[l>>2]=94848;c[l+4>>2]=171;c[l+8>>2]=0;IH(94848,l,172)}l=(c[94852>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Cc(4)|0;D=C;HR(D);E=110416;F=127;Kd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Cc(4)|0;D=C;HR(D);E=110416;F=127;Kd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+4|0}else{I=c[j+8>>2]|0}C=c[I>>2]|0;H=(C|0)==(ne[c[(c[A>>2]|0)+44>>2]&63](F,45)|0)}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;jO(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=aS(P<<2)|0;O=N;if((N|0)!=0){Q=O;R=O;break}nS()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+4|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}kO(R,w,x,c[g+4>>2]|0,S,S+(T<<2)|0,F,H,o,c[p>>2]|0,c[q>>2]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];dM(b,k,R,e,w,g,h);if((Q|0)==0){zI(t);zI(s);XH(r);U=c[z>>2]|0;V=U;W=V;X=nH(W)|0;i=d;return}bS(Q);zI(t);zI(s);XH(r);U=c[z>>2]|0;V=U;W=V;X=nH(W)|0;i=d;return}function mO(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function nO(a){a=a|0;i=i;return}function oO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=sc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function pO(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;j=d;k=j;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;k=a[h]|0;if((k&1)==0){l=h+1|0;m=h+1|0;n=(k&255)>>>1}else{k=c[h+8>>2]|0;l=k;m=k;n=c[h+4>>2]|0}h=l+n|0;do{if(m>>>0<h>>>0){n=m;do{nI(j,a[n]|0);n=n+1|0;}while(n>>>0<h>>>0);n=(e|0)==-1?-1:e<<1;if((a[j]&1)==0){o=n;p=9;break}q=n;r=c[j+8>>2]|0}else{o=(e|0)==-1?-1:e<<1;p=9}}while(0);if((p|0)==9){q=o;r=j+1|0}o=qd(q|0,f|0,g|0,r|0)|0;r=b;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;r=ES(o|0)|0;g=o+r|0;if((r|0)>0){s=o}else{XH(j);i=d;return}do{nI(b,a[s]|0);s=s+1|0;}while(s>>>0<g>>>0);XH(j);i=d;return}function qO(a,b){a=a|0;b=b|0;a=i;Gb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function rO(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function sO(a){a=a|0;i=i;return}function tO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=sc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function uO(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+240|0;j=d;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=d+224|0;t=d+232|0;u=r;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[s+4>>2]=0;c[s>>2]=96512;u=a[h]|0;if((u&1)==0){v=h+4|0;w=h+4|0;x=(u&255)>>>1}else{u=c[h+8>>2]|0;v=u;w=u;x=c[h+4>>2]|0}h=v+(x<<2)|0;x=k;v=j;u=j;c[u>>2]=0;c[u+4>>2]=0;a:do{if(w>>>0<h>>>0){u=s;j=k+32|0;y=w;z=96512|0;while(1){c[m>>2]=y;A=(we[c[z+12>>2]&15](u,v,y,h,m,x,j,l)|0)==2;B=c[m>>2]|0;if(A|(B|0)==(y|0)){break}if(x>>>0<(c[l>>2]|0)>>>0){A=x;do{nI(r,a[A]|0);A=A+1|0;}while(A>>>0<(c[l>>2]|0)>>>0);C=c[m>>2]|0}else{C=B}if(!(C>>>0<h>>>0)){break a}y=C;z=c[s>>2]|0}PN(95736)}}while(0);if((a[r]&1)==0){D=r+1|0}else{D=c[r+8>>2]|0}s=qd(((e|0)==-1?-1:e<<1)|0,f|0,g|0,D|0)|0;D=b;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[t+4>>2]=0;c[t>>2]=96616;D=ES(s|0)|0;g=s+D|0;f=n;e=n;c[e>>2]=0;c[e+4>>2]=0;if((D|0)<=0){XH(r);i=d;return}D=t;e=g;n=o;C=o+128|0;o=s;s=96616|0;while(1){c[q>>2]=o;h=(we[c[s+16>>2]&15](D,f,o,(e-o|0)>32?o+32|0:g,q,n,C,p)|0)==2;m=c[q>>2]|0;if(h|(m|0)==(o|0)){E=20;break}if(n>>>0<(c[p>>2]|0)>>>0){h=n;do{DI(b,c[h>>2]|0);h=h+4|0;}while(h>>>0<(c[p>>2]|0)>>>0);F=c[q>>2]|0}else{F=m}if(!(F>>>0<g>>>0)){E=25;break}o=F;s=c[t>>2]|0}if((E|0)==20){PN(95736)}else if((E|0)==25){XH(r);i=d;return}}function vO(a,b){a=a|0;b=b|0;a=i;Gb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function wO(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=94944;e=b+8|0;b=c[e>>2]|0;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);if((b|0)==(c[23686]|0)){i=d;return}_b(c[e>>2]|0);i=d;return}function xO(a){a=a|0;a=Cc(8)|0;oH(a,94736);c[a>>2]=91704;Kd(a|0,91744,40)}function yO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+448|0;f=e;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;z=e+304|0;A=e+320|0;B=e+336|0;C=e+352|0;D=e+368|0;E=e+384|0;F=e+400|0;G=e+416|0;H=e+432|0;c[b+4>>2]=d+ -1;c[b>>2]=94776;d=b+8|0;I=b+12|0;J=b+136|0;a[J]=1;K=b+24|0;c[I>>2]=K;c[d>>2]=K;c[b+16>>2]=J;J=28;L=K;do{if((L|0)==0){M=0}else{c[L>>2]=0;M=c[I>>2]|0}L=M+4|0;c[I>>2]=L;J=J+ -1|0;}while((J|0)!=0);PH(b+144|0,94760,1);J=c[d>>2]|0;d=c[I>>2]|0;if((d|0)!=(J|0)){c[I>>2]=d+(~((d+ -4+(0-J)|0)>>>2)<<2)}c[99668>>2]=0;c[24916]=93256;if(!((c[23320]|0)==-1)){c[G>>2]=93280;c[G+4>>2]=171;c[G+8>>2]=0;IH(93280,G,172)}zO(b,99664,(c[93284>>2]|0)+ -1|0);c[99660>>2]=0;c[24914]=93296;if(!((c[23330]|0)==-1)){c[F>>2]=93320;c[F+4>>2]=171;c[F+8>>2]=0;IH(93320,F,172)}zO(b,99656,(c[93324>>2]|0)+ -1|0);c[99644>>2]=0;c[24910]=94872;c[99648>>2]=0;a[99652|0]=0;F=c[(wc()|0)>>2]|0;c[99648>>2]=F;if(!((c[23714]|0)==-1)){c[E>>2]=94856;c[E+4>>2]=171;c[E+8>>2]=0;IH(94856,E,172)}zO(b,99640,(c[94860>>2]|0)+ -1|0);c[99636>>2]=0;c[24908]=95832;if(!((c[23712]|0)==-1)){c[D>>2]=94848;c[D+4>>2]=171;c[D+8>>2]=0;IH(94848,D,172)}zO(b,99632,(c[94852>>2]|0)+ -1|0);c[99628>>2]=0;c[24906]=96048;if(!((c[23730]|0)==-1)){c[C>>2]=94920;c[C+4>>2]=171;c[C+8>>2]=0;IH(94920,C,172)}zO(b,99624,(c[94924>>2]|0)+ -1|0);c[99612>>2]=0;c[24902]=94944;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);c[99616>>2]=c[23686];if(!((c[23732]|0)==-1)){c[B>>2]=94928;c[B+4>>2]=171;c[B+8>>2]=0;IH(94928,B,172)}zO(b,99608,(c[94932>>2]|0)+ -1|0);c[99604>>2]=0;c[24900]=96272;if(!((c[23746]|0)==-1)){c[A>>2]=94984;c[A+4>>2]=171;c[A+8>>2]=0;IH(94984,A,172)}zO(b,99600,(c[94988>>2]|0)+ -1|0);c[99596>>2]=0;c[24898]=96392;if(!((c[23748]|0)==-1)){c[z>>2]=94992;c[z+4>>2]=171;c[z+8>>2]=0;IH(94992,z,172)}zO(b,99592,(c[94996>>2]|0)+ -1|0);c[99572>>2]=0;c[24892]=95024;a[99576|0]=46;a[99577|0]=44;z=99580|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;if(!((c[23750]|0)==-1)){c[y>>2]=95e3;c[y+4>>2]=171;c[y+8>>2]=0;IH(95e3,y,172)}zO(b,99568,(c[95004>>2]|0)+ -1|0);c[99540>>2]=0;c[24884]=95064;c[99544>>2]=46;c[99548>>2]=44;y=99552|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(!((c[23752]|0)==-1)){c[x>>2]=95008;c[x+4>>2]=171;c[x+8>>2]=0;IH(95008,x,172)}zO(b,99536,(c[95012>>2]|0)+ -1|0);c[99532>>2]=0;c[24882]=93336;if(!((c[23348]|0)==-1)){c[w>>2]=93392;c[w+4>>2]=171;c[w+8>>2]=0;IH(93392,w,172)}zO(b,99528,(c[93396>>2]|0)+ -1|0);c[99524>>2]=0;c[24880]=93456;if(!((c[23378]|0)==-1)){c[v>>2]=93512;c[v+4>>2]=171;c[v+8>>2]=0;IH(93512,v,172)}zO(b,99520,(c[93516>>2]|0)+ -1|0);c[99516>>2]=0;c[24878]=93528;if(!((c[23394]|0)==-1)){c[u>>2]=93576;c[u+4>>2]=171;c[u+8>>2]=0;IH(93576,u,172)}zO(b,99512,(c[93580>>2]|0)+ -1|0);c[99508>>2]=0;c[24876]=93592;if(!((c[23410]|0)==-1)){c[t>>2]=93640;c[t+4>>2]=171;c[t+8>>2]=0;IH(93640,t,172)}zO(b,99504,(c[93644>>2]|0)+ -1|0);c[99500>>2]=0;c[24874]=94184;if(!((c[23558]|0)==-1)){c[s>>2]=94232;c[s+4>>2]=171;c[s+8>>2]=0;IH(94232,s,172)}zO(b,99496,(c[94236>>2]|0)+ -1|0);c[99492>>2]=0;c[24872]=94248;if(!((c[23574]|0)==-1)){c[r>>2]=94296;c[r+4>>2]=171;c[r+8>>2]=0;IH(94296,r,172)}zO(b,99488,(c[94300>>2]|0)+ -1|0);c[99484>>2]=0;c[24870]=94312;if(!((c[23590]|0)==-1)){c[q>>2]=94360;c[q+4>>2]=171;c[q+8>>2]=0;IH(94360,q,172)}zO(b,99480,(c[94364>>2]|0)+ -1|0);c[99476>>2]=0;c[24868]=94376;if(!((c[23606]|0)==-1)){c[p>>2]=94424;c[p+4>>2]=171;c[p+8>>2]=0;IH(94424,p,172)}zO(b,99472,(c[94428>>2]|0)+ -1|0);c[99468>>2]=0;c[24866]=94440;if(!((c[23616]|0)==-1)){c[o>>2]=94464;c[o+4>>2]=171;c[o+8>>2]=0;IH(94464,o,172)}zO(b,99464,(c[94468>>2]|0)+ -1|0);c[99460>>2]=0;c[24864]=94520;if(!((c[23636]|0)==-1)){c[n>>2]=94544;c[n+4>>2]=171;c[n+8>>2]=0;IH(94544,n,172)}zO(b,99456,(c[94548>>2]|0)+ -1|0);c[99452>>2]=0;c[24862]=94576;if(!((c[23650]|0)==-1)){c[m>>2]=94600;c[m+4>>2]=171;c[m+8>>2]=0;IH(94600,m,172)}zO(b,99448,(c[94604>>2]|0)+ -1|0);c[99444>>2]=0;c[24860]=94624;if(!((c[23662]|0)==-1)){c[l>>2]=94648;c[l+4>>2]=171;c[l+8>>2]=0;IH(94648,l,172)}zO(b,99440,(c[94652>>2]|0)+ -1|0);c[99428>>2]=0;c[24856]=93672;c[99432>>2]=93720;if(!((c[23438]|0)==-1)){c[k>>2]=93752;c[k+4>>2]=171;c[k+8>>2]=0;IH(93752,k,172)}zO(b,99424,(c[93756>>2]|0)+ -1|0);c[99412>>2]=0;c[24852]=93824;c[99416>>2]=93872;if(!((c[23476]|0)==-1)){c[j>>2]=93904;c[j+4>>2]=171;c[j+8>>2]=0;IH(93904,j,172)}zO(b,99408,(c[93908>>2]|0)+ -1|0);c[99396>>2]=0;c[24848]=95768;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);c[99400>>2]=c[23686];c[24848]=94120;if(!((c[23534]|0)==-1)){c[h>>2]=94136;c[h+4>>2]=171;c[h+8>>2]=0;IH(94136,h,172)}zO(b,99392,(c[94140>>2]|0)+ -1|0);c[99380>>2]=0;c[24844]=95768;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);c[99384>>2]=c[23686];c[24844]=94152;if(!((c[23542]|0)==-1)){c[g>>2]=94168;c[g+4>>2]=171;c[g+8>>2]=0;IH(94168,g,172)}zO(b,99376,(c[94172>>2]|0)+ -1|0);c[99372>>2]=0;c[24842]=94664;if(!((c[23672]|0)==-1)){c[f>>2]=94688;c[f+4>>2]=171;c[f+8>>2]=0;IH(94688,f,172)}zO(b,99368,(c[94692>>2]|0)+ -1|0);c[99364>>2]=0;c[24840]=94704;if((c[23682]|0)==-1){N=94728;O=94728;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=99360;zO(b,T,S);i=e;return}c[H>>2]=94728;c[H+4>>2]=171;c[H+8>>2]=0;IH(94728,H,172);N=94728;O=94728;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=99360;zO(b,T,S);i=e;return}function zO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;mH(b);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f;j=c[h>>2]|0;k=a-j>>2;do{if(k>>>0>d>>>0){l=j}else{m=d+1|0;if(k>>>0<m>>>0){EQ(f,m-k|0);l=c[h>>2]|0;break}if(!(k>>>0>m>>>0)){l=j;break}n=j+(m<<2)|0;if((a|0)==(n|0)){l=j;break}c[g>>2]=a+(~((a+ -4+(0-n)|0)>>>2)<<2);l=j}}while(0);j=c[l+(d<<2)>>2]|0;if((j|0)==0){o=l;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}nH(j)|0;o=c[h>>2]|0;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}function AO(a){a=a|0;var b=0;b=i;BO(a);iS(a);i=b;return}function BO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[b>>2]=94776;e=b+12|0;f=c[e>>2]|0;g=b+8|0;h=c[g>>2]|0;if((f|0)!=(h|0)){j=f;f=h;h=0;while(1){k=c[f+(h<<2)>>2]|0;if((k|0)==0){l=f;m=j}else{nH(k)|0;l=c[g>>2]|0;m=c[e>>2]|0}k=h+1|0;if(k>>>0<m-l>>2>>>0){j=m;f=l;h=k}else{break}}}XH(b+144|0);h=c[g>>2]|0;if((h|0)==0){i=d;return}g=c[e>>2]|0;if((g|0)!=(h|0)){c[e>>2]=g+(~((g+ -4+(0-h)|0)>>>2)<<2)}if((b+24|0)==(h|0)){a[b+136|0]=0;i=d;return}else{iS(h);i=d;return}}function CO(){var b=0,d=0,e=0,f=0;b=i;if((a[94832]|0)!=0){d=94824;e=c[23706]|0;i=b;return e|0}if((Ya(94832)|0)==0){d=94824;e=c[23706]|0;i=b;return e|0}do{if((a[94808]|0)==0){if((Ya(94808)|0)==0){break}yO(99200,1);c[23698]=99200;c[23700]=94792;Rb(94808)}}while(0);f=c[c[23700]>>2]|0;c[23704]=f;mH(f);c[23706]=94816;Rb(94832);d=94824;e=c[23706]|0;i=b;return e|0}function DO(a){a=a|0;var b=0,d=0;b=i;d=c[(CO()|0)>>2]|0;c[a>>2]=d;mH(d);i=b;return}function EO(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;mH(e);i=d;return}function FO(a){a=a|0;var b=0;b=i;nH(c[a>>2]|0)|0;i=b;return}function GO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=171;c[e+8>>2]=0;IH(a,e,172)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function HO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=171;c[e+8>>2]=0;IH(a,e,172)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=Cc(4)|0;h=g;HR(h);j=110416;k=127;Kd(g|0,j|0,k|0)}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=Cc(4)|0;h=g;HR(h);j=110416;k=127;Kd(g|0,j|0,k|0)}else{i=d;return f|0}return 0}function IO(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function JO(a){a=a|0;var b=0;b=i;if((a|0)==0){i=b;return}Yd[c[(c[a>>2]|0)+4>>2]&255](a);i=b;return}function KO(a){a=a|0;var b=0;b=c[23710]|0;c[23710]=1+b;c[a+4>>2]=b+1;i=i;return}function LO(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function MO(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;a=i;if(!(e>>>0<128)){f=0;i=a;return f|0}f=(b[(c[(wc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;i=a;return f|0}function NO(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;if((d|0)==(e|0)){g=d;i=a;return g|0}else{h=d;j=f}while(1){f=c[h>>2]|0;if(f>>>0<128){k=b[(c[(wc()|0)>>2]|0)+(f<<1)>>1]|0}else{k=0}b[j>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;break}else{h=f;j=j+2|0}}i=a;return g|0}function OO(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;if((e|0)==(f|0)){g=e;i=a;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128){if(!((b[(c[(wc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16==0)){g=h;j=5;break}}e=h+4|0;if((e|0)==(f|0)){g=f;j=5;break}else{h=e}}if((j|0)==5){i=a;return g|0}return 0}function PO(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;a:do{if((e|0)==(f|0)){g=e}else{h=e;while(1){j=c[h>>2]|0;if(!(j>>>0<128)){g=h;break a}k=h+4|0;if((b[(c[(wc()|0)>>2]|0)+(j<<1)>>1]&d)<<16>>16==0){g=h;break a}if((k|0)==(f|0)){g=f;break}else{h=k}}}}while(0);i=a;return g|0}function QO(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(ud()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function RO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(ud()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function SO(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(zd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function TO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(zd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function UO(a,b){a=a|0;b=b|0;i=i;return b<<24>>24|0}function VO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((d|0)==(e|0)){g=d;i=b;return g|0}else{h=d;j=f}while(1){c[j>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{j=j+4|0;h=f}}i=b;return g|0}function WO(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b>>>0<128?b&255:c)|0}function XO(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;if((d|0)==(e|0)){h=d;i=b;return h|0}j=((e+ -4+(0-d)|0)>>>2)+1|0;k=d;l=g;while(1){g=c[k>>2]|0;a[l]=g>>>0<128?g&255:f;g=k+4|0;if((g|0)==(e|0)){break}else{l=l+1|0;k=g}}h=d+(j<<2)|0;i=b;return h|0}function YO(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=94872;e=c[b+8>>2]|0;do{if((e|0)!=0){if((a[b+12|0]|0)==0){break}jS(e)}}while(0);iS(b);i=d;return}function ZO(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=94872;e=c[b+8>>2]|0;if((e|0)==0){i=d;return}if((a[b+12|0]|0)==0){i=d;return}jS(e);i=d;return}function _O(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(ud()|0)>>2]|0)+((b&255)<<2)>>2]&255;i=a;return d|0}function $O(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(ud()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function aP(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(zd()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;i=a;return d|0}function bP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(zd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function cP(a,b){a=a|0;b=b|0;i=i;return b|0}function dP(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((c|0)==(d|0)){f=c;i=b;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{h=h+1|0;g=e}}i=b;return f|0}function eP(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b<<24>>24>-1?b:c)|0}function fP(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((c|0)==(d|0)){g=c;i=b;return g|0}else{h=c;j=f}while(1){f=a[h]|0;a[j]=f<<24>>24>-1?f:e;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{j=j+1|0;h=f}}i=b;return g|0}function gP(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function hP(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function iP(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function jP(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function kP(a){a=a|0;i=i;return 1}function lP(a){a=a|0;i=i;return 1}function mP(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;i=i;return(b>>>0<e>>>0?b:e)|0}function nP(a){a=a|0;i=i;return 1}function oP(a){a=a|0;var b=0;b=i;wO(a);iS(a);i=b;return}function pP(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+8|0;m=l;n=m;o=i;i=i+8|0;p=(e|0)==(f|0);a:do{if(p){c[k>>2]=h;c[g>>2]=e;q=e}else{r=e;while(1){s=r+4|0;if((c[r>>2]|0)==0){t=r;break}if((s|0)==(f|0)){t=f;break}else{r=s}}c[k>>2]=h;c[g>>2]=e;if(p|(h|0)==(j|0)){q=e;break}r=j;s=b+8|0;u=o;v=e;w=h;x=t;while(1){y=d;z=c[y+4>>2]|0;A=m;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=Jc(c[s>>2]|0)|0;A=gR(w,g,x-v>>2,r-w|0,d)|0;if((z|0)!=0){Jc(z|0)|0}if((A|0)==0){B=1;C=33;break}else if((A|0)==-1){C=10;break}z=(c[k>>2]|0)+A|0;c[k>>2]=z;if((z|0)==(j|0)){C=31;break}if((x|0)==(f|0)){D=c[g>>2]|0;E=z;F=f}else{z=Jc(c[s>>2]|0)|0;A=fR(u,0,d)|0;if((z|0)!=0){Jc(z|0)|0}if((A|0)==-1){B=2;C=33;break}z=c[k>>2]|0;if(A>>>0>(r-z|0)>>>0){B=1;C=33;break}b:do{if((A|0)!=0){y=z;G=A;H=u;while(1){I=a[H]|0;c[k>>2]=y+1;a[y]=I;I=G+ -1|0;if((I|0)==0){break b}y=c[k>>2]|0;H=H+1|0;G=I}}}while(0);A=(c[g>>2]|0)+4|0;c[g>>2]=A;c:do{if((A|0)==(f|0)){J=f}else{z=A;while(1){G=z+4|0;if((c[z>>2]|0)==0){J=z;break c}if((G|0)==(f|0)){J=f;break}else{z=G}}}}while(0);D=A;E=c[k>>2]|0;F=J}if((D|0)==(f|0)|(E|0)==(j|0)){q=D;break a}else{v=D;w=E;x=F}}if((C|0)==10){c[k>>2]=w;d:do{if((v|0)==(c[g>>2]|0)){K=v}else{x=v;u=w;while(1){r=c[x>>2]|0;z=Jc(c[s>>2]|0)|0;G=fR(u,r,n)|0;if((z|0)!=0){Jc(z|0)|0}if((G|0)==-1){K=x;break d}z=(c[k>>2]|0)+G|0;c[k>>2]=z;G=x+4|0;if((G|0)==(c[g>>2]|0)){K=G;break}else{x=G;u=z}}}}while(0);c[g>>2]=K;B=2;i=l;return B|0}else if((C|0)==31){q=c[g>>2]|0;break}else if((C|0)==33){i=l;return B|0}}}while(0);B=(q|0)!=(f|0)|0;i=l;return B|0}function qP(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=i;i=i+8|0;m=l;n=m;o=(e|0)==(f|0);a:do{if(o){c[k>>2]=h;c[g>>2]=e;p=e}else{q=e;while(1){r=q+1|0;if((a[q]|0)==0){s=q;break}if((r|0)==(f|0)){s=f;break}else{q=r}}c[k>>2]=h;c[g>>2]=e;if(o|(h|0)==(j|0)){p=e;break}q=j;r=b+8|0;t=e;u=h;v=s;while(1){w=d;x=c[w+4>>2]|0;y=m;c[y>>2]=c[w>>2];c[y+4>>2]=x;z=v;x=Jc(c[r>>2]|0)|0;y=cR(u,g,z-t|0,q-u>>2,d)|0;if((x|0)!=0){Jc(x|0)|0}if((y|0)==0){A=2;B=32;break}else if((y|0)==-1){B=10;break}x=(c[k>>2]|0)+(y<<2)|0;c[k>>2]=x;if((x|0)==(j|0)){B=30;break}y=c[g>>2]|0;if((v|0)==(f|0)){C=y;D=x;E=f}else{w=Jc(c[r>>2]|0)|0;F=bR(x,y,1,d)|0;if((w|0)!=0){Jc(w|0)|0}if((F|0)!=0){A=2;B=32;break}c[k>>2]=(c[k>>2]|0)+4;F=(c[g>>2]|0)+1|0;c[g>>2]=F;b:do{if((F|0)==(f|0)){G=f}else{w=F;while(1){y=w+1|0;if((a[w]|0)==0){G=w;break b}if((y|0)==(f|0)){G=f;break}else{w=y}}}}while(0);C=F;D=c[k>>2]|0;E=G}if((C|0)==(f|0)|(D|0)==(j|0)){p=C;break a}else{t=C;u=D;v=E}}if((B|0)==10){c[k>>2]=u;c:do{if((t|0)==(c[g>>2]|0)){H=t}else{v=t;q=u;while(1){w=Jc(c[r>>2]|0)|0;y=bR(q,v,z-v|0,n)|0;if((w|0)!=0){Jc(w|0)|0}if((y|0)==-1){B=15;break}else if((y|0)==0){I=v+1|0}else if((y|0)==-2){B=16;break}else{I=v+y|0}y=(c[k>>2]|0)+4|0;c[k>>2]=y;if((I|0)==(c[g>>2]|0)){H=I;break c}else{v=I;q=y}}if((B|0)==15){c[g>>2]=v;A=2;i=l;return A|0}else if((B|0)==16){c[g>>2]=v;A=1;i=l;return A|0}}}while(0);c[g>>2]=H;A=(H|0)!=(f|0)|0;i=l;return A|0}else if((B|0)==30){p=c[g>>2]|0;break}else if((B|0)==32){i=l;return A|0}}}while(0);A=(p|0)!=(f|0)|0;i=l;return A|0}function rP(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h;j=Jc(c[b+8>>2]|0)|0;b=fR(e,0,d)|0;if((j|0)!=0){Jc(j|0)|0}if((b|0)==0|(b|0)==-1){k=2;i=h;return k|0}j=b+ -1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=b;m=j;n=e}while(1){e=a[n]|0;c[g>>2]=l+1;a[l]=e;e=m+ -1|0;if((e|0)==0){k=0;break}l=c[g>>2]|0;n=n+1|0;m=e}i=h;return k|0}function sP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+8|0;a=Jc(c[d>>2]|0)|0;e=eR(0,0,4)|0;if((a|0)!=0){Jc(a|0)|0}do{if((e|0)==0){a=c[d>>2]|0;if((a|0)==0){f=1;break}g=Jc(a|0)|0;if((g|0)==0){f=0;break}Jc(g|0)|0;f=0}else{f=-1}}while(0);i=b;return f|0}function tP(a){a=a|0;i=i;return 0}function uP(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((f|0)==0|(d|0)==(e|0)){h=0;i=g;return h|0}j=e;k=a+8|0;a=d;d=0;l=0;while(1){m=Jc(c[k>>2]|0)|0;n=aR(a,j-a|0,b)|0;if((m|0)!=0){Jc(m|0)|0}if((n|0)==-2|(n|0)==-1){h=d;o=9;break}else if((n|0)==0){p=a+1|0;q=1}else{p=a+n|0;q=n}n=q+d|0;m=l+1|0;if(m>>>0>=f>>>0|(p|0)==(e|0)){h=n;o=9;break}else{a=p;d=n;l=m}}if((o|0)==9){i=g;return h|0}return 0}function vP(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;do{if((d|0)==0){e=1}else{a=Jc(d|0)|0;if((a|0)==0){e=4;break}Jc(a|0)|0;e=4}}while(0);i=b;return e|0}function wP(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function xP(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=yP(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function yP(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;c[g>>2]=d;c[k>>2]=h;do{if((m&2|0)!=0){if((j-h|0)<3){o=1;i=n;return o|0}else{c[k>>2]=h+1;a[h]=-17;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-69;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-65;break}}}while(0);h=f;m=c[g>>2]|0;if(!(m>>>0<f>>>0)){o=0;i=n;return o|0}d=j;j=m;a:while(1){m=b[j>>1]|0;p=m&65535;if(p>>>0>l>>>0){o=2;q=26;break}do{if((m&65535)<128){r=c[k>>2]|0;if((d-r|0)<1){o=1;q=26;break a}c[k>>2]=r+1;a[r]=m}else{if((m&65535)<2048){r=c[k>>2]|0;if((d-r|0)<2){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>6|192;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((m&65535)<55296){r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if(!((m&65535)<56320)){if((m&65535)<57344){o=2;q=26;break a}r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((h-j|0)<4){o=1;q=26;break a}r=j+2|0;s=e[r>>1]|0;if((s&64512|0)!=56320){o=2;q=26;break a}if((d-(c[k>>2]|0)|0)<4){o=1;q=26;break a}t=p&960;if(((t<<10)+65536|p<<10&64512|s&1023)>>>0>l>>>0){o=2;q=26;break a}c[g>>2]=r;r=(t>>>6)+1|0;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=r>>>2|240;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=p>>>2&15|r<<4&48|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p<<4&48|s>>>6&15|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=s&63|128}}while(0);p=(c[g>>2]|0)+2|0;c[g>>2]=p;if(p>>>0<f>>>0){j=p}else{o=0;q=26;break}}if((q|0)==26){i=n;return o|0}return 0}function zP(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=AP(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function AP(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;c[g>>2]=e;c[k>>2]=h;h=c[g>>2]|0;do{if((m&4|0)==0){o=h}else{if((f-h|0)<=2){o=h;break}if(!((a[h]|0)==-17)){o=h;break}if(!((a[h+1|0]|0)==-69)){o=h;break}if(!((a[h+2|0]|0)==-65)){o=h;break}e=h+3|0;c[g>>2]=e;o=e}}while(0);a:do{if(o>>>0<f>>>0){h=f;m=j;e=o;p=c[k>>2]|0;b:while(1){if(!(p>>>0<j>>>0)){q=e;break a}r=a[e]|0;s=r&255;if(s>>>0>l>>>0){t=2;u=41;break}do{if(r<<24>>24>-1){b[p>>1]=r&255;c[g>>2]=e+1}else{if((r&255)<194){t=2;u=41;break b}if((r&255)<224){if((h-e|0)<2){t=1;u=41;break b}v=d[e+1|0]|0;if((v&192|0)!=128){t=2;u=41;break b}w=v&63|s<<6&1984;if(w>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=w;c[g>>2]=e+2;break}if((r&255)<240){if((h-e|0)<3){t=1;u=41;break b}w=a[e+1|0]|0;v=a[e+2|0]|0;if((s|0)==224){if(!((w&-32)<<24>>24==-96)){t=2;u=41;break b}}else if((s|0)==237){if(!((w&-32)<<24>>24==-128)){t=2;u=41;break b}}else{if(!((w&-64)<<24>>24==-128)){t=2;u=41;break b}}x=v&255;if((x&192|0)!=128){t=2;u=41;break b}v=(w&255)<<6&4032|s<<12|x&63;if((v&65535)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=v;c[g>>2]=e+3;break}if(!((r&255)<245)){t=2;u=41;break b}if((h-e|0)<4){t=1;u=41;break b}v=a[e+1|0]|0;x=a[e+2|0]|0;w=a[e+3|0]|0;if((s|0)==240){if(!((v+112<<24>>24&255)<48)){t=2;u=41;break b}}else if((s|0)==244){if(!((v&-16)<<24>>24==-128)){t=2;u=41;break b}}else{if(!((v&-64)<<24>>24==-128)){t=2;u=41;break b}}y=x&255;if((y&192|0)!=128){t=2;u=41;break b}x=w&255;if((x&192|0)!=128){t=2;u=41;break b}if((m-p|0)<4){t=1;u=41;break b}w=s&7;z=v&255;v=y<<6;A=x&63;if((z<<12&258048|w<<18|v&4032|A)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=z<<2&60|y>>>4&3|((z>>>4&3|w<<2)<<6)+16320|55296;w=p+2|0;c[k>>2]=w;b[w>>1]=A|v&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);s=(c[k>>2]|0)+2|0;c[k>>2]=s;r=c[g>>2]|0;if(r>>>0<f>>>0){e=r;p=s}else{q=r;break a}}if((u|0)==41){i=n;return t|0}}else{q=o}}while(0);t=q>>>0<f>>>0|0;i=n;return t|0}function BP(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function CP(a){a=a|0;i=i;return 0}function DP(a){a=a|0;i=i;return 0}function EP(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=FP(c,d,e,1114111,0)|0;i=b;return a|0}function FP(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k]|0;n=m&255;if(n>>>0>f>>>0){o=k;break a}do{if(m<<24>>24>-1){p=k+1|0;q=l}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}r=d[k+1|0]|0;if((r&192|0)!=128){o=k;break a}if((r&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;q=l;break}if((m&255)<240){s=k;if((g-s|0)<3){o=k;break a}r=a[k+1|0]|0;t=a[k+2|0]|0;if((n|0)==224){if(!((r&-32)<<24>>24==-96)){u=21;break b}}else if((n|0)==237){if(!((r&-32)<<24>>24==-128)){u=23;break b}}else{if(!((r&-64)<<24>>24==-128)){u=25;break b}}v=t&255;if((v&192|0)!=128){o=k;break a}if(((r&255)<<6&4032|n<<12&61440|v&63)>>>0>f>>>0){o=k;break a}p=k+3|0;q=l;break}if(!((m&255)<245)){o=k;break a}w=k;if((g-w|0)<4){o=k;break a}if((e-l|0)>>>0<2){o=k;break a}v=a[k+1|0]|0;r=a[k+2|0]|0;t=a[k+3|0]|0;if((n|0)==244){if(!((v&-16)<<24>>24==-128)){u=36;break b}}else if((n|0)==240){if(!((v+112<<24>>24&255)<48)){u=34;break b}}else{if(!((v&-64)<<24>>24==-128)){u=38;break b}}x=r&255;if((x&192|0)!=128){o=k;break a}r=t&255;if((r&192|0)!=128){o=k;break a}if(((v&255)<<12&258048|n<<18&1835008|x<<6&4032|r&63)>>>0>f>>>0){o=k;break a}p=k+4|0;q=l+1|0}}while(0);n=q+1|0;if(p>>>0<c>>>0&n>>>0<e>>>0){k=p;l=n}else{o=p;break a}}if((u|0)==21){y=s-b|0;i=h;return y|0}else if((u|0)==23){y=s-b|0;i=h;return y|0}else if((u|0)==25){y=s-b|0;i=h;return y|0}else if((u|0)==34){y=w-b|0;i=h;return y|0}else if((u|0)==36){y=w-b|0;i=h;return y|0}else if((u|0)==38){y=w-b|0;i=h;return y|0}}else{o=j}}while(0);y=o-b|0;i=h;return y|0}function GP(a){a=a|0;i=i;return 4}function HP(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function IP(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=JP(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function JP(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;c[e>>2]=b;c[h>>2]=f;do{if((k&2|0)!=0){if((g-f|0)<3){m=1;i=l;return m|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(!(f>>>0<d>>>0)){m=0;i=l;return m|0}k=g;g=f;a:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>j>>>0){m=2;n=19;break}do{if(f>>>0<128){b=c[h>>2]|0;if((k-b|0)<1){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048){b=c[h>>2]|0;if((k-b|0)<2){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;o=k-b|0;if(f>>>0<65536){if((o|0)<3){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>12|224;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f>>>6&63|128;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f&63|128;break}else{if((o|0)<4){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{m=0;n=19;break}}if((n|0)==19){i=l;return m|0}return 0}function KP(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=LP(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function LP(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;c[f>>2]=b;c[j>>2]=g;g=c[f>>2]|0;do{if((l&4|0)==0){n=g}else{if((e-g|0)<=2){n=g;break}if(!((a[g]|0)==-17)){n=g;break}if(!((a[g+1|0]|0)==-69)){n=g;break}if(!((a[g+2|0]|0)==-65)){n=g;break}b=g+3|0;c[f>>2]=b;n=b}}while(0);a:do{if(n>>>0<e>>>0){g=e;l=n;b=c[j>>2]|0;b:while(1){if(!(b>>>0<h>>>0)){o=l;break a}p=a[l]|0;q=p&255;do{if(p<<24>>24>-1){if(q>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=q;c[f>>2]=l+1}else{if((p&255)<194){r=2;s=40;break b}if((p&255)<224){if((g-l|0)<2){r=1;s=40;break b}t=d[l+1|0]|0;if((t&192|0)!=128){r=2;s=40;break b}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+2;break}if((p&255)<240){if((g-l|0)<3){r=1;s=40;break b}u=a[l+1|0]|0;t=a[l+2|0]|0;if((q|0)==237){if(!((u&-32)<<24>>24==-128)){r=2;s=40;break b}}else if((q|0)==224){if(!((u&-32)<<24>>24==-96)){r=2;s=40;break b}}else{if(!((u&-64)<<24>>24==-128)){r=2;s=40;break b}}v=t&255;if((v&192|0)!=128){r=2;s=40;break b}t=(u&255)<<6&4032|q<<12&61440|v&63;if(t>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=t;c[f>>2]=l+3;break}if(!((p&255)<245)){r=2;s=40;break b}if((g-l|0)<4){r=1;s=40;break b}t=a[l+1|0]|0;v=a[l+2|0]|0;u=a[l+3|0]|0;if((q|0)==240){if(!((t+112<<24>>24&255)<48)){r=2;s=40;break b}}else if((q|0)==244){if(!((t&-16)<<24>>24==-128)){r=2;s=40;break b}}else{if(!((t&-64)<<24>>24==-128)){r=2;s=40;break b}}w=v&255;if((w&192|0)!=128){r=2;s=40;break b}v=u&255;if((v&192|0)!=128){r=2;s=40;break b}u=(t&255)<<12&258048|q<<18&1835008|w<<6&4032|v&63;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+4}}while(0);q=(c[j>>2]|0)+4|0;c[j>>2]=q;p=c[f>>2]|0;if(p>>>0<e>>>0){l=p;b=q}else{o=p;break a}}if((s|0)==40){i=m;return r|0}}else{o=n}}while(0);r=o>>>0<e>>>0|0;i=m;return r|0}function MP(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function NP(a){a=a|0;i=i;return 0}function OP(a){a=a|0;i=i;return 0}function PP(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=QP(c,d,e,1114111,0)|0;i=b;return a|0}function QP(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=1;b:while(1){m=a[k]|0;n=m&255;do{if(m<<24>>24>-1){if(n>>>0>f>>>0){o=k;break a}p=k+1|0}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}q=d[k+1|0]|0;if((q&192|0)!=128){o=k;break a}if((q&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;break}if((m&255)<240){r=k;if((g-r|0)<3){o=k;break a}q=a[k+1|0]|0;s=a[k+2|0]|0;if((n|0)==237){if(!((q&-32)<<24>>24==-128)){t=23;break b}}else if((n|0)==224){if(!((q&-32)<<24>>24==-96)){t=21;break b}}else{if(!((q&-64)<<24>>24==-128)){t=25;break b}}u=s&255;if((u&192|0)!=128){o=k;break a}if(((q&255)<<6&4032|n<<12&61440|u&63)>>>0>f>>>0){o=k;break a}p=k+3|0;break}if(!((m&255)<245)){o=k;break a}v=k;if((g-v|0)<4){o=k;break a}u=a[k+1|0]|0;q=a[k+2|0]|0;s=a[k+3|0]|0;if((n|0)==240){if(!((u+112<<24>>24&255)<48)){t=33;break b}}else if((n|0)==244){if(!((u&-16)<<24>>24==-128)){t=35;break b}}else{if(!((u&-64)<<24>>24==-128)){t=37;break b}}w=q&255;if((w&192|0)!=128){o=k;break a}q=s&255;if((q&192|0)!=128){o=k;break a}if(((u&255)<<12&258048|n<<18&1835008|w<<6&4032|q&63)>>>0>f>>>0){o=k;break a}p=k+4|0}}while(0);if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}k=p;l=l+1|0}if((t|0)==21){x=r-b|0;i=h;return x|0}else if((t|0)==23){x=r-b|0;i=h;return x|0}else if((t|0)==25){x=r-b|0;i=h;return x|0}else if((t|0)==33){x=v-b|0;i=h;return x|0}else if((t|0)==35){x=v-b|0;i=h;return x|0}else if((t|0)==37){x=v-b|0;i=h;return x|0}}else{o=j}}while(0);x=o-b|0;i=h;return x|0}function RP(a){a=a|0;i=i;return 4}function SP(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function TP(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function UP(a){a=a|0;var b=0;b=i;c[a>>2]=95024;XH(a+12|0);iS(a);i=b;return}function VP(a){a=a|0;var b=0;b=i;c[a>>2]=95024;XH(a+12|0);i=b;return}function WP(a){a=a|0;var b=0;b=i;c[a>>2]=95064;XH(a+16|0);iS(a);i=b;return}function XP(a){a=a|0;var b=0;b=i;c[a>>2]=95064;XH(a+16|0);i=b;return}function YP(b){b=b|0;i=i;return a[b+8|0]|0}function ZP(a){a=a|0;i=i;return c[a+8>>2]|0}function _P(b){b=b|0;i=i;return a[b+9|0]|0}function $P(a){a=a|0;i=i;return c[a+12>>2]|0}function aQ(a,b){a=a|0;b=b|0;var c=0;c=i;NH(a,b+12|0);i=c;return}function bQ(a,b){a=a|0;b=b|0;var c=0;c=i;NH(a,b+16|0);i=c;return}function cQ(a,b){a=a|0;b=b|0;b=i;PH(a,95096,4);i=b;return}function dQ(a,b){a=a|0;b=b|0;b=i;xI(a,95104,CR(95104)|0);i=b;return}function eQ(a,b){a=a|0;b=b|0;b=i;PH(a,95128,5);i=b;return}function fQ(a,b){a=a|0;b=b|0;b=i;xI(a,95136,CR(95136)|0);i=b;return}function gQ(b){b=b|0;var d=0,e=0;b=i;if((a[95168]|0)!=0){d=95160;e=c[23790]|0;i=b;return e|0}if((Ya(95168)|0)==0){d=95160;e=c[23790]|0;i=b;return e|0}do{if((a[102368]|0)==0){if((Ya(102368)|0)==0){break}IS(102200,0,168)|0;Qd(174,0,q|0)|0;Rb(102368)}}while(0);_H(102200,102376)|0;_H(102212|0,102384)|0;_H(102224|0,102392)|0;_H(102236|0,102400)|0;_H(102248|0,102416)|0;_H(102260|0,102432)|0;_H(102272|0,102440)|0;_H(102284|0,102456)|0;_H(102296|0,102464)|0;_H(102308|0,102472)|0;_H(102320|0,102480)|0;_H(102332|0,102488)|0;_H(102344|0,102496)|0;_H(102356|0,102504)|0;c[23790]=102200;Rb(95168);d=95160;e=c[23790]|0;i=b;return e|0}function hQ(b){b=b|0;var d=0,e=0;b=i;if((a[95184]|0)!=0){d=95176;e=c[23794]|0;i=b;return e|0}if((Ya(95184)|0)==0){d=95176;e=c[23794]|0;i=b;return e|0}do{if((a[101832]|0)==0){if((Ya(101832)|0)==0){break}IS(101664,0,168)|0;Qd(175,0,q|0)|0;Rb(101832)}}while(0);AI(101664,101840)|0;AI(101676|0,101872)|0;AI(101688|0,101904)|0;AI(101700|0,101936)|0;AI(101712|0,101976)|0;AI(101724|0,102016)|0;AI(101736|0,102048)|0;AI(101748|0,102088)|0;AI(101760|0,102104)|0;AI(101772|0,102120)|0;AI(101784|0,102136)|0;AI(101796|0,102152)|0;AI(101808|0,102168)|0;AI(101820|0,102184)|0;c[23794]=101664;Rb(95184);d=95176;e=c[23794]|0;i=b;return e|0}function iQ(b){b=b|0;var d=0,e=0;b=i;if((a[95200]|0)!=0){d=95192;e=c[23798]|0;i=b;return e|0}if((Ya(95200)|0)==0){d=95192;e=c[23798]|0;i=b;return e|0}do{if((a[101440]|0)==0){if((Ya(101440)|0)==0){break}IS(101152,0,288)|0;Qd(176,0,q|0)|0;Rb(101440)}}while(0);_H(101152,101448)|0;_H(101164|0,101456)|0;_H(101176|0,101472)|0;_H(101188|0,101480)|0;_H(101200|0,101488)|0;_H(101212|0,101496)|0;_H(101224|0,101504)|0;_H(101236|0,101512)|0;_H(101248|0,101520)|0;_H(101260|0,101536)|0;_H(101272|0,101544)|0;_H(101284|0,101560)|0;_H(101296|0,101576)|0;_H(101308|0,101584)|0;_H(101320|0,101592)|0;_H(101332|0,101600)|0;_H(101344|0,101488)|0;_H(101356|0,101608)|0;_H(101368|0,101616)|0;_H(101380|0,101624)|0;_H(101392|0,101632)|0;_H(101404|0,101640)|0;_H(101416|0,101648)|0;_H(101428|0,101656)|0;c[23798]=101152;Rb(95200);d=95192;e=c[23798]|0;i=b;return e|0}function jQ(b){b=b|0;var d=0,e=0;b=i;if((a[95216]|0)!=0){d=95208;e=c[23802]|0;i=b;return e|0}if((Ya(95216)|0)==0){d=95208;e=c[23802]|0;i=b;return e|0}do{if((a[100600]|0)==0){if((Ya(100600)|0)==0){break}IS(100312,0,288)|0;Qd(177,0,q|0)|0;Rb(100600)}}while(0);AI(100312,100608)|0;AI(100324|0,100640)|0;AI(100336|0,100680)|0;AI(100348|0,100704)|0;AI(100360|0,101024)|0;AI(100372|0,100728)|0;AI(100384|0,100752)|0;AI(100396|0,100776)|0;AI(100408|0,100808)|0;AI(100420|0,100848)|0;AI(100432|0,100880)|0;AI(100444|0,100920)|0;AI(100456|0,100960)|0;AI(100468|0,100976)|0;AI(100480|0,100992)|0;AI(100492|0,101008)|0;AI(100504|0,101024)|0;AI(100516|0,101040)|0;AI(100528|0,101056)|0;AI(100540|0,101072)|0;AI(100552|0,101088)|0;AI(100564|0,101104)|0;AI(100576|0,101120)|0;AI(100588|0,101136)|0;c[23802]=100312;Rb(95216);d=95208;e=c[23802]|0;i=b;return e|0}function kQ(b){b=b|0;var d=0,e=0;b=i;if((a[95232]|0)!=0){d=95224;e=c[23806]|0;i=b;return e|0}if((Ya(95232)|0)==0){d=95224;e=c[23806]|0;i=b;return e|0}do{if((a[100288]|0)==0){if((Ya(100288)|0)==0){break}IS(1e5,0,288)|0;Qd(178,0,q|0)|0;Rb(100288)}}while(0);_H(1e5,100296)|0;_H(100012|0,100304)|0;c[23806]=1e5;Rb(95232);d=95224;e=c[23806]|0;i=b;return e|0}function lQ(b){b=b|0;var d=0,e=0;b=i;if((a[95248]|0)!=0){d=95240;e=c[23810]|0;i=b;return e|0}if((Ya(95248)|0)==0){d=95240;e=c[23810]|0;i=b;return e|0}do{if((a[99960]|0)==0){if((Ya(99960)|0)==0){break}IS(99672,0,288)|0;Qd(179,0,q|0)|0;Rb(99960)}}while(0);AI(99672,99968)|0;AI(99684|0,99984)|0;c[23810]=99672;Rb(95248);d=95240;e=c[23810]|0;i=b;return e|0}function mQ(b){b=b|0;var c=0;b=i;if((a[95272]|0)!=0){c=95256;i=b;return c|0}if((Ya(95272)|0)==0){c=95256;i=b;return c|0}PH(95256,95280,8);Qd(180,95256,q|0)|0;Rb(95272);c=95256;i=b;return c|0}function nQ(b){b=b|0;var c=0;b=i;if((a[95312]|0)!=0){c=95296;i=b;return c|0}if((Ya(95312)|0)==0){c=95296;i=b;return c|0}xI(95296,95320,CR(95320)|0);Qd(181,95296,q|0)|0;Rb(95312);c=95296;i=b;return c|0}function oQ(b){b=b|0;var c=0;b=i;if((a[95376]|0)!=0){c=95360;i=b;return c|0}if((Ya(95376)|0)==0){c=95360;i=b;return c|0}PH(95360,95384,8);Qd(180,95360,q|0)|0;Rb(95376);c=95360;i=b;return c|0}function pQ(b){b=b|0;var c=0;b=i;if((a[95416]|0)!=0){c=95400;i=b;return c|0}if((Ya(95416)|0)==0){c=95400;i=b;return c|0}xI(95400,95424,CR(95424)|0);Qd(181,95400,q|0)|0;Rb(95416);c=95400;i=b;return c|0}function qQ(b){b=b|0;var c=0;b=i;if((a[95480]|0)!=0){c=95464;i=b;return c|0}if((Ya(95480)|0)==0){c=95464;i=b;return c|0}PH(95464,95488,20);Qd(180,95464,q|0)|0;Rb(95480);c=95464;i=b;return c|0}function rQ(b){b=b|0;var c=0;b=i;if((a[95528]|0)!=0){c=95512;i=b;return c|0}if((Ya(95528)|0)==0){c=95512;i=b;return c|0}xI(95512,95536,CR(95536)|0);Qd(181,95512,q|0)|0;Rb(95528);c=95512;i=b;return c|0}function sQ(b){b=b|0;var c=0;b=i;if((a[95640]|0)!=0){c=95624;i=b;return c|0}if((Ya(95640)|0)==0){c=95624;i=b;return c|0}PH(95624,95648,11);Qd(180,95624,q|0)|0;Rb(95640);c=95624;i=b;return c|0}function tQ(b){b=b|0;var c=0;b=i;if((a[95680]|0)!=0){c=95664;i=b;return c|0}if((Ya(95680)|0)==0){c=95664;i=b;return c|0}xI(95664,95688,CR(95688)|0);Qd(181,95664,q|0)|0;Rb(95680);c=95664;i=b;return c|0}function uQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Lc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);l=+yS(b,g,c[23686]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function vQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Lc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);l=+yS(b,g,c[23686]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function wQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Lc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);l=+yS(b,g,c[23686]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=l;i=f;return+h}function xQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;do{if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0}else{if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;break}l=Lc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);n=kb(b|0,h|0,f|0,c[23686]|0)|0;o=c[l>>2]|0;if((o|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;break}if((o|0)!=34){j=n;k=J;break}c[e>>2]=4;j=-1;k=-1}}while(0);J=k;i=g;return j|0}function yQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Lc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);m=kb(b|0,h|0,f|0,c[23686]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function zQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Lc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);m=kb(b|0,h|0,f|0,c[23686]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function AQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Lc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);m=kb(b|0,h|0,f|0,c[23686]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>65535)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function BQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Lc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);n=Ec(b|0,h|0,f|0,c[23686]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)==34){c[e>>2]=4;e=(f|0)>0|(f|0)==0&n>>>0>0;J=e?2147483647:-2147483648;i=g;return(e?-1:0)|0}else{j=n;k=f;J=k;i=g;return j|0}return 0}function CQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=Lc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[94752]|0)==0){if((Ya(94752)|0)==0){break}c[23686]=Xb(2147483647,94760,0)|0;Rb(94752)}}while(0);m=Ec(b|0,h|0,f|0,c[23686]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}do{if((b|0)==34){c[e>>2]=4;if((f|0)>0|(f|0)==0&m>>>0>0){j=2147483647}else{break}i=g;return j|0}else{if((f|0)<-1|(f|0)==-1&m>>>0<2147483648){c[e>>2]=4;break}if((f|0)>0|(f|0)==0&m>>>0>2147483647){c[e>>2]=4;j=2147483647;i=g;return j|0}else{j=m;i=g;return j|0}}}while(0);j=-2147483648;i=g;return j|0}function DQ(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;e=a+4|0;f=e;g=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=e+4|0;e=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=(c[a>>2]|0)+(e>>1)|0;a=f;if((e&1|0)==0){h=g;Yd[h&255](a);i=b;return}else{h=c[(c[f>>2]|0)+g>>2]|0;Yd[h&255](a);i=b;return}}function EQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b+8|0;g=b+4|0;h=c[g>>2]|0;j=c[f>>2]|0;k=h;if(!(j-k>>2>>>0<d>>>0)){l=d;m=h;do{if((m|0)==0){n=0}else{c[m>>2]=0;n=c[g>>2]|0}m=n+4|0;c[g>>2]=m;l=l+ -1|0;}while((l|0)!=0);i=e;return}l=b+16|0;m=b;n=c[m>>2]|0;h=k-n>>2;k=h+d|0;if(k>>>0>1073741823){xO(0)}o=j-n|0;do{if(o>>2>>>0<536870911){n=o>>1;j=n>>>0<k>>>0?k:n;if((j|0)==0){p=0;q=0;break}n=b+128|0;if(!((a[n]|0)==0&j>>>0<29)){r=j;s=11;break}a[n]=1;p=j;q=l}else{r=1073741823;s=11}}while(0);if((s|0)==11){p=r;q=gS(r<<2)|0}r=d;d=q+(h<<2)|0;do{if((d|0)==0){t=0}else{c[d>>2]=0;t=d}d=t+4|0;r=r+ -1|0;}while((r|0)!=0);r=c[m>>2]|0;t=(c[g>>2]|0)-r|0;s=q+(h-(t>>2)<<2)|0;h=r;GS(s|0,h|0,t|0)|0;c[m>>2]=s;c[g>>2]=d;c[f>>2]=q+(p<<2);if((r|0)==0){i=e;return}if((l|0)==(r|0)){a[b+128|0]=0;i=e;return}else{iS(h);i=e;return}}function FQ(a){a=a|0;a=i;zI(99948|0);zI(99936|0);zI(99924|0);zI(99912|0);zI(99900|0);zI(99888|0);zI(99876|0);zI(99864|0);zI(99852|0);zI(99840|0);zI(99828|0);zI(99816|0);zI(99804|0);zI(99792|0);zI(99780|0);zI(99768|0);zI(99756|0);zI(99744|0);zI(99732|0);zI(99720|0);zI(99708|0);zI(99696|0);zI(99684|0);zI(99672);i=a;return}function GQ(a){a=a|0;a=i;XH(100276|0);XH(100264|0);XH(100252|0);XH(100240|0);XH(100228|0);XH(100216|0);XH(100204|0);XH(100192|0);XH(100180|0);XH(100168|0);XH(100156|0);XH(100144|0);XH(100132|0);XH(100120|0);XH(100108|0);XH(100096|0);XH(100084|0);XH(100072|0);XH(100060|0);XH(100048|0);XH(100036|0);XH(100024|0);XH(100012|0);XH(1e5);i=a;return}



function hk(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+64|0;k=e;e=f;f=g;g=h;h=k;l=0;while(1){if((l|0)>=368){break}a[k+l|0]=a[18896+l|0]|0;l=l+1|0}l=0;a:while(1){if((l|0)>=128){break}do{if((d[18972+l|0]|0|0)!=28){if((d[18972+l|0]|0|0)==0){break}if((c[e+(l<<2)>>2]|0)!=(l|0)){m=9;break a}}}while(0);l=l+1|0}if((m|0)==9){n=0;o=n;i=j;return o|0}l=0;b:while(1){if((l|0)>=256){m=36;break}k=c[e+(l<<2)>>2]|0;do{if((k|0)==-1){a[h+76+l|0]=1;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0}else{p=k;if((k|0)<0){if((p|0)<-4){m=17;break b}a[h+76+l|0]=5-(k+2);a[h+888+(l<<2)|0]=0;b[h+376+(l<<1)>>1]=0;break}q=k;if((p|0)<128){do{if((d[18972+q|0]|0|0)!=28){if((d[18972+k|0]|0|0)==0){break}if((k|0)!=(l|0)){m=23;break b}}}while(0);a[h+76+l|0]=a[18972+k|0]|0;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=k;b[h+376+(l<<1)>>1]=(k|0)==0?65535:k;break}if((ik(q)|0)<0){a[h+76+l|0]=0;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0;break}if((k|0)>65535){m=28;break b}do{if((c[13064+(((d[12808+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[h+76+l|0]=22}else{p=h+76+l|0;if((c[13064+(((d[14344+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[p]=26;break}else{a[p]=28;break}}}while(0);a[h+888+(l<<2)|0]=fk(k,h+888+(l<<2)+1|0)|0;b[h+376+(l<<1)>>1]=k}}while(0);l=l+1|0}if((m|0)==17){n=0;o=n;i=j;return o|0}else if((m|0)==23){n=0;o=n;i=j;return o|0}else if((m|0)==28){n=0;o=n;i=j;return o|0}else if((m|0)==36){c[h+372>>2]=g;c[h+368>>2]=f;if((f|0)!=0){c[h+332>>2]=49;c[h+336>>2]=49;c[h+340>>2]=49;c[h+344>>2]=50;c[h+348>>2]=50;c[h+352>>2]=50;c[h+356>>2]=51;c[h+360>>2]=51;c[h+364>>2]=51}c[h+60>>2]=13;c[h+64>>2]=14;n=h;o=n;i=j;return o|0}return 0}function ik(a){a=a|0;var b=0,c=0,e=0,f=0;b=i;i=i+16|0;c=a;a:do{switch(c>>8|0){case 0:{if((d[18972+c|0]|0|0)!=0){e=7;break a}f=-1;break};case 255:{if(!((c|0)==65534|(c|0)==65535)){e=7;break a}f=-1;break};case 223:case 222:case 221:case 220:case 219:case 218:case 217:case 216:{f=-1;break};default:{e=7}}}while(0);if((e|0)==7){f=c}i=b;return f|0}function jk(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=ne[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[13064+(((d[14344+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function kk(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=ne[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[13064+(((d[12808+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function lk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=a;a=ne[c[e+368>>2]&63](c[e+372>>2]|0,b)|0;if((a&-65536|0)!=0){f=1;g=f&1;i=d;return g|0}f=(ik(a)|0)<0;g=f&1;i=d;return g|0}function mk(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+80|0;k=j+48|0;l=b;b=e;e=f;f=g;g=h;h=l;a:while(1){if((c[b>>2]|0)==(e|0)){m=9;break}n=h+888+(d[c[b>>2]|0]<<2)|0;o=n;n=o+1|0;p=a[o]|0;if((p|0)==0){p=fk(ne[c[h+368>>2]&63](c[h+372>>2]|0,c[b>>2]|0)|0,k)|0;if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}n=k;o=b;c[o>>2]=(c[o>>2]|0)+((d[l+76+(d[c[b>>2]|0]|0)|0]|0)-3)}else{if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}o=b;c[o>>2]=(c[o>>2]|0)+1}while(1){o=n;n=o+1|0;q=a[o]|0;o=f;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;q=p+ -1|0;p=q;if((q|0)==0){continue a}}}if((m|0)==9){i=j;return}}function nk(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+56|0;k=a;a=e;e=f;f=g;g=h;h=k;while(1){if((c[a>>2]|0)==(e|0)){l=8;break}if((c[f>>2]|0)==(g|0)){l=8;break}m=b[h+376+((d[c[a>>2]|0]|0)<<1)>>1]|0;if((m&65535|0)==0){m=(ne[c[h+368>>2]&63](c[h+372>>2]|0,c[a>>2]|0)|0)&65535;n=a;c[n>>2]=(c[n>>2]|0)+((d[k+76+(d[c[a>>2]|0]|0)|0]|0)-3)}else{n=a;c[n>>2]=(c[n>>2]|0)+1}n=f;o=c[n>>2]|0;c[n>>2]=o+2;b[o>>1]=m}if((l|0)==8){i=j;return}}function ok(){i=i;return 18528}function pk(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=qk(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=47;c[g+4>>2]=48;c[g+52>>2]=21;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function qk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+24|0;d=a;if((d|0)==0){e=6;f=e;i=b;return f|0}a=0;while(1){if((a|0)>=6){g=8;break}h=a;if((Ek(d,c[18432+(a<<2)>>2]|0)|0)!=0){g=6;break}a=h+1|0}if((g|0)==6){e=h;f=e;i=b;return f|0}else if((g|0)==8){e=-1;f=e;i=b;return f|0}return 0}function rk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=Cm(16872,a,0,b,c,d)|0;i=e;return f|0}function sk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=Cm(16872,a,1,b,c,d)|0;i=e;return f|0}function tk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;i=i+32|0;$l(17640,b,c,d);i=a;return}function uk(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=vk(34,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function vk(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+128|0;o=n+32|0;p=n+96|0;q=n+104|0;r=n+112|0;s=a;a=b;b=d;c[o>>2]=e;e=f;f=g;g=h;h=j;j=k;k=l;l=m;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[o>>2]=(c[o>>2]|0)+((c[b+68>>2]|0)*5|0);e=e+(0-(c[b+68>>2]<<1))|0;m=(Dm(b,c[o>>2]|0,e,q,r,p,o)|0)!=0;if(!(m&(c[q>>2]|0)!=0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}do{if((xe[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,18376)|0)!=0){if((g|0)!=0){c[g>>2]=c[p>>2]}if((h|0)!=0){c[h>>2]=c[o>>2]}if((Dm(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}if((a|0)!=0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}else{if((a|0)!=0){break}c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}}while(0);do{if((xe[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,18384)|0)!=0){h=Em(b,c[p>>2]|0,e)|0;do{if(!(97<=(h|0)&(h|0)<=122)){if(65<=(h|0)&(h|0)<=90){break}c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}while(0);if((j|0)!=0){c[j>>2]=c[p>>2]}if((k|0)!=0){c[k>>2]=be[s&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0)|0}if((Dm(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}t=1;u=t;i=n;return u|0}}while(0);do{if((xe[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,18400)|0)!=0){if((a|0)!=0){break}do{if((xe[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,18416)|0)!=0){if((l|0)==0){break}c[l>>2]=1}else{if((xe[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,18424)|0)!=0){if((l|0)==0){break}c[l>>2]=0;break}else{c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}}while(0);while(1){if((Fm(Em(b,c[o>>2]|0,e)|0)|0)==0){break}c[o>>2]=(c[o>>2]|0)+(c[b+68>>2]|0)}if((c[o>>2]|0)!=(e|0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}}while(0);c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}function wk(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;Vd[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((Ek(h,14600)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=qk(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[16872+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function xk(){i=i;return 16504}function yk(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=qk(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=49;c[g+4>>2]=50;c[g+52>>2]=21;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function zk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=Cm(14608,a,0,b,c,d)|0;i=e;return f|0}function Ak(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=Cm(14608,a,1,b,c,d)|0;i=e;return f|0}function Bk(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=vk(35,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function Ck(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;Vd[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((Ek(h,14600)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=qk(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[14608+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function Dk(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+40|0;g=hk(b,c,d,e)|0;if((g|0)==0){h=g;i=f;return h|0}a[g+134|0]=23;h=g;i=f;return h|0}function Ek(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+40|0;e=b;b=c;while(1){c=e;e=c+1|0;f=a[c]|0;c=b;b=c+1|0;g=a[c]|0;do{if(97<=(f<<24>>24|0)){if((f<<24>>24|0)>122){break}f=(f<<24>>24)+ -32&255}}while(0);do{if(97<=(g<<24>>24|0)){if((g<<24>>24|0)>122){break}g=(g<<24>>24)+ -32&255}}while(0);if((f<<24>>24|0)!=(g<<24>>24|0)){h=9;break}if(!(f<<24>>24!=0)){h=11;break}}if((h|0)==9){j=0;k=j;i=d;return k|0}else if((h|0)==11){j=1;k=j;i=d;return k|0}return 0}function Fk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Wk(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 29:{g=b;if((c[13064+((d[12808+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){b=g+2|0;n=18;o=77;break a}if((c[13064+((d[14344+(d[g+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=76;break a}b=b+2|0;n=19;o=77;break};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+3|0]|0)!=0){break}if((a[b+2|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[g]|0)|0]|0}else{p=Wk(a[g+1|0]|0,a[b]|0)|0}switch(p|0){case 16:{k=hl(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 15:{k=cl(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 30:{k=Yk(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 12:{k=gl(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{n=18;b=b+2|0;o=77;break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 10:case 21:{o=25;break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[g]|0)|0]|0}else{q=Wk(a[g+1|0]|0,a[b]|0)|0}switch(q|0){case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{n=19;b=b+2|0;o=77;break};case 9:{if((b+2|0)!=(e|0)){o=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 13:{k=gl(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 19:{k=il(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{o=76}}}while(0);if((o|0)==25){while(1){o=0;b=b+2|0;r=b;if((b|0)==(e|0)){o=32;break}q=b;if((a[r+1|0]|0)==0){s=d[j+76+(d[q]|0)|0]|0}else{s=Wk(a[q+1|0]|0,a[b]|0)|0}if((s|0)==10|(s|0)==21){o=25;continue}else if((s|0)!=9){o=31;break}if((b+2|0)!=(e|0)){o=25}else{o=31;break}}if((o|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((o|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((o|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==77){b:while(1){o=0;if((b|0)==(e|0)){o=126;break}r=b;if((a[b+1|0]|0)==0){t=d[j+76+(d[r]|0)|0]|0}else{t=Wk(a[r+1|0]|0,a[b]|0)|0}switch(t|0){case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{o=94;break b;break};case 6:{o=88;break b;break};case 15:{o=122;break b;break};case 5:{o=85;break b;break};case 7:{o=91;break b;break};case 34:{o=116;break b;break};case 33:{o=119;break b;break};case 23:{b=b+2|0;r=n;if((r|0)==41){n=19;o=77;continue b}else if((r|0)!=18){o=77;continue b}if((b|0)==(e|0)){o=97;break b}n=41;r=b;if((a[b+1|0]|0)==0){u=d[j+76+(d[r]|0)|0]|0}else{u=Wk(a[r+1|0]|0,a[b]|0)|0}switch(u|0){case 27:case 26:case 25:case 24:case 22:{break};case 5:{o=105;break b;break};case 6:{o=108;break b;break};case 7:{o=111;break b;break};case 29:{if((c[13064+((d[14344+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=103;break b}break};default:{n=19;o=77;continue b}}b=b+2|0;o=77;continue b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[13064+((d[14344+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=83;break b}break};default:{o=125;break b}}b=b+2|0;o=77}if((o|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==94){c[f>>2]=b;k=n;l=k;i=h;return l|0}else if((o|0)==97){k=-1;l=k;i=h;return l|0}else if((o|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==116){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((o|0)==119){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((o|0)==122){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((o|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==126){k=0-n|0;l=k;i=h;return l|0}}return 0}function Gk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Wk(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 2:{k=$k(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 3:{k=Xk(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Wk(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=Wk(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 7:{r=b;if((e-b|0)<4){p=55;break b}b=r+4|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 6:{s=b;if((e-b|0)<3){p=52;break b}b=s+3|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=49;break b}b=t+2|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+3|0]|0)==0){if((a[b+2|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+5|0]|0)==0){if((a[b+4|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Hk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Wk(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Wk(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=Wk(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 6:{r=b;if((e-b|0)<3){p=50;break b}b=r+3|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=53;break b}b=s+4|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=47;break b}b=t+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Ik(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[k]|0)|0]|0}else{m=Wk(a[k+1|0]|0,a[b]|0)|0}switch(m|0){case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function Jk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Wk(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 21:{n=29;break a;break};case 2:{n=15;break a;break};case 10:{n=16;break a;break};case 7:{b=b+4|0;continue a;break};case 3:{n=12;break a;break};case 9:{n=19;break a;break};case 6:{b=b+3|0;continue a;break};case 5:{b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Xk(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=Wk(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Kk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Wk(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 5:{b=b+2|0;continue a;break};case 30:{n=15;break a;break};case 7:{b=b+4|0;continue a;break};case 3:{n=12;break a;break};case 6:{b=b+3|0;continue a;break};case 10:{n=18;break a;break};case 9:{n=21;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Xk(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=Yk(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=Wk(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Lk(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b+1|0]|0)==0){h=d[g+76+(d[e]|0)|0]|0}else{h=Wk(a[e+1|0]|0,a[b]|0)|0}switch(h|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=15;break a}j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=17;break a}else{continue a}break};case 5:{break};case 6:{k=8;break};case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c+1|0]|0)==0){n=d[g+76+(d[k]|0)|0]|0}else{n=Wk(a[k+1|0]|0,a[c]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function Mk(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f+1|0]|0)!=0){h=7;break}if((a[f]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function Nk(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b+1|0]|0)==0){h=d[f+76+(d[g]|0)|0]|0}else{h=Wk(a[g+1|0]|0,a[b]|0)|0}switch(h|0){case 7:{b=b+4|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function Ok(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b+1|0]|0)==0){g=d[f+76+(d[c]|0)|0]|0}else{g=Wk(a[c+1|0]|0,a[b]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function Pk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[m]|0)|0]|0}else{n=Wk(a[m+1|0]|0,a[b]|0)|0}b:do{switch(n|0){case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b+1|0]|0)==0){o=a[b]|0}else{o=-1}if((o|0)!=32){break}if((a[b+3|0]|0)==0){p=a[b+2|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+3|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=Wk(a[m+1|0]|0,a[b+2|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 17:case 11:{if((g|0)!=2){break a}break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function Qk(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d+1|0]|0)==0){if((a[d]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d+1|0]|0)==0){f=(a[d]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d+1|0]|0)==0){g=a[d]|0}else{g=-1}h=g;switch(h|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d+1|0]|0)==0){l=(a[d]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d+1|0]|0)==0){m=a[d]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=ik(c)|0;k=j;i=b;return k|0}function Rk(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==3){if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=97){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=109){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}else if((c|0)==4){if((a[e+1|0]|0)==0){h=a[e]|0}else{h=-1}if((h|0)==113){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=117){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else if((h|0)==97){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else{break}}else if((c|0)==2){if((a[e+3|0]|0)!=0){break}if((a[e+2|0]|0)!=116){break}if((a[e+1|0]|0)==0){j=a[e]|0}else{j=-1}if((j|0)==103){f=62;g=f;i=b;return g|0}else if((j|0)==108){f=60;g=f;i=b;return g|0}else{break}}}while(0);f=0;g=f;i=b;return g|0}function Sk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=Wk(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 6:{b=b+3|0;break};case 7:{b=b+4|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 5:{b=b+2|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=Wk(a[g+1|0]|0,a[b]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function Tk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=Wk(a[g+1|0]|0,a[b]|0)|0}b:do{switch(l|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 22:case 26:{if((a[b+1|0]|0)==0){m=a[b]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 21:{if((a[b+1|0]|0)!=0){break b}if((a[b]|0)==9){k=9;break a}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b+1|0]|0)==0){n=a[b]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function Uk(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j]|0;m=a[g+1|0]|0;b:do{switch(m&255|0){case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g]|0;n=((l&3)<<4|(a[g+1|0]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function Vk(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2+1|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[(c[k>>2]|0)+1|0]|0)<<8|(d[c[k>>2]|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function Wk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+24|0;a:do{switch(a&255|0){case 255:{if(!(((b&255)+ -254|0)>>>0<2)){d=6;break a}e=0;break};case 223:case 222:case 221:case 220:{e=8;break};case 219:case 218:case 217:case 216:{e=7;break};default:{d=6}}}while(0);if((d|0)==6){e=29}i=c;return e|0}function Xk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Wk(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[13064+((d[12808+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=Zk(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Wk(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 29:{if((c[13064+((d[14344+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 7:{n=35;break b;break};case 6:{n=32;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=29;break b;break};case 18:{n=38;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Yk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Wk(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[13064+((d[12808+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Wk(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 29:{if((c[13064+((d[14344+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 5:{n=29;break b;break};case 7:{n=35;break b;break};case 18:{n=38;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=32;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Zk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=120){break}k=_k(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Wk(a[g+1|0]|0,a[b]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Wk(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function _k(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=Wk(a[g+1|0]|0,a[b]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Wk(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function $k(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Wk(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=dl(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 15:{k=cl(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Wk(a[g+1|0]|0,a[b]|0)|0}if((n|0)==20){k=bl(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==27){k=al(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[13064+((d[12808+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[m]|0)|0]|0}else{p=Wk(a[m+1|0]|0,a[b]|0)|0}switch(p|0){case 29:{if((c[13064+((d[14344+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=37;break b}break};case 17:{break b;break};case 5:{o=39;break b;break};case 11:{o=90;break b;break};case 6:{o=42;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=Wk(a[m+1|0]|0,a[b]|0)|0}switch(q|0){case 24:case 22:{break};case 6:{o=62;break b;break};case 29:{if((c[13064+((d[12808+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=57;break b}break};case 5:{o=59;break b;break};case 7:{o=65;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{break};case 10:case 9:case 21:{o=69;break b;break};case 7:{o=45;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b+1|0]|0)==0){r=d[j+76+(d[q]|0)|0]|0}else{r=Wk(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 10:case 9:case 21:{break};case 17:{break c;break};case 6:{o=81;break d;break};case 7:{o=84;break d;break};case 11:{o=90;break c;break};case 29:{o=75;break d;break};case 5:{o=78;break d;break};case 24:case 22:{break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[13064+((d[12808+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=el(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function al(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=Wk(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b+1|0]|0)!=0){continue b}if((a[b]|0)==45){l=25;break b}else{continue b}break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function bl(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k+1|0]|0)!=0){l=7;break}if((a[g]|0)!=(a[15008+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function cl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b+1|0]|0)==0){o=d[k+76+(d[n]|0)|0]|0}else{o=Wk(a[n+1|0]|0,a[b]|0)|0}a:do{switch(o|0){case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 24:case 22:{break};case 29:{if((c[13064+((d[12808+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=Wk(a[o+1|0]|0,a[b]|0)|0}switch(q|0){case 29:{if((c[13064+((d[14344+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=26;break b}break};case 10:case 9:case 21:{p=37;break b;break};case 7:{p=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{p=31;break b;break};case 15:{p=62;break b;break};case 5:{p=28;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((fl(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b+1|0]|0)==0){r=d[k+76+(d[q]|0)|0]|0}else{r=Wk(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 8:case 1:case 0:{p=54;break c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b+1|0]|0)!=0){continue c}if((a[b]|0)==62){p=59;break c}else{continue c}break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((fl(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b+1|0]|0)!=0){break}if((a[b]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function dl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Wk(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[13064+((d[12808+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Wk(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 29:{if((c[13064+((d[14344+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 23:{b=b+2|0;continue b;break};case 10:case 9:case 21:{n=37;break b;break};case 5:{n=28;break b;break};case 7:{n=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=31;break b;break};case 11:{n=48;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Wk(a[o+1|0]|0,a[b]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function el(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){m=d[k+76+(d[b]|0)|0]|0}else{m=Wk(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b:do{switch(m|0){case 29:{if((c[13064+((d[14344+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 6:{l=13;break a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){n=d[k+76+(d[b]|0)|0]|0}else{n=Wk(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b=n;if((b|0)==14){break b}o=b;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=47;break a}}break};case 14:{break};case 5:{l=10;break a;break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 7:{l=16;break a;break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){p=d[k+76+(d[o]|0)|0]|0}else{p=Wk(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(p|0){case 7:{l=36;break a;break};case 24:case 22:{break};case 29:{if((c[13064+((d[12808+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=28;break a}break};case 6:{l=33;break a;break};case 5:{l=30;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=Wk(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}o=r;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){s=d[k+76+(d[o]|0)|0]|0}else{s=Wk(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}o=s;if((o|0)==(r|0)){break}switch(o|0){case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 2:{l=79;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 8:case 1:case 0:{l=74;break a;break};case 3:{t=Xk(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){u=d[k+76+(d[o]|0)|0]|0}else{u=Wk(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(u|0){case 11:{l=106;break a;break};case 17:{l=107;break a;break};case 10:case 9:case 21:{break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){v=d[k+76+(d[o]|0)|0]|0}else{v=Wk(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(v|0){case 29:{l=94;break d;break};case 6:{l=100;break a;break};case 5:{l=97;break a;break};case 7:{l=103;break a;break};case 11:{l=106;break a;break};case 17:{l=107;break a;break};case 24:case 22:{break d;break};case 10:case 9:case 21:{break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[13064+((d[12808+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[(c[j>>2]|0)+1|0]|0)==0){if((a[c[j>>2]|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function fl(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g+1|0]|0)==0){k=a[g]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){l=a[g]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){m=a[g]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function gl(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e+1|0]|0)==0){m=d[b+76+(d[h]|0)|0]|0}else{m=Wk(a[h+1|0]|0,a[e]|0)|0}h=m;switch(h|0){case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e+1|0]|0)==0){p=d[b+76+(d[g]|0)|0]|0}else{p=Wk(a[g+1|0]|0,a[e]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function hl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Wk(a[g+1|0]|0,a[b]|0)|0}if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=Wk(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 24:case 22:{break};case 10:case 9:case 21:{break a;break};case 30:{n=16;break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+3|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Wk(a[o+1|0]|0,a[b+2|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==27){k=al(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function il(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Wk(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[13064+((d[12808+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Wk(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 7:{n=34;break b;break};case 5:{n=28;break b;break};case 29:{if((c[13064+((d[14344+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 6:{n=31;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function jl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Wk(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 13:{k=Ll(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{n=18;b=b+2|0;o=77;break};case 23:case 27:case 26:case 25:{n=19;b=b+2|0;o=77;break};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){p=d[j+76+(d[g+1|0]|0)|0]|0}else{p=Wk(a[g]|0,a[b+1|0]|0)|0}switch(p|0){case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 10:case 21:{o=25;break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 12:{k=Ll(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){q=d[j+76+(d[g+1|0]|0)|0]|0}else{q=Wk(a[g]|0,a[b+1|0]|0)|0}switch(q|0){case 15:{k=Hl(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 16:{k=Ml(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+2|0]|0)!=0){break}if((a[b+3|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 19:{k=Nl(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 9:{if((b+2|0)!=(e|0)){o=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{g=b;if((c[13064+((d[12808+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){b=g+2|0;n=18;o=77;break a}if((c[13064+((d[14344+(d[g]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=76;break a}b=b+2|0;n=19;o=77;break};case 30:{k=Bl(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};default:{o=76}}}while(0);if((o|0)==25){while(1){o=0;b=b+2|0;r=b;if((b|0)==(e|0)){o=32;break}q=b;if((a[r]|0)==0){s=d[j+76+(d[q+1|0]|0)|0]|0}else{s=Wk(a[q]|0,a[b+1|0]|0)|0}if((s|0)==10|(s|0)==21){o=25;continue}else if((s|0)!=9){o=31;break}if((b+2|0)!=(e|0)){o=25}else{o=31;break}}if((o|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((o|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((o|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==77){b:while(1){o=0;if((b|0)==(e|0)){o=126;break}r=b;if((a[b]|0)==0){t=d[j+76+(d[r+1|0]|0)|0]|0}else{t=Wk(a[r]|0,a[b+1|0]|0)|0}switch(t|0){case 23:{b=b+2|0;r=n;if((r|0)==41){n=19;o=77;continue b}else if((r|0)!=18){o=77;continue b}if((b|0)==(e|0)){o=97;break b}n=41;r=b;if((a[b]|0)==0){u=d[j+76+(d[r+1|0]|0)|0]|0}else{u=Wk(a[r]|0,a[b+1|0]|0)|0}switch(u|0){case 7:{o=111;break b;break};case 5:{o=105;break b;break};case 6:{o=108;break b;break};case 29:{if((c[13064+((d[14344+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=103;break b}break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=19;o=77;continue b}}b=b+2|0;o=77;continue b;break};case 29:{if((c[13064+((d[14344+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=83;break b}break};case 6:{o=88;break b;break};case 7:{o=91;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{o=94;break b;break};case 15:{o=122;break b;break};case 5:{o=85;break b;break};case 34:{o=116;break b;break};case 33:{o=119;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{o=125;break b}}b=b+2|0;o=77}if((o|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==94){c[f>>2]=b;k=n;l=k;i=h;return l|0}else if((o|0)==97){k=-1;l=k;i=h;return l|0}else if((o|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==116){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((o|0)==119){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((o|0)==122){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((o|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==126){k=0-n|0;l=k;i=h;return l|0}}return 0}function kl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Wk(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 3:{k=Al(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 2:{k=El(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Wk(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=Wk(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 5:{r=b;if((e-b|0)<2){p=49;break b}b=r+2|0;continue b;break};case 6:{s=b;if((e-b|0)<3){p=52;break b}b=s+3|0;continue b;break};case 7:{t=b;if((e-b|0)<4){p=55;break b}b=t+4|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+2|0]|0)==0){if((a[b+3|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+4|0]|0)==0){if((a[b+5|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function ll(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Wk(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Wk(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=Wk(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 5:{r=b;if((e-b|0)<2){p=47;break b}b=r+2|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=53;break b}b=s+4|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=50;break b}b=t+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function ml(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b]|0)==0){m=d[j+76+(d[k+1|0]|0)|0]|0}else{m=Wk(a[k]|0,a[b+1|0]|0)|0}switch(m|0){case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function nl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Wk(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 2:{n=15;break a;break};case 7:{b=b+4|0;continue a;break};case 9:{n=19;break a;break};case 5:{b=b+2|0;continue a;break};case 21:{n=29;break a;break};case 6:{b=b+3|0;continue a;break};case 10:{n=16;break a;break};case 3:{n=12;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Al(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=Wk(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function ol(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Wk(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 30:{n=15;break a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 9:{n=21;break a;break};case 6:{b=b+3|0;continue a;break};case 3:{n=12;break a;break};case 10:{n=18;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Al(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=Bl(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=Wk(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function pl(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b]|0)==0){h=d[g+76+(d[e+1|0]|0)|0]|0}else{h=Wk(a[e]|0,a[b+1|0]|0)|0}switch(h|0){case 6:{j=8;break};case 7:{e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=7;break a}else{j=8}break};case 5:{break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{k=c;c=k+1|0;e=b;b=e+1|0;if((a[k]|0)!=(a[e]|0)){j=15;break a}e=c;c=e+1|0;k=b;b=k+1|0;if((a[e]|0)!=(a[k]|0)){j=17;break a}else{continue a}break};default:{j=18;break a}}if((j|0)==8){j=0;k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=9;break}}e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=11;break}k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=13;break}}if((j|0)==7){l=0;m=l;i=f;return m|0}else if((j|0)==9){l=0;m=l;i=f;return m|0}else if((j|0)==11){l=0;m=l;i=f;return m|0}else if((j|0)==13){l=0;m=l;i=f;return m|0}else if((j|0)==15){l=0;m=l;i=f;return m|0}else if((j|0)==17){l=0;m=l;i=f;return m|0}else if((j|0)==18){j=c;if((a[c]|0)==0){n=d[g+76+(d[j+1|0]|0)|0]|0}else{n=Wk(a[j]|0,a[c+1|0]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function ql(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f]|0)!=0){h=7;break}if((a[f+1|0]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function rl(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b]|0)==0){h=d[f+76+(d[g+1|0]|0)|0]|0}else{h=Wk(a[g]|0,a[b+1|0]|0)|0}switch(h|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 7:{b=b+4|0;continue a;break};default:{break a}}}i=e;return b-c|0}function sl(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b]|0)==0){g=d[f+76+(d[c+1|0]|0)|0]|0}else{g=Wk(a[c]|0,a[b+1|0]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function tl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b]|0)==0){n=d[j+76+(d[m+1|0]|0)|0]|0}else{n=Wk(a[m]|0,a[b+1|0]|0)|0}b:do{switch(n|0){case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)==0){o=a[b+1|0]|0}else{o=-1}if((o|0)!=32){break}if((a[b+2|0]|0)==0){p=a[b+3|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+2|0]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=Wk(a[m]|0,a[b+3|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function ul(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d]|0)==0){if((a[d+1|0]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d]|0)==0){f=(a[d+1|0]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d]|0)==0){g=a[d+1|0]|0}else{g=-1}h=g;switch(h|0){case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d]|0)==0){l=(a[d+1|0]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d]|0)==0){m=a[d+1|0]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=ik(c)|0;k=j;i=b;return k|0}function vl(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==2){if((a[e+2|0]|0)!=0){break}if((a[e+3|0]|0)!=116){break}if((a[e]|0)==0){f=a[e+1|0]|0}else{f=-1}if((f|0)==108){g=60;h=g;i=b;return h|0}else if((f|0)==103){g=62;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=97){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=109){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}g=38;h=g;i=b;return h|0}else if((c|0)==4){if((a[e]|0)==0){j=a[e+1|0]|0}else{j=-1}if((j|0)==97){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=115){break}g=39;h=g;i=b;return h|0}else if((j|0)==113){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=117){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=116){break}g=34;h=g;i=b;return h|0}else{break}}}while(0);g=0;h=g;i=b;return h|0}function wl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=Wk(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=Wk(a[g]|0,a[b+1|0]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 7:{b=b+4|0;break};case 5:{b=b+2|0;break};case 6:{b=b+3|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function xl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=Wk(a[g]|0,a[b+1|0]|0)|0}b:do{switch(l|0){case 22:case 26:{if((a[b]|0)==0){m=a[b+1|0]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 21:{if((a[b]|0)!=0){break b}if((a[b+1|0]|0)==9){k=9;break a}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b]|0)==0){n=a[b+1|0]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function yl(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j+1|0]|0;m=a[g]|0;b:do{switch(m&255|0){case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g+1|0]|0;n=((l&3)<<4|(a[g]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function zl(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[c[k>>2]|0]|0)<<8|(d[(c[k>>2]|0)+1|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function Al(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Wk(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 19:{k=Cl(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{if((c[13064+((d[12808+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Wk(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 18:{n=38;break b;break};case 7:{n=35;break b;break};case 5:{n=29;break b;break};case 29:{if((c[13064+((d[14344+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=32;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Bl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Wk(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 29:{if((c[13064+((d[12808+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Wk(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 7:{n=35;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=29;break b;break};case 6:{n=32;break b;break};case 29:{if((c[13064+((d[14344+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 18:{n=38;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Cl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=120){break}k=Dl(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Wk(a[g]|0,a[b+1|0]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Wk(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function Dl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=Wk(a[g]|0,a[b+1|0]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Wk(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}



function $r(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+4096|0;jq(b,+h[b+240>>3]);yq(b);Dq(b);Nr(b,0,1)|0;v=b+540|0;w=c[v>>2]|0;if((c[w+76>>2]|0)!=0&(d|0)>1){x=u;u=b+8|0;y=b+116|0;z=cS(c[y>>2]|0,8)|0;A=b+124|0;B=cS(c[A>>2]|0,4)|0;C=b+128|0;D=cS(c[C>>2]|0,1)|0;E=b+132|0;F=cS(c[E>>2]|0,4)|0;G=b+536|0;Un(c[G>>2]|0,(z|0)!=0|0,59392,t);Un(c[G>>2]|0,(B|0)!=0|0,59392,s);Un(c[G>>2]|0,(D|0)!=0|0,59392,r);Un(c[G>>2]|0,(F|0)!=0|0,59392,q);q=c[y>>2]|0;if((q|0)>0){G=c[u>>2]|0;r=0;do{h[z+(r<<3)>>3]=+h[G+(r*112|0)+96>>3];r=r+1|0;}while((r|0)<(q|0))}q=c[A>>2]|0;if((q|0)>0){r=c[b+12>>2]|0;G=0;do{c[B+(G<<2)>>2]=c[r+(G*60|0)+52>>2];G=G+1|0;}while((G|0)<(q|0))}q=c[C>>2]|0;if((q|0)>0){G=c[b+16>>2]|0;r=0;do{a[D+r|0]=a[G+(r*48|0)+42|0]|0;r=r+1|0;}while((r|0)<(q|0))}q=c[E>>2]|0;if((q|0)>0){r=c[b+20>>2]|0;G=0;do{c[F+(G<<2)>>2]=c[r+(G*52|0)+44>>2];G=G+1|0;}while((G|0)<(q|0))}if((c[21268>>2]|0)==0){H=0}else{c[p>>2]=c[b+88>>2];gc(x|0,59408,p|0)|0;p=hc(x|0,59424)|0;c[o>>2]=59440;od(p|0,59432,o|0)|0;if((c[y>>2]|0)>0){o=u;x=0;do{c[n>>2]=c[(c[o>>2]|0)+(x*112|0)+4>>2];od(p|0,59432,n|0)|0;x=x+1|0;}while((x|0)<(c[y>>2]|0))}Jd(10,p|0)|0;H=p}Rn(9,1,59448,m);a:do{if((d|0)>0){I=+(d+ -1|0);m=b+304|0;p=b+4|0;x=0;do{J=+(x|0)/I;h[m>>3]=J>1.0?1.0:J;$d[c[(c[v>>2]|0)+80>>2]&127](b)|0;n=l;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Rn(9,0,59472,l);if((c[21268>>2]|0)!=0){n=j;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];od(H|0,59496,j|0)|0;if((c[y>>2]|0)>0){n=0;do{o=g;h[k>>3]=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+(n<<3)>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];od(H|0,59496,g|0)|0;n=n+1|0;}while((n|0)<(c[y>>2]|0))}Jd(10,H|0)|0}if((kr(b,0)|0)!=0){break a}if((cr(b,0)|0)!=0){break a}if((Uq(b,0)|0)!=0){break a}Gq(b);x=x+1|0;}while((x|0)<(d|0))}}while(0);Yd[c[5446]&255](9);if((c[21268>>2]|0)!=0){Vc(H|0)|0}H=c[y>>2]|0;if((H|0)>0){y=c[u>>2]|0;u=0;do{h[y+(u*112|0)+96>>3]=+h[z+(u<<3)>>3];u=u+1|0;}while((u|0)<(H|0))}if((c[A>>2]|0)>0){H=c[b+12>>2]|0;u=0;do{c[H+(u*60|0)+52>>2]=c[B+(u<<2)>>2];u=u+1|0;}while((u|0)<(c[A>>2]|0))}if((c[C>>2]|0)>0){A=b+16|0;u=0;do{a[(c[A>>2]|0)+(u*48|0)+42|0]=a[D+u|0]|0;u=u+1|0;}while((u|0)<(c[C>>2]|0))}C=c[E>>2]|0;if((C|0)>0){E=b+20|0;u=0;do{c[(c[E>>2]|0)+(u*52|0)+44>>2]=c[F+(u<<2)>>2];u=u+1|0;}while((u|0)<(C|0))}bS(z);bS(B);bS(D);bS(F)}else{h[b+304>>3]=1.0;$d[c[w+80>>2]&127](b)|0}vq(b);if((Nr(b,1,1)|0)!=1){i=e;return}$d[c[(c[v>>2]|0)+80>>2]&127](b)|0;vq(b);if((Nr(b,1,1)|0)!=1){i=e;return}Tn(1,0,59504,f);i=e;return}function as(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=ds(b)|0;w=v;x=c[w>>2]|0;if((x|0)==0){Rn(9,0,59608,u);if((c[b+184>>2]|0)==0){ne[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0}bS(v);y=0;i=f;return y|0}u=b+184|0;z=c[u>>2]|0;if((z|0)==0){Rn(9,0,59640,t);ne[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0;bS(v);y=0;i=f;return y|0}do{if((c[v+16>>2]|0)<(x|0)){Rn(9,1,59712,s);t=aS(c[w>>2]<<3)|0;A=v+40|0;B=c[A>>2]|0;c[A>>2]=0;C=+Vr(v,1.0);c[A>>2]=B;D=c[w>>2]|0;if((D|0)>0){E=v+24|0;F=c[E>>2]|0;G=0;while(1){H=F+(G<<3)|0;h[H>>3]=+h[H>>3]+1.0e-6;c[A>>2]=0;h[t+(G<<3)>>3]=+U(+(+Vr(v,1.0)-C))/1.0e-6;c[A>>2]=B;H=c[E>>2]|0;I=H+(G<<3)|0;h[I>>3]=+h[I>>3]+-1.0e-6;I=G+1|0;J=c[w>>2]|0;if((I|0)<(J|0)){G=I;F=H}else{K=J;break}}}else{K=D}F=c[u>>2]|0;if((F|0)>0){G=(K|0)>1;E=0;do{if(G){B=1;A=0;while(1){J=+h[t+(B<<3)>>3]>+h[t+(A<<3)>>3]?B:A;H=B+1|0;if((H|0)<(K|0)){A=J;B=H}else{L=J;break}}}else{L=0}h[t+(L<<3)>>3]=-1.0;E=E+1|0;}while((E|0)<(F|0))}Rn(9,1,59736,r);F=b+112|0;E=c[F>>2]|0;if((E|0)>0){G=b+8|0;D=v+44|0;B=v+24|0;A=E;E=0;J=0;while(1){H=(c[G>>2]|0)+(E*112|0)+72|0;if((a[H]|0)==0){if(!(+h[t+(J<<3)>>3]>=0.0)){M=A}else{a[H]=1;C=+h[(c[B>>2]|0)+(J<<3)>>3];c[q>>2]=c[(c[D>>2]|0)+(J<<2)>>2];H=q+4|0;h[k>>3]=C;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];Rn(9,0,59760,q);M=c[F>>2]|0}N=M;O=J+1|0}else{N=A;O=J}H=E+1|0;if((H|0)<(N|0)){A=N;E=H;J=O}else{P=O;break}}}else{P=0}J=b+136|0;if((c[J>>2]|0)>0){E=b+24|0;A=v+44|0;F=v+24|0;D=b+116|0;B=b+120|0;G=0;H=P;while(1){I=(c[E>>2]|0)+(G*112|0)+72|0;if((a[I]|0)==0){if(+h[t+(H<<3)>>3]>=0.0){a[I]=1;C=+h[(c[F>>2]|0)+(H<<3)>>3];c[p>>2]=c[(c[A>>2]|0)+(H<<2)>>2];I=p+4|0;h[k>>3]=C;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];Rn(9,0,59760,p)}Q=H+1|0}else{Q=H}I=c[B>>2]|0;R=(c[D>>2]|0)-I|0;if((R|0)<(I|0)){S=I;I=R;T=Q;while(1){V=(c[E>>2]|0)+(I*112|0)+72|0;if((a[V]|0)==0){if(!(+h[t+(T<<3)>>3]>=0.0)){W=S}else{a[V]=1;C=+h[(c[F>>2]|0)+(T<<3)>>3];c[o>>2]=c[(c[A>>2]|0)+(T<<2)>>2];V=o+4|0;h[k>>3]=C;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];Rn(9,0,59760,o);W=c[B>>2]|0}X=W;Y=T+1|0}else{X=S;Y=T}V=I+1|0;if((V|0)<(X|0)){S=X;I=V;T=Y}else{Z=V;_=Y;break}}}else{Z=R;_=Q}T=Z+1|0;if((T|0)<(c[J>>2]|0)){G=T;H=_}else{break}}}if((c[21268>>2]|0)!=0){Yd[c[5446]&255](9);Yd[c[5446]&255](9)}bS(t);es(v);H=ds(b)|0;if((c[H>>2]|0)!=0){$=H;break}Rn(9,0,59784,n);bS(H);y=0;i=f;return y|0}else{if((z|0)<=(x|0)){$=v;break}Rn(9,0,59816,m);$=v}}while(0);do{if((d|0)==3|(d|0)==5){Rn(9,0,59832,l);bs($,d,1,e);Wr(b,$);v=c[$>>2]|0;if((v|0)<=0){break}m=c[$+24>>2]|0;x=c[$+28>>2]|0;z=0;do{h[x+(z<<3)>>3]=+h[m+(z<<3)>>3];z=z+1|0;}while((z|0)<(v|0))}}while(0);if(+Vr($,1.0)>1.0e-9){l=$+40|0;v=c[l>>2]|0;if((v|0)!=0){bS(v);c[l>>2]=0}l=$+52|0;v=c[l>>2]|0;if((v|0)!=0){bS(v);c[l>>2]=0}l=$+56|0;v=c[l>>2]|0;if((v|0)!=0){bS(v);c[l>>2]=0}bs($,d,0,e);Wr(b,$);+Vr($,1.0)}else{Rn(9,0,59856,j)}Rn(9,1,59880,g);Wr(b,$);b=Ur($)|0;if((c[21268>>2]|0)!=0){Yd[c[5446]&255](9)}es($);y=b;i=f;return y|0}function bs(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=c[a+60>>2]|0;h[n>>3]=0.0;p=a;q=aS(c[p>>2]<<3)|0;r=q;s=+Vr(a,1.0);t=c[p>>2]|0;if((t|0)>0){u=c[a+28>>2]|0;v=c[a+24>>2]|0;w=0;do{x=+h[u+(w<<3)>>3];h[v+(w<<3)>>3]=x;h[q+(w<<3)>>3]=x;w=w+1|0;}while((w|0)<(t|0))}if(!(s>1.0e-12)){y=1;gs(a,r);bS(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=60008;F=E;Rn(9,0,F,g);i=f;return}t=(d|0)==0;d=a+24|0;x=s;w=1;a:while(1){c[m>>2]=w;Rn(9,0,59920,m);if(!t){fs(a)}switch(b|0){case 4:{G=12;break a;break};case 2:{H=ls(a)|0;break};case 5:{G=13;break a;break};case 3:{H=ps(a,n,e)|0;break};case 6:{G=14;break a;break};case 1:{H=ns(a)|0;break};default:{G=15;break a}}Dq(o);tq(o);zq(o);Dq(o);s=+Vr(a,1.0);v=(H|0)>-1;if(v&s<x){u=c[p>>2]|0;if((u|0)>0){I=c[d>>2]|0;J=0;do{h[q+(J<<3)>>3]=+h[I+(J<<3)>>3];J=J+1|0;}while((J|0)<(u|0))}Rn(9,0,59968,k);Wr(o,a);K=s}else{Rn(9,0,59984,j);if(v&s==x){y=w;G=23;break}else{K=x}}u=w+1|0;if((u|0)<201&s>1.0e-12){x=K;w=u}else{y=u;G=23;break}}if((G|0)==12){ks(a)|0}else if((G|0)==13){ks(a)|0}else if((G|0)==14){js(o,a,0)|0}else if((G|0)==15){Vn(c[o+536>>2]|0,59944,l)}else if((G|0)==23){gs(a,r);bS(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=60008;F=E;Rn(9,0,F,g);i=f;return}}function cs(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=i;d=ES(b|0)|0;do{if((d|0)==0){e=aS(1)|0;f=0}else{g=0;h=0;j=d;while(1){k=a[b+g|0]|0;if(k<<24>>24==93){l=h+ -1|0}else if(k<<24>>24==91){l=h+1|0}else{l=h}if((l|0)!=0&k<<24>>24==44){m=((a[b+(g+1)|0]|0)!=32)+j|0}else{m=j}k=g+1|0;if(k>>>0<d>>>0){g=k;h=l;j=m}else{break}}j=aS(m+1|0)|0;if((m|0)==0){e=j;f=0;break}else{n=0;o=0;p=l}while(1){h=a[b+o|0]|0;if(h<<24>>24==93){q=p+ -1|0}else if(h<<24>>24==91){q=p+1|0}else{q=p}a[j+n|0]=h;do{if((q|0)!=0&h<<24>>24==44){if((a[b+(o+1)|0]|0)==32){r=n;break}g=n+1|0;a[j+g|0]=32;r=g}else{r=n}}while(0);h=r+1|0;if(h>>>0<m>>>0){n=h;o=o+1|0;p=q}else{e=j;f=m;break}}}}while(0);a[e+f|0]=0;if((zS(e,61024,4)|0)!=0){i=c;return e|0}m=f>>>0>3;q=e+4|0;while(1){a:do{if(m){p=f;while(1){o=p+ -1|0;if((a[e+p|0]|0)==46){s=p;break a}if(o>>>0>3){p=o}else{s=o;break}}}else{s=f}}while(0);if((s|0)==3){t=24;break}p=s+ -3|0;GS(e|0,q|0,p|0)|0;o=e+p|0;a[o]=678585700;a[o+1|0]=2650725;a[o+2|0]=10354;a[o+3|0]=40;if((zS(e,61024,4)|0)!=0){t=24;break}}if((t|0)==24){i=c;return e|0}return 0}function ds(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+32|0;o=i;i=i+32|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=aS(64)|0;z=y;Un(0,(y|0)!=0|0,61032,x);x=y+4|0;A=y+8|0;B=y+12|0;C=y+16|0;D=y+20|0;E=y+24|0;F=y+28|0;G=y+32|0;H=y+36|0;I=y+40|0;J=y+44|0;K=y+48|0;L=y+52|0;M=y+56|0;N=y+60|0;O=y+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));c[N>>2]=b;N=b+8|0;O=b+112|0;P=c[O>>2]|0;if((P|0)>0){Q=c[N>>2]|0;R=0;S=0;while(1){if((a[Q+(S*112|0)+72|0]|0)==0){T=R+1|0;c[x>>2]=T;V=T}else{V=R}T=S+1|0;if((T|0)<(P|0)){R=V;S=T}else{W=V;break}}}else{W=0}V=b+136|0;S=c[V>>2]|0;if((S|0)>0){R=c[b+24>>2]|0;P=0;x=0;while(1){if((a[R+(x*112|0)+72|0]|0)==0){Q=P+1|0;c[A>>2]=Q;X=Q}else{X=P}Q=x+1|0;if((Q|0)<(S|0)){P=X;x=Q}else{Y=X;break}}}else{Y=0}X=b+116|0;x=b+120|0;P=c[x>>2]|0;if((P|0)>0){S=c[X>>2]|0;A=c[N>>2]|0;R=0;Q=S-P|0;while(1){if((a[A+(Q*112|0)+72|0]|0)==0){P=R+1|0;c[B>>2]=P;Z=P}else{Z=R}P=Q+1|0;if((P|0)<(S|0)){R=Z;Q=P}else{_=Z;break}}}else{_=0}Z=Y+W+_|0;c[y>>2]=Z;if((Z|0)==0){i=d;return z|0}y=cS(Z,8)|0;c[E>>2]=y;Un(0,(y|0)!=0|0,61032,w);w=cS(Z,8)|0;c[F>>2]=w;Un(0,(w|0)!=0|0,61032,v);v=cS(Z,8)|0;c[G>>2]=v;Un(0,(v|0)!=0|0,61032,u);u=cS(Z,8)|0;c[H>>2]=u;Un(0,(u|0)!=0|0,61032,t);t=cS(Z,8)|0;c[I>>2]=t;Un(0,(t|0)!=0|0,61032,s);s=cS(Z,4)|0;t=s;c[J>>2]=t;Un(0,(s|0)!=0|0,61032,r);Rn(9,0,61048,q);c[p>>2]=Z;c[p+4>>2]=W;c[p+8>>2]=Y;c[p+12>>2]=_;Rn(9,0,61072,p);p=c[O>>2]|0;if((p|0)>0){_=N;Y=p;p=t;W=0;Z=0;while(1){q=c[_>>2]|0;if((a[q+(W*112|0)+72|0]|0)==0){c[p+(Z<<2)>>2]=c[q+(W*112|0)+4>>2];q=c[_>>2]|0;do{if((a[q+(W*112|0)+73|0]|0)==0){$=(c[I>>2]|0)+(Z<<3)|0;aa=1.0}else{ba=+h[q+(W*112|0)+80>>3];ca=+U(+ba);r=(c[I>>2]|0)+(Z<<3)|0;if(!(ba==0.0)){$=r;aa=ca;break}$=r;aa=1.0}}while(0);h[$>>3]=aa;r=q+(W*112|0)+96|0;s=(c[E>>2]|0)+(Z<<3)|0;h[s>>3]=+h[r>>3];u=(c[F>>2]|0)+(Z<<3)|0;h[u>>3]=+h[r>>3];h[(c[G>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+56>>3];h[(c[H>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+64>>3];r=Z+1|0;v=c[J>>2]|0;w=c[v+(Z<<2)>>2]|0;ca=+h[u>>3];ba=+h[$>>3];da=+h[s>>3];c[o>>2]=r;c[o+4>>2]=w;w=o+8|0;h[k>>3]=ca;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+16|0;h[k>>3]=ba;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+24|0;h[k>>3]=da;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Rn(9,0,61160,o);ea=c[O>>2]|0;fa=v;ga=r}else{ea=Y;fa=p;ga=Z}r=W+1|0;if((r|0)<(ea|0)){Y=ea;p=fa;W=r;Z=ga}else{ha=fa;ia=ga;break}}}else{ha=t;ia=0}t=c[V>>2]|0;if((t|0)>0){ga=b+24|0;fa=t;t=ha;Z=0;W=ia;while(1){p=c[ga>>2]|0;if((a[p+(Z*112|0)+72|0]|0)==0){c[t+(W<<2)>>2]=c[p+(Z*112|0)+4>>2];p=c[ga>>2]|0;aa=+h[p+(Z*112|0)+80>>3];da=+U(+aa);ea=(c[I>>2]|0)+(W<<3)|0;h[ea>>3]=aa==0.0?1.0:da;Y=p+(Z*112|0)+96|0;O=(c[E>>2]|0)+(W<<3)|0;h[O>>3]=+h[Y>>3];o=(c[F>>2]|0)+(W<<3)|0;h[o>>3]=+h[Y>>3];h[(c[G>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+56>>3];h[(c[H>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+64>>3];p=W+1|0;Y=c[J>>2]|0;$=c[Y+(W<<2)>>2]|0;da=+h[o>>3];aa=+h[ea>>3];ba=+h[O>>3];c[n>>2]=p;c[n+4>>2]=$;$=n+8|0;h[k>>3]=da;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+16|0;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+24|0;h[k>>3]=ba;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];Rn(9,0,61208,n);ja=c[V>>2]|0;ka=Y;la=p}else{ja=fa;ka=t;la=W}p=Z+1|0;if((p|0)<(ja|0)){fa=ja;t=ka;Z=p;W=la}else{ma=ka;na=la;break}}}else{ma=ha;na=ia}ia=c[x>>2]|0;if((ia|0)>0){ha=c[X>>2]|0;la=N;ka=ha;W=ma;ma=ha-ia|0;ia=na;while(1){na=c[la>>2]|0;if((a[na+(ma*112|0)+72|0]|0)==0){c[W+(ia<<2)>>2]=c[na+(ma*112|0)+4>>2];na=c[la>>2]|0;do{if((a[na+(ma*112|0)+73|0]|0)==0){oa=(c[I>>2]|0)+(ia<<3)|0;pa=1.0}else{ba=+h[na+(ma*112|0)+80>>3];aa=+U(+ba);ha=(c[I>>2]|0)+(ia<<3)|0;if(!(ba==0.0)){oa=ha;pa=aa;break}oa=ha;pa=1.0}}while(0);h[oa>>3]=pa;q=na+(ma*112|0)+96|0;ha=(c[E>>2]|0)+(ia<<3)|0;h[ha>>3]=+h[q>>3];Z=(c[F>>2]|0)+(ia<<3)|0;h[Z>>3]=+h[q>>3];h[(c[G>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+56>>3];h[(c[H>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+64>>3];q=ia+1|0;t=c[J>>2]|0;ja=c[t+(ia<<2)>>2]|0;aa=+h[Z>>3];ba=+h[oa>>3];da=+h[ha>>3];c[m>>2]=q;c[m+4>>2]=ja;ja=m+8|0;h[k>>3]=aa;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+16|0;h[k>>3]=ba;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+24|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];Rn(9,0,61264,m);qa=c[X>>2]|0;ra=t;sa=q}else{qa=ka;ra=W;sa=ia}q=ma+1|0;if((q|0)<(qa|0)){ka=qa;W=ra;ma=q;ia=sa}else{break}}}sa=c[b+184>>2]|0;c[C>>2]=sa;c[D>>2]=0;C=c[X>>2]|0;if((C|0)>0){X=c[N>>2]|0;ia=0;ma=0;while(1){if((a[X+(ma*112|0)+88|0]|0)==0){ta=ia}else{ra=ia+1|0;c[D>>2]=ra;ta=ra}ra=ma+1|0;if((ra|0)<(C|0)){ia=ta;ma=ra}else{ua=ta;break}}}else{ua=0}ta=c[V>>2]|0;if((ta|0)>0){V=c[b+24>>2]|0;ma=ua;ia=0;while(1){do{if((a[V+(ia*112|0)+88|0]|0)==0){va=ma}else{if((a[V+(ia*112|0)+72|0]|0)!=0){va=ma;break}X=ma+1|0;c[D>>2]=X;va=X}}while(0);na=ia+1|0;if((na|0)<(ta|0)){ma=va;ia=na}else{wa=va;break}}}else{wa=ua}ua=c[x>>2]|0;if((ua|0)>0){x=c[N>>2]|0;N=wa;va=C-ua|0;while(1){do{if((a[x+(va*112|0)+88|0]|0)==0){xa=N}else{if((a[x+(va*112|0)+72|0]|0)!=0){xa=N;break}ua=N+1|0;c[D>>2]=ua;xa=ua}}while(0);ua=va+1|0;if((ua|0)<(C|0)){N=xa;va=ua}else{ya=xa;break}}}else{ya=wa}wa=c[b+176>>2]|0;xa=c[b+180>>2]|0;c[l>>2]=sa;c[l+4>>2]=wa;c[l+8>>2]=xa;Rn(9,0,61320,l);c[j>>2]=ya;Rn(9,0,61392,j);j=cS(sa,8)|0;c[K>>2]=j;Un(0,(j|0)!=0|0,61032,g);g=aS(sa<<3)|0;c[L>>2]=g;Un(0,(g|0)!=0|0,61032,f);f=aS(ya<<3)|0;c[M>>2]=f;Un(0,(f|0)!=0|0,61032,e);if((sa|0)>0){e=0;do{h[g+(e<<3)>>3]=1.0;e=e+1|0;}while((e|0)<(sa|0))}if((ya|0)>0){za=0}else{i=d;return z|0}do{h[f+(za<<3)>>3]=1.0;za=za+1|0;}while((za|0)<(ya|0));i=d;return z|0}function es(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;if((d|0)!=0){bS(d)}d=c[a+28>>2]|0;if((d|0)!=0){bS(d)}d=c[a+32>>2]|0;if((d|0)!=0){bS(d)}d=c[a+36>>2]|0;if((d|0)!=0){bS(d)}d=c[a+40>>2]|0;if((d|0)!=0){bS(d)}d=c[a+44>>2]|0;if((d|0)!=0){bS(d)}d=c[a+48>>2]|0;if((d|0)!=0){bS(d)}d=c[a+52>>2]|0;if((d|0)!=0){bS(d)}d=c[a+56>>2]|0;if((d|0)==0){e=a;bS(e);i=b;return}bS(d);e=a;bS(e);i=b;return}function fs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0,W=0;d=i;i=i+8|0;e=d;f=c[b+60>>2]|0;g=b+40|0;if((c[g>>2]|0)==0){i=d;return}j=b+52|0;k=c[j>>2]|0;if((k|0)==0){i=d;return}l=b+56|0;m=c[l>>2]|0;if((m|0)==0){i=d;return}n=b+16|0;o=c[n>>2]|0;p=cS(o,8)|0;q=cS(o,8)|0;r=b+20|0;s=c[r>>2]|0;t=cS(s,8)|0;u=cS(s,8)|0;v=cS(o,8)|0;w=cS(s,8)|0;if((o|0)>0){x=0;do{h[k+(x<<3)>>3]=1.0;x=x+1|0;}while((x|0)<(o|0))}if((s|0)>0){o=0;do{h[m+(o<<3)>>3]=1.0;o=o+1|0;}while((o|0)<(s|0))}+Vr(b,1.0);s=c[n>>2]|0;if((s|0)>0){GS(p|0,c[b+48>>2]|0,((s|0)>1?s<<3:8)|0)|0}o=f+8|0;m=f+116|0;x=c[m>>2]|0;if((x|0)>0){k=c[o>>2]|0;y=f+4|0;z=0;A=0;while(1){if((a[k+(z*112|0)+88|0]|0)==0){B=A}else{h[t+(A<<3)>>3]=+h[k+(z*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];B=A+1|0}C=z+1|0;if((C|0)<(x|0)){z=C;A=B}else{D=B;break}}}else{D=0}B=f+136|0;A=c[B>>2]|0;if((A|0)>0){z=c[f+24>>2]|0;y=f+4|0;k=0;C=D;while(1){do{if((a[z+(k*112|0)+88|0]|0)==0){E=C}else{if((a[z+(k*112|0)+72|0]|0)!=0){E=C;break}h[t+(C<<3)>>3]=+h[z+(k*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3];E=C+1|0}}while(0);F=k+1|0;if((F|0)<(A|0)){k=F;C=E}else{G=E;break}}}else{G=D}D=f+120|0;E=c[D>>2]|0;if((E|0)>0){C=c[o>>2]|0;k=f+4|0;A=x-E|0;E=G;while(1){do{if((a[C+(A*112|0)+88|0]|0)==0){H=E}else{if((a[C+(A*112|0)+72|0]|0)!=0){H=E;break}h[t+(E<<3)>>3]=+h[C+(A*112|0)+96>>3]- +h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];H=E+1|0}}while(0);G=A+1|0;if((G|0)<(x|0)){A=G;E=H}else{break}}}H=b;if((c[H>>2]|0)>0){E=b+24|0;A=o;o=f+4|0;x=f+24|0;f=b+48|0;k=c[E>>2]|0;C=0;while(1){G=k+(C<<3)|0;h[G>>3]=+h[G>>3]+1.0e-6;+Vr(b,1.0);G=c[n>>2]|0;y=(G|0)>0;if(y){GS(q|0,c[f>>2]|0,((G|0)>1?G<<3:8)|0)|0}z=c[m>>2]|0;if((z|0)>0){F=c[A>>2]|0;I=0;J=0;while(1){if((a[F+(J*112|0)+88|0]|0)==0){K=I}else{h[u+(I<<3)>>3]=+h[F+(J*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(J<<3)>>3];K=I+1|0}L=J+1|0;if((L|0)<(z|0)){I=K;J=L}else{M=K;break}}}else{M=0}J=c[B>>2]|0;if((J|0)>0){I=c[x>>2]|0;F=M;L=0;while(1){do{if((a[I+(L*112|0)+88|0]|0)==0){N=F}else{if((a[I+(L*112|0)+72|0]|0)!=0){N=F;break}h[u+(F<<3)>>3]=+h[I+(L*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(L<<3)>>3];N=F+1|0}}while(0);O=L+1|0;if((O|0)<(J|0)){F=N;L=O}else{P=N;break}}}else{P=M}L=c[D>>2]|0;if((L|0)>0){F=c[A>>2]|0;J=P;I=z-L|0;while(1){do{if((a[F+(I*112|0)+88|0]|0)==0){Q=J}else{if((a[F+(I*112|0)+72|0]|0)!=0){Q=J;break}h[u+(J<<3)>>3]=+h[F+(I*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(I<<3)>>3];Q=J+1|0}}while(0);L=I+1|0;if((L|0)<(z|0)){J=Q;I=L}else{break}}}if(y){R=+h[(c[g>>2]|0)+(C<<3)>>3];I=0;do{S=+U(+(R*(+h[q+(I<<3)>>3]- +h[p+(I<<3)>>3])/1.0e-6));J=v+(I<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}I=I+1|0;}while((I|0)<(G|0))}I=c[r>>2]|0;if((I|0)>0){R=+h[(c[g>>2]|0)+(C<<3)>>3];y=0;do{S=+U(+(R*(+h[u+(y<<3)>>3]- +h[t+(y<<3)>>3])/1.0e-6));J=w+(y<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}y=y+1|0;}while((y|0)<(I|0))}I=c[E>>2]|0;y=I+(C<<3)|0;h[y>>3]=+h[y>>3]+-1.0e-6;y=C+1|0;if((y|0)<(c[H>>2]|0)){k=I;C=y}else{T=G;break}}}else{T=s}if((T|0)>0){s=T;T=0;while(1){R=+h[v+(T<<3)>>3];C=(c[j>>2]|0)+(T<<3)|0;if(R<1.0e-42){h[C>>3]=1.0;k=T+1|0;c[e>>2]=k;Rn(9,0,61432,e);V=k;W=c[n>>2]|0}else{h[C>>3]=R;V=T+1|0;W=s}if((V|0)<(W|0)){s=W;T=V}else{break}}}V=c[r>>2]|0;if((V|0)>0){r=c[l>>2]|0;l=0;do{R=+h[w+(l<<3)>>3];h[r+(l<<3)>>3]=R<1.0e-42?1.0:R;l=l+1|0;}while((l|0)<(V|0))}bS(p);bS(q);bS(t);bS(u);bS(v);bS(w);i=d;return}function gs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+24>>2]|0;a=0;do{h[f+(a<<3)>>3]=+h[b+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=d;return}function hs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+40>>2]|0;g=(f|0)==0;j=c[a+24>>2]|0;a=0;do{k=+h[b+(a<<3)>>3];if(g){l=k}else{l=k*+h[f+(a<<3)>>3]}h[j+(a<<3)>>3]=l;a=a+1|0;}while((a|0)<(e|0));i=d;return}function is(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=c[b+60>>2]|0;f=c[e+112>>2]|0;if((f|0)>0){g=b+24|0;j=c[e+8>>2]|0;k=0;l=0;while(1){if((a[j+(k*112|0)+72|0]|0)==0){h[(c[(c[c[e+4>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3]=+h[(c[g>>2]|0)+(l<<3)>>3];m=l+1|0}else{m=l}n=k+1|0;if((n|0)<(f|0)){k=n;l=m}else{o=m;break}}}else{o=0}m=c[e+136>>2]|0;if((m|0)>0){l=b+24|0;k=c[e+24>>2]|0;f=0;g=o;while(1){if((a[k+(f*112|0)+72|0]|0)==0){h[(c[e+416>>2]|0)+(f<<3)>>3]=+h[(c[l>>2]|0)+(g<<3)>>3];p=g+1|0}else{p=g}j=f+1|0;if((j|0)<(m|0)){f=j;g=p}else{q=p;break}}}else{q=o}o=c[e+116>>2]|0;p=c[e+120>>2]|0;if((p|0)<=0){i=d;return}g=b+24|0;b=c[e+8>>2]|0;f=o-p|0;p=q;while(1){if((a[b+(f*112|0)+72|0]|0)==0){h[(c[e+400>>2]|0)+(f<<3)>>3]=+h[(c[g>>2]|0)+(p<<3)>>3];r=p+1|0}else{r=p}q=f+1|0;if((q|0)<(o|0)){f=q;p=r}else{break}}i=d;return}function js(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+8|0;Vn(c[a+536>>2]|0,61504,d);return 0}function ks(a){a=a|0;a=i;i=i+8|0;Vn(0,61536,a);return 0}function ls(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;c[d>>2]=(c[21268>>2]|0)!=0?1e3:0;k=a;l=c[k>>2]|0;c[e>>2]=l*1e3;h[f>>3]=1.0e-12;h[g>>3]=10.0;m=l<<1|1;c[j>>2]=m;n=cS((fa(m+13|0,m+l|0)|0)+((fa(l*3|0,l+3|0)|0)/2|0)|0,8)|0;Un(0,(n|0)!=0|0,61576,b);c[15398]=c[a+60>>2];c[15400]=c[a+48>>2];Lp(k,j,c[a+24>>2]|0,g,f,d,e,n,5)|0;bS(n);c[15398]=0;c[15400]=0;n=Ur(a)|0;i=b;return n|0}function ms(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[15400];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[15398];h[d>>3]=+Vr(f,1.0);i=e;return}function ns(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;h[o>>3]=0.0;h[p>>3]=0.0;h[q>>3]=0.0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;w=a;x=c[w>>2]<<3;y=aS(x)|0;z=y;A=aS(x)|0;x=A;Un(0,(y|0)!=0|0,61608,n);Un(0,(A|0)!=0|0,61608,m);m=c[w>>2]|0;if((m|0)>0){n=c[a+24>>2]|0;B=0;do{C=+h[n+(B<<3)>>3];if(C!=0.0){D=+U(+C)/1.0e3}else{D=1.0}h[y+(B<<3)>>3]=D;h[A+(B<<3)>>3]=0.0;B=B+1|0;}while((B|0)<(m|0))}B=m*1e3|0;c[v>>2]=B;if((c[21268>>2]|0)==0){E=-1}else{E=(B|0)/10|0}c[r>>2]=E;h[p>>3]=1.0e-12;c[s>>2]=m;c[t>>2]=0;h[q>>3]=1.0e-12;D=+Vr(a,1.0);h[o>>3]=D;if(D!=0.0){c[15406]=c[a+60>>2];c[15408]=c[a+48>>2];Ip(c[a+24>>2]|0,z,w,o,v,r,p,s,t,q,x,6,u)|0;c[15406]=0;c[15408]=0}else{x=l;h[k>>3]=D;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Rn(9,0,61640,l)}D=+Vr(a,1.0);h[o>>3]=D;l=j;h[k>>3]=D;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];Rn(9,0,61744,j);j=c[u>>2]|0;do{if((j|0)==3){Tn(9,0,61904,e);F=-3;i=b;return F|0}else if((j|0)==1){if(!(+h[q>>3]<+h[o>>3])){break}c[g>>2]=c[v>>2];Tn(9,0,61760,g);F=-1;i=b;return F|0}else if((j|0)==4){Tn(9,0,61976,d);F=-4;i=b;return F|0}else if((j|0)==2){Tn(9,0,61840,f);F=-2;i=b;return F|0}}while(0);F=Ur(a)|0;i=b;return F|0}function os(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[15408];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[15406];h[d>>3]=+Vr(f,1.0);i=e;return}function ps(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=fa(d*1e3|0,c[a>>2]|0)|0;c[j>>2]=0;Rn(9,1,62032,g);if((c[21268>>2]|0)==0){l=0}else{l=(k|0)/10|0}qs(a,d,k,l,b,j);c[f>>2]=c[j>>2];Rn(9,0,62056,f);Yd[c[5446]&255](9);if(+h[b>>3]<1.0){m=-1;i=e;return m|0}b=Ur(a)|0;if((b|0)==0){m=0;i=e;return m|0}Tn(9,0,62072,e);m=b;i=e;return m|0}function qs(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0;j=i;i=i+8|0;l=j;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+24|0;v=i;i=i+32|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+4096|0;K=a;L=c[K>>2]|0;M=L+1|0;N=L<<3;O=aS(fa(N,M)|0)|0;P=aS(M<<3)|0;Q=aS(N)|0;R=Q;S=aS(N)|0;T=S;V=aS(N)|0;W=V;X=aS(N)|0;Y=+h[f>>3];if((c[21268>>2]|0)!=0&Y<1.0){N=J;c[I>>2]=c[(c[a+60>>2]|0)+88>>2];gc(N|0,62120,I|0)|0;I=hc(N|0,62136)|0;c[H>>2]=62152;od(I|0,62144,H|0)|0;c[G>>2]=62168;od(I|0,62144,G|0)|0;if((c[K>>2]|0)>0){G=a+44|0;H=0;do{c[F>>2]=c[(c[G>>2]|0)+(H<<2)>>2];od(I|0,62144,F|0)|0;H=H+1|0;}while((H|0)<(c[K>>2]|0))}Jd(10,I|0)|0;c[E>>2]=0;od(I|0,62176,E|0)|0;E=D;h[k>>3]=Y;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];od(I|0,62184,D|0)|0;if((c[K>>2]|0)>0){D=a+24|0;E=0;do{H=C;h[k>>3]=+h[(c[D>>2]|0)+(E<<3)>>3];c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];od(I|0,62184,C|0)|0;E=E+1|0;}while((E|0)<(c[K>>2]|0))}Jd(10,I|0)|0;Z=I}else{Z=0}Un(0,(O|0)!=0|0,62192,B);Un(0,(P|0)!=0|0,62192,A);Un(0,(Q|0)!=0|0,62192,z);Un(0,(S|0)!=0|0,62192,y);Un(0,(V|0)!=0|0,62192,x);Un(0,(X|0)!=0|0,62192,w);w=c[a+40>>2]|0;x=(L|0)>0;do{if((w|0)==0){if(!x){_=0;break}y=a+24|0;z=0;while(1){A=(c[y>>2]|0)+(z<<3)|0;B=0;do{h[O+((fa(B,L)|0)+z<<3)>>3]=+h[A>>3];B=B+1|0;}while((B|0)<(M|0));B=z+1|0;if((B|0)<(L|0)){z=B}else{$=14;break}}}else{if(!x){_=0;break}z=c[a+24>>2]|0;y=0;while(1){aa=+h[z+(y<<3)>>3]/+h[w+(y<<3)>>3];B=0;do{h[O+((fa(B,L)|0)+y<<3)>>3]=aa;B=B+1|0;}while((B|0)<(M|0));B=y+1|0;if((B|0)<(L|0)){y=B}else{$=14;break}}}}while(0);do{if(($|0)==14){w=(L|0)>0;if(w){ba=0}else{_=0;break}while(1){x=O+((fa(ba,L)|0)+ba<<3)|0;h[x>>3]=+h[x>>3]+1.0;x=ba+1|0;if((x|0)<(L|0)){ba=x}else{_=w;break}}}}while(0);ba=(L|0)>-1;w=a+16|0;aa=+(M|0);ca=+(L|0);x=(e|0)==0;y=a+48|0;da=1.0/+(b+ -1|0);b=(Z|0)==0;z=a+24|0;B=L<<3;ea=0.0;A=0;ga=Y;a:while(1){I=!(ga>=1.0);E=ga<1.0;ha=ea;C=A;b:while(1){D=C;c:while(1){ia=D+1|0;if(ba){H=0;do{hs(a,O+((fa(H,L)|0)<<3)|0);h[P+(H<<3)>>3]=+Vr(a,ga);H=H+1|0;}while((H|0)<(M|0))}if(_){H=1;F=0;while(1){G=+h[P+(H<<3)>>3]<+h[P+(F<<3)>>3]?H:F;N=H+1|0;if((N|0)<(M|0)){F=G;H=N}else{ja=G;break}}}else{ja=0}ka=fa(ja,L)|0;la=O+(ka<<3)|0;hs(a,la);+Vr(a,ga);H=c[w>>2]|0;if((H|0)>0){F=c[y>>2]|0;Y=0.0;G=0;do{ma=+U(+(+h[F+(G<<3)>>3]));Y=ma>Y?ma:Y;G=G+1|0;}while((G|0)<(H|0));na=!(Y<1.0e-12)}else{na=0}if(!((na|I)&(D|0)<(d|0))){break a}do{if(ba){H=0;G=ja;F=ja;while(1){ma=+h[P+(H<<3)>>3];N=ma>+h[P+(G<<3)>>3];oa=N?H:G;J=N?G:F;pa=!(ma>+h[P+(J<<3)>>3])|(H|0)==(oa|0)?J:H;J=H+1|0;if((J|0)<(M|0)){F=pa;G=oa;H=J}else{break}}if(ba){qa=0.0;ra=0}else{sa=0.0;ta=oa;ua=pa;break}do{qa=qa+ +h[P+(ra<<3)>>3];ra=ra+1|0;}while((ra|0)<(M|0));ma=qa/aa;if(ba){va=0.0;wa=0}else{sa=0.0;ta=oa;ua=pa;break}while(1){xa=+h[P+(wa<<3)>>3]-ma;ya=va+xa*xa;H=wa+1|0;if((H|0)<(M|0)){wa=H;va=ya}else{sa=ya;ta=oa;ua=pa;break}}}else{sa=0.0;ta=ja;ua=ja}}while(0);Y=sa/ca;do{if(!x){if(((ia|0)%(e|0)|0|0)!=0){break}ma=+h[P+(ja<<3)>>3];ya=+h[P+(ta<<3)>>3];H=v;h[k>>3]=ga;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];c[v+8>>2]=ia;H=v+12|0;h[k>>3]=ma;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=v+20|0;h[k>>3]=ya;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];Rn(9,0,62208,v)}}while(0);if(Y<1.0e-8&E){break b}if(_){IS(X|0,0,B|0)|0}if(ba){H=0;do{if(!((H|0)==(ta|0)|_^1)){G=fa(H,L)|0;F=0;do{J=X+(F<<3)|0;h[J>>3]=+h[O+(F+G<<3)>>3]+ +h[J>>3];F=F+1|0;}while((F|0)<(L|0))}H=H+1|0;}while((H|0)<(M|0))}do{if(_){H=0;do{F=X+(H<<3)|0;h[F>>3]=+h[F>>3]/ca;H=H+1|0;}while((H|0)<(L|0));if(!_){break}H=fa(ta,L)|0;F=0;do{Y=+h[X+(F<<3)>>3];h[Q+(F<<3)>>3]=Y+(Y- +h[O+(F+H<<3)>>3]);F=F+1|0;}while((F|0)<(L|0))}}while(0);hs(a,R);za=+Vr(a,ga);Y=+h[P+(ja<<3)>>3];do{if(Y<=za){if(!(za<=+h[P+(ua<<3)>>3])){break}if(!_){Aa=ia;D=Aa;continue c}GS(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue c}}while(0);if(!(za<=Y)){break}if(_){F=0;do{ya=+h[X+(F<<3)>>3];h[S+(F<<3)>>3]=ya+(+h[Q+(F<<3)>>3]-ya)*2.0;F=F+1|0;}while((F|0)<(L|0))}hs(a,T);if(+Vr(a,ga)<za){if(!_){Aa=ia;D=Aa;continue}GS(O+(fa(B,ta)|0)|0,S|0,B|0)|0;Aa=ia;D=Aa;continue}else{if(!_){Aa=ia;D=Aa;continue}GS(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue}}if(!(+h[P+(ua<<3)>>3]<=za)){$=89;break a}Y=+h[P+(ta<<3)>>3];if(!(za>=Y)){if(_){D=0;do{ya=+h[X+(D<<3)>>3];h[V+(D<<3)>>3]=ya+(+h[Q+(D<<3)>>3]-ya)*.5;D=D+1|0;}while((D|0)<(L|0))}hs(a,W);Ba=+Vr(a,ga)}else{if(_){D=fa(ta,L)|0;F=0;do{ya=+h[X+(F<<3)>>3];h[V+(F<<3)>>3]=ya+(+h[O+(F+D<<3)>>3]-ya)*.5;F=F+1|0;}while((F|0)<(L|0))}hs(a,W);Ba=+Vr(a,ga)}if(Ba<Y){if(!_){ha=Ba;C=ia;continue}GS(O+(fa(B,ta)|0)|0,V|0,B|0)|0;ha=Ba;C=ia;continue}if(ba){Ca=0}else{ha=Ba;C=ia;continue}while(1){if(_){F=fa(Ca,L)|0;D=0;do{H=O+(D+F<<3)|0;h[H>>3]=(+h[H>>3]+ +h[O+(D+ka<<3)>>3])*.5;D=D+1|0;}while((D|0)<(L|0))}D=Ca+1|0;if((D|0)<(M|0)){Ca=D}else{ha=Ba;C=ia;continue b}}}Y=ga+da;ya=Y>1.0?1.0:Y;Y=+h[P+(ja<<3)>>3];C=u;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[u+8>>2]=ia;C=u+12|0;h[k>>3]=Y;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Rn(9,0,62248,u);if(b){ea=ha;A=ia;ga=ya;continue}c[t>>2]=ia;od(Z|0,62176,t|0)|0;C=s;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];od(Z|0,62184,s|0)|0;if((c[K>>2]|0)>0){C=0;do{E=r;h[k>>3]=+h[(c[z>>2]|0)+(C<<3)>>3];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];od(Z|0,62184,r|0)|0;C=C+1|0;}while((C|0)<(c[K>>2]|0))}Jd(10,Z|0)|0;ea=ha;A=ia;ga=ya}if(($|0)==89){$=q;h[k>>3]=za;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];Tn(9,0,62296,q);q=p;h[k>>3]=ha;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];Tn(9,0,62312,p);Vn(0,62328,o)}hs(a,la);if((f|0)!=0){h[f>>3]=ga}if((g|0)!=0){c[g>>2]=ia}if(b){bS(S);bS(Q);bS(V);bS(X);bS(P);bS(O);i=j;return}c[n>>2]=ia;od(Z|0,62176,n|0)|0;n=m;h[k>>3]=ga;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];od(Z|0,62184,m|0)|0;if((c[K>>2]|0)>0){m=0;do{n=l;h[k>>3]=+h[(c[z>>2]|0)+(m<<3)>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];od(Z|0,62184,l|0)|0;m=m+1|0;}while((m|0)<(c[K>>2]|0))}Jd(10,Z|0)|0;Vc(Z|0)|0;bS(S);bS(Q);bS(V);bS(X);bS(P);bS(O);i=j;return}function rs(a,b){a=a|0;b=b|0;i=i;return}function ss(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=c[b+12>>2]|0;Vo(3);Yo(0);w=+Qo(0);Vo(0);x=d+4|0;y=u;h[k>>3]=+h[c[c[x>>2]>>2]>>3];c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];od(v|0,62408,u|0)|0;if((c[b+8>>2]|0)!=0){b=t;h[k>>3]=w;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];od(v|0,62408,t|0)|0}t=d+116|0;b=c[t>>2]|0;if((b|0)>0){u=d+8|0;y=b;b=0;while(1){if((a[(c[u>>2]|0)+(b*112|0)+104|0]|0)==0){z=s;h[k>>3]=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(b<<3)>>3];c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];od(v|0,62408,s|0)|0;A=c[t>>2]|0}else{A=y}z=b+1|0;if((z|0)<(A|0)){y=A;b=z}else{break}}}b=d+124|0;A=c[b>>2]|0;if((A|0)>0){y=d+12|0;t=A;A=0;while(1){if((a[(c[y>>2]|0)+(A*60|0)+56|0]|0)==0){c[r>>2]=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(A<<2)>>2];od(v|0,62416,r|0)|0;B=c[b>>2]|0}else{B=t}s=A+1|0;if((s|0)<(B|0)){t=B;A=s}else{break}}}A=d+128|0;B=c[A>>2]|0;if((B|0)>0){t=d+16|0;b=B;B=0;while(1){if((a[(c[t>>2]|0)+(B*48|0)+44|0]|0)==0){c[q>>2]=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+B|0]|0;od(v|0,62416,q|0)|0;C=c[A>>2]|0}else{C=b}r=B+1|0;if((r|0)<(C|0)){b=C;B=r}else{break}}}B=d+132|0;C=c[B>>2]|0;if((C|0)>0){b=d+20|0;A=C;C=0;while(1){if((a[(c[b>>2]|0)+(C*52|0)+48|0]|0)==0){c[p>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(C<<2)>>2];od(v|0,62424,p|0)|0;D=c[B>>2]|0}else{D=A}q=C+1|0;if((q|0)<(D|0)){A=D;C=q}else{break}}}C=d+216|0;if((c[C>>2]|0)>0){D=d+40|0;A=0;do{B=c[D>>2]|0;do{if((a[B+(A*52|0)+48|0]|0)==0){p=a[B+(A*52|0)+8|0]|0;if(p<<24>>24==2){E=c[c[x>>2]>>2]|0}else if(p<<24>>24==1){break}else{E=(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(c[B+(A*52|0)+4>>2]<<3)|0}w=+h[E>>3];if((c[B+(A*52|0)>>2]|0)==0){p=n;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];od(v|0,62408,n|0)|0;break}else{p=o;h[k>>3]=-w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];od(v|0,62408,o|0)|0;break}}}while(0);A=A+1|0;}while((A|0)<(c[C>>2]|0))}C=d+220|0;if((c[C>>2]|0)>0){A=d+44|0;o=0;do{n=c[A>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){if((a[n+(o*52|0)+8|0]|0)==1){break}E=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(c[n+(o*52|0)+4>>2]<<2)>>2]|0;if((c[n+(o*52|0)>>2]|0)==0){c[l>>2]=E;od(v|0,62416,l|0)|0;break}else{c[m>>2]=0-E;od(v|0,62416,m|0)|0;break}}}while(0);o=o+1|0;}while((o|0)<(c[C>>2]|0))}C=d+224|0;if((c[C>>2]|0)>0){o=d+48|0;m=0;do{l=c[o>>2]|0;do{if((a[l+(m*52|0)+48|0]|0)==0){if((a[l+(m*52|0)+8|0]|0)==1){break}A=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+(c[l+(m*52|0)+4>>2]|0)|0]|0;if((c[l+(m*52|0)>>2]|0)==0){c[g>>2]=A<<24>>24;od(v|0,62416,g|0)|0;break}else{c[j>>2]=A<<24>>24!=1;od(v|0,62416,j|0)|0;break}}}while(0);m=m+1|0;}while((m|0)<(c[C>>2]|0))}C=d+228|0;m=c[C>>2]|0;if((m|0)<=0){F=Jd(10,v|0)|0;Yo(3);i=e;return}j=d+52|0;d=m;m=0;while(1){g=c[j>>2]|0;do{if((a[g+(m*52|0)+48|0]|0)==0){if((a[g+(m*52|0)+8|0]|0)==1){G=d;break}c[f>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(c[g+(m*52|0)+4>>2]<<2)>>2];od(v|0,62424,f|0)|0;G=c[C>>2]|0}else{G=d}}while(0);g=m+1|0;if((g|0)<(G|0)){d=G;m=g}else{break}}F=Jd(10,v|0)|0;Yo(3);i=e;return}function ts(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b;s=hc(c[r>>2]|0,62432)|0;t=c[d+536>>2]|0;u=c[r>>2]|0;r=Nd(c[(Lc()|0)>>2]|0)|0;c[q>>2]=u;c[q+4>>2]=r;Un(t,(s|0)!=0|0,62440,q);c[p>>2]=62496;od(s|0,62424,p|0)|0;if((c[b+8>>2]|0)!=0){c[o>>2]=62504;od(s|0,62424,o|0)|0}o=d+116|0;p=c[o>>2]|0;if((p|0)>0){q=d+8|0;t=p;p=0;while(1){r=c[q>>2]|0;if((a[r+(p*112|0)+104|0]|0)==0){c[n>>2]=c[r+(p*112|0)+4>>2];od(s|0,62424,n|0)|0;v=c[o>>2]|0}else{v=t}r=p+1|0;if((r|0)<(v|0)){t=v;p=r}else{break}}}p=d+124|0;v=c[p>>2]|0;if((v|0)>0){t=d+12|0;o=v;v=0;while(1){n=c[t>>2]|0;if((a[n+(v*60|0)+56|0]|0)==0){c[m>>2]=c[n+(v*60|0)+4>>2];od(s|0,62424,m|0)|0;w=c[p>>2]|0}else{w=o}n=v+1|0;if((n|0)<(w|0)){o=w;v=n}else{break}}}v=d+128|0;w=c[v>>2]|0;if((w|0)>0){o=d+16|0;p=w;w=0;while(1){m=c[o>>2]|0;if((a[m+(w*48|0)+44|0]|0)==0){c[l>>2]=c[m+(w*48|0)+4>>2];od(s|0,62424,l|0)|0;x=c[v>>2]|0}else{x=p}m=w+1|0;if((m|0)<(x|0)){p=x;w=m}else{break}}}w=d+132|0;x=c[w>>2]|0;if((x|0)>0){p=d+20|0;v=x;x=0;while(1){l=c[p>>2]|0;if((a[l+(x*52|0)+48|0]|0)==0){c[k>>2]=c[l+(x*52|0)+4>>2];od(s|0,62424,k|0)|0;y=c[w>>2]|0}else{y=v}l=x+1|0;if((l|0)<(y|0)){v=y;x=l}else{break}}}x=d+216|0;y=c[x>>2]|0;if((y|0)>0){v=d+40|0;w=y;y=0;while(1){k=c[v>>2]|0;do{if((a[k+(y*52|0)+48|0]|0)==0){if((a[k+(y*52|0)+8|0]|0)==1){z=w;break}c[j>>2]=c[k+(y*52|0)+16>>2];od(s|0,62424,j|0)|0;z=c[x>>2]|0}else{z=w}}while(0);k=y+1|0;if((k|0)<(z|0)){w=z;y=k}else{break}}}y=d+220|0;z=c[y>>2]|0;if((z|0)>0){w=d+44|0;x=z;z=0;while(1){j=c[w>>2]|0;do{if((a[j+(z*52|0)+48|0]|0)==0){if((a[j+(z*52|0)+8|0]|0)==1){A=x;break}c[h>>2]=c[j+(z*52|0)+16>>2];od(s|0,62424,h|0)|0;A=c[y>>2]|0}else{A=x}}while(0);j=z+1|0;if((j|0)<(A|0)){x=A;z=j}else{break}}}z=d+224|0;A=c[z>>2]|0;if((A|0)>0){x=d+48|0;y=A;A=0;while(1){h=c[x>>2]|0;do{if((a[h+(A*52|0)+48|0]|0)==0){if((a[h+(A*52|0)+8|0]|0)==1){B=y;break}c[g>>2]=c[h+(A*52|0)+16>>2];od(s|0,62424,g|0)|0;B=c[z>>2]|0}else{B=y}}while(0);h=A+1|0;if((h|0)<(B|0)){y=B;A=h}else{break}}}A=d+228|0;B=c[A>>2]|0;if((B|0)<=0){C=Jd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}y=d+52|0;d=B;B=0;while(1){z=c[y>>2]|0;do{if((a[z+(B*52|0)+48|0]|0)==0){if((a[z+(B*52|0)+8|0]|0)==1){H=d;break}c[f>>2]=c[z+(B*52|0)+16>>2];od(s|0,62424,f|0)|0;H=c[A>>2]|0}else{H=d}}while(0);z=B+1|0;if((z|0)<(H|0)){d=H;B=z}else{break}}C=Jd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}function us(a,b){a=a|0;b=b|0;var d=0;b=i;d=c[a+12>>2]|0;Vo(3);Vc(d|0)|0;Yo(3);i=b;return}function vs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d;f=d+16|0;g=d+32|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+88|0;o=c[a+12>>2]|0;c[k>>2]=0;p=o;mK(l,p);q=o+184|0;r=m;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=f;r=m;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];nK(p,f)|0;ws(b,k,g,j,+h[o+224>>3],+h[o+232>>3]);o=c[k>>2]|0;xs(a,b,62520,c[j>>2]|0,c[g>>2]|0,o,8);bS(o);c[k>>2]=0;k=n;o=l;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=e;k=n;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];nK(p,e)|0;i=d;return}function ws(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+8|0;c[e>>2]=2;l=b+136|0;m=b+140|0;n=b+144|0;o=(c[l>>2]|0)+1+(c[m>>2]|0)+(c[n>>2]|0)|0;c[f>>2]=o;p=cS(fa(c[e>>2]|0,o)|0,8)|0;c[d>>2]=p;Un(c[b+536>>2]|0,(p|0)!=0|0,62800,k);p=c[d>>2]|0;h[p>>3]=g;d=c[f>>2]|0;h[p+(d<<3)>>3]=j;f=c[l>>2]|0;if((f|0)>0){l=c[b+416>>2]|0;o=0;do{e=l+(o<<3)|0;o=o+1|0;h[p+(o<<3)>>3]=+h[e>>3];h[p+(d+o<<3)>>3]=+h[e>>3];}while((o|0)<(f|0))}o=f+1|0;f=c[m>>2]|0;if((f|0)>0){m=c[b+420>>2]|0;l=0;do{j=+(c[m+(l<<2)>>2]|0);e=l+o|0;h[p+(e<<3)>>3]=j;h[p+(d+e<<3)>>3]=j;l=l+1|0;}while((l|0)<(f|0))}l=f+o|0;o=c[n>>2]|0;if((o|0)<=0){i=k;return}n=c[b+424>>2]|0;b=0;do{f=n+b|0;m=l+b|0;h[p+(m<<3)>>3]=+(a[f]|0);h[p+(d+m<<3)>>3]=+(a[f]|0);b=b+1|0;}while((b|0)<(o|0));i=k;return}function xs(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+8|0;k=j;l=c[a+12>>2]|0;Is(a,b,d,e,f,h);lK(l,g,fa(fa(f,e)|0,h)|0)|0;if(II(l+(c[(c[l>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];Vn(l,62752,k)}else{i=j;return}}function ys(a){a=a|0;var b=0;b=i;if((At(a+4|0)|0)!=0){i=b;return}LI(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function zs(a){a=a|0;Pc(a|0)|0;Xa()}function As(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=gS(320)|0;IS(q|0,0,320)|0;Bs(q);r=a+12|0;c[r>>2]=q;s=(c[b+140>>2]|0)+(c[b+136>>2]|0)+(c[b+144>>2]|0)|0;c[f>>2]=0;c[k>>2]=0;c[l>>2]=0;Vo(3);t=a+8|0;u=Cs(c[t>>2]|0,c[r>>2]|0,b)|0;r=q+316|0;c[r>>2]=u;v=Ds(a,b,u+s|0)|0;u=q+184|0;Es(m,-1,-1);w=m;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];w=q+200|0;Es(n,-1,-1);m=n;c[w+0>>2]=c[m+0>>2];c[w+4>>2]=c[m+4>>2];c[w+8>>2]=c[m+8>>2];c[w+12>>2]=c[m+12>>2];c[q+216>>2]=0;m=q+224|0;h[m>>3]=+h[b+240>>3];n=q+232|0;h[n>>3]=+h[b+248>>3];x=a;Fs(q,c[x>>2]|0,36);if(II(q+(c[(c[q>>2]|0)+ -12>>2]|0)|0)|0){y=c[b+536>>2]|0;c[e>>2]=c[x>>2];Vn(y,62576,e)}else{xs(a,b,62608,4,11,62528,1);Gs((c[r>>2]|0)+s|0,v,f,g,j,0,0)|0;e=c[f>>2]|0;xs(a,b,62616,c[g>>2]|0,c[j>>2]|0,e,1);bS(e);c[f>>2]=0;Gs((c[r>>2]|0)+s|0,v,f,g,j,0,1)|0;e=c[f>>2]|0;xs(a,b,62624,c[g>>2]|0,c[j>>2]|0,e,1);bS(e);c[f>>2]=0;Hs(a,b,k,g,j,c[r>>2]|0,s);xs(a,b,62640,c[j>>2]|0,c[g>>2]|0,c[k>>2]|0,4);s=q;mK(o,s);r=o;c[u+0>>2]=c[r+0>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];ws(b,l,g,j,+h[m>>3],+h[n>>3]);n=c[l>>2]|0;xs(a,b,62520,c[j>>2]|0,c[g>>2]|0,n,8);mK(p,s);g=p;c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2];c[w+12>>2]=c[g+12>>2];g=Js(q+240|0)|0;w=Js(q+264|0)|0;p=Js(q+288|0)|0;Is(a,b,62656,g+1+w+p+(c[q+312>>2]|0)+(c[t>>2]|0)|0,0,8);bS(n);bS(c[k>>2]|0);c[l>>2]=0;c[k>>2]=0;TJ(s)|0;bS(v);Yo(3);i=d;return}}function Bs(a){a=a|0;var b=0;b=i;Kv(a);i=b;return}function Cs(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=(b|0)==0?1:2;c[g>>2]=0;b=e+116|0;l=c[b>>2]|0;if((l|0)>0){m=e+8|0;n=d+240|0;o=l;l=0;p=k;while(1){if((a[(c[m>>2]|0)+(l*112|0)+104|0]|0)==0){c[(Ou(n,g)|0)>>2]=p;q=c[b>>2]|0;r=c[g>>2]|0;s=p+1|0}else{q=o;r=l;s=p}t=r+1|0;c[g>>2]=t;if((t|0)<(q|0)){o=q;l=t;p=s}else{u=s;break}}}else{u=k}c[h>>2]=0;k=e+124|0;s=c[k>>2]|0;if((s|0)>0){p=e+12|0;l=d+264|0;q=s;s=0;o=u;while(1){if((a[(c[p>>2]|0)+(s*60|0)+56|0]|0)==0){c[(Ou(l,h)|0)>>2]=o;v=c[k>>2]|0;w=c[h>>2]|0;x=o+1|0}else{v=q;w=s;x=o}g=w+1|0;c[h>>2]=g;if((g|0)<(v|0)){q=v;s=g;o=x}else{y=x;break}}}else{y=u}c[j>>2]=0;u=e+128|0;x=c[u>>2]|0;if((x|0)>0){o=e+16|0;s=d+288|0;v=x;x=0;q=y;while(1){if((a[(c[o>>2]|0)+(x*48|0)+44|0]|0)==0){c[(Ou(s,j)|0)>>2]=q;z=c[u>>2]|0;A=c[j>>2]|0;B=q+1|0}else{z=v;A=x;B=q}h=A+1|0;c[j>>2]=h;if((h|0)<(z|0)){v=z;x=h;q=B}else{C=B;break}}}else{C=y}y=c[e+216>>2]|0;if((y|0)>0){B=c[e+40>>2]|0;q=0;x=C;while(1){z=((a[B+(q*52|0)+48|0]|0)==0)+x|0;v=q+1|0;if((v|0)<(y|0)){x=z;q=v}else{D=z;break}}}else{D=C}C=c[e+220>>2]|0;if((C|0)>0){q=c[e+44>>2]|0;x=0;y=D;while(1){B=((a[q+(x*52|0)+48|0]|0)==0)+y|0;z=x+1|0;if((z|0)<(C|0)){y=B;x=z}else{E=B;break}}}else{E=D}D=d+312|0;c[D>>2]=0;d=c[e+224>>2]|0;if((d|0)<=0){F=E;i=f;return F|0}x=c[e+48>>2]|0;e=0;y=0;C=E;while(1){if((a[x+(y*52|0)+48|0]|0)==0){if((c[x+(y*52|0)>>2]|0)==0){G=e}else{E=e+1|0;c[D>>2]=E;G=E}H=G;I=C+1|0}else{H=e;I=C}E=y+1|0;if((E|0)<(d|0)){e=H;y=E;C=I}else{F=I;break}}i=f;return F|0}function Ds(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=c[b+12>>2]|0;l=aS(e<<2)|0;e=l;c[l>>2]=63208;if((c[b+8>>2]|0)==0){m=1}else{c[l+4>>2]=63248;m=2}b=c[d+116>>2]|0;if((b|0)>0){n=c[d+8>>2]|0;o=m;p=0;while(1){if((a[n+(p*112|0)+104|0]|0)==0){c[l+(o<<2)>>2]=n+(p*112|0);q=o+1|0}else{q=o}r=p+1|0;if((r|0)<(b|0)){o=q;p=r}else{s=q;break}}}else{s=m}m=c[d+124>>2]|0;if((m|0)>0){q=c[d+12>>2]|0;p=s;o=0;while(1){if((a[q+(o*60|0)+56|0]|0)==0){c[l+(p<<2)>>2]=q+(o*60|0);t=p+1|0}else{t=p}b=o+1|0;if((b|0)<(m|0)){p=t;o=b}else{u=t;break}}}else{u=s}s=c[d+128>>2]|0;if((s|0)>0){t=c[d+16>>2]|0;o=u;p=0;while(1){if((a[t+(p*48|0)+44|0]|0)==0){c[l+(o<<2)>>2]=t+(p*48|0);v=o+1|0}else{v=o}m=p+1|0;if((m|0)<(s|0)){o=v;p=m}else{w=v;break}}}else{w=u}u=c[d+216>>2]|0;if((u|0)>0){v=c[d+40>>2]|0;p=w;o=0;while(1){if((a[v+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=v+(o*52|0)+12;x=p+1|0}else{x=p}s=o+1|0;if((s|0)<(u|0)){p=x;o=s}else{y=x;break}}}else{y=w}w=c[d+220>>2]|0;if((w|0)>0){x=c[d+44>>2]|0;o=y;p=0;while(1){if((a[x+(p*52|0)+48|0]|0)==0){c[l+(o<<2)>>2]=x+(p*52|0)+12;z=o+1|0}else{z=o}u=p+1|0;if((u|0)<(w|0)){o=z;p=u}else{A=z;break}}}else{A=y}y=c[d+224>>2]|0;if((y|0)>0){z=c[d+48>>2]|0;p=A;o=0;while(1){if((a[z+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=z+(o*52|0)+12;B=p+1|0}else{B=p}w=o+1|0;if((w|0)<(y|0)){p=B;o=w}else{C=B;break}}}else{C=A}c[g>>2]=0;A=d+136|0;if((c[A>>2]|0)>0){B=d+24|0;o=k+252|0;p=C;y=0;z=1;while(1){w=p+1|0;c[l+(p<<2)>>2]=(c[B>>2]|0)+(y*112|0);c[(Ou(o,g)|0)>>2]=z;x=z+1|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;if((u|0)<(c[A>>2]|0)){z=x;y=u;p=w}else{D=w;E=x;break}}}else{D=C;E=1}c[h>>2]=0;C=d+140|0;if((c[C>>2]|0)>0){p=d+28|0;y=k+276|0;z=D;A=0;g=E;while(1){o=z+1|0;c[l+(z<<2)>>2]=(c[p>>2]|0)+(A*60|0);c[(Ou(y,h)|0)>>2]=g;B=g+1|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;if((x|0)<(c[C>>2]|0)){g=B;A=x;z=o}else{F=o;G=B;break}}}else{F=D;G=E}c[j>>2]=0;E=d+144|0;if((c[E>>2]|0)<=0){i=f;return e|0}D=d+32|0;d=k+300|0;k=F;F=0;z=G;while(1){c[l+(k<<2)>>2]=(c[D>>2]|0)+(F*48|0);c[(Ou(d,j)|0)>>2]=z;G=(c[j>>2]|0)+1|0;c[j>>2]=G;if((G|0)<(c[E>>2]|0)){z=z+1|0;F=G;k=k+1|0}else{break}}i=f;return e|0}function Es(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;zt(a,b,c);i=d;return}function Fs(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(yt(a+4|0,b,d|16)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){LI(d,4);i=e;return}else{JI(d,0);i=e;return}}function Gs(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+8|0;k=j;l=i;i=i+8|0;c[f>>2]=a;c[e>>2]=0;m=(a|0)>0;do{if(m){n=0;o=0;while(1){p=c[b+(o<<2)>>2]|0;q=ES(c[(h?p+8|0:p+4|0)>>2]|0)|0;if((q|0)>(n|0)){c[e>>2]=q;r=q}else{r=n}q=o+1|0;if((q|0)<(a|0)){n=r;o=q}else{break}}o=cS((fa(c[f>>2]|0,r)|0)+1|0,1)|0;c[d>>2]=o;Un(0,(o|0)!=0|0,62728,l);if(!m){break}o=c[e>>2]|0;n=0;q=c[d>>2]|0;while(1){p=b+(n<<2)|0;s=c[p>>2]|0;PS(q|0,c[(h?s+8|0:s+4|0)>>2]|0,o+1|0)|0;if(g){s=c[p>>2]|0;Ns(q,ES(c[(h?s+8|0:s+4|0)>>2]|0)|0)}s=c[e>>2]|0;p=n+1|0;if((p|0)<(a|0)){o=s;n=p;q=q+s|0}else{t=s;break}}u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}else{q=cS(1,1)|0;c[d>>2]=q;Un(0,(q|0)!=0|0,62728,k)}}while(0);t=c[e>>2]|0;u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}function Hs(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=c[b+12>>2]|0;c[f>>2]=j+h;c[g>>2]=4;g=cS(c[f>>2]<<2,4)|0;c[e>>2]=g;Un(c[d+536>>2]|0,(g|0)!=0|0,62776,k);g=s+240|0;f=Js(g)|0;h=s+264|0;t=Js(h)|0;u=s+288|0;v=Js(u)|0;w=b+8|0;if((f+1+t+v|0)==(0-(c[w>>2]|0)|0)){x=0;y=1}else{v=c[e>>2]|0;t=0;f=0;b=1;while(1){c[v+(t<<2)>>2]=2;c[v+((t|1)<<2)>>2]=b;c[v+((t|2)<<2)>>2]=0;z=t+4|0;c[v+((t|3)<<2)>>2]=-1;A=b+1|0;B=f+1|0;C=Js(g)|0;D=Js(h)|0;E=Js(u)|0;if(B>>>0<(C+1+D+E+(c[w>>2]|0)|0)>>>0){b=A;f=B;t=z}else{x=z;y=A;break}}}t=d+216|0;if((c[t>>2]|0)>0){f=d+40|0;b=s+252|0;w=x;v=0;while(1){A=c[f>>2]|0;do{if((a[A+(v*52|0)+48|0]|0)==0){z=a[A+(v*52|0)+8|0]|0;if(z<<24>>24==0){Os(l,g,A+(v*52|0)+4|0);Qs(m,g);if(!(Ps(l,m)|0)){F=w;break}G=(c[(Rs(l)|0)+4>>2]|0)+1|0;H=2}else if(z<<24>>24==1){Os(l,b,A+(v*52|0)+4|0);Qs(n,b);if(!(Ps(l,n)|0)){F=w;break}G=(c[(Rs(l)|0)+4>>2]|0)+1|0;H=1}else if(z<<24>>24==2){G=1;H=2}else{F=w;break}z=c[e>>2]|0;c[z+(w<<2)>>2]=H;if((c[(c[f>>2]|0)+(v*52|0)>>2]|0)==0){c[z+(w+1<<2)>>2]=G}else{c[z+(w+1<<2)>>2]=0-G}c[z+(w+2<<2)>>2]=0;c[z+(w+3<<2)>>2]=-1;F=w+4|0}else{F=w}}while(0);A=v+1|0;if((A|0)<(c[t>>2]|0)){w=F;v=A}else{I=F;break}}}else{I=x}x=d+220|0;if((c[x>>2]|0)>0){F=d+44|0;v=s+276|0;w=I;t=0;while(1){G=c[F>>2]|0;do{if((a[G+(t*52|0)+48|0]|0)==0){f=a[G+(t*52|0)+8|0]|0;if(f<<24>>24==1){Os(l,v,G+(t*52|0)+4|0);Qs(p,v);J=(Ps(l,p)|0)&1}else if(f<<24>>24==0){Os(l,h,G+(t*52|0)+4|0);Qs(o,h);f=Ps(l,o)|0;J=f?2:0}else{K=w;break}if((J|0)==0){K=w;break}f=c[e>>2]|0;c[f+(w<<2)>>2]=J;H=(c[(c[F>>2]|0)+(t*52|0)>>2]|0)==0;n=c[(Rs(l)|0)+4>>2]|0;if(H){c[f+(w+1<<2)>>2]=n+1}else{c[f+(w+1<<2)>>2]=~n}c[f+(w+2<<2)>>2]=0;c[f+(w+3<<2)>>2]=-1;K=w+4|0}else{K=w}}while(0);G=t+1|0;if((G|0)<(c[x>>2]|0)){w=K;t=G}else{L=K;break}}}else{L=I}I=d+224|0;if((c[I>>2]|0)>0){K=d+48|0;d=s+300|0;s=L;t=0;w=y;while(1){y=c[K>>2]|0;do{if((a[y+(t*52|0)+48|0]|0)==0){if((c[y+(t*52|0)>>2]|0)==0){x=a[y+(t*52|0)+8|0]|0;if(x<<24>>24==1){Os(l,d,y+(t*52|0)+4|0);Qs(r,d);M=(Ps(l,r)|0)&1}else if(x<<24>>24==0){Os(l,u,y+(t*52|0)+4|0);Qs(q,u);x=Ps(l,q)|0;M=x?2:0}else{N=s;O=w;break}if((M|0)==0){N=s;O=w;break}P=c[K>>2]|0;Q=M}else{P=y;Q=2}x=c[e>>2]|0;c[x+(s<<2)>>2]=Q;if((c[P+(t*52|0)>>2]|0)==0){c[x+(s+1<<2)>>2]=(c[(Rs(l)|0)+4>>2]|0)+1;R=w}else{c[x+(s+1<<2)>>2]=w;R=w+1|0}c[x+(s+2<<2)>>2]=0;c[x+(s+3<<2)>>2]=-1;N=s+4|0;O=R}else{N=s;O=w}}while(0);y=t+1|0;if((y|0)<(c[I>>2]|0)){s=N;t=y;w=O}else{S=N;break}}}else{S=L}if((j|0)==0){i=k;return}L=c[e>>2]|0;e=0;do{N=(e<<2)+S|0;c[L+(N<<2)>>2]=1;c[L+(N+1<<2)>>2]=e+2;c[L+(N+2<<2)>>2]=0;c[L+(N+3<<2)>>2]=0;e=e+1|0;}while(e>>>0<j>>>0);i=k;return}function Is(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+24|0;m=c[a+12>>2]|0;c[l>>2]=(g|0)==4?20:(g|0)==1?51:0;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;f=l+16|0;c[f>>2]=(ES(d|0)|0)+1;e=m;lK(e,l,20)|0;if(II(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];Vn(l,62752,k)}lK(e,d,c[f>>2]|0)|0;if(II(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){m=c[b+536>>2]|0;c[j>>2]=c[a>>2];Vn(m,62752,j)}else{i=h;return}}function Js(a){a=a|0;var b=0,d=0;b=i;d=c[(vt(a)|0)>>2]|0;i=b;return d|0}function Ks(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=a+12|0;h=c[g>>2]|0;j=h;Vo(3);do{if(HI(h+(c[(c[h>>2]|0)+ -12>>2]|0)|0)|0){k=h;l=h+200|0;m=f;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];l=e;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];nK(k,e)|0;k=Js(h+240|0)|0;m=Js(h+264|0)|0;l=Js(h+288|0)|0;Is(a,b,62656,k+1+m+l+(c[h+312>>2]|0)+(c[a+8>>2]|0)|0,c[h+216>>2]|0,8);ys(h)}else{if((h|0)!=0){break}c[g>>2]=0;Yo(3);i=d;return}}while(0);Ls(j);iS(h);c[g>>2]=0;Yo(3);i=d;return}function Ls(a){a=a|0;var b=0;b=i;Tt(a);i=b;return}function Ms(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=c[b+12>>2]|0;h[g>>3]=0.0;Vo(3);Yo(0);h[j>>3]=+Qo(0);Vo(0);l=k;m=d+4|0;lK(l,c[c[m>>2]>>2]|0,8)|0;if((c[b+8>>2]|0)!=0){lK(l,j,8)|0}j=d+116|0;n=c[j>>2]|0;if((n|0)>0){o=d+8|0;p=n;n=0;while(1){if((a[(c[o>>2]|0)+(n*112|0)+104|0]|0)==0){lK(l,(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+(n<<3)|0,8)|0;q=c[j>>2]|0}else{q=p}r=n+1|0;if((r|0)<(q|0)){p=q;n=r}else{break}}}n=d+124|0;q=c[n>>2]|0;if((q|0)>0){p=d+12|0;j=g;o=q;q=0;while(1){if((a[(c[p>>2]|0)+(q*60|0)+56|0]|0)==0){h[g>>3]=+(c[(c[(c[c[m>>2]>>2]|0)+12>>2]|0)+(q<<2)>>2]|0);lK(l,j,8)|0;s=c[n>>2]|0}else{s=o}r=q+1|0;if((r|0)<(s|0)){o=s;q=r}else{break}}}q=d+128|0;s=c[q>>2]|0;if((s|0)>0){o=d+16|0;n=g;j=s;s=0;while(1){if((a[(c[o>>2]|0)+(s*48|0)+44|0]|0)==0){h[g>>3]=+(a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+s|0]|0);lK(l,n,8)|0;t=c[q>>2]|0}else{t=j}p=s+1|0;if((p|0)<(t|0)){j=t;s=p}else{break}}}s=d+224|0;t=c[s>>2]|0;if((t|0)>0){j=d+48|0;q=g;n=t;t=0;while(1){o=c[j>>2]|0;do{if((a[o+(t*52|0)+48|0]|0)==0){if((c[o+(t*52|0)>>2]|0)==0){u=n;break}h[g>>3]=+((a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+(c[o+(t*52|0)+4>>2]|0)|0]|0)!=1|0);lK(l,q,8)|0;u=c[s>>2]|0}else{u=n}}while(0);o=t+1|0;if((o|0)<(u|0)){n=u;t=o}else{break}}}if(II(k+(c[(c[k>>2]|0)+ -12>>2]|0)|0)|0){t=c[d+536>>2]|0;c[f>>2]=c[b>>2];Vn(t,62696,f)}else{f=k+216|0;c[f>>2]=(c[f>>2]|0)+1;Yo(3);i=e;return}}function Ns(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(c>>>0<6){i=d;return}if((BS(b,62912,4)|0)!=0){i=d;return}c=b;while(1){e=Ua(b|0,46)|0;if((e|0)==0){f=8;break}g=e-c|0;e=g+1|0;if(e>>>0>4){h=4;do{a[b+(h+ -4)|0]=a[b+h|0]|0;h=h+1|0;}while(h>>>0<e>>>0)}e=b+(g+ -3)|0;a[e]=678585700;a[e+1|0]=2650725;a[e+2|0]=10354;a[e+3|0]=40;if((BS(b,62912,4)|0)!=0){f=8;break}}if((f|0)==8){i=d;return}}function Os(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;ht(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];Zs(a,f);i=e;return}function Ps(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Xs(a,b)|0;i=c;return d|0}function Qs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;_s(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];Zs(a,e);i=d;return}function Rs(a){a=a|0;var b=0,c=0;b=i;c=Ss(Ts(a)|0)|0;i=b;return c|0}function Ss(a){a=a|0;var b=0,c=0;b=i;c=Ws(a)|0;i=b;return c|0}function Ts(a){a=a|0;var b=0,d=0;b=i;d=Us((c[a>>2]|0)+16|0)|0;i=b;return d|0}function Us(a){a=a|0;var b=0,c=0;b=i;c=Vs(a)|0;i=b;return c|0}function Vs(a){a=a|0;i=i;return a|0}function Ws(a){a=a|0;i=i;return a|0}function Xs(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(Ys(a,b)|0)^1;i=c;return d|0}function Ys(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function Zs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];gt(a,e);i=d;return}function _s(a,b){a=a|0;b=b|0;var c=0;c=i;$s(a,at(b)|0);i=c;return}function $s(a,b){a=a|0;b=b|0;var c=0;c=i;ft(a,b);i=c;return}function at(a){a=a|0;var b=0,c=0;b=i;c=bt(ct(a+4|0)|0)|0;i=b;return c|0}function bt(a){a=a|0;var b=0,c=0;b=i;c=et(a)|0;i=b;return c|0}function ct(a){a=a|0;var b=0,c=0;b=i;c=dt(a)|0;i=b;return c|0}function dt(a){a=a|0;i=i;return a|0}function et(a){a=a|0;i=i;return a|0}function ft(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function gt(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function ht(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=jt(b)|0;it(f,b,d,h,at(b)|0);_s(g,b);do{if(Xs(f,g)|0){h=kt(b)|0;if(lt(h,d,mt(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);_s(a,b);i=e;return}function it(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;qt(h);a:do{if((e|0)==0){j=f}else{k=kt(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(rt(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;qt(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;qt(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);$s(a,j);i=g;return}function jt(a){a=a|0;var b=0,d=0;b=i;d=c[(at(a)|0)>>2]|0;i=b;return d|0}function kt(a){a=a|0;var b=0,c=0;b=i;c=ot(a+8|0)|0;i=b;return c|0}function lt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=nt(0,b,c)|0;i=a;return d|0}function mt(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function nt(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function ot(a){a=a|0;var b=0,c=0;b=i;c=pt(a)|0;i=b;return c|0}function pt(a){a=a|0;i=i;return a|0}function qt(a){a=a|0;var b=0;b=i;st(a,-1);i=b;return}function rt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=nt(0,b,c)|0;i=a;return d|0}function st(a,b){a=a|0;b=b|0;b=i;tt(a,0);i=b;return}function tt(a,b){a=a|0;b=b|0;c[a>>2]=0;i=i;return}function ut(a){a=a|0;i=i;return c[a+4>>2]|0}function vt(a){a=a|0;var b=0,c=0;b=i;c=wt(a+8|0)|0;i=b;return c|0}function wt(a){a=a|0;var b=0,c=0;b=i;c=xt(a)|0;i=b;return c|0}function xt(a){a=a|0;i=i;return a|0}function yt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+64|0;if((c[f>>2]|0)!=0){g=0;i=e;return g|0}switch(d&-3|0){case 8:{h=62832;break};case 48:case 16:{h=62816;break};case 56:{h=62848;break};case 52:case 20:{h=62864;break};case 60:{h=62896;break};case 5:case 21:{h=62872;break};case 28:{h=62888;break};case 1:case 17:{h=62824;break};case 24:{h=62840;break};case 12:{h=62880;break};case 13:case 29:{h=62904;break};case 9:case 25:{h=62856;break};default:{g=0;i=e;return g|0}}if((a|0)==0){g=0;i=e;return g|0}j=hc(b|0,h|0)|0;c[f>>2]=j;if((j|0)==0){g=0;i=e;return g|0}c[a+88>>2]=d;if((d&2|0)==0){g=a;i=e;return g|0}if((Tc(j|0,0,2)|0)==0){g=a;i=e;return g|0}Vc(c[f>>2]|0)|0;c[f>>2]=0;g=0;i=e;return g|0}function zt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=b;c[e+4>>2]=d;i=i;return}function At(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+64|0;f=c[e>>2]|0;if((f|0)==0){g=0;i=b;return g|0}Bt(d,f,102);f=$d[c[(c[a>>2]|0)+24>>2]&127](a)|0;if((Vc(Ct(d)|0)|0)==0){c[e>>2]=0;h=(f|0)==0?a:0}else{h=0}Dt(d);g=h;i=b;return g|0}function Bt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Kt(a,b,c);i=d;return}function Ct(a){a=a|0;var b=0,d=0;b=i;d=Gt(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function Dt(a){a=a|0;var b=0;b=i;Et(a);i=b;return}function Et(a){a=a|0;var b=0;b=i;Ft(a,0);i=b;return}function Ft(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=Gt(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}$d[c[(Ht(e)|0)>>2]&127](f)|0;i=d;return}function Gt(a){a=a|0;var b=0,c=0;b=i;c=Jt(a)|0;i=b;return c|0}function Ht(a){a=a|0;var b=0,c=0;b=i;c=It(a)|0;i=b;return c|0}function It(a){a=a|0;i=i;return a+4|0}function Jt(a){a=a|0;i=i;return a|0}function Kt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(Mt(f)|0)>>2]|0;Lt(a,d,c[(Nt(g)|0)>>2]|0);i=e;return}function Lt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Ot(a,b,c);i=d;return}function Mt(a){a=a|0;i=i;return a|0}function Nt(a){a=a|0;i=i;return a|0}function Ot(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(Qt(f)|0)>>2]|0;Pt(a,d,c[(Rt(g)|0)>>2]|0);i=e;return}function Pt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;c[a>>2]=c[(Qt(f)|0)>>2];c[a+4>>2]=c[(Rt(g)|0)>>2];i=e;return}function Qt(a){a=a|0;i=i;return a|0}function Rt(a){a=a|0;i=i;return a|0}function St(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;J=c[d+4>>2]|0;i=b;return c[d>>2]|0}function Tt(a){a=a|0;var b=0;b=i;Ut(a+300|0);Ut(a+288|0);Ut(a+276|0);Ut(a+264|0);Ut(a+252|0);Ut(a+240|0);Vt(a);i=b;return}function Ut(a){a=a|0;var b=0;b=i;Fu(a);i=b;return}function Vt(a){a=a|0;var b=0;b=i;Wt(a,62960);PI(a+104|0);i=b;return}function Wt(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];_t(a+4|0);i=d;return}function Xt(a){a=a|0;var b=0;b=i;Vt(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Yt(a){a=a|0;var b=0;b=i;Vt(a);iS(a);i=b;return}function Zt(a){a=a|0;var b=0;b=i;Yt(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function _t(a){a=a|0;var b=0;b=i;$t(a);i=b;return}function $t(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=63088;At(b)|0;do{if((a[b+96|0]|0)!=0){e=c[b+32>>2]|0;if((e|0)==0){break}jS(e)}}while(0);do{if((a[b+97|0]|0)!=0){e=c[b+56>>2]|0;if((e|0)==0){break}jS(e)}}while(0);YI(b);i=d;return}function au(a){a=a|0;var b=0;b=i;_t(a);iS(a);i=b;return}function bu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;$d[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=Du(d)|0;c[b+68>>2]=f;d=b+98|0;g=a[d]|0;h=Eu(f)|0;a[d]=h&1;if((g&255|0)==(h&1|0)){i=e;return}h=b;gJ(h,0,0,0);lJ(h,0,0);h=b+96|0;g=(a[h]|0)!=0;if((a[d]|0)!=0){d=b+32|0;do{if(g){f=c[d>>2]|0;if((f|0)==0){break}jS(f)}}while(0);f=b+97|0;a[h]=a[f]|0;j=b+60|0;c[b+52>>2]=c[j>>2];k=b+56|0;c[d>>2]=c[k>>2];c[j>>2]=0;c[k>>2]=0;a[f]=0;i=e;return}do{if(!g){f=b+32|0;k=c[f>>2]|0;if((k|0)==(b+44|0)){break}j=c[b+52>>2]|0;c[b+60>>2]=j;c[b+56>>2]=k;a[b+97|0]=0;c[f>>2]=hS(j)|0;a[h]=1;i=e;return}}while(0);h=c[b+52>>2]|0;c[b+60>>2]=h;c[b+56>>2]=hS(h)|0;a[b+97|0]=1;i=e;return}function cu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=f+8|0;c[g>>2]=e;e=b;gJ(e,0,0,0);lJ(e,0,0);j=b+96|0;do{if((a[j]|0)!=0){k=c[b+32>>2]|0;if((k|0)==0){break}jS(k)}}while(0);k=b+97|0;do{if((a[k]|0)!=0){l=c[b+56>>2]|0;if((l|0)==0){break}jS(l)}}while(0);l=c[g>>2]|0;m=b+52|0;c[m>>2]=l;do{if(l>>>0>8){n=a[b+98|0]|0;if(n<<24>>24==0|(d|0)==0){c[b+32>>2]=hS(l)|0;a[j]=1;o=n;break}else{c[b+32>>2]=d;a[j]=0;o=n;break}}else{c[b+32>>2]=b+44;c[m>>2]=8;a[j]=0;o=a[b+98|0]|0}}while(0);if(!(o<<24>>24==0)){c[b+60>>2]=0;c[b+56>>2]=0;a[k]=0;i=f;return e|0}c[h>>2]=8;o=c[(Au(g,h)|0)>>2]|0;c[b+60>>2]=o;if((d|0)!=0&o>>>0>7){c[b+56>>2]=d;a[k]=0;i=f;return e|0}else{c[b+56>>2]=hS(o)|0;a[k]=1;i=f;return e|0}return 0}function du(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g;j=g+8|0;k=g+24|0;l=k;m=c[b+68>>2]|0;if((m|0)==0){n=Cc(4)|0;HR(n);Kd(n|0,110416,127)}n=wu(m)|0;m=b+64|0;do{if((c[m>>2]|0)!=0){o=(n|0)>0;if(!(o|(d|0)==0&(e|0)==0)){break}if(($d[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}if(!(f>>>0<3)){Es(a,-1,-1);i=g;return}p=c[m>>2]|0;if(o){o=XS(n|0,((n|0)<0)<<31>>31|0,d|0,e|0)|0;q=o}else{q=0}if((Tc(p|0,q|0,f|0)|0)==0){p=xb(c[m>>2]|0)|0;Es(j,p,((p|0)<0)<<31>>31);p=b+72|0;o=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=o;o=h;r=l;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];zu(j,h);r=a;o=j;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];i=g;return}else{Es(a,-1,-1);i=g;return}}}while(0);Es(a,-1,-1);i=g;return}function eu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=f;h=b+64|0;do{if((c[h>>2]|0)!=0){if(($d[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}j=c[h>>2]|0;k=St(d)|0;if((Tc(j|0,k|0,0)|0)==0){yu(g,d);k=f;j=c[k+4>>2]|0;l=b+72|0;c[l>>2]=c[k>>2];c[l+4>>2]=j;j=a;l=d;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=e;return}else{Es(a,-1,-1);i=e;return}}}while(0);Es(a,-1,-1);i=e;return}function fu(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=Cc(4)|0;HR(m);Kd(m|0,110416,127)}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;do{if((a[b+98|0]|0)==0){p=wu(l)|0;q=b+36|0;o=c[q>>2]|0;r=(c[b+40>>2]|0)-o|0;s=b;if((p|0)>0){t=eJ(s)|0;u=(fa(t-(dJ(s)|0)|0,p)|0)+r|0;v=0;break}p=dJ(s)|0;if((p|0)==(eJ(s)|0)){u=r;v=0;break}t=c[k>>2]|0;w=b+32|0;x=c[w>>2]|0;y=xu(t,g,x,o,p-(cJ(s)|0)|0)|0;u=r-y+(c[q>>2]|0)-(c[w>>2]|0)|0;v=1}else{w=b;q=eJ(w)|0;u=q-(dJ(w)|0)|0;v=0}}while(0);if((Tc(c[h>>2]|0,0-u|0,1)|0)!=0){j=-1;i=d;return j|0}if(v){w=f;q=c[w+4>>2]|0;y=b+72|0;c[y>>2]=c[w>>2];c[y+4>>2]=q}q=c[b+32>>2]|0;c[b+40>>2]=q;c[b+36>>2]=q;gJ(b,0,0,0);c[m>>2]=0}else{q=b;y=iJ(q)|0;do{if((y|0)!=(hJ(q)|0)){if((ne[c[(c[b>>2]|0)+52>>2]&63](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);q=b+72|0;y=b+32|0;w=b+52|0;while(1){r=c[y>>2]|0;s=vu(c[k>>2]|0,q,r,r+(c[w>>2]|0)|0,e)|0;r=c[y>>2]|0;p=(c[e>>2]|0)-r|0;if((pc(r|0,1,p|0,c[h>>2]|0)|0)!=(p|0)){j=-1;z=23;break}if((s|0)==2){j=-1;z=23;break}else if((s|0)!=1){z=10;break}}if((z|0)==10){if((md(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((z|0)==23){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function gu(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=b+64|0;if((c[l>>2]|0)==0){m=-1;i=d;return m|0}n=qu(b)|0;o=b;if((dJ(o)|0)==0){p=e+1|0;gJ(o,e,p,p)}if(n){q=0}else{n=eJ(o)|0;c[f>>2]=(n-(cJ(o)|0)|0)/2|0;c[g>>2]=4;q=c[(ru(f,g)|0)>>2]|0}g=dJ(o)|0;do{if((g|0)==(eJ(o)|0)){HS(cJ(o)|0,g+(0-q)|0,q|0)|0;if((a[b+98|0]|0)!=0){f=eJ(o)|0;n=cJ(o)|0;p=rb(n+q|0,1,f-q-n|0,c[l>>2]|0)|0;if((p|0)==0){r=-1;break}n=cJ(o)|0;gJ(o,n,n+q|0,n+(p+q)|0);r=ou(a[dJ(o)|0]|0)|0;break}p=b+32|0;n=b+36|0;f=c[n>>2]|0;s=b+40|0;HS(c[p>>2]|0,f|0,(c[s>>2]|0)-f|0)|0;f=c[p>>2]|0;t=f+((c[s>>2]|0)-(c[n>>2]|0))|0;c[n>>2]=t;if((f|0)==(b+44|0)){u=8}else{u=c[b+52>>2]|0}v=f+u|0;c[s>>2]=v;f=b+60|0;c[h>>2]=(c[f>>2]|0)-q;c[j>>2]=v-t;v=c[(ru(h,j)|0)>>2]|0;w=b+72|0;x=w;y=c[x+4>>2]|0;z=b+80|0;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=rb(t|0,1,v|0,c[l>>2]|0)|0;if((y|0)==0){r=-1;break}v=c[b+68>>2]|0;if((v|0)==0){t=Cc(4)|0;HR(t);Kd(t|0,110416,127)}t=(c[n>>2]|0)+y|0;c[s>>2]=t;y=c[p>>2]|0;z=cJ(o)|0;if((su(v,w,y,t,n,z+q|0,z+(c[f>>2]|0)|0,k)|0)==3){f=c[p>>2]|0;gJ(o,f,f,c[s>>2]|0);r=ou(a[dJ(o)|0]|0)|0;break}s=c[k>>2]|0;f=cJ(o)|0;p=f+q|0;if((s|0)==(p|0)){r=-1;break}gJ(o,f,p,s);r=ou(a[dJ(o)|0]|0)|0}else{r=ou(a[g]|0)|0}}while(0);if((cJ(o)|0)!=(e|0)){m=r;i=d;return m|0}gJ(o,0,0,0);m=r;i=d;return m|0}function hu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[b+64>>2]|0)==0){f=-1;i=e;return f|0}g=b;h=cJ(g)|0;j=dJ(g)|0;if(!(h>>>0<j>>>0)){f=-1;i=e;return f|0}if(ku(d,-1)|0){fJ(g,-1);f=nu(d)|0;i=e;return f|0}h=(c[b+88>>2]&16|0)==0;b=lu(d)|0;do{if(h){if(pu(b,a[j+ -1|0]|0)|0){break}else{f=-1}i=e;return f|0}}while(0);fJ(g,-1);a[dJ(g)|0]=b;f=d;i=e;return f|0}function iu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}ju(b);l=b;m=hJ(l)|0;n=jJ(l)|0;if(!(ku(d,-1)|0)){if((iJ(l)|0)==0){lJ(l,f,f+1|0)}f=lu(d)|0;a[iJ(l)|0]=f;kJ(l,1)}f=iJ(l)|0;o=hJ(l)|0;if((f|0)!=(o|0)){a:do{if((a[b+98|0]|0)==0){p=b+32|0;q=c[p>>2]|0;c[g>>2]=q;r=b+68|0;s=c[r>>2]|0;if((s|0)==0){t=Cc(4)|0;u=t;HR(u);v=110416;w=127;Kd(t|0,v|0,w|0)}x=b+72|0;y=b+52|0;z=q;q=s;while(1){s=hJ(l)|0;A=iJ(l)|0;B=mu(q,x,s,A,h,z,z+(c[y>>2]|0)|0,g)|0;A=c[h>>2]|0;C=hJ(l)|0;if((A|0)==(C|0)){k=-1;D=22;break}if((B|0)==3){D=14;break}if(!(B>>>0<2)){k=-1;D=22;break}A=c[p>>2]|0;s=(c[g>>2]|0)-A|0;if((pc(A|0,1,s|0,c[j>>2]|0)|0)!=(s|0)){k=-1;D=22;break}if((B|0)!=1){break a}B=c[h>>2]|0;lJ(l,B,iJ(l)|0);B=jJ(l)|0;kJ(l,B-(hJ(l)|0)|0);B=c[r>>2]|0;if((B|0)==0){D=11;break}z=c[p>>2]|0;q=B}if((D|0)==11){t=Cc(4)|0;u=t;HR(u);v=110416;w=127;Kd(t|0,v|0,w|0)}else if((D|0)==14){q=(iJ(l)|0)-C|0;if((pc(C|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((D|0)==22){i=e;return k|0}}else{q=f-o|0;if((pc(o|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);lJ(l,m,n)}k=nu(d)|0;i=e;return k|0}function ju(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+92|0;if((c[e>>2]&16|0)!=0){i=d;return}f=b;gJ(f,0,0,0);g=c[b+52>>2]|0;do{if(g>>>0>8){if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;lJ(f,h,h+((c[b+60>>2]|0)+ -1)|0);break}else{h=c[b+32>>2]|0;lJ(f,h,h+(g+ -1)|0);break}}else{lJ(f,0,0)}}while(0);c[e>>2]=16;i=d;return}function ku(a,b){a=a|0;b=b|0;i=i;return(a|0)==(b|0)|0}function lu(a){a=a|0;i=i;return a&255|0}function mu(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=we[c[(c[a>>2]|0)+12>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function nu(a){a=a|0;var b=0,c=0;b=i;c=ku(a,-1)|0;i=b;return(c?0:a)|0}function ou(a){a=a|0;i=i;return a&255|0}function pu(a,b){a=a|0;b=b|0;i=i;return a<<24>>24==b<<24>>24|0}function qu(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+92|0;if((c[e>>2]&8|0)!=0){f=0;i=d;return f|0}g=b;lJ(g,0,0);if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;j=h+(c[b+60>>2]|0)|0;gJ(g,h,j,j)}else{j=c[b+32>>2]|0;h=j+(c[b+52>>2]|0)|0;gJ(g,j,h,h)}c[e>>2]=8;f=1;i=d;return f|0}function ru(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=tu(b,c,e)|0;i=d;return g|0}function su(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=we[c[(c[a>>2]|0)+16>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function tu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=uu(0,b,a)|0;i=c;return(d?b:a)|0}function uu(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function vu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=oe[c[(c[a>>2]|0)+20>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function wu(a){a=a|0;var b=0,d=0;b=i;d=$d[c[(c[a>>2]|0)+24>>2]&127](a)|0;i=b;return d|0}function xu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=oe[c[(c[a>>2]|0)+32>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function yu(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function zu(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function Au(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=Bu(b,c,e)|0;i=d;return g|0}function Bu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=Cu(0,a,b)|0;i=c;return(d?b:a)|0}function Cu(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function Du(a){a=a|0;var b=0,c=0;b=i;c=HO(a,94920)|0;i=b;return c|0}function Eu(a){a=a|0;var b=0,d=0;b=i;d=$d[c[(c[a>>2]|0)+28>>2]&127](a)|0;i=b;return d|0}function Fu(a){a=a|0;var b=0;b=i;Gu(a);i=b;return}function Gu(a){a=a|0;var b=0;b=i;Hu(a);i=b;return}function Hu(a){a=a|0;var b=0;b=i;Iu(a,jt(a)|0);i=b;return}function Iu(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;qt(d);if((b|0)==0){i=d;return}Iu(a,c[b>>2]|0);Iu(a,c[b+4>>2]|0);Ku(Ju(a)|0,b,1);i=d;return}function Ju(a){a=a|0;var b=0,c=0;b=i;c=Mu(a+4|0)|0;i=b;return c|0}function Ku(a,b,c){a=a|0;b=b|0;c=c|0;c=i;Lu(0,b,0);i=c;return}function Lu(a,b,c){a=a|0;b=b|0;c=c|0;c=i;iS(b);i=c;return}function Mu(a){a=a|0;var b=0,c=0;b=i;c=Nu(a)|0;i=b;return c|0}function Nu(a){a=a|0;i=i;return a|0}function Ou(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=Pu(a,f,b)|0;l=c[k>>2]|0;qt(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}Ru(j,a,b);Su(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];Qu(g,e);Tu(j);j=c[f>>2]|0;Uu(a,j,k,Vu(g)|0);k=Wu(g)|0;Tu(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function Pu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=jt(h)|0;qt(e);if((a|0)==0){j=at(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(nt(0,d,a)|0){m=l;j=c[m>>2]|0;qt(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(nt(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;qt(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function Qu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Iv(a,e);i=d;return}function Ru(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=Ju(d)|0;d=rv(n,1)|0;sv(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];qv(j,d,h);tv(0,mv((uv(j)|0)+16|0)|0,e);e=vv(j)|0;a[e+4|0]=1;wv(0,lv((uv(j)|0)+20|0)|0);a[e+5|0]=1;xv(m,j);Su(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];Qu(b,g);Tu(m);Tu(j);i=f;return}function Su(a,b){a=a|0;b=b|0;var c=0;c=i;ov(a,b);i=c;return}function Tu(a){a=a|0;var b=0;b=i;hv(a);i=b;return}function Uu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;qt(f);c[e>>2]=0;qt(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=$u(a)|0;b=c[c[e>>2]>>2]|0;qt(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(at(a)|0)>>2]|0;av(e,c[d>>2]|0);d=bv(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function Vu(a){a=a|0;var b=0,d=0;b=i;d=c[(Zu(a)|0)>>2]|0;i=b;return d|0}function Wu(a){a=a|0;var b=0,d=0;b=i;d=Xu(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function Xu(a){a=a|0;var b=0,c=0;b=i;c=Yu(a)|0;i=b;return c|0}function Yu(a){a=a|0;i=i;return a|0}function Zu(a){a=a|0;var b=0,c=0;b=i;c=_u(a)|0;i=b;return c|0}function _u(a){a=a|0;i=i;return a|0}function $u(a){a=a|0;i=i;return a|0}function av(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(d|0)==(b|0);a[d+12|0]=h&1;if(h){i=e;return}else{j=d}while(1){k=j+8|0;d=c[k>>2]|0;if((a[d+12|0]|0)!=0){l=17;break}h=ev(d)|0;m=c[d+8>>2]|0;if(h){h=c[m+4>>2]|0;qt(f);if((h|0)==0){l=7;break}d=h+12|0;if((a[d]|0)!=0){l=7;break}h=c[k>>2]|0;a[h+12|0]=1;n=c[h+8>>2]|0;a[n+12|0]=(n|0)==(b|0)|0;a[d]=1;o=n}else{n=c[m>>2]|0;qt(g);if((n|0)==0){l=14;break}m=n+12|0;if((a[m]|0)!=0){l=14;break}n=c[k>>2]|0;a[n+12|0]=1;d=c[n+8>>2]|0;a[d+12|0]=(d|0)==(b|0)|0;a[m]=1;o=d}if((o|0)==(b|0)){l=17;break}else{j=o}}if((l|0)==7){if(ev(j)|0){p=j}else{o=c[k>>2]|0;fv(o);p=o}o=c[p+8>>2]|0;a[o+12|0]=1;p=c[o+8>>2]|0;a[p+12|0]=0;gv(p);i=e;return}else if((l|0)==14){if(ev(j)|0){p=c[k>>2]|0;gv(p);q=p}else{q=j}j=c[q+8>>2]|0;a[j+12|0]=1;q=c[j+8>>2]|0;a[q+12|0]=0;fv(q);i=e;return}else if((l|0)==17){i=e;return}}function bv(a){a=a|0;var b=0,c=0;b=i;c=cv(a+8|0)|0;i=b;return c|0}function cv(a){a=a|0;var b=0,c=0;b=i;c=dv(a)|0;i=b;return c|0}function dv(a){a=a|0;i=i;return a|0}function ev(a){a=a|0;i=i;return(c[c[a+8>>2]>>2]|0)==(a|0)|0}function fv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;f=e;g=c[f>>2]|0;c[d>>2]=g;qt(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=ev(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function gv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;f=e+4|0;g=c[f>>2]|0;c[d>>2]=g;qt(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=ev(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function hv(a){a=a|0;var b=0;b=i;iv(a,0);i=b;return}function iv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=Xu(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}kv(jv(e)|0,f);i=d;return}function jv(a){a=a|0;var b=0,c=0;b=i;c=nv(a)|0;i=b;return c|0}function kv(a,b){a=a|0;b=b|0;var d=0;d=i;if((b|0)==0){i=d;return}Ku(c[a>>2]|0,b,1);i=d;return}function lv(a){a=a|0;i=i;return a|0}function mv(a){a=a|0;i=i;return a|0}function nv(a){a=a|0;i=i;return a+4|0}function ov(a,b){a=a|0;b=b|0;var c=0;c=i;pv(a,b);i=c;return}function pv(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function qv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];Av(a,b,f);i=e;return}function rv(a,b){a=a|0;b=b|0;var c=0;a=i;c=zv(0,b,0)|0;i=a;return c|0}function sv(a,b){a=a|0;b=b|0;var c=0;c=i;yv(a,b);i=c;return}function tv(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function uv(a){a=a|0;var b=0,d=0;b=i;d=c[(Zu(a)|0)>>2]|0;i=b;return d|0}function vv(a){a=a|0;var b=0,c=0;b=i;c=jv(a)|0;i=b;return c|0}function wv(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function xv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;ov(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];Qu(h,f);Su(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];Qu(a,e);Tu(h);i=d;return}function yv(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function zv(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=gS(b*24|0)|0;i=c;return a|0}function Av(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(Cv(g)|0)>>2]|0;g=Dv(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];Bv(b,a,f);i=e;return}function Bv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];Ev(a,b,f);i=e;return}function Cv(a){a=a|0;i=i;return a|0}function Dv(a){a=a|0;i=i;return a|0}function Ev(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(Gv(g)|0)>>2]|0;g=Hv(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];Fv(b,a,f);i=e;return}function Fv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(Gv(f)|0)>>2];f=Hv(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function Gv(a){a=a|0;i=i;return a|0}function Hv(a){a=a|0;i=i;return a|0}function Iv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=Wu(Jv(b)|0)|0;h=Hv(vv(Jv(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];Bv(g,a,e);i=d;return}function Jv(a){a=a|0;i=i;return c[a>>2]|0}function Kv(a){a=a|0;var b=0;b=i;i=i+48|0;Lv(a);Es(a+184|0,0,0);Es(a+200|0,0,0);Mv(a+240|0,b);Mv(a+252|0,b+8|0);Mv(a+264|0,b+16|0);Mv(a+276|0,b+24|0);Mv(a+288|0,b+32|0);Mv(a+300|0,b+40|0);i=b;return}function Lv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+104|0;UI(d);e=a;c[e>>2]=62932;f=d;c[f>>2]=62952;d=a+4|0;$J(a,62964|0,d);c[e>>2]=62932;c[f>>2]=62952;Zv(d);i=b;return}function Mv(a,b){a=a|0;b=b|0;b=i;Nv(a,0);i=b;return}function Nv(a,b){a=a|0;b=b|0;b=i;i=i+8|0;Ov(a,b);i=b;return}function Ov(a,b){a=a|0;b=b|0;b=i;Pv(a,0);i=b;return}function Pv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;Qv(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;Rv(f,0,e);e=at(b)|0;c[($u(b)|0)>>2]=e;i=d;return}function Qv(a){a=a|0;var b=0;b=i;Vv(a);i=b;return}function Rv(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;Sv(b,c,f);i=e;return}function Sv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(Uv(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;Tv(d,b,f);i=e;return}function Tv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(Uv(e)|0)>>2];i=d;return}function Uv(a){a=a|0;i=i;return a|0}function Vv(a){a=a|0;var b=0;b=i;Wv(a);i=b;return}function Wv(a){a=a|0;var b=0;b=i;Xv(a);i=b;return}function Xv(a){a=a|0;var b=0;b=i;Yv(a);i=b;return}function Yv(a){a=a|0;c[a>>2]=0;i=i;return}function Zv(a){a=a|0;var b=0;b=i;_v(a);i=b;return}function _v(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=d;bJ(j);c[d>>2]=63088;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;k=d+68|0;l=d+52|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;qt(f);f=d+98|0;l=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;b[l+28>>1]=0;a[l+30|0]=0;ZI(g,j);l=$v(g)|0;FO(g);if(!l){m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=be[r&63](d,0,4096)|0;i=e;return}ZI(h,j);c[k>>2]=Du(h)|0;FO(h);a[f]=(Eu(c[k>>2]|0)|0)&1;m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=be[r&63](d,0,4096)|0;i=e;return}function $v(a){a=a|0;var b=0,c=0;b=i;c=GO(a,94920)|0;i=b;return c|0}function aw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+8|0;e=d;f=c[a+12>>2]|0;Vo(3);g=f+8|0;h=g;j=c[g>>2]|0;g=f+12|0;k=c[g>>2]|0;if((j|0)<(k|0)){bw(a,b,c[f>>2]|0,h);Yo(3);i=d;return}l=~~(+(k|0)*1.4+ +(k-j|0)+2.0e3);c[g>>2]=l;j=f+16|0;k=dS(c[f>>2]|0,fa(l<<3,c[j>>2]|0)|0)|0;l=k;c[f>>2]=l;if((k|0)==0){k=c[b+536>>2]|0;c[e>>2]=fa(c[j>>2]|0,c[g>>2]|0)|0;Vn(k,63360,e)}bw(a,b,l,h);Yo(3);i=d;return}function bw(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;j=c[b+12>>2]|0;Yo(0);k=+Qo(0);Vo(0);l=c[c[d+4>>2]>>2]|0;m=l;n=+h[m>>3];o=j+4|0;j=c[o>>2]|0;p=j+1|0;c[o>>2]=p;h[e+(j<<3)>>3]=n;if((c[b+8>>2]|0)==0){q=p}else{b=j+2|0;c[o>>2]=b;h[e+(p<<3)>>3]=k;q=b}b=d+116|0;p=c[b>>2]|0;if((p|0)>0){j=c[d+8>>2]|0;r=p;p=q;s=0;while(1){if((a[j+(s*112|0)+104|0]|0)==0){k=+h[(c[l+8>>2]|0)+(s<<3)>>3];t=p+1|0;c[o>>2]=t;h[e+(p<<3)>>3]=k;u=c[b>>2]|0;v=t}else{u=r;v=p}t=s+1|0;if((t|0)<(u|0)){r=u;p=v;s=t}else{w=v;break}}}else{w=q}q=d+124|0;v=c[q>>2]|0;if((v|0)>0){s=c[d+12>>2]|0;p=v;v=w;u=0;while(1){if((a[s+(u*60|0)+56|0]|0)==0){k=+(c[(c[l+12>>2]|0)+(u<<2)>>2]|0);r=v+1|0;c[o>>2]=r;h[e+(v<<3)>>3]=k;x=c[q>>2]|0;y=r}else{x=p;y=v}r=u+1|0;if((r|0)<(x|0)){p=x;v=y;u=r}else{z=y;break}}}else{z=w}w=d+128|0;y=c[w>>2]|0;if((y|0)>0){u=c[d+16>>2]|0;v=y;y=z;x=0;while(1){if((a[u+(x*48|0)+44|0]|0)==0){k=+(a[(c[l+16>>2]|0)+x|0]|0);p=y+1|0;c[o>>2]=p;h[e+(y<<3)>>3]=k;A=c[w>>2]|0;B=p}else{A=v;B=y}p=x+1|0;if((p|0)<(A|0)){v=A;y=B;x=p}else{C=B;break}}}else{C=z}z=d+216|0;if((c[z>>2]|0)>0){B=d+416|0;x=c[d+40>>2]|0;y=C;A=0;while(1){do{if((a[x+(A*52|0)+48|0]|0)==0){v=a[x+(A*52|0)+8|0]|0;do{if(v<<24>>24==2){D=m}else{w=c[x+(A*52|0)+4>>2]|0;if(v<<24>>24==1){D=(c[B>>2]|0)+(w<<3)|0;break}else{D=(c[l+8>>2]|0)+(w<<3)|0;break}}}while(0);k=+h[D>>3];if((c[x+(A*52|0)>>2]|0)==0){v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=k;E=v;break}else{v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=-k;E=v;break}}else{E=y}}while(0);v=A+1|0;if((v|0)<(c[z>>2]|0)){y=E;A=v}else{F=E;break}}}else{F=C}C=d+220|0;if((c[C>>2]|0)>0){E=d+40|0;A=d+420|0;y=c[d+44>>2]|0;z=F;x=0;while(1){do{if((a[y+(x*52|0)+48|0]|0)==0){D=c[(c[((a[y+(x*52|0)+8|0]|0)==1?A:l+12|0)>>2]|0)+(c[(c[E>>2]|0)+(x*52|0)+4>>2]<<2)>>2]|0;if((c[y+(x*52|0)>>2]|0)==0){B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(D|0);G=B;break}else{B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(0-D|0);G=B;break}}else{G=z}}while(0);B=x+1|0;if((B|0)<(c[C>>2]|0)){z=G;x=B}else{H=G;break}}}else{H=F}F=d+224|0;if((c[F>>2]|0)<=0){I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}G=d+44|0;x=d+40|0;z=d+424|0;C=c[d+48>>2]|0;d=H;H=0;while(1){do{if((a[C+(H*52|0)+48|0]|0)==0){y=a[(c[((a[(c[G>>2]|0)+(H*52|0)+8|0]|0)==1?z:l+16|0)>>2]|0)+(c[(c[x>>2]|0)+(H*52|0)+4>>2]|0)|0]|0;if((c[C+(H*52|0)>>2]|0)==0){E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24);K=E;break}else{E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24!=1|0);K=E;break}}else{K=d}}while(0);E=H+1|0;if((E|0)<(c[F>>2]|0)){d=K;H=E}else{break}}I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}function cw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=aS(24)|0;Vo(3);c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=g+16|0;c[j>>2]=0;k=a+4|0;l=c[k>>2]|0;c[g+12>>2]=l;m=b+536|0;Un(c[m>>2]|0,l>>>31^1,63416,f);f=b+8|0;b=c[a+8>>2]|0;l=dw(b,f)|0;c[g+20>>2]=l;l=dw(b,f)|0;c[j>>2]=l;j=c[k>>2]|0;k=aS(fa(l<<3,j)|0)|0;c[g>>2]=k;if((k|0)==0){k=c[m>>2]|0;c[e>>2]=fa(l,j)|0;Vn(k,63496,e)}else{c[h>>2]=0;c[a+12>>2]=g;Yo(3);i=d;return}}function dw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=(b|0)==0?1:2;b=c[d+108>>2]|0;if((b|0)>0){g=c[d>>2]|0;h=0;j=f;while(1){k=((a[g+(h*112|0)+104|0]|0)==0)+j|0;l=h+1|0;if((l|0)<(b|0)){j=k;h=l}else{m=k;break}}}else{m=f}f=c[d+116>>2]|0;if((f|0)>0){h=c[d+4>>2]|0;j=0;b=m;while(1){g=((a[h+(j*60|0)+56|0]|0)==0)+b|0;k=j+1|0;if((k|0)<(f|0)){b=g;j=k}else{n=g;break}}}else{n=m}m=c[d+120>>2]|0;if((m|0)>0){j=c[d+8>>2]|0;b=0;f=n;while(1){h=((a[j+(b*48|0)+44|0]|0)==0)+f|0;g=b+1|0;if((g|0)<(m|0)){f=h;b=g}else{o=h;break}}}else{o=n}n=c[d+208>>2]|0;if((n|0)>0){b=c[d+32>>2]|0;f=0;m=o;while(1){j=((a[b+(f*52|0)+48|0]|0)==0)+m|0;h=f+1|0;if((h|0)<(n|0)){m=j;f=h}else{p=j;break}}}else{p=o}o=c[d+212>>2]|0;if((o|0)>0){f=c[d+36>>2]|0;m=0;n=p;while(1){b=((a[f+(m*52|0)+48|0]|0)==0)+n|0;j=m+1|0;if((j|0)<(o|0)){n=b;m=j}else{q=b;break}}}else{q=p}p=c[d+216>>2]|0;if((p|0)<=0){r=q;i=e;return r|0}m=c[d+40>>2]|0;d=0;n=q;while(1){q=((a[m+(d*52|0)+48|0]|0)==0)+n|0;o=d+1|0;if((o|0)<(p|0)){n=q;d=o}else{r=q;break}}i=e;return r|0}



function Mp(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0.0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0;z=i;i=i+8|0;A=z;B=c[b>>2]|0;C=~B;D=c[u>>2]|0;E=~D;h[6004]=.5;h[5995]=1.0;h[6035]=.1;F=(c[a>>2]|0)+1|0;c[11986]=F;G=fa(c[a>>2]|0,F)|0;H=(G|0)/2|0;c[11978]=H;I=(c[b>>2]|0)-F|0;c[12032]=I;F=c[j>>2]|0;c[12086]=(F|0)<1?1:F;F=c[a>>2]|0;c[11970]=1;if((F|0)>=1){j=1;while(1){J=j+ -1|0;h[k+(J<<3)>>3]=+h[d+(J<<3)>>3];J=c[b>>2]|0;c[11972]=1;if((J|0)>=1){K=fa(j,B)|0;L=1;while(1){h[n+(L+C+K<<3)>>3]=0.0;if((L|0)<(J|0)){L=L+1|0}else{break}}c[11972]=J+1}L=c[u>>2]|0;c[11968]=1;if((L|0)>=1){K=1;while(1){h[s+(K+E+(fa(j,D)|0)<<3)>>3]=0.0;if((K|0)<(L|0)){K=K+1|0}else{break}}c[11968]=L+1}K=j+1|0;c[11970]=K;if((j|0)<(F|0)){j=K}else{break}}}c[11974]=1;if((G|0)>=2){G=1;while(1){h[q+(G+ -1<<3)>>3]=0.0;if((G|0)<(H|0)){G=G+1|0}else{break}}c[11974]=H+1}H=c[b>>2]|0;c[11972]=1;if((H|0)>=1){G=(I|0)<1;j=I+1|0;F=1;while(1){h[r+(F+ -1<<3)>>3]=0.0;if(G){M=1}else{K=1;while(1){h[t+((fa(K,B)|0)+C+F<<3)>>3]=0.0;if((K|0)<(I|0)){K=K+1|0}else{M=j;break}}}if((F|0)<(H|0)){F=F+1|0}else{break}}c[11970]=M;c[11972]=H+1}N=+h[e>>3];O=N*N;h[6040]=O;h[6026]=+h[5995]/O;h[6027]=+V(+(+h[6004]))/O;c[11976]=0;H=y;y=A;M=0;a:while(1){c[11988]=M;F=M-(c[a>>2]|0)|0;c[12012]=F;j=M+1|0;c[11976]=j;I=c[a>>2]|0;do{if((M|0)>(I<<1|0)){G=(F+ -1|0)/(I|0)|0;c[12062]=G;K=c[a>>2]|0;L=M-(fa(K,G)|0)-K|0;c[12e3]=L;K=L+G|0;c[11998]=K;if((K|0)>(c[a>>2]|0)){c[12062]=L;G=K-(c[a>>2]|0)|0;c[12e3]=G;c[11998]=L;P=L;Q=G}else{P=K;Q=L}O=+h[e>>3];h[6017]=O;L=c[11986]|0;if(+h[o+(P+ -1+L<<3)>>3]<+h[o+(P<<3)>>3]){N=-O;h[6017]=N;R=N}else{R=O}O=+h[e>>3];h[6018]=O;if(+h[o+(Q+ -1+L<<3)>>3]<+h[o+(Q<<3)>>3]){h[6018]=-O}L=j+C|0;h[n+(L+(fa(P,B)|0)<<3)>>3]=R;h[n+(L+(fa(Q,B)|0)<<3)>>3]=+h[6018];S=c[a>>2]|0}else{L=(M|0)>(I|0);if(!((M|0)<1|L)){h[n+((fa(M,B)|0)+C+j<<3)>>3]=+h[e>>3];S=I;break}if(!L){S=I;break}h[n+(j+C+(fa(F,B)|0)<<3)>>3]=-+h[e>>3];S=I}}while(0);c[11970]=1;if((S|0)>=1){I=1;while(1){O=+h[n+((fa(I,B)|0)+C+j<<3)>>3];F=I+ -1|0;h[d+(F<<3)>>3]=O+ +h[k+(F<<3)>>3];if((I|0)<(S|0)){I=I+1|0}else{break}}c[11970]=S+1}if((M|0)>=(c[12086]|0)){T=j;U=159;break}while(1){be[H&63](a,d,47864)|0;if((c[g>>2]|0)==3){FG(48392)|0;WF(48560,47904,4)|0;WF(48560,47864,8)|0;I=c[a>>2]|0;c[11968]=1;if((I|0)>=1){F=1;do{WF(48560,d+(F+ -1<<3)|0,8)|0;L=c[11968]|0;F=L+1|0;c[11968]=F;}while((L|0)<(I|0))}nG()|0}I=c[11976]|0;do{if((I|0)>(c[b>>2]|0)){F=c[12016]|0;if((F|0)==-1){break a}h[6036]=0.0;c[11974]=0;L=c[a>>2]|0;c[11970]=1;if((L|0)<1){W=0.0}else{O=0.0;K=2;G=1;J=0;while(1){X=G+ -1|0;N=O+ +h[v+(X<<3)>>3]*+h[p+(X<<3)>>3];h[6036]=N;if((G|0)<1){Y=1;Z=N;_=J}else{X=G+ -1|0;$=m+(X<<3)|0;aa=v+(X<<3)|0;ba=N;X=1;ca=J;while(1){da=X+ -1|0;N=+h[v+(da<<3)>>3]*+h[$>>3]+ +h[aa>>3]*+h[l+(da<<3)>>3];h[6009]=N;if((X|0)==(G|0)){ea=N*+h[6004];h[6009]=ea;ga=ea}else{ga=N}ha=ba+ga*+h[q+(ca<<3)>>3];h[6036]=ha;if((X|0)<(G|0)){ba=ha;X=X+1|0;ca=ca+1|0}else{break}}ca=J+G|0;c[11974]=ca;Y=K;Z=ha;_=ca}if((G|0)<(L|0)){O=Z;K=K+1|0;G=G+1|0;J=_}else{break}}c[11968]=Y;c[11970]=L+1;W=Z}J=c[b>>2]|0;c[11972]=1;if((J|0)<1){ia=W}else{O=W;G=1;while(1){K=G+ -1|0;ja=O+ +h[r+(K<<3)>>3]*+h[x+(K<<3)>>3];h[6036]=ja;if((G|0)<(J|0)){G=G+1|0;O=ja}else{break}}c[11972]=J+1;ia=ja}O=+h[5983];ba=+h[6012];N=O-ba-ia;h[6003]=N;h[6022]=+h[6021];h[6021]=+h[6020];if(!(N>=0.0)){ka=-N}else{ka=N}h[6020]=ka;if(+h[6032]>+h[5998]){c[12060]=I}h[6028]=ba;do{if(O<ba){h[6012]=O;h[6045]=0.0;G=c[a>>2]|0;c[11968]=1;if((G|0)<1){break}else{la=1}while(1){L=la+ -1|0;h[l+(L<<3)>>3]=+h[m+(L<<3)>>3];ma=+h[l+(la+ -1<<3)>>3];h[6045]=+h[6045]+ma*ma;if((la|0)<(G|0)){la=la+1|0}else{break}}c[11968]=G+1;h[A>>3]=ma}}while(0);c[12058]=F;if((F|0)<=0){O=+h[6036];if(O>=0.0){U=190;break a}ba=+h[5983];N=+h[6028];ea=(ba-N)/O;h[6033]=ea;O=+h[6035];do{if(!(ea<=O)){na=+h[6004]*+h[6025];h[A>>3]=na;oa=+h[6032];if(!(ea<=.7)){pa=oa+oa;qa=na>=pa?na:pa;h[6025]=qa;ra=qa;break}else{qa=na>=oa?na:oa;h[6025]=qa;ra=qa;break}}else{qa=+h[6004]*+h[6032];h[6025]=qa;ra=qa}}while(0);ea=+h[5998];if(!(ra<=ea*1.5)){sa=ra}else{h[6025]=ea;sa=ea}qa=O*sa;oa=qa>=ea?qa:ea;h[A>>3]=oa;ea=oa*oa;h[6040]=ea;c[12074]=0;h[6041]=0.0;if(!(ba>=N)){ta=0;ua=0.0}else{J=c[12030]|0;c[12074]=J;oa=+h[5995];h[6041]=oa;ta=J;ua=oa}J=c[b>>2]|0;c[11972]=1;if((J|0)<1){va=F}else{L=c[12032]|0;oa=ua;K=1;ca=F;while(1){h[6023]=0.0;c[11970]=1;if((L|0)<1){wa=0.0}else{X=c[11992]|0;aa=K+C|0;qa=+h[5995];na=0.0;$=1;while(1){if(($|0)<(X|0)){xa=-qa}else{xa=qa}h[6009]=xa;pa=+h[t+(aa+(fa($,B)|0)<<3)>>3];ya=na+xa*pa*pa;h[6023]=ya;if(($|0)<(L|0)){na=ya;$=$+1|0}else{break}}c[11970]=L+1;wa=ya}na=+h[w+(K+ -1<<3)>>3];qa=na*na+ +h[6005]*wa;if(!(qa>=0.0)){za=-qa}else{za=qa}h[6009]=za;h[6044]=0.0;$=c[a>>2]|0;c[11970]=1;if(($|0)<1){Aa=qa;Ba=0.0}else{qa=0.0;aa=1;while(1){na=+h[n+((fa(aa,B)|0)+C+K<<3)>>3];Ca=na- +h[l+(aa+ -1<<3)>>3];Da=qa+Ca*Ca;h[6044]=Da;if((aa|0)<($|0)){aa=aa+1|0;qa=Da}else{break}}c[11970]=$+1;Aa=Ca;Ba=Da}if(Ba>ea){qa=Ba/ea;na=za*qa*qa*qa;h[6009]=na;Ea=qa;Fa=na}else{Ea=Aa;Fa=za}if(!(Fa>oa)|(K|0)==(ta|0)){Ga=oa;Ha=ca}else{h[6041]=Fa;c[12016]=K;Ga=Fa;Ha=K}aa=K+1|0;c[11972]=aa;if((K|0)<(J|0)){oa=Ga;K=aa;ca=Ha}else{break}}h[A>>3]=Ea;va=Ha}if((va|0)==0){Ia=0;Ja=sa;Ka=O;U=286;break}}Sp(a,b,s,t,47968,u,w,48040,48064,x)|0;ca=c[12016]|0;K=ca+ -1|0;h[o+(K<<3)>>3]=+h[5983];c[11974]=0;J=c[a>>2]|0;c[11968]=1;L=r+(K<<3)|0;if((J|0)>=1){K=ca+C|0;F=2;aa=1;X=0;while(1){oa=+h[L>>3]*+h[n+((fa(aa,B)|0)+C+ca<<3)>>3];h[6009]=oa;if((aa|0)<1){La=1;Ma=X}else{ea=oa;G=1;da=X;while(1){oa=ea*+h[n+(K+(fa(G,B)|0)<<3)>>3];Na=q+(da<<3)|0;h[Na>>3]=+h[Na>>3]+oa;if((G|0)>=(aa|0)){break}ea=+h[6009];G=G+1|0;da=da+1|0}da=X+aa|0;c[11974]=da;La=F;Ma=da}if((aa|0)<(J|0)){F=F+1|0;aa=aa+1|0;X=Ma}else{break}}c[11970]=La;c[11968]=J+1}h[L>>3]=0.0;X=c[12032]|0;c[11970]=1;aa=(X|0)<1;if(!aa){F=c[11992]|0;K=1;while(1){da=fa(K,B)|0;O=+h[6003]*+h[t+(da+C+ca<<3)>>3];if((K|0)<(F|0)){Oa=-O}else{Oa=O}h[6009]=Oa;G=c[b>>2]|0;c[11972]=1;if((G|0)>=1){O=Oa;$=1;while(1){Na=r+($+ -1<<3)|0;h[Na>>3]=+h[Na>>3]+O*+h[t+($+C+da<<3)>>3];if(($|0)>=(G|0)){break}O=+h[6009];$=$+1|0}c[11972]=G+1}$=K+1|0;c[11970]=$;if((K|0)<(X|0)){K=$}else{break}}}h[6014]=0.0;K=c[a>>2]|0;c[11968]=1;if((K|0)>=1){F=1;while(1){O=+h[6003]*+h[s+((fa(F,D)|0)+E+ca<<3)>>3];L=p+(F+ -1<<3)|0;h[L>>3]=+h[L>>3]+O;L=F+ -1|0;Pa=+h[p+(L<<3)>>3];h[6014]=+h[6014]+Pa*Pa;h[n+((fa(F,B)|0)+C+ca<<3)>>3]=+h[m+(L<<3)>>3];if((F|0)<(K|0)){F=F+1|0}else{break}}c[11968]=K+1;h[A>>3]=Pa}F=c[12058]|0;do{if((F|0)==0){if(!(+h[6025]==+h[5998])){break}O=+h[6033];if(!(O>=0.0)){Qa=-O}else{Qa=O}if(Qa>.01){c[12078]=0;break}L=c[b>>2]|0;c[11972]=1;if((L|0)>=1){J=o+((c[12030]|0)+ -1<<3)|0;$=1;while(1){da=$+ -1|0;h[w+(da<<3)>>3]=+h[o+(da<<3)>>3]- +h[J>>3];if(($|0)<(L|0)){$=$+1|0}else{break}}c[11972]=L+1}h[6007]=0.0;$=c[a>>2]|0;c[11968]=1;if(($|0)<1){Ra=0.0}else{J=1;while(1){h[6001]=0.0;G=c[b>>2]|0;c[11972]=1;if((G|0)<1){Sa=0.0}else{da=fa(J,D)|0;O=0.0;Na=1;while(1){Ta=O+ +h[s+(Na+E+da<<3)>>3]*+h[w+(Na+ -1<<3)>>3];h[6001]=Ta;if((Na|0)<(G|0)){Na=Na+1|0;O=Ta}else{break}}c[11972]=G+1;Sa=Ta}h[6007]=+h[6007]+Sa*Sa;h[x+(J+ -1<<3)>>3]=Sa;Na=J+1|0;c[11968]=Na;if((J|0)<($|0)){J=Na}else{break}}Ra=+h[6007]*100.0}J=c[12078]|0;c[12078]=J+1;if(+h[6014]<Ra){c[12078]=0;break}if((J|0)<=1){break}J=c[a>>2]|0;c[11968]=1;if((J|0)>=1){$=1;while(1){L=$+ -1|0;h[p+(L<<3)>>3]=+h[x+(L<<3)>>3];if(($|0)<(J|0)){$=$+1|0}else{break}}c[11968]=J+1}$=c[11978]|0;c[11974]=1;if(($|0)>=1){L=1;while(1){h[q+(L+ -1<<3)>>3]=0.0;if((L|0)<($|0)){L=L+1|0}else{break}}c[11974]=$+1}c[11970]=1;if(!aa){L=1;while(1){J=x+(L+ -1<<3)|0;h[J>>3]=0.0;Na=c[b>>2]|0;c[11972]=1;if((Na|0)<1){Ua=0.0}else{da=fa(L,B)|0;O=0.0;Va=1;while(1){Wa=O+ +h[w+(Va+ -1<<3)>>3]*+h[t+(Va+C+da<<3)>>3];h[J>>3]=Wa;if((Va|0)<(Na|0)){Va=Va+1|0;O=Wa}else{break}}c[11972]=Na+1;Ua=Wa}if((L|0)<(c[11992]|0)){h[J>>3]=-Ua}Va=L+1|0;c[11970]=Va;if((L|0)<(X|0)){L=Va}else{break}}}L=c[b>>2]|0;c[11972]=1;if((L|0)>=1){$=X+1|0;Va=1;while(1){h[r+(Va+ -1<<3)>>3]=0.0;if(aa){Xa=1}else{da=1;while(1){O=+h[t+((fa(da,B)|0)+C+Va<<3)>>3];G=r+(Va+ -1<<3)|0;h[G>>3]=+h[G>>3]+O*+h[x+(da+ -1<<3)>>3];if((da|0)<(X|0)){da=da+1|0}else{Xa=$;break}}}if((Va|0)<(L|0)){Va=Va+1|0}else{break}}c[11970]=Xa;c[11972]=L+1}c[12078]=0}}while(0);O=+h[5983];ea=+h[6028];if(O<ea){c[12030]=ca}oa=+h[6035];if(O<=ea+oa*+h[6036]|(F|0)>0){U=54;break}c[12016]=0;Ia=0;Ja=+h[6025];Ka=oa;U=286}else{h[o+(I+ -1<<3)>>3]=+h[5983];oa=+h[5983];do{if((I|0)==1){h[6002]=oa;h[6012]=oa;c[12030]=1;Ya=1}else{if(!(oa<+h[6012])){Ya=I;break}h[6012]=oa;c[12030]=I;Ya=I}}while(0);F=c[11988]|0;ca=c[a>>2]|0;do{if((F|0)>(ca<<1|0)){X=c[11998]|0;aa=(fa(X+ -1|0,X)|0)/2|0;K=c[12e3]|0;Va=K+aa|0;c[11974]=Va;if(+h[6017]<0.0){aa=X+(c[a>>2]|0)|0;c[11998]=aa;Za=aa}else{Za=X}if(+h[6018]<0.0){X=K+(c[a>>2]|0)|0;c[12e3]=X;_a=X}else{_a=K}K=fa(c[12012]|0,B)|0;h[t+(K-B<<3)>>3]=+h[6026];h[t+(Ya+C+K<<3)>>3]=+h[6026];h[t+(Za-B+K<<3)>>3]=-+h[6026];h[t+(_a-B+K<<3)>>3]=-+h[6026];h[q+(Va+ -1<<3)>>3]=(+h[6002]- +h[o+(Za<<3)>>3]- +h[o+(_a<<3)>>3]+ +h[5983])/(+h[6017]*+h[6018])}else{Va=(F|0)>(ca|0);if((F|0)<1|Va){if(!Va){break}Va=c[12012]|0;K=fa(Va,D)|0;h[s+(E-ca+Ya+K<<3)>>3]=+h[6004]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=-+h[6004]/+h[e>>3];ea=+h[6027];K=fa(Va,B)|0;h[t+(K-B<<3)>>3]=-ea-ea;X=Ya+C|0;h[t+(X-ca+K<<3)>>3]=+h[6027];h[t+(X+K<<3)>>3]=+h[6027];K=(fa(Va+1|0,Va)|0)/2|0;c[11974]=K;ea=(+h[6002]- +h[5983])/+h[e>>3];h[6009]=ea;X=p+(Va+ -1<<3)|0;h[q+(K+ -1<<3)>>3]=(+h[X>>3]-ea)/+h[e>>3];h[X>>3]=+h[6004]*(+h[X>>3]+ +h[6009]);break}else{h[p+(F+ -1<<3)>>3]=(oa- +h[6002])/+h[e>>3];X=c[b>>2]|0;if((X|0)>=(ca+Ya|0)){break}K=fa(F,D)|0;h[s+(K-D<<3)>>3]=-+h[5995]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=+h[5995]/+h[e>>3];h[s+(X+E+F+K<<3)>>3]=-(+h[6004]*+h[6040]);break}}}while(0);if((Ya|0)<(c[b>>2]|0)){M=Ya;continue a}oa=+h[e>>3];h[5998]=oa;h[6025]=oa;c[11992]=1;h[6020]=0.0;h[6021]=0.0;c[12078]=0;h[6045]=0.0;F=c[a>>2]|0;c[11968]=1;if((F|0)<1){U=53;break}ca=c[12030]|0;K=1;while(1){h[l+(K+ -1<<3)>>3]=+h[n+((fa(K,B)|0)+C+ca<<3)>>3];$a=+h[l+(K+ -1<<3)>>3];h[6045]=+h[6045]+$a*$a;if((K|0)<(F|0)){K=K+1|0}else{break}}c[11968]=F+1;h[A>>3]=$a;U=53}}while(0);while(1){if((U|0)==53){U=0;c[12060]=c[11976];U=54;continue}else if((U|0)==54){U=0;c[12016]=0;I=(c[11986]|0)+ -1|0;K=c[a>>2]|0;Rp(a,b,l,n,p,q,r,48200,v,x,x+(I<<3)|0,x+(I+K<<3)|0,x+(I+(K<<1)<<3)|0,48336)|0;h[5997]=0.0;K=c[a>>2]|0;c[11968]=1;if((K|0)<1){ab=0.0}else{oa=0.0;I=1;while(1){bb=+h[v+(I+ -1<<3)>>3];cb=oa+bb*bb;h[5997]=cb;if((I|0)<(K|0)){I=I+1|0;oa=cb}else{break}}h[A>>3]=bb;c[11968]=K+1;ab=cb}oa=+h[6025];h[A>>3]=oa;ea=+V(+ab);O=oa<=ea?oa:ea;h[6032]=O;ea=+h[5998];if(!(O<+h[6004]*ea)){db=ab;U=62;break}c[12016]=-1;O=+h[6035];N=O*oa;h[6025]=N;h[6033]=-1.0;if(!(N<=ea*1.5)){eb=N}else{h[6025]=ea;eb=ea}if((c[11976]|0)<=((c[12060]|0)+2|0)){Ia=-1;Ja=eb;Ka=O;U=286;continue}N=ea*+h[6042]*.125*ea;h[6009]=N;oa=+h[6020];ba=+h[6021];na=oa>=ba?oa:ba;h[A>>3]=na;ba=+h[6022];if(!(N<=(na>=ba?na:ba))){fb=-1;gb=O;hb=ea}else{Ia=-1;Ja=eb;Ka=O;U=286;continue}}else if((U|0)==286){U=0;O=Ja*Ja*4.0;h[6044]=O;I=c[b>>2]|0;c[11972]=1;if((I|0)<1){ib=Ia}else{F=1;ea=O;ca=Ia;while(1){h[6001]=0.0;X=c[a>>2]|0;c[11970]=1;if((X|0)<1){jb=0.0}else{O=0.0;Va=1;while(1){ba=+h[n+((fa(Va,B)|0)+C+F<<3)>>3];kb=ba- +h[l+(Va+ -1<<3)>>3];lb=O+kb*kb;h[6001]=lb;if((Va|0)<(X|0)){Va=Va+1|0;O=lb}else{break}}h[A>>3]=kb;c[11970]=X+1;jb=lb}if(jb>ea){c[12016]=F;h[6044]=jb;mb=jb;nb=F}else{mb=ea;nb=ca}Va=F+1|0;c[11972]=Va;if((F|0)<(I|0)){F=Va;ea=mb;ca=nb}else{break}}if((nb|0)>0){U=294;break}else{ib=nb}}if(+h[6033]>0.0){U=54;continue}ea=+h[6032];O=+h[5998];if((Ja>=ea?Ja:ea)>O){U=54;continue}else{fb=ib;gb=Ka;hb=O}}if(!(hb>+h[f>>3])){U=309;break}O=hb*+h[6004];h[6025]=O;ea=hb/+h[f>>3];h[6033]=ea;do{if(!(ea<=16.0)){if(!(ea<=250.0)){ba=gb*hb;h[5998]=ba;ob=ba;break}else{ba=+V(+ea);na=ba*+h[f>>3];h[5998]=na;ob=na;break}}else{na=+h[f>>3];h[5998]=na;ob=na}}while(0);h[6025]=O>=ob?O:ob;ca=c[g>>2]|0;if((ca|0)<=1){U=53;continue}if((ca|0)>2){FG(48440)|0;nG()|0}FG(48464)|0;WF(48560,47984,8)|0;WF(48560,47904,4)|0;nG()|0;FG(48488)|0;WF(48560,48096,8)|0;ca=c[a>>2]|0;c[11968]=1;if((ca|0)>=1){F=1;do{I=F+ -1|0;h[A>>3]=+h[k+(I<<3)>>3]+ +h[l+(I<<3)>>3];WF(48560,y,8)|0;I=c[11968]|0;F=I+1|0;c[11968]=F;}while((I|0)<(ca|0))}nG()|0;U=53}if((U|0)==294){U=0;O=Ka*+V(+mb);ea=+h[6004]*Ja;na=O<=ea?O:ea;h[A>>3]=na;ea=+h[5998];O=na>=ea?na:ea;h[6034]=O;ea=O*O;h[5997]=ea;db=ea;U=62}else if((U|0)==309){U=0;if(!((fb|0)==-1)){break a}}do{if((U|0)==62){U=0;ea=+h[6045];if(db<=ea*.001){h[6038]=ea*.25;ca=c[b>>2]|0;c[11972]=1;if((ca|0)>=1){F=1;while(1){h[6001]=0.0;I=c[a>>2]|0;c[11968]=1;if((I|0)<1){pb=0.0}else{ea=0.0;K=1;while(1){O=+h[n+((fa(K,B)|0)+C+F<<3)>>3];qb=ea+O*+h[l+(K+ -1<<3)>>3];h[6001]=qb;if((K|0)<(I|0)){K=K+1|0;ea=qb}else{break}}c[11968]=I+1;pb=qb}h[6009]=+h[r+(F+ -1<<3)>>3]*pb;ea=pb- +h[6004]*+h[6045];h[6001]=ea;h[x+((c[b>>2]|0)+ -1+F<<3)>>3]=ea;K=c[a>>2]|0;c[11968]=1;if((K|0)>=1){X=1;while(1){Va=fa(X,B)|0;L=n+(Va+C+F<<3)|0;aa=X+ -1|0;$=p+(aa<<3)|0;h[$>>3]=+h[$>>3]+ +h[6009]*+h[L>>3];$=l+(aa<<3)|0;h[L>>3]=+h[L>>3]- +h[6004]*+h[$>>3];L=w+(aa<<3)|0;h[L>>3]=+h[s+(F+E+(fa(X,D)|0)<<3)>>3];ea=+h[6001]*+h[n+(F+C+Va<<3)>>3]+ +h[6038]*+h[$>>3];$=x+(aa<<3)|0;h[$>>3]=ea;aa=X+(c[b>>2]|0)|0;c[11980]=aa;c[11970]=1;if((X|0)<1){rb=X+1|0}else{O=ea;Va=1;while(1){da=s+((fa(Va,D)|0)+E+aa<<3)|0;J=Va+ -1|0;h[da>>3]=+h[da>>3]+ +h[L>>3]*+h[x+(J<<3)>>3]+O*+h[w+(J<<3)>>3];if((Va|0)>=(X|0)){break}O=+h[$>>3];Va=Va+1|0}Va=X+1|0;c[11970]=Va;rb=Va}c[11968]=rb;if((X|0)<(K|0)){X=rb}else{break}}}X=F+1|0;c[11972]=X;if((F|0)<(ca|0)){F=X}else{break}}}F=c[12032]|0;c[11972]=1;if((F|0)>=1){ca=1;while(1){h[6019]=0.0;X=c[b>>2]|0;c[11968]=1;b:do{if((X|0)>=1){O=0.0;K=1;while(1){I=t+(K+C+(fa(ca,B)|0)<<3)|0;h[6019]=+h[I>>3]+O;h[x+(K+ -1<<3)>>3]=+h[x+((c[b>>2]|0)+ -1+K<<3)>>3]*+h[I>>3];I=K+1|0;c[11968]=I;if((K|0)>=(X|0)){break b}O=+h[6019];K=I}}}while(0);X=c[a>>2]|0;c[11970]=1;if((X|0)>=1){K=1;while(1){I=K+ -1|0;O=+h[6038]*+h[6019]*+h[l+(I<<3)>>3];h[6001]=O;Va=c[b>>2]|0;c[11968]=1;if((Va|0)<1){sb=O}else{$=fa(K,B)|0;ea=O;L=1;while(1){tb=ea+ +h[x+(L+ -1<<3)>>3]*+h[n+(L+C+$<<3)>>3];h[6001]=tb;if((L|0)<(Va|0)){L=L+1|0;ea=tb}else{break}}c[11968]=Va+1;sb=tb}h[w+(I<<3)>>3]=sb;if((ca|0)<(c[11992]|0)){h[6001]=-+h[6001]}L=c[b>>2]|0;c[11968]=1;if((L|0)>=1){$=fa(ca,B)|0;aa=fa(K,D)|0;J=1;while(1){da=s+(J+E+aa<<3)|0;h[da>>3]=+h[6001]*+h[t+(J+C+$<<3)>>3]+ +h[da>>3];if((J|0)<(L|0)){J=J+1|0}else{break}}c[11968]=L+1}J=K+1|0;c[11970]=J;if((K|0)<(X|0)){K=J}else{break}}}K=c[a>>2]|0;c[11968]=1;if((K|0)>=1){X=c[11992]|0;J=1;while(1){$=(c[b>>2]|0)+J|0;c[11980]=$;ea=+h[w+(J+ -1<<3)>>3];if((ca|0)<(X|0)){ub=-ea}else{ub=ea}h[6009]=ub;c[11970]=1;if((J|0)<1){vb=J+1|0}else{ea=ub;aa=1;while(1){I=s+((fa(aa,D)|0)+E+$<<3)|0;h[I>>3]=ea*+h[w+(aa+ -1<<3)>>3]+ +h[I>>3];if((aa|0)>=(J|0)){break}ea=+h[6009];aa=aa+1|0}aa=J+1|0;c[11970]=aa;vb=aa}c[11968]=vb;if((J|0)<(K|0)){J=vb}else{break}}}J=ca+1|0;c[11972]=J;if((ca|0)<(F|0)){ca=J}else{break}}}c[11974]=0;ca=c[a>>2]|0;c[11970]=1;if((ca|0)>=1){F=0;J=1;while(1){K=J+ -1|0;X=x+(K<<3)|0;h[X>>3]=0.0;aa=c[b>>2]|0;c[11972]=1;if((aa|0)>=1){$=fa(J,B)|0;L=l+(K<<3)|0;I=$+C|0;ea=0.0;Va=1;while(1){h[X>>3]=ea+ +h[r+(Va+ -1<<3)>>3]*+h[n+(Va+C+$<<3)>>3];da=n+(I+Va<<3)|0;h[da>>3]=+h[da>>3]- +h[6004]*+h[L>>3];if((Va|0)>=(aa|0)){break}ea=+h[X>>3];Va=Va+1|0}c[11972]=aa+1}c[11968]=1;if((J|0)<1){wb=F}else{Va=1;L=F;while(1){I=L+1|0;c[11974]=I;$=(Va|0)<(J|0);da=q+(L<<3)|0;if($){Na=Va+ -1|0;G=l+(Na<<3)|0;xb=p+(K<<3)|0;h[xb>>3]=+h[xb>>3]+ +h[da>>3]*+h[G>>3];yb=G;zb=Na}else{Na=Va+ -1|0;yb=l+(Na<<3)|0;zb=Na}Na=l+(K<<3)|0;G=p+(zb<<3)|0;h[G>>3]=+h[da>>3]*+h[Na>>3]+ +h[G>>3];h[da>>3]=+h[da>>3]+ +h[x+(zb<<3)>>3]*+h[Na>>3]+ +h[yb>>3]*+h[X>>3];Na=(c[b>>2]|0)+E|0;h[s+(Na+Va+(fa(J,D)|0)<<3)>>3]=+h[s+(Na+J+(fa(Va,D)|0)<<3)>>3];Na=Va+1|0;c[11968]=Na;if($){Va=Na;L=I}else{wb=I;break}}}L=J+1|0;c[11970]=L;if((J|0)<(ca|0)){F=wb;J=L}else{break}}}J=c[a>>2]|0;c[11970]=1;if((J|0)>=1){F=1;while(1){ca=F+ -1|0;L=k+(ca<<3)|0;h[L>>3]=+h[l+(ca<<3)>>3]+ +h[L>>3];h[l+(F+ -1<<3)>>3]=0.0;if((F|0)<(J|0)){F=F+1|0}else{break}}c[11970]=J+1}h[6045]=0.0}if((c[12016]|0)>0){F=(c[11986]|0)+ -1|0;cp(a,b,l,n,s,t,47968,u,48064,48272,v,48192,w,w+(c[b>>2]<<3)|0,x,x+(F<<3)|0,x+(F+(c[a>>2]|0)<<3)|0)|0}F=c[b>>2]|0;c[11972]=1;if((F|0)>=1){L=1;while(1){h[6010]=0.0;h[6011]=0.0;h[6001]=0.0;ca=c[a>>2]|0;c[11970]=1;if((ca|0)<1){Ab=0.0;Bb=0.0}else{Va=L+C|0;X=L+E|0;ea=0.0;O=0.0;na=0.0;K=1;while(1){ba=+h[n+((fa(K,B)|0)+C+L<<3)>>3];Cb=na+ba*+h[v+(K+ -1<<3)>>3];h[6010]=Cb;ba=+h[n+(Va+(fa(K,B)|0)<<3)>>3];aa=K+ -1|0;Db=O+ba*+h[l+(aa<<3)>>3];h[6011]=Db;ba=+h[s+(X+(fa(K,D)|0)<<3)>>3];N=ea+ba*+h[v+(aa<<3)>>3];h[6001]=N;if((K|0)<(ca|0)){K=K+1|0;na=Cb;O=Db;ea=N}else{break}}c[11970]=ca+1;Ab=Db;Bb=Cb}K=L+ -1|0;h[x+(K<<3)>>3]=Bb*(Bb*+h[6004]+Ab);h[w+(K<<3)>>3]=+h[6001];K=L+1|0;c[11972]=K;if((L|0)<(F|0)){L=K}else{break}}}h[6005]=0.0;L=c[12032]|0;c[11972]=1;if((L|0)>=1){F=1;while(1){h[6001]=0.0;J=c[b>>2]|0;c[11968]=1;if((J|0)<1){Eb=0.0}else{ea=0.0;K=1;while(1){O=+h[t+(K+C+(fa(F,B)|0)<<3)>>3];Fb=ea+O*+h[x+(K+ -1<<3)>>3];h[6001]=Fb;if((K|0)<(J|0)){K=K+1|0;ea=Fb}else{break}}c[11968]=J+1;Eb=Fb}ea=Eb*Eb;O=+h[6005];if((F|0)<(c[11992]|0)){h[6005]=O+ea;na=-Eb;h[6001]=na;Gb=na}else{h[6005]=O-ea;Gb=Eb}K=c[b>>2]|0;c[11968]=1;if((K|0)>=1){ca=fa(F,B)|0;ea=Gb;X=1;while(1){Va=w+(X+ -1<<3)|0;h[Va>>3]=+h[Va>>3]+ea*+h[t+(X+C+ca<<3)>>3];if((X|0)>=(K|0)){break}ea=+h[6001];X=X+1|0}c[11968]=K+1}X=F+1|0;c[11972]=X;if((F|0)<(L|0)){F=X}else{break}}}h[6013]=0.0;h[5992]=0.0;F=c[a>>2]|0;c[11970]=1;if((F|0)<1){Hb=0.0;Ib=0.0}else{ea=0.0;L=1;while(1){h[6001]=0.0;X=c[b>>2]|0;c[11968]=1;if((X|0)<1){Jb=0.0}else{ca=fa(L,D)|0;O=0.0;J=1;while(1){Kb=O+ +h[x+(J+ -1<<3)>>3]*+h[s+(J+E+ca<<3)>>3];h[6001]=Kb;if((J|0)<(X|0)){J=J+1|0;O=Kb}else{break}}c[11968]=X+1;Jb=Kb}J=L+ -1|0;ca=v+(J<<3)|0;h[6013]=ea+Jb*+h[ca>>3];K=L+(c[b>>2]|0)|0;c[11982]=K;Va=c[a>>2]|0;c[11972]=1;if((Va|0)<1){Lb=Jb}else{O=Jb;aa=1;while(1){na=+h[s+((fa(aa,D)|0)+E+K<<3)>>3];Mb=O+na*+h[v+(aa+ -1<<3)>>3];h[6001]=Mb;if((aa|0)<(Va|0)){aa=aa+1|0;O=Mb}else{break}}c[11972]=Va+1;Lb=Mb}h[w+(K+ -1<<3)>>3]=Lb;O=+h[6013]+ +h[6001]*+h[ca>>3];h[6013]=O;na=+h[5992]+ +h[ca>>3]*+h[l+(J<<3)>>3];h[5992]=na;aa=L+1|0;c[11970]=aa;if((L|0)<(F|0)){ea=O;L=aa}else{Hb=O;Ib=na;break}}}ea=+h[5997];h[6005]=+h[6005]+(Ib*Ib+ea*(Ib+(Ib+ +h[6045])+ea*+h[6004]))-Hb;L=w+((c[12030]|0)+ -1<<3)|0;h[L>>3]=+h[5995]+ +h[L>>3];L=c[12016]|0;if((L|0)<=0){break}ea=+h[w+(L+ -1<<3)>>3];h[A>>3]=ea;na=+h[5995]+ +h[6024]*+h[6005]/(ea*ea);h[6009]=na;if(!(na>=0.0)){Nb=-na}else{Nb=na}if(!(Nb<=.8)){break}L=c[u>>2]|0;bp(a,b,l,n,s,t,47968,u,48120,48064,v,x,w,48040,m,x+(L<<3)|0,x+((L*6|1)+ -1<<3)|0)|0}}while(0);L=c[a>>2]|0;c[11968]=1;if((L|0)>=1){F=1;while(1){aa=F+ -1|0;h[m+(aa<<3)>>3]=+h[l+(aa<<3)>>3]+ +h[v+(aa<<3)>>3];aa=F+ -1|0;h[d+(aa<<3)>>3]=+h[k+(aa<<3)>>3]+ +h[m+(aa<<3)>>3];if((F|0)<(L|0)){F=F+1|0}else{break}}c[11968]=L+1}F=c[11976]|0;aa=F+1|0;c[11976]=aa;if((F|0)>=(c[12086]|0)){T=aa;U=159;break a}}}do{if((U|0)==159){c[11976]=T+ -1;if((c[g>>2]|0)<=0){break}FG(48368)|0;nG()|0}else if((U|0)==190){if((c[g>>2]|0)<=0){break}FG(48416)|0;nG()|0}}while(0);Nb=+h[6012];if(Nb<=+h[5983]){U=c[a>>2]|0;c[11968]=1;if((U|0)<1){Ob=Nb}else{T=1;while(1){m=T+ -1|0;h[d+(m<<3)>>3]=+h[k+(m<<3)>>3]+ +h[l+(m<<3)>>3];if((T|0)<(U|0)){T=T+1|0}else{break}}c[11968]=U+1;Ob=+h[6012]}h[5983]=Ob}if((c[g>>2]|0)<=0){i=z;return 0}FG(48512)|0;WF(48560,47904,4)|0;nG()|0;FG(48536)|0;WF(48560,47864,8)|0;g=c[a>>2]|0;c[11968]=1;if((g|0)>=1){a=1;do{WF(48560,d+(a+ -1<<3)|0,8)|0;U=c[11968]|0;a=U+1|0;c[11968]=a;}while((U|0)<(g|0))}nG()|0;i=z;return 0}function Np(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0;g=i;j=c[e>>2]|0;e=~j;k=c[a>>2]|0;l=c[b>>2]|0;m=(k|0)>(l|0)?l:k;if((m|0)<2){n=k;o=l}else{l=0;k=2;while(1){if((k|0)>=2){IS(d+(j+(fa(j,l)|0)<<3)|0,0,(l<<3)+8|0)|0}if((k|0)<(m|0)){l=l+1|0;k=k+1|0}else{break}}n=c[a>>2]|0;o=c[b>>2]|0}b=o+1|0;if((n|0)>=(b|0)&(o|0)<(n|0)){k=(n|0)<1;l=n<<3;p=0;q=b;while(1){b=fa(q,j)|0;if(!k){IS(d+((fa(o+p|0,j)|0)<<3)|0,0,l|0)|0}h[d+(q+e+b<<3)>>3]=1.0;if((q|0)<(n|0)){p=p+1|0;q=q+1|0}else{break}}}if((m|0)<1){i=g;return 0}q=c[a>>2]|0;a=1;while(1){p=m-a|0;n=p+1|0;l=(p|0)<(q|0);o=fa(n,j)|0;if(l){k=o+e|0;b=n;while(1){r=d+(k+b<<3)|0;h[f+(b+ -1<<3)>>3]=+h[r>>3];h[r>>3]=0.0;if((b|0)<(q|0)){b=b+1|0}else{break}}}h[d+(n+e+o<<3)>>3]=1.0;b=f+(p<<3)|0;if(!(+h[b>>3]==0.0|l^1)){k=n;while(1){r=(fa(k,j)|0)+e|0;s=n;t=0.0;while(1){u=t+ +h[d+(r+s<<3)>>3]*+h[f+(s+ -1<<3)>>3];if((s|0)>=(q|0)){break}s=s+1|0;t=u}t=+h[b>>3];v=u/t;s=(fa(k,j)|0)+e|0;w=t;r=n;while(1){x=d+(s+r<<3)|0;h[x>>3]=+h[x>>3]-v*w;if((r|0)>=(q|0)){break}w=+h[f+(r<<3)>>3];r=r+1|0}if((k|0)<(q|0)){k=k+1|0}else{break}}}if((a|0)<(m|0)){a=a+1|0}else{break}}i=g;return 0}function Op(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0.0,S=0.0;j=i;i=i+16|0;n=j;o=j+8|0;p=c[e>>2]|0;e=~p;q=+Ep(48568);r=c[b>>2]|0;if((r|0)<1){s=r}else{t=1;while(1){u=+Fp(a,d+((fa(t,p)|0)-p<<3)|0);v=t+ -1|0;h[l+(v<<3)>>3]=u;h[k+(v<<3)>>3]=u;h[m+(v<<3)>>3]=u;if((c[f>>2]|0)!=0){c[g+(v<<2)>>2]=t}if((t|0)<(r|0)){t=t+1|0}else{break}}s=c[b>>2]|0}t=c[a>>2]|0;r=(t|0)>(s|0)?s:t;if((r|0)<1){i=j;return 0}else{w=1}while(1){do{if((c[f>>2]|0)!=0){t=c[b>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){break}else{x=w;y=w}while(1){z=+h[k+(x+ -1<<3)>>3]>+h[k+(y+ -1<<3)>>3]?x:y;if((x|0)<(t|0)){y=z;x=x+1|0}else{break}}if((z|0)==(w|0)){break}t=c[a>>2]|0;c[n>>2]=t;if((t|0)>=1){s=(fa(w,p)|0)+e|0;l=(fa(z,p)|0)+e|0;v=1;while(1){A=d+(s+v<<3)|0;u=+h[A>>3];B=d+(l+v<<3)|0;h[A>>3]=+h[B>>3];h[B>>3]=u;if((v|0)<(t|0)){v=v+1|0}else{break}}}v=w+ -1|0;t=z+ -1|0;h[k+(t<<3)>>3]=+h[k+(v<<3)>>3];h[m+(t<<3)>>3]=+h[m+(v<<3)>>3];l=g+(v<<2)|0;v=c[l>>2]|0;s=g+(t<<2)|0;c[l>>2]=c[s>>2];c[s>>2]=v}}while(0);c[n>>2]=1-w+(c[a>>2]|0);v=fa(w,p)|0;s=w+e|0;l=d+(s+v<<3)|0;u=+Fp(n,l);a:do{if(u==0.0){C=w+1|0;D=u}else{E=+h[l>>3];if(E<0.0){F=-u}else{F=u}t=c[a>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){G=E}else{B=v+e|0;A=w;while(1){H=d+(B+A<<3)|0;h[H>>3]=+h[H>>3]/F;if((A|0)<(t|0)){A=A+1|0}else{break}}G=+h[l>>3]}h[l>>3]=G+1.0;A=w+1|0;B=c[b>>2]|0;if((B|0)<(A|0)){C=A;D=F;break}c[n>>2]=B;if((w|0)>=(B|0)){C=A;D=F;break}H=A+e|0;I=v+e|0;J=t;K=B;B=A;while(1){c[o>>2]=J;L=(w|0)>(J|0);do{if(L){c[o>>2]=J}else{M=(fa(B,p)|0)+e|0;N=w;E=0.0;while(1){O=E+ +h[d+(I+N<<3)>>3]*+h[d+(M+N<<3)>>3];if((N|0)<(J|0)){E=O;N=N+1|0}else{break}}E=O/+h[l>>3];c[o>>2]=J;if(L){break}N=(fa(B,p)|0)+e|0;M=w;while(1){P=d+(N+M<<3)|0;h[P>>3]=+h[P>>3]-E*+h[d+(I+M<<3)>>3];if((M|0)<(J|0)){M=M+1|0}else{break}}}}while(0);do{if((c[f>>2]|0)==0){Q=K}else{L=B+ -1|0;M=k+(L<<3)|0;E=+h[M>>3];if(E==0.0){Q=K;break}N=fa(B,p)|0;R=+h[d+(s+N<<3)>>3]/E;S=1.0-R*R;R=E*+V(+(S<=0.0?0.0:S));h[M>>3]=R;P=m+(L<<3)|0;S=R/+h[P>>3];if(S*S*.05>q){Q=K;break}c[o>>2]=J-w;S=+Fp(o,d+(H+N<<3)|0);h[M>>3]=S;h[P>>3]=S;Q=c[n>>2]|0}}while(0);if((B|0)>=(Q|0)){C=A;D=F;break a}J=c[a>>2]|0;K=Q;B=B+1|0}}}while(0);h[k+(w+ -1<<3)>>3]=-D;if((w|0)<(r|0)){w=C}else{break}}i=j;return 0}function Pp(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;j=i;k=c[e>>2]|0;e=~k;l=c[b>>2]|0;b=l+ -1|0;if((l|0)<2){i=j;return 0}m=c[a>>2]|0;n=(m|0)<1;o=0.0;p=1;q=0.0;while(1){r=l-p|0;s=+h[f+(r+ -1<<3)>>3];t=!(s>=0.0);if(t){u=-s}else{u=s}if(u>1.0){v=1.0/s}else{v=o}if(t){w=-s}else{w=s}if(w>1.0){x=+V(+(1.0-v*v))}else{x=q}if(t){y=-s;z=!(s>=-1.0)?x:s}else{y=s;z=!(s<=1.0)?x:s}if(!(y<=1.0)){A=v}else{A=+V(+(1.0-z*z))}if(!n){t=(fa(r,k)|0)+e|0;r=fa(l,k)|0;B=1;while(1){C=d+(t+B<<3)|0;s=+h[C>>3];D=d+(B+e+r<<3)|0;E=+h[D>>3];h[D>>3]=z*s+A*E;h[C>>3]=A*s-z*E;if((B|0)<(m|0)){B=B+1|0}else{break}}}if((p|0)<(b|0)){o=A;p=p+1|0;q=z}else{break}}p=c[a>>2]|0;a=(p|0)<1;q=A;m=1;A=z;while(1){z=+h[g+(m+ -1<<3)>>3];n=!(z>=0.0);if(n){F=-z}else{F=z}if(F>1.0){G=1.0/z}else{G=q}if(n){H=-z}else{H=z}if(H>1.0){I=+V(+(1.0-G*G))}else{I=A}if(n){J=-z;K=!(z>=-1.0)?I:z}else{J=z;K=!(z<=1.0)?I:z}if(!(J<=1.0)){L=G}else{L=+V(+(1.0-K*K))}if(!a){n=(fa(m,k)|0)+e|0;f=fa(l,k)|0;B=1;while(1){r=d+(n+B<<3)|0;z=+h[r>>3];t=d+(B+e+f<<3)|0;o=+h[t>>3];h[t>>3]=L*o-K*z;h[r>>3]=L*z+K*o;if((B|0)<(p|0)){B=B+1|0}else{break}}}if((m|0)<(b|0)){q=L;m=m+1|0;A=K}else{break}}i=j;return 0}function Qp(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0;e=i;l=+Ep(48576);m=c[b>>2]|0;n=c[a>>2]|0;o=(fa(1-m+(n<<1)|0,m)|0)/2|0;p=o+(m-n)|0;if((m|0)<=(n|0)){q=m;r=p;while(1){h[j+(q+ -1<<3)>>3]=+h[d+(r+ -1<<3)>>3];if((q|0)<(n|0)){r=r+1|0;q=q+1|0}else{break}}}q=m+ -1|0;r=(m|0)<2;if(r){s=p}else{t=(q|0)>1?q:1;u=t+ -1|0;v=(m<<1)+o+(fa(u,m+ -3-n|0)|0)+ -2-n|0;o=XS(u|0,0,t+ -2|0,0)|0;t=QS(o|0,J&1|0,1)|0;o=p;p=1;while(1){u=m-p|0;w=o+ -1+u-n|0;x=u+ -1|0;h[j+(x<<3)>>3]=0.0;y=g+(x<<3)|0;z=+h[y>>3];do{if(!(z==0.0)){x=g+(q<<3)|0;A=+h[x>>3];if(!(A>=0.0)){B=-A}else{B=A}if(!(z>=0.0)){C=-z}else{C=z}do{if(!(B>=C)){D=A/z;E=.5/+V(+(D*D*.25+.25));F=D*E;if(!(F>=0.0)){G=-F}else{G=F}if(!(l*G>1.0)){H=F;I=E;K=1.0;break}H=F;I=E;K=1.0/F}else{F=z/A;E=.5/+V(+(F*F*.25+.25));D=F*E;H=E;I=D;K=D}}while(0);h[x>>3]=I*z+H*A;h[y>>3]=K;if((u|0)>(n|0)){break}else{L=u;M=w}while(1){N=d+(M+ -1<<3)|0;D=+h[N>>3];O=j+(L+ -1<<3)|0;E=+h[O>>3];h[O>>3]=I*D+H*E;h[N>>3]=H*D-I*E;if((L|0)<(n|0)){M=M+1|0;L=L+1|0}else{break}}}}while(0);if((p|0)<(q|0)){p=p+1|0;o=w}else{break}}s=v-n-t|0}if((n|0)>=1){t=g+(q<<3)|0;g=1;while(1){v=g+ -1|0;o=j+(v<<3)|0;h[o>>3]=+h[o>>3]+ +h[t>>3]*+h[f+(v<<3)>>3];if((g|0)<(n|0)){g=g+1|0}else{break}}}c[k>>2]=0;if(r){P=s}else{r=1;g=s;while(1){s=j+(r+ -1<<3)|0;I=+h[s>>3];n=d+(g+ -1<<3)|0;if(!(I==0.0)){H=+h[n>>3];if(!(H>=0.0)){Q=-H}else{Q=H}if(!(I>=0.0)){R=-I}else{R=I}do{if(!(Q>=R)){K=H/I;G=.5/+V(+(K*K*.25+.25));C=K*G;if(!(C>=0.0)){S=-C}else{S=C}if(!(l*S>1.0)){T=C;U=G;W=1.0;break}T=C;U=G;W=1.0/C}else{C=I/H;G=.5/+V(+(C*C*.25+.25));K=C*G;T=G;U=K;W=K}}while(0);w=c[a>>2]|0;a:do{if((r|0)<=(w|0)){K=I;G=H;f=r;t=g;while(1){h[j+(f+ -1<<3)>>3]=T*K-U*G;h[d+(t+ -1<<3)>>3]=T*G+U*K;if((f|0)>=(w|0)){break a}K=+h[j+(f<<3)>>3];G=+h[d+(t<<3)>>3];f=f+1|0;t=t+1|0}}}while(0);h[s>>3]=W}if(+h[n>>3]==0.0){c[k>>2]=1}w=1-r+g+(c[a>>2]|0)|0;if((r|0)<(q|0)){r=r+1|0;g=w}else{P=w;break}}}g=c[a>>2]|0;a=c[b>>2]|0;if((a|0)<=(g|0)){b=a;a=P;while(1){h[d+(a+ -1<<3)>>3]=+h[j+(b+ -1<<3)>>3];if((b|0)<(g|0)){a=a+1|0;b=b+1|0}else{break}}}if(!(+h[d+(P+ -1<<3)>>3]==0.0)){i=e;return 0}c[k>>2]=1;i=e;return 0}function Rp(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0;s=i;t=c[d>>2]|0;u=~t;h[6092]=.5;h[6110]=6.283185307179586;v=+h[l>>3];h[6105]=v*v;c[12206]=0;l=c[b>>2]|0;c[12224]=l;c[12222]=l;w=c[b>>2]|0;c[12146]=1;if((w|0)<1){x=l;y=0}else{z=1;while(1){A=z+ -1|0;h[n+(A<<3)>>3]=+h[e+(A<<3)>>3];if((z|0)<(w|0)){z=z+1|0}else{break}}c[12146]=w+1;x=l;y=0}a:while(1){w=c[b>>2]|0;c[12146]=1;if((w|0)>=1){z=1;while(1){h[p+(z+ -1<<3)>>3]=0.0;if((z|0)<(w|0)){z=z+1|0}else{break}}c[12146]=w+1}z=c[d>>2]|0;c[12150]=1;if((z|0)>=1){e=1;while(1){h[6096]=0.0;A=c[b>>2]|0;c[12148]=1;if((A|0)<1){B=0.0}else{v=0.0;C=1;while(1){D=+h[f+((fa(C,t)|0)+u+e<<3)>>3];E=v+D*+h[n+(C+ -1<<3)>>3];h[6096]=E;if((C|0)<(A|0)){C=C+1|0;v=E}else{break}}c[12148]=A+1;B=E}v=+h[k+(e+ -1<<3)>>3]*B;h[6096]=v;C=c[b>>2]|0;c[12146]=1;if((C|0)>=1){D=v;F=1;while(1){v=D*+h[f+((fa(F,t)|0)+u+e<<3)>>3];G=p+(F+ -1<<3)|0;h[G>>3]=+h[G>>3]+v;if((F|0)>=(C|0)){break}D=+h[6096];F=F+1|0}c[12146]=C+1}F=e+1|0;c[12150]=F;if((e|0)<(z|0)){e=F}else{break}}}c[12160]=0;e=c[b>>2]|0;c[12148]=1;if((e|0)>=1){z=1;w=0;while(1){if((z|0)<1){H=1;I=w}else{F=z+ -1|0;A=p+(F<<3)|0;G=n+(F<<3)|0;F=z+1|0;J=1;K=w;while(1){L=j+(K<<3)|0;if((J|0)<(z|0)){M=J+ -1|0;h[A>>3]=+h[A>>3]+ +h[L>>3]*+h[n+(M<<3)>>3];N=M}else{N=J+ -1|0}M=p+(N<<3)|0;h[M>>3]=+h[L>>3]*+h[G>>3]+ +h[M>>3];if((J|0)<(z|0)){J=J+1|0;K=K+1|0}else{break}}K=z+w|0;c[12160]=K;H=F;I=K}if((z|0)<(e|0)){z=z+1|0;w=I}else{break}}c[12146]=H;c[12148]=e+1}do{if((y|0)==0){h[6094]=0.0;h[6076]=0.0;w=c[b>>2]|0;c[12146]=1;if((w|0)>=1){z=1;while(1){h[m+(z+ -1<<3)>>3]=0.0;K=z+ -1|0;h[q+(K<<3)>>3]=0.0;D=+h[g+(K<<3)>>3]+ +h[p+(K<<3)>>3];h[o+(K<<3)>>3]=D;h[n+(K<<3)>>3]=-D;h[6076]=+h[6076]+D*D;if((z|0)<(w|0)){z=z+1|0}else{break}}c[12146]=w+1}h[r>>3]=0.0;D=+h[6076];if(D==0.0){O=55;break a}h[6081]=0.0;h[6084]=0.0;h[6079]=D;h[6099]=D;P=D;Q=0.0;R=0.0;S=+h[6105];T=0}else{if((y|0)>(x|0)){h[6078]=0.0;h[6085]=0.0;h[6086]=0.0;z=c[b>>2]|0;c[12146]=1;if((z|0)<1){U=0.0;W=0.0;Z=0.0}else{D=0.0;v=0.0;_=0.0;F=1;while(1){K=F+ -1|0;$=_+ +h[n+(K<<3)>>3]*+h[o+(K<<3)>>3];h[6078]=$;K=F+ -1|0;J=p+(K<<3)|0;aa=v+ +h[J>>3]*+h[n+(K<<3)>>3];h[6085]=aa;ba=D+ +h[J>>3]*+h[m+(K<<3)>>3];h[6086]=ba;if((F|0)<(z|0)){F=F+1|0;_=$;v=aa;D=ba}else{break}}c[12146]=z+1;U=ba;W=$;Z=aa}D=+h[6092];v=D*(+h[6089]-Z);h[6077]=v;_=+h[6082];ca=_+v;h[6093]=ca;h[6097]=ca;h[6095]=ca;c[12216]=0;a[48664]=1;da=+h[6110]/50.0;h[6096]=da;c[12146]=1;F=0;ea=ca;ga=ca;w=1;while(1){ha=+(w|0)*da;ia=+X(+ha);ja=+Y(+ha);ka=ia*(_+ia*v)+ja*(W+ia*U);do{if(ka<ea){h[6095]=ka;c[12216]=w;h[6106]=ga;la=w;ma=ka}else{if((w|0)!=(F+1|0)){la=F;ma=ea;break}h[6107]=ka;la=F;ma=ea}}while(0);K=w+1|0;if((K|0)<50){F=la;ea=ma;w=K;ga=ka}else{break}}h[6101]=ha;h[6087]=ia;h[6090]=ja;h[6098]=ka;c[12146]=50;h[6097]=ka;if((la|0)==49){h[6107]=ca;na=ca}else if((la|0)==0){h[6106]=ka;O=46}else{O=46}if((O|0)==46){O=0;na=+h[6107]}h[6101]=0.0;ga=+h[6106];if(ga!=na){ea=ga-ma;h[6106]=ea;ga=na-ma;h[6107]=ga;oa=D*(ea-ga)/(ea+ga);h[6101]=oa;pa=oa}else{pa=0.0}oa=da*(+(la|0)+pa);h[6101]=oa;ga=+X(+oa);h[6087]=ga;ea=+Y(+oa);h[6090]=ea;oa=ca-ga*(_+ga*v)-ea*(W+ga*U);h[6102]=oa;h[6079]=0.0;w=c[b>>2]|0;c[12146]=1;if((w|0)<1){qa=0.0;ra=oa}else{oa=ea;ea=ga;F=1;z=0;while(1){K=m+(z<<3)|0;h[K>>3]=ea*+h[K>>3]+oa*+h[n+(z<<3)>>3];K=F+ -1|0;J=q+(K<<3)|0;ga=+h[6087]*+h[J>>3]+ +h[6090]*+h[p+(K<<3)>>3];h[J>>3]=ga;sa=+h[o+(K<<3)>>3]+ga;ta=+h[6079]+sa*sa;h[6079]=ta;if((F|0)>=(w|0)){break}K=F;oa=+h[6090];ea=+h[6087];F=F+1|0;z=K}c[12146]=w+1;qa=ta;ra=+h[6102]}ea=ra+ +h[6094];h[6094]=ea;if((y|0)<(l|0)&ra/ea>.01){ua=qa;va=x}else{O=55;break a}}else{h[6085]=0.0;z=c[b>>2]|0;c[12148]=1;do{if((z|0)<1){ea=+h[6109];h[6100]=ea;wa=ea;xa=0.0;O=11}else{ea=0.0;F=1;while(1){K=F+ -1|0;ya=ea+ +h[n+(K<<3)>>3]*+h[p+(K<<3)>>3];h[6085]=ya;if((F|0)<(z|0)){F=F+1|0;ea=ya}else{break}}c[12148]=z+1;ea=+h[6109];h[6100]=ea;if(!(ya>0.0)){wa=ea;xa=ya;O=11;break}ea=ya/+h[6076];h[6096]=ea;if((y|0)==1){h[r>>3]=ea;za=ea;Aa=+h[6096]}else{za=+h[r>>3];Aa=ea}h[r>>3]=!(za<=Aa)?Aa:za;ea=+h[6100];oa=+h[6079];v=+h[6085];_=oa/v;ca=ea<=_?ea:_;h[6100]=ca;Ba=oa;Ca=v;Da=ca}}while(0);if((O|0)==11){O=0;Ba=+h[6079];Ca=xa;Da=wa}ca=Da*(Ba-Da*+h[6092]*Ca);h[6091]=ca;h[6094]=+h[6094]+ca;h[6104]=Ba;h[6079]=0.0;z=c[b>>2]|0;c[12146]=1;if((z|0)<1){Ea=Da;Fa=0.0}else{w=1;ca=Da;while(1){F=w+ -1|0;K=m+(F<<3)|0;h[K>>3]=+h[K>>3]+ca*+h[n+(F<<3)>>3];F=w+ -1|0;K=q+(F<<3)|0;v=+h[K>>3]+ +h[6100]*+h[p+(F<<3)>>3];h[K>>3]=v;oa=+h[o+(F<<3)>>3]+v;Ga=+h[6079]+oa*oa;h[6079]=Ga;Ha=+h[6100];if((w|0)<(z|0)){ca=Ha;w=w+1|0}else{break}}c[12146]=z+1;Ea=Ha;Fa=Ga}if(Ea<+h[6109]){if(+h[6091]<=+h[6094]*.01){O=55;break a}if(Fa<=+h[6099]*1.0e-4|(y|0)==(l|0)){O=55;break a}ca=Fa/+h[6104];h[6096]=ca;h[6076]=0.0;h[6081]=0.0;h[6084]=0.0;w=c[b>>2]|0;c[12146]=1;if((w|0)<1){O=55;break a}else{Ia=ca;Ja=1;Ka=0}while(1){F=n+(Ka<<3)|0;h[F>>3]=Ia*+h[F>>3]- +h[o+(Ka<<3)>>3]- +h[q+(Ka<<3)>>3];F=Ja+ -1|0;K=n+(F<<3)|0;ca=+h[K>>3];La=+h[6076]+ca*ca;h[6076]=La;J=m+(F<<3)|0;Ma=+h[6081]+ +h[K>>3]*+h[J>>3];h[6081]=Ma;ca=+h[J>>3];Na=+h[6084]+ca*ca;h[6084]=Na;if((Ja|0)>=(w|0)){break}J=Ja;Ia=+h[6096];Ja=Ja+1|0;Ka=J}c[12146]=w+1;if(Ma<=0.0){O=55;break a}ca=+h[6105];if(Na<ca){P=La;Q=Ma;R=Na;S=ca;T=y;break}}h[r>>3]=0.0;c[12222]=y;ua=+h[6079];va=y}if(ua<=+h[6099]*1.0e-4){O=55;break a}h[6082]=0.0;h[6089]=0.0;z=c[b>>2]|0;c[12146]=1;if((z|0)<1){Oa=0.0;Pa=0.0}else{ca=0.0;oa=0.0;J=1;while(1){K=J+ -1|0;Qa=oa+ +h[m+(K<<3)>>3]*+h[o+(K<<3)>>3];h[6082]=Qa;K=J+ -1|0;Ra=ca+ +h[m+(K<<3)>>3]*+h[q+(K<<3)>>3];h[6089]=Ra;if((J|0)<(z|0)){J=J+1|0;oa=Qa;ca=Ra}else{break}}c[12146]=z+1;Oa=Ra;Pa=Qa}ca=Pa+Oa;h[6088]=ca;oa=+h[6105];v=ua*oa;if(ca/+V(+v)<=-.99){O=55;break a}J=y+1|0;c[12206]=J;_=+V(+(v-ca*ca));h[6096]=_;v=oa/_;h[6106]=v;oa=ca/_;h[6107]=oa;w=c[b>>2]|0;c[12146]=1;if((w|0)<1){x=va;y=J;continue a}else{Sa=oa;Ta=v;Ua=1;Va=0}while(1){h[n+(Va<<3)>>3]=Ta*(+h[o+(Va<<3)>>3]+ +h[q+(Va<<3)>>3])-Sa*+h[m+(Va<<3)>>3];if((Ua|0)>=(w|0)){break}K=Ua;Sa=+h[6107];Ta=+h[6106];Ua=Ua+1|0;Va=K}c[12146]=w+1;x=va;y=J;continue a}}while(0);e=T+1|0;c[12206]=e;v=S-R;h[6096]=v;h[6109]=v/(Q+ +V(+(Q*Q+v*P)));y=e;x=x}if((O|0)==55){i=s;return 0}return 0}function Sp(b,d,e,f,g,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0,R=0;o=i;p=c[d>>2]|0;q=~p;r=c[j>>2]|0;j=~r;h[6119]=1.0;s=p-(c[b>>2]|0)|0;t=s+ -1|0;c[12244]=t;c[12234]=1;c[12228]=2;if((s|0)<3){u=1}else{s=2;v=1;while(1){do{if((s|0)==(c[g>>2]|0)){c[12234]=s;w=s}else{x=c[m>>2]|0;y=fa(s,p)|0;z=+h[f+(y+q+x<<3)>>3];if(!(z!=0.0)){w=v;break}A=fa(v,p)|0;B=x+q|0;x=f+(B+A<<3)|0;C=+h[x>>3];D=+V(+(z*z+C*C));h[6121]=D;C=+h[x>>3]/D;h[6128]=C;z=+h[f+(B+y<<3)>>3]/D;h[6129]=z;B=c[d>>2]|0;c[12226]=1;if((B|0)>=1){D=z;z=C;x=1;while(1){E=x+q|0;h[6121]=z*+h[f+(E+A<<3)>>3]+D*+h[f+(E+y<<3)>>3];E=x+q|0;F=f+(E+y<<3)|0;G=f+(E+A<<3)|0;h[F>>3]=z*+h[F>>3]-D*+h[G>>3];h[G>>3]=+h[6121];if((x|0)>=(B|0)){break}D=+h[6129];z=+h[6128];x=x+1|0}c[12226]=B+1}h[f+((c[m>>2]|0)+q+y<<3)>>3]=0.0;w=v}}while(0);x=s+1|0;c[12228]=x;if((s|0)<(t|0)){s=x;v=w}else{u=w;break}}}w=c[m>>2]|0;z=+h[f+(w+ -1<<3)>>3];h[6128]=z;if((c[g>>2]|0)>1){D=-z;h[6128]=D;H=D}else{H=z}v=(u|0)>1;if(v){h[6129]=+h[f+((fa(u,p)|0)+q+w<<3)>>3]}w=c[d>>2]|0;c[12226]=1;if((w|0)>=1){s=(fa(u,p)|0)+q|0;z=H;t=1;x=0;while(1){h[n+(x<<3)>>3]=z*+h[f+(x<<3)>>3];if(v){A=n+(t+ -1<<3)|0;h[A>>3]=+h[A>>3]+ +h[6129]*+h[f+(s+t<<3)>>3]}if((t|0)>=(w|0)){break}A=t;z=+h[6128];t=t+1|0;x=A}c[12226]=w+1}w=(c[m>>2]|0)+ -1|0;z=+h[n+(w<<3)>>3];h[6126]=z;x=k+(w<<3)|0;H=+h[x>>3];h[6120]=H;D=H*H;h[6130]=D;h[6127]=D+z*+h[l>>3];h[x>>3]=+h[x>>3]- +h[6119];a[48984]=0;do{if((u|0)==1){z=+h[6127];if(!(z>=0.0)){I=-z}else{I=z}z=+V(+I);h[6121]=z;D=+h[6128]/z;h[6129]=D;H=+h[6120]/z;h[6128]=H;x=c[d>>2]|0;c[12226]=1;if((x|0)<1){J=z}else{z=D;D=H;w=1;t=0;while(1){s=f+(t<<3)|0;h[s>>3]=D*+h[s>>3]-z*+h[k+(t<<3)>>3];if((w|0)>=(x|0)){break}s=w;z=+h[6129];D=+h[6128];w=w+1|0;t=s}c[12226]=x+1;J=+h[6121]}t=c[g>>2]|0;if((t|0)==1&J<0.0){c[g>>2]=2;K=2}else{K=t}if(!((K|0)<2|!(J>=0.0))){L=46}}else{c[12230]=1;if(!(+h[l>>3]>=0.0)){M=1}else{c[12230]=u;M=u}t=u+1-M|0;c[12232]=t;w=fa(t,p)|0;t=(c[m>>2]|0)+q|0;D=+h[6127];z=+h[f+(t+w<<3)>>3]/D;h[6121]=z;h[6128]=z*+h[l>>3];H=+h[6120];h[6129]=z*H;s=fa(M,p)|0;z=+h[f+(t+s<<3)>>3];h[6121]=z;C=+h[l>>3];if(!(C>=0.0)){N=-C}else{N=C}C=+h[6119]/+V(+(+h[6130]+z*N*z));h[6124]=C;if(!(D>=0.0)){O=-D}else{O=D}h[6125]=C*+V(+O);t=c[d>>2]|0;c[12226]=1;if((t|0)<1){P=D}else{D=z;z=H;H=C;v=1;while(1){A=f+(v+q+s<<3)|0;h[A>>3]=H*(z*+h[A>>3]-D*+h[k+(v+ -1<<3)>>3]);A=f+(v+q+w<<3)|0;G=v+ -1|0;h[A>>3]=+h[6125]*(+h[A>>3]- +h[6128]*+h[n+(G<<3)>>3]- +h[6129]*+h[k+(G<<3)>>3]);if((v|0)>=(t|0)){break}D=+h[6121];z=+h[6120];H=+h[6124];v=v+1|0}c[12226]=t+1;P=+h[6127]}if(!(P<=0.0)){break}H=+h[l>>3];if(H<0.0){c[g>>2]=(c[g>>2]|0)+1}if(H>=0.0){L=46}}}while(0);do{if((L|0)==46){a[48984]=1;c[g>>2]=(c[g>>2]|0)+ -1;M=c[d>>2]|0;c[12226]=1;if((M|0)<1){break}else{Q=1}while(1){u=f+(Q+ -1<<3)|0;h[6121]=+h[u>>3];K=f+(Q+q+(fa(c[g>>2]|0,p)|0)<<3)|0;h[u>>3]=+h[K>>3];h[K>>3]=+h[6121];K=Q+1|0;c[12226]=K;if((Q|0)<(M|0)){Q=K}else{break}}}}while(0);Q=c[b>>2]|0;c[12228]=1;if((Q|0)<1){i=o;return 0}else{R=1}while(1){b=(c[d>>2]|0)+R|0;c[12236]=b;p=fa(R,r)|0;P=+h[e+((c[m>>2]|0)+j+p<<3)>>3];g=b+ -1|0;q=n+(g<<3)|0;h[q>>3]=P;f=k+(g<<3)|0;O=+h[6120];N=+h[6127];J=(+h[6126]*+h[f>>3]-O*P)/N;h[6128]=J;P=(-(+h[l>>3]*+h[q>>3])-O*+h[f>>3])/N;h[6129]=P;c[12226]=1;a:do{if((b|0)>=1){N=P;O=J;f=1;while(1){q=e+(f+j+p<<3)|0;g=f+ -1|0;I=+h[q>>3]+O*+h[k+(g<<3)>>3]+N*+h[n+(g<<3)>>3];h[q>>3]=I;q=c[d>>2]|0;if((f|0)>(q|0)){h[e+((fa(f-q|0,r)|0)+j+b<<3)>>3]=I}q=f+1|0;c[12226]=q;if((f|0)>=(b|0)){break a}N=+h[6129];O=+h[6128];f=q}}}while(0);b=R+1|0;c[12228]=b;if((R|0)<(Q|0)){R=b}else{break}}i=o;return 0}function Tp(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0;m=i;if((b|0)<(d|0)){n=(b|0)<(e|0);o=0.0;p=-1;q=-1;r=b;while(1){if(n){s=c[f+(r<<2)>>2]|0;t=b;u=o;v=p;w=q;while(1){x=+U(+(+h[a+((fa(c[g+(t<<2)>>2]|0,d)|0)+s<<3)>>3]));y=x>u;z=y?r:w;A=y?t:v;B=y?x:u;y=t+1|0;if((y|0)<(e|0)){w=z;v=A;u=B;t=y}else{C=B;D=A;E=z;break}}}else{C=o;D=p;E=q}t=r+1|0;if((t|0)<(d|0)){o=C;p=D;q=E;r=t}else{F=C;G=D;H=E;break}}}else{F=0.0;G=-1;H=-1}if((G|H|0)<0){I=-1;i=m;return I|0}c[j>>2]=H;c[k>>2]=G;h[l>>3]=F;I=0;i=m;return I|0}function Up(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;m=(b|0)<=(d|0)?b:d;if((m|0)>0){n=0}else{o=0;i=g;return o|0}while(1){p=e+(n<<2)|0;q=f+(n<<2)|0;r=+h[a+((fa(c[q>>2]|0,b)|0)+(c[p>>2]|0)<<3)>>3];if((Tp(a,n,b,d,e,f,j,k,l)|0)!=0){o=-1;s=14;break}t=+U(+r);if(+h[l>>3]>t*1.125){u=c[p>>2]|0;v=e+(c[j>>2]<<2)|0;c[p>>2]=c[v>>2];c[v>>2]=u;u=c[q>>2]|0;v=f+(c[k>>2]<<2)|0;c[q>>2]=c[v>>2];c[v>>2]=u}u=c[p>>2]|0;p=fa(c[q>>2]|0,b)|0;t=+h[a+(p+u<<3)>>3];if(!(t!=0.0)){s=7;break}q=n+1|0;if((q|0)<(b|0)){v=(q|0)<(d|0);w=q;do{x=c[e+(w<<2)>>2]|0;y=a+(p+x<<3)|0;r=+h[y>>3];do{if(r!=0.0){z=-r/t;h[y>>3]=0.0;if(v){A=q}else{break}do{B=fa(c[f+(A<<2)>>2]|0,b)|0;C=a+(B+x<<3)|0;h[C>>3]=+h[C>>3]+z*+h[a+(u+B<<3)>>3];A=A+1|0;}while((A|0)<(d|0))}}while(0);w=w+1|0;}while((w|0)<(b|0))}if((q|0)<(m|0)){n=q}else{o=0;s=14;break}}if((s|0)==7){bb(49048,49064,116,49088)}else if((s|0)==14){i=g;return o|0}return 0}function Vp(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=e;c[u>>2]=0;v=b+280|0;w=c[v>>2]|0;x=1;while(1){y=x+1|0;if((AS(w,c[49096+(x<<2)>>2]|0)|0)==0){z=4;break}if((y|0)<8){x=y}else{break}}do{if((z|0)==4){c[u>>2]=x;if((x|0)==0){break}y=c[49200+(x<<2)>>2]|0;c[q>>2]=c[49096+(x<<2)>>2];c[q+4>>2]=y;Rn(23,0,49272,q);y=b+112|0;A=e+28|0;c[A>>2]=(c[y>>2]|0)+20;B=c[y>>2]|0;C=b+160|0;D=((c[C>>2]|0)*3|0)+50+(fa(B+9|0,B)|0)|0;c[e+32>>2]=D;B=cS(D,8)|0;c[e+40>>2]=B;D=b+536|0;Un(c[D>>2]|0,(B|0)!=0|0,49312,p);B=cS(c[A>>2]|0,4)|0;c[e+36>>2]=B;Un(c[D>>2]|0,(B|0)!=0|0,49312,o);c[e+56>>2]=c[C>>2];c[e+52>>2]=0;c[e+60>>2]=cS(c[C>>2]|0,4)|0;c[e+24>>2]=aS(8)|0;C=aS(4)|0;c[e+20>>2]=C;c[C>>2]=c[21288>>2];Un(c[D>>2]|0,(C|0)!=0|0,49312,n);C=c[y>>2]<<3;B=e+48|0;c[B>>2]=aS(C)|0;A=e+44|0;c[A>>2]=aS(C)|0;C=cS(15,4)|0;E=e+12|0;c[E>>2]=C;Un(c[D>>2]|0,(C|0)!=0|0,49312,m);C=cS(5,4)|0;c[e+4>>2]=C;Un(c[D>>2]|0,(C|0)!=0|0,49312,l);C=cS(5,4)|0;c[e+8>>2]=C;Un(c[D>>2]|0,(C|0)!=0|0,49312,k);c[e+16>>2]=0;h[e+64>>3]=1.4901161193847656e-8;C=c[y>>2]<<3;c[e+72>>2]=aS(C)|0;c[e+76>>2]=aS(C)|0;c[e+80>>2]=aS(C)|0;C=c[E>>2]|0;c[C+8>>2]=1;D=c[u>>2]|0;a:do{switch(D|0){case 7:case 1:case 2:case 4:case 5:case 3:{if(($d[c[(c[b+540>>2]|0)+140>>2]&127](b)|0)==0){F=c[E>>2]|0;c[F+16>>2]=1;G=F;H=c[u>>2]|0;z=17;break a}if((c[y>>2]|0)==1){Rn(23,0,49328,j)}else{Rn(1,0,49400,g)}c[u>>2]=6;z=18;break};default:{G=C;H=D;z=17}}}while(0);if((z|0)==17){if((H|0)==2){I=G}else{z=18}}if((z|0)==18){a[d+28|0]=1;I=c[E>>2]|0}c[I+4>>2]=1;D=c[y>>2]|0;if((D|0)<=0){i=f;return 0}C=b+272|0;F=c[A>>2]|0;J=c[b+8>>2]|0;K=c[B>>2]|0;L=0;do{h[F+(L<<3)>>3]=+h[C>>3];h[K+(L<<3)>>3]=+h[C>>3]*+h[J+(L*112|0)+80>>3];L=L+1|0;}while((L|0)<(D|0));i=f;return 0}}while(0);if((c[21324>>2]|c[5306]|0)==0){M=w;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=4;U=T;V=49232;W=V;Vn(Q,W,r)}c[t>>2]=w;Tn(23,1,49128,t);t=1;do{w=c[49200+(t<<2)>>2]|0;c[s>>2]=c[49096+(t<<2)>>2];c[s+4>>2]=w;Tn(23,0,49184,s);t=t+1|0;}while((t|0)<8);Yd[c[5446]&255](23);M=c[v>>2]|0;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=4;U=T;V=49232;W=V;Vn(Q,W,r);return 0}function Wp(a){a=a|0;var b=0;b=i;bS(c[a+40>>2]|0);bS(c[a+36>>2]|0);bS(c[a+20>>2]|0);bS(c[a+12>>2]|0);bS(c[a+4>>2]|0);bS(c[a+8>>2]|0);bS(a);i=b;return 0}function Xp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;h[D>>3]=0.0;E=a+4|0;F=c[E>>2]|0;G=c[F>>2]|0;H=c[b+48>>2]|0;I=(c[F+4>>2]|0)+8|0;F=c[I>>2]|0;J=a+112|0;K=c[J>>2]|0;L=F+(K<<3)|0;M=H+24|0;c[c[M>>2]>>2]=a;c[(c[M>>2]|0)+4>>2]=H;N=a+536|0;Un(c[N>>2]|0,(c[M>>2]|0)!=0|0,49496,C);if((c[b+36>>2]|0)!=0){c[c[H+12>>2]>>2]=0;c[H+16>>2]=0}C=b;O=+h[C>>3];P=b+8|0;Q=O+ +h[P>>3];h[D>>3]=Q;if(O-Q>=-1.0e-13){Rn(3,0,49528,B);Rn(3,0,49568,A);A=c[J>>2]|0;if((A|0)>0){B=c[I>>2]|0;I=c[G+8>>2]|0;R=0;do{h[I+(R<<3)>>3]=+h[B+(R<<3)>>3]+ +h[F+(R+K<<3)>>3]*+h[P>>3];R=R+1|0;}while((R|0)<(A|0))}h[G>>3]=+h[D>>3];$d[c[(c[a+540>>2]|0)+28>>2]&127](a)|0;h[C>>3]=+h[D>>3];S=0;i=d;return S|0}A=z;h[k>>3]=O;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Rn(3,0,49592,z);z=H+16|0;A=z;R=a;P=b+24|0;b=H+12|0;K=H+44|0;F=H+48|0;B=H+40|0;I=H+32|0;T=H+36|0;U=H+28|0;V=U;W=H+20|0;X=H+52|0;Y=H+56|0;Z=H+60|0;_=c[r>>2]|0;$=c[t>>2]|0;aa=a+248|0;ba=a+540|0;ca=G;G=L;a:while(1){Q=+h[D>>3];L=y;h[k>>3]=+h[C>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=y+8|0;h[k>>3]=Q;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];Rn(23,0,49632,y);if((c[z>>2]|0)==1){Ko(c[R>>2]|0,1,c[E>>2]|0);L=c[E>>2]|0;da=c[L>>2]|0;ea=(c[(c[L+4>>2]|0)+8>>2]|0)+(c[J>>2]<<3)|0;h[da>>3]=+h[C>>3];fa=da;ga=ea}else{fa=ca;ga=G}if((c[P>>2]|0)!=5){Tr(a)|0;$d[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ea=c[H>>2]|0;b:do{switch(ea|0){case 5:{ep(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,5,2,Y,c[Z>>2]|0)|0;break};case 7:{ep(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,7,3,X,0)|0;break};case 6:{ep(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,6,2,Y,c[Z>>2]|0)|0;break};case 4:{ep(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,4,2,Y,c[Z>>2]|0)|0;break};case 3:{ep(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,3,2,Y,c[Z>>2]|0)|0;break};default:{da=c[fa+8>>2]|0;L=c[b>>2]|0;ha=c[K>>2]|0;ia=c[F>>2]|0;ja=c[B>>2]|0;ka=c[T>>2]|0;la=c[M>>2]|0;ma=c[W>>2]|0;if((ea|0)==2){ep(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,3,X,0)|0;break b}else{ep(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,2,Y,c[Z>>2]|0)|0;break b}}}}while(0);ea=c[z>>2]|0;do{if((ea|0)==-1){md(_|0)|0;md($|0)|0;Tn(3,0,49664,x);Rn(3,0,49752,w);c[c[b>>2]>>2]=1}else{if((ea|0)<0){na=25;break a}if((ea|0)!=4){break}c[(c[N>>2]|0)+84>>2]=4}}while(0);ea=c[z>>2]|0;if((ea|0)==1){ca=fa;G=ga;continue}else if(!((ea|0)==-1)){na=31;break}Q=+h[C>>3];if(!(Q<=+h[aa>>3])){oa=Q;break}else{ca=fa;G=ga}}if((na|0)==25){md(_|0)|0;md($|0)|0;$=eq(c[z>>2]|0)|0;if((c[P>>2]|0)!=5){Tr(a)|0;$d[c[(c[ba>>2]|0)+40>>2]&127](a)|0}$d[c[(c[ba>>2]|0)+28>>2]&127](a)|0;a=v;h[k>>3]=+h[fa>>3];c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];Tn(1,0,49776,v);S=$;i=d;return S|0}else if((na|0)==31){oa=+h[C>>3]}h[fa>>3]=oa;if((c[21244>>2]|0)!=0){Rn(3,1,49808,u);c[s>>2]=c[z>>2];Rn(3,0,49832,s);s=q;h[k>>3]=+h[C>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];Rn(3,0,49856,q);q=p;h[k>>3]=+h[(c[B>>2]|0)+24>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];Rn(3,0,49888,p);p=o;h[k>>3]=+h[(c[B>>2]|0)+16>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Rn(3,0,49928,o);o=n;h[k>>3]=+h[(c[B>>2]|0)+48>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Rn(3,0,49976,n);c[m>>2]=c[(c[T>>2]|0)+40>>2];Rn(3,0,50024,m);c[l>>2]=c[(c[T>>2]|0)+44>>2];Rn(3,0,50064,l);c[j>>2]=c[(c[T>>2]|0)+48>>2];Rn(3,0,50104,j);c[g>>2]=c[(c[T>>2]|0)+52>>2];Rn(3,0,50144,g);c[f>>2]=c[(c[T>>2]|0)+56>>2];Rn(3,0,50192,f);Yd[c[5446]&255](3)}f=c[U>>2]|0;U=H+8|0;H=0;do{g=H+10|0;if(!(g>>>0<f>>>0)){na=37;break}c[(c[U>>2]|0)+(H<<2)>>2]=c[(c[T>>2]|0)+(g<<2)>>2];H=H+1|0;}while(H>>>0<5);if((na|0)==37){bb(50232,50264,410,50296)}Rn(3,0,50312,e);S=0;i=d;return S|0}function Yp(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;f=c[g>>2]|0;g=f;b=f+536|0;k=f+4|0;l=c[c[k>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[a>>3];a=(c[b>>2]|0)+84|0;l=c[a>>2]|0;c[a>>2]=2;Tr(g)|0;a=f+540|0;$d[c[(c[a>>2]|0)+40>>2]&127](g)|0;$d[c[(c[a>>2]|0)+28>>2]&127](g)|0;g=c[f+112>>2]|0;if((g|0)<=0){n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;a=0;do{h[e+(a<<3)>>3]=+h[f+(g+a<<3)>>3]- +h[d+(a<<3)>>3];a=a+1|0;}while((a|0)<(g|0));n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}function Zp(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;Tr(l)|0;b=k+540|0;$d[c[(c[b>>2]|0)+40>>2]&127](l)|0;$d[c[(c[b>>2]|0)+28>>2]&127](l)|0;gq(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function _p(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0;j=i;e=c[g>>2]|0;g=e;d=e+536|0;a=(c[d>>2]|0)+84|0;k=c[a>>2]|0;c[a>>2]=4;a=e+4|0;l=c[c[a>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[b>>3];Tr(g)|0;l=e+540|0;$d[c[(c[l>>2]|0)+40>>2]&127](g)|0;$d[c[(c[l>>2]|0)+28>>2]&127](g)|0;$d[c[(c[l>>2]|0)+32>>2]&127](g)|0;be[c[(c[l>>2]|0)+92>>2]&63](g,f,b)|0;c[(c[d>>2]|0)+84>>2]=k;h[c[c[a>>2]>>2]>>3]=m;i=j;return 0}function $p(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;hq(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function aq(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;Tr(l)|0;b=k+540|0;$d[c[(c[b>>2]|0)+40>>2]&127](l)|0;$d[c[(c[b>>2]|0)+28>>2]&127](l)|0;fq(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function bq(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;i=i;return 0}function cq(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;iq(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function dq(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i;return 0}function eq(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;c=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;switch(a|0){case-12:{Tn(1,0,50808,c);m=-12;i=b;return m|0};case-7:{Tn(1,0,50448,h);m=-7;i=b;return m|0};case-9:{Tn(1,0,50536,f);m=-9;i=b;return m|0};case-8:{Tn(1,0,50488,g);m=-8;i=b;return m|0};case-11:{Tn(1,0,50720,d);m=-11;i=b;return m|0};case-1:{Tn(3,0,49664,l);m=1;i=b;return m|0};case-10:{Tn(1,0,50624,e);m=-10;i=b;return m|0};case-33:{Tn(1,0,50856,b);m=-33;i=b;return m|0};case-2:{Tn(1,0,50336,k);m=-2;i=b;return m|0};case-3:{m=-3;i=b;return m|0};case-6:{Tn(1,0,50376,j);m=-6;i=b;return m|0};default:{m=-1;i=b;return m|0}}return 0}function fq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+540|0;f=c[(c[e>>2]|0)+120>>2]|0;g=a+464|0;j=c[g>>2]|0;if((c[j+(f*44|0)+24>>2]|0)==0){i=d;return 0}k=a;a=c[j+(f*44|0)>>2]|0;l=j;j=0;do{if((a|0)!=0){m=0;do{if(((c[(c[l+(f*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}$d[c[(c[e>>2]|0)+160>>2]&127](k)|0;l=c[g>>2]|0;a=c[l+(f*44|0)>>2]|0;do{if((a|0)!=0){m=c[l+(f*44|0)+28>>2]|0;n=0;do{do{if(+h[m+(n<<3)>>3]==1.0){if((n|0)==0){o=l+(f*44|0)+8|0;p=0}else{q=l+(f*44|0)+8|0;o=q;p=c[(c[q>>2]|0)+(n+ -1<<2)>>2]|0}q=c[(c[o>>2]|0)+(n<<2)>>2]|0;if(!(p>>>0<q>>>0)){break}r=c[l+(f*44|0)+12>>2]|0;s=c[l+(f*44|0)+4>>2]|0;t=c[l+(f*44|0)+36>>2]|0;u=p;do{v=c[r+(u<<2)>>2]|0;w=(fa(s,n)|0)+v|0;h[b+(w<<3)>>3]=+h[t+(v<<3)>>3];u=u+1|0;}while(u>>>0<q>>>0)}}while(0);n=n+1|0;}while(n>>>0<a>>>0);if((a|0)==0){break}n=c[l+(f*44|0)+20>>2]|0;m=0;do{if(((c[n+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=0.0}m=m+1|0;}while(m>>>0<a>>>0)}}while(0);j=j+1|0;}while(j>>>0<(c[l+(f*44|0)+24>>2]|0)>>>0);i=d;return 0}function gq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+540|0;f=c[e>>2]|0;g=c[f+120>>2]|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)>>2]|0)==0){i=d;return 0}l=a;a=f;f=c[k+(g*44|0)+28>>2]|0;k=0;m=0;while(1){h[f+(k<<3)>>3]=1.0;$d[c[a+160>>2]&127](l)|0;n=c[j>>2]|0;o=c[n+(g*44|0)+4>>2]|0;if((o|0)==0){p=m}else{q=o>>>0>1?o:1;r=c[n+(g*44|0)+36>>2]|0;s=0;t=m;while(1){h[b+(t<<3)>>3]=+h[r+(s<<3)>>3];u=s+1|0;if(u>>>0<o>>>0){t=t+1|0;s=u}else{break}}p=m+q|0}s=c[n+(g*44|0)+28>>2]|0;h[s+(k<<3)>>3]=0.0;t=k+1|0;if(!(t>>>0<(c[n+(g*44|0)>>2]|0)>>>0)){break}a=c[e>>2]|0;f=s;k=t;m=p}i=d;return 0}function hq(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;n=i;j=c[m+4>>2]|0;o=+h[j+64>>3];p=a+112|0;a=c[p>>2]|0;if((a|0)<=0){i=n;return 0}q=j+80|0;j=a;do{j=j+ -1|0;r=+h[k>>3]*+h[e+(j<<3)>>3];a=d+(j<<3)|0;s=+h[a>>3];if(!(s>=0.0)){t=-s}else{t=s}u=r>=0.0;if(u){v=r}else{v=-r}r=+ld(+t,+v);w=+h[l+(j<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}w=o*+ld(+r,+x);if(u){y=w}else{y=-w}w=y+s-s;r=1.0/w;h[a>>3]=s+w;Yp(b,0,e,c[q>>2]|0,0,m,0)|0;u=c[p>>2]|0;if((u|0)>0){z=c[q>>2]|0;A=fa(u,j)|0;B=u;do{B=B+ -1|0;h[g+(A+B<<3)>>3]=r*(+h[z+(B<<3)>>3]- +h[f+(B<<3)>>3]);}while((B|0)>0)}h[a>>3]=s;}while((j|0)>0);i=n;return 0}function iq(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;n=i;j=c[(c[a+540>>2]|0)+120>>2]|0;o=c[m+4>>2]|0;p=+h[o+64>>3];q=c[o+76>>2]|0;r=c[o+72>>2]|0;s=a+464|0;a=c[s>>2]|0;if((c[a+(j*44|0)+24>>2]|0)==0){i=n;return 0}t=o+80|0;o=c[a+(j*44|0)>>2]|0;u=a;a=0;do{if((o|0)!=0){v=0;do{if(((c[(c[u+(j*44|0)+20>>2]|0)+(v<<2)>>2]|0)+ -1|0)==(a|0)){w=+h[k>>3]*+h[e+(v<<3)>>3];x=d+(v<<3)|0;y=+h[x>>3];if(!(y>=0.0)){z=-y}else{z=y}A=w>=0.0;if(A){B=w}else{B=-w}w=+ld(+z,+B);y=+h[l+(v<<3)>>3];if(!(y>=0.0)){C=-y}else{C=y}y=p*+ld(+w,+C);D=q+(v<<3)|0;h[D>>3]=y;if(A){E=y}else{E=-y}h[D>>3]=E;y=+h[x>>3];h[D>>3]=E+y-y;h[r+(v<<3)>>3]=+h[x>>3];h[x>>3]=+h[D>>3]+ +h[x>>3];h[D>>3]=1.0/+h[D>>3]}v=v+1|0;}while(v>>>0<o>>>0)}Yp(b,0,e,c[t>>2]|0,0,m,0)|0;u=c[s>>2]|0;o=c[u+(j*44|0)>>2]|0;if((o|0)!=0){v=c[u+(j*44|0)+20>>2]|0;D=0;do{if(((c[v+(D<<2)>>2]|0)+ -1|0)==(a|0)){if((D|0)==0){F=u+(j*44|0)+8|0;G=0}else{x=u+(j*44|0)+8|0;F=x;G=c[(c[x>>2]|0)+(D+ -1<<2)>>2]|0}x=c[(c[F>>2]|0)+(D<<2)>>2]|0;if(G>>>0<x>>>0){A=c[t>>2]|0;H=q+(D<<3)|0;I=c[u+(j*44|0)+12>>2]|0;J=c[u+(j*44|0)+4>>2]|0;K=G;do{L=c[I+(K<<2)>>2]|0;M=(fa(J,D)|0)+L|0;h[g+(M<<3)>>3]=(+h[A+(L<<3)>>3]- +h[f+(L<<3)>>3])*+h[H>>3];K=K+1|0;}while(K>>>0<x>>>0)}h[d+(D<<3)>>3]=+h[r+(D<<3)>>3]}D=D+1|0;}while(D>>>0<o>>>0)}a=a+1|0;}while(a>>>0<(c[u+(j*44|0)+24>>2]|0)>>>0);i=n;return 0}function jq(a,b){a=a|0;b=+b;h[a+496>>3]=b;i=i;return}function kq(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0;e=i;Yd[c[(c[a+540>>2]|0)+112>>2]&255](a);f=a+328|0;h[f>>3]=d+1.0;g=c[a+104>>2]|0;if((g|0)<=0){i=e;return}j=c[a+108>>2]|0;k=a+336|0;a=0;do{d=+h[j+(a*24|0)+8>>3];if(d>b){h[(c[k>>2]|0)+(a<<3)>>3]=d;l=d}else{m=+h[j+(a*24|0)+16>>3];n=d+m*+ea(+((b-d)/m));h[(c[k>>2]|0)+(a<<3)>>3]=n;l=n}if((a|0)==0){o=8}else{if(l<+h[f>>3]){o=8}}if((o|0)==8){o=0;h[f>>3]=l}a=a+1|0;}while((a|0)<(g|0));i=e;return}function lq(b,c){b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0;d=i;e=+h[c>>3];f=c+8|0;g=+h[b+328>>3];if(!(g<=e+ +h[f>>3]+1.0e-14)){i=d;return}h[f>>3]=g-e;a[b+317|0]=1;i=d;return}function mq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;d=i;i=i+8|0;e=d;f=a+160|0;if((c[f>>2]|0)<=0){g=ao(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}l=a+540|0;m=a+344|0;n=a+348|0;o=a+368|0;a=0;do{ne[c[(c[l>>2]|0)+104>>2]&63](a,e)|0;p=+h[(c[m>>2]|0)+(a<<3)>>3];if(p==1.0){if(+h[(c[n>>2]|0)+(a<<3)>>3]==-1.0){q=7}else{q=5}}else{q=5}do{if((q|0)==5){q=0;if(!(p==-1.0)){break}if(+h[(c[n>>2]|0)+(a<<3)>>3]==1.0){q=7}}}while(0);if((q|0)==7){q=0;_n(b,(c[o>>2]|0)+(a<<2)|0)}a=a+1|0;}while((a|0)<(c[f>>2]|0));g=ao(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}function nq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;e=i;g=f+32|0;do{if((mq(b,c[g>>2]|0)|0)!=0){if((a[f+28|0]|0)!=0){break}oq(b,c[g>>2]|0,f)}}while(0);if((a[b+317|0]|0)==1){h=1;i=e;return h|0}b=(ao(d)|0)>0;h=b?2:0;i=e;return h|0}function oq(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=a+112|0;q=c[p>>2]<<3;r=aS(q)|0;s=r;t=aS(q)|0;q=t;h[n>>3]=+h[a+376>>3];u=a+4|0;h[o>>3]=+h[c[c[u>>2]>>2]>>3];c[12904]=Yn(4)|0;if((r|0)==0){bb(51624,51640,308,51672)}if((t|0)==0){bb(51688,51640,309,51672)}v=eo(b)|0;if((v|0)!=0){w=v;do{v=go(w)|0;c[l>>2]=c[v>>2];Rn(27,0,51704,l);w=fo(w)|0;}while((w|0)!=0)}w=c[p>>2]|0;if((w|0)>0){l=c[(c[c[u>>2]>>2]|0)+8>>2]|0;v=(w|0)>1?w<<3:8;GS(t|0,c[a+384>>2]|0,v|0)|0;GS(r|0,l|0,v|0)|0}h[d>>3]=+rq(a,n,o,q,s,c[12904]|0,b);do{if((ao(c[12904]|0)|0)==0){s=bo(b)|0;q=a+344|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));s=eo(b)|0;if((s|0)==0){y=x}else{v=s;z=x;while(1){s=go(v)|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));A=z>x?x:z;s=fo(v)|0;if((s|0)==0){y=A;break}else{z=A;v=s}}}v=j;h[k>>3]=y;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];Rn(27,0,51752,j);v=eo(b)|0;if((v|0)==0){break}else{B=v}do{v=go(B)|0;if(y==+U(+(+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]))){v=c[12904]|0;$n(v,go(B)|0);v=go(B)|0;c[g>>2]=c[v>>2];Rn(27,0,51776,g)}B=fo(B)|0;}while((B|0)!=0)}}while(0);Zn(b);if((c[21260>>2]|0)!=0){ao(c[12904]|0)|0}if((ao(c[12904]|0)|0)>0){B=m;do{g=bo(c[12904]|0)|0;c[m>>2]=c[g>>2];co(c[12904]|0);c[f>>2]=c[m>>2];Rn(7,0,51800,f);_n(b,B);}while((ao(c[12904]|0)|0)>0)}h[d>>3]=+h[o>>3];o=c[c[u>>2]>>2]|0;h[o>>3]=+h[n>>3];n=c[p>>2]|0;if((n|0)>0){GS(c[o+8>>2]|0,t|0,((n|0)>1?n<<3:8)|0)|0}Pe(a);uq(a);a=c[c[u>>2]>>2]|0;h[a>>3]=+h[d>>3];d=c[p>>2]|0;if((d|0)<=0){bS(t);bS(r);i=e;return}GS(c[a+8>>2]|0,r|0,((d|0)>1?d<<3:8)|0)|0;bS(t);bS(r);i=e;return}function pq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0;g=i;i=i+32|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+8|0;p=b+4|0;q=+h[c[c[p>>2]>>2]>>3];r=b+317|0;do{if((a[r]|0)!=0){yq(b);s=b+104|0;t=c[s>>2]|0;if((t|0)<=0){break}u=b+336|0;v=q+1.0e-14;w=b+340|0;x=b+108|0;y=t;t=0;while(1){if(!(+h[(c[u>>2]|0)+(t<<3)>>3]<=v)){z=y}else{a[(c[w>>2]|0)+t|0]=1;A=c[x>>2]|0;B=+h[A+(t*24|0)+8>>3];C=+h[A+(t*24|0)+16>>3];c[m>>2]=c[A+(t*24|0)>>2];A=m+4|0;h[k>>3]=B;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=m+12|0;h[k>>3]=C;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Rn(7,0,51344,m);z=c[s>>2]|0}A=t+1|0;if((A|0)<(z|0)){y=z;t=A}else{break}}}}while(0);z=b+512|0;m=b+524|0;t=b+516|0;y=b+528|0;c[y>>2]=(c[y>>2]|0)-(c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]|0);if((ao(d)|0)>0){h[c[c[p>>2]>>2]>>3]=+h[e>>3];do{if((c[21260>>2]|0)!=0){e=eo(d)|0;if((e|0)==0){break}p=b+540|0;s=e;do{e=go(s)|0;x=c[e>>2]|0;e=ne[c[(c[p>>2]|0)+104>>2]&63](x,n)|0;w=c[n>>2]|0;c[l>>2]=x;c[l+4>>2]=e;Qn(7,0,w,51368,l);s=fo(s)|0;}while((s|0)!=0)}}while(0);l=f+40|0;c[l>>2]=(c[l>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+1;c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=1;l=c[m>>2]|0;n=c[b+520>>2]|0;h[n+(l<<3)>>3]=q;s=b+532|0;do{if((c[s>>2]|0)==0){p=c[y>>2]|0;if((p|0)!=(c[z>>2]|0)){break}v=+h[n+(((l+1|0)%(p|0)|0)<<3)>>3];w=b+264|0;if(!(q-v<+h[w>>3])){break}e=go(eo(d)|0)|0;x=ne[c[(c[b+540>>2]|0)+104>>2]&63](c[e>>2]|0,o)|0;e=c[o>>2]|0;C=+h[w>>3];w=j;h[k>>3]=v;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=j+8|0;h[k>>3]=q;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[j+16>>2]=p;p=j+20|0;h[k>>3]=C;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[j+28>>2]=x;Qn(1,0,e,51384,j);c[s>>2]=1}}while(0);Zn(d)}else{c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=0}c[m>>2]=((c[m>>2]|0)+1|0)%(c[z>>2]|0)|0;tq(b);qq(b);if((a[r]|0)==0){i=g;return}z=b+104|0;m=c[z>>2]|0;do{if((m|0)>0){t=b+340|0;d=b+108|0;s=b+336|0;j=m;o=0;while(1){l=(c[t>>2]|0)+o|0;if((a[l]|0)==0){D=j}else{a[l]=0;l=(c[s>>2]|0)+(o<<3)|0;h[l>>3]=+h[(c[d>>2]|0)+(o*24|0)+16>>3]+ +h[l>>3];D=c[z>>2]|0}l=o+1|0;if((l|0)<(D|0)){j=D;o=l}else{break}}if((D|0)<=0){break}o=b+336|0;j=b+328|0;d=0;do{s=c[o>>2]|0;if((d|0)==0){E=+h[s>>3];F=29}else{q=+h[s+(d<<3)>>3];if(q<+h[j>>3]){E=q;F=29}}if((F|0)==29){F=0;h[j>>3]=E}d=d+1|0;}while((d|0)<(D|0))}}while(0);a[r]=0;r=f+44|0;c[r>>2]=(c[r>>2]|0)+1;i=g;return}function qq(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;Rn(27,0,51992,b);d=a+344|0;be[c[(c[a+540>>2]|0)+92>>2]&63](a,c[d>>2]|0,c[c[a+4>>2]>>2]|0)|0;e=c[a+160>>2]|0;if((e|0)<=0){i=b;return}f=c[d>>2]|0;d=c[a+348>>2]|0;a=0;do{h[d+(a<<3)>>3]=+h[f+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=b;return}function rq(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=a+160|0;p=c[o>>2]|0;q=aS(p<<3)|0;if((q|0)==0){bb(51808,51640,409,51824)}if((p|0)>0){GS(q|0,c[a+344>>2]|0,((p|0)>1?p<<3:8)|0)|0}r=+h[d>>3];p=n;h[k>>3]=+h[b>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=r;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Rn(27,0,51840,n);n=m;h[k>>3]=1.0e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Rn(27,0,51888,m);r=+h[d>>3];s=+h[b>>3];if(!(+U(+(r-s))>1.0e-9)){bS(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}m=a+4|0;n=a+112|0;p=a+540|0;x=a+344|0;y=a+348|0;z=c[n>>2]|0;A=s;s=r;while(1){r=(s+A)*.5;B=c[c[m>>2]>>2]|0;h[B>>3]=r;if((z|0)>0){C=c[B+8>>2]|0;B=0;do{h[C+(B<<3)>>3]=(+h[e+(B<<3)>>3]+ +h[f+(B<<3)>>3])*.5;B=B+1|0;}while((B|0)<(z|0))}Tr(a)|0;$d[c[(c[p>>2]|0)+40>>2]&127](a)|0;$d[c[(c[p>>2]|0)+28>>2]&127](a)|0;$d[c[(c[p>>2]|0)+32>>2]&127](a)|0;be[c[(c[p>>2]|0)+92>>2]&63](a,c[x>>2]|0,c[c[m>>2]>>2]|0)|0;B=(sq(a,g,j)|0)==0;C=c[n>>2]|0;D=(C|0)>0;do{if(B){if(D){E=c[(c[c[m>>2]>>2]|0)+8>>2]|0;F=0;do{h[e+(F<<3)>>3]=+h[E+(F<<3)>>3];F=F+1|0;}while((F|0)<(C|0))}h[b>>3]=r;F=c[o>>2]|0;if((F|0)>0){E=c[x>>2]|0;G=c[y>>2]|0;H=0;do{I=E+(H<<3)|0;h[G+(H<<3)>>3]=+h[I>>3];h[I>>3]=+h[q+(H<<3)>>3];H=H+1|0;}while((H|0)<(F|0))}J=+h[d>>3]}else{if(D){F=c[(c[c[m>>2]>>2]|0)+8>>2]|0;H=0;do{h[f+(H<<3)>>3]=+h[F+(H<<3)>>3];H=H+1|0;}while((H|0)<(C|0))}h[d>>3]=r;H=c[o>>2]|0;if((H|0)<=0){J=r;break}GS(q|0,c[x>>2]|0,((H|0)>1?H<<3:8)|0)|0;J=r}}while(0);r=+h[b>>3];if(+U(+(J-r))>1.0e-9){z=C;A=r;s=J}else{break}}bS(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}function sq(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;Zn(b);Rn(27,0,51912,g);g=eo(d)|0;if((g|0)==0){j=ao(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}d=a+344|0;m=a+348|0;a=g;do{g=go(a)|0;if(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){g=go(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==1.0){n=7}else{n=5}}else{n=5}do{if((n|0)==5){n=0;g=go(a)|0;if(!(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==1.0)){break}g=go(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){n=7}}}while(0);if((n|0)==7){n=0;g=go(a)|0;o=c[g>>2]|0;g=go(a)|0;p=+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]>0.0?51328:51336;g=go(a)|0;q=+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]>0.0?51328:51336;c[f>>2]=o;c[f+4>>2]=p;c[f+8>>2]=q;Rn(27,0,51952,f);_n(b,go(a)|0)}a=fo(a)|0;}while((a|0)!=0);j=ao(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}function tq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+8|0;e=d;f=b+315|0;a[f]=0;g=b+540|0;ne[c[(c[g>>2]|0)+96>>2]&63](b,1)|0;uq(b);vq(b);$d[c[(c[g>>2]|0)+36>>2]&127](b)|0;wq(b,8);h=xq(b)|0;j=$d[c[(c[g>>2]|0)+100>>2]&127](b)|0;k=b+312|0;if((a[k]|0)==0){l=1;m=j;n=h}else{vq(b);i=d;return}while(1){if((m|0)==0){if((a[f]|n)<<24>>24==0){o=7;break}}yq(b);uq(b);wq(b,8);$d[c[(c[g>>2]|0)+36>>2]&127](b)|0;if((l|0)>200){o=5;break}h=xq(b)|0;j=$d[c[(c[g>>2]|0)+100>>2]&127](b)|0;if((a[k]|0)==0){l=l+1|0;m=j;n=h}else{o=7;break}}if((o|0)==5){Vn(c[b+536>>2]|0,52032,e)}else if((o|0)==7){vq(b);i=d;return}}function uq(a){a=a|0;var b=0;b=i;GS(c[a+356>>2]|0,c[a+352>>2]|0,c[a+164>>2]|0)|0;i=b;return}function vq(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+164|0;if((c[e>>2]|0)<=0){i=d;return}f=b+352|0;g=b+360|0;b=0;do{a[(c[g>>2]|0)+b|0]=(a[(c[f>>2]|0)+b|0]|0)!=0|0;b=b+1|0;}while((b|0)<(c[e>>2]|0));i=d;return}function wq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+8|0;if((c[21232+(d<<2)>>2]|0)==0){i=e;return}Rn(d,1,52456,g);g=b+164|0;if((c[g>>2]|0)>0){h=b+540|0;j=b+352|0;k=b+356|0;b=0;do{l=$d[c[(c[h>>2]|0)+108>>2]&127](b)|0;m=(a[(c[j>>2]|0)+b|0]|0)!=0?84:70;n=$d[c[(c[h>>2]|0)+108>>2]&127](b)|0;o=(a[(c[k>>2]|0)+b|0]|0)!=0?84:70;c[f>>2]=b;c[f+4>>2]=l;c[f+8>>2]=m;c[f+12>>2]=n;c[f+16>>2]=o;Rn(d,0,52480,f);b=b+1|0;}while((b|0)<(c[g>>2]|0))}Yd[c[5446]&255](d);i=e;return}function xq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+164>>2]|0;if((e|0)<=0){f=0;i=d;return f|0}g=c[b+356>>2]|0;h=c[b+352>>2]|0;b=0;while(1){j=b+1|0;if((a[g+b|0]|0)!=(a[h+b|0]|0)){f=1;k=5;break}if((j|0)<(e|0)){b=j}else{f=0;k=5;break}}if((k|0)==5){i=d;return f|0}return 0}function yq(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;GS(c[a+400>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;GS(c[a+404>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;GS(c[a+408>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;GS(c[a+412>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function zq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+160>>2]|0;e=c[a+344>>2]|0;if((d|0)>0){f=c[a+348>>2]|0;g=0;do{h[f+(g<<3)>>3]=+h[e+(g<<3)>>3];g=g+1|0;}while((g|0)<(d|0))}be[c[(c[a+540>>2]|0)+92>>2]&63](a,e,c[c[a+4>>2]>>2]|0)|0;i=b;return}function Aq(a){a=a|0;var b=0;b=i;Bq(a);Cq(a);yq(a);Dq(a);i=b;return}function Bq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+136>>2]|0;if((e|0)>0){f=c[b+24>>2]|0;g=c[b+416>>2]|0;j=0;do{h[g+(j<<3)>>3]=+h[f+(j*112|0)+96>>3];j=j+1|0;}while((j|0)<(e|0))}e=b+140|0;if((c[e>>2]|0)>0){j=c[b+28>>2]|0;f=c[b+420>>2]|0;g=0;do{c[f+(g<<2)>>2]=c[j+(g*60|0)+52>>2];g=g+1|0;}while((g|0)<(c[e>>2]|0))}e=b+144|0;if((c[e>>2]|0)>0){g=b+32|0;j=b+424|0;f=0;do{a[(c[j>>2]|0)+f|0]=a[(c[g>>2]|0)+(f*48|0)+42|0]|0;f=f+1|0;}while((f|0)<(c[e>>2]|0))}e=c[b+148>>2]|0;if((e|0)<=0){i=d;return}f=b+36|0;g=b+428|0;b=0;do{c[(c[g>>2]|0)+(b<<2)>>2]=c[(c[f>>2]|0)+(b*52|0)+44>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function Cq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[b+8>>2]|0;j=c[e+8>>2]|0;k=0;do{h[j+(k<<3)>>3]=+h[g+(k*112|0)+96>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[b+12>>2]|0;g=c[e+12>>2]|0;j=0;do{c[g+(j<<2)>>2]=c[k+(j*60|0)+52>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=b+16|0;k=e+16|0;g=0;do{a[(c[k>>2]|0)+g|0]=a[(c[j>>2]|0)+(g*48|0)+42|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=b+20|0;b=e+20|0;e=0;do{c[(c[b>>2]|0)+(e<<2)>>2]=c[(c[g>>2]|0)+(e*52|0)+44>>2];e=e+1|0;}while((e|0)<(f|0));i=d;return}function Dq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((Jo(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=a+ -1|0;m=c[e>>2]|0;n=c[m+(l<<2)>>2]|0;o=c[m+(a<<2)>>2]|0;h[o>>3]=+h[n>>3];GS(c[o+8>>2]|0,c[n+8>>2]|0,c[f>>2]<<3|0)|0;n=c[e>>2]|0;GS(c[(c[n+(a<<2)>>2]|0)+12>>2]|0,c[(c[n+(l<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;n=c[e>>2]|0;GS(c[(c[n+(a<<2)>>2]|0)+16>>2]|0,c[(c[n+(l<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;n=c[e>>2]|0;GS(c[(c[n+(a<<2)>>2]|0)+20>>2]|0,c[(c[n+(l<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(Jo(c[d>>2]|0)|0));i=b;return}function Eq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[21232+(d<<2)>>2]|0)==0){i=e;return}Rn(d,1,52128,q);q=b+136|0;if((c[q>>2]|0)>0){Rn(d,1,52152,p);if((c[q>>2]|0)>0){p=b+24|0;r=b+416|0;s=0;while(1){t=s+1|0;u=c[p>>2]|0;v=c[u+(s*112|0)+4>>2]|0;w=+h[u+(s*112|0)+96>>3];x=(a[u+(s*112|0)+72|0]|0)!=0?52112:52120;y=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=t;c[o+4>>2]=v;v=o+8|0;h[k>>3]=w;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[o+16>>2]=x;x=o+20|0;h[k>>3]=y;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Rn(d,0,52168,o);if((t|0)<(c[q>>2]|0)){s=t}else{break}}}Yd[c[5446]&255](d)}s=b+140|0;if((c[s>>2]|0)>0){Rn(d,1,52224,n);if((c[s>>2]|0)>0){n=b+28|0;q=b+420|0;o=0;while(1){r=o+1|0;p=c[n>>2]|0;t=c[p+(o*60|0)+4>>2]|0;x=c[p+(o*60|0)+52>>2]|0;v=(a[p+(o*60|0)+48|0]|0)!=0?52112:52120;p=c[(c[q>>2]|0)+(o<<2)>>2]|0;c[m>>2]=r;c[m+4>>2]=t;c[m+8>>2]=x;c[m+12>>2]=v;c[m+16>>2]=p;Rn(d,0,52248,m);if((r|0)<(c[s>>2]|0)){o=r}else{break}}}Yd[c[5446]&255](d)}o=b+144|0;if((c[o>>2]|0)>0){Rn(d,1,52304,l);if((c[o>>2]|0)>0){l=b+32|0;s=b+424|0;m=0;while(1){q=m+1|0;n=c[l>>2]|0;r=c[n+(m*48|0)+4>>2]|0;p=(a[n+(m*48|0)+42|0]|0)!=0?52112:52120;v=(a[n+(m*48|0)+40|0]|0)!=0?52112:52120;n=(a[(c[s>>2]|0)+m|0]|0)!=0?52112:52120;c[j>>2]=q;c[j+4>>2]=r;c[j+8>>2]=p;c[j+12>>2]=v;c[j+16>>2]=n;Rn(d,0,52328,j);if((q|0)<(c[o>>2]|0)){m=q}else{break}}}Yd[c[5446]&255](d)}m=b+148|0;if((c[m>>2]|0)>0){Rn(d,1,52384,g);if((c[m>>2]|0)>0){g=b+36|0;o=b+428|0;b=0;while(1){j=b+1|0;s=c[g>>2]|0;l=c[s+(b*52|0)+4>>2]|0;q=c[s+(b*52|0)+44>>2]|0;s=c[(c[o>>2]|0)+(b<<2)>>2]|0;c[f>>2]=j;c[f+4>>2]=l;c[f+8>>2]=q;c[f+12>>2]=s;Rn(d,0,52408,f);if((j|0)<(c[m>>2]|0)){b=j}else{break}}}Yd[c[5446]&255](d)}Yd[c[5446]&255](d);i=e;return}function Fq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((Jo(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=c[e>>2]|0;m=c[l+(a<<2)>>2]|0;n=a+ -1|0;o=c[l+(n<<2)>>2]|0;h[o>>3]=+h[m>>3];GS(c[o+8>>2]|0,c[m+8>>2]|0,c[f>>2]<<3|0)|0;m=c[e>>2]|0;GS(c[(c[m+(n<<2)>>2]|0)+12>>2]|0,c[(c[m+(a<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;m=c[e>>2]|0;GS(c[(c[m+(n<<2)>>2]|0)+16>>2]|0,c[(c[m+(a<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;m=c[e>>2]|0;GS(c[(c[m+(n<<2)>>2]|0)+20>>2]|0,c[(c[m+(a<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(Jo(c[d>>2]|0)|0));i=b;return}function Gq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[e+8>>2]|0;j=c[b+8>>2]|0;k=0;do{h[j+(k*112|0)+96>>3]=+h[g+(k<<3)>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[e+12>>2]|0;g=c[b+12>>2]|0;j=0;do{c[g+(j*60|0)+52>>2]=c[k+(j<<2)>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=e+16|0;k=b+16|0;g=0;do{a[(c[k>>2]|0)+(g*48|0)+42|0]=a[(c[j>>2]|0)+g|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=e+20|0;e=b+20|0;b=0;do{c[(c[e>>2]|0)+(b*52|0)+44>>2]=c[(c[g>>2]|0)+(b<<2)>>2];b=b+1|0;}while((b|0)<(f|0));i=d;return}function Hq(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;h[a+376>>3]=+h[d>>3];GS(c[a+384>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;GS(c[a+388>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;GS(c[a+392>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;GS(c[a+396>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function Iq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+32|0;o=b;c[o>>2]=0;p=Eo(3,32)|0;c[o>>2]=p;if((p|0)==0){Vn(c[b+536>>2]|0,52512,m)}m=n;p=b+116|0;q=n+8|0;r=b+536|0;s=b+124|0;t=n+12|0;u=b+128|0;v=n+16|0;w=b+132|0;x=n+20|0;y=n;n=0;do{h[m>>3]=0.0;z=cS(c[p>>2]|0,8)|0;c[q>>2]=z;Un(c[r>>2]|0,(z|0)!=0|0,52568,l);z=cS(c[s>>2]|0,4)|0;c[t>>2]=z;Un(c[r>>2]|0,(z|0)!=0|0,52568,k);z=cS(c[u>>2]|0,1)|0;c[v>>2]=z;Un(c[r>>2]|0,(z|0)!=0|0,52568,j);z=cS(c[w>>2]|0,4)|0;c[x>>2]=z;Un(c[r>>2]|0,(z|0)!=0|0,52568,g);Io(c[o>>2]|0,y);n=n+1|0;}while(n>>>0<3);n=cS(3,4)|0;c[b+4>>2]=n;Ko(c[o>>2]|0,0,n);c[b+8>>2]=cS(c[p>>2]|0,112)|0;c[b+12>>2]=cS(c[s>>2]|0,60)|0;c[b+16>>2]=cS(c[u>>2]|0,48)|0;c[b+20>>2]=cS(c[w>>2]|0,52)|0;n=b+136|0;c[b+24>>2]=cS(c[n>>2]|0,112)|0;o=c[b+140>>2]|0;c[b+28>>2]=cS(o,60)|0;y=c[b+144>>2]|0;c[b+32>>2]=cS(y,48)|0;g=c[b+148>>2]|0;c[b+36>>2]=cS(g,52)|0;c[b+40>>2]=cS(c[b+216>>2]|0,52)|0;c[b+44>>2]=cS(c[b+220>>2]|0,52)|0;c[b+48>>2]=cS(c[b+224>>2]|0,52)|0;c[b+52>>2]=cS(c[b+228>>2]|0,52)|0;x=c[b+104>>2]|0;c[b+108>>2]=cS(x,24)|0;h[b+328>>3]=+h[b+240>>3];c[b+336>>2]=cS(x,8)|0;c[b+340>>2]=cS(x,1)|0;c[b+300>>2]=1;c[b+292>>2]=1;c[b+296>>2]=1;x=c[b+160>>2]|0;c[b+344>>2]=cS(x,8)|0;c[b+348>>2]=cS(x,8)|0;j=c[b+164>>2]|0;c[b+352>>2]=cS(j,1)|0;c[b+356>>2]=cS(j,1)|0;c[b+360>>2]=cS(j,1)|0;j=aS(x<<2)|0;c[b+368>>2]=j;c[b+364>>2]=aS(c[b+168>>2]<<3)|0;if((x|0)!=0){v=0;do{c[j+(v<<2)>>2]=v;v=v+1|0;}while(v>>>0<x>>>0)}x=c[p>>2]|0;c[b+384>>2]=cS(x,8)|0;p=c[s>>2]|0;c[b+388>>2]=cS(p,4)|0;s=c[u>>2]|0;c[b+392>>2]=cS(s,1)|0;u=c[w>>2]|0;c[b+396>>2]=cS(u,4)|0;c[b+400>>2]=cS(x,8)|0;c[b+404>>2]=cS(p,4)|0;c[b+408>>2]=cS(s,1)|0;c[b+412>>2]=cS(u,4)|0;c[b+416>>2]=cS(c[n>>2]|0,8)|0;c[b+420>>2]=cS(o,4)|0;c[b+424>>2]=cS(y,1)|0;c[b+428>>2]=cS(g,4)|0;c[b+432>>2]=cS(c[b+152>>2]|0,8)|0;c[b+436>>2]=cS(c[b+156>>2]|0,8)|0;g=aS((c[b+192>>2]|0)*40|0)|0;c[b+484>>2]=g;y=b+540|0;Yd[c[(c[y>>2]|0)+20>>2]&255](g);g=aS((c[b+196>>2]|0)*80|0)|0;c[b+476>>2]=g;Yd[c[(c[y>>2]|0)+16>>2]&255](g);g=aS((c[b+200>>2]|0)*80|0)|0;c[b+468>>2]=g;Yd[c[(c[y>>2]|0)+12>>2]&255](g);g=aS((c[b+204>>2]|0)*48|0)|0;c[b+488>>2]=g;Zd[c[(c[y>>2]|0)+24>>2]&63](g,b);c[b+464>>2]=aS((c[b+232>>2]|0)*44|0)|0;c[b+76>>2]=0;c[b+80>>2]=0;g=cS(c[b+188>>2]|0,4)|0;c[b+320>>2]=g;Un(c[r>>2]|0,(g|0)!=0|0,52584,f);c[b+512>>2]=100;c[b+516>>2]=cS(100,4)|0;c[b+520>>2]=cS(100,8)|0;c[b+524>>2]=0;c[b+528>>2]=0;c[b+532>>2]=0;h[b+304>>3]=1.0;a[b+313|0]=0;a[b+312|0]=0;a[b+314|0]=0;f=b+172|0;g=b+316|0;a[g]=0;a[g+1|0]=0;a[g+2|0]=0;a[g+3|0]=0;g=aS(c[f>>2]<<2)|0;y=b+504|0;c[y>>2]=g;Un(c[r>>2]|0,(g|0)!=0|0,52568,e);if((c[f>>2]|0)==0){i=d;return}else{A=0}do{e=Eo(1024,16)|0;c[(c[y>>2]|0)+(A<<2)>>2]=e;A=A+1|0;}while(A>>>0<(c[f>>2]|0)>>>0);i=d;return}function Jq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;d=a+4|0;e=c[d>>2]|0;f=0;do{g=c[e+(f<<2)>>2]|0;bS(c[g+8>>2]|0);bS(c[g+12>>2]|0);bS(c[g+16>>2]|0);bS(c[g+20>>2]|0);f=f+1|0;e=c[d>>2]|0}while(f>>>0<3);bS(e);Fo(c[a>>2]|0);e=a+116|0;f=a+8|0;d=c[f>>2]|0;if((c[e>>2]|0)==0){h=d}else{g=d;d=0;while(1){ap(g+(d*112|0)|0);j=d+1|0;k=c[f>>2]|0;if(j>>>0<(c[e>>2]|0)>>>0){d=j;g=k}else{h=k;break}}}bS(h);h=a+124|0;g=a+12|0;d=c[g>>2]|0;if((c[h>>2]|0)==0){l=d}else{e=d;d=0;while(1){ap(e+(d*60|0)|0);f=d+1|0;k=c[g>>2]|0;if(f>>>0<(c[h>>2]|0)>>>0){d=f;e=k}else{l=k;break}}}bS(l);l=a+128|0;e=a+16|0;d=c[e>>2]|0;if((c[l>>2]|0)==0){m=d}else{h=d;d=0;while(1){ap(h+(d*48|0)|0);g=d+1|0;k=c[e>>2]|0;if(g>>>0<(c[l>>2]|0)>>>0){d=g;h=k}else{m=k;break}}}bS(m);m=a+132|0;h=a+20|0;d=c[h>>2]|0;if((c[m>>2]|0)==0){n=d}else{l=d;d=0;while(1){ap(l+(d*52|0)|0);e=d+1|0;k=c[h>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){d=e;l=k}else{n=k;break}}}bS(n);n=a+136|0;l=a+24|0;d=c[l>>2]|0;if((c[n>>2]|0)==0){o=d}else{m=d;d=0;while(1){ap(m+(d*112|0)|0);h=d+1|0;k=c[l>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){d=h;m=k}else{o=k;break}}}bS(o);o=a+140|0;m=a+28|0;d=c[m>>2]|0;if((c[o>>2]|0)==0){p=d}else{n=d;d=0;while(1){ap(n+(d*60|0)|0);l=d+1|0;k=c[m>>2]|0;if(l>>>0<(c[o>>2]|0)>>>0){d=l;n=k}else{p=k;break}}}bS(p);p=a+144|0;n=a+32|0;d=c[n>>2]|0;if((c[p>>2]|0)==0){q=d}else{o=d;d=0;while(1){ap(o+(d*48|0)|0);m=d+1|0;k=c[n>>2]|0;if(m>>>0<(c[p>>2]|0)>>>0){d=m;o=k}else{q=k;break}}}bS(q);q=a+148|0;o=a+36|0;d=c[o>>2]|0;if((c[q>>2]|0)==0){r=d}else{p=d;d=0;while(1){ap(p+(d*52|0)|0);n=d+1|0;k=c[o>>2]|0;if(n>>>0<(c[q>>2]|0)>>>0){d=n;p=k}else{r=k;break}}}bS(r);r=a+216|0;p=a+40|0;d=c[p>>2]|0;if((c[r>>2]|0)==0){s=d}else{q=d;d=0;while(1){ap(q+(d*52|0)+12|0);o=d+1|0;k=c[p>>2]|0;if(o>>>0<(c[r>>2]|0)>>>0){d=o;q=k}else{s=k;break}}}bS(s);s=a+220|0;q=a+44|0;d=c[q>>2]|0;if((c[s>>2]|0)==0){t=d}else{r=d;d=0;while(1){ap(r+(d*52|0)+12|0);p=d+1|0;k=c[q>>2]|0;if(p>>>0<(c[s>>2]|0)>>>0){d=p;r=k}else{t=k;break}}}bS(t);t=a+224|0;r=a+48|0;d=c[r>>2]|0;if((c[t>>2]|0)==0){u=d}else{s=d;d=0;while(1){ap(s+(d*52|0)+12|0);q=d+1|0;k=c[r>>2]|0;if(q>>>0<(c[t>>2]|0)>>>0){d=q;s=k}else{u=k;break}}}bS(u);u=a+228|0;s=a+52|0;d=c[s>>2]|0;if((c[u>>2]|0)==0){v=d}else{t=d;d=0;while(1){ap(t+(d*52|0)+12|0);r=d+1|0;k=c[s>>2]|0;if(r>>>0<(c[u>>2]|0)>>>0){d=r;t=k}else{v=k;break}}}bS(v);bS(c[a+108>>2]|0);bS(c[a+336>>2]|0);bS(c[a+340>>2]|0);bS(c[a+344>>2]|0);bS(c[a+348>>2]|0);bS(c[a+352>>2]|0);bS(c[a+356>>2]|0);bS(c[a+360>>2]|0);bS(c[a+368>>2]|0);bS(c[a+384>>2]|0);bS(c[a+388>>2]|0);bS(c[a+392>>2]|0);bS(c[a+396>>2]|0);bS(c[a+400>>2]|0);bS(c[a+404>>2]|0);bS(c[a+408>>2]|0);bS(c[a+412>>2]|0);bS(c[a+416>>2]|0);bS(c[a+420>>2]|0);bS(c[a+424>>2]|0);bS(c[a+428>>2]|0);bS(c[a+488>>2]|0);bS(c[a+484>>2]|0);bS(c[a+476>>2]|0);bS(c[a+468>>2]|0);bS(c[a+464>>2]|0);bS(c[a+432>>2]|0);bS(c[a+436>>2]|0);bS(c[a+320>>2]|0);bS(c[a+516>>2]|0);bS(c[a+520>>2]|0);uF(a+56|0);v=a+172|0;t=a+504|0;a=c[t>>2]|0;if((c[v>>2]|0)==0){w=a;x=w;bS(x);i=b;return}else{y=a;z=0}while(1){Fo(c[y+(z<<2)>>2]|0);a=z+1|0;d=c[t>>2]|0;if(a>>>0<(c[v>>2]|0)>>>0){z=a;y=d}else{w=d;break}}x=w;bS(x);i=b;return}function Kq(a){a=+a;var b=0,d=0,e=0.0,f=0;b=i;i=i+8|0;d=b;e=a*1.0e-4;h[6578]=e;f=d;h[k>>3]=e;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];Rn(8,0,52632,d);i=b;return}function Lq(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;d=c<<24>>24!=0;e=+h[6578];f=e+e*+U(+(d?b:a));if(d){g=f}else{g=-f}i=i;return a-b<=g|0}function Mq(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;d=c<<24>>24!=0;e=+h[6578];f=e+e*+U(+(d?a:b));if(d){g=-f}else{g=f}i=i;return a-b>=g|0}function Nq(a,b){a=+a;b=+b;i=i;return a<b|0}function Oq(a,b){a=+a;b=+b;i=i;return a<=b|0}function Pq(a,b){a=+a;b=+b;i=i;return a>b|0}function Qq(a,b){a=+a;b=+b;i=i;return a>=b|0}function Rq(b,d,e){b=+b;d=d|0;e=e|0;var f=0,g=0,j=0.0,k=0,l=0;f=i;do{if((a[e+314|0]|0)==0){g=3}else{if((a[e+318|0]|0)!=0){g=3;break}j=+(~~+T(+b)|0);k=e+364|0;h[(c[k>>2]|0)+(d<<3)>>3]=j;l=k}}while(0);if((g|0)==3){l=e+364|0}i=f;return~~+h[(c[l>>2]|0)+(d<<3)>>3]|0}



function Sq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){j=c[e+(h*40|0)>>2]|0;k=j<<2;c[e+(h*40|0)+20>>2]=aS(k)|0;c[e+(h*40|0)+24>>2]=aS(k)|0;if((c[g>>2]|0)!=1){l=5;break}Vq(j,e+(h*40|0)+28|0)|0;j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{l=6;break}}if((l|0)==5){Vn(c[a+536>>2]|0,52688,d)}else if((l|0)==6){i=b;return 0}return 0}function Tq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){bS(c[e+(h*40|0)+20>>2]|0);bS(c[e+(h*40|0)+24>>2]|0);if((c[g>>2]|0)!=1){j=5;break}k=e+(h*40|0)+28|0;Wq(k)|0;bS(c[k>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{j=6;break}}if((j|0)==5){Vn(c[a+536>>2]|0,52688,d)}else if((j|0)==6){i=b;return 0}return 0}function Uq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+484>>2]|0;o=b+192|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+4|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p*40|0)+36|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[21300>>2]|c[5306]|0)==0){z=w;A=1;break}sF(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Tn(17,1,52720,g);sF(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;sF(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;Tn(17,0,52752,f);sF(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}Yd[c[5446]&255](17);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function Vq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=aS(20)|0;c[b>>2]=f;Un(0,(f|0)!=0|0,52760,e);e=aS(a)|0;c[f>>2]=e;e=aS(a)|0;c[f+4>>2]=e;e=aS(a)|0;c[f+8>>2]=e;e=aS(a)|0;c[f+16>>2]=e;Un(0,(c[b>>2]|0)!=0|0,52792,d);i=d;return 0}function Wq(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;bS(c[d>>2]|0);bS(c[d+4>>2]|0);bS(c[d+8>>2]|0);bS(c[d+16>>2]|0);i=b;return 0}function Xq(a,b){a=a|0;b=b|0;b=i;i=i+8|0;Vn(c[a+536>>2]|0,52840,b);return 0}function Yq(a){a=a|0;a=i;i=i+8|0;Vn(0,52840,a);return 0}function Zq(a,b){a=a|0;b=b|0;b=i;i=i+8|0;Vn(c[a+536>>2]|0,52840,b);return 0}function _q(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){j=c[e+(h<<6)+16>>2]|0;k=c[e+(h<<6)+12>>2]|0;l=j<<3;c[e+(h<<6)+28>>2]=aS(l)|0;c[e+(h<<6)+36>>2]=aS(l)|0;m=c[g>>2]|0;if((m|0)==2){c[e+(h<<6)+8>>2]=2;fr(j,j,k,e+(h<<6)+24|0)|0}else if((m|0)==1){c[e+(h<<6)+32>>2]=aS(fa(l,j)|0)|0;c[e+(h<<6)+8>>2]=1;dr(j,e+(h<<6)+24|0)|0}else{n=6;break}j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{n=8;break}}if((n|0)==6){Vn(c[a+536>>2]|0,52880,d)}else if((n|0)==8){i=b;return 0}return 0}function $q(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=(fa(c[f+16>>2]|0,b)|0)+a|0;h[(c[f+32>>2]|0)+(e<<3)>>3]=d;i=i;return}function ar(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=i;ub(0,a|0,b|0,+d,c[c[f+24>>2]>>2]|0)|0;i=e;return}function br(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){bS(c[e+(h<<6)+28>>2]|0);bS(c[e+(h<<6)+36>>2]|0);j=c[g>>2]|0;if((j|0)==1){er(e+(h<<6)+24|0)|0;bS(c[e+(h<<6)+32>>2]|0)}else if((j|0)==2){gr(e+(h<<6)+24|0)|0}else{k=6;break}bS(c[e+(h<<6)+24>>2]|0);j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{k=8;break}}if((k|0)==6){Vn(c[a+536>>2]|0,52880,d)}else if((k|0)==8){i=b;return 0}return 0}function cr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+476>>2]|0;o=b+196|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+20|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p<<6)+56|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[21292>>2]|c[5306]|0)==0){z=w;A=1;break}sF(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Tn(15,1,52912,g);sF(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;sF(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;Tn(15,0,52944,f);sF(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}Yd[c[5446]&255](15);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function dr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=aS(12)|0;f=aS(a<<2)|0;c[e>>2]=f;Un(0,(f|0)!=0|0,52952,d);c[e+4>>2]=1;c[e+8>>2]=0;c[b>>2]=e;i=d;return 0}function er(a){a=a|0;var b=0;b=i;bS(c[c[a>>2]>>2]|0);i=b;return 0}function fr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=aS(32)|0;Un(0,(g|0)!=0|0,53008,f);c[g+20>>2]=b;b=g+24|0;c[b>>2]=a;c[g+28>>2]=d;d=g+8|0;Pd(0,d|0)|0;Ed(c[d>>2]|0,c[b>>2]|0,0)|0;Pd(0,g+4|0)|0;Ed(c[d>>2]|0,c[b>>2]|0,0)|0;b=g+12|0;ab(b|0)|0;Jb(53056,c[b>>2]|0)|0;c[e>>2]=g;i=f;return 0}function gr(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Ld(c[d+12>>2]|0)|0;Ib(c[d+8>>2]|0)|0;Ib(c[d+4>>2]|0)|0;i=b;return 0}function hr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=c[a+468>>2]|0;h=a+200|0;if((c[h>>2]|0)<=0){i=b;return 0}j=a+536|0;k=a;l=a+300|0;m=0;a:while(1){n=g+(m*80|0)|0;o=c[n>>2]|0;Un(c[j>>2]|0,(c[g+(m*80|0)+32>>2]|0)!=0|0,53224,f);p=g+(m*80|0)+28|0;do{if(!((c[p>>2]|0)==-1)){Un(c[j>>2]|0,(c[g+(m*80|0)+20>>2]|0)!=0|0,53264,e);if(($d[c[g+(m*80|0)+24>>2]&127](k)|0)==0){break}c[p>>2]=-1}}while(0);p=o<<3;c[g+(m*80|0)+44>>2]=aS(p)|0;c[g+(m*80|0)+52>>2]=aS(p)|0;c[g+(m*80|0)+48>>2]=aS(p)|0;c[g+(m*80|0)+16>>2]=aS(p)|0;c[g+(m*80|0)+8>>2]=aS(p)|0;c[g+(m*80|0)+12>>2]=aS(p)|0;Zd[c[g+(m*80|0)+36>>2]&63](k,n);do{if((c[g+(m*80|0)+56>>2]|0)==1){ur(o,g+(m*80|0)+40|0)|0}else{p=c[l>>2]|0;if((p|0)==2){Xq(a,n)|0;break}else if((p|0)==1){mr(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==3){ur(o,g+(m*80|0)+40|0)|0;break}else{q=12;break a}}}while(0);o=m+1|0;if((o|0)<(c[h>>2]|0)){m=o}else{q=14;break}}if((q|0)==12){Vn(c[j>>2]|0,53304,d)}else if((q|0)==14){i=b;return 0}return 0}function ir(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+468>>2]|0;f=a+200|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+300|0;h=0;a:while(1){j=e+(h*80|0)|0;bS(c[e+(h*80|0)+44>>2]|0);bS(c[e+(h*80|0)+52>>2]|0);bS(c[e+(h*80|0)+48>>2]|0);bS(c[e+(h*80|0)+16>>2]|0);bS(c[e+(h*80|0)+8>>2]|0);bS(c[e+(h*80|0)+12>>2]|0);do{if((c[e+(h*80|0)+56>>2]|0)==1){k=e+(h*80|0)+40|0;vr(k)|0;l=k}else{k=c[g>>2]|0;if((k|0)==2){m=7;break a}else if((k|0)==1){n=e+(h*80|0)+40|0;nr(n)|0;l=n;break}else if((k|0)==3){k=e+(h*80|0)+40|0;vr(k)|0;l=k;break}else{m=9;break a}}}while(0);bS(c[l>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{m=11;break}}if((m|0)==7){Yq(j)|0}else if((m|0)==9){Vn(c[a+536>>2]|0,53304,d)}else if((m|0)==11){i=b;return 0}return 0}function jr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=c[b+468>>2]|0;c[b+472>>2]=d;h=b+319|0;a[h]=1;do{if((c[g+(d*80|0)+56>>2]|0)==1){j=(xr(b,d)|0)&255}else{k=c[b+300>>2]|0;if((k|0)==1){l=b+536|0;m=(c[l>>2]|0)+84|0;n=c[m>>2]|0;c[m>>2]=3;m=or(b,d)|0;c[(c[l>>2]|0)+84>>2]=n;j=m&255;break}else if((k|0)==2){j=(Zq(b,d)|0)&255;break}else if((k|0)==3){j=(xr(b,d)|0)&255;break}else{Vn(c[b+536>>2]|0,53304,f)}}}while(0);a[g+(d*80|0)+72|0]=j;a[h]=0;i=e;return 0}function kr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=c[b+468>>2]|0;v=c[b+200>>2]|0;if((v|0)>0){w=0}else{x=0;i=e;return x|0}while(1){y=w+1|0;if((a[u+(w*80|0)+72|0]|0)==0){break}if((y|0)<(v|0)){w=y}else{x=0;z=22;break}}if((z|0)==22){i=e;return x|0}v=u+(w*80|0)+4|0;w=c[v>>2]|0;u=n;c[u>>2]=1;c[n+4>>2]=w;if((d|0)==0){x=1;i=e;return x|0}d=b+56|0;sF(o,d,w);A=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[o+8>>2];o=m+4|0;h[k>>3]=A;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Sn(17,1,u,53336,m);do{if((a[b+312|0]|0)==0){sF(s,d,c[v>>2]|0);m=s+12|0;if((c[m>>2]|0)<=0){break}u=t+16|0;o=0;while(1){w=o+1|0;sF(t,d,c[v>>2]|0);n=c[(c[(c[u>>2]|0)+(o<<2)>>2]|0)+4>>2]|0;c[f>>2]=w;c[f+4>>2]=n;Tn(17,0,53536,f);sF(s,d,c[v>>2]|0);if((w|0)<(c[m>>2]|0)){o=w}else{break}}}else{Tn(17,1,53376,l);sF(p,d,c[v>>2]|0);o=p+12|0;if((c[o>>2]|0)>0){m=b+116|0;u=r+16|0;w=b+8|0;n=q+16|0;y=0;while(1){a:do{if((c[m>>2]|0)>0){B=y+1|0;C=0;while(1){D=c[(c[w>>2]|0)+(C*112|0)+4>>2]|0;sF(q,d,c[v>>2]|0);if((AS(D,c[(c[(c[n>>2]|0)+(y<<2)>>2]|0)+4>>2]|0)|0)==0){break}D=C+1|0;if((D|0)<(c[m>>2]|0)){C=D}else{z=15;break a}}D=c[w>>2]|0;E=c[D+(C*112|0)+4>>2]|0;A=+h[D+(C*112|0)+96>>3];F=+h[D+(C*112|0)+80>>3];c[j>>2]=B;c[j+4>>2]=E;E=j+8|0;h[k>>3]=A;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=j+16|0;h[k>>3]=F;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Tn(17,0,53456,j);G=y+1|0}else{z=15}}while(0);if((z|0)==15){z=0;E=y+1|0;sF(r,d,c[v>>2]|0);D=c[(c[(c[u>>2]|0)+(y<<2)>>2]|0)+4>>2]|0;c[g>>2]=E;c[g+4>>2]=D;Tn(17,0,53496,g);G=E}sF(p,d,c[v>>2]|0);if((G|0)<(c[o>>2]|0)){y=G}else{break}}}if((c[21300>>2]|c[5306]|0)==0){break}Yd[c[5446]&255](17)}}while(0);if((c[21300>>2]|c[5306]|0)==0){x=1;i=e;return x|0}Yd[c[5446]&255](17);x=1;i=e;return x|0}function lr(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0;e=i;f=c[a+4>>2]|0;g=+h[c[f+4>>2]>>3];j=+h[c[f+8>>2]>>3];if(g==j){k=b;i=e;return+k}k=(b-d)*((+h[c[f>>2]>>3]-j)/(g-j))+d;i=e;return+k}function mr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=i;i=i+8|0;f=aS(144)|0;c[b>>2]=f;Un(0,(f|0)!=0|0,53552,e);c[f>>2]=0;e=a<<3;g=aS(e)|0;c[f+4>>2]=g;g=aS(e)|0;c[f+16>>2]=g;c[f+8>>2]=1;g=aS(e)|0;c[f+12>>2]=g;c[f+20>>2]=a;g=aS(e)|0;c[f+24>>2]=g;g=cS(a,8)|0;c[f+28>>2]=g;h[f+32>>3]=1.0e-12;c[f+40>>2]=a*1e4;g=a+ -1|0;c[f+44>>2]=g;c[f+48>>2]=g;h[f+56>>3]=1.0e-12;g=aS(e)|0;c[f+64>>2]=g;g=aS(e)|0;c[f+68>>2]=g;c[f+72>>2]=1;h[f+80>>3]=100.0;c[f+88>>2]=-1;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;g=fa(a,a)|0;j=cS(g,8)|0;c[f+104>>2]=j;j=cS(g,8)|0;c[f+108>>2]=j;c[f+112>>2]=a;j=(fa(a+1|0,a)|0)/2|0;a=aS(j<<3)|0;c[f+116>>2]=a;c[f+120>>2]=j;j=aS(e)|0;c[f+124>>2]=j;j=aS(e)|0;c[f+128>>2]=j;j=aS(e)|0;c[f+132>>2]=j;j=aS(e)|0;c[f+136>>2]=j;j=aS(e)|0;c[f+140>>2]=j;Un(0,(c[b>>2]|0)!=0|0,53584,d);i=d;return 0}function nr(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;bS(c[d+4>>2]|0);bS(c[d+16>>2]|0);bS(c[d+12>>2]|0);bS(c[d+24>>2]|0);bS(c[d+28>>2]|0);bS(c[d+64>>2]|0);bS(c[d+68>>2]|0);bS(c[d+104>>2]|0);bS(c[d+108>>2]|0);bS(c[d+116>>2]|0);bS(c[d+124>>2]|0);bS(c[d+128>>2]|0);bS(c[d+132>>2]|0);bS(c[d+136>>2]|0);bS(c[d+140>>2]|0);i=b;return 0}function or(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0,kb=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+24|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+24|0;N=i;i=i+24|0;O=i;i=i+4096|0;P=i;i=i+24|0;Q=c[b+468>>2]|0;R=c[Q+(d*80|0)+40>>2]|0;S=R;T=c[Q+(d*80|0)+4>>2]|0;c[I>>2]=1;V=R+80|0;W=V;X=+h[V>>3];c[L>>2]=0;Y=b+164|0;Z=aS(c[Y>>2]|0)|0;if((c[21300>>2]|0)!=0){sF(M,b+56|0,T);_=+h[c[c[b+4>>2]>>2]>>3];c[H>>2]=c[M+8>>2];M=H+4|0;h[k>>3]=_;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];Rn(17,1,53624,H);H=R+20|0;if((c[H>>2]|0)>0){M=Q+(d*80|0)+44|0;$=Q+(d*80|0)+16|0;aa=Q+(d*80|0)+48|0;ba=Q+(d*80|0)+52|0;ca=0;do{_=+h[(c[M>>2]|0)+(ca<<3)>>3];c[G>>2]=ca;da=G+4|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];Rn(17,1,53680,G);_=+h[(c[aa>>2]|0)+(ca<<3)>>3];ea=+h[(c[ba>>2]|0)+(ca<<3)>>3];da=F;h[k>>3]=+h[(c[$>>2]|0)+(ca<<3)>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+8|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+16|0;h[k>>3]=ea;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];Rn(17,0,53696,F);Yd[c[5446]&255](17);ca=ca+1|0;}while((ca|0)<(c[H>>2]|0))}Yd[c[5446]&255](17)}H=b+314|0;ca=R+24|0;F=c[ca>>2]|0;if((a[H]|0)==0){GS(F|0,c[Q+(d*80|0)+52>>2]|0,c[R+20>>2]<<3|0)|0}else{GS(F|0,c[Q+(d*80|0)+44>>2]|0,c[R+20>>2]<<3|0)|0}F=R+20|0;$=F;ba=c[F>>2]|0;if((ba|0)>0){aa=c[ca>>2]|0;G=c[Q+(d*80|0)+16>>2]|0;M=c[R+12>>2]|0;da=0;do{ea=+U(+(+h[aa+(da<<3)>>3]));h[M+(da<<3)>>3]=+ld(+ea,+(+h[G+(da<<3)>>3]));da=da+1|0;}while((da|0)<(ba|0))}ba=R+8|0;da=(c[ba>>2]|0)!=0;if(da){c[ba>>2]=0}G=R+28|0;M=R+104|0;aa=R+112|0;ga=b;pr($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(da){c[ba>>2]=1}da=b+318|0;ha=R+32|0;ia=R+40|0;ja=R+64|0;ka=R+72|0;la=ka;ma=R+88|0;na=R+92|0;oa=na;pa=R+96|0;qa=pa;ra=R+100|0;sa=R+116|0;ta=R+120|0;ua=R+124|0;va=R+128|0;wa=R+132|0;xa=R+136|0;ya=R+140|0;za=b+56|0;Aa=b+4|0;Ba=Q+(d*80|0)+52|0;Ca=Q+(d*80|0)+44|0;Da=Q+(d*80|0)+48|0;Ea=Q+(d*80|0)+16|0;Q=R+12|0;Fa=b+356|0;Ga=R+4|0;Ha=b+312|0;Ia=R+16|0;Ja=O;O=R+108|0;R=1;ea=1.0e-12;Ka=0;La=0;Ma=0;Na=0;a:while(1){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=c[Ea>>2]|0;Ra=c[Q>>2]|0;Sa=0;do{_=+U(+(+h[Pa+(Sa<<3)>>3]));h[Ra+(Sa<<3)>>3]=+ld(+_,+(+h[Qa+(Sa<<3)>>3]));Sa=Sa+1|0;}while((Sa|0)<(Oa|0))}if((c[21304>>2]|0)!=0){qr(c[Q>>2]|0,$,18,53736);qr(c[ca>>2]|0,$,18,53768)}do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Sa=c[Q>>2]|0;Qa=c[ca>>2]|0;Ra=0;do{Pa=Qa+(Ra<<3)|0;h[Pa>>3]=1.0/+h[Sa+(Ra<<3)>>3]*+h[Pa>>3];Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}}while(0);if((c[21304>>2]|0)!=0){qr(c[ca>>2]|0,$,18,53800)}a[da]=R;Gp(10,$,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,ha,ia,c[ja>>2]|0,la,W,ma,oa,qa,ra,c[sa>>2]|0,ta,c[ua>>2]|0,c[va>>2]|0,c[wa>>2]|0,c[xa>>2]|0,c[ya>>2]|0,ga,d)|0;a[da]=R^1;do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Ra=c[ca>>2]|0;Sa=c[Q>>2]|0;Qa=0;do{Pa=Ra+(Qa<<3)|0;h[Pa>>3]=+h[Pa>>3]*+h[Sa+(Qa<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}}while(0);Oa=c[na>>2]|0;if((Oa|0)==0){sF(N,za,T);_=+h[c[c[Aa>>2]>>2]>>3];Qa=g;Sa=N;c[Qa+0>>2]=c[Sa+0>>2];c[Qa+4>>2]=c[Sa+4>>2];c[Qa+8>>2]=c[Sa+8>>2];c[Qa+12>>2]=c[Sa+12>>2];c[Qa+16>>2]=c[Sa+16>>2];$o(3,g,_);Ta=c[na>>2]|0}else{Ta=Oa}do{if(!((Ta|0)==-1)){if((a[H]|0)==0){Ua=Ta}else{if((c[ba>>2]|0)==0){a[da]=0;pr($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0}else{c[ba>>2]=0;a[da]=0;pr($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;c[ba>>2]=1}uq(b);Ua=c[na>>2]|0}if((Ua|0)==-1){break}Oa=c[F>>2]|0;if((Oa|0)>0){Sa=c[Ga>>2]|0;Qa=c[G>>2]|0;Ra=c[Ia>>2]|0;Pa=0;Va=0;while(1){Wa=Sa+(Pa<<3)|0;h[Wa>>3]=1.0e-16;Xa=c[O>>2]|0;Ya=(Oa|0)>1?Oa:1;_=1.0e-16;Za=0;_a=Va;while(1){$a=+U(+(+h[Xa+(_a<<3)>>3]));ab=$a>_?$a:_;h[Wa>>3]=ab;bb=Za+1|0;if((bb|0)<(Oa|0)){_a=_a+1|0;Za=bb;_=ab}else{break}}h[Ra+(Pa<<3)>>3]=+h[Qa+(Pa<<3)>>3]*(1.0/ab);Za=Pa+1|0;if((Za|0)<(Oa|0)){Pa=Za;Va=Va+Ya|0}else{break}}}if((c[21304>>2]|0)!=0){Rn(18,1,53840,E);if((c[F>>2]|0)>0){Va=0;do{_=+h[(c[Ia>>2]|0)+(Va<<3)>>3];c[D>>2]=Va;Pa=D+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];Rn(18,1,53880,D);_=+h[(c[Ga>>2]|0)+(Va<<3)>>3];c[C>>2]=Va;Pa=C+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];Rn(18,0,53912,C);Yd[c[5446]&255](18);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}Yd[c[5446]&255](18)}if((c[21308>>2]|0)!=0){Va=c[F>>2]|0;c[B>>2]=Va;c[B+4>>2]=Va;Rn(19,1,53944,B);if((c[F>>2]|0)>0){Va=0;do{a[Ja]=0;Pa=c[F>>2]|0;if((Pa|0)>0){Oa=Pa;Pa=0;do{Qa=(fa(Oa,Va)|0)+Pa|0;_=+h[(c[O>>2]|0)+(Qa<<3)>>3];c[A>>2]=Ja;Qa=A+4|0;h[k>>3]=_;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];gc(Ja|0,53968,A|0)|0;Pa=Pa+1|0;Oa=c[F>>2]|0;}while((Pa|0)<(Oa|0))}c[z>>2]=Ja;Rn(19,0,53976,z);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}Yd[c[5446]&255](19)}h[K>>3]=+Fp($,c[Ia>>2]|0);h[J>>3]=+Fp($,c[G>>2]|0)}}while(0);do{if((Ka|0)==0){cb=0}else{if(!(+h[J>>3]>ea)){cb=Ka;break}if(!(+h[K>>3]>ea)){cb=Ka;break}GS(c[Fa>>2]|0,Z|0,c[Y>>2]|0)|0;cb=0}}while(0);Va=c[na>>2]|0;_=+h[J>>3];b:do{if((Va|0)<4){do{if(_>ea){if(!(+h[K>>3]>ea)){break}c[na>>2]=4;db=4;break b}}while(0);if((Va|0)==1){eb=68;break a}else{db=Va}}else{db=Va}}while(0);if(_<=ea){eb=68;break}if(+h[K>>3]<=ea){eb=68;break}Va=(db+ -4|0)>>>0<2;if(Va&(La|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){GS(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{GS(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}$a=+h[V>>3]/10.0;h[V>>3]=$a;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[21300>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Pa=w;h[k>>3]=$a;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];Rn(17,0,54024,w);rr(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<4){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[Ea>>2]|0;Ya=c[ca>>2]|0;Qa=0;do{Ra=Ya+(Qa<<3)|0;h[Ra>>3]=+h[Pa+(Qa<<3)>>3]*.1+ +h[Ra>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}h[V>>3]=X;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[21300>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Rn(17,0,54096,v);rr(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){GS(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{GS(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Da>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Ra=0;do{_=+U(+(+h[Qa+(Ra<<3)>>3]));h[Ya+(Ra<<3)>>3]=+ld(+_,+(+h[Pa+(Ra<<3)>>3]));Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[21300>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Rn(17,0,54160,u);rr(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<6){Oa=c[ca>>2]|0;if((a[H]|0)==0){GS(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{GS(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}if((c[ba>>2]|0)!=0){c[ba>>2]=0}Oa=c[F>>2]|0;if((Oa|0)>0){Ra=c[ca>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Qa=0;do{_=+U(+(+h[Ra+(Qa<<3)>>3]));h[Ya+(Qa<<3)>>3]=+ld(+_,+(+h[Pa+(Qa<<3)>>3]));Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[21300>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Rn(17,0,54232,t);rr(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}do{if(Va&(La|0)<7){if((a[H]|0)==0){break}GS(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;Oa=La+1|0;GS(Z|0,c[Fa>>2]|0,c[Y>>2]|0)|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[21300>>2]|0)==0){fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}Rn(17,0,54296,s);rr(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}}while(0);if(Va&(Ma|0)<1){GS(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;if((c[ba>>2]|0)==0){c[ba>>2]=1}h[V>>3]=X;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[21300>>2]|0)==0){fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}Rn(17,0,54368,r);rr(S,L,J,K,18);fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}if(Va&(Ma|0)<2){Oa=c[ca>>2]|0;if((a[H]|0)==0){GS(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{GS(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[ca>>2]|0;Pa=0;do{Ya=Qa+(Pa<<3)|0;h[Ya>>3]=+h[Ya>>3]*1.01;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[21300>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}Rn(17,0,54440,q);rr(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){GS(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{GS(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=0;do{Ya=Pa+(Qa<<3)|0;h[Ya>>3]=+h[Ya>>3]*.99;Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[21300>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}Rn(17,0,54512,p);rr(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<4){GS(c[ca>>2]|0,c[Ea>>2]|0,c[F>>2]<<3|0)|0;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[21300>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}Rn(17,0,54576,o);rr(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){GS(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{GS(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Ga>>2]|0;Pa=c[ja>>2]|0;Ya=0;do{_=+U(+(+h[Qa+(Ya<<3)>>3]));h[Pa+(Ya<<3)>>3]=!(_<=1.0e-16)?_:1.0e-16;Ya=Ya+1|0;}while((Ya|0)<(Oa|0))}Oa=Ma+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[21300>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}Rn(17,0,54648,n);rr(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(!(Va&(Na|0)<1)){if(!(Va&(Na|0)<6)){eb=160;break}Oa=c[ca>>2]|0;if((a[H]|0)==0){GS(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{GS(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}_=ea*10.0;h[V>>3]=X;c[ka>>2]=1;Oa=Na+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[21300>>2]|0)==0){ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Ya=l;h[k>>3]=_;c[Ya>>2]=c[k>>2];c[Ya+4>>2]=c[k+4>>2];Rn(17,0,54784,l);rr(S,L,J,K,18);ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Oa=c[ca>>2]|0;if((a[H]|0)==0){GS(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{GS(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Ya=c[ja>>2]|0;Pa=0;do{h[Ya+(Pa<<3)>>3]=1.0;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}c[ba>>2]=1;Oa=Na+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[21300>>2]|0)==0){hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib;continue}Rn(17,0,54712,m);rr(S,L,J,K,18);hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib}if((eb|0)==68){c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[21300>>2]|0)!=0){Rn(17,1,53984,y);c[x>>2]=La;c[x+4>>2]=Na+Ma;Rn(17,0,54e3,x);Yd[c[5446]&255](17);rr(S,L,J,K,17)}x=(c[ba>>2]|0)!=0;if(x){c[ba>>2]=0;jb=x}else{jb=0}GS(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;pr($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(!jb){kb=1;h[V>>3]=X;c[ka>>2]=1;bS(Z);i=e;return kb|0}c[ba>>2]=1;kb=1;h[V>>3]=X;c[ka>>2]=1;bS(Z);i=e;return kb|0}else if((eb|0)==160){if(!((db+ -2|0)>>>0<4)){kb=0;h[V>>3]=X;c[ka>>2]=1;bS(Z);i=e;return kb|0}if((a[Ha]|0)==0){sF(P,za,T);hb=+h[c[c[Aa>>2]>>2]>>3];Aa=f;T=P;c[Aa+0>>2]=c[T+0>>2];c[Aa+4>>2]=c[T+4>>2];c[Aa+8>>2]=c[T+8>>2];c[Aa+12>>2]=c[T+12>>2];c[Aa+16>>2]=c[T+16>>2];$o(0,f,hb);}if((c[21300>>2]|0)!=0){c[j>>2]=fa(fa(Ma,La)|0,Na)|0;Rn(17,0,54856,j);rr(S,L,J,K,17)}GS(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;kb=0;h[V>>3]=X;c[ka>>2]=1;bS(Z);i=e;return kb|0}return 0}function pr(b,d,e,f,g,j,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0;g=i;i=i+8|0;n=g;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16384|0;w=l;x=c[l+468>>2]|0;y=c[x+(m*80|0)+40>>2]|0;z=l+318|0;A=c[j>>2]|0;if((A|0)==1){B=y+8|0;do{if((c[B>>2]|0)!=0){C=c[b>>2]|0;if((C|0)<=0){break}D=c[y+12>>2]|0;E=0;do{F=d+(E<<3)|0;h[F>>3]=+h[F>>3]*+h[D+(E<<3)>>3];E=E+1|0;}while((E|0)<(C|0))}}while(0);if((c[21312>>2]|0)!=0){c[u>>2]=c[y+96>>2];Rn(20,0,55104,u);qr(d,b,20,55136)}ye[c[x+(m*80|0)+32>>2]&31](l,d,e,j);if((c[21312>>2]|0)!=0){qr(e,b,20,55152);c[t>>2]=c[y+96>>2];Rn(20,0,55168,t)}if((c[B>>2]|0)==0){i=g;return 0}B=c[b>>2]|0;if((B|0)<=0){i=g;return 0}t=c[y+12>>2]|0;j=0;do{u=d+(j<<3)|0;h[u>>3]=1.0/+h[t+(j<<3)>>3]*+h[u>>3];j=j+1|0;}while((j|0)<(B|0));i=g;return 0}else if((A|0)==2){B=(a[z]|0)!=0;if(B){a[z]=0}if((c[21312>>2]|0)!=0){Rn(20,0,55208,s)}if((c[x+(m*80|0)+28>>2]|0)==-1){tr(w,f,d,e,m)}else{sr(w,f,m)}do{if((c[21312>>2]|0)!=0){Rn(20,0,55248,r);if((c[21308>>2]|0)==0){break}m=v;w=c[b>>2]|0;c[q>>2]=w;c[q+4>>2]=w;Rn(19,1,53944,q);w=c[b>>2]|0;if((w|0)>0){e=y+20|0;d=w;w=0;do{a[m]=0;if((d|0)>0){x=0;do{G=+h[f+((fa(c[e>>2]|0,w)|0)+x<<3)>>3];c[p>>2]=m;s=p+4|0;h[k>>3]=G;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];gc(m|0,55280,p|0)|0;x=x+1|0;}while((x|0)<(c[b>>2]|0))}c[o>>2]=m;Rn(19,0,53976,o);w=w+1|0;d=c[b>>2]|0;}while((w|0)<(d|0))}Yd[c[5446]&255](19)}}while(0);if(!B){i=g;return 0}a[z]=1;i=g;return 0}else{g=c[l+536>>2]|0;c[n>>2]=A;Vn(g,55296,n)}return 0}function qr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0.0;f=i;i=i+16|0;g=f;j=i;i=i+8|0;if((c[21232+(d<<2)>>2]|0)==0){i=f;return}c[j>>2]=e;Rn(d,1,53976,j);if((c[b>>2]|0)>0){j=0;do{l=+h[a+(j<<3)>>3];c[g>>2]=j;e=g+4|0;h[k>>3]=l;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];Rn(d,0,55088,g);j=j+1|0;}while((j|0)<(c[b>>2]|0))}Yd[c[5446]&255](d);i=f;return}function rr(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0;g=i;i=i+24|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[21232+(f<<2)>>2]|0)==0){i=g;return}Rn(f,1,54896,q);Rn(f,1,54912,p);p=a+20|0;if((c[p>>2]|0)>0){q=a+24|0;r=a+64|0;s=0;do{t=+h[(c[q>>2]|0)+(s<<3)>>3];u=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=s;v=o+4|0;h[k>>3]=t;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=o+12|0;h[k>>3]=u;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];Rn(f,0,54928,o);s=s+1|0;}while((s|0)<(c[p>>2]|0))}Yd[c[5446]&255](f);Rn(f,1,54968,n);if((c[p>>2]|0)>0){n=a+28|0;s=a+4|0;a=0;do{u=+h[(c[n>>2]|0)+(a<<3)>>3];t=+h[(c[s>>2]|0)+(a<<3)>>3];c[m>>2]=a;o=m+4|0;h[k>>3]=u;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=m+12|0;h[k>>3]=t;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Rn(f,0,54984,m);a=a+1|0;}while((a|0)<(c[p>>2]|0))}Yd[c[5446]&255](f);Rn(f,1,55024,l);t=+h[d>>3];u=+h[e>>3];c[j>>2]=c[b>>2];b=j+4|0;h[k>>3]=t;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=j+12|0;h[k>>3]=u;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];Rn(f,0,55040,j);Yd[c[5446]&255](f);Yd[c[5446]&255](f);i=g;return}function sr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+40>>2]|0;j=c[f+(d*80|0)+28>>2]|0;k=g+20|0;l=c[k>>2]|0;IS(b|0,0,fa(l<<3,l)|0)|0;l=g+108|0;g=c[k>>2]|0;IS(c[l>>2]|0,0,fa(g<<3,g)|0)|0;g=a+464|0;k=c[g>>2]|0;if((c[k+(j*44|0)+24>>2]|0)==0){i=e;return}m=f+(d*80|0)+20|0;d=a;a=c[k+(j*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[f+(j*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(j*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}$d[c[m>>2]&127](d)|0;f=c[g>>2]|0;a=c[f+(j*44|0)>>2]|0;if((a|0)!=0){n=c[f+(j*44|0)+20>>2]|0;o=c[f+(j*44|0)+28>>2]|0;p=0;do{q=o+(p<<3)|0;do{if(+h[q>>3]==1.0){if((p|0)==0){r=f+(j*44|0)+8|0;s=0}else{t=f+(j*44|0)+8|0;r=t;s=c[(c[t>>2]|0)+(p+ -1<<2)>>2]|0}t=c[(c[r>>2]|0)+(p<<2)>>2]|0;if(!(s>>>0<t>>>0)){break}u=c[l>>2]|0;v=c[f+(j*44|0)+12>>2]|0;w=c[f+(j*44|0)+4>>2]|0;x=c[f+(j*44|0)+36>>2]|0;y=s;do{z=c[v+(y<<2)>>2]|0;A=(fa(w,p)|0)+z|0;B=+h[x+(z<<3)>>3];h[b+(A<<3)>>3]=B;h[u+(A<<3)>>3]=B;y=y+1|0;}while(y>>>0<t>>>0)}}while(0);if(((c[n+(p<<2)>>2]|0)+ -1|0)==(k|0)){h[q>>3]=0.0}p=p+1|0;}while(p>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(j*44|0)+24>>2]|0)>>>0);i=e;return}function tr(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0;g=i;i=i+8|0;j=g;k=c[(c[a+468>>2]|0)+(f*80|0)+40>>2]|0;l=k+56|0;m=+h[l>>3];n=+V(+m);c[j>>2]=1;o=k+20|0;p=o;if((c[o>>2]|0)<=0){i=g;return}q=k+128|0;r=k+108|0;s=k+112|0;k=a;t=m;a=0;while(1){m=+h[e+(a<<3)>>3];u=t*m;v=d+(a<<3)|0;w=+h[v>>3];if(!(w>=0.0)){x=-w}else{x=w}if(!(u>=0.0)){y=-u}else{y=u}u=+ld(+(n*+ld(+x,+y)),+n);if(!(m>=0.0)){z=-u}else{z=u}u=z+w-w;m=1.0/u;h[v>>3]=w+u;pr(p,d,c[q>>2]|0,c[r>>2]|0,s,j,k,f)|0;A=c[o>>2]|0;if((A|0)>0){B=c[q>>2]|0;C=c[r>>2]|0;D=0;do{E=(fa(A,a)|0)+D|0;u=m*(+h[B+(D<<3)>>3]- +h[e+(D<<3)>>3]);h[b+(E<<3)>>3]=u;h[C+(E<<3)>>3]=u;D=D+1|0;}while((D|0)<(A|0))}h[v>>3]=w;D=a+1|0;if((D|0)>=(A|0)){break}t=+h[l>>3];a=D}i=g;return}function ur(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=i;i=i+8|0;f=aS(80)|0;c[b>>2]=f;Un(0,(f|0)!=0|0,55376,e);c[f>>2]=0;e=a<<3;g=aS(e)|0;c[f+4>>2]=g;g=aS(e)|0;c[f+8>>2]=g;c[f+12>>2]=a;g=aS(e)|0;c[f+16>>2]=g;g=cS(a,8)|0;c[f+20>>2]=g;h[f+24>>3]=1.0e-8;h[f+32>>3]=1.0e-8;c[f+44>>2]=a*100;h[f+56>>3]=2.220446049250313e-16;g=aS(fa(e,a)|0)|0;c[f+64>>2]=g;g=aS(e)|0;c[f+68>>2]=g;g=aS(a<<2)|0;c[f+72>>2]=g;Un(0,(c[b>>2]|0)!=0|0,55408,d);i=d;return 0}function vr(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;bS(c[d+4>>2]|0);bS(c[d+8>>2]|0);bS(c[d+16>>2]|0);bS(c[d+20>>2]|0);bS(c[d+64>>2]|0);bS(c[d+68>>2]|0);bS(c[d+72>>2]|0);i=b;return 0}function wr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+28>>2]|0;j=c[(c[f+(d*80|0)+40>>2]|0)+12>>2]|0;IS(b|0,0,fa(j<<3,j)|0)|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=e;return 0}l=f+(d*80|0)+20|0;d=a;a=c[k+(g*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){m=0;do{if(((c[(c[f+(g*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(g*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}$d[c[l>>2]&127](d)|0;f=c[j>>2]|0;a=c[f+(g*44|0)>>2]|0;if((a|0)!=0){m=c[f+(g*44|0)+20>>2]|0;n=c[f+(g*44|0)+28>>2]|0;o=0;do{p=n+(o<<3)|0;do{if(+h[p>>3]==1.0){if((o|0)==0){q=f+(g*44|0)+8|0;r=0}else{s=f+(g*44|0)+8|0;q=s;r=c[(c[s>>2]|0)+(o+ -1<<2)>>2]|0}s=c[(c[q>>2]|0)+(o<<2)>>2]|0;if(!(r>>>0<s>>>0)){break}t=c[f+(g*44|0)+12>>2]|0;u=c[f+(g*44|0)+4>>2]|0;v=c[f+(g*44|0)+36>>2]|0;w=r;do{x=c[t+(w<<2)>>2]|0;y=(fa(u,o)|0)+x|0;h[b+(y<<3)>>3]=+h[v+(x<<3)>>3];w=w+1|0;}while(w>>>0<s>>>0)}}while(0);if(((c[m+(o<<2)>>2]|0)+ -1|0)==(k|0)){h[p>>3]=0.0}o=o+1|0;}while(o>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(g*44|0)+24>>2]|0)>>>0);i=e;return 0}function xr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=i;i=i+72|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+8|0;t=i;i=i+24|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+24|0;x=i;i=i+24|0;y=i;i=i+24|0;z=c[b+468>>2]|0;A=c[z+(d*80|0)+40>>2]|0;B=c[z+(d*80|0)+4>>2]|0;C=A+40|0;D=C;c[C>>2]=0;E=A+16|0;F=z+(d*80|0)+52|0;G=A+12|0;H=G;GS(c[E>>2]|0,c[F>>2]|0,c[G>>2]<<3|0)|0;I=b+56|0;if((c[21300>>2]|0)==0){J=b+4|0}else{sF(w,I,B);K=b+4|0;L=+h[c[c[K>>2]>>2]>>3];c[v>>2]=c[w+8>>2];w=v+4|0;h[k>>3]=L;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Rn(17,1,55448,v);if((c[G>>2]|0)>0){v=z+(d*80|0)+44|0;w=z+(d*80|0)+16|0;M=z+(d*80|0)+48|0;N=0;do{L=+h[(c[v>>2]|0)+(N<<3)>>3];c[u>>2]=N;O=u+4|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];Rn(17,1,55520,u);L=+h[(c[M>>2]|0)+(N<<3)>>3];P=+h[(c[F>>2]|0)+(N<<3)>>3];O=t;h[k>>3]=+h[(c[w>>2]|0)+(N<<3)>>3];c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+8|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+16|0;h[k>>3]=P;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];Rn(17,0,55536,t);Yd[c[5446]&255](17);N=N+1|0;}while((N|0)<(c[G>>2]|0))}Yd[c[5446]&255](17);J=K}K=b+318|0;N=A+20|0;t=A+24|0;w=A+56|0;F=A+44|0;M=A+64|0;u=A+68|0;v=A+72|0;O=A+48|0;Q=O;R=b;b=A+4|0;S=A+32|0;A=z+(d*80|0)+48|0;T=z+(d*80|0)+16|0;U=0;V=0;a:while(1){a[K]=1;W=c[E>>2]|0;X=c[N>>2]|0;Y=c[M>>2]|0;Z=c[u>>2]|0;_=c[v>>2]|0;c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];yr(H,W,X,+h[k>>3],w,c[F>>2]|0,D,Y,Z,_,Q,R,d);a[K]=0;if((c[O>>2]|0)==0){sF(x,I,B);P=+h[c[c[J>>2]>>2]>>3];_=g;Z=x;c[_+0>>2]=c[Z+0>>2];c[_+4>>2]=c[Z+4>>2];c[_+8>>2]=c[Z+8>>2];c[_+12>>2]=c[Z+12>>2];c[_+16>>2]=c[Z+16>>2];$o(3,g,P);}$=+Fp(H,c[b>>2]|0);aa=+Fp(H,c[N>>2]|0);P=+h[S>>3];if(!(!(aa<=P)&!($<=P))){if((c[O>>2]|0)>0){ba=12;break}}do{if((V|0)<1){GS(c[E>>2]|0,c[A>>2]|0,c[G>>2]<<3|0)|0;Z=c[C>>2]|0;Rn(17,0,55712,p);ca=Z}else{if((V|0)<2){Z=c[G>>2]|0;if((Z|0)>0){_=c[T>>2]|0;Y=c[E>>2]|0;X=0;do{W=Y+(X<<3)|0;h[W>>3]=+h[_+(X<<3)>>3]*.01+ +h[W>>3];X=X+1|0;}while((X|0)<(Z|0))}Z=c[C>>2]|0;Rn(17,0,55768,o);ca=Z;break}if((V|0)>=3){ba=28;break a}Z=c[G>>2]|0;if((Z|0)>0){X=c[T>>2]|0;_=c[E>>2]|0;Y=0;do{h[_+(Y<<3)>>3]=+h[X+(Y<<3)>>3];Y=Y+1|0;}while((Y|0)<(Z|0))}Z=c[C>>2]|0;Rn(17,0,55832,n);ca=Z}}while(0);U=ca+U|0;V=V+1|0}do{if((ba|0)==12){if((c[21300>>2]|0)==0){da=1;break}ca=(c[C>>2]|0)+U|0;c[s>>2]=V;Rn(17,0,55584,s);c[r>>2]=ca;ca=r+4|0;h[k>>3]=aa;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=r+12|0;h[k>>3]=$;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];Rn(17,0,55624,r);if((c[G>>2]|0)>0){ea=0}else{da=1;break}while(1){P=+h[(c[E>>2]|0)+(ea<<3)>>3];L=+h[(c[N>>2]|0)+(ea<<3)>>3];c[q>>2]=ea;ca=q+4|0;h[k>>3]=P;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=q+12|0;h[k>>3]=L;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];Rn(17,0,55680,q);ca=ea+1|0;if((ca|0)<(c[G>>2]|0)){ea=ca}else{da=1;break}}}else if((ba|0)==28){sF(y,I,B);L=+h[c[c[J>>2]>>2]>>3];ca=f;n=y;c[ca+0>>2]=c[n+0>>2];c[ca+4>>2]=c[n+4>>2];c[ca+8>>2]=c[n+8>>2];c[ca+12>>2]=c[n+12>>2];c[ca+16>>2]=c[n+16>>2];$o(0,f,L);if((c[21300>>2]|0)==0){da=0;break}c[m>>2]=V;Rn(17,0,55912,m);c[l>>2]=U;n=l+4|0;h[k>>3]=aa;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l+12|0;h[k>>3]=$;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Rn(17,0,55624,l);if((c[21300>>2]|0)==0){da=0;break}if((c[G>>2]|0)>0){fa=0}else{da=0;break}while(1){L=+h[(c[E>>2]|0)+(fa<<3)>>3];P=+h[(c[N>>2]|0)+(fa<<3)>>3];c[j>>2]=fa;n=j+4|0;h[k>>3]=L;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=j+12|0;h[k>>3]=P;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Rn(17,0,55680,j);n=fa+1|0;if((n|0)<(c[G>>2]|0)){fa=n}else{da=0;break}}}}while(0);if((c[21300>>2]|0)==0){ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;GS(ma|0,oa|0,qa|0)|0;i=e;return da|0}Yd[c[5446]&255](17);ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;GS(ma|0,oa|0,qa|0)|0;i=e;return da|0}function yr(b,d,e,f,g,j,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0;s=i;i=i+8|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+4096|0;E=q;F=c[q+468>>2]|0;G=c[F+(r*80|0)+40>>2]|0;H=+h[G+32>>3];c[B>>2]=1;c[C>>2]=1;do{if((c[21304>>2]|0)!=0){c[z>>2]=j;Rn(18,0,55952,z);if((c[b>>2]|0)>0){I=0}else{break}do{J=+h[d+(I<<3)>>3];c[y>>2]=I;K=y+4|0;h[k>>3]=J;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];Rn(18,0,56e3,y);I=I+1|0;}while((I|0)<(c[b>>2]|0))}}while(0);c[p>>2]=1;I=F+(r*80|0)+28|0;F=D;D=G+12|0;y=G+8|0;z=G+4|0;K=G+20|0;L=G+64|0;G=j;a:while(1){zr(d,e,A,q,r)|0;c[l>>2]=(c[l>>2]|0)+1;if((c[I>>2]|0)==-1){Ar(b,d,e,m,+h[g>>3],A,n,q,r);c[l>>2]=(c[b>>2]|0)+(c[l>>2]|0)}else{wr(E,m,r)|0}if((c[21308>>2]|0)!=0){j=c[b>>2]|0;c[x>>2]=j;c[x+4>>2]=j;Rn(19,1,56016,x);if((c[D>>2]|0)>0){j=0;do{a[F]=0;if((c[D>>2]|0)>0){M=0;do{J=+h[m+((fa(c[b>>2]|0,j)|0)+M<<3)>>3];c[w>>2]=F;N=w+4|0;h[k>>3]=J;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];gc(F|0,56040,w|0)|0;M=M+1|0;}while((M|0)<(c[D>>2]|0))}c[v>>2]=F;Rn(19,0,56048,v);j=j+1|0;}while((j|0)<(c[D>>2]|0))}Yd[c[5446]&255](19)}j=c[D>>2]|0;if((j|0)>0){M=c[z>>2]|0;N=c[K>>2]|0;O=c[y>>2]|0;P=0;Q=0;while(1){R=M+(P<<3)|0;h[R>>3]=1.0e-16;S=c[L>>2]|0;T=(j|0)>1?j:1;J=1.0e-16;V=0;W=Q;while(1){X=+U(+(+h[S+(W<<3)>>3]));Y=X>J?X:J;h[R>>3]=Y;Z=V+1|0;if((Z|0)<(j|0)){W=W+1|0;V=Z;J=Y}else{break}}h[O+(P<<3)>>3]=+h[N+(P<<3)>>3]*(1.0/Y);V=P+1|0;if((V|0)<(j|0)){P=V;Q=Q+T|0}else{_=O;break}}}else{_=c[y>>2]|0}J=+Fp(b,_);if(!(!(J<=H)&!(+Fp(b,e)<=H))){$=31;break}Ji(b,B,m,b,o,e,b,C)|0;O=c[C>>2]|0;do{if((O|0)>0){c[p>>2]=-1;Tn(17,0,56056,u)}else{if((O|0)<0){c[p>>2]=-1;c[t>>2]=O;Tn(17,0,56088,t);break}Q=c[b>>2]|0;if((Q|0)>0){P=0;do{j=d+(P<<3)|0;h[j>>3]=+h[j>>3]- +h[e+(P<<3)>>3];P=P+1|0;}while((P|0)<(Q|0))}if(+Fp(b,e)<=f){$=31;break a}}}while(0);if((G|0)<1){$=30;break}if((c[p>>2]|0)>-1){G=G+ -1|0}else{$=31;break}}if(($|0)==30){c[p>>2]=-1;i=s;return}else if(($|0)==31){i=s;return}}function zr(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;ye[c[(c[e+468>>2]|0)+(f*80|0)+32>>2]&31](e,a,b,d);i=g;return 0}function Ar(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0;m=i;n=+V(+f);if((c[a>>2]|0)<=0){i=m;return}o=(c[(c[k+468>>2]|0)+(l*80|0)+56>>2]|0)==0;p=0;do{f=+h[b+(p<<3)>>3];if(o){if(!(f>=0.0)){q=-f}else{q=f}r=n*+ld(1.0,+q);if(!(+h[d+(p<<3)>>3]>=0.0)){s=-r}else{s=r}t=s+f-f}else{t=1.0}u=b+(p<<3)|0;h[u>>3]=t+f;r=1.0/t;zr(b,j,g,k,l)|0;v=c[a>>2]|0;if((v|0)>0){w=0;do{x=(fa(v,p)|0)+w|0;h[e+(x<<3)>>3]=r*(+h[j+(w<<3)>>3]- +h[d+(w<<3)>>3]);w=w+1|0;}while((w|0)<(v|0))}h[u>>3]=f;p=p+1|0;}while((p|0)<(v|0));i=m;return}function Br(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+24>>2]|0;if((e|0)==2){Cr(a,b);f=0;i=d;return f|0}else if((e|0)==1){g=c[a+4>>2]|0;j=c[g+4>>2]|0;Dr(c[g>>2]|0,+h[j>>3],c[j+8>>2]|0,c[a+112>>2]|0,b);f=0;i=d;return f|0}else if((e|0)==4){je[c[(c[a+540>>2]|0)+56>>2]&1](a,+h[b+8>>3])|0;h[b>>3]=+h[c[c[a+4>>2]>>2]>>3];f=0;i=d;return f|0}else if((e|0)==3){f=Xp(a,b)|0;i=d;return f|0}else{f=1;i=d;return f|0}return 0}function Cr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0;d=i;e=c[c[b+48>>2]>>2]|0;f=c[a+4>>2]|0;g=c[f>>2]|0;j=c[f+4>>2]|0;f=g+8|0;k=c[f>>2]|0;l=a+112|0;m=c[l>>2]|0;n=j+8|0;o=c[n>>2]|0;p=j;j=b+8|0;q=b;h[q>>3]=+h[p>>3]+ +h[j>>3];if((m|0)>0){b=c[e>>2]|0;r=0;do{h[b+(r<<3)>>3]=+h[o+(r+m<<3)>>3];r=r+1|0;}while((r|0)<(m|0))}r=g;g=a+540|0;o=m;b=1;do{if((o|0)>0){s=c[n>>2]|0;t=+h[56120+(b<<3)>>3];u=c[e+(b+ -1<<2)>>2]|0;v=c[f>>2]|0;w=0;while(1){h[v+(w<<3)>>3]=+h[s+(w<<3)>>3]+ +h[j>>3]*t*+h[u+(w<<3)>>3];x=w+1|0;if((x|0)<(o|0)){w=x}else{y=t;break}}}else{y=+h[56120+(b<<3)>>3]}h[r>>3]=+h[p>>3]+y*+h[j>>3];$d[c[(c[g>>2]|0)+28>>2]&127](a)|0;o=c[l>>2]|0;z=(o|0)>0;if(z){w=c[e+(b<<2)>>2]|0;u=0;do{h[w+(u<<3)>>3]=+h[k+(u+m<<3)>>3];u=u+1|0;}while((u|0)<(o|0))}b=b+1|0;}while((b|0)<4);if(!z){A=+h[q>>3];h[r>>3]=A;i=d;return}z=c[n>>2]|0;n=c[f>>2]|0;f=c[e>>2]|0;b=c[e+4>>2]|0;m=c[e+8>>2]|0;k=c[e+12>>2]|0;e=0;do{h[n+(e<<3)>>3]=+h[z+(e<<3)>>3]+(+h[f+(e<<3)>>3]*.16666666666666666+0.0+ +h[b+(e<<3)>>3]*.3333333333333333+ +h[m+(e<<3)>>3]*.3333333333333333+ +h[k+(e<<3)>>3]*.16666666666666666)*+h[j>>3];e=e+1|0;}while((e|0)<(o|0));A=+h[q>>3];h[r>>3]=A;i=d;return}function Dr(a,b,d,e,f){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0;g=i;j=f+8|0;k=+h[j>>3];l=k+b;m=f;h[m>>3]=l;if((e|0)<=0){n=l;o=a;p=o;h[p>>3]=n;i=g;return}f=c[a+8>>2]|0;l=k;q=0;while(1){h[f+(q<<3)>>3]=+h[d+(q<<3)>>3]+ +h[d+(q+e<<3)>>3]*l;r=q+1|0;if((r|0)>=(e|0)){break}l=+h[j>>3];q=r}n=+h[m>>3];o=a;p=o;h[p>>3]=n;i=g;return}function Er(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+8|0;f=e;h[d>>3]=+h[b+240>>3];h[d+8>>3]=+h[b+264>>3];h[d+16>>3]=0.0;a[d+28|0]=0;c[d+32>>2]=Yn(4)|0;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;g=c[d+24>>2]|0;a:do{if((g|0)==4){j=c[352]|0;k=aS(j<<2)|0;c[14044]=k;if((j|0)<=0){l=0;break}m=c[b+116>>2]|0;n=k;k=0;while(1){c[n+(k<<2)>>2]=cS(m,8)|0;o=k+1|0;if((o|0)>=(j|0)){l=0;break a}n=c[14044]|0;k=o}}else if((g|0)==3){k=aS(88)|0;Rn(23,0,56152,f);n=Vp(b,d,k)|0;c[d+48>>2]=k;l=n}else if((g|0)==2){n=aS(8)|0;c[n+4>>2]=4;k=aS(20)|0;c[n>>2]=k;j=c[b+112>>2]|0;m=k;k=0;while(1){c[m+(k<<2)>>2]=cS(j,8)|0;if((k|0)>=4){break}m=c[n>>2]|0;k=k+1|0}c[d+48>>2]=n;l=0}else{l=0}}while(0);Rr(b)|0;if((c[2]|0)==0){i=e;return l|0}Yo(6);Vo(1);i=e;return l|0}function Fr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[b+24>>2]|0;if((e|0)==2){f=b+48|0;g=c[f>>2]|0;h=c[g>>2]|0;if((c[g+4>>2]|0)>-1){g=h;j=0;while(1){bS(c[g+(j<<2)>>2]|0);k=c[f>>2]|0;l=c[k>>2]|0;if((j|0)<(c[k+4>>2]|0)){j=j+1|0;g=l}else{m=l;break}}}else{m=h}bS(m);bS(c[f>>2]|0)}else if((e|0)==4){f=c[352]|0;m=c[14044]|0;if((f|0)>0){h=m;g=0;while(1){bS(c[h+(g<<2)>>2]|0);j=g+1|0;l=c[14044]|0;if((j|0)<(f|0)){g=j;h=l}else{n=l;break}}}else{n=m}bS(n)}else if((e|0)==3){Wp(c[b+48>>2]|0)|0}Sr(a)|0;Mr(a);i=d;return 0}function Gr(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+168|0;c[o>>2]=0;p=i;i=i+160|0;q=b+536|0;r=c[q>>2]|0;u=0;pa(155,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){t=RS(c[s>>2]|0,o)|0;if((t|0)==0){db(s|0,v|0)}J=v}else{t=-1}do{if((t|0)==1){w=0;x=0;y=0;z=0;A=J}else{u=0;sa(97,b|0)|0;s=u;u=0;if((s|0)!=0&(v|0)!=0){B=RS(c[s>>2]|0,o)|0;if((B|0)==0){db(s|0,v|0)}J=v}else{B=-1}if((B|0)==1){w=0;x=0;y=0;z=0;A=J;break}s=b+540|0;u=0;sa(c[(c[s>>2]|0)+40>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){D=RS(c[C>>2]|0,o)|0;if((D|0)==0){db(C|0,v|0)}J=v}else{D=-1}if((D|0)==1){w=0;x=0;y=0;z=0;A=J;break}if((a[b+440|0]|0)!=0){u=0;sa(c[(c[s>>2]|0)+44>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){E=RS(c[C>>2]|0,o)|0;if((E|0)==0){db(C|0,v|0)}J=v}else{E=-1}if((E|0)==1){w=0;x=0;y=0;z=0;A=J;break}}C=b+240|0;h[c[c[b+4>>2]>>2]>>3]=+h[C>>3];u=0;pa(c[(c[s>>2]|0)+4>>2]|0,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){F=RS(c[s>>2]|0,o)|0;if((F|0)==0){db(s|0,v|0)}J=v}else{F=-1}if((F|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;pa(156,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){G=RS(c[s>>2]|0,o)|0;if((G|0)==0){db(s|0,v|0)}J=v}else{G=-1}if((G|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;oa(1,+(+h[b+272>>3]));s=u;u=0;if((s|0)!=0&(v|0)!=0){H=RS(c[s>>2]|0,o)|0;if((H|0)==0){db(s|0,v|0)}J=v}else{H=-1}if((H|0)==1){w=0;x=0;y=0;z=C;A=J;break}c[(c[q>>2]|0)+84>>2]=1;s=p;I=r+80|0;K=c[I>>2]|0;c[I>>2]=p;DS(p,1,o|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=RS(c[L>>2]|0,o)|0;if((M|0)==0){db(L|0,v|0)}J=v}else{M=-1}if((M|0)==1){w=K;x=I;y=s;z=C;A=J;break}w=K;x=I;y=s;z=C;A=0}}while(0);a:while(1){do{if((A|0)==0){u=0;M=Ia(1,b|0,d|0,e|0,f|0,+g,j|0)|0;p=u;u=0;if((p|0)!=0&(v|0)!=0){N=RS(c[p>>2]|0,o)|0;if((N|0)==0){db(p|0,v|0)}J=v}else{N=-1}if((N|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}if((M|0)==0){S=0;T=1;break}u=0;Ra(14,1,0,56184,n|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){U=RS(c[M>>2]|0,o)|0;if((U|0)==0){db(M|0,v|0)}J=v}else{U=-1}if((U|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}h[b+248>>3]=+h[z>>3];S=-1;T=1}else{S=0;T=0}}while(0);c[x>>2]=w;u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){V=RS(c[M>>2]|0,o)|0;if((V|0)==0){db(M|0,v|0)}J=v}else{V=-1}if((V|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if(T){W=S}else{u=0;Ra(15,2,0,56280,m|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){X=RS(c[M>>2]|0,o)|0;if((X|0)==0){db(M|0,v|0)}J=v}else{X=-1}if((X|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}W=-1}u=0;qa(c[62400>>2]|0,62376,b|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Y=RS(c[M>>2]|0,o)|0;if((Y|0)==0){db(M|0,v|0)}J=v}else{Y=-1}if((Y|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}u=0;Ra(15,23,0,56336,l|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Z=RS(c[M>>2]|0,o)|0;if((Z|0)==0){db(M|0,v|0)}J=v}else{Z=-1}if((Z|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if((c[2]|0)==0){_=26;break}u=0;pa(157,1);M=u;u=0;if((M|0)!=0&(v|0)!=0){$=RS(c[M>>2]|0,o)|0;if(($|0)==0){db(M|0,v|0)}J=v}else{$=-1}if(($|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R}else{break}}if((_|0)==26){i=k;return W|0}i=k;return W|0}function Hr(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=+h[d>>3];do{if(H>=+h[b+248>>3]){if((c[d+24>>2]|0)==5){break}I=G;h[k>>3]=H;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];Rn(8,0,56432,G);I=b+313|0;a[I]=1;tq(b);if((c[77708>>2]|0)==0){Zd[c[62396>>2]&63](62376,b)}a[I]=0}}while(0);if((e|0)!=0){Ir(rd(e|0)|0,b)}if((c[21332>>2]|0)==0){i=f;return 0}Yo(0);Rn(25,0,56480,F);Rn(25,1,56504,E);H=+Qo(6);J=+Qo(6);K=J/+Qo(0)*100.0;E=D;h[k>>3]=H;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=K;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Rn(25,0,56512,D);K=+Qo(1);H=+Qo(1);J=H/+Qo(0)*100.0;D=C;h[k>>3]=K;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=J;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];Rn(25,0,56552,C);J=+Qo(2);K=+Qo(2);H=K/+Qo(0)*100.0;C=B;h[k>>3]=J;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+8|0;h[k>>3]=H;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Rn(25,0,56584,B);H=+Qo(3);J=+Qo(3);K=J/+Qo(0)*100.0;B=A;h[k>>3]=H;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=K;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];Rn(25,0,56608,A);K=+Qo(4);H=+Qo(4);J=H/+Qo(0)*100.0;A=z;h[k>>3]=K;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=J;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Rn(25,0,56648,z);J=+Qo(7);K=+Qo(7);H=K/+Qo(0)*100.0;z=y;h[k>>3]=J;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Rn(25,0,56680,y);y=d+24|0;z=(c[y>>2]|0)==5;H=+Qo(0);J=H- +Qo(7);H=J- +Qo(4);J=H- +Qo(3);H=J- +Qo(2);J=H- +Qo(1);H=J- +Qo(6);J=+Qo(0);K=J- +Qo(7);J=K- +Qo(4);K=J- +Qo(3);J=K- +Qo(2);K=J- +Qo(1);J=K- +Qo(6);K=J/+Qo(0)*100.0;if(z){z=w;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=w+8|0;h[k>>3]=K;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Rn(25,0,56744,w)}else{w=x;h[k>>3]=H;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=x+8|0;h[k>>3]=K;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Rn(25,0,56712,x)}K=+Qo(0);H=+Qo(0);J=H/+Qo(0)*100.0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=v+8|0;h[k>>3]=J;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Rn(25,0,56776,v);Yd[c[5446]&255](25);Rn(25,1,56800,u);c[t>>2]=c[d+40>>2];Rn(25,0,56808,t);c[s>>2]=c[d+44>>2];Rn(25,0,56832,s);Yd[c[5446]&255](25);s=c[y>>2]|0;if((s|0)==3){y=d+48|0;d=c[y>>2]|0;t=c[d+8>>2]|0;u=c[d+4>>2]|0;c[u>>2]=(c[u>>2]|0)+(c[t>>2]|0);d=u+4|0;c[d>>2]=(c[d>>2]|0)+(c[t+4>>2]|0);d=u+8|0;c[d>>2]=(c[d>>2]|0)+(c[t+8>>2]|0);d=u+12|0;c[d>>2]=(c[d>>2]|0)+(c[t+12>>2]|0);d=u+16|0;c[d>>2]=(c[d>>2]|0)+(c[t+16>>2]|0);Rn(25,1,56856,r);c[q>>2]=c[c[(c[y>>2]|0)+4>>2]>>2];Rn(25,0,56872,q);c[p>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+4>>2];Rn(25,0,56888,p);c[o>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+8>>2];Rn(25,0,56920,o);c[n>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+12>>2];Rn(25,0,56952,n);c[m>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+16>>2];Rn(25,0,56976,m);Yd[c[5446]&255](25)}else if((s|0)!=5){Rn(25,1,57008,l);Rn(25,0,57016,j);Yd[c[5446]&255](25)}Rn(25,0,57080,g);Vo(0);i=f;return 0}function Ir(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+16|0;y=i;i=i+8|0;z=Vb(b|0,57552)|0;b=c[t>>2]|0;A=d+4|0;B=y;h[k>>3]=+h[c[c[A>>2]>>2]>>3];c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];od(b|0,57560,y|0)|0;if((z|0)==0){C=Jd(10,b|0)|0;D=md(b|0)|0;i=e;return}y=d+116|0;B=d+124|0;E=d+128|0;F=d+132|0;G=d+216|0;H=d+220|0;I=d+224|0;J=d+228|0;K=d+136|0;L=d+140|0;M=d+144|0;N=d+148|0;O=d+36|0;P=d+428|0;Q=d+32|0;R=d+424|0;S=d+28|0;T=d+420|0;U=d+24|0;V=d+416|0;W=d+52|0;X=d+48|0;Y=d+44|0;Z=d+40|0;_=d+20|0;$=d+16|0;aa=d+12|0;ba=d+8|0;d=z;do{z=c[y>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((AS(d,c[(c[ba>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];c[x>>2]=d;ea=x+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];od(b|0,57576,x|0)|0;fa=c[y>>2]|0}else{fa=ca}ea=z+1|0;if((ea|0)<(fa|0)){ca=fa;z=ea}else{break}}}z=c[B>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((AS(d,c[(c[aa>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(z<<2)>>2]|0;c[w>>2]=d;c[w+4>>2]=ea;od(b|0,57592,w|0)|0;ga=c[B>>2]|0}else{ga=ca}ea=z+1|0;if((ea|0)<(ga|0)){ca=ga;z=ea}else{break}}}z=c[E>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((AS(d,c[(c[$>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+z|0]|0;c[v>>2]=d;c[v+4>>2]=ea;od(b|0,57600,v|0)|0;ha=c[E>>2]|0}else{ha=ca}ea=z+1|0;if((ea|0)<(ha|0)){ca=ha;z=ea}else{break}}}z=c[F>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((AS(d,c[(c[_>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(z<<2)>>2]|0;c[u>>2]=d;c[u+4>>2]=ea;od(b|0,57608,u|0)|0;ia=c[F>>2]|0}else{ia=ca}ea=z+1|0;if((ea|0)<(ia|0)){ca=ia;z=ea}else{break}}}if((c[G>>2]|0)>0){z=0;do{ca=c[Z>>2]|0;do{if((AS(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(c[ca+(z*52|0)+4>>2]<<3)>>3];if((c[ca+(z*52|0)>>2]|0)==0){c[r>>2]=d;ea=r+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];od(b|0,57576,r|0)|0;break}else{c[s>>2]=d;ea=s+4|0;h[k>>3]=-da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];od(b|0,57576,s|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[G>>2]|0))}if((c[H>>2]|0)>0){z=0;do{ca=c[Y>>2]|0;do{if((AS(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(c[ca+(z*52|0)+4>>2]<<2)>>2]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[p>>2]=d;c[p+4>>2]=ea;od(b|0,57592,p|0)|0;break}else{c[q>>2]=d;c[q+4>>2]=0-ea;od(b|0,57592,q|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[H>>2]|0))}if((c[I>>2]|0)>0){z=0;do{ca=c[X>>2]|0;do{if((AS(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+(c[ca+(z*52|0)+4>>2]|0)|0]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[n>>2]=d;c[n+4>>2]=ea;od(b|0,57600,n|0)|0;break}else{c[o>>2]=d;c[o+4>>2]=0-ea;od(b|0,57600,o|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[I>>2]|0))}z=c[J>>2]|0;if((z|0)>0){ca=z;z=0;while(1){ea=c[W>>2]|0;if((AS(d,c[ea+(z*52|0)+16>>2]|0)|0)==0){ja=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(c[ea+(z*52|0)+4>>2]<<2)>>2]|0;c[m>>2]=d;c[m+4>>2]=ja;od(b|0,57608,m|0)|0;ka=c[J>>2]|0}else{ka=ca}ja=z+1|0;if((ja|0)<(ka|0)){ca=ka;z=ja}else{break}}}z=c[K>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((AS(d,c[(c[U>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[V>>2]|0)+(z<<3)>>3];c[l>>2]=d;ja=l+4|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];od(b|0,57576,l|0)|0;la=c[K>>2]|0}else{la=ca}ja=z+1|0;if((ja|0)<(la|0)){ca=la;z=ja}else{break}}}z=c[L>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((AS(d,c[(c[S>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ja=c[(c[T>>2]|0)+(z<<2)>>2]|0;c[j>>2]=d;c[j+4>>2]=ja;od(b|0,57592,j|0)|0;ma=c[L>>2]|0}else{ma=ca}ja=z+1|0;if((ja|0)<(ma|0)){ca=ma;z=ja}else{break}}}z=c[M>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((AS(d,c[(c[Q>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ja=a[(c[R>>2]|0)+z|0]|0;c[g>>2]=d;c[g+4>>2]=ja;od(b|0,57600,g|0)|0;na=c[M>>2]|0}else{na=ca}ja=z+1|0;if((ja|0)<(na|0)){ca=na;z=ja}else{break}}}z=c[N>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((AS(d,c[(c[O>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ja=c[(c[P>>2]|0)+(z<<2)>>2]|0;c[f>>2]=d;c[f+4>>2]=ja;od(b|0,57608,f|0)|0;oa=c[N>>2]|0}else{oa=ca}ja=z+1|0;if((ja|0)<(oa|0)){ca=oa;z=ja}else{break}}}d=Vb(0,57552)|0;}while((d|0)!=0);C=Jd(10,b|0)|0;D=md(b|0)|0;i=e;return}function Jr(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;m=i;i=i+16|0;n=m;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+56|0;t=s;u=s+24|0;c[u>>2]=j;a:do{switch(j|0){case 5:{Tn(1,0,57176,q);v=1;i=m;return v|0};case 11:case 10:case 9:case 6:case 7:case 8:{Tn(1,0,57104,r);v=1;i=m;return v|0};case 18:{w=c[350]|0;do{if((w|0)!=0){if((AS(w,57360)|0)!=0){break}c[u>>2]=4;break a}}while(0);Rn(23,0,57384,o);v=1;i=m;return v|0};case 17:case 16:case 15:case 14:case 13:case 12:{c[u>>2]=3;break};case 4:{w=c[350]|0;if((w|0)!=0){if((AS(w,57216)|0)==0){break a}}Rn(23,0,57232,p);v=1;i=m;return v|0};default:{}}}while(0);p=Er(a,s)|0;se[c[22132>>2]&7]()|0;do{if((p|0)==0){o=Gr(a,b,d,e,f,g)|0;se[c[22132>>2]&7]()|0;if((o|0)!=0){x=o;break}if((c[u>>2]|0)!=5){Zd[c[62396>>2]&63](62376,a);Dq(a)}y=+h[a+248>>3];o=n;h[k>>3]=+h[a+240>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=y;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Rn(23,0,57512,n);o=ne[c[c[a+540>>2]>>2]&63](a,t)|0;se[c[22132>>2]&7]()|0;Hr(a,s,l)|0;se[c[22132>>2]&7]()|0;x=o}else{se[c[22132>>2]&7]()|0;x=p}}while(0);Fr(a,s)|0;v=x;i=m;return v|0}function Kr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=a+204|0;if((c[e>>2]|0)<=0){Lr(a);i=b;return}f=a+488|0;g=a;h=0;while(1){j=h+1|0;if(($d[c[(c[f>>2]|0)+(h*48|0)+40>>2]&127](g)|0)!=0){k=5;break}if((j|0)<(c[e>>2]|0)){h=j}else{k=6;break}}if((k|0)==5){Vn(c[a+536>>2]|0,57624,d)}else if((k|0)==6){Lr(a);i=b;return}}function Lr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;f=a+12|0;g=a+4|0;a=0;do{h=c[e>>2]|0;j=(c[c[h+(a*48|0)+12>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0;k=c[(c[c[g>>2]>>2]|0)+12>>2]|0;l=h+(a*48|0)|0;m=h+(a*48|0)+4|0;IS(k+(j<<2)|0,0,fa(c[l>>2]<<2,c[m>>2]|0)|0)|0;n=h+(a*48|0)+8|0;if((c[n>>2]|0)>0){o=c[h+(a*48|0)+16>>2]|0;p=0;do{c[o+(p<<2)>>2]=p;p=p+1|0;}while((p|0)<(c[n>>2]|0))}n=c[l>>2]|0;if((n|0)>0){p=c[h+(a*48|0)+20>>2]|0;o=n;n=0;do{c[p+(n<<2)>>2]=o+~n;n=n+1|0;o=c[l>>2]|0;}while((n|0)<(o|0))}o=c[m>>2]|0;if((o|0)>0){n=o;o=0;do{c[k+(o+j+(fa(n,o)|0)<<2)>>2]=1;o=o+1|0;n=c[m>>2]|0;}while((o|0)<(n|0))}a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function Mr(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;a=0;do{f=c[e>>2]|0;bS(c[f+(a*48|0)+28>>2]|0);bS(c[f+(a*48|0)+32>>2]|0);bS(c[f+(a*48|0)+16>>2]|0);bS(c[f+(a*48|0)+20>>2]|0);bS(c[f+(a*48|0)+24>>2]|0);a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function Nr(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+4096|0;p=b+204|0;if((c[p>>2]|0)<=0){q=0;i=f;return q|0}r=b+488|0;s=d<<24>>24==0;d=(e|0)==0;t=0;u=0;while(1){v=c[r>>2]|0;w=v+(u*48|0)|0;x=aS(c[w>>2]<<2)|0;y=v+(u*48|0)+8|0;z=aS(c[y>>2]<<2)|0;Or(b,u);A=v+(u*48|0)+20|0;B=c[A>>2]|0;C=c[w>>2]|0;GS(x|0,B|0,C<<2|0)|0;D=v+(u*48|0)+16|0;E=c[D>>2]|0;F=c[y>>2]|0;GS(z|0,E|0,F<<2|0)|0;G=v+(u*48|0)+24|0;if(!((Up(c[G>>2]|0,F,C,E,B)|0)==0|s)){break}B=Pr(x,c[A>>2]|0,c[w>>2]|0,c[y>>2]|0,c[v+(u*48|0)+4>>2]|0,c[v+(u*48|0)+12>>2]|0,c[v+(u*48|0)+28>>2]|0,c[v+(u*48|0)+32>>2]|0,b,e)|0;if(d){GS(c[A>>2]|0,x|0,c[w>>2]<<2|0)|0;GS(c[D>>2]|0,z|0,c[y>>2]<<2|0)|0}y=(B|0)==0?t:1;bS(x);bS(z);z=u+1|0;if((z|0)<(c[p>>2]|0)){t=y;u=z}else{q=y;H=15;break}}if((H|0)==15){i=f;return q|0}q=o;o=v+(u*48|0)+44|0;f=c[o>>2]|0;H=b+464|0;t=c[H>>2]|0;p=c[t+(f*44|0)>>2]|0;c[n>>2]=c[t+(f*44|0)+4>>2];c[n+4>>2]=p;c[n+8>>2]=f;Tn(5,1,57680,n);n=c[H>>2]|0;if((c[n+((c[o>>2]|0)*44|0)+4>>2]|0)!=0){f=n;n=0;do{a[q]=0;p=c[f+((c[o>>2]|0)*44|0)>>2]|0;if((p|0)!=0){t=p;p=0;do{d=(fa(t,n)|0)+p|0;I=+h[(c[G>>2]|0)+(d<<3)>>3];c[m>>2]=q;d=m+4|0;h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];gc(q|0,57712,m|0)|0;p=p+1|0;t=c[(c[H>>2]|0)+((c[o>>2]|0)*44|0)>>2]|0;}while(p>>>0<t>>>0)}c[l>>2]=q;Tn(5,0,57720,l);n=n+1|0;f=c[H>>2]|0;}while(n>>>0<(c[f+((c[o>>2]|0)*44|0)+4>>2]|0)>>>0)}if((c[w>>2]|0)<=0){J=21784;K=c[5446]|0;Yd[K&255](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=4;_=Z;$=57728;aa=$;Vn(O,aa,g)}o=v+(u*48|0)+32|0;u=0;do{c[j>>2]=c[(c[(c[o>>2]|0)+(u<<2)>>2]|0)+4>>2];Tn(5,0,57720,j);u=u+1|0;}while((u|0)<(c[w>>2]|0));J=21784;K=c[5446]|0;Yd[K&255](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=4;_=Z;$=57728;aa=$;Vn(O,aa,g);return 0}function Or(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+488|0;f=c[e>>2]|0;g=c[f+(b*48|0)+44>>2]|0;j=a+464|0;k=c[j>>2]|0;l=c[f+(b*48|0)+24>>2]|0;IS(l|0,0,fa(c[k+(g*44|0)+4>>2]<<3,c[k+(g*44|0)>>2]|0)|0)|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=d;return}f=a;a=c[k+(g*44|0)>>2]|0;m=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[m+(g*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}$d[c[(c[e>>2]|0)+(b*48|0)+36>>2]&127](f)|0;m=c[j>>2]|0;a=c[m+(g*44|0)>>2]|0;do{if((a|0)!=0){n=c[m+(g*44|0)+28>>2]|0;o=0;do{do{if(+h[n+(o<<3)>>3]==1.0){if((o|0)==0){p=m+(g*44|0)+8|0;q=0}else{r=m+(g*44|0)+8|0;p=r;q=c[(c[r>>2]|0)+(o+ -1<<2)>>2]|0}r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if(!(q>>>0<r>>>0)){break}s=c[m+(g*44|0)+12>>2]|0;t=c[m+(g*44|0)+4>>2]|0;u=c[m+(g*44|0)+36>>2]|0;v=q;do{w=c[s+(v<<2)>>2]|0;x=(fa(t,o)|0)+w|0;h[l+(x<<3)>>3]=+h[u+(w<<3)>>3];v=v+1|0;}while(v>>>0<r>>>0)}}while(0);o=o+1|0;}while(o>>>0<a>>>0);if((a|0)==0){break}o=c[m+(g*44|0)+20>>2]|0;n=0;do{if(((c[o+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=0.0}n=n+1|0;}while(n>>>0<a>>>0)}}while(0);k=k+1|0;}while(k>>>0<(c[m+(g*44|0)+24>>2]|0)>>>0);i=d;return}function Pr(a,b,d,e,f,g,j,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;o=i;i=i+8|0;p=o;q=cS(d,4)|0;r=cS(d,4)|0;s=r;t=(d|0)>0;if(t){u=0}else{v=0;bS(q);bS(r);i=o;return v|0}do{w=(u|0)<(e|0)?1:2;c[r+(c[b+(u<<2)>>2]<<2)>>2]=w;c[q+(c[a+(u<<2)>>2]<<2)>>2]=w;u=u+1|0;}while((u|0)<(d|0));if(t){x=0}else{v=0;bS(q);bS(r);i=o;return v|0}while(1){t=x+1|0;if((c[r+(x<<2)>>2]|0)!=(c[q+(x<<2)>>2]|0)){break}if((t|0)<(d|0)){x=t}else{v=0;y=9;break}}if((y|0)==9){bS(q);bS(r);i=o;return v|0}if((n|0)==0){v=-1;bS(q);bS(r);i=o;return v|0}n=p;h[k>>3]=+h[c[c[m+4>>2]>>2]>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Rn(5,1,57832,p);Qr(s,d,f,c[g>>2]|0,j,l,m);if((c[21252>>2]|0)==0){v=-1;bS(q);bS(r);i=o;return v|0}Yd[c[5446]&255](5);v=-1;bS(q);bS(r);i=o;return v|0}function Qr(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+8|0;l=k;m=e-(c[c[j+12>>2]>>2]|0)|0;e=j+4|0;n=c[(c[c[e>>2]>>2]|0)+12>>2]|0;IS(n+(m<<2)|0,0,fa(b<<2,d)|0)|0;if((b|0)<=0){i=k;return}o=j+8|0;j=0;p=0;while(1){if((c[a+(j<<2)>>2]|0)==2){q=c[c[o>>2]>>2]|0;r=c[g+(j<<2)>>2]|0;s=(c[r>>2]|0)-q|0;t=(c[c[f+(p<<2)>>2]>>2]|0)-q|0;c[l>>2]=c[r+4>>2];Rn(5,0,57864,l);c[n+(p+m+(fa(j,d)|0)<<2)>>2]=1;r=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[r+(t<<3)>>3]=+h[r+(s<<3)>>3];u=p+1|0}else{u=p}s=j+1|0;if((s|0)<(b|0)){j=s;p=u}else{break}}i=k;return}function Rr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=hc(57880,57904)|0;o=(n|0)!=0;a[b+440|0]=o&1;if(o){p=0}else{i=d;return 0}a:while(1){while(1){o=$c(n|0)|0;if((o|0)==10){break}else if((o|0)==-1){break a}}p=p+1|0}o=p+ -1|0;p=b+456|0;c[p>>2]=o;c[b+452>>2]=o;ob(n|0);do{}while(($c(n|0)|0)!=10);q=c[b+152>>2]|0;r=cS(o,4)|0;o=b+444|0;c[o>>2]=r;s=c[p>>2]|0;t=(s|0)>0;b:do{if(t){u=r;v=0;while(1){c[u+(v<<2)>>2]=cS(q,8)|0;w=v+1|0;if((w|0)>=(s|0)){break}u=c[o>>2]|0;v=w}v=cS(s,8)|0;u=b+448|0;c[u>>2]=v;if(!t){x=u;break}w=(q|0)>0;y=v;v=0;while(1){c[m>>2]=y+(v<<3);z=ac(n|0,57912,m|0)|0;if(w){A=0;while(1){c[l>>2]=(c[(c[o>>2]|0)+(v<<2)>>2]|0)+(A<<3);B=ac(n|0,57912,l|0)|0;C=A+1|0;if((C|0)<(q|0)){A=C}else{D=B;break}}}else{D=z}if((D|0)<0){c[p>>2]=v;E=v}else{E=c[p>>2]|0}A=v+1|0;if((A|0)>=(E|0)){x=u;break b}y=c[u>>2]|0;v=A}}else{v=b+448|0;c[v>>2]=cS(s,8)|0;x=v}}while(0);fc(57920,j|0)|0;fc(57976,g|0)|0;if((c[p>>2]|0)>0){g=(q|0)>0;j=0;do{s=f;h[k>>3]=+h[(c[x>>2]|0)+(j<<3)>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];fc(57936,f|0)|0;if(g){s=0;while(1){E=s+1|0;F=+h[(c[(c[o>>2]|0)+(j<<2)>>2]|0)+(s<<3)>>3];c[e>>2]=E;D=e+4|0;h[k>>3]=F;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];fc(57960,e|0)|0;if((E|0)<(q|0)){s=E}else{break}}}j=j+1|0;}while((j|0)<(c[p>>2]|0))}sb(57976)|0;Vc(n|0)|0;c[b+460>>2]=0;i=d;return 0}function Sr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((a[b+440|0]|0)==0){i=d;return 0}bS(c[b+448>>2]|0);e=b+452|0;f=b+444|0;b=c[f>>2]|0;if((c[e>>2]|0)>0){g=b;h=0;while(1){bS(c[g+(h<<2)>>2]|0);j=h+1|0;k=c[f>>2]|0;if((j|0)<(c[e>>2]|0)){h=j;g=k}else{l=k;break}}}else{l=b}bS(l);i=d;return 0}function Tr(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;d=i;if((a[b+440|0]|0)==0){e=-1;i=d;return e|0}f=+h[c[c[b+4>>2]>>2]>>3];g=b+460|0;j=c[g>>2]|0;k=c[b+448>>2]|0;l=+h[k+(j<<3)>>3];if(f==l){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;p=0;while(1){h[o+(p<<3)>>3]=+h[n+(p<<3)>>3];q=p+1|0;if((q|0)<(m|0)){p=q}else{e=1;break}}i=d;return e|0}p=j+1|0;r=+h[k+(p<<3)>>3];if(f==r){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;q=0;while(1){s=q+1|0;h[o+(q<<3)>>3]=+h[n+(s<<3)>>3];if((s|0)<(m|0)){q=s}else{e=1;break}}i=d;return e|0}a:do{if(f>r){q=(c[b+456>>2]|0)+ -1|0;m=j;n=p;while(1){if((n|0)>=(q|0)){t=m;break a}c[g>>2]=n;o=n+1|0;if(f>+h[k+(o<<3)>>3]){s=n;n=o;m=s}else{t=n;break}}}else{t=j}}while(0);j=t+1|0;r=+h[k+(j<<3)>>3]- +h[k+(t<<3)>>3];k=c[b+152>>2]|0;if((k|0)<=0){e=0;i=d;return e|0}g=c[b+444>>2]|0;p=c[g+(t<<2)>>2]|0;t=c[g+(j<<2)>>2]|0;u=l+r;j=b+432|0;v=u-f;w=f-l;b=0;while(1){x=+h[p+(b<<3)>>3];y=+h[t+(b<<3)>>3];do{if(x!=y){if(x>0.0){z=1}else{z=(x<0.0)<<31>>31}if(y>0.0){A=1}else{A=(y<0.0)<<31>>31}if((z|0)==(A|0)){h[(c[j>>2]|0)+(b<<3)>>3]=(u*x+f*y-(f*x+l*y))/r;break}else{h[(c[j>>2]|0)+(b<<3)>>3]=(v*x+w*y)/r;break}}else{h[(c[j>>2]|0)+(b<<3)>>3]=x}}while(0);g=b+1|0;if((g|0)<(k|0)){b=g}else{e=0;break}}i=d;return e|0}function Ur(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=+Vr(a,1.0);if(!(f>1.0e-5)){g=0;i=b;return g|0}if((c[21268>>2]|0)==0){g=1;i=b;return g|0}j=e;h[k>>3]=f;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];Rn(9,1,58040,e);e=a+16|0;j=c[e>>2]|0;if((j|0)>0){l=a+48|0;a=j;j=0;while(1){f=+h[(c[l>>2]|0)+(j<<3)>>3];m=j+1|0;if(+U(+f)>1.0e-5){c[d>>2]=m;n=d+4|0;h[k>>3]=f;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Rn(9,0,58152,d);o=c[e>>2]|0}else{o=a}if((m|0)<(o|0)){a=o;j=m}else{break}}}Yd[c[5446]&255](9);g=1;i=b;return g|0}function Vr(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0,K=0,L=0.0;e=i;f=c[b+60>>2]|0;is(b);g=f+540|0;$d[c[(c[g>>2]|0)+84>>2]&127](f)|0;$d[c[(c[g>>2]|0)+36>>2]&127](f)|0;$d[c[(c[g>>2]|0)+32>>2]&127](f)|0;j=b+48|0;ne[c[(c[g>>2]|0)+68>>2]&63](f,c[j>>2]|0)|0;g=f+8|0;k=c[f+184>>2]|0;if((k|0)>0){l=c[b+52>>2]|0;m=(l|0)==0;n=c[j>>2]|0;o=0.0;j=0;while(1){if(m){p=1.0}else{p=+h[l+(j<<3)>>3]}q=+h[n+(j<<3)>>3]/p;r=o+q*q;s=j+1|0;if((s|0)<(k|0)){o=r;j=s}else{t=r;break}}}else{t=0.0}if(!(d<1.0)){u=t;i=e;return+u}o=t*d;j=c[f+116>>2]|0;if((j|0)>0){k=c[g>>2]|0;n=b+56|0;t=1.0-d;l=f+4|0;p=o;m=0;s=0;while(1){if((a[k+(m*112|0)+88|0]|0)==0){v=p;w=s}else{x=c[n>>2]|0;if((x|0)==0){y=s;z=1.0}else{y=s+1|0;z=+h[x+(s<<3)>>3]}r=(+h[k+(m*112|0)+96>>3]- +h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+(m<<3)>>3])/z;v=p+r*t*r;w=y}x=m+1|0;if((x|0)<(j|0)){p=v;m=x;s=w}else{A=v;B=w;break}}}else{A=o;B=0}w=c[f+136>>2]|0;if((w|0)>0){s=c[f+24>>2]|0;m=b+56|0;o=1.0-d;y=f+416|0;v=A;l=0;k=B;while(1){do{if((a[s+(l*112|0)+88|0]|0)==0){C=v;D=k}else{if((a[s+(l*112|0)+72|0]|0)!=0){C=v;D=k;break}n=c[m>>2]|0;if((n|0)==0){E=k;F=1.0}else{E=k+1|0;F=+h[n+(k<<3)>>3]}p=(+h[s+(l*112|0)+96>>3]- +h[(c[y>>2]|0)+(l<<3)>>3])/F;C=v+p*o*p;D=E}}while(0);n=l+1|0;if((n|0)<(w|0)){v=C;l=n;k=D}else{G=C;H=D;break}}}else{G=A;H=B}B=c[f+120>>2]|0;D=j-B|0;if((D|0)>=(B|0)){u=G;i=e;return+u}j=c[g>>2]|0;g=b+56|0;A=1.0-d;b=f+416|0;d=G;f=D;D=H;while(1){do{if((a[j+(f*112|0)+88|0]|0)==0){I=d;J=D}else{if((a[j+(f*112|0)+72|0]|0)!=0){I=d;J=D;break}H=c[g>>2]|0;if((H|0)==0){K=D;L=1.0}else{K=D+1|0;L=+h[H+(D<<3)>>3]}G=(+h[j+(f*112|0)+96>>3]- +h[(c[b>>2]|0)+(f<<3)>>3])/L;I=d+G*A*G;J=K}}while(0);H=f+1|0;if((H|0)<(B|0)){d=I;f=H;D=J}else{u=I;break}}i=e;return+u}function Wr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+16|0;e=d;f=i;i=i+24|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+16|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;u=+Vr(b,1.0);if((c[21268>>2]|0)==0){i=d;return}v=b+16|0;w=c[v>>2]|0;if((w|0)>0){x=c[b+48>>2]|0;y=0.0;z=0;while(1){A=+h[x+(z<<3)>>3];B=y+A*A;C=z+1|0;if((C|0)<(w|0)){z=C;y=B}else{D=B;break}}}else{D=0.0}Rn(9,1,58176,t);t=b+52|0;if((c[t>>2]|0)==0){z=r;h[k>>3]=D;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Rn(9,0,58240,r)}else{r=s;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=s+8|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Rn(9,0,58200,s)}Rn(9,1,58264,q);q=b+4|0;s=c[q>>2]|0;if((s|0)>0){r=b+40|0;z=b+24|0;w=b+44|0;x=0;while(1){C=c[r>>2]|0;E=x+1|0;u=+h[(c[z>>2]|0)+(x<<3)>>3];F=c[(c[w>>2]|0)+(x<<2)>>2]|0;if((C|0)==0){c[o>>2]=E;G=o+4|0;h[k>>3]=u;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];c[o+12>>2]=F;Rn(9,0,58336,o)}else{D=+h[C+(x<<3)>>3];c[p>>2]=E;C=p+4|0;h[k>>3]=u;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[p+12>>2]=F;F=p+16|0;h[k>>3]=D;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];Rn(9,0,58288,p)}F=c[q>>2]|0;if((E|0)<(F|0)){x=E}else{H=F;I=E;break}}}else{H=s;I=0}s=b+8|0;if((I|0)<((c[s>>2]|0)+H|0)){H=b+40|0;x=b+24|0;p=b+44|0;o=I;while(1){w=c[H>>2]|0;z=o+1|0;D=+h[(c[x>>2]|0)+(o<<3)>>3];r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if((w|0)==0){c[m>>2]=z;E=m+4|0;h[k>>3]=D;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];c[m+12>>2]=r;Rn(9,0,58424,m)}else{u=+h[w+(o<<3)>>3];c[n>>2]=z;w=n+4|0;h[k>>3]=D;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[n+12>>2]=r;r=n+16|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Rn(9,0,58360,n)}if((z|0)<((c[s>>2]|0)+(c[q>>2]|0)|0)){o=z}else{J=z;break}}}else{J=I}I=b;if((J|0)<(c[I>>2]|0)){o=b+40|0;q=b+24|0;s=b+44|0;n=J;while(1){J=c[o>>2]|0;m=n+1|0;u=+h[(c[q>>2]|0)+(n<<3)>>3];p=c[(c[s>>2]|0)+(n<<2)>>2]|0;if((J|0)==0){c[j>>2]=m;x=j+4|0;h[k>>3]=u;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];c[j+12>>2]=p;Rn(9,0,58512,j)}else{D=+h[J+(n<<3)>>3];c[l>>2]=m;J=l+4|0;h[k>>3]=u;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];c[l+12>>2]=p;p=l+16|0;h[k>>3]=D;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Rn(9,0,58456,l)}if((m|0)<(c[I>>2]|0)){n=m}else{break}}}Yd[c[5446]&255](9);Rn(9,1,58544,g);if((c[v>>2]|0)>0){g=b+48|0;b=a+540|0;a=0;while(1){n=(c[t>>2]|0)==0;I=a+1|0;D=+h[(c[g>>2]|0)+(a<<3)>>3];l=$d[c[(c[b>>2]|0)+64>>2]&127](a)|0;if(n){c[e>>2]=I;n=e+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[e+12>>2]=l;Rn(9,0,58336,e)}else{u=+h[(c[t>>2]|0)+(a<<3)>>3];c[f>>2]=I;n=f+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[f+12>>2]=l;l=f+16|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];Rn(9,0,58288,f)}if((I|0)<(c[v>>2]|0)){a=I}else{break}}}Yd[c[5446]&255](9);Yd[c[5446]&255](9);i=d;return}function Xr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0;d=i;i=i+24|0;e=d;f=i;i=i+8|0;g=i;i=i+24|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+8|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+40|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b+8|0;if((c[21268>>2]|0)!=0){Eq(b,9)}if((c[21328>>2]|0)==0){i=d;return}Rn(24,1,58568,t);t=b+112|0;v=c[t>>2]|0;do{if((v|0)>0){Rn(24,1,58608,s);if((c[t>>2]|0)>0){w=u;x=b+4|0;y=b+400|0;z=0;while(1){A=z+1|0;B=c[w>>2]|0;C=c[B+(z*112|0)+4>>2]|0;D=+h[B+(z*112|0)+96>>3];E=+h[B+(z*112|0)+80>>3];F=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];G=+h[(c[y>>2]|0)+(z<<3)>>3];c[r>>2]=A;c[r+4>>2]=C;C=r+8|0;h[k>>3]=D;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+16|0;h[k>>3]=E;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+24|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+32|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Rn(24,0,58632,r);if((A|0)<(c[t>>2]|0)){z=A}else{break}}}Yd[c[5446]&255](24);z=c[t>>2]|0;if((z|0)<=0){H=z;break}Rn(24,1,58688,q);z=c[t>>2]|0;if((z|0)<(z<<1|0)){y=u;x=b+4|0;w=b+400|0;A=z;while(1){z=A+1|0;C=c[(c[y>>2]|0)+(A*112|0)+4>>2]|0;G=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];F=+h[(c[w>>2]|0)+(A<<3)>>3];c[p>>2]=z;c[p+4>>2]=C;C=p+8|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=p+16|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Rn(24,0,58712,p);if((z|0)<(c[t>>2]<<1|0)){A=z}else{break}}}Yd[c[5446]&255](24);H=c[t>>2]|0}else{H=v}}while(0);v=b+116|0;if((H<<1|0)<(c[v>>2]|0)){Rn(24,1,58744,o);o=c[t>>2]<<1;if((o|0)<(c[v>>2]|0)){t=u;u=b+4|0;H=b+400|0;p=o;while(1){o=p+1|0;q=c[t>>2]|0;r=c[q+(p*112|0)+4>>2]|0;F=+h[q+(p*112|0)+96>>3];G=+h[q+(p*112|0)+80>>3];E=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+(p<<3)>>3];D=+h[(c[H>>2]|0)+(p<<3)>>3];c[n>>2]=o;c[n+4>>2]=r;r=n+8|0;h[k>>3]=F;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+16|0;h[k>>3]=G;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+24|0;h[k>>3]=E;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+32|0;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Rn(24,0,58632,n);if((o|0)<(c[v>>2]|0)){p=o}else{break}}}Yd[c[5446]&255](24)}p=b+124|0;if((c[p>>2]|0)>0){Rn(24,1,58768,m);if((c[p>>2]|0)>0){m=b+12|0;v=b+4|0;n=b+404|0;H=0;while(1){u=H+1|0;t=c[m>>2]|0;o=c[t+(H*60|0)+4>>2]|0;r=c[t+(H*60|0)+52>>2]|0;t=c[(c[(c[c[v>>2]>>2]|0)+12>>2]|0)+(H<<2)>>2]|0;q=c[(c[n>>2]|0)+(H<<2)>>2]|0;c[l>>2]=u;c[l+4>>2]=o;c[l+8>>2]=r;c[l+12>>2]=t;c[l+16>>2]=q;Rn(24,0,58792,l);if((u|0)<(c[p>>2]|0)){H=u}else{break}}}Yd[c[5446]&255](24)}H=b+128|0;if((c[H>>2]|0)>0){Rn(24,1,58840,j);if((c[H>>2]|0)>0){j=b+16|0;p=b+4|0;l=b+408|0;n=0;while(1){v=n+1|0;m=c[j>>2]|0;u=c[m+(n*48|0)+4>>2]|0;q=(a[m+(n*48|0)+42|0]|0)!=0?58912:58920;m=(a[(c[(c[c[p>>2]>>2]|0)+16>>2]|0)+n|0]|0)!=0?58912:58920;t=(a[(c[l>>2]|0)+n|0]|0)!=0?58912:58920;c[g>>2]=v;c[g+4>>2]=u;c[g+8>>2]=q;c[g+12>>2]=m;c[g+16>>2]=t;Rn(24,0,58864,g);if((v|0)<(c[H>>2]|0)){n=v}else{break}}}Yd[c[5446]&255](24)}n=b+132|0;if((c[n>>2]|0)>0){Rn(24,1,58928,f);if((c[n>>2]|0)>0){f=b+20|0;H=b+4|0;g=b+412|0;b=0;while(1){l=b+1|0;p=c[f>>2]|0;j=c[p+(b*52|0)+4>>2]|0;v=c[p+(b*52|0)+44>>2]|0;p=c[(c[(c[c[H>>2]>>2]|0)+20>>2]|0)+(b<<2)>>2]|0;t=c[(c[g>>2]|0)+(b<<2)>>2]|0;c[e>>2]=l;c[e+4>>2]=j;c[e+8>>2]=v;c[e+12>>2]=p;c[e+16>>2]=t;Rn(24,0,58952,e);if((l|0)<(c[n>>2]|0)){b=l}else{break}}}Yd[c[5446]&255](24)}Yd[c[5446]&255](24);i=d;return}function Yr(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=b+540|0;B=(c[(c[A>>2]|0)+72>>2]|0)!=0?3:2;Rn(9,0,59e3,z);if((f|0)==0){Bq(b);Cq(b);C=6}else{if((a[f]|0)!=0){Zr(b,f,g)}Bq(b);Cq(b);if((a[f]|0)==0){C=6}}if((C|0)==6){$d[c[(c[A>>2]|0)+84>>2]&127](b)|0;$d[c[(c[A>>2]|0)+60>>2]&127](b)|0}do{if((d|0)==0){D=B}else{if((a[d]|0)==0){D=B;break}C=(AS(d,60488)|0)==0|0;f=(AS(d,60496)|0)==0;z=(AS(d,60504)|0)==0;E=z?3:f?2:C;if((E|0)!=0){D=E;break}c[y>>2]=d;Tn(1,0,59048,y);Tn(1,0,59080,x);c[w>>2]=60488;c[w+4>>2]=60296;Tn(1,0,59104,w);c[v>>2]=60496;c[v+4>>2]=60376;Tn(1,0,59104,v);c[u>>2]=60504;c[u+4>>2]=60424;Tn(1,0,59104,u);Vn(c[b+536>>2]|0,59136,t)}}while(0);do{if((e|0)==0){F=3}else{if((a[e]|0)==0){F=3;break}else{G=1;H=0}do{t=(AS(e,c[59160+(G<<2)>>2]|0)|0)==0;H=t?G:H;G=G+1|0;}while((G|0)<7);if((H|0)!=0){F=H;break}c[s>>2]=e;Tn(1,0,59192,s);Tn(1,0,59080,r);t=1;do{u=c[59224+(t<<2)>>2]|0;c[q>>2]=c[59160+(t<<2)>>2];c[q+4>>2]=u;Tn(1,0,59104,q);t=t+1|0;}while((t|0)<7);Vn(c[b+536>>2]|0,59136,p)}}while(0);p=c[59120+(D<<2)>>2]|0;c[o>>2]=c[59032+(D<<2)>>2];c[o+4>>2]=p;Rn(9,0,59256,o);o=(D|0)==2;if(o){p=c[59224+(F<<2)>>2]|0;c[n>>2]=c[59160+(F<<2)>>2];c[n+4>>2]=p;Rn(9,0,59296,n)}n=b+312|0;a[n]=1;p=b+200|0;if((c[p>>2]|0)>0){q=b+468|0;r=0;do{a[(c[q>>2]|0)+(r*80|0)+72|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+196|0;if((c[p>>2]|0)>0){r=b+476|0;q=0;do{a[(c[r>>2]|0)+(q<<6)+56|0]=1;q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+192|0;if((c[p>>2]|0)>0){q=b+484|0;r=0;do{a[(c[q>>2]|0)+(r*40|0)+36|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}do{if((D|0)==1){I=0}else{if(o){I=_r(b,F,j)|0;break}if((D|0)==3){$r(b,j);I=0;break}else{Vn(c[b+536>>2]|0,59336,m)}}}while(0);if((kr(b,1)|0)!=0){J=-2;Xr(b);K=15;L=K;M=59360;N=M;Rn(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];kq(b,R,V);W=152;yq(b);X=158;Dq(b);Y=153;tq(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=$d[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=ne[ha&63](b,1)|0;ja=161;zq(b);i=k;return J|0}if((cr(b,1)|0)!=0){J=-3;Xr(b);K=15;L=K;M=59360;N=M;Rn(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];kq(b,R,V);W=152;yq(b);X=158;Dq(b);Y=153;tq(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=$d[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=ne[ha&63](b,1)|0;ja=161;zq(b);i=k;return J|0}m=(Uq(b,1)|0)==0;J=m?I:-4;Xr(b);K=15;L=K;M=59360;N=M;Rn(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];kq(b,R,V);W=152;yq(b);X=158;Dq(b);Y=153;tq(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=$d[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=ne[ha&63](b,1)|0;ja=161;zq(b);i=k;return J|0}function Zr(b,d,e){b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+48|0;B=i;i=i+8|0;c[z>>2]=d;C=z+4|0;h[k>>3]=e;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Rn(9,0,60520,z);z=wo(d,A)|0;if((z|0)!=0){C=c[b+536>>2]|0;c[y>>2]=d;c[y+4>>2]=z;Vn(C,60560,y)}Rn(9,0,60600,x);x=b+116|0;if((c[x>>2]|0)>0){y=b+8|0;C=0;do{z=xo(A,c[(c[y>>2]|0)+(C*112|0)+4>>2]|0)|0;d=c[y>>2]|0;do{if((z|0)==0){D=cs(c[d+(C*112|0)+4>>2]|0)|0;E=xo(A,D)|0;bS(D);D=c[y>>2]|0;if((E|0)!=0){F=D;G=E;H=7;break}E=c[D+(C*112|0)+4>>2]|0;if((BS(E,60640,6)|0)==0){if((c[21268>>2]|0)==0){break}}else{D=BS(E,60648,6)|0;if((c[21268>>2]|D|0)==0){break}}c[v>>2]=E;Tn(9,0,60656,v)}else{F=d;G=z;H=7}}while(0);if((H|0)==7){H=0;Do(F+(C*112|0)+96|0,A,G,e)|0;z=c[y>>2]|0;I=+h[z+(C*112|0)+96>>3];c[w>>2]=c[z+(C*112|0)+4>>2];z=w+4|0;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Rn(9,0,60624,w)}C=C+1|0;}while((C|0)<(c[x>>2]|0))}Rn(9,0,60712,u);u=b+136|0;if((c[u>>2]|0)>0){C=b+24|0;w=0;do{y=xo(A,c[(c[C>>2]|0)+(w*112|0)+4>>2]|0)|0;G=c[C>>2]|0;do{if((y|0)==0){F=cs(c[G+(w*112|0)+4>>2]|0)|0;v=xo(A,F)|0;bS(F);F=c[C>>2]|0;if((v|0)!=0){J=F;K=v;H=17;break}c[s>>2]=c[F+(w*112|0)+4>>2];Tn(9,0,60736,s)}else{J=G;K=y;H=17}}while(0);if((H|0)==17){H=0;Do(J+(w*112|0)+96|0,A,K,e)|0;y=c[C>>2]|0;I=+h[y+(w*112|0)+96>>3];c[t>>2]=c[y+(w*112|0)+4>>2];y=t+4|0;h[k>>3]=I;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];Rn(9,0,60624,t)}w=w+1|0;}while((w|0)<(c[u>>2]|0))}Rn(9,0,60792,r);r=b+120|0;u=c[r>>2]|0;w=(c[x>>2]|0)-u|0;if((w|0)<(u|0)){u=b+24|0;x=w;do{w=xo(A,c[(c[u>>2]|0)+(x*112|0)+4>>2]|0)|0;t=c[u>>2]|0;do{if((w|0)==0){C=cs(c[t+(x*112|0)+4>>2]|0)|0;K=xo(A,C)|0;bS(C);C=c[u>>2]|0;if((K|0)!=0){L=C;M=K;H=24;break}c[p>>2]=c[C+(x*112|0)+4>>2];Tn(9,0,60736,p)}else{L=t;M=w;H=24}}while(0);if((H|0)==24){H=0;Do(L+(x*112|0)+96|0,A,M,e)|0;w=c[u>>2]|0;I=+h[w+(x*112|0)+96>>3];c[q>>2]=c[w+(x*112|0)+4>>2];w=q+4|0;h[k>>3]=I;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Rn(9,0,60624,q)}x=x+1|0;}while((x|0)<(c[r>>2]|0))}Rn(9,0,60816,o);o=b+140|0;if((c[o>>2]|0)>0){r=b+28|0;x=0;do{q=xo(A,c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;do{if((q|0)==0){u=cs(c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;M=xo(A,u)|0;bS(u);if((M|0)!=0){N=M;H=31;break}c[m>>2]=c[(c[r>>2]|0)+(x*60|0)+4>>2];Tn(9,0,60864,m)}else{N=q;H=31}}while(0);if((H|0)==31){H=0;Do(B,A,N,e)|0;q=~~+h[B>>3];M=c[r>>2]|0;c[M+(x*60|0)+52>>2]=q;c[n>>2]=c[M+(x*60|0)+4>>2];c[n+4>>2]=q;Rn(9,0,60848,n)}x=x+1|0;}while((x|0)<(c[o>>2]|0))}Rn(9,0,60920,l);l=b+144|0;if((c[l>>2]|0)<=0){uo(A);i=f;return}o=b+32|0;b=0;do{x=xo(A,c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;do{if((x|0)==0){n=cs(c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;r=xo(A,n)|0;bS(n);if((r|0)!=0){O=r;H=38;break}c[g>>2]=c[(c[o>>2]|0)+(b*48|0)+4>>2];Tn(9,0,60968,g)}else{O=x;H=38}}while(0);if((H|0)==38){H=0;Do(B,A,O,e)|0;a[(c[o>>2]|0)+(b*48|0)+42|0]=~~+h[B>>3];x=c[o>>2]|0;r=(a[x+(b*48|0)+42|0]|0)!=0?58912:58920;c[j>>2]=c[x+(b*48|0)+4>>2];c[j+4>>2]=r;Rn(9,0,60952,j)}b=b+1|0;}while((b|0)<(c[l>>2]|0));uo(A);i=f;return}function _r(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;jq(a,+h[a+240>>3]);yq(a);Dq(a);tq(a);Fq(a);Lr(a);uq(a);yq(a);e=as(a,b,c)|0;Dq(a);tq(a);zq(a);Dq(a);i=d;return e|0}



function wo(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+88|0;f=e;j=e+24|0;k=e+72|0;l=d+0|0;m=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=hc(b|0,22352)|0;m=d;c[m>>2]=l;if((l|0)==0){n=Nd(c[(Lc()|0)>>2]|0)|0;i=e;return n|0}c[d+4>>2]=rd(b|0)|0;c[d+36>>2]=0;b=f;l=d+44|0;o=f;p=f+12|0;q=f+16|0;r=f+4|0;s=f+8|0;f=j;t=k;u=d+8|0;v=d+12|0;w=d+16|0;x=d+20|0;y=d+28|0;z=d+24|0;A=d+32|0;B=d+40|0;d=1;C=0;a:while(1){D=rb(b|0,20,1,c[m>>2]|0)|0;a[l]=1;if((D|0)!=1){n=22360;E=131;break}D=c[o>>2]|0;if((D|0)!=(c[22328+(C<<2)>>2]|0)){if(!((C|0)>3&(D|0)==10)){n=22384;E=131;break}a[l]=0}F=c[p>>2]|0;if(F>>>0>1){n=22408;E=131;break}G=to(D)|0;if((G|0)==-1){n=22440;E=131;break}D=c[q>>2]|0;H=aS(D)|0;if((rb(H|0,D|0,1,c[m>>2]|0)|0)!=1){n=22488;E=131;break}if((a[H+(D+ -1)|0]|0)!=0){n=22512;E=131;break}D=c[r>>2]|0;I=c[s>>2]|0;J=fa(fa(fa(D,G)|0,I)|0,F+1|0)|0;if((AS(H,c[22304+(C<<2)>>2]|0)|0)!=0){n=22536;E=131;break}bS(H);H=23112;b:do{switch(C|0){case 4:{if(d<<24>>24==1){if((D|0)==0){n=22800;E=131;break a}if(!((I+ -1|0)>>>0<2)){n=22856;E=131;break a}c[w>>2]=D;F=fa(I,D)|0;if((a[l]|0)==1){G=aS(F<<3)|0;c[x>>2]=G;if((rb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=22896;E=131;break a}}else{G=aS(F<<2)|0;c[x>>2]=aS(fa(D<<3,I)|0)|0;if((rb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=22896;E=131;break a}if((F|0)!=0){K=c[x>>2]|0;L=0;do{h[K+(L<<3)>>3]=+g[G+(L<<2)>>2];L=L+1|0;}while(L>>>0<F>>>0)}bS(G)}F=c[w>>2]|0;if(!(F>>>0>1)){M=1;E=130;break b}L=(I|0)==2;K=1;while(1){if(L){N=c[x>>2]|0;if(+h[N+(K<<3)>>3]!=+h[N+(F+K<<3)>>3]){n=22928;E=131;break a}}N=K+1|0;if(N>>>0<F>>>0){K=N}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){O=d;E=129;break b}if((I|0)==0){n=22800;E=131;break a}if(!((D+ -1|0)>>>0<2)){n=23008;E=131;break a}c[w>>2]=I;K=fa(I,D)|0;if((a[l]|0)==1){F=aS(K<<3)|0;c[x>>2]=aS(fa(D<<3,I)|0)|0;if((rb(F|0,J|0,1,c[m>>2]|0)|0)!=1){n=22896;E=131;break a}if((D|0)!=0){L=0;do{G=c[x>>2]|0;N=0;do{h[G+((fa(I,L)|0)+N<<3)>>3]=+h[F+((fa(D,N)|0)+L<<3)>>3];N=N+1|0;}while(N>>>0<I>>>0);L=L+1|0;}while(L>>>0<D>>>0)}bS(F)}else{L=aS(K<<2)|0;c[x>>2]=aS(fa(D<<3,I)|0)|0;if((rb(L|0,J|0,1,c[m>>2]|0)|0)!=1){n=22896;E=131;break a}if((D|0)!=0){N=0;do{G=c[x>>2]|0;P=0;do{h[G+((fa(I,N)|0)+P<<3)>>3]=+g[L+((fa(D,P)|0)+N<<2)>>2];P=P+1|0;}while(P>>>0<I>>>0);N=N+1|0;}while(N>>>0<D>>>0)}bS(L)}N=c[w>>2]|0;if(!(N>>>0>1)){M=d;E=130;break b}K=(D|0)==2;F=1;while(1){if(K){P=c[x>>2]|0;if(+h[P+(F<<3)>>3]!=+h[P+(N+F<<3)>>3]){n=22928;E=131;break a}}P=F+1|0;if(P>>>0<N>>>0){F=P}else{M=d;E=130;break}}break};case 2:{if(d<<24>>24==1){if((I|0)==0){O=1;E=129;break b}F=D+1|0;N=0;while(1){K=aS(F)|0;c[(c[v>>2]|0)+(N<<4)+4>>2]=K;if((rb(c[(c[v>>2]|0)+(N<<4)+4>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=22736;E=131;break a}a[(c[(c[v>>2]|0)+(N<<4)+4>>2]|0)+D|0]=0;K=N+1|0;if(K>>>0<I>>>0){N=K}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){O=d;E=129;break b}N=fa(D,I)|0;Q=aS(N+1|0)|0;if((rb(Q|0,N|0,1,c[m>>2]|0)|0)!=1){E=46;break a}if((D|0)!=0){N=I+1|0;F=(I|0)==0;K=0;do{L=aS(N)|0;c[(c[v>>2]|0)+(K<<4)+4>>2]=L;if(!F){L=0;do{P=a[Q+((fa(D,L)|0)+K)|0]|0;a[(c[(c[v>>2]|0)+(K<<4)+4>>2]|0)+L|0]=P;L=L+1|0;}while(L>>>0<I>>>0)}a[(c[(c[v>>2]|0)+(K<<4)+4>>2]|0)+I|0]=0;K=K+1|0;}while(K>>>0<D>>>0)}bS(Q);M=0;E=130;break};case 0:{if((D|0)!=4){n=22560;E=131;break a}if((I|0)!=11){n=22600;E=131;break a}if((rb(f|0,44,1,c[m>>2]|0)|0)==1){R=0}else{n=22640;E=131;break a}while(1){K=0;do{a[k+K|0]=a[j+((K<<2)+R)|0]|0;K=K+1|0;}while(K>>>0<11);a[k+11|0]=0;if((R|0)==3){break}K=R+1|0;if(K>>>0<4){R=K}else{M=d;E=130;break b}}if((BS(t,c[5552]|0,8)|0)==0){M=1;E=130;break b}if((BS(t,c[5558]|0,9)|0)==0){M=0;E=130}else{n=22672;E=131;break a}break};case 1:{K=d<<24>>24==0;c[u>>2]=K?D:I;F=aS((K?D:I)<<4)|0;c[v>>2]=F;c:do{if(d<<24>>24==1){if((I|0)==0){S=0;break}N=D+1|0;L=F;P=0;while(1){c[L+(P<<4)>>2]=aS(N)|0;if((rb(c[(c[v>>2]|0)+(P<<4)>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=22736;E=131;break a}a[(c[(c[v>>2]|0)+(P<<4)>>2]|0)+D|0]=0;G=c[v>>2]|0;c[G+(P<<4)+8>>2]=-1;c[G+(P<<4)+12>>2]=-1;vo(c[G+(P<<4)>>2]|0);G=P+1|0;if(!(G>>>0<I>>>0)){S=I;break c}L=c[v>>2]|0;P=G}}else{S=I}}while(0);if(!K){M=d;E=130;break b}F=fa(D,S)|0;T=aS(F+1|0)|0;if((rb(T|0,F|0,1,c[m>>2]|0)|0)!=1){E=33;break a}if((D|0)!=0){F=S+1|0;P=(S|0)==0;L=0;do{N=aS(F)|0;c[(c[v>>2]|0)+(L<<4)>>2]=N;if(!P){N=0;do{G=a[T+((fa(D,N)|0)+L)|0]|0;a[(c[(c[v>>2]|0)+(L<<4)>>2]|0)+N|0]=G;N=N+1|0;}while(N>>>0<S>>>0)}a[(c[(c[v>>2]|0)+(L<<4)>>2]|0)+S|0]=0;N=c[v>>2]|0;c[N+(L<<4)+8>>2]=-1;c[N+(L<<4)+12>>2]=-1;vo(c[N+(L<<4)>>2]|0);L=L+1|0;}while(L>>>0<D>>>0)}bS(T);M=0;E=130;break};case 3:{L=fa(I<<2,D)|0;U=aS(L)|0;if((rb(U|0,L|0,1,c[m>>2]|0)|0)!=1){E=52;break a}do{if(d<<24>>24==0){if((D|0)==0){break}L=c[v>>2]|0;P=0;do{c[L+(P<<4)+8>>2]=(c[U+(P<<2)>>2]|0)==1;c[L+(P<<4)+12>>2]=c[U+(D+P<<2)>>2];P=P+1|0;}while(P>>>0<D>>>0)}else if(d<<24>>24==1){if((I|0)==0){break}P=c[v>>2]|0;L=0;do{F=fa(D,L)|0;c[P+(L<<4)+8>>2]=(c[U+(F<<2)>>2]|0)==1;c[P+(L<<4)+12>>2]=c[U+(F+1<<2)>>2];L=L+1|0;}while(L>>>0<I>>>0)}}while(0);bS(U);bc(c[v>>2]|0,c[u>>2]|0,16,53);M=d;E=130;break};case 5:{if(d<<24>>24==1){c[y>>2]=I;if(I>>>0<2){n=23048;E=131;break a}c[z>>2]=D;c[A>>2]=xb(c[m>>2]|0)|0;c[B>>2]=cS(c[z>>2]<<1,4)|0;if((Tc(c[m>>2]|0,J|0,1)|0)==-1){n=23080;E=131;break a}else{M=1;E=130;break b}}else if(!(d<<24>>24==0)){n=0;E=131;break a}c[y>>2]=D;if(D>>>0<2){n=23048;E=131;break a}c[z>>2]=I;c[A>>2]=xb(c[m>>2]|0)|0;c[B>>2]=cS(c[z>>2]<<1,4)|0;L=fa(I,D)|0;if((a[l]|0)==1){P=aS(L<<3)|0;if((rb(P|0,J|0,1,c[m>>2]|0)|0)!=1){n=23080;E=131;break a}if((I|0)!=0){F=D<<3;K=(D|0)==0;N=D<<3;G=0;do{V=aS(F)|0;c[(c[B>>2]|0)+(G<<2)>>2]=V;if(!K){V=P+(fa(N,G)|0)|0;GS(c[(c[B>>2]|0)+(G<<2)>>2]|0,V|0,N|0)|0}G=G+1|0;}while(G>>>0<I>>>0)}G=c[z>>2]|0;N=G<<1;if(G>>>0<N>>>0){K=D<<3;F=(D|0)==0;V=G;do{W=aS(K)|0;c[(c[B>>2]|0)+(V<<2)>>2]=W;if(!F){W=c[B>>2]|0;X=c[W+(V-G<<2)>>2]|0;Y=c[W+(V<<2)>>2]|0;W=0;do{h[Y+(W<<3)>>3]=-+h[X+(W<<3)>>3];W=W+1|0;}while(W>>>0<D>>>0)}V=V+1|0;}while(V>>>0<N>>>0)}bS(P)}else{N=aS(L<<2)|0;if((rb(N|0,J|0,1,c[m>>2]|0)|0)!=1){n=23080;E=131;break a}if((I|0)!=0){V=D<<3;G=(D|0)==0;F=0;do{K=aS(V)|0;c[(c[B>>2]|0)+(F<<2)>>2]=K;if(!G){K=c[(c[B>>2]|0)+(F<<2)>>2]|0;W=0;do{h[K+(W<<3)>>3]=+g[N+((fa(D,F)|0)+W<<2)>>2];W=W+1|0;}while(W>>>0<D>>>0)}F=F+1|0;}while(F>>>0<I>>>0)}F=c[z>>2]|0;G=F<<1;if(F>>>0<G>>>0){V=D<<3;L=(D|0)==0;P=F;do{W=aS(V)|0;c[(c[B>>2]|0)+(P<<2)>>2]=W;if(!L){W=c[B>>2]|0;K=c[W+(P-F<<2)>>2]|0;X=c[W+(P<<2)>>2]|0;W=0;do{h[X+(W<<3)>>3]=-+h[K+(W<<3)>>3];W=W+1|0;}while(W>>>0<D>>>0)}P=P+1|0;}while(P>>>0<G>>>0)}bS(N)}if((Tc(c[m>>2]|0,J|0,1)|0)==-1){n=23080;E=131;break a}else{M=d;E=130}break};default:{n=H;E=131;break a}}}while(0);if((E|0)==129){E=0;d=O;C=C+1|0;continue}else if((E|0)==130){E=0;H=C+1|0;if((H|0)<6){d=M;C=H;continue}else{n=0;E=131;break}}}if((E|0)==33){bS(T);n=22736;i=e;return n|0}else if((E|0)==46){bS(Q);n=22736;i=e;return n|0}else if((E|0)==52){bS(U);n=22768;i=e;return n|0}else if((E|0)==131){i=e;return n|0}return 0}function xo(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=vd(e|0,c[a+12>>2]|0,c[a+8>>2]|0,16,53)|0;i=d;return b|0}function yo(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=(d|0)>-1?d:0-d|0;j=(d|0)<0;do{if(j){k=c[b+24>>2]|0;l=k+f|0;m=k}else{if((d|0)==0){n=23152;o=n;p=23200;q=p;r=23224;s=r;bb(o|0,q|0,399,s|0)}else{l=f;m=c[b+24>>2]|0;break}}}while(0);d=l+ -1|0;l=b+24|0;if(f>>>0>m>>>0){n=23152;o=n;p=23200;q=p;r=23224;s=r;bb(o|0,q|0,399,s|0)}s=b+40|0;q=c[(c[s>>2]|0)+(d<<2)>>2]|0;if((q|0)!=0){t=q;i=e;return t|0}q=b+28|0;o=c[q>>2]|0;r=aS(o<<3)|0;p=r;a:do{if((a[b+44|0]|0)==1){if((o|0)==0){break}n=b;m=b+32|0;k=0;while(1){Tc(c[n>>2]|0,(c[m>>2]|0)+ -8+((fa(c[l>>2]|0,k)|0)+f<<3)|0,0)|0;u=r+(k<<3)|0;if((rb(u|0,8,1,c[n>>2]|0)|0)!=1){break}if(j){h[u>>3]=-+h[u>>3]}k=k+1|0;if(!(k>>>0<(c[q>>2]|0)>>>0)){break a}}bS(r);t=0;i=e;return t|0}else{k=aS(o<<2)|0;b:do{if((o|0)==0){v=0}else{n=b;m=b+32|0;u=0;while(1){Tc(c[n>>2]|0,(c[m>>2]|0)+ -4+((fa(c[l>>2]|0,u)|0)+f<<2)|0,0)|0;w=u+1|0;if((rb(k+(u<<2)|0,4,1,c[n>>2]|0)|0)!=1){break}x=c[q>>2]|0;if(w>>>0<x>>>0){u=w}else{v=x;break b}}bS(k);bS(r);t=0;i=e;return t|0}}while(0);u=(v|0)==0;do{if(j){if(u){break}else{y=0}do{h[r+(y<<3)>>3]=-+g[k+(y<<2)>>2];y=y+1|0;}while(y>>>0<v>>>0)}else{if(u){break}else{z=0}do{h[r+(z<<3)>>3]=+g[k+(z<<2)>>2];z=z+1|0;}while(z>>>0<v>>>0)}}while(0);bS(k)}}while(0);c[(c[s>>2]|0)+(d<<2)>>2]=p;t=c[(c[s>>2]|0)+(d<<2)>>2]|0;i=e;return t|0}function zo(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;j=i;i=i+8|0;k=j;l=(e|0)>-1?e:0-e|0;m=(e|0)<0;do{if(m){n=c[d+24>>2]|0;o=n+l|0;p=n}else{if((e|0)==0){q=23152;r=q;s=23200;t=s;u=23248;v=u;bb(r|0,t|0,519,v|0)}else{o=l;p=c[d+24>>2]|0;break}}}while(0);if(l>>>0>p>>>0){q=23152;r=q;s=23200;t=s;u=23248;v=u;bb(r|0,t|0,519,v|0)}v=c[(c[d+40>>2]|0)+(o+ -1<<2)>>2]|0;if((v|0)!=0){h[b>>3]=+h[v+(f<<3)>>3];w=0.0;i=j;return+w}v=d;o=c[v>>2]|0;t=c[d+32>>2]|0;r=l+ -1+(fa(p,f)|0)|0;do{if((a[d+44|0]|0)==1){Tc(o|0,t+(r<<3)|0,0)|0;f=(rb(b|0,8,1,c[v>>2]|0)|0)!=1;if(f|m^1){w=f?1.0:0.0;i=j;return+w}else{x=+h[b>>3];break}}else{Tc(o|0,t+(r<<2)|0,0)|0;if((rb(k|0,4,1,c[v>>2]|0)|0)!=1){w=1.0;i=j;return+w}y=+g[k>>2];h[b>>3]=y;if(m){x=y;break}else{w=0.0}i=j;return+w}}while(0);h[b>>3]=-x;w=0.0;i=j;return+w}function Ao(a,b,d,e,f,g,j){a=+a;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0;k=i;l=d+ -1|0;d=0;while(1){m=((l-d|0)/2|0)+d|0;n=+h[b+(m<<3)>>3];if(n==a){o=n;p=m;q=3;break}r=n<a;s=r?m+1|0:d;t=r?l:m+ -1|0;if((t|0)>(s|0)){l=t;d=s}else{break}}if((q|0)==3){while(1){q=0;if((p|0)>=(l|0)){break}d=p+1|0;n=+h[b+(d<<3)>>3];if(o==n){o=n;p=d;q=3}else{break}}c[e>>2]=p;h[f>>3]=1.0;c[g>>2]=-1;u=0.0;h[j>>3]=u;i=k;return}do{if((t|0)==(s|0)){if(+h[b+(s<<3)>>3]<a){v=s+1|0;w=s;break}else{v=s;w=s+ -1|0;break}}else{v=t;w=s}}while(0);c[e>>2]=v;c[g>>2]=w;o=+h[b+(w<<3)>>3];n=(a-o)/(+h[b+(v<<3)>>3]-o);h[f>>3]=n;u=1.0-n;h[j>>3]=u;i=k;return}function Bo(a){a=a|0;i=i;return+(+h[c[a+20>>2]>>3])}function Co(a){a=a|0;i=i;return+(+h[(c[a+20>>2]|0)+(c[a+16>>2]<<3)>>3])}function Do(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;f=i;i=i+48|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;if((c[d+8>>2]|0)!=0){o=c[d+12>>2]|0;if((o|0)<0){p=-+h[(c[b+20>>2]|0)+(~o<<3)>>3]}else{p=+h[(c[b+20>>2]|0)+(o+ -1<<3)>>3]}h[a>>3]=p;q=0;i=f;return q|0}if(+Co(b)<e){q=1;i=f;return q|0}if(+Bo(b)>e){q=1;i=f;return q|0}if((yo(b,1)|0)==0){q=1;i=f;return q|0}Ao(e,c[c[b+40>>2]>>2]|0,c[b+28>>2]|0,m,g,n,j);o=c[n>>2]|0;if((o|0)==-1){q=~~+zo(a,b,c[d+12>>2]|0,c[m>>2]|0);i=f;return q|0}n=c[m>>2]|0;m=d+12|0;d=c[m>>2]|0;if((n|0)==-1){q=~~+zo(a,b,d,o);i=f;return q|0}if(+zo(k,b,d,n)!=0.0){q=1;i=f;return q|0}if(+zo(l,b,c[m>>2]|0,o)!=0.0){q=1;i=f;return q|0}h[a>>3]=+h[g>>3]*+h[k>>3]+ +h[j>>3]*+h[l>>3];q=0;i=f;return q|0}function Eo(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=aS(20)|0;Un(0,(f|0)!=0|0,23280,e);c[f+8>>2]=0;c[f+12>>2]=0;e=(a|0)<1?1:a;c[f+16>>2]=e;c[f+4>>2]=b;a=cS(e,b)|0;c[f>>2]=a;Un(0,(a|0)!=0|0,23280,d);i=d;return f|0}function Fo(a){a=a|0;var b=0;b=i;bS(c[a>>2]|0);bS(a);i=b;return}function Go(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=a+12|0;Un(0,(c[h>>2]|0)>0|0,23296,g);g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=1-g;c[f+8>>2]=g+ -1;Un(0,(g|0)>(b|0)|0,23320,f);f=c[h>>2]|0;c[e>>2]=b;c[e+4>>2]=1-f;c[e+8>>2]=f+ -1;Un(0,(0-f|0)<(b|0)|0,23320,e);e=(c[a>>2]|0)+(fa(c[a+4>>2]|0,((c[a+8>>2]|0)+b|0)%(c[a+16>>2]|0)|0)|0)|0;i=d;return e|0}function Ho(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=a+16|0;e=a+4|0;f=cS(c[d>>2]<<1,c[e>>2]|0)|0;Un(0,(f|0)!=0|0,23280,b);g=a+12|0;if((c[g>>2]|0)>0){h=c[e>>2]|0;j=0;do{k=f+(fa(h,j)|0)|0;l=Go(a,j)|0;h=c[e>>2]|0;GS(k|0,l|0,h|0)|0;j=j+1|0;}while((j|0)<(c[g>>2]|0))}g=a;bS(c[g>>2]|0);c[g>>2]=f;c[d>>2]=c[d>>2]<<1;c[a+8>>2]=0;i=b;return}function Io(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+16|0;f=c[e>>2]|0;g=a+12|0;h=c[g>>2]|0;if((f|0)<(h+1|0)){Ho(a);j=c[e>>2]|0;k=c[g>>2]|0}else{j=f;k=h}h=c[a+4>>2]|0;GS((c[a>>2]|0)+(fa(h,(k+(c[a+8>>2]|0)|0)%(j|0)|0)|0)|0,b|0,h|0)|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function Jo(a){a=a|0;i=i;return c[a+12>>2]|0}function Ko(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=a+12|0;Un(0,(c[j>>2]|0)>0|0,23296,h);h=c[j>>2]|0;c[g>>2]=b;c[g+4>>2]=0;c[g+8>>2]=h+ -1;Un(0,(h|0)>(b|0)|0,23320,g);g=(c[j>>2]|0)+ -1|0;c[f>>2]=b;c[f+4>>2]=0;c[f+8>>2]=g;Un(0,b>>>31^1,23320,f);f=a+8|0;g=c[a+16>>2]|0;c[f>>2]=((fa(g+ -1|0,b)|0)+(c[f>>2]|0)|0)%(g|0)|0;if((d|0)==0){i=e;return}if((c[j>>2]|0)>0){k=0}else{i=e;return}do{c[d+(k<<2)>>2]=Go(a,k)|0;k=k+1|0;}while((k|0)<(c[j>>2]|0));i=e;return}function Lo(a){a=a|0;i=i;return c[(c[5838]|0)+(a<<2)>>2]|0}function Mo(a){a=a|0;i=i;return c[(c[5840]|0)+(a<<2)>>2]|0}function No(a){a=a|0;i=i;return c[(c[5842]|0)+(a<<2)>>2]|0}function Oo(a){a=a|0;i=i;return c[(c[5844]|0)+(a<<2)>>2]|0}function Po(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=(c[5840]|0)+(a<<2)|0;e=c[d>>2]|0;f=(c[5842]|0)+(a<<2)|0;g=c[f>>2]|0;h=c[(c[5838]|0)+(a<<2)>>2]|0;if((h|0)==0){i=b;return}c[d>>2]=(e|0)!=0&e>>>0<h>>>0?e:h;c[f>>2]=g>>>0>h>>>0?g:h;i=b;return}function Qo(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[5846]|0;e=+Ro(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Ro(a,b){a=a|0;b=b|0;i=i;return+(+(a|0)+ +(b|0)*1.0e-9)}function So(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[5848]|0;e=+Ro(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function To(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[5850]|0;e=+Ro(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Uo(a){a=a|0;i=i;return 0}function Vo(a){a=a|0;var b=0,d=0;b=i;fb(4,(c[5852]|0)+(a<<3)|0)|0;d=(c[5838]|0)+(a<<2)|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function Wo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[5846]|0;f=e+(a<<3)|0;g=c[5850]|0;h=g+(a<<3)|0;c[h>>2]=(c[h>>2]|0)+(c[f>>2]|0);h=e+(a<<3)+4|0;e=g+(a<<3)+4|0;c[e>>2]=(c[e>>2]|0)+(c[h>>2]|0);e=(c[5844]|0)+(a<<2)|0;c[e>>2]=(c[e>>2]|0)+(c[(c[5838]|0)+(a<<2)>>2]|0);e=c[5848]|0;g=e+(a<<3)|0;Xo(d,c[g>>2]|0,c[e+(a<<3)+4>>2]|0,c[f>>2]|0,c[h>>2]|0);h=d;d=c[h+4>>2]|0;f=g;c[f>>2]=c[h>>2];c[f+4>>2]=d;Po(a);d=c[5846]|0;c[d+(a<<3)>>2]=0;c[d+(a<<3)+4>>2]=0;c[(c[5838]|0)+(a<<2)>>2]=0;i=b;return}function Xo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(_o(b,d,e,f)|0)<0;if(h){j=e;k=f}else{j=b;k=d}d=a;c[d>>2]=j;c[d+4>>2]=k;i=g;return}function Yo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+8|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;fb(4,d|0)|0;e=c[5852]|0;f=c[5846]|0;g=f+(a<<3)|0;h=(c[d>>2]|0)-(c[e+(a<<3)>>2]|0)+(c[g>>2]|0)|0;c[g>>2]=h;j=f+(a<<3)+4|0;f=(c[d+4>>2]|0)-(c[e+(a<<3)+4>>2]|0)+(c[j>>2]|0)|0;c[j>>2]=f;if((f|0)<=999999999){i=b;return}c[g>>2]=h+1;c[j>>2]=~~(+(f|0)+-1.0e9);i=b;return}function Zo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((a|0)<33){i=b;return}d=cS(a,8)|0;c[5846]=d;e=cS(a,8)|0;c[5848]=e;f=cS(a,8)|0;c[5850]=f;g=cS(a,8)|0;c[5852]=g;h=cS(a,4)|0;c[5838]=h;j=cS(a,4)|0;c[5844]=j;k=a<<2;l=aS(k)|0;c[5840]=l;m=cS(a,4)|0;c[5842]=m;IS(l|0,-1,k|0)|0;if((d|0)==0){bb(23416,23432,393,23448)}if((e|0)==0){bb(23456,23432,394,23448)}if((f|0)==0){bb(23472,23432,395,23448)}if((g|0)==0){bb(23488,23432,396,23448)}if((h|0)==0){bb(23504,23432,397,23448)}if((l|0)==0){bb(23528,23432,398,23448)}if((m|0)==0){bb(23552,23432,399,23448)}if((j|0)==0){bb(23576,23432,400,23448)}else{i=b;return}}function _o(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;i=i;return((a|0)==(c|0)?b-d|0:a-c|0)|0}function $o(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+8|0;o=n;c[o>>2]=1;c[n+4>>2]=c[b>>2];if((a|0)==2){c[j>>2]=c[b+8>>2];n=j+4|0;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Sn(17,0,o,25360,j);i=e;return}else if((a|0)==0){c[m>>2]=c[b+8>>2];j=m+4|0;h[k>>3]=d;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];Sn(17,0,o,25208,m);i=e;return}else if((a|0)==3){c[g>>2]=c[b+8>>2];m=g+4|0;h[k>>3]=d;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];Sn(17,0,o,25456,g);i=e;return}else if((a|0)==1){c[l>>2]=c[b+8>>2];g=l+4|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];Sn(17,0,o,25256,l);i=e;return}else{l=c[b+8>>2]|0;c[f>>2]=a;c[f+4>>2]=l;l=f+8|0;h[k>>3]=d;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];Sn(17,0,o,25520,f);i=e;return}}function ap(a){a=a|0;var b=0;b=i;bS(c[a+12>>2]|0);bS(c[a+4>>2]|0);bS(c[a+8>>2]|0);i=b;return}function bp(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;z=~y;h[3793]=.5;h[3779]=1.0;h[3816]=.25;h[3791]=2.0;h[3818]=6.283185307179586;A=w+ -1-(c[b>>2]|0)|0;c[7594]=A;B=c[d>>2]|0;c[7524]=1;if((B|0)>=1){C=1;while(1){h[p+(C+ -1+(c[b>>2]|0)<<3)>>3]=0.0;D=C+1|0;c[7524]=D;if((C|0)<(B|0)){C=D}else{break}}}c[7522]=1;if((A|0)>=1){C=1;while(1){B=fa(C,w)|0;E=+h[j+(B+x+(c[n>>2]|0)<<3)>>3];h[3794]=E;if((C|0)<(c[k>>2]|0)){F=-E;h[3794]=F;G=F}else{G=E}D=c[d>>2]|0;c[7524]=1;a:do{if((D|0)>=1){E=G;H=1;while(1){I=p+(H+ -1+(c[b>>2]|0)<<3)|0;h[I>>3]=E*+h[j+(H+x+B<<3)>>3]+ +h[I>>3];I=H+1|0;c[7524]=I;if((H|0)>=(D|0)){break a}E=+h[3794];H=I}}}while(0);D=C+1|0;c[7522]=D;if((C|0)<(A|0)){C=D}else{break}}}C=c[b>>2]|0;h[3798]=+h[p+(C+ -1+(c[n>>2]|0)<<3)>>3];h[3763]=0.0;h[3765]=0.0;h[3769]=0.0;h[3826]=0.0;c[7520]=1;if((C|0)<1){J=0.0;K=0.0;L=0.0}else{G=0.0;A=1;while(1){D=A+ -1|0;B=o+(D<<3)|0;E=+h[B>>3];h[3763]=G+E*E;E=+h[f+((c[n>>2]|0)+x+(fa(A,w)|0)<<3)>>3];H=e+(D<<3)|0;F=E- +h[H>>3];I=s+(D<<3)|0;h[I>>3]=F;E=+h[3765]+ +h[B>>3]*F;h[3765]=E;F=+h[I>>3];M=+h[3769]+F*F;h[3769]=M;F=+h[H>>3];h[3826]=+h[3826]+F*F;H=A+1|0;c[7520]=H;F=+h[3763];if((A|0)<(C|0)){A=H;G=F}else{J=M;K=F;L=E;break}}}G=L*L;do{if(G>K*.99*J){A=c[n>>2]|0;c[7590]=A;E=G/J;h[3815]=E;C=c[d>>2]|0;c[7524]=1;if((C|0)<1){N=J;O=L;P=A}else{F=J;M=L;Q=E;H=A;A=1;while(1){do{if((A|0)==(c[m>>2]|0)){R=F;S=M;T=Q;U=H}else{h[3823]=0.0;h[3825]=0.0;I=c[b>>2]|0;c[7520]=1;if((I|0)<1){W=0.0;Z=0.0}else{E=0.0;_=0.0;B=1;while(1){$=+h[f+((fa(B,w)|0)+x+A<<3)>>3];aa=$- +h[e+(B+ -1<<3)>>3];h[3792]=aa;ba=_+aa*+h[o+(B+ -1<<3)>>3];h[3823]=ba;ca=E+aa*aa;h[3825]=ca;if((B|0)<(I|0)){B=B+1|0;_=ba;E=ca}else{break}}c[7520]=I+1;W=ca;Z=ba}E=Z*Z/W;if(!(E<Q)){R=F;S=M;T=Q;U=H;break}c[7590]=A;h[3815]=E;h[3765]=Z;h[3769]=W;R=W;S=Z;T=E;U=A}}while(0);B=A+1|0;c[7524]=B;if((A|0)<(C|0)){F=R;M=S;Q=T;H=U;A=B}else{N=R;O=S;P=U;break}}}A=c[b>>2]|0;c[7520]=1;if((A|0)<1){da=O;ea=N;ga=K;break}else{ha=1}while(1){Q=+h[f+((fa(ha,w)|0)+x+P<<3)>>3];H=ha+ -1|0;h[s+(H<<3)>>3]=Q- +h[e+(H<<3)>>3];if((ha|0)<(A|0)){ha=ha+1|0}else{break}}c[7520]=A+1;da=+h[3765];ea=+h[3769];ga=+h[3763]}else{da=L;ea=J;ga=K}}while(0);K=ga*ea-da*da;h[3814]=K;c[7618]=0;h[3822]=0.0;ha=(y<<1)+z|0;P=(y<<2)+z|0;U=(y*3|0)+z|0;H=(y*5|0)+z|0;ea=da;da=ga;ga=K;C=1;while(1){c[7618]=C;K=+h[3779]/+V(+ga);h[3794]=K;h[3817]=0.0;h[3819]=0.0;B=c[b>>2]|0;c[7520]=1;if((B|0)<1){ia=da;ja=0.0;ka=0.0}else{J=ea;L=da;N=K;D=1;la=0;while(1){ma=s+(la<<3)|0;h[ma>>3]=N*(L*+h[ma>>3]-J*+h[o+(la<<3)>>3]);ma=D+ -1|0;na=e+(ma<<3)|0;oa=+h[3817]+ +h[na>>3]*+h[o+(ma<<3)>>3];h[3817]=oa;pa=+h[3819]+ +h[na>>3]*+h[s+(ma<<3)>>3];h[3819]=pa;if((D|0)>=(B|0)){break}ma=D;J=+h[3765];L=+h[3763];N=+h[3794];D=D+1|0;la=ma}c[7520]=B+1;ia=+h[3763];ja=pa;ka=oa}N=+h[3793];L=ka*N*ka;h[3810]=L;J=ja*N*ja;h[3811]=J;h[3770]=J+(L+ia*(+h[3826]+ia*N));N=+h[3791];h[30168>>3]=N*ka*ia;h[30176>>3]=N*ja*ia;h[30184>>3]=L-J;h[30192>>3]=ka*ja;la=30200|0;c[la+0>>2]=0;c[la+4>>2]=0;c[la+8>>2]=0;c[la+12>>2]=0;c[la+16>>2]=0;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=0;c[7520]=10;la=c[d>>2]|0;c[7524]=1;if((la|0)>=1){D=1;while(1){h[3810]=0.0;h[3811]=0.0;h[3812]=0.0;A=c[b>>2]|0;c[7520]=1;if((A|0)<1){qa=0.0;ra=0.0}else{ma=D+x|0;J=0.0;L=0.0;N=0.0;na=1;while(1){K=+h[f+((fa(na,w)|0)+x+D<<3)>>3];sa=N+K*+h[o+(na+ -1<<3)>>3];h[3810]=sa;ta=f+(ma+(fa(na,w)|0)<<3)|0;ua=na+ -1|0;va=L+ +h[ta>>3]*+h[s+(ua<<3)>>3];h[3811]=va;K=J+ +h[ta>>3]*+h[e+(ua<<3)>>3];h[3812]=K;if((na|0)<(A|0)){na=na+1|0;N=sa;L=va;J=K}else{break}}c[7520]=A+1;qa=va;ra=sa}h[t+(D+ -1<<3)>>3]=+h[3816]*(ra*ra+qa*qa);h[t+(ha+D<<3)>>3]=+h[3810]*+h[3812];h[t+(U+D<<3)>>3]=+h[3811]*+h[3812];J=+h[3810];L=+h[3811];h[t+(P+D<<3)>>3]=+h[3816]*(J*J-L*L);h[t+(H+D<<3)>>3]=+h[3793]*+h[3810]*+h[3811];na=D+1|0;c[7524]=na;if((D|0)<(la|0)){D=na}else{break}}}D=c[b>>2]|0;c[7520]=1;if((D|0)>=1){la=1;while(1){B=(c[d>>2]|0)+la|0;c[7532]=B;h[t+(B+ -1<<3)>>3]=0.0;na=la+ -1|0;h[t+(ha+B<<3)>>3]=+h[o+(na<<3)>>3];h[t+(U+B<<3)>>3]=+h[s+(na<<3)>>3];h[t+(P+B<<3)>>3]=0.0;h[t+(H+B<<3)>>3]=0.0;B=la+1|0;c[7520]=B;if((la|0)<(D|0)){la=B}else{break}}}c[7528]=1;la=1;do{D=c[d>>2]|0;c[7536]=D;if((la&-2|0)==2){B=c[l>>2]|0;c[7536]=B;wa=B}else{wa=D}D=c[d>>2]|0;c[7524]=1;if((D|0)>=1){B=fa(la,y)|0;na=1;while(1){h[u+(na+z+B<<3)>>3]=0.0;if((na|0)<(D|0)){na=na+1|0}else{break}}c[7524]=D+1}na=c[7594]|0;c[7522]=1;if((na|0)<1){xa=la}else{B=1;A=la;while(1){h[3790]=0.0;ma=c[d>>2]|0;c[7524]=1;if((ma|0)<1){ya=0.0;za=A}else{ua=fa(la,y)|0;L=0.0;ta=1;while(1){J=+h[j+(ta+x+(fa(B,w)|0)<<3)>>3];Aa=L+J*+h[t+(ta+z+ua<<3)>>3];h[3790]=Aa;if((ta|0)<(ma|0)){ta=ta+1|0;L=Aa}else{break}}c[7524]=ma+1;ya=Aa;za=la}if((B|0)<(c[k>>2]|0)){L=-ya;h[3790]=L;Ba=L}else{Ba=ya}ta=c[d>>2]|0;c[7524]=1;if((ta|0)>=1){ua=fa(B,w)|0;I=fa(za,y)|0;L=Ba;Ca=1;while(1){Da=u+(Ca+z+I<<3)|0;h[Da>>3]=L*+h[j+(Ca+x+ua<<3)>>3]+ +h[Da>>3];if((Ca|0)>=(ta|0)){break}L=+h[3790];Ca=Ca+1|0}c[7524]=ta+1}Ca=B+1|0;c[7522]=Ca;if((B|0)<(na|0)){B=Ca;A=za}else{xa=za;break}}}do{if((wa|0)==(c[l>>2]|0)){A=c[d>>2]|0;c[7524]=1;if((A|0)<1){break}else{Ea=1}while(1){h[3790]=0.0;B=c[b>>2]|0;c[7522]=1;if((B|0)<1){Fa=fa(xa,y)|0;Ga=0.0}else{L=0.0;na=1;while(1){J=+h[g+((fa(na,y)|0)+z+Ea<<3)>>3];D=fa(xa,y)|0;N=L+J*+h[t+(na+z+(c[d>>2]|0)+D<<3)>>3];h[3790]=N;Ca=na+1|0;c[7522]=Ca;if((na|0)<(B|0)){na=Ca;L=N}else{Fa=D;Ga=N;break}}}na=u+(Ea+z+Fa<<3)|0;h[na>>3]=Ga+ +h[na>>3];na=Ea+1|0;c[7524]=na;if((Ea|0)<(A|0)){Ea=na}else{break}}}}while(0);A=c[b>>2]|0;c[7522]=1;if((A|0)>=1){ta=1;while(1){h[3790]=0.0;c[7520]=1;if((wa|0)<1){Ha=fa(xa,y)|0;Ia=0.0}else{na=fa(ta,y)|0;B=fa(xa,y)|0;L=0.0;D=1;while(1){Ca=D+z|0;Ja=L+ +h[g+(Ca+na<<3)>>3]*+h[t+(Ca+B<<3)>>3];h[3790]=Ja;if((D|0)<(wa|0)){D=D+1|0;L=Ja}else{break}}c[7520]=wa+1;Ha=B;Ia=Ja}h[u+((c[d>>2]|0)+z+ta+Ha<<3)>>3]=Ia;D=ta+1|0;c[7522]=D;if((ta|0)<(A|0)){ta=D}else{break}}}la=xa+1|0;c[7528]=la;}while((la|0)<6);la=c[l>>2]|0;c[7524]=1;h[3790]=0.0;c[7520]=1;L=+h[3793];if((la|0)<1){Ka=L}else{N=L;ta=1;while(1){L=0.0;A=1;do{D=(fa(A,y)|0)+z+ta|0;h[30240+(A+ -1<<3)>>3]=N*+h[u+(D<<3)>>3]*+h[t+(D<<3)>>3];L=+h[30240+(A+ -1<<3)>>3]+L;h[3790]=L;A=A+1|0;}while((A|0)<6);h[3770]=+h[3770]- +h[3780]-L;A=ta+ -1|0;D=u+(A<<3)|0;na=ha+ta|0;Ca=t+(na<<3)|0;ua=u+(na<<3)|0;na=t+(A<<3)|0;J=+h[D>>3]*+h[Ca>>3]+ +h[ua>>3]*+h[na>>3];h[3810]=J;A=P+ta|0;I=t+(A<<3)|0;ma=u+(A<<3)|0;K=+h[ua>>3]*+h[I>>3]+ +h[ma>>3]*+h[Ca>>3];h[3811]=K;A=U+ta|0;Da=u+(A<<3)|0;La=H+ta|0;Ma=t+(La<<3)|0;Na=u+(La<<3)|0;La=t+(A<<3)|0;O=+h[Da>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[La>>3];h[3812]=O;h[30168>>3]=+h[30168>>3]-J-N*(O+K);h[30200>>3]=+h[30200>>3]-N*(K-O);O=+h[D>>3]*+h[La>>3]+ +h[Da>>3]*+h[na>>3];h[3810]=O;K=+h[ua>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[Ca>>3];h[3811]=K;J=+h[Da>>3]*+h[I>>3]+ +h[ma>>3]*+h[La>>3];h[3812]=J;h[30176>>3]=+h[30176>>3]-O-N*(K-J);h[30208>>3]=+h[30208>>3]-N*(K+J);J=+h[D>>3]*+h[I>>3]+ +h[ma>>3]*+h[na>>3];h[3810]=J;h[30184>>3]=+h[30256>>3]+(+h[30184>>3]-J- +h[30248>>3]);J=+h[D>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[na>>3];h[3810]=J;K=+h[ua>>3]*+h[La>>3]+ +h[Da>>3]*+h[Ca>>3];h[3811]=K;Oa=+h[3793];h[30192>>3]=+h[30192>>3]-J-K*Oa;h[30216>>3]=+h[30216>>3]- +h[30264>>3]+ +h[30272>>3];K=+h[ma>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[I>>3];h[3810]=K;h[30224>>3]=+h[30224>>3]-Oa*K;h[3790]=0.0;if((ta|0)<(la|0)){N=Oa;ta=ta+1|0}else{break}}c[7524]=la+1;c[7520]=1;Ka=Oa}N=0.0;ta=1;do{K=+h[u+((fa(ta,y)|0)+z+(c[n>>2]|0)<<3)>>3];h[30240+(ta+ -1<<3)>>3]=Ka*K*K;N=+h[30240+(ta+ -1<<3)>>3]+N;h[3790]=N;ta=ta+1|0;c[7520]=ta;}while((ta|0)<6);K=+h[3798];h[3800]=K*+h[3770]+ +h[3780]+N;J=+h[3791];ta=c[n>>2]|0;la=u+(ta+ -1<<3)|0;I=u+(ha+ta<<3)|0;O=J*+h[la>>3]*+h[I>>3];h[3810]=O;Na=u+(P+ta<<3)|0;S=+h[I>>3]*+h[Na>>3];h[3811]=S;Ma=u+(U+ta<<3)|0;ma=u+(H+ta<<3)|0;R=+h[Ma>>3]*+h[ma>>3];h[3812]=R;T=R+(K*+h[30168>>3]+O+S);h[30408>>3]=T;O=K*+h[30200>>3]+S-R;h[30440>>3]=O;R=J*+h[la>>3]*+h[Ma>>3];h[3810]=R;S=+h[I>>3]*+h[ma>>3];h[3811]=S;Z=+h[Ma>>3]*+h[Na>>3];h[3812]=Z;h[30416>>3]=K*+h[30176>>3]+R+S-Z;h[30448>>3]=K*+h[30208>>3]+S+Z;Z=J*+h[la>>3]*+h[Na>>3];h[3810]=Z;R=+h[30248>>3]+(Z+K*+h[30184>>3])- +h[30256>>3];h[30424>>3]=R;Z=J*+h[la>>3]*+h[ma>>3];h[3810]=Z;h[30432>>3]=Z+K*+h[30192>>3]+ +h[I>>3]*+h[Ma>>3];J=K*+h[30216>>3]+ +h[30264>>3]- +h[30272>>3];h[30456>>3]=J;h[30464>>3]=+h[3798]*+h[30224>>3]+ +h[Na>>3]*+h[ma>>3];K=+h[3800]+T+R+O+J;h[3790]=K;h[3820]=K;h[3821]=K;c[7626]=0;J=+h[3818]/50.0;h[3794]=J;h[3780]=+h[3779];c[7520]=1;O=K;ma=0;R=K;T=S;S=Z;Na=1;while(1){Pa=+(Na|0)*J;Z=+X(+Pa);h[30248>>3]=Z;W=+Y(+Pa);h[30256>>3]=W;ba=W;ca=Z;G=W;W=Z;Ma=4;while(1){Z=ca*W-ba*G;h[30240+(Ma+ -1<<3)>>3]=Z;Q=+h[30248>>3]*G+ +h[30256>>3]*W;h[30240+(Ma<<3)>>3]=Q;I=Ma+2|0;if((I|0)>=9){Qa=1;Ra=0.0;break}ba=+h[30256>>3];ca=+h[30248>>3];Ma=I;W=Z;G=Q}do{Ma=Qa+ -1|0;Ra=Ra+ +h[30400+(Ma<<3)>>3]*+h[30240+(Ma<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<10);if(!(Ra>=0.0)){Sa=-Ra}else{Sa=Ra}if(!(R>=0.0)){Ta=-R}else{Ta=R}do{if(Sa>Ta){h[3821]=Ra;c[7626]=Na;h[3810]=O;Ua=Ra;Va=T;Wa=O;Xa=Na}else{if((Na|0)!=(ma+1|0)){Ua=R;Va=T;Wa=S;Xa=ma;break}h[3811]=Ra;Ua=R;Va=Ra;Wa=S;Xa=ma}}while(0);if((Na|0)>48){break}else{O=Ra;ma=Xa;R=Ua;T=Va;S=Wa;Na=Na+1|0}}c[7522]=10;h[3790]=Ra;h[3799]=Pa;h[3824]=O;c[7520]=50;if((Xa|0)==49){h[3811]=K;Ya=Wa;Za=K}else if((Xa|0)==0){h[3810]=Ra;Ya=Ra;Za=Va}else{Ya=Wa;Za=Va}h[3796]=0.0;if(Ya!=Za){S=Ya-Ua;h[3810]=S;T=Za-Ua;h[3811]=T;R=+h[3793]*(S-T)/(S+T);h[3796]=R;_a=R}else{_a=0.0}R=J*(+(Xa|0)+_a);h[3799]=R;T=+X(+R);h[30248>>3]=T;S=+Y(+R);h[30256>>3]=S;c[7522]=4;R=S;N=T;G=S;S=T;Na=4;while(1){T=N*S-R*G;h[30240+(Na+ -1<<3)>>3]=T;W=+h[30248>>3]*G+ +h[30256>>3]*S;h[30240+(Na<<3)>>3]=W;ma=Na+2|0;if((ma|0)>=9){break}R=+h[30256>>3];N=+h[30248>>3];Na=ma;S=T;G=W}h[r>>3]=0.0;h[3821]=0.0;c[7522]=1;Na=1;do{ma=Na+ -1|0;Ma=30240+(ma<<3)|0;h[r>>3]=+h[r>>3]+ +h[30160+(ma<<3)>>3]*+h[Ma>>3];h[3821]=+h[3821]+ +h[30400+(ma<<3)>>3]*+h[Ma>>3];Na=Na+1|0;}while((Na|0)<10);c[7522]=10;Na=c[l>>2]|0;c[7524]=1;if((Na|0)>=1){Ma=1;while(1){h[q+(Ma+ -1<<3)>>3]=0.0;ma=1;do{G=+h[u+((fa(ma,y)|0)+z+Ma<<3)>>3];I=q+(Ma+ -1<<3)|0;h[I>>3]=+h[I>>3]+G*+h[30240+(ma+ -1<<3)>>3];ma=ma+1|0;}while((ma|0)<6);if((Ma|0)<(Na|0)){Ma=Ma+1|0}else{break}}c[7522]=6;c[7524]=Na+1}h[3789]=+h[q+((c[n>>2]|0)+ -1<<3)>>3];h[3763]=0.0;h[3810]=0.0;h[3811]=0.0;Ma=c[b>>2]|0;c[7520]=1;if((Ma|0)<1){$a=0.0;ab=0.0}else{ma=1;while(1){I=ma+ -1|0;la=o+(I<<3)|0;h[la>>3]=+h[30248>>3]*+h[la>>3]+ +h[30256>>3]*+h[s+(I<<3)>>3];I=ma+ -1|0;la=o+(I<<3)|0;ta=p+(I<<3)|0;h[ta>>3]=+h[e+(I<<3)>>3]+ +h[la>>3];G=+h[la>>3];h[3763]=+h[3763]+G*G;bb=+h[3810]+ +h[la>>3]*+h[ta>>3];h[3810]=bb;G=+h[ta>>3];cb=+h[3811]+G*G;h[3811]=cb;if((ma|0)<(Ma|0)){ma=ma+1|0}else{break}}c[7520]=Ma+1;$a=cb;ab=bb}ma=c[7618]|0;Na=c[b>>2]|0;if((ma|0)>=(Na|0)){break}if((ma|0)>1){G=+h[3822];S=+h[3820];h[3822]=G>=S?G:S}S=+h[3821];if(!(S>=0.0)){db=-S}else{db=S}G=+h[3822];if(!(G>=0.0)){eb=-G}else{eb=G}if(db<=eb*1.1){break}h[3822]=S;c[7520]=1;b:do{if((Na|0)>=1){S=$a;G=ab;ta=1;while(1){la=ta+ -1|0;N=G*+h[e+(la<<3)>>3]+S*+h[o+(la<<3)>>3]- +h[q+(la+(c[d>>2]|0)<<3)>>3];h[3794]=N;R=+h[3789]*+h[g+((c[n>>2]|0)+z+(fa(ta,y)|0)<<3)>>3];h[s+(la<<3)>>3]=R+N*+h[3798];la=ta+1|0;c[7520]=la;if((ta|0)>=(Na|0)){break b}S=+h[3811];G=+h[3810];ta=la}}}while(0);Na=c[d>>2]|0;c[7524]=1;if((Na|0)>=1){Ma=1;while(1){h[3790]=0.0;ta=c[b>>2]|0;c[7522]=1;if((ta|0)<1){fb=0.0}else{G=0.0;la=1;while(1){S=+h[f+((fa(la,w)|0)+x+Ma<<3)>>3];gb=G+S*+h[p+(la+ -1<<3)>>3];h[3790]=gb;if((la|0)<(ta|0)){la=la+1|0;G=gb}else{break}}c[7522]=ta+1;fb=gb}la=c[b>>2]|0;G=fb*(+h[3789]*+h[p+(la+ -1+Ma<<3)>>3]- +h[3798]*+h[q+(Ma+ -1<<3)>>3]);h[3794]=G;c[7520]=1;if((la|0)>=1){S=G;I=1;while(1){G=S*+h[f+((fa(I,w)|0)+x+Ma<<3)>>3];Ca=s+(I+ -1<<3)|0;h[Ca>>3]=+h[Ca>>3]+G;if((I|0)>=(la|0)){break}S=+h[3794];I=I+1|0}c[7520]=la+1}I=Ma+1|0;c[7524]=I;if((Ma|0)<(Na|0)){Ma=I}else{break}}}h[3769]=0.0;h[3765]=0.0;Ma=c[b>>2]|0;c[7520]=1;if((Ma|0)<1){hb=0.0;ib=0.0}else{S=0.0;G=0.0;Na=1;while(1){N=+h[s+(Na+ -1<<3)>>3];jb=G+N*N;h[3769]=jb;I=Na+ -1|0;kb=S+ +h[o+(I<<3)>>3]*+h[s+(I<<3)>>3];h[3765]=kb;if((Na|0)<(Ma|0)){Na=Na+1|0;G=jb;S=kb}else{break}}c[7520]=Ma+1;hb=kb;ib=jb}S=+h[3763];G=S*ib-hb*hb;h[3814]=G;if(!(G>=S*1.0e-8*ib)){break}ea=hb;da=S;ga=G;C=ma+1|0}a[30136]=1;C=c[l>>2]|0;c[7524]=1;if((C|0)<1){lb=30232;mb=+h[3779];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}else{vb=1}while(1){h[p+(vb+ -1<<3)>>3]=0.0;l=1;do{ga=+h[t+((fa(l,y)|0)+z+vb<<3)>>3];s=p+(vb+ -1<<3)|0;h[s>>3]=+h[s>>3]+ga*+h[30240+(l+ -1<<3)>>3];l=l+1|0;}while((l|0)<6);if((vb|0)<(C|0)){vb=vb+1|0}else{break}}c[7522]=6;c[7524]=C+1;lb=30232;mb=+h[3779];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}function cp(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;l=~y;h[3846]=.5;h[3842]=1.0;h[3858]=6.283185307179586;z=+h[n>>3];h[3855]=z*z;A=w+ -1-(c[b>>2]|0)|0;c[7698]=A;c[7706]=0;B=c[d>>2]|0;c[7658]=1;if((B|0)>=1){C=1;while(1){h[q+(C+ -1<<3)>>3]=0.0;if((C|0)<(B|0)){C=C+1|0}else{break}}c[7658]=B+1}c[7656]=1;B=c[m>>2]|0;if((A|0)<1){D=B}else{C=B;B=1;while(1){E=fa(B,w)|0;z=+h[j+(E+x+C<<3)>>3];h[3847]=z;if((B|0)<(c[k>>2]|0)){F=-z;h[3847]=F;G=F}else{G=z}H=c[d>>2]|0;c[7658]=1;if((H|0)>=1){z=G;I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]+z*+h[j+(I+x+E<<3)>>3];if((I|0)>=(H|0)){break}z=+h[3847];I=I+1|0}c[7658]=H+1}I=B+1|0;c[7656]=I;E=c[m>>2]|0;if((B|0)<(A|0)){C=E;B=I}else{D=E;break}}}h[p>>3]=+h[q+(D+ -1<<3)>>3];h[3830]=0.0;D=c[b>>2]|0;c[7654]=1;if((D|0)>=1){p=1;while(1){B=c[m>>2]|0;G=+h[f+((fa(p,w)|0)+x+B<<3)>>3];C=p+ -1|0;A=o+(C<<3)|0;h[A>>3]=G- +h[e+(C<<3)>>3];h[r+(C<<3)>>3]=+h[g+(B+l+(fa(p,y)|0)<<3)>>3];h[s+(C<<3)>>3]=0.0;G=+h[A>>3];h[3830]=+h[3830]+G*G;A=p+1|0;c[7654]=A;if((p|0)<(D|0)){p=A}else{break}}}p=c[d>>2]|0;c[7658]=1;if((p|0)>=1){D=1;while(1){h[3847]=0.0;h[3845]=0.0;y=c[b>>2]|0;c[7656]=1;if((y|0)<1){K=0.0;L=0.0}else{l=D+x|0;G=0.0;z=0.0;g=1;while(1){F=+h[f+((fa(g,w)|0)+x+D<<3)>>3];M=z+F*+h[e+(g+ -1<<3)>>3];h[3847]=M;F=+h[f+(l+(fa(g,w)|0)<<3)>>3];N=G+F*+h[o+(g+ -1<<3)>>3];h[3845]=N;if((g|0)<(y|0)){g=g+1|0;z=M;G=N}else{break}}c[7656]=y+1;K=M;L=N}g=q+(D+ -1<<3)|0;G=+h[g>>3]*K;h[3847]=G;h[3845]=+h[g>>3]*L;g=c[b>>2]|0;c[7654]=1;if((g|0)>=1){l=D+x|0;z=G;H=1;while(1){G=z*+h[f+((fa(H,w)|0)+x+D<<3)>>3];m=r+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;G=+h[3845]*+h[f+(l+(fa(H,w)|0)<<3)>>3];m=s+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;if((H|0)>=(g|0)){break}z=+h[3847];H=H+1|0}c[7654]=g+1}H=D+1|0;c[7658]=H;if((D|0)<(p|0)){D=H}else{break}}}h[3831]=0.0;h[3833]=0.0;h[3840]=0.0;D=c[b>>2]|0;c[7654]=1;if((D|0)<1){O=0.0;P=0.0;Q=0.0}else{L=0.0;K=0.0;N=0.0;p=1;while(1){M=+h[r+(p+ -1<<3)>>3];R=N+M*M;h[3831]=R;e=p+ -1|0;H=o+(e<<3)|0;S=K+ +h[H>>3]*+h[r+(e<<3)>>3];h[3833]=S;T=L+ +h[H>>3]*+h[s+(e<<3)>>3];h[3840]=T;if((p|0)<(D|0)){p=p+1|0;N=R;K=S;L=T}else{break}}c[7654]=D+1;O=R;P=T;Q=S}S=+h[3830];T=+h[n>>3]/+V(+S);if(Q*P<0.0){U=-T}else{U=T}h[3851]=U;h[3847]=0.0;if(Q*Q>S*.99*O){h[3847]=+h[3842]}if(!(Q>=0.0)){W=-Q}else{W=Q}if(!(P>=0.0)){Z=-P}else{Z=P}P=U*(W+ +h[3846]*U*Z);h[3843]=P;if(O*+h[3855]<P*P*.01){h[3847]=+h[3842]}n=c[b>>2]|0;c[7654]=1;if((n|0)<1){_=0}else{P=U;D=1;p=0;while(1){e=o+(p<<3)|0;h[e>>3]=P*+h[e>>3];e=D+ -1|0;H=s+(e<<3)|0;U=+h[3851]*+h[H>>3];h[H>>3]=U;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+ +h[3847]*U;if((D|0)>=(n|0)){break}e=D;P=+h[3851];D=D+1|0;p=e}c[7654]=n+1;_=0}while(1){n=_+1|0;c[7706]=n;h[3830]=0.0;h[3833]=0.0;h[3834]=0.0;p=c[b>>2]|0;c[7654]=1;if((p|0)<1){$=0.0;aa=0.0;ba=0.0}else{P=0.0;U=0.0;O=0.0;D=1;while(1){Z=+h[o+(D+ -1<<3)>>3];ca=O+Z*Z;h[3830]=ca;e=D+ -1|0;H=t+(e<<3)|0;da=U+ +h[o+(e<<3)>>3]*+h[H>>3];h[3833]=da;Z=+h[H>>3];ea=P+Z*Z;h[3834]=ea;if((D|0)<(p|0)){D=D+1|0;O=ca;U=da;P=ea}else{break}}c[7654]=p+1;$=da;aa=ea;ba=ca}P=ba*aa-$*$;h[3847]=P;if(P<=ba*1.0e-8*aa){ga=88;break}U=+V(+P);h[3852]=U;D=c[b>>2]|0;c[7654]=1;if((D|0)>=1){P=U;U=$;O=ba;g=1;H=0;while(1){e=t+(H<<3)|0;h[e>>3]=(O*+h[e>>3]-U*+h[o+(H<<3)>>3])/P;h[u+(g+ -1<<3)>>3]=0.0;if((g|0)>=(D|0)){break}e=g;P=+h[3852];U=+h[3833];O=+h[3830];g=g+1|0;H=e}c[7654]=D+1}H=c[d>>2]|0;c[7658]=1;if((H|0)>=1){g=1;while(1){h[3845]=0.0;p=c[b>>2]|0;c[7656]=1;if((p|0)<1){ha=0.0}else{O=0.0;e=1;while(1){U=+h[f+((fa(e,w)|0)+x+g<<3)>>3];ia=O+U*+h[t+(e+ -1<<3)>>3];h[3845]=ia;if((e|0)<(p|0)){e=e+1|0;O=ia}else{break}}c[7656]=p+1;ha=ia}O=+h[q+(g+ -1<<3)>>3]*ha;h[3845]=O;e=c[b>>2]|0;c[7654]=1;if((e|0)>=1){U=O;l=1;while(1){O=U*+h[f+((fa(l,w)|0)+x+g<<3)>>3];y=u+(l+ -1<<3)|0;h[y>>3]=+h[y>>3]+O;if((l|0)>=(e|0)){break}U=+h[3845];l=l+1|0}c[7654]=e+1}l=g+1|0;c[7658]=l;if((g|0)<(H|0)){g=l}else{break}}}h[3835]=0.0;h[3836]=0.0;h[3837]=0.0;h[3838]=0.0;h[3839]=0.0;g=c[b>>2]|0;c[7654]=1;if((g|0)<1){ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0}else{U=0.0;O=0.0;P=0.0;Z=0.0;W=0.0;H=1;while(1){D=H+ -1|0;oa=W+ +h[t+(D<<3)>>3]*+h[u+(D<<3)>>3];h[3835]=oa;D=H+ -1|0;l=o+(D<<3)|0;p=r+(D<<3)|0;pa=Z+ +h[l>>3]*+h[p>>3];h[3836]=pa;y=t+(D<<3)|0;qa=P+ +h[y>>3]*+h[p>>3];h[3837]=qa;p=s+(D<<3)|0;ra=O+ +h[l>>3]*+h[p>>3];h[3838]=ra;sa=U+ +h[y>>3]*+h[p>>3];h[3839]=sa;if((H|0)<(g|0)){H=H+1|0;W=oa;Z=pa;P=qa;O=ra;U=sa}else{break}}c[7654]=g+1;ja=sa;ka=qa;la=pa;ma=ra;na=oa}U=+h[3846];O=U*na;h[3835]=O;P=U*ma-O;h[3838]=P;Z=O+la+P;h[3859]=Z;h[3861]=Z;h[3860]=Z;c[7708]=0;a[30656]=1;W=+h[3858]/50.0;h[3847]=W;c[7654]=1;H=0;Q=Z;S=Z;p=1;while(1){ta=+(p|0)*W;ua=+X(+ta);va=+Y(+ta);wa=O+ua*(la+ua*P)+va*(ka+ua*ja);if(!(wa>=0.0)){xa=-wa}else{xa=wa}if(!(Q>=0.0)){ya=-Q}else{ya=Q}do{if(xa>ya){h[3861]=wa;c[7708]=p;h[3856]=S;za=p;Aa=wa}else{if((p|0)!=(H+1|0)){za=H;Aa=Q;break}h[3857]=wa;za=H;Aa=Q}}while(0);e=p+1|0;if((e|0)<50){H=za;Q=Aa;p=e;S=wa}else{break}}h[3850]=ta;h[3841]=ua;h[3844]=va;h[3843]=wa;c[7654]=50;h[3860]=wa;if((za|0)==49){h[3857]=Z;Ba=Z}else if((za|0)==0){h[3856]=wa;ga=74}else{ga=74}if((ga|0)==74){ga=0;Ba=+h[3857]}h[3848]=0.0;S=+h[3856];if(S!=Ba){Q=S-Aa;h[3856]=Q;S=Ba-Aa;h[3857]=S;T=U*(Q-S)/(Q+S);h[3848]=T;Ca=T}else{Ca=0.0}T=W*(+(za|0)+Ca);h[3850]=T;S=+X(+T);h[3841]=S;Q=+Y(+T);h[3844]=Q;T=O+S*(la+S*P)+Q*(ka+S*ja);h[3843]=T;p=c[b>>2]|0;c[7654]=1;if((p|0)<1){Da=T}else{T=Q;Q=S;H=1;g=0;while(1){e=o+(g<<3)|0;h[e>>3]=Q*+h[e>>3]+T*+h[t+(g<<3)>>3];e=H+ -1|0;y=s+(e<<3)|0;S=+h[3841]*+h[y>>3]+ +h[3844]*+h[u+(e<<3)>>3];h[y>>3]=S;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+S;if((H|0)>=(p|0)){break}e=H;T=+h[3844];Q=+h[3841];H=H+1|0;g=e}c[7654]=p+1;Da=+h[3843]}if(!(Da>=0.0)){Ea=-Da}else{Ea=Da}Q=+h[3859];if(!(Q>=0.0)){Fa=-Q}else{Fa=Q}if(Ea<=Fa*1.1){ga=88;break}if((n|0)<(c[b>>2]|0)){_=n}else{ga=88;break}}if((ga|0)==88){i=v;return 0}return 0}function dp(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;n=i;a[31112]=1;a[31104]=1;c[31124>>2]=6;FG(31120)|0;e=c[d>>2]|0;c[7774]=1;if((e|0)>=1){d=1;do{WF(31240,b+(d+ -1)|0,1)|0;o=c[7774]|0;d=o+1|0;c[7774]=d;}while((o|0)<(e|0))}nG()|0;e=c[g>>2]|0;if((e|0)==1){c[31148>>2]=a[31104]&1?6:0;FG(31144)|0;WF(31240,h,4)|0;nG()|0;p=c[g>>2]|0}else{p=e}if((p|0)==2){c[31172>>2]=a[31104]&1?6:0;FG(31168)|0;WF(31240,h,4)|0;WF(31240,j,4)|0;nG()|0}j=c[k>>2]|0;if((j|0)==1){c[31196>>2]=a[31104]&1?6:0;FG(31192)|0;WF(31240,l,8)|0;nG()|0;q=c[k>>2]|0}else{q=j}if((q|0)==2){c[31220>>2]=a[31104]&1?6:0;FG(31216)|0;WF(31240,l,8)|0;WF(31240,m,8)|0;nG()|0}if((c[f>>2]|0)==2){EF(31248,0)|0}else{i=n;return 0}return 0}function ep(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0;y=i;i=i+8|0;z=y;A=c[k>>2]|0;a:do{if((A|0)==0){c[7816]=2;B=2;while(1){C=B+1|0;if(!((c[k+(B+ -1<<2)>>2]|0)>>>0<2)){D=210;break a}c[7816]=C;if((C|0)<12){B=C}else{break}}if((c[d>>2]|0)<1){LF(31320,33016,80,25);B=31624;C=31632;dp(31320,33048,31800,B,31704,d,B,B,C,C,80)|0;break}c[7880]=5;C=q+8|0;do{if((c[k+32>>2]|0)==0){E=5}else{B=c[C>>2]|0;c[7880]=B;if(!((B+ -1|0)>>>0>4)){E=B;break}LF(31320,33056,80,34);B=31624;F=31632;dp(31320,33096,31792,B,31704,31520,B,B,F,F,80)|0;break a}}while(0);c[C>>2]=E;b:do{if((c[k+20>>2]|0)==0){F=c[d>>2]|0;B=fa(F,F)|0;c[7866]=B;c[7878]=B+50+(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0);B=q+12|0;if((c[k+16>>2]|0)==0){c[B>>2]=2;break}else{c[B>>2]=1;break}}else{B=c[q>>2]|0;do{if((B|0)>=0){F=c[d>>2]|0;if((B|0)>=(F|0)){break}G=q+4|0;H=c[G>>2]|0;if(!((H|0)>-1&(H|0)<(F|0))){LF(31320,33880,80,52);I=31624;J=31632;dp(31320,33864,33936,I,31704,G,I,I,J,J,80)|0;break a}c[7866]=fa((B<<1|1)+H|0,F)|0;F=q+12|0;if((c[k+16>>2]|0)==0){c[F>>2]=5;H=c[d>>2]|0;J=fa((c[C>>2]|0)+4|0,H)|0;c[7878]=(((H|0)/((c[q>>2]|0)+1+(c[G>>2]|0)|0)|0)<<1)+52+(c[7866]|0)+J;break b}else{c[F>>2]=4;F=(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0)+50|0;c[7878]=F+(c[7866]|0);break b}}}while(0);LF(31320,33808,80,52);B=31624;F=31632;dp(31320,33864,33872,B,31704,q,B,B,F,F,80)|0;break a}}while(0);c[7870]=(c[d>>2]|0)+20;c[q+64>>2]=c[7866];if((c[p>>2]|0)<(c[7878]|0)){LF(31320,33104,80,60);C=31624;F=31632;dp(31320,33168,33176,C,31800,31512,p,C,F,F,80)|0;break}if((c[r>>2]|0)<(c[7870]|0)){LF(31320,33184,80,60);F=31624;C=31632;dp(31320,33168,33248,F,31800,31480,r,F,C,C,80)|0;break}if(+h[j>>3]==+h[e>>3]){D=227;break}if((c[w>>2]|0)<0){LF(31320,33992,80,24);C=31704;F=31624;B=31632;dp(31320,34024,34032,C,C,w,F,F,B,B,80)|0;break}do{if((c[k+24>>2]|0)!=0){K=+h[o+8>>3];h[3930]=K;if(!(K<=0.0)){break}LF(31320,33488,80,28);B=31624;dp(31320,32200,33520,B,B,B,B,31704,31440,31632,80)|0;break a}}while(0);c[q+60>>2]=0;B=q+36|0;c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[B+12>>2]=0;c[n>>2]=1;D=27}else if((A|0)==-1){LF(31320,31552,80,49);B=31624;F=31632;dp(31320,31608,31616,B,B,B,B,B,F,F,80)|0;LF(31320,31640,80,47);F=31624;B=31632;dp(31320,31688,31696,F,31704,n,F,F,B,B,80)|0;LF(31320,31712,80,41);B=31624;F=31632;dp(31320,31760,31768,31704,B,B,B,B,F,F,80)|0;i=y;return 0}else if((A|0)==1){c[q+36>>2]=c[q+40>>2];D=27}else{D=210}}while(0);c:do{if((D|0)==27){a[31496]=0;K=+h[l>>3];h[3941]=K;L=+h[m>>3];h[3934]=L;A=c[d>>2]|0;c[7816]=1;do{if((A|0)>=1){r=k+4|0;p=0;E=1;M=L;N=K;while(1){if((c[r>>2]|0)==1){F=E+ -1|0;O=+h[l+(F<<3)>>3];h[3941]=O;P=+h[m+(F<<3)>>3];h[3934]=P;Q=O;R=P}else{Q=N;R=M}if(Q>0.0|R>0.0){a[31496]=1;S=1}else{S=p}if(Q<0.0){D=215;break}if(R<0.0){D=216;break}F=E+1|0;c[7816]=F;if((E|0)<(A|0)){p=S;E=F;M=R;N=Q}else{D=36;break}}if((D|0)==36){if(!S){break}E=c[d>>2]|0;p=E+51|0;c[7826]=p;r=p+(c[w>>2]|0)|0;c[7828]=r;p=r+(c[w>>2]|0)|0;c[7850]=p;F=p+(c[w>>2]|0)|0;c[7820]=F;B=F+(c[d>>2]|0)|0;c[7856]=B;C=B+(c[d>>2]|0)|0;c[7862]=C;c[7852]=(fa((c[q+8>>2]|0)+1|0,c[d>>2]|0)|0)+C;c[7876]=(c[q+64>>2]|0)+1;d:do{if((c[k>>2]|0)==1){B=o+64|0;h[3943]=+h[B>>3];a[31432]=0;h[3912]=+h[o+24>>3];J=o+16|0;h[3907]=+h[J>>3];do{if((c[w>>2]|0)!=0){fp(31800,v,w,d,31296,j,f,o+(F+ -1<<3)|0,o+(C+ -1<<3)|0,o+224|0,q+28|0,o+(E+50<<3)|0,o+(r+ -1<<3)|0,o+(p+ -1<<3)|0,x,31416,B,0,o,q,s,t)|0;if((c[7946]|0)>0){i=y;return 0}if((c[7854]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];G=31704;Cp(d,o+((c[7820]|0)+ -1<<3)|0,G,g,G)|0;a[31432]=1;D=197;break d}}while(0);do{if((c[k+24>>2]|0)!=0){N=+h[3907];if(!(N>=0.0)){T=-N}else{T=N}M=T/+h[o+8>>3];if(!(M>1.0)){break}h[3907]=N/M}}while(0);M=+h[e>>3];N=+h[j>>3];if(M==N){D=227;break c}P=+h[3907];if((M-N)*P>0.0){D=220;break}B=(c[k+8>>2]|0)==1;do{if((c[k+12>>2]|0)==1){O=+h[o>>3];h[3942]=O;U=+h[3912];V=U-O;G=V*P>0.0;do{if(B){if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U- +h[e>>3])<=0.0){break}H=q+28|0;I=o+((c[7862]|0)+ -1<<3)|0;X=o+224|0;if(P*(U-W)>0.0){kp(31296,j,f,g,d,H,I,X)|0;if((c[7946]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[31432]=1;D=197;break d}}else{Y=31296;kp(Y,Y,f,g,d,H,I,X)|0;if((c[7946]|0)>0){i=y;return 0}else{h[e>>3]=+h[3912];c[n>>2]=1;a[31432]=1;D=197;break d}}}else{if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U-W)<0.0){break}kp(31296,j,f,g,d,q+28|0,o+((c[7862]|0)+ -1<<3)|0,o+224|0)|0;if((c[7946]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[31432]=1;D=197;break d}}}while(0);h[z>>3]=V;if(!(V>=0.0)){Z=-V}else{Z=V}if(!(U>=0.0)){_=-U}else{_=U}if(!(P>=0.0)){$=-P}else{$=P}if(Z>+h[3943]*100.0*(_+$)){if(P*(U+P-O)<=0.0){break}W=O-U;h[3907]=W;h[J>>3]=W;break}kp(31296,31536,f,g,d,q+28|0,o+((c[7862]|0)+ -1<<3)|0,o+224|0)|0;if((c[7946]|0)>0){i=y;return 0}else{c[n>>2]=2;h[e>>3]=+h[3942];a[31432]=1;D=197;break d}}else{W=+h[3912];if(!B){if(P*(W-N)<0.0){break}kp(31296,j,f,g,d,q+28|0,o+((c[7862]|0)+ -1<<3)|0,o+224|0)|0;if((c[7946]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[31432]=1;D=197;break d}}if(P*(W-M)<=0.0){break}G=q+28|0;X=o+((c[7862]|0)+ -1<<3)|0;I=o+224|0;if(P*(W-N)>0.0){kp(31296,j,f,g,d,G,X,I)|0;if((c[7946]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[31432]=1;D=197;break d}}else{H=31296;kp(H,H,f,g,d,G,X,I)|0;if((c[7946]|0)>0){i=y;return 0}else{h[e>>3]=+h[3912];c[n>>2]=1;a[31432]=1;D=197;break d}}}}while(0);if(a[31432]&1){D=197}else{D=128}}else{h[3912]=+h[e>>3];c[n>>2]=1;hp(d,k+4|0,l,m,f,o+((c[7856]|0)+ -1<<3)|0,s,t)|0;B=c[d>>2]|0;c[7816]=1;e:do{if((B|0)>=1){J=c[7856]|0;I=1;while(1){X=I+1|0;if(+h[o+(I+ -2+J<<3)>>3]<=0.0){break}c[7816]=X;if((I|0)<(B|0)){I=X}else{break e}}LF(31320,33624,80,39);I=31624;J=31632;dp(31320,33296,33664,I,I,I,I,I,J,J,80)|0;break c}}while(0);U=+op(31776,1);h[3943]=U;B=o+64|0;h[B>>3]=U;U=+h[e>>3];if(!(U>=0.0)){aa=-U}else{aa=U}h[z>>3]=aa;U=+h[j>>3];if(!(U>=0.0)){ba=-U}else{ba=U}U=+h[3943]*4.0*(aa>=ba?aa:ba);h[3932]=U;O=+h[j>>3]- +h[e>>3];h[z>>3]=O;if(!(O>=0.0)){ca=-O}else{ca=O}if(ca<U){LF(31320,33672,80,60);J=31624;dp(31320,33168,33736,J,J,J,J,31800,j,e,80)|0;break c}do{if((c[k+28>>2]|0)==0){h[3911]=ca*.001;U=+ip(d,g,o+((c[7856]|0)+ -1<<3)|0,s,t);if(U>.5/+h[3911]){h[3911]=.5/U}h[z>>3]=+h[j>>3]- +h[e>>3];U=+IF(31288,z);h[3911]=U;da=U}else{U=+h[o+16>>3];h[3911]=U;if(U*(+h[j>>3]- +h[e>>3])<0.0){D=220;break d}if(!(U==0.0)){da=U;break}LF(31320,33576,80,29);J=31624;I=31632;dp(31320,33608,33616,J,J,J,J,J,I,I,80)|0;break c}}while(0);do{if((c[k+24>>2]|0)==0){ea=da}else{if(!(da>=0.0)){ga=-da}else{ga=da}U=ga/+h[o+8>>3];if(!(U>1.0)){ea=da;break}O=da/U;h[3911]=O;ea=O}}while(0);if((c[k+12>>2]|0)==0){ha=ea}else{O=+h[o>>3];h[3942]=O;U=+h[e>>3];V=O-U;if(V*ea<0.0){D=224;break}if(ea*(U+ea-O)>0.0){h[3911]=V;ia=V}else{ia=ea}if((O- +h[j>>3])*ia<0.0){D=218;break}else{ha=ia}}I=k+40|0;if((c[I>>2]|0)==0){ja=ha}else{jp(31296,f,g,d,b,u,31288,o+((c[7856]|0)+ -1<<3)|0,n,s,t,o+((c[7862]|0)+ -1<<3)|0,o+400|0,o+((c[7820]|0)+ -1<<3)|0,o+((c[7852]|0)+ -1<<3)|0,q,31456,B,k+36|0,31504)|0;if((c[7946]|0)>0){i=y;return 0}J=c[n>>2]|0;if((J|0)<0){ka=J;D=129;break}ja=+h[3911]}h[3907]=ja;h[o+16>>3]=ja;J=c[7862]|0;X=(c[d>>2]|0)+J|0;c[7872]=X;G=c[d>>2]|0;c[7816]=1;if((G|0)>=1){H=1;while(1){h[o+(H+ -2+J<<3)>>3]=+h[f+(H+ -1<<3)>>3];h[o+(H+ -2+X<<3)>>3]=+h[3907]*+h[g+(H+ -1<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[7816]=G+1}H=o+320|0;h[H>>3]=+h[e>>3];X=q+68|0;c[X>>2]=0;J=o+224|0;h[J>>3]=+h[3907];h[o+232>>3]=+h[3907]*2.0;Y=q+28|0;c[Y>>2]=1;if((c[w>>2]|0)==0){D=128;break}fp(31704,v,w,d,e,j,f,o+((c[7820]|0)+ -1<<3)|0,o+((c[7862]|0)+ -1<<3)|0,J,Y,o+((c[7826]|0)+ -1<<3)|0,o+((c[7828]|0)+ -1<<3)|0,o+((c[7850]|0)+ -1<<3)|0,x,31416,B,0,o,q,s,t)|0;if((c[7946]|0)>0){i=y;return 0}if((c[7854]|0)!=0){LF(31320,34040,80,47);la=31624;ma=31632;dp(31320,31688,34088,31704,la,la,la,la,ma,ma,80)|0;LF(31320,34096,80,38);ma=31624;la=31632;dp(31320,31848,34088,31704,ma,ma,ma,ma,la,la,80)|0;break c}if((c[w>>2]|0)==0){D=128;break}if((c[I>>2]|0)==0){D=128;break}fp(31792,v,w,d,31296,j,f,o+((c[7820]|0)+ -1<<3)|0,o+((c[7862]|0)+ -1<<3)|0,J,Y,o+((c[7826]|0)+ -1<<3)|0,o+((c[7828]|0)+ -1<<3)|0,o+((c[7850]|0)+ -1<<3)|0,x,31416,B,0,o,q,s,t)|0;if((c[7946]|0)>0){i=y;return 0}if((c[7854]|0)!=1){D=128;break}c[X>>2]=1;c[n>>2]=4;h[e>>3]=+h[H>>3];H=31704;Cp(d,o+((c[7820]|0)+ -1<<3)|0,H,g,H)|0;D=197}}while(0);if((D|0)==218){LF(31320,33416,80,54);p=31624;dp(31320,33472,33480,p,p,p,p,31800,31536,j,80)|0;break c}else if((D|0)==220){LF(31320,33528,80,34);p=31624;dp(31320,33096,33568,p,p,p,p,31800,j,e,80)|0;break c}else if((D|0)==224){LF(31320,33744,80,49);p=31624;dp(31320,31608,33800,p,p,p,p,31800,31536,e,80)|0;break c}f:while(1){if((D|0)==128){D=0;ka=c[n>>2]|0;D=129;continue}else if((D|0)==129){D=0;if((ka|0)==-12){na=-12;break}if(((c[q+40>>2]|0)-(c[q+36>>2]|0)|0)>=500){D=131;break}oa=k+4|0;hp(d,oa,l,m,o+((c[7862]|0)+ -1<<3)|0,o+((c[7856]|0)+ -1<<3)|0,s,t)|0;if((c[7946]|0)>0){D=233;break}p=c[d>>2]|0;c[7816]=1;r=c[7856]|0;if((p|0)>=1){E=1;while(1){C=E+1|0;if(!(+h[o+(E+ -2+r<<3)>>3]>0.0)){D=136;break f}c[7816]=C;if((E|0)<(p|0)){E=C}else{break}}}O=+ip(d,o+((c[7862]|0)+ -1<<3)|0,o+(r+ -1<<3)|0,s,t)*100.0;V=+h[3943];pa=O*V;h[3909]=pa;if(!(pa<=1.0)){D=138;break}O=+h[3912];if(!(O>=0.0)){qa=-O}else{qa=O}h[z>>3]=qa;O=+h[j>>3];if(!(O>=0.0)){ra=-O}else{ra=O}h[3932]=V*4.0*(qa>=ra?qa:ra);do{if((c[k+24>>2]|0)!=0){V=+h[3907];if(!(V>=0.0)){sa=-V}else{sa=V}O=sa/+h[o+8>>3];if(!(O>1.0)){break}h[3907]=V/O}}while(0);lp(31296,f,g,d,b,u,31256,o+((c[7856]|0)+ -1<<3)|0,k,n,s,t,o+((c[7862]|0)+ -1<<3)|0,o+400|0,o+((c[7820]|0)+ -1<<3)|0,o+((c[7852]|0)+ -1<<3)|0,q,o+80|0,o+128|0,o+176|0,o+224|0,o+272|0,o+32|0,o+40|0,o+48|0,o+56|0,31456,o+64|0,q+20|0,q+16|0,q+24|0,q+28|0,q+32|0,k+36|0,31504)|0;if((c[7946]|0)>0){D=233;break}r=c[n>>2]|0;if((r|0)<0){na=r;break}do{if((c[w>>2]|0)!=0){fp(31792,v,w,d,31296,j,f,o+((c[7820]|0)+ -1<<3)|0,o+((c[7862]|0)+ -1<<3)|0,o+224|0,q+28|0,o+((c[7826]|0)+ -1<<3)|0,o+((c[7828]|0)+ -1<<3)|0,o+((c[7850]|0)+ -1<<3)|0,x,31416,o+64|0,0,o,q,s,t)|0;if((c[7946]|0)>0){D=233;break f}if((c[7854]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];r=31704;Cp(d,o+((c[7820]|0)+ -1<<3)|0,r,g,r)|0;D=197;continue f}}while(0);r=(c[k+8>>2]|0)!=0;O=+h[3912];V=+h[3907];U=(O- +h[j>>3])*V;if((c[k+12>>2]|0)==0){if(!r){if(U<0.0){D=128;continue}kp(31296,j,f,g,d,q+28|0,o+((c[7862]|0)+ -1<<3)|0,o+224|0)|0;if((c[7946]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(!(U>=0.0)){h[e>>3]=O;c[n>>2]=1;D=197;continue}kp(31296,j,f,g,d,q+28|0,o+((c[7862]|0)+ -1<<3)|0,o+224|0)|0;if((c[7946]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(r){if(U>=0.0){kp(31296,j,f,g,d,q+28|0,o+((c[7862]|0)+ -1<<3)|0,o+224|0)|0;if((c[7946]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}N=O- +h[3942];h[z>>3]=N;if(!(N>=0.0)){ta=-N}else{ta=N}if(!(O>=0.0)){ua=-O}else{ua=O}if(!(V>=0.0)){va=-V}else{va=V}if(!(ta<=+h[3943]*100.0*(ua+va))){h[e>>3]=O;c[n>>2]=1;D=197;continue}kp(31296,31536,f,g,d,q+28|0,o+((c[7862]|0)+ -1<<3)|0,o+224|0)|0;if((c[7946]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[3942];D=197;continue}if(!(U<0.0)){kp(31296,j,f,g,d,q+28|0,o+((c[7862]|0)+ -1<<3)|0,o+224|0)|0;if((c[7946]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}U=+h[3942];N=O-U;h[z>>3]=N;if(!(N>=0.0)){wa=-N}else{wa=N}if(!(O>=0.0)){xa=-O}else{xa=O}if(!(V>=0.0)){ya=-V}else{ya=V}if(!(wa<=+h[3943]*100.0*(xa+ya))){if(V*(O+V-U)<=0.0){D=128;continue}h[3907]=U-O;D=128;continue}else{kp(31296,31536,f,g,d,q+28|0,o+((c[7862]|0)+ -1<<3)|0,o+224|0)|0;if((c[7946]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[3942];D=197;continue}}else if((D|0)==197){D=0;h[o+24>>3]=+h[3912];h[o+16>>3]=+h[3907];h[o+328>>3]=+h[e>>3];D=233;break}}do{if((D|0)==131){c[n>>2]=-1;na=-1}else if((D|0)==136){c[n>>2]=-3;na=-3}else if((D|0)==138){if((c[oa>>2]|0)!=1){h[l>>3]=pa*+h[l>>3];h[m>>3]=+h[3909]*+h[m>>3];c[n>>2]=-2;na=-2;break}r=c[d>>2]|0;c[7816]=1;if((r|0)>=1){O=pa;E=1;p=0;while(1){B=l+(p<<3)|0;h[B>>3]=O*+h[B>>3];B=m+(E+ -1<<3)|0;h[B>>3]=+h[3909]*+h[B>>3];if((E|0)>=(r|0)){break}B=E;O=+h[3909];E=E+1|0;p=B}c[7816]=r+1}c[n>>2]=-2;na=-2}else if((D|0)==233){i=y;return 0}}while(0);p=0-na|0;c[7872]=p;switch(p|0){case 6:{LF(31320,32216,80,44);p=31624;dp(31320,32264,32272,p,p,p,p,31800,31296,31256,80)|0;LF(31320,32280,80,57);p=31624;E=31632;dp(31320,32344,32352,p,p,p,p,p,E,E,80)|0;break};case 7:{LF(31320,32216,80,44);E=31624;dp(31320,32264,32360,E,E,E,E,31800,31296,31256,80)|0;LF(31320,32368,80,48);E=31624;p=31632;dp(31320,31920,32424,E,E,E,E,E,p,p,80)|0;LF(31320,32432,80,28);p=31624;E=31632;dp(31320,32200,32464,p,p,p,p,p,E,E,80)|0;break};case 8:{LF(31320,32216,80,44);E=31624;dp(31320,32264,32472,E,E,E,E,31800,31296,31256,80)|0;LF(31320,32480,80,37);E=31624;p=31632;dp(31320,32520,32528,E,E,E,E,E,p,p,80)|0;break};case 9:{LF(31320,32216,80,44);p=31624;dp(31320,32264,32536,p,p,p,p,31800,31296,31256,80)|0;LF(31320,32544,80,49);p=31624;E=31632;dp(31320,31608,32600,p,p,p,p,p,E,E,80)|0;LF(31320,32608,80,38);E=31624;p=31632;dp(31320,31848,32648,E,E,E,E,E,p,p,80)|0;break};case 10:{LF(31320,32216,80,44);p=31624;dp(31320,32264,32656,p,p,p,p,31800,31296,31256,80)|0;LF(31320,32664,80,45);p=31624;E=31632;dp(31320,32104,32712,p,p,p,p,p,E,E,80)|0;LF(31320,32720,80,36);E=31624;p=31632;dp(31320,32760,32768,E,E,E,E,E,p,p,80)|0;break};case 2:{LF(31320,31936,80,47);p=31624;dp(31320,31688,31984,p,p,p,p,31704,31296,31632,80)|0;LF(31320,31992,80,48);p=31624;E=31632;dp(31320,31920,32048,p,p,p,p,p,E,E,80)|0;LF(31320,32056,80,45);E=31624;p=31632;dp(31320,32104,32112,E,E,E,E,E,p,p,80)|0;break};case 3:{LF(31320,32120,80,38);p=31624;dp(31320,31848,32160,p,p,p,p,31704,31296,31632,80)|0;LF(31320,32168,80,28);p=31624;E=31632;dp(31320,32200,32208,p,p,p,p,p,E,E,80)|0;break};case 11:{LF(31320,32776,80,40);E=31624;dp(31320,32824,32832,E,E,E,E,31800,31296,31256,80)|0;LF(31320,32840,80,36);E=31624;p=31632;dp(31320,32760,32880,E,E,E,E,E,p,p,80)|0;break};case 12:{LF(31320,32216,80,44);p=31624;dp(31320,32264,32888,p,p,p,p,31800,31296,31288,80)|0;LF(31320,32896,80,45);p=31624;E=31632;dp(31320,32104,32944,p,p,p,p,p,E,E,80)|0;break};case 5:case 4:{break};default:{LF(31320,31808,80,38);E=31624;dp(31320,31848,31856,E,E,E,E,31704,31296,31632,80)|0;LF(31320,31864,80,48);E=31624;p=31632;dp(31320,31920,31928,E,E,E,E,E,p,p,80)|0}}c[k>>2]=-1;h[e>>3]=+h[3912];h[o+24>>3]=+h[3912];h[o+16>>3]=+h[3907];i=y;return 0}else if((D|0)==215){LF(31320,33256,80,39);p=31624;E=31632;dp(31320,33296,33304,p,p,p,p,p,E,E,80)|0;break c}else if((D|0)==216){LF(31320,33312,80,39);E=31624;p=31632;dp(31320,33296,33352,E,E,E,E,E,p,p,80)|0;break c}}}while(0);LF(31320,33360,80,47);A=31624;p=31632;dp(31320,31688,33408,A,A,A,A,A,p,p,80)|0}else if((D|0)==210){LF(31320,32952,80,55);p=31624;A=31632;dp(31320,33008,31704,p,p,p,p,p,A,A,80)|0}}while(0);if((D|0)==227){LF(31320,33944,80,39);D=31624;dp(31320,33296,33984,D,D,D,D,31800,j,e,80)|0}if((c[k>>2]|0)==-1){LF(31320,34136,80,46);e=31624;j=31632;dp(31320,34184,34192,e,e,e,e,e,j,j,80)|0;LF(31320,34200,80,47);j=31624;e=31632;dp(31320,31688,34248,31704,j,j,j,j,e,e,80)|0;i=y;return 0}else{c[k>>2]=-1;c[n>>2]=-33;i=y;return 0}return 0}function fp(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;var A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0;v=i;A=c[f>>2]|0;B=~A;C=+h[n>>3];h[4282]=C;c[t>>2]=0;D=c[e>>2]|0;c[8566]=1;if((D|0)>=1){E=1;do{c[s+(E+ -1<<2)>>2]=0;F=c[8566]|0;E=F+1|0;c[8566]=E;}while((F|0)<(D|0))}G=+h[g>>3];if(!(G>=0.0)){H=-G}else{H=G}if(!(C>=0.0)){I=-C}else{I=C}h[4289]=(H+I)*+h[u>>3]*100.0;u=c[b>>2]|0;do{if((u|0)==2){do{if((c[x+68>>2]|0)!=0){b=w+320|0;kp(g,b,k,l,f,o,m,n)|0;if((c[7946]|0)>0){i=v;return 0}D=d;Ud[D&7](f,b,k,e,p,y,z)|0;if((c[7946]|0)>0){i=v;return 0}E=x+60|0;c[E>>2]=(c[E>>2]|0)+1;a[34320]=0;F=c[e>>2]|0;c[8566]=1;if((F|0)<1){break}else{J=0;K=1}while(1){I=+h[p+(K+ -1<<3)>>3];if(!(I>=0.0)){L=-I}else{L=I}if(!(L<=0.0)){M=J}else{a[34320]=1;M=1}if((K|0)<(F|0)){J=M;K=K+1|0}else{break}}c[8566]=F+1;if(!M){break}I=+IF(34312,34256);h[4286]=I;H=I+ +h[b>>3];h[b>>3]=H;I=+h[4282];do{if((H- +h[g>>3])*I<0.0){kp(g,b,k,l,f,o,m,n)|0;if((c[7946]|0)<=0){break}i=v;return 0}else{G=+h[4286]/I;h[4287]=G;N=c[f>>2]|0;c[8566]=1;if((N|0)<1){break}O=(A<<1)+B|0;P=G;Q=1;while(1){R=k+(Q+ -1<<3)|0;h[R>>3]=+h[R>>3]+P*+h[m+(O+Q<<3)>>3];if((Q|0)>=(N|0)){break}P=+h[4287];Q=Q+1|0}c[8566]=N+1}}while(0);Ud[D&7](f,b,k,e,p,y,z)|0;if((c[7946]|0)>0){i=v;return 0}c[E>>2]=(c[E>>2]|0)+1;a[34320]=0;F=c[e>>2]|0;c[8566]=1;if((F|0)<1){break}else{S=0;T=1}while(1){Q=T+ -1|0;I=+h[p+(Q<<3)>>3];if(!(I>=0.0)){U=-I}else{U=I}if(U>0.0){V=S;W=T}else{c[s+(Q<<2)>>2]=1;a[34320]=1;V=1;W=c[8566]|0}Q=W+1|0;c[8566]=Q;if((W|0)<(F|0)){S=V;T=Q}else{break}}if(!V){break}c[t>>2]=1;i=v;return 0}}while(0);I=+h[g>>3];if(I==+h[w+328>>3]){i=v;return 0}else{X=+h[4282];Y=I;break}}else if((u|0)==3){X=C;Y=+h[g>>3]}else{F=w+320|0;kp(g,F,k,l,f,o,m,n)|0;if((c[7946]|0)>0){i=v;return 0}E=d;Ud[E&7](f,F,k,e,p,y,z)|0;if((c[7946]|0)>0){i=v;return 0}b=x+60|0;c[b>>2]=1;a[34320]=0;D=c[e>>2]|0;c[8566]=1;if((D|0)<1){i=v;return 0}else{Z=0;_=1}while(1){I=+h[p+(_+ -1<<3)>>3];if(!(I>=0.0)){$=-I}else{$=I}if(!($<=0.0)){aa=Z}else{a[34320]=1;aa=1}if((_|0)<(D|0)){Z=aa;_=_+1|0}else{break}}c[8566]=D+1;if(!aa){i=v;return 0}I=+IF(34312,34256);h[4286]=I;h[F>>3]=I+ +h[F>>3];I=+h[4286]/+h[4282];h[4287]=I;Q=c[f>>2]|0;c[8566]=1;if((Q|0)>=1){O=(A<<1)+B|0;H=I;R=1;while(1){ba=k+(R+ -1<<3)|0;h[ba>>3]=+h[ba>>3]+H*+h[m+(O+R<<3)>>3];if((R|0)>=(Q|0)){break}H=+h[4287];R=R+1|0}c[8566]=Q+1}Ud[E&7](f,F,k,e,p,y,z)|0;if((c[7946]|0)>0){i=v;return 0}c[b>>2]=(c[b>>2]|0)+1;a[34320]=0;R=c[e>>2]|0;c[8566]=1;if((R|0)<1){i=v;return 0}else{ca=0;da=1}while(1){H=+h[p+(da+ -1<<3)>>3];if(!(H>=0.0)){ea=-H}else{ea=H}if(!(ea<=0.0)){fa=ca}else{a[34320]=1;fa=1}if((da|0)<(R|0)){ca=fa;da=da+1|0}else{break}}c[8566]=R+1;if(!fa){i=v;return 0}c[t>>2]=-1;i=v;return 0}}while(0);ea=+h[j>>3];do{if(!((ea-Y)*X>=0.0)){h[4285]=ea;if((ea- +h[w+320>>3])*X<=0.0){i=v;return 0}kp(g,34280,k,l,f,o,m,n)|0;if((c[7946]|0)<=0){break}i=v;return 0}else{h[4285]=Y;j=c[f>>2]|0;c[8566]=1;if((j|0)<1){break}else{ga=1}while(1){fa=ga+ -1|0;h[k+(fa<<3)>>3]=+h[m+(fa<<3)>>3];if((ga|0)<(j|0)){ga=ga+1|0}else{break}}c[8566]=j+1}}while(0);ga=d;Ud[ga&7](f,34280,k,e,q,y,z)|0;if((c[7946]|0)>0){i=v;return 0}d=x+60|0;c[d>>2]=(c[d>>2]|0)+1;c[8576]=0;R=w+320|0;fa=x+76|0;da=x+72|0;x=w+336|0;ca=w+344|0;while(1){gp(e,34312,34304,R,34280,p,q,r,34272,s,fa,da,x,ca)|0;if((c[7946]|0)>0){ha=76;break}if((c[8576]|0)>1){ha=73;break}kp(g,34272,k,l,f,o,m,n)|0;if((c[7946]|0)>0){ha=76;break}Ud[ga&7](f,34272,k,e,r,y,z)|0;if((c[7946]|0)>0){ha=76;break}c[d>>2]=(c[d>>2]|0)+1}if((ha|0)==73){h[R>>3]=+h[4284];R=31704;Cp(e,r,R,p,R)|0;if((c[8576]|0)==4){i=v;return 0}kp(g,34272,k,l,f,o,m,n)|0;if((c[7946]|0)>0){i=v;return 0}c[t>>2]=1;i=v;return 0}else if((ha|0)==76){i=v;return 0}return 0}function gp(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;s=i;do{if((c[e>>2]|0)==1){c[8592]=c[o>>2];c[o>>2]=0;h[4292]=0.0;a[34352]=0;t=c[b>>2]|0;c[8582]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;w=+h[l+(v<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}do{if(x>0.0){w=+IF(34384,j+(v<<3)|0);if(w==+IF(34384,l+((c[8582]|0)+ -1<<3)|0)){break}y=c[8582]|0;z=y+ -1|0;w=+h[l+(z<<3)>>3];A=w/(w- +h[j+(z<<3)>>3]);if(!(A>=0.0)){B=-A}else{B=A}if(B<=+h[4292]){break}h[4292]=B;c[o>>2]=y}else{a[34352]=1}}while(0);v=c[8582]|0;u=v+1|0;c[8582]=u;}while((v|0)<(t|0))}do{if((c[o>>2]|0)>0){a[34360]=1;c[8594]=c[p>>2];h[g>>3]=+h[r>>3];t=31704;Cp(b,l,t,k,t)|0;c[p>>2]=1;a[34344]=0;C=0}else{a[34360]=0;c[o>>2]=c[8592];c[8594]=c[p>>2];if(a[34352]&1){h[g>>3]=+h[r>>3];t=31704;Cp(b,l,t,k,t)|0;a[34344]=1;C=1;break}else{t=31704;Cp(b,l,t,j,t)|0;h[f>>3]=+h[r>>3];c[p>>2]=0;a[34344]=0;C=0;break}}}while(0);A=+h[g>>3];w=A- +h[f>>3];if(!(w>=0.0)){D=-w}else{D=w}if(!(D<=+h[d>>3])){if(!C){break}E=+h[g>>3]}else{a[34344]=1;E=A}c[e>>2]=2;h[m>>3]=E;t=31704;Cp(b,k,t,l,t)|0;t=c[b>>2]|0;c[8582]=1;if((t|0)<1){i=s;return 0}else{F=1}do{c[n+(F+ -1<<2)>>2]=0;u=(c[8582]|0)+ -1|0;A=+h[k+(u<<3)>>3];if(!(A>=0.0)){G=-A}else{G=A}do{if(G>0.0){A=+IF(34384,j+(u<<3)|0);if(!(A!=+IF(34384,k+((c[8582]|0)+ -1<<3)|0))){break}c[n+((c[8582]|0)+ -1<<2)>>2]=1}else{c[n+(u<<2)>>2]=1}}while(0);u=c[8582]|0;F=u+1|0;c[8582]=F;}while((u|0)<(t|0));i=s;return 0}else{c[o>>2]=0;h[4292]=0.0;a[34352]=0;t=c[b>>2]|0;c[8582]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;A=+h[k+(v<<3)>>3];if(!(A>=0.0)){H=-A}else{H=A}do{if(H>0.0){A=+IF(34384,j+(v<<3)|0);if(A==+IF(34384,k+((c[8582]|0)+ -1<<3)|0)){break}y=c[8582]|0;z=y+ -1|0;A=+h[k+(z<<3)>>3];w=A/(A- +h[j+(z<<3)>>3]);if(!(w>=0.0)){I=-w}else{I=w}if(I<=+h[4292]){break}h[4292]=I;c[o>>2]=y}else{a[34352]=1}}while(0);v=c[8582]|0;u=v+1|0;c[8582]=u;}while((v|0)<(t|0))}t=(c[o>>2]|0)>0;a[34360]=t&1;if(t){a[34344]=0;c[8594]=0;c[p>>2]=1;break}if(!(a[34352]&1)){t=31704;Cp(b,k,t,l,t)|0;h[m>>3]=+h[g>>3];c[e>>2]=4;i=s;return 0}h[m>>3]=+h[g>>3];t=31704;Cp(b,k,t,l,t)|0;t=c[b>>2]|0;c[8582]=1;if((t|0)>=1){u=1;do{c[n+(u+ -1<<2)>>2]=0;v=c[8582]|0;y=v+ -1|0;w=+h[k+(y<<3)>>3];if(!(w>=0.0)){J=-w}else{J=w}if(!(J<=0.0)){K=v}else{c[n+(y<<2)>>2]=1;K=c[8582]|0}u=K+1|0;c[8582]=u;}while((K|0)<(t|0))}c[e>>2]=3;i=s;return 0}}while(0);K=c[8594]|0;do{if((K|0)==(c[p>>2]|0)){J=+h[q>>3];if((K|0)==0){I=J*2.0;h[q>>3]=I;L=I;break}else{I=J*.5;h[q>>3]=I;L=I;break}}else{h[q>>3]=1.0;L=1.0}}while(0);I=+h[g>>3];q=(c[o>>2]|0)+ -1|0;J=+h[k+(q<<3)>>3];H=I-(I- +h[f>>3])*J/(J-L*+h[j+(q<<3)>>3]);h[r>>3]=H;L=+h[f>>3];J=H-L;if(!(J>=0.0)){M=-J}else{M=J}J=+h[d>>3];do{if(M<J){I=+h[g>>3]-L;if(!(I>=0.0)){N=-I}else{N=I}if(!(N>J*10.0)){O=H;break}G=L+I*.1;h[r>>3]=G;O=G}else{O=H}}while(0);c[e>>2]=1;h[m>>3]=O;i=s;return 0}function hp(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0.0,o=0.0,p=0.0;k=i;h[4301]=+h[d>>3];h[4300]=+h[e>>3];j=c[a>>2]|0;c[8598]=1;if((j|0)<1){i=k;return 0}else{l=1}while(1){if((c[b>>2]|0)==0){m=l+ -1|0;n=+h[4301]}else{a=l+ -1|0;o=+h[d+(a<<3)>>3];h[4301]=o;h[4300]=+h[e+(a<<3)>>3];m=a;n=o}o=+h[f+(m<<3)>>3];if(!(o>=0.0)){p=-o}else{p=o}h[g+(m<<3)>>3]=n*p+ +h[4300];a=l+1|0;c[8598]=a;if((l|0)<(j|0)){l=a}else{break}}i=k;return 0}function ip(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;f=i;h[4304]=0.0;e=c[a>>2]|0;c[8604]=1;if((e|0)<1){g=0.0;i=f;return+g}else{j=0.0;k=1}while(1){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){n=-m}else{n=m}if(n>j){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){o=-m}else{o=m}h[4304]=o;p=o}else{p=j}if((k|0)<(e|0)){j=p;k=k+1|0}else{break}}c[8604]=e+1;if(p<=0.0){g=0.0;i=f;return+g}h[4303]=0.0;e=c[a>>2]|0;c[8604]=1;if((e|0)<1){q=0.0}else{j=0.0;k=1;while(1){l=k+ -1|0;o=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3]/p;r=j+o*o;h[4303]=r;if((k|0)<(e|0)){k=k+1|0;j=r}else{break}}c[8604]=e+1;q=r}g=p*+V(+(q/+(c[a>>2]|0)));i=f;return+g}function jp(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;y=i;i=i+16|0;z=y;A=y+8|0;B=c[f>>2]|0;c[m>>2]=1;c[8622]=0;c[8620]=0;c[8626]=0;h[4316]=+h[b>>3];h[4318]=+ip(f,d,l,0,0);C=c[f>>2]|0;c[8610]=1;D=(B<<1)+~B|0;if((C|0)>=1){B=1;while(1){E=B+ -1|0;h[p+(E<<3)>>3]=+h[d+(E<<3)>>3];h[p+(D+B<<3)>>3]=+h[e+(B+ -1<<3)>>3];if((B|0)<(C|0)){B=B+1|0}else{break}}c[8610]=C+1}C=t+44|0;B=g;E=t+48|0;F=+h[k>>3];a:while(1){h[4309]=1.0/F;h[b>>3]=+h[k>>3]+ +h[b>>3];G=c[f>>2]|0;c[8610]=1;if((G|0)>=1){H=1;while(1){I=H+ -1|0;J=d+(I<<3)|0;h[J>>3]=+h[J>>3]+ +h[k>>3]*+h[e+(I<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[8610]=G+1}a[34536]=1;c[8612]=0;a[34552]=1;c[C>>2]=(c[C>>2]|0)+1;c[8630]=0;Ud[B&7](b,d,e,q,34520,n,o)|0;b:do{if((c[8630]|0)<0){K=35}else{while(1){if(a[34536]&1){c[E>>2]=(c[E>>2]|0)+1;a[34536]=0;mp(f,b,d,e,q,34472,k,34496,l,r,s,t,g,34520,v,j,n,o,x)|0;h[4308]=1.0e6;if((c[8630]|0)<0|(c[8624]|0)!=0){K=35;break b}c[8626]=0}H=c[f>>2]|0;c[8610]=1;if((H|0)>=1){I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]*.75;if((I|0)<(H|0)){I=I+1|0}else{break}}c[8610]=H+1}np(f,q,s,t)|0;I=c[f>>2]|0;c[8610]=1;if((I|0)>=1){J=1;while(1){L=J+ -1|0;M=d+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[q+(L<<3)>>3];L=J+ -1|0;M=e+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[4309]*+h[q+(L<<3)>>3];if((J|0)<(I|0)){J=J+1|0}else{break}}c[8610]=I+1}N=+ip(f,q,l,0,0);h[4320]=N;if(N<=+h[v>>3]*100.0*+h[4318]){break}J=c[8612]|0;if((J|0)>0){h[z>>3]=N/+h[4321];h[A>>3]=1.0/+(J|0);O=+GF(z,A);if(O>.9){K=35;break b}P=O/(1.0-O);h[4308]=P;Q=+h[4320];R=P}else{h[4321]=N;Q=N;R=+h[4308]}if(R*Q<=.33){break}J=c[8612]|0;H=J+1|0;c[8612]=H;if((J|0)>8){K=35;break b}if(((H|0)%5|0|0)==0){a[34536]=1}c[C>>2]=(c[C>>2]|0)+1;c[8630]=0;Ud[B&7](b,d,e,q,34520,n,o)|0;if((c[8630]|0)<0){K=35;break b}}do{if((c[w>>2]|0)!=0){H=c[f>>2]|0;c[8610]=1;if((H|0)>=1){J=1;while(1){S=+h[d+(J+ -1<<3)>>3];h[q+(J+ -1<<3)>>3]=S<=0.0?S:0.0;if((J|0)<(H|0)){J=J+1|0}else{break}}h[z>>3]=S;c[8610]=H+1}N=+ip(f,q,l,0,0);h[4320]=N;if(N>.33){K=35;break b}J=c[f>>2]|0;c[8610]=1;if((J|0)<1){break}else{T=1}while(1){I=T+ -1|0;L=d+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[q+(I<<3)>>3];I=T+ -1|0;L=e+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[4309]*+h[q+(I<<3)>>3];if((T|0)<(J|0)){T=T+1|0}else{break}}c[8610]=J+1}}while(0);if(!(a[34552]&1)){break}H=c[f>>2]|0;c[8610]=1;if((H|0)>=1){I=1;while(1){L=I+ -1|0;h[r+(L<<3)>>3]=+h[d+(L<<3)>>3]- +h[p+(L<<3)>>3];if((I|0)<(H|0)){I=I+1|0}else{break}}c[8610]=H+1}N=+ip(f,r,l,0,0);h[4314]=N;if(N<=1.0){K=63;break a}}}while(0);if((K|0)==35){K=0;a[34552]=0}h[b>>3]=+h[4316];G=c[f>>2]|0;c[8610]=1;if((G|0)>=1){I=1;while(1){L=I+ -1|0;h[d+(L<<3)>>3]=+h[p+(L<<3)>>3];h[e+(I+ -1<<3)>>3]=+h[p+(D+I<<3)>>3];if((I|0)<(G|0)){I=I+1|0}else{break}}c[8610]=G+1}if(a[34552]&1){I=(c[8622]|0)+1|0;c[8622]=I;N=.9/(+h[4314]*2.0+1.0e-4);h[z>>3]=.1;P=N>=.5?.5:N;h[A>>3]=P;N=P<=.1?.1:P;h[4307]=N;P=+h[k>>3]*N;h[k>>3]=P;if(!(P>=0.0)){U=-P}else{U=P}if(U>=+h[u>>3]&(I|0)<10){F=P;continue}else{K=62;break}}if((c[8624]|0)!=0){I=(c[8626]|0)+1|0;c[8626]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=3){K=51;break}if(!(P>=0.0)){V=-P}else{V=P}if(!(V>=+h[u>>3])){K=51;break}else{F=P;continue}}if(!((c[8630]|0)>-2)){K=53;break}I=(c[8620]|0)+1|0;c[8620]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=10){K=58;break}if(!(P>=0.0)){W=-P}else{W=P}if(!(W>=+h[u>>3])){K=58;break}else{F=P}}if((K|0)==51){c[m>>2]=-12;i=y;return 0}else if((K|0)==53){c[m>>2]=-12;i=y;return 0}else if((K|0)==58){c[m>>2]=-12;i=y;return 0}else if((K|0)==62){c[m>>2]=-12;i=y;return 0}else if((K|0)==63){i=y;return 0}return 0}function kp(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;l=i;m=c[f>>2]|0;n=~m;o=(c[g>>2]|0)+1|0;c[8656]=o;p=+h[b>>3]- +h[a>>3];h[4326]=p;a=c[f>>2]|0;c[8648]=1;if((a|0)<1){q=p}else{b=1;while(1){g=b+ -1|0;h[d+(g<<3)>>3]=+h[j+(g<<3)>>3];h[e+(b+ -1<<3)>>3]=0.0;if((b|0)<(a|0)){b=b+1|0}else{break}}c[8648]=a+1;q=+h[4326]}h[4322]=1.0;h[4323]=0.0;p=q/+h[k>>3];h[4327]=p;c[8650]=2;if((o|0)<2){i=l;return 0}else{r=q;s=1.0;t=p;u=0.0;v=2}while(1){a=k+(v+ -2<<3)|0;h[4323]=u*t+s/+h[a>>3];p=t*s;h[4322]=p;h[4327]=(r+ +h[a>>3])/+h[k+(v+ -1<<3)>>3];a=c[f>>2]|0;c[8648]=1;if((a|0)>=1){b=fa(v,m)|0;q=p;g=1;while(1){w=d+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+q*+h[j+(g+n+b<<3)>>3];w=e+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+ +h[4323]*+h[j+(g+n+b<<3)>>3];if((g|0)>=(a|0)){break}q=+h[4322];g=g+1|0}c[8648]=a+1}g=v+1|0;c[8650]=g;if((v|0)>=(o|0)){break}r=+h[4326];s=+h[4322];t=+h[4327];u=+h[4323];v=g}i=l;return 0}function lp(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;F=F|0;G=G|0;H=H|0;I=I|0;J=J|0;K=K|0;L=L|0;M=M|0;var N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0;N=i;i=i+16|0;O=N;P=N+8|0;Q=c[f>>2]|0;R=~Q;c[n>>2]=1;h[4349]=+h[b>>3];c[8676]=0;c[8684]=0;c[8678]=0;S=u+52|0;if((c[m>>2]|0)==0){c[S>>2]=0;T=u+56|0;c[T>>2]=0;c[I>>2]=1;c[J>>2]=0;h[C>>3]=0.0;c[m>>2]=1;h[y>>3]=+h[k>>3];U=1.0/+h[k>>3];h[B>>3]=U;h[A>>3]=U;h[D>>3]=100.0;c[H>>2]=-1;h[4361]=1.0;c[G>>2]=0;c[K>>2]=0;V=T}else{V=u+56|0}T=u+44|0;m=g;W=u+48|0;while(1){c[8672]=(c[I>>2]|0)+1;c[8674]=(c[I>>2]|0)+2;c[8670]=(c[I>>2]|0)+ -1;h[4349]=+h[b>>3];do{if(+h[k>>3]!=+h[C>>3]){X=8}else{Y=c[I>>2]|0;if((Y|0)!=(c[J>>2]|0)){X=8;break}Z=(c[K>>2]|0)+1|0;_=Y}}while(0);if((X|0)==8){X=0;c[K>>2]=0;Z=1;_=c[J>>2]|0}Y=_+2|0;$=(Z|0)<=(Y|0)?Z:Y;c[K>>2]=$;c[8688]=$+1;$=c[8672]|0;if(($|0)>=(c[K>>2]|0)){h[w>>3]=1.0;h[v>>3]=1.0;h[4352]=+h[k>>3];h[x>>3]=0.0;h[z>>3]=1.0;c[8658]=2;if(($|0)>=2){Y=2;while(1){h[4353]=+h[y+(Y+ -2<<3)>>3];U=+h[4352];aa=Y+ -2|0;h[y+(aa<<3)>>3]=U;ba=Y+ -1|0;h[w+(ba<<3)>>3]=+h[w+(aa<<3)>>3]*U/+h[4353];U=+h[4353]+ +h[k>>3];h[4352]=U;ca=+h[k>>3]/U;h[v+(ba<<3)>>3]=ca;h[z+(ba<<3)>>3]=ca*+h[z+(aa<<3)>>3]*+(ba|0);h[x+(ba<<3)>>3]=+h[x+(aa<<3)>>3]+ +h[v+(aa<<3)>>3]/+h[k>>3];if((Y|0)<($|0)){Y=Y+1|0}else{break}}c[8658]=$+1}h[y+($+ -1<<3)>>3]=+h[4352]}h[4359]=0.0;h[4357]=0.0;Y=c[I>>2]|0;c[8658]=1;if((Y|0)<1){da=0.0}else{ca=0.0;U=0.0;aa=1;while(1){ea=U-1.0/+(aa|0);h[4359]=ea;ga=ca- +h[v+(aa+ -1<<3)>>3];h[4357]=ga;if((aa|0)<(Y|0)){aa=aa+1|0;U=ea;ca=ga}else{break}}c[8658]=Y+1;da=ea}h[4360]=+h[A>>3];h[A>>3]=-da/+h[k>>3];aa=v+($+ -1<<3)|0;ca=+h[aa>>3]+ +h[4359]- +h[4357];h[O>>3]=ca;if(!(ca>=0.0)){ha=-ca}else{ha=ca}h[4334]=ha;h[O>>3]=ha;ca=+h[aa>>3];h[P>>3]=ca;h[4334]=ha>=ca?ha:ca;h[4352]=.6;h[4353]=1.6666666666666667;ca=+h[A>>3];U=ca/+h[B>>3];if(U<.6|U>1.6666666666666667){c[H>>2]=-1}if(ca!=+h[4360]){h[D>>3]=100.0}aa=c[8672]|0;ba=c[8688]|0;if((aa|0)>=(ba|0)){c[8660]=ba;ia=ba;while(1){ba=c[f>>2]|0;c[8658]=1;if((ba|0)>=1){ja=1;while(1){ka=q+(ja+R+(fa(ia,Q)|0)<<3)|0;h[ka>>3]=+h[w+(ia+ -1<<3)>>3]*+h[ka>>3];if((ja|0)<(ba|0)){ja=ja+1|0}else{break}}c[8658]=ba+1}ja=ia+1|0;c[8660]=ja;if((ia|0)<(aa|0)){ia=ja}else{break}}}h[b>>3]=+h[k>>3]+ +h[b>>3];a:while(1){ia=c[f>>2]|0;c[8658]=1;if((ia|0)>=1){aa=1;while(1){$=aa+ -1|0;h[d+($<<3)>>3]=+h[q+($<<3)>>3];h[e+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ia|0)){aa=aa+1|0}else{break}}c[8658]=ia+1}aa=c[8672]|0;c[8660]=2;if((aa|0)>=2){ba=2;while(1){$=c[f>>2]|0;c[8658]=1;if(($|0)>=1){Y=x+(ba+ -1<<3)|0;ja=fa(ba,Q)|0;ka=ja+R|0;la=1;while(1){ma=d+(la+ -1<<3)|0;h[ma>>3]=+h[q+(la+R+ja<<3)>>3]+ +h[ma>>3];ma=e+(la+ -1<<3)|0;h[ma>>3]=+h[ma>>3]+ +h[Y>>3]*+h[q+(ka+la<<3)>>3];if((la|0)<($|0)){la=la+1|0}else{break}}c[8658]=$+1}la=ba+1|0;c[8660]=la;if((ba|0)<(aa|0)){ba=la}else{break}}}h[4356]=+ip(f,d,l,0,0);a[34896]=1;c[8662]=0;c[T>>2]=(c[T>>2]|0)+1;c[8692]=0;Ud[m&7](b,d,e,r,34768,o,p)|0;if((c[8692]|0)<0){X=70;break}if((c[H>>2]|0)==-1){c[W>>2]=(c[W>>2]|0)+1;c[H>>2]=0;mp(f,b,d,e,r,A,k,34720,l,s,t,u,g,34768,F,j,o,p,M)|0;h[B>>3]=+h[A>>3];h[D>>3]=100.0;if((c[8692]|0)<0|(c[8680]|0)!=0){X=70;break}c[8684]=0}ba=c[f>>2]|0;c[8658]=1;if((ba|0)>=1){aa=1;while(1){h[s+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[8658]=ba+1}while(1){ca=2.0/(+h[A>>3]/+h[B>>3]+1.0);h[4352]=ca;aa=c[f>>2]|0;c[8658]=1;if((aa|0)>=1){U=ca;ia=1;la=0;while(1){ka=r+(la<<3)|0;h[ka>>3]=U*+h[ka>>3];if((ia|0)>=(aa|0)){break}ka=ia;U=+h[4352];ia=ia+1|0;la=ka}c[8658]=aa+1}np(f,r,t,u)|0;la=c[f>>2]|0;c[8658]=1;if((la|0)>=1){ia=1;while(1){$=ia+ -1|0;ka=d+($<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+($<<3)>>3];$=ia+ -1|0;ka=r+($<<3)|0;Y=s+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[ka>>3];Y=e+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[A>>3]*+h[ka>>3];if((ia|0)<(la|0)){ia=ia+1|0}else{break}}c[8658]=la+1}U=+ip(f,r,l,0,0);h[4361]=U;if(U<=+h[F>>3]*100.0*+h[4356]){X=63;break a}ia=c[8662]|0;if((ia|0)>0){h[O>>3]=U/+h[4363];h[P>>3]=1.0/+(ia|0);ca=+GF(O,P);if(ca>.9){break}ga=ca/(1.0-ca);h[D>>3]=ga;na=+h[4361];oa=ga}else{h[4363]=U;na=U;oa=+h[D>>3]}if(oa*na<=.33){X=63;break a}ia=c[8662]|0;c[8662]=ia+1;if((ia|0)>2){break}c[T>>2]=(c[T>>2]|0)+1;c[8692]=0;Ud[m&7](b,d,e,r,34768,o,p)|0;if((c[8692]|0)<0){X=70;break a}}if((c[H>>2]|0)==0){X=70;break}c[H>>2]=-1}do{if((X|0)==63){X=0;if((c[L>>2]|0)==0){break}ba=c[f>>2]|0;c[8658]=1;if((ba|0)>=1){ia=1;while(1){pa=+h[d+(ia+ -1<<3)>>3];h[r+(ia+ -1<<3)>>3]=pa<=0.0?pa:0.0;if((ia|0)<(ba|0)){ia=ia+1|0}else{break}}h[O>>3]=pa;c[8658]=ba+1}U=+ip(f,r,l,0,0);h[4361]=U;if(U>.33){X=70;break}ia=c[f>>2]|0;c[8658]=1;if((ia|0)<1){break}else{qa=1}while(1){aa=qa+ -1|0;ka=s+(aa<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+(aa<<3)>>3];if((qa|0)<(ia|0)){qa=qa+1|0}else{break}}c[8658]=ia+1}}while(0);if((X|0)==70){X=0;a[34896]=0}c[H>>2]=1;if(a[34896]&1){U=+ip(f,s,l,0,0);h[4355]=U;ba=c[I>>2]|0;ga=U*+h[z+(ba<<3)>>3];h[4341]=ga;h[4348]=ga*+(ba+1|0);h[4343]=ga;c[8694]=ba;do{if((c[I>>2]|0)!=1){ba=c[f>>2]|0;c[8658]=1;if((ba|0)>=1){aa=fa(c[8672]|0,Q)|0;ka=1;while(1){Y=ka+ -1|0;h[r+(Y<<3)>>3]=+h[q+(ka+R+aa<<3)>>3]+ +h[s+(Y<<3)>>3];if((ka|0)<(ba|0)){ka=ka+1|0}else{break}}c[8658]=ba+1}ga=+h[z+((c[I>>2]|0)+ -1<<3)>>3];U=ga*+ip(f,r,l,0,0);h[4350]=U;ka=c[I>>2]|0;ga=U*+(ka|0);h[4358]=ga;if((ka|0)>2){aa=c[f>>2]|0;c[8658]=1;ia=c[I>>2]|0;if((aa|0)<1){ra=ia}else{Y=ia;ia=1;while(1){ca=+h[q+(ia+R+(fa(Y,Q)|0)<<3)>>3];$=r+(ia+ -1<<3)|0;h[$>>3]=ca+ +h[$>>3];$=ia+1|0;c[8658]=$;ja=c[I>>2]|0;if((ia|0)<(aa|0)){ia=$;Y=ja}else{ra=ja;break}}}ca=+h[z+(ra+ -2<<3)>>3];sa=ca*+ip(f,r,l,0,0);Y=c[I>>2]|0;ca=sa*+(Y+ -1|0);sa=+h[4358];if((sa>=ca?sa:ca)>+h[4348]){break}ta=+h[4350];ua=Y}else{if(!(ga<=+h[4348]*.5)){break}else{ta=U;ua=ka}}c[8694]=ua+ -1;h[4343]=ta}}while(0);if(!(+h[4334]*+h[4355]>1.0)){X=86;break}}c[G>>2]=1;h[b>>3]=+h[4349];Y=c[8672]|0;ia=c[8688]|0;if((Y|0)>=(ia|0)){c[8660]=ia;aa=ia;while(1){ca=1.0/+h[w+(aa+ -1<<3)>>3];h[4352]=ca;ia=c[f>>2]|0;c[8658]=1;if((ia|0)>=1){ba=fa(aa,Q)|0;sa=ca;ja=1;while(1){$=q+(ja+R+ba<<3)|0;h[$>>3]=sa*+h[$>>3];if((ja|0)>=(ia|0)){break}sa=+h[4352];ja=ja+1|0}c[8658]=ia+1}ja=aa+1|0;c[8660]=ja;if((aa|0)<(Y|0)){aa=ja}else{break}}}c[8658]=2;if((Y|0)>=2){aa=2;while(1){h[y+(aa+ -2<<3)>>3]=+h[y+(aa+ -1<<3)>>3]- +h[k>>3];if((aa|0)<(Y|0)){aa=aa+1|0}else{break}}c[8658]=Y+1}if(!(a[34896]&1)){c[V>>2]=(c[V>>2]|0)+1;if((c[8680]|0)!=0){aa=(c[8684]|0)+1|0;c[8684]=aa;h[4332]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=3){X=144;break}if(!(sa>=0.0)){va=-sa}else{va=sa}if(!(va>=+h[E>>3])){X=144;break}else{continue}}if(!((c[8692]|0)>-2)){X=146;break}aa=(c[8676]|0)+1|0;c[8676]=aa;h[4332]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=10){X=151;break}if(!(sa>=0.0)){wa=-sa}else{wa=sa}if(!(wa>=+h[E>>3])){X=151;break}else{continue}}c[8678]=(c[8678]|0)+1;c[S>>2]=(c[S>>2]|0)+1;aa=c[8678]|0;if((aa|0)<=1){ja=c[8694]|0;c[I>>2]=ja;sa=+(ja+1|0);h[4353]=sa;h[O>>3]=+h[4343]*2.0+1.0e-4;h[P>>3]=-1.0/sa;sa=+GF(O,P)*.9;h[O>>3]=.25;U=sa>=.9?.9:sa;h[P>>3]=U;sa=U<=.25?.25:U;h[4332]=sa;U=+h[k>>3]*sa;h[k>>3]=U;if(!(U>=0.0)){xa=-U}else{xa=U}if(!(xa>=+h[E>>3])){X=156;break}else{continue}}if((aa|0)>2){c[I>>2]=1;U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){ya=-U}else{ya=U}if(!(ya>=+h[E>>3])){X=165;break}else{continue}}else{c[I>>2]=c[8694];U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){za=-U}else{za=U}if(!(za>=+h[E>>3])){X=161;break}else{continue}}}if((X|0)==86){c[n>>2]=1;E=u+40|0;c[E>>2]=(c[E>>2]|0)+1;c[8708]=(c[I>>2]|0)-(c[J>>2]|0);c[J>>2]=c[I>>2];h[C>>3]=+h[k>>3];C=c[8694]|0;E=c[8670]|0;do{if((C|0)==(E|0)){X=88}else{S=u+8|0;if((c[I>>2]|0)==(c[S>>2]|0)){X=88;break}if((c[G>>2]|0)!=0){Aa=E;Ba=C;X=90;break}c[I>>2]=c[8672];za=+h[k>>3]*2.0;h[4345]=za;Ca=S;Da=za}}while(0);if((X|0)==88){c[G>>2]=1;Aa=c[8670]|0;Ba=c[8694]|0;X=90}if((X|0)==90){do{if((Ba|0)==(Aa|0)){Ea=Aa;X=104}else{G=c[I>>2]|0;C=u+8|0;if((G|0)==(c[C>>2]|0)){Fa=G;break}if((c[8672]|0)>=(c[K>>2]|0)|(c[8708]|0)==1){Fa=G;break}G=c[f>>2]|0;c[8658]=1;if((G|0)>=1){E=fa(c[8674]|0,Q)|0;S=1;while(1){V=S+ -1|0;h[r+(V<<3)>>3]=+h[s+(V<<3)>>3]- +h[q+(S+R+E<<3)>>3];if((S|0)<(G|0)){S=S+1|0}else{break}}c[8658]=G+1}za=1.0/+((c[I>>2]|0)+2|0);ya=za*+ip(f,r,l,0,0);h[4351]=ya;S=c[I>>2]|0;za=ya*+(S+2|0);if((S|0)>1){xa=+h[4348];E=xa<=za;if(+h[4358]<=(E?xa:za)){Ea=c[8670]|0;X=104;break}if(E){Fa=S;break}if((S|0)==(c[C>>2]|0)){Fa=S;break}}else{if(za>=+h[4348]*.5){Fa=S;break}}S=c[8672]|0;c[I>>2]=S;h[4343]=ya;Fa=S}}while(0);if((X|0)==104){c[I>>2]=Ea;h[4343]=+h[4350];Fa=Ea}h[4345]=+h[k>>3];ya=+(Fa+1|0);h[4353]=ya;h[O>>3]=+h[4343]*2.0+1.0e-4;h[P>>3]=-1.0/ya;ya=+GF(O,P);h[4332]=ya;do{if(ya<2.0){if(ya>1.0){Ga=+h[4345];break}else{h[O>>3]=.5;za=ya>=.9?.9:ya;h[P>>3]=za;xa=za<=.5?.5:za;h[4332]=xa;za=+h[k>>3]*xa;h[4345]=za;Ga=za;break}}else{za=+h[k>>3]*2.0;h[4345]=za;Ga=za}}while(0);Ca=u+8|0;Da=Ga}h[k>>3]=Da;do{if((c[J>>2]|0)!=(c[Ca>>2]|0)){k=c[f>>2]|0;c[8658]=1;if((k|0)<1){break}u=fa(c[8674]|0,Q)|0;P=1;while(1){h[q+(P+R+u<<3)>>3]=+h[s+(P+ -1<<3)>>3];if((P|0)<(k|0)){P=P+1|0}else{break}}c[8658]=k+1}}while(0);Ca=c[f>>2]|0;c[8658]=1;if((Ca|0)>=1){J=fa(c[8672]|0,Q)|0;P=1;while(1){u=q+(P+R+J<<3)|0;h[u>>3]=+h[s+(P+ -1<<3)>>3]+ +h[u>>3];if((P|0)<(Ca|0)){P=P+1|0}else{break}}c[8658]=Ca+1}Ca=c[8672]|0;c[8666]=2;if((Ca|0)<2){i=N;return 0}else{Ha=2}while(1){P=1-Ha+Ca|0;c[8660]=P;s=c[f>>2]|0;c[8658]=1;if((s|0)>=1){J=fa(P+1|0,Q)|0;u=fa(P,Q)|0;P=1;while(1){C=P+R|0;G=q+(C+u<<3)|0;h[G>>3]=+h[q+(C+J<<3)>>3]+ +h[G>>3];if((P|0)<(s|0)){P=P+1|0}else{break}}c[8658]=s+1}P=Ha+1|0;c[8666]=P;if((Ha|0)<(Ca|0)){Ha=P}else{break}}i=N;return 0}else if((X|0)==144){c[n>>2]=-8}else if((X|0)==146){c[n>>2]=-11}else if((X|0)==151){c[n>>2]=-7;Ha=(c[8692]>>31&-3)+ -7|0;c[n>>2]=Ha;c[n>>2]=(c[8678]|0)>2?-9:Ha}else if((X|0)==156){c[n>>2]=-6}else if((X|0)==161){c[n>>2]=-6}else if((X|0)==165){c[n>>2]=-6}kp(b,b,d,e,f,I,q,y)|0;i=N;return 0}



function Tg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+7|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+7|0]|0;k=Mq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+80>>3],+h[(c[b+416>>2]|0)+464>>3],a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=k;f=j;break}else{j=Mq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+80>>3],+h[(c[b+416>>2]|0)+464>>3],a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+7|0]|0;j=Pq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+80>>3],+h[(c[b+416>>2]|0)+464>>3])|0;a[(c[b+352>>2]|0)+7|0]=j;f=g;break}else{g=Pq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+80>>3],+h[(c[b+416>>2]|0)+464>>3])|0;a[(c[b+352>>2]|0)+7|0]=g;f=g;break}}}}while(0);do{if((a[e]|0)==0){l=a[(c[b+356>>2]|0)+8|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+8|0]|0;k=Mq(-+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+152>>3],+h[(c[b+416>>2]|0)+432>>3],a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=k;l=j;break}else{j=Mq(-+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+152>>3],+h[(c[b+416>>2]|0)+432>>3],a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=j;l=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+8|0]|0;j=Pq(-+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+152>>3],+h[(c[b+416>>2]|0)+432>>3])|0;a[(c[b+352>>2]|0)+8|0]=j;l=g;break}else{g=Pq(-+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+152>>3],+h[(c[b+416>>2]|0)+432>>3])|0;a[(c[b+352>>2]|0)+8|0]=g;l=g;break}}}}while(0);if((l|f)<<24>>24==0){m=0.0;n=b;o=n+4|0;p=o;q=c[p>>2]|0;r=c[q>>2]|0;s=r;t=s+8|0;u=t;v=c[u>>2]|0;w=v;x=w+88|0;y=x;h[y>>3]=m;i=d;return}m=+h[(c[b+416>>2]|0)+528>>3];n=b;o=n+4|0;p=o;q=c[p>>2]|0;r=c[q>>2]|0;s=r;t=s+8|0;u=t;v=c[u>>2]|0;w=v;x=w+88|0;y=x;h[y>>3]=m;i=d;return}function Ug(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=a+416|0;a=(Nq(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+200>>3],+h[(c[e>>2]|0)+488>>3]*.95)|0)<<24>>24==0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;do{if(a){if((Nq(+h[f+200>>3],+h[(c[e>>2]|0)+488>>3]*.95+.001)|0)<<24>>24==0){g=c[(c[c[d>>2]>>2]|0)+8>>2]|0;j=g;k=+h[g+152>>3]*-10.0;break}else{g=c[(c[c[d>>2]>>2]|0)+8>>2]|0;j=g;k=(+h[(c[e>>2]|0)+488>>3]*.95- +h[g+200>>3])*+h[g+152>>3]*1.0e4;break}}else{j=f;k=0.0}}while(0);h[j+96>>3]=k+ +h[j+88>>3];i=b;return}function Vg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0,t=0.0;d=i;do{if((a[b+314|0]|0)==0){e=a[(c[b+356>>2]|0)+6|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){g=a[(c[b+356>>2]|0)+6|0]|0;j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=Mq(+h[j+96>>3]- +h[j>>3],0.0,a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=k;e=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=Mq(+h[g+96>>3]- +h[g>>3],0.0,a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=k;e=k;break}}else{if(f){f=a[(c[b+356>>2]|0)+6|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=Pq(+h[k+96>>3]- +h[k>>3],0.0)|0;a[(c[b+352>>2]|0)+6|0]=g;e=f;break}else{f=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=Pq(+h[f+96>>3]- +h[f>>3],0.0)|0;a[(c[b+352>>2]|0)+6|0]=g;e=g;break}}}}while(0);g=e<<24>>24!=0;e=c[b+416>>2]|0;if(g){l=+h[e+496>>3]*1.87}else{l=+h[e+504>>3]*.638}f=b+4|0;k=c[c[f>>2]>>2]|0;j=c[k+8>>2]|0;m=+h[j+96>>3]- +h[j>>3];if(l!=0.0){if(g){n=+h[e+496>>3]*1.87}else{n=+h[e+504>>3]*.638}o=j;p=m/n;q=o;r=q+24|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){o=j;p=m;q=o;r=q+24|0;s=r;h[s>>3]=p;i=d;return}if(g){t=+h[e+496>>3]*1.87}else{t=+h[e+504>>3]*.638}n=m/+Xn(c[b+536>>2]|0,t,5360,5352,+h[k>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[f>>2]>>2]|0)+8>>2]|0;p=n;q=o;r=q+24|0;s=r;h[s>>3]=p;i=d;return}function Wg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+4|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+4|0]|0;k=Mq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],+h[(c[b+416>>2]|0)+328>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=k;f=j;break}else{j=Mq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],+h[(c[b+416>>2]|0)+328>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+4|0]|0;j=Pq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],+h[(c[b+416>>2]|0)+328>>3])|0;a[(c[b+352>>2]|0)+4|0]=j;f=g;break}else{g=Pq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],+h[(c[b+416>>2]|0)+328>>3])|0;a[(c[b+352>>2]|0)+4|0]=g;f=g;break}}}}while(0);do{if((a[e]|0)==0){l=a[(c[b+356>>2]|0)+5|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+5|0]|0;k=Mq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+152>>3],+h[(c[b+416>>2]|0)+296>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=k;l=j;break}else{j=Mq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+152>>3],+h[(c[b+416>>2]|0)+296>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=j;l=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+5|0]|0;j=Pq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+152>>3],+h[(c[b+416>>2]|0)+296>>3])|0;a[(c[b+352>>2]|0)+5|0]=j;l=g;break}else{g=Pq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+152>>3],+h[(c[b+416>>2]|0)+296>>3])|0;a[(c[b+352>>2]|0)+5|0]=g;l=g;break}}}}while(0);if((l|f)<<24>>24==0){m=0.0;n=b;o=n+4|0;p=o;q=c[p>>2]|0;r=c[q>>2]|0;s=r;t=s+8|0;u=t;v=c[u>>2]|0;w=v;x=w+136|0;y=x;h[y>>3]=m;i=d;return}m=+h[(c[b+416>>2]|0)+392>>3];n=b;o=n+4|0;p=o;q=c[p>>2]|0;r=c[q>>2]|0;s=r;t=s+8|0;u=t;v=c[u>>2]|0;w=v;x=w+136|0;y=x;h[y>>3]=m;i=d;return}function Xg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+288>>3]=+h[b+152>>3]- +h[b+280>>3];i=i;return}function Yg(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[c[b+416>>2]>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+288>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+40|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+40|0;p=o;h[p>>3]=m;i=d;return}q=k/+Xn(c[b+536>>2]|0,e,5528,5520,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+40|0;p=o;h[p>>3]=m;i=d;return}function Zg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+112>>3]=+h[b+72>>3]*+h[b+152>>3]+ +h[b+200>>3]*+h[b+192>>3];i=i;return}function _g(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;d=a+4|0;e=a+416|0;a=(Nq(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+232>>3],+h[(c[e>>2]|0)+352>>3]*.95)|0)<<24>>24==0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;do{if(a){g=(Nq(+h[f+232>>3],+h[(c[e>>2]|0)+352>>3]*.95+.001)|0)<<24>>24==0;j=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(g){k=j;l=+h[j+152>>3]*10.0;break}else{k=j;l=+h[j+152>>3]*(+h[j+232>>3]+ +h[(c[e>>2]|0)+352>>3]*-.95)*1.0e4;break}}else{k=f;l=0.0}}while(0);h[k+144>>3]=l+ +h[k+136>>3];i=b;return}function $g(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0,t=0.0;d=i;do{if((a[b+314|0]|0)==0){e=a[(c[b+356>>2]|0)+3|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){g=a[(c[b+356>>2]|0)+3|0]|0;j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=Mq(+h[j+144>>3]- +h[j+8>>3],0.0,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=k;e=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=Mq(+h[g+144>>3]- +h[g+8>>3],0.0,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=k;e=k;break}}else{if(f){f=a[(c[b+356>>2]|0)+3|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=Pq(+h[k+144>>3]- +h[k+8>>3],0.0)|0;a[(c[b+352>>2]|0)+3|0]=g;e=f;break}else{f=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=Pq(+h[f+144>>3]- +h[f+8>>3],0.0)|0;a[(c[b+352>>2]|0)+3|0]=g;e=g;break}}}}while(0);g=e<<24>>24!=0;e=c[b+416>>2]|0;if(g){l=+h[e+360>>3]*1.87}else{l=+h[e+368>>3]*.638}f=b+4|0;k=c[c[f>>2]>>2]|0;j=c[k+8>>2]|0;m=+h[j+144>>3]- +h[j+8>>3];if(l!=0.0){if(g){n=+h[e+360>>3]*1.87}else{n=+h[e+368>>3]*.638}o=j;p=m/n;q=o;r=q+32|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){o=j;p=m;q=o;r=q+32|0;s=r;h[s>>3]=p;i=d;return}if(g){t=+h[e+360>>3]*1.87}else{t=+h[e+368>>3]*.638}n=m/+Xn(c[b+536>>2]|0,t,5544,5536,+h[k>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[f>>2]>>2]|0)+8>>2]|0;p=n;q=o;r=q+32|0;s=r;h[s>>3]=p;i=d;return}function ah(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+168>>3]=+h[b+128>>3]*+h[b+152>>3]+ +h[b+232>>3]*+h[b+160>>3];i=i;return}function bh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+120>>3]=-+h[b+128>>3]- +h[b+232>>3];i=i;return}function ch(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+248>>3]=+h[b+120>>3]+ +h[b+80>>3];i=i;return}function dh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+224>>3]=+h[b+240>>3]*+h[b+232>>3];i=i;return}function eh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+184>>3]=+h[b+208>>3]*+h[b+200>>3];i=i;return}function fh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+296>>3]=+h[b+16>>3]- +h[b+56>>3]- +h[b+248>>3];i=i;return}function gh(a){a=a|0;c[c[a+404>>2]>>2]=c[c[(c[c[a+4>>2]>>2]|0)+12>>2]>>2];i=i;return}function hh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0;d=i;if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+11|0]|0;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;o=n;p=o+2|0;q=p;a[q]=f;i=d;return}if((a[b+318|0]|0)==0){r=c[b+416>>2]|0;s=+h[r+616>>3];t=b+4|0;u=+h[c[c[t>>2]>>2]>>3];v=u- +h[r+632>>3];do{if(s!=0.0){w=v/s}else{if(v==0.0){w=v;break}w=v/+Xn(c[b+536>>2]|0,s,5704,5696,u,(a[b+319|0]|0)!=0|0)}}while(0);u=+(Rq(w,0,b)|0);r=Pq(u,+(c[c[b+404>>2]>>2]|0))|0;a[(c[b+352>>2]|0)+11|0]=r;e=t;f=r;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;o=n;p=o+2|0;q=p;a[q]=f;i=d;return}else{r=a[(c[b+356>>2]|0)+11|0]|0;t=c[b+416>>2]|0;u=+h[t+616>>3];x=b+4|0;w=+h[c[c[x>>2]>>2]>>3];s=w- +h[t+632>>3];do{if(u!=0.0){y=s/u}else{if(s==0.0){y=s;break}y=s/+Xn(c[b+536>>2]|0,u,5704,5696,w,(a[b+319|0]|0)!=0|0)}}while(0);w=+(Rq(y,0,b)|0);t=Pq(w,+(c[c[b+404>>2]>>2]|0))|0;a[(c[b+352>>2]|0)+11|0]=t;e=x;f=r;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;o=n;p=o+2|0;q=p;a[q]=f;i=d;return}}function ih(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+424>>3]=+h[b+280>>3];i=i;return}function jh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+288>>3]=+h[b+280>>3];i=i;return}function kh(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+320>>3]=0.0;i=i;return}function lh(b){b=b|0;var c=0,d=0;c=i;d=b+314|0;a[d]=1;ng(b);og(b);pg(b);qg(b);rg(b);sg(b);tg(b);ug(b);vg(b);wg(b);xg(b);yg(b);zg(b);Ag(b);Bg(b);Cg(b);Dg(b);Eg(b);Fg(b);Gg(b);Hg(b);Ig(b);Jg(b);Kg(b);Lg(b);Mg(b);Ng(b);Og(b);Pg(b);Qg(b);Rg(b);Sg(b);Tg(b);Ug(b);Vg(b);Wg(b);Xg(b);Yg(b);Zg(b);_g(b);$g(b);ah(b);bh(b);ch(b);dh(b);eh(b);fh(b);gh(b);hh(b);ih(b);jh(b);kh(b);a[d]=0;i=c;return 0}function mh(a){a=a|0;i=i;return}function nh(a){a=a|0;i=i;return 0}function oh(a){a=a|0;var b=0,d=0,e=0;a=i;i=i+8|0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;Rn(9,1,5744,e);if((c[21268>>2]|0)!=0){Yd[c[5446]&255](9)}Rn(9,1,5768,d);if((c[21268>>2]|0)!=0){Yd[c[5446]&255](9)}Rn(9,1,5792,b);if((c[21268>>2]|0)!=0){Yd[c[5446]&255](9)}Rn(9,1,5816,a);if((c[21268>>2]|0)==0){i=a;return 0}Yd[c[5446]&255](9);i=a;return 0}function ph(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+320>>3]=0.0;i=i;return}function qh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32>>3]=+h[b+16>>3];i=i;return}function rh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+304>>3]=+h[b+8>>3]*(+h[b+24>>3]*(+h[b+32>>3]- +h[b+16>>3])+1.0);i=i;return}function sh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+80>>3]=+h[b+56>>3];i=i;return}function th(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+88>>3]=+h[b+72>>3];i=i;return}function uh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+96>>3]=+h[b+64>>3];i=i;return}function vh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+104>>3]=+h[b+40>>3];i=i;return}function wh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+112>>3]=+h[b+48>>3];i=i;return}function xh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+288>>3]=+h[b+280>>3];i=i;return}function yh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+296>>3]=+h[b+120>>3];i=i;return}function zh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+304>>3]=+h[b+128>>3];i=i;return}function Ah(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+296>>3];j=+h[f+328>>3]*+h[f+320>>3];k=g*g;if(j!=0.0){l=f;m=k/j;n=l;o=n+408|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=f;m=k;n=l;o=n+408|0;p=o;h[p>>3]=m;i=d;return}g=k/+Xn(c[b+536>>2]|0,j,5848,5840,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);l=c[e>>2]|0;m=g;n=l;o=n+408|0;p=o;h[p>>3]=m;i=d;return}function Bh(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+336>>3];j=+h[f+320>>3]+-.7;do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+Xn(c[b+536>>2]|0,g,5912,5904,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+416>>3]=l;i=d;return}function Ch(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+424>>3]=+h[b+280>>3];i=i;return}function Dh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+432>>3]=+h[b+120>>3];i=i;return}function Eh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+440>>3]=+h[b+128>>3];i=i;return}function Fh(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+432>>3];j=+h[f+464>>3]*+h[f+456>>3];k=g*g;if(j!=0.0){l=f;m=k/j;n=l;o=n+544|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=f;m=k;n=l;o=n+544|0;p=o;h[p>>3]=m;i=d;return}g=k/+Xn(c[b+536>>2]|0,j,5952,5944,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);l=c[e>>2]|0;m=g;n=l;o=n+544|0;p=o;h[p>>3]=m;i=d;return}function Gh(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+472>>3];j=+h[f+456>>3]+-.7;do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+Xn(c[b+536>>2]|0,g,6016,6008,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+552>>3]=l;i=d;return}function Hh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+600>>3]=+h[b+576>>3];i=i;return}function Ih(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+608>>3]=+h[b+584>>3];i=i;return}function Jh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+616>>3]=+h[b+592>>3];i=i;return}function Kh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+312>>3]=+h[b+616>>3]*+h[b+608>>3]*.01;i=i;return}function Lh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+624>>3]=+h[b+560>>3];i=i;return}function Mh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+632>>3]=+h[b+568>>3];i=i;return}function Nh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6048]&1){i=d;return}g=b+416|0;if(!((Qq(+h[(c[g>>2]|0)+616>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=ro(6064,oo(+h[(c[g>>2]|0)+616>>3],6056)|0)|0;g=c[17500]|0;j=e;k=6264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ue[g&15](e,b,f);a[6048]=1;i=d;return}function Oh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6288]&1){i=d;return}g=b+416|0;b=Qq(+h[(c[g>>2]|0)+608>>3],1.0e-60)|0;if(!(b<<24>>24==0|(Oq(+h[(c[g>>2]|0)+608>>3],100.0)|0)<<24>>24==0)){i=d;return}b=ro(6296,oo(+h[(c[g>>2]|0)+608>>3],6056)|0)|0;g=c[17500]|0;j=e;k=6464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ue[g&15](e,b,f);a[6288]=1;i=d;return}function Ph(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6488]&1){i=d;return}g=b+416|0;if(!((Qq(+h[(c[g>>2]|0)+592>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=ro(6496,oo(+h[(c[g>>2]|0)+592>>3],6056)|0)|0;g=c[17500]|0;j=e;k=6688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ue[g&15](e,b,f);a[6488]=1;i=d;return}function Qh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6712]&1){i=d;return}g=b+416|0;b=Qq(+h[(c[g>>2]|0)+584>>3],1.0e-60)|0;if(!(b<<24>>24==0|(Oq(+h[(c[g>>2]|0)+584>>3],100.0)|0)<<24>>24==0)){i=d;return}b=ro(6720,oo(+h[(c[g>>2]|0)+584>>3],6056)|0)|0;g=c[17500]|0;j=e;k=6848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ue[g&15](e,b,f);a[6712]=1;i=d;return}function Rh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6872]&1){i=d;return}g=b+416|0;if(!((Qq(+h[(c[g>>2]|0)+440>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ro(6880,oo(+h[(c[g>>2]|0)+440>>3],6056)|0)|0;g=c[17500]|0;j=e;k=7536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ue[g&15](e,b,f);a[6872]=1;i=d;return}function Sh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7088]&1){i=d;return}g=b+416|0;if(!((Qq(+h[(c[g>>2]|0)+432>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ro(7096,oo(+h[(c[g>>2]|0)+432>>3],6056)|0)|0;g=c[17500]|0;j=e;k=7680;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ue[g&15](e,b,f);a[7088]=1;i=d;return}function Th(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7208]&1){i=d;return}g=b+416|0;if(!((Qq(+h[(c[g>>2]|0)+424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ro(7216,oo(+h[(c[g>>2]|0)+424>>3],6056)|0)|0;g=c[17500]|0;j=e;k=9400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ue[g&15](e,b,f);a[7208]=1;i=d;return}function Uh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7416]&1){i=d;return}g=b+416|0;if(!((Qq(+h[(c[g>>2]|0)+304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ro(7424,oo(+h[(c[g>>2]|0)+304>>3],6056)|0)|0;g=c[17500]|0;j=e;k=7536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ue[g&15](e,b,f);a[7416]=1;i=d;return}function Vh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7560]&1){i=d;return}g=b+416|0;if(!((Qq(+h[(c[g>>2]|0)+296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ro(7568,oo(+h[(c[g>>2]|0)+296>>3],6056)|0)|0;g=c[17500]|0;j=e;k=7680;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ue[g&15](e,b,f);a[7560]=1;i=d;return}function Wh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7704]&1){i=d;return}g=b+416|0;if(!((Qq(+h[(c[g>>2]|0)+288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ro(7712,oo(+h[(c[g>>2]|0)+288>>3],6056)|0)|0;g=c[17500]|0;j=e;k=9400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ue[g&15](e,b,f);a[7704]=1;i=d;return}function Xh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7816]&1){i=d;return}g=b+416|0;if(!((Qq(+h[(c[g>>2]|0)+280>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ro(7824,oo(+h[(c[g>>2]|0)+280>>3],6056)|0)|0;g=c[17500]|0;j=e;k=7912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ue[g&15](e,b,f);a[7816]=1;i=d;return}function Yh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7936]&1){i=d;return}g=b+416|0;if(!((Qq(+h[(c[g>>2]|0)+272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ro(7944,oo(+h[(c[g>>2]|0)+272>>3],6056)|0)|0;g=c[17500]|0;j=e;k=8640;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ue[g&15](e,b,f);a[7936]=1;i=d;return}function Zh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8144]&1){i=d;return}g=b+416|0;if(!((Qq(+h[(c[g>>2]|0)+264>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ro(8152,oo(+h[(c[g>>2]|0)+264>>3],6056)|0)|0;g=c[17500]|0;j=e;k=8784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ue[g&15](e,b,f);a[8144]=1;i=d;return}function _h(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8272]&1){i=d;return}g=b+416|0;if(!((Qq(+h[(c[g>>2]|0)+256>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ro(8280,oo(+h[(c[g>>2]|0)+256>>3],6056)|0)|0;g=c[17500]|0;j=e;k=8928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ue[g&15](e,b,f);a[8272]=1;i=d;return}function $h(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8392]&1){i=d;return}g=b+416|0;if(!((Qq(+h[(c[g>>2]|0)+248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ro(8400,oo(+h[(c[g>>2]|0)+248>>3],6056)|0)|0;g=c[17500]|0;j=e;k=9400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ue[g&15](e,b,f);a[8392]=1;i=d;return}function ai(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8512]&1){i=d;return}g=b+416|0;if(!((Qq(+h[(c[g>>2]|0)+240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ro(8520,oo(+h[(c[g>>2]|0)+240>>3],6056)|0)|0;g=c[17500]|0;j=e;k=8640;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ue[g&15](e,b,f);a[8512]=1;i=d;return}function bi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8664]&1){i=d;return}g=b+416|0;if(!((Qq(+h[(c[g>>2]|0)+232>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ro(8672,oo(+h[(c[g>>2]|0)+232>>3],6056)|0)|0;g=c[17500]|0;j=e;k=8784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ue[g&15](e,b,f);a[8664]=1;i=d;return}function ci(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8808]&1){i=d;return}g=b+416|0;if(!((Qq(+h[(c[g>>2]|0)+224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ro(8816,oo(+h[(c[g>>2]|0)+224>>3],6056)|0)|0;g=c[17500]|0;j=e;k=8928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ue[g&15](e,b,f);a[8808]=1;i=d;return}function di(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8952]&1){i=d;return}g=b+416|0;if(!((Qq(+h[(c[g>>2]|0)+216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ro(8960,oo(+h[(c[g>>2]|0)+216>>3],6056)|0)|0;g=c[17500]|0;j=e;k=9400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ue[g&15](e,b,f);a[8952]=1;i=d;return}function ei(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9072]&1){i=d;return}g=b+416|0;if(!((Qq(+h[(c[g>>2]|0)+128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ro(9080,oo(+h[(c[g>>2]|0)+128>>3],6056)|0)|0;g=c[17500]|0;j=e;k=9176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ue[g&15](e,b,f);a[9072]=1;i=d;return}function fi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9200]&1){i=d;return}g=b+416|0;if(!((Qq(+h[(c[g>>2]|0)+120>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ro(9208,oo(+h[(c[g>>2]|0)+120>>3],6056)|0)|0;g=c[17500]|0;j=e;k=9304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ue[g&15](e,b,f);a[9200]=1;i=d;return}function gi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9328]&1){i=d;return}g=b+416|0;if(!((Qq(+h[(c[g>>2]|0)+32>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ro(9336,oo(+h[(c[g>>2]|0)+32>>3],6056)|0)|0;g=c[17500]|0;j=e;k=9400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ue[g&15](e,b,f);a[9328]=1;i=d;return}function hi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9424]&1){i=d;return}g=b+416|0;if(!((Qq(+h[(c[g>>2]|0)+16>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ro(9432,oo(+h[(c[g>>2]|0)+16>>3],6056)|0)|0;g=c[17500]|0;j=e;k=9584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ue[g&15](e,b,f);a[9424]=1;i=d;return}function ii(a){a=a|0;var b=0;b=i;ph(a);qh(a);rh(a);sh(a);th(a);uh(a);vh(a);wh(a);xh(a);yh(a);zh(a);Ah(a);Bh(a);Ch(a);Dh(a);Eh(a);Fh(a);Gh(a);Hh(a);Ih(a);Jh(a);Kh(a);Lh(a);Mh(a);Nh(a);Oh(a);Ph(a);Qh(a);Rh(a);Sh(a);Th(a);Uh(a);Vh(a);Wh(a);Xh(a);Yh(a);Zh(a);_h(a);$h(a);ai(a);bi(a);ci(a);di(a);ei(a);fi(a);gi(a);hi(a);i=b;return 0}function ji(b){b=b|0;var c=0;c=i;a[b+314|0]=0;ki(b);i=c;return 0}function ki(a){a=a|0;var b=0;b=i;Ze(a);_e(a);$e(a);ef(a);ff(a);jf(a);kf(a);nf(a);rf(a);i=b;return}function li(a){a=a|0;i=i;return 0}function mi(a){a=a|0;i=i;return 1}function ni(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+464|0;a=c[d>>2]|0;c[a+44>>2]=3;c[a+48>>2]=3;c[a+72>>2]=cS(3,8)|0;a=cS(3,8)|0;c[(c[d>>2]|0)+80>>2]=a;a=cS(0,8)|0;c[(c[d>>2]|0)+76>>2]=a;a=aS(12)|0;c[(c[d>>2]|0)+52>>2]=a;a=aS(36)|0;c[(c[d>>2]|0)+56>>2]=a;a=aS(12)|0;c[(c[d>>2]|0)+64>>2]=a;a=c[d>>2]|0;c[a+68>>2]=3;c[a+84>>2]=0;a=c[d>>2]|0;e=c[a+52>>2]|0;c[e>>2]=3;c[e+4>>2]=6;c[e+8>>2]=9;oi(e,c[a+56>>2]|0);a=c[d>>2]|0;pi(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;qi(c[a+52>>2]|0,c[a+56>>2]|0);a=c[(c[d>>2]|0)+64>>2]|0;c[a+8>>2]=1;c[a+4>>2]=2;c[a>>2]=3;i=b;return 0}function oi(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;c[b+((c[d>>2]|0)+ -3<<2)>>2]=0;c[b+((c[d>>2]|0)+ -2<<2)>>2]=1;c[b+((c[d>>2]|0)+ -1<<2)>>2]=2;i=i;return}function pi(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;c[b+((c[d>>2]|0)+ -3<<2)>>2]=0;c[b+((c[d>>2]|0)+ -2<<2)>>2]=1;c[b+((c[d>>2]|0)+ -1<<2)>>2]=2;i=i;return}function qi(a,b){a=a|0;b=b|0;c[b+((c[a>>2]|0)+ -3<<2)>>2]=0;c[b+((c[a>>2]|0)+ -2<<2)>>2]=1;c[b+((c[a>>2]|0)+ -1<<2)>>2]=2;i=i;return}function ri(a){a=a|0;i=i;return 1}function si(a){a=a|0;i=i;return 1}function ti(a){a=a|0;i=i;return 1}function ui(a){a=a|0;i=i;return 0}function vi(a){a=a|0;i=i;return 0}function wi(a){a=a|0;i=i;return 0}function xi(a){a=a|0;i=i;return 0}function yi(a){a=a|0;i=i;return 0}function zi(a,b){a=a|0;b=b|0;i=i;return-1}function Ai(a,b){a=a|0;b=b|0;i=i;return-1}function Bi(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i;return-1}function Ci(){i=i;return 9608}function Di(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}a=c[d>>2]|0;if((a|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}j=+h[b>>3];d=!(j>=0.0);if((a|0)==1){if(d){k=-j}else{k=j}if((f|0)<2){g=1;i=e;return g|0}else{l=k;m=2;n=1}while(1){k=+h[b+(m+ -1<<3)>>3];o=!(k>=0.0);if(o){p=-k}else{p=k}q=p<=l;if(q|o^1){r=q?l:k;s=q?n:m}else{r=-k;s=m}q=m+1|0;if((q|0)>(f|0)){g=s;break}else{l=r;m=q;n=s}}i=e;return g|0}if(d){t=-j}else{t=j}if((f|0)<2){g=1;i=e;return g|0}j=t;d=2;s=a+1|0;n=1;while(1){t=+h[b+(s+ -1<<3)>>3];m=!(t>=0.0);if(m){u=-t}else{u=t}q=u<=j;if(q|m^1){v=q?j:t;w=q?n:d}else{v=-t;w=d}q=d+1|0;if((q|0)>(f|0)){g=w;break}else{j=v;d=q;s=a+s|0;n=w}}i=e;return g|0}function Ei(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)<1){i=f;return 0}if((j|0)!=1){e=fa(j,g)|0;if((e|0)>0){k=1}else{i=f;return 0}do{l=d+(k+ -1<<3)|0;h[l>>3]=+h[b>>3]*+h[l>>3];k=k+j|0;}while((k|0)<=(e|0));i=f;return 0}e=(g|0)%5|0;do{if((e|0)==0){m=g}else{if((e|0)<1){n=g}else{k=1;do{j=d+(k+ -1<<3)|0;h[j>>3]=+h[b>>3]*+h[j>>3];k=k+1|0;}while((k|0)<=(e|0));n=c[a>>2]|0}if((n|0)>=5){m=n;break}i=f;return 0}}while(0);n=e+1|0;if((n|0)>(m|0)){i=f;return 0}else{o=n}do{n=d+(o+ -1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+2<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+3<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];o=o+5|0;}while((o|0)<=(m|0));i=f;return 0}function Fi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}k=c[d>>2]|0;do{if((k|0)==1){l=c[f>>2]|0;if((l|0)!=1){m=l;n=1;break}l=(j|0)%3|0;do{if((l|0)==0){o=j}else{if((l|0)<1){p=j}else{q=1;do{r=q+ -1|0;s=b+(r<<3)|0;t=+h[s>>3];u=e+(r<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;q=q+1|0;}while((q|0)<=(l|0));p=c[a>>2]|0}if((p|0)>=3){o=p;break}i=g;return 0}}while(0);q=l+1|0;if((q|0)>(o|0)){i=g;return 0}else{v=q}do{q=v+ -1|0;u=b+(q<<3)|0;t=+h[u>>3];s=e+(q<<3)|0;h[u>>3]=+h[s>>3];h[s>>3]=t;s=b+(v<<3)|0;t=+h[s>>3];u=e+(v<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;u=v+1|0;s=b+(u<<3)|0;t=+h[s>>3];q=e+(u<<3)|0;h[s>>3]=+h[q>>3];h[q>>3]=t;v=v+3|0;}while((v|0)<=(o|0));i=g;return 0}else{if((k|0)<0){w=(fa(1-j|0,k)|0)+1|0}else{w=1}m=c[f>>2]|0;n=w}}while(0);if((m|0)<0){x=1;y=n;z=(fa(1-j|0,m)|0)+1|0}else{x=1;y=n;z=1}while(1){n=b+(y+ -1<<3)|0;t=+h[n>>3];m=e+(z+ -1<<3)|0;h[n>>3]=+h[m>>3];h[m>>3]=t;m=x+1|0;if((m|0)>(j|0)){break}else{z=(c[f>>2]|0)+z|0;y=(c[d>>2]|0)+y|0;x=m}}i=g;return 0}function Gi(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+8|0;n=m;o=c[l>>2]|0;l=~o;c[n>>2]=0;p=c[a>>2]|0;do{if((p|0)<0){c[n>>2]=1}else{q=c[b>>2]|0;if((q|0)<0){c[n>>2]=2;break}r=c[f>>2]|0;if((r|0)==0){c[n>>2]=5;break}s=c[j>>2]|0;if((s|0)==0){c[n>>2]=7;break}if((o|0)<(((p|0)>1?p:1)|0)){c[n>>2]=9;break}if((p|0)==0|(q|0)==0){i=m;return 0}if(+h[d>>3]==0.0){i=m;return 0}if((s|0)>0){t=1}else{t=1-(fa(s,q+ -1|0)|0)|0}if((r|0)==1){if((q|0)<1){i=m;return 0}else{u=s;v=1;w=t}while(1){x=+h[g+(w+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){A=u;break}B=(fa(v,o)|0)+l|0;C=1;do{D=k+(B+C<<3)|0;h[D>>3]=+h[D>>3]+y*+h[e+(C+ -1<<3)>>3];C=C+1|0;}while((C|0)<=(z|0));A=c[j>>2]|0}else{A=u}}while(0);z=v+1|0;if((z|0)>(q|0)){break}else{u=A;v=z;w=A+w|0}}i=m;return 0}if((r|0)>0){E=1}else{E=1-(fa(p+ -1|0,r)|0)|0}if((q|0)<1){i=m;return 0}else{F=s;G=1;H=t}while(1){x=+h[g+(H+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){I=F;break}C=(fa(G,o)|0)+l|0;B=1;D=E;while(1){J=k+(C+B<<3)|0;h[J>>3]=+h[J>>3]+y*+h[e+(D+ -1<<3)>>3];J=B+1|0;if((J|0)>(z|0)){break}else{D=(c[f>>2]|0)+D|0;B=J}}I=c[j>>2]|0}else{I=F}}while(0);B=G+1|0;if((B|0)>(q|0)){break}else{F=I;G=B;H=I+H|0}}i=m;return 0}}while(0);zb(10344,n|0)|0;i=m;return 0}function Hi(a,b,d,e,f,g,j,k,l,m,n,o,p){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0,da=0;q=i;i=i+8|0;r=q;s=c[k>>2]|0;t=~s;u=c[m>>2]|0;v=~u;w=c[p>>2]|0;x=~w;y=Hp(a,10352)|0;z=Hp(b,10352)|0;A=(y|0)!=0;y=c[(A?d:f)>>2]|0;B=(z|0)!=0;z=c[(B?f:e)>>2]|0;c[r>>2]=0;do{if(A){C=5}else{if((Hp(a,10360)|0)!=0){C=5;break}if((Hp(a,10368)|0)!=0){C=5;break}c[r>>2]=1}}while(0);a:do{if((C|0)==5){do{if(!B){if((Hp(b,10360)|0)!=0){break}if((Hp(b,10368)|0)!=0){break}c[r>>2]=2;break a}}while(0);a=c[d>>2]|0;if((a|0)<0){c[r>>2]=3;break}D=c[e>>2]|0;if((D|0)<0){c[r>>2]=4;break}E=c[f>>2]|0;if((E|0)<0){c[r>>2]=5;break}if((c[k>>2]|0)<(((y|0)>1?y:1)|0)){c[r>>2]=8;break}if((c[m>>2]|0)<(((z|0)>1?z:1)|0)){c[r>>2]=10;break}if((c[p>>2]|0)<(((a|0)>1?a:1)|0)){c[r>>2]=13;break}if((c[r>>2]|0)!=0){break}if((a|0)==0|(D|0)==0){i=q;return 0}F=+h[g>>3]==0.0;do{if(F|(E|0)==0){if(+h[n>>3]==1.0){i=q;return 0}if(!F){break}G=(D|0)<1;if(+h[n>>3]==0.0){if(G){i=q;return 0}else{H=a;I=0;J=2}while(1){if((H|0)>=1){IS(o+((fa(w,I)|0)<<3)|0,0,H<<3|0)|0}if((J|0)>(D|0)){break}H=c[d>>2]|0;I=I+1|0;J=J+1|0}i=q;return 0}if(G){i=q;return 0}else{K=a;L=1}while(1){if((K|0)>=1){M=(fa(L,w)|0)+x|0;N=1;do{O=o+(M+N<<3)|0;h[O>>3]=+h[n>>3]*+h[O>>3];N=N+1|0;}while((N|0)<=(K|0))}N=L+1|0;if((N|0)>(D|0)){break}K=c[d>>2]|0;L=N}i=q;return 0}}while(0);F=(D|0)<1;if(B){if(!A){if(F){i=q;return 0}else{P=a;Q=1}while(1){if((P|0)>=1){E=(fa(Q,w)|0)+x|0;G=(fa(Q,u)|0)+v|0;N=1;do{M=c[f>>2]|0;if((M|0)<1){R=0.0}else{O=(fa(N,s)|0)+t|0;S=1;T=0.0;while(1){U=T+ +h[j+(O+S<<3)>>3]*+h[l+(G+S<<3)>>3];V=S+1|0;if((V|0)>(M|0)){R=U;break}else{T=U;S=V}}}T=+h[n>>3];U=R*+h[g>>3];S=o+(E+N<<3)|0;if(T==0.0){W=U}else{W=U+T*+h[S>>3]}h[S>>3]=W;N=N+1|0;}while((N|0)<=(P|0))}N=Q+1|0;if((N|0)>(D|0)){break}P=c[d>>2]|0;Q=N}i=q;return 0}if(F){i=q;return 0}else{X=0;Y=1}while(1){N=o+((fa(w,X)|0)<<3)|0;T=+h[n>>3];b:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}IS(N|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}G=(fa(Y,w)|0)+x|0;U=T;S=1;while(1){M=o+(G+S<<3)|0;h[M>>3]=U*+h[M>>3];M=S+1|0;if((M|0)>(E|0)){break b}U=+h[n>>3];S=M}}}while(0);N=c[f>>2]|0;if((N|0)>=1){S=(fa(Y,u)|0)+v|0;E=(fa(Y,w)|0)+x|0;G=1;do{T=+h[l+(S+G<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];M=c[d>>2]|0;if((M|0)<1){break}O=(fa(G,s)|0)+t|0;V=1;do{Z=o+(E+V<<3)|0;h[Z>>3]=+h[Z>>3]+U*+h[j+(O+V<<3)>>3];V=V+1|0;}while((V|0)<=(M|0))}}while(0);G=G+1|0;}while((G|0)<=(N|0))}N=Y+1|0;if((N|0)>(D|0)){break}X=X+1|0;Y=N}i=q;return 0}else{if(!A){if(F){i=q;return 0}else{_=a;$=1}while(1){if((_|0)>=1){N=(fa($,w)|0)+x|0;G=$+v|0;E=1;do{S=c[f>>2]|0;if((S|0)<1){aa=0.0}else{M=(fa(E,s)|0)+t|0;V=1;T=0.0;while(1){U=T+ +h[j+(M+V<<3)>>3]*+h[l+(G+(fa(V,u)|0)<<3)>>3];O=V+1|0;if((O|0)>(S|0)){aa=U;break}else{T=U;V=O}}}T=+h[n>>3];U=aa*+h[g>>3];V=o+(N+E<<3)|0;if(T==0.0){ba=U}else{ba=U+T*+h[V>>3]}h[V>>3]=ba;E=E+1|0;}while((E|0)<=(_|0))}E=$+1|0;if((E|0)>(D|0)){break}_=c[d>>2]|0;$=E}i=q;return 0}if(F){i=q;return 0}else{ca=0;da=1}while(1){a=o+((fa(w,ca)|0)<<3)|0;T=+h[n>>3];c:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}IS(a|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}N=(fa(da,w)|0)+x|0;U=T;G=1;while(1){V=o+(N+G<<3)|0;h[V>>3]=U*+h[V>>3];V=G+1|0;if((V|0)>(E|0)){break c}U=+h[n>>3];G=V}}}while(0);a=c[f>>2]|0;if((a|0)>=1){G=da+v|0;E=(fa(da,w)|0)+x|0;N=1;do{T=+h[l+(G+(fa(N,u)|0)<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];V=c[d>>2]|0;if((V|0)<1){break}S=(fa(N,s)|0)+t|0;M=1;do{O=o+(E+M<<3)|0;h[O>>3]=+h[O>>3]+U*+h[j+(S+M<<3)>>3];M=M+1|0;}while((M|0)<=(V|0))}}while(0);N=N+1|0;}while((N|0)<=(a|0))}a=da+1|0;if((a|0)>(D|0)){break}ca=ca+1|0;da=a}i=q;return 0}}}while(0);zb(10376,r|0)|0;i=q;return 0}function Ii(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0,X=0.0,Y=0,Z=0,_=0;o=i;i=i+8|0;p=o;q=c[l>>2]|0;r=~q;s=c[n>>2]|0;t=~s;u=(Hp(a,10384)|0)!=0;v=c[(u?f:g)>>2]|0;w=Hp(e,10392)|0;x=Hp(b,10400)|0;c[p>>2]=0;do{if(u){y=4}else{if((Hp(a,10408)|0)!=0){y=4;break}c[p>>2]=1}}while(0);a:do{if((y|0)==4){do{if((x|0)==0){if((Hp(b,10384)|0)!=0){break}c[p>>2]=2;break a}}while(0);do{if((Hp(d,10392)|0)==0){if((Hp(d,10416)|0)!=0){break}if((Hp(d,10424)|0)!=0){break}c[p>>2]=3;break a}}while(0);do{if((Hp(e,10400)|0)==0){if((Hp(e,10392)|0)!=0){break}c[p>>2]=4;break a}}while(0);a=c[f>>2]|0;if((a|0)<0){c[p>>2]=5;break}z=c[g>>2]|0;if((z|0)<0){c[p>>2]=6;break}if((c[l>>2]|0)<(((v|0)>1?v:1)|0)){c[p>>2]=9;break}if((c[n>>2]|0)<(((a|0)>1?a:1)|0)){c[p>>2]=11;break}if((c[p>>2]|0)!=0){break}if((a|0)==0|(z|0)==0){i=o;return 0}if(+h[j>>3]==0.0){if((z|0)<1){i=o;return 0}else{A=a;B=0;C=2}while(1){if((A|0)>=1){IS(m+((fa(s,B)|0)<<3)|0,0,A<<3|0)|0}if((C|0)>(z|0)){break}A=c[f>>2]|0;B=B+1|0;C=C+1|0}i=o;return 0}z=(Hp(d,10392)|0)!=0;a=(x|0)!=0;D=c[g>>2]|0;if(u){E=(D|0)<1;if(!z){if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{H=c[f>>2]|0;if((H|0)>=1){I=(fa(G,s)|0)+t|0;J=1;do{K=m+(I+J<<3)|0;L=+h[j>>3]*+h[K>>3];M=J+ -1|0;if((M|0)<1){N=L}else{O=(fa(J,q)|0)+r|0;P=1;Q=L;while(1){L=Q- +h[k+(O+P<<3)>>3]*+h[m+(I+P<<3)>>3];R=P+1|0;if((R|0)>(M|0)){N=L;break}else{Q=L;P=R}}}if(F){S=N}else{S=N/+h[k+(J+r+(fa(J,q)|0)<<3)>>3]}h[K>>3]=S;J=J+1|0;}while((J|0)<=(H|0))}G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{H=c[f>>2]|0;b:do{if((H|0)>0){J=(fa(F,s)|0)+t|0;I=H;P=H;while(1){M=m+(J+P<<3)|0;Q=+h[j>>3]*+h[M>>3];O=P+1|0;if((O|0)>(I|0)){T=Q}else{R=(fa(P,q)|0)+r|0;U=O;L=Q;while(1){Q=L- +h[k+(R+U<<3)>>3]*+h[m+(J+U<<3)>>3];O=U+1|0;if((O|0)>(I|0)){T=Q;break}else{L=Q;U=O}}}if(G){V=T}else{V=T/+h[k+(P+r+(fa(P,q)|0)<<3)>>3]}h[M>>3]=V;U=P+ -1|0;if((U|0)<=0){break b}I=c[f>>2]|0;P=U}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];c:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}P=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){J=m+(P+I<<3)|0;h[J>>3]=Q*+h[J>>3];J=I+1|0;if((J|0)>(H|0)){y=43;break c}Q=+h[j>>3];I=J}}else{y=43}}while(0);d:do{if((y|0)==43){y=0;I=c[f>>2]|0;if((I|0)<=0){break}H=(fa(G,s)|0)+t|0;if(F){P=I;while(1){J=m+(H+P<<3)|0;L=+h[J>>3];K=P+ -1|0;e:do{if(L!=0.0){if((K|0)<1){break d}U=(fa(P,q)|0)+r|0;Q=L;R=1;while(1){O=m+(H+R<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(U+R<<3)>>3];O=R+1|0;if((O|0)>(K|0)){break e}Q=+h[J>>3];R=O}}}while(0);if((K|0)>0){P=K}else{break d}}}else{W=I}while(1){P=m+(H+W<<3)|0;L=+h[P>>3];f:do{if(L!=0.0){Q=L/+h[k+(W+r+(fa(W,q)|0)<<3)>>3];h[P>>3]=Q;J=W+ -1|0;if((J|0)<1){break d}M=(fa(W,q)|0)+r|0;X=Q;R=1;while(1){U=m+(H+R<<3)|0;h[U>>3]=+h[U>>3]-X*+h[k+(M+R<<3)>>3];U=R+1|0;if((U|0)>(J|0)){Y=J;break f}X=+h[P>>3];R=U}}else{Y=W+ -1|0}}while(0);if((Y|0)>0){W=Y}else{break}}}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{L=+h[j>>3];g:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(F,s)|0)+t|0;X=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=X*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){y=64;break g}X=+h[j>>3];P=K}}else{y=64}}while(0);do{if((y|0)==64){y=0;P=c[f>>2]|0;if((P|0)<1){break}H=(fa(F,s)|0)+t|0;if(G){I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];h:do{if(L!=0.0){R=c[f>>2]|0;J=I+1|0;if((J|0)>(R|0)){Z=J;break}M=(fa(I,q)|0)+r|0;X=L;U=J;while(1){O=m+(H+U<<3)|0;h[O>>3]=+h[O>>3]-X*+h[k+(M+U<<3)>>3];O=U+1|0;if((O|0)>(R|0)){Z=J;break h}X=+h[K>>3];U=O}}else{Z=I+1|0}}while(0);if((Z|0)>(P|0)){break}else{I=Z}}}else{I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];i:do{if(L!=0.0){X=L/+h[k+(I+r+(fa(I,q)|0)<<3)>>3];h[K>>3]=X;U=c[f>>2]|0;J=I+1|0;if((J|0)>(U|0)){_=J;break}R=(fa(I,q)|0)+r|0;Q=X;M=J;while(1){O=m+(H+M<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(R+M<<3)>>3];O=M+1|0;if((O|0)>(U|0)){_=J;break i}Q=+h[K>>3];M=O}}else{_=I+1|0}}while(0);if((_|0)>(P|0)){break}else{I=_}}}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(!z){if(a){if((D|0)<=0){i=o;return 0}F=(w|0)==0;G=D;while(1){do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];E=c[f>>2]|0;if((E|0)<1){break}I=(fa(G,s)|0)+t|0;P=1;do{H=m+(I+P<<3)|0;h[H>>3]=L*+h[H>>3];P=P+1|0;}while((P|0)<=(E|0))}}while(0);E=G+ -1|0;if((E|0)>=1){P=(fa(G,q)|0)+r|0;I=(fa(G,s)|0)+t|0;H=1;do{L=+h[k+(P+H<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(H,s)|0)+t|0;J=1;do{U=m+(M+J<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(I+J<<3)>>3];J=J+1|0;}while((J|0)<=(K|0))}}while(0);H=H+1|0;}while((H|0)<=(E|0))}L=+h[j>>3];j:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(G,s)|0)+t|0;Q=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=Q*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){break j}Q=+h[j>>3];P=K}}}while(0);if((E|0)>0){G=E}else{break}}i=o;return 0}else{if((D|0)<1){i=o;return 0}G=(w|0)==0;F=1;while(1){do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}P=(fa(F,s)|0)+t|0;H=1;do{I=m+(P+H<<3)|0;h[I>>3]=L*+h[I>>3];H=H+1|0;}while((H|0)<=(z|0))}}while(0);E=c[g>>2]|0;z=F+1|0;if((z|0)<=(E|0)){H=(fa(F,q)|0)+r|0;P=(fa(F,s)|0)+t|0;I=z;do{L=+h[k+(H+I<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}J=(fa(I,s)|0)+t|0;M=1;do{U=m+(J+M<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(P+M<<3)>>3];M=M+1|0;}while((M|0)<=(K|0))}}while(0);I=I+1|0;}while((I|0)<=(E|0))}L=+h[j>>3];k:do{if(L!=1.0){E=c[f>>2]|0;if((E|0)<1){break}I=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){H=m+(I+P<<3)|0;h[H>>3]=Q*+h[H>>3];H=P+1|0;if((H|0)>(E|0)){break k}Q=+h[j>>3];P=H}}}while(0);if((z|0)>(D|0)){break}else{F=z}}i=o;return 0}}if(a){if((D|0)<1){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];l:do{if(L!=1.0){P=c[f>>2]|0;if((P|0)<1){break}E=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){H=m+(E+I<<3)|0;h[H>>3]=Q*+h[H>>3];H=I+1|0;if((H|0)>(P|0)){break l}Q=+h[j>>3];I=H}}}while(0);z=G+ -1|0;if((z|0)>=1){I=(fa(G,q)|0)+r|0;P=(fa(G,s)|0)+t|0;E=1;do{H=k+(I+E<<3)|0;L=+h[H>>3];m:do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(E,s)|0)+t|0;Q=L;J=1;while(1){U=m+(P+J<<3)|0;h[U>>3]=+h[U>>3]-Q*+h[m+(M+J<<3)>>3];U=J+1|0;if((U|0)>(K|0)){break m}Q=+h[H>>3];J=U}}}while(0);E=E+1|0;}while((E|0)<=(z|0))}do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}E=(fa(G,s)|0)+t|0;P=1;do{I=m+(E+P<<3)|0;h[I>>3]=L*+h[I>>3];P=P+1|0;}while((P|0)<=(z|0))}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}else{if((D|0)<=0){i=o;return 0}G=(w|0)==0;F=D;do{L=+h[j>>3];n:do{if(L!=1.0){a=c[f>>2]|0;if((a|0)<1){break}z=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){E=m+(z+P<<3)|0;h[E>>3]=Q*+h[E>>3];E=P+1|0;if((E|0)>(a|0)){break n}Q=+h[j>>3];P=E}}}while(0);P=c[g>>2]|0;a=F+1|0;if((a|0)<=(P|0)){z=(fa(F,q)|0)+r|0;E=(fa(F,s)|0)+t|0;I=a;do{a=k+(z+I<<3)|0;L=+h[a>>3];o:do{if(L!=0.0){H=c[f>>2]|0;if((H|0)<1){break}J=(fa(I,s)|0)+t|0;Q=L;K=1;while(1){M=m+(E+K<<3)|0;h[M>>3]=+h[M>>3]-Q*+h[m+(J+K<<3)>>3];M=K+1|0;if((M|0)>(H|0)){break o}Q=+h[a>>3];K=M}}}while(0);I=I+1|0;}while((I|0)<=(P|0))}do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];P=c[f>>2]|0;if((P|0)<1){break}I=(fa(F,s)|0)+t|0;E=1;do{z=m+(I+E<<3)|0;h[z>>3]=L*+h[z>>3];E=E+1|0;}while((E|0)<=(P|0))}}while(0);F=F+ -1|0;}while((F|0)>0);i=o;return 0}}}while(0);zb(10432,p|0)|0;i=o;return 0}function Ji(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;i=i+8|0;l=k;c[j>>2]=0;m=c[a>>2]|0;do{if((m|0)<0){c[j>>2]=-1;n=-1}else{if((c[b>>2]|0)<0){c[j>>2]=-2;n=-2;break}o=(m|0)>1?m:1;if((c[e>>2]|0)<(o|0)){c[j>>2]=-4;n=-4;break}if((c[h>>2]|0)<(o|0)){c[j>>2]=-7;n=-7;break}Li(a,a,d,e,f,j)|0;if((c[j>>2]|0)!=0){i=k;return 0}Mi(10448,a,b,d,e,f,g,h,j)|0;i=k;return 0}}while(0);c[l>>2]=0-n;zb(10440,l|0)|0;i=k;return 0}function Ki(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;o=c[e>>2]|0;p=~o;c[g>>2]=0;q=c[a>>2]|0;do{if((q|0)<0){c[g>>2]=-1;r=-1}else{s=c[b>>2]|0;if((s|0)<0){c[g>>2]=-2;r=-2;break}if((c[e>>2]|0)<(((q|0)>1?q:1)|0)){c[g>>2]=-4;r=-4;break}if((q|0)==0|(s|0)==0){i=j;return 0}t=+op(10472);s=c[a>>2]|0;u=c[b>>2]|0;v=(s|0)>(u|0)?u:s;c[k>>2]=v;if((v|0)<1){i=j;return 0}else{w=s;x=1}while(1){c[l>>2]=1-x+w;s=x+ -1|0;v=fa(x,o)|0;u=x+p|0;y=u+v|0;z=d+(y<<3)|0;A=s+(Di(l,z,10480)|0)|0;c[f+(s<<2)>>2]=A;B=v+p|0;a:do{if(+h[d+(B+A<<3)>>3]!=0.0){if((A|0)!=(x|0)){Fi(b,d+(s<<3)|0,e,d+(A+ -1<<3)|0,e)|0}C=c[a>>2]|0;if((x|0)>=(C|0)){break}D=+h[z>>3];h[n>>3]=D;if(!(D>=0.0)){E=-D}else{E=D}F=C-x|0;c[l>>2]=F;if(E>=t){h[n>>3]=1.0/D;Ei(l,n,d+(x-o+v<<3)|0,10480)|0;break}if((F|0)<1){break}else{G=D;H=1}while(1){C=d+(y+H<<3)|0;h[C>>3]=+h[C>>3]/G;C=H+1|0;if((C|0)>(F|0)){break a}G=+h[z>>3];H=C}}else{if((c[g>>2]|0)!=0){break}c[g>>2]=x}}while(0);z=c[a>>2]|0;y=c[b>>2]|0;if((x|0)<(((z|0)>(y|0)?y:z)|0)){c[l>>2]=z-x;c[m>>2]=y-x;y=x+1|0;z=fa(y,o)|0;Gi(l,m,10488,d+(B+y<<3)|0,10480,d+(u+z<<3)|0,e,d+(y+p+z<<3)|0,e)|0;I=y}else{I=x+1|0}if((I|0)>(c[k>>2]|0)){break}w=c[a>>2]|0;x=I}i=j;return 0}}while(0);c[k>>2]=0-r;zb(10464,k|0)|0;i=j;return 0}function Li(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;i=i+48|0;j=h;k=h+8|0;l=h+16|0;m=h+24|0;n=h+32|0;o=h+40|0;p=c[e>>2]|0;q=~p;c[g>>2]=0;r=c[a>>2]|0;do{if((r|0)<0){c[g>>2]=-1;s=-1}else{t=c[b>>2]|0;if((t|0)<0){c[g>>2]=-2;s=-2;break}if((c[e>>2]|0)<(((r|0)>1?r:1)|0)){c[g>>2]=-4;s=-4;break}if((r|0)==0|(t|0)==0){i=h;return 0}t=10520;u=Oi(10504,10496,10512,a,b,t,t)|0;do{if((u|0)>=2){t=c[a>>2]|0;v=c[b>>2]|0;w=(t|0)>(v|0)?v:t;if((u|0)>=(w|0)){break}c[j>>2]=w;c[m>>2]=1;if((w|0)>0){x=v;y=t;z=1}else{i=h;return 0}while(1){t=((y|0)>(x|0)?x:y)-z+1|0;c[n>>2]=(t|0)<=(u|0)?t:u;c[k>>2]=y+1-z;Ki(k,n,d+(z+q+(fa(z,p)|0)<<3)|0,e,f+(z+ -1<<2)|0,o)|0;do{if((c[g>>2]|0)==0){t=c[o>>2]|0;if((t|0)<=0){break}c[g>>2]=t+ -1+(c[m>>2]|0)}}while(0);t=c[a>>2]|0;c[l>>2]=t;v=c[m>>2]|0;w=v+ -1|0;A=w+(c[n>>2]|0)|0;B=(t|0)<=(A|0)?t:A;c[k>>2]=B;if((v|0)<=(B|0)){t=v;do{v=f+(t+ -1<<2)|0;c[v>>2]=(c[v>>2]|0)+w;t=t+1|0;}while((t|0)<=(B|0))}c[k>>2]=w;c[l>>2]=A;Ni(k,d,e,m,l,f,10504)|0;B=c[m>>2]|0;t=c[n>>2]|0;v=t+B|0;C=c[b>>2]|0;do{if((v|0)>(C|0)){D=B}else{c[k>>2]=1-B-t+C;c[l>>2]=v+ -1;Ni(k,d+((fa(v,p)|0)-p<<3)|0,e,m,l,f,10504)|0;E=c[m>>2]|0;F=c[n>>2]|0;c[k>>2]=(c[b>>2]|0)+1-E-F;G=E+q|0;Ii(10528,10536,10544,10560,n,k,10568,d+(G+(fa(E,p)|0)<<3)|0,e,d+(G+(fa(F+E|0,p)|0)<<3)|0,e)|0;E=c[m>>2]|0;F=c[n>>2]|0;G=F+E|0;H=c[a>>2]|0;if((G|0)>(H|0)){D=E;break}c[k>>2]=1-E-F+H;c[l>>2]=(c[b>>2]|0)+1-E-F;F=fa(G,p)|0;H=10544;Hi(H,H,k,l,n,10576,d+((fa(E,p)|0)+q+G<<3)|0,e,d+(E+q+F<<3)|0,e,10568,d+(G+q+F<<3)|0,e)|0;D=c[m>>2]|0}}while(0);v=D+u|0;c[m>>2]=v;if((v|0)>(c[j>>2]|0)){break}x=c[b>>2]|0;y=c[a>>2]|0;z=v}i=h;return 0}}while(0);Ki(a,b,d,e,f,g)|0;i=h;return 0}}while(0);c[j>>2]=0-s;zb(10496,j|0)|0;i=h;return 0}function Mi(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;l=i;i=i+8|0;m=l;c[k>>2]=0;n=(Hp(a,10584)|0)!=0;do{if(n){o=5}else{if((Hp(a,10592)|0)!=0){o=5;break}if((Hp(a,10600)|0)!=0){o=5;break}c[k>>2]=-1;p=-1}}while(0);do{if((o|0)==5){a=c[b>>2]|0;if((a|0)<0){c[k>>2]=-2;p=-2;break}q=c[d>>2]|0;if((q|0)<0){c[k>>2]=-3;p=-3;break}r=(a|0)>1?a:1;if((c[f>>2]|0)<(r|0)){c[k>>2]=-5;p=-5;break}if((c[j>>2]|0)<(r|0)){c[k>>2]=-8;p=-8;break}r=c[k>>2]|0;if((r|0)!=0){p=r;break}if((a|0)==0|(q|0)==0){i=l;return 0}if(n){q=10616;Ni(d,h,j,q,b,g,q)|0;Ii(10624,10632,10640,10656,b,d,10664,e,f,h,j)|0;Ii(10624,10672,10640,10680,b,d,10664,e,f,h,j)|0;i=l;return 0}else{Ii(10624,10672,10696,10680,b,d,10664,e,f,h,j)|0;Ii(10624,10632,10696,10656,b,d,10664,e,f,h,j)|0;Ni(d,h,j,10616,b,g,10712)|0;i=l;return 0}}}while(0);c[m>>2]=0-p;zb(10608,m|0)|0;i=l;return 0}function Ni(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0;k=i;l=c[d>>2]|0;d=~l;m=c[j>>2]|0;do{if((m|0)>0){n=c[e>>2]|0;o=n;p=f;q=1;r=n}else{if((m|0)<0){n=c[f>>2]|0;o=n;p=e;q=-1;r=(fa(1-n|0,m)|0)+1|0;break}else{i=k;return 0}}}while(0);e=c[p>>2]|0;p=c[a>>2]|0;f=((p|0)/32|0)<<5;if((f|0)<1){s=m;t=p}else{p=(q|0)<0;n=p?(o|0)>=(e|0):(o|0)<=(e|0);u=m;m=1;while(1){if(n){v=m+31|0;if(p){w=u;x=o;y=r;while(1){z=c[g+(y+ -1<<2)>>2]|0;if((z|0)==(x|0)){A=w}else{B=x+d|0;C=z+d|0;z=m;do{D=fa(z,l)|0;E=b+(B+D<<3)|0;F=+h[E>>3];G=b+(C+D<<3)|0;h[E>>3]=+h[G>>3];h[G>>3]=F;z=z+1|0;}while((z|0)<=(v|0));A=c[j>>2]|0}z=x+q|0;if((z|0)<(e|0)){H=A;break}else{w=A;x=z;y=A+y|0}}}else{y=u;x=o;w=r;while(1){z=c[g+(w+ -1<<2)>>2]|0;if((z|0)==(x|0)){I=y}else{C=x+d|0;B=z+d|0;z=m;do{G=fa(z,l)|0;E=b+(C+G<<3)|0;F=+h[E>>3];D=b+(B+G<<3)|0;h[E>>3]=+h[D>>3];h[D>>3]=F;z=z+1|0;}while((z|0)<=(v|0));I=c[j>>2]|0}z=x+q|0;if((z|0)>(e|0)){H=I;break}else{y=I;x=z;w=I+w|0}}}}else{H=u}w=m+32|0;if((w|0)>(f|0)){break}else{u=H;m=w}}s=H;t=c[a>>2]|0}if((f|0)==(t|0)){i=k;return 0}t=f|1;f=(q|0)<0;if(!(f?(o|0)>=(e|0):(o|0)<=(e|0))){i=k;return 0}if(f){f=s;H=o;m=r;while(1){u=c[g+(m+ -1<<2)>>2]|0;do{if((u|0)==(H|0)){J=f}else{I=c[a>>2]|0;if((t|0)>(I|0)){J=f;break}A=H+d|0;p=u+d|0;n=t;do{w=fa(n,l)|0;x=b+(A+w<<3)|0;F=+h[x>>3];y=b+(p+w<<3)|0;h[x>>3]=+h[y>>3];h[y>>3]=F;n=n+1|0;}while((n|0)<=(I|0));J=c[j>>2]|0}}while(0);u=H+q|0;if((u|0)<(e|0)){break}else{f=J;H=u;m=J+m|0}}i=k;return 0}else{m=s;s=o;o=r;while(1){r=c[g+(o+ -1<<2)>>2]|0;do{if((r|0)==(s|0)){K=m}else{J=c[a>>2]|0;if((t|0)>(J|0)){K=m;break}H=s+d|0;f=r+d|0;u=t;do{I=fa(u,l)|0;n=b+(H+I<<3)|0;F=+h[n>>3];p=b+(f+I<<3)|0;h[n>>3]=+h[p>>3];h[p>>3]=F;u=u+1|0;}while((u|0)<=(J|0));K=c[j>>2]|0}}while(0);r=s+q|0;if((r|0)>(e|0)){break}else{m=K;s=r;o=K+o|0}}i=k;return 0}return 0}function Oi(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=ES(d|0)|0;switch(c[b>>2]|0){case 3:case 2:case 1:{q=o;LF(q,d,1,p);p=a[q]|0;do{if((p+ -97<<24>>24&255)<26){r=p+ -32<<24>>24;a[q]=r;s=o+1|0;t=a[s]|0;if((t+ -97<<24>>24&255)<26){a[s]=t+ -32<<24>>24}t=o+2|0;s=a[t]|0;if((s+ -97<<24>>24&255)<26){a[t]=s+ -32<<24>>24}s=o+3|0;t=a[s]|0;if((t+ -97<<24>>24&255)<26){a[s]=t+ -32<<24>>24}t=o+4|0;s=a[t]|0;if((s+ -97<<24>>24&255)<26){a[t]=s+ -32<<24>>24}s=o+5|0;t=a[s]|0;if(!((t+ -97<<24>>24&255)<26)){u=r;break}a[s]=t+ -32<<24>>24;u=r}else{u=p}}while(0);p=u<<24>>24==83;q=u<<24>>24==68;r=p|q;if(!(u<<24>>24==67|u<<24>>24==68|u<<24>>24==83|u<<24>>24==90)){v=1;i=k;return v|0}t=l;LF(t,o+1|0,1,2);l=m;LF(l,o+3|0,1,3);o=n;LF(o,m+1|0,1,2);m=c[b>>2]|0;if((m|0)==2){if((KF(t,10720,1,2)|0)==0){if((KF(l,10736,1,3)|0)==0){v=2;i=k;return v|0}if((KF(l,10744,1,3)|0)==0){v=2;i=k;return v|0}if((KF(l,10752,1,3)|0)==0){v=2;i=k;return v|0}if((KF(l,10760,1,3)|0)==0){v=2;i=k;return v|0}if((KF(l,10768,1,3)|0)==0){v=2;i=k;return v|0}if((KF(l,10776,1,3)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}if((KF(t,10800,1,2)|0)==0){n=(KF(l,10728,1,3)|0)==0;if(n|(p|q)^1){v=n?8:2;i=k;return v|0}v=2;i=k;return v|0}if(u<<24>>24==67|u<<24>>24==90){w=91}else if(u<<24>>24==68|u<<24>>24==83){w=94}else{v=2;i=k;return v|0}do{if((w|0)==91){if((KF(t,10824,1,2)|0)==0){v=2;i=k;return v|0}else{if(u<<24>>24==68|u<<24>>24==83){w=94;break}else if(u<<24>>24==67|u<<24>>24==90){break}else{v=2}i=k;return v|0}}}while(0);do{if((w|0)==94){if((KF(t,10832,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){break}else{v=2}i=k;return v|0}n=a[l]|0;if(n<<24>>24==77){if((KF(o,10840,1,2)|0)==0){v=2;i=k;return v|0}if((KF(o,10848,1,2)|0)==0){v=2;i=k;return v|0}if((KF(o,10856,1,2)|0)==0){v=2;i=k;return v|0}if((KF(o,10864,1,2)|0)==0){v=2;i=k;return v|0}if((KF(o,10872,1,2)|0)==0){v=2;i=k;return v|0}if((KF(o,10880,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else if(n<<24>>24==71){if((KF(o,10840,1,2)|0)==0){v=2;i=k;return v|0}if((KF(o,10848,1,2)|0)==0){v=2;i=k;return v|0}if((KF(o,10856,1,2)|0)==0){v=2;i=k;return v|0}if((KF(o,10864,1,2)|0)==0){v=2;i=k;return v|0}if((KF(o,10872,1,2)|0)==0){v=2;i=k;return v|0}if((KF(o,10880,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else{v=2;i=k;return v|0}}}while(0);if((KF(t,10896,1,2)|0)!=0){v=2;i=k;return v|0}n=a[l]|0;if(n<<24>>24==77){if((KF(o,10840,1,2)|0)==0){v=2;i=k;return v|0}if((KF(o,10848,1,2)|0)==0){v=2;i=k;return v|0}if((KF(o,10856,1,2)|0)==0){v=2;i=k;return v|0}if((KF(o,10864,1,2)|0)==0){v=2;i=k;return v|0}if((KF(o,10872,1,2)|0)==0){v=2;i=k;return v|0}if((KF(o,10880,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else if(n<<24>>24==71){if((KF(o,10840,1,2)|0)==0){v=2;i=k;return v|0}if((KF(o,10848,1,2)|0)==0){v=2;i=k;return v|0}if((KF(o,10856,1,2)|0)==0){v=2;i=k;return v|0}if((KF(o,10864,1,2)|0)==0){v=2;i=k;return v|0}if((KF(o,10872,1,2)|0)==0){v=2;i=k;return v|0}if((KF(o,10880,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else{v=2;i=k;return v|0}}else if((m|0)==3){if((KF(t,10720,1,2)|0)==0){if((KF(l,10736,1,3)|0)==0){v=128;i=k;return v|0}if((KF(l,10744,1,3)|0)==0){v=128;i=k;return v|0}if((KF(l,10752,1,3)|0)==0){v=128;i=k;return v|0}if((KF(l,10760,1,3)|0)==0){v=128;i=k;return v|0}if((KF(l,10768,1,3)|0)==0){v=128;i=k;return v|0}m=(KF(l,10776,1,3)|0)==0;v=m?128:0;i=k;return v|0}if((KF(t,10800,1,2)|0)==0){if(!(u<<24>>24==68|u<<24>>24==83)){v=0;i=k;return v|0}m=(KF(l,10808,1,3)|0)==0;v=m?32:0;i=k;return v|0}if(u<<24>>24==67|u<<24>>24==90){w=138}else if(u<<24>>24==68|u<<24>>24==83){w=141}else{v=0;i=k;return v|0}do{if((w|0)==138){if((KF(t,10824,1,2)|0)==0){m=(KF(l,10808,1,3)|0)==0;v=m?32:0;i=k;return v|0}else{if(u<<24>>24==68|u<<24>>24==83){w=141;break}else if(u<<24>>24==67|u<<24>>24==90){break}else{v=0}i=k;return v|0}}}while(0);do{if((w|0)==141){if((KF(t,10832,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){break}else{v=0}i=k;return v|0}if((a[l]|0)!=71){v=0;i=k;return v|0}do{if((KF(o,10840,1,2)|0)!=0){if((KF(o,10848,1,2)|0)==0){break}if((KF(o,10856,1,2)|0)==0){break}if((KF(o,10864,1,2)|0)==0){break}if((KF(o,10872,1,2)|0)==0){break}if((KF(o,10880,1,2)|0)==0){break}if((KF(o,10888,1,2)|0)==0){break}else{v=0}i=k;return v|0}}while(0);v=128;i=k;return v|0}}while(0);if((KF(t,10896,1,2)|0)!=0){v=0;i=k;return v|0}if((a[l]|0)!=71){v=0;i=k;return v|0}do{if((KF(o,10840,1,2)|0)!=0){if((KF(o,10848,1,2)|0)==0){break}if((KF(o,10856,1,2)|0)==0){break}if((KF(o,10864,1,2)|0)==0){break}if((KF(o,10872,1,2)|0)==0){break}if((KF(o,10880,1,2)|0)==0){break}if((KF(o,10888,1,2)|0)==0){break}else{v=0}i=k;return v|0}}while(0);v=128;i=k;return v|0}else{if((KF(t,10720,1,2)|0)==0){if((KF(l,10728,1,3)|0)==0){v=64;i=k;return v|0}if((KF(l,10736,1,3)|0)==0){v=32;i=k;return v|0}if((KF(l,10744,1,3)|0)==0){v=32;i=k;return v|0}if((KF(l,10752,1,3)|0)==0){v=32;i=k;return v|0}if((KF(l,10760,1,3)|0)==0){v=32;i=k;return v|0}if((KF(l,10768,1,3)|0)==0){v=32;i=k;return v|0}if((KF(l,10776,1,3)|0)==0){v=32;i=k;return v|0}m=(KF(l,10784,1,3)|0)==0;v=m?64:1;i=k;return v|0}if((KF(t,10792,1,2)|0)==0){m=(KF(l,10728,1,3)|0)==0;v=m?64:1;i=k;return v|0}if((KF(t,10800,1,2)|0)==0){m=(KF(l,10728,1,3)|0)==0;if(m|r^1){v=m?64:1;i=k;return v|0}m=(KF(l,10808,1,3)|0)==0;if(m){v=m?32:1;i=k;return v|0}m=(KF(l,10816,1,3)|0)==0;v=m?64:1;i=k;return v|0}do{if(u<<24>>24==68|u<<24>>24==83){w=29}else if(u<<24>>24==67|u<<24>>24==90){if((KF(t,10824,1,2)|0)!=0){if(u<<24>>24==68|u<<24>>24==83){w=29;break}else if(u<<24>>24==67|u<<24>>24==90){w=48;break}else{break}}if((KF(l,10728,1,3)|0)==0){v=64;i=k;return v|0}if((KF(l,10808,1,3)|0)==0){v=32;i=k;return v|0}m=(KF(l,10816,1,3)|0)==0;v=m?64:1;i=k;return v|0}}while(0);do{if((w|0)==29){if((KF(t,10832,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){w=48;break}else{break}}m=a[l]|0;if(m<<24>>24==77){do{if((KF(o,10840,1,2)|0)!=0){if((KF(o,10848,1,2)|0)==0){break}if((KF(o,10856,1,2)|0)==0){break}if((KF(o,10864,1,2)|0)==0){break}if((KF(o,10872,1,2)|0)==0){break}if((KF(o,10880,1,2)|0)==0){break}if((KF(o,10888,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else if(m<<24>>24==71){do{if((KF(o,10840,1,2)|0)!=0){if((KF(o,10848,1,2)|0)==0){break}if((KF(o,10856,1,2)|0)==0){break}if((KF(o,10864,1,2)|0)==0){break}if((KF(o,10872,1,2)|0)==0){break}if((KF(o,10880,1,2)|0)==0){break}if((KF(o,10888,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else{v=1;i=k;return v|0}}}while(0);do{if((w|0)==48){if((KF(t,10896,1,2)|0)!=0){break}m=a[l]|0;if(m<<24>>24==77){do{if((KF(o,10840,1,2)|0)!=0){if((KF(o,10848,1,2)|0)==0){break}if((KF(o,10856,1,2)|0)==0){break}if((KF(o,10864,1,2)|0)==0){break}if((KF(o,10872,1,2)|0)==0){break}if((KF(o,10880,1,2)|0)==0){break}if((KF(o,10888,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else if(m<<24>>24==71){do{if((KF(o,10840,1,2)|0)!=0){if((KF(o,10848,1,2)|0)==0){break}if((KF(o,10856,1,2)|0)==0){break}if((KF(o,10864,1,2)|0)==0){break}if((KF(o,10872,1,2)|0)==0){break}if((KF(o,10880,1,2)|0)==0){break}if((KF(o,10888,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else{v=1;i=k;return v|0}}}while(0);if((KF(t,10904,1,2)|0)==0){if((KF(l,10728,1,3)|0)!=0){v=1;i=k;return v|0}v=(c[j>>2]|0)<65?1:32;i=k;return v|0}if((KF(t,10912,1,2)|0)==0){if((KF(l,10728,1,3)|0)!=0){v=1;i=k;return v|0}v=(c[g>>2]|0)<65?1:32;i=k;return v|0}if((KF(t,10880,1,2)|0)==0){o=(KF(l,10784,1,3)|0)==0;v=o?64:1;i=k;return v|0}if((KF(t,10920,1,2)|0)==0){o=(KF(l,10928,1,3)|0)==0;v=o?64:1;i=k;return v|0}if(!(u<<24>>24==68|u<<24>>24==83)){v=1;i=k;return v|0}if((KF(t,10936,1,2)|0)==0){i=k;return 1}else{v=1;i=k;return v|0}}break};case 6:{t=c[f>>2]|0;u=c[g>>2]|0;v=~~(+(((t|0)>(u|0)?u:t)|0)*1.600000023841858);i=k;return v|0};case 7:{v=1;i=k;return v|0};case 8:{v=50;i=k;return v|0};case 9:{v=25;i=k;return v|0};case 10:{v=Pi(10952,10960,10968)|0;i=k;return v|0};case 11:{v=Pi(10976,10960,10968)|0;i=k;return v|0};case 16:case 15:case 14:case 13:case 12:{v=Qi(b,d,e,f,g,h,j)|0;i=k;return v|0};case 4:{v=6;i=k;return v|0};case 5:{v=2;i=k;return v|0};default:{v=-1;i=k;return v|0}}return 0}function Pi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0.0,h=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=+g[d>>2];h=+g[b>>2];do{if(!(f/h<=f)){j=-f/h;if(j>=h){k=0;break}l=f/(f+j);if(l!=h){k=0;break}j=f/l;if(j>=h){k=0;break}m=h+l;if(m!=h){k=0;break}n=f/m;if(n<=f){k=0;break}m=j*n;if(m>=h){k=0;break}j=n*n;if(j<=f){k=0;break}if((c[a>>2]|0)==0){k=1;break}n=j+m;o=j/j;p=h*j;q=l*m;l=j/m;if(n==n&0.0==0.0|l==l&0.0==0.0|o==o&0.0==0.0|p==p&0.0==0.0|q==q&0.0==0.0){k=0;break}p=q*0.0;k=(p!=p|0.0!=0.0)&1}else{k=0}}while(0);i=e;return k|0}function Qi(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+8|0;e=j;d=c[a>>2]|0;if((d|0)==16|(d|0)==13|(d|0)==15){b=(c[h>>2]|0)-(c[f>>2]|0)+1|0;if((b|0)>149){g[e>>2]=+da(+(+(b|0)))/.6931471805599453;f=(b|0)/(JF(e)|0)|0;k=c[a>>2]|0;l=(f|0)>10?f:10}else{k=d;l=(b|0)>59?10:(b|0)>29?4:2}f=(b|0)>5999?256:(b|0)>2999?128:(b|0)>589?64:l;l=f-((f|0)%2|0)|0;m=k;n=b;o=(l|0)>2?l:2}else{m=d;n=0;o=0}switch(m|0){case 15:{p=o;i=j;return p|0};case 16:{m=(o|0)>13;i=j;return(m?2:m&1)|0};case 13:{if((n|0)<501){p=o;i=j;return p|0}p=(o*3|0)/2|0;i=j;return p|0};case 12:{p=75;i=j;return p|0};case 14:{p=14;i=j;return p|0};default:{p=-1;i=j;return p|0}}return 0}function Ri(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=Si(a,0,0)|0;i=b;return c|0}function Si(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=Ti(a,b,c,0)|0;i=d;return e|0}function Ti(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+64|0;h=b;b=d;d=e;e=f;do{if((b|0)!=0){j=$d[c[b>>2]&127](500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}else{j=aS(500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=29;c[f+4>>2]=48;c[f+8>>2]=148}}while(0);b=j;if((j|0)==0){k=b;l=k;i=g;return l|0}c[b+8>>2]=0;c[j+32>>2]=0;c[j+380>>2]=16;c[j+392>>2]=$d[c[j+12>>2]&127](c[j+380>>2]<<4)|0;b=j+12|0;if((c[j+392>>2]|0)==0){Yd[c[b+8>>2]&255](j);k=0;l=k;i=g;return l|0}c[j+44>>2]=$d[c[b>>2]&127](1024)|0;b=j;if((c[j+44>>2]|0)==0){Yd[c[b+20>>2]&255](c[j+392>>2]|0);Yd[c[j+20>>2]&255](j);k=0;l=k;i=g;return l|0}c[j+48>>2]=(c[b+44>>2]|0)+1024;do{if((e|0)!=0){c[j+356>>2]=e}else{c[j+356>>2]=ck(j+12|0)|0;if((c[j+356>>2]|0)!=0){break}Yd[c[j+20>>2]&255](c[j+44>>2]|0);Yd[c[j+20>>2]&255](c[j+392>>2]|0);Yd[c[j+20>>2]&255](j);k=0;l=k;i=g;return l|0}}while(0);c[j+376>>2]=0;c[j+368>>2]=0;c[j+304>>2]=0;c[j+468>>2]=0;c[j+464>>2]=0;c[j+124>>2]=0;c[j+248>>2]=0;a[j+472|0]=33;a[j+236|0]=0;a[j+237|0]=0;c[j+396>>2]=0;c[j+400>>2]=0;a[j+404|0]=0;dk(j+416|0,j+12|0);dk(j+440|0,j+12|0);Vi(j,h);do{if((h|0)!=0){if((c[j+232>>2]|0)!=0){break}Yi(j);k=0;l=k;i=g;return l|0}}while(0);if((d|0)!=0){a[j+236|0]=1;c[j+228>>2]=xk()|0;a[j+472|0]=a[d]|0}else{c[j+228>>2]=ok()|0}k=j;l=k;i=g;return l|0}function Ui(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;a=c[d>>2]|0;a:do{if((c[d+4>>2]|0)!=0){e=a;while(1){if((e|0)==0){break a}f=c[e>>2]|0;c[e>>2]=c[d+4>>2];c[d+4>>2]=e;e=f}}else{c[d+4>>2]=a}}while(0);c[d>>2]=0;c[d+16>>2]=0;c[d+12>>2]=0;c[d+8>>2]=0;i=b;return}function Vi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=d;c[f+280>>2]=36;Gm(f+256|0);if((b|0)!=0){g=Wi(f+416|0,b)|0}else{g=0}c[f+232>>2]=g;c[f+360>>2]=0;pk(f+148|0,f+144|0,0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=0;c[f+64>>2]=0;c[f+68>>2]=0;c[f+72>>2]=0;c[f+76>>2]=0;c[f+80>>2]=0;c[f+84>>2]=0;c[f+88>>2]=0;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;c[f+104>>2]=0;c[f+108>>2]=0;c[f+112>>2]=0;c[f+116>>2]=f;c[f+120>>2]=0;c[f+128>>2]=0;c[f+132>>2]=0;c[f+136>>2]=0;c[f+140>>2]=0;c[f+24>>2]=c[f+8>>2];c[f+28>>2]=c[f+8>>2];c[f+36>>2]=0;c[f+40>>2]=0;c[f+344>>2]=0;c[f+348>>2]=0;c[f+316>>2]=0;c[f+320>>2]=0;c[f+324>>2]=0;c[f+328>>2]=0;c[f+332>>2]=0;c[f+336>>2]=0;c[f+340>>2]=0;a[f+352|0]=0;a[f+353|0]=0;g=f+408|0;c[g+0>>2]=0;c[g+4>>2]=0;c[f+284>>2]=0;c[f+288>>2]=0;c[f+292>>2]=0;c[f+296>>2]=0;c[f+300>>2]=0;a[f+308|0]=1;c[f+312>>2]=0;c[f+364>>2]=0;c[f+372>>2]=0;c[f+384>>2]=0;c[f+240>>2]=0;c[f+252>>2]=0;c[f+244>>2]=0;c[f+476>>2]=0;c[f+480>>2]=0;a[f+488|0]=0;a[f+489|0]=0;c[f+492>>2]=0;c[f+496>>2]=0;i=e;return}function Wi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+24|0;f=b;b=d;while(1){if((c[f+12>>2]|0)==(c[f+8>>2]|0)){if(!((lj(f)|0)<<24>>24!=0)){g=5;break}}d=a[b]|0;h=f+12|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j]=d;d=b;b=d+1|0;if((a[d]|0)==0){g=6;break}}if((g|0)==5){k=0;l=k;i=e;return l|0}else if((g|0)==6){b=c[f+16>>2]|0;c[f+16>>2]=c[f+12>>2];k=b;l=k;i=e;return l|0}return 0}function Xi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=b;a:while(1){if((a[b]|0)==0){h=45;break}do{if((a[g]|0)!=12){if((a[g]|0)==0){break}j=c[f+428>>2]|0;k=f+416|0;if((a[g]|0)!=61){if((j|0)==(c[k+8>>2]|0)){if(!((lj(f+416|0)|0)<<24>>24!=0)){h=44;break a}}l=a[g]|0;m=f+428|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;g=g+1|0;continue a}if((j-(c[k+16>>2]|0)|0)==0){o=d+152|0}else{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((lj(f+416|0)|0)<<24>>24!=0)){h=19;break a}}k=f+428|0;j=c[k>>2]|0;c[k>>2]=j+1;a[j]=0;o=oj(f,d+60|0,c[f+432>>2]|0,8)|0;if((o|0)==0){h=20;break a}if((c[o>>2]|0)==(c[f+432>>2]|0)){c[o>>2]=Wi(d+80|0,c[o>>2]|0)|0;if((c[o>>2]|0)==0){h=23;break a}}c[f+428>>2]=c[f+432>>2]}b=g+1|0;while(1){if((a[b]|0)!=12){p=(a[b]|0)!=0}else{p=0}q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if(!p){break}if(q){if(!((lj(f+416|0)|0)<<24>>24!=0)){h=32;break a}}j=a[b]|0;k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=j;b=b+1|0}if(q){if(!((lj(f+416|0)|0)<<24>>24!=0)){h=36;break a}}j=f+428|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;if((sj(f,o,0,c[f+432>>2]|0,f+372|0)|0)!=0){h=37;break a}c[f+428>>2]=c[f+432>>2];if((a[b]|0)!=0){b=b+1|0}g=b;continue a}}while(0);if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((lj(f+416|0)|0)<<24>>24!=0)){h=8;break}}l=f+428|0;j=c[l>>2]|0;c[l>>2]=j+1;a[j]=0;j=oj(f,d,c[f+432>>2]|0,0)|0;if((j|0)!=0){a[j+32|0]=1}if((a[g]|0)!=0){g=g+1|0}b=g;c[f+428>>2]=c[f+432>>2]}if((h|0)==8){r=0;s=r;i=e;return s|0}else if((h|0)==19){r=0;s=r;i=e;return s|0}else if((h|0)==20){r=0;s=r;i=e;return s|0}else if((h|0)==23){r=0;s=r;i=e;return s|0}else if((h|0)==32){r=0;s=r;i=e;return s|0}else if((h|0)==36){r=0;s=r;i=e;return s|0}else if((h|0)==37){r=0;s=r;i=e;return s|0}else if((h|0)==44){r=0;s=r;i=e;return s|0}else if((h|0)==45){r=1;s=r;i=e;return s|0}return 0}function Yi(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=b;if((e|0)==0){i=d;return}b=c[e+364>>2]|0;while(1){if((b|0)==0){f=e;if((c[e+368>>2]|0)==0){break}b=c[f+368>>2]|0;c[e+368>>2]=0}g=b;b=c[b>>2]|0;Yd[c[e+20>>2]&255](c[g+36>>2]|0);Zi(c[g+44>>2]|0,e);Yd[c[e+20>>2]&255](g)}b=c[f+300>>2]|0;while(1){if((b|0)==0){h=e;if((c[e+304>>2]|0)==0){break}b=c[h+304>>2]|0;c[e+304>>2]=0}f=b;b=c[b+8>>2]|0;Yd[c[e+20>>2]&255](f)}Zi(c[h+376>>2]|0,e);Zi(c[e+372>>2]|0,e);_i(e+416|0);_i(e+440|0);do{if((a[e+488|0]|0)==0){if((c[e+356>>2]|0)==0){break}$i(c[e+356>>2]|0,((c[e+476>>2]|0)!=0^1)&1,e+12|0)}}while(0);Yd[c[e+20>>2]&255](c[e+392>>2]|0);Yd[c[e+20>>2]&255](c[e+464>>2]|0);Yd[c[e+20>>2]&255](c[e+8>>2]|0);Yd[c[e+20>>2]&255](c[e+44>>2]|0);Yd[c[e+20>>2]&255](c[e+396>>2]|0);Yd[c[e+20>>2]&255](c[e+240>>2]|0);if((c[e+252>>2]|0)!=0){Yd[c[e+252>>2]&255](c[e+244>>2]|0)}Yd[c[e+20>>2]&255](e);i=d;return}function Zi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+24|0;e=a;a=b;while(1){b=e;if((b|0)==0){break}e=c[b+4>>2]|0;Yd[c[a+20>>2]&255](c[b+16>>2]|0);Yd[c[a+20>>2]&255](b)}i=d;return}function _i(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=a;a=c[d>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;Yd[c[(c[d+20>>2]|0)+8>>2]&255](a);a=e}a=c[d+4>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;Yd[c[(c[d+20>>2]|0)+8>>2]&255](a);a=e}i=b;return}function $i(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+40|0;f=e+24|0;g=a;a=b;b=d;mj(f,g+20|0);while(1){d=nj(f)|0;if((d|0)==0){break}if((c[d+16>>2]|0)==0){continue}Yd[c[b+8>>2]&255](c[d+20>>2]|0)}rj(g);rj(g+132|0);rj(g+20|0);rj(g+40|0);rj(g+60|0);_i(g+80|0);_i(g+104|0);if(!(a<<24>>24!=0)){h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;Yd[m&255](o);i=e;return}Yd[c[b+8>>2]&255](c[g+184>>2]|0);Yd[c[b+8>>2]&255](c[g+164>>2]|0);h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;Yd[m&255](o);i=e;return}function aj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a;a=(c[e+4>>2]|0)==(c[e>>2]|0);f=b;c[e>>2]=f;if(!a){i=d;return}c[e+4>>2]=f;i=d;return}function bj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+24|0;f=a;c[f+52>>2]=b;c[f+56>>2]=d;i=e;return}function cj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=d;d=e;e=f;f=c[h+480>>2]|0;do{if((f|0)==3){c[h+284>>2]=33;j=0;k=j;i=g;return k|0}else if((f|0)==2){c[h+284>>2]=36;j=0;k=j;i=g;return k|0}else if((f|0)==0){if((c[h+476>>2]|0)!=0){break}if((dj(h)|0)<<24>>24!=0){break}c[h+284>>2]=1;j=0;k=j;i=g;return k|0}}while(0);c[h+480>>2]=1;if((d|0)!=0){f=fj(h,d)|0;if((f|0)==0){j=0;k=j;i=g;return k|0}else{GS(f|0,b|0,d|0)|0;j=gj(h,d,e)|0;k=j;i=g;return k|0}}a[h+484|0]=e;if((e|0)==0){j=1;k=j;i=g;return k|0}c[h+296>>2]=c[h+24>>2];c[h+40>>2]=c[h+28>>2];c[h+284>>2]=xe[c[h+280>>2]&63](h,c[h+24>>2]|0,c[h+40>>2]|0,h+24|0)|0;e=h;if((c[h+284>>2]|0)!=0){c[h+292>>2]=c[e+288>>2];c[h+280>>2]=37;j=0;k=j;i=g;return k|0}d=c[e+480>>2]|0;if((d|0)==1|(d|0)==0){c[h+480>>2]=2}else if((d|0)==3){ye[c[(c[h+144>>2]|0)+52>>2]&31](c[h+144>>2]|0,c[h+296>>2]|0,c[h+24>>2]|0,h+408|0);c[h+296>>2]=c[h+24>>2];j=2;k=j;i=g;return k|0}j=1;k=j;i=g;return k|0}function dj(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=b;if((c[e+496>>2]|0)==0){c[e+496>>2]=ak()|0}if((a[e+236|0]|0)!=0){f=Xi(e,12760)|0;g=f;i=d;return g|0}else{f=1;g=f;i=d;return g|0}return 0}function ej(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+32|0;i=e;return c[a+284>>2]|0}function fj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+72|0;e=a;a=b;b=c[e+480>>2]|0;if((b|0)==3){c[e+284>>2]=33;f=0;g=f;i=d;return g|0}else if((b|0)==2){c[e+284>>2]=36;f=0;g=f;i=d;return g|0}else{if((a|0)>((c[e+32>>2]|0)-(c[e+28>>2]|0)|0)){b=a+((c[e+28>>2]|0)-(c[e+24>>2]|0))|0;a=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;h=a;h=(h|0)>1024?1024:a;b=b+h|0;do{if((b|0)<=((c[e+32>>2]|0)-(c[e+8>>2]|0)|0)){if((h|0)>=((c[e+24>>2]|0)-(c[e+8>>2]|0)|0)){break}a=(c[e+24>>2]|0)-(c[e+8>>2]|0)-h|0;HS(c[e+8>>2]|0,(c[e+8>>2]|0)+a|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+h|0)|0;j=e+28|0;c[j>>2]=(c[j>>2]|0)+(0-a);j=e+24|0;c[j>>2]=(c[j>>2]|0)+(0-a)}else{a=(c[e+32>>2]|0)-(c[e+24>>2]|0)|0;j=a;j=(j|0)==0?1024:a;do{j=j<<1;}while((j|0)<(b|0));a=$d[c[e+12>>2]&127](j)|0;if((a|0)==0){c[e+284>>2]=1;f=0;g=f;i=d;return g|0}c[e+32>>2]=a+j;if((c[e+24>>2]|0)!=0){k=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;l=k;l=(l|0)>1024?1024:k;GS(a|0,(c[e+24>>2]|0)+(0-l)|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+l|0)|0;Yd[c[e+20>>2]&255](c[e+8>>2]|0);c[e+8>>2]=a;c[e+28>>2]=(c[e+8>>2]|0)+((c[e+28>>2]|0)-(c[e+24>>2]|0))+l;c[e+24>>2]=(c[e+8>>2]|0)+l;break}else{c[e+28>>2]=a+((c[e+28>>2]|0)-(c[e+24>>2]|0));l=a;c[e+8>>2]=l;c[e+24>>2]=l;break}}}while(0);c[e+292>>2]=0;c[e+288>>2]=0;c[e+296>>2]=0}f=c[e+28>>2]|0;g=f;i=d;return g|0}return 0}function gj(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=b;b=d;d=e;e=1;h=c[g+480>>2]|0;do{if((h|0)==0){if((c[g+476>>2]|0)!=0){break}if((dj(g)|0)<<24>>24!=0){break}c[g+284>>2]=1;j=0;k=j;i=f;return k|0}else if((h|0)==3){c[g+284>>2]=33;j=0;k=j;i=f;return k|0}else if((h|0)==2){c[g+284>>2]=36;j=0;k=j;i=f;return k|0}}while(0);c[g+480>>2]=1;h=c[g+24>>2]|0;c[g+296>>2]=h;l=g+28|0;c[l>>2]=(c[l>>2]|0)+b;c[g+40>>2]=c[g+28>>2];l=g+36|0;c[l>>2]=(c[l>>2]|0)+b;a[g+484|0]=d;c[g+284>>2]=xe[c[g+280>>2]&63](g,h,c[g+40>>2]|0,g+24|0)|0;h=g;if((c[g+284>>2]|0)!=0){c[g+292>>2]=c[h+288>>2];c[g+280>>2]=37;j=0;k=j;i=f;return k|0}b=c[h+480>>2]|0;do{if((b|0)==3){e=2}else if((b|0)==1|(b|0)==0){if((d|0)==0){break}c[g+480>>2]=2;j=e;k=j;i=f;return k|0}}while(0);ye[c[(c[g+144>>2]|0)+52>>2]&31](c[g+144>>2]|0,c[g+296>>2]|0,c[g+24>>2]|0,g+408|0);c[g+296>>2]=c[g+24>>2];j=e;k=j;i=f;return k|0}function hj(a){a=a|0;var b=0;b=i;i=i+8|0;i=b;return c[a+284>>2]|0}function ij(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;do{if((c[d+288>>2]|0)!=0){if(!((c[d+288>>2]|0)>>>0>=(c[d+296>>2]|0)>>>0)){break}ye[c[(c[d+144>>2]|0)+52>>2]&31](c[d+144>>2]|0,c[d+296>>2]|0,c[d+288>>2]|0,d+408|0);c[d+296>>2]=c[d+288>>2]}}while(0);i=b;return(c[d+408>>2]|0)+1|0}function jj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+16|0;j=g+48|0;k=b;b=d;c[h>>2]=e;e=f;if((a[b+72|0]|0)!=0){ue[c[k+80>>2]&15](c[k+4>>2]|0,c[h>>2]|0,e-(c[h>>2]|0)|0);i=g;return}f=k;if((b|0)==(c[k+144>>2]|0)){l=f+288|0;m=k+292|0}else{l=c[f+300>>2]|0;m=(c[k+300>>2]|0)+4|0}do{c[j>>2]=c[k+44>>2];Vd[c[b+60>>2]&31](b,h,e,j,c[k+48>>2]|0);c[m>>2]=c[h>>2];ue[c[k+80>>2]&15](c[k+4>>2]|0,c[k+44>>2]|0,(c[j>>2]|0)-(c[k+44>>2]|0)|0);c[l>>2]=c[h>>2];}while((c[h>>2]|0)!=(e|0));i=g;return}function kj(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;if(d>>>0>0&d>>>0<41){e=c[10984+(d<<2)>>2]|0;f=e;i=b;return f|0}else{e=0;f=e;i=b;return f|0}return 0}function lj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;do{if((c[d+4>>2]|0)!=0){a=d;if((c[d+16>>2]|0)==0){c[d>>2]=c[a+4>>2];c[d+4>>2]=c[c[d+4>>2]>>2];c[c[d>>2]>>2]=0;c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);c[d+12>>2]=c[d+16>>2];e=1;f=e;i=b;return f|0}if(((c[a+8>>2]|0)-(c[d+16>>2]|0)|0)>=(c[(c[d+4>>2]|0)+4>>2]|0)){break}a=c[c[d+4>>2]>>2]|0;c[c[d+4>>2]>>2]=c[d>>2];c[d>>2]=c[d+4>>2];c[d+4>>2]=a;GS((c[d>>2]|0)+8|0,c[d+16>>2]|0,(c[d+8>>2]|0)-(c[d+16>>2]|0)|0)|0;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);e=1;f=e;i=b;return f|0}}while(0);do{if((c[d>>2]|0)!=0){if((c[d+16>>2]|0)!=((c[d>>2]|0)+8|0)){g=11;break}a=(c[d+8>>2]|0)-(c[d+16>>2]|0)<<1;h=ne[c[(c[d+20>>2]|0)+4>>2]&63](c[d>>2]|0,8+a|0)|0;if((h|0)!=0){c[d>>2]=h;c[(c[d>>2]|0)+4>>2]=a;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+a;break}e=0;f=e;i=b;return f|0}else{g=11}}while(0);if((g|0)==11){g=(c[d+8>>2]|0)-(c[d+16>>2]|0)|0;if((g|0)<1024){g=1024}else{g=g<<1}a=$d[c[c[d+20>>2]>>2]&127](8+g|0)|0;if((a|0)==0){e=0;f=e;i=b;return f|0}c[a+4>>2]=g;c[a>>2]=c[d>>2];c[d>>2]=a;if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){GS(a+8|0,c[d+16>>2]|0,(c[d+12>>2]|0)-(c[d+16>>2]|0)|0)|0}c[d+12>>2]=a+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=a+8;c[d+8>>2]=a+8+g}e=1;f=e;i=b;return f|0}function mj(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;a=b;c[e>>2]=c[a>>2];c[e+4>>2]=(c[e>>2]|0)+(c[a+8>>2]<<2);i=d;return}function nj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+24|0;d=a;while(1){if((c[d>>2]|0)==(c[d+4>>2]|0)){e=5;break}a=d;f=c[a>>2]|0;c[a>>2]=f+4;g=c[f>>2]|0;if((g|0)!=0){e=4;break}}if((e|0)==4){h=g;j=h;i=b;return j|0}else if((e|0)==5){h=0;j=h;i=b;return j|0}return 0}function oj(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+136|0;j=b;b=e;e=f;f=g;a:do{if((c[b+8>>2]|0)==0){if((f|0)==0){k=0;l=k;i=h;return l|0}a[b+4|0]=6;c[b+8>>2]=64;g=c[b+8>>2]<<2;c[b>>2]=$d[c[c[b+16>>2]>>2]&127](g)|0;m=b;if((c[b>>2]|0)!=0){IS(c[m>>2]|0,0,g|0)|0;g=pj(j,e)|0;n=g&(c[b+8>>2]|0)-1;break}c[m+8>>2]=0;k=0;l=k;i=h;return l|0}else{m=pj(j,e)|0;g=(c[b+8>>2]|0)-1|0;o=0;n=m&g;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break}if((qj(e,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0)<<24>>24!=0){p=10;break}if(!(o<<24>>24!=0)){o=((m&~g)>>>((d[b+4|0]|0)-1|0)&g>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+((c[b+8>>2]|0)-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}if((p|0)==10){k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}if((f|0)==0){k=0;l=k;i=h;return l|0}if(((c[b+12>>2]|0)>>>((d[b+4|0]|0)-1|0)|0)==0){break}g=(d[b+4|0]|0)+1&255;q=1<<(g&255);r=q-1|0;s=q<<2;t=$d[c[c[b+16>>2]>>2]&127](s)|0;if((t|0)==0){k=0;l=k;i=h;return l|0}IS(t|0,0,s|0)|0;n=0;while(1){if(!(n>>>0<(c[b+8>>2]|0)>>>0)){break}if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){s=pj(j,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0;u=s&r;o=0;while(1){if((c[t+(u<<2)>>2]|0)==0){break}if(!(o<<24>>24!=0)){o=((s&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(u>>>0<(o&255)>>>0){u=u+(q-(o&255))|0;continue}else{u=u-(o&255)|0;continue}}c[t+(u<<2)>>2]=c[(c[b>>2]|0)+(n<<2)>>2]}n=n+1|0}Yd[c[(c[b+16>>2]|0)+8>>2]&255](c[b>>2]|0);c[b>>2]=t;a[b+4|0]=g;c[b+8>>2]=q;n=m&r;o=0;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break a}if(!(o<<24>>24!=0)){o=((m&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+(q-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}}}while(0);j=$d[c[c[b+16>>2]>>2]&127](f)|0;c[(c[b>>2]|0)+(n<<2)>>2]=j;if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){IS(c[(c[b>>2]|0)+(n<<2)>>2]|0,0,f|0)|0;c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]=e;e=b+12|0;c[e>>2]=(c[e>>2]|0)+1;k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}else{k=0;l=k;i=h;return l|0}return 0}function pj(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+24|0;g=e;e=c[b+496>>2]|0;while(1){h=e;if((a[g]|0)==0){break}b=g;g=b+1|0;e=h*1000003^d[b]}i=f;return h|0}function qj(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;while(1){if((a[e]|0)!=(a[b]|0)){f=6;break}if((a[e]|0)==0){f=4;break}e=e+1|0;b=b+1|0}if((f|0)==4){g=1;h=g;i=d;return h|0}else if((f|0)==6){g=0;h=g;i=d;return h|0}return 0}function rj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;a=0;while(1){e=c[(c[d+16>>2]|0)+8>>2]|0;if(!(a>>>0<(c[d+8>>2]|0)>>>0)){break}Yd[e&255](c[(c[d>>2]|0)+(a<<2)>>2]|0);a=a+1|0}Yd[e&255](c[d>>2]|0);i=b;return}function sj(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+96|0;j=b;b=d;d=e;e=f;f=g;g=0;k=1;l=1;do{if((a[e]|0)==0){if((c[b>>2]|0)==0){break}m=28;n=m;i=h;return n|0}}while(0);do{if((c[b>>2]|0)!=0){if((a[c[b>>2]|0]|0)!=120){break}if((a[(c[b>>2]|0)+1|0]|0)!=109){break}if((a[(c[b>>2]|0)+2|0]|0)!=108){break}do{if((a[(c[b>>2]|0)+3|0]|0)==110){if((a[(c[b>>2]|0)+4|0]|0)!=115){break}if((a[(c[b>>2]|0)+5|0]|0)!=0){break}m=39;n=m;i=h;return n|0}}while(0);if((a[(c[b>>2]|0)+3|0]|0)!=0){break}g=1}}while(0);o=0;while(1){p=(k&255|0)!=0;if((a[e+o|0]|0)==0){break}do{if(p){if((o|0)<=36){if((a[e+o|0]|0)==(a[12568+o|0]|0)){break}}k=0}}while(0);do{if(!(g<<24>>24!=0)){if((l&255|0)==0){break}if((o|0)<=29){if((a[e+o|0]|0)==(a[12608+o|0]|0)){break}}l=0}}while(0);o=o+1|0}if(p){q=(o|0)==36}else{q=0}k=q&1;if((l&255|0)!=0){r=(o|0)==29}else{r=0}l=r&1;if((g&255|0)!=(k&255|0)){m=(g&255|0)!=0?38:40;n=m;i=h;return n|0}if(l<<24>>24!=0){m=40;n=m;i=h;return n|0}if((a[j+472|0]|0)!=0){o=o+1|0}l=j;do{if((c[j+376>>2]|0)!=0){s=c[l+376>>2]|0;do{if((o|0)>(c[s+24>>2]|0)){g=ne[c[j+16>>2]&63](c[s+16>>2]|0,o+24|0)|0;if((g|0)!=0){c[s+16>>2]=g;c[s+24>>2]=o+24;break}m=1;n=m;i=h;return n|0}}while(0);c[j+376>>2]=c[s+4>>2]}else{s=$d[c[l+12>>2]&127](28)|0;if((s|0)==0){m=1;n=m;i=h;return n|0}c[s+16>>2]=$d[c[j+12>>2]&127](o+24|0)|0;if((c[s+16>>2]|0)!=0){c[s+24>>2]=o+24;break}Yd[c[j+20>>2]&255](s);m=1;n=m;i=h;return n|0}}while(0);c[s+20>>2]=o;GS(c[s+16>>2]|0,e|0,o|0)|0;if((a[j+472|0]|0)!=0){a[(c[s+16>>2]|0)+(o-1)|0]=a[j+472|0]|0}c[s>>2]=b;c[s+12>>2]=d;c[s+8>>2]=c[b+4>>2];do{if((a[e]|0)==0){if((b|0)!=((c[j+356>>2]|0)+152|0)){t=52;break}c[b+4>>2]=0}else{t=52}}while(0);if((t|0)==52){c[b+4>>2]=s}c[s+4>>2]=c[f>>2];c[f>>2]=s;do{if((d|0)!=0){if((c[j+100>>2]|0)==0){break}ue[c[j+100>>2]&15](c[j+4>>2]|0,c[b>>2]|0,(c[b+4>>2]|0)!=0?e:0)}}while(0);m=0;n=m;i=h;return n|0}function tj(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=b;if((be[((a[e+236|0]&255|0)!=0?32:33)&63](e+148|0,e+144|0,c[e+232>>2]|0)|0)!=0){f=0;g=f;i=d;return g|0}else{f=$j(e,c[e+232>>2]|0)|0;g=f;i=d;return g|0}return 0}function uj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+32|0;j=b;b=d;d=e;c[h>>2]=b;e=xe[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=vj(j,c[j+144>>2]|0,b,d,e,c[h>>2]|0,f,((a[j+484|0]|0)!=0^1)&1)|0;i=g;return k|0}



function ze(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function Ae(){return i|0}function Be(a){a=a|0;i=a}function Ce(a,b){a=a|0;b=b|0;if((u|0)==0){u=a;v=b}}function De(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function Ee(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function Fe(a){a=a|0;J=a}function Ge(a){a=a|0;K=a}function He(a){a=a|0;L=a}function Ie(a){a=a|0;M=a}function Je(a){a=a|0;N=a}function Ke(a){a=a|0;O=a}function Le(a){a=a|0;P=a}function Me(a){a=a|0;Q=a}function Ne(a){a=a|0;R=a}function Oe(a){a=a|0;S=a}function Pe(a){a=a|0;var b=0,d=0;b=i;Tr(a)|0;d=a+540|0;$d[c[(c[d>>2]|0)+40>>2]&127](a)|0;$d[c[(c[d>>2]|0)+28>>2]&127](a)|0;$d[c[(c[d>>2]|0)+32>>2]&127](a)|0;$d[c[(c[d>>2]|0)+48>>2]&127](a)|0;$d[c[(c[d>>2]|0)+52>>2]&127](a)|0;yq(a);i=b;return}function Qe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+24|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[v>>2]=0;y=b+240|0;z=d;h[z>>3]=+h[y>>3];if((c[2]|0)==0){A=0}else{B=c[b+88>>2]|0;C=ES(B|0)|0;D=aS(C+11|0)|0;PS(D|0,B|0,C|0)|0;B=D+C+0|0;C=16|0;E=B+11|0;do{a[B]=a[C]|0;B=B+1|0;C=C+1|0}while((B|0)<(E|0));C=hc(D|0,32)|0;if((C|0)==0){B=Nd(c[(Lc()|0)>>2]|0)|0;c[u>>2]=D;c[u+4>>2]=B;Tn(23,0,40,u);Vc(0)|0;F=0}else{F=C}bS(D);A=F}F=b+248|0;D=b+536|0;C=b;u=b+4|0;B=d+36|0;E=d+16|0;G=b+256|0;H=d+8|0;I=d+24|0;J=d+32|0;K=b+540|0;L=d+48|0;M=c[t>>2]|0;N=v;O=w;P=b+64|0;Q=b+72|0;R=x;S=0;T=A;while(1){if(!(+h[z>>3]<+h[F>>3])){U=T;V=0;break}se[c[22132>>2]&7]()|0;c[(c[D>>2]|0)+84>>2]=1;if((c[2]|0)!=0){if(((c[Q>>2]|0)+(c[P>>2]|0)|0)>0){A=0;do{Wo(A+9|0);A=A+1|0;}while((A|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0))}Wo(2);Vo(2)}Ko(c[C>>2]|0,1,c[u>>2]|0);if((c[B>>2]|0)==1){A=s;h[k>>3]=+h[z>>3]- +h[E>>3];c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Rn(23,0,104,s);W=S}else{W=S+1|0}X=+h[y>>3];h[H>>3]=X+ +(W>>>0)*(+h[F>>3]-X)/+(c[G>>2]|0)- +h[z>>3];lq(b,d);X=+h[z>>3];Y=+h[H>>3];A=r;h[k>>3]=X;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+8|0;h[k>>3]=X+Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+16|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Rn(23,1,144,r);Z=Br(b,d)|0;if((c[I>>2]|0)==5){U=T;V=0;break}Pe(b);zq(b);if((c[21324>>2]|0)!=0){Yd[c[5446]&255](23)}if((c[2]|0)!=0){Vo(4)}A=nq(b,c[J>>2]|0,z,d)|0;if((A|0)>0){c[(c[D>>2]|0)+84>>2]=4;Y=+h[z>>3];c[q>>2]=(A|0)==1?224:232;A=q+4|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Rn(7,1,200,q);if((c[77708>>2]|0)==0){Zd[c[62396>>2]&63](62376,b)}pq(b,c[J>>2]|0,z,d);if((c[21260>>2]|0)!=0){Yd[c[5446]&255](7)}c[(c[D>>2]|0)+84>>2]=1;c[B>>2]=1;Dq(b)}else{h[E>>3]=+h[z>>3];c[B>>2]=0}if((c[2]|0)!=0){Yo(4)}if((Nr(b,1,1)|0)!=0){c[B>>2]=1;Dq(b)}$d[c[(c[K>>2]|0)+88>>2]&127](b)|0;yq(b);Hq(b);zq(b);do{if((T|0)==0){_=0}else{Vo(7);Yo(2);A=(pc(N|0,4,1,T|0)|0)==1;c[v>>2]=(c[v>>2]|0)+1;do{if(A){$=(pc(c[c[u>>2]>>2]|0,8,1,T|0)|0)==1;h[w>>3]=+Qo(2);if(!$){aa=0;break}aa=(pc(O|0,8,1,T|0)|0)==1|0}else{h[w>>3]=+Qo(2);aa=0}}while(0);A=c[P>>2]|0;$=c[Q>>2]|0;if(($+A|0)>0){ba=aa;ca=0;while(1){c[x>>2]=Lo(ca+9|0)|0;if((ba|0)==0){da=0}else{da=(pc(R|0,4,1,T|0)|0)==1|0}ea=ca+1|0;fa=c[P>>2]|0;ga=c[Q>>2]|0;if((ea|0)<(ga+fa|0)){ba=da;ca=ea}else{ha=ga;ia=fa;ja=da;break}}}else{ha=$;ia=A;ja=aa}if((ha+ia|0)>0){ca=ja;ba=0;while(1){h[w>>3]=+Qo(ba+9|0);if((ca|0)==0){ka=0}else{ka=(pc(O|0,8,1,T|0)|0)==1|0}fa=ba+1|0;if((fa|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0)){ca=ka;ba=fa}else{la=ka;break}}}else{la=ja}Yo(7);if((la|0)!=0){_=T;break}c[p>>2]=Nd(c[(Lc()|0)>>2]|0)|0;Tn(23,0,240,p);Vc(T|0)|0;_=0}}while(0);if((c[77708>>2]|0)==0){ma=47}else{ba=c[B>>2]|0;if((ba|0)==0){ma=47}else{na=ba}}if((ma|0)==47){ma=0;Zd[c[62396>>2]&63](62376,b);na=c[B>>2]|0}do{if((na|0)==1){if((c[I>>2]|0)!=3){break}ba=c[L>>2]|0;ca=c[ba+8>>2]|0;A=c[ba+4>>2]|0;c[A>>2]=(c[A>>2]|0)+(c[ca>>2]|0);ba=A+4|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+4>>2]|0);ba=A+8|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+8>>2]|0);ba=A+12|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+12>>2]|0);ba=A+16|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+16>>2]|0)}}while(0);if((c[16994]|0)!=0){ca=f;ba=67984;c[ca+0>>2]=c[ba+0>>2];c[ca+4>>2]=c[ba+4>>2];c[ca+8>>2]=c[ba+8>>2];c[ca+12>>2]=c[ba+12>>2];c[ca+16>>2]=c[ba+16>>2];c[ca+20>>2]=c[ba+20>>2];Jn(M,f);Jd(10,M|0)|0;ba=c[17002]|0;ca=o;h[k>>3]=+h[c[c[u>>2]>>2]>>3];c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];c[o+8>>2]=ba;Rn(1,0,320,o);h[F>>3]=+h[z>>3]}if((Z|0)!=0){ma=57;break}if((kr(b,0)|0)!=0){ma=58;break}if((cr(b,0)|0)!=0){ma=58;break}if((Uq(b,0)|0)==0){S=W;T=_}else{ma=58;break}}do{if((ma|0)==57){T=n;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Rn(1,0,376,n);U=_;V=Z+ -1|0}else if((ma|0)==58){if((kr(b,0)|0)!=0){T=m;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Rn(1,0,448,m);U=_;V=-2;break}if((cr(b,0)|0)!=0){T=l;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Rn(1,0,536,l);U=_;V=-3;break}T=(Uq(b,0)|0)==0;Y=+h[z>>3];if(T){T=g;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Rn(1,0,712,g);U=_;V=-1;break}else{T=j;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Rn(1,0,624,j);U=_;V=-3;break}}}while(0);if((U|0)==0){i=e;return V|0}Vc(U|0)|0;i=e;return V|0}function Re(a){a=a|0;i=i;return 0}function Se(a){a=a|0;i=i;return 0}function Te(a){a=a|0;i=i;return 0}function Ue(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0;d=i;if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+11|0]|0;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;o=n;p=o+2|0;q=p;a[q]=f;i=d;return}if((a[b+318|0]|0)==0){r=c[b+416>>2]|0;s=+h[r+616>>3];t=b+4|0;u=+h[c[c[t>>2]>>2]>>3];v=u- +h[r+632>>3];do{if(s!=0.0){w=v/s}else{if(v==0.0){w=v;break}w=v/+Xn(c[b+536>>2]|0,s,872,864,u,(a[b+319|0]|0)!=0|0)}}while(0);u=+(Rq(w,0,b)|0);r=Pq(u,+(c[c[b+404>>2]>>2]|0))|0;a[(c[b+352>>2]|0)+11|0]=r;e=t;f=r;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;o=n;p=o+2|0;q=p;a[q]=f;i=d;return}else{r=a[(c[b+356>>2]|0)+11|0]|0;t=c[b+416>>2]|0;u=+h[t+616>>3];x=b+4|0;w=+h[c[c[x>>2]>>2]>>3];s=w- +h[t+632>>3];do{if(u!=0.0){y=s/u}else{if(s==0.0){y=s;break}y=s/+Xn(c[b+536>>2]|0,u,872,864,w,(a[b+319|0]|0)!=0|0)}}while(0);w=+(Rq(y,0,b)|0);t=Pq(w,+(c[c[b+404>>2]>>2]|0))|0;a[(c[b+352>>2]|0)+11|0]=t;e=x;f=r;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;o=n;p=o+2|0;q=p;a[q]=f;i=d;return}}function Ve(b){b=b|0;var d=0,e=0;d=i;if((a[b+312|0]|0)!=0){h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+48>>3]=+h[(c[b+400>>2]|0)+48>>3];i=d;return}e=c[c[b+4>>2]>>2]|0;do{if((a[(c[e+16>>2]|0)+2|0]|0)!=0){if((a[(c[b+408>>2]|0)+2|0]|0)!=0){break}h[(c[e+8>>2]|0)+48>>3]=+h[e>>3];i=d;return}}while(0);h[(c[e+8>>2]|0)+48>>3]=+h[(c[b+400>>2]|0)+48>>3];i=d;return}function We(b){b=b|0;var d=0,e=0;d=i;if((a[b+312|0]|0)!=0){c[c[(c[c[b+4>>2]>>2]|0)+12>>2]>>2]=c[c[b+404>>2]>>2];i=d;return}e=c[c[b+4>>2]>>2]|0;do{if((a[(c[e+16>>2]|0)+2|0]|0)!=0){if((a[(c[b+408>>2]|0)+2|0]|0)!=0){break}c[c[e+12>>2]>>2]=(c[c[b+404>>2]>>2]|0)+1;i=d;return}}while(0);c[c[e+12>>2]>>2]=c[c[b+404>>2]>>2];i=d;return}function Xe(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=b+4|0;g=a[(c[b+356>>2]|0)+9|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){k=a[(c[b+356>>2]|0)+9|0]|0;l=b+4|0;m=Lq(+h[c[c[l>>2]>>2]>>3],+h[(c[b+416>>2]|0)+632>>3],a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=m;f=l;g=k;break}else{k=b+4|0;l=Lq(+h[c[c[k>>2]>>2]>>3],+h[(c[b+416>>2]|0)+632>>3],a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=l;f=k;g=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+9|0]|0;l=b+4|0;k=Nq(+h[c[c[l>>2]>>2]>>3],+h[(c[b+416>>2]|0)+632>>3])|0;a[(c[b+352>>2]|0)+9|0]=k;f=l;g=j;break}else{j=b+4|0;l=Nq(+h[c[c[j>>2]>>2]>>3],+h[(c[b+416>>2]|0)+632>>3])|0;a[(c[b+352>>2]|0)+9|0]=l;f=j;g=l;break}}}}while(0);l=b+420|0;j=Pq(+(c[c[l>>2]>>2]|0),0.0)|0;k=Qq(+(c[c[(c[c[f>>2]>>2]|0)+12>>2]>>2]|0),+(c[c[l>>2]>>2]|0))|0;do{if(g<<24>>24==0){if((c[c[l>>2]>>2]|0)==0){n=0.0;break}if(k<<24>>24!=0&j<<24>>24!=0){n=0.0;break}do{if((a[e]|0)==0){o=a[(c[b+356>>2]|0)+10|0]|0}else{m=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(m){p=a[(c[b+356>>2]|0)+10|0]|0;q=c[c[f>>2]>>2]|0;r=c[q+8>>2]|0;s=Lq(+h[q>>3],+h[r+48>>3]+ +h[r+312>>3],a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=s;o=p;break}else{p=c[c[f>>2]>>2]|0;s=c[p+8>>2]|0;r=Lq(+h[p>>3],+h[s+48>>3]+ +h[s+312>>3],a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=r;o=r;break}}else{if(m){m=a[(c[b+356>>2]|0)+10|0]|0;r=c[c[f>>2]>>2]|0;s=c[r+8>>2]|0;p=Nq(+h[r>>3],+h[s+48>>3]+ +h[s+312>>3])|0;a[(c[b+352>>2]|0)+10|0]=p;o=m;break}else{m=c[c[f>>2]>>2]|0;p=c[m+8>>2]|0;s=Nq(+h[m>>3],+h[p+48>>3]+ +h[p+312>>3])|0;a[(c[b+352>>2]|0)+10|0]=s;o=s;break}}}}while(0);if(o<<24>>24==0){n=0.0;break}n=+h[(c[b+416>>2]|0)+600>>3]}else{n=0.0}}while(0);h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+56>>3]=n+ +h[(c[b+416>>2]|0)+624>>3];i=d;return}function Ye(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+124>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+160>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+160|0;h[c[g+128>>2]>>3]=+h[j>>3];k=+lr(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+160>>3]);e=c[f>>2]|0;h[c[e+132>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+124>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+152>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+152|0;h[(c[e+128>>2]|0)+8>>3]=+h[g>>3];k=+lr(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+152>>3]);j=c[f>>2]|0;h[(c[j+132>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+124>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+176>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+176|0;h[(c[j+128>>2]|0)+16>>3]=+h[e>>3];k=+lr(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+176>>3]);g=c[f>>2]|0;h[(c[g+132>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+124>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+216>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+216|0;h[(c[g+128>>2]|0)+24>>3]=+h[j>>3];k=+lr(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+216>>3]);h[(c[(c[f>>2]|0)+132>>2]|0)+24>>3]=k;jr(a,1)|0;e=c[(c[f>>2]|0)+124>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+160>>3]=+h[e>>3];h[f+152>>3]=+h[e+8>>3];h[f+176>>3]=+h[e+16>>3];h[f+216>>3]=+h[e+24>>3];Pf(a);Qf(a);Rf(a);Sf(a);Tf(a);Uf(a);Vf(a);Wf(a);Xf(a);Yf(a);Zf(a);_f(a);i=b;return}function Ze(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+224>>3]=+h[b+240>>3]*+h[b+232>>3];i=i;return}function _e(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+184>>3]=+h[b+208>>3]*+h[b+200>>3];i=i;return}function $e(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+120>>3]=-+h[b+128>>3]- +h[b+232>>3];i=i;return}function af(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+4|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+4|0]|0;k=Mq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],+h[(c[b+416>>2]|0)+328>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=k;f=j;break}else{j=Mq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],+h[(c[b+416>>2]|0)+328>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+4|0]|0;j=Pq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],+h[(c[b+416>>2]|0)+328>>3])|0;a[(c[b+352>>2]|0)+4|0]=j;f=g;break}else{g=Pq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],+h[(c[b+416>>2]|0)+328>>3])|0;a[(c[b+352>>2]|0)+4|0]=g;f=g;break}}}}while(0);do{if((a[e]|0)==0){l=a[(c[b+356>>2]|0)+5|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+5|0]|0;k=Mq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+152>>3],+h[(c[b+416>>2]|0)+296>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=k;l=j;break}else{j=Mq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+152>>3],+h[(c[b+416>>2]|0)+296>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=j;l=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+5|0]|0;j=Pq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+152>>3],+h[(c[b+416>>2]|0)+296>>3])|0;a[(c[b+352>>2]|0)+5|0]=j;l=g;break}else{g=Pq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+152>>3],+h[(c[b+416>>2]|0)+296>>3])|0;a[(c[b+352>>2]|0)+5|0]=g;l=g;break}}}}while(0);if((l|f)<<24>>24==0){m=0.0;n=b;o=n+4|0;p=o;q=c[p>>2]|0;r=c[q>>2]|0;s=r;t=s+8|0;u=t;v=c[u>>2]|0;w=v;x=w+136|0;y=x;h[y>>3]=m;i=d;return}m=+h[(c[b+416>>2]|0)+392>>3];n=b;o=n+4|0;p=o;q=c[p>>2]|0;r=c[q>>2]|0;s=r;t=s+8|0;u=t;v=c[u>>2]|0;w=v;x=w+136|0;y=x;h[y>>3]=m;i=d;return}function bf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;d=a+4|0;e=a+416|0;a=(Nq(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+232>>3],+h[(c[e>>2]|0)+352>>3]*.95)|0)<<24>>24==0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;do{if(a){g=(Nq(+h[f+232>>3],+h[(c[e>>2]|0)+352>>3]*.95+.001)|0)<<24>>24==0;j=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(g){k=j;l=+h[j+152>>3]*10.0;break}else{k=j;l=+h[j+152>>3]*(+h[j+232>>3]+ +h[(c[e>>2]|0)+352>>3]*-.95)*1.0e4;break}}else{k=f;l=0.0}}while(0);h[k+144>>3]=l+ +h[k+136>>3];i=b;return}function cf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0,t=0.0;d=i;do{if((a[b+314|0]|0)==0){e=a[(c[b+356>>2]|0)+3|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){g=a[(c[b+356>>2]|0)+3|0]|0;j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=Mq(+h[j+144>>3]- +h[j+8>>3],0.0,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=k;e=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=Mq(+h[g+144>>3]- +h[g+8>>3],0.0,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=k;e=k;break}}else{if(f){f=a[(c[b+356>>2]|0)+3|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=Pq(+h[k+144>>3]- +h[k+8>>3],0.0)|0;a[(c[b+352>>2]|0)+3|0]=g;e=f;break}else{f=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=Pq(+h[f+144>>3]- +h[f+8>>3],0.0)|0;a[(c[b+352>>2]|0)+3|0]=g;e=g;break}}}}while(0);g=e<<24>>24!=0;e=c[b+416>>2]|0;if(g){l=+h[e+360>>3]*1.87}else{l=+h[e+368>>3]*.638}f=b+4|0;k=c[c[f>>2]>>2]|0;j=c[k+8>>2]|0;m=+h[j+144>>3]- +h[j+8>>3];if(l!=0.0){if(g){n=+h[e+360>>3]*1.87}else{n=+h[e+368>>3]*.638}o=j;p=m/n;q=o;r=q+32|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){o=j;p=m;q=o;r=q+32|0;s=r;h[s>>3]=p;i=d;return}if(g){t=+h[e+360>>3]*1.87}else{t=+h[e+368>>3]*.638}n=m/+Xn(c[b+536>>2]|0,t,920,912,+h[k>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[f>>2]>>2]|0)+8>>2]|0;p=n;q=o;r=q+32|0;s=r;h[s>>3]=p;i=d;return}function df(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+7|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+7|0]|0;k=Mq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+80>>3],+h[(c[b+416>>2]|0)+464>>3],a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=k;f=j;break}else{j=Mq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+80>>3],+h[(c[b+416>>2]|0)+464>>3],a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+7|0]|0;j=Pq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+80>>3],+h[(c[b+416>>2]|0)+464>>3])|0;a[(c[b+352>>2]|0)+7|0]=j;f=g;break}else{g=Pq(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+80>>3],+h[(c[b+416>>2]|0)+464>>3])|0;a[(c[b+352>>2]|0)+7|0]=g;f=g;break}}}}while(0);do{if((a[e]|0)==0){l=a[(c[b+356>>2]|0)+8|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+8|0]|0;k=Mq(-+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+152>>3],+h[(c[b+416>>2]|0)+432>>3],a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=k;l=j;break}else{j=Mq(-+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+152>>3],+h[(c[b+416>>2]|0)+432>>3],a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=j;l=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+8|0]|0;j=Pq(-+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+152>>3],+h[(c[b+416>>2]|0)+432>>3])|0;a[(c[b+352>>2]|0)+8|0]=j;l=g;break}else{g=Pq(-+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+152>>3],+h[(c[b+416>>2]|0)+432>>3])|0;a[(c[b+352>>2]|0)+8|0]=g;l=g;break}}}}while(0);if((l|f)<<24>>24==0){m=0.0;n=b;o=n+4|0;p=o;q=c[p>>2]|0;r=c[q>>2]|0;s=r;t=s+8|0;u=t;v=c[u>>2]|0;w=v;x=w+88|0;y=x;h[y>>3]=m;i=d;return}m=+h[(c[b+416>>2]|0)+528>>3];n=b;o=n+4|0;p=o;q=c[p>>2]|0;r=c[q>>2]|0;s=r;t=s+8|0;u=t;v=c[u>>2]|0;w=v;x=w+88|0;y=x;h[y>>3]=m;i=d;return}function ef(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+248>>3]=+h[b+120>>3]+ +h[b+80>>3];i=i;return}function ff(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+296>>3]=+h[b+16>>3]- +h[b+56>>3]- +h[b+248>>3];i=i;return}function gf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=a+416|0;a=(Nq(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+200>>3],+h[(c[e>>2]|0)+488>>3]*.95)|0)<<24>>24==0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;do{if(a){if((Nq(+h[f+200>>3],+h[(c[e>>2]|0)+488>>3]*.95+.001)|0)<<24>>24==0){g=c[(c[c[d>>2]>>2]|0)+8>>2]|0;j=g;k=+h[g+152>>3]*-10.0;break}else{g=c[(c[c[d>>2]>>2]|0)+8>>2]|0;j=g;k=(+h[(c[e>>2]|0)+488>>3]*.95- +h[g+200>>3])*+h[g+152>>3]*1.0e4;break}}else{j=f;k=0.0}}while(0);h[j+96>>3]=k+ +h[j+88>>3];i=b;return}function hf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0,r=0,s=0,t=0.0;d=i;do{if((a[b+314|0]|0)==0){e=a[(c[b+356>>2]|0)+6|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){g=a[(c[b+356>>2]|0)+6|0]|0;j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=Mq(+h[j+96>>3]- +h[j>>3],0.0,a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=k;e=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=Mq(+h[g+96>>3]- +h[g>>3],0.0,a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=k;e=k;break}}else{if(f){f=a[(c[b+356>>2]|0)+6|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=Pq(+h[k+96>>3]- +h[k>>3],0.0)|0;a[(c[b+352>>2]|0)+6|0]=g;e=f;break}else{f=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=Pq(+h[f+96>>3]- +h[f>>3],0.0)|0;a[(c[b+352>>2]|0)+6|0]=g;e=g;break}}}}while(0);g=e<<24>>24!=0;e=c[b+416>>2]|0;if(g){l=+h[e+496>>3]*1.87}else{l=+h[e+504>>3]*.638}f=b+4|0;k=c[c[f>>2]>>2]|0;j=c[k+8>>2]|0;m=+h[j+96>>3]- +h[j>>3];if(l!=0.0){if(g){n=+h[e+496>>3]*1.87}else{n=+h[e+504>>3]*.638}o=j;p=m/n;q=o;r=q+24|0;s=r;h[s>>3]=p;i=d;return}if(m==0.0){o=j;p=m;q=o;r=q+24|0;s=r;h[s>>3]=p;i=d;return}if(g){t=+h[e+496>>3]*1.87}else{t=+h[e+504>>3]*.638}n=m/+Xn(c[b+536>>2]|0,t,1080,1072,+h[k>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[f>>2]>>2]|0)+8>>2]|0;p=n;q=o;r=q+24|0;s=r;h[s>>3]=p;i=d;return}function jf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+112>>3]=+h[b+72>>3]*+h[b+152>>3]+ +h[b+200>>3]*+h[b+192>>3];i=i;return}function kf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+168>>3]=+h[b+128>>3]*+h[b+152>>3]+ +h[b+232>>3]*+h[b+160>>3];i=i;return}function lf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;do{if((a[b+314|0]|0)==0){e=a[c[b+356>>2]|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){g=a[c[b+356>>2]|0]|0;j=Lq(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+112>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=j;e=g;break}else{g=Lq(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+112>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=g;e=g;break}}else{if(f){f=a[c[b+356>>2]|0]|0;g=Nq(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+112>>3])|0;a[c[b+352>>2]|0]=g;e=f;break}else{f=Nq(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+112>>3])|0;a[c[b+352>>2]|0]=f;e=f;break}}}}while(0);f=c[b+416>>2]|0;if(e<<24>>24==0){e=c[c[b+4>>2]>>2]|0;k=+Y(+(+h[f+96>>3]+ +h[f+88>>3]*(+h[e>>3]- +h[f+112>>3])*6.283185307179586));l=e;m=k*+h[f+80>>3];n=f;o=n+104|0;p=o;q=+h[p>>3];r=m+q;s=l;t=s+8|0;u=t;v=c[u>>2]|0;w=v;x=w+256|0;y=x;h[y>>3]=r;i=d;return}else{l=c[c[b+4>>2]>>2]|0;m=0.0;n=f;o=n+104|0;p=o;q=+h[p>>3];r=m+q;s=l;t=s+8|0;u=t;v=c[u>>2]|0;w=v;x=w+256|0;y=x;h[y>>3]=r;i=d;return}}function mf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+272>>3]=+h[b+304>>3]*+h[b+16>>3];i=i;return}function nf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+264>>3]=+h[b+272>>3]*+h[b+16>>3];i=i;return}function of(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+280>>3]=+h[b+272>>3]+ +h[b+256>>3];i=i;return}function pf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+288>>3]=+h[b+152>>3]- +h[b+280>>3];i=i;return}function qf(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[c[b+416>>2]>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+288>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+40|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+40|0;p=o;h[p>>3]=m;i=d;return}q=k/+Xn(c[b+536>>2]|0,e,1248,1240,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+40|0;p=o;h[p>>3]=m;i=d;return}function rf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((Qq(+h[f+24>>3]*(+h[f+32>>3]- +h[f+16>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[17498]|0;g=d;j=1336;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];ye[a&31](f,d,1360,e);i=b;return}function sf(b){b=b|0;var c=0;c=i;a[b+315|0]=0;a[b+314|0]=1;Ue(b);Ve(b);We(b);Xe(b);Ye(b);Ze(b);_e(b);$e(b);af(b);bf(b);cf(b);df(b);ef(b);ff(b);gf(b);hf(b);jf(b);kf(b);lf(b);mf(b);nf(b);of(b);pf(b);qf(b);rf(b);i=c;return 0}function tf(b){b=b|0;var c=0;c=i;a[b+314|0]=0;uf(b);i=c;return 0}function uf(a){a=a|0;var b=0;b=i;Ue(a);Xe(a);Ye(a);af(a);bf(a);cf(a);df(a);gf(a);hf(a);lf(a);mf(a);of(a);pf(a);qf(a);i=b;return}function vf(a,b){a=a|0;b=+b;i=i;return 0}function wf(a){a=a|0;var b=0;b=i;i=i+8|0;Un(c[a+536>>2]|0,(a|0)!=0|0,1608,b);c[a+540>>2]=1416;c[a+84>>2]=1640;c[a+88>>2]=1640;c[a+92>>2]=1696;c[a+96>>2]=1776;c[a+100>>2]=0;c[a+60>>2]=0;c[a+112>>2]=3;c[a+116>>2]=42;c[a+120>>2]=1;c[a+124>>2]=2;c[a+128>>2]=3;c[a+132>>2]=0;c[a+136>>2]=80;c[a+140>>2]=1;c[a+144>>2]=6;c[a+148>>2]=0;c[a+152>>2]=0;c[a+156>>2]=0;c[a+232>>2]=5;c[a+216>>2]=47;c[a+220>>2]=0;c[a+224>>2]=0;c[a+228>>2]=0;c[a+160>>2]=11;c[a+104>>2]=0;c[a+164>>2]=12;c[a+168>>2]=1;c[a+176>>2]=2;c[a+180>>2]=2;c[a+184>>2]=4;c[a+188>>2]=0;c[a+56>>2]=1816;c[a+64>>2]=0;c[a+72>>2]=0;c[a+68>>2]=162;c[a+192>>2]=0;c[a+196>>2]=0;c[a+200>>2]=2;c[a+204>>2]=0;c[a+208>>2]=0;c[a+212>>2]=0;c[a+172>>2]=0;i=b;return}function xf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=i;e=i;i=i+168|0;c[e>>2]=0;f=i;i=i+544|0;g=i;i=i+88|0;h=i;i=i+160|0;j=i;i=i+160|0;u=0;Oa(3);k=u;u=0;if((k|0)!=0&(v|0)!=0){l=RS(c[k>>2]|0,e)|0;if((l|0)==0){db(k|0,v|0)}J=v}else{l=-1}k=J;do{if((l|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=k}else if((l|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=k;D=7}else{E=22112;F=22136;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[E+12>>2]=c[F+12>>2];c[E+16>>2]=c[F+16>>2];c[E+20>>2]=c[F+20>>2];u=0;Oa(c[5528]|0);F=u;u=0;if((F|0)!=0&(v|0)!=0){G=RS(c[F>>2]|0,e)|0;if((G|0)==0){db(F|0,v|0)}J=v}else{G=-1}F=J;if((G|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=F;break}else if((G|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=F;D=7;break}F=g;E=F+0|0;H=E+88|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(H|0));u=0;E=sa(98,c[4878]|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){I=RS(c[H>>2]|0,e)|0;if((I|0)==0){db(H|0,v|0)}J=v}else{I=-1}H=J;if((I|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((I|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}u=0;Ga(47,c[4878]|0,F|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){K=RS(c[H>>2]|0,e)|0;if((K|0)==0){db(H|0,v|0)}J=v}else{K=-1}H=J;if((K|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((K|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}H=h;c[g>>2]=h;DS(h,2,e|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=RS(c[L>>2]|0,e)|0;if((M|0)==0){db(L|0,v|0)}J=v}else{M=-1}L=J;if((M|0)==1){m=0;n=0;o=0;p=H;q=E;s=F;t=L;break}else if((M|0)==2){w=0;x=0;y=0;z=H;A=E;B=F;C=L;D=7;break}w=0;x=0;y=0;z=H;A=E;B=F;C=0;D=7}}while(0);while(1){if((D|0)==7){D=0;if((C|0)==0){M=j;h=g+4|0;K=c[h>>2]|0;c[h>>2]=j;DS(j,1,e|0)|0;u=0;I=u;u=0;if((I|0)!=0&(v|0)!=0){N=RS(c[I>>2]|0,e)|0;if((N|0)==0){db(I|0,v|0)}J=v}else{N=-1}I=J;if((N|0)==1){m=K;n=h;o=M;p=z;q=A;s=B;t=I;continue}else if((N|0)==2){O=B;P=A;Q=z;w=K;x=h;y=M;C=I;B=O;A=P;z=Q;D=7;continue}m=K;n=h;o=M;p=z;q=A;s=B;t=0;continue}else{u=0;Ga(47,c[4878]|0,A|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){R=RS(c[M>>2]|0,e)|0;if((R|0)==0){db(M|0,v|0)}J=v}else{R=-1}M=J;if((R|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((R|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}u=0;Oa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){V=RS(c[M>>2]|0,e)|0;if((V|0)==0){db(M|0,v|0)}J=v}else{V=-1}M=J;if((V|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((V|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}else{D=18;break}}}if((t|0)!=0){u=0;Oa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){W=RS(c[M>>2]|0,e)|0;if((W|0)==0){db(M|0,v|0)}J=v}else{W=-1}M=J;if((W|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((W|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}M=c[r>>2]|0;u=0;Qa(34,1880,154,1,M|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ba=RS(c[M>>2]|0,e)|0;if((ba|0)==0){db(M|0,v|0)}J=v}else{ba=-1}M=J;if((ba|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ba|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ca=RS(c[M>>2]|0,e)|0;if((ca|0)==0){db(M|0,v|0)}J=v}else{ca=-1}M=J;if((ca|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ca|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;sa(99,0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){da=RS(c[M>>2]|0,e)|0;if((da|0)==0){db(M|0,v|0)}J=v}else{da=-1}M=J;if((da|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((da|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}else{D=15;break}}u=0;pa(137,f|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ea=RS(c[M>>2]|0,e)|0;if((ea|0)==0){db(M|0,v|0)}J=v}else{ea=-1}M=J;if((ea|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ea|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}c[f+536>>2]=g;u=0;M=ua(31,a|0,b|0,f|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){fa=RS(c[h>>2]|0,e)|0;if((fa|0)==0){db(h|0,v|0)}J=v}else{fa=-1}h=J;if((fa|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((fa|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}c[n>>2]=m;u=0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ga=RS(c[h>>2]|0,e)|0;if((ga|0)==0){db(h|0,v|0)}J=v}else{ga=-1}h=J;if((ga|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ga|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;Ga(47,c[4878]|0,q|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ha=RS(c[h>>2]|0,e)|0;if((ha|0)==0){db(h|0,v|0)}J=v}else{ha=-1}h=J;if((ha|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ha|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ia=RS(c[h>>2]|0,e)|0;if((ia|0)==0){db(h|0,v|0)}J=v}else{ia=-1}h=J;if((ia|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ia|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ja=RS(c[h>>2]|0,e)|0;if((ja|0)==0){db(h|0,v|0)}J=v}else{ja=-1}h=J;if((ja|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ja|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;pa(138,M|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ka=RS(c[M>>2]|0,e)|0;if((ka|0)==0){db(M|0,v|0)}J=v}else{ka=-1}M=J;if((ka|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa}else if((ka|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7}else{D=26;break}}if((D|0)==15){la=p;ma=s;i=d;return 1}else if((D|0)==18){la=z;ma=B;i=d;return 1}return 0}function yf(){var a=0;a=i;md(0)|0;pc(2040,18,1,c[r>>2]|0)|0;md(0)|0;i=a;return}function zf(a){a=a|0;var b=0;a=i;i=i+8|0;b=i;i=i+8|0;Rn(4,0,2064,b);Rn(4,0,2104,a);i=a;return}function Af(a){a=a|0;var b=0,d=0;b=i;d=a+320|0;a=c[d>>2]|0;if((a|0)==0){i=b;return}bS(a);c[d>>2]=0;i=b;return}function Bf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+2|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+2|0]|0;k=b+4|0;l=Lq(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+176>>3],0.0,a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=l;e=k;f=j;break}else{j=b+4|0;k=Lq(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+176>>3],0.0,a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+2|0]|0;k=b+4|0;j=Nq(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+176>>3],0.0)|0;a[(c[b+352>>2]|0)+2|0]=j;e=k;f=g;break}else{g=b+4|0;k=Nq(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],0.0)|0;a[(c[b+352>>2]|0)+2|0]=k;e=g;f=k;break}}}}while(0);a[c[(c[c[e>>2]>>2]|0)+16>>2]|0]=f;i=d;return}function Cf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+1|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+1|0]|0;k=b+4|0;l=Lq(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+216>>3],0.0,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=l;e=k;f=j;break}else{j=b+4|0;k=Lq(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+216>>3],0.0,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+1|0]|0;k=b+4|0;j=Nq(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+216>>3],0.0)|0;a[(c[b+352>>2]|0)+1|0]=j;e=k;f=g;break}else{g=b+4|0;k=Nq(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],0.0)|0;a[(c[b+352>>2]|0)+1|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+1|0]=f;i=d;return}function Df(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0.0,X=0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0.0,da=0,ea=0.0,fa=0,ga=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=b+416|0;if(!((Nq(-+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3],-+h[(c[j>>2]|0)+440>>3])|0)<<24>>24==0)){l=c[j>>2]|0;m=+h[l+512>>3]*+h[l+520>>3];n=c[c[g>>2]>>2]|0;o=+h[l+440>>3];p=+h[(c[n+8>>2]|0)+152>>3]-o;do{if(m!=0.0){q=o;r=l;s=p/m}else{if(p==0.0){q=o;r=l;s=p;break}t=p/+Xn(c[b+536>>2]|0,m,2168,2160,+h[n>>3],(a[b+319|0]|0)!=0|0);u=c[j>>2]|0;q=+h[u+440>>3];r=u;s=t}}while(0);m=+ca(+s);s=+h[r+544>>3];do{if(s!=0.0){v=m/s}else{if(m==0.0){v=m;break}v=m/+Xn(c[b+536>>2]|0,s,2224,2160,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);w=-(q*v);x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+80|0;F=E;h[F>>3]=w;i=d;return}if(!((Nq(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],+h[(c[j>>2]|0)+536>>3])|0)<<24>>24==0)){v=+h[(c[j>>2]|0)+544>>3];r=c[c[g>>2]>>2]|0;q=+h[(c[r+8>>2]|0)+152>>3];s=-q;if(v!=0.0){w=s/v;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+80|0;F=E;h[F>>3]=w;i=d;return}if(q==-0.0){w=s;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+80|0;F=E;h[F>>3]=w;i=d;return}w=s/+Xn(c[b+536>>2]|0,v,2224,2160,+h[r>>3],(a[b+319|0]|0)!=0|0);x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+80|0;F=E;h[F>>3]=w;i=d;return}r=(Nq(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],+h[(c[j>>2]|0)+528>>3])|0)<<24>>24==0;n=c[j>>2]|0;if(r){v=+h[n+552>>3];r=c[c[g>>2]>>2]|0;s=+h[(c[r+8>>2]|0)+152>>3];q=-s;if(v!=0.0){w=q/v;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+80|0;F=E;h[F>>3]=w;i=d;return}if(s==-0.0){w=q;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+80|0;F=E;h[F>>3]=w;i=d;return}w=q/+Xn(c[b+536>>2]|0,v,2496,2160,+h[r>>3],(a[b+319|0]|0)!=0|0);x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+80|0;F=E;h[F>>3]=w;i=d;return}v=+h[n+528>>3];q=+h[n+536>>3];s=v-q;r=c[c[g>>2]>>2]|0;m=-v-q+ +h[c[r+8>>2]>>3]*2.0;do{if(s!=0.0){G=n;H=m/s}else{if(m==0.0){G=n;H=m;break}q=m/+Xn(c[b+536>>2]|0,s,2256,2160,+h[r>>3],(a[b+319|0]|0)!=0|0);G=c[j>>2]|0;H=q}}while(0);s=+h[G+552>>3];m=+h[G+544>>3];q=s*m;if(!(q>=0.0)){r=c[17498]|0;n=c[b+536>>2]|0;l=f;h[k>>3]=q;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=r;r=e;u=3040;c[r+0>>2]=c[u+0>>2];c[r+4>>2]=c[u+4>>2];c[r+8>>2]=c[u+8>>2];c[r+12>>2]=c[u+12>>2];c[r+16>>2]=c[u+16>>2];c[r+20>>2]=c[u+20>>2];ye[l&31](n,e,2320,f);f=c[j>>2]|0;I=+h[f+552>>3];J=+h[f+544>>3];K=f}else{I=s;J=m;K=G}G=c[c[g>>2]>>2]|0;f=c[G+8>>2]|0;m=+h[f+152>>3];s=+V(+q);e=J!=0.0;do{if(s!=0.0){do{if(e){L=f;M=G;N=K;O=I/J}else{if(I==0.0){L=f;M=G;N=K;O=I;break}q=I/+Xn(c[b+536>>2]|0,J,2224,2160,+h[G>>3],(a[b+319|0]|0)!=0|0);n=c[c[g>>2]>>2]|0;L=c[n+8>>2]|0;M=n;N=c[j>>2]|0;O=q}}while(0);q=+h[N+528>>3];v=+h[N+536>>3];p=q-v;o=-q-v+ +h[L>>3]*2.0;do{if(p!=0.0){P=o/p}else{if(o==0.0){P=o;break}P=o/+Xn(c[b+536>>2]|0,p,2256,2160,+h[M>>3],(a[b+319|0]|0)!=0|0)}}while(0);Q=+W(+O,+(H*H*H*.25+P*-.75))/s}else{do{if(e){R=f;S=G;T=K;U=I/J}else{if(I==0.0){R=f;S=G;T=K;U=I;break}p=I/+Xn(c[b+536>>2]|0,J,2224,2160,+h[G>>3],(a[b+319|0]|0)!=0|0);n=c[c[g>>2]>>2]|0;R=c[n+8>>2]|0;S=n;T=c[j>>2]|0;U=p}}while(0);p=+h[T+528>>3];o=+h[T+536>>3];v=p-o;q=-p-o+ +h[R>>3]*2.0;do{if(v!=0.0){X=T;Y=q/v}else{if(q==0.0){X=T;Y=q;break}o=q/+Xn(c[b+536>>2]|0,v,2256,2160,+h[S>>3],(a[b+319|0]|0)!=0|0);X=c[j>>2]|0;Y=o}}while(0);v=H*H*H*.25;n=+W(+U,+(v+Y*-.75))==0.0;q=+h[X+544>>3];l=q!=0.0;o=+h[X+552>>3];if(n){do{if(l){Z=X;_=o/q}else{if(o==0.0){Z=X;_=o;break}p=o/+Xn(c[b+536>>2]|0,q,2224,2160,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Z=c[j>>2]|0;_=p}}while(0);p=+h[Z+528>>3];t=+h[Z+536>>3];$=p-t;n=c[c[g>>2]>>2]|0;aa=-p-t+ +h[c[n+8>>2]>>3]*2.0;do{if($!=0.0){ba=aa/$}else{if(aa==0.0){ba=aa;break}ba=aa/+Xn(c[b+536>>2]|0,$,2256,2160,+h[n>>3],(a[b+319|0]|0)!=0|0)}}while(0);Q=+W(+_,+(v+ba*-.75));break}else{do{if(l){da=X;ea=o/q}else{if(o==0.0){da=X;ea=o;break}$=o/+Xn(c[b+536>>2]|0,q,2224,2160,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);da=c[j>>2]|0;ea=$}}while(0);q=+h[da+528>>3];o=+h[da+536>>3];$=q-o;l=c[c[g>>2]>>2]|0;aa=-q-o+ +h[c[l+8>>2]>>3]*2.0;do{if($!=0.0){fa=l;ga=aa/$}else{if(aa==0.0){fa=l;ga=aa;break}o=aa/+Xn(c[b+536>>2]|0,$,2256,2160,+h[l>>3],(a[b+319|0]|0)!=0|0);fa=c[c[g>>2]>>2]|0;ga=o}}while(0);$=+W(+ea,+(v+ga*-.75));Q=$/+Xn(c[b+536>>2]|0,s,2432,2160,+h[fa>>3],(a[b+319|0]|0)!=0|0);break}}}while(0);w=-(m*Q);x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+80|0;F=E;h[F>>3]=w;i=d;return}function Ef(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0.0,X=0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0.0,da=0,ea=0.0,fa=0,ga=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=b+416|0;if(!((Nq(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3],-+h[(c[j>>2]|0)+304>>3])|0)<<24>>24==0)){l=c[j>>2]|0;m=+h[l+376>>3]*+h[l+384>>3];n=c[c[g>>2]>>2]|0;o=+h[l+304>>3];p=-+h[(c[n+8>>2]|0)+152>>3]-o;do{if(m!=0.0){q=o;r=l;s=p/m}else{if(p==0.0){q=o;r=l;s=p;break}t=p/+Xn(c[b+536>>2]|0,m,2536,2528,+h[n>>3],(a[b+319|0]|0)!=0|0);u=c[j>>2]|0;q=+h[u+304>>3];r=u;s=t}}while(0);m=+ca(+s);s=+h[r+408>>3];do{if(s!=0.0){v=m/s}else{if(m==0.0){v=m;break}v=m/+Xn(c[b+536>>2]|0,s,2592,2528,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);w=-(q*v);x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+128|0;F=E;h[F>>3]=w;i=d;return}if(!((Nq(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[j>>2]|0)+400>>3])|0)<<24>>24==0)){v=+h[(c[j>>2]|0)+408>>3];r=c[c[g>>2]>>2]|0;q=+h[(c[r+8>>2]|0)+152>>3];if(v!=0.0){w=q/v;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+128|0;F=E;h[F>>3]=w;i=d;return}if(q==0.0){w=q;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+128|0;F=E;h[F>>3]=w;i=d;return}w=q/+Xn(c[b+536>>2]|0,v,2592,2528,+h[r>>3],(a[b+319|0]|0)!=0|0);x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+128|0;F=E;h[F>>3]=w;i=d;return}r=(Nq(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[j>>2]|0)+392>>3])|0)<<24>>24==0;n=c[j>>2]|0;if(r){v=+h[n+416>>3];r=c[c[g>>2]>>2]|0;q=+h[(c[r+8>>2]|0)+152>>3];if(v!=0.0){w=q/v;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+128|0;F=E;h[F>>3]=w;i=d;return}if(q==0.0){w=q;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+128|0;F=E;h[F>>3]=w;i=d;return}w=q/+Xn(c[b+536>>2]|0,v,2856,2528,+h[r>>3],(a[b+319|0]|0)!=0|0);x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+128|0;F=E;h[F>>3]=w;i=d;return}v=+h[n+392>>3];q=+h[n+400>>3];s=v-q;r=c[c[g>>2]>>2]|0;m=-v-q+ +h[(c[r+8>>2]|0)+8>>3]*2.0;do{if(s!=0.0){G=n;H=m/s}else{if(m==0.0){G=n;H=m;break}q=m/+Xn(c[b+536>>2]|0,s,2624,2528,+h[r>>3],(a[b+319|0]|0)!=0|0);G=c[j>>2]|0;H=q}}while(0);s=+h[G+416>>3];m=+h[G+408>>3];q=s*m;if(!(q>=0.0)){r=c[17498]|0;n=c[b+536>>2]|0;l=f;h[k>>3]=q;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=r;r=e;u=3040;c[r+0>>2]=c[u+0>>2];c[r+4>>2]=c[u+4>>2];c[r+8>>2]=c[u+8>>2];c[r+12>>2]=c[u+12>>2];c[r+16>>2]=c[u+16>>2];c[r+20>>2]=c[u+20>>2];ye[l&31](n,e,2680,f);f=c[j>>2]|0;I=+h[f+416>>3];J=+h[f+408>>3];K=f}else{I=s;J=m;K=G}G=c[c[g>>2]>>2]|0;f=c[G+8>>2]|0;m=+h[f+152>>3];s=+V(+q);e=J!=0.0;do{if(s!=0.0){do{if(e){L=f;M=G;N=K;O=I/J}else{if(I==0.0){L=f;M=G;N=K;O=I;break}q=I/+Xn(c[b+536>>2]|0,J,2592,2528,+h[G>>3],(a[b+319|0]|0)!=0|0);n=c[c[g>>2]>>2]|0;L=c[n+8>>2]|0;M=n;N=c[j>>2]|0;O=q}}while(0);q=+h[N+392>>3];v=+h[N+400>>3];p=q-v;o=-q-v+ +h[L+8>>3]*2.0;do{if(p!=0.0){P=o/p}else{if(o==0.0){P=o;break}P=o/+Xn(c[b+536>>2]|0,p,2624,2528,+h[M>>3],(a[b+319|0]|0)!=0|0)}}while(0);Q=+W(+O,+(H*H*H*.25+P*-.75))/s}else{do{if(e){R=f;S=G;T=K;U=I/J}else{if(I==0.0){R=f;S=G;T=K;U=I;break}p=I/+Xn(c[b+536>>2]|0,J,2592,2528,+h[G>>3],(a[b+319|0]|0)!=0|0);n=c[c[g>>2]>>2]|0;R=c[n+8>>2]|0;S=n;T=c[j>>2]|0;U=p}}while(0);p=+h[T+392>>3];o=+h[T+400>>3];v=p-o;q=-p-o+ +h[R+8>>3]*2.0;do{if(v!=0.0){X=T;Y=q/v}else{if(q==0.0){X=T;Y=q;break}o=q/+Xn(c[b+536>>2]|0,v,2624,2528,+h[S>>3],(a[b+319|0]|0)!=0|0);X=c[j>>2]|0;Y=o}}while(0);v=H*H*H*.25;n=+W(+U,+(v+Y*-.75))==0.0;q=+h[X+408>>3];l=q!=0.0;o=+h[X+416>>3];if(n){do{if(l){Z=X;_=o/q}else{if(o==0.0){Z=X;_=o;break}p=o/+Xn(c[b+536>>2]|0,q,2592,2528,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Z=c[j>>2]|0;_=p}}while(0);p=+h[Z+392>>3];t=+h[Z+400>>3];$=p-t;n=c[c[g>>2]>>2]|0;aa=-p-t+ +h[(c[n+8>>2]|0)+8>>3]*2.0;do{if($!=0.0){ba=aa/$}else{if(aa==0.0){ba=aa;break}ba=aa/+Xn(c[b+536>>2]|0,$,2624,2528,+h[n>>3],(a[b+319|0]|0)!=0|0)}}while(0);Q=+W(+_,+(v+ba*-.75));break}else{do{if(l){da=X;ea=o/q}else{if(o==0.0){da=X;ea=o;break}$=o/+Xn(c[b+536>>2]|0,q,2592,2528,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);da=c[j>>2]|0;ea=$}}while(0);q=+h[da+392>>3];o=+h[da+400>>3];$=q-o;l=c[c[g>>2]>>2]|0;aa=-q-o+ +h[(c[l+8>>2]|0)+8>>3]*2.0;do{if($!=0.0){fa=l;ga=aa/$}else{if(aa==0.0){fa=l;ga=aa;break}o=aa/+Xn(c[b+536>>2]|0,$,2624,2528,+h[l>>3],(a[b+319|0]|0)!=0|0);fa=c[c[g>>2]>>2]|0;ga=o}}while(0);$=+W(+ea,+(v+ga*-.75));Q=$/+Xn(c[b+536>>2]|0,s,2792,2528,+h[fa>>3],(a[b+319|0]|0)!=0|0);break}}}while(0);w=m*Q;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+128|0;F=E;h[F>>3]=w;i=d;return}function Ff(b){b=b|0;var d=0,e=0,f=0,g=0.0;d=c[c[b+4>>2]>>2]|0;e=c[d+8>>2]|0;f=c[b+416>>2]|0;if((a[(c[d+16>>2]|0)+1|0]|0)==0){g=+h[f+224>>3]}else{g=1.0}h[e+240>>3]=+h[e+216>>3]*g+ +h[f+240>>3];i=i;return}function Gf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+64>>3]=-+h[b+240>>3]- +h[b+160>>3];i=i;return}function Hf(b){b=b|0;var d=0,e=0,f=0,g=0.0;d=c[c[b+4>>2]>>2]|0;e=c[d+8>>2]|0;f=c[b+416>>2]|0;if((a[c[d+16>>2]|0]|0)==0){g=+h[f+256>>3]}else{g=1.0}h[e+208>>3]=+h[e+176>>3]*g+ +h[f+272>>3];i=i;return}function If(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+192>>3]=-+h[b+208>>3]- +h[b+64>>3];i=i;return}function Jf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+104>>3]=+h[b+192>>3]- +h[b+152>>3];i=i;return}function Kf(b){b=b|0;var d=0,e=0,f=0,g=0.0;d=c[c[b+4>>2]>>2]|0;e=c[d+8>>2]|0;f=c[b+416>>2]|0;g=+h[f+264>>3];h[e+200>>3]=+h[e+176>>3]*((a[c[d+16>>2]|0]|0)==0?1.0:g)+g*+h[f+272>>3];i=i;return}function Lf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+72>>3]=-+h[b+80>>3]- +h[b+200>>3];i=i;return}function Mf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+232>>3]=+h[b+56>>3]- +h[b+200>>3];i=i;return}function Nf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+2320>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+2296>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+2304>>3];h[a+8>>3]=+h[d+2208>>3];h[e+8>>3]=+h[d+2184>>3];h[f+8>>3]=+h[d+2192>>3];h[a+16>>3]=+h[d+3104>>3];h[e+16>>3]=+h[d+3080>>3];h[f+16>>3]=+h[d+3088>>3];h[a+24>>3]=+h[d+2544>>3];h[e+24>>3]=+h[d+2520>>3];h[f+24>>3]=+h[d+2528>>3];i=i;return}function Of(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0,K=0,L=0,M=0.0;f=i;g=b;j=b+4|0;k=c[(c[c[j>>2]>>2]|0)+8>>2]|0;h[k+160>>3]=+h[d>>3];h[k+152>>3]=+h[d+8>>3];h[k+216>>3]=+h[d+16>>3];h[k+176>>3]=+h[d+24>>3];Bf(g);Cf(g);Df(g);Ef(g);Ff(g);Gf(g);Hf(g);If(g);Jf(g);Kf(g);Lf(g);Mf(g);g=c[c[j>>2]>>2]|0;d=c[g+8>>2]|0;k=b+416|0;l=c[k>>2]|0;m=+h[l+232>>3];h[e>>3]=+h[d+232>>3]+(-(+h[d+216>>3]*((a[(c[g+16>>2]|0)+1|0]|0)==0?1.0:m))-m*+h[l+240>>3]);l=Nq(+h[d+104>>3],.65)|0;d=c[c[j>>2]>>2]|0;g=c[d+8>>2]|0;m=+h[g+104>>3];n=c[k>>2]|0;o=+h[n+480>>3];if(l<<24>>24==0){if(o!=0.0){p=o;q=o;r=n;s=g;t=d}else{u=+Xn(c[b+536>>2]|0,o,2928,2888,+h[d>>3],(a[b+319|0]|0)!=0|0);l=c[c[j>>2]>>2]|0;v=c[k>>2]|0;p=u;q=+h[v+480>>3];r=v;s=c[l+8>>2]|0;t=l}u=.4225/p;p=+h[s+200>>3];w=+h[r+488>>3];x=q+-.65;do{if(w!=0.0){y=x/w}else{if(x==0.0){y=x;break}y=x/+Xn(c[b+536>>2]|0,w,2896,2888,+h[t>>3],(a[b+319|0]|0)!=0|0)}}while(0);z=u+p*y}else{y=+h[n+488>>3];p=+h[g+200>>3];do{if(y!=0.0){A=p/y}else{if(p==0.0){A=p;break}A=p/+Xn(c[b+536>>2]|0,y,2896,2888,+h[d>>3],(a[b+319|0]|0)!=0|0)}}while(0);z=o*A}h[e+8>>3]=m-z;d=c[(c[c[j>>2]>>2]|0)+8>>2]|0;h[e+16>>3]=+h[d+128>>3]+(+h[d+72>>3]+ +h[d+16>>3]);g=Nq(+h[d+160>>3],.65)|0;d=c[c[j>>2]>>2]|0;n=c[d+8>>2]|0;z=+h[n+160>>3];t=c[k>>2]|0;m=+h[t+344>>3];if(!(g<<24>>24==0)){A=+h[t+352>>3];o=+h[n+232>>3];do{if(A!=0.0){B=o/A}else{if(o==0.0){B=o;break}B=o/+Xn(c[b+536>>2]|0,A,2960,2888,+h[d>>3],(a[b+319|0]|0)!=0|0)}}while(0);C=m*B;D=z-C;E=e;F=E+24|0;G=F;h[G>>3]=D;i=f;return}if(m!=0.0){H=m;I=m;J=t;K=n;L=d}else{B=+Xn(c[b+536>>2]|0,m,2992,2888,+h[d>>3],(a[b+319|0]|0)!=0|0);d=c[c[j>>2]>>2]|0;j=c[k>>2]|0;H=B;I=+h[j+344>>3];J=j;K=c[d+8>>2]|0;L=d}B=.4225/H;H=+h[K+232>>3];m=+h[J+352>>3];A=I+-.65;do{if(m!=0.0){M=A/m}else{if(A==0.0){M=A;break}M=A/+Xn(c[b+536>>2]|0,m,2960,2888,+h[L>>3],(a[b+319|0]|0)!=0|0)}}while(0);C=B+H*M;D=z-C;E=e;F=E+24|0;G=F;h[G>>3]=D;i=f;return}function Pf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+1|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+1|0]|0;k=b+4|0;l=Lq(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+216>>3],0.0,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=l;e=k;f=j;break}else{j=b+4|0;k=Lq(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+216>>3],0.0,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+1|0]|0;k=b+4|0;j=Nq(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+216>>3],0.0)|0;a[(c[b+352>>2]|0)+1|0]=j;e=k;f=g;break}else{g=b+4|0;k=Nq(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],0.0)|0;a[(c[b+352>>2]|0)+1|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+1|0]=f;i=d;return}function Qf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+2|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+2|0]|0;k=b+4|0;l=Lq(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+176>>3],0.0,a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=l;e=k;f=j;break}else{j=b+4|0;k=Lq(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+176>>3],0.0,a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+2|0]|0;k=b+4|0;j=Nq(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+176>>3],0.0)|0;a[(c[b+352>>2]|0)+2|0]=j;e=k;f=g;break}else{g=b+4|0;k=Nq(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],0.0)|0;a[(c[b+352>>2]|0)+2|0]=k;e=g;f=k;break}}}}while(0);a[c[(c[c[e>>2]>>2]|0)+16>>2]|0]=f;i=d;return}function Rf(b){b=b|0;var d=0,e=0,f=0,g=0.0;d=c[c[b+4>>2]>>2]|0;e=c[d+8>>2]|0;f=c[b+416>>2]|0;if((a[c[d+16>>2]|0]|0)==0){g=+h[f+256>>3]}else{g=1.0}h[e+208>>3]=+h[e+176>>3]*g+ +h[f+272>>3];i=i;return}function Sf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0.0,X=0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0.0,da=0,ea=0.0,fa=0,ga=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=b+416|0;if(!((Nq(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3],-+h[(c[j>>2]|0)+304>>3])|0)<<24>>24==0)){l=c[j>>2]|0;m=+h[l+376>>3]*+h[l+384>>3];n=c[c[g>>2]>>2]|0;o=+h[l+304>>3];p=-+h[(c[n+8>>2]|0)+152>>3]-o;do{if(m!=0.0){q=o;r=l;s=p/m}else{if(p==0.0){q=o;r=l;s=p;break}t=p/+Xn(c[b+536>>2]|0,m,2536,3024,+h[n>>3],(a[b+319|0]|0)!=0|0);u=c[j>>2]|0;q=+h[u+304>>3];r=u;s=t}}while(0);m=+ca(+s);s=+h[r+408>>3];do{if(s!=0.0){v=m/s}else{if(m==0.0){v=m;break}v=m/+Xn(c[b+536>>2]|0,s,2592,3024,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);w=-(q*v);x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+128|0;F=E;h[F>>3]=w;i=d;return}if(!((Nq(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[j>>2]|0)+400>>3])|0)<<24>>24==0)){v=+h[(c[j>>2]|0)+408>>3];r=c[c[g>>2]>>2]|0;q=+h[(c[r+8>>2]|0)+152>>3];if(v!=0.0){w=q/v;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+128|0;F=E;h[F>>3]=w;i=d;return}if(q==0.0){w=q;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+128|0;F=E;h[F>>3]=w;i=d;return}w=q/+Xn(c[b+536>>2]|0,v,2592,3024,+h[r>>3],(a[b+319|0]|0)!=0|0);x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+128|0;F=E;h[F>>3]=w;i=d;return}r=(Nq(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[j>>2]|0)+392>>3])|0)<<24>>24==0;n=c[j>>2]|0;if(r){v=+h[n+416>>3];r=c[c[g>>2]>>2]|0;q=+h[(c[r+8>>2]|0)+152>>3];if(v!=0.0){w=q/v;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+128|0;F=E;h[F>>3]=w;i=d;return}if(q==0.0){w=q;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+128|0;F=E;h[F>>3]=w;i=d;return}w=q/+Xn(c[b+536>>2]|0,v,2856,3024,+h[r>>3],(a[b+319|0]|0)!=0|0);x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+128|0;F=E;h[F>>3]=w;i=d;return}v=+h[n+392>>3];q=+h[n+400>>3];s=v-q;r=c[c[g>>2]>>2]|0;m=-v-q+ +h[(c[r+8>>2]|0)+8>>3]*2.0;do{if(s!=0.0){G=n;H=m/s}else{if(m==0.0){G=n;H=m;break}q=m/+Xn(c[b+536>>2]|0,s,2624,3024,+h[r>>3],(a[b+319|0]|0)!=0|0);G=c[j>>2]|0;H=q}}while(0);s=+h[G+416>>3];m=+h[G+408>>3];q=s*m;if(!(q>=0.0)){r=c[17498]|0;n=c[b+536>>2]|0;l=f;h[k>>3]=q;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=r;r=e;u=3040;c[r+0>>2]=c[u+0>>2];c[r+4>>2]=c[u+4>>2];c[r+8>>2]=c[u+8>>2];c[r+12>>2]=c[u+12>>2];c[r+16>>2]=c[u+16>>2];c[r+20>>2]=c[u+20>>2];ye[l&31](n,e,2680,f);f=c[j>>2]|0;I=+h[f+416>>3];J=+h[f+408>>3];K=f}else{I=s;J=m;K=G}G=c[c[g>>2]>>2]|0;f=c[G+8>>2]|0;m=+h[f+152>>3];s=+V(+q);e=J!=0.0;do{if(s!=0.0){do{if(e){L=f;M=G;N=K;O=I/J}else{if(I==0.0){L=f;M=G;N=K;O=I;break}q=I/+Xn(c[b+536>>2]|0,J,2592,3024,+h[G>>3],(a[b+319|0]|0)!=0|0);n=c[c[g>>2]>>2]|0;L=c[n+8>>2]|0;M=n;N=c[j>>2]|0;O=q}}while(0);q=+h[N+392>>3];v=+h[N+400>>3];p=q-v;o=-q-v+ +h[L+8>>3]*2.0;do{if(p!=0.0){P=o/p}else{if(o==0.0){P=o;break}P=o/+Xn(c[b+536>>2]|0,p,2624,3024,+h[M>>3],(a[b+319|0]|0)!=0|0)}}while(0);Q=+W(+O,+(H*H*H*.25+P*-.75))/s}else{do{if(e){R=f;S=G;T=K;U=I/J}else{if(I==0.0){R=f;S=G;T=K;U=I;break}p=I/+Xn(c[b+536>>2]|0,J,2592,3024,+h[G>>3],(a[b+319|0]|0)!=0|0);n=c[c[g>>2]>>2]|0;R=c[n+8>>2]|0;S=n;T=c[j>>2]|0;U=p}}while(0);p=+h[T+392>>3];o=+h[T+400>>3];v=p-o;q=-p-o+ +h[R+8>>3]*2.0;do{if(v!=0.0){X=T;Y=q/v}else{if(q==0.0){X=T;Y=q;break}o=q/+Xn(c[b+536>>2]|0,v,2624,3024,+h[S>>3],(a[b+319|0]|0)!=0|0);X=c[j>>2]|0;Y=o}}while(0);v=H*H*H*.25;n=+W(+U,+(v+Y*-.75))==0.0;q=+h[X+408>>3];l=q!=0.0;o=+h[X+416>>3];if(n){do{if(l){Z=X;_=o/q}else{if(o==0.0){Z=X;_=o;break}p=o/+Xn(c[b+536>>2]|0,q,2592,3024,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Z=c[j>>2]|0;_=p}}while(0);p=+h[Z+392>>3];t=+h[Z+400>>3];$=p-t;n=c[c[g>>2]>>2]|0;aa=-p-t+ +h[(c[n+8>>2]|0)+8>>3]*2.0;do{if($!=0.0){ba=aa/$}else{if(aa==0.0){ba=aa;break}ba=aa/+Xn(c[b+536>>2]|0,$,2624,3024,+h[n>>3],(a[b+319|0]|0)!=0|0)}}while(0);Q=+W(+_,+(v+ba*-.75));break}else{do{if(l){da=X;ea=o/q}else{if(o==0.0){da=X;ea=o;break}$=o/+Xn(c[b+536>>2]|0,q,2592,3024,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);da=c[j>>2]|0;ea=$}}while(0);q=+h[da+392>>3];o=+h[da+400>>3];$=q-o;l=c[c[g>>2]>>2]|0;aa=-q-o+ +h[(c[l+8>>2]|0)+8>>3]*2.0;do{if($!=0.0){fa=l;ga=aa/$}else{if(aa==0.0){fa=l;ga=aa;break}o=aa/+Xn(c[b+536>>2]|0,$,2624,3024,+h[l>>3],(a[b+319|0]|0)!=0|0);fa=c[c[g>>2]>>2]|0;ga=o}}while(0);$=+W(+ea,+(v+ga*-.75));Q=$/+Xn(c[b+536>>2]|0,s,2792,3024,+h[fa>>3],(a[b+319|0]|0)!=0|0);break}}}while(0);w=m*Q;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+128|0;F=E;h[F>>3]=w;i=d;return}function Tf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+72>>3]=-+h[b+128>>3]- +h[b+16>>3];i=i;return}function Uf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0.0,X=0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0.0,da=0,ea=0.0,fa=0,ga=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=b+416|0;if(!((Nq(-+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3],-+h[(c[j>>2]|0)+440>>3])|0)<<24>>24==0)){l=c[j>>2]|0;m=+h[l+512>>3]*+h[l+520>>3];n=c[c[g>>2]>>2]|0;o=+h[l+440>>3];p=+h[(c[n+8>>2]|0)+152>>3]-o;do{if(m!=0.0){q=o;r=l;s=p/m}else{if(p==0.0){q=o;r=l;s=p;break}t=p/+Xn(c[b+536>>2]|0,m,2168,3032,+h[n>>3],(a[b+319|0]|0)!=0|0);u=c[j>>2]|0;q=+h[u+440>>3];r=u;s=t}}while(0);m=+ca(+s);s=+h[r+544>>3];do{if(s!=0.0){v=m/s}else{if(m==0.0){v=m;break}v=m/+Xn(c[b+536>>2]|0,s,2224,3032,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);w=-(q*v);x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+80|0;F=E;h[F>>3]=w;i=d;return}if(!((Nq(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],+h[(c[j>>2]|0)+536>>3])|0)<<24>>24==0)){v=+h[(c[j>>2]|0)+544>>3];r=c[c[g>>2]>>2]|0;q=+h[(c[r+8>>2]|0)+152>>3];s=-q;if(v!=0.0){w=s/v;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+80|0;F=E;h[F>>3]=w;i=d;return}if(q==-0.0){w=s;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+80|0;F=E;h[F>>3]=w;i=d;return}w=s/+Xn(c[b+536>>2]|0,v,2224,3032,+h[r>>3],(a[b+319|0]|0)!=0|0);x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+80|0;F=E;h[F>>3]=w;i=d;return}r=(Nq(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],+h[(c[j>>2]|0)+528>>3])|0)<<24>>24==0;n=c[j>>2]|0;if(r){v=+h[n+552>>3];r=c[c[g>>2]>>2]|0;s=+h[(c[r+8>>2]|0)+152>>3];q=-s;if(v!=0.0){w=q/v;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+80|0;F=E;h[F>>3]=w;i=d;return}if(s==-0.0){w=q;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+80|0;F=E;h[F>>3]=w;i=d;return}w=q/+Xn(c[b+536>>2]|0,v,2496,3032,+h[r>>3],(a[b+319|0]|0)!=0|0);x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+80|0;F=E;h[F>>3]=w;i=d;return}v=+h[n+528>>3];q=+h[n+536>>3];s=v-q;r=c[c[g>>2]>>2]|0;m=-v-q+ +h[c[r+8>>2]>>3]*2.0;do{if(s!=0.0){G=n;H=m/s}else{if(m==0.0){G=n;H=m;break}q=m/+Xn(c[b+536>>2]|0,s,2256,3032,+h[r>>3],(a[b+319|0]|0)!=0|0);G=c[j>>2]|0;H=q}}while(0);s=+h[G+552>>3];m=+h[G+544>>3];q=s*m;if(!(q>=0.0)){r=c[17498]|0;n=c[b+536>>2]|0;l=f;h[k>>3]=q;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=r;r=e;u=3040;c[r+0>>2]=c[u+0>>2];c[r+4>>2]=c[u+4>>2];c[r+8>>2]=c[u+8>>2];c[r+12>>2]=c[u+12>>2];c[r+16>>2]=c[u+16>>2];c[r+20>>2]=c[u+20>>2];ye[l&31](n,e,2320,f);f=c[j>>2]|0;I=+h[f+552>>3];J=+h[f+544>>3];K=f}else{I=s;J=m;K=G}G=c[c[g>>2]>>2]|0;f=c[G+8>>2]|0;m=+h[f+152>>3];s=+V(+q);e=J!=0.0;do{if(s!=0.0){do{if(e){L=f;M=G;N=K;O=I/J}else{if(I==0.0){L=f;M=G;N=K;O=I;break}q=I/+Xn(c[b+536>>2]|0,J,2224,3032,+h[G>>3],(a[b+319|0]|0)!=0|0);n=c[c[g>>2]>>2]|0;L=c[n+8>>2]|0;M=n;N=c[j>>2]|0;O=q}}while(0);q=+h[N+528>>3];v=+h[N+536>>3];p=q-v;o=-q-v+ +h[L>>3]*2.0;do{if(p!=0.0){P=o/p}else{if(o==0.0){P=o;break}P=o/+Xn(c[b+536>>2]|0,p,2256,3032,+h[M>>3],(a[b+319|0]|0)!=0|0)}}while(0);Q=+W(+O,+(H*H*H*.25+P*-.75))/s}else{do{if(e){R=f;S=G;T=K;U=I/J}else{if(I==0.0){R=f;S=G;T=K;U=I;break}p=I/+Xn(c[b+536>>2]|0,J,2224,3032,+h[G>>3],(a[b+319|0]|0)!=0|0);n=c[c[g>>2]>>2]|0;R=c[n+8>>2]|0;S=n;T=c[j>>2]|0;U=p}}while(0);p=+h[T+528>>3];o=+h[T+536>>3];v=p-o;q=-p-o+ +h[R>>3]*2.0;do{if(v!=0.0){X=T;Y=q/v}else{if(q==0.0){X=T;Y=q;break}o=q/+Xn(c[b+536>>2]|0,v,2256,3032,+h[S>>3],(a[b+319|0]|0)!=0|0);X=c[j>>2]|0;Y=o}}while(0);v=H*H*H*.25;n=+W(+U,+(v+Y*-.75))==0.0;q=+h[X+544>>3];l=q!=0.0;o=+h[X+552>>3];if(n){do{if(l){Z=X;_=o/q}else{if(o==0.0){Z=X;_=o;break}p=o/+Xn(c[b+536>>2]|0,q,2224,3032,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);Z=c[j>>2]|0;_=p}}while(0);p=+h[Z+528>>3];t=+h[Z+536>>3];$=p-t;n=c[c[g>>2]>>2]|0;aa=-p-t+ +h[c[n+8>>2]>>3]*2.0;do{if($!=0.0){ba=aa/$}else{if(aa==0.0){ba=aa;break}ba=aa/+Xn(c[b+536>>2]|0,$,2256,3032,+h[n>>3],(a[b+319|0]|0)!=0|0)}}while(0);Q=+W(+_,+(v+ba*-.75));break}else{do{if(l){da=X;ea=o/q}else{if(o==0.0){da=X;ea=o;break}$=o/+Xn(c[b+536>>2]|0,q,2224,3032,+h[c[c[g>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);da=c[j>>2]|0;ea=$}}while(0);q=+h[da+528>>3];o=+h[da+536>>3];$=q-o;l=c[c[g>>2]>>2]|0;aa=-q-o+ +h[c[l+8>>2]>>3]*2.0;do{if($!=0.0){fa=l;ga=aa/$}else{if(aa==0.0){fa=l;ga=aa;break}o=aa/+Xn(c[b+536>>2]|0,$,2256,3032,+h[l>>3],(a[b+319|0]|0)!=0|0);fa=c[c[g>>2]>>2]|0;ga=o}}while(0);$=+W(+ea,+(v+ga*-.75));Q=$/+Xn(c[b+536>>2]|0,s,2432,3032,+h[fa>>3],(a[b+319|0]|0)!=0|0);break}}}while(0);w=-(m*Q);x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+80|0;F=E;h[F>>3]=w;i=d;return}function Vf(b){b=b|0;var d=0,e=0,f=0,g=0.0;d=c[c[b+4>>2]>>2]|0;e=c[d+8>>2]|0;f=c[b+416>>2]|0;if((a[(c[d+16>>2]|0)+1|0]|0)==0){g=+h[f+224>>3]}else{g=1.0}h[e+240>>3]=+h[e+216>>3]*g+ +h[f+240>>3];i=i;return}function Wf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+64>>3]=-+h[b+240>>3]- +h[b+160>>3];i=i;return}function Xf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+192>>3]=-+h[b+208>>3]- +h[b+64>>3];i=i;return}function Yf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+104>>3]=+h[b+192>>3]- +h[b+152>>3];i=i;return}function Zf(b){b=b|0;var d=0,e=0,f=0,g=0.0;d=c[c[b+4>>2]>>2]|0;e=c[d+8>>2]|0;f=c[b+416>>2]|0;g=+h[f+232>>3];h[e+232>>3]=+h[e+216>>3]*((a[(c[d+16>>2]|0)+1|0]|0)==0?1.0:g)+g*+h[f+240>>3];i=i;return}function _f(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+200>>3]=+h[b+56>>3]- +h[b+232>>3];i=i;return}function $f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+2320>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+2296>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+2304>>3];h[a+8>>3]=+h[d+2208>>3];h[e+8>>3]=+h[d+2184>>3];h[f+8>>3]=+h[d+2192>>3];h[a+16>>3]=+h[d+2544>>3];h[e+16>>3]=+h[d+2520>>3];h[f+16>>3]=+h[d+2528>>3];h[a+24>>3]=+h[d+3104>>3];h[e+24>>3]=+h[d+3080>>3];h[f+24>>3]=+h[d+3088>>3];i=i;return}function ag(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0,K=0,L=0,M=0.0;f=i;g=b;j=b+4|0;k=c[(c[c[j>>2]>>2]|0)+8>>2]|0;h[k+160>>3]=+h[d>>3];h[k+152>>3]=+h[d+8>>3];h[k+176>>3]=+h[d+16>>3];h[k+216>>3]=+h[d+24>>3];Pf(g);Qf(g);Rf(g);Sf(g);Tf(g);Uf(g);Vf(g);Wf(g);Xf(g);Yf(g);Zf(g);_f(g);g=c[c[j>>2]>>2]|0;d=c[g+8>>2]|0;k=d+200|0;h[e>>3]=+h[d+80>>3]+(+h[k>>3]+ +h[d+72>>3]);l=b+416|0;m=c[l>>2]|0;n=+h[m+264>>3];h[e+8>>3]=+h[k>>3]+(-(+h[d+176>>3]*((a[c[g+16>>2]|0]|0)==0?1.0:n))-n*+h[m+272>>3]);m=Nq(+h[d+104>>3],.65)|0;d=c[c[j>>2]>>2]|0;g=c[d+8>>2]|0;n=+h[g+104>>3];k=c[l>>2]|0;o=+h[k+480>>3];if(m<<24>>24==0){if(o!=0.0){p=o;q=o;r=k;s=g;t=d}else{u=+Xn(c[b+536>>2]|0,o,2928,3064,+h[d>>3],(a[b+319|0]|0)!=0|0);m=c[c[j>>2]>>2]|0;v=c[l>>2]|0;p=u;q=+h[v+480>>3];r=v;s=c[m+8>>2]|0;t=m}u=.4225/p;p=+h[s+200>>3];w=+h[r+488>>3];x=q+-.65;do{if(w!=0.0){y=x/w}else{if(x==0.0){y=x;break}y=x/+Xn(c[b+536>>2]|0,w,2896,3064,+h[t>>3],(a[b+319|0]|0)!=0|0)}}while(0);z=u+p*y}else{y=+h[k+488>>3];p=+h[g+200>>3];do{if(y!=0.0){A=p/y}else{if(p==0.0){A=p;break}A=p/+Xn(c[b+536>>2]|0,y,2896,3064,+h[d>>3],(a[b+319|0]|0)!=0|0)}}while(0);z=o*A}h[e+16>>3]=n-z;d=Nq(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+160>>3],.65)|0;g=c[c[j>>2]>>2]|0;k=c[g+8>>2]|0;z=+h[k+160>>3];t=c[l>>2]|0;n=+h[t+344>>3];if(!(d<<24>>24==0)){A=+h[t+352>>3];o=+h[k+232>>3];do{if(A!=0.0){B=o/A}else{if(o==0.0){B=o;break}B=o/+Xn(c[b+536>>2]|0,A,2960,3064,+h[g>>3],(a[b+319|0]|0)!=0|0)}}while(0);C=n*B;D=z-C;E=e;F=E+24|0;G=F;h[G>>3]=D;i=f;return}if(n!=0.0){H=n;I=n;J=t;K=k;L=g}else{B=+Xn(c[b+536>>2]|0,n,2992,3064,+h[g>>3],(a[b+319|0]|0)!=0|0);g=c[c[j>>2]>>2]|0;j=c[l>>2]|0;H=B;I=+h[j+344>>3];J=j;K=c[g+8>>2]|0;L=g}B=.4225/H;H=+h[K+232>>3];n=+h[J+352>>3];A=I+-.65;do{if(n!=0.0){M=A/n}else{if(A==0.0){M=A;break}M=A/+Xn(c[b+536>>2]|0,n,2960,3064,+h[L>>3],(a[b+319|0]|0)!=0|0)}}while(0);C=B+H*M;D=z-C;E=e;F=E+24|0;G=F;h[G>>3]=D;i=f;return}function bg(a){a=a|0;c[a+4>>2]=48;c[a>>2]=4;c[a+56>>2]=0;c[a+32>>2]=18;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=-1;c[a+36>>2]=43;c[a+84>>2]=94;c[a+80>>2]=4;c[a+136>>2]=0;c[a+112>>2]=19;c[a+100>>2]=0;c[a+104>>2]=0;c[a+108>>2]=-1;c[a+116>>2]=44;i=i;return}function cg(a){a=a|0;i=i;return}function dg(a,b){a=a|0;b=b|0;i=i;return}function eg(a){a=a|0;i=i;return}function fg(a,b){a=a|0;b=b|0;c[b>>2]=c[4088+(a<<2)>>2];i=i;return c[3072+(a<<2)>>2]|0}function gg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0;e=i;f=b+4|0;g=b+416|0;j=b+360|0;k=(Lq(+h[c[c[f>>2]>>2]>>3],+h[(c[g>>2]|0)+112>>3],a[c[j>>2]|0]|0)|0)<<24>>24!=0;h[d>>3]=k?1.0:-1.0;k=(Lq(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+216>>3],0.0,a[(c[j>>2]|0)+1|0]|0)|0)<<24>>24!=0;h[d+8>>3]=k?1.0:-1.0;k=(Lq(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+176>>3],0.0,a[(c[j>>2]|0)+2|0]|0)|0)<<24>>24!=0;h[d+16>>3]=k?1.0:-1.0;k=c[(c[c[f>>2]>>2]|0)+8>>2]|0;l=(Mq(+h[k+144>>3]- +h[k+8>>3],0.0,a[(c[j>>2]|0)+3|0]|0)|0)<<24>>24!=0;h[d+24>>3]=l?1.0:-1.0;l=Mq(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+128>>3],+h[(c[g>>2]|0)+328>>3],a[(c[j>>2]|0)+4|0]|0)|0;k=Mq(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+152>>3],+h[(c[g>>2]|0)+296>>3],a[(c[j>>2]|0)+5|0]|0)|0;if(l<<24>>24==0){m=k<<24>>24!=0?1.0:-1.0}else{m=1.0}h[d+32>>3]=m;k=c[(c[c[f>>2]>>2]|0)+8>>2]|0;l=(Mq(+h[k+96>>3]- +h[k>>3],0.0,a[(c[j>>2]|0)+6|0]|0)|0)<<24>>24!=0;h[d+40>>3]=l?1.0:-1.0;l=Mq(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+80>>3],+h[(c[g>>2]|0)+464>>3],a[(c[j>>2]|0)+7|0]|0)|0;k=Mq(-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+152>>3],+h[(c[g>>2]|0)+432>>3],a[(c[j>>2]|0)+8|0]|0)|0;if(l<<24>>24==0){n=k<<24>>24!=0?1.0:-1.0}else{n=1.0}h[d+48>>3]=n;if((Lq(+h[c[c[f>>2]>>2]>>3],+h[(c[g>>2]|0)+632>>3],a[(c[j>>2]|0)+9|0]|0)|0)<<24>>24==0){o=(c[c[b+420>>2]>>2]|0)==0?1.0:-1.0}else{o=1.0}h[d+56>>3]=o;k=c[c[f>>2]>>2]|0;l=c[k+8>>2]|0;p=(Lq(+h[k>>3],+h[l+48>>3]+ +h[l+312>>3],a[(c[j>>2]|0)+10|0]|0)|0)<<24>>24!=0;h[d+64>>3]=p?1.0:-1.0;p=c[g>>2]|0;o=+(~~+T(+((+h[c[c[f>>2]>>2]>>3]- +h[p+632>>3])/+h[p+616>>3]))|0);p=(Pq(o,+(c[c[b+404>>2]>>2]|0))|0)<<24>>24!=0;h[d+72>>3]=p?1.0:-1.0;p=c[g>>2]|0;o=+T(+((+h[c[c[f>>2]>>2]>>3]- +h[p+632>>3])/+h[p+616>>3]));p=o!=+T(+(+h[c[b+364>>2]>>3]));h[d+80>>3]=p?1.0:-1.0;i=e;return 0}function hg(a){a=a|0;i=i;return c[4432+(a<<2)>>2]|0}function ig(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0,k=0.0,l=0,m=0,n=0,o=0;e=i;f=b+4|0;g=+h[c[c[f>>2]>>2]>>3];j=b+416|0;k=+h[(c[j>>2]|0)+112>>3];if((d|0)==0){d=b+352|0;a[c[d>>2]|0]=g<k|0;a[(c[d>>2]|0)+1|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+216>>3]<0.0|0;a[(c[d>>2]|0)+2|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+176>>3]<0.0|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+3|0]=+h[l+144>>3]- +h[l+8>>3]>0.0|0;a[(c[d>>2]|0)+4|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+128>>3]>+h[(c[j>>2]|0)+328>>3]|0;a[(c[d>>2]|0)+5|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+152>>3]>+h[(c[j>>2]|0)+296>>3]|0;l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;a[(c[d>>2]|0)+6|0]=+h[l+96>>3]- +h[l>>3]>0.0|0;a[(c[d>>2]|0)+7|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+80>>3]>+h[(c[j>>2]|0)+464>>3]|0;a[(c[d>>2]|0)+8|0]=+h[(c[j>>2]|0)+432>>3]<-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+152>>3]|0;a[(c[d>>2]|0)+9|0]=+h[c[c[f>>2]>>2]>>3]<+h[(c[j>>2]|0)+632>>3]|0;l=c[c[f>>2]>>2]|0;m=c[l+8>>2]|0;a[(c[d>>2]|0)+10|0]=+h[l>>3]<+h[m+48>>3]+ +h[m+312>>3]|0;m=c[j>>2]|0;l=~~+T(+((+h[c[c[f>>2]>>2]>>3]- +h[m+632>>3])/+h[m+616>>3]));a[(c[d>>2]|0)+11|0]=(l|0)>(c[c[b+404>>2]>>2]|0)|0;i=e;return 0}else{l=b+360|0;d=Lq(g,k,a[c[l>>2]|0]|0)|0;m=b+352|0;a[c[m>>2]|0]=d;d=Lq(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+216>>3],0.0,a[(c[l>>2]|0)+1|0]|0)|0;a[(c[m>>2]|0)+1|0]=d;d=Lq(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+176>>3],0.0,a[(c[l>>2]|0)+2|0]|0)|0;a[(c[m>>2]|0)+2|0]=d;d=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=Mq(+h[d+144>>3]- +h[d+8>>3],0.0,a[(c[l>>2]|0)+3|0]|0)|0;a[(c[m>>2]|0)+3|0]=n;n=Mq(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+128>>3],+h[(c[j>>2]|0)+328>>3],a[(c[l>>2]|0)+4|0]|0)|0;a[(c[m>>2]|0)+4|0]=n;n=Mq(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+152>>3],+h[(c[j>>2]|0)+296>>3],a[(c[l>>2]|0)+5|0]|0)|0;a[(c[m>>2]|0)+5|0]=n;n=c[(c[c[f>>2]>>2]|0)+8>>2]|0;d=Mq(+h[n+96>>3]- +h[n>>3],0.0,a[(c[l>>2]|0)+6|0]|0)|0;a[(c[m>>2]|0)+6|0]=d;d=Mq(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+80>>3],+h[(c[j>>2]|0)+464>>3],a[(c[l>>2]|0)+7|0]|0)|0;a[(c[m>>2]|0)+7|0]=d;d=Mq(-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+152>>3],+h[(c[j>>2]|0)+432>>3],a[(c[l>>2]|0)+8|0]|0)|0;a[(c[m>>2]|0)+8|0]=d;d=Lq(+h[c[c[f>>2]>>2]>>3],+h[(c[j>>2]|0)+632>>3],a[(c[l>>2]|0)+9|0]|0)|0;a[(c[m>>2]|0)+9|0]=d;d=c[c[f>>2]>>2]|0;n=c[d+8>>2]|0;o=Lq(+h[d>>3],+h[n+48>>3]+ +h[n+312>>3],a[(c[l>>2]|0)+10|0]|0)|0;a[(c[m>>2]|0)+10|0]=o;o=c[j>>2]|0;k=+(~~+T(+((+h[c[c[f>>2]>>2]>>3]- +h[o+632>>3])/+h[o+616>>3]))|0);o=Pq(k,+(c[c[b+404>>2]>>2]|0))|0;a[(c[m>>2]|0)+11|0]=o;i=e;return 0}return 0}function jg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0,H=0;d=i;i=i+8|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;Rn(8,1,4480,m);m=b+4|0;n=c[c[m>>2]>>2]|0;o=c[n+16>>2]|0;p=a[o+2|0]|0;q=b+408|0;r=c[q>>2]|0;s=a[r+2|0]|0;if(p<<24>>24==s<<24>>24){t=r;u=o;v=n;w=0}else{c[l>>2]=s<<24>>24;c[l+4>>2]=p<<24>>24;Rn(8,0,4512,l);l=c[c[m>>2]>>2]|0;t=c[q>>2]|0;u=c[l+16>>2]|0;v=l;w=1}l=a[u+1|0]|0;p=a[t+1|0]|0;if(l<<24>>24==p<<24>>24){x=t;y=u;z=v;A=w}else{c[j>>2]=p<<24>>24;c[j+4>>2]=l<<24>>24;Rn(8,0,4568,j);j=c[c[m>>2]>>2]|0;x=c[q>>2]|0;y=c[j+16>>2]|0;z=j;A=1}j=a[y]|0;y=a[x]|0;if(j<<24>>24==y<<24>>24){B=z;C=A}else{c[g>>2]=y<<24>>24;c[g+4>>2]=j<<24>>24;Rn(8,0,4640,g);B=c[c[m>>2]>>2]|0;C=1}D=+h[(c[B+8>>2]|0)+48>>3];E=+h[(c[b+400>>2]|0)+48>>3];if(D!=E){g=f;h[k>>3]=E;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=f+8|0;h[k>>3]=D;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];Rn(8,0,4712,f);F=c[c[m>>2]>>2]|0;G=1}else{F=B;G=C}C=c[c[F+12>>2]>>2]|0;F=c[c[b+404>>2]>>2]|0;if((C|0)==(F|0)){H=G}else{c[e>>2]=F;c[e+4>>2]=C;Rn(8,0,4784,e);H=1}if((c[21264>>2]|0)==0){i=d;return H|0}Yd[c[5446]&255](8);i=d;return H|0}function kg(a){a=a|0;i=i;return c[5080+(a<<2)>>2]|0}function lg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+4|0;e=a+416|0;f=c[e>>2]|0;g=Rq((+h[c[c[d>>2]>>2]>>3]- +h[f+632>>3])/+h[f+616>>3],0,a)|0;a=c[c[d>>2]>>2]|0;c[(c[a+12>>2]|0)+4>>2]=g;d=c[e>>2]|0;h[(c[a+8>>2]|0)+328>>3]=+h[d+632>>3]+ +(g|0)*+h[d+616>>3];i=b;return}function mg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+8|0;Rn(21,1,5096,l);l=a+4|0;m=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+8>>3];h[b>>3]=m;n=kg(0)|0;c[j>>2]=1;c[j+4>>2]=n;n=j+8|0;h[k>>3]=m;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Rn(21,0,5128,j);m=+h[c[(c[c[l>>2]>>2]|0)+8>>2]>>3];h[b+8>>3]=m;j=kg(1)|0;c[g>>2]=2;c[g+4>>2]=j;j=g+8|0;h[k>>3]=m;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];Rn(21,0,5128,g);lg(a);a=c[(c[c[l>>2]>>2]|0)+12>>2]|0;m=+((c[a>>2]|0)-(c[a+4>>2]|0)|0);h[b+16>>3]=m;a=kg(2)|0;c[f>>2]=3;c[f+4>>2]=a;a=f+8|0;h[k>>3]=m;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];Rn(21,0,5128,f);f=c[(c[c[l>>2]>>2]|0)+8>>2]|0;m=+h[f+48>>3]- +h[f+328>>3];h[b+24>>3]=m;b=kg(3)|0;c[e>>2]=4;c[e+4>>2]=b;b=e+8|0;h[k>>3]=m;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];Rn(21,0,5128,e);if((c[21316>>2]|0)==0){i=d;return 0}Yd[c[5446]&255](21);i=d;return 0}function ng(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+632>>3]=+h[b+568>>3];i=i;return}function og(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+624>>3]=+h[b+560>>3];i=i;return}function pg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+616>>3]=+h[b+592>>3];i=i;return}function qg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+608>>3]=+h[b+584>>3];i=i;return}function rg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+600>>3]=+h[b+576>>3];i=i;return}function sg(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+472>>3];j=+h[f+456>>3]+-.7;do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+Xn(c[b+536>>2]|0,g,5152,5144,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+552>>3]=l;i=d;return}function tg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+440>>3]=+h[b+128>>3];i=i;return}function ug(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+432>>3]=+h[b+120>>3];i=i;return}function vg(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+432>>3];j=+h[f+464>>3]*+h[f+456>>3];k=g*g;if(j!=0.0){l=f;m=k/j;n=l;o=n+544|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=f;m=k;n=l;o=n+544|0;p=o;h[p>>3]=m;i=d;return}g=k/+Xn(c[b+536>>2]|0,j,5192,5184,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);l=c[e>>2]|0;m=g;n=l;o=n+544|0;p=o;h[p>>3]=m;i=d;return}function wg(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+336>>3];j=+h[f+320>>3]+-.7;do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+Xn(c[b+536>>2]|0,g,5256,5248,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+416>>3]=l;i=d;return}function xg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+304>>3]=+h[b+128>>3];i=i;return}function yg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+296>>3]=+h[b+120>>3];i=i;return}function zg(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+296>>3];j=+h[f+328>>3]*+h[f+320>>3];k=g*g;if(j!=0.0){l=f;m=k/j;n=l;o=n+408|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=f;m=k;n=l;o=n+408|0;p=o;h[p>>3]=m;i=d;return}g=k/+Xn(c[b+536>>2]|0,j,5296,5288,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);l=c[e>>2]|0;m=g;n=l;o=n+408|0;p=o;h[p>>3]=m;i=d;return}function Ag(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+112>>3]=+h[b+48>>3];i=i;return}function Bg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+104>>3]=+h[b+40>>3];i=i;return}function Cg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+96>>3]=+h[b+64>>3];i=i;return}function Dg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+88>>3]=+h[b+72>>3];i=i;return}function Eg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+80>>3]=+h[b+56>>3];i=i;return}function Fg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32>>3]=+h[b+16>>3];i=i;return}function Gg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+312>>3]=+h[b+616>>3]*+h[b+608>>3]*.01;i=i;return}function Hg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+304>>3]=+h[b+8>>3]*(+h[b+24>>3]*(+h[b+32>>3]- +h[b+16>>3])+1.0);i=i;return}function Ig(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;do{if((a[b+314|0]|0)==0){e=a[c[b+356>>2]|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){g=a[c[b+356>>2]|0]|0;j=Lq(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+112>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=j;e=g;break}else{g=Lq(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+112>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=g;e=g;break}}else{if(f){f=a[c[b+356>>2]|0]|0;g=Nq(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+112>>3])|0;a[c[b+352>>2]|0]=g;e=f;break}else{f=Nq(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+112>>3])|0;a[c[b+352>>2]|0]=f;e=f;break}}}}while(0);f=c[b+416>>2]|0;if(e<<24>>24==0){e=c[c[b+4>>2]>>2]|0;k=+Y(+(+h[f+96>>3]+ +h[f+88>>3]*(+h[e>>3]- +h[f+112>>3])*6.283185307179586));l=e;m=k*+h[f+80>>3];n=f;o=n+104|0;p=o;q=+h[p>>3];r=m+q;s=l;t=s+8|0;u=t;v=c[u>>2]|0;w=v;x=w+256|0;y=x;h[y>>3]=r;i=d;return}else{l=c[c[b+4>>2]>>2]|0;m=0.0;n=f;o=n+104|0;p=o;q=+h[p>>3];r=m+q;s=l;t=s+8|0;u=t;v=c[u>>2]|0;w=v;x=w+256|0;y=x;h[y>>3]=r;i=d;return}}function Jg(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16>>3]=0.0;i=i;return}function Kg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+272>>3]=+h[b+304>>3]*+h[b+16>>3];i=i;return}function Lg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+280>>3]=+h[b+272>>3]+ +h[b+256>>3];i=i;return}function Mg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+264>>3]=+h[b+272>>3]*+h[b+16>>3];i=i;return}function Ng(a){a=a|0;h[c[(c[c[a+4>>2]>>2]|0)+8>>2]>>3]=0.0;i=i;return}function Og(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8>>3]=0.0;i=i;return}function Pg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+4|0;e=a+416|0;f=c[e>>2]|0;g=Rq((+h[c[c[d>>2]>>2]>>3]- +h[f+632>>3])/+h[f+616>>3],0,a)|0;a=c[c[d>>2]>>2]|0;c[c[a+12>>2]>>2]=g;d=c[e>>2]|0;h[(c[a+8>>2]|0)+48>>3]=+h[d+632>>3]+ +(g|0)*+h[d+616>>3];i=b;return}function Qg(a){a=a|0;h[(c[a+400>>2]|0)+48>>3]=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+48>>3];i=i;return}function Rg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=b+4|0;g=a[(c[b+356>>2]|0)+9|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){k=a[(c[b+356>>2]|0)+9|0]|0;l=b+4|0;m=Lq(+h[c[c[l>>2]>>2]>>3],+h[(c[b+416>>2]|0)+632>>3],a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=m;f=l;g=k;break}else{k=b+4|0;l=Lq(+h[c[c[k>>2]>>2]>>3],+h[(c[b+416>>2]|0)+632>>3],a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=l;f=k;g=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+9|0]|0;l=b+4|0;k=Nq(+h[c[c[l>>2]>>2]>>3],+h[(c[b+416>>2]|0)+632>>3])|0;a[(c[b+352>>2]|0)+9|0]=k;f=l;g=j;break}else{j=b+4|0;l=Nq(+h[c[c[j>>2]>>2]>>3],+h[(c[b+416>>2]|0)+632>>3])|0;a[(c[b+352>>2]|0)+9|0]=l;f=j;g=l;break}}}}while(0);l=b+420|0;j=Pq(+(c[c[l>>2]>>2]|0),0.0)|0;k=Qq(+(c[c[(c[c[f>>2]>>2]|0)+12>>2]>>2]|0),+(c[c[l>>2]>>2]|0))|0;do{if(g<<24>>24==0){if((c[c[l>>2]>>2]|0)==0){n=0.0;break}if(k<<24>>24!=0&j<<24>>24!=0){n=0.0;break}do{if((a[e]|0)==0){o=a[(c[b+356>>2]|0)+10|0]|0}else{m=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(m){p=a[(c[b+356>>2]|0)+10|0]|0;q=c[c[f>>2]>>2]|0;r=c[q+8>>2]|0;s=Lq(+h[q>>3],+h[r+48>>3]+ +h[r+312>>3],a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=s;o=p;break}else{p=c[c[f>>2]>>2]|0;s=c[p+8>>2]|0;r=Lq(+h[p>>3],+h[s+48>>3]+ +h[s+312>>3],a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=r;o=r;break}}else{if(m){m=a[(c[b+356>>2]|0)+10|0]|0;r=c[c[f>>2]>>2]|0;s=c[r+8>>2]|0;p=Nq(+h[r>>3],+h[s+48>>3]+ +h[s+312>>3])|0;a[(c[b+352>>2]|0)+10|0]=p;o=m;break}else{m=c[c[f>>2]>>2]|0;p=c[m+8>>2]|0;s=Nq(+h[m>>3],+h[p+48>>3]+ +h[p+312>>3])|0;a[(c[b+352>>2]|0)+10|0]=s;o=s;break}}}}while(0);if(o<<24>>24==0){n=0.0;break}n=+h[(c[b+416>>2]|0)+600>>3]}else{n=0.0}}while(0);h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+56>>3]=n+ +h[(c[b+416>>2]|0)+624>>3];i=d;return}function Sg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+44>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+160>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+160|0;h[c[g+48>>2]>>3]=+h[j>>3];k=+lr(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+160>>3]);e=c[f>>2]|0;h[c[e+52>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+44>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+152>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+152|0;h[(c[e+48>>2]|0)+8>>3]=+h[g>>3];k=+lr(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+152>>3]);j=c[f>>2]|0;h[(c[j+52>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+44>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+216>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+216|0;h[(c[j+48>>2]|0)+16>>3]=+h[e>>3];k=+lr(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+216>>3]);g=c[f>>2]|0;h[(c[g+52>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+44>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+176>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+176|0;h[(c[g+48>>2]|0)+24>>3]=+h[j>>3];k=+lr(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+176>>3]);h[(c[(c[f>>2]|0)+52>>2]|0)+24>>3]=k;jr(a,0)|0;e=c[(c[f>>2]|0)+44>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+160>>3]=+h[e>>3];h[f+152>>3]=+h[e+8>>3];h[f+216>>3]=+h[e+16>>3];h[f+176>>3]=+h[e+24>>3];Bf(a);Cf(a);Df(a);Ef(a);Ff(a);Gf(a);Hf(a);If(a);Jf(a);Kf(a);Lf(a);Mf(a);i=b;return}



function Kz(a){a=a|0;var b=0,d=0;b=i;d=c[(Oz(a)|0)>>2]|0;i=b;return d|0}function Lz(a){a=a|0;var b=0,d=0;b=i;d=Mz(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function Mz(a){a=a|0;var b=0,c=0;b=i;c=Nz(a)|0;i=b;return c|0}function Nz(a){a=a|0;i=i;return a|0}function Oz(a){a=a|0;var b=0,c=0;b=i;c=Pz(a)|0;i=b;return c|0}function Pz(a){a=a|0;i=i;return a|0}function Qz(a){a=a|0;i=i;return a|0}function Rz(a){a=a|0;var b=0,c=0;b=i;c=bt(Vz(a+4|0)|0)|0;i=b;return c|0}function Sz(a){a=a|0;var b=0,c=0;b=i;c=Tz(a+8|0)|0;i=b;return c|0}function Tz(a){a=a|0;var b=0,c=0;b=i;c=Uz(a)|0;i=b;return c|0}function Uz(a){a=a|0;i=i;return a|0}function Vz(a){a=a|0;var b=0,c=0;b=i;c=Wz(a)|0;i=b;return c|0}function Wz(a){a=a|0;i=i;return a|0}function Xz(a){a=a|0;var b=0;b=i;Yz(a,0);i=b;return}function Yz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=Mz(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}_z(Zz(e)|0,f);i=d;return}function Zz(a){a=a|0;var b=0,c=0;b=i;c=eA(a)|0;i=b;return c|0}function _z(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;$z(f,aA(d+20|0)|0)}if((d|0)==0){i=e;return}bA(c[b>>2]|0,d,1);i=e;return}function $z(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;dA(d,0,c);i=b;return}function aA(a){a=a|0;i=i;return a|0}function bA(a,b,c){a=a|0;b=b|0;c=c|0;c=i;cA(0,b,0);i=c;return}function cA(a,b,c){a=a|0;b=b|0;c=c|0;c=i;iS(b);i=c;return}function dA(a,b,c){a=a|0;b=b|0;c=c|0;b=i;ox(c);i=b;return}function eA(a){a=a|0;i=i;return a+4|0}function fA(a,b){a=a|0;b=b|0;var c=0;c=i;gA(a,b);i=c;return}function gA(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function hA(a){a=a|0;var b=0,c=0;b=i;c=AA(a+4|0)|0;i=b;return c|0}function iA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];sA(a,b,f);i=e;return}function jA(a,b){a=a|0;b=b|0;var c=0;a=i;c=rA(0,b,0)|0;i=a;return c|0}function kA(a,b){a=a|0;b=b|0;var c=0;c=i;qA(a,b);i=c;return}function lA(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function mA(a){a=a|0;var b=0,d=0;b=i;d=c[(Oz(a)|0)>>2]|0;i=b;return d|0}function nA(a){a=a|0;var b=0,c=0;b=i;c=Zz(a)|0;i=b;return c|0}function oA(a,b){a=a|0;b=b|0;a=i;i=i+8|0;if((b|0)==0){i=a;return}gx(b,a);i=a;return}function pA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;fA(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];Fz(h,f);Hz(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];Fz(a,e);Iz(h);i=d;return}function qA(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function rA(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=gS(b<<5)|0;i=c;return a|0}function sA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(uA(g)|0)>>2]|0;g=vA(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];tA(b,a,f);i=e;return}function tA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];wA(a,b,f);i=e;return}function uA(a){a=a|0;i=i;return a|0}function vA(a){a=a|0;i=i;return a|0}function wA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(yA(g)|0)>>2]|0;g=zA(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];xA(b,a,f);i=e;return}function xA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(yA(f)|0)>>2];f=zA(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function yA(a){a=a|0;i=i;return a|0}function zA(a){a=a|0;i=i;return a|0}function AA(a){a=a|0;var b=0,c=0;b=i;c=BA(a)|0;i=b;return c|0}function BA(a){a=a|0;i=i;return a|0}function CA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=Lz(DA(b)|0)|0;h=zA(nA(DA(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];tA(g,a,e);i=d;return}function DA(a){a=a|0;i=i;return c[a>>2]|0}function EA(a){a=a|0;var b=0,d=0;b=i;d=c[(Rz(a)|0)>>2]|0;i=b;return d|0}function FA(a,b){a=a|0;b=b|0;b=i;i=i+8|0;GA(a,b);i=b;return}function GA(a,b){a=a|0;b=b|0;b=i;HA(a,0);i=b;return}function HA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;IA(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;JA(f,0,e);e=iz(b)|0;c[(KA(b)|0)>>2]=e;i=d;return}function IA(a){a=a|0;var b=0;b=i;NA(a);i=b;return}function JA(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;LA(b,c,f);i=e;return}function KA(a){a=a|0;i=i;return a|0}function LA(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(Uv(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;MA(d,b,f);i=e;return}function MA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(Uv(e)|0)>>2];i=d;return}function NA(a){a=a|0;var b=0;b=i;OA(a);i=b;return}function OA(a){a=a|0;var b=0;b=i;Xv(a);i=b;return}function PA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=pz(h)|0;qt(e);if((a|0)==0){j=iz(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(vx(0,d,a)|0){m=l;j=c[m>>2]|0;qt(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(vx(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;qt(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function QA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];LB(a,e);i=d;return}function RA(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=qB(d)|0;d=sB(n,1)|0;tB(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];rB(j,d,h);uB(0,Cy((vB(j)|0)+16|0)|0,e);e=wB(j)|0;a[e+4|0]=1;xB(0,hB((vB(j)|0)+28|0)|0);a[e+5|0]=1;yB(m,j);SA(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];QA(b,g);TA(m);TA(j);i=f;return}function SA(a,b){a=a|0;b=b|0;var c=0;c=i;oB(a,b);i=c;return}function TA(a){a=a|0;var b=0;b=i;cB(a);i=b;return}function UA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;qt(f);c[e>>2]=0;qt(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=KA(a)|0;b=c[c[e>>2]>>2]|0;qt(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(iz(a)|0)>>2]|0;av(e,c[d>>2]|0);d=$A(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function VA(a){a=a|0;var b=0,d=0;b=i;d=c[(ZA(a)|0)>>2]|0;i=b;return d|0}function WA(a){a=a|0;var b=0,d=0;b=i;d=XA(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function XA(a){a=a|0;var b=0,c=0;b=i;c=YA(a)|0;i=b;return c|0}function YA(a){a=a|0;i=i;return a|0}function ZA(a){a=a|0;var b=0,c=0;b=i;c=_A(a)|0;i=b;return c|0}function _A(a){a=a|0;i=i;return a|0}function $A(a){a=a|0;var b=0,c=0;b=i;c=aB(a+8|0)|0;i=b;return c|0}function aB(a){a=a|0;var b=0,c=0;b=i;c=bB(a)|0;i=b;return c|0}function bB(a){a=a|0;i=i;return a|0}function cB(a){a=a|0;var b=0;b=i;dB(a,0);i=b;return}function dB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=XA(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}fB(eB(e)|0,f);i=d;return}function eB(a){a=a|0;var b=0,c=0;b=i;c=nB(a)|0;i=b;return c|0}function fB(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;gB(f,hB(d+28|0)|0)}if((a[b+4|0]|0)!=0){f=c[b>>2]|0;iB(f,Cy(d+16|0)|0)}if((d|0)==0){i=e;return}jB(c[b>>2]|0,d,1);i=e;return}function gB(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;mB(d,0,c);i=b;return}function hB(a){a=a|0;i=i;return a|0}function iB(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;lB(d,0,c);i=b;return}function jB(a,b,c){a=a|0;b=b|0;c=c|0;c=i;kB(0,b,0);i=c;return}function kB(a,b,c){a=a|0;b=b|0;c=c|0;c=i;iS(b);i=c;return}function lB(a,b,c){a=a|0;b=b|0;c=c|0;b=i;XH(c);i=b;return}function mB(a,b,c){a=a|0;b=b|0;c=c|0;b=i;XH(c);i=b;return}function nB(a){a=a|0;i=i;return a+4|0}function oB(a,b){a=a|0;b=b|0;var c=0;c=i;pB(a,b);i=c;return}function pB(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function qB(a){a=a|0;var b=0,c=0;b=i;c=JB(a+4|0)|0;i=b;return c|0}function rB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];BB(a,b,f);i=e;return}function sB(a,b){a=a|0;b=b|0;var c=0;a=i;c=AB(0,b,0)|0;i=a;return c|0}function tB(a,b){a=a|0;b=b|0;var c=0;c=i;zB(a,b);i=c;return}function uB(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}NH(b,c);i=a;return}function vB(a){a=a|0;var b=0,d=0;b=i;d=c[(ZA(a)|0)>>2]|0;i=b;return d|0}function wB(a){a=a|0;var b=0,c=0;b=i;c=eB(a)|0;i=b;return c|0}function xB(a,b){a=a|0;b=b|0;a=i;if((b|0)==0){i=a;return}LH(b);i=a;return}function yB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;oB(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];QA(h,f);SA(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];QA(a,e);TA(h);i=d;return}function zB(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function AB(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=gS(b*40|0)|0;i=c;return a|0}function BB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(DB(g)|0)>>2]|0;g=EB(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];CB(b,a,f);i=e;return}function CB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];FB(a,b,f);i=e;return}function DB(a){a=a|0;i=i;return a|0}function EB(a){a=a|0;i=i;return a|0}function FB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(HB(g)|0)>>2]|0;g=IB(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];GB(b,a,f);i=e;return}function GB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(HB(f)|0)>>2];f=IB(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function HB(a){a=a|0;i=i;return a|0}function IB(a){a=a|0;i=i;return a|0}function JB(a){a=a|0;var b=0,c=0;b=i;c=KB(a)|0;i=b;return c|0}function KB(a){a=a|0;i=i;return a|0}function LB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=WA(MB(b)|0)|0;h=IB(wB(MB(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];CB(g,a,e);i=d;return}function MB(a){a=a|0;i=i;return c[a>>2]|0}function NB(a){a=a|0;var b=0;b=i;OB(a);i=b;return}function OB(a){a=a|0;var b=0;b=i;PB(a);i=b;return}function PB(a){a=a|0;var b=0;b=i;QB(a,pz(a)|0);i=b;return}function QB(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;qt(d);if((b|0)==0){i=d;return}QB(a,c[b>>2]|0);QB(a,c[b+4>>2]|0);e=qB(a)|0;RB(e,SB(b+16|0)|0);jB(e,b,1);i=d;return}function RB(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;TB(d,0,c);i=b;return}function SB(a){a=a|0;i=i;return a|0}function TB(a,b,c){a=a|0;b=b|0;c=c|0;b=i;UB(c);i=b;return}function UB(a){a=a|0;var b=0;b=i;VB(a);i=b;return}function VB(a){a=a|0;var b=0;b=i;WB(a);i=b;return}function WB(a){a=a|0;var b=0;b=i;XB(a);i=b;return}function XB(a){a=a|0;var b=0;b=i;XH(a+12|0);XH(a);i=b;return}function YB(a){a=a|0;var b=0;b=i;ZB(a+180|0);ZB(a+168|0);ZB(a+156|0);ZB(a+144|0);ZB(a+132|0);ZB(a+120|0);ZB(a+108|0);ZB(a+96|0);ZB(a+84|0);ZB(a+72|0);ZB(a+60|0);ZB(a+48|0);ZB(a+36|0);ZB(a+24|0);ox(a+12|0);ox(a);i=b;return}function ZB(a){a=a|0;var b=0;b=i;_B(a);i=b;return}function _B(a){a=a|0;var b=0;b=i;$B(a);i=b;return}function $B(a){a=a|0;var b=0;b=i;aC(a);i=b;return}function aC(a){a=a|0;var b=0;b=i;bC(a,EA(a)|0);i=b;return}function bC(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;qt(d);if((b|0)==0){i=d;return}bC(a,c[b>>2]|0);bC(a,c[b+4>>2]|0);e=hA(a)|0;cC(e,dC(b+16|0)|0);bA(e,b,1);i=d;return}function cC(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;eC(d,0,c);i=b;return}function dC(a){a=a|0;i=i;return a|0}function eC(a,b,c){a=a|0;b=b|0;c=c|0;b=i;fC(c);i=b;return}function fC(a){a=a|0;var b=0;b=i;gC(a);i=b;return}function gC(a){a=a|0;var b=0;b=i;hC(a);i=b;return}function hC(a){a=a|0;var b=0;b=i;iC(a);i=b;return}function iC(a){a=a|0;var b=0;b=i;ox(a+4|0);i=b;return}function jC(a){a=a|0;var b=0;b=i;kC(a);i=b;return}function kC(a){a=a|0;var b=0;b=i;lC(a);i=b;return}function lC(a){a=a|0;var b=0;b=i;mC(a,$x(a)|0);i=b;return}function mC(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;qt(d);if((b|0)==0){i=d;return}mC(a,c[b>>2]|0);mC(a,c[b+4>>2]|0);e=Jy(a)|0;nC(e,Ox(b+16|0)|0);Dy(e,b,1);i=d;return}function nC(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;oC(d,0,c);i=b;return}function oC(a,b,c){a=a|0;b=b|0;c=c|0;b=i;pC(c);i=b;return}function pC(a){a=a|0;var b=0;b=i;qC(a);i=b;return}function qC(a){a=a|0;var b=0;b=i;rC(a);i=b;return}function rC(a){a=a|0;var b=0;b=i;sC(a);i=b;return}function sC(a){a=a|0;var b=0;b=i;XH(a);i=b;return}function tC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;uC(a);wC(g,b);xC(h,b);b=f;j=g;c[b+0>>2]=c[j+0>>2];j=e;b=h;c[j+0>>2]=c[b+0>>2];vC(a,f,e);i=d;return a|0}function uC(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;QB(a,pz(a)|0);c[($A(a)|0)>>2]=0;d=iz(a)|0;c[(KA(a)|0)>>2]=d;qt(b);c[d>>2]=0;i=b;return}function vC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;FC(h,a);if(!(GC(b,d)|0)){i=e;return}m=c[h>>2]|0;h=k;do{c[h>>2]=m;n=g;o=k;c[n+0>>2]=c[o+0>>2];yC(j,g);o=IC(b)|0;n=f;p=j;c[n+0>>2]=c[p+0>>2];HC(l,a,f,o);JC(b)|0;}while(GC(b,d)|0);i=e;return}function wC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;DC(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];yC(a,e);i=d;return}function xC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;zC(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];yC(a,e);i=d;return}function yC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];CC(a,e);i=d;return}function zC(a,b){a=a|0;b=b|0;var c=0;c=i;AC(a,qx(b)|0);i=c;return}function AC(a,b){a=a|0;b=b|0;var c=0;c=i;BC(a,b);i=c;return}function BC(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function CC(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function DC(a,b){a=a|0;b=b|0;var d=0;d=i;AC(a,c[(EC(b)|0)>>2]|0);i=d;return}function EC(a){a=a|0;i=i;return a|0}function FC(a,b){a=a|0;b=b|0;var c=0;c=i;xC(a,b);i=c;return}function GC(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=PD(a,b)|0;i=c;return d|0}function HC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+56|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=b;c[k>>2]=c[d>>2];RC(l,e);e=h;d=k;c[e+0>>2]=c[d+0>>2];QC(j,m,h,l);h=g;m=j;c[h+0>>2]=c[m+0>>2];fz(a,g);UB(l);i=f;return}function IC(a){a=a|0;var b=0,c=0;b=i;c=NC(a)|0;i=b;return c|0}function JC(a){a=a|0;var b=0;b=i;KC(a)|0;i=b;return a|0}function KC(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=LC(c[d>>2]|0)|0;i=b;return a|0}function LC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;qt(b);if((e|0)==0){e=a;while(1){a=ev(e)|0;f=c[e+8>>2]|0;if(a){g=f;break}else{e=f}}i=b;return g|0}else{g=MC(c[d>>2]|0)|0;i=b;return g|0}return 0}function MC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a;f=c[e>>2]|0;qt(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e;f=c[a>>2]|0;qt(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function NC(a){a=a|0;var b=0,d=0;b=i;d=OC((c[a>>2]|0)+16|0)|0;i=b;return d|0}function OC(a){a=a|0;var b=0,c=0;b=i;c=PC(a)|0;i=b;return c|0}function PC(a){a=a|0;i=i;return a|0}function QC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+56|0;o=f+64|0;c[k>>2]=c[d>>2];d=h;p=k;c[d+0>>2]=c[p+0>>2];p=VC(b,h,j,e)|0;h=c[p>>2]|0;qt(l);if((h|0)!=0){q=h;hz(a,q);i=f;return}XC(o,b,e);YC(n,o);e=g;h=n;c[e+0>>2]=c[h+0>>2];WC(m,g);ZC(o);o=c[j>>2]|0;UA(b,o,p,_C(m)|0);p=$C(m)|0;ZC(m);q=p;hz(a,q);i=f;return}function RC(a,b){a=a|0;b=b|0;var c=0;c=i;SC(a,b);i=c;return}function SC(a,b){a=a|0;b=b|0;var c=0;c=i;TC(a,b);i=c;return}function TC(a,b){a=a|0;b=b|0;var c=0;c=i;UC(a,b);i=c;return}function UC(a,b){a=a|0;b=b|0;var c=0;c=i;NH(a,b);NH(a+12|0,b+12|0);i=c;return}function VC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+120|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=f+64|0;q=f+72|0;r=f+80|0;s=f+88|0;t=f+96|0;u=f+104|0;v=f+112|0;gz(m,a);w=k;x=m;c[w+0>>2]=c[x+0>>2];DD(l,k);do{if(!(CD(b,l)|0)){k=rz(a)|0;x=FD(b)|0;if(ED(k,e,x)|0){break}w=ED(k,x,e)|0;x=c[b>>2]|0;if(!w){c[d>>2]=x;y=d;i=f;return y|0}c[s>>2]=x;w=h;m=s;c[w+0>>2]=c[m+0>>2];JD(r,h,1,0);gz(u,a);m=g;w=u;c[m+0>>2]=c[w+0>>2];DD(t,g);do{if(!(CD(r,t)|0)){if(ED(k,e,FD(r)|0)|0){break}y=ID(a,d,e)|0;i=f;return y|0}}while(0);k=x+4|0;w=c[k>>2]|0;qt(v);if((w|0)==0){c[d>>2]=x;y=k;i=f;return y|0}else{k=c[r>>2]|0;c[d>>2]=k;y=k;i=f;return y|0}}}while(0);r=c[b>>2]|0;b=n;c[b>>2]=r;GD(p,a);v=j;t=p;c[v+0>>2]=c[t+0>>2];DD(o,j);do{if(!(CD(n,o)|0)){j=rz(a)|0;if(ED(j,FD(HD(n)|0)|0,e)|0){break}y=ID(a,d,e)|0;i=f;return y|0}}while(0);e=r;a=c[e>>2]|0;qt(q);if((a|0)==0){c[d>>2]=r;y=e;i=f;return y|0}else{e=c[b>>2]|0;c[d>>2]=e;y=e+4|0;i=f;return y|0}return 0}function WC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];AD(a,e);i=d;return}function XC(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=qB(d)|0;d=sB(n,1)|0;mD(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];lD(j,d,h);nD(0,SB((oD(j)|0)+16|0)|0,e);a[(pD(j)|0)+4|0]=1;qD(m,j);YC(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];WC(b,g);ZC(m);ZC(j);i=f;return}function YC(a,b){a=a|0;b=b|0;var c=0;c=i;jD(a,b);i=c;return}function ZC(a){a=a|0;var b=0;b=i;eD(a);i=b;return}function _C(a){a=a|0;var b=0,d=0;b=i;d=c[(cD(a)|0)>>2]|0;i=b;return d|0}function $C(a){a=a|0;var b=0,d=0;b=i;d=aD(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function aD(a){a=a|0;var b=0,c=0;b=i;c=bD(a)|0;i=b;return c|0}function bD(a){a=a|0;i=i;return a|0}function cD(a){a=a|0;var b=0,c=0;b=i;c=dD(a)|0;i=b;return c|0}function dD(a){a=a|0;i=i;return a|0}function eD(a){a=a|0;var b=0;b=i;fD(a,0);i=b;return}function fD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=aD(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}hD(gD(e)|0,f);i=d;return}function gD(a){a=a|0;var b=0,c=0;b=i;c=iD(a)|0;i=b;return c|0}function hD(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;RB(f,SB(d+16|0)|0)}if((d|0)==0){i=e;return}jB(c[b>>2]|0,d,1);i=e;return}function iD(a){a=a|0;i=i;return a+4|0}function jD(a,b){a=a|0;b=b|0;var c=0;c=i;kD(a,b);i=c;return}function kD(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function lD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];uD(a,b,f);i=e;return}function mD(a,b){a=a|0;b=b|0;var c=0;c=i;tD(a,b);i=c;return}function nD(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}rD(b,c);i=a;return}function oD(a){a=a|0;var b=0,d=0;b=i;d=c[(cD(a)|0)>>2]|0;i=b;return d|0}function pD(a){a=a|0;var b=0,c=0;b=i;c=gD(a)|0;i=b;return c|0}function qD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;jD(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];WC(h,f);YC(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];WC(a,e);ZC(h);i=d;return}function rD(a,b){a=a|0;b=b|0;var c=0;c=i;sD(a,b);i=c;return}function sD(a,b){a=a|0;b=b|0;var c=0;c=i;TC(a,b);i=c;return}function tD(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;i=i;return}function uD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(DB(g)|0)>>2]|0;g=wD(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];vD(b,a,f);i=e;return}function vD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];xD(a,b,f);i=e;return}function wD(a){a=a|0;i=i;return a|0}function xD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(HB(g)|0)>>2]|0;g=zD(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];yD(b,a,f);i=e;return}function yD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(HB(f)|0)>>2];f=zD(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function zD(a){a=a|0;i=i;return a|0}function AD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=$C(BD(b)|0)|0;h=zD(pD(BD(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];vD(g,a,e);i=d;return}function BD(a){a=a|0;i=i;return c[a>>2]|0}function CD(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function DD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];OD(a,e);i=d;return}function ED(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=vx(0,b,c)|0;i=a;return d|0}function FD(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function GD(a,b){a=a|0;b=b|0;var d=0;d=i;hz(a,c[(KA(b)|0)>>2]|0);i=d;return}function HD(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=MD(c[d>>2]|0)|0;i=b;return a|0}function ID(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=pz(a)|0;qt(e);if((h|0)==0){j=iz(a)|0;c[b>>2]=j;k=j;i=e;return k|0}j=rz(a)|0;a=h;while(1){h=a+16|0;if(ED(j,d,h)|0){l=a;m=c[l>>2]|0;qt(f);if((m|0)==0){n=5;break}else{o=l}}else{p=a;if(!(ED(j,h,d)|0)){n=10;break}q=a+4|0;h=c[q>>2]|0;qt(g);if((h|0)==0){n=9;break}else{o=q}}a=c[o>>2]|0}if((n|0)==5){c[b>>2]=a;k=l;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==10){c[b>>2]=p;k=b;i=e;return k|0}return 0}function JD(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;KD(b,d);c[a>>2]=c[b>>2];i=e;return}function KD(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;LD(b,c,e);i=d;return}function LD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;if(!((b|0)>-1)){d=b;do{HD(a)|0;d=d+1|0;}while((d|0)<0);i=c;return}if((b|0)>0){e=b}else{i=c;return}do{KC(a)|0;e=e+ -1|0;}while((e|0)>0);i=c;return}function MD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;qt(b);if((e|0)==0){e=a;while(1){a=ev(e)|0;f=c[e+8>>2]|0;if(a){e=f}else{g=f;break}}i=b;return g|0}else{g=ND(c[d>>2]|0)|0;i=b;return g|0}return 0}function ND(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[e>>2]|0;qt(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e+4|0;f=c[a>>2]|0;qt(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function OD(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function PD(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(CD(a,b)|0)^1;i=c;return d|0}function QD(a){a=a|0;var b=0;b=i;i=i+128|0;gx(a,b);gx(a+12|0,b+8|0);RD(a+24|0,b+16|0);RD(a+36|0,b+24|0);RD(a+48|0,b+32|0);RD(a+60|0,b+40|0);RD(a+72|0,b+48|0);RD(a+84|0,b+56|0);RD(a+96|0,b+64|0);RD(a+108|0,b+72|0);RD(a+120|0,b+80|0);RD(a+132|0,b+88|0);RD(a+144|0,b+96|0);RD(a+156|0,b+104|0);RD(a+168|0,b+112|0);RD(a+180|0,b+120|0);i=b;return}function RD(a,b){a=a|0;b=b|0;b=i;SD(a,0);i=b;return}function SD(a,b){a=a|0;b=b|0;b=i;i=i+8|0;TD(a,b);i=b;return}function TD(a,b){a=a|0;b=b|0;b=i;UD(a,0);i=b;return}function UD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;VD(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;WD(f,0,e);e=Rz(b)|0;c[(Qz(b)|0)>>2]=e;i=d;return}function VD(a){a=a|0;var b=0;b=i;ZD(a);i=b;return}function WD(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;XD(b,c,f);i=e;return}function XD(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(Uv(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;YD(d,b,f);i=e;return}function YD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(Uv(e)|0)>>2];i=d;return}function ZD(a){a=a|0;var b=0;b=i;_D(a);i=b;return}function _D(a){a=a|0;var b=0;b=i;Xv(a);i=b;return}function $D(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=c[77820>>2]|0;if((m|0)==0){n=0}else{o=gS(12)|0;RH(o,m);n=o}if((c[77736>>2]|0)!=0){c[5306]=1}if((n|0)==0){c[21236>>2]=1;c[21240>>2]=1;i=b;return}do{if((tI(n,68024,0)|0)==-1){NH(g,n);LH(h);o=c[4880]|0;m=(o|0)<28;while(1){p=tI(g,68032,0)|0;q=(p|0)!=-1;if(q){rI(j,g,0,p);YH(h,j)|0;XH(j);rI(k,g,p+1|0,-1);YH(g,k)|0;XH(k)}else{YH(h,g)|0}if(m){r=1;s=o}else{t=20;break}while(1){RH(l,c[19936+(s<<2)>>2]|0);p=aE(h,l)|0;XH(l);if(p){c[21232+(s<<2)>>2]=1;u=0}else{u=r}p=s+1|0;if((p|0)<28){r=u;s=p}else{break}}if((u|0)!=0){t=18;break}if(!q){t=23;break}}if((t|0)==18){Tn(1,1,68040,f);if(m){v=o}else{w=21784;x=c[5446]|0;Yd[x&255](1);y=sI(n)|0;z=a;A=z;c[A>>2]=y;B=4;C=B;D=68080;E=D;Vn(0,E,a)}do{p=c[21104+(v<<2)>>2]|0;c[e>>2]=c[19936+(v<<2)>>2];c[e+4>>2]=p;Tn(1,0,68064,e);v=v+1|0;}while((v|0)<28);w=21784;x=c[5446]|0;Yd[x&255](1);y=sI(n)|0;z=a;A=z;c[A>>2]=y;B=4;C=B;D=68080;E=D;Vn(0,E,a)}else if((t|0)==20){Tn(1,1,68040,d);w=21784;x=c[5446]|0;Yd[x&255](1);y=sI(n)|0;z=a;A=z;c[A>>2]=y;B=4;C=B;D=68080;E=D;Vn(0,E,a)}else if((t|0)==23){XH(h);XH(g);break}}else{o=1;do{c[21232+(o<<2)>>2]=1;o=o+1|0;}while((o|0)<28)}}while(0);c[21236>>2]=1;c[21240>>2]=1;if((c[21268>>2]|0)!=0){c[21328>>2]=1}if((c[21324>>2]|0)==1){c[21332>>2]=1}if((c[21304>>2]|0)!=0){c[21300>>2]=1}if((c[21312>>2]|0)!=0){c[21300>>2]=1}if((c[21264>>2]|0)!=0){c[21260>>2]=1}if((c[21308>>2]|0)!=0){c[21300>>2]=1}if((c[21256>>2]|0)!=0){c[21252>>2]=1}XH(n);iS(n);i=b;return}function aE(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=VH(b)|0;if((e|0)!=(VH(c)|0)){f=0;i=d;return f|0}g=WH(b)|0;h=WH(c)|0;if(OH(b)|0){f=(xx(g,h,e)|0)==0;i=d;return f|0}if((e|0)==0){f=1;i=d;return f|0}else{j=e;k=g;l=h}while(1){if((a[k]|0)!=(a[l]|0)){f=0;m=7;break}h=j+ -1|0;if((h|0)==0){f=1;m=7;break}else{j=h;k=k+1|0;l=l+1|0}}if((m|0)==7){i=d;return f|0}return 0}function bE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=c[77828>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=gS(12)|0;l=k;RH(l,h);if((k|0)==0){j=1;i=b;return j|0}else{m=1}while(1){k=m+1|0;if(cE(l,c[53120+(m<<2)>>2]|0)|0){j=m;n=6;break}if((k|0)<4){m=k}else{n=5;break}}if((n|0)==5){c[g>>2]=sI(l)|0;Tn(1,1,68112,g);g=c[53204>>2]|0;c[f>>2]=c[53124>>2];c[f+4>>2]=g;Tn(1,0,68064,f);f=c[53208>>2]|0;c[e>>2]=c[53128>>2];c[e+4>>2]=f;Tn(1,0,68064,e);e=c[53212>>2]|0;c[d>>2]=c[53132>>2];c[d+4>>2]=e;Tn(1,0,68064,d);Yd[c[5446]&255](1);Vn(0,68168,a)}else if((n|0)==6){i=b;return j|0}return 0}function cE(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(vI(a,b)|0)==0;i=c;return d|0}function dE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;a=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+16|0;g=i;i=i+16|0;h=c[77812>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=gS(12)|0;l=k;RH(l,h);if((k|0)==0){j=1;i=b;return j|0}RH(f,68192);k=aE(l,f)|0;XH(f);if(k){j=1;i=b;return j|0}RH(g,68200);k=aE(l,g)|0;XH(g);if(k){j=2;i=b;return j|0}else{c[e>>2]=sI(l)|0;Tn(1,1,68208,e);c[d>>2]=68192;c[d+4>>2]=68264;Tn(1,0,68064,d);c[a>>2]=68200;c[a+4>>2]=68280;Tn(1,0,68064,a);Yd[c[5446]&255](1);Vn(0,68168,b)}return 0}function eE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;eK(f,a);if(!(hK(f)|0)){fK(f);i=d;return a|0}j=Fx(b)|0;rE(g,a);k=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;l=k;if(((ut(l)|0)&176|0)==32){m=b+j|0}else{m=b}n=RI(k)|0;k=b+j|0;j=e;o=g;c[j+0>>2]=c[o+0>>2];uE(h,e,b,m,k,l,n);if(!(sE(h)|0)){fK(f);i=d;return a|0}LI(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,5);fK(f);i=d;return a|0}function fE(a){a=a|0;var b=0;b=i;kK(a,SI(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;TJ(a)|0;i=b;return a|0}function gE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+2128|0;g=f;h=f+32|0;j=f+48|0;k=f+64|0;l=f+80|0;RH(h,d);GI(k,68288,h);Sw(j,k,68296);XH(k);k=sI(j)|0;d=b+104|0;do{if((c[d>>2]|0)>0){m=b;n=c[m>>2]|0;if((AS(c[n+4>>2]|0,68304)|0)!=0){break}a[n+104|0]=1;a[(c[m>>2]|0)+((c[d>>2]|0)*112|0)+104|0]=1}}while(0);if((AS(k,68312)|0)==0){XH(j);XH(h);i=f;return}d=iR(g,k,1)|0;if((d|0)!=0){m=l;IS(m|0,0,2048)|0;vR(d,g,m,2048)|0;iK(eE(eE(eE(eE(eE(90216,68320)|0,k)|0,68360)|0,m)|0,68376)|0,103)|0;XH(j);XH(h);i=f;return}m=b+108|0;k=c[m>>2]|0;if((k|0)>0){d=b;l=k;k=0;while(1){n=c[d>>2]|0;if((a[n+(k*112|0)+104|0]|0)==0){o=(wR(g,c[n+(k*112|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(k*112|0)+104|0]=o;p=c[m>>2]|0}else{p=l}o=k+1|0;if((o|0)<(p|0)){l=p;k=o}else{break}}}k=b+208|0;if((c[k>>2]|0)>0){p=b+32|0;l=b;m=(e|0)==0;d=b+16|0;o=0;do{n=c[p>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){q=a[n+(o*52|0)+8|0]|0;if(q<<24>>24==1){r=(wR(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=r;r=c[p>>2]|0;if((a[r+(o*52|0)+48|0]|0)!=0|m){break}a[(c[d>>2]|0)+((c[r+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else if(q<<24>>24==0){q=(wR(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=q;q=c[p>>2]|0;if((a[q+(o*52|0)+48|0]|0)!=0){break}a[(c[l>>2]|0)+((c[q+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else{break}}}while(0);o=o+1|0;}while((o|0)<(c[k>>2]|0))}k=b+116|0;o=c[k>>2]|0;if((o|0)>0){l=b+4|0;p=o;o=0;while(1){d=c[l>>2]|0;if((a[d+(o*60|0)+56|0]|0)==0){m=(wR(g,c[d+(o*60|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(o*60|0)+56|0]=m;s=c[k>>2]|0}else{s=p}m=o+1|0;if((m|0)<(s|0)){p=s;o=m}else{break}}}o=b+212|0;if((c[o>>2]|0)>0){s=b+36|0;p=b+4|0;k=(e|0)==0;l=b+20|0;m=0;do{d=c[s>>2]|0;do{if((a[d+(m*52|0)+48|0]|0)==0){n=a[d+(m*52|0)+8|0]|0;if(n<<24>>24==0){q=(wR(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=q;q=c[s>>2]|0;if((a[q+(m*52|0)+48|0]|0)!=0){break}a[(c[p>>2]|0)+((c[q+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else if(n<<24>>24==1){n=(wR(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=n;n=c[s>>2]|0;if((a[n+(m*52|0)+48|0]|0)!=0|k){break}a[(c[l>>2]|0)+((c[n+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else{break}}}while(0);m=m+1|0;}while((m|0)<(c[o>>2]|0))}o=b+120|0;m=c[o>>2]|0;if((m|0)>0){l=b+8|0;k=m;m=0;while(1){s=c[l>>2]|0;if((a[s+(m*48|0)+44|0]|0)==0){p=(wR(g,c[s+(m*48|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(m*48|0)+44|0]=p;t=c[o>>2]|0}else{t=k}p=m+1|0;if((p|0)<(t|0)){k=t;m=p}else{break}}}m=b+216|0;if((c[m>>2]|0)>0){t=b+40|0;k=b+8|0;o=(e|0)==0;l=b+24|0;p=0;do{s=c[t>>2]|0;do{if((a[s+(p*52|0)+48|0]|0)==0){d=a[s+(p*52|0)+8|0]|0;if(d<<24>>24==1){n=(wR(g,c[s+(p*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(p*52|0)+48|0]=n;n=c[t>>2]|0;if((a[n+(p*52|0)+48|0]|0)!=0|o){break}a[(c[l>>2]|0)+((c[n+(p*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else if(d<<24>>24==0){d=(wR(g,c[s+(p*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(p*52|0)+48|0]=d;d=c[t>>2]|0;if((a[d+(p*52|0)+48|0]|0)!=0){break}a[(c[k>>2]|0)+((c[d+(p*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else{break}}}while(0);p=p+1|0;}while((p|0)<(c[m>>2]|0))}m=b+124|0;p=c[m>>2]|0;if((p|0)>0){k=b+12|0;t=p;p=0;while(1){l=c[k>>2]|0;if((a[l+(p*52|0)+48|0]|0)==0){o=(wR(g,c[l+(p*52|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[k>>2]|0)+(p*52|0)+48|0]=o;u=c[m>>2]|0}else{u=t}o=p+1|0;if((o|0)<(u|0)){t=u;p=o}else{break}}}p=b+220|0;if((c[p>>2]|0)>0){u=b+44|0;t=b+12|0;m=(e|0)==0;e=b+28|0;b=0;do{k=c[u>>2]|0;do{if((a[k+(b*52|0)+48|0]|0)==0){o=a[k+(b*52|0)+8|0]|0;if(o<<24>>24==1){l=(wR(g,c[k+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=l;l=c[u>>2]|0;if((a[l+(b*52|0)+48|0]|0)!=0|m){break}a[(c[e>>2]|0)+((c[l+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else if(o<<24>>24==0){o=(wR(g,c[k+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=o;o=c[u>>2]|0;if((a[o+(b*52|0)+48|0]|0)!=0){break}a[(c[t>>2]|0)+((c[o+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else{break}}}while(0);b=b+1|0;}while((b|0)<(c[p>>2]|0))}mR(g);XH(j);XH(h);i=f;return}function hE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0;b=i;i=i+8|0;a=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[77676>>2]|0;H=c[77804>>2]|0;I=c[2]|0;if((c[21332>>2]|0)==0){if(!((c[77624>>2]|0)==0|(I|0)!=0)){J=3}}else{J=3}if((J|0)==3){c[2]=1}J=d+248|0;K=d+240|0;L=~~+Ab(+((+h[J>>3]- +h[K>>3])/+h[d+264>>3]));c[d+256>>2]=L;c[l>>2]=L;Rn(23,0,68424,l);l=c[77748>>2]|0;do{if((l|0)==0){M=0}else{if((AS(l,68448)|0)==0){M=1;break}if((AS(l,68456)|0)==0){M=0;break}if((AS(l,68464)|0)==0){M=2;break}c[j>>2]=l;Tn(1,0,68472,j);M=0}}while(0);if((Uo(M)|0)!=0){c[g>>2]=l;Tn(1,0,68544,g)}if((c[2]|0)!=0){pF(d+56|0);Zo((c[d+64>>2]|0)+13+(c[d+68>>2]|0)+(c[d+72>>2]|0)|0);Vo(0);Vo(6);Wo(3);Wo(4);Wo(1)}g=(G|0)!=0;if(g){if((H|0)==0){N=+h[K>>3]}else{N=+wS(H)}h[J>>3]=N;J=f;h[k>>3]=N;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];Rn(1,0,68632,f)}do{if((c[77732>>2]|0)!=0){f=gS(12)|0;J=f;RH(J,c[77860>>2]|0);if((f|0)==0){break}f=sI(J)|0;c[d+280>>2]=f;c[e>>2]=f;Rn(23,0,68688,e)}}while(0);e=c[77856>>2]|0;LH(m);if((e|0)==0){RH(p,c[d+88>>2]|0);RH(q,68736);iE(o,p,q);Sw(n,o,c[d+284>>2]|0);YH(m,n)|0;XH(n);XH(o);XH(q);XH(p)}else{ZH(m,e)|0}RH(r,68744);RH(s,68744);RH(t,68744);RH(u,68744);RH(v,68744);RH(w,68744);e=c[77624>>2]|0;if((c[77644>>2]|0)!=0){ZH(r,c[77772>>2]|0)|0}if((c[77660>>2]|0)!=0){ZH(s,c[77788>>2]|0)|0}if((c[77640>>2]|0)!=0){ZH(t,c[77768>>2]|0)|0}if((c[77648>>2]|0)==0){O=0.0}else{ZH(u,c[77776>>2]|0)|0;O=+wS(sI(u)|0)}if((c[77652>>2]|0)==0){P=1}else{ZH(v,c[77780>>2]|0)|0;P=Dc(sI(v)|0)|0}if((c[77712>>2]|0)!=0){ZH(w,c[77840>>2]|0)|0}NH(x,m);NH(y,r);NH(z,s);NH(A,t);NH(B,w);p=jE(d,x,y,z,A,O,P,B,e)|0;XH(B);XH(A);XH(z);XH(y);XH(x);if((p|0)!=0|g^1){Q=p}else{Vo(5);p=GE(d)|0;Yo(5);Rn(1,0,68752,a);Q=p}c[2]=I;if(!((Q|0)==0&(I|0)!=0)){R=Q;XH(w);XH(v);XH(u);XH(t);XH(s);XH(r);XH(m);i=b;return R|0}Q=d+88|0;RH(D,c[Q>>2]|0);Sw(C,D,68784);XH(D);RH(F,c[Q>>2]|0);Sw(E,F,68800);XH(F);Yo(0);F=c[77824>>2]|0;Q=sI(C)|0;D=sI(E)|0;I=c[d+280>>2]|0;p=c[d+284>>2]|0;dF(d,Q,D,(F|0)!=0?F:68816,I,p,sI(m)|0)|0;XH(E);XH(C);R=0;XH(w);XH(v);XH(u);XH(t);XH(s);XH(r);XH(m);i=b;return R|0}function iE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;MH(a,d);e=VH(b)|0;f=VH(c)|0;wI(a,WH(b)|0,e,f+e|0);oI(a,WH(c)|0,f)|0;i=d;return}function jE(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;if((VH(j)|0)==0){u=0}else{u=sI(j)|0}NH(r,b);b=(kE(a,r,k)|0)==0;XH(r);if(!b){v=-1;i=l;return v|0}RH(s,68744);b=a+280|0;r=cE(s,c[b>>2]|0)|0;XH(s);do{if(r){w=3}else{s=1;k=0;do{RH(t,c[68960+(s<<2)>>2]|0);j=cE(t,c[b>>2]|0)|0;XH(t);k=j?s:k;s=s+1|0;}while((s|0)<20);if((k|0)!=0){w=k;break}c[q>>2]=c[b>>2];Tn(1,0,69040,q);Tn(1,0,68040,p);s=1;do{j=c[69072+(s<<2)>>2]|0;c[o>>2]=c[68960+(s<<2)>>2];c[o+4>>2]=j;Tn(1,0,68064,o);s=s+1|0;}while((s|0)<20);Vn(c[a+536>>2]|0,68168,n)}}while(0);c[m>>2]=c[68960+(w<<2)>>2];Rn(23,0,69152,m);m=sI(d)|0;d=sI(e)|0;e=Jr(a,m,d,sI(f)|0,g,h,w,u)|0;Zd[c[62404>>2]&63](62376,a);v=e;i=l;return v|0}function kE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[a+256>>2]<<2;c[15594]=rd(sI(b)|0)|0;c[62380>>2]=g;c[62384>>2]=d;d=a+284|0;do{if((c[17004]|0)==0){g=c[d>>2]|0;if((AS(68824,g)|0)==0){h=0;break}if((AS(68832,g)|0)==0){c[62392>>2]=47;c[62396>>2]=48;c[62404>>2]=49;h=0;break}if((AS(68840,g)|0)==0){c[62392>>2]=50;c[62396>>2]=51;c[62400>>2]=52;c[62404>>2]=53;h=1;break}if((AS(68848,g)|0)==0){c[62392>>2]=54;c[62396>>2]=55;c[62400>>2]=56;c[62404>>2]=57;h=1;break}if((AS(68856,g)|0)==0){c[62392>>2]=58;c[62396>>2]=59;c[62404>>2]=60;h=0;break}g=eE(90216,68864)|0;iK(eE(g,c[d>>2]|0)|0,103)|0;j=1;i=e;return j|0}else{h=0}}while(0);gE(a+8|0,c[a+288>>2]|0,h);Zd[c[62392>>2]&63](62376,a);a=c[15594]|0;c[f>>2]=c[d>>2];c[f+4>>2]=a;Rn(23,0,68888,f);j=0;i=e;return j|0}function lE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;In();do{if((xF(a,b)|0)==0){if((zF(a,b)|0)!=0){break}do{if((c[77680>>2]|0)!=0){w=c[77808>>2]|0;if((AS(w,69272)|0)==0){On(1);break}if((AS(w,69280)|0)==0){On(0);break}else{c[p>>2]=w;Tn(1,0,69288,p);md(0)|0;td(0)}}}while(0);if((c[77636>>2]|0)==0){$D(0,0);Iq(d);if((d|0)==0){iK(eE(90216,69656)|0,103)|0}c[d+300>>2]=bE(0,0)|0;c[d+292>>2]=dE(0,0)|0;Pw(d+8|0,d+240|0);Sq(d)|0;_q(d)|0;hr(d)|0;do{if((c[d+116>>2]|0)==0){if((c[d+124>>2]|0)==0){break}if((c[d+128>>2]|0)==0){break}iK(eE(90216,69720)|0,103)|0;x=1;i=e;return x|0}}while(0);c[17004]=c[77704>>2];x=0;i=e;return x|0}RH(u,c[77764>>2]|0);w=1;while(1){y=25928+(w<<2)|0;RH(v,c[y>>2]|0);z=aE(u,v)|0;XH(v);A=w+1|0;if(z){break}if((A|0)<31){w=A}else{B=33;break}}if((B|0)==33){c[g>>2]=sI(u)|0;Tn(1,0,69560,g);c[f>>2]=c[b>>2];Tn(1,0,69600,f);md(0)|0;td(0)}A=c[29952+(w<<2)>>2]|0;do{if((A|0)==1){z=c[29824+(w<<2)>>2]|0;c[o>>2]=c[y>>2];c[o+4>>2]=z;Rn(1,1,69360,o)}else{z=c[y>>2]|0;if((A|0)==2){C=c[29824+(w<<2)>>2]|0;c[n>>2]=z;c[n+4>>2]=z;c[n+8>>2]=C;Rn(1,1,69400,n);break}else{c[m>>2]=z;Tn(1,1,69240,m);break}}}while(0);if((w|0)==19){A=c[4880]|0;if((A|0)<28){D=A}else{E=21784;F=c[5446]|0;Yd[F&255](1);G=md(0)|0;td(0)}do{A=c[21104+(D<<2)>>2]|0;c[l>>2]=c[19936+(D<<2)>>2];c[l+4>>2]=A;Rn(1,0,68064,l);D=D+1|0;}while((D|0)<28);E=21784;F=c[5446]|0;Yd[F&255](1);G=md(0)|0;td(0)}else if((w|0)==7){A=1;do{z=c[69480+(A<<2)>>2]|0;c[k>>2]=c[69464+(A<<2)>>2];c[k+4>>2]=z;Rn(1,0,68064,k);A=A+1|0;}while((A|0)<4);E=21784;F=c[5446]|0;Yd[F&255](1);G=md(0)|0;td(0)}else if((w|0)==11){A=1;do{z=c[69528+(A<<2)>>2]|0;c[j>>2]=c[69496+(A<<2)>>2];c[j+4>>2]=z;Rn(1,0,68064,j);A=A+1|0;}while((A|0)<7);E=21784;F=c[5446]|0;Yd[F&255](1);G=md(0)|0;td(0)}else if((w|0)==29){A=1;do{z=c[69072+(A<<2)>>2]|0;c[h>>2]=c[68960+(A<<2)>>2];c[h+4>>2]=z;Rn(1,0,68064,h);A=A+1|0;}while((A|0)<20);E=21784;F=c[5446]|0;Yd[F&255](1);G=md(0)|0;td(0)}else{E=21784;F=c[5446]|0;Yd[F&255](1);G=md(0)|0;td(0)}}}while(0);c[t>>2]=c[b>>2];Rn(1,1,69176,t);t=1;do{b=c[29952+(t<<2)>>2]|0;do{if((b|0)==1){G=c[27832+(t<<2)>>2]|0;c[s>>2]=c[25928+(t<<2)>>2];c[s+4>>2]=G;Rn(1,0,69192,s)}else{G=c[25928+(t<<2)>>2]|0;if((b|0)==2){F=c[27832+(t<<2)>>2]|0;c[r>>2]=G;c[r+4>>2]=G;c[r+8>>2]=F;Rn(1,0,69208,r);break}else{c[q>>2]=G;Tn(1,0,69240,q);break}}}while(0);t=t+1|0;}while((t|0)<31);Yd[c[5446]&255](1);md(0)|0;td(0);return 0}function mE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0;a=i;i=i+8|0;b=a;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=c[17438]|0;sb(71336)|0;c[l>>2]=c[m+88>>2];fc(69760,l|0)|0;sb(71352)|0;l=j;h[k>>3]=+h[m+264>>3];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];fc(69784,j|0)|0;j=m+4|0;m=g;h[k>>3]=+h[c[(c[j>>2]|0)+4>>2]>>3];c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];fc(69824,g|0)|0;g=f;h[k>>3]=+h[c[(c[j>>2]|0)+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];fc(69856,f|0)|0;f=c[j>>2]|0;g=e;h[k>>3]=+h[c[f+4>>2]>>3]- +h[c[f+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];fc(69888,e|0)|0;e=d;h[k>>3]=+h[c[c[j>>2]>>2]>>3];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];fc(69920,d|0)|0;d=c[j>>2]|0;j=b;h[k>>3]=+h[c[d>>2]>>3]- +h[c[d+4>>2]>>3];c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];fc(69952,b|0)|0;sb(71376)|0;i=a;return}function nE(a,b){a=a|0;b=+b;i=i;return}function oE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;e=i;f=i;i=i+168|0;c[f>>2]=0;g=i;i=i+160|0;h=(c[d+536>>2]|0)+76|0;j=c[h>>2]|0;c[h>>2]=g;DS(g,1,f|0)|0;u=0;g=u;u=0;if((g|0)!=0&(v|0)!=0){k=RS(c[g>>2]|0,f)|0;if((k|0)==0){db(g|0,v|0)}J=v}else{k=-1}if((k|0)==1){l=J}else{l=0}while(1){if((l|0)==0){u=0;k=ua(40,a|0,b|0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){m=RS(c[g>>2]|0,f)|0;if((m|0)==0){db(g|0,v|0)}J=v}else{m=-1}if((m|0)==1){l=J;continue}if((k|0)!=0){n=1;o=17;break}c[17438]=d;u=0;Ga(58,10,167)|0;k=u;u=0;if((k|0)!=0&(v|0)!=0){p=RS(c[k>>2]|0,f)|0;if((p|0)==0){db(k|0,v|0)}J=v}else{p=-1}if((p|0)==1){l=J;continue}u=0;k=ua(41,0,0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){q=RS(c[g>>2]|0,f)|0;if((q|0)==0){db(g|0,v|0)}J=v}else{q=-1}if((q|0)==1){l=J;continue}u=0;sa(108,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){r=RS(c[g>>2]|0,f)|0;if((r|0)==0){db(g|0,v|0)}J=v}else{r=-1}if((r|0)==1){l=J;continue}u=0;sa(109,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){s=RS(c[g>>2]|0,f)|0;if((s|0)==0){db(g|0,v|0)}J=v}else{s=-1}if((s|0)==1){l=J;continue}u=0;sa(110,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){t=RS(c[g>>2]|0,f)|0;if((t|0)==0){db(g|0,v|0)}J=v}else{t=-1}if((t|0)==1){l=J;continue}u=0;pa(c[(c[d+540>>2]|0)+8>>2]|0,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){w=RS(c[g>>2]|0,f)|0;if((w|0)==0){db(g|0,v|0)}J=v}else{w=-1}if((w|0)==1){l=J;continue}u=0;pa(168,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){x=RS(c[g>>2]|0,f)|0;if((x|0)==0){db(g|0,v|0)}J=v}else{x=-1}if((x|0)==1){l=J;continue}u=0;sa(99,0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){y=RS(c[g>>2]|0,f)|0;if((y|0)==0){db(g|0,v|0)}J=v}else{y=-1}if((y|0)==1){l=J;continue}z=k}else{z=-1}c[h>>2]=j;u=0;k=u;u=0;if((k|0)!=0&(v|0)!=0){A=RS(c[k>>2]|0,f)|0;if((A|0)==0){db(k|0,v|0)}J=v}else{A=-1}if((A|0)==1){l=J}else{break}}if((o|0)==17){i=e;return n|0}n=z;i=e;return n|0}function pE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;f=i;i=i+16|0;if((a|0)==0){g=gd(c[4878]|0)|0}else{g=a}switch(c[g+84>>2]|0){case 2:{if((c[21244>>2]|0)==0){h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;db(n|0,1)}c[f>>2]=e;a=c[r>>2]|0;pc(70024,7,1,a|0)|0;Bc(a|0,d|0,f|0)|0;Jd(10,a|0)|0;md(0)|0;h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;db(n|0,1);break};case 1:{c[f>>2]=e;n=c[r>>2]|0;pc(70024,7,1,n|0)|0;Bc(n|0,d|0,f|0)|0;Jd(10,n|0)|0;md(0)|0;db(c[g+80>>2]|0,1);break};case 5:case 4:{i=b;return};case 3:{if((c[21300>>2]|0)==0){i=b;return}c[f>>2]=e;e=c[r>>2]|0;pc(70024,7,1,e|0)|0;Bc(e|0,d|0,f|0)|0;Jd(10,e|0)|0;md(0)|0;i=b;return};default:{Vn(g,70032,b)}}}function qE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=d;d=c[r>>2]|0;pc(70008,9,1,d|0)|0;Bc(d|0,b|0,e|0)|0;Jd(10,d|0)|0;md(0)|0;i=a;return}function rE(a,b){a=a|0;b=b|0;var c=0;c=i;tE(a,b);i=c;return}function sE(a){a=a|0;i=i;return(c[a>>2]|0)==0|0}function tE(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=QI(b+(c[(c[b>>2]|0)+ -12>>2]|0)|0)|0;i=d;return}function uE(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+8|0;l=j+16|0;m=j+32|0;n=j+40|0;o=b;b=c[o>>2]|0;qt(j);if((b|0)==0){c[a>>2]=0;i=j;return}p=f;f=d;q=p-f|0;r=vE(g)|0;s=(r|0)>(q|0)?r-q|0:0;q=e;r=q-f|0;do{if((r|0)>0){if((aJ(b,d,r)|0)==(r|0)){break}qt(k);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);do{if((s|0)>0){SH(l,s,h);if((aJ(b,WH(l)|0,s)|0)==(s|0)){XH(l);break}qt(m);c[o>>2]=0;c[a>>2]=0;XH(l);i=j;return}}while(0);l=p-q|0;do{if((l|0)>0){if((aJ(b,e,l)|0)==(l|0)){break}qt(n);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);wE(g,0)|0;c[a>>2]=b;i=j;return}function vE(a){a=a|0;i=i;return c[a+12>>2]|0}function wE(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function xE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+136|0;g=f;yE(g,16);zE(g+(c[(c[g>>2]|0)+ -12>>2]|0)|0,16)|0;if((d|0)<=0){AE(a,g);BE(g);i=f;return}j=e+ -1|0;k=(j|0)>0;l=(e|0)>0;m=g;n=(e|0)==0;e=0;do{if(k){o=0;p=e;while(1){eE(jK(m,+h[b+(p<<3)>>3])|0,71392)|0;q=p+d|0;r=o+1|0;if((r|0)<(j|0)){p=q;o=r}else{s=q;break}}}else{s=e}if(l){jK(m,+h[b+(s<<3)>>3])|0}e=e+1|0;if(!((e|0)==(d|0)|n)){eE(m,71400)|0}}while((e|0)<(d|0));AE(a,g);BE(g);i=f;return}function yE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+56|0;UI(e);f=a;c[f>>2]=71772;g=e;c[g>>2]=71792;e=a+4|0;$J(a,71804|0,e);c[f>>2]=71772;c[g>>2]=71792;NE(e,b|16);i=d;return}function zE(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function AE(a,b){a=a|0;b=b|0;var c=0;c=i;HE(a,b+4|0);i=c;return}function BE(a){a=a|0;var b=0;b=i;RE(a,71800);PI(a+56|0);i=b;return}function CE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+120>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[21288>>2]|0)!=0){sb(72096)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Rn(14,0,71408,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);$d[c[(c[l>>2]|0)+160>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Rn(14,0,71480,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[21288>>2]|0)==0){i=d;return 0}Rn(14,0,71528,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];fc(71544,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}cc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function DE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+124>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[21288>>2]|0)!=0){sb(72096)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Rn(14,0,71408,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);$d[c[(c[l>>2]|0)+164>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Rn(14,0,71480,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[21288>>2]|0)==0){i=d;return 0}Rn(14,0,71528,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];fc(71544,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}cc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function EE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+128>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[21288>>2]|0)!=0){sb(72096)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Rn(14,0,71408,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);$d[c[(c[l>>2]|0)+168>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Rn(14,0,71480,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[21288>>2]|0)==0){i=d;return 0}Rn(14,0,71528,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];fc(71544,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}cc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function FE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+132>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[21288>>2]|0)!=0){sb(72096)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Rn(14,0,71408,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);$d[c[(c[l>>2]|0)+172>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Rn(14,0,71480,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[21288>>2]|0)==0){i=d;return 0}Rn(14,0,71528,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];fc(71544,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}cc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function GE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+24|0;d=b;e=i;i=i+24|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=c[a+112>>2]|0;G=c[a+152>>2]|0;H=c[a+156>>2]|0;I=cS(fa(F,F)|0,8)|0;J=I;K=cS(fa(G,F)|0,8)|0;L=K;M=cS(fa(H,F)|0,8)|0;N=M;O=cS(fa(H,G)|0,8)|0;P=O;LH(p);LH(q);LH(r);LH(s);LH(t);LH(u);LH(v);Q=a+536|0;Un(c[Q>>2]|0,(I|0)!=0|0,71552,o);Un(c[Q>>2]|0,(K|0)!=0|0,71552,n);Un(c[Q>>2]|0,(M|0)!=0|0,71552,m);Un(c[Q>>2]|0,(O|0)!=0|0,71552,l);l=a+540|0;m=a;if(($d[c[(c[l>>2]|0)+140>>2]&127](m)|0)==0){n=c[Q>>2]|0;CE(a,J)|0;Un(n,1,71568,k)}xE(w,J,F,F);YH(p,w)|0;XH(w);if(($d[c[(c[l>>2]|0)+144>>2]&127](m)|0)==0){w=c[Q>>2]|0;DE(a,L)|0;Un(w,1,71600,j)}xE(x,L,F,G);YH(q,x)|0;XH(x);if(($d[c[(c[l>>2]|0)+148>>2]&127](m)|0)==0){x=c[Q>>2]|0;EE(a,N)|0;Un(x,1,71632,h)}xE(y,N,H,F);YH(r,y)|0;XH(y);if(($d[c[(c[l>>2]|0)+152>>2]&127](m)|0)==0){m=c[Q>>2]|0;FE(a,P)|0;Un(m,1,71664,g)}xE(z,P,H,G);YH(s,z)|0;XH(z);if((F|0)==0){ZH(t,71696)|0}else{xE(A,c[(c[c[a+4>>2]>>2]|0)+8>>2]|0,1,F);YH(t,A)|0;XH(A)}if((G|0)==0){ZH(u,71696)|0}else{xE(B,c[a+432>>2]|0,1,G);YH(u,B)|0;XH(B)}bS(I);bS(K);bS(M);bS(O);RH(E,c[a+84>>2]|0);GI(D,71712,E);Sw(C,D,71720);YH(v,C)|0;XH(C);XH(D);XH(E);E=hc(sI(v)|0,71728)|0;D=c[Q>>2]|0;c[f>>2]=sI(v)|0;Un(D,(E|0)!=0|0,71736,f);f=se[c[(c[l>>2]|0)+176>>2]&7]()|0;D=sI(t)|0;Q=sI(u)|0;C=sI(p)|0;a=sI(q)|0;O=sI(r)|0;M=sI(s)|0;c[e>>2]=D;c[e+4>>2]=Q;c[e+8>>2]=C;c[e+12>>2]=a;c[e+16>>2]=O;c[e+20>>2]=M;od(E|0,f|0,e|0)|0;if((c[21332>>2]|0)==0){R=md(E|0)|0;S=Vc(E|0)|0;XH(v);XH(u);XH(t);XH(s);XH(r);XH(q);XH(p);i=b;return 0}e=se[c[(c[l>>2]|0)+176>>2]&7]()|0;l=sI(t)|0;f=sI(u)|0;M=sI(p)|0;O=sI(q)|0;a=sI(r)|0;C=sI(s)|0;c[d>>2]=l;c[d+4>>2]=f;c[d+8>>2]=M;c[d+12>>2]=O;c[d+16>>2]=a;c[d+20>>2]=C;Rn(25,0,e,d);R=md(E|0)|0;S=Vc(E|0)|0;XH(v);XH(u);XH(t);XH(s);XH(r);XH(q);XH(p);i=b;return 0}function HE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;h=c[b+48>>2]|0;if((h&16|0)!=0){j=b+44|0;k=c[j>>2]|0;l=b;m=iJ(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}IE(a,hJ(l)|0,n,e);i=d;return}if((h&8|0)==0){MH(a,g);i=d;return}else{g=b;b=cJ(g)|0;IE(a,b,eJ(g)|0,f);i=d;return}}function IE(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;JE(a,b,c,0);i=d;return}function JE(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;KE(a,b,c);i=d;return}function KE(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=LE(c,d)|0;if(g>>>0>4294967279){JH(0)}if(g>>>0<11){bI(b,g);h=aI(b)|0}else{j=iI(g)|0;k=j+1|0;j=Cx(QH(b)|0,k)|0;kI(b,j);jI(b,k);$H(b,g);h=j}if((c|0)==(d|0)){l=h;a[f]=0;Dx(l,f);i=e;return}j=d+(0-c)|0;g=c;c=h;while(1){Dx(c,g);b=g+1|0;if((b|0)==(d|0)){break}else{c=c+1|0;g=b}}l=h+j|0;a[f]=0;Dx(l,f);i=e;return}function LE(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=ME(b,c,e)|0;i=d;return g|0}function ME(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return b-a|0}function NE(a,b){a=a|0;b=b|0;var c=0;c=i;bF(a,b);i=c;return}function OE(a){a=a|0;var b=0;b=i;BE(a);iS(a);i=b;return}function PE(a){a=a|0;var b=0;b=i;BE(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function QE(a){a=a|0;var b=0;b=i;OE(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function RE(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];SE(a+4|0);i=d;return}function SE(a){a=a|0;var b=0;b=i;TE(a);i=b;return}function TE(a){a=a|0;var b=0;b=i;c[a>>2]=71952;XH(a+32|0);YI(a);i=b;return}function UE(a){a=a|0;var b=0;b=i;SE(a);iS(a);i=b;return}function VE(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=b+44|0;k=c[j>>2]|0;l=b;m=iJ(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}k=g&24;do{if((k|0)==24){if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}Es(a,-1,-1);i=h;return}else if((k|0)==0){Es(a,-1,-1);i=h;return}else{if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}if((g&8|0)==0){m=iJ(l)|0;j=m-(hJ(l)|0)|0;p=j;q=((j|0)<0)<<31>>31;break}else{j=dJ(l)|0;m=j-(cJ(l)|0)|0;p=m;q=((m|0)<0)<<31>>31;break}}}while(0);if((o|0)==11){f=n-(WH(b+32|0)|0)|0;p=f;q=((f|0)<0)<<31>>31}else if((o|0)==12){Es(a,-1,-1);i=h;return}o=OS(p|0,q|0,d|0,e|0)|0;e=J;do{if(!((e|0)<0|(e|0)==0&o>>>0<0)){d=n-(WH(b+32|0)|0)|0;q=((d|0)<0)<<31>>31;if((q|0)<(e|0)|(q|0)==(e|0)&d>>>0<o>>>0){break}d=g&8;do{if(!((o|0)==0&(e|0)==0)){do{if((d|0)!=0){if((dJ(l)|0)!=0){break}Es(a,-1,-1);i=h;return}}while(0);if((g&16|0)==0){break}if((iJ(l)|0)!=0){break}Es(a,-1,-1);i=h;return}}while(0);if((d|0)!=0){q=cJ(l)|0;gJ(l,q,q+o|0,n)}if((g&16|0)!=0){q=hJ(l)|0;lJ(l,q,jJ(l)|0);kJ(l,o)}Es(a,o,e);i=h;return}}while(0);Es(a,-1,-1);i=h;return}function WE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[b>>2]|0)+16>>2]|0;h=St(d)|0;he[g&31](a,b,h,J,0,e);i=f;return}function XE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+44|0;f=c[e>>2]|0;g=b;h=iJ(g)|0;if(f>>>0<h>>>0){c[e>>2]=h;j=h}else{j=f}if((c[b+48>>2]&8|0)==0){k=-1;i=d;return k|0}if((eJ(g)|0)>>>0<j>>>0){b=cJ(g)|0;gJ(g,b,dJ(g)|0,j)}j=dJ(g)|0;if(!(j>>>0<(eJ(g)|0)>>>0)){k=-1;i=d;return k|0}k=ou(a[j]|0)|0;i=d;return k|0}function YE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+44|0;g=c[f>>2]|0;h=b;j=iJ(h)|0;if(g>>>0<j>>>0){c[f>>2]=j;k=j}else{k=g}g=cJ(h)|0;j=dJ(h)|0;if(!(g>>>0<j>>>0)){l=-1;i=e;return l|0}if(ku(d,-1)|0){gJ(h,g,j+ -1|0,k);l=nu(d)|0;i=e;return l|0}g=(c[b+48>>2]&16|0)==0;b=lu(d)|0;do{if(g){if(pu(b,a[j+ -1|0]|0)|0){break}else{l=-1}i=e;return l|0}}while(0);j=cJ(h)|0;gJ(h,j,(dJ(h)|0)+ -1|0,k);a[dJ(h)|0]=b;l=d;i=e;return l|0}function ZE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;if(ku(b,-1)|0){f=nu(b)|0;i=d;return f|0}g=a;h=dJ(g)|0;j=h-(cJ(g)|0)|0;h=iJ(g)|0;do{if((h|0)==(jJ(g)|0)){k=a+48|0;if((c[k>>2]&16|0)==0){f=-1;i=d;return f|0}else{l=hJ(g)|0;m=a+44|0;n=(c[m>>2]|0)-l|0;o=a+32|0;nI(o,0);gI(o,dI(o)|0);p=WH(o)|0;lJ(g,p,p+(VH(o)|0)|0);kJ(g,h-l|0);c[m>>2]=(hJ(g)|0)+n;q=k;r=m;break}}else{q=a+48|0;r=a+44|0}}while(0);c[e>>2]=(iJ(g)|0)+1;h=c[(_E(e,r)|0)>>2]|0;c[r>>2]=h;if((c[q>>2]&8|0)!=0){q=WH(a+32|0)|0;gJ(g,q,q+j|0,h)}f=$I(g,b&255)|0;i=d;return f|0}function _E(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=$E(b,c,e)|0;i=d;return g|0}function $E(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=aF(0,a,b)|0;i=c;return(d?b:a)|0}function aF(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function bF(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;bJ(a);c[a>>2]=71952;LH(a+32|0);c[a+44>>2]=0;c[a+48>>2]=b;LH(e);cF(a,e);XH(e);i=d;return}function cF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+32|0;YH(e,b)|0;b=a+44|0;c[b>>2]=0;f=a+48|0;g=c[f>>2]|0;if((g&8|0)==0){h=g}else{g=WH(e)|0;j=g+(VH(e)|0)|0;c[b>>2]=j;g=WH(e)|0;gJ(a,g,g,j);h=c[f>>2]|0}if((h&16|0)==0){i=d;return}h=VH(e)|0;c[b>>2]=(WH(e)|0)+h;gI(e,dI(e)|0);b=a;a=WH(e)|0;lJ(b,a,a+(VH(e)|0)|0);if((c[f>>2]&3|0)==0){i=d;return}kJ(b,h);i=d;return}function dF(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0;j=i;i=i+8|0;g=j;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=hc(d|0,72376)|0;J=Zc(72384,72376)|0;K=(J|0)!=0;L=Lc()|0;if(K){M=c[b+536>>2]|0;N=Nd(c[L>>2]|0)|0;c[E>>2]=d;c[E+4>>2]=N;Un(M,(I|0)!=0|0,72440,E);pc(72464,17,1,J|0)|0;pc(72488,10,1,J|0)|0;pc(72504,18,1,J|0)|0;eF(J,f,72528,c[b+88>>2]|0,(c[b+72>>2]|0)+(c[b+64>>2]|0)|0,-1,999,72560)}else{c[G>>2]=Nd(c[L>>2]|0)|0;Tn(26,0,72392,G);G=c[b+536>>2]|0;E=Nd(c[L>>2]|0)|0;c[F>>2]=d;c[F+4>>2]=E;Un(G,(I|0)!=0|0,72440,F)}pc(72568,348,1,I|0)|0;if((qc(H|0)|0)<0){c[D>>2]=Nd(c[L>>2]|0)|0;Tn(26,0,72920,D);Vc(I|0)|0;$a(J|0)|0;O=1;i=j;return O|0}if((Qc(72120,250,72944,fd(H|0)|0)|0)==0){Tn(26,0,72968,C);Vc(I|0)|0;O=1;i=j;return O|0}pc(72992,13,1,I|0)|0;pc(73008,12,1,I|0)|0;fF(I,2);pc(73024,6,1,I|0)|0;gF(I,c[b+84>>2]|0);pc(73032,8,1,I|0)|0;fF(I,2);pc(73048,8,1,I|0)|0;C=b+88|0;gF(I,c[C>>2]|0);pc(73064,10,1,I|0)|0;fF(I,2);pc(73080,6,1,I|0)|0;gF(I,72120);pc(73088,8,1,I|0)|0;fF(I,2);pc(73104,8,1,I|0)|0;gF(I,c[b+280>>2]|0);pc(73120,10,1,I|0)|0;fF(I,2);pc(73136,14,1,I|0)|0;gF(I,c[b+284>>2]|0);pc(73152,16,1,I|0)|0;fF(I,2);pc(73176,16,1,I|0)|0;gF(I,l);pc(73200,18,1,I|0)|0;fF(I,2);c[B>>2]=hF(l)|0;od(I|0,73224,B|0)|0;fF(I,2);P=+Qo(7);B=A;h[k>>3]=P;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];od(I|0,73264,A|0)|0;fF(I,2);P=+Qo(6);A=z;h[k>>3]=P;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];od(I|0,73304,z|0)|0;fF(I,2);P=+Qo(1);z=y;h[k>>3]=P;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];od(I|0,73336,y|0)|0;fF(I,2);P=+Qo(4);y=x;h[k>>3]=P;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];od(I|0,73368,x|0)|0;fF(I,2);P=+Qo(3);x=w;h[k>>3]=P;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];od(I|0,73400,w|0)|0;fF(I,2);P=+Qo(5);w=v;h[k>>3]=P;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];od(I|0,73432,v|0)|0;fF(I,2);P=+Qo(0);v=u;h[k>>3]=P;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];od(I|0,73472,u|0)|0;fF(I,2);P=+To(2);u=t;h[k>>3]=P;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];od(I|0,73504,t|0)|0;fF(I,2);c[s>>2]=Oo(2)|0;od(I|0,73544,s|0)|0;fF(I,2);P=+So(2);s=r;h[k>>3]=P;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];od(I|0,73568,r|0)|0;pc(73600,13,1,I|0)|0;pc(73616,16,1,I|0)|0;fF(I,2);P=+Qo(8);r=q;h[k>>3]=P;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];od(I|0,73640,q|0)|0;fF(I,2);c[p>>2]=Lo(8)|0;od(I|0,73664,p|0)|0;pc(73704,17,1,I|0)|0;pc(73728,22,1,I|0)|0;iF(I,b);pc(73752,23,1,I|0)|0;pc(73776,12,1,I|0)|0;p=b+116|0;if((c[p>>2]|0)>0){q=b+8|0;r=0;do{jF(I,(c[q>>2]|0)+(r*112|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+136|0;if((c[p>>2]|0)>0){r=b+24|0;q=0;do{jF(I,(c[r>>2]|0)+(q*112|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+124|0;if((c[p>>2]|0)>0){q=b+12|0;r=0;do{jF(I,(c[q>>2]|0)+(r*60|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+140|0;if((c[p>>2]|0)>0){r=b+28|0;q=0;do{jF(I,(c[r>>2]|0)+(q*60|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+128|0;if((c[p>>2]|0)>0){q=b+16|0;r=0;do{jF(I,(c[q>>2]|0)+(r*48|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+144|0;if((c[p>>2]|0)>0){r=b+32|0;q=0;do{jF(I,(c[r>>2]|0)+(q*48|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+132|0;if((c[p>>2]|0)>0){q=b+20|0;r=0;do{jF(I,(c[q>>2]|0)+(r*52|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+148|0;if((c[p>>2]|0)>0){r=b+36|0;q=0;do{jF(I,(c[r>>2]|0)+(q*52|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}pc(73792,13,1,I|0)|0;pc(73808,12,1,I|0)|0;kF(I,J,f,c[C>>2]|0,b);pc(73824,13,1,I|0)|0;pc(73840,12,1,I|0)|0;lF(I,c[b+68>>2]|0,b+56|0);pc(73856,13,1,I|0)|0;pc(73872,16,1,I|0)|0;mF(I,J,f,b);pc(73896,17,1,I|0)|0;pc(73920,14,1,I|0)|0;Vc(I|0)|0;if(!K){O=0;i=j;return O|0}K=c[b+508>>2]|0;b=((ES(e|0)|0)<<1)+230|0;e=(K|0)!=0;if(e){Q=(ES(K|0)|0)<<1}else{Q=0}I=aS(b+Q|0)|0;if((I|0)==0){bb(73936,73944,404,73968)}if(($a(J|0)|0)!=0){Tn(26,0,73984,o)}if(e){e=c[C>>2]|0;c[n>>2]=74016;c[n+4>>2]=e;c[n+8>>2]=K;c[n+12>>2]=e;gc(I|0,74032,n|0)|0;if((kd(I|0)|0)!=0){R=42}}else{n=I+0|0;e=74112|0;K=n+25|0;do{a[n]=a[e]|0;n=n+1|0;e=e+1|0}while((n|0)<(K|0));R=42}if((R|0)==42){c[m>>2]=I;Tn(1,0,74144,m)}m=c[C>>2]|0;c[g>>2]=m;c[g+4>>2]=m;Rn(1,0,74208,g);bS(I);O=0;i=j;return O|0}function eF(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0;m=i;i=i+24|0;n=m;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+24|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+24|0;C=i;i=i+8|0;D=i;i=i+16|0;if((a|0)==0){i=m;return}E=(g|0)>-1;if(E){F=g+9|0;G=Mo(F)|0;H=No(F)|0;if((G|0)==0){I=-.01}else{I=+(G>>>0)*.95}if((H|0)==0){J=.01}else{J=+(H>>>0)*1.05}K=H;L=G;M=+So(F)*1.01+1.0e-30;N=J;O=I}else{K=0;L=0;M=0.0;N=0.0;O=0.0}pc(72464,17,1,a|0)|0;pc(75376,12,1,a|0)|0;pc(75392,12,1,a|0)|0;pc(75408,13,1,a|0)|0;c[D>>2]=e;c[D+4>>2]=l;c[D+8>>2]=j;od(a|0,75424,D|0)|0;pc(75464,10,1,a|0)|0;pc(75480,11,1,a|0)|0;pc(75496,11,1,a|0)|0;pc(75512,10,1,a|0)|0;if(E){D=C;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];od(a|0,75528,C|0)|0}else{pc(75552,17,1,a|0)|0}C=g+3|0;c[B>>2]=e;c[B+4>>2]=f;c[B+8>>2]=f;c[B+12>>2]=C;c[B+16>>2]=C;c[B+20>>2]=4;od(a|0,75152,B|0)|0;pc(75576,13,1,a|0)|0;if(E){pc(75392,12,1,a|0)|0;if((L|0)==(K|0)){B=A;h[k>>3]=O;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=N;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];od(a|0,75592,A|0)|0}else{pc(75552,17,1,a|0)|0}c[z>>2]=e;c[z+4>>2]=l;c[z+8>>2]=j;od(a|0,75616,z|0)|0;c[y>>2]=e;c[y+4>>2]=f;c[y+8>>2]=f;c[y+12>>2]=g+1;c[y+16>>2]=4;od(a|0,75272,y|0)|0;pc(75664,10,1,a|0)|0;pc(75680,10,1,a|0)|0;pc(75664,10,1,a|0)|0;pc(75696,11,1,a|0)|0;c[x>>2]=b;od(a|0,75712,x|0)|0;c[w>>2]=d;od(a|0,75736,w|0)|0;pc(75752,33,1,a|0)|0;pc(75792,32,1,a|0)|0;c[v>>2]=e;c[v+4>>2]=l;c[v+8>>2]=j;c[v+12>>2]=b;od(a|0,75832,v|0)|0;pc(75512,10,1,a|0)|0;v=u;h[k>>3]=M;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];od(a|0,75528,u|0)|0}else{pc(75680,10,1,a|0)|0;pc(75664,10,1,a|0)|0;pc(75696,11,1,a|0)|0;c[t>>2]=b;od(a|0,75712,t|0)|0;c[s>>2]=d;od(a|0,75736,s|0)|0;pc(75752,33,1,a|0)|0;pc(75792,32,1,a|0)|0;c[r>>2]=e;c[r+4>>2]=l;c[r+8>>2]=j;c[r+12>>2]=b;od(a|0,75832,r|0)|0;pc(75512,10,1,a|0)|0;pc(75552,17,1,a|0)|0}c[q>>2]=e;c[q+4>>2]=f;c[q+8>>2]=f;c[q+12>>2]=C;c[q+16>>2]=C;c[q+20>>2]=2;od(a|0,75152,q|0)|0;pc(75576,13,1,a|0)|0;if(!E){i=m;return}if((L|0)==(K|0)){K=p;h[k>>3]=O;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=p+8|0;h[k>>3]=N;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];od(a|0,75592,p|0)|0}else{pc(75552,17,1,a|0)|0}pc(75864,32,1,a|0)|0;pc(75904,29,1,a|0)|0;c[o>>2]=e;c[o+4>>2]=l;c[o+8>>2]=j;c[o+12>>2]=b;od(a|0,75936,o|0)|0;c[n>>2]=e;c[n+4>>2]=f;c[n+8>>2]=f;c[n+12>>2]=g+1;c[n+16>>2]=2;od(a|0,75272,n|0)|0;i=m;return}function fF(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)==0){i=c;return}else{d=b}do{d=d+ -1|0;Jd(32,a|0)|0;}while((d|0)!=0);i=c;return}function gF(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;e=a[c]|0;if(e<<24>>24==0){i=d;return}else{f=c;g=e}do{e=g<<24>>24;if((e|0)==39){pc(75136,6,1,b|0)|0}else if((e|0)==34){pc(75144,6,1,b|0)|0}else if((e|0)==62){pc(75128,4,1,b|0)|0}else if((e|0)==60){pc(75120,4,1,b|0)|0}else{Jd(e|0,b|0)|0}f=f+1|0;g=a[f]|0;}while(!(g<<24>>24==0));i=d;return}function hF(a){a=a|0;var b=0,c=0,d=0;b=i;c=hc(a|0,75112)|0;if((c|0)==0){d=-1;i=b;return d|0}Tc(c|0,0,2)|0;a=xb(c|0)|0;Vc(c|0)|0;d=a;i=b;return d|0}function iF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;h=i;i=i+24|0;j=i;i=i+32|0;k=i;i=i+24|0;l=c[b+88>>2]|0;m=aS((ES(l|0)|0)+15|0)|0;c[f>>2]=l;gc(m|0,74840,f|0)|0;fF(a,2);pc(74856,10,1,a|0)|0;gF(a,m);pc(74872,12,1,a|0)|0;fF(a,2);c[e>>2]=hF(m)|0;od(a|0,74888,e|0)|0;bS(m);fF(a,2);pc(74920,9,1,a|0)|0;fF(a,4);pc(74936,22,1,a|0)|0;fF(a,4);pc(74960,22,1,a|0)|0;fF(a,4);pc(74984,26,1,a|0)|0;m=b+56|0;e=b+64|0;f=c[e>>2]|0;if((f|0)>0){l=g+4|0;n=0;while(1){oF(g,m,n);o=c[l>>2]|0;fF(a,4);pc(75016,8,1,a|0)|0;gF(a,o);pc(75032,18,1,a|0)|0;o=n+1|0;p=c[e>>2]|0;if((o|0)<(p|0)){n=o}else{q=p;break}}}else{q=f}f=b+72|0;b=c[f>>2]|0;if((b|0)>0){n=h+8|0;l=0;do{tF(h,m,l);g=c[n>>2]|0;fF(a,4);pc(75016,8,1,a|0)|0;gF(a,g);pc(75032,18,1,a|0)|0;l=l+1|0;r=c[f>>2]|0;}while((l|0)<(r|0));s=r;t=c[e>>2]|0}else{s=b;t=q}if((t|0)>0){t=j+4|0;q=0;do{oF(j,m,q);b=c[t>>2]|0;fF(a,4);pc(75056,8,1,a|0)|0;gF(a,b);pc(75072,21,1,a|0)|0;q=q+1|0;}while((q|0)<(c[e>>2]|0));u=c[f>>2]|0}else{u=s}if((u|0)<=0){fF(a,2);v=75096;w=v;x=pc(w|0,10,1,a|0)|0;i=d;return}u=k+8|0;s=0;do{tF(k,m,s);e=c[u>>2]|0;fF(a,4);pc(75056,8,1,a|0)|0;gF(a,e);pc(75072,21,1,a|0)|0;s=s+1|0;}while((s|0)<(c[f>>2]|0));fF(a,2);v=75096;w=v;x=pc(w|0,10,1,a|0)|0;i=d;return}function jF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+24|0;fF(a,2);c[f>>2]=c[b>>2];od(a|0,74776,f|0)|0;gF(a,c[b+4>>2]|0);pc(74808,11,1,a|0)|0;gF(a,c[b+8>>2]|0);pc(74480,3,1,a|0)|0;f=e;g=b+12|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];nF(a,4,e);fF(a,2);pc(74824,12,1,a|0)|0;i=d;return}function kF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+32|0;q=f+64|0;if((c[q>>2]|0)<=0){i=g;return}r=f+56|0;s=p+4|0;t=f+72|0;f=p;u=p+8|0;v=0;do{oF(p,r,v);eF(b,d,c[s>>2]|0,e,(c[t>>2]|0)+(c[q>>2]|0)|0,v,c[f>>2]|0,74592);w=v+9|0;Wo(w);fF(a,2);c[o>>2]=c[f>>2];od(a|0,74600,o|0)|0;fF(a,4);pc(73024,6,1,a|0)|0;gF(a,c[s>>2]|0);pc(73032,8,1,a|0)|0;fF(a,4);c[n>>2]=Oo(w)|0;od(a|0,74376,n|0)|0;fF(a,4);x=+To(w);y=m;h[k>>3]=x;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];od(a|0,74400,m|0)|0;fF(a,4);x=+So(w);w=l;h[k>>3]=x;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];od(a|0,73568,l|0)|0;w=j;y=u;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];nF(a,6,j);fF(a,2);pc(74624,12,1,a|0)|0;v=v+1|0;}while((v|0)<(c[q>>2]|0));i=g;return}function lF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;if((b|0)<=0){i=e;return}q=l;r=m+8|0;s=n+12|0;t=d+8|0;u=d+16|0;v=o;w=p;x=0;do{fF(a,2);sF(l,d,x);c[j>>2]=c[q>>2];od(a|0,74448,j|0)|0;sF(m,d,x);gF(a,c[r>>2]|0);pc(74480,3,1,a|0)|0;fF(a,4);pc(74488,7,1,a|0)|0;sF(n,d,x);if((c[s>>2]|0)>0){y=0;do{fF(a,6);c[g>>2]=0;od(a|0,74496,g|0)|0;y=y+1|0;sF(n,d,x);}while((y|0)<(c[s>>2]|0))}fF(a,4);pc(74520,8,1,a|0)|0;fF(a,4);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;sF(o,d,x);z=+Qo(y+(c[v>>2]|0)|0);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;sF(p,d,x);A=Lo(y+(c[w>>2]|0)|0)|0;y=f;h[k>>3]=z;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[f+8>>2]=A;od(a|0,74536,f|0)|0;fF(a,2);pc(74576,12,1,a|0)|0;x=x+1|0;}while((x|0)<(b|0));i=e;return}function mF(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=e+56|0;p=e+64|0;q=c[p>>2]|0;r=e+72|0;if((c[r>>2]|0)<=0){i=f;return}s=n+8|0;t=e+88|0;e=n;u=q;v=q;do{tF(n,o,v-u|0);eF(b,d,c[s>>2]|0,c[t>>2]|0,(c[r>>2]|0)+(c[p>>2]|0)|0,v,c[e>>2]|0,74328);q=v+9|0;Wo(q);fF(a,2);pc(74336,15,1,a|0)|0;fF(a,4);c[m>>2]=c[e>>2];od(a|0,74352,m|0)|0;fF(a,4);c[l>>2]=Oo(q)|0;od(a|0,74376,l|0)|0;fF(a,4);w=+To(q);x=j;h[k>>3]=w;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];od(a|0,74400,j|0)|0;fF(a,4);w=+So(q);q=g;h[k>>3]=w;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];od(a|0,73568,g|0)|0;fF(a,2);pc(74424,16,1,a|0)|0;v=v+1|0;u=c[p>>2]|0;}while((v|0)<((c[r>>2]|0)+u|0));i=f;return}function nF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;fF(a,b);pc(74640,16,1,a|0)|0;gF(a,c[d>>2]|0);b=c[d+8>>2]|0;g=c[d+12>>2]|0;h=c[d+16>>2]|0;j=(c[d+20>>2]|0)!=0?74744:74760;c[f>>2]=c[d+4>>2];c[f+4>>2]=b;c[f+8>>2]=g;c[f+12>>2]=h;c[f+16>>2]=j;od(a|0,74664,f|0)|0;i=e;return}function oF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+24>>2]|0)==0){pF(b)}f=a;a=(c[b+20>>2]|0)+(d<<5)|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];i=e;return}



function HQ(a){a=a|0;a=i;zI(100588|0);zI(100576|0);zI(100564|0);zI(100552|0);zI(100540|0);zI(100528|0);zI(100516|0);zI(100504|0);zI(100492|0);zI(100480|0);zI(100468|0);zI(100456|0);zI(100444|0);zI(100432|0);zI(100420|0);zI(100408|0);zI(100396|0);zI(100384|0);zI(100372|0);zI(100360|0);zI(100348|0);zI(100336|0);zI(100324|0);zI(100312);i=a;return}function IQ(a){a=a|0;a=i;XH(101428|0);XH(101416|0);XH(101404|0);XH(101392|0);XH(101380|0);XH(101368|0);XH(101356|0);XH(101344|0);XH(101332|0);XH(101320|0);XH(101308|0);XH(101296|0);XH(101284|0);XH(101272|0);XH(101260|0);XH(101248|0);XH(101236|0);XH(101224|0);XH(101212|0);XH(101200|0);XH(101188|0);XH(101176|0);XH(101164|0);XH(101152);i=a;return}function JQ(a){a=a|0;a=i;zI(101820|0);zI(101808|0);zI(101796|0);zI(101784|0);zI(101772|0);zI(101760|0);zI(101748|0);zI(101736|0);zI(101724|0);zI(101712|0);zI(101700|0);zI(101688|0);zI(101676|0);zI(101664);i=a;return}function KQ(a){a=a|0;a=i;XH(102356|0);XH(102344|0);XH(102332|0);XH(102320|0);XH(102308|0);XH(102296|0);XH(102284|0);XH(102272|0);XH(102260|0);XH(102248|0);XH(102236|0);XH(102224|0);XH(102212|0);XH(102200);i=a;return}function LQ(a){a=a|0;var b=0,c=0;b=i;if((RQ(a)|0)==0){c=(MQ(a)|0)!=0|0}else{c=1}i=b;return c|0}function MQ(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<131072){c=(d[102512+((d[102512+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}else{c=a>>>0<196606|0;i=b;return c|0}return 0}function NQ(a){a=a|0;var b=0,c=0;b=i;c=wb(a|0)|0;i=b;return c|0}function OQ(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<32|(a+ -127|0)>>>0<33|(a+ -8232|0)>>>0<2){c=1;i=b;return c|0}c=(a+ -65529|0)>>>0<3|0;i=b;return c|0}function PQ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;switch(b|0){case 8:{d=UQ(a)|0;break};case 11:{d=XQ(a)|0;break};case 6:{d=SQ(a)|0;break};case 5:{d=RQ(a)|0;break};case 10:{d=WQ(a)|0;break};case 1:{d=LQ(a)|0;break};case 3:{d=NQ(a)|0;break};case 2:{d=MQ(a)|0;break};case 12:{d=YQ(a)|0;break};case 7:{d=TQ(a)|0;break};case 9:{d=VQ(a)|0;break};case 4:{d=OQ(a)|0;break};default:{d=0}}i=c;return d|0}function QQ(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;c=i;d=a[b]|0;e=97;f=1;g=105488;while(1){if(d<<24>>24==e<<24>>24){if((AS(b,g)|0)==0){h=f;j=5;break}}k=g+6|0;l=a[k]|0;if(l<<24>>24==0){h=0;j=5;break}else{e=l;f=f+1|0;g=k}}if((j|0)==5){i=c;return h|0}return 0}function RQ(a){a=a|0;i=i;return(a+ -48|0)>>>0<10|0}function SQ(a){a=a|0;var b=0,c=0;b=i;if((WQ(a)|0)==0){c=(UQ(a)|0)!=0|0}else{c=0}i=b;return c|0}function TQ(a){a=a|0;var b=0,c=0;b=i;if((ZQ(a)|0)==(a|0)){c=(a|0)==223|0}else{c=1}i=b;return c|0}function UQ(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<255){c=(a+1&127)>>>0>32|0;i=b;return c|0}if(a>>>0<8232|(a+ -8234|0)>>>0<47062|(a+ -57344|0)>>>0<8185){c=1;i=b;return c|0}else{i=b;return((a+ -65532|0)>>>0>1048579|(a&65534|0)==65534)&1^1|0}return 0}function VQ(a){a=a|0;var b=0,c=0;b=i;if(!(a>>>0<131072)){c=0;i=b;return c|0}c=(d[105568+((d[105568+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}function WQ(a){a=a|0;var b=0,c=0;b=i;c=(BR(108736,a)|0)!=0|0;i=b;return c|0}function XQ(a){a=a|0;var b=0,c=0;b=i;c=($Q(a)|0)!=(a|0)|0;i=b;return c|0}function YQ(a){a=a|0;var b=0,c=0;b=i;if((a+ -48|0)>>>0<10){c=1;i=b;return c|0}c=((a|32)+ -97|0)>>>0<6|0;i=b;return c|0}function ZQ(a){a=a|0;var b=0,c=0;b=i;c=_Q(a,0)|0;i=b;return c|0}function _Q(c,f){c=c|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=(f<<1)+ -1|0;j=f+ -1|0;if((MQ(c)|0)==0|(c+ -1536|0)>>>0<2560|(c+ -11776|0)>>>0<30784|(c+ -43008|0)>>>0<22272){k=c;i=g;return k|0}do{if((f|0)==0){if(!((c+ -11520|0)>>>0<38)){l=0;break}k=c+ -7264|0;i=g;return k|0}else{if(!((c+ -4256|0)>>>0<46)){l=0;break}do{if((c|0)>4293){if((c|0)==4295|(c|0)==4301){break}else{k=c}i=g;return k|0}}while(0);k=c+7264|0;i=g;return k|0}}while(0);while(1){m=a[108826+(l<<2)|0]|0;n=m<<24>>24;o=c-(e[108824+(l<<2)>>1]|0)|0;p=l+1|0;if((o-(n&j)|0)>>>0<(d[108827+(l<<2)|0]|0)>>>0){q=12;break}if((p|0)==61){break}else{l=p}}if((q|0)==12){if(m<<24>>24==1){k=f+c-(o&1)|0;i=g;return k|0}else{k=(fa(n,h)|0)+c|0;i=g;return k|0}}h=1-f|0;n=b[109072+(h<<1)>>1]|0;a:do{if(!(n<<16>>16==0)){o=n;m=0;while(1){q=m+1|0;if((o&65535|0)==(c|0)){break}l=b[109072+(q<<2)+(h<<1)>>1]|0;if(l<<16>>16==0){break a}else{o=l;m=q}}k=e[109072+(m<<2)+(f<<1)>>1]|0;i=g;return k|0}}while(0);if(!((c+ -66600+(f*40|0)|0)>>>0<40)){k=c;i=g;return k|0}k=c+ -40+(f*80|0)|0;i=g;return k|0}function $Q(a){a=a|0;var b=0,c=0;b=i;c=_Q(a,1)|0;i=b;return c|0}function aR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=bR(0,a,b,(c|0)!=0?c:109776)|0;i=d;return e|0}function bR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+8|0;h=g;c[h>>2]=b;j=(f|0)==0?109784:f;f=c[j>>2]|0;a:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n+ -194|0;if(l>>>0>50){break a}o=e+ -1|0;p=c[109568+(l<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}}while(0);b:do{if((o|0)==0){r=p}else{l=a[q]|0;n=(l&255)>>>3;if((n+ -16|n+(p>>26))>>>0>7){break a}else{s=o;t=l;u=p;v=q}while(1){v=v+1|0;u=(t&255)+ -128|u<<6;s=s+ -1|0;if((u|0)>=0){break}if((s|0)==0){r=u;break b}t=a[v]|0;if(((t&255)+ -128|0)>>>0>63){break a}}c[j>>2]=0;c[m>>2]=u;k=e-s|0;i=g;return k|0}}while(0);c[j>>2]=r;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(Lc()|0)>>2]=84;k=-1;i=g;return k|0}function cR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+1032|0;h=g+1024|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=g;m=k?e:256;e=k?a:l;a:do{if((j|0)==0|(m|0)==0){n=d;o=m;p=j;q=0;r=e}else{a=d;s=m;t=j;u=0;v=e;while(1){w=a>>>2;x=w>>>0>=s>>>0;if(!(x|a>>>0>131)){n=a;o=s;p=t;q=u;r=v;break a}y=x?s:w;z=a-y|0;w=dR(v,h,y,f)|0;if((w|0)==-1){break}if((v|0)==(l|0)){A=s;B=l}else{A=s-w|0;B=v+(w<<2)|0}y=w+u|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){n=z;o=A;p=w;q=y;r=B;break a}else{a=z;s=A;t=w;u=y;v=B}}n=z;o=0;p=c[h>>2]|0;q=-1;r=v}}while(0);b:do{if((p|0)==0){C=q}else{if((o|0)==0|(n|0)==0){C=q;break}else{D=n;E=o;F=p;G=q;H=r}while(1){I=bR(H,F,D,f)|0;if((I+2|0)>>>0<3){break}z=(c[h>>2]|0)+I|0;c[h>>2]=z;B=E+ -1|0;A=G+1|0;if((B|0)==0|(D|0)==(I|0)){C=A;break b}else{D=D-I|0;E=B;F=z;G=A;H=H+4|0}}if((I|0)==-1){C=-1;break}else if((I|0)==0){c[h>>2]=0;C=G;break}else{c[f>>2]=0;C=G;break}}}while(0);if(!k){i=g;return C|0}c[b>>2]=c[h>>2];i=g;return C|0}function dR(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;h=i;j=c[e>>2]|0;do{if((g|0)==0){k=5}else{l=g;m=c[l>>2]|0;if((m|0)==0){k=5;break}if((b|0)==0){n=f;o=m;p=j;k=16;break}c[l>>2]=0;q=b;r=f;s=m;t=j;k=36}}while(0);if((k|0)==5){if((b|0)==0){u=f;v=j;k=7}else{w=b;x=f;y=j;k=6}}a:while(1){if((k|0)==6){k=0;if((x|0)==0){z=f;k=53;break}else{A=w;B=x;C=y}while(1){j=a[C]|0;do{if(((j&255)+ -1|0)>>>0<127){if((C&3|0)==0&B>>>0>3){D=A;E=B;F=C}else{G=A;H=B;I=j;J=C;break}while(1){K=c[F>>2]|0;if(((K+ -16843009|K)&-2139062144|0)!=0){k=30;break}c[D>>2]=K&255;c[D+4>>2]=d[F+1|0]|0;c[D+8>>2]=d[F+2|0]|0;L=F+4|0;M=D+16|0;c[D+12>>2]=d[F+3|0]|0;N=E+ -4|0;if(N>>>0>3){D=M;E=N;F=L}else{k=31;break}}if((k|0)==30){k=0;G=D;H=E;I=K&255;J=F;break}else if((k|0)==31){k=0;G=M;H=N;I=a[L]|0;J=L;break}}else{G=A;H=B;I=j;J=C}}while(0);O=I&255;if(!((O+ -1|0)>>>0<127)){break}c[G>>2]=O;j=H+ -1|0;if((j|0)==0){z=f;k=53;break a}else{A=G+4|0;B=j;C=J+1|0}}j=O+ -194|0;if(j>>>0>50){P=G;Q=H;R=J;k=47;break}q=G;r=H;s=c[109568+(j<<2)>>2]|0;t=J+1|0;k=36;continue}else if((k|0)==7){k=0;j=a[v]|0;do{if(((j&255)+ -1|0)>>>0<127){if((v&3|0)!=0){S=u;T=j;U=v;break}g=c[v>>2]|0;if(((g+ -16843009|g)&-2139062144|0)==0){V=u;W=v}else{S=u;T=g&255;U=v;break}do{W=W+4|0;V=V+ -4|0;X=c[W>>2]|0;}while(((X+ -16843009|X)&-2139062144|0)==0);S=V;T=X&255;U=W}else{S=u;T=j;U=v}}while(0);j=T&255;if((j+ -1|0)>>>0<127){u=S+ -1|0;v=U+1|0;k=7;continue}g=j+ -194|0;if(g>>>0>50){P=b;Q=S;R=U;k=47;break}n=S;o=c[109568+(g<<2)>>2]|0;p=U+1|0;k=16;continue}else if((k|0)==16){k=0;g=(d[p]|0)>>>3;if((g+ -16|g+(o>>26))>>>0>7){k=17;break}g=p+1|0;do{if((o&33554432|0)==0){Y=g}else{if(((d[g]|0)+ -128|0)>>>0>63){k=20;break a}j=p+2|0;if((o&524288|0)==0){Y=j;break}if(((d[j]|0)+ -128|0)>>>0>63){k=23;break a}Y=p+3|0}}while(0);u=n+ -1|0;v=Y;k=7;continue}else if((k|0)==36){k=0;g=d[t]|0;j=g>>>3;if((j+ -16|j+(s>>26))>>>0>7){k=37;break}j=t+1|0;Z=g+ -128|s<<6;do{if((Z|0)<0){g=(d[j]|0)+ -128|0;if(g>>>0>63){k=40;break a}m=t+2|0;_=g|Z<<6;if((_|0)>=0){$=_;aa=m;break}g=(d[m]|0)+ -128|0;if(g>>>0>63){k=43;break a}$=g|_<<6;aa=t+3|0}else{$=Z;aa=j}}while(0);c[q>>2]=$;w=q+4|0;x=r+ -1|0;y=aa;k=6;continue}}if((k|0)==17){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==20){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==23){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==37){ba=q;ca=r;da=s;ea=t+ -1|0;k=46}else if((k|0)==40){ba=q;ca=r;da=Z;ea=t+ -1|0;k=46}else if((k|0)==43){ba=q;ca=r;da=_;ea=t+ -1|0;k=46}else if((k|0)==53){i=h;return z|0}if((k|0)==46){if((da|0)==0){P=ba;Q=ca;R=ea;k=47}else{fa=ba;ga=ea}}do{if((k|0)==47){if((a[R]|0)!=0){fa=P;ga=R;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}z=f-Q|0;i=h;return z|0}}while(0);c[(Lc()|0)>>2]=84;if((fa|0)==0){z=-1;i=h;return z|0}c[e>>2]=ga;z=-1;i=h;return z|0}function eR(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m+ -194|0;if(k>>>0>50){break}m=e+1|0;n=c[109568+(k<<2)>>2]|0;if(f>>>0<4){if((n&-2147483648>>>((f*6|0)+ -6|0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m+ -16|m+(n>>26))>>>0>7){break}m=k+ -128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)+ -128|0;if(n>>>0>63){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)+ -128|0;if(m>>>0>63){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(Lc()|0)>>2]=84;j=-1;i=g;return j|0}function fR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((b|0)==0){f=1;i=e;return f|0}if(d>>>0<128){a[b]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d+ -57344|0)>>>0<8192){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;i=e;return f|0}if((d+ -65536|0)>>>0<1048576){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;i=e;return f|0}else{c[(Lc()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function gR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+264|0;g=f+256|0;h=f;j=c[b>>2]|0;c[g>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:h;a:do{if((j|0)==0|(l|0)==0){m=d;n=l;o=j;p=0;q=e}else{a=d;r=l;s=j;t=0;u=e;while(1){v=a>>>0>=r>>>0;if(!(v|a>>>0>32)){m=a;n=r;o=s;p=t;q=u;break a}w=v?r:a;x=a-w|0;v=hR(u,g,w,0)|0;if((v|0)==-1){break}if((u|0)==(h|0)){y=r;z=h}else{y=r-v|0;z=u+v|0}w=v+t|0;v=c[g>>2]|0;if((v|0)==0|(y|0)==0){m=x;n=y;o=v;p=w;q=z;break a}else{a=x;r=y;s=v;t=w;u=z}}m=x;n=0;o=c[g>>2]|0;p=-1;q=u}}while(0);b:do{if((o|0)==0){A=p}else{if((n|0)==0|(m|0)==0){A=p;break}else{B=m;C=n;D=o;E=p;F=q}while(1){G=fR(F,c[D>>2]|0,0)|0;if((G+1|0)>>>0<2){break}x=(c[g>>2]|0)+4|0;c[g>>2]=x;z=B+ -1|0;y=E+1|0;if((C|0)==(G|0)|(z|0)==0){A=y;break b}else{B=z;C=C-G|0;D=x;E=y;F=F+G|0}}if((G|0)!=0){A=-1;break}c[g>>2]=0;A=E}}while(0);if(!k){i=f;return A|0}c[b>>2]=c[g>>2];i=f;return A|0}function hR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f;if((b|0)==0){h=c[d>>2]|0;j=g;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=k;o=h}while(1){if(n>>>0>127){h=fR(j,n,0)|0;if((h|0)==-1){l=-1;p=26;break}else{q=h}}else{q=1}h=q+m|0;k=o+4|0;r=c[k>>2]|0;if((r|0)==0){l=h;p=26;break}else{m=h;n=r;o=k}}if((p|0)==26){i=f;return l|0}}a:do{if(e>>>0>3){o=b;n=e;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break a}if(q>>>0>127){j=fR(o,q,0)|0;if((j|0)==-1){l=-1;break}u=o+j|0;v=n-j|0;w=m}else{a[o]=q;u=o+1|0;v=n+ -1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3){o=u;n=v;m=q}else{s=u;t=v;break a}}i=f;return l|0}else{s=b;t=e}}while(0);b:do{if((t|0)==0){x=0}else{b=g;v=s;u=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127){n=fR(b,m,0)|0;if((n|0)==-1){l=-1;p=26;break}if(n>>>0>u>>>0){p=20;break}fR(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u+ -1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break b}else{v=y;u=z;w=m}}if((p|0)==20){l=e-u|0;i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}else if((p|0)==26){i=f;return l|0}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}function iR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;f=i;i=i+104|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=aS(20)|0;q=p;if((p|0)==0){r=12;i=f;return r|0}s=aS(2048)|0;c[p+16>>2]=s;if((s|0)==0){bS(p);r=12;i=f;return r|0}c[p>>2]=512;c[p+4>>2]=10240;c[p+8>>2]=128;c[p+12>>2]=0;s=yR(0,0)|0;if((s|0)==0){bS(c[p+16>>2]|0);bS(p);r=12;i=f;return r|0}t=o+0|0;u=t+44|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));c[o>>2]=s;c[o+4>>2]=q;c[o+12>>2]=d;c[o+36>>2]=e;d=o+28|0;c[d>>2]=-1;t=jR(o)|0;a:do{if((t|0)==0){u=o+20|0;v=c[u>>2]|0;w=v+ -1|0;c[b>>2]=w;x=c[o+8>>2]|0;y=c[d>>2]|0;if((y|0)>-1){if((c[o+32>>2]|0)!=0){z=0;A=2;B=0;C=0;break}}if((y|0)>(w|0)){z=0;A=6;B=0;C=0;break}w=cS(1,68)|0;D=w;if((w|0)==0){z=0;A=12;B=0;C=D;break}E=y>>>31;c[w+60>>2]=E^1;c[w+64>>2]=c[o+32>>2];c[w+28>>2]=v;if((E|0)==1){if((e&8|0)==0){F=13}else{G=0}}else{F=13}if((F|0)==13){E=kR(0,q,x,D)|0;if((E|0)!=0){z=0;A=E;B=0;C=D;break}E=c[w+40>>2]|0;if((E|0)>0){v=(E<<2)+4|0;y=aS(v)|0;H=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[w+32>>2]=H;IS(y|0,-1,v|0)|0;I=H}else{I=0}H=cS(E<<1|1,4)|0;c[w+36>>2]=H;if((H|0)==0){z=0;A=12;B=0;C=D;break}H=cS(c[u>>2]|0,12)|0;if((H|0)==0){z=0;A=12;B=0;C=D;break}c[w+16>>2]=H;H=kR(s,q,x,D)|0;if((H|0)==0){G=I}else{z=0;A=H;B=0;C=D;break}}H=o+24|0;u=p+12|0;E=c[u>>2]|0;c[j>>2]=0;c[k>>2]=0;v=qR(q,x)|0;b:do{if((v|0)==0){y=qR(q,0)|0;if((y|0)!=0){J=y;break}y=p+16|0;K=c[u>>2]|0;c:do{if((K|0)>(E|0)){L=0;M=0;N=0;O=K;d:while(1){P=O+ -1|0;c[u>>2]=P;Q=c[y>>2]|0;R=c[Q+(P<<2)>>2]|0;P=O+ -2|0;c[u>>2]=P;S=c[Q+(P<<2)>>2]|0;do{if((R|0)==0){P=c[S>>2]|0;if((P|0)==2){T=c[S+4>>2]|0;U=qR(q,L)|0;if((U|0)!=0){V=N;W=U;break c}U=qR(q,S)|0;if((U|0)!=0){V=N;W=U;break c}U=qR(q,1)|0;if((U|0)!=0){V=N;W=U;break c}U=qR(q,c[T>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}U=qR(q,0)|0;if((U|0)!=0){V=N;W=U;break c}if((c[T+4>>2]|0)>1){F=45}else{if((c[T+8>>2]|0)>1){F=45}else{X=L}}if((F|0)==45){F=0;c[j>>2]=0;X=0}Y=X;Z=M+1|0;_=N;break}else if((P|0)==3){T=c[S+4>>2]|0;U=qR(q,c[T+4>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}U=qR(q,0)|0;if((U|0)!=0){V=N;W=U;break c}U=qR(q,c[T>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}$=qR(q,0)|0}else if((P|0)==0){U=c[S+4>>2]|0;T=c[U>>2]|0;if(!((T|0)>-1|(T|0)==-4)){Y=L;Z=M;_=N;break}T=U+8|0;U=(c[T>>2]|0)+L|0;c[T>>2]=U;if((U|0)<=(c[k>>2]|0)){Y=L;Z=M;_=N;break}c[k>>2]=U;Y=L;Z=M;_=N;break}else if((P|0)==1){P=c[S+4>>2]|0;U=qR(q,c[P+4>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}U=qR(q,0)|0;if((U|0)!=0){V=N;W=U;break c}U=qR(q,c[P>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}$=qR(q,0)|0}else{Y=L;Z=M;_=N;break}if(($|0)==0){Y=L;Z=M;_=N}else{V=N;W=$;break c}}else if((R|0)==1){U=S+4|0;P=c[U>>2]|0;T=O+ -3|0;c[u>>2]=T;aa=c[Q+(T<<2)>>2]|0;c[j>>2]=aa;T=P+4|0;ba=c[T>>2]|0;do{if((ba|0)>1){c[l>>2]=0;ca=P;F=51}else{if((c[P+8>>2]|0)<=1){da=aa;break}c[l>>2]=0;ea=P;if((ba|0)>0){ca=ea;F=51}else{fa=ba;ga=ea;ha=aa;ia=0;F=60}}}while(0);e:do{if((F|0)==51){F=0;ea=aa;ja=ba;ka=1;la=0;while(1){ma=rR(s,q,c[ca>>2]|0,(ka|0)<(ja|0)?1:2,j,G,m,k)|0;if((ma|0)!=0){J=ma;break b}ma=c[m>>2]|0;if((la|0)==0){na=ma}else{oa=AR(s,0,0,1,32)|0;if((oa|0)==0){J=12;break b}pa=AR(s,0,0,1,8)|0;qa=oa+4|0;c[qa>>2]=pa;if((pa|0)==0){J=12;break b}c[oa>>2]=1;c[oa+8>>2]=-1;c[oa+12>>2]=-1;c[pa>>2]=la;c[(c[qa>>2]|0)+4>>2]=ma;c[oa+16>>2]=(c[ma+16>>2]|0)+(c[la+16>>2]|0);na=oa}if((na|0)==0){J=12;break b}oa=c[T>>2]|0;if((ka|0)>=(oa|0)){fa=oa;ga=ca;ha=ea;ia=na;F=60;break e}ea=c[j>>2]|0;ja=oa;ka=ka+1|0;la=na}}}while(0);if((F|0)==60){F=0;T=P+8|0;ba=c[T>>2]|0;do{if((ba|0)==-1){la=c[j>>2]|0;ka=rR(s,q,c[ga>>2]|0,0,j,0,l,k)|0;if((ka|0)!=0){J=ka;break b}ka=c[l>>2]|0;ja=AR(s,0,0,1,32)|0;ea=ja;if((ja|0)==0){F=65;break d}oa=AR(s,0,0,1,16)|0;c[ja+4>>2]=oa;if((oa|0)==0){F=65;break d}c[ja>>2]=2;c[ja+8>>2]=-1;c[ja+12>>2]=-1;c[oa>>2]=ka;c[oa+4>>2]=0;c[oa+8>>2]=-1;ma=oa+12|0;a[ma]=a[ma]&-2;c[ja+16>>2]=c[ka+16>>2];c[l>>2]=ea;ra=ea;sa=la}else{if((fa|0)<(ba|0)){ta=0;ua=fa}else{ra=0;sa=ha;break}while(1){la=c[j>>2]|0;ea=rR(s,q,c[ga>>2]|0,0,j,0,n,k)|0;if((ea|0)!=0){J=ea;break b}ea=c[n>>2]|0;if((ta|0)==0){va=ea}else{ka=AR(s,0,0,1,32)|0;if((ka|0)==0){F=73;break d}ja=AR(s,0,0,1,8)|0;ma=ka+4|0;c[ma>>2]=ja;if((ja|0)==0){F=73;break d}c[ka>>2]=1;c[ka+8>>2]=-1;c[ka+12>>2]=-1;c[ja>>2]=ea;c[(c[ma>>2]|0)+4>>2]=ta;c[ka+16>>2]=(c[ta+16>>2]|0)+(c[ea+16>>2]|0);va=ka}c[l>>2]=va;if((va|0)==0){J=12;break b}ka=AR(s,0,0,1,32)|0;if((ka|0)==0){J=12;break b}ea=AR(s,0,0,1,20)|0;c[ka+4>>2]=ea;if((ea|0)==0){J=12;break b}c[ka>>2]=0;c[ka+8>>2]=-1;c[ka+12>>2]=-1;c[ea>>2]=-1;c[ea+4>>2]=-1;c[ea+8>>2]=-1;ea=AR(s,0,0,1,32)|0;ma=ea;if((ea|0)==0){F=79;break d}ja=AR(s,0,0,1,8)|0;oa=ea+4|0;c[oa>>2]=ja;if((ja|0)==0){F=79;break d}c[ea>>2]=3;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[ja>>2]=ka;c[(c[oa>>2]|0)+4>>2]=va;c[ea+16>>2]=(c[va+16>>2]|0)+(c[ka+16>>2]|0);c[l>>2]=ma;ka=ua+1|0;if((ka|0)<(c[T>>2]|0)){ta=ma;ua=ka}else{ra=ma;sa=la;break}}}}while(0);c[j>>2]=sa;do{if((ia|0)==0){wa=ra;F=85}else{if((ra|0)==0){xa=ia;break}T=AR(s,0,0,1,32)|0;if((T|0)==0){J=12;break b}ba=AR(s,0,0,1,8)|0;P=T+4|0;c[P>>2]=ba;if((ba|0)==0){J=12;break b}c[T>>2]=1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[ba>>2]=ia;c[(c[P>>2]|0)+4>>2]=ra;c[T+16>>2]=(c[ra+16>>2]|0)+(c[ia+16>>2]|0);wa=T;F=85}}while(0);if((F|0)==85){F=0;if((wa|0)==0){J=12;break b}else{xa=wa}}c[U>>2]=c[xa+4>>2];c[S>>2]=c[xa>>2];da=sa}T=M+ -1|0;P=da-aa+N|0;if((T|0)!=0){Y=da;Z=T;_=P;break}c[j>>2]=P;Y=P;Z=0;_=P}else{Y=L;Z=M;_=N}}while(0);S=c[u>>2]|0;if((S|0)>(E|0)){L=Y;M=Z;N=_;O=S}else{V=_;W=0;break c}}if((F|0)==65){c[l>>2]=0;J=12;break b}else if((F|0)==73){c[l>>2]=0;J=12;break b}else if((F|0)==79){c[l>>2]=0;J=12;break b}}else{V=0;W=0}}while(0);y=(c[H>>2]|0)+V|0;K=c[k>>2]|0;c[H>>2]=(K|0)>(y|0)?K:y;J=W}else{J=v}}while(0);if((J|0)!=0){z=0;A=J;B=0;C=D;break}v=c[H>>2]|0;c[H>>2]=v+1;E=AR(s,0,0,1,32)|0;if((E|0)==0){z=0;A=12;B=0;C=D;break}y=AR(s,0,0,1,20)|0;c[E+4>>2]=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[E>>2]=0;c[E+8>>2]=-1;c[E+12>>2]=-1;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=v;v=AR(s,0,0,1,32)|0;y=v;if((v|0)==0){z=0;A=12;B=0;C=D;break}K=AR(s,0,0,1,8)|0;O=v+4|0;c[O>>2]=K;if((K|0)==0){z=0;A=12;B=0;C=D;break}c[v>>2]=1;c[v+8>>2]=-1;c[v+12>>2]=-1;c[K>>2]=x;c[(c[O>>2]|0)+4>>2]=E;c[v+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);E=c[u>>2]|0;O=qR(q,v)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=qR(q,0)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=c[u>>2]|0;f:do{if((O|0)>(E|0)){K=p+16|0;N=O;g:while(1){M=N+ -1|0;c[u>>2]=M;L=c[K>>2]|0;S=c[L+(M<<2)>>2]|0;M=N+ -2|0;c[u>>2]=M;ya=c[L+(M<<2)>>2]|0;do{if((S|0)==3){M=c[ya+4>>2]|0;L=c[M>>2]|0;do{if((c[M+4>>2]|0)==0){F=141}else{if((c[L+8>>2]|0)!=0){F=141;break}c[ya+8>>2]=0}}while(0);if((F|0)==141){F=0;c[ya+8>>2]=1}c[ya+24>>2]=c[L+24>>2];c[ya+28>>2]=c[(c[M>>2]|0)+28>>2]}else if((S|0)==2){Q=c[ya+4>>2]|0;R=c[Q>>2]|0;P=R+8|0;if((c[P>>2]|0)==0){za=0}else{za=(c[(c[Q+4>>2]|0)+8>>2]|0)!=0|0}c[ya+8>>2]=za;if((c[P>>2]|0)==0){c[ya+24>>2]=c[R+24>>2];Aa=Q+4|0}else{P=pR(q,R,0,0,g)|0;if((P|0)!=0){z=0;A=P;B=0;C=D;break a}Ba=aS((c[g>>2]<<2)+4|0)|0;P=Ba;if((Ba|0)==0){z=0;A=12;B=0;C=D;break a}c[Ba>>2]=-1;c[h>>2]=0;Ca=pR(q,c[Q>>2]|0,P,h,0)|0;if((Ca|0)!=0){F=150;break g}R=Q+4|0;T=oR(s,c[(c[R>>2]|0)+24>>2]|0,c[(c[Q>>2]|0)+24>>2]|0,P,c[h>>2]|0)|0;P=ya+24|0;c[P>>2]=T;bS(Ba);if((c[P>>2]|0)==0){z=0;A=12;B=0;C=D;break a}else{Aa=R}}R=c[Aa>>2]|0;if((c[R+8>>2]|0)==0){c[ya+28>>2]=c[R+28>>2];break}P=pR(q,R,0,0,g)|0;if((P|0)!=0){z=0;A=P;B=0;C=D;break a}Da=aS((c[g>>2]<<2)+4|0)|0;P=Da;if((Da|0)==0){z=0;A=12;B=0;C=D;break a}c[Da>>2]=-1;c[h>>2]=0;Ea=pR(q,c[Aa>>2]|0,P,h,0)|0;if((Ea|0)!=0){F=157;break g}R=oR(s,c[(c[Q>>2]|0)+28>>2]|0,c[(c[Aa>>2]|0)+28>>2]|0,P,c[h>>2]|0)|0;P=ya+28|0;c[P>>2]=R;bS(Da);if((c[P>>2]|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==0){P=c[ya>>2]|0;if((P|0)==3){R=qR(q,ya)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=qR(q,1)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=ya+4|0;Q=qR(q,c[(c[R>>2]|0)+4>>2]|0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=qR(q,0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=qR(q,c[c[R>>2]>>2]|0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=qR(q,0)|0;if((Q|0)==0){break}else{z=0;A=Q;B=0;C=D;break a}}else if((P|0)==0){Q=c[ya+4>>2]|0;R=c[Q>>2]|0;if((R|0)==-4){c[ya+8>>2]=0;T=Q+8|0;ba=c[T>>2]|0;la=AR(s,0,0,1,64)|0;if((la|0)==0){F=104;break g}ma=la;c[la>>2]=ba;c[la+4>>2]=0;c[la+8>>2]=1114111;c[la+20>>2]=0;c[la+24>>2]=0;ba=la+28|0;la=ya+24|0;c[ba+0>>2]=-1;c[ba+4>>2]=-1;c[ba+8>>2]=-1;c[ba+12>>2]=-1;c[la>>2]=ma;ma=c[T>>2]|0;T=c[Q+4>>2]|0;la=AR(s,0,0,1,64)|0;if((la|0)==0){F=106;break g}c[la>>2]=ma;c[la+4>>2]=0;c[la+8>>2]=1114111;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=T;c[la+32>>2]=-1;c[la+36>>2]=-1;c[la+40>>2]=-1;c[ya+28>>2]=la;break}la=ya+8|0;if((R|0)<0){c[la>>2]=1;T=AR(s,0,0,1,32)|0;if((T|0)==0){F=110;break g}c[T>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[ya+24>>2]=T;T=AR(s,0,0,1,32)|0;if((T|0)==0){F=112;break g}c[T>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[ya+28>>2]=T;break}else{c[la>>2]=0;la=Q+8|0;T=c[la>>2]|0;ma=Q+4|0;ba=c[ma>>2]|0;ka=AR(s,0,0,1,64)|0;if((ka|0)==0){F=115;break g}ea=ka;c[ka>>2]=T;c[ka+4>>2]=R;c[ka+8>>2]=ba;c[ka+20>>2]=0;c[ka+24>>2]=0;ba=ka+28|0;ka=ya+24|0;c[ba+0>>2]=-1;c[ba+4>>2]=-1;c[ba+8>>2]=-1;c[ba+12>>2]=-1;c[ka>>2]=ea;ea=c[la>>2]|0;la=c[Q>>2]|0;ka=c[ma>>2]|0;ma=c[Q+12>>2]|0;ba=c[Q+16>>2]|0;Q=AR(s,0,0,1,64)|0;if((Q|0)==0){F=117;break g}R=Q;c[Q>>2]=ea;c[Q+4>>2]=la;c[Q+8>>2]=ka;c[Q+20>>2]=ma;c[Q+24>>2]=ba;ba=Q+28|0;Q=ya+28|0;c[ba+0>>2]=-1;c[ba+4>>2]=-1;c[ba+8>>2]=-1;c[ba+12>>2]=-1;c[Q>>2]=R;break}}else if((P|0)==1){R=qR(q,ya)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=qR(q,2)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=ya+4|0;Q=qR(q,c[(c[R>>2]|0)+4>>2]|0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=qR(q,0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=qR(q,c[c[R>>2]>>2]|0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=qR(q,0)|0;if((Q|0)==0){break}else{z=0;A=Q;B=0;C=D;break a}}else if((P|0)==2){P=qR(q,ya)|0;if((P|0)!=0){z=0;A=P;B=0;C=D;break a}P=qR(q,3)|0;if((P|0)!=0){z=0;A=P;B=0;C=D;break a}P=qR(q,c[c[ya+4>>2]>>2]|0)|0;if((P|0)!=0){z=0;A=P;B=0;C=D;break a}P=qR(q,0)|0;if((P|0)==0){break}else{z=0;A=P;B=0;C=D;break a}}else{break}}else if((S|0)==1){P=c[ya+4>>2]|0;Q=c[P>>2]|0;R=P+4|0;ba=c[R>>2]|0;if((c[Q+8>>2]|0)==0){Fa=(c[ba+8>>2]|0)!=0|0}else{Fa=1}c[ya+8>>2]=Fa;ma=oR(s,c[Q+24>>2]|0,c[ba+24>>2]|0,0,0)|0;c[ya+24>>2]=ma;if((ma|0)==0){z=0;A=12;B=0;C=D;break a}ma=oR(s,c[(c[P>>2]|0)+28>>2]|0,c[(c[R>>2]|0)+28>>2]|0,0,0)|0;c[ya+28>>2]=ma;if((ma|0)==0){z=0;A=12;B=0;C=D;break a}}}while(0);N=c[u>>2]|0;if((N|0)<=(E|0)){break f}}if((F|0)==104){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==106){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==110){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==112){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==115){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==117){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==150){bS(Ba);z=0;A=Ca;B=0;C=D;break a}else if((F|0)==157){bS(Da);z=0;A=Ea;B=0;C=D;break a}}}while(0);E=c[H>>2]|0;u=E<<2;O=aS(u)|0;x=O;if((O|0)==0){z=x;A=12;B=0;C=D;break}N=aS(u)|0;u=N;if((N|0)==0){z=x;A=12;B=u;C=D;break}if((E|0)>0){IS(O|0,0,((E|0)>1?E<<2:4)|0)|0}lR(y,0,x,0)|0;E=c[H>>2]|0;if((E|0)>0){K=0;S=0;while(1){c[N+(S<<2)>>2]=K;ma=O+(S<<2)|0;R=K+1+(c[ma>>2]|0)|0;c[ma>>2]=0;ma=S+1|0;if((ma|0)<(E|0)){S=ma;K=R}else{Ga=R;break}}}else{Ga=0}K=cS(Ga+1|0,32)|0;S=K;if((K|0)==0){z=x;A=12;B=u;C=D;break}c[w>>2]=S;E=w+4|0;c[E>>2]=Ga;R=lR(y,S,x,u)|0;if((R|0)!=0){z=x;A=R;B=u;C=D;break}c[w+20>>2]=0;R=v+24|0;S=c[R>>2]|0;if((c[S>>2]|0)>-1){ma=1;P=S;while(1){S=P+32|0;ba=ma+1|0;if((c[S>>2]|0)>-1){P=S;ma=ba}else{Ha=ba;break}}}else{Ha=1}ma=cS(Ha,32)|0;if((ma|0)==0){z=x;A=12;B=u;C=D;break}c[w+8>>2]=ma;P=c[R>>2]|0;y=c[P>>2]|0;if((y|0)>-1){ba=y;y=P;P=0;while(1){c[ma+(P<<5)+8>>2]=K+(c[N+(ba<<2)>>2]<<5);c[ma+(P<<5)+12>>2]=ba;S=ma+(P<<5)+16|0;c[S>>2]=0;Q=y+12|0;ka=c[Q>>2]|0;if((ka|0)!=0){la=0;while(1){Ia=la+1|0;if((c[ka+(la<<2)>>2]|0)>-1){la=Ia}else{break}}la=Ia<<2;ka=aS(la)|0;c[S>>2]=ka;if((ka|0)==0){z=x;A=12;B=u;C=D;break a}GS(ka|0,c[Q>>2]|0,la|0)|0}c[ma+(P<<5)+20>>2]=c[y+16>>2];la=P+1|0;ka=y+32|0;ea=c[ka>>2]|0;if((ea|0)>-1){ba=ea;y=ka;P=la}else{Ja=la;break}}}else{Ja=0}c[ma+(Ja<<5)+8>>2]=0;c[E>>2]=Ga;c[w+12>>2]=K+(c[N+(c[c[v+28>>2]>>2]<<2)>>2]<<5);c[w+52>>2]=c[H>>2];c[w+56>>2]=e;zR(s);bS(c[p+16>>2]|0);bS(p);bS(O);bS(N);c[b+4>>2]=w;r=0;i=f;return r|0}else{z=0;A=t;B=0;C=0}}while(0);zR(s);bS(c[p+16>>2]|0);bS(p);if((z|0)!=0){bS(z)}if((B|0)!=0){bS(B)}c[b+4>>2]=C;mR(b);r=A;i=f;return r|0}function jR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0;d=i;i=i+424|0;e=d;f=d+8|0;g=d+72|0;h=d+328|0;j=d+336|0;k=d+384|0;l=d+392|0;m=c[b+4>>2]|0;n=m+12|0;o=c[n>>2]|0;if((c[b+40>>2]|0)==0){p=b+20|0;qR(m,c[p>>2]|0)|0;qR(m,2)|0;c[p>>2]=(c[p>>2]|0)+1}p=qR(m,0)|0;q=b+12|0;r=b+16|0;c[r>>2]=c[q>>2];s=c[n>>2]|0;t=(p|0)==0;a:do{if((s|0)>(o|0)&t){u=m+16|0;v=b+36|0;w=b;x=b+24|0;y=b+20|0;z=g;A=f;B=b+28|0;C=l;D=k;E=k+1|0;F=j;G=b;H=j+12|0;I=j+40|0;J=j+24|0;K=j+8|0;L=s;M=0;N=0;b:while(1){O=L+ -1|0;c[n>>2]=O;P=c[u>>2]|0;c:do{switch(c[P+(O<<2)>>2]|0){case 0:{if((c[v>>2]&1|0)!=0){Q=qR(m,7)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}}U=M;V=N;W=qR(m,3)|0;break};case 6:{Q=L+ -2|0;c[n>>2]=Q;X=c[P+(Q<<2)>>2]|0;Q=c[w>>2]|0;Y=AR(Q,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}_=AR(Q,0,0,1,8)|0;Q=Y+4|0;c[Q>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[Y>>2]=1;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[_>>2]=X;c[(c[Q>>2]|0)+4>>2]=N;c[Y+16>>2]=(c[N+16>>2]|0)+(c[X+16>>2]|0);U=M;V=Y;W=0;break};case 9:{Y=c[q>>2]|0;X=a[Y]|0;switch(X<<24>>24|0){case 123:{Q=c[v>>2]|0;if((Q&1|0)==0){U=M;V=N;W=0;break c}else{$=Q;aa=Y}break};case 63:case 43:{if((c[v>>2]&1|0)==0){U=M;V=N;W=0;break c}else{T=41}break};case 42:{T=41;break};case 92:{Q=c[v>>2]|0;if((Q&1|0)!=0){U=M;V=N;W=0;break c}_=Y+1|0;if((a[_]|0)!=123){U=M;V=N;W=0;break c}c[q>>2]=_;$=Q;aa=_;break};default:{U=M;V=N;W=0;break c}}if((T|0)==41){T=0;c[q>>2]=Y+1;Y=c[w>>2]|0;_=AR(Y,0,0,1,32)|0;if((_|0)==0){Z=12;T=294;break b}Q=AR(Y,0,0,1,16)|0;c[_+4>>2]=Q;if((Q|0)==0){Z=12;T=294;break b}c[_>>2]=2;c[_+8>>2]=-1;c[_+12>>2]=-1;c[Q>>2]=N;c[Q+4>>2]=X<<24>>24==43;c[Q+8>>2]=X<<24>>24==63?1:-1;X=Q+12|0;a[X]=a[X]&-2;c[_+16>>2]=c[N+16>>2];U=M;V=_;W=qR(m,9)|0;break c}_=aa+1|0;c[q>>2]=_;X=a[_]|0;if((X+ -48<<24>>24&255)<10){Q=X<<24>>24;if((Q+ -48|0)>>>0<10){ba=Q;ca=-1;da=_}else{Z=10;T=294;break b}while(1){Q=((ca|0)<0?-48:(ca*10|0)+ -48|0)+ba|0;Y=da+1|0;ea=a[Y]|0;fa=ea<<24>>24;if((fa+ -48|0)>>>0<10){da=Y;ca=Q;ba=fa}else{ga=ea;ha=Q;ia=Y;break}}}else{ga=X;ha=-1;ia=_}do{if(ga<<24>>24==44){Y=ia+1|0;Q=a[Y]|0;ea=Q<<24>>24;if((ea+ -48|0)>>>0<10){ja=ea;ka=-1;la=Y}else{ma=Q;na=-1;oa=Y;break}while(1){Y=((ka|0)<0?-48:(ka*10|0)+ -48|0)+ja|0;Q=la+1|0;ea=a[Q]|0;fa=ea<<24>>24;if((fa+ -48|0)>>>0<10){la=Q;ka=Y;ja=fa}else{pa=ea;qa=Y;ra=Q;T=54;break}}}else{pa=ga;qa=ha;ra=ia;T=54}}while(0);do{if((T|0)==54){T=0;if(!((qa|0)>-1)){ma=pa;na=qa;oa=ra;break}if((ha|0)>(qa|0)|(qa|0)>255){Z=10;T=294;break b}else{ma=pa;na=qa;oa=ra}}}while(0);if(ma<<24>>24==0){Z=9;T=294;break b}if((oa|0)==(_|0)){Z=10;T=294;break b}if(($&1|0)==0){if(!(ma<<24>>24==92)){Z=10;T=294;break b}if((a[oa+1|0]|0)!=125){Z=10;T=294;break b}sa=oa+2|0}else{if(!(ma<<24>>24==125)){Z=10;T=294;break b}sa=oa+1|0}if((na|ha|0)==0){X=c[w>>2]|0;Q=AR(X,0,0,1,32)|0;if((Q|0)==0){Z=12;T=294;break b}Y=AR(X,0,0,1,20)|0;c[Q+4>>2]=Y;if((Y|0)==0){Z=12;T=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[Y>>2]=-1;c[Y+4>>2]=-1;c[Y+8>>2]=-1;ta=Q}else{Q=(na&ha|0)<0;Y=c[w>>2]|0;X=AR(Y,0,0,1,32)|0;if((X|0)==0){Z=12;T=294;break b}ea=AR(Y,0,0,1,16)|0;c[X+4>>2]=ea;if((ea|0)==0){Z=12;T=294;break b}c[X>>2]=2;c[X+8>>2]=-1;c[X+12>>2]=-1;c[ea>>2]=N;c[ea+4>>2]=Q?1:ha;c[ea+8>>2]=Q?1:na;Q=ea+12|0;a[Q]=a[Q]&-2;c[X+16>>2]=c[N+16>>2];ta=X}c[q>>2]=sa;U=M;V=ta;W=qR(m,9)|0;break};case 7:{X=c[q>>2]|0;Q=a[X]|0;if((Q|0)==41){c[q>>2]=X+1;U=M;V=N;W=0;break c}else if((Q|0)!=124){U=M;V=N;W=0;break c}Q=qR(m,7)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}Q=qR(m,N)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}Q=qR(m,8)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}Q=qR(m,3)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}c[q>>2]=(c[q>>2]|0)+1;U=M;V=N;W=0;break};case 3:{Q=qR(m,5)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}U=M;V=N;W=qR(m,4)|0;break};case 1:{Q=c[q>>2]|0;d:do{switch(a[Q]|0){case 91:{X=Q+1|0;c[q>>2]=X;ea=aS(128)|0;if((ea|0)==0){Z=12;T=294;break b}if((a[X]|0)==94){Y=Q+2|0;c[q>>2]=Y;ua=Y;va=1}else{ua=X;va=0}X=(va|0)==0;Y=ea;ea=0;fa=0;wa=32;xa=ua;e:while(1){ya=a[xa]|0;if(ya<<24>>24==93){if(xa>>>0>(c[q>>2]|0)>>>0){T=85;break}}else if(ya<<24>>24==0){za=Y;Aa=xa;Ba=7;T=140;break}ya=eR(e,xa,-1)|0;if((ya|0)<0){c[e>>2]=-1;Ca=1}else{Ca=ya}ya=xa+Ca|0;do{if((a[ya]|0)==45){Da=Ca+1|0;Ea=xa+Da|0;if((a[Ea]|0)==93){T=94;break}Fa=c[e>>2]|0;Ga=eR(e,Ea,-1)|0;if((Ga|0)<0){c[e>>2]=-1;Ha=-1;Ia=1}else{Ha=c[e>>2]|0;Ia=Ga}Ja=0;Ka=Ha;La=Fa;Ma=xa+(Ia+Da)|0;Na=Fa>>>0>Ha>>>0?11:0}else{T=94}}while(0);f:do{if((T|0)==94){T=0;Fa=a[xa]|0;do{if(Fa<<24>>24==45){if((a[xa+1|0]|0)==93){Oa=0;break}Oa=(c[q>>2]|0)==(xa|0)?0:11}else if(Fa<<24>>24==91){Da=a[xa+1|0]|0;if(Da<<24>>24==61|Da<<24>>24==46){za=Y;Aa=xa;Ba=3;T=140;break e}else if(!(Da<<24>>24==58)){Oa=0;break}Da=xa+2|0;Ga=Da;while(1){Ea=a[Ga]|0;Pa=Ea<<24>>24==0;if(Ea<<24>>24!=58&(Pa^1)){Ga=Ga+1|0}else{break}}if(Pa){za=Y;Aa=xa;Ba=4;T=140;break e}Ea=Ga-xa+ -2|0;Qa=(Ea|0)>63?63:Ea;PS(A|0,Da|0,Qa|0)|0;a[f+Qa|0]=0;Qa=QQ(A)|0;Ja=Qa;Ka=1114111;La=0;Ma=Ga+2|0;Na=(Qa|0)==0?4:0;break f}else{Oa=0}}while(0);Fa=c[e>>2]|0;Ja=0;Ka=Fa;La=Fa;Ma=ya;Na=Oa}}while(0);if((Na|0)!=0){za=Y;Aa=Ma;Ba=Na;T=140;break}ya=(Ja|0)!=0;do{if(X|ya^1){Fa=c[w>>2]|0;if((fa|0)<(wa|0)){Ra=Y;Sa=wa}else{if((wa|0)>1024){za=Y;Aa=Ma;Ba=12;T=140;break e}Qa=dS(Y,wa<<3)|0;if((Qa|0)==0){za=Y;Aa=Ma;Ba=12;T=140;break e}else{Ra=Qa;Sa=wa<<1}}Qa=AR(Fa,0,0,1,32)|0;if((Qa|0)==0){T=112;break e}Ea=AR(Fa,0,0,1,20)|0;Fa=Qa+4|0;c[Fa>>2]=Ea;if((Ea|0)==0){T=112;break e}c[Qa>>2]=0;c[Qa+8>>2]=-1;c[Qa+12>>2]=-1;c[Ea>>2]=La;c[Ea+4>>2]=Ka;c[Ea+8>>2]=-1;c[Ra+(fa<<2)>>2]=Qa;c[(c[Fa>>2]|0)+12>>2]=Ja;Ta=Ra;Ua=ea;Va=fa+1|0;Wa=Sa;Xa=0}else{if((ea|0)>63){Ta=Y;Ua=ea;Va=fa;Wa=wa;Xa=12;break}c[g+(ea<<2)>>2]=Ja;Ta=Y;Ua=ea+1|0;Va=fa;Wa=wa;Xa=0}}while(0);Fa=(Xa|0)==0;if(Fa&(((c[v>>2]&2|0)==0|ya)^1)){Ya=Ta;Za=Va;_a=Wa;$a=La}else{if(Fa){Y=Ta;ea=Ua;fa=Va;wa=Wa;xa=Ma;continue}else{za=Ta;Aa=Ma;Ba=Xa;T=140;break}}while(1){Fa=$a;while(1){if(Fa>>>0>Ka>>>0){Y=Ya;ea=Ua;fa=Za;wa=_a;xa=Ma;continue e}if((TQ(Fa)|0)!=0){T=118;break}ab=Fa+1|0;if((XQ(Fa)|0)==0){Fa=ab}else{T=129;break}}if((T|0)==118){T=0;Qa=ZQ(Fa)|0;Ea=Fa+1|0;g:do{if((TQ(Ea)|0)==0){bb=Qa;cb=Ea}else{db=Qa;eb=Ea;while(1){if((ZQ(eb)|0)!=(db+1|0)|eb>>>0>Ka>>>0){bb=db;cb=eb;break g}fb=ZQ(eb)|0;gb=eb+1|0;if((TQ(gb)|0)==0){bb=fb;cb=gb;break}else{db=fb;eb=gb}}}}while(0);Ea=c[w>>2]|0;if((Za|0)<(_a|0)){hb=Ya;ib=_a}else{if((_a|0)>1024){za=Ya;Aa=Ma;Ba=12;T=140;break e}eb=dS(Ya,_a<<3)|0;if((eb|0)==0){za=Ya;Aa=Ma;Ba=12;T=140;break e}else{hb=eb;ib=_a<<1}}eb=AR(Ea,0,0,1,32)|0;db=eb;do{if((eb|0)==0){jb=0}else{Ga=AR(Ea,0,0,1,20)|0;c[eb+4>>2]=Ga;if((Ga|0)==0){jb=0;break}c[eb>>2]=0;c[eb+8>>2]=-1;c[eb+12>>2]=-1;c[Ga>>2]=Qa;c[Ga+4>>2]=bb;c[Ga+8>>2]=-1;jb=db}}while(0);c[hb+(Za<<2)>>2]=jb;kb=jb;lb=hb;mb=ib;nb=cb}else if((T|0)==129){T=0;db=$Q(Fa)|0;h:do{if((XQ(ab)|0)==0){ob=db;pb=ab}else{Qa=db;eb=ab;while(1){if(($Q(eb)|0)!=(Qa+1|0)|eb>>>0>Ka>>>0){ob=Qa;pb=eb;break h}Ea=eb+1|0;Ga=$Q(eb)|0;if((XQ(Ea)|0)==0){ob=Ga;pb=Ea;break}else{Qa=Ga;eb=Ea}}}}while(0);Fa=c[w>>2]|0;if((Za|0)<(_a|0)){qb=Ya;rb=_a}else{if((_a|0)>1024){za=Ya;Aa=Ma;Ba=12;T=140;break e}eb=dS(Ya,_a<<3)|0;if((eb|0)==0){za=Ya;Aa=Ma;Ba=12;T=140;break e}else{qb=eb;rb=_a<<1}}eb=AR(Fa,0,0,1,32)|0;Qa=eb;do{if((eb|0)==0){sb=0}else{Ea=AR(Fa,0,0,1,20)|0;c[eb+4>>2]=Ea;if((Ea|0)==0){sb=0;break}c[eb>>2]=0;c[eb+8>>2]=-1;c[eb+12>>2]=-1;c[Ea>>2]=db;c[Ea+4>>2]=ob;c[Ea+8>>2]=-1;sb=Qa}}while(0);c[qb+(Za<<2)>>2]=sb;kb=sb;lb=qb;mb=rb;nb=pb}if((kb|0)==0){T=141;break e}else{Ya=lb;Za=Za+1|0;_a=mb;$a=nb}}}i:do{if((T|0)==85){T=0;c[q>>2]=xa+1;wa=(va|0)!=0;if(wa){bc(Y|0,fa|0,4,59)}j:do{if((fa|0)>0){X=(ea|0)>0;ya=ea<<2;Qa=ya+4|0;if(wa){tb=0;ub=0;vb=0;wb=0}else{db=0;eb=0;while(1){Fa=Y+(db<<2)|0;Ea=c[(c[Fa>>2]|0)+4>>2]|0;do{if((Ea|0)==0){xb=eb;yb=0}else{c[Ea+8>>2]=c[x>>2];if(X){Ga=AR(c[w>>2]|0,0,0,0,Qa)|0;Da=Ea+16|0;c[Da>>2]=Ga;if((Ga|0)==0){zb=Y;Ab=eb;Bb=12;break i}GS(Ga|0,z|0,ya|0)|0;c[(c[Da>>2]|0)+(ea<<2)>>2]=0}else{c[Ea+16>>2]=0}if((eb|0)==0){xb=c[Fa>>2]|0;yb=0;break}Da=c[w>>2]|0;Ga=c[Fa>>2]|0;gb=AR(Da,0,0,1,32)|0;fb=gb;do{if((gb|0)==0){Cb=0}else{Db=AR(Da,0,0,1,8)|0;Eb=gb+4|0;c[Eb>>2]=Db;if((Db|0)==0){Cb=0;break}c[gb>>2]=3;c[gb+8>>2]=-1;c[gb+12>>2]=-1;c[Db>>2]=eb;c[(c[Eb>>2]|0)+4>>2]=Ga;c[gb+16>>2]=(c[Ga+16>>2]|0)+(c[eb+16>>2]|0);Cb=fb}}while(0);xb=Cb;yb=(Cb|0)==0?12:0}}while(0);Fa=db+1|0;if((Fa|0)<(fa|0)&(yb|0)==0){db=Fa;eb=xb}else{Fb=0;Gb=xb;Hb=yb;break j}}}while(1){eb=Y+(vb<<2)|0;db=c[(c[eb>>2]|0)+4>>2]|0;Fa=c[db>>2]|0;Ea=db+4|0;fb=c[Ea>>2]|0;do{if((Fa|0)<(tb|0)){Ga=fb+1|0;Ib=(Ga|0)<(tb|0)?tb:Ga;Jb=ub;Kb=wb;Lb=0}else{if((Fa|0)<=(ub|0)){Ga=fb+1|0;Ib=Ga;Jb=Ga;Kb=wb;Lb=0;break}c[db>>2]=ub;c[Ea>>2]=Fa+ -1;Ga=fb+1|0;if((db|0)==0){Ib=Ga;Jb=Ga;Kb=wb;Lb=0;break}c[db+8>>2]=c[x>>2];if(X){gb=AR(c[w>>2]|0,0,0,0,Qa)|0;Da=db+16|0;c[Da>>2]=gb;if((gb|0)==0){zb=Y;Ab=wb;Bb=12;break i}GS(gb|0,z|0,ya|0)|0;c[(c[Da>>2]|0)+(ea<<2)>>2]=0}else{c[db+16>>2]=0}if((wb|0)==0){Ib=Ga;Jb=Ga;Kb=c[eb>>2]|0;Lb=0;break}Da=c[w>>2]|0;gb=c[eb>>2]|0;Eb=AR(Da,0,0,1,32)|0;Db=Eb;do{if((Eb|0)==0){Mb=0}else{Nb=AR(Da,0,0,1,8)|0;Ob=Eb+4|0;c[Ob>>2]=Nb;if((Nb|0)==0){Mb=0;break}c[Eb>>2]=3;c[Eb+8>>2]=-1;c[Eb+12>>2]=-1;c[Nb>>2]=wb;c[(c[Ob>>2]|0)+4>>2]=gb;c[Eb+16>>2]=(c[gb+16>>2]|0)+(c[wb+16>>2]|0);Mb=Db}}while(0);Ib=Ga;Jb=Ga;Kb=Mb;Lb=(Mb|0)==0?12:0}}while(0);eb=vb+1|0;if((eb|0)<(fa|0)&(Lb|0)==0){tb=Ib;ub=Jb;vb=eb;wb=Kb}else{Fb=Jb;Gb=Kb;Hb=Lb;break}}}else{Fb=0;Gb=0;Hb=0}}while(0);if((Hb|0)!=0|wa^1){zb=Y;Ab=Gb;Bb=Hb;break}ya=c[w>>2]|0;Qa=c[x>>2]|0;X=AR(ya,0,0,1,32)|0;eb=X;if((X|0)==0){zb=Y;Ab=Gb;Bb=12;break}db=AR(ya,0,0,1,20)|0;c[X+4>>2]=db;if((db|0)==0){zb=Y;Ab=Gb;Bb=12;break}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[db>>2]=Fb;c[db+4>>2]=1114111;c[db+8>>2]=Qa;if((ea|0)>0){Qa=ea<<2;ya=AR(c[w>>2]|0,0,0,0,Qa+4|0)|0;fb=db+16|0;c[fb>>2]=ya;if((ya|0)==0){zb=Y;Ab=Gb;Bb=12;break}GS(ya|0,z|0,Qa|0)|0;c[(c[fb>>2]|0)+(ea<<2)>>2]=0}else{c[db+16>>2]=0}if((Gb|0)==0){zb=Y;Ab=eb;Bb=0;break}db=c[w>>2]|0;fb=AR(db,0,0,1,32)|0;Qa=fb;do{if((fb|0)==0){Pb=0}else{ya=AR(db,0,0,1,8)|0;Fa=fb+4|0;c[Fa>>2]=ya;if((ya|0)==0){Pb=0;break}c[fb>>2]=3;c[fb+8>>2]=-1;c[fb+12>>2]=-1;c[ya>>2]=Gb;c[(c[Fa>>2]|0)+4>>2]=eb;c[fb+16>>2]=(c[X+16>>2]|0)+(c[Gb+16>>2]|0);Pb=Qa}}while(0);zb=Y;Ab=Pb;Bb=(Pb|0)==0?12:0}else if((T|0)==112){T=0;c[Ra+(fa<<2)>>2]=0;za=Ra;Aa=Ma;Ba=12;T=140}else if((T|0)==141){T=0;c[q>>2]=Ma;zb=lb;Ab=0;Bb=12}}while(0);if((T|0)==140){T=0;c[q>>2]=Aa;zb=za;Ab=0;Bb=Ba}bS(zb);c[x>>2]=(c[x>>2]|0)+1;if((Bb|0)==0){U=M;V=Ab;W=0;break c}else{Z=Bb;T=294;break b}break};case 36:{if((c[v>>2]&1|0)==0){if((a[Q+1|0]|0)!=0){break d}}fa=c[w>>2]|0;Y=AR(fa,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}ea=AR(fa,0,0,1,20)|0;c[Y+4>>2]=ea;if((ea|0)==0){Z=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[ea>>2]=-2;c[ea+4>>2]=2;c[ea+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=Y;W=0;break c;break};case 63:case 43:case 123:case 124:case 42:{T=264;break};case 0:{T=265;break};case 41:{if((M|0)!=0){T=264}break};case 40:{if((c[v>>2]&1|0)!=0){Qb=Q;T=74}break};case 92:{Y=Q+1|0;ea=a[Y]|0;do{if((c[v>>2]&1|0)==0){if(ea<<24>>24==40){c[q>>2]=Y;Qb=Y;T=74;break d}else{fa=a[Q+1|0]|0;if(fa<<24>>24==41){T=265;break d}else{Rb=fa;break}}}else{Rb=ea}}while(0);ea=Q+1|0;Y=Rb<<24>>24==0;if(Y){Z=5;T=294;break b}else{Sb=109796|0;Ub=0}while(1){fa=Ub+1|0;if((a[109792+(Ub<<3)|0]|0)==Rb<<24>>24){Vb=Sb;break}xa=109796+(fa<<3)|0;if((fa|0)==12){Vb=xa;break}else{Sb=xa;Ub=fa}}fa=c[Vb>>2]|0;if((fa|0)!=0){xa=F+0|0;Qa=G+0|0;X=xa+40|0;do{c[xa>>2]=c[Qa>>2];xa=xa+4|0;Qa=Qa+4|0}while((xa|0)<(X|0));c[H>>2]=fa;c[I>>2]=1;Qa=jR(j)|0;if((Qa|0)!=0){Z=Qa;T=294;break b}c[q>>2]=(c[q>>2]|0)+2;c[x>>2]=c[J>>2];U=M;V=c[K>>2]|0;W=0;break c}if(Y){Z=5;T=294;break b}c[q>>2]=ea;Qa=a[ea]|0;k:do{switch(Qa|0){case 120:{xa=Q+2|0;c[q>>2]=xa;X=a[xa]|0;if(X<<24>>24==123){xa=Q+3|0;c[q>>2]=xa;fb=xa;xa=0;while(1){eb=a[fb]|0;if(eb<<24>>24==0|eb<<24>>24==125){Wb=xa;Xb=fb;break}if((YQ(eb<<24>>24)|0)==0){Z=9;T=294;break b}eb=c[q>>2]|0;a[l+xa|0]=a[eb]|0;db=xa+1|0;wa=eb+1|0;c[q>>2]=wa;if(db>>>0>31){Wb=db;Xb=wa;break}else{fb=wa;xa=db}}c[q>>2]=Xb+1;a[l+Wb|0]=0;xa=Tb(C|0,0,16)|0;fb=c[w>>2]|0;db=c[x>>2]|0;wa=AR(fb,0,0,1,32)|0;eb=wa;do{if((wa|0)==0){Yb=0}else{Fa=AR(fb,0,0,1,20)|0;c[wa+4>>2]=Fa;if((Fa|0)==0){Yb=0;break}c[wa>>2]=0;c[wa+8>>2]=-1;c[wa+12>>2]=-1;c[Fa>>2]=xa;c[Fa+4>>2]=xa;c[Fa+8>>2]=db;Yb=eb}}while(0);c[x>>2]=(c[x>>2]|0)+1;Zb=Yb;break k}else{a[D+0|0]=0;a[D+1|0]=0;a[D+2|0]=0;eb=(YQ(X<<24>>24)|0)==0;db=c[q>>2]|0;if(eb){_b=db}else{a[D]=a[db]|0;eb=db+1|0;c[q>>2]=eb;_b=eb}if((YQ(a[_b]|0)|0)!=0){eb=c[q>>2]|0;a[E]=a[eb]|0;c[q>>2]=eb+1}eb=Tb(D|0,0,16)|0;db=c[w>>2]|0;xa=c[x>>2]|0;wa=AR(db,0,0,1,32)|0;fb=wa;do{if((wa|0)==0){$b=0}else{Fa=AR(db,0,0,1,20)|0;c[wa+4>>2]=Fa;if((Fa|0)==0){$b=0;break}c[wa>>2]=0;c[wa+8>>2]=-1;c[wa+12>>2]=-1;c[Fa>>2]=eb;c[Fa+4>>2]=eb;c[Fa+8>>2]=xa;$b=fb}}while(0);c[x>>2]=(c[x>>2]|0)+1;Zb=$b;break k}break};case 62:{fb=c[w>>2]|0;xa=AR(fb,0,0,1,32)|0;eb=xa;do{if((xa|0)==0){ac=0}else{wa=AR(fb,0,0,1,20)|0;c[xa+4>>2]=wa;if((wa|0)==0){ac=0;break}c[xa>>2]=0;c[xa+8>>2]=-1;c[xa+12>>2]=-1;c[wa>>2]=-2;c[wa+4>>2]=32;c[wa+8>>2]=-1;ac=eb}}while(0);c[q>>2]=(c[q>>2]|0)+1;Zb=ac;break};case 66:{eb=c[w>>2]|0;xa=AR(eb,0,0,1,32)|0;fb=xa;do{if((xa|0)==0){cc=0}else{wa=AR(eb,0,0,1,20)|0;c[xa+4>>2]=wa;if((wa|0)==0){cc=0;break}c[xa>>2]=0;c[xa+8>>2]=-1;c[xa+12>>2]=-1;c[wa>>2]=-2;c[wa+4>>2]=128;c[wa+8>>2]=-1;cc=fb}}while(0);c[q>>2]=(c[q>>2]|0)+1;Zb=cc;break};case 60:{fb=c[w>>2]|0;xa=AR(fb,0,0,1,32)|0;eb=xa;do{if((xa|0)==0){dc=0}else{wa=AR(fb,0,0,1,20)|0;c[xa+4>>2]=wa;if((wa|0)==0){dc=0;break}c[xa>>2]=0;c[xa+8>>2]=-1;c[xa+12>>2]=-1;c[wa>>2]=-2;c[wa+4>>2]=16;c[wa+8>>2]=-1;dc=eb}}while(0);c[q>>2]=(c[q>>2]|0)+1;Zb=dc;break};case 98:{eb=c[w>>2]|0;xa=AR(eb,0,0,1,32)|0;fb=xa;do{if((xa|0)==0){ec=0}else{wa=AR(eb,0,0,1,20)|0;c[xa+4>>2]=wa;if((wa|0)==0){ec=0;break}c[xa>>2]=0;c[xa+8>>2]=-1;c[xa+12>>2]=-1;c[wa>>2]=-2;c[wa+4>>2]=64;c[wa+8>>2]=-1;ec=fb}}while(0);c[q>>2]=(c[q>>2]|0)+1;Zb=ec;break};default:{if((RQ(Qa)|0)!=0){fb=(a[c[q>>2]|0]|0)+ -48|0;xa=c[w>>2]|0;eb=c[x>>2]|0;wa=AR(xa,0,0,1,32)|0;if((wa|0)==0){Z=12;T=294;break b}db=AR(xa,0,0,1,20)|0;c[wa+4>>2]=db;if((db|0)==0){Z=12;T=294;break b}c[wa>>2]=0;c[wa+8>>2]=-1;c[wa+12>>2]=-1;c[db>>2]=-4;c[db+4>>2]=fb;c[db+8>>2]=eb;c[x>>2]=(c[x>>2]|0)+1;eb=c[B>>2]|0;c[B>>2]=(fb|0)<(eb|0)?eb:fb;c[q>>2]=(c[q>>2]|0)+1;U=M;V=wa;W=0;break c}wa=c[w>>2]|0;fb=a[c[q>>2]|0]|0;eb=c[x>>2]|0;db=AR(wa,0,0,1,32)|0;xa=db;do{if((db|0)==0){fc=0}else{X=AR(wa,0,0,1,20)|0;c[db+4>>2]=X;if((X|0)==0){fc=0;break}c[db>>2]=0;c[db+8>>2]=-1;c[db+12>>2]=-1;c[X>>2]=fb;c[X+4>>2]=fb;c[X+8>>2]=eb;fc=xa}}while(0);c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1;Zb=fc}}}while(0);if((Zb|0)==0){Z=12;T=294;break b}else{U=M;V=Zb;W=0;break c}break};case 46:{Qa=(c[v>>2]&4|0)==0;ea=c[w>>2]|0;Y=c[x>>2]|0;fa=AR(ea,0,0,1,32)|0;xa=fa;eb=(fa|0)==0;if(Qa){if(eb){Z=12;T=294;break b}Qa=AR(ea,0,0,1,20)|0;c[fa+4>>2]=Qa;if((Qa|0)==0){Z=12;T=294;break b}c[fa>>2]=0;c[fa+8>>2]=-1;c[fa+12>>2]=-1;c[Qa>>2]=0;c[Qa+4>>2]=1114111;c[Qa+8>>2]=Y;gc=xa;hc=(c[x>>2]|0)+1|0}else{if(eb){Z=12;T=294;break b}eb=AR(ea,0,0,1,20)|0;c[fa+4>>2]=eb;if((eb|0)==0){Z=12;T=294;break b}c[fa>>2]=0;c[fa+8>>2]=-1;c[fa+12>>2]=-1;c[eb>>2]=0;c[eb+4>>2]=9;c[eb+8>>2]=Y;Y=c[w>>2]|0;eb=(c[x>>2]|0)+1|0;ea=AR(Y,0,0,1,32)|0;if((ea|0)==0){Z=12;T=294;break b}Qa=AR(Y,0,0,1,20)|0;c[ea+4>>2]=Qa;if((Qa|0)==0){Z=12;T=294;break b}c[ea>>2]=0;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[Qa>>2]=11;c[Qa+4>>2]=1114111;c[Qa+8>>2]=eb;eb=c[w>>2]|0;Qa=AR(eb,0,0,1,32)|0;if((Qa|0)==0){Z=12;T=294;break b}Y=AR(eb,0,0,1,8)|0;eb=Qa+4|0;c[eb>>2]=Y;if((Y|0)==0){Z=12;T=294;break b}c[Qa>>2]=3;c[Qa+8>>2]=-1;c[Qa+12>>2]=-1;c[Y>>2]=xa;c[(c[eb>>2]|0)+4>>2]=ea;c[Qa+16>>2]=(c[ea+16>>2]|0)+(c[fa+16>>2]|0);gc=Qa;hc=(c[x>>2]|0)+2|0}c[x>>2]=hc;c[q>>2]=(c[q>>2]|0)+1;U=M;V=gc;W=0;break c;break};case 94:{if((c[v>>2]&1|0)==0){if((Q|0)!=(c[r>>2]|0)){break d}Qa=qR(m,5)|0;if((Qa|0)!=0){R=M;S=Qa;T=6;break b}}Qa=c[w>>2]|0;fa=AR(Qa,0,0,1,32)|0;if((fa|0)==0){Z=12;T=294;break b}ea=AR(Qa,0,0,1,20)|0;c[fa+4>>2]=ea;if((ea|0)==0){Z=12;T=294;break b}c[fa>>2]=0;c[fa+8>>2]=-1;c[fa+12>>2]=-1;c[ea>>2]=-2;c[ea+4>>2]=1;c[ea+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=fa;W=0;break c;break};default:{}}}while(0);if((T|0)==74){T=0;_=M+1|0;c[q>>2]=Qb+1;fa=qR(m,c[y>>2]|0)|0;if((fa|0)!=0){R=_;S=fa;T=6;break b}fa=qR(m,2)|0;if((fa|0)!=0){R=_;S=fa;T=6;break b}fa=qR(m,0)|0;if((fa|0)!=0){R=_;S=fa;T=6;break b}c[y>>2]=(c[y>>2]|0)+1;U=_;V=N;W=0;break c}else if((T|0)==264){T=0;if((c[v>>2]&1|0)!=0){T=265}}if((T|0)==265){T=0;_=c[w>>2]|0;fa=AR(_,0,0,1,32)|0;if((fa|0)==0){Z=12;T=294;break b}ea=AR(_,0,0,1,20)|0;c[fa+4>>2]=ea;if((ea|0)==0){Z=12;T=294;break b}c[fa>>2]=0;c[fa+8>>2]=-1;c[fa+12>>2]=-1;c[ea>>2]=-1;c[ea+4>>2]=-1;c[ea+8>>2]=-1;U=M;V=fa;W=0;break c}fa=eR(h,Q,-1)|0;if((fa|0)<0){c[h>>2]=-1;ic=1}else{ic=fa}do{if((c[v>>2]&2|0)==0){T=280}else{if((XQ(c[h>>2]|0)|0)==0){if((TQ(c[h>>2]|0)|0)==0){T=280;break}}fa=c[w>>2]|0;ea=ZQ(c[h>>2]|0)|0;_=ZQ(c[h>>2]|0)|0;Qa=c[x>>2]|0;eb=AR(fa,0,0,1,32)|0;if((eb|0)==0){Z=12;T=294;break b}xa=AR(fa,0,0,1,20)|0;c[eb+4>>2]=xa;if((xa|0)==0){Z=12;T=294;break b}c[eb>>2]=0;c[eb+8>>2]=-1;c[eb+12>>2]=-1;c[xa>>2]=ea;c[xa+4>>2]=_;c[xa+8>>2]=Qa;Qa=c[w>>2]|0;xa=$Q(c[h>>2]|0)|0;_=$Q(c[h>>2]|0)|0;ea=c[x>>2]|0;fa=AR(Qa,0,0,1,32)|0;if((fa|0)==0){Z=12;T=294;break b}Y=AR(Qa,0,0,1,20)|0;c[fa+4>>2]=Y;if((Y|0)==0){Z=12;T=294;break b}c[fa>>2]=0;c[fa+8>>2]=-1;c[fa+12>>2]=-1;c[Y>>2]=xa;c[Y+4>>2]=_;c[Y+8>>2]=ea;ea=c[w>>2]|0;Y=AR(ea,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}_=AR(ea,0,0,1,8)|0;ea=Y+4|0;c[ea>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[Y>>2]=3;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[_>>2]=eb;c[(c[ea>>2]|0)+4>>2]=fa;c[Y+16>>2]=(c[fa+16>>2]|0)+(c[eb+16>>2]|0);jc=Y}}while(0);if((T|0)==280){T=0;Q=c[w>>2]|0;Y=c[h>>2]|0;eb=c[x>>2]|0;fa=AR(Q,0,0,1,32)|0;if((fa|0)==0){Z=12;T=294;break b}ea=AR(Q,0,0,1,20)|0;c[fa+4>>2]=ea;if((ea|0)==0){Z=12;T=294;break b}c[fa>>2]=0;c[fa+8>>2]=-1;c[fa+12>>2]=-1;c[ea>>2]=Y;c[ea+4>>2]=Y;c[ea+8>>2]=eb;jc=fa}c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+ic;U=M;V=jc;W=0;break};case 5:{fa=c[q>>2]|0;eb=a[fa]|0;if(eb<<24>>24==0){U=M;V=N;W=0;break c}ea=c[v>>2]&1;Y=(ea|0)!=0;if(Y&eb<<24>>24==124){U=M;V=N;W=0;break c}do{if(!(Y&eb<<24>>24==41&(M|0)>0)){if((ea|0)==0&eb<<24>>24==92){if((a[fa+1|0]|0)==41){break}}Q=qR(m,5)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}Q=qR(m,N)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}Q=qR(m,6)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}U=M;V=N;W=qR(m,4)|0;break c}}while(0);eb=(ea|M|0)==0?8:0;Y=M+ -1|0;if((ea|0)!=0){U=Y;V=N;W=eb;break c}c[q>>2]=fa+2;U=Y;V=N;W=eb;break};case 4:{eb=qR(m,9)|0;if((eb|0)!=0){R=M;S=eb;T=6;break b}U=M;V=N;W=qR(m,1)|0;break};case 8:{eb=L+ -2|0;c[n>>2]=eb;Y=c[P+(eb<<2)>>2]|0;eb=c[w>>2]|0;Q=AR(eb,0,0,1,32)|0;if((Q|0)==0){Z=12;T=294;break b}_=AR(eb,0,0,1,8)|0;eb=Q+4|0;c[eb>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[Q>>2]=3;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[_>>2]=Y;c[(c[eb>>2]|0)+4>>2]=N;c[Q+16>>2]=(c[N+16>>2]|0)+(c[Y+16>>2]|0);U=M;V=Q;W=0;break};case 2:{Q=L+ -2|0;c[n>>2]=Q;Y=c[P+(Q<<2)>>2]|0;if((c[N+12>>2]|0)>-1){Q=c[w>>2]|0;eb=AR(Q,0,0,1,32)|0;if((eb|0)==0){Z=12;T=294;break b}_=AR(Q,0,0,1,20)|0;c[eb+4>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[eb>>2]=0;c[eb+8>>2]=-1;c[eb+12>>2]=-1;c[_>>2]=-1;c[_+4>>2]=-1;c[_+8>>2]=-1;_=c[w>>2]|0;Q=AR(_,0,0,1,32)|0;if((Q|0)==0){Z=12;T=294;break b}xa=AR(_,0,0,1,8)|0;_=Q+4|0;c[_>>2]=xa;if((xa|0)==0){Z=12;T=294;break b}c[Q>>2]=1;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[xa>>2]=eb;c[(c[_>>2]|0)+4>>2]=N;_=N+16|0;xa=Q+16|0;c[xa>>2]=(c[_>>2]|0)+(c[eb+16>>2]|0);c[xa>>2]=c[_>>2];kc=Q}else{kc=N}c[kc+12>>2]=Y;Y=kc+16|0;c[Y>>2]=(c[Y>>2]|0)+1;U=M;V=kc;W=0;break};case 10:{Y=L+ -2|0;c[n>>2]=Y;c[v>>2]=c[P+(Y<<2)>>2];U=M;V=N;W=0;break};default:{U=M;V=N;W=0}}}while(0);P=c[n>>2]|0;O=(W|0)==0;if((P|0)>(o|0)&O){L=P;M=U;N=V}else{lc=O;mc=U;nc=V;oc=W;break a}}if((T|0)==6){lc=(S|0)==0;mc=R;nc=N;oc=S;break}else if((T|0)==294){i=d;return Z|0}}else{lc=t;mc=0;nc=0;oc=p}}while(0);p=(mc|0)>0;if(p|lc^1){Z=p?8:oc;i=d;return Z|0}c[b+8>>2]=nc;Z=0;i=d;return Z|0}function kR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;g=i;h=d+12|0;j=c[h>>2]|0;k=(b|0)==0|(f|0)==0;if(!k){c[f+48>>2]=0;c[c[f+36>>2]>>2]=-1}l=c[f+28>>2]|0;m=aS((l<<3)+8|0)|0;n=m;if((m|0)==0){o=12;i=g;return o|0}c[m>>2]=-1;p=aS((l<<2)+4|0)|0;if((p|0)==0){bS(m);o=12;i=g;return o|0}c[p>>2]=-1;q=0;while(1){if(q>>>0>l>>>0){break}else{q=q+1|0}}qR(d,e)|0;e=qR(d,0)|0;q=c[h>>2]|0;a:do{if((q|0)>(j|0)&(e|0)==0){l=d+16|0;r=f+32|0;s=f+16|0;t=f+36|0;u=q;v=0;w=-1;x=1;y=0;z=0;A=n;B=0;while(1){C=u+ -1|0;c[h>>2]=C;D=c[l>>2]|0;b:do{switch(c[D+(C<<2)>>2]|0){case 0:{E=u+ -2|0;c[h>>2]=E;F=c[D+(E<<2)>>2]|0;E=F;G=F+12|0;H=c[G>>2]|0;if((H|0)>-1){I=0;do{J=A+(I<<2)|0;I=I+1|0}while((c[J>>2]|0)>-1);c[J>>2]=H<<1;c[A+(I<<2)>>2]=-1;do{if(!k){K=0;while(1){if((c[p+(K<<2)>>2]|0)>-1){K=K+1|0}else{break}}c[(c[s>>2]|0)+(H*12|0)+8>>2]=0;if((K|0)<=0){break}L=aS((K<<2)+4|0)|0;M=L;if((L|0)==0){N=w;O=y;P=z;Q=A;R=12;S=B;break a}c[(c[s>>2]|0)+(H*12|0)+8>>2]=M;T=c[p>>2]|0;if((T|0)>-1){U=M;V=T;T=0;while(1){c[U>>2]=V;W=T+1|0;X=c[p+(W<<2)>>2]|0;Y=L+(W<<2)|0;if((X|0)>-1){T=W;V=X;U=Y}else{Z=Y;break}}}else{Z=M}c[Z>>2]=-1}}while(0);H=qR(d,c[G>>2]|0)|0;if((H|0)!=0){N=w;O=y;P=z;Q=A;R=H;S=B;break a}H=qR(d,6)|0;if((H|0)!=0){N=w;O=y;P=z;Q=A;R=H;S=B;break a}}H=c[F>>2]|0;do{if((H|0)==0){I=c[c[F+4>>2]>>2]|0;if(!((I|0)>-1|(I|0)==-4)){_=v;$=w;aa=x;ba=y;ca=z;da=0;ea=B;break}if(!((c[A>>2]|0)>-1)){_=v;$=w;aa=x;ba=y;ca=z;da=0;ea=B;break}if(k){c[F+20>>2]=1;fa=w;ga=y;ha=0}else{I=sR(b,E,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){U=c[t>>2]|0;V=0;while(1){ia=U+(V<<2)|0;ja=V+1|0;if((c[ia>>2]|0)>-1){V=ja}else{break}}c[ia>>2]=B;c[U+(ja<<2)>>2]=w;c[U+(V+2<<2)>>2]=-1;ka=-1;la=y+1|0}else{ka=w;la=y}M=c[A>>2]|0;if((M|0)>-1){T=c[s>>2]|0;L=M;M=0;do{K=(L|0)/2|0;if((L&1|0)==0){c[T+(K*12|0)>>2]=B}else{c[T+(K*12|0)+4>>2]=B}M=M+1|0;L=c[A+(M<<2)>>2]|0;}while((L|0)>-1)}c[A>>2]=-1;fa=ka;ga=la;ha=I}c[A>>2]=-1;_=v;$=fa;aa=x+1|0;ba=ga;ca=z+1|0;da=ha;ea=x}else if((H|0)==3){L=c[F+4>>2]|0;M=c[L>>2]|0;T=c[L+4>>2]|0;L=(c[A>>2]|0)>-1;V=x+1|0;U=qR(d,L?V:x)|0;if((U|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=U;ea=B;break}U=qR(d,L?x:B)|0;if((U|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=U;ea=B;break}U=qR(d,A)|0;if((U|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=U;ea=B;break}U=qR(d,(c[A>>2]|0)>>>31^1)|0;if((U|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=U;ea=B;break}U=qR(d,F)|0;if((U|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=U;ea=B;break}U=T;T=qR(d,U)|0;if((T|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=T;ea=B;break}T=M;M=qR(d,T)|0;if((M|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=M;ea=B;break}M=qR(d,3)|0;if((M|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=M;ea=B;break}M=qR(d,U)|0;if((M|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=M;ea=B;break}M=qR(d,0)|0;if((M|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=M;ea=B;break}M=qR(d,2)|0;if((M|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=M;ea=B;break}M=qR(d,T)|0;if((M|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=M;ea=B;break}M=qR(d,0)|0;if((M|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=M;ea=B;break}if((c[A>>2]|0)>-1){if(k){ma=w;na=y;oa=0}else{M=sR(b,E,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){T=c[t>>2]|0;U=0;while(1){pa=T+(U<<2)|0;qa=U+1|0;if((c[pa>>2]|0)>-1){U=qa}else{break}}c[pa>>2]=B;c[T+(qa<<2)>>2]=w;c[T+(U+2<<2)>>2]=-1;ra=-1;sa=y+1|0}else{ra=w;sa=y}I=c[A>>2]|0;if((I|0)>-1){L=c[s>>2]|0;K=I;I=0;do{Y=(K|0)/2|0;if((K&1|0)==0){c[L+(Y*12|0)>>2]=B}else{c[L+(Y*12|0)+4>>2]=B}I=I+1|0;K=c[A+(I<<2)>>2]|0;}while((K|0)>-1)}c[A>>2]=-1;ma=ra;na=sa;oa=M}c[A>>2]=-1;ta=ma;ua=V;va=na;wa=z+1|0;xa=oa;ya=x}else{ta=w;ua=x;va=y;wa=z;xa=0;ya=B}if((c[F+16>>2]|0)<=0){_=v;$=ta;aa=ua;ba=va;ca=wa;da=xa;ea=ya;break}_=v;$=ta;aa=ua+2|0;ba=va;ca=wa;da=xa;ea=ua+1|0}else if((H|0)==2){K=c[F+4>>2]|0;if(k){if((c[A>>2]|0)>-1){za=1}else{za=a[K+12|0]&1}I=qR(d,za)|0;if((I|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=I;ea=B;break}}else{I=qR(d,B)|0;if((I|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=I;ea=B;break}I=qR(d,a[K+12|0]&1)|0;if((I|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=I;ea=B;break}}I=qR(d,F)|0;if((I|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=I;ea=B;break}I=qR(d,1)|0;if((I|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=I;ea=B;break}I=qR(d,c[K>>2]|0)|0;if((I|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=I;ea=B;break}I=qR(d,0)|0;if((I|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=I;ea=B;break}if(!((c[A>>2]|0)>-1)){if((a[K+12|0]&1)==0){_=0;$=w;aa=x;ba=y;ca=z;da=0;ea=B;break}}if(k){Aa=w;Ba=y;Ca=0}else{I=sR(b,E,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=(a[K+12|0]&1)==0?v:1;if((w|0)>-1){K=c[t>>2]|0;L=0;while(1){Da=K+(L<<2)|0;Ea=L+1|0;if((c[Da>>2]|0)>-1){L=Ea}else{break}}c[Da>>2]=B;c[K+(Ea<<2)>>2]=w;c[K+(L+2<<2)>>2]=-1;Fa=-1;Ga=y+1|0}else{Fa=w;Ga=y}V=c[A>>2]|0;if((V|0)>-1){M=c[s>>2]|0;U=V;V=0;do{T=(U|0)/2|0;if((U&1|0)==0){c[M+(T*12|0)>>2]=B}else{c[M+(T*12|0)+4>>2]=B}V=V+1|0;U=c[A+(V<<2)>>2]|0;}while((U|0)>-1)}c[A>>2]=-1;Aa=Fa;Ba=Ga;Ca=I}c[A>>2]=-1;_=0;$=Aa;aa=x+1|0;ba=Ba;ca=z+1|0;da=Ca;ea=x}else if((H|0)==1){U=c[F+4>>2]|0;V=c[U>>2]|0;M=c[U+4>>2]|0;U=qR(d,F)|0;if((U|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=U;ea=B;break}U=qR(d,5)|0;if((U|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=U;ea=B;break}U=qR(d,M)|0;if((U|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=U;ea=B;break}U=qR(d,0)|0;if((U|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=U;ea=B;break}U=V+20|0;L=qR(d,(c[U>>2]|0)+x|0)|0;if((L|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=L;ea=B;break}if((c[U>>2]|0)>0){U=(c[M+20>>2]|0)>0;Ha=(U&1)+x|0;Ia=U?x:-1}else{Ha=x;Ia=-1}U=qR(d,Ia)|0;if((U|0)!=0){_=v;$=w;aa=Ha;ba=y;ca=z;da=U;ea=B;break}U=qR(d,4)|0;if((U|0)!=0){_=v;$=w;aa=Ha;ba=y;ca=z;da=U;ea=B;break}U=qR(d,V)|0;if((U|0)!=0){_=v;$=w;aa=Ha;ba=y;ca=z;da=U;ea=B;break}_=v;$=w;aa=Ha;ba=y;ca=z;da=qR(d,0)|0;ea=B}else{_=v;$=w;aa=x;ba=y;ca=z;da=0;ea=B}}while(0);F=c[G>>2]|0;if((F|0)>-1){Ja=0}else{Ka=_;La=$;Ma=aa;Na=ba;Oa=ca;Pa=A;Qa=da;Ra=ea;break b}do{Sa=p+(Ja<<2)|0;Ja=Ja+1|0}while((c[Sa>>2]|0)>-1);c[Sa>>2]=F;c[p+(Ja<<2)>>2]=-1;Ka=_;La=$;Ma=aa;Na=ba;Oa=ca;Pa=A;Qa=da;Ra=ea;break};case 1:{G=u+ -2|0;c[h>>2]=G;H=c[D+(G<<2)>>2]|0;if(k){G=c[(c[c[H+4>>2]>>2]|0)+20>>2]|0;E=u+ -3|0;c[h>>2]=E;c[H+20>>2]=(c[D+(E<<2)>>2]|0)+G;Ka=v;La=-1;Ma=x;Na=y;Oa=z;Pa=A;Qa=0;Ra=B;break b}else{G=u+ -3|0;c[h>>2]=G;E=c[D+(G<<2)>>2]|0;G=u+ -4|0;c[h>>2]=G;H=(E|0)==0;Ka=H&1;La=H?w:c[D+(G<<2)>>2]|0;Ma=x;Na=y;Oa=z;Pa=A;Qa=0;Ra=B;break b}break};case 2:{G=A;while(1){if((c[G>>2]|0)>-1){G=G+4|0}else{Ka=v;La=w;Ma=x;Na=y;Oa=z;Pa=G;Qa=0;Ra=B;break}}break};case 5:{G=u+ -2|0;c[h>>2]=G;F=c[D+(G<<2)>>2]|0;if(!k){Ka=v;La=w;Ma=x;Na=y;Oa=z;Pa=A;Qa=0;Ra=B;break b}G=c[F+4>>2]|0;c[F+20>>2]=(c[(c[G+4>>2]|0)+20>>2]|0)+(c[(c[G>>2]|0)+20>>2]|0);Ka=v;La=w;Ma=x;Na=y;Oa=z;Pa=A;Qa=0;Ra=B;break};case 4:{G=u+ -2|0;c[h>>2]=G;F=c[D+(G<<2)>>2]|0;G=u+ -3|0;c[h>>2]=G;Ka=v;La=w;Ma=c[D+(G<<2)>>2]|0;Na=y;Oa=z;Pa=A;Qa=0;Ra=(F|0)>-1?F:B;break};case 6:{F=u+ -2|0;c[h>>2]=F;G=c[D+(F<<2)>>2]|0;F=0;do{Ta=A+(F<<2)|0;F=F+1|0}while((c[Ta>>2]|0)>-1);c[Ta>>2]=G<<1|1;c[A+(F<<2)>>2]=-1;H=0;while(1){if((c[p+(H<<2)>>2]|0)>-1){H=H+1|0}else{break}}c[p+(H+ -1<<2)>>2]=-1;Ka=v;La=w;Ma=x;Na=y;Oa=z;Pa=A;Qa=0;Ra=B;break};case 3:{F=c[D+(u+ -2<<2)>>2]|0;G=c[D+(u+ -3<<2)>>2]|0;E=c[D+(u+ -4<<2)>>2]|0;U=u+ -5|0;c[h>>2]=U;if(k){V=c[E+4>>2]|0;M=E+16|0;c[E+20>>2]=(c[(c[V>>2]|0)+20>>2]|0)+(c[D+(U<<2)>>2]|0)+(c[(c[V+4>>2]|0)+20>>2]|0)+((c[M>>2]|0)>0?2:0);Ua=M;Va=c[h>>2]|0}else{Ua=E+16|0;Va=U}U=c[D+(Va+ -1<<2)>>2]|0;E=Va+ -2|0;c[h>>2]=E;M=c[D+(E<<2)>>2]|0;E=Va+ -3|0;c[h>>2]=E;V=c[D+(E<<2)>>2]|0;if((c[Ua>>2]|0)<=0){Ka=1;La=w;Ma=x;Na=y;Oa=z;Pa=U;Qa=0;Ra=B;break b}if(k){Wa=0}else{tR(b,F,M)|0;c[(c[r>>2]|0)+(M<<2)>>2]=1;M=tR(b,G,V)|0;c[(c[r>>2]|0)+(V<<2)>>2]=1;Wa=M}Ka=1;La=w;Ma=x;Na=y;Oa=z+2|0;Pa=U;Qa=Wa;Ra=B;break};default:{Ka=v;La=w;Ma=x;Na=y;Oa=z;Pa=A;Qa=0;Ra=B}}}while(0);D=c[h>>2]|0;if((D|0)>(j|0)&(Qa|0)==0){u=D;v=Ka;w=La;x=Ma;y=Na;z=Oa;A=Pa;B=Ra}else{N=La;O=Na;P=Oa;Q=Pa;R=Qa;S=Ra;break a}}}else{N=-1;O=0;P=0;Q=n;R=e;S=0}}while(0);do{if(k){Xa=O}else{e=c[Q>>2]|0;if((e|0)>-1){n=c[f+16>>2]|0;Ra=e;e=0;do{Qa=(Ra|0)/2|0;if((Ra&1|0)==0){c[n+(Qa*12|0)>>2]=S}else{c[n+(Qa*12|0)+4>>2]=S}e=e+1|0;Ra=c[Q+(e<<2)>>2]|0;}while((Ra|0)>-1)}c[Q>>2]=-1;if(!((N|0)>-1)){Xa=O;break}Ra=c[f+36>>2]|0;e=0;while(1){Ya=Ra+(e<<2)|0;Za=e+1|0;if((c[Ya>>2]|0)>-1){e=Za}else{break}}c[Ya>>2]=S;c[Ra+(Za<<2)>>2]=N;c[Ra+(e+2<<2)>>2]=-1;Xa=O+1|0}}while(0);c[f+48>>2]=P;c[f+40>>2]=P;c[f+44>>2]=Xa;bS(m);bS(p);o=R;i=g;return o|0}function lR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a;a:while(1){a=c[g>>2]|0;do{if((a|0)==3){h=c[g+4>>2]|0;j=lR(c[h>>2]|0,b,d,e)|0;if((j|0)!=0){k=j;l=10;break a}m=h+4|0}else if((a|0)==1){h=c[g+4>>2]|0;j=h+4|0;n=nR(c[(c[h>>2]|0)+28>>2]|0,c[(c[j>>2]|0)+24>>2]|0,b,d,e)|0;if((n|0)!=0){k=n;l=10;break a}n=lR(c[h>>2]|0,b,d,e)|0;if((n|0)==0){m=j}else{k=n;l=10;break a}}else if((a|0)==2){n=c[g+4>>2]|0;j=n;if(!((c[n+8>>2]|0)==-1)){m=j;break}h=c[n>>2]|0;n=nR(c[h+28>>2]|0,c[h+24>>2]|0,b,d,e)|0;if((n|0)==0){m=j}else{k=n;l=10;break a}}else{k=0;l=10;break a}}while(0);g=c[m>>2]|0}if((l|0)==10){i=f;return k|0}return 0}function mR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+4>>2]|0;if((d|0)==0){i=b;return}a=d+4|0;e=c[d>>2]|0;if((c[a>>2]|0)==0){f=e}else{g=e;e=0;while(1){do{if((c[g+(e<<5)+8>>2]|0)==0){h=g}else{j=c[g+(e<<5)+16>>2]|0;if((j|0)==0){k=g}else{bS(j);k=c[d>>2]|0}j=c[k+(e<<5)+28>>2]|0;if((j|0)==0){h=k;break}bS(j);h=c[d>>2]|0}}while(0);j=e+1|0;if(j>>>0<(c[a>>2]|0)>>>0){g=h;e=j}else{f=h;break}}}if((f|0)!=0){bS(f)}f=d+8|0;h=c[f>>2]|0;if((h|0)!=0){if((c[h+8>>2]|0)==0){l=h}else{e=h;while(1){h=c[e+16>>2]|0;if((h|0)!=0){bS(h)}if((c[e+40>>2]|0)==0){break}else{e=e+32|0}}l=c[f>>2]|0}bS(l)}l=d+16|0;f=c[l>>2]|0;if((f|0)!=0){e=d+28|0;h=c[e>>2]|0;if((h|0)==0){m=f}else{g=h;h=f;f=0;while(1){a=c[h+(f*12|0)+8>>2]|0;if((a|0)==0){n=h;o=g}else{bS(a);n=c[l>>2]|0;o=c[e>>2]|0}a=f+1|0;if(a>>>0<o>>>0){g=o;h=n;f=a}else{m=n;break}}}bS(m)}m=c[d+32>>2]|0;if((m|0)!=0){bS(m)}m=c[d+20>>2]|0;if((m|0)!=0){bS(m)}m=c[d+36>>2]|0;if((m|0)!=0){bS(m)}bS(d);i=b;return}function nR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;h=a;a=c[h>>2]|0;j=(a|0)>-1;if((d|0)==0){if(!j){k=0;i=g;return k|0}l=b;m=a;a=h;while(1){a:do{if((c[l>>2]|0)>-1){n=b;o=m;while(1){p=e+(o<<2)|0;c[p>>2]=(c[p>>2]|0)+1;p=n+32|0;if(!((c[p>>2]|0)>-1)){break a}o=c[a>>2]|0;n=p}}}while(0);n=a+32|0;o=c[n>>2]|0;if((o|0)>-1){m=o;a=n}else{k=0;break}}i=g;return k|0}if(!j){k=0;i=g;return k|0}j=b;a=h;b:while(1){h=c[j>>2]|0;c:do{if((h|0)>-1){m=a+4|0;e=a+8|0;l=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+12|0;r=b;s=h;t=j;u=-1;while(1){v=r;w=s;x=t;while(1){y=v+32|0;if((w|0)!=(u|0)){break}z=y;A=c[z>>2]|0;if((A|0)>-1){w=A;x=z;v=y}else{break c}}z=d+(c[f+(c[a>>2]<<2)>>2]<<5)|0;while(1){B=z+8|0;if((c[B>>2]|0)==0){break}else{z=z+32|0}}c[z+40>>2]=0;c[z>>2]=c[m>>2];c[z+4>>2]=c[e>>2];A=c[x>>2]|0;c[B>>2]=d+(c[f+(A<<2)>>2]<<5);c[z+12>>2]=A;A=c[n>>2]|0;C=c[o>>2]|0;D=c[v+16>>2]|c[l>>2]|((A|0)!=0?4:0)|((C|0)!=0?8:0);E=z+20|0;c[E>>2]=D;F=c[p>>2]|0;G=z+24|0;if((F|0)>-1){c[G>>2]=F;c[E>>2]=D|256}else{c[G>>2]=A}if((C|0)==0){c[z+28>>2]=0}else{A=0;while(1){H=A+1|0;if((c[C+(A<<2)>>2]|0)==0){break}else{A=H}}A=aS(H<<2)|0;C=A;c[z+28>>2]=C;if((A|0)==0){k=12;I=49;break b}x=c[o>>2]|0;G=c[x>>2]|0;if((G|0)==0){J=C}else{D=C;C=G;G=0;while(1){c[D>>2]=C;E=G+1|0;F=c[x+(E<<2)>>2]|0;K=A+(E<<2)|0;if((F|0)==0){J=K;break}else{G=E;C=F;D=K}}}c[J>>2]=0}D=c[q>>2]|0;if((D|0)==0){L=0}else{C=0;while(1){if((c[D+(C<<2)>>2]|0)>-1){C=C+1|0}else{L=C;break}}}C=v+12|0;D=c[C>>2]|0;if((D|0)==0){M=0}else{G=0;while(1){if((c[D+(G<<2)>>2]|0)>-1){G=G+1|0}else{M=G;break}}}G=z+16|0;D=c[G>>2]|0;if((D|0)!=0){bS(D)}c[G>>2]=0;D=M+L|0;if((D|0)>0){v=aS((D<<2)+4|0)|0;c[G>>2]=v;if((v|0)==0){k=12;I=49;break b}G=c[q>>2]|0;do{if((G|0)==0){N=0}else{D=c[G>>2]|0;if((D|0)>-1){O=D;P=0}else{N=0;break}while(1){c[v+(P<<2)>>2]=O;D=P+1|0;A=c[G+(D<<2)>>2]|0;if((A|0)>-1){P=D;O=A}else{N=D;break}}}}while(0);G=c[C>>2]|0;do{if((G|0)==0){Q=N}else{z=c[G>>2]|0;if(!((z|0)>-1)){Q=N;break}D=(N|0)>0;A=z;z=0;x=N;while(1){d:do{if(D){K=0;while(1){F=K+1|0;if((c[v+(K<<2)>>2]|0)==(A|0)){R=x;break d}if((F|0)<(N|0)){K=F}else{I=40;break}}}else{I=40}}while(0);if((I|0)==40){I=0;c[v+(x<<2)>>2]=A;R=x+1|0}K=z+1|0;F=c[G+(K<<2)>>2]|0;if((F|0)>-1){A=F;z=K;x=R}else{Q=R;break}}}}while(0);c[v+(Q<<2)>>2]=-1}G=y;C=c[G>>2]|0;if((C|0)>-1){r=y;s=C;t=G;u=w}else{break}}}}while(0);h=a+32|0;if((c[h>>2]|0)>-1){a=h}else{k=0;I=49;break}}if((I|0)==49){i=g;return k|0}return 0}function oR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=(e|0)==0;a:do{if(h){j=0}else{k=0;while(1){if(!((c[e+(k<<2)>>2]|0)>-1)){j=k;break a}k=k+1|0}}}while(0);k=0;while(1){if((c[b+(k<<5)>>2]|0)>-1){k=k+1|0}else{l=0;break}}while(1){if((c[d+(l<<5)>>2]|0)>-1){l=l+1|0}else{break}}m=AR(a,0,0,1,(l+k<<5)+32|0)|0;k=m;if((m|0)==0){n=0;i=g;return n|0}l=c[b>>2]|0;b:do{if((l|0)>-1){o=(j|0)>0;p=l;q=0;while(1){c[m+(q<<5)>>2]=p;c[m+(q<<5)+4>>2]=c[b+(q<<5)+4>>2];c[m+(q<<5)+8>>2]=c[b+(q<<5)+8>>2];c[m+(q<<5)+16>>2]=c[b+(q<<5)+16>>2]|f;c[m+(q<<5)+20>>2]=c[b+(q<<5)+20>>2];c[m+(q<<5)+24>>2]=c[b+(q<<5)+24>>2];c[m+(q<<5)+28>>2]=c[b+(q<<5)+28>>2];r=b+(q<<5)+12|0;s=c[r>>2]|0;t=(s|0)==0;if(t&h){c[m+(q<<5)+12>>2]=0}else{c:do{if(t){u=0}else{v=0;while(1){if(!((c[s+(v<<2)>>2]|0)>-1)){u=v;break c}v=v+1|0}}}while(0);s=AR(a,0,0,0,(u+j<<2)+4|0)|0;t=s;if((s|0)==0){n=0;break}if((u|0)>0){v=c[r>>2]|0;w=0;while(1){c[s+(w<<2)>>2]=c[v+(w<<2)>>2];x=w+1|0;if((x|0)<(u|0)){w=x}else{y=u;break}}}else{y=0}if(o){w=0;while(1){c[s+(w+y<<2)>>2]=c[e+(w<<2)>>2];v=w+1|0;if((v|0)<(j|0)){w=v}else{z=j;break}}}else{z=0}c[s+(z+y<<2)>>2]=-1;c[m+(q<<5)+12>>2]=t}w=q+1|0;v=c[b+(w<<5)>>2]|0;if((v|0)>-1){p=v;q=w}else{A=w;break b}}i=g;return n|0}else{A=0}}while(0);b=c[d>>2]|0;y=m+(A<<5)|0;d:do{if((b|0)>-1){z=y;j=A;e=b;u=0;while(1){c[z>>2]=e;c[m+(j<<5)+4>>2]=c[d+(u<<5)+4>>2];c[m+(j<<5)+8>>2]=c[d+(u<<5)+8>>2];c[m+(j<<5)+16>>2]=c[d+(u<<5)+16>>2];c[m+(j<<5)+20>>2]=c[d+(u<<5)+20>>2];c[m+(j<<5)+24>>2]=c[d+(u<<5)+24>>2];c[m+(j<<5)+28>>2]=c[d+(u<<5)+28>>2];h=d+(u<<5)+12|0;f=c[h>>2]|0;if((f|0)==0){c[m+(j<<5)+12>>2]=0}else{l=0;while(1){if((c[f+(l<<2)>>2]|0)>-1){l=l+1|0}else{break}}f=AR(a,0,0,0,(l<<2)+4|0)|0;t=f;if((f|0)==0){n=0;break}if((l|0)>0){s=c[h>>2]|0;q=0;while(1){c[f+(q<<2)>>2]=c[s+(q<<2)>>2];p=q+1|0;if((p|0)<(l|0)){q=p}else{B=l;break}}}else{B=0}c[f+(B<<2)>>2]=-1;c[m+(j<<5)+12>>2]=t}l=u+1|0;q=c[d+(l<<5)>>2]|0;s=l+A|0;h=m+(s<<5)|0;if((q|0)>-1){z=h;j=s;e=q;u=l}else{C=h;break d}}i=g;return n|0}else{C=y}}while(0);c[C>>2]=-1;n=k;i=g;return n|0}function pR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=a+12|0;j=c[h>>2]|0;k=(f|0)!=0;if(k){c[f>>2]=0}l=qR(a,b)|0;if((l|0)!=0){m=l;i=g;return m|0}l=a+16|0;b=(d|0)==0;n=(e|0)==0;a:while(1){o=c[h>>2]|0;if((o|0)<=(j|0)){m=0;p=28;break}q=o+ -1|0;c[h>>2]=q;o=c[(c[l>>2]|0)+(q<<2)>>2]|0;q=c[o>>2]|0;do{if((q|0)==2){r=c[c[o+4>>2]>>2]|0;if((c[r+8>>2]|0)==0){continue a}s=qR(a,r)|0}else if((q|0)==0){r=c[o+4>>2]|0;t=c[r>>2]|0;if((t|0)==-2){if(n){continue a}c[e>>2]=c[e>>2]|c[r+4>>2];continue a}else if(!((t|0)==-3)){continue a}t=c[r+4>>2]|0;if(!((t|0)>-1)){continue a}b:do{if(!b){r=c[d>>2]|0;c:do{if((r|0)>-1){u=r;v=d;w=0;while(1){x=w+1|0;if((u|0)==(t|0)){break}y=d+(x<<2)|0;z=c[y>>2]|0;if((z|0)>-1){u=z;v=y;w=x}else{A=y;B=x;break c}}if((t|0)<0){A=v;B=w}else{break b}}else{A=d;B=0}}while(0);c[A>>2]=t;c[d+(B+1<<2)>>2]=-1}}while(0);if(!k){continue a}c[f>>2]=(c[f>>2]|0)+1;continue a}else if((q|0)==1){t=c[o+4>>2]|0;r=qR(a,c[t>>2]|0)|0;if((r|0)!=0){m=r;p=28;break a}s=qR(a,c[t+4>>2]|0)|0}else if((q|0)==3){t=c[o+4>>2]|0;r=c[t>>2]|0;if((c[r+8>>2]|0)!=0){s=qR(a,r)|0;break}r=c[t+4>>2]|0;if((c[r+8>>2]|0)==0){continue a}s=qR(a,r)|0}else{continue a}}while(0);if((s|0)!=0){m=s;p=28;break}}if((p|0)==28){i=g;return m|0}return 0}function qR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a;h=c[g>>2]|0;if((f|0)<(h|0)){c[(c[a+16>>2]|0)+(f<<2)>>2]=b;c[e>>2]=(c[e>>2]|0)+1;j=0;i=d;return j|0}e=c[a+4>>2]|0;if((h|0)>=(e|0)){j=12;i=d;return j|0}f=(c[a+8>>2]|0)+h|0;h=(f|0)>(e|0)?e:f;f=a+16|0;e=dS(c[f>>2]|0,h<<2)|0;if((e|0)==0){j=12;i=d;return j|0}else{c[g>>2]=h;c[f>>2]=e;qR(a,b)|0;i=d;return 0}return 0}function rR(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;l=i;m=d+12|0;n=c[m>>2]|0;qR(d,e)|0;e=qR(d,0)|0;a:do{if((e|0)==0){o=d+16|0;p=(f&1|0)==0;q=(f&2|0)==0;r=1;s=0;t=j;b:while(1){u=c[m>>2]|0;if((u|0)<=(n|0)){v=s;w=0;break a}x=u+ -1|0;c[m>>2]=x;y=c[o>>2]|0;z=c[y+(x<<2)>>2]|0;if((z|0)==1){x=u+ -2|0;c[m>>2]=x;A=s;B=r;t=c[y+(x<<2)>>2]|0;s=A;r=B;continue}else if((z|0)!=0){C=t;A=s;B=r;t=C;s=A;r=B;continue}z=u+ -2|0;c[m>>2]=z;u=c[y+(z<<2)>>2]|0;z=c[u>>2]|0;do{if((z|0)==2){y=c[u+4>>2]|0;x=qR(d,c[y>>2]|0)|0;if((x|0)!=0){v=s;w=x;break a}x=qR(d,0)|0;if((x|0)!=0){v=s;w=x;break a}x=c[y>>2]|0;D=c[y+4>>2]|0;E=c[y+8>>2]|0;F=a[y+12|0]|0;y=AR(b,0,0,1,32)|0;if((y|0)==0){G=40;break b}H=AR(b,0,0,1,16)|0;I=y+4|0;c[I>>2]=H;if((H|0)==0){G=40;break b}c[y>>2]=2;c[y+8>>2]=-1;c[y+12>>2]=-1;c[H>>2]=x;c[H+4>>2]=D;c[H+8>>2]=E;E=H+12|0;a[E]=a[E]&-2|F&1;c[y+16>>2]=c[x+16>>2];c[t>>2]=y;A=s;B=r;t=c[I>>2]|0;s=A;r=B;continue b}else if((z|0)==0){I=c[u+4>>2]|0;y=c[I+8>>2]|0;x=c[I>>2]|0;F=c[I+4>>2]|0;do{if((x|0)>-1|(x|0)==-4){J=r;K=F;L=x;M=s+1|0;N=(c[g>>2]|0)+y|0}else{if(!((x|0)==-3)){J=r;K=F;L=x;M=s;N=y;break}if(!p){J=r;K=-1;L=-1;M=s;N=-1;break}if(q|(r|0)==0){J=r;K=F;L=-3;M=s;N=y;break}c[h+(F<<2)>>2]=1;J=0;K=F;L=-3;M=s;N=y}}while(0);y=AR(b,0,0,1,32)|0;F=y;do{if((y|0)==0){O=0}else{x=AR(b,0,0,1,20)|0;c[y+4>>2]=x;if((x|0)==0){O=0;break}c[y>>2]=0;c[y+8>>2]=-1;c[y+12>>2]=-1;c[x>>2]=L;c[x+4>>2]=K;c[x+8>>2]=N;O=F}}while(0);c[t>>2]=O;F=(O|0)==0?12:0;if((N|0)<=(c[k>>2]|0)){P=J;Q=M;R=t;S=F;break}c[k>>2]=N;P=J;Q=M;R=t;S=F}else if((z|0)==1){F=c[u+4>>2]|0;y=c[F>>2]|0;x=F+4|0;I=c[x>>2]|0;E=AR(b,0,0,1,32)|0;if((E|0)==0){G=29;break b}H=AR(b,0,0,1,8)|0;D=E+4|0;c[D>>2]=H;if((H|0)==0){G=29;break b}c[E>>2]=1;c[E+8>>2]=-1;c[E+12>>2]=-1;c[H>>2]=y;c[(c[D>>2]|0)+4>>2]=I;c[E+16>>2]=(c[I+16>>2]|0)+(c[y+16>>2]|0);c[t>>2]=E;E=c[D>>2]|0;c[E>>2]=0;D=E+4|0;c[D>>2]=0;y=qR(d,c[x>>2]|0)|0;if((y|0)!=0){v=s;w=y;break a}y=qR(d,0)|0;if((y|0)!=0){v=s;w=y;break a}y=qR(d,D)|0;if((y|0)!=0){v=s;w=y;break a}y=qR(d,1)|0;if((y|0)!=0){v=s;w=y;break a}y=qR(d,c[F>>2]|0)|0;if((y|0)!=0){v=s;w=y;break a}P=r;Q=s;R=E;S=qR(d,0)|0}else if((z|0)==3){E=c[u+4>>2]|0;y=c[E>>2]|0;F=E+4|0;D=c[F>>2]|0;x=AR(b,0,0,1,32)|0;if((x|0)==0){G=20;break b}I=AR(b,0,0,1,8)|0;H=x+4|0;c[H>>2]=I;if((I|0)==0){G=20;break b}c[x>>2]=3;c[x+8>>2]=-1;c[x+12>>2]=-1;c[I>>2]=y;c[(c[H>>2]|0)+4>>2]=D;c[x+16>>2]=(c[D+16>>2]|0)+(c[y+16>>2]|0);c[t>>2]=x;x=c[H>>2]|0;H=qR(d,c[F>>2]|0)|0;if((H|0)!=0){v=s;w=H;break a}H=qR(d,0)|0;if((H|0)!=0){v=s;w=H;break a}H=qR(d,x+4|0)|0;if((H|0)!=0){v=s;w=H;break a}H=qR(d,1)|0;if((H|0)!=0){v=s;w=H;break a}H=qR(d,c[E>>2]|0)|0;if((H|0)!=0){v=s;w=H;break a}P=r;Q=s;R=x;S=qR(d,0)|0}else{C=t;A=s;B=r;t=C;s=A;r=B;continue b}}while(0);if((S|0)==0){r=P;s=Q;t=R}else{v=Q;w=S;break a}}if((G|0)==20){c[t>>2]=0;v=s;w=12;break}else if((G|0)==29){c[t>>2]=0;v=s;w=12;break}else if((G|0)==40){c[t>>2]=0;v=s;w=12;break}}else{v=0;w=e}}while(0);c[g>>2]=(c[g>>2]|0)+v;i=l;return w|0}function sR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=AR(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=AR(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=AR(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f>>2]=j;k=AR(a,0,0,0,32)|0;l=f+4|0;c[l>>2]=k;if((k|0)==0){g=12;i=e;return g|0}m=b+4|0;c[k+4>>2]=c[m>>2];k=b;c[c[l>>2]>>2]=c[k>>2];n=c[l>>2]|0;c[n+8>>2]=-1;c[n+12>>2]=-1;c[n+24>>2]=0;c[(c[l>>2]|0)+28>>2]=0;c[(c[l>>2]|0)+20>>2]=0;c[m>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f>>2]=0;g=12;i=e;return g|0}function tR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=AR(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=AR(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=AR(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f+4>>2]=j;k=AR(a,0,0,0,32)|0;c[f>>2]=k;if((k|0)==0){g=12;i=e;return g|0}l=b+4|0;c[k+4>>2]=c[l>>2];k=b;c[c[f>>2]>>2]=c[k>>2];m=c[f>>2]|0;c[m+8>>2]=-1;c[m+12>>2]=-1;c[m+24>>2]=0;c[(c[f>>2]|0)+28>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[l>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f+4>>2]=0;g=12;i=e;return g|0}function uR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[c[(c[b>>2]|0)+4>>2]>>2]|0;if((e|0)<(a|0)){f=-1;i=d;return f|0}f=(e|0)>(a|0)|0;i=d;return f|0}function vR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;g=d;a:do{if((b|0)==0){h=110040}else{j=b;k=110040;while(1){if((a[k]|0)==0){h=k;break a}l=j+ -1|0;m=k+((ES(k|0)|0)+1)|0;if((l|0)==0){h=m;break}else{j=l;k=m}}}}while(0);c[g>>2]=(a[h]|0)==0?h+1|0:h;h=(Kc(e|0,f|0,110328,g|0)|0)+1|0;i=d;return h|0}



function ew(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b+12|0;s=c[r>>2]|0;t=s;Vo(3);u=b;v=hc(c[u>>2]|0,63560)|0;if((v|0)==0){fw(t);w=c[d+536>>2]|0;x=c[u>>2]|0;y=Nd(c[(Lc()|0)>>2]|0)|0;c[q>>2]=x;c[q+4>>2]=y;Vn(w,63568,q)}pc(63624,46,1,v|0)|0;q=s+20|0;c[p>>2]=c[q>>2];od(v|0,63672,p|0)|0;p=s+8|0;c[o>>2]=c[p>>2];od(v|0,63696,o|0)|0;pc(63720,40,1,v|0)|0;pc(63768,11,1,v|0)|0;pc(63784,14,1,v|0)|0;if((c[p>>2]|0)>0){o=0;do{w=fa(c[q>>2]|0,o)|0;z=+h[(c[s>>2]|0)+(w<<3)>>3];gw(v,z,z);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Jd(10,v|0)|0;if((c[b+8>>2]|0)==0){A=1}else{pc(63800,18,1,v|0)|0;if((c[p>>2]|0)>0){b=0;do{o=fa(c[q>>2]|0,b)|0;w=c[s>>2]|0;gw(v,+h[w+(o<<3)>>3],+h[w+(o+1<<3)>>3]);b=b+1|0;}while((b|0)<(c[p>>2]|0))}Jd(10,v|0)|0;A=2}b=d+116|0;o=c[b>>2]|0;if((o|0)>0){w=d+8|0;y=o;o=0;x=A;while(1){B=c[w>>2]|0;if((a[B+(o*112|0)+104|0]|0)==0){c[n>>2]=c[B+(o*112|0)+4>>2];od(v|0,63824,n|0)|0;if((c[p>>2]|0)>0){B=0;do{C=fa(c[q>>2]|0,B)|0;D=c[s>>2]|0;gw(v,+h[D+(C<<3)>>3],+h[D+(C+x<<3)>>3]);B=B+1|0;}while((B|0)<(c[p>>2]|0))}Jd(10,v|0)|0;E=c[b>>2]|0;F=x+1|0}else{E=y;F=x}B=o+1|0;if((B|0)<(E|0)){y=E;o=B;x=F}else{G=F;break}}}else{G=A}A=d+124|0;F=c[A>>2]|0;if((F|0)>0){x=d+12|0;o=F;F=0;E=G;while(1){y=c[x>>2]|0;if((a[y+(F*60|0)+56|0]|0)==0){c[m>>2]=c[y+(F*60|0)+4>>2];od(v|0,63824,m|0)|0;if((c[p>>2]|0)>0){y=0;do{b=fa(c[q>>2]|0,y)|0;n=c[s>>2]|0;gw(v,+h[n+(b<<3)>>3],+h[n+(b+E<<3)>>3]);y=y+1|0;}while((y|0)<(c[p>>2]|0))}Jd(10,v|0)|0;H=c[A>>2]|0;I=E+1|0}else{H=o;I=E}y=F+1|0;if((y|0)<(H|0)){o=H;F=y;E=I}else{J=I;break}}}else{J=G}G=d+128|0;I=c[G>>2]|0;if((I|0)>0){E=d+16|0;F=I;I=0;H=J;while(1){o=c[E>>2]|0;if((a[o+(I*48|0)+44|0]|0)==0){c[l>>2]=c[o+(I*48|0)+4>>2];od(v|0,63824,l|0)|0;if((c[p>>2]|0)>0){o=0;do{A=fa(c[q>>2]|0,o)|0;m=c[s>>2]|0;gw(v,+h[m+(A<<3)>>3],+h[m+(A+H<<3)>>3]);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Jd(10,v|0)|0;K=c[G>>2]|0;L=H+1|0}else{K=F;L=H}o=I+1|0;if((o|0)<(K|0)){F=K;I=o;H=L}else{M=L;break}}}else{M=J}J=d+216|0;L=c[J>>2]|0;if((L|0)>0){H=d+40|0;I=L;L=0;K=M;while(1){F=c[H>>2]|0;if((a[F+(L*52|0)+48|0]|0)==0){c[k>>2]=c[F+(L*52|0)+16>>2];od(v|0,63824,k|0)|0;if((c[p>>2]|0)>0){F=0;do{G=fa(c[q>>2]|0,F)|0;l=c[s>>2]|0;gw(v,+h[l+(G<<3)>>3],+h[l+(G+K<<3)>>3]);F=F+1|0;}while((F|0)<(c[p>>2]|0))}Jd(10,v|0)|0;N=c[J>>2]|0;O=K+1|0}else{N=I;O=K}F=L+1|0;if((F|0)<(N|0)){I=N;L=F;K=O}else{P=O;break}}}else{P=M}M=d+220|0;O=c[M>>2]|0;if((O|0)>0){K=d+44|0;L=O;O=0;N=P;while(1){I=c[K>>2]|0;if((a[I+(O*52|0)+48|0]|0)==0){c[j>>2]=c[I+(O*52|0)+16>>2];od(v|0,63824,j|0)|0;if((c[p>>2]|0)>0){I=0;do{J=fa(c[q>>2]|0,I)|0;k=c[s>>2]|0;gw(v,+h[k+(J<<3)>>3],+h[k+(J+N<<3)>>3]);I=I+1|0;}while((I|0)<(c[p>>2]|0))}Jd(10,v|0)|0;Q=c[M>>2]|0;R=N+1|0}else{Q=L;R=N}I=O+1|0;if((I|0)<(Q|0)){L=Q;O=I;N=R}else{S=R;break}}}else{S=P}P=d+224|0;R=c[P>>2]|0;if((R|0)>0){N=d+48|0;O=R;R=0;Q=S;while(1){S=c[N>>2]|0;if((a[S+(R*52|0)+48|0]|0)==0){c[g>>2]=c[S+(R*52|0)+16>>2];od(v|0,63824,g|0)|0;if((c[p>>2]|0)>0){S=0;do{L=fa(c[q>>2]|0,S)|0;M=c[s>>2]|0;gw(v,+h[M+(L<<3)>>3],+h[M+(L+Q<<3)>>3]);S=S+1|0;}while((S|0)<(c[p>>2]|0))}Jd(10,v|0)|0;T=c[P>>2]|0;U=Q+1|0}else{T=O;U=Q}S=R+1|0;if((S|0)<(T|0)){O=T;R=S;Q=U}else{break}}}fw(t);if((Vc(v|0)|0)==0){bS(c[r>>2]|0);c[r>>2]=0;Yo(3);i=e;return}else{e=c[d+536>>2]|0;c[f>>2]=c[u>>2];Vn(e,63840,f)}}function fw(a){a=a|0;var b=0,d=0;b=i;d=a;a=c[d>>2]|0;if((a|0)==0){i=b;return}bS(a);c[d>>2]=0;i=b;return}function gw(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=f;h[k>>3]=b;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];od(a|0,63888,f|0)|0;i=e;return}function hw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=gS(192)|0;IS(m|0,0,192)|0;iw(m);c[a+12>>2]=m;n=m;o=a;Fs(n,c[o>>2]|0,36);if(II(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){a=c[b+536>>2]|0;c[g>>2]=c[o>>2];Vn(a,63928,g)}else{g=m;lK(g,63904,14)|0;mK(h,g);a=St(h)|0;h=m+184|0;c[h>>2]=a;lK(g,63920,4)|0;jw(n,b+8|0);mK(j,g);b=St(j)|0;j=m+188|0;c[j>>2]=b;m=c[h>>2]|0;Es(k,m,((m|0)<0)<<31>>31);h=f;a=k;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];nK(g,f)|0;kw(n,-4-m+b|0);b=c[j>>2]|0;Es(l,b,((b|0)<0)<<31>>31);b=e;j=l;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];nK(g,e)|0;Yo(3);i=d;return}}function iw(a){a=a|0;var b=0;b=i;Dw(a);i=b;return}function jw(a,b){a=a|0;b=b|0;var c=0;c=i;mw(a,3);nw(a,64104);mw(a,0);nw(a,64112);mw(a,2);yw(a,b);zw(a,b);nw(a,64120);mw(a,0);i=c;return}function kw(a,b){a=a|0;b=b|0;var d=0;d=i;c[16024]=yd(b|0)|0;lK(a,64096,4)|0;i=d;return}function lw(b,d,e,f){b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=b;mK(l,q);r=St(l)|0;kw(b,0);mK(m,q);l=St(m)|0;mw(b,1);nw(b,63992);m=e+128|0;s=e+132|0;t=e+136|0;u=e+140|0;ow(b,(c[m>>2]|0)+1+(c[s>>2]|0)+(c[t>>2]|0)+(c[u>>2]|0)|0);pw(b,d);if((c[m>>2]|0)>0){e=f+176|0;v=0;do{pw(b,+h[(c[e>>2]|0)+(v<<3)>>3]);v=v+1|0;}while((v|0)<(c[m>>2]|0))}if((c[s>>2]|0)>0){m=f+180|0;v=0;do{qw(b,c[(c[m>>2]|0)+(v<<2)>>2]|0);v=v+1|0;}while((v|0)<(c[s>>2]|0))}if((c[t>>2]|0)>0){s=f+184|0;v=0;do{rw(b,(a[(c[s>>2]|0)+v|0]|0)!=0);v=v+1|0;}while((v|0)<(c[t>>2]|0))}if((c[u>>2]|0)>0){t=f+188|0;f=0;do{nw(b,c[(c[t>>2]|0)+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(c[u>>2]|0))}mK(n,q);u=St(n)|0;n=FS(0,r|0,32)|0;Es(o,n,J);n=k;r=o;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];nK(q,k)|0;kw(b,u-l|0);Es(p,u,((u|0)<0)<<31>>31);u=j;l=p;c[u+0>>2]=c[l+0>>2];c[u+4>>2]=c[l+4>>2];c[u+8>>2]=c[l+8>>2];c[u+12>>2]=c[l+12>>2];nK(q,j)|0;i=g;return}function mw(b,d){b=b|0;d=d|0;var e=0;e=i;a[64080]=-33;c[16022]=yd(d|0)|0;d=b;lK(d,64080,1)|0;lK(d,64088,4)|0;i=e;return}function nw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;c[f>>2]=yd(ES(d|0)|0)|0;a[64072]=-37;g=b;lK(g,64072,1)|0;lK(g,f,4)|0;lK(g,d,ES(d|0)|0)|0;i=e;return}function ow(b,d){b=b|0;d=d|0;var e=0;e=i;a[64056]=-35;c[16016]=yd(d|0)|0;d=b;lK(d,64056,1)|0;lK(d,64064,4)|0;i=e;return}function pw(b,c){b=b|0;c=+c;var d=0,e=0;d=i;a[64040]=-53;xw(c);e=b;lK(e,64040,1)|0;lK(e,64048,8)|0;i=d;return}function qw(b,d){b=b|0;d=d|0;var e=0;e=i;a[64024]=-46;c[16008]=yd(d|0)|0;d=b;lK(d,64024,1)|0;lK(d,64032,4)|0;i=e;return}function rw(b,c){b=b|0;c=c|0;var d=0;d=i;a[64016]=c?-61:-62;lK(b,64016,1)|0;i=d;return}function sw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+12>>2]|0;a=b+8|0;f=b+240|0;lw(e,+h[f>>3],a,f);lw(e,+h[b+248>>3],a,f);i=d;return}function tw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=c[b+12>>2]|0;b=o;p=o;mK(j,p);o=St(j)|0;kw(b,0);mK(k,p);j=St(k)|0;mw(b,1);nw(b,64e3);k=d+116|0;q=d+124|0;r=d+128|0;s=d+132|0;ow(b,(c[k>>2]|0)+1+(c[q>>2]|0)+(c[r>>2]|0)+(c[s>>2]|0)|0);t=d+4|0;pw(b,+h[c[c[t>>2]>>2]>>3]);if((c[k>>2]|0)>0){d=0;do{pw(b,+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+(d<<3)>>3]);d=d+1|0;}while((d|0)<(c[k>>2]|0))}if((c[q>>2]|0)>0){k=0;do{qw(b,c[(c[(c[c[t>>2]>>2]|0)+12>>2]|0)+(k<<2)>>2]|0);k=k+1|0;}while((k|0)<(c[q>>2]|0))}if((c[r>>2]|0)>0){q=0;do{rw(b,(a[(c[(c[c[t>>2]>>2]|0)+16>>2]|0)+q|0]|0)!=0);q=q+1|0;}while((q|0)<(c[r>>2]|0))}if((c[s>>2]|0)>0){r=0;do{nw(b,c[(c[(c[c[t>>2]>>2]|0)+20>>2]|0)+(r<<2)>>2]|0);r=r+1|0;}while((r|0)<(c[s>>2]|0))}mK(l,p);s=St(l)|0;l=FS(0,o|0,32)|0;Es(m,l,J);l=g;o=m;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];nK(p,g)|0;kw(b,s-j|0);Es(n,s,((s|0)<0)<<31>>31);s=f;j=n;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];nK(p,f)|0;i=e;return}function uw(a,b){a=a|0;b=b|0;var d=0;b=i;d=a+12|0;a=c[d>>2]|0;ys(a);Vo(3);if((a|0)!=0){vw(a);iS(a)}c[d>>2]=0;Yo(3);i=b;return}function vw(a){a=a|0;var b=0;b=i;ww(a);i=b;return}function ww(a){a=a|0;var b=0;b=i;Vt(a);i=b;return}function xw(b){b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=d;h[e>>3]=b;if((yd(1)|0)==1){f=e;g=c[f+4>>2]|0;j=64048;c[j>>2]=c[f>>2];c[j+4>>2]=g;i=d;return}h[k>>3]=b;g=c[k>>2]&255;j=0;while(1){a[64048+(7-j)|0]=g;f=j+1|0;if((f|0)>=8){break}g=a[e+f|0]|0;j=f}i=d;return}function yw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;nw(a,63992);mw(a,4);nw(a,64128);mw(a,0);nw(a,64136);f=b+128|0;g=b+132|0;h=b+136|0;j=b+140|0;ow(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);nw(a,64144);if((c[f>>2]|0)>0){k=b+16|0;l=0;do{nw(a,c[(c[k>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){l=b+20|0;k=0;do{nw(a,c[(c[l>>2]|0)+(k*60|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){k=b+24|0;l=0;do{nw(a,c[(c[k>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)>0){l=b+28|0;k=0;do{nw(a,c[(c[l>>2]|0)+(k*52|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[j>>2]|0))}k=e;l=64232;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];Aw(a,b,e);nw(a,64168);mw(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);Bw(a,64144,64176);if((c[f>>2]|0)>0){e=b+16|0;l=0;do{k=c[e>>2]|0;Bw(a,c[k+(l*112|0)+4>>2]|0,c[k+(l*112|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=b+20|0;l=0;do{e=c[f>>2]|0;Bw(a,c[e+(l*60|0)+4>>2]|0,c[e+(l*60|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){g=b+24|0;l=0;do{f=c[g>>2]|0;Bw(a,c[f+(l*48|0)+4>>2]|0,c[f+(l*48|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)<=0){i=d;return}h=b+28|0;b=0;do{l=c[h>>2]|0;Bw(a,c[l+(b*52|0)+4>>2]|0,c[l+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[j>>2]|0));i=d;return}function zw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=b+108|0;g=c[f>>2]|0;h=b+116|0;j=c[h>>2]|0;k=b+120|0;l=c[k>>2]|0;m=b+124|0;n=c[m>>2]|0;nw(a,64e3);mw(a,4);nw(a,64128);mw(a,0);nw(a,64136);o=g+1+j+l+n|0;ow(a,o);nw(a,64144);if((c[f>>2]|0)>0){n=b;l=0;do{nw(a,c[(c[n>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){l=b+4|0;n=0;do{nw(a,c[(c[l>>2]|0)+(n*60|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){n=b+8|0;l=0;do{nw(a,c[(c[n>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[k>>2]|0))}if((c[m>>2]|0)>0){l=b+12|0;n=0;do{nw(a,c[(c[l>>2]|0)+(n*52|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[m>>2]|0))}n=e;l=64152;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];Aw(a,b,e);nw(a,64168);mw(a,o);Bw(a,64144,64176);if((c[f>>2]|0)>0){o=b;e=0;do{l=c[o>>2]|0;Bw(a,c[l+(e*112|0)+4>>2]|0,c[l+(e*112|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){f=b+4|0;e=0;do{o=c[f>>2]|0;Bw(a,c[o+(e*60|0)+4>>2]|0,c[o+(e*60|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){h=b+8|0;e=0;do{f=c[h>>2]|0;Bw(a,c[f+(e*48|0)+4>>2]|0,c[f+(e*48|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[k>>2]|0))}if((c[m>>2]|0)<=0){i=d;return}k=b+12|0;b=0;do{e=c[k>>2]|0;Bw(a,c[e+(b*52|0)+4>>2]|0,c[e+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[m>>2]|0));i=d;return}function Aw(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;nw(b,64200);g=d+208|0;h=c[g>>2]|0;if((h|0)>0){j=c[d+32>>2]|0;k=0;l=0;while(1){m=(c[e+(a[j+(k*52|0)+8|0]<<2)>>2]|0)+l|0;n=k+1|0;if((n|0)<(h|0)){l=m;k=n}else{o=m;break}}}else{o=0}k=d+212|0;l=c[k>>2]|0;if((l|0)>0){h=c[d+36>>2]|0;j=0;m=o;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{q=n;break}}}else{q=o}o=d+216|0;j=c[o>>2]|0;if((j|0)>0){m=c[d+40>>2]|0;l=0;h=q;while(1){n=(c[e+(a[m+(l*52|0)+8|0]<<2)>>2]|0)+h|0;p=l+1|0;if((p|0)<(j|0)){h=n;l=p}else{r=n;break}}}else{r=q}q=d+220|0;l=c[q>>2]|0;if((l|0)>0){h=c[d+44>>2]|0;j=0;m=r;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{s=n;break}}}else{s=r}mw(b,s);s=c[g>>2]|0;if((s|0)>0){r=d+32|0;j=d+16|0;m=d;l=s;s=0;h=0;while(1){n=c[r>>2]|0;p=a[n+(s*52|0)+8|0]|0;if((c[e+(p<<24>>24<<2)>>2]|0)==0){t=l;u=h}else{v=p<<24>>24==2?64144:h;if(p<<24>>24==0){w=c[(c[m>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else if(p<<24>>24==1){w=c[(c[j>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else{w=v}Cw(b,c[n+(s*52|0)+16>>2]|0,w,(c[n+(s*52|0)>>2]|0)!=0);t=c[g>>2]|0;u=w}n=s+1|0;if((n|0)<(t|0)){l=t;s=n;h=u}else{x=u;break}}}else{x=0}u=c[k>>2]|0;if((u|0)>0){h=d+36|0;s=d+20|0;t=d+4|0;l=u;u=0;w=x;while(1){g=c[h>>2]|0;j=a[g+(u*52|0)+8|0]|0;if((c[e+(j<<24>>24<<2)>>2]|0)==0){y=l;z=w}else{m=j<<24>>24==2?64144:w;if(j<<24>>24==0){A=c[(c[t>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else if(j<<24>>24==1){A=c[(c[s>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else{A=m}Cw(b,c[g+(u*52|0)+16>>2]|0,A,(c[g+(u*52|0)>>2]|0)!=0);y=c[k>>2]|0;z=A}g=u+1|0;if((g|0)<(y|0)){l=y;u=g;w=z}else{B=z;break}}}else{B=x}x=c[o>>2]|0;if((x|0)>0){z=d+40|0;w=d+24|0;u=d+8|0;y=x;x=0;l=B;while(1){A=c[z>>2]|0;k=a[A+(x*52|0)+8|0]|0;if((c[e+(k<<24>>24<<2)>>2]|0)==0){C=y;D=l}else{s=k<<24>>24==2?64144:l;if(k<<24>>24==1){E=c[(c[w>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else if(k<<24>>24==0){E=c[(c[u>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else{E=s}Cw(b,c[A+(x*52|0)+16>>2]|0,E,(c[A+(x*52|0)>>2]|0)!=0);C=c[o>>2]|0;D=E}A=x+1|0;if((A|0)<(C|0)){y=C;x=A;l=D}else{F=D;break}}}else{F=B}B=c[q>>2]|0;if((B|0)<=0){i=f;return}D=d+44|0;l=d+28|0;x=d+12|0;d=B;B=0;C=F;while(1){F=c[D>>2]|0;y=a[F+(B*52|0)+8|0]|0;if((c[e+(y<<24>>24<<2)>>2]|0)==0){G=d;H=C}else{E=y<<24>>24==2?64144:C;if(y<<24>>24==0){I=c[(c[x>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else if(y<<24>>24==1){I=c[(c[l>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else{I=E}Cw(b,c[F+(B*52|0)+16>>2]|0,I,(c[F+(B*52|0)>>2]|0)!=0);G=c[q>>2]|0;H=I}F=B+1|0;if((F|0)<(G|0)){d=G;B=F;C=H}else{break}}i=f;return}function Bw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;nw(a,b);mw(a,1);nw(a,64184);nw(a,c);i=d;return}function Cw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;nw(a,b);mw(a,d?2:1);nw(a,64208);nw(a,c);if(!d){i=e;return}nw(a,64216);nw(a,64224);i=e;return}function Dw(a){a=a|0;var b=0;b=i;Lv(a);i=b;return}function Ew(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=i;i=i+288|0;d=c;e=c+16|0;f=c+32|0;g=c+48|0;h=c+64|0;j=c+80|0;k=c+96|0;l=c+112|0;m=c+128|0;n=c+144|0;o=c+160|0;p=c+176|0;q=c+192|0;r=c+208|0;s=c+224|0;t=c+240|0;u=c+256|0;v=c+272|0;RH(e,64248);NH(d,Gw(a,e)|0);Fw(d,b+4|0);XH(d);XH(e);RH(g,64256);NH(f,Gw(a,g)|0);Hw(f,b);XH(f);XH(g);RH(j,64272);NH(h,Gw(a,j)|0);Fw(h,b+8|0);XH(h);XH(j);RH(l,64288);NH(k,Gw(a,l)|0);Fw(k,b+12|0);XH(k);XH(l);RH(n,64304);NH(m,Gw(a,n)|0);Iw(m,b+16|0,0);XH(m);XH(n);RH(p,64320);NH(o,Gw(a,p)|0);Iw(o,b+20|0,0);XH(o);XH(p);RH(r,64336);NH(q,Gw(a,r)|0);Iw(q,b+24|0,0);XH(q);XH(r);RH(t,64344);NH(s,Gw(a,t)|0);Iw(s,b+28|0,0);XH(s);XH(t);RH(v,64360);NH(u,Gw(a,v)|0);Iw(u,b+32|0,0);XH(u);XH(v);i=c;return}function Fw(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;if((b|0)==0){Tn(22,0,67568,d);i=d;return}else{c[b>>2]=rd(sI(a)|0)|0;i=d;return}}function Gw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=PA(a,f,b)|0;l=c[k>>2]|0;qt(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}RA(j,a,b);SA(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];QA(g,e);TA(j);j=c[f>>2]|0;UA(a,j,k,VA(g)|0);k=WA(g)|0;TA(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function Hw(a,b){a=a|0;b=b|0;var d=0;d=i;if((vI(a,64536)|0)==0){c[b>>2]=1;i=d;return}if((vI(a,64544)|0)==0){c[b>>2]=0;i=d;return}else{c[b>>2]=Dc(sI(a)|0)|0;i=d;return}}function Iw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((vI(a,64512)|0)==0){c[b>>2]=d}if((vI(a,64536)|0)==0){c[b>>2]=1;i=e;return}if((vI(a,64544)|0)==0){c[b>>2]=0;i=e;return}else{c[b>>2]=Dc(sI(a)|0)|0;i=e;return}}function Jw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;e=i;i=i+56|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;RH(j,64376);NH(g,Gw(b,j)|0);y=d+48|0;Kw(g,y);XH(g);XH(j);RH(m,64392);NH(l,Gw(b,m)|0);j=d+56|0;Lw(l,j,0.0);XH(l);XH(m);RH(o,64400);NH(n,Gw(b,o)|0);m=d+32|0;Kw(n,m);XH(n);XH(o);RH(q,64408);NH(p,Gw(b,q)|0);o=d+33|0;Kw(p,o);XH(p);XH(q);RH(s,64424);NH(r,Gw(b,s)|0);q=d+40|0;Lw(r,q,1.0);XH(r);XH(s);RH(u,64432);NH(t,Gw(b,u)|0);s=d+16|0;Lw(t,s,-1.7976931348623157e+308);XH(t);XH(u);RH(w,64440);NH(v,Gw(b,w)|0);u=d+24|0;Lw(v,u,1.7976931348623157e+308);XH(v);XH(w);RH(x,64248);w=sI(Gw(b,x)|0)|0;b=(a[y]|0)!=0;z=+h[j>>3];j=(a[m]|0)!=0?64536:64544;m=(a[o]|0)!=0;A=+h[q>>3];B=+h[s>>3];C=+h[u>>3];c[f>>2]=w;c[f+4>>2]=b?64512:64520;w=f+8|0;h[k>>3]=z;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[f+16>>2]=b?64512:64528;c[f+20>>2]=j;c[f+24>>2]=m?64512:64520;j=f+28|0;h[k>>3]=A;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[f+36>>2]=m?64512:64528;m=f+40|0;h[k>>3]=B;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=f+48|0;h[k>>3]=C;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];Rn(4,0,64448,f);XH(x);i=e;return}function Kw(b,c){b=b|0;c=c|0;var d=0;d=i;a[c]=(vI(b,64536)|0)==0|0;i=d;return}function Lw(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;if((vI(a,64512)|0)==0){h[b>>3]=c;i=d;return}if((vI(a,64536)|0)==0){h[b>>3]=1.0;i=d;return}if((vI(a,64544)|0)==0){h[b>>3]=0.0;i=d;return}else{h[b>>3]=+wS(sI(a)|0);i=d;return}}function Mw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;RH(h,64376);NH(g,Gw(b,h)|0);s=d+13|0;Kw(g,s);XH(g);XH(h);RH(k,64392);NH(j,Gw(b,k)|0);h=d+16|0;Iw(j,h,0);XH(j);XH(k);RH(m,64400);NH(l,Gw(b,m)|0);k=d+12|0;Kw(l,k);XH(l);XH(m);RH(o,64432);NH(n,Gw(b,o)|0);m=d+4|0;Iw(n,m,-2147483648);XH(n);XH(o);RH(q,64440);NH(p,Gw(b,q)|0);o=d+8|0;Iw(p,o,2147483647);XH(p);XH(q);RH(r,64248);q=sI(Gw(b,r)|0)|0;b=(a[s]|0)!=0;s=c[h>>2]|0;h=(a[k]|0)!=0?64536:64544;k=c[m>>2]|0;m=c[o>>2]|0;c[f>>2]=q;c[f+4>>2]=b?64512:64520;c[f+8>>2]=s;c[f+12>>2]=b?64512:64528;c[f+16>>2]=h;c[f+20>>2]=k;c[f+24>>2]=m;Rn(4,0,64552,f);XH(r);i=e;return}function Nw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;RH(h,64376);NH(g,Gw(b,h)|0);o=d+5|0;Kw(g,o);XH(g);XH(h);RH(k,64392);NH(j,Gw(b,k)|0);h=d+6|0;Kw(j,h);XH(j);XH(k);RH(m,64400);NH(l,Gw(b,m)|0);k=d+4|0;Kw(l,k);XH(l);XH(m);RH(n,64248);m=sI(Gw(b,n)|0)|0;b=(a[o]|0)!=0;o=(a[h]|0)!=0?64536:64544;h=(a[k]|0)!=0?64536:64544;c[f>>2]=m;c[f+4>>2]=b?64512:64520;c[f+8>>2]=o;c[f+12>>2]=b?64512:64528;c[f+16>>2]=h;Rn(4,0,64608,f);XH(n);i=e;return}function Ow(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;RH(h,64376);NH(g,Gw(b,h)|0);m=d+4|0;Kw(g,m);XH(g);XH(h);RH(k,64392);NH(j,Gw(b,k)|0);h=d+8|0;Fw(j,h);XH(j);XH(k);RH(l,64248);k=sI(Gw(b,l)|0)|0;b=(a[m]|0)!=0;m=c[h>>2]|0;c[f>>2]=k;c[f+4>>2]=b?64512:64520;c[f+8>>2]=m;c[f+12>>2]=b?64512:64528;Rn(4,0,64648,f);XH(l);i=e;return}function Pw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Wc=0,Xc=0,Yc=0,Zc=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+200|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+16|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+1024|0;Ba=i;i=i+8|0;Ca=i;i=i+16|0;Da=i;i=i+8|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;sb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+8|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+8|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+8|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+8|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+8|0;fc=i;i=i+16|0;gc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+8|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+8|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+8|0;sc=i;i=i+16|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+8|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+8|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+8|0;Ec=i;i=i+16|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+8|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+8|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+8|0;Qc=i;i=i+16|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Wc=qa;Qw(qa);LH(ra);Rw(sa,ta);Rw(ua,va);va=b+92|0;do{if((c[va>>2]|0)==0){if((c[77632>>2]|0)==0){RH(za,c[b+80>>2]|0);Sw(ya,za,64672);YH(ra,ya)|0;XH(ya);XH(za)}else{ZH(ra,c[77760>>2]|0)|0}ta=hc(sI(ra)|0,64688)|0;if((ta|0)!=0){Xc=ta;break}c[pa>>2]=sI(ra)|0;Vn(0,64696,pa)}else{Xc=0}}while(0);pa=Ri(0)|0;if((pa|0)==0){Vc(Xc|0)|0;Vn(0,64800,oa)}aj(pa,Wc);bj(pa,7,46);Wc=c[va>>2]|0;do{if((Wc|0)==0){oa=Aa;IS(oa|0,0,1024)|0;while(1){za=rb(oa|0,1,1024,Xc|0)|0;ya=za>>>0<1024;if((cj(pa,oa,za,ya&1)|0)==0){Yc=12;break}if(ya){Yc=14;break}}if((Yc|0)==12){Vc(Xc|0)|0;oa=sI(ra)|0;ya=kj(hj(pa)|0)|0;za=ij(pa)|0;c[na>>2]=oa;c[na+4>>2]=ya;c[na+8>>2]=za;Tn(1,0,64880,na);Yi(pa);Vn(0,64968,ma)}else if((Yc|0)==14){Vc(Xc|0)|0;break}}else{if((cj(pa,Wc,ES(Wc|0)|0,1)|0)!=0){break}za=c[r>>2]|0;ya=c[va>>2]|0;oa=kj(hj(pa)|0)|0;ta=ij(pa)|0;c[la>>2]=ya;c[la+4>>2]=oa;c[la+8>>2]=ta;od(za|0,64992,la|0)|0;za=c[va>>2]|0;ta=kj(hj(pa)|0)|0;oa=ij(pa)|0;c[ka>>2]=za;c[ka+4>>2]=ta;c[ka+8>>2]=oa;Tn(1,0,65008,ka);Yi(pa);Vn(0,64968,ja)}}while(0);ja=qa;RH(Ca,65096);Ww(Ba,ja,Ca);Xw(Da,ja);ka=Vw(Ba,Da)|0;XH(Ca);Ca=b+88|0;Da=c[Ca>>2]|0;do{if(ka){Ba=sI(ra)|0;c[ia>>2]=Da;c[ia+4>>2]=Ba;Tn(1,0,65104,ia)}else{RH(Ea,65096);Ba=AS(Da,sI(Gw(ja,Ea)|0)|0)|0;XH(Ea);if((Ba|0)==0){break}Yi(pa);RH(Fa,65096);Ba=sI(Gw(ja,Fa)|0)|0;va=sI(ra)|0;la=c[Ca>>2]|0;c[ha>>2]=Ba;c[ha+4>>2]=va;c[ha+8>>2]=la;Tn(1,0,65152,ha);XH(Fa);Vn(0,64968,ga)}}while(0);Yw(qa,b,c[77844>>2]|0,c[77848>>2]|0);Rn(23,1,65248,fa);fa=qa+12|0;RH(Ha,65288);NH(Ga,Gw(fa,Ha)|0);ga=d;Lw(Ga,ga,0.0);XH(Ga);XH(Ha);Ha=ea;h[k>>3]=+h[ga>>3];c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];Rn(23,0,65304,ea);RH(Ja,65320);NH(Ia,Gw(fa,Ja)|0);ea=d+8|0;Lw(Ia,ea,1.0);XH(Ia);XH(Ja);Ja=da;h[k>>3]=+h[ea>>3];c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];Rn(23,0,65336,da);RH(La,65352);NH(Ka,Gw(fa,La)|0);da=d+24|0;Lw(Ka,da,(+h[ea>>3]- +h[ga>>3])/500.0);XH(Ka);XH(La);La=ca;h[k>>3]=+h[da>>3];c[La>>2]=c[k>>2];c[La+4>>2]=c[k+4>>2];Rn(23,0,65368,ca);RH(Na,65384);NH(Ma,Gw(fa,Na)|0);ca=d+32|0;Lw(Ma,ca,1.0e-5);XH(Ma);XH(Na);Na=ba;h[k>>3]=+h[ca>>3];c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];Rn(23,0,65400,ba);RH(Pa,65416);NH(Oa,Gw(fa,Pa)|0);ba=d+40|0;Fw(Oa,ba);XH(Oa);XH(Pa);c[aa>>2]=c[ba>>2];Rn(23,0,65424,aa);RH(Ra,65448);NH(Qa,Gw(fa,Ra)|0);aa=d+44|0;Fw(Qa,aa);XH(Qa);XH(Ra);c[$>>2]=c[aa>>2];Rn(23,0,65464,$);RH(Ta,65488);NH(Sa,Gw(fa,Ta)|0);fa=d+48|0;Fw(Sa,fa);XH(Sa);XH(Ta);c[_>>2]=c[fa>>2];Rn(23,0,65504,_);RH(Va,65528);NH(Ua,Gw(ja,Va)|0);_=d+268|0;Fw(Ua,_);XH(Ua);XH(Va);c[Z>>2]=c[_>>2];Rn(23,0,65552,Z);if((c[21324>>2]|0)!=0){Yd[c[5446]&255](23)}RH(eb,65576);NH(db,Gw(ja,eb)|0);Iw(db,Wa,0);XH(db);XH(eb);RH(gb,65608);NH(fb,Gw(ja,gb)|0);Iw(fb,Xa,0);XH(fb);XH(gb);RH(ib,65640);NH(hb,Gw(ja,ib)|0);Iw(hb,Ya,0);XH(hb);XH(ib);RH(kb,65664);NH(jb,Gw(ja,kb)|0);Iw(jb,_a,0);XH(jb);XH(kb);RH(mb,65696);NH(lb,Gw(ja,mb)|0);Iw(lb,Za,0);XH(lb);XH(mb);RH(ob,65736);NH(nb,Gw(ja,ob)|0);Iw(nb,ab,0);XH(nb);XH(ob);RH(qb,65768);NH(pb,Gw(ja,qb)|0);Iw(pb,$a,0);XH(pb);XH(qb);RH(tb,65808);NH(sb,Gw(ja,tb)|0);Iw(sb,cb,0);XH(sb);XH(tb);RH(vb,65840);NH(ub,Gw(ja,vb)|0);Iw(ub,bb,0);XH(ub);XH(vb);vb=c[Wa>>2]|0;Wa=b+104|0;do{if((vb|0)==(c[Wa>>2]|0)){ub=b+108|0;if((c[Xa>>2]|0)!=((c[ub>>2]|0)-(vb<<1)|0)){break}ja=b+128|0;if((c[Ya>>2]|0)!=(c[ja>>2]|0)){break}tb=b+132|0;if((c[_a>>2]|0)!=(c[tb>>2]|0)){break}sb=b+116|0;if((c[Za>>2]|0)!=(c[sb>>2]|0)){break}qb=b+136|0;if((c[ab>>2]|0)!=(c[qb>>2]|0)){break}pb=b+120|0;if((c[$a>>2]|0)!=(c[pb>>2]|0)){break}ob=b+140|0;if((c[cb>>2]|0)!=(c[ob>>2]|0)){break}nb=b+124|0;if((c[bb>>2]|0)!=(c[nb>>2]|0)){break}c[O>>2]=66384;Rn(4,1,66360,O);if((c[Wa>>2]|0)>0){mb=b;lb=qa+24|0;kb=0;do{jb=c[mb>>2]|0;c[wb>>2]=kb;ib=Zw(lb,wb)|0;Ew(ib,jb+(kb*112|0)|0);Jw(ib,jb+(kb*112|0)+40|0);hb=jb+(kb*112|0)+4|0;do{if((a[c[hb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}else{if((c[77628>>2]|0)!=0){break}RH(xb,66400);jb=(vI(Gw(ib,xb)|0,64536)|0)==0;XH(xb);if(!jb){break}c[N>>2]=c[hb>>2];Rn(4,0,66416,N);a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}}while(0);RH(yb,c[hb>>2]|0);c[(_w(sa,yb)|0)>>2]=kb;XH(yb);kb=kb+1|0;}while((kb|0)<(c[Wa>>2]|0))}if((c[21248>>2]|0)!=0){Yd[c[5446]&255](4)}c[M>>2]=66448;Rn(4,1,66360,M);kb=c[Wa>>2]|0;if((kb|0)>0){mb=b;lb=qa+36|0;ib=kb;kb=0;do{jb=ib+kb|0;gb=c[mb>>2]|0;c[zb>>2]=kb;fb=Zw(lb,zb)|0;Ew(fb,gb+(jb*112|0)|0);Jw(fb,gb+(jb*112|0)+40|0);eb=gb+(jb*112|0)+4|0;do{if((a[c[eb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}else{if((c[77628>>2]|0)!=0){break}RH(Ab,66400);gb=(vI(Gw(fb,Ab)|0,64536)|0)==0;XH(Ab);if(!gb){break}c[L>>2]=c[eb>>2];Rn(4,0,66416,L);a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}}while(0);RH(Bb,c[eb>>2]|0);c[(_w(sa,Bb)|0)>>2]=jb;XH(Bb);kb=kb+1|0;ib=c[Wa>>2]|0;}while((kb|0)<(ib|0))}if((c[21248>>2]|0)!=0){Yd[c[5446]&255](4)}c[K>>2]=66472;Rn(4,1,66360,K);ib=c[Wa>>2]<<1;if(((c[ub>>2]|0)-ib|0)>0){kb=b;mb=qa+48|0;lb=ib;ib=0;do{fb=lb+ib|0;hb=c[kb>>2]|0;c[Cb>>2]=ib;gb=Zw(mb,Cb)|0;Ew(gb,hb+(fb*112|0)|0);Jw(gb,hb+(fb*112|0)+40|0);db=hb+(fb*112|0)+4|0;do{if((a[c[db>>2]|0]|0)==36){a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}else{if((c[77628>>2]|0)!=0){break}RH(Db,66400);hb=(vI(Gw(gb,Db)|0,64536)|0)==0;XH(Db);if(!hb){break}c[J>>2]=c[db>>2];Rn(4,0,66416,J);a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}}while(0);RH(Eb,c[db>>2]|0);c[(_w(sa,Eb)|0)>>2]=fb;XH(Eb);ib=ib+1|0;lb=c[Wa>>2]<<1;}while((ib|0)<((c[ub>>2]|0)-lb|0))}if((c[21248>>2]|0)!=0){Yd[c[5446]&255](4)}c[I>>2]=66488;Rn(4,1,66360,I);if((c[sb>>2]|0)>0){lb=b+4|0;ub=qa+84|0;ib=0;do{kb=c[lb>>2]|0;c[Fb>>2]=ib;mb=Zw(ub,Fb)|0;Ew(mb,kb+(ib*60|0)|0);Mw(mb,kb+(ib*60|0)+36|0);gb=kb+(ib*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}else{if((c[77628>>2]|0)!=0){break}RH(Gb,66400);kb=(vI(Gw(mb,Gb)|0,64536)|0)==0;XH(Gb);if(!kb){break}c[H>>2]=c[gb>>2];Rn(4,0,66416,H);a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}}while(0);RH(Hb,c[gb>>2]|0);c[(_w(sa,Hb)|0)>>2]=ib;XH(Hb);ib=ib+1|0;}while((ib|0)<(c[sb>>2]|0))}if((c[21248>>2]|0)!=0){Yd[c[5446]&255](4)}c[G>>2]=66512;Rn(4,1,66360,G);if((c[pb>>2]|0)>0){sb=b+8|0;ib=qa+120|0;lb=0;do{ub=c[sb>>2]|0;c[Ib>>2]=lb;mb=Zw(ib,Ib)|0;Ew(mb,ub+(lb*48|0)|0);Nw(mb,ub+(lb*48|0)+36|0);fb=ub+(lb*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[sb>>2]|0)+(lb*48|0)+44|0]=1}else{if((c[77628>>2]|0)!=0){break}RH(Jb,66400);ub=(vI(Gw(mb,Jb)|0,64536)|0)==0;XH(Jb);if(!ub){break}c[F>>2]=c[fb>>2];Rn(4,0,66416,F);a[(c[sb>>2]|0)+(lb*48|0)+44|0]=1}}while(0);RH(Kb,c[fb>>2]|0);c[(_w(sa,Kb)|0)>>2]=lb;XH(Kb);lb=lb+1|0;}while((lb|0)<(c[pb>>2]|0))}if((c[21248>>2]|0)!=0){Yd[c[5446]&255](4)}c[E>>2]=66536;Rn(4,1,66360,E);if((c[nb>>2]|0)>0){pb=b+12|0;lb=qa+156|0;sb=0;do{ib=c[pb>>2]|0;c[Lb>>2]=sb;mb=Zw(lb,Lb)|0;Ew(mb,ib+(sb*52|0)|0);Ow(mb,ib+(sb*52|0)+36|0);gb=ib+(sb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[pb>>2]|0)+(sb*52|0)+48|0]=1}else{if((c[77628>>2]|0)!=0){break}RH(Mb,66400);ib=(vI(Gw(mb,Mb)|0,64536)|0)==0;XH(Mb);if(!ib){break}c[D>>2]=c[gb>>2];Rn(4,0,66416,D);a[(c[pb>>2]|0)+(sb*52|0)+48|0]=1}}while(0);RH(Nb,c[gb>>2]|0);c[(_w(sa,Nb)|0)>>2]=sb;XH(Nb);sb=sb+1|0;}while((sb|0)<(c[nb>>2]|0))}if((c[21248>>2]|0)!=0){Yd[c[5446]&255](4)}c[C>>2]=66560;Rn(4,1,66360,C);if((c[ja>>2]|0)>0){nb=b+16|0;sb=qa+60|0;pb=0;do{lb=c[nb>>2]|0;c[Ob>>2]=pb;mb=Zw(sb,Ob)|0;Ew(mb,lb+(pb*112|0)|0);Jw(mb,lb+(pb*112|0)+40|0);fb=lb+(pb*112|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}else{if((c[77628>>2]|0)!=0){break}RH(Pb,66400);lb=(vI(Gw(mb,Pb)|0,64536)|0)==0;XH(Pb);if(!lb){break}c[B>>2]=c[fb>>2];Rn(4,0,66416,B);a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}}while(0);RH(Qb,c[fb>>2]|0);c[(_w(ua,Qb)|0)>>2]=pb;XH(Qb);pb=pb+1|0;}while((pb|0)<(c[ja>>2]|0))}if((c[21248>>2]|0)!=0){Yd[c[5446]&255](4)}c[A>>2]=66576;Rn(4,1,66360,A);if((c[tb>>2]|0)>0){ja=b+20|0;pb=qa+96|0;nb=0;do{sb=c[ja>>2]|0;c[Rb>>2]=nb;mb=Zw(pb,Rb)|0;Ew(mb,sb+(nb*60|0)|0);Mw(mb,sb+(nb*60|0)+36|0);gb=sb+(nb*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}else{if((c[77628>>2]|0)!=0){break}RH(Sb,66400);sb=(vI(Gw(mb,Sb)|0,64536)|0)==0;XH(Sb);if(!sb){break}c[z>>2]=c[gb>>2];Rn(4,0,66416,z);a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}}while(0);RH(Tb,c[gb>>2]|0);c[(_w(ua,Tb)|0)>>2]=nb;XH(Tb);nb=nb+1|0;}while((nb|0)<(c[tb>>2]|0))}if((c[21248>>2]|0)!=0){Yd[c[5446]&255](4)}c[y>>2]=66600;Rn(4,1,66360,y);if((c[qb>>2]|0)>0){tb=b+24|0;nb=qa+132|0;ja=0;do{pb=c[tb>>2]|0;c[Ub>>2]=ja;mb=Zw(nb,Ub)|0;Ew(mb,pb+(ja*48|0)|0);Nw(mb,pb+(ja*48|0)+36|0);fb=pb+(ja*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}else{if((c[77628>>2]|0)!=0){break}RH(Vb,66400);pb=(vI(Gw(mb,Vb)|0,64536)|0)==0;XH(Vb);if(!pb){break}c[x>>2]=c[fb>>2];Rn(4,0,66416,x);a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}}while(0);RH(Wb,c[fb>>2]|0);c[(_w(ua,Wb)|0)>>2]=ja;XH(Wb);ja=ja+1|0;}while((ja|0)<(c[qb>>2]|0))}if((c[21248>>2]|0)!=0){Yd[c[5446]&255](4)}c[w>>2]=66624;Rn(4,1,66360,w);if((c[ob>>2]|0)>0){qb=b+28|0;ja=qa+168|0;tb=0;do{nb=c[qb>>2]|0;c[Xb>>2]=tb;mb=Zw(ja,Xb)|0;Ew(mb,nb+(tb*52|0)|0);Ow(mb,nb+(tb*52|0)+36|0);gb=nb+(tb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}else{if((c[77628>>2]|0)!=0){break}RH(Yb,66400);nb=(vI(Gw(mb,Yb)|0,64536)|0)==0;XH(Yb);if(!nb){break}c[v>>2]=c[gb>>2];Rn(4,0,66416,v);a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}}while(0);RH(Zb,c[gb>>2]|0);c[(_w(ua,Zb)|0)>>2]=tb;XH(Zb);tb=tb+1|0;}while((tb|0)<(c[ob>>2]|0))}if((c[21248>>2]|0)!=0){Yd[c[5446]&255](4)}Rn(4,1,66648,u);ob=b+208|0;a:do{if((c[ob>>2]|0)>0){tb=qa+72|0;qb=b+32|0;ja=0;b:while(1){c[_b>>2]=ja;mb=Zw(tb,_b)|0;Ew(mb,(c[qb>>2]|0)+(ja*52|0)+12|0);LH($b);c[bc>>2]=ja;mb=Zw(tb,bc)|0;RH(cc,66688);NH(ac,Gw(mb,cc)|0);$w(ac,$b);XH(ac);XH(cc);mb=(vI($b,66696)|0)==0;fb=c[qb>>2]|0;nb=mb&1;c[fb+(ja*52|0)>>2]=nb;c[t>>2]=c[fb+(ja*52|0)+16>>2];c[t+4>>2]=nb;Rn(4,0,66712,t);nb=c[qb>>2]|0;if((a[c[nb+(ja*52|0)+16>>2]|0]|0)==36){a[nb+(ja*52|0)+48|0]=1}c[ec>>2]=ja;nb=Zw(tb,ec)|0;RH(fc,66752);NH(dc,Gw(nb,fc)|0);$w(dc,$b);XH(dc);XH(fc);ax(wa,sa,$b);ax(xa,ua,$b);cx(gc,sa);do{if(bx(wa,gc)|0){nb=c[(dx(wa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(ja*52|0)+4>>2]=nb;a[fb+(ja*52|0)+8|0]=0}else{cx(ic,ua);if(bx(xa,ic)|0){fb=c[(dx(xa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=fb;a[nb+(ja*52|0)+8|0]=1;break}if((vI($b,66768)|0)!=0){break b}a[(c[qb>>2]|0)+(ja*52|0)+8|0]=2}}while(0);XH($b);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break a}}GI(kc,66776,$b);Sw(jc,kc,66800);XH(kc);c[s>>2]=sI(jc)|0;Vn(0,66816,s)}}while(0);if((c[21248>>2]|0)!=0){Yd[c[5446]&255](4)}Rn(4,1,66824,q);ob=b+212|0;c:do{if((c[ob>>2]|0)>0){ja=qa+108|0;qb=b+36|0;tb=0;while(1){c[lc>>2]=tb;gb=Zw(ja,lc)|0;Ew(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);LH(mc);c[oc>>2]=tb;gb=Zw(ja,oc)|0;RH(pc,66688);NH(nc,Gw(gb,pc)|0);$w(nc,mc);XH(nc);XH(pc);gb=(vI(mc,66696)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[p>>2]=c[nb+(tb*52|0)+16>>2];c[p+4>>2]=fb;Rn(4,0,66712,p);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[rc>>2]=tb;fb=Zw(ja,rc)|0;RH(sc,66752);NH(qc,Gw(fb,sc)|0);$w(qc,mc);XH(qc);XH(sc);ax(wa,sa,mc);ax(xa,ua,mc);cx(tc,sa);if(bx(wa,tc)|0){fb=c[(dx(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{cx(uc,ua);if(!(bx(xa,uc)|0)){break}nb=c[(dx(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}XH(mc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break c}}GI(wc,66864,mc);Sw(vc,wc,66800);XH(wc);c[o>>2]=sI(vc)|0;Vn(0,66816,o)}}while(0);if((c[21248>>2]|0)!=0){Yd[c[5446]&255](4)}Rn(4,1,66888,n);ob=b+216|0;d:do{if((c[ob>>2]|0)>0){tb=qa+144|0;qb=b+40|0;ja=0;while(1){c[xc>>2]=ja;fb=Zw(tb,xc)|0;Ew(fb,(c[qb>>2]|0)+(ja*52|0)+12|0);LH(yc);c[Ac>>2]=ja;fb=Zw(tb,Ac)|0;RH(Bc,66688);NH(zc,Gw(fb,Bc)|0);$w(zc,yc);XH(zc);XH(Bc);fb=(vI(yc,66696)|0)==0;nb=c[qb>>2]|0;gb=fb&1;c[nb+(ja*52|0)>>2]=gb;c[m>>2]=c[nb+(ja*52|0)+16>>2];c[m+4>>2]=gb;Rn(4,0,66712,m);gb=c[qb>>2]|0;if((a[c[gb+(ja*52|0)+16>>2]|0]|0)==36){a[gb+(ja*52|0)+48|0]=1}c[Dc>>2]=ja;gb=Zw(tb,Dc)|0;RH(Ec,66752);NH(Cc,Gw(gb,Ec)|0);$w(Cc,yc);XH(Cc);XH(Ec);ax(wa,sa,yc);ax(xa,ua,yc);cx(Fc,sa);if(bx(wa,Fc)|0){gb=c[(dx(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=gb;a[nb+(ja*52|0)+8|0]=0}else{cx(Gc,ua);if(!(bx(xa,Gc)|0)){break}nb=c[(dx(xa)|0)+12>>2]|0;gb=c[qb>>2]|0;c[gb+(ja*52|0)+4>>2]=nb;a[gb+(ja*52|0)+8|0]=1}XH(yc);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break d}}GI(Ic,66928,yc);Sw(Hc,Ic,66800);XH(Ic);c[l>>2]=sI(Hc)|0;Vn(0,66816,l)}}while(0);if((c[21248>>2]|0)!=0){Yd[c[5446]&255](4)}Rn(4,1,66952,j);ob=b+220|0;e:do{if((c[ob>>2]|0)>0){ja=qa+180|0;qb=b+44|0;tb=0;while(1){c[Jc>>2]=tb;gb=Zw(ja,Jc)|0;Ew(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);LH(Kc);c[Mc>>2]=tb;gb=Zw(ja,Mc)|0;RH(Nc,66688);NH(Lc,Gw(gb,Nc)|0);$w(Lc,Kc);XH(Lc);XH(Nc);gb=(vI(Kc,66696)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[g>>2]=c[nb+(tb*52|0)+16>>2];c[g+4>>2]=fb;Rn(4,0,66712,g);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[Pc>>2]=tb;fb=Zw(ja,Pc)|0;RH(Qc,66752);NH(Oc,Gw(fb,Qc)|0);$w(Oc,Kc);XH(Oc);XH(Qc);ax(wa,sa,Kc);ax(xa,ua,Kc);cx(Rc,sa);if(bx(wa,Rc)|0){fb=c[(dx(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{cx(Sc,ua);if(!(bx(xa,Sc)|0)){break}nb=c[(dx(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}XH(Kc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break e}}GI(Uc,66992,Kc);Sw(Tc,Uc,66800);XH(Uc);c[f>>2]=sI(Tc)|0;Vn(0,66816,f)}}while(0);if((c[21248>>2]|0)==0){Yi(pa);ex(ua);ex(sa);XH(ra);fx(qa);i=e;return}Yd[c[5446]&255](4);Yi(pa);ex(ua);ex(sa);XH(ra);fx(qa);i=e;return}}while(0);if((c[21320>>2]|c[5306]|0)==0){Yi(pa);Zc=md(0)|0;td(-1)}Tn(22,1,65880,Y);Y=c[Wa>>2]|0;c[X>>2]=vb;c[X+4>>2]=Y;Tn(22,0,65928,X);X=(c[b+108>>2]|0)-(c[Wa>>2]<<1)|0;c[W>>2]=c[Xa>>2];c[W+4>>2]=X;Tn(22,0,65976,W);W=c[b+128>>2]|0;c[V>>2]=c[Ya>>2];c[V+4>>2]=W;Tn(22,0,66024,V);V=c[b+132>>2]|0;c[U>>2]=c[_a>>2];c[U+4>>2]=V;Tn(22,0,66072,U);U=c[b+116>>2]|0;c[T>>2]=c[Za>>2];c[T+4>>2]=U;Tn(22,0,66120,T);T=c[b+136>>2]|0;c[S>>2]=c[ab>>2];c[S+4>>2]=T;Tn(22,0,66168,S);S=c[b+120>>2]|0;c[R>>2]=c[$a>>2];c[R+4>>2]=S;Tn(22,0,66216,R);R=c[b+140>>2]|0;c[Q>>2]=c[cb>>2];c[Q+4>>2]=R;Tn(22,0,66264,Q);Q=c[b+124>>2]|0;c[P>>2]=c[bb>>2];c[P+4>>2]=Q;Tn(22,0,66312,P);Yd[c[5446]&255](22);Yi(pa);Zc=md(0)|0;td(-1)}function Qw(a){a=a|0;var b=0;b=i;QD(a);i=b;return}function Rw(a,b){a=a|0;b=b|0;b=i;vz(a,0);i=b;return}function Sw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;MH(a,d);e=VH(b)|0;f=Fx(c)|0;wI(a,WH(b)|0,e,f+e|0);oI(a,c,f)|0;i=d;return}function Tw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;if((AS(b,67624)|0)==0){t=c[d>>2]|0;if((t|0)==0){i=e;return}u=a;v=t;t=0;do{RH(g,v);w=Gw(u,g)|0;ZH(w,c[d+((t|1)<<2)>>2]|0)|0;XH(g);t=t+2|0;v=c[d+(t<<2)>>2]|0;}while((v|0)!=0);i=e;return}if((AS(b,67648)|0)==0){v=c[d>>2]|0;if((v|0)==0){i=e;return}t=a+12|0;g=v;v=0;do{RH(h,g);u=Gw(t,h)|0;ZH(u,c[d+((v|1)<<2)>>2]|0)|0;XH(h);v=v+2|0;g=c[d+(v<<2)>>2]|0;}while((g|0)!=0);i=e;return}if((AS(b,67672)|0)!=0){do{if((AS(b,67928)|0)!=0){if((AS(b,67936)|0)==0){break}if((AS(b,67944)|0)==0){break}if((AS(b,67952)|0)==0){break}i=e;return}}while(0);g=(c[d>>2]|0)==0;v=a+196|0;h=a+192|0;t=Zw(c[v>>2]|0,h)|0;if(g){x=t}else{g=t;t=d;u=0;while(1){RH(r,c[t>>2]|0);w=Gw(g,r)|0;ZH(w,c[d+((u|1)<<2)>>2]|0)|0;XH(r);w=u+2|0;y=d+(w<<2)|0;z=(c[y>>2]|0)==0;A=Zw(c[v>>2]|0,h)|0;if(z){x=A;break}else{u=w;t=y;g=A}}}RH(s,67960);ZH(Gw(x,s)|0,b)|0;XH(s);i=e;return}gx(j,k);LH(l);LH(m);k=a+192|0;s=k;c[k>>2]=-1;b=a+196|0;c[b>>2]=0;x=c[d>>2]|0;if((x|0)!=0){g=x;x=0;do{RH(n,g);t=Gw(j,n)|0;ZH(t,c[d+((x|1)<<2)>>2]|0)|0;XH(n);x=x+2|0;g=c[d+(x<<2)>>2]|0;}while((g|0)!=0)}RH(o,67688);YH(l,Gw(j,o)|0)|0;XH(o);RH(p,67704);YH(m,Gw(j,p)|0)|0;XH(p);c[k>>2]=Dc(sI(l)|0)|0;if((vI(m,67720)|0)==0){B=a+24|0}else{B=c[b>>2]|0}c[b>>2]=B;if((vI(m,67728)|0)==0){C=a+36|0}else{C=c[b>>2]|0}c[b>>2]=C;if((vI(m,67736)|0)==0){D=a+48|0}else{D=c[b>>2]|0}c[b>>2]=D;if((vI(m,67744)|0)==0){E=a+60|0}else{E=c[b>>2]|0}c[b>>2]=E;if((vI(m,67752)|0)==0){F=a+72|0}else{F=c[b>>2]|0}c[b>>2]=F;if((vI(m,67760)|0)==0){G=a+84|0}else{G=c[b>>2]|0}c[b>>2]=G;if((vI(m,67768)|0)==0){H=a+96|0}else{H=c[b>>2]|0}c[b>>2]=H;if((vI(m,67776)|0)==0){I=a+108|0}else{I=c[b>>2]|0}c[b>>2]=I;if((vI(m,67784)|0)==0){J=a+120|0}else{J=c[b>>2]|0}c[b>>2]=J;if((vI(m,67792)|0)==0){K=a+132|0}else{K=c[b>>2]|0}c[b>>2]=K;if((vI(m,67800)|0)==0){L=a+144|0}else{L=c[b>>2]|0}c[b>>2]=L;if((vI(m,67808)|0)==0){M=a+156|0}else{M=c[b>>2]|0}c[b>>2]=M;if((vI(m,67816)|0)==0){N=a+168|0}else{N=c[b>>2]|0}c[b>>2]=N;if((vI(m,67824)|0)==0){O=a+180|0}else{O=c[b>>2]|0}c[b>>2]=O;a=sI(m)|0;RH(q,64248);N=sI(Gw(j,q)|0)|0;c[f>>2]=a;c[f+4>>2]=N;Un(0,(O|0)!=0|0,67832,f);XH(q);tC(Zw(c[b>>2]|0,s)|0,j)|0;XH(m);XH(l);ox(j);i=e;return}function Uw(a,b){a=a|0;b=b|0;i=i;return}function Vw(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ez(a,b)|0;i=c;return d|0}function Ww(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;nz(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];fz(a,f);i=e;return}function Xw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;gz(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];fz(a,e);i=d;return}function Yw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+192|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+8|0;$=i;i=i+16|0;aa=i;i=i+8|0;ba=i;i=i+16|0;ca=i;i=i+8|0;da=i;i=i+16|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+16|0;qa=i;i=i+8|0;ra=i;i=i+16|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+16|0;wa=i;i=i+8|0;xa=i;i=i+16|0;ya=i;i=i+8|0;za=i;i=i+16|0;Aa=i;i=i+8|0;Ba=i;i=i+16|0;Ca=i;i=i+8|0;Da=i;i=i+16|0;Ea=i;i=i+8|0;Fa=i;i=i+16|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;Ka=i;i=i+8|0;La=i;i=i+16|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+16|0;Sa=i;i=i+8|0;Ta=i;i=i+16|0;Ua=i;i=i+8|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;Ya=i;i=i+8|0;Za=i;i=i+16|0;_a=i;i=i+8|0;$a=i;i=i+16|0;ab=i;i=i+8|0;bb=i;i=i+16|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+8|0;fb=i;i=i+16|0;gb=i;i=i+8|0;hb=i;i=i+16|0;ib=i;i=i+8|0;jb=i;i=i+16|0;kb=i;i=i+8|0;lb=i;i=i+16|0;mb=i;i=i+8|0;nb=i;i=i+16|0;ob=i;i=i+8|0;pb=i;i=i+16|0;qb=i;i=i+8|0;rb=i;i=i+16|0;sb=i;i=i+8|0;tb=i;i=i+16|0;ub=i;i=i+8|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+8|0;zb=i;i=i+16|0;Ab=i;i=i+8|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;Gb=i;i=i+8|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+8|0;Lb=i;i=i+16|0;Mb=i;i=i+8|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+8|0;Rb=i;i=i+16|0;Sb=i;i=i+8|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+8|0;_b=i;i=i+16|0;$b=i;i=i+8|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;gx(o,p);p=(d|0)!=0;dc=(e|0)==0;if(!(dc|p^1)){Vn(0,67016,n)}if(p){ec=rd(d|0)|0}else{ec=0}if(dc){fc=ec}else{c[m>>2]=e;Rn(23,0,67160,m);hx(q);ix(q,e,8);if(!(jx(q)|0)){c[l>>2]=e;Vn(0,67200,l)}LH(r);l=q;kx(l,r)|0;NH(s,r);while(1){e=kx(l,r)|0;if(!(HI(e+(c[(c[e>>2]|0)+ -12>>2]|0)|0)|0)){break}GI(t,67280,r);mI(s,t)|0;XH(t)}t=rd(sI(s)|0)|0;lx(q);XH(s);XH(r);mx(q);fc=t}if((fc|0)==0){Rn(23,0,67368,g);ox(o);i=f;return}LH(u);LH(v);c[k>>2]=fc;Rn(23,0,67288,k);k=Vb(fc|0,67280)|0;if((k|0)!=0){g=k;do{k=gS(12)|0;RH(k,g);t=tI(k,67320,0)|0;rI(w,k,0,t);YH(u,w)|0;XH(w);rI(x,k,t+1|0,(cI(k)|0)+~t|0);YH(v,x)|0;XH(x);YH(Gw(o,u)|0,v)|0;t=sI(u)|0;k=sI(v)|0;c[j>>2]=t;c[j+4>>2]=k;Rn(23,0,67328,j);g=Vb(0,67280)|0;}while((g|0)!=0)}bS(fc);fc=a+12|0;RH(y,65416);g=Gw(fc,y)|0;RH(z,65416);if((nx(o,z)|0)==0){RH(B,65416);gc=1;hc=0;ic=Gw(fc,B)|0}else{RH(A,65416);gc=0;hc=1;ic=Gw(o,A)|0}YH(g,ic)|0;if(gc){XH(B)}if(hc){XH(A)}XH(z);XH(y);RH(C,65288);y=Gw(fc,C)|0;RH(D,65288);if((nx(o,D)|0)==0){RH(F,65288);jc=1;kc=0;lc=Gw(fc,F)|0}else{RH(E,65288);jc=0;kc=1;lc=Gw(o,E)|0}YH(y,lc)|0;if(jc){XH(F)}if(kc){XH(E)}XH(D);XH(C);RH(G,65320);C=Gw(fc,G)|0;RH(H,65320);if((nx(o,H)|0)==0){RH(J,65320);mc=1;nc=0;oc=Gw(fc,J)|0}else{RH(I,65320);mc=0;nc=1;oc=Gw(o,I)|0}YH(C,oc)|0;if(mc){XH(J)}if(nc){XH(I)}XH(H);XH(G);RH(K,65352);G=Gw(fc,K)|0;RH(L,65352);if((nx(o,L)|0)==0){RH(N,65352);pc=0;qc=1;rc=Gw(fc,N)|0}else{RH(M,65352);pc=1;qc=0;rc=Gw(o,M)|0}YH(G,rc)|0;if(qc){XH(N)}if(pc){XH(M)}XH(L);XH(K);RH(O,65384);K=Gw(fc,O)|0;RH(P,65384);if((nx(o,P)|0)==0){RH(R,65384);sc=1;tc=0;uc=Gw(fc,R)|0}else{RH(Q,65384);sc=0;tc=1;uc=Gw(o,Q)|0}YH(K,uc)|0;if(sc){XH(R)}if(tc){XH(Q)}XH(P);XH(O);RH(S,65448);O=Gw(fc,S)|0;RH(T,65448);if((nx(o,T)|0)==0){RH(V,65448);vc=1;wc=0;xc=Gw(fc,V)|0}else{RH(U,65448);vc=0;wc=1;xc=Gw(o,U)|0}YH(O,xc)|0;if(vc){XH(V)}if(wc){XH(U)}XH(T);XH(S);RH(W,65488);S=Gw(fc,W)|0;RH(X,65488);if((nx(o,X)|0)==0){RH(Z,65488);yc=1;zc=0;Ac=Gw(fc,Z)|0}else{RH(Y,65488);yc=0;zc=1;Ac=Gw(o,Y)|0}YH(S,Ac)|0;if(yc){XH(Z)}if(zc){XH(Y)}XH(X);XH(W);W=b+104|0;X=c[W>>2]|0;if((X|0)>0){Y=a+24|0;zc=a+36|0;Z=0;while(1){c[_>>2]=Z;yc=Zw(Y,_)|0;RH($,64392);Ac=Gw(yc,$)|0;c[aa>>2]=Z;yc=Zw(Y,aa)|0;RH(ba,64248);if((nx(o,Gw(yc,ba)|0)|0)==0){c[ea>>2]=Z;yc=Zw(Y,ea)|0;RH(fa,64392);Bc=1;Cc=0;Dc=Gw(yc,fa)|0}else{c[ca>>2]=Z;yc=Zw(Y,ca)|0;RH(da,64248);Bc=0;Cc=1;Dc=Gw(o,Gw(yc,da)|0)|0}YH(Ac,Dc)|0;if(Bc){XH(fa)}if(Cc){XH(da)}XH(ba);XH($);c[ga>>2]=Z;Ac=Zw(zc,ga)|0;RH(ha,64392);yc=Gw(Ac,ha)|0;c[ia>>2]=Z;Ac=Zw(zc,ia)|0;RH(ja,64248);if((nx(o,Gw(Ac,ja)|0)|0)==0){c[ma>>2]=Z;Ac=Zw(zc,ma)|0;RH(na,64392);Ec=1;Fc=0;Gc=Gw(Ac,na)|0}else{c[ka>>2]=Z;Ac=Zw(zc,ka)|0;RH(la,64248);Ec=0;Fc=1;Gc=Gw(o,Gw(Ac,la)|0)|0}YH(yc,Gc)|0;if(Ec){XH(na)}if(Fc){XH(la)}XH(ja);XH(ha);yc=Z+1|0;Ac=c[W>>2]|0;if((yc|0)<(Ac|0)){Z=yc}else{Hc=Ac;break}}}else{Hc=X}X=b+108|0;if(((c[X>>2]|0)-(Hc<<1)|0)>0){Hc=a+48|0;Z=0;do{c[oa>>2]=Z;ha=Zw(Hc,oa)|0;RH(pa,64392);ja=Gw(ha,pa)|0;c[qa>>2]=Z;ha=Zw(Hc,qa)|0;RH(ra,64248);if((nx(o,Gw(ha,ra)|0)|0)==0){c[ua>>2]=Z;ha=Zw(Hc,ua)|0;RH(va,64392);Ic=1;Jc=0;Kc=Gw(ha,va)|0}else{c[sa>>2]=Z;ha=Zw(Hc,sa)|0;RH(ta,64248);Ic=0;Jc=1;Kc=Gw(o,Gw(ha,ta)|0)|0}YH(ja,Kc)|0;if(Ic){XH(va)}if(Jc){XH(ta)}XH(ra);XH(pa);Z=Z+1|0;}while((Z|0)<((c[X>>2]|0)-(c[W>>2]<<1)|0))}W=b+116|0;if((c[W>>2]|0)>0){X=a+84|0;Z=0;do{c[wa>>2]=Z;pa=Zw(X,wa)|0;RH(xa,64392);ra=Gw(pa,xa)|0;c[ya>>2]=Z;pa=Zw(X,ya)|0;RH(za,64248);if((nx(o,Gw(pa,za)|0)|0)==0){c[Ca>>2]=Z;pa=Zw(X,Ca)|0;RH(Da,64392);Lc=1;Mc=0;Nc=Gw(pa,Da)|0}else{c[Aa>>2]=Z;pa=Zw(X,Aa)|0;RH(Ba,64248);Lc=0;Mc=1;Nc=Gw(o,Gw(pa,Ba)|0)|0}YH(ra,Nc)|0;if(Lc){XH(Da)}if(Mc){XH(Ba)}XH(za);XH(xa);Z=Z+1|0;}while((Z|0)<(c[W>>2]|0))}W=b+120|0;if((c[W>>2]|0)>0){Z=a+120|0;xa=0;do{c[Ea>>2]=xa;za=Zw(Z,Ea)|0;RH(Fa,64392);Ba=Gw(za,Fa)|0;c[Ga>>2]=xa;za=Zw(Z,Ga)|0;RH(Ha,64248);if((nx(o,Gw(za,Ha)|0)|0)==0){c[Ka>>2]=xa;za=Zw(Z,Ka)|0;RH(La,64392);Oc=1;Pc=0;Qc=Gw(za,La)|0}else{c[Ia>>2]=xa;za=Zw(Z,Ia)|0;RH(Ja,64248);Oc=0;Pc=1;Qc=Gw(o,Gw(za,Ja)|0)|0}YH(Ba,Qc)|0;if(Oc){XH(La)}if(Pc){XH(Ja)}XH(Ha);XH(Fa);xa=xa+1|0;}while((xa|0)<(c[W>>2]|0))}W=b+124|0;if((c[W>>2]|0)>0){xa=a+156|0;Fa=0;do{c[Ma>>2]=Fa;Ha=Zw(xa,Ma)|0;RH(Na,64392);Ja=Gw(Ha,Na)|0;c[Oa>>2]=Fa;Ha=Zw(xa,Oa)|0;RH(Pa,64248);if((nx(o,Gw(Ha,Pa)|0)|0)==0){c[Sa>>2]=Fa;Ha=Zw(xa,Sa)|0;RH(Ta,64392);Rc=1;Sc=0;Tc=Gw(Ha,Ta)|0}else{c[Qa>>2]=Fa;Ha=Zw(xa,Qa)|0;RH(Ra,64248);Rc=0;Sc=1;Tc=Gw(o,Gw(Ha,Ra)|0)|0}YH(Ja,Tc)|0;if(Rc){XH(Ta)}if(Sc){XH(Ra)}XH(Pa);XH(Na);Fa=Fa+1|0;}while((Fa|0)<(c[W>>2]|0))}W=b+128|0;if((c[W>>2]|0)>0){Fa=a+60|0;Na=0;do{c[Ua>>2]=Na;Pa=Zw(Fa,Ua)|0;RH(Va,64392);Ra=Gw(Pa,Va)|0;c[Wa>>2]=Na;Pa=Zw(Fa,Wa)|0;RH(Xa,64248);if((nx(o,Gw(Pa,Xa)|0)|0)==0){c[_a>>2]=Na;Pa=Zw(Fa,_a)|0;RH($a,64392);Uc=1;Vc=0;Wc=Gw(Pa,$a)|0}else{c[Ya>>2]=Na;Pa=Zw(Fa,Ya)|0;RH(Za,64248);Uc=0;Vc=1;Wc=Gw(o,Gw(Pa,Za)|0)|0}YH(Ra,Wc)|0;if(Uc){XH($a)}if(Vc){XH(Za)}XH(Xa);XH(Va);Na=Na+1|0;}while((Na|0)<(c[W>>2]|0))}W=b+132|0;if((c[W>>2]|0)>0){Na=a+96|0;Va=0;do{c[ab>>2]=Va;Xa=Zw(Na,ab)|0;RH(bb,64392);Za=Gw(Xa,bb)|0;c[cb>>2]=Va;Xa=Zw(Na,cb)|0;RH(db,64248);if((nx(o,Gw(Xa,db)|0)|0)==0){c[gb>>2]=Va;Xa=Zw(Na,gb)|0;RH(hb,64392);Xc=1;Yc=0;Zc=Gw(Xa,hb)|0}else{c[eb>>2]=Va;Xa=Zw(Na,eb)|0;RH(fb,64248);Xc=0;Yc=1;Zc=Gw(o,Gw(Xa,fb)|0)|0}YH(Za,Zc)|0;if(Xc){XH(hb)}if(Yc){XH(fb)}XH(db);XH(bb);Va=Va+1|0;}while((Va|0)<(c[W>>2]|0))}W=b+136|0;if((c[W>>2]|0)>0){Va=a+132|0;bb=0;do{c[ib>>2]=bb;db=Zw(Va,ib)|0;RH(jb,64392);fb=Gw(db,jb)|0;c[kb>>2]=bb;db=Zw(Va,kb)|0;RH(lb,64248);if((nx(o,Gw(db,lb)|0)|0)==0){c[ob>>2]=bb;db=Zw(Va,ob)|0;RH(pb,64392);_c=1;$c=0;ad=Gw(db,pb)|0}else{c[mb>>2]=bb;db=Zw(Va,mb)|0;RH(nb,64248);_c=0;$c=1;ad=Gw(o,Gw(db,nb)|0)|0}YH(fb,ad)|0;if(_c){XH(pb)}if($c){XH(nb)}XH(lb);XH(jb);bb=bb+1|0;}while((bb|0)<(c[W>>2]|0))}W=b+140|0;if((c[W>>2]|0)>0){bb=a+168|0;jb=0;do{c[qb>>2]=jb;lb=Zw(bb,qb)|0;RH(rb,64392);nb=Gw(lb,rb)|0;c[sb>>2]=jb;lb=Zw(bb,sb)|0;RH(tb,64248);if((nx(o,Gw(lb,tb)|0)|0)==0){c[wb>>2]=jb;lb=Zw(bb,wb)|0;RH(xb,64392);bd=1;cd=0;dd=Gw(lb,xb)|0}else{c[ub>>2]=jb;lb=Zw(bb,ub)|0;RH(vb,64248);bd=0;cd=1;dd=Gw(o,Gw(lb,vb)|0)|0}YH(nb,dd)|0;if(bd){XH(xb)}if(cd){XH(vb)}XH(tb);XH(rb);jb=jb+1|0;}while((jb|0)<(c[W>>2]|0))}W=b+208|0;if((c[W>>2]|0)>0){jb=a+72|0;rb=0;do{c[yb>>2]=rb;tb=Zw(jb,yb)|0;RH(zb,64392);vb=Gw(tb,zb)|0;c[Ab>>2]=rb;tb=Zw(jb,Ab)|0;RH(Bb,64248);if((nx(o,Gw(tb,Bb)|0)|0)==0){c[Eb>>2]=rb;tb=Zw(jb,Eb)|0;RH(Fb,64392);ed=1;fd=0;gd=Gw(tb,Fb)|0}else{c[Cb>>2]=rb;tb=Zw(jb,Cb)|0;RH(Db,64248);ed=0;fd=1;gd=Gw(o,Gw(tb,Db)|0)|0}YH(vb,gd)|0;if(ed){XH(Fb)}if(fd){XH(Db)}XH(Bb);XH(zb);rb=rb+1|0;}while((rb|0)<(c[W>>2]|0))}W=b+212|0;if((c[W>>2]|0)>0){rb=a+108|0;zb=0;do{c[Gb>>2]=zb;Bb=Zw(rb,Gb)|0;RH(Hb,64392);Db=Gw(Bb,Hb)|0;c[Ib>>2]=zb;Bb=Zw(rb,Ib)|0;RH(Jb,64248);if((nx(o,Gw(Bb,Jb)|0)|0)==0){c[Mb>>2]=zb;Bb=Zw(rb,Mb)|0;RH(Nb,64392);hd=0;id=1;jd=Gw(Bb,Nb)|0}else{c[Kb>>2]=zb;Bb=Zw(rb,Kb)|0;RH(Lb,64248);hd=1;id=0;jd=Gw(o,Gw(Bb,Lb)|0)|0}YH(Db,jd)|0;if(id){XH(Nb)}if(hd){XH(Lb)}XH(Jb);XH(Hb);zb=zb+1|0;}while((zb|0)<(c[W>>2]|0))}W=b+216|0;if((c[W>>2]|0)>0){zb=a+144|0;Hb=0;do{c[Ob>>2]=Hb;Jb=Zw(zb,Ob)|0;RH(Pb,64392);Lb=Gw(Jb,Pb)|0;c[Qb>>2]=Hb;Jb=Zw(zb,Qb)|0;RH(Rb,64248);if((nx(o,Gw(Jb,Rb)|0)|0)==0){c[Ub>>2]=Hb;Jb=Zw(zb,Ub)|0;RH(Wb,64392);kd=1;ld=0;md=Gw(Jb,Wb)|0}else{c[Sb>>2]=Hb;Jb=Zw(zb,Sb)|0;RH(Tb,64248);kd=0;ld=1;md=Gw(o,Gw(Jb,Tb)|0)|0}YH(Lb,md)|0;if(kd){XH(Wb)}if(ld){XH(Tb)}XH(Rb);XH(Pb);Hb=Hb+1|0;}while((Hb|0)<(c[W>>2]|0))}W=b+220|0;if((c[W>>2]|0)>0){b=a+180|0;a=0;do{c[Xb>>2]=a;Hb=Zw(b,Xb)|0;RH(Yb,64392);Pb=Gw(Hb,Yb)|0;c[Zb>>2]=a;Hb=Zw(b,Zb)|0;RH(_b,64248);if((nx(o,Gw(Hb,_b)|0)|0)==0){c[bc>>2]=a;Hb=Zw(b,bc)|0;RH(cc,64392);nd=1;od=0;pd=Gw(Hb,cc)|0}else{c[$b>>2]=a;Hb=Zw(b,$b)|0;RH(ac,64248);nd=0;od=1;pd=Gw(o,Gw(Hb,ac)|0)|0}YH(Pb,pd)|0;if(nd){XH(cc)}if(od){XH(ac)}XH(_b);XH(Yb);a=a+1|0;}while((a|0)<(c[W>>2]|0))}Rn(23,0,67352,h);XH(v);XH(u);ox(o);i=f;return}function Zw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=Ez(a,f,b)|0;l=c[k>>2]|0;qt(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}Gz(j,a,b);Hz(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];Fz(g,e);Iz(j);j=c[f>>2]|0;Jz(a,j,k,Kz(g)|0);k=Lz(g)|0;Iz(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function _w(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=gy(a,f,b)|0;l=c[k>>2]|0;qt(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}iy(j,a,b);jy(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];hy(g,e);ky(j);j=c[f>>2]|0;ly(a,j,k,my(g)|0);k=ny(g)|0;ky(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function $w(a,b){a=a|0;b=b|0;var c=0;c=i;YH(b,a)|0;i=c;return}function ax(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;Zx(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];Rx(a,f);i=e;return}function bx(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Px(a,b)|0;i=c;return d|0}function cx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;Sx(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];Rx(a,e);i=d;return}function dx(a){a=a|0;var b=0,c=0;b=i;c=Mx(a)|0;i=b;return c|0}function ex(a){a=a|0;var b=0;b=i;jC(a);i=b;return}function fx(a){a=a|0;var b=0;b=i;YB(a);i=b;return}function gx(a,b){a=a|0;b=b|0;b=i;FA(a,0);i=b;return}function hx(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+108|0;UI(d);e=a;c[e>>2]=67420;f=d;c[f>>2]=67440;d=a+8|0;MJ(a,67452|0,d);c[e>>2]=67420;c[f>>2]=67440;Zv(d);i=b;return}function ix(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(yt(a+8|0,b,d|8)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){LI(d,4);i=e;return}else{JI(d,0);i=e;return}}function jx(a){a=a|0;var b=0,c=0;b=i;c=Hx(a+8|0)|0;i=b;return c|0}function kx(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Gx(a,b,SI(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;i=d;return e|0}function lx(a){a=a|0;var b=0;b=i;if((At(a+8|0)|0)!=0){i=b;return}LI(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function mx(a){a=a|0;var b=0;b=i;Lx(a,67448);PI(a+108|0);i=b;return}function nx(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=px(a,b)|0;i=c;return d|0}function ox(a){a=a|0;var b=0;b=i;NB(a);i=b;return}function px(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d;f=rx(a)|0;qt(e);if((f|0)==0){g=0;i=d;return g|0}h=sx(a)|0;a=f;while(1){f=a+16|0;if(tx(h,b,f)|0){j=a}else{if(!(ux(h,f,b)|0)){g=1;k=8;break}j=a+4|0}f=c[j>>2]|0;qt(e);if((f|0)==0){g=0;k=8;break}else{a=f}}if((k|0)==8){i=d;return g|0}return 0}function qx(a){a=a|0;var b=0,c=0;b=i;c=bt(Ax(a+4|0)|0)|0;i=b;return c|0}function rx(a){a=a|0;var b=0,d=0;b=i;d=c[(qx(a)|0)>>2]|0;i=b;return d|0}function sx(a){a=a|0;var b=0,c=0;b=i;c=yx(a+8|0)|0;i=b;return c|0}function tx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=vx(0,b,c)|0;i=a;return d|0}function ux(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=vx(0,b,c)|0;i=a;return d|0}function vx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=wx(b,c)|0;i=a;return d|0}function wx(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(uI(a,b)|0)<0;i=c;return d|0}function xx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=zS(a,b,c)|0;i=d;return e|0}function yx(a){a=a|0;var b=0,c=0;b=i;c=zx(a)|0;i=b;return c|0}function zx(a){a=a|0;i=i;return a|0}function Ax(a){a=a|0;var b=0,c=0;b=i;c=Bx(a)|0;i=b;return c|0}function Bx(a){a=a|0;i=i;return a|0}function Cx(a,b){a=a|0;b=b|0;var c=0;a=i;c=Ex(0,b,0)|0;i=a;return c|0}function Dx(b,c){b=b|0;c=c|0;a[b]=a[c]|0;i=i;return}function Ex(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=gS(b)|0;i=c;return a|0}function Fx(a){a=a|0;var b=0,c=0;b=i;c=ES(a|0)|0;i=b;return c|0}function Gx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;RJ(f,a,1);if(!(UJ(f)|0)){i=e;return a|0}lI(b);f=0;while(1){g=_I(QI(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0)|0)|0;if(ku(g,-1)|0){h=2;j=f;break}k=f+1|0;l=lu(g)|0;if(pu(l,d)|0){h=0;j=k;break}nI(b,l);if((VH(b)|0)==-17){h=4;j=k;break}else{f=k}}LI(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,(j|0)==0?h|4:h);i=e;return a|0}function Hx(a){a=a|0;i=i;return(c[a+64>>2]|0)!=0|0}function Ix(a){a=a|0;var b=0;b=i;mx(a);iS(a);i=b;return}function Jx(a){a=a|0;var b=0;b=i;mx(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Kx(a){a=a|0;var b=0;b=i;Ix(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Lx(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];_t(a+8|0);i=d;return}function Mx(a){a=a|0;var b=0,d=0;b=i;d=Nx((c[a>>2]|0)+16|0)|0;i=b;return d|0}function Nx(a){a=a|0;var b=0,c=0;b=i;c=Ox(a)|0;i=b;return c|0}function Ox(a){a=a|0;i=i;return a|0}function Px(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(Qx(a,b)|0)^1;i=c;return d|0}function Qx(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function Rx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Yx(a,e);i=d;return}function Sx(a,b){a=a|0;b=b|0;var c=0;c=i;Tx(a,Ux(b)|0);i=c;return}function Tx(a,b){a=a|0;b=b|0;var c=0;c=i;Xx(a,b);i=c;return}function Ux(a){a=a|0;var b=0,c=0;b=i;c=bt(Vx(a+4|0)|0)|0;i=b;return c|0}function Vx(a){a=a|0;var b=0,c=0;b=i;c=Wx(a)|0;i=b;return c|0}function Wx(a){a=a|0;i=i;return a|0}function Xx(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Yx(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function Zx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=$x(b)|0;_x(f,b,d,h,Ux(b)|0);Sx(g,b);do{if(Px(f,g)|0){h=ay(b)|0;if(by(h,d,cy(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);Sx(a,b);i=e;return}function _x(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;qt(h);a:do{if((e|0)==0){j=f}else{k=ay(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(fy(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;qt(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;qt(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);Tx(a,j);i=g;return}function $x(a){a=a|0;var b=0,d=0;b=i;d=c[(Ux(a)|0)>>2]|0;i=b;return d|0}function ay(a){a=a|0;var b=0,c=0;b=i;c=dy(a+8|0)|0;i=b;return c|0}function by(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=vx(0,b,c)|0;i=a;return d|0}function cy(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function dy(a){a=a|0;var b=0,c=0;b=i;c=ey(a)|0;i=b;return c|0}function ey(a){a=a|0;i=i;return a|0}function fy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=vx(0,b,c)|0;i=a;return d|0}function gy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=$x(h)|0;qt(e);if((a|0)==0){j=Ux(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(vx(0,d,a)|0){m=l;j=c[m>>2]|0;qt(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(vx(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;qt(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function hy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];cz(a,e);i=d;return}function iy(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=Jy(d)|0;d=Ly(n,1)|0;My(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];Ky(j,d,h);Ny(0,Cy((Oy(j)|0)+16|0)|0,e);e=Py(j)|0;a[e+4|0]=1;Qy(0,Ay((Oy(j)|0)+28|0)|0);a[e+5|0]=1;Ry(m,j);jy(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];hy(b,g);ky(m);ky(j);i=f;return}function jy(a,b){a=a|0;b=b|0;var c=0;c=i;Hy(a,b);i=c;return}function ky(a){a=a|0;var b=0;b=i;wy(a);i=b;return}function ly(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;qt(f);c[e>>2]=0;qt(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=sy(a)|0;b=c[c[e>>2]>>2]|0;qt(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(Ux(a)|0)>>2]|0;av(e,c[d>>2]|0);d=ty(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function my(a){a=a|0;var b=0,d=0;b=i;d=c[(qy(a)|0)>>2]|0;i=b;return d|0}function ny(a){a=a|0;var b=0,d=0;b=i;d=oy(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function oy(a){a=a|0;var b=0,c=0;b=i;c=py(a)|0;i=b;return c|0}function py(a){a=a|0;i=i;return a|0}function qy(a){a=a|0;var b=0,c=0;b=i;c=ry(a)|0;i=b;return c|0}function ry(a){a=a|0;i=i;return a|0}function sy(a){a=a|0;i=i;return a|0}function ty(a){a=a|0;var b=0,c=0;b=i;c=uy(a+8|0)|0;i=b;return c|0}function uy(a){a=a|0;var b=0,c=0;b=i;c=vy(a)|0;i=b;return c|0}function vy(a){a=a|0;i=i;return a|0}function wy(a){a=a|0;var b=0;b=i;xy(a,0);i=b;return}function xy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=oy(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}zy(yy(e)|0,f);i=d;return}function yy(a){a=a|0;var b=0,c=0;b=i;c=Gy(a)|0;i=b;return c|0}function zy(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;By(f,Cy(d+16|0)|0)}if((d|0)==0){i=e;return}Dy(c[b>>2]|0,d,1);i=e;return}function Ay(a){a=a|0;i=i;return a|0}function By(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;Fy(d,0,c);i=b;return}function Cy(a){a=a|0;i=i;return a|0}function Dy(a,b,c){a=a|0;b=b|0;c=c|0;c=i;Ey(0,b,0);i=c;return}function Ey(a,b,c){a=a|0;b=b|0;c=c|0;c=i;iS(b);i=c;return}function Fy(a,b,c){a=a|0;b=b|0;c=c|0;b=i;XH(c);i=b;return}function Gy(a){a=a|0;i=i;return a+4|0}function Hy(a,b){a=a|0;b=b|0;var c=0;c=i;Iy(a,b);i=c;return}function Iy(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Jy(a){a=a|0;var b=0,c=0;b=i;c=az(a+4|0)|0;i=b;return c|0}function Ky(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];Uy(a,b,f);i=e;return}function Ly(a,b){a=a|0;b=b|0;var c=0;a=i;c=Ty(0,b,0)|0;i=a;return c|0}function My(a,b){a=a|0;b=b|0;var c=0;c=i;Sy(a,b);i=c;return}function Ny(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}NH(b,c);i=a;return}function Oy(a){a=a|0;var b=0,d=0;b=i;d=c[(qy(a)|0)>>2]|0;i=b;return d|0}function Py(a){a=a|0;var b=0,c=0;b=i;c=yy(a)|0;i=b;return c|0}function Qy(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function Ry(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;Hy(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];hy(h,f);jy(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];hy(a,e);ky(h);i=d;return}function Sy(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function Ty(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=gS(b<<5)|0;i=c;return a|0}function Uy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(Wy(g)|0)>>2]|0;g=Xy(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];Vy(b,a,f);i=e;return}function Vy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];Yy(a,b,f);i=e;return}function Wy(a){a=a|0;i=i;return a|0}function Xy(a){a=a|0;i=i;return a|0}function Yy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(_y(g)|0)>>2]|0;g=$y(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];Zy(b,a,f);i=e;return}function Zy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(_y(f)|0)>>2];f=$y(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function _y(a){a=a|0;i=i;return a|0}function $y(a){a=a|0;i=i;return a|0}function az(a){a=a|0;var b=0,c=0;b=i;c=bz(a)|0;i=b;return c|0}function bz(a){a=a|0;i=i;return a|0}function cz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=ny(dz(b)|0)|0;h=$y(Py(dz(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];Vy(g,a,e);i=d;return}function dz(a){a=a|0;i=i;return c[a>>2]|0}function ez(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function fz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];mz(a,e);i=d;return}function gz(a,b){a=a|0;b=b|0;var c=0;c=i;hz(a,iz(b)|0);i=c;return}function hz(a,b){a=a|0;b=b|0;var c=0;c=i;lz(a,b);i=c;return}function iz(a){a=a|0;var b=0,c=0;b=i;c=bt(jz(a+4|0)|0)|0;i=b;return c|0}function jz(a){a=a|0;var b=0,c=0;b=i;c=kz(a)|0;i=b;return c|0}function kz(a){a=a|0;i=i;return a|0}function lz(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function mz(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function nz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=pz(b)|0;oz(f,b,d,h,iz(b)|0);gz(g,b);do{if(qz(f,g)|0){h=rz(b)|0;if(tx(h,d,sz(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);gz(a,b);i=e;return}function oz(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;qt(h);a:do{if((e|0)==0){j=f}else{k=rz(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(ux(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;qt(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;qt(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);hz(a,j);i=g;return}function pz(a){a=a|0;var b=0,d=0;b=i;d=c[(iz(a)|0)>>2]|0;i=b;return d|0}function qz(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(ez(a,b)|0)^1;i=c;return d|0}function rz(a){a=a|0;var b=0,c=0;b=i;c=tz(a+8|0)|0;i=b;return c|0}function sz(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function tz(a){a=a|0;var b=0,c=0;b=i;c=uz(a)|0;i=b;return c|0}function uz(a){a=a|0;i=i;return a|0}function vz(a,b){a=a|0;b=b|0;b=i;i=i+8|0;wz(a,b);i=b;return}function wz(a,b){a=a|0;b=b|0;b=i;xz(a,0);i=b;return}function xz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;yz(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;zz(f,0,e);e=Ux(b)|0;c[(sy(b)|0)>>2]=e;i=d;return}function yz(a){a=a|0;var b=0;b=i;Cz(a);i=b;return}function zz(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;Az(b,c,f);i=e;return}function Az(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(Uv(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;Bz(d,b,f);i=e;return}function Bz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(Uv(e)|0)>>2];i=d;return}function Cz(a){a=a|0;var b=0;b=i;Dz(a);i=b;return}function Dz(a){a=a|0;var b=0;b=i;Xv(a);i=b;return}function Ez(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=EA(h)|0;qt(e);if((a|0)==0){j=Rz(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(nt(0,d,a)|0){m=l;j=c[m>>2]|0;qt(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(nt(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;qt(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function Fz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];CA(a,e);i=d;return}function Gz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=hA(d)|0;d=jA(n,1)|0;kA(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];iA(j,d,h);lA(0,mv((mA(j)|0)+16|0)|0,e);e=nA(j)|0;a[e+4|0]=1;oA(0,aA((mA(j)|0)+20|0)|0);a[e+5|0]=1;pA(m,j);Hz(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];Fz(b,g);Iz(m);Iz(j);i=f;return}function Hz(a,b){a=a|0;b=b|0;var c=0;c=i;fA(a,b);i=c;return}function Iz(a){a=a|0;var b=0;b=i;Xz(a);i=b;return}function Jz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;qt(f);c[e>>2]=0;qt(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=Qz(a)|0;b=c[c[e>>2]>>2]|0;qt(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(Rz(a)|0)>>2]|0;av(e,c[d>>2]|0);d=Sz(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}



function wR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0;g=i;i=i+16|0;h=g;j=g+8|0;k=c[a+4>>2]|0;a=k;l=k+40|0;m=c[l>>2]|0;do{if((m|0)<1|(d|0)==0){n=0}else{o=aS(m<<2)|0;if((o|0)==0){p=12}else{n=o;break}i=g;return p|0}}while(0);m=n;a:do{if((c[k+60>>2]|0)==0){c[h>>2]=0;o=f&1;q=f&2;r=k+56|0;s=c[r>>2]&4;if((n|0)==0){t=0}else{t=c[l>>2]|0}u=t<<2;v=c[k+52>>2]|0;w=v<<3;x=w+8|0;y=u+12+w+(x+(fa(u,v)|0)<<1)|0;z=aS(y)|0;if((z|0)==0){A=12;break}IS(z|0,0,y|0)|0;y=z;B=z+u&3;C=((B|0)==0?0:4-B|0)+u|0;B=z+C|0;D=B;E=C+x|0;C=z+E&3;F=((C|0)==0?0:4-C|0)+E|0;E=z+F|0;C=E;G=F+x|0;x=z+G&3;F=((x|0)==0?0:4-x|0)+G|0;G=z+F|0;x=F+w|0;w=z+x&3;if((v|0)>0){F=t<<3;H=0;I=z+(((w|0)==0?0:4-w|0)+x)|0;while(1){c[E+(H<<3)+4>>2]=I;c[B+(H<<3)+4>>2]=I+u;x=H+1|0;if((x|0)<(v|0)){I=I+F|0;H=x}else{J=0;break}}do{c[G+(J<<3)>>2]=-1;J=J+1|0;}while((J|0)<(v|0))}v=eR(h,b,4)|0;if((v|0)<1){if((v|0)<0){A=1;break}K=v+1|0}else{K=v}v=k+8|0;H=(s|0)==0;F=(o|0)==0;I=(t|0)>0;B=k+12|0;E=k+44|0;x=k+32|0;w=k+36|0;L=(t|0)==0;M=I^1;N=-1;O=0;P=0;Q=K;R=0;S=C;T=D;U=D;V=b+K|0;W=y;while(1){if((N|0)<0){X=c[v>>2]|0;Y=X+8|0;b:do{if((c[Y>>2]|0)==0){Z=N;_=O;$=U}else{aa=(P|0)==0;ba=(R|0)==95;ca=(P|0)<1&F;da=((R|0)!=10|H)^1;ea=Y;ga=N;ha=O;ia=U;ja=X;while(1){ka=ea;la=ja;c:while(1){ma=la+12|0;if((c[G+(c[ma>>2]<<3)>>2]|0)>=(P|0)){na=ga;oa=ha;pa=ia;break}qa=la+20|0;ra=c[qa>>2]|0;if((ra|0)==0){sa=260;break}d:do{if((ra&1|0)==0|ca|da){if((ra&2|0)!=0){ta=c[h>>2]|0;if((ta|q|0)!=0&((ta|0)!=10|H)){break}}do{if((ra&16|0)!=0){if(ba){break d}if((LQ(R)|0)!=0){break d}ta=c[h>>2]|0;if((ta|0)==95){break}if((LQ(ta)|0)==0){break d}}}while(0);ta=c[qa>>2]|0;if((ta&32|0)==0){ua=ta}else{if(!ba){if((LQ(R)|0)==0){break}}ta=c[h>>2]|0;if((ta|0)==95){break}if((LQ(ta)|0)!=0){break}ua=c[qa>>2]|0}do{if((ua&64|0)==0|aa){va=ua}else{ta=c[h>>2]|0;if((ta|0)==0){va=ua;break}if(ba){wa=ta;xa=1}else{ta=(LQ(R)|0)!=0|0;wa=c[h>>2]|0;xa=ta}if((wa|0)==95){ya=1}else{ya=(LQ(wa)|0)!=0|0}if((xa|0)==(ya|0)){break d}va=c[qa>>2]|0}}while(0);if((va&128|0)==0){sa=260;break c}if(aa){break}ta=c[h>>2]|0;if((ta|0)==0){break}if(ba){za=ta;Aa=1}else{ta=(LQ(R)|0)!=0|0;za=c[h>>2]|0;Aa=ta}if((za|0)==95){Ba=1}else{Ba=(LQ(za)|0)!=0|0}if((Aa|0)==(Ba|0)){sa=260;break c}}}while(0);qa=la+40|0;if((c[qa>>2]|0)==0){Z=ga;_=ha;$=ia;break b}else{ka=qa;la=la+32|0}}if((sa|0)==260){sa=0;qa=ia;c[qa>>2]=c[ka>>2];if(I){IS(c[ia+4>>2]|0,-1,u|0)|0}ra=c[la+16>>2]|0;do{if((ra|0)!=0){ta=c[ra>>2]|0;if(!((ta|0)>-1)){break}Ca=ia+4|0;Da=ta;ta=ra;do{if((Da|0)<(t|0)){c[(c[Ca>>2]|0)+(Da<<2)>>2]=P}ta=ta+4|0;Da=c[ta>>2]|0;}while((Da|0)>-1)}}while(0);ra=(c[qa>>2]|0)!=(c[B>>2]|0);if(ra|M){Ea=ia+4|0;Fa=ra?ga:P;Ga=ra?ha:1}else{ra=ia+4|0;ka=c[ra>>2]|0;Da=0;while(1){c[n+(Da<<2)>>2]=c[ka+(Da<<2)>>2];ta=Da+1|0;if((ta|0)<(t|0)){Da=ta}else{Ea=ra;Fa=P;Ga=1;break}}}c[G+(c[ma>>2]<<3)>>2]=P;c[G+(c[ma>>2]<<3)+4>>2]=Ea;na=Fa;oa=Ga;pa=ia+8|0}ra=la+40|0;if((c[ra>>2]|0)==0){Z=na;_=oa;$=pa;break}else{ea=ra;ga=na;ha=oa;ia=pa;ja=la+32|0}}}}while(0);c[$>>2]=0;Ha=Z;Ia=_}else{if(L|(U|0)==(T|0)){Ja=N;break}else{Ha=N;Ia=O}}X=c[h>>2]|0;if((X|0)==0){Ja=Ha;break}Y=P+Q|0;ja=eR(h,V,4)|0;if((ja|0)<1){if((ja|0)<0){A=1;break a}Ka=ja+1|0}else{Ka=ja}ja=V+Ka|0;if((c[E>>2]|0)==0|(Ia|0)==0){La=Ia;Ma=T;Na=S}else{ia=T;ha=c[ia>>2]|0;if((ha|0)==0){Oa=S}else{ga=ha;ha=ia;ia=S;while(1){ea=c[w>>2]|0;ba=c[ea>>2]|0;aa=ha+4|0;e:do{if((ba|0)>-1){da=ba;ca=0;while(1){ra=c[ea+((ca|1)<<2)>>2]|0;if((da|0)>=(t|0)){Pa=ia;break e}Da=c[aa>>2]|0;if((c[Da+(ra<<2)>>2]|0)==(c[n+(ra<<2)>>2]|0)){if((c[Da+(da<<2)>>2]|0)<(c[n+(da<<2)>>2]|0)){Pa=ia;break e}}Da=ca+2|0;ra=c[ea+(Da<<2)>>2]|0;if((ra|0)>-1){da=ra;ca=Da}else{sa=287;break}}}else{sa=287}}while(0);if((sa|0)==287){sa=0;c[ia>>2]=ga;ea=ia+4|0;ba=c[ea>>2]|0;c[ea>>2]=c[aa>>2];c[aa>>2]=ba;Pa=ia+8|0}ba=ha+8|0;ea=c[ba>>2]|0;if((ea|0)==0){Oa=Pa;break}else{ga=ea;ha=ba;ia=Pa}}}c[Oa>>2]=0;La=0;Ma=S;Na=T}ia=c[Ma>>2]|0;if((ia|0)==0){Qa=Ha;Ra=La;Sa=Na;Ta=W}else{ha=(Y|0)==0;ga=(X|0)==95;ba=(Y|0)<1&F;ea=((X|0)!=10|H)^1;ca=ia;ia=Ha;da=La;la=Ma;Da=Na;ra=W;while(1){ka=ca+8|0;if((c[ka>>2]|0)==0){Ua=ia;Va=da;Wa=Da;Xa=ra}else{qa=la+4|0;ta=ka;ka=ia;Ca=da;Ya=Da;Za=ra;_a=ca;while(1){f:do{if((c[_a>>2]|0)>>>0>X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za}else{if((c[_a+4>>2]|0)>>>0<X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za;break}db=_a+20|0;eb=c[db>>2]|0;g:do{if((eb|0)!=0){if(!((eb&1|0)==0|ba|ea)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((eb&2|0)!=0){fb=c[h>>2]|0;if((fb|q|0)!=0&((fb|0)!=10|H)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}do{if((eb&16|0)!=0){if(ga){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((LQ(X)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==95){break}if((LQ(fb)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);fb=c[db>>2]|0;if((fb&32|0)==0){gb=fb}else{if(!ga){if((LQ(X)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}fb=c[h>>2]|0;if((fb|0)==95){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((LQ(fb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}gb=c[db>>2]|0}do{if((gb&64|0)==0|ha){hb=gb}else{fb=c[h>>2]|0;if((fb|0)==0){hb=gb;break}if(ga){ib=fb;jb=1}else{fb=(LQ(X)|0)!=0|0;ib=c[h>>2]|0;jb=fb}if((ib|0)==95){kb=1}else{kb=(LQ(ib)|0)!=0|0}if((jb|0)==(kb|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}hb=c[db>>2]|0}}while(0);if((hb&128|0)==0){lb=hb}else{if(ha){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if(ga){mb=fb;nb=1}else{fb=(LQ(X)|0)!=0|0;mb=c[h>>2]|0;nb=fb}if((mb|0)==95){ob=1}else{ob=(LQ(mb)|0)!=0|0}if((nb|0)!=(ob|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}lb=c[db>>2]|0}do{if((lb&4|0)==0){pb=lb}else{if((c[r>>2]&2|0)!=0){pb=lb;break}if((PQ(X,c[_a+24>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}pb=c[db>>2]|0}}while(0);do{if((pb&4|0)!=0){if((c[r>>2]&2|0)==0){break}fb=$Q(X)|0;qb=_a+24|0;if((PQ(fb,c[qb>>2]|0)|0)!=0){break}fb=ZQ(X)|0;if((PQ(fb,c[qb>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);if((c[db>>2]&8|0)==0){break}qb=c[_a+28>>2]|0;fb=c[qb>>2]|0;if((fb|0)==0){break}if((c[r>>2]&2|0)==0){rb=qb;sb=fb;while(1){if((PQ(X,sb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}rb=rb+4|0;sb=c[rb>>2]|0;if((sb|0)==0){break g}}}else{tb=qb}do{sb=ZQ(X)|0;if((PQ(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}sb=$Q(X)|0;if((PQ(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}tb=tb+4|0;}while((c[tb>>2]|0)!=0)}}while(0);if(I){db=c[qa>>2]|0;eb=0;do{c[Za+(eb<<2)>>2]=c[db+(eb<<2)>>2];eb=eb+1|0;}while((eb|0)<(t|0))}eb=c[_a+16>>2]|0;do{if((eb|0)!=0){db=c[eb>>2]|0;if((db|0)>-1){ub=db;vb=eb}else{break}do{if((ub|0)<(t|0)){c[Za+(ub<<2)>>2]=Y}vb=vb+4|0;ub=c[vb>>2]|0;}while((ub|0)>-1)}}while(0);eb=_a+12|0;db=c[eb>>2]|0;qb=G+(db<<3)|0;if((c[qb>>2]|0)<(Y|0)){sb=Ya;c[sb>>2]=c[ta>>2];rb=Ya+4|0;fb=c[rb>>2]|0;c[rb>>2]=Za;c[qb>>2]=Y;c[G+(c[eb>>2]<<3)+4>>2]=rb;do{if((c[sb>>2]|0)==(c[B>>2]|0)){if((ka|0)==-1){if(!I){wb=Y;xb=1;break}yb=c[rb>>2]|0}else{if(!I){wb=ka;xb=Ca;break}eb=c[rb>>2]|0;if((c[eb>>2]|0)>(c[n>>2]|0)){wb=ka;xb=Ca;break}else{yb=eb}}eb=0;while(1){c[n+(eb<<2)>>2]=c[yb+(eb<<2)>>2];qb=eb+1|0;if((qb|0)<(t|0)){eb=qb}else{wb=Y;xb=1;break}}}else{wb=ka;xb=Ca}}while(0);$a=wb;ab=xb;bb=Ya+8|0;cb=fb;break}else{rb=c[x>>2]|0;sb=c[G+(db<<3)+4>>2]|0;eb=c[sb>>2]|0;if(I){zb=0}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break}while(1){qb=c[Za+(zb<<2)>>2]|0;Ab=c[eb+(zb<<2)>>2]|0;if((c[rb+(zb<<2)>>2]|0)==0){if((qb|0)<(Ab|0)){break}if((qb|0)>(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}else{if((qb|0)>(Ab|0)){break}if((qb|0)<(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}Ab=zb+1|0;if((Ab|0)<(t|0)){zb=Ab}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}c[sb>>2]=Za;if((c[ta>>2]|0)==(c[B>>2]|0)){Bb=0}else{$a=ka;ab=Ca;bb=Ya;cb=eb;break}while(1){c[n+(Bb<<2)>>2]=c[Za+(Bb<<2)>>2];rb=Bb+1|0;if((rb|0)<(t|0)){Bb=rb}else{$a=Y;ab=1;bb=Ya;cb=eb;break}}}}}while(0);eb=_a+40|0;if((c[eb>>2]|0)==0){Ua=$a;Va=ab;Wa=bb;Xa=cb;break}else{ta=eb;ka=$a;Ca=ab;Ya=bb;Za=cb;_a=_a+32|0}}}_a=la+8|0;Za=c[_a>>2]|0;if((Za|0)==0){Qa=Ua;Ra=Va;Sa=Wa;Ta=Xa;break}else{ca=Za;ia=Ua;da=Va;la=_a;Da=Wa;ra=Xa}}}c[Sa>>2]=0;N=Qa;O=Ra;P=Y;Q=Ka;R=X;S=Ma;T=Na;U=Sa;V=ja;W=Ta}bS(z);Cb=Ja;Db=Ja>>>31;sa=375}else{c[j>>2]=0;W=f&1;V=f&2;U=k+56|0;T=c[U>>2]&4;S=yR(0,0)|0;if((S|0)==0){A=12;break}R=AR(S,0,0,0,32)|0;Q=R;if((R|0)==0){zR(S);A=12;break}c[R+24>>2]=0;c[R+28>>2]=0;R=c[l>>2]|0;if((R|0)==0){Eb=0;sa=9}else{P=aS(R<<2)|0;O=P;if((P|0)==0){Fb=0;Gb=0;Hb=12;Ib=0;Jb=O}else{Eb=O;sa=9}}do{if((sa|0)==9){O=Eb;P=c[k+28>>2]|0;if((P|0)==0){Kb=0}else{N=aS(P<<3)|0;P=N;if((N|0)==0){Fb=0;Gb=P;Hb=12;Ib=0;Jb=Eb;break}else{Kb=P}}P=k+52|0;N=c[P>>2]|0;if((N|0)==0){Lb=0}else{B=aS(N<<2)|0;N=B;if((B|0)==0){Fb=0;Gb=Kb;Hb=12;Ib=N;Jb=Eb;break}else{Lb=N}}N=Lb;B=(n|0)==0;I=k+8|0;G=k+12|0;x=k+32|0;r=(T|0)==0;H=(W|0)==0;q=R;F=-1;w=1;E=-1;L=Q;M=b;h:while(1){do{if((q|0)>0){if(B){IS(O|0,-1,q<<2|0)|0;break}else{u=0;do{c[Eb+(u<<2)>>2]=-1;c[n+(u<<2)>>2]=-1;u=u+1|0;}while((u|0)<(c[l>>2]|0))}}}while(0);u=c[P>>2]|0;if((u|0)>0){IS(N|0,0,u<<2|0)|0}u=c[j>>2]|0;v=w+E|0;y=eR(j,M,4)|0;if((y|0)<1){if((y|0)<0){A=1;break a}Mb=y+1|0}else{Mb=y}y=M+Mb|0;D=c[j>>2]|0;C=c[I>>2]|0;o=C+8|0;if((c[o>>2]|0)==0){Nb=F;Ob=0;Pb=Mb;Qb=L;sa=196}else{s=(v|0)==0;ra=(u|0)==95;Da=(v|0)<1&H;la=((u|0)!=10|r)^1;da=o;o=0;ia=L;ca=0;ga=C;while(1){C=ga+20|0;ha=c[C>>2]|0;i:do{if((ha|0)==0){sa=56}else{if(!((ha&1|0)==0|Da|la)){Rb=o;Sb=ia;Tb=ca;break}if((ha&2|0)!=0){ea=c[j>>2]|0;if((ea|V|0)!=0&((ea|0)!=10|r)){Rb=o;Sb=ia;Tb=ca;break}}do{if((ha&16|0)!=0){if(ra){Rb=o;Sb=ia;Tb=ca;break i}if((LQ(u)|0)!=0){Rb=o;Sb=ia;Tb=ca;break i}ea=c[j>>2]|0;if((ea|0)==95){break}if((LQ(ea)|0)==0){Rb=o;Sb=ia;Tb=ca;break i}}}while(0);ea=c[C>>2]|0;if((ea&32|0)==0){Ub=ea}else{if(!ra){if((LQ(u)|0)==0){Rb=o;Sb=ia;Tb=ca;break}}ea=c[j>>2]|0;if((ea|0)==95){Rb=o;Sb=ia;Tb=ca;break}if((LQ(ea)|0)!=0){Rb=o;Sb=ia;Tb=ca;break}Ub=c[C>>2]|0}do{if((Ub&64|0)==0|s){Vb=Ub}else{ea=c[j>>2]|0;if((ea|0)==0){Vb=Ub;break}if(ra){Wb=ea;Xb=1}else{ea=(LQ(u)|0)!=0|0;Wb=c[j>>2]|0;Xb=ea}if((Wb|0)==95){Yb=1}else{Yb=(LQ(Wb)|0)!=0|0}if((Xb|0)==(Yb|0)){Rb=o;Sb=ia;Tb=ca;break i}Vb=c[C>>2]|0}}while(0);if((Vb&128|0)==0){sa=56;break}if(s){Rb=o;Sb=ia;Tb=ca;break}ea=c[j>>2]|0;if((ea|0)==0){Rb=o;Sb=ia;Tb=ca;break}if(ra){Zb=ea;_b=1}else{ea=(LQ(u)|0)!=0|0;Zb=c[j>>2]|0;_b=ea}if((Zb|0)==95){$b=1}else{$b=(LQ(Zb)|0)!=0|0}if((_b|0)==($b|0)){sa=56}else{Rb=o;Sb=ia;Tb=ca}}}while(0);do{if((sa|0)==56){sa=0;if((ca|0)==0){Rb=c[ga+16>>2]|0;Sb=ia;Tb=c[da>>2]|0;break}C=ia+28|0;ha=c[C>>2]|0;if((ha|0)==0){ea=AR(S,0,0,0,32)|0;ba=ea;if((ea|0)==0){sa=60;break h}c[ea+24>>2]=ia;c[ea+28>>2]=0;_a=AR(S,0,0,0,c[l>>2]<<2)|0;c[ea+20>>2]=_a;if((_a|0)==0){sa=67;break h}c[C>>2]=ba;ac=ba}else{ac=ha}c[ac>>2]=v;c[ac+4>>2]=y;c[ac+8>>2]=c[da>>2];c[ac+12>>2]=c[ga+12>>2];c[ac+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ha=c[ac+20>>2]|0;ba=0;do{c[ha+(ba<<2)>>2]=c[Eb+(ba<<2)>>2];ba=ba+1|0;}while((ba|0)<(c[l>>2]|0))}ba=c[ga+16>>2]|0;if((ba|0)==0){Rb=o;Sb=ac;Tb=ca;break}ha=c[ba>>2]|0;if(!((ha|0)>-1)){Rb=o;Sb=ac;Tb=ca;break}C=c[ac+20>>2]|0;_a=ha;ha=ba;while(1){ba=ha+4|0;c[C+(_a<<2)>>2]=v;ea=c[ba>>2]|0;if((ea|0)>-1){ha=ba;_a=ea}else{Rb=o;Sb=ac;Tb=ca;break}}}}while(0);_a=ga+40|0;if((c[_a>>2]|0)==0){break}else{da=_a;o=Rb;ia=Sb;ca=Tb;ga=ga+32|0}}do{if((Rb|0)==0){bc=0}else{ga=c[Rb>>2]|0;if((ga|0)>-1){cc=ga;dc=Rb}else{bc=Rb;break}while(1){c[Eb+(cc<<2)>>2]=v;ga=dc+4|0;ca=c[ga>>2]|0;if((ca|0)>-1){dc=ga;cc=ca}else{bc=ga;break}}}}while(0);if((Tb|0)==0){Nb=F;Ob=bc;Pb=Mb;Qb=Sb;sa=196}else{ec=F;fc=bc;gc=v;hc=Mb;ic=Sb;jc=Tb;kc=y}}j:while(1){if((sa|0)==196){sa=0;ga=c[Qb+24>>2]|0;if((ga|0)==0){break}ca=c[Qb+8>>2]|0;if((c[ca+20>>2]&256|0)!=0){c[Lb+(c[Qb+12>>2]<<2)>>2]=0}ia=c[Qb>>2]|0;o=c[Qb+4>>2]|0;c[j>>2]=c[Qb+16>>2];da=c[l>>2]|0;if((da|0)<=0){ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue}u=c[Qb+20>>2]|0;ra=0;while(1){c[Eb+(ra<<2)>>2]=c[u+(ra<<2)>>2];s=ra+1|0;if((s|0)<(da|0)){ra=s}else{ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue j}}}if((jc|0)==(c[G>>2]|0)){lc=fc;mc=gc;nc=hc;oc=ic}else{o=fc;ca=gc;ga=hc;ia=ic;ra=jc;da=kc;while(1){u=ra+8|0;do{if((c[u>>2]|0)==0){sa=109}else{if((c[ra+20>>2]&256|0)==0){sa=109;break}s=c[ra+24>>2]|0;xR(s+1|0,Kb,c[U>>2]&-9,a,Eb,ca);la=c[Kb+(s<<3)>>2]|0;Da=c[Kb+(s<<3)+4>>2]|0;s=Da-la|0;if((BS(b+la|0,da+ -1|0,s)|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}_a=(Da|0)==(la|0);la=_a&1;Da=Lb+(c[ra+12>>2]<<2)|0;if(_a){if((c[Da>>2]|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}}c[Da>>2]=la;la=s+ -1|0;s=la+ca|0;Da=c[j>>2]|0;_a=eR(j,da+la|0,4)|0;if((_a|0)<1){if((_a|0)<0){A=1;break a}pc=_a+1|0}else{pc=_a}qc=s;rc=pc+la|0;sc=pc;tc=Da}}while(0);do{if((sa|0)==109){sa=0;Da=c[j>>2]|0;if((Da|0)==0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}la=eR(j,da,4)|0;if((la|0)>=1){qc=ca;rc=la;sc=la;tc=Da;break}if((la|0)<0){A=1;break a}s=la+1|0;qc=ca;rc=s;sc=s;tc=Da}}while(0);Da=da+rc|0;s=qc+ga|0;if((c[u>>2]|0)==0){Nb=ec;Ob=o;Pb=sc;Qb=ia;sa=196;continue j}la=(s|0)==0;_a=(tc|0)==95;ha=(s|0)<1&H;C=((tc|0)!=10|r)^1;ea=u;ba=0;Za=o;Ya=ia;Ca=ra;while(1){k:do{if((c[Ca>>2]|0)>>>0>tc>>>0){uc=ba;vc=Za;wc=Ya}else{if((c[Ca+4>>2]|0)>>>0<tc>>>0){uc=ba;vc=Za;wc=Ya;break}ka=Ca+20|0;ta=c[ka>>2]|0;l:do{if((ta|0)!=0){if(!((ta&1|0)==0|ha|C)){uc=ba;vc=Za;wc=Ya;break k}if((ta&2|0)!=0){qa=c[j>>2]|0;if((qa|V|0)!=0&((qa|0)!=10|r)){uc=ba;vc=Za;wc=Ya;break k}}do{if((ta&16|0)!=0){if(_a){uc=ba;vc=Za;wc=Ya;break k}if((LQ(tc)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==95){break}if((LQ(qa)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);qa=c[ka>>2]|0;if((qa&32|0)==0){xc=qa}else{if(!_a){if((LQ(tc)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}qa=c[j>>2]|0;if((qa|0)==95){uc=ba;vc=Za;wc=Ya;break k}if((LQ(qa)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}xc=c[ka>>2]|0}do{if((xc&64|0)==0|la){yc=xc}else{qa=c[j>>2]|0;if((qa|0)==0){yc=xc;break}if(_a){zc=qa;Ac=1}else{qa=(LQ(tc)|0)!=0|0;zc=c[j>>2]|0;Ac=qa}if((zc|0)==95){Bc=1}else{Bc=(LQ(zc)|0)!=0|0}if((Ac|0)==(Bc|0)){uc=ba;vc=Za;wc=Ya;break k}yc=c[ka>>2]|0}}while(0);if((yc&128|0)==0){Cc=yc}else{if(la){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==0){uc=ba;vc=Za;wc=Ya;break k}if(_a){Dc=qa;Ec=1}else{qa=(LQ(tc)|0)!=0|0;Dc=c[j>>2]|0;Ec=qa}if((Dc|0)==95){Fc=1}else{Fc=(LQ(Dc)|0)!=0|0}if((Ec|0)!=(Fc|0)){uc=ba;vc=Za;wc=Ya;break k}Cc=c[ka>>2]|0}do{if((Cc&4|0)==0){Gc=Cc}else{if((c[U>>2]&2|0)!=0){Gc=Cc;break}if((PQ(tc,c[Ca+24>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}Gc=c[ka>>2]|0}}while(0);do{if((Gc&4|0)!=0){if((c[U>>2]&2|0)==0){break}qa=$Q(tc)|0;aa=Ca+24|0;if((PQ(qa,c[aa>>2]|0)|0)!=0){break}qa=ZQ(tc)|0;if((PQ(qa,c[aa>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);if((c[ka>>2]&8|0)==0){break}aa=c[Ca+28>>2]|0;qa=c[aa>>2]|0;if((qa|0)==0){break}if((c[U>>2]&2|0)==0){eb=aa;sb=qa;while(1){if((PQ(tc,sb)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}eb=eb+4|0;sb=c[eb>>2]|0;if((sb|0)==0){break l}}}else{Hc=aa}do{sb=ZQ(tc)|0;if((PQ(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}sb=$Q(tc)|0;if((PQ(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}Hc=Hc+4|0;}while((c[Hc>>2]|0)!=0)}}while(0);if((ba|0)==0){uc=c[ea>>2]|0;vc=c[Ca+16>>2]|0;wc=Ya;break}ka=Ya+28|0;ta=c[ka>>2]|0;if((ta|0)==0){aa=AR(S,0,0,0,32)|0;sb=aa;if((aa|0)==0){sa=169;break h}c[aa+24>>2]=Ya;c[aa+28>>2]=0;eb=AR(S,0,0,0,c[l>>2]<<2)|0;c[aa+20>>2]=eb;if((eb|0)==0){sa=176;break h}c[ka>>2]=sb;Ic=sb}else{Ic=ta}c[Ic>>2]=s;c[Ic+4>>2]=Da;c[Ic+8>>2]=c[ea>>2];c[Ic+12>>2]=c[Ca+12>>2];c[Ic+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ta=c[Ic+20>>2]|0;sb=0;do{c[ta+(sb<<2)>>2]=c[Eb+(sb<<2)>>2];sb=sb+1|0;}while((sb|0)<(c[l>>2]|0))}sb=c[Ca+16>>2]|0;if((sb|0)==0){uc=ba;vc=Za;wc=Ic;break}ta=c[sb>>2]|0;if(!((ta|0)>-1)){uc=ba;vc=Za;wc=Ic;break}ka=c[Ic+20>>2]|0;eb=ta;ta=sb;while(1){c[ka+(eb<<2)>>2]=s;sb=ta+4|0;aa=c[sb>>2]|0;if((aa|0)>-1){ta=sb;eb=aa}else{uc=ba;vc=Za;wc=Ic;break}}}}while(0);eb=Ca+40|0;if((c[eb>>2]|0)==0){break}else{ea=eb;ba=uc;Za=vc;Ya=wc;Ca=Ca+32|0}}if((uc|0)==0){Nb=ec;Ob=vc;Pb=sc;Qb=wc;sa=196;continue j}do{if((vc|0)==0){Jc=0}else{Ca=c[vc>>2]|0;if((Ca|0)>-1){Kc=Ca;Lc=vc}else{Jc=vc;break}while(1){Ca=Lc+4|0;c[Eb+(Kc<<2)>>2]=s;Ya=c[Ca>>2]|0;if((Ya|0)>-1){Lc=Ca;Kc=Ya}else{Jc=Ca;break}}}}while(0);if((uc|0)==(c[G>>2]|0)){lc=Jc;mc=s;nc=sc;oc=wc;break}else{o=Jc;ca=s;ga=sc;ia=wc;ra=uc;da=Da}}}m:do{if((ec|0)<(mc|0)){sa=96}else{if((ec|0)!=(mc|0)|B){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}da=c[l>>2]|0;ra=c[x>>2]|0;if((da|0)>0){Mc=0}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}while(1){ia=c[Eb+(Mc<<2)>>2]|0;ga=c[n+(Mc<<2)>>2]|0;if((c[ra+(Mc<<2)>>2]|0)==0){if((ia|0)<(ga|0)){sa=96;break m}if((ia|0)>(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}else{if((ia|0)>(ga|0)){Nc=da;break m}if((ia|0)<(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}ga=Mc+1|0;if((ga|0)<(da|0)){Mc=ga}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}}while(0);if((sa|0)==96){sa=0;if(B){Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}Nc=c[l>>2]|0}if((Nc|0)>0){Oc=0}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}while(1){c[n+(Oc<<2)>>2]=c[Eb+(Oc<<2)>>2];da=Oc+1|0;if((da|0)<(c[l>>2]|0)){Oc=da}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}if((Nb|0)>=0){sa=205;break}if((c[j>>2]|0)==0){sa=205;break}c[j>>2]=D;q=c[l>>2]|0;F=Nb;w=Pb;E=v;L=Qb;M=y}if((sa|0)==60){zR(S);if((Eb|0)!=0){bS(O)}if((Kb|0)!=0){bS(Kb)}if((Lb|0)==0){A=12;break a}bS(N);A=12;break a}else if((sa|0)==67){zR(S);if((Eb|0)!=0){bS(O)}if((Kb|0)!=0){bS(Kb)}if((Lb|0)==0){A=12;break a}bS(N);A=12;break a}else if((sa|0)==169){zR(S);if((Eb|0)!=0){bS(O)}if((Kb|0)!=0){bS(Kb)}if((Lb|0)==0){A=12;break a}bS(N);A=12;break a}else if((sa|0)==176){zR(S);if((Eb|0)!=0){bS(O)}if((Kb|0)!=0){bS(Kb)}if((Lb|0)==0){A=12;break a}bS(N);A=12;break a}else if((sa|0)==205){Fb=Nb;Gb=Kb;Hb=Nb>>>31;Ib=Lb;Jb=Eb;break}}}while(0);zR(S);if((Jb|0)!=0){bS(Jb)}if((Gb|0)!=0){bS(Gb)}if((Ib|0)==0){Cb=Fb;Db=Hb;sa=375;break}bS(Ib);Cb=Fb;Db=Hb;sa=375}}while(0);do{if((sa|0)==375){if((Db|0)!=0){A=Db;break}xR(d,e,c[k+56>>2]|0,a,n,Cb);A=0}}while(0);if((n|0)==0){p=A;i=g;return p|0}bS(m);p=A;i=g;return p|0}function xR(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;do{if((g|0)>-1){if((d&8|0)!=0){j=0;break}k=c[e+16>>2]|0;l=e+28|0;m=c[l>>2]|0;n=(a|0)!=0;if((m|0)!=0&n){o=e+48|0;p=0;while(1){q=c[k+(p*12|0)>>2]|0;if((q|0)==(c[o>>2]|0)){c[b+(p<<3)>>2]=g;r=g}else{s=c[f+(q<<2)>>2]|0;c[b+(p<<3)>>2]=s;r=s}s=c[k+(p*12|0)+4>>2]|0;if((s|0)==(c[o>>2]|0)){c[b+(p<<3)+4>>2]=g;t=g}else{q=c[f+(s<<2)>>2]|0;c[b+(p<<3)+4>>2]=q;t=q}if((r|0)==-1|(t|0)==-1){c[b+(p<<3)+4>>2]=-1;c[b+(p<<3)>>2]=-1}q=p+1|0;s=c[l>>2]|0;if(q>>>0<s>>>0&q>>>0<a>>>0){p=q}else{u=s;break}}}else{u=m}if((u|0)!=0&n){v=u;w=0}else{j=0;break}while(1){p=b+(w<<3)+4|0;o=c[k+(w*12|0)+8>>2]|0;do{if((o|0)==0){x=v}else{s=c[o>>2]|0;if(!((s|0)>-1)){x=v;break}q=b+(w<<3)|0;y=c[q>>2]|0;z=s;s=0;while(1){if((y|0)<(c[b+(z<<3)>>2]|0)){A=21}else{if((c[p>>2]|0)>(c[b+(z<<3)+4>>2]|0)){A=21}else{B=y}}if((A|0)==21){A=0;c[p>>2]=-1;c[q>>2]=-1;B=-1}C=s+1|0;D=c[o+(C<<2)>>2]|0;if((D|0)>-1){y=B;z=D;s=C}else{break}}x=c[l>>2]|0}}while(0);o=w+1|0;if(o>>>0<x>>>0&o>>>0<a>>>0){v=x;w=o}else{j=o;break}}}else{j=0}}while(0);if(j>>>0<a>>>0){E=j}else{i=h;return}do{c[b+(E<<3)>>2]=-1;c[b+(E<<3)+4>>2]=-1;E=E+1|0;}while(E>>>0<a>>>0);i=h;return}function yR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)==0){e=cS(1,24)|0}else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;e=b}if((e|0)==0){f=0;i=d;return f|0}f=e;i=d;return f|0}function zR(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;if((d|0)==0){e=a;bS(e);i=b;return}else{f=d}while(1){bS(c[f>>2]|0);d=c[f+4>>2]|0;bS(f);if((d|0)==0){break}else{f=d}}e=a;bS(e);i=b;return}function AR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=a+16|0;if((c[h>>2]|0)!=0){j=0;i=g;return j|0}k=a+12|0;l=c[k>>2]|0;do{if(l>>>0<f>>>0){if((b|0)!=0){if((d|0)!=0){c[a+8>>2]=d;c[k>>2]=1024;m=d;n=1024;break}c[h>>2]=1;j=0;i=g;return j|0}o=f<<3;p=o>>>0>1024?o:1024;o=aS(8)|0;q=o;if((o|0)==0){c[h>>2]=1;j=0;i=g;return j|0}r=aS(p)|0;c[o>>2]=r;if((r|0)==0){bS(o);c[h>>2]=1;j=0;i=g;return j|0}c[o+4>>2]=0;r=a+4|0;s=c[r>>2]|0;if((s|0)!=0){c[s+4>>2]=q}s=a;if((c[s>>2]|0)==0){c[s>>2]=q}c[r>>2]=q;q=c[o>>2]|0;c[a+8>>2]=q;c[k>>2]=p;m=q;n=p}else{m=c[a+8>>2]|0;n=l}}while(0);l=m+f&3;h=((l|0)==0?0:4-l|0)+f|0;c[a+8>>2]=m+h;c[k>>2]=n-h;if((e|0)==0){j=m;i=g;return j|0}IS(m|0,0,h|0)|0;j=m;i=g;return j|0}function BR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==0){e=a+((CR(a)|0)<<2)|0;i=d;return e|0}else{f=a}while(1){g=c[f>>2]|0;if((g|0)==0|(g|0)==(b|0)){break}else{f=f+4|0}}e=(g|0)!=0?f:0;i=d;return e|0}function CR(a){a=a|0;var b=0,d=0;b=i;d=a;while(1){if((c[d>>2]|0)==0){break}else{d=d+4|0}}i=b;return d-a>>2|0}function DR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=b;h=a}while(1){b=f+ -1|0;c[h>>2]=c[g>>2];if((b|0)==0){break}else{h=h+4|0;g=g+4|0;f=b}}i=e;return a|0}function ER(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(f){i=e;return a|0}else{g=d}do{g=g+ -1|0;c[a+(g<<2)>>2]=c[b+(g<<2)>>2];}while((g|0)!=0);i=e;return a|0}else{if(f){i=e;return a|0}else{h=b;j=a;k=d}while(1){d=k+ -1|0;c[j>>2]=c[h>>2];if((d|0)==0){break}else{k=d;j=j+4|0;h=h+4|0}}i=e;return a|0}return 0}function FR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=a}while(1){d=f+ -1|0;c[g>>2]=b;if((d|0)==0){break}else{g=g+4|0;f=d}}i=e;return a|0}function GR(a){a=a|0;i=i;return}function HR(a){a=a|0;c[a>>2]=110344;i=i;return}function IR(a){a=a|0;var b=0;b=i;yb(a|0);iS(a);i=b;return}function JR(a){a=a|0;var b=0;b=i;yb(a|0);i=b;return}function KR(a){a=a|0;i=i;return 110360}function LR(a){a=a|0;i=i;return}function MR(a){a=a|0;i=i;return}function NR(a){a=a|0;i=i;return}function OR(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function PR(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function QR(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function RR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+56|0;f=e;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=VR(b,110472,110528,0)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}j=f+0|0;k=j+56|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;ye[c[(c[h>>2]|0)+28>>2]&31](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function SR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((c[d+8>>2]|0)!=(b|0)){i=g;return}b=d+16|0;h=c[b>>2]|0;if((h|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function TR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((b|0)!=(c[d+8>>2]|0)){h=c[b+8>>2]|0;ye[c[(c[h>>2]|0)+28>>2]&31](h,d,e,f);i=g;return}h=d+16|0;b=c[h>>2]|0;if((b|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function UR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((b|0)==(c[d+8>>2]|0)){h=d+16|0;j=c[h>>2]|0;if((j|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((j|0)!=(e|0)){j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}j=d+24|0;if((c[j>>2]|0)!=2){i=g;return}c[j>>2]=f;i=g;return}j=c[b+12>>2]|0;h=b+16+(j<<3)|0;k=c[b+20>>2]|0;l=k>>8;if((k&1|0)==0){m=l}else{m=c[(c[e>>2]|0)+l>>2]|0}l=c[b+16>>2]|0;ye[c[(c[l>>2]|0)+28>>2]&31](l,d,e+m|0,(k&2|0)!=0?f:2);if((j|0)<=1){i=g;return}j=d+54|0;k=b+24|0;while(1){b=c[k+4>>2]|0;m=b>>8;if((b&1|0)==0){n=m}else{n=c[(c[e>>2]|0)+m>>2]|0}m=c[k>>2]|0;ye[c[(c[m>>2]|0)+28>>2]&31](m,d,e+n|0,(b&2|0)!=0?f:2);if((a[j]|0)!=0){o=16;break}b=k+8|0;if(b>>>0<h>>>0){k=b}else{o=16;break}}if((o|0)==16){i=g;return}}function VR(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+56|0;j=h;k=c[d>>2]|0;l=d+(c[k+ -8>>2]|0)|0;m=c[k+ -4>>2]|0;k=m;c[j>>2]=f;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=g;g=j+16|0;e=j+20|0;d=j+24|0;n=j+28|0;o=j+32|0;p=j+40|0;q=(m|0)==(f|0);f=g;r=f+0|0;s=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));b[f+36>>1]=0;a[f+38|0]=0;if(q){c[j+48>>2]=1;he[c[(c[m>>2]|0)+20>>2]&31](k,j,l,l,1,0);t=(c[d>>2]|0)==1?l:0;i=h;return t|0}Vd[c[(c[m>>2]|0)+24>>2]&31](k,j,l,1,0);l=c[j+36>>2]|0;if((l|0)==0){if((c[p>>2]|0)!=1){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}t=(c[o>>2]|0)==1?c[e>>2]|0:0;i=h;return t|0}else if((l|0)==1){do{if((c[d>>2]|0)!=1){if((c[p>>2]|0)!=0){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}if((c[o>>2]|0)==1){break}else{t=0}i=h;return t|0}}while(0);t=c[g>>2]|0;i=h;return t|0}else{t=0;i=h;return t|0}return 0}function WR(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=c[b+12>>2]|0;m=b+16+(l<<3)|0;a:do{if((l|0)>0){n=d+52|0;o=d+53|0;p=d+54|0;q=b+8|0;r=d+24|0;s=0;t=0;u=b+16|0;b:while(1){a[n]=0;a[o]=0;v=c[u+4>>2]|0;w=v>>8;if((v&1|0)==0){x=w}else{x=c[(c[e>>2]|0)+w>>2]|0}w=c[u>>2]|0;he[c[(c[w>>2]|0)+20>>2]&31](w,d,e,e+x|0,2-(v>>>1&1)|0,g);if((a[p]|0)!=0){y=s;z=t;break}do{if((a[o]|0)==0){A=s;B=t}else{if((a[n]|0)==0){if((c[q>>2]&1|0)==0){y=s;z=1;break b}else{A=s;B=1;break}}if((c[r>>2]|0)==1){C=27;break a}if((c[q>>2]&2|0)==0){C=27;break a}else{A=1;B=1}}}while(0);v=u+8|0;if(v>>>0<m>>>0){s=A;t=B;u=v}else{y=A;z=B;break}}if(y){D=z;C=26}else{E=z;C=23}}else{E=0;C=23}}while(0);do{if((C|0)==23){c[j>>2]=e;m=d+40|0;c[m>>2]=(c[m>>2]|0)+1;if((c[d+36>>2]|0)!=1){D=E;C=26;break}if((c[d+24>>2]|0)!=2){D=E;C=26;break}a[d+54|0]=1;if(E){C=27}else{C=28}}}while(0);if((C|0)==26){if(D){C=27}else{C=28}}if((C|0)==27){c[k>>2]=3;i=h;return}else if((C|0)==28){c[k>>2]=4;i=h;return}}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}D=c[b+12>>2]|0;E=b+16+(D<<3)|0;z=c[b+20>>2]|0;y=z>>8;if((z&1|0)==0){F=y}else{F=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;Vd[c[(c[y>>2]|0)+24>>2]&31](y,d,e+F|0,(z&2|0)!=0?f:2,g);z=b+24|0;if((D|0)<=1){i=h;return}D=c[b+8>>2]|0;do{if((D&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((D&1|0)==0){F=d+54|0;y=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){C=53;break}B=c[y+4>>2]|0;A=B>>8;if((B&1|0)==0){G=A}else{G=c[(c[e>>2]|0)+A>>2]|0}A=c[y>>2]|0;Vd[c[(c[A>>2]|0)+24>>2]&31](A,d,e+G|0,(B&2|0)!=0?f:2,g);B=y+8|0;if(B>>>0<E>>>0){y=B}else{C=53;break}}if((C|0)==53){i=h;return}}y=d+24|0;F=d+54|0;k=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){if((c[y>>2]|0)==1){C=53;break}}B=c[k+4>>2]|0;A=B>>8;if((B&1|0)==0){H=A}else{H=c[(c[e>>2]|0)+A>>2]|0}A=c[k>>2]|0;Vd[c[(c[A>>2]|0)+24>>2]&31](A,d,e+H|0,(B&2|0)!=0?f:2,g);B=k+8|0;if(B>>>0<E>>>0){k=B}else{C=53;break}}if((C|0)==53){i=h;return}}}while(0);H=d+54|0;G=z;while(1){if((a[H]|0)!=0){C=53;break}z=c[G+4>>2]|0;D=z>>8;if((z&1|0)==0){I=D}else{I=c[(c[e>>2]|0)+D>>2]|0}D=c[G>>2]|0;Vd[c[(c[D>>2]|0)+24>>2]&31](D,d,e+I|0,(z&2|0)!=0?f:2,g);z=G+8|0;if(z>>>0<E>>>0){G=z}else{C=53;break}}if((C|0)==53){i=h;return}}function XR(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;Vd[c[(c[j>>2]|0)+24>>2]&31](j,d,e,f,g);i=h;return}do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=d+52|0;a[l]=0;m=d+53|0;a[m]=0;n=c[b+8>>2]|0;he[c[(c[n>>2]|0)+20>>2]&31](n,d,e,e,1,g);if((a[m]|0)==0){o=0;p=13}else{if((a[l]|0)==0){o=1;p=13}}a:do{if((p|0)==13){c[j>>2]=e;l=d+40|0;c[l>>2]=(c[l>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){p=16;break}a[d+54|0]=1;if(o){break a}}else{p=16}}while(0);if((p|0)==16){if(o){break}}c[k>>2]=4;i=h;return}}while(0);c[k>>2]=3;i=h;return}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function YR(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){i=g;return}h=d+28|0;if((c[h>>2]|0)==1){i=g;return}c[h>>2]=f;i=g;return}if((c[d>>2]|0)!=(b|0)){i=g;return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;i=g;return}}while(0);if((f|0)!=1){i=g;return}c[d+32>>2]=1;i=g;return}function ZR(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=d+52|0;l=a[k]|0;m=d+53|0;n=a[m]|0;o=c[b+12>>2]|0;p=b+16+(o<<3)|0;a[k]=0;a[m]=0;q=c[b+20>>2]|0;r=q>>8;if((q&1|0)==0){s=r}else{s=c[(c[f>>2]|0)+r>>2]|0}r=c[b+16>>2]|0;he[c[(c[r>>2]|0)+20>>2]&31](r,d,e,f+s|0,(q&2|0)!=0?g:2,h);a:do{if((o|0)>1){q=d+24|0;s=b+8|0;r=d+54|0;t=b+24|0;do{if((a[r]|0)!=0){break a}do{if((a[k]|0)==0){if((a[m]|0)==0){break}if((c[s>>2]&1|0)==0){break a}}else{if((c[q>>2]|0)==1){break a}if((c[s>>2]&2|0)==0){break a}}}while(0);a[k]=0;a[m]=0;u=c[t+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[f>>2]|0)+v>>2]|0}v=c[t>>2]|0;he[c[(c[v>>2]|0)+20>>2]&31](v,d,e,f+w|0,(u&2|0)!=0?g:2,h);t=t+8|0;}while(t>>>0<p>>>0)}}while(0);a[k]=l;a[m]=n;i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;n=c[f>>2]|0;if((n|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((n|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;n=c[e>>2]|0;if((n|0)==2){c[e>>2]=g;x=g}else{x=n}if(!((c[d+48>>2]|0)==1&(x|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function _R(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=c[b+8>>2]|0;he[c[(c[k>>2]|0)+20>>2]&31](k,d,e,f,g,h);i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;l=g}else{l=h}if(!((c[d+48>>2]|0)==1&(l|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function $R(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;if((c[d+8>>2]|0)!=(b|0)){i=h;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=h;return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=h;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;j=g}else{j=b}if(!((c[d+48>>2]|0)==1&(j|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}function aS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;b=i;do{if(a>>>0<245){if(a>>>0<11){d=16}else{d=a+11&-8}e=d>>>3;f=c[27694]|0;g=f>>>e;if((g&3|0)!=0){h=(g&1^1)+e|0;j=h<<1;k=110816+(j<<2)|0;l=110816+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do{if((k|0)==(n|0)){c[27694]=f&~(1<<h)}else{if(n>>>0<(c[110792>>2]|0)>>>0){cd()}o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else{cd()}}}while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}if(!(d>>>0>(c[110784>>2]|0)>>>0)){q=d;break}if((g|0)!=0){l=2<<e;n=g<<e&(l|0-l);l=(n&0-n)+ -1|0;n=l>>>12&16;k=l>>>n;l=k>>>5&8;o=k>>>l;k=o>>>2&4;r=o>>>k;o=r>>>1&2;s=r>>>o;r=s>>>1&1;t=(l|n|k|o|r)+(s>>>r)|0;r=t<<1;s=110816+(r<<2)|0;o=110816+(r+2<<2)|0;r=c[o>>2]|0;k=r+8|0;n=c[k>>2]|0;do{if((s|0)==(n|0)){c[27694]=f&~(1<<t)}else{if(n>>>0<(c[110792>>2]|0)>>>0){cd()}l=n+12|0;if((c[l>>2]|0)==(r|0)){c[l>>2]=s;c[o>>2]=n;break}else{cd()}}}while(0);n=t<<3;o=n-d|0;c[r+4>>2]=d|3;s=r+d|0;c[r+(d|4)>>2]=o|1;c[r+n>>2]=o;n=c[110784>>2]|0;if((n|0)!=0){f=c[110796>>2]|0;e=n>>>3;n=e<<1;g=110816+(n<<2)|0;m=c[27694]|0;j=1<<e;do{if((m&j|0)==0){c[27694]=m|j;u=110816+(n+2<<2)|0;v=g}else{e=110816+(n+2<<2)|0;h=c[e>>2]|0;if(!(h>>>0<(c[110792>>2]|0)>>>0)){u=e;v=h;break}cd()}}while(0);c[u>>2]=f;c[v+12>>2]=f;c[f+8>>2]=v;c[f+12>>2]=g}c[110784>>2]=o;c[110796>>2]=s;p=k;i=b;return p|0}n=c[110780>>2]|0;if((n|0)==0){q=d;break}j=(n&0-n)+ -1|0;n=j>>>12&16;m=j>>>n;j=m>>>5&8;r=m>>>j;m=r>>>2&4;t=r>>>m;r=t>>>1&2;h=t>>>r;t=h>>>1&1;e=c[111080+((j|n|m|r|t)+(h>>>t)<<2)>>2]|0;t=(c[e+4>>2]&-8)-d|0;h=e;r=e;while(1){e=c[h+16>>2]|0;if((e|0)==0){m=c[h+20>>2]|0;if((m|0)==0){break}else{w=m}}else{w=e}e=(c[w+4>>2]&-8)-d|0;m=e>>>0<t>>>0;t=m?e:t;h=w;r=m?w:r}h=r;k=c[110792>>2]|0;if(h>>>0<k>>>0){cd()}s=r+d|0;o=s;if(!(h>>>0<s>>>0)){cd()}s=c[r+24>>2]|0;h=c[r+12>>2]|0;do{if((h|0)==(r|0)){g=r+20|0;f=c[g>>2]|0;if((f|0)==0){m=r+16|0;e=c[m>>2]|0;if((e|0)==0){x=0;break}else{y=e;z=m}}else{y=f;z=g}while(1){g=y+20|0;f=c[g>>2]|0;if((f|0)!=0){z=g;y=f;continue}f=y+16|0;g=c[f>>2]|0;if((g|0)==0){break}else{y=g;z=f}}if(z>>>0<k>>>0){cd()}else{c[z>>2]=0;x=y;break}}else{f=c[r+8>>2]|0;if(f>>>0<k>>>0){cd()}g=f+12|0;if((c[g>>2]|0)!=(r|0)){cd()}m=h+8|0;if((c[m>>2]|0)==(r|0)){c[g>>2]=h;c[m>>2]=f;x=h;break}else{cd()}}}while(0);a:do{if((s|0)!=0){h=c[r+28>>2]|0;k=111080+(h<<2)|0;do{if((r|0)==(c[k>>2]|0)){c[k>>2]=x;if((x|0)!=0){break}c[110780>>2]=c[110780>>2]&~(1<<h);break a}else{if(s>>>0<(c[110792>>2]|0)>>>0){cd()}f=s+16|0;if((c[f>>2]|0)==(r|0)){c[f>>2]=x}else{c[s+20>>2]=x}if((x|0)==0){break a}}}while(0);if(x>>>0<(c[110792>>2]|0)>>>0){cd()}c[x+24>>2]=s;h=c[r+16>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[110792>>2]|0)>>>0){cd()}else{c[x+16>>2]=h;c[h+24>>2]=x;break}}}while(0);h=c[r+20>>2]|0;if((h|0)==0){break}if(h>>>0<(c[110792>>2]|0)>>>0){cd()}else{c[x+20>>2]=h;c[h+24>>2]=x;break}}}while(0);if(t>>>0<16){s=t+d|0;c[r+4>>2]=s|3;h=r+(s+4)|0;c[h>>2]=c[h>>2]|1}else{c[r+4>>2]=d|3;c[r+(d|4)>>2]=t|1;c[r+(t+d)>>2]=t;h=c[110784>>2]|0;if((h|0)!=0){s=c[110796>>2]|0;k=h>>>3;h=k<<1;f=110816+(h<<2)|0;m=c[27694]|0;g=1<<k;do{if((m&g|0)==0){c[27694]=m|g;A=110816+(h+2<<2)|0;B=f}else{k=110816+(h+2<<2)|0;e=c[k>>2]|0;if(!(e>>>0<(c[110792>>2]|0)>>>0)){A=k;B=e;break}cd()}}while(0);c[A>>2]=s;c[B+12>>2]=s;c[s+8>>2]=B;c[s+12>>2]=f}c[110784>>2]=t;c[110796>>2]=o}p=r+8|0;i=b;return p|0}else{if(a>>>0>4294967231){q=-1;break}h=a+11|0;g=h&-8;m=c[110780>>2]|0;if((m|0)==0){q=g;break}e=0-g|0;k=h>>>8;do{if((k|0)==0){C=0}else{if(g>>>0>16777215){C=31;break}h=(k+1048320|0)>>>16&8;n=k<<h;j=(n+520192|0)>>>16&4;l=n<<j;n=(l+245760|0)>>>16&2;D=14-(j|h|n)+(l<<n>>>15)|0;C=g>>>(D+7|0)&1|D<<1}}while(0);k=c[111080+(C<<2)>>2]|0;b:do{if((k|0)==0){E=e;F=0;G=0}else{if((C|0)==31){H=0}else{H=25-(C>>>1)|0}r=e;o=0;t=g<<H;f=k;s=0;while(1){D=c[f+4>>2]&-8;n=D-g|0;if(n>>>0<r>>>0){if((D|0)==(g|0)){E=n;F=f;G=f;break b}else{I=n;J=f}}else{I=r;J=s}n=c[f+20>>2]|0;D=c[f+16+(t>>>31<<2)>>2]|0;l=(n|0)==0|(n|0)==(D|0)?o:n;if((D|0)==0){E=I;F=l;G=J;break}else{r=I;o=l;t=t<<1;f=D;s=J}}}}while(0);if((F|0)==0&(G|0)==0){k=2<<C;e=m&(k|0-k);if((e|0)==0){q=g;break}k=(e&0-e)+ -1|0;e=k>>>12&16;s=k>>>e;k=s>>>5&8;f=s>>>k;s=f>>>2&4;t=f>>>s;f=t>>>1&2;o=t>>>f;t=o>>>1&1;K=c[111080+((k|e|s|f|t)+(o>>>t)<<2)>>2]|0}else{K=F}if((K|0)==0){L=E;M=G}else{t=E;o=K;f=G;while(1){s=(c[o+4>>2]&-8)-g|0;e=s>>>0<t>>>0;k=e?s:t;s=e?o:f;e=c[o+16>>2]|0;if((e|0)!=0){N=s;O=k;f=N;o=e;t=O;continue}e=c[o+20>>2]|0;if((e|0)==0){L=k;M=s;break}else{N=s;O=k;o=e;f=N;t=O}}}if((M|0)==0){q=g;break}if(!(L>>>0<((c[110784>>2]|0)-g|0)>>>0)){q=g;break}t=M;f=c[110792>>2]|0;if(t>>>0<f>>>0){cd()}o=M+g|0;m=o;if(!(t>>>0<o>>>0)){cd()}t=c[M+24>>2]|0;e=c[M+12>>2]|0;do{if((e|0)==(M|0)){k=M+20|0;s=c[k>>2]|0;if((s|0)==0){r=M+16|0;D=c[r>>2]|0;if((D|0)==0){P=0;break}else{Q=D;R=r}}else{Q=s;R=k}while(1){k=Q+20|0;s=c[k>>2]|0;if((s|0)!=0){R=k;Q=s;continue}s=Q+16|0;k=c[s>>2]|0;if((k|0)==0){break}else{Q=k;R=s}}if(R>>>0<f>>>0){cd()}else{c[R>>2]=0;P=Q;break}}else{s=c[M+8>>2]|0;if(s>>>0<f>>>0){cd()}k=s+12|0;if((c[k>>2]|0)!=(M|0)){cd()}r=e+8|0;if((c[r>>2]|0)==(M|0)){c[k>>2]=e;c[r>>2]=s;P=e;break}else{cd()}}}while(0);c:do{if((t|0)!=0){e=c[M+28>>2]|0;f=111080+(e<<2)|0;do{if((M|0)==(c[f>>2]|0)){c[f>>2]=P;if((P|0)!=0){break}c[110780>>2]=c[110780>>2]&~(1<<e);break c}else{if(t>>>0<(c[110792>>2]|0)>>>0){cd()}s=t+16|0;if((c[s>>2]|0)==(M|0)){c[s>>2]=P}else{c[t+20>>2]=P}if((P|0)==0){break c}}}while(0);if(P>>>0<(c[110792>>2]|0)>>>0){cd()}c[P+24>>2]=t;e=c[M+16>>2]|0;do{if((e|0)!=0){if(e>>>0<(c[110792>>2]|0)>>>0){cd()}else{c[P+16>>2]=e;c[e+24>>2]=P;break}}}while(0);e=c[M+20>>2]|0;if((e|0)==0){break}if(e>>>0<(c[110792>>2]|0)>>>0){cd()}else{c[P+20>>2]=e;c[e+24>>2]=P;break}}}while(0);d:do{if(L>>>0<16){t=L+g|0;c[M+4>>2]=t|3;e=M+(t+4)|0;c[e>>2]=c[e>>2]|1}else{c[M+4>>2]=g|3;c[M+(g|4)>>2]=L|1;c[M+(L+g)>>2]=L;e=L>>>3;if(L>>>0<256){t=e<<1;f=110816+(t<<2)|0;s=c[27694]|0;r=1<<e;do{if((s&r|0)==0){c[27694]=s|r;S=110816+(t+2<<2)|0;T=f}else{e=110816+(t+2<<2)|0;k=c[e>>2]|0;if(!(k>>>0<(c[110792>>2]|0)>>>0)){S=e;T=k;break}cd()}}while(0);c[S>>2]=m;c[T+12>>2]=m;c[M+(g+8)>>2]=T;c[M+(g+12)>>2]=f;break}t=o;r=L>>>8;do{if((r|0)==0){U=0}else{if(L>>>0>16777215){U=31;break}s=(r+1048320|0)>>>16&8;k=r<<s;e=(k+520192|0)>>>16&4;D=k<<e;k=(D+245760|0)>>>16&2;l=14-(e|s|k)+(D<<k>>>15)|0;U=L>>>(l+7|0)&1|l<<1}}while(0);r=111080+(U<<2)|0;c[M+(g+28)>>2]=U;c[M+(g+20)>>2]=0;c[M+(g+16)>>2]=0;f=c[110780>>2]|0;l=1<<U;if((f&l|0)==0){c[110780>>2]=f|l;c[r>>2]=t;c[M+(g+24)>>2]=r;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break}l=c[r>>2]|0;if((U|0)==31){V=0}else{V=25-(U>>>1)|0}e:do{if((c[l+4>>2]&-8|0)==(L|0)){W=l}else{r=L<<V;f=l;while(1){X=f+16+(r>>>31<<2)|0;k=c[X>>2]|0;if((k|0)==0){break}if((c[k+4>>2]&-8|0)==(L|0)){W=k;break e}else{r=r<<1;f=k}}if(X>>>0<(c[110792>>2]|0)>>>0){cd()}else{c[X>>2]=t;c[M+(g+24)>>2]=f;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break d}}}while(0);l=W+8|0;r=c[l>>2]|0;k=c[110792>>2]|0;if(W>>>0<k>>>0){cd()}if(r>>>0<k>>>0){cd()}else{c[r+12>>2]=t;c[l>>2]=t;c[M+(g+8)>>2]=r;c[M+(g+12)>>2]=W;c[M+(g+24)>>2]=0;break}}}while(0);p=M+8|0;i=b;return p|0}}while(0);M=c[110784>>2]|0;if(!(q>>>0>M>>>0)){W=M-q|0;X=c[110796>>2]|0;if(W>>>0>15){c[110796>>2]=X+q;c[110784>>2]=W;c[X+(q+4)>>2]=W|1;c[X+M>>2]=W;c[X+4>>2]=q|3}else{c[110784>>2]=0;c[110796>>2]=0;c[X+4>>2]=M|3;W=X+(M+4)|0;c[W>>2]=c[W>>2]|1}p=X+8|0;i=b;return p|0}X=c[110788>>2]|0;if(q>>>0<X>>>0){W=X-q|0;c[110788>>2]=W;X=c[110800>>2]|0;c[110800>>2]=X+q;c[X+(q+4)>>2]=W|1;c[X+4>>2]=q|3;p=X+8|0;i=b;return p|0}do{if((c[27812]|0)==0){X=ad(30)|0;if((X+ -1&X|0)==0){c[111256>>2]=X;c[111252>>2]=X;c[111260>>2]=-1;c[111264>>2]=-1;c[111268>>2]=0;c[111220>>2]=0;c[27812]=(qc(0)|0)&-16^1431655768;break}else{cd()}}}while(0);X=q+48|0;W=c[111256>>2]|0;M=q+47|0;L=W+M|0;V=0-W|0;W=L&V;if(!(W>>>0>q>>>0)){p=0;i=b;return p|0}U=c[111216>>2]|0;do{if((U|0)!=0){T=c[111208>>2]|0;S=T+W|0;if(S>>>0<=T>>>0|S>>>0>U>>>0){p=0}else{break}i=b;return p|0}}while(0);f:do{if((c[111220>>2]&4|0)==0){U=c[110800>>2]|0;g:do{if((U|0)==0){Y=182}else{S=U;T=111224|0;while(1){Z=T;P=c[Z>>2]|0;if(!(P>>>0>S>>>0)){_=T+4|0;if((P+(c[_>>2]|0)|0)>>>0>S>>>0){break}}P=c[T+8>>2]|0;if((P|0)==0){Y=182;break g}else{T=P}}if((T|0)==0){Y=182;break}S=L-(c[110788>>2]|0)&V;if(!(S>>>0<2147483647)){$=0;break}t=jb(S|0)|0;P=(t|0)==((c[Z>>2]|0)+(c[_>>2]|0)|0);aa=t;ba=S;ca=P?t:-1;da=P?S:0;Y=191}}while(0);do{if((Y|0)==182){U=jb(0)|0;if((U|0)==(-1|0)){$=0;break}S=U;P=c[111252>>2]|0;t=P+ -1|0;if((t&S|0)==0){ea=W}else{ea=W-S+(t+S&0-P)|0}P=c[111208>>2]|0;S=P+ea|0;if(!(ea>>>0>q>>>0&ea>>>0<2147483647)){$=0;break}t=c[111216>>2]|0;if((t|0)!=0){if(S>>>0<=P>>>0|S>>>0>t>>>0){$=0;break}}t=jb(ea|0)|0;S=(t|0)==(U|0);aa=t;ba=ea;ca=S?U:-1;da=S?ea:0;Y=191}}while(0);h:do{if((Y|0)==191){S=0-ba|0;if((ca|0)!=(-1|0)){fa=ca;ga=da;Y=202;break f}do{if((aa|0)!=(-1|0)&ba>>>0<2147483647&ba>>>0<X>>>0){U=c[111256>>2]|0;t=M-ba+U&0-U;if(!(t>>>0<2147483647)){ha=ba;break}if((jb(t|0)|0)==(-1|0)){jb(S|0)|0;$=da;break h}else{ha=t+ba|0;break}}else{ha=ba}}while(0);if((aa|0)==(-1|0)){$=da}else{fa=aa;ga=ha;Y=202;break f}}}while(0);c[111220>>2]=c[111220>>2]|4;ia=$;Y=199}else{ia=0;Y=199}}while(0);do{if((Y|0)==199){if(!(W>>>0<2147483647)){break}$=jb(W|0)|0;ha=jb(0)|0;if(!((ha|0)!=(-1|0)&($|0)!=(-1|0)&$>>>0<ha>>>0)){break}aa=ha-$|0;ha=aa>>>0>(q+40|0)>>>0;if(ha){fa=$;ga=ha?aa:ia;Y=202}}}while(0);do{if((Y|0)==202){ia=(c[111208>>2]|0)+ga|0;c[111208>>2]=ia;if(ia>>>0>(c[111212>>2]|0)>>>0){c[111212>>2]=ia}ia=c[110800>>2]|0;W=111224|0;i:do{if((ia|0)==0){aa=c[110792>>2]|0;if((aa|0)==0|fa>>>0<aa>>>0){c[110792>>2]=fa}c[111224>>2]=fa;c[111228>>2]=ga;c[111236>>2]=0;c[110812>>2]=c[27812];c[110808>>2]=-1;aa=0;do{ha=aa<<1;$=110816+(ha<<2)|0;c[110816+(ha+3<<2)>>2]=$;c[110816+(ha+2<<2)>>2]=$;aa=aa+1|0;}while(aa>>>0<32);aa=fa+8|0;if((aa&7|0)==0){ja=0}else{ja=0-aa&7}aa=ga+ -40-ja|0;c[110800>>2]=fa+ja;c[110788>>2]=aa;c[fa+(ja+4)>>2]=aa|1;c[fa+(ga+ -36)>>2]=40;c[110804>>2]=c[111264>>2]}else{aa=W;while(1){ka=c[aa>>2]|0;la=aa+4|0;ma=c[la>>2]|0;if((fa|0)==(ka+ma|0)){Y=214;break}$=c[aa+8>>2]|0;if(($|0)==0){break}else{aa=$}}do{if((Y|0)==214){if((c[aa+12>>2]&8|0)!=0){break}$=ia;if(!($>>>0>=ka>>>0&$>>>0<fa>>>0)){break}c[la>>2]=ma+ga;$=(c[110788>>2]|0)+ga|0;ha=ia+8|0;if((ha&7|0)==0){na=0}else{na=0-ha&7}ha=$-na|0;c[110800>>2]=ia+na;c[110788>>2]=ha;c[ia+(na+4)>>2]=ha|1;c[ia+($+4)>>2]=40;c[110804>>2]=c[111264>>2];break i}}while(0);if(fa>>>0<(c[110792>>2]|0)>>>0){c[110792>>2]=fa}aa=fa+ga|0;$=111224|0;while(1){oa=$;if((c[oa>>2]|0)==(aa|0)){Y=224;break}ha=c[$+8>>2]|0;if((ha|0)==0){break}else{$=ha}}do{if((Y|0)==224){if((c[$+12>>2]&8|0)!=0){break}c[oa>>2]=fa;aa=$+4|0;c[aa>>2]=(c[aa>>2]|0)+ga;aa=fa+8|0;if((aa&7|0)==0){pa=0}else{pa=0-aa&7}aa=fa+(ga+8)|0;if((aa&7|0)==0){qa=0}else{qa=0-aa&7}aa=fa+(qa+ga)|0;ha=aa;da=pa+q|0;ba=fa+da|0;M=ba;X=aa-(fa+pa)-q|0;c[fa+(pa+4)>>2]=q|3;j:do{if((ha|0)==(c[110800>>2]|0)){ca=(c[110788>>2]|0)+X|0;c[110788>>2]=ca;c[110800>>2]=M;c[fa+(da+4)>>2]=ca|1}else{if((ha|0)==(c[110796>>2]|0)){ca=(c[110784>>2]|0)+X|0;c[110784>>2]=ca;c[110796>>2]=M;c[fa+(da+4)>>2]=ca|1;c[fa+(ca+da)>>2]=ca;break}ca=ga+4|0;ea=c[fa+(ca+qa)>>2]|0;if((ea&3|0)==1){_=ea&-8;Z=ea>>>3;k:do{if(ea>>>0<256){V=c[fa+((qa|8)+ga)>>2]|0;L=c[fa+(ga+12+qa)>>2]|0;S=110816+(Z<<1<<2)|0;do{if((V|0)!=(S|0)){if(V>>>0<(c[110792>>2]|0)>>>0){cd()}if((c[V+12>>2]|0)==(ha|0)){break}cd()}}while(0);if((L|0)==(V|0)){c[27694]=c[27694]&~(1<<Z);break}do{if((L|0)==(S|0)){ra=L+8|0}else{if(L>>>0<(c[110792>>2]|0)>>>0){cd()}T=L+8|0;if((c[T>>2]|0)==(ha|0)){ra=T;break}cd()}}while(0);c[V+12>>2]=L;c[ra>>2]=V}else{S=aa;T=c[fa+((qa|24)+ga)>>2]|0;t=c[fa+(ga+12+qa)>>2]|0;do{if((t|0)==(S|0)){U=qa|16;P=fa+(ca+U)|0;Q=P;R=c[P>>2]|0;if((R|0)==0){P=fa+(U+ga)|0;U=c[P>>2]|0;if((U|0)==0){sa=0;break}else{ta=U;ua=P}}else{ta=R;ua=Q}while(1){Q=ta+20|0;R=c[Q>>2]|0;if((R|0)!=0){ua=Q;ta=R;continue}R=ta+16|0;Q=c[R>>2]|0;if((Q|0)==0){break}else{ta=Q;ua=R}}if(ua>>>0<(c[110792>>2]|0)>>>0){cd()}else{c[ua>>2]=0;sa=ta;break}}else{R=c[fa+((qa|8)+ga)>>2]|0;if(R>>>0<(c[110792>>2]|0)>>>0){cd()}Q=R+12|0;if((c[Q>>2]|0)!=(S|0)){cd()}P=t+8|0;if((c[P>>2]|0)==(S|0)){c[Q>>2]=t;c[P>>2]=R;sa=t;break}else{cd()}}}while(0);if((T|0)==0){break}t=c[fa+(ga+28+qa)>>2]|0;V=111080+(t<<2)|0;do{if((S|0)==(c[V>>2]|0)){c[V>>2]=sa;if((sa|0)!=0){break}c[110780>>2]=c[110780>>2]&~(1<<t);break k}else{if(T>>>0<(c[110792>>2]|0)>>>0){cd()}L=T+16|0;if((c[L>>2]|0)==(S|0)){c[L>>2]=sa}else{c[T+20>>2]=sa}if((sa|0)==0){break k}}}while(0);if(sa>>>0<(c[110792>>2]|0)>>>0){cd()}c[sa+24>>2]=T;S=qa|16;t=c[fa+(S+ga)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[110792>>2]|0)>>>0){cd()}else{c[sa+16>>2]=t;c[t+24>>2]=sa;break}}}while(0);t=c[fa+(ca+S)>>2]|0;if((t|0)==0){break}if(t>>>0<(c[110792>>2]|0)>>>0){cd()}else{c[sa+20>>2]=t;c[t+24>>2]=sa;break}}}while(0);va=fa+((_|qa)+ga)|0;wa=_+X|0}else{va=ha;wa=X}ca=va+4|0;c[ca>>2]=c[ca>>2]&-2;c[fa+(da+4)>>2]=wa|1;c[fa+(wa+da)>>2]=wa;ca=wa>>>3;if(wa>>>0<256){Z=ca<<1;ea=110816+(Z<<2)|0;t=c[27694]|0;T=1<<ca;do{if((t&T|0)==0){c[27694]=t|T;xa=110816+(Z+2<<2)|0;ya=ea}else{ca=110816+(Z+2<<2)|0;V=c[ca>>2]|0;if(!(V>>>0<(c[110792>>2]|0)>>>0)){xa=ca;ya=V;break}cd()}}while(0);c[xa>>2]=M;c[ya+12>>2]=M;c[fa+(da+8)>>2]=ya;c[fa+(da+12)>>2]=ea;break}Z=ba;T=wa>>>8;do{if((T|0)==0){za=0}else{if(wa>>>0>16777215){za=31;break}t=(T+1048320|0)>>>16&8;_=T<<t;V=(_+520192|0)>>>16&4;ca=_<<V;_=(ca+245760|0)>>>16&2;L=14-(V|t|_)+(ca<<_>>>15)|0;za=wa>>>(L+7|0)&1|L<<1}}while(0);T=111080+(za<<2)|0;c[fa+(da+28)>>2]=za;c[fa+(da+20)>>2]=0;c[fa+(da+16)>>2]=0;ea=c[110780>>2]|0;L=1<<za;if((ea&L|0)==0){c[110780>>2]=ea|L;c[T>>2]=Z;c[fa+(da+24)>>2]=T;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break}L=c[T>>2]|0;if((za|0)==31){Aa=0}else{Aa=25-(za>>>1)|0}l:do{if((c[L+4>>2]&-8|0)==(wa|0)){Ba=L}else{T=wa<<Aa;ea=L;while(1){Ca=ea+16+(T>>>31<<2)|0;_=c[Ca>>2]|0;if((_|0)==0){break}if((c[_+4>>2]&-8|0)==(wa|0)){Ba=_;break l}else{T=T<<1;ea=_}}if(Ca>>>0<(c[110792>>2]|0)>>>0){cd()}else{c[Ca>>2]=Z;c[fa+(da+24)>>2]=ea;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break j}}}while(0);L=Ba+8|0;T=c[L>>2]|0;S=c[110792>>2]|0;if(Ba>>>0<S>>>0){cd()}if(T>>>0<S>>>0){cd()}else{c[T+12>>2]=Z;c[L>>2]=Z;c[fa+(da+8)>>2]=T;c[fa+(da+12)>>2]=Ba;c[fa+(da+24)>>2]=0;break}}}while(0);p=fa+(pa|8)|0;i=b;return p|0}}while(0);$=ia;da=111224|0;while(1){Da=c[da>>2]|0;if(!(Da>>>0>$>>>0)){Ea=c[da+4>>2]|0;Fa=Da+Ea|0;if(Fa>>>0>$>>>0){break}}da=c[da+8>>2]|0}da=Da+(Ea+ -39)|0;if((da&7|0)==0){Ga=0}else{Ga=0-da&7}da=Da+(Ea+ -47+Ga)|0;ba=da>>>0<(ia+16|0)>>>0?$:da;da=ba+8|0;M=da;X=fa+8|0;if((X&7|0)==0){Ha=0}else{Ha=0-X&7}X=ga+ -40-Ha|0;c[110800>>2]=fa+Ha;c[110788>>2]=X;c[fa+(Ha+4)>>2]=X|1;c[fa+(ga+ -36)>>2]=40;c[110804>>2]=c[111264>>2];c[ba+4>>2]=27;X=111224|0;c[da+0>>2]=c[X+0>>2];c[da+4>>2]=c[X+4>>2];c[da+8>>2]=c[X+8>>2];c[da+12>>2]=c[X+12>>2];c[111224>>2]=fa;c[111228>>2]=ga;c[111236>>2]=0;c[111232>>2]=M;M=ba+28|0;c[M>>2]=7;if((ba+32|0)>>>0<Fa>>>0){X=M;while(1){M=X+4|0;c[M>>2]=7;if((X+8|0)>>>0<Fa>>>0){X=M}else{break}}}if((ba|0)==($|0)){break}X=ba-ia|0;M=ia+(X+4)|0;c[M>>2]=c[M>>2]&-2;c[ia+4>>2]=X|1;c[ia+X>>2]=X;M=X>>>3;if(X>>>0<256){da=M<<1;ha=110816+(da<<2)|0;aa=c[27694]|0;f=1<<M;do{if((aa&f|0)==0){c[27694]=aa|f;Ia=110816+(da+2<<2)|0;Ja=ha}else{M=110816+(da+2<<2)|0;T=c[M>>2]|0;if(!(T>>>0<(c[110792>>2]|0)>>>0)){Ia=M;Ja=T;break}cd()}}while(0);c[Ia>>2]=ia;c[Ja+12>>2]=ia;c[ia+8>>2]=Ja;c[ia+12>>2]=ha;break}da=ia;f=X>>>8;do{if((f|0)==0){Ka=0}else{if(X>>>0>16777215){Ka=31;break}aa=(f+1048320|0)>>>16&8;ba=f<<aa;$=(ba+520192|0)>>>16&4;T=ba<<$;ba=(T+245760|0)>>>16&2;M=14-($|aa|ba)+(T<<ba>>>15)|0;Ka=X>>>(M+7|0)&1|M<<1}}while(0);f=111080+(Ka<<2)|0;c[ia+28>>2]=Ka;c[ia+20>>2]=0;c[ia+16>>2]=0;ha=c[110780>>2]|0;M=1<<Ka;if((ha&M|0)==0){c[110780>>2]=ha|M;c[f>>2]=da;c[ia+24>>2]=f;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break}M=c[f>>2]|0;if((Ka|0)==31){La=0}else{La=25-(Ka>>>1)|0}m:do{if((c[M+4>>2]&-8|0)==(X|0)){Ma=M}else{f=X<<La;ha=M;while(1){Na=ha+16+(f>>>31<<2)|0;ba=c[Na>>2]|0;if((ba|0)==0){break}if((c[ba+4>>2]&-8|0)==(X|0)){Ma=ba;break m}else{f=f<<1;ha=ba}}if(Na>>>0<(c[110792>>2]|0)>>>0){cd()}else{c[Na>>2]=da;c[ia+24>>2]=ha;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break i}}}while(0);X=Ma+8|0;M=c[X>>2]|0;f=c[110792>>2]|0;if(Ma>>>0<f>>>0){cd()}if(M>>>0<f>>>0){cd()}else{c[M+12>>2]=da;c[X>>2]=da;c[ia+8>>2]=M;c[ia+12>>2]=Ma;c[ia+24>>2]=0;break}}}while(0);ia=c[110788>>2]|0;if(!(ia>>>0>q>>>0)){break}W=ia-q|0;c[110788>>2]=W;ia=c[110800>>2]|0;c[110800>>2]=ia+q;c[ia+(q+4)>>2]=W|1;c[ia+4>>2]=q|3;p=ia+8|0;i=b;return p|0}}while(0);c[(Lc()|0)>>2]=12;p=0;i=b;return p|0}function bS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=i;if((a|0)==0){i=b;return}d=a+ -8|0;e=d;f=c[110792>>2]|0;if(d>>>0<f>>>0){cd()}g=c[a+ -4>>2]|0;h=g&3;if((h|0)==1){cd()}j=g&-8;k=a+(j+ -8)|0;l=k;a:do{if((g&1|0)==0){m=c[d>>2]|0;if((h|0)==0){i=b;return}n=-8-m|0;o=a+n|0;p=o;q=m+j|0;if(o>>>0<f>>>0){cd()}if((p|0)==(c[110796>>2]|0)){r=a+(j+ -4)|0;if((c[r>>2]&3|0)!=3){s=p;t=q;break}c[110784>>2]=q;c[r>>2]=c[r>>2]&-2;c[a+(n+4)>>2]=q|1;c[k>>2]=q;i=b;return}r=m>>>3;if(m>>>0<256){m=c[a+(n+8)>>2]|0;u=c[a+(n+12)>>2]|0;v=110816+(r<<1<<2)|0;do{if((m|0)!=(v|0)){if(m>>>0<f>>>0){cd()}if((c[m+12>>2]|0)==(p|0)){break}cd()}}while(0);if((u|0)==(m|0)){c[27694]=c[27694]&~(1<<r);s=p;t=q;break}do{if((u|0)==(v|0)){w=u+8|0}else{if(u>>>0<f>>>0){cd()}x=u+8|0;if((c[x>>2]|0)==(p|0)){w=x;break}cd()}}while(0);c[m+12>>2]=u;c[w>>2]=m;s=p;t=q;break}v=o;r=c[a+(n+24)>>2]|0;x=c[a+(n+12)>>2]|0;do{if((x|0)==(v|0)){y=a+(n+20)|0;z=y;A=c[y>>2]|0;if((A|0)==0){y=a+(n+16)|0;B=c[y>>2]|0;if((B|0)==0){C=0;break}else{D=B;E=y}}else{D=A;E=z}while(1){z=D+20|0;A=c[z>>2]|0;if((A|0)!=0){E=z;D=A;continue}A=D+16|0;z=c[A>>2]|0;if((z|0)==0){break}else{D=z;E=A}}if(E>>>0<f>>>0){cd()}else{c[E>>2]=0;C=D;break}}else{A=c[a+(n+8)>>2]|0;if(A>>>0<f>>>0){cd()}z=A+12|0;if((c[z>>2]|0)!=(v|0)){cd()}y=x+8|0;if((c[y>>2]|0)==(v|0)){c[z>>2]=x;c[y>>2]=A;C=x;break}else{cd()}}}while(0);if((r|0)==0){s=p;t=q;break}x=c[a+(n+28)>>2]|0;o=111080+(x<<2)|0;do{if((v|0)==(c[o>>2]|0)){c[o>>2]=C;if((C|0)!=0){break}c[110780>>2]=c[110780>>2]&~(1<<x);s=p;t=q;break a}else{if(r>>>0<(c[110792>>2]|0)>>>0){cd()}m=r+16|0;if((c[m>>2]|0)==(v|0)){c[m>>2]=C}else{c[r+20>>2]=C}if((C|0)==0){s=p;t=q;break a}}}while(0);if(C>>>0<(c[110792>>2]|0)>>>0){cd()}c[C+24>>2]=r;v=c[a+(n+16)>>2]|0;do{if((v|0)!=0){if(v>>>0<(c[110792>>2]|0)>>>0){cd()}else{c[C+16>>2]=v;c[v+24>>2]=C;break}}}while(0);v=c[a+(n+20)>>2]|0;if((v|0)==0){s=p;t=q;break}if(v>>>0<(c[110792>>2]|0)>>>0){cd()}else{c[C+20>>2]=v;c[v+24>>2]=C;s=p;t=q;break}}else{s=e;t=j}}while(0);if(!(s>>>0<k>>>0)){cd()}e=a+(j+ -4)|0;C=c[e>>2]|0;if((C&1|0)==0){cd()}do{if((C&2|0)==0){if((l|0)==(c[110800>>2]|0)){f=(c[110788>>2]|0)+t|0;c[110788>>2]=f;c[110800>>2]=s;c[s+4>>2]=f|1;if((s|0)!=(c[110796>>2]|0)){i=b;return}c[110796>>2]=0;c[110784>>2]=0;i=b;return}if((l|0)==(c[110796>>2]|0)){f=(c[110784>>2]|0)+t|0;c[110784>>2]=f;c[110796>>2]=s;c[s+4>>2]=f|1;c[s+f>>2]=f;i=b;return}f=(C&-8)+t|0;D=C>>>3;b:do{if(C>>>0<256){E=c[a+j>>2]|0;w=c[a+(j|4)>>2]|0;h=110816+(D<<1<<2)|0;do{if((E|0)!=(h|0)){if(E>>>0<(c[110792>>2]|0)>>>0){cd()}if((c[E+12>>2]|0)==(l|0)){break}cd()}}while(0);if((w|0)==(E|0)){c[27694]=c[27694]&~(1<<D);break}do{if((w|0)==(h|0)){F=w+8|0}else{if(w>>>0<(c[110792>>2]|0)>>>0){cd()}d=w+8|0;if((c[d>>2]|0)==(l|0)){F=d;break}cd()}}while(0);c[E+12>>2]=w;c[F>>2]=E}else{h=k;d=c[a+(j+16)>>2]|0;g=c[a+(j|4)>>2]|0;do{if((g|0)==(h|0)){v=a+(j+12)|0;r=v;x=c[v>>2]|0;if((x|0)==0){v=a+(j+8)|0;o=c[v>>2]|0;if((o|0)==0){G=0;break}else{H=o;I=v}}else{H=x;I=r}while(1){r=H+20|0;x=c[r>>2]|0;if((x|0)!=0){I=r;H=x;continue}x=H+16|0;r=c[x>>2]|0;if((r|0)==0){break}else{H=r;I=x}}if(I>>>0<(c[110792>>2]|0)>>>0){cd()}else{c[I>>2]=0;G=H;break}}else{x=c[a+j>>2]|0;if(x>>>0<(c[110792>>2]|0)>>>0){cd()}r=x+12|0;if((c[r>>2]|0)!=(h|0)){cd()}v=g+8|0;if((c[v>>2]|0)==(h|0)){c[r>>2]=g;c[v>>2]=x;G=g;break}else{cd()}}}while(0);if((d|0)==0){break}g=c[a+(j+20)>>2]|0;E=111080+(g<<2)|0;do{if((h|0)==(c[E>>2]|0)){c[E>>2]=G;if((G|0)!=0){break}c[110780>>2]=c[110780>>2]&~(1<<g);break b}else{if(d>>>0<(c[110792>>2]|0)>>>0){cd()}w=d+16|0;if((c[w>>2]|0)==(h|0)){c[w>>2]=G}else{c[d+20>>2]=G}if((G|0)==0){break b}}}while(0);if(G>>>0<(c[110792>>2]|0)>>>0){cd()}c[G+24>>2]=d;h=c[a+(j+8)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[110792>>2]|0)>>>0){cd()}else{c[G+16>>2]=h;c[h+24>>2]=G;break}}}while(0);h=c[a+(j+12)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[110792>>2]|0)>>>0){cd()}else{c[G+20>>2]=h;c[h+24>>2]=G;break}}}while(0);c[s+4>>2]=f|1;c[s+f>>2]=f;if((s|0)!=(c[110796>>2]|0)){J=f;break}c[110784>>2]=f;i=b;return}else{c[e>>2]=C&-2;c[s+4>>2]=t|1;c[s+t>>2]=t;J=t}}while(0);t=J>>>3;if(J>>>0<256){C=t<<1;e=110816+(C<<2)|0;G=c[27694]|0;j=1<<t;do{if((G&j|0)==0){c[27694]=G|j;K=110816+(C+2<<2)|0;L=e}else{t=110816+(C+2<<2)|0;a=c[t>>2]|0;if(!(a>>>0<(c[110792>>2]|0)>>>0)){K=t;L=a;break}cd()}}while(0);c[K>>2]=s;c[L+12>>2]=s;c[s+8>>2]=L;c[s+12>>2]=e;i=b;return}e=s;L=J>>>8;do{if((L|0)==0){M=0}else{if(J>>>0>16777215){M=31;break}K=(L+1048320|0)>>>16&8;C=L<<K;j=(C+520192|0)>>>16&4;G=C<<j;C=(G+245760|0)>>>16&2;a=14-(j|K|C)+(G<<C>>>15)|0;M=J>>>(a+7|0)&1|a<<1}}while(0);L=111080+(M<<2)|0;c[s+28>>2]=M;c[s+20>>2]=0;c[s+16>>2]=0;a=c[110780>>2]|0;C=1<<M;c:do{if((a&C|0)==0){c[110780>>2]=a|C;c[L>>2]=e;c[s+24>>2]=L;c[s+12>>2]=s;c[s+8>>2]=s}else{G=c[L>>2]|0;if((M|0)==31){N=0}else{N=25-(M>>>1)|0}d:do{if((c[G+4>>2]&-8|0)==(J|0)){O=G}else{K=J<<N;j=G;while(1){P=j+16+(K>>>31<<2)|0;t=c[P>>2]|0;if((t|0)==0){break}if((c[t+4>>2]&-8|0)==(J|0)){O=t;break d}else{K=K<<1;j=t}}if(P>>>0<(c[110792>>2]|0)>>>0){cd()}else{c[P>>2]=e;c[s+24>>2]=j;c[s+12>>2]=s;c[s+8>>2]=s;break c}}}while(0);G=O+8|0;f=c[G>>2]|0;K=c[110792>>2]|0;if(O>>>0<K>>>0){cd()}if(f>>>0<K>>>0){cd()}else{c[f+12>>2]=e;c[G>>2]=e;c[s+8>>2]=f;c[s+12>>2]=O;c[s+24>>2]=0;break}}}while(0);s=(c[110808>>2]|0)+ -1|0;c[110808>>2]=s;if((s|0)==0){Q=111232|0}else{i=b;return}while(1){s=c[Q>>2]|0;if((s|0)==0){break}else{Q=s+8|0}}c[110808>>2]=-1;i=b;return}function cS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{if((a|0)==0){e=0}else{f=fa(b,a)|0;if(!((b|a)>>>0>65535)){e=f;break}e=((f>>>0)/(a>>>0)|0|0)==(b|0)?f:-1}}while(0);b=aS(e)|0;if((b|0)==0){i=d;return b|0}if((c[b+ -4>>2]&3|0)==0){i=d;return b|0}IS(b|0,0,e|0)|0;i=d;return b|0}function dS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if((a|0)==0){e=aS(b)|0;i=d;return e|0}if(b>>>0>4294967231){c[(Lc()|0)>>2]=12;e=0;i=d;return e|0}if(b>>>0<11){f=16}else{f=b+11&-8}g=eS(a+ -8|0,f)|0;if((g|0)!=0){e=g+8|0;i=d;return e|0}g=aS(b)|0;if((g|0)==0){e=0;i=d;return e|0}f=c[a+ -4>>2]|0;h=(f&-8)-((f&3|0)==0?8:4)|0;GS(g|0,a|0,(h>>>0<b>>>0?h:b)|0)|0;bS(a);e=g;i=d;return e|0}function eS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a;j=a+g|0;k=j;l=c[110792>>2]|0;if(h>>>0<l>>>0){cd()}m=f&3;if(!((m|0)!=1&h>>>0<j>>>0)){cd()}h=a+(g|4)|0;n=c[h>>2]|0;if((n&1|0)==0){cd()}if((m|0)==0){if(b>>>0<256){o=0;i=d;return o|0}do{if(!(g>>>0<(b+4|0)>>>0)){if((g-b|0)>>>0>c[111256>>2]<<1>>>0){break}else{o=a}i=d;return o|0}}while(0);o=0;i=d;return o|0}if(!(g>>>0<b>>>0)){m=g-b|0;if(!(m>>>0>15)){o=a;i=d;return o|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|3;c[h>>2]=c[h>>2]|1;fS(a+b|0,m);o=a;i=d;return o|0}if((k|0)==(c[110800>>2]|0)){m=(c[110788>>2]|0)+g|0;if(!(m>>>0>b>>>0)){o=0;i=d;return o|0}h=m-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=h|1;c[110800>>2]=a+b;c[110788>>2]=h;o=a;i=d;return o|0}if((k|0)==(c[110796>>2]|0)){h=(c[110784>>2]|0)+g|0;if(h>>>0<b>>>0){o=0;i=d;return o|0}m=h-b|0;if(m>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|1;c[a+h>>2]=m;p=a+(h+4)|0;c[p>>2]=c[p>>2]&-2;q=a+b|0;r=m}else{c[e>>2]=f&1|h|2;f=a+(h+4)|0;c[f>>2]=c[f>>2]|1;q=0;r=0}c[110784>>2]=r;c[110796>>2]=q;o=a;i=d;return o|0}if((n&2|0)!=0){o=0;i=d;return o|0}q=(n&-8)+g|0;if(q>>>0<b>>>0){o=0;i=d;return o|0}r=q-b|0;f=n>>>3;a:do{if(n>>>0<256){h=c[a+(g+8)>>2]|0;m=c[a+(g+12)>>2]|0;p=110816+(f<<1<<2)|0;do{if((h|0)!=(p|0)){if(h>>>0<l>>>0){cd()}if((c[h+12>>2]|0)==(k|0)){break}cd()}}while(0);if((m|0)==(h|0)){c[27694]=c[27694]&~(1<<f);break}do{if((m|0)==(p|0)){s=m+8|0}else{if(m>>>0<l>>>0){cd()}t=m+8|0;if((c[t>>2]|0)==(k|0)){s=t;break}cd()}}while(0);c[h+12>>2]=m;c[s>>2]=h}else{p=j;t=c[a+(g+24)>>2]|0;u=c[a+(g+12)>>2]|0;do{if((u|0)==(p|0)){v=a+(g+20)|0;w=v;x=c[v>>2]|0;if((x|0)==0){v=a+(g+16)|0;y=c[v>>2]|0;if((y|0)==0){z=0;break}else{A=y;B=v}}else{A=x;B=w}while(1){w=A+20|0;x=c[w>>2]|0;if((x|0)!=0){B=w;A=x;continue}x=A+16|0;w=c[x>>2]|0;if((w|0)==0){break}else{A=w;B=x}}if(B>>>0<l>>>0){cd()}else{c[B>>2]=0;z=A;break}}else{x=c[a+(g+8)>>2]|0;if(x>>>0<l>>>0){cd()}w=x+12|0;if((c[w>>2]|0)!=(p|0)){cd()}v=u+8|0;if((c[v>>2]|0)==(p|0)){c[w>>2]=u;c[v>>2]=x;z=u;break}else{cd()}}}while(0);if((t|0)==0){break}u=c[a+(g+28)>>2]|0;h=111080+(u<<2)|0;do{if((p|0)==(c[h>>2]|0)){c[h>>2]=z;if((z|0)!=0){break}c[110780>>2]=c[110780>>2]&~(1<<u);break a}else{if(t>>>0<(c[110792>>2]|0)>>>0){cd()}m=t+16|0;if((c[m>>2]|0)==(p|0)){c[m>>2]=z}else{c[t+20>>2]=z}if((z|0)==0){break a}}}while(0);if(z>>>0<(c[110792>>2]|0)>>>0){cd()}c[z+24>>2]=t;p=c[a+(g+16)>>2]|0;do{if((p|0)!=0){if(p>>>0<(c[110792>>2]|0)>>>0){cd()}else{c[z+16>>2]=p;c[p+24>>2]=z;break}}}while(0);p=c[a+(g+20)>>2]|0;if((p|0)==0){break}if(p>>>0<(c[110792>>2]|0)>>>0){cd()}else{c[z+20>>2]=p;c[p+24>>2]=z;break}}}while(0);if(r>>>0<16){c[e>>2]=q|c[e>>2]&1|2;z=a+(q|4)|0;c[z>>2]=c[z>>2]|1;o=a;i=d;return o|0}else{c[e>>2]=c[e>>2]&1|b|2;c[a+(b+4)>>2]=r|3;e=a+(q|4)|0;c[e>>2]=c[e>>2]|1;fS(a+b|0,r);o=a;i=d;return o|0}return 0}function fS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+b|0;f=e;g=c[a+4>>2]|0;a:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){i=d;return}j=a+(0-h)|0;k=j;l=h+b|0;m=c[110792>>2]|0;if(j>>>0<m>>>0){cd()}if((k|0)==(c[110796>>2]|0)){n=a+(b+4)|0;if((c[n>>2]&3|0)!=3){o=k;p=l;break}c[110784>>2]=l;c[n>>2]=c[n>>2]&-2;c[a+(4-h)>>2]=l|1;c[e>>2]=l;i=d;return}n=h>>>3;if(h>>>0<256){q=c[a+(8-h)>>2]|0;r=c[a+(12-h)>>2]|0;s=110816+(n<<1<<2)|0;do{if((q|0)!=(s|0)){if(q>>>0<m>>>0){cd()}if((c[q+12>>2]|0)==(k|0)){break}cd()}}while(0);if((r|0)==(q|0)){c[27694]=c[27694]&~(1<<n);o=k;p=l;break}do{if((r|0)==(s|0)){t=r+8|0}else{if(r>>>0<m>>>0){cd()}u=r+8|0;if((c[u>>2]|0)==(k|0)){t=u;break}cd()}}while(0);c[q+12>>2]=r;c[t>>2]=q;o=k;p=l;break}s=j;n=c[a+(24-h)>>2]|0;u=c[a+(12-h)>>2]|0;do{if((u|0)==(s|0)){v=16-h|0;w=a+(v+4)|0;x=w;y=c[w>>2]|0;if((y|0)==0){w=a+v|0;v=c[w>>2]|0;if((v|0)==0){z=0;break}else{A=v;B=w}}else{A=y;B=x}while(1){x=A+20|0;y=c[x>>2]|0;if((y|0)!=0){B=x;A=y;continue}y=A+16|0;x=c[y>>2]|0;if((x|0)==0){break}else{A=x;B=y}}if(B>>>0<m>>>0){cd()}else{c[B>>2]=0;z=A;break}}else{y=c[a+(8-h)>>2]|0;if(y>>>0<m>>>0){cd()}x=y+12|0;if((c[x>>2]|0)!=(s|0)){cd()}w=u+8|0;if((c[w>>2]|0)==(s|0)){c[x>>2]=u;c[w>>2]=y;z=u;break}else{cd()}}}while(0);if((n|0)==0){o=k;p=l;break}u=c[a+(28-h)>>2]|0;m=111080+(u<<2)|0;do{if((s|0)==(c[m>>2]|0)){c[m>>2]=z;if((z|0)!=0){break}c[110780>>2]=c[110780>>2]&~(1<<u);o=k;p=l;break a}else{if(n>>>0<(c[110792>>2]|0)>>>0){cd()}j=n+16|0;if((c[j>>2]|0)==(s|0)){c[j>>2]=z}else{c[n+20>>2]=z}if((z|0)==0){o=k;p=l;break a}}}while(0);if(z>>>0<(c[110792>>2]|0)>>>0){cd()}c[z+24>>2]=n;s=16-h|0;u=c[a+s>>2]|0;do{if((u|0)!=0){if(u>>>0<(c[110792>>2]|0)>>>0){cd()}else{c[z+16>>2]=u;c[u+24>>2]=z;break}}}while(0);u=c[a+(s+4)>>2]|0;if((u|0)==0){o=k;p=l;break}if(u>>>0<(c[110792>>2]|0)>>>0){cd()}else{c[z+20>>2]=u;c[u+24>>2]=z;o=k;p=l;break}}else{o=a;p=b}}while(0);z=c[110792>>2]|0;if(e>>>0<z>>>0){cd()}A=a+(b+4)|0;B=c[A>>2]|0;do{if((B&2|0)==0){if((f|0)==(c[110800>>2]|0)){t=(c[110788>>2]|0)+p|0;c[110788>>2]=t;c[110800>>2]=o;c[o+4>>2]=t|1;if((o|0)!=(c[110796>>2]|0)){i=d;return}c[110796>>2]=0;c[110784>>2]=0;i=d;return}if((f|0)==(c[110796>>2]|0)){t=(c[110784>>2]|0)+p|0;c[110784>>2]=t;c[110796>>2]=o;c[o+4>>2]=t|1;c[o+t>>2]=t;i=d;return}t=(B&-8)+p|0;g=B>>>3;b:do{if(B>>>0<256){u=c[a+(b+8)>>2]|0;h=c[a+(b+12)>>2]|0;n=110816+(g<<1<<2)|0;do{if((u|0)!=(n|0)){if(u>>>0<z>>>0){cd()}if((c[u+12>>2]|0)==(f|0)){break}cd()}}while(0);if((h|0)==(u|0)){c[27694]=c[27694]&~(1<<g);break}do{if((h|0)==(n|0)){C=h+8|0}else{if(h>>>0<z>>>0){cd()}m=h+8|0;if((c[m>>2]|0)==(f|0)){C=m;break}cd()}}while(0);c[u+12>>2]=h;c[C>>2]=u}else{n=e;m=c[a+(b+24)>>2]|0;j=c[a+(b+12)>>2]|0;do{if((j|0)==(n|0)){q=a+(b+20)|0;r=q;y=c[q>>2]|0;if((y|0)==0){q=a+(b+16)|0;w=c[q>>2]|0;if((w|0)==0){D=0;break}else{E=w;F=q}}else{E=y;F=r}while(1){r=E+20|0;y=c[r>>2]|0;if((y|0)!=0){F=r;E=y;continue}y=E+16|0;r=c[y>>2]|0;if((r|0)==0){break}else{E=r;F=y}}if(F>>>0<z>>>0){cd()}else{c[F>>2]=0;D=E;break}}else{y=c[a+(b+8)>>2]|0;if(y>>>0<z>>>0){cd()}r=y+12|0;if((c[r>>2]|0)!=(n|0)){cd()}q=j+8|0;if((c[q>>2]|0)==(n|0)){c[r>>2]=j;c[q>>2]=y;D=j;break}else{cd()}}}while(0);if((m|0)==0){break}j=c[a+(b+28)>>2]|0;u=111080+(j<<2)|0;do{if((n|0)==(c[u>>2]|0)){c[u>>2]=D;if((D|0)!=0){break}c[110780>>2]=c[110780>>2]&~(1<<j);break b}else{if(m>>>0<(c[110792>>2]|0)>>>0){cd()}h=m+16|0;if((c[h>>2]|0)==(n|0)){c[h>>2]=D}else{c[m+20>>2]=D}if((D|0)==0){break b}}}while(0);if(D>>>0<(c[110792>>2]|0)>>>0){cd()}c[D+24>>2]=m;n=c[a+(b+16)>>2]|0;do{if((n|0)!=0){if(n>>>0<(c[110792>>2]|0)>>>0){cd()}else{c[D+16>>2]=n;c[n+24>>2]=D;break}}}while(0);n=c[a+(b+20)>>2]|0;if((n|0)==0){break}if(n>>>0<(c[110792>>2]|0)>>>0){cd()}else{c[D+20>>2]=n;c[n+24>>2]=D;break}}}while(0);c[o+4>>2]=t|1;c[o+t>>2]=t;if((o|0)!=(c[110796>>2]|0)){G=t;break}c[110784>>2]=t;i=d;return}else{c[A>>2]=B&-2;c[o+4>>2]=p|1;c[o+p>>2]=p;G=p}}while(0);p=G>>>3;if(G>>>0<256){B=p<<1;A=110816+(B<<2)|0;D=c[27694]|0;b=1<<p;do{if((D&b|0)==0){c[27694]=D|b;H=110816+(B+2<<2)|0;I=A}else{p=110816+(B+2<<2)|0;a=c[p>>2]|0;if(!(a>>>0<(c[110792>>2]|0)>>>0)){H=p;I=a;break}cd()}}while(0);c[H>>2]=o;c[I+12>>2]=o;c[o+8>>2]=I;c[o+12>>2]=A;i=d;return}A=o;I=G>>>8;do{if((I|0)==0){J=0}else{if(G>>>0>16777215){J=31;break}H=(I+1048320|0)>>>16&8;B=I<<H;b=(B+520192|0)>>>16&4;D=B<<b;B=(D+245760|0)>>>16&2;a=14-(b|H|B)+(D<<B>>>15)|0;J=G>>>(a+7|0)&1|a<<1}}while(0);I=111080+(J<<2)|0;c[o+28>>2]=J;c[o+20>>2]=0;c[o+16>>2]=0;a=c[110780>>2]|0;B=1<<J;if((a&B|0)==0){c[110780>>2]=a|B;c[I>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}B=c[I>>2]|0;if((J|0)==31){K=0}else{K=25-(J>>>1)|0}c:do{if((c[B+4>>2]&-8|0)==(G|0)){L=B}else{J=G<<K;I=B;while(1){M=I+16+(J>>>31<<2)|0;a=c[M>>2]|0;if((a|0)==0){break}if((c[a+4>>2]&-8|0)==(G|0)){L=a;break c}else{J=J<<1;I=a}}if(M>>>0<(c[110792>>2]|0)>>>0){cd()}c[M>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}}while(0);M=L+8|0;G=c[M>>2]|0;B=c[110792>>2]|0;if(L>>>0<B>>>0){cd()}if(G>>>0<B>>>0){cd()}c[G+12>>2]=A;c[M>>2]=A;c[o+8>>2]=G;c[o+12>>2]=L;c[o+24>>2]=0;i=d;return}function gS(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(a|0)==0?1:a;while(1){e=aS(d)|0;if((e|0)!=0){f=6;break}a=c[27818]|0;c[27818]=0+a;if((a|0)==0){f=5;break}ve[a&7]()}if((f|0)==5){d=Cc(4)|0;c[d>>2]=111288;Kd(d|0,111336,135)}else if((f|0)==6){i=b;return e|0}return 0}function hS(a){a=a|0;var b=0,c=0;b=i;c=gS(a)|0;i=b;return c|0}function iS(a){a=a|0;var b=0;b=i;if((a|0)!=0){bS(a)}i=b;return}function jS(a){a=a|0;var b=0;b=i;iS(a);i=b;return}function kS(a){a=a|0;var b=0;b=i;yb(a|0);iS(a);i=b;return}function lS(a){a=a|0;var b=0;b=i;yb(a|0);i=b;return}function mS(a){a=a|0;i=i;return 111304}function nS(){var a=0;a=Cc(4)|0;c[a>>2]=111288;Kd(a|0,111336,135)}



function vj(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+368|0;n=m+48|0;o=b;b=e;e=f;f=g;g=h;c[n>>2]=j;j=k;k=l;l=c[o+356>>2]|0;h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}a:while(1){h=1;c[p>>2]=e;c[q>>2]=c[n>>2];b:do{if((g|0)<=0){if((k&255|0)!=0){if((g|0)!=0){r=7;break a}}switch(g|0){case 0:{r=9;break a;break};case-1:{r=10;break a;break};case-2:{r=11;break a;break};case-15:{g=0-g|0;break b;break};case-4:{r=13;break a;break};default:{g=0-g|0;c[n>>2]=f;break b}}}}while(0);s=oe[c[o+256>>2]&63](o+256|0,g,e,c[n>>2]|0,b)|0;c:do{switch(s|0){case 1:{t=wj(o,0,e,c[n>>2]|0)|0;if((t|0)!=0){r=25;break a}b=c[o+144>>2]|0;h=0;break};case 6:{a[o+489|0]=0;c[o+316>>2]=oj(o,l+132|0,12640,36)|0;if((c[o+316>>2]|0)==0){r=38;break a}a[l+129|0]=1;if((c[o+84>>2]|0)==0){r=45;break c}if((xe[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=41;break a}u=xj(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((u|0)==0){r=43;break a}yj(u);c[o+432>>2]=c[o+428>>2];c[o+328>>2]=u;h=0;r=47;break};case 4:{if((c[o+84>>2]|0)!=0){c[o+320>>2]=xj(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+320>>2]|0)==0){r=29;break a}c[o+432>>2]=c[o+428>>2];c[o+328>>2]=0;h=0}c[o+324>>2]=0;break};case 7:{if((c[o+84>>2]|0)==0){break c}Vd[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,1);c[o+320>>2]=0;Ui(o+416|0);h=0;break};case 57:{v=wj(o,1,e,c[n>>2]|0)|0;if((v|0)!=0){r=35;break a}b=c[o+144>>2]|0;h=0;break};case 22:{c[o+348>>2]=Bj(o,b,e,c[n>>2]|0)|0;if((c[o+348>>2]|0)==0){r=92;break a}a[o+352|0]=0;c[o+332>>2]=0;a[o+353|0]=0;r=102;break};case 14:{r=45;break};case 8:{if((c[o+320>>2]|0)!=0){Vd[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,0);Ui(o+416|0);h=0}if((c[o+324>>2]|0)!=0){r=57}else{if((d[o+489|0]|0)!=0){r=57}}if((r|0)==57){r=0;u=a[l+129|0]|0;a[l+129|0]=1;do{if((c[o+492>>2]|0)!=0){if((c[o+112>>2]|0)==0){break}w=oj(o,l+132|0,12640,36)|0;if((w|0)==0){r=60;break a}if((a[o+489|0]|0)!=0){c[w+20>>2]=c[o+360>>2]}a[l+131|0]=0;if((oe[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)==0){r=64;break a}if((a[l+131|0]|0)==0){if((c[o+324>>2]|0)!=0){break}a[l+129|0]=u;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if(($d[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=69;break a}}}while(0);a[o+489|0]=0}if((c[o+88>>2]|0)==0){break c}Yd[c[o+88>>2]&255](c[o+4>>2]|0);h=0;break};case 2:{r=75;break a;break};case 34:{c[o+344>>2]=Aj(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)!=0){r=102}else{r=90;break a}break};case 32:case 31:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)!=0){x=12744}else{x=(s|0)==32?12728:12752}if((Cj(o+416|0,x)|0)==0){r=111;break a}if((Dj(o+416|0,b,e,c[n>>2]|0)|0)==0){r=113;break a}c[o+332>>2]=c[o+432>>2];h=0;break};case 23:{a[o+352|0]=1;c[o+332>>2]=12648;r=102;break};case 24:{a[o+353|0]=1;c[o+332>>2]=12656;r=102;break};case 25:{c[o+332>>2]=12664;r=102;break};case 26:{c[o+332>>2]=12672;r=102;break};case 27:{c[o+332>>2]=12680;r=102;break};case 28:{c[o+332>>2]=12688;r=102;break};case 29:{c[o+332>>2]=12704;r=102;break};case 30:{c[o+332>>2]=12712;r=102;break};case 36:case 35:{if((a[l+128|0]|0)==0){break c}if((Ej(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,a[o+353|0]|0,0,o)|0)==0){r=117;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=123}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=123}}}while(0);if((r|0)==123){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((lj(o+416|0)|0)<<24>>24!=0)){r=128;break a}}u=o+428|0;w=c[u>>2]|0;c[u>>2]=w+1;a[w]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((lj(o+416|0)|0)<<24>>24!=0)){r=128;break a}}w=o+428|0;u=c[w>>2]|0;c[w>>2]=u+1;a[u]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;he[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,0,(s|0)==36|0);Ui(o+416|0);h=0;break};case 5:{a[o+489|0]=0;a[l+129|0]=1;u=o;if((c[o+84>>2]|0)!=0){c[o+324>>2]=xj(u+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((c[o+324>>2]|0)==0){r=156;break a}c[o+432>>2]=c[o+428>>2];h=0}else{c[u+324>>2]=12640}do{if((a[l+130|0]|0)==0){if((c[o+492>>2]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if(($d[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=163;break a}}}while(0);if((c[o+316>>2]|0)!=0){r=168;break c}c[o+316>>2]=oj(o,l+132|0,12640,36)|0;if((c[o+316>>2]|0)==0){r=166;break a}c[(c[o+316>>2]|0)+24>>2]=0;r=168;break};case 38:case 37:{if((a[l+128|0]|0)==0){break c}y=Fj(o,b,a[o+352|0]|0,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0,l+80|0)|0;if((y|0)!=0){r=132;break a}u=c[l+96>>2]|0;c[l+96>>2]=c[l+92>>2];if((Ej(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,0,u,o)|0)==0){r=134;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=140}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=140}}}while(0);if((r|0)==140){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((lj(o+416|0)|0)<<24>>24!=0)){r=145;break a}}w=o+428|0;z=c[w>>2]|0;c[w>>2]=z+1;a[z]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((lj(o+416|0)|0)<<24>>24!=0)){r=145;break a}}z=o+428|0;w=c[z>>2]|0;c[z>>2]=w+1;a[w]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;he[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,u,(s|0)==38|0);Ui(o+416|0);h=0;break};case 12:{if((a[l+128|0]|0)==0){break c}A=Gj(o,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;w=c[l+120>>2]|0;do{if((c[o+316>>2]|0)!=0){c[(c[o+316>>2]|0)+4>>2]=w;c[(c[o+316>>2]|0)+8>>2]=(c[l+116>>2]|0)-(c[l+120>>2]|0);c[l+120>>2]=c[l+116>>2];if((c[o+136>>2]|0)==0){break}c[q>>2]=e;me[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,c[(c[o+316>>2]|0)+4>>2]|0,c[(c[o+316>>2]|0)+8>>2]|0,c[o+360>>2]|0,0,0,0);h=0}else{c[l+116>>2]=w}}while(0);if((A|0)!=0){r=153;break a}break};case 13:{r=168;break};case 15:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;me[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,0);h=0;break};case 16:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}w=xj(l+80|0,b,e,c[n>>2]|0)|0;c[(c[o+316>>2]|0)+28>>2]=w;if((c[(c[o+316>>2]|0)+28>>2]|0)==0){r=181;break a}c[l+96>>2]=c[l+92>>2];if((c[o+92>>2]|0)!=0){c[q>>2]=e;he[c[o+92>>2]&31](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;me[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break};case 9:{if((be[c[b+48>>2]&63](b,e,c[n>>2]|0)|0)!=0){c[o+316>>2]=0;break c}w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=xj(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=190;break a}c[o+316>>2]=oj(o,l,u,36)|0;if((c[o+316>>2]|0)==0){r=192;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=0;if((c[o+476>>2]|0)!=0){B=1}else{B=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(B^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 10:{w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=xj(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=202;break a}c[o+316>>2]=oj(o,l+132|0,u,36)|0;if((c[o+316>>2]|0)==0){r=204;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=1;if((c[o+476>>2]|0)!=0){C=1}else{C=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(C^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 18:{c[o+340>>2]=0;c[o+336>>2]=0;if((c[o+96>>2]|0)==0){break c}c[o+336>>2]=xj(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+336>>2]|0)==0){r=214;break a}c[o+432>>2]=c[o+428>>2];h=0;break};case 58:{if((c[o+80>>2]|0)!=0){jj(o,b,e,c[n>>2]|0)}h=0;D=Hj(o,b,n,f,j,k)|0;if((D|0)!=0){r=239;break a}if((c[n>>2]|0)==0){r=241;break a}break};case 21:{if((xe[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=217;break a}if((c[o+336>>2]|0)==0){break c}w=xj(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=220;break a}yj(w);c[o+340>>2]=w;c[o+432>>2]=c[o+428>>2];h=0;break};case 19:{do{if((c[o+336>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}w=xj(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=225;break a}c[q>>2]=e;Vd[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,w,c[o+340>>2]|0);h=0}}while(0);Ui(o+416|0);break};case 20:{do{if((c[o+340>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}c[q>>2]=e;Vd[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,0,c[o+340>>2]|0);h=0}}while(0);Ui(o+416|0);break};case-1:{r=232;break a;break};case 44:{do{if((c[o+260>>2]|0)>>>0>=(c[o+468>>2]|0)>>>0){w=o+12|0;if((c[o+468>>2]|0)==0){u=c[w>>2]|0;c[o+468>>2]=32;c[o+464>>2]=$d[u&127](32)|0;if((c[o+464>>2]|0)!=0){break}else{r=251;break a}}u=c[w+4>>2]|0;w=c[o+464>>2]|0;z=o+468|0;E=c[z>>2]<<1;c[z>>2]=E;z=ne[u&63](w,E)|0;if((z|0)==0){r=245;break a}c[o+464>>2]=z;if((c[l+184>>2]|0)==0){break}z=ne[c[o+16>>2]&63](c[l+184>>2]|0,c[o+468>>2]<<2)|0;if((z|0)==0){r=248;break a}c[l+184>>2]=z}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=0;if((a[l+160|0]|0)==0){break c}z=Jj(o)|0;if((z|0)<0){r=254;break a}c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]=z;E=l+180|0;c[E>>2]=(c[E>>2]|0)+1;c[(c[l+164>>2]|0)+(z*28|0)>>2]=6;if((c[o+128>>2]|0)==0){break c}h=0;break};case 50:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==124){r=258;break a}a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=44;if((d[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)==0){break c}h=0;break};case 49:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==44){r=263;break a}do{if((d[l+160|0]|0)!=0){if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)!=0){break}if((c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]|0)==3){break}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=5;if((c[o+128>>2]|0)==0){break}h=0}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=124;break};case 59:case 60:{a[l+129|0]=1;z=l;do{if((c[o+492>>2]|0)!=0){E=xj(z+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=273;break a}w=oj(o,l+132|0,E,0)|0;c[l+92>>2]=c[l+96>>2];do{if((c[o+272>>2]|0)!=0){if((d[l+130|0]|0)!=0){if((c[o+300>>2]|0)!=0){r=282;break}}else{if((a[l+129|0]|0)!=0){r=282;break}}if((w|0)==0){r=279;break a}if((a[w+34|0]|0)==0){r=281;break a}}else{r=282}}while(0);do{if((r|0)==282){r=0;if((w|0)!=0){break}a[l+128|0]=a[l+130|0]|0;if((s|0)!=60){break c}if((c[o+120>>2]|0)==0){break c}ue[c[o+120>>2]&15](c[o+4>>2]|0,E,1);h=0;break c}}while(0);if((a[w+32|0]|0)!=0){r=287;break a}if((c[w+4>>2]|0)!=0){F=Kj(o,w,((s|0)==60?1:0)&255)|0;if((F|0)!=0){r=290;break a}h=0;break c}E=l;if((c[o+112>>2]|0)==0){a[l+128|0]=a[E+130|0]|0;break c}a[E+131|0]=0;a[w+32|0]=1;E=(oe[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)!=0;a[w+32|0]=0;if(!E){r=294;break a}h=0;if((a[l+131|0]|0)!=0){break}a[l+128|0]=a[l+130|0]|0;break c}else{a[l+128|0]=a[z+130|0]|0}}while(0);if((a[l+130|0]|0)!=0){break c}if((c[o+108>>2]|0)==0){break c}if(($d[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=301;break a}break};case 53:{G=1;r=319;break};case 52:{G=2;r=319;break};case 54:{G=3;r=319;break};case 40:{if((c[o+128>>2]|0)==0){break c}c[o+344>>2]=Aj(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)==0){r=304;break a}c[l+180>>2]=0;c[l+176>>2]=0;a[l+160|0]=1;h=0;break};case 42:case 41:{if((a[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)!=0){z=$d[c[o+12>>2]&127](20)|0;if((z|0)==0){r=309;break a}c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;c[z+16>>2]=0;c[z>>2]=(s|0)==41?2:1;c[q>>2]=e;ue[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,z);h=0}a[l+160|0]=0;break};case 43:{if((a[l+160|0]|0)==0){break c}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=3;if((c[o+128>>2]|0)==0){break c}h=0;break};case 51:{G=0;r=319;break};case 47:{G=1;r=334;break};case 46:{G=2;r=334;break};case 48:{G=3;r=334;break};case 45:{G=0;r=334;break};case 56:{if((Nj(o,b,e,c[n>>2]|0)|0)==0){r=347;break a}h=0;break};case 0:{if((g|0)!=14){break c}h=0;break};case 3:{if((c[o+84>>2]|0)==0){break c}h=0;break};case 11:{if((d[l+128|0]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}h=0;break};case 55:{if((Mj(o,b,e,c[n>>2]|0)|0)==0){r=344;break a}h=0;break};case 17:{if((c[o+96>>2]|0)==0){break c}h=0;break};case 33:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}h=0;break};case 39:{if((c[o+128>>2]|0)==0){break c}h=0;break};default:{}}}while(0);do{if((r|0)==45){r=0;if((xe[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)!=0){r=47}else{r=46;break a}}else if((r|0)==102){r=0;if((d[l+128|0]|0)==0){break}if((c[o+132>>2]|0)==0){break}h=0}else if((r|0)==168){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}s=xj(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;c[(c[o+316>>2]|0)+16>>2]=s;if((c[(c[o+316>>2]|0)+16>>2]|0)==0){r=171;break a}c[(c[o+316>>2]|0)+20>>2]=c[o+360>>2];c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}else if((r|0)==319){r=0;if((a[l+160|0]|0)==0){break}s=c[n>>2]|0;if((G|0)==0){H=s}else{H=s+(0-(c[b+68>>2]|0))|0}s=Jj(o)|0;if((s|0)<0){r=323;break a}c[(c[l+164>>2]|0)+(s*28|0)>>2]=4;c[(c[l+164>>2]|0)+(s*28|0)+4>>2]=G;z=Aj(o,b,e,H)|0;if((z|0)==0){r=325;break a}E=c[z>>2]|0;c[(c[l+164>>2]|0)+(s*28|0)+8>>2]=E;s=0;do{z=s;s=z+1|0;}while((a[E+z|0]|0)!=0);E=l+168|0;c[E>>2]=(c[E>>2]|0)+s;if((c[o+128>>2]|0)==0){break}h=0}else if((r|0)==334){r=0;if((a[l+160|0]|0)==0){break}if((c[o+128>>2]|0)!=0){h=0}E=l+180|0;c[E>>2]=(c[E>>2]|0)+ -1;c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]|0)*28|0)+4>>2]=G;if((c[l+180>>2]|0)!=0){break}if(!(h<<24>>24!=0)){E=Lj(o)|0;if((E|0)==0){r=340;break a}c[q>>2]=e;ue[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,E)}a[l+160|0]=0;c[l+168>>2]=0}}while(0);do{if((r|0)==47){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}E=xj(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=50;break a}yj(E);c[(c[o+316>>2]|0)+24>>2]=E;c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}}while(0);do{if((h&255|0)!=0){if((c[o+80>>2]|0)==0){break}jj(o,b,e,c[n>>2]|0)}}while(0);h=c[o+480>>2]|0;if((h|0)==3){r=367;break}else if((h|0)==2){r=368;break}e=c[n>>2]|0;g=xe[c[b>>2]&63](b,e,f,n)|0}if((r|0)==7){c[j>>2]=e;I=0;J=I;i=m;return J|0}else if((r|0)==9){c[p>>2]=c[n>>2];I=4;J=I;i=m;return J|0}else if((r|0)==10){I=5;J=I;i=m;return J|0}else if((r|0)==11){I=6;J=I;i=m;return J|0}else if((r|0)==13){do{if((b|0)!=(c[o+144>>2]|0)){if((a[(c[o+300>>2]|0)+20|0]|0)!=0){break}c[j>>2]=e;I=0;J=I;i=m;return J|0}}while(0);do{if((d[o+488|0]|0)==0){if((b|0)!=(c[o+144>>2]|0)){break}I=3;J=I;i=m;return J|0}}while(0);if((oe[c[o+256>>2]&63](o+256|0,-4,f,f,b)|0)==-1){I=29;J=I;i=m;return J|0}else{c[j>>2]=e;I=0;J=I;i=m;return J|0}}else if((r|0)==25){I=t;J=I;i=m;return J|0}else if((r|0)==29){I=1;J=I;i=m;return J|0}else if((r|0)==35){I=v;J=I;i=m;return J|0}else if((r|0)==38){I=1;J=I;i=m;return J|0}else if((r|0)==41){I=32;J=I;i=m;return J|0}else if((r|0)==43){I=1;J=I;i=m;return J|0}else if((r|0)==46){I=32;J=I;i=m;return J|0}else if((r|0)==50){I=1;J=I;i=m;return J|0}else if((r|0)==60){I=1;J=I;i=m;return J|0}else if((r|0)==64){I=21;J=I;i=m;return J|0}else if((r|0)==69){I=22;J=I;i=m;return J|0}else if((r|0)==75){do{if((a[o+489|0]|0)!=0){v=a[l+129|0]|0;a[l+129|0]=1;if((c[o+492>>2]|0)==0){break}if((c[o+112>>2]|0)==0){break}t=oj(o,l+132|0,12640,36)|0;if((t|0)==0){I=1;J=I;i=m;return J|0}c[t+20>>2]=c[o+360>>2];a[l+131|0]=0;if((oe[c[o+112>>2]&63](c[o+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)==0){I=21;J=I;i=m;return J|0}if((a[l+131|0]|0)==0){a[l+129|0]=v;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if(($d[c[o+108>>2]&127](c[o+4>>2]|0)|0)!=0){break}I=22;J=I;i=m;return J|0}}while(0);c[o+280>>2]=38;I=zj(o,e,f,j)|0;J=I;i=m;return J|0}else if((r|0)==90){I=1;J=I;i=m;return J|0}else if((r|0)==92){I=1;J=I;i=m;return J|0}else if((r|0)==111){I=1;J=I;i=m;return J|0}else if((r|0)==113){I=1;J=I;i=m;return J|0}else if((r|0)==117){I=1;J=I;i=m;return J|0}else if((r|0)==128){I=1;J=I;i=m;return J|0}else if((r|0)==132){I=y;J=I;i=m;return J|0}else if((r|0)==134){I=1;J=I;i=m;return J|0}else if((r|0)==145){I=1;J=I;i=m;return J|0}else if((r|0)==153){I=A;J=I;i=m;return J|0}else if((r|0)==156){I=1;J=I;i=m;return J|0}else if((r|0)==163){I=22;J=I;i=m;return J|0}else if((r|0)==166){I=1;J=I;i=m;return J|0}else if((r|0)==171){I=1;J=I;i=m;return J|0}else if((r|0)==181){I=1;J=I;i=m;return J|0}else if((r|0)==190){I=1;J=I;i=m;return J|0}else if((r|0)==192){I=1;J=I;i=m;return J|0}else if((r|0)==202){I=1;J=I;i=m;return J|0}else if((r|0)==204){I=1;J=I;i=m;return J|0}else if((r|0)==214){I=1;J=I;i=m;return J|0}else if((r|0)==217){I=32;J=I;i=m;return J|0}else if((r|0)==220){I=1;J=I;i=m;return J|0}else if((r|0)==225){I=1;J=I;i=m;return J|0}else if((r|0)==232){A=g;if((A|0)==28){I=10;J=I;i=m;return J|0}else if((A|0)==12){I=17;J=I;i=m;return J|0}else{I=2;J=I;i=m;return J|0}}else if((r|0)==239){I=D;J=I;i=m;return J|0}else if((r|0)==241){c[o+280>>2]=39;I=D;J=I;i=m;return J|0}else if((r|0)==245){I=1;J=I;i=m;return J|0}else if((r|0)==248){I=1;J=I;i=m;return J|0}else if((r|0)==251){I=1;J=I;i=m;return J|0}else if((r|0)==254){I=1;J=I;i=m;return J|0}else if((r|0)==258){I=2;J=I;i=m;return J|0}else if((r|0)==263){I=2;J=I;i=m;return J|0}else if((r|0)==273){I=1;J=I;i=m;return J|0}else if((r|0)==279){I=11;J=I;i=m;return J|0}else if((r|0)==281){I=24;J=I;i=m;return J|0}else if((r|0)==287){I=12;J=I;i=m;return J|0}else if((r|0)==290){I=F;J=I;i=m;return J|0}else if((r|0)==294){I=21;J=I;i=m;return J|0}else if((r|0)==301){I=22;J=I;i=m;return J|0}else if((r|0)==304){I=1;J=I;i=m;return J|0}else if((r|0)==309){I=1;J=I;i=m;return J|0}else if((r|0)==323){I=1;J=I;i=m;return J|0}else if((r|0)==325){I=1;J=I;i=m;return J|0}else if((r|0)==340){I=1;J=I;i=m;return J|0}else if((r|0)==344){I=1;J=I;i=m;return J|0}else if((r|0)==347){I=1;J=I;i=m;return J|0}else if((r|0)==367){c[j>>2]=c[n>>2];I=0;J=I;i=m;return J|0}else if((r|0)==368){I=35;J=I;i=m;return J|0}return 0}function wj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+104|0;h=g+40|0;j=g+56|0;k=g+64|0;l=g+72|0;m=g+88|0;n=b;b=d;d=e;e=f;c[h>>2]=0;f=0;c[j>>2]=0;c[k>>2]=0;o=0;c[m>>2]=-1;p=(b|0)!=0;if((_d[((a[n+236|0]&255|0)!=0?1:2)&7](b,c[n+144>>2]|0,d,e,n+288|0,k,l,h,j,m)|0)==0){if(p){q=31;r=q;i=g;return r|0}else{q=30;r=q;i=g;return r|0}}do{if(!p){if((c[m>>2]|0)!=1){break}a[(c[n+356>>2]|0)+130|0]=1;if((c[n+492>>2]|0)!=1){break}c[n+492>>2]=0}}while(0);do{if((c[n+140>>2]|0)!=0){do{if((c[h>>2]|0)!=0){p=c[n+144>>2]|0;b=c[h>>2]|0;s=c[h>>2]|0;f=xj(n+440|0,p,b,s+(ne[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){c[n+456>>2]=c[n+452>>2];break}q=1;r=q;i=g;return r|0}}while(0);do{if((c[k>>2]|0)!=0){o=xj(n+440|0,c[n+144>>2]|0,c[k>>2]|0,(c[l>>2]|0)+(0-(c[(c[n+144>>2]|0)+68>>2]|0))|0)|0;if((o|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);ye[c[n+140>>2]&31](c[n+4>>2]|0,o,f,c[m>>2]|0)}else{if((c[n+80>>2]|0)==0){break}jj(n,c[n+144>>2]|0,d,e)}}while(0);do{if((c[n+232>>2]|0)==0){if((c[j>>2]|0)!=0){if((c[(c[j>>2]|0)+68>>2]|0)==(c[(c[n+144>>2]|0)+68>>2]|0)){c[n+144>>2]=c[j>>2];break}c[n+288>>2]=c[h>>2];q=19;r=q;i=g;return r|0}if((c[h>>2]|0)==0){break}do{if((f|0)==0){e=c[n+144>>2]|0;d=c[h>>2]|0;m=c[h>>2]|0;f=xj(n+440|0,e,d,m+(ne[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);m=$j(n,f)|0;Ui(n+440|0);if((m|0)==18){c[n+288>>2]=c[h>>2]}q=m;r=q;i=g;return r|0}}while(0);if((f|0)!=0){t=34}else{if((o|0)!=0){t=34}}if((t|0)==34){Ui(n+440|0)}q=0;r=q;i=g;return r|0}function xj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+40|0;h=b;if((Dj(h,d,e,f)|0)==0){j=0;k=j;i=g;return k|0}do{if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if((lj(h)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);f=h+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e]=0;j=c[h+16>>2]|0;k=j;i=g;return k|0}function yj(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;i=i+24|0;d=b;b=d;e=d;while(1){if((a[e]|0)==0){break}f=a[e]|0;do{if((f|0)==10|(f|0)==13|(f|0)==32){if((b|0)==(d|0)){break}if((a[b+ -1|0]|0)==32){break}g=b;b=g+1|0;a[g]=32}else{g=b;b=g+1|0;a[g]=a[e]|0}}while(0);e=e+1|0}if((b|0)==(d|0)){h=b;a[h]=0;i=c;return}if((a[b+ -1|0]|0)!=32){h=b;a[h]=0;i=c;return}b=b+ -1|0;h=b;a[h]=0;i=c;return}function zj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=Qj(h,0,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((Yj(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function Aj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=c[g+356>>2]|0;h=xj(a+80|0,b,d,e)|0;if((h|0)==0){j=0;k=j;i=f;return k|0}e=oj(g,a+20|0,h,24)|0;if((e|0)==0){j=0;k=j;i=f;return k|0}d=a+80|0;do{if((c[e>>2]|0)!=(h|0)){c[a+92>>2]=c[d+16>>2]}else{c[a+96>>2]=c[d+12>>2];if((Zj(g,e)|0)!=0){break}j=0;k=j;i=f;return k|0}}while(0);j=e;k=j;i=f;return k|0}function Bj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=b;b=d;d=e;e=f;f=c[h+356>>2]|0;do{if((c[f+92>>2]|0)==(c[f+88>>2]|0)){if((lj(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m]=0;m=xj(f+80|0,b,d,e)|0;if((m|0)==0){j=0;k=j;i=g;return k|0}m=m+1|0;e=oj(h,f+40|0,m,12)|0;if((e|0)==0){j=0;k=j;i=g;return k|0}d=f+80|0;a:do{if((c[e>>2]|0)!=(m|0)){c[f+92>>2]=c[d+16>>2]}else{c[f+96>>2]=c[d+12>>2];if((a[h+236|0]|0)==0){break}do{if((a[m]|0)==120){if((a[m+1|0]|0)!=109){break}if((a[m+2|0]|0)!=108){break}if((a[m+3|0]|0)!=110){break}if((a[m+4|0]|0)!=115){break}if((a[m+5|0]|0)!=0){if((a[m+5|0]|0)!=58){break}}if((a[m+5|0]|0)==0){c[e+4>>2]=f+152}else{c[e+4>>2]=oj(h,f+60|0,m+6|0,8)|0}a[e+9|0]=1;break a}}while(0);b=0;while(1){if((a[m+b|0]|0)==0){break a}if((a[m+b|0]|0)==58){break}b=b+1|0}l=0;while(1){n=(c[f+92>>2]|0)==(c[f+88>>2]|0);if((l|0)>=(b|0)){break}if(n){if(!((lj(f+80|0)|0)<<24>>24!=0)){o=30;break}}p=a[m+l|0]|0;q=f+92|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;l=l+1|0}if((o|0)==30){j=0;k=j;i=g;return k|0}do{if(n){if((lj(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;b=c[l>>2]|0;c[l>>2]=b+1;a[b]=0;c[e+4>>2]=oj(h,f+60|0,c[f+96>>2]|0,8)|0;b=f+80|0;if((c[c[e+4>>2]>>2]|0)==(c[f+96>>2]|0)){c[f+96>>2]=c[b+12>>2];break}else{c[f+92>>2]=c[b+16>>2];break}}}while(0);j=e;k=j;i=g;return k|0}function Cj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=b;b=d;while(1){g=f;if((a[b]|0)==0){h=7;break}if((c[g+12>>2]|0)==(c[f+8>>2]|0)){if(!((lj(f)|0)<<24>>24!=0)){h=6;break}}d=a[b]|0;j=f+12|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k]=d;b=b+1|0}if((h|0)==6){l=0;m=l;i=e;return m|0}else if((h|0)==7){l=c[g+16>>2]|0;m=l;i=e;return m|0}return 0}function Dj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=f+24|0;h=a;a=b;c[g>>2]=d;d=e;do{if((c[h+12>>2]|0)==0){if((lj(h)|0)<<24>>24!=0){break}j=0;k=j;i=f;return k|0}}while(0);while(1){Vd[c[a+60>>2]&31](a,g,d,h+12|0,c[h+8>>2]|0);l=h;if((c[g>>2]|0)==(d|0)){m=7;break}if(!((lj(l)|0)<<24>>24!=0)){m=6;break}}if((m|0)==6){j=0;k=j;i=f;return k|0}else if((m|0)==7){j=c[l+16>>2]|0;k=j;i=f;return k|0}return 0}function Ej(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+88|0;k=b;b=d;d=e;e=f;f=g;g=h;if((f|0)!=0){l=3}else{if((e&255|0)!=0){l=3}}do{if((l|0)==3){h=0;while(1){if((h|0)>=(c[k+12>>2]|0)){break}if((b|0)==(c[(c[k+20>>2]|0)+(h*12|0)>>2]|0)){l=6;break}h=h+1|0}if((l|0)==6){m=1;n=m;i=j;return n|0}if((e&255|0)==0){break}if((c[k+8>>2]|0)!=0){break}if((a[b+9|0]|0)!=0){break}c[k+8>>2]=b}}while(0);do{if((c[k+12>>2]|0)==(c[k+16>>2]|0)){e=k+16|0;if((c[k+16>>2]|0)==0){c[e>>2]=8;c[k+20>>2]=$d[c[g+12>>2]&127]((c[k+16>>2]|0)*12|0)|0;if((c[k+20>>2]|0)!=0){break}m=0;n=m;i=j;return n|0}l=c[e>>2]<<1;e=ne[c[g+16>>2]&63](c[k+20>>2]|0,l*12|0)|0;if((e|0)!=0){c[k+16>>2]=l;c[k+20>>2]=e;break}m=0;n=m;i=j;return n|0}}while(0);g=(c[k+20>>2]|0)+((c[k+12>>2]|0)*12|0)|0;c[g>>2]=b;c[g+8>>2]=f;a[g+4|0]=d;if(!(d<<24>>24!=0)){a[b+8|0]=1}b=k+12|0;c[b>>2]=(c[b>>2]|0)+1;m=1;n=m;i=j;return n|0}function Fj(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+64|0;k=e;e=h;h=_j(b,d,k,f,g,e)|0;if((h|0)!=0){l=h;m=l;i=j;return m|0}do{if(!(k<<24>>24!=0)){if(((c[e+12>>2]|0)-(c[e+16>>2]|0)|0)==0){break}if((a[(c[e+12>>2]|0)+ -1|0]|0)!=32){break}h=e+12|0;c[h>>2]=(c[h>>2]|0)+ -1}}while(0);do{if((c[e+12>>2]|0)==(c[e+8>>2]|0)){if((lj(e)|0)<<24>>24!=0){break}l=1;m=l;i=j;return m|0}}while(0);k=e+12|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e]=0;l=0;m=l;i=j;return m|0}function Gj(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+128|0;j=h+72|0;k=h+104|0;l=b;b=e;e=f;f=g;g=c[l+356>>2]|0;m=g+104|0;n=0;o=c[l+276>>2]|0;c[l+276>>2]=1;do{if((c[m>>2]|0)==0){if((lj(m)|0)<<24>>24!=0){break}p=1;q=p;i=h;return q|0}}while(0);a:while(1){b:do{switch(xe[c[b+20>>2]&63](b,e,f,j)|0){case 0:{r=49;break a;break};case 28:{if((d[l+488|0]|0)==0){if((b|0)==(c[l+144>>2]|0)){r=23;break a}}s=xj(l+416|0,b,e+(c[b+68>>2]|0)|0,(c[j>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((s|0)==0){r=8;break a}t=oj(l,g+132|0,s,0)|0;c[l+428>>2]=c[l+432>>2];if((t|0)==0){r=10;break a}if((a[t+32|0]|0)!=0){r=12;break a}if((c[t+16>>2]|0)==0){a[t+32|0]=1;n=Gj(l,c[l+228>>2]|0,c[t+4>>2]|0,(c[t+4>>2]|0)+(c[t+8>>2]|0)|0)|0;a[t+32|0]=0;if((n|0)!=0){break a}else{break b}}s=g;if((c[l+112>>2]|0)==0){a[g+128|0]=a[s+130|0]|0;break b}a[s+131|0]=0;a[t+32|0]=1;s=(oe[c[l+112>>2]&63](c[l+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)!=0;a[t+32|0]=0;if(!s){r=18;break a}if((a[g+131|0]|0)!=0){break b}a[g+128|0]=a[g+130|0]|0;break};case 6:case 9:{if((Dj(m,b,e,c[j>>2]|0)|0)==0){r=26;break a}break};case-1:{r=46;break a;break};case-4:{r=24;break a;break};case 10:{s=ne[c[b+44>>2]&63](b,e)|0;if((s|0)<0){r=33;break a}s=fk(s,k)|0;if((s|0)==0){r=37;break a}t=0;while(1){if((t|0)>=(s|0)){break b}if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((lj(m)|0)<<24>>24!=0)){r=44;break a}}u=a[k+t|0]|0;v=m+12|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=u;t=t+1|0}break};case-3:{c[j>>2]=e+(c[b+68>>2]|0);r=28;break};case 7:{r=28;break};default:{r=52;break a}}}while(0);if((r|0)==28){r=0;if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((lj(m)|0)<<24>>24!=0)){r=30;break}}t=m+12|0;s=c[t>>2]|0;c[t>>2]=s+1;a[s]=10}e=c[j>>2]|0}if((r|0)==8){n=1}else if((r|0)==10){a[g+128|0]=a[g+130|0]|0}else if((r|0)==12){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=12}else if((r|0)==18){n=21}else if((r|0)==23){c[l+288>>2]=e;n=10}else if((r|0)==24){n=0}else if((r|0)==26){n=1}else if((r|0)==30){n=1}else if((r|0)==33){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==37){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==44){n=1}else if((r|0)==46){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=4}else if((r|0)==49){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=c[j>>2]}n=4}else if((r|0)==52){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=23}c[l+276>>2]=o;p=n;q=p;i=h;return q|0}function Hj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+96|0;j=h+56|0;k=a;a=b;b=d;d=f;f=g;g=c[b>>2]|0;l=k;if((a|0)==(c[k+144>>2]|0)){m=l+288|0;c[m>>2]=g;n=k+292|0}else{m=c[l+300>>2]|0;n=(c[k+300>>2]|0)+4|0}c[m>>2]=g;c[b>>2]=0;l=xe[c[a+12>>2]&63](a,g,e,j)|0;c[n>>2]=c[j>>2];switch(l|0){case 0:{c[m>>2]=c[j>>2];o=4;p=o;i=h;return p|0};case-4:case-1:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=2;p=o;i=h;return p|0}break};case 42:{if((c[k+80>>2]|0)!=0){jj(k,a,g,c[j>>2]|0)}c[b>>2]=c[j>>2];c[d>>2]=c[j>>2];if((c[k+480>>2]|0)==2){o=35;p=o;i=h;return p|0}else{o=0;p=o;i=h;return p|0}break};case-2:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=6;p=o;i=h;return p|0}break};default:{c[m>>2]=c[j>>2];o=23;p=o;i=h;return p|0}}return 0}function Ij(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=Hj(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)!=0){c[j+280>>2]=40;k=uj(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{k=f;l=k;i=g;return l|0}return 0}function Jj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;a=c[d+356>>2]|0;do{if((c[a+184>>2]|0)==0){c[a+184>>2]=$d[c[d+12>>2]&127](c[d+468>>2]<<2)|0;if((c[a+184>>2]|0)!=0){c[c[a+184>>2]>>2]=0;break}e=-1;f=e;i=b;return f|0}}while(0);if((c[a+176>>2]|0)>>>0>=(c[a+172>>2]|0)>>>0){g=d+12|0;do{if((c[a+164>>2]|0)!=0){h=ne[c[g+4>>2]&63](c[a+164>>2]|0,(c[a+172>>2]<<1)*28|0)|0;if((h|0)!=0){d=a+172|0;c[d>>2]=c[d>>2]<<1;break}e=-1;f=e;i=b;return f|0}else{h=$d[c[g>>2]&127](896)|0;if((h|0)!=0){c[a+172>>2]=32;break}e=-1;f=e;i=b;return f|0}}while(0);c[a+164>>2]=h}h=a+176|0;g=c[h>>2]|0;c[h>>2]=g+1;h=g;g=(c[a+164>>2]|0)+(h*28|0)|0;if((c[a+180>>2]|0)!=0){d=(c[a+164>>2]|0)+((c[(c[a+184>>2]|0)+((c[a+180>>2]|0)-1<<2)>>2]|0)*28|0)|0;if((c[d+16>>2]|0)!=0){c[(c[a+164>>2]|0)+((c[d+16>>2]|0)*28|0)+24>>2]=h}if((c[d+20>>2]|0)==0){c[d+12>>2]=h}c[d+16>>2]=h;a=d+20|0;c[a>>2]=(c[a>>2]|0)+1}c[g+24>>2]=0;c[g+20>>2]=0;c[g+16>>2]=0;c[g+12>>2]=0;e=h;f=e;i=b;return f|0}function Kj(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+80|0;g=f+48|0;h=b;b=d;d=e;e=h;do{if((c[h+304>>2]|0)!=0){j=c[e+304>>2]|0;c[h+304>>2]=c[j+8>>2]}else{j=$d[c[e+12>>2]&127](24)|0;if((j|0)!=0){break}k=1;l=k;i=f;return l|0}}while(0);a[b+32|0]=1;c[b+12>>2]=0;c[j+8>>2]=c[h+300>>2];c[h+300>>2]=j;c[j+12>>2]=b;c[j+16>>2]=c[h+312>>2];a[j+20|0]=d;c[j>>2]=0;c[j+4>>2]=0;d=c[b+4>>2]|0;e=(c[b+4>>2]|0)+(c[b+8>>2]|0)|0;m=h;if((a[b+33|0]|0)!=0){n=xe[c[c[m+228>>2]>>2]&63](c[h+228>>2]|0,d,e,g)|0;o=vj(h,c[h+228>>2]|0,d,e,n,c[g>>2]|0,g,0)|0}else{o=Qj(m,c[h+312>>2]|0,c[h+228>>2]|0,d,e,g,0)|0}a:do{if((o|0)==0){do{if((e|0)!=(c[g>>2]|0)){if((c[h+480>>2]|0)!=3){break}c[b+12>>2]=(c[g>>2]|0)-d;c[h+280>>2]=41;break a}}while(0);a[b+32|0]=0;c[h+300>>2]=c[j+8>>2];c[j+8>>2]=c[h+304>>2];c[h+304>>2]=j}}while(0);k=o;l=k;i=f;return l|0}function Lj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+56|0;d=b+32|0;e=b+40|0;f=a;a=c[f+356>>2]|0;g=$d[c[f+12>>2]&127](((c[a+176>>2]|0)*20|0)+(c[a+168>>2]|0)|0)|0;if((g|0)!=0){c[e>>2]=g+((c[a+176>>2]|0)*20|0);c[d>>2]=g+20;Pj(f,0,g,d,e);h=g;j=h;i=b;return j|0}else{h=0;j=h;i=b;return j|0}return 0}function Mj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=b;b=d;d=e;if((c[g+64>>2]|0)==0){if((c[g+80>>2]|0)!=0){jj(g,a,b,d)}h=1;j=h;i=f;return j|0}b=b+(c[a+68>>2]<<1)|0;e=b+(ne[c[a+32>>2]&63](a,b)|0)|0;k=xj(g+416|0,a,b,e)|0;if((k|0)==0){h=0;j=h;i=f;return j|0}c[g+432>>2]=c[g+428>>2];b=ne[c[a+36>>2]&63](a,e)|0;e=xj(g+416|0,a,b,d+(0-(c[a+68>>2]<<1))|0)|0;if((e|0)!=0){Oj(e);ue[c[g+64>>2]&15](c[g+4>>2]|0,k,e);Ui(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function Nj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=a;a=b;b=d;d=e;e=g;if((c[g+68>>2]|0)==0){if((c[e+80>>2]|0)!=0){jj(g,a,b,d)}h=1;j=h;i=f;return j|0}k=xj(e+416|0,a,b+(c[a+68>>2]<<2)|0,d+(0-((c[a+68>>2]|0)*3|0))|0)|0;if((k|0)!=0){Oj(k);Zd[c[g+68>>2]&63](c[g+4>>2]|0,k);Ui(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function Oj(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=b;while(1){if((a[d]|0)==0){e=12;break}f=d;if((a[d]|0)==13){break}d=f+1|0}if((e|0)==12){i=c;return}e=f;do{do{if((a[d]|0)==13){f=e;e=f+1|0;a[f]=10;f=d+1|0;d=f;if((a[f]|0)!=10){break}d=d+1|0}else{f=d;d=f+1|0;b=e;e=b+1|0;a[b]=a[f]|0}}while(0);}while((a[d]|0)!=0);a[e]=0;i=c;return}function Pj(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+72|0;j=b;b=d;d=e;e=f;f=g;g=c[j+356>>2]|0;c[d>>2]=c[(c[g+164>>2]|0)+(b*28|0)>>2];c[d+4>>2]=c[(c[g+164>>2]|0)+(b*28|0)+4>>2];if((c[d>>2]|0)==4){c[d+8>>2]=c[f>>2];k=c[(c[g+164>>2]|0)+(b*28|0)+8>>2]|0;while(1){l=a[k]|0;m=f;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;if((a[k]|0)==0){break}k=k+1|0}c[d+12>>2]=0;c[d+16>>2]=0;i=h;return}else{c[d+12>>2]=c[(c[g+164>>2]|0)+(b*28|0)+20>>2];c[d+16>>2]=c[e>>2];k=e;c[k>>2]=(c[k>>2]|0)+((c[d+12>>2]|0)*20|0);k=0;l=c[(c[g+164>>2]|0)+(b*28|0)+12>>2]|0;while(1){if(!(k>>>0<(c[d+12>>2]|0)>>>0)){break}Pj(j,l,(c[d+16>>2]|0)+(k*20|0)|0,e,f);k=k+1|0;l=c[(c[g+164>>2]|0)+(l*28|0)+24>>2]|0}c[d+8>>2]=0;i=h;return}}function Qj(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;l=i;i=i+392|0;m=l+32|0;n=l+88|0;o=l+104|0;p=l+128|0;q=l+168|0;r=l+184|0;s=l+232|0;t=l+248|0;u=l+344|0;v=l+352|0;w=l+368|0;x=l+384|0;y=b;b=e;e=f;c[m>>2]=g;g=h;h=j;j=k;k=c[y+356>>2]|0;f=y;if((e|0)==(c[y+144>>2]|0)){z=f+288|0;A=y+292|0}else{z=c[f+300>>2]|0;A=(c[y+300>>2]|0)+4|0}c[z>>2]=c[m>>2];a:while(1){c[n>>2]=c[m>>2];f=xe[c[e+4>>2]&63](e,c[m>>2]|0,g,n)|0;c[A>>2]=c[n>>2];b:do{switch(f|0){case-2:{B=28;break a;break};case-3:{B=6;break a;break};case 9:{a[p]=be[c[e+48>>2]&63](e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((a[p]|0)!=0){C=y;if((c[y+60>>2]|0)!=0){ue[c[C+60>>2]&15](c[y+4>>2]|0,p,1);break b}if((c[C+80>>2]|0)==0){break b}jj(y,e,c[m>>2]|0,c[n>>2]|0);break b}C=xj(k+80|0,e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((C|0)==0){B=37;break a}D=oj(y,k,C,0)|0;c[k+92>>2]=c[k+96>>2];do{if((a[k+129|0]|0)!=0){if((d[k+130|0]|0)!=0){B=40;break}if((D|0)!=0){break}E=y;if((c[y+120>>2]|0)!=0){ue[c[E+120>>2]&15](c[y+4>>2]|0,C,0);break b}if((c[E+80>>2]|0)==0){break b}jj(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{B=40}}while(0);if((B|0)==40){B=0;if((D|0)==0){B=41;break a}if((a[D+34|0]|0)==0){B=43;break a}}if((a[D+32|0]|0)!=0){B=50;break a}if((c[D+28>>2]|0)!=0){B=52;break a}C=y;if((c[D+4>>2]|0)!=0){E=y;if((a[C+308|0]|0)!=0){F=Kj(E,D,0)|0;if((F|0)!=0){B=60;break a}else{break b}}G=y;if((c[E+120>>2]|0)!=0){ue[c[G+120>>2]&15](c[y+4>>2]|0,c[D>>2]|0,0);break b}if((c[G+80>>2]|0)==0){break b}jj(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{if((c[C+112>>2]|0)==0){if((c[y+80>>2]|0)==0){break b}jj(y,e,c[m>>2]|0,c[n>>2]|0);break b}a[D+32|0]=1;C=Sj(y)|0;a[D+32|0]=0;if((C|0)==0){B=63;break a}if((oe[c[y+112>>2]&63](c[y+116>>2]|0,C,c[D+20>>2]|0,c[D+16>>2]|0,c[D+24>>2]|0)|0)==0){B=65;break a}c[y+428>>2]=c[y+432>>2];break b}break};case-4:{B=17;break a;break};case 5:{if((c[y+312>>2]|0)==(b|0)){B=109;break a}C=c[y+364>>2]|0;c[y+364>>2]=c[C>>2];c[C>>2]=c[y+368>>2];c[y+368>>2]=C;H=(c[m>>2]|0)+(c[e+68>>2]<<1)|0;G=ne[c[e+32>>2]&63](e,H)|0;if((G|0)!=(c[C+8>>2]|0)){B=112;break a}if((zS(c[C+4>>2]|0,H,G)|0)!=0){B=112;break a}G=y+312|0;c[G>>2]=(c[G>>2]|0)+ -1;do{if((c[y+56>>2]|0)!=0){G=c[C+16>>2]|0;do{if((d[y+236|0]|0)!=0){if((G|0)==0){break}E=(c[C+12>>2]|0)+(c[C+28>>2]|0)|0;while(1){if((a[G]|0)==0){break}I=G;G=I+1|0;J=E;E=J+1|0;a[J]=a[I]|0}I=c[C+20>>2]|0;c:do{if((d[y+237|0]|0)!=0){if((I|0)==0){break}J=E;E=J+1|0;a[J]=a[y+472|0]|0;while(1){if((a[I]|0)==0){break c}J=I;I=J+1|0;K=E;E=K+1|0;a[K]=a[J]|0}}}while(0);a[E]=0}}while(0);Zd[c[y+56>>2]&63](c[y+4>>2]|0,c[C+12>>2]|0)}else{if((c[y+80>>2]|0)==0){break}jj(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);while(1){if((c[C+44>>2]|0)==0){break}D=c[C+44>>2]|0;if((c[y+104>>2]|0)!=0){Zd[c[y+104>>2]&63](c[y+4>>2]|0,c[c[D>>2]>>2]|0)}c[C+44>>2]=c[(c[C+44>>2]|0)+4>>2];c[D+4>>2]=c[y+376>>2];c[y+376>>2]=D;c[(c[D>>2]|0)+4>>2]=c[D+8>>2]}if((c[y+312>>2]|0)==0){B=133;break a}break};case 12:{B=140;break a;break};case 7:{if((c[y+60>>2]|0)!=0){a[v]=10;ue[c[y+60>>2]&15](c[y+4>>2]|0,v,1);break b}if((c[y+80>>2]|0)==0){break b}jj(y,e,c[m>>2]|0,c[n>>2]|0);break};case 10:{C=ne[c[e+44>>2]&63](e,c[m>>2]|0)|0;if((C|0)<0){B=135;break a}D=y;if((c[y+60>>2]|0)!=0){G=c[D+60>>2]|0;I=c[y+4>>2]|0;J=fk(C,u)|0;ue[G&15](I,u,J);break b}if((c[D+80>>2]|0)==0){break b}jj(y,e,c[m>>2]|0,c[n>>2]|0);break};case 8:{D=y;do{if((c[y+72>>2]|0)!=0){Yd[c[D+72>>2]&255](c[y+4>>2]|0)}else{if((c[D+80>>2]|0)==0){break}jj(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);L=Vj(y,e,n,g,h,j)|0;if((L|0)!=0){B=150;break a}if((c[n>>2]|0)==0){B=152;break a}break};case-5:{B=153;break a;break};case 6:{D=c[y+60>>2]|0;if((D|0)==0){if((c[y+80>>2]|0)==0){break b}jj(y,e,c[m>>2]|0,c[n>>2]|0);break b}if((a[e+72|0]|0)!=0){ue[D&15](c[y+4>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0);break b}while(1){c[x>>2]=c[y+44>>2];Vd[c[e+60>>2]&31](e,m,c[n>>2]|0,x,c[y+48>>2]|0);c[A>>2]=c[m>>2];ue[D&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[x>>2]|0)-(c[y+44>>2]|0)|0);if((c[m>>2]|0)==(c[n>>2]|0)){break b}c[z>>2]=c[m>>2]}break};case 11:{if((Mj(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=174;break a}break};case 13:{if((Nj(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=176;break a}break};case 1:case 2:{D=y;if((c[y+368>>2]|0)!=0){M=c[D+368>>2]|0;c[y+368>>2]=c[c[y+368>>2]>>2]}else{M=$d[c[D+12>>2]&127](48)|0;if((M|0)==0){B=72;break a}c[M+36>>2]=$d[c[y+12>>2]&127](32)|0;if((c[M+36>>2]|0)==0){B=74;break a}c[M+40>>2]=(c[M+36>>2]|0)+32}c[M+44>>2]=0;c[M>>2]=c[y+364>>2];c[y+364>>2]=M;c[M+16>>2]=0;c[M+20>>2]=0;c[M+4>>2]=(c[m>>2]|0)+(c[e+68>>2]|0);c[M+8>>2]=ne[c[e+32>>2]&63](e,c[M+4>>2]|0)|0;D=y+312|0;c[D>>2]=(c[D>>2]|0)+1;D=(c[M+4>>2]|0)+(c[M+8>>2]|0)|0;c[r>>2]=c[M+4>>2];c[q>>2]=c[M+36>>2];while(1){Vd[c[e+60>>2]&31](e,r,D,q,(c[M+40>>2]|0)+ -1|0);N=(c[q>>2]|0)-(c[M+36>>2]|0)|0;if((c[r>>2]|0)==(D|0)){break}J=(c[M+40>>2]|0)-(c[M+36>>2]|0)<<1;I=ne[c[y+16>>2]&63](c[M+36>>2]|0,J)|0;if((I|0)==0){B=80;break a}c[M+36>>2]=I;c[M+40>>2]=I+J;c[q>>2]=I+N}c[M+24>>2]=N;c[M+12>>2]=c[M+36>>2];a[c[q>>2]|0]=0;O=Tj(y,e,c[m>>2]|0,M+12|0,M+44|0)|0;if((O|0)!=0){B=82;break a}D=y;do{if((c[y+52>>2]|0)!=0){ue[c[D+52>>2]&15](c[y+4>>2]|0,c[M+12>>2]|0,c[y+392>>2]|0)}else{if((c[D+80>>2]|0)==0){break}jj(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);Ui(y+416|0);break};case 3:case 4:{D=(c[m>>2]|0)+(c[e+68>>2]|0)|0;c[s>>2]=0;I=1;c[t>>2]=xj(y+416|0,e,D,D+(ne[c[e+32>>2]&63](e,D)|0)|0)|0;if((c[t>>2]|0)==0){B=89;break a}c[y+432>>2]=c[y+428>>2];P=Tj(y,e,c[m>>2]|0,t,s)|0;if((P|0)!=0){B=91;break a}c[y+432>>2]=c[y+428>>2];if((c[y+52>>2]|0)!=0){ue[c[y+52>>2]&15](c[y+4>>2]|0,c[t>>2]|0,c[y+392>>2]|0);I=0}if((c[y+56>>2]|0)!=0){if((c[y+52>>2]|0)!=0){c[z>>2]=c[A>>2]}Zd[c[y+56>>2]&63](c[y+4>>2]|0,c[t>>2]|0);I=0}do{if((I&255|0)!=0){if((c[y+80>>2]|0)==0){break}jj(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);Ui(y+416|0);while(1){if((c[s>>2]|0)==0){break}I=c[s>>2]|0;if((c[y+104>>2]|0)!=0){Zd[c[y+104>>2]&63](c[y+4>>2]|0,c[c[I>>2]>>2]|0)}c[s>>2]=c[(c[s>>2]|0)+4>>2];c[I+4>>2]=c[y+376>>2];c[y+376>>2]=I;c[(c[I>>2]|0)+4>>2]=c[I+8>>2]}if((c[y+312>>2]|0)==0){B=107;break a}break};case 0:{B=24;break a;break};case-1:{B=25;break a;break};default:{if((c[y+80>>2]|0)==0){break b}jj(y,e,c[m>>2]|0,c[n>>2]|0)}}}while(0);f=c[n>>2]|0;c[m>>2]=f;c[z>>2]=f;f=c[y+480>>2]|0;if((f|0)==2){B=181;break}else if((f|0)==3){B=180;break}}if((B|0)==6){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}c[A>>2]=g;do{if((c[y+60>>2]|0)!=0){a[o]=10;ue[c[y+60>>2]&15](c[y+4>>2]|0,o,1)}else{if((c[y+80>>2]|0)==0){break}jj(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){Q=3;R=Q;i=l;return R|0}if((c[y+312>>2]|0)!=(b|0)){Q=13;R=Q;i=l;return R|0}else{c[h>>2]=g;Q=0;R=Q;i=l;return R|0}}else if((B|0)==17){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}if((b|0)<=0){Q=3;R=Q;i=l;return R|0}if((c[y+312>>2]|0)!=(b|0)){Q=13;R=Q;i=l;return R|0}else{c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}}else if((B|0)==24){c[z>>2]=c[n>>2];Q=4;R=Q;i=l;return R|0}else if((B|0)==25){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}else{Q=5;R=Q;i=l;return R|0}}else if((B|0)==28){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}else{Q=6;R=Q;i=l;return R|0}}else if((B|0)==37){Q=1;R=Q;i=l;return R|0}else if((B|0)==41){Q=11;R=Q;i=l;return R|0}else if((B|0)==43){Q=24;R=Q;i=l;return R|0}else if((B|0)==50){Q=12;R=Q;i=l;return R|0}else if((B|0)==52){Q=15;R=Q;i=l;return R|0}else if((B|0)==60){Q=F;R=Q;i=l;return R|0}else if((B|0)==63){Q=1;R=Q;i=l;return R|0}else if((B|0)==65){Q=21;R=Q;i=l;return R|0}else if((B|0)==72){Q=1;R=Q;i=l;return R|0}else if((B|0)==74){Yd[c[y+20>>2]&255](M);Q=1;R=Q;i=l;return R|0}else if((B|0)==80){Q=1;R=Q;i=l;return R|0}else if((B|0)==82){Q=O;R=Q;i=l;return R|0}else if((B|0)==89){Q=1;R=Q;i=l;return R|0}else if((B|0)==91){Q=P;R=Q;i=l;return R|0}else if((B|0)==107){Q=Uj(y,c[n>>2]|0,g,h)|0;R=Q;i=l;return R|0}else if((B|0)==109){Q=13;R=Q;i=l;return R|0}else if((B|0)==112){c[z>>2]=H;Q=7;R=Q;i=l;return R|0}else if((B|0)==133){Q=Uj(y,c[n>>2]|0,g,h)|0;R=Q;i=l;return R|0}else if((B|0)==135){Q=14;R=Q;i=l;return R|0}else if((B|0)==140){Q=17;R=Q;i=l;return R|0}else if((B|0)==150){Q=L;R=Q;i=l;return R|0}else if((B|0)==152){c[y+280>>2]=42;Q=L;R=Q;i=l;return R|0}else if((B|0)==153){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}do{if((c[y+60>>2]|0)!=0){j=y;if((a[e+72|0]|0)!=0){ue[c[j+60>>2]&15](c[y+4>>2]|0,c[m>>2]|0,g-(c[m>>2]|0)|0);break}else{c[w>>2]=c[j+44>>2];Vd[c[e+60>>2]&31](e,m,g,w,c[y+48>>2]|0);ue[c[y+60>>2]&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[w>>2]|0)-(c[y+44>>2]|0)|0);break}}else{if((c[y+80>>2]|0)==0){break}jj(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){c[z>>2]=g;Q=3;R=Q;i=l;return R|0}m=g;if((c[y+312>>2]|0)!=(b|0)){c[z>>2]=m;Q=13;R=Q;i=l;return R|0}else{c[h>>2]=m;Q=0;R=Q;i=l;return R|0}}else if((B|0)==174){Q=1;R=Q;i=l;return R|0}else if((B|0)==176){Q=1;R=Q;i=l;return R|0}else if((B|0)==180){c[h>>2]=c[n>>2];Q=0;R=Q;i=l;return R|0}else if((B|0)==181){Q=35;R=Q;i=l;return R|0}return 0}function Rj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+104|0;h=g+64|0;j=b;b=d;d=e;e=f;f=c[j+300>>2]|0;if((f|0)==0){k=23;l=k;i=g;return l|0}m=c[f+12>>2]|0;n=(c[m+4>>2]|0)+(c[m+12>>2]|0)|0;o=(c[m+4>>2]|0)+(c[m+8>>2]|0)|0;p=j;if((a[m+33|0]|0)!=0){q=xe[c[c[p+228>>2]>>2]&63](c[j+228>>2]|0,n,o,h)|0;r=vj(j,c[j+228>>2]|0,n,o,q,c[h>>2]|0,h,0)|0}else{r=Qj(p,c[f+16>>2]|0,c[j+228>>2]|0,n,o,h,0)|0}if((r|0)!=0){k=r;l=k;i=g;return l|0}do{if((o|0)!=(c[h>>2]|0)){if((c[j+480>>2]|0)!=3){break}c[m+12>>2]=(c[h>>2]|0)-(c[m+4>>2]|0);k=r;l=k;i=g;return l|0}}while(0);a[m+32|0]=0;c[j+300>>2]=c[f+8>>2];c[f+8>>2]=c[j+304>>2];c[j+304>>2]=f;f=j+280|0;if((a[m+33|0]|0)!=0){c[f>>2]=40;m=xe[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=vj(j,c[j+144>>2]|0,b,d,m,c[h>>2]|0,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=Qj(j,(c[j+476>>2]|0)!=0?1:0,c[j+144>>2]|0,b,d,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}return 0}function Sj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d+24|0;f=b;b=c[f+356>>2]|0;g=0;do{if((c[b+156>>2]|0)!=0){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((lj(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=61;l=c[(c[b+156>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}k=0;while(1){if((k|0)>=(l|0)){m=13;break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((lj(f+416|0)|0)<<24>>24!=0)){break}}n=a[(c[(c[b+156>>2]|0)+16>>2]|0)+k|0]|0;o=f+428|0;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n;k=k+1|0}if((m|0)==13){g=1;break}h=0;j=h;i=d;return j|0}}while(0);mj(e,b+60|0);a:while(1){k=nj(e)|0;if((k|0)==0){m=40;break}if((c[k+4>>2]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((lj(f+416|0)|0)<<24>>24!=0)){m=21;break}}l=f+428|0;n=c[l>>2]|0;c[l>>2]=n+1;a[n]=12}n=c[k>>2]|0;while(1){q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if((a[n]|0)==0){break}if(q){if(!((lj(f+416|0)|0)<<24>>24!=0)){m=27;break a}}l=a[n]|0;p=f+428|0;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=l;n=n+1|0}if(q){if(!((lj(f+416|0)|0)<<24>>24!=0)){m=31;break}}n=f+428|0;l=c[n>>2]|0;c[n>>2]=l+1;a[l]=61;l=c[(c[k+4>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}n=0;while(1){if((n|0)>=(l|0)){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((lj(f+416|0)|0)<<24>>24!=0)){m=38;break a}}o=a[(c[(c[k+4>>2]|0)+16>>2]|0)+n|0]|0;p=f+428|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=o;n=n+1|0}g=1}if((m|0)==21){h=0;j=h;i=d;return j|0}else if((m|0)==27){h=0;j=h;i=d;return j|0}else if((m|0)==31){h=0;j=h;i=d;return j|0}else if((m|0)==38){h=0;j=h;i=d;return j|0}else if((m|0)==40){mj(e,b);b:while(1){b=nj(e)|0;if((b|0)==0){m=55;break}if((a[b+32|0]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((lj(f+416|0)|0)<<24>>24!=0)){m=47;break}}q=f+428|0;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=12}n=c[b>>2]|0;while(1){if((a[n]|0)==0){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((lj(f+416|0)|0)<<24>>24!=0)){m=53;break b}}b=a[n]|0;q=f+428|0;k=c[q>>2]|0;c[q>>2]=k+1;a[k]=b;n=n+1|0}g=1}if((m|0)==47){h=0;j=h;i=d;return j|0}else if((m|0)==53){h=0;j=h;i=d;return j|0}else if((m|0)==55){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((lj(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);m=f+428|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g]=0;h=c[f+432>>2]|0;j=h;i=d;return j|0}}return 0}function Tj(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+352|0;k=b;b=e;e=f;f=g;g=h;h=c[k+356>>2]|0;l=0;m=0;n=oj(k,h+20|0,c[f>>2]|0,0)|0;do{if((n|0)==0){o=Wi(h+80|0,c[f>>2]|0)|0;if((o|0)==0){p=1;q=p;i=j;return q|0}n=oj(k,h+20|0,o,24)|0;if((n|0)==0){p=1;q=p;i=j;return q|0}if((d[k+236|0]|0)==0){break}if((Zj(k,n)|0)!=0){break}p=1;q=p;i=j;return q|0}}while(0);o=c[n+12>>2]|0;r=xe[c[b+40>>2]&63](b,e,c[k+380>>2]|0,c[k+392>>2]|0)|0;do{if((r+o|0)>(c[k+380>>2]|0)){s=c[k+380>>2]|0;c[k+380>>2]=r+o+16;t=ne[c[k+16>>2]&63](c[k+392>>2]|0,c[k+380>>2]<<4)|0;if((t|0)==0){p=1;q=p;i=j;return q|0}else{c[k+392>>2]=t;if((r|0)<=(s|0)){break}xe[c[b+40>>2]&63](b,e,r,c[k+392>>2]|0)|0;break}}}while(0);e=c[k+392>>2]|0;s=0;a:while(1){if((s|0)>=(r|0)){u=43;break}t=(c[k+392>>2]|0)+(s<<4)|0;v=c[t>>2]|0;w=c[t>>2]|0;x=Bj(k,b,v,w+(ne[c[b+32>>2]&63](b,c[t>>2]|0)|0)|0)|0;if((x|0)==0){u=17;break}if((a[(c[x>>2]|0)+ -1|0]|0)!=0){u=19;break}a[(c[x>>2]|0)+ -1|0]=1;t=l;l=t+1|0;c[e+(t<<2)>>2]=c[x>>2];if((a[(c[k+392>>2]|0)+(s<<4)+12|0]|0)!=0){c[e+(l<<2)>>2]=xj(k+416|0,b,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0)|0;if((c[e+(l<<2)>>2]|0)==0){u=33;break}c[k+432>>2]=c[k+428>>2]}else{t=1;b:do{if((a[x+8|0]|0)!=0){w=0;while(1){if((w|0)>=(o|0)){break b}y=w;if((x|0)==(c[(c[n+20>>2]|0)+(w*12|0)>>2]|0)){break}w=y+1|0}t=a[(c[n+20>>2]|0)+(y*12|0)+4|0]|0}}while(0);z=Fj(k,b,t,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0,k+416|0)|0;if((z|0)!=0){u=30;break}c[e+(l<<2)>>2]=c[k+432>>2];c[k+432>>2]=c[k+428>>2]}do{if((c[x+4>>2]|0)!=0){if((a[x+9|0]|0)==0){l=l+1|0;m=m+1|0;a[(c[x>>2]|0)+ -1|0]=2;break}A=sj(k,c[x+4>>2]|0,x,c[e+(l<<2)>>2]|0,g)|0;if((A|0)!=0){u=38;break a}l=l+ -1|0}else{l=l+1|0}}while(0);s=s+1|0}if((u|0)==17){p=1;q=p;i=j;return q|0}else if((u|0)==19){if((b|0)==(c[k+144>>2]|0)){c[k+288>>2]=c[(c[k+392>>2]|0)+(s<<4)>>2]}p=8;q=p;i=j;return q|0}else if((u|0)==30){p=z;q=p;i=j;return q|0}else if((u|0)==33){p=1;q=p;i=j;return q|0}else if((u|0)==38){p=A;q=p;i=j;return q|0}else if((u|0)==43){c[k+384>>2]=l;c:do{if((c[n+8>>2]|0)!=0){if((a[(c[c[n+8>>2]>>2]|0)+ -1|0]|0)==0){u=50;break}s=0;while(1){if((s|0)>=(l|0)){break c}B=s;if((c[e+(s<<2)>>2]|0)==(c[c[n+8>>2]>>2]|0)){break}s=B+2|0}c[k+388>>2]=B}else{u=50}}while(0);if((u|0)==50){c[k+388>>2]=-1}s=0;d:while(1){if((s|0)>=(o|0)){break}B=(c[n+20>>2]|0)+(s*12|0)|0;do{if((a[(c[c[B>>2]>>2]|0)+ -1|0]|0)==0){if((c[B+8>>2]|0)==0){break}A=c[B>>2]|0;if((c[(c[B>>2]|0)+4>>2]|0)==0){a[(c[A>>2]|0)+ -1|0]=1;z=l;l=z+1|0;c[e+(z<<2)>>2]=c[c[B>>2]>>2];z=l;l=z+1|0;c[e+(z<<2)>>2]=c[B+8>>2];break}if((a[A+9|0]|0)!=0){C=sj(k,c[(c[B>>2]|0)+4>>2]|0,c[B>>2]|0,c[B+8>>2]|0,g)|0;if((C|0)!=0){u=58;break d}else{break}}else{a[(c[c[B>>2]>>2]|0)+ -1|0]=2;m=m+1|0;A=l;l=A+1|0;c[e+(A<<2)>>2]=c[c[B>>2]>>2];A=l;l=A+1|0;c[e+(A<<2)>>2]=c[B+8>>2];break}}}while(0);s=s+1|0}if((u|0)==58){p=C;q=p;i=j;return q|0}c[e+(l<<2)>>2]=0;s=0;e:do{if((m|0)!=0){C=c[k+400>>2]|0;o=1<<d[k+404|0];do{if((m<<1>>d[k+404|0]|0)!=0){do{B=k+404|0;A=a[B]|0;a[B]=A+1<<24>>24;}while((m>>(A&255)|0)!=0);if((d[k+404|0]|0)<3){a[k+404|0]=3}o=1<<d[k+404|0];A=ne[c[k+16>>2]&63](c[k+396>>2]|0,o*12|0)|0;if((A|0)!=0){c[k+396>>2]=A;C=0;break}p=1;q=p;i=j;return q|0}}while(0);f:do{if((C|0)==0){C=-1;D=o;while(1){if((D|0)==0){break f}A=D+ -1|0;D=A;c[(c[k+396>>2]|0)+(A*12|0)>>2]=C}}}while(0);A=C+ -1|0;C=A;c[k+400>>2]=A;g:while(1){if((s|0)>=(l|0)){break e}A=c[e+(s<<2)>>2]|0;if((a[A+ -1|0]|0)==2){B=c[k+496>>2]|0;a[A+ -1|0]=0;z=c[(c[(oj(k,h+40|0,A,0)|0)+4>>2]|0)+4>>2]|0;if((z|0)==0){u=78;break}D=0;while(1){if((D|0)>=(c[z+20>>2]|0)){break}b=a[(c[z+16>>2]|0)+D|0]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((lj(k+416|0)|0)<<24>>24!=0)){u=84;break g}}y=k+428|0;x=c[y>>2]|0;c[y>>2]=x+1;a[x]=b;B=B*1000003^b&255;D=D+1|0}do{b=A;A=b+1|0;}while((a[b]|0)!=58);do{b=a[A]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((lj(k+416|0)|0)<<24>>24!=0)){u=89;break g}}x=a[A]|0;y=k+428|0;t=c[y>>2]|0;c[y>>2]=t+1;a[t]=x;B=B*1000003^b&255;b=A;A=b+1|0;}while((a[b]|0)!=0);b=0;x=o-1|0;D=B&x;while(1){if((c[(c[k+396>>2]|0)+(D*12|0)>>2]|0)!=(C|0)){break}if((B|0)==(c[(c[k+396>>2]|0)+(D*12|0)+4>>2]|0)){t=c[k+432>>2]|0;y=c[(c[k+396>>2]|0)+(D*12|0)+8>>2]|0;while(1){if((a[t]|0)!=(a[y]|0)){break}if((a[t]|0)==0){break}t=t+1|0;y=y+1|0}if((a[t]|0)==0){u=98;break g}}if(!(b<<24>>24!=0)){b=((B&~x)>>>((d[k+404|0]|0)-1|0)&x>>>2|1)&255}if((D|0)<(b&255|0)){D=D+(o-(b&255))|0;continue}else{D=D-(b&255)|0;continue}}if((a[k+237|0]|0)!=0){a[(c[k+428>>2]|0)+ -1|0]=a[k+472|0]|0;A=c[c[z>>2]>>2]|0;do{if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((lj(k+416|0)|0)<<24>>24!=0)){u=109;break g}}b=a[A]|0;x=k+428|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=b;b=A;A=b+1|0;}while((a[b]|0)!=0)}A=c[k+432>>2]|0;c[k+432>>2]=c[k+428>>2];c[e+(s<<2)>>2]=A;c[(c[k+396>>2]|0)+(D*12|0)>>2]=C;c[(c[k+396>>2]|0)+(D*12|0)+4>>2]=B;c[(c[k+396>>2]|0)+(D*12|0)+8>>2]=A;z=m+ -1|0;m=z;if((z|0)==0){u=111;break}}else{a[A+ -1|0]=0}s=s+2|0}if((u|0)==78){p=27;q=p;i=j;return q|0}else if((u|0)==84){p=1;q=p;i=j;return q|0}else if((u|0)==89){p=1;q=p;i=j;return q|0}else if((u|0)==98){p=8;q=p;i=j;return q|0}else if((u|0)==109){p=1;q=p;i=j;return q|0}else if((u|0)==111){s=s+2|0;break}}}while(0);while(1){if((s|0)>=(l|0)){break}a[(c[e+(s<<2)>>2]|0)+ -1|0]=0;s=s+2|0}e=c[g>>2]|0;while(1){if((e|0)==0){break}a[(c[c[e+12>>2]>>2]|0)+ -1|0]=0;e=c[e+4>>2]|0}if((a[k+236|0]|0)==0){p=0;q=p;i=j;return q|0}do{if((c[n+4>>2]|0)!=0){e=c[(c[n+4>>2]|0)+4>>2]|0;if((e|0)!=0){E=c[f>>2]|0;do{g=E;E=g+1|0;}while((a[g]|0)!=58)}else{p=27;q=p;i=j;return q|0}}else{if((c[h+156>>2]|0)!=0){e=c[h+156>>2]|0;E=c[f>>2]|0;break}p=0;q=p;i=j;return q|0}}while(0);h=0;do{if((d[k+237|0]|0)!=0){if((c[c[e>>2]>>2]|0)==0){break}do{n=h;h=n+1|0;}while((a[(c[c[e>>2]>>2]|0)+n|0]|0)!=0)}}while(0);c[f+4>>2]=E;c[f+16>>2]=c[e+20>>2];c[f+8>>2]=c[c[e>>2]>>2];c[f+20>>2]=h;s=0;do{n=s;s=n+1|0;}while((a[E+n|0]|0)!=0);r=s+(c[e+20>>2]|0)+h|0;if((r|0)>(c[e+24>>2]|0)){F=$d[c[k+12>>2]&127](r+24|0)|0;if((F|0)==0){p=1;q=p;i=j;return q|0}c[e+24>>2]=r+24;GS(F|0,c[e+16>>2]|0,c[e+20>>2]|0)|0;r=c[k+364>>2]|0;while(1){if((r|0)==0){break}if((c[r+12>>2]|0)==(c[e+16>>2]|0)){c[r+12>>2]=F}r=c[r>>2]|0}Yd[c[k+20>>2]&255](c[e+16>>2]|0);c[e+16>>2]=F}F=(c[e+16>>2]|0)+(c[e+20>>2]|0)|0;GS(F|0,E|0,s|0)|0;if((h|0)!=0){F=F+(s-1)|0;a[F]=a[k+472|0]|0;GS(F+1|0,c[c[e>>2]>>2]|0,h|0)|0}c[f>>2]=c[e+16>>2];p=0;q=p;i=j;return q|0}return 0}function Uj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+40|0;j=b;b=d;d=e;e=f;c[j+280>>2]=43;c[j+288>>2]=b;a:while(1){c[h>>2]=0;f=xe[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;c[j+292>>2]=c[h>>2];b:do{switch(f|0){case 0:{k=14;break a;break};case-4:{k=7;break a;break};case 11:{if((Mj(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=11;break a}break};case 13:{if((Nj(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=13;break a}break};case 15:{if((c[j+80>>2]|0)==0){break b}jj(j,c[j+144>>2]|0,b,c[h>>2]|0);break};case-15:{k=3;break a;break};case-1:{k=15;break a;break};case-2:{k=18;break a;break};default:{k=21;break a}}}while(0);f=c[h>>2]|0;b=f;c[j+288>>2]=f;f=c[j+480>>2]|0;if((f|0)==2){k=24;break}else if((f|0)==3){k=23;break}}if((k|0)==3){do{if((c[j+80>>2]|0)!=0){jj(j,c[j+144>>2]|0,b,c[h>>2]|0);if((c[j+480>>2]|0)!=2){break}l=35;m=l;i=g;return m|0}}while(0);c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==7){c[e>>2]=b;l=0;m=l;i=g;return m|0}else if((k|0)==11){l=1;m=l;i=g;return m|0}else if((k|0)==13){l=1;m=l;i=g;return m|0}else if((k|0)==14){c[j+288>>2]=c[h>>2];l=4;m=l;i=g;return m|0}else if((k|0)==15){if((a[j+484|0]|0)!=0){l=5;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==18){if((a[j+484|0]|0)!=0){l=6;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==21){l=9;m=l;i=g;return m|0}else if((k|0)==23){c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==24){l=35;m=l;i=g;return m|0}return 0}function Vj(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+120|0;k=j+56|0;l=j+80|0;m=j+96|0;n=j+112|0;o=b;b=d;d=e;e=f;f=g;g=h;c[k>>2]=c[d>>2];h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;c[p>>2]=c[k>>2];q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}c[p>>2]=c[k>>2];c[d>>2]=0;a:while(1){h=xe[c[b+8>>2]&63](b,c[k>>2]|0,e,l)|0;c[q>>2]=c[l>>2];b:do{switch(h|0){case 7:{if((c[o+60>>2]|0)!=0){a[m]=10;ue[c[o+60>>2]&15](c[o+4>>2]|0,m,1);break b}if((c[o+80>>2]|0)==0){break b}jj(o,b,c[k>>2]|0,c[l>>2]|0);break};case 0:{r=24;break a;break};case 40:{r=6;break a;break};case-4:case-1:{r=28;break a;break};case-2:{r=25;break a;break};case 6:{s=c[o+60>>2]|0;if((s|0)==0){if((c[o+80>>2]|0)==0){break b}jj(o,b,c[k>>2]|0,c[l>>2]|0);break b}if((a[b+72|0]|0)!=0){ue[s&15](c[o+4>>2]|0,c[k>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0);break b}while(1){c[n>>2]=c[o+44>>2];Vd[c[b+60>>2]&31](b,k,c[l>>2]|0,n,c[o+48>>2]|0);c[q>>2]=c[l>>2];ue[s&15](c[o+4>>2]|0,c[o+44>>2]|0,(c[n>>2]|0)-(c[o+44>>2]|0)|0);if((c[k>>2]|0)==(c[l>>2]|0)){break b}c[p>>2]=c[k>>2]}break};default:{r=31;break a}}}while(0);h=c[l>>2]|0;c[k>>2]=h;c[p>>2]=h;h=c[o+480>>2]|0;if((h|0)==3){r=33;break}else if((h|0)==2){r=34;break}}if((r|0)==6){n=o;do{if((c[o+76>>2]|0)!=0){Yd[c[n+76>>2]&255](c[o+4>>2]|0)}else{if((c[n+80>>2]|0)==0){break}jj(o,b,c[k>>2]|0,c[l>>2]|0)}}while(0);c[d>>2]=c[l>>2];c[f>>2]=c[l>>2];if((c[o+480>>2]|0)==2){t=35;u=t;i=j;return u|0}else{t=0;u=t;i=j;return u|0}}else if((r|0)==24){c[p>>2]=c[l>>2];t=4;u=t;i=j;return u|0}else if((r|0)==25){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=6;u=t;i=j;return u|0}}else if((r|0)==28){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=20;u=t;i=j;return u|0}}else if((r|0)==31){c[p>>2]=c[l>>2];t=23;u=t;i=j;return u|0}else if((r|0)==33){c[f>>2]=c[l>>2];t=0;u=t;i=j;return u|0}else if((r|0)==34){t=35;u=t;i=j;return u|0}return 0}function Wj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=Vj(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)==0){k=f;l=k;i=g;return l|0}f=j+280|0;if((c[j+476>>2]|0)!=0){c[f>>2]=44;k=Xj(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=zj(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}return 0}function Xj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=Qj(h,1,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((Yj(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function Yj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+56|0;d=a;a=c[d+364>>2]|0;while(1){if((a|0)==0){e=13;break}f=(c[a+24>>2]|0)+1|0;g=(c[a+36>>2]|0)+f|0;if((c[a+4>>2]|0)==(g|0)){e=13;break}h=f+((c[a+8>>2]|0)+0)|0;if((h|0)>((c[a+40>>2]|0)-(c[a+36>>2]|0)|0)){j=ne[c[d+16>>2]&63](c[a+36>>2]|0,h)|0;if((j|0)==0){e=6;break}if((c[a+12>>2]|0)==(c[a+36>>2]|0)){c[a+12>>2]=j}if((c[a+16>>2]|0)!=0){c[a+16>>2]=j+((c[a+16>>2]|0)-(c[a+36>>2]|0))}c[a+36>>2]=j;c[a+40>>2]=j+h;g=j+f|0}GS(g|0,c[a+4>>2]|0,c[a+8>>2]|0)|0;c[a+4>>2]=g;a=c[a>>2]|0}if((e|0)==6){k=0;l=k;i=b;return l|0}else if((e|0)==13){k=1;l=k;i=b;return l|0}return 0}function Zj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=c[b>>2]|0;a:while(1){if((a[g]|0)==0){h=20;break}if((a[g]|0)==58){j=c[b>>2]|0;while(1){k=(c[d+92>>2]|0)==(c[d+88>>2]|0);if((j|0)==(g|0)){break}if(k){if(!((lj(d+80|0)|0)<<24>>24!=0)){h=9;break a}}l=a[j]|0;m=d+92|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;j=j+1|0}if(k){if(!((lj(d+80|0)|0)<<24>>24!=0)){h=13;break}}j=d+92|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;l=oj(f,d+60|0,c[d+96>>2]|0,8)|0;if((l|0)==0){h=14;break}j=d+80|0;if((c[l>>2]|0)==(c[d+96>>2]|0)){c[d+96>>2]=c[j+12>>2]}else{c[d+92>>2]=c[j+16>>2]}c[b+4>>2]=l}g=g+1|0}if((h|0)==9){o=0;p=o;i=e;return p|0}else if((h|0)==13){o=0;p=o;i=e;return p|0}else if((h|0)==14){o=0;p=o;i=e;return p|0}else if((h|0)==20){o=1;p=o;i=e;return p|0}return 0}function _j(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+152|0;l=k+64|0;m=k+80|0;n=b;b=e;e=f;f=g;g=h;h=j;j=c[n+356>>2]|0;a:while(1){b:do{switch(xe[c[b+16>>2]&63](b,f,g,l)|0){case 10:{o=ne[c[b+44>>2]&63](b,f)|0;if((o|0)<0){p=11;break a}do{if(!(e<<24>>24!=0)){if((o|0)!=32){break}if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break b}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break b}}}while(0);o=fk(o,m)|0;if((o|0)==0){p=19;break a}q=0;while(1){if((q|0)>=(o|0)){break b}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((lj(h)|0)<<24>>24!=0)){p=27;break a}}r=a[m+q|0]|0;s=h+12|0;t=c[s>>2]|0;c[s>>2]=t+1;a[t]=r;q=q+1|0}break};case-1:{p=7;break a;break};case 7:case 39:{p=31;break};case-4:{p=3;break a;break};case 9:{q=(be[c[b+48>>2]&63](b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0)&255;if(q<<24>>24!=0){if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((lj(h)|0)<<24>>24!=0)){p=42;break a}}o=h+12|0;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;break b}q=xj(n+440|0,b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((q|0)==0){p=44;break a}r=oj(n,j,q,0)|0;c[n+452>>2]=c[n+456>>2];if((h|0)==(j+80|0)){if((c[n+272>>2]|0)!=0){if((d[j+130|0]|0)!=0){u=(c[n+300>>2]|0)!=0}else{u=(a[j+129|0]|0)!=0}v=((u^1)&1|0)!=0}else{v=0}w=v&1}else{if((a[j+129|0]|0)!=0){x=(d[j+130|0]|0)!=0}else{x=1}w=x&1}q=(r|0)!=0;if(w<<24>>24!=0){if(!q){p=57;break a}if((a[r+34|0]|0)==0){p=59;break a}}else{if(!q){break b}}if((a[r+32|0]|0)!=0){p=62;break a}if((c[r+28>>2]|0)!=0){p=66;break a}if((c[r+4>>2]|0)==0){p=70;break a}q=(c[r+4>>2]|0)+(c[r+8>>2]|0)|0;a[r+32|0]=1;y=_j(n,c[n+228>>2]|0,e,c[r+4>>2]|0,q,h)|0;a[r+32|0]=0;if((y|0)!=0){p=74;break a}break};case 6:{if((Dj(h,b,f,c[l>>2]|0)|0)==0){p=29;break a}break};case-3:{c[l>>2]=f+(c[b+68>>2]|0);p=31;break};case 0:{p=4;break a;break};default:{p=75;break a}}}while(0);do{if((p|0)==31){p=0;if(!(e<<24>>24!=0)){if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break}}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((lj(h)|0)<<24>>24!=0)){p=37;break a}}r=h+12|0;q=c[r>>2]|0;c[r>>2]=q+1;a[q]=32}}while(0);f=c[l>>2]|0}if((p|0)==3){z=0;A=z;i=k;return A|0}else if((p|0)==4){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=c[l>>2]}z=4;A=z;i=k;return A|0}else if((p|0)==7){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=4;A=z;i=k;return A|0}else if((p|0)==11){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((p|0)==19){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((p|0)==27){z=1;A=z;i=k;return A|0}else if((p|0)==29){z=1;A=z;i=k;return A|0}else if((p|0)==37){z=1;A=z;i=k;return A|0}else if((p|0)==42){z=1;A=z;i=k;return A|0}else if((p|0)==44){z=1;A=z;i=k;return A|0}else if((p|0)==57){z=11;A=z;i=k;return A|0}else if((p|0)==59){z=24;A=z;i=k;return A|0}else if((p|0)==62){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=12;A=z;i=k;return A|0}else if((p|0)==66){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=15;A=z;i=k;return A|0}else if((p|0)==70){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=16;A=z;i=k;return A|0}else if((p|0)==74){z=y;A=z;i=k;return A|0}else if((p|0)==75){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=23;A=z;i=k;return A|0}return 0}function $j(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1080|0;f=e+24|0;g=b;b=d;do{if((c[g+124>>2]|0)!=0){d=0;while(1){if((d|0)>=256){break}c[f+(d<<2)>>2]=-1;d=d+1|0}c[f+1028>>2]=0;c[f+1024>>2]=0;c[f+1032>>2]=0;do{if((be[c[g+124>>2]&63](c[g+248>>2]|0,b,f)|0)!=0){d=c[g+12>>2]|0;h=gk()|0;c[g+240>>2]=$d[d&127](h)|0;if((c[g+240>>2]|0)!=0){h=xe[((a[g+236|0]&255|0)!=0?45:46)&63](c[g+240>>2]|0,f,c[f+1028>>2]|0,c[f+1024>>2]|0)|0;if((h|0)==0){break}c[g+244>>2]=c[f+1024>>2];c[g+252>>2]=c[f+1032>>2];c[g+144>>2]=h;j=0;k=j;i=e;return k|0}if((c[f+1032>>2]|0)!=0){Yd[c[f+1032>>2]&255](c[f+1024>>2]|0)}j=1;k=j;i=e;return k|0}}while(0);if((c[f+1032>>2]|0)==0){break}Yd[c[f+1032>>2]&255](c[f+1024>>2]|0)}}while(0);j=18;k=j;i=e;return k|0}function ak(){var a=0,b=0;a=i;i=i+8|0;$b(((qc(0)|0)>>>0)%4294967295|0|0);b=MS()|0;i=a;return b|0}function bk(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+48|0;g=a;a=tj(g)|0;if((a|0)!=0){h=a;j=h;i=f;return j|0}else{c[g+280>>2]=40;h=uj(g,b,d,e)|0;j=h;i=f;return j|0}return 0}function ck(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=$d[c[e>>2]&127](188)|0;f=b;if((b|0)==0){g=f;h=g;i=d;return h|0}else{dk(f+80|0,e);dk(b+104|0,e);ek(b,e);ek(b+20|0,e);ek(b+40|0,e);ek(b+60|0,e);a[b+131|0]=0;ek(b+132|0,e);c[b+152>>2]=0;c[b+156>>2]=0;a[b+160|0]=0;c[b+184>>2]=0;c[b+164>>2]=0;c[b+180>>2]=0;c[b+172>>2]=0;c[b+176>>2]=0;c[b+168>>2]=0;a[b+128|0]=1;a[b+129|0]=0;a[b+130|0]=0;g=b;h=g;i=d;return h|0}return 0}function dk(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;c[e>>2]=0;c[e+4>>2]=0;c[e+16>>2]=0;c[e+12>>2]=0;c[e+8>>2]=0;c[e+20>>2]=b;i=d;return}function ek(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=b;a[f+4|0]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f>>2]=0;c[f+16>>2]=d;i=e;return}function fk(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;if((e|0)<0){f=0;g=f;i=d;return g|0}c=e;if((e|0)<128){a[b]=c;f=1;g=f;i=d;return g|0}h=e;if((c|0)<2048){a[b]=h>>6|192;a[b+1|0]=e&63|128;f=2;g=f;i=d;return g|0}c=e;if((h|0)<65536){a[b]=c>>12|224;a[b+1|0]=e>>6&63|128;a[b+2|0]=e&63|128;f=3;g=f;i=d;return g|0}if((c|0)<1114112){a[b]=e>>18|240;a[b+1|0]=e>>12&63|128;a[b+2|0]=e>>6&63|128;a[b+3|0]=e&63|128;f=4;g=f;i=d;return g|0}else{f=0;g=f;i=d;return g|0}return 0}function gk(){i=i;return 1912}



function mp(b,d,e,f,g,j,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,W=0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0,xa=0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+16|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;c[m>>2]=0;O=c[q+12>>2]|0;a:do{if((O|0)==2){c[s>>2]=0;c[8750]=0;h[4376]=+V(+(+h[t>>3]));P=c[b>>2]|0;c[8728]=1;b:do{if((P|0)>=1){Q=r;R=1;while(1){S=R+ -1|0;T=+h[e+(S<<3)>>3];h[N>>3]=T;if(!(T>=0.0)){U=-T}else{U=T}W=f+(S<<3)|0;T=+h[l>>3]*+h[W>>3];if(!(T>=0.0)){X=-T}else{X=T}T=U>=X?U:X;Y=+h[n+(S<<3)>>3];if(!(Y>=0.0)){Z=-Y}else{Z=Y}h[4373]=+h[4376]*(T>=Z?T:Z);h[N>>3]=+h[l>>3]*+h[W>>3];T=+IF(34984,N);h[4373]=T;W=(c[8728]|0)+ -1|0;S=e+(W<<3)|0;Y=+h[S>>3];_=T+Y-Y;h[4373]=_;h[4380]=+h[S>>3];$=f+(W<<3)|0;h[4384]=+h[$>>3];h[S>>3]=_+ +h[S>>3];h[$>>3]=+h[j>>3]*+h[4373]+ +h[$>>3];Ud[Q&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}_=1.0/+h[4373];h[4382]=_;$=c[b>>2]|0;c[8734]=1;S=c[8750]|0;if(($|0)>=1){Y=_;W=1;aa=0;while(1){h[p+(aa+S<<3)>>3]=(+h[o+(aa<<3)>>3]- +h[g+(aa<<3)>>3])*Y;if((W|0)>=($|0)){break}ba=W;Y=+h[4382];W=W+1|0;aa=ba}c[8734]=$+1}c[8750]=S+(c[b>>2]|0);aa=c[8728]|0;W=aa+ -1|0;h[e+(W<<3)>>3]=+h[4380];h[f+(W<<3)>>3]=+h[4384];R=aa+1|0;c[8728]=R;if((aa|0)>=(P|0)){break b}}i=y;return 0}}while(0);if((c[w>>2]|0)==0){ca=42;break}c[8750]=0;P=c[b>>2]|0;if((c[21288>>2]|0)==0){ca=42;break}R=aS(P*20|0)|0;Q=F;h[k>>3]=+h[d>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];Rn(14,1,35080,F);Q=E;h[k>>3]=+h[j>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];Rn(14,0,35104,E);Rn(14,1,35112,D);c[8732]=0;if((c[b>>2]|0)>0){Q=0;do{Y=+h[e+(Q<<3)>>3];c[C>>2]=Q+1;aa=C+4|0;h[k>>3]=Y;c[aa>>2]=c[k>>2];c[aa+4>>2]=c[k+4>>2];Rn(14,0,35120,C);Q=(c[8732]|0)+1|0;c[8732]=Q;}while((Q|0)<(c[b>>2]|0))}Yd[c[5446]&255](14);Rn(14,1,35176,B);c[8728]=1;if((P|0)>=1){Q=R+1|0;aa=c[8750]|0;W=1;do{ba=p+(W+ -1+aa<<3)|0;h[ba>>3]=+h[j>>3]+ +h[ba>>3];a[R]=0;a[Q]=0;c[8734]=1;ba=aa;da=0;while(1){Y=+h[p+(da+ba<<3)>>3];c[A>>2]=R;ea=A+4|0;h[k>>3]=Y;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];gc(R|0,35160,A|0)|0;ea=c[8734]|0;c[8734]=ea+1;if((ea|0)>=(P|0)){break}ba=c[8750]|0;da=ea}c[z>>2]=R;Rn(14,0,35168,z);da=c[8750]|0;ba=c[8728]|0;ea=p+(da+ -1+ba<<3)|0;h[ea>>3]=+h[ea>>3]- +h[j>>3];aa=da+(c[b>>2]|0)|0;c[8750]=aa;W=ba+1|0;c[8728]=W;}while((ba|0)<(P|0))}Yd[c[5446]&255](14);Yd[c[5446]&255](14);bS(R);ca=42}else if((O|0)==4){P=c[q>>2]|0;W=q+4|0;aa=c[W>>2]|0;Q=c[b>>2]|0;ba=fa(aa+1+(P<<1)|0,Q)|0;c[8728]=1;if((ba|0)>=1){da=fa(Q,aa+(P<<1)+1|0)|0;P=(da|0)<1;aa=1;while(1){h[p+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[8728]=P?2:da+1|0}_d[u&7](d,e,f,g,p,j,l,n,v,w)|0;c[8762]=(c[W>>2]|0)+1+(c[q>>2]<<1);ca=75}else if((O|0)==3){i=y;return 0}else if((O|0)==5){aa=q+4|0;ba=(c[aa>>2]|0)+(c[q>>2]|0)|0;R=ba+1|0;c[8754]=R;Q=c[b>>2]|0;c[8744]=(ba|0)<(Q|0)?R:Q;Q=c[q>>2]|0;c[8762]=R+Q;c[8748]=Q+ba;ba=(c[b>>2]|0)/(R|0)|0;c[8758]=ba+1;R=c[x>>2]|0;c[8756]=R+ -1;c[8766]=R+ba;c[s>>2]=0;h[4376]=+V(+(+h[t>>3]));ba=c[8744]|0;c[8730]=1;if((ba|0)<1){ca=75;break}R=r;Q=1;while(1){ea=c[b>>2]|0;ga=c[8754]|0;c[8736]=Q;ha=(ga|0)<0;c:do{if(ha?(Q|0)>=(ea|0):(Q|0)<=(ea|0)){ia=ga;ja=Q;ka=Q;while(1){la=(ka-ja|0)/(ia|0)|0;c[8732]=la+1;ma=ka+ -1|0;na=e+(ma<<3)|0;h[p+((c[8756]|0)+la<<3)>>3]=+h[na>>3];oa=f+(ma<<3)|0;h[p+((c[8766]|0)+la<<3)>>3]=+h[oa>>3];Y=+h[na>>3];h[N>>3]=Y;if(!(Y>=0.0)){pa=-Y}else{pa=Y}Y=+h[l>>3]*+h[oa>>3];if(!(Y>=0.0)){qa=-Y}else{qa=Y}Y=pa>=qa?pa:qa;_=+h[n+(ma<<3)>>3];if(!(_>=0.0)){ra=-_}else{ra=_}h[4373]=+h[4376]*(Y>=ra?Y:ra);h[N>>3]=+h[l>>3]*+h[oa>>3];Y=+IF(34984,N);h[4373]=Y;oa=c[8736]|0;ma=oa+ -1|0;na=e+(ma<<3)|0;_=+h[na>>3];T=Y+_-_;h[4373]=T;h[na>>3]=+h[na>>3]+T;na=f+(ma<<3)|0;h[na>>3]=+h[j>>3]*+h[4373]+ +h[na>>3];na=oa+ga|0;c[8736]=na;if(!(ha?(na|0)>=(ea|0):(na|0)<=(ea|0))){break c}ia=c[8754]|0;ja=c[8730]|0;ka=na}}}while(0);Ud[R&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}ea=c[b>>2]|0;ha=c[8754]|0;ga=c[8730]|0;c[8736]=ga;ka=(ha|0)<0;d:do{if(ka?(ga|0)>=(ea|0):(ga|0)<=(ea|0)){ja=ha;ia=ga;S=ga;while(1){$=(S-ia|0)/(ja|0)|0;c[8732]=$+1;na=S+ -1|0;oa=e+(na<<3)|0;h[oa>>3]=+h[p+((c[8756]|0)+$<<3)>>3];T=+h[p+((c[8766]|0)+$<<3)>>3];$=f+(na<<3)|0;h[$>>3]=T;_=+h[oa>>3];h[N>>3]=_;if(!(_>=0.0)){sa=-_}else{sa=_}_=+h[l>>3]*T;if(!(_>=0.0)){ta=-_}else{ta=_}_=sa>=ta?sa:ta;T=+h[n+(na<<3)>>3];if(!(T>=0.0)){ua=-T}else{ua=T}h[4373]=+h[4376]*(_>=ua?_:ua);h[N>>3]=+h[l>>3]*+h[$>>3];_=+IF(34984,N);h[4373]=_;$=c[8736]|0;T=+h[e+($+ -1<<3)>>3];Y=_+T-T;h[4373]=Y;T=1.0/Y;h[4382]=T;na=$-(c[aa>>2]|0)|0;oa=(na|0)>1?na:1;c[8738]=oa;na=c[b>>2]|0;ma=(c[q>>2]|0)+$|0;la=(na|0)<=(ma|0)?na:ma;c[8740]=la;va=fa(c[8748]|0,$)|0;wa=va-(c[q>>2]|0)|0;c[8742]=wa;c[8728]=oa;if((oa|0)<=(la|0)){va=~na;na=~ma;ma=~((va|0)>(na|0)?va:na);na=(oa|0)>(ma|0)?oa:ma;Y=T;ma=oa;while(1){oa=ma+ -1|0;h[p+(oa+wa<<3)>>3]=(+h[o+(oa<<3)>>3]- +h[g+(oa<<3)>>3])*Y;if((ma|0)>=(la|0)){break}Y=+h[4382];ma=ma+1|0}c[8728]=na+1}ma=$+ha|0;c[8736]=ma;la=c[8730]|0;if(!(ka?(ma|0)>=(ea|0):(ma|0)<=(ea|0))){xa=la;break d}ja=c[8754]|0;ia=la;S=ma}}else{xa=ga}}while(0);ga=xa+1|0;c[8730]=ga;if((xa|0)<(ba|0)){Q=ga}else{ca=75;break a}}i=y;return 0}else{Q=c[b>>2]|0;ba=fa(Q,Q)|0;c[8728]=1;if((ba|0)!=0){Q=(ba|0)<1;aa=1;while(1){h[p+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[8728]=Q?2:ba+1|0}_d[u&7](d,e,f,g,p,j,l,n,v,w)|0;if((c[w>>2]|0)==0){ca=42;break}c[8750]=0;aa=c[b>>2]|0;if((c[21288>>2]|0)==0){ca=42;break}R=aS(aa*20|0)|0;W=M;h[k>>3]=+h[d>>3];c[W>>2]=c[k>>2];c[W+4>>2]=c[k+4>>2];Rn(14,1,35080,M);W=L;h[k>>3]=+h[j>>3];c[W>>2]=c[k>>2];c[W+4>>2]=c[k+4>>2];Rn(14,0,35104,L);Rn(14,1,35112,K);c[8732]=0;if((c[b>>2]|0)>0){W=0;do{Y=+h[e+(W<<3)>>3];c[J>>2]=W+1;da=J+4|0;h[k>>3]=Y;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];Rn(14,0,35120,J);W=(c[8732]|0)+1|0;c[8732]=W;}while((W|0)<(c[b>>2]|0))}Yd[c[5446]&255](14);Rn(14,1,35136,I);c[8728]=1;if((aa|0)>=1){W=R+1|0;ba=c[8750]|0;Q=1;do{da=p+(Q+ -1+ba<<3)|0;h[da>>3]=+h[j>>3]+ +h[da>>3];a[R]=0;a[W]=0;c[8734]=1;da=ba;P=0;while(1){Y=+h[p+(P+da<<3)>>3];c[H>>2]=R;ga=H+4|0;h[k>>3]=Y;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];gc(R|0,35160,H|0)|0;ga=c[8734]|0;c[8734]=ga+1;if((ga|0)>=(aa|0)){break}da=c[8750]|0;P=ga}c[G>>2]=R;Rn(14,0,35168,G);P=c[8750]|0;da=c[8728]|0;ga=p+(P+ -1+da<<3)|0;h[ga>>3]=+h[ga>>3]- +h[j>>3];ba=P+(c[b>>2]|0)|0;c[8750]=ba;Q=da+1|0;c[8728]=Q;}while((da|0)<(aa|0))}Yd[c[5446]&255](14);Yd[c[5446]&255](14);bS(R);ca=42}}while(0);if((ca|0)==42){up(p,b,b,q+80|0,m)|0;i=y;return 0}else if((ca|0)==75){Ap(p,35048,b,q,q+4|0,q+80|0,m)|0;i=y;return 0}return 0}function np(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[e+12>>2]|0;if((g|0)==3){i=f;return 0}else if((g|0)==4|(g|0)==5){g=e+4|0;c[8800]=(c[g>>2]|0)+1+(c[e>>2]<<1);Bp(d,35200,a,e,g,e+80|0,b,35208)|0;i=f;return 0}else{yp(d,a,a,e+80|0,b,35208)|0;i=f;return 0}return 0}function op(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0;d=i;i=i+8|0;e=d;do{if(!(a[35216]&1)){a[35216]=1;pp(35264,35232,35312,35248,35296,35320,35304,35328)|0;h[4407]=+(c[8816]|0);f=c[8808]|0;h[4403]=+(f|0);if((c[8828]|0)==0){h[4405]=0.0;c[e>>2]=1-f;g=+HF(35256,e)}else{h[4405]=1.0;c[e>>2]=1-f;g=+HF(35256,e)*.5}h[4406]=g;h[4410]=g*+h[4407];h[4409]=+(c[8824]|0);h[4411]=+(c[8826]|0);j=+h[4415];h[4418]=j;k=1.0/+h[4416];if(!(k>=j)){break}h[4418]=k*(g+1.0)}}while(0);if((Hp(b,35352,1,1)|0)!=0){g=+h[4406];h[4417]=g;l=g;i=d;return+l}if((Hp(b,35360,1,1)|0)!=0){g=+h[4418];h[4417]=g;l=g;i=d;return+l}if((Hp(b,35368,1,1)|0)!=0){g=+h[4407];h[4417]=g;l=g;i=d;return+l}if((Hp(b,35376,1,1)|0)!=0){g=+h[4410];h[4417]=g;l=g;i=d;return+l}if((Hp(b,35384,1,1)|0)!=0){g=+h[4403];h[4417]=g;l=g;i=d;return+l}if((Hp(b,35392,1,1)|0)!=0){g=+h[4405];h[4417]=g;l=g;i=d;return+l}if((Hp(b,35400,1,1)|0)!=0){g=+h[4409];h[4417]=g;l=g;i=d;return+l}if((Hp(b,35408,1,1)|0)!=0){g=+h[4415];h[4417]=g;l=g;i=d;return+l}if((Hp(b,35416,1,1)|0)!=0){g=+h[4411];h[4417]=g;l=g;i=d;return+l}if((Hp(b,35424,1,1)|0)==0){l=+h[4417];i=d;return+l}else{g=+h[4416];h[4417]=g;l=g;i=d;return+l}return 0.0}function pp(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;m=i;i=i+24|0;n=m;o=m+8|0;p=m+16|0;if(a[35536]&1){q=35904;r=c[8976]|0;c[b>>2]=r;s=35840;t=c[8960]|0;c[d>>2]=t;u=35880;v=c[8970]|0;c[e>>2]=v;w=35888;x=+h[4486];h[f>>3]=x;y=35920;z=c[8980]|0;c[g>>2]=z;A=35968;B=+h[4496];h[j>>3]=B;C=35928;D=c[8982]|0;c[k>>2]=D;E=35976;F=+h[4497];h[l>>3]=F;i=m;return 0}a[35536]=1;h[4487]=0.0;h[4481]=1.0;h[4482]=2.0;qp(35904,35840,35880,35992)|0;h[4477]=+(c[8976]|0);c[n>>2]=0-(c[8960]|0);G=+HF(35816,n);h[4476]=G;h[4486]=G;H=+h[4482];h[4477]=H/3.0;I=+h[4481];J=I*.5;h[4484]=J;K=-J;h[o>>3]=K;h[4498]=+rp(35816,o);L=35984;h[4495]=+rp(L,L);h[o>>3]=K;h[4477]=+rp(35960,o);K=+rp(35816,35984);h[4477]=K;if(!(K>=0.0)){M=-K}else{M=K}K=M<G?G:M;h[4477]=K;h[4486]=1.0;M=+h[4487];if(K<1.0&K>M){N=K;while(1){h[4486]=N;h[o>>3]=N*J;K=H*H;h[p>>3]=N*N*H*K*K;K=+rp(o,p);h[4478]=K;h[o>>3]=-K;h[4478]=+rp(35872,o);K=+rp(35872,35824);h[4477]=K;h[o>>3]=-K;h[4478]=+rp(35872,o);K=+rp(35872,35824);h[4477]=K;if(N>K&K>M){N=K}else{O=N;break}}}else{O=1.0}if(G<O){h[4486]=G}G=I/+(c[8976]|0);h[4489]=G;h[4493]=I;c[8958]=1;p=1;O=I;do{h[o>>3]=O*G;O=+rp(o,35896);h[4493]=O;p=p+1|0;c[8958]=p;}while((p|0)<4);h[4476]=+rp(35848,35944);sp(36008,35848,35904)|0;h[o>>3]=-+h[4481];sp(36e3,o,35904)|0;sp(35952,35808,35904)|0;h[o>>3]=-+h[4476];sp(35936,o,35904)|0;c[8966]=0;p=c[9002]|0;L=c[9e3]|0;P=c[8988]|0;Q=(p|0)==(P|0);do{if((p|0)==(L|0)&(P|0)==(c[8984]|0)){if(Q){c[8980]=p;R=0;S=25;break}if((P-p|0)==3){c[8980]=p+ -1+(c[8960]|0);c[8966]=1;R=1;S=25;break}else{c[8980]=(p|0)<=(P|0)?p:P;a[35544]=1;S=26;break}}else{T=Q&(L|0)==(c[8984]|0);U=p-L|0;c[n>>2]=U;V=(((U|0)>-1?U:0-U|0)|0)==1;if(T){if(V){c[8980]=(p|0)>=(L|0)?p:L;R=0;S=25;break}else{c[8980]=(p|0)<=(L|0)?p:L;a[35544]=1;S=26;break}}T=c[8984]|0;U=(p|0)<=(L|0)?p:L;if(!(V&(P|0)==(T|0))){V=(U|0)<=(P|0)?U:P;c[n>>2]=V;c[8980]=(V|0)<=(T|0)?V:T;a[35544]=1;S=26;break}if((P-U|0)==3){c[8980]=((p|0)>=(L|0)?p:L)+ -1+(c[8960]|0);R=0;S=25;break}else{c[8980]=U;a[35544]=1;S=26;break}}}while(0);if((S|0)==25){if(a[35544]&1){S=26}else{W=R}}if((S|0)==26){a[35536]=0;FG(36016)|0;WF(36040,35920,4)|0;nG()|0;W=c[8966]|0}if((W|0)==0){X=(c[8998]|0)!=0|0}else{X=1}c[8966]=X;h[4496]=1.0;X=c[8980]|0;W=1-X|0;c[n>>2]=W;c[8958]=1;if((X|0)<=0){O=+h[4489];X=1;G=1.0;while(1){h[o>>3]=G*O;I=+rp(o,35896);h[4496]=I;n=X+1|0;c[8958]=n;if((X|0)<(W|0)){G=I;X=n}else{break}}}tp(35904,35840,35920,35864,35928,35976)|0;q=35904;r=c[8976]|0;c[b>>2]=r;s=35840;t=c[8960]|0;c[d>>2]=t;u=35880;v=c[8970]|0;c[e>>2]=v;w=35888;x=+h[4486];h[f>>3]=x;y=35920;z=c[8980]|0;c[g>>2]=z;A=35968;B=+h[4496];h[j>>3]=B;C=35928;D=c[8982]|0;c[k>>2]=D;E=35976;F=+h[4497];h[l>>3]=F;i=m;return 0}function qp(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;if(a[35432]&1){l=a[35504]&1;m=c[8878]|0;c[b>>2]=m;n=35480;o=c[8870]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=35528;r=c[8882]|0;c[f>>2]=r;i=g;return 0}a[35432]=1;h[4436]=1.0;h[4430]=1.0;h[4432]=1.0;s=1.0;do{s=s*2.0;h[4430]=s;h[4432]=+rp(35440,35488);h[j>>3]=-s;t=+rp(35456,j);h[4432]=t;}while(t==1.0);h[4431]=1.0;t=+rp(35440,35448);h[4432]=t;if(t==s){u=1.0;while(1){v=u*2.0;h[4431]=v;w=+rp(35440,35448);h[4432]=w;if(w==s){u=v}else{x=w;break}}}else{x=t}h[4437]=.25;h[4440]=x;h[j>>3]=-s;t=+rp(35456,j);h[4432]=t;y=~~(t+.25);c[8878]=y;t=+(y|0);h[4431]=t;u=t*.5;h[j>>3]=u;h[k>>3]=-t/100.0;h[4433]=+rp(j,k);w=+rp(35464,35440);h[4432]=w;z=w==s;a[35504]=z&1;h[j>>3]=u;h[k>>3]=t/100.0;h[4433]=+rp(j,k);w=+rp(35464,35440);h[4432]=w;if(z&w==s){a[35504]=0;A=0}else{A=z}h[j>>3]=u;w=+rp(j,35440);h[4434]=w;h[j>>3]=u;z=w==s&+rp(j,35520)>x;c[8882]=z?A&1:0;c[8870]=0;h[4430]=1.0;h[4432]=1.0;x=1.0;z=0;while(1){k=z+1|0;c[8870]=k;s=x*t;h[4430]=s;h[4432]=+rp(35440,35488);h[j>>3]=-s;w=+rp(35456,j);h[4432]=w;if(w==1.0){z=k;x=s}else{l=A;m=y;break}}c[b>>2]=m;n=35480;o=c[8870]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=35528;r=c[8882]|0;c[f>>2]=r;i=g;return 0}function rp(a,b){a=a|0;b=b|0;i=i;return+(+h[a>>3]+ +h[b>>3])}function sp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];h[4506]=g;j=1.0/+(c[d>>2]|0);h[4515]=j;h[4514]=0.0;c[a>>2]=1;h[f>>3]=g*j;k=+rp(f,36112);h[4508]=k;h[4510]=g;h[4511]=g;h[4512]=g;h[4513]=g;if(g==g&0.0==0.0){l=0;m=k}else{i=e;return 0}while(1){c[a>>2]=l;h[4506]=m;b=c[d>>2]|0;k=+(b|0);h[f>>3]=m/k;g=+rp(f,36112);h[4508]=g;h[f>>3]=g*k;k=+rp(f,36112);h[4510]=k;h[4512]=0.0;c[9014]=1;if((b|0)<1){n=0.0}else{o=1;p=0.0;while(1){q=g+p;if((o|0)<(b|0)){p=q;o=o+1|0}else{break}}h[4512]=q;c[9014]=b+1;n=q}h[f>>3]=m*j;p=+rp(f,36112);h[4509]=p;h[f>>3]=p/j;r=+rp(f,36112);h[4511]=r;h[4513]=0.0;o=c[d>>2]|0;c[9014]=1;if((o|0)<1){s=0.0}else{t=1;u=0.0;while(1){v=p+u;if((t|0)<(o|0)){u=v;t=t+1|0}else{break}}h[4513]=v;c[9014]=o+1;s=v}if(!(k==m&r==m&n==m&s==m)){break}l=(c[a>>2]|0)+ -1|0;m=g}i=e;return 0}function tp(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0;j=i;i=i+8|0;k=j;c[9038]=1;c[9046]=1;l=0-(c[d>>2]|0)|0;if((l|0)<2){m=2;n=l;o=2;p=1}else{l=1;q=2;while(1){c[9038]=q;r=l+1|0;c[9046]=r;s=q<<1;t=0-(c[d>>2]|0)|0;if((s|0)>(t|0)){break}else{q=s;l=r}}m=s;n=t;o=l+2|0;p=q}if((p|0)==(n|0)){c[9042]=n;u=n}else{c[9042]=m;c[9046]=o;u=m}m=c[d>>2]|0;o=((m+u|0)>(0-(p+m)|0)?p:u)<<1;c[9048]=o;u=o+(c[d>>2]|0)|0;d=u+ -1|0;c[f>>2]=d;do{if((((c[9046]|0)+1+(c[b>>2]|0)|0)%2|0|0)==1){if((c[a>>2]|0)!=2){v=d;break}o=u+ -2|0;c[f>>2]=o;v=o}else{v=d}}while(0);if((c[e>>2]|0)!=0){c[f>>2]=v+ -1}w=+(c[a>>2]|0);x=1.0/w;h[4522]=x;y=w+-1.0;h[4518]=y;h[4517]=0.0;v=c[b>>2]|0;c[9032]=1;do{if((v|0)<1){z=0.0}else{b=1;w=0.0;A=y;while(1){B=x*A;h[4518]=B;if(w<1.0){h[4520]=w}C=+rp(36136,36144);h[4517]=C;e=b+1|0;c[9032]=e;if((b|0)<(v|0)){b=e;w=C;A=B}else{break}}if(!(C>=1.0)){z=C;break}A=+h[4520];h[4517]=A;z=A}}while(0);v=c[f>>2]|0;c[9032]=1;if((v|0)<1){D=z;h[g>>3]=D;i=j;return 0}else{E=1;F=z}while(1){h[k>>3]=F*+(c[a>>2]|0);z=+rp(k,36200);h[4517]=z;f=E+1|0;c[9032]=f;if((E|0)<(v|0)){F=z;E=f}else{D=z;break}}h[g>>3]=D;i=j;return 0}function up(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;l=c[b>>2]|0;b=~l;c[f>>2]=0;m=c[d>>2]|0;n=m+ -1|0;if((m|0)<2){o=m}else{c[9054]=1;m=1;do{c[9060]=m+1;c[j>>2]=(c[d>>2]|0)+1-m;p=vp(j,a+(m+b+(fa(m,l)|0)<<3)|0,36248)|0;q=c[9054]|0;r=p+ -1+q|0;c[9056]=r;c[e+(q+ -1<<2)>>2]=r;r=c[9056]|0;q=c[9054]|0;p=fa(q,l)|0;s=+h[a+(r+b+p<<3)>>3];do{if(s==0.0){c[f>>2]=q}else{if((r|0)==(q|0)){t=r}else{h[4529]=s;u=a+(q+b+p<<3)|0;h[a+(p+b+r<<3)>>3]=+h[u>>3];h[u>>3]=+h[4529];t=q}u=fa(t,l)|0;h[4529]=-1.0/+h[a+(t+b+u<<3)>>3];c[j>>2]=(c[d>>2]|0)-t;wp(j,36232,a+(t-l+u<<3)|0,36248)|0;u=c[d>>2]|0;c[j>>2]=u;v=c[9060]|0;c[9052]=v;if((v|0)>(u|0)){break}else{w=v}do{v=c[9056]|0;x=fa(w,l)|0;h[4529]=+h[a+(x+b+v<<3)>>3];y=c[9054]|0;if((v|0)==(y|0)){z=v}else{A=a+(y+b+x<<3)|0;h[a+(v+b+x<<3)>>3]=+h[A>>3];h[A>>3]=+h[4529];z=y}c[k>>2]=(c[d>>2]|0)-z;y=z+1|0;A=36248;xp(k,36232,a+((fa(z,l)|0)+b+y<<3)|0,A,a+(y+b+x<<3)|0,A)|0;A=c[9052]|0;w=A+1|0;c[9052]=w;}while((A|0)<(u|0))}}while(0);q=c[9054]|0;m=q+1|0;c[9054]=m;}while((q|0)<(n|0));o=c[d>>2]|0}c[e+(o+ -1<<2)>>2]=o;o=c[d>>2]|0;if(!(+h[a+(o+b+(fa(o,l)|0)<<3)>>3]==0.0)){i=g;return 0}c[f>>2]=o;i=g;return 0}function vp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}if((c[d>>2]|0)!=1){c[9152]=1;j=+h[b>>3];if(!(j>=0.0)){k=-j}else{k=j}h[4577]=k;l=(c[d>>2]|0)+1|0;c[9152]=l;m=c[a>>2]|0;c[9150]=2;if((m|0)<2){g=1;i=e;return g|0}else{n=2;o=k;p=l;q=1}while(1){k=+h[b+(p+ -1<<3)>>3];l=!(k>=0.0);if(l){r=-k}else{r=k}if(!(r<=o)){if(l){s=-k}else{s=k}h[4577]=s;t=s;u=n}else{t=o;u=q}l=p+(c[d>>2]|0)|0;c[9152]=l;a=n+1|0;c[9150]=a;if((n|0)<(m|0)){n=a;o=t;p=l;q=u}else{g=u;break}}i=e;return g|0}t=+h[b>>3];if(!(t>=0.0)){v=-t}else{v=t}h[4577]=v;c[9150]=2;if((f|0)<2){g=1;i=e;return g|0}else{w=v;x=2;y=1}while(1){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){z=-v}else{z=v}if(!(z<=w)){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){A=-v}else{A=v}h[4577]=A;B=A;C=x}else{B=w;C=y}if((x|0)<(f|0)){w=B;x=x+1|0;y=C}else{break}}c[9150]=f+1;g=C;i=e;return g|0}function wp(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)!=1){e=fa(j,g)|0;c[9136]=1;k=(j|0)<0;if(k?(e|0)<2:(e|0)>0){l=1}else{i=f;return 0}do{m=d+(l+ -1<<3)|0;h[m>>3]=+h[b>>3]*+h[m>>3];l=l+j|0;}while(k?(l|0)>=(e|0):(l|0)<=(e|0));c[9136]=l;i=f;return 0}l=(g|0)%5|0;c[9138]=l;do{if((l|0)==0){n=c[a>>2]|0}else{c[9136]=1;if((l|0)>=1){g=1;while(1){e=d+(g+ -1<<3)|0;h[e>>3]=+h[b>>3]*+h[e>>3];if((g|0)<(l|0)){g=g+1|0}else{break}}c[9136]=l+1}g=c[a>>2]|0;if((g|0)>=5){n=g;break}i=f;return 0}}while(0);a=l+1|0;c[9136]=a;if((l|0)<(n|0)){o=a}else{i=f;return 0}do{a=d+(o+ -1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+2<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+3<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];o=o+5|0;}while((o|0)<=(n|0));c[9136]=o;i=f;return 0}function xp(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0;j=i;k=c[a>>2]|0;if((k|0)<1){i=j;return 0}l=+h[b>>3];if(l==0.0){i=j;return 0}do{if((c[e>>2]|0)==1){if((c[g>>2]|0)!=1){break}m=(k|0)%4|0;c[9122]=m;do{if((m|0)==0){n=c[a>>2]|0}else{c[9120]=1;if((m|0)>=1){o=l;p=1;q=0;while(1){r=f+(q<<3)|0;h[r>>3]=+h[r>>3]+o*+h[d+(q<<3)>>3];if((p|0)>=(m|0)){break}r=p;o=+h[b>>3];p=p+1|0;q=r}c[9120]=m+1}q=c[a>>2]|0;if((q|0)>=4){n=q;break}i=j;return 0}}while(0);q=m+1|0;c[9120]=q;if((m|0)<(n|0)){s=q}else{i=j;return 0}do{q=s+ -1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=f+(s<<3)|0;h[q>>3]=+h[q>>3]+ +h[b>>3]*+h[d+(s<<3)>>3];q=s+1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=s+2|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];s=s+4|0;}while((s|0)<=(n|0));c[9120]=s;i=j;return 0}}while(0);c[9124]=1;c[9126]=1;s=c[e>>2]|0;if((s|0)<0){n=(fa(1-(c[a>>2]|0)|0,s)|0)+1|0;c[9124]=n;t=n}else{t=1}n=c[g>>2]|0;if((n|0)<0){s=(fa(1-(c[a>>2]|0)|0,n)|0)+1|0;c[9126]=s;u=s}else{u=1}s=c[a>>2]|0;c[9120]=1;if((s|0)<1){i=j;return 0}else{v=l;w=1;x=u;y=t}while(1){t=f+(x+ -1<<3)|0;h[t>>3]=v*+h[d+(y+ -1<<3)>>3]+ +h[t>>3];t=y+(c[e>>2]|0)|0;c[9124]=t;u=x+(c[g>>2]|0)|0;c[9126]=u;a=w+1|0;c[9120]=a;if((w|0)>=(s|0)){break}v=+h[b>>3];y=t;x=u;w=a}i=j;return 0}function yp(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;j=i;i=i+8|0;k=j;l=c[b>>2]|0;b=~l;m=c[d>>2]|0;n=m+ -1|0;c[9072]=n;if((c[g>>2]|0)==0){if((m|0)>=2){c[9064]=1;m=1;do{g=m+ -1|0;o=c[e+(g<<2)>>2]|0;c[9066]=o;p=f+(o+ -1<<3)|0;h[4534]=+h[p>>3];if((o|0)!=(m|0)){o=f+(g<<3)|0;h[p>>3]=+h[o>>3];h[o>>3]=+h[4534]}c[k>>2]=(c[d>>2]|0)-m;o=36248;xp(k,36272,a+(m-l+(fa(m,l)|0)<<3)|0,o,f+(m<<3)|0,o)|0;o=c[9064]|0;m=o+1|0;c[9064]=m;}while((o|0)<(n|0))}m=c[d>>2]|0;c[9070]=1;if((m|0)<1){i=j;return 0}else{q=1}do{o=1-q+(c[d>>2]|0)|0;c[9064]=o;p=fa(o,l)|0;g=o+ -1|0;r=f+(g<<3)|0;s=+h[r>>3]/+h[a+(o+b+p<<3)>>3];h[r>>3]=s;h[4534]=-s;c[k>>2]=g;g=36248;xp(k,36272,a+(p-l<<3)|0,g,f,g)|0;g=c[9070]|0;q=g+1|0;c[9070]=q;}while((g|0)<(m|0));i=j;return 0}m=c[d>>2]|0;c[9064]=1;if((m|0)<1){t=n}else{n=1;do{c[k>>2]=n+ -1;q=36248;s=+zp(k,a+((fa(n,l)|0)-l<<3)|0,q,f,q);h[4534]=s;q=c[9064]|0;g=f+(q+ -1<<3)|0;h[g>>3]=(+h[g>>3]-s)/+h[a+(q+b+(fa(q,l)|0)<<3)>>3];n=q+1|0;c[9064]=n;}while((q|0)<(m|0));t=c[9072]|0}if((t|0)<1){i=j;return 0}c[9070]=1;m=1;do{n=(c[d>>2]|0)-m|0;c[9064]=n;c[k>>2]=(c[d>>2]|0)-n;b=36248;s=+zp(k,a+(n-l+(fa(n,l)|0)<<3)|0,b,f+(n<<3)|0,b);b=c[9064]|0;n=b+ -1|0;q=f+(n<<3)|0;h[q>>3]=s+ +h[q>>3];g=c[e+(n<<2)>>2]|0;c[9066]=g;if((g|0)!=(b|0)){b=f+(g+ -1<<3)|0;h[4534]=+h[b>>3];h[b>>3]=+h[q>>3];h[q>>3]=+h[4534]}q=c[9070]|0;m=q+1|0;c[9070]=m;}while((q|0)<(t|0));i=j;return 0}function zp(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0;g=i;h[4574]=0.0;j=c[a>>2]|0;if((j|0)<1){k=0.0;i=g;return+k}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}l=(j|0)%5|0;c[9142]=l;do{if((l|0)==0){m=c[a>>2]|0;n=0.0}else{c[9140]=1;if((l|0)<1){o=0.0}else{p=0.0;q=1;while(1){r=q+ -1|0;s=p+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3];h[4574]=s;if((q|0)<(l|0)){q=q+1|0;p=s}else{break}}c[9140]=l+1;o=s}q=c[a>>2]|0;if((q|0)<5){k=o}else{m=q;n=o;break}i=g;return+k}}while(0);q=l+1|0;c[9140]=q;if((l|0)<(m|0)){t=n;u=q}else{k=n;i=g;return+k}do{q=u+ -1|0;r=u+1|0;v=u+2|0;w=u+3|0;t=t+ +h[b+(q<<3)>>3]*+h[e+(q<<3)>>3]+ +h[b+(u<<3)>>3]*+h[e+(u<<3)>>3]+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3]+ +h[b+(v<<3)>>3]*+h[e+(v<<3)>>3]+ +h[b+(w<<3)>>3]*+h[e+(w<<3)>>3];h[4574]=t;u=u+5|0;}while((u|0)<=(m|0));c[9140]=u;k=t;i=g;return+k}}while(0);c[9144]=1;c[9146]=1;u=c[d>>2]|0;if((u|0)<0){m=(fa(1-(c[a>>2]|0)|0,u)|0)+1|0;c[9144]=m;x=m}else{x=1}m=c[f>>2]|0;if((m|0)<0){u=(fa(1-(c[a>>2]|0)|0,m)|0)+1|0;c[9146]=u;y=u}else{y=1}u=c[a>>2]|0;c[9140]=1;if((u|0)<1){k=0.0;i=g;return+k}else{z=1;A=0.0;B=y;C=x}while(1){t=A+ +h[b+(C+ -1<<3)>>3]*+h[e+(B+ -1<<3)>>3];h[4574]=t;x=C+(c[d>>2]|0)|0;c[9144]=x;y=B+(c[f>>2]|0)|0;c[9146]=y;a=z+1|0;c[9140]=a;if((z|0)<(u|0)){C=x;B=y;A=t;z=a}else{k=t;break}}i=g;return+k}function Ap(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+8|0;l=k;m=c[b>>2]|0;b=~m;c[9082]=(c[e>>2]|0)+1+(c[f>>2]|0);c[j>>2]=0;n=(c[f>>2]|0)+2|0;c[9088]=n;o=c[d>>2]|0;p=c[9082]|0;q=(o|0)>(p|0)?p:o;o=q+ -1|0;c[9090]=o;do{if((q|0)>(n|0)){c[9098]=n;if((n|0)>(o|0)){break}else{r=n}while(1){s=1-r+p|0;c[9086]=s;t=c[e>>2]|0;c[9074]=s;if((s|0)<=(t|0)){u=s;while(1){h[a+(u+b+(fa(r,m)|0)<<3)>>3]=0.0;if((u|0)<(t|0)){u=u+1|0}else{break}}c[9074]=t+1}u=r+1|0;c[9098]=u;if((r|0)<(o|0)){r=u}else{break}}c[l>>2]=t}}while(0);c[9098]=o;c[9096]=0;t=c[d>>2]|0;r=t+ -1|0;if((t|0)<2){v=t}else{c[9078]=1;t=o;o=1;while(1){c[9100]=o+1;p=t+1|0;c[9098]=p;n=c[d>>2]|0;do{if((t|0)<(n|0)){q=c[e>>2]|0;if((q|0)<1){w=n;break}c[l>>2]=q;c[9074]=1;u=fa(p,m)|0;s=1;while(1){h[a+(s+b+u<<3)>>3]=0.0;if((s|0)<(q|0)){s=s+1|0}else{break}}c[9074]=q+1;w=c[d>>2]|0}else{w=n}}while(0);n=c[e>>2]|0;p=w-o|0;s=(n|0)<=(p|0)?n:p;c[9092]=s;c[l>>2]=s+1;s=vp(l,a+((c[9082]|0)+b+(fa(o,m)|0)<<3)|0,36248)|0;p=s+ -1|0;c[9080]=p+(c[9082]|0);s=c[9078]|0;c[g+(s+ -1<<2)>>2]=p+s;s=c[9080]|0;p=c[9078]|0;n=fa(p,m)|0;x=+h[a+(s+b+n<<3)>>3];a:do{if(x==0.0){c[j>>2]=p}else{u=c[9082]|0;if((s|0)==(u|0)){y=s}else{h[4542]=x;z=a+(u+b+n<<3)|0;h[a+(n+b+s<<3)>>3]=+h[z>>3];h[z>>3]=+h[4542];y=u}h[4542]=-1.0/+h[a+(y+b+n<<3)>>3];wp(36368,36336,a+(y-m+n<<3)|0,36248)|0;u=c[9096]|0;z=(c[g+((c[9078]|0)+ -1<<2)>>2]|0)+(c[f>>2]|0)|0;A=(u|0)>=(z|0)?u:z;c[l>>2]=A;z=c[d>>2]|0;u=(A|0)>(z|0)?z:A;c[9096]=u;A=c[9082]|0;c[9094]=A;z=c[9100]|0;if((u|0)<(z|0)){break}c[l>>2]=u;c[9076]=z;B=z;z=A;while(1){A=(c[9080]|0)+ -1|0;c[9080]=A;C=z+ -1|0;c[9094]=C;D=fa(B,m)|0;E=a+(A+b+D<<3)|0;h[4542]=+h[E>>3];if((A|0)==(C|0)){F=A}else{A=a+(C+b+D<<3)|0;h[E>>3]=+h[A>>3];h[A>>3]=+h[4542];F=C}C=36248;xp(36368,36336,a+((c[9082]|0)-m+(fa(c[9078]|0,m)|0)<<3)|0,C,a+(F-m+D<<3)|0,C)|0;C=c[9076]|0;D=C+1|0;c[9076]=D;if((C|0)>=(u|0)){break a}B=D;z=c[9094]|0}}}while(0);n=c[9078]|0;s=n+1|0;c[9078]=s;if((n|0)>=(r|0)){break}t=c[9098]|0;o=s}v=c[d>>2]|0}c[g+(v+ -1<<2)>>2]=v;v=c[d>>2]|0;if(!(+h[a+((c[9082]|0)+b+(fa(v,m)|0)<<3)>>3]==0.0)){i=k;return 0}c[j>>2]=v;i=k;return 0}function Bp(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0;l=i;m=c[b>>2]|0;b=~m;n=(c[f>>2]|0)+1+(c[e>>2]|0)|0;c[9106]=n;f=c[d>>2]|0;o=f+ -1|0;c[9118]=o;if((c[k>>2]|0)==0){if(!((c[e>>2]|0)==0|(f|0)<2)){c[9102]=1;f=1;do{k=c[e>>2]|0;p=(c[d>>2]|0)-f|0;c[9116]=(k|0)<=(p|0)?k:p;p=f+ -1|0;k=c[g+(p<<2)>>2]|0;c[9104]=k;q=j+(k+ -1<<3)|0;h[4554]=+h[q>>3];if((k|0)!=(f|0)){k=j+(p<<3)|0;h[q>>3]=+h[k>>3];h[k>>3]=+h[4554]}k=36248;xp(36464,36432,a+((c[9106]|0)-m+(fa(f,m)|0)<<3)|0,k,j+(f<<3)|0,k)|0;k=c[9102]|0;f=k+1|0;c[9102]=f;}while((k|0)<(o|0))}f=c[d>>2]|0;c[9110]=1;if((f|0)<1){i=l;return 0}else{r=1}do{k=1-r+(c[d>>2]|0)|0;c[9102]=k;q=c[9106]|0;p=fa(k,m)|0;s=j+(k+ -1<<3)|0;t=+h[s>>3]/+h[a+(q+b+p<<3)>>3];h[s>>3]=t;s=((k|0)<=(q|0)?k:q)+ -1|0;c[9116]=s;u=q-s|0;c[9112]=u;q=k-s|0;c[9114]=q;h[4554]=-t;s=36248;xp(36464,36432,a+(u+b+p<<3)|0,s,j+(q+ -1<<3)|0,s)|0;s=c[9110]|0;r=s+1|0;c[9110]=r;}while((s|0)<(f|0));i=l;return 0}f=c[d>>2]|0;c[9102]=1;if((f|0)<1){v=n;w=o}else{o=n;n=1;do{r=((n|0)<=(o|0)?n:o)+ -1|0;c[9116]=r;s=o-r|0;c[9112]=s;q=n-r|0;c[9114]=q;r=36248;t=+zp(36464,a+((fa(n,m)|0)+b+s<<3)|0,r,j+(q+ -1<<3)|0,r);h[4554]=t;r=c[9102]|0;q=j+(r+ -1<<3)|0;o=c[9106]|0;h[q>>3]=(+h[q>>3]-t)/+h[a+((fa(r,m)|0)+b+o<<3)>>3];n=r+1|0;c[9102]=n;}while((r|0)<(f|0));v=o;w=c[9118]|0}if((c[e>>2]|0)==0|(w|0)<1){i=l;return 0}c[9110]=1;o=v;v=1;while(1){f=(c[d>>2]|0)-v|0;c[9102]=f;n=c[e>>2]|0;b=(c[d>>2]|0)-f|0;c[9116]=(n|0)<=(b|0)?n:b;b=36248;t=+zp(36464,a+(o-m+(fa(f,m)|0)<<3)|0,b,j+(f<<3)|0,b);b=c[9102]|0;f=b+ -1|0;n=j+(f<<3)|0;h[n>>3]=t+ +h[n>>3];r=c[g+(f<<2)>>2]|0;c[9104]=r;if((r|0)!=(b|0)){b=j+(r+ -1<<3)|0;h[4554]=+h[b>>3];h[b>>3]=+h[n>>3];h[n>>3]=+h[4554]}n=c[9110]|0;b=n+1|0;c[9110]=b;if((n|0)>=(w|0)){break}o=c[9106]|0;v=b}i=l;return 0}function Cp(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}k=(j|0)%7|0;c[9130]=k;do{if((k|0)==0){l=c[a>>2]|0}else{c[9128]=1;if((k|0)>=1){m=1;while(1){n=m+ -1|0;h[e+(n<<3)>>3]=+h[b+(n<<3)>>3];if((m|0)<(k|0)){m=m+1|0}else{break}}c[9128]=k+1}m=c[a>>2]|0;if((m|0)>=7){l=m;break}i=g;return 0}}while(0);m=k+1|0;c[9128]=m;if((k|0)<(l|0)){o=m}else{i=g;return 0}do{m=o+ -1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];h[e+(o<<3)>>3]=+h[b+(o<<3)>>3];m=o+1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+2|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+3|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+4|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+5|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];o=o+7|0;}while((o|0)<=(l|0));c[9128]=o;i=g;return 0}}while(0);c[9132]=1;c[9134]=1;o=c[d>>2]|0;if((o|0)<0){l=(fa(1-(c[a>>2]|0)|0,o)|0)+1|0;c[9132]=l;p=l}else{p=1}l=c[f>>2]|0;if((l|0)<0){o=(fa(1-(c[a>>2]|0)|0,l)|0)+1|0;c[9134]=o;q=o}else{q=1}o=c[a>>2]|0;c[9128]=1;if((o|0)<1){i=g;return 0}else{r=1;s=q;t=p}while(1){h[e+(s+ -1<<3)>>3]=+h[b+(t+ -1<<3)>>3];p=t+(c[d>>2]|0)|0;c[9132]=p;q=s+(c[f>>2]|0)|0;c[9134]=q;a=r+1|0;c[9128]=a;if((r|0)<(o|0)){t=p;s=q;r=a}else{break}}i=g;return 0}function Dp(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0;d=i;m=+Ep(36624);n=c[a>>2]|0;o=(n|0)<1;do{if(!o){p=((fa(n+1|0,n)|0)/2|0)+1|0;q=1;while(1){r=n-q|0;s=r+1|0;t=r+2|0;u=p-q|0;if((n|0)<(t|0)){v=0.0}else{w=t;t=u;x=0.0;while(1){y=x+ +h[b+(t<<3)>>3]*+h[j+(w+ -1<<3)>>3];if((w|0)<(n|0)){x=y;t=t+1|0;w=w+1|0}else{v=y;break}}}x=+h[b+(u+ -1<<3)>>3];do{if(x!=0.0){z=x}else{if((r|0)<0){A=x}else{w=1;t=s;y=x;while(1){B=+h[b+(t+ -1<<3)>>3];if(!(B>=0.0)){C=-B}else{C=B}B=y>=C?y:C;D=t-w+n|0;if((w|0)<(s|0)){w=w+1|0;t=D;y=B}else{A=B;break}}}y=m*A;if(!(y==0.0)){z=y;break}z=m}}while(0);h[j+(r<<3)>>3]=(+h[f+(r<<3)>>3]-v)/z;if((q|0)<(n|0)){q=q+1|0;p=u}else{break}}if(o){break}else{E=1}while(1){p=E+ -1|0;h[k+(p<<3)>>3]=0.0;h[l+(p<<3)>>3]=+h[e+(p<<3)>>3]*+h[j+(p<<3)>>3];if((E|0)<(n|0)){E=E+1|0}else{break}}}}while(0);z=+Fp(a,l);if(z<=+h[g>>3]){i=d;return 0}E=c[a>>2]|0;if((E|0)>=1){n=E;o=1;p=1;while(1){q=o+ -1|0;v=+h[f+(q<<3)>>3];if((o|0)>(E|0)){F=p}else{s=o;t=p;while(1){w=k+(s+ -1<<3)|0;h[w>>3]=+h[w>>3]+v*+h[b+(t+ -1<<3)>>3];if((s|0)<(E|0)){t=t+1|0;s=s+1|0}else{break}}F=p+n|0}s=k+(q<<3)|0;h[s>>3]=+h[s>>3]/+h[e+(q<<3)>>3];if((o|0)<(E|0)){n=n+ -1|0;o=o+1|0;p=F}else{break}}}v=+Fp(a,k);m=+h[g>>3];do{if(v==0.0){G=m;H=m/z;I=0.0}else{F=c[a>>2]|0;p=(F|0)<1;do{if(!p){o=1;while(1){n=o+ -1|0;E=k+(n<<3)|0;h[E>>3]=+h[E>>3]/v/+h[e+(n<<3)>>3];if((o|0)<(F|0)){o=o+1|0}else{break}}if(p){break}else{J=F;K=1;L=1}while(1){if((K|0)>(F|0)){M=L;N=0.0}else{o=K;u=L;A=0.0;while(1){O=A+ +h[b+(u+ -1<<3)>>3]*+h[k+(o+ -1<<3)>>3];if((o|0)<(F|0)){A=O;u=u+1|0;o=o+1|0}else{break}}M=L+J|0;N=O}h[l+(K+ -1<<3)>>3]=N;if((K|0)<(F|0)){J=J+ -1|0;K=K+1|0;L=M}else{break}}}}while(0);A=+Fp(a,l);C=v/A/A;A=+h[g>>3];if(C>=A){G=A;H=0.0;I=C;break}A=+Fp(a,f);x=+h[g>>3];y=C/x;B=A/v*(A/z)*y;A=x/z;P=B-A;Q=y*y;y=1.0-Q;G=x;H=A*y/(+V(+(P*P+y*(1.0-A*A)))+(B-A*Q));I=C}}while(0);z=(1.0-H)*(!(I<=G)?G:I);g=c[a>>2]|0;if((g|0)<1){i=d;return 0}else{R=1}while(1){a=R+ -1|0;f=j+(a<<3)|0;h[f>>3]=z*+h[k+(a<<3)>>3]+H*+h[f>>3];if((R|0)<(g|0)){R=R+1|0}else{break}}i=d;return 0}function Ep(a){a=a|0;i=i;return+(+h[36632+((((c[a>>2]<<3)+ -8|0)/8|0)<<3)>>3])}function Fp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;d=i;e=c[a>>2]|0;f=1304.0e16/+(e|0);do{if((e|0)<1){g=0.0;j=0.0}else{a=1;k=0.0;l=0.0;m=0.0;n=0.0;o=0.0;while(1){p=+h[b+(a+ -1<<3)>>3];if(!(p>=0.0)){q=-p}else{q=p}do{if(q>3.834e-20&q<f){r=k;s=l+q*q;t=m;u=n;v=o}else{if(!(q<=3.834e-20)){if(!(q<=n)){p=n/q;r=k*p*p+1.0;s=l;t=m;u=q;v=o;break}else{p=q/n;r=k+p*p;s=l;t=m;u=n;v=o;break}}if(!(q<=o)){p=o/q;r=k;s=l;t=m*p*p+1.0;u=n;v=q;break}if(!(q!=0.0)){r=k;s=l;t=m;u=n;v=o;break}p=q/o;r=k;s=l;t=m+p*p;u=n;v=o}}while(0);if((a|0)<(e|0)){a=a+1|0;k=r;l=s;m=t;n=u;o=v}else{break}}if(!(r==0.0)){w=u*+V(+(r+s/u/u));i=d;return+w}if(s==0.0){g=t;j=v;break}if(!(s>=v)){x=0.0}else{x=+V(+(s*(t*v*(v/s)+1.0)))}if(!(s<v)){w=x;i=d;return+w}w=+V(+(v*(t*v+s/v)));i=d;return+w}}while(0);w=j*+V(+g);i=d;return+w}function Gp(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;var B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0.0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0;B=i;i=i+32|0;C=B;D=B+8|0;E=B+16|0;F=B+24|0;G=c[g>>2]|0;H=~G;I=+Ep(36664);c[p>>2]=0;c[E>>2]=0;c[q>>2]=0;c[r>>2]=0;K=c[b>>2]|0;a:do{if((K|0)<1){L=97}else{if((c[g>>2]|0)<(K|0)){L=97;break}if(+h[j>>3]<0.0){L=97;break}if((c[k>>2]|0)<1){L=97;break}if(+h[n>>3]<=0.0){L=97;break}if((c[t>>2]|0)<((fa(K+1|0,K)|0)/2|0|0)){L=97;break}if((c[m>>2]|0)==2){M=1;while(1){if(+h[l+(M+ -1<<3)>>3]<=0.0){L=97;break a}if((M|0)<(K|0)){M=M+1|0}else{break}}}c[E>>2]=1;M=a;we[M&15](b,d,e,f,g,E,z,A)|0;c[q>>2]=1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}P=+Fp(b,e);c[E>>2]=2;we[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}N=C;Q=P;R=1;S=0;T=0;U=0;V=0;P=0.0;b:while(1){Op(b,b,f,g,36672,N,36664,v,w,x)|0;do{if((R|0)==1){W=c[b>>2]|0;do{if((c[m>>2]|0)==2){L=20}else{if((W|0)<1){break}else{X=1}while(1){Y=X+ -1|0;Z=w+(Y<<3)|0;_=l+(Y<<3)|0;h[_>>3]=+h[Z>>3];if(+h[Z>>3]==0.0){h[_>>3]=1.0}if((X|0)<(W|0)){X=X+1|0}else{L=20;break}}}}while(0);do{if((L|0)==20){L=0;if((W|0)<1){break}else{$=1}while(1){_=$+ -1|0;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[d+(_<<3)>>3];if(($|0)<(W|0)){$=$+1|0}else{break}}}}while(0);aa=+Fp(b,x);ba=+h[n>>3];ca=aa*ba;h[F>>3]=ca;if(!(ca==0.0)){da=aa;break}h[F>>3]=ba;da=aa}else{da=P}}while(0);W=c[b>>2]|0;_=(W|0)<1;do{if(_){L=35}else{Z=1;while(1){Y=Z+ -1|0;h[u+(Y<<3)>>3]=+h[e+(Y<<3)>>3];if((Z|0)<(W|0)){Z=Z+1|0}else{break}}if(_){L=35;break}else{ea=1}while(1){Z=fa(ea,G)|0;aa=+h[f+(ea+H+Z<<3)>>3];do{if(!(aa==0.0)){Y=(ea|0)>(W|0);if(Y){break}ga=Z+H|0;ha=ea;ba=0.0;while(1){ia=ba+ +h[f+(ga+ha<<3)>>3]*+h[u+(ha+ -1<<3)>>3];if((ha|0)<(W|0)){ba=ia;ha=ha+1|0}else{break}}ba=-ia/aa;if(Y){break}ha=Z+H|0;ga=ea;while(1){ja=u+(ga+ -1<<3)|0;h[ja>>3]=+h[ja>>3]+ba*+h[f+(ha+ga<<3)>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}}while(0);if((ea|0)<(W|0)){ea=ea+1|0}else{break}}c[D>>2]=0;if(_){break}else{ka=0;la=1}while(1){Z=(ka|0)>1?ka:1;ga=Z+ -1|0;ha=XS(ga|0,0,Z+ -2|0,0)|0;Z=QS(ha|0,J&1|0,1)|0;ha=la+ -1|0;if((la|0)<2){ma=la}else{Y=(fa(la,G)|0)+H|0;ja=W+ka+(fa(ga,W+ -2|0)|0)|0;ga=1;na=la;while(1){h[s+(na+ -1<<3)>>3]=+h[f+(Y+ga<<3)>>3];if((ga|0)<(ha|0)){na=na-ga+W|0;ga=ga+1|0}else{break}}ma=ja-Z|0}ga=v+(ha<<3)|0;h[s+(ma+ -1<<3)>>3]=+h[ga>>3];if(+h[ga>>3]==0.0){c[D>>2]=1}if((la|0)<(W|0)){ka=ka+1|0;la=la+1|0}else{break}}}}while(0);if((L|0)==35){L=0;c[D>>2]=0}Np(b,b,f,g,v)|0;do{if((c[m>>2]|0)==2){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da}else{W=c[b>>2]|0;if((W|0)<1){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}else{wa=1}while(1){_=wa+ -1|0;ga=l+(_<<3)|0;aa=+h[ga>>3];ba=+h[w+(_<<3)>>3];h[ga>>3]=aa>=ba?aa:ba;if((wa|0)<(W|0)){wa=wa+1|0}else{oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}}}}while(0);while(1){W=c[o>>2]|0;do{if((W|0)>=1){c[E>>2]=0;if(((pa+ -1|0)%(W|0)|0|0)!=0){break}we[M&15](b,d,e,f,g,E,z,A)|0;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}}}while(0);Dp(b,s,t,l,u,F,v,w,x)|0;W=c[b>>2]|0;if((W|0)>=1){ga=1;while(1){_=ga+ -1|0;na=v+(_<<3)|0;ba=+h[na>>3];h[na>>3]=-ba;h[w+(_<<3)>>3]=+h[d+(_<<3)>>3]-ba;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[na>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}ba=+Fp(b,x);if((pa|0)==1){aa=+h[F>>3];h[F>>3]=aa<=ba?aa:ba}c[E>>2]=1;we[M&15](b,w,y,f,g,E,z,A)|0;c[q>>2]=(c[q>>2]|0)+1;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}aa=+Fp(b,y);if(aa<oa){ca=aa/oa;xa=1.0-ca*ca}else{xa=-1.0}ga=c[b>>2]|0;if((ga|0)>=1){W=1;na=ga;_=1;while(1){if((W|0)>(ga|0)){ya=_;za=0.0}else{Y=W;Aa=_;ca=0.0;while(1){Ba=ca+ +h[s+(Aa+ -1<<3)>>3]*+h[v+(Y+ -1<<3)>>3];if((Y|0)<(ga|0)){ca=Ba;Aa=Aa+1|0;Y=Y+1|0}else{break}}ya=_+na|0;za=Ba}Y=W+ -1|0;h[x+(Y<<3)>>3]=za+ +h[u+(Y<<3)>>3];if((W|0)<(ga|0)){W=W+1|0;na=na+ -1|0;_=ya}else{break}}}ca=+Fp(b,x);do{if(ca<oa){Ca=ca/oa;Da=1.0-Ca*Ca;if(!(Da>0.0)){Ea=0.0;L=65;break}Ca=xa/Da;if(!(Ca>=.1)){Ea=Ca;L=65;break}_=sa+1|0;if(Ca>=.5|(sa|0)>0){Da=+h[F>>3];Fa=ba*2.0;h[F>>3]=Da>=Fa?Da:Fa}Fa=Ca+-1.0;if(!(Fa>=0.0)){Ga=-Fa}else{Ga=Fa}if(!(Ga<=.1)){Ha=0;Ia=_;Ja=Ca;break}h[F>>3]=ba*2.0;Ha=0;Ia=_;Ja=Ca}else{Ea=0.0;L=65}}while(0);if((L|0)==65){L=0;h[F>>3]=+h[F>>3]*.5;Ha=ra+1|0;Ia=0;Ja=Ea}if(Ja<1.0e-4){Ka=oa;La=pa;Ma=va}else{_=c[b>>2]|0;if((_|0)>=1){na=1;while(1){W=na+ -1|0;ga=w+(W<<3)|0;ca=+h[ga>>3];h[d+(W<<3)>>3]=ca;h[ga>>3]=ca*+h[l+(W<<3)>>3];h[e+(W<<3)>>3]=+h[y+(W<<3)>>3];if((na|0)<(_|0)){na=na+1|0}else{break}}}Ka=aa;La=pa+1|0;Ma=+Fp(b,w)}Na=!(xa>=.001)?ta+1|0:0;Oa=!(xa>=.1)?ua+qa|0:0;ca=+h[F>>3];if(ca<=Ma*+h[j>>3]|Ka==0.0){L=77;break b}if((c[p>>2]|0)!=0){L=97;break a}if((c[q>>2]|0)<(c[k>>2]|0)){Pa=0}else{c[p>>2]=2;Pa=2}Ca=ca*.1;if(!((Ca>=ba?Ca:ba)*.1<=I*Ma)){Qa=Pa}else{c[p>>2]=3;Qa=3}if((Oa|0)==5){c[p>>2]=4;Ra=4}else{Ra=Qa}if((Na|0)==10){L=86;break b}if((Ra|0)!=0){L=97;break a}if((Ha|0)==2){break}na=c[b>>2]|0;if((na|0)>=1){_=!(Ja>=1.0e-4);W=1;while(1){ga=(fa(W,G)|0)+H|0;Y=1;Ca=0.0;while(1){Sa=Ca+ +h[f+(ga+Y<<3)>>3]*+h[y+(Y+ -1<<3)>>3];if((Y|0)<(na|0)){Ca=Sa;Y=Y+1|0}else{break}}Y=W+ -1|0;h[w+(Y<<3)>>3]=(Sa- +h[x+(Y<<3)>>3])/ba;Ca=+h[l+(Y<<3)>>3];ga=v+(Y<<3)|0;h[ga>>3]=Ca*(Ca*+h[ga>>3]/ba);if(!_){h[u+(Y<<3)>>3]=Sa}if((W|0)<(na|0)){W=W+1|0}else{break}}}Qp(b,b,s,t,v,w,x,D)|0;Pp(b,b,f,g,w,x)|0;W=36664;Pp(W,b,u,W,w,x)|0;oa=Ka;pa=La;qa=0;ra=Ha;sa=Ia;ta=Na;ua=Oa;va=Ma}c[E>>2]=2;we[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;W=c[E>>2]|0;if((W|0)<0){O=W;L=98;break a}else{Q=Ka;R=La;S=2;T=Ia;U=Na;V=Oa;P=Ma}}if((L|0)==77){c[p>>2]=1;L=97;break}else if((L|0)==86){c[p>>2]=5;L=97;break}}}while(0);if((L|0)==97){Oa=c[E>>2]|0;if((Oa|0)<0){O=Oa;L=98}}if((L|0)==98){c[p>>2]=O}c[E>>2]=0;if((c[o>>2]|0)<=0){i=B;return 0}we[a&15](b,d,e,f,g,E,z,A)|0;i=B;return 0}function Hp(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;if((a[b]|0)==(a[e]|0)){h=1;i=g;return h|0}a[36696]=1;f=d[b]|0;c[9170]=f;b=d[e]|0;c[9172]=b;if((f+ -97|0)>>>0<26){e=f+ -32|0;c[9170]=e;j=e}else{j=f}if((b+ -97|0)>>>0<26){f=b+ -32|0;c[9172]=f;k=f}else{k=b}h=(j|0)==(k|0)|0;i=g;return h|0}function Ip(b,d,e,f,g,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0.0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;r=i;if((c[j>>2]|0)>0){c[46228>>2]=6;FG(46224)|0;WF(46968,j,4)|0;nG()|0}c[q>>2]=0;s=(c[e>>2]|0)<1?3:0;c[q>>2]=s;t=(c[l>>2]|0)<1?4:s;c[q>>2]=t;if((t|0)!=0){i=r;return 0}c[10858]=0;c[11464]=0;c[11452]=0;a[45832]=0;t=c[e>>2]|0;c[10412]=1;do{if((t|0)>=1){s=0;u=1;while(1){if(+h[d+(u+ -1<<3)>>3]!=0.0){v=s+1|0;c[10858]=v;w=v}else{w=s}if((u|0)<(t|0)){s=w;u=u+1|0}else{break}}c[10412]=t+1;if((w|0)<=0){break}u=p;s=f;a:while(1){v=c[e>>2]|0;c[10412]=1;if((v|0)>=1){x=1;while(1){h[38120+((x*21|0)+ -21<<3)>>3]=+h[b+(x+ -1<<3)>>3];if((x|0)<(v|0)){x=x+1|0}else{break}}c[10412]=v+1}c[11456]=2;x=c[e>>2]|0;c[10412]=1;if((x|0)>=1){y=2;z=1;while(1){A=z+ -1|0;B=d+(A<<3)|0;C=+h[B>>3];if(C==0.0){D=y}else{E=c[e>>2]|0;c[10414]=1;if((E|0)<1){F=C}else{G=1;while(1){h[38120+((G*21|0)+ -22+y<<3)>>3]=+h[b+(G+ -1<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[10414]=E+1;F=+h[B>>3]}h[38120+((z*21|0)+ -22+y<<3)>>3]=+h[b+(A<<3)>>3]+F;G=y+1|0;c[11456]=G;D=G}G=z+1|0;c[10412]=G;if((z|0)<(x|0)){y=D;z=G}else{break}}}z=c[10858]|0;y=z+1|0;c[10854]=y;c[10412]=1;if((z|0)>=0){z=1;do{x=c[e>>2]|0;c[10414]=1;if((x|0)>=1){v=1;while(1){h[b+(v+ -1<<3)>>3]=+h[38120+((v*21|0)+ -22+z<<3)>>3];if((v|0)<(x|0)){v=v+1|0}else{break}}c[10414]=x+1}be[u&63](e,b,41480+(z+ -1<<3)|0)|0;c[11464]=(c[11464]|0)+1;if((c[j>>2]|0)>=1){c[46252>>2]=6;FG(46248)|0;WF(46968,45856,4)|0;WF(46968,41480+((c[10412]|0)+ -1<<3)|0,8)|0;v=c[e>>2]|0;c[10414]=1;if((v|0)>=1){A=1;do{WF(46968,b+(A+ -1<<3)|0,8)|0;B=c[10414]|0;A=B+1|0;c[10414]=A;}while((B|0)<(v|0))}nG()|0}v=c[10412]|0;z=v+1|0;c[10412]=z;}while((v|0)<(y|0))}y=c[11452]|0;b:while(1){c[11452]=y+1;c[11364]=1;c[11360]=1;C=+h[5185];h[5681]=C;h[5683]=C;z=c[10854]|0;c[10412]=2;if((z|0)<2){H=1}else{I=C;K=C;v=1;A=2;while(1){C=+h[41480+(A+ -1<<3)>>3];do{if(!(C<=K)){c[11364]=A;L=+h[41480+(A+ -1<<3)>>3];h[5681]=L;M=I;N=L;O=A}else{if(C>=I){M=I;N=K;O=v;break}c[11360]=A;L=+h[41480+(A+ -1<<3)>>3];h[5683]=L;M=L;N=K;O=v}}while(0);if((A|0)<(z|0)){I=M;K=N;v=O;A=A+1|0}else{break}}c[10412]=z+1;H=O}A=c[e>>2]|0;c[10412]=1;if((A|0)>=1){v=1;while(1){h[43600+(v+ -1<<3)>>3]=0.0;if((v|0)<(A|0)){v=v+1|0}else{break}}c[10412]=A+1}c[10412]=1;if((z|0)>=1){v=1;do{do{if((v|0)==(H|0)){P=H}else{x=c[e>>2]|0;c[10414]=1;if((x|0)<1){P=v;break}else{Q=1}while(1){B=43600+(Q+ -1<<3)|0;h[B>>3]=+h[38120+((Q*21|0)+ -22+v<<3)>>3]+ +h[B>>3];if((Q|0)<(x|0)){Q=Q+1|0}else{break}}c[10414]=x+1;P=v}}while(0);v=P+1|0;c[10412]=v;}while((P|0)<(z|0))}z=c[e>>2]|0;c[10414]=1;if((z|0)>=1){K=+(c[10858]|0);v=1;while(1){A=43600+(v+ -1<<3)|0;h[A>>3]=+h[A>>3]/K;if((v|0)<(z|0)){v=v+1|0}else{break}}c[10414]=z+1}v=c[e>>2]|0;c[10412]=1;if((v|0)>=1){A=1;while(1){B=A+ -1|0;K=+h[43600+(B<<3)>>3];h[45880+(B<<3)>>3]=K+(K- +h[38120+((A*21|0)+ -22+H<<3)>>3]);if((A|0)<(v|0)){A=A+1|0}else{break}}c[10412]=v+1}be[u&63](e,45880,45872)|0;A=(c[11464]|0)+1|0;c[11464]=A;z=c[j>>2]|0;do{if((z|0)>=1){if(((A|0)%(z|0)|0|0)!=0){break}c[46276>>2]=6;FG(46272)|0;WF(46968,45856,4)|0;WF(46968,45872,8)|0;B=c[e>>2]|0;c[10414]=1;if((B|0)>=1){E=1;do{WF(46968,45880+(E+ -1<<3)|0,8)|0;G=c[10414]|0;E=G+1|0;c[10414]=E;}while((G|0)<(B|0))}nG()|0}}while(0);K=+h[5734];c:do{if(!(K>=+h[5683])){z=c[e>>2]|0;c[10412]=1;if((z|0)>=1){A=1;while(1){v=A+ -1|0;I=+h[43600+(v<<3)>>3];h[46048+(v<<3)>>3]=I+(+h[45880+(v<<3)>>3]-I)*2.0;if((A|0)<(z|0)){A=A+1|0}else{break}}c[10412]=z+1}be[u&63](e,46048,46040)|0;A=(c[11464]|0)+1|0;c[11464]=A;v=c[j>>2]|0;do{if((v|0)>=1){if(((A|0)%(v|0)|0|0)!=0){break}c[46300>>2]=6;FG(46296)|0;WF(46968,45856,4)|0;WF(46968,46040,8)|0;B=c[e>>2]|0;c[10414]=1;if((B|0)>=1){E=1;do{WF(46968,46048+(E+ -1<<3)|0,8)|0;G=c[10414]|0;E=G+1|0;c[10414]=E;}while((G|0)<(B|0))}nG()|0}}while(0);I=+h[5755];if(I>=+h[5683]){R=118;break}v=c[e>>2]|0;c[10412]=1;A=c[11364]|0;if((v|0)>=1){z=1;while(1){B=z+ -1|0;if(+h[d+(B<<3)>>3]!=0.0){h[38120+((z*21|0)+ -22+A<<3)>>3]=+h[46048+(B<<3)>>3]}if((z|0)<(v|0)){z=z+1|0}else{break}}c[10412]=v+1}h[41480+(A+ -1<<3)>>3]=I}else{z=c[10854]|0;c[10412]=1;if((z|0)>=1){B=c[11364]|0;E=1;while(1){if((E|0)!=(B|0)){if(K<+h[41480+(E+ -1<<3)>>3]){R=118;break c}}x=E+1|0;c[10412]=x;if((E|0)<(z|0)){E=x}else{break}}}if(!(K>+h[5681])){E=c[e>>2]|0;c[10412]=1;z=c[11364]|0;if((E|0)>=1){B=1;while(1){A=B+ -1|0;if(+h[d+(A<<3)>>3]!=0.0){h[38120+((B*21|0)+ -22+z<<3)>>3]=+h[45880+(A<<3)>>3]}if((B|0)<(E|0)){B=B+1|0}else{break}}c[10412]=E+1}h[5681]=K;h[41480+(z+ -1<<3)>>3]=K}B=c[e>>2]|0;c[10412]=1;if((B|0)>=1){A=c[11364]|0;v=1;while(1){x=v+ -1|0;h[46048+(x<<3)>>3]=+h[38120+((v*21|0)+ -22+A<<3)>>3]*.5+ +h[43600+(x<<3)>>3]*.5;if((v|0)<(B|0)){v=v+1|0}else{break}}c[10412]=B+1}be[u&63](e,46048,46040)|0;v=(c[11464]|0)+1|0;c[11464]=v;A=c[j>>2]|0;do{if((A|0)>=1){if(((v|0)%(A|0)|0|0)!=0){break}c[46324>>2]=6;FG(46320)|0;WF(46968,45856,4)|0;WF(46968,46040,8)|0;z=c[e>>2]|0;c[10414]=1;if((z|0)>=1){E=1;do{WF(46968,46048+(E+ -1<<3)|0,8)|0;x=c[10414]|0;E=x+1|0;c[10414]=E;}while((x|0)<(z|0))}nG()|0}}while(0);I=+h[5755];if(!(I>+h[5681])){A=c[e>>2]|0;c[10412]=1;v=c[11364]|0;if((A|0)>=1){B=1;while(1){z=B+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[38120+((B*21|0)+ -22+v<<3)>>3]=+h[46048+(z<<3)>>3]}if((B|0)<(A|0)){B=B+1|0}else{break}}c[10412]=A+1}h[41480+(v+ -1<<3)>>3]=I;break}B=c[10854]|0;c[10412]=1;if((B|0)<1){break}else{S=1}do{z=c[11360]|0;do{if((S|0)!=(z|0)){E=c[e>>2]|0;c[10414]=1;if((E|0)>=1){x=S+ -22|0;G=1;while(1){if(+h[d+(G+ -1<<3)>>3]!=0.0){T=(G*21|0)+ -22|0;U=38120+(T+S<<3)|0;h[U>>3]=(+h[U>>3]+ +h[38120+(T+z<<3)>>3])*.5}h[b+(G+ -1<<3)>>3]=+h[38120+(x+(G*21|0)<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[10414]=E+1}be[u&63](e,b,41480+(S+ -1<<3)|0)|0;G=(c[11464]|0)+1|0;c[11464]=G;x=c[j>>2]|0;if((x|0)<1){break}if(((G|0)%(x|0)|0|0)!=0){break}c[46348>>2]=6;FG(46344)|0;WF(46968,45856,4)|0;WF(46968,41480+((c[10412]|0)+ -1<<3)|0,8)|0;x=c[e>>2]|0;c[10414]=1;if((x|0)>=1){G=1;do{WF(46968,b+(G+ -1<<3)|0,8)|0;T=c[10414]|0;G=T+1|0;c[10414]=G;}while((T|0)<(x|0))}nG()|0}}while(0);z=c[10412]|0;S=z+1|0;c[10412]=S;}while((z|0)<(B|0))}}while(0);if((R|0)==118){R=0;B=c[e>>2]|0;c[10412]=1;v=c[11364]|0;if((B|0)>=1){A=1;while(1){z=A+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[38120+((A*21|0)+ -22+v<<3)>>3]=+h[45880+(z<<3)>>3]}if((A|0)<(B|0)){A=A+1|0}else{break}}c[10412]=B+1}h[41480+(v+ -1<<3)>>3]=+h[5734]}A=c[11452]|0;if((A|0)<(c[l>>2]|0)){y=A;continue}h[5684]=0.0;h[5730]=0.0;A=c[10854]|0;c[10412]=1;z=(A|0)<1;do{if(z){K=+(A|0);h[5730]=0.0/K;c[10412]=1;W=K;X=0.0}else{x=1;K=0.0;while(1){Y=+h[41480+(x+ -1<<3)>>3]+K;if((x|0)<(A|0)){K=Y;x=x+1|0}else{break}}K=+(A|0);I=Y/K;h[5730]=I;c[10412]=1;if(z){W=K;X=0.0;break}else{Z=1;_=0.0}while(1){C=+h[41480+(Z+ -1<<3)>>3]-I;$=_+C*C;if((Z|0)<(A|0)){_=$;Z=Z+1|0}else{break}}h[5684]=$;c[10412]=A+1;W=K;X=$}}while(0);I=+V(+(X/W));h[5684]=I;do{if(!(I<=+h[k>>3])){if((c[11464]|0)>(c[g>>2]|0)){break}a[45832]=0;c[11452]=0;y=0;continue b}}while(0);v=c[e>>2]|0;c[10412]=1;if((v|0)>=1){B=1;while(1){x=B+ -1|0;if(!(+h[d+(x<<3)>>3]==0.0)){h[b+(x<<3)>>3]=0.0;c[10414]=1;if(z){aa=b+(B+ -1<<3)|0}else{x=B*21|0;G=b+(B+ -1<<3)|0;I=+h[G>>3];E=1;while(1){C=+h[38120+(E+ -22+x<<3)>>3]+I;h[G>>3]=C;if((E|0)<(A|0)){E=E+1|0;I=C}else{break}}c[10414]=A+1;aa=G}h[aa>>3]=+h[aa>>3]/W}if((B|0)<(v|0)){B=B+1|0}else{break}}c[10412]=v+1}be[u&63](e,b,f)|0;B=(c[11464]|0)+1|0;c[11464]=B;A=c[j>>2]|0;do{if((A|0)<1){ba=B}else{if(((B|0)%(A|0)|0|0)!=0){ba=B;break}c[46372>>2]=6;FG(46368)|0;WF(46968,45856,4)|0;WF(46968,s,8)|0;z=c[e>>2]|0;c[10414]=1;if((z|0)>=1){E=1;do{WF(46968,b+(E+ -1<<3)|0,8)|0;x=c[10414]|0;E=x+1|0;c[10414]=E;}while((x|0)<(z|0))}nG()|0;ba=c[11464]|0}}while(0);if((ba|0)>(c[g>>2]|0)){R=150;break a}if((c[j>>2]|0)>=0){c[46492>>2]=6;FG(46488)|0;nG()|0;c[46516>>2]=6;FG(46512)|0;B=c[e>>2]|0;c[10412]=1;if((B|0)>=1){A=1;do{WF(46968,b+(A+ -1<<3)|0,8)|0;v=c[10412]|0;A=v+1|0;c[10412]=A;}while((v|0)<(B|0))}nG()|0;c[46540>>2]=6;FG(46536)|0;WF(46968,s,8)|0;nG()|0}if(a[45832]&1){I=+h[5730];K=+h[5776]-I;if(!(K>=0.0)){ca=-K}else{ca=K}if(!(ca>=+h[k>>3])){break}else{da=I}}else{a[45832]=1;da=+h[5730]}h[5776]=da;c[11452]=0;y=0}if((c[j>>2]|0)>=0){c[46564>>2]=6;FG(46560)|0;WF(46968,45856,4)|0;nG()|0;c[46588>>2]=6;FG(46584)|0;y=c[e>>2]|0;c[10412]=1;if((y|0)>=1){B=1;do{WF(46968,b+(B+ -1<<3)|0,8)|0;A=c[10412]|0;B=A+1|0;c[10412]=B;}while((A|0)<(y|0))}nG()|0;c[46612>>2]=6;FG(46608)|0;WF(46968,s,8)|0;nG()|0}if((c[m>>2]|0)<1){R=312;break}if((c[j>>2]|0)>-1){c[46636>>2]=6;FG(46632)|0;nG()|0}h[5683]=+h[f>>3];c[11466]=0;y=c[10854]|0;c[10412]=1;if((y|0)>=1){B=1;while(1){A=41480+(B+ -1<<3)|0;I=+h[A>>3]- +h[f>>3];if(!(I>=0.0)){ea=-I}else{ea=I}if(ea>=+h[n>>3]){v=B+1|0;c[10412]=v;if((B|0)<(y|0)){B=v;continue}else{break}}v=c[e>>2]|0;c[10414]=1;if((v|0)>=1){z=B+ -22|0;E=1;while(1){G=E+ -1|0;if(+h[d+(G<<3)>>3]!=0.0){x=38120+((E*21|0)+ -22+B<<3)|0;I=+h[x>>3];h[x>>3]=I+(I- +h[b+(G<<3)>>3])}h[46048+(E+ -1<<3)>>3]=+h[38120+(z+(E*21|0)<<3)>>3];if((E|0)<(v|0)){E=E+1|0}else{break}}c[10414]=v+1}be[u&63](e,46048,A)|0;c[11466]=(c[11466]|0)+1;c[11464]=(c[11464]|0)+1;E=c[10412]|0;I=+h[41480+(E+ -1<<3)>>3];if(I>=+h[5683]){B=E;continue}h[5683]=I;if(!((c[j>>2]|0)>-1)){B=E;continue}c[46660>>2]=6;FG(46656)|0;WF(46968,45856,4)|0;WF(46968,45464,8)|0;E=c[e>>2]|0;c[10414]=1;if((E|0)>=1){z=1;do{WF(46968,46048+(z+ -1<<3)|0,8)|0;G=c[10414]|0;z=G+1|0;c[10414]=z;}while((G|0)<(E|0))}nG()|0;B=c[10412]|0}}B=c[10858]|0;c[10412]=1;do{if((B|0)<1){h[5210]=+h[5185];c[10412]=1;ga=B;R=202}else{y=1;do{E=y+1|0;c[10422]=E;z=c[e>>2]|0;c[10414]=1;if((z|0)>=1){A=1;while(1){v=A*21|0;h[45880+(A+ -1<<3)>>3]=(+h[38120+(v+ -21<<3)>>3]+ +h[38120+(v+ -22+E<<3)>>3])*.5;if((A|0)<(z|0)){A=A+1|0}else{break}}c[10414]=z+1}be[u&63](e,45880,43440+(y+ -1<<3)|0)|0;c[11466]=(c[11466]|0)+1;c[11464]=(c[11464]|0)+1;A=c[10412]|0;y=A+1|0;c[10412]=y;}while((A|0)<(B|0));y=c[10858]|0;I=+h[5185];h[5210]=I;c[10412]=1;if((y|0)<1){ga=y;R=202;break}else{ha=I;ia=1}while(1){A=ia+ -1|0;c[10422]=A;c[10424]=ia+1;if((ia|0)<2){ja=ia;ka=ha}else{c[10414]=1;E=1;while(1){v=E+1|0;c[10426]=v;G=c[e>>2]|0;c[10416]=1;if((G|0)>=1){x=c[10424]|0;T=1;while(1){U=(T*21|0)+ -22|0;h[46048+(T+ -1<<3)>>3]=(+h[38120+(U+x<<3)>>3]+ +h[38120+(U+v<<3)>>3])*.5;if((T|0)<(G|0)){T=T+1|0}else{break}}c[10416]=G+1}be[u&63](e,46048,46040)|0;c[11466]=(c[11466]|0)+1;c[11464]=(c[11464]|0)+1;T=c[10412]|0;v=T+ -1|0;x=(fa(v,T)|0)/2|0;U=c[10414]|0;la=U+x|0;c[10418]=la;I=+h[5210];h[43760+(la+ -1<<3)>>3]=(+h[5755]+I- +h[43440+(v<<3)>>3]- +h[43440+(U+ -1<<3)>>3])*2.0;v=U+1|0;c[10414]=v;if((U|0)<(A|0)){E=v}else{ja=T;ka=I;break}}}E=ja+1|0;c[10412]=E;if((ja|0)<(y|0)){ha=ka;ia=E}else{break}}y=c[10858]|0;c[10418]=0;c[10412]=1;E=(y|0)<1;if(E){c[10412]=1;ma=1;na=y;break}A=y+ -1|0;z=A<<1;T=XS(A|0,0,y+ -2|0,0)|0;A=QS(T|0,J&1|0,1)|0;T=0;v=1;while(1){U=T+v|0;h[43760+(U+ -1<<3)>>3]=(+h[41480+(v<<3)>>3]+ka- +h[43440+(v+ -1<<3)>>3]*2.0)*2.0;if((v|0)<(y|0)){v=v+1|0;T=U}else{break}}c[10422]=v+1;c[10418]=(z|1)+A;c[10412]=1;if(E){ma=1;na=y;break}I=ka*3.0;T=1;while(1){U=43440+(T+ -1<<3)|0;h[U>>3]=+h[U>>3]*2.0-(+h[41480+(T<<3)>>3]+I)*.5;if((T|0)<(y|0)){T=T+1|0}else{break}}c[10422]=T+1;c[10412]=y+1;ma=E;na=y}}while(0);if((R|0)==202){R=0;c[10418]=0;c[10412]=1;ma=(ga|0)<1;na=ga}B=c[e>>2]|0;c[10412]=1;if((B|0)>=1){A=1;while(1){h[45480+(A+ -1<<3)>>3]=+h[38120+((A*21|0)+ -21<<3)>>3];if((A|0)<(B|0)){A=A+1|0}else{break}}c[10412]=B+1}c[10412]=1;do{if(ma){c[10412]=1}else{A=1;while(1){z=A+1|0;c[10422]=z;v=c[e>>2]|0;c[10414]=1;if((v|0)>=1){U=1;while(1){la=U*21|0;x=38120+(la+ -22+z<<3)|0;h[x>>3]=+h[x>>3]- +h[38120+(la+ -21<<3)>>3];if((U|0)<(v|0)){U=U+1|0}else{break}}c[10414]=v+1}c[10412]=z;if((A|0)<(na|0)){A=z}else{break}}c[10412]=1;if(ma){break}else{oa=1}while(1){A=oa+1|0;c[10422]=A;y=c[e>>2]|0;c[10414]=1;if((y|0)>=1){E=1;while(1){T=(E*21|0)+ -22|0;h[38120+(T+oa<<3)>>3]=+h[38120+(T+A<<3)>>3];if((E|0)<(y|0)){E=E+1|0}else{break}}c[10414]=y+1}c[10412]=A;if((oa|0)<(na|0)){oa=A}else{break}}}}while(0);B=43760;Jp(B,43432,B,45640,46216,q,45800)|0;if((c[q>>2]|0)==0){R=226;break}if((c[j>>2]|0)>-1){c[46684>>2]=6;FG(46680)|0;nG()|0}c[q>>2]=2;if((c[11464]|0)>(c[g>>2]|0)){R=312;break}c[46708>>2]=6;FG(46704)|0;nG()|0;B=c[e>>2]|0;c[10412]=1;if((B|0)<1){continue}else{pa=1}while(1){E=d+(pa+ -1<<3)|0;h[E>>3]=+h[E>>3]*.5;if((pa|0)<(B|0)){pa=pa+1|0}else{break}}c[10412]=B+1}if((R|0)==150){c[q>>2]=1;if((c[j>>2]|0)<0){i=r;return 0}c[46396>>2]=6;FG(46392)|0;WF(46968,g,4)|0;nG()|0;c[46420>>2]=6;FG(46416)|0;WF(46968,45472,8)|0;nG()|0;c[46444>>2]=6;FG(46440)|0;u=c[e>>2]|0;c[10412]=1;if((u|0)>=1){E=1;do{WF(46968,b+(E+ -1<<3)|0,8)|0;z=c[10412]|0;E=z+1|0;c[10412]=E;}while((z|0)<(u|0))}nG()|0;c[46468>>2]=6;FG(46464)|0;WF(46968,s,8)|0;nG()|0;i=r;return 0}else if((R|0)==226){u=c[10858]|0;c[11462]=u-(c[11554]|0);c[10412]=1;E=(u|0)<1;do{if(E){h[5727]=0.0;c[10412]=1;qa=0.0}else{z=u+1|0;v=1;while(1){h[41480+(v+ -1<<3)>>3]=0.0;T=v+ -1|0;U=41480+(T<<3)|0;I=+h[U>>3];la=1;while(1){if((la|0)>(v|0)){x=la+ -1|0;ra=x;sa=((fa(x,la)|0)/2|0)+v|0}else{ra=la+ -1|0;sa=((fa(T,v)|0)/2|0)+la|0}ta=+h[43760+(sa+ -1<<3)>>3]*+h[43440+(ra<<3)>>3]+I;if((la|0)<(u|0)){I=ta;la=la+1|0}else{break}}c[10418]=sa;h[U>>3]=ta;if((v|0)<(u|0)){v=v+1|0}else{break}}c[10414]=z;h[5727]=0.0;c[10412]=1;if(E){qa=0.0;break}else{ua=1;va=0.0}while(1){v=ua+ -1|0;wa=va+ +h[41480+(v<<3)>>3]*+h[43440+(v<<3)>>3];if((ua|0)<(u|0)){va=wa;ua=ua+1|0}else{break}}h[5727]=wa;c[10412]=u+1;qa=wa}}while(0);h[5727]=+h[5210]-qa;s=c[e>>2]|0;c[10412]=1;if((s|0)>=1){z=u+1|0;v=1;while(1){h[46048+(v+ -1<<3)>>3]=0.0;if(E){xa=1}else{B=v*21|0;la=46048+(v+ -1<<3)|0;T=1;I=+h[la>>3];while(1){ya=I+ +h[41480+(T+ -1<<3)>>3]*+h[38120+(T+ -22+B<<3)>>3];if((T|0)<(u|0)){I=ya;T=T+1|0}else{break}}h[la>>3]=ya;xa=z}if((v|0)<(s|0)){v=v+1|0}else{break}}c[10412]=s+1;c[10414]=xa}v=c[e>>2]|0;c[10412]=1;if((v|0)>=1){z=1;while(1){u=z+ -1|0;E=45480+(u<<3)|0;h[E>>3]=+h[E>>3]- +h[46048+(u<<3)>>3];if((z|0)<(v|0)){z=z+1|0}else{break}}c[10412]=v+1}if((c[j>>2]|0)>=0){c[46732>>2]=6;FG(46728)|0;WF(46968,45816,8)|0;z=c[e>>2]|0;c[10412]=1;if((z|0)>=1){s=1;do{WF(46968,45480+(s+ -1<<3)|0,8)|0;u=c[10412]|0;s=u+1|0;c[10412]=s;}while((u|0)<(z|0))}nG()|0;c[46756>>2]=6;FG(46752)|0;nG()|0}z=c[e>>2]|0;c[10412]=1;if((z|0)>=1){s=c[10858]|0;v=1;while(1){c[10414]=1;if((s|0)>=1){u=v*21|0;E=s+1|0;T=1;while(1){h[41480+(T+ -1<<3)>>3]=0.0;B=T+ -1|0;x=41480+(B<<3)|0;I=+h[x>>3];za=1;while(1){if((za|0)>(T|0)){Aa=((fa(za+ -1|0,za)|0)/2|0)+T|0}else{Aa=((fa(B,T)|0)/2|0)+za|0}Ba=I+ +h[43760+(Aa+ -1<<3)>>3]*+h[38120+(za+ -22+u<<3)>>3]*.5;if((za|0)<(s|0)){I=Ba;za=za+1|0}else{break}}c[10418]=Aa;h[x>>3]=Ba;if((T|0)<(s|0)){T=T+1|0}else{break}}c[10416]=E;c[10414]=s+1}T=c[e>>2]|0;c[10414]=v;if((v|0)<=(T|0)){u=(s|0)<1;la=s+1|0;za=v;while(1){Ca=v+((fa(za+ -1|0,za)|0)/2|0)|0;B=41736+(Ca+ -1<<3)|0;h[B>>3]=0.0;if(u){Da=1}else{U=za*21|0;Ea=1;I=0.0;while(1){Fa=+h[41480+(Ea+ -1<<3)>>3]*+h[38120+(Ea+ -22+U<<3)>>3]+I;if((Ea|0)<(s|0)){I=Fa;Ea=Ea+1|0}else{break}}h[B>>3]=Fa;Da=la}if((za|0)<(T|0)){za=za+1|0}else{break}}c[10414]=T+1;c[10418]=Ca;c[10416]=Da}za=v+1|0;c[10412]=za;if((v|0)<(z|0)){v=za}else{break}}}c[10414]=0;v=c[e>>2]|0;c[10412]=1;if((v|0)>=1){z=1;s=0;while(1){Ga=s+z|0;h[o+(z+ -1<<3)>>3]=+h[41736+(Ga+ -1<<3)>>3];if((z|0)<(v|0)){s=Ga;z=z+1|0}else{break}}c[10414]=Ga;c[10412]=v+1}if((c[j>>2]|0)<0){i=r;return 0}c[46780>>2]=6;FG(46776)|0;WF(46968,45848,4)|0;nG()|0;c[10856]=1;z=1;d:while(1){c[10418]=z;do{if((z|0)>(c[e>>2]|0)){s=c[10856]|0;if((s|0)==1){c[46804>>2]=6;FG(46800)|0;nG()|0;Jp(41736,43432,43760,45640,46216,q,45800)|0;c[46828>>2]=6;FG(46824)|0;nG()|0;c[10856]=3;z=1;continue d}else if((s|0)==2){break d}else if((s|0)!=3){break}c[10856]=2;c[10428]=0;c[10430]=0;s=c[e>>2]|0;c[10412]=1;if((s|0)>=1){za=0;la=1;u=0;E=0;while(1){Ea=(E|0)>1?E:1;U=Ea+1|0;x=XS(Ea+ -1|0,0,Ea+ -2|0,0)|0;Ha=QS(x|0,J&1|0,1)|0;x=(Ea<<1)+ -1+Ha|0;Ia=u+la|0;Ha=41736+(Ia+ -1<<3)|0;I=+h[Ha>>3];if(I>0.0){Ja=1.0/+V(+I)}else{Ja=0.0}h[Ha>>3]=Ja;Ka=la+ -1|0;if((la|0)<2){La=za;Ma=1;Na=0}else{I=Ja;Oa=1;Pa=za;Qa=0;while(1){Ra=Qa+Oa|0;Sa=41736+(Pa<<3)|0;h[Sa>>3]=+h[Sa>>3]*I*+h[41736+(Ra+ -1<<3)>>3];if((Oa|0)>=(Ka|0)){break}I=+h[Ha>>3];Oa=Oa+1|0;Pa=Pa+1|0;Qa=Ra}La=za+Ea|0;Ma=U;Na=x}Ta=La+1|0;if((la|0)<(s|0)){za=Ta;la=la+1|0;E=E+1|0;u=Ia}else{break}}c[10432]=Na;c[10430]=Ta;c[10428]=Ia;c[10414]=Ma;c[10412]=s+1}c[46852>>2]=6;FG(46848)|0;nG()|0;c[10428]=0;u=c[e>>2]|0;c[10412]=1;if((u|0)<1){z=1;continue d}else{Ua=1;Va=0}while(1){Wa=Va+Ua|0;E=41736+(Wa+ -1<<3)|0;if(+h[E>>3]!=0.0){h[E>>3]=1.0}if((Ua|0)<(u|0)){Ua=Ua+1|0;Va=Wa}else{break}}c[10428]=Wa;c[10412]=u+1;z=1;continue d}}while(0);T=(fa(z+ -1|0,z)|0)/2|0;c[10428]=T;s=c[e>>2]|0;c[10412]=z;e:do{if((z|0)<=(s|0)){E=z;la=T;za=z;while(1){B=E+la|0;c[10422]=B;Qa=za+la|0;c[10428]=Qa;Pa=B+5|0;c[10424]=(Qa|0)<=(Pa|0)?Qa:Pa;if((c[10856]|0)==3){c[46924>>2]=6;FG(46920)|0;Pa=c[10424]|0;Qa=c[10422]|0;c[10414]=Qa;if((Qa|0)<=(Pa|0)){B=Qa;do{WF(46968,43760+(B+ -1<<3)|0,8)|0;Qa=c[10414]|0;B=Qa+1|0;c[10414]=B;}while((Qa|0)<(Pa|0))}nG()|0}else{c[46900>>2]=6;FG(46896)|0;Pa=c[10424]|0;B=c[10422]|0;c[10414]=B;if((B|0)<=(Pa|0)){x=B;do{WF(46968,41736+(x+ -1<<3)|0,8)|0;B=c[10414]|0;x=B+1|0;c[10414]=x;}while((B|0)<(Pa|0))}nG()|0}Pa=c[10412]|0;x=Pa+1|0;c[10412]=x;if((Pa|0)>=(s|0)){break e}E=c[10418]|0;la=c[10428]|0;za=x}}}while(0);c[46948>>2]=6;FG(46944)|0;nG()|0;z=(c[10418]|0)+6|0}c[46876>>2]=6;FG(46872)|0;WF(46968,45864,4)|0;nG()|0;i=r;return 0}else if((R|0)==312){i=r;return 0}}}while(0);be[p&63](e,b,f)|0;i=r;return 0}function Jp(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0;k=i;c[11762]=c[b>>2];c[g>>2]=1;if((c[11762]|0)<1){i=k;return 0}c[g>>2]=0;Kp(a,47048,d,f,g,j,e)|0;if((c[g>>2]|0)!=0){i=k;return 0}g=c[11762]|0;j=g+1|0;f=(fa(j,g)|0)/2|0;c[11754]=f;c[11760]=g;c[11766]=f;a=g+ -1|0;b=f+(fa(a,1-g|0)|0)|0;l=XS(a|0,0,g+ -2|0,0)|0;m=QS(l|0,J&1|0,1)|0;l=b+m|0;m=0-g|0;b=f;n=g;while(1){if(+h[d+(b+ -1<<3)>>3]==0.0){c[11746]=n;if((n|0)>(g|0)){o=b}else{p=g-n|0;q=fa(p,n+1|0)|0;r=XS(p|0,0,a-n|0,0)|0;p=QS(r|0,J&1|0,1)|0;r=n;s=b;while(1){h[d+(s+ -1<<3)>>3]=0.0;if((r|0)<(g|0)){s=s+r|0;r=r+1|0}else{break}}c[11746]=j;o=n+b+q+p|0}t=o;u=n+ -1|0}else{c[11744]=n;if((n|0)<=(g|0)){r=n;s=b;while(1){h[e+(r+ -1<<3)>>3]=+h[d+(s+ -1<<3)>>3];if((r|0)>=(g|0)){break}v=s+r|0;r=r+1|0;s=v}c[11744]=j}c[11756]=g;c[11758]=f;c[11764]=f;s=n+ -1|0;r=e+(s<<3)|0;p=(g|0)==(n|0);q=f;v=g;w=f;while(1){h[5876]=0.0;x=(v|0)==(n|0);if(x){y=1.0/+h[r>>3];h[5876]=y;z=y}else{z=0.0}if(p){A=g;B=w;C=z}else{y=z;D=g;E=w;while(1){F=D+ -1|0;G=E+ -1|0;H=y- +h[e+(F<<3)>>3]*+h[d+(G<<3)>>3];h[5876]=H;if((G|0)>(q|0)){I=E+(1-D)|0}else{I=G}if((F|0)==(n|0)){A=n;B=I;C=H;break}else{E=I;D=F;y=H}}}h[d+(B+ -1<<3)>>3]=C/+h[r>>3];if(x){break}D=q-v|0;c[11764]=D;E=v+ -1|0;c[11756]=E;F=w+ -1|0;c[11758]=F;q=D;v=E;w=F}c[11748]=A;t=B;u=s}w=b+m|0;if((u|0)==0){break}else{m=m+1|0;b=w;n=u}}c[11750]=t;c[11760]=0;c[11766]=l-g;i=k;return 0}function Kp(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0;k=i;h[5890]=.5;l=.5;do{l=l*.5;}while(l+1.0>1.0);m=l*2.0;h[5890]=m;c[f>>2]=1;if((c[b>>2]|0)<1){i=k;return 0}c[f>>2]=2;c[e>>2]=0;h[g>>3]=m;h[j>>3]=+h[5890];c[11770]=1;c[11772]=0;n=c[b>>2]|0;c[11784]=1;a:do{if((n|0)>=1){b=1;o=1;b:while(1){c[11774]=0;c[11786]=1;do{if((o|0)>=1){p=1;q=c[11772]|0;r=0;while(1){s=q+1|0;t=a+(q<<3)|0;m=+h[t>>3];h[5889]=m;u=(p|0)==(o|0);if(u){l=m*+h[5890];h[5891]=l*l}do{if((p|0)<1){v=m;w=r;x=b;y=1}else{l=m;z=b;A=1;B=r;while(1){C=B+1|0;if((A|0)==(p|0)){D=14;break}E=d+(B<<3)|0;F=l- +h[E>>3]*+h[d+(z+ -1<<3)>>3];h[5889]=F;if(u){G=+h[E>>3];H=G*G*+h[j+(A+ -1<<3)>>3];h[5891]=+h[5891]+H*H}I=z+1|0;J=A+1|0;if((A|0)<(p|0)){l=F;z=I;A=J;B=C}else{D=15;break}}if((D|0)==14){D=0;c[11774]=C;v=l;w=C;x=z;y=p;break}else if((D|0)==15){D=0;c[11774]=C;v=F;w=C;x=I;y=J;break}}}while(0);if(u){D=25;break}m=+h[d+(w+ -1<<3)>>3];if(m==0.0){h[d+(q<<3)>>3]=0.0;H=+h[5889];if(!(H>=0.0)){K=-H}else{K=H}H=+h[g>>3]*+h[t>>3];if(!(H>=0.0)){L=-H}else{L=H}if(K>L){break b}}else{h[d+(q<<3)>>3]=v/m}B=p+1|0;c[11786]=B;if((p|0)<(o|0)){p=B;r=w;q=s}else{D=26;break}}if((D|0)==25){D=0;c[11768]=y;c[11776]=x;c[11772]=s;break}else if((D|0)==26){D=0;c[11768]=y;c[11776]=x;c[11772]=s;break}}}while(0);m=+V(+(+h[5891]));h[5891]=m;H=+h[5889];if(!(H>=0.0)){M=-H}else{M=H}do{if(!(M<=m*5.0)){if(H<0.0){D=37;break b}G=+V(+H);h[d+((c[11772]|0)+ -1<<3)>>3]=G;G=+h[5891]/+h[5889];h[j+((c[11768]|0)+ -1<<3)>>3]=G;if(!(G>+h[g>>3])){N=b;O=o;break}h[g>>3]=G;N=b;O=o}else{h[d+((c[11772]|0)+ -1<<3)>>3]=0.0;c[e>>2]=(c[e>>2]|0)+1;N=c[11770]|0;O=c[11784]|0}}while(0);b=N+O|0;c[11770]=b;o=O+1|0;c[11784]=o;if((O|0)>=(n|0)){break a}}if((D|0)==37){i=k;return 0}c[11768]=y;c[11776]=x;c[11772]=s;i=k;return 0}}while(0);c[f>>2]=0;i=k;return 0}function Lp(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;n=(c[b>>2]|0)+1|0;c[11810]=n;o=(c[d>>2]|0)-n|0;c[11832]=o;p=c[d>>2]|0;q=c[b>>2]|0;r=q+2|0;do{if((p|0)>=(r|0)){if((p|0)>((fa(n,r)|0)/2|0|0)){break}s=q+p|0;c[11830]=s;a[47264]=1;t=c[b>>2]|0;u=t+1|0;c[11826]=u;v=c[b>>2]|0;w=u+v|0;c[11824]=w;u=w+(c[b>>2]|0)|0;c[11828]=u;w=(fa(c[d>>2]|0,c[b>>2]|0)|0)+u|0;c[11818]=w;x=w+(c[d>>2]|0)|0;c[11812]=x;y=x+(c[b>>2]|0)|0;c[11814]=y;z=((fa(n,c[b>>2]|0)|0)/2|0)+y|0;c[11820]=z;A=z+(c[d>>2]|0)|0;c[11834]=A;B=(fa(c[b>>2]|0,s)|0)+A|0;c[11836]=B;C=(fa(o,c[d>>2]|0)|0)+B|0;c[11808]=C;D=C+(c[b>>2]|0)|0;c[11822]=D;Mp(b,d,e,f,g,h,j,k,k+(t<<3)|0,k+(t+v<<3)|0,k+(u+ -1<<3)|0,k+(w+ -1<<3)|0,k+(x+ -1<<3)|0,k+(y+ -1<<3)|0,k+(z+ -1<<3)|0,k+(A+ -1<<3)|0,k+(B+ -1<<3)|0,47320,k+(C+ -1<<3)|0,k+(D+ -1<<3)|0,k+(s+ -1+D<<3)|0,l)|0;i=m;return 0}}while(0);FG(47352)|0;nG()|0;i=m;return 0}



function oS(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0.0,ja=0,ka=0.0,la=0,ma=0.0,na=0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0.0,Fa=0,Ga=0.0,Ha=0.0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0.0,yc=0,zc=0,Ac=0.0,Bc=0.0,Cc=0.0,Dc=0.0,Ec=0.0,Fc=0.0,Gc=0,Hc=0,Ic=0.0,Jc=0,Kc=0.0,Mc=0;g=i;i=i+512|0;h=g;if((e|0)==2){j=53;k=-1074}else if((e|0)==1){j=53;k=-1074}else if((e|0)==0){j=24;k=-149}else{l=0.0;i=g;return+l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n]|0}else{o=rS(b)|0}}while((ed(o|0)|0)!=0);do{if((o|0)==43|(o|0)==45){n=1-(((o|0)==45)<<1)|0;p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;q=d[p]|0;r=n;break}else{q=rS(b)|0;r=n;break}}else{q=o;r=1}}while(0);o=q;q=0;while(1){if((o|32|0)!=(a[111352+q|0]|0)){s=o;t=q;break}do{if(q>>>0<7){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;u=d[n]|0;break}else{u=rS(b)|0;break}}else{u=o}}while(0);n=q+1|0;if(n>>>0<8){o=u;q=n}else{s=u;t=n;break}}do{if((t|0)==3){v=23}else if((t|0)!=8){u=(f|0)==0;if(!(t>>>0<4|u)){if((t|0)==8){break}else{v=23;break}}a:do{if((t|0)==0){q=s;o=0;while(1){if((q|32|0)!=(a[111368+o|0]|0)){w=q;x=o;break a}do{if(o>>>0<2){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;A=d[n]|0;break}else{A=rS(b)|0;break}}else{A=q}}while(0);n=o+1|0;if(n>>>0<3){q=A;o=n}else{w=A;x=n;break}}}else{w=s;x=t}}while(0);if((x|0)==3){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;B=d[o]|0}else{B=rS(b)|0}if((B|0)==40){C=1}else{if((c[m>>2]|0)==0){l=+y;i=g;return+l}c[e>>2]=(c[e>>2]|0)+ -1;l=+y;i=g;return+l}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0}else{D=rS(b)|0}if(!((D+ -48|0)>>>0<10|(D+ -65|0)>>>0<26)){if(!((D+ -97|0)>>>0<26|(D|0)==95)){break}}C=C+1|0}if((D|0)==41){l=+y;i=g;return+l}o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}if(u){c[(Lc()|0)>>2]=22;qS(b,0);l=0.0;i=g;return+l}if((C|0)==0|o){l=+y;i=g;return+l}else{E=C}while(1){o=E+ -1|0;c[e>>2]=(c[e>>2]|0)+ -1;if((o|0)==0){l=+y;break}else{E=o}}i=g;return+l}else if((x|0)==0){do{if((w|0)==48){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;F=d[o]|0}else{F=rS(b)|0}if((F|32|0)!=120){if((c[m>>2]|0)==0){G=48;break}c[e>>2]=(c[e>>2]|0)+ -1;G=48;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;H=d[o]|0;I=0}else{H=rS(b)|0;I=0}while(1){if((H|0)==46){v=70;break}else if((H|0)!=48){K=0;L=0;M=0;N=0;O=H;P=I;Q=0;R=0;S=1.0;T=0;V=0.0;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;H=d[o]|0;I=1;continue}else{H=rS(b)|0;I=1;continue}}b:do{if((v|0)==70){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;W=d[o]|0}else{W=rS(b)|0}if((W|0)==48){X=-1;Y=-1}else{K=0;L=0;M=0;N=0;O=W;P=I;Q=1;R=0;S=1.0;T=0;V=0.0;break}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;Z=d[o]|0}else{Z=rS(b)|0}if((Z|0)!=48){K=X;L=Y;M=0;N=0;O=Z;P=1;Q=1;R=0;S=1.0;T=0;V=0.0;break b}o=OS(X|0,Y|0,-1,-1)|0;X=o;Y=J}}}while(0);c:while(1){o=O+ -48|0;do{if(o>>>0<10){_=o;v=84}else{q=O|32;n=(O|0)==46;if(!((q+ -97|0)>>>0<6|n)){$=O;break c}if(n){if((Q|0)==0){aa=M;ba=N;ca=M;da=N;ea=P;ga=1;ha=R;ia=S;ja=T;ka=V;break}else{$=46;break c}}else{_=(O|0)>57?q+ -87|0:o;v=84;break}}}while(0);if((v|0)==84){v=0;do{if((N|0)<0|(N|0)==0&M>>>0<8){la=R;ma=S;na=_+(T<<4)|0;oa=V}else{if((N|0)<0|(N|0)==0&M>>>0<14){pa=S*.0625;la=R;ma=pa;na=T;oa=V+pa*+(_|0);break}if(!((_|0)!=0&(R|0)==0)){la=R;ma=S;na=T;oa=V;break}la=1;ma=S;na=T;oa=V+S*.5}}while(0);o=OS(M|0,N|0,1,0)|0;aa=K;ba=L;ca=o;da=J;ea=1;ga=Q;ha=la;ia=ma;ja=na;ka=oa}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;K=aa;L=ba;M=ca;N=da;O=d[o]|0;P=ea;Q=ga;R=ha;S=ia;T=ja;V=ka;continue}else{K=aa;L=ba;M=ca;N=da;O=rS(b)|0;P=ea;Q=ga;R=ha;S=ia;T=ja;V=ka;continue}}if((P|0)==0){o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}do{if(u){qS(b,0)}else{if(o){break}q=c[e>>2]|0;c[e>>2]=q+ -1;if((Q|0)==0){break}c[e>>2]=q+ -2}}while(0);l=+(r|0)*0.0;i=g;return+l}o=(Q|0)==0;q=o?M:K;n=o?N:L;if((N|0)<0|(N|0)==0&M>>>0<8){o=M;p=N;qa=T;while(1){ra=qa<<4;sa=OS(o|0,p|0,1,0)|0;ta=J;if((ta|0)<0|(ta|0)==0&sa>>>0<8){qa=ra;p=ta;o=sa}else{ua=ra;break}}}else{ua=T}do{if(($|32|0)==112){o=pS(b,f)|0;p=J;if(!((o|0)==0&(p|0)==-2147483648)){va=o;wa=p;break}if(u){qS(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){va=0;wa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;va=0;wa=0;break}}else{if((c[m>>2]|0)==0){va=0;wa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;va=0;wa=0}}while(0);p=JS(q|0,n|0,2)|0;o=OS(p|0,J|0,-32,-1)|0;p=OS(o|0,J|0,va|0,wa|0)|0;o=J;if((ua|0)==0){l=+(r|0)*0.0;i=g;return+l}if((o|0)>0|(o|0)==0&p>>>0>(0-k|0)>>>0){c[(Lc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}qa=k+ -106|0;ra=((qa|0)<0)<<31>>31;if((o|0)<(ra|0)|(o|0)==(ra|0)&p>>>0<qa>>>0){c[(Lc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((ua|0)>-1){qa=p;ra=o;sa=ua;pa=V;while(1){ta=sa<<1;if(!(pa>=.5)){xa=pa;ya=ta}else{xa=pa+-1.0;ya=ta|1}za=pa+xa;ta=OS(qa|0,ra|0,-1,-1)|0;Aa=J;if((ya|0)>-1){qa=ta;ra=Aa;sa=ya;pa=za}else{Ba=ta;Ca=Aa;Da=ya;Ea=za;break}}}else{Ba=p;Ca=o;Da=ua;Ea=V}sa=NS(32,0,k|0,((k|0)<0)<<31>>31|0)|0;ra=OS(Ba|0,Ca|0,sa|0,J|0)|0;sa=J;if(0>(sa|0)|0==(sa|0)&j>>>0>ra>>>0){Fa=(ra|0)<0?0:ra}else{Fa=j}do{if((Fa|0)<53){pa=+(r|0);za=+Id(+(+sS(1.0,84-Fa|0)),+pa);if(!((Fa|0)<32&Ea!=0.0)){Ga=pa;Ha=za;Ia=Da;Ja=Ea;break}ra=Da&1;Ga=pa;Ha=za;Ia=(ra^1)+Da|0;Ja=(ra|0)==0?0.0:Ea}else{Ga=+(r|0);Ha=0.0;Ia=Da;Ja=Ea}}while(0);za=Ga*Ja+(Ha+Ga*+(Ia>>>0))-Ha;if(!(za!=0.0)){c[(Lc()|0)>>2]=34}l=+tS(za,Ba);i=g;return+l}else{G=w}}while(0);o=k+j|0;p=0-o|0;ra=G;sa=0;while(1){if((ra|0)==46){v=139;break}else if((ra|0)!=48){Ka=ra;La=0;Ma=0;Na=sa;Oa=0;break}qa=c[e>>2]|0;if(qa>>>0<(c[m>>2]|0)>>>0){c[e>>2]=qa+1;ra=d[qa]|0;sa=1;continue}else{ra=rS(b)|0;sa=1;continue}}d:do{if((v|0)==139){ra=c[e>>2]|0;if(ra>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ra+1;Pa=d[ra]|0}else{Pa=rS(b)|0}if((Pa|0)==48){Qa=-1;Ra=-1}else{Ka=Pa;La=0;Ma=0;Na=sa;Oa=1;break}while(1){ra=c[e>>2]|0;if(ra>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ra+1;Sa=d[ra]|0}else{Sa=rS(b)|0}if((Sa|0)!=48){Ka=Sa;La=Qa;Ma=Ra;Na=1;Oa=1;break d}ra=OS(Qa|0,Ra|0,-1,-1)|0;Qa=ra;Ra=J}}}while(0);sa=h;c[sa>>2]=0;ra=Ka+ -48|0;qa=(Ka|0)==46;e:do{if(ra>>>0<10|qa){n=h+496|0;q=Ka;Aa=qa;ta=ra;Ta=0;Ua=0;Va=La;Wa=Ma;Xa=Na;Ya=Oa;Za=0;_a=0;$a=0;while(1){do{if(Aa){if((Ya|0)==0){ab=Ta;bb=Ua;cb=Ta;db=Ua;eb=Xa;fb=1;gb=Za;hb=_a;ib=$a}else{jb=q;kb=Ta;lb=Ua;mb=Va;nb=Wa;ob=Xa;pb=Za;qb=_a;rb=$a;break e}}else{sb=OS(Ta|0,Ua|0,1,0)|0;tb=J;ub=(q|0)!=48;if((_a|0)>=125){if(!ub){ab=Va;bb=Wa;cb=sb;db=tb;eb=Xa;fb=Ya;gb=Za;hb=_a;ib=$a;break}c[n>>2]=c[n>>2]|1;ab=Va;bb=Wa;cb=sb;db=tb;eb=Xa;fb=Ya;gb=Za;hb=_a;ib=$a;break}vb=h+(_a<<2)|0;if((Za|0)==0){wb=ta}else{wb=q+ -48+((c[vb>>2]|0)*10|0)|0}c[vb>>2]=wb;vb=Za+1|0;xb=(vb|0)==9;ab=Va;bb=Wa;cb=sb;db=tb;eb=1;fb=Ya;gb=xb?0:vb;hb=(xb&1)+_a|0;ib=ub?sb:$a}}while(0);sb=c[e>>2]|0;if(sb>>>0<(c[m>>2]|0)>>>0){c[e>>2]=sb+1;yb=d[sb]|0}else{yb=rS(b)|0}sb=yb+ -48|0;ub=(yb|0)==46;if(sb>>>0<10|ub){q=yb;Aa=ub;ta=sb;Ta=cb;Ua=db;Va=ab;Wa=bb;Xa=eb;Ya=fb;Za=gb;_a=hb;$a=ib}else{zb=yb;Ab=cb;Bb=db;Cb=ab;Db=bb;Eb=eb;Fb=fb;Gb=gb;Hb=hb;Ib=ib;v=162;break}}}else{zb=Ka;Ab=0;Bb=0;Cb=La;Db=Ma;Eb=Na;Fb=Oa;Gb=0;Hb=0;Ib=0;v=162}}while(0);if((v|0)==162){ra=(Fb|0)==0;jb=zb;kb=Ab;lb=Bb;mb=ra?Ab:Cb;nb=ra?Bb:Db;ob=Eb;pb=Gb;qb=Hb;rb=Ib}ra=(ob|0)!=0;do{if(ra){if((jb|32|0)!=101){v=171;break}qa=pS(b,f)|0;$a=J;do{if((qa|0)==0&($a|0)==-2147483648){if(u){qS(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){Jb=0;Kb=0;break}c[e>>2]=(c[e>>2]|0)+ -1;Jb=0;Kb=0;break}}else{Jb=qa;Kb=$a}}while(0);$a=OS(Jb|0,Kb|0,mb|0,nb|0)|0;Lb=$a;Mb=J}else{v=171}}while(0);do{if((v|0)==171){if(!((jb|0)>-1)){Lb=mb;Mb=nb;break}if((c[m>>2]|0)==0){Lb=mb;Mb=nb;break}c[e>>2]=(c[e>>2]|0)+ -1;Lb=mb;Mb=nb}}while(0);if(!ra){c[(Lc()|0)>>2]=22;qS(b,0);l=0.0;i=g;return+l}u=c[sa>>2]|0;if((u|0)==0){l=+(r|0)*0.0;i=g;return+l}do{if((Lb|0)==(kb|0)&(Mb|0)==(lb|0)&((lb|0)<0|(lb|0)==0&kb>>>0<10)){if(!(j>>>0>30)){if((u>>>j|0)!=0){break}}l=+(r|0)*+(u>>>0);i=g;return+l}}while(0);u=(k|0)/-2|0;ra=((u|0)<0)<<31>>31;if((Mb|0)>(ra|0)|(Mb|0)==(ra|0)&Lb>>>0>u>>>0){c[(Lc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}u=k+ -106|0;ra=((u|0)<0)<<31>>31;if((Mb|0)<(ra|0)|(Mb|0)==(ra|0)&Lb>>>0<u>>>0){c[(Lc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((pb|0)==0){Nb=qb}else{if((pb|0)<9){u=h+(qb<<2)|0;ra=c[u>>2]|0;$a=pb;do{ra=ra*10|0;$a=$a+1|0;}while(($a|0)<9);c[u>>2]=ra}Nb=qb+1|0}do{if((rb|0)<9){if(!((rb|0)<=(Lb|0)&(Lb|0)<18)){break}if((Lb|0)==9){l=+(r|0)*+((c[sa>>2]|0)>>>0);i=g;return+l}if((Lb|0)<9){l=+(r|0)*+((c[sa>>2]|0)>>>0)/+(c[111384+(8-Lb<<2)>>2]|0);i=g;return+l}$a=j+27+(fa(Lb,-3)|0)|0;qa=c[sa>>2]|0;if(($a|0)<=30){if((qa>>>$a|0)!=0){break}}l=+(r|0)*+(qa>>>0)*+(c[111384+(Lb+ -10<<2)>>2]|0);i=g;return+l}}while(0);sa=(Lb|0)%9|0;if((sa|0)==0){Ob=0;Pb=0;Qb=Lb;Rb=Nb}else{ra=(Lb|0)>-1?sa:sa+9|0;sa=c[111384+(8-ra<<2)>>2]|0;do{if((Nb|0)==0){Sb=0;Tb=Lb;Ub=0}else{u=1e9/(sa|0)|0;qa=0;$a=0;_a=0;Za=Lb;while(1){Ya=h+(_a<<2)|0;Xa=c[Ya>>2]|0;Wa=((Xa>>>0)/(sa>>>0)|0)+$a|0;c[Ya>>2]=Wa;Vb=fa((Xa>>>0)%(sa>>>0)|0,u)|0;Xa=_a+1|0;if((_a|0)==(qa|0)&(Wa|0)==0){Wb=Xa&127;Xb=Za+ -9|0}else{Wb=qa;Xb=Za}if((Xa|0)==(Nb|0)){break}else{qa=Wb;Za=Xb;_a=Xa;$a=Vb}}if((Vb|0)==0){Sb=Wb;Tb=Xb;Ub=Nb;break}c[h+(Nb<<2)>>2]=Vb;Sb=Wb;Tb=Xb;Ub=Nb+1|0}}while(0);Ob=Sb;Pb=0;Qb=9-ra+Tb|0;Rb=Ub}f:while(1){sa=h+(Ob<<2)|0;if((Qb|0)<18){$a=Pb;_a=Rb;while(1){Za=0;qa=_a+127|0;u=_a;while(1){Xa=qa&127;Wa=h+(Xa<<2)|0;Ya=JS(c[Wa>>2]|0,0,29)|0;Va=OS(Ya|0,J|0,Za|0,0)|0;Ya=J;if(Ya>>>0>0|(Ya|0)==0&Va>>>0>1e9){Ua=YS(Va|0,Ya|0,1e9,0)|0;Ta=ZS(Va|0,Ya|0,1e9,0)|0;Yb=Ta;Zb=Ua}else{Yb=Va;Zb=0}c[Wa>>2]=Yb;Wa=(Xa|0)==(Ob|0);if((Xa|0)!=(u+127&127|0)|Wa){_b=u}else{_b=(Yb|0)==0?Xa:u}if(Wa){break}else{Za=Zb;qa=Xa+ -1|0;u=_b}}u=$a+ -29|0;if((Zb|0)==0){$a=u;_a=_b}else{$b=u;ac=Zb;bc=_b;break}}}else{if((Qb|0)==18){cc=Pb;dc=Rb}else{ec=Ob;fc=Pb;gc=Qb;hc=Rb;break}while(1){if(!((c[sa>>2]|0)>>>0<9007199)){ec=Ob;fc=cc;gc=18;hc=dc;break f}_a=0;$a=dc+127|0;u=dc;while(1){qa=$a&127;Za=h+(qa<<2)|0;Xa=JS(c[Za>>2]|0,0,29)|0;Wa=OS(Xa|0,J|0,_a|0,0)|0;Xa=J;if(Xa>>>0>0|(Xa|0)==0&Wa>>>0>1e9){Va=YS(Wa|0,Xa|0,1e9,0)|0;Ua=ZS(Wa|0,Xa|0,1e9,0)|0;ic=Ua;jc=Va}else{ic=Wa;jc=0}c[Za>>2]=ic;Za=(qa|0)==(Ob|0);if((qa|0)!=(u+127&127|0)|Za){kc=u}else{kc=(ic|0)==0?qa:u}if(Za){break}else{_a=jc;$a=qa+ -1|0;u=kc}}u=cc+ -29|0;if((jc|0)==0){cc=u;dc=kc}else{$b=u;ac=jc;bc=kc;break}}}sa=Ob+127&127;if((sa|0)==(bc|0)){u=bc+127&127;$a=h+((bc+126&127)<<2)|0;c[$a>>2]=c[$a>>2]|c[h+(u<<2)>>2];lc=u}else{lc=bc}c[h+(sa<<2)>>2]=ac;Ob=sa;Pb=$b;Qb=Qb+9|0;Rb=lc}g:while(1){mc=hc+1&127;ra=h+((hc+127&127)<<2)|0;sa=ec;u=fc;$a=gc;while(1){_a=($a|0)==18;qa=($a|0)>27?9:1;nc=sa;oc=u;while(1){Za=0;while(1){Wa=Za+nc&127;if((Wa|0)==(hc|0)){pc=2;break}Va=c[h+(Wa<<2)>>2]|0;Wa=c[111376+(Za<<2)>>2]|0;if(Va>>>0<Wa>>>0){pc=2;break}Ua=Za+1|0;if(Va>>>0>Wa>>>0){pc=Za;break}if((Ua|0)<2){Za=Ua}else{pc=Ua;break}}if((pc|0)==2&_a){break g}qc=qa+oc|0;if((nc|0)==(hc|0)){nc=hc;oc=qc}else{break}}_a=(1<<qa)+ -1|0;Za=1e9>>>qa;rc=nc;sc=0;Ua=nc;tc=$a;do{Wa=h+(Ua<<2)|0;Va=c[Wa>>2]|0;Xa=(Va>>>qa)+sc|0;c[Wa>>2]=Xa;sc=fa(Va&_a,Za)|0;Va=(Ua|0)==(rc|0)&(Xa|0)==0;Ua=Ua+1&127;tc=Va?tc+ -9|0:tc;rc=Va?Ua:rc;}while((Ua|0)!=(hc|0));if((sc|0)==0){sa=rc;u=qc;$a=tc;continue}if((mc|0)!=(rc|0)){break}c[ra>>2]=c[ra>>2]|1;sa=rc;u=qc;$a=tc}c[h+(hc<<2)>>2]=sc;ec=rc;fc=qc;gc=tc;hc=mc}$a=nc&127;if(($a|0)==(hc|0)){c[h+(mc+ -1<<2)>>2]=0;uc=mc}else{uc=hc}za=+((c[h+($a<<2)>>2]|0)>>>0);$a=nc+1&127;if(($a|0)==(uc|0)){u=uc+1&127;c[h+(u+ -1<<2)>>2]=0;vc=u}else{vc=uc}pa=+(r|0);wc=pa*(za*1.0e9+ +((c[h+($a<<2)>>2]|0)>>>0));$a=oc+53|0;u=$a-k|0;if((u|0)<(j|0)){yc=(u|0)<0?0:u;zc=1}else{yc=j;zc=0}if((yc|0)<53){za=+Id(+(+sS(1.0,105-yc|0)),+wc);Ac=+xc(+wc,+(+sS(1.0,53-yc|0)));Bc=za;Cc=Ac;Dc=za+(wc-Ac)}else{Bc=0.0;Cc=0.0;Dc=wc}sa=nc+2&127;do{if((sa|0)==(vc|0)){Ec=Cc}else{ra=c[h+(sa<<2)>>2]|0;do{if(ra>>>0<5e8){if((ra|0)==0){if((nc+3&127|0)==(vc|0)){Fc=Cc;break}}Fc=pa*.25+Cc}else{if(ra>>>0>5e8){Fc=pa*.75+Cc;break}if((nc+3&127|0)==(vc|0)){Fc=pa*.5+Cc;break}else{Fc=pa*.75+Cc;break}}}while(0);if((53-yc|0)<=1){Ec=Fc;break}if(+xc(+Fc,1.0)!=0.0){Ec=Fc;break}Ec=Fc+1.0}}while(0);pa=Dc+Ec-Bc;do{if(($a&2147483647|0)>(-2-o|0)){if(!(+U(+pa)>=9007199254740992.0)){Gc=zc;Hc=oc;Ic=pa}else{Gc=(zc|0)!=0&(yc|0)==(u|0)?0:zc;Hc=oc+1|0;Ic=pa*.5}if((Hc+50|0)<=(p|0)){if(!((Gc|0)!=0&Ec!=0.0)){Jc=Hc;Kc=Ic;break}}c[(Lc()|0)>>2]=34;Jc=Hc;Kc=Ic}else{Jc=oc;Kc=pa}}while(0);l=+tS(Kc,Jc);i=g;return+l}else{if((c[m>>2]|0)!=0){c[e>>2]=(c[e>>2]|0)+ -1}c[(Lc()|0)>>2]=22;qS(b,0);l=0.0;i=g;return+l}}}while(0);do{if((v|0)==23){b=(c[m>>2]|0)==0;if(!b){c[e>>2]=(c[e>>2]|0)+ -1}if(t>>>0<4|(f|0)==0|b){break}else{Mc=t}do{c[e>>2]=(c[e>>2]|0)+ -1;Mc=Mc+ -1|0;}while(Mc>>>0>3)}}while(0);l=+(r|0)*+z;i=g;return+l}function pS(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g]|0}else{j=rS(a)|0}do{if((j|0)==43|(j|0)==45){g=(j|0)==45|0;k=c[f>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[f>>2]=k+1;l=d[k]|0}else{l=rS(a)|0}if((l+ -48|0)>>>0<10|(b|0)==0){m=l;n=g;break}if((c[h>>2]|0)==0){m=l;n=g;break}c[f>>2]=(c[f>>2]|0)+ -1;m=l;n=g}else{m=j;n=0}}while(0);if((m+ -48|0)>>>0>9){if((c[h>>2]|0)==0){o=0;p=-2147483648;J=p;i=e;return o|0}c[f>>2]=(c[f>>2]|0)+ -1;o=0;p=-2147483648;J=p;i=e;return o|0}else{q=m;r=0}while(1){s=q+ -48+r|0;m=c[f>>2]|0;if(m>>>0<(c[h>>2]|0)>>>0){c[f>>2]=m+1;t=d[m]|0}else{t=rS(a)|0}if(!((t+ -48|0)>>>0<10&(s|0)<214748364)){break}q=t;r=s*10|0}r=((s|0)<0)<<31>>31;if((t+ -48|0)>>>0<10){q=s;m=r;j=t;while(1){l=XS(q|0,m|0,10,0)|0;b=J;g=OS(j|0,((j|0)<0)<<31>>31|0,-48,-1)|0;k=OS(g|0,J|0,l|0,b|0)|0;b=J;l=c[f>>2]|0;if(l>>>0<(c[h>>2]|0)>>>0){c[f>>2]=l+1;u=d[l]|0}else{u=rS(a)|0}if((u+ -48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&k>>>0<2061584302)){j=u;m=b;q=k}else{v=k;w=b;x=u;break}}}else{v=s;w=r;x=t}if((x+ -48|0)>>>0<10){do{x=c[f>>2]|0;if(x>>>0<(c[h>>2]|0)>>>0){c[f>>2]=x+1;y=d[x]|0}else{y=rS(a)|0}}while((y+ -48|0)>>>0<10)}if((c[h>>2]|0)!=0){c[f>>2]=(c[f>>2]|0)+ -1}f=(n|0)!=0;n=NS(0,0,v|0,w|0)|0;o=f?n:v;p=f?J:w;J=p;i=e;return o|0}function qS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if((b|0)!=0&(g|0)>(b|0)){c[a+100>>2]=f+b;i=d;return}else{c[a+100>>2]=e;i=d;return}}function rS(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+104|0;g=c[f>>2]|0;if((g|0)==0){h=3}else{if((c[b+108>>2]|0)<(g|0)){h=3}}do{if((h|0)==3){g=vS(b)|0;if((g|0)<0){break}j=c[f>>2]|0;k=c[b+8>>2]|0;do{if((j|0)==0){h=8}else{l=c[b+4>>2]|0;m=j-(c[b+108>>2]|0)+ -1|0;if((k-l|0)<=(m|0)){h=8;break}c[b+100>>2]=l+m}}while(0);if((h|0)==8){c[b+100>>2]=k}j=c[b+4>>2]|0;if((k|0)!=0){m=b+108|0;c[m>>2]=k+1-j+(c[m>>2]|0)}m=j+ -1|0;if((d[m]|0|0)==(g|0)){n=g;i=e;return n|0}a[m]=g;n=g;i=e;return n|0}}while(0);c[b+100>>2]=0;n=-1;i=e;return n|0}function sS(a,b){a=+a;b=b|0;var d=0,e=0.0,f=0,g=0,j=0.0;d=i;do{if((b|0)>1023){e=a*8.98846567431158e+307;f=b+ -1023|0;if((f|0)<=1023){g=f;j=e;break}f=b+ -2046|0;g=(f|0)>1023?1023:f;j=e*8.98846567431158e+307}else{if(!((b|0)<-1022)){g=b;j=a;break}e=a*1.2882297539194267e-231;f=b+1022|0;if(!((f|0)<-1022)){g=f;j=e;break}f=b+2044|0;g=(f|0)<-1022?-1022:f;j=e*1.2882297539194267e-231}}while(0);b=JS(g+1023|0,0,52)|0;g=J;c[k>>2]=b;c[k+4>>2]=g;a=j*+h[k>>3];i=d;return+a}function tS(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+sS(a,b);i=c;return+d}function uS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+74|0;f=a[e]|0;a[e]=f+ -1<<24>>24|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0){be[c[b+36>>2]&63](b,0,0)|0}c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=b;g=c[f>>2]|0;if((g&20|0)==0){h=c[e>>2]|0;c[b+8>>2]=h;c[b+4>>2]=h;j=0;i=d;return j|0}if((g&4|0)==0){j=-1;i=d;return j|0}c[f>>2]=g|32;j=-1;i=d;return j|0}function vS(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+8|0;e=b;do{if((c[a+8>>2]|0)==0){if((uS(a)|0)==0){break}else{f=-1}i=b;return f|0}}while(0);if((be[c[a+32>>2]&63](a,e,1)|0)!=1){f=-1;i=b;return f|0}f=d[e]|0;i=b;return f|0}function wS(a){a=a|0;var b=0,c=0.0;b=i;c=+xS(a,0);i=b;return+c}function xS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;qS(e,0);h=+oS(e,1,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function yS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;qS(e,0);h=+oS(e,2,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function zS(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)==0){f=0;i=e;return f|0}else{g=d;h=b;j=c}while(1){k=a[h]|0;l=a[j]|0;if(!(k<<24>>24==l<<24>>24)){break}c=g+ -1|0;if((c|0)==0){f=0;m=5;break}else{g=c;h=h+1|0;j=j+1|0}}if((m|0)==5){i=e;return f|0}f=(k&255)-(l&255)|0;i=e;return f|0}function AS(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a[b]|0;f=a[c]|0;if(e<<24>>24!=f<<24>>24|e<<24>>24==0|f<<24>>24==0){g=e;h=f;j=g&255;k=h&255;l=j-k|0;i=d;return l|0}else{m=b;n=c}while(1){c=m+1|0;b=n+1|0;f=a[c]|0;e=a[b]|0;if(f<<24>>24!=e<<24>>24|f<<24>>24==0|e<<24>>24==0){g=f;h=e;break}else{n=b;m=c}}j=g&255;k=h&255;l=j-k|0;i=d;return l|0}function BS(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;if((e|0)==0){g=0;i=f;return g|0}h=a[b]|0;a:do{if(h<<24>>24==0){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){p=l+ -1|0;q=a[o]|0;if(!((p|0)!=0&q<<24>>24!=0&m<<24>>24==q<<24>>24)){j=m;k=o;break a}q=n+1|0;r=o+1|0;s=a[q]|0;if(s<<24>>24==0){j=0;k=r;break}else{m=s;n=q;o=r;l=p}}}}while(0);g=(j&255)-(d[k]|0)|0;i=f;return g|0}function CS(){c[22922]=p;c[22964]=p;c[27606]=p;c[27836]=p}function DS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;w=w+1|0;c[a>>2]=w;while((e|0)<40){if((c[d+(e<<2)>>2]|0)==0){c[d+(e<<2)>>2]=w;c[d+((e<<2)+4)>>2]=b;c[d+((e<<2)+8)>>2]=0;return 0}e=e+2|0}cc(116);cc(111);cc(111);cc(32);cc(109);cc(97);cc(110);cc(121);cc(32);cc(115);cc(101);cc(116);cc(106);cc(109);cc(112);cc(115);cc(32);cc(105);cc(110);cc(32);cc(97);cc(32);cc(102);cc(117);cc(110);cc(99);cc(116);cc(105);cc(111);cc(110);cc(32);cc(99);cc(97);cc(108);cc(108);cc(44);cc(32);cc(98);cc(117);cc(105);cc(108);cc(100);cc(32);cc(119);cc(105);cc(116);cc(104);cc(32);cc(97);cc(32);cc(104);cc(105);cc(103);cc(104);cc(101);cc(114);cc(32);cc(118);cc(97);cc(108);cc(117);cc(101);cc(32);cc(102);cc(111);cc(114);cc(32);cc(77);cc(65);cc(88);cc(95);cc(83);cc(69);cc(84);cc(74);cc(77);cc(80);cc(83);cc(10);ga(0);return 0}function ES(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function FS(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function GS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return lb(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function HS(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{GS(b,c,d)|0}return b|0}function IS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function JS(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function KS(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function LS(a){a=a|0;var b=0;b=(fa(c[a>>2]|0,31010991)|0)+1735287159&2147483647;c[a>>2]=b;return b|0}function MS(){return LS(o)|0}function NS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(J=e,a-c>>>0|0)|0}function OS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function PS(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e|0]=f?0:a[c+e|0]|0;f=f?1:(a[c+e|0]|0)==0;e=e+1|0}return b|0}function QS(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function RS(a,b){a=a|0;b=b|0;var d=0,e=0;while((d|0)<20){e=c[b+(d<<2)>>2]|0;if((e|0)==0)break;if((e|0)==(a|0)){return c[b+((d<<2)+4)>>2]|0}d=d+2|0}return 0}function SS(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function TS(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function US(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=fa(d,c)|0;f=a>>>16;a=(e>>>16)+(fa(d,f)|0)|0;d=b>>>16;b=fa(d,c)|0;return(J=(a>>>16)+(fa(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function VS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=NS(e^a,f^b,e,f)|0;b=J;a=g^e;e=h^f;f=NS((_S(i,b,NS(g^c,h^d,g,h)|0,J,0)|0)^a,J^e,a,e)|0;return(J=J,f)|0}function WS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=NS(h^a,j^b,h,j)|0;b=J;_S(m,b,NS(k^d,l^e,k,l)|0,J,g)|0;l=NS(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=J;i=f;return(J=j,l)|0}function XS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=US(e,a)|0;f=J;return(J=(fa(b,a)|0)+(fa(d,e)|0)+f|f&0,c|0|0)|0}function YS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=_S(a,b,c,d,0)|0;return(J=J,e)|0}function ZS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;_S(a,b,d,e,g)|0;i=f;return(J=c[g+4>>2]|0,c[g>>2]|0)|0}function _S(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(J=n,o)|0}else{if(!m){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(J=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(J=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(J=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((TS(l|0)|0)>>>0);return(J=n,o)|0}p=(SS(l|0)|0)-(SS(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}else{if(!m){r=(SS(l|0)|0)-(SS(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(SS(j|0)|0)+33-(SS(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(J=n,o)|0}else{p=TS(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(J=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=OS(g,d,-1,-1)|0;k=J;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;NS(e,k,j,a)|0;b=J;h=b>>31|((b|0)<0?-1:0)<<1;K=h&1;L=NS(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=J;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=K}}B=H;C=I;D=M;E=L;F=0;G=K}K=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(K|0)>>>31|(B|C)<<1|(C<<1|K>>>31)&0|F;o=(K<<1|0>>>31)&-2|G;return(J=n,o)|0}function $S(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Ud[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function aT(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Vd[a&31](b|0,c|0,d|0,e|0,f|0)}function bT(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return Wd[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function cT(a,b){a=a|0;b=+b;Xd[a&1](+b)}function dT(a,b){a=a|0;b=b|0;Yd[a&255](b|0)}function eT(a,b,c){a=a|0;b=b|0;c=c|0;Zd[a&63](b|0,c|0)}function fT(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return _d[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function gT(a,b){a=a|0;b=b|0;return $d[a&127](b|0)|0}function hT(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;return ae[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0)|0}function iT(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return be[a&63](b|0,c|0,d|0)|0}function jT(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;return ce[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0)|0}function kT(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;return de[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0)|0}function lT(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ee[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function mT(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;fe[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function nT(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;return ge[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0,x|0,y|0)|0}function oT(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;he[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function pT(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;ie[a&3](b|0,c|0,+d,e|0,f|0)}function qT(a,b,c){a=a|0;b=b|0;c=+c;return je[a&1](b|0,+c)|0}function rT(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ke[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function sT(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;le[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function tT(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;me[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function uT(a,b,c){a=a|0;b=b|0;c=c|0;return ne[a&63](b|0,c|0)|0}function vT(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return oe[a&63](b|0,c|0,d|0,e|0,f|0)|0}function wT(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return pe[a&1](b|0,c|0,d|0,e|0,+f,g|0)|0}function xT(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;return+qe[a&1](b|0,+c,+d)}function yT(a,b,c){a=a|0;b=b|0;c=c|0;return+re[a&1](b|0,c|0)}function zT(a){a=a|0;return se[a&7]()|0}function AT(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return te[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function BT(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ue[a&15](b|0,c|0,d|0)}function CT(a){a=a|0;ve[a&7]()}function DT(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return we[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function ET(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return xe[a&63](b|0,c|0,d|0,e|0)|0}function FT(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ye[a&31](b|0,c|0,d|0,e|0)}function GT(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(0);return 0}function HT(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(1)}function IT(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ga(2);return 0}function JT(a){a=+a;ga(3)}function KT(a){a=a|0;ga(4)}function LT(a){a=a|0;td(a|0)}function MT(a,b){a=a|0;b=b|0;ga(5)}function NT(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ga(6);return 0}function OT(a){a=a|0;ga(7);return 0}function PT(a){a=a|0;return Mc(a|0)|0}function QT(a){a=a|0;return Cd(a|0)|0}function RT(a){a=a|0;return uc(a|0)|0}function ST(a){a=a|0;return rd(a|0)|0}function TT(a){a=a|0;return gd(a|0)|0}function UT(a){a=a|0;return md(a|0)|0}function VT(a){a=a|0;return Vc(a|0)|0}function WT(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;ga(8);return 0}function XT(a,b,c){a=a|0;b=b|0;c=c|0;ga(9);return 0}function YT(a,b,c){a=a|0;b=b|0;c=c|0;return od(a|0,b|0,c|0)|0}function ZT(a,b,c){a=a|0;b=b|0;c=c|0;return gc(a|0,b|0,c|0)|0}function _T(a,b,c){a=a|0;b=b|0;c=c|0;return ac(a|0,b|0,c|0)|0}function $T(a,b,c){a=a|0;b=b|0;c=c|0;return sd(a|0,b|0,c|0)|0}function aU(a,b,c){a=a|0;b=b|0;c=c|0;return pd(a|0,b|0,c|0)|0}function bU(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;ga(10);return 0}function cU(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;ga(11);return 0}function dU(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ga(12)}function eU(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(13)}function fU(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;ga(14);return 0}function gU(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ga(15)}function hU(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ga(16)}function iU(a,b){a=a|0;b=+b;ga(17);return 0}function jU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(18)}function kU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ga(19)}function lU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(20)}function mU(a,b){a=a|0;b=b|0;ga(21);return 0}function nU(a,b){a=a|0;b=b|0;return Hd(a|0,b|0)|0}function oU(a,b){a=a|0;b=b|0;return fc(a|0,b|0)|0}function pU(a,b){a=a|0;b=b|0;return hb(a|0,b|0)|0}function qU(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(22);return 0}function rU(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ga(23);return 0}function sU(a,b,c){a=a|0;b=+b;c=+c;ga(24);return 0.0}function tU(a,b){a=a|0;b=b|0;ga(25);return 0.0}function uU(){ga(26);return 0}function vU(){return ib()|0}function wU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(27);return 0}function xU(a,b,c){a=a|0;b=b|0;c=c|0;ga(28)}function yU(){ga(29)}function zU(){Sc()}function AU(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(30);return 0}function BU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(31);return 0}function CU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return pc(a|0,b|0,c|0,d|0)|0}function DU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Kc(a|0,b|0,c|0,d|0)|0}function EU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(32)}




// EMSCRIPTEN_END_FUNCS
var Ud=[GT,Yp,_p,dq,dF,GT,GT,GT];var Vd=[HT,Uk,Vk,yl,zl,bm,cm,zm,Am,Bm,YR,XR,WR,mk,nk,Sn,Qn,HT,HT,HT,HT,HT,HT,HT,HT,HT,HT,HT,HT,HT,HT,HT];var Wd=[IT,Jr];var Xd=[JT,Kq];var Yd=[KT,zf,Af,bg,cg,mh,eg,Nn,Vt,Yt,Xt,Zt,bK,aK,dK,cK,_t,au,mx,Ix,Jx,Kx,OJ,NJ,QJ,PJ,BE,OE,PE,QE,SE,UE,KG,LG,RG,SG,YG,ZG,dH,eH,qH,pH,vH,uH,xH,yH,HH,GH,OI,NI,XI,WI,zJ,yJ,XJ,WJ,ZJ,YJ,pK,oK,rK,qK,xK,wK,MI,yK,vK,zK,BK,AK,JO,HK,GK,MK,LK,jL,iL,NL,ML,$L,_L,nM,mM,BM,AM,OM,NM,RM,QM,VM,UM,eN,dN,pN,oN,AN,zN,LN,KN,VN,UN,bO,aO,hO,gO,nO,mO,sO,rO,BO,AO,ZO,YO,wO,oP,VP,UP,XP,WP,CK,IO,LO,gP,wP,HP,SP,TP,JR,IR,LR,OR,MR,NR,PR,QR,lS,kS,wf,LT,Ze,_e,$e,ef,ff,jf,kf,nf,rf,bS,Pn,Pe,uq,yq,tq,Mr,Aq,Kr,Yo,Dq,Bq,Cq,zq,Fq,Lr,Gq,vq,Iq,mE,Jq,iG,JG,KO,DQ,NN,KQ,JQ,IQ,HQ,GQ,FQ,XH,zI,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT,KT];var Zd=[MT,dg,rs,bu,mJ,MG,TG,_G,fH,AJ,YM,ZM,_M,$M,bN,cN,hN,iN,jN,kN,mN,nN,sN,tN,uN,vN,xN,yN,DN,EN,FN,GN,IN,JN,qO,vO,aQ,cQ,eQ,bQ,dQ,fQ,lq,Nf,$f,Eq,Uw,ts,ss,us,As,Ms,vs,Ks,hw,tw,sw,uw,cw,aw,ew,rF,MT,MT];var _d=[NT,Bk,uk,Zp,$p,aq,bq,cq];var $d=[OT,tf,ji,sf,Re,Se,Te,nh,oh,kg,lh,ii,li,jg,hg,mi,ni,ri,si,ti,ui,vi,wi,xi,yi,PT,QT,RT,io,aS,ST,fu,rJ,gu,uJ,qJ,XE,NG,FJ,HJ,IJ,EJ,UG,VG,$G,tJ,gH,hH,rH,wH,tK,oM,gQ,iQ,kQ,qQ,sQ,mQ,oQ,CM,hQ,jQ,lQ,rQ,tQ,nQ,pQ,WM,XM,aN,fN,gN,lN,qN,rN,wN,BN,CN,HN,sP,tP,vP,YP,_P,ZP,$P,kP,lP,nP,CP,DP,GP,NP,OP,RP,KR,mS,Tr,TT,UT,Rr,Sr,VT,fE,GE,Sq,_q,hr,Tq,br,ir,BG,vS,OT,OT,OT,OT,OT,OT,OT,OT,OT,OT,OT,OT,OT,OT,OT];var ae=[WT,Ip];var be=[XT,gg,Lk,Rk,pl,vl,Ul,_l,cu,sJ,wJ,nJ,BJ,GJ,OG,KJ,aH,BH,CH,FK,KK,oO,tO,$O,bP,eP,MO,RO,TO,WO,RR,oE,yk,pk,wk,Ck,YT,ZT,_T,Nr,lE,hE,$T,tG,aU,XT,XT,XT,XT,XT,XT,XT,XT,XT,XT,XT,XT,XT,XT,XT,XT,XT,XT,XT];var ce=[bU,Mp];var de=[cU,ep];var ee=[dU,VL,YL,hM,jM,dU,dU,dU];var fe=[eU,PM,SM,MN,QN,WN,YN,eU];var ge=[fU,Gp];var he=[gU,Kn,du,VE,CJ,oJ,OL,PL,TL,ZL,aM,bM,fM,kM,pO,uO,$R,_R,ZR,Ln,gU,gU,gU,gU,gU,gU,gU,gU,gU,gU,gU,gU];var ie=[hU,$q,ar,hU];var je=[iU,vf];var ke=[jU,NK,PK,RK,TK,VK,XK,ZK,$K,bL,dL,fL,kL,mL,oL,qL,sL,uL,wL,yL,AL,CL,EL,SL,UL,eM,gM,pM,qM,rM,sM,tM,DM,EM,FM,GM,HM,fO,lO,jU,jU,jU,jU,jU,jU,jU,jU,jU,jU,jU,jU,jU,jU,jU,jU,jU,jU,jU,jU,jU,jU,jU,jU,jU];var le=[kU,cO,iO,kU];var me=[lU,uM,IM,lU];var ne=[mU,Qe,mg,ig,fg,zi,Ai,Nk,Ok,Qk,rl,sl,ul,Wl,Xl,Zl,dm,em,fm,gm,hm,im,jm,km,hu,iu,YE,ZE,JJ,PG,WG,LJ,vJ,bH,iH,xJ,_O,aP,cP,QO,SO,UO,Br,kr,cr,Uq,jr,nU,dS,jk,kk,lk,oU,so,Xq,xr,or,Zq,pU,uR,mU,mU,mU,mU];var oe=[qU,DK,IK,fP,rP,uP,XO,jP,mP,BP,EP,MP,PP,Hm,zn,An,Mm,Jm,xn,yn,Nm,Om,Pm,Qm,Rm,nn,on,dn,Ym,Tm,Sm,Um,Vm,Xm,Wm,Km,Im,Zm,_m,$m,an,bn,cn,en,fn,gn,hn,mn,kn,jn,ln,tn,pn,qn,rn,sn,un,vn,wn,Bn,Cn,Dn,En,QL];var pe=[rU,Yr];var qe=[sU,lr];var re=[tU,op];var se=[uU,Ci,vU,jo,GG,HG,EG,uU];var te=[wU,Lp];var ue=[xU,qE,AH,uK,Vn,ms,os,Tw,qF,xU,xU,xU,xU,xU,xU,xU];var ve=[yU,zU,ho,Hn,yf,yU,yU,yU];var we=[AU,Bi,pP,qP,hP,iP,xP,zP,IP,KP,pr,AU,AU,AU,AU,AU];var xe=[BU,Fk,Gk,Hk,Ik,Jk,Kk,Mk,Pk,Tk,jl,kl,ll,ml,nl,ol,ql,tl,xl,Ol,Pl,Ql,Rl,Sl,Tl,Vl,Yl,am,dP,NO,OO,PO,VO,nq,CU,Hp,bk,ej,zj,Ij,uj,Rj,Wj,Uj,Xj,Dk,hk,rk,sk,zk,Ak,hL,WL,DU,BU,BU,BU,BU,BU,BU,BU,BU,BU,BU];var ye=[EU,Sk,wl,$l,eu,pE,WE,DJ,pJ,EK,JK,SR,TR,UR,Tn,Rn,pq,Un,Of,ag,LF,tk,Wn,EU,EU,EU,EU,EU,EU,EU,EU,EU];return{_testSetjmp:RS,_saveSetjmp:DS,_free:bS,_main:xf,_rand_r:LS,_realloc:dS,_i64Add:OS,_memmove:HS,_bitshift64Ashr:FS,_memset:IS,_malloc:aS,_strncpy:PS,_memcpy:GS,_strlen:ES,_bitshift64Lshr:QS,_bitshift64Shl:JS,_i64Subtract:NS,_strcpy:KS,_calloc:cS,_rand:MS,__GLOBAL__I_a:kH,runPostSets:CS,stackAlloc:ze,stackSave:Ae,stackRestore:Be,setThrew:Ce,setTempRet0:Fe,setTempRet1:Ge,setTempRet2:He,setTempRet3:Ie,setTempRet4:Je,setTempRet5:Ke,setTempRet6:Le,setTempRet7:Me,setTempRet8:Ne,setTempRet9:Oe,dynCall_iiiiiiii:$S,dynCall_viiiii:aT,dynCall_iiiiidiii:bT,dynCall_vd:cT,dynCall_vi:dT,dynCall_vii:eT,dynCall_iiiiiiiiiii:fT,dynCall_ii:gT,dynCall_iiiiiiiiiiiiii:hT,dynCall_iiii:iT,dynCall_iiiiiiiiiiiiiiiiiiiiiii:jT,dynCall_iiiiiiiiiiiiiiiiiiiii:kT,dynCall_viiiiid:lT,dynCall_viiiiiiii:mT,dynCall_iiiiiiiiiiiiiiiiiiiiiiiii:nT,dynCall_viiiiii:oT,dynCall_viidii:pT,dynCall_iid:qT,dynCall_viiiiiii:rT,dynCall_viiiiiid:sT,dynCall_viiiiiiiii:tT,dynCall_iii:uT,dynCall_iiiiii:vT,dynCall_iiiiidi:wT,dynCall_didd:xT,dynCall_dii:yT,dynCall_i:zT,dynCall_iiiiiiiiii:AT,dynCall_viii:BT,dynCall_v:CT,dynCall_iiiiiiiii:DT,dynCall_iiiii:ET,dynCall_viiii:FT}})


// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_viiiii": invoke_viiiii, "invoke_iiiiidiii": invoke_iiiiidiii, "invoke_vd": invoke_vd, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiiiiiii": invoke_iiiiiiiiiii, "invoke_ii": invoke_ii, "invoke_iiiiiiiiiiiiii": invoke_iiiiiiiiiiiiii, "invoke_iiii": invoke_iiii, "invoke_iiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_viidii": invoke_viidii, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_iii": invoke_iii, "invoke_iiiiii": invoke_iiiiii, "invoke_iiiiidi": invoke_iiiiidi, "invoke_didd": invoke_didd, "invoke_dii": invoke_dii, "invoke_i": invoke_i, "invoke_iiiiiiiiii": invoke_iiiiiiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_fabs": _fabs, "_exp": _exp, "_strrchr": _strrchr, "_pthread_key_create": _pthread_key_create, "_vsscanf": _vsscanf, "__ZSt9terminatev": __ZSt9terminatev, "___cxa_guard_acquire": ___cxa_guard_acquire, "__reallyNegative": __reallyNegative, "_fstat": _fstat, "_pclose": _pclose, "_lis_solver_create": _lis_solver_create, "___assert_fail": ___assert_fail, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "_longjmp": _longjmp, "__isLeapYear": __isLeapYear, "_clock_gettime": _clock_gettime, "_fsync": _fsync, "_signal": _signal, "_GC_collect_a_little": _GC_collect_a_little, "_sbrk": _sbrk, "_strtoull": _strtoull, "_emscripten_memcpy_big": _emscripten_memcpy_big, "__parseInt64": __parseInt64, "_close": _close, "_rewind": _rewind, "_cos": _cos, "_fileno": _fileno, "_fread": _fread, "_puts": _puts, "_isatty": _isatty, "_lis_matrix_set_value": _lis_matrix_set_value, "_write": _write, "_isblank": _isblank, "_ftell": _ftell, "__ZNSt9exceptionD2Ev": __ZNSt9exceptionD2Ev, "_xerbla_": _xerbla_, "_round": _round, "___cxa_does_inherit": ___cxa_does_inherit, "_strtoll_l": _strtoll_l, "_strstr": _strstr, "___cxa_rethrow": ___cxa_rethrow, "_llvm_lifetime_end": _llvm_lifetime_end, "_catclose": _catclose, "_tmpnam": _tmpnam, "_lis_vector_destroy": _lis_vector_destroy, "_lis_solver_set_option": _lis_solver_set_option, "_tmpfile": _tmpfile, "_send": _send, "_pow": _pow, "___cxa_is_number_type": ___cxa_is_number_type, "___cxa_free_exception": ___cxa_free_exception, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_isxdigit_l": _isxdigit_l, "___cxa_guard_release": ___cxa_guard_release, "_truncate": _truncate, "_strtol": _strtol, "_sin": _sin, "_strtok": _strtok, "___setErrNo": ___setErrNo, "_newlocale": _newlocale, "_isdigit_l": _isdigit_l, "___resumeException": ___resumeException, "_freelocale": _freelocale, "_srand": _srand, "_fscanf": _fscanf, "_qsort": _qsort, "_putchar": _putchar, "_floor": _floor, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_printf": _printf, "_sprintf": _sprintf, "_fopen": _fopen, "_vasprintf": _vasprintf, "_emscripten_get_now": _emscripten_get_now, "_stat": _stat, "_vsnprintf": _vsnprintf, "_strtoull_l": _strtoull_l, "_read": _read, "__addDays": __addDays, "_fwrite": _fwrite, "_time": _time, "_pthread_mutex_lock": _pthread_mutex_lock, "_catopen": _catopen, "_exit": _exit, "_GC_strdup": _GC_strdup, "_freopen": _freopen, "___ctype_b_loc": ___ctype_b_loc, "_fmod": _fmod, "_strtok_r": _strtok_r, "_lseek": _lseek, "_access": _access, "_vfprintf": _vfprintf, "___cxa_allocate_exception": ___cxa_allocate_exception, "_atoi": _atoi, "_strtoll": _strtoll, "_pwrite": _pwrite, "_localtime_r": _localtime_r, "_tzset": _tzset, "_open": _open, "_uselocale": _uselocale, "_snprintf": _snprintf, "___errno_location": ___errno_location, "_GC_malloc": _GC_malloc, "___cxa_end_catch": ___cxa_end_catch, "_perror": _perror, "___cxa_begin_catch": ___cxa_begin_catch, "_strftime": _strftime, "_ftruncate": _ftruncate, "_GC_init": _GC_init, "_fseek": _fseek, "_isxdigit": _isxdigit, "_fclose": _fclose, "__parseInt": __parseInt, "_log": _log, "_pthread_cond_broadcast": _pthread_cond_broadcast, "_popen": _popen, "_recv": _recv, "_fgetc": _fgetc, "_sysconf": _sysconf, "__getFloat": __getFloat, "_abort": _abort, "_ceil": _ceil, "_isspace": _isspace, "_localtime": _localtime, "_pthread_getspecific": _pthread_getspecific, "_pthread_cond_wait": _pthread_cond_wait, "_llvm_lifetime_start": _llvm_lifetime_start, "_ungetc": _ungetc, "_system": _system, "_fmax": _fmax, "_fflush": _fflush, "_strftime_l": _strftime_l, "_fprintf": _fprintf, "_sscanf": _sscanf, "_catgets": _catgets, "_strdup": _strdup, "_asprintf": _asprintf, "__exit": __exit, "___ctype_toupper_loc": ___ctype_toupper_loc, "_bsearch": _bsearch, "__arraySum": __arraySum, "__formatString": __formatString, "_htonl": _htonl, "___ctype_tolower_loc": ___ctype_tolower_loc, "_unlink": _unlink, "_fputs": _fputs, "_GC_malloc_atomic": _GC_malloc_atomic, "_pread": _pread, "_lis_vector_set_size": _lis_vector_set_size, "_mkport": _mkport, "__scanString": __scanString, "_pthread_setspecific": _pthread_setspecific, "_copysign": _copysign, "_fputc": _fputc, "___cxa_throw": ___cxa_throw, "_lis_solver_destroy": _lis_solver_destroy, "_isdigit": _isdigit, "_strerror": _strerror, "_emscripten_longjmp": _emscripten_longjmp, "_lis_vector_create": _lis_vector_create, "_atexit": _atexit, "_sqrt": _sqrt, "_strerror_r": _strerror_r, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "___rand_seed": ___rand_seed, "NaN": NaN, "Infinity": Infinity, "__ZTISt9exception": __ZTISt9exception, "___dso_handle": ___dso_handle, "_stderr": _stderr, "_stdin": _stdin, "_stdout": _stdout }, buffer);
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _rand_r = Module["_rand_r"] = asm["_rand_r"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _rand = Module["_rand"] = asm["_rand"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_iiiiidiii = Module["dynCall_iiiiidiii"] = asm["dynCall_iiiiidiii"];
var dynCall_vd = Module["dynCall_vd"] = asm["dynCall_vd"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiiiiiii = Module["dynCall_iiiiiiiiiii"] = asm["dynCall_iiiiiiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_iiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_viidii = Module["dynCall_viidii"] = asm["dynCall_viidii"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiidi = Module["dynCall_iiiiidi"] = asm["dynCall_iiiiidi"];
var dynCall_didd = Module["dynCall_didd"] = asm["dynCall_didd"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];

Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };


// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======



// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}






