var Module = {};
var preloadComplete = false;

Module['noInitialRun'] = true;
Module['OpenModelica_readFile'] = function(fname) {
  return intArrayToString(FS.findObject(fname).contents);
};
Module['OpenModelica_readFileBuffer'] = function(fname) {
  return FS.findObject(fname).contents;
};

try { // Try to add an event listener like a webworker thread
  self.addEventListener('message', function(e) {
    var data = e.data;
    if (!data) return;
    if (data.preload) {
      var error = function() {console.log('error...'); /* self.postError({message: "Preload failed"}); */ };
      if (!preloadComplete) {
        FS.createPreloadedFile('/', data.basename + "_init.xml", data.basename + "_init.xml", true, false, function() {
        FS.createLazyFile('/', data.basename + "_info.xml", data.basename + "_info.xml", true, false);
        preloadComplete = true;
        self.postMessage({preloaded:true});
      }, error);
      } else {
        self.postMessage({preloaded:true});
      }
      return;
    }
    var result = {};
    result.status = "Simulation failed"
    try {
      shouldRunNow = true;
      var args = ['-override','outputFormat=csv,stopTime=' +  data.stopTime +',tolerance=' + data.tolerance + ',stepSize=' + data.stepSize];
      Module.callMain(args);
      result.csv = intArrayToString(FS.findObject(data.basename + "_res.csv").contents);
      result.status = "Simulation finished";

  } catch(e) {
  }
  self.postMessage(result);
  }, false);
} catch (e) {
}

// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 536870912;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===
var __ZTVN10__cxxabiv117__class_type_infoE = 151160;
var __ZTVN10__cxxabiv120__si_class_type_infoE = 151200;




STATIC_BASE = 8;

STATICTOP = STATIC_BASE + Runtime.alignMemory(152027);
/* global initializers */ __ATINIT__.push({ func: function() { __GLOBAL__I_a() } });


/* memory initializer */ allocate([0,0,0,0,0,0,0,0,95,112,114,111,102,46,100,97,116,97,0,0,0,0,0,0,119,98,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,111,112,101,110,101,100,58,32,37,115,0,0,0,0,0,0,0,0,111,102,102,115,101,116,32,118,97,108,117,101,32,102,111,114,32,116,104,101,32,110,101,120,116,32,115,116,101,112,58,32,37,46,49,48,102,0,0,0,99,97,108,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,32,40,115,116,101,112,83,105,122,101,58,32,37,103,41,0,0,0,0,0,0,0,0,82,117,110,110,105,110,103,0,37,115,32,101,118,101,110,116,32,97,116,32,116,105,109,101,32,37,46,49,50,103,0,0,116,105,109,101,0,0,0,0,115,116,97,116,101,0,0,0,68,105,115,97,98,108,101,100,32,116,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,98,101,99,97,117,115,101,32,116,104,101,32,111,117,116,112,117,116,32,102,105,108,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,103,101,110,101,114,97,116,101,100,58,32,37,115,0,0,0,83,105,109,117,108,97,116,105,111,110,32,99,97,108,108,32,116,101,114,109,105,110,97,116,101,40,41,32,97,116,32,116,105,109,101,32,37,102,10,77,101,115,115,97,103,101,32,58,32,37,115,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,73,110,116,101,103,114,97,116,111,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,109,105,120,101,100,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,112,114,111,98,97,98,108,121,32,97,32,115,116,114,111,110,103,32,99,111,109,112,111,110,101,110,116,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,102,108,97,103,115,32,45,108,118,32,76,79,71,95,78,76,83,44,32,76,79,71,95,76,83,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,1,0,0,0,232,8,0,0,240,8,0,0,0,0,0,0,2,0,0,0,152,7,0,0,160,7,0,0,0,0,0,0,1,0,0,0,104,7,0,0,112,7,0,0,0,0,0,0,2,0,0,0,24,6,0,0,32,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,1,0,0,0,3,0,0,0,13,0,0,0,4,0,0,0,14,0,0,0,6,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,69,114,114,111,114,32,119,104,105,108,101,32,105,110,105,116,105,97,108,105,122,101,32,68,97,116,97,0,0,0,0,0,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,69,120,97,109,112,108,101,115,46,67,111,117,110,116,101,114,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,0,123,56,99,52,101,56,49,48,102,45,51,100,102,51,45,52,97,48,48,45,56,50,55,54,45,49,55,54,102,97,51,99,57,102,57,101,48,125,0,0,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,69,120,97,109,112,108,101,115,46,67,111,117,110,116,101,114,95,105,110,102,111,46,120,109,108,0,0,0,83,116,97,99,107,32,111,118,101,114,102,108,111,119,32,100,101,116,101,99,116,101,100,32,97,110,100,32,119,97,115,32,110,111,116,32,99,97,117,103,104,116,46,10,83,101,110,100,32,117,115,32,97,32,98,117,103,32,114,101,112,111,114,116,32,97,116,32,104,116,116,112,115,58,47,47,116,114,97,99,46,111,112,101,110,109,111,100,101,108,105,99,97,46,111,114,103,47,79,112,101,110,77,111,100,101,108,105,99,97,47,110,101,119,116,105,99,107,101,116,10,32,32,32,32,73,110,99,108,117,100,101,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,116,114,97,99,101,58,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,9,0,0,0,9,0,0,0,1,0,0,0,1,0,0,0,3,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,3,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,4,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,4,0,0,0,3,0,0,0,2,0,0,0,0,0,0,0,9,0,0,0,9,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,4,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,4,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,4,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,4,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,4,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,4,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,4,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,4,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,4,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,115,97,109,112,108,101,45,105,110,116,101,114,118,97,108,32,60,61,32,48,46,48,0,0,208,9,0,0,248,9,0,0,128,10,0,0,168,10,0,0,48,11,0,0,88,11,0,0,224,11,0,0,8,12,0,0,144,12,0,0,184,12,0,0,64,13,0,0,104,13,0,0,240,13,0,0,24,14,0,0,160,14,0,0,200,14,0,0,80,15,0,0,152,15,0,0,116,105,109,101,32,62,61,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,84,68,49,46,100,101,108,97,121,84,105,109,101,0,105,110,116,101,103,101,114,40,100,101,108,97,121,40,49,44,32,47,42,82,101,97,108,42,47,40,73,110,116,101,103,101,114,40,112,114,101,40,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,84,68,49,46,120,41,41,41,44,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,84,68,49,46,100,101,108,97,121,84,105,109,101,44,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,84,68,49,46,100,101,108,97,121,84,105,109,101,41,44,32,48,41,0,116,105,109,101,32,62,61,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,84,68,49,46,100,101,108,97,121,84,105,109,101,0,105,110,116,101,103,101,114,40,100,101,108,97,121,40,48,44,32,47,42,82,101,97,108,42,47,40,73,110,116,101,103,101,114,40,112,114,101,40,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,84,68,49,46,120,41,41,41,44,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,84,68,49,46,100,101,108,97,121,84,105,109,101,44,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,84,68,49,46,100,101,108,97,121,84,105,109,101,41,44,32,49,41,0,116,105,109,101,32,62,61,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,84,68,49,46,100,101,108,97,121,84,105,109,101,0,105,110,116,101,103,101,114,40,100,101,108,97,121,40,51,44,32,47,42,82,101,97,108,42,47,40,73,110,116,101,103,101,114,40,112,114,101,40,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,84,68,49,46,120,41,41,41,44,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,84,68,49,46,100,101,108,97,121,84,105,109,101,44,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,84,68,49,46,100,101,108,97,121,84,105,109,101,41,44,32,50,41,0,116,105,109,101,32,62,61,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,84,68,49,46,100,101,108,97,121,84,105,109,101,0,105,110,116,101,103,101,114,40,100,101,108,97,121,40,50,44,32,47,42,82,101,97,108,42,47,40,73,110,116,101,103,101,114,40,112,114,101,40,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,84,68,49,46,120,41,41,41,44,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,84,68,49,46,100,101,108,97,121,84,105,109,101,44,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,84,68,49,46,100,101,108,97,121,84,105,109,101,41,44,32,51,41,0,116,105,109,101,32,62,61,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,84,68,49,46,100,101,108,97,121,84,105,109,101,0,105,110,116,101,103,101,114,40,100,101,108,97,121,40,53,44,32,47,42,82,101,97,108,42,47,40,73,110,116,101,103,101,114,40,112,114,101,40,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,84,68,49,46,120,41,41,41,44,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,84,68,49,46,100,101,108,97,121,84,105,109,101,44,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,84,68,49,46,100,101,108,97,121,84,105,109,101,41,44,32,52,41,0,116,105,109,101,32,62,61,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,84,68,49,46,100,101,108,97,121,84,105,109,101,0,105,110,116,101,103,101,114,40,100,101,108,97,121,40,52,44,32,47,42,82,101,97,108,42,47,40,73,110,116,101,103,101,114,40,112,114,101,40,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,84,68,49,46,120,41,41,41,44,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,84,68,49,46,100,101,108,97,121,84,105,109,101,44,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,84,68,49,46,100,101,108,97,121,84,105,109,101,41,44,32,53,41,0,116,105,109,101,32,62,61,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,84,68,49,46,100,101,108,97,121,84,105,109,101,0,105,110,116,101,103,101,114,40,100,101,108,97,121,40,55,44,32,47,42,82,101,97,108,42,47,40,73,110,116,101,103,101,114,40,112,114,101,40,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,84,68,49,46,120,41,41,41,44,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,84,68,49,46,100,101,108,97,121,84,105,109,101,44,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,84,68,49,46,100,101,108,97,121,84,105,109,101,41,44,32,54,41,0,116,105,109,101,32,62,61,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,84,68,49,46,100,101,108,97,121,84,105,109,101,0,105,110,116,101,103,101,114,40,100,101,108,97,121,40,54,44,32,47,42,82,101,97,108,42,47,40,73,110,116,101,103,101,114,40,112,114,101,40,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,84,68,49,46,120,41,41,41,44,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,84,68,49,46,100,101,108,97,121,84,105,109,101,44,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,84,68,49,46,100,101,108,97,121,84,105,109,101,41,44,32,55,41,0,110,111,116,32,116,105,109,101,32,62,61,32,67,108,111,99,107,46,115,116,97,114,116,84,105,109,101,32,111,114,32,116,105,109,101,32,62,61,32,67,108,111,99,107,46,116,95,105,32,43,32,67,108,111,99,107,46,116,95,119,105,100,116,104,0,0,0,0,0,0,0,0,116,105,109,101,32,62,61,32,69,110,97,98,108,101,46,115,116,101,112,84,105,109,101,0,1,0,0,0,207,0,0,0,1,0,0,0,209,0,0,0,1,0,0,0,207,0,0,0,1,0,0,0,209,0,0,0,1,0,0,0,207,0,0,0,1,0,0,0,209,0,0,0,1,0,0,0,207,0,0,0,1,0,0,0,209,0,0,0,1,0,0,0,207,0,0,0,1,0,0,0,209,0,0,0,1,0,0,0,207,0,0,0,1,0,0,0,209,0,0,0,1,0,0,0,207,0,0,0,1,0,0,0,209,0,0,0,1,0,0,0,207,0,0,0,1,0,0,0,209,0,0,0,1,0,0,0,27,1,0,0,1,0,0,0,25,1,0,0,176,15,0,0,184,15,0,0,192,15,0,0,200,15,0,0,208,15,0,0,216,15,0,0,224,15,0,0,232,15,0,0,240,15,0,0,248,15,0,0,0,16,0,0,8,16,0,0,16,16,0,0,24,16,0,0,32,16,0,0,40,16,0,0,48,16,0,0,56,16,0,0,116,105,109,101,32,62,61,32,67,108,111,99,107,46,115,116,97,114,116,84,105,109,101,0,116,105,109,101,32,62,61,32,67,108,111,99,107,46,116,95,105,32,43,32,67,108,111,99,107,46,116,95,119,105,100,116,104,0,0,0,0,0,0,0,208,9,0,0,128,10,0,0,48,11,0,0,224,11,0,0,144,12,0,0,64,13,0,0,240,13,0,0,160,14,0,0,136,16,0,0,160,16,0,0,152,15,0,0,0,0,0,0,99,104,101,99,107,32,102,111,114,32,100,105,115,99,114,101,116,101,32,99,104,97,110,103,101,115,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,49,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,108,111,99,107,46,95,121,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,108,111,99,107,46,95,116,95,105,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,101,110,97,98,108,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,65,110,100,49,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,65,110,100,49,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,65,110,100,50,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,65,110,100,50,46,95,120,91,49,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,65,110,100,50,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,65,110,100,51,46,95,121,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,78,111,116,49,46,95,97,117,120,105,108,105,97,114,121,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,82,83,49,46,95,78,111,114,49,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,82,83,49,46,95,78,111,114,49,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,82,83,49,46,95,84,68,49,46,95,120,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,65,110,100,49,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,65,110,100,49,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,65,110,100,50,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,65,110,100,50,46,95,120,91,49,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,65,110,100,50,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,65,110,100,51,46,95,121,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,78,111,116,49,46,95,97,117,120,105,108,105,97,114,121,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,82,83,49,46,95,78,111,114,49,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,82,83,49,46,95,78,111,114,49,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,82,83,49,46,95,84,68,49,46,95,120,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,65,110,100,49,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,65,110,100,49,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,65,110,100,50,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,65,110,100,50,46,95,120,91,49,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,65,110,100,50,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,65,110,100,51,46,95,121,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,78,111,116,49,46,95,97,117,120,105,108,105,97,114,121,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,82,83,49,46,95,78,111,114,49,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,82,83,49,46,95,78,111,114,49,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,82,83,49,46,95,84,68,49,46,95,120,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,65,110,100,49,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,65,110,100,49,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,65,110,100,50,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,65,110,100,50,46,95,120,91,49,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,65,110,100,50,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,65,110,100,51,46,95,121,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,78,111,116,49,46,95,97,117,120,105,108,105,97,114,121,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,82,83,49,46,95,78,111,114,49,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,82,83,49,46,95,78,111,114,49,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,82,83,49,46,95,84,68,49,46,95,120,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,65,110,100,49,46,95,121,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,65,110,100,51,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,65,110,100,51,46,95,120,91,49,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,65,110,100,51,46,95,120,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,65,110,100,52,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,82,83,50,46,95,78,111,114,49,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,82,83,50,46,95,78,111,114,49,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,82,83,50,46,95,84,68,49,46,95,120,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,65,110,100,52,46,95,121,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,82,83,49,46,95,78,111,114,50,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,82,83,49,46,95,78,111,114,50,46,95,120,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,82,83,49,46,95,78,111,114,50,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,82,83,49,46,95,84,68,49,46,95,120,95,100,101,108,97,121,101,100,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,65,110,100,50,46,95,121,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,82,83,50,46,95,78,111,114,50,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,82,83,50,46,95,78,111,114,50,46,95,120,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,82,83,50,46,95,78,111,114,50,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,52,93,46,95,82,83,50,46,95,84,68,49,46,95,120,95,100,101,108,97,121,101,100,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,65,110,100,49,46,95,121,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,65,110,100,51,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,65,110,100,51,46,95,120,91,49,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,65,110,100,51,46,95,120,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,65,110,100,52,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,82,83,50,46,95,78,111,114,49,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,82,83,50,46,95,78,111,114,49,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,82,83,50,46,95,84,68,49,46,95,120,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,65,110,100,52,46,95,121,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,82,83,49,46,95,78,111,114,50,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,82,83,49,46,95,78,111,114,50,46,95,120,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,82,83,49,46,95,78,111,114,50,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,82,83,49,46,95,84,68,49,46,95,120,95,100,101,108,97,121,101,100,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,65,110,100,50,46,95,121,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,82,83,50,46,95,78,111,114,50,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,82,83,50,46,95,78,111,114,50,46,95,120,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,82,83,50,46,95,78,111,114,50,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,51,93,46,95,82,83,50,46,95,84,68,49,46,95,120,95,100,101,108,97,121,101,100,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
/* memory initializer */ allocate([110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,65,110,100,49,46,95,121,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,65,110,100,51,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,65,110,100,51,46,95,120,91,49,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,65,110,100,51,46,95,120,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,65,110,100,52,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,82,83,50,46,95,78,111,114,49,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,82,83,50,46,95,78,111,114,49,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,82,83,50,46,95,84,68,49,46,95,120,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,65,110,100,52,46,95,121,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,82,83,49,46,95,78,111,114,50,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,82,83,49,46,95,78,111,114,50,46,95,120,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,82,83,49,46,95,78,111,114,50,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,82,83,49,46,95,84,68,49,46,95,120,95,100,101,108,97,121,101,100,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,65,110,100,50,46,95,121,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,82,83,50,46,95,78,111,114,50,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,82,83,50,46,95,78,111,114,50,46,95,120,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,82,83,50,46,95,78,111,114,50,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,50,93,46,95,82,83,50,46,95,84,68,49,46,95,120,95,100,101,108,97,121,101,100,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,65,110,100,49,46,95,121,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,65,110,100,51,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,65,110,100,51,46,95,120,91,49,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,65,110,100,51,46,95,120,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,65,110,100,52,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,82,83,50,46,95,78,111,114,49,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,82,83,50,46,95,78,111,114,49,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,82,83,50,46,95,84,68,49,46,95,120,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,65,110,100,52,46,95,121,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,82,83,49,46,95,78,111,114,50,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,82,83,49,46,95,78,111,114,50,46,95,120,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,82,83,49,46,95,78,111,114,50,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,82,83,49,46,95,84,68,49,46,95,120,95,100,101,108,97,121,101,100,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,65,110,100,50,46,95,121,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,82,83,50,46,95,78,111,114,50,46,95,97,117,120,105,108,105,97,114,121,95,110,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,82,83,50,46,95,78,111,114,50,46,95,120,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,82,83,50,46,95,78,111,114,50,46,95,97,117,120,105,108,105,97,114,121,91,50,93,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,67,111,117,110,116,101,114,46,95,70,70,91,49,93,46,95,82,83,50,46,95,84,68,49,46,95,120,95,100,101,108,97,121,101,100,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,101,109,112,116,121,0,0,0,117,112,100,97,116,105,110,103,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,1,0,0,0,160,53,0,0,168,53,0,0,0,0,0,0,2,0,0,0,80,52,0,0,88,52,0,0,0,0,0,0,1,0,0,0,32,52,0,0,40,52,0,0,0,0,0,0,2,0,0,0,208,50,0,0,216,50,0,0,0,0,0,0,9,0,0,0,9,0,0,0,1,0,0,0,1,0,0,0,3,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,3,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,4,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,4,0,0,0,3,0,0,0,2,0,0,0,0,0,0,0,9,0,0,0,9,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,4,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,4,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,4,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,4,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,4,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,4,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,4,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,4,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,4,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,105,110,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,97,120,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,110,111,109,105,110,97,108,45,118,97,108,117,101,115,0,117,112,100,97,116,105,110,103,32,115,116,97,114,116,45,118,97,108,117,101,115,0,0,0,37,115,40,115,116,97,114,116,61,37,103,41,0,0,0,0,0,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,81,51,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,81,51,46,110,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,68,105,103,105,116,97,108,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,81,50,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,81,50,46,110,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,81,49,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,81,49,46,110,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,81,48,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,81,48,46,110,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,144,54,0,0,206,18,0,0,11,0,0,0,206,18,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,84,68,49,46,121,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,84,68,49,46,121,48,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,84,68,49,46,121,48,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,78,111,114,50,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,78,111,114,50,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,78,111,114,49,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,78,111,114,49,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,113,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,113,48,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,113,48,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,84,68,49,46,121,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,84,68,49,46,121,48,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,84,68,49,46,121,48,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,78,111,114,50,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,78,111,114,50,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,78,111,114,49,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,78,111,114,49,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,113,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,113,48,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,113,48,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,52,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,52,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,51,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,51,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,50,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,50,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,49,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,49,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,113,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,113,48,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,113,48,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,84,68,49,46,121,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,84,68,49,46,121,48,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,84,68,49,46,121,48,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,78,111,114,50,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,78,111,114,50,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,78,111,114,49,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,78,111,114,49,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,113,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,113,48,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,113,48,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,84,68,49,46,121,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,84,68,49,46,121,48,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,84,68,49,46,121,48,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,78,111,114,50,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,78,111,114,50,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,78,111,114,49,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,78,111,114,49,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,113,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,113,48,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,113,48,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,52,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,52,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,51,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,51,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,50,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,50,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,49,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,49,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,113,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,113,48,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,113,48,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,84,68,49,46,121,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,84,68,49,46,121,48,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,84,68,49,46,121,48,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,78,111,114,50,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,78,111,114,50,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,78,111,114,49,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,78,111,114,49,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,113,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,113,48,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,113,48,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,84,68,49,46,121,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,84,68,49,46,121,48,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,84,68,49,46,121,48,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,78,111,114,50,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,78,111,114,50,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,78,111,114,49,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,78,111,114,49,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,113,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,113,48,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,113,48,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,52,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,52,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,51,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,51,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,50,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,50,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,49,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,49,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,113,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,113,48,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,113,48,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,84,68,49,46,121,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,84,68,49,46,121,48,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+10240);
/* memory initializer */ allocate([116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,84,68,49,46,121,48,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,78,111,114,50,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,78,111,114,50,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,78,111,114,49,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,78,111,114,49,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,113,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,113,48,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,113,48,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,84,68,49,46,121,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,84,68,49,46,121,48,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,84,68,49,46,121,48,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,144,54,0,0,172,11,0,0,11,0,0,0,172,11,0,0,74,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,78,111,114,50,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,78,111,114,50,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,78,111,114,49,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,78,111,114,49,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,113,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,113,48,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,113,48,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,144,54,0,0,248,5,0,0,11,0,0,0,248,5,0,0,74,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,52,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,52,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,51,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,51,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,50,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,50,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,49,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,49,46,110,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,144,54,0,0,158,10,0,0,11,0,0,0,158,10,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,113,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,113,48,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,113,48,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,144,54,0,0,33,7,0,0,11,0,0,0,33,7,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,113,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,113,48,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,113,48,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,144,54,0,0,165,9,0,0,11,0,0,0,165,9,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,108,111,99,107,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,108,111,99,107,46,119,105,100,116,104,32,62,61,32,49,101,45,54,48,32,97,110,100,32,67,108,111,99,107,46,119,105,100,116,104,32,60,61,32,49,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,144,54,0,0,255,16,0,0,11,0,0,0,1,17,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,108,111,99,107,46,112,101,114,105,111,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,108,111,99,107,46,112,101,114,105,111,100,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,144,54,0,0,253,16,0,0,11,0,0,0,254,16,0,0,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,69,110,97,98,108,101,46,97,102,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,69,110,97,98,108,101,46,97,102,116,101,114,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,69,110,97,98,108,101,46,97,102,116,101,114,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,144,54,0,0,2,16,0,0,11,0,0,0,3,16,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,69,110,97,98,108,101,46,98,101,102,111,114,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,69,110,97,98,108,101,46,98,101,102,111,114,101,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,69,110,97,98,108,101,46,98,101,102,111,114,101,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,144,54,0,0,0,16,0,0,11,0,0,0,1,16,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,108,111,99,107,46,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,108,111,99,107,46,121,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,108,111,99,107,46,121,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,68,105,103,105,116,97,108,46,109,111,0,0,0,0,0,0,88,92,0,0,2,17,0,0,11,0,0,0,4,17,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,101,110,97,98,108,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,101,110,97,98,108,101,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,101,110,97,98,108,101,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,88,92,0,0,166,9,0,0,11,0,0,0,168,9,0,0,57,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,50,46,120,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,50,46,120,91,49,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,50,46,120,91,49,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,51,46,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,51,46,121,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,51,46,121,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,78,111,116,49,46,97,117,120,105,108,105,97,114,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,78,111,116,49,46,97,117,120,105,108,105,97,114,121,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,78,111,116,49,46,97,117,120,105,108,105,97,114,121,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,84,68,49,46,120,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,84,68,49,46,120,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,84,68,49,46,120,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,50,46,120,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,50,46,120,91,49,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,50,46,120,91,49,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,51,46,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,51,46,121,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,51,46,121,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,78,111,116,49,46,97,117,120,105,108,105,97,114,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,78,111,116,49,46,97,117,120,105,108,105,97,114,121,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,78,111,116,49,46,97,117,120,105,108,105,97,114,121,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,84,68,49,46,120,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,84,68,49,46,120,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,84,68,49,46,120,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,50,46,120,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,50,46,120,91,49,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,50,46,120,91,49,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,51,46,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,51,46,121,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,51,46,121,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,78,111,116,49,46,97,117,120,105,108,105,97,114,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+20480);
/* memory initializer */ allocate([105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,78,111,116,49,46,97,117,120,105,108,105,97,114,121,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,78,111,116,49,46,97,117,120,105,108,105,97,114,121,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,84,68,49,46,120,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,84,68,49,46,120,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,84,68,49,46,120,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,50,46,120,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,50,46,120,91,49,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,50,46,120,91,49,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,88,92,0,0,238,12,0,0,11,0,0,0,238,12,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,51,46,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,51,46,121,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,51,46,121,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,78,111,116,49,46,97,117,120,105,108,105,97,114,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,78,111,116,49,46,97,117,120,105,108,105,97,114,121,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,78,111,116,49,46,97,117,120,105,108,105,97,114,121,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,88,92,0,0,199,12,0,0,11,0,0,0,199,12,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,84,68,49,46,120,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,84,68,49,46,120,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,84,68,49,46,120,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,49,46,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,49,46,121,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,49,46,121,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,51,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,51,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,51,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,51,46,120,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,51,46,120,91,49,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,51,46,120,91,49,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,51,46,120,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,51,46,120,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,51,46,120,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,52,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,52,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,52,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,84,68,49,46,120,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,84,68,49,46,120,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,84,68,49,46,120,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,52,46,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,52,46,121,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,52,46,121,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,78,111,114,50,46,120,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,78,111,114,50,46,120,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,78,111,114,50,46,120,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,49,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,50,46,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,50,46,121,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,65,110,100,50,46,121,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,78,111,114,50,46,120,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,78,111,114,50,46,120,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,78,111,114,50,46,120,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,52,93,46,82,83,50,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,49,46,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,49,46,121,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,49,46,121,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,51,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,51,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,51,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,51,46,120,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,51,46,120,91,49,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,51,46,120,91,49,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,51,46,120,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,51,46,120,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,51,46,120,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,52,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,52,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,52,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,84,68,49,46,120,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,84,68,49,46,120,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,84,68,49,46,120,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+30720);
/* memory initializer */ allocate([116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,52,46,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,52,46,121,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,52,46,121,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,78,111,114,50,46,120,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,78,111,114,50,46,120,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,78,111,114,50,46,120,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,49,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,50,46,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,50,46,121,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,65,110,100,50,46,121,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,78,111,114,50,46,120,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,78,111,114,50,46,120,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,78,111,114,50,46,120,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,51,93,46,82,83,50,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,49,46,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,49,46,121,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,49,46,121,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,51,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,51,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,51,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,51,46,120,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,51,46,120,91,49,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,51,46,120,91,49,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,51,46,120,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,51,46,120,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,51,46,120,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,52,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,52,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,52,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,84,68,49,46,120,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,84,68,49,46,120,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,84,68,49,46,120,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,52,46,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,52,46,121,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,52,46,121,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,78,111,114,50,46,120,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,78,111,114,50,46,120,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,78,111,114,50,46,120,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,49,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,50,46,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,50,46,121,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,65,110,100,50,46,121,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,78,111,114,50,46,120,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,78,111,114,50,46,120,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,78,111,114,50,46,120,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,50,93,46,82,83,50,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,49,46,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,49,46,121,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,49,46,121,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,51,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,51,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,51,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,51,46,120,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,51,46,120,91,49,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,51,46,120,91,49,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,51,46,120,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,51,46,120,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,51,46,120,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,52,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,52,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,52,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,88,92,0,0,239,12,0,0,11,0,0,0,239,12,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,78,111,114,49,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,84,68,49,46,120,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,84,68,49,46,120,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,84,68,49,46,120,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,88,92,0,0,135,10,0,0,11,0,0,0,137,10,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,52,46,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,52,46,121,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,52,46,121,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,78,111,114,50,46,120,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,78,111,114,50,46,120,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,78,111,114,50,46,120,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+40960);
/* memory initializer */ allocate([121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,49,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,50,46,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,50,46,121,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,65,110,100,50,46,121,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,88,92,0,0,163,10,0,0,11,0,0,0,165,10,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,95,110,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,88,92,0,0,115,13,0,0,11,0,0,0,115,13,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,78,111,114,50,46,120,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,78,111,114,50,46,120,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,78,111,114,50,46,120,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,88,92,0,0,159,10,0,0,11,0,0,0,162,10,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,78,111,114,50,46,97,117,120,105,108,105,97,114,121,91,50,93,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,88,92,0,0,114,13,0,0,11,0,0,0,114,13,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,62,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,85,39,32,97,110,100,32,67,111,117,110,116,101,114,46,70,70,91,49,93,46,82,83,50,46,84,68,49,46,120,95,100,101,108,97,121,101,100,32,60,61,32,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,68,105,103,105,116,97,108,46,73,110,116,101,114,102,97,99,101,115,46,76,111,103,105,99,46,39,45,39,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,88,92,0,0,175,11,0,0,11,0,0,0,175,11,0,0,39,0,0,0,0,0,0,0,109,111,100,101,108,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,69,108,101,99,116,114,105,99,97,108,95,68,105,103,105,116,97,108,95,69,120,97,109,112,108,101,115,95,67,111,117,110,116,101,114,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,110,32,61,32,49,59,32,47,47,32,115,116,97,116,101,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,107,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,105,110,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,108,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,111,117,116,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,120,48,91,49,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,117,48,91,48,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,65,91,49,44,49,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,66,91,49,44,48,93,32,61,32,122,101,114,111,115,40,49,44,48,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,67,91,48,44,49,93,32,61,32,122,101,114,111,115,40,48,44,49,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,68,91,48,44,48,93,32,61,32,122,101,114,111,115,40,48,44,48,41,59,37,115,10,32,32,82,101,97,108,32,120,91,49,93,40,115,116,97,114,116,61,120,48,41,59,10,32,32,105,110,112,117,116,32,82,101,97,108,32,117,91,48,93,59,10,32,32,111,117,116,112,117,116,32,82,101,97,108,32,121,91,48,93,59,10,10,32,32,82,101,97,108,32,120,95,80,36,100,117,109,109,121,32,61,32,120,91,49,93,59,10,32,32,32,32,32,32,10,101,113,117,97,116,105,111,110,10,32,32,100,101,114,40,120,41,32,61,32,65,32,42,32,120,32,43,32,66,32,42,32,117,59,10,32,32,121,32,61,32,67,32,42,32,120,32,43,32,68,32,42,32,117,59,10,101,110,100,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,69,108,101,99,116,114,105,99,97,108,95,68,105,103,105,116,97,108,95,69,120,97,109,112,108,101,115,95,67,111,117,110,116,101,114,59,10,0,0,0,0,0,88,210,0,0,104,210,0,0,120,210,0,0,144,210,0,0,176,210,0,0,192,210,0,0,216,210,0,0,232,210,0,0,0,211,0,0,32,211,0,0,72,211,0,0,96,211,0,0,128,211,0,0,152,211,0,0,192,211,0,0,224,211,0,0,16,212,0,0,64,212,0,0,88,212,0,0,144,212,0,0,168,212,0,0,216,212,0,0,248,212,0,0,48,213,0,0,88,213,0,0,144,213,0,0,192,213,0,0,208,213,0,0,240,213,0,0,24,214,0,0,56,214,0,0,96,214,0,0,136,214,0,0,160,214,0,0,184,214,0,0,200,214,0,0,224,214,0,0,16,215,0,0,96,215,0,0,160,215,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,115,121,110,116,97,120,32,101,114,114,111,114,0,0,0,0,110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0,0,0,0,0,0,0,0,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0,117,110,99,108,111,115,101,100,32,116,111,107,101,110,0,0,112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,109,105,115,109,97,116,99,104,101,100,32,116,97,103,0,0,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0,0,0,0,0,0,0,0,114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0,0,101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0,0,0,0,0,0,101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0,0,0,0,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0,0,0,0,117,110,98,111,117,110,100,32,112,114,101,102,105,120,0,0,109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0,0,0,0,0,0,0,105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0,0,0,0,0,0,0,112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0,0,0,0,0,0,0,0,112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0,0,0,0,112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0,112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0,0,0,0,0,0,112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,35,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,89,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,40,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,4,254,255,255,135,254,255,255,7,0,0,0,0,0,0,0,0,255,255,127,255,255,255,127,255,255,255,255,255,255,255,243,127,254,253,255,255,255,255,255,127,255,255,255,255,255,255,255,255,15,224,255,255,255,255,49,252,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,3,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,0,0,0,0,0,0,0,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,254,7,0,0,0,0,254,255,255,255,255,255,255,255,255,124,255,127,47,0,96,0,0,0,224,255,255,255,255,255,255,35,0,0,0,255,3,0,0,0,224,159,249,255,255,253,197,3,0,0,0,176,3,0,3,0,224,135,249,255,255,253,109,3,0,0,0,94,0,0,28,0,224,175,251,255,255,253,237,35,0,0,0,0,1,0,0,0,224,159,249,255,255,253,205,35,0,0,0,176,3,0,0,0,224,199,61,214,24,199,191,3,0,0,0,0,0,0,0,0,224,223,253,255,255,253,239,3,0,0,0,0,3,0,0,0,224,223,253,255,255,253,239,3,0,0,0,64,3,0,0,0,224,223,253,255,255,253,255,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,13,0,63,0,0,0,0,0,0,0,150,37,240,254,174,108,13,32,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,254,255,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,63,0,255,255,255,255,127,0,237,218,7,0,0,0,0,80,1,80,49,130,171,98,44,0,0,0,0,64,0,201,128,245,7,0,0,0,0,8,1,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,3,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,64,76,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,254,3,0,0,254,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,7,224,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,7,254,255,255,135,254,255,255,7,0,0,0,0,0,0,128,0,255,255,127,255,255,255,127,255,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,3,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,3,0,0,0,192,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,123,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,254,255,251,255,255,187,22,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,255,255,7,0,255,3,255,255,255,255,255,255,255,255,255,124,255,127,239,255,255,61,255,3,238,255,255,255,255,255,255,243,255,63,30,255,207,255,0,0,238,159,249,255,255,253,197,211,159,57,128,176,207,255,3,0,228,135,249,255,255,253,109,211,135,57,0,94,192,255,31,0,238,175,251,255,255,253,237,243,191,59,0,0,193,255,0,0,238,159,249,255,255,253,205,243,143,57,192,176,195,255,0,0,236,199,61,214,24,199,191,195,199,61,128,0,128,255,0,0,238,223,253,255,255,253,239,195,223,61,96,0,195,255,0,0,236,223,253,255,255,253,239,195,223,61,96,64,195,255,0,0,236,223,253,255,255,253,255,195,207,61,128,0,195,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,255,7,255,127,255,3,0,0,0,0,150,37,240,254,174,108,255,59,95,63,255,3,0,0,0,0,0,0,0,3,255,3,160,194,255,254,255,255,255,3,254,255,223,15,191,254,255,63,254,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,31,2,0,0,0,160,0,0,0,254,255,62,0,254,255,255,255,255,255,255,255,255,255,31,102,254,255,255,255,255,255,255,255,255,255,255,119,25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,208,229,0,0,96,228,0,0,232,226,0,0,112,225,0,0,112,225,0,0,248,223,0,0,232,226,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,152,240,0,0,32,237,0,0,176,235,0,0,64,234,0,0,64,234,0,0,208,232,0,0,176,235,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,101,114,115,105,111,110,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,121,101,115,0,0,0,0,0,110,111,0,0,0,0,0,0,224,238,0,0,240,238,0,0,0,239,0,0,208,223,0,0,8,239,0,0,24,239,0,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+51200);
/* memory initializer */ allocate([8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,65,84,84,76,73,83,84,0,69,76,69,77,69,78,84,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,69,77,80,84,89,0,0,0,65,78,89,0,0,0,0,0,80,67,68,65,84,65,0,0,120,242,0,0,128,242,0,0,136,242,0,0,144,242,0,0,8,242,0,0,152,242,0,0,168,242,0,0,176,242,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,73,77,80,76,73,69,68,0,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,0,70,73,88,69,68,0,0,0,78,68,65,84,65,0,0,0,73,78,67,76,85,68,69,0,73,71,78,79,82,69,0,0,68,79,67,84,89,80,69,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,76,79,71,95,85,78,75,78,79,87,78,0,0,0,0,0,115,116,100,111,117,116,0,0,97,115,115,101,114,116,0,0,76,79,71,95,68,68,65,83,82,84,0,0,0,0,0,0,76,79,71,95,68,69,66,85,71,0,0,0,0,0,0,0,76,79,71,95,68,83,83,0,76,79,71,95,68,83,83,95,74,65,67,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,0,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,95,86,0,0,0,0,76,79,71,95,73,78,73,84,0,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,95,70,85,76,76,0,0,76,79,71,95,73,80,79,80,84,95,74,65,67,0,0,0,76,79,71,95,73,80,79,80,84,95,72,69,83,83,69,0,76,79,71,95,74,65,67,0,76,79,71,95,76,83,0,0,76,79,71,95,76,83,95,86,0,0,0,0,0,0,0,0,76,79,71,95,78,76,83,0,76,79,71,95,78,76,83,95,86,0,0,0,0,0,0,0,76,79,71,95,78,76,83,95,74,65,67,0,0,0,0,0,76,79,71,95,78,76,83,95,82,69,83,0,0,0,0,0,76,79,71,95,82,69,83,95,73,78,73,84,0,0,0,0,76,79,71,95,83,73,77,85,76,65,84,73,79,78,0,0,76,79,71,95,83,79,76,86,69,82,0,0,0,0,0,0,76,79,71,95,83,79,84,73,0,0,0,0,0,0,0,0,76,79,71,95,83,84,65,84,83,0,0,0,0,0,0,0,76,79,71,95,85,84,73,76,0,0,0,0,0,0,0,0,76,79,71,95,90,69,82,79,67,82,79,83,83,73,78,71,83,0,0,0,0,0,0,0,16,243,0,0,32,243,0,0,40,243,0,0,48,243,0,0,64,243,0,0,80,243,0,0,88,243,0,0,104,243,0,0,120,243,0,0,136,243,0,0,152,243,0,0,168,243,0,0,184,243,0,0,200,243,0,0,216,243,0,0,224,243,0,0,232,243,0,0,248,243,0,0,0,244,0,0,16,244,0,0,32,244,0,0,48,244,0,0,64,244,0,0,80,244,0,0,96,244,0,0,112,244,0,0,128,244,0,0,144,244,0,0,117,110,107,110,111,119,110,0,116,104,105,115,32,115,116,114,101,97,109,32,105,115,32,97,108,119,97,121,115,32,97,99,116,105,118,101,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,97,115,115,108,32,115,111,108,118,101,114,0,0,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,100,101,98,117,103,32,105,110,102,111,114,109,97,116,105,111,110,0,0,0,0,111,117,116,112,117,116,115,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,106,97,99,111,98,105,97,110,32,111,102,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,101,118,101,110,116,32,115,121,115,116,101,109,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,0,0,0,99,104,101,99,107,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,0,0,0,0,0,0,0,99,104,101,99,107,32,104,101,115,115,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,117,115,101,100,32,98,121,32,100,97,115,115,108,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,101,118,101,114,121,32,101,118,97,108,117,97,116,105,111,110,32,111,102,32,116,104,101,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,114,101,115,105,100,117,97,108,115,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,105,109,117,108,97,116,105,111,110,32,112,114,111,99,101,115,115,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,111,108,118,101,114,32,112,114,111,99,101,115,115,0,0,0,0,0,102,105,110,97,108,32,115,111,108,117,116,105,111,110,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,115,116,97,116,105,115,116,105,99,115,32,97,98,111,117,116,32,116,105,109,101,114,47,101,118,101,110,116,115,47,115,111,108,118,101,114,0,63,63,63,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,116,104,101,32,122,101,114,111,99,114,111,115,115,105,110,103,115,0,0,24,245,0,0,32,245,0,0,32,245,0,0,64,245,0,0,112,245,0,0,144,245,0,0,200,245,0,0,248,245,0,0,40,246,0,0,72,246,0,0,120,246,0,0,144,246,0,0,176,246,0,0,216,246,0,0,248,246,0,0,40,247,0,0,72,247,0,0,112,247,0,0,144,247,0,0,184,247,0,0,232,247,0,0,32,248,0,0,72,248,0,0,120,248,0,0,168,248,0,0,208,248,0,0,0,249,0,0,8,249,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91,37,115,58,37,100,58,37,100,45,37,100,58,37,100,58,37,115,93,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,37,45,49,55,115,32,124,32,0,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,37,45,55,115,32,124,32,0,24,245,0,0,8,252,0,0,16,252,0,0,24,252,0,0,40,243,0,0,32,252,0,0,124,32,0,0,0,0,0,0,60,109,101,115,115,97,103,101,32,115,116,114,101,97,109,61,34,37,115,34,32,116,121,112,101,61,34,37,115,34,32,116,101,120,116,61,34,0,0,0,34,62,10,0,0,0,0,0,60,117,115,101,100,32,105,110,100,101,120,61,34,37,100,34,32,47,62,10,0,0,0,0,60,47,109,101,115,115,97,103,101,62,10,0,0,0,0,0,34,32,47,62,10,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,38,97,109,112,59,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,105,110,102,111,0,0,0,0,119,97,114,110,105,110,103,0,101,114,114,111,114,0,0,0,100,101,98,117,103,0,0,0,34,62,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,101,109,112,116,121,32,108,105,115,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,102,105,115,116,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,110,111,100,101,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,100,97,116,97,32,110,111,100,101,0,0,0,0,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,27,0,0,0,2,0,0,0,2,0,0,0,28,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,105,110,84,114,97,110,115,0,0,0,0,0,0,0,0,8,253,0,0,0,0,0,0,98,105,110,78,111,114,109,97,108,0,0,0,0,0,0,0,32,253,0,0,0,0,0,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,100,97,116,97,95,50,0,0,56,253,0,0,64,253,0,0,72,253,0,0,88,253,0,0,104,253,0,0,112,253,0,0,51,0,0,0,51,0,0,0,51,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,49,41,0,0,0,0,0,0,77,97,116,114,105,120,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,0,0,0,77,97,116,114,105,120,32,117,115,101,115,32,105,109,97,103,105,110,97,114,121,32,110,117,109,98,101,114,115,0,0,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,105,122,101,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,50,41,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,51,41,0,0,0,0,0,0,77,97,116,114,105,120,32,110,97,109,101,32,109,105,115,109,97,116,99,104,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,52,32,114,111,119,115,0,0,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,49,32,99,111,108,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,65,99,108,97,115,115,32,109,97,116,114,105,120,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,98,105,110,84,114,97,110,115,32,111,114,32,98,105,110,78,111,114,109,97,108,32,102,111,114,109,97,116,0,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,110,97,109,101,115,32,109,97,116,114,105,120,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,73,110,102,111,32,109,97,116,114,105,120,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,49,32,118,97,114,105,97,98,108,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,99,111,108,115,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,49,32,109,97,116,114,105,120,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,99,111,110,116,97,105,110,101,100,32,112,97,114,97,109,101,116,101,114,32,116,104,97,116,32,99,104,97,110,103,101,100,32,98,101,116,119,101,101,110,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,45,116,105,109,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,114,111,119,115,0,84,111,111,32,102,101,119,32,114,111,119,115,32,105,110,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,73,109,112,108,101,109,101,110,116,97,116,105,111,110,32,101,114,114,111,114,58,32,85,110,107,110,111,119,110,32,99,97,115,101,0,0,0,0,0,0,97,98,115,86,97,114,73,110,100,101,120,32,62,32,48,32,38,38,32,97,98,115,86,97,114,73,110,100,101,120,32,60,61,32,114,101,97,100,101,114,45,62,110,118,97,114,0,0,117,116,105,108,47,114,101,97,100,95,109,97,116,108,97,98,52,46,99,0,0,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,118,97,108,115,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,115,105,110,103,108,101,95,118,97,108,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,109,112,116,121,32,82,105,110,103,66,117,102,102,101,114,0,0,0,0,0,0,0,0,105,110,100,101,120,32,91,37,100,93,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,100,58,37,100,93,0,72,8,1,0,0,0,0,0,192,7,1,0,0,0,0,0,56,7,1,0,0,0,0,0,176,6,1,0,0,0,0,0,168,5,1,0,0,0,0,0,160,4,1,0,0,0,0,0,152,3,1,0,0,0,0,0,144,2,1,0,0,0,0,0,97,99,99,95,116,112,32,33,61,32,48,0,0,0,0,0,117,116,105,108,47,114,116,99,108,111,99,107,46,99,0,0,114,116,95,105,110,105,116,0,109,97,120,95,116,112,32,33,61,32,48,0,0,0,0,0,116,111,116,97,108,95,116,112,32,33,61,32,48,0,0,0,116,105,99,107,95,116,112,32,33,61,32,48,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,32,33,61,32,48,0,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,105,110,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,97,120,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,116,111,116,97,108,32,33,61,32,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+61440);
/* memory initializer */ allocate([70,76,65,71,95,85,78,75,78,79,87,78,0,0,0,0,99,108,111,99,107,0,0,0,99,112,117,0,0,0,0,0,101,109,105,116,95,112,114,111,116,101,99,116,101,100,0,0,102,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,105,105,102,0,0,0,0,0,105,105,109,0,0,0,0,0,105,105,116,0,0,0,0,0,105,108,115,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,0,0,0,0,0,105,111,109,0,0,0,0,0,105,112,111,112,116,95,104,101,115,115,101,0,0,0,0,0,105,112,111,112,116,95,106,97,99,0,0,0,0,0,0,0,105,112,111,112,116,95,105,110,105,116,0,0,0,0,0,0,108,0,0,0,0,0,0,0,108,111,103,70,111,114,109,97,116,0,0,0,0,0,0,0,108,115,0,0,0,0,0,0,108,115,95,105,112,111,112,116,0,0,0,0,0,0,0,0,108,118,0,0,0,0,0,0,109,101,97,115,117,114,101,84,105,109,101,80,108,111,116,70,111,114,109,97,116,0,0,0,110,108,115,0,0,0,0,0,110,111,101,109,105,116,0,0,110,111,69,118,101,110,116,69,109,105,116,0,0,0,0,0,111,117,116,112,117,116,0,0,111,118,101,114,114,105,100,101,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,70,105,108,101,0,0,0,0,112,111,114,116,0,0,0,0,114,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,208,8,1,0,224,8,1,0,232,8,1,0,240,8,1,0,0,9,1,0,8,9,1,0,16,9,1,0,24,9,1,0,32,9,1,0,40,9,1,0,48,9,1,0,64,9,1,0,72,9,1,0,88,9,1,0,104,9,1,0,120,9,1,0,128,9,1,0,144,9,1,0,152,9,1,0,168,9,1,0,176,9,1,0,200,9,1,0,208,9,1,0,216,9,1,0,232,9,1,0,240,9,1,0,0,10,1,0,16,10,1,0,24,10,1,0,32,10,1,0,40,10,1,0,48,10,1,0,117,110,107,110,111,119,110,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,0,0,0,0,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,115,45,102,105,108,101,0,0,0,0,0,0,0,0,101,109,105,116,115,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,115,101,116,117,112,32,88,77,76,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,110,32,101,120,116,101,114,110,97,108,32,102,105,108,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,0,91,100,111,117,98,108,101,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,91,105,110,116,93,32,100,101,102,97,117,108,116,58,32,49,0,0,0,0,0,0,0,0,115,112,101,99,105,102,121,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,119,104,101,114,101,32,116,104,101,32,108,105,110,101,97,114,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,32,115,104,111,117,108,100,32,98,101,32,112,101,114,102,111,114,109,101,100,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,46,32,45,108,111,103,70,111,114,109,97,116,61,116,101,120,116,32,40,100,101,102,97,117,108,116,41,32,111,114,32,45,108,111,103,70,111,114,109,97,116,61,120,109,108,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,105,112,111,112,116,0,0,0,0,0,0,91,115,116,114,105,110,103,32,108,105,115,116,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,97,110,121,32,114,101,115,117,108,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,101,118,101,110,116,32,112,111,105,110,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,32,112,111,114,116,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,114,101,115,117,108,116,32,102,105,108,101,32,116,104,97,110,32,116,104,101,32,100,101,102,97,117,108,116,32,77,111,100,101,108,95,114,101,115,46,109,97,116,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,115,111,108,118,101,114,0,0,0,0,0,0,115,104,111,119,115,32,97,108,108,32,119,97,114,110,105,110,103,115,32,101,118,101,110,32,105,102,32,97,32,114,101,108,97,116,101,100,32,108,111,103,45,115,116,114,101,97,109,32,105,115,32,105,110,97,99,116,105,118,101,0,0,0,0,0,192,10,1,0,200,10,1,0,16,11,1,0,64,11,1,0,112,11,1,0,184,11,1,0,248,11,1,0,64,12,1,0,112,12,1,0,184,12,1,0,208,12,1,0,240,12,1,0,40,13,1,0,80,13,1,0,120,13,1,0,176,13,1,0,0,14,1,0,96,14,1,0,144,14,1,0,200,14,1,0,248,14,1,0,64,15,1,0,104,15,1,0,152,15,1,0,200,15,1,0,32,16,1,0,104,16,1,0,216,16,1,0,8,17,1,0,80,17,1,0,112,17,1,0,48,10,1,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,10,32,32,82,84,61,109,111,110,111,116,111,110,105,99,32,114,101,97,108,45,116,105,109,101,32,99,108,111,99,107,44,32,67,80,85,61,112,114,111,99,101,115,115,45,98,97,115,101,100,32,67,80,85,45,116,105,109,101,44,32,67,89,67,61,99,112,117,32,99,121,99,108,101,115,32,109,101,97,115,117,114,101,100,32,119,105,116,104,32,82,68,84,83,67,0,0,0,0,0,32,32,45,32,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,10,32,32,45,32,36,99,112,117,84,105,109,101,32,105,115,32,116,104,101,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,105,110,115,105,100,101,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,10,32,32,101,46,103,46,32,45,104,101,108,112,61,102,32,112,114,105,110,116,115,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,32,102,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,102,111,114,32,104,111,109,111,116,111,112,121,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,115,121,109,98,111,108,105,99,41,32,111,114,10,39,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,39,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,110,117,109,101,114,105,99,32,45,105,111,109,61,110,101,108,100,101,114,95,109,101,97,100,95,101,120,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,101,109,97,116,114,105,120,32,102,111,114,32,73,112,111,112,116,40,79,77,67,44,32,66,70,71,83,44,32,99,111,110,115,116,41,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,40,83,89,77,44,32,78,85,77,44,32,78,85,77,68,69,78,83,69,41,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,32,40,115,105,109,44,32,99,111,110,115,116,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,10,32,32,108,97,112,97,99,107,44,32,108,105,115,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,73,112,111,112,116,44,32,100,101,102,97,117,108,116,32,109,117,109,112,115,46,10,32,78,111,116,101,58,32,85,115,101,32,105,102,32,121,111,117,32,98,117,105,108,100,32,105,112,111,112,116,32,119,105,116,104,32,111,116,104,101,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,105,107,101,32,109,97,50,55,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,10,32,32,115,118,103,10,32,32,106,112,103,10,32,32,112,115,10,32,32,103,105,102,10,32,32,46,46,46,0,0,0,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,10,32,32,116,105,109,101,32,61,32,118,97,108,117,101,44,32,97,32,61,32,118,97,108,117,101,44,32,98,32,61,32,118,97,108,117,101,44,32,99,32,61,32,118,97,108,117,101,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,10,32,32,101,46,103,46,32,118,97,114,49,61,115,116,97,114,116,49,44,118,97,114,50,61,115,116,97,114,116,50,44,112,97,114,51,61,115,116,97,114,116,51,44,115,116,97,114,116,84,105,109,101,61,118,97,108,49,44,115,116,111,112,84,105,109,101,61,118,97,108,50,44,115,116,101,112,83,105,122,101,61,118,97,108,51,44,10,32,32,32,32,32,32,32,116,111,108,101,114,97,110,99,101,61,118,97,108,52,44,115,111,108,118,101,114,61,34,115,101,101,32,45,115,34,44,111,117,116,112,117,116,70,111,114,109,97,116,61,34,109,97,116,124,112,108,116,124,99,115,118,124,101,109,112,116,121,34,44,118,97,114,105,97,98,108,101,70,105,108,116,101,114,61,34,102,105,108,116,101,114,34,0,0,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,10,32,32,110,111,116,101,32,116,104,97,116,58,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,67,65,78,78,79,84,32,98,101,32,117,115,101,100,32,119,105,116,104,32,45,111,118,101,114,114,105,100,101,10,32,32,117,115,101,32,119,104,101,110,32,118,97,114,105,97,98,108,101,115,32,102,111,114,32,45,111,118,101,114,114,105,100,101,32,97,114,101,32,116,111,111,32,109,97,110,121,32,97,110,100,32,100,111,32,110,111,116,32,102,105,116,32,105,110,32,99,111,109,109,97,110,100,32,108,105,110,101,32,115,105,122,101,10,32,32,111,118,101,114,114,105,100,101,70,105,108,101,78,97,109,101,32,99,111,110,116,97,105,110,115,32,108,105,110,101,115,32,111,102,32,116,104,101,32,102,111,114,109,58,32,118,97,114,49,61,115,116,97,114,116,49,0,0,0,0,0,0,192,10,1,0,48,18,1,0,216,18,1,0,64,11,1,0,112,11,1,0,64,19,1,0,248,11,1,0,64,12,1,0,200,19,1,0,8,20,1,0,208,12,1,0,240,12,1,0,168,20,1,0,232,20,1,0,40,21,1,0,176,13,1,0,0,14,1,0,104,21,1,0,160,21,1,0,40,22,1,0,80,22,1,0,64,15,1,0,104,15,1,0,152,15,1,0,184,22,1,0,64,23,1,0,64,24,1,0,216,16,1,0,8,17,1,0,80,17,1,0,112,17,1,0,48,10,1,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,49,120,44,56,48,97,49,41,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,41,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,44,51,120,44,2,73,50,32,61,2,44,105,49,48,41,0,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,41,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,44,51,120,44,2,82,50,32,61,2,44,101,50,49,46,49,51,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,29,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,29,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,29,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,30,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,30,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,72,69,32,76,65,83,84,32,83,84,69,80,32,84,69,82,77,73,78,65,84,69,68,32,87,73,84,72,32,65,32,78,69,71,65,84,73,86,69,0,0,0,0,0,0,0,49,0,0,0,0,0,0,0,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,86,65,76,85,69,32,40,61,73,49,41,32,79,70,32,73,68,73,68,32,65,78,68,32,78,79,32,65,80,80,82,79,80,82,73,65,84,69,0,47,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,67,84,73,79,78,32,87,65,83,32,84,65,75,69,78,46,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,203,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,67,85,82,82,69,78,84,32,84,32,40,61,82,49,41,32,32,53,48,48,32,83,84,69,80,83,0,0,38,0,0,0,0,0,0,0,98,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,65,75,69,78,32,79,78,32,84,72,73,83,32,67,65,76,76,32,66,69,70,79,82,69,32,82,69,65,67,72,73,78,71,32,84,79,85,84,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,99,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,84,79,79,32,77,85,67,72,32,65,67,67,85,82,65,67,89,32,82,69,81,85,69,83,84,69,68,0,108,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,70,79,82,32,80,82,69,67,73,83,73,79,78,32,79,70,32,77,65,67,72,73,78,69,46,32,82,84,79,76,32,65,78,68,32,65,84,79,76,0,0,0,0,0,0,0,0,109,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,87,69,82,69,32,73,78,67,82,69,65,83,69,68,32,84,79,32,65,80,80,82,79,80,82,73,65,84,69,32,86,65,76,85,69,83,0,0,0,45,0,0,0,0,0,0,0,110,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,0,0,118,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,65,83,32,66,69,67,79,77,69,32,46,76,69,46,32,48,46,48,0,0,0,0,28,0,0,0,0,0,0,0,119,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,32,84,72,69,0,0,0,0,44,0,0,0,0,0,0,0,128,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,129,2,0,0,0,0,0,0,138,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,70,65,73,76,69,68,32,84,79,32,67,79,78,86,69,82,71,69,32,82,69,80,69,65,84,69,68,76,89,0,0,0,0,0,0,0,0,139,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,140,2,0,0,0,0,0,0,148,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,84,69,82,65,84,73,79,78,32,77,65,84,82,73,88,32,73,83,32,83,73,78,71,85,76,65,82,0,0,0,37,0,0,0,0,0,0,0,149,2,0,0,0,0,0,0,158,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,46,32,32,65,76,83,79,44,32,84,72,69,0,0,0,0,0,0,0,159,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,46,0,0,160,2,0,0,0,0,0,0,163,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,32,66,69,67,65,85,83,69,0,0,0,164,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,79,78,69,0,0,0,0,36,0,0,0,0,0,0,0,165,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,0,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,168,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,84,87,79,0,0,0,0,169,2,0,0,0,0,0,0,173,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,73,84,73,65,76,32,89,80,82,73,77,69,32,67,79,85,76,68,32,78,79,84,32,66,69,32,67,79,77,80,85,84,69,68,0,0,0,174,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,73,78,70,79,32,86,69,67,84,79,82,32,73,83,32,78,79,84,32,90,69,82,79,32,79,82,32,79,78,69,0,55,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,69,81,32,40,61,73,49,41,32,46,76,69,46,32,48,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,65,88,79,82,68,32,40,61,73,49,41,32,78,79,84,32,73,78,32,82,65,78,71,69,0,0,0,0,0,0,34,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,82,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,82,87,32,40,61,73,50,41,0,0,0,0,60,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,73,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,73,87,32,40,61,73,50,41,0,0,0,0,5,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,82,84,79,76,32,73,83,32,46,76,84,46,32,48,0,39,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,65,84,79,76,32,73,83,32,46,76,84,46,32,48,0,7,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,76,76,32,69,76,69,77,69,78,84,83,32,79,70,32,82,84,79,76,32,65,78,68,32,65,84,79,76,32,65,82,69,32,90,69,82,79,0,8,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,32,61,32,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,79,85,84,32,40,61,82,50,41,0,0,54,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,77,65,88,32,40,61,82,49,41,32,46,76,84,46,32,48,46,48,0,0,0,0,10,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,11,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,56,41,61,49,32,65,78,68,32,72,48,61,48,46,48,0,0,0,29,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,32,73,83,32,46,76,69,46,32,48,46,48,0,13,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,84,79,85,84,32,40,61,82,49,41,32,84,79,79,32,67,76,79,83,69,32,84,79,32,84,32,40,61,82,50,41,32,84,79,32,83,84,65,82,84,32,73,78,84,69,71,82,65,84,73,79,78,0,0,0,0,14,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,61,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,76,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,52,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,85,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,18,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,73,83,32,69,81,85,65,76,32,84,79,32,84,32,40,61,82,50,41,0,19,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,71,32,40,61,73,49,41,32,46,76,84,46,32,48,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,78,69,32,79,82,32,77,79,82,69,32,67,79,77,80,79,78,69,78,84,83,32,79,70,32,71,32,72,65,83,32,65,32,82,79,79,84,0,32,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,84,79,79,32,78,69,65,82,32,84,79,32,84,72,69,32,73,78,73,84,73,65,76,32,80,79,73,78,84,0,0,68,65,83,83,76,45,45,32,32,82,69,80,69,65,84,69,68,32,79,67,67,85,82,82,69,78,67,69,83,32,79,70,32,73,76,76,69,71,65,76,32,73,78,80,85,84,0,0,46,0,0,0,0,0,0,0,33,3,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,46,32,65,80,80,65,82,69,78,84,32,73,78,70,73,78,73,84,69,32,76,79,79,80,0,34,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,116,32,112,111,105,110,116,32,105,110,32,116,105,109,101,58,32,37,103,0,0,0,0,99,106,58,32,37,103,0,0,115,116,97,116,101,115,0,0,91,37,108,100,93,32,37,103,0,0,0,0,0,0,0,0,97,110,97,108,121,116,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,37,115,37,103,32,0,0,0,37,115,0,0,0,0,0,0,110,117,109,101,114,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,66,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,77,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,76,0,0,0,0,0,0,0,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,47,2,32,87,65,82,78,73,78,71,46,32,84,104,101,32,118,97,108,117,101,32,69,77,73,78,32,109,97,121,32,98,101,32,105,110,99,111,114,114,101,99,116,58,45,2,44,2,32,32,69,77,73,78,32,61,32,2,44,105,56,44,47,2,32,73,102,44,32,97,102,116,101,114,32,105,110,115,112,101,99,116,105,111,110,44,32,116,104,101,32,118,97,108,117,101,32,69,77,73,78,32,108,111,111,107,115,2,44,2,32,97,99,99,101,112,116,97,98,108,101,32,112,108,101,97,115,101,32,99,111,109,109,101,110,116,32,111,117,116,32,2,44,47,2,32,116,104,101,32,73,70,32,98,108,111,99,107,32,97,115,32,109,97,114,107,101,100,32,119,105,116,104,105,110,32,116,104,101,32,99,111,100,101,32,111,102,32,114,111,117,116,105,110,101,2,44,2,32,68,76,65,77,67,50,44,2,44,47,2,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,108,121,32,69,77,73,78,32,101,120,112,108,105,99,105,116,108,121,46,2,44], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+67784);
/* memory initializer */ allocate([47,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,216,47,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,2,32,80,114,111,103,114,101,115,115,32,82,101,112,111,114,116,32,101,118,101,114,121,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,47,44,2,32,69,86,65,76,46,32,32,32,70,85,78,67,46,86,65,76,85,69,46,2,44,49,48,120,44,2,80,65,82,65,77,69,84,69,82,32,86,65,76,85,69,83,2,41,0,0,0,0,40,47,49,120,44,105,52,44,50,120,44,103,49,50,46,53,44,50,120,44,53,103,49,49,46,52,44,51,40,47,50,49,120,44,53,103,49,49,46,52,41,41,0,0,0,0,0,0,40,2,32,78,111,46,32,111,102,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,62,32,2,44,105,53,41,0,0,40,2,32,82,77,83,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,103,49,52,46,54,41,0,0,0,0,0,40,2,32,67,101,110,116,114,111,105,100,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,99,101,110,116,114,111,105,100,32,61,2,44,103,49,52,46,54,41,0,40,47,2,32,69,86,73,68,69,78,67,69,32,79,70,32,67,79,78,86,69,82,71,69,78,67,69,2,41,0,0,0,40,47,47,2,32,77,105,110,105,109,117,109,32,102,111,117,110,100,32,97,102,116,101,114,2,44,105,53,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,41,0,0,0,40,2,32,77,105,110,105,109,117,109,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,54,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,109,105,110,105,109,117,109,32,61,2,44,103,49,52,46,54,41,0,0,40,47,2,32,70,105,116,116,105,110,103,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,97,98,111,117,116,32,115,117,112,112,111,115,101,100,32,109,105,110,105,109,117,109,2,47,41,0,40,47,2,32,77,65,84,82,73,88,32,79,70,32,69,83,84,73,77,65,84,69,68,32,83,69,67,79,78,68,32,68,69,82,73,86,65,84,73,86,69,83,32,78,79,84,32,43,86,69,32,68,69,70,78,46,2,47,2,32,77,73,78,73,77,85,77,32,80,82,79,66,65,66,76,89,32,78,79,84,32,70,79,85,78,68,2,47,41,0,0,0,0,0,0,0,40,47,49,48,120,44,2,83,101,97,114,99,104,32,114,101,115,116,97,114,116,105,110,103,2,47,41,0,0,0,0,0,40,2,32,77,105,110,105,109,117,109,32,111,102,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,61,2,44,103,49,52,46,54,44,2,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,73,70,32,84,72,73,83,32,68,73,70,70,69,82,83,32,66,89,32,77,85,67,72,32,70,82,79,77,32,84,72,69,32,77,73,78,73,77,85,77,32,69,83,84,73,77,65,84,69,68,2,44,49,120,44,2,70,82,79,77,32,84,72,69,32,77,73,78,73,77,73,90,65,84,73,79,78,44,2,47,2,32,84,72,69,32,77,73,78,73,77,85,77,32,77,65,89,32,66,69,32,70,65,76,83,69,32,38,47,79,82,32,84,72,69,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,32,77,65,89,32,66,69,2,44,49,120,44,2,73,78,65,67,67,85,82,65,84,69,2,47,41,0,0,0,0,0,40,2,32,82,97,110,107,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,32,61,2,44,105,51,47,2,32,73,110,118,101,114,115,101,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,58,45,2,41,0,40,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,109,105,110,105,109,105,122,101,100,32,119,97,115,32,45,76,79,71,40,76,73,75,69,76,73,72,79,79,68,41,44,2,47,2,32,116,104,105,115,32,105,115,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,32,111,102,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,46,2,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,119,97,115,32,97,32,115,117,109,32,111,102,32,115,113,117,97,114,101,115,32,111,102,32,114,101,115,105,100,117,97,108,115,44,2,47,2,32,116,104,105,115,32,109,97,116,114,105,120,32,109,117,115,116,32,98,101,32,109,117,108,116,105,112,108,105,101,100,32,98,121,32,116,119,105,99,101,32,116,104,101,32,101,115,116,105,109,97,116,101,100,2,44,49,120,44,2,114,101,115,105,100,117,97,108,32,118,97,114,105,97,110,99,101,2,47,2,32,116,111,32,111,98,116,97,105,110,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,46,2,47,41,0,0,0,0,40,2,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,47,41,0,0,0,0,0,0,40,47,47,2,32,67,79,82,82,69,76,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,41,0,0,0,0,0,40,47,2,32,65,32,102,117,114,116,104,101,114,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,104,97,118,101,32,98,101,101,110,32,117,115,101,100,2,47,41,0,0,0,0,0,0,40,49,120,44,54,103,49,51,46,53,41,0,0,0,0,0,40,47,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+78024);
/* memory initializer */ allocate([32,52,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,52,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,52,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,52,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,52,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,52,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,52,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,52,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,52,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,53,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,53,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,53,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,53,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,53,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,53,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,53,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,53,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,54,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,52,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,54,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,54,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,54,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,55,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,55,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,55,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,57,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,57,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,57,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,57,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,57,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,57,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,78,80,84,32,105,115,32,110,111,116,32,105,110,2,44,2,32,116,104,101,32,114,101,113,117,105,114,101,100,32,105,110,116,101,114,118,97,108,2,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,240,92,1,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,67,65,76,70,85,78,32,104,97,115,32,98,101,101,110,2,44,2,32,99,97,108,108,101,100,32,77,65,88,70,85,78,32,116,105,109,101,115,46,2,41,0,0,0,0,0,0,40,47,52,120,44,2,70,117,110,99,116,105,111,110,32,110,117,109,98,101,114,2,44,105,54,44,2,32,32,32,32,70,32,61,2,44,49,112,100,49,56,46,49,48,44,2,32,32,32,32,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,97,32,116,114,117,115,116,2,44,2,32,114,101,103,105,111,110,32,115,116,101,112,32,104,97,115,32,102,97,105,108,101,100,32,116,111,32,114,101,100,117,99,101,32,81,46,2,41,0,0,0,0,0,0,0,40,53,120,41,0,0,0,0,40,47,52,120,44,2,78,101,119,32,82,72,79,32,61,2,44,49,112,100,49,49,46,52,44,53,120,44,2,78,117,109,98,101,114,32,111,102,2,44,2,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,40,52,120,44,2,76,101,97,115,116,32,118,97,108,117,101,32,111,102,32,70,32,61,2,44,49,112,100,50,51,46,49,53,44,57,120,44,2,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,0,0,0,0,40,47,52,120,44,2,65,116,32,116,104,101,32,114,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,2,44,53,120,44,2,78,117,109,98,101,114,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,208,93,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,32,94,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,120,94,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,208,94,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,216,94,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,32,95,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,112,95,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,32,95,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,105,118,111,116,32,33,61,32,48,0,0,0,0,0,0,109,97,116,104,45,115,117,112,112,111,114,116,47,112,105,118,111,116,46,99,0,0,0,0,112,105,118,111,116,0,0,0,152,107,1,0,184,108,1,0,192,108,1,0,208,108,1,0,224,108,1,0,240,108,1,0,8,109,1,0,32,109,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,152,107,1,0,160,107,1,0,232,107,1,0,16,108,1,0,48,108,1,0,80,108,1,0,120,108,1,0,160,108,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,100,97,115,115,108,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,0,0,0,0,0,124,32,115,111,108,118,101,114,32,124,32,85,115,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,9,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,78,111,32,83,112,97,114,115,101,80,97,116,116,101,114,110,44,32,115,105,110,99,101,32,116,104,101,114,101,32,97,114,101,32,110,111,32,115,116,97,116,101,115,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,74,97,99,111,98,105,97,110,32,111,114,32,83,112,97,114,115,101,80,97,116,116,101,114,110,32,105,115,32,110,111,116,32,103,101,110,101,114,97,116,101,100,32,111,114,32,102,97,105,108,101,100,32,116,111,32,105,110,105,116,105,97,108,105,122,101,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,112,97,115,115,101,100,32,116,111,32,68,68,65,83,82,84,0,0,0,0,0,0,68,101,115,105,114,101,100,32,115,116,101,112,32,116,111,32,115,109,97,108,108,32,116,114,121,32,110,101,120,116,32,111,110,101,0,0,0,0,0,0,73,110,116,101,114,112,111,108,97,116,101,32,108,105,110,101,97,114,0,0,0,0,0,0,67,97,108,108,105,110,103,32,68,68,65,83,82,84,32,102,114,111,109,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,83,116,97,114,116,32,115,116,101,112,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,0,65,32,108,97,114,103,101,32,97,109,111,117,110,116,32,111,102,32,119,111,114,107,32,104,97,115,32,98,101,101,110,32,101,120,112,101,110,100,101,100,46,40,65,98,111,117,116,32,53,48,48,32,115,116,101,112,115,41,46,32,84,114,121,105,110,103,32,116,111,32,99,111,110,116,105,110,117,101,32,46,46,46,0,0,0,0,0,0,68,65,83,83,76,32,119,105,108,108,32,116,114,121,32,97,103,97,105,110,46,46,46,0,99,97,110,39,116,32,99,111,110,116,105,110,117,101,46,32,116,105,109,101,32,61,32,37,102,0,0,0,0,0,0,0,100,97,115,115,108,32,99,97,108,108,32,115,116,97,105,115,116,105,99,115,58,32,0,0,118,97,108,117,101,32,111,102,32,105,100,105,100,58,32,37,100,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,105,110,116,101,103,114,97,116,105,111,110,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,115,116,101,112,32,115,105,122,101,32,72,32,116,111,32,98,101,32,97,116,116,101,109,112,116,101,100,32,111,110,32,110,101,120,116,32,115,116,101,112,58,32,37,48,46,52,103,0,115,116,101,112,32,115,105,122,101,32,117,115,101,100,32,111,110,32,108,97,115,116,32,115,117,99,99,101,115,115,102,117,108,32,115,116,101,112,58,32,37,48,46,52,103,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,116,97,107,101,110,32,115,111,32,102,97,114,58,32,37,100,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,40,41,32,58,32,37,100,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,99,117,108,97,116,105,111,110,32,111,102,32,106,97,99,111,98,105,97,110,32,58,32,37,100,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,49,48,32,43,32,117,105,32,60,32,100,97,115,115,108,68,97,116,97,45,62,108,105,119,0,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,100,97,115,115,108,46,99,0,0,0,0,0,0,0,100,97,115,114,116,95,115,116,101,112,0,0,0,0,0,0,70,105,110,105,115,104,101,100,32,68,68,65,83,82,84,32,115,116,101,112,46,0,0,0,84,104,101,32,101,114,114,111,114,32,116,111,108,101,114,97,110,99,101,115,32,97,114,101,32,116,111,111,32,115,116,114,105,110,103,101,110,116,0,0,68,68,65,83,83,76,32,104,97,100,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,111,110,32,116,104,101,32,108,97,115,116,32,97,116,116,101,109,112,116,101,100,32,115,116,101,112,46,0,0,0,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,0,0,0,0,0,0,0,84,104,101,32,109,97,116,114,105,120,32,111,102,32,112,97,114,116,105,97,108,32,100,101,114,105,118,97,116,105,118,101,115,32,105,115,32,115,105,110,103,117,108,97,114,46,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,32,84,104,101,114,101,32,119,101,114,101,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,105,110,32,116,104,105,115,32,115,116,101,112,46,0,65,32,77,111,100,101,108,105,99,97,32,97,115,115,101,114,116,32,112,114,101,118,101,110,116,115,32,116,104,101,32,105,110,116,101,103,114,97,116,111,114,32,116,111,32,99,111,110,116,105,110,117,101,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,45,108,118,32,76,79,71,95,68,68,65,83,82,84,0,0,73,82,69,83,32,101,113,117,97,108,32,116,111,32,45,50,32,119,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,97,110,100,32,99,111,110,116,114,111,108,32,105,115,32,98,101,105,110,103,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,99,97,108,108,105,110,103,32,112,114,111,103,114,97,109,46,0,0,68,68,65,83,83,76,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,116,104,101,32,105,110,105,116,105,97,108,32,89,80,82,73,77,69,46,0,0,0,0,84,104,101,32,99,111,100,101,32,104,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,116,114,111,117,98,108,101,32,102,114,111,109,32,119,104,105,99,104,32,105,116,32,99,97,110,110,111,116,32,114,101,99,111,118,101,114,46,0,0,117,110,107,110,111,119,110,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,115,116,111,114,101,68,101,108,97,121,101,100,69,120,112,114,101,115,115,105,111,110,58,32,105,110,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,32,110,117,109,98,101,114,32,37,100,0,0,0,0,115,116,111,114,101,68,101,108,97,121,101,100,69,120,112,114,101,115,115,105,111,110,58,32,116,105,109,101,32,105,115,32,115,109,97,108,108,101,114,32,116,104,97,110,32,115,116,97,114,116,105,110,103,32,116,105,109,101,46,32,86,97,108,117,101,32,105,103,110,111,114,101,100,0,0,0,0,0,0,0,115,116,111,114,101,68,101,108,97,121,101,100,91,37,100,93,32,37,103,58,37,103,32,112,111,115,105,116,105,111,110,61,37,100,0,0,0,0,0,0,100,101,108,97,121,73,109,112,108,58,32,100,101,113,117,101,117,101,78,70,105,114,115,116,82,105,110,103,68,97,116,97,115,91,37,100,93,32,37,103,32,61,32,37,103,0,0,0,100,101,108,97,121,73,109,112,108,58,32,101,120,112,114,78,117,109,98,101,114,32,61,32,37,100,44,32,101,120,112,114,86,97,108,117,101,32,61,32,37,103,44,32,116,105,109,101,32,61,32,37,103,44,32,100,101,108,97,121,84,105,109,101,32,61,32,37,103,0,0,0,105,110,118,97,108,105,100,32,101,120,112,114,78,117,109,98,101,114,32,61,32,37,100,0,100,101,108,97,121,73,109,112,108,58,32,69,110,116,101,114,101,100,32,97,116,32,116,105,109,101,32,60,32,115,116,97,114,116,105,110,103,32,116,105,109,101,58,32,37,103,46,0,78,101,103,97,116,105,118,101,32,100,101,108,97,121,32,114,101,113,117,101,115,116,101,100,32,37,103,0,0,0,0,0,100,101,108,97,121,73,109,112,108,58,32,77,105,115,115,105,110,103,32,105,110,105,116,105,97,108,32,118,97,108,117,101,44,32,117,115,105,110,103,32,97,114,103,117,109,101,110,116,32,118,97,108,117,101,32,37,103,32,105,110,115,116,101,97,100,46,0,0,0,0,0,0,102,105,110,100,84,105,109,101,58,32,116,105,109,101,32,60,61,32,116,83,116,97,114,116,32,43,32,100,101,108,97,121,84,105,109,101,58,32,91,37,100,93,32,61,32,37,103,0,78,101,103,97,116,105,118,101,32,100,101,108,97,121,32,114,101,113,117,101,115,116,101,100,58,32,100,101,108,97,121,84,105,109,101,32,61,32,37,103,0,0,0,0,0,0,0,0,100,101,108,97,121,73,109,112,108,58,32,102,105,110,100,32,116,104,101,32,114,111,119,32,32,37,103,32,61,32,37,103,0,0,0,0,0,0,0,0,100,101,108,97,121,73,109,112,108,58,32,116,105,109,101,115,32,37,103,32,97,110,100,32,37,103,0,0,0,0,0,0,100,101,108,97,121,73,109,112,108,58,32,118,97,108,117,101,115,32,37,103,32,97,110,100,32,32,37,103,0,0,0,0,37,100,32,61,32,105,32,60,32,108,101,110,103,116,104,32,61,32,37,100,0,0,0,0,100,101,108,97,121,73,109,112,108,58,32,69,120,97,99,116,32,109,97,116,99,104,32,97,116,32,37,103,32,61,32,37,103,0,0,0,0,0,0,0,100,101,108,97,121,73,109,112,108,58,32,76,105,110,101,97,114,32,105,110,116,101,114,112,111,108,97,116,105,111,110,32,111,102,32,37,103,32,98,101,116,119,101,101,110,32,37,103,32,97,110,100,32,37,103,0,100,101,108,97,121,73,109,112,108,58,32,76,105,110,101,97,114,32,105,110,116,101,114,112,111,108,97,116,105,111,110,32,111,102,32,37,103,32,118,97,108,117,101,58,32,37,103,32,97,110,100,32,37,103,32,61,32,37,103,0,0,0,0,0,102,105,110,100,84,105,109,101,32,37,101,0,0,0,0,0,116,105,109,101,40,37,100,44,32,37,100,41,91,37,100,93,32,61,32,37,101,0,0,0,114,101,116,117,114,110,32,116,105,109,101,91,37,100,44,32,37,100,93,32,61,32,37,101,0,0,0,0,0,0,0,0,84,82,85,69,0,0,0,0,70,65,76,83,69,0,0,0,91,37,108,100,93,32,115,97,109,112,108,101,40,37,103,44,32,37,103,41,0,0,0,0,91,37,108,100,93,32,37,115,0,0,0,0,0,0,0,0,67,104,97,116,116,101,114,105,110,103,32,100,101,116,101,99,116,101,100,32,97,114,111,117,110,100,32,116,105,109,101,32,37,46,49,50,103,46,46,37,46,49,50,103,32,40,37,100,32,115,116,97,116,101,32,101,118,101,110,116,115,32,105,110,32,97,32,114,111,119,32,119,105,116,104,32,97,32,116,111,116,97,108,32,116,105,109,101,32,100,101,108,116,97,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,115,116,101,112,32,115,105,122,101,32,37,46,49,50,103,41,46,32,84,104,105,115,32,99,97,110,32,98,101,32,97,32,112,101,114,102,111,114,109,97,110,99,101,32,98,111,116,116,108,101,110,101,99,107,46,32,85,115,101,32,45,108,118,32,76,79,71,95,69,86,69,78,84,83,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,32,84,104,101,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,119,97,115,58,32,37,115,0,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,114,105,103,104,116,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,101,118,101,110,116,115,46,99,0,0,0,0,0,0,102,105,110,100,82,111,111,116,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,108,101,102,116,0,0,0,0,0,115,101,97,114,99,104,32,102,111,114,32,99,117,114,114,101,110,116,32,101,118,101,110,116,46,32,69,118,101,110,116,115,32,105,110,32,108,105,115,116,58,32,37,108,100,0,0,0,77,105,110,105,109,117,109,32,118,97,108,117,101,58,32,37,101,0,0,0,0,0,0,0,97,100,100,101,100,32,116,109,112,32,101,118,101,110,116,32,58,32,37,108,100,0,0,0,37,108,100,32,0,0,0,0,98,97,99,107,117,112,95,103,111,117,116,0,0,0,0,0,98,105,115,101,99,116,105,111,110,0,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,109,101,116,104,111,100,32,115,116,97,114,116,115,32,105,110,32,105,110,116,101,114,118,97,108,32,91,37,101,44,32,37,101,93,0,0,0,0,84,84,79,76,32,105,115,32,115,101,116,32,116,111,58,32,37,101,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,99,104,101,99,107,115,32,102,111,114,32,99,111,110,100,105,116,105,111,110,32,99,104,97,110,103,101,115,0,0,37,108,100,32,99,104,97,110,103,101,100,32,102,114,111,109,32,37,115,32,116,111,32,99,117,114,114,101,110,116,32,37,115,0,0,0,0,0,0,0,115,97,118,101,32,97,108,108,32,122,101,114,111,99,114,111,115,115,105,110,103,115,32,97,102,116,101,114,32,97,110,32,101,118,101,110,116,0,0,0,69,82,82,79,82,58,32,84,111,111,32,109,97,110,121,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,115,46,32,83,121,115,116,101,109,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,46,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,112,97,114,97,109,101,116,101,114,32,118,97,108,117,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,103,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,108,100,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,115,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,0,0,0,0,115,116,97,116,117,115,32,111,102,32,114,101,108,97,116,105,111,110,115,0,0,0,0,0,91,37,108,100,93,32,37,115,32,61,32,37,99,32,124,32,112,114,101,40,37,115,41,32,61,32,37,99,0,0,0,0,89,111,117,114,32,109,101,109,111,114,121,32,105,115,32,110,111,116,32,115,116,114,111,110,103,32,101,110,111,117,103,104,32,102,111,114,32,111,117,114,32,82,105,110,103,98,117,102,102,101,114,33,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,101,120,116,101,114,110,97,108,32,111,98,106,101,99,116,115,0,0,0,0,0,0,0,187,189,215,217,223,124,219,61,83,101,116,32,116,111,108,101,114,97,110,99,101,32,102,111,114,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,104,121,115,116,101,114,101,115,105,115,32,116,111,58,32,37,101,0,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,109,105,120,101,100,32,115,111,108,118,101,114,0,0,0,0,0,0,0,109,105,120,101,100,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,91,37,100,93,32,37,115,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,101,77,105,120,101,100,83,101,97,114,99,104,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,0,0,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,91,37,100,93,32,37,115,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,97,112,97,99,107,46,0,0,0,0,0,0,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,76,105,115,46,0,0,45,105,32,102,103,109,114,101,115,32,0,0,0,0,0,0,78,76,83,95,85,78,75,78,79,87,78,0,0,0,0,0,104,121,98,114,105,100,0,0,107,105,110,115,111,108,0,0,110,101,119,116,111,110,0,0,78,76,83,95,77,65,88,0,160,119,1,0,176,119,1,0,184,119,1,0,192,119,1,0,200,119,1,0,0,0,0,0,117,110,107,110,111,119,110,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,78,101,119,116,111,110,32,82,97,112,104,115,111,110,0,0,232,119,1,0,240,119,1,0,0,120,1,0,16,120,1,0,200,119,1,0,0,0,0,0,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,106,97,99,111,98,105,97,110,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,0,0,0,0,112,114,111,112,101,114,32,115,116,97,114,116,45,118,97,108,117,101,115,32,102,111,114,32,115,111,109,101,32,111,102,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,115,32,109,105,103,104,116,32,104,101,108,112,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,63,44,32,110,111,109,105,110,97,108,61,63,41,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,240,63,73,110,105,116,105,97,108,105,122,105,110,103,32,68,65,83,83,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,116,111,114,105,110,103,32,114,101,115,117,108,116,115,32,97,110,100,32,101,120,105,116,105,110,103,46,10,85,115,101,32,45,108,118,61,76,79,71,95,73,78,73,84,32,45,119,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,0,115,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,97,110,32,97,115,115,101,114,116,105,111,110,32,97,116,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,87,114,111,116,101,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,116,104,101,32,102,105,108,101,32,97,102,116,101,114,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,40,102,111,114,32,111,117,116,112,117,116,32,102,111,114,109,97,116,115,32,116,104,97,116,32,115,117,112,112,111,114,116,32,116,104,105,115,41,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,108,32,101,118,101,110,116,32,97,116,32,115,116,111,112,32,116,105,109,101,32,37,103,0,0,70,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,35,35,35,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,0,0,0,0,116,105,109,101,114,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,112,114,101,45,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,116,101,112,115,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,45,102,105,108,101,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,101,118,101,110,116,45,104,97,110,100,108,105,110,103,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,118,101,114,104,101,97,100,0,0,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,105,109,117,108,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,116,111,116,97,108,0,0,0,101,118,101,110,116,115,0,0,37,53,108,100,32,115,116,97,116,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,37,53,108,100,32,116,105,109,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,0,115,111,108,118,101,114,58,32,68,65,83,83,76,0,0,0,37,53,100,32,115,116,101,112,115,32,116,97,107,101,110,0,37,53,100,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,0,0,0,0,0,0,0,0,37,53,100,32,101,118,97,108,117,97,116,105,111,110,115,32,111,102,32,106,97,99,111,98,105,97,110,0,0,0,0,0,37,53,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,37,53,100,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,0,0,115,111,108,118,101,114,0,0,115,111,114,114,121,32,45,32,110,111,32,115,111,108,118,101,114,32,115,116,97,116,105,115,116,105,99,115,32,97,118,97,105,108,97,98,108,101,46,32,91,110,111,116,32,121,101,116,32,105,109,112,108,101,109,101,110,116,101,100,93,0,0,0,35,35,35,32,69,78,68,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,83,117,110,100,105,97,108,47,107,105,110,115,111,108,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,32,80,108,101,97,115,101,32,99,104,111,111,115,101,32,111,116,104,101,114,32,115,111,108,118,101,114,46,0,73,112,111,112,116,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,0,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,101,117,108,101,114,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,69,85,76,69,82,46,0,0,0,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,82,75,46,0,0,0,83,116,97,114,116,32,110,117,109,101,114,105,99,97,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,44,0,0,0,0,0,0,0,116,105,109,101,61,37,46,50,48,103,0,0,0,0,0,0,44,37,115,61,37,46,50,48,103,0,0,0,0,0,0,0,44,37,115,61,37,108,105,0,44,37,115,61,37,105,0,0,44,37,115,61,34,37,115,34,0,0,0,0,0,0,0,0,99,97,110,32,110,111,116,32,105,110,105,116,105,97,108,122,101,32,74,97,99,111,98,105,97,110,115,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,106,97,99,111,98,105,97,110,32,37,100,120,37,100,32,91,105,100,58,32,37,108,100,93,0,0,0,0,0,0,0,0,37,115,37,46,53,101,32,0,37,115,0,0,0,0,0,0,69,114,114,111,114,44,32,115,105,110,103,117,108,97,114,32,74,97,99,111,98,105,97,110,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,32,97,116,32,116,105,109,101,32,37,102,10,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,95,74,65,67,32,116,111,32,103,101,116,32,116,104,101,32,74,97,99,111,98,105,97,110,0,115,101,108,101,99,116,32,110,101,119,32,115,116,97,116,101,115,32,97,116,32,116,105,109,101,32,37,102,0,0,0,0,115,101,108,101,99,116,32,37,115,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,73,110,112,117,116,46,99,115,118,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,37,108,102,0,0,0,0,0,10,69,120,116,101,114,110,97,108,32,73,110,112,117,116,0,10,73,110,112,117,116,58,32,116,61,37,102,32,32,32,9,0,0,0,0,0,0,0,0,117,37,100,40,116,41,61,32,37,102,32,9,0,0,0,0,10,61,61,61,61,61,61,61,61,61,61,61], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+88404);
/* memory initializer */ allocate([61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,0,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,121,115,116,101,109,32,111,102,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,97,114,101,32,110,111,116,32,99,111,110,115,105,115,116,101,110,116,10,40,108,101,97,115,116,32,115,113,117,97,114,101,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,32,105,115,32,37,103,41,0,0,0,0,0,114,101,115,105,100,117,97,108,91,37,108,100,93,32,61,32,37,103,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,115,116,97,116,117,115,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,32,91,115,99,97,108,101,100,58,32,37,103,93,0,0,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,0,0,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,0,0,0,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,35,35,35,32,83,79,76,85,84,73,79,78,32,79,70,32,84,72,69,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,115,116,97,116,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,0,0,100,101,114,105,118,97,116,105,118,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,111,116,104,101,114,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,41,32,61,32,37,108,100,32,40,112,114,101,58,32,37,108,100,41,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,41,32,61,32,37,115,32,40,112,114,101,58,32,37,115,41,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,32,40,112,114,101,58,32,34,37,115,34,41,0,0,35,35,35,32,83,84,65,82,84,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,88,137,1,0,32,139,1,0,40,139,1,0,48,139,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,105,109,32,37,115,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,124,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,88,137,1,0,96,138,1,0,176,138,1,0,224,138,1,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,88,137,1,0,32,138,1,0,40,138,1,0,48,138,1,0,64,138,1,0,72,138,1,0,88,138,1,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,111,109,32,37,115,0,0,0,0,0,88,137,1,0,96,137,1,0,120,137,1,0,136,137,1,0,208,137,1,0,224,137,1,0,0,138,1,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,105,109,0,35,35,35,32,69,78,68,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,37,115,95,104,111,109,111,116,111,112,121,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,108,97,109,98,100,97,0,0,104,111,109,111,116,111,112,121,32,112,114,111,99,101,115,115,0,0,0,0,0,0,0,0,108,97,109,98,100,97,32,61,32,37,103,32,100,111,110,101,0,0,0,0,0,0,0,0,37,46,49,54,103,44,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,117,110,105,113,117,101,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,46,32,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,32,116,111,32,115,101,101,32,116,104,101,32,115,119,105,116,99,104,105,110,103,32,115,116,97,116,101,32,115,101,116,46,0,0,0,110,111,32,118,97,114,105,97,98,108,101,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,0,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,32,40,110,101,105,116,104,101,114,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,110,111,114,32,105,110,105,116,105,97,108,32,97,108,103,111,114,105,116,104,109,115,41,0,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,0,0,0,0,0,0,0,0,115,101,116,116,105,110,103,32,102,105,120,101,100,61,116,114,117,101,32,102,111,114,58,0,37,115,40,102,105,120,101,100,61,116,114,117,101,41,32,61,32,37,103,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,0,0,111,118,101,114,45,100,101,116,101,114,109,105,110,101,100,0,115,116,97,114,116,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,0,0,115,107,105,112,32,119,47,111,32,115,99,97,108,105,110,103,0,0,0,0,0,0,0,0,35,35,35,32,70,73,78,65,76,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,82,69,83,85,76,84,83,32,35,35,35,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,45,110,114,46,32,37,108,100,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,111,109,0,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,110,111,116,32,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,45,99,97,108,108,115,58,32,37,108,100,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,105,109,112,111,114,116,32,115,116,97,114,116,32,118,97,108,117,101,115,10,102,105,108,101,58,32,37,115,10,116,105,109,101,58,32,37,103,0,0,0,117,110,97,98,108,101,32,116,111,32,114,101,97,100,32,105,110,112,117,116,45,102,105,108,101,32,60,37,115,62,32,91,37,115,93,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,103,41,0,0,36,90,69,82,79,46,0,0,36,112,68,69,82,46,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,100,105,115,99,114,101,116,101,0,0,0,0,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,108,100,41,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,115,41,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,100,101,114,40,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,105,116,105,97,108,32,112,114,111,98,108,101,109,58,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,58,32,32,37,108,100,32,40,37,108,100,32,115,116,97,116,101,115,32,43,32,37,108,100,32,112,97,114,97,109,101,116,101,114,115,32,43,32,37,108,100,32,100,105,115,99,114,101,116,101,32,114,101,97,108,115,41,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,91,37,108,100,93,32,100,105,115,99,114,101,116,101,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,58,32,32,37,108,100,32,40,37,108,100,32,101,113,117,97,116,105,111,110,115,32,43,32,37,108,100,32,97,108,103,111,114,105,116,104,109,115,41,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,97,114,116,32,118,97,108,117,101,32,114,101,115,105,100,117,97,108,115,58,32,37,108,100,0,0,0,0,91,37,108,100,93,32,114,101,115,105,100,117,97,108,32,105,115,32,105,110,101,102,102,101,99,116,105,118,101,32,40,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,32,105,115,32,115,101,116,32,116,111,32,49,46,48,41,0,0,0,0,0,0,0,110,111,32,105,112,111,112,116,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,124,32,82,101,115,117,108,116,32,111,102,32,108,101,97,115,116,83,113,117,97,114,101,32,109,101,116,104,111,100,32,61,32,37,103,46,32,84,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,105,116,115,32,116,111,32,116,104,101,32,115,121,115,116,101,109,0,0,0,0,0,0,0,0,108,101,97,115,116,83,113,117,97,114,101,61,37,103,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,111,108,118,101,114,32,105,116,101,114,97,116,101,100,32,37,100,32,116,105,109,101,115,32,119,105,116,104,111,117,116,32,102,105,110,100,105,110,103,32,97,32,115,111,108,117,116,105,111,110,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,99,111,110,115,105,115,116,101,110,116,32,105,110,105,116,105,97,108,32,99,111,110,100,105,116,105,111,110,115,46,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,78,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,32,60,32,49,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,78,76,79,79,80,32,60,32,49,46,0,0,0,0,0,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,105,116,101,114,97,116,105,111,110,115,58,32,37,108,100,0,116,114,121,32,45,105,108,115,32,116,111,32,97,99,116,105,118,97,116,101,32,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,0,0,0,0,0,0,0,37,115,95,105,110,105,116,80,97,116,104,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,105,116,101,114,97,116,105,111,110,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,37,108,100,44,0,0,0,0,37,46,49,54,103,44,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,108,97,109,98,100,97,32,105,115,32,37,45,51,103,32,105,110,32,115,116,101,112,61,37,54,100,32,97,116,32,102,61,37,103,32,91,37,103,93,0,105,110,99,114,101,97,115,105,110,103,32,108,97,109,98,100,97,32,116,111,32,37,45,51,103,32,105,110,32,115,116,101,112,32,37,54,100,32,97,116,32,102,61,37,103,0,0,0,102,120,114,32,61,32,37,103,0,0,0,0,0,0,0,0,102,120,107,32,61,32,37,103,0,0,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,114,114,111,114,32,105,110,32,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,37,46,49,54,103,44,0,0,37,105,44,0,0,0,0,0,34,37,115,34,44,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,116,105,109,101,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,65,49,32,98,116,46,32,105,114,49,32,110,97,32,32,84,106,32,32,114,101,32,32,97,99,32,32,110,116,32,32,115,111,32,32,32,114,32,32,32,121,32,32,32,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,50,0,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,102,105,108,101,32,37,115,0,0,0,0,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,0,0,67,97,110,110,111,116,32,119,114,105,116,101,32,116,111,32,102,105,108,101,32,37,115,0,67,97,110,110,111,116,32,97,108,108,111,99,32,109,101,109,111,114,121,0,0,0,0,0,77,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,119,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,114,43,0,0,0,0,0,0,119,43,0,0,0,0,0,0,97,43,0,0,0,0,0,0,119,98,0,0,0,0,0,0,97,98,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,119,43,98,0,0,0,0,0,97,43,98,0,0,0,0,0,100,101,114,40,0,0,0,0,104,0,0,0,0,0,0,0,8,149,1,0,8,0,0,0,9,0,0,0,152,255,255,255,152,255,255,255,8,149,1,0,10,0,0,0,11,0,0,0,172,148,1,0,36,149,1,0,56,149,1,0,192,148,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,111,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,168,78,2,0,216,148,1,0,48,10,2,0,0,0,0,0,104,0,0,0,0,0,0,0,48,10,2,0,12,0,0,0,13,0,0,0,152,255,255,255,152,255,255,255,48,10,2,0,14,0,0,0,15,0,0,0,0,0,0,0,176,149,1,0,16,0,0,0,17,0,0,0,3,0,0,0,8,0,0,0,2,0,0,0,4,0,0,0,31,0,0,0,32,0,0,0,9,0,0,0,33,0,0,0,34,0,0,0,24,0,0,0,10,0,0,0,25,0,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,168,78,2,0,128,149,1,0,40,9,2,0,0,0,0,0,0,0,0,0,56,150,1,0,64,150,1,0,48,150,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,16,150,1,0,32,150,1,0,48,150,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,99,112,117,32,116,105,109,101,32,91,115,93,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,83,105,109,117,108,97,116,105,111,110,32,116,105,109,101,32,91,115,93,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,0,0,0,0,0,65,117,116,111,109,97,116,105,99,32,111,117,116,112,117,116,32,115,116,101,112,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,79,112,101,110,77,111,100,101,108,105,99,97,32,121,101,116,46,32,83,101,116,32,110,117,109,112,111,105,110,116,115,32,62,61,32,48,46,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,32,102,97,105,108,101,100,0,0,0,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,35,80,116,111,108,101,109,121,32,80,108,111,116,32,102,105,108,101,44,32,103,101,110,101,114,97,116,101,100,32,98,121,32,79,112,101,110,77,111,100,101,108,105,99,97,10,0,0,35,78,117,109,98,101,114,111,102,86,97,114,105,97,98,108,101,115,61,37,100,10,0,0,35,73,110,116,101,114,118,97,108,83,105,122,101,61,37,108,100,10,0,0,0,0,0,0,84,105,116,108,101,84,101,120,116,58,32,79,112,101,110,77,111,100,101,108,105,99,97,32,115,105,109,117,108,97,116,105,111,110,32,112,108,111,116,10,0,0,0,0,0,0,0,0,88,76,97,98,101,108,58,32,116,10,10,0,0,0,0,0,68,97,116,97,83,101,116,58,32,116,105,109,101,10,0,0,68,97,116,97,83,101,116,58,32,36,99,112,117,84,105,109,101,10,0,0,0,0,0,0,68,97,116,97,83,101,116,58,32,37,115,10,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,119,114,105,116,101,32,116,111,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,37,46,49,54,103,44,32,37,46,49,54,103,10,0,0,0,114,101,99,111,110,58,119,97,108,108,58,118,48,49,0,0,0,0,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,112,97,114,97,109,115,0,0,99,111,110,116,105,110,117,111,117,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,101,116,97,0,0,0,116,97,98,115,0,0,0,0,111,98,106,115,0,0,0,0,116,109,101,116,97,0,0,0,115,105,103,115,0,0,0,0,116,105,109,101,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,118,109,101,116,97,0,0,0,84,105,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,97,108,115,0,0,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,105,110,118,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,118,97,108,117,101,82,101,102,101,114,101,110,99,101,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,102,105,108,101,78,97,109,101,0,0,0,0,0,0,0,0,115,116,97,114,116,76,105,110,101,0,0,0,0,0,0,0,115,116,97,114,116,67,111,108,117,109,110,0,0,0,0,0,101,110,100,76,105,110,101,0,101,110,100,67,111,108,117,109,110,0,0,0,0,0,0,0,102,105,108,101,87,114,105,116,97,98,108,101,0,0,0,0,117,115,101,83,116,97,114,116,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,102,105,120,101,100,0,0,0,117,115,101,78,111,109,105,110,97,108,0,0,0,0,0,0,110,111,109,105,110,97,108,0,109,105,110,0,0,0,0,0,109,97,120,0,0,0,0,0,82,101,97,108,32,37,115,40,37,115,115,116,97,114,116,61,37,103,37,115,44,32,102,105,120,101,100,61,37,115,44,32,37,115,110,111,109,105,110,97,108,61,37,103,37,115,44,32,109,105,110,61,37,103,44,32,109,97,120,61,37,103,41,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,116,101,103,101,114,32,37,115,40,37,115,115,116,97,114,116,61,37,108,100,37,115,44,32,102,105,120,101,100,61,37,115,44,32,109,105,110,61,37,108,100,44,32,109,97,120,61,37,108,100,41,0,0,0,66,111,111,108,101,97,110,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,44,32,102,105,120,101,100,61,37,115,41,0,0,0,0,0,0,83,116,114,105,110,103,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,41,0,95,105,110,105,116,46,120,109,108,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,97,110,32,110,111,116,32,114,101,97,100,32,102,105,108,101,32,37,115,32,97,115,32,115,101,116,117,112,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,46,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,88,77,76,32,112,97,114,115,101,114,33,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,37,115,44,32,37,115,32,37,108,117,10,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,103,117,105,100,0,0,0,0,84,104,101,32,77,111,100,101,108,32,71,85,73,68,58,32,37,115,32,105,115,32,110,111,116,32,115,101,116,32,105,110,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,0,69,114,114,111,114,44,32,116,104,101,32,71,85,73,68,58,32,37,115,32,102,114,111,109,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,58,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,71,85,73,68,32,99,111,109,112,105,108,101,100,32,105,110,32,116,104,101,32,109,111,100,101,108,58,32,37,115,0,0,114,101,97,100,32,97,108,108,32,116,104,101,32,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,32,118,97,108,117,101,115,58,0,0,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,115,116,97,114,116,84,105,109,101,32,61,32,37,103,0,0,115,116,111,112,84,105,109,101,0,0,0,0,0,0,0,0,115,116,111,112,84,105,109,101,32,61,32,37,103,0,0,0,115,116,101,112,83,105,122,101,0,0,0,0,0,0,0,0,115,116,101,112,83,105,122,101,32,61,32,37,103,0,0,0,116,111,108,101,114,97,110,99,101,0,0,0,0,0,0,0,116,111,108,101,114,97,110,99,101,32,61,32,37,103,0,0,115,111,108,118,101,114,0,0,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,0,0,0,0,0,0,0,111,117,116,112,117,116,70,111,114,109,97,116,0,0,0,0,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,37,115,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,70,105,108,116,101,114,0,0,118,97,114,105,97,98,108,101,32,102,105,108,116,101,114,58,32,37,115,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,0,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,58,32,37,115,0,0,0,0,110,117,109,98,101,114,79,102,67,111,110,116,105,110,117,111,117,115,83,116,97,116,101,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,82,101,97,108,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,110,117,109,98,101,114,79,102,82,101,97,108,80,97,114,97,109,101,116,101,114,115,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,111,100,101,108,46,0,0,0,0,110,120,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,100,0,0,0,0,0,0,0,110,121,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,112,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,121,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,112,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,37,115,0,0,0,0,114,101,97,108,32,115,116,97,116,101,115,0,0,0,0,0,105,115,80,114,111,116,101,99,116,101,100,0,0,0,0,0,102,105,108,116,101,114,105,110,103,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,32,37,115,0,114,101,97,108,32,115,116,97,116,101,32,100,101,114,105,118,97,116,105,118,101,115,0,0,114,101,97,108,32,97,108,103,101,98,114,97,105,99,115,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,114,101,97,108,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,0,0,97,108,105,97,115,0,0,0,110,101,103,97,116,101,100,65,108,105,97,115,0,0,0,0,114,101,97,100,32,102,111,114,32,37,115,32,110,101,103,97,116,101,100,32,37,100,32,102,114,111,109,32,115,101,116,117,112,32,102,105,108,101,0,0,97,108,105,97,115,86,97,114,105,97,98,108,101,0,0,0,116,105,109,101,0,0,0,0,82,101,97,108,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,0,0,32,110,111,116,32,102,111,117,110,100,46,0,0,0,0,0,37,115,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,105,110,116,101,103,101,114,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,73,110,116,101,103,101,114,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,98,111,111,108,101,97,110,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,66,111,111,108,101,97,110,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,115,116,114,105,110,103,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,83,116,114,105,110,103,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,117,115,97,103,101,32,101,114,114,111,114,32,121,111,117,32,99,97,110,110,111,116,32,104,97,118,101,32,98,111,116,104,32,45,111,118,101,114,114,105,100,101,32,97,110,100,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,97,99,116,105,118,101,32,97,116,32,116,104,101,32,115,97,109,101,32,116,105,109,101,46,32,115,101,101,32,77,111,100,101,108,32,45,63,32,102,111,114,32,109,111,114,101,32,105,110,102,111,33,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,32,102,114,111,109,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,99,111,117,108,100,32,110,111,116,32,111,112,101,110,32,116,104,101,32,102,105,108,101,32,103,105,118,101,110,32,116,111,32,45,111,118,101,114,114,105,100,101,70,105,108,101,61,37,115,0,0,0,0,0,44,0,0,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,58,32,37,115,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,37,115,32,61,32,37,115,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,100,111,110,101,33,0,0,78,79,32,111,118,101,114,114,105,100,101,32,103,105,118,101,110,32,111,110,32,116,104,101,32,99,111,109,109,97,110,100,32,108,105,110,101,46,0,0,108,0,0,0,0,0,0,0,144,166,1,0,18,0,0,0,19,0,0,0,148,255,255,255,148,255,255,255,144,166,1,0,20,0,0,0,21,0,0,0,52,166,1,0,172,166,1,0,192,166,1,0,72,166,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,168,78,2,0,96,166,1,0,160,9,2,0,0,0,0,0,108,0,0,0,0,0,0,0,160,9,2,0,22,0,0,0,23,0,0,0,148,255,255,255,148,255,255,255,160,9,2,0,24,0,0,0,25,0,0,0,101,114,114,111,114,32,114,101,97,100,95,118,97,108,117,101,44,32,110,111,32,100,97,116,97,32,97,108,108,111,99,97,116,101,100,32,102,111,114,32,115,116,111,114,105,110,103,32,115,116,114,105,110,103,0,0,102,109,105,77,111,100,101,108,68,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,0,0,0,0,0,0,0,83,99,97,108,97,114,86,97,114,105,97,98,108,101,0,0,99,108,97,115,115,73,110,100,101,120,0,0,0,0,0,0,99,108,97,115,115,84,121,112,101,0,0,0,0,0,0,0,114,83,116,97,0,0,0,0,114,68,101,114,0,0,0,0,114,65,108,103,0,0,0,0,114,80,97,114,0,0,0,0,114,65,108,105,0,0,0,0,105,65,108,103,0,0,0,0,105,80,97,114,0,0,0,0,105,65,108,105,0,0,0,0,98,65,108,103,0,0,0,0,98,80,97,114,0,0,0,0,98,65,108,105,0,0,0,0,115,65,108,103,0,0,0,0,115,80,97,114,0,0,0,0,115,65,108,105,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,101,114,114,111,114,32,114,101,97,100,105,110,103,32,116,104,101,32,120,109,108,32,102,105,108,101,44,32,102,111,117,110,100,32,117,110,107,110,111,119,110,32,99,108,97,115,115,58,32,37,115,32,32,102,111,114,32,118,97,114,105,97,98,108,101,58,32,37,115,0,82,101,97,108,0,0,0,0,73,110,116,101,103,101,114,0,66,111,111,108,101,97,110,0,83,116,114,105,110,103,0,0,118,97,114,105,97,98,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,79,71,95,65,76,76,0,44,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,37,45,49,56,115,32,91,37,115,93,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,118,32,37,115,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,110,108,115,61,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,108,97,112,97,99,107,0,0,108,105,115,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+98644);
/* memory initializer */ allocate([45,108,115,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,76,105,115,0,0,0,0,0,94,40,0,0,0,0,0,0,41,36,0,0,0,0,0,0,36,100,117,109,109,121,0,0,46,42,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,58,32,0,0,32,119,105,116,104,32,101,114,114,111,114,58,32,0,0,0,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,111,117,116,112,117,116,116,105,110,103,32,97,108,108,32,118,97,114,105,97,98,108,101,115,46,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,114,118,97,108,115,32,61,32,37,108,100,0,67,80,85,0,0,0,0,0,82,84,0,0,0,0,0,0,67,89,67,0,0,0,0,0,91,117,110,107,110,111,119,110,32,99,108,111,99,107,45,116,121,112,101,93,32,103,111,116,32,37,115,44,32,101,120,112,101,99,116,101,100,32,67,80,85,124,82,84,124,67,89,67,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,82,84,46,0,0,0,0,0,67,104,111,115,101,110,32,99,108,111,99,107,45,116,121,112,101,58,32,37,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,114,101,97,108,45,116,105,109,101,46,0,0,76,105,110,101,97,114,105,122,97,116,105,111,110,32,119,105,108,108,32,112,101,114,102,111,114,109,101,100,32,97,116,32,112,111,105,110,116,32,111,102,32,116,105,109,101,58,32,37,102,0,0,0,0,0,0,0,111,118,101,114,119,114,105,116,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,32,91,102,114,111,109,32,99,111,109,109,97,110,100,32,108,105,110,101,93,0,95,114,101,115,46,0,0,0,0,0,0,0,0,0,0,0,76,105,110,101,97,114,32,109,111,100,101,108,32,105,115,32,99,114,101,97,116,101,100,33,0,0,0,0,0,0,0,0,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,95,112,114,111,102,46,112,108,116,0,0,0,0,0,0,0,115,118,103,0,0,0,0,0,101,109,112,116,121,0,0,0,99,115,118,0,0,0,0,0,109,97,116,0,0,0,0,0,119,97,108,108,0,0,0,0,112,108,116,0,0,0,0,0,85,110,107,110,111,119,110,32,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,0,65,108,108,111,99,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,115,116,111,114,97,103,101,32,102,111,114,32,109,101,116,104,111,100,32,39,37,115,39,32,97,110,100,32,102,105,108,101,61,39,37,115,39,0,0,88,176,1,0,64,178,1,0,72,178,1,0,144,180,1,0,168,178,1,0,184,178,1,0,152,180,1,0,160,180,1,0,168,180,1,0,176,180,1,0,192,180,1,0,208,180,1,0,224,180,1,0,240,180,1,0,0,181,1,0,16,181,1,0,32,181,1,0,56,181,1,0,112,180,1,0,136,180,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,115,32,37,115,0,0,0,0,0,0,0,88,176,1,0,64,178,1,0,72,178,1,0,88,178,1,0,168,178,1,0,184,178,1,0,200,178,1,0,232,178,1,0,8,179,1,0,40,179,1,0,80,179,1,0,120,179,1,0,160,179,1,0,200,179,1,0,224,179,1,0,0,180,1,0,32,180,1,0,72,180,1,0,112,180,1,0,136,180,1,0,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,37,115,0,0,0,117,115,97,103,101,58,32,37,115,0,0,0,0,0,0,0,60,45,37,115,62,10,32,32,37,115,0,0,0,0,0,0,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,32,32,37,115,0,91,117,110,107,110,111,119,110,32,102,108,97,103,45,116,121,112,101,93,32,60,45,37,115,62,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,108,111,103,70,111,114,109,97,116,61,37,115,44,32,101,120,112,101,99,116,101,100,32,116,101,120,116,32,111,114,32,120,109,108,0,0,0,0,0,0,0,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,62,10,37,115,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,37,115,0,0,0,0,88,176,1,0,32,178,1,0,40,178,1,0,48,178,1,0,88,176,1,0,96,177,1,0,176,177,1,0,224,177,1,0,88,176,1,0,32,177,1,0,40,177,1,0,48,177,1,0,64,177,1,0,72,177,1,0,88,177,1,0,0,0,0,0,88,176,1,0,96,176,1,0,120,176,1,0,136,176,1,0,208,176,1,0,224,176,1,0,0,177,1,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,104,101,108,112,61,37,115,0,0,0,117,115,101,32,37,115,32,45,104,101,108,112,32,102,111,114,32,97,32,108,105,115,116,32,111,102,32,97,108,108,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,67,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,103,108,111,98,97,108,32,100,97,116,97,32,115,116,114,117,99,116,117,114,101,32,102,105,108,101,0,0,0,0,0,0,78,111,32,118,97,114,105,97,98,108,101,115,32,105,110,32,116,104,101,32,109,111,100,101,108,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,109,111,100,101,108,62,37,115,60,47,109,111,100,101,108,62,10,0,0,0,0,0,0,60,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,37,103,60,47,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,10,0,0,60,111,108,100,84,105,109,101,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,62,10,0,0,0,0,0,0,0,60,111,108,100,84,105,109,101,50,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,50,62,10,0,0,0,0,0,60,100,105,102,102,79,108,100,84,105,109,101,62,37,103,60,47,100,105,102,102,79,108,100,84,105,109,101,62,10,0,0,60,99,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,99,117,114,114,101,110,116,84,105,109,101,62,10,0,0,60,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,10,0,0,1,0,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,101,117,108,101,114,0,0,0,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,114,97,100,97,117,53,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,51,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,49,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,108,111,98,97,116,116,111,50,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,113,115,115,0,0,0,0,0,100,97,115,115,108,0,0,0,114,97,100,97,117,53,0,0,114,97,100,97,117,51,0,0,114,97,100,97,117,49,0,0,108,111,98,97,116,116,111,50,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,0,0,0,0,0,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,60,115,116,97,116,117,115,62,0,0,0,0,0,0,0,0,60,112,104,97,115,101,62,85,78,75,78,79,87,78,60,47,112,104,97,115,101,62,0,0,60,47,115,116,97,116,117,115,62,0,0,0,0,0,0,0,44,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,115,101,101,100,58,32,100,97,116,97,45,62,115,105,109,117,108,97,116,105,111,110,73,110,102,111,46,97,110,97,108,121,116,105,99,74,97,99,111,98,105,97,110,115,91,105,110,100,101,120,93,46,115,101,101,100,86,97,114,115,91,37,100,93,61,32,37,102,0,0,0,0,119,114,105,116,101,32,105,110,32,106,97,99,91,37,100,93,45,91,37,100,44,37,100,93,61,37,103,32,102,114,111,109,32,114,111,119,91,37,100,93,61,37,103,0,0,0,0,0,80,114,105,110,116,32,106,97,99,58,0,0,0,0,0,0,37,32,46,53,101,32,0,0,99,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,65,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,66,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,67,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,68,32,0,0,0,0,105,32,102,111,114,32,105,32,105,110,32,49,58,48,0,0,108,105,110,101,97,114,95,0,46,109,111,0,0,0,0,0,119,98,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,0,0,0,0,0,56,0,0,0,0,0,0,0,120,183,1,0,26,0,0,0,27,0,0,0,200,255,255,255,200,255,255,255,120,183,1,0,28,0,0,0,29,0,0,0,4,183,1,0,148,183,1,0,168,183,1,0,24,183,1,0,78,83,116,51,95,95,49,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,168,78,2,0,48,183,1,0,48,10,2,0,0,0,0,0,56,0,0,0,0,0,0,0,48,10,2,0,12,0,0,0,13,0,0,0,200,255,255,255,200,255,255,255,48,10,2,0,14,0,0,0,15,0,0,0,0,0,0,0,56,184,1,0,30,0,0,0,31,0,0,0,4,0,0,0,11,0,0,0,3,0,0,0,5,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,36,0,0,0,34,0,0,0,26,0,0,0,10,0,0,0,27,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,168,78,2,0,240,183,1,0,40,9,2,0,0,0,0,0,67,97,108,117,99,117,108,97,116,101,32,111,110,101,32,99,111,108,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,103,110,117,112,108,111,116,0,80,108,111,116,115,32,111,102,32,112,114,111,102,105,108,105,110,103,32,100,97,116,97,32,119,101,114,101,32,100,105,115,97,98,108,101,100,58,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,58,32,37,115,10,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,115,118,103,10,0,0,0,0,0,0,0,115,101,116,32,110,111,107,101,121,10,0,0,0,0,0,0,115,101,116,32,102,111,114,109,97,116,32,121,32,34,37,103,34,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,111,102,32,103,108,111,98,97,108,32,115,116,101,112,115,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,100,111,99,32,91,32,32,60,33,69,76,69,77,69,78,84,32,115,105,109,117,108,97,116,105,111,110,32,40,109,111,100,101,108,105,110,102,111,44,32,118,97,114,105,97,98,108,101,115,44,32,102,117,110,99,116,105,111,110,115,44,32,101,113,117,97,116,105,111,110,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,118,97,114,105,97,98,108,101,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,101,113,117,97,116,105,111,110,32,40,114,101,102,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,101,113,117,97,116,105,111,110,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,115,32,40,112,114,111,102,105,108,101,98,108,111,99,107,42,41,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,32,40,114,101,102,115,44,32,110,99,97,108,108,44,32,116,105,109,101,44,32,109,97,120,84,105,109,101,41,62,32,32,60,33,69,76,69,77,69,78,84,32,114,101,102,115,32,40,114,101,102,42,41,62,32,32,60,33,65,84,84,76,73,83,84,32,114,101,102,32,114,101,102,105,100,32,73,68,82,69,70,32,35,82,69,81,85,73,82,69,68,62,32,32,93,62,10,0,0,0,0,116,105,109,101,40,41,32,102,97,105,108,101,100,58,32,37,115,0,0,0,0,0,0,0,37,89,45,37,109,45,37,100,32,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,115,116,114,102,116,105,109,101,40,41,32,102,97,105,108,101,100,0,0,0,0,0,0,0,60,115,105,109,117,108,97,116,105,111,110,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,62,10,0,0,0,0,60,110,97,109,101,62,0,0,60,47,110,97,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,102,105,120,62,0,0,0,0,0,0,0,0,60,47,112,114,101,102,105,120,62,10,0,0,0,0,0,0,60,100,97,116,101,62,0,0,60,47,100,97,116,101,62,10,0,0,0,0,0,0,0,0,60,109,101,116,104,111,100,62,0,0,0,0,0,0,0,0,60,47,109,101,116,104,111,100,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,111,114,109,97,116,62,0,0,60,47,111,117,116,112,117,116,70,111,114,109,97,116,62,10,0,0,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,0,0,0,0,0,0,0,0,60,47,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,37,108,100,60,47,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,10,0,0,0,60,111,118,101,114,104,101,97,100,84,105,109,101,62,37,102,60,47,111,118,101,114,104,101,97,100,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,105,110,105,116,84,105,109,101,62,37,102,60,47,112,114,101,105,110,105,116,84,105,109,101,62,10,0,0,60,105,110,105,116,84,105,109,101,62,37,102,60,47,105,110,105,116,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,101,118,101,110,116,84,105,109,101,62,37,102,60,47,101,118,101,110,116,84,105,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,84,105,109,101,62,37,102,60,47,111,117,116,112,117,116,84,105,109,101,62,10,0,0,0,0,60,108,105,110,101,97,114,105,122,101,84,105,109,101,62,37,102,60,47,108,105,110,101,97,114,105,122,101,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,84,105,109,101,62,37,102,60,47,116,111,116,97,108,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,37,102,60,47,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,10,0,0,0,0,60,110,117,109,83,116,101,112,62,37,100,60,47,110,117,109,83,116,101,112,62,10,0,0,60,109,97,120,84,105,109,101,62,37,46,57,102,60,47,109,97,120,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,0,60,111,100,101,84,105,109,101,62,37,102,60,47,111,100,101,84,105,109,101,62,10,0,0,60,111,100,101,84,105,109,101,84,105,99,107,115,62,37,108,117,60,47,111,100,101,84,105,109,101,84,105,99,107,115,62,10,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,60,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,0,60,47,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,60,118,97,114,105,97,98,108,101,115,62,10,0,0,0,0,60,47,118,97,114,105,97,98,108,101,115,62,10,0,0,0,60,102,117,110,99,116,105,111,110,115,62,10,0,0,0,0,60,47,102,117,110,99,116,105,111,110,115,62,10,0,0,0,60,101,113,117,97,116,105,111,110,115,62,10,0,0,0,0,60,47,101,113,117,97,116,105,111,110,115,62,10,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,60,47,115,105,109,117,108,97,116,105,111,110,62,10,0,0,98,117,102,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,109,111,100,101,108,105,110,102,111,46,99,0,0,112,114,105,110,116,77,111,100,101,108,73,110,102,111,0,0,87,97,114,110,105,110,103,58,32,80,108,111,116,32,99,111,109,109,97,110,100,32,102,97,105,108,101,100,10,0,0,0,120,115,108,116,112,114,111,99,0,0,0,0,0,0,0,0,37,115,32,45,111,32,37,115,95,112,114,111,102,46,104,116,109,108,32,37,115,47,115,104,97,114,101,47,111,109,99,47,115,99,114,105,112,116,115,47,100,101,102,97,117,108,116,95,112,114,111,102,105,108,105,110,103,46,120,115,108,32,37,115,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,103,101,110,101,114,97,116,101,32,104,116,109,108,32,118,101,114,115,105,111,110,32,111,102,32,112,114,111,102,105,108,105,110,103,32,114,101,115,117,108,116,115,58,32,37,115,10,0,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,97,114,101,32,115,116,111,114,101,100,32,105,110,32,37,115,95,112,114,111,102,46,104,116,109,108,32,40,104,117,109,97,110,45,114,101,97,100,97,98,108,101,41,32,97,110,100,32,37,115,95,112,114,111,102,46,120,109,108,32,40,102,111,114,32,88,83,76,32,116,114,97,110,115,102,111,114,109,115,32,111,114,32,109,111,114,101,32,100,101,116,97,105,108,115,41,0,0,0,0,0,0,101,113,0,0,0,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,101,113,37,100,34,47,62,10,0,0,0,0,60,110,99,97,108,108,62,37,100,60,47,110,99,97,108,108,62,10,0,0,0,0,0,0,60,116,105,109,101,62,37,46,57,102,60,47,116,105,109,101,62,10,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,0,0,0,0,0,0,0,60,101,113,117,97,116,105,111,110,32,105,100,61,34,101,113,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,0,34,62,10,0,0,0,0,0,60,114,101,102,115,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,118,97,114,37,100,34,32,47,62,10,0,0,60,47,114,101,102,115,62,10,0,0,0,0,0,0,0,0,60,99,97,108,99,105,110,102,111,32,116,105,109,101,61,34,37,102,34,32,99,111,117,110,116,61,34,37,108,117,34,47,62,10,0,0,0,0,0,0,60,47,101,113,117,97,116,105,111,110,62,10,0,0,0,0,102,117,110,0,0,0,0,0,60,102,117,110,99,116,105,111,110,32,105,100,61,34,102,117,110,37,100,34,62,10,0,0,60,47,102,117,110,99,116,105,111,110,62,10,0,0,0,0,60,105,110,102,111,32,102,105,108,101,110,97,109,101,61,34,0,0,0,0,0,0,0,0,34,32,115,116,97,114,116,108,105,110,101,61,34,37,100,34,32,115,116,97,114,116,99,111,108,61,34,37,100,34,32,101,110,100,108,105,110,101,61,34,37,100,34,32,101,110,100,99,111,108,61,34,37,100,34,32,114,101,97,100,111,110,108,121,61,34,37,115,34,32,47,62,10,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,60,118,97,114,105,97,98,108,101,32,105,100,61,34,118,97,114,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,34,32,99,111,109,109,101,110,116,61,34,0,0,0,0,0,60,47,118,97,114,105,97,98,108,101,62,10,0,0,0,0,37,115,95,112,114,111,102,46,100,97,116,97,0,0,0,0,60,102,105,108,101,110,97,109,101,62,0,0,0,0,0,0,60,47,102,105,108,101,110,97,109,101,62,10,0,0,0,0,60,102,105,108,101,115,105,122,101,62,37,108,100,60,47,102,105,108,101,115,105,122,101,62,10,0,0,0,0,0,0,0,60,102,111,114,109,97,116,62,10,0,0,0,0,0,0,0,60,117,105,110,116,51,50,62,115,116,101,112,60,47,117,105,110,116,51,50,62,10,0,0,60,100,111,117,98,108,101,62,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,60,100,111,117,98,108,101,62,99,112,117,32,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,0,0,0,0,60,117,105,110,116,51,50,62,0,0,0,0,0,0,0,0,32,40,99,97,108,108,115,41,60,47,117,105,110,116,51,50,62,10,0,0,0,0,0,0,60,100,111,117,98,108,101,62,0,0,0,0,0,0,0,0,32,40,99,112,117,32,116,105,109,101,41,60,47,100,111,117,98,108,101,62,10,0,0,0,60,47,102,111,114,109,97,116,62,10,0,0,0,0,0,0,114,98,0,0,0,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,112,111,115,59,0,0,38,113,117,111,116,59,0,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,50,100,111,117,98,108,101,37,37,42,37,100,117,105,110,116,51,50,37,37,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,49,58,40,36,37,100,62,49,101,45,57,32,63,32,36,37,100,32,58,32,49,101,45,51,48,41,32,119,32,108,32,108,119,32,37,100,10,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,42,50,100,111,117,98,108,101,37,37,37,100,117,105,110,116,51,50,37,37,42,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,37,100,32,119,32,108,32,108,119,32,37,100,10,0,0,0,0,0,0,0,0,117,110,115,101,116,32,120,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,121,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,98,111,114,100,101,114,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,115,101,116,32,116,105,116,108,101,10,0,0,0,0,0,0,115,101,116,32,120,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,108,111,103,32,121,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,37,103,93,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,42,93,10,0,0,0,0,0,0,0,115,101,116,32,110,111,108,111,103,32,120,121,10,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,37,103,58,37,103,93,10,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,0,0,115,101,116,32,121,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,120,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,98,111,114,100,101,114,10,0,0,0,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,37,115,10,0,0,0,0,0,0,0,0,115,101,116,32,116,105,116,108,101,32,34,37,115,34,10,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,97,116,32,116,105,109,101,34,10,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,91,115,93,34,10,0,0,0,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,37,115,34,10,0,0,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,110,117,109,98,101,114,34,10,0,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,99,111,117,110,116,34,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,37,115,58,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,101,120,112,97,116,32,111,98,106,101,99,116,0,0,0,68,117,109,109,121,32,101,113,117,97,116,105,111,110,32,115,111,32,119,101,32,99,97,110,32,105,110,100,101,120,32,102,114,111,109,32,49,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,105,109,117,108,97,116,105,111,110,95,105,110,102,111,95,120,109,108,46,99,0,0,0,0,0,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,120,109,108,45,62,110,69,113,117,97,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,49,93,0,0,0,109,111,100,101,108,73,110,102,111,88,109,108,73,110,105,116,0,0,0,0,0,0,0,0,120,109,108,45,62,110,70,117,110,99,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,51,93,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,119,101,32,111,110,108,121,32,104,97,118,101,32,37,108,100,32,115,117,99,104,32,98,108,111,99,107,115,0,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,105,116,33,0,0,0,0,0,0,118,97,114,105,97,98,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,113,117,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,97,114,0,0,76,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,105,110,100,101,120,32,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,0,110,111,110,108,105,110,101,97,114,0,0,0,0,0,0,0,78,111,110,108,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,114,101,115,105,100,117,97,108,70,117,110,99,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,101,102,105,110,101,115,0,110,97,109,101,0,0,0,0,60,100,101,102,105,110,101,115,62,32,110,101,101,100,115,32,116,111,32,104,97,118,101,32,101,120,97,99,116,108,121,32,111,110,101,32,97,116,116,114,105,98,117,116,101,58,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,0,0,0,0,102,105,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,83,116,97,114,116,0,0,0,0,0,0,0,108,105,110,101,69,110,100,0,99,111,108,83,116,97,114,116,0,0,0,0,0,0,0,0,99,111,108,69,110,100,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,37,115,58,32,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,105,110,32,60,105,110,102,111,62,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,109,111,114,101,32,101,113,117,97,116,105,111,110,115,32,116,104,97,110,32,101,120,112,101,99,116,101,100,32,40,37,108,100,41,0,0,0,0,105,110,100,101,120,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,111,117,116,32,105,110,100,101,120,0,0,0,0,0,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,103,111,116,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,105,110,100,101,120,32,37,108,100,44,32,101,120,112,101,99,116,101,100,32,37,108,100,0,0,0,0,0,0,0,83,79,77,69,32,78,73,67,69,32,69,81,85,65,84,73,79,78,32,78,65,77,69,32,40,116,111,32,98,101,32,115,101,116,32,97,32,108,105,116,116,108,101,32,108,97,116,101,114,41,0,0,0,0,0,0,99,111,109,109,101,110,116,0,60,118,97,114,62,45,116,97,103,32,100,105,100,32,110,111,116,32,115,101,116,32,110,97,109,101,32,97,110,100,32,99,111,109,109,101,110,116,0,0,35,70,73,88,77,69,35,0,84,79,68,79,58,32,83,101,116,32,109,101,32,117,112,33,33,33,0,0,0,0,0,0,100,117,109,109,121,86,97,114,83,116,97,116,101,83,101,116,74,97,99,0,0,0,0,0,255,255,255,255,200,204,1,0,200,204,1,0,200,204,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,100,32,39,37,115,39,32,116,104,97,116,32,119,97,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,97,115,32,60,118,97,114,105,97,98,108,101,62,0,0,0,0,0,63,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,78,65,77,69,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,83,67,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,84,65,73,76,69,68,95,68,69,83,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,97,99,104,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,111,110,99,101,58,32,37,115,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,37,115,0,83,84,79,80,32,0,0,0,32,115,116,97,116,101,109,101,110,116,32,101,120,101,99,117,116,101,100,10,0,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,110,100,102,105,108,101,0,101,114,114,111,114,32,105,110,32,102,111,114,109,97,116,0,105,108,108,101,103,97,108,32,117,110,105,116,32,110,117,109,98,101,114,0,0,0,0,0,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,100,105,114,101,99,116,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,115,101,113,117,101,110,116,105,97,108,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,99,97,110,39,116,32,98,97,99,107,115,112,97,99,101,32,102,105,108,101,0,0,0,0,110,117,108,108,32,102,105,108,101,32,110,97,109,101,0,0,99,97,110,39,116,32,115,116,97,116,32,102,105,108,101,0,117,110,105,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,111,102,102,32,101,110,100,32,111,102,32,114,101,99,111,114,100,0,0,0,0,0,0,0,116,114,117,110,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,101,110,100,102,105,108,101,0,0,0,0,105,110,99,111,109,112,114,101,104,101,110,115,105,98,108,101,32,108,105,115,116,32,105,110,112,117,116,0,0,0,0,0,111,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,0,0,0,0,0,0,0,114,101,97,100,32,117,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,98,97,100,32,108,111,103,105,99,97,108,32,105,110,112,117,116,32,102,105,101,108,100,0,98,97,100,32,118,97,114,105,97,98,108,101,32,116,121,112,101,0,0,0,0,0,0,0,98,97,100,32,110,97,109,101,108,105,115,116,32,110,97,109,101,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,32,110,111,116,32,105,110,32,110,97,109,101,108,105,115,116,0,0,0,0,0,0,0,0,110,111,32,101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+108884);
/* memory initializer */ allocate([110,100,32,114,101,99,111,114,100,0,0,0,118,97,114,105,97,98,108,101,32,99,111,117,110,116,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,32,102,111,114,32,115,99,97,108,97,114,32,118,97,114,105,97,98,108,101,0,0,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,115,101,99,116,105,111,110,0,0,0,115,117,98,115,116,114,105,110,103,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,115,117,98,115,99,114,105,112,116,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,99,97,110,39,116,32,114,101,97,100,32,102,105,108,101,0,99,97,110,39,116,32,119,114,105,116,101,32,102,105,108,101,0,0,0,0,0,0,0,0,39,110,101,119,39,32,102,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,0,0,99,97,110,39,116,32,97,112,112,101,110,100,32,116,111,32,102,105,108,101,0,0,0,0,110,111,110,45,112,111,115,105,116,105,118,101,32,114,101,99,111,114,100,32,110,117,109,98,101,114,0,0,0,0,0,0,110,109,76,98,117,102,32,111,118,101,114,102,108,111,119,0,112,207,1,0,128,207,1,0,152,207,1,0,184,207,1,0,216,207,1,0,240,207,1,0,16,208,1,0,40,208,1,0,56,208,1,0,72,208,1,0,96,208,1,0,120,208,1,0,152,208,1,0,184,208,1,0,72,208,1,0,208,208,1,0,240,208,1,0,8,209,1,0,32,209,1,0,56,209,1,0,88,209,1,0,104,209,1,0,136,209,1,0,168,209,1,0,192,209,1,0,216,209,1,0,240,209,1,0,0,210,1,0,24,210,1,0,48,210,1,0,72,210,1,0,104,210,1,0,37,115,58,32,105,108,108,101,103,97,108,32,101,114,114,111,114,32,110,117,109,98,101,114,32,37,100,10,0,0,0,0,37,115,58,32,101,110,100,32,111,102,32,102,105,108,101,10,0,0,0,0,0,0,0,0,37,115,58,32,37,115,10,0,0,0,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,117,110,105,116,32,37,100,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+119124);
/* memory initializer */ allocate([110,97,109,101,100,32,37,115,10,0,0,0,0,0,0,0,40,117,110,110,97,109,101,100,41,10,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,105,110,116,101,114,110,97,108,32,73,47,79,10,0,0,0,0,0,0,0,0,0,0,0,108,97,115,116,32,102,111,114,109,97,116,58,32,37,115,10,0,0,0,0,0,0,0,0,108,97,116,101,108,121,32,37,115,32,37,115,32,37,115,32,37,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,101,97,100,105,110,103,0,119,114,105,116,105,110,103,0,0,0,0,0,0,0,0,0,115,101,113,117,101,110,116,105,97,108,0,0,0,0,0,0,100,105,114,101,99,116,0,0,0,0,0,0,0,0,0,0,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,105,110,116,101,114,110,97,108,0,0,0,0,0,0,0,0,32,73,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+124440);
/* memory initializer */ allocate([117,110,107,110,111,119,110,32,99,111,100,101,32,105,110,32,100,111,95,102,105,111,58,32,37,100,10,37,115,10,0,0,100,111,95,102,105,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,100,32,115,116,114,105,110,103,0,0,0,0,0,0,102,111,114,109,97,116,32,116,111,111,32,99,111,109,112,108,105,99,97,116,101,100,58,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,0,0,0,0,0,0,0,112,251,1,0,120,251,1,0,119,98,0,0,0,0,0,0,119,0,0,0,0,0,0,0,114,43,98,0,0,0,0,0,114,43,0,0,0,0,0,0,136,251,1,0,144,251,1,0,152,251,1,0,160,251,1,0,144,1,0,0,0,0,0,0,16,252,1,0,0,0,0,0,111,112,101,110,0,0,0,0,102,111,114,116,46,37,108,100,0,0,0,0,0,0,0,0,110,111,32,115,112,97,99,101,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,102,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,117,114,101,0,0,115,116,97,114,116,105,111,0,115,102,101,0,0,0,0,0,37,35,46,42,69,0,0,0,37,43,46,50,100,0,0,0,37,35,46,42,102,0,0,0,119,95,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,0,119,95,110,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,108,101,102,116,32,111,102,102,0,0,0,0,0,0,0,0,114,101,99,101,110,100,0,0,115,116,97,114,116,105,111,0,119,114,105,116,101,32,115,116,97,114,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+129664);
/* memory initializer */ allocate([232,2,2,0,32,0,0,0,33,0,0,0,5,0,0,0,12,0,0,0,4,0,0,0,6,0,0,0,37,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,168,78,2,0,200,2,2,0,104,9,2,0,0,0,0,0,0,0,0,0,80,3,2,0,34,0,0,0,35,0,0,0,6,0,0,0,12,0,0,0,4,0,0,0,6,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,42,0,0,0,43,0,0,0,30,0,0,0,15,0,0,0,31,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,168,78,2,0,56,3,2,0,104,9,2,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,0,0,0,0,232,3,2,0,36,0,0,0,37,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,7,0,0,0,44,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,16,0,0,0,33,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,168,78,2,0,200,3,2,0,40,9,2,0,0,0,0,0,0,0,0,0,80,4,2,0,38,0,0,0,39,0,0,0,8,0,0,0,11,0,0,0,5,0,0,0,7,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,46,0,0,0,47,0,0,0,34,0,0,0,10,0,0,0,35,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,168,78,2,0,56,4,2,0,40,9,2,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,128,78,2,0,96,4,2,0,0,0,0,0,200,4,2,0,40,0,0,0,41,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,112,5,2,0,42,0,0,0,43,0,0,0,49,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,168,78,2,0,184,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,8,5,2,0,40,0,0,0,44,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,168,78,2,0,240,4,2,0,200,4,2,0,0,0,0,0,0,0,0,0,72,5,2,0,40,0,0,0,45,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,168,78,2,0,48,5,2,0,200,4,2,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,168,78,2,0,88,5,2,0,0,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,0,0,0,0,184,5,2,0,46,0,0,0,47,0,0,0,49,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,168,78,2,0,160,5,2,0,112,5,2,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,128,78,2,0,200,5,2,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,168,78,2,0,240,5,2,0,232,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,0,0,0,0,160,8,2,0,48,0,0,0,49,0,0,0,0,0,0,0,40,9,2,0,50,0,0,0,51,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,7,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,10,0,0,0,35,0,0,0,0,0,0,0,104,9,2,0,52,0,0,0,53,0,0,0,9,0,0,0,12,0,0,0,4,0,0,0,6,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,15,0,0,0,31,0,0,0,8,0,0,0,0,0,0,0,160,9,2,0,22,0,0,0,23,0,0,0,248,255,255,255,248,255,255,255,160,9,2,0,24,0,0,0,25,0,0,0,8,0,0,0,0,0,0,0,232,9,2,0,54,0,0,0,55,0,0,0,248,255,255,255,248,255,255,255,232,9,2,0,56,0,0,0,57,0,0,0,4,0,0,0,0,0,0,0,48,10,2,0,12,0,0,0,13,0,0,0,252,255,255,255,252,255,255,255,48,10,2,0,14,0,0,0,15,0,0,0,4,0,0,0,0,0,0,0,120,10,2,0,58,0,0,0,59,0,0,0,252,255,255,255,252,255,255,255,120,10,2,0,60,0,0,0,61,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,8,2,0,62,0,0,0,63,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,104,8,2,0,64,0,0,0,65,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,168,78,2,0,32,8,2,0,184,5,2,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,128,78,2,0,80,8,2,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,168,78,2,0,112,8,2,0,104,8,2,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,168,78,2,0,176,8,2,0,104,8,2,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,128,78,2,0,240,8,2,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,128,78,2,0,48,9,2,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,8,79,2,0,112,9,2,0,0,0,0,0,1,0,0,0,160,8,2,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,8,79,2,0,184,9,2,0,0,0,0,0,1,0,0,0,224,8,2,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,8,79,2,0,0,10,2,0,0,0,0,0,1,0,0,0,160,8,2,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,8,79,2,0,72,10,2,0,0,0,0,0,1,0,0,0,224,8,2,0,3,244,255,255,0,0,0,0,216,10,2,0,66,0,0,0,67,0,0,0,50,0,0,0,2,0,0,0,17,0,0,0,18,0,0,0,3,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,168,78,2,0,184,10,2,0,8,6,2,0,0,0,0,0,0,0,0,0,0,25,2,0,68,0,0,0,69,0,0,0,70,0,0,0,1,0,0,0,8,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,25,2,0,71,0,0,0,72,0,0,0,70,0,0,0,2,0,0,0,9,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,29,2,0,73,0,0,0,74,0,0,0,70,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,112,30,2,0,75,0,0,0,76,0,0,0,70,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,31,2,0,77,0,0,0,78,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,23,0,0,0,8,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,31,2,0,79,0,0,0,80,0,0,0,70,0,0,0,10,0,0,0,11,0,0,0,25,0,0,0,12,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,240,26,2,0,81,0,0,0,82,0,0,0,70,0,0,0,51,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,240,26,2,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,72,58,37,77,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,144,27,2,0,83,0,0,0,84,0,0,0,70,0,0,0,59,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,144,27,2,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,32,28,2,0,85,0,0,0,86,0,0,0,70,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,28,2,0,87,0,0,0,88,0,0,0,70,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,25,2,0,89,0,0,0,90,0,0,0,70,0,0,0,67,0,0,0,68,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,69,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,25,2,0,91,0,0,0,92,0,0,0,70,0,0,0,70,0,0,0,71,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,72,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,25,2,0,93,0,0,0,94,0,0,0,70,0,0,0,73,0,0,0,74,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,75,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,26,2,0,95,0,0,0,96,0,0,0,70,0,0,0,76,0,0,0,77,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,78,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,32,2,0,97,0,0,0,98,0,0,0,70,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,76,102,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,0,0,0,0,232,32,2,0,99,0,0,0,100,0,0,0,70,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,0,0,0,0,120,33,2,0,101,0,0,0,102,0,0,0,70,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,0,0,0,0,8,34,2,0,103,0,0,0,104,0,0,0,70,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,28,2,0,105,0,0,0,106,0,0,0,70,0,0,0,21,0,0,0,14,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,29,2,0,107,0,0,0,108,0,0,0,70,0,0,0,22,0,0,0,15,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,118,101,99,116,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,216,24,2,0,109,0,0,0,110,0,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,21,2,0,111,0,0,0,112,0,0,0,70,0,0,0,36,0,0,0,23,0,0,0,37,0,0,0,24,0,0,0,38,0,0,0,28,0,0,0,25,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,22,2,0,113,0,0,0,114,0,0,0,70,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,79,0,0,0,80,0,0,0,5,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,24,2,0,115,0,0,0,116,0,0,0,70,0,0,0,82,0,0,0,83,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,176,24,2,0,117,0,0,0,118,0,0,0,70,0,0,0,84,0,0,0,85,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,116,114,117,101,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,0,0,0,0,232,20,2,0,119,0,0,0,120,0,0,0,70,0,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,168,78,2,0,208,20,2,0,128,4,2,0,0,0,0,0,0,0,0,0,120,21,2,0,119,0,0,0,121,0,0,0,70,0,0,0,26,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,39,0,0,0,27,0,0,0,40,0,0,0,28,0,0,0,41,0,0,0,32,0,0,0,29,0,0,0,6,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,128,78,2,0,88,21,2,0,8,79,2,0,64,21,2,0,0,0,0,0,2,0,0,0,232,20,2,0,2,0,0,0,112,21,2,0,2,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,8,79,2,0,152,21,2,0,0,0,0,0,2,0,0,0,232,20,2,0,2,0,0,0,112,21,2,0,2,0,0,0,0,0,0,0,72,22,2,0,119,0,0,0,122,0,0,0,70,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,86,0,0,0,87,0,0,0,8,0,0,0,88,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,128,78,2,0,40,22,2,0,8,79,2,0,0,22,2,0,0,0,0,0,2,0,0,0,232,20,2,0,2,0,0,0,64,22,2,0,2,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,8,79,2,0,104,22,2,0,0,0,0,0,2,0,0,0,232,20,2,0,2,0,0,0,64,22,2,0,2,0,0,0,0,0,0,0,8,23,2,0,119,0,0,0,123,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,9,0,0,0,89,0,0,0,90,0,0,0,10,0,0,0,91,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,8,79,2,0,224,22,2,0,0,0,0,0,2,0,0,0,232,20,2,0,2,0,0,0,64,22,2,0,2,0,0,0,0,0,0,0,128,23,2,0,119,0,0,0,124,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,8,79,2,0,88,23,2,0,0,0,0,0,2,0,0,0,232,20,2,0,2,0,0,0,64,22,2,0,2,0,0,0,0,0,0,0,248,23,2,0,119,0,0,0,125,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,168,78,2,0,208,23,2,0,128,23,2,0,0,0,0,0,0,0,0,0,96,24,2,0,119,0,0,0,126,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,168,78,2,0,56,24,2,0,128,23,2,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,168,78,2,0,112,24,2,0,232,20,2,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,168,78,2,0,152,24,2,0,232,20,2,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,168,78,2,0,192,24,2,0,232,20,2,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,168,78,2,0,232,24,2,0,232,20,2,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,168,78,2,0,16,25,2,0,232,20,2,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,128,78,2,0,88,25,2,0,8,79,2,0,56,25,2,0,0,0,0,0,2,0,0,0,232,20,2,0,2,0,0,0,112,25,2,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,8,79,2,0,152,25,2,0,0,0,0,0,2,0,0,0,232,20,2,0,2,0,0,0,112,25,2,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,8,79,2,0,216,25,2,0,0,0,0,0,2,0,0,0,232,20,2,0,2,0,0,0,112,25,2,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,8,79,2,0,24,26,2,0,0,0,0,0,2,0,0,0,232,20,2,0,2,0,0,0,112,25,2,0,2,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,128,78,2,0,160,26,2,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,128,78,2,0,192,26,2,0,8,79,2,0,88,26,2,0,0,0,0,0,3,0,0,0,232,20,2,0,2,0,0,0,184,26,2,0,2,0,0,0,232,26,2,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,128,78,2,0,96,27,2,0,8,79,2,0,24,27,2,0,0,0,0,0,3,0,0,0,232,20,2,0,2,0,0,0,184,26,2,0,2,0,0,0,136,27,2,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,128,78,2,0,0,28,2,0,8,79,2,0,184,27,2,0,0,0,0,0,2,0,0,0,232,20,2,0,2,0,0,0,24,28,2,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,8,79,2,0,64,28,2,0,0,0,0,0,2,0,0,0,232,20,2,0,2,0,0,0,24,28,2,0,0,8,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,128,78,2,0,192,28,2,0,8,79,2,0,168,28,2,0,0,0,0,0,2,0,0,0,232,20,2,0,2,0,0,0,216,28,2,0,2,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,8,79,2,0,0,29,2,0,0,0,0,0,2,0,0,0,232,20,2,0,2,0,0,0,216,28,2,0,2,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,128,78,2,0,152,29,2,0,8,79,2,0,128,29,2,0,0,0,0,0,1,0,0,0,184,29,2,0,0,0,0,0,8,79,2,0,56,29,2,0,0,0,0,0,2,0,0,0,232,20,2,0,2,0,0,0,192,29,2,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,8,79,2,0,64,30,2,0,0,0,0,0,1,0,0,0,184,29,2,0,0,0,0,0,8,79,2,0,248,29,2,0,0,0,0,0,2,0,0,0,232,20,2,0,2,0,0,0,88,30,2,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,128,78,2,0,240,30,2,0,8,79,2,0,216,30,2,0,0,0,0,0,1,0,0,0,16,31,2,0,0,0,0,0,8,79,2,0,144,30,2,0,0,0,0,0,2,0,0,0,232,20,2,0,2,0,0,0,24,31,2,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,8,79,2,0,152,31,2,0,0,0,0,0,1,0,0,0,16,31,2,0,0,0,0,0,8,79,2,0,80,31,2,0,0,0,0,0,2,0,0,0,232,20,2,0,2,0,0,0,176,31,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,128,78,2,0,48,32,2,0,8,79,2,0,232,31,2,0,0,0,0,0,2,0,0,0,232,20,2,0,2,0,0,0,80,32,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,128,78,2,0,192,32,2,0,8,79,2,0,120,32,2,0,0,0,0,0,2,0,0,0,232,20,2,0,2,0,0,0,224,32,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,128,78,2,0,80,33,2,0,8,79,2,0,8,33,2,0,0,0,0,0,2,0,0,0,232,20,2,0,2,0,0,0,112,33,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,128,78,2,0,224,33,2,0,8,79,2,0,152,33,2,0,0,0,0,0,2,0,0,0,232,20,2,0,2,0,0,0,0,34,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+131716);
/* memory initializer */ allocate([74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,77,97,114,99,104,0,0,0,65,112,114,105,108,0,0,0,77,97,121,0,0,0,0,0,74,117,110,101,0,0,0,0,74,117,108,121,0,0,0,0,65,117,103,117,115,116,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,74,97,110,0,0,0,0,0,70,101,98,0,0,0,0,0,77,97,114,0,0,0,0,0,65,112,114,0,0,0,0,0,74,117,110,0,0,0,0,0,74,117,108,0,0,0,0,0,65,117,103,0,0,0,0,0,83,101,112,0,0,0,0,0,79,99,116,0,0,0,0,0,78,111,118,0,0,0,0,0,68,101,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,117,110,100,97,121,0,0,77,111,110,100,97,121,0,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,83,117,110,0,0,0,0,0,77,111,110,0,0,0,0,0,84,117,101,0,0,0,0,0,87,101,100,0,0,0,0,0,84,104,117,0,0,0,0,0,70,114,105,0,0,0,0,0,83,97,116,0,0,0,0,0,18,17,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,17,34,35,36,17,37,38,39,40,41,42,43,44,17,45,46,47,16,16,48,16,16,16,16,16,16,16,49,50,51,16,52,53,16,16,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,54,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,55,17,17,17,17,56,17,57,58,59,60,61,62,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,63,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,64,65,17,66,67,68,69,70,71,72,73,16,16,16,74,75,76,77,78,16,16,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,17,17,17,82,83,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,84,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,17,85,16,16,16,16,86,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,87,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,88,89,90,91,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,92,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,254,255,255,7,254,255,255,7,0,0,0,0,0,4,32,4,255,255,127,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,195,255,3,0,31,80,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,223,60,64,215,255,255,251,255,255,255,255,255,255,255,255,255,191,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,254,255,255,255,127,2,254,255,255,255,255,0,0,0,0,0,255,191,182,0,255,255,255,7,7,0,0,0,255,7,255,255,255,255,255,255,255,254,255,195,255,255,255,255,255,255,255,255,255,255,255,255,239,31,254,225,255,159,0,0,255,255,255,255,255,255,0,224,255,255,255,255,255,255,255,255,255,255,255,255,3,0,255,255,255,255,255,7,48,4,255,255,255,252,255,31,0,0,255,255,255,1,0,0,0,0,0,0,0,0,253,31,0,0,0,0,0,0,240,3,255,127,255,255,255,255,255,255,255,239,255,223,225,255,207,255,254,254,238,159,249,255,255,253,197,227,159,89,128,176,207,255,3,0,238,135,249,255,255,253,109,195,135,25,2,94,192,255,63,0,238,191,251,255,255,253,237,227,191,27,1,0,207,255,0,0,238,159,249,255,255,253,237,227,159,25,192,176,207,255,2,0,236,199,61,214,24,199,255,195,199,29,129,0,192,255,0,0,238,223,253,255,255,253,239,227,223,29,96,3,207,255,0,0,236,223,253,255,255,253,239,227,223,29,96,64,207,255,6,0,236,223,253,255,255,255,255,231,223,93,128,0,207,255,0,252,236,255,127,252,255,255,251,47,127,128,95,255,0,0,12,0,254,255,255,255,255,127,255,7,63,32,255,3,0,0,0,0,150,37,240,254,174,236,255,59,95,32,255,243,0,0,0,0,1,0,0,0,255,3,0,0,255,254,255,255,255,31,254,255,3,255,255,254,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,249,255,3,255,255,231,193,255,255,127,64,255,51,255,255,255,255,191,32,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,61,127,61,255,255,255,255,255,61,255,255,255,255,61,127,61,255,127,255,255,255,255,255,255,255,61,255,255,255,255,255,255,255,255,135,0,0,0,0,255,255,0,0,255,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,159,255,255,254,255,255,7,255,255,255,255,255,255,255,255,255,199,1,0,255,223,15,0,255,255,15,0,255,255,15,0,255,223,13,0,255,255,255,255,255,255,207,255,255,1,128,16,255,3,0,0,0,0,255,3,255,255,255,255,255,255,255,255,255,255,255,0,255,255,255,255,255,7,255,255,255,255,255,255,255,255,63,0,255,255,255,31,255,15,255,1,192,255,255,255,255,63,31,0,255,255,255,255,255,15,255,255,255,3,255,3,0,0,0,0,255,255,255,15,255,255,255,255,255,255,255,127,254,255,31,0,255,3,255,3,128,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,239,255,239,15,255,3,0,0,0,0,255,255,255,255,255,243,255,255,255,255,255,255,191,255,3,0,255,255,255,255,255,255,63,0,255,227,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,222,111,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,0,0,255,31,0,0,0,0,0,0,0,0,0,0,0,0,132,252,47,62,80,189,255,243,224,67,0,0,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,255,255,255,3,0,0,255,255,255,255,255,127,255,255,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,120,12,0,255,255,255,255,191,32,255,255,255,255,255,255,255,128,0,0,255,255,127,0,127,127,127,127,127,127,127,127,255,255,255,255,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,254,3,62,31,254,255,255,255,255,255,255,255,255,255,127,224,254,255,255,255,255,255,255,255,255,255,255,247,224,255,255,255,255,63,254,255,255,255,255,255,255,255,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,63,255,31,255,255,255,15,0,0,255,255,255,255,255,127,240,143,255,255,255,128,255,255,255,255,255,255,255,255,255,255,0,0,0,0,128,255,252,255,255,255,255,255,255,255,255,255,255,255,255,121,15,0,255,7,0,0,0,0,0,0,0,0,0,255,187,247,255,255,255,0,0,0,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,15,0,255,3,0,0,252,8,255,255,255,255,255,7,255,255,255,255,7,0,255,255,255,31,255,255,255,255,255,255,247,255,0,128,255,3,0,0,0,0,255,255,255,255,255,255,127,0,255,63,255,3,255,255,127,4,255,255,255,255,255,255,255,127,5,0,0,56,255,255,60,0,126,126,126,0,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,7,255,3,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,127,248,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,0,127,0,248,224,255,253,127,95,219,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,248,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,255,255,255,255,255,255,255,255,252,255,255,255,255,255,255,0,0,0,0,0,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,255,3,254,255,255,7,254,255,255,7,192,255,255,255,255,255,255,255,255,255,255,127,252,252,252,28,0,0,0,0,255,239,255,255,127,255,255,183,255,63,255,63,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,31,255,255,255,255,255,255,1,0,0,0,0,0,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,63,255,255,255,255,15,255,62,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,3,0,0,0,0,0,0,0,0,0,0,63,253,255,255,255,255,191,145,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,63,0,255,255,255,3,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,192,0,0,0,0,0,0,0,0,111,240,239,254,255,255,15,0,0,0,0,0,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,255,63,0,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,192,255,0,0,252,255,255,255,255,255,255,1,0,0,255,255,255,1,255,3,255,255,255,255,255,255,199,255,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,30,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,3,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,31,0,255,255,255,255,255,127,0,0,248,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,223,100,222,255,235,239,255,255,255,255,255,255,255,191,231,223,223,255,255,255,123,95,252,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,253,255,255,247,255,255,255,247,255,255,223,255,255,255,223,255,255,127,255,255,255,127,255,255,255,253,255,255,255,253,255,255,247,207,255,255,255,255,255,255,239,255,255,255,150,254,247,10,132,234,150,170,150,247,247,94,255,251,255,15,238,251,255,15,0,0,0,0,0,0,0,0,97,108,110,117,109,0,97,108,112,104,97,0,98,108,97,110,107,0,99,110,116,114,108,0,100,105,103,105,116,0,103,114,97,112,104,0,108,111,119,101,114,0,112,114,105,110,116,0,112,117,110,99,116,0,115,112,97,99,101,0,117,112,112,101,114,0,120,100,105,103,105,116,0,0,0,0,0,0,0,0,18,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,16,16,34,35,16,36,37,38,39,40,41,42,43,16,44,45,46,17,47,48,17,17,49,17,17,17,50,51,52,53,54,55,56,57,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,58,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,59,16,60,61,62,63,64,65,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,66,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,67,16,16,68,16,69,70,71,16,72,16,73,16,16,16,16,74,75,76,77,16,16,78,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,16,16,16,16,82,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,83,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,84,85,86,87,16,16,88,89,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,90,16,91,92,93,94,95,96,97,98,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,254,255,0,252,1,0,0,248,1,0,0,120,0,0,0,0,255,251,223,251,0,0,128,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,252,255,224,175,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,32,64,176,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,134,254,255,255,255,0,64,73,0,0,0,0,0,24,0,223,255,0,200,0,0,0,0,0,0,0,1,0,60,0,0,0,0,0,0,0,0,0,0,0,0,16,224,1,30,0,96,255,191,0,0,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,207,3,0,0,0,3,0,32,255,127,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,0,0,0,16,0,32,30,0,48,0,1,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,252,15,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,3,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,253,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,255,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,63,2,0,0,0,0,0,0,0,0,0,4,0,0,0,0,16,0,0,0,0,0,0,128,0,128,192,223,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,254,255,255,255,0,252,255,255,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,192,255,223,255,7,0,0,0,0,0,0,0,0,0,0,128,6,0,252,0,0,24,62,0,0,128,191,0,204,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,31,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,0,0,24,0,0,0,0,0,0,0,0,0,56,0,0,0,0,16,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,254,127,47,0,0,255,3,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,196,255,255,255,255,0,0,0,192,0,0,0,0,0,0,0,0,1,0,224,159,0,0,0,0,127,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,16,0,0,252,255,255,255,31,0,0,0,0,0,12,0,0,0,0,0,0,64,0,12,240,0,0,0,0,0,0,192,248,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,255,0,255,255,255,33,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,127,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,3,224,0,224,0,224,0,96,128,248,255,255,255,252,255,255,255,255,255,127,31,252,241,127,255,127,0,0,255,255,255,3,0,0,255,255,255,255,1,0,123,3,208,193,175,66,0,12,31,188,255,255,0,0,0,0,0,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,127,0,0,0,255,7,0,0,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,252,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,255,15,0,0,0,0,0,0,0,0,255,255,255,251,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,255,15,30,255,255,255,1,252,193,224,0,0,0,0,0,0,0,0,0,0,0,30,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,255,255,255,255,15,0,0,0,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,0,0,0,0,0,0,192,0,224,0,0,0,0,0,0,0,0,0,0,0,128,15,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,255,255,127,0,3,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,8,0,0,0,15,255,3,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,16,192,0,0,255,255,3,7,0,0,0,0,0,248,0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,8,0,255,63,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,128,11,0,0,0,0,0,0,0,128,2,0,0,192,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,255,255,255,3,127,0,255,255,255,255,247,255,127,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,254,255,0,252,1,0,0,248,1,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,0,48,135,255,255,255,255,255,143,255,0,0,0,0,0,0,224,255,255,7,255,15,0,0,0,0,0,0,255,255,255,255,255,63,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,143,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,255,0,255,1,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,63,252,255,63,0,0,0,3,0,0,0,0,0,0,254,3,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,7,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,255,255,255,255,127,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,127,0,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8,0,0,0,8,0,0,32,0,0,0,32,0,0,128,0,0,0,128,0,0,0,2,0,0,0,2,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,127,254,127,254,255,254,255,0,0,0,0,255,7,255,255,255,127,255,255,255,255,255,255,255,15,255,255,255,255,255,7,0,0,0,0,0,0,0,0,192,255,255,255,7,0,255,255,255,255,255,7,255,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,1,0,191,255,255,255,255,255,255,255,255,31,255,255,15,0,255,255,255,255,223,7,0,0,255,255,1,0,255,255,255,255,255,255,255,127,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,30,255,255,255,255,255,255,255,63,15,0,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,255,255,255,255,255,255,255,255,225,255,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,9,0,0,0,10,0,0,0,13,0,0,0,11,0,0,0,12,0,0,0,133,0,0,0,0,32,0,0,1,32,0,0,2,32,0,0,3,32,0,0,4,32,0,0,5,32,0,0,6,32,0,0,8,32,0,0,9,32,0,0,10,32,0,0,40,32,0,0,41,32,0,0,95,32,0,0,0,48,0,0,0,0,0,0,65,0,32,26,192,0,32,31,0,1,1,47,50,1,1,5,57,1,1,15,74,1,1,45,121,1,1,5,112,3,1,3,145,3,32,17,163,3,32,9,0,4,80,16,16,4,32,32,96,4,1,33,138,4,1,53,193,4,1,13,208,4,1,63,20,5,1,19,49,5,48,38,160,1,1,5,179,1,1,3,205,1,1,15,222,1,1,17,248,1,1,39,34,2,1,17,216,3,1,23,0,30,1,149,160,30,1,95,8,31,248,8,24,31,248,6,40,31,248,8,56,31,248,8,72,31,248,6,104,31,248,8,136,31,248,8,152,31,248,8,168,31,248,8,184,31,248,2,186,31,182,2,200,31,170,4,216,31,248,2,218,31,156,2,232,31,248,2,234,31,144,2,248,31,128,2,250,31,130,2,70,2,1,9,16,5,1,3,96,33,16,16,0,44,48,47,103,44,1,5,128,44,1,99,235,44,1,3,64,166,1,45,128,166,1,23,34,167,1,13,50,167,1,61,121,167,1,3,126,167,1,9,144,167,1,3,160,167,1,9,33,255,32,26,0,0,0,0,73,0,49,1,83,0,127,1,48,1,105,0,120,1,255,0,129,1,83,2,130,1,131,1,132,1,133,1,134,1,84,2,135,1,136,1,137,1,86,2,138,1,87,2,139,1,140,1,142,1,221,1,143,1,89,2,144,1,91,2,145,1,146,1,147,1,96,2,148,1,99,2,150,1,105,2,151,1,104,2,152,1,153,1,156,1,111,2,157,1,114,2,159,1,117,2,166,1,128,2,167,1,168,1,169,1,131,2,172,1,173,1,174,1,136,2,175,1,176,1,177,1,138,2,178,1,139,2,183,1,146,2,184,1,185,1,188,1,189,1,196,1,198,1,196,1,197,1,197,1,198,1,199,1,201,1,199,1,200,1,200,1,201,1,202,1,204,1,202,1,203,1,203,1,204,1,241,1,243,1,241,1,242,1,242,1,243,1,244,1,245,1,246,1,149,1,247,1,191,1,32,2,158,1,134,3,172,3,136,3,173,3,137,3,174,3,138,3,175,3,140,3,204,3,142,3,205,3,143,3,206,3,153,3,69,3,153,3,190,31,163,3,194,3,247,3,248,3,250,3,251,3,96,30,155,30,223,0,223,0,158,30,223,0,89,31,81,31,91,31,83,31,93,31,85,31,95,31,87,31,188,31,179,31,204,31,195,31,236,31,229,31,252,31,243,31,58,2,101,44,59,2,60,2,61,2,154,1,62,2,102,44,65,2,66,2,67,2,128,1,68,2,137,2,69,2,140,2,244,3,184,3,249,3,242,3,253,3,123,3,254,3,124,3,255,3,125,3,192,4,207,4,38,33,201,3,42,33,107,0,43,33,229,0,50,33,78,33,131,33,132,33,96,44,97,44,98,44,107,2,99,44,125,29,100,44,125,2,109,44,81,2,110,44,113,2,111,44,80,2,112,44,82,2,114,44,115,44,117,44,118,44,126,44,63,2,127,44,64,2,242,44,243,44,125,167,121,29,139,167,140,167,141,167,101,2,170,167,102,2,199,16,39,45,205,16,45,45,118,3,119,3,156,3,181,0,146,3,208,3,152,3,209,3,166,3,213,3,160,3,214,3,154,3,240,3,161,3,241,3,149,3,245,3,207,3,215,3,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,240,75,2,0,110,0,0,0,248,75,2,0,114,0,0,0,0,76,2,0,102,0,0,0,8,76,2,0,97,0,0,0,16,76,2,0,101,0,0,0,24,76,2,0,119,0,0,0,32,76,2,0,87,0,0,0,48,76,2,0,115,0,0,0,64,76,2,0,83,0,0,0,80,76,2,0,100,0,0,0,96,76,2,0,68,0,0,0,112,76,2,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,27,0,0,0,0,0,0,0,91,91,58,97,108,110,117,109,58,93,95,93,0,0,0,0,91,94,91,58,97,108,110,117,109,58,93,95,93,0,0,0,91,91,58,115,112,97,99,101,58,93,93,0,0,0,0,0,91,94,91,58,115,112,97,99,101,58,93,93,0,0,0,0,91,91,58,100,105,103,105,116,58,93,93,0,0,0,0,0,91,94,91,58,100,105,103,105,116,58,93,93,0,0,0,0,78,111,32,101,114,114,111,114,0,78,111,32,109,97,116,99,104,0,73,110,118,97,108,105,100,32,114,101,103,101,120,112,0,85,110,107,110,111,119,110,32,99,111,108,108,97,116,105,110,103,32,101,108,101,109,101,110,116,0,85,110,107,110,111,119,110,32,99,104,97,114,97,99,116,101,114,32,99,108,97,115,115,32,110,97,109,101,0,84,114,97,105,108,105,110,103,32,98,97,99,107,115,108,97,115,104,0,73,110,118,97,108,105,100,32,98,97,99,107,32,114,101,102,101,114,101,110,99,101,0,77,105,115,115,105,110,103,32,39,93,39,0,77,105,115,115,105,110,103,32,39,41,39,0,77,105,115,115,105,110,103,32,39,125,39,0,73,110,118,97,108,105,100,32,99,111,110,116,101,110,116,115,32,111,102,32,123,125,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,114,97,110,103,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,112,101,116,105,116,105,111,110,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,0,0,0,37,115,0,0,0,0,0,0,0,0,0,0,248,77,2,0,127,0,0,0,128,0,0,0,95,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,128,78,2,0,208,77,2,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,168,78,2,0,232,77,2,0,0,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,168,78,2,0,8,78,2,0,224,77,2,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,168,78,2,0,64,78,2,0,48,78,2,0,0,0,0,0,0,0,0,0,104,78,2,0,129,0,0,0,130,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,16,0,0,0,10,0,0,0,10,0,0,0,0,0,0,0,240,78,2,0,129,0,0,0,133,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,17,0,0,0,11,0,0,0,11,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,168,78,2,0,200,78,2,0,104,78,2,0,0,0,0,0,0,0,0,0,80,79,2,0,129,0,0,0,134,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,18,0,0,0,12,0,0,0,12,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,168,78,2,0,40,79,2,0,104,78,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,81,2,0,135,0,0,0,136,0,0,0,96,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,168,78,2,0,128,81,2,0,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+142056);




var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  function _llvm_lifetime_end() {}

  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function _pthread_mutex_lock() {}

  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
  
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
  
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
  
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }


  function _lis_solver_create() {
  Module['printErr']('missing function: lis_solver_create'); abort(-1);
  }

  var _emscripten_check_longjmp=true;

  
  function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }

  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var fd = _fileno(stream);
      var ret = _write(fd, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }

  
  var ___strtok_state=0;
  
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
  
  
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
  
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
  
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
  
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }

  function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  
  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    } 
  Module["_saveSetjmp"] = _saveSetjmp;

  
   
  Module["_strlen"] = _strlen;function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      var fd = _fileno(stream);
      return _write(fd, s, _strlen(s));
    }

  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};


  
  function _malloc(bytes) {
      /* Over-allocate to make sure it is byte-aligned by 8.
       * This will leak memory, but this is only the dummy
       * implementation (replaced by dlmalloc normally) so
       * not an issue.
       */
      var ptr = Runtime.dynamicAlloc(bytes + 8);
      return (ptr+8) & 0xFFFFFFF8;
    }
  Module["_malloc"] = _malloc;
  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

   
  Module["_bitshift64Ashr"] = _bitshift64Ashr;

  
  var PTHREAD_SPECIFIC={};function _pthread_setspecific(key, value) {
      if (!(key in PTHREAD_SPECIFIC)) {
        return ERRNO_CODES.EINVAL;
      }
      PTHREAD_SPECIFIC[key] = value;
      return 0;
    }

  function _GC_init() {
  Module['printErr']('missing function: GC_init'); abort(-1);
  }

  var _ceil=Math_ceil;

  function _GC_strdup() {
  Module['printErr']('missing function: GC_strdup'); abort(-1);
  }

  function _GC_malloc_atomic() {
  Module['printErr']('missing function: GC_malloc_atomic'); abort(-1);
  }

  
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }function _isxdigit_l(chr) {
      return _isxdigit(chr); // no locale support yet
    }

  
  function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }
  
  
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  
  function ___errno_location() {
      return ___errno_state;
    }function _perror(s) {
      // void perror(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/perror.html
      var stdout = HEAP32[((_stdout)>>2)];
      if (s) {
        _fputs(s, stdout);
        _fputc(58, stdout);
        _fputc(32, stdout);
      }
      var errnum = HEAP32[((___errno_location())>>2)];
      _puts(_strerror(errnum));
    }

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 
  Module["_memcpy"] = _memcpy;


  function _strstr(ptr1, ptr2) {
      var check = 0, start;
      do {
        if (!check) {
          start = ptr1;
          check = ptr2;
        }
        var curr1 = HEAP8[((ptr1++)|0)];
        var curr2 = HEAP8[((check++)|0)];
        if (curr2 == 0) return start;
        if (curr2 != curr1) {
          // rewind to one character after start, to find ez in eeez
          ptr1 = start + 1;
          check = 0;
        }
      } while (curr1);
      return 0;
    }

   
  Module["_memmove"] = _memmove;

  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }

  function _signal(sig, func) {
      // TODO
      return 0;
    }

  
  
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
  
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
  
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
                if (next === 0) return i > 0 ? fields : fields-1; // we failed to read the full length of this field
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
  
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
  
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
  
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
  
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
  
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
  
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
  
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16);
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text);
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text);
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j];
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }
  
  
  
  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }
  
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }function _fscanf(stream, format, varargs) {
      // int fscanf(FILE *restrict stream, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        return -1;
      }
      var buffer = [];
      function get() {
        var c = _fgetc(stream);
        buffer.push(c);
        return c;
      };
      function unget() {
        _ungetc(buffer.pop(), stream);
      };
      return __scanString(format, get, unget, varargs);
    }

  var _emscripten_preinvoke=true;

  function _pthread_cond_wait() {
      return 0;
    }

  
  
  
  var ___cxa_exception_header_size=8;
  
  function _free() {
  }
  Module["_free"] = _free;function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr - ___cxa_exception_header_size);
      } catch(e) { // XXX FIXME
      }
    }
  
  var ___cxa_last_thrown_exception=0;
  
  var ___cxa_caught_exceptions=[];function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Call destructor if one is registered then clear it.
      var ptr = ___cxa_caught_exceptions.pop();
      if (ptr) {
        header = ptr - ___cxa_exception_header_size;
        var destructor = HEAP32[(((header)+(4))>>2)];
        if (destructor) {
          Runtime.dynCall('vi', destructor, [ptr]);
          HEAP32[(((header)+(4))>>2)]=0;
        }
        ___cxa_free_exception(ptr);
        ___cxa_last_thrown_exception = 0;
      }
    }function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      var ptr = ___cxa_caught_exceptions.pop();
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }function _freopen(filename, mode, stream) {
      // FILE *freopen(const char *restrict filename, const char *restrict mode, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/freopen.html
      if (!filename) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (!streamObj) {
          ___setErrNo(ERRNO_CODES.EBADF);
          return 0;
        }
        if (_freopen.buffer) _free(_freopen.buffer);
        filename = intArrayFromString(streamObj.path);
        filename = allocate(filename, 'i8', ALLOC_NORMAL);
      }
      _fclose(stream);
      return _fopen(filename, mode);
    }

  function _round(x) {
      return (x < 0) ? -Math.round(-x) : Math.round(x);
    }

  
  function _emscripten_get_now() {
      if (!_emscripten_get_now.actual) {
        if (ENVIRONMENT_IS_NODE) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() {
            var t = process['hrtime']();
            return t[0] * 1e3 + t[1] / 1e6;
          }
        } else if (typeof dateNow !== 'undefined') {
          _emscripten_get_now.actual = dateNow;
        } else if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() { return window['performance']['now'](); };
        } else {
          _emscripten_get_now.actual = Date.now;
        }
      }
      return _emscripten_get_now.actual();
    }function _clock_gettime(clk_id, tp) {
      // int clock_gettime(clockid_t clk_id, struct timespec *tp);
      var now;
      if (clk_id === 0) {
        now = Date.now();
      } else {
        now = _emscripten_get_now();
      }
      HEAP32[((tp)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((tp)+(4))>>2)]=Math.floor((now % 1000)*1000*1000); // nanoseconds
      return 0;
    }

  
  function _tmpnam(s, dir, prefix) {
      // char *tmpnam(char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpnam.html
      // NOTE: The dir and prefix arguments are for internal use only.
      var folder = FS.findObject(dir || '/tmp');
      if (!folder || !folder.isFolder) {
        dir = '/tmp';
        folder = FS.findObject(dir);
        if (!folder || !folder.isFolder) return 0;
      }
      var name = prefix || 'file';
      do {
        name += String.fromCharCode(65 + Math.floor(Math.random() * 25));
      } while (name in folder.contents);
      var result = dir + '/' + name;
      if (!_tmpnam.buffer) _tmpnam.buffer = _malloc(256);
      if (!s) s = _tmpnam.buffer;
      writeAsciiToMemory(result, s);
      return s;
    }function _tmpfile() {
      // FILE *tmpfile(void);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpfile.html
      // TODO: Delete the created file on closing.
      if (_tmpfile.mode) {
        _tmpfile.mode = allocate(intArrayFromString('w+'), 'i8', ALLOC_NORMAL);
      }
      return _fopen(_tmpnam(0), _tmpfile.mode);
    }

  
  function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }

  
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = (HEAP32[((tempDoublePtr)>>2)]=HEAP32[(((varargs)+(argIndex))>>2)],HEAP32[(((tempDoublePtr)+(4))>>2)]=HEAP32[(((varargs)+((argIndex)+(4)))>>2)],(+(HEAPF64[(tempDoublePtr)>>3])));
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+4))>>2)]];
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Runtime.getNativeFieldSize(type);
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision < 0) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }


  function _pclose(stream) {
      // int pclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/pclose.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.ECHILD);
      return -1;
    }

   
  Module["_memset"] = _memset;

  var _BDtoILow=true;


   
  Module["_bitshift64Shl"] = _bitshift64Shl;

  var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }function _isdigit_l(chr) {
      return _isdigit(chr); // no locale support yet
    }

  var _emscripten_prep_setjmp=true;


  function _access(path, amode) {
      // int access(const char *path, int amode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/access.html
      path = Pointer_stringify(path);
      if (amode & ~7) {
        // need a valid mode
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      }
      var node;
      try {
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
      var perms = '';
      if (amode & 4) perms += 'r';
      if (amode & 2) perms += 'w';
      if (amode & 1) perms += 'x';
      if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      }
      return 0;
    }

  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }

  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }

  var _emscripten_get_longjmp_result=true;

  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i];
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }

  function _freelocale(locale) {
      _free(locale);
    }

  function _catgets(catd, set_id, msg_id, s) {
      // char *catgets (nl_catd catd, int set_id, int msg_id, const char *s)
      return s;
    }

  function _fmod(x, y) {
      return x % y;
    }

  function _fmax(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.max(x, y);
    }

  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }

  function _GC_malloc() {
  Module['printErr']('missing function: GC_malloc'); abort(-1);
  }

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function _lis_vector_destroy() {
  Module['printErr']('missing function: lis_vector_destroy'); abort(-1);
  }

  
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      ___cxa_caught_exceptions.push(___cxa_last_thrown_exception);
      return ptr;
    }

  function _lis_vector_create() {
  Module['printErr']('missing function: lis_vector_create'); abort(-1);
  }


  var _cos=Math_cos;

  var _fseeko=_fseek;



  function __ZNSt9exceptionD2Ev() {}

  function _lis_solver_destroy() {
  Module['printErr']('missing function: lis_solver_destroy'); abort(-1);
  }

  function _popen(command, mode) {
      // FILE *popen(const char *command, const char *mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/popen.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.EMFILE);
      return 0;
    }

  function _isblank(chr) {
      return chr == 32 || chr == 9;
    }

   
  Module["_strcpy"] = _strcpy;

  function _copysign(a, b) {
      return __reallyNegative(a) === __reallyNegative(b) ? a : -a;
    }

  function _bsearch(key, base, num, size, compar) {
      function cmp(x, y) {
        return Module['dynCall_iii'](compar, x, y);
      };
      var left = 0;
      var right = num;
      var mid, test, addr;
  
      while (left < right) {
        mid = (left + right) >>> 1;
        addr = base + (mid * size);
        test = cmp(key, addr);
        if (test < 0) {
          right = mid;
        } else if (test > 0) {
          left = mid + 1;
        } else {
          return addr;
        }
      }
  
      return 0;
    }

  
  var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key, destructor) {
      if (key == 0) {
        return ERRNO_CODES.EINVAL;
      }
      HEAP32[((key)>>2)]=PTHREAD_SPECIFIC_NEXT_KEY;
      // values start at 0
      PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
      PTHREAD_SPECIFIC_NEXT_KEY++;
      return 0;
    }


  
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  
  
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
  
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
  
      var pattern = Pointer_stringify(format);
  
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
  
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
  
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
  
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
  
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
  
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
  
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
  
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
  
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
  
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
  
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
  
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
  
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
  
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
  
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }

  
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;

  
   
  Module["_rand_r"] = _rand_r;
  
  var ___rand_seed=allocate([0x0273459b, 0, 0, 0], "i32", ALLOC_STATIC); 
  Module["_rand"] = _rand;

  var _llvm_memset_p0i8_i32=_memset;

   
  Module["_i64Subtract"] = _i64Subtract;

   
  Module["_i64Add"] = _i64Add;

  var _pow=Math_pow;

  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  
  function ___resumeException(ptr) {
      if (!___cxa_last_thrown_exception) { ___cxa_last_thrown_exception = ptr; }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = ___cxa_last_thrown_exception;
      header = thrown - ___cxa_exception_header_size;
      if (throwntype == -1) throwntype = HEAP32[((header)>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
  
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      var header = ptr - ___cxa_exception_header_size;
      HEAP32[((header)>>2)]=type;
      HEAP32[(((header)+(4))>>2)]=destructor;
      ___cxa_last_thrown_exception = ptr;
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }


  
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }

  function _htonl(value) {
      return ((value & 0xff) << 24) + ((value & 0xff00) << 8) +
             ((value & 0xff0000) >>> 8) + ((value & 0xff000000) >>> 24);
    }


   
  Module["_strncpy"] = _strncpy;

  function _strtoull_l(str, endptr, base) {
      return _strtoull(str, endptr, base); // no locale support yet
    }

  function ___assert_fail(condition, filename, line, func) {
      ABORT = true;
      throw 'Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'] + ' at ' + stackTrace();
    }

  var _emscripten_postinvoke=true;

  var _copysignl=_copysign;

  
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }function _strtoll_l(str, endptr, base) {
      return _strtoll(str, endptr, base); // no locale support yet
    }

  function _qsort(base, num, size, cmp) {
      if (num == 0 || size == 0) return;
      // forward calls to the JavaScript sort method
      // first, sort the items logically
      var keys = [];
      for (var i = 0; i < num; i++) keys.push(i);
      keys.sort(function(a, b) {
        return Module['dynCall_iii'](cmp, base+a*size, base+b*size);
      });
      // apply the sort
      var temp = _malloc(num*size);
      _memcpy(temp, base, num*size);
      for (var i = 0; i < num; i++) {
        if (keys[i] == i) continue; // already in place
        _memcpy(base+i*size, temp+keys[i]*size, size);
      }
      _free(temp);
    }

  function _system(command) {
      // int system(const char *command);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/system.html
      // Can't call external programs.
      ___setErrNo(ERRNO_CODES.EAGAIN);
      return -1;
    }

  var _putc=_fputc;

  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }

   
  Module["_bitshift64Lshr"] = _bitshift64Lshr;

  function _srand(seed) {
      HEAP32[((___rand_seed)>>2)]=seed
    }

  function _isatty(fildes) {
      // int isatty(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/isatty.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      // HACK - implement tcgetattr
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return 0;
      }
      return 1;
    }

  var _BDtoIHigh=true;

  function _pthread_cond_broadcast() {
      return 0;
    }

  
  
   
  Module["_testSetjmp"] = _testSetjmp;function _longjmp(env, value) {
      asm['setThrew'](env, value || 1);
      throw 'longjmp';
    }function _emscripten_longjmp(env, value) {
      _longjmp(env, value);
    }

  function __ZSt9terminatev() {
      _exit(-1234);
    }

  function _lis_matrix_set_value() {
  Module['printErr']('missing function: lis_matrix_set_value'); abort(-1);
  }

  function _vfprintf(s, f, va_arg) {
      return _fprintf(s, f, HEAP32[((va_arg)>>2)]);
    }

  
  function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }var _atol=_atoi;

  function _pthread_mutex_unlock() {}

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }



  var _BItoD=true;

  
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000);
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000);
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000);
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fstat(fildes, buf) {
      // int fstat(int fildes, struct stat *buf);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/fstat.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      return _stat(stream.path, buf);
    }

  function _catclose(catd) {
      // int catclose (nl_catd catd)
      return 0;
    }

  function _llvm_lifetime_start() {}

  function ___cxa_guard_release() {}


  
  function _truncate(path, length) {
      // int truncate(const char *path, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/truncate.html
      // NOTE: The path argument may be a string, to simplify ftruncate().
      if (typeof path !== 'string') path = Pointer_stringify(path);
      try {
        FS.truncate(path, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _ftruncate(fildes, length) {
      // int ftruncate(int fildes, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftruncate.html
      try {
        FS.ftruncate(fildes, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  function _uselocale(locale) {
      return 0;
    }

  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }


  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }

  var _llvm_memmove_p0i8_p0i8_i32=_memmove;

  var _ftello=_ftell;

  function _strftime_l(s, maxsize, format, tm) {
      return _strftime(s, maxsize, format, tm); // no locale support yet
    }

  function _abort() {
      Module['abort']();
    }





  function _pthread_getspecific(key) {
      return PTHREAD_SPECIFIC[key] || 0;
    }

  var _fabs=Math_abs;

  var _floor=Math_floor;

  var _getc=_fgetc;

  var _sqrt=Math_sqrt;

  function _rewind(stream) {
      // void rewind(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rewind.html
      _fseek(stream, 0, 0);  // SEEK_SET.
      var streamObj = FS.getStreamFromPtr(stream);
      if (streamObj) streamObj.error = false;
    }

  function ___cxa_allocate_exception(size) {
      var ptr = _malloc(size + ___cxa_exception_header_size);
      return ptr + ___cxa_exception_header_size;
    }

  var _sin=Math_sin;

  var _fmodl=_fmod;



  function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }

  function _catopen(name, oflag) {
      // nl_catd catopen (const char *name, int oflag)
      return -1;
    }

  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_vector_set_size() {
  Module['printErr']('missing function: lis_vector_set_size'); abort(-1);
  }

  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = Pointer_stringify(path);
      try {
        FS.unlink(path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  var _emscripten_setjmp=true;

  function _GC_collect_a_little() {
  Module['printErr']('missing function: GC_collect_a_little'); abort(-1);
  }


  function _lis_solver_set_option() {
  Module['printErr']('missing function: lis_solver_set_option'); abort(-1);
  }

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  var __ZTISt9exception=allocate([allocate([1,0,0,0,0,0,0], "i8", ALLOC_STATIC)+8, 0], "i32", ALLOC_STATIC);

  var ___dso_handle=allocate(1, "i32*", ALLOC_STATIC);



FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
___strtok_state = Runtime.staticAlloc(4);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vd(index,a1) {
  try {
    Module["dynCall_vd"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) {
  try {
    return Module["dynCall_iiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidddd(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viidddd"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_idii(index,a1,a2,a3) {
  try {
    return Module["dynCall_idii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viidii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_diidddd(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_diidddd"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.___rand_seed|0;var p=env.__ZTISt9exception|0;var q=env.___dso_handle|0;var r=env._stderr|0;var s=env._stdin|0;var t=env._stdout|0;var u=0;var v=0;var w=0;var x=0;var y=+env.NaN,z=+env.Infinity;var A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=global.Math.floor;var U=global.Math.abs;var V=global.Math.sqrt;var W=global.Math.pow;var X=global.Math.cos;var Y=global.Math.sin;var Z=global.Math.tan;var _=global.Math.acos;var $=global.Math.asin;var aa=global.Math.atan;var ba=global.Math.atan2;var ca=global.Math.exp;var da=global.Math.log;var ea=global.Math.ceil;var fa=global.Math.imul;var ga=env.abort;var ha=env.assert;var ia=env.asmPrintInt;var ja=env.asmPrintFloat;var ka=env.min;var la=env.invoke_iiiiiiii;var ma=env.invoke_viiiii;var na=env.invoke_iiiiidiii;var oa=env.invoke_vd;var pa=env.invoke_vi;var qa=env.invoke_vii;var ra=env.invoke_iiiiiiiiiii;var sa=env.invoke_ii;var ta=env.invoke_iiiiiiiiiiiiii;var ua=env.invoke_viidddd;var va=env.invoke_iiii;var wa=env.invoke_iiiiiiiiiiiiiiiiiiiiiii;var xa=env.invoke_iiiiiiiiiiiiiiiiiiiii;var ya=env.invoke_idii;var za=env.invoke_viiiiid;var Aa=env.invoke_viiiiiiii;var Ba=env.invoke_viiiiii;var Ca=env.invoke_viidii;var Da=env.invoke_iid;var Ea=env.invoke_viiiiiii;var Fa=env.invoke_viiiiiid;var Ga=env.invoke_viiiiiiiii;var Ha=env.invoke_iii;var Ia=env.invoke_iiiiii;var Ja=env.invoke_iiiiidi;var Ka=env.invoke_diidddd;var La=env.invoke_i;var Ma=env.invoke_iiiiiiiiii;var Na=env.invoke_viii;var Oa=env.invoke_v;var Pa=env.invoke_iiiiiiiii;var Qa=env.invoke_iiiii;var Ra=env.invoke_viiii;var Sa=env._fabs;var Ta=env._strrchr;var Ua=env._vsscanf;var Va=env.__ZSt9terminatev;var Wa=env.___cxa_guard_acquire;var Xa=env.__reallyNegative;var Ya=env._fstat;var Za=env._pclose;var _a=env._lis_solver_create;var $a=env.___assert_fail;var ab=env.__ZSt18uncaught_exceptionv;var bb=env._longjmp;var cb=env.__isLeapYear;var db=env._clock_gettime;var eb=env._fsync;var fb=env._signal;var gb=env._GC_collect_a_little;var hb=env._sbrk;var ib=env._strtoull;var jb=env._emscripten_memcpy_big;var kb=env.__parseInt64;var lb=env._close;var mb=env._rewind;var nb=env._cos;var ob=env._fileno;var pb=env._fread;var qb=env._puts;var rb=env._isatty;var sb=env._lis_matrix_set_value;var tb=env._write;var ub=env._isblank;var vb=env._ftell;var wb=env.__ZNSt9exceptionD2Ev;var xb=env._round;var yb=env.___cxa_does_inherit;var zb=env._strtoll_l;var Ab=env._strstr;var Bb=env.___cxa_rethrow;var Cb=env._llvm_lifetime_end;var Db=env._catclose;var Eb=env._tmpnam;var Fb=env._lis_vector_destroy;var Gb=env._lis_solver_set_option;var Hb=env._tmpfile;var Ib=env._send;var Jb=env._pow;var Kb=env.___cxa_is_number_type;var Lb=env.___cxa_free_exception;var Mb=env.___cxa_find_matching_catch;var Nb=env._isxdigit_l;var Ob=env.___cxa_guard_release;var Pb=env._truncate;var Qb=env._strtol;var Rb=env._sin;var Sb=env._strtok;var Tb=env.___setErrNo;var Ub=env._newlocale;var Vb=env._isdigit_l;var Wb=env.___resumeException;var Xb=env._freelocale;var Yb=env._srand;var Zb=env._fscanf;var _b=env._qsort;var $b=env._putchar;var ac=env._floor;var bc=env._pthread_mutex_unlock;var cc=env._printf;var dc=env._sprintf;var ec=env._fopen;var fc=env._strtok_r;var gc=env._emscripten_get_now;var hc=env._stat;var ic=env._vsnprintf;var jc=env._strtoull_l;var kc=env._read;var lc=env.__addDays;var mc=env._fwrite;var nc=env._time;var oc=env._pthread_mutex_lock;var pc=env._catopen;var qc=env._exit;var rc=env._GC_strdup;var sc=env._freopen;var tc=env.___ctype_b_loc;var uc=env._fmod;var vc=env._vasprintf;var wc=env._lseek;var xc=env._access;var yc=env._vfprintf;var zc=env.___cxa_allocate_exception;var Ac=env._atoi;var Bc=env._strtoll;var Cc=env._pwrite;var Dc=env._localtime_r;var Ec=env._tzset;var Fc=env._open;var Gc=env._uselocale;var Hc=env._snprintf;var Ic=env.___errno_location;var Jc=env._GC_malloc;var Kc=env.___cxa_end_catch;var Lc=env._perror;var Mc=env.___cxa_begin_catch;var Nc=env._strftime;var Oc=env._ftruncate;var Pc=env._GC_init;var Qc=env._fseek;var Rc=env._isxdigit;var Sc=env._fclose;var Tc=env.__parseInt;var Uc=env._pthread_key_create;var Vc=env._pthread_cond_broadcast;var Wc=env._popen;var Xc=env._recv;var Yc=env._fgetc;var Zc=env._sysconf;var _c=env.__getFloat;var $c=env._abort;var ad=env._ceil;var bd=env._isspace;var cd=env._localtime;var dd=env._pthread_getspecific;var ed=env._pthread_cond_wait;var fd=env._llvm_lifetime_start;var gd=env._ungetc;var hd=env._system;var id=env._fmax;var jd=env._fflush;var kd=env._strftime_l;var ld=env._fprintf;var md=env._sscanf;var nd=env._catgets;var od=env._strdup;var pd=env._asprintf;var qd=env.__exit;var rd=env.___ctype_toupper_loc;var sd=env._bsearch;var td=env.__arraySum;var ud=env.__formatString;var vd=env._htonl;var wd=env.___ctype_tolower_loc;var xd=env._unlink;var yd=env._fputs;var zd=env._GC_malloc_atomic;var Ad=env._pread;var Bd=env._lis_vector_set_size;var Cd=env._mkport;var Dd=env.__scanString;var Ed=env._pthread_setspecific;var Fd=env._copysign;var Gd=env._fputc;var Hd=env.___cxa_throw;var Id=env._lis_solver_destroy;var Jd=env._isdigit;var Kd=env._strerror;var Ld=env._emscripten_longjmp;var Md=env._lis_vector_create;var Nd=env._atexit;var Od=env._sqrt;var Pd=env._strerror_r;var Qd=0.0;
// EMSCRIPTEN_START_FUNCS
function ws(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Rr(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[55760+((d[55504+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Rr(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=29;break b;break};case 6:{n=32;break b;break};case 7:{n=35;break b;break};case 18:{n=38;break b;break};case 29:{if((c[55760+((d[57040+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function xs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=120){break}k=ys(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Rr(a[g]|0,a[b+1|0]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Rr(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function ys(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=Rr(a[g]|0,a[b+1|0]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Rr(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function zs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Rr(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[55760+((d[55504+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 15:{k=Cs(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 17:{k=Ds(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Rr(a[g]|0,a[b+1|0]|0)|0}if((n|0)==27){k=As(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=Bs(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b]|0)==0){p=d[j+76+(d[m+1|0]|0)|0]|0}else{p=Rr(a[m]|0,a[b+1|0]|0)|0}switch(p|0){case 11:{o=90;break b;break};case 17:{break b;break};case 29:{if((c[55760+((d[57040+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=37;break b}break};case 7:{o=45;break b;break};case 10:case 9:case 21:{o=69;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=Rr(a[m]|0,a[b+1|0]|0)|0}switch(q|0){case 5:{o=59;break b;break};case 6:{o=62;break b;break};case 7:{o=65;break b;break};case 29:{if((c[55760+((d[55504+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=57;break b}break};case 24:case 22:{break};default:{o=68;break b}}b=b+2|0;continue b;break};case 5:{o=39;break b;break};case 6:{o=42;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b]|0)==0){r=d[j+76+(d[q+1|0]|0)|0]|0}else{r=Rr(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 11:{o=90;break c;break};case 5:{o=78;break d;break};case 17:{break c;break};case 24:case 22:{break d;break};case 7:{o=84;break d;break};case 10:case 9:case 21:{break};case 6:{o=81;break d;break};case 29:{o=75;break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[55760+((d[55504+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=Es(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function As(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=Rr(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b]|0)!=0){continue b}if((a[b+1|0]|0)==45){l=25;break b}else{continue b}break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function Bs(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k]|0)!=0){l=7;break}if((a[g+1|0]|0)!=(a[58080+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function Cs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b]|0)==0){o=d[k+76+(d[n+1|0]|0)|0]|0}else{o=Rr(a[n]|0,a[b+1|0]|0)|0}a:do{switch(o|0){case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[55760+((d[55504+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 24:case 22:{break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=Rr(a[o]|0,a[b+1|0]|0)|0}switch(q|0){case 5:{p=28;break b;break};case 7:{p=34;break b;break};case 15:{p=62;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 10:case 9:case 21:{p=37;break b;break};case 29:{if((c[55760+((d[57040+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=26;break b}break};case 6:{p=31;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((Fs(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b]|0)==0){r=d[k+76+(d[q+1|0]|0)|0]|0}else{r=Rr(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 8:case 1:case 0:{p=54;break c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b]|0)!=0){continue c}if((a[b+1|0]|0)==62){p=59;break c}else{continue c}break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((Fs(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=0){break}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function Ds(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Rr(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[55760+((d[55504+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Rr(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 7:{n=34;break b;break};case 10:case 9:case 21:{n=37;break b;break};case 6:{n=31;break b;break};case 5:{n=28;break b;break};case 11:{n=48;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 23:{b=b+2|0;continue b;break};case 29:{if((c[55760+((d[57040+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Rr(a[o]|0,a[b+1|0]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function Es(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){m=d[k+76+(d[b+1|0]|0)|0]|0}else{m=Rr(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b:do{switch(m|0){case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){n=d[k+76+(d[b+1|0]|0)|0]|0}else{n=Rr(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(n|0){case 6:{l=33;break a;break};case 7:{l=36;break a;break};case 5:{l=30;break a;break};case 29:{if((c[55760+((d[55504+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=28;break a}break};case 24:case 22:{break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 29:{if((c[55760+((d[57040+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 6:{l=13;break a;break};case 7:{l=16;break a;break};case 5:{l=10;break a;break};case 14:{break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){o=d[k+76+(d[b+1|0]|0)|0]|0}else{o=Rr(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){q=d[k+76+(d[p+1|0]|0)|0]|0}else{q=Rr(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){s=d[k+76+(d[p+1|0]|0)|0]|0}else{s=Rr(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 2:{l=79;break a;break};case 3:{t=vs(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 8:case 1:case 0:{l=74;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){u=d[k+76+(d[p+1|0]|0)|0]|0}else{u=Rr(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(u|0){case 11:{l=106;break a;break};case 17:{l=107;break a;break};case 10:case 9:case 21:{break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){v=d[k+76+(d[p+1|0]|0)|0]|0}else{v=Rr(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(v|0){case 11:{l=106;break a;break};case 7:{l=103;break a;break};case 24:case 22:{break d;break};case 6:{l=100;break a;break};case 5:{l=97;break a;break};case 17:{l=107;break a;break};case 29:{l=94;break d;break};case 10:case 9:case 21:{break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[55760+((d[55504+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[c[j>>2]|0]|0)==0){if((a[(c[j>>2]|0)+1|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function Fs(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g]|0)==0){k=a[g+1|0]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){l=a[g+1|0]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){m=a[g+1|0]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function Gs(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e]|0)==0){m=d[b+76+(d[h+1|0]|0)|0]|0}else{m=Rr(a[h]|0,a[e+1|0]|0)|0}h=m;switch(h|0){case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 8:case 1:case 0:{l=16;break a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e]|0)==0){p=d[b+76+(d[g+1|0]|0)|0]|0}else{p=Rr(a[g]|0,a[e+1|0]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function Hs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Rr(a[g]|0,a[b+1|0]|0)|0}if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b]|0)==0){o=d[j+76+(d[g+1|0]|0)|0]|0}else{o=Rr(a[g]|0,a[b+1|0]|0)|0}switch(o|0){case 10:case 9:case 21:{break a;break};case 30:{n=16;break a;break};case 24:case 22:{break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+2|0]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Rr(a[o]|0,a[b+3|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==27){k=As(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function Is(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Rr(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[55760+((d[55504+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Rr(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 6:{n=31;break b;break};case 29:{if((c[55760+((d[57040+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=34;break b;break};case 5:{n=28;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function Js(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 20:{c[f>>2]=b+1;k=25;l=k;i=h;return l|0};case 35:{c[f>>2]=b+1;k=38;l=k;i=h;return l|0};case 12:{k=rt(12,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 31:{c[f>>2]=b+1;k=23;l=k;i=h;return l|0};case 32:{b=b+1|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 15:{c[f>>2]=b+1;k=35;l=k;i=h;return l|0};case 33:{c[f>>2]=b+1;k=36;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 34:{c[f>>2]=b+1;k=37;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 10:case 21:{m=15;break};case 11:{c[f>>2]=b+1;k=17;l=k;i=h;return l|0};case 36:{c[f>>2]=b+1;k=21;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==93){if((b+1|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 24:case 22:{n=18;b=b+1|0;break};case 19:{k=tt(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}if((le[c[j+344>>2]&63](j,b)|0)!=0){b=b+2|0;n=18;break a}g=b;if((le[c[j+332>>2]&63](j,b)|0)!=0){b=g+2|0;n=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}if((le[c[j+348>>2]&63](j,b)|0)!=0){b=b+3|0;n=18;break a}g=b;if((le[c[j+336>>2]&63](j,b)|0)!=0){b=g+3|0;n=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 9:{if((b+1|0)!=(e|0)){m=15;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{n=19;b=b+1|0;break};case 13:{k=rt(13,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}if((le[c[j+352>>2]&63](j,b)|0)!=0){b=b+4|0;n=18;break a}g=b;if((le[c[j+340>>2]&63](j,b)|0)!=0){b=g+4|0;n=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 30:{k=ht(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 2:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 16:{k=st(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=nt(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -1;k=29;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);if((m|0)==15){while(1){m=0;b=b+1|0;o=b;if((b|0)==(e|0)){m=19;break}g=d[j+76+(d[o]|0)|0]|0;if((g|0)==10|(g|0)==21){m=15;continue}else if((g|0)!=9){m=18;break}if((b+1|0)!=(e|0)){m=15}else{m=18;break}}if((m|0)==18){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((m|0)==19){c[f>>2]=o;k=15;l=k;i=h;return l|0}}b:while(1){if((b|0)==(e|0)){m=120;break}switch(d[j+76+(d[b]|0)|0]|0){case 23:{b=b+1|0;o=n;if((o|0)==41){n=19;continue b}else if((o|0)!=18){continue b}if((b|0)==(e|0)){m=89;break b}n=41;switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){m=104;break b}p=b;if((le[c[j+340>>2]&63](j,b)|0)==0){m=106;break b}b=p+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 5:{if((e-b|0)<2){m=94;break b}q=b;if((le[c[j+332>>2]&63](j,b)|0)==0){m=96;break b}b=q+2|0;continue b;break};case 29:{m=91;break b;break};case 6:{if((e-b|0)<3){m=99;break b}r=b;if((le[c[j+336>>2]&63](j,b)|0)==0){m=101;break b}b=r+3|0;continue b;break};default:{n=19;continue b}}break};case 7:{if((e-b|0)<4){m=82;break b}s=b;if((le[c[j+340>>2]&63](j,b)|0)==0){m=84;break b}b=s+4|0;continue b;break};case 6:{if((e-b|0)<3){m=77;break b}t=b;if((le[c[j+336>>2]&63](j,b)|0)==0){m=79;break b}b=t+3|0;continue b;break};case 5:{if((e-b|0)<2){m=72;break b}u=b;if((le[c[j+332>>2]&63](j,b)|0)==0){m=74;break b}b=u+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 33:{m=113;break b;break};case 29:{m=69;break b;break};case 34:{m=110;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{m=86;break b;break};case 15:{m=116;break b;break};default:{m=119;break b}}}if((m|0)==69){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==72){k=-2;l=k;i=h;return l|0}else if((m|0)==74){c[f>>2]=u;k=0;l=k;i=h;return l|0}else if((m|0)==77){k=-2;l=k;i=h;return l|0}else if((m|0)==79){c[f>>2]=t;k=0;l=k;i=h;return l|0}else if((m|0)==82){k=-2;l=k;i=h;return l|0}else if((m|0)==84){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==86){c[f>>2]=b;k=n;l=k;i=h;return l|0}else if((m|0)==89){k=-1;l=k;i=h;return l|0}else if((m|0)==91){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==94){k=-2;l=k;i=h;return l|0}else if((m|0)==96){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==99){k=-2;l=k;i=h;return l|0}else if((m|0)==101){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-2;l=k;i=h;return l|0}else if((m|0)==106){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==110){p=b;if((n|0)==19){c[f>>2]=p;k=0;l=k;i=h;return l|0}else{c[f>>2]=p+1;k=32;l=k;i=h;return l|0}}else if((m|0)==113){p=b;if((n|0)==19){c[f>>2]=p;k=0;l=k;i=h;return l|0}else{c[f>>2]=p+1;k=31;l=k;i=h;return l|0}}else if((m|0)==116){p=b;if((n|0)==19){c[f>>2]=p;k=0;l=k;i=h;return l|0}else{c[f>>2]=p+1;k=30;l=k;i=h;return l|0}}else if((m|0)==119){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==120){k=0-n|0;l=k;i=h;return l|0}return 0}function Ks(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((le[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 2:{k=kt(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((le[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((le[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 3:{k=gt(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=60;break}switch(d[j+76+(d[m]|0)|0]|0){case 4:{if((b+1|0)==(e|0)){n=58;break b}g=b;if((a[b+1|0]|0)!=93){b=g+1|0;continue b}if((g+2|0)==(e|0)){n=58;break b}o=b;if((a[b+2|0]|0)==62){n=57;break b}b=o+1|0;continue b;break};case 6:{if((e-b|0)<3){n=45;break b}if((le[c[j+360>>2]&63](j,b)|0)!=0){n=45;break b}b=b+3|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{n=58;break b;break};case 7:{if((e-b|0)<4){n=49;break b}if((le[c[j+364>>2]&63](j,b)|0)!=0){n=49;break b}b=b+4|0;continue b;break};case 5:{if((e-b|0)<2){n=41;break b}if((le[c[j+356>>2]&63](j,b)|0)!=0){n=41;break b}b=b+2|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==41){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==45){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==57){c[f>>2]=o+2;k=0;l=k;i=h;return l|0}else if((n|0)==58){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==60){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Ls(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((le[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g+1;k=40;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((le[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((le[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=51;break}switch(d[j+76+(d[m]|0)|0]|0){case 5:{if((e-b|0)<2){n=39;break b}if((le[c[j+356>>2]&63](j,b)|0)!=0){n=39;break b}b=b+2|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{n=49;break b;break};case 6:{if((e-b|0)<3){n=43;break b}if((le[c[j+360>>2]&63](j,b)|0)!=0){n=43;break b}b=b+3|0;continue b;break};case 7:{if((e-b|0)<4){n=47;break b}if((le[c[j+364>>2]&63](j,b)|0)!=0){n=47;break b}b=b+4|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==39){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==43){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==47){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==51){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Ms(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;g=0;a:while(1){if((b|0)==(e|0)){k=37;break}switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){k=5;break a}l=b;if((le[c[j+356>>2]&63](j,b)|0)!=0){k=7;break a}b=l+2|0;continue a;break};case 2:{m=b+1|0;b=m;if((m|0)==(e|0)){k=21;break a}if((a[b]|0)!=33){continue a}m=b+1|0;b=m;if((m|0)==(e|0)){k=24;break a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+1|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 6:{if((e-b|0)<3){k=10;break a}n=b;if((le[c[j+360>>2]&63](j,b)|0)!=0){k=12;break a}b=n+3|0;continue a;break};case 4:{m=b+1|0;b=m;if((m|0)==(e|0)){k=28;break a}if((a[b]|0)!=93){continue a}m=b+1|0;b=m;if((m|0)==(e|0)){k=31;break a}if((a[b]|0)!=62){continue a}b=b+1|0;if((g|0)==0){k=34;break a}g=g+ -1|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}o=b;if((le[c[j+364>>2]&63](j,b)|0)!=0){k=17;break a}b=o+4|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){p=-2;q=p;i=h;return q|0}else if((k|0)==7){c[f>>2]=l;p=0;q=p;i=h;return q|0}else if((k|0)==10){p=-2;q=p;i=h;return q|0}else if((k|0)==12){c[f>>2]=n;p=0;q=p;i=h;return q|0}else if((k|0)==15){p=-2;q=p;i=h;return q|0}else if((k|0)==17){c[f>>2]=o;p=0;q=p;i=h;return q|0}else if((k|0)==19){c[f>>2]=b;p=0;q=p;i=h;return q|0}else if((k|0)==21){p=-1;q=p;i=h;return q|0}else if((k|0)==24){p=-1;q=p;i=h;return q|0}else if((k|0)==28){p=-1;q=p;i=h;return q|0}else if((k|0)==31){p=-1;q=p;i=h;return q|0}else if((k|0)==34){c[f>>2]=b;p=42;q=p;i=h;return q|0}else if((k|0)==37){p=-1;q=p;i=h;return q|0}return 0}function Ns(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=27;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 21:{m=23;break a;break};case 10:{m=13;break a;break};case 6:{a=a+3|0;continue a;break};case 9:{m=16;break a;break};case 7:{a=a+4|0;continue a;break};case 2:{m=12;break a;break};case 3:{m=9;break a;break};case 5:{a=a+2|0;continue a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=gt(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((m|0)==13){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==16){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==23){h=a;if((a|0)==(f|0)){c[e>>2]=h+1;j=39;k=j;i=g;return k|0}else{c[e>>2]=h;j=6;k=j;i=g;return k|0}}else if((m|0)==27){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function Os(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+56|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=26;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 6:{a=a+3|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 30:{m=12;break a;break};case 10:{m=15;break a;break};case 9:{m=18;break a;break};case 3:{m=9;break a;break};case 5:{a=a+2|0;continue a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=gt(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){if((a|0)==(f|0)){n=ht(h,a+1|0,b,e)|0;j=(n|0)==22?0:n;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==15){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==18){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==26){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function Ps(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){switch(d[g+76+(d[b]|0)|0]|0){case 7:{e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=4;break a}else{j=5}break};case 6:{j=5;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{h=c;c=h+1|0;e=b;b=e+1|0;if((a[h]|0)!=(a[e]|0)){j=12;break a}else{continue a}break};case 5:{break};default:{j=13;break a}}if((j|0)==5){j=0;e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=6;break}}h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=8;break}e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=10;break}}if((j|0)==4){k=0;l=k;i=f;return l|0}else if((j|0)==6){k=0;l=k;i=f;return l|0}else if((j|0)==8){k=0;l=k;i=f;return l|0}else if((j|0)==10){k=0;l=k;i=f;return l|0}else if((j|0)==12){k=0;l=k;i=f;return l|0}else if((j|0)==13){if((a[b]|0)==(a[c]|0)){k=1;l=k;i=f;return l|0}switch(d[g+76+(d[c]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{k=0;l=k;i=f;return l|0};default:{k=1;l=k;i=f;return l|0}}}return 0}function Qs(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=8;break}if(g){h=4;break}if((a[f]|0)!=(a[d]|0)){h=6;break}f=f+1|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==6){j=0;k=j;i=b;return k|0}else if((h|0)==8){j=g&1;k=j;i=b;return k|0}return 0}function Rs(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+24|0;e=a;a=b;b=a;a:while(1){switch(d[e+76+(d[a]|0)|0]|0|0){case 7:{a=a+4|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{a=a+1|0;continue a;break};case 5:{a=a+2|0;continue a;break};case 6:{a=a+3|0;continue a;break};default:{break a}}}i=c;return a-b|0}function Ss(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+16|0;e=a;a=b;while(1){b=d[e+76+(d[a]|0)|0]|0;if(!((b|0)==21|(b|0)==9|(b|0)==10)){break}a=a+1|0}i=c;return a|0}function Ts(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+1|0;a:while(1){b:do{switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+3|0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)!=32){break}if((a[b+1|0]|0)==32){break}if((d[j+76+(d[b+1|0]|0)|0]|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 17:case 11:{if((g|0)!=2){break a}break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};default:{}}}while(0);b=b+1|0}i=h;return k|0}function Us(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=c;c=0;d=d+2|0;a:do{if((a[d]|0)==120){d=d+1|0;while(1){if(!((a[d]|0)==59^1)){break a}e=a[d]|0;switch(e|0){case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(e-97))|0;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(e-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|e-48;break};default:{}}if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}else{while(1){if(!((a[d]|0)==59^1)){break a}c=c*10|0;c=c+((a[d]|0)-48)|0;if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}}while(0);f=dr(c)|0;g=f;i=b;return g|0}function Vs(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+32|0;e=c;c=(d-e|0)/1|0;do{if((c|0)==2){if((a[e+1|0]|0)!=116){break}d=a[e]|0;if((d|0)==103){f=62;g=f;i=b;return g|0}else if((d|0)==108){f=60;g=f;i=b;return g|0}else{break}}else if((c|0)==3){if((a[e]|0)!=97){break}e=e+1|0;if((a[e]|0)!=109){break}e=e+1|0;if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}else if((c|0)==4){d=a[e]|0;if((d|0)==97){e=e+1|0;if((a[e]|0)!=112){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else if((d|0)==113){e=e+1|0;if((a[e]|0)!=117){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else{break}}}while(0);f=0;g=f;i=b;return g|0}function Ws(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=a;a=b;b=e;e=f;while(1){if(!(a>>>0<b>>>0)){break}switch(d[h+76+(d[a]|0)|0]|0|0){case 9:{f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;do{if((a|0)!=(b|0)){if((d[h+76+(d[a]|0)|0]|0|0)!=10){break}a=a+1|0}}while(0);c[e+4>>2]=-1;break};case 5:{a=a+2|0;break};case 7:{a=a+4|0;break};case 6:{a=a+3|0;break};case 10:{c[e+4>>2]=-1;f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;break};default:{a=a+1|0}}f=e+4|0;c[f>>2]=(c[f>>2]|0)+1}i=g;return}function Xs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+1|0;e=e+ -1|0;a:while(1){if((b|0)==(e|0)){k=10;break}switch(d[j+76+(d[b]|0)|0]|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 22:case 26:{if((a[b]&-128|0)!=0){k=7}break};case 21:{if((a[b]|0)==9){k=5;break a}break};default:{k=7}}if((k|0)==7){k=0;g=a[b]|0;if(!((g|0)==64|(g|0)==36)){k=8;break}}b=b+1|0}if((k|0)==5){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==8){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==10){l=1;m=l;i=h;return m|0}return 0}function Ys(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+56|0;h=d;d=e;e=f;f=g;a:do{if((d-(c[h>>2]|0)|0)>(f-(c[e>>2]|0)|0)){d=(c[h>>2]|0)+(f-(c[e>>2]|0))|0;while(1){if(!(d>>>0>(c[h>>2]|0)>>>0)){break a}if((a[d+ -1|0]&192|0)!=128){break a}d=d+ -1|0}}}while(0);f=c[e>>2]|0;g=c[h>>2]|0;while(1){j=g;if((g|0)==(d|0)){break}a[f]=a[j]|0;g=g+1|0;f=f+1|0}c[h>>2]=j;c[e>>2]=f;i=b;return}function Zs(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+64|0;l=e;e=f;f=g;g=h;h=j;j=c[g>>2]|0;m=c[e>>2]|0;while(1){if((m|0)==(f|0)){n=10;break}if((j|0)==(h|0)){n=10;break}o=d[l+76+(d[m]|0)|0]|0;if((o|0)==7){if((j+2|0)==(h|0)){n=10;break}p=(a[m]&7)<<18|(a[m+1|0]&63)<<12|(a[m+2|0]&63)<<6|a[m+3|0]&63;p=p-65536|0;b[j>>1]=p>>>10|55296;b[j+2>>1]=p&1023|56320;j=j+4|0;m=m+4|0;continue}else if((o|0)==6){p=j;j=p+2|0;b[p>>1]=(a[m]&15)<<12|(a[m+1|0]&63)<<6|a[m+2|0]&63;m=m+3|0;continue}else if((o|0)==5){o=j;j=o+2|0;b[o>>1]=(a[m]&31)<<6|a[m+1|0]&63;m=m+2|0;continue}else{o=m;m=o+1|0;p=j;j=p+2|0;b[p>>1]=a[o]|0;continue}}if((n|0)==10){c[e>>2]=m;c[g>>2]=j;i=k;return}}function _s(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[55760+(((d[57040+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function $s(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[55760+(((d[57040+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function at(a,b){a=a|0;b=b|0;b=i;i=i+16|0;i=b;return 0}function bt(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[55760+(((d[55504+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function ct(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[55760+(((d[55504+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function dt(b,c){b=b|0;c=c|0;var e=0,f=0;b=i;i=i+16|0;e=c;do{if((d[e]|0|0)<194){f=1}else{if((a[e+1|0]&128|0)==0){f=1;break}f=(a[e+1|0]&192|0)==192}}while(0);i=b;return f&1|0}function et(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}do{if((d[e]|0|0)==239){if((d[e+1|0]|0|0)!=191){h=5;break}if((d[e+2|0]|0|0)>189){f=1}else{break}g=f&1;i=b;return g|0}else{h=5}}while(0);do{if((h|0)==5){if((a[e+2|0]&192|0)==192){f=1}else{break}g=f&1;i=b;return g|0}}while(0);h=d[e+1|0]|0;do{if((d[e]|0|0)==224){if((h|0)<160){j=1;break}j=(a[e+1|0]&192|0)==192}else{if((h&128|0)==0){j=1;break}c=d[e+1|0]|0;if((d[e]|0|0)==237){k=(c|0)>159}else{k=(c&192|0)==192}j=(k&1|0)!=0}}while(0);f=(j&1|0)!=0;g=f&1;i=b;return g|0}function ft(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+3|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+3|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}c=d[e+1|0]|0;do{if((d[e]|0|0)==240){if((c|0)<144){h=1;break}h=(a[e+1|0]&192|0)==192}else{if((c&128|0)==0){h=1;break}j=d[e+1|0]|0;if((d[e]|0|0)==244){k=(j|0)>143}else{k=(j&192|0)==192}h=(k&1|0)!=0}}while(0);f=(h&1|0)!=0;g=f&1;i=b;return g|0}function gt(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 19:{j=it(h,a+1|0,b,e)|0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((le[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((le[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((le[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){l=33;break b}m=a;if((le[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=m+3|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 29:{l=25;break b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((le[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 5:{if((b-a|0)<2){l=28;break b}o=a;if((le[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=o+2|0;continue b;break};case 18:{l=42;break b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=9;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function ht(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 30:case 9:case 10:case 21:{c[e>>2]=a;j=22;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((le[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((le[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((le[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){l=33;break b}m=a;if((le[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=m+3|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 29:{l=25;break b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((le[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 5:{if((b-a|0)<2){l=28;break b}o=a;if((le[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=o+2|0;continue b;break};case 18:{l=42;break b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=28;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function it(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){if((a[b]|0)==120){k=jt(j,b+1|0,e,f)|0;l=k;i=h;return l|0}g=b;if((d[j+76+(d[b]|0)|0]|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;while(1){if((b|0)==(e|0)){break a}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==18){m=9;break}else if((g|0)!=25){m=10;break}b=b+1|0}if((m|0)==9){c[f>>2]=b+1;k=10;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function jt(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;a:do{if((a|0)!=(b|0)){f=a;if(!(((d[h+76+(d[a]|0)|0]|0)+ -24|0)>>>0<2)){c[e>>2]=f;j=0;k=j;i=g;return k|0}a=f+1|0;while(1){if((a|0)==(b|0)){break a}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==18){l=7;break}else if(!((f|0)==24|(f|0)==25)){l=8;break}a=a+1|0}if((l|0)==7){c[e>>2]=a+1;j=10;k=j;i=g;return k|0}else if((l|0)==8){c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);j=-1;k=j;i=g;return k|0}function kt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 15:{k=nt(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((le[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 29:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 16:{g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==20){k=mt(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else if((g|0)==27){k=lt(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((le[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 24:case 22:{b=b+1|0;break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((le[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 17:{k=ot(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);g=0;b:while(1){if((b|0)==(e|0)){m=104;break}switch(d[j+76+(d[b]|0)|0]|0){case 17:{break b;break};case 10:case 9:case 21:{m=73;break b;break};case 11:{m=97;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 7:{if((e-b|0)<4){m=46;break b}n=b;if((le[c[j+340>>2]&63](j,b)|0)==0){m=48;break b}b=n+4|0;continue b;break};case 5:{if((e-b|0)<2){m=36;break b}o=b;if((le[c[j+332>>2]&63](j,b)|0)==0){m=38;break b}b=o+2|0;continue b;break};case 6:{if((e-b|0)<3){m=41;break b}p=b;if((le[c[j+336>>2]&63](j,b)|0)==0){m=43;break b}b=p+3|0;continue b;break};case 29:{m=33;break b;break};case 23:{if((g|0)!=0){m=51;break b}g=1;b=b+1|0;if((b|0)==(e|0)){m=53;break b}switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){m=58;break b}q=b;if((le[c[j+344>>2]&63](j,b)|0)==0){m=60;break b}b=q+2|0;continue b;break};case 29:{m=55;break b;break};case 6:{if((e-b|0)<3){m=63;break b}r=b;if((le[c[j+348>>2]&63](j,b)|0)==0){m=65;break b}b=r+3|0;continue b;break};case 24:case 22:{b=b+1|0;continue b;break};case 7:{if((e-b|0)<4){m=68;break b}s=b;if((le[c[j+352>>2]&63](j,b)|0)==0){m=70;break b}b=s+4|0;continue b;break};default:{m=72;break b}}break};default:{m=103;break b}}}c:do{if((m|0)==33){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==36){k=-2;l=k;i=h;return l|0}else if((m|0)==38){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==41){k=-2;l=k;i=h;return l|0}else if((m|0)==43){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==46){k=-2;l=k;i=h;return l|0}else if((m|0)==48){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==51){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==53){k=-1;l=k;i=h;return l|0}else if((m|0)==55){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==58){k=-2;l=k;i=h;return l|0}else if((m|0)==60){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==63){k=-2;l=k;i=h;return l|0}else if((m|0)==65){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==68){k=-2;l=k;i=h;return l|0}else if((m|0)==70){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==72){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==73){b=b+1|0;d:while(1){if((b|0)==(e|0)){m=96;break}switch(d[j+76+(d[b]|0)|0]|0){case 6:{m=83;break d;break};case 17:{break c;break};case 11:{m=97;break c;break};case 5:{m=78;break d;break};case 7:{m=88;break d;break};case 10:case 9:case 21:{break};case 24:case 22:{m=77;break d;break};case 29:{m=76;break d;break};default:{m=94;break d}}b=b+1|0}do{if((m|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==77){b=b+1|0}else if((m|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((le[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==83){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((le[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==88){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((le[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==94){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==96){k=-1;l=k;i=h;return l|0}}while(0);k=pt(j,b,e,f)|0;l=k;i=h;return l|0}else if((m|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-1;l=k;i=h;return l|0}}while(0);if((m|0)==97){c[f>>2]=b+1;k=2;l=k;i=h;return l|0}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}e=b;if((a[b]|0)==62){c[f>>2]=e+1;k=4;l=k;i=h;return l|0}else{c[f>>2]=e;k=0;l=k;i=h;return l|0}return 0}function lt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)!=45){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;b:while(1){if((b|0)==(e|0)){break a}switch(d[j+76+(d[b]|0)|0]|0){case 27:{g=b+1|0;b=g;if((g|0)==(e|0)){m=24;break b}if((a[b]|0)==45){m=26;break b}else{continue b}break};case 6:{if((e-b|0)<3){m=13;break b}n=b;if((le[c[j+360>>2]&63](j,b)|0)!=0){m=15;break b}b=n+3|0;continue b;break};case 5:{if((e-b|0)<2){m=8;break b}o=b;if((le[c[j+356>>2]&63](j,b)|0)!=0){m=10;break b}b=o+2|0;continue b;break};case 7:{if((e-b|0)<4){m=18;break b}p=b;if((le[c[j+364>>2]&63](j,b)|0)!=0){m=20;break b}b=p+4|0;continue b;break};case 8:case 1:case 0:{m=22;break b;break};default:{b=b+1|0;continue b}}}if((m|0)==8){k=-2;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==13){k=-2;l=k;i=h;return l|0}else if((m|0)==15){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==18){k=-2;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==22){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==24){k=-1;l=k;i=h;return l|0}else if((m|0)==26){g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==62){c[f>>2]=g+1;k=13;l=k;i=h;return l|0}else{c[f>>2]=g;k=0;l=k;i=h;return l|0}}}}while(0);k=-1;l=k;i=h;return l|0}function mt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<6){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=8;break}if((a[k]|0)!=(a[58456+e|0]|0)){l=6;break}e=e+1|0;g=g+1|0}if((l|0)==6){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==8){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function nt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}a:do{switch(d[k+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}n=b;if((le[c[k+348>>2]&63](k,b)|0)!=0){b=n+3|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 24:case 22:{b=b+1|0;break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}n=b;if((le[c[k+344>>2]&63](k,b)|0)!=0){b=n+2|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}n=b;if((le[c[k+352>>2]&63](k,b)|0)!=0){b=n+4|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 29:{c[f>>2]=b;l=0;m=l;i=h;return m|0};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b:while(1){if((b|0)==(e|0)){o=75;break}switch(d[k+76+(d[b]|0)|0]|0){case 29:{o=24;break b;break};case 7:{if((e-b|0)<4){o=37;break b}p=b;if((le[c[k+340>>2]&63](k,b)|0)==0){o=39;break b}b=p+4|0;continue b;break};case 10:case 9:case 21:{o=41;break b;break};case 5:{if((e-b|0)<2){o=27;break b}q=b;if((le[c[k+332>>2]&63](k,b)|0)==0){o=29;break b}b=q+2|0;continue b;break};case 6:{if((e-b|0)<3){o=32;break b}r=b;if((le[c[k+336>>2]&63](k,b)|0)==0){o=34;break b}b=r+3|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 15:{o=68;break b;break};default:{break b}}}do{if((o|0)==24){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==27){l=-2;m=l;i=h;return m|0}else if((o|0)==29){c[f>>2]=q;l=0;m=l;i=h;return m|0}else if((o|0)==32){l=-2;m=l;i=h;return m|0}else if((o|0)==34){c[f>>2]=r;l=0;m=l;i=h;return m|0}else if((o|0)==37){l=-2;m=l;i=h;return m|0}else if((o|0)==39){c[f>>2]=p;l=0;m=l;i=h;return m|0}else if((o|0)==41){n=b;if((qt(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;c:while(1){if((b|0)==(e|0)){o=67;break}switch(d[k+76+(d[b]|0)|0]|0){case 15:{b=b+1|0;if((b|0)==(e|0)){o=63;break c}if((a[b]|0)==62){o=65;break c}else{continue c}break};case 5:{if((e-b|0)<2){o=47;break c}s=b;if((le[c[k+356>>2]&63](k,b)|0)!=0){o=49;break c}b=s+2|0;continue c;break};case 6:{if((e-b|0)<3){o=52;break c}t=b;if((le[c[k+360>>2]&63](k,b)|0)!=0){o=54;break c}b=t+3|0;continue c;break};case 7:{if((e-b|0)<4){o=57;break c}u=b;if((le[c[k+364>>2]&63](k,b)|0)!=0){o=59;break c}b=u+4|0;continue c;break};case 8:case 1:case 0:{o=61;break c;break};default:{b=b+1|0;continue c}}}if((o|0)==47){l=-2;m=l;i=h;return m|0}else if((o|0)==49){c[f>>2]=s;l=0;m=l;i=h;return m|0}else if((o|0)==52){l=-2;m=l;i=h;return m|0}else if((o|0)==54){c[f>>2]=t;l=0;m=l;i=h;return m|0}else if((o|0)==57){l=-2;m=l;i=h;return m|0}else if((o|0)==59){c[f>>2]=u;l=0;m=l;i=h;return m|0}else if((o|0)==61){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==63){l=-1;m=l;i=h;return m|0}else if((o|0)==65){c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==67){l=-1;m=l;i=h;return m|0}}else if((o|0)==68){n=b;if((qt(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=62){break}c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==75){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function ot(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((le[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((le[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((le[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=51;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{l=24;break b;break};case 10:case 9:case 21:{l=41;break b;break};case 7:{if((b-a|0)<4){l=37;break b}m=a;if((le[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=m+4|0;continue b;break};case 11:{l=49;break b;break};case 5:{if((b-a|0)<2){l=27;break b}n=a;if((le[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=n+2|0;continue b;break};case 6:{if((b-a|0)<3){l=32;break b}o=a;if((le[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=o+3|0;continue b;break};case 23:{a=a+1|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};default:{l=50;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==41){a=a+1|0;while(1){if((a|0)==(b|0)){l=47;break}m=d[h+76+(d[a]|0)|0]|0;if((m|0)==11){l=44;break}else if(!((m|0)==10|(m|0)==9|(m|0)==21)){l=45;break}a=a+1|0}if((l|0)==44){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==45){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==47){j=-1;k=j;i=g;return k|0}}else if((l|0)==49){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==50){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==51){j=-1;k=j;i=g;return k|0}return 0}function pt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=114;break}b:do{switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 7:{if((e-(c[j>>2]|0)|0)<4){l=17;break a}b=(le[c[k+340>>2]&63](k,c[j>>2]|0)|0)!=0;m=c[j>>2]|0;if(!b){l=19;break a}c[j>>2]=m+4;continue a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=45;break a}b=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((b|0)==14){break b}n=b;if(!((n|0)==9|(n|0)==10|(n|0)==21)){l=48;break a}}break};case 29:{l=4;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=7;break a}n=(le[c[k+332>>2]&63](k,c[j>>2]|0)|0)!=0;o=c[j>>2]|0;if(!n){l=9;break a}c[j>>2]=o+2;continue a;break};case 14:{break};case 23:{if((g|0)!=0){l=22;break a}g=1;c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=24;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 5:{if((e-(c[j>>2]|0)|0)<2){l=29;break a}n=(le[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;p=c[j>>2]|0;if(!n){l=31;break a}c[j>>2]=p+2;continue a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=39;break a}n=(le[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;q=c[j>>2]|0;if(!n){l=41;break a}c[j>>2]=q+4;continue a;break};case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=34;break a}n=(le[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;r=c[j>>2]|0;if(!n){l=36;break a}c[j>>2]=r+3;continue a;break};case 29:{l=26;break a;break};default:{l=43;break a}}break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=12;break a}n=(le[c[k+336>>2]&63](k,c[j>>2]|0)|0)!=0;s=c[j>>2]|0;if(!n){l=14;break a}c[j>>2]=s+3;continue a;break};case 27:case 26:case 25:case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};default:{l=113;break a}}}while(0);g=0;while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=51;break a}t=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((t|0)==12|(t|0)==13){break}n=t;if(!((n|0)==9|(n|0)==10|(n|0)==21)){l=54;break a}}c[j>>2]=(c[j>>2]|0)+1;c:while(1){if((c[j>>2]|0)==(e|0)){l=57;break a}n=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((n|0)==(t|0)){break}switch(n|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=66;break a}n=(le[c[k+360>>2]&63](k,c[j>>2]|0)|0)!=0;u=c[j>>2]|0;if(n){l=68;break a}c[j>>2]=u+3;continue c;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=71;break a}n=(le[c[k+364>>2]&63](k,c[j>>2]|0)|0)!=0;v=c[j>>2]|0;if(n){l=73;break a}c[j>>2]=v+4;continue c;break};case 8:case 1:case 0:{l=75;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=61;break a}n=(le[c[k+356>>2]&63](k,c[j>>2]|0)|0)!=0;w=c[j>>2]|0;if(n){l=63;break a}c[j>>2]=w+2;continue c;break};case 2:{l=80;break a;break};case 3:{x=gt(k,(c[j>>2]|0)+1|0,e,j)|0;if((x|0)<=0){l=77;break a}else{continue c}break};default:{c[j>>2]=(c[j>>2]|0)+1;continue c}}}c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=83;break}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 10:case 9:case 21:{break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};default:{l=85;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=87;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 5:{l=91;break d;break};case 29:{l=89;break a;break};case 7:{l=101;break d;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};case 24:case 22:{l=90;break d;break};case 6:{l=96;break d;break};case 11:{l=106;break a;break};default:{l=112;break a}}}if((l|0)==90){l=0;c[j>>2]=(c[j>>2]|0)+1;continue}else if((l|0)==91){l=0;if((e-(c[j>>2]|0)|0)<2){l=92;break}n=(le[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;y=c[j>>2]|0;if(!n){l=94;break}c[j>>2]=y+2;continue}else if((l|0)==96){l=0;if((e-(c[j>>2]|0)|0)<3){l=97;break}n=(le[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;z=c[j>>2]|0;if(!n){l=99;break}c[j>>2]=z+3;continue}else if((l|0)==101){l=0;if((e-(c[j>>2]|0)|0)<4){l=102;break}n=(le[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;A=c[j>>2]|0;if(!n){l=104;break}c[j>>2]=A+4;continue}}if((l|0)==4){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==7){B=-2;C=B;i=h;return C|0}else if((l|0)==9){c[f>>2]=o;B=0;C=B;i=h;return C|0}else if((l|0)==12){B=-2;C=B;i=h;return C|0}else if((l|0)==14){c[f>>2]=s;B=0;C=B;i=h;return C|0}else if((l|0)==17){B=-2;C=B;i=h;return C|0}else if((l|0)==19){c[f>>2]=m;B=0;C=B;i=h;return C|0}else if((l|0)==22){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==24){B=-1;C=B;i=h;return C|0}else if((l|0)==26){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==29){B=-2;C=B;i=h;return C|0}else if((l|0)==31){c[f>>2]=p;B=0;C=B;i=h;return C|0}else if((l|0)==34){B=-2;C=B;i=h;return C|0}else if((l|0)==36){c[f>>2]=r;B=0;C=B;i=h;return C|0}else if((l|0)==39){B=-2;C=B;i=h;return C|0}else if((l|0)==41){c[f>>2]=q;B=0;C=B;i=h;return C|0}else if((l|0)==43){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==45){B=-1;C=B;i=h;return C|0}else if((l|0)==48){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==51){B=-1;C=B;i=h;return C|0}else if((l|0)==54){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==57){B=-1;C=B;i=h;return C|0}else if((l|0)==61){B=-2;C=B;i=h;return C|0}else if((l|0)==63){c[f>>2]=w;B=0;C=B;i=h;return C|0}else if((l|0)==66){B=-2;C=B;i=h;return C|0}else if((l|0)==68){c[f>>2]=u;B=0;C=B;i=h;return C|0}else if((l|0)==71){B=-2;C=B;i=h;return C|0}else if((l|0)==73){c[f>>2]=v;B=0;C=B;i=h;return C|0}else if((l|0)==75){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==77){if((x|0)==0){c[f>>2]=c[j>>2]}B=x;C=B;i=h;return C|0}else if((l|0)==80){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==83){B=-1;C=B;i=h;return C|0}else if((l|0)==85){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==87){B=-1;C=B;i=h;return C|0}else if((l|0)==89){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==92){B=-2;C=B;i=h;return C|0}else if((l|0)==94){c[f>>2]=y;B=0;C=B;i=h;return C|0}else if((l|0)==97){B=-2;C=B;i=h;return C|0}else if((l|0)==99){c[f>>2]=z;B=0;C=B;i=h;return C|0}else if((l|0)==102){B=-2;C=B;i=h;return C|0}else if((l|0)==104){c[f>>2]=A;B=0;C=B;i=h;return C|0}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+1;B=1;C=B;i=h;return C|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){B=-1;C=B;i=h;return C|0}e=c[j>>2]|0;if((a[c[j>>2]|0]|0)==62){c[f>>2]=e+1;B=3;C=B;i=h;return C|0}else{c[f>>2]=e;B=0;C=B;i=h;return C|0}}else if((l|0)==112){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==113){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==114){B=-1;C=B;i=h;return C|0}return 0}function qt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;do{if((e-g|0)!=3){h=1}else{j=a[g]|0;if((j|0)==88){f=1}else if((j|0)!=120){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==77){f=1}else if((j|0)!=109){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==76){f=1}else if((j|0)!=108){h=1;break}if((f|0)!=0){h=0;break}else{c[d>>2]=12;h=1;break}}}while(0);i=b;return h|0}function rt(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+56|0;j=a;a=b;b=e;e=f;f=g;a:while(1){if((b|0)==(e|0)){k=27;break}g=d[a+76+(d[b]|0)|0]|0;switch(g|0){case 5:{if((e-b|0)<2){k=5;break a}l=b;if((le[c[a+356>>2]&63](a,b)|0)!=0){k=7;break a}b=l+2|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}m=b;if((le[c[a+360>>2]&63](a,b)|0)!=0){k=12;break a}b=m+3|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}n=b;if((le[c[a+364>>2]&63](a,b)|0)!=0){k=17;break a}b=n+4|0;continue a;break};case 13:case 12:{b=b+1|0;if((g|0)!=(j|0)){continue a}else{k=21;break a}break};case 8:case 1:case 0:{k=19;break a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){o=-2;p=o;i=h;return p|0}else if((k|0)==7){c[f>>2]=l;o=0;p=o;i=h;return p|0}else if((k|0)==10){o=-2;p=o;i=h;return p|0}else if((k|0)==12){c[f>>2]=m;o=0;p=o;i=h;return p|0}else if((k|0)==15){o=-2;p=o;i=h;return p|0}else if((k|0)==17){c[f>>2]=n;o=0;p=o;i=h;return p|0}else if((k|0)==19){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==21){if((b|0)==(e|0)){o=-27;p=o;i=h;return p|0}c[f>>2]=b;switch(d[a+76+(d[b]|0)|0]|0|0){case 20:case 30:case 11:case 10:case 9:case 21:{o=27;p=o;i=h;return p|0};default:{o=0;p=o;i=h;return p|0}}}else if((k|0)==27){o=-1;p=o;i=h;return p|0}return 0}function st(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==24|(f|0)==22){a=a+1|0;a:while(1){if((a|0)==(b|0)){l=17;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 10:case 9:case 21:{break a;break};case 30:{l=10;break a;break};case 24:case 22:{break};default:{l=16;break a}}a=a+1|0}do{if((l|0)==10){if((a+1|0)==(b|0)){j=-1;k=j;i=g;return k|0}m=d[h+76+(d[a+1|0]|0)|0]|0;if(!((m|0)==30|(m|0)==10|(m|0)==9|(m|0)==21)){break}c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==16){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==17){j=-1;k=j;i=g;return k|0}}while(0);c[e>>2]=a;j=16;k=j;i=g;return k|0}else if((f|0)==20){c[e>>2]=a+1;j=33;k=j;i=g;return k|0}else if((f|0)==27){j=lt(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=0;k=j;i=g;return k|0}return 0}function tt(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((le[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((le[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((le[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=43;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){l=27;break b}m=a;if((le[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=m+2|0;continue b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{l=41;break b;break};case 7:{if((b-a|0)<4){l=37;break b}n=a;if((le[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=n+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 29:{l=24;break b;break};case 6:{if((b-a|0)<3){l=32;break b}o=a;if((le[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=o+3|0;continue b;break};default:{l=42;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==41){c[e>>2]=a;j=20;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==43){j=-20;k=j;i=g;return k|0}return 0}function ut(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+40|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=5;break}if((c[e>>2]|0)==(f|0)){j=5;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g}if((j|0)==5){i=b;return}}function vt(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;a=i;i=i+40|0;j=e;e=f;f=g;g=h;while(1){if((c[j>>2]|0)==(e|0)){k=5;break}if((c[f>>2]|0)==(g|0)){k=5;break}h=j;l=c[h>>2]|0;c[h>>2]=l+1;h=d[l]|0;l=f;m=c[l>>2]|0;c[l>>2]=m+2;b[m>>1]=h}if((k|0)==5){i=a;return}}function wt(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+48|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=8;break}g=a[c[h>>2]|0]|0;if((g&128|0)!=0){if((f-(c[e>>2]|0)|0)<2){j=8;break}k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=(g&255)>>6|192;l=e;k=c[l>>2]|0;c[l>>2]=k+1;a[k]=g&63|128;g=h;c[g>>2]=(c[g>>2]|0)+1;continue}else{if((c[e>>2]|0)==(f|0)){j=8;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g;continue}}if((j|0)==8){i=b;return}}function xt(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;i=i+72|0;l=b;b=e;e=f;f=g;g=h;h=j;if((f|0)==(g|0)){m=-4;n=m;i=k;return n|0}j=c[b+76>>2]|0;a:do{if((f+1|0)==(g|0)){if(((a[b+73|0]|0)+ -3|0)>>>0<3){m=-1;n=m;i=k;return n|0}b:do{switch(d[f]|0){case 60:case 0:{break};case 239:case 255:case 254:{if((a[b+73|0]|0)!=0){break b}if((e|0)==1){break a}break};default:{break a}}}while(0);m=-1;n=m;i=k;return n|0}else{o=d[f]<<8|d[f+1|0];if((o|0)==65534){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+20>>2];m=14;n=m;i=k;return n|0}else if((o|0)==61371){if((e|0)==1){p=a[b+73|0]|0;if((p|0)==0|(p|0)==4|(p|0)==5|(p|0)==3){break}}if((f+2|0)==(g|0)){m=-1;n=m;i=k;return n|0}if((d[f+2|0]|0)!=191){break}c[h>>2]=f+3;c[j>>2]=c[l+8>>2];m=14;n=m;i=k;return n|0}else if((o|0)==15360){if((a[b+73|0]|0)==4){q=16}else{if((a[b+73|0]|0)==3){q=16}}if((q|0)==16){if((e|0)==1){break}}c[j>>2]=c[l+20>>2];m=ue[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else if((o|0)==65279){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+16>>2];m=14;n=m;i=k;return n|0}else{if((a[f]|0)==0){if((e|0)==1){if((a[b+73|0]|0)==5){break}}c[j>>2]=c[l+16>>2];m=ue[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f+1|0]|0)!=0){break}if((e|0)==1){break}c[j>>2]=c[l+20>>2];m=ue[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}}}}while(0);c[j>>2]=c[l+(a[b+73|0]<<2)>>2];m=ue[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}function yt(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+80|0;k=a;a=b;b=d;d=e;e=f;f=g;g=h;if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}if((At(zt(k,a,b)|0)|0)==0){c[g>>2]=a;l=0;m=l;i=j;return m|0}do{a=a+(c[k+68>>2]|0)|0;}while((At(zt(k,a,b)|0)|0)!=0);if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}c[d>>2]=a;while(1){n=zt(k,a,b)|0;if((n|0)==-1){o=10;break}if((n|0)==61){o=12;break}if((At(n)|0)!=0){o=14;break}a=a+(c[k+68>>2]|0)|0}do{if((o|0)==10){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==12){c[e>>2]=a}else if((o|0)==14){c[e>>2]=a;do{a=a+(c[k+68>>2]|0)|0;h=zt(k,a,b)|0;n=h;}while((At(h)|0)!=0);if((n|0)==61){break}c[g>>2]=a;l=0;m=l;i=j;return m|0}}while(0);if((a|0)==(c[d>>2]|0)){c[g>>2]=a;l=0;m=l;i=j;return m|0}a=a+(c[k+68>>2]|0)|0;n=zt(k,a,b)|0;while(1){if((At(n)|0)==0){break}a=a+(c[k+68>>2]|0)|0;n=zt(k,a,b)|0}if((n|0)!=34&(n|0)!=39){c[g>>2]=a;l=0;m=l;i=j;return m|0}d=n&255;a=a+(c[k+68>>2]|0)|0;c[f>>2]=a;a:while(1){n=zt(k,a,b)|0;if((n|0)==(d<<24>>24|0)){o=33;break}do{if(!(97<=(n|0)&(n|0)<=122)){if(65<=(n|0)&(n|0)<=90){break}if((48<=(n|0)&(n|0)<=57^1)&(n|0)!=46&(n|0)!=45&(n|0)!=95){o=31;break a}}}while(0);a=a+(c[k+68>>2]|0)|0}if((o|0)==31){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==33){c[g>>2]=a+(c[k+68>>2]|0);l=1;m=l;i=j;return m|0}return 0}function zt(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f+40|0;k=b;c[g>>2]=d;c[j>>2]=h;Sd[c[k+60>>2]&31](k,g,e,j,(c[j>>2]|0)+1|0);if((c[j>>2]|0)==(h|0)){l=-1;m=l;i=f;return m|0}else{l=a[h]|0;m=l;i=f;return m|0}return 0}function At(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=a;if((c|0)==9|(c|0)==10|(c|0)==13|(c|0)==32){d=1}else{d=0}i=b;return d|0}function Bt(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d>>2]=13;c[d+16>>2]=1;c[d+12>>2]=0;c[d+20>>2]=0;i=b;return}function Ct(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 16:{if((ue[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,62200)|0)==0){j=10;break a}c[h>>2]=15;k=3;break};case 11:{c[h>>2]=14;k=55;break};case 29:{c[h>>2]=16;k=2;break};case 15:{c[h>>2]=14;k=0;break};case 12:{c[h>>2]=14;k=1;break};case 13:{c[h>>2]=14;k=56;break};case 14:{k=0;break};default:{j=10}}}while(0);if((j|0)==10){k=Gt(h,a)|0}i=g;return k|0}function Dt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;a:do{switch(a|0){case 26:{j=9;break};case 33:{c[h>>2]=17;k=0;break};case 34:{if((c[h+12>>2]|0)==0){j=9;break a}b=h+12|0;c[b>>2]=(c[b>>2]|0)-1;k=0;break};case 15:{k=0;break};case-4:{if((c[h+12>>2]|0)!=0){j=9;break a}k=0;break};default:{k=Ft(h,a,d,e,f)|0}}}while(0);if((j|0)==9){k=Gt(h,a)|0}i=g;return k|0}function Et(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==18){j=3}else if((f|0)==15){k=0;l=k;i=g;return l|0}do{if((j|0)==3){if((ue[c[e+28>>2]&63](e,b,d,62184)|0)!=0){c[h>>2]=18;k=0;l=k;i=g;return l|0}if((ue[c[e+28>>2]&63](e,b,d,62192)|0)==0){break}c[h>>2]=19;k=0;l=k;i=g;return l|0}}while(0);k=Gt(h,a)|0;l=k;i=g;return l|0}function Ft(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;a:do{switch(a|0){case 26:{c[h>>2]=24;j=3;k=j;i=g;return k|0};case 13:{j=56;k=j;i=g;return k|0};case-4:{j=0;k=j;i=g;return k|0};case 15:{j=0;k=j;i=g;return k|0};case 11:{j=55;k=j;i=g;return k|0};case 16:{if((ue[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,61960)|0)!=0){c[h>>2]=20;j=11;k=j;i=g;return k|0}if((ue[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,61968)|0)!=0){c[h>>2]=21;j=33;k=j;i=g;return k|0}if((ue[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,61976)|0)!=0){c[h>>2]=22;j=39;k=j;i=g;return k|0}if((ue[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,61984)|0)==0){break a}c[h>>2]=23;j=17;k=j;i=g;return k|0};case 28:{j=60;k=j;i=g;return k|0};default:{}}}while(0);j=Gt(h,a)|0;k=j;i=g;return k|0}function Gt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=a;do{if((c[e+16>>2]|0)==0){if((b|0)!=28){break}f=59;g=f;i=d;return g|0}}while(0);c[e>>2]=16;f=-1;g=f;i=d;return g|0}function Ht(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;i=e;return 0}function It(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=26;g=9}else if((b|0)==22){c[e>>2]=25;g=11}else if((b|0)==15){g=11}else{g=Gt(e,a)|0}i=f;return g|0}function Jt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=27;g=34}else{g=Gt(e,a)|0}i=f;return g|0}function Kt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=28;g=40}else{g=Gt(e,a)|0}i=f;return g|0}function Lt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=29;g=18}else if((b|0)==15){g=17}else{g=Gt(e,a)|0}i=f;return g|0}function Mt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==17){c[e>>2]=30;g=8}else{g=Gt(e,a)|0}i=f;return g|0}function Nt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==11){g=55}else if((b|0)==15){g=0}else if((b|0)==13){g=56}else if((b|0)==29){c[e>>2]=16;g=2}else{g=Gt(e,a)|0}i=f;return g|0}function Ot(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=17;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((ue[c[e+28>>2]&63](e,b,d,62e3)|0)!=0){c[h>>2]=31;j=17;k=j;i=g;return k|0}if((ue[c[e+28>>2]&63](e,b,d,62008)|0)==0){break}c[h>>2]=32;j=17;k=j;i=g;return k|0}}while(0);j=Gt(h,a)|0;k=j;i=g;return k|0}function Pt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else{g=Gt(e,a)|0}i=f;return g|0}function Qt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=34;g=21}else{g=Gt(e,a)|0}i=f;return g|0}function Rt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=20}else if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else{g=Gt(e,a)|0}i=f;return g|0}function St(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=c[e+8>>2]|0;h=g;i=f;return h|0}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=c[e+8>>2]|0;h=g;i=f;return h|0}else{g=Gt(e,a)|0;h=g;i=f;return h|0}return 0}function Tt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((ue[c[e+28>>2]&63](e,b,d,62016)|0)!=0){c[h>>2]=33;c[h+8>>2]=39;j=42;k=j;i=g;return k|0}if((ue[c[e+28>>2]&63](e,b,d,62024)|0)==0){break}c[h>>2]=33;c[h+8>>2]=39;j=41;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=37;c[h+4>>2]=1;j=44;k=j;i=g;return k|0}else if((f|0)==15){j=39;k=j;i=g;return k|0}}while(0);j=Gt(h,a)|0;k=j;i=g;return k|0}function Ut(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 32:{c[h>>2]=40;j=54;break};case 15:{j=39;break};case 30:{c[h>>2]=40;j=53;break};case 20:{if((ue[c[b+28>>2]&63](b,d+(c[b+68>>2]|0)|0,e,62032)|0)==0){k=10;break a}c[h>>2]=38;j=43;break};case 23:{c[h+4>>2]=2;c[h>>2]=39;j=44;break};case 41:case 18:{c[h>>2]=40;j=51;break};case 31:{c[h>>2]=40;j=52;break};default:{k=10}}}while(0);if((k|0)==10){j=Gt(h,a)|0}i=g;return j|0}function Vt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==24){c[e>>2]=33;c[e+8>>2]=39;g=45}else if((b|0)==15){g=39}else{g=Gt(e,a)|0}i=f;return g|0}function Wt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 30:{c[e>>2]=40;g=53;break};case 31:{c[e>>2]=40;g=52;break};case 15:{g=39;break};case 23:{b=e+4|0;c[b>>2]=(c[b>>2]|0)+1;g=44;break};case 32:{c[e>>2]=40;g=54;break};case 41:case 18:{c[e>>2]=40;g=51;break};default:{g=Gt(e,a)|0}}i=f;return g|0}function Xt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 24:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=45;h=g;i=f;return h|0};case 35:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=47;h=g;i=f;return h|0};case 21:{c[e>>2]=39;g=49;h=g;i=f;return h|0};case 36:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=46;h=g;i=f;return h|0};case 37:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=48;h=g;i=f;return h|0};case 15:{g=39;h=g;i=f;return h|0};case 38:{c[e>>2]=39;g=50;h=g;i=f;return h|0};default:{g=Gt(e,a)|0;h=g;i=f;return h|0}}return 0}function Yt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=42;g=51}else if((b|0)==15){g=39}else{g=Gt(e,a)|0}i=f;return g|0}function Zt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==15){g=39}else{g=Gt(e,a)|0}i=f;return g|0}function _t(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=43;g=22}else{g=Gt(e,a)|0}i=f;return g|0}function $t(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+56|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){j=0;while(1){k=c[e+28>>2]|0;l=e;m=b;n=d;if((j|0)>=8){break}if((ue[k&63](l,m,n,c[62040+(j<<2)>>2]|0)|0)!=0){o=6;break}j=j+1|0}if((o|0)==6){c[h>>2]=44;p=23+j|0;q=p;i=g;return q|0}if((ue[k&63](l,m,n,61984)|0)==0){break}c[h>>2]=45;p=33;q=p;i=g;return q|0}else if((f|0)==23){c[h>>2]=46;p=33;q=p;i=g;return q|0}else if((f|0)==15){p=33;q=p;i=g;return q|0}}while(0);p=Gt(h,a)|0;q=p;i=g;return q|0}function au(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==20){if((ue[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,62144)|0)!=0){c[h>>2]=27;j=35;k=j;i=g;return k|0}if((ue[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,62152)|0)!=0){c[h>>2]=27;j=36;k=j;i=g;return k|0}if((ue[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,62168)|0)==0){break}c[h>>2]=47;j=33;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=27;j=37;k=j;i=g;return k|0}}while(0);j=Gt(h,a)|0;k=j;i=g;return k|0}function bu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==23){c[e>>2]=48;g=33}else if((b|0)==15){g=33}else{g=Gt(e,a)|0}i=f;return g|0}function cu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18|(b|0)==19){c[e>>2]=49;g=31}else if((b|0)==15){g=33}else{g=Gt(e,a)|0}i=f;return g|0}function du(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==21){c[e>>2]=46;g=33}else{g=Gt(e,a)|0}i=f;return g|0}function eu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=50;g=32}else if((b|0)==15){g=33}else{g=Gt(e,a)|0}i=f;return g|0}function fu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=48;g=33}else if((b|0)==15){g=33}else if((b|0)==24){c[e>>2]=44;g=33}else{g=Gt(e,a)|0}i=f;return g|0}function gu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==27){c[e>>2]=27;g=38}else{g=Gt(e,a)|0}i=f;return g|0}function hu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=51;g=10}else if((b|0)==15){g=11}else{g=Gt(e,a)|0}i=f;return g|0}function iu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((ue[c[e+28>>2]&63](e,b,d,62e3)|0)!=0){c[h>>2]=52;j=11;k=j;i=g;return k|0}if((ue[c[e+28>>2]&63](e,b,d,62008)|0)==0){break}c[h>>2]=53;j=11;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}}while(0);j=Gt(h,a)|0;k=j;i=g;return k|0}function ju(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=54;g=13}else{g=Gt(e,a)|0}i=f;return g|0}function ku(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=52;g=14}else if((b|0)==15){g=11}else{g=Gt(e,a)|0}i=f;return g|0}function lu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((ue[c[e+28>>2]&63](e,b,d,62176)|0)==0){break}c[h>>2]=55;j=11;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=(c[h+16>>2]|0)!=0?35:36;j=15;k=j;i=g;return k|0}}while(0);j=Gt(h,a)|0;k=j;i=g;return k|0}function mu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=33;c[e+8>>2]=11;g=16}else if((b|0)==15){g=11}else{g=Gt(e,a)|0}i=f;return g|0}function nu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((ue[c[e+28>>2]&63](e,b,d,62e3)|0)!=0){c[h>>2]=56;j=11;k=j;i=g;return k|0}if((ue[c[e+28>>2]&63](e,b,d,62008)|0)==0){break}c[h>>2]=57;j=11;k=j;i=g;return k|0}}while(0);j=Gt(h,a)|0;k=j;i=g;return k|0}function ou(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=58;g=13}else{g=Gt(e,a)|0}i=f;return g|0}function pu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=56;g=14}else{g=Gt(e,a)|0}i=f;return g|0}function qu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=15;h=g;i=f;return h|0}else if((b|0)==15){g=11;h=g;i=f;return h|0}else{g=Gt(e,a)|0;h=g;i=f;return h|0}return 0}function ru(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0;h=g;i=f;return h|0}else if((b|0)==25){c[e>>2]=36;b=e+12|0;c[b>>2]=(c[b>>2]|0)+1;g=0;h=g;i=f;return h|0}else{g=Gt(e,a)|0;h=g;i=f;return h|0}return 0}function su(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=36;g=58}else if((b|0)==15){g=0}else{g=Gt(e,a)|0}i=f;return g|0}function tu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 13:{j=56;break};case 15:{j=0;break};case 14:{j=0;break};case 11:{j=55;break};case 29:{c[h>>2]=16;j=2;break};case 16:{if((ue[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,62200)|0)==0){k=9;break a}c[h>>2]=15;j=3;break};default:{k=9}}}while(0);if((k|0)==9){j=Gt(h,a)|0}i=g;return j|0}function uu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==41|(b|0)==18){c[e>>2]=59;g=4}else{g=Gt(e,a)|0}i=f;return g|0}function vu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((ue[c[e+28>>2]&63](e,b,d,62e3)|0)!=0){c[h>>2]=60;j=3;k=j;i=g;return k|0}if((ue[c[e+28>>2]&63](e,b,d,62008)|0)==0){break}c[h>>2]=61;j=3;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=30;j=8;k=j;i=g;return k|0}else if((f|0)==25){c[h>>2]=35;j=7;k=j;i=g;return k|0}else if((f|0)==15){j=3;k=j;i=g;return k|0}}while(0);j=Gt(h,a)|0;k=j;i=g;return k|0}function wu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=62;g=5}else if((b|0)==15){g=3}else{g=Gt(e,a)|0}i=f;return g|0}function xu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=60;g=6}else if((b|0)==15){g=3}else{g=Gt(e,a)|0}i=f;return g|0}function yu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==15){g=3}else if((b|0)==25){c[e>>2]=35;g=7}else{g=Gt(e,a)|0}i=f;return g|0}function zu(){i=i;return}function Au(){i=i;return}function Bu(){var a=0;a=i;Uc(62208,0)|0;i=a;return}function Cu(){var a=0,b=0,d=0;a=i;b=63928|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=64040|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=64152|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));c[63932>>2]=1;c[63936>>2]=1;i=a;return}function Du(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+24|0;e=d;f=c[b+4>>2]|0;g=c[b+8>>2]|0;h=c[b+12>>2]|0;j=c[b+16>>2]|0;k=(c[b+20>>2]|0)!=0?64288:64304;c[e>>2]=c[b>>2];c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=h;c[e+16>>2]=j;c[e+20>>2]=k;ld(a|0,64264,e|0)|0;i=d;return}function Eu(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=64152+(d<<2)|0;o=64040+(d<<2)|0;p=64352+(b<<2)|0;q=62632+(d<<2)|0;r=e;e=f;f=(g|0)!=0;a:while(1){b:do{if(f){c[l>>2]=64336;cc(64320,l|0)|0;s=64336}else{if((c[15978]|0)==(d|0)){if((c[o>>2]|0)>0){t=64336}else{u=5}}else{u=5}if((u|0)==5){u=0;t=c[q>>2]|0}c[m>>2]=t;cc(64320,m|0)|0;do{if((c[15978]|0)==(d|0)){if((c[n>>2]|0)!=(b|0)){break}if((c[o>>2]|0)>0){s=64336;break b}}}while(0);s=c[p>>2]|0}}while(0);c[k>>2]=s;cc(64344,k|0)|0;c[n>>2]=b;c[15978]=d;if((c[o>>2]|0)>0){g=0;while(1){cc(64376,j|0)|0;v=g+1|0;if((v|0)<(c[o>>2]|0)){g=v}else{w=0;break}}}else{w=0}while(1){x=e+w|0;g=a[x]|0;if(g<<24>>24==10){break}else if(g<<24>>24==0){break a}w=w+1|0}a[x]=0;qb(e|0)|0;r=0;e=e+(w+1)|0;f=1}qb(e|0)|0;jd(0)|0;if((r|0)==0){i=h;return}c[o>>2]=(c[o>>2]|0)+1;i=h;return}function Fu(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;h=f;j=i;i=i+8|0;k=c[64352+(a<<2)>>2]|0;c[j>>2]=c[62632+(b<<2)>>2];c[j+4>>2]=k;cc(64384,j|0)|0;Gu(e);if((g|0)==0){yd(((d|0)!=0?64424:64472)|0,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=jd(m|0)|0;i=f;return}qb(64552)|0;if((c[g>>2]|0)>=1){e=1;while(1){c[h>>2]=c[g+(e<<2)>>2];cc(64432,h|0)|0;if((e|0)<(c[g>>2]|0)){e=e+1|0}else{break}}}if((d|0)!=0){l=t;m=c[t>>2]|0;n=jd(m|0)|0;i=f;return}mc(64456,11,1,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=jd(m|0)|0;i=f;return}function Gu(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[t>>2]|0;f=b;while(1){b=a[f]|0;if(b<<24>>24==62){mc(64512,4,1,e|0)|0}else if(b<<24>>24==38){mc(64496,5,1,e|0)|0}else if(b<<24>>24==0){break}else if(b<<24>>24==60){mc(64504,4,1,e|0)|0}else{Gd(b<<24>>24|0,e|0)|0}f=f+1|0}i=d;return}function Hu(a){a=a|0;var b=0;b=64040+(a<<2)|0;c[b>>2]=(c[b>>2]|0)+ -1;i=i;return}function Iu(a){a=a|0;var b=0;b=(a|0)==0;c[16122]=b?1:19;c[16120]=b?7:259;i=i;return}function Ju(a){a=a|0;var b=0;a=i;b=c[t>>2]|0;mc(64456,11,1,b|0)|0;jd(b|0)|0;i=a;return}function Ku(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+2064|0;h=g+2048|0;if((c[63928+(a<<2)>>2]|0)==0){i=g;return}j=g;c[h>>2]=f;ic(j|0,2048,e|0,h|0)|0;fe[c[16122]&31](1,a,b,j,0,d);i=g;return}function Lu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((c[63928+(a<<2)>>2]|0)==0){i=f;return}h=f;c[g>>2]=e;ic(h|0,2048,d|0,g|0)|0;fe[c[16122]&31](1,a,b,h,0,0);i=f;return}function Mu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+2064|0;h=g;j=g+2048|0;do{if((c[15980]|0)==0){if((c[63928+(a<<2)>>2]|0)!=0){break}i=g;return}}while(0);k=h;c[j>>2]=f;ic(k|0,2048,e|0,j|0)|0;fe[c[16122]&31](2,a,b,k,0,d);i=g;return}function Nu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f;h=f+2048|0;do{if((c[15980]|0)==0){if((c[63928+(a<<2)>>2]|0)!=0){break}i=f;return}}while(0);j=g;c[h>>2]=e;ic(j|0,2048,d|0,h|0)|0;fe[c[16122]&31](2,a,b,j,0,0);i=f;return}function Ou(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((b|0)!=0){i=f;return}b=f;c[g>>2]=e;ic(b|0,2048,d|0,g|0)|0;fe[c[16122]&31](4,2,0,b,0,0);if((a|0)==0){h=dd(c[15552]|0)|0}else{h=a}bb(c[h+76>>2]|0,1)}function Pu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+2064|0;f=e+2048|0;g=e;c[f>>2]=d;ic(g|0,2048,b|0,f|0)|0;fe[c[16122]&31](5,2,0,g,0,0);if((a|0)==0){h=dd(c[15552]|0)|0}else{h=a}bb(c[h+76>>2]|0,1)}function Qu(a,b){a=a|0;b=b|0;i=i;return c[(c[a+8>>2]|0)+(b<<2)>>2]|0}function Ru(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=Qu(a,(fa(c[(c[a+4>>2]|0)+4>>2]|0,b)|0)+d|0)|0;i=e;return f|0}function Su(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=zY(16)|0;Ou(0,(d|0)!=0|0,64560,b);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=a;c[d+12>>2]=0;i=b;return d|0}function Tu(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)!=0){f=e;while(1){e=c[f+4>>2]|0;AY(c[f>>2]|0);AY(f);if((e|0)==0){break}else{f=e}}}c[a+12>>2]=0;c[d>>2]=0;c[a+4>>2]=0;i=b;return}function Uu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;Ou(0,(a|0)!=0|0,64576,f);f=zY(8)|0;g=f;Ou(0,(f|0)!=0|0,64560,e);e=a+8|0;h=zY(c[e>>2]|0)|0;c[f>>2]=h;Ou(0,(h|0)!=0|0,64560,d);dZ(c[f>>2]|0,b|0,c[e>>2]|0)|0;e=a;c[f+4>>2]=c[e>>2];f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=g;e=a+4|0;if((c[e>>2]|0)!=0){i=d;return}c[e>>2]=g;i=d;return}function Vu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;Ou(0,(a|0)!=0|0,64576,f);f=zY(8)|0;g=f;Ou(0,(f|0)!=0|0,64560,e);e=a+8|0;h=zY(c[e>>2]|0)|0;c[f>>2]=h;Ou(0,(h|0)!=0|0,64560,d);dZ(c[f>>2]|0,b|0,c[e>>2]|0)|0;c[f+4>>2]=0;f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;f=a+4|0;e=c[f>>2]|0;if((e|0)!=0){c[e+4>>2]=g}c[f>>2]=g;f=a;if((c[f>>2]|0)!=0){i=d;return}c[f>>2]=g;i=d;return}function Wu(a){a=a|0;var b=0;b=i;i=i+8|0;Ou(0,(a|0)!=0|0,64576,b);i=b;return c[a+12>>2]|0}function Xu(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;Ou(0,(a|0)!=0|0,64576,d);d=a;Ou(0,(c[d>>2]|0)!=0|0,64600,b);i=b;return c[c[d>>2]>>2]|0}function Yu(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=c[e+4>>2]|0;AY(c[e>>2]|0);AY(c[d>>2]|0);c[d>>2]=f;d=a+12|0;c[d>>2]=(c[d>>2]|0)+ -1;if((f|0)!=0){i=b;return}c[a+4>>2]=0;i=b;return}



function tM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;e=i;i=i+8|0;f=e;if((c[a>>2]|0)>0){g=b;h=0}else{j=0;i=e;return j|0}a:while(1){b=(g|0)==0;b:while(1){k=c[31212]|0;l=124872+(k<<4)|0;m=c[l>>2]|0;switch(uM(m)|0){case 8:{n=c[32428]|0;o=129720+(n<<2)|0;p=c[o>>2]|0;if((p|0)>=1){q=10;break b}c[32428]=n+ -1;c[31212]=k+1;continue b;break};case 1:{n=c[124876+(k<<4)>>2]|0;s=(c[32444]|0)+1|0;c[32444]=s;c[129784+(s<<2)>>2]=n;c[31212]=k+1;continue b;break};case 3:{n=c[32428]|0;s=129720+(n<<2)|0;t=c[s>>2]|0;c[s>>2]=t+ -1;if((t|0)<2){c[32428]=n+ -1;c[32444]=(c[32444]|0)+ -1;c[31212]=k+1;continue b}else{n=c[32444]|0;c[32444]=n+ -1;c[31212]=(c[129784+(n<<2)>>2]|0)+1;continue b}break};case 22:{c[31190]=1;c[31212]=k+1;continue b;break};case 9:{n=(Yd[c[31196]&127](l)|0)==0;c[31212]=(c[31212]|0)+1;if(n){break b}else{continue b}break};case 33:{c[32456]=1;c[31212]=k+1;continue b;break};case 21:{c[31190]=0;c[31212]=k+1;continue b;break};case 6:{n=c[124876+(k<<4)>>2]|0;t=(c[32428]|0)+1|0;c[32428]=t;c[129720+(t<<2)>>2]=n;c[31212]=k+1;continue b;break};case 2:{c[32428]=0;c[32444]=0;c[31212]=c[124876+(k<<4)>>2];if(b){q=24;break a}if((c[32440]|0)==0){j=0;q=37;break a}n=pe[c[31198]&7]()|0;if((n|0)==0){continue b}else{j=n;q=37;break a}break};case 16:{if(b){q=28;break a}c[31212]=k+1;continue b;break};case 18:{c[31188]=1;c[31212]=k+1;continue b;break};case 19:case 17:{c[31188]=0;c[31212]=k+1;continue b;break};case 20:{c[31208]=c[124876+(k<<4)>>2];c[31212]=k+1;continue b;break};default:{q=4;break a}}}if((q|0)==10){q=0;if(b){q=11;break}c[o>>2]=p+ -1;c[32440]=1;k=$d[c[31194]&63](l,g,d)|0;if((k|0)>0){q=13;break}if((k|0)<0){q=15;break}}k=h+1|0;if((k|0)<(c[a>>2]|0)){g=g+d|0;h=k}else{j=0;q=37;break}}if((q|0)==4){h=c[r>>2]|0;d=c[31128]|0;c[f>>2]=m;c[f+4>>2]=d;ld(h|0,129672,f|0)|0;if((c[c[31184]>>2]|0)==0){nM(100,129704);j=100;i=e;return j|0}else{c[(Ic()|0)>>2]=100;j=100;i=e;return j|0}}else if((q|0)==11){j=pe[c[31182]&7]()|0;i=e;return j|0}else if((q|0)==13){f=c[c[31184]>>2]|0;j=qM(f,c[(Ic()|0)>>2]|0,129768)|0;i=e;return j|0}else if((q|0)==15){if((c[(c[31184]|0)+8>>2]|0)==0){nM(-1,129768);j=-1;i=e;return j|0}else{c[(Ic()|0)>>2]=-1;j=-1;i=e;return j|0}}else if((q|0)==24){j=pe[c[31182]&7]()|0;i=e;return j|0}else if((q|0)==28){j=pe[c[31182]&7]()|0;i=e;return j|0}else if((q|0)==37){i=e;return j|0}return 0}function uM(a){a=a|0;var b=0;switch(a|0){case 14:case 13:case 15:case 12:case 11:case 5:case 4:{b=9;break};case 26:case 25:case 24:case 29:case 34:case 32:case 31:case 30:case 10:case 7:case 23:case 27:case 28:case 35:case 36:{b=8;break};default:{b=a}}i=i;return b|0}function vM(){var a=0,b=0,d=0;a=i;i=i+8|0;b=a;c[b>>2]=1;d=tM(b,0,0)|0;i=a;return d|0}function wM(){c[31204]=0;c[31212]=0;c[32444]=0;c[32428]=0;c[32440]=0;c[32446]=0;c[32430]=0;i=i;return}function xM(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[31212]|0;if((g|0)>299){mc(129848,24,1,c[r>>2]|0)|0;eM(c[31128]|0,1)}else{c[124872+(g<<4)>>2]=a;c[124876+(g<<4)>>2]=b;c[124880+(g<<4)>>2]=d;c[124884+(g<<4)>>2]=e;c[31212]=g+1;i=f;return g|0}return 0}function yM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a[b]|0;if(e<<24>>24==0){f=0;i=d;return f|0}else{g=b;h=e}a:while(1){e=g+1|0;if(h<<24>>24==32){h=a[e]|0;g=e;continue}e=zM(g)|0;if((e|0)==0){f=0;j=12;break}else{k=e}while(1){e=a[k]|0;if(e<<24>>24==41){j=9;break a}else if(e<<24>>24==44){j=7;break}else if(!(e<<24>>24==32)){l=k;break}k=k+1|0}if((j|0)==7){j=0;l=k+1|0}e=a[l]|0;if(e<<24>>24==0){f=0;j=12;break}else{g=l;h=e}}if((j|0)==9){h=(c[31216]|0)+ -1|0;c[31216]=h;if((h|0)==0){xM(2,c[31214]|0,0,0)|0;f=k+1|0;i=d;return f|0}else{xM(3,0,0,0)|0;f=k+1|0;i=d;return f|0}}else if((j|0)==12){i=d;return f|0}return 0}function zM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;do{if((a[b]|0)==41){g=b}else{if((AM(b,e)|0)!=0){g=c[e>>2]|0;break}if((BM(b,e)|0)!=0){g=c[e>>2]|0;break}h=CM(b,f,1)|0;j=xM(6,c[f>>2]|0,0,0)|0;if((j|0)<0){g=0;break}g=sM(h,j)|0}}while(0);i=d;return g|0}function AM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;a:do{switch(a[b]|0){case 112:case 80:{xM(20,1,0,0)|0;g=b;h=30;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{j=b;k=0;h=14;break};case 116:case 84:{l=b+1|0;m=a[l]|0;if(m<<24>>24==76|m<<24>>24==108){n=l;o=13}else if(m<<24>>24==82|m<<24>>24==114){n=l;o=14}else{n=b;o=15}l=CM(n+1|0,f,0)|0;if((l|0)==0){h=15;break a}xM(o,c[f>>2]|0,0,0)|0;g=l+ -1|0;h=30;break};case 58:{xM(16,0,0,0)|0;g=b;h=30;break};case 39:case 34:case 2:{c[124880+((xM(11,0,0,0)|0)<<4)>>2]=b;l=DM(b)|0;c[d>>2]=l;p=(l|0)!=0|0;i=e;return p|0};case 120:case 88:{xM(4,1,0,0)|0;g=b;h=30;break};case 98:case 66:{l=b+1|0;m=a[l]|0;if(m<<24>>24==90|m<<24>>24==122){xM(22,0,0,0)|0;g=l;h=30;break a}else{xM(21,0,0,0)|0;g=l;h=30;break a}break};case 36:{xM(33,0,0,0)|0;g=b;h=30;break};case 45:{q=1;h=13;break};case 47:{xM(5,0,0,0)|0;g=b;h=30;break};case 43:{q=0;h=13;break};case 115:case 83:{l=b+1|0;m=a[l]|0;if(m<<24>>24==83|m<<24>>24==115){r=l;s=19}else if(m<<24>>24==80|m<<24>>24==112){r=l;s=18}else{r=b;s=17}xM(s,0,0,0)|0;g=r;h=30;break};default:{p=0;i=e;return p|0}}}while(0);if((h|0)==13){j=b+1|0;k=q;h=14}b:do{if((h|0)==14){q=CM(j,f,0)|0;if((q|0)==0){h=15;break}switch(a[q]|0){case 112:case 80:{b=c[f>>2]|0;if((k|0)==0){t=b}else{r=0-b|0;c[f>>2]=r;t=r}xM(20,t,0,0)|0;g=q;h=30;break b;break};case 120:case 88:{xM(4,c[f>>2]|0,0,0)|0;g=q;h=30;break b;break};case 104:case 72:{r=c[f>>2]|0;c[124880+((xM(12,r,0,0)|0)<<4)>>2]=q+1;g=q+r|0;h=30;break b;break};default:{p=0;i=e;return p|0}}}}while(0);if((h|0)==15){c[d>>2]=0;p=1;i=e;return p|0}else if((h|0)==30){c[d>>2]=g+1;p=1;i=e;return p|0}return 0}function BM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=CM(b,f,1)|0;xM(6,c[f>>2]|0,0,0)|0;f=k+1|0;a:do{switch(a[k]|0){case 111:case 79:{l=32;m=34;n=38;break};case 97:case 65:{o=f;while(1){p=a[o]|0;if(p<<24>>24==32){o=o+1|0}else{break}}if(!((p+ -48<<24>>24&255)<10)){xM(30,0,0,0)|0;q=o;n=45;break a}r=CM(o,g,1)|0;s=c[g>>2]|0;if((s|0)==0){q=r;n=45;break a}xM(31,s,0,0)|0;q=r;n=45;break};case 100:case 68:{r=CM(f,g,0)|0;if((r|0)==0){n=4;break a}s=c[g>>2]|0;if((s|0)==0){q=r;n=45;break a}if((a[r]|0)==46){t=CM(r+1|0,h,0)|0;if((t|0)==0){n=4;break a}u=t;v=c[h>>2]|0}else{c[h>>2]=0;u=r;v=0}xM(26,s,v,0)|0;q=u;n=45;break};case 122:case 90:{l=35;m=36;n=38;break};case 103:case 71:{w=0;n=3;break};case 101:case 69:{w=1;n=3;break};case 108:case 76:{s=CM(f,g,0)|0;if((s|0)==0){n=4;break a}r=c[g>>2]|0;if((r|0)==0){q=s;n=45;break a}xM(29,r,0,0)|0;q=s;n=45;break};case 102:case 70:{s=CM(f,g,0)|0;if((s|0)==0){n=4;break a}r=c[g>>2]|0;if((r|0)==0){q=s;n=45;break a}if((a[s]|0)==46){t=CM(s+1|0,h,0)|0;if((t|0)==0){n=4;break a}x=t;y=c[h>>2]|0}else{c[h>>2]=0;x=s;y=0}xM(23,r,y,0)|0;q=x;n=45;break};case 105:case 73:{l=7;m=10;n=38;break};default:{c[31212]=(c[31212]|0)+ -1;c[d>>2]=b;z=0;i=e;return z|0}}}while(0);do{if((n|0)==3){b=CM(f,g,0)|0;if((b|0)==0){n=4;break}x=c[g>>2]|0;if((x|0)==0){q=b;n=45;break}y=a[b]|0;if(y<<24>>24==46){u=CM(b+1|0,h,0)|0;if((u|0)==0){n=4;break}A=u;B=a[u]|0}else{c[h>>2]=0;A=b;B=y}if(!(B<<24>>24==101|B<<24>>24==69)){xM((w|0)==1?24:27,x,c[h>>2]|0,0)|0;q=A;n=45;break}y=CM(A+1|0,j,0)|0;if((y|0)==0){n=4;break}xM((w|0)==1?25:28,x,c[h>>2]|0,c[j>>2]|0)|0;q=y;n=45}else if((n|0)==38){y=CM(f,g,0)|0;if((y|0)==0){n=4;break}x=c[g>>2]|0;if((x|0)==0){q=y;n=45;break}if((a[y]|0)!=46){xM(l,x,0,0)|0;q=y;n=45;break}b=CM(y+1|0,h,0)|0;if((b|0)==0){n=4;break}xM(m,x,c[h>>2]|0,0)|0;q=b;n=45}}while(0);if((n|0)==4){c[d>>2]=0;z=1;i=e;return z|0}else if((n|0)==45){c[d>>2]=q;z=1;i=e;return z|0}return 0}function CM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b;b=0;h=0;while(1){j=a[g]|0;k=j<<24>>24;if(j<<24>>24==32){l=b;m=h}else{if((j+ -48<<24>>24&255)>9){break}l=b+1|0;m=(h*10|0)+ -48+k|0}g=g+1|0;b=l;h=m}if((b|0)!=0){n=g;o=h;c[d>>2]=o;i=f;return n|0}n=(e|0)==0?0:g;o=e;c[d>>2]=o;i=f;return n|0}function DM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a[b]|0;f=b+1|0;g=a[f]|0;a:do{if(!(g<<24>>24==0)){h=f;j=g;k=b;while(1){if(j<<24>>24==e<<24>>24){l=k+2|0;if((a[l]|0)==e<<24>>24){m=l}else{n=l;break}}else{m=h}l=m+1|0;o=a[l]|0;if(o<<24>>24==0){break a}else{h=l;j=o;k=m}}i=d;return n|0}}while(0);if((c[c[31184]>>2]|0)==0){nM(100,129832);n=0;i=d;return n|0}else{c[(Ic()|0)>>2]=100;n=0;i=d;return n|0}return 0}function EM(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;do{if((b|0)>0){h=0;j=b}else{if((b|0)<0){h=1;j=0-b|0;break}c[e>>2]=0;c[d>>2]=1;a[129902|0]=48;k=129902|0;i=g;return k|0}}while(0);c[e>>2]=h;h=23;e=j;while(1){j=h+ -1|0;l=129880+j|0;a[l]=((e>>>0)%(f>>>0)|0)+48;b=(e>>>0)/(f>>>0)|0;if((b|0)==0){break}else{e=b;h=j}}c[d>>2]=24-h;k=l;i=g;return k|0}function FM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[31206]|0;f=c[31202]|0;if((e|0)>(f|0)){c[31202]=e;g=e}else{g=f}f=g+1|0;if((f|0)<(c[32494]|0)){h=g}else{GM(f,g);h=c[31202]|0}g=c[32496]|0;f=g+h|0;if((b|0)==0){j=f}else{a[f]=b;j=g+(h+1)|0}a[j]=0;yd(g|0,c[31180]|0)|0;h=bZ(g|0)|0;b=g+h|0;if(b>>>0<j>>>0){k=b;l=h;m=g}else{i=d;return 0}while(1){g=l+1|0;h=m+g|0;Gd(a[k]|0,c[31180]|0)|0;yd(h|0,c[31180]|0)|0;b=bZ(h|0)|0;f=m+(g+b)|0;if(f>>>0<j>>>0){m=h;l=b;k=f}else{break}}i=d;return 0}function GM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[32496]|0;if((f|0)==130064){c[32494]=1024;g=1024}else{g=c[32494]|0}if((g|0)>(b|0)){h=g}else{j=g;do{j=j<<1;}while((j|0)<=(b|0));c[32494]=j;h=j}j=zY(h)|0;if((j|0)==0){nM(113,130464);k=c[32496]|0}else{k=f}f=k+d|0;if((d|0)>0){d=j;h=k;while(1){b=h+1|0;a[d]=a[h]|0;if(b>>>0<f>>>0){h=b;d=d+1|0}else{break}}l=c[32496]|0}else{l=k}if((l|0)==130064){m=129984;c[32496]=j;i=e;return}AY(l);m=129984;c[32496]=j;i=e;return}function HM(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[31202]|0;f=c[32494]|0;if((e|0)<(f|0)){g=e}else{GM(e,f);g=c[31202]|0}c[31202]=g+1;a[(c[32496]|0)+g|0]=b;i=d;return}function IM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d;f=i;i=i+256|0;g=i;i=i+16|0;h=i;i=i+8|0;j=f;c[31166]=1;f=b+4|0;k=c[f>>2]|0;if(k>>>0>99){if((c[b>>2]|0)==0){nM(101,129992);l=101;i=d;return l|0}else{c[(Ic()|0)>>2]=101;l=101;i=d;return l|0}}if((c[31178]|0)==0){oM();m=c[f>>2]|0}else{m=k}k=119648+(m*48|0)|0;c[29902]=k;n=k;a:do{if((c[n>>2]|0)!=0){k=c[b+8>>2]|0;do{if((k|0)!=0){NM(k,c[b+12>>2]|0,j);o=OM(j,h)|0;if((o|0)==(c[119656+(m*48|0)>>2]|0)){if((c[h>>2]|0)==(c[119660+(m*48|0)>>2]|0)){break}}c[g+4>>2]=c[f>>2];c[g+8>>2]=0;c[g>>2]=c[b>>2];o=jM(g)|0;if((o|0)==0){break a}else{l=o}i=d;return l|0}}while(0);k=c[b+32>>2]|0;if((k|0)==0){l=0;i=d;return l|0}o=a[k]|0;if(o<<24>>24==122){p=1}else{p=o<<24>>24==90|0}c[119680+(m*48|0)>>2]=p;l=0;i=d;return l|0}}while(0);p=b+28|0;g=c[p>>2]|0;h=119664+(m*48|0)|0;c[h>>2]=g;o=c[b+32>>2]|0;do{if((o|0)==0){q=0}else{k=a[o]|0;if(k<<24>>24==122){q=1;break}q=k<<24>>24==90|0}}while(0);c[119680+(m*48|0)>>2]=q;q=c[b+24>>2]|0;do{if((q|0)==0){o=119672+(m*48|0)|0;if((g|0)>0){c[o>>2]=0;r=0;break}else{c[o>>2]=1;r=1;break}}else{o=a[q]|0;if(o<<24>>24==70|o<<24>>24==102){c[119672+(m*48|0)>>2]=1;r=1;break}else{c[119672+(m*48|0)>>2]=0;r=0;break}}}while(0);q=c[b+8>>2]|0;do{if((q|0)==0){c[e>>2]=c[f>>2];dc(j|0,13e4,e|0)|0}else{NM(q,c[b+12>>2]|0,j);if((a[j]|0)!=0){break}if((c[b>>2]|0)==0){JM(107,129992,b);l=107;i=d;return l|0}else{c[(Ic()|0)>>2]=107;l=107;i=d;return l|0}}}while(0);q=119692+(m*48|0)|0;c[q>>2]=0;c[119684+(m*48|0)>>2]=0;e=119688+(m*48|0)|0;c[e>>2]=0;c[n>>2]=0;f=119676+(m*48|0)|0;c[f>>2]=3;g=c[b+16>>2]|0;b:do{if((g|0)!=0){c:do{switch(a[g]|0){case 82:case 114:{break};case 83:case 115:{c[q>>2]=1;o=Hb()|0;c[n>>2]=o;if((o|0)!=0){c[119652+(m*48|0)>>2]=0;c[119660+(m*48|0)>>2]=-1;c[119656+(m*48|0)>>2]=-1;c[119668+(m*48|0)>>2]=1;l=0;i=d;return l|0}o=(c[b>>2]|0)==0;k=Ic()|0;s=c[k>>2]|0;if(o){JM(s,129992,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=s;l=s;i=d;return l|0}break};case 78:case 110:{if((xc(j|0,0)|0)!=0){break c}if((c[b>>2]|0)==0){JM(128,129992,b);l=128;i=d;return l|0}else{c[(Ic()|0)>>2]=128;l=128;i=d;return l|0}break};case 79:case 111:{if((xc(j|0,0)|0)==0){break b}s=(c[b>>2]|0)==0;k=Ic()|0;o=c[k>>2]|0;if(s){JM(o,129992,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=o;l=o;i=d;return l|0}break};default:{break b}}}while(0);o=ec(j|0,c[32490]|0)|0;if((o|0)==0){break}Sc(o|0)|0}}while(0);q=zY((bZ(j|0)|0)+1|0)|0;c[119652+(m*48|0)>>2]=q;if((q|0)==0){if((c[b>>2]|0)==0){JM(113,130016,b);l=113;i=d;return l|0}else{c[(Ic()|0)>>2]=113;l=113;i=d;return l|0}}hZ(q|0,j|0)|0;q=b+20|0;if((c[q>>2]|0)==0){t=r}else{t=(c[h>>2]|0)==0?r:0}r=ec(j|0,c[129960+((t|2)<<2)>>2]|0)|0;do{if((r|0)==0){h=ec(j|0,c[129920+(t<<2)>>2]|0)|0;if((h|0)!=0){c[f>>2]=1;u=h;break}h=ec(j|0,c[129960+(t<<2)>>2]|0)|0;if((h|0)!=0){c[e>>2]=1;c[f>>2]=2;u=h;break}h=(c[b>>2]|0)==0;g=Ic()|0;o=c[g>>2]|0;if(h){nM(o,129992);l=c[g>>2]|0;i=d;return l|0}else{c[g>>2]=o;l=o;i=d;return l|0}}else{u=r}}while(0);c[n>>2]=u;r=119668+(m*48|0)|0;c[r>>2]=mM(u)|0;u=OM(j,119660+(m*48|0)|0)|0;c[119656+(m*48|0)>>2]=u;if((u|0)==-1){if((c[b>>2]|0)==0){JM(108,129992,b);l=108;i=d;return l|0}else{c[(Ic()|0)>>2]=108;l=108;i=d;return l|0}}if((c[r>>2]|0)==0){l=0;i=d;return l|0}if((c[p>>2]|0)!=0){mb(c[n>>2]|0);l=0;i=d;return l|0}p=c[q>>2]|0;if((p|0)==0){l=0;i=d;return l|0}q=a[p]|0;if(!(q<<24>>24==65|q<<24>>24==97)){l=0;i=d;return l|0}if((Qc(c[n>>2]|0,0,2)|0)==0){l=0;i=d;return l|0}if((c[b>>2]|0)==0){JM(129,129992,b);l=129;i=d;return l|0}else{c[(Ic()|0)>>2]=129;l=129;i=d;return l|0}return 0}function JM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d+8|0;g=c[f>>2]|0;if((g|0)==0){nM(a,b);i=e;return}h=d+12|0;d=c[h>>2]|0;if((d|0)<(c[32494]|0)){j=d;k=g}else{GM(d,0);j=c[h>>2]|0;k=c[f>>2]|0}f=c[32496]|0;c[(c[29902]|0)+4>>2]=f;NM(k,j,f);nM(a,b);i=e;return}function KM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+40|0;j=g;c[f>>2]=d;dc(j|0,13e4,f|0)|0;c[h>>2]=1;c[h+4>>2]=d;c[h+8>>2]=j;c[h+12>>2]=bZ(j|0)|0;c[h+16>>2]=0;c[h+20>>2]=(a|0)==3?130032:130040;c[h+24>>2]=(b|0)==5?130048:130056;c[h+28>>2]=(a|0)==4;c[h+32>>2]=0;a=IM(h)|0;i=e;return a|0}function LM(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=119648+(d*48|0)|0;c[29902]=e;if(d>>>0>99){if((c[a>>2]|0)==0){nM(101,130480);f=101;i=b;return f|0}else{c[(Ic()|0)>>2]=101;f=101;i=b;return f|0}}do{if((c[e>>2]|0)==0){if((KM(3,5,d)|0)==0){break}if((c[a>>2]|0)==0){nM(114,130488);f=114;i=b;return f|0}else{c[(Ic()|0)>>2]=114;f=114;i=b;return f|0}}}while(0);if((c[119672+(d*48|0)>>2]|0)!=0){f=0;i=b;return f|0}if((c[a>>2]|0)==0){nM(102,130488);f=102;i=b;return f|0}else{c[(Ic()|0)>>2]=102;f=102;i=b;return f|0}return 0}function MM(){var a=0,b=0;a=i;b=vM()|0;c[31128]=0;i=a;return b|0}function NM(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+c|0;g=d+c|0;while(1){if(!(f>>>0>b>>>0)){h=3;break}j=f+ -1|0;k=g+ -1|0;if((a[j]|0)==32){f=j;g=k}else{break}}if((h|0)==3){a[d]=0;i=e;return}a[g]=0;g=j;j=k;while(1){a[j]=a[g]|0;if(g>>>0>b>>>0){j=j+ -1|0;g=g+ -1|0}else{break}}i=e;return}function OM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+80|0;e=d;if((hc(a|0,e|0)|0)<0){f=-1;i=d;return f|0}c[b>>2]=c[e>>2];f=c[e+72>>2]|0;i=d;return f|0}function PM(b,d,e,f,j){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=i;i=i+56|0;p=o;q=(f|0)<1?2:f;r=c[31208]|0;if((r|0)==0){s=3}else{if((r|0)<(e+2|0)&(r|0)>(0-e|0)){s=3}}a:do{if((s|0)==3){t=(((r|0)<1)<<31>>31)+e|0;if((j|0)==4){u=+g[b>>2]}else{u=+h[b>>3]}do{if(u<0.0){v=-u;w=1;x=1}else{y=c[31188]|0;if(u!=0.0){v=u;w=0;x=y;break}v=0.0;w=0;x=y}}while(0);y=d+ -4-q-t-x|0;if((y|0)<0){break}z=((r|0)<0?r:0)+t|0;A=(z|0)>40;B=A?40:z;C=A?z+ -40|0:0;c[n>>2]=B;z=n+4|0;h[k>>3]=v;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];dc(p|0,130496,n|0)|0;z=a[p]|0;if(!((z+ -48|0)>>>0<10)){if((z|0)==78|(z|0)==110){D=0}else{D=x}z=d-(bZ(p|0)|0)-D|0;if((z|0)<0){break}if((z|0)>0){A=z;do{A=A+ -1|0;Vd[c[31192]&511](32);}while((A|0)>0)}if((D|0)!=0){Vd[c[31192]&511]((w|0)!=0?45:43)}A=a[p]|0;if(A<<24>>24==0){i=l;return 0}else{E=A;F=p}do{Vd[c[31192]&511](E<<24>>24);F=F+1|0;E=a[F]|0;}while(!(E<<24>>24==0));i=l;return 0}A=o+(B+3)|0;if(v!=0.0){t=(Ac(A|0)|0)+1|0;c[m>>2]=t-(c[31208]|0);dc(A|0,130504,m|0)|0}else{t=A;a[t]=3158059;a[t+1|0]=12336;a[t+2|0]=48;a[t+3|0]=0}t=o+(B+4)|0;A=(q|0)<2;if(A){if((a[t]|0)!=48){break}}z=o+(B+6)|0;G=(a[z]|0)==0;b:do{if(G){H=2}else{if((f|0)==0){I=o+(B+2)|0;while(1){J=I+1|0;K=a[J]|0;a[I]=K;if(K<<24>>24==0){H=2;break b}else{I=J}}}I=(f|0)<0;if(I|G){H=I?q:2;break}else{L=2;M=z}while(1){if((L|0)>=(q|0)){break a}I=L+1|0;J=M+1|0;if((a[J]|0)==0){H=I;break}else{L=I;M=J}}}}while(0);if((y|0)>0){z=y;do{z=z+ -1|0;Vd[c[31192]&511](32);}while((z|0)>0)}if((x|0)!=0){Vd[c[31192]&511]((w|0)!=0?45:43)}z=c[31208]|0;do{if((z|0)<1){Vd[c[31192]&511](46);y=c[31192]|0;if((z|0)<0){G=y;J=z;while(1){Vd[G&511](48);I=J+1|0;K=c[31192]|0;if((I|0)<0){J=I;G=K}else{N=K;break}}}else{N=y}Vd[N&511](a[p]|0);O=o+2|0}else{if((z|0)<=1){O=p;break}Vd[c[31192]&511](a[p]|0);G=o+2|0;J=z+ -1|0;K=c[31192]|0;if((J|0)>0){I=z+1|0;P=K;Q=J;J=G;while(1){Vd[P&511](a[J]|0);R=Q+ -1|0;S=c[31192]|0;if((R|0)>0){J=J+1|0;Q=R;P=S}else{break}}T=S;U=o+I|0}else{T=K;U=G}Vd[T&511](46);O=U}}while(0);if((C|0)==0){V=O}else{z=o+(B+2)|0;if(O>>>0<z>>>0){P=O;while(1){Q=P+1|0;Vd[c[31192]&511](a[P]|0);if(Q>>>0<z>>>0){P=Q}else{W=Q;break}}}else{W=O}P=C;while(1){Vd[c[31192]&511](48);z=P+ -1|0;if((z|0)>0){P=z}else{V=W;break}}}if(V>>>0<t>>>0){P=V;while(1){C=P+1|0;Vd[c[31192]&511](a[P]|0);if(C>>>0<t>>>0){P=C}else{X=C;break}}}else{X=V}if(A){Vd[c[31192]&511](a[X+1|0]|0);i=l;return 0}if((H|0)<(q|0)){P=H;do{P=P+1|0;Vd[c[31192]&511](48);}while((P|0)<(q|0))}P=a[X]|0;if(P<<24>>24==0){i=l;return 0}else{Y=P;Z=X}do{Z=Z+1|0;Vd[c[31192]&511](Y<<24>>24);Y=a[Z]|0;}while(!(Y<<24>>24==0));i=l;return 0}}while(0);if((d|0)>0){_=d}else{i=l;return 0}do{_=_+ -1|0;Vd[c[31192]&511](42);}while((_|0)>0);i=l;return 0}function QM(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;l=j;m=i;i=i+656|0;n=m;if((f|0)==4){o=+g[b>>2]}else{o=+h[b>>3]}b=(e|0)<344;f=b?e:344;p=b?0:e+ -344|0;do{if(o<0.0){q=1;r=-o}else{if(o!=0.0){q=0;r=o;break}q=0;r=0.0}}while(0);e=c[31208]|0;if((e|0)==0){s=r}else{if((e|0)>0){b=e;o=r;while(1){t=o*10.0;u=b+ -1|0;if((u|0)>0){o=t;b=u}else{s=t;break}}}else{b=e;o=r;while(1){r=o*.1;e=b+1|0;if((e|0)<0){o=r;b=e}else{s=r;break}}}}c[l>>2]=f;b=l+4|0;h[k>>3]=s;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=(dc(n|0,130512,l|0)|0)+p|0;if((a[n]|0)!=48|(f|0)==0){v=n;w=b}else{v=m+1|0;w=b+ -1|0}a:do{if((q|0)==1){b=v;while(1){m=a[b]|0;if(!(m<<24>>24==48)){n=m<<24>>24;if((n|0)==0){x=0;break a}else if((n|0)!=46){break}}b=b+1|0}x=1}else{x=q}}while(0);q=(x|0)==0;b=((c[31188]|x|0)!=0)+w|0;if((b|0)>(d|0)){if((d|0)>0){y=d}else{i=j;return 0}do{y=y+ -1|0;Vd[c[31192]&511](42);}while((y|0)>0);i=j;return 0}y=d-b|0;if((y|0)>0){b=y;do{b=b+ -1|0;Vd[c[31192]&511](32);}while((b|0)>0)}do{if(q){if((c[31188]|0)==0){break}Vd[c[31192]&511](43)}else{Vd[c[31192]&511](45)}}while(0);q=a[v]|0;if(!(q<<24>>24==0)){b=q;q=v;do{q=q+1|0;Vd[c[31192]&511](b<<24>>24);b=a[q]|0;}while(!(b<<24>>24==0))}if((p|0)>0){z=p}else{i=j;return 0}do{z=z+ -1|0;Vd[c[31192]&511](48);}while((z|0)>0);i=j;return 0}function RM(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((f|0)==4){h=c[d>>2]|0}else if((f|0)==1){h=a[d]|0}else{h=b[d>>1]|0}d=e+ -1|0;if((d|0)>0){e=0;do{Vd[c[31192]&511](32);e=e+1|0;}while((e|0)<(d|0))}d=c[31192]|0;if((h|0)==0){Vd[d&511](70);i=g;return 0}else{Vd[d&511](84);i=g;return 0}return 0}function SM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;do{if((c[31204]|0)!=0){g=TM()|0;if((g|0)==0){break}else{h=g}i=e;return h|0}}while(0);g=c[a>>2]|0;switch(g|0){case 25:case 24:case 26:{h=PM(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 28:case 27:{h=YM(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 31:{XM(b,c[a+4>>2]|0,d);h=0;i=e;return h|0};case 36:{ZM(b,c[a+4>>2]|0,c[a+8>>2]|0,d);h=0;i=e;return h|0};case 10:{VM(b,c[a+4>>2]|0,c[a+8>>2]|0,d,10);h=0;i=e;return h|0};case 23:{h=QM(b,c[a+4>>2]|0,c[a+8>>2]|0,d)|0;i=e;return h|0};case 29:{RM(b,c[a+4>>2]|0,d)|0;h=0;i=e;return h|0};case 30:{WM(b,d);h=0;i=e;return h|0};case 32:{UM(b,c[a+4>>2]|0,d,8);h=0;i=e;return h|0};case 34:{VM(b,c[a+4>>2]|0,c[a+8>>2]|0,d,8);h=0;i=e;return h|0};case 35:{ZM(b,c[a+4>>2]|0,0,d);h=0;i=e;return h|0};case 7:{UM(b,c[a+4>>2]|0,d,10);h=0;i=e;return h|0};default:{h=c[r>>2]|0;c[f>>2]=g;ld(h|0,130520,f|0)|0;eM(c[31128]|0,1)}}return 0}function TM(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=c[31204]|0;c[31204]=0;if((c[31166]|0)!=0){if((b|0)>0){d=c[31206]|0;e=c[31202]|0;if((d|0)<=(e|0)){f=b;while(1){Vd[c[31192]&511](32);g=f+ -1|0;if((g|0)>0){f=g}else{h=0;break}}i=a;return h|0}f=e+b|0;if((d|0)>(f|0)){c[31202]=f;h=0;i=a;return h|0}f=b-d+e|0;c[31202]=d;if((f|0)>0){j=f}else{h=0;i=a;return h|0}while(1){Vd[c[31192]&511](32);f=j+ -1|0;if((f|0)>0){j=f}else{h=0;break}}i=a;return h|0}if((b|0)>=0){h=0;i=a;return h|0}j=c[31202]|0;f=j+b|0;if((f|0)>=0){if((c[31206]|0)<(j|0)){c[31206]=j}c[31202]=f;h=0;i=a;return h|0}if((c[c[31184]>>2]|0)==0){nM(110,130608);h=110;i=a;return h|0}else{c[(Ic()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<0){f=c[31202]|0;if((c[31206]|0)<(f|0)){c[31206]=f}j=f+b|0;c[31202]=j;c[31210]=(c[31210]|0)+b;if((j|0)>=0){h=0;i=a;return h|0}if((c[c[31184]>>2]|0)==0){nM(110,130608);h=110;i=a;return h|0}else{c[(Ic()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<=0){h=0;i=a;return h|0}j=c[31202]|0;f=j+b|0;if((f|0)>=(c[(c[31186]|0)+16>>2]|0)){if((c[c[31184]>>2]|0)==0){nM(110,130624);h=110;i=a;return h|0}else{c[(Ic()|0)>>2]=110;h=110;i=a;return h|0}}d=c[31206]|0;if((d|0)<=(j|0)){e=b;while(1){Vd[c[31192]&511](32);g=e+ -1|0;if((g|0)>0){e=g}else{h=0;break}}i=a;return h|0}if((d|0)>(f|0)){c[31210]=(c[31210]|0)+b;c[31202]=f;h=0;i=a;return h|0}f=d-j|0;j=b-f|0;c[31210]=(c[31210]|0)+f;c[31202]=d;if((j|0)>0){k=j}else{h=0;i=a;return h|0}while(1){Vd[c[31192]&511](32);j=k+ -1|0;if((j|0)>0){k=j}else{h=0;break}}i=a;return h|0}function UM(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;k=h+8|0;if((f|0)==4){l=c[d>>2]|0}else if((f|0)==1){l=a[d]|0}else{l=b[d>>1]|0}d=EM(l,j,k,g)|0;g=c[k>>2]|0;l=(((c[31188]|g|0)!=0)<<31>>31)+(e-(c[j>>2]|0))|0;if((l|0)<0){if((e|0)>0){m=0}else{i=h;return}do{Vd[c[31192]&511](42);m=m+1|0;}while((m|0)<(e|0));i=h;return}if((l|0)>0){e=0;do{Vd[c[31192]&511](32);e=e+1|0;}while((e|0)<(l|0));n=c[k>>2]|0}else{n=g}do{if((n|0)==0){if((c[31188]|0)==0){break}Vd[c[31192]&511](43)}else{Vd[c[31192]&511](45)}}while(0);if((c[j>>2]|0)>0){o=d;p=0}else{i=h;return}while(1){Vd[c[31192]&511](a[o]|0);d=p+1|0;if((d|0)<(c[j>>2]|0)){p=d;o=o+1|0}else{break}}i=h;return}function VM(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;l=j+8|0;if((g|0)==1){m=a[d]|0}else if((g|0)==4){m=c[d>>2]|0}else{m=b[d>>1]|0}d=EM(m,k,l,h)|0;h=c[l>>2]|0;g=(c[31188]|h|0)!=0;n=g&1;o=c[k>>2]|0;do{if((n+o|0)<=(e|0)){if((n+f|0)>(e|0)){break}if((m|f|0)==0){if((e|0)>0){p=0}else{i=j;return}do{Vd[c[31192]&511](32);p=p+1|0;}while((p|0)<(e|0));i=j;return}q=e-((o|0)<(f|0)?f:o)+(g<<31>>31)|0;if((q|0)>0){r=0;do{Vd[c[31192]&511](32);r=r+1|0;}while((r|0)<(q|0));s=c[l>>2]|0}else{s=h}do{if((s|0)==0){if((c[31188]|0)==0){break}Vd[c[31192]&511](43)}else{Vd[c[31192]&511](45)}}while(0);q=c[k>>2]|0;if((f-q|0)>0){r=0;while(1){Vd[c[31192]&511](48);t=r+1|0;u=c[k>>2]|0;if((t|0)<(f-u|0)){r=t}else{v=u;break}}}else{v=q}if((v|0)>0){w=d;x=0}else{i=j;return}while(1){Vd[c[31192]&511](a[w]|0);r=x+1|0;if((r|0)<(c[k>>2]|0)){x=r;w=w+1|0}else{break}}i=j;return}}while(0);if((e|0)>0){y=0}else{i=j;return}do{Vd[c[31192]&511](42);y=y+1|0;}while((y|0)<(e|0));i=j;return}function WM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)>0){f=b;g=d}else{i=e;return}while(1){d=g+ -1|0;Vd[c[31192]&511](a[f]|0);if((d|0)>0){g=d;f=f+1|0}else{break}}i=e;return}function XM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if((d|0)>(e|0)){g=d;while(1){h=g+ -1|0;Vd[c[31192]&511](32);if((h|0)>(e|0)){g=h}else{j=e;break}}}else{j=d}if((j|0)>0){k=b;l=j}else{i=f;return}while(1){j=l+ -1|0;Vd[c[31192]&511](a[k]|0);if((j|0)>0){l=j;k=k+1|0}else{break}}i=f;return}function YM(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0,n=0,o=0,p=0;j=i;if((f|0)==4){k=+g[a>>2]}else{k=+h[a>>3]}if(k<0.0){l=-k}else{l=k}a:do{if(l<.1){if(!(l!=0.0)){m=1;break}n=PM(a,b,d,e,f)|0;i=j;return n|0}else{if((d|0)>=0){o=0;k=1.0;while(1){if(!(l>=k)){m=o;break a}if((o|0)<(d|0)){o=o+1|0;k=k*10.0}else{break}}}n=PM(a,b,d,e,f)|0;i=j;return n|0}}while(0);o=c[31208]|0;c[31208]=0;p=(e|0)==0?4:e+2|0;e=QM(a,b-p|0,d-m|0,f)|0;if((p|0)>0){f=0;do{Vd[c[31192]&511](32);f=f+1|0;}while((f|0)<(p|0))}c[31208]=o;n=e;i=j;return n|0}function ZM(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;k=b+(g+ -1)|0;a:do{if((k|0)==(j|0)){l=1;m=j}else{g=k;while(1){n=g+ -1|0;if((a[g]|0)!=0){l=0;m=g;break a}if((n|0)==(j|0)){l=1;m=j;break}else{g=n}}}}while(0);k=((d[m]|0)>15)+(m-b<<1|1)|0;if((k|0)>(e|0)){if((e|0)>0){o=0}else{i=h;return}do{Vd[c[31192]&511](42);o=o+1|0;}while((o|0)<(e|0));i=h;return}o=f-k|0;b=(o|0)>0;g=b?f:k;if((g|0)<(e|0)){k=e;do{k=k+ -1|0;Vd[c[31192]&511](32);}while((k|0)>(g|0))}if(b){b=o;do{b=b+ -1|0;Vd[c[31192]&511](48);}while((b|0)>0)}b=a[m]|0;do{if((b&240|0)==0){Vd[c[31192]&511](a[130584+(b&15)|0]|0);if(l){i=h;return}else{p=m+ -1|0;break}}else{p=m}}while(0);while(1){Vd[c[31192]&511](a[130584+((d[p]|0)>>>4)|0]|0);Vd[c[31192]&511](a[130584+(a[p]&15)|0]|0);if((p|0)==(j|0)){break}p=p+ -1|0}i=h;return}function _M(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=c[a>>2]|0;switch(e|0){case 12:{f=aN(c[a+4>>2]|0,c[a+8>>2]|0)|0;i=b;return f|0};case 11:{f=$M(c[a+8>>2]|0)|0;i=b;return f|0};case 5:{f=pe[c[31200]&7]()|0;i=b;return f|0};case 15:{c[31204]=(c[a+4>>2]|0)+ -1-(c[31202]|0);f=1;i=b;return f|0};case 4:case 14:{c[31204]=(c[31204]|0)+(c[a+4>>2]|0);f=1;i=b;return f|0};case 13:{g=(c[31204]|0)-(c[a+4>>2]|0)|0;a=0-(c[31202]|0)|0;c[31204]=(g|0)<(a|0)?a:g;f=1;i=b;return f|0};default:{f=c[r>>2]|0;c[d>>2]=e;ld(f|0,130552,d|0)|0;eM(c[31128]|0,1)}}return 0}function $M(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;do{if((c[31204]|0)!=0){e=TM()|0;if((e|0)==0){break}else{f=e}i=d;return f|0}}while(0);e=a[b]|0;g=b+1|0;h=a[g]|0;if(h<<24>>24==0){f=1;i=d;return f|0}else{j=g;k=h;l=b}while(1){if(k<<24>>24==e<<24>>24){b=l+2|0;if(!((a[b]|0)==e<<24>>24)){f=1;m=9;break}Vd[c[31192]&511](e<<24>>24);n=b}else{Vd[c[31192]&511](k<<24>>24);n=j}b=n+1|0;h=a[b]|0;if(h<<24>>24==0){f=1;m=9;break}else{j=b;k=h;l=n}}if((m|0)==9){i=d;return f|0}return 0}function aN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;do{if((c[31204]|0)!=0){f=TM()|0;if((f|0)==0){break}else{g=f}i=e;return g|0}}while(0);if((b|0)==0){g=1;i=e;return g|0}else{h=d;j=b}while(1){b=j+ -1|0;Vd[c[31192]&511](a[h]|0);if((b|0)==0){g=1;break}else{j=b;h=h+1|0}}i=e;return g|0}function bN(){var a=0,b=0;a=i;b=FM(10)|0;c[31204]=0;c[31202]=0;c[31206]=0;i=a;return(b|0)==0|0}function cN(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((c[31178]|0)==0){oM()}c[31142]=0;c[31148]=1;c[31156]=1;c[31166]=1;d=LM(a)|0;if((d|0)!=0){e=d;i=b;return e|0}c[31184]=a;c[31202]=0;c[31204]=0;c[31206]=0;c[32456]=0;c[31208]=0;d=c[a+12>>2]|0;c[31128]=d;c[31180]=c[c[29902]>>2];if((rM(d)|0)<0){if((c[a>>2]|0)==0){nM(100,130632);e=100;i=b;return e|0}else{c[(Ic()|0)>>2]=100;e=100;i=b;return e|0}}c[31192]=279;c[31194]=43;c[31196]=111;c[31182]=4;c[31198]=5;c[31200]=6;wM();c[31188]=0;d=c[29902]|0;c[31190]=c[d+32>>2];if((c[d+40>>2]|0)==1){e=0;i=b;return e|0}if((pM(d)|0)==0){e=0;i=b;return e|0}d=(c[a>>2]|0)==0;a=Ic()|0;f=c[a>>2]|0;if(d){nM(f,130640);e=c[a>>2]|0;i=b;return e|0}else{c[a>>2]=f;e=f;i=b;return e|0}return 0}function dN(){var a=0,b=0;a=i;if((c[32456]|0)==0){b=FM(10)|0}else{FM(0)|0;jd(c[31180]|0)|0;b=0}c[31204]=0;c[31202]=0;c[31206]=0;i=a;return b|0}function eN(){var a=0,b=0,d=0;a=i;if((c[32440]|0)==0){b=0}else{d=FM(10)|0;c[32440]=0;b=d}c[31204]=0;c[31202]=0;c[31206]=0;i=a;return b|0}function fN(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;BN(131368,h,131424);c[32664]=132876;c[130664>>2]=132896;c[130660>>2]=0;sP(130664|0,131368);c[130736>>2]=0;c[130740>>2]=-1;j=c[t>>2]|0;c[32868]=132744;aV(131476|0);k=131480|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[32868]=131984;c[131504>>2]=j;bV(g,131476|0);k=eV(g,135536)|0;l=k;cV(g);c[131508>>2]=l;c[131512>>2]=131432;a[131516|0]=(Yd[c[(c[k>>2]|0)+28>>2]&127](l)|0)&1;c[32686]=132956;c[130748>>2]=132976;sP(130748|0,131472);c[130820>>2]=0;c[130824>>2]=-1;l=c[r>>2]|0;c[32880]=132744;aV(131524|0);k=131528|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[32880]=131984;c[131552>>2]=l;bV(f,131524|0);k=eV(f,135536)|0;g=k;cV(f);c[131556>>2]=g;c[131560>>2]=131440;a[131564|0]=(Yd[c[(c[k>>2]|0)+28>>2]&127](g)|0)&1;c[32708]=132956;c[130836>>2]=132976;sP(130836|0,131520);c[130908>>2]=0;c[130912>>2]=-1;g=c[(c[(c[32708]|0)+ -12>>2]|0)+130856>>2]|0;c[32730]=132956;c[130924>>2]=132976;sP(130924|0,g);c[130996>>2]=0;c[131e3>>2]=-1;c[(c[(c[32664]|0)+ -12>>2]|0)+130728>>2]=130744;g=(c[(c[32708]|0)+ -12>>2]|0)+130836|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[32708]|0)+ -12>>2]|0)+130904>>2]=130744;nN(131568,h,131448|0);c[32752]=132916;c[131016>>2]=132936;c[131012>>2]=0;sP(131016|0,131568);c[131088>>2]=0;c[131092>>2]=-1;c[32906]=132808;aV(131628|0);h=131632|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[32906]=131728;c[131656>>2]=j;bV(e,131628|0);j=eV(e,135544)|0;h=j;cV(e);c[131660>>2]=h;c[131664>>2]=131456;a[131668|0]=(Yd[c[(c[j>>2]|0)+28>>2]&127](h)|0)&1;c[32774]=132996;c[131100>>2]=133016;sP(131100|0,131624);c[131172>>2]=0;c[131176>>2]=-1;c[32918]=132808;aV(131676|0);h=131680|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[32918]=131728;c[131704>>2]=l;bV(d,131676|0);l=eV(d,135544)|0;h=l;cV(d);c[131708>>2]=h;c[131712>>2]=131464;a[131716|0]=(Yd[c[(c[l>>2]|0)+28>>2]&127](h)|0)&1;c[32796]=132996;c[131188>>2]=133016;sP(131188|0,131672);c[131260>>2]=0;c[131264>>2]=-1;h=c[(c[(c[32796]|0)+ -12>>2]|0)+131208>>2]|0;c[32818]=132996;c[131276>>2]=133016;sP(131276|0,h);c[131348>>2]=0;c[131352>>2]=-1;c[(c[(c[32752]|0)+ -12>>2]|0)+131080>>2]=131096;h=(c[(c[32796]|0)+ -12>>2]|0)+131188|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[32796]|0)+ -12>>2]|0)+131256>>2]=131096;i=b;return}function gN(a){a=a|0;a=i;qQ(130744)|0;qQ(130920)|0;xQ(131096)|0;xQ(131272)|0;i=a;return}function hN(a){a=a|0;var b=0;b=i;c[a>>2]=132808;cV(a+4|0);i=b;return}function iN(a){a=a|0;var b=0;b=i;c[a>>2]=132808;cV(a+4|0);HY(a);i=b;return}function jN(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;Yd[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=eV(d,135544)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(Yd[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function kN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=me[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((mc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((jd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function lN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((a[b+44|0]|0)!=0){g=mc(d|0,4,e|0,c[b+32>>2]|0)|0;i=f;return g|0}if((e|0)>0){h=d;j=0}else{g=0;i=f;return g|0}while(1){if((le[c[(c[b>>2]|0)+52>>2]&63](b,c[h>>2]|0)|0)==-1){g=j;k=6;break}d=j+1|0;if((d|0)<(e|0)){h=h+4|0;j=d}else{g=d;k=6;break}}if((k|0)==6){i=f;return g|0}return 0}function mN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){c[g>>2]=d;if((a[b+44|0]|0)!=0){if((mc(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=te[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((mc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((mc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function nN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=132808;j=b+4|0;aV(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=131840;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;bV(g,j);j=eV(g,135544)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=Yd[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(Yd[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){mU(131936)}else{cV(g);i=f;return}}function oN(a){a=a|0;var b=0;b=i;c[a>>2]=132808;cV(a+4|0);i=b;return}function pN(a){a=a|0;var b=0;b=i;c[a>>2]=132808;cV(a+4|0);HY(a);i=b;return}function qN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=eV(d,135544)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=Yd[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(Yd[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){mU(131936)}else{i=e;return}}function rN(a){a=a|0;var b=0,c=0;b=i;c=uN(a,0)|0;i=b;return c|0}function sN(a){a=a|0;var b=0,c=0;b=i;c=uN(a,1)|0;i=b;return c|0}function tN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f;q=te[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((gd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function uN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]|0)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;a:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=Yc(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break a}}i=e;return n|0}}while(0);b:do{if((a[b+53|0]|0)==0){l=b+40|0;m=b+36|0;o=f;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=te[c[(c[t>>2]|0)+16>>2]&15](t,s,o,w,h,g,p,j)|0;if((x|0)==3){y=14;break}else if((x|0)==2){n=-1;y=22;break}else if((x|0)!=1){z=r;break b}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=22;break}v=Yc(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=22;break}a[w]=v;r=r+1|0}if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==22){i=e;return n|0}}else{c[g>>2]=a[f]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b+ -1|0;if((gd(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=22;break}else{b=z}}if((y|0)==22){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function vN(a){a=a|0;var b=0;b=i;c[a>>2]=132744;cV(a+4|0);i=b;return}function wN(a){a=a|0;var b=0;b=i;c[a>>2]=132744;cV(a+4|0);HY(a);i=b;return}function xN(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;Yd[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=eV(d,135536)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(Yd[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function yN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=me[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((mc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((jd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function zN(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((a[b+44|0]|0)!=0){h=mc(e|0,1,f|0,c[b+32>>2]|0)|0;i=g;return h|0}if((f|0)>0){j=e;k=0}else{h=0;i=g;return h|0}while(1){if((le[c[(c[b>>2]|0)+52>>2]&63](b,d[j]|0)|0)==-1){h=k;l=6;break}e=k+1|0;if((e|0)<(f|0)){j=j+1|0;k=e}else{h=e;l=6;break}}if((l|0)==6){i=g;return h|0}return 0}function AN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){a[g]=d;if((a[b+44|0]|0)!=0){if((mc(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=te[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((mc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((mc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function BN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=132744;j=b+4|0;aV(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=132096;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;bV(g,j);j=eV(g,135536)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=Yd[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(Yd[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){mU(131936)}else{cV(g);i=f;return}}function CN(a){a=a|0;var b=0;b=i;c[a>>2]=132744;cV(a+4|0);i=b;return}function DN(a){a=a|0;var b=0;b=i;c[a>>2]=132744;cV(a+4|0);HY(a);i=b;return}function EN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=eV(d,135536)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=Yd[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(Yd[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){mU(131936)}else{i=e;return}}function FN(a){a=a|0;var b=0,c=0;b=i;c=IN(a,0)|0;i=b;return c|0}function GN(a){a=a|0;var b=0,c=0;b=i;c=IN(a,1)|0;i=b;return c|0}function HN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f;q=te[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((gd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function IN(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]|0)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;a:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=Yc(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break a}}i=f;return o|0}}while(0);b:do{if((a[b+53|0]|0)==0){m=b+40|0;n=b+36|0;p=g;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=te[c[(c[u>>2]|0)+16>>2]&15](u,t,p,x,j,h,q,k)|0;if((y|0)==3){z=14;break}else if((y|0)==2){o=-1;z=23;break}else if((y|0)!=1){A=s;break b}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=23;break}w=Yc(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=23;break}a[x]=w;s=s+1|0}if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==23){i=f;return o|0}}else{a[h]=a[g]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k+ -1|0;if((gd(d[g+j|0]|0,c[l>>2]|0)|0)==-1){o=-1;z=23;break}else{k=j}}if((z|0)==21){B=a[h]|0;break}else if((z|0)==23){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function JN(){var a=0;a=i;fN(0);Nd(280,131360,q|0)|0;i=a;return}function KN(a){a=a|0;i=i;return}function LN(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=1+(c[b>>2]|0);i=i;return}function MN(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=-1+e;if((e|0)!=0){f=0;i=b;return f|0}Vd[c[(c[a>>2]|0)+8>>2]&511](a);f=1;i=b;return f|0}function NN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=132240;e=bZ(b|0)|0;f=GY(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;dZ(g|0,b|0,e+1|0)|0;i=d;return}function ON(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=132240;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;wb(h|0);j=a;HY(j);i=b;return}IY((c[d>>2]|0)+ -12|0);g=a;h=g;wb(h|0);j=a;HY(j);i=b;return}function PN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=132240;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;wb(h|0);i=b;return}IY((c[d>>2]|0)+ -12|0);g=a;h=g;wb(h|0);i=b;return}function QN(a){a=a|0;i=i;return c[a+4>>2]|0}function RN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;c[b>>2]=132264;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=bZ(f|0)|0;g=GY(d+13|0)|0;c[g+4>>2]=d;c[g>>2]=d;h=g+12|0;c[b+4>>2]=h;c[g+8>>2]=0;dZ(h|0,f|0,d+1|0)|0;i=e;return}function SN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=132264;e=bZ(b|0)|0;f=GY(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;dZ(g|0,b|0,e+1|0)|0;i=d;return}function TN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=132264;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;wb(h|0);j=a;HY(j);i=b;return}IY((c[d>>2]|0)+ -12|0);g=a;h=g;wb(h|0);j=a;HY(j);i=b;return}function UN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=132264;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;wb(h|0);i=b;return}IY((c[d>>2]|0)+ -12|0);g=a;h=g;wb(h|0);i=b;return}function VN(a){a=a|0;i=i;return c[a+4>>2]|0}function WN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=132240;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;wb(h|0);j=a;HY(j);i=b;return}IY((c[d>>2]|0)+ -12|0);g=a;h=g;wb(h|0);j=a;HY(j);i=b;return}function XN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=132240;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;wb(h|0);j=a;HY(j);i=b;return}IY((c[d>>2]|0)+ -12|0);g=a;h=g;wb(h|0);j=a;HY(j);i=b;return}function YN(a){a=a|0;i=i;return}function ZN(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;i=i;return}function _N(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;re[c[(c[a>>2]|0)+12>>2]&15](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function $N(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+4>>2]|0)!=(a|0)){f=0;i=e;return f|0}f=(c[b>>2]|0)==(d|0);i=e;return f|0}function aO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=Kd(e|0)|0;e=bZ(f|0)|0;if(e>>>0>4294967279){gO(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0;dZ(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}else{l=e+16&-16;m=FY(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=e;g=m;dZ(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}}function bO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=d;j=c[h>>2]|0;k=e;do{if((j|0)!=0){l=a[e]|0;if((l&1)==0){m=(l&255)>>>1}else{m=c[e+4>>2]|0}if((m|0)==0){n=j}else{NO(e,132480,2)|0;n=c[h>>2]|0}l=c[d+4>>2]|0;re[c[(c[l>>2]|0)+24>>2]&15](g,l,n);l=a[g]|0;if((l&1)==0){o=g+1|0;p=(l&255)>>>1}else{o=c[g+8>>2]|0;p=c[g+4>>2]|0}NO(e,o,p)|0;if((a[g]&1)==0){break}HY(c[g+8>>2]|0)}}while(0);g=b;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;i=f;return}function cO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=bZ(e|0)|0;if(j>>>0>4294967279){gO(0)}if(j>>>0<11){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=FY(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}dZ(k|0,e|0,j|0)|0;a[k+j|0]=0;bO(g,d,h);RN(b,g);if(!((a[g]&1)==0)){HY(c[g+8>>2]|0)}if(!((a[h]&1)==0)){HY(c[h+8>>2]|0)}c[b>>2]=132496;h=d;d=c[h+4>>2]|0;g=b+8|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;i=f;return}function dO(a){a=a|0;var b=0;b=i;UN(a);HY(a);i=b;return}function eO(a){a=a|0;var b=0;b=i;UN(a);i=b;return}function fO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;oc(132632)|0;if((c[a>>2]|0)==1){do{ed(132656,132632)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)==0){c[a>>2]=1;bc(132632)|0;Vd[d&511](b);oc(132632)|0;c[a>>2]=-1;bc(132632)|0;Vc(132656)|0;i=e;return}else{bc(132632)|0;i=e;return}}function gO(a){a=a|0;a=zc(8)|0;NN(a,132704);c[a>>2]=132320;Hd(a|0,132360,40)}function hO(a){a=a|0;a=zc(8)|0;NN(a,132704);c[a>>2]=132384;Hd(a|0,132424,40)}function iO(a){a=a|0;var b=0,d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function jO(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function kO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d;if((a[d]&1)==0){g=b;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];i=e;return}f=c[d+8>>2]|0;g=c[d+4>>2]|0;if(g>>>0>4294967279){gO(0)}if(g>>>0<11){a[b]=g<<1;h=b+1|0}else{d=g+16&-16;j=FY(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=g;h=j}dZ(h|0,f|0,g|0)|0;a[h+g|0]=0;i=e;return}function lO(b){b=b|0;i=i;return(a[b]&1)!=0|0}function mO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>4294967279){gO(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0}else{h=e+16&-16;j=FY(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}dZ(g|0,d|0,e|0)|0;a[g+e|0]=0;i=f;return}function nO(a){a=a|0;i=i;return a|0}function oO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=bZ(d|0)|0;if(f>>>0>4294967279){gO(0)}if(f>>>0<11){a[b]=f<<1;g=b+1|0;dZ(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}else{l=f+16&-16;m=FY(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=f;g=m;dZ(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}}function pO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>4294967279){gO(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0}else{h=d+16&-16;j=FY(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}fZ(g|0,e|0,d|0)|0;a[g+d|0]=0;i=f;return}function qO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if(d>>>0>4294967279){gO(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0;fZ(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}else{l=d+16&-16;m=FY(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=d;g=m;fZ(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}}function rO(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=a[d]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[d+4>>2]|0}if(k>>>0<e>>>0){hO(0)}if(j){l=d+1|0}else{l=c[d+8>>2]|0}d=l+e|0;l=k-e|0;e=l>>>0<f>>>0?l:f;if(e>>>0>4294967279){gO(0)}if(e>>>0<11){a[b]=e<<1;m=b+1|0;dZ(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}else{f=e+16&-16;l=FY(f)|0;c[b+8>>2]=l;c[b>>2]=f|1;c[b+4>>2]=e;m=l;dZ(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}}function sO(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function tO(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function uO(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}HY(c[b+8>>2]|0);i=d;return}function vO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((b|0)==(d|0)){i=e;return b|0}f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=a[b]|0;if((d&1)==0){j=d;k=10}else{d=c[b>>2]|0;j=d&255;k=(d&-2)+ -1|0}d=(j&1)==0;if(k>>>0<h>>>0){if(d){l=(j&255)>>>1}else{l=c[b+4>>2]|0}OO(b,k,h-k|0,l,0,l,h,g);i=e;return b|0}if(d){m=b+1|0}else{m=c[b+8>>2]|0}eZ(m|0,g|0,h|0)|0;a[m+h|0]=0;if((a[b]&1)==0){a[b]=h<<1;i=e;return b|0}else{c[b+4>>2]=h;i=e;return b|0}return 0}function wO(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=xO(a,b)|0;i=c;return d|0}function xO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=bZ(d|0)|0;g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}g=(h&1)==0;if(j>>>0<f>>>0){if(g){k=(h&255)>>>1}else{k=c[b+4>>2]|0}OO(b,j,f-j|0,k,0,k,f,d);i=e;return b|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}eZ(l|0,d|0,f|0)|0;a[l+f|0]=0;if((a[b]&1)==0){a[b]=f<<1;i=e;return b|0}else{c[b+4>>2]=f;i=e;return b|0}return 0}function yO(a,b){a=a|0;b=b|0;c[a+4>>2]=b;i=i;return}function zO(a){a=a|0;i=i;return a+1|0}function AO(b,c){b=b|0;c=c|0;a[b]=c<<1;i=i;return}function BO(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function CO(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=10;i=d;return e|0}e=(c[b>>2]&-2)+ -1|0;i=d;return e|0}function DO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){EO(b,d-j|0,e)|0;i=f;return}if(h){a[b+1+d|0]=0;a[b]=d<<1;i=f;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=f;return}}function EO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)==0){i=f;return b|0}g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}if((h&1)==0){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if((j-k|0)>>>0<d>>>0){PO(b,j,d-j+k|0,k,k,0,0);l=a[b]|0}else{l=h}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}fZ(m+k|0,e|0,d|0)|0;e=k+d|0;if((a[b]&1)==0){a[b]=e<<1}else{c[b+4>>2]=e}a[m+e|0]=0;i=f;return b|0}function FO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}if(h>>>0<d>>>0){EO(b,d-h|0,0)|0;i=e;return}if(g){a[b+1+d|0]=0;a[b]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=e;return}}function GO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>4294967279){gO(0)}f=a[b]|0;if((f&1)==0){g=f;h=10}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<11){k=10}else{k=(f+16&-16)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==10){l=b+1|0;m=0;n=c[b+8>>2]|0;o=1}else{f=k+1|0;if(k>>>0>h>>>0){p=FY(f)|0}else{p=FY(f)|0}if((g&1)==0){l=p;m=1;n=b+1|0;o=0;break}else{l=p;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}dZ(l|0,n|0,q+1|0)|0;if(o){HY(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function HO(a){a=a|0;var b=0;if(a>>>0<11){b=10}else{b=(a+16&-16)+ -1|0}i=i;return b|0}function IO(a,b){a=a|0;b=b|0;c[a>>2]=b|1;i=i;return}function JO(a,b){a=a|0;b=b|0;c[a+8>>2]=b;i=i;return}function KO(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){a[b+1|0]=0;a[b]=0;i=d;return}else{a[c[b+8>>2]|0]=0;c[b+4>>2]=0;i=d;return}}function LO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=NO(b,g,h)|0;i=e;return d|0}function MO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=10;j=(f&255)>>>1}if((j|0)==(h|0)){PO(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+1|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}a[l+j|0]=d;a[l+m|0]=0;i=e;return}function NO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}if((j&1)==0){k=(j&255)>>>1}else{k=c[b+4>>2]|0}if((h-k|0)>>>0<e>>>0){OO(b,h,e-h+k|0,k,k,0,e,d);i=f;return b|0}if((e|0)==0){i=f;return b|0}if((j&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}dZ(l+k|0,d|0,e|0)|0;d=k+e|0;if((a[b]&1)==0){a[b]=d<<1}else{c[b+4>>2]=d}a[l+d|0]=0;i=f;return b|0}function OO(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((-18-d|0)>>>0<e>>>0){gO(0)}if((a[b]&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}do{if(d>>>0<2147483623){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<11){q=11;break}q=p+16&-16}else{q=-17}}while(0);e=FY(q)|0;if((g|0)!=0){dZ(e|0,m|0,g|0)|0}if((j|0)!=0){dZ(e+g|0,k|0,j|0)|0}k=f-h|0;if((k|0)!=(g|0)){dZ(e+(j+g)|0,m+(h+g)|0,k-g|0)|0}if((d|0)!=10){HY(m)}c[b+8>>2]=e;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;a[e+q|0]=0;i=l;return}function PO(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((-17-d|0)>>>0<e>>>0){gO(0)}if((a[b]&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}do{if(d>>>0<2147483623){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<11){p=11;break}p=o+16&-16}else{p=-17}}while(0);e=FY(p)|0;if((g|0)!=0){dZ(e|0,l|0,g|0)|0}o=f-h|0;if((o|0)!=(g|0)){dZ(e+(j+g)|0,l+(h+g)|0,o-g|0)|0}if((d|0)==10){q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}HY(l);q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function QO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;rO(a,b,c,d,0);i=e;return}function RO(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function SO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=bZ(d|0)|0;h=a[b]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if(k>>>0<e>>>0|(k-e|0)>>>0<g>>>0){l=-1;i=f;return l|0}if((g|0)==0){l=e;i=f;return l|0}if(j){m=b+1|0}else{m=c[b+8>>2]|0}b=m+e|0;j=m+k|0;h=d+g|0;if((j-b|0)<(g|0)){l=-1;i=f;return l|0}n=k+(1-g)|0;g=m+n|0;if((n|0)==(e|0)){l=-1;i=f;return l|0}e=a[d]|0;n=b;a:while(1){if((a[n]|0)==e<<24>>24){b=n;k=d;do{k=k+1|0;if((k|0)==(h|0)){break a}b=b+1|0;}while((a[b]|0)==(a[k]|0))}k=n+1|0;if((k|0)==(g|0)){l=-1;o=18;break}else{n=k}}if((o|0)==18){i=f;return l|0}if((n|0)==(j|0)){l=-1;i=f;return l|0}l=n-m|0;i=f;return l|0}function TO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}f=a[d]|0;j=(f&1)==0;if(j){k=(f&255)>>>1}else{k=c[d+4>>2]|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}if(j){m=d+1|0}else{m=c[d+8>>2]|0}d=k>>>0<h>>>0;j=YY(l,m,d?k:h)|0;if((j|0)==0){i=e;return(h>>>0<k>>>0?-1:d&1)|0}else{i=e;return j|0}return 0}function UO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=bZ(d|0)|0;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if((f|0)==-1){hO(0)}if(h){k=b+1|0}else{k=c[b+8>>2]|0}b=j>>>0>f>>>0;h=YY(k,d,b?f:j)|0;if((h|0)==0){i=e;return(j>>>0<f>>>0?-1:b&1)|0}else{i=e;return h|0}return 0}function VO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(f>>>0>4294967279){gO(0)}if(f>>>0<11){a[b]=e<<1;h=b+1|0;dZ(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}else{m=f+16&-16;f=FY(m)|0;c[b+8>>2]=f;c[b>>2]=m|1;c[b+4>>2]=e;h=f;dZ(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}}function WO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>1073741807){gO(0)}if(e>>>0<2){a[b]=e<<1;g=b+4|0}else{h=e+4&-4;j=FY(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}aY(g,d,e)|0;c[g+(e<<2)>>2]=0;i=f;return}function XO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>1073741807){gO(0)}if(d>>>0<2){a[b]=d<<1;g=b+4|0}else{h=d+4&-4;j=FY(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}cY(g,e,d)|0;c[g+(d<<2)>>2]=0;i=f;return}function YO(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}HY(c[b+8>>2]|0);i=d;return}function ZO(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=_O(a,b,$X(b)|0)|0;i=c;return d|0}function _O(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=1;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g){k=(j&255)>>>1}else{k=c[b+4>>2]|0}bP(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g){l=b+4|0}else{l=c[b+8>>2]|0}bY(l,d,e)|0;c[l+(e<<2)>>2]=0;if((a[b]&1)==0){a[b]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function $O(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>1073741807){gO(0)}f=a[b]|0;if((f&1)==0){g=f;h=1}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<2){k=1}else{k=(f+4&-4)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==1){l=b+4|0;m=0;n=c[b+8>>2]|0;o=1}else{f=(k<<2)+4|0;if(k>>>0>h>>>0){p=FY(f)|0}else{p=FY(f)|0}f=p;if((g&1)==0){l=f;m=1;n=b+4|0;o=0;break}else{l=f;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}aY(l,n,q+1|0)|0;if(o){HY(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function aP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=1;j=(f&255)>>>1}if((j|0)==(h|0)){cP(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+4|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}c[l+(j<<2)>>2]=d;c[l+(m<<2)>>2]=0;i=e;return}function bP(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((1073741806-d|0)>>>0<e>>>0){gO(0)}if((a[b]&1)==0){m=b+4|0}else{m=c[b+8>>2]|0}do{if(d>>>0<536870887){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<2){q=2;break}q=p+4&-4}else{q=1073741807}}while(0);e=FY(q<<2)|0;p=e;if((g|0)!=0){aY(p,m,g)|0}if((j|0)!=0){aY(e+(g<<2)|0,k,j)|0}k=f-h|0;if((k|0)!=(g|0)){aY(e+(j+g<<2)|0,m+(h+g<<2)|0,k-g|0)|0}if((d|0)!=1){HY(m)}c[b+8>>2]=p;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;c[e+(q<<2)>>2]=0;i=l;return}function cP(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((1073741807-d|0)>>>0<e>>>0){gO(0)}if((a[b]&1)==0){l=b+4|0}else{l=c[b+8>>2]|0}do{if(d>>>0<536870887){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<2){p=2;break}p=o+4&-4}else{p=1073741807}}while(0);e=FY(p<<2)|0;o=e;if((g|0)!=0){aY(o,l,g)|0}m=f-h|0;if((m|0)!=(g|0)){aY(e+(j+g<<2)|0,l+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}HY(l);q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function dP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;g=bZ(d|0)|0;h=a[e]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[e+4>>2]|0}h=j+g|0;if(h>>>0>4294967279){gO(0)}if(h>>>0<11){a[b]=g<<1;k=b+1|0}else{l=h+16&-16;h=FY(l)|0;c[b+8>>2]=h;c[b>>2]=l|1;c[b+4>>2]=g;k=h}dZ(k|0,d|0,g|0)|0;a[k+g|0]=0;if((a[e]&1)==0){m=e+1|0;n=NO(b,m,j)|0;i=f;return}else{m=c[e+8>>2]|0;n=NO(b,m,j)|0;i=f;return}}function eP(a){a=a|0;i=i;return(c[a+16>>2]&5|0)==0|0}function fP(a){a=a|0;i=i;return(c[a+16>>2]&5|0)!=0|0}function gP(a,b){a=a|0;b=b|0;var c=0;c=i;hP(a,b);i=c;return}function hP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(c[b+24>>2]|0)==0;if(h){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((h&1|d)&c[b+20>>2]|0)==0){i=e;return}e=zc(16)|0;do{if((a[133088]|0)==0){if((Wa(133088)|0)==0){break}c[33270]=133784;Nd(66,133080,q|0)|0;Ob(133088)}}while(0);b=e;d=g;c[d>>2]=1;c[d+4>>2]=133080;d=f;h=g;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];cO(b,f,133136);c[e>>2]=133104;Hd(e|0,133184,62)}function iP(a,b){a=a|0;b=b|0;var d=0;d=i;hP(a,c[a+16>>2]|b);i=d;return}function jP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=133128;d=c[a+40>>2]|0;e=a+32|0;f=a+36|0;if((d|0)!=0){g=d;do{g=g+ -1|0;re[c[(c[e>>2]|0)+(g<<2)>>2]&15](0,a,c[(c[f>>2]|0)+(g<<2)>>2]|0);}while((g|0)!=0)}cV(a+28|0);AY(c[e>>2]|0);AY(c[f>>2]|0);AY(c[a+48>>2]|0);AY(c[a+60>>2]|0);i=b;return}function kP(a){a=a|0;var b=0;b=i;jP(a);HY(a);i=b;return}function lP(a){a=a|0;var b=0;b=i;jP(a);i=b;return}function mP(a){a=a|0;var b=0;b=i;jP(a);i=b;return}function nP(a){a=a|0;i=i;return c[a+24>>2]|0}function oP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+76|0;f=c[e>>2]|0;if(!((f|0)==-1)){g=f&255;i=b;return g|0}bV(d,a+28|0);a=eV(d,135472)|0;f=le[c[(c[a>>2]|0)+28>>2]&63](a,32)|0;cV(d);c[e>>2]=f<<24>>24;g=f;i=b;return g|0}function pP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;bV(e,a+28|0);a=eV(e,135472)|0;f=le[c[(c[a>>2]|0)+28>>2]&63](a,b)|0;cV(e);i=d;return f|0}function qP(a,b){a=a|0;b=b|0;var c=0;c=i;bV(a,b+28|0);i=c;return}function rP(a){a=a|0;c[a>>2]=132728;i=i;return}function sP(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;e=a+32|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));aV(b);i=d;return}function tP(a){a=a|0;var b=0;b=i;c[a>>2]=132744;cV(a+4|0);HY(a);i=b;return}function uP(a){a=a|0;var b=0;b=i;c[a>>2]=132744;cV(a+4|0);i=b;return}function vP(a){a=a|0;var b=0;b=i;c[a>>2]=132744;cV(a+4|0);i=b;return}function wP(a,b){a=a|0;b=b|0;var c=0;c=i;bV(a,b+4|0);i=c;return}function xP(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;e=a+12|0;f=c[e>>2]|0;if((f|0)==(c[a+16>>2]|0)){g=Yd[c[(c[a>>2]|0)+40>>2]&127](a)|0;i=b;return g|0}else{c[e>>2]=f+1;g=d[f]|0;i=b;return g|0}return 0}function yP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==(c[b+28>>2]|0)){h=le[c[(c[b>>2]|0)+52>>2]&63](b,d&255)|0;i=e;return h|0}else{c[f>>2]=g+1;a[g]=d;h=d&255;i=e;return h|0}return 0}function zP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=$d[c[(c[a>>2]|0)+48>>2]&63](a,b,d)|0;i=e;return f|0}function AP(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=132744;aV(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function BP(a){a=a|0;i=i;return c[a+8>>2]|0}function CP(a){a=a|0;i=i;return c[a+12>>2]|0}function DP(a){a=a|0;i=i;return c[a+16>>2]|0}function EP(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function FP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;i=i;return}function GP(a){a=a|0;i=i;return c[a+20>>2]|0}function HP(a){a=a|0;i=i;return c[a+24>>2]|0}function IP(a){a=a|0;i=i;return c[a+28>>2]|0}function JP(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function KP(a,b,d){a=a|0;b=b|0;d=d|0;c[a+24>>2]=b;c[a+20>>2]=b;c[a+28>>2]=d;i=i;return}function LP(a,b){a=a|0;b=b|0;i=i;return}function MP(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function NP(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function OP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function PP(a){a=a|0;i=i;return 0}function QP(a){a=a|0;i=i;return 0}function RP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((e|0)<=0){g=0;i=f;return g|0}h=b+12|0;j=b+16|0;k=d;d=0;while(1){l=c[h>>2]|0;if(l>>>0<(c[j>>2]|0)>>>0){c[h>>2]=l+1;m=a[l]|0}else{l=Yd[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((l|0)==-1){g=d;n=8;break}m=l&255}a[k]=m;l=d+1|0;if((l|0)<(e|0)){k=k+1|0;d=l}else{g=l;n=8;break}}if((n|0)==8){i=f;return g|0}return 0}function SP(a){a=a|0;i=i;return-1}function TP(a){a=a|0;var b=0,e=0,f=0;b=i;if((Yd[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){e=-1;i=b;return e|0}f=a+12|0;a=c[f>>2]|0;c[f>>2]=a+1;e=d[a]|0;i=b;return e|0}function UP(a,b){a=a|0;b=b|0;i=i;return-1}function VP(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((f|0)<=0){h=0;i=g;return h|0}j=b+24|0;k=b+28|0;l=e;e=0;while(1){m=c[j>>2]|0;if(m>>>0<(c[k>>2]|0)>>>0){n=a[l]|0;c[j>>2]=m+1;a[m]=n}else{if((le[c[(c[b>>2]|0)+52>>2]&63](b,d[l]|0)|0)==-1){h=e;o=7;break}}n=e+1|0;if((n|0)<(f|0)){l=l+1|0;e=n}else{h=n;o=7;break}}if((o|0)==7){i=g;return h|0}return 0}function WP(a,b){a=a|0;b=b|0;i=i;return-1}function XP(a){a=a|0;var b=0;b=i;c[a>>2]=132808;cV(a+4|0);HY(a);i=b;return}function YP(a){a=a|0;var b=0;b=i;c[a>>2]=132808;cV(a+4|0);i=b;return}function ZP(a,b){a=a|0;b=b|0;i=i;return}function _P(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function $P(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function aQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function bQ(a){a=a|0;i=i;return 0}function cQ(a){a=a|0;i=i;return 0}function dQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+12|0;h=a+16|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[g>>2]=k+4;l=c[k>>2]|0}else{k=Yd[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((k|0)==-1){f=b;m=8;break}else{l=k}}c[j>>2]=l;k=b+1|0;if((k|0)>=(d|0)){f=k;m=8;break}j=j+4|0;b=k}if((m|0)==8){i=e;return f|0}return 0}function eQ(a){a=a|0;i=i;return-1}function fQ(a){a=a|0;var b=0,d=0,e=0;b=i;if((Yd[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){d=-1;i=b;return d|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+4;d=c[a>>2]|0;i=b;return d|0}function gQ(a,b){a=a|0;b=b|0;i=i;return-1}function hQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;h=a+28|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){l=c[j>>2]|0;c[g>>2]=k+4;c[k>>2]=l}else{if((le[c[(c[a>>2]|0)+52>>2]&63](a,c[j>>2]|0)|0)==-1){f=b;m=8;break}}l=b+1|0;if((l|0)>=(d|0)){f=l;m=8;break}j=j+4|0;b=l}if((m|0)==8){i=e;return f|0}return 0}function iQ(a,b){a=a|0;b=b|0;i=i;return-1}function jQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];c[a+4>>2]=0;b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));aV(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function kQ(a){a=a|0;var b=0;b=i;jP(a+8|0);HY(a);i=b;return}function lQ(a){a=a|0;var b=0;b=i;jP(a+8|0);i=b;return}function mQ(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;jP(a+(d+8)|0);HY(a+d|0);i=b;return}function nQ(a){a=a|0;var b=0;b=i;jP(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function oQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;pQ(a,b,c);i=d;return}function pQ(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;h=g;j=d;a[j]=0;d=c[(c[e>>2]|0)+ -12>>2]|0;k=c[e+(d+16)>>2]|0;if((k|0)!=0){hP(e+d|0,k|4);i=g;return}k=c[e+(d+72)>>2]|0;if((k|0)!=0){qQ(k)|0}a:do{if(!f){k=c[(c[e>>2]|0)+ -12>>2]|0;if((c[e+(k+4)>>2]&4096|0)==0){break}bV(h,e+(k+28)|0);k=eV(h,135472)|0;cV(h);d=k+8|0;k=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;while(1){if((k|0)==0){break}if((c[k+12>>2]|0)==(c[k+16>>2]|0)){l=(Yd[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;m=l?0:k;if((m|0)==0){break}else{n=m}}else{n=k}m=n+12|0;l=c[m>>2]|0;o=n+16|0;if((l|0)==(c[o>>2]|0)){p=(Yd[c[(c[n>>2]|0)+36>>2]&127](n)|0)&255}else{p=a[l]|0}if(!(p<<24>>24>-1)){q=18;break}if((b[(c[d>>2]|0)+(p<<24>>24<<1)>>1]&8192)==0){q=18;break}l=c[m>>2]|0;if((l|0)==(c[o>>2]|0)){Yd[c[(c[n>>2]|0)+40>>2]&127](n)|0;k=n;continue}else{c[m>>2]=l+1;k=n;continue}}do{if((q|0)==18){if((n|0)==0){break}if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){break a}if(!((Yd[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1|(n|0)==0)){break a}}}while(0);k=c[(c[e>>2]|0)+ -12>>2]|0;hP(e+k|0,c[e+(k+16)>>2]|6)}}while(0);a[j]=(c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+16)>>2]|0)==0|0;i=g;return}function qQ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{qQ(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((Yd[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;hP(b+h|0,c[b+(h+16)>>2]|1)}}while(0);FQ(e);i=d;return b|0}function rQ(b){b=b|0;i=i;return(a[b]|0)!=0|0}function sQ(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){i=i;return}else{Bb()}}function tQ(a){a=a|0;var b=0;b=i;jP(a+8|0);HY(a);i=b;return}function uQ(a){a=a|0;var b=0;b=i;jP(a+8|0);i=b;return}function vQ(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;jP(a+(d+8)|0);HY(a+d|0);i=b;return}function wQ(a){a=a|0;var b=0;b=i;jP(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function xQ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{xQ(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((Yd[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;hP(b+h|0,c[b+(h+16)>>2]|1)}}while(0);RQ(e);i=d;return b|0}function yQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));aV(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function zQ(a){a=a|0;var b=0;b=i;jP(a+4|0);HY(a);i=b;return}function AQ(a){a=a|0;var b=0;b=i;jP(a+4|0);i=b;return}function BQ(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;jP(a+(d+4)|0);HY(a+d|0);i=b;return}function CQ(a){a=a|0;var b=0;b=i;jP(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function DQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b;a[f]=0;c[b+4>>2]=d;b=c[(c[d>>2]|0)+ -12>>2]|0;if((c[d+(b+16)>>2]|0)!=0){i=e;return}g=c[d+(b+72)>>2]|0;if((g|0)!=0){qQ(g)|0}a[f]=1;i=e;return}function EQ(a){a=a|0;var b=0;b=i;FQ(a);i=b;return}function FQ(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(ab()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((Yd[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;hP(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function GQ(b){b=b|0;i=i;return(a[b]|0)!=0|0}function HQ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Yd[b&127](a)|0;i=c;return d|0}function IQ(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=j;a[m]=0;c[j+4>>2]=b;n=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(n+16)>>2]|0)!=0){FQ(j);i=e;return b|0}o=c[b+(n+72)>>2]|0;if((o|0)==0){p=n}else{qQ(o)|0;p=c[(c[b>>2]|0)+ -12>>2]|0}a[m]=1;bV(k,b+(p+28)|0);p=eV(k,134192)|0;m=p;cV(k);k=c[(c[b>>2]|0)+ -12>>2]|0;o=c[b+(k+24)>>2]|0;n=b+(k+76)|0;q=c[n>>2]|0;if((q|0)==-1){bV(h,b+(k+28)|0);r=eV(h,135472)|0;s=le[c[(c[r>>2]|0)+28>>2]&63](r,32)|0;cV(h);c[n>>2]=s<<24>>24;t=s}else{t=q&255}q=b+k|0;k=c[(c[p>>2]|0)+32>>2]|0;c[g>>2]=o;o=f;p=g;c[o+0>>2]=c[p+0>>2];de[k&7](l,m,f,q,t,d);if((c[l>>2]|0)!=0){FQ(j);i=e;return b|0}l=c[(c[b>>2]|0)+ -12>>2]|0;hP(b+l|0,c[b+(l+16)>>2]|5);FQ(j);i=e;return b|0}function JQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=f;a[g]=0;c[f+4>>2]=b;h=c[b>>2]|0;j=c[h+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){FQ(f);i=e;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)==0){l=h;m=j}else{qQ(k)|0;k=c[b>>2]|0;l=k;m=c[k+ -12>>2]|0}a[g]=1;g=c[b+(m+24)>>2]|0;m=g;do{if((g|0)==0){n=l}else{k=g+24|0;j=c[k>>2]|0;if((j|0)!=(c[g+28>>2]|0)){c[k>>2]=j+1;a[j]=d;FQ(f);i=e;return b|0}if((le[c[(c[g>>2]|0)+52>>2]&63](m,d&255)|0)==-1){n=c[b>>2]|0;break}else{FQ(f);i=e;return b|0}}}while(0);d=c[n+ -12>>2]|0;hP(b+d|0,c[b+(d+16)>>2]|1);FQ(f);i=e;return b|0}function KQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=g;a[h]=0;c[g+4>>2]=b;j=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){FQ(g);i=f;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)!=0){qQ(k)|0}a[h]=1;if((e|0)==0){FQ(g);i=f;return b|0}h=c[b+((c[(c[b>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(($d[c[(c[h>>2]|0)+48>>2]&63](h,d,e)|0)==(e|0)){FQ(g);i=f;return b|0}e=c[(c[b>>2]|0)+ -12>>2]|0;hP(b+e|0,c[b+(e+16)>>2]|1);FQ(g);i=f;return b|0}function LQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(e+16)>>2]&5|0)==0){f=c[b+(e+24)>>2]|0;fe[c[(c[f>>2]|0)+16>>2]&31](a,f,0,0,1,16);i=d;return}else{f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;i=d;return}}function MQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=e;g=e+16|0;h=e+32|0;j=e+40|0;k=h;a[k]=0;c[h+4>>2]=b;l=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(l+16)>>2]|0)!=0){FQ(h);i=e;return b|0}m=c[b+(l+72)>>2]|0;if((m|0)==0){n=l}else{qQ(m)|0;n=c[(c[b>>2]|0)+ -12>>2]|0}a[k]=1;k=c[b+(n+24)>>2]|0;n=k;m=d;d=g;l=c[(c[k>>2]|0)+20>>2]|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];m=f;d=g;c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];ve[l&31](j,n,f,16);f=j+8|0;if(!((c[f>>2]|0)==-1&(c[f+4>>2]|0)==-1)){FQ(h);i=e;return b|0}f=c[(c[b>>2]|0)+ -12>>2]|0;hP(b+f|0,c[b+(f+16)>>2]|4);FQ(h);i=e;return b|0}function NQ(a){a=a|0;var b=0;b=i;jP(a+4|0);HY(a);i=b;return}function OQ(a){a=a|0;var b=0;b=i;jP(a+4|0);i=b;return}function PQ(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;jP(a+(d+4)|0);HY(a+d|0);i=b;return}function QQ(a){a=a|0;var b=0;b=i;jP(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function RQ(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(ab()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((Yd[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;hP(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function SQ(a){a=a|0;i=i;return 133024}function TQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((c|0)==1){mO(a,133040,35);i=d;return}else{aO(a,b,c);i=d;return}}function UQ(a){a=a|0;i=i;return}function VQ(a){a=a|0;var b=0;b=i;eO(a);HY(a);i=b;return}function WQ(a){a=a|0;var b=0;b=i;eO(a);i=b;return}function XQ(a){a=a|0;var b=0;b=i;jP(a);HY(a);i=b;return}function YQ(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function ZQ(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function _Q(a){a=a|0;i=i;return}function $Q(a){a=a|0;i=i;return}function aR(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;a:do{if((e|0)==(f|0)){g=c;h=6}else{j=e;k=c;while(1){if((k|0)==(d|0)){l=-1;break a}m=a[k]|0;n=a[j]|0;if(m<<24>>24<n<<24>>24){l=-1;break a}if(n<<24>>24<m<<24>>24){l=1;break a}m=k+1|0;n=j+1|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=b;return l|0}function bR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;g=e;h=f-g|0;if(h>>>0>4294967279){gO(b)}if(h>>>0<11){a[b]=h<<1;j=b+1|0}else{k=h+16&-16;l=FY(k)|0;c[b+8>>2]=l;c[b>>2]=k|1;c[b+4>>2]=h;j=l}if((e|0)==(f|0)){m=j;a[m]=0;i=d;return}else{n=e;o=j}while(1){a[o]=a[n]|0;e=n+1|0;if((e|0)==(f|0)){break}else{o=o+1|0;n=e}}m=j+(f+(0-g))|0;a[m]=0;i=d;return}function cR(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)==(d|0)){e=0;i=b;return e|0}else{f=0;g=c}while(1){c=(a[g]|0)+(f<<4)|0;h=c&-268435456;j=(h>>>24|h)^c;c=g+1|0;if((c|0)==(d|0)){e=j;break}else{g=c;f=j}}i=b;return e|0}function dR(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function eR(a){a=a|0;i=i;return}function fR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;a:do{if((e|0)==(f|0)){g=b;h=6}else{j=e;k=b;while(1){if((k|0)==(d|0)){l=-1;break a}m=c[k>>2]|0;n=c[j>>2]|0;if((m|0)<(n|0)){l=-1;break a}if((n|0)<(m|0)){l=1;break a}m=k+4|0;n=j+4|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=a;return l|0}function gR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;g=e;h=f-g|0;j=h>>2;if(j>>>0>1073741807){gO(b)}if(j>>>0<2){a[b]=h>>>1;k=b+4|0}else{h=j+4&-4;l=FY(h<<2)|0;c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;k=l}if((e|0)==(f|0)){m=k;c[m>>2]=0;i=d;return}l=f+ -4+(0-g)|0;g=e;e=k;while(1){c[e>>2]=c[g>>2];j=g+4|0;if((j|0)==(f|0)){break}else{e=e+4|0;g=j}}m=k+((l>>>2)+1<<2)|0;c[m>>2]=0;i=d;return}function hR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=0;i=a;return e|0}else{f=0;g=b}while(1){b=(c[g>>2]|0)+(f<<4)|0;h=b&-268435456;j=(h>>>24|h)^b;b=g+4|0;if((b|0)==(d|0)){e=j;break}else{g=b;f=j}}i=a;return e|0}function iR(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function jR(a){a=a|0;i=i;return}function kR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];ie[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==1){a[j]=1}else if((z|0)==0){a[j]=0}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}qP(u,g);m=u;u=c[m>>2]|0;if(!((c[33868]|0)==-1)){c[p>>2]=135472;c[p+4>>2]=281;c[p+8>>2]=0;fO(135472,p,282)}p=(c[135476>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=zc(4)|0;D=C;eY(D);E=151032;F=127;Hd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=zc(4)|0;D=C;eY(D);E=151032;F=127;Hd(C|0,E|0,F|0)}F=u;MN(c[m>>2]|0)|0;qP(v,g);g=v;v=c[g>>2]|0;if(!((c[33904]|0)==-1)){c[o>>2]=135616;c[o+4>>2]=281;c[o+8>>2]=0;fO(135616,o,282)}o=(c[135620>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=zc(4)|0;H=G;eY(H);I=151032;J=127;Hd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=zc(4)|0;H=G;eY(H);I=151032;J=127;Hd(G|0,I|0,J|0)}J=v;MN(c[g>>2]|0)|0;g=w;Wd[c[(c[v>>2]|0)+24>>2]&63](g,J);Wd[c[(c[v>>2]|0)+28>>2]&63](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=lR(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];uO(w+12|0);uO(w);i=k;return}function lR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=zY(l)|0;if((n|0)!=0){o=n;p=n;break}MY()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){y=r;break}if((Yd[c[(c[r>>2]|0)+36>>2]&127](r)|0)==-1){c[l>>2]=0;y=0;break}else{y=c[l>>2]|0;break}}}while(0);r=(y|0)==0;t=c[b>>2]|0;do{if((t|0)==0){z=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){z=t;break}if(!((Yd[c[(c[t>>2]|0)+36>>2]&127](t)|0)==-1)){z=t;break}c[b>>2]=0;z=0}}while(0);A=(z|0)==0;B=c[l>>2]|0;if(!((r^A)&(q|0)!=0)){break}t=c[B+12>>2]|0;if((t|0)==(c[B+16>>2]|0)){C=(Yd[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[t]|0}if(j){D=C}else{D=le[c[(c[g>>2]|0)+12>>2]&63](g,C)|0}t=d+1|0;if(m){d=t;q=q;x=x;continue}b:do{if(j){w=0;s=e;n=x;v=q;u=p;while(1){do{if((a[u]|0)==1){E=a[s]|0;F=(E&1)==0;if(F){G=s+1|0}else{G=c[s+8>>2]|0}if(!(D<<24>>24==(a[G+d|0]|0))){a[u]=0;H=w;I=n;J=v+ -1|0;break}if(F){K=(E&255)>>>1}else{K=c[s+4>>2]|0}if((K|0)!=(t|0)){H=1;I=n;J=v;break}a[u]=2;H=1;I=n+1|0;J=v+ -1|0}else{H=w;I=n;J=v}}while(0);E=s+12|0;if((E|0)==(f|0)){L=H;M=I;N=J;break b}w=H;s=E;n=I;v=J;u=u+1|0}}else{u=0;v=e;n=x;s=q;w=p;while(1){do{if((a[w]|0)==1){if((a[v]&1)==0){O=v+1|0}else{O=c[v+8>>2]|0}if(!(D<<24>>24==(le[c[(c[g>>2]|0)+12>>2]&63](g,a[O+d|0]|0)|0)<<24>>24)){a[w]=0;P=u;Q=n;R=s+ -1|0;break}E=a[v]|0;if((E&1)==0){S=(E&255)>>>1}else{S=c[v+4>>2]|0}if((S|0)!=(t|0)){P=1;Q=n;R=s;break}a[w]=2;P=1;Q=n+1|0;R=s+ -1|0}else{P=u;Q=n;R=s}}while(0);E=v+12|0;if((E|0)==(f|0)){L=P;M=Q;N=R;break b}u=P;v=E;n=Q;s=R;w=w+1|0}}}while(0);if(!L){d=t;x=M;q=N;continue}r=c[l>>2]|0;w=r+12|0;s=c[w>>2]|0;if((s|0)==(c[r+16>>2]|0)){Yd[c[(c[r>>2]|0)+40>>2]&127](r)|0}else{c[w>>2]=s+1}if((N+M|0)>>>0<2){d=t;x=M;q=N;continue}else{T=e;U=M;V=p}while(1){do{if((a[V]|0)==2){s=a[T]|0;if((s&1)==0){W=(s&255)>>>1}else{W=c[T+4>>2]|0}if((W|0)==(t|0)){X=U;break}a[V]=0;X=U+ -1|0}else{X=U}}while(0);s=T+12|0;if((s|0)==(f|0)){d=t;x=X;q=N;continue a}else{T=s;U=X;V=V+1|0}}}do{if((B|0)==0){Y=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){Y=B;break}if((Yd[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[l>>2]=0;Y=0;break}else{Y=c[l>>2]|0;break}}}while(0);l=(Y|0)==0;do{if(A){Z=78}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){if(l){break}else{Z=80;break}}if((Yd[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1){c[b>>2]=0;Z=78;break}else{if(l){break}else{Z=80;break}}}}while(0);if((Z|0)==78){if(l){Z=80}}if((Z|0)==80){c[h>>2]=c[h>>2]|2}c:do{if(m){Z=85}else{if((a[p]|0)==2){_=e;break}else{$=e;aa=p}while(1){l=$+12|0;b=aa+1|0;if((l|0)==(f|0)){Z=85;break c}if((a[b]|0)==2){_=l;break}else{aa=b;$=l}}}}while(0);if((Z|0)==85){c[h>>2]=c[h>>2]|4;_=f}if((o|0)==0){i=k;return _|0}AY(o);i=k;return _|0}function mR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];nR(a,0,k,j,f,g,h);i=b;return}function nR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;dS(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;DO(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((Yd[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((Yd[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}DO(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}DO(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(Yd[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((FR(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){Yd[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=$W(F,c[o>>2]|0,h,t)|0;qU(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((Yd[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;uO(n);uO(m);i=d;return}if((Yd[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;uO(n);uO(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;uO(n);uO(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;uO(n);uO(m);i=d;return}function oR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];pR(a,0,k,j,f,g,h);i=b;return}function pR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;dS(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;DO(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((Yd[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((Yd[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}DO(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}DO(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(Yd[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((FR(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){Yd[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=_W(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;qU(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((Yd[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;uO(n);uO(m);i=d;return}if((Yd[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;uO(n);uO(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;uO(n);uO(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;uO(n);uO(m);i=d;return}function qR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];rR(a,0,k,j,f,g,h);i=b;return}function rR(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;l=e;m=e+32|0;n=e+40|0;o=e+56|0;p=e+72|0;q=e+80|0;r=e+240|0;s=e+248|0;t=c[h+4>>2]&74;if((t|0)==0){u=0}else if((t|0)==8){u=16}else if((t|0)==64){u=8}else{u=10}t=l;dS(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;DO(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=a[m]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){B=m;break}if(!((Yd[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){B=m;break}c[l>>2]=0;B=0}}while(0);x=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){D=18}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){if(x){E=C;break}else{F=C;G=A;break a}}if((Yd[c[(c[C>>2]|0)+36>>2]&127](C)|0)==-1){c[f>>2]=0;D=18;break}else{if(x){E=C;break}else{F=C;G=A;break a}}}}while(0);if((D|0)==18){D=0;if(x){F=0;G=A;break}else{E=0}}C=a[o]|0;H=(C&1)==0;if(H){I=(C&255)>>>1}else{I=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(I|0)){if(H){J=(C&255)>>>1;K=(C&255)>>>1}else{C=c[y>>2]|0;J=C;K=C}DO(o,K<<1,0);if((a[o]&1)==0){L=10}else{L=(c[g>>2]&-2)+ -1|0}DO(o,L,0);if((a[o]&1)==0){M=v}else{M=c[w>>2]|0}c[p>>2]=M+J;N=M}else{N=A}C=B+12|0;H=c[C>>2]|0;O=B+16|0;if((H|0)==(c[O>>2]|0)){P=(Yd[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{P=a[H]|0}if((FR(P,u,N,p,s,z,n,h,r,t)|0)!=0){F=E;G=N;break}H=c[C>>2]|0;if((H|0)==(c[O>>2]|0)){Yd[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=N;continue}else{c[C>>2]=H+1;m=B;A=N;continue}}N=a[n]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[n+4>>2]|0}do{if((Q|0)!=0){N=c[r>>2]|0;if((N-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=N+4;c[N>>2]=A}}while(0);b[k>>1]=ZW(G,c[p>>2]|0,j,u)|0;qU(n,h,c[r>>2]|0,j);do{if((B|0)==0){R=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){R=B;break}if(!((Yd[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1)){R=B;break}c[l>>2]=0;R=0}}while(0);l=(R|0)==0;do{if((F|0)==0){D=54}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(!l){break}S=d;T=S;c[T>>2]=R;uO(o);uO(n);i=e;return}if((Yd[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1){c[f>>2]=0;D=54;break}if(!(l^(F|0)==0)){break}S=d;T=S;c[T>>2]=R;uO(o);uO(n);i=e;return}}while(0);do{if((D|0)==54){if(l){break}S=d;T=S;c[T>>2]=R;uO(o);uO(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;S=d;T=S;c[T>>2]=R;uO(o);uO(n);i=e;return}function sR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];tR(a,0,k,j,f,g,h);i=b;return}function tR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;dS(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;DO(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((Yd[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((Yd[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}DO(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}DO(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(Yd[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((FR(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){Yd[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=YW(F,c[o>>2]|0,h,t)|0;qU(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((Yd[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;uO(n);uO(m);i=d;return}if((Yd[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;uO(n);uO(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;uO(n);uO(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;uO(n);uO(m);i=d;return}function uR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];vR(a,0,k,j,f,g,h);i=b;return}function vR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;dS(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;DO(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((Yd[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((Yd[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}DO(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}DO(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(Yd[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((FR(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){Yd[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=XW(F,c[o>>2]|0,h,t)|0;qU(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((Yd[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;uO(n);uO(m);i=d;return}if((Yd[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;uO(n);uO(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;uO(n);uO(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;uO(n);uO(m);i=d;return}function wR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];xR(a,0,k,j,f,g,h);i=b;return}



function KS(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;n=i;i=i+64|0;o=n;p=n+8|0;q=n+16|0;r=n+32|0;s=n+40|0;t=n+48|0;u=n+56|0;qP(r,h);v=r;r=c[v>>2]|0;if(!((c[33868]|0)==-1)){c[q>>2]=135472;c[q+4>>2]=281;c[q+8>>2]=0;fO(135472,q,282)}q=(c[135476>>2]|0)+ -1|0;w=c[r+8>>2]|0;if(!((c[r+12>>2]|0)-w>>2>>>0>q>>>0)){x=zc(4)|0;y=x;eY(y);z=151032;A=127;Hd(x|0,z|0,A|0)}r=c[w+(q<<2)>>2]|0;if((r|0)==0){x=zc(4)|0;y=x;eY(y);z=151032;A=127;Hd(x|0,z|0,A|0)}A=r;MN(c[v>>2]|0)|0;c[j>>2]=0;v=f;a:do{if((l|0)==(m|0)){B=65}else{z=g;x=r+8|0;y=t;q=u;w=s;C=l;D=0;b:while(1){E=D;while(1){if((E|0)!=0){B=65;break a}F=c[v>>2]|0;do{if((F|0)==0){G=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){G=F;break}if(!((Yd[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){G=F;break}c[v>>2]=0;G=0}}while(0);F=(G|0)==0;H=c[z>>2]|0;c:do{if((H|0)==0){B=19}else{do{if((c[H+12>>2]|0)==(c[H+16>>2]|0)){if(!((Yd[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1)){break}c[z>>2]=0;B=19;break c}}while(0);if(F){I=H}else{B=20;break b}}}while(0);if((B|0)==19){B=0;if(F){B=20;break b}else{I=0}}if(($d[c[(c[r>>2]|0)+36>>2]&63](A,a[C]|0,0)|0)<<24>>24==37){B=22;break}H=a[C]|0;if(H<<24>>24>-1){J=c[x>>2]|0;if(!((b[J+(H<<24>>24<<1)>>1]&8192)==0)){K=C;B=33;break}}L=G+12|0;H=c[L>>2]|0;M=G+16|0;if((H|0)==(c[M>>2]|0)){N=(Yd[c[(c[G>>2]|0)+36>>2]&127](G)|0)&255}else{N=a[H]|0}H=le[c[(c[r>>2]|0)+12>>2]&63](A,N)|0;if(H<<24>>24==(le[c[(c[r>>2]|0)+12>>2]&63](A,a[C]|0)|0)<<24>>24){B=60;break}c[j>>2]=4;E=4}d:do{if((B|0)==22){B=0;E=C+1|0;if((E|0)==(m|0)){B=23;break b}H=$d[c[(c[r>>2]|0)+36>>2]&63](A,a[E]|0,0)|0;if(H<<24>>24==48|H<<24>>24==69){O=C+2|0;if((O|0)==(m|0)){B=26;break b}P=O;Q=$d[c[(c[r>>2]|0)+36>>2]&63](A,a[O]|0,0)|0;R=H}else{P=E;Q=H;R=0}H=c[(c[e>>2]|0)+36>>2]|0;c[y>>2]=G;c[q>>2]=I;E=p;O=t;c[E+0>>2]=c[O+0>>2];O=o;E=u;c[O+0>>2]=c[E+0>>2];ke[H&3](s,e,p,o,h,j,k,Q,R);c[v>>2]=c[w>>2];S=P+1|0}else if((B|0)==33){while(1){B=0;H=K+1|0;if((H|0)==(m|0)){T=m;break}E=a[H]|0;if(!(E<<24>>24>-1)){T=H;break}if((b[J+(E<<24>>24<<1)>>1]&8192)==0){T=H;break}else{K=H;B=33}}F=G;H=I;E=I;while(1){do{if((F|0)==0){U=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){U=F;break}if(!((Yd[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){U=F;break}c[v>>2]=0;U=0}}while(0);O=(U|0)==0;do{if((E|0)==0){V=H;B=46}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(O){W=H;X=E;break}else{S=T;break d}}if((Yd[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[z>>2]=0;V=0;B=46;break}else{if(O^(H|0)==0){W=H;X=H;break}else{S=T;break d}}}}while(0);if((B|0)==46){B=0;if(O){S=T;break d}else{W=V;X=0}}Y=U+12|0;Z=c[Y>>2]|0;_=U+16|0;if((Z|0)==(c[_>>2]|0)){$=(Yd[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{$=a[Z]|0}if(!($<<24>>24>-1)){S=T;break d}if((b[(c[x>>2]|0)+($<<24>>24<<1)>>1]&8192)==0){S=T;break d}Z=c[Y>>2]|0;if((Z|0)==(c[_>>2]|0)){Yd[c[(c[U>>2]|0)+40>>2]&127](U)|0;F=U;H=W;E=X;continue}else{c[Y>>2]=Z+1;F=U;H=W;E=X;continue}}}else if((B|0)==60){B=0;E=c[L>>2]|0;if((E|0)==(c[M>>2]|0)){Yd[c[(c[G>>2]|0)+40>>2]&127](G)|0}else{c[L>>2]=E+1}S=C+1|0}}while(0);if((S|0)==(m|0)){B=65;break a}C=S;D=c[j>>2]|0}if((B|0)==20){c[j>>2]=4;aa=G;break}else if((B|0)==23){c[j>>2]=4;aa=G;break}else if((B|0)==26){c[j>>2]=4;aa=G;break}}}while(0);if((B|0)==65){aa=c[v>>2]|0}v=f;do{if((aa|0)==0){ba=0}else{if((c[aa+12>>2]|0)!=(c[aa+16>>2]|0)){ba=aa;break}if(!((Yd[c[(c[aa>>2]|0)+36>>2]&127](aa)|0)==-1)){ba=aa;break}c[v>>2]=0;ba=0}}while(0);v=(ba|0)==0;aa=g;g=c[aa>>2]|0;e:do{if((g|0)==0){B=75}else{do{if((c[g+12>>2]|0)==(c[g+16>>2]|0)){if(!((Yd[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1)){break}c[aa>>2]=0;B=75;break e}}while(0);if(!v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);do{if((B|0)==75){if(v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ca=d;da=ca;c[da>>2]=ba;i=n;return}function LS(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function MS(a){a=a|0;i=i;return}function NS(a){a=a|0;i=i;return 2}function OS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];KS(a,b,l,k,f,g,h,134376,134384|0);i=j;return}function PS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=Yd[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+1|0;s=q+1|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+t|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];KS(b,d,m,l,g,h,j,s,q);i=k;return}function QS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;qP(n,f);f=n;n=c[f>>2]|0;if(!((c[33868]|0)==-1)){c[m>>2]=135472;c[m+4>>2]=281;c[m+8>>2]=0;fO(135472,m,282)}m=(c[135476>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=zc(4)|0;q=p;eY(q);r=151032;s=127;Hd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=zc(4)|0;q=p;eY(q);r=151032;s=127;Hd(p|0,r|0,s|0)}s=n;MN(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=Yd[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=lR(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function RS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;qP(n,f);f=n;n=c[f>>2]|0;if(!((c[33868]|0)==-1)){c[m>>2]=135472;c[m+4>>2]=281;c[m+8>>2]=0;fO(135472,m,282)}m=(c[135476>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=zc(4)|0;q=p;eY(q);r=151032;s=127;Hd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=zc(4)|0;q=p;eY(q);r=151032;s=127;Hd(p|0,r|0,s|0)}s=n;MN(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=Yd[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=lR(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function SS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;qP(m,f);f=m;m=c[f>>2]|0;if(!((c[33868]|0)==-1)){c[l>>2]=135472;c[l+4>>2]=281;c[l+8>>2]=0;fO(135472,l,282)}l=(c[135476>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=zc(4)|0;p=o;eY(p);q=151032;r=127;Hd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=zc(4)|0;p=o;eY(p);q=151032;r=127;Hd(o|0,q|0,r|0)}r=m;MN(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=XS(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function TS(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;qP(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[33868]|0)==-1)){c[ba>>2]=135472;c[ba+4>>2]=281;c[ba+8>>2]=0;fO(135472,ba,282)}ba=(c[135476>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=zc(4)|0;Ga=Fa;eY(Ga);Ha=151032;Ia=127;Hd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=zc(4)|0;Ga=Fa;eY(Ga);Ha=151032;Ia=127;Hd(Fa|0,Ha|0,Ia|0)}Ia=ca;MN(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 65:case 97:{Da=c[f>>2]|0;ca=d+8|0;Ha=Yd[c[c[ca>>2]>>2]&127](ca)|0;c[aa>>2]=Da;c[Q+0>>2]=c[aa+0>>2];Da=(lR(e,Q,Ha,Ha+168|0,Ia,h,0)|0)-Ha|0;if((Da|0)>=168){break a}c[j+24>>2]=((Da|0)/12|0|0)%7|0;break};case 104:case 66:case 98:{Da=c[f>>2]|0;Ha=d+8|0;ca=Yd[c[(c[Ha>>2]|0)+4>>2]&127](Ha)|0;c[$>>2]=Da;c[P+0>>2]=c[$+0>>2];Da=(lR(e,P,ca,ca+288|0,Ia,h,0)|0)-ca|0;if((Da|0)>=288){break a}c[j+16>>2]=((Da|0)/12|0|0)%12|0;break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Da=XS(e,E,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<13){c[j+16>>2]=Da+ -1;break a}else{c[h>>2]=ca|4;break a}break};case 84:{ca=e;c[va>>2]=c[ca>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];KS(ua,d,v,u,g,h,j,134424,134432|0);c[ca>>2]=c[ua>>2];break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];ca=XS(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=ca+ -1900;break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];WS(0,e,m,h,Ia);break};case 70:{ca=e;c[ka>>2]=c[ca>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];KS(ja,d,J,I,g,h,j,134392,134400|0);c[ca>>2]=c[ja>>2];break};case 99:{ca=d+8|0;Da=Yd[c[(c[ca>>2]|0)+12>>2]&127](ca)|0;ca=e;c[ea>>2]=c[ca>>2];c[fa>>2]=c[f>>2];Ha=a[Da]|0;if((Ha&1)==0){Ja=Da+1|0;Ka=Da+1|0;La=(Ha&255)>>>1}else{Ha=c[Da+8>>2]|0;Ja=Ha;Ka=Ha;La=c[Da+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];KS(da,d,O,N,g,h,j,Ka,Ja+La|0);c[ca>>2]=c[da>>2];break};case 68:{ca=e;c[ha>>2]=c[ca>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];KS(ga,d,L,K,g,h,j,134384,134392|0);c[ca>>2]=c[ga>>2];break};case 114:{ca=e;c[pa>>2]=c[ca>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];KS(oa,d,A,z,g,h,j,134400,134411|0);c[ca>>2]=c[oa>>2];break};case 73:{ca=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Da=XS(e,G,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((Da+ -1|0)>>>0<12)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Ha|4;break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=XS(e,w,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];ca=XS(e,H,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<24){c[j+8>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 88:{Da=d+8|0;ca=Yd[c[(c[Da>>2]|0)+24>>2]&127](Da)|0;Da=e;c[Aa>>2]=c[Da>>2];c[Ba>>2]=c[f>>2];Fa=a[ca]|0;if((Fa&1)==0){Ma=ca+1|0;Na=ca+1|0;Oa=(Fa&255)>>>1}else{Fa=c[ca+8>>2]|0;Ma=Fa;Na=Fa;Oa=c[ca+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];KS(za,d,q,p,g,h,j,Na,Ma+Oa|0);c[Da>>2]=c[za>>2];break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];US(0,e,C,h,Ia);break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Da=XS(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<60){c[j+4>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 120:{ca=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];ie[ca&63](b,d,s,r,g,h,j);i=l;return};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];VS(d,j+8|0,e,B,h,Ia);break};case 82:{ca=e;c[sa>>2]=c[ca>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];KS(ra,d,y,x,g,h,j,134416,134421|0);c[ca>>2]=c[ra>>2];break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];ca=XS(e,t,h,Ia,1)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<7){c[j+24>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Da=XS(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Da|0)<69){Pa=Da+2e3|0}else{Pa=(Da+ -69|0)>>>0<31?Da+1900|0:Da}c[j+20>>2]=Pa+ -1900;break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Da=XS(e,F,h,Ia,3)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<366){c[j+28>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 101:case 100:{ca=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Da=XS(e,M,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Da+ -1|0)>>>0<31)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Fa|4;break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function US(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;j=e;e=f;f=h+8|0;a:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if((Yd[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;do{if((l|0)==0){m=12}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(h){n=l;break}else{o=l;break a}}if((Yd[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;m=12;break}else{if(h){n=l;break}else{o=l;break a}}}}while(0);if((m|0)==12){m=0;if(h){o=0;break}else{n=0}}l=c[j>>2]|0;p=c[l+12>>2]|0;if((p|0)==(c[l+16>>2]|0)){q=(Yd[c[(c[l>>2]|0)+36>>2]&127](l)|0)&255}else{q=a[p]|0}if(!(q<<24>>24>-1)){o=n;break}if((b[(c[f>>2]|0)+(q<<24>>24<<1)>>1]&8192)==0){o=n;break}p=c[j>>2]|0;l=p+12|0;r=c[l>>2]|0;if((r|0)==(c[p+16>>2]|0)){Yd[c[(c[p>>2]|0)+40>>2]&127](p)|0;continue}else{c[l>>2]=r+1;continue}}n=c[j>>2]|0;do{if((n|0)==0){s=0}else{if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){s=n;break}if((Yd[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1){c[j>>2]=0;s=0;break}else{s=c[j>>2]|0;break}}}while(0);j=(s|0)==0;b:do{if((o|0)==0){m=32}else{do{if((c[o+12>>2]|0)==(c[o+16>>2]|0)){if(!((Yd[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1)){break}c[e>>2]=0;m=32;break b}}while(0);if(!j){break}i=d;return}}while(0);do{if((m|0)==32){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function VS(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=Yd[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=lR(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function WS(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;b=i;h=d;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if((Yd[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e;e=c[j>>2]|0;a:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((Yd[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[j>>2]=0;k=11;break a}}while(0);if(d){l=e}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){m=(Yd[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{m=a[e]|0}if(!(($d[c[(c[g>>2]|0)+36>>2]&63](g,m,0)|0)<<24>>24==37)){c[f>>2]=c[f>>2]|4;i=b;return}m=c[h>>2]|0;g=m+12|0;e=c[g>>2]|0;if((e|0)==(c[m+16>>2]|0)){Yd[c[(c[m>>2]|0)+40>>2]&127](m)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){n=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){n=e;break}if((Yd[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[h>>2]=0;n=0;break}else{n=c[h>>2]|0;break}}}while(0);h=(n|0)==0;b:do{if((l|0)==0){k=31}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if(!((Yd[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){break}c[j>>2]=0;k=31;break b}}while(0);if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function XS(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=d;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if((Yd[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e;e=c[l>>2]|0;a:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((Yd[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[l>>2]=0;m=11;break a}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=(Yd[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>-1){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=($d[c[(c[g>>2]|0)+36>>2]&63](g,p,0)|0)<<24>>24;q=c[k>>2]|0;r=q+12|0;s=c[r>>2]|0;if((s|0)==(c[q+16>>2]|0)){Yd[c[(c[q>>2]|0)+40>>2]&127](q)|0;t=h;u=n;v=n;w=d}else{c[r>>2]=s+1;t=h;u=n;v=n;w=d}while(1){x=w+ -48|0;d=t+ -1|0;s=c[k>>2]|0;do{if((s|0)==0){y=0}else{if((c[s+12>>2]|0)!=(c[s+16>>2]|0)){y=s;break}if((Yd[c[(c[s>>2]|0)+36>>2]&127](s)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);s=(y|0)==0;do{if((v|0)==0){z=u;A=0}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){z=u;A=v;break}if(!((Yd[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1)){z=u;A=u;break}c[l>>2]=0;z=0;A=0}}while(0);B=c[k>>2]|0;if(!((s^(A|0)==0)&(d|0)>0)){m=40;break}r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){C=(Yd[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[r]|0}if(!(C<<24>>24>-1)){o=x;m=52;break}if((b[(c[e>>2]|0)+(C<<24>>24<<1)>>1]&2048)==0){o=x;m=52;break}r=(($d[c[(c[g>>2]|0)+36>>2]&63](g,C,0)|0)<<24>>24)+(x*10|0)|0;q=c[k>>2]|0;D=q+12|0;E=c[D>>2]|0;if((E|0)==(c[q+16>>2]|0)){Yd[c[(c[q>>2]|0)+40>>2]&127](q)|0;F=d;u=z;v=A;w=r;t=F;continue}else{c[D>>2]=E+1;F=d;u=z;v=A;w=r;t=F;continue}}if((m|0)==40){do{if((B|0)==0){G=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){G=B;break}if((Yd[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);e=(G|0)==0;b:do{if((z|0)==0){m=50}else{do{if((c[z+12>>2]|0)==(c[z+16>>2]|0)){if(!((Yd[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1)){break}c[l>>2]=0;m=50;break b}}while(0);if(e){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==50){if(e){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==52){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function YS(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;l=i;i=i+64|0;m=l;n=l+8|0;o=l+16|0;p=l+32|0;q=l+40|0;r=l+48|0;s=l+56|0;qP(p,f);t=p;p=c[t>>2]|0;if(!((c[33866]|0)==-1)){c[o>>2]=135464;c[o+4>>2]=281;c[o+8>>2]=0;fO(135464,o,282)}o=(c[135468>>2]|0)+ -1|0;u=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-u>>2>>>0>o>>>0)){v=zc(4)|0;w=v;eY(w);x=151032;y=127;Hd(v|0,x|0,y|0)}p=c[u+(o<<2)>>2]|0;if((p|0)==0){v=zc(4)|0;w=v;eY(w);x=151032;y=127;Hd(v|0,x|0,y|0)}y=p;MN(c[t>>2]|0)|0;c[g>>2]=0;t=d;a:do{if((j|0)==(k|0)){z=69}else{x=e;v=r;w=s;o=q;u=j;A=0;b:while(1){B=A;while(1){if((B|0)!=0){z=69;break a}C=c[t>>2]|0;do{if((C|0)==0){D=0;E=1}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){G=Yd[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[F>>2]|0}if(!((G|0)==-1)){D=C;E=0;break}c[t>>2]=0;D=0;E=1}}while(0);C=c[x>>2]|0;do{if((C|0)==0){z=22}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){H=Yd[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{H=c[F>>2]|0}if((H|0)==-1){c[x>>2]=0;z=22;break}else{if(E){I=C;break}else{z=24;break b}}}}while(0);if((z|0)==22){z=0;if(E){z=24;break b}else{I=0}}if(($d[c[(c[p>>2]|0)+52>>2]&63](y,c[u>>2]|0,0)|0)<<24>>24==37){z=26;break}if($d[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[u>>2]|0)|0){J=u;z=36;break}K=D+12|0;C=c[K>>2]|0;L=D+16|0;if((C|0)==(c[L>>2]|0)){M=Yd[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{M=c[C>>2]|0}C=le[c[(c[p>>2]|0)+28>>2]&63](y,M)|0;if((C|0)==(le[c[(c[p>>2]|0)+28>>2]&63](y,c[u>>2]|0)|0)){z=64;break}c[g>>2]=4;B=4}c:do{if((z|0)==26){z=0;B=u+4|0;if((B|0)==(k|0)){z=27;break b}C=$d[c[(c[p>>2]|0)+52>>2]&63](y,c[B>>2]|0,0)|0;if(C<<24>>24==48|C<<24>>24==69){F=u+8|0;if((F|0)==(k|0)){z=30;break b}N=F;O=$d[c[(c[p>>2]|0)+52>>2]&63](y,c[F>>2]|0,0)|0;P=C}else{N=B;O=C;P=0}C=c[(c[b>>2]|0)+36>>2]|0;c[v>>2]=D;c[w>>2]=I;B=n;F=r;c[B+0>>2]=c[F+0>>2];F=m;B=s;c[F+0>>2]=c[B+0>>2];ke[C&3](q,b,n,m,f,g,h,O,P);c[t>>2]=c[o>>2];Q=N+4|0}else if((z|0)==36){while(1){z=0;C=J+4|0;if((C|0)==(k|0)){R=k;break}if($d[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[C>>2]|0)|0){J=C;z=36}else{R=C;break}}C=D;B=I;F=I;while(1){do{if((C|0)==0){S=0;T=1}else{U=c[C+12>>2]|0;if((U|0)==(c[C+16>>2]|0)){V=Yd[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{V=c[U>>2]|0}if(!((V|0)==-1)){S=C;T=0;break}c[t>>2]=0;S=0;T=1}}while(0);do{if((F|0)==0){W=B;z=51}else{U=c[F+12>>2]|0;if((U|0)==(c[F+16>>2]|0)){X=Yd[c[(c[F>>2]|0)+36>>2]&127](F)|0}else{X=c[U>>2]|0}if((X|0)==-1){c[x>>2]=0;W=0;z=51;break}else{if(T^(B|0)==0){Y=B;Z=B;break}else{Q=R;break c}}}}while(0);if((z|0)==51){z=0;if(T){Q=R;break c}else{Y=W;Z=0}}U=S+12|0;_=c[U>>2]|0;$=S+16|0;if((_|0)==(c[$>>2]|0)){aa=Yd[c[(c[S>>2]|0)+36>>2]&127](S)|0}else{aa=c[_>>2]|0}if(!($d[c[(c[p>>2]|0)+12>>2]&63](y,8192,aa)|0)){Q=R;break c}_=c[U>>2]|0;if((_|0)==(c[$>>2]|0)){Yd[c[(c[S>>2]|0)+40>>2]&127](S)|0;C=S;B=Y;F=Z;continue}else{c[U>>2]=_+4;C=S;B=Y;F=Z;continue}}}else if((z|0)==64){z=0;F=c[K>>2]|0;if((F|0)==(c[L>>2]|0)){Yd[c[(c[D>>2]|0)+40>>2]&127](D)|0}else{c[K>>2]=F+4}Q=u+4|0}}while(0);if((Q|0)==(k|0)){z=69;break a}u=Q;A=c[g>>2]|0}if((z|0)==24){c[g>>2]=4;ba=D;break}else if((z|0)==27){c[g>>2]=4;ba=D;break}else if((z|0)==30){c[g>>2]=4;ba=D;break}}}while(0);if((z|0)==69){ba=c[t>>2]|0}t=d;do{if((ba|0)==0){ca=0;da=1}else{d=c[ba+12>>2]|0;if((d|0)==(c[ba+16>>2]|0)){ea=Yd[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ea=c[d>>2]|0}if(!((ea|0)==-1)){ca=ba;da=0;break}c[t>>2]=0;ca=0;da=1}}while(0);t=e;e=c[t>>2]|0;do{if((e|0)==0){z=82}else{ba=c[e+12>>2]|0;if((ba|0)==(c[e+16>>2]|0)){fa=Yd[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{fa=c[ba>>2]|0}if((fa|0)==-1){c[t>>2]=0;z=82;break}if(!da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);do{if((z|0)==82){if(da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;ga=a;ha=ga;c[ha>>2]=ca;i=l;return}function ZS(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function _S(a){a=a|0;i=i;return}function $S(a){a=a|0;i=i;return 2}function aT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];YS(a,b,l,k,f,g,h,134528,134560|0);i=j;return}function bT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=Yd[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+4|0;s=q+4|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+(t<<2)|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];YS(b,d,m,l,g,h,j,s,q);i=k;return}function cT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;qP(n,f);f=n;n=c[f>>2]|0;if(!((c[33866]|0)==-1)){c[m>>2]=135464;c[m+4>>2]=281;c[m+8>>2]=0;fO(135464,m,282)}m=(c[135468>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=zc(4)|0;q=p;eY(q);r=151032;s=127;Hd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=zc(4)|0;q=p;eY(q);r=151032;s=127;Hd(p|0,r|0,s|0)}s=n;MN(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=Yd[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=KR(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function dT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;qP(n,f);f=n;n=c[f>>2]|0;if(!((c[33866]|0)==-1)){c[m>>2]=135464;c[m+4>>2]=281;c[m+8>>2]=0;fO(135464,m,282)}m=(c[135468>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=zc(4)|0;q=p;eY(q);r=151032;s=127;Hd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=zc(4)|0;q=p;eY(q);r=151032;s=127;Hd(p|0,r|0,s|0)}s=n;MN(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=Yd[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=KR(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function eT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;qP(m,f);f=m;m=c[f>>2]|0;if(!((c[33866]|0)==-1)){c[l>>2]=135464;c[l+4>>2]=281;c[l+8>>2]=0;fO(135464,l,282)}l=(c[135468>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=zc(4)|0;p=o;eY(p);q=151032;r=127;Hd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=zc(4)|0;p=o;eY(p);q=151032;r=127;Hd(o|0,q|0,r|0)}r=m;MN(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=jT(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function fT(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;qP(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[33866]|0)==-1)){c[ba>>2]=135464;c[ba+4>>2]=281;c[ba+8>>2]=0;fO(135464,ba,282)}ba=(c[135468>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=zc(4)|0;Ga=Fa;eY(Ga);Ha=151032;Ia=127;Hd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=zc(4)|0;Ga=Fa;eY(Ga);Ha=151032;Ia=127;Hd(Fa|0,Ha|0,Ia|0)}Ia=ca;MN(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Da=jT(e,H,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<24){c[j+8>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 104:case 66:case 98:{ca=c[f>>2]|0;Da=d+8|0;Ha=Yd[c[(c[Da>>2]|0)+4>>2]&127](Da)|0;c[$>>2]=ca;c[P+0>>2]=c[$+0>>2];ca=(KR(e,P,Ha,Ha+288|0,Ia,h,0)|0)-Ha|0;if((ca|0)>=288){break a}c[j+16>>2]=((ca|0)/12|0|0)%12|0;break};case 84:{ca=e;c[va>>2]=c[ca>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];YS(ua,d,v,u,g,h,j,134696,134728|0);c[ca>>2]=c[ua>>2];break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];ca=jT(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=ca+ -1900;break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];iT(0,e,m,h,Ia);break};case 73:{ca=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Ha=jT(e,G,h,Ia,2)|0;Da=c[h>>2]|0;do{if((Da&4|0)==0){if(!((Ha+ -1|0)>>>0<12)){break}c[ca>>2]=Ha;break a}}while(0);c[h>>2]=Da|4;break};case 68:{Ha=e;c[ha>>2]=c[Ha>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];YS(ga,d,L,K,g,h,j,134560,134592|0);c[Ha>>2]=c[ga>>2];break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Ha=jT(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Ha|0)<60){c[j+4>>2]=Ha;break a}else{c[h>>2]=ca|4;break a}break};case 101:case 100:{ca=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Ha=jT(e,M,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Ha+ -1|0)>>>0<31)){break}c[ca>>2]=Ha;break a}}while(0);c[h>>2]=Fa|4;break};case 65:case 97:{Ha=c[f>>2]|0;ca=d+8|0;Da=Yd[c[c[ca>>2]>>2]&127](ca)|0;c[aa>>2]=Ha;c[Q+0>>2]=c[aa+0>>2];Ha=(KR(e,Q,Da,Da+168|0,Ia,h,0)|0)-Da|0;if((Ha|0)>=168){break a}c[j+24>>2]=((Ha|0)/12|0|0)%7|0;break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Ha=jT(e,F,h,Ia,3)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Ha|0)<366){c[j+28>>2]=Ha;break a}else{c[h>>2]=Da|4;break a}break};case 114:{Da=e;c[pa>>2]=c[Da>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];YS(oa,d,A,z,g,h,j,134624,134668|0);c[Da>>2]=c[oa>>2];break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=jT(e,w,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=Ha|4;break a}break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Ha=jT(e,E,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Ha|0)<13){c[j+16>>2]=Ha+ -1;break a}else{c[h>>2]=Da|4;break a}break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Da=jT(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Da|0)<69){Ja=Da+2e3|0}else{Ja=(Da+ -69|0)>>>0<31?Da+1900|0:Da}c[j+20>>2]=Ja+ -1900;break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];gT(0,e,C,h,Ia);break};case 70:{Da=e;c[ka>>2]=c[Da>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];YS(ja,d,J,I,g,h,j,134592,134624|0);c[Da>>2]=c[ja>>2];break};case 120:{Da=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];ie[Da&63](b,d,s,r,g,h,j);i=l;return};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];hT(d,j+8|0,e,B,h,Ia);break};case 82:{Da=e;c[sa>>2]=c[Da>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];YS(ra,d,y,x,g,h,j,134672,134692|0);c[Da>>2]=c[ra>>2];break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];Da=jT(e,t,h,Ia,1)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<7){c[j+24>>2]=Da;break a}else{c[h>>2]=Ha|4;break a}break};case 88:{Ha=d+8|0;Da=Yd[c[(c[Ha>>2]|0)+24>>2]&127](Ha)|0;Ha=e;c[Aa>>2]=c[Ha>>2];c[Ba>>2]=c[f>>2];ca=a[Da]|0;if((ca&1)==0){Ka=Da+4|0;La=Da+4|0;Ma=(ca&255)>>>1}else{ca=c[Da+8>>2]|0;Ka=ca;La=ca;Ma=c[Da+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];YS(za,d,q,p,g,h,j,La,Ka+(Ma<<2)|0);c[Ha>>2]=c[za>>2];break};case 99:{Ha=d+8|0;Da=Yd[c[(c[Ha>>2]|0)+12>>2]&127](Ha)|0;Ha=e;c[ea>>2]=c[Ha>>2];c[fa>>2]=c[f>>2];ca=a[Da]|0;if((ca&1)==0){Na=Da+4|0;Oa=Da+4|0;Pa=(ca&255)>>>1}else{ca=c[Da+8>>2]|0;Na=ca;Oa=ca;Pa=c[Da+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];YS(da,d,O,N,g,h,j,Oa,Na+(Pa<<2)|0);c[Ha>>2]=c[da>>2];break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function gT(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;g=b;b=d;a:while(1){d=c[g>>2]|0;do{if((d|0)==0){h=1}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){k=Yd[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);d=c[b>>2]|0;do{if((d|0)==0){l=15}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){m=Yd[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[j>>2]|0}if((m|0)==-1){c[b>>2]=0;l=15;break}else{if(h){n=d;break}else{o=d;break a}}}}while(0);if((l|0)==15){l=0;if(h){o=0;break}else{n=0}}d=c[g>>2]|0;j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){p=Yd[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{p=c[j>>2]|0}if(!($d[c[(c[f>>2]|0)+12>>2]&63](f,8192,p)|0)){o=n;break}j=c[g>>2]|0;d=j+12|0;q=c[d>>2]|0;if((q|0)==(c[j+16>>2]|0)){Yd[c[(c[j>>2]|0)+40>>2]&127](j)|0;continue}else{c[d>>2]=q+4;continue}}n=c[g>>2]|0;do{if((n|0)==0){r=1}else{p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){s=Yd[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{s=c[p>>2]|0}if((s|0)==-1){c[g>>2]=0;r=1;break}else{r=(c[g>>2]|0)==0;break}}}while(0);do{if((o|0)==0){l=37}else{g=c[o+12>>2]|0;if((g|0)==(c[o+16>>2]|0)){t=Yd[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{t=c[g>>2]|0}if((t|0)==-1){c[b>>2]=0;l=37;break}if(!r){break}i=a;return}}while(0);do{if((l|0)==37){if(r){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function hT(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=Yd[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=KR(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function iT(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;g=b;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=Yd[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=Yd[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{if(h){n=d;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){o=Yd[c[(c[h>>2]|0)+36>>2]&127](h)|0}else{o=c[d>>2]|0}if(!(($d[c[(c[f>>2]|0)+52>>2]&63](f,o,0)|0)<<24>>24==37)){c[e>>2]=c[e>>2]|4;i=a;return}o=c[g>>2]|0;f=o+12|0;d=c[f>>2]|0;if((d|0)==(c[o+16>>2]|0)){Yd[c[(c[o>>2]|0)+40>>2]&127](o)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){p=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){q=Yd[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{q=c[f>>2]|0}if((q|0)==-1){c[g>>2]=0;p=1;break}else{p=(c[g>>2]|0)==0;break}}}while(0);do{if((n|0)==0){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){r=Yd[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{r=c[g>>2]|0}if((r|0)==-1){c[k>>2]=0;l=38;break}if(!p){break}i=a;return}}while(0);do{if((l|0)==38){if(p){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function jT(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;h=a;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=Yd[c[(c[a>>2]|0)+36>>2]&127](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=Yd[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=Yd[c[(c[j>>2]|0)+36>>2]&127](j)|0}else{q=c[b>>2]|0}if(!($d[c[(c[e>>2]|0)+12>>2]&63](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}b=($d[c[(c[e>>2]|0)+52>>2]&63](e,q,0)|0)<<24>>24;q=c[h>>2]|0;j=q+12|0;n=c[j>>2]|0;if((n|0)==(c[q+16>>2]|0)){Yd[c[(c[q>>2]|0)+40>>2]&127](q)|0;r=f;s=o;t=o;u=b}else{c[j>>2]=n+4;r=f;s=o;t=o;u=b}while(1){v=u+ -48|0;b=r+ -1|0;o=c[h>>2]|0;do{if((o|0)==0){w=1}else{f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0)){x=Yd[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{x=c[f>>2]|0}if((x|0)==-1){c[h>>2]=0;w=1;break}else{w=(c[h>>2]|0)==0;break}}}while(0);do{if((t|0)==0){y=s;z=0;A=1}else{o=c[t+12>>2]|0;if((o|0)==(c[t+16>>2]|0)){B=Yd[c[(c[t>>2]|0)+36>>2]&127](t)|0}else{B=c[o>>2]|0}if((B|0)==-1){c[l>>2]=0;y=0;z=0;A=1;break}else{y=s;z=s;A=(s|0)==0;break}}}while(0);C=c[h>>2]|0;if(!((w^A)&(b|0)>0)){break}o=c[C+12>>2]|0;if((o|0)==(c[C+16>>2]|0)){D=Yd[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{D=c[o>>2]|0}if(!($d[c[(c[e>>2]|0)+12>>2]&63](e,2048,D)|0)){p=v;m=63;break}o=(($d[c[(c[e>>2]|0)+52>>2]&63](e,D,0)|0)<<24>>24)+(v*10|0)|0;f=c[h>>2]|0;n=f+12|0;j=c[n>>2]|0;if((j|0)==(c[f+16>>2]|0)){Yd[c[(c[f>>2]|0)+40>>2]&127](f)|0;E=b;s=y;t=z;u=o;r=E;continue}else{c[n>>2]=j+4;E=b;s=y;t=z;u=o;r=E;continue}}if((m|0)==63){i=g;return p|0}do{if((C|0)==0){F=1}else{E=c[C+12>>2]|0;if((E|0)==(c[C+16>>2]|0)){G=Yd[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[h>>2]=0;F=1;break}else{F=(c[h>>2]|0)==0;break}}}while(0);do{if((y|0)==0){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){H=Yd[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{H=c[h>>2]|0}if((H|0)==-1){c[l>>2]=0;m=60;break}if(F){p=v}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(F){break}else{p=v}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=v;i=g;return p|0}function kT(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);if((f|0)==(c[33840]|0)){g=b;HY(g);i=d;return}Xb(c[e>>2]|0);g=b;HY(g);i=d;return}function lT(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);if((b|0)==(c[33840]|0)){i=d;return}Xb(c[e>>2]|0);i=d;return}function mT(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;f=g;l=g+8|0;m=l;n=f;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(!(k<<24>>24==0)){a[o]=k;a[p]=j}j=Nc(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b;s=r;c[s>>2]=q;i=g;return}else{t=m;u=l;v=l}while(1){l=a[t]|0;do{if((v|0)==0){w=u;x=0}else{m=v+24|0;j=c[m>>2]|0;if((j|0)==(c[v+28>>2]|0)){e=(le[c[(c[v>>2]|0)+52>>2]&63](v,l&255)|0)==-1;w=e?0:u;x=e?0:v;break}else{c[m>>2]=j+1;a[j]=l;w=u;x=v;break}}}while(0);l=t+1|0;if((l|0)==(d|0)){q=w;break}else{t=l;u=w;v=x}}r=b;s=r;c[s>>2]=q;i=g;return}function nT(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);if((f|0)==(c[33840]|0)){g=b;HY(g);i=d;return}Xb(c[e>>2]|0);g=b;HY(g);i=d;return}function oT(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);if((b|0)==(c[33840]|0)){i=d;return}Xb(c[e>>2]|0);i=d;return}function pT(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+408|0;e=f;k=f+400|0;l=e;c[k>>2]=e+400;qT(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a;o=n;c[o>>2]=m;i=f;return}else{p=l;q=k;r=k}while(1){k=c[p>>2]|0;if((q|0)==0){s=r;t=0}else{l=q+24|0;d=c[l>>2]|0;if((d|0)==(c[q+28>>2]|0)){u=le[c[(c[q>>2]|0)+52>>2]&63](q,k)|0}else{c[l>>2]=d+4;c[d>>2]=k;u=k}k=(u|0)==-1;s=k?0:r;t=k?0:q}k=p+4|0;if((k|0)==(j|0)){m=s;break}else{p=k;q=t;r=s}}n=a;o=n;c[o>>2]=m;i=f;return}function qT(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j;l=j+112|0;m=i;i=i+8|0;n=j+8|0;o=k;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(!(h<<24>>24==0)){a[p]=h;a[q]=g}g=b;Nc(n|0,100,o|0,f|0,c[g>>2]|0)|0;f=l;c[f>>2]=0;c[f+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=Gc(c[g>>2]|0)|0;g=CX(d,m,n,l)|0;if((f|0)!=0){Gc(f|0)|0}if((g|0)==-1){mU(136352)}else{c[e>>2]=d+(g<<2);i=j;return}}function rT(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function sT(a){a=a|0;i=i;return}function tT(a){a=a|0;i=i;return 127}function uT(a){a=a|0;i=i;return 127}function vT(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function wT(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function xT(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function yT(a,b){a=a|0;b=b|0;b=i;qO(a,1,45);i=b;return}function zT(a){a=a|0;i=i;return 0}function AT(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function BT(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function CT(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function DT(a){a=a|0;i=i;return}function ET(a){a=a|0;i=i;return 127}function FT(a){a=a|0;i=i;return 127}function GT(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function HT(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function IT(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function JT(a,b){a=a|0;b=b|0;b=i;qO(a,1,45);i=b;return}function KT(a){a=a|0;i=i;return 0}function LT(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function MT(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function NT(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function OT(a){a=a|0;i=i;return}function PT(a){a=a|0;i=i;return 2147483647}function QT(a){a=a|0;i=i;return 2147483647}function RT(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function ST(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function TT(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function UT(a,b){a=a|0;b=b|0;b=i;XO(a,1,45);i=b;return}function VT(a){a=a|0;i=i;return 0}function WT(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function XT(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function YT(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function ZT(a){a=a|0;i=i;return}function _T(a){a=a|0;i=i;return 2147483647}function $T(a){a=a|0;i=i;return 2147483647}function aU(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function bU(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function cU(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function dU(a,b){a=a|0;b=b|0;b=i;XO(a,1,45);i=b;return}function eU(a){a=a|0;i=i;return 0}function fU(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function gU(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function hU(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function iU(a){a=a|0;i=i;return}function jU(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+104|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=283;y=o+100|0;qP(r,h);o=r;z=c[o>>2]|0;if(!((c[33868]|0)==-1)){c[n>>2]=135472;c[n+4>>2]=281;c[n+8>>2]=0;fO(135472,n,282)}n=(c[135476>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=zc(4)|0;C=B;eY(C);D=151032;E=127;Hd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=zc(4)|0;C=B;eY(C);D=151032;E=127;Hd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=lU(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;ue[c[(c[z>>2]|0)+32>>2]&63](E,135088,135098|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>98){l=zY(g+2|0)|0;if((l|0)!=0){F=l;G=l;break}MY()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+10|0;l=u;h=H;t=r;while(1){C=a[t]|0;n=y;while(1){A=n+1|0;if((a[n]|0)==C<<24>>24){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[135088+(I-l)|0]|0;n=t+1|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((md(p|0,135104,m|0)|0)!=1){t=zc(8)|0;SN(t,135112);Hd(t|0,132464,42)}if((F|0)==0){break}AY(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){K=e;break}if(!((Yd[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){K=e;break}c[F>>2]=0;K=0}}while(0);F=(K|0)==0;e=c[D>>2]|0;do{if((e|0)==0){L=31}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){if(F){break}else{L=33;break}}if((Yd[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[D>>2]=0;L=31;break}else{if(F){break}else{L=33;break}}}}while(0);if((L|0)==31){if(F){L=33}}if((L|0)==33){c[j>>2]=c[j>>2]|2}c[b>>2]=K;MN(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}Vd[c[x>>2]&511](o);i=d;return}function kU(a){a=a|0;i=i;return}function lU(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;q=i;i=i+408|0;r=q;s=q+400|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=r;c[s>>2]=0;E=w;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=x;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=y;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=z;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=A;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;pU(g,h,t,u,v,w,x,y,z,B);t=n;c[o>>2]=c[t>>2];h=e;e=f;f=m+8|0;m=z+1|0;g=z+4|0;E=z+8|0;F=y+1|0;G=y+4|0;H=y+8|0;I=(j&512|0)!=0;j=x+1|0;J=x+8|0;K=x+4|0;L=A+1|0;M=A+8|0;N=A+4|0;O=s+3|0;P=n+4|0;n=w+4|0;Q=r+400|0;r=D;R=D;D=p;p=0;S=0;T=283;a:while(1){U=c[h>>2]|0;do{if((U|0)==0){V=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){V=U;break}if((Yd[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;V=0;break}else{V=c[h>>2]|0;break}}}while(0);U=(V|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=12}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}if((Yd[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=12;break}else{if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}}}while(0);if((X|0)==12){X=0;if(U){Z=R;_=r;$=S;aa=T;X=269;break}else{Y=0}}b:do{switch(a[s+p|0]|0){case 2:{if(!((S|0)!=0|p>>>0<2)){if((p|0)==2){ba=(a[O]|0)!=0}else{ba=0}if(!(I|ba)){ca=D;da=R;ea=r;fa=Q;ga=0;ha=T;break b}}W=a[x]|0;ia=(W&1)==0;ja=ia?j:c[J>>2]|0;c:do{if((p|0)==0){ka=Y;la=Y;ma=W;na=ja}else{if((d[s+(p+ -1)|0]|0)>=2){ka=Y;la=Y;ma=W;na=ja;break}oa=ja+(ia?(W&255)>>>1:c[K>>2]|0)|0;pa=ja;while(1){if((pa|0)==(oa|0)){qa=oa;break}ra=a[pa]|0;if(!(ra<<24>>24>-1)){qa=pa;break}if((b[(c[f>>2]|0)+(ra<<24>>24<<1)>>1]&8192)==0){qa=pa;break}else{pa=pa+1|0}}pa=qa-ja|0;oa=a[A]|0;ra=(oa&1)==0;if(ra){sa=(oa&255)>>>1}else{sa=c[N>>2]|0}if(pa>>>0>sa>>>0){ka=Y;la=Y;ma=W;na=ja;break}if(ra){ra=(oa&255)>>>1;ta=A+1+(ra-pa)|0;ua=L;va=ra}else{ra=c[M>>2]|0;oa=c[N>>2]|0;ta=ra+(oa-pa)|0;ua=ra;va=oa}oa=ua+va|0;if((ta|0)==(oa|0)){ka=Y;la=Y;ma=W;na=qa;break}else{wa=ja;xa=ta}while(1){if((a[xa]|0)!=(a[wa]|0)){ka=Y;la=Y;ma=W;na=ja;break c}ra=xa+1|0;if((ra|0)==(oa|0)){ka=Y;la=Y;ma=W;na=qa;break}else{wa=wa+1|0;xa=ra}}}}while(0);d:while(1){if((ma&1)==0){ya=j;za=(ma&255)>>>1}else{ya=c[J>>2]|0;za=c[K>>2]|0}if((na|0)==(ya+za|0)){break}W=c[h>>2]|0;do{if((W|0)==0){Aa=0}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){Aa=W;break}if((Yd[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[h>>2]=0;Aa=0;break}else{Aa=c[h>>2]|0;break}}}while(0);W=(Aa|0)==0;do{if((la|0)==0){Ba=ka;X=147}else{if((c[la+12>>2]|0)!=(c[la+16>>2]|0)){if(W){Ca=ka;Da=la;break}else{break d}}if((Yd[c[(c[la>>2]|0)+36>>2]&127](la)|0)==-1){c[e>>2]=0;Ba=0;X=147;break}else{if(W^(ka|0)==0){Ca=ka;Da=ka;break}else{break d}}}}while(0);if((X|0)==147){X=0;if(W){break}else{Ca=Ba;Da=0}}ja=c[h>>2]|0;ia=c[ja+12>>2]|0;if((ia|0)==(c[ja+16>>2]|0)){Ea=(Yd[c[(c[ja>>2]|0)+36>>2]&127](ja)|0)&255}else{Ea=a[ia]|0}if(!(Ea<<24>>24==(a[na]|0))){break}ia=c[h>>2]|0;ja=ia+12|0;oa=c[ja>>2]|0;if((oa|0)==(c[ia+16>>2]|0)){Yd[c[(c[ia>>2]|0)+40>>2]&127](ia)|0}else{c[ja>>2]=oa+1}ka=Ca;la=Da;ma=a[x]|0;na=na+1|0}if(!I){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break b}oa=a[x]|0;if((oa&1)==0){Fa=j;Ga=(oa&255)>>>1}else{Fa=c[J>>2]|0;Ga=c[K>>2]|0}if((na|0)==(Fa+Ga|0)){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T}else{X=162;break a}break};case 0:{X=26;break};case 3:{oa=a[y]|0;ja=(oa&1)==0;if(ja){Ha=(oa&255)>>>1}else{Ha=c[G>>2]|0}ia=a[z]|0;ra=(ia&1)==0;if(ra){Ia=(ia&255)>>>1}else{Ia=c[g>>2]|0}if((Ha|0)==(0-Ia|0)){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break b}if(ja){Ja=(oa&255)>>>1}else{Ja=c[G>>2]|0}do{if((Ja|0)!=0){if(ra){Ka=(ia&255)>>>1}else{Ka=c[g>>2]|0}if((Ka|0)==0){break}pa=c[h>>2]|0;La=c[pa+12>>2]|0;Ma=c[pa+16>>2]|0;if((La|0)==(Ma|0)){Na=(Yd[c[(c[pa>>2]|0)+36>>2]&127](pa)|0)&255;Oa=c[h>>2]|0;Pa=Na;Qa=c[Oa+16>>2]|0;Ra=c[Oa+12>>2]|0;Sa=Oa;Ta=a[y]|0}else{Pa=a[La]|0;Qa=Ma;Ra=La;Sa=pa;Ta=oa}pa=Sa+12|0;La=(Ra|0)==(Qa|0);if(Pa<<24>>24==(a[(Ta&1)==0?F:c[H>>2]|0]|0)){if(La){Yd[c[(c[Sa>>2]|0)+40>>2]&127](Sa)|0}else{c[pa>>2]=Ra+1}pa=a[y]|0;if((pa&1)==0){Ua=(pa&255)>>>1}else{Ua=c[G>>2]|0}ca=D;da=R;ea=r;fa=Q;ga=Ua>>>0>1?y:S;ha=T;break b}if(La){Va=(Yd[c[(c[Sa>>2]|0)+36>>2]&127](Sa)|0)&255}else{Va=a[Ra]|0}if(!(Va<<24>>24==(a[(a[z]&1)==0?m:c[E>>2]|0]|0))){X=112;break a}La=c[h>>2]|0;pa=La+12|0;Ma=c[pa>>2]|0;if((Ma|0)==(c[La+16>>2]|0)){Yd[c[(c[La>>2]|0)+40>>2]&127](La)|0}else{c[pa>>2]=Ma+1}a[l]=1;Ma=a[z]|0;if((Ma&1)==0){Wa=(Ma&255)>>>1}else{Wa=c[g>>2]|0}ca=D;da=R;ea=r;fa=Q;ga=Wa>>>0>1?z:S;ha=T;break b}}while(0);if(ja){Xa=(oa&255)>>>1}else{Xa=c[G>>2]|0}ra=c[h>>2]|0;Ma=c[ra+12>>2]|0;pa=(Ma|0)==(c[ra+16>>2]|0);if((Xa|0)==0){if(pa){La=(Yd[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)&255;Ya=La;Za=a[z]|0}else{Ya=a[Ma]|0;Za=ia}if(!(Ya<<24>>24==(a[(Za&1)==0?m:c[E>>2]|0]|0))){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break b}La=c[h>>2]|0;Oa=La+12|0;Na=c[Oa>>2]|0;if((Na|0)==(c[La+16>>2]|0)){Yd[c[(c[La>>2]|0)+40>>2]&127](La)|0}else{c[Oa>>2]=Na+1}a[l]=1;Na=a[z]|0;if((Na&1)==0){_a=(Na&255)>>>1}else{_a=c[g>>2]|0}ca=D;da=R;ea=r;fa=Q;ga=_a>>>0>1?z:S;ha=T;break b}if(pa){pa=(Yd[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)&255;$a=pa;ab=a[y]|0}else{$a=a[Ma]|0;ab=oa}if(!($a<<24>>24==(a[(ab&1)==0?F:c[H>>2]|0]|0))){a[l]=1;ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break b}Ma=c[h>>2]|0;pa=Ma+12|0;ra=c[pa>>2]|0;if((ra|0)==(c[Ma+16>>2]|0)){Yd[c[(c[Ma>>2]|0)+40>>2]&127](Ma)|0}else{c[pa>>2]=ra+1}ra=a[y]|0;if((ra&1)==0){bb=(ra&255)>>>1}else{bb=c[G>>2]|0}ca=D;da=R;ea=r;fa=Q;ga=bb>>>0>1?y:S;ha=T;break};case 1:{if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}ra=c[h>>2]|0;pa=c[ra+12>>2]|0;if((pa|0)==(c[ra+16>>2]|0)){cb=(Yd[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)&255}else{cb=a[pa]|0}if(!(cb<<24>>24>-1)){X=25;break a}if((b[(c[f>>2]|0)+(cb<<24>>24<<1)>>1]&8192)==0){X=25;break a}pa=c[h>>2]|0;ra=pa+12|0;Ma=c[ra>>2]|0;if((Ma|0)==(c[pa+16>>2]|0)){db=(Yd[c[(c[pa>>2]|0)+40>>2]&127](pa)|0)&255}else{c[ra>>2]=Ma+1;db=a[Ma]|0}MO(A,db);X=26;break};case 4:{Ma=D;ra=R;pa=r;Na=Q;Oa=0;La=T;e:while(1){eb=c[h>>2]|0;do{if((eb|0)==0){fb=0}else{if((c[eb+12>>2]|0)!=(c[eb+16>>2]|0)){fb=eb;break}if((Yd[c[(c[eb>>2]|0)+36>>2]&127](eb)|0)==-1){c[h>>2]=0;fb=0;break}else{fb=c[h>>2]|0;break}}}while(0);eb=(fb|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=173}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(eb){break}else{break e}}if((Yd[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=173;break}else{if(eb){break}else{break e}}}}while(0);if((X|0)==173){X=0;if(eb){break}}W=c[h>>2]|0;gb=c[W+12>>2]|0;if((gb|0)==(c[W+16>>2]|0)){hb=(Yd[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255}else{hb=a[gb]|0}do{if(hb<<24>>24>-1){if((b[(c[f>>2]|0)+(hb<<24>>24<<1)>>1]&2048)==0){X=189;break}gb=c[o>>2]|0;if((gb|0)==(Ma|0)){W=(c[P>>2]|0)!=283;ib=c[t>>2]|0;jb=Ma-ib|0;kb=jb>>>0<2147483647?jb<<1:-1;lb=CY(W?ib:0,kb)|0;if((lb|0)==0){X=182;break a}do{if(W){c[t>>2]=lb;mb=lb}else{ib=c[t>>2]|0;c[t>>2]=lb;if((ib|0)==0){mb=lb;break}Vd[c[P>>2]&511](ib);mb=c[t>>2]|0}}while(0);c[P>>2]=258;lb=mb+jb|0;c[o>>2]=lb;nb=lb;ob=(c[t>>2]|0)+kb|0}else{nb=gb;ob=Ma}c[o>>2]=nb+1;a[nb]=hb;pb=ob;qb=ra;rb=pa;sb=Na;tb=Oa+1|0;ub=La}else{X=189}}while(0);if((X|0)==189){X=0;eb=a[w]|0;if((eb&1)==0){vb=(eb&255)>>>1}else{vb=c[n>>2]|0}if((vb|0)==0|(Oa|0)==0){break}if(!(hb<<24>>24==(a[v]|0))){break}if((pa|0)==(Na|0)){eb=pa-ra|0;lb=eb>>>0<2147483647?eb<<1:-1;if((La|0)==283){wb=0}else{wb=ra}W=CY(wb,lb)|0;if((W|0)==0){X=198;break a}xb=W;yb=W+(eb>>2<<2)|0;zb=W+(lb>>>2<<2)|0;Ab=258}else{xb=ra;yb=pa;zb=Na;Ab=La}c[yb>>2]=Oa;pb=Ma;qb=xb;rb=yb+4|0;sb=zb;tb=0;ub=Ab}lb=c[h>>2]|0;W=lb+12|0;eb=c[W>>2]|0;if((eb|0)==(c[lb+16>>2]|0)){Yd[c[(c[lb>>2]|0)+40>>2]&127](lb)|0;Ma=pb;ra=qb;pa=rb;Na=sb;Oa=tb;La=ub;continue}else{c[W>>2]=eb+1;Ma=pb;ra=qb;pa=rb;Na=sb;Oa=tb;La=ub;continue}}if((ra|0)==(pa|0)|(Oa|0)==0){Bb=ra;Cb=pa;Db=Na;Eb=La}else{if((pa|0)==(Na|0)){oa=pa-ra|0;ia=oa>>>0<2147483647?oa<<1:-1;if((La|0)==283){Fb=0}else{Fb=ra}ja=CY(Fb,ia)|0;if((ja|0)==0){X=209;break a}Gb=ja;Hb=ja+(oa>>2<<2)|0;Ib=ja+(ia>>>2<<2)|0;Jb=258}else{Gb=ra;Hb=pa;Ib=Na;Jb=La}c[Hb>>2]=Oa;Bb=Gb;Cb=Hb+4|0;Db=Ib;Eb=Jb}if((c[B>>2]|0)>0){ia=c[h>>2]|0;do{if((ia|0)==0){Kb=0}else{if((c[ia+12>>2]|0)!=(c[ia+16>>2]|0)){Kb=ia;break}if((Yd[c[(c[ia>>2]|0)+36>>2]&127](ia)|0)==-1){c[h>>2]=0;Kb=0;break}else{Kb=c[h>>2]|0;break}}}while(0);ia=(Kb|0)==0;Oa=c[e>>2]|0;do{if((Oa|0)==0){X=223}else{if((c[Oa+12>>2]|0)!=(c[Oa+16>>2]|0)){if(ia){Lb=Oa;break}else{X=229;break a}}if((Yd[c[(c[Oa>>2]|0)+36>>2]&127](Oa)|0)==-1){c[e>>2]=0;X=223;break}else{if(ia){Lb=Oa;break}else{X=229;break a}}}}while(0);if((X|0)==223){X=0;if(ia){X=229;break a}else{Lb=0}}Oa=c[h>>2]|0;La=c[Oa+12>>2]|0;if((La|0)==(c[Oa+16>>2]|0)){Mb=(Yd[c[(c[Oa>>2]|0)+36>>2]&127](Oa)|0)&255}else{Mb=a[La]|0}if(!(Mb<<24>>24==(a[u]|0))){X=229;break a}La=c[h>>2]|0;Oa=La+12|0;Na=c[Oa>>2]|0;if((Na|0)==(c[La+16>>2]|0)){Yd[c[(c[La>>2]|0)+40>>2]&127](La)|0;Nb=Lb;Ob=Lb;Pb=Ma}else{c[Oa>>2]=Na+1;Nb=Lb;Ob=Lb;Pb=Ma}while(1){Na=c[h>>2]|0;do{if((Na|0)==0){Qb=0}else{if((c[Na+12>>2]|0)!=(c[Na+16>>2]|0)){Qb=Na;break}if((Yd[c[(c[Na>>2]|0)+36>>2]&127](Na)|0)==-1){c[h>>2]=0;Qb=0;break}else{Qb=c[h>>2]|0;break}}}while(0);Na=(Qb|0)==0;do{if((Ob|0)==0){Rb=Nb;X=243}else{if((c[Ob+12>>2]|0)!=(c[Ob+16>>2]|0)){if(Na){Sb=Nb;Tb=Ob;break}else{X=250;break a}}if((Yd[c[(c[Ob>>2]|0)+36>>2]&127](Ob)|0)==-1){c[e>>2]=0;Rb=0;X=243;break}else{if(Na^(Nb|0)==0){Sb=Nb;Tb=Nb;break}else{X=250;break a}}}}while(0);if((X|0)==243){X=0;if(Na){X=250;break a}else{Sb=Rb;Tb=0}}Oa=c[h>>2]|0;La=c[Oa+12>>2]|0;if((La|0)==(c[Oa+16>>2]|0)){Ub=(Yd[c[(c[Oa>>2]|0)+36>>2]&127](Oa)|0)&255}else{Ub=a[La]|0}if(!(Ub<<24>>24>-1)){X=250;break a}if((b[(c[f>>2]|0)+(Ub<<24>>24<<1)>>1]&2048)==0){X=250;break a}La=c[o>>2]|0;if((La|0)==(Pb|0)){Oa=(c[P>>2]|0)!=283;pa=c[t>>2]|0;ra=Pb-pa|0;ja=ra>>>0<2147483647?ra<<1:-1;oa=CY(Oa?pa:0,ja)|0;if((oa|0)==0){X=253;break a}do{if(Oa){c[t>>2]=oa;Vb=oa}else{pa=c[t>>2]|0;c[t>>2]=oa;if((pa|0)==0){Vb=oa;break}Vd[c[P>>2]&511](pa);Vb=c[t>>2]|0}}while(0);c[P>>2]=258;oa=Vb+ra|0;c[o>>2]=oa;Wb=oa;Xb=(c[t>>2]|0)+ja|0}else{Wb=La;Xb=Pb}oa=c[h>>2]|0;Oa=c[oa+12>>2]|0;if((Oa|0)==(c[oa+16>>2]|0)){Na=(Yd[c[(c[oa>>2]|0)+36>>2]&127](oa)|0)&255;Yb=Na;Zb=c[o>>2]|0}else{Yb=a[Oa]|0;Zb=Wb}c[o>>2]=Zb+1;a[Zb]=Yb;Oa=(c[B>>2]|0)+ -1|0;c[B>>2]=Oa;Na=c[h>>2]|0;oa=Na+12|0;pa=c[oa>>2]|0;if((pa|0)==(c[Na+16>>2]|0)){Yd[c[(c[Na>>2]|0)+40>>2]&127](Na)|0}else{c[oa>>2]=pa+1}if((Oa|0)>0){Nb=Sb;Ob=Tb;Pb=Xb}else{_b=Xb;break}}}else{_b=Ma}if((c[o>>2]|0)==(c[t>>2]|0)){X=267;break a}else{ca=_b;da=Bb;ea=Cb;fa=Db;ga=S;ha=Eb}break};default:{ca=D;da=R;ea=r;fa=Q;ga=S;ha=T}}}while(0);f:do{if((X|0)==26){X=0;if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}else{$b=Y;ac=Y}while(1){U=c[h>>2]|0;do{if((U|0)==0){bc=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){bc=U;break}if((Yd[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;bc=0;break}else{bc=c[h>>2]|0;break}}}while(0);U=(bc|0)==0;do{if((ac|0)==0){cc=$b;X=37}else{if((c[ac+12>>2]|0)!=(c[ac+16>>2]|0)){if(U){dc=$b;ec=ac;break}else{ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break f}}if((Yd[c[(c[ac>>2]|0)+36>>2]&127](ac)|0)==-1){c[e>>2]=0;cc=0;X=37;break}else{if(U^($b|0)==0){dc=$b;ec=$b;break}else{ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break f}}}}while(0);if((X|0)==37){X=0;if(U){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break f}else{dc=cc;ec=0}}La=c[h>>2]|0;ja=c[La+12>>2]|0;if((ja|0)==(c[La+16>>2]|0)){fc=(Yd[c[(c[La>>2]|0)+36>>2]&127](La)|0)&255}else{fc=a[ja]|0}if(!(fc<<24>>24>-1)){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break f}if((b[(c[f>>2]|0)+(fc<<24>>24<<1)>>1]&8192)==0){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break f}ja=c[h>>2]|0;La=ja+12|0;ra=c[La>>2]|0;if((ra|0)==(c[ja+16>>2]|0)){gc=(Yd[c[(c[ja>>2]|0)+40>>2]&127](ja)|0)&255}else{c[La>>2]=ra+1;gc=a[ra]|0}MO(A,gc);$b=dc;ac=ec}}}while(0);Ma=p+1|0;if(Ma>>>0<4){Q=fa;r=ea;R=da;D=ca;p=Ma;S=ga;T=ha}else{Z=da;_=ea;$=ga;aa=ha;X=269;break}}g:do{if((X|0)==25){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==112){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==162){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==182){MY()}else if((X|0)==198){MY()}else if((X|0)==209){MY()}else if((X|0)==229){c[k>>2]=c[k>>2]|4;hc=0;ic=Bb;jc=Eb}else if((X|0)==250){c[k>>2]=c[k>>2]|4;hc=0;ic=Bb;jc=Eb}else if((X|0)==253){MY()}else if((X|0)==267){c[k>>2]=c[k>>2]|4;hc=0;ic=Bb;jc=Eb}else if((X|0)==269){h:do{if(($|0)!=0){ha=$+1|0;ga=$+8|0;ea=$+4|0;da=1;i:while(1){S=a[$]|0;if((S&1)==0){kc=(S&255)>>>1}else{kc=c[ea>>2]|0}if(!(da>>>0<kc>>>0)){break h}S=c[h>>2]|0;do{if((S|0)==0){lc=0}else{if((c[S+12>>2]|0)!=(c[S+16>>2]|0)){lc=S;break}if((Yd[c[(c[S>>2]|0)+36>>2]&127](S)|0)==-1){c[h>>2]=0;lc=0;break}else{lc=c[h>>2]|0;break}}}while(0);S=(lc|0)==0;U=c[e>>2]|0;do{if((U|0)==0){X=285}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){if(S){break}else{break i}}if((Yd[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[e>>2]=0;X=285;break}else{if(S){break}else{break i}}}}while(0);if((X|0)==285){X=0;if(S){break}}U=c[h>>2]|0;p=c[U+12>>2]|0;if((p|0)==(c[U+16>>2]|0)){mc=(Yd[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{mc=a[p]|0}if((a[$]&1)==0){nc=ha}else{nc=c[ga>>2]|0}if(!(mc<<24>>24==(a[nc+da|0]|0))){break}p=da+1|0;U=c[h>>2]|0;ca=U+12|0;D=c[ca>>2]|0;if((D|0)==(c[U+16>>2]|0)){Yd[c[(c[U>>2]|0)+40>>2]&127](U)|0;da=p;continue}else{c[ca>>2]=D+1;da=p;continue}}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa;break g}}while(0);if((Z|0)==(_|0)){hc=1;ic=_;jc=aa;break}c[C>>2]=0;qU(w,Z,_,C);if((c[C>>2]|0)==0){hc=1;ic=Z;jc=aa;break}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa}}while(0);uO(A);uO(z);uO(y);uO(x);uO(w);if((ic|0)==0){i=q;return hc|0}Vd[jc&511](ic);i=q;return hc|0}function mU(a){a=a|0;var b=0;b=zc(8)|0;SN(b,a);Hd(b|0,132464,42)}function nU(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+168|0;l=d;m=d+8|0;n=d+24|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=283;v=n+100|0;qP(q,h);n=q;w=c[n>>2]|0;if(!((c[33868]|0)==-1)){c[m>>2]=135472;c[m+4>>2]=281;c[m+8>>2]=0;fO(135472,m,282)}m=(c[135476>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=zc(4)|0;z=y;eY(z);A=151032;B=127;Hd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=zc(4)|0;z=y;eY(z);A=151032;B=127;Hd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=lU(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}if((a[r]|0)!=0){MO(k,le[c[(c[w>>2]|0)+28>>2]&63](B,45)|0)}r=le[c[(c[w>>2]|0)+28>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -1|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+1|0;if(!((a[z]|0)==r<<24>>24)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);oU(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){D=e;break}if(!((Yd[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){D=e;break}c[w>>2]=0;D=0}}while(0);w=(D|0)==0;do{if((f|0)==0){E=25}else{if((c[f+12>>2]|0)!=(c[f+16>>2]|0)){if(w){break}else{E=27;break}}if((Yd[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1){c[A>>2]=0;E=25;break}else{if(w^(f|0)==0){break}else{E=27;break}}}}while(0);if((E|0)==25){if(w){E=27}}if((E|0)==27){c[j>>2]=c[j>>2]|2}c[b>>2]=D;MN(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}Vd[c[u>>2]&511](n);i=d;return}function oU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=10}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g|0;if((e|0)==(d|0)){i=f;return b|0}if((l-j|0)>>>0<h>>>0){PO(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;k=g+1|0;if((k|0)==(e|0)){break}else{d=d+1|0;g=k}}a[n+m|0]=0;m=j+h|0;if((a[b]&1)==0){a[b]=m<<1;i=f;return b|0}else{c[b+4>>2]=m;i=f;return b|0}return 0}function pU(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[33728]|0)==-1)){c[p>>2]=134912;c[p+4>>2]=281;c[p+8>>2]=0;fO(134912,p,282)}p=(c[134916>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=zc(4)|0;C=B;eY(C);D=151032;E=127;Hd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=zc(4)|0;C=B;eY(C);D=151032;E=127;Hd(B|0,D|0,E|0)}E=b;Wd[c[(c[b>>2]|0)+44>>2]&63](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;Wd[c[(c[b>>2]|0)+32>>2]&63](r,E);B=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}GO(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;uO(r);Wd[c[(c[b>>2]|0)+28>>2]&63](s,E);r=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}GO(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;uO(s);a[f]=Yd[c[(c[b>>2]|0)+12>>2]&127](E)|0;a[g]=Yd[c[(c[b>>2]|0)+16>>2]&127](E)|0;Wd[c[(c[b>>2]|0)+20>>2]&63](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}GO(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;uO(t);Wd[c[(c[b>>2]|0)+24>>2]&63](u,E);t=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}GO(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;uO(u);F=Yd[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[33712]|0)==-1)){c[o>>2]=134848;c[o+4>>2]=281;c[o+8>>2]=0;fO(134848,o,282)}o=(c[134852>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=zc(4)|0;H=G;eY(H);I=151032;J=127;Hd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=zc(4)|0;H=G;eY(H);I=151032;J=127;Hd(G|0,I|0,J|0)}J=E;Wd[c[(c[E>>2]|0)+44>>2]&63](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;Wd[c[(c[E>>2]|0)+32>>2]&63](w,J);e=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}GO(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;uO(w);Wd[c[(c[E>>2]|0)+28>>2]&63](x,J);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}GO(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;uO(x);a[f]=Yd[c[(c[E>>2]|0)+12>>2]&127](J)|0;a[g]=Yd[c[(c[E>>2]|0)+16>>2]&127](J)|0;Wd[c[(c[E>>2]|0)+20>>2]&63](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}GO(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;uO(y);Wd[c[(c[E>>2]|0)+24>>2]&63](z,J);y=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}GO(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;uO(z);F=Yd[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function qU(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[b+4>>2]|0}if((j|0)==0){i=g;return}do{if((d|0)==(e|0)){k=h}else{j=e+ -4|0;if(j>>>0>d>>>0){l=d;m=j}else{k=h;break}do{j=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=j;l=l+4|0;m=m+ -4|0;}while(l>>>0<m>>>0);k=a[b]|0}}while(0);if((k&1)==0){n=b+1|0;o=(k&255)>>>1}else{n=c[b+8>>2]|0;o=c[b+4>>2]|0}b=e+ -4|0;e=a[n]|0;k=e<<24>>24<1|e<<24>>24==127;a:do{if(b>>>0>d>>>0){m=n+o|0;l=e;h=n;j=d;p=k;while(1){if(!p){if((l<<24>>24|0)!=(c[j>>2]|0)){break}}q=(m-h|0)>1?h+1|0:h;r=j+4|0;s=a[q]|0;t=s<<24>>24<1|s<<24>>24==127;if(r>>>0<b>>>0){l=s;h=q;j=r;p=t}else{u=s;v=t;break a}}c[f>>2]=4;i=g;return}else{u=e;v=k}}while(0);if(v){i=g;return}v=c[b>>2]|0;if(!(u<<24>>24>>>0<v>>>0|(v|0)==0)){i=g;return}c[f>>2]=4;i=g;return}function rU(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function sU(a){a=a|0;i=i;return}function tU(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+400|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+40|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=283;y=o+400|0;qP(r,h);o=r;z=c[o>>2]|0;if(!((c[33866]|0)==-1)){c[n>>2]=135464;c[n+4>>2]=281;c[n+8>>2]=0;fO(135464,n,282)}n=(c[135468>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=zc(4)|0;C=B;eY(C);D=151032;E=127;Hd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=zc(4)|0;C=B;eY(C);D=151032;E=127;Hd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=uU(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;ue[c[(c[z>>2]|0)+48>>2]&63](E,135168,135178|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>392){l=zY((g>>2)+2|0)|0;if((l|0)!=0){F=l;G=l;break}MY()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+40|0;l=u;h=H;t=r;while(1){C=c[t>>2]|0;n=y;while(1){A=n+4|0;if((c[n>>2]|0)==(C|0)){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[135168+(I-l>>2)|0]|0;n=t+4|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((md(p|0,135104,m|0)|0)!=1){t=zc(8)|0;SN(t,135112);Hd(t|0,132464,42)}if((F|0)==0){break}AY(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=1}else{m=c[e+12>>2]|0;if((m|0)==(c[e+16>>2]|0)){L=Yd[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{L=c[m>>2]|0}if((L|0)==-1){c[F>>2]=0;K=1;break}else{K=(c[F>>2]|0)==0;break}}}while(0);L=c[D>>2]|0;do{if((L|0)==0){M=35}else{e=c[L+12>>2]|0;if((e|0)==(c[L+16>>2]|0)){N=Yd[c[(c[L>>2]|0)+36>>2]&127](L)|0}else{N=c[e>>2]|0}if((N|0)==-1){c[D>>2]=0;M=35;break}else{if(K){break}else{M=37;break}}}}while(0);if((M|0)==35){if(K){M=37}}if((M|0)==37){c[j>>2]=c[j>>2]|2}c[b>>2]=c[F>>2];MN(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}Vd[c[x>>2]&511](o);i=d;return}function uU(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0;p=i;i=i+416|0;q=p;r=p+8|0;s=p+408|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;c[q>>2]=o;o=r;c[s>>2]=0;D=w;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=x;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=y;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=z;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=A;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;xU(f,g,t,u,v,w,x,y,z,B);t=m;c[n>>2]=c[t>>2];g=b;b=e;e=z+4|0;f=z+8|0;D=y+4|0;E=y+8|0;F=(h&512|0)!=0;h=x+4|0;G=x+8|0;H=A+4|0;I=A+8|0;J=s+3|0;K=w+4|0;L=r+400|0;r=o;M=o;o=0;N=0;O=283;a:while(1){P=c[g>>2]|0;do{if((P|0)==0){Q=1}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=Yd[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{S=c[R>>2]|0}if((S|0)==-1){c[g>>2]=0;Q=1;break}else{Q=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=15}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){U=Yd[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{U=c[R>>2]|0}if((U|0)==-1){c[b>>2]=0;T=15;break}else{if(Q){V=P;break}else{W=M;X=r;Y=N;Z=O;T=276;break a}}}}while(0);if((T|0)==15){T=0;if(Q){W=M;X=r;Y=N;Z=O;T=276;break}else{V=0}}b:do{switch(a[s+o|0]|0){case 1:{if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}P=c[g>>2]|0;R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){_=Yd[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{_=c[R>>2]|0}if(!($d[c[(c[l>>2]|0)+12>>2]&63](l,8192,_)|0)){T=27;break a}R=c[g>>2]|0;P=R+12|0;$=c[P>>2]|0;if(($|0)==(c[R+16>>2]|0)){aa=Yd[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[P>>2]=$+4;aa=c[$>>2]|0}aP(A,aa);T=28;break};case 4:{$=M;P=r;R=L;ba=0;ca=O;c:while(1){da=c[g>>2]|0;do{if((da|0)==0){ea=1}else{fa=c[da+12>>2]|0;if((fa|0)==(c[da+16>>2]|0)){ga=Yd[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{ga=c[fa>>2]|0}if((ga|0)==-1){c[g>>2]=0;ea=1;break}else{ea=(c[g>>2]|0)==0;break}}}while(0);da=c[b>>2]|0;do{if((da|0)==0){T=188}else{fa=c[da+12>>2]|0;if((fa|0)==(c[da+16>>2]|0)){ha=Yd[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{ha=c[fa>>2]|0}if((ha|0)==-1){c[b>>2]=0;T=188;break}else{if(ea){break}else{break c}}}}while(0);if((T|0)==188){T=0;if(ea){break}}da=c[g>>2]|0;fa=c[da+12>>2]|0;if((fa|0)==(c[da+16>>2]|0)){ia=Yd[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{ia=c[fa>>2]|0}if($d[c[(c[l>>2]|0)+12>>2]&63](l,2048,ia)|0){fa=c[n>>2]|0;if((fa|0)==(c[q>>2]|0)){yU(m,n,q);ja=c[n>>2]|0}else{ja=fa}c[n>>2]=ja+4;c[ja>>2]=ia;ka=$;la=P;ma=R;na=ba+1|0;oa=ca}else{fa=a[w]|0;if((fa&1)==0){pa=(fa&255)>>>1}else{pa=c[K>>2]|0}if((pa|0)==0|(ba|0)==0){break}if((ia|0)!=(c[v>>2]|0)){break}if((P|0)==(R|0)){fa=P-$|0;da=fa>>>0<2147483647?fa<<1:-1;if((ca|0)!=283){qa=$}else{qa=0}ra=CY(qa,da)|0;if((ra|0)==0){T=206;break a}sa=ra;ta=ra+(fa>>2<<2)|0;ua=ra+(da>>>2<<2)|0;va=258}else{sa=$;ta=P;ua=R;va=ca}c[ta>>2]=ba;ka=sa;la=ta+4|0;ma=ua;na=0;oa=va}da=c[g>>2]|0;ra=da+12|0;fa=c[ra>>2]|0;if((fa|0)==(c[da+16>>2]|0)){Yd[c[(c[da>>2]|0)+40>>2]&127](da)|0;$=ka;P=la;R=ma;ba=na;ca=oa;continue}else{c[ra>>2]=fa+4;$=ka;P=la;R=ma;ba=na;ca=oa;continue}}if(($|0)==(P|0)|(ba|0)==0){wa=$;xa=P;ya=R;za=ca}else{if((P|0)==(R|0)){fa=P-$|0;ra=fa>>>0<2147483647?fa<<1:-1;if((ca|0)!=283){Aa=$}else{Aa=0}da=CY(Aa,ra)|0;if((da|0)==0){T=217;break a}Ba=da;Ca=da+(fa>>2<<2)|0;Da=da+(ra>>>2<<2)|0;Ea=258}else{Ba=$;Ca=P;Da=R;Ea=ca}c[Ca>>2]=ba;wa=Ba;xa=Ca+4|0;ya=Da;za=Ea}ra=c[B>>2]|0;if((ra|0)>0){da=c[g>>2]|0;do{if((da|0)==0){Fa=1}else{fa=c[da+12>>2]|0;if((fa|0)==(c[da+16>>2]|0)){Ga=Yd[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{Ga=c[fa>>2]|0}if((Ga|0)==-1){c[g>>2]=0;Fa=1;break}else{Fa=(c[g>>2]|0)==0;break}}}while(0);da=c[b>>2]|0;do{if((da|0)==0){T=234}else{ba=c[da+12>>2]|0;if((ba|0)==(c[da+16>>2]|0)){Ha=Yd[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{Ha=c[ba>>2]|0}if((Ha|0)==-1){c[b>>2]=0;T=234;break}else{if(Fa){Ia=da;break}else{T=240;break a}}}}while(0);if((T|0)==234){T=0;if(Fa){T=240;break a}else{Ia=0}}da=c[g>>2]|0;ba=c[da+12>>2]|0;if((ba|0)==(c[da+16>>2]|0)){Ja=Yd[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{Ja=c[ba>>2]|0}if((Ja|0)!=(c[u>>2]|0)){T=240;break a}ba=c[g>>2]|0;da=ba+12|0;ca=c[da>>2]|0;if((ca|0)==(c[ba+16>>2]|0)){Yd[c[(c[ba>>2]|0)+40>>2]&127](ba)|0;Ka=Ia;La=ra;Ma=Ia}else{c[da>>2]=ca+4;Ka=Ia;La=ra;Ma=Ia}while(1){ca=c[g>>2]|0;do{if((ca|0)==0){Na=1}else{da=c[ca+12>>2]|0;if((da|0)==(c[ca+16>>2]|0)){Oa=Yd[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{Oa=c[da>>2]|0}if((Oa|0)==-1){c[g>>2]=0;Na=1;break}else{Na=(c[g>>2]|0)==0;break}}}while(0);do{if((Ma|0)==0){Pa=Ka;T=257}else{ca=c[Ma+12>>2]|0;if((ca|0)==(c[Ma+16>>2]|0)){Qa=Yd[c[(c[Ma>>2]|0)+36>>2]&127](Ma)|0}else{Qa=c[ca>>2]|0}if((Qa|0)==-1){c[b>>2]=0;Pa=0;T=257;break}else{if(Na^(Ka|0)==0){Ra=Ka;Sa=Ka;break}else{T=263;break a}}}}while(0);if((T|0)==257){T=0;if(Na){T=263;break a}else{Ra=Pa;Sa=0}}ca=c[g>>2]|0;da=c[ca+12>>2]|0;if((da|0)==(c[ca+16>>2]|0)){Ta=Yd[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{Ta=c[da>>2]|0}if(!($d[c[(c[l>>2]|0)+12>>2]&63](l,2048,Ta)|0)){T=263;break a}if((c[n>>2]|0)==(c[q>>2]|0)){yU(m,n,q)}da=c[g>>2]|0;ca=c[da+12>>2]|0;if((ca|0)==(c[da+16>>2]|0)){Ua=Yd[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{Ua=c[ca>>2]|0}ca=c[n>>2]|0;c[n>>2]=ca+4;c[ca>>2]=Ua;ca=La+ -1|0;c[B>>2]=ca;da=c[g>>2]|0;ba=da+12|0;R=c[ba>>2]|0;if((R|0)==(c[da+16>>2]|0)){Yd[c[(c[da>>2]|0)+40>>2]&127](da)|0}else{c[ba>>2]=R+4}if((ca|0)>0){Ka=Ra;La=ca;Ma=Sa}else{break}}}if((c[n>>2]|0)==(c[t>>2]|0)){T=274;break a}else{Va=wa;Wa=xa;Xa=ya;Ya=N;Za=za}break};case 0:{T=28;break};case 3:{ra=a[y]|0;ca=(ra&1)==0;if(ca){_a=(ra&255)>>>1}else{_a=c[D>>2]|0}R=a[z]|0;ba=(R&1)==0;if(ba){$a=(R&255)>>>1}else{$a=c[e>>2]|0}if((_a|0)==(0-$a|0)){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break b}if(ca){ab=(ra&255)>>>1}else{ab=c[D>>2]|0}do{if((ab|0)!=0){if(ba){bb=(R&255)>>>1}else{bb=c[e>>2]|0}if((bb|0)==0){break}da=c[g>>2]|0;P=c[da+12>>2]|0;if((P|0)==(c[da+16>>2]|0)){$=Yd[c[(c[da>>2]|0)+36>>2]&127](da)|0;cb=$;db=a[y]|0}else{cb=c[P>>2]|0;db=ra}P=c[g>>2]|0;$=P+12|0;da=c[$>>2]|0;fa=(da|0)==(c[P+16>>2]|0);if((cb|0)==(c[((db&1)==0?D:c[E>>2]|0)>>2]|0)){if(fa){Yd[c[(c[P>>2]|0)+40>>2]&127](P)|0}else{c[$>>2]=da+4}$=a[y]|0;if(($&1)==0){eb=($&255)>>>1}else{eb=c[D>>2]|0}Va=M;Wa=r;Xa=L;Ya=eb>>>0>1?y:N;Za=O;break b}if(fa){fb=Yd[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{fb=c[da>>2]|0}if((fb|0)!=(c[((a[z]&1)==0?e:c[f>>2]|0)>>2]|0)){T=116;break a}da=c[g>>2]|0;P=da+12|0;fa=c[P>>2]|0;if((fa|0)==(c[da+16>>2]|0)){Yd[c[(c[da>>2]|0)+40>>2]&127](da)|0}else{c[P>>2]=fa+4}a[k]=1;fa=a[z]|0;if((fa&1)==0){gb=(fa&255)>>>1}else{gb=c[e>>2]|0}Va=M;Wa=r;Xa=L;Ya=gb>>>0>1?z:N;Za=O;break b}}while(0);if(ca){hb=(ra&255)>>>1}else{hb=c[D>>2]|0}ba=c[g>>2]|0;fa=c[ba+12>>2]|0;P=(fa|0)==(c[ba+16>>2]|0);if((hb|0)==0){if(P){da=Yd[c[(c[ba>>2]|0)+36>>2]&127](ba)|0;ib=da;jb=a[z]|0}else{ib=c[fa>>2]|0;jb=R}if((ib|0)!=(c[((jb&1)==0?e:c[f>>2]|0)>>2]|0)){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break b}da=c[g>>2]|0;$=da+12|0;kb=c[$>>2]|0;if((kb|0)==(c[da+16>>2]|0)){Yd[c[(c[da>>2]|0)+40>>2]&127](da)|0}else{c[$>>2]=kb+4}a[k]=1;kb=a[z]|0;if((kb&1)==0){lb=(kb&255)>>>1}else{lb=c[e>>2]|0}Va=M;Wa=r;Xa=L;Ya=lb>>>0>1?z:N;Za=O;break b}if(P){P=Yd[c[(c[ba>>2]|0)+36>>2]&127](ba)|0;mb=P;nb=a[y]|0}else{mb=c[fa>>2]|0;nb=ra}if((mb|0)!=(c[((nb&1)==0?D:c[E>>2]|0)>>2]|0)){a[k]=1;Va=M;Wa=r;Xa=L;Ya=N;Za=O;break b}fa=c[g>>2]|0;P=fa+12|0;ba=c[P>>2]|0;if((ba|0)==(c[fa+16>>2]|0)){Yd[c[(c[fa>>2]|0)+40>>2]&127](fa)|0}else{c[P>>2]=ba+4}ba=a[y]|0;if((ba&1)==0){ob=(ba&255)>>>1}else{ob=c[D>>2]|0}Va=M;Wa=r;Xa=L;Ya=ob>>>0>1?y:N;Za=O;break};case 2:{if(!((N|0)!=0|o>>>0<2)){if((o|0)==2){pb=(a[J]|0)!=0}else{pb=0}if(!(F|pb)){Va=M;Wa=r;Xa=L;Ya=0;Za=O;break b}}ba=a[x]|0;P=(ba&1)==0?h:c[G>>2]|0;d:do{if((o|0)==0){qb=V;rb=V;sb=ba;tb=P}else{if((d[s+(o+ -1)|0]|0)<2){ub=ba;vb=P}else{qb=V;rb=V;sb=ba;tb=P;break}while(1){if((ub&1)==0){wb=h;xb=(ub&255)>>>1}else{wb=c[G>>2]|0;xb=c[h>>2]|0}if((vb|0)==(wb+(xb<<2)|0)){yb=ub;break}if(!($d[c[(c[l>>2]|0)+12>>2]&63](l,8192,c[vb>>2]|0)|0)){T=129;break}ub=a[x]|0;vb=vb+4|0}if((T|0)==129){T=0;yb=a[x]|0}fa=(yb&1)==0;kb=vb-(fa?h:c[G>>2]|0)>>2;$=a[A]|0;da=($&1)==0;if(da){zb=($&255)>>>1}else{zb=c[H>>2]|0}e:do{if(!(kb>>>0>zb>>>0)){if(da){Ab=H+((($&255)>>>1)-kb<<2)|0;Bb=H;Cb=($&255)>>>1}else{Db=c[I>>2]|0;Eb=c[H>>2]|0;Ab=Db+(Eb-kb<<2)|0;Bb=Db;Cb=Eb}Eb=Bb+(Cb<<2)|0;if((Ab|0)==(Eb|0)){qb=V;rb=V;sb=yb;tb=vb;break d}else{Fb=fa?h:c[G>>2]|0;Gb=Ab}while(1){if((c[Gb>>2]|0)!=(c[Fb>>2]|0)){break e}Db=Gb+4|0;if((Db|0)==(Eb|0)){qb=V;rb=V;sb=yb;tb=vb;break d}Fb=Fb+4|0;Gb=Db}}}while(0);qb=V;rb=V;sb=yb;tb=fa?h:c[G>>2]|0}}while(0);f:while(1){if((sb&1)==0){Hb=h;Ib=(sb&255)>>>1}else{Hb=c[G>>2]|0;Ib=c[h>>2]|0}if((tb|0)==(Hb+(Ib<<2)|0)){break}P=c[g>>2]|0;do{if((P|0)==0){Jb=1}else{ba=c[P+12>>2]|0;if((ba|0)==(c[P+16>>2]|0)){Kb=Yd[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{Kb=c[ba>>2]|0}if((Kb|0)==-1){c[g>>2]=0;Jb=1;break}else{Jb=(c[g>>2]|0)==0;break}}}while(0);do{if((rb|0)==0){Lb=qb;T=159}else{P=c[rb+12>>2]|0;if((P|0)==(c[rb+16>>2]|0)){Mb=Yd[c[(c[rb>>2]|0)+36>>2]&127](rb)|0}else{Mb=c[P>>2]|0}if((Mb|0)==-1){c[b>>2]=0;Lb=0;T=159;break}else{if(Jb^(qb|0)==0){Nb=qb;Ob=qb;break}else{break f}}}}while(0);if((T|0)==159){T=0;if(Jb){break}else{Nb=Lb;Ob=0}}P=c[g>>2]|0;fa=c[P+12>>2]|0;if((fa|0)==(c[P+16>>2]|0)){Pb=Yd[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{Pb=c[fa>>2]|0}if((Pb|0)!=(c[tb>>2]|0)){break}fa=c[g>>2]|0;P=fa+12|0;ba=c[P>>2]|0;if((ba|0)==(c[fa+16>>2]|0)){Yd[c[(c[fa>>2]|0)+40>>2]&127](fa)|0}else{c[P>>2]=ba+4}qb=Nb;rb=Ob;sb=a[x]|0;tb=tb+4|0}if(!F){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break b}ba=a[x]|0;if((ba&1)==0){Qb=h;Rb=(ba&255)>>>1}else{Qb=c[G>>2]|0;Rb=c[h>>2]|0}if((tb|0)==(Qb+(Rb<<2)|0)){Va=M;Wa=r;Xa=L;Ya=N;Za=O}else{T=174;break a}break};default:{Va=M;Wa=r;Xa=L;Ya=N;Za=O}}}while(0);g:do{if((T|0)==28){T=0;if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}else{Sb=V;Tb=V}while(1){ba=c[g>>2]|0;do{if((ba|0)==0){Ub=1}else{P=c[ba+12>>2]|0;if((P|0)==(c[ba+16>>2]|0)){Vb=Yd[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{Vb=c[P>>2]|0}if((Vb|0)==-1){c[g>>2]=0;Ub=1;break}else{Ub=(c[g>>2]|0)==0;break}}}while(0);do{if((Tb|0)==0){Wb=Sb;T=42}else{ba=c[Tb+12>>2]|0;if((ba|0)==(c[Tb+16>>2]|0)){Xb=Yd[c[(c[Tb>>2]|0)+36>>2]&127](Tb)|0}else{Xb=c[ba>>2]|0}if((Xb|0)==-1){c[b>>2]=0;Wb=0;T=42;break}else{if(Ub^(Sb|0)==0){Yb=Sb;Zb=Sb;break}else{Va=M;Wa=r;Xa=L;Ya=N;Za=O;break g}}}}while(0);if((T|0)==42){T=0;if(Ub){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break g}else{Yb=Wb;Zb=0}}ba=c[g>>2]|0;P=c[ba+12>>2]|0;if((P|0)==(c[ba+16>>2]|0)){_b=Yd[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{_b=c[P>>2]|0}if(!($d[c[(c[l>>2]|0)+12>>2]&63](l,8192,_b)|0)){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break g}P=c[g>>2]|0;ba=P+12|0;fa=c[ba>>2]|0;if((fa|0)==(c[P+16>>2]|0)){$b=Yd[c[(c[P>>2]|0)+40>>2]&127](P)|0}else{c[ba>>2]=fa+4;$b=c[fa>>2]|0}aP(A,$b);Sb=Yb;Tb=Zb}}}while(0);fa=o+1|0;if(fa>>>0<4){L=Xa;r=Wa;M=Va;o=fa;N=Ya;O=Za}else{W=Va;X=Wa;Y=Ya;Z=Za;T=276;break}}h:do{if((T|0)==27){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==116){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==174){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==206){MY()}else if((T|0)==217){MY()}else if((T|0)==240){c[j>>2]=c[j>>2]|4;ac=0;bc=wa;cc=za}else if((T|0)==263){c[j>>2]=c[j>>2]|4;ac=0;bc=wa;cc=za}else if((T|0)==274){c[j>>2]=c[j>>2]|4;ac=0;bc=wa;cc=za}else if((T|0)==276){i:do{if((Y|0)!=0){Za=Y+4|0;Ya=Y+8|0;Wa=1;j:while(1){Va=a[Y]|0;if((Va&1)==0){dc=(Va&255)>>>1}else{dc=c[Za>>2]|0}if(!(Wa>>>0<dc>>>0)){break i}Va=c[g>>2]|0;do{if((Va|0)==0){ec=1}else{N=c[Va+12>>2]|0;if((N|0)==(c[Va+16>>2]|0)){fc=Yd[c[(c[Va>>2]|0)+36>>2]&127](Va)|0}else{fc=c[N>>2]|0}if((fc|0)==-1){c[g>>2]=0;ec=1;break}else{ec=(c[g>>2]|0)==0;break}}}while(0);Va=c[b>>2]|0;do{if((Va|0)==0){T=295}else{N=c[Va+12>>2]|0;if((N|0)==(c[Va+16>>2]|0)){gc=Yd[c[(c[Va>>2]|0)+36>>2]&127](Va)|0}else{gc=c[N>>2]|0}if((gc|0)==-1){c[b>>2]=0;T=295;break}else{if(ec){break}else{break j}}}}while(0);if((T|0)==295){T=0;if(ec){break}}Va=c[g>>2]|0;N=c[Va+12>>2]|0;if((N|0)==(c[Va+16>>2]|0)){hc=Yd[c[(c[Va>>2]|0)+36>>2]&127](Va)|0}else{hc=c[N>>2]|0}if((a[Y]&1)==0){ic=Za}else{ic=c[Ya>>2]|0}if((hc|0)!=(c[ic+(Wa<<2)>>2]|0)){break}N=Wa+1|0;Va=c[g>>2]|0;o=Va+12|0;r=c[o>>2]|0;if((r|0)==(c[Va+16>>2]|0)){Yd[c[(c[Va>>2]|0)+40>>2]&127](Va)|0;Wa=N;continue}else{c[o>>2]=r+4;Wa=N;continue}}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z;break h}}while(0);if((W|0)==(X|0)){ac=1;bc=X;cc=Z;break}c[C>>2]=0;qU(w,W,X,C);if((c[C>>2]|0)==0){ac=1;bc=W;cc=Z;break}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z}}while(0);YO(A);YO(z);YO(y);YO(x);uO(w);if((bc|0)==0){i=p;return ac|0}Vd[cc&511](bc);i=p;return ac|0}function vU(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+464|0;l=d;m=d+8|0;n=d+24|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=283;v=n+400|0;qP(q,h);n=q;w=c[n>>2]|0;if(!((c[33866]|0)==-1)){c[m>>2]=135464;c[m+4>>2]=281;c[m+8>>2]=0;fO(135464,m,282)}m=(c[135468>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=zc(4)|0;z=y;eY(z);A=151032;B=127;Hd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=zc(4)|0;z=y;eY(z);A=151032;B=127;Hd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=uU(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}if((a[r]|0)!=0){aP(k,le[c[(c[w>>2]|0)+44>>2]&63](B,45)|0)}r=le[c[(c[w>>2]|0)+44>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -4|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+4|0;if((c[z>>2]|0)!=(r|0)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);wU(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=1}else{C=c[e+12>>2]|0;if((C|0)==(c[e+16>>2]|0)){E=Yd[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{E=c[C>>2]|0}if((E|0)==-1){c[w>>2]=0;D=1;break}else{D=(c[w>>2]|0)==0;break}}}while(0);do{if((f|0)==0){F=29}else{E=c[f+12>>2]|0;if((E|0)==(c[f+16>>2]|0)){G=Yd[c[(c[f>>2]|0)+36>>2]&127](f)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[A>>2]=0;F=29;break}else{if(D){break}else{F=31;break}}}}while(0);if((F|0)==29){if(D){F=31}}if((F|0)==31){c[j>>2]=c[j>>2]|2}c[b>>2]=c[w>>2];MN(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}Vd[c[u>>2]&511](n);i=d;return}function wU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=1}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g>>2;if((h|0)==0){i=f;return b|0}if((l-j|0)>>>0<h>>>0){cP(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{k=j+((e+ -4+(0-g)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{d=d+4|0;g=m}}o=n+(k<<2)|0}c[o>>2]=0;o=j+h|0;if((a[b]&1)==0){a[b]=o<<1;i=f;return b|0}else{c[b+4>>2]=o;i=f;return b|0}return 0}function xU(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[33760]|0)==-1)){c[p>>2]=135040;c[p+4>>2]=281;c[p+8>>2]=0;fO(135040,p,282)}p=(c[135044>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=zc(4)|0;C=B;eY(C);D=151032;E=127;Hd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=zc(4)|0;C=B;eY(C);D=151032;E=127;Hd(B|0,D|0,E|0)}E=b;Wd[c[(c[b>>2]|0)+44>>2]&63](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;Wd[c[(c[b>>2]|0)+32>>2]&63](r,E);B=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}$O(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;YO(r);Wd[c[(c[b>>2]|0)+28>>2]&63](s,E);r=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}$O(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;YO(s);c[f>>2]=Yd[c[(c[b>>2]|0)+12>>2]&127](E)|0;c[g>>2]=Yd[c[(c[b>>2]|0)+16>>2]&127](E)|0;Wd[c[(c[b>>2]|0)+20>>2]&63](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}GO(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;uO(t);Wd[c[(c[b>>2]|0)+24>>2]&63](u,E);t=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}$O(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;YO(u);F=Yd[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[33744]|0)==-1)){c[o>>2]=134976;c[o+4>>2]=281;c[o+8>>2]=0;fO(134976,o,282)}o=(c[134980>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=zc(4)|0;H=G;eY(H);I=151032;J=127;Hd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=zc(4)|0;H=G;eY(H);I=151032;J=127;Hd(G|0,I|0,J|0)}J=E;Wd[c[(c[E>>2]|0)+44>>2]&63](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;Wd[c[(c[E>>2]|0)+32>>2]&63](w,J);e=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}$O(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;YO(w);Wd[c[(c[E>>2]|0)+28>>2]&63](x,J);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}$O(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;YO(x);c[f>>2]=Yd[c[(c[E>>2]|0)+12>>2]&127](J)|0;c[g>>2]=Yd[c[(c[E>>2]|0)+16>>2]&127](J)|0;Wd[c[(c[E>>2]|0)+20>>2]&63](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}GO(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;uO(y);Wd[c[(c[E>>2]|0)+24>>2]&63](z,J);y=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}$O(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;YO(z);F=Yd[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function yU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=283;h=a;a=c[h>>2]|0;j=a;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;if(g){m=a}else{m=0}a=CY(m,l)|0;m=a;if((a|0)==0){MY()}do{if(g){c[h>>2]=m;n=m}else{a=c[h>>2]|0;c[h>>2]=m;if((a|0)==0){n=m;break}Vd[c[f>>2]&511](a);n=c[h>>2]|0}}while(0);c[f>>2]=258;c[b>>2]=n+(k<<2);c[d>>2]=(c[h>>2]|0)+(l>>>2<<2);i=e;return}function zU(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function AU(a){a=a|0;i=i;return}function BU(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+104|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+104|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Hc(G|0,100,135224,o|0)|0;do{if(s>>>0>99){do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);o=c[33840]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=tS(r,o,135224,n)|0;o=c[r>>2]|0;if((o|0)==0){MY()}H=zY(G)|0;if((H|0)!=0){I=o;J=H;K=H;L=G;break}MY()}else{I=0;J=0;K=q;L=s}}while(0);qP(t,g);s=t;q=c[s>>2]|0;if(!((c[33868]|0)==-1)){c[p>>2]=135472;c[p+4>>2]=281;c[p+8>>2]=0;fO(135472,p,282)}p=(c[135476>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){M=zc(4)|0;N=M;eY(N);O=151032;P=127;Hd(M|0,O|0,P|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){M=zc(4)|0;N=M;eY(N);O=151032;P=127;Hd(M|0,O|0,P|0)}P=q;O=c[r>>2]|0;ue[c[(c[q>>2]|0)+32>>2]&63](P,O,O+L|0,K)|0;if((L|0)==0){Q=0}else{Q=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;CU(f,Q,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((L|0)>(C|0)){B=a[A]|0;if((B&1)==0){R=(B&255)>>>1}else{R=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[z+4>>2]|0}T=R+(L-C<<1|1)+S|0}else{S=a[A]|0;if((S&1)==0){U=(S&255)>>>1}else{U=c[A+4>>2]|0}S=a[z]|0;if((S&1)==0){V=(S&255)>>>1}else{V=c[z+4>>2]|0}T=U+2+V|0}V=T+C|0;do{if(V>>>0>100){T=zY(V)|0;if((T|0)!=0){W=T;X=T;break}MY()}else{W=0;X=t}}while(0);DU(X,D,E,c[g+4>>2]|0,K,K+L|0,P,Q,v,a[w]|0,a[x]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];VK(b,m,X,e,D,g,j);if((W|0)!=0){AY(W)}uO(A);uO(z);uO(y);MN(c[s>>2]|0)|0;if((J|0)!=0){AY(J)}if((I|0)==0){i=d;return}AY(I);i=d;return}function CU(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[33728]|0)==-1)){c[p>>2]=134912;c[p+4>>2]=281;c[p+8>>2]=0;fO(134912,p,282)}p=(c[134916>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=zc(4)|0;I=H;eY(I);J=151032;K=127;Hd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=zc(4)|0;I=H;eY(I);J=151032;K=127;Hd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){Wd[c[J+44>>2]&63](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;Wd[c[(c[e>>2]|0)+32>>2]&63](s,K);H=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}GO(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;uO(s)}else{Wd[c[J+40>>2]&63](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;Wd[c[(c[e>>2]|0)+28>>2]&63](v,K);J=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}GO(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;uO(v)}a[g]=Yd[c[(c[e>>2]|0)+12>>2]&127](K)|0;a[h]=Yd[c[(c[e>>2]|0)+16>>2]&127](K)|0;Wd[c[(c[e>>2]|0)+20>>2]&63](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}GO(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;uO(w);Wd[c[(c[e>>2]|0)+24>>2]&63](x,K);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}GO(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;uO(x);L=Yd[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[33712]|0)==-1)){c[o>>2]=134848;c[o+4>>2]=281;c[o+8>>2]=0;fO(134848,o,282)}o=(c[134852>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=zc(4)|0;N=M;eY(N);O=151032;P=127;Hd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=zc(4)|0;N=M;eY(N);O=151032;P=127;Hd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){Wd[c[O+44>>2]&63](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;Wd[c[(c[G>>2]|0)+32>>2]&63](A,P);d=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}GO(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;uO(A)}else{Wd[c[O+40>>2]&63](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;Wd[c[(c[G>>2]|0)+28>>2]&63](D,P);f=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}GO(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;uO(D)}a[g]=Yd[c[(c[G>>2]|0)+12>>2]&127](P)|0;a[h]=Yd[c[(c[G>>2]|0)+16>>2]&127](P)|0;Wd[c[(c[G>>2]|0)+20>>2]&63](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}GO(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;uO(E);Wd[c[(c[G>>2]|0)+24>>2]&63](F,P);E=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}GO(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;uO(F);L=Yd[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}



function xR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;dS(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;DO(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((Yd[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((Yd[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}DO(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}DO(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(Yd[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((FR(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){Yd[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=WW(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;qU(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((Yd[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;uO(n);uO(m);i=d;return}if((Yd[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;uO(n);uO(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;uO(n);uO(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;uO(n);uO(m);i=d;return}function yR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];zR(a,0,k,j,f,g,h);i=b;return}function zR(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;eS(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;DO(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((Yd[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((Yd[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}DO(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}DO(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(Yd[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((fS(R,t,u,P,p,B,l,n,h,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){Yd[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);g[k>>2]=+VW(I,c[p>>2]|0,j);qU(n,h,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((Yd[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;uO(o);uO(n);i=d;return}if((Yd[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;uO(o);uO(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;uO(o);uO(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;uO(o);uO(n);i=d;return}function AR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];BR(a,0,k,j,f,g,h);i=b;return}function BR(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;eS(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;DO(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((Yd[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((Yd[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}DO(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}DO(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(Yd[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((fS(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){Yd[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+UW(I,c[p>>2]|0,j);qU(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((Yd[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;uO(o);uO(n);i=d;return}if((Yd[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;uO(o);uO(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;uO(o);uO(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;uO(o);uO(n);i=d;return}function CR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];DR(a,0,k,j,f,g,h);i=b;return}function DR(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;eS(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;DO(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((Yd[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((Yd[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}DO(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}DO(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(Yd[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((fS(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){Yd[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+TW(I,c[p>>2]|0,j);qU(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((Yd[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;uO(o);uO(n);i=d;return}if((Yd[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;uO(o);uO(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;uO(o);uO(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;uO(o);uO(n);i=d;return}function ER(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;qP(o,g);g=o;o=c[g>>2]|0;if(!((c[33868]|0)==-1)){c[l>>2]=135472;c[l+4>>2]=281;c[l+8>>2]=0;fO(135472,l,282)}l=(c[135476>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=zc(4)|0;w=v;eY(w);x=151032;y=127;Hd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=zc(4)|0;w=v;eY(w);x=151032;y=127;Hd(v|0,x|0,y|0)}y=m;ue[c[(c[o>>2]|0)+32>>2]&63](o,134016,134042|0,y)|0;MN(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;DO(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){C=m;break}if(!((Yd[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){C=m;break}c[r>>2]=0;C=0}}while(0);B=(C|0)==0;v=c[e>>2]|0;do{if((v|0)==0){D=19}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){if(B){break}else{E=x;break a}}if((Yd[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1){c[e>>2]=0;D=19;break}else{if(B){break}else{E=x;break a}}}}while(0);if((D|0)==19){D=0;if(B){E=x;break}}v=a[p]|0;w=(v&1)==0;if(w){F=(v&255)>>>1}else{F=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(F|0)){if(w){G=(v&255)>>>1;H=(v&255)>>>1}else{v=c[o>>2]|0;G=v;H=v}DO(p,H<<1,0);if((a[p]&1)==0){I=10}else{I=(c[f>>2]&-2)+ -1|0}DO(p,I,0);if((a[p]&1)==0){J=z}else{J=c[A>>2]|0}c[q>>2]=J+G;K=J}else{K=x}v=C+12|0;w=c[v>>2]|0;l=C+16|0;if((w|0)==(c[l>>2]|0)){L=(Yd[c[(c[C>>2]|0)+36>>2]&127](C)|0)&255}else{L=a[w]|0}if((FR(L,16,K,q,t,0,n,g,s,y)|0)!=0){E=K;break}w=c[v>>2]|0;if((w|0)==(c[l>>2]|0)){Yd[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=K;continue}else{c[v>>2]=w+1;m=C;x=K;continue}}a[E+3|0]=0;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);K=c[33840]|0;c[k>>2]=j;if((GR(E,K,134056,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){M=0}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){M=k;break}if(!((Yd[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1)){M=k;break}c[r>>2]=0;M=0}}while(0);r=(M|0)==0;k=c[e>>2]|0;do{if((k|0)==0){D=54}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){if(!r){break}N=b;O=N;c[O>>2]=M;uO(p);uO(n);i=d;return}if((Yd[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1){c[e>>2]=0;D=54;break}if(!(r^(k|0)==0)){break}N=b;O=N;c[O>>2]=M;uO(p);uO(n);i=d;return}}while(0);do{if((D|0)==54){if(r){break}N=b;O=N;c[O>>2]=M;uO(p);uO(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;N=b;O=N;c[O>>2]=M;uO(p);uO(n);i=d;return}function FR(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(a[m+24|0]|0)==b<<24>>24;if(!q){if(!((a[m+25|0]|0)==b<<24>>24)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&b<<24>>24==h<<24>>24){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+26|0;h=m;while(1){l=h+1|0;if((a[h]|0)==b<<24>>24){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;if((h|0)>23){r=-1;i=n;return r|0}do{if((d|0)==16){if((h|0)<22){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;m=a[134016+h|0]|0;c[f>>2]=o+1;a[o]=m;r=0;i=n;return r|0}else if((d|0)==10|(d|0)==8){if((h|0)<(d|0)){break}else{r=-1}i=n;return r|0}}while(0);d=a[134016+h|0]|0;c[f>>2]=o+1;a[o]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function GR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Gc(b|0)|0;b=Ua(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Gc(e|0)|0;i=f;return b|0}function HR(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function IR(a){a=a|0;i=i;return}function JR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];ie[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}qP(u,g);m=u;u=c[m>>2]|0;if(!((c[33866]|0)==-1)){c[p>>2]=135464;c[p+4>>2]=281;c[p+8>>2]=0;fO(135464,p,282)}p=(c[135468>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=zc(4)|0;D=C;eY(D);E=151032;F=127;Hd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=zc(4)|0;D=C;eY(D);E=151032;F=127;Hd(C|0,E|0,F|0)}F=u;MN(c[m>>2]|0)|0;qP(v,g);g=v;v=c[g>>2]|0;if(!((c[33906]|0)==-1)){c[o>>2]=135624;c[o+4>>2]=281;c[o+8>>2]=0;fO(135624,o,282)}o=(c[135628>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=zc(4)|0;H=G;eY(H);I=151032;J=127;Hd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=zc(4)|0;H=G;eY(H);I=151032;J=127;Hd(G|0,I|0,J|0)}J=v;MN(c[g>>2]|0)|0;g=w;Wd[c[(c[v>>2]|0)+24>>2]&63](g,J);Wd[c[(c[v>>2]|0)+28>>2]&63](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=KR(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];YO(w+12|0);YO(w);i=k;return}function KR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=zY(l)|0;if((n|0)!=0){o=n;p=n;break}MY()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){z=Yd[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{z=c[t>>2]|0}if((z|0)==-1){c[l>>2]=0;y=1;break}else{y=(c[l>>2]|0)==0;break}}}while(0);r=c[b>>2]|0;do{if((r|0)==0){A=0;B=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){C=Yd[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{C=c[t>>2]|0}if(!((C|0)==-1)){A=r;B=0;break}c[b>>2]=0;A=0;B=1}}while(0);D=c[l>>2]|0;if(!((y^B)&(q|0)!=0)){break}r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){E=Yd[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{E=c[r>>2]|0}if(j){F=E}else{F=le[c[(c[g>>2]|0)+28>>2]&63](g,E)|0}r=d+1|0;if(m){d=r;q=q;x=x;continue}b:do{if(j){t=0;w=e;s=x;n=q;v=p;while(1){do{if((a[v]|0)==1){u=a[w]|0;G=(u&1)==0;if(G){H=w+4|0}else{H=c[w+8>>2]|0}if((F|0)!=(c[H+(d<<2)>>2]|0)){a[v]=0;I=t;J=s;K=n+ -1|0;break}if(G){L=(u&255)>>>1}else{L=c[w+4>>2]|0}if((L|0)!=(r|0)){I=1;J=s;K=n;break}a[v]=2;I=1;J=s+1|0;K=n+ -1|0}else{I=t;J=s;K=n}}while(0);u=w+12|0;if((u|0)==(f|0)){M=I;N=J;O=K;break b}t=I;w=u;s=J;n=K;v=v+1|0}}else{v=0;n=e;s=x;w=q;t=p;while(1){do{if((a[t]|0)==1){if((a[n]&1)==0){P=n+4|0}else{P=c[n+8>>2]|0}if((F|0)!=(le[c[(c[g>>2]|0)+28>>2]&63](g,c[P+(d<<2)>>2]|0)|0)){a[t]=0;Q=v;R=s;S=w+ -1|0;break}u=a[n]|0;if((u&1)==0){T=(u&255)>>>1}else{T=c[n+4>>2]|0}if((T|0)!=(r|0)){Q=1;R=s;S=w;break}a[t]=2;Q=1;R=s+1|0;S=w+ -1|0}else{Q=v;R=s;S=w}}while(0);u=n+12|0;if((u|0)==(f|0)){M=Q;N=R;O=S;break b}v=Q;n=u;s=R;w=S;t=t+1|0}}}while(0);if(!M){d=r;x=N;q=O;continue}t=c[l>>2]|0;w=t+12|0;s=c[w>>2]|0;if((s|0)==(c[t+16>>2]|0)){Yd[c[(c[t>>2]|0)+40>>2]&127](t)|0}else{c[w>>2]=s+4}if((O+N|0)>>>0<2){d=r;x=N;q=O;continue}else{U=e;V=N;W=p}while(1){do{if((a[W]|0)==2){s=a[U]|0;if((s&1)==0){X=(s&255)>>>1}else{X=c[U+4>>2]|0}if((X|0)==(r|0)){Y=V;break}a[W]=0;Y=V+ -1|0}else{Y=V}}while(0);s=U+12|0;if((s|0)==(f|0)){d=r;x=Y;q=O;continue a}else{U=s;V=Y;W=W+1|0}}}do{if((D|0)==0){Z=1}else{W=c[D+12>>2]|0;if((W|0)==(c[D+16>>2]|0)){_=Yd[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{_=c[W>>2]|0}if((_|0)==-1){c[l>>2]=0;Z=1;break}else{Z=(c[l>>2]|0)==0;break}}}while(0);do{if((A|0)==0){$=85}else{l=c[A+12>>2]|0;if((l|0)==(c[A+16>>2]|0)){aa=Yd[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{aa=c[l>>2]|0}if((aa|0)==-1){c[b>>2]=0;$=85;break}else{if(Z){break}else{$=87;break}}}}while(0);if(($|0)==85){if(Z){$=87}}if(($|0)==87){c[h>>2]=c[h>>2]|2}c:do{if(m){$=92}else{if((a[p]|0)==2){ba=e;break}else{ca=e;da=p}while(1){Z=ca+12|0;b=da+1|0;if((Z|0)==(f|0)){$=92;break c}if((a[b]|0)==2){ba=Z;break}else{da=b;ca=Z}}}}while(0);if(($|0)==92){c[h>>2]=c[h>>2]|4;ba=f}if((o|0)==0){i=k;return ba|0}AY(o);i=k;return ba|0}function LR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];MR(a,0,k,j,f,g,h);i=b;return}function MR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;gS(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;DO(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=Yd[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=Yd[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}DO(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}DO(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=Yd[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((cS(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){Yd[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=$W(I,c[o>>2]|0,h,t)|0;qU(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=Yd[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=Yd[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;uO(n);uO(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;uO(n);uO(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;uO(n);uO(m);i=d;return}function NR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];OR(a,0,k,j,f,g,h);i=b;return}function OR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;gS(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;DO(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=Yd[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=Yd[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}DO(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}DO(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=Yd[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((cS(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){Yd[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=_W(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;qU(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=Yd[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=Yd[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;uO(n);uO(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;uO(n);uO(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;uO(n);uO(m);i=d;return}function PR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];QR(a,0,k,j,f,g,h);i=b;return}function QR(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+328|0;l=e;m=e+104|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+152|0;r=e+312|0;s=e+320|0;t=c[h+4>>2]&74;if((t|0)==0){u=0}else if((t|0)==8){u=16}else if((t|0)==64){u=8}else{u=10}t=l;gS(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;DO(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=c[m>>2]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0;C=1}else{x=c[m+12>>2]|0;if((x|0)==(c[m+16>>2]|0)){D=Yd[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{D=c[x>>2]|0}if(!((D|0)==-1)){B=m;C=0;break}c[l>>2]=0;B=0;C=1}}while(0);x=c[f>>2]|0;do{if((x|0)==0){E=21}else{F=c[x+12>>2]|0;if((F|0)==(c[x+16>>2]|0)){G=Yd[c[(c[x>>2]|0)+36>>2]&127](x)|0}else{G=c[F>>2]|0}if((G|0)==-1){c[f>>2]=0;E=21;break}else{if(C){H=x;break}else{I=x;J=A;break a}}}}while(0);if((E|0)==21){E=0;if(C){I=0;J=A;break}else{H=0}}x=a[o]|0;F=(x&1)==0;if(F){K=(x&255)>>>1}else{K=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(K|0)){if(F){L=(x&255)>>>1;M=(x&255)>>>1}else{x=c[y>>2]|0;L=x;M=x}DO(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[g>>2]&-2)+ -1|0}DO(o,N,0);if((a[o]&1)==0){O=v}else{O=c[w>>2]|0}c[p>>2]=O+L;P=O}else{P=A}x=B+12|0;F=c[x>>2]|0;Q=B+16|0;if((F|0)==(c[Q>>2]|0)){R=Yd[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{R=c[F>>2]|0}if((cS(R,u,P,p,s,z,n,h,r,t)|0)!=0){I=H;J=P;break}F=c[x>>2]|0;if((F|0)==(c[Q>>2]|0)){Yd[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=P;continue}else{c[x>>2]=F+4;m=B;A=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){P=c[r>>2]|0;if((P-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=A}}while(0);b[k>>1]=ZW(J,c[p>>2]|0,j,u)|0;qU(n,h,c[r>>2]|0,j);do{if((B|0)==0){T=0;U=1}else{r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){V=Yd[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{V=c[r>>2]|0}if(!((V|0)==-1)){T=B;U=0;break}c[l>>2]=0;T=0;U=1}}while(0);do{if((I|0)==0){E=60}else{l=c[I+12>>2]|0;if((l|0)==(c[I+16>>2]|0)){W=Yd[c[(c[I>>2]|0)+36>>2]&127](I)|0}else{W=c[l>>2]|0}if((W|0)==-1){c[f>>2]=0;E=60;break}if(!U){break}X=d;Y=X;c[Y>>2]=T;uO(o);uO(n);i=e;return}}while(0);do{if((E|0)==60){if(U){break}X=d;Y=X;c[Y>>2]=T;uO(o);uO(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;X=d;Y=X;c[Y>>2]=T;uO(o);uO(n);i=e;return}function RR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];SR(a,0,k,j,f,g,h);i=b;return}function SR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;gS(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;DO(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=Yd[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=Yd[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}DO(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}DO(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=Yd[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((cS(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){Yd[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=YW(I,c[o>>2]|0,h,t)|0;qU(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=Yd[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=Yd[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;uO(n);uO(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;uO(n);uO(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;uO(n);uO(m);i=d;return}function TR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];UR(a,0,k,j,f,g,h);i=b;return}function UR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;gS(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;DO(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=Yd[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=Yd[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}DO(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}DO(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=Yd[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((cS(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){Yd[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=XW(I,c[o>>2]|0,h,t)|0;qU(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=Yd[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=Yd[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;uO(n);uO(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;uO(n);uO(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;uO(n);uO(m);i=d;return}function VR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];WR(a,0,k,j,f,g,h);i=b;return}function WR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;gS(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;DO(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=Yd[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=Yd[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}DO(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}DO(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=Yd[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((cS(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){Yd[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=WW(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;qU(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=Yd[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=Yd[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;uO(n);uO(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;uO(n);uO(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;uO(n);uO(m);i=d;return}function XR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];YR(a,0,k,j,f,g,h);i=b;return}function YR(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;hS(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;DO(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=Yd[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=Yd[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}DO(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}DO(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=Yd[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((iS(T,t,u,R,p,B,l,n,h,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){Yd[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);g[k>>2]=+VW(L,c[p>>2]|0,j);qU(n,h,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=Yd[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=Yd[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;uO(o);uO(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;uO(o);uO(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;uO(o);uO(n);i=d;return}function ZR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];_R(a,0,k,j,f,g,h);i=b;return}function _R(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;hS(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;DO(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=Yd[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=Yd[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}DO(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}DO(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=Yd[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((iS(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){Yd[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+UW(L,c[p>>2]|0,j);qU(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=Yd[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=Yd[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;uO(o);uO(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;uO(o);uO(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;uO(o);uO(n);i=d;return}function $R(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];aS(a,0,k,j,f,g,h);i=b;return}function aS(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;hS(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;DO(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=Yd[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=Yd[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}DO(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}DO(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=Yd[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((iS(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){Yd[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+TW(L,c[p>>2]|0,j);qU(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=Yd[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=Yd[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;uO(o);uO(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;uO(o);uO(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;uO(o);uO(n);i=d;return}function bS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+104|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;qP(o,g);g=o;o=c[g>>2]|0;if(!((c[33866]|0)==-1)){c[l>>2]=135464;c[l+4>>2]=281;c[l+8>>2]=0;fO(135464,l,282)}l=(c[135468>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=zc(4)|0;w=v;eY(w);x=151032;y=127;Hd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=zc(4)|0;w=v;eY(w);x=151032;y=127;Hd(v|0,x|0,y|0)}y=m;ue[c[(c[o>>2]|0)+48>>2]&63](o,134016,134042|0,y)|0;MN(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;DO(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0;D=1}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){E=Yd[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{E=c[B>>2]|0}if(!((E|0)==-1)){C=m;D=0;break}c[r>>2]=0;C=0;D=1}}while(0);B=c[e>>2]|0;do{if((B|0)==0){F=22}else{v=c[B+12>>2]|0;if((v|0)==(c[B+16>>2]|0)){G=Yd[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{G=c[v>>2]|0}if((G|0)==-1){c[e>>2]=0;F=22;break}else{if(D){break}else{H=x;break a}}}}while(0);if((F|0)==22){F=0;if(D){H=x;break}}B=a[p]|0;v=(B&1)==0;if(v){I=(B&255)>>>1}else{I=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(I|0)){if(v){J=(B&255)>>>1;K=(B&255)>>>1}else{B=c[o>>2]|0;J=B;K=B}DO(p,K<<1,0);if((a[p]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}DO(p,L,0);if((a[p]&1)==0){M=z}else{M=c[A>>2]|0}c[q>>2]=M+J;N=M}else{N=x}B=C+12|0;v=c[B>>2]|0;w=C+16|0;if((v|0)==(c[w>>2]|0)){O=Yd[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{O=c[v>>2]|0}if((cS(O,16,N,q,t,0,n,g,s,y)|0)!=0){H=N;break}v=c[B>>2]|0;if((v|0)==(c[w>>2]|0)){Yd[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=N;continue}else{c[B>>2]=v+4;m=C;x=N;continue}}a[H+3|0]=0;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);N=c[33840]|0;c[k>>2]=j;if((GR(H,N,134056,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){P=0;Q=1}else{N=c[k+12>>2]|0;if((N|0)==(c[k+16>>2]|0)){R=Yd[c[(c[k>>2]|0)+36>>2]&127](k)|0}else{R=c[N>>2]|0}if(!((R|0)==-1)){P=k;Q=0;break}c[r>>2]=0;P=0;Q=1}}while(0);r=c[e>>2]|0;do{if((r|0)==0){F=60}else{k=c[r+12>>2]|0;if((k|0)==(c[r+16>>2]|0)){S=Yd[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{S=c[k>>2]|0}if((S|0)==-1){c[e>>2]=0;F=60;break}if(!Q){break}T=b;U=T;c[U>>2]=P;uO(p);uO(n);i=d;return}}while(0);do{if((F|0)==60){if(Q){break}T=b;U=T;c[U>>2]=P;uO(p);uO(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;T=b;U=T;c[U>>2]=P;uO(p);uO(n);i=d;return}function cS(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(c[m+96>>2]|0)==(b|0);if(!q){if((c[m+100>>2]|0)!=(b|0)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&(b|0)==(h|0)){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+104|0;h=m;while(1){l=h+4|0;if((c[h>>2]|0)==(b|0)){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;m=h>>2;if((h|0)>92){r=-1;i=n;return r|0}do{if((d|0)==16){if((h|0)<88){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;t=a[134016+m|0]|0;c[f>>2]=o+1;a[o]=t;r=0;i=n;return r|0}else if((d|0)==10|(d|0)==8){if((m|0)<(d|0)){break}else{r=-1}i=n;return r|0}}while(0);d=a[134016+m|0]|0;c[f>>2]=o+1;a[o]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function dS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;qP(k,d);d=k;k=c[d>>2]|0;if(!((c[33868]|0)==-1)){c[j>>2]=135472;c[j+4>>2]=281;c[j+8>>2]=0;fO(135472,j,282)}j=(c[135476>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=zc(4)|0;n=m;eY(n);o=151032;p=127;Hd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=zc(4)|0;n=m;eY(n);o=151032;p=127;Hd(m|0,o|0,p|0)}ue[c[(c[k>>2]|0)+32>>2]&63](k,134016,134042|0,e)|0;e=c[d>>2]|0;if(!((c[33904]|0)==-1)){c[h>>2]=135616;c[h+4>>2]=281;c[h+8>>2]=0;fO(135616,h,282)}h=(c[135620>>2]|0)+ -1|0;k=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-k>>2>>>0>h>>>0)){q=zc(4)|0;r=q;eY(r);s=151032;t=127;Hd(q|0,s|0,t|0)}e=c[k+(h<<2)>>2]|0;if((e|0)==0){q=zc(4)|0;r=q;eY(r);s=151032;t=127;Hd(q|0,s|0,t|0)}else{t=e;a[f]=Yd[c[(c[e>>2]|0)+16>>2]&127](t)|0;Wd[c[(c[e>>2]|0)+20>>2]&63](b,t);MN(c[d>>2]|0)|0;i=g;return}}function eS(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h;k=h+16|0;l=h+32|0;qP(l,d);d=l;l=c[d>>2]|0;if(!((c[33868]|0)==-1)){c[k>>2]=135472;c[k+4>>2]=281;c[k+8>>2]=0;fO(135472,k,282)}k=(c[135476>>2]|0)+ -1|0;m=c[l+8>>2]|0;if(!((c[l+12>>2]|0)-m>>2>>>0>k>>>0)){n=zc(4)|0;o=n;eY(o);p=151032;q=127;Hd(n|0,p|0,q|0)}l=c[m+(k<<2)>>2]|0;if((l|0)==0){n=zc(4)|0;o=n;eY(o);p=151032;q=127;Hd(n|0,p|0,q|0)}ue[c[(c[l>>2]|0)+32>>2]&63](l,134016,134048|0,e)|0;e=c[d>>2]|0;if(!((c[33904]|0)==-1)){c[j>>2]=135616;c[j+4>>2]=281;c[j+8>>2]=0;fO(135616,j,282)}j=(c[135620>>2]|0)+ -1|0;l=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-l>>2>>>0>j>>>0)){r=zc(4)|0;s=r;eY(s);t=151032;u=127;Hd(r|0,t|0,u|0)}e=c[l+(j<<2)>>2]|0;if((e|0)==0){r=zc(4)|0;s=r;eY(s);t=151032;u=127;Hd(r|0,t|0,u|0)}else{u=e;a[f]=Yd[c[(c[e>>2]|0)+12>>2]&127](u)|0;a[g]=Yd[c[(c[e>>2]|0)+16>>2]&127](u)|0;Wd[c[(c[e>>2]|0)+20>>2]&63](b,u);MN(c[d>>2]|0)|0;i=h;return}}function fS(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if(b<<24>>24==h<<24>>24){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if(b<<24>>24==j<<24>>24){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+32|0;j=o;while(1){r=j+1|0;if((a[j]|0)==b<<24>>24){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;if((j|0)>31){q=-1;i=p;return q|0}o=a[134016+j|0]|0;if((j|0)==23|(j|0)==22){a[e]=80;t=c[g>>2]|0;c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else if((j|0)==24|(j|0)==25){t=c[g>>2]|0;do{if((t|0)!=(f|0)){if((a[t+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else{t=a[e]|0;do{if((o&95|0)==(t<<24>>24|0)){a[e]=t|-128;if((a[d]|0)==0){break}a[d]=0;f=a[k]|0;if((f&1)==0){u=(f&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}f=c[m>>2]|0;if((f-l|0)>=160){break}s=c[n>>2]|0;c[m>>2]=f+4;c[f>>2]=s}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=o;if((j|0)>21){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}return 0}function gS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+40|0;g=f;h=f+16|0;j=f+32|0;qP(j,b);b=j;j=c[b>>2]|0;if(!((c[33866]|0)==-1)){c[h>>2]=135464;c[h+4>>2]=281;c[h+8>>2]=0;fO(135464,h,282)}h=(c[135468>>2]|0)+ -1|0;k=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-k>>2>>>0>h>>>0)){l=zc(4)|0;m=l;eY(m);n=151032;o=127;Hd(l|0,n|0,o|0)}j=c[k+(h<<2)>>2]|0;if((j|0)==0){l=zc(4)|0;m=l;eY(m);n=151032;o=127;Hd(l|0,n|0,o|0)}ue[c[(c[j>>2]|0)+48>>2]&63](j,134016,134042|0,d)|0;d=c[b>>2]|0;if(!((c[33906]|0)==-1)){c[g>>2]=135624;c[g+4>>2]=281;c[g+8>>2]=0;fO(135624,g,282)}g=(c[135628>>2]|0)+ -1|0;j=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-j>>2>>>0>g>>>0)){p=zc(4)|0;q=p;eY(q);r=151032;s=127;Hd(p|0,r|0,s|0)}d=c[j+(g<<2)>>2]|0;if((d|0)==0){p=zc(4)|0;q=p;eY(q);r=151032;s=127;Hd(p|0,r|0,s|0)}else{s=d;c[e>>2]=Yd[c[(c[d>>2]|0)+16>>2]&127](s)|0;Wd[c[(c[d>>2]|0)+20>>2]&63](a,s);MN(c[b>>2]|0)|0;i=f;return}}function hS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;qP(k,b);b=k;k=c[b>>2]|0;if(!((c[33866]|0)==-1)){c[j>>2]=135464;c[j+4>>2]=281;c[j+8>>2]=0;fO(135464,j,282)}j=(c[135468>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=zc(4)|0;n=m;eY(n);o=151032;p=127;Hd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=zc(4)|0;n=m;eY(n);o=151032;p=127;Hd(m|0,o|0,p|0)}ue[c[(c[k>>2]|0)+48>>2]&63](k,134016,134048|0,d)|0;d=c[b>>2]|0;if(!((c[33906]|0)==-1)){c[h>>2]=135624;c[h+4>>2]=281;c[h+8>>2]=0;fO(135624,h,282)}h=(c[135628>>2]|0)+ -1|0;k=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-k>>2>>>0>h>>>0)){q=zc(4)|0;r=q;eY(r);s=151032;t=127;Hd(q|0,s|0,t|0)}d=c[k+(h<<2)>>2]|0;if((d|0)==0){q=zc(4)|0;r=q;eY(r);s=151032;t=127;Hd(q|0,s|0,t|0)}else{t=d;c[e>>2]=Yd[c[(c[d>>2]|0)+12>>2]&127](t)|0;c[f>>2]=Yd[c[(c[d>>2]|0)+16>>2]&127](t)|0;Wd[c[(c[d>>2]|0)+20>>2]&63](a,t);MN(c[b>>2]|0)|0;i=g;return}}function iS(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if((b|0)==(h|0)){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if((b|0)==(j|0)){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+128|0;j=o;while(1){r=j+4|0;if((c[j>>2]|0)==(b|0)){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;o=j>>2;if((j|0)>124){q=-1;i=p;return q|0}t=a[134016+o|0]|0;do{if((o|0)==23|(o|0)==22){a[e]=80}else if((o|0)==24|(o|0)==25){s=c[g>>2]|0;do{if((s|0)!=(f|0)){if((a[s+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=s+1;a[s]=t;q=0;i=p;return q|0}else{b=a[e]|0;if((t&95|0)!=(b<<24>>24|0)){break}a[e]=b|-128;if((a[d]|0)==0){break}a[d]=0;b=a[k]|0;if((b&1)==0){u=(b&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}b=c[m>>2]|0;if((b-l|0)>=160){break}r=c[n>>2]|0;c[m>>2]=b+4;c[b>>2]=r}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=t;if((j|0)>84){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}function jS(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function kS(a){a=a|0;i=i;return}function lS(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];fe[p&31](b,d,k,f,g,q);i=j;return}qP(n,f);f=n;n=c[f>>2]|0;if(!((c[33904]|0)==-1)){c[l>>2]=135616;c[l+4>>2]=281;c[l+8>>2]=0;fO(135616,l,282)}l=(c[135620>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=zc(4)|0;u=t;eY(u);v=151032;w=127;Hd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=zc(4)|0;u=t;eY(u);v=151032;w=127;Hd(t|0,v|0,w|0)}w=n;MN(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){Wd[c[f+24>>2]&63](o,w)}else{Wd[c[f+28>>2]&63](o,w)}w=a[o]|0;if((w&1)==0){f=o+1|0;x=f;y=f;z=o+8|0}else{f=o+8|0;x=c[f>>2]|0;y=o+1|0;z=f}f=e;e=o+4|0;h=w;w=x;while(1){if((h&1)==0){A=y;B=(h&255)>>>1}else{A=c[z>>2]|0;B=c[e>>2]|0}if((w|0)==(A+B|0)){break}x=a[w]|0;n=c[f>>2]|0;do{if((n|0)!=0){v=n+24|0;t=c[v>>2]|0;if((t|0)!=(c[n+28>>2]|0)){c[v>>2]=t+1;a[t]=x;break}if(!((le[c[(c[n>>2]|0)+52>>2]&63](n,x&255)|0)==-1)){break}c[f>>2]=0}}while(0);h=a[o]|0;w=w+1|0}c[b>>2]=c[f>>2];uO(o);i=j;return}function mS(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=134264;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=100}}while(0);w=m;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);x=c[33840]|0;c[k>>2]=h;h=nS(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;qP(q,f);oS(w,y,k,z,o,p,q);MN(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];VK(b,j,z,e,o,f,g);i=d;return}function nS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;f=Gc(d|0)|0;d=ic(a|0,b|0,e|0,h|0)|0;if((f|0)==0){i=g;return d|0}Gc(f|0)|0;i=g;return d|0}function oS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[33868]|0)==-1)){c[m>>2]=135472;c[m+4>>2]=281;c[m+8>>2]=0;fO(135472,m,282)}m=(c[135476>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=zc(4)|0;r=q;eY(r);s=151032;t=127;Hd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=zc(4)|0;r=q;eY(r);s=151032;t=127;Hd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[33904]|0)==-1)){c[l>>2]=135616;c[l+4>>2]=281;c[l+8>>2]=0;fO(135616,l,282)}l=(c[135620>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=zc(4)|0;v=u;eY(v);w=151032;x=127;Hd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=zc(4)|0;v=u;eY(v);w=151032;x=127;Hd(u|0,w|0,x|0)}x=s;Wd[c[(c[s>>2]|0)+20>>2]&63](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){ue[c[(c[j>>2]|0)+32>>2]&63](t,b,e,f)|0;c[h>>2]=f+(e-b)}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=le[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;z=b+1|0}else{z=b}do{if((e-z|0)>1){if((a[z]|0)!=48){A=z;break}u=z+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){A=z;break}w=le[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+1;a[v]=w;w=le[c[(c[j>>2]|0)+28>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+1;a[u]=w;A=z+2|0}else{A=z}}while(0);do{if((A|0)!=(e|0)){w=e+ -1|0;if(w>>>0>A>>>0){B=A;C=w}else{break}do{w=a[B]|0;a[B]=a[C]|0;a[C]=w;B=B+1|0;C=C+ -1|0;}while(B>>>0<C>>>0)}}while(0);w=Yd[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(A>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=A;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){D=o;E=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){D=o;E=q;break}p=c[h>>2]|0;c[h>>2]=p+1;a[p]=w;p=a[n]|0;if((p&1)==0){F=(p&255)>>>1}else{F=c[v>>2]|0}D=0;E=(q>>>0<(F+ -1|0)>>>0)+q|0}}while(0);m=le[c[(c[j>>2]|0)+28>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=m;m=r+1|0;if(m>>>0<e>>>0){o=D+1|0;q=E;r=m}else{break}}}r=f+(A-b)|0;q=c[h>>2]|0;if((r|0)==(q|0)){break}o=q+ -1|0;if(o>>>0>r>>>0){G=r;H=o}else{break}do{o=a[G]|0;a[G]=a[H]|0;a[H]=o;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);if((d|0)==(e|0)){I=c[h>>2]|0;c[g>>2]=I;uO(n);i=k;return}else{I=f+(d-b)|0;c[g>>2]=I;uO(n);i=k;return}}function pS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=100}}while(0);x=n;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);w=c[33840]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=nS(x,22,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;qP(r,f);oS(x,z,l,A,p,q,r);MN(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];VK(b,k,A,e,p,f,g);i=d;return}function qS(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=134264;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);v=c[33840]|0;c[k>>2]=h;h=nS(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;qP(q,f);oS(w,y,k,z,o,p,q);MN(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];VK(b,j,z,e,o,f,g);i=d;return}function rS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);y=c[33840]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=nS(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;qP(r,f);oS(x,z,l,A,p,q,r);MN(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];VK(b,k,A,e,p,f,g);i=d;return}function sS(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);r=c[33840]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=nS(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=nS(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[135368]|0)==0;if(F){do{if(o){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);r=c[33840]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=tS(s,r,z,n)|0}else{do{if(o){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);o=c[33840]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=tS(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}MY()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=zY(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}MY()}}while(0);qP(w,f);uS(N,L,G,P,u,v,w);MN(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];VK(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){AY(O)}if((J|0)==0){i=d;return}AY(J);i=d;return}function tS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Gc(b|0)|0;b=vc(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Gc(e|0)|0;i=f;return b|0}function uS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[33868]|0)==-1)){c[m>>2]=135472;c[m+4>>2]=281;c[m+8>>2]=0;fO(135472,m,282)}m=(c[135476>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=zc(4)|0;r=q;eY(r);s=151032;t=127;Hd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=zc(4)|0;r=q;eY(r);s=151032;t=127;Hd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[33904]|0)==-1)){c[l>>2]=135616;c[l+4>>2]=281;c[l+8>>2]=0;fO(135616,l,282)}l=(c[135620>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=zc(4)|0;v=u;eY(v);w=151032;x=127;Hd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=zc(4)|0;v=u;eY(v);w=151032;x=127;Hd(u|0,w|0,x|0)}x=s;Wd[c[(c[s>>2]|0)+20>>2]&63](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=le[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=le[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+1;a[l]=v;v=y+2|0;l=le[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);w=A+1|0;if((Rc(l<<24>>24|0,c[33840]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);l=D+1|0;if((Jd(A<<24>>24|0,c[33840]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){ue[c[(c[j>>2]|0)+32>>2]&63](t,B,C,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(C-B)}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){F=B;G=y}else{break}do{y=a[F]|0;a[F]=a[G]|0;a[G]=y;F=F+1|0;G=G+ -1|0;}while(F>>>0<G>>>0)}}while(0);A=Yd[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){H=l;I=v;break}q=c[h>>2]|0;c[h>>2]=q+1;a[q]=A;q=a[n]|0;if((q&1)==0){J=(q&255)>>>1}else{J=c[D>>2]|0}H=0;I=(v>>>0<(J+ -1|0)>>>0)+v|0}else{H=l;I=v}}while(0);o=le[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q]=o;o=w+1|0;if(o>>>0<C>>>0){l=H+1|0;v=I;w=o}else{break}}}w=f+(B-b)|0;v=c[h>>2]|0;if((w|0)==(v|0)){break}l=v+ -1|0;if(l>>>0>w>>>0){K=w;L=l}else{break}do{l=a[K]|0;a[K]=a[L]|0;a[L]=l;K=K+1|0;L=L+ -1|0;}while(K>>>0<L>>>0)}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){K=a[L]|0;if(K<<24>>24==46){break}B=le[c[(c[j>>2]|0)+28>>2]&63](t,K)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;B=L+1|0;if(B>>>0<e>>>0){L=B}else{M=B;break c}}B=Yd[c[(c[s>>2]|0)+12>>2]&127](x)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;M=L+1|0}else{M=C}}while(0);ue[c[(c[j>>2]|0)+32>>2]&63](t,M,e,c[h>>2]|0)|0;t=(c[h>>2]|0)+(u-M)|0;c[h>>2]=t;if((d|0)==(e|0)){N=t;c[g>>2]=N;uO(n);i=k;return}N=f+(d-b)|0;c[g>>2]=N;uO(n);i=k;return}function vS(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);r=c[33840]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=nS(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=nS(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[135368]|0)==0;if(F){do{if(o){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);r=c[33840]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=tS(s,r,z,n)|0}else{do{if(o){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);o=c[33840]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=tS(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}MY()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=zY(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}MY()}}while(0);qP(w,f);uS(N,L,G,P,u,v,w);MN(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];VK(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){AY(O)}if((J|0)==0){i=d;return}AY(J);i=d;return}function wS(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+40|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=134272;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);s=c[33840]|0;c[k>>2]=h;h=nS(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==32){t=k}else if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else{u=10}}while(0);if((u|0)==10){t=m}u=o;qP(p,f);r=p;p=c[r>>2]|0;if(!((c[33868]|0)==-1)){c[l>>2]=135472;c[l+4>>2]=281;c[l+8>>2]=0;fO(135472,l,282)}l=(c[135476>>2]|0)+ -1|0;s=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-s>>2>>>0>l>>>0)){v=zc(4)|0;w=v;eY(w);x=151032;y=127;Hd(v|0,x|0,y|0)}p=c[s+(l<<2)>>2]|0;if((p|0)==0){v=zc(4)|0;w=v;eY(w);x=151032;y=127;Hd(v|0,x|0,y|0)}MN(c[r>>2]|0)|0;ue[c[(c[p>>2]|0)+32>>2]&63](p,m,k,u)|0;m=o+h|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];VK(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];VK(b,j,u,z,m,f,g);I=j;i=d;return}function xS(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function yS(a){a=a|0;i=i;return}function zS(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];fe[p&31](b,d,k,f,g,q);i=j;return}qP(n,f);f=n;n=c[f>>2]|0;if(!((c[33906]|0)==-1)){c[l>>2]=135624;c[l+4>>2]=281;c[l+8>>2]=0;fO(135624,l,282)}l=(c[135628>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=zc(4)|0;u=t;eY(u);v=151032;w=127;Hd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=zc(4)|0;u=t;eY(u);v=151032;w=127;Hd(t|0,v|0,w|0)}w=n;MN(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){Wd[c[f+24>>2]&63](o,w)}else{Wd[c[f+28>>2]&63](o,w)}w=a[o]|0;if((w&1)==0){f=o+4|0;x=f;y=o+8|0;z=f}else{f=o+8|0;x=c[f>>2]|0;y=f;z=o+4|0}f=e;e=w;w=x;while(1){if((e&1)==0){A=z;B=(e&255)>>>1}else{A=c[y>>2]|0;B=c[z>>2]|0}if((w|0)==(A+(B<<2)|0)){break}x=c[w>>2]|0;h=c[f>>2]|0;do{if((h|0)!=0){n=h+24|0;v=c[n>>2]|0;if((v|0)==(c[h+28>>2]|0)){C=le[c[(c[h>>2]|0)+52>>2]&63](h,x)|0}else{c[n>>2]=v+4;c[v>>2]=x;C=x}if(!((C|0)==-1)){break}c[f>>2]=0}}while(0);e=a[o]|0;w=w+4|0}c[b>>2]=c[f>>2];YO(o);i=j;return}function AS(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=134264;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=100}}while(0);w=m;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);x=c[33840]|0;c[k>>2]=h;h=nS(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;qP(q,f);BS(w,y,k,z,o,p,q);MN(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];CS(b,j,z,e,o,f,g);i=d;return}function BS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[33866]|0)==-1)){c[m>>2]=135464;c[m+4>>2]=281;c[m+8>>2]=0;fO(135464,m,282)}m=(c[135468>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=zc(4)|0;r=q;eY(r);s=151032;t=127;Hd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=zc(4)|0;r=q;eY(r);s=151032;t=127;Hd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[33906]|0)==-1)){c[l>>2]=135624;c[l+4>>2]=281;c[l+8>>2]=0;fO(135624,l,282)}l=(c[135628>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=zc(4)|0;v=u;eY(v);w=151032;x=127;Hd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=zc(4)|0;v=u;eY(v);w=151032;x=127;Hd(u|0,w|0,x|0)}x=s;Wd[c[(c[s>>2]|0)+20>>2]&63](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){ue[c[(c[j>>2]|0)+48>>2]&63](t,b,e,f)|0;w=f+(e-b<<2)|0;c[h>>2]=w;z=w}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=le[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;A=b+1|0}else{A=b}do{if((e-A|0)>1){if((a[A]|0)!=48){B=A;break}u=A+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){B=A;break}w=le[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=w;w=le[c[(c[j>>2]|0)+44>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=w;B=A+2|0}else{B=A}}while(0);do{if((B|0)!=(e|0)){w=e+ -1|0;if(w>>>0>B>>>0){C=B;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D+ -1|0;}while(C>>>0<D>>>0)}}while(0);w=Yd[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=B;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){E=o;F=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){E=o;F=q;break}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=w;p=a[n]|0;if((p&1)==0){G=(p&255)>>>1}else{G=c[v>>2]|0}E=0;F=(q>>>0<(G+ -1|0)>>>0)+q|0}}while(0);m=le[c[(c[j>>2]|0)+44>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;H=p+4|0;c[h>>2]=H;c[p>>2]=m;m=r+1|0;if(m>>>0<e>>>0){o=E+1|0;q=F;r=m}else{I=H;break}}}else{I=c[h>>2]|0}r=f+(B-b<<2)|0;if((r|0)==(I|0)){z=I;break}q=I+ -4|0;if(q>>>0>r>>>0){J=r;K=q}else{z=I;break}while(1){q=c[J>>2]|0;c[J>>2]=c[K>>2];c[K>>2]=q;q=J+4|0;r=K+ -4|0;if(q>>>0<r>>>0){K=r;J=q}else{z=I;break}}}}while(0);if((d|0)==(e|0)){L=z;c[g>>2]=L;uO(n);i=k;return}L=f+(d-b<<2)|0;c[g>>2]=L;uO(n);i=k;return}function CS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=d;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if(($d[c[(c[d>>2]|0)+48>>2]&63](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){XO(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}if(($d[c[(c[d>>2]|0)+48>>2]&63](d,r,q)|0)==(q|0)){YO(l);break}c[m>>2]=0;c[b>>2]=0;YO(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if(($d[c[(c[d>>2]|0)+48>>2]&63](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function DS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+168|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=100}}while(0);x=n;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);w=c[33840]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=nS(x,22,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;qP(r,f);BS(x,z,l,A,p,q,r);MN(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];CS(b,k,A,e,p,f,g);i=d;return}function ES(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=134264;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);v=c[33840]|0;c[k>>2]=h;h=nS(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;qP(q,f);BS(w,y,k,z,o,p,q);MN(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];CS(b,j,z,e,o,f,g);i=d;return}function FS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+176|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=117}}while(0);x=n;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);w=c[33840]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=nS(x,23,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;qP(r,f);BS(x,z,l,A,p,q,r);MN(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];CS(b,k,A,e,p,f,g);i=d;return}function GS(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);r=c[33840]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=nS(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=nS(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[135368]|0)==0;if(F){do{if(o){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);r=c[33840]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=tS(s,r,z,n)|0}else{do{if(o){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);o=c[33840]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=tS(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}MY()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=zY(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}MY()}}while(0);qP(w,f);HS(N,L,G,P,u,v,w);MN(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];CS(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){AY(O)}if((J|0)==0){i=d;return}AY(J);i=d;return}function HS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[33866]|0)==-1)){c[m>>2]=135464;c[m+4>>2]=281;c[m+8>>2]=0;fO(135464,m,282)}m=(c[135468>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=zc(4)|0;r=q;eY(r);s=151032;t=127;Hd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=zc(4)|0;r=q;eY(r);s=151032;t=127;Hd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[33906]|0)==-1)){c[l>>2]=135624;c[l+4>>2]=281;c[l+8>>2]=0;fO(135624,l,282)}l=(c[135628>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=zc(4)|0;v=u;eY(v);w=151032;x=127;Hd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=zc(4)|0;v=u;eY(v);w=151032;x=127;Hd(u|0,w|0,x|0)}x=s;Wd[c[(c[s>>2]|0)+20>>2]&63](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=le[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=le[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=v;v=y+2|0;l=le[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);w=A+1|0;if((Rc(l<<24>>24|0,c[33840]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);l=D+1|0;if((Jd(A<<24>>24|0,c[33840]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){ue[c[(c[j>>2]|0)+48>>2]&63](t,B,C,c[h>>2]|0)|0;y=(c[h>>2]|0)+(C-B<<2)|0;c[h>>2]=y;F=y}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){G=B;H=y}else{break}do{y=a[G]|0;a[G]=a[H]|0;a[H]=y;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);A=Yd[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){I=l;J=v;break}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=A;q=a[n]|0;if((q&1)==0){K=(q&255)>>>1}else{K=c[D>>2]|0}I=0;J=(v>>>0<(K+ -1|0)>>>0)+v|0}else{I=l;J=v}}while(0);o=le[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;r=q+4|0;c[h>>2]=r;c[q>>2]=o;o=w+1|0;if(o>>>0<C>>>0){l=I+1|0;v=J;w=o}else{L=r;break}}}else{L=c[h>>2]|0}w=f+(B-b<<2)|0;if((w|0)==(L|0)){F=L;break}v=L+ -4|0;if(v>>>0>w>>>0){M=w;N=v}else{F=L;break}while(1){v=c[M>>2]|0;c[M>>2]=c[N>>2];c[N>>2]=v;v=M+4|0;w=N+ -4|0;if(v>>>0<w>>>0){N=w;M=v}else{F=L;break}}}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){M=a[L]|0;if(M<<24>>24==46){break}N=le[c[(c[j>>2]|0)+44>>2]&63](t,M)|0;M=c[h>>2]|0;B=M+4|0;c[h>>2]=B;c[M>>2]=N;N=L+1|0;if(N>>>0<e>>>0){L=N}else{O=B;P=N;break c}}N=Yd[c[(c[s>>2]|0)+12>>2]&127](x)|0;B=c[h>>2]|0;M=B+4|0;c[h>>2]=M;c[B>>2]=N;O=M;P=L+1|0}else{O=F;P=C}}while(0);ue[c[(c[j>>2]|0)+48>>2]&63](t,P,e,O)|0;O=(c[h>>2]|0)+(u-P<<2)|0;c[h>>2]=O;if((d|0)==(e|0)){Q=O;c[g>>2]=Q;uO(n);i=k;return}Q=f+(d-b<<2)|0;c[g>>2]=Q;uO(n);i=k;return}function IS(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);r=c[33840]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=nS(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=nS(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[135368]|0)==0;if(F){do{if(o){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);r=c[33840]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=tS(s,r,z,n)|0}else{do{if(o){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);o=c[33840]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=tS(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}MY()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=zY(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}MY()}}while(0);qP(w,f);HS(N,L,G,P,u,v,w);MN(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];CS(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){AY(O)}if((J|0)==0){i=d;return}AY(J);i=d;return}function JS(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+152|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=134272;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);s=c[33840]|0;c[k>>2]=h;h=nS(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else if((r|0)==32){t=k}else{u=10}}while(0);if((u|0)==10){t=m}qP(p,f);u=p;p=c[u>>2]|0;if(!((c[33866]|0)==-1)){c[l>>2]=135464;c[l+4>>2]=281;c[l+8>>2]=0;fO(135464,l,282)}l=(c[135468>>2]|0)+ -1|0;r=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-r>>2>>>0>l>>>0)){v=zc(4)|0;w=v;eY(w);x=151032;y=127;Hd(v|0,x|0,y|0)}p=c[r+(l<<2)>>2]|0;if((p|0)==0){v=zc(4)|0;w=v;eY(w);x=151032;y=127;Hd(v|0,x|0,y|0)}MN(c[u>>2]|0)|0;u=o;ue[c[(c[p>>2]|0)+48>>2]&63](p,m,k,u)|0;m=o+(h<<2)|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];CS(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n<<2)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];CS(b,j,u,z,m,f,g);I=j;i=d;return}



function Wq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1080|0;f=e+24|0;g=b;b=d;do{if((c[g+124>>2]|0)!=0){d=0;while(1){if((d|0)>=256){break}c[f+(d<<2)>>2]=-1;d=d+1|0}c[f+1028>>2]=0;c[f+1024>>2]=0;c[f+1032>>2]=0;do{if(($d[c[g+124>>2]&63](c[g+248>>2]|0,b,f)|0)!=0){d=c[g+12>>2]|0;h=br()|0;c[g+240>>2]=Yd[d&127](h)|0;if((c[g+240>>2]|0)!=0){h=ue[((a[g+236|0]&255|0)!=0?44:45)&63](c[g+240>>2]|0,f,c[f+1028>>2]|0,c[f+1024>>2]|0)|0;if((h|0)==0){break}c[g+244>>2]=c[f+1024>>2];c[g+252>>2]=c[f+1032>>2];c[g+144>>2]=h;j=0;k=j;i=e;return k|0}if((c[f+1032>>2]|0)!=0){Vd[c[f+1032>>2]&511](c[f+1024>>2]|0)}j=1;k=j;i=e;return k|0}}while(0);if((c[f+1032>>2]|0)==0){break}Vd[c[f+1032>>2]&511](c[f+1024>>2]|0)}}while(0);j=18;k=j;i=e;return k|0}function Xq(){var a=0,b=0;a=i;i=i+8|0;Yb(((nc(0)|0)>>>0)%4294967295|0|0);b=jZ()|0;i=a;return b|0}function Yq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+48|0;g=a;a=oq(g)|0;if((a|0)!=0){h=a;j=h;i=f;return j|0}else{c[g+280>>2]=39;h=pq(g,b,d,e)|0;j=h;i=f;return j|0}return 0}function Zq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=Yd[c[e>>2]&127](188)|0;f=b;if((b|0)==0){g=f;h=g;i=d;return h|0}else{_q(f+80|0,e);_q(b+104|0,e);$q(b,e);$q(b+20|0,e);$q(b+40|0,e);$q(b+60|0,e);a[b+131|0]=0;$q(b+132|0,e);c[b+152>>2]=0;c[b+156>>2]=0;a[b+160|0]=0;c[b+184>>2]=0;c[b+164>>2]=0;c[b+180>>2]=0;c[b+172>>2]=0;c[b+176>>2]=0;c[b+168>>2]=0;a[b+128|0]=1;a[b+129|0]=0;a[b+130|0]=0;g=b;h=g;i=d;return h|0}return 0}function _q(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;c[e>>2]=0;c[e+4>>2]=0;c[e+16>>2]=0;c[e+12>>2]=0;c[e+8>>2]=0;c[e+20>>2]=b;i=d;return}function $q(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=b;a[f+4|0]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f>>2]=0;c[f+16>>2]=d;i=e;return}function ar(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;if((e|0)<0){f=0;g=f;i=d;return g|0}c=e;if((e|0)<128){a[b]=c;f=1;g=f;i=d;return g|0}h=e;if((c|0)<2048){a[b]=h>>6|192;a[b+1|0]=e&63|128;f=2;g=f;i=d;return g|0}c=e;if((h|0)<65536){a[b]=c>>12|224;a[b+1|0]=e>>6&63|128;a[b+2|0]=e&63|128;f=3;g=f;i=d;return g|0}if((c|0)<1114112){a[b]=e>>18|240;a[b+1|0]=e>>12&63|128;a[b+2|0]=e>>6&63|128;a[b+3|0]=e&63|128;f=4;g=f;i=d;return g|0}else{f=0;g=f;i=d;return g|0}return 0}function br(){i=i;return 1912}function cr(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+64|0;k=e;e=f;f=g;g=h;h=k;l=0;while(1){if((l|0)>=368){break}a[k+l|0]=a[61592+l|0]|0;l=l+1|0}l=0;a:while(1){if((l|0)>=128){break}do{if((d[61668+l|0]|0|0)!=28){if((d[61668+l|0]|0|0)==0){break}if((c[e+(l<<2)>>2]|0)!=(l|0)){m=9;break a}}}while(0);l=l+1|0}if((m|0)==9){n=0;o=n;i=j;return o|0}l=0;b:while(1){if((l|0)>=256){m=36;break}k=c[e+(l<<2)>>2]|0;do{if((k|0)==-1){a[h+76+l|0]=1;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0}else{p=k;if((k|0)<0){if((p|0)<-4){m=17;break b}a[h+76+l|0]=5-(k+2);a[h+888+(l<<2)|0]=0;b[h+376+(l<<1)>>1]=0;break}q=k;if((p|0)<128){do{if((d[61668+q|0]|0|0)!=28){if((d[61668+k|0]|0|0)==0){break}if((k|0)!=(l|0)){m=23;break b}}}while(0);a[h+76+l|0]=a[61668+k|0]|0;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=k;b[h+376+(l<<1)>>1]=(k|0)==0?65535:k;break}if((dr(q)|0)<0){a[h+76+l|0]=0;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0;break}if((k|0)>65535){m=28;break b}do{if((c[55760+(((d[55504+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[h+76+l|0]=22}else{p=h+76+l|0;if((c[55760+(((d[57040+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[p]=26;break}else{a[p]=28;break}}}while(0);a[h+888+(l<<2)|0]=ar(k,h+888+(l<<2)+1|0)|0;b[h+376+(l<<1)>>1]=k}}while(0);l=l+1|0}if((m|0)==17){n=0;o=n;i=j;return o|0}else if((m|0)==23){n=0;o=n;i=j;return o|0}else if((m|0)==28){n=0;o=n;i=j;return o|0}else if((m|0)==36){c[h+372>>2]=g;c[h+368>>2]=f;if((f|0)!=0){c[h+332>>2]=48;c[h+336>>2]=48;c[h+340>>2]=48;c[h+344>>2]=49;c[h+348>>2]=49;c[h+352>>2]=49;c[h+356>>2]=50;c[h+360>>2]=50;c[h+364>>2]=50}c[h+60>>2]=13;c[h+64>>2]=14;n=h;o=n;i=j;return o|0}return 0}function dr(a){a=a|0;var b=0,c=0,e=0,f=0;b=i;i=i+16|0;c=a;a:do{switch(c>>8|0){case 0:{if((d[61668+c|0]|0|0)!=0){e=7;break a}f=-1;break};case 255:{if(!((c|0)==65534|(c|0)==65535)){e=7;break a}f=-1;break};case 223:case 222:case 221:case 220:case 219:case 218:case 217:case 216:{f=-1;break};default:{e=7}}}while(0);if((e|0)==7){f=c}i=b;return f|0}function er(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=le[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[55760+(((d[57040+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function fr(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=le[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[55760+(((d[55504+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function gr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=a;a=le[c[e+368>>2]&63](c[e+372>>2]|0,b)|0;if((a&-65536|0)!=0){f=1;g=f&1;i=d;return g|0}f=(dr(a)|0)<0;g=f&1;i=d;return g|0}function hr(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+80|0;k=j+48|0;l=b;b=e;e=f;f=g;g=h;h=l;a:while(1){if((c[b>>2]|0)==(e|0)){m=9;break}n=h+888+(d[c[b>>2]|0]<<2)|0;o=n;n=o+1|0;p=a[o]|0;if((p|0)==0){p=ar(le[c[h+368>>2]&63](c[h+372>>2]|0,c[b>>2]|0)|0,k)|0;if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}n=k;o=b;c[o>>2]=(c[o>>2]|0)+((d[l+76+(d[c[b>>2]|0]|0)|0]|0)-3)}else{if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}o=b;c[o>>2]=(c[o>>2]|0)+1}while(1){o=n;n=o+1|0;q=a[o]|0;o=f;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;q=p+ -1|0;p=q;if((q|0)==0){continue a}}}if((m|0)==9){i=j;return}}function ir(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+56|0;k=a;a=e;e=f;f=g;g=h;h=k;while(1){if((c[a>>2]|0)==(e|0)){l=8;break}if((c[f>>2]|0)==(g|0)){l=8;break}m=b[h+376+((d[c[a>>2]|0]|0)<<1)>>1]|0;if((m&65535|0)==0){m=(le[c[h+368>>2]&63](c[h+372>>2]|0,c[a>>2]|0)|0)&65535;n=a;c[n>>2]=(c[n>>2]|0)+((d[k+76+(d[c[a>>2]|0]|0)|0]|0)-3)}else{n=a;c[n>>2]=(c[n>>2]|0)+1}n=f;o=c[n>>2]|0;c[n>>2]=o+2;b[o>>1]=m}if((l|0)==8){i=j;return}}function jr(){i=i;return 61224}function kr(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=lr(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=46;c[g+4>>2]=47;c[g+52>>2]=17;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function lr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+24|0;d=a;if((d|0)==0){e=6;f=e;i=b;return f|0}a=0;while(1){if((a|0)>=6){g=8;break}h=a;if((zr(d,c[61128+(a<<2)>>2]|0)|0)!=0){g=6;break}a=h+1|0}if((g|0)==6){e=h;f=e;i=b;return f|0}else if((g|0)==8){e=-1;f=e;i=b;return f|0}return 0}function mr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=xt(59568,a,0,b,c,d)|0;i=e;return f|0}function nr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=xt(59568,a,1,b,c,d)|0;i=e;return f|0}function or(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;i=i+32|0;Ws(60336,b,c,d);i=a;return}function pr(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=qr(34,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function qr(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+128|0;o=n+32|0;p=n+96|0;q=n+104|0;r=n+112|0;s=a;a=b;b=d;c[o>>2]=e;e=f;f=g;g=h;h=j;j=k;k=l;l=m;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[o>>2]=(c[o>>2]|0)+((c[b+68>>2]|0)*5|0);e=e+(0-(c[b+68>>2]<<1))|0;m=(yt(b,c[o>>2]|0,e,q,r,p,o)|0)!=0;if(!(m&(c[q>>2]|0)!=0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}do{if((ue[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,61072)|0)!=0){if((g|0)!=0){c[g>>2]=c[p>>2]}if((h|0)!=0){c[h>>2]=c[o>>2]}if((yt(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}if((a|0)!=0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}else{if((a|0)!=0){break}c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}}while(0);do{if((ue[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,61080)|0)!=0){h=zt(b,c[p>>2]|0,e)|0;do{if(!(97<=(h|0)&(h|0)<=122)){if(65<=(h|0)&(h|0)<=90){break}c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}while(0);if((j|0)!=0){c[j>>2]=c[p>>2]}if((k|0)!=0){c[k>>2]=$d[s&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0)|0}if((yt(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}t=1;u=t;i=n;return u|0}}while(0);do{if((ue[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,61096)|0)!=0){if((a|0)!=0){break}do{if((ue[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,61112)|0)!=0){if((l|0)==0){break}c[l>>2]=1}else{if((ue[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,61120)|0)!=0){if((l|0)==0){break}c[l>>2]=0;break}else{c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}}while(0);while(1){if((At(zt(b,c[o>>2]|0,e)|0)|0)==0){break}c[o>>2]=(c[o>>2]|0)+(c[b+68>>2]|0)}if((c[o>>2]|0)!=(e|0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}}while(0);c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}function rr(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;Sd[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((zr(h,57296)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=lr(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[59568+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function sr(){i=i;return 59200}function tr(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=lr(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=48;c[g+4>>2]=49;c[g+52>>2]=17;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function ur(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=xt(57304,a,0,b,c,d)|0;i=e;return f|0}function vr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=xt(57304,a,1,b,c,d)|0;i=e;return f|0}function wr(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=qr(35,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function xr(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;Sd[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((zr(h,57296)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=lr(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[57304+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function yr(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+40|0;g=cr(b,c,d,e)|0;if((g|0)==0){h=g;i=f;return h|0}a[g+134|0]=23;h=g;i=f;return h|0}function zr(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+40|0;e=b;b=c;while(1){c=e;e=c+1|0;f=a[c]|0;c=b;b=c+1|0;g=a[c]|0;do{if(97<=(f<<24>>24|0)){if((f<<24>>24|0)>122){break}f=(f<<24>>24)+ -32&255}}while(0);do{if(97<=(g<<24>>24|0)){if((g<<24>>24|0)>122){break}g=(g<<24>>24)+ -32&255}}while(0);if((f<<24>>24|0)!=(g<<24>>24|0)){h=9;break}if(!(f<<24>>24!=0)){h=11;break}}if((h|0)==9){j=0;k=j;i=d;return k|0}else if((h|0)==11){j=1;k=j;i=d;return k|0}return 0}function Ar(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Rr(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 13:{k=bs(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 19:{k=ds(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 30:{k=Tr(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Rr(a[g+1|0]|0,a[b]|0)|0}switch(n|0){case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+3|0]|0)!=0){break}if((a[b+2|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 9:{if((b+2|0)!=(e|0)){o=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 10:case 21:{o=25;break};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 24:case 22:{p=18;b=b+2|0;o=77;break};case 29:{g=b;if((c[55760+((d[55504+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){b=g+2|0;p=18;o=77;break a}if((c[55760+((d[57040+(d[g+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=76;break a}b=b+2|0;p=19;o=77;break};case 12:{k=bs(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 23:case 27:case 26:case 25:{p=19;b=b+2|0;o=77;break};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[g]|0)|0]|0}else{q=Rr(a[g+1|0]|0,a[b]|0)|0}switch(q|0){case 15:{k=Zr(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 16:{k=cs(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};default:{o=76}}}while(0);if((o|0)==25){while(1){o=0;b=b+2|0;r=b;if((b|0)==(e|0)){o=32;break}q=b;if((a[r+1|0]|0)==0){s=d[j+76+(d[q]|0)|0]|0}else{s=Rr(a[q+1|0]|0,a[b]|0)|0}if((s|0)==10|(s|0)==21){o=25;continue}else if((s|0)!=9){o=31;break}if((b+2|0)!=(e|0)){o=25}else{o=31;break}}if((o|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((o|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((o|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==77){b:while(1){o=0;if((b|0)==(e|0)){o=126;break}r=b;if((a[b+1|0]|0)==0){t=d[j+76+(d[r]|0)|0]|0}else{t=Rr(a[r+1|0]|0,a[b]|0)|0}switch(t|0){case 6:{o=88;break b;break};case 7:{o=91;break b;break};case 34:{o=116;break b;break};case 33:{o=119;break b;break};case 15:{o=122;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{o=85;break b;break};case 29:{if((c[55760+((d[57040+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=83;break b}break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{o=94;break b;break};case 23:{b=b+2|0;r=p;if((r|0)==41){p=19;o=77;continue b}else if((r|0)!=18){o=77;continue b}if((b|0)==(e|0)){o=97;break b}p=41;r=b;if((a[b+1|0]|0)==0){u=d[j+76+(d[r]|0)|0]|0}else{u=Rr(a[r+1|0]|0,a[b]|0)|0}switch(u|0){case 29:{if((c[55760+((d[57040+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=103;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{o=105;break b;break};case 6:{o=108;break b;break};case 7:{o=111;break b;break};default:{p=19;o=77;continue b}}b=b+2|0;o=77;continue b;break};default:{o=125;break b}}b=b+2|0;o=77}if((o|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==94){c[f>>2]=b;k=p;l=k;i=h;return l|0}else if((o|0)==97){k=-1;l=k;i=h;return l|0}else if((o|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==116){e=b;if((p|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((o|0)==119){e=b;if((p|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((o|0)==122){e=b;if((p|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((o|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==126){k=0-p|0;l=k;i=h;return l|0}}return 0}function Br(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Rr(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 2:{k=Wr(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Rr(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 3:{k=Sr(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=Rr(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+3|0]|0)==0){if((a[b+2|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+5|0]|0)==0){if((a[b+4|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 5:{r=b;if((e-b|0)<2){p=49;break b}b=r+2|0;continue b;break};case 6:{s=b;if((e-b|0)<3){p=52;break b}b=s+3|0;continue b;break};case 7:{t=b;if((e-b|0)<4){p=55;break b}b=t+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Cr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Rr(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Rr(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=Rr(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 6:{r=b;if((e-b|0)<3){p=50;break b}b=r+3|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 5:{s=b;if((e-b|0)<2){p=47;break b}b=s+2|0;continue b;break};case 7:{t=b;if((e-b|0)<4){p=53;break b}b=t+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Dr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[k]|0)|0]|0}else{m=Rr(a[k+1|0]|0,a[b]|0)|0}switch(m|0){case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function Er(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Rr(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 6:{b=b+3|0;continue a;break};case 3:{n=12;break a;break};case 7:{b=b+4|0;continue a;break};case 10:{n=16;break a;break};case 2:{n=15;break a;break};case 21:{n=29;break a;break};case 5:{b=b+2|0;continue a;break};case 9:{n=19;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Sr(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=Rr(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Fr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Rr(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 9:{n=21;break a;break};case 6:{b=b+3|0;continue a;break};case 10:{n=18;break a;break};case 3:{n=12;break a;break};case 7:{b=b+4|0;continue a;break};case 30:{n=15;break a;break};case 5:{b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Sr(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=Tr(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=Rr(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Gr(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b+1|0]|0)==0){h=d[g+76+(d[e]|0)|0]|0}else{h=Rr(a[e+1|0]|0,a[b]|0)|0}switch(h|0){case 5:{break};case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=15;break a}e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=17;break a}else{continue a}break};case 6:{k=8;break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c+1|0]|0)==0){n=d[g+76+(d[k]|0)|0]|0}else{n=Rr(a[k+1|0]|0,a[c]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function Hr(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f+1|0]|0)!=0){h=7;break}if((a[f]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function Ir(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b+1|0]|0)==0){h=d[f+76+(d[g]|0)|0]|0}else{h=Rr(a[g+1|0]|0,a[b]|0)|0}switch(h|0){case 5:{b=b+2|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 7:{b=b+4|0;continue a;break};default:{break a}}}i=e;return b-c|0}function Jr(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b+1|0]|0)==0){g=d[f+76+(d[c]|0)|0]|0}else{g=Rr(a[c+1|0]|0,a[b]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function Kr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[m]|0)|0]|0}else{n=Rr(a[m+1|0]|0,a[b]|0)|0}b:do{switch(n|0){case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b+1|0]|0)==0){o=a[b]|0}else{o=-1}if((o|0)!=32){break}if((a[b+3|0]|0)==0){p=a[b+2|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+3|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=Rr(a[m+1|0]|0,a[b+2|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function Lr(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d+1|0]|0)==0){if((a[d]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d+1|0]|0)==0){f=(a[d]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d+1|0]|0)==0){g=a[d]|0}else{g=-1}h=g;switch(h|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d+1|0]|0)==0){l=(a[d]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d+1|0]|0)==0){m=a[d]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=dr(c)|0;k=j;i=b;return k|0}function Mr(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==3){if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=97){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=109){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}else if((c|0)==4){if((a[e+1|0]|0)==0){h=a[e]|0}else{h=-1}if((h|0)==113){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=117){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else if((h|0)==97){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else{break}}else if((c|0)==2){if((a[e+3|0]|0)!=0){break}if((a[e+2|0]|0)!=116){break}if((a[e+1|0]|0)==0){j=a[e]|0}else{j=-1}if((j|0)==103){f=62;g=f;i=b;return g|0}else if((j|0)==108){f=60;g=f;i=b;return g|0}else{break}}}while(0);f=0;g=f;i=b;return g|0}function Nr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=Rr(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=Rr(a[g+1|0]|0,a[b]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 6:{b=b+3|0;break};case 7:{b=b+4|0;break};case 5:{b=b+2|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function Or(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=Rr(a[g+1|0]|0,a[b]|0)|0}b:do{switch(l|0){case 21:{if((a[b+1|0]|0)!=0){break b}if((a[b]|0)==9){k=9;break a}break};case 22:case 26:{if((a[b+1|0]|0)==0){m=a[b]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b+1|0]|0)==0){n=a[b]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function Pr(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j]|0;m=a[g+1|0]|0;b:do{switch(m&255|0){case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g]|0;n=((l&3)<<4|(a[g+1|0]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function Qr(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2+1|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[(c[k>>2]|0)+1|0]|0)<<8|(d[c[k>>2]|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function Rr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+24|0;a:do{switch(a&255|0){case 223:case 222:case 221:case 220:{d=8;break};case 219:case 218:case 217:case 216:{d=7;break};case 255:{if(!(((b&255)+ -254|0)>>>0<2)){e=6;break a}d=0;break};default:{e=6}}}while(0);if((e|0)==6){d=29}i=c;return d|0}function Sr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Rr(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[55760+((d[55504+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 19:{k=Ur(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Rr(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 5:{n=29;break b;break};case 7:{n=35;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=32;break b;break};case 18:{n=38;break b;break};case 29:{if((c[55760+((d[57040+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Tr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Rr(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[55760+((d[55504+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Rr(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 5:{n=29;break b;break};case 29:{if((c[55760+((d[57040+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 7:{n=35;break b;break};case 18:{n=38;break b;break};case 6:{n=32;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Ur(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=120){break}k=Vr(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Rr(a[g+1|0]|0,a[b]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Rr(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function Vr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=Rr(a[g+1|0]|0,a[b]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Rr(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function Wr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Rr(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 17:{k=_r(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{if((c[55760+((d[55504+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=Zr(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Rr(a[g+1|0]|0,a[b]|0)|0}if((n|0)==27){k=Xr(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=Yr(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[m]|0)|0]|0}else{p=Rr(a[m+1|0]|0,a[b]|0)|0}switch(p|0){case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=Rr(a[m+1|0]|0,a[b]|0)|0}switch(q|0){case 6:{o=62;break b;break};case 29:{if((c[55760+((d[55504+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=57;break b}break};case 7:{o=65;break b;break};case 5:{o=59;break b;break};case 24:case 22:{break};default:{o=68;break b}}b=b+2|0;continue b;break};case 5:{o=39;break b;break};case 11:{o=90;break b;break};case 10:case 9:case 21:{o=69;break b;break};case 7:{o=45;break b;break};case 6:{o=42;break b;break};case 17:{break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[55760+((d[57040+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=37;break b}break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b+1|0]|0)==0){r=d[j+76+(d[q]|0)|0]|0}else{r=Rr(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 6:{o=81;break d;break};case 11:{o=90;break c;break};case 29:{o=75;break d;break};case 7:{o=84;break d;break};case 17:{break c;break};case 24:case 22:{break d;break};case 10:case 9:case 21:{break};case 5:{o=78;break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[55760+((d[55504+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=$r(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function Xr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=Rr(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 8:case 1:case 0:{l=20;break b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b+1|0]|0)!=0){continue b}if((a[b]|0)==45){l=25;break b}else{continue b}break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function Yr(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k+1|0]|0)!=0){l=7;break}if((a[g]|0)!=(a[57704+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function Zr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b+1|0]|0)==0){o=d[k+76+(d[n]|0)|0]|0}else{o=Rr(a[n+1|0]|0,a[b]|0)|0}a:do{switch(o|0){case 29:{if((c[55760+((d[55504+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 24:case 22:{break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=Rr(a[o+1|0]|0,a[b]|0)|0}switch(q|0){case 10:case 9:case 21:{p=37;break b;break};case 15:{p=62;break b;break};case 7:{p=34;break b;break};case 6:{p=31;break b;break};case 29:{if((c[55760+((d[57040+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=26;break b}break};case 5:{p=28;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((as(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b+1|0]|0)==0){r=d[k+76+(d[q]|0)|0]|0}else{r=Rr(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 8:case 1:case 0:{p=54;break c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b+1|0]|0)!=0){continue c}if((a[b]|0)==62){p=59;break c}else{continue c}break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((as(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b+1|0]|0)!=0){break}if((a[b]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function _r(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Rr(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 29:{if((c[55760+((d[55504+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Rr(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=28;break b;break};case 29:{if((c[55760+((d[57040+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 6:{n=31;break b;break};case 11:{n=48;break b;break};case 23:{b=b+2|0;continue b;break};case 7:{n=34;break b;break};case 10:case 9:case 21:{n=37;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Rr(a[o+1|0]|0,a[b]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function $r(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){m=d[k+76+(d[b]|0)|0]|0}else{m=Rr(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b:do{switch(m|0){case 27:case 26:case 25:case 24:case 22:{l=9;break};case 29:{if((c[55760+((d[57040+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 7:{l=16;break a;break};case 5:{l=10;break a;break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){n=d[k+76+(d[b]|0)|0]|0}else{n=Rr(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}switch(n|0){case 24:case 22:{break};case 5:{l=30;break a;break};case 6:{l=33;break a;break};case 29:{if((c[55760+((d[55504+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=28;break a}break};case 7:{l=36;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 6:{l=13;break a;break};case 14:{break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){o=d[k+76+(d[b]|0)|0]|0}else{o=Rr(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){q=d[k+76+(d[p]|0)|0]|0}else{q=Rr(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){s=d[k+76+(d[p]|0)|0]|0}else{s=Rr(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 2:{l=79;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 3:{t=Sr(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 8:case 1:case 0:{l=74;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){u=d[k+76+(d[p]|0)|0]|0}else{u=Rr(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(u|0){case 11:{l=106;break a;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){v=d[k+76+(d[p]|0)|0]|0}else{v=Rr(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(v|0){case 11:{l=106;break a;break};case 6:{l=100;break a;break};case 10:case 9:case 21:{break};case 29:{l=94;break d;break};case 7:{l=103;break a;break};case 5:{l=97;break a;break};case 24:case 22:{break d;break};case 17:{l=107;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[55760+((d[55504+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[(c[j>>2]|0)+1|0]|0)==0){if((a[c[j>>2]|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function as(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g+1|0]|0)==0){k=a[g]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){l=a[g]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){m=a[g]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function bs(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e+1|0]|0)==0){m=d[b+76+(d[h]|0)|0]|0}else{m=Rr(a[h+1|0]|0,a[e]|0)|0}h=m;switch(h|0){case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e+1|0]|0)==0){p=d[b+76+(d[g]|0)|0]|0}else{p=Rr(a[g+1|0]|0,a[e]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function cs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Rr(a[g+1|0]|0,a[b]|0)|0}if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=Rr(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 30:{n=16;break a;break};case 10:case 9:case 21:{break a;break};case 24:case 22:{break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+3|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Rr(a[o+1|0]|0,a[b+2|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==27){k=Xr(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function ds(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Rr(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[55760+((d[55504+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Rr(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 29:{if((c[55760+((d[57040+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 7:{n=34;break b;break};case 5:{n=28;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=31;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function es(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Rr(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Rr(a[g]|0,a[b+1|0]|0)|0}switch(n|0){case 15:{k=Cs(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 16:{k=Hs(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 12:{k=Gs(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 13:{k=Gs(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 9:{if((b+2|0)!=(e|0)){o=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 10:case 21:{o=25;break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){p=d[j+76+(d[g+1|0]|0)|0]|0}else{p=Rr(a[g]|0,a[b+1|0]|0)|0}switch(p|0){case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 29:{g=b;if((c[55760+((d[55504+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){b=g+2|0;q=18;o=77;break a}if((c[55760+((d[57040+(d[g]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=76;break a}b=b+2|0;q=19;o=77;break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{q=19;b=b+2|0;o=77;break};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 24:case 22:{q=18;b=b+2|0;o=77;break};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 19:{k=Is(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+2|0]|0)!=0){break}if((a[b+3|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 30:{k=ws(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{o=76}}}while(0);if((o|0)==25){while(1){o=0;b=b+2|0;r=b;if((b|0)==(e|0)){o=32;break}p=b;if((a[r]|0)==0){s=d[j+76+(d[p+1|0]|0)|0]|0}else{s=Rr(a[p]|0,a[b+1|0]|0)|0}if((s|0)==10|(s|0)==21){o=25;continue}else if((s|0)!=9){o=31;break}if((b+2|0)!=(e|0)){o=25}else{o=31;break}}if((o|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((o|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((o|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==77){b:while(1){o=0;if((b|0)==(e|0)){o=126;break}r=b;if((a[b]|0)==0){t=d[j+76+(d[r+1|0]|0)|0]|0}else{t=Rr(a[r]|0,a[b+1|0]|0)|0}switch(t|0){case 6:{o=88;break b;break};case 5:{o=85;break b;break};case 34:{o=116;break b;break};case 33:{o=119;break b;break};case 15:{o=122;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{o=94;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 23:{b=b+2|0;r=q;if((r|0)==41){q=19;o=77;continue b}else if((r|0)!=18){o=77;continue b}if((b|0)==(e|0)){o=97;break b}q=41;r=b;if((a[b]|0)==0){u=d[j+76+(d[r+1|0]|0)|0]|0}else{u=Rr(a[r]|0,a[b+1|0]|0)|0}switch(u|0){case 27:case 26:case 25:case 24:case 22:{break};case 5:{o=105;break b;break};case 29:{if((c[55760+((d[57040+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=103;break b}break};case 6:{o=108;break b;break};case 7:{o=111;break b;break};default:{q=19;o=77;continue b}}b=b+2|0;o=77;continue b;break};case 7:{o=91;break b;break};case 29:{if((c[55760+((d[57040+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=83;break b}break};default:{o=125;break b}}b=b+2|0;o=77}if((o|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==94){c[f>>2]=b;k=q;l=k;i=h;return l|0}else if((o|0)==97){k=-1;l=k;i=h;return l|0}else if((o|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==116){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((o|0)==119){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((o|0)==122){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((o|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==126){k=0-q|0;l=k;i=h;return l|0}}return 0}function fs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Rr(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Rr(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 3:{k=vs(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 2:{k=zs(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=Rr(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 7:{r=b;if((e-b|0)<4){p=55;break b}b=r+4|0;continue b;break};case 5:{s=b;if((e-b|0)<2){p=49;break b}b=s+2|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=52;break b}b=t+3|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+2|0]|0)==0){if((a[b+3|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+4|0]|0)==0){if((a[b+5|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function gs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Rr(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Rr(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=Rr(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 6:{r=b;if((e-b|0)<3){p=50;break b}b=r+3|0;continue b;break};case 5:{s=b;if((e-b|0)<2){p=47;break b}b=s+2|0;continue b;break};case 7:{t=b;if((e-b|0)<4){p=53;break b}b=t+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function hs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b]|0)==0){m=d[j+76+(d[k+1|0]|0)|0]|0}else{m=Rr(a[k]|0,a[b+1|0]|0)|0}switch(m|0){case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function is(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Rr(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 6:{b=b+3|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 3:{n=12;break a;break};case 2:{n=15;break a;break};case 7:{b=b+4|0;continue a;break};case 21:{n=29;break a;break};case 10:{n=16;break a;break};case 9:{n=19;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=vs(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=Rr(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function js(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Rr(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 6:{b=b+3|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 3:{n=12;break a;break};case 30:{n=15;break a;break};case 7:{b=b+4|0;continue a;break};case 10:{n=18;break a;break};case 9:{n=21;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=vs(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=ws(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=Rr(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function ks(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b]|0)==0){h=d[g+76+(d[e+1|0]|0)|0]|0}else{h=Rr(a[e]|0,a[b+1|0]|0)|0}switch(h|0){case 5:{break};case 6:{j=8;break};case 7:{e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=7;break a}else{j=8}break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{k=c;c=k+1|0;e=b;b=e+1|0;if((a[k]|0)!=(a[e]|0)){j=15;break a}e=c;c=e+1|0;k=b;b=k+1|0;if((a[e]|0)!=(a[k]|0)){j=17;break a}else{continue a}break};default:{j=18;break a}}if((j|0)==8){j=0;k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=9;break}}e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=11;break}k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=13;break}}if((j|0)==7){l=0;m=l;i=f;return m|0}else if((j|0)==9){l=0;m=l;i=f;return m|0}else if((j|0)==11){l=0;m=l;i=f;return m|0}else if((j|0)==13){l=0;m=l;i=f;return m|0}else if((j|0)==15){l=0;m=l;i=f;return m|0}else if((j|0)==17){l=0;m=l;i=f;return m|0}else if((j|0)==18){j=c;if((a[c]|0)==0){n=d[g+76+(d[j+1|0]|0)|0]|0}else{n=Rr(a[j]|0,a[c+1|0]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function ls(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f]|0)!=0){h=7;break}if((a[f+1|0]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function ms(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b]|0)==0){h=d[f+76+(d[g+1|0]|0)|0]|0}else{h=Rr(a[g]|0,a[b+1|0]|0)|0}switch(h|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function ns(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b]|0)==0){g=d[f+76+(d[c+1|0]|0)|0]|0}else{g=Rr(a[c]|0,a[b+1|0]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function os(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b]|0)==0){n=d[j+76+(d[m+1|0]|0)|0]|0}else{n=Rr(a[m]|0,a[b+1|0]|0)|0}b:do{switch(n|0){case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 17:case 11:{if((g|0)!=2){break a}break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)==0){o=a[b+1|0]|0}else{o=-1}if((o|0)!=32){break}if((a[b+2|0]|0)==0){p=a[b+3|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+2|0]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=Rr(a[m]|0,a[b+3|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function ps(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d]|0)==0){if((a[d+1|0]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d]|0)==0){f=(a[d+1|0]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d]|0)==0){g=a[d+1|0]|0}else{g=-1}h=g;switch(h|0){case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d]|0)==0){l=(a[d+1|0]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d]|0)==0){m=a[d+1|0]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=dr(c)|0;k=j;i=b;return k|0}function qs(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==4){if((a[e]|0)==0){f=a[e+1|0]|0}else{f=-1}if((f|0)==97){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=115){break}g=39;h=g;i=b;return h|0}else if((f|0)==113){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=117){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=116){break}g=34;h=g;i=b;return h|0}else{break}}else if((c|0)==2){if((a[e+2|0]|0)!=0){break}if((a[e+3|0]|0)!=116){break}if((a[e]|0)==0){j=a[e+1|0]|0}else{j=-1}if((j|0)==108){g=60;h=g;i=b;return h|0}else if((j|0)==103){g=62;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=97){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=109){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}g=38;h=g;i=b;return h|0}}while(0);g=0;h=g;i=b;return h|0}function rs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=Rr(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=Rr(a[g]|0,a[b+1|0]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 7:{b=b+4|0;break};case 5:{b=b+2|0;break};case 6:{b=b+3|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function ss(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=Rr(a[g]|0,a[b+1|0]|0)|0}b:do{switch(l|0){case 22:case 26:{if((a[b]|0)==0){m=a[b+1|0]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 21:{if((a[b]|0)!=0){break b}if((a[b+1|0]|0)==9){k=9;break a}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b]|0)==0){n=a[b+1|0]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function ts(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j+1|0]|0;m=a[g]|0;b:do{switch(m&255|0){case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g+1|0]|0;n=((l&3)<<4|(a[g]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function us(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[c[k>>2]|0]|0)<<8|(d[(c[k>>2]|0)+1|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function vs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Rr(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=xs(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[55760+((d[55504+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Rr(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[55760+((d[57040+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 6:{n=32;break b;break};case 5:{n=29;break b;break};case 7:{n=35;break b;break};case 18:{n=38;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}



function we(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function xe(){return i|0}function ye(a){a=a|0;i=a}function ze(a,b){a=a|0;b=b|0;if((u|0)==0){u=a;v=b}}function Ae(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function Be(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function Ce(a){a=a|0;J=a}function De(a){a=a|0;K=a}function Ee(a){a=a|0;L=a}function Fe(a){a=a|0;M=a}function Ge(a){a=a|0;N=a}function He(a){a=a|0;O=a}function Ie(a){a=a|0;P=a}function Je(a){a=a|0;Q=a}function Ke(a){a=a|0;R=a}function Le(a){a=a|0;S=a}function Me(a){a=a|0;var b=0,d=0;b=i;ty(a)|0;d=a+540|0;Yd[c[(c[d>>2]|0)+40>>2]&127](a)|0;Yd[c[(c[d>>2]|0)+28>>2]&127](a)|0;Yd[c[(c[d>>2]|0)+32>>2]&127](a)|0;Yd[c[(c[d>>2]|0)+48>>2]&127](a)|0;Yd[c[(c[d>>2]|0)+52>>2]&127](a)|0;nx(a);i=b;return}function Ne(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+24|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[v>>2]=0;y=b+240|0;z=d;h[z>>3]=+h[y>>3];if((c[2]|0)==0){A=0}else{B=c[b+88>>2]|0;C=bZ(B|0)|0;D=zY(C+11|0)|0;mZ(D|0,B|0,C|0)|0;B=D+C+0|0;C=16|0;E=B+11|0;do{a[B]=a[C]|0;B=B+1|0;C=C+1|0}while((B|0)<(E|0));C=ec(D|0,32)|0;if((C|0)==0){B=Kd(c[(Ic()|0)>>2]|0)|0;c[u>>2]=D;c[u+4>>2]=B;Nu(23,0,40,u);Sc(0)|0;F=0}else{F=C}AY(D);A=F}F=b+248|0;D=b+536|0;C=b;u=b+4|0;B=d+36|0;E=d+16|0;G=b+256|0;H=d+8|0;I=d+24|0;J=d+32|0;K=b+540|0;L=d+48|0;M=c[t>>2]|0;N=v;O=w;P=b+64|0;Q=b+72|0;R=x;S=0;T=A;while(1){if(!(+h[z>>3]<+h[F>>3])){U=T;V=0;break}pe[c[64716>>2]&7]()|0;c[(c[D>>2]|0)+84>>2]=1;if((c[2]|0)!=0){if(((c[Q>>2]|0)+(c[P>>2]|0)|0)>0){A=0;do{Rv(A+9|0);A=A+1|0;}while((A|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0))}Rv(2);Qv(2)}Fv(c[C>>2]|0,1,c[u>>2]|0);if((c[B>>2]|0)==1){A=s;h[k>>3]=+h[z>>3]- +h[E>>3];c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Lu(23,0,104,s);W=S}else{W=S+1|0}X=+h[y>>3];h[H>>3]=X+ +(W>>>0)*(+h[F>>3]-X)/+(c[G>>2]|0)- +h[z>>3];ax(b,d);X=+h[z>>3];Y=+h[H>>3];A=r;h[k>>3]=X;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+8|0;h[k>>3]=X+Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+16|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Lu(23,1,144,r);Z=by(b,d)|0;if((c[I>>2]|0)==5){U=T;V=0;break}Me(b);ox(b);if((c[64020>>2]|0)!=0){Vd[c[16120]&511](23)}if((c[2]|0)!=0){Qv(4)}A=cx(b,c[J>>2]|0,z,d)|0;if((A|0)>0){c[(c[D>>2]|0)+84>>2]=4;Y=+h[z>>3];c[q>>2]=(A|0)==1?224:232;A=q+4|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Lu(7,1,200,q);if((c[118324>>2]|0)==0){Wd[c[103060>>2]&63](103040,b)}ex(b,c[J>>2]|0,z,d);if((c[63956>>2]|0)!=0){Vd[c[16120]&511](7)}c[(c[D>>2]|0)+84>>2]=1;c[B>>2]=1;sx(b)}else{h[E>>3]=+h[z>>3];c[B>>2]=0}if((c[2]|0)!=0){Tv(4)}if((ny(b,1,1)|0)!=0){c[B>>2]=1;sx(b)}Yd[c[(c[K>>2]|0)+88>>2]&127](b)|0;nx(b);wx(b);ox(b);do{if((T|0)==0){_=0}else{Qv(7);Tv(2);A=(mc(N|0,4,1,T|0)|0)==1;c[v>>2]=(c[v>>2]|0)+1;do{if(A){$=(mc(c[c[u>>2]>>2]|0,8,1,T|0)|0)==1;h[w>>3]=+Lv(2);if(!$){aa=0;break}aa=(mc(O|0,8,1,T|0)|0)==1|0}else{h[w>>3]=+Lv(2);aa=0}}while(0);A=c[P>>2]|0;$=c[Q>>2]|0;if(($+A|0)>0){ba=aa;ca=0;while(1){c[x>>2]=Gv(ca+9|0)|0;if((ba|0)==0){da=0}else{da=(mc(R|0,4,1,T|0)|0)==1|0}ea=ca+1|0;fa=c[P>>2]|0;ga=c[Q>>2]|0;if((ea|0)<(ga+fa|0)){ba=da;ca=ea}else{ha=ga;ia=fa;ja=da;break}}}else{ha=$;ia=A;ja=aa}if((ha+ia|0)>0){ca=ja;ba=0;while(1){h[w>>3]=+Lv(ba+9|0);if((ca|0)==0){ka=0}else{ka=(mc(O|0,8,1,T|0)|0)==1|0}fa=ba+1|0;if((fa|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0)){ca=ka;ba=fa}else{la=ka;break}}}else{la=ja}Tv(7);if((la|0)!=0){_=T;break}c[p>>2]=Kd(c[(Ic()|0)>>2]|0)|0;Nu(23,0,240,p);Sc(T|0)|0;_=0}}while(0);if((c[118324>>2]|0)==0){ma=47}else{ba=c[B>>2]|0;if((ba|0)==0){ma=47}else{na=ba}}if((ma|0)==47){ma=0;Wd[c[103060>>2]&63](103040,b);na=c[B>>2]|0}do{if((na|0)==1){if((c[I>>2]|0)!=3){break}ba=c[L>>2]|0;ca=c[ba+8>>2]|0;A=c[ba+4>>2]|0;c[A>>2]=(c[A>>2]|0)+(c[ca>>2]|0);ba=A+4|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+4>>2]|0);ba=A+8|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+8>>2]|0);ba=A+12|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+12>>2]|0);ba=A+16|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+16>>2]|0)}}while(0);if((c[27160]|0)!=0){ca=f;ba=108648;c[ca+0>>2]=c[ba+0>>2];c[ca+4>>2]=c[ba+4>>2];c[ca+8>>2]=c[ba+8>>2];c[ca+12>>2]=c[ba+12>>2];c[ca+16>>2]=c[ba+16>>2];c[ca+20>>2]=c[ba+20>>2];Du(M,f);Gd(10,M|0)|0;ba=c[27168]|0;ca=o;h[k>>3]=+h[c[c[u>>2]>>2]>>3];c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];c[o+8>>2]=ba;Lu(1,0,320,o);h[F>>3]=+h[z>>3]}if((Z|0)!=0){ma=57;break}if((Yx(b,0)|0)!=0){ma=58;break}if((Rx(b,0)|0)!=0){ma=58;break}if((Ix(b,0)|0)==0){S=W;T=_}else{ma=58;break}}do{if((ma|0)==57){T=n;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Lu(1,0,376,n);U=_;V=Z+ -1|0}else if((ma|0)==58){if((Yx(b,0)|0)!=0){T=m;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Lu(1,0,448,m);U=_;V=-2;break}if((Rx(b,0)|0)!=0){T=l;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Lu(1,0,536,l);U=_;V=-3;break}T=(Ix(b,0)|0)==0;Y=+h[z>>3];if(T){T=g;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Lu(1,0,712,g);U=_;V=-1;break}else{T=j;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Lu(1,0,624,j);U=_;V=-3;break}}}while(0);if((U|0)==0){i=e;return V|0}Sc(U|0)|0;i=e;return V|0}function Oe(a){a=a|0;i=i;return 0}function Pe(a){a=a|0;i=i;return 0}function Qe(a){a=a|0;i=i;return 0}function Re(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8>>3]=0.0;i=i;return}function Se(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+16>>2]=c[(c[a+404>>2]|0)+436>>2];i=i;return}function Te(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;d=a+4|0;e=+h[(c[a+416>>2]|0)+32>>3];f=Qu(864,(Fx(+_w(a,1,+(c[(c[a+404>>2]|0)+40>>2]|0),+h[c[c[d>>2]>>2]>>3],e,e),0,a)|0)+ -1|0)|0;c[c[(c[c[d>>2]>>2]|0)+12>>2]>>2]=f;i=b;return}function Ue(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+416|0;if((Dx(+h[(c[e>>2]|0)+32>>3],0.0)|0)<<24>>24==0){f=(c[b+404>>2]|0)+40|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+8|0;u=t;c[u>>2]=g;i=d;return}do{if((a[b+314|0]|0)==0){v=a[c[b+356>>2]|0]|0}else{w=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(w){x=a[c[b+356>>2]|0]|0;y=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+32>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=y;v=x;break}else{x=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+32>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=x;v=x;break}}else{if(w){w=a[c[b+356>>2]|0]|0;x=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+32>>3])|0;a[c[b+352>>2]|0]=x;v=w;break}else{w=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+32>>3])|0;a[c[b+352>>2]|0]=w;v=w;break}}}}while(0);if(v<<24>>24==0){f=(c[b+420>>2]|0)+48|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+8|0;u=t;c[u>>2]=g;i=d;return}else{f=c[(c[c[b+4>>2]>>2]|0)+12>>2]|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+8|0;u=t;c[u>>2]=g;i=d;return}}function Ve(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(880,(c[a+16>>2]|0)+ -1|0,(c[a+8>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+4>>2]=e;i=b;return}function We(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(896,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+4>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+12>>2]=a;i=b;return}function Xe(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+36>>2]=c[(c[a+404>>2]|0)+52>>2];i=i;return}function Ye(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;d=a+4|0;e=+h[(c[a+416>>2]|0)+16>>3];f=Qu(864,(Fx(+_w(a,0,+(c[(c[a+404>>2]|0)+408>>2]|0),+h[c[c[d>>2]>>2]>>3],e,e),1,a)|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+20>>2]=f;i=b;return}function Ze(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+416|0;if((Dx(+h[(c[e>>2]|0)+16>>3],0.0)|0)<<24>>24==0){f=(c[b+404>>2]|0)+408|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+28|0;u=t;c[u>>2]=g;i=d;return}do{if((a[b+314|0]|0)==0){v=a[(c[b+356>>2]|0)+1|0]|0}else{w=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(w){x=a[(c[b+356>>2]|0)+1|0]|0;y=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+16>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=y;v=x;break}else{x=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+16>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=x;v=x;break}}else{if(w){w=a[(c[b+356>>2]|0)+1|0]|0;x=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+16>>3])|0;a[(c[b+352>>2]|0)+1|0]=x;v=w;break}else{w=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+16>>3])|0;a[(c[b+352>>2]|0)+1|0]=w;v=w;break}}}}while(0);if(v<<24>>24==0){f=(c[b+420>>2]|0)+32|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+28|0;u=t;c[u>>2]=g;i=d;return}else{f=(c[(c[c[b+4>>2]>>2]|0)+12>>2]|0)+20|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+28|0;u=t;c[u>>2]=g;i=d;return}}function _e(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(880,(c[a+36>>2]|0)+ -1|0,(c[a+28>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+24>>2]=e;i=b;return}function $e(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(896,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+24>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+32>>2]=a;i=b;return}function af(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+68>>2]=c[(c[a+404>>2]|0)+444>>2];i=i;return}function bf(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+56>>2]=c[(c[a+404>>2]|0)+420>>2];i=i;return}function cf(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+40>>2]=c[(c[a+404>>2]|0)+48>>2];i=i;return}function df(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+56>>2]|0)+ -1|0,(c[a+40>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+52>>2]=e;i=b;return}function ef(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+60>>2]=c[(c[a+404>>2]|0)+12>>2];i=i;return}function ff(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(880,(c[a+60>>2]|0)+ -1|0,(c[a+68>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+44>>2]=e;i=b;return}function gf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(896,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+44>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+48>>2]=a;i=b;return}function hf(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+56>>2]|0)+ -1|0,(c[a+60>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+64>>2]=e;i=b;return}function jf(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+88>>2]=c[(c[a+404>>2]|0)+396>>2];i=i;return}function kf(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;d=a+4|0;e=+h[(c[a+416>>2]|0)+72>>3];f=Qu(864,(Fx(+_w(a,3,+(c[(c[a+404>>2]|0)+112>>2]|0),+h[c[c[d>>2]>>2]>>3],e,e),2,a)|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+72>>2]=f;i=b;return}function lf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+416|0;if((Dx(+h[(c[e>>2]|0)+72>>3],0.0)|0)<<24>>24==0){f=(c[b+404>>2]|0)+112|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+80|0;u=t;c[u>>2]=g;i=d;return}do{if((a[b+314|0]|0)==0){v=a[(c[b+356>>2]|0)+2|0]|0}else{w=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(w){x=a[(c[b+356>>2]|0)+2|0]|0;y=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+72>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=y;v=x;break}else{x=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+72>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=x;v=x;break}}else{if(w){w=a[(c[b+356>>2]|0)+2|0]|0;x=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+72>>3])|0;a[(c[b+352>>2]|0)+2|0]=x;v=w;break}else{w=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+72>>3])|0;a[(c[b+352>>2]|0)+2|0]=w;v=w;break}}}}while(0);if(v<<24>>24==0){f=(c[b+420>>2]|0)+100|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+80|0;u=t;c[u>>2]=g;i=d;return}else{f=(c[(c[c[b+4>>2]>>2]|0)+12>>2]|0)+72|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+80|0;u=t;c[u>>2]=g;i=d;return}}function mf(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(880,(c[a+88>>2]|0)+ -1|0,(c[a+80>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+76>>2]=e;i=b;return}function nf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(896,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+76>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+84>>2]=a;i=b;return}function of(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+108>>2]=c[(c[a+404>>2]|0)+124>>2];i=i;return}function pf(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;d=a+4|0;e=+h[(c[a+416>>2]|0)+56>>3];f=Qu(864,(Fx(+_w(a,2,+(c[(c[a+404>>2]|0)+368>>2]|0),+h[c[c[d>>2]>>2]>>3],e,e),3,a)|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+92>>2]=f;i=b;return}function qf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+416|0;if((Dx(+h[(c[e>>2]|0)+56>>3],0.0)|0)<<24>>24==0){f=(c[b+404>>2]|0)+368|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+100|0;u=t;c[u>>2]=g;i=d;return}do{if((a[b+314|0]|0)==0){v=a[(c[b+356>>2]|0)+3|0]|0}else{w=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(w){x=a[(c[b+356>>2]|0)+3|0]|0;y=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+56>>3],a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=y;v=x;break}else{x=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+56>>3],a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=x;v=x;break}}else{if(w){w=a[(c[b+356>>2]|0)+3|0]|0;x=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+56>>3])|0;a[(c[b+352>>2]|0)+3|0]=x;v=w;break}else{w=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+56>>3])|0;a[(c[b+352>>2]|0)+3|0]=w;v=w;break}}}}while(0);if(v<<24>>24==0){f=(c[b+420>>2]|0)+84|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+100|0;u=t;c[u>>2]=g;i=d;return}else{f=(c[(c[c[b+4>>2]>>2]|0)+12>>2]|0)+92|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+100|0;u=t;c[u>>2]=g;i=d;return}}function rf(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(880,(c[a+108>>2]|0)+ -1|0,(c[a+100>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+96>>2]=e;i=b;return}function sf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(896,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+96>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+104>>2]=a;i=b;return}function tf(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+140>>2]=c[(c[a+404>>2]|0)+404>>2];i=i;return}function uf(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+128>>2]=c[(c[a+404>>2]|0)+380>>2];i=i;return}function vf(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+112>>2]=c[(c[a+404>>2]|0)+120>>2];i=i;return}function wf(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+128>>2]|0)+ -1|0,(c[a+112>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+124>>2]=e;i=b;return}function xf(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+132>>2]=c[(c[a+404>>2]|0)+84>>2];i=i;return}function yf(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(880,(c[a+132>>2]|0)+ -1|0,(c[a+140>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+116>>2]=e;i=b;return}function zf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(896,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+116>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+120>>2]=a;i=b;return}function Af(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+128>>2]|0)+ -1|0,(c[a+132>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+136>>2]=e;i=b;return}function Bf(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+160>>2]=c[(c[a+404>>2]|0)+356>>2];i=i;return}function Cf(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;d=a+4|0;e=+h[(c[a+416>>2]|0)+112>>3];f=Qu(864,(Fx(+_w(a,5,+(c[(c[a+404>>2]|0)+184>>2]|0),+h[c[c[d>>2]>>2]>>3],e,e),4,a)|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+144>>2]=f;i=b;return}function Df(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+416|0;if((Dx(+h[(c[e>>2]|0)+112>>3],0.0)|0)<<24>>24==0){f=(c[b+404>>2]|0)+184|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+152|0;u=t;c[u>>2]=g;i=d;return}do{if((a[b+314|0]|0)==0){v=a[(c[b+356>>2]|0)+4|0]|0}else{w=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(w){x=a[(c[b+356>>2]|0)+4|0]|0;y=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+112>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=y;v=x;break}else{x=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+112>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=x;v=x;break}}else{if(w){w=a[(c[b+356>>2]|0)+4|0]|0;x=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+112>>3])|0;a[(c[b+352>>2]|0)+4|0]=x;v=w;break}else{w=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+112>>3])|0;a[(c[b+352>>2]|0)+4|0]=w;v=w;break}}}}while(0);if(v<<24>>24==0){f=(c[b+420>>2]|0)+152|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+152|0;u=t;c[u>>2]=g;i=d;return}else{f=(c[(c[c[b+4>>2]>>2]|0)+12>>2]|0)+144|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+152|0;u=t;c[u>>2]=g;i=d;return}}function Ef(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(880,(c[a+160>>2]|0)+ -1|0,(c[a+152>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+148>>2]=e;i=b;return}function Ff(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(896,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+148>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+156>>2]=a;i=b;return}function Gf(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+180>>2]=c[(c[a+404>>2]|0)+196>>2];i=i;return}function Hf(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;d=a+4|0;e=+h[(c[a+416>>2]|0)+96>>3];f=Qu(864,(Fx(+_w(a,4,+(c[(c[a+404>>2]|0)+328>>2]|0),+h[c[c[d>>2]>>2]>>3],e,e),5,a)|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+164>>2]=f;i=b;return}function If(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+416|0;if((Dx(+h[(c[e>>2]|0)+96>>3],0.0)|0)<<24>>24==0){f=(c[b+404>>2]|0)+328|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+172|0;u=t;c[u>>2]=g;i=d;return}do{if((a[b+314|0]|0)==0){v=a[(c[b+356>>2]|0)+5|0]|0}else{w=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(w){x=a[(c[b+356>>2]|0)+5|0]|0;y=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+96>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=y;v=x;break}else{x=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+96>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=x;v=x;break}}else{if(w){w=a[(c[b+356>>2]|0)+5|0]|0;x=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+96>>3])|0;a[(c[b+352>>2]|0)+5|0]=x;v=w;break}else{w=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+96>>3])|0;a[(c[b+352>>2]|0)+5|0]=w;v=w;break}}}}while(0);if(v<<24>>24==0){f=(c[b+420>>2]|0)+136|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+172|0;u=t;c[u>>2]=g;i=d;return}else{f=(c[(c[c[b+4>>2]>>2]|0)+12>>2]|0)+164|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+172|0;u=t;c[u>>2]=g;i=d;return}}function Jf(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(880,(c[a+180>>2]|0)+ -1|0,(c[a+172>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+168>>2]=e;i=b;return}function Kf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(896,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+168>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+176>>2]=a;i=b;return}function Lf(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+212>>2]=c[(c[a+404>>2]|0)+364>>2];i=i;return}function Mf(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+200>>2]=c[(c[a+404>>2]|0)+340>>2];i=i;return}function Nf(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+184>>2]=c[(c[a+404>>2]|0)+192>>2];i=i;return}function Of(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+200>>2]|0)+ -1|0,(c[a+184>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+196>>2]=e;i=b;return}function Pf(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+204>>2]=c[(c[a+404>>2]|0)+156>>2];i=i;return}function Qf(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(880,(c[a+204>>2]|0)+ -1|0,(c[a+212>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+188>>2]=e;i=b;return}function Rf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(896,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+188>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+192>>2]=a;i=b;return}function Sf(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+200>>2]|0)+ -1|0,(c[a+204>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+208>>2]=e;i=b;return}function Tf(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+232>>2]=c[(c[a+404>>2]|0)+316>>2];i=i;return}function Uf(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;d=a+4|0;e=+h[(c[a+416>>2]|0)+152>>3];f=Qu(864,(Fx(+_w(a,7,+(c[(c[a+404>>2]|0)+256>>2]|0),+h[c[c[d>>2]>>2]>>3],e,e),6,a)|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+216>>2]=f;i=b;return}function Vf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+416|0;if((Dx(+h[(c[e>>2]|0)+152>>3],0.0)|0)<<24>>24==0){f=(c[b+404>>2]|0)+256|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+224|0;u=t;c[u>>2]=g;i=d;return}do{if((a[b+314|0]|0)==0){v=a[(c[b+356>>2]|0)+6|0]|0}else{w=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(w){x=a[(c[b+356>>2]|0)+6|0]|0;y=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+152>>3],a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=y;v=x;break}else{x=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+152>>3],a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=x;v=x;break}}else{if(w){w=a[(c[b+356>>2]|0)+6|0]|0;x=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+152>>3])|0;a[(c[b+352>>2]|0)+6|0]=x;v=w;break}else{w=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+152>>3])|0;a[(c[b+352>>2]|0)+6|0]=w;v=w;break}}}}while(0);if(v<<24>>24==0){f=(c[b+420>>2]|0)+204|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+224|0;u=t;c[u>>2]=g;i=d;return}else{f=(c[(c[c[b+4>>2]>>2]|0)+12>>2]|0)+216|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+224|0;u=t;c[u>>2]=g;i=d;return}}function Wf(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(880,(c[a+232>>2]|0)+ -1|0,(c[a+224>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+220>>2]=e;i=b;return}function Xf(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(896,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+220>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+228>>2]=a;i=b;return}function Yf(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+252>>2]=c[(c[a+404>>2]|0)+268>>2];i=i;return}function Zf(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;d=a+4|0;e=+h[(c[a+416>>2]|0)+136>>3];f=Qu(864,(Fx(+_w(a,6,+(c[(c[a+404>>2]|0)+288>>2]|0),+h[c[c[d>>2]>>2]>>3],e,e),7,a)|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+236>>2]=f;i=b;return}function _f(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+416|0;if((Dx(+h[(c[e>>2]|0)+136>>3],0.0)|0)<<24>>24==0){f=(c[b+404>>2]|0)+288|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+244|0;u=t;c[u>>2]=g;i=d;return}do{if((a[b+314|0]|0)==0){v=a[(c[b+356>>2]|0)+7|0]|0}else{w=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(w){x=a[(c[b+356>>2]|0)+7|0]|0;y=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+136>>3],a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=y;v=x;break}else{x=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+136>>3],a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=x;v=x;break}}else{if(w){w=a[(c[b+356>>2]|0)+7|0]|0;x=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+136>>3])|0;a[(c[b+352>>2]|0)+7|0]=x;v=w;break}else{w=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+136>>3])|0;a[(c[b+352>>2]|0)+7|0]=w;v=w;break}}}}while(0);if(v<<24>>24==0){f=(c[b+420>>2]|0)+188|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+244|0;u=t;c[u>>2]=g;i=d;return}else{f=(c[(c[c[b+4>>2]>>2]|0)+12>>2]|0)+236|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+244|0;u=t;c[u>>2]=g;i=d;return}}function $f(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(880,(c[a+252>>2]|0)+ -1|0,(c[a+244>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+240>>2]=e;i=b;return}function ag(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(896,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+240>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+248>>2]=a;i=b;return}function bg(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+284>>2]=c[(c[a+404>>2]|0)+324>>2];i=i;return}function cg(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+272>>2]=c[(c[a+404>>2]|0)+300>>2];i=i;return}function dg(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+256>>2]=c[(c[a+404>>2]|0)+264>>2];i=i;return}function eg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+272>>2]|0)+ -1|0,(c[a+256>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+268>>2]=e;i=b;return}function fg(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+276>>2]=c[(c[a+404>>2]|0)+228>>2];i=i;return}function gg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(880,(c[a+276>>2]|0)+ -1|0,(c[a+284>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+260>>2]=e;i=b;return}function hg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(896,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+260>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+264>>2]=a;i=b;return}function ig(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+272>>2]|0)+ -1|0,(c[a+276>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+280>>2]=e;i=b;return}function jg(b){b=b|0;a[c[(c[c[b+4>>2]>>2]|0)+16>>2]|0]=a[c[b+340>>2]|0]|0;i=i;return}function kg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;c[(c[f+12>>2]|0)+448>>2]=c[(c[b+404>>2]|0)+448>>2];do{if((a[b+314|0]|0)==0){g=a[(c[b+356>>2]|0)+10|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){k=a[(c[b+356>>2]|0)+10|0]|0;l=Bx(+h[f>>3],+h[(c[b+416>>2]|0)+160>>3],a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=l;g=k;break}else{k=Bx(+h[f>>3],+h[(c[b+416>>2]|0)+160>>3],a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=k;g=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+10|0]|0;k=Ex(+h[f>>3],+h[(c[b+416>>2]|0)+160>>3])|0;a[(c[b+352>>2]|0)+10|0]=k;g=j;break}else{j=Ex(+h[f>>3],+h[(c[b+416>>2]|0)+160>>3])|0;a[(c[b+352>>2]|0)+10|0]=j;g=j;break}}}}while(0);f=c[b+420>>2]|0;if(g<<24>>24==0){c[(c[(c[c[e>>2]>>2]|0)+12>>2]|0)+448>>2]=c[f+208>>2];i=d;return}else{c[(c[(c[c[e>>2]>>2]|0)+12>>2]|0)+448>>2]=c[f+212>>2];i=d;return}}function lg(b){b=b|0;var d=0,e=0;d=i;if((a[b+312|0]|0)!=0){h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+48>>3]=+h[(c[b+400>>2]|0)+48>>3];i=d;return}e=c[c[b+4>>2]>>2]|0;do{if((a[c[e+16>>2]|0]|0)!=0){if((a[c[b+408>>2]|0]|0)!=0){break}h[(c[e+8>>2]|0)+48>>3]=+h[e>>3];i=d;return}}while(0);h[(c[e+8>>2]|0)+48>>3]=+h[(c[b+400>>2]|0)+48>>3];i=d;return}function mg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+4|0;f=Ex(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+168>>3])|0;do{if((a[b+314|0]|0)==0){g=a[(c[b+356>>2]|0)+9|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){k=a[(c[b+356>>2]|0)+9|0]|0;l=c[c[e>>2]>>2]|0;m=c[l+8>>2]|0;n=Bx(+h[l>>3],+h[m+48>>3]+ +h[m+56>>3],a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=n;g=k;break}else{k=c[c[e>>2]>>2]|0;n=c[k+8>>2]|0;m=Bx(+h[k>>3],+h[n+48>>3]+ +h[n+56>>3],a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=m;g=m;break}}else{if(j){j=a[(c[b+356>>2]|0)+9|0]|0;m=c[c[e>>2]>>2]|0;n=c[m+8>>2]|0;k=Ex(+h[m>>3],+h[n+48>>3]+ +h[n+56>>3])|0;a[(c[b+352>>2]|0)+9|0]=k;g=j;break}else{j=c[c[e>>2]>>2]|0;k=c[j+8>>2]|0;n=Ex(+h[j>>3],+h[k+48>>3]+ +h[k+56>>3])|0;a[(c[b+352>>2]|0)+9|0]=n;g=n;break}}}}while(0);if(f<<24>>24==0){o=3;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+452|0;x=w;c[x>>2]=o;i=d;return}o=g<<24>>24!=0?3:4;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+452|0;x=w;c[x>>2]=o;i=d;return}function ng(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+452>>2]|0)+ -1|0,(c[a+448>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+440>>2]=e;i=b;return}function og(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+424>>2]=c[(c[a+404>>2]|0)+64>>2];i=i;return}function pg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(896,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+452>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+420>>2]=a;i=b;return}function qg(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+408>>2]=c[(c[a+404>>2]|0)+416>>2];i=i;return}function rg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+440>>2]|0)+ -1|0,(c[a+408>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+444>>2]=e;i=b;return}function sg(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+432>>2]=c[(c[a+404>>2]|0)+32>>2];i=i;return}function tg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(880,(c[a+432>>2]|0)+ -1|0,(c[a+424>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+412>>2]=e;i=b;return}function ug(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(896,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+412>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+416>>2]=a;i=b;return}function vg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+432>>2]|0)+ -1|0,(c[a+448>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+428>>2]=e;i=b;return}function wg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+428>>2]|0)+ -1|0,(c[a+452>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+436>>2]=e;i=b;return}function xg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+408>>2]|0)+ -1|0,(c[a+448>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+400>>2]=e;i=b;return}function yg(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+384>>2]=c[(c[a+404>>2]|0)+136>>2];i=i;return}function zg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(896,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+408>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+380>>2]=a;i=b;return}function Ag(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+368>>2]=c[(c[a+404>>2]|0)+376>>2];i=i;return}function Bg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+400>>2]|0)+ -1|0,(c[a+368>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+404>>2]=e;i=b;return}function Cg(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+392>>2]=c[(c[a+404>>2]|0)+104>>2];i=i;return}function Dg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(880,(c[a+392>>2]|0)+ -1|0,(c[a+384>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+372>>2]=e;i=b;return}function Eg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(896,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+372>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+376>>2]=a;i=b;return}function Fg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+392>>2]|0)+ -1|0,(c[a+448>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+388>>2]=e;i=b;return}function Gg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+388>>2]|0)+ -1|0,(c[a+408>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+396>>2]=e;i=b;return}function Hg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+368>>2]|0)+ -1|0,(c[a+448>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+360>>2]=e;i=b;return}function Ig(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+344>>2]=c[(c[a+404>>2]|0)+208>>2];i=i;return}function Jg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(896,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+368>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+340>>2]=a;i=b;return}function Kg(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+328>>2]=c[(c[a+404>>2]|0)+336>>2];i=i;return}function Lg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+360>>2]|0)+ -1|0,(c[a+328>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+364>>2]=e;i=b;return}function Mg(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+352>>2]=c[(c[a+404>>2]|0)+176>>2];i=i;return}function Ng(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(880,(c[a+352>>2]|0)+ -1|0,(c[a+344>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+332>>2]=e;i=b;return}function Og(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(896,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+332>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+336>>2]=a;i=b;return}function Pg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+352>>2]|0)+ -1|0,(c[a+448>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+348>>2]=e;i=b;return}function Qg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+348>>2]|0)+ -1|0,(c[a+368>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+356>>2]=e;i=b;return}function Rg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+328>>2]|0)+ -1|0,(c[a+448>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+320>>2]=e;i=b;return}function Sg(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+304>>2]=c[(c[a+404>>2]|0)+280>>2];i=i;return}function Tg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(896,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+328>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+300>>2]=a;i=b;return}function Ug(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+288>>2]=c[(c[a+404>>2]|0)+296>>2];i=i;return}function Vg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+320>>2]|0)+ -1|0,(c[a+288>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+324>>2]=e;i=b;return}function Wg(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+312>>2]=c[(c[a+404>>2]|0)+248>>2];i=i;return}function Xg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(880,(c[a+312>>2]|0)+ -1|0,(c[a+304>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+292>>2]=e;i=b;return}function Yg(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(896,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+292>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+296>>2]=a;i=b;return}function Zg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+312>>2]|0)+ -1|0,(c[a+448>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+308>>2]=e;i=b;return}function _g(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(912,(c[a+308>>2]|0)+ -1|0,(c[a+328>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+316>>2]=e;i=b;return}function $g(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[c[a+4>>2]>>2]|0;d=c[(c[b+12>>2]|0)+408>>2]|0;a:do{switch(d|0){case 3:{e=(c[a+416>>2]|0)+216|0;break};case 4:{e=(c[a+416>>2]|0)+224|0;break};case 5:{e=(c[a+416>>2]|0)+232|0;break};case 7:{e=(c[a+416>>2]|0)+248|0;break};case 1:{e=(c[a+416>>2]|0)+200|0;break};case 6:{e=(c[a+416>>2]|0)+240|0;break};case 2:{e=(c[a+416>>2]|0)+208|0;break};default:{f=c[a+416>>2]|0;if((d|0)==8){e=f+256|0;break a}else{e=f+264|0;break a}}}}while(0);h[(c[b+8>>2]|0)+40>>3]=+h[e>>3];i=i;return}function ah(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[c[a+4>>2]>>2]|0;d=c[(c[b+12>>2]|0)+368>>2]|0;a:do{switch(d|0){case 6:{e=(c[a+416>>2]|0)+312|0;break};case 4:{e=(c[a+416>>2]|0)+296|0;break};case 5:{e=(c[a+416>>2]|0)+304|0;break};case 1:{e=(c[a+416>>2]|0)+272|0;break};case 2:{e=(c[a+416>>2]|0)+280|0;break};case 7:{e=(c[a+416>>2]|0)+320|0;break};case 3:{e=(c[a+416>>2]|0)+288|0;break};default:{f=c[a+416>>2]|0;if((d|0)==8){e=f+328|0;break a}else{e=f+336|0;break a}}}}while(0);h[(c[b+8>>2]|0)+32>>3]=+h[e>>3];i=i;return}function bh(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[c[a+4>>2]>>2]|0;d=c[(c[b+12>>2]|0)+328>>2]|0;a:do{switch(d|0){case 7:{e=(c[a+416>>2]|0)+392|0;break};case 4:{e=(c[a+416>>2]|0)+368|0;break};case 5:{e=(c[a+416>>2]|0)+376|0;break};case 1:{e=(c[a+416>>2]|0)+344|0;break};case 6:{e=(c[a+416>>2]|0)+384|0;break};case 2:{e=(c[a+416>>2]|0)+352|0;break};case 3:{e=(c[a+416>>2]|0)+360|0;break};default:{f=c[a+416>>2]|0;if((d|0)==8){e=f+400|0;break a}else{e=f+408|0;break a}}}}while(0);h[(c[b+8>>2]|0)+24>>3]=+h[e>>3];i=i;return}function ch(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[c[a+4>>2]>>2]|0;d=c[(c[b+12>>2]|0)+288>>2]|0;a:do{switch(d|0){case 6:{e=(c[a+416>>2]|0)+456|0;break};case 4:{e=(c[a+416>>2]|0)+440|0;break};case 5:{e=(c[a+416>>2]|0)+448|0;break};case 1:{e=(c[a+416>>2]|0)+416|0;break};case 2:{e=(c[a+416>>2]|0)+424|0;break};case 7:{e=(c[a+416>>2]|0)+464|0;break};case 3:{e=(c[a+416>>2]|0)+432|0;break};default:{f=c[a+416>>2]|0;if((d|0)==8){e=f+472|0;break a}else{e=f+480|0;break a}}}}while(0);h[(c[b+8>>2]|0)+16>>3]=+h[e>>3];i=i;return}function dh(b){b=b|0;var c=0;c=i;a[b+315|0]=0;a[b+314|0]=1;Re(b);Se(b);Te(b);Ue(b);Ve(b);We(b);Xe(b);Ye(b);Ze(b);_e(b);$e(b);af(b);bf(b);cf(b);df(b);ef(b);ff(b);gf(b);hf(b);jf(b);kf(b);lf(b);mf(b);nf(b);of(b);pf(b);qf(b);rf(b);sf(b);tf(b);uf(b);vf(b);wf(b);xf(b);yf(b);zf(b);Af(b);Bf(b);Cf(b);Df(b);Ef(b);Ff(b);Gf(b);Hf(b);If(b);Jf(b);Kf(b);Lf(b);Mf(b);Nf(b);Of(b);Pf(b);Qf(b);Rf(b);Sf(b);Tf(b);Uf(b);Vf(b);Wf(b);Xf(b);Yf(b);Zf(b);_f(b);$f(b);ag(b);bg(b);cg(b);dg(b);eg(b);fg(b);gg(b);hg(b);ig(b);jg(b);kg(b);lg(b);mg(b);ng(b);og(b);pg(b);qg(b);rg(b);sg(b);tg(b);ug(b);vg(b);wg(b);xg(b);yg(b);zg(b);Ag(b);Bg(b);Cg(b);Dg(b);Eg(b);Fg(b);Gg(b);Hg(b);Ig(b);Jg(b);Kg(b);Lg(b);Mg(b);Ng(b);Og(b);Pg(b);Qg(b);Rg(b);Sg(b);Tg(b);Ug(b);Vg(b);Wg(b);Xg(b);Yg(b);Zg(b);_g(b);$g(b);ah(b);bh(b);ch(b);i=c;return 0}function eh(b){b=b|0;var c=0;c=i;a[b+314|0]=0;fh(b);i=c;return 0}function fh(a){a=a|0;var b=0;b=i;Re(a);i=b;return}function gh(a,b){a=a|0;b=+b;i=i;return 0}function hh(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;Ou(c[a+536>>2]|0,(a|0)!=0|0,1136,b);c[a+540>>2]=944;c[a+84>>2]=1168;c[a+88>>2]=1168;c[a+92>>2]=1216;c[a+96>>2]=1280;c[a+100>>2]=0;c[a+60>>2]=0;c[a+112>>2]=1;c[a+116>>2]=8;c[a+120>>2]=1;c[a+124>>2]=114;c[a+128>>2]=1;c[a+132>>2]=0;c[a+136>>2]=61;c[a+140>>2]=60;d=a+232|0;e=a+144|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[d>>2]=5;c[a+216>>2]=0;c[a+220>>2]=194;c[a+224>>2]=0;c[a+228>>2]=0;c[a+160>>2]=18;c[a+104>>2]=1;c[a+164>>2]=11;c[a+168>>2]=8;d=a+56|0;e=a+176|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[d>>2]=1320;c[a+64>>2]=0;c[a+72>>2]=0;c[a+68>>2]=545;d=a+172|0;e=a+192|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[d>>2]=8;i=b;return}function ih(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=i;e=i;i=i+168|0;c[e>>2]=0;f=i;i=i+544|0;g=i;i=i+88|0;h=i;i=i+160|0;j=i;i=i+160|0;u=0;Oa(3);k=u;u=0;if((k|0)!=0&(v|0)!=0){l=oZ(c[k>>2]|0,e)|0;if((l|0)==0){bb(k|0,v|0)}J=v}else{l=-1}k=J;do{if((l|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=k}else if((l|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=k;D=7}else{E=64696;F=64720;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[E+12>>2]=c[F+12>>2];c[E+16>>2]=c[F+16>>2];c[E+20>>2]=c[F+20>>2];u=0;Oa(c[16174]|0);F=u;u=0;if((F|0)!=0&(v|0)!=0){G=oZ(c[F>>2]|0,e)|0;if((G|0)==0){bb(F|0,v|0)}J=v}else{G=-1}F=J;if((G|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=F;break}else if((G|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=F;D=7;break}F=g;E=F+0|0;H=E+88|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(H|0));u=0;E=sa(98,c[15552]|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){I=oZ(c[H>>2]|0,e)|0;if((I|0)==0){bb(H|0,v|0)}J=v}else{I=-1}H=J;if((I|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((I|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}u=0;Ha(46,c[15552]|0,F|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){K=oZ(c[H>>2]|0,e)|0;if((K|0)==0){bb(H|0,v|0)}J=v}else{K=-1}H=J;if((K|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((K|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}H=h;c[g>>2]=h;aZ(h,2,e|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=oZ(c[L>>2]|0,e)|0;if((M|0)==0){bb(L|0,v|0)}J=v}else{M=-1}L=J;if((M|0)==1){m=0;n=0;o=0;p=H;q=E;s=F;t=L;break}else if((M|0)==2){w=0;x=0;y=0;z=H;A=E;B=F;C=L;D=7;break}w=0;x=0;y=0;z=H;A=E;B=F;C=0;D=7}}while(0);while(1){if((D|0)==7){D=0;if((C|0)==0){M=j;h=g+4|0;K=c[h>>2]|0;c[h>>2]=j;aZ(j,1,e|0)|0;u=0;I=u;u=0;if((I|0)!=0&(v|0)!=0){N=oZ(c[I>>2]|0,e)|0;if((N|0)==0){bb(I|0,v|0)}J=v}else{N=-1}I=J;if((N|0)==1){m=K;n=h;o=M;p=z;q=A;s=B;t=I;continue}else if((N|0)==2){O=B;P=A;Q=z;w=K;x=h;y=M;C=I;B=O;A=P;z=Q;D=7;continue}m=K;n=h;o=M;p=z;q=A;s=B;t=0;continue}else{u=0;Ha(46,c[15552]|0,A|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){R=oZ(c[M>>2]|0,e)|0;if((R|0)==0){bb(M|0,v|0)}J=v}else{R=-1}M=J;if((R|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((R|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}u=0;Oa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){V=oZ(c[M>>2]|0,e)|0;if((V|0)==0){bb(M|0,v|0)}J=v}else{V=-1}M=J;if((V|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((V|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}else{D=18;break}}}if((t|0)!=0){u=0;Oa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){W=oZ(c[M>>2]|0,e)|0;if((W|0)==0){bb(M|0,v|0)}J=v}else{W=-1}M=J;if((W|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((W|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}M=c[r>>2]|0;u=0;Qa(34,1376,154,1,M|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ba=oZ(c[M>>2]|0,e)|0;if((ba|0)==0){bb(M|0,v|0)}J=v}else{ba=-1}M=J;if((ba|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ba|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ca=oZ(c[M>>2]|0,e)|0;if((ca|0)==0){bb(M|0,v|0)}J=v}else{ca=-1}M=J;if((ca|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ca|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;sa(99,0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){da=oZ(c[M>>2]|0,e)|0;if((da|0)==0){bb(M|0,v|0)}J=v}else{da=-1}M=J;if((da|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((da|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}else{D=15;break}}u=0;pa(137,f|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ea=oZ(c[M>>2]|0,e)|0;if((ea|0)==0){bb(M|0,v|0)}J=v}else{ea=-1}M=J;if((ea|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ea|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}c[f+536>>2]=g;u=0;M=va(31,a|0,b|0,f|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){fa=oZ(c[h>>2]|0,e)|0;if((fa|0)==0){bb(h|0,v|0)}J=v}else{fa=-1}h=J;if((fa|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((fa|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}c[n>>2]=m;u=0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ga=oZ(c[h>>2]|0,e)|0;if((ga|0)==0){bb(h|0,v|0)}J=v}else{ga=-1}h=J;if((ga|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ga|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;Ha(46,c[15552]|0,q|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ha=oZ(c[h>>2]|0,e)|0;if((ha|0)==0){bb(h|0,v|0)}J=v}else{ha=-1}h=J;if((ha|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ha|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ia=oZ(c[h>>2]|0,e)|0;if((ia|0)==0){bb(h|0,v|0)}J=v}else{ia=-1}h=J;if((ia|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ia|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ja=oZ(c[h>>2]|0,e)|0;if((ja|0)==0){bb(h|0,v|0)}J=v}else{ja=-1}h=J;if((ja|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ja|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;pa(138,M|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ka=oZ(c[M>>2]|0,e)|0;if((ka|0)==0){bb(M|0,v|0)}J=v}else{ka=-1}M=J;if((ka|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa}else if((ka|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7}else{D=26;break}}if((D|0)==15){la=p;ma=s;i=d;return 1}else if((D|0)==18){la=z;ma=B;i=d;return 1}return 0}function jh(){var a=0;a=i;jd(0)|0;mc(1536,18,1,c[r>>2]|0)|0;jd(0)|0;i=a;return}function kh(a){a=a|0;var b=0;a=i;i=i+8|0;b=i;i=i+8|0;Lu(4,0,2328,b);Lu(4,0,2368,a);i=a;return}function lh(a){a=a|0;var b=0,d=0;b=i;d=a+320|0;a=c[d>>2]|0;if((a|0)==0){i=b;return}AY(a);c[d>>2]=0;i=b;return}function mh(a){a=a|0;i=i;return}function nh(a){a=a|0;i=i;return}function oh(a,b){a=a|0;b=b|0;i=i;return}function ph(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;i=i+8|0;d=c[a+108>>2]|0;c[d>>2]=1;e=c[a+416>>2]|0;h[d+8>>3]=+h[e+168>>3];f=+h[e+176>>3];h[d+16>>3]=f;Ou(c[a+536>>2]|0,f>0.0|0,2416,b);i=b;return}function qh(a,b){a=a|0;b=b|0;c[b>>2]=c[4160+(a<<2)>>2];i=i;return c[2440+(a<<2)>>2]|0}function rh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0;e=i;f=b+4|0;g=b+416|0;j=b+360|0;k=(Bx(+h[c[c[f>>2]>>2]>>3],+h[(c[g>>2]|0)+32>>3],a[c[j>>2]|0]|0)|0)<<24>>24!=0;h[d>>3]=k?1.0:-1.0;k=b+404|0;l=+h[(c[g>>2]|0)+32>>3];m=+T(+(+_w(b,1,+(c[(c[k>>2]|0)+40>>2]|0),+h[c[c[f>>2]>>2]>>3],l,l)));n=b+364|0;o=m!=+T(+(+h[c[n>>2]>>3]));h[d+8>>3]=o?1.0:-1.0;o=(Bx(+h[c[c[f>>2]>>2]>>3],+h[(c[g>>2]|0)+16>>3],a[(c[j>>2]|0)+1|0]|0)|0)<<24>>24!=0;h[d+16>>3]=o?1.0:-1.0;m=+h[(c[g>>2]|0)+16>>3];l=+T(+(+_w(b,0,+(c[(c[k>>2]|0)+408>>2]|0),+h[c[c[f>>2]>>2]>>3],m,m)));o=l!=+T(+(+h[(c[n>>2]|0)+8>>3]));h[d+24>>3]=o?1.0:-1.0;o=(Bx(+h[c[c[f>>2]>>2]>>3],+h[(c[g>>2]|0)+72>>3],a[(c[j>>2]|0)+2|0]|0)|0)<<24>>24!=0;h[d+32>>3]=o?1.0:-1.0;l=+h[(c[g>>2]|0)+72>>3];m=+T(+(+_w(b,3,+(c[(c[k>>2]|0)+112>>2]|0),+h[c[c[f>>2]>>2]>>3],l,l)));o=m!=+T(+(+h[(c[n>>2]|0)+16>>3]));h[d+40>>3]=o?1.0:-1.0;o=(Bx(+h[c[c[f>>2]>>2]>>3],+h[(c[g>>2]|0)+56>>3],a[(c[j>>2]|0)+3|0]|0)|0)<<24>>24!=0;h[d+48>>3]=o?1.0:-1.0;m=+h[(c[g>>2]|0)+56>>3];l=+T(+(+_w(b,2,+(c[(c[k>>2]|0)+368>>2]|0),+h[c[c[f>>2]>>2]>>3],m,m)));o=l!=+T(+(+h[(c[n>>2]|0)+24>>3]));h[d+56>>3]=o?1.0:-1.0;o=(Bx(+h[c[c[f>>2]>>2]>>3],+h[(c[g>>2]|0)+112>>3],a[(c[j>>2]|0)+4|0]|0)|0)<<24>>24!=0;h[d+64>>3]=o?1.0:-1.0;l=+h[(c[g>>2]|0)+112>>3];m=+T(+(+_w(b,5,+(c[(c[k>>2]|0)+184>>2]|0),+h[c[c[f>>2]>>2]>>3],l,l)));o=m!=+T(+(+h[(c[n>>2]|0)+32>>3]));h[d+72>>3]=o?1.0:-1.0;o=(Bx(+h[c[c[f>>2]>>2]>>3],+h[(c[g>>2]|0)+96>>3],a[(c[j>>2]|0)+5|0]|0)|0)<<24>>24!=0;h[d+80>>3]=o?1.0:-1.0;m=+h[(c[g>>2]|0)+96>>3];l=+T(+(+_w(b,4,+(c[(c[k>>2]|0)+328>>2]|0),+h[c[c[f>>2]>>2]>>3],m,m)));o=l!=+T(+(+h[(c[n>>2]|0)+40>>3]));h[d+88>>3]=o?1.0:-1.0;o=(Bx(+h[c[c[f>>2]>>2]>>3],+h[(c[g>>2]|0)+152>>3],a[(c[j>>2]|0)+6|0]|0)|0)<<24>>24!=0;h[d+96>>3]=o?1.0:-1.0;l=+h[(c[g>>2]|0)+152>>3];m=+T(+(+_w(b,7,+(c[(c[k>>2]|0)+256>>2]|0),+h[c[c[f>>2]>>2]>>3],l,l)));o=m!=+T(+(+h[(c[n>>2]|0)+48>>3]));h[d+104>>3]=o?1.0:-1.0;o=(Bx(+h[c[c[f>>2]>>2]>>3],+h[(c[g>>2]|0)+136>>3],a[(c[j>>2]|0)+7|0]|0)|0)<<24>>24!=0;h[d+112>>3]=o?1.0:-1.0;m=+h[(c[g>>2]|0)+136>>3];l=+T(+(+_w(b,6,+(c[(c[k>>2]|0)+288>>2]|0),+h[c[c[f>>2]>>2]>>3],m,m)));k=l!=+T(+(+h[(c[n>>2]|0)+56>>3]));h[d+120>>3]=k?1.0:-1.0;k=Ex(+h[c[c[f>>2]>>2]>>3],+h[(c[g>>2]|0)+168>>3])|0;n=c[c[f>>2]>>2]|0;b=c[n+8>>2]|0;o=Bx(+h[n>>3],+h[b+48>>3]+ +h[b+56>>3],a[(c[j>>2]|0)+9|0]|0)|0;if(k<<24>>24==0){p=1.0;q=d;r=q+128|0;s=r;h[s>>3]=p;t=c[f>>2]|0;u=c[t>>2]|0;v=u;w=v;x=+h[w>>3];y=c[g>>2]|0;z=y;A=z+160|0;B=A;C=+h[B>>3];D=c[j>>2]|0;E=D;F=E+10|0;G=F;H=a[G]|0;I=Bx(x,C,H)|0;J=I<<24>>24!=0;K=J?1.0:-1.0;L=d;M=L+136|0;N=M;h[N>>3]=K;i=e;return 0}p=o<<24>>24!=0?1.0:-1.0;q=d;r=q+128|0;s=r;h[s>>3]=p;t=c[f>>2]|0;u=c[t>>2]|0;v=u;w=v;x=+h[w>>3];y=c[g>>2]|0;z=y;A=z+160|0;B=A;C=+h[B>>3];D=c[j>>2]|0;E=D;F=E+10|0;G=F;H=a[G]|0;I=Bx(x,C,H)|0;J=I<<24>>24!=0;K=J?1.0:-1.0;L=d;M=L+136|0;N=M;h[N>>3]=K;i=e;return 0}function sh(a){a=a|0;i=i;return c[4296+(a<<2)>>2]|0}function th(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0,k=0.0,l=0,m=0,n=0;e=i;f=b+4|0;g=+h[c[c[f>>2]>>2]>>3];j=b+416|0;k=+h[(c[j>>2]|0)+32>>3];if((d|0)==0){d=b+352|0;a[c[d>>2]|0]=g>=k|0;a[(c[d>>2]|0)+1|0]=+h[c[c[f>>2]>>2]>>3]>=+h[(c[j>>2]|0)+16>>3]|0;a[(c[d>>2]|0)+2|0]=+h[c[c[f>>2]>>2]>>3]>=+h[(c[j>>2]|0)+72>>3]|0;a[(c[d>>2]|0)+3|0]=+h[c[c[f>>2]>>2]>>3]>=+h[(c[j>>2]|0)+56>>3]|0;a[(c[d>>2]|0)+4|0]=+h[c[c[f>>2]>>2]>>3]>=+h[(c[j>>2]|0)+112>>3]|0;a[(c[d>>2]|0)+5|0]=+h[c[c[f>>2]>>2]>>3]>=+h[(c[j>>2]|0)+96>>3]|0;a[(c[d>>2]|0)+6|0]=+h[c[c[f>>2]>>2]>>3]>=+h[(c[j>>2]|0)+152>>3]|0;a[(c[d>>2]|0)+7|0]=+h[c[c[f>>2]>>2]>>3]>=+h[(c[j>>2]|0)+136>>3]|0;a[(c[d>>2]|0)+8|0]=+h[c[c[f>>2]>>2]>>3]>=+h[(c[j>>2]|0)+168>>3]|0;l=c[c[f>>2]>>2]|0;m=c[l+8>>2]|0;a[(c[d>>2]|0)+9|0]=+h[l>>3]>=+h[m+48>>3]+ +h[m+56>>3]|0;a[(c[d>>2]|0)+10|0]=+h[c[c[f>>2]>>2]>>3]>=+h[(c[j>>2]|0)+160>>3]|0;i=e;return 0}else{d=b+360|0;m=Bx(g,k,a[c[d>>2]|0]|0)|0;l=b+352|0;a[c[l>>2]|0]=m;m=Bx(+h[c[c[f>>2]>>2]>>3],+h[(c[j>>2]|0)+16>>3],a[(c[d>>2]|0)+1|0]|0)|0;a[(c[l>>2]|0)+1|0]=m;m=Bx(+h[c[c[f>>2]>>2]>>3],+h[(c[j>>2]|0)+72>>3],a[(c[d>>2]|0)+2|0]|0)|0;a[(c[l>>2]|0)+2|0]=m;m=Bx(+h[c[c[f>>2]>>2]>>3],+h[(c[j>>2]|0)+56>>3],a[(c[d>>2]|0)+3|0]|0)|0;a[(c[l>>2]|0)+3|0]=m;m=Bx(+h[c[c[f>>2]>>2]>>3],+h[(c[j>>2]|0)+112>>3],a[(c[d>>2]|0)+4|0]|0)|0;a[(c[l>>2]|0)+4|0]=m;m=Bx(+h[c[c[f>>2]>>2]>>3],+h[(c[j>>2]|0)+96>>3],a[(c[d>>2]|0)+5|0]|0)|0;a[(c[l>>2]|0)+5|0]=m;m=Bx(+h[c[c[f>>2]>>2]>>3],+h[(c[j>>2]|0)+152>>3],a[(c[d>>2]|0)+6|0]|0)|0;a[(c[l>>2]|0)+6|0]=m;m=Bx(+h[c[c[f>>2]>>2]>>3],+h[(c[j>>2]|0)+136>>3],a[(c[d>>2]|0)+7|0]|0)|0;a[(c[l>>2]|0)+7|0]=m;m=Bx(+h[c[c[f>>2]>>2]>>3],+h[(c[j>>2]|0)+168>>3],a[(c[d>>2]|0)+8|0]|0)|0;a[(c[l>>2]|0)+8|0]=m;m=c[c[f>>2]>>2]|0;b=c[m+8>>2]|0;n=Bx(+h[m>>3],+h[b+48>>3]+ +h[b+56>>3],a[(c[d>>2]|0)+9|0]|0)|0;a[(c[l>>2]|0)+9|0]=n;n=Bx(+h[c[c[f>>2]>>2]>>3],+h[(c[j>>2]|0)+160>>3],a[(c[d>>2]|0)+10|0]|0)|0;a[(c[l>>2]|0)+10|0]=n;i=e;return 0}return 0}function uh(b){b=b|0;var d=0,e=0,f=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0.0,Ab=0.0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0;d=i;i=i+5632|0;e=i;i=i+8|0;f=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+16|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;Lu(8,1,4344,sb);sb=c[c[(b+4|0)>>2]>>2]|0;tb=a[c[sb+16>>2]|0]|0;ub=a[c[b+408>>2]|0]|0;if(tb<<24>>24==ub<<24>>24){vb=sb;wb=0}else{c[rb>>2]=ub<<24>>24;c[rb+4>>2]=tb<<24>>24;Lu(8,0,4376,rb);vb=c[c[(b+4|0)>>2]>>2]|0;wb=1}rb=c[(c[vb+12>>2]|0)+452>>2]|0;tb=c[(c[(b+404|0)>>2]|0)+452>>2]|0;if((rb|0)==(tb|0)){xb=vb;yb=wb}else{c[qb>>2]=tb;c[qb+4>>2]=rb;Lu(8,0,4432,qb);xb=c[c[(b+4|0)>>2]>>2]|0;yb=1}zb=+h[(c[xb+8>>2]|0)+48>>3];Ab=+h[(c[b+400>>2]|0)+48>>3];if(zb!=Ab){h[k>>3]=Ab;c[pb>>2]=c[k>>2];c[pb+4>>2]=c[k+4>>2];h[k>>3]=zb;c[(pb+8|0)>>2]=c[k>>2];c[(pb+8|0)+4>>2]=c[k+4>>2];Lu(8,0,4480,pb);Bb=c[c[(b+4|0)>>2]>>2]|0;Cb=1}else{Bb=xb;Cb=yb}yb=c[Bb+12>>2]|0;Bb=c[yb+448>>2]|0;xb=c[(b+404|0)>>2]|0;pb=c[xb+448>>2]|0;if((Bb|0)==(pb|0)){Db=xb;Eb=yb;Fb=Cb}else{c[ob>>2]=pb;c[ob+4>>2]=Bb;Lu(8,0,4528,ob);Db=c[(b+404|0)>>2]|0;Eb=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Fb=1}ob=c[Eb+444>>2]|0;Bb=c[Db+444>>2]|0;if((ob|0)==(Bb|0)){Gb=Db;Hb=Eb;Ib=Fb}else{c[nb>>2]=Bb;c[nb+4>>2]=ob;Lu(8,0,4584,nb);Gb=c[(b+404|0)>>2]|0;Hb=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Ib=1}nb=c[Hb+440>>2]|0;ob=c[Gb+440>>2]|0;if((nb|0)==(ob|0)){Jb=Gb;Kb=Hb;Lb=Ib}else{c[mb>>2]=ob;c[mb+4>>2]=nb;Lu(8,0,4656,mb);Jb=c[(b+404|0)>>2]|0;Kb=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Lb=1}mb=c[Kb+436>>2]|0;nb=c[Jb+436>>2]|0;if((mb|0)==(nb|0)){Mb=Jb;Nb=Kb;Ob=Lb}else{c[lb>>2]=nb;c[lb+4>>2]=mb;Lu(8,0,4736,lb);Mb=c[(b+404|0)>>2]|0;Nb=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Ob=1}lb=c[Nb+432>>2]|0;mb=c[Mb+432>>2]|0;if((lb|0)==(mb|0)){Pb=Mb;Qb=Nb;Rb=Ob}else{c[kb>>2]=mb;c[kb+4>>2]=lb;Lu(8,0,4808,kb);Pb=c[(b+404|0)>>2]|0;Qb=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Rb=1}kb=c[Qb+428>>2]|0;lb=c[Pb+428>>2]|0;if((kb|0)==(lb|0)){Sb=Pb;Tb=Qb;Ub=Rb}else{c[jb>>2]=lb;c[jb+4>>2]=kb;Lu(8,0,4880,jb);Sb=c[(b+404|0)>>2]|0;Tb=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Ub=1}jb=c[Tb+424>>2]|0;kb=c[Sb+424>>2]|0;if((jb|0)==(kb|0)){Vb=Sb;Wb=Tb;Xb=Ub}else{c[ib>>2]=kb;c[ib+4>>2]=jb;Lu(8,0,4960,ib);Vb=c[(b+404|0)>>2]|0;Wb=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Xb=1}ib=c[Wb+420>>2]|0;jb=c[Vb+420>>2]|0;if((ib|0)==(jb|0)){Yb=Vb;Zb=Wb;_b=Xb}else{c[hb>>2]=jb;c[hb+4>>2]=ib;Lu(8,0,5024,hb);Yb=c[(b+404|0)>>2]|0;Zb=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;_b=1}hb=c[Zb+416>>2]|0;ib=c[Yb+416>>2]|0;if((hb|0)==(ib|0)){$b=Yb;ac=Zb;bc=_b}else{c[gb>>2]=ib;c[gb+4>>2]=hb;Lu(8,0,5096,gb);$b=c[(b+404|0)>>2]|0;ac=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;bc=1}gb=c[ac+412>>2]|0;hb=c[$b+412>>2]|0;if((gb|0)==(hb|0)){cc=$b;dc=ac;ec=bc}else{c[fb>>2]=hb;c[fb+4>>2]=gb;Lu(8,0,5176,fb);cc=c[(b+404|0)>>2]|0;dc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;ec=1}fb=c[dc+408>>2]|0;gb=c[cc+408>>2]|0;if((fb|0)==(gb|0)){fc=cc;gc=dc;hc=ec}else{c[eb>>2]=gb;c[eb+4>>2]=fb;Lu(8,0,5256,eb);fc=c[(b+404|0)>>2]|0;gc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;hc=1}eb=c[gc+404>>2]|0;fb=c[fc+404>>2]|0;if((eb|0)==(fb|0)){ic=fc;jc=gc;kc=hc}else{c[db>>2]=fb;c[db+4>>2]=eb;Lu(8,0,5328,db);ic=c[(b+404|0)>>2]|0;jc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;kc=1}db=c[jc+400>>2]|0;eb=c[ic+400>>2]|0;if((db|0)==(eb|0)){lc=ic;mc=jc;nc=kc}else{c[cb>>2]=eb;c[cb+4>>2]=db;Lu(8,0,5400,cb);lc=c[(b+404|0)>>2]|0;mc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;nc=1}cb=c[mc+396>>2]|0;db=c[lc+396>>2]|0;if((cb|0)==(db|0)){oc=lc;pc=mc;qc=nc}else{c[bb>>2]=db;c[bb+4>>2]=cb;Lu(8,0,5480,bb);oc=c[(b+404|0)>>2]|0;pc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;qc=1}bb=c[pc+392>>2]|0;cb=c[oc+392>>2]|0;if((bb|0)==(cb|0)){rc=oc;sc=pc;tc=qc}else{c[ab>>2]=cb;c[ab+4>>2]=bb;Lu(8,0,5552,ab);rc=c[(b+404|0)>>2]|0;sc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;tc=1}ab=c[sc+388>>2]|0;bb=c[rc+388>>2]|0;if((ab|0)==(bb|0)){uc=rc;vc=sc;wc=tc}else{c[$a>>2]=bb;c[$a+4>>2]=ab;Lu(8,0,5624,$a);uc=c[(b+404|0)>>2]|0;vc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;wc=1}$a=c[vc+384>>2]|0;ab=c[uc+384>>2]|0;if(($a|0)==(ab|0)){xc=uc;yc=vc;zc=wc}else{c[_a>>2]=ab;c[_a+4>>2]=$a;Lu(8,0,5704,_a);xc=c[(b+404|0)>>2]|0;yc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;zc=1}_a=c[yc+380>>2]|0;$a=c[xc+380>>2]|0;if((_a|0)==($a|0)){Ac=xc;Bc=yc;Cc=zc}else{c[Za>>2]=$a;c[Za+4>>2]=_a;Lu(8,0,5768,Za);Ac=c[(b+404|0)>>2]|0;Bc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Cc=1}Za=c[Bc+376>>2]|0;_a=c[Ac+376>>2]|0;if((Za|0)==(_a|0)){Dc=Ac;Ec=Bc;Fc=Cc}else{c[Ya>>2]=_a;c[Ya+4>>2]=Za;Lu(8,0,5840,Ya);Dc=c[(b+404|0)>>2]|0;Ec=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Fc=1}Ya=c[Ec+372>>2]|0;Za=c[Dc+372>>2]|0;if((Ya|0)==(Za|0)){Gc=Dc;Hc=Ec;Ic=Fc}else{c[Xa>>2]=Za;c[Xa+4>>2]=Ya;Lu(8,0,5920,Xa);Gc=c[(b+404|0)>>2]|0;Hc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Ic=1}Xa=c[Hc+368>>2]|0;Ya=c[Gc+368>>2]|0;if((Xa|0)==(Ya|0)){Jc=Gc;Kc=Hc;Lc=Ic}else{c[Wa>>2]=Ya;c[Wa+4>>2]=Xa;Lu(8,0,6e3,Wa);Jc=c[(b+404|0)>>2]|0;Kc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Lc=1}Wa=c[Kc+364>>2]|0;Xa=c[Jc+364>>2]|0;if((Wa|0)==(Xa|0)){Mc=Jc;Nc=Kc;Oc=Lc}else{c[Va>>2]=Xa;c[Va+4>>2]=Wa;Lu(8,0,6072,Va);Mc=c[(b+404|0)>>2]|0;Nc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Oc=1}Va=c[Nc+360>>2]|0;Wa=c[Mc+360>>2]|0;if((Va|0)==(Wa|0)){Pc=Mc;Qc=Nc;Rc=Oc}else{c[Ua>>2]=Wa;c[Ua+4>>2]=Va;Lu(8,0,6144,Ua);Pc=c[(b+404|0)>>2]|0;Qc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Rc=1}Ua=c[Qc+356>>2]|0;Va=c[Pc+356>>2]|0;if((Ua|0)==(Va|0)){Sc=Pc;Tc=Qc;Uc=Rc}else{c[Ta>>2]=Va;c[Ta+4>>2]=Ua;Lu(8,0,6224,Ta);Sc=c[(b+404|0)>>2]|0;Tc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Uc=1}Ta=c[Tc+352>>2]|0;Ua=c[Sc+352>>2]|0;if((Ta|0)==(Ua|0)){Vc=Sc;Wc=Tc;Xc=Uc}else{c[Sa>>2]=Ua;c[Sa+4>>2]=Ta;Lu(8,0,6296,Sa);Vc=c[(b+404|0)>>2]|0;Wc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Xc=1}Sa=c[Wc+348>>2]|0;Ta=c[Vc+348>>2]|0;if((Sa|0)==(Ta|0)){Yc=Vc;Zc=Wc;_c=Xc}else{c[Ra>>2]=Ta;c[Ra+4>>2]=Sa;Lu(8,0,6368,Ra);Yc=c[(b+404|0)>>2]|0;Zc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;_c=1}Ra=c[Zc+344>>2]|0;Sa=c[Yc+344>>2]|0;if((Ra|0)==(Sa|0)){$c=Yc;ad=Zc;bd=_c}else{c[Qa>>2]=Sa;c[Qa+4>>2]=Ra;Lu(8,0,6448,Qa);$c=c[(b+404|0)>>2]|0;ad=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;bd=1}Qa=c[ad+340>>2]|0;Ra=c[$c+340>>2]|0;if((Qa|0)==(Ra|0)){cd=$c;dd=ad;ed=bd}else{c[Pa>>2]=Ra;c[Pa+4>>2]=Qa;Lu(8,0,6512,Pa);cd=c[(b+404|0)>>2]|0;dd=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;ed=1}Pa=c[dd+336>>2]|0;Qa=c[cd+336>>2]|0;if((Pa|0)==(Qa|0)){fd=cd;gd=dd;hd=ed}else{c[Oa>>2]=Qa;c[Oa+4>>2]=Pa;Lu(8,0,6584,Oa);fd=c[(b+404|0)>>2]|0;gd=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;hd=1}Oa=c[gd+332>>2]|0;Pa=c[fd+332>>2]|0;if((Oa|0)==(Pa|0)){id=fd;jd=gd;kd=hd}else{c[Na>>2]=Pa;c[Na+4>>2]=Oa;Lu(8,0,6664,Na);id=c[(b+404|0)>>2]|0;jd=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;kd=1}Na=c[jd+328>>2]|0;Oa=c[id+328>>2]|0;if((Na|0)==(Oa|0)){ld=id;md=jd;nd=kd}else{c[Ma>>2]=Oa;c[Ma+4>>2]=Na;Lu(8,0,6744,Ma);ld=c[(b+404|0)>>2]|0;md=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;nd=1}Ma=c[md+324>>2]|0;Na=c[ld+324>>2]|0;if((Ma|0)==(Na|0)){od=ld;pd=md;qd=nd}else{c[La>>2]=Na;c[La+4>>2]=Ma;Lu(8,0,6816,La);od=c[(b+404|0)>>2]|0;pd=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;qd=1}La=c[pd+320>>2]|0;Ma=c[od+320>>2]|0;if((La|0)==(Ma|0)){rd=od;sd=pd;td=qd}else{c[Ka>>2]=Ma;c[Ka+4>>2]=La;Lu(8,0,6888,Ka);rd=c[(b+404|0)>>2]|0;sd=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;td=1}Ka=c[sd+316>>2]|0;La=c[rd+316>>2]|0;if((Ka|0)==(La|0)){ud=rd;vd=sd;wd=td}else{c[Ja>>2]=La;c[Ja+4>>2]=Ka;Lu(8,0,6968,Ja);ud=c[(b+404|0)>>2]|0;vd=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;wd=1}Ja=c[vd+312>>2]|0;Ka=c[ud+312>>2]|0;if((Ja|0)==(Ka|0)){xd=ud;yd=vd;zd=wd}else{c[Ia>>2]=Ka;c[Ia+4>>2]=Ja;Lu(8,0,7040,Ia);xd=c[(b+404|0)>>2]|0;yd=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;zd=1}Ia=c[yd+308>>2]|0;Ja=c[xd+308>>2]|0;if((Ia|0)==(Ja|0)){Ad=xd;Bd=yd;Cd=zd}else{c[Ha>>2]=Ja;c[Ha+4>>2]=Ia;Lu(8,0,7112,Ha);Ad=c[(b+404|0)>>2]|0;Bd=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Cd=1}Ha=c[Bd+304>>2]|0;Ia=c[Ad+304>>2]|0;if((Ha|0)==(Ia|0)){Dd=Ad;Ed=Bd;Fd=Cd}else{c[Ga>>2]=Ia;c[Ga+4>>2]=Ha;Lu(8,0,7192,Ga);Dd=c[(b+404|0)>>2]|0;Ed=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Fd=1}Ga=c[Ed+300>>2]|0;Ha=c[Dd+300>>2]|0;if((Ga|0)==(Ha|0)){Gd=Dd;Hd=Ed;Id=Fd}else{c[Fa>>2]=Ha;c[Fa+4>>2]=Ga;Lu(8,0,7256,Fa);Gd=c[(b+404|0)>>2]|0;Hd=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Id=1}Fa=c[Hd+296>>2]|0;Ga=c[Gd+296>>2]|0;if((Fa|0)==(Ga|0)){Jd=Gd;Kd=Hd;Ld=Id}else{c[Ea>>2]=Ga;c[Ea+4>>2]=Fa;Lu(8,0,7328,Ea);Jd=c[(b+404|0)>>2]|0;Kd=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Ld=1}Ea=c[Kd+292>>2]|0;Fa=c[Jd+292>>2]|0;if((Ea|0)==(Fa|0)){Md=Jd;Nd=Kd;Od=Ld}else{c[Da>>2]=Fa;c[Da+4>>2]=Ea;Lu(8,0,7408,Da);Md=c[(b+404|0)>>2]|0;Nd=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Od=1}Da=c[Nd+288>>2]|0;Ea=c[Md+288>>2]|0;if((Da|0)==(Ea|0)){Pd=Md;Qd=Nd;Rd=Od}else{c[Ca>>2]=Ea;c[Ca+4>>2]=Da;Lu(8,0,7488,Ca);Pd=c[(b+404|0)>>2]|0;Qd=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Rd=1}Ca=c[Qd+284>>2]|0;Da=c[Pd+284>>2]|0;if((Ca|0)==(Da|0)){Sd=Pd;Td=Qd;Ud=Rd}else{c[Ba>>2]=Da;c[Ba+4>>2]=Ca;Lu(8,0,7560,Ba);Sd=c[(b+404|0)>>2]|0;Td=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Ud=1}Ba=c[Td+280>>2]|0;Ca=c[Sd+280>>2]|0;if((Ba|0)==(Ca|0)){Vd=Sd;Wd=Td;Xd=Ud}else{c[Aa>>2]=Ca;c[Aa+4>>2]=Ba;Lu(8,0,7624,Aa);Vd=c[(b+404|0)>>2]|0;Wd=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Xd=1}Aa=c[Wd+272>>2]|0;Ba=c[Vd+272>>2]|0;if((Aa|0)==(Ba|0)){Yd=Vd;Zd=Wd;_d=Xd}else{c[za>>2]=Ba;c[za+4>>2]=Aa;Lu(8,0,7696,za);Yd=c[(b+404|0)>>2]|0;Zd=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;_d=1}za=c[Zd+276>>2]|0;Aa=c[Yd+276>>2]|0;if((za|0)==(Aa|0)){$d=Yd;ae=Zd;be=_d}else{c[ya>>2]=Aa;c[ya+4>>2]=za;Lu(8,0,7768,ya);$d=c[(b+404|0)>>2]|0;ae=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;be=1}ya=c[ae+268>>2]|0;za=c[$d+268>>2]|0;if((ya|0)==(za|0)){ce=$d;de=ae;ee=be}else{c[xa>>2]=za;c[xa+4>>2]=ya;Lu(8,0,7840,xa);ce=c[(b+404|0)>>2]|0;de=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;ee=1}xa=c[de+264>>2]|0;ya=c[ce+264>>2]|0;if((xa|0)==(ya|0)){fe=ce;ge=de;he=ee}else{c[wa>>2]=ya;c[wa+4>>2]=xa;Lu(8,0,7912,wa);fe=c[(b+404|0)>>2]|0;ge=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;he=1}wa=c[ge+260>>2]|0;xa=c[fe+260>>2]|0;c[d+16>>2]=b;c[d+1296>>2]=fe;c[d+1304>>2]=ge;c[d+1312>>2]=wa;c[d+1320>>2]=xa;c[d+4200>>2]=he;c[d+4936>>2]=va;c[d+4944>>2]=ua;c[d+4952>>2]=ta;c[d+4960>>2]=sa;c[d+4968>>2]=ra;c[d+4976>>2]=qa;c[d+4984>>2]=pa;c[d+4992>>2]=oa;c[d+5e3>>2]=na;c[d+5008>>2]=ma;c[d+5024>>2]=la;c[d+5032>>2]=ka;c[d+5040>>2]=ja;c[d+5048>>2]=ia;c[d+5056>>2]=ha;c[d+5064>>2]=ga;c[d+5072>>2]=fa;c[d+5080>>2]=ea;c[d+5088>>2]=da;c[d+5096>>2]=ca;c[d+5112>>2]=ba;c[d+5120>>2]=aa;c[d+5128>>2]=$;c[d+5136>>2]=_;c[d+5144>>2]=Z;c[d+5152>>2]=Y;c[d+5160>>2]=X;c[d+5168>>2]=W;c[d+5176>>2]=V;c[d+5184>>2]=U;c[d+5200>>2]=T;c[d+5208>>2]=S;c[d+5216>>2]=R;c[d+5224>>2]=Q;c[d+5232>>2]=P;c[d+5240>>2]=O;c[d+5248>>2]=N;c[d+5256>>2]=M;c[d+5264>>2]=L;c[d+5272>>2]=K;c[d+5288>>2]=J;c[d+5296>>2]=G;c[d+5304>>2]=F;c[d+5312>>2]=E;c[d+5320>>2]=D;c[d+5328>>2]=C;c[d+5336>>2]=B;c[d+5344>>2]=z;c[d+5352>>2]=y;c[d+5360>>2]=x;c[d+5384>>2]=w;c[d+5392>>2]=v;c[d+5400>>2]=u;c[d+5408>>2]=t;c[d+5416>>2]=s;c[d+5424>>2]=r;c[d+5432>>2]=q;c[d+5440>>2]=p;c[d+5448>>2]=o;c[d+5456>>2]=n;c[d+5472>>2]=m;c[d+5480>>2]=l;c[d+5488>>2]=j;c[d+5496>>2]=f;c[d+5504>>2]=e;c[d+5584>>2]=0;c[d+5588>>2]=0;_Modelica_Electrical_Digital_Examples_Counter_checkForDiscreteChanges$0(d);H=c[d+5584>>2]|0;A=c[d+5588>>2]|0;I=+g[d+5588>>2];c[d+5584>>2]=0;c[d+5588>>2]=0;if((H|0)==6){return A|0}return 0|0;return 0}function vh(a){a=a|0;i=i;return 12904}function wh(a,b){a=a|0;b=b|0;b=i;i=i+8|0;Lu(21,1,12912,b);if((c[64012>>2]|0)==0){i=b;return 0}Vd[c[16120]&511](21);i=b;return 0}function xh(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+156>>2]=c[b+220>>2];i=i;return}function yh(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+176>>2]=c[b+156>>2];i=i;return}function zh(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+188>>2]=c[b+176>>2];i=i;return}function Ah(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+192>>2]=c[b+156>>2];i=i;return}function Bh(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+204>>2]=c[b+192>>2];i=i;return}function Ch(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+120>>3]=+h[b+192>>3];i=i;return}function Dh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+128>>3]=+h[b+120>>3];i=i;return}function Eh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+136>>3]=+h[b+128>>3];i=i;return}function Fh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+144>>3]=+h[b+120>>3];i=i;return}function Gh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+152>>3]=+h[b+144>>3];i=i;return}function Hh(a){a=a|0;c[(c[a+404>>2]|0)+316>>2]=1;i=i;return}function Ih(a){a=a|0;c[(c[a+404>>2]|0)+288>>2]=1;i=i;return}function Jh(a){a=a|0;c[(c[a+404>>2]|0)+268>>2]=1;i=i;return}function Kh(a){a=a|0;c[(c[a+404>>2]|0)+256>>2]=1;i=i;return}function Lh(a){a=a|0;var b=0,d=0;b=i;d=Qu(12944,(Fx(+(c[(c[a+404>>2]|0)+288>>2]|0),7,a)|0)+ -1|0)|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+236>>2]=d;i=b;return}function _Modelica_Electrical_Digital_Examples_Counter_checkForDiscreteChanges$0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0;b=c[a+16>>2]|0;d=c[a+1296>>2]|0;e=c[a+1304>>2]|0;f=c[a+1312>>2]|0;g=c[a+1320>>2]|0;h=c[a+4200>>2]|0;j=c[a+4936>>2]|0;k=c[a+4944>>2]|0;l=c[a+4952>>2]|0;m=c[a+4960>>2]|0;n=c[a+4968>>2]|0;o=c[a+4976>>2]|0;p=c[a+4984>>2]|0;q=c[a+4992>>2]|0;r=c[a+5e3>>2]|0;s=c[a+5008>>2]|0;t=c[a+5024>>2]|0;u=c[a+5032>>2]|0;v=c[a+5040>>2]|0;w=c[a+5048>>2]|0;x=c[a+5056>>2]|0;y=c[a+5064>>2]|0;z=c[a+5072>>2]|0;A=c[a+5080>>2]|0;B=c[a+5088>>2]|0;C=c[a+5096>>2]|0;D=c[a+5112>>2]|0;E=c[a+5120>>2]|0;F=c[a+5128>>2]|0;G=c[a+5136>>2]|0;H=c[a+5144>>2]|0;I=c[a+5152>>2]|0;J=c[a+5160>>2]|0;K=c[a+5168>>2]|0;L=c[a+5176>>2]|0;M=c[a+5184>>2]|0;N=c[a+5200>>2]|0;O=c[a+5208>>2]|0;P=c[a+5216>>2]|0;Q=c[a+5224>>2]|0;R=c[a+5232>>2]|0;S=c[a+5240>>2]|0;T=c[a+5248>>2]|0;U=c[a+5256>>2]|0;V=c[a+5264>>2]|0;W=c[a+5272>>2]|0;X=c[a+5288>>2]|0;Y=c[a+5296>>2]|0;Z=c[a+5304>>2]|0;_=c[a+5312>>2]|0;$=c[a+5320>>2]|0;aa=c[a+5328>>2]|0;ba=c[a+5336>>2]|0;ca=c[a+5344>>2]|0;da=c[a+5352>>2]|0;ea=c[a+5360>>2]|0;fa=c[a+5384>>2]|0;ga=c[a+5392>>2]|0;ha=c[a+5400>>2]|0;ia=c[a+5408>>2]|0;ja=c[a+5416>>2]|0;ka=c[a+5424>>2]|0;la=c[a+5432>>2]|0;ma=c[a+5440>>2]|0;na=c[a+5448>>2]|0;oa=c[a+5456>>2]|0;pa=c[a+5472>>2]|0;qa=c[a+5480>>2]|0;ra=c[a+5488>>2]|0;sa=c[a+5496>>2]|0;ta=c[a+5504>>2]|0;a:do{if((f|0)==(g|0)){ua=d;va=e;wa=h}else{c[j>>2]=g;c[j+4>>2]=f;Lu(8,0,7992,j);ua=c[(b+404|0)>>2]|0;va=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;wa=1}xa=c[va+256>>2]|0;ya=c[ua+256>>2]|0;if((xa|0)==(ya|0)){za=ua;Aa=va;Ba=wa}else{c[k>>2]=ya;c[k+4>>2]=xa;Lu(8,0,8072,k);za=c[(b+404|0)>>2]|0;Aa=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Ba=1}xa=c[Aa+252>>2]|0;ya=c[za+252>>2]|0;if((xa|0)==(ya|0)){Ca=za;Da=Aa;Ea=Ba}else{c[l>>2]=ya;c[l+4>>2]=xa;Lu(8,0,8144,l);Ca=c[(b+404|0)>>2]|0;Da=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Ea=1}xa=c[Da+248>>2]|0;ya=c[Ca+248>>2]|0;if((xa|0)==(ya|0)){Fa=Ca;Ga=Da;Ha=Ea}else{c[m>>2]=ya;c[m+4>>2]=xa;Lu(8,0,8208,m);Fa=c[(b+404|0)>>2]|0;Ga=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Ha=1}xa=c[Ga+244>>2]|0;ya=c[Fa+244>>2]|0;if((xa|0)==(ya|0)){Ia=Fa;Ja=Ga;Ka=Ha}else{c[n>>2]=ya;c[n+4>>2]=xa;Lu(8,0,8288,n);Ia=c[(b+404|0)>>2]|0;Ja=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Ka=1}xa=c[Ja+240>>2]|0;ya=c[Ia+240>>2]|0;if((xa|0)==(ya|0)){La=Ia;Ma=Ja;Na=Ka}else{c[o>>2]=ya;c[o+4>>2]=xa;Lu(8,0,8360,o);La=c[(b+404|0)>>2]|0;Ma=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Na=1}xa=c[Ma+236>>2]|0;ya=c[La+236>>2]|0;if((xa|0)==(ya|0)){Oa=La;Pa=Ma;Qa=Na}else{c[p>>2]=ya;c[p+4>>2]=xa;Lu(8,0,8440,p);Oa=c[(b+404|0)>>2]|0;Pa=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Qa=1}xa=c[Pa+232>>2]|0;ya=c[Oa+232>>2]|0;if((xa|0)==(ya|0)){Ra=Oa;Sa=Pa;Ta=Qa}else{c[q>>2]=ya;c[q+4>>2]=xa;Lu(8,0,8520,q);Ra=c[(b+404|0)>>2]|0;Sa=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Ta=1}xa=c[Sa+228>>2]|0;ya=c[Ra+228>>2]|0;if((xa|0)==(ya|0)){Ua=Ra;Va=Sa;Wa=Ta}else{c[r>>2]=ya;c[r+4>>2]=xa;Lu(8,0,8584,r);Ua=c[(b+404|0)>>2]|0;Va=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Wa=1}xa=c[Va+224>>2]|0;ya=c[Ua+224>>2]|0;if((xa|0)==(ya|0)){Xa=Ua;Ya=Va;Za=Wa}else{c[s>>2]=ya;c[s+4>>2]=xa;Lu(8,0,8664,s);Xa=c[(b+404|0)>>2]|0;Ya=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Za=1}xa=c[Ya+220>>2]|0;ya=c[Xa+220>>2]|0;if((xa|0)==(ya|0)){_a=Xa;$a=Ya;ab=Za}else{c[t>>2]=ya;c[t+4>>2]=xa;Lu(8,0,8736,t);_a=c[(b+404|0)>>2]|0;$a=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;ab=1}xa=c[$a+216>>2]|0;ya=c[_a+216>>2]|0;if((xa|0)==(ya|0)){bb=_a;cb=$a;db=ab}else{c[u>>2]=ya;c[u+4>>2]=xa;Lu(8,0,8816,u);bb=c[(b+404|0)>>2]|0;cb=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;db=1}xa=c[cb+212>>2]|0;ya=c[bb+212>>2]|0;if((xa|0)==(ya|0)){eb=bb;fb=cb;gb=db}else{c[v>>2]=ya;c[v+4>>2]=xa;Lu(8,0,8896,v);eb=c[(b+404|0)>>2]|0;fb=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;gb=1}xa=c[fb+208>>2]|0;ya=c[eb+208>>2]|0;if((xa|0)==(ya|0)){hb=eb;ib=fb;jb=gb}else{c[w>>2]=ya;c[w+4>>2]=xa;Lu(8,0,8960,w);hb=c[(b+404|0)>>2]|0;ib=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;jb=1}xa=c[ib+200>>2]|0;ya=c[hb+200>>2]|0;if((xa|0)==(ya|0)){kb=hb;lb=ib;mb=jb}else{c[x>>2]=ya;c[x+4>>2]=xa;Lu(8,0,9032,x);kb=c[(b+404|0)>>2]|0;lb=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;mb=1}xa=c[lb+204>>2]|0;ya=c[kb+204>>2]|0;if((xa|0)==(ya|0)){nb=kb;ob=lb;pb=mb}else{c[y>>2]=ya;c[y+4>>2]=xa;Lu(8,0,9104,y);nb=c[(b+404|0)>>2]|0;ob=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;pb=1}xa=c[ob+196>>2]|0;ya=c[nb+196>>2]|0;if((xa|0)==(ya|0)){qb=nb;rb=ob;sb=pb}else{c[z>>2]=ya;c[z+4>>2]=xa;Lu(8,0,9176,z);qb=c[(b+404|0)>>2]|0;rb=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;sb=1}xa=c[rb+192>>2]|0;ya=c[qb+192>>2]|0;if((xa|0)==(ya|0)){tb=qb;ub=rb;vb=sb}else{c[A>>2]=ya;c[A+4>>2]=xa;Lu(8,0,9248,A);tb=c[(b+404|0)>>2]|0;ub=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;vb=1}xa=c[ub+188>>2]|0;ya=c[tb+188>>2]|0;if((xa|0)==(ya|0)){wb=tb;xb=ub;yb=vb}else{c[B>>2]=ya;c[B+4>>2]=xa;Lu(8,0,9328,B);wb=c[(b+404|0)>>2]|0;xb=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;yb=1}xa=c[xb+184>>2]|0;ya=c[wb+184>>2]|0;if((xa|0)==(ya|0)){zb=wb;Ab=xb;Bb=yb}else{c[C>>2]=ya;c[C+4>>2]=xa;Lu(8,0,9408,C);zb=c[(b+404|0)>>2]|0;Ab=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Bb=1}xa=c[Ab+180>>2]|0;ya=c[zb+180>>2]|0;if((xa|0)==(ya|0)){Cb=zb;Db=Ab;Eb=Bb}else{c[D>>2]=ya;c[D+4>>2]=xa;Lu(8,0,9480,D);Cb=c[(b+404|0)>>2]|0;Db=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Eb=1}xa=c[Db+176>>2]|0;ya=c[Cb+176>>2]|0;if((xa|0)==(ya|0)){Fb=Cb;Gb=Db;Hb=Eb}else{c[E>>2]=ya;c[E+4>>2]=xa;Lu(8,0,9544,E);Fb=c[(b+404|0)>>2]|0;Gb=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Hb=1}xa=c[Gb+172>>2]|0;ya=c[Fb+172>>2]|0;if((xa|0)==(ya|0)){Ib=Fb;Jb=Gb;Kb=Hb}else{c[F>>2]=ya;c[F+4>>2]=xa;Lu(8,0,9624,F);Ib=c[(b+404|0)>>2]|0;Jb=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Kb=1}xa=c[Jb+168>>2]|0;ya=c[Ib+168>>2]|0;if((xa|0)==(ya|0)){Lb=Ib;Mb=Jb;Nb=Kb}else{c[G>>2]=ya;c[G+4>>2]=xa;Lu(8,0,9696,G);Lb=c[(b+404|0)>>2]|0;Mb=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Nb=1}xa=c[Mb+164>>2]|0;ya=c[Lb+164>>2]|0;if((xa|0)==(ya|0)){Ob=Lb;Pb=Mb;Qb=Nb}else{c[H>>2]=ya;c[H+4>>2]=xa;Lu(8,0,9776,H);Ob=c[(b+404|0)>>2]|0;Pb=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Qb=1}xa=c[Pb+160>>2]|0;ya=c[Ob+160>>2]|0;if((xa|0)==(ya|0)){Rb=Ob;Sb=Pb;Tb=Qb}else{c[I>>2]=ya;c[I+4>>2]=xa;Lu(8,0,9856,I);Rb=c[(b+404|0)>>2]|0;Sb=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Tb=1}xa=c[Sb+156>>2]|0;ya=c[Rb+156>>2]|0;if((xa|0)==(ya|0)){Ub=Rb;Vb=Sb;Wb=Tb}else{c[J>>2]=ya;c[J+4>>2]=xa;Lu(8,0,9920,J);Ub=c[(b+404|0)>>2]|0;Vb=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Wb=1}xa=c[Vb+152>>2]|0;ya=c[Ub+152>>2]|0;if((xa|0)==(ya|0)){Xb=Ub;Yb=Vb;Zb=Wb}else{c[K>>2]=ya;c[K+4>>2]=xa;Lu(8,0,1e4,K);Xb=c[(b+404|0)>>2]|0;Yb=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Zb=1}xa=c[Yb+148>>2]|0;ya=c[Xb+148>>2]|0;if((xa|0)==(ya|0)){_b=Xb;$b=Yb;ac=Zb}else{c[L>>2]=ya;c[L+4>>2]=xa;Lu(8,0,10072,L);_b=c[(b+404|0)>>2]|0;$b=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;ac=1}xa=c[$b+144>>2]|0;ya=c[_b+144>>2]|0;if((xa|0)==(ya|0)){bc=_b;cc=$b;dc=ac}else{c[M>>2]=ya;c[M+4>>2]=xa;Lu(8,0,10152,M);bc=c[(b+404|0)>>2]|0;cc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;dc=1}xa=c[cc+140>>2]|0;ya=c[bc+140>>2]|0;if((xa|0)==(ya|0)){ec=bc;fc=cc;gc=dc}else{c[N>>2]=ya;c[N+4>>2]=xa;Lu(8,0,10232,N);ec=c[(b+404|0)>>2]|0;fc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;gc=1}xa=c[fc+136>>2]|0;ya=c[ec+136>>2]|0;if((xa|0)==(ya|0)){hc=ec;ic=fc;jc=gc}else{c[O>>2]=ya;c[O+4>>2]=xa;Lu(8,0,10296,O);hc=c[(b+404|0)>>2]|0;ic=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;jc=1}xa=c[ic+128>>2]|0;ya=c[hc+128>>2]|0;if((xa|0)==(ya|0)){kc=hc;lc=ic;mc=jc}else{c[P>>2]=ya;c[P+4>>2]=xa;Lu(8,0,10368,P);kc=c[(b+404|0)>>2]|0;lc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;mc=1}xa=c[lc+132>>2]|0;ya=c[kc+132>>2]|0;if((xa|0)==(ya|0)){nc=kc;oc=lc;pc=mc}else{c[Q>>2]=ya;c[Q+4>>2]=xa;Lu(8,0,10440,Q);nc=c[(b+404|0)>>2]|0;oc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;pc=1}xa=c[oc+124>>2]|0;ya=c[nc+124>>2]|0;if((xa|0)==(ya|0)){qc=nc;rc=oc;sc=pc}else{c[R>>2]=ya;c[R+4>>2]=xa;Lu(8,0,10512,R);qc=c[(b+404|0)>>2]|0;rc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;sc=1}xa=c[rc+120>>2]|0;ya=c[qc+120>>2]|0;if((xa|0)==(ya|0)){tc=qc;uc=rc;vc=sc}else{c[S>>2]=ya;c[S+4>>2]=xa;Lu(8,0,10584,S);tc=c[(b+404|0)>>2]|0;uc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;vc=1}xa=c[uc+116>>2]|0;ya=c[tc+116>>2]|0;if((xa|0)==(ya|0)){wc=tc;xc=uc;yc=vc}else{c[T>>2]=ya;c[T+4>>2]=xa;Lu(8,0,10664,T);wc=c[(b+404|0)>>2]|0;xc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;yc=1}xa=c[xc+112>>2]|0;ya=c[wc+112>>2]|0;if((xa|0)==(ya|0)){zc=wc;Ac=xc;Bc=yc}else{c[U>>2]=ya;c[U+4>>2]=xa;Lu(8,0,10744,U);zc=c[(b+404|0)>>2]|0;Ac=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Bc=1}xa=c[Ac+108>>2]|0;ya=c[zc+108>>2]|0;if((xa|0)==(ya|0)){Cc=zc;Dc=Ac;Ec=Bc}else{c[V>>2]=ya;c[V+4>>2]=xa;Lu(8,0,10816,V);Cc=c[(b+404|0)>>2]|0;Dc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Ec=1}xa=c[Dc+104>>2]|0;ya=c[Cc+104>>2]|0;if((xa|0)==(ya|0)){Fc=Cc;Gc=Dc;Hc=Ec}else{c[W>>2]=ya;c[W+4>>2]=xa;Lu(8,0,10880,W);Fc=c[(b+404|0)>>2]|0;Gc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Hc=1}xa=c[Gc+100>>2]|0;ya=c[Fc+100>>2]|0;if((xa|0)==(ya|0)){Ic=Fc;Jc=Gc;Kc=Hc}else{c[X>>2]=ya;c[X+4>>2]=xa;Lu(8,0,10960,X);Ic=c[(b+404|0)>>2]|0;Jc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Kc=1}xa=c[Jc+96>>2]|0;ya=c[Ic+96>>2]|0;if((xa|0)==(ya|0)){Lc=Ic;Mc=Jc;Nc=Kc}else{c[Y>>2]=ya;c[Y+4>>2]=xa;Lu(8,0,11032,Y);Lc=c[(b+404|0)>>2]|0;Mc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Nc=1}xa=c[Mc+92>>2]|0;ya=c[Lc+92>>2]|0;if((xa|0)==(ya|0)){Oc=Lc;Pc=Mc;Qc=Nc}else{c[Z>>2]=ya;c[Z+4>>2]=xa;Lu(8,0,11112,Z);Oc=c[(b+404|0)>>2]|0;Pc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Qc=1}xa=c[Pc+88>>2]|0;ya=c[Oc+88>>2]|0;if((xa|0)==(ya|0)){Rc=Oc;Sc=Pc;Tc=Qc}else{c[_>>2]=ya;c[_+4>>2]=xa;Lu(8,0,11192,_);Rc=c[(b+404|0)>>2]|0;Sc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Tc=1}xa=c[Sc+84>>2]|0;ya=c[Rc+84>>2]|0;if((xa|0)==(ya|0)){Uc=Rc;Vc=Sc;Wc=Tc}else{c[$>>2]=ya;c[$+4>>2]=xa;Lu(8,0,11256,$);Uc=c[(b+404|0)>>2]|0;Vc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Wc=1}xa=c[Vc+80>>2]|0;ya=c[Uc+80>>2]|0;if((xa|0)==(ya|0)){Xc=Uc;Yc=Vc;Zc=Wc}else{c[aa>>2]=ya;c[aa+4>>2]=xa;Lu(8,0,11336,aa);Xc=c[(b+404|0)>>2]|0;Yc=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Zc=1}xa=c[Yc+76>>2]|0;ya=c[Xc+76>>2]|0;if((xa|0)==(ya|0)){_c=Xc;$c=Yc;ad=Zc}else{c[ba>>2]=ya;c[ba+4>>2]=xa;Lu(8,0,11408,ba);_c=c[(b+404|0)>>2]|0;$c=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;ad=1}xa=c[$c+72>>2]|0;ya=c[_c+72>>2]|0;if((xa|0)==(ya|0)){bd=_c;cd=$c;dd=ad}else{c[ca>>2]=ya;c[ca+4>>2]=xa;Lu(8,0,11488,ca);bd=c[(b+404|0)>>2]|0;cd=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;dd=1}xa=c[cd+68>>2]|0;ya=c[bd+68>>2]|0;if((xa|0)==(ya|0)){ed=bd;fd=cd;gd=dd}else{c[da>>2]=ya;c[da+4>>2]=xa;Lu(8,0,11568,da);ed=c[(b+404|0)>>2]|0;fd=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;gd=1}xa=c[fd+64>>2]|0;ya=c[ed+64>>2]|0;if((xa|0)==(ya|0)){hd=ed;id=gd}else{c[ea>>2]=ya;c[ea+4>>2]=xa;Lu(8,0,11632,ea);hd=c[(b+404|0)>>2]|0;id=1}xa=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;ya=c[xa+56>>2]|0;jd=c[hd+56>>2]|0;if((ya|0)==(jd|0)){kd=hd;ld=xa;md=id}else{c[fa>>2]=jd;c[fa+4>>2]=ya;Lu(8,0,11704,fa);kd=c[(b+404|0)>>2]|0;ld=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;md=1}ya=c[ld+60>>2]|0;jd=c[kd+60>>2]|0;if((ya|0)==(jd|0)){nd=kd;od=ld;pd=md}else{c[ga>>2]=jd;c[ga+4>>2]=ya;Lu(8,0,11776,ga);nd=c[(b+404|0)>>2]|0;od=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;pd=1}ya=c[od+52>>2]|0;jd=c[nd+52>>2]|0;if((ya|0)==(jd|0)){qd=od;rd=pd}else{c[ha>>2]=jd;c[ha+4>>2]=ya;Lu(8,0,11848,ha);qd=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;rd=1}ya=c[qd+48>>2]|0;jd=c[(b+404|0)>>2]|0;xa=c[jd+48>>2]|0;if((ya|0)==(xa|0)){sd=jd;td=qd;ud=rd}else{c[ia>>2]=xa;c[ia+4>>2]=ya;Lu(8,0,11920,ia);sd=c[(b+404|0)>>2]|0;td=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;ud=1}ya=c[td+44>>2]|0;xa=c[sd+44>>2]|0;if((ya|0)==(xa|0)){vd=sd;wd=td;xd=ud}else{c[ja>>2]=xa;c[ja+4>>2]=ya;Lu(8,0,12e3,ja);vd=c[(b+404|0)>>2]|0;wd=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;xd=1}ya=c[wd+40>>2]|0;xa=c[vd+40>>2]|0;if((ya|0)==(xa|0)){yd=vd;zd=wd;Ad=xd}else{c[ka>>2]=xa;c[ka+4>>2]=ya;Lu(8,0,12080,ka);yd=c[(b+404|0)>>2]|0;zd=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Ad=1}ya=c[zd+36>>2]|0;xa=c[yd+36>>2]|0;if((ya|0)==(xa|0)){Bd=yd;Cd=zd;Dd=Ad}else{c[la>>2]=xa;c[la+4>>2]=ya;Lu(8,0,12152,la);Bd=c[(b+404|0)>>2]|0;Cd=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Dd=1}ya=c[Cd+32>>2]|0;xa=c[Bd+32>>2]|0;if((ya|0)==(xa|0)){Ed=Bd;Fd=Cd;Gd=Dd}else{c[ma>>2]=xa;c[ma+4>>2]=ya;Lu(8,0,12216,ma);Ed=c[(b+404|0)>>2]|0;Fd=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Gd=1}ya=c[Fd+28>>2]|0;xa=c[Ed+28>>2]|0;if((ya|0)==(xa|0)){Hd=Ed;Id=Fd;Jd=Gd}else{c[na>>2]=xa;c[na+4>>2]=ya;Lu(8,0,12296,na);Hd=c[(b+404|0)>>2]|0;Id=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Jd=1}ya=c[Id+24>>2]|0;xa=c[Hd+24>>2]|0;if((ya|0)==(xa|0)){Kd=Hd;Ld=Id;Md=Jd}else{c[oa>>2]=xa;c[oa+4>>2]=ya;Lu(8,0,12368,oa);Kd=c[(b+404|0)>>2]|0;Ld=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Md=1}ya=c[Ld+20>>2]|0;xa=c[Kd+20>>2]|0;if((ya|0)==(xa|0)){Nd=Kd;Od=Ld;Pd=Md}else{c[pa>>2]=xa;c[pa+4>>2]=ya;Lu(8,0,12448,pa);Nd=c[(b+404|0)>>2]|0;Od=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Pd=1}ya=c[Od+16>>2]|0;xa=c[Nd+16>>2]|0;if((ya|0)==(xa|0)){Qd=Nd;Rd=Od;Sd=Pd}else{c[qa>>2]=xa;c[qa+4>>2]=ya;Lu(8,0,12528,qa);Qd=c[(b+404|0)>>2]|0;Rd=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Sd=1}ya=c[Rd+12>>2]|0;xa=c[Qd+12>>2]|0;if((ya|0)==(xa|0)){Td=Qd;Ud=Rd;Wd=Sd}else{c[ra>>2]=xa;c[ra+4>>2]=ya;Lu(8,0,12592,ra);Td=c[(b+404|0)>>2]|0;Ud=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Wd=1}ya=c[Ud+8>>2]|0;xa=c[Td+8>>2]|0;if((ya|0)==(xa|0)){Xd=Td;Yd=Ud;Zd=Wd}else{c[sa>>2]=xa;c[sa+4>>2]=ya;Lu(8,0,12672,sa);Xd=c[(b+404|0)>>2]|0;Yd=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;Zd=1}ya=c[Yd+4>>2]|0;xa=c[Xd+4>>2]|0;if((ya|0)==(xa|0)){_d=Xd;$d=Yd;ae=Zd}else{c[ta>>2]=xa;c[ta+4>>2]=ya;Lu(8,0,12744,ta);_d=c[(b+404|0)>>2]|0;$d=c[(c[c[(b+4|0)>>2]>>2]|0)+12>>2]|0;ae=1}ya=c[$d>>2]|0;xa=c[_d>>2]|0;if((ya|0)==(xa|0)){be=ae}else{c[a>>2]=xa;c[a+4>>2]=ya;Lu(8,0,12824,a);be=1}if((c[63960>>2]|0)==0){i=a;c[a+5584>>2]=6;c[a+5588>>2]=be|0;break a}Vd[c[16120]&511](8);i=a;c[a+5584>>2]=6;c[a+5588>>2]=be|0;break a}while(0)}



function HX(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;f=i;i=i+104|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=zY(20)|0;q=p;if((p|0)==0){r=12;i=f;return r|0}s=zY(2048)|0;c[p+16>>2]=s;if((s|0)==0){AY(p);r=12;i=f;return r|0}c[p>>2]=512;c[p+4>>2]=10240;c[p+8>>2]=128;c[p+12>>2]=0;s=XX(0,0)|0;if((s|0)==0){AY(c[p+16>>2]|0);AY(p);r=12;i=f;return r|0}t=o+0|0;u=t+44|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));c[o>>2]=s;c[o+4>>2]=q;c[o+12>>2]=d;c[o+36>>2]=e;d=o+28|0;c[d>>2]=-1;t=IX(o)|0;a:do{if((t|0)==0){u=o+20|0;v=c[u>>2]|0;w=v+ -1|0;c[b>>2]=w;x=c[o+8>>2]|0;y=c[d>>2]|0;if((y|0)>-1){if((c[o+32>>2]|0)!=0){z=0;A=2;B=0;C=0;break}}if((y|0)>(w|0)){z=0;A=6;B=0;C=0;break}w=BY(1,68)|0;D=w;if((w|0)==0){z=0;A=12;B=0;C=D;break}E=y>>>31;c[w+60>>2]=E^1;c[w+64>>2]=c[o+32>>2];c[w+28>>2]=v;if((E|0)==1){if((e&8|0)==0){F=13}else{G=0}}else{F=13}if((F|0)==13){E=JX(0,q,x,D)|0;if((E|0)!=0){z=0;A=E;B=0;C=D;break}E=c[w+40>>2]|0;if((E|0)>0){v=(E<<2)+4|0;y=zY(v)|0;H=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[w+32>>2]=H;fZ(y|0,-1,v|0)|0;I=H}else{I=0}H=BY(E<<1|1,4)|0;c[w+36>>2]=H;if((H|0)==0){z=0;A=12;B=0;C=D;break}H=BY(c[u>>2]|0,12)|0;if((H|0)==0){z=0;A=12;B=0;C=D;break}c[w+16>>2]=H;H=JX(s,q,x,D)|0;if((H|0)==0){G=I}else{z=0;A=H;B=0;C=D;break}}H=o+24|0;u=p+12|0;E=c[u>>2]|0;c[j>>2]=0;c[k>>2]=0;v=PX(q,x)|0;b:do{if((v|0)==0){y=PX(q,0)|0;if((y|0)!=0){J=y;break}y=p+16|0;K=c[u>>2]|0;c:do{if((K|0)>(E|0)){L=0;M=0;N=0;O=K;d:while(1){P=O+ -1|0;c[u>>2]=P;Q=c[y>>2]|0;R=c[Q+(P<<2)>>2]|0;P=O+ -2|0;c[u>>2]=P;S=c[Q+(P<<2)>>2]|0;do{if((R|0)==0){P=c[S>>2]|0;if((P|0)==2){T=c[S+4>>2]|0;U=PX(q,L)|0;if((U|0)!=0){V=N;W=U;break c}U=PX(q,S)|0;if((U|0)!=0){V=N;W=U;break c}U=PX(q,1)|0;if((U|0)!=0){V=N;W=U;break c}U=PX(q,c[T>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}U=PX(q,0)|0;if((U|0)!=0){V=N;W=U;break c}if((c[T+4>>2]|0)>1){F=45}else{if((c[T+8>>2]|0)>1){F=45}else{X=L}}if((F|0)==45){F=0;c[j>>2]=0;X=0}Y=X;Z=M+1|0;_=N;break}else if((P|0)==3){T=c[S+4>>2]|0;U=PX(q,c[T+4>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}U=PX(q,0)|0;if((U|0)!=0){V=N;W=U;break c}U=PX(q,c[T>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}$=PX(q,0)|0}else if((P|0)==1){U=c[S+4>>2]|0;T=PX(q,c[U+4>>2]|0)|0;if((T|0)!=0){V=N;W=T;break c}T=PX(q,0)|0;if((T|0)!=0){V=N;W=T;break c}T=PX(q,c[U>>2]|0)|0;if((T|0)!=0){V=N;W=T;break c}$=PX(q,0)|0}else if((P|0)==0){P=c[S+4>>2]|0;T=c[P>>2]|0;if(!((T|0)>-1|(T|0)==-4)){Y=L;Z=M;_=N;break}T=P+8|0;P=(c[T>>2]|0)+L|0;c[T>>2]=P;if((P|0)<=(c[k>>2]|0)){Y=L;Z=M;_=N;break}c[k>>2]=P;Y=L;Z=M;_=N;break}else{Y=L;Z=M;_=N;break}if(($|0)==0){Y=L;Z=M;_=N}else{V=N;W=$;break c}}else if((R|0)==1){P=S+4|0;T=c[P>>2]|0;U=O+ -3|0;c[u>>2]=U;aa=c[Q+(U<<2)>>2]|0;c[j>>2]=aa;U=T+4|0;ba=c[U>>2]|0;do{if((ba|0)>1){c[l>>2]=0;ca=T;F=51}else{if((c[T+8>>2]|0)<=1){da=aa;break}c[l>>2]=0;ea=T;if((ba|0)>0){ca=ea;F=51}else{fa=ba;ga=ea;ha=aa;ia=0;F=60}}}while(0);e:do{if((F|0)==51){F=0;ea=aa;ja=ba;ka=1;la=0;while(1){ma=QX(s,q,c[ca>>2]|0,(ka|0)<(ja|0)?1:2,j,G,m,k)|0;if((ma|0)!=0){J=ma;break b}ma=c[m>>2]|0;if((la|0)==0){na=ma}else{oa=ZX(s,0,0,1,32)|0;if((oa|0)==0){J=12;break b}pa=ZX(s,0,0,1,8)|0;qa=oa+4|0;c[qa>>2]=pa;if((pa|0)==0){J=12;break b}c[oa>>2]=1;c[oa+8>>2]=-1;c[oa+12>>2]=-1;c[pa>>2]=la;c[(c[qa>>2]|0)+4>>2]=ma;c[oa+16>>2]=(c[ma+16>>2]|0)+(c[la+16>>2]|0);na=oa}if((na|0)==0){J=12;break b}oa=c[U>>2]|0;if((ka|0)>=(oa|0)){fa=oa;ga=ca;ha=ea;ia=na;F=60;break e}ea=c[j>>2]|0;ja=oa;ka=ka+1|0;la=na}}}while(0);if((F|0)==60){F=0;U=T+8|0;ba=c[U>>2]|0;do{if((ba|0)==-1){la=c[j>>2]|0;ka=QX(s,q,c[ga>>2]|0,0,j,0,l,k)|0;if((ka|0)!=0){J=ka;break b}ka=c[l>>2]|0;ja=ZX(s,0,0,1,32)|0;ea=ja;if((ja|0)==0){F=65;break d}oa=ZX(s,0,0,1,16)|0;c[ja+4>>2]=oa;if((oa|0)==0){F=65;break d}c[ja>>2]=2;c[ja+8>>2]=-1;c[ja+12>>2]=-1;c[oa>>2]=ka;c[oa+4>>2]=0;c[oa+8>>2]=-1;ma=oa+12|0;a[ma]=a[ma]&-2;c[ja+16>>2]=c[ka+16>>2];c[l>>2]=ea;ra=ea;sa=la}else{if((fa|0)<(ba|0)){ta=0;ua=fa}else{ra=0;sa=ha;break}while(1){la=c[j>>2]|0;ea=QX(s,q,c[ga>>2]|0,0,j,0,n,k)|0;if((ea|0)!=0){J=ea;break b}ea=c[n>>2]|0;if((ta|0)==0){va=ea}else{ka=ZX(s,0,0,1,32)|0;if((ka|0)==0){F=73;break d}ja=ZX(s,0,0,1,8)|0;ma=ka+4|0;c[ma>>2]=ja;if((ja|0)==0){F=73;break d}c[ka>>2]=1;c[ka+8>>2]=-1;c[ka+12>>2]=-1;c[ja>>2]=ea;c[(c[ma>>2]|0)+4>>2]=ta;c[ka+16>>2]=(c[ta+16>>2]|0)+(c[ea+16>>2]|0);va=ka}c[l>>2]=va;if((va|0)==0){J=12;break b}ka=ZX(s,0,0,1,32)|0;if((ka|0)==0){J=12;break b}ea=ZX(s,0,0,1,20)|0;c[ka+4>>2]=ea;if((ea|0)==0){J=12;break b}c[ka>>2]=0;c[ka+8>>2]=-1;c[ka+12>>2]=-1;c[ea>>2]=-1;c[ea+4>>2]=-1;c[ea+8>>2]=-1;ea=ZX(s,0,0,1,32)|0;ma=ea;if((ea|0)==0){F=79;break d}ja=ZX(s,0,0,1,8)|0;oa=ea+4|0;c[oa>>2]=ja;if((ja|0)==0){F=79;break d}c[ea>>2]=3;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[ja>>2]=ka;c[(c[oa>>2]|0)+4>>2]=va;c[ea+16>>2]=(c[va+16>>2]|0)+(c[ka+16>>2]|0);c[l>>2]=ma;ka=ua+1|0;if((ka|0)<(c[U>>2]|0)){ta=ma;ua=ka}else{ra=ma;sa=la;break}}}}while(0);c[j>>2]=sa;do{if((ia|0)==0){wa=ra;F=85}else{if((ra|0)==0){xa=ia;break}U=ZX(s,0,0,1,32)|0;if((U|0)==0){J=12;break b}ba=ZX(s,0,0,1,8)|0;T=U+4|0;c[T>>2]=ba;if((ba|0)==0){J=12;break b}c[U>>2]=1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[ba>>2]=ia;c[(c[T>>2]|0)+4>>2]=ra;c[U+16>>2]=(c[ra+16>>2]|0)+(c[ia+16>>2]|0);wa=U;F=85}}while(0);if((F|0)==85){F=0;if((wa|0)==0){J=12;break b}else{xa=wa}}c[P>>2]=c[xa+4>>2];c[S>>2]=c[xa>>2];da=sa}U=M+ -1|0;T=da-aa+N|0;if((U|0)!=0){Y=da;Z=U;_=T;break}c[j>>2]=T;Y=T;Z=0;_=T}else{Y=L;Z=M;_=N}}while(0);S=c[u>>2]|0;if((S|0)>(E|0)){L=Y;M=Z;N=_;O=S}else{V=_;W=0;break c}}if((F|0)==65){c[l>>2]=0;J=12;break b}else if((F|0)==73){c[l>>2]=0;J=12;break b}else if((F|0)==79){c[l>>2]=0;J=12;break b}}else{V=0;W=0}}while(0);y=(c[H>>2]|0)+V|0;K=c[k>>2]|0;c[H>>2]=(K|0)>(y|0)?K:y;J=W}else{J=v}}while(0);if((J|0)!=0){z=0;A=J;B=0;C=D;break}v=c[H>>2]|0;c[H>>2]=v+1;E=ZX(s,0,0,1,32)|0;if((E|0)==0){z=0;A=12;B=0;C=D;break}y=ZX(s,0,0,1,20)|0;c[E+4>>2]=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[E>>2]=0;c[E+8>>2]=-1;c[E+12>>2]=-1;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=v;v=ZX(s,0,0,1,32)|0;y=v;if((v|0)==0){z=0;A=12;B=0;C=D;break}K=ZX(s,0,0,1,8)|0;O=v+4|0;c[O>>2]=K;if((K|0)==0){z=0;A=12;B=0;C=D;break}c[v>>2]=1;c[v+8>>2]=-1;c[v+12>>2]=-1;c[K>>2]=x;c[(c[O>>2]|0)+4>>2]=E;c[v+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);E=c[u>>2]|0;O=PX(q,v)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=PX(q,0)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=c[u>>2]|0;f:do{if((O|0)>(E|0)){K=p+16|0;N=O;g:while(1){M=N+ -1|0;c[u>>2]=M;L=c[K>>2]|0;S=c[L+(M<<2)>>2]|0;M=N+ -2|0;c[u>>2]=M;ya=c[L+(M<<2)>>2]|0;do{if((S|0)==3){M=c[ya+4>>2]|0;L=c[M>>2]|0;do{if((c[M+4>>2]|0)==0){F=141}else{if((c[L+8>>2]|0)!=0){F=141;break}c[ya+8>>2]=0}}while(0);if((F|0)==141){F=0;c[ya+8>>2]=1}c[ya+24>>2]=c[L+24>>2];c[ya+28>>2]=c[(c[M>>2]|0)+28>>2]}else if((S|0)==2){Q=c[ya+4>>2]|0;R=c[Q>>2]|0;T=R+8|0;if((c[T>>2]|0)==0){za=0}else{za=(c[(c[Q+4>>2]|0)+8>>2]|0)!=0|0}c[ya+8>>2]=za;if((c[T>>2]|0)==0){c[ya+24>>2]=c[R+24>>2];Aa=Q+4|0}else{T=OX(q,R,0,0,g)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}Ba=zY((c[g>>2]<<2)+4|0)|0;T=Ba;if((Ba|0)==0){z=0;A=12;B=0;C=D;break a}c[Ba>>2]=-1;c[h>>2]=0;Ca=OX(q,c[Q>>2]|0,T,h,0)|0;if((Ca|0)!=0){F=150;break g}R=Q+4|0;U=NX(s,c[(c[R>>2]|0)+24>>2]|0,c[(c[Q>>2]|0)+24>>2]|0,T,c[h>>2]|0)|0;T=ya+24|0;c[T>>2]=U;AY(Ba);if((c[T>>2]|0)==0){z=0;A=12;B=0;C=D;break a}else{Aa=R}}R=c[Aa>>2]|0;if((c[R+8>>2]|0)==0){c[ya+28>>2]=c[R+28>>2];break}T=OX(q,R,0,0,g)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}Da=zY((c[g>>2]<<2)+4|0)|0;T=Da;if((Da|0)==0){z=0;A=12;B=0;C=D;break a}c[Da>>2]=-1;c[h>>2]=0;Ea=OX(q,c[Aa>>2]|0,T,h,0)|0;if((Ea|0)!=0){F=157;break g}R=NX(s,c[(c[Q>>2]|0)+28>>2]|0,c[(c[Aa>>2]|0)+28>>2]|0,T,c[h>>2]|0)|0;T=ya+28|0;c[T>>2]=R;AY(Da);if((c[T>>2]|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==1){T=c[ya+4>>2]|0;R=c[T>>2]|0;Q=T+4|0;U=c[Q>>2]|0;if((c[R+8>>2]|0)==0){Fa=(c[U+8>>2]|0)!=0|0}else{Fa=1}c[ya+8>>2]=Fa;ba=NX(s,c[R+24>>2]|0,c[U+24>>2]|0,0,0)|0;c[ya+24>>2]=ba;if((ba|0)==0){z=0;A=12;B=0;C=D;break a}ba=NX(s,c[(c[T>>2]|0)+28>>2]|0,c[(c[Q>>2]|0)+28>>2]|0,0,0)|0;c[ya+28>>2]=ba;if((ba|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==0){ba=c[ya>>2]|0;if((ba|0)==3){Q=PX(q,ya)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=PX(q,1)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=ya+4|0;T=PX(q,c[(c[Q>>2]|0)+4>>2]|0)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}T=PX(q,0)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}T=PX(q,c[c[Q>>2]>>2]|0)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}T=PX(q,0)|0;if((T|0)==0){break}else{z=0;A=T;B=0;C=D;break a}}else if((ba|0)==2){T=PX(q,ya)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}T=PX(q,3)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}T=PX(q,c[c[ya+4>>2]>>2]|0)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}T=PX(q,0)|0;if((T|0)==0){break}else{z=0;A=T;B=0;C=D;break a}}else if((ba|0)==0){T=c[ya+4>>2]|0;Q=c[T>>2]|0;if((Q|0)==-4){c[ya+8>>2]=0;U=T+8|0;R=c[U>>2]|0;la=ZX(s,0,0,1,64)|0;if((la|0)==0){F=104;break g}ma=la;c[la>>2]=R;c[la+4>>2]=0;c[la+8>>2]=1114111;c[la+20>>2]=0;c[la+24>>2]=0;R=la+28|0;la=ya+24|0;c[R+0>>2]=-1;c[R+4>>2]=-1;c[R+8>>2]=-1;c[R+12>>2]=-1;c[la>>2]=ma;ma=c[U>>2]|0;U=c[T+4>>2]|0;la=ZX(s,0,0,1,64)|0;if((la|0)==0){F=106;break g}c[la>>2]=ma;c[la+4>>2]=0;c[la+8>>2]=1114111;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=U;c[la+32>>2]=-1;c[la+36>>2]=-1;c[la+40>>2]=-1;c[ya+28>>2]=la;break}la=ya+8|0;if((Q|0)<0){c[la>>2]=1;U=ZX(s,0,0,1,32)|0;if((U|0)==0){F=110;break g}c[U>>2]=-1;c[U+4>>2]=-1;c[U+8>>2]=-1;c[ya+24>>2]=U;U=ZX(s,0,0,1,32)|0;if((U|0)==0){F=112;break g}c[U>>2]=-1;c[U+4>>2]=-1;c[U+8>>2]=-1;c[ya+28>>2]=U;break}else{c[la>>2]=0;la=T+8|0;U=c[la>>2]|0;ma=T+4|0;R=c[ma>>2]|0;ka=ZX(s,0,0,1,64)|0;if((ka|0)==0){F=115;break g}ea=ka;c[ka>>2]=U;c[ka+4>>2]=Q;c[ka+8>>2]=R;c[ka+20>>2]=0;c[ka+24>>2]=0;R=ka+28|0;ka=ya+24|0;c[R+0>>2]=-1;c[R+4>>2]=-1;c[R+8>>2]=-1;c[R+12>>2]=-1;c[ka>>2]=ea;ea=c[la>>2]|0;la=c[T>>2]|0;ka=c[ma>>2]|0;ma=c[T+12>>2]|0;R=c[T+16>>2]|0;T=ZX(s,0,0,1,64)|0;if((T|0)==0){F=117;break g}Q=T;c[T>>2]=ea;c[T+4>>2]=la;c[T+8>>2]=ka;c[T+20>>2]=ma;c[T+24>>2]=R;R=T+28|0;T=ya+28|0;c[R+0>>2]=-1;c[R+4>>2]=-1;c[R+8>>2]=-1;c[R+12>>2]=-1;c[T>>2]=Q;break}}else if((ba|0)==1){ba=PX(q,ya)|0;if((ba|0)!=0){z=0;A=ba;B=0;C=D;break a}ba=PX(q,2)|0;if((ba|0)!=0){z=0;A=ba;B=0;C=D;break a}ba=ya+4|0;Q=PX(q,c[(c[ba>>2]|0)+4>>2]|0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=PX(q,0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=PX(q,c[c[ba>>2]>>2]|0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=PX(q,0)|0;if((Q|0)==0){break}else{z=0;A=Q;B=0;C=D;break a}}else{break}}}while(0);N=c[u>>2]|0;if((N|0)<=(E|0)){break f}}if((F|0)==104){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==106){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==110){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==112){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==115){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==117){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==150){AY(Ba);z=0;A=Ca;B=0;C=D;break a}else if((F|0)==157){AY(Da);z=0;A=Ea;B=0;C=D;break a}}}while(0);E=c[H>>2]|0;u=E<<2;O=zY(u)|0;x=O;if((O|0)==0){z=x;A=12;B=0;C=D;break}N=zY(u)|0;u=N;if((N|0)==0){z=x;A=12;B=u;C=D;break}if((E|0)>0){fZ(O|0,0,((E|0)>1?E<<2:4)|0)|0}KX(y,0,x,0)|0;E=c[H>>2]|0;if((E|0)>0){K=0;S=0;while(1){c[N+(S<<2)>>2]=K;Q=O+(S<<2)|0;ba=K+1+(c[Q>>2]|0)|0;c[Q>>2]=0;Q=S+1|0;if((Q|0)<(E|0)){S=Q;K=ba}else{Ga=ba;break}}}else{Ga=0}K=BY(Ga+1|0,32)|0;S=K;if((K|0)==0){z=x;A=12;B=u;C=D;break}c[w>>2]=S;E=w+4|0;c[E>>2]=Ga;ba=KX(y,S,x,u)|0;if((ba|0)!=0){z=x;A=ba;B=u;C=D;break}c[w+20>>2]=0;ba=v+24|0;S=c[ba>>2]|0;if((c[S>>2]|0)>-1){Q=1;T=S;while(1){S=T+32|0;R=Q+1|0;if((c[S>>2]|0)>-1){T=S;Q=R}else{Ha=R;break}}}else{Ha=1}Q=BY(Ha,32)|0;if((Q|0)==0){z=x;A=12;B=u;C=D;break}c[w+8>>2]=Q;T=c[ba>>2]|0;y=c[T>>2]|0;if((y|0)>-1){R=y;y=T;T=0;while(1){c[Q+(T<<5)+8>>2]=K+(c[N+(R<<2)>>2]<<5);c[Q+(T<<5)+12>>2]=R;S=Q+(T<<5)+16|0;c[S>>2]=0;ma=y+12|0;ka=c[ma>>2]|0;if((ka|0)!=0){la=0;while(1){Ia=la+1|0;if((c[ka+(la<<2)>>2]|0)>-1){la=Ia}else{break}}la=Ia<<2;ka=zY(la)|0;c[S>>2]=ka;if((ka|0)==0){z=x;A=12;B=u;C=D;break a}dZ(ka|0,c[ma>>2]|0,la|0)|0}c[Q+(T<<5)+20>>2]=c[y+16>>2];la=T+1|0;ka=y+32|0;ea=c[ka>>2]|0;if((ea|0)>-1){R=ea;y=ka;T=la}else{Ja=la;break}}}else{Ja=0}c[Q+(Ja<<5)+8>>2]=0;c[E>>2]=Ga;c[w+12>>2]=K+(c[N+(c[c[v+28>>2]>>2]<<2)>>2]<<5);c[w+52>>2]=c[H>>2];c[w+56>>2]=e;YX(s);AY(c[p+16>>2]|0);AY(p);AY(O);AY(N);c[b+4>>2]=w;r=0;i=f;return r|0}else{z=0;A=t;B=0;C=0}}while(0);YX(s);AY(c[p+16>>2]|0);AY(p);if((z|0)!=0){AY(z)}if((B|0)!=0){AY(B)}c[b+4>>2]=C;LX(b);r=A;i=f;return r|0}function IX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0;d=i;i=i+424|0;e=d;f=d+8|0;g=d+72|0;h=d+328|0;j=d+336|0;k=d+384|0;l=d+392|0;m=c[b+4>>2]|0;n=m+12|0;o=c[n>>2]|0;if((c[b+40>>2]|0)==0){p=b+20|0;PX(m,c[p>>2]|0)|0;PX(m,2)|0;c[p>>2]=(c[p>>2]|0)+1}p=PX(m,0)|0;q=b+12|0;r=b+16|0;c[r>>2]=c[q>>2];s=c[n>>2]|0;t=(p|0)==0;a:do{if((s|0)>(o|0)&t){u=m+16|0;v=b+36|0;w=b;x=b+24|0;y=b+20|0;z=g;A=f;B=b+28|0;C=l;D=k;E=k+1|0;F=j;G=b;H=j+12|0;I=j+40|0;J=j+24|0;K=j+8|0;L=s;M=0;N=0;b:while(1){O=L+ -1|0;c[n>>2]=O;P=c[u>>2]|0;c:do{switch(c[P+(O<<2)>>2]|0){case 10:{Q=L+ -2|0;c[n>>2]=Q;c[v>>2]=c[P+(Q<<2)>>2];R=M;S=N;T=0;break};case 4:{Q=PX(m,9)|0;if((Q|0)!=0){U=M;V=Q;W=6;break b}R=M;S=N;T=PX(m,1)|0;break};case 8:{Q=L+ -2|0;c[n>>2]=Q;X=c[P+(Q<<2)>>2]|0;Q=c[w>>2]|0;Y=ZX(Q,0,0,1,32)|0;if((Y|0)==0){Z=12;W=294;break b}_=ZX(Q,0,0,1,8)|0;Q=Y+4|0;c[Q>>2]=_;if((_|0)==0){Z=12;W=294;break b}c[Y>>2]=3;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[_>>2]=X;c[(c[Q>>2]|0)+4>>2]=N;c[Y+16>>2]=(c[N+16>>2]|0)+(c[X+16>>2]|0);R=M;S=Y;T=0;break};case 2:{Y=L+ -2|0;c[n>>2]=Y;X=c[P+(Y<<2)>>2]|0;if((c[N+12>>2]|0)>-1){Y=c[w>>2]|0;Q=ZX(Y,0,0,1,32)|0;if((Q|0)==0){Z=12;W=294;break b}_=ZX(Y,0,0,1,20)|0;c[Q+4>>2]=_;if((_|0)==0){Z=12;W=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[_>>2]=-1;c[_+4>>2]=-1;c[_+8>>2]=-1;_=c[w>>2]|0;Y=ZX(_,0,0,1,32)|0;if((Y|0)==0){Z=12;W=294;break b}$=ZX(_,0,0,1,8)|0;_=Y+4|0;c[_>>2]=$;if(($|0)==0){Z=12;W=294;break b}c[Y>>2]=1;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[$>>2]=Q;c[(c[_>>2]|0)+4>>2]=N;_=N+16|0;$=Y+16|0;c[$>>2]=(c[_>>2]|0)+(c[Q+16>>2]|0);c[$>>2]=c[_>>2];aa=Y}else{aa=N}c[aa+12>>2]=X;X=aa+16|0;c[X>>2]=(c[X>>2]|0)+1;R=M;S=aa;T=0;break};case 0:{if((c[v>>2]&1|0)!=0){X=PX(m,7)|0;if((X|0)!=0){U=M;V=X;W=6;break b}}R=M;S=N;T=PX(m,3)|0;break};case 6:{X=L+ -2|0;c[n>>2]=X;Y=c[P+(X<<2)>>2]|0;X=c[w>>2]|0;_=ZX(X,0,0,1,32)|0;if((_|0)==0){Z=12;W=294;break b}$=ZX(X,0,0,1,8)|0;X=_+4|0;c[X>>2]=$;if(($|0)==0){Z=12;W=294;break b}c[_>>2]=1;c[_+8>>2]=-1;c[_+12>>2]=-1;c[$>>2]=Y;c[(c[X>>2]|0)+4>>2]=N;c[_+16>>2]=(c[N+16>>2]|0)+(c[Y+16>>2]|0);R=M;S=_;T=0;break};case 9:{_=c[q>>2]|0;Y=a[_]|0;switch(Y<<24>>24|0){case 92:{X=c[v>>2]|0;if((X&1|0)!=0){R=M;S=N;T=0;break c}$=_+1|0;if((a[$]|0)!=123){R=M;S=N;T=0;break c}c[q>>2]=$;ba=X;ca=$;break};case 123:{$=c[v>>2]|0;if(($&1|0)==0){R=M;S=N;T=0;break c}else{ba=$;ca=_}break};case 42:{W=41;break};case 63:case 43:{if((c[v>>2]&1|0)==0){R=M;S=N;T=0;break c}else{W=41}break};default:{R=M;S=N;T=0;break c}}if((W|0)==41){W=0;c[q>>2]=_+1;_=c[w>>2]|0;$=ZX(_,0,0,1,32)|0;if(($|0)==0){Z=12;W=294;break b}X=ZX(_,0,0,1,16)|0;c[$+4>>2]=X;if((X|0)==0){Z=12;W=294;break b}c[$>>2]=2;c[$+8>>2]=-1;c[$+12>>2]=-1;c[X>>2]=N;c[X+4>>2]=Y<<24>>24==43;c[X+8>>2]=Y<<24>>24==63?1:-1;Y=X+12|0;a[Y]=a[Y]&-2;c[$+16>>2]=c[N+16>>2];R=M;S=$;T=PX(m,9)|0;break c}$=ca+1|0;c[q>>2]=$;Y=a[$]|0;if((Y+ -48<<24>>24&255)<10){X=Y<<24>>24;if((X+ -48|0)>>>0<10){da=X;ea=-1;fa=$}else{Z=10;W=294;break b}while(1){X=((ea|0)<0?-48:(ea*10|0)+ -48|0)+da|0;_=fa+1|0;Q=a[_]|0;ga=Q<<24>>24;if((ga+ -48|0)>>>0<10){fa=_;ea=X;da=ga}else{ha=Q;ia=X;ja=_;break}}}else{ha=Y;ia=-1;ja=$}do{if(ha<<24>>24==44){_=ja+1|0;X=a[_]|0;Q=X<<24>>24;if((Q+ -48|0)>>>0<10){ka=Q;la=-1;ma=_}else{na=X;oa=-1;pa=_;break}while(1){_=((la|0)<0?-48:(la*10|0)+ -48|0)+ka|0;X=ma+1|0;Q=a[X]|0;ga=Q<<24>>24;if((ga+ -48|0)>>>0<10){ma=X;la=_;ka=ga}else{qa=Q;ra=_;sa=X;W=54;break}}}else{qa=ha;ra=ia;sa=ja;W=54}}while(0);do{if((W|0)==54){W=0;if(!((ra|0)>-1)){na=qa;oa=ra;pa=sa;break}if((ia|0)>(ra|0)|(ra|0)>255){Z=10;W=294;break b}else{na=qa;oa=ra;pa=sa}}}while(0);if(na<<24>>24==0){Z=9;W=294;break b}if((pa|0)==($|0)){Z=10;W=294;break b}if((ba&1|0)==0){if(!(na<<24>>24==92)){Z=10;W=294;break b}if((a[pa+1|0]|0)!=125){Z=10;W=294;break b}ta=pa+2|0}else{if(!(na<<24>>24==125)){Z=10;W=294;break b}ta=pa+1|0}if((oa|ia|0)==0){Y=c[w>>2]|0;X=ZX(Y,0,0,1,32)|0;if((X|0)==0){Z=12;W=294;break b}_=ZX(Y,0,0,1,20)|0;c[X+4>>2]=_;if((_|0)==0){Z=12;W=294;break b}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[_>>2]=-1;c[_+4>>2]=-1;c[_+8>>2]=-1;ua=X}else{X=(oa&ia|0)<0;_=c[w>>2]|0;Y=ZX(_,0,0,1,32)|0;if((Y|0)==0){Z=12;W=294;break b}Q=ZX(_,0,0,1,16)|0;c[Y+4>>2]=Q;if((Q|0)==0){Z=12;W=294;break b}c[Y>>2]=2;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[Q>>2]=N;c[Q+4>>2]=X?1:ia;c[Q+8>>2]=X?1:oa;X=Q+12|0;a[X]=a[X]&-2;c[Y+16>>2]=c[N+16>>2];ua=Y}c[q>>2]=ta;R=M;S=ua;T=PX(m,9)|0;break};case 3:{Y=PX(m,5)|0;if((Y|0)!=0){U=M;V=Y;W=6;break b}R=M;S=N;T=PX(m,4)|0;break};case 7:{Y=c[q>>2]|0;X=a[Y]|0;if((X|0)==41){c[q>>2]=Y+1;R=M;S=N;T=0;break c}else if((X|0)!=124){R=M;S=N;T=0;break c}X=PX(m,7)|0;if((X|0)!=0){U=M;V=X;W=6;break b}X=PX(m,N)|0;if((X|0)!=0){U=M;V=X;W=6;break b}X=PX(m,8)|0;if((X|0)!=0){U=M;V=X;W=6;break b}X=PX(m,3)|0;if((X|0)!=0){U=M;V=X;W=6;break b}c[q>>2]=(c[q>>2]|0)+1;R=M;S=N;T=0;break};case 1:{X=c[q>>2]|0;d:do{switch(a[X]|0){case 40:{if((c[v>>2]&1|0)!=0){va=X;W=74}break};case 0:{W=265;break};case 92:{Y=X+1|0;Q=a[Y]|0;do{if((c[v>>2]&1|0)==0){if(Q<<24>>24==40){c[q>>2]=Y;va=Y;W=74;break d}else{_=a[X+1|0]|0;if(_<<24>>24==41){W=265;break d}else{wa=_;break}}}else{wa=Q}}while(0);Q=X+1|0;Y=wa<<24>>24==0;if(Y){Z=5;W=294;break b}else{xa=150412|0;ya=0}while(1){_=ya+1|0;if((a[150408+(ya<<3)|0]|0)==wa<<24>>24){za=xa;break}ga=150412+(_<<3)|0;if((_|0)==12){za=ga;break}else{xa=ga;ya=_}}_=c[za>>2]|0;if((_|0)!=0){ga=F+0|0;Aa=G+0|0;Ba=ga+40|0;do{c[ga>>2]=c[Aa>>2];ga=ga+4|0;Aa=Aa+4|0}while((ga|0)<(Ba|0));c[H>>2]=_;c[I>>2]=1;Aa=IX(j)|0;if((Aa|0)!=0){Z=Aa;W=294;break b}c[q>>2]=(c[q>>2]|0)+2;c[x>>2]=c[J>>2];R=M;S=c[K>>2]|0;T=0;break c}if(Y){Z=5;W=294;break b}c[q>>2]=Q;Aa=a[Q]|0;e:do{switch(Aa|0){case 62:{ga=c[w>>2]|0;Ba=ZX(ga,0,0,1,32)|0;Ca=Ba;do{if((Ba|0)==0){Da=0}else{Ea=ZX(ga,0,0,1,20)|0;c[Ba+4>>2]=Ea;if((Ea|0)==0){Da=0;break}c[Ba>>2]=0;c[Ba+8>>2]=-1;c[Ba+12>>2]=-1;c[Ea>>2]=-2;c[Ea+4>>2]=32;c[Ea+8>>2]=-1;Da=Ca}}while(0);c[q>>2]=(c[q>>2]|0)+1;Fa=Da;break};case 66:{Ca=c[w>>2]|0;Ba=ZX(Ca,0,0,1,32)|0;ga=Ba;do{if((Ba|0)==0){Ga=0}else{Ea=ZX(Ca,0,0,1,20)|0;c[Ba+4>>2]=Ea;if((Ea|0)==0){Ga=0;break}c[Ba>>2]=0;c[Ba+8>>2]=-1;c[Ba+12>>2]=-1;c[Ea>>2]=-2;c[Ea+4>>2]=128;c[Ea+8>>2]=-1;Ga=ga}}while(0);c[q>>2]=(c[q>>2]|0)+1;Fa=Ga;break};case 98:{ga=c[w>>2]|0;Ba=ZX(ga,0,0,1,32)|0;Ca=Ba;do{if((Ba|0)==0){Ha=0}else{Ea=ZX(ga,0,0,1,20)|0;c[Ba+4>>2]=Ea;if((Ea|0)==0){Ha=0;break}c[Ba>>2]=0;c[Ba+8>>2]=-1;c[Ba+12>>2]=-1;c[Ea>>2]=-2;c[Ea+4>>2]=64;c[Ea+8>>2]=-1;Ha=Ca}}while(0);c[q>>2]=(c[q>>2]|0)+1;Fa=Ha;break};case 60:{Ca=c[w>>2]|0;Ba=ZX(Ca,0,0,1,32)|0;ga=Ba;do{if((Ba|0)==0){Ia=0}else{Ea=ZX(Ca,0,0,1,20)|0;c[Ba+4>>2]=Ea;if((Ea|0)==0){Ia=0;break}c[Ba>>2]=0;c[Ba+8>>2]=-1;c[Ba+12>>2]=-1;c[Ea>>2]=-2;c[Ea+4>>2]=16;c[Ea+8>>2]=-1;Ia=ga}}while(0);c[q>>2]=(c[q>>2]|0)+1;Fa=Ia;break};case 120:{ga=X+2|0;c[q>>2]=ga;Ba=a[ga]|0;if(Ba<<24>>24==123){ga=X+3|0;c[q>>2]=ga;Ca=ga;ga=0;while(1){Ea=a[Ca]|0;if(Ea<<24>>24==0|Ea<<24>>24==125){Ja=ga;Ka=Ca;break}if((vX(Ea<<24>>24)|0)==0){Z=9;W=294;break b}Ea=c[q>>2]|0;a[l+ga|0]=a[Ea]|0;La=ga+1|0;Ma=Ea+1|0;c[q>>2]=Ma;if(La>>>0>31){Ja=La;Ka=Ma;break}else{Ca=Ma;ga=La}}c[q>>2]=Ka+1;a[l+Ja|0]=0;ga=Qb(C|0,0,16)|0;Ca=c[w>>2]|0;La=c[x>>2]|0;Ma=ZX(Ca,0,0,1,32)|0;Ea=Ma;do{if((Ma|0)==0){Na=0}else{Oa=ZX(Ca,0,0,1,20)|0;c[Ma+4>>2]=Oa;if((Oa|0)==0){Na=0;break}c[Ma>>2]=0;c[Ma+8>>2]=-1;c[Ma+12>>2]=-1;c[Oa>>2]=ga;c[Oa+4>>2]=ga;c[Oa+8>>2]=La;Na=Ea}}while(0);c[x>>2]=(c[x>>2]|0)+1;Fa=Na;break e}else{a[D+0|0]=0;a[D+1|0]=0;a[D+2|0]=0;Ea=(vX(Ba<<24>>24)|0)==0;La=c[q>>2]|0;if(Ea){Pa=La}else{a[D]=a[La]|0;Ea=La+1|0;c[q>>2]=Ea;Pa=Ea}if((vX(a[Pa]|0)|0)!=0){Ea=c[q>>2]|0;a[E]=a[Ea]|0;c[q>>2]=Ea+1}Ea=Qb(D|0,0,16)|0;La=c[w>>2]|0;ga=c[x>>2]|0;Ma=ZX(La,0,0,1,32)|0;Ca=Ma;do{if((Ma|0)==0){Qa=0}else{Oa=ZX(La,0,0,1,20)|0;c[Ma+4>>2]=Oa;if((Oa|0)==0){Qa=0;break}c[Ma>>2]=0;c[Ma+8>>2]=-1;c[Ma+12>>2]=-1;c[Oa>>2]=Ea;c[Oa+4>>2]=Ea;c[Oa+8>>2]=ga;Qa=Ca}}while(0);c[x>>2]=(c[x>>2]|0)+1;Fa=Qa;break e}break};default:{if((oX(Aa)|0)!=0){Ca=(a[c[q>>2]|0]|0)+ -48|0;ga=c[w>>2]|0;Ea=c[x>>2]|0;Ma=ZX(ga,0,0,1,32)|0;if((Ma|0)==0){Z=12;W=294;break b}La=ZX(ga,0,0,1,20)|0;c[Ma+4>>2]=La;if((La|0)==0){Z=12;W=294;break b}c[Ma>>2]=0;c[Ma+8>>2]=-1;c[Ma+12>>2]=-1;c[La>>2]=-4;c[La+4>>2]=Ca;c[La+8>>2]=Ea;c[x>>2]=(c[x>>2]|0)+1;Ea=c[B>>2]|0;c[B>>2]=(Ca|0)<(Ea|0)?Ea:Ca;c[q>>2]=(c[q>>2]|0)+1;R=M;S=Ma;T=0;break c}Ma=c[w>>2]|0;Ca=a[c[q>>2]|0]|0;Ea=c[x>>2]|0;La=ZX(Ma,0,0,1,32)|0;ga=La;do{if((La|0)==0){Ra=0}else{Ba=ZX(Ma,0,0,1,20)|0;c[La+4>>2]=Ba;if((Ba|0)==0){Ra=0;break}c[La>>2]=0;c[La+8>>2]=-1;c[La+12>>2]=-1;c[Ba>>2]=Ca;c[Ba+4>>2]=Ca;c[Ba+8>>2]=Ea;Ra=ga}}while(0);c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1;Fa=Ra}}}while(0);if((Fa|0)==0){Z=12;W=294;break b}else{R=M;S=Fa;T=0;break c}break};case 36:{if((c[v>>2]&1|0)==0){if((a[X+1|0]|0)!=0){break d}}Aa=c[w>>2]|0;Q=ZX(Aa,0,0,1,32)|0;if((Q|0)==0){Z=12;W=294;break b}Y=ZX(Aa,0,0,1,20)|0;c[Q+4>>2]=Y;if((Y|0)==0){Z=12;W=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[Y>>2]=-2;c[Y+4>>2]=2;c[Y+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;R=M;S=Q;T=0;break c;break};case 41:{if((M|0)!=0){W=264}break};case 63:case 43:case 123:case 124:case 42:{W=264;break};case 94:{if((c[v>>2]&1|0)==0){if((X|0)!=(c[r>>2]|0)){break d}Q=PX(m,5)|0;if((Q|0)!=0){U=M;V=Q;W=6;break b}}Q=c[w>>2]|0;Y=ZX(Q,0,0,1,32)|0;if((Y|0)==0){Z=12;W=294;break b}Aa=ZX(Q,0,0,1,20)|0;c[Y+4>>2]=Aa;if((Aa|0)==0){Z=12;W=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[Aa>>2]=-2;c[Aa+4>>2]=1;c[Aa+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;R=M;S=Y;T=0;break c;break};case 46:{Y=(c[v>>2]&4|0)==0;Aa=c[w>>2]|0;Q=c[x>>2]|0;_=ZX(Aa,0,0,1,32)|0;ga=_;Ea=(_|0)==0;if(Y){if(Ea){Z=12;W=294;break b}Y=ZX(Aa,0,0,1,20)|0;c[_+4>>2]=Y;if((Y|0)==0){Z=12;W=294;break b}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[Y>>2]=0;c[Y+4>>2]=1114111;c[Y+8>>2]=Q;Sa=ga;Ta=(c[x>>2]|0)+1|0}else{if(Ea){Z=12;W=294;break b}Ea=ZX(Aa,0,0,1,20)|0;c[_+4>>2]=Ea;if((Ea|0)==0){Z=12;W=294;break b}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[Ea>>2]=0;c[Ea+4>>2]=9;c[Ea+8>>2]=Q;Q=c[w>>2]|0;Ea=(c[x>>2]|0)+1|0;Aa=ZX(Q,0,0,1,32)|0;if((Aa|0)==0){Z=12;W=294;break b}Y=ZX(Q,0,0,1,20)|0;c[Aa+4>>2]=Y;if((Y|0)==0){Z=12;W=294;break b}c[Aa>>2]=0;c[Aa+8>>2]=-1;c[Aa+12>>2]=-1;c[Y>>2]=11;c[Y+4>>2]=1114111;c[Y+8>>2]=Ea;Ea=c[w>>2]|0;Y=ZX(Ea,0,0,1,32)|0;if((Y|0)==0){Z=12;W=294;break b}Q=ZX(Ea,0,0,1,8)|0;Ea=Y+4|0;c[Ea>>2]=Q;if((Q|0)==0){Z=12;W=294;break b}c[Y>>2]=3;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[Q>>2]=ga;c[(c[Ea>>2]|0)+4>>2]=Aa;c[Y+16>>2]=(c[Aa+16>>2]|0)+(c[_+16>>2]|0);Sa=Y;Ta=(c[x>>2]|0)+2|0}c[x>>2]=Ta;c[q>>2]=(c[q>>2]|0)+1;R=M;S=Sa;T=0;break c;break};case 91:{Y=X+1|0;c[q>>2]=Y;_=zY(128)|0;if((_|0)==0){Z=12;W=294;break b}if((a[Y]|0)==94){Aa=X+2|0;c[q>>2]=Aa;Ua=Aa;Va=1}else{Ua=Y;Va=0}Y=(Va|0)==0;Aa=_;_=0;Ea=0;ga=32;Q=Ua;f:while(1){Ca=a[Q]|0;if(Ca<<24>>24==0){Wa=Aa;Xa=Q;Ya=7;W=140;break}else if(Ca<<24>>24==93){if(Q>>>0>(c[q>>2]|0)>>>0){W=85;break}}Ca=DX(e,Q,-1)|0;if((Ca|0)<0){c[e>>2]=-1;Za=1}else{Za=Ca}Ca=Q+Za|0;do{if((a[Ca]|0)==45){La=Za+1|0;Ma=Q+La|0;if((a[Ma]|0)==93){W=94;break}Ba=c[e>>2]|0;Oa=DX(e,Ma,-1)|0;if((Oa|0)<0){c[e>>2]=-1;_a=-1;$a=1}else{_a=c[e>>2]|0;$a=Oa}ab=0;bb=_a;cb=Ba;db=Q+($a+La)|0;eb=Ba>>>0>_a>>>0?11:0}else{W=94}}while(0);g:do{if((W|0)==94){W=0;Ba=a[Q]|0;do{if(Ba<<24>>24==45){if((a[Q+1|0]|0)==93){fb=0;break}fb=(c[q>>2]|0)==(Q|0)?0:11}else if(Ba<<24>>24==91){La=a[Q+1|0]|0;if(La<<24>>24==61|La<<24>>24==46){Wa=Aa;Xa=Q;Ya=3;W=140;break f}else if(!(La<<24>>24==58)){fb=0;break}La=Q+2|0;Oa=La;while(1){Ma=a[Oa]|0;gb=Ma<<24>>24==0;if(Ma<<24>>24!=58&(gb^1)){Oa=Oa+1|0}else{break}}if(gb){Wa=Aa;Xa=Q;Ya=4;W=140;break f}Ma=Oa-Q+ -2|0;hb=(Ma|0)>63?63:Ma;mZ(A|0,La|0,hb|0)|0;a[f+hb|0]=0;hb=nX(A)|0;ab=hb;bb=1114111;cb=0;db=Oa+2|0;eb=(hb|0)==0?4:0;break g}else{fb=0}}while(0);Ba=c[e>>2]|0;ab=0;bb=Ba;cb=Ba;db=Ca;eb=fb}}while(0);if((eb|0)!=0){Wa=Aa;Xa=db;Ya=eb;W=140;break}Ca=(ab|0)!=0;do{if(Y|Ca^1){Ba=c[w>>2]|0;if((Ea|0)<(ga|0)){ib=Aa;jb=ga}else{if((ga|0)>1024){Wa=Aa;Xa=db;Ya=12;W=140;break f}hb=CY(Aa,ga<<3)|0;if((hb|0)==0){Wa=Aa;Xa=db;Ya=12;W=140;break f}else{ib=hb;jb=ga<<1}}hb=ZX(Ba,0,0,1,32)|0;if((hb|0)==0){W=112;break f}Ma=ZX(Ba,0,0,1,20)|0;Ba=hb+4|0;c[Ba>>2]=Ma;if((Ma|0)==0){W=112;break f}c[hb>>2]=0;c[hb+8>>2]=-1;c[hb+12>>2]=-1;c[Ma>>2]=cb;c[Ma+4>>2]=bb;c[Ma+8>>2]=-1;c[ib+(Ea<<2)>>2]=hb;c[(c[Ba>>2]|0)+12>>2]=ab;kb=ib;lb=_;mb=Ea+1|0;nb=jb;ob=0}else{if((_|0)>63){kb=Aa;lb=_;mb=Ea;nb=ga;ob=12;break}c[g+(_<<2)>>2]=ab;kb=Aa;lb=_+1|0;mb=Ea;nb=ga;ob=0}}while(0);Ba=(ob|0)==0;if(Ba&(((c[v>>2]&2|0)==0|Ca)^1)){pb=kb;qb=mb;rb=nb;sb=cb}else{if(Ba){Aa=kb;_=lb;Ea=mb;ga=nb;Q=db;continue}else{Wa=kb;Xa=db;Ya=ob;W=140;break}}while(1){Ba=sb;while(1){if(Ba>>>0>bb>>>0){Aa=pb;_=lb;Ea=qb;ga=rb;Q=db;continue f}if((qX(Ba)|0)!=0){W=118;break}tb=Ba+1|0;if((uX(Ba)|0)==0){Ba=tb}else{W=129;break}}if((W|0)==118){W=0;hb=wX(Ba)|0;Ma=Ba+1|0;h:do{if((qX(Ma)|0)==0){ub=hb;vb=Ma}else{wb=hb;xb=Ma;while(1){if((wX(xb)|0)!=(wb+1|0)|xb>>>0>bb>>>0){ub=wb;vb=xb;break h}yb=wX(xb)|0;zb=xb+1|0;if((qX(zb)|0)==0){ub=yb;vb=zb;break}else{wb=yb;xb=zb}}}}while(0);Ma=c[w>>2]|0;if((qb|0)<(rb|0)){Ab=pb;Bb=rb}else{if((rb|0)>1024){Wa=pb;Xa=db;Ya=12;W=140;break f}xb=CY(pb,rb<<3)|0;if((xb|0)==0){Wa=pb;Xa=db;Ya=12;W=140;break f}else{Ab=xb;Bb=rb<<1}}xb=ZX(Ma,0,0,1,32)|0;wb=xb;do{if((xb|0)==0){Cb=0}else{Oa=ZX(Ma,0,0,1,20)|0;c[xb+4>>2]=Oa;if((Oa|0)==0){Cb=0;break}c[xb>>2]=0;c[xb+8>>2]=-1;c[xb+12>>2]=-1;c[Oa>>2]=hb;c[Oa+4>>2]=ub;c[Oa+8>>2]=-1;Cb=wb}}while(0);c[Ab+(qb<<2)>>2]=Cb;Db=Cb;Eb=Ab;Fb=Bb;Gb=vb}else if((W|0)==129){W=0;wb=yX(Ba)|0;i:do{if((uX(tb)|0)==0){Hb=wb;Ib=tb}else{hb=wb;xb=tb;while(1){if((yX(xb)|0)!=(hb+1|0)|xb>>>0>bb>>>0){Hb=hb;Ib=xb;break i}Ma=xb+1|0;Oa=yX(xb)|0;if((uX(Ma)|0)==0){Hb=Oa;Ib=Ma;break}else{hb=Oa;xb=Ma}}}}while(0);Ba=c[w>>2]|0;if((qb|0)<(rb|0)){Jb=pb;Kb=rb}else{if((rb|0)>1024){Wa=pb;Xa=db;Ya=12;W=140;break f}xb=CY(pb,rb<<3)|0;if((xb|0)==0){Wa=pb;Xa=db;Ya=12;W=140;break f}else{Jb=xb;Kb=rb<<1}}xb=ZX(Ba,0,0,1,32)|0;hb=xb;do{if((xb|0)==0){Lb=0}else{Ma=ZX(Ba,0,0,1,20)|0;c[xb+4>>2]=Ma;if((Ma|0)==0){Lb=0;break}c[xb>>2]=0;c[xb+8>>2]=-1;c[xb+12>>2]=-1;c[Ma>>2]=wb;c[Ma+4>>2]=Hb;c[Ma+8>>2]=-1;Lb=hb}}while(0);c[Jb+(qb<<2)>>2]=Lb;Db=Lb;Eb=Jb;Fb=Kb;Gb=Ib}if((Db|0)==0){W=141;break f}else{pb=Eb;qb=qb+1|0;rb=Fb;sb=Gb}}}j:do{if((W|0)==85){W=0;c[q>>2]=Q+1;ga=(Va|0)!=0;if(ga){_b(Aa|0,Ea|0,4,55)}k:do{if((Ea|0)>0){Y=(_|0)>0;Ca=_<<2;hb=Ca+4|0;if(ga){Mb=0;Nb=0;Ob=0;Pb=0}else{wb=0;xb=0;while(1){Ba=Aa+(wb<<2)|0;Ma=c[(c[Ba>>2]|0)+4>>2]|0;do{if((Ma|0)==0){Rb=xb;Sb=0}else{c[Ma+8>>2]=c[x>>2];if(Y){Oa=ZX(c[w>>2]|0,0,0,0,hb)|0;La=Ma+16|0;c[La>>2]=Oa;if((Oa|0)==0){Tb=Aa;Ub=xb;Vb=12;break j}dZ(Oa|0,z|0,Ca|0)|0;c[(c[La>>2]|0)+(_<<2)>>2]=0}else{c[Ma+16>>2]=0}if((xb|0)==0){Rb=c[Ba>>2]|0;Sb=0;break}La=c[w>>2]|0;Oa=c[Ba>>2]|0;zb=ZX(La,0,0,1,32)|0;yb=zb;do{if((zb|0)==0){Wb=0}else{Xb=ZX(La,0,0,1,8)|0;Yb=zb+4|0;c[Yb>>2]=Xb;if((Xb|0)==0){Wb=0;break}c[zb>>2]=3;c[zb+8>>2]=-1;c[zb+12>>2]=-1;c[Xb>>2]=xb;c[(c[Yb>>2]|0)+4>>2]=Oa;c[zb+16>>2]=(c[Oa+16>>2]|0)+(c[xb+16>>2]|0);Wb=yb}}while(0);Rb=Wb;Sb=(Wb|0)==0?12:0}}while(0);Ba=wb+1|0;if((Ba|0)<(Ea|0)&(Sb|0)==0){wb=Ba;xb=Rb}else{Zb=0;$b=Rb;ac=Sb;break k}}}while(1){xb=Aa+(Ob<<2)|0;wb=c[(c[xb>>2]|0)+4>>2]|0;Ba=c[wb>>2]|0;Ma=wb+4|0;yb=c[Ma>>2]|0;do{if((Ba|0)<(Mb|0)){Oa=yb+1|0;bc=(Oa|0)<(Mb|0)?Mb:Oa;cc=Nb;dc=Pb;ec=0}else{if((Ba|0)<=(Nb|0)){Oa=yb+1|0;bc=Oa;cc=Oa;dc=Pb;ec=0;break}c[wb>>2]=Nb;c[Ma>>2]=Ba+ -1;Oa=yb+1|0;if((wb|0)==0){bc=Oa;cc=Oa;dc=Pb;ec=0;break}c[wb+8>>2]=c[x>>2];if(Y){zb=ZX(c[w>>2]|0,0,0,0,hb)|0;La=wb+16|0;c[La>>2]=zb;if((zb|0)==0){Tb=Aa;Ub=Pb;Vb=12;break j}dZ(zb|0,z|0,Ca|0)|0;c[(c[La>>2]|0)+(_<<2)>>2]=0}else{c[wb+16>>2]=0}if((Pb|0)==0){bc=Oa;cc=Oa;dc=c[xb>>2]|0;ec=0;break}La=c[w>>2]|0;zb=c[xb>>2]|0;Yb=ZX(La,0,0,1,32)|0;Xb=Yb;do{if((Yb|0)==0){fc=0}else{gc=ZX(La,0,0,1,8)|0;hc=Yb+4|0;c[hc>>2]=gc;if((gc|0)==0){fc=0;break}c[Yb>>2]=3;c[Yb+8>>2]=-1;c[Yb+12>>2]=-1;c[gc>>2]=Pb;c[(c[hc>>2]|0)+4>>2]=zb;c[Yb+16>>2]=(c[zb+16>>2]|0)+(c[Pb+16>>2]|0);fc=Xb}}while(0);bc=Oa;cc=Oa;dc=fc;ec=(fc|0)==0?12:0}}while(0);xb=Ob+1|0;if((xb|0)<(Ea|0)&(ec|0)==0){Mb=bc;Nb=cc;Ob=xb;Pb=dc}else{Zb=cc;$b=dc;ac=ec;break}}}else{Zb=0;$b=0;ac=0}}while(0);if((ac|0)!=0|ga^1){Tb=Aa;Ub=$b;Vb=ac;break}Ca=c[w>>2]|0;hb=c[x>>2]|0;Y=ZX(Ca,0,0,1,32)|0;xb=Y;if((Y|0)==0){Tb=Aa;Ub=$b;Vb=12;break}wb=ZX(Ca,0,0,1,20)|0;c[Y+4>>2]=wb;if((wb|0)==0){Tb=Aa;Ub=$b;Vb=12;break}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[wb>>2]=Zb;c[wb+4>>2]=1114111;c[wb+8>>2]=hb;if((_|0)>0){hb=_<<2;Ca=ZX(c[w>>2]|0,0,0,0,hb+4|0)|0;yb=wb+16|0;c[yb>>2]=Ca;if((Ca|0)==0){Tb=Aa;Ub=$b;Vb=12;break}dZ(Ca|0,z|0,hb|0)|0;c[(c[yb>>2]|0)+(_<<2)>>2]=0}else{c[wb+16>>2]=0}if(($b|0)==0){Tb=Aa;Ub=xb;Vb=0;break}wb=c[w>>2]|0;yb=ZX(wb,0,0,1,32)|0;hb=yb;do{if((yb|0)==0){ic=0}else{Ca=ZX(wb,0,0,1,8)|0;Ba=yb+4|0;c[Ba>>2]=Ca;if((Ca|0)==0){ic=0;break}c[yb>>2]=3;c[yb+8>>2]=-1;c[yb+12>>2]=-1;c[Ca>>2]=$b;c[(c[Ba>>2]|0)+4>>2]=xb;c[yb+16>>2]=(c[Y+16>>2]|0)+(c[$b+16>>2]|0);ic=hb}}while(0);Tb=Aa;Ub=ic;Vb=(ic|0)==0?12:0}else if((W|0)==112){W=0;c[ib+(Ea<<2)>>2]=0;Wa=ib;Xa=db;Ya=12;W=140}else if((W|0)==141){W=0;c[q>>2]=db;Tb=Eb;Ub=0;Vb=12}}while(0);if((W|0)==140){W=0;c[q>>2]=Xa;Tb=Wa;Ub=0;Vb=Ya}AY(Tb);c[x>>2]=(c[x>>2]|0)+1;if((Vb|0)==0){R=M;S=Ub;T=0;break c}else{Z=Vb;W=294;break b}break};default:{}}}while(0);if((W|0)==74){W=0;$=M+1|0;c[q>>2]=va+1;Ea=PX(m,c[y>>2]|0)|0;if((Ea|0)!=0){U=$;V=Ea;W=6;break b}Ea=PX(m,2)|0;if((Ea|0)!=0){U=$;V=Ea;W=6;break b}Ea=PX(m,0)|0;if((Ea|0)!=0){U=$;V=Ea;W=6;break b}c[y>>2]=(c[y>>2]|0)+1;R=$;S=N;T=0;break c}else if((W|0)==264){W=0;if((c[v>>2]&1|0)!=0){W=265}}if((W|0)==265){W=0;$=c[w>>2]|0;Ea=ZX($,0,0,1,32)|0;if((Ea|0)==0){Z=12;W=294;break b}Aa=ZX($,0,0,1,20)|0;c[Ea+4>>2]=Aa;if((Aa|0)==0){Z=12;W=294;break b}c[Ea>>2]=0;c[Ea+8>>2]=-1;c[Ea+12>>2]=-1;c[Aa>>2]=-1;c[Aa+4>>2]=-1;c[Aa+8>>2]=-1;R=M;S=Ea;T=0;break c}Ea=DX(h,X,-1)|0;if((Ea|0)<0){c[h>>2]=-1;jc=1}else{jc=Ea}do{if((c[v>>2]&2|0)==0){W=280}else{if((uX(c[h>>2]|0)|0)==0){if((qX(c[h>>2]|0)|0)==0){W=280;break}}Ea=c[w>>2]|0;Aa=wX(c[h>>2]|0)|0;$=wX(c[h>>2]|0)|0;_=c[x>>2]|0;Q=ZX(Ea,0,0,1,32)|0;if((Q|0)==0){Z=12;W=294;break b}hb=ZX(Ea,0,0,1,20)|0;c[Q+4>>2]=hb;if((hb|0)==0){Z=12;W=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[hb>>2]=Aa;c[hb+4>>2]=$;c[hb+8>>2]=_;_=c[w>>2]|0;hb=yX(c[h>>2]|0)|0;$=yX(c[h>>2]|0)|0;Aa=c[x>>2]|0;Ea=ZX(_,0,0,1,32)|0;if((Ea|0)==0){Z=12;W=294;break b}Y=ZX(_,0,0,1,20)|0;c[Ea+4>>2]=Y;if((Y|0)==0){Z=12;W=294;break b}c[Ea>>2]=0;c[Ea+8>>2]=-1;c[Ea+12>>2]=-1;c[Y>>2]=hb;c[Y+4>>2]=$;c[Y+8>>2]=Aa;Aa=c[w>>2]|0;Y=ZX(Aa,0,0,1,32)|0;if((Y|0)==0){Z=12;W=294;break b}$=ZX(Aa,0,0,1,8)|0;Aa=Y+4|0;c[Aa>>2]=$;if(($|0)==0){Z=12;W=294;break b}c[Y>>2]=3;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[$>>2]=Q;c[(c[Aa>>2]|0)+4>>2]=Ea;c[Y+16>>2]=(c[Ea+16>>2]|0)+(c[Q+16>>2]|0);kc=Y}}while(0);if((W|0)==280){W=0;X=c[w>>2]|0;Y=c[h>>2]|0;Q=c[x>>2]|0;Ea=ZX(X,0,0,1,32)|0;if((Ea|0)==0){Z=12;W=294;break b}Aa=ZX(X,0,0,1,20)|0;c[Ea+4>>2]=Aa;if((Aa|0)==0){Z=12;W=294;break b}c[Ea>>2]=0;c[Ea+8>>2]=-1;c[Ea+12>>2]=-1;c[Aa>>2]=Y;c[Aa+4>>2]=Y;c[Aa+8>>2]=Q;kc=Ea}c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+jc;R=M;S=kc;T=0;break};case 5:{Ea=c[q>>2]|0;Q=a[Ea]|0;if(Q<<24>>24==0){R=M;S=N;T=0;break c}Aa=c[v>>2]&1;Y=(Aa|0)!=0;if(Y&Q<<24>>24==124){R=M;S=N;T=0;break c}do{if(!(Y&Q<<24>>24==41&(M|0)>0)){if((Aa|0)==0&Q<<24>>24==92){if((a[Ea+1|0]|0)==41){break}}X=PX(m,5)|0;if((X|0)!=0){U=M;V=X;W=6;break b}X=PX(m,N)|0;if((X|0)!=0){U=M;V=X;W=6;break b}X=PX(m,6)|0;if((X|0)!=0){U=M;V=X;W=6;break b}R=M;S=N;T=PX(m,4)|0;break c}}while(0);Q=(Aa|M|0)==0?8:0;Y=M+ -1|0;if((Aa|0)!=0){R=Y;S=N;T=Q;break c}c[q>>2]=Ea+2;R=Y;S=N;T=Q;break};default:{R=M;S=N;T=0}}}while(0);P=c[n>>2]|0;O=(T|0)==0;if((P|0)>(o|0)&O){L=P;M=R;N=S}else{lc=O;mc=R;nc=S;oc=T;break a}}if((W|0)==6){lc=(V|0)==0;mc=U;nc=N;oc=V;break}else if((W|0)==294){i=d;return Z|0}}else{lc=t;mc=0;nc=0;oc=p}}while(0);p=(mc|0)>0;if(p|lc^1){Z=p?8:oc;i=d;return Z|0}c[b+8>>2]=nc;Z=0;i=d;return Z|0}function JX(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;g=i;h=d+12|0;j=c[h>>2]|0;k=(b|0)==0|(f|0)==0;if(!k){c[f+48>>2]=0;c[c[f+36>>2]>>2]=-1}l=c[f+28>>2]|0;m=zY((l<<3)+8|0)|0;n=m;if((m|0)==0){o=12;i=g;return o|0}c[m>>2]=-1;p=zY((l<<2)+4|0)|0;if((p|0)==0){AY(m);o=12;i=g;return o|0}c[p>>2]=-1;q=0;while(1){if(q>>>0>l>>>0){break}else{q=q+1|0}}PX(d,e)|0;e=PX(d,0)|0;q=c[h>>2]|0;a:do{if((q|0)>(j|0)&(e|0)==0){l=d+16|0;r=f+32|0;s=f+16|0;t=f+36|0;u=q;v=0;w=-1;x=1;y=0;z=0;A=n;B=0;while(1){C=u+ -1|0;c[h>>2]=C;D=c[l>>2]|0;b:do{switch(c[D+(C<<2)>>2]|0){case 6:{E=u+ -2|0;c[h>>2]=E;F=c[D+(E<<2)>>2]|0;E=0;do{G=A+(E<<2)|0;E=E+1|0}while((c[G>>2]|0)>-1);c[G>>2]=F<<1|1;c[A+(E<<2)>>2]=-1;H=0;while(1){if((c[p+(H<<2)>>2]|0)>-1){H=H+1|0}else{break}}c[p+(H+ -1<<2)>>2]=-1;I=v;J=w;K=x;L=y;M=z;N=A;O=0;P=B;break};case 5:{E=u+ -2|0;c[h>>2]=E;F=c[D+(E<<2)>>2]|0;if(!k){I=v;J=w;K=x;L=y;M=z;N=A;O=0;P=B;break b}E=c[F+4>>2]|0;c[F+20>>2]=(c[(c[E+4>>2]|0)+20>>2]|0)+(c[(c[E>>2]|0)+20>>2]|0);I=v;J=w;K=x;L=y;M=z;N=A;O=0;P=B;break};case 2:{E=A;while(1){if((c[E>>2]|0)>-1){E=E+4|0}else{I=v;J=w;K=x;L=y;M=z;N=E;O=0;P=B;break}}break};case 3:{E=c[D+(u+ -2<<2)>>2]|0;H=c[D+(u+ -3<<2)>>2]|0;F=c[D+(u+ -4<<2)>>2]|0;Q=u+ -5|0;c[h>>2]=Q;if(k){R=c[F+4>>2]|0;S=F+16|0;c[F+20>>2]=(c[(c[R>>2]|0)+20>>2]|0)+(c[D+(Q<<2)>>2]|0)+(c[(c[R+4>>2]|0)+20>>2]|0)+((c[S>>2]|0)>0?2:0);T=S;U=c[h>>2]|0}else{T=F+16|0;U=Q}Q=c[D+(U+ -1<<2)>>2]|0;F=U+ -2|0;c[h>>2]=F;S=c[D+(F<<2)>>2]|0;F=U+ -3|0;c[h>>2]=F;R=c[D+(F<<2)>>2]|0;if((c[T>>2]|0)<=0){I=1;J=w;K=x;L=y;M=z;N=Q;O=0;P=B;break b}if(k){V=0}else{SX(b,E,S)|0;c[(c[r>>2]|0)+(S<<2)>>2]=1;S=SX(b,H,R)|0;c[(c[r>>2]|0)+(R<<2)>>2]=1;V=S}I=1;J=w;K=x;L=y;M=z+2|0;N=Q;O=V;P=B;break};case 1:{Q=u+ -2|0;c[h>>2]=Q;S=c[D+(Q<<2)>>2]|0;if(k){Q=c[(c[c[S+4>>2]>>2]|0)+20>>2]|0;R=u+ -3|0;c[h>>2]=R;c[S+20>>2]=(c[D+(R<<2)>>2]|0)+Q;I=v;J=-1;K=x;L=y;M=z;N=A;O=0;P=B;break b}else{Q=u+ -3|0;c[h>>2]=Q;R=c[D+(Q<<2)>>2]|0;Q=u+ -4|0;c[h>>2]=Q;S=(R|0)==0;I=S&1;J=S?w:c[D+(Q<<2)>>2]|0;K=x;L=y;M=z;N=A;O=0;P=B;break b}break};case 0:{Q=u+ -2|0;c[h>>2]=Q;S=c[D+(Q<<2)>>2]|0;Q=S;R=S+12|0;H=c[R>>2]|0;if((H|0)>-1){E=0;do{W=A+(E<<2)|0;E=E+1|0}while((c[W>>2]|0)>-1);c[W>>2]=H<<1;c[A+(E<<2)>>2]=-1;do{if(!k){F=0;while(1){if((c[p+(F<<2)>>2]|0)>-1){F=F+1|0}else{break}}c[(c[s>>2]|0)+(H*12|0)+8>>2]=0;if((F|0)<=0){break}X=zY((F<<2)+4|0)|0;Y=X;if((X|0)==0){Z=w;_=y;$=z;aa=A;ba=12;ca=B;break a}c[(c[s>>2]|0)+(H*12|0)+8>>2]=Y;da=c[p>>2]|0;if((da|0)>-1){ea=Y;fa=da;da=0;while(1){c[ea>>2]=fa;ga=da+1|0;ha=c[p+(ga<<2)>>2]|0;ia=X+(ga<<2)|0;if((ha|0)>-1){da=ga;fa=ha;ea=ia}else{ja=ia;break}}}else{ja=Y}c[ja>>2]=-1}}while(0);H=PX(d,c[R>>2]|0)|0;if((H|0)!=0){Z=w;_=y;$=z;aa=A;ba=H;ca=B;break a}H=PX(d,6)|0;if((H|0)!=0){Z=w;_=y;$=z;aa=A;ba=H;ca=B;break a}}H=c[S>>2]|0;do{if((H|0)==1){E=c[S+4>>2]|0;ea=c[E>>2]|0;fa=c[E+4>>2]|0;E=PX(d,S)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=PX(d,5)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=PX(d,fa)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=PX(d,0)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=ea+20|0;da=PX(d,(c[E>>2]|0)+x|0)|0;if((da|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=da;qa=B;break}if((c[E>>2]|0)>0){E=(c[fa+20>>2]|0)>0;ra=(E&1)+x|0;sa=E?x:-1}else{ra=x;sa=-1}E=PX(d,sa)|0;if((E|0)!=0){ka=v;la=w;ma=ra;na=y;oa=z;pa=E;qa=B;break}E=PX(d,4)|0;if((E|0)!=0){ka=v;la=w;ma=ra;na=y;oa=z;pa=E;qa=B;break}E=PX(d,ea)|0;if((E|0)!=0){ka=v;la=w;ma=ra;na=y;oa=z;pa=E;qa=B;break}ka=v;la=w;ma=ra;na=y;oa=z;pa=PX(d,0)|0;qa=B}else if((H|0)==3){E=c[S+4>>2]|0;ea=c[E>>2]|0;fa=c[E+4>>2]|0;E=(c[A>>2]|0)>-1;da=x+1|0;X=PX(d,E?da:x)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=PX(d,E?x:B)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=PX(d,A)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=PX(d,(c[A>>2]|0)>>>31^1)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=PX(d,S)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=fa;fa=PX(d,X)|0;if((fa|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=fa;qa=B;break}fa=ea;ea=PX(d,fa)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=PX(d,3)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=PX(d,X)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=PX(d,0)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=PX(d,2)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=PX(d,fa)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=PX(d,0)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}if((c[A>>2]|0)>-1){if(k){ta=w;ua=y;va=0}else{ea=RX(b,Q,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){fa=c[t>>2]|0;X=0;while(1){wa=fa+(X<<2)|0;xa=X+1|0;if((c[wa>>2]|0)>-1){X=xa}else{break}}c[wa>>2]=B;c[fa+(xa<<2)>>2]=w;c[fa+(X+2<<2)>>2]=-1;ya=-1;za=y+1|0}else{ya=w;za=y}Y=c[A>>2]|0;if((Y|0)>-1){E=c[s>>2]|0;F=Y;Y=0;do{ia=(F|0)/2|0;if((F&1|0)==0){c[E+(ia*12|0)>>2]=B}else{c[E+(ia*12|0)+4>>2]=B}Y=Y+1|0;F=c[A+(Y<<2)>>2]|0;}while((F|0)>-1)}c[A>>2]=-1;ta=ya;ua=za;va=ea}c[A>>2]=-1;Aa=ta;Ba=da;Ca=ua;Da=z+1|0;Ea=va;Fa=x}else{Aa=w;Ba=x;Ca=y;Da=z;Ea=0;Fa=B}if((c[S+16>>2]|0)<=0){ka=v;la=Aa;ma=Ba;na=Ca;oa=Da;pa=Ea;qa=Fa;break}ka=v;la=Aa;ma=Ba+2|0;na=Ca;oa=Da;pa=Ea;qa=Ba+1|0}else if((H|0)==0){F=c[c[S+4>>2]>>2]|0;if(!((F|0)>-1|(F|0)==-4)){ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}if(!((c[A>>2]|0)>-1)){ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}if(k){c[S+20>>2]=1;Ga=w;Ha=y;Ia=0}else{F=RX(b,Q,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){Y=c[t>>2]|0;E=0;while(1){Ja=Y+(E<<2)|0;Ka=E+1|0;if((c[Ja>>2]|0)>-1){E=Ka}else{break}}c[Ja>>2]=B;c[Y+(Ka<<2)>>2]=w;c[Y+(E+2<<2)>>2]=-1;La=-1;Ma=y+1|0}else{La=w;Ma=y}da=c[A>>2]|0;if((da|0)>-1){ea=c[s>>2]|0;X=da;da=0;do{fa=(X|0)/2|0;if((X&1|0)==0){c[ea+(fa*12|0)>>2]=B}else{c[ea+(fa*12|0)+4>>2]=B}da=da+1|0;X=c[A+(da<<2)>>2]|0;}while((X|0)>-1)}c[A>>2]=-1;Ga=La;Ha=Ma;Ia=F}c[A>>2]=-1;ka=v;la=Ga;ma=x+1|0;na=Ha;oa=z+1|0;pa=Ia;qa=x}else if((H|0)==2){X=c[S+4>>2]|0;if(k){if((c[A>>2]|0)>-1){Na=1}else{Na=a[X+12|0]&1}da=PX(d,Na)|0;if((da|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=da;qa=B;break}}else{da=PX(d,B)|0;if((da|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=da;qa=B;break}da=PX(d,a[X+12|0]&1)|0;if((da|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=da;qa=B;break}}da=PX(d,S)|0;if((da|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=da;qa=B;break}da=PX(d,1)|0;if((da|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=da;qa=B;break}da=PX(d,c[X>>2]|0)|0;if((da|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=da;qa=B;break}da=PX(d,0)|0;if((da|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=da;qa=B;break}if(!((c[A>>2]|0)>-1)){if((a[X+12|0]&1)==0){ka=0;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}}if(k){Oa=w;Pa=y;Qa=0}else{da=RX(b,Q,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=(a[X+12|0]&1)==0?v:1;if((w|0)>-1){X=c[t>>2]|0;ea=0;while(1){Ra=X+(ea<<2)|0;Sa=ea+1|0;if((c[Ra>>2]|0)>-1){ea=Sa}else{break}}c[Ra>>2]=B;c[X+(Sa<<2)>>2]=w;c[X+(ea+2<<2)>>2]=-1;Ta=-1;Ua=y+1|0}else{Ta=w;Ua=y}F=c[A>>2]|0;if((F|0)>-1){E=c[s>>2]|0;Y=F;F=0;do{fa=(Y|0)/2|0;if((Y&1|0)==0){c[E+(fa*12|0)>>2]=B}else{c[E+(fa*12|0)+4>>2]=B}F=F+1|0;Y=c[A+(F<<2)>>2]|0;}while((Y|0)>-1)}c[A>>2]=-1;Oa=Ta;Pa=Ua;Qa=da}c[A>>2]=-1;ka=0;la=Oa;ma=x+1|0;na=Pa;oa=z+1|0;pa=Qa;qa=x}else{ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B}}while(0);Q=c[R>>2]|0;if((Q|0)>-1){Va=0}else{I=ka;J=la;K=ma;L=na;M=oa;N=A;O=pa;P=qa;break b}do{Wa=p+(Va<<2)|0;Va=Va+1|0}while((c[Wa>>2]|0)>-1);c[Wa>>2]=Q;c[p+(Va<<2)>>2]=-1;I=ka;J=la;K=ma;L=na;M=oa;N=A;O=pa;P=qa;break};case 4:{R=u+ -2|0;c[h>>2]=R;S=c[D+(R<<2)>>2]|0;R=u+ -3|0;c[h>>2]=R;I=v;J=w;K=c[D+(R<<2)>>2]|0;L=y;M=z;N=A;O=0;P=(S|0)>-1?S:B;break};default:{I=v;J=w;K=x;L=y;M=z;N=A;O=0;P=B}}}while(0);D=c[h>>2]|0;if((D|0)>(j|0)&(O|0)==0){u=D;v=I;w=J;x=K;y=L;z=M;A=N;B=P}else{Z=J;_=L;$=M;aa=N;ba=O;ca=P;break a}}}else{Z=-1;_=0;$=0;aa=n;ba=e;ca=0}}while(0);do{if(k){Xa=_}else{e=c[aa>>2]|0;if((e|0)>-1){n=c[f+16>>2]|0;P=e;e=0;do{O=(P|0)/2|0;if((P&1|0)==0){c[n+(O*12|0)>>2]=ca}else{c[n+(O*12|0)+4>>2]=ca}e=e+1|0;P=c[aa+(e<<2)>>2]|0;}while((P|0)>-1)}c[aa>>2]=-1;if(!((Z|0)>-1)){Xa=_;break}P=c[f+36>>2]|0;e=0;while(1){Ya=P+(e<<2)|0;Za=e+1|0;if((c[Ya>>2]|0)>-1){e=Za}else{break}}c[Ya>>2]=ca;c[P+(Za<<2)>>2]=Z;c[P+(e+2<<2)>>2]=-1;Xa=_+1|0}}while(0);c[f+48>>2]=$;c[f+40>>2]=$;c[f+44>>2]=Xa;AY(m);AY(p);o=ba;i=g;return o|0}function KX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a;a:while(1){a=c[g>>2]|0;do{if((a|0)==3){h=c[g+4>>2]|0;j=KX(c[h>>2]|0,b,d,e)|0;if((j|0)!=0){k=j;l=10;break a}m=h+4|0}else if((a|0)==2){h=c[g+4>>2]|0;j=h;if(!((c[h+8>>2]|0)==-1)){m=j;break}n=c[h>>2]|0;h=MX(c[n+28>>2]|0,c[n+24>>2]|0,b,d,e)|0;if((h|0)==0){m=j}else{k=h;l=10;break a}}else if((a|0)==1){h=c[g+4>>2]|0;j=h+4|0;n=MX(c[(c[h>>2]|0)+28>>2]|0,c[(c[j>>2]|0)+24>>2]|0,b,d,e)|0;if((n|0)!=0){k=n;l=10;break a}n=KX(c[h>>2]|0,b,d,e)|0;if((n|0)==0){m=j}else{k=n;l=10;break a}}else{k=0;l=10;break a}}while(0);g=c[m>>2]|0}if((l|0)==10){i=f;return k|0}return 0}function LX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+4>>2]|0;if((d|0)==0){i=b;return}a=d+4|0;e=c[d>>2]|0;if((c[a>>2]|0)==0){f=e}else{g=e;e=0;while(1){do{if((c[g+(e<<5)+8>>2]|0)==0){h=g}else{j=c[g+(e<<5)+16>>2]|0;if((j|0)==0){k=g}else{AY(j);k=c[d>>2]|0}j=c[k+(e<<5)+28>>2]|0;if((j|0)==0){h=k;break}AY(j);h=c[d>>2]|0}}while(0);j=e+1|0;if(j>>>0<(c[a>>2]|0)>>>0){g=h;e=j}else{f=h;break}}}if((f|0)!=0){AY(f)}f=d+8|0;h=c[f>>2]|0;if((h|0)!=0){if((c[h+8>>2]|0)==0){l=h}else{e=h;while(1){h=c[e+16>>2]|0;if((h|0)!=0){AY(h)}if((c[e+40>>2]|0)==0){break}else{e=e+32|0}}l=c[f>>2]|0}AY(l)}l=d+16|0;f=c[l>>2]|0;if((f|0)!=0){e=d+28|0;h=c[e>>2]|0;if((h|0)==0){m=f}else{g=h;h=f;f=0;while(1){a=c[h+(f*12|0)+8>>2]|0;if((a|0)==0){n=h;o=g}else{AY(a);n=c[l>>2]|0;o=c[e>>2]|0}a=f+1|0;if(a>>>0<o>>>0){g=o;h=n;f=a}else{m=n;break}}}AY(m)}m=c[d+32>>2]|0;if((m|0)!=0){AY(m)}m=c[d+20>>2]|0;if((m|0)!=0){AY(m)}m=c[d+36>>2]|0;if((m|0)!=0){AY(m)}AY(d);i=b;return}function MX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;h=a;a=c[h>>2]|0;j=(a|0)>-1;if((d|0)==0){if(!j){k=0;i=g;return k|0}l=b;m=a;a=h;while(1){a:do{if((c[l>>2]|0)>-1){n=b;o=m;while(1){p=e+(o<<2)|0;c[p>>2]=(c[p>>2]|0)+1;p=n+32|0;if(!((c[p>>2]|0)>-1)){break a}o=c[a>>2]|0;n=p}}}while(0);n=a+32|0;o=c[n>>2]|0;if((o|0)>-1){m=o;a=n}else{k=0;break}}i=g;return k|0}if(!j){k=0;i=g;return k|0}j=b;a=h;b:while(1){h=c[j>>2]|0;c:do{if((h|0)>-1){m=a+4|0;e=a+8|0;l=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+12|0;r=b;s=h;t=j;u=-1;while(1){v=r;w=s;x=t;while(1){y=v+32|0;if((w|0)!=(u|0)){break}z=y;A=c[z>>2]|0;if((A|0)>-1){w=A;x=z;v=y}else{break c}}z=d+(c[f+(c[a>>2]<<2)>>2]<<5)|0;while(1){B=z+8|0;if((c[B>>2]|0)==0){break}else{z=z+32|0}}c[z+40>>2]=0;c[z>>2]=c[m>>2];c[z+4>>2]=c[e>>2];A=c[x>>2]|0;c[B>>2]=d+(c[f+(A<<2)>>2]<<5);c[z+12>>2]=A;A=c[n>>2]|0;C=c[o>>2]|0;D=c[v+16>>2]|c[l>>2]|((A|0)!=0?4:0)|((C|0)!=0?8:0);E=z+20|0;c[E>>2]=D;F=c[p>>2]|0;G=z+24|0;if((F|0)>-1){c[G>>2]=F;c[E>>2]=D|256}else{c[G>>2]=A}if((C|0)==0){c[z+28>>2]=0}else{A=0;while(1){H=A+1|0;if((c[C+(A<<2)>>2]|0)==0){break}else{A=H}}A=zY(H<<2)|0;C=A;c[z+28>>2]=C;if((A|0)==0){k=12;I=49;break b}x=c[o>>2]|0;G=c[x>>2]|0;if((G|0)==0){J=C}else{D=C;C=G;G=0;while(1){c[D>>2]=C;E=G+1|0;F=c[x+(E<<2)>>2]|0;K=A+(E<<2)|0;if((F|0)==0){J=K;break}else{G=E;C=F;D=K}}}c[J>>2]=0}D=c[q>>2]|0;if((D|0)==0){L=0}else{C=0;while(1){if((c[D+(C<<2)>>2]|0)>-1){C=C+1|0}else{L=C;break}}}C=v+12|0;D=c[C>>2]|0;if((D|0)==0){M=0}else{G=0;while(1){if((c[D+(G<<2)>>2]|0)>-1){G=G+1|0}else{M=G;break}}}G=z+16|0;D=c[G>>2]|0;if((D|0)!=0){AY(D)}c[G>>2]=0;D=M+L|0;if((D|0)>0){v=zY((D<<2)+4|0)|0;c[G>>2]=v;if((v|0)==0){k=12;I=49;break b}G=c[q>>2]|0;do{if((G|0)==0){N=0}else{D=c[G>>2]|0;if((D|0)>-1){O=D;P=0}else{N=0;break}while(1){c[v+(P<<2)>>2]=O;D=P+1|0;A=c[G+(D<<2)>>2]|0;if((A|0)>-1){P=D;O=A}else{N=D;break}}}}while(0);G=c[C>>2]|0;do{if((G|0)==0){Q=N}else{z=c[G>>2]|0;if(!((z|0)>-1)){Q=N;break}D=(N|0)>0;A=z;z=0;x=N;while(1){d:do{if(D){K=0;while(1){F=K+1|0;if((c[v+(K<<2)>>2]|0)==(A|0)){R=x;break d}if((F|0)<(N|0)){K=F}else{I=40;break}}}else{I=40}}while(0);if((I|0)==40){I=0;c[v+(x<<2)>>2]=A;R=x+1|0}K=z+1|0;F=c[G+(K<<2)>>2]|0;if((F|0)>-1){A=F;z=K;x=R}else{Q=R;break}}}}while(0);c[v+(Q<<2)>>2]=-1}G=y;C=c[G>>2]|0;if((C|0)>-1){r=y;s=C;t=G;u=w}else{break}}}}while(0);h=a+32|0;if((c[h>>2]|0)>-1){a=h}else{k=0;I=49;break}}if((I|0)==49){i=g;return k|0}return 0}function NX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=(e|0)==0;a:do{if(h){j=0}else{k=0;while(1){if(!((c[e+(k<<2)>>2]|0)>-1)){j=k;break a}k=k+1|0}}}while(0);k=0;while(1){if((c[b+(k<<5)>>2]|0)>-1){k=k+1|0}else{l=0;break}}while(1){if((c[d+(l<<5)>>2]|0)>-1){l=l+1|0}else{break}}m=ZX(a,0,0,1,(l+k<<5)+32|0)|0;k=m;if((m|0)==0){n=0;i=g;return n|0}l=c[b>>2]|0;b:do{if((l|0)>-1){o=(j|0)>0;p=l;q=0;while(1){c[m+(q<<5)>>2]=p;c[m+(q<<5)+4>>2]=c[b+(q<<5)+4>>2];c[m+(q<<5)+8>>2]=c[b+(q<<5)+8>>2];c[m+(q<<5)+16>>2]=c[b+(q<<5)+16>>2]|f;c[m+(q<<5)+20>>2]=c[b+(q<<5)+20>>2];c[m+(q<<5)+24>>2]=c[b+(q<<5)+24>>2];c[m+(q<<5)+28>>2]=c[b+(q<<5)+28>>2];r=b+(q<<5)+12|0;s=c[r>>2]|0;t=(s|0)==0;if(t&h){c[m+(q<<5)+12>>2]=0}else{c:do{if(t){u=0}else{v=0;while(1){if(!((c[s+(v<<2)>>2]|0)>-1)){u=v;break c}v=v+1|0}}}while(0);s=ZX(a,0,0,0,(u+j<<2)+4|0)|0;t=s;if((s|0)==0){n=0;break}if((u|0)>0){v=c[r>>2]|0;w=0;while(1){c[s+(w<<2)>>2]=c[v+(w<<2)>>2];x=w+1|0;if((x|0)<(u|0)){w=x}else{y=u;break}}}else{y=0}if(o){w=0;while(1){c[s+(w+y<<2)>>2]=c[e+(w<<2)>>2];v=w+1|0;if((v|0)<(j|0)){w=v}else{z=j;break}}}else{z=0}c[s+(z+y<<2)>>2]=-1;c[m+(q<<5)+12>>2]=t}w=q+1|0;v=c[b+(w<<5)>>2]|0;if((v|0)>-1){p=v;q=w}else{A=w;break b}}i=g;return n|0}else{A=0}}while(0);b=c[d>>2]|0;y=m+(A<<5)|0;d:do{if((b|0)>-1){z=y;j=A;e=b;u=0;while(1){c[z>>2]=e;c[m+(j<<5)+4>>2]=c[d+(u<<5)+4>>2];c[m+(j<<5)+8>>2]=c[d+(u<<5)+8>>2];c[m+(j<<5)+16>>2]=c[d+(u<<5)+16>>2];c[m+(j<<5)+20>>2]=c[d+(u<<5)+20>>2];c[m+(j<<5)+24>>2]=c[d+(u<<5)+24>>2];c[m+(j<<5)+28>>2]=c[d+(u<<5)+28>>2];h=d+(u<<5)+12|0;f=c[h>>2]|0;if((f|0)==0){c[m+(j<<5)+12>>2]=0}else{l=0;while(1){if((c[f+(l<<2)>>2]|0)>-1){l=l+1|0}else{break}}f=ZX(a,0,0,0,(l<<2)+4|0)|0;t=f;if((f|0)==0){n=0;break}if((l|0)>0){s=c[h>>2]|0;q=0;while(1){c[f+(q<<2)>>2]=c[s+(q<<2)>>2];p=q+1|0;if((p|0)<(l|0)){q=p}else{B=l;break}}}else{B=0}c[f+(B<<2)>>2]=-1;c[m+(j<<5)+12>>2]=t}l=u+1|0;q=c[d+(l<<5)>>2]|0;s=l+A|0;h=m+(s<<5)|0;if((q|0)>-1){z=h;j=s;e=q;u=l}else{C=h;break d}}i=g;return n|0}else{C=y}}while(0);c[C>>2]=-1;n=k;i=g;return n|0}function OX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=a+12|0;j=c[h>>2]|0;k=(f|0)!=0;if(k){c[f>>2]=0}l=PX(a,b)|0;if((l|0)!=0){m=l;i=g;return m|0}l=a+16|0;b=(d|0)==0;n=(e|0)==0;a:while(1){o=c[h>>2]|0;if((o|0)<=(j|0)){m=0;p=28;break}q=o+ -1|0;c[h>>2]=q;o=c[(c[l>>2]|0)+(q<<2)>>2]|0;q=c[o>>2]|0;do{if((q|0)==0){r=c[o+4>>2]|0;s=c[r>>2]|0;if((s|0)==-2){if(n){continue a}c[e>>2]=c[e>>2]|c[r+4>>2];continue a}else if(!((s|0)==-3)){continue a}s=c[r+4>>2]|0;if(!((s|0)>-1)){continue a}b:do{if(!b){r=c[d>>2]|0;c:do{if((r|0)>-1){t=r;u=d;v=0;while(1){w=v+1|0;if((t|0)==(s|0)){break}x=d+(w<<2)|0;y=c[x>>2]|0;if((y|0)>-1){t=y;u=x;v=w}else{z=x;A=w;break c}}if((s|0)<0){z=u;A=v}else{break b}}else{z=d;A=0}}while(0);c[z>>2]=s;c[d+(A+1<<2)>>2]=-1}}while(0);if(!k){continue a}c[f>>2]=(c[f>>2]|0)+1;continue a}else if((q|0)==2){s=c[c[o+4>>2]>>2]|0;if((c[s+8>>2]|0)==0){continue a}B=PX(a,s)|0}else if((q|0)==1){s=c[o+4>>2]|0;r=PX(a,c[s>>2]|0)|0;if((r|0)!=0){m=r;p=28;break a}B=PX(a,c[s+4>>2]|0)|0}else if((q|0)==3){s=c[o+4>>2]|0;r=c[s>>2]|0;if((c[r+8>>2]|0)!=0){B=PX(a,r)|0;break}r=c[s+4>>2]|0;if((c[r+8>>2]|0)==0){continue a}B=PX(a,r)|0}else{continue a}}while(0);if((B|0)!=0){m=B;p=28;break}}if((p|0)==28){i=g;return m|0}return 0}function PX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a;h=c[g>>2]|0;if((f|0)<(h|0)){c[(c[a+16>>2]|0)+(f<<2)>>2]=b;c[e>>2]=(c[e>>2]|0)+1;j=0;i=d;return j|0}e=c[a+4>>2]|0;if((h|0)>=(e|0)){j=12;i=d;return j|0}f=(c[a+8>>2]|0)+h|0;h=(f|0)>(e|0)?e:f;f=a+16|0;e=CY(c[f>>2]|0,h<<2)|0;if((e|0)==0){j=12;i=d;return j|0}else{c[g>>2]=h;c[f>>2]=e;PX(a,b)|0;i=d;return 0}return 0}function QX(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;l=i;m=d+12|0;n=c[m>>2]|0;PX(d,e)|0;e=PX(d,0)|0;a:do{if((e|0)==0){o=d+16|0;p=(f&1|0)==0;q=(f&2|0)==0;r=1;s=0;t=j;b:while(1){u=c[m>>2]|0;if((u|0)<=(n|0)){v=s;w=0;break a}x=u+ -1|0;c[m>>2]=x;y=c[o>>2]|0;z=c[y+(x<<2)>>2]|0;if((z|0)==1){x=u+ -2|0;c[m>>2]=x;A=s;B=r;t=c[y+(x<<2)>>2]|0;s=A;r=B;continue}else if((z|0)!=0){C=t;A=s;B=r;t=C;s=A;r=B;continue}z=u+ -2|0;c[m>>2]=z;u=c[y+(z<<2)>>2]|0;z=c[u>>2]|0;do{if((z|0)==1){y=c[u+4>>2]|0;x=c[y>>2]|0;D=y+4|0;E=c[D>>2]|0;F=ZX(b,0,0,1,32)|0;if((F|0)==0){G=29;break b}H=ZX(b,0,0,1,8)|0;I=F+4|0;c[I>>2]=H;if((H|0)==0){G=29;break b}c[F>>2]=1;c[F+8>>2]=-1;c[F+12>>2]=-1;c[H>>2]=x;c[(c[I>>2]|0)+4>>2]=E;c[F+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);c[t>>2]=F;F=c[I>>2]|0;c[F>>2]=0;I=F+4|0;c[I>>2]=0;x=PX(d,c[D>>2]|0)|0;if((x|0)!=0){v=s;w=x;break a}x=PX(d,0)|0;if((x|0)!=0){v=s;w=x;break a}x=PX(d,I)|0;if((x|0)!=0){v=s;w=x;break a}x=PX(d,1)|0;if((x|0)!=0){v=s;w=x;break a}x=PX(d,c[y>>2]|0)|0;if((x|0)!=0){v=s;w=x;break a}J=r;K=s;L=F;M=PX(d,0)|0}else if((z|0)==3){F=c[u+4>>2]|0;x=c[F>>2]|0;y=F+4|0;I=c[y>>2]|0;D=ZX(b,0,0,1,32)|0;if((D|0)==0){G=20;break b}E=ZX(b,0,0,1,8)|0;H=D+4|0;c[H>>2]=E;if((E|0)==0){G=20;break b}c[D>>2]=3;c[D+8>>2]=-1;c[D+12>>2]=-1;c[E>>2]=x;c[(c[H>>2]|0)+4>>2]=I;c[D+16>>2]=(c[I+16>>2]|0)+(c[x+16>>2]|0);c[t>>2]=D;D=c[H>>2]|0;H=PX(d,c[y>>2]|0)|0;if((H|0)!=0){v=s;w=H;break a}H=PX(d,0)|0;if((H|0)!=0){v=s;w=H;break a}H=PX(d,D+4|0)|0;if((H|0)!=0){v=s;w=H;break a}H=PX(d,1)|0;if((H|0)!=0){v=s;w=H;break a}H=PX(d,c[F>>2]|0)|0;if((H|0)!=0){v=s;w=H;break a}J=r;K=s;L=D;M=PX(d,0)|0}else if((z|0)==0){D=c[u+4>>2]|0;H=c[D+8>>2]|0;F=c[D>>2]|0;y=c[D+4>>2]|0;do{if((F|0)>-1|(F|0)==-4){N=r;O=y;P=F;Q=s+1|0;R=(c[g>>2]|0)+H|0}else{if(!((F|0)==-3)){N=r;O=y;P=F;Q=s;R=H;break}if(!p){N=r;O=-1;P=-1;Q=s;R=-1;break}if(q|(r|0)==0){N=r;O=y;P=-3;Q=s;R=H;break}c[h+(y<<2)>>2]=1;N=0;O=y;P=-3;Q=s;R=H}}while(0);H=ZX(b,0,0,1,32)|0;y=H;do{if((H|0)==0){S=0}else{F=ZX(b,0,0,1,20)|0;c[H+4>>2]=F;if((F|0)==0){S=0;break}c[H>>2]=0;c[H+8>>2]=-1;c[H+12>>2]=-1;c[F>>2]=P;c[F+4>>2]=O;c[F+8>>2]=R;S=y}}while(0);c[t>>2]=S;y=(S|0)==0?12:0;if((R|0)<=(c[k>>2]|0)){J=N;K=Q;L=t;M=y;break}c[k>>2]=R;J=N;K=Q;L=t;M=y}else if((z|0)==2){y=c[u+4>>2]|0;H=PX(d,c[y>>2]|0)|0;if((H|0)!=0){v=s;w=H;break a}H=PX(d,0)|0;if((H|0)!=0){v=s;w=H;break a}H=c[y>>2]|0;F=c[y+4>>2]|0;D=c[y+8>>2]|0;x=a[y+12|0]|0;y=ZX(b,0,0,1,32)|0;if((y|0)==0){G=40;break b}I=ZX(b,0,0,1,16)|0;E=y+4|0;c[E>>2]=I;if((I|0)==0){G=40;break b}c[y>>2]=2;c[y+8>>2]=-1;c[y+12>>2]=-1;c[I>>2]=H;c[I+4>>2]=F;c[I+8>>2]=D;D=I+12|0;a[D]=a[D]&-2|x&1;c[y+16>>2]=c[H+16>>2];c[t>>2]=y;A=s;B=r;t=c[E>>2]|0;s=A;r=B;continue b}else{C=t;A=s;B=r;t=C;s=A;r=B;continue b}}while(0);if((M|0)==0){r=J;s=K;t=L}else{v=K;w=M;break a}}if((G|0)==20){c[t>>2]=0;v=s;w=12;break}else if((G|0)==29){c[t>>2]=0;v=s;w=12;break}else if((G|0)==40){c[t>>2]=0;v=s;w=12;break}}else{v=0;w=e}}while(0);c[g>>2]=(c[g>>2]|0)+v;i=l;return w|0}function RX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=ZX(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=ZX(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=ZX(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f>>2]=j;k=ZX(a,0,0,0,32)|0;l=f+4|0;c[l>>2]=k;if((k|0)==0){g=12;i=e;return g|0}m=b+4|0;c[k+4>>2]=c[m>>2];k=b;c[c[l>>2]>>2]=c[k>>2];n=c[l>>2]|0;c[n+8>>2]=-1;c[n+12>>2]=-1;c[n+24>>2]=0;c[(c[l>>2]|0)+28>>2]=0;c[(c[l>>2]|0)+20>>2]=0;c[m>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f>>2]=0;g=12;i=e;return g|0}function SX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=ZX(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=ZX(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=ZX(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f+4>>2]=j;k=ZX(a,0,0,0,32)|0;c[f>>2]=k;if((k|0)==0){g=12;i=e;return g|0}l=b+4|0;c[k+4>>2]=c[l>>2];k=b;c[c[f>>2]>>2]=c[k>>2];m=c[f>>2]|0;c[m+8>>2]=-1;c[m+12>>2]=-1;c[m+24>>2]=0;c[(c[f>>2]|0)+28>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[l>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f+4>>2]=0;g=12;i=e;return g|0}function TX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[c[(c[b>>2]|0)+4>>2]>>2]|0;if((e|0)<(a|0)){f=-1;i=d;return f|0}f=(e|0)>(a|0)|0;i=d;return f|0}function UX(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;g=d;a:do{if((b|0)==0){h=150656}else{j=b;k=150656;while(1){if((a[k]|0)==0){h=k;break a}l=j+ -1|0;m=k+((bZ(k|0)|0)+1)|0;if((l|0)==0){h=m;break}else{j=l;k=m}}}}while(0);c[g>>2]=(a[h]|0)==0?h+1|0:h;h=(Hc(e|0,f|0,150944,g|0)|0)+1|0;i=d;return h|0}function VX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0;g=i;i=i+16|0;h=g;j=g+8|0;k=c[a+4>>2]|0;a=k;l=k+40|0;m=c[l>>2]|0;do{if((m|0)<1|(d|0)==0){n=0}else{o=zY(m<<2)|0;if((o|0)==0){p=12}else{n=o;break}i=g;return p|0}}while(0);m=n;a:do{if((c[k+60>>2]|0)==0){c[h>>2]=0;o=f&1;q=f&2;r=k+56|0;s=c[r>>2]&4;if((n|0)==0){t=0}else{t=c[l>>2]|0}u=t<<2;v=c[k+52>>2]|0;w=v<<3;x=w+8|0;y=u+12+w+(x+(fa(u,v)|0)<<1)|0;z=zY(y)|0;if((z|0)==0){A=12;break}fZ(z|0,0,y|0)|0;y=z;B=z+u&3;C=((B|0)==0?0:4-B|0)+u|0;B=z+C|0;D=B;E=C+x|0;C=z+E&3;F=((C|0)==0?0:4-C|0)+E|0;E=z+F|0;C=E;G=F+x|0;x=z+G&3;F=((x|0)==0?0:4-x|0)+G|0;G=z+F|0;x=F+w|0;w=z+x&3;if((v|0)>0){F=t<<3;H=0;I=z+(((w|0)==0?0:4-w|0)+x)|0;while(1){c[E+(H<<3)+4>>2]=I;c[B+(H<<3)+4>>2]=I+u;x=H+1|0;if((x|0)<(v|0)){I=I+F|0;H=x}else{J=0;break}}do{c[G+(J<<3)>>2]=-1;J=J+1|0;}while((J|0)<(v|0))}v=DX(h,b,4)|0;if((v|0)<1){if((v|0)<0){A=1;break}K=v+1|0}else{K=v}v=k+8|0;H=(s|0)==0;F=(o|0)==0;I=(t|0)>0;B=k+12|0;E=k+44|0;x=k+32|0;w=k+36|0;L=(t|0)==0;M=I^1;N=-1;O=0;P=0;Q=K;R=0;S=C;T=D;U=D;V=b+K|0;W=y;while(1){if((N|0)<0){X=c[v>>2]|0;Y=X+8|0;b:do{if((c[Y>>2]|0)==0){Z=N;_=O;$=U}else{aa=(P|0)==0;ba=(R|0)==95;ca=(P|0)<1&F;da=((R|0)!=10|H)^1;ea=Y;ga=N;ha=O;ia=U;ja=X;while(1){ka=ea;la=ja;c:while(1){ma=la+12|0;if((c[G+(c[ma>>2]<<3)>>2]|0)>=(P|0)){na=ga;oa=ha;pa=ia;break}qa=la+20|0;ra=c[qa>>2]|0;if((ra|0)==0){sa=260;break}d:do{if((ra&1|0)==0|ca|da){if((ra&2|0)!=0){ta=c[h>>2]|0;if((ta|q|0)!=0&((ta|0)!=10|H)){break}}do{if((ra&16|0)!=0){if(ba){break d}if((iX(R)|0)!=0){break d}ta=c[h>>2]|0;if((ta|0)==95){break}if((iX(ta)|0)==0){break d}}}while(0);ta=c[qa>>2]|0;if((ta&32|0)==0){ua=ta}else{if(!ba){if((iX(R)|0)==0){break}}ta=c[h>>2]|0;if((ta|0)==95){break}if((iX(ta)|0)!=0){break}ua=c[qa>>2]|0}do{if((ua&64|0)==0|aa){va=ua}else{ta=c[h>>2]|0;if((ta|0)==0){va=ua;break}if(ba){wa=ta;xa=1}else{ta=(iX(R)|0)!=0|0;wa=c[h>>2]|0;xa=ta}if((wa|0)==95){ya=1}else{ya=(iX(wa)|0)!=0|0}if((xa|0)==(ya|0)){break d}va=c[qa>>2]|0}}while(0);if((va&128|0)==0){sa=260;break c}if(aa){break}ta=c[h>>2]|0;if((ta|0)==0){break}if(ba){za=ta;Aa=1}else{ta=(iX(R)|0)!=0|0;za=c[h>>2]|0;Aa=ta}if((za|0)==95){Ba=1}else{Ba=(iX(za)|0)!=0|0}if((Aa|0)==(Ba|0)){sa=260;break c}}}while(0);qa=la+40|0;if((c[qa>>2]|0)==0){Z=ga;_=ha;$=ia;break b}else{ka=qa;la=la+32|0}}if((sa|0)==260){sa=0;qa=ia;c[qa>>2]=c[ka>>2];if(I){fZ(c[ia+4>>2]|0,-1,u|0)|0}ra=c[la+16>>2]|0;do{if((ra|0)!=0){ta=c[ra>>2]|0;if(!((ta|0)>-1)){break}Ca=ia+4|0;Da=ta;ta=ra;do{if((Da|0)<(t|0)){c[(c[Ca>>2]|0)+(Da<<2)>>2]=P}ta=ta+4|0;Da=c[ta>>2]|0;}while((Da|0)>-1)}}while(0);ra=(c[qa>>2]|0)!=(c[B>>2]|0);if(ra|M){Ea=ia+4|0;Fa=ra?ga:P;Ga=ra?ha:1}else{ra=ia+4|0;ka=c[ra>>2]|0;Da=0;while(1){c[n+(Da<<2)>>2]=c[ka+(Da<<2)>>2];ta=Da+1|0;if((ta|0)<(t|0)){Da=ta}else{Ea=ra;Fa=P;Ga=1;break}}}c[G+(c[ma>>2]<<3)>>2]=P;c[G+(c[ma>>2]<<3)+4>>2]=Ea;na=Fa;oa=Ga;pa=ia+8|0}ra=la+40|0;if((c[ra>>2]|0)==0){Z=na;_=oa;$=pa;break}else{ea=ra;ga=na;ha=oa;ia=pa;ja=la+32|0}}}}while(0);c[$>>2]=0;Ha=Z;Ia=_}else{if(L|(U|0)==(T|0)){Ja=N;break}else{Ha=N;Ia=O}}X=c[h>>2]|0;if((X|0)==0){Ja=Ha;break}Y=P+Q|0;ja=DX(h,V,4)|0;if((ja|0)<1){if((ja|0)<0){A=1;break a}Ka=ja+1|0}else{Ka=ja}ja=V+Ka|0;if((c[E>>2]|0)==0|(Ia|0)==0){La=Ia;Ma=T;Na=S}else{ia=T;ha=c[ia>>2]|0;if((ha|0)==0){Oa=S}else{ga=ha;ha=ia;ia=S;while(1){ea=c[w>>2]|0;ba=c[ea>>2]|0;aa=ha+4|0;e:do{if((ba|0)>-1){da=ba;ca=0;while(1){ra=c[ea+((ca|1)<<2)>>2]|0;if((da|0)>=(t|0)){Pa=ia;break e}Da=c[aa>>2]|0;if((c[Da+(ra<<2)>>2]|0)==(c[n+(ra<<2)>>2]|0)){if((c[Da+(da<<2)>>2]|0)<(c[n+(da<<2)>>2]|0)){Pa=ia;break e}}Da=ca+2|0;ra=c[ea+(Da<<2)>>2]|0;if((ra|0)>-1){da=ra;ca=Da}else{sa=287;break}}}else{sa=287}}while(0);if((sa|0)==287){sa=0;c[ia>>2]=ga;ea=ia+4|0;ba=c[ea>>2]|0;c[ea>>2]=c[aa>>2];c[aa>>2]=ba;Pa=ia+8|0}ba=ha+8|0;ea=c[ba>>2]|0;if((ea|0)==0){Oa=Pa;break}else{ga=ea;ha=ba;ia=Pa}}}c[Oa>>2]=0;La=0;Ma=S;Na=T}ia=c[Ma>>2]|0;if((ia|0)==0){Qa=Ha;Ra=La;Sa=Na;Ta=W}else{ha=(Y|0)==0;ga=(X|0)==95;ba=(Y|0)<1&F;ea=((X|0)!=10|H)^1;ca=ia;ia=Ha;da=La;la=Ma;Da=Na;ra=W;while(1){ka=ca+8|0;if((c[ka>>2]|0)==0){Ua=ia;Va=da;Wa=Da;Xa=ra}else{qa=la+4|0;ta=ka;ka=ia;Ca=da;Ya=Da;Za=ra;_a=ca;while(1){f:do{if((c[_a>>2]|0)>>>0>X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za}else{if((c[_a+4>>2]|0)>>>0<X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za;break}db=_a+20|0;eb=c[db>>2]|0;g:do{if((eb|0)!=0){if(!((eb&1|0)==0|ba|ea)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((eb&2|0)!=0){fb=c[h>>2]|0;if((fb|q|0)!=0&((fb|0)!=10|H)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}do{if((eb&16|0)!=0){if(ga){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((iX(X)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==95){break}if((iX(fb)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);fb=c[db>>2]|0;if((fb&32|0)==0){gb=fb}else{if(!ga){if((iX(X)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}fb=c[h>>2]|0;if((fb|0)==95){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((iX(fb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}gb=c[db>>2]|0}do{if((gb&64|0)==0|ha){hb=gb}else{fb=c[h>>2]|0;if((fb|0)==0){hb=gb;break}if(ga){ib=fb;jb=1}else{fb=(iX(X)|0)!=0|0;ib=c[h>>2]|0;jb=fb}if((ib|0)==95){kb=1}else{kb=(iX(ib)|0)!=0|0}if((jb|0)==(kb|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}hb=c[db>>2]|0}}while(0);if((hb&128|0)==0){lb=hb}else{if(ha){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if(ga){mb=fb;nb=1}else{fb=(iX(X)|0)!=0|0;mb=c[h>>2]|0;nb=fb}if((mb|0)==95){ob=1}else{ob=(iX(mb)|0)!=0|0}if((nb|0)!=(ob|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}lb=c[db>>2]|0}do{if((lb&4|0)==0){pb=lb}else{if((c[r>>2]&2|0)!=0){pb=lb;break}if((mX(X,c[_a+24>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}pb=c[db>>2]|0}}while(0);do{if((pb&4|0)!=0){if((c[r>>2]&2|0)==0){break}fb=yX(X)|0;qb=_a+24|0;if((mX(fb,c[qb>>2]|0)|0)!=0){break}fb=wX(X)|0;if((mX(fb,c[qb>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);if((c[db>>2]&8|0)==0){break}qb=c[_a+28>>2]|0;fb=c[qb>>2]|0;if((fb|0)==0){break}if((c[r>>2]&2|0)==0){rb=qb;sb=fb;while(1){if((mX(X,sb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}rb=rb+4|0;sb=c[rb>>2]|0;if((sb|0)==0){break g}}}else{tb=qb}do{sb=wX(X)|0;if((mX(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}sb=yX(X)|0;if((mX(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}tb=tb+4|0;}while((c[tb>>2]|0)!=0)}}while(0);if(I){db=c[qa>>2]|0;eb=0;do{c[Za+(eb<<2)>>2]=c[db+(eb<<2)>>2];eb=eb+1|0;}while((eb|0)<(t|0))}eb=c[_a+16>>2]|0;do{if((eb|0)!=0){db=c[eb>>2]|0;if((db|0)>-1){ub=db;vb=eb}else{break}do{if((ub|0)<(t|0)){c[Za+(ub<<2)>>2]=Y}vb=vb+4|0;ub=c[vb>>2]|0;}while((ub|0)>-1)}}while(0);eb=_a+12|0;db=c[eb>>2]|0;qb=G+(db<<3)|0;if((c[qb>>2]|0)<(Y|0)){sb=Ya;c[sb>>2]=c[ta>>2];rb=Ya+4|0;fb=c[rb>>2]|0;c[rb>>2]=Za;c[qb>>2]=Y;c[G+(c[eb>>2]<<3)+4>>2]=rb;do{if((c[sb>>2]|0)==(c[B>>2]|0)){if((ka|0)==-1){if(!I){wb=Y;xb=1;break}yb=c[rb>>2]|0}else{if(!I){wb=ka;xb=Ca;break}eb=c[rb>>2]|0;if((c[eb>>2]|0)>(c[n>>2]|0)){wb=ka;xb=Ca;break}else{yb=eb}}eb=0;while(1){c[n+(eb<<2)>>2]=c[yb+(eb<<2)>>2];qb=eb+1|0;if((qb|0)<(t|0)){eb=qb}else{wb=Y;xb=1;break}}}else{wb=ka;xb=Ca}}while(0);$a=wb;ab=xb;bb=Ya+8|0;cb=fb;break}else{rb=c[x>>2]|0;sb=c[G+(db<<3)+4>>2]|0;eb=c[sb>>2]|0;if(I){zb=0}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break}while(1){qb=c[Za+(zb<<2)>>2]|0;Ab=c[eb+(zb<<2)>>2]|0;if((c[rb+(zb<<2)>>2]|0)==0){if((qb|0)<(Ab|0)){break}if((qb|0)>(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}else{if((qb|0)>(Ab|0)){break}if((qb|0)<(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}Ab=zb+1|0;if((Ab|0)<(t|0)){zb=Ab}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}c[sb>>2]=Za;if((c[ta>>2]|0)==(c[B>>2]|0)){Bb=0}else{$a=ka;ab=Ca;bb=Ya;cb=eb;break}while(1){c[n+(Bb<<2)>>2]=c[Za+(Bb<<2)>>2];rb=Bb+1|0;if((rb|0)<(t|0)){Bb=rb}else{$a=Y;ab=1;bb=Ya;cb=eb;break}}}}}while(0);eb=_a+40|0;if((c[eb>>2]|0)==0){Ua=$a;Va=ab;Wa=bb;Xa=cb;break}else{ta=eb;ka=$a;Ca=ab;Ya=bb;Za=cb;_a=_a+32|0}}}_a=la+8|0;Za=c[_a>>2]|0;if((Za|0)==0){Qa=Ua;Ra=Va;Sa=Wa;Ta=Xa;break}else{ca=Za;ia=Ua;da=Va;la=_a;Da=Wa;ra=Xa}}}c[Sa>>2]=0;N=Qa;O=Ra;P=Y;Q=Ka;R=X;S=Ma;T=Na;U=Sa;V=ja;W=Ta}AY(z);Cb=Ja;Db=Ja>>>31;sa=375}else{c[j>>2]=0;W=f&1;V=f&2;U=k+56|0;T=c[U>>2]&4;S=XX(0,0)|0;if((S|0)==0){A=12;break}R=ZX(S,0,0,0,32)|0;Q=R;if((R|0)==0){YX(S);A=12;break}c[R+24>>2]=0;c[R+28>>2]=0;R=c[l>>2]|0;if((R|0)==0){Eb=0;sa=9}else{P=zY(R<<2)|0;O=P;if((P|0)==0){Fb=0;Gb=0;Hb=12;Ib=0;Jb=O}else{Eb=O;sa=9}}do{if((sa|0)==9){O=Eb;P=c[k+28>>2]|0;if((P|0)==0){Kb=0}else{N=zY(P<<3)|0;P=N;if((N|0)==0){Fb=0;Gb=P;Hb=12;Ib=0;Jb=Eb;break}else{Kb=P}}P=k+52|0;N=c[P>>2]|0;if((N|0)==0){Lb=0}else{B=zY(N<<2)|0;N=B;if((B|0)==0){Fb=0;Gb=Kb;Hb=12;Ib=N;Jb=Eb;break}else{Lb=N}}N=Lb;B=(n|0)==0;I=k+8|0;G=k+12|0;x=k+32|0;r=(T|0)==0;H=(W|0)==0;q=R;F=-1;w=1;E=-1;L=Q;M=b;h:while(1){do{if((q|0)>0){if(B){fZ(O|0,-1,q<<2|0)|0;break}else{u=0;do{c[Eb+(u<<2)>>2]=-1;c[n+(u<<2)>>2]=-1;u=u+1|0;}while((u|0)<(c[l>>2]|0))}}}while(0);u=c[P>>2]|0;if((u|0)>0){fZ(N|0,0,u<<2|0)|0}u=c[j>>2]|0;v=w+E|0;y=DX(j,M,4)|0;if((y|0)<1){if((y|0)<0){A=1;break a}Mb=y+1|0}else{Mb=y}y=M+Mb|0;D=c[j>>2]|0;C=c[I>>2]|0;o=C+8|0;if((c[o>>2]|0)==0){Nb=F;Ob=0;Pb=Mb;Qb=L;sa=196}else{s=(v|0)==0;ra=(u|0)==95;Da=(v|0)<1&H;la=((u|0)!=10|r)^1;da=o;o=0;ia=L;ca=0;ga=C;while(1){C=ga+20|0;ha=c[C>>2]|0;i:do{if((ha|0)==0){sa=56}else{if(!((ha&1|0)==0|Da|la)){Rb=o;Sb=ia;Tb=ca;break}if((ha&2|0)!=0){ea=c[j>>2]|0;if((ea|V|0)!=0&((ea|0)!=10|r)){Rb=o;Sb=ia;Tb=ca;break}}do{if((ha&16|0)!=0){if(ra){Rb=o;Sb=ia;Tb=ca;break i}if((iX(u)|0)!=0){Rb=o;Sb=ia;Tb=ca;break i}ea=c[j>>2]|0;if((ea|0)==95){break}if((iX(ea)|0)==0){Rb=o;Sb=ia;Tb=ca;break i}}}while(0);ea=c[C>>2]|0;if((ea&32|0)==0){Ub=ea}else{if(!ra){if((iX(u)|0)==0){Rb=o;Sb=ia;Tb=ca;break}}ea=c[j>>2]|0;if((ea|0)==95){Rb=o;Sb=ia;Tb=ca;break}if((iX(ea)|0)!=0){Rb=o;Sb=ia;Tb=ca;break}Ub=c[C>>2]|0}do{if((Ub&64|0)==0|s){Vb=Ub}else{ea=c[j>>2]|0;if((ea|0)==0){Vb=Ub;break}if(ra){Wb=ea;Xb=1}else{ea=(iX(u)|0)!=0|0;Wb=c[j>>2]|0;Xb=ea}if((Wb|0)==95){Yb=1}else{Yb=(iX(Wb)|0)!=0|0}if((Xb|0)==(Yb|0)){Rb=o;Sb=ia;Tb=ca;break i}Vb=c[C>>2]|0}}while(0);if((Vb&128|0)==0){sa=56;break}if(s){Rb=o;Sb=ia;Tb=ca;break}ea=c[j>>2]|0;if((ea|0)==0){Rb=o;Sb=ia;Tb=ca;break}if(ra){Zb=ea;_b=1}else{ea=(iX(u)|0)!=0|0;Zb=c[j>>2]|0;_b=ea}if((Zb|0)==95){$b=1}else{$b=(iX(Zb)|0)!=0|0}if((_b|0)==($b|0)){sa=56}else{Rb=o;Sb=ia;Tb=ca}}}while(0);do{if((sa|0)==56){sa=0;if((ca|0)==0){Rb=c[ga+16>>2]|0;Sb=ia;Tb=c[da>>2]|0;break}C=ia+28|0;ha=c[C>>2]|0;if((ha|0)==0){ea=ZX(S,0,0,0,32)|0;ba=ea;if((ea|0)==0){sa=60;break h}c[ea+24>>2]=ia;c[ea+28>>2]=0;_a=ZX(S,0,0,0,c[l>>2]<<2)|0;c[ea+20>>2]=_a;if((_a|0)==0){sa=67;break h}c[C>>2]=ba;ac=ba}else{ac=ha}c[ac>>2]=v;c[ac+4>>2]=y;c[ac+8>>2]=c[da>>2];c[ac+12>>2]=c[ga+12>>2];c[ac+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ha=c[ac+20>>2]|0;ba=0;do{c[ha+(ba<<2)>>2]=c[Eb+(ba<<2)>>2];ba=ba+1|0;}while((ba|0)<(c[l>>2]|0))}ba=c[ga+16>>2]|0;if((ba|0)==0){Rb=o;Sb=ac;Tb=ca;break}ha=c[ba>>2]|0;if(!((ha|0)>-1)){Rb=o;Sb=ac;Tb=ca;break}C=c[ac+20>>2]|0;_a=ha;ha=ba;while(1){ba=ha+4|0;c[C+(_a<<2)>>2]=v;ea=c[ba>>2]|0;if((ea|0)>-1){ha=ba;_a=ea}else{Rb=o;Sb=ac;Tb=ca;break}}}}while(0);_a=ga+40|0;if((c[_a>>2]|0)==0){break}else{da=_a;o=Rb;ia=Sb;ca=Tb;ga=ga+32|0}}do{if((Rb|0)==0){bc=0}else{ga=c[Rb>>2]|0;if((ga|0)>-1){cc=ga;dc=Rb}else{bc=Rb;break}while(1){c[Eb+(cc<<2)>>2]=v;ga=dc+4|0;ca=c[ga>>2]|0;if((ca|0)>-1){dc=ga;cc=ca}else{bc=ga;break}}}}while(0);if((Tb|0)==0){Nb=F;Ob=bc;Pb=Mb;Qb=Sb;sa=196}else{ec=F;fc=bc;gc=v;hc=Mb;ic=Sb;jc=Tb;kc=y}}j:while(1){if((sa|0)==196){sa=0;ga=c[Qb+24>>2]|0;if((ga|0)==0){break}ca=c[Qb+8>>2]|0;if((c[ca+20>>2]&256|0)!=0){c[Lb+(c[Qb+12>>2]<<2)>>2]=0}ia=c[Qb>>2]|0;o=c[Qb+4>>2]|0;c[j>>2]=c[Qb+16>>2];da=c[l>>2]|0;if((da|0)<=0){ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue}u=c[Qb+20>>2]|0;ra=0;while(1){c[Eb+(ra<<2)>>2]=c[u+(ra<<2)>>2];s=ra+1|0;if((s|0)<(da|0)){ra=s}else{ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue j}}}if((jc|0)==(c[G>>2]|0)){lc=fc;mc=gc;nc=hc;oc=ic}else{o=fc;ca=gc;ga=hc;ia=ic;ra=jc;da=kc;while(1){u=ra+8|0;do{if((c[u>>2]|0)==0){sa=109}else{if((c[ra+20>>2]&256|0)==0){sa=109;break}s=c[ra+24>>2]|0;WX(s+1|0,Kb,c[U>>2]&-9,a,Eb,ca);la=c[Kb+(s<<3)>>2]|0;Da=c[Kb+(s<<3)+4>>2]|0;s=Da-la|0;if((_Y(b+la|0,da+ -1|0,s)|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}_a=(Da|0)==(la|0);la=_a&1;Da=Lb+(c[ra+12>>2]<<2)|0;if(_a){if((c[Da>>2]|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}}c[Da>>2]=la;la=s+ -1|0;s=la+ca|0;Da=c[j>>2]|0;_a=DX(j,da+la|0,4)|0;if((_a|0)<1){if((_a|0)<0){A=1;break a}pc=_a+1|0}else{pc=_a}qc=s;rc=pc+la|0;sc=pc;tc=Da}}while(0);do{if((sa|0)==109){sa=0;Da=c[j>>2]|0;if((Da|0)==0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}la=DX(j,da,4)|0;if((la|0)>=1){qc=ca;rc=la;sc=la;tc=Da;break}if((la|0)<0){A=1;break a}s=la+1|0;qc=ca;rc=s;sc=s;tc=Da}}while(0);Da=da+rc|0;s=qc+ga|0;if((c[u>>2]|0)==0){Nb=ec;Ob=o;Pb=sc;Qb=ia;sa=196;continue j}la=(s|0)==0;_a=(tc|0)==95;ha=(s|0)<1&H;C=((tc|0)!=10|r)^1;ea=u;ba=0;Za=o;Ya=ia;Ca=ra;while(1){k:do{if((c[Ca>>2]|0)>>>0>tc>>>0){uc=ba;vc=Za;wc=Ya}else{if((c[Ca+4>>2]|0)>>>0<tc>>>0){uc=ba;vc=Za;wc=Ya;break}ka=Ca+20|0;ta=c[ka>>2]|0;l:do{if((ta|0)!=0){if(!((ta&1|0)==0|ha|C)){uc=ba;vc=Za;wc=Ya;break k}if((ta&2|0)!=0){qa=c[j>>2]|0;if((qa|V|0)!=0&((qa|0)!=10|r)){uc=ba;vc=Za;wc=Ya;break k}}do{if((ta&16|0)!=0){if(_a){uc=ba;vc=Za;wc=Ya;break k}if((iX(tc)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==95){break}if((iX(qa)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);qa=c[ka>>2]|0;if((qa&32|0)==0){xc=qa}else{if(!_a){if((iX(tc)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}qa=c[j>>2]|0;if((qa|0)==95){uc=ba;vc=Za;wc=Ya;break k}if((iX(qa)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}xc=c[ka>>2]|0}do{if((xc&64|0)==0|la){yc=xc}else{qa=c[j>>2]|0;if((qa|0)==0){yc=xc;break}if(_a){zc=qa;Ac=1}else{qa=(iX(tc)|0)!=0|0;zc=c[j>>2]|0;Ac=qa}if((zc|0)==95){Bc=1}else{Bc=(iX(zc)|0)!=0|0}if((Ac|0)==(Bc|0)){uc=ba;vc=Za;wc=Ya;break k}yc=c[ka>>2]|0}}while(0);if((yc&128|0)==0){Cc=yc}else{if(la){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==0){uc=ba;vc=Za;wc=Ya;break k}if(_a){Dc=qa;Ec=1}else{qa=(iX(tc)|0)!=0|0;Dc=c[j>>2]|0;Ec=qa}if((Dc|0)==95){Fc=1}else{Fc=(iX(Dc)|0)!=0|0}if((Ec|0)!=(Fc|0)){uc=ba;vc=Za;wc=Ya;break k}Cc=c[ka>>2]|0}do{if((Cc&4|0)==0){Gc=Cc}else{if((c[U>>2]&2|0)!=0){Gc=Cc;break}if((mX(tc,c[Ca+24>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}Gc=c[ka>>2]|0}}while(0);do{if((Gc&4|0)!=0){if((c[U>>2]&2|0)==0){break}qa=yX(tc)|0;aa=Ca+24|0;if((mX(qa,c[aa>>2]|0)|0)!=0){break}qa=wX(tc)|0;if((mX(qa,c[aa>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);if((c[ka>>2]&8|0)==0){break}aa=c[Ca+28>>2]|0;qa=c[aa>>2]|0;if((qa|0)==0){break}if((c[U>>2]&2|0)==0){eb=aa;sb=qa;while(1){if((mX(tc,sb)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}eb=eb+4|0;sb=c[eb>>2]|0;if((sb|0)==0){break l}}}else{Hc=aa}do{sb=wX(tc)|0;if((mX(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}sb=yX(tc)|0;if((mX(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}Hc=Hc+4|0;}while((c[Hc>>2]|0)!=0)}}while(0);if((ba|0)==0){uc=c[ea>>2]|0;vc=c[Ca+16>>2]|0;wc=Ya;break}ka=Ya+28|0;ta=c[ka>>2]|0;if((ta|0)==0){aa=ZX(S,0,0,0,32)|0;sb=aa;if((aa|0)==0){sa=169;break h}c[aa+24>>2]=Ya;c[aa+28>>2]=0;eb=ZX(S,0,0,0,c[l>>2]<<2)|0;c[aa+20>>2]=eb;if((eb|0)==0){sa=176;break h}c[ka>>2]=sb;Ic=sb}else{Ic=ta}c[Ic>>2]=s;c[Ic+4>>2]=Da;c[Ic+8>>2]=c[ea>>2];c[Ic+12>>2]=c[Ca+12>>2];c[Ic+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ta=c[Ic+20>>2]|0;sb=0;do{c[ta+(sb<<2)>>2]=c[Eb+(sb<<2)>>2];sb=sb+1|0;}while((sb|0)<(c[l>>2]|0))}sb=c[Ca+16>>2]|0;if((sb|0)==0){uc=ba;vc=Za;wc=Ic;break}ta=c[sb>>2]|0;if(!((ta|0)>-1)){uc=ba;vc=Za;wc=Ic;break}ka=c[Ic+20>>2]|0;eb=ta;ta=sb;while(1){c[ka+(eb<<2)>>2]=s;sb=ta+4|0;aa=c[sb>>2]|0;if((aa|0)>-1){ta=sb;eb=aa}else{uc=ba;vc=Za;wc=Ic;break}}}}while(0);eb=Ca+40|0;if((c[eb>>2]|0)==0){break}else{ea=eb;ba=uc;Za=vc;Ya=wc;Ca=Ca+32|0}}if((uc|0)==0){Nb=ec;Ob=vc;Pb=sc;Qb=wc;sa=196;continue j}do{if((vc|0)==0){Jc=0}else{Ca=c[vc>>2]|0;if((Ca|0)>-1){Kc=Ca;Lc=vc}else{Jc=vc;break}while(1){Ca=Lc+4|0;c[Eb+(Kc<<2)>>2]=s;Ya=c[Ca>>2]|0;if((Ya|0)>-1){Lc=Ca;Kc=Ya}else{Jc=Ca;break}}}}while(0);if((uc|0)==(c[G>>2]|0)){lc=Jc;mc=s;nc=sc;oc=wc;break}else{o=Jc;ca=s;ga=sc;ia=wc;ra=uc;da=Da}}}m:do{if((ec|0)<(mc|0)){sa=96}else{if((ec|0)!=(mc|0)|B){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}da=c[l>>2]|0;ra=c[x>>2]|0;if((da|0)>0){Mc=0}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}while(1){ia=c[Eb+(Mc<<2)>>2]|0;ga=c[n+(Mc<<2)>>2]|0;if((c[ra+(Mc<<2)>>2]|0)==0){if((ia|0)<(ga|0)){sa=96;break m}if((ia|0)>(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}else{if((ia|0)>(ga|0)){Nc=da;break m}if((ia|0)<(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}ga=Mc+1|0;if((ga|0)<(da|0)){Mc=ga}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}}while(0);if((sa|0)==96){sa=0;if(B){Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}Nc=c[l>>2]|0}if((Nc|0)>0){Oc=0}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}while(1){c[n+(Oc<<2)>>2]=c[Eb+(Oc<<2)>>2];da=Oc+1|0;if((da|0)<(c[l>>2]|0)){Oc=da}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}if((Nb|0)>=0){sa=205;break}if((c[j>>2]|0)==0){sa=205;break}c[j>>2]=D;q=c[l>>2]|0;F=Nb;w=Pb;E=v;L=Qb;M=y}if((sa|0)==60){YX(S);if((Eb|0)!=0){AY(O)}if((Kb|0)!=0){AY(Kb)}if((Lb|0)==0){A=12;break a}AY(N);A=12;break a}else if((sa|0)==67){YX(S);if((Eb|0)!=0){AY(O)}if((Kb|0)!=0){AY(Kb)}if((Lb|0)==0){A=12;break a}AY(N);A=12;break a}else if((sa|0)==169){YX(S);if((Eb|0)!=0){AY(O)}if((Kb|0)!=0){AY(Kb)}if((Lb|0)==0){A=12;break a}AY(N);A=12;break a}else if((sa|0)==176){YX(S);if((Eb|0)!=0){AY(O)}if((Kb|0)!=0){AY(Kb)}if((Lb|0)==0){A=12;break a}AY(N);A=12;break a}else if((sa|0)==205){Fb=Nb;Gb=Kb;Hb=Nb>>>31;Ib=Lb;Jb=Eb;break}}}while(0);YX(S);if((Jb|0)!=0){AY(Jb)}if((Gb|0)!=0){AY(Gb)}if((Ib|0)==0){Cb=Fb;Db=Hb;sa=375;break}AY(Ib);Cb=Fb;Db=Hb;sa=375}}while(0);do{if((sa|0)==375){if((Db|0)!=0){A=Db;break}WX(d,e,c[k+56>>2]|0,a,n,Cb);A=0}}while(0);if((n|0)==0){p=A;i=g;return p|0}AY(m);p=A;i=g;return p|0}function WX(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;do{if((g|0)>-1){if((d&8|0)!=0){j=0;break}k=c[e+16>>2]|0;l=e+28|0;m=c[l>>2]|0;n=(a|0)!=0;if((m|0)!=0&n){o=e+48|0;p=0;while(1){q=c[k+(p*12|0)>>2]|0;if((q|0)==(c[o>>2]|0)){c[b+(p<<3)>>2]=g;r=g}else{s=c[f+(q<<2)>>2]|0;c[b+(p<<3)>>2]=s;r=s}s=c[k+(p*12|0)+4>>2]|0;if((s|0)==(c[o>>2]|0)){c[b+(p<<3)+4>>2]=g;t=g}else{q=c[f+(s<<2)>>2]|0;c[b+(p<<3)+4>>2]=q;t=q}if((r|0)==-1|(t|0)==-1){c[b+(p<<3)+4>>2]=-1;c[b+(p<<3)>>2]=-1}q=p+1|0;s=c[l>>2]|0;if(q>>>0<s>>>0&q>>>0<a>>>0){p=q}else{u=s;break}}}else{u=m}if((u|0)!=0&n){v=u;w=0}else{j=0;break}while(1){p=b+(w<<3)+4|0;o=c[k+(w*12|0)+8>>2]|0;do{if((o|0)==0){x=v}else{s=c[o>>2]|0;if(!((s|0)>-1)){x=v;break}q=b+(w<<3)|0;y=c[q>>2]|0;z=s;s=0;while(1){if((y|0)<(c[b+(z<<3)>>2]|0)){A=21}else{if((c[p>>2]|0)>(c[b+(z<<3)+4>>2]|0)){A=21}else{B=y}}if((A|0)==21){A=0;c[p>>2]=-1;c[q>>2]=-1;B=-1}C=s+1|0;D=c[o+(C<<2)>>2]|0;if((D|0)>-1){y=B;z=D;s=C}else{break}}x=c[l>>2]|0}}while(0);o=w+1|0;if(o>>>0<x>>>0&o>>>0<a>>>0){v=x;w=o}else{j=o;break}}}else{j=0}}while(0);if(j>>>0<a>>>0){E=j}else{i=h;return}do{c[b+(E<<3)>>2]=-1;c[b+(E<<3)+4>>2]=-1;E=E+1|0;}while(E>>>0<a>>>0);i=h;return}function XX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)==0){e=BY(1,24)|0}else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;e=b}if((e|0)==0){f=0;i=d;return f|0}f=e;i=d;return f|0}function YX(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;if((d|0)==0){e=a;AY(e);i=b;return}else{f=d}while(1){AY(c[f>>2]|0);d=c[f+4>>2]|0;AY(f);if((d|0)==0){break}else{f=d}}e=a;AY(e);i=b;return}function ZX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=a+16|0;if((c[h>>2]|0)!=0){j=0;i=g;return j|0}k=a+12|0;l=c[k>>2]|0;do{if(l>>>0<f>>>0){if((b|0)!=0){if((d|0)!=0){c[a+8>>2]=d;c[k>>2]=1024;m=d;n=1024;break}c[h>>2]=1;j=0;i=g;return j|0}o=f<<3;p=o>>>0>1024?o:1024;o=zY(8)|0;q=o;if((o|0)==0){c[h>>2]=1;j=0;i=g;return j|0}r=zY(p)|0;c[o>>2]=r;if((r|0)==0){AY(o);c[h>>2]=1;j=0;i=g;return j|0}c[o+4>>2]=0;r=a+4|0;s=c[r>>2]|0;if((s|0)!=0){c[s+4>>2]=q}s=a;if((c[s>>2]|0)==0){c[s>>2]=q}c[r>>2]=q;q=c[o>>2]|0;c[a+8>>2]=q;c[k>>2]=p;m=q;n=p}else{m=c[a+8>>2]|0;n=l}}while(0);l=m+f&3;h=((l|0)==0?0:4-l|0)+f|0;c[a+8>>2]=m+h;c[k>>2]=n-h;if((e|0)==0){j=m;i=g;return j|0}fZ(m|0,0,h|0)|0;j=m;i=g;return j|0}function _X(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==0){e=a+(($X(a)|0)<<2)|0;i=d;return e|0}else{f=a}while(1){g=c[f>>2]|0;if((g|0)==0|(g|0)==(b|0)){break}else{f=f+4|0}}e=(g|0)!=0?f:0;i=d;return e|0}function $X(a){a=a|0;var b=0,d=0;b=i;d=a;while(1){if((c[d>>2]|0)==0){break}else{d=d+4|0}}i=b;return d-a>>2|0}function aY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=b;h=a}while(1){b=f+ -1|0;c[h>>2]=c[g>>2];if((b|0)==0){break}else{h=h+4|0;g=g+4|0;f=b}}i=e;return a|0}function bY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(f){i=e;return a|0}else{g=d}do{g=g+ -1|0;c[a+(g<<2)>>2]=c[b+(g<<2)>>2];}while((g|0)!=0);i=e;return a|0}else{if(f){i=e;return a|0}else{h=b;j=a;k=d}while(1){d=k+ -1|0;c[j>>2]=c[h>>2];if((d|0)==0){break}else{k=d;j=j+4|0;h=h+4|0}}i=e;return a|0}return 0}function cY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=a}while(1){d=f+ -1|0;c[g>>2]=b;if((d|0)==0){break}else{g=g+4|0;f=d}}i=e;return a|0}function dY(a){a=a|0;i=i;return}function eY(a){a=a|0;c[a>>2]=150960;i=i;return}function fY(a){a=a|0;var b=0;b=i;wb(a|0);HY(a);i=b;return}function gY(a){a=a|0;var b=0;b=i;wb(a|0);i=b;return}function hY(a){a=a|0;i=i;return 150976}function iY(a){a=a|0;i=i;return}function jY(a){a=a|0;i=i;return}function kY(a){a=a|0;i=i;return}function lY(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function mY(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function nY(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function oY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+56|0;f=e;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=sY(b,151088,151144,0)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}j=f+0|0;k=j+56|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;ve[c[(c[h>>2]|0)+28>>2]&31](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function pY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((c[d+8>>2]|0)!=(b|0)){i=g;return}b=d+16|0;h=c[b>>2]|0;if((h|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function qY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((b|0)!=(c[d+8>>2]|0)){h=c[b+8>>2]|0;ve[c[(c[h>>2]|0)+28>>2]&31](h,d,e,f);i=g;return}h=d+16|0;b=c[h>>2]|0;if((b|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function rY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((b|0)==(c[d+8>>2]|0)){h=d+16|0;j=c[h>>2]|0;if((j|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((j|0)!=(e|0)){j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}j=d+24|0;if((c[j>>2]|0)!=2){i=g;return}c[j>>2]=f;i=g;return}j=c[b+12>>2]|0;h=b+16+(j<<3)|0;k=c[b+20>>2]|0;l=k>>8;if((k&1|0)==0){m=l}else{m=c[(c[e>>2]|0)+l>>2]|0}l=c[b+16>>2]|0;ve[c[(c[l>>2]|0)+28>>2]&31](l,d,e+m|0,(k&2|0)!=0?f:2);if((j|0)<=1){i=g;return}j=d+54|0;k=b+24|0;while(1){b=c[k+4>>2]|0;m=b>>8;if((b&1|0)==0){n=m}else{n=c[(c[e>>2]|0)+m>>2]|0}m=c[k>>2]|0;ve[c[(c[m>>2]|0)+28>>2]&31](m,d,e+n|0,(b&2|0)!=0?f:2);if((a[j]|0)!=0){o=16;break}b=k+8|0;if(b>>>0<h>>>0){k=b}else{o=16;break}}if((o|0)==16){i=g;return}}



function Cw(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0.0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0;z=i;i=i+8|0;A=z;B=c[b>>2]|0;C=~B;D=c[u>>2]|0;E=~D;h[11276]=.5;h[11267]=1.0;h[11307]=.1;F=(c[a>>2]|0)+1|0;c[22530]=F;G=fa(c[a>>2]|0,F)|0;H=(G|0)/2|0;c[22522]=H;I=(c[b>>2]|0)-F|0;c[22576]=I;F=c[j>>2]|0;c[22630]=(F|0)<1?1:F;F=c[a>>2]|0;c[22514]=1;if((F|0)>=1){j=1;while(1){J=j+ -1|0;h[k+(J<<3)>>3]=+h[d+(J<<3)>>3];J=c[b>>2]|0;c[22516]=1;if((J|0)>=1){K=fa(j,B)|0;L=1;while(1){h[n+(L+C+K<<3)>>3]=0.0;if((L|0)<(J|0)){L=L+1|0}else{break}}c[22516]=J+1}L=c[u>>2]|0;c[22512]=1;if((L|0)>=1){K=1;while(1){h[s+(K+E+(fa(j,D)|0)<<3)>>3]=0.0;if((K|0)<(L|0)){K=K+1|0}else{break}}c[22512]=L+1}K=j+1|0;c[22514]=K;if((j|0)<(F|0)){j=K}else{break}}}c[22518]=1;if((G|0)>=2){G=1;while(1){h[q+(G+ -1<<3)>>3]=0.0;if((G|0)<(H|0)){G=G+1|0}else{break}}c[22518]=H+1}H=c[b>>2]|0;c[22516]=1;if((H|0)>=1){G=(I|0)<1;j=I+1|0;F=1;while(1){h[r+(F+ -1<<3)>>3]=0.0;if(G){M=1}else{K=1;while(1){h[t+((fa(K,B)|0)+C+F<<3)>>3]=0.0;if((K|0)<(I|0)){K=K+1|0}else{M=j;break}}}if((F|0)<(H|0)){F=F+1|0}else{break}}c[22514]=M;c[22516]=H+1}N=+h[e>>3];O=N*N;h[11312]=O;h[11298]=+h[11267]/O;h[11299]=+V(+(+h[11276]))/O;c[22520]=0;H=y;y=A;M=0;a:while(1){c[22532]=M;F=M-(c[a>>2]|0)|0;c[22556]=F;j=M+1|0;c[22520]=j;I=c[a>>2]|0;do{if((M|0)>(I<<1|0)){G=(F+ -1|0)/(I|0)|0;c[22606]=G;K=c[a>>2]|0;L=M-(fa(K,G)|0)-K|0;c[22544]=L;K=L+G|0;c[22542]=K;if((K|0)>(c[a>>2]|0)){c[22606]=L;G=K-(c[a>>2]|0)|0;c[22544]=G;c[22542]=L;P=L;Q=G}else{P=K;Q=L}O=+h[e>>3];h[11289]=O;L=c[22530]|0;if(+h[o+(P+ -1+L<<3)>>3]<+h[o+(P<<3)>>3]){N=-O;h[11289]=N;R=N}else{R=O}O=+h[e>>3];h[11290]=O;if(+h[o+(Q+ -1+L<<3)>>3]<+h[o+(Q<<3)>>3]){h[11290]=-O}L=j+C|0;h[n+(L+(fa(P,B)|0)<<3)>>3]=R;h[n+(L+(fa(Q,B)|0)<<3)>>3]=+h[11290];S=c[a>>2]|0}else{L=(M|0)>(I|0);if(!((M|0)<1|L)){h[n+((fa(M,B)|0)+C+j<<3)>>3]=+h[e>>3];S=I;break}if(!L){S=I;break}h[n+(j+C+(fa(F,B)|0)<<3)>>3]=-+h[e>>3];S=I}}while(0);c[22514]=1;if((S|0)>=1){I=1;while(1){O=+h[n+((fa(I,B)|0)+C+j<<3)>>3];F=I+ -1|0;h[d+(F<<3)>>3]=O+ +h[k+(F<<3)>>3];if((I|0)<(S|0)){I=I+1|0}else{break}}c[22514]=S+1}if((M|0)>=(c[22630]|0)){T=j;U=159;break}while(1){$d[H&63](a,d,90040)|0;if((c[g>>2]|0)==3){cN(90568)|0;tM(90736,90080,4)|0;tM(90736,90040,8)|0;I=c[a>>2]|0;c[22512]=1;if((I|0)>=1){F=1;do{tM(90736,d+(F+ -1<<3)|0,8)|0;L=c[22512]|0;F=L+1|0;c[22512]=F;}while((L|0)<(I|0))}MM()|0}I=c[22520]|0;do{if((I|0)>(c[b>>2]|0)){F=c[22560]|0;if((F|0)==-1){break a}h[11308]=0.0;c[22518]=0;L=c[a>>2]|0;c[22514]=1;if((L|0)<1){W=0.0}else{O=0.0;K=2;G=1;J=0;while(1){X=G+ -1|0;N=O+ +h[v+(X<<3)>>3]*+h[p+(X<<3)>>3];h[11308]=N;if((G|0)<1){Y=1;Z=N;_=J}else{X=G+ -1|0;$=m+(X<<3)|0;aa=v+(X<<3)|0;ba=N;X=1;ca=J;while(1){da=X+ -1|0;N=+h[v+(da<<3)>>3]*+h[$>>3]+ +h[aa>>3]*+h[l+(da<<3)>>3];h[11281]=N;if((X|0)==(G|0)){ea=N*+h[11276];h[11281]=ea;ga=ea}else{ga=N}ha=ba+ga*+h[q+(ca<<3)>>3];h[11308]=ha;if((X|0)<(G|0)){ba=ha;X=X+1|0;ca=ca+1|0}else{break}}ca=J+G|0;c[22518]=ca;Y=K;Z=ha;_=ca}if((G|0)<(L|0)){O=Z;K=K+1|0;G=G+1|0;J=_}else{break}}c[22512]=Y;c[22514]=L+1;W=Z}J=c[b>>2]|0;c[22516]=1;if((J|0)<1){ia=W}else{O=W;G=1;while(1){K=G+ -1|0;ja=O+ +h[r+(K<<3)>>3]*+h[x+(K<<3)>>3];h[11308]=ja;if((G|0)<(J|0)){G=G+1|0;O=ja}else{break}}c[22516]=J+1;ia=ja}O=+h[11255];ba=+h[11284];N=O-ba-ia;h[11275]=N;h[11294]=+h[11293];h[11293]=+h[11292];if(!(N>=0.0)){ka=-N}else{ka=N}h[11292]=ka;if(+h[11304]>+h[11270]){c[22604]=I}h[11300]=ba;do{if(O<ba){h[11284]=O;h[11317]=0.0;G=c[a>>2]|0;c[22512]=1;if((G|0)<1){break}else{la=1}while(1){L=la+ -1|0;h[l+(L<<3)>>3]=+h[m+(L<<3)>>3];ma=+h[l+(la+ -1<<3)>>3];h[11317]=+h[11317]+ma*ma;if((la|0)<(G|0)){la=la+1|0}else{break}}c[22512]=G+1;h[A>>3]=ma}}while(0);c[22602]=F;if((F|0)<=0){O=+h[11308];if(O>=0.0){U=190;break a}ba=+h[11255];N=+h[11300];ea=(ba-N)/O;h[11305]=ea;O=+h[11307];do{if(!(ea<=O)){na=+h[11276]*+h[11297];h[A>>3]=na;oa=+h[11304];if(!(ea<=.7)){pa=oa+oa;qa=na>=pa?na:pa;h[11297]=qa;ra=qa;break}else{qa=na>=oa?na:oa;h[11297]=qa;ra=qa;break}}else{qa=+h[11276]*+h[11304];h[11297]=qa;ra=qa}}while(0);ea=+h[11270];if(!(ra<=ea*1.5)){sa=ra}else{h[11297]=ea;sa=ea}qa=O*sa;oa=qa>=ea?qa:ea;h[A>>3]=oa;ea=oa*oa;h[11312]=ea;c[22618]=0;h[11313]=0.0;if(!(ba>=N)){ta=0;ua=0.0}else{J=c[22574]|0;c[22618]=J;oa=+h[11267];h[11313]=oa;ta=J;ua=oa}J=c[b>>2]|0;c[22516]=1;if((J|0)<1){va=F}else{L=c[22576]|0;oa=ua;K=1;ca=F;while(1){h[11295]=0.0;c[22514]=1;if((L|0)<1){wa=0.0}else{X=c[22536]|0;aa=K+C|0;qa=+h[11267];na=0.0;$=1;while(1){if(($|0)<(X|0)){xa=-qa}else{xa=qa}h[11281]=xa;pa=+h[t+(aa+(fa($,B)|0)<<3)>>3];ya=na+xa*pa*pa;h[11295]=ya;if(($|0)<(L|0)){na=ya;$=$+1|0}else{break}}c[22514]=L+1;wa=ya}na=+h[w+(K+ -1<<3)>>3];qa=na*na+ +h[11277]*wa;if(!(qa>=0.0)){za=-qa}else{za=qa}h[11281]=za;h[11316]=0.0;$=c[a>>2]|0;c[22514]=1;if(($|0)<1){Aa=qa;Ba=0.0}else{qa=0.0;aa=1;while(1){na=+h[n+((fa(aa,B)|0)+C+K<<3)>>3];Ca=na- +h[l+(aa+ -1<<3)>>3];Da=qa+Ca*Ca;h[11316]=Da;if((aa|0)<($|0)){aa=aa+1|0;qa=Da}else{break}}c[22514]=$+1;Aa=Ca;Ba=Da}if(Ba>ea){qa=Ba/ea;na=za*qa*qa*qa;h[11281]=na;Ea=qa;Fa=na}else{Ea=Aa;Fa=za}if(!(Fa>oa)|(K|0)==(ta|0)){Ga=oa;Ha=ca}else{h[11313]=Fa;c[22560]=K;Ga=Fa;Ha=K}aa=K+1|0;c[22516]=aa;if((K|0)<(J|0)){oa=Ga;K=aa;ca=Ha}else{break}}h[A>>3]=Ea;va=Ha}if((va|0)==0){Ia=0;Ja=sa;Ka=O;U=286;break}}Ew(a,b,s,t,90144,u,w,90216,90240,x)|0;ca=c[22560]|0;K=ca+ -1|0;h[o+(K<<3)>>3]=+h[11255];c[22518]=0;J=c[a>>2]|0;c[22512]=1;L=r+(K<<3)|0;if((J|0)>=1){K=ca+C|0;F=2;aa=1;X=0;while(1){oa=+h[L>>3]*+h[n+((fa(aa,B)|0)+C+ca<<3)>>3];h[11281]=oa;if((aa|0)<1){La=1;Ma=X}else{ea=oa;G=1;da=X;while(1){oa=ea*+h[n+(K+(fa(G,B)|0)<<3)>>3];Na=q+(da<<3)|0;h[Na>>3]=+h[Na>>3]+oa;if((G|0)>=(aa|0)){break}ea=+h[11281];G=G+1|0;da=da+1|0}da=X+aa|0;c[22518]=da;La=F;Ma=da}if((aa|0)<(J|0)){F=F+1|0;aa=aa+1|0;X=Ma}else{break}}c[22514]=La;c[22512]=J+1}h[L>>3]=0.0;X=c[22576]|0;c[22514]=1;aa=(X|0)<1;if(!aa){F=c[22536]|0;K=1;while(1){da=fa(K,B)|0;O=+h[11275]*+h[t+(da+C+ca<<3)>>3];if((K|0)<(F|0)){Oa=-O}else{Oa=O}h[11281]=Oa;G=c[b>>2]|0;c[22516]=1;if((G|0)>=1){O=Oa;$=1;while(1){Na=r+($+ -1<<3)|0;h[Na>>3]=+h[Na>>3]+O*+h[t+($+C+da<<3)>>3];if(($|0)>=(G|0)){break}O=+h[11281];$=$+1|0}c[22516]=G+1}$=K+1|0;c[22514]=$;if((K|0)<(X|0)){K=$}else{break}}}h[11286]=0.0;K=c[a>>2]|0;c[22512]=1;if((K|0)>=1){F=1;while(1){O=+h[11275]*+h[s+((fa(F,D)|0)+E+ca<<3)>>3];L=p+(F+ -1<<3)|0;h[L>>3]=+h[L>>3]+O;L=F+ -1|0;Pa=+h[p+(L<<3)>>3];h[11286]=+h[11286]+Pa*Pa;h[n+((fa(F,B)|0)+C+ca<<3)>>3]=+h[m+(L<<3)>>3];if((F|0)<(K|0)){F=F+1|0}else{break}}c[22512]=K+1;h[A>>3]=Pa}F=c[22602]|0;do{if((F|0)==0){if(!(+h[11297]==+h[11270])){break}O=+h[11305];if(!(O>=0.0)){Qa=-O}else{Qa=O}if(Qa>.01){c[22622]=0;break}L=c[b>>2]|0;c[22516]=1;if((L|0)>=1){J=o+((c[22574]|0)+ -1<<3)|0;$=1;while(1){da=$+ -1|0;h[w+(da<<3)>>3]=+h[o+(da<<3)>>3]- +h[J>>3];if(($|0)<(L|0)){$=$+1|0}else{break}}c[22516]=L+1}h[11279]=0.0;$=c[a>>2]|0;c[22512]=1;if(($|0)<1){Ra=0.0}else{J=1;while(1){h[11273]=0.0;G=c[b>>2]|0;c[22516]=1;if((G|0)<1){Sa=0.0}else{da=fa(J,D)|0;O=0.0;Na=1;while(1){Ta=O+ +h[s+(Na+E+da<<3)>>3]*+h[w+(Na+ -1<<3)>>3];h[11273]=Ta;if((Na|0)<(G|0)){Na=Na+1|0;O=Ta}else{break}}c[22516]=G+1;Sa=Ta}h[11279]=+h[11279]+Sa*Sa;h[x+(J+ -1<<3)>>3]=Sa;Na=J+1|0;c[22512]=Na;if((J|0)<($|0)){J=Na}else{break}}Ra=+h[11279]*100.0}J=c[22622]|0;c[22622]=J+1;if(+h[11286]<Ra){c[22622]=0;break}if((J|0)<=1){break}J=c[a>>2]|0;c[22512]=1;if((J|0)>=1){$=1;while(1){L=$+ -1|0;h[p+(L<<3)>>3]=+h[x+(L<<3)>>3];if(($|0)<(J|0)){$=$+1|0}else{break}}c[22512]=J+1}$=c[22522]|0;c[22518]=1;if(($|0)>=1){L=1;while(1){h[q+(L+ -1<<3)>>3]=0.0;if((L|0)<($|0)){L=L+1|0}else{break}}c[22518]=$+1}c[22514]=1;if(!aa){L=1;while(1){J=x+(L+ -1<<3)|0;h[J>>3]=0.0;Na=c[b>>2]|0;c[22516]=1;if((Na|0)<1){Ua=0.0}else{da=fa(L,B)|0;O=0.0;Va=1;while(1){Wa=O+ +h[w+(Va+ -1<<3)>>3]*+h[t+(Va+C+da<<3)>>3];h[J>>3]=Wa;if((Va|0)<(Na|0)){Va=Va+1|0;O=Wa}else{break}}c[22516]=Na+1;Ua=Wa}if((L|0)<(c[22536]|0)){h[J>>3]=-Ua}Va=L+1|0;c[22514]=Va;if((L|0)<(X|0)){L=Va}else{break}}}L=c[b>>2]|0;c[22516]=1;if((L|0)>=1){$=X+1|0;Va=1;while(1){h[r+(Va+ -1<<3)>>3]=0.0;if(aa){Xa=1}else{da=1;while(1){O=+h[t+((fa(da,B)|0)+C+Va<<3)>>3];G=r+(Va+ -1<<3)|0;h[G>>3]=+h[G>>3]+O*+h[x+(da+ -1<<3)>>3];if((da|0)<(X|0)){da=da+1|0}else{Xa=$;break}}}if((Va|0)<(L|0)){Va=Va+1|0}else{break}}c[22514]=Xa;c[22516]=L+1}c[22622]=0}}while(0);O=+h[11255];ea=+h[11300];if(O<ea){c[22574]=ca}oa=+h[11307];if(O<=ea+oa*+h[11308]|(F|0)>0){U=54;break}c[22560]=0;Ia=0;Ja=+h[11297];Ka=oa;U=286}else{h[o+(I+ -1<<3)>>3]=+h[11255];oa=+h[11255];do{if((I|0)==1){h[11274]=oa;h[11284]=oa;c[22574]=1;Ya=1}else{if(!(oa<+h[11284])){Ya=I;break}h[11284]=oa;c[22574]=I;Ya=I}}while(0);F=c[22532]|0;ca=c[a>>2]|0;do{if((F|0)>(ca<<1|0)){X=c[22542]|0;aa=(fa(X+ -1|0,X)|0)/2|0;K=c[22544]|0;Va=K+aa|0;c[22518]=Va;if(+h[11289]<0.0){aa=X+(c[a>>2]|0)|0;c[22542]=aa;Za=aa}else{Za=X}if(+h[11290]<0.0){X=K+(c[a>>2]|0)|0;c[22544]=X;_a=X}else{_a=K}K=fa(c[22556]|0,B)|0;h[t+(K-B<<3)>>3]=+h[11298];h[t+(Ya+C+K<<3)>>3]=+h[11298];h[t+(Za-B+K<<3)>>3]=-+h[11298];h[t+(_a-B+K<<3)>>3]=-+h[11298];h[q+(Va+ -1<<3)>>3]=(+h[11274]- +h[o+(Za<<3)>>3]- +h[o+(_a<<3)>>3]+ +h[11255])/(+h[11289]*+h[11290])}else{Va=(F|0)>(ca|0);if((F|0)<1|Va){if(!Va){break}Va=c[22556]|0;K=fa(Va,D)|0;h[s+(E-ca+Ya+K<<3)>>3]=+h[11276]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=-+h[11276]/+h[e>>3];ea=+h[11299];K=fa(Va,B)|0;h[t+(K-B<<3)>>3]=-ea-ea;X=Ya+C|0;h[t+(X-ca+K<<3)>>3]=+h[11299];h[t+(X+K<<3)>>3]=+h[11299];K=(fa(Va+1|0,Va)|0)/2|0;c[22518]=K;ea=(+h[11274]- +h[11255])/+h[e>>3];h[11281]=ea;X=p+(Va+ -1<<3)|0;h[q+(K+ -1<<3)>>3]=(+h[X>>3]-ea)/+h[e>>3];h[X>>3]=+h[11276]*(+h[X>>3]+ +h[11281]);break}else{h[p+(F+ -1<<3)>>3]=(oa- +h[11274])/+h[e>>3];X=c[b>>2]|0;if((X|0)>=(ca+Ya|0)){break}K=fa(F,D)|0;h[s+(K-D<<3)>>3]=-+h[11267]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=+h[11267]/+h[e>>3];h[s+(X+E+F+K<<3)>>3]=-(+h[11276]*+h[11312]);break}}}while(0);if((Ya|0)<(c[b>>2]|0)){M=Ya;continue a}oa=+h[e>>3];h[11270]=oa;h[11297]=oa;c[22536]=1;h[11292]=0.0;h[11293]=0.0;c[22622]=0;h[11317]=0.0;F=c[a>>2]|0;c[22512]=1;if((F|0)<1){U=53;break}ca=c[22574]|0;K=1;while(1){h[l+(K+ -1<<3)>>3]=+h[n+((fa(K,B)|0)+C+ca<<3)>>3];$a=+h[l+(K+ -1<<3)>>3];h[11317]=+h[11317]+$a*$a;if((K|0)<(F|0)){K=K+1|0}else{break}}c[22512]=F+1;h[A>>3]=$a;U=53}}while(0);while(1){if((U|0)==53){U=0;c[22604]=c[22520];U=54;continue}else if((U|0)==54){U=0;c[22560]=0;I=(c[22530]|0)+ -1|0;K=c[a>>2]|0;Dw(a,b,l,n,p,q,r,90376,v,x,x+(I<<3)|0,x+(I+K<<3)|0,x+(I+(K<<1)<<3)|0,90512)|0;h[11269]=0.0;K=c[a>>2]|0;c[22512]=1;if((K|0)<1){ab=0.0}else{oa=0.0;I=1;while(1){bb=+h[v+(I+ -1<<3)>>3];cb=oa+bb*bb;h[11269]=cb;if((I|0)<(K|0)){I=I+1|0;oa=cb}else{break}}h[A>>3]=bb;c[22512]=K+1;ab=cb}oa=+h[11297];h[A>>3]=oa;ea=+V(+ab);O=oa<=ea?oa:ea;h[11304]=O;ea=+h[11270];if(!(O<+h[11276]*ea)){db=ab;U=62;break}c[22560]=-1;O=+h[11307];N=O*oa;h[11297]=N;h[11305]=-1.0;if(!(N<=ea*1.5)){eb=N}else{h[11297]=ea;eb=ea}if((c[22520]|0)<=((c[22604]|0)+2|0)){Ia=-1;Ja=eb;Ka=O;U=286;continue}N=ea*+h[11314]*.125*ea;h[11281]=N;oa=+h[11292];ba=+h[11293];na=oa>=ba?oa:ba;h[A>>3]=na;ba=+h[11294];if(!(N<=(na>=ba?na:ba))){fb=-1;gb=O;hb=ea}else{Ia=-1;Ja=eb;Ka=O;U=286;continue}}else if((U|0)==286){U=0;O=Ja*Ja*4.0;h[11316]=O;I=c[b>>2]|0;c[22516]=1;if((I|0)<1){ib=Ia}else{F=1;ea=O;ca=Ia;while(1){h[11273]=0.0;X=c[a>>2]|0;c[22514]=1;if((X|0)<1){jb=0.0}else{O=0.0;Va=1;while(1){ba=+h[n+((fa(Va,B)|0)+C+F<<3)>>3];kb=ba- +h[l+(Va+ -1<<3)>>3];lb=O+kb*kb;h[11273]=lb;if((Va|0)<(X|0)){Va=Va+1|0;O=lb}else{break}}h[A>>3]=kb;c[22514]=X+1;jb=lb}if(jb>ea){c[22560]=F;h[11316]=jb;mb=jb;nb=F}else{mb=ea;nb=ca}Va=F+1|0;c[22516]=Va;if((F|0)<(I|0)){F=Va;ea=mb;ca=nb}else{break}}if((nb|0)>0){U=294;break}else{ib=nb}}if(+h[11305]>0.0){U=54;continue}ea=+h[11304];O=+h[11270];if((Ja>=ea?Ja:ea)>O){U=54;continue}else{fb=ib;gb=Ka;hb=O}}if(!(hb>+h[f>>3])){U=309;break}O=hb*+h[11276];h[11297]=O;ea=hb/+h[f>>3];h[11305]=ea;do{if(!(ea<=16.0)){if(!(ea<=250.0)){ba=gb*hb;h[11270]=ba;ob=ba;break}else{ba=+V(+ea);na=ba*+h[f>>3];h[11270]=na;ob=na;break}}else{na=+h[f>>3];h[11270]=na;ob=na}}while(0);h[11297]=O>=ob?O:ob;ca=c[g>>2]|0;if((ca|0)<=1){U=53;continue}if((ca|0)>2){cN(90616)|0;MM()|0}cN(90640)|0;tM(90736,90160,8)|0;tM(90736,90080,4)|0;MM()|0;cN(90664)|0;tM(90736,90272,8)|0;ca=c[a>>2]|0;c[22512]=1;if((ca|0)>=1){F=1;do{I=F+ -1|0;h[A>>3]=+h[k+(I<<3)>>3]+ +h[l+(I<<3)>>3];tM(90736,y,8)|0;I=c[22512]|0;F=I+1|0;c[22512]=F;}while((I|0)<(ca|0))}MM()|0;U=53}if((U|0)==294){U=0;O=Ka*+V(+mb);ea=+h[11276]*Ja;na=O<=ea?O:ea;h[A>>3]=na;ea=+h[11270];O=na>=ea?na:ea;h[11306]=O;ea=O*O;h[11269]=ea;db=ea;U=62}else if((U|0)==309){U=0;if(!((fb|0)==-1)){break a}}do{if((U|0)==62){U=0;ea=+h[11317];if(db<=ea*.001){h[11310]=ea*.25;ca=c[b>>2]|0;c[22516]=1;if((ca|0)>=1){F=1;while(1){h[11273]=0.0;I=c[a>>2]|0;c[22512]=1;if((I|0)<1){pb=0.0}else{ea=0.0;K=1;while(1){O=+h[n+((fa(K,B)|0)+C+F<<3)>>3];qb=ea+O*+h[l+(K+ -1<<3)>>3];h[11273]=qb;if((K|0)<(I|0)){K=K+1|0;ea=qb}else{break}}c[22512]=I+1;pb=qb}h[11281]=+h[r+(F+ -1<<3)>>3]*pb;ea=pb- +h[11276]*+h[11317];h[11273]=ea;h[x+((c[b>>2]|0)+ -1+F<<3)>>3]=ea;K=c[a>>2]|0;c[22512]=1;if((K|0)>=1){X=1;while(1){Va=fa(X,B)|0;L=n+(Va+C+F<<3)|0;aa=X+ -1|0;$=p+(aa<<3)|0;h[$>>3]=+h[$>>3]+ +h[11281]*+h[L>>3];$=l+(aa<<3)|0;h[L>>3]=+h[L>>3]- +h[11276]*+h[$>>3];L=w+(aa<<3)|0;h[L>>3]=+h[s+(F+E+(fa(X,D)|0)<<3)>>3];ea=+h[11273]*+h[n+(F+C+Va<<3)>>3]+ +h[11310]*+h[$>>3];$=x+(aa<<3)|0;h[$>>3]=ea;aa=X+(c[b>>2]|0)|0;c[22524]=aa;c[22514]=1;if((X|0)<1){rb=X+1|0}else{O=ea;Va=1;while(1){da=s+((fa(Va,D)|0)+E+aa<<3)|0;J=Va+ -1|0;h[da>>3]=+h[da>>3]+ +h[L>>3]*+h[x+(J<<3)>>3]+O*+h[w+(J<<3)>>3];if((Va|0)>=(X|0)){break}O=+h[$>>3];Va=Va+1|0}Va=X+1|0;c[22514]=Va;rb=Va}c[22512]=rb;if((X|0)<(K|0)){X=rb}else{break}}}X=F+1|0;c[22516]=X;if((F|0)<(ca|0)){F=X}else{break}}}F=c[22576]|0;c[22516]=1;if((F|0)>=1){ca=1;while(1){h[11291]=0.0;X=c[b>>2]|0;c[22512]=1;b:do{if((X|0)>=1){O=0.0;K=1;while(1){I=t+(K+C+(fa(ca,B)|0)<<3)|0;h[11291]=+h[I>>3]+O;h[x+(K+ -1<<3)>>3]=+h[x+((c[b>>2]|0)+ -1+K<<3)>>3]*+h[I>>3];I=K+1|0;c[22512]=I;if((K|0)>=(X|0)){break b}O=+h[11291];K=I}}}while(0);X=c[a>>2]|0;c[22514]=1;if((X|0)>=1){K=1;while(1){I=K+ -1|0;O=+h[11310]*+h[11291]*+h[l+(I<<3)>>3];h[11273]=O;Va=c[b>>2]|0;c[22512]=1;if((Va|0)<1){sb=O}else{$=fa(K,B)|0;ea=O;L=1;while(1){tb=ea+ +h[x+(L+ -1<<3)>>3]*+h[n+(L+C+$<<3)>>3];h[11273]=tb;if((L|0)<(Va|0)){L=L+1|0;ea=tb}else{break}}c[22512]=Va+1;sb=tb}h[w+(I<<3)>>3]=sb;if((ca|0)<(c[22536]|0)){h[11273]=-+h[11273]}L=c[b>>2]|0;c[22512]=1;if((L|0)>=1){$=fa(ca,B)|0;aa=fa(K,D)|0;J=1;while(1){da=s+(J+E+aa<<3)|0;h[da>>3]=+h[11273]*+h[t+(J+C+$<<3)>>3]+ +h[da>>3];if((J|0)<(L|0)){J=J+1|0}else{break}}c[22512]=L+1}J=K+1|0;c[22514]=J;if((K|0)<(X|0)){K=J}else{break}}}K=c[a>>2]|0;c[22512]=1;if((K|0)>=1){X=c[22536]|0;J=1;while(1){$=(c[b>>2]|0)+J|0;c[22524]=$;ea=+h[w+(J+ -1<<3)>>3];if((ca|0)<(X|0)){ub=-ea}else{ub=ea}h[11281]=ub;c[22514]=1;if((J|0)<1){vb=J+1|0}else{ea=ub;aa=1;while(1){I=s+((fa(aa,D)|0)+E+$<<3)|0;h[I>>3]=ea*+h[w+(aa+ -1<<3)>>3]+ +h[I>>3];if((aa|0)>=(J|0)){break}ea=+h[11281];aa=aa+1|0}aa=J+1|0;c[22514]=aa;vb=aa}c[22512]=vb;if((J|0)<(K|0)){J=vb}else{break}}}J=ca+1|0;c[22516]=J;if((ca|0)<(F|0)){ca=J}else{break}}}c[22518]=0;ca=c[a>>2]|0;c[22514]=1;if((ca|0)>=1){F=0;J=1;while(1){K=J+ -1|0;X=x+(K<<3)|0;h[X>>3]=0.0;aa=c[b>>2]|0;c[22516]=1;if((aa|0)>=1){$=fa(J,B)|0;L=l+(K<<3)|0;I=$+C|0;ea=0.0;Va=1;while(1){h[X>>3]=ea+ +h[r+(Va+ -1<<3)>>3]*+h[n+(Va+C+$<<3)>>3];da=n+(I+Va<<3)|0;h[da>>3]=+h[da>>3]- +h[11276]*+h[L>>3];if((Va|0)>=(aa|0)){break}ea=+h[X>>3];Va=Va+1|0}c[22516]=aa+1}c[22512]=1;if((J|0)<1){wb=F}else{Va=1;L=F;while(1){I=L+1|0;c[22518]=I;$=(Va|0)<(J|0);da=q+(L<<3)|0;if($){Na=Va+ -1|0;G=l+(Na<<3)|0;xb=p+(K<<3)|0;h[xb>>3]=+h[xb>>3]+ +h[da>>3]*+h[G>>3];yb=G;zb=Na}else{Na=Va+ -1|0;yb=l+(Na<<3)|0;zb=Na}Na=l+(K<<3)|0;G=p+(zb<<3)|0;h[G>>3]=+h[da>>3]*+h[Na>>3]+ +h[G>>3];h[da>>3]=+h[da>>3]+ +h[x+(zb<<3)>>3]*+h[Na>>3]+ +h[yb>>3]*+h[X>>3];Na=(c[b>>2]|0)+E|0;h[s+(Na+Va+(fa(J,D)|0)<<3)>>3]=+h[s+(Na+J+(fa(Va,D)|0)<<3)>>3];Na=Va+1|0;c[22512]=Na;if($){Va=Na;L=I}else{wb=I;break}}}L=J+1|0;c[22514]=L;if((J|0)<(ca|0)){F=wb;J=L}else{break}}}J=c[a>>2]|0;c[22514]=1;if((J|0)>=1){F=1;while(1){ca=F+ -1|0;L=k+(ca<<3)|0;h[L>>3]=+h[l+(ca<<3)>>3]+ +h[L>>3];h[l+(F+ -1<<3)>>3]=0.0;if((F|0)<(J|0)){F=F+1|0}else{break}}c[22514]=J+1}h[11317]=0.0}if((c[22560]|0)>0){F=(c[22530]|0)+ -1|0;Yv(a,b,l,n,s,t,90144,u,90240,90448,v,90368,w,w+(c[b>>2]<<3)|0,x,x+(F<<3)|0,x+(F+(c[a>>2]|0)<<3)|0)|0}F=c[b>>2]|0;c[22516]=1;if((F|0)>=1){L=1;while(1){h[11282]=0.0;h[11283]=0.0;h[11273]=0.0;ca=c[a>>2]|0;c[22514]=1;if((ca|0)<1){Ab=0.0;Bb=0.0}else{Va=L+C|0;X=L+E|0;ea=0.0;O=0.0;na=0.0;K=1;while(1){ba=+h[n+((fa(K,B)|0)+C+L<<3)>>3];Cb=na+ba*+h[v+(K+ -1<<3)>>3];h[11282]=Cb;ba=+h[n+(Va+(fa(K,B)|0)<<3)>>3];aa=K+ -1|0;Db=O+ba*+h[l+(aa<<3)>>3];h[11283]=Db;ba=+h[s+(X+(fa(K,D)|0)<<3)>>3];N=ea+ba*+h[v+(aa<<3)>>3];h[11273]=N;if((K|0)<(ca|0)){K=K+1|0;na=Cb;O=Db;ea=N}else{break}}c[22514]=ca+1;Ab=Db;Bb=Cb}K=L+ -1|0;h[x+(K<<3)>>3]=Bb*(Bb*+h[11276]+Ab);h[w+(K<<3)>>3]=+h[11273];K=L+1|0;c[22516]=K;if((L|0)<(F|0)){L=K}else{break}}}h[11277]=0.0;L=c[22576]|0;c[22516]=1;if((L|0)>=1){F=1;while(1){h[11273]=0.0;J=c[b>>2]|0;c[22512]=1;if((J|0)<1){Eb=0.0}else{ea=0.0;K=1;while(1){O=+h[t+(K+C+(fa(F,B)|0)<<3)>>3];Fb=ea+O*+h[x+(K+ -1<<3)>>3];h[11273]=Fb;if((K|0)<(J|0)){K=K+1|0;ea=Fb}else{break}}c[22512]=J+1;Eb=Fb}ea=Eb*Eb;O=+h[11277];if((F|0)<(c[22536]|0)){h[11277]=O+ea;na=-Eb;h[11273]=na;Gb=na}else{h[11277]=O-ea;Gb=Eb}K=c[b>>2]|0;c[22512]=1;if((K|0)>=1){ca=fa(F,B)|0;ea=Gb;X=1;while(1){Va=w+(X+ -1<<3)|0;h[Va>>3]=+h[Va>>3]+ea*+h[t+(X+C+ca<<3)>>3];if((X|0)>=(K|0)){break}ea=+h[11273];X=X+1|0}c[22512]=K+1}X=F+1|0;c[22516]=X;if((F|0)<(L|0)){F=X}else{break}}}h[11285]=0.0;h[11264]=0.0;F=c[a>>2]|0;c[22514]=1;if((F|0)<1){Hb=0.0;Ib=0.0}else{ea=0.0;L=1;while(1){h[11273]=0.0;X=c[b>>2]|0;c[22512]=1;if((X|0)<1){Jb=0.0}else{ca=fa(L,D)|0;O=0.0;J=1;while(1){Kb=O+ +h[x+(J+ -1<<3)>>3]*+h[s+(J+E+ca<<3)>>3];h[11273]=Kb;if((J|0)<(X|0)){J=J+1|0;O=Kb}else{break}}c[22512]=X+1;Jb=Kb}J=L+ -1|0;ca=v+(J<<3)|0;h[11285]=ea+Jb*+h[ca>>3];K=L+(c[b>>2]|0)|0;c[22526]=K;Va=c[a>>2]|0;c[22516]=1;if((Va|0)<1){Lb=Jb}else{O=Jb;aa=1;while(1){na=+h[s+((fa(aa,D)|0)+E+K<<3)>>3];Mb=O+na*+h[v+(aa+ -1<<3)>>3];h[11273]=Mb;if((aa|0)<(Va|0)){aa=aa+1|0;O=Mb}else{break}}c[22516]=Va+1;Lb=Mb}h[w+(K+ -1<<3)>>3]=Lb;O=+h[11285]+ +h[11273]*+h[ca>>3];h[11285]=O;na=+h[11264]+ +h[ca>>3]*+h[l+(J<<3)>>3];h[11264]=na;aa=L+1|0;c[22514]=aa;if((L|0)<(F|0)){ea=O;L=aa}else{Hb=O;Ib=na;break}}}ea=+h[11269];h[11277]=+h[11277]+(Ib*Ib+ea*(Ib+(Ib+ +h[11317])+ea*+h[11276]))-Hb;L=w+((c[22574]|0)+ -1<<3)|0;h[L>>3]=+h[11267]+ +h[L>>3];L=c[22560]|0;if((L|0)<=0){break}ea=+h[w+(L+ -1<<3)>>3];h[A>>3]=ea;na=+h[11267]+ +h[11296]*+h[11277]/(ea*ea);h[11281]=na;if(!(na>=0.0)){Nb=-na}else{Nb=na}if(!(Nb<=.8)){break}L=c[u>>2]|0;Xv(a,b,l,n,s,t,90144,u,90296,90240,v,x,w,90216,m,x+(L<<3)|0,x+((L*6|1)+ -1<<3)|0)|0}}while(0);L=c[a>>2]|0;c[22512]=1;if((L|0)>=1){F=1;while(1){aa=F+ -1|0;h[m+(aa<<3)>>3]=+h[l+(aa<<3)>>3]+ +h[v+(aa<<3)>>3];aa=F+ -1|0;h[d+(aa<<3)>>3]=+h[k+(aa<<3)>>3]+ +h[m+(aa<<3)>>3];if((F|0)<(L|0)){F=F+1|0}else{break}}c[22512]=L+1}F=c[22520]|0;aa=F+1|0;c[22520]=aa;if((F|0)>=(c[22630]|0)){T=aa;U=159;break a}}}do{if((U|0)==159){c[22520]=T+ -1;if((c[g>>2]|0)<=0){break}cN(90544)|0;MM()|0}else if((U|0)==190){if((c[g>>2]|0)<=0){break}cN(90592)|0;MM()|0}}while(0);Nb=+h[11284];if(Nb<=+h[11255]){U=c[a>>2]|0;c[22512]=1;if((U|0)<1){Ob=Nb}else{T=1;while(1){m=T+ -1|0;h[d+(m<<3)>>3]=+h[k+(m<<3)>>3]+ +h[l+(m<<3)>>3];if((T|0)<(U|0)){T=T+1|0}else{break}}c[22512]=U+1;Ob=+h[11284]}h[11255]=Ob}if((c[g>>2]|0)<=0){i=z;return 0}cN(90688)|0;tM(90736,90080,4)|0;MM()|0;cN(90712)|0;tM(90736,90040,8)|0;g=c[a>>2]|0;c[22512]=1;if((g|0)>=1){a=1;do{tM(90736,d+(a+ -1<<3)|0,8)|0;U=c[22512]|0;a=U+1|0;c[22512]=a;}while((U|0)<(g|0))}MM()|0;i=z;return 0}function Dw(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0;s=i;t=c[d>>2]|0;u=~t;h[11362]=.5;h[11380]=6.283185307179586;v=+h[l>>3];h[11375]=v*v;c[22746]=0;l=c[b>>2]|0;c[22764]=l;c[22762]=l;w=c[b>>2]|0;c[22686]=1;if((w|0)<1){x=l;y=0}else{z=1;while(1){A=z+ -1|0;h[n+(A<<3)>>3]=+h[e+(A<<3)>>3];if((z|0)<(w|0)){z=z+1|0}else{break}}c[22686]=w+1;x=l;y=0}a:while(1){w=c[b>>2]|0;c[22686]=1;if((w|0)>=1){z=1;while(1){h[p+(z+ -1<<3)>>3]=0.0;if((z|0)<(w|0)){z=z+1|0}else{break}}c[22686]=w+1}z=c[d>>2]|0;c[22690]=1;if((z|0)>=1){e=1;while(1){h[11366]=0.0;A=c[b>>2]|0;c[22688]=1;if((A|0)<1){B=0.0}else{v=0.0;C=1;while(1){D=+h[f+((fa(C,t)|0)+u+e<<3)>>3];E=v+D*+h[n+(C+ -1<<3)>>3];h[11366]=E;if((C|0)<(A|0)){C=C+1|0;v=E}else{break}}c[22688]=A+1;B=E}v=+h[k+(e+ -1<<3)>>3]*B;h[11366]=v;C=c[b>>2]|0;c[22686]=1;if((C|0)>=1){D=v;F=1;while(1){v=D*+h[f+((fa(F,t)|0)+u+e<<3)>>3];G=p+(F+ -1<<3)|0;h[G>>3]=+h[G>>3]+v;if((F|0)>=(C|0)){break}D=+h[11366];F=F+1|0}c[22686]=C+1}F=e+1|0;c[22690]=F;if((e|0)<(z|0)){e=F}else{break}}}c[22700]=0;e=c[b>>2]|0;c[22688]=1;if((e|0)>=1){z=1;w=0;while(1){if((z|0)<1){H=1;I=w}else{F=z+ -1|0;A=p+(F<<3)|0;G=n+(F<<3)|0;F=z+1|0;J=1;K=w;while(1){L=j+(K<<3)|0;if((J|0)<(z|0)){M=J+ -1|0;h[A>>3]=+h[A>>3]+ +h[L>>3]*+h[n+(M<<3)>>3];N=M}else{N=J+ -1|0}M=p+(N<<3)|0;h[M>>3]=+h[L>>3]*+h[G>>3]+ +h[M>>3];if((J|0)<(z|0)){J=J+1|0;K=K+1|0}else{break}}K=z+w|0;c[22700]=K;H=F;I=K}if((z|0)<(e|0)){z=z+1|0;w=I}else{break}}c[22686]=H;c[22688]=e+1}do{if((y|0)==0){h[11364]=0.0;h[11346]=0.0;w=c[b>>2]|0;c[22686]=1;if((w|0)>=1){z=1;while(1){h[m+(z+ -1<<3)>>3]=0.0;K=z+ -1|0;h[q+(K<<3)>>3]=0.0;D=+h[g+(K<<3)>>3]+ +h[p+(K<<3)>>3];h[o+(K<<3)>>3]=D;h[n+(K<<3)>>3]=-D;h[11346]=+h[11346]+D*D;if((z|0)<(w|0)){z=z+1|0}else{break}}c[22686]=w+1}h[r>>3]=0.0;D=+h[11346];if(D==0.0){O=55;break a}h[11351]=0.0;h[11354]=0.0;h[11349]=D;h[11369]=D;P=D;Q=0.0;R=0.0;S=+h[11375];T=0}else{if((y|0)>(x|0)){h[11348]=0.0;h[11355]=0.0;h[11356]=0.0;z=c[b>>2]|0;c[22686]=1;if((z|0)<1){U=0.0;W=0.0;Z=0.0}else{D=0.0;v=0.0;_=0.0;F=1;while(1){K=F+ -1|0;$=_+ +h[n+(K<<3)>>3]*+h[o+(K<<3)>>3];h[11348]=$;K=F+ -1|0;J=p+(K<<3)|0;aa=v+ +h[J>>3]*+h[n+(K<<3)>>3];h[11355]=aa;ba=D+ +h[J>>3]*+h[m+(K<<3)>>3];h[11356]=ba;if((F|0)<(z|0)){F=F+1|0;_=$;v=aa;D=ba}else{break}}c[22686]=z+1;U=ba;W=$;Z=aa}D=+h[11362];v=D*(+h[11359]-Z);h[11347]=v;_=+h[11352];ca=_+v;h[11363]=ca;h[11367]=ca;h[11365]=ca;c[22756]=0;a[90824]=1;da=+h[11380]/50.0;h[11366]=da;c[22686]=1;F=0;ea=ca;ga=ca;w=1;while(1){ha=+(w|0)*da;ia=+X(+ha);ja=+Y(+ha);ka=ia*(_+ia*v)+ja*(W+ia*U);do{if(ka<ea){h[11365]=ka;c[22756]=w;h[11376]=ga;la=w;ma=ka}else{if((w|0)!=(F+1|0)){la=F;ma=ea;break}h[11377]=ka;la=F;ma=ea}}while(0);K=w+1|0;if((K|0)<50){F=la;ea=ma;w=K;ga=ka}else{break}}h[11371]=ha;h[11357]=ia;h[11360]=ja;h[11368]=ka;c[22686]=50;h[11367]=ka;if((la|0)==0){h[11376]=ka;O=46}else if((la|0)==49){h[11377]=ca;na=ca}else{O=46}if((O|0)==46){O=0;na=+h[11377]}h[11371]=0.0;ga=+h[11376];if(ga!=na){ea=ga-ma;h[11376]=ea;ga=na-ma;h[11377]=ga;oa=D*(ea-ga)/(ea+ga);h[11371]=oa;pa=oa}else{pa=0.0}oa=da*(+(la|0)+pa);h[11371]=oa;ga=+X(+oa);h[11357]=ga;ea=+Y(+oa);h[11360]=ea;oa=ca-ga*(_+ga*v)-ea*(W+ga*U);h[11372]=oa;h[11349]=0.0;w=c[b>>2]|0;c[22686]=1;if((w|0)<1){qa=0.0;ra=oa}else{oa=ea;ea=ga;F=1;z=0;while(1){K=m+(z<<3)|0;h[K>>3]=ea*+h[K>>3]+oa*+h[n+(z<<3)>>3];K=F+ -1|0;J=q+(K<<3)|0;ga=+h[11357]*+h[J>>3]+ +h[11360]*+h[p+(K<<3)>>3];h[J>>3]=ga;sa=+h[o+(K<<3)>>3]+ga;ta=+h[11349]+sa*sa;h[11349]=ta;if((F|0)>=(w|0)){break}K=F;oa=+h[11360];ea=+h[11357];F=F+1|0;z=K}c[22686]=w+1;qa=ta;ra=+h[11372]}ea=ra+ +h[11364];h[11364]=ea;if((y|0)<(l|0)&ra/ea>.01){ua=qa;va=x}else{O=55;break a}}else{h[11355]=0.0;z=c[b>>2]|0;c[22688]=1;do{if((z|0)<1){ea=+h[11379];h[11370]=ea;wa=ea;xa=0.0;O=11}else{ea=0.0;F=1;while(1){K=F+ -1|0;ya=ea+ +h[n+(K<<3)>>3]*+h[p+(K<<3)>>3];h[11355]=ya;if((F|0)<(z|0)){F=F+1|0;ea=ya}else{break}}c[22688]=z+1;ea=+h[11379];h[11370]=ea;if(!(ya>0.0)){wa=ea;xa=ya;O=11;break}ea=ya/+h[11346];h[11366]=ea;if((y|0)==1){h[r>>3]=ea;za=ea;Aa=+h[11366]}else{za=+h[r>>3];Aa=ea}h[r>>3]=!(za<=Aa)?Aa:za;ea=+h[11370];oa=+h[11349];v=+h[11355];_=oa/v;ca=ea<=_?ea:_;h[11370]=ca;Ba=oa;Ca=v;Da=ca}}while(0);if((O|0)==11){O=0;Ba=+h[11349];Ca=xa;Da=wa}ca=Da*(Ba-Da*+h[11362]*Ca);h[11361]=ca;h[11364]=+h[11364]+ca;h[11374]=Ba;h[11349]=0.0;z=c[b>>2]|0;c[22686]=1;if((z|0)<1){Ea=Da;Fa=0.0}else{w=1;ca=Da;while(1){F=w+ -1|0;K=m+(F<<3)|0;h[K>>3]=+h[K>>3]+ca*+h[n+(F<<3)>>3];F=w+ -1|0;K=q+(F<<3)|0;v=+h[K>>3]+ +h[11370]*+h[p+(F<<3)>>3];h[K>>3]=v;oa=+h[o+(F<<3)>>3]+v;Ga=+h[11349]+oa*oa;h[11349]=Ga;Ha=+h[11370];if((w|0)<(z|0)){ca=Ha;w=w+1|0}else{break}}c[22686]=z+1;Ea=Ha;Fa=Ga}if(Ea<+h[11379]){if(+h[11361]<=+h[11364]*.01){O=55;break a}if(Fa<=+h[11369]*1.0e-4|(y|0)==(l|0)){O=55;break a}ca=Fa/+h[11374];h[11366]=ca;h[11346]=0.0;h[11351]=0.0;h[11354]=0.0;w=c[b>>2]|0;c[22686]=1;if((w|0)<1){O=55;break a}else{Ia=ca;Ja=1;Ka=0}while(1){F=n+(Ka<<3)|0;h[F>>3]=Ia*+h[F>>3]- +h[o+(Ka<<3)>>3]- +h[q+(Ka<<3)>>3];F=Ja+ -1|0;K=n+(F<<3)|0;ca=+h[K>>3];La=+h[11346]+ca*ca;h[11346]=La;J=m+(F<<3)|0;Ma=+h[11351]+ +h[K>>3]*+h[J>>3];h[11351]=Ma;ca=+h[J>>3];Na=+h[11354]+ca*ca;h[11354]=Na;if((Ja|0)>=(w|0)){break}J=Ja;Ia=+h[11366];Ja=Ja+1|0;Ka=J}c[22686]=w+1;if(Ma<=0.0){O=55;break a}ca=+h[11375];if(Na<ca){P=La;Q=Ma;R=Na;S=ca;T=y;break}}h[r>>3]=0.0;c[22762]=y;ua=+h[11349];va=y}if(ua<=+h[11369]*1.0e-4){O=55;break a}h[11352]=0.0;h[11359]=0.0;z=c[b>>2]|0;c[22686]=1;if((z|0)<1){Oa=0.0;Pa=0.0}else{ca=0.0;oa=0.0;J=1;while(1){K=J+ -1|0;Qa=oa+ +h[m+(K<<3)>>3]*+h[o+(K<<3)>>3];h[11352]=Qa;K=J+ -1|0;Ra=ca+ +h[m+(K<<3)>>3]*+h[q+(K<<3)>>3];h[11359]=Ra;if((J|0)<(z|0)){J=J+1|0;oa=Qa;ca=Ra}else{break}}c[22686]=z+1;Oa=Ra;Pa=Qa}ca=Pa+Oa;h[11358]=ca;oa=+h[11375];v=ua*oa;if(ca/+V(+v)<=-.99){O=55;break a}J=y+1|0;c[22746]=J;_=+V(+(v-ca*ca));h[11366]=_;v=oa/_;h[11376]=v;oa=ca/_;h[11377]=oa;w=c[b>>2]|0;c[22686]=1;if((w|0)<1){x=va;y=J;continue a}else{Sa=oa;Ta=v;Ua=1;Va=0}while(1){h[n+(Va<<3)>>3]=Ta*(+h[o+(Va<<3)>>3]+ +h[q+(Va<<3)>>3])-Sa*+h[m+(Va<<3)>>3];if((Ua|0)>=(w|0)){break}K=Ua;Sa=+h[11377];Ta=+h[11376];Ua=Ua+1|0;Va=K}c[22686]=w+1;x=va;y=J;continue a}}while(0);e=T+1|0;c[22746]=e;v=S-R;h[11366]=v;h[11379]=v/(Q+ +V(+(Q*Q+v*P)));y=e;x=x}if((O|0)==55){i=s;return 0}return 0}function Ew(b,d,e,f,g,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0,R=0;o=i;p=c[d>>2]|0;q=~p;r=c[j>>2]|0;j=~r;h[11389]=1.0;s=p-(c[b>>2]|0)|0;t=s+ -1|0;c[22784]=t;c[22774]=1;c[22768]=2;if((s|0)<3){u=1}else{s=2;v=1;while(1){do{if((s|0)==(c[g>>2]|0)){c[22774]=s;w=s}else{x=c[m>>2]|0;y=fa(s,p)|0;z=+h[f+(y+q+x<<3)>>3];if(!(z!=0.0)){w=v;break}A=fa(v,p)|0;B=x+q|0;x=f+(B+A<<3)|0;C=+h[x>>3];D=+V(+(z*z+C*C));h[11391]=D;C=+h[x>>3]/D;h[11398]=C;z=+h[f+(B+y<<3)>>3]/D;h[11399]=z;B=c[d>>2]|0;c[22766]=1;if((B|0)>=1){D=z;z=C;x=1;while(1){E=x+q|0;h[11391]=z*+h[f+(E+A<<3)>>3]+D*+h[f+(E+y<<3)>>3];E=x+q|0;F=f+(E+y<<3)|0;G=f+(E+A<<3)|0;h[F>>3]=z*+h[F>>3]-D*+h[G>>3];h[G>>3]=+h[11391];if((x|0)>=(B|0)){break}D=+h[11399];z=+h[11398];x=x+1|0}c[22766]=B+1}h[f+((c[m>>2]|0)+q+y<<3)>>3]=0.0;w=v}}while(0);x=s+1|0;c[22768]=x;if((s|0)<(t|0)){s=x;v=w}else{u=w;break}}}w=c[m>>2]|0;z=+h[f+(w+ -1<<3)>>3];h[11398]=z;if((c[g>>2]|0)>1){D=-z;h[11398]=D;H=D}else{H=z}v=(u|0)>1;if(v){h[11399]=+h[f+((fa(u,p)|0)+q+w<<3)>>3]}w=c[d>>2]|0;c[22766]=1;if((w|0)>=1){s=(fa(u,p)|0)+q|0;z=H;t=1;x=0;while(1){h[n+(x<<3)>>3]=z*+h[f+(x<<3)>>3];if(v){A=n+(t+ -1<<3)|0;h[A>>3]=+h[A>>3]+ +h[11399]*+h[f+(s+t<<3)>>3]}if((t|0)>=(w|0)){break}A=t;z=+h[11398];t=t+1|0;x=A}c[22766]=w+1}w=(c[m>>2]|0)+ -1|0;z=+h[n+(w<<3)>>3];h[11396]=z;x=k+(w<<3)|0;H=+h[x>>3];h[11390]=H;D=H*H;h[11400]=D;h[11397]=D+z*+h[l>>3];h[x>>3]=+h[x>>3]- +h[11389];a[91144]=0;do{if((u|0)==1){z=+h[11397];if(!(z>=0.0)){I=-z}else{I=z}z=+V(+I);h[11391]=z;D=+h[11398]/z;h[11399]=D;H=+h[11390]/z;h[11398]=H;x=c[d>>2]|0;c[22766]=1;if((x|0)<1){J=z}else{z=D;D=H;w=1;t=0;while(1){s=f+(t<<3)|0;h[s>>3]=D*+h[s>>3]-z*+h[k+(t<<3)>>3];if((w|0)>=(x|0)){break}s=w;z=+h[11399];D=+h[11398];w=w+1|0;t=s}c[22766]=x+1;J=+h[11391]}t=c[g>>2]|0;if((t|0)==1&J<0.0){c[g>>2]=2;K=2}else{K=t}if(!((K|0)<2|!(J>=0.0))){L=46}}else{c[22770]=1;if(!(+h[l>>3]>=0.0)){M=1}else{c[22770]=u;M=u}t=u+1-M|0;c[22772]=t;w=fa(t,p)|0;t=(c[m>>2]|0)+q|0;D=+h[11397];z=+h[f+(t+w<<3)>>3]/D;h[11391]=z;h[11398]=z*+h[l>>3];H=+h[11390];h[11399]=z*H;s=fa(M,p)|0;z=+h[f+(t+s<<3)>>3];h[11391]=z;C=+h[l>>3];if(!(C>=0.0)){N=-C}else{N=C}C=+h[11389]/+V(+(+h[11400]+z*N*z));h[11394]=C;if(!(D>=0.0)){O=-D}else{O=D}h[11395]=C*+V(+O);t=c[d>>2]|0;c[22766]=1;if((t|0)<1){P=D}else{D=z;z=H;H=C;v=1;while(1){A=f+(v+q+s<<3)|0;h[A>>3]=H*(z*+h[A>>3]-D*+h[k+(v+ -1<<3)>>3]);A=f+(v+q+w<<3)|0;G=v+ -1|0;h[A>>3]=+h[11395]*(+h[A>>3]- +h[11398]*+h[n+(G<<3)>>3]- +h[11399]*+h[k+(G<<3)>>3]);if((v|0)>=(t|0)){break}D=+h[11391];z=+h[11390];H=+h[11394];v=v+1|0}c[22766]=t+1;P=+h[11397]}if(!(P<=0.0)){break}H=+h[l>>3];if(H<0.0){c[g>>2]=(c[g>>2]|0)+1}if(H>=0.0){L=46}}}while(0);do{if((L|0)==46){a[91144]=1;c[g>>2]=(c[g>>2]|0)+ -1;M=c[d>>2]|0;c[22766]=1;if((M|0)<1){break}else{Q=1}while(1){u=f+(Q+ -1<<3)|0;h[11391]=+h[u>>3];K=f+(Q+q+(fa(c[g>>2]|0,p)|0)<<3)|0;h[u>>3]=+h[K>>3];h[K>>3]=+h[11391];K=Q+1|0;c[22766]=K;if((Q|0)<(M|0)){Q=K}else{break}}}}while(0);Q=c[b>>2]|0;c[22768]=1;if((Q|0)<1){i=o;return 0}else{R=1}while(1){b=(c[d>>2]|0)+R|0;c[22776]=b;p=fa(R,r)|0;P=+h[e+((c[m>>2]|0)+j+p<<3)>>3];g=b+ -1|0;q=n+(g<<3)|0;h[q>>3]=P;f=k+(g<<3)|0;O=+h[11390];N=+h[11397];J=(+h[11396]*+h[f>>3]-O*P)/N;h[11398]=J;P=(-(+h[l>>3]*+h[q>>3])-O*+h[f>>3])/N;h[11399]=P;c[22766]=1;a:do{if((b|0)>=1){N=P;O=J;f=1;while(1){q=e+(f+j+p<<3)|0;g=f+ -1|0;I=+h[q>>3]+O*+h[k+(g<<3)>>3]+N*+h[n+(g<<3)>>3];h[q>>3]=I;q=c[d>>2]|0;if((f|0)>(q|0)){h[e+((fa(f-q|0,r)|0)+j+b<<3)>>3]=I}q=f+1|0;c[22766]=q;if((f|0)>=(b|0)){break a}N=+h[11399];O=+h[11398];f=q}}}while(0);b=R+1|0;c[22768]=b;if((R|0)<(Q|0)){R=b}else{break}}i=o;return 0}function Fw(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0;m=i;if((b|0)<(d|0)){n=(b|0)<(e|0);o=0.0;p=-1;q=-1;r=b;while(1){if(n){s=c[f+(r<<2)>>2]|0;t=b;u=o;v=p;w=q;while(1){x=+U(+(+h[a+((fa(c[g+(t<<2)>>2]|0,d)|0)+s<<3)>>3]));y=x>u;z=y?r:w;A=y?t:v;B=y?x:u;y=t+1|0;if((y|0)<(e|0)){w=z;v=A;u=B;t=y}else{C=B;D=A;E=z;break}}}else{C=o;D=p;E=q}t=r+1|0;if((t|0)<(d|0)){o=C;p=D;q=E;r=t}else{F=C;G=D;H=E;break}}}else{F=0.0;G=-1;H=-1}if((G|H|0)<0){I=-1;i=m;return I|0}c[j>>2]=H;c[k>>2]=G;h[l>>3]=F;I=0;i=m;return I|0}function Gw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;m=(b|0)<=(d|0)?b:d;if((m|0)>0){n=0}else{o=0;i=g;return o|0}while(1){p=e+(n<<2)|0;q=f+(n<<2)|0;r=+h[a+((fa(c[q>>2]|0,b)|0)+(c[p>>2]|0)<<3)>>3];if((Fw(a,n,b,d,e,f,j,k,l)|0)!=0){o=-1;s=14;break}t=+U(+r);if(+h[l>>3]>t*1.125){u=c[p>>2]|0;v=e+(c[j>>2]<<2)|0;c[p>>2]=c[v>>2];c[v>>2]=u;u=c[q>>2]|0;v=f+(c[k>>2]<<2)|0;c[q>>2]=c[v>>2];c[v>>2]=u}u=c[p>>2]|0;p=fa(c[q>>2]|0,b)|0;t=+h[a+(p+u<<3)>>3];if(!(t!=0.0)){s=7;break}q=n+1|0;if((q|0)<(b|0)){v=(q|0)<(d|0);w=q;do{x=c[e+(w<<2)>>2]|0;y=a+(p+x<<3)|0;r=+h[y>>3];do{if(r!=0.0){z=-r/t;h[y>>3]=0.0;if(v){A=q}else{break}do{B=fa(c[f+(A<<2)>>2]|0,b)|0;C=a+(B+x<<3)|0;h[C>>3]=+h[C>>3]+z*+h[a+(u+B<<3)>>3];A=A+1|0;}while((A|0)<(d|0))}}while(0);w=w+1|0;}while((w|0)<(b|0))}if((q|0)<(m|0)){n=q}else{o=0;s=14;break}}if((s|0)==7){$a(91208,91224,116,91248)}else if((s|0)==14){i=g;return o|0}return 0}function Hw(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=e;c[u>>2]=0;v=b+280|0;w=c[v>>2]|0;x=1;while(1){y=x+1|0;if((ZY(w,c[91256+(x<<2)>>2]|0)|0)==0){z=4;break}if((y|0)<8){x=y}else{break}}do{if((z|0)==4){c[u>>2]=x;if((x|0)==0){break}y=c[91360+(x<<2)>>2]|0;c[q>>2]=c[91256+(x<<2)>>2];c[q+4>>2]=y;Lu(23,0,91432,q);y=b+112|0;A=e+28|0;c[A>>2]=(c[y>>2]|0)+20;B=c[y>>2]|0;C=b+160|0;D=((c[C>>2]|0)*3|0)+50+(fa(B+9|0,B)|0)|0;c[e+32>>2]=D;B=BY(D,8)|0;c[e+40>>2]=B;D=b+536|0;Ou(c[D>>2]|0,(B|0)!=0|0,91472,p);B=BY(c[A>>2]|0,4)|0;c[e+36>>2]=B;Ou(c[D>>2]|0,(B|0)!=0|0,91472,o);c[e+56>>2]=c[C>>2];c[e+52>>2]=0;c[e+60>>2]=BY(c[C>>2]|0,4)|0;c[e+24>>2]=zY(8)|0;C=zY(4)|0;c[e+20>>2]=C;c[C>>2]=c[63984>>2];Ou(c[D>>2]|0,(C|0)!=0|0,91472,n);C=c[y>>2]<<3;B=e+48|0;c[B>>2]=zY(C)|0;A=e+44|0;c[A>>2]=zY(C)|0;C=BY(15,4)|0;E=e+12|0;c[E>>2]=C;Ou(c[D>>2]|0,(C|0)!=0|0,91472,m);C=BY(5,4)|0;c[e+4>>2]=C;Ou(c[D>>2]|0,(C|0)!=0|0,91472,l);C=BY(5,4)|0;c[e+8>>2]=C;Ou(c[D>>2]|0,(C|0)!=0|0,91472,k);c[e+16>>2]=0;h[e+64>>3]=1.4901161193847656e-8;C=c[y>>2]<<3;c[e+72>>2]=zY(C)|0;c[e+76>>2]=zY(C)|0;c[e+80>>2]=zY(C)|0;C=c[E>>2]|0;c[C+8>>2]=1;D=c[u>>2]|0;a:do{switch(D|0){case 7:case 1:case 2:case 4:case 5:case 3:{if((Yd[c[(c[b+540>>2]|0)+140>>2]&127](b)|0)==0){F=c[E>>2]|0;c[F+16>>2]=1;G=F;H=c[u>>2]|0;z=17;break a}if((c[y>>2]|0)==1){Lu(23,0,91488,j)}else{Lu(1,0,91560,g)}c[u>>2]=6;z=18;break};default:{G=C;H=D;z=17}}}while(0);if((z|0)==17){if((H|0)==2){I=G}else{z=18}}if((z|0)==18){a[d+28|0]=1;I=c[E>>2]|0}c[I+4>>2]=1;D=c[y>>2]|0;if((D|0)<=0){i=f;return 0}C=b+272|0;F=c[A>>2]|0;J=c[b+8>>2]|0;K=c[B>>2]|0;L=0;do{h[F+(L<<3)>>3]=+h[C>>3];h[K+(L<<3)>>3]=+h[C>>3]*+h[J+(L*112|0)+80>>3];L=L+1|0;}while((L|0)<(D|0));i=f;return 0}}while(0);if((c[64020>>2]|c[15980]|0)==0){M=w;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=4;U=T;V=91392;W=V;Pu(Q,W,r)}c[t>>2]=w;Nu(23,1,91288,t);t=1;do{w=c[91360+(t<<2)>>2]|0;c[s>>2]=c[91256+(t<<2)>>2];c[s+4>>2]=w;Nu(23,0,91344,s);t=t+1|0;}while((t|0)<8);Vd[c[16120]&511](23);M=c[v>>2]|0;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=4;U=T;V=91392;W=V;Pu(Q,W,r);return 0}function Iw(a){a=a|0;var b=0;b=i;AY(c[a+40>>2]|0);AY(c[a+36>>2]|0);AY(c[a+20>>2]|0);AY(c[a+12>>2]|0);AY(c[a+4>>2]|0);AY(c[a+8>>2]|0);AY(a);i=b;return 0}function Jw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;h[D>>3]=0.0;E=a+4|0;F=c[E>>2]|0;G=c[F>>2]|0;H=c[b+48>>2]|0;I=(c[F+4>>2]|0)+8|0;F=c[I>>2]|0;J=a+112|0;K=c[J>>2]|0;L=F+(K<<3)|0;M=H+24|0;c[c[M>>2]>>2]=a;c[(c[M>>2]|0)+4>>2]=H;N=a+536|0;Ou(c[N>>2]|0,(c[M>>2]|0)!=0|0,91656,C);if((c[b+36>>2]|0)!=0){c[c[H+12>>2]>>2]=0;c[H+16>>2]=0}C=b;O=+h[C>>3];P=b+8|0;Q=O+ +h[P>>3];h[D>>3]=Q;if(O-Q>=-1.0e-13){Lu(3,0,91688,B);Lu(3,0,91728,A);A=c[J>>2]|0;if((A|0)>0){B=c[I>>2]|0;I=c[G+8>>2]|0;R=0;do{h[I+(R<<3)>>3]=+h[B+(R<<3)>>3]+ +h[F+(R+K<<3)>>3]*+h[P>>3];R=R+1|0;}while((R|0)<(A|0))}h[G>>3]=+h[D>>3];Yd[c[(c[a+540>>2]|0)+28>>2]&127](a)|0;h[C>>3]=+h[D>>3];S=0;i=d;return S|0}A=z;h[k>>3]=O;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Lu(3,0,91752,z);z=H+16|0;A=z;R=a;P=b+24|0;b=H+12|0;K=H+44|0;F=H+48|0;B=H+40|0;I=H+32|0;T=H+36|0;U=H+28|0;V=U;W=H+20|0;X=H+52|0;Y=H+56|0;Z=H+60|0;_=c[r>>2]|0;$=c[t>>2]|0;aa=a+248|0;ba=a+540|0;ca=G;G=L;a:while(1){Q=+h[D>>3];L=y;h[k>>3]=+h[C>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=y+8|0;h[k>>3]=Q;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];Lu(23,0,91792,y);if((c[z>>2]|0)==1){Fv(c[R>>2]|0,1,c[E>>2]|0);L=c[E>>2]|0;da=c[L>>2]|0;ea=(c[(c[L+4>>2]|0)+8>>2]|0)+(c[J>>2]<<3)|0;h[da>>3]=+h[C>>3];fa=da;ga=ea}else{fa=ca;ga=G}if((c[P>>2]|0)!=5){ty(a)|0;Yd[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ea=c[H>>2]|0;b:do{switch(ea|0){case 5:{_v(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,5,2,Y,c[Z>>2]|0)|0;break};case 4:{_v(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,4,2,Y,c[Z>>2]|0)|0;break};case 6:{_v(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,6,2,Y,c[Z>>2]|0)|0;break};case 7:{_v(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,7,3,X,0)|0;break};case 3:{_v(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,3,2,Y,c[Z>>2]|0)|0;break};default:{da=c[fa+8>>2]|0;L=c[b>>2]|0;ha=c[K>>2]|0;ia=c[F>>2]|0;ja=c[B>>2]|0;ka=c[T>>2]|0;la=c[M>>2]|0;ma=c[W>>2]|0;if((ea|0)==2){_v(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,3,X,0)|0;break b}else{_v(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,2,Y,c[Z>>2]|0)|0;break b}}}}while(0);ea=c[z>>2]|0;do{if((ea|0)==-1){jd(_|0)|0;jd($|0)|0;Nu(3,0,91824,x);Lu(3,0,91912,w);c[c[b>>2]>>2]=1}else{if((ea|0)<0){na=25;break a}if((ea|0)!=4){break}c[(c[N>>2]|0)+84>>2]=4}}while(0);ea=c[z>>2]|0;if((ea|0)==1){ca=fa;G=ga;continue}else if(!((ea|0)==-1)){na=31;break}Q=+h[C>>3];if(!(Q<=+h[aa>>3])){oa=Q;break}else{ca=fa;G=ga}}if((na|0)==25){jd(_|0)|0;jd($|0)|0;$=Sw(c[z>>2]|0)|0;if((c[P>>2]|0)!=5){ty(a)|0;Yd[c[(c[ba>>2]|0)+40>>2]&127](a)|0}Yd[c[(c[ba>>2]|0)+28>>2]&127](a)|0;a=v;h[k>>3]=+h[fa>>3];c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];Nu(1,0,91936,v);S=$;i=d;return S|0}else if((na|0)==31){oa=+h[C>>3]}h[fa>>3]=oa;if((c[63940>>2]|0)!=0){Lu(3,1,91968,u);c[s>>2]=c[z>>2];Lu(3,0,91992,s);s=q;h[k>>3]=+h[C>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];Lu(3,0,92016,q);q=p;h[k>>3]=+h[(c[B>>2]|0)+24>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];Lu(3,0,92048,p);p=o;h[k>>3]=+h[(c[B>>2]|0)+16>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Lu(3,0,92088,o);o=n;h[k>>3]=+h[(c[B>>2]|0)+48>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Lu(3,0,92136,n);c[m>>2]=c[(c[T>>2]|0)+40>>2];Lu(3,0,92184,m);c[l>>2]=c[(c[T>>2]|0)+44>>2];Lu(3,0,92224,l);c[j>>2]=c[(c[T>>2]|0)+48>>2];Lu(3,0,92264,j);c[g>>2]=c[(c[T>>2]|0)+52>>2];Lu(3,0,92304,g);c[f>>2]=c[(c[T>>2]|0)+56>>2];Lu(3,0,92352,f);Vd[c[16120]&511](3)}f=c[U>>2]|0;U=H+8|0;H=0;do{g=H+10|0;if(!(g>>>0<f>>>0)){na=37;break}c[(c[U>>2]|0)+(H<<2)>>2]=c[(c[T>>2]|0)+(g<<2)>>2];H=H+1|0;}while(H>>>0<5);if((na|0)==37){$a(92392,92424,410,92456)}Lu(3,0,92472,e);S=0;i=d;return S|0}function Kw(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;f=c[g>>2]|0;g=f;b=f+536|0;k=f+4|0;l=c[c[k>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[a>>3];a=(c[b>>2]|0)+84|0;l=c[a>>2]|0;c[a>>2]=2;ty(g)|0;a=f+540|0;Yd[c[(c[a>>2]|0)+40>>2]&127](g)|0;Yd[c[(c[a>>2]|0)+28>>2]&127](g)|0;g=c[f+112>>2]|0;if((g|0)<=0){n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;a=0;do{h[e+(a<<3)>>3]=+h[f+(g+a<<3)>>3]- +h[d+(a<<3)>>3];a=a+1|0;}while((a|0)<(g|0));n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}function Lw(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;ty(l)|0;b=k+540|0;Yd[c[(c[b>>2]|0)+40>>2]&127](l)|0;Yd[c[(c[b>>2]|0)+28>>2]&127](l)|0;Uw(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function Mw(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0;j=i;e=c[g>>2]|0;g=e;d=e+536|0;a=(c[d>>2]|0)+84|0;k=c[a>>2]|0;c[a>>2]=4;a=e+4|0;l=c[c[a>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[b>>3];ty(g)|0;l=e+540|0;Yd[c[(c[l>>2]|0)+40>>2]&127](g)|0;Yd[c[(c[l>>2]|0)+28>>2]&127](g)|0;Yd[c[(c[l>>2]|0)+32>>2]&127](g)|0;$d[c[(c[l>>2]|0)+92>>2]&63](g,f,b)|0;c[(c[d>>2]|0)+84>>2]=k;h[c[c[a>>2]>>2]>>3]=m;i=j;return 0}function Nw(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;Vw(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function Ow(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;ty(l)|0;b=k+540|0;Yd[c[(c[b>>2]|0)+40>>2]&127](l)|0;Yd[c[(c[b>>2]|0)+28>>2]&127](l)|0;Tw(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function Pw(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;i=i;return 0}function Qw(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;Ww(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function Rw(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i;return 0}function Sw(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;c=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;switch(a|0){case-7:{Nu(1,0,92608,h);m=-7;i=b;return m|0};case-9:{Nu(1,0,92696,f);m=-9;i=b;return m|0};case-8:{Nu(1,0,92648,g);m=-8;i=b;return m|0};case-1:{Nu(3,0,91824,l);m=1;i=b;return m|0};case-3:{m=-3;i=b;return m|0};case-6:{Nu(1,0,92536,j);m=-6;i=b;return m|0};case-33:{Nu(1,0,93016,b);m=-33;i=b;return m|0};case-2:{Nu(1,0,92496,k);m=-2;i=b;return m|0};case-10:{Nu(1,0,92784,e);m=-10;i=b;return m|0};case-11:{Nu(1,0,92880,d);m=-11;i=b;return m|0};case-12:{Nu(1,0,92968,c);m=-12;i=b;return m|0};default:{m=-1;i=b;return m|0}}return 0}function Tw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+540|0;f=c[(c[e>>2]|0)+120>>2]|0;g=a+464|0;j=c[g>>2]|0;if((c[j+(f*44|0)+24>>2]|0)==0){i=d;return 0}k=a;a=c[j+(f*44|0)>>2]|0;l=j;j=0;do{if((a|0)!=0){m=0;do{if(((c[(c[l+(f*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}Yd[c[(c[e>>2]|0)+160>>2]&127](k)|0;l=c[g>>2]|0;a=c[l+(f*44|0)>>2]|0;do{if((a|0)!=0){m=c[l+(f*44|0)+28>>2]|0;n=0;do{do{if(+h[m+(n<<3)>>3]==1.0){if((n|0)==0){o=l+(f*44|0)+8|0;p=0}else{q=l+(f*44|0)+8|0;o=q;p=c[(c[q>>2]|0)+(n+ -1<<2)>>2]|0}q=c[(c[o>>2]|0)+(n<<2)>>2]|0;if(!(p>>>0<q>>>0)){break}r=c[l+(f*44|0)+12>>2]|0;s=c[l+(f*44|0)+4>>2]|0;t=c[l+(f*44|0)+36>>2]|0;u=p;do{v=c[r+(u<<2)>>2]|0;w=(fa(s,n)|0)+v|0;h[b+(w<<3)>>3]=+h[t+(v<<3)>>3];u=u+1|0;}while(u>>>0<q>>>0)}}while(0);n=n+1|0;}while(n>>>0<a>>>0);if((a|0)==0){break}n=c[l+(f*44|0)+20>>2]|0;m=0;do{if(((c[n+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=0.0}m=m+1|0;}while(m>>>0<a>>>0)}}while(0);j=j+1|0;}while(j>>>0<(c[l+(f*44|0)+24>>2]|0)>>>0);i=d;return 0}function Uw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+540|0;f=c[e>>2]|0;g=c[f+120>>2]|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)>>2]|0)==0){i=d;return 0}l=a;a=f;f=c[k+(g*44|0)+28>>2]|0;k=0;m=0;while(1){h[f+(k<<3)>>3]=1.0;Yd[c[a+160>>2]&127](l)|0;n=c[j>>2]|0;o=c[n+(g*44|0)+4>>2]|0;if((o|0)==0){p=m}else{q=o>>>0>1?o:1;r=c[n+(g*44|0)+36>>2]|0;s=0;t=m;while(1){h[b+(t<<3)>>3]=+h[r+(s<<3)>>3];u=s+1|0;if(u>>>0<o>>>0){t=t+1|0;s=u}else{break}}p=m+q|0}s=c[n+(g*44|0)+28>>2]|0;h[s+(k<<3)>>3]=0.0;t=k+1|0;if(!(t>>>0<(c[n+(g*44|0)>>2]|0)>>>0)){break}a=c[e>>2]|0;f=s;k=t;m=p}i=d;return 0}function Vw(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;n=i;j=c[m+4>>2]|0;o=+h[j+64>>3];p=a+112|0;a=c[p>>2]|0;if((a|0)<=0){i=n;return 0}q=j+80|0;j=a;do{j=j+ -1|0;r=+h[k>>3]*+h[e+(j<<3)>>3];a=d+(j<<3)|0;s=+h[a>>3];if(!(s>=0.0)){t=-s}else{t=s}u=r>=0.0;if(u){v=r}else{v=-r}r=+id(+t,+v);w=+h[l+(j<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}w=o*+id(+r,+x);if(u){y=w}else{y=-w}w=y+s-s;r=1.0/w;h[a>>3]=s+w;Kw(b,0,e,c[q>>2]|0,0,m,0)|0;u=c[p>>2]|0;if((u|0)>0){z=c[q>>2]|0;A=fa(u,j)|0;B=u;do{B=B+ -1|0;h[g+(A+B<<3)>>3]=r*(+h[z+(B<<3)>>3]- +h[f+(B<<3)>>3]);}while((B|0)>0)}h[a>>3]=s;}while((j|0)>0);i=n;return 0}function Ww(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;n=i;j=c[(c[a+540>>2]|0)+120>>2]|0;o=c[m+4>>2]|0;p=+h[o+64>>3];q=c[o+76>>2]|0;r=c[o+72>>2]|0;s=a+464|0;a=c[s>>2]|0;if((c[a+(j*44|0)+24>>2]|0)==0){i=n;return 0}t=o+80|0;o=c[a+(j*44|0)>>2]|0;u=a;a=0;do{if((o|0)!=0){v=0;do{if(((c[(c[u+(j*44|0)+20>>2]|0)+(v<<2)>>2]|0)+ -1|0)==(a|0)){w=+h[k>>3]*+h[e+(v<<3)>>3];x=d+(v<<3)|0;y=+h[x>>3];if(!(y>=0.0)){z=-y}else{z=y}A=w>=0.0;if(A){B=w}else{B=-w}w=+id(+z,+B);y=+h[l+(v<<3)>>3];if(!(y>=0.0)){C=-y}else{C=y}y=p*+id(+w,+C);D=q+(v<<3)|0;h[D>>3]=y;if(A){E=y}else{E=-y}h[D>>3]=E;y=+h[x>>3];h[D>>3]=E+y-y;h[r+(v<<3)>>3]=+h[x>>3];h[x>>3]=+h[D>>3]+ +h[x>>3];h[D>>3]=1.0/+h[D>>3]}v=v+1|0;}while(v>>>0<o>>>0)}Kw(b,0,e,c[t>>2]|0,0,m,0)|0;u=c[s>>2]|0;o=c[u+(j*44|0)>>2]|0;if((o|0)!=0){v=c[u+(j*44|0)+20>>2]|0;D=0;do{if(((c[v+(D<<2)>>2]|0)+ -1|0)==(a|0)){if((D|0)==0){F=u+(j*44|0)+8|0;G=0}else{x=u+(j*44|0)+8|0;F=x;G=c[(c[x>>2]|0)+(D+ -1<<2)>>2]|0}x=c[(c[F>>2]|0)+(D<<2)>>2]|0;if(G>>>0<x>>>0){A=c[t>>2]|0;H=q+(D<<3)|0;I=c[u+(j*44|0)+12>>2]|0;J=c[u+(j*44|0)+4>>2]|0;K=G;do{L=c[I+(K<<2)>>2]|0;M=(fa(J,D)|0)+L|0;h[g+(M<<3)>>3]=(+h[A+(L<<3)>>3]- +h[f+(L<<3)>>3])*+h[H>>3];K=K+1|0;}while(K>>>0<x>>>0)}h[d+(D<<3)>>3]=+h[r+(D<<3)>>3]}D=D+1|0;}while(D>>>0<o>>>0)}a=a+1|0;}while(a>>>0<(c[u+(j*44|0)+24>>2]|0)>>>0);i=n;return 0}function Xw(a,b){a=a|0;b=+b;h[a+496>>3]=b;i=i;return}function Yw(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=i;i=i+24|0;l=j;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;r=a+536|0;s=c[r>>2]|0;t=(c[a+172>>2]|0)>(b|0)|0;c[p>>2]=b;Ou(s,t,93488,p);p=c[r>>2]|0;c[o>>2]=b;Ou(p,b>>>31^1,93488,o);Ou(c[r>>2]|0,+h[a+496>>3]<=e|0,93544,n);h[q>>3]=e;h[q+8>>3]=d;n=a+504|0;Cv(c[(c[n>>2]|0)+(b<<2)>>2]|0,q);q=Ev(c[(c[n>>2]|0)+(b<<2)>>2]|0)|0;c[m>>2]=b;a=m+4|0;h[k>>3]=e;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=m+12|0;h[k>>3]=d;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];c[m+20>>2]=q;Lu(7,0,93624,m);d=e-g+2.220446049250313e-16;m=Zw(d,c[(c[n>>2]|0)+(b<<2)>>2]|0)|0;if((m|0)<=0){i=j;return}Dv(c[(c[n>>2]|0)+(b<<2)>>2]|0,m+ -1|0);c[l>>2]=m;m=l+4|0;h[k>>3]=d;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=l+12|0;h[k>>3]=f;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];Lu(7,0,93664,l);i=j;return}function Zw(a,b){a=+a;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0.0;d=i;i=i+16|0;e=d;f=i;i=i+24|0;g=i;i=i+8|0;j=Ev(b)|0;l=g;h[k>>3]=a;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];Lu(7,0,94344,g);g=j;j=0;do{l=(j+g|0)/2|0;m=Av(b,l)|0;n=+h[m>>3];c[f>>2]=j;c[f+4>>2]=g;c[f+8>>2]=l;m=f+12|0;h[k>>3]=n;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];Lu(7,0,94360,f);m=n>a;g=m?l:g;j=m?j:l;if(!(n!=a)){break}}while((g|0)>(j+1|0));c[e>>2]=j;c[e+4>>2]=g;g=e+8|0;h[k>>3]=n;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];Lu(7,0,94384,e);i=d;return j|0}function _w(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;j=i;i=i+32|0;l=j;m=i;i=i+24|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+32|0;B=c[(c[a+504>>2]|0)+(b<<2)>>2]|0;C=Ev(B)|0;c[A>>2]=b;D=A+4|0;h[k>>3]=d;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=A+12|0;h[k>>3]=e;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=A+20|0;h[k>>3]=f;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];Lu(7,0,93712,A);A=a+536|0;D=c[A>>2]|0;c[z>>2]=b;Ou(D,b>>>31^1,93784,z);z=c[A>>2]|0;D=(c[a+172>>2]|0)>(b|0)|0;c[y>>2]=b;Ou(z,D,93784,y);g=+h[a+496>>3];if(g>=e){a=x;h[k>>3]=d;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];Lu(7,0,93808,x);E=d;i=j;return+E}if(f<0.0){x=c[A>>2]|0;a=w;h[k>>3]=f;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];Pu(x,93856,w)}if((C|0)==0){w=v;h[k>>3]=d;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Lu(7,0,93888,v);E=d;i=j;return+E}if(g+f>=e){v=(Av(B,0)|0)+8|0;g=+h[v>>3];c[u>>2]=b;b=u+4|0;h[k>>3]=g;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];Lu(7,0,93960,u);E=g;i=j;return+E}g=e-f;u=c[A>>2]|0;b=t;h[k>>3]=f;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];Ou(u,f>=0.0|0,94008,t);t=C+ -1|0;u=Av(B,t)|0;do{if(g>+h[u>>3]){b=Av(B,t)|0;f=+h[b>>3];b=s;h[k>>3]=g;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=s+8|0;h[k>>3]=f;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];Lu(7,0,94056,s);b=Av(B,t)|0;f=+h[b>>3];b=(Av(B,t)|0)+8|0;F=+h[b>>3];b=r;h[k>>3]=f;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=r+8|0;h[k>>3]=e;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];Lu(7,0,94096,r);b=q;h[k>>3]=F;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=q+8|0;h[k>>3]=d;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];Lu(7,0,94128,q);G=f;H=e;I=F;J=d}else{b=Zw(g,B)|0;v=c[A>>2]|0;c[p>>2]=b;c[p+4>>2]=C;Ou(v,(b|0)<(C|0)|0,94160,p);v=Av(B,b)|0;F=+h[v>>3];v=(Av(B,b)|0)+8|0;f=+h[v>>3];v=b+1|0;if((v|0)==(C|0)){E=f;i=j;return+E}else{b=Av(B,v)|0;K=+h[b>>3];b=(Av(B,v)|0)+8|0;G=F;H=K;I=f;J=+h[b>>3];break}}}while(0);if(G==g){B=o;h[k>>3]=g;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=o+8|0;h[k>>3]=I;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];Lu(7,0,94184,o);E=I;i=j;return+E}if(H==g){o=n;h[k>>3]=g;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=J;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Lu(7,0,94184,n);E=J;i=j;return+E}else{d=(I*(H-g)+J*(g-G))/(H-G);n=m;h[k>>3]=g;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+8|0;h[k>>3]=G;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+16|0;h[k>>3]=H;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Lu(7,0,94224,m);m=l;h[k>>3]=g;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=l+8|0;h[k>>3]=I;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=l+16|0;h[k>>3]=J;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=l+24|0;h[k>>3]=d;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];Lu(7,0,94280,l);E=d;i=j;return+E}return 0.0}function $w(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0;e=i;Vd[c[(c[a+540>>2]|0)+112>>2]&511](a);f=a+328|0;h[f>>3]=d+1.0;g=c[a+104>>2]|0;if((g|0)<=0){i=e;return}j=c[a+108>>2]|0;k=a+336|0;a=0;do{d=+h[j+(a*24|0)+8>>3];if(d>b){h[(c[k>>2]|0)+(a<<3)>>3]=d;l=d}else{m=+h[j+(a*24|0)+16>>3];n=d+m*+ea(+((b-d)/m));h[(c[k>>2]|0)+(a<<3)>>3]=n;l=n}if((a|0)==0){o=8}else{if(l<+h[f>>3]){o=8}}if((o|0)==8){o=0;h[f>>3]=l}a=a+1|0;}while((a|0)<(g|0));i=e;return}function ax(b,c){b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0;d=i;e=+h[c>>3];f=c+8|0;g=+h[b+328>>3];if(!(g<=e+ +h[f>>3]+1.0e-14)){i=d;return}h[f>>3]=g-e;a[b+317|0]=1;i=d;return}function bx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;d=i;i=i+8|0;e=d;f=a+160|0;if((c[f>>2]|0)<=0){g=Wu(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}l=a+540|0;m=a+344|0;n=a+348|0;o=a+368|0;a=0;do{le[c[(c[l>>2]|0)+104>>2]&63](a,e)|0;p=+h[(c[m>>2]|0)+(a<<3)>>3];if(p==1.0){if(+h[(c[n>>2]|0)+(a<<3)>>3]==-1.0){q=7}else{q=5}}else{q=5}do{if((q|0)==5){q=0;if(!(p==-1.0)){break}if(+h[(c[n>>2]|0)+(a<<3)>>3]==1.0){q=7}}}while(0);if((q|0)==7){q=0;Uu(b,(c[o>>2]|0)+(a<<2)|0)}a=a+1|0;}while((a|0)<(c[f>>2]|0));g=Wu(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}function cx(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;e=i;g=f+32|0;do{if((bx(b,c[g>>2]|0)|0)!=0){if((a[f+28|0]|0)!=0){break}dx(b,c[g>>2]|0,f)}}while(0);if((a[b+317|0]|0)==1){h=1;i=e;return h|0}b=(Wu(d)|0)>0;h=b?2:0;i=e;return h|0}function dx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=a+112|0;q=c[p>>2]<<3;r=zY(q)|0;s=r;t=zY(q)|0;q=t;h[n>>3]=+h[a+376>>3];u=a+4|0;h[o>>3]=+h[c[c[u>>2]>>2]>>3];c[23676]=Su(4)|0;if((r|0)==0){$a(94712,94728,308,94760)}if((t|0)==0){$a(94776,94728,309,94760)}v=Zu(b)|0;if((v|0)!=0){w=v;do{v=$u(w)|0;c[l>>2]=c[v>>2];Lu(27,0,94792,l);w=_u(w)|0;}while((w|0)!=0)}w=c[p>>2]|0;if((w|0)>0){l=c[(c[c[u>>2]>>2]|0)+8>>2]|0;v=(w|0)>1?w<<3:8;dZ(t|0,c[a+384>>2]|0,v|0)|0;dZ(r|0,l|0,v|0)|0}h[d>>3]=+gx(a,n,o,q,s,c[23676]|0,b);do{if((Wu(c[23676]|0)|0)==0){s=Xu(b)|0;q=a+344|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));s=Zu(b)|0;if((s|0)==0){y=x}else{v=s;z=x;while(1){s=$u(v)|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));A=z>x?x:z;s=_u(v)|0;if((s|0)==0){y=A;break}else{z=A;v=s}}}v=j;h[k>>3]=y;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];Lu(27,0,94840,j);v=Zu(b)|0;if((v|0)==0){break}else{B=v}do{v=$u(B)|0;if(y==+U(+(+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]))){v=c[23676]|0;Vu(v,$u(B)|0);v=$u(B)|0;c[g>>2]=c[v>>2];Lu(27,0,94864,g)}B=_u(B)|0;}while((B|0)!=0)}}while(0);Tu(b);if((c[63956>>2]|0)!=0){Wu(c[23676]|0)|0}if((Wu(c[23676]|0)|0)>0){B=m;do{g=Xu(c[23676]|0)|0;c[m>>2]=c[g>>2];Yu(c[23676]|0);c[f>>2]=c[m>>2];Lu(7,0,94888,f);Uu(b,B);}while((Wu(c[23676]|0)|0)>0)}h[d>>3]=+h[o>>3];o=c[c[u>>2]>>2]|0;h[o>>3]=+h[n>>3];n=c[p>>2]|0;if((n|0)>0){dZ(c[o+8>>2]|0,t|0,((n|0)>1?n<<3:8)|0)|0}Me(a);jx(a);a=c[c[u>>2]>>2]|0;h[a>>3]=+h[d>>3];d=c[p>>2]|0;if((d|0)<=0){AY(t);AY(r);i=e;return}dZ(c[a+8>>2]|0,r|0,((d|0)>1?d<<3:8)|0)|0;AY(t);AY(r);i=e;return}function ex(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0;g=i;i=i+32|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+8|0;p=b+4|0;q=+h[c[c[p>>2]>>2]>>3];r=b+317|0;do{if((a[r]|0)!=0){nx(b);s=b+104|0;t=c[s>>2]|0;if((t|0)<=0){break}u=b+336|0;v=q+1.0e-14;w=b+340|0;x=b+108|0;y=t;t=0;while(1){if(!(+h[(c[u>>2]|0)+(t<<3)>>3]<=v)){z=y}else{a[(c[w>>2]|0)+t|0]=1;A=c[x>>2]|0;B=+h[A+(t*24|0)+8>>3];C=+h[A+(t*24|0)+16>>3];c[m>>2]=c[A+(t*24|0)>>2];A=m+4|0;h[k>>3]=B;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=m+12|0;h[k>>3]=C;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Lu(7,0,94432,m);z=c[s>>2]|0}A=t+1|0;if((A|0)<(z|0)){y=z;t=A}else{break}}}}while(0);z=b+512|0;m=b+524|0;t=b+516|0;y=b+528|0;c[y>>2]=(c[y>>2]|0)-(c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]|0);if((Wu(d)|0)>0){h[c[c[p>>2]>>2]>>3]=+h[e>>3];do{if((c[63956>>2]|0)!=0){e=Zu(d)|0;if((e|0)==0){break}p=b+540|0;s=e;do{e=$u(s)|0;x=c[e>>2]|0;e=le[c[(c[p>>2]|0)+104>>2]&63](x,n)|0;w=c[n>>2]|0;c[l>>2]=x;c[l+4>>2]=e;Ku(7,0,w,94456,l);s=_u(s)|0;}while((s|0)!=0)}}while(0);l=f+40|0;c[l>>2]=(c[l>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+1;c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=1;l=c[m>>2]|0;n=c[b+520>>2]|0;h[n+(l<<3)>>3]=q;s=b+532|0;do{if((c[s>>2]|0)==0){p=c[y>>2]|0;if((p|0)!=(c[z>>2]|0)){break}v=+h[n+(((l+1|0)%(p|0)|0)<<3)>>3];w=b+264|0;if(!(q-v<+h[w>>3])){break}e=$u(Zu(d)|0)|0;x=le[c[(c[b+540>>2]|0)+104>>2]&63](c[e>>2]|0,o)|0;e=c[o>>2]|0;C=+h[w>>3];w=j;h[k>>3]=v;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=j+8|0;h[k>>3]=q;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[j+16>>2]=p;p=j+20|0;h[k>>3]=C;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[j+28>>2]=x;Ku(1,0,e,94472,j);c[s>>2]=1}}while(0);Tu(d)}else{c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=0}c[m>>2]=((c[m>>2]|0)+1|0)%(c[z>>2]|0)|0;ix(b);fx(b);if((a[r]|0)==0){i=g;return}z=b+104|0;m=c[z>>2]|0;do{if((m|0)>0){t=b+340|0;d=b+108|0;s=b+336|0;j=m;o=0;while(1){l=(c[t>>2]|0)+o|0;if((a[l]|0)==0){D=j}else{a[l]=0;l=(c[s>>2]|0)+(o<<3)|0;h[l>>3]=+h[(c[d>>2]|0)+(o*24|0)+16>>3]+ +h[l>>3];D=c[z>>2]|0}l=o+1|0;if((l|0)<(D|0)){j=D;o=l}else{break}}if((D|0)<=0){break}o=b+336|0;j=b+328|0;d=0;do{s=c[o>>2]|0;if((d|0)==0){E=+h[s>>3];F=29}else{q=+h[s+(d<<3)>>3];if(q<+h[j>>3]){E=q;F=29}}if((F|0)==29){F=0;h[j>>3]=E}d=d+1|0;}while((d|0)<(D|0))}}while(0);a[r]=0;r=f+44|0;c[r>>2]=(c[r>>2]|0)+1;i=g;return}function fx(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;Lu(27,0,95080,b);d=a+344|0;$d[c[(c[a+540>>2]|0)+92>>2]&63](a,c[d>>2]|0,c[c[a+4>>2]>>2]|0)|0;e=c[a+160>>2]|0;if((e|0)<=0){i=b;return}f=c[d>>2]|0;d=c[a+348>>2]|0;a=0;do{h[d+(a<<3)>>3]=+h[f+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=b;return}function gx(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=a+160|0;p=c[o>>2]|0;q=zY(p<<3)|0;if((q|0)==0){$a(94896,94728,409,94912)}if((p|0)>0){dZ(q|0,c[a+344>>2]|0,((p|0)>1?p<<3:8)|0)|0}r=+h[d>>3];p=n;h[k>>3]=+h[b>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=r;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Lu(27,0,94928,n);n=m;h[k>>3]=1.0e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Lu(27,0,94976,m);r=+h[d>>3];s=+h[b>>3];if(!(+U(+(r-s))>1.0e-9)){AY(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}m=a+4|0;n=a+112|0;p=a+540|0;x=a+344|0;y=a+348|0;z=c[n>>2]|0;A=s;s=r;while(1){r=(s+A)*.5;B=c[c[m>>2]>>2]|0;h[B>>3]=r;if((z|0)>0){C=c[B+8>>2]|0;B=0;do{h[C+(B<<3)>>3]=(+h[e+(B<<3)>>3]+ +h[f+(B<<3)>>3])*.5;B=B+1|0;}while((B|0)<(z|0))}ty(a)|0;Yd[c[(c[p>>2]|0)+40>>2]&127](a)|0;Yd[c[(c[p>>2]|0)+28>>2]&127](a)|0;Yd[c[(c[p>>2]|0)+32>>2]&127](a)|0;$d[c[(c[p>>2]|0)+92>>2]&63](a,c[x>>2]|0,c[c[m>>2]>>2]|0)|0;B=(hx(a,g,j)|0)==0;C=c[n>>2]|0;D=(C|0)>0;do{if(B){if(D){E=c[(c[c[m>>2]>>2]|0)+8>>2]|0;F=0;do{h[e+(F<<3)>>3]=+h[E+(F<<3)>>3];F=F+1|0;}while((F|0)<(C|0))}h[b>>3]=r;F=c[o>>2]|0;if((F|0)>0){E=c[x>>2]|0;G=c[y>>2]|0;H=0;do{I=E+(H<<3)|0;h[G+(H<<3)>>3]=+h[I>>3];h[I>>3]=+h[q+(H<<3)>>3];H=H+1|0;}while((H|0)<(F|0))}J=+h[d>>3]}else{if(D){F=c[(c[c[m>>2]>>2]|0)+8>>2]|0;H=0;do{h[f+(H<<3)>>3]=+h[F+(H<<3)>>3];H=H+1|0;}while((H|0)<(C|0))}h[d>>3]=r;H=c[o>>2]|0;if((H|0)<=0){J=r;break}dZ(q|0,c[x>>2]|0,((H|0)>1?H<<3:8)|0)|0;J=r}}while(0);r=+h[b>>3];if(+U(+(J-r))>1.0e-9){z=C;A=r;s=J}else{break}}AY(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}function hx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;Tu(b);Lu(27,0,95e3,g);g=Zu(d)|0;if((g|0)==0){j=Wu(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}d=a+344|0;m=a+348|0;a=g;do{g=$u(a)|0;if(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){g=$u(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==1.0){n=7}else{n=5}}else{n=5}do{if((n|0)==5){n=0;g=$u(a)|0;if(!(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==1.0)){break}g=$u(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){n=7}}}while(0);if((n|0)==7){n=0;g=$u(a)|0;o=c[g>>2]|0;g=$u(a)|0;p=+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]>0.0?94416:94424;g=$u(a)|0;q=+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]>0.0?94416:94424;c[f>>2]=o;c[f+4>>2]=p;c[f+8>>2]=q;Lu(27,0,95040,f);Uu(b,$u(a)|0)}a=_u(a)|0;}while((a|0)!=0);j=Wu(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}function ix(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+8|0;e=d;f=b+315|0;a[f]=0;g=b+540|0;le[c[(c[g>>2]|0)+96>>2]&63](b,1)|0;jx(b);kx(b);Yd[c[(c[g>>2]|0)+36>>2]&127](b)|0;lx(b,8);h=mx(b)|0;j=Yd[c[(c[g>>2]|0)+100>>2]&127](b)|0;k=b+312|0;if((a[k]|0)==0){l=1;m=j;n=h}else{kx(b);i=d;return}while(1){if((m|0)==0){if((a[f]|n)<<24>>24==0){o=7;break}}nx(b);jx(b);lx(b,8);Yd[c[(c[g>>2]|0)+36>>2]&127](b)|0;if((l|0)>200){o=5;break}h=mx(b)|0;j=Yd[c[(c[g>>2]|0)+100>>2]&127](b)|0;if((a[k]|0)==0){l=l+1|0;m=j;n=h}else{o=7;break}}if((o|0)==5){Pu(c[b+536>>2]|0,95120,e)}else if((o|0)==7){kx(b);i=d;return}}function jx(a){a=a|0;var b=0;b=i;dZ(c[a+356>>2]|0,c[a+352>>2]|0,c[a+164>>2]|0)|0;i=b;return}function kx(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+164|0;if((c[e>>2]|0)<=0){i=d;return}f=b+352|0;g=b+360|0;b=0;do{a[(c[g>>2]|0)+b|0]=(a[(c[f>>2]|0)+b|0]|0)!=0|0;b=b+1|0;}while((b|0)<(c[e>>2]|0));i=d;return}function lx(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+8|0;if((c[63928+(d<<2)>>2]|0)==0){i=e;return}Lu(d,1,95544,g);g=b+164|0;if((c[g>>2]|0)>0){h=b+540|0;j=b+352|0;k=b+356|0;b=0;do{l=Yd[c[(c[h>>2]|0)+108>>2]&127](b)|0;m=(a[(c[j>>2]|0)+b|0]|0)!=0?84:70;n=Yd[c[(c[h>>2]|0)+108>>2]&127](b)|0;o=(a[(c[k>>2]|0)+b|0]|0)!=0?84:70;c[f>>2]=b;c[f+4>>2]=l;c[f+8>>2]=m;c[f+12>>2]=n;c[f+16>>2]=o;Lu(d,0,95568,f);b=b+1|0;}while((b|0)<(c[g>>2]|0))}Vd[c[16120]&511](d);i=e;return}function mx(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+164>>2]|0;if((e|0)<=0){f=0;i=d;return f|0}g=c[b+356>>2]|0;h=c[b+352>>2]|0;b=0;while(1){j=b+1|0;if((a[g+b|0]|0)!=(a[h+b|0]|0)){f=1;k=5;break}if((j|0)<(e|0)){b=j}else{f=0;k=5;break}}if((k|0)==5){i=d;return f|0}return 0}function nx(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;dZ(c[a+400>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;dZ(c[a+404>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;dZ(c[a+408>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;dZ(c[a+412>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function ox(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+160>>2]|0;e=c[a+344>>2]|0;if((d|0)>0){f=c[a+348>>2]|0;g=0;do{h[f+(g<<3)>>3]=+h[e+(g<<3)>>3];g=g+1|0;}while((g|0)<(d|0))}$d[c[(c[a+540>>2]|0)+92>>2]&63](a,e,c[c[a+4>>2]>>2]|0)|0;i=b;return}function px(a){a=a|0;var b=0;b=i;qx(a);rx(a);nx(a);sx(a);i=b;return}function qx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+136>>2]|0;if((e|0)>0){f=c[b+24>>2]|0;g=c[b+416>>2]|0;j=0;do{h[g+(j<<3)>>3]=+h[f+(j*112|0)+96>>3];j=j+1|0;}while((j|0)<(e|0))}e=b+140|0;if((c[e>>2]|0)>0){j=c[b+28>>2]|0;f=c[b+420>>2]|0;g=0;do{c[f+(g<<2)>>2]=c[j+(g*60|0)+52>>2];g=g+1|0;}while((g|0)<(c[e>>2]|0))}e=b+144|0;if((c[e>>2]|0)>0){g=b+32|0;j=b+424|0;f=0;do{a[(c[j>>2]|0)+f|0]=a[(c[g>>2]|0)+(f*48|0)+42|0]|0;f=f+1|0;}while((f|0)<(c[e>>2]|0))}e=c[b+148>>2]|0;if((e|0)<=0){i=d;return}f=b+36|0;g=b+428|0;b=0;do{c[(c[g>>2]|0)+(b<<2)>>2]=c[(c[f>>2]|0)+(b*52|0)+44>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function rx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[b+8>>2]|0;j=c[e+8>>2]|0;k=0;do{h[j+(k<<3)>>3]=+h[g+(k*112|0)+96>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[b+12>>2]|0;g=c[e+12>>2]|0;j=0;do{c[g+(j<<2)>>2]=c[k+(j*60|0)+52>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=b+16|0;k=e+16|0;g=0;do{a[(c[k>>2]|0)+g|0]=a[(c[j>>2]|0)+(g*48|0)+42|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=b+20|0;b=e+20|0;e=0;do{c[(c[b>>2]|0)+(e<<2)>>2]=c[(c[g>>2]|0)+(e*52|0)+44>>2];e=e+1|0;}while((e|0)<(f|0));i=d;return}function sx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((Ev(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=a+ -1|0;m=c[e>>2]|0;n=c[m+(l<<2)>>2]|0;o=c[m+(a<<2)>>2]|0;h[o>>3]=+h[n>>3];dZ(c[o+8>>2]|0,c[n+8>>2]|0,c[f>>2]<<3|0)|0;n=c[e>>2]|0;dZ(c[(c[n+(a<<2)>>2]|0)+12>>2]|0,c[(c[n+(l<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;n=c[e>>2]|0;dZ(c[(c[n+(a<<2)>>2]|0)+16>>2]|0,c[(c[n+(l<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;n=c[e>>2]|0;dZ(c[(c[n+(a<<2)>>2]|0)+20>>2]|0,c[(c[n+(l<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(Ev(c[d>>2]|0)|0));i=b;return}function tx(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[63928+(d<<2)>>2]|0)==0){i=e;return}Lu(d,1,95216,q);q=b+136|0;if((c[q>>2]|0)>0){Lu(d,1,95240,p);if((c[q>>2]|0)>0){p=b+24|0;r=b+416|0;s=0;while(1){t=s+1|0;u=c[p>>2]|0;v=c[u+(s*112|0)+4>>2]|0;w=+h[u+(s*112|0)+96>>3];x=(a[u+(s*112|0)+72|0]|0)!=0?95200:95208;y=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=t;c[o+4>>2]=v;v=o+8|0;h[k>>3]=w;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[o+16>>2]=x;x=o+20|0;h[k>>3]=y;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Lu(d,0,95256,o);if((t|0)<(c[q>>2]|0)){s=t}else{break}}}Vd[c[16120]&511](d)}s=b+140|0;if((c[s>>2]|0)>0){Lu(d,1,95312,n);if((c[s>>2]|0)>0){n=b+28|0;q=b+420|0;o=0;while(1){r=o+1|0;p=c[n>>2]|0;t=c[p+(o*60|0)+4>>2]|0;x=c[p+(o*60|0)+52>>2]|0;v=(a[p+(o*60|0)+48|0]|0)!=0?95200:95208;p=c[(c[q>>2]|0)+(o<<2)>>2]|0;c[m>>2]=r;c[m+4>>2]=t;c[m+8>>2]=x;c[m+12>>2]=v;c[m+16>>2]=p;Lu(d,0,95336,m);if((r|0)<(c[s>>2]|0)){o=r}else{break}}}Vd[c[16120]&511](d)}o=b+144|0;if((c[o>>2]|0)>0){Lu(d,1,95392,l);if((c[o>>2]|0)>0){l=b+32|0;s=b+424|0;m=0;while(1){q=m+1|0;n=c[l>>2]|0;r=c[n+(m*48|0)+4>>2]|0;p=(a[n+(m*48|0)+42|0]|0)!=0?95200:95208;v=(a[n+(m*48|0)+40|0]|0)!=0?95200:95208;n=(a[(c[s>>2]|0)+m|0]|0)!=0?95200:95208;c[j>>2]=q;c[j+4>>2]=r;c[j+8>>2]=p;c[j+12>>2]=v;c[j+16>>2]=n;Lu(d,0,95416,j);if((q|0)<(c[o>>2]|0)){m=q}else{break}}}Vd[c[16120]&511](d)}m=b+148|0;if((c[m>>2]|0)>0){Lu(d,1,95472,g);if((c[m>>2]|0)>0){g=b+36|0;o=b+428|0;b=0;while(1){j=b+1|0;s=c[g>>2]|0;l=c[s+(b*52|0)+4>>2]|0;q=c[s+(b*52|0)+44>>2]|0;s=c[(c[o>>2]|0)+(b<<2)>>2]|0;c[f>>2]=j;c[f+4>>2]=l;c[f+8>>2]=q;c[f+12>>2]=s;Lu(d,0,95496,f);if((j|0)<(c[m>>2]|0)){b=j}else{break}}}Vd[c[16120]&511](d)}Vd[c[16120]&511](d);i=e;return}function ux(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((Ev(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=c[e>>2]|0;m=c[l+(a<<2)>>2]|0;n=a+ -1|0;o=c[l+(n<<2)>>2]|0;h[o>>3]=+h[m>>3];dZ(c[o+8>>2]|0,c[m+8>>2]|0,c[f>>2]<<3|0)|0;m=c[e>>2]|0;dZ(c[(c[m+(n<<2)>>2]|0)+12>>2]|0,c[(c[m+(a<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;m=c[e>>2]|0;dZ(c[(c[m+(n<<2)>>2]|0)+16>>2]|0,c[(c[m+(a<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;m=c[e>>2]|0;dZ(c[(c[m+(n<<2)>>2]|0)+20>>2]|0,c[(c[m+(a<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(Ev(c[d>>2]|0)|0));i=b;return}function vx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[e+8>>2]|0;j=c[b+8>>2]|0;k=0;do{h[j+(k*112|0)+96>>3]=+h[g+(k<<3)>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[e+12>>2]|0;g=c[b+12>>2]|0;j=0;do{c[g+(j*60|0)+52>>2]=c[k+(j<<2)>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=e+16|0;k=b+16|0;g=0;do{a[(c[k>>2]|0)+(g*48|0)+42|0]=a[(c[j>>2]|0)+g|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=e+20|0;e=b+20|0;b=0;do{c[(c[e>>2]|0)+(b*52|0)+44>>2]=c[(c[g>>2]|0)+(b<<2)>>2];b=b+1|0;}while((b|0)<(f|0));i=d;return}function wx(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;h[a+376>>3]=+h[d>>3];dZ(c[a+384>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;dZ(c[a+388>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;dZ(c[a+392>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;dZ(c[a+396>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function xx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+32|0;o=b;c[o>>2]=0;p=yv(3,32)|0;c[o>>2]=p;if((p|0)==0){Pu(c[b+536>>2]|0,95600,m)}m=n;p=b+116|0;q=n+8|0;r=b+536|0;s=b+124|0;t=n+12|0;u=b+128|0;v=n+16|0;w=b+132|0;x=n+20|0;y=n;n=0;do{h[m>>3]=0.0;z=BY(c[p>>2]|0,8)|0;c[q>>2]=z;Ou(c[r>>2]|0,(z|0)!=0|0,95656,l);z=BY(c[s>>2]|0,4)|0;c[t>>2]=z;Ou(c[r>>2]|0,(z|0)!=0|0,95656,k);z=BY(c[u>>2]|0,1)|0;c[v>>2]=z;Ou(c[r>>2]|0,(z|0)!=0|0,95656,j);z=BY(c[w>>2]|0,4)|0;c[x>>2]=z;Ou(c[r>>2]|0,(z|0)!=0|0,95656,g);Cv(c[o>>2]|0,y);n=n+1|0;}while(n>>>0<3);n=BY(3,4)|0;c[b+4>>2]=n;Fv(c[o>>2]|0,0,n);c[b+8>>2]=BY(c[p>>2]|0,112)|0;c[b+12>>2]=BY(c[s>>2]|0,60)|0;c[b+16>>2]=BY(c[u>>2]|0,48)|0;c[b+20>>2]=BY(c[w>>2]|0,52)|0;n=b+136|0;c[b+24>>2]=BY(c[n>>2]|0,112)|0;o=c[b+140>>2]|0;c[b+28>>2]=BY(o,60)|0;y=c[b+144>>2]|0;c[b+32>>2]=BY(y,48)|0;g=c[b+148>>2]|0;c[b+36>>2]=BY(g,52)|0;c[b+40>>2]=BY(c[b+216>>2]|0,52)|0;c[b+44>>2]=BY(c[b+220>>2]|0,52)|0;c[b+48>>2]=BY(c[b+224>>2]|0,52)|0;c[b+52>>2]=BY(c[b+228>>2]|0,52)|0;x=c[b+104>>2]|0;c[b+108>>2]=BY(x,24)|0;h[b+328>>3]=+h[b+240>>3];c[b+336>>2]=BY(x,8)|0;c[b+340>>2]=BY(x,1)|0;c[b+300>>2]=1;c[b+292>>2]=1;c[b+296>>2]=1;x=c[b+160>>2]|0;c[b+344>>2]=BY(x,8)|0;c[b+348>>2]=BY(x,8)|0;j=c[b+164>>2]|0;c[b+352>>2]=BY(j,1)|0;c[b+356>>2]=BY(j,1)|0;c[b+360>>2]=BY(j,1)|0;j=zY(x<<2)|0;c[b+368>>2]=j;c[b+364>>2]=zY(c[b+168>>2]<<3)|0;if((x|0)!=0){v=0;do{c[j+(v<<2)>>2]=v;v=v+1|0;}while(v>>>0<x>>>0)}x=c[p>>2]|0;c[b+384>>2]=BY(x,8)|0;p=c[s>>2]|0;c[b+388>>2]=BY(p,4)|0;s=c[u>>2]|0;c[b+392>>2]=BY(s,1)|0;u=c[w>>2]|0;c[b+396>>2]=BY(u,4)|0;c[b+400>>2]=BY(x,8)|0;c[b+404>>2]=BY(p,4)|0;c[b+408>>2]=BY(s,1)|0;c[b+412>>2]=BY(u,4)|0;c[b+416>>2]=BY(c[n>>2]|0,8)|0;c[b+420>>2]=BY(o,4)|0;c[b+424>>2]=BY(y,1)|0;c[b+428>>2]=BY(g,4)|0;c[b+432>>2]=BY(c[b+152>>2]|0,8)|0;c[b+436>>2]=BY(c[b+156>>2]|0,8)|0;g=zY((c[b+192>>2]|0)*40|0)|0;c[b+484>>2]=g;y=b+540|0;Vd[c[(c[y>>2]|0)+20>>2]&511](g);g=zY((c[b+196>>2]|0)*80|0)|0;c[b+476>>2]=g;Vd[c[(c[y>>2]|0)+16>>2]&511](g);g=zY((c[b+200>>2]|0)*80|0)|0;c[b+468>>2]=g;Vd[c[(c[y>>2]|0)+12>>2]&511](g);g=zY((c[b+204>>2]|0)*48|0)|0;c[b+488>>2]=g;Wd[c[(c[y>>2]|0)+24>>2]&63](g,b);c[b+464>>2]=zY((c[b+232>>2]|0)*44|0)|0;c[b+76>>2]=0;c[b+80>>2]=0;g=BY(c[b+188>>2]|0,4)|0;c[b+320>>2]=g;Ou(c[r>>2]|0,(g|0)!=0|0,95672,f);c[b+512>>2]=100;c[b+516>>2]=BY(100,4)|0;c[b+520>>2]=BY(100,8)|0;c[b+524>>2]=0;c[b+528>>2]=0;c[b+532>>2]=0;h[b+304>>3]=1.0;a[b+313|0]=0;a[b+312|0]=0;a[b+314|0]=0;f=b+172|0;g=b+316|0;a[g]=0;a[g+1|0]=0;a[g+2|0]=0;a[g+3|0]=0;g=zY(c[f>>2]<<2)|0;y=b+504|0;c[y>>2]=g;Ou(c[r>>2]|0,(g|0)!=0|0,95656,e);if((c[f>>2]|0)==0){i=d;return}else{A=0}do{e=yv(1024,16)|0;c[(c[y>>2]|0)+(A<<2)>>2]=e;A=A+1|0;}while(A>>>0<(c[f>>2]|0)>>>0);i=d;return}function yx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;d=a+4|0;e=c[d>>2]|0;f=0;do{g=c[e+(f<<2)>>2]|0;AY(c[g+8>>2]|0);AY(c[g+12>>2]|0);AY(c[g+16>>2]|0);AY(c[g+20>>2]|0);f=f+1|0;e=c[d>>2]|0}while(f>>>0<3);AY(e);zv(c[a>>2]|0);e=a+116|0;f=a+8|0;d=c[f>>2]|0;if((c[e>>2]|0)==0){h=d}else{g=d;d=0;while(1){Wv(g+(d*112|0)|0);j=d+1|0;k=c[f>>2]|0;if(j>>>0<(c[e>>2]|0)>>>0){d=j;g=k}else{h=k;break}}}AY(h);h=a+124|0;g=a+12|0;d=c[g>>2]|0;if((c[h>>2]|0)==0){l=d}else{e=d;d=0;while(1){Wv(e+(d*60|0)|0);f=d+1|0;k=c[g>>2]|0;if(f>>>0<(c[h>>2]|0)>>>0){d=f;e=k}else{l=k;break}}}AY(l);l=a+128|0;e=a+16|0;d=c[e>>2]|0;if((c[l>>2]|0)==0){m=d}else{h=d;d=0;while(1){Wv(h+(d*48|0)|0);g=d+1|0;k=c[e>>2]|0;if(g>>>0<(c[l>>2]|0)>>>0){d=g;h=k}else{m=k;break}}}AY(m);m=a+132|0;h=a+20|0;d=c[h>>2]|0;if((c[m>>2]|0)==0){n=d}else{l=d;d=0;while(1){Wv(l+(d*52|0)|0);e=d+1|0;k=c[h>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){d=e;l=k}else{n=k;break}}}AY(n);n=a+136|0;l=a+24|0;d=c[l>>2]|0;if((c[n>>2]|0)==0){o=d}else{m=d;d=0;while(1){Wv(m+(d*112|0)|0);h=d+1|0;k=c[l>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){d=h;m=k}else{o=k;break}}}AY(o);o=a+140|0;m=a+28|0;d=c[m>>2]|0;if((c[o>>2]|0)==0){p=d}else{n=d;d=0;while(1){Wv(n+(d*60|0)|0);l=d+1|0;k=c[m>>2]|0;if(l>>>0<(c[o>>2]|0)>>>0){d=l;n=k}else{p=k;break}}}AY(p);p=a+144|0;n=a+32|0;d=c[n>>2]|0;if((c[p>>2]|0)==0){q=d}else{o=d;d=0;while(1){Wv(o+(d*48|0)|0);m=d+1|0;k=c[n>>2]|0;if(m>>>0<(c[p>>2]|0)>>>0){d=m;o=k}else{q=k;break}}}AY(q);q=a+148|0;o=a+36|0;d=c[o>>2]|0;if((c[q>>2]|0)==0){r=d}else{p=d;d=0;while(1){Wv(p+(d*52|0)|0);n=d+1|0;k=c[o>>2]|0;if(n>>>0<(c[q>>2]|0)>>>0){d=n;p=k}else{r=k;break}}}AY(r);r=a+216|0;p=a+40|0;d=c[p>>2]|0;if((c[r>>2]|0)==0){s=d}else{q=d;d=0;while(1){Wv(q+(d*52|0)+12|0);o=d+1|0;k=c[p>>2]|0;if(o>>>0<(c[r>>2]|0)>>>0){d=o;q=k}else{s=k;break}}}AY(s);s=a+220|0;q=a+44|0;d=c[q>>2]|0;if((c[s>>2]|0)==0){t=d}else{r=d;d=0;while(1){Wv(r+(d*52|0)+12|0);p=d+1|0;k=c[q>>2]|0;if(p>>>0<(c[s>>2]|0)>>>0){d=p;r=k}else{t=k;break}}}AY(t);t=a+224|0;r=a+48|0;d=c[r>>2]|0;if((c[t>>2]|0)==0){u=d}else{s=d;d=0;while(1){Wv(s+(d*52|0)+12|0);q=d+1|0;k=c[r>>2]|0;if(q>>>0<(c[t>>2]|0)>>>0){d=q;s=k}else{u=k;break}}}AY(u);u=a+228|0;s=a+52|0;d=c[s>>2]|0;if((c[u>>2]|0)==0){v=d}else{t=d;d=0;while(1){Wv(t+(d*52|0)+12|0);r=d+1|0;k=c[s>>2]|0;if(r>>>0<(c[u>>2]|0)>>>0){d=r;t=k}else{v=k;break}}}AY(v);AY(c[a+108>>2]|0);AY(c[a+336>>2]|0);AY(c[a+340>>2]|0);AY(c[a+344>>2]|0);AY(c[a+348>>2]|0);AY(c[a+352>>2]|0);AY(c[a+356>>2]|0);AY(c[a+360>>2]|0);AY(c[a+368>>2]|0);AY(c[a+384>>2]|0);AY(c[a+388>>2]|0);AY(c[a+392>>2]|0);AY(c[a+396>>2]|0);AY(c[a+400>>2]|0);AY(c[a+404>>2]|0);AY(c[a+408>>2]|0);AY(c[a+412>>2]|0);AY(c[a+416>>2]|0);AY(c[a+420>>2]|0);AY(c[a+424>>2]|0);AY(c[a+428>>2]|0);AY(c[a+488>>2]|0);AY(c[a+484>>2]|0);AY(c[a+476>>2]|0);AY(c[a+468>>2]|0);AY(c[a+464>>2]|0);AY(c[a+432>>2]|0);AY(c[a+436>>2]|0);AY(c[a+320>>2]|0);AY(c[a+516>>2]|0);AY(c[a+520>>2]|0);VL(a+56|0);v=a+172|0;t=a+504|0;a=c[t>>2]|0;if((c[v>>2]|0)==0){w=a;x=w;AY(x);i=b;return}else{y=a;z=0}while(1){zv(c[y+(z<<2)>>2]|0);a=z+1|0;d=c[t>>2]|0;if(a>>>0<(c[v>>2]|0)>>>0){z=a;y=d}else{w=d;break}}x=w;AY(x);i=b;return}function zx(a){a=+a;var b=0,d=0,e=0.0,f=0;b=i;i=i+8|0;d=b;e=a*1.0e-4;h[11964]=e;f=d;h[k>>3]=e;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];Lu(8,0,95720,d);i=b;return}function Ax(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;d=c<<24>>24!=0;e=+h[11964];f=e+e*+U(+(d?b:a));if(d){g=f}else{g=-f}i=i;return a-b<=g|0}function Bx(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0;d=i;e=(Ax(a,b,c<<24>>24==0|0)|0)<<24>>24==0|0;i=d;return e|0}function Cx(a,b){a=+a;b=+b;i=i;return a<=b|0}function Dx(a,b){a=+a;b=+b;i=i;return a>b|0}function Ex(a,b){a=+a;b=+b;i=i;return a>=b|0}function Fx(b,d,e){b=+b;d=d|0;e=e|0;var f=0,g=0,j=0.0,k=0,l=0;f=i;do{if((a[e+314|0]|0)==0){g=3}else{if((a[e+318|0]|0)!=0){g=3;break}j=+(~~+T(+b)|0);k=e+364|0;h[(c[k>>2]|0)+(d<<3)>>3]=j;l=k}}while(0);if((g|0)==3){l=e+364|0}i=f;return~~+h[(c[l>>2]|0)+(d<<3)>>3]|0}function Gx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){j=c[e+(h*40|0)>>2]|0;k=j<<2;c[e+(h*40|0)+20>>2]=zY(k)|0;c[e+(h*40|0)+24>>2]=zY(k)|0;if((c[g>>2]|0)!=1){l=5;break}Jx(j,e+(h*40|0)+28|0)|0;j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{l=6;break}}if((l|0)==5){Pu(c[a+536>>2]|0,95776,d)}else if((l|0)==6){i=b;return 0}return 0}function Hx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){AY(c[e+(h*40|0)+20>>2]|0);AY(c[e+(h*40|0)+24>>2]|0);if((c[g>>2]|0)!=1){j=5;break}k=e+(h*40|0)+28|0;Kx(k)|0;AY(c[k>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{j=6;break}}if((j|0)==5){Pu(c[a+536>>2]|0,95776,d)}else if((j|0)==6){i=b;return 0}return 0}function Ix(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+484>>2]|0;o=b+192|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+4|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p*40|0)+36|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[63996>>2]|c[15980]|0)==0){z=w;A=1;break}TL(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Nu(17,1,95808,g);TL(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;TL(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;Nu(17,0,95840,f);TL(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}Vd[c[16120]&511](17);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function Jx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=zY(20)|0;c[b>>2]=f;Ou(0,(f|0)!=0|0,95848,e);e=zY(a)|0;c[f>>2]=e;e=zY(a)|0;c[f+4>>2]=e;e=zY(a)|0;c[f+8>>2]=e;e=zY(a)|0;c[f+16>>2]=e;Ou(0,(c[b>>2]|0)!=0|0,95880,d);i=d;return 0}function Kx(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;AY(c[d>>2]|0);AY(c[d+4>>2]|0);AY(c[d+8>>2]|0);AY(c[d+16>>2]|0);i=b;return 0}function Lx(a,b){a=a|0;b=b|0;b=i;i=i+8|0;Pu(c[a+536>>2]|0,95928,b);return 0}function Mx(a){a=a|0;a=i;i=i+8|0;Pu(0,95928,a);return 0}



function Sy(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0;j=i;i=i+8|0;l=j;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+24|0;v=i;i=i+32|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+4096|0;K=a;L=c[K>>2]|0;M=L+1|0;N=L<<3;O=zY(fa(N,M)|0)|0;P=zY(M<<3)|0;Q=zY(N)|0;R=Q;S=zY(N)|0;T=S;V=zY(N)|0;W=V;X=zY(N)|0;Y=+h[f>>3];if((c[63964>>2]|0)!=0&Y<1.0){N=J;c[I>>2]=c[(c[a+60>>2]|0)+88>>2];dc(N|0,102784,I|0)|0;I=ec(N|0,102800)|0;c[H>>2]=102816;ld(I|0,102808,H|0)|0;c[G>>2]=102832;ld(I|0,102808,G|0)|0;if((c[K>>2]|0)>0){G=a+44|0;H=0;do{c[F>>2]=c[(c[G>>2]|0)+(H<<2)>>2];ld(I|0,102808,F|0)|0;H=H+1|0;}while((H|0)<(c[K>>2]|0))}Gd(10,I|0)|0;c[E>>2]=0;ld(I|0,102840,E|0)|0;E=D;h[k>>3]=Y;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];ld(I|0,102848,D|0)|0;if((c[K>>2]|0)>0){D=a+24|0;E=0;do{H=C;h[k>>3]=+h[(c[D>>2]|0)+(E<<3)>>3];c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];ld(I|0,102848,C|0)|0;E=E+1|0;}while((E|0)<(c[K>>2]|0))}Gd(10,I|0)|0;Z=I}else{Z=0}Ou(0,(O|0)!=0|0,102856,B);Ou(0,(P|0)!=0|0,102856,A);Ou(0,(Q|0)!=0|0,102856,z);Ou(0,(S|0)!=0|0,102856,y);Ou(0,(V|0)!=0|0,102856,x);Ou(0,(X|0)!=0|0,102856,w);w=c[a+40>>2]|0;x=(L|0)>0;do{if((w|0)==0){if(!x){_=0;break}y=a+24|0;z=0;while(1){A=(c[y>>2]|0)+(z<<3)|0;B=0;do{h[O+((fa(B,L)|0)+z<<3)>>3]=+h[A>>3];B=B+1|0;}while((B|0)<(M|0));B=z+1|0;if((B|0)<(L|0)){z=B}else{$=14;break}}}else{if(!x){_=0;break}z=c[a+24>>2]|0;y=0;while(1){aa=+h[z+(y<<3)>>3]/+h[w+(y<<3)>>3];B=0;do{h[O+((fa(B,L)|0)+y<<3)>>3]=aa;B=B+1|0;}while((B|0)<(M|0));B=y+1|0;if((B|0)<(L|0)){y=B}else{$=14;break}}}}while(0);do{if(($|0)==14){w=(L|0)>0;if(w){ba=0}else{_=0;break}while(1){x=O+((fa(ba,L)|0)+ba<<3)|0;h[x>>3]=+h[x>>3]+1.0;x=ba+1|0;if((x|0)<(L|0)){ba=x}else{_=w;break}}}}while(0);ba=(L|0)>-1;w=a+16|0;aa=+(M|0);ca=+(L|0);x=(e|0)==0;y=a+48|0;da=1.0/+(b+ -1|0);b=(Z|0)==0;z=a+24|0;B=L<<3;ea=0.0;A=0;ga=Y;a:while(1){I=!(ga>=1.0);E=ga<1.0;ha=ea;C=A;b:while(1){D=C;c:while(1){ia=D+1|0;if(ba){H=0;do{Jy(a,O+((fa(H,L)|0)<<3)|0);h[P+(H<<3)>>3]=+vy(a,ga);H=H+1|0;}while((H|0)<(M|0))}if(_){H=1;F=0;while(1){G=+h[P+(H<<3)>>3]<+h[P+(F<<3)>>3]?H:F;N=H+1|0;if((N|0)<(M|0)){F=G;H=N}else{ja=G;break}}}else{ja=0}ka=fa(ja,L)|0;la=O+(ka<<3)|0;Jy(a,la);+vy(a,ga);H=c[w>>2]|0;if((H|0)>0){F=c[y>>2]|0;Y=0.0;G=0;do{ma=+U(+(+h[F+(G<<3)>>3]));Y=ma>Y?ma:Y;G=G+1|0;}while((G|0)<(H|0));na=!(Y<1.0e-12)}else{na=0}if(!((na|I)&(D|0)<(d|0))){break a}do{if(ba){H=0;G=ja;F=ja;while(1){ma=+h[P+(H<<3)>>3];N=ma>+h[P+(G<<3)>>3];oa=N?H:G;J=N?G:F;pa=!(ma>+h[P+(J<<3)>>3])|(H|0)==(oa|0)?J:H;J=H+1|0;if((J|0)<(M|0)){F=pa;G=oa;H=J}else{break}}if(ba){qa=0.0;ra=0}else{sa=0.0;ta=oa;ua=pa;break}do{qa=qa+ +h[P+(ra<<3)>>3];ra=ra+1|0;}while((ra|0)<(M|0));ma=qa/aa;if(ba){va=0.0;wa=0}else{sa=0.0;ta=oa;ua=pa;break}while(1){xa=+h[P+(wa<<3)>>3]-ma;ya=va+xa*xa;H=wa+1|0;if((H|0)<(M|0)){wa=H;va=ya}else{sa=ya;ta=oa;ua=pa;break}}}else{sa=0.0;ta=ja;ua=ja}}while(0);Y=sa/ca;do{if(!x){if(((ia|0)%(e|0)|0|0)!=0){break}ma=+h[P+(ja<<3)>>3];ya=+h[P+(ta<<3)>>3];H=v;h[k>>3]=ga;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];c[v+8>>2]=ia;H=v+12|0;h[k>>3]=ma;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=v+20|0;h[k>>3]=ya;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];Lu(9,0,102872,v)}}while(0);if(Y<1.0e-8&E){break b}if(_){fZ(X|0,0,B|0)|0}if(ba){H=0;do{if(!((H|0)==(ta|0)|_^1)){G=fa(H,L)|0;F=0;do{J=X+(F<<3)|0;h[J>>3]=+h[O+(F+G<<3)>>3]+ +h[J>>3];F=F+1|0;}while((F|0)<(L|0))}H=H+1|0;}while((H|0)<(M|0))}do{if(_){H=0;do{F=X+(H<<3)|0;h[F>>3]=+h[F>>3]/ca;H=H+1|0;}while((H|0)<(L|0));if(!_){break}H=fa(ta,L)|0;F=0;do{Y=+h[X+(F<<3)>>3];h[Q+(F<<3)>>3]=Y+(Y- +h[O+(F+H<<3)>>3]);F=F+1|0;}while((F|0)<(L|0))}}while(0);Jy(a,R);za=+vy(a,ga);Y=+h[P+(ja<<3)>>3];do{if(Y<=za){if(!(za<=+h[P+(ua<<3)>>3])){break}if(!_){Aa=ia;D=Aa;continue c}dZ(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue c}}while(0);if(!(za<=Y)){break}if(_){F=0;do{ya=+h[X+(F<<3)>>3];h[S+(F<<3)>>3]=ya+(+h[Q+(F<<3)>>3]-ya)*2.0;F=F+1|0;}while((F|0)<(L|0))}Jy(a,T);if(+vy(a,ga)<za){if(!_){Aa=ia;D=Aa;continue}dZ(O+(fa(B,ta)|0)|0,S|0,B|0)|0;Aa=ia;D=Aa;continue}else{if(!_){Aa=ia;D=Aa;continue}dZ(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue}}if(!(+h[P+(ua<<3)>>3]<=za)){$=89;break a}Y=+h[P+(ta<<3)>>3];if(!(za>=Y)){if(_){D=0;do{ya=+h[X+(D<<3)>>3];h[V+(D<<3)>>3]=ya+(+h[Q+(D<<3)>>3]-ya)*.5;D=D+1|0;}while((D|0)<(L|0))}Jy(a,W);Ba=+vy(a,ga)}else{if(_){D=fa(ta,L)|0;F=0;do{ya=+h[X+(F<<3)>>3];h[V+(F<<3)>>3]=ya+(+h[O+(F+D<<3)>>3]-ya)*.5;F=F+1|0;}while((F|0)<(L|0))}Jy(a,W);Ba=+vy(a,ga)}if(Ba<Y){if(!_){ha=Ba;C=ia;continue}dZ(O+(fa(B,ta)|0)|0,V|0,B|0)|0;ha=Ba;C=ia;continue}if(ba){Ca=0}else{ha=Ba;C=ia;continue}while(1){if(_){F=fa(Ca,L)|0;D=0;do{H=O+(D+F<<3)|0;h[H>>3]=(+h[H>>3]+ +h[O+(D+ka<<3)>>3])*.5;D=D+1|0;}while((D|0)<(L|0))}D=Ca+1|0;if((D|0)<(M|0)){Ca=D}else{ha=Ba;C=ia;continue b}}}Y=ga+da;ya=Y>1.0?1.0:Y;Y=+h[P+(ja<<3)>>3];C=u;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[u+8>>2]=ia;C=u+12|0;h[k>>3]=Y;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Lu(9,0,102912,u);if(b){ea=ha;A=ia;ga=ya;continue}c[t>>2]=ia;ld(Z|0,102840,t|0)|0;C=s;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];ld(Z|0,102848,s|0)|0;if((c[K>>2]|0)>0){C=0;do{E=r;h[k>>3]=+h[(c[z>>2]|0)+(C<<3)>>3];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];ld(Z|0,102848,r|0)|0;C=C+1|0;}while((C|0)<(c[K>>2]|0))}Gd(10,Z|0)|0;ea=ha;A=ia;ga=ya}if(($|0)==89){$=q;h[k>>3]=za;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];Nu(9,0,102960,q);q=p;h[k>>3]=ha;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];Nu(9,0,102976,p);Pu(0,102992,o)}Jy(a,la);if((f|0)!=0){h[f>>3]=ga}if((g|0)!=0){c[g>>2]=ia}if(b){AY(S);AY(Q);AY(V);AY(X);AY(P);AY(O);i=j;return}c[n>>2]=ia;ld(Z|0,102840,n|0)|0;n=m;h[k>>3]=ga;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];ld(Z|0,102848,m|0)|0;if((c[K>>2]|0)>0){m=0;do{n=l;h[k>>3]=+h[(c[z>>2]|0)+(m<<3)>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];ld(Z|0,102848,l|0)|0;m=m+1|0;}while((m|0)<(c[K>>2]|0))}Gd(10,Z|0)|0;Sc(Z|0)|0;AY(S);AY(Q);AY(V);AY(X);AY(P);AY(O);i=j;return}function Ty(a,b){a=a|0;b=b|0;i=i;return}function Uy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=c[b+12>>2]|0;Qv(3);Tv(0);w=+Lv(0);Qv(0);x=d+4|0;y=u;h[k>>3]=+h[c[c[x>>2]>>2]>>3];c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];ld(v|0,103072,u|0)|0;if((c[b+8>>2]|0)!=0){b=t;h[k>>3]=w;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];ld(v|0,103072,t|0)|0}t=d+116|0;b=c[t>>2]|0;if((b|0)>0){u=d+8|0;y=b;b=0;while(1){if((a[(c[u>>2]|0)+(b*112|0)+104|0]|0)==0){z=s;h[k>>3]=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(b<<3)>>3];c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];ld(v|0,103072,s|0)|0;A=c[t>>2]|0}else{A=y}z=b+1|0;if((z|0)<(A|0)){y=A;b=z}else{break}}}b=d+124|0;A=c[b>>2]|0;if((A|0)>0){y=d+12|0;t=A;A=0;while(1){if((a[(c[y>>2]|0)+(A*60|0)+56|0]|0)==0){c[r>>2]=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(A<<2)>>2];ld(v|0,103080,r|0)|0;B=c[b>>2]|0}else{B=t}s=A+1|0;if((s|0)<(B|0)){t=B;A=s}else{break}}}A=d+128|0;B=c[A>>2]|0;if((B|0)>0){t=d+16|0;b=B;B=0;while(1){if((a[(c[t>>2]|0)+(B*48|0)+44|0]|0)==0){c[q>>2]=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+B|0]|0;ld(v|0,103080,q|0)|0;C=c[A>>2]|0}else{C=b}r=B+1|0;if((r|0)<(C|0)){b=C;B=r}else{break}}}B=d+132|0;C=c[B>>2]|0;if((C|0)>0){b=d+20|0;A=C;C=0;while(1){if((a[(c[b>>2]|0)+(C*52|0)+48|0]|0)==0){c[p>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(C<<2)>>2];ld(v|0,103088,p|0)|0;D=c[B>>2]|0}else{D=A}q=C+1|0;if((q|0)<(D|0)){A=D;C=q}else{break}}}C=d+216|0;if((c[C>>2]|0)>0){D=d+40|0;A=0;do{B=c[D>>2]|0;do{if((a[B+(A*52|0)+48|0]|0)==0){p=a[B+(A*52|0)+8|0]|0;if(p<<24>>24==1){break}else if(p<<24>>24==2){E=c[c[x>>2]>>2]|0}else{E=(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(c[B+(A*52|0)+4>>2]<<3)|0}w=+h[E>>3];if((c[B+(A*52|0)>>2]|0)==0){p=n;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];ld(v|0,103072,n|0)|0;break}else{p=o;h[k>>3]=-w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];ld(v|0,103072,o|0)|0;break}}}while(0);A=A+1|0;}while((A|0)<(c[C>>2]|0))}C=d+220|0;if((c[C>>2]|0)>0){A=d+44|0;o=0;do{n=c[A>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){if((a[n+(o*52|0)+8|0]|0)==1){break}E=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(c[n+(o*52|0)+4>>2]<<2)>>2]|0;if((c[n+(o*52|0)>>2]|0)==0){c[l>>2]=E;ld(v|0,103080,l|0)|0;break}else{c[m>>2]=0-E;ld(v|0,103080,m|0)|0;break}}}while(0);o=o+1|0;}while((o|0)<(c[C>>2]|0))}C=d+224|0;if((c[C>>2]|0)>0){o=d+48|0;m=0;do{l=c[o>>2]|0;do{if((a[l+(m*52|0)+48|0]|0)==0){if((a[l+(m*52|0)+8|0]|0)==1){break}A=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+(c[l+(m*52|0)+4>>2]|0)|0]|0;if((c[l+(m*52|0)>>2]|0)==0){c[g>>2]=A<<24>>24;ld(v|0,103080,g|0)|0;break}else{c[j>>2]=A<<24>>24!=1;ld(v|0,103080,j|0)|0;break}}}while(0);m=m+1|0;}while((m|0)<(c[C>>2]|0))}C=d+228|0;m=c[C>>2]|0;if((m|0)<=0){F=Gd(10,v|0)|0;Tv(3);i=e;return}j=d+52|0;d=m;m=0;while(1){g=c[j>>2]|0;do{if((a[g+(m*52|0)+48|0]|0)==0){if((a[g+(m*52|0)+8|0]|0)==1){G=d;break}c[f>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(c[g+(m*52|0)+4>>2]<<2)>>2];ld(v|0,103088,f|0)|0;G=c[C>>2]|0}else{G=d}}while(0);g=m+1|0;if((g|0)<(G|0)){d=G;m=g}else{break}}F=Gd(10,v|0)|0;Tv(3);i=e;return}function Vy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b;s=ec(c[r>>2]|0,103096)|0;t=c[d+536>>2]|0;u=c[r>>2]|0;r=Kd(c[(Ic()|0)>>2]|0)|0;c[q>>2]=u;c[q+4>>2]=r;Ou(t,(s|0)!=0|0,103104,q);c[p>>2]=103160;ld(s|0,103088,p|0)|0;if((c[b+8>>2]|0)!=0){c[o>>2]=103168;ld(s|0,103088,o|0)|0}o=d+116|0;p=c[o>>2]|0;if((p|0)>0){q=d+8|0;t=p;p=0;while(1){r=c[q>>2]|0;if((a[r+(p*112|0)+104|0]|0)==0){c[n>>2]=c[r+(p*112|0)+4>>2];ld(s|0,103088,n|0)|0;v=c[o>>2]|0}else{v=t}r=p+1|0;if((r|0)<(v|0)){t=v;p=r}else{break}}}p=d+124|0;v=c[p>>2]|0;if((v|0)>0){t=d+12|0;o=v;v=0;while(1){n=c[t>>2]|0;if((a[n+(v*60|0)+56|0]|0)==0){c[m>>2]=c[n+(v*60|0)+4>>2];ld(s|0,103088,m|0)|0;w=c[p>>2]|0}else{w=o}n=v+1|0;if((n|0)<(w|0)){o=w;v=n}else{break}}}v=d+128|0;w=c[v>>2]|0;if((w|0)>0){o=d+16|0;p=w;w=0;while(1){m=c[o>>2]|0;if((a[m+(w*48|0)+44|0]|0)==0){c[l>>2]=c[m+(w*48|0)+4>>2];ld(s|0,103088,l|0)|0;x=c[v>>2]|0}else{x=p}m=w+1|0;if((m|0)<(x|0)){p=x;w=m}else{break}}}w=d+132|0;x=c[w>>2]|0;if((x|0)>0){p=d+20|0;v=x;x=0;while(1){l=c[p>>2]|0;if((a[l+(x*52|0)+48|0]|0)==0){c[k>>2]=c[l+(x*52|0)+4>>2];ld(s|0,103088,k|0)|0;y=c[w>>2]|0}else{y=v}l=x+1|0;if((l|0)<(y|0)){v=y;x=l}else{break}}}x=d+216|0;y=c[x>>2]|0;if((y|0)>0){v=d+40|0;w=y;y=0;while(1){k=c[v>>2]|0;do{if((a[k+(y*52|0)+48|0]|0)==0){if((a[k+(y*52|0)+8|0]|0)==1){z=w;break}c[j>>2]=c[k+(y*52|0)+16>>2];ld(s|0,103088,j|0)|0;z=c[x>>2]|0}else{z=w}}while(0);k=y+1|0;if((k|0)<(z|0)){w=z;y=k}else{break}}}y=d+220|0;z=c[y>>2]|0;if((z|0)>0){w=d+44|0;x=z;z=0;while(1){j=c[w>>2]|0;do{if((a[j+(z*52|0)+48|0]|0)==0){if((a[j+(z*52|0)+8|0]|0)==1){A=x;break}c[h>>2]=c[j+(z*52|0)+16>>2];ld(s|0,103088,h|0)|0;A=c[y>>2]|0}else{A=x}}while(0);j=z+1|0;if((j|0)<(A|0)){x=A;z=j}else{break}}}z=d+224|0;A=c[z>>2]|0;if((A|0)>0){x=d+48|0;y=A;A=0;while(1){h=c[x>>2]|0;do{if((a[h+(A*52|0)+48|0]|0)==0){if((a[h+(A*52|0)+8|0]|0)==1){B=y;break}c[g>>2]=c[h+(A*52|0)+16>>2];ld(s|0,103088,g|0)|0;B=c[z>>2]|0}else{B=y}}while(0);h=A+1|0;if((h|0)<(B|0)){y=B;A=h}else{break}}}A=d+228|0;B=c[A>>2]|0;if((B|0)<=0){C=Gd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}y=d+52|0;d=B;B=0;while(1){z=c[y>>2]|0;do{if((a[z+(B*52|0)+48|0]|0)==0){if((a[z+(B*52|0)+8|0]|0)==1){H=d;break}c[f>>2]=c[z+(B*52|0)+16>>2];ld(s|0,103088,f|0)|0;H=c[A>>2]|0}else{H=d}}while(0);z=B+1|0;if((z|0)<(H|0)){d=H;B=z}else{break}}C=Gd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}function Wy(a,b){a=a|0;b=b|0;var d=0;b=i;d=c[a+12>>2]|0;Qv(3);Sc(d|0)|0;Tv(3);i=b;return}function Xy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d;f=d+16|0;g=d+32|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+88|0;o=c[a+12>>2]|0;c[k>>2]=0;p=o;LQ(l,p);q=o+184|0;r=m;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=f;r=m;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];MQ(p,f)|0;Yy(b,k,g,j,+h[o+224>>3],+h[o+232>>3]);o=c[k>>2]|0;Zy(a,b,103184,c[j>>2]|0,c[g>>2]|0,o,8);AY(o);c[k>>2]=0;k=n;o=l;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=e;k=n;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];MQ(p,e)|0;i=d;return}function Yy(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+8|0;c[e>>2]=2;l=b+136|0;m=b+140|0;n=b+144|0;o=(c[l>>2]|0)+1+(c[m>>2]|0)+(c[n>>2]|0)|0;c[f>>2]=o;p=BY(fa(c[e>>2]|0,o)|0,8)|0;c[d>>2]=p;Ou(c[b+536>>2]|0,(p|0)!=0|0,103464,k);p=c[d>>2]|0;h[p>>3]=g;d=c[f>>2]|0;h[p+(d<<3)>>3]=j;f=c[l>>2]|0;if((f|0)>0){l=c[b+416>>2]|0;o=0;do{e=l+(o<<3)|0;o=o+1|0;h[p+(o<<3)>>3]=+h[e>>3];h[p+(d+o<<3)>>3]=+h[e>>3];}while((o|0)<(f|0))}o=f+1|0;f=c[m>>2]|0;if((f|0)>0){m=c[b+420>>2]|0;l=0;do{j=+(c[m+(l<<2)>>2]|0);e=l+o|0;h[p+(e<<3)>>3]=j;h[p+(d+e<<3)>>3]=j;l=l+1|0;}while((l|0)<(f|0))}l=f+o|0;o=c[n>>2]|0;if((o|0)<=0){i=k;return}n=c[b+424>>2]|0;b=0;do{f=n+b|0;m=l+b|0;h[p+(m<<3)>>3]=+(a[f]|0);h[p+(d+m<<3)>>3]=+(a[f]|0);b=b+1|0;}while((b|0)<(o|0));i=k;return}function Zy(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+8|0;k=j;l=c[a+12>>2]|0;iz(a,b,d,e,f,h);KQ(l,g,fa(fa(f,e)|0,h)|0)|0;if(fP(l+(c[(c[l>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];Pu(l,103416,k)}else{i=j;return}}function _y(a){a=a|0;var b=0;b=i;if((aA(a+4|0)|0)!=0){i=b;return}iP(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function $y(a){a=a|0;Mc(a|0)|0;Va()}function az(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=FY(320)|0;fZ(q|0,0,320)|0;bz(q);r=a+12|0;c[r>>2]=q;s=(c[b+140>>2]|0)+(c[b+136>>2]|0)+(c[b+144>>2]|0)|0;c[f>>2]=0;c[k>>2]=0;c[l>>2]=0;Qv(3);t=a+8|0;u=cz(c[t>>2]|0,c[r>>2]|0,b)|0;r=q+316|0;c[r>>2]=u;v=dz(a,b,u+s|0)|0;u=q+184|0;ez(m,-1,-1);w=m;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];w=q+200|0;ez(n,-1,-1);m=n;c[w+0>>2]=c[m+0>>2];c[w+4>>2]=c[m+4>>2];c[w+8>>2]=c[m+8>>2];c[w+12>>2]=c[m+12>>2];c[q+216>>2]=0;m=q+224|0;h[m>>3]=+h[b+240>>3];n=q+232|0;h[n>>3]=+h[b+248>>3];x=a;fz(q,c[x>>2]|0,36);if(fP(q+(c[(c[q>>2]|0)+ -12>>2]|0)|0)|0){y=c[b+536>>2]|0;c[e>>2]=c[x>>2];Pu(y,103240,e)}else{Zy(a,b,103272,4,11,103192,1);gz((c[r>>2]|0)+s|0,v,f,g,j,0,0)|0;e=c[f>>2]|0;Zy(a,b,103280,c[g>>2]|0,c[j>>2]|0,e,1);AY(e);c[f>>2]=0;gz((c[r>>2]|0)+s|0,v,f,g,j,0,1)|0;e=c[f>>2]|0;Zy(a,b,103288,c[g>>2]|0,c[j>>2]|0,e,1);AY(e);c[f>>2]=0;hz(a,b,k,g,j,c[r>>2]|0,s);Zy(a,b,103304,c[j>>2]|0,c[g>>2]|0,c[k>>2]|0,4);s=q;LQ(o,s);r=o;c[u+0>>2]=c[r+0>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];Yy(b,l,g,j,+h[m>>3],+h[n>>3]);n=c[l>>2]|0;Zy(a,b,103184,c[j>>2]|0,c[g>>2]|0,n,8);LQ(p,s);g=p;c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2];c[w+12>>2]=c[g+12>>2];g=jz(q+240|0)|0;w=jz(q+264|0)|0;p=jz(q+288|0)|0;iz(a,b,103320,g+1+w+p+(c[q+312>>2]|0)+(c[t>>2]|0)|0,0,8);AY(n);AY(c[k>>2]|0);c[l>>2]=0;c[k>>2]=0;qQ(s)|0;AY(v);Tv(3);i=d;return}}function bz(a){a=a|0;var b=0;b=i;kC(a);i=b;return}function cz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=(b|0)==0?1:2;c[g>>2]=0;b=e+116|0;l=c[b>>2]|0;if((l|0)>0){m=e+8|0;n=d+240|0;o=l;l=0;p=k;while(1){if((a[(c[m>>2]|0)+(l*112|0)+104|0]|0)==0){c[(oB(n,g)|0)>>2]=p;q=c[b>>2]|0;r=c[g>>2]|0;s=p+1|0}else{q=o;r=l;s=p}t=r+1|0;c[g>>2]=t;if((t|0)<(q|0)){o=q;l=t;p=s}else{u=s;break}}}else{u=k}c[h>>2]=0;k=e+124|0;s=c[k>>2]|0;if((s|0)>0){p=e+12|0;l=d+264|0;q=s;s=0;o=u;while(1){if((a[(c[p>>2]|0)+(s*60|0)+56|0]|0)==0){c[(oB(l,h)|0)>>2]=o;v=c[k>>2]|0;w=c[h>>2]|0;x=o+1|0}else{v=q;w=s;x=o}g=w+1|0;c[h>>2]=g;if((g|0)<(v|0)){q=v;s=g;o=x}else{y=x;break}}}else{y=u}c[j>>2]=0;u=e+128|0;x=c[u>>2]|0;if((x|0)>0){o=e+16|0;s=d+288|0;v=x;x=0;q=y;while(1){if((a[(c[o>>2]|0)+(x*48|0)+44|0]|0)==0){c[(oB(s,j)|0)>>2]=q;z=c[u>>2]|0;A=c[j>>2]|0;B=q+1|0}else{z=v;A=x;B=q}h=A+1|0;c[j>>2]=h;if((h|0)<(z|0)){v=z;x=h;q=B}else{C=B;break}}}else{C=y}y=c[e+216>>2]|0;if((y|0)>0){B=c[e+40>>2]|0;q=0;x=C;while(1){z=((a[B+(q*52|0)+48|0]|0)==0)+x|0;v=q+1|0;if((v|0)<(y|0)){x=z;q=v}else{D=z;break}}}else{D=C}C=c[e+220>>2]|0;if((C|0)>0){q=c[e+44>>2]|0;x=0;y=D;while(1){B=((a[q+(x*52|0)+48|0]|0)==0)+y|0;z=x+1|0;if((z|0)<(C|0)){y=B;x=z}else{E=B;break}}}else{E=D}D=d+312|0;c[D>>2]=0;d=c[e+224>>2]|0;if((d|0)<=0){F=E;i=f;return F|0}x=c[e+48>>2]|0;e=0;y=0;C=E;while(1){if((a[x+(y*52|0)+48|0]|0)==0){if((c[x+(y*52|0)>>2]|0)==0){G=e}else{E=e+1|0;c[D>>2]=E;G=E}H=G;I=C+1|0}else{H=e;I=C}E=y+1|0;if((E|0)<(d|0)){e=H;y=E;C=I}else{F=I;break}}i=f;return F|0}function dz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=c[b+12>>2]|0;l=zY(e<<2)|0;e=l;c[l>>2]=103872;if((c[b+8>>2]|0)==0){m=1}else{c[l+4>>2]=103912;m=2}b=c[d+116>>2]|0;if((b|0)>0){n=c[d+8>>2]|0;o=m;p=0;while(1){if((a[n+(p*112|0)+104|0]|0)==0){c[l+(o<<2)>>2]=n+(p*112|0);q=o+1|0}else{q=o}r=p+1|0;if((r|0)<(b|0)){o=q;p=r}else{s=q;break}}}else{s=m}m=c[d+124>>2]|0;if((m|0)>0){q=c[d+12>>2]|0;p=s;o=0;while(1){if((a[q+(o*60|0)+56|0]|0)==0){c[l+(p<<2)>>2]=q+(o*60|0);t=p+1|0}else{t=p}b=o+1|0;if((b|0)<(m|0)){p=t;o=b}else{u=t;break}}}else{u=s}s=c[d+128>>2]|0;if((s|0)>0){t=c[d+16>>2]|0;o=u;p=0;while(1){if((a[t+(p*48|0)+44|0]|0)==0){c[l+(o<<2)>>2]=t+(p*48|0);v=o+1|0}else{v=o}m=p+1|0;if((m|0)<(s|0)){o=v;p=m}else{w=v;break}}}else{w=u}u=c[d+216>>2]|0;if((u|0)>0){v=c[d+40>>2]|0;p=w;o=0;while(1){if((a[v+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=v+(o*52|0)+12;x=p+1|0}else{x=p}s=o+1|0;if((s|0)<(u|0)){p=x;o=s}else{y=x;break}}}else{y=w}w=c[d+220>>2]|0;if((w|0)>0){x=c[d+44>>2]|0;o=y;p=0;while(1){if((a[x+(p*52|0)+48|0]|0)==0){c[l+(o<<2)>>2]=x+(p*52|0)+12;z=o+1|0}else{z=o}u=p+1|0;if((u|0)<(w|0)){o=z;p=u}else{A=z;break}}}else{A=y}y=c[d+224>>2]|0;if((y|0)>0){z=c[d+48>>2]|0;p=A;o=0;while(1){if((a[z+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=z+(o*52|0)+12;B=p+1|0}else{B=p}w=o+1|0;if((w|0)<(y|0)){p=B;o=w}else{C=B;break}}}else{C=A}c[g>>2]=0;A=d+136|0;if((c[A>>2]|0)>0){B=d+24|0;o=k+252|0;p=C;y=0;z=1;while(1){w=p+1|0;c[l+(p<<2)>>2]=(c[B>>2]|0)+(y*112|0);c[(oB(o,g)|0)>>2]=z;x=z+1|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;if((u|0)<(c[A>>2]|0)){z=x;y=u;p=w}else{D=w;E=x;break}}}else{D=C;E=1}c[h>>2]=0;C=d+140|0;if((c[C>>2]|0)>0){p=d+28|0;y=k+276|0;z=D;A=0;g=E;while(1){o=z+1|0;c[l+(z<<2)>>2]=(c[p>>2]|0)+(A*60|0);c[(oB(y,h)|0)>>2]=g;B=g+1|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;if((x|0)<(c[C>>2]|0)){g=B;A=x;z=o}else{F=o;G=B;break}}}else{F=D;G=E}c[j>>2]=0;E=d+144|0;if((c[E>>2]|0)<=0){i=f;return e|0}D=d+32|0;d=k+300|0;k=F;F=0;z=G;while(1){c[l+(k<<2)>>2]=(c[D>>2]|0)+(F*48|0);c[(oB(d,j)|0)>>2]=z;G=(c[j>>2]|0)+1|0;c[j>>2]=G;if((G|0)<(c[E>>2]|0)){z=z+1|0;F=G;k=k+1|0}else{break}}i=f;return e|0}function ez(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;$z(a,b,c);i=d;return}function fz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(_z(a+4|0,b,d|16)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){iP(d,4);i=e;return}else{gP(d,0);i=e;return}}function gz(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+8|0;k=j;l=i;i=i+8|0;c[f>>2]=a;c[e>>2]=0;m=(a|0)>0;do{if(m){n=0;o=0;while(1){p=c[b+(o<<2)>>2]|0;q=bZ(c[(h?p+8|0:p+4|0)>>2]|0)|0;if((q|0)>(n|0)){c[e>>2]=q;r=q}else{r=n}q=o+1|0;if((q|0)<(a|0)){n=r;o=q}else{break}}o=BY((fa(c[f>>2]|0,r)|0)+1|0,1)|0;c[d>>2]=o;Ou(0,(o|0)!=0|0,103392,l);if(!m){break}o=c[e>>2]|0;n=0;q=c[d>>2]|0;while(1){p=b+(n<<2)|0;s=c[p>>2]|0;mZ(q|0,c[(h?s+8|0:s+4|0)>>2]|0,o+1|0)|0;if(g){s=c[p>>2]|0;nz(q,bZ(c[(h?s+8|0:s+4|0)>>2]|0)|0)}s=c[e>>2]|0;p=n+1|0;if((p|0)<(a|0)){o=s;n=p;q=q+s|0}else{t=s;break}}u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}else{q=BY(1,1)|0;c[d>>2]=q;Ou(0,(q|0)!=0|0,103392,k)}}while(0);t=c[e>>2]|0;u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}function hz(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=c[b+12>>2]|0;c[f>>2]=j+h;c[g>>2]=4;g=BY(c[f>>2]<<2,4)|0;c[e>>2]=g;Ou(c[d+536>>2]|0,(g|0)!=0|0,103440,k);g=s+240|0;f=jz(g)|0;h=s+264|0;t=jz(h)|0;u=s+288|0;v=jz(u)|0;w=b+8|0;if((f+1+t+v|0)==(0-(c[w>>2]|0)|0)){x=0;y=1}else{v=c[e>>2]|0;t=0;f=0;b=1;while(1){c[v+(t<<2)>>2]=2;c[v+((t|1)<<2)>>2]=b;c[v+((t|2)<<2)>>2]=0;z=t+4|0;c[v+((t|3)<<2)>>2]=-1;A=b+1|0;B=f+1|0;C=jz(g)|0;D=jz(h)|0;E=jz(u)|0;if(B>>>0<(C+1+D+E+(c[w>>2]|0)|0)>>>0){b=A;f=B;t=z}else{x=z;y=A;break}}}t=d+216|0;if((c[t>>2]|0)>0){f=d+40|0;b=s+252|0;w=x;v=0;while(1){A=c[f>>2]|0;do{if((a[A+(v*52|0)+48|0]|0)==0){z=a[A+(v*52|0)+8|0]|0;if(z<<24>>24==1){oz(l,b,A+(v*52|0)+4|0);qz(n,b);if(!(pz(l,n)|0)){F=w;break}G=(c[(rz(l)|0)+4>>2]|0)+1|0;H=1}else if(z<<24>>24==2){G=1;H=2}else if(z<<24>>24==0){oz(l,g,A+(v*52|0)+4|0);qz(m,g);if(!(pz(l,m)|0)){F=w;break}G=(c[(rz(l)|0)+4>>2]|0)+1|0;H=2}else{F=w;break}z=c[e>>2]|0;c[z+(w<<2)>>2]=H;if((c[(c[f>>2]|0)+(v*52|0)>>2]|0)==0){c[z+(w+1<<2)>>2]=G}else{c[z+(w+1<<2)>>2]=0-G}c[z+(w+2<<2)>>2]=0;c[z+(w+3<<2)>>2]=-1;F=w+4|0}else{F=w}}while(0);A=v+1|0;if((A|0)<(c[t>>2]|0)){w=F;v=A}else{I=F;break}}}else{I=x}x=d+220|0;if((c[x>>2]|0)>0){F=d+44|0;v=s+276|0;w=I;t=0;while(1){G=c[F>>2]|0;do{if((a[G+(t*52|0)+48|0]|0)==0){f=a[G+(t*52|0)+8|0]|0;if(f<<24>>24==1){oz(l,v,G+(t*52|0)+4|0);qz(p,v);J=(pz(l,p)|0)&1}else if(f<<24>>24==0){oz(l,h,G+(t*52|0)+4|0);qz(o,h);f=pz(l,o)|0;J=f?2:0}else{K=w;break}if((J|0)==0){K=w;break}f=c[e>>2]|0;c[f+(w<<2)>>2]=J;H=(c[(c[F>>2]|0)+(t*52|0)>>2]|0)==0;m=c[(rz(l)|0)+4>>2]|0;if(H){c[f+(w+1<<2)>>2]=m+1}else{c[f+(w+1<<2)>>2]=~m}c[f+(w+2<<2)>>2]=0;c[f+(w+3<<2)>>2]=-1;K=w+4|0}else{K=w}}while(0);G=t+1|0;if((G|0)<(c[x>>2]|0)){w=K;t=G}else{L=K;break}}}else{L=I}I=d+224|0;if((c[I>>2]|0)>0){K=d+48|0;d=s+300|0;s=L;t=0;w=y;while(1){y=c[K>>2]|0;do{if((a[y+(t*52|0)+48|0]|0)==0){if((c[y+(t*52|0)>>2]|0)==0){x=a[y+(t*52|0)+8|0]|0;if(x<<24>>24==1){oz(l,d,y+(t*52|0)+4|0);qz(r,d);M=(pz(l,r)|0)&1}else if(x<<24>>24==0){oz(l,u,y+(t*52|0)+4|0);qz(q,u);x=pz(l,q)|0;M=x?2:0}else{N=s;O=w;break}if((M|0)==0){N=s;O=w;break}P=c[K>>2]|0;Q=M}else{P=y;Q=2}x=c[e>>2]|0;c[x+(s<<2)>>2]=Q;if((c[P+(t*52|0)>>2]|0)==0){c[x+(s+1<<2)>>2]=(c[(rz(l)|0)+4>>2]|0)+1;R=w}else{c[x+(s+1<<2)>>2]=w;R=w+1|0}c[x+(s+2<<2)>>2]=0;c[x+(s+3<<2)>>2]=-1;N=s+4|0;O=R}else{N=s;O=w}}while(0);y=t+1|0;if((y|0)<(c[I>>2]|0)){s=N;t=y;w=O}else{S=N;break}}}else{S=L}if((j|0)==0){i=k;return}L=c[e>>2]|0;e=0;do{N=(e<<2)+S|0;c[L+(N<<2)>>2]=1;c[L+(N+1<<2)>>2]=e+2;c[L+(N+2<<2)>>2]=0;c[L+(N+3<<2)>>2]=0;e=e+1|0;}while(e>>>0<j>>>0);i=k;return}function iz(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+24|0;m=c[a+12>>2]|0;c[l>>2]=(g|0)==4?20:(g|0)==1?51:0;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;f=l+16|0;c[f>>2]=(bZ(d|0)|0)+1;e=m;KQ(e,l,20)|0;if(fP(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];Pu(l,103416,k)}KQ(e,d,c[f>>2]|0)|0;if(fP(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){m=c[b+536>>2]|0;c[j>>2]=c[a>>2];Pu(m,103416,j)}else{i=h;return}}function jz(a){a=a|0;var b=0,d=0;b=i;d=c[(Xz(a)|0)>>2]|0;i=b;return d|0}function kz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=a+12|0;h=c[g>>2]|0;j=h;Qv(3);do{if(eP(h+(c[(c[h>>2]|0)+ -12>>2]|0)|0)|0){k=h;l=h+200|0;m=f;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];l=e;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];MQ(k,e)|0;k=jz(h+240|0)|0;m=jz(h+264|0)|0;l=jz(h+288|0)|0;iz(a,b,103320,k+1+m+l+(c[h+312>>2]|0)+(c[a+8>>2]|0)|0,c[h+216>>2]|0,8);_y(h)}else{if((h|0)!=0){break}c[g>>2]=0;Tv(3);i=d;return}}while(0);lz(j);HY(h);c[g>>2]=0;Tv(3);i=d;return}function lz(a){a=a|0;var b=0;b=i;tA(a);i=b;return}function mz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=c[b+12>>2]|0;h[g>>3]=0.0;Qv(3);Tv(0);h[j>>3]=+Lv(0);Qv(0);l=k;m=d+4|0;KQ(l,c[c[m>>2]>>2]|0,8)|0;if((c[b+8>>2]|0)!=0){KQ(l,j,8)|0}j=d+116|0;n=c[j>>2]|0;if((n|0)>0){o=d+8|0;p=n;n=0;while(1){if((a[(c[o>>2]|0)+(n*112|0)+104|0]|0)==0){KQ(l,(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+(n<<3)|0,8)|0;q=c[j>>2]|0}else{q=p}r=n+1|0;if((r|0)<(q|0)){p=q;n=r}else{break}}}n=d+124|0;q=c[n>>2]|0;if((q|0)>0){p=d+12|0;j=g;o=q;q=0;while(1){if((a[(c[p>>2]|0)+(q*60|0)+56|0]|0)==0){h[g>>3]=+(c[(c[(c[c[m>>2]>>2]|0)+12>>2]|0)+(q<<2)>>2]|0);KQ(l,j,8)|0;s=c[n>>2]|0}else{s=o}r=q+1|0;if((r|0)<(s|0)){o=s;q=r}else{break}}}q=d+128|0;s=c[q>>2]|0;if((s|0)>0){o=d+16|0;n=g;j=s;s=0;while(1){if((a[(c[o>>2]|0)+(s*48|0)+44|0]|0)==0){h[g>>3]=+(a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+s|0]|0);KQ(l,n,8)|0;t=c[q>>2]|0}else{t=j}p=s+1|0;if((p|0)<(t|0)){j=t;s=p}else{break}}}s=d+224|0;t=c[s>>2]|0;if((t|0)>0){j=d+48|0;q=g;n=t;t=0;while(1){o=c[j>>2]|0;do{if((a[o+(t*52|0)+48|0]|0)==0){if((c[o+(t*52|0)>>2]|0)==0){u=n;break}h[g>>3]=+((a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+(c[o+(t*52|0)+4>>2]|0)|0]|0)!=1|0);KQ(l,q,8)|0;u=c[s>>2]|0}else{u=n}}while(0);o=t+1|0;if((o|0)<(u|0)){n=u;t=o}else{break}}}if(fP(k+(c[(c[k>>2]|0)+ -12>>2]|0)|0)|0){t=c[d+536>>2]|0;c[f>>2]=c[b>>2];Pu(t,103360,f)}else{f=k+216|0;c[f>>2]=(c[f>>2]|0)+1;Tv(3);i=e;return}}function nz(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(c>>>0<6){i=d;return}if((_Y(b,103576,4)|0)!=0){i=d;return}c=b;while(1){e=Ta(b|0,46)|0;if((e|0)==0){f=8;break}g=e-c|0;e=g+1|0;if(e>>>0>4){h=4;do{a[b+(h+ -4)|0]=a[b+h|0]|0;h=h+1|0;}while(h>>>0<e>>>0)}e=b+(g+ -3)|0;a[e]=678585700;a[e+1|0]=2650725;a[e+2|0]=10354;a[e+3|0]=40;if((_Y(b,103576,4)|0)!=0){f=8;break}}if((f|0)==8){i=d;return}}function oz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;Jz(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];zz(a,f);i=e;return}function pz(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=xz(a,b)|0;i=c;return d|0}function qz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;Az(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];zz(a,e);i=d;return}function rz(a){a=a|0;var b=0,c=0;b=i;c=sz(tz(a)|0)|0;i=b;return c|0}function sz(a){a=a|0;var b=0,c=0;b=i;c=wz(a)|0;i=b;return c|0}function tz(a){a=a|0;var b=0,d=0;b=i;d=uz((c[a>>2]|0)+16|0)|0;i=b;return d|0}function uz(a){a=a|0;var b=0,c=0;b=i;c=vz(a)|0;i=b;return c|0}function vz(a){a=a|0;i=i;return a|0}function wz(a){a=a|0;i=i;return a|0}function xz(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(yz(a,b)|0)^1;i=c;return d|0}function yz(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function zz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Iz(a,e);i=d;return}function Az(a,b){a=a|0;b=b|0;var c=0;c=i;Bz(a,Cz(b)|0);i=c;return}function Bz(a,b){a=a|0;b=b|0;var c=0;c=i;Hz(a,b);i=c;return}function Cz(a){a=a|0;var b=0,c=0;b=i;c=Dz(Ez(a+4|0)|0)|0;i=b;return c|0}function Dz(a){a=a|0;var b=0,c=0;b=i;c=Gz(a)|0;i=b;return c|0}function Ez(a){a=a|0;var b=0,c=0;b=i;c=Fz(a)|0;i=b;return c|0}function Fz(a){a=a|0;i=i;return a|0}function Gz(a){a=a|0;i=i;return a|0}function Hz(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Iz(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function Jz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=Lz(b)|0;Kz(f,b,d,h,Cz(b)|0);Az(g,b);do{if(xz(f,g)|0){h=Mz(b)|0;if(Nz(h,d,Oz(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);Az(a,b);i=e;return}function Kz(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;Sz(h);a:do{if((e|0)==0){j=f}else{k=Mz(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(Tz(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;Sz(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;Sz(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);Bz(a,j);i=g;return}function Lz(a){a=a|0;var b=0,d=0;b=i;d=c[(Cz(a)|0)>>2]|0;i=b;return d|0}function Mz(a){a=a|0;var b=0,c=0;b=i;c=Qz(a+8|0)|0;i=b;return c|0}function Nz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=Pz(0,b,c)|0;i=a;return d|0}function Oz(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function Pz(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function Qz(a){a=a|0;var b=0,c=0;b=i;c=Rz(a)|0;i=b;return c|0}function Rz(a){a=a|0;i=i;return a|0}function Sz(a){a=a|0;var b=0;b=i;Uz(a,-1);i=b;return}function Tz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=Pz(0,b,c)|0;i=a;return d|0}function Uz(a,b){a=a|0;b=b|0;b=i;Vz(a,0);i=b;return}function Vz(a,b){a=a|0;b=b|0;c[a>>2]=0;i=i;return}function Wz(a){a=a|0;i=i;return c[a+4>>2]|0}function Xz(a){a=a|0;var b=0,c=0;b=i;c=Yz(a+8|0)|0;i=b;return c|0}function Yz(a){a=a|0;var b=0,c=0;b=i;c=Zz(a)|0;i=b;return c|0}function Zz(a){a=a|0;i=i;return a|0}function _z(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+64|0;if((c[f>>2]|0)!=0){g=0;i=e;return g|0}switch(d&-3|0){case 52:case 20:{h=103528;break};case 8:{h=103496;break};case 28:{h=103552;break};case 56:{h=103512;break};case 24:{h=103504;break};case 5:case 21:{h=103536;break};case 9:case 25:{h=103520;break};case 13:case 29:{h=103568;break};case 48:case 16:{h=103480;break};case 1:case 17:{h=103488;break};case 60:{h=103560;break};case 12:{h=103544;break};default:{g=0;i=e;return g|0}}if((a|0)==0){g=0;i=e;return g|0}j=ec(b|0,h|0)|0;c[f>>2]=j;if((j|0)==0){g=0;i=e;return g|0}c[a+88>>2]=d;if((d&2|0)==0){g=a;i=e;return g|0}if((Qc(j|0,0,2)|0)==0){g=a;i=e;return g|0}Sc(c[f>>2]|0)|0;c[f>>2]=0;g=0;i=e;return g|0}function $z(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=b;c[e+4>>2]=d;i=i;return}function aA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+64|0;f=c[e>>2]|0;if((f|0)==0){g=0;i=b;return g|0}bA(d,f,102);f=Yd[c[(c[a>>2]|0)+24>>2]&127](a)|0;if((Sc(cA(d)|0)|0)==0){c[e>>2]=0;h=(f|0)==0?a:0}else{h=0}dA(d);g=h;i=b;return g|0}function bA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;kA(a,b,c);i=d;return}function cA(a){a=a|0;var b=0,d=0;b=i;d=gA(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function dA(a){a=a|0;var b=0;b=i;eA(a);i=b;return}function eA(a){a=a|0;var b=0;b=i;fA(a,0);i=b;return}function fA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=gA(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}Yd[c[(hA(e)|0)>>2]&127](f)|0;i=d;return}function gA(a){a=a|0;var b=0,c=0;b=i;c=jA(a)|0;i=b;return c|0}function hA(a){a=a|0;var b=0,c=0;b=i;c=iA(a)|0;i=b;return c|0}function iA(a){a=a|0;i=i;return a+4|0}function jA(a){a=a|0;i=i;return a|0}function kA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(mA(f)|0)>>2]|0;lA(a,d,c[(nA(g)|0)>>2]|0);i=e;return}function lA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;oA(a,b,c);i=d;return}function mA(a){a=a|0;i=i;return a|0}function nA(a){a=a|0;i=i;return a|0}function oA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(qA(f)|0)>>2]|0;pA(a,d,c[(rA(g)|0)>>2]|0);i=e;return}function pA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;c[a>>2]=c[(qA(f)|0)>>2];c[a+4>>2]=c[(rA(g)|0)>>2];i=e;return}function qA(a){a=a|0;i=i;return a|0}function rA(a){a=a|0;i=i;return a|0}function sA(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;J=c[d+4>>2]|0;i=b;return c[d>>2]|0}function tA(a){a=a|0;var b=0;b=i;uA(a+300|0);uA(a+288|0);uA(a+276|0);uA(a+264|0);uA(a+252|0);uA(a+240|0);vA(a);i=b;return}function uA(a){a=a|0;var b=0;b=i;fB(a);i=b;return}function vA(a){a=a|0;var b=0;b=i;wA(a,103624);mP(a+104|0);i=b;return}function wA(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];AA(a+4|0);i=d;return}function xA(a){a=a|0;var b=0;b=i;vA(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function yA(a){a=a|0;var b=0;b=i;vA(a);HY(a);i=b;return}function zA(a){a=a|0;var b=0;b=i;yA(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function AA(a){a=a|0;var b=0;b=i;BA(a);i=b;return}function BA(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=103752;aA(b)|0;do{if((a[b+96|0]|0)!=0){e=c[b+32>>2]|0;if((e|0)==0){break}IY(e)}}while(0);do{if((a[b+97|0]|0)!=0){e=c[b+56>>2]|0;if((e|0)==0){break}IY(e)}}while(0);vP(b);i=d;return}function CA(a){a=a|0;var b=0;b=i;AA(a);HY(a);i=b;return}function DA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;Yd[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=dB(d)|0;c[b+68>>2]=f;d=b+98|0;g=a[d]|0;h=eB(f)|0;a[d]=h&1;if((g&255|0)==(h&1|0)){i=e;return}h=b;FP(h,0,0,0);KP(h,0,0);h=b+96|0;g=(a[h]|0)!=0;if((a[d]|0)!=0){d=b+32|0;do{if(g){f=c[d>>2]|0;if((f|0)==0){break}IY(f)}}while(0);f=b+97|0;a[h]=a[f]|0;j=b+60|0;c[b+52>>2]=c[j>>2];k=b+56|0;c[d>>2]=c[k>>2];c[j>>2]=0;c[k>>2]=0;a[f]=0;i=e;return}do{if(!g){f=b+32|0;k=c[f>>2]|0;if((k|0)==(b+44|0)){break}j=c[b+52>>2]|0;c[b+60>>2]=j;c[b+56>>2]=k;a[b+97|0]=0;c[f>>2]=GY(j)|0;a[h]=1;i=e;return}}while(0);h=c[b+52>>2]|0;c[b+60>>2]=h;c[b+56>>2]=GY(h)|0;a[b+97|0]=1;i=e;return}function EA(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=f+8|0;c[g>>2]=e;e=b;FP(e,0,0,0);KP(e,0,0);j=b+96|0;do{if((a[j]|0)!=0){k=c[b+32>>2]|0;if((k|0)==0){break}IY(k)}}while(0);k=b+97|0;do{if((a[k]|0)!=0){l=c[b+56>>2]|0;if((l|0)==0){break}IY(l)}}while(0);l=c[g>>2]|0;m=b+52|0;c[m>>2]=l;do{if(l>>>0>8){n=a[b+98|0]|0;if(n<<24>>24==0|(d|0)==0){c[b+32>>2]=GY(l)|0;a[j]=1;o=n;break}else{c[b+32>>2]=d;a[j]=0;o=n;break}}else{c[b+32>>2]=b+44;c[m>>2]=8;a[j]=0;o=a[b+98|0]|0}}while(0);if(!(o<<24>>24==0)){c[b+60>>2]=0;c[b+56>>2]=0;a[k]=0;i=f;return e|0}c[h>>2]=8;o=c[(aB(g,h)|0)>>2]|0;c[b+60>>2]=o;if((d|0)!=0&o>>>0>7){c[b+56>>2]=d;a[k]=0;i=f;return e|0}else{c[b+56>>2]=GY(o)|0;a[k]=1;i=f;return e|0}return 0}function FA(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g;j=g+8|0;k=g+24|0;l=k;m=c[b+68>>2]|0;if((m|0)==0){n=zc(4)|0;eY(n);Hd(n|0,151032,127)}n=YA(m)|0;m=b+64|0;do{if((c[m>>2]|0)!=0){o=(n|0)>0;if(!(o|(d|0)==0&(e|0)==0)){break}if((Yd[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}if(!(f>>>0<3)){ez(a,-1,-1);i=g;return}p=c[m>>2]|0;if(o){o=uZ(n|0,((n|0)<0)<<31>>31|0,d|0,e|0)|0;q=o}else{q=0}if((Qc(p|0,q|0,f|0)|0)==0){p=vb(c[m>>2]|0)|0;ez(j,p,((p|0)<0)<<31>>31);p=b+72|0;o=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=o;o=h;r=l;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];$A(j,h);r=a;o=j;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];i=g;return}else{ez(a,-1,-1);i=g;return}}}while(0);ez(a,-1,-1);i=g;return}function GA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=f;h=b+64|0;do{if((c[h>>2]|0)!=0){if((Yd[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}j=c[h>>2]|0;k=sA(d)|0;if((Qc(j|0,k|0,0)|0)==0){_A(g,d);k=f;j=c[k+4>>2]|0;l=b+72|0;c[l>>2]=c[k>>2];c[l+4>>2]=j;j=a;l=d;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=e;return}else{ez(a,-1,-1);i=e;return}}}while(0);ez(a,-1,-1);i=e;return}function HA(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=zc(4)|0;eY(m);Hd(m|0,151032,127)}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;do{if((a[b+98|0]|0)==0){p=YA(l)|0;q=b+36|0;o=c[q>>2]|0;r=(c[b+40>>2]|0)-o|0;s=b;if((p|0)>0){t=DP(s)|0;u=(fa(t-(CP(s)|0)|0,p)|0)+r|0;v=0;break}p=CP(s)|0;if((p|0)==(DP(s)|0)){u=r;v=0;break}t=c[k>>2]|0;w=b+32|0;x=c[w>>2]|0;y=ZA(t,g,x,o,p-(BP(s)|0)|0)|0;u=r-y+(c[q>>2]|0)-(c[w>>2]|0)|0;v=1}else{w=b;q=DP(w)|0;u=q-(CP(w)|0)|0;v=0}}while(0);if((Qc(c[h>>2]|0,0-u|0,1)|0)!=0){j=-1;i=d;return j|0}if(v){w=f;q=c[w+4>>2]|0;y=b+72|0;c[y>>2]=c[w>>2];c[y+4>>2]=q}q=c[b+32>>2]|0;c[b+40>>2]=q;c[b+36>>2]=q;FP(b,0,0,0);c[m>>2]=0}else{q=b;y=HP(q)|0;do{if((y|0)!=(GP(q)|0)){if((le[c[(c[b>>2]|0)+52>>2]&63](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);q=b+72|0;y=b+32|0;w=b+52|0;while(1){r=c[y>>2]|0;s=XA(c[k>>2]|0,q,r,r+(c[w>>2]|0)|0,e)|0;r=c[y>>2]|0;p=(c[e>>2]|0)-r|0;if((mc(r|0,1,p|0,c[h>>2]|0)|0)!=(p|0)){j=-1;z=23;break}if((s|0)==2){j=-1;z=23;break}else if((s|0)!=1){z=10;break}}if((z|0)==10){if((jd(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((z|0)==23){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function IA(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=b+64|0;if((c[l>>2]|0)==0){m=-1;i=d;return m|0}n=SA(b)|0;o=b;if((CP(o)|0)==0){p=e+1|0;FP(o,e,p,p)}if(n){q=0}else{n=DP(o)|0;c[f>>2]=(n-(BP(o)|0)|0)/2|0;c[g>>2]=4;q=c[(TA(f,g)|0)>>2]|0}g=CP(o)|0;do{if((g|0)==(DP(o)|0)){eZ(BP(o)|0,g+(0-q)|0,q|0)|0;if((a[b+98|0]|0)!=0){f=DP(o)|0;n=BP(o)|0;p=pb(n+q|0,1,f-q-n|0,c[l>>2]|0)|0;if((p|0)==0){r=-1;break}n=BP(o)|0;FP(o,n,n+q|0,n+(p+q)|0);r=QA(a[CP(o)|0]|0)|0;break}p=b+32|0;n=b+36|0;f=c[n>>2]|0;s=b+40|0;eZ(c[p>>2]|0,f|0,(c[s>>2]|0)-f|0)|0;f=c[p>>2]|0;t=f+((c[s>>2]|0)-(c[n>>2]|0))|0;c[n>>2]=t;if((f|0)==(b+44|0)){u=8}else{u=c[b+52>>2]|0}v=f+u|0;c[s>>2]=v;f=b+60|0;c[h>>2]=(c[f>>2]|0)-q;c[j>>2]=v-t;v=c[(TA(h,j)|0)>>2]|0;w=b+72|0;x=w;y=c[x+4>>2]|0;z=b+80|0;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=pb(t|0,1,v|0,c[l>>2]|0)|0;if((y|0)==0){r=-1;break}v=c[b+68>>2]|0;if((v|0)==0){t=zc(4)|0;eY(t);Hd(t|0,151032,127)}t=(c[n>>2]|0)+y|0;c[s>>2]=t;y=c[p>>2]|0;z=BP(o)|0;if((UA(v,w,y,t,n,z+q|0,z+(c[f>>2]|0)|0,k)|0)==3){f=c[p>>2]|0;FP(o,f,f,c[s>>2]|0);r=QA(a[CP(o)|0]|0)|0;break}s=c[k>>2]|0;f=BP(o)|0;p=f+q|0;if((s|0)==(p|0)){r=-1;break}FP(o,f,p,s);r=QA(a[CP(o)|0]|0)|0}else{r=QA(a[g]|0)|0}}while(0);if((BP(o)|0)!=(e|0)){m=r;i=d;return m|0}FP(o,0,0,0);m=r;i=d;return m|0}function JA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[b+64>>2]|0)==0){f=-1;i=e;return f|0}g=b;h=BP(g)|0;j=CP(g)|0;if(!(h>>>0<j>>>0)){f=-1;i=e;return f|0}if(MA(d,-1)|0){EP(g,-1);f=PA(d)|0;i=e;return f|0}h=(c[b+88>>2]&16|0)==0;b=NA(d)|0;do{if(h){if(RA(b,a[j+ -1|0]|0)|0){break}else{f=-1}i=e;return f|0}}while(0);EP(g,-1);a[CP(g)|0]=b;f=d;i=e;return f|0}function KA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}LA(b);l=b;m=GP(l)|0;n=IP(l)|0;if(!(MA(d,-1)|0)){if((HP(l)|0)==0){KP(l,f,f+1|0)}f=NA(d)|0;a[HP(l)|0]=f;JP(l,1)}f=HP(l)|0;o=GP(l)|0;if((f|0)!=(o|0)){a:do{if((a[b+98|0]|0)==0){p=b+32|0;q=c[p>>2]|0;c[g>>2]=q;r=b+68|0;s=c[r>>2]|0;if((s|0)==0){t=zc(4)|0;u=t;eY(u);v=151032;w=127;Hd(t|0,v|0,w|0)}x=b+72|0;y=b+52|0;z=q;q=s;while(1){s=GP(l)|0;A=HP(l)|0;B=OA(q,x,s,A,h,z,z+(c[y>>2]|0)|0,g)|0;A=c[h>>2]|0;C=GP(l)|0;if((A|0)==(C|0)){k=-1;D=22;break}if((B|0)==3){D=14;break}if(!(B>>>0<2)){k=-1;D=22;break}A=c[p>>2]|0;s=(c[g>>2]|0)-A|0;if((mc(A|0,1,s|0,c[j>>2]|0)|0)!=(s|0)){k=-1;D=22;break}if((B|0)!=1){break a}B=c[h>>2]|0;KP(l,B,HP(l)|0);B=IP(l)|0;JP(l,B-(GP(l)|0)|0);B=c[r>>2]|0;if((B|0)==0){D=11;break}z=c[p>>2]|0;q=B}if((D|0)==11){t=zc(4)|0;u=t;eY(u);v=151032;w=127;Hd(t|0,v|0,w|0)}else if((D|0)==14){q=(HP(l)|0)-C|0;if((mc(C|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((D|0)==22){i=e;return k|0}}else{q=f-o|0;if((mc(o|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);KP(l,m,n)}k=PA(d)|0;i=e;return k|0}function LA(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+92|0;if((c[e>>2]&16|0)!=0){i=d;return}f=b;FP(f,0,0,0);g=c[b+52>>2]|0;do{if(g>>>0>8){if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;KP(f,h,h+((c[b+60>>2]|0)+ -1)|0);break}else{h=c[b+32>>2]|0;KP(f,h,h+(g+ -1)|0);break}}else{KP(f,0,0)}}while(0);c[e>>2]=16;i=d;return}function MA(a,b){a=a|0;b=b|0;i=i;return(a|0)==(b|0)|0}function NA(a){a=a|0;i=i;return a&255|0}function OA(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=te[c[(c[a>>2]|0)+12>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function PA(a){a=a|0;var b=0,c=0;b=i;c=MA(a,-1)|0;i=b;return(c?0:a)|0}function QA(a){a=a|0;i=i;return a&255|0}function RA(a,b){a=a|0;b=b|0;i=i;return a<<24>>24==b<<24>>24|0}function SA(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+92|0;if((c[e>>2]&8|0)!=0){f=0;i=d;return f|0}g=b;KP(g,0,0);if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;j=h+(c[b+60>>2]|0)|0;FP(g,h,j,j)}else{j=c[b+32>>2]|0;h=j+(c[b+52>>2]|0)|0;FP(g,j,h,h)}c[e>>2]=8;f=1;i=d;return f|0}function TA(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=VA(b,c,e)|0;i=d;return g|0}function UA(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=te[c[(c[a>>2]|0)+16>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function VA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=WA(0,b,a)|0;i=c;return(d?b:a)|0}function WA(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function XA(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=me[c[(c[a>>2]|0)+20>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function YA(a){a=a|0;var b=0,d=0;b=i;d=Yd[c[(c[a>>2]|0)+24>>2]&127](a)|0;i=b;return d|0}function ZA(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=me[c[(c[a>>2]|0)+32>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function _A(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function $A(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function aB(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=bB(b,c,e)|0;i=d;return g|0}function bB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=cB(0,a,b)|0;i=c;return(d?b:a)|0}function cB(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function dB(a){a=a|0;var b=0,c=0;b=i;c=eV(a,135536)|0;i=b;return c|0}function eB(a){a=a|0;var b=0,d=0;b=i;d=Yd[c[(c[a>>2]|0)+28>>2]&127](a)|0;i=b;return d|0}function fB(a){a=a|0;var b=0;b=i;gB(a);i=b;return}function gB(a){a=a|0;var b=0;b=i;hB(a);i=b;return}function hB(a){a=a|0;var b=0;b=i;iB(a,Lz(a)|0);i=b;return}function iB(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;Sz(d);if((b|0)==0){i=d;return}iB(a,c[b>>2]|0);iB(a,c[b+4>>2]|0);kB(jB(a)|0,b,1);i=d;return}function jB(a){a=a|0;var b=0,c=0;b=i;c=mB(a+4|0)|0;i=b;return c|0}function kB(a,b,c){a=a|0;b=b|0;c=c|0;c=i;lB(0,b,0);i=c;return}function lB(a,b,c){a=a|0;b=b|0;c=c|0;c=i;HY(b);i=c;return}function mB(a){a=a|0;var b=0,c=0;b=i;c=nB(a)|0;i=b;return c|0}function nB(a){a=a|0;i=i;return a|0}function oB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=pB(a,f,b)|0;l=c[k>>2]|0;Sz(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}rB(j,a,b);sB(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];qB(g,e);tB(j);j=c[f>>2]|0;uB(a,j,k,vB(g)|0);k=wB(g)|0;tB(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function pB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=Lz(h)|0;Sz(e);if((a|0)==0){j=Cz(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(Pz(0,d,a)|0){m=l;j=c[m>>2]|0;Sz(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(Pz(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;Sz(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function qB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];iC(a,e);i=d;return}function rB(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=jB(d)|0;d=TB(n,1)|0;UB(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];SB(j,d,h);VB(0,OB((WB(j)|0)+16|0)|0,e);e=XB(j)|0;a[e+4|0]=1;YB(0,NB((WB(j)|0)+20|0)|0);a[e+5|0]=1;ZB(m,j);sB(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];qB(b,g);tB(m);tB(j);i=f;return}function sB(a,b){a=a|0;b=b|0;var c=0;c=i;QB(a,b);i=c;return}function tB(a){a=a|0;var b=0;b=i;JB(a);i=b;return}function uB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;Sz(f);c[e>>2]=0;Sz(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=BB(a)|0;b=c[c[e>>2]>>2]|0;Sz(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(Cz(a)|0)>>2]|0;CB(e,c[d>>2]|0);d=DB(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function vB(a){a=a|0;var b=0,d=0;b=i;d=c[(zB(a)|0)>>2]|0;i=b;return d|0}function wB(a){a=a|0;var b=0,d=0;b=i;d=xB(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function xB(a){a=a|0;var b=0,c=0;b=i;c=yB(a)|0;i=b;return c|0}function yB(a){a=a|0;i=i;return a|0}function zB(a){a=a|0;var b=0,c=0;b=i;c=AB(a)|0;i=b;return c|0}function AB(a){a=a|0;i=i;return a|0}function BB(a){a=a|0;i=i;return a|0}function CB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(d|0)==(b|0);a[d+12|0]=h&1;if(h){i=e;return}else{j=d}while(1){k=j+8|0;d=c[k>>2]|0;if((a[d+12|0]|0)!=0){l=17;break}h=GB(d)|0;m=c[d+8>>2]|0;if(h){h=c[m+4>>2]|0;Sz(f);if((h|0)==0){l=7;break}d=h+12|0;if((a[d]|0)!=0){l=7;break}h=c[k>>2]|0;a[h+12|0]=1;n=c[h+8>>2]|0;a[n+12|0]=(n|0)==(b|0)|0;a[d]=1;o=n}else{n=c[m>>2]|0;Sz(g);if((n|0)==0){l=14;break}m=n+12|0;if((a[m]|0)!=0){l=14;break}n=c[k>>2]|0;a[n+12|0]=1;d=c[n+8>>2]|0;a[d+12|0]=(d|0)==(b|0)|0;a[m]=1;o=d}if((o|0)==(b|0)){l=17;break}else{j=o}}if((l|0)==7){if(GB(j)|0){p=j}else{o=c[k>>2]|0;HB(o);p=o}o=c[p+8>>2]|0;a[o+12|0]=1;p=c[o+8>>2]|0;a[p+12|0]=0;IB(p);i=e;return}else if((l|0)==14){if(GB(j)|0){p=c[k>>2]|0;IB(p);q=p}else{q=j}j=c[q+8>>2]|0;a[j+12|0]=1;q=c[j+8>>2]|0;a[q+12|0]=0;HB(q);i=e;return}else if((l|0)==17){i=e;return}}function DB(a){a=a|0;var b=0,c=0;b=i;c=EB(a+8|0)|0;i=b;return c|0}function EB(a){a=a|0;var b=0,c=0;b=i;c=FB(a)|0;i=b;return c|0}function FB(a){a=a|0;i=i;return a|0}function GB(a){a=a|0;i=i;return(c[c[a+8>>2]>>2]|0)==(a|0)|0}function HB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;f=e;g=c[f>>2]|0;c[d>>2]=g;Sz(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=GB(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function IB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;f=e+4|0;g=c[f>>2]|0;c[d>>2]=g;Sz(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=GB(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function JB(a){a=a|0;var b=0;b=i;KB(a,0);i=b;return}function KB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=xB(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}MB(LB(e)|0,f);i=d;return}function LB(a){a=a|0;var b=0,c=0;b=i;c=PB(a)|0;i=b;return c|0}function MB(a,b){a=a|0;b=b|0;var d=0;d=i;if((b|0)==0){i=d;return}kB(c[a>>2]|0,b,1);i=d;return}function NB(a){a=a|0;i=i;return a|0}function OB(a){a=a|0;i=i;return a|0}function PB(a){a=a|0;i=i;return a+4|0}function QB(a,b){a=a|0;b=b|0;var c=0;c=i;RB(a,b);i=c;return}function RB(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function SB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];aC(a,b,f);i=e;return}function TB(a,b){a=a|0;b=b|0;var c=0;a=i;c=$B(0,b,0)|0;i=a;return c|0}function UB(a,b){a=a|0;b=b|0;var c=0;c=i;_B(a,b);i=c;return}function VB(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function WB(a){a=a|0;var b=0,d=0;b=i;d=c[(zB(a)|0)>>2]|0;i=b;return d|0}function XB(a){a=a|0;var b=0,c=0;b=i;c=LB(a)|0;i=b;return c|0}function YB(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function ZB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;QB(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];qB(h,f);sB(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];qB(a,e);tB(h);i=d;return}function _B(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function $B(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=FY(b*24|0)|0;i=c;return a|0}function aC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(cC(g)|0)>>2]|0;g=dC(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];bC(b,a,f);i=e;return}function bC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];eC(a,b,f);i=e;return}function cC(a){a=a|0;i=i;return a|0}function dC(a){a=a|0;i=i;return a|0}function eC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(gC(g)|0)>>2]|0;g=hC(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];fC(b,a,f);i=e;return}function fC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(gC(f)|0)>>2];f=hC(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function gC(a){a=a|0;i=i;return a|0}function hC(a){a=a|0;i=i;return a|0}function iC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=wB(jC(b)|0)|0;h=hC(XB(jC(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];bC(g,a,e);i=d;return}function jC(a){a=a|0;i=i;return c[a>>2]|0}function kC(a){a=a|0;var b=0;b=i;i=i+48|0;lC(a);ez(a+184|0,0,0);ez(a+200|0,0,0);mC(a+240|0,b);mC(a+252|0,b+8|0);mC(a+264|0,b+16|0);mC(a+276|0,b+24|0);mC(a+288|0,b+32|0);mC(a+300|0,b+40|0);i=b;return}function lC(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+104|0;rP(d);e=a;c[e>>2]=103596;f=d;c[f>>2]=103616;d=a+4|0;yQ(a,103628|0,d);c[e>>2]=103596;c[f>>2]=103616;zC(d);i=b;return}function mC(a,b){a=a|0;b=b|0;b=i;nC(a,0);i=b;return}function nC(a,b){a=a|0;b=b|0;b=i;i=i+8|0;oC(a,b);i=b;return}function oC(a,b){a=a|0;b=b|0;b=i;pC(a,0);i=b;return}function pC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;qC(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;rC(f,0,e);e=Cz(b)|0;c[(BB(b)|0)>>2]=e;i=d;return}function qC(a){a=a|0;var b=0;b=i;vC(a);i=b;return}function rC(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;sC(b,c,f);i=e;return}function sC(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(uC(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;tC(d,b,f);i=e;return}function tC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(uC(e)|0)>>2];i=d;return}function uC(a){a=a|0;i=i;return a|0}function vC(a){a=a|0;var b=0;b=i;wC(a);i=b;return}function wC(a){a=a|0;var b=0;b=i;xC(a);i=b;return}function xC(a){a=a|0;var b=0;b=i;yC(a);i=b;return}function yC(a){a=a|0;c[a>>2]=0;i=i;return}function zC(a){a=a|0;var b=0;b=i;AC(a);i=b;return}function AC(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=d;AP(j);c[d>>2]=103752;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;k=d+68|0;l=d+52|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;Sz(f);f=d+98|0;l=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;b[l+28>>1]=0;a[l+30|0]=0;wP(g,j);l=BC(g)|0;cV(g);if(!l){m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=$d[r&63](d,0,4096)|0;i=e;return}wP(h,j);c[k>>2]=dB(h)|0;cV(h);a[f]=(eB(c[k>>2]|0)|0)&1;m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=$d[r&63](d,0,4096)|0;i=e;return}function BC(a){a=a|0;var b=0,c=0;b=i;c=dV(a,135536)|0;i=b;return c|0}function CC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+8|0;e=d;f=c[a+12>>2]|0;Qv(3);g=f+8|0;h=g;j=c[g>>2]|0;g=f+12|0;k=c[g>>2]|0;if((j|0)<(k|0)){DC(a,b,c[f>>2]|0,h);Tv(3);i=d;return}l=~~(+(k|0)*1.4+ +(k-j|0)+2.0e3);c[g>>2]=l;j=f+16|0;k=CY(c[f>>2]|0,fa(l<<3,c[j>>2]|0)|0)|0;l=k;c[f>>2]=l;if((k|0)==0){k=c[b+536>>2]|0;c[e>>2]=fa(c[j>>2]|0,c[g>>2]|0)|0;Pu(k,104024,e)}DC(a,b,l,h);Tv(3);i=d;return}function DC(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;j=c[b+12>>2]|0;Tv(0);k=+Lv(0);Qv(0);l=c[c[d+4>>2]>>2]|0;m=l;n=+h[m>>3];o=j+4|0;j=c[o>>2]|0;p=j+1|0;c[o>>2]=p;h[e+(j<<3)>>3]=n;if((c[b+8>>2]|0)==0){q=p}else{b=j+2|0;c[o>>2]=b;h[e+(p<<3)>>3]=k;q=b}b=d+116|0;p=c[b>>2]|0;if((p|0)>0){j=c[d+8>>2]|0;r=p;p=q;s=0;while(1){if((a[j+(s*112|0)+104|0]|0)==0){k=+h[(c[l+8>>2]|0)+(s<<3)>>3];t=p+1|0;c[o>>2]=t;h[e+(p<<3)>>3]=k;u=c[b>>2]|0;v=t}else{u=r;v=p}t=s+1|0;if((t|0)<(u|0)){r=u;p=v;s=t}else{w=v;break}}}else{w=q}q=d+124|0;v=c[q>>2]|0;if((v|0)>0){s=c[d+12>>2]|0;p=v;v=w;u=0;while(1){if((a[s+(u*60|0)+56|0]|0)==0){k=+(c[(c[l+12>>2]|0)+(u<<2)>>2]|0);r=v+1|0;c[o>>2]=r;h[e+(v<<3)>>3]=k;x=c[q>>2]|0;y=r}else{x=p;y=v}r=u+1|0;if((r|0)<(x|0)){p=x;v=y;u=r}else{z=y;break}}}else{z=w}w=d+128|0;y=c[w>>2]|0;if((y|0)>0){u=c[d+16>>2]|0;v=y;y=z;x=0;while(1){if((a[u+(x*48|0)+44|0]|0)==0){k=+(a[(c[l+16>>2]|0)+x|0]|0);p=y+1|0;c[o>>2]=p;h[e+(y<<3)>>3]=k;A=c[w>>2]|0;B=p}else{A=v;B=y}p=x+1|0;if((p|0)<(A|0)){v=A;y=B;x=p}else{C=B;break}}}else{C=z}z=d+216|0;if((c[z>>2]|0)>0){B=d+416|0;x=c[d+40>>2]|0;y=C;A=0;while(1){do{if((a[x+(A*52|0)+48|0]|0)==0){v=a[x+(A*52|0)+8|0]|0;do{if(v<<24>>24==2){D=m}else{w=c[x+(A*52|0)+4>>2]|0;if(v<<24>>24==1){D=(c[B>>2]|0)+(w<<3)|0;break}else{D=(c[l+8>>2]|0)+(w<<3)|0;break}}}while(0);k=+h[D>>3];if((c[x+(A*52|0)>>2]|0)==0){v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=k;E=v;break}else{v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=-k;E=v;break}}else{E=y}}while(0);v=A+1|0;if((v|0)<(c[z>>2]|0)){y=E;A=v}else{F=E;break}}}else{F=C}C=d+220|0;if((c[C>>2]|0)>0){E=d+40|0;A=d+420|0;y=c[d+44>>2]|0;z=F;x=0;while(1){do{if((a[y+(x*52|0)+48|0]|0)==0){D=c[(c[((a[y+(x*52|0)+8|0]|0)==1?A:l+12|0)>>2]|0)+(c[(c[E>>2]|0)+(x*52|0)+4>>2]<<2)>>2]|0;if((c[y+(x*52|0)>>2]|0)==0){B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(D|0);G=B;break}else{B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(0-D|0);G=B;break}}else{G=z}}while(0);B=x+1|0;if((B|0)<(c[C>>2]|0)){z=G;x=B}else{H=G;break}}}else{H=F}F=d+224|0;if((c[F>>2]|0)<=0){I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}G=d+44|0;x=d+40|0;z=d+424|0;C=c[d+48>>2]|0;d=H;H=0;while(1){do{if((a[C+(H*52|0)+48|0]|0)==0){y=a[(c[((a[(c[G>>2]|0)+(H*52|0)+8|0]|0)==1?z:l+16|0)>>2]|0)+(c[(c[x>>2]|0)+(H*52|0)+4>>2]|0)|0]|0;if((c[C+(H*52|0)>>2]|0)==0){E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24);K=E;break}else{E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24!=1|0);K=E;break}}else{K=d}}while(0);E=H+1|0;if((E|0)<(c[F>>2]|0)){d=K;H=E}else{break}}I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}function EC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=zY(24)|0;Qv(3);c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=g+16|0;c[j>>2]=0;k=a+4|0;l=c[k>>2]|0;c[g+12>>2]=l;m=b+536|0;Ou(c[m>>2]|0,l>>>31^1,104080,f);f=b+8|0;b=c[a+8>>2]|0;l=FC(b,f)|0;c[g+20>>2]=l;l=FC(b,f)|0;c[j>>2]=l;j=c[k>>2]|0;k=zY(fa(l<<3,j)|0)|0;c[g>>2]=k;if((k|0)==0){k=c[m>>2]|0;c[e>>2]=fa(l,j)|0;Pu(k,104160,e)}else{c[h>>2]=0;c[a+12>>2]=g;Tv(3);i=d;return}}function FC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=(b|0)==0?1:2;b=c[d+108>>2]|0;if((b|0)>0){g=c[d>>2]|0;h=0;j=f;while(1){k=((a[g+(h*112|0)+104|0]|0)==0)+j|0;l=h+1|0;if((l|0)<(b|0)){j=k;h=l}else{m=k;break}}}else{m=f}f=c[d+116>>2]|0;if((f|0)>0){h=c[d+4>>2]|0;j=0;b=m;while(1){g=((a[h+(j*60|0)+56|0]|0)==0)+b|0;k=j+1|0;if((k|0)<(f|0)){b=g;j=k}else{n=g;break}}}else{n=m}m=c[d+120>>2]|0;if((m|0)>0){j=c[d+8>>2]|0;b=0;f=n;while(1){h=((a[j+(b*48|0)+44|0]|0)==0)+f|0;g=b+1|0;if((g|0)<(m|0)){f=h;b=g}else{o=h;break}}}else{o=n}n=c[d+208>>2]|0;if((n|0)>0){b=c[d+32>>2]|0;f=0;m=o;while(1){j=((a[b+(f*52|0)+48|0]|0)==0)+m|0;h=f+1|0;if((h|0)<(n|0)){m=j;f=h}else{p=j;break}}}else{p=o}o=c[d+212>>2]|0;if((o|0)>0){f=c[d+36>>2]|0;m=0;n=p;while(1){b=((a[f+(m*52|0)+48|0]|0)==0)+n|0;j=m+1|0;if((j|0)<(o|0)){n=b;m=j}else{q=b;break}}}else{q=p}p=c[d+216>>2]|0;if((p|0)<=0){r=q;i=e;return r|0}m=c[d+40>>2]|0;d=0;n=q;while(1){q=((a[m+(d*52|0)+48|0]|0)==0)+n|0;o=d+1|0;if((o|0)<(p|0)){n=q;d=o}else{r=q;break}}i=e;return r|0}function GC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b+12|0;s=c[r>>2]|0;t=s;Qv(3);u=b;v=ec(c[u>>2]|0,104224)|0;if((v|0)==0){HC(t);w=c[d+536>>2]|0;x=c[u>>2]|0;y=Kd(c[(Ic()|0)>>2]|0)|0;c[q>>2]=x;c[q+4>>2]=y;Pu(w,104232,q)}mc(104288,46,1,v|0)|0;q=s+20|0;c[p>>2]=c[q>>2];ld(v|0,104336,p|0)|0;p=s+8|0;c[o>>2]=c[p>>2];ld(v|0,104360,o|0)|0;mc(104384,40,1,v|0)|0;mc(104432,11,1,v|0)|0;mc(104448,14,1,v|0)|0;if((c[p>>2]|0)>0){o=0;do{w=fa(c[q>>2]|0,o)|0;z=+h[(c[s>>2]|0)+(w<<3)>>3];IC(v,z,z);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Gd(10,v|0)|0;if((c[b+8>>2]|0)==0){A=1}else{mc(104464,18,1,v|0)|0;if((c[p>>2]|0)>0){b=0;do{o=fa(c[q>>2]|0,b)|0;w=c[s>>2]|0;IC(v,+h[w+(o<<3)>>3],+h[w+(o+1<<3)>>3]);b=b+1|0;}while((b|0)<(c[p>>2]|0))}Gd(10,v|0)|0;A=2}b=d+116|0;o=c[b>>2]|0;if((o|0)>0){w=d+8|0;y=o;o=0;x=A;while(1){B=c[w>>2]|0;if((a[B+(o*112|0)+104|0]|0)==0){c[n>>2]=c[B+(o*112|0)+4>>2];ld(v|0,104488,n|0)|0;if((c[p>>2]|0)>0){B=0;do{C=fa(c[q>>2]|0,B)|0;D=c[s>>2]|0;IC(v,+h[D+(C<<3)>>3],+h[D+(C+x<<3)>>3]);B=B+1|0;}while((B|0)<(c[p>>2]|0))}Gd(10,v|0)|0;E=c[b>>2]|0;F=x+1|0}else{E=y;F=x}B=o+1|0;if((B|0)<(E|0)){y=E;o=B;x=F}else{G=F;break}}}else{G=A}A=d+124|0;F=c[A>>2]|0;if((F|0)>0){x=d+12|0;o=F;F=0;E=G;while(1){y=c[x>>2]|0;if((a[y+(F*60|0)+56|0]|0)==0){c[m>>2]=c[y+(F*60|0)+4>>2];ld(v|0,104488,m|0)|0;if((c[p>>2]|0)>0){y=0;do{b=fa(c[q>>2]|0,y)|0;n=c[s>>2]|0;IC(v,+h[n+(b<<3)>>3],+h[n+(b+E<<3)>>3]);y=y+1|0;}while((y|0)<(c[p>>2]|0))}Gd(10,v|0)|0;H=c[A>>2]|0;I=E+1|0}else{H=o;I=E}y=F+1|0;if((y|0)<(H|0)){o=H;F=y;E=I}else{J=I;break}}}else{J=G}G=d+128|0;I=c[G>>2]|0;if((I|0)>0){E=d+16|0;F=I;I=0;H=J;while(1){o=c[E>>2]|0;if((a[o+(I*48|0)+44|0]|0)==0){c[l>>2]=c[o+(I*48|0)+4>>2];ld(v|0,104488,l|0)|0;if((c[p>>2]|0)>0){o=0;do{A=fa(c[q>>2]|0,o)|0;m=c[s>>2]|0;IC(v,+h[m+(A<<3)>>3],+h[m+(A+H<<3)>>3]);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Gd(10,v|0)|0;K=c[G>>2]|0;L=H+1|0}else{K=F;L=H}o=I+1|0;if((o|0)<(K|0)){F=K;I=o;H=L}else{M=L;break}}}else{M=J}J=d+216|0;L=c[J>>2]|0;if((L|0)>0){H=d+40|0;I=L;L=0;K=M;while(1){F=c[H>>2]|0;if((a[F+(L*52|0)+48|0]|0)==0){c[k>>2]=c[F+(L*52|0)+16>>2];ld(v|0,104488,k|0)|0;if((c[p>>2]|0)>0){F=0;do{G=fa(c[q>>2]|0,F)|0;l=c[s>>2]|0;IC(v,+h[l+(G<<3)>>3],+h[l+(G+K<<3)>>3]);F=F+1|0;}while((F|0)<(c[p>>2]|0))}Gd(10,v|0)|0;N=c[J>>2]|0;O=K+1|0}else{N=I;O=K}F=L+1|0;if((F|0)<(N|0)){I=N;L=F;K=O}else{P=O;break}}}else{P=M}M=d+220|0;O=c[M>>2]|0;if((O|0)>0){K=d+44|0;L=O;O=0;N=P;while(1){I=c[K>>2]|0;if((a[I+(O*52|0)+48|0]|0)==0){c[j>>2]=c[I+(O*52|0)+16>>2];ld(v|0,104488,j|0)|0;if((c[p>>2]|0)>0){I=0;do{J=fa(c[q>>2]|0,I)|0;k=c[s>>2]|0;IC(v,+h[k+(J<<3)>>3],+h[k+(J+N<<3)>>3]);I=I+1|0;}while((I|0)<(c[p>>2]|0))}Gd(10,v|0)|0;Q=c[M>>2]|0;R=N+1|0}else{Q=L;R=N}I=O+1|0;if((I|0)<(Q|0)){L=Q;O=I;N=R}else{S=R;break}}}else{S=P}P=d+224|0;R=c[P>>2]|0;if((R|0)>0){N=d+48|0;O=R;R=0;Q=S;while(1){S=c[N>>2]|0;if((a[S+(R*52|0)+48|0]|0)==0){c[g>>2]=c[S+(R*52|0)+16>>2];ld(v|0,104488,g|0)|0;if((c[p>>2]|0)>0){S=0;do{L=fa(c[q>>2]|0,S)|0;M=c[s>>2]|0;IC(v,+h[M+(L<<3)>>3],+h[M+(L+Q<<3)>>3]);S=S+1|0;}while((S|0)<(c[p>>2]|0))}Gd(10,v|0)|0;T=c[P>>2]|0;U=Q+1|0}else{T=O;U=Q}S=R+1|0;if((S|0)<(T|0)){O=T;R=S;Q=U}else{break}}}HC(t);if((Sc(v|0)|0)==0){AY(c[r>>2]|0);c[r>>2]=0;Tv(3);i=e;return}else{e=c[d+536>>2]|0;c[f>>2]=c[u>>2];Pu(e,104504,f)}}function HC(a){a=a|0;var b=0,d=0;b=i;d=a;a=c[d>>2]|0;if((a|0)==0){i=b;return}AY(a);c[d>>2]=0;i=b;return}function IC(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=f;h[k>>3]=b;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];ld(a|0,104552,f|0)|0;i=e;return}function JC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=FY(192)|0;fZ(m|0,0,192)|0;KC(m);c[a+12>>2]=m;n=m;o=a;fz(n,c[o>>2]|0,36);if(fP(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){a=c[b+536>>2]|0;c[g>>2]=c[o>>2];Pu(a,104592,g)}else{g=m;KQ(g,104568,14)|0;LQ(h,g);a=sA(h)|0;h=m+184|0;c[h>>2]=a;KQ(g,104584,4)|0;LC(n,b+8|0);LQ(j,g);b=sA(j)|0;j=m+188|0;c[j>>2]=b;m=c[h>>2]|0;ez(k,m,((m|0)<0)<<31>>31);h=f;a=k;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];MQ(g,f)|0;MC(n,-4-m+b|0);b=c[j>>2]|0;ez(l,b,((b|0)<0)<<31>>31);b=e;j=l;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];MQ(g,e)|0;Tv(3);i=d;return}}function KC(a){a=a|0;var b=0;b=i;dD(a);i=b;return}function LC(a,b){a=a|0;b=b|0;var c=0;c=i;OC(a,3);PC(a,104768);OC(a,0);PC(a,104776);OC(a,2);_C(a,b);$C(a,b);PC(a,104784);OC(a,0);i=c;return}function MC(a,b){a=a|0;b=b|0;var d=0;d=i;c[26190]=vd(b|0)|0;KQ(a,104760,4)|0;i=d;return}function NC(b,d,e,f){b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=b;LQ(l,q);r=sA(l)|0;MC(b,0);LQ(m,q);l=sA(m)|0;OC(b,1);PC(b,104656);m=e+128|0;s=e+132|0;t=e+136|0;u=e+140|0;QC(b,(c[m>>2]|0)+1+(c[s>>2]|0)+(c[t>>2]|0)+(c[u>>2]|0)|0);RC(b,d);if((c[m>>2]|0)>0){e=f+176|0;v=0;do{RC(b,+h[(c[e>>2]|0)+(v<<3)>>3]);v=v+1|0;}while((v|0)<(c[m>>2]|0))}if((c[s>>2]|0)>0){m=f+180|0;v=0;do{SC(b,c[(c[m>>2]|0)+(v<<2)>>2]|0);v=v+1|0;}while((v|0)<(c[s>>2]|0))}if((c[t>>2]|0)>0){s=f+184|0;v=0;do{TC(b,(a[(c[s>>2]|0)+v|0]|0)!=0);v=v+1|0;}while((v|0)<(c[t>>2]|0))}if((c[u>>2]|0)>0){t=f+188|0;f=0;do{PC(b,c[(c[t>>2]|0)+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(c[u>>2]|0))}LQ(n,q);u=sA(n)|0;n=cZ(0,r|0,32)|0;ez(o,n,J);n=k;r=o;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];MQ(q,k)|0;MC(b,u-l|0);ez(p,u,((u|0)<0)<<31>>31);u=j;l=p;c[u+0>>2]=c[l+0>>2];c[u+4>>2]=c[l+4>>2];c[u+8>>2]=c[l+8>>2];c[u+12>>2]=c[l+12>>2];MQ(q,j)|0;i=g;return}function OC(b,d){b=b|0;d=d|0;var e=0;e=i;a[104744]=-33;c[26188]=vd(d|0)|0;d=b;KQ(d,104744,1)|0;KQ(d,104752,4)|0;i=e;return}function PC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;c[f>>2]=vd(bZ(d|0)|0)|0;a[104736]=-37;g=b;KQ(g,104736,1)|0;KQ(g,f,4)|0;KQ(g,d,bZ(d|0)|0)|0;i=e;return}function QC(b,d){b=b|0;d=d|0;var e=0;e=i;a[104720]=-35;c[26182]=vd(d|0)|0;d=b;KQ(d,104720,1)|0;KQ(d,104728,4)|0;i=e;return}function RC(b,c){b=b|0;c=+c;var d=0,e=0;d=i;a[104704]=-53;ZC(c);e=b;KQ(e,104704,1)|0;KQ(e,104712,8)|0;i=d;return}function SC(b,d){b=b|0;d=d|0;var e=0;e=i;a[104688]=-46;c[26174]=vd(d|0)|0;d=b;KQ(d,104688,1)|0;KQ(d,104696,4)|0;i=e;return}function TC(b,c){b=b|0;c=c|0;var d=0;d=i;a[104680]=c?-61:-62;KQ(b,104680,1)|0;i=d;return}function UC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+12>>2]|0;a=b+8|0;f=b+240|0;NC(e,+h[f>>3],a,f);NC(e,+h[b+248>>3],a,f);i=d;return}function VC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=c[b+12>>2]|0;b=o;p=o;LQ(j,p);o=sA(j)|0;MC(b,0);LQ(k,p);j=sA(k)|0;OC(b,1);PC(b,104664);k=d+116|0;q=d+124|0;r=d+128|0;s=d+132|0;QC(b,(c[k>>2]|0)+1+(c[q>>2]|0)+(c[r>>2]|0)+(c[s>>2]|0)|0);t=d+4|0;RC(b,+h[c[c[t>>2]>>2]>>3]);if((c[k>>2]|0)>0){d=0;do{RC(b,+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+(d<<3)>>3]);d=d+1|0;}while((d|0)<(c[k>>2]|0))}if((c[q>>2]|0)>0){k=0;do{SC(b,c[(c[(c[c[t>>2]>>2]|0)+12>>2]|0)+(k<<2)>>2]|0);k=k+1|0;}while((k|0)<(c[q>>2]|0))}if((c[r>>2]|0)>0){q=0;do{TC(b,(a[(c[(c[c[t>>2]>>2]|0)+16>>2]|0)+q|0]|0)!=0);q=q+1|0;}while((q|0)<(c[r>>2]|0))}if((c[s>>2]|0)>0){r=0;do{PC(b,c[(c[(c[c[t>>2]>>2]|0)+20>>2]|0)+(r<<2)>>2]|0);r=r+1|0;}while((r|0)<(c[s>>2]|0))}LQ(l,p);s=sA(l)|0;l=cZ(0,o|0,32)|0;ez(m,l,J);l=g;o=m;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];MQ(p,g)|0;MC(b,s-j|0);ez(n,s,((s|0)<0)<<31>>31);s=f;j=n;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];MQ(p,f)|0;i=e;return}function WC(a,b){a=a|0;b=b|0;var d=0;b=i;d=a+12|0;a=c[d>>2]|0;_y(a);Qv(3);if((a|0)!=0){XC(a);HY(a)}c[d>>2]=0;Tv(3);i=b;return}function XC(a){a=a|0;var b=0;b=i;YC(a);i=b;return}function YC(a){a=a|0;var b=0;b=i;vA(a);i=b;return}function ZC(b){b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=d;h[e>>3]=b;if((vd(1)|0)==1){f=e;g=c[f+4>>2]|0;j=104712;c[j>>2]=c[f>>2];c[j+4>>2]=g;i=d;return}h[k>>3]=b;g=c[k>>2]&255;j=0;while(1){a[104712+(7-j)|0]=g;f=j+1|0;if((f|0)>=8){break}g=a[e+f|0]|0;j=f}i=d;return}function _C(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;PC(a,104656);OC(a,4);PC(a,104792);OC(a,0);PC(a,104800);f=b+128|0;g=b+132|0;h=b+136|0;j=b+140|0;QC(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);PC(a,104808);if((c[f>>2]|0)>0){k=b+16|0;l=0;do{PC(a,c[(c[k>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){l=b+20|0;k=0;do{PC(a,c[(c[l>>2]|0)+(k*60|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){k=b+24|0;l=0;do{PC(a,c[(c[k>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)>0){l=b+28|0;k=0;do{PC(a,c[(c[l>>2]|0)+(k*52|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[j>>2]|0))}k=e;l=104896;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];aD(a,b,e);PC(a,104832);OC(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);bD(a,104808,104840);if((c[f>>2]|0)>0){e=b+16|0;l=0;do{k=c[e>>2]|0;bD(a,c[k+(l*112|0)+4>>2]|0,c[k+(l*112|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=b+20|0;l=0;do{e=c[f>>2]|0;bD(a,c[e+(l*60|0)+4>>2]|0,c[e+(l*60|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){g=b+24|0;l=0;do{f=c[g>>2]|0;bD(a,c[f+(l*48|0)+4>>2]|0,c[f+(l*48|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)<=0){i=d;return}h=b+28|0;b=0;do{l=c[h>>2]|0;bD(a,c[l+(b*52|0)+4>>2]|0,c[l+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[j>>2]|0));i=d;return}function $C(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=b+108|0;g=c[f>>2]|0;h=b+116|0;j=c[h>>2]|0;k=b+120|0;l=c[k>>2]|0;m=b+124|0;n=c[m>>2]|0;PC(a,104664);OC(a,4);PC(a,104792);OC(a,0);PC(a,104800);o=g+1+j+l+n|0;QC(a,o);PC(a,104808);if((c[f>>2]|0)>0){n=b;l=0;do{PC(a,c[(c[n>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){l=b+4|0;n=0;do{PC(a,c[(c[l>>2]|0)+(n*60|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){n=b+8|0;l=0;do{PC(a,c[(c[n>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[k>>2]|0))}if((c[m>>2]|0)>0){l=b+12|0;n=0;do{PC(a,c[(c[l>>2]|0)+(n*52|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[m>>2]|0))}n=e;l=104816;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];aD(a,b,e);PC(a,104832);OC(a,o);bD(a,104808,104840);if((c[f>>2]|0)>0){o=b;e=0;do{l=c[o>>2]|0;bD(a,c[l+(e*112|0)+4>>2]|0,c[l+(e*112|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){f=b+4|0;e=0;do{o=c[f>>2]|0;bD(a,c[o+(e*60|0)+4>>2]|0,c[o+(e*60|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){h=b+8|0;e=0;do{f=c[h>>2]|0;bD(a,c[f+(e*48|0)+4>>2]|0,c[f+(e*48|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[k>>2]|0))}if((c[m>>2]|0)<=0){i=d;return}k=b+12|0;b=0;do{e=c[k>>2]|0;bD(a,c[e+(b*52|0)+4>>2]|0,c[e+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[m>>2]|0));i=d;return}function aD(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;PC(b,104864);g=d+208|0;h=c[g>>2]|0;if((h|0)>0){j=c[d+32>>2]|0;k=0;l=0;while(1){m=(c[e+(a[j+(k*52|0)+8|0]<<2)>>2]|0)+l|0;n=k+1|0;if((n|0)<(h|0)){l=m;k=n}else{o=m;break}}}else{o=0}k=d+212|0;l=c[k>>2]|0;if((l|0)>0){h=c[d+36>>2]|0;j=0;m=o;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{q=n;break}}}else{q=o}o=d+216|0;j=c[o>>2]|0;if((j|0)>0){m=c[d+40>>2]|0;l=0;h=q;while(1){n=(c[e+(a[m+(l*52|0)+8|0]<<2)>>2]|0)+h|0;p=l+1|0;if((p|0)<(j|0)){h=n;l=p}else{r=n;break}}}else{r=q}q=d+220|0;l=c[q>>2]|0;if((l|0)>0){h=c[d+44>>2]|0;j=0;m=r;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{s=n;break}}}else{s=r}OC(b,s);s=c[g>>2]|0;if((s|0)>0){r=d+32|0;j=d+16|0;m=d;l=s;s=0;h=0;while(1){n=c[r>>2]|0;p=a[n+(s*52|0)+8|0]|0;if((c[e+(p<<24>>24<<2)>>2]|0)==0){t=l;u=h}else{v=p<<24>>24==2?104808:h;if(p<<24>>24==1){w=c[(c[j>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else if(p<<24>>24==0){w=c[(c[m>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else{w=v}cD(b,c[n+(s*52|0)+16>>2]|0,w,(c[n+(s*52|0)>>2]|0)!=0);t=c[g>>2]|0;u=w}n=s+1|0;if((n|0)<(t|0)){l=t;s=n;h=u}else{x=u;break}}}else{x=0}u=c[k>>2]|0;if((u|0)>0){h=d+36|0;s=d+20|0;t=d+4|0;l=u;u=0;w=x;while(1){g=c[h>>2]|0;m=a[g+(u*52|0)+8|0]|0;if((c[e+(m<<24>>24<<2)>>2]|0)==0){y=l;z=w}else{j=m<<24>>24==2?104808:w;if(m<<24>>24==1){A=c[(c[s>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else if(m<<24>>24==0){A=c[(c[t>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else{A=j}cD(b,c[g+(u*52|0)+16>>2]|0,A,(c[g+(u*52|0)>>2]|0)!=0);y=c[k>>2]|0;z=A}g=u+1|0;if((g|0)<(y|0)){l=y;u=g;w=z}else{B=z;break}}}else{B=x}x=c[o>>2]|0;if((x|0)>0){z=d+40|0;w=d+24|0;u=d+8|0;y=x;x=0;l=B;while(1){A=c[z>>2]|0;k=a[A+(x*52|0)+8|0]|0;if((c[e+(k<<24>>24<<2)>>2]|0)==0){C=y;D=l}else{t=k<<24>>24==2?104808:l;if(k<<24>>24==0){E=c[(c[u>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else if(k<<24>>24==1){E=c[(c[w>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else{E=t}cD(b,c[A+(x*52|0)+16>>2]|0,E,(c[A+(x*52|0)>>2]|0)!=0);C=c[o>>2]|0;D=E}A=x+1|0;if((A|0)<(C|0)){y=C;x=A;l=D}else{F=D;break}}}else{F=B}B=c[q>>2]|0;if((B|0)<=0){i=f;return}D=d+44|0;l=d+28|0;x=d+12|0;d=B;B=0;C=F;while(1){F=c[D>>2]|0;y=a[F+(B*52|0)+8|0]|0;if((c[e+(y<<24>>24<<2)>>2]|0)==0){G=d;H=C}else{E=y<<24>>24==2?104808:C;if(y<<24>>24==0){I=c[(c[x>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else if(y<<24>>24==1){I=c[(c[l>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else{I=E}cD(b,c[F+(B*52|0)+16>>2]|0,I,(c[F+(B*52|0)>>2]|0)!=0);G=c[q>>2]|0;H=I}F=B+1|0;if((F|0)<(G|0)){d=G;B=F;C=H}else{break}}i=f;return}function bD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;PC(a,b);OC(a,1);PC(a,104848);PC(a,c);i=d;return}function cD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;PC(a,b);OC(a,d?2:1);PC(a,104872);PC(a,c);if(!d){i=e;return}PC(a,104880);PC(a,104888);i=e;return}function dD(a){a=a|0;var b=0;b=i;lC(a);i=b;return}function eD(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=i;i=i+288|0;d=c;e=c+16|0;f=c+32|0;g=c+48|0;h=c+64|0;j=c+80|0;k=c+96|0;l=c+112|0;m=c+128|0;n=c+144|0;o=c+160|0;p=c+176|0;q=c+192|0;r=c+208|0;s=c+224|0;t=c+240|0;u=c+256|0;v=c+272|0;oO(e,104912);kO(d,gD(a,e)|0);fD(d,b+4|0);uO(d);uO(e);oO(g,104920);kO(f,gD(a,g)|0);hD(f,b);uO(f);uO(g);oO(j,104936);kO(h,gD(a,j)|0);fD(h,b+8|0);uO(h);uO(j);oO(l,104952);kO(k,gD(a,l)|0);fD(k,b+12|0);uO(k);uO(l);oO(n,104968);kO(m,gD(a,n)|0);iD(m,b+16|0,0);uO(m);uO(n);oO(p,104984);kO(o,gD(a,p)|0);iD(o,b+20|0,0);uO(o);uO(p);oO(r,105e3);kO(q,gD(a,r)|0);iD(q,b+24|0,0);uO(q);uO(r);oO(t,105008);kO(s,gD(a,t)|0);iD(s,b+28|0,0);uO(s);uO(t);oO(v,105024);kO(u,gD(a,v)|0);iD(u,b+32|0,0);uO(u);uO(v);i=c;return}function fD(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;if((b|0)==0){Nu(22,0,108232,d);i=d;return}else{c[b>>2]=od(RO(a)|0)|0;i=d;return}}function gD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=pH(a,f,b)|0;l=c[k>>2]|0;Sz(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}rH(j,a,b);sH(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];qH(g,e);tH(j);j=c[f>>2]|0;uH(a,j,k,vH(g)|0);k=wH(g)|0;tH(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function hD(a,b){a=a|0;b=b|0;var d=0;d=i;if((UO(a,105200)|0)==0){c[b>>2]=1;i=d;return}if((UO(a,105208)|0)==0){c[b>>2]=0;i=d;return}else{c[b>>2]=Ac(RO(a)|0)|0;i=d;return}}function iD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((UO(a,105176)|0)==0){c[b>>2]=d}if((UO(a,105200)|0)==0){c[b>>2]=1;i=e;return}if((UO(a,105208)|0)==0){c[b>>2]=0;i=e;return}else{c[b>>2]=Ac(RO(a)|0)|0;i=e;return}}function jD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;e=i;i=i+56|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;oO(j,105040);kO(g,gD(b,j)|0);y=d+48|0;kD(g,y);uO(g);uO(j);oO(m,105056);kO(l,gD(b,m)|0);j=d+56|0;lD(l,j,0.0);uO(l);uO(m);oO(o,105064);kO(n,gD(b,o)|0);m=d+32|0;kD(n,m);uO(n);uO(o);oO(q,105072);kO(p,gD(b,q)|0);o=d+33|0;kD(p,o);uO(p);uO(q);oO(s,105088);kO(r,gD(b,s)|0);q=d+40|0;lD(r,q,1.0);uO(r);uO(s);oO(u,105096);kO(t,gD(b,u)|0);s=d+16|0;lD(t,s,-1.7976931348623157e+308);uO(t);uO(u);oO(w,105104);kO(v,gD(b,w)|0);u=d+24|0;lD(v,u,1.7976931348623157e+308);uO(v);uO(w);oO(x,104912);w=RO(gD(b,x)|0)|0;b=(a[y]|0)!=0;z=+h[j>>3];j=(a[m]|0)!=0?105200:105208;m=(a[o]|0)!=0;A=+h[q>>3];B=+h[s>>3];C=+h[u>>3];c[f>>2]=w;c[f+4>>2]=b?105176:105184;w=f+8|0;h[k>>3]=z;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[f+16>>2]=b?105176:105192;c[f+20>>2]=j;c[f+24>>2]=m?105176:105184;j=f+28|0;h[k>>3]=A;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[f+36>>2]=m?105176:105192;m=f+40|0;h[k>>3]=B;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=f+48|0;h[k>>3]=C;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];Lu(4,0,105112,f);uO(x);i=e;return}function kD(b,c){b=b|0;c=c|0;var d=0;d=i;a[c]=(UO(b,105200)|0)==0|0;i=d;return}function lD(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;if((UO(a,105176)|0)==0){h[b>>3]=c;i=d;return}if((UO(a,105200)|0)==0){h[b>>3]=1.0;i=d;return}if((UO(a,105208)|0)==0){h[b>>3]=0.0;i=d;return}else{h[b>>3]=+VY(RO(a)|0);i=d;return}}function mD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;oO(h,105040);kO(g,gD(b,h)|0);s=d+13|0;kD(g,s);uO(g);uO(h);oO(k,105056);kO(j,gD(b,k)|0);h=d+16|0;iD(j,h,0);uO(j);uO(k);oO(m,105064);kO(l,gD(b,m)|0);k=d+12|0;kD(l,k);uO(l);uO(m);oO(o,105096);kO(n,gD(b,o)|0);m=d+4|0;iD(n,m,-2147483648);uO(n);uO(o);oO(q,105104);kO(p,gD(b,q)|0);o=d+8|0;iD(p,o,2147483647);uO(p);uO(q);oO(r,104912);q=RO(gD(b,r)|0)|0;b=(a[s]|0)!=0;s=c[h>>2]|0;h=(a[k]|0)!=0?105200:105208;k=c[m>>2]|0;m=c[o>>2]|0;c[f>>2]=q;c[f+4>>2]=b?105176:105184;c[f+8>>2]=s;c[f+12>>2]=b?105176:105192;c[f+16>>2]=h;c[f+20>>2]=k;c[f+24>>2]=m;Lu(4,0,105216,f);uO(r);i=e;return}function nD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;oO(h,105040);kO(g,gD(b,h)|0);o=d+5|0;kD(g,o);uO(g);uO(h);oO(k,105056);kO(j,gD(b,k)|0);h=d+6|0;kD(j,h);uO(j);uO(k);oO(m,105064);kO(l,gD(b,m)|0);k=d+4|0;kD(l,k);uO(l);uO(m);oO(n,104912);m=RO(gD(b,n)|0)|0;b=(a[o]|0)!=0;o=(a[h]|0)!=0?105200:105208;h=(a[k]|0)!=0?105200:105208;c[f>>2]=m;c[f+4>>2]=b?105176:105184;c[f+8>>2]=o;c[f+12>>2]=b?105176:105192;c[f+16>>2]=h;Lu(4,0,105272,f);uO(n);i=e;return}function oD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;oO(h,105040);kO(g,gD(b,h)|0);m=d+4|0;kD(g,m);uO(g);uO(h);oO(k,105056);kO(j,gD(b,k)|0);h=d+8|0;fD(j,h);uO(j);uO(k);oO(l,104912);k=RO(gD(b,l)|0)|0;b=(a[m]|0)!=0;m=c[h>>2]|0;c[f>>2]=k;c[f+4>>2]=b?105176:105184;c[f+8>>2]=m;c[f+12>>2]=b?105176:105192;Lu(4,0,105312,f);uO(l);i=e;return}



function Mh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+416|0;if((Dx(+h[(c[e>>2]|0)+136>>3],0.0)|0)<<24>>24==0){f=(c[b+404>>2]|0)+288|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+244|0;u=t;c[u>>2]=g;i=d;return}do{if((a[b+314|0]|0)==0){v=a[(c[b+356>>2]|0)+7|0]|0}else{w=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(w){x=a[(c[b+356>>2]|0)+7|0]|0;y=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+136>>3],a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=y;v=x;break}else{x=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+136>>3],a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=x;v=x;break}}else{if(w){w=a[(c[b+356>>2]|0)+7|0]|0;x=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+136>>3])|0;a[(c[b+352>>2]|0)+7|0]=x;v=w;break}else{w=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+136>>3])|0;a[(c[b+352>>2]|0)+7|0]=w;v=w;break}}}}while(0);if(v<<24>>24==0){f=(c[b+420>>2]|0)+188|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+244|0;u=t;c[u>>2]=g;i=d;return}else{f=(c[(c[c[b+4>>2]>>2]|0)+12>>2]|0)+236|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+244|0;u=t;c[u>>2]=g;i=d;return}}function Nh(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+252>>2]=c[(c[a+404>>2]|0)+268>>2];i=i;return}function Oh(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12960,(c[a+252>>2]|0)+ -1|0,(c[a+244>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+240>>2]=e;i=b;return}function Ph(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(12976,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+240>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+248>>2]=a;i=b;return}function Qh(a){a=a|0;var b=0,d=0;b=i;d=Qu(12944,(Fx(+(c[(c[a+404>>2]|0)+256>>2]|0),6,a)|0)+ -1|0)|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+216>>2]=d;i=b;return}function Rh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+416|0;if((Dx(+h[(c[e>>2]|0)+152>>3],0.0)|0)<<24>>24==0){f=(c[b+404>>2]|0)+256|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+224|0;u=t;c[u>>2]=g;i=d;return}do{if((a[b+314|0]|0)==0){v=a[(c[b+356>>2]|0)+6|0]|0}else{w=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(w){x=a[(c[b+356>>2]|0)+6|0]|0;y=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+152>>3],a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=y;v=x;break}else{x=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+152>>3],a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=x;v=x;break}}else{if(w){w=a[(c[b+356>>2]|0)+6|0]|0;x=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+152>>3])|0;a[(c[b+352>>2]|0)+6|0]=x;v=w;break}else{w=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+152>>3])|0;a[(c[b+352>>2]|0)+6|0]=w;v=w;break}}}}while(0);if(v<<24>>24==0){f=(c[b+420>>2]|0)+204|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+224|0;u=t;c[u>>2]=g;i=d;return}else{f=(c[(c[c[b+4>>2]>>2]|0)+12>>2]|0)+216|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+224|0;u=t;c[u>>2]=g;i=d;return}}function Sh(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+232>>2]=c[(c[a+404>>2]|0)+316>>2];i=i;return}function Th(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12960,(c[a+232>>2]|0)+ -1|0,(c[a+224>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+220>>2]=e;i=b;return}function Uh(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(12976,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+220>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+228>>2]=a;i=b;return}function Vh(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+104>>2]=c[b+220>>2];i=i;return}function Wh(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+124>>2]=c[b+104>>2];i=i;return}function Xh(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+136>>2]=c[b+124>>2];i=i;return}function Yh(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+140>>2]=c[b+104>>2];i=i;return}function Zh(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+152>>2]=c[b+140>>2];i=i;return}function _h(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+80>>3]=+h[b+192>>3];i=i;return}function $h(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+88>>3]=+h[b+80>>3];i=i;return}function ai(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+96>>3]=+h[b+88>>3];i=i;return}function bi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+104>>3]=+h[b+80>>3];i=i;return}function ci(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+112>>3]=+h[b+104>>3];i=i;return}function di(a){a=a|0;c[(c[a+404>>2]|0)+356>>2]=1;i=i;return}function ei(a){a=a|0;c[(c[a+404>>2]|0)+328>>2]=1;i=i;return}function fi(a){a=a|0;c[(c[a+404>>2]|0)+196>>2]=1;i=i;return}function gi(a){a=a|0;c[(c[a+404>>2]|0)+184>>2]=1;i=i;return}function hi(a){a=a|0;var b=0,d=0;b=i;d=Qu(12944,(Fx(+(c[(c[a+404>>2]|0)+328>>2]|0),5,a)|0)+ -1|0)|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+164>>2]=d;i=b;return}function ii(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+416|0;if((Dx(+h[(c[e>>2]|0)+96>>3],0.0)|0)<<24>>24==0){f=(c[b+404>>2]|0)+328|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+172|0;u=t;c[u>>2]=g;i=d;return}do{if((a[b+314|0]|0)==0){v=a[(c[b+356>>2]|0)+5|0]|0}else{w=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(w){x=a[(c[b+356>>2]|0)+5|0]|0;y=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+96>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=y;v=x;break}else{x=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+96>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=x;v=x;break}}else{if(w){w=a[(c[b+356>>2]|0)+5|0]|0;x=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+96>>3])|0;a[(c[b+352>>2]|0)+5|0]=x;v=w;break}else{w=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+96>>3])|0;a[(c[b+352>>2]|0)+5|0]=w;v=w;break}}}}while(0);if(v<<24>>24==0){f=(c[b+420>>2]|0)+136|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+172|0;u=t;c[u>>2]=g;i=d;return}else{f=(c[(c[c[b+4>>2]>>2]|0)+12>>2]|0)+164|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+172|0;u=t;c[u>>2]=g;i=d;return}}function ji(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+180>>2]=c[(c[a+404>>2]|0)+196>>2];i=i;return}function ki(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12960,(c[a+180>>2]|0)+ -1|0,(c[a+172>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+168>>2]=e;i=b;return}function li(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(12976,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+168>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+176>>2]=a;i=b;return}function mi(a){a=a|0;var b=0,d=0;b=i;d=Qu(12944,(Fx(+(c[(c[a+404>>2]|0)+184>>2]|0),4,a)|0)+ -1|0)|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+144>>2]=d;i=b;return}function ni(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+416|0;if((Dx(+h[(c[e>>2]|0)+112>>3],0.0)|0)<<24>>24==0){f=(c[b+404>>2]|0)+184|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+152|0;u=t;c[u>>2]=g;i=d;return}do{if((a[b+314|0]|0)==0){v=a[(c[b+356>>2]|0)+4|0]|0}else{w=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(w){x=a[(c[b+356>>2]|0)+4|0]|0;y=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+112>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=y;v=x;break}else{x=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+112>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=x;v=x;break}}else{if(w){w=a[(c[b+356>>2]|0)+4|0]|0;x=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+112>>3])|0;a[(c[b+352>>2]|0)+4|0]=x;v=w;break}else{w=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+112>>3])|0;a[(c[b+352>>2]|0)+4|0]=w;v=w;break}}}}while(0);if(v<<24>>24==0){f=(c[b+420>>2]|0)+152|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+152|0;u=t;c[u>>2]=g;i=d;return}else{f=(c[(c[c[b+4>>2]>>2]|0)+12>>2]|0)+144|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+152|0;u=t;c[u>>2]=g;i=d;return}}function oi(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+160>>2]=c[(c[a+404>>2]|0)+356>>2];i=i;return}function pi(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12960,(c[a+160>>2]|0)+ -1|0,(c[a+152>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+148>>2]=e;i=b;return}function qi(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(12976,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+148>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+156>>2]=a;i=b;return}function ri(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+52>>2]=c[b+220>>2];i=i;return}function si(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+72>>2]=c[b+52>>2];i=i;return}function ti(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+84>>2]=c[b+72>>2];i=i;return}function ui(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+88>>2]=c[b+52>>2];i=i;return}function vi(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+100>>2]=c[b+88>>2];i=i;return}function wi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40>>3]=+h[b+192>>3];i=i;return}function xi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+48>>3]=+h[b+40>>3];i=i;return}function yi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+56>>3]=+h[b+48>>3];i=i;return}function zi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+64>>3]=+h[b+40>>3];i=i;return}function Ai(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+72>>3]=+h[b+64>>3];i=i;return}function Bi(a){a=a|0;c[(c[a+404>>2]|0)+396>>2]=1;i=i;return}function Ci(a){a=a|0;c[(c[a+404>>2]|0)+368>>2]=1;i=i;return}function Di(a){a=a|0;c[(c[a+404>>2]|0)+124>>2]=1;i=i;return}function Ei(a){a=a|0;c[(c[a+404>>2]|0)+112>>2]=1;i=i;return}function Fi(a){a=a|0;var b=0,d=0;b=i;d=Qu(12944,(Fx(+(c[(c[a+404>>2]|0)+368>>2]|0),3,a)|0)+ -1|0)|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+92>>2]=d;i=b;return}function Gi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+416|0;if((Dx(+h[(c[e>>2]|0)+56>>3],0.0)|0)<<24>>24==0){f=(c[b+404>>2]|0)+368|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+100|0;u=t;c[u>>2]=g;i=d;return}do{if((a[b+314|0]|0)==0){v=a[(c[b+356>>2]|0)+3|0]|0}else{w=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(w){x=a[(c[b+356>>2]|0)+3|0]|0;y=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+56>>3],a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=y;v=x;break}else{x=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+56>>3],a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=x;v=x;break}}else{if(w){w=a[(c[b+356>>2]|0)+3|0]|0;x=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+56>>3])|0;a[(c[b+352>>2]|0)+3|0]=x;v=w;break}else{w=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+56>>3])|0;a[(c[b+352>>2]|0)+3|0]=w;v=w;break}}}}while(0);if(v<<24>>24==0){f=(c[b+420>>2]|0)+84|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+100|0;u=t;c[u>>2]=g;i=d;return}else{f=(c[(c[c[b+4>>2]>>2]|0)+12>>2]|0)+92|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+100|0;u=t;c[u>>2]=g;i=d;return}}function Hi(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+108>>2]=c[(c[a+404>>2]|0)+124>>2];i=i;return}function Ii(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12960,(c[a+108>>2]|0)+ -1|0,(c[a+100>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+96>>2]=e;i=b;return}function Ji(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(12976,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+96>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+104>>2]=a;i=b;return}function Ki(a){a=a|0;var b=0,d=0;b=i;d=Qu(12944,(Fx(+(c[(c[a+404>>2]|0)+112>>2]|0),2,a)|0)+ -1|0)|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+72>>2]=d;i=b;return}function Li(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+416|0;if((Dx(+h[(c[e>>2]|0)+72>>3],0.0)|0)<<24>>24==0){f=(c[b+404>>2]|0)+112|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+80|0;u=t;c[u>>2]=g;i=d;return}do{if((a[b+314|0]|0)==0){v=a[(c[b+356>>2]|0)+2|0]|0}else{w=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(w){x=a[(c[b+356>>2]|0)+2|0]|0;y=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+72>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=y;v=x;break}else{x=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+72>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=x;v=x;break}}else{if(w){w=a[(c[b+356>>2]|0)+2|0]|0;x=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+72>>3])|0;a[(c[b+352>>2]|0)+2|0]=x;v=w;break}else{w=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+72>>3])|0;a[(c[b+352>>2]|0)+2|0]=w;v=w;break}}}}while(0);if(v<<24>>24==0){f=(c[b+420>>2]|0)+100|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+80|0;u=t;c[u>>2]=g;i=d;return}else{f=(c[(c[c[b+4>>2]>>2]|0)+12>>2]|0)+72|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+80|0;u=t;c[u>>2]=g;i=d;return}}function Mi(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+88>>2]=c[(c[a+404>>2]|0)+396>>2];i=i;return}function Ni(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12960,(c[a+88>>2]|0)+ -1|0,(c[a+80>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+76>>2]=e;i=b;return}function Oi(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(12976,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+76>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+84>>2]=a;i=b;return}function Pi(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b>>2]=c[b+220>>2];i=i;return}function Qi(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+20>>2]=c[b>>2];i=i;return}function Ri(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+32>>2]=c[b+20>>2];i=i;return}function Si(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+36>>2]=c[b>>2];i=i;return}function Ti(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+48>>2]=c[b+36>>2];i=i;return}function Ui(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b>>3]=+h[b+192>>3];i=i;return}function Vi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8>>3]=+h[b>>3];i=i;return}function Wi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16>>3]=+h[b+8>>3];i=i;return}function Xi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24>>3]=+h[b>>3];i=i;return}function Yi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32>>3]=+h[b+24>>3];i=i;return}function Zi(a){a=a|0;c[(c[a+404>>2]|0)+436>>2]=1;i=i;return}function _i(a){a=a|0;c[(c[a+404>>2]|0)+408>>2]=1;i=i;return}function $i(a){a=a|0;c[(c[a+404>>2]|0)+52>>2]=1;i=i;return}function aj(a){a=a|0;c[(c[a+404>>2]|0)+40>>2]=1;i=i;return}function bj(a){a=a|0;var b=0,d=0;b=i;d=Qu(12944,(Fx(+(c[(c[a+404>>2]|0)+408>>2]|0),1,a)|0)+ -1|0)|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+20>>2]=d;i=b;return}function cj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+416|0;if((Dx(+h[(c[e>>2]|0)+16>>3],0.0)|0)<<24>>24==0){f=(c[b+404>>2]|0)+408|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+28|0;u=t;c[u>>2]=g;i=d;return}do{if((a[b+314|0]|0)==0){v=a[(c[b+356>>2]|0)+1|0]|0}else{w=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(w){x=a[(c[b+356>>2]|0)+1|0]|0;y=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+16>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=y;v=x;break}else{x=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+16>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=x;v=x;break}}else{if(w){w=a[(c[b+356>>2]|0)+1|0]|0;x=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+16>>3])|0;a[(c[b+352>>2]|0)+1|0]=x;v=w;break}else{w=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+16>>3])|0;a[(c[b+352>>2]|0)+1|0]=w;v=w;break}}}}while(0);if(v<<24>>24==0){f=(c[b+420>>2]|0)+32|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+28|0;u=t;c[u>>2]=g;i=d;return}else{f=(c[(c[c[b+4>>2]>>2]|0)+12>>2]|0)+20|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+28|0;u=t;c[u>>2]=g;i=d;return}}function dj(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+36>>2]=c[(c[a+404>>2]|0)+52>>2];i=i;return}function ej(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12960,(c[a+36>>2]|0)+ -1|0,(c[a+28>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+24>>2]=e;i=b;return}function fj(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(12976,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+24>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+32>>2]=a;i=b;return}function gj(a){a=a|0;var b=0,d=0;b=i;d=Qu(12944,(Fx(+(c[(c[a+404>>2]|0)+40>>2]|0),0,a)|0)+ -1|0)|0;c[c[(c[c[a+4>>2]>>2]|0)+12>>2]>>2]=d;i=b;return}function hj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+416|0;if((Dx(+h[(c[e>>2]|0)+32>>3],0.0)|0)<<24>>24==0){f=(c[b+404>>2]|0)+40|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+8|0;u=t;c[u>>2]=g;i=d;return}do{if((a[b+314|0]|0)==0){v=a[c[b+356>>2]|0]|0}else{w=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(w){x=a[c[b+356>>2]|0]|0;y=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+32>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=y;v=x;break}else{x=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+32>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=x;v=x;break}}else{if(w){w=a[c[b+356>>2]|0]|0;x=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+32>>3])|0;a[c[b+352>>2]|0]=x;v=w;break}else{w=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[e>>2]|0)+32>>3])|0;a[c[b+352>>2]|0]=w;v=w;break}}}}while(0);if(v<<24>>24==0){f=(c[b+420>>2]|0)+48|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+8|0;u=t;c[u>>2]=g;i=d;return}else{f=c[(c[c[b+4>>2]>>2]|0)+12>>2]|0;g=c[f>>2]|0;j=b;k=j+4|0;l=k;m=c[l>>2]|0;n=c[m>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=r;t=s+8|0;u=t;c[u>>2]=g;i=d;return}}function ij(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+16>>2]=c[(c[a+404>>2]|0)+436>>2];i=i;return}function jj(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12960,(c[a+16>>2]|0)+ -1|0,(c[a+8>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+4>>2]=e;i=b;return}function kj(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(12976,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+4>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+12>>2]=a;i=b;return}function lj(a){a=a|0;h[(c[a+400>>2]|0)+48>>3]=+h[(c[a+8>>2]|0)+768>>3];i=i;return}function mj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+56>>3]=+h[b+176>>3]*+h[b+184>>3]*.01;i=i;return}function nj(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+48>>3]=+h[(c[a+400>>2]|0)+48>>3];i=i;return}function oj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+4|0;f=Ex(+h[c[c[e>>2]>>2]>>3],+h[(c[b+416>>2]|0)+168>>3])|0;do{if((a[b+314|0]|0)==0){g=a[(c[b+356>>2]|0)+9|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){k=a[(c[b+356>>2]|0)+9|0]|0;l=c[c[e>>2]>>2]|0;m=c[l+8>>2]|0;n=Bx(+h[l>>3],+h[m+48>>3]+ +h[m+56>>3],a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=n;g=k;break}else{k=c[c[e>>2]>>2]|0;n=c[k+8>>2]|0;m=Bx(+h[k>>3],+h[n+48>>3]+ +h[n+56>>3],a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=m;g=m;break}}else{if(j){j=a[(c[b+356>>2]|0)+9|0]|0;m=c[c[e>>2]>>2]|0;n=c[m+8>>2]|0;k=Ex(+h[m>>3],+h[n+48>>3]+ +h[n+56>>3])|0;a[(c[b+352>>2]|0)+9|0]=k;g=j;break}else{j=c[c[e>>2]>>2]|0;k=c[j+8>>2]|0;n=Ex(+h[j>>3],+h[k+48>>3]+ +h[k+56>>3])|0;a[(c[b+352>>2]|0)+9|0]=n;g=n;break}}}}while(0);if(f<<24>>24==0){o=3;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+452|0;x=w;c[x>>2]=o;i=d;return}o=g<<24>>24!=0?3:4;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+12|0;t=s;u=c[t>>2]|0;v=u;w=v+452|0;x=w;c[x>>2]=o;i=d;return}function pj(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(12976,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+452>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+420>>2]=a;i=b;return}function qj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;do{if((a[b+314|0]|0)==0){e=a[(c[b+356>>2]|0)+10|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){g=a[(c[b+356>>2]|0)+10|0]|0;j=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+160>>3],a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=j;e=g;break}else{g=Bx(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+160>>3],a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=g;e=g;break}}else{if(f){f=a[(c[b+356>>2]|0)+10|0]|0;g=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+160>>3])|0;a[(c[b+352>>2]|0)+10|0]=g;e=f;break}else{f=Ex(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+160>>3])|0;a[(c[b+352>>2]|0)+10|0]=f;e=f;break}}}}while(0);f=c[b+420>>2]|0;if(e<<24>>24==0){c[(c[(c[c[b+4>>2]>>2]|0)+12>>2]|0)+448>>2]=c[f+208>>2];i=d;return}else{c[(c[(c[c[b+4>>2]>>2]|0)+12>>2]|0)+448>>2]=c[f+212>>2];i=d;return}}function rj(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+452>>2]|0)+ -1|0,(c[a+448>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+440>>2]=e;i=b;return}function sj(a){a=a|0;c[(c[a+404>>2]|0)+416>>2]=1;i=i;return}function tj(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+408>>2]=c[(c[a+404>>2]|0)+416>>2];i=i;return}function uj(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+440>>2]|0)+ -1|0,(c[a+408>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+444>>2]=e;i=b;return}function vj(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+408>>2]|0)+ -1|0,(c[a+448>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+400>>2]=e;i=b;return}function wj(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(12976,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+408>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+380>>2]=a;i=b;return}function xj(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[c[a+4>>2]>>2]|0;d=c[(c[b+12>>2]|0)+408>>2]|0;a:do{switch(d|0){case 6:{e=(c[a+416>>2]|0)+240|0;break};case 7:{e=(c[a+416>>2]|0)+248|0;break};case 2:{e=(c[a+416>>2]|0)+208|0;break};case 3:{e=(c[a+416>>2]|0)+216|0;break};case 4:{e=(c[a+416>>2]|0)+224|0;break};case 5:{e=(c[a+416>>2]|0)+232|0;break};case 1:{e=(c[a+416>>2]|0)+200|0;break};default:{f=c[a+416>>2]|0;if((d|0)==8){e=f+256|0;break a}else{e=f+264|0;break a}}}}while(0);h[(c[b+8>>2]|0)+40>>3]=+h[e>>3];i=i;return}function yj(a){a=a|0;c[(c[a+404>>2]|0)+376>>2]=1;i=i;return}function zj(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+368>>2]=c[(c[a+404>>2]|0)+376>>2];i=i;return}function Aj(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+400>>2]|0)+ -1|0,(c[a+368>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+404>>2]=e;i=b;return}function Bj(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+368>>2]|0)+ -1|0,(c[a+448>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+360>>2]=e;i=b;return}function Cj(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(12976,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+368>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+340>>2]=a;i=b;return}function Dj(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[c[a+4>>2]>>2]|0;d=c[(c[b+12>>2]|0)+368>>2]|0;a:do{switch(d|0){case 6:{e=(c[a+416>>2]|0)+312|0;break};case 7:{e=(c[a+416>>2]|0)+320|0;break};case 2:{e=(c[a+416>>2]|0)+280|0;break};case 3:{e=(c[a+416>>2]|0)+288|0;break};case 4:{e=(c[a+416>>2]|0)+296|0;break};case 5:{e=(c[a+416>>2]|0)+304|0;break};case 1:{e=(c[a+416>>2]|0)+272|0;break};default:{f=c[a+416>>2]|0;if((d|0)==8){e=f+328|0;break a}else{e=f+336|0;break a}}}}while(0);h[(c[b+8>>2]|0)+32>>3]=+h[e>>3];i=i;return}function Ej(a){a=a|0;c[(c[a+404>>2]|0)+336>>2]=1;i=i;return}function Fj(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+328>>2]=c[(c[a+404>>2]|0)+336>>2];i=i;return}function Gj(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+360>>2]|0)+ -1|0,(c[a+328>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+364>>2]=e;i=b;return}function Hj(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+328>>2]|0)+ -1|0,(c[a+448>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+320>>2]=e;i=b;return}function Ij(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(12976,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+328>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+300>>2]=a;i=b;return}function Jj(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[c[a+4>>2]>>2]|0;d=c[(c[b+12>>2]|0)+328>>2]|0;a:do{switch(d|0){case 6:{e=(c[a+416>>2]|0)+384|0;break};case 7:{e=(c[a+416>>2]|0)+392|0;break};case 2:{e=(c[a+416>>2]|0)+352|0;break};case 3:{e=(c[a+416>>2]|0)+360|0;break};case 4:{e=(c[a+416>>2]|0)+368|0;break};case 5:{e=(c[a+416>>2]|0)+376|0;break};case 1:{e=(c[a+416>>2]|0)+344|0;break};default:{f=c[a+416>>2]|0;if((d|0)==8){e=f+400|0;break a}else{e=f+408|0;break a}}}}while(0);h[(c[b+8>>2]|0)+24>>3]=+h[e>>3];i=i;return}function Kj(a){a=a|0;c[(c[a+404>>2]|0)+296>>2]=1;i=i;return}function Lj(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+288>>2]=c[(c[a+404>>2]|0)+296>>2];i=i;return}function Mj(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+320>>2]|0)+ -1|0,(c[a+288>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+324>>2]=e;i=b;return}function Nj(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[c[a+4>>2]>>2]|0;d=c[(c[b+12>>2]|0)+288>>2]|0;a:do{switch(d|0){case 6:{e=(c[a+416>>2]|0)+456|0;break};case 7:{e=(c[a+416>>2]|0)+464|0;break};case 1:{e=(c[a+416>>2]|0)+416|0;break};case 3:{e=(c[a+416>>2]|0)+432|0;break};case 4:{e=(c[a+416>>2]|0)+440|0;break};case 5:{e=(c[a+416>>2]|0)+448|0;break};case 2:{e=(c[a+416>>2]|0)+424|0;break};default:{f=c[a+416>>2]|0;if((d|0)==8){e=f+472|0;break a}else{e=f+480|0;break a}}}}while(0);h[(c[b+8>>2]|0)+16>>3]=+h[e>>3];i=i;return}function Oj(a){a=a|0;c[(c[a+404>>2]|0)+280>>2]=1;i=i;return}function Pj(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+304>>2]=c[(c[a+404>>2]|0)+280>>2];i=i;return}function Qj(a){a=a|0;c[(c[a+404>>2]|0)+248>>2]=1;i=i;return}function Rj(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+312>>2]=c[(c[a+404>>2]|0)+248>>2];i=i;return}function Sj(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+312>>2]|0)+ -1|0,(c[a+448>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+308>>2]=e;i=b;return}function Tj(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+308>>2]|0)+ -1|0,(c[a+328>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+316>>2]=e;i=b;return}function Uj(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12960,(c[a+312>>2]|0)+ -1|0,(c[a+304>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+292>>2]=e;i=b;return}function Vj(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(12976,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+292>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+296>>2]=a;i=b;return}function Wj(a){a=a|0;c[(c[a+404>>2]|0)+208>>2]=1;i=i;return}function Xj(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+344>>2]=c[(c[a+404>>2]|0)+208>>2];i=i;return}function Yj(a){a=a|0;c[(c[a+404>>2]|0)+176>>2]=1;i=i;return}function Zj(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+352>>2]=c[(c[a+404>>2]|0)+176>>2];i=i;return}function _j(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+352>>2]|0)+ -1|0,(c[a+448>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+348>>2]=e;i=b;return}function $j(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+348>>2]|0)+ -1|0,(c[a+368>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+356>>2]=e;i=b;return}function ak(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12960,(c[a+352>>2]|0)+ -1|0,(c[a+344>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+332>>2]=e;i=b;return}function bk(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(12976,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+332>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+336>>2]=a;i=b;return}function ck(a){a=a|0;c[(c[a+404>>2]|0)+136>>2]=1;i=i;return}function dk(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+384>>2]=c[(c[a+404>>2]|0)+136>>2];i=i;return}function ek(a){a=a|0;c[(c[a+404>>2]|0)+104>>2]=1;i=i;return}function fk(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+392>>2]=c[(c[a+404>>2]|0)+104>>2];i=i;return}function gk(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+392>>2]|0)+ -1|0,(c[a+448>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+388>>2]=e;i=b;return}function hk(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+388>>2]|0)+ -1|0,(c[a+408>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+396>>2]=e;i=b;return}function ik(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12960,(c[a+392>>2]|0)+ -1|0,(c[a+384>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+372>>2]=e;i=b;return}function jk(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(12976,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+372>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+376>>2]=a;i=b;return}function kk(a){a=a|0;c[(c[a+404>>2]|0)+64>>2]=1;i=i;return}function lk(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+424>>2]=c[(c[a+404>>2]|0)+64>>2];i=i;return}function mk(a){a=a|0;c[(c[a+404>>2]|0)+32>>2]=1;i=i;return}function nk(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+432>>2]=c[(c[a+404>>2]|0)+32>>2];i=i;return}function ok(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+432>>2]|0)+ -1|0,(c[a+448>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+428>>2]=e;i=b;return}function pk(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+428>>2]|0)+ -1|0,(c[a+452>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+436>>2]=e;i=b;return}function qk(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12960,(c[a+432>>2]|0)+ -1|0,(c[a+424>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+412>>2]=e;i=b;return}function rk(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(12976,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+412>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+416>>2]=a;i=b;return}function sk(b){b=b|0;a[c[(c[c[b+4>>2]>>2]|0)+16>>2]|0]=0;i=i;return}function tk(a){a=a|0;c[(c[a+404>>2]|0)+444>>2]=1;i=i;return}function uk(a){a=a|0;c[(c[a+404>>2]|0)+420>>2]=3;i=i;return}function vk(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+56>>2]=c[(c[a+404>>2]|0)+420>>2];i=i;return}function wk(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+68>>2]=c[(c[a+404>>2]|0)+444>>2];i=i;return}function xk(a){a=a|0;c[(c[a+404>>2]|0)+48>>2]=1;i=i;return}function yk(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+40>>2]=c[(c[a+404>>2]|0)+48>>2];i=i;return}function zk(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+56>>2]|0)+ -1|0,(c[a+40>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+52>>2]=e;i=b;return}function Ak(a){a=a|0;c[(c[a+404>>2]|0)+12>>2]=1;i=i;return}function Bk(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+60>>2]=c[(c[a+404>>2]|0)+12>>2];i=i;return}function Ck(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+56>>2]|0)+ -1|0,(c[a+60>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+64>>2]=e;i=b;return}function Dk(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12960,(c[a+60>>2]|0)+ -1|0,(c[a+68>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+44>>2]=e;i=b;return}function Ek(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(12976,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+44>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+48>>2]=a;i=b;return}function Fk(a){a=a|0;c[(c[a+404>>2]|0)+404>>2]=1;i=i;return}function Gk(a){a=a|0;c[(c[a+404>>2]|0)+380>>2]=3;i=i;return}function Hk(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+128>>2]=c[(c[a+404>>2]|0)+380>>2];i=i;return}function Ik(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+140>>2]=c[(c[a+404>>2]|0)+404>>2];i=i;return}function Jk(a){a=a|0;c[(c[a+404>>2]|0)+120>>2]=1;i=i;return}function Kk(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+112>>2]=c[(c[a+404>>2]|0)+120>>2];i=i;return}function Lk(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+128>>2]|0)+ -1|0,(c[a+112>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+124>>2]=e;i=b;return}function Mk(a){a=a|0;c[(c[a+404>>2]|0)+84>>2]=1;i=i;return}function Nk(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+132>>2]=c[(c[a+404>>2]|0)+84>>2];i=i;return}function Ok(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+128>>2]|0)+ -1|0,(c[a+132>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+136>>2]=e;i=b;return}function Pk(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12960,(c[a+132>>2]|0)+ -1|0,(c[a+140>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+116>>2]=e;i=b;return}function Qk(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(12976,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+116>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+120>>2]=a;i=b;return}function Rk(a){a=a|0;c[(c[a+404>>2]|0)+364>>2]=1;i=i;return}function Sk(a){a=a|0;c[(c[a+404>>2]|0)+340>>2]=3;i=i;return}function Tk(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+200>>2]=c[(c[a+404>>2]|0)+340>>2];i=i;return}function Uk(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+212>>2]=c[(c[a+404>>2]|0)+364>>2];i=i;return}function Vk(a){a=a|0;c[(c[a+404>>2]|0)+192>>2]=1;i=i;return}function Wk(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+184>>2]=c[(c[a+404>>2]|0)+192>>2];i=i;return}function Xk(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+200>>2]|0)+ -1|0,(c[a+184>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+196>>2]=e;i=b;return}function Yk(a){a=a|0;c[(c[a+404>>2]|0)+156>>2]=1;i=i;return}function Zk(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+204>>2]=c[(c[a+404>>2]|0)+156>>2];i=i;return}function _k(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+200>>2]|0)+ -1|0,(c[a+204>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+208>>2]=e;i=b;return}function $k(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12960,(c[a+204>>2]|0)+ -1|0,(c[a+212>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+188>>2]=e;i=b;return}function al(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(12976,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+188>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+192>>2]=a;i=b;return}function bl(a){a=a|0;c[(c[a+404>>2]|0)+324>>2]=1;i=i;return}function cl(a){a=a|0;c[(c[a+404>>2]|0)+300>>2]=3;i=i;return}function dl(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+272>>2]=c[(c[a+404>>2]|0)+300>>2];i=i;return}function el(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+284>>2]=c[(c[a+404>>2]|0)+324>>2];i=i;return}function fl(a){a=a|0;c[(c[a+404>>2]|0)+264>>2]=1;i=i;return}function gl(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+256>>2]=c[(c[a+404>>2]|0)+264>>2];i=i;return}function hl(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+272>>2]|0)+ -1|0,(c[a+256>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+268>>2]=e;i=b;return}function il(a){a=a|0;c[(c[a+404>>2]|0)+228>>2]=1;i=i;return}function jl(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+276>>2]=c[(c[a+404>>2]|0)+228>>2];i=i;return}function kl(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12992,(c[a+272>>2]|0)+ -1|0,(c[a+276>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+280>>2]=e;i=b;return}function ll(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+12>>2]|0;e=Ru(12960,(c[a+276>>2]|0)+ -1|0,(c[a+284>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+260>>2]=e;i=b;return}function ml(a){a=a|0;var b=0,d=0;b=i;d=a+4|0;a=Qu(12976,(c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+260>>2]|0)+ -1|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+264>>2]=a;i=b;return}function nl(b){b=b|0;var c=0,d=0;c=i;d=b+314|0;a[d]=1;xh(b);yh(b);zh(b);Ah(b);Bh(b);Ch(b);Dh(b);Eh(b);Fh(b);Gh(b);Hh(b);Ih(b);Jh(b);Kh(b);Lh(b);Mh(b);Nh(b);Oh(b);Ph(b);Qh(b);Rh(b);Sh(b);Th(b);Uh(b);Vh(b);Wh(b);Xh(b);Yh(b);Zh(b);_h(b);$h(b);ai(b);bi(b);ci(b);di(b);ei(b);fi(b);gi(b);hi(b);ii(b);ji(b);ki(b);li(b);mi(b);ni(b);oi(b);pi(b);qi(b);ri(b);si(b);ti(b);ui(b);vi(b);wi(b);xi(b);yi(b);zi(b);Ai(b);Bi(b);Ci(b);Di(b);Ei(b);Fi(b);Gi(b);Hi(b);Ii(b);Ji(b);Ki(b);Li(b);Mi(b);Ni(b);Oi(b);Pi(b);Qi(b);Ri(b);Si(b);Ti(b);Ui(b);Vi(b);Wi(b);Xi(b);Yi(b);Zi(b);_i(b);$i(b);aj(b);bj(b);cj(b);dj(b);ej(b);fj(b);gj(b);hj(b);ij(b);jj(b);kj(b);lj(b);mj(b);nj(b);oj(b);pj(b);qj(b);rj(b);sj(b);tj(b);uj(b);vj(b);wj(b);xj(b);yj(b);zj(b);Aj(b);Bj(b);Cj(b);Dj(b);Ej(b);Fj(b);Gj(b);Hj(b);Ij(b);Jj(b);Kj(b);Lj(b);Mj(b);Nj(b);Oj(b);Pj(b);Qj(b);Rj(b);Sj(b);Tj(b);Uj(b);Vj(b);Wj(b);Xj(b);Yj(b);Zj(b);_j(b);$j(b);ak(b);bk(b);ck(b);dk(b);ek(b);fk(b);gk(b);hk(b);ik(b);jk(b);kk(b);lk(b);mk(b);nk(b);ok(b);pk(b);qk(b);rk(b);sk(b);tk(b);uk(b);vk(b);wk(b);xk(b);yk(b);zk(b);Ak(b);Bk(b);Ck(b);Dk(b);Ek(b);Fk(b);Gk(b);Hk(b);Ik(b);Jk(b);Kk(b);Lk(b);Mk(b);Nk(b);Ok(b);Pk(b);Qk(b);Rk(b);Sk(b);Tk(b);Uk(b);Vk(b);Wk(b);Xk(b);Yk(b);Zk(b);_k(b);$k(b);al(b);bl(b);cl(b);dl(b);el(b);fl(b);gl(b);hl(b);il(b);jl(b);kl(b);ll(b);ml(b);a[d]=0;i=c;return 0}function ol(a){a=a|0;i=i;return}function pl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0;b=i;d=a+404|0;e=a+4|0;f=a+416|0;g=+h[(c[f>>2]|0)+136>>3];Yw(a,6,+(c[(c[d>>2]|0)+288>>2]|0),+h[c[c[e>>2]>>2]>>3],g,g);g=+h[(c[f>>2]|0)+152>>3];Yw(a,7,+(c[(c[d>>2]|0)+256>>2]|0),+h[c[c[e>>2]>>2]>>3],g,g);g=+h[(c[f>>2]|0)+96>>3];Yw(a,4,+(c[(c[d>>2]|0)+328>>2]|0),+h[c[c[e>>2]>>2]>>3],g,g);g=+h[(c[f>>2]|0)+112>>3];Yw(a,5,+(c[(c[d>>2]|0)+184>>2]|0),+h[c[c[e>>2]>>2]>>3],g,g);g=+h[(c[f>>2]|0)+56>>3];Yw(a,2,+(c[(c[d>>2]|0)+368>>2]|0),+h[c[c[e>>2]>>2]>>3],g,g);g=+h[(c[f>>2]|0)+72>>3];Yw(a,3,+(c[(c[d>>2]|0)+112>>2]|0),+h[c[c[e>>2]>>2]>>3],g,g);g=+h[(c[f>>2]|0)+16>>3];Yw(a,0,+(c[(c[d>>2]|0)+408>>2]|0),+h[c[c[e>>2]>>2]>>3],g,g);g=+h[(c[f>>2]|0)+32>>3];Yw(a,1,+(c[(c[d>>2]|0)+40>>2]|0),+h[c[c[e>>2]>>2]>>3],g,g);i=b;return 0}function ql(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+48>>3]=+h[(c[a+416>>2]|0)+168>>3];i=i;return}function rl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0.0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;Lu(9,1,13776,j);if((c[63964>>2]|0)!=0){Vd[c[16120]&511](9)}Lu(9,1,13800,g);if((c[63964>>2]|0)!=0){Vd[c[16120]&511](9)}Lu(9,1,13824,f);if((c[63964>>2]|0)!=0){Vd[c[16120]&511](9)}ql(a);Lu(9,1,13848,e);l=+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+48>>3];e=c[a+8>>2]|0;h[e+768>>3]=l;c[d>>2]=c[e+676>>2];e=d+4|0;h[k>>3]=l;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];Lu(9,0,13872,d);if((c[63964>>2]|0)==0){i=b;return 0}Vd[c[16120]&511](9);i=b;return 0}function sl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+56>>3]=+h[b+176>>3]*+h[b+184>>3]*.01;i=i;return}function tl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b>>3]=+h[b+192>>3];i=i;return}function ul(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b>>2]=c[b+220>>2];i=i;return}function vl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8>>3]=+h[b>>3];i=i;return}function wl(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+20>>2]=c[b>>2];i=i;return}function xl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16>>3]=+h[b+8>>3];i=i;return}function yl(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+32>>2]=c[b+20>>2];i=i;return}function zl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24>>3]=+h[b>>3];i=i;return}function Al(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+36>>2]=c[b>>2];i=i;return}function Bl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32>>3]=+h[b+24>>3];i=i;return}function Cl(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+48>>2]=c[b+36>>2];i=i;return}function Dl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40>>3]=+h[b+192>>3];i=i;return}function El(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+52>>2]=c[b+220>>2];i=i;return}function Fl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+48>>3]=+h[b+40>>3];i=i;return}function Gl(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+72>>2]=c[b+52>>2];i=i;return}function Hl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+56>>3]=+h[b+48>>3];i=i;return}function Il(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+84>>2]=c[b+72>>2];i=i;return}function Jl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+64>>3]=+h[b+40>>3];i=i;return}function Kl(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+88>>2]=c[b+52>>2];i=i;return}function Ll(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+72>>3]=+h[b+64>>3];i=i;return}function Ml(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+100>>2]=c[b+88>>2];i=i;return}function Nl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+80>>3]=+h[b+192>>3];i=i;return}function Ol(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+104>>2]=c[b+220>>2];i=i;return}function Pl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+88>>3]=+h[b+80>>3];i=i;return}function Ql(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+124>>2]=c[b+104>>2];i=i;return}function Rl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+96>>3]=+h[b+88>>3];i=i;return}function Sl(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+136>>2]=c[b+124>>2];i=i;return}function Tl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+104>>3]=+h[b+80>>3];i=i;return}function Ul(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+140>>2]=c[b+104>>2];i=i;return}function Vl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+112>>3]=+h[b+104>>3];i=i;return}function Wl(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+152>>2]=c[b+140>>2];i=i;return}function Xl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+120>>3]=+h[b+192>>3];i=i;return}function Yl(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+156>>2]=c[b+220>>2];i=i;return}function Zl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+128>>3]=+h[b+120>>3];i=i;return}function _l(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+176>>2]=c[b+156>>2];i=i;return}function $l(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+136>>3]=+h[b+128>>3];i=i;return}function am(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+188>>2]=c[b+176>>2];i=i;return}function bm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+144>>3]=+h[b+120>>3];i=i;return}function cm(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+192>>2]=c[b+156>>2];i=i;return}function dm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+152>>3]=+h[b+144>>3];i=i;return}function em(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+204>>2]=c[b+192>>2];i=i;return}function fm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13888]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+236>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=lv(13904,jv(c[(c[g>>2]|0)+236>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=14264;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[13888]=1;i=d;return}function gm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14048]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+232>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=lv(14056,jv(c[(c[g>>2]|0)+232>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=14264;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[14048]=1;i=d;return}function hm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14120]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+228>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=lv(14128,jv(c[(c[g>>2]|0)+228>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=14264;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[14120]=1;i=d;return}function im(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14192]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+224>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=lv(14200,jv(c[(c[g>>2]|0)+224>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=14264;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[14192]=1;i=d;return}function jm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14288]&1){i=d;return}g=b+420|0;b=Ex(+(c[(c[g>>2]|0)+204>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[g>>2]|0)+204>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(14296,jv(c[(c[g>>2]|0)+204>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=21296;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[14288]=1;i=d;return}function km(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14528]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+200>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(14536,jv(c[(c[g>>2]|0)+200>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[14528]=1;i=d;return}function lm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14640]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+196>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(14648,jv(c[(c[g>>2]|0)+196>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[14640]=1;i=d;return}function mm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14752]&1){i=d;return}g=b+420|0;b=Ex(+(c[(c[g>>2]|0)+192>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[g>>2]|0)+192>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(14760,jv(c[(c[g>>2]|0)+192>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=21776;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[14752]=1;i=d;return}function nm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14984]&1){i=d;return}g=b+420|0;b=Ex(+(c[(c[g>>2]|0)+188>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[g>>2]|0)+188>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(14992,jv(c[(c[g>>2]|0)+188>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=21296;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[14984]=1;i=d;return}function om(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15224]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+184>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(15232,jv(c[(c[g>>2]|0)+184>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[15224]=1;i=d;return}function pm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15336]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+180>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(15344,jv(c[(c[g>>2]|0)+180>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[15336]=1;i=d;return}function qm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15448]&1){i=d;return}g=b+420|0;b=Ex(+(c[(c[g>>2]|0)+176>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[g>>2]|0)+176>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(15456,jv(c[(c[g>>2]|0)+176>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=21776;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[15448]=1;i=d;return}function rm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15680]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+172>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(15688,jv(c[(c[g>>2]|0)+172>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[15680]=1;i=d;return}function sm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15784]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+168>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(15792,jv(c[(c[g>>2]|0)+168>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[15784]=1;i=d;return}function tm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15888]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+164>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(15896,jv(c[(c[g>>2]|0)+164>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[15888]=1;i=d;return}function um(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15992]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+160>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(16e3,jv(c[(c[g>>2]|0)+160>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[15992]=1;i=d;return}function vm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16096]&1){i=d;return}g=b+420|0;b=Ex(+(c[(c[g>>2]|0)+156>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[g>>2]|0)+156>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(16104,jv(c[(c[g>>2]|0)+156>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22456;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[16096]=1;i=d;return}function wm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16312]&1){i=d;return}g=b+420|0;b=Ex(+(c[(c[g>>2]|0)+152>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[g>>2]|0)+152>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(16320,jv(c[(c[g>>2]|0)+152>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=21296;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[16312]=1;i=d;return}function xm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16552]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+148>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(16560,jv(c[(c[g>>2]|0)+148>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[16552]=1;i=d;return}function ym(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16664]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+144>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(16672,jv(c[(c[g>>2]|0)+144>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[16664]=1;i=d;return}function zm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16776]&1){i=d;return}g=b+420|0;b=Ex(+(c[(c[g>>2]|0)+140>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[g>>2]|0)+140>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(16784,jv(c[(c[g>>2]|0)+140>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=21776;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[16776]=1;i=d;return}function Am(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17008]&1){i=d;return}g=b+420|0;b=Ex(+(c[(c[g>>2]|0)+136>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[g>>2]|0)+136>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(17016,jv(c[(c[g>>2]|0)+136>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=21296;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[17008]=1;i=d;return}function Bm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17248]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+132>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(17256,jv(c[(c[g>>2]|0)+132>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[17248]=1;i=d;return}function Cm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17360]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+128>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(17368,jv(c[(c[g>>2]|0)+128>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[17360]=1;i=d;return}function Dm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17472]&1){i=d;return}g=b+420|0;b=Ex(+(c[(c[g>>2]|0)+124>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[g>>2]|0)+124>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(17480,jv(c[(c[g>>2]|0)+124>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=21776;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[17472]=1;i=d;return}function Em(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17704]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+120>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(17712,jv(c[(c[g>>2]|0)+120>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[17704]=1;i=d;return}function Fm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17808]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+116>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(17816,jv(c[(c[g>>2]|0)+116>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[17808]=1;i=d;return}function Gm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17912]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+112>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(17920,jv(c[(c[g>>2]|0)+112>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[17912]=1;i=d;return}function Hm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18016]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+108>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(18024,jv(c[(c[g>>2]|0)+108>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[18016]=1;i=d;return}function Im(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18120]&1){i=d;return}g=b+420|0;b=Ex(+(c[(c[g>>2]|0)+104>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[g>>2]|0)+104>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(18128,jv(c[(c[g>>2]|0)+104>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22456;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[18120]=1;i=d;return}function Jm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18336]&1){i=d;return}g=b+420|0;b=Ex(+(c[(c[g>>2]|0)+100>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[g>>2]|0)+100>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(18344,jv(c[(c[g>>2]|0)+100>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=21296;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[18336]=1;i=d;return}function Km(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18576]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+96>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(18584,jv(c[(c[g>>2]|0)+96>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[18576]=1;i=d;return}function Lm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18688]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+92>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(18696,jv(c[(c[g>>2]|0)+92>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[18688]=1;i=d;return}function Mm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18800]&1){i=d;return}g=b+420|0;b=Ex(+(c[(c[g>>2]|0)+88>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[g>>2]|0)+88>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(18808,jv(c[(c[g>>2]|0)+88>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=21776;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[18800]=1;i=d;return}function Nm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19032]&1){i=d;return}g=b+420|0;b=Ex(+(c[(c[g>>2]|0)+84>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[g>>2]|0)+84>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(19040,jv(c[(c[g>>2]|0)+84>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=21296;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[19032]=1;i=d;return}function Om(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19272]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+80>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(19280,jv(c[(c[g>>2]|0)+80>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[19272]=1;i=d;return}function Pm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19384]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+76>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(19392,jv(c[(c[g>>2]|0)+76>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[19384]=1;i=d;return}function Qm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19496]&1){i=d;return}g=b+420|0;b=Ex(+(c[(c[g>>2]|0)+72>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[g>>2]|0)+72>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(19504,jv(c[(c[g>>2]|0)+72>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=21776;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[19496]=1;i=d;return}function Rm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19728]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+68>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(19736,jv(c[(c[g>>2]|0)+68>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[19728]=1;i=d;return}function Sm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19832]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+64>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(19840,jv(c[(c[g>>2]|0)+64>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[19832]=1;i=d;return}function Tm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19936]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+60>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(19944,jv(c[(c[g>>2]|0)+60>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[19936]=1;i=d;return}function Um(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20040]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+56>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(20048,jv(c[(c[g>>2]|0)+56>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[20040]=1;i=d;return}function Vm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20144]&1){i=d;return}g=b+420|0;b=Ex(+(c[(c[g>>2]|0)+52>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[g>>2]|0)+52>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(20152,jv(c[(c[g>>2]|0)+52>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22456;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[20144]=1;i=d;return}function Wm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20360]&1){i=d;return}g=b+420|0;b=Ex(+(c[(c[g>>2]|0)+48>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[g>>2]|0)+48>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(20368,jv(c[(c[g>>2]|0)+48>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=21296;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[20360]=1;i=d;return}function Xm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20600]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+44>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(20608,jv(c[(c[g>>2]|0)+44>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[20600]=1;i=d;return}function Ym(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20712]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+40>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(20720,jv(c[(c[g>>2]|0)+40>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[20712]=1;i=d;return}function Zm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20824]&1){i=d;return}g=b+420|0;b=Ex(+(c[(c[g>>2]|0)+36>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[g>>2]|0)+36>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(20832,jv(c[(c[g>>2]|0)+36>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=21776;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[20824]=1;i=d;return}function _m(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21056]&1){i=d;return}g=b+420|0;b=Ex(+(c[(c[g>>2]|0)+32>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[g>>2]|0)+32>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(21064,jv(c[(c[g>>2]|0)+32>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=21296;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[21056]=1;i=d;return}function $m(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21320]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+28>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(21328,jv(c[(c[g>>2]|0)+28>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[21320]=1;i=d;return}function an(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21432]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+24>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(21440,jv(c[(c[g>>2]|0)+24>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[21432]=1;i=d;return}function bn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21544]&1){i=d;return}g=b+420|0;b=Ex(+(c[(c[g>>2]|0)+20>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[g>>2]|0)+20>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(21552,jv(c[(c[g>>2]|0)+20>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=21776;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[21544]=1;i=d;return}function cn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21800]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+16>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(21808,jv(c[(c[g>>2]|0)+16>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[21800]=1;i=d;return}function dn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21904]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+12>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(21912,jv(c[(c[g>>2]|0)+12>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[21904]=1;i=d;return}function en(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22008]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+8>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(22016,jv(c[(c[g>>2]|0)+8>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[22008]=1;i=d;return}function fn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22112]&1){i=d;return}g=b+420|0;if(!((Ex(+(c[(c[g>>2]|0)+4>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lv(22120,jv(c[(c[g>>2]|0)+4>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[22112]=1;i=d;return}function gn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22240]&1){i=d;return}g=b+420|0;b=Ex(+(c[c[g>>2]>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[c[g>>2]>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(22248,jv(c[c[g>>2]>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22456;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[22240]=1;i=d;return}function hn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22480]&1){i=d;return}g=b+420|0;b=Ex(+(c[(c[g>>2]|0)+220>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[g>>2]|0)+220>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(22488,jv(c[(c[g>>2]|0)+220>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=22680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[22480]=1;i=d;return}function jn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22704]&1){i=d;return}g=b+416|0;b=Ex(+h[(c[g>>2]|0)+184>>3],1.0e-60)|0;if(!(b<<24>>24==0|(Cx(+h[(c[g>>2]|0)+184>>3],100.0)|0)<<24>>24==0)){i=d;return}b=lv(22720,hv(+h[(c[g>>2]|0)+184>>3],22712)|0)|0;g=c[27664]|0;j=e;k=22832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];re[g&15](e,b,f);a[22704]=1;i=d;return}function kn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22856]&1){i=d;return}g=b+416|0;if(!((Ex(+h[(c[g>>2]|0)+176>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=lv(22864,hv(+h[(c[g>>2]|0)+176>>3],22712)|0)|0;g=c[27664]|0;j=e;k=22952;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];re[g&15](e,b,f);a[22856]=1;i=d;return}function ln(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22976]&1){i=d;return}g=b+420|0;b=Ex(+(c[(c[g>>2]|0)+212>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[g>>2]|0)+212>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(22984,jv(c[(c[g>>2]|0)+212>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=23184;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[22976]=1;i=d;return}function mn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23208]&1){i=d;return}g=b+420|0;b=Ex(+(c[(c[g>>2]|0)+208>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[g>>2]|0)+208>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(23216,jv(c[(c[g>>2]|0)+208>>2]|0,13896)|0)|0;g=c[27664]|0;h=e;j=23416;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[23208]=1;i=d;return}function nn(a){a=a|0;var b=0;b=i;sl(a);tl(a);ul(a);vl(a);wl(a);xl(a);yl(a);zl(a);Al(a);Bl(a);Cl(a);Dl(a);El(a);Fl(a);Gl(a);Hl(a);Il(a);Jl(a);Kl(a);Ll(a);Ml(a);Nl(a);Ol(a);Pl(a);Ql(a);Rl(a);Sl(a);Tl(a);Ul(a);Vl(a);Wl(a);Xl(a);Yl(a);Zl(a);_l(a);$l(a);am(a);bm(a);cm(a);dm(a);em(a);fm(a);gm(a);hm(a);im(a);jm(a);km(a);lm(a);mm(a);nm(a);om(a);pm(a);qm(a);rm(a);sm(a);tm(a);um(a);vm(a);wm(a);xm(a);ym(a);zm(a);Am(a);Bm(a);Cm(a);Dm(a);Em(a);Fm(a);Gm(a);Hm(a);Im(a);Jm(a);Km(a);Lm(a);Mm(a);Nm(a);Om(a);Pm(a);Qm(a);Rm(a);Sm(a);Tm(a);Um(a);Vm(a);Wm(a);Xm(a);Ym(a);Zm(a);_m(a);$m(a);an(a);bn(a);cn(a);dn(a);en(a);fn(a);gn(a);hn(a);jn(a);kn(a);ln(a);mn(a);i=b;return 0}function on(b){b=b|0;var c=0;c=i;a[b+314|0]=0;pn(b);i=c;return 0}function pn(a){a=a|0;var b=0;b=i;jg(a);kg(a);mg(a);ng(a);og(a);pg(a);qg(a);rg(a);sg(a);tg(a);ug(a);vg(a);wg(a);xg(a);yg(a);zg(a);Ag(a);Bg(a);Cg(a);Dg(a);Eg(a);Fg(a);Gg(a);Hg(a);Ig(a);Jg(a);Kg(a);Lg(a);Mg(a);Ng(a);Og(a);Pg(a);Qg(a);Rg(a);Sg(a);Tg(a);Ug(a);Vg(a);Wg(a);Xg(a);Yg(a);Zg(a);_g(a);$g(a);ah(a);bh(a);ch(a);bg(a);cg(a);dg(a);eg(a);fg(a);gg(a);hg(a);ig(a);Yf(a);Zf(a);_f(a);$f(a);ag(a);Tf(a);Uf(a);Vf(a);Wf(a);Xf(a);Lf(a);Mf(a);Nf(a);Of(a);Pf(a);Qf(a);Rf(a);Sf(a);Gf(a);Hf(a);If(a);Jf(a);Kf(a);Bf(a);Cf(a);Df(a);Ef(a);Ff(a);tf(a);uf(a);vf(a);wf(a);xf(a);yf(a);zf(a);Af(a);of(a);pf(a);qf(a);rf(a);sf(a);jf(a);kf(a);lf(a);mf(a);nf(a);af(a);bf(a);cf(a);df(a);ef(a);ff(a);gf(a);hf(a);Xe(a);Ye(a);Ze(a);_e(a);$e(a);Se(a);Te(a);Ue(a);Ve(a);We(a);i=b;return}function qn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23440]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+452>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+452>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(23456,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+452>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=23720;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[23440]=1;i=d;return}function rn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23744]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+448>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+448>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(23752,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+448>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=23960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[23744]=1;i=d;return}function sn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23984]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+444>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+444>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(23992,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+444>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=49496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[23984]=1;i=d;return}function tn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24248]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+440>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+440>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(24256,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+440>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=33008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[24248]=1;i=d;return}function un(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24512]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+436>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+436>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(24520,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+436>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=49496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[24512]=1;i=d;return}function vn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24776]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+432>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+432>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(24784,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+432>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[24776]=1;i=d;return}function wn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25016]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+428>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+428>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(25024,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+428>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=33008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[25016]=1;i=d;return}function xn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25280]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+424>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+424>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(25288,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+424>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=51872;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[25280]=1;i=d;return}function yn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25512]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+420>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+420>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(25520,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+420>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=33520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[25512]=1;i=d;return}function zn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25768]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+416>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+416>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(25776,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+416>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52168;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[25768]=1;i=d;return}function An(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26040]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+412>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+412>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(26048,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+412>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[26040]=1;i=d;return}



function DU(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;t=i;c[f>>2]=d;u=r+1|0;v=r+8|0;w=r+4|0;x=(g&512|0)==0;y=q+1|0;z=q+8|0;A=q+4|0;B=(s|0)>0;C=p+1|0;D=p+8|0;E=p+4|0;F=k+8|0;G=0-s|0;H=h;h=0;while(1){a:do{switch(a[m+h|0]|0){case 1:{c[e>>2]=c[f>>2];I=le[c[(c[k>>2]|0)+28>>2]&63](k,32)|0;J=c[f>>2]|0;c[f>>2]=J+1;a[J]=I;K=H;break};case 2:{I=a[q]|0;J=(I&1)==0;if(J){L=(I&255)>>>1}else{L=c[A>>2]|0}if((L|0)==0|x){K=H;break a}if(J){M=y;N=(I&255)>>>1}else{M=c[z>>2]|0;N=c[A>>2]|0}I=M+N|0;J=c[f>>2]|0;if((M|0)==(I|0)){O=J}else{P=J;J=M;while(1){a[P]=a[J]|0;Q=J+1|0;R=P+1|0;if((Q|0)==(I|0)){O=R;break}else{J=Q;P=R}}}c[f>>2]=O;K=H;break};case 0:{c[e>>2]=c[f>>2];K=H;break};case 3:{P=a[r]|0;J=(P&1)==0;if(J){S=(P&255)>>>1}else{S=c[w>>2]|0}if((S|0)==0){K=H;break a}if(J){T=u}else{T=c[v>>2]|0}J=a[T]|0;P=c[f>>2]|0;c[f>>2]=P+1;a[P]=J;K=H;break};case 4:{J=c[f>>2]|0;P=l?H+1|0:H;b:do{if(P>>>0<j>>>0){I=P;while(1){R=a[I]|0;if(!(R<<24>>24>-1)){U=I;break b}Q=I+1|0;if((b[(c[F>>2]|0)+(R<<24>>24<<1)>>1]&2048)==0){U=I;break b}if(Q>>>0<j>>>0){I=Q}else{U=Q;break}}}else{U=P}}while(0);I=U;if(B){if(U>>>0>P>>>0){Q=P+(0-I)|0;I=Q>>>0<G>>>0?G:Q;Q=I+s|0;R=J;V=U;W=s;while(1){X=V+ -1|0;Y=a[X]|0;c[f>>2]=R+1;a[R]=Y;Y=W+ -1|0;Z=(Y|0)>0;if(!(X>>>0>P>>>0&Z)){break}R=c[f>>2]|0;W=Y;V=X}V=U+I|0;if(Z){_=V;$=Q;aa=32}else{ba=0;ca=V;da=Q}}else{_=U;$=s;aa=32}if((aa|0)==32){aa=0;ba=le[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;ca=_;da=$}V=c[f>>2]|0;c[f>>2]=V+1;if((da|0)>0){W=V;R=da;while(1){a[W]=ba;X=R+ -1|0;Y=c[f>>2]|0;c[f>>2]=Y+1;if((X|0)>0){R=X;W=Y}else{ea=Y;break}}}else{ea=V}a[ea]=n;fa=ca}else{fa=U}if((fa|0)==(P|0)){W=le[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;R=c[f>>2]|0;c[f>>2]=R+1;a[R]=W}else{W=a[p]|0;R=(W&1)==0;if(R){ga=(W&255)>>>1}else{ga=c[E>>2]|0}if((ga|0)==0){ha=fa;ia=-1;ja=0;ka=0}else{if(R){la=C}else{la=c[D>>2]|0}ha=fa;ia=a[la]|0;ja=0;ka=0}while(1){do{if((ka|0)==(ia|0)){R=c[f>>2]|0;c[f>>2]=R+1;a[R]=o;R=ja+1|0;W=a[p]|0;Q=(W&1)==0;if(Q){ma=(W&255)>>>1}else{ma=c[E>>2]|0}if(!(R>>>0<ma>>>0)){na=ia;oa=R;pa=0;break}if(Q){qa=C}else{qa=c[D>>2]|0}if((a[qa+R|0]|0)==127){na=-1;oa=R;pa=0;break}if(Q){ra=C}else{ra=c[D>>2]|0}na=a[ra+R|0]|0;oa=R;pa=0}else{na=ia;oa=ja;pa=ka}}while(0);R=ha+ -1|0;Q=a[R]|0;W=c[f>>2]|0;c[f>>2]=W+1;a[W]=Q;if((R|0)==(P|0)){break}else{ha=R;ia=na;ja=oa;ka=pa+1|0}}}V=c[f>>2]|0;if((J|0)==(V|0)){K=P;break a}R=V+ -1|0;if(R>>>0>J>>>0){sa=J;ta=R}else{K=P;break a}while(1){R=a[sa]|0;a[sa]=a[ta]|0;a[ta]=R;R=sa+1|0;V=ta+ -1|0;if(R>>>0<V>>>0){ta=V;sa=R}else{K=P;break}}break};default:{K=H}}}while(0);P=h+1|0;if(P>>>0<4){H=K;h=P}else{break}}h=a[r]|0;r=(h&1)==0;if(r){ua=(h&255)>>>1}else{ua=c[w>>2]|0}if(ua>>>0>1){if(r){va=u;wa=(h&255)>>>1}else{va=c[v>>2]|0;wa=c[w>>2]|0}w=va+1|0;v=va+wa|0;wa=c[f>>2]|0;if((w|0)==(v|0)){xa=wa}else{va=wa;wa=w;while(1){a[va]=a[wa]|0;w=wa+1|0;h=va+1|0;if((w|0)==(v|0)){xa=h;break}else{wa=w;va=h}}}c[f>>2]=xa}xa=g&176;if((xa|0)==16){i=t;return}else if((xa|0)==32){c[e>>2]=c[f>>2];i=t;return}else{c[e>>2]=d;i=t;return}}function EU(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+104|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;qP(m,g);z=m;A=c[z>>2]|0;if(!((c[33868]|0)==-1)){c[l>>2]=135472;c[l+4>>2]=281;c[l+8>>2]=0;fO(135472,l,282)}l=(c[135476>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=zc(4)|0;D=C;eY(D);E=151032;F=127;Hd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=zc(4)|0;D=C;eY(D);E=151032;F=127;Hd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+1|0}else{I=c[j+8>>2]|0}C=a[I]|0;H=C<<24>>24==(le[c[(c[A>>2]|0)+28>>2]&63](F,45)|0)<<24>>24}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;CU(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=zY(P)|0;if((N|0)!=0){Q=N;R=N;break}MY()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+1|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}DU(R,w,x,c[g+4>>2]|0,S,S+T|0,F,H,o,a[p]|0,a[q]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];VK(b,k,R,e,w,g,h);if((Q|0)==0){uO(t);uO(s);uO(r);U=c[z>>2]|0;V=U;W=V;X=MN(W)|0;i=d;return}AY(Q);uO(t);uO(s);uO(r);U=c[z>>2]|0;V=U;W=V;X=MN(W)|0;i=d;return}function FU(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function GU(a){a=a|0;i=i;return}function HU(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+400|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+400|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Hc(G|0,100,135224,o|0)|0;do{if(s>>>0>99){do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);o=c[33840]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=tS(r,o,135224,n)|0;o=c[r>>2]|0;if((o|0)==0){MY()}H=zY(G<<2)|0;I=H;if((H|0)!=0){J=o;K=I;L=I;M=G;break}MY()}else{J=0;K=0;L=q;M=s}}while(0);qP(t,g);s=t;q=c[s>>2]|0;if(!((c[33866]|0)==-1)){c[p>>2]=135464;c[p+4>>2]=281;c[p+8>>2]=0;fO(135464,p,282)}p=(c[135468>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){N=zc(4)|0;O=N;eY(O);P=151032;Q=127;Hd(N|0,P|0,Q|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){N=zc(4)|0;O=N;eY(O);P=151032;Q=127;Hd(N|0,P|0,Q|0)}Q=q;P=c[r>>2]|0;ue[c[(c[q>>2]|0)+48>>2]&63](Q,P,P+M|0,L)|0;if((M|0)==0){R=0}else{R=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;IU(f,R,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((M|0)>(C|0)){B=a[A]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){T=(B&255)>>>1}else{T=c[z+4>>2]|0}U=S+(M-C<<1|1)+T|0}else{T=a[A]|0;if((T&1)==0){V=(T&255)>>>1}else{V=c[A+4>>2]|0}T=a[z]|0;if((T&1)==0){W=(T&255)>>>1}else{W=c[z+4>>2]|0}U=V+2+W|0}W=U+C|0;do{if(W>>>0>100){U=zY(W<<2)|0;V=U;if((U|0)!=0){X=V;Y=V;break}MY()}else{X=0;Y=t}}while(0);JU(Y,D,E,c[g+4>>2]|0,L,L+(M<<2)|0,Q,R,v,c[w>>2]|0,c[x>>2]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];CS(b,m,Y,e,D,g,j);if((X|0)!=0){AY(X)}YO(A);YO(z);uO(y);MN(c[s>>2]|0)|0;if((K|0)!=0){AY(K)}if((J|0)==0){i=d;return}AY(J);i=d;return}function IU(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[33760]|0)==-1)){c[p>>2]=135040;c[p+4>>2]=281;c[p+8>>2]=0;fO(135040,p,282)}p=(c[135044>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=zc(4)|0;I=H;eY(I);J=151032;K=127;Hd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=zc(4)|0;I=H;eY(I);J=151032;K=127;Hd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){Wd[c[J+44>>2]&63](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;Wd[c[(c[e>>2]|0)+32>>2]&63](s,K);H=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}$O(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;YO(s)}else{Wd[c[J+40>>2]&63](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;Wd[c[(c[e>>2]|0)+28>>2]&63](v,K);J=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}$O(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;YO(v)}c[g>>2]=Yd[c[(c[e>>2]|0)+12>>2]&127](K)|0;c[h>>2]=Yd[c[(c[e>>2]|0)+16>>2]&127](K)|0;Wd[c[(c[e>>2]|0)+20>>2]&63](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}GO(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;uO(w);Wd[c[(c[e>>2]|0)+24>>2]&63](x,K);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}$O(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;YO(x);L=Yd[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[33744]|0)==-1)){c[o>>2]=134976;c[o+4>>2]=281;c[o+8>>2]=0;fO(134976,o,282)}o=(c[134980>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=zc(4)|0;N=M;eY(N);O=151032;P=127;Hd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=zc(4)|0;N=M;eY(N);O=151032;P=127;Hd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){Wd[c[O+44>>2]&63](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;Wd[c[(c[G>>2]|0)+32>>2]&63](A,P);d=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}$O(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;YO(A)}else{Wd[c[O+40>>2]&63](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;Wd[c[(c[G>>2]|0)+28>>2]&63](D,P);f=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}$O(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;YO(D)}c[g>>2]=Yd[c[(c[G>>2]|0)+12>>2]&127](P)|0;c[h>>2]=Yd[c[(c[G>>2]|0)+16>>2]&127](P)|0;Wd[c[(c[G>>2]|0)+20>>2]&63](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}GO(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;uO(E);Wd[c[(c[G>>2]|0)+24>>2]&63](F,P);E=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}$O(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;YO(F);L=Yd[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function JU(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;s=i;c[e>>2]=b;t=q+4|0;u=q+8|0;v=(f&512|0)==0;w=p+4|0;x=p+8|0;y=(r|0)>0;z=o+1|0;A=o+8|0;B=o+4|0;C=g;g=0;while(1){a:do{switch(a[l+g|0]|0){case 2:{D=a[p]|0;E=(D&1)==0;if(E){F=(D&255)>>>1}else{F=c[w>>2]|0}if((F|0)==0|v){G=C;break a}if(E){H=w;I=(D&255)>>>1}else{H=c[x>>2]|0;I=c[w>>2]|0}D=H+(I<<2)|0;E=c[e>>2]|0;if((H|0)==(D|0)){J=E}else{K=(H+(I+ -1<<2)+(0-H)|0)>>>2;L=E;M=H;while(1){c[L>>2]=c[M>>2];N=M+4|0;if((N|0)==(D|0)){break}L=L+4|0;M=N}J=E+(K+1<<2)|0}c[e>>2]=J;G=C;break};case 4:{M=c[e>>2]|0;L=k?C+4|0:C;b:do{if(L>>>0<h>>>0){D=L;while(1){N=D+4|0;if(!($d[c[(c[j>>2]|0)+12>>2]&63](j,2048,c[D>>2]|0)|0)){O=D;break b}if(N>>>0<h>>>0){D=N}else{O=N;break}}}else{O=L}}while(0);if(y){do{if(O>>>0>L>>>0){K=c[e>>2]|0;E=O;D=r;while(1){P=E+ -4|0;Q=K+4|0;c[K>>2]=c[P>>2];R=D+ -1|0;S=(R|0)>0;if(P>>>0>L>>>0&S){D=R;E=P;K=Q}else{break}}c[e>>2]=Q;if(S){T=P;U=R;V=34;break}K=c[e>>2]|0;c[e>>2]=K+4;W=K;X=P}else{T=O;U=r;V=34}}while(0);do{if((V|0)==34){V=0;K=le[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;E=c[e>>2]|0;D=E+4|0;c[e>>2]=D;if((U|0)>0){Y=D;Z=E;_=U}else{W=E;X=T;break}while(1){c[Z>>2]=K;D=_+ -1|0;if((D|0)>0){_=D;Z=Y;Y=Y+4|0}else{break}}c[e>>2]=E+(U+1<<2);W=E+(U<<2)|0;X=T}}while(0);c[W>>2]=m;$=X}else{$=O}if(($|0)==(L|0)){K=le[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;D=c[e>>2]|0;N=D+4|0;c[e>>2]=N;c[D>>2]=K;aa=N}else{N=a[o]|0;K=(N&1)==0;if(K){ba=(N&255)>>>1}else{ba=c[B>>2]|0}if((ba|0)==0){ca=$;da=-1;ea=0;fa=0}else{if(K){ga=z}else{ga=c[A>>2]|0}ca=$;da=a[ga]|0;ea=0;fa=0}while(1){K=c[e>>2]|0;do{if((fa|0)==(da|0)){N=K+4|0;c[e>>2]=N;c[K>>2]=n;D=ea+1|0;ha=a[o]|0;ia=(ha&1)==0;if(ia){ja=(ha&255)>>>1}else{ja=c[B>>2]|0}if(!(D>>>0<ja>>>0)){ka=N;la=da;ma=D;na=0;break}if(ia){oa=z}else{oa=c[A>>2]|0}if((a[oa+D|0]|0)==127){ka=N;la=-1;ma=D;na=0;break}if(ia){pa=z}else{pa=c[A>>2]|0}ka=N;la=a[pa+D|0]|0;ma=D;na=0}else{ka=K;la=da;ma=ea;na=fa}}while(0);K=ca+ -4|0;E=c[K>>2]|0;D=ka+4|0;c[e>>2]=D;c[ka>>2]=E;if((K|0)==(L|0)){aa=D;break}else{ca=K;da=la;ea=ma;fa=na+1|0}}}if((M|0)==(aa|0)){G=L;break a}K=aa+ -4|0;if(K>>>0>M>>>0){qa=M;ra=K}else{G=L;break a}while(1){K=c[qa>>2]|0;c[qa>>2]=c[ra>>2];c[ra>>2]=K;K=qa+4|0;D=ra+ -4|0;if(K>>>0<D>>>0){ra=D;qa=K}else{G=L;break}}break};case 0:{c[d>>2]=c[e>>2];G=C;break};case 3:{L=a[q]|0;M=(L&1)==0;if(M){sa=(L&255)>>>1}else{sa=c[t>>2]|0}if((sa|0)==0){G=C;break a}if(M){ta=t}else{ta=c[u>>2]|0}M=c[ta>>2]|0;L=c[e>>2]|0;c[e>>2]=L+4;c[L>>2]=M;G=C;break};case 1:{c[d>>2]=c[e>>2];M=le[c[(c[j>>2]|0)+44>>2]&63](j,32)|0;L=c[e>>2]|0;c[e>>2]=L+4;c[L>>2]=M;G=C;break};default:{G=C}}}while(0);M=g+1|0;if(M>>>0<4){C=G;g=M}else{break}}g=a[q]|0;q=(g&1)==0;if(q){ua=(g&255)>>>1}else{ua=c[t>>2]|0}if(ua>>>0>1){if(q){va=t;wa=(g&255)>>>1}else{va=c[u>>2]|0;wa=c[t>>2]|0}t=va+4|0;u=va+(wa<<2)|0;g=c[e>>2]|0;if((t|0)==(u|0)){xa=g}else{q=(va+(wa+ -1<<2)+(0-t)|0)>>>2;wa=g;va=t;while(1){c[wa>>2]=c[va>>2];t=va+4|0;if((t|0)==(u|0)){break}else{va=t;wa=wa+4|0}}xa=g+(q+1<<2)|0}c[e>>2]=xa}xa=f&176;if((xa|0)==32){c[d>>2]=c[e>>2];i=s;return}else if((xa|0)==16){i=s;return}else{c[d>>2]=b;i=s;return}}function KU(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+400|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;qP(m,g);z=m;A=c[z>>2]|0;if(!((c[33866]|0)==-1)){c[l>>2]=135464;c[l+4>>2]=281;c[l+8>>2]=0;fO(135464,l,282)}l=(c[135468>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=zc(4)|0;D=C;eY(D);E=151032;F=127;Hd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=zc(4)|0;D=C;eY(D);E=151032;F=127;Hd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+4|0}else{I=c[j+8>>2]|0}C=c[I>>2]|0;H=(C|0)==(le[c[(c[A>>2]|0)+44>>2]&63](F,45)|0)}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;IU(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=zY(P<<2)|0;O=N;if((N|0)!=0){Q=O;R=O;break}MY()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+4|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}JU(R,w,x,c[g+4>>2]|0,S,S+(T<<2)|0,F,H,o,c[p>>2]|0,c[q>>2]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];CS(b,k,R,e,w,g,h);if((Q|0)==0){YO(t);YO(s);uO(r);U=c[z>>2]|0;V=U;W=V;X=MN(W)|0;i=d;return}AY(Q);YO(t);YO(s);uO(r);U=c[z>>2]|0;V=U;W=V;X=MN(W)|0;i=d;return}function LU(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function MU(a){a=a|0;i=i;return}function NU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=pc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function OU(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;j=d;k=j;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;k=a[h]|0;if((k&1)==0){l=h+1|0;m=h+1|0;n=(k&255)>>>1}else{k=c[h+8>>2]|0;l=k;m=k;n=c[h+4>>2]|0}h=l+n|0;do{if(m>>>0<h>>>0){n=m;do{MO(j,a[n]|0);n=n+1|0;}while(n>>>0<h>>>0);n=(e|0)==-1?-1:e<<1;if((a[j]&1)==0){o=n;p=9;break}q=n;r=c[j+8>>2]|0}else{o=(e|0)==-1?-1:e<<1;p=9}}while(0);if((p|0)==9){q=o;r=j+1|0}o=nd(q|0,f|0,g|0,r|0)|0;r=b;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;r=bZ(o|0)|0;g=o+r|0;if((r|0)>0){s=o}else{uO(j);i=d;return}do{MO(b,a[s]|0);s=s+1|0;}while(s>>>0<g>>>0);uO(j);i=d;return}function PU(a,b){a=a|0;b=b|0;a=i;Db(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function QU(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function RU(a){a=a|0;i=i;return}function SU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=pc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function TU(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+240|0;j=d;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=d+224|0;t=d+232|0;u=r;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[s+4>>2]=0;c[s>>2]=137128;u=a[h]|0;if((u&1)==0){v=h+4|0;w=h+4|0;x=(u&255)>>>1}else{u=c[h+8>>2]|0;v=u;w=u;x=c[h+4>>2]|0}h=v+(x<<2)|0;x=k;v=j;u=j;c[u>>2]=0;c[u+4>>2]=0;a:do{if(w>>>0<h>>>0){u=s;j=k+32|0;y=w;z=137128|0;while(1){c[m>>2]=y;A=(te[c[z+12>>2]&15](u,v,y,h,m,x,j,l)|0)==2;B=c[m>>2]|0;if(A|(B|0)==(y|0)){break}if(x>>>0<(c[l>>2]|0)>>>0){A=x;do{MO(r,a[A]|0);A=A+1|0;}while(A>>>0<(c[l>>2]|0)>>>0);C=c[m>>2]|0}else{C=B}if(!(C>>>0<h>>>0)){break a}y=C;z=c[s>>2]|0}mU(136352)}}while(0);if((a[r]&1)==0){D=r+1|0}else{D=c[r+8>>2]|0}s=nd(((e|0)==-1?-1:e<<1)|0,f|0,g|0,D|0)|0;D=b;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[t+4>>2]=0;c[t>>2]=137232;D=bZ(s|0)|0;g=s+D|0;f=n;e=n;c[e>>2]=0;c[e+4>>2]=0;if((D|0)<=0){uO(r);i=d;return}D=t;e=g;n=o;C=o+128|0;o=s;s=137232|0;while(1){c[q>>2]=o;h=(te[c[s+16>>2]&15](D,f,o,(e-o|0)>32?o+32|0:g,q,n,C,p)|0)==2;m=c[q>>2]|0;if(h|(m|0)==(o|0)){E=20;break}if(n>>>0<(c[p>>2]|0)>>>0){h=n;do{aP(b,c[h>>2]|0);h=h+4|0;}while(h>>>0<(c[p>>2]|0)>>>0);F=c[q>>2]|0}else{F=m}if(!(F>>>0<g>>>0)){E=25;break}o=F;s=c[t>>2]|0}if((E|0)==20){mU(136352)}else if((E|0)==25){uO(r);i=d;return}}function UU(a,b){a=a|0;b=b|0;a=i;Db(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function VU(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=135560;e=b+8|0;b=c[e>>2]|0;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);if((b|0)==(c[33840]|0)){i=d;return}Xb(c[e>>2]|0);i=d;return}function WU(a){a=a|0;a=zc(8)|0;NN(a,135352);c[a>>2]=132320;Hd(a|0,132360,40)}function XU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+448|0;f=e;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;z=e+304|0;A=e+320|0;B=e+336|0;C=e+352|0;D=e+368|0;E=e+384|0;F=e+400|0;G=e+416|0;H=e+432|0;c[b+4>>2]=d+ -1;c[b>>2]=135392;d=b+8|0;I=b+12|0;J=b+136|0;a[J]=1;K=b+24|0;c[I>>2]=K;c[d>>2]=K;c[b+16>>2]=J;J=28;L=K;do{if((L|0)==0){M=0}else{c[L>>2]=0;M=c[I>>2]|0}L=M+4|0;c[I>>2]=L;J=J+ -1|0;}while((J|0)!=0);mO(b+144|0,135376,1);J=c[d>>2]|0;d=c[I>>2]|0;if((d|0)!=(J|0)){c[I>>2]=d+(~((d+ -4+(0-J)|0)>>>2)<<2)}c[140284>>2]=0;c[35070]=133872;if(!((c[33474]|0)==-1)){c[G>>2]=133896;c[G+4>>2]=281;c[G+8>>2]=0;fO(133896,G,282)}YU(b,140280,(c[133900>>2]|0)+ -1|0);c[140276>>2]=0;c[35068]=133912;if(!((c[33484]|0)==-1)){c[F>>2]=133936;c[F+4>>2]=281;c[F+8>>2]=0;fO(133936,F,282)}YU(b,140272,(c[133940>>2]|0)+ -1|0);c[140260>>2]=0;c[35064]=135488;c[140264>>2]=0;a[140268|0]=0;F=c[(tc()|0)>>2]|0;c[140264>>2]=F;if(!((c[33868]|0)==-1)){c[E>>2]=135472;c[E+4>>2]=281;c[E+8>>2]=0;fO(135472,E,282)}YU(b,140256,(c[135476>>2]|0)+ -1|0);c[140252>>2]=0;c[35062]=136448;if(!((c[33866]|0)==-1)){c[D>>2]=135464;c[D+4>>2]=281;c[D+8>>2]=0;fO(135464,D,282)}YU(b,140248,(c[135468>>2]|0)+ -1|0);c[140244>>2]=0;c[35060]=136664;if(!((c[33884]|0)==-1)){c[C>>2]=135536;c[C+4>>2]=281;c[C+8>>2]=0;fO(135536,C,282)}YU(b,140240,(c[135540>>2]|0)+ -1|0);c[140228>>2]=0;c[35056]=135560;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);c[140232>>2]=c[33840];if(!((c[33886]|0)==-1)){c[B>>2]=135544;c[B+4>>2]=281;c[B+8>>2]=0;fO(135544,B,282)}YU(b,140224,(c[135548>>2]|0)+ -1|0);c[140220>>2]=0;c[35054]=136888;if(!((c[33900]|0)==-1)){c[A>>2]=135600;c[A+4>>2]=281;c[A+8>>2]=0;fO(135600,A,282)}YU(b,140216,(c[135604>>2]|0)+ -1|0);c[140212>>2]=0;c[35052]=137008;if(!((c[33902]|0)==-1)){c[z>>2]=135608;c[z+4>>2]=281;c[z+8>>2]=0;fO(135608,z,282)}YU(b,140208,(c[135612>>2]|0)+ -1|0);c[140188>>2]=0;c[35046]=135640;a[140192|0]=46;a[140193|0]=44;z=140196|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;if(!((c[33904]|0)==-1)){c[y>>2]=135616;c[y+4>>2]=281;c[y+8>>2]=0;fO(135616,y,282)}YU(b,140184,(c[135620>>2]|0)+ -1|0);c[140156>>2]=0;c[35038]=135680;c[140160>>2]=46;c[140164>>2]=44;y=140168|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(!((c[33906]|0)==-1)){c[x>>2]=135624;c[x+4>>2]=281;c[x+8>>2]=0;fO(135624,x,282)}YU(b,140152,(c[135628>>2]|0)+ -1|0);c[140148>>2]=0;c[35036]=133952;if(!((c[33502]|0)==-1)){c[w>>2]=134008;c[w+4>>2]=281;c[w+8>>2]=0;fO(134008,w,282)}YU(b,140144,(c[134012>>2]|0)+ -1|0);c[140140>>2]=0;c[35034]=134072;if(!((c[33532]|0)==-1)){c[v>>2]=134128;c[v+4>>2]=281;c[v+8>>2]=0;fO(134128,v,282)}YU(b,140136,(c[134132>>2]|0)+ -1|0);c[140132>>2]=0;c[35032]=134144;if(!((c[33548]|0)==-1)){c[u>>2]=134192;c[u+4>>2]=281;c[u+8>>2]=0;fO(134192,u,282)}YU(b,140128,(c[134196>>2]|0)+ -1|0);c[140124>>2]=0;c[35030]=134208;if(!((c[33564]|0)==-1)){c[t>>2]=134256;c[t+4>>2]=281;c[t+8>>2]=0;fO(134256,t,282)}YU(b,140120,(c[134260>>2]|0)+ -1|0);c[140116>>2]=0;c[35028]=134800;if(!((c[33712]|0)==-1)){c[s>>2]=134848;c[s+4>>2]=281;c[s+8>>2]=0;fO(134848,s,282)}YU(b,140112,(c[134852>>2]|0)+ -1|0);c[140108>>2]=0;c[35026]=134864;if(!((c[33728]|0)==-1)){c[r>>2]=134912;c[r+4>>2]=281;c[r+8>>2]=0;fO(134912,r,282)}YU(b,140104,(c[134916>>2]|0)+ -1|0);c[140100>>2]=0;c[35024]=134928;if(!((c[33744]|0)==-1)){c[q>>2]=134976;c[q+4>>2]=281;c[q+8>>2]=0;fO(134976,q,282)}YU(b,140096,(c[134980>>2]|0)+ -1|0);c[140092>>2]=0;c[35022]=134992;if(!((c[33760]|0)==-1)){c[p>>2]=135040;c[p+4>>2]=281;c[p+8>>2]=0;fO(135040,p,282)}YU(b,140088,(c[135044>>2]|0)+ -1|0);c[140084>>2]=0;c[35020]=135056;if(!((c[33770]|0)==-1)){c[o>>2]=135080;c[o+4>>2]=281;c[o+8>>2]=0;fO(135080,o,282)}YU(b,140080,(c[135084>>2]|0)+ -1|0);c[140076>>2]=0;c[35018]=135136;if(!((c[33790]|0)==-1)){c[n>>2]=135160;c[n+4>>2]=281;c[n+8>>2]=0;fO(135160,n,282)}YU(b,140072,(c[135164>>2]|0)+ -1|0);c[140068>>2]=0;c[35016]=135192;if(!((c[33804]|0)==-1)){c[m>>2]=135216;c[m+4>>2]=281;c[m+8>>2]=0;fO(135216,m,282)}YU(b,140064,(c[135220>>2]|0)+ -1|0);c[140060>>2]=0;c[35014]=135240;if(!((c[33816]|0)==-1)){c[l>>2]=135264;c[l+4>>2]=281;c[l+8>>2]=0;fO(135264,l,282)}YU(b,140056,(c[135268>>2]|0)+ -1|0);c[140044>>2]=0;c[35010]=134288;c[140048>>2]=134336;if(!((c[33592]|0)==-1)){c[k>>2]=134368;c[k+4>>2]=281;c[k+8>>2]=0;fO(134368,k,282)}YU(b,140040,(c[134372>>2]|0)+ -1|0);c[140028>>2]=0;c[35006]=134440;c[140032>>2]=134488;if(!((c[33630]|0)==-1)){c[j>>2]=134520;c[j+4>>2]=281;c[j+8>>2]=0;fO(134520,j,282)}YU(b,140024,(c[134524>>2]|0)+ -1|0);c[140012>>2]=0;c[35002]=136384;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);c[140016>>2]=c[33840];c[35002]=134736;if(!((c[33688]|0)==-1)){c[h>>2]=134752;c[h+4>>2]=281;c[h+8>>2]=0;fO(134752,h,282)}YU(b,140008,(c[134756>>2]|0)+ -1|0);c[139996>>2]=0;c[34998]=136384;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);c[14e4>>2]=c[33840];c[34998]=134768;if(!((c[33696]|0)==-1)){c[g>>2]=134784;c[g+4>>2]=281;c[g+8>>2]=0;fO(134784,g,282)}YU(b,139992,(c[134788>>2]|0)+ -1|0);c[139988>>2]=0;c[34996]=135280;if(!((c[33826]|0)==-1)){c[f>>2]=135304;c[f+4>>2]=281;c[f+8>>2]=0;fO(135304,f,282)}YU(b,139984,(c[135308>>2]|0)+ -1|0);c[139980>>2]=0;c[34994]=135320;if((c[33836]|0)==-1){N=135344;O=135344;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=139976;YU(b,T,S);i=e;return}c[H>>2]=135344;c[H+4>>2]=281;c[H+8>>2]=0;fO(135344,H,282);N=135344;O=135344;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=139976;YU(b,T,S);i=e;return}function YU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;LN(b);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f;j=c[h>>2]|0;k=a-j>>2;do{if(k>>>0>d>>>0){l=j}else{m=d+1|0;if(k>>>0<m>>>0){bX(f,m-k|0);l=c[h>>2]|0;break}if(!(k>>>0>m>>>0)){l=j;break}n=j+(m<<2)|0;if((a|0)==(n|0)){l=j;break}c[g>>2]=a+(~((a+ -4+(0-n)|0)>>>2)<<2);l=j}}while(0);j=c[l+(d<<2)>>2]|0;if((j|0)==0){o=l;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}MN(j)|0;o=c[h>>2]|0;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}function ZU(a){a=a|0;var b=0;b=i;_U(a);HY(a);i=b;return}function _U(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[b>>2]=135392;e=b+12|0;f=c[e>>2]|0;g=b+8|0;h=c[g>>2]|0;if((f|0)!=(h|0)){j=f;f=h;h=0;while(1){k=c[f+(h<<2)>>2]|0;if((k|0)==0){l=f;m=j}else{MN(k)|0;l=c[g>>2]|0;m=c[e>>2]|0}k=h+1|0;if(k>>>0<m-l>>2>>>0){j=m;f=l;h=k}else{break}}}uO(b+144|0);h=c[g>>2]|0;if((h|0)==0){i=d;return}g=c[e>>2]|0;if((g|0)!=(h|0)){c[e>>2]=g+(~((g+ -4+(0-h)|0)>>>2)<<2)}if((b+24|0)==(h|0)){a[b+136|0]=0;i=d;return}else{HY(h);i=d;return}}function $U(){var b=0,d=0,e=0,f=0;b=i;if((a[135448]|0)!=0){d=135440;e=c[33860]|0;i=b;return e|0}if((Wa(135448)|0)==0){d=135440;e=c[33860]|0;i=b;return e|0}do{if((a[135424]|0)==0){if((Wa(135424)|0)==0){break}XU(139816,1);c[33852]=139816;c[33854]=135408;Ob(135424)}}while(0);f=c[c[33854]>>2]|0;c[33858]=f;LN(f);c[33860]=135432;Ob(135448);d=135440;e=c[33860]|0;i=b;return e|0}function aV(a){a=a|0;var b=0,d=0;b=i;d=c[($U()|0)>>2]|0;c[a>>2]=d;LN(d);i=b;return}function bV(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;LN(e);i=d;return}function cV(a){a=a|0;var b=0;b=i;MN(c[a>>2]|0)|0;i=b;return}function dV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=281;c[e+8>>2]=0;fO(a,e,282)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function eV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=281;c[e+8>>2]=0;fO(a,e,282)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=zc(4)|0;h=g;eY(h);j=151032;k=127;Hd(g|0,j|0,k|0)}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=zc(4)|0;h=g;eY(h);j=151032;k=127;Hd(g|0,j|0,k|0)}else{i=d;return f|0}return 0}function fV(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function gV(a){a=a|0;var b=0;b=i;if((a|0)==0){i=b;return}Vd[c[(c[a>>2]|0)+4>>2]&511](a);i=b;return}function hV(a){a=a|0;var b=0;b=c[33864]|0;c[33864]=1+b;c[a+4>>2]=b+1;i=i;return}function iV(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function jV(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;a=i;if(!(e>>>0<128)){f=0;i=a;return f|0}f=(b[(c[(tc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;i=a;return f|0}function kV(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;if((d|0)==(e|0)){g=d;i=a;return g|0}else{h=d;j=f}while(1){f=c[h>>2]|0;if(f>>>0<128){k=b[(c[(tc()|0)>>2]|0)+(f<<1)>>1]|0}else{k=0}b[j>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;break}else{h=f;j=j+2|0}}i=a;return g|0}function lV(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;if((e|0)==(f|0)){g=e;i=a;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128){if(!((b[(c[(tc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16==0)){g=h;j=5;break}}e=h+4|0;if((e|0)==(f|0)){g=f;j=5;break}else{h=e}}if((j|0)==5){i=a;return g|0}return 0}function mV(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;a:do{if((e|0)==(f|0)){g=e}else{h=e;while(1){j=c[h>>2]|0;if(!(j>>>0<128)){g=h;break a}k=h+4|0;if((b[(c[(tc()|0)>>2]|0)+(j<<1)>>1]&d)<<16>>16==0){g=h;break a}if((k|0)==(f|0)){g=f;break}else{h=k}}}}while(0);i=a;return g|0}function nV(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(rd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function oV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(rd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function pV(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(wd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function qV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(wd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function rV(a,b){a=a|0;b=b|0;i=i;return b<<24>>24|0}function sV(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((d|0)==(e|0)){g=d;i=b;return g|0}else{h=d;j=f}while(1){c[j>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{j=j+4|0;h=f}}i=b;return g|0}function tV(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b>>>0<128?b&255:c)|0}function uV(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;if((d|0)==(e|0)){h=d;i=b;return h|0}j=((e+ -4+(0-d)|0)>>>2)+1|0;k=d;l=g;while(1){g=c[k>>2]|0;a[l]=g>>>0<128?g&255:f;g=k+4|0;if((g|0)==(e|0)){break}else{l=l+1|0;k=g}}h=d+(j<<2)|0;i=b;return h|0}function vV(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=135488;e=c[b+8>>2]|0;do{if((e|0)!=0){if((a[b+12|0]|0)==0){break}IY(e)}}while(0);HY(b);i=d;return}function wV(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=135488;e=c[b+8>>2]|0;if((e|0)==0){i=d;return}if((a[b+12|0]|0)==0){i=d;return}IY(e);i=d;return}function xV(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(rd()|0)>>2]|0)+((b&255)<<2)>>2]&255;i=a;return d|0}function yV(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(rd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function zV(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(wd()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;i=a;return d|0}function AV(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(wd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function BV(a,b){a=a|0;b=b|0;i=i;return b|0}function CV(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((c|0)==(d|0)){f=c;i=b;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{h=h+1|0;g=e}}i=b;return f|0}function DV(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b<<24>>24>-1?b:c)|0}function EV(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((c|0)==(d|0)){g=c;i=b;return g|0}else{h=c;j=f}while(1){f=a[h]|0;a[j]=f<<24>>24>-1?f:e;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{j=j+1|0;h=f}}i=b;return g|0}function FV(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function GV(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function HV(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function IV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function JV(a){a=a|0;i=i;return 1}function KV(a){a=a|0;i=i;return 1}function LV(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;i=i;return(b>>>0<e>>>0?b:e)|0}function MV(a){a=a|0;i=i;return 1}function NV(a){a=a|0;var b=0;b=i;VU(a);HY(a);i=b;return}function OV(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+8|0;m=l;n=m;o=i;i=i+8|0;p=(e|0)==(f|0);a:do{if(p){c[k>>2]=h;c[g>>2]=e;q=e}else{r=e;while(1){s=r+4|0;if((c[r>>2]|0)==0){t=r;break}if((s|0)==(f|0)){t=f;break}else{r=s}}c[k>>2]=h;c[g>>2]=e;if(p|(h|0)==(j|0)){q=e;break}r=j;s=b+8|0;u=o;v=e;w=h;x=t;while(1){y=d;z=c[y+4>>2]|0;A=m;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=Gc(c[s>>2]|0)|0;A=FX(w,g,x-v>>2,r-w|0,d)|0;if((z|0)!=0){Gc(z|0)|0}if((A|0)==-1){B=10;break}else if((A|0)==0){C=1;B=33;break}z=(c[k>>2]|0)+A|0;c[k>>2]=z;if((z|0)==(j|0)){B=31;break}if((x|0)==(f|0)){D=c[g>>2]|0;E=z;F=f}else{z=Gc(c[s>>2]|0)|0;A=EX(u,0,d)|0;if((z|0)!=0){Gc(z|0)|0}if((A|0)==-1){C=2;B=33;break}z=c[k>>2]|0;if(A>>>0>(r-z|0)>>>0){C=1;B=33;break}b:do{if((A|0)!=0){y=z;G=A;H=u;while(1){I=a[H]|0;c[k>>2]=y+1;a[y]=I;I=G+ -1|0;if((I|0)==0){break b}y=c[k>>2]|0;H=H+1|0;G=I}}}while(0);A=(c[g>>2]|0)+4|0;c[g>>2]=A;c:do{if((A|0)==(f|0)){J=f}else{z=A;while(1){G=z+4|0;if((c[z>>2]|0)==0){J=z;break c}if((G|0)==(f|0)){J=f;break}else{z=G}}}}while(0);D=A;E=c[k>>2]|0;F=J}if((D|0)==(f|0)|(E|0)==(j|0)){q=D;break a}else{v=D;w=E;x=F}}if((B|0)==10){c[k>>2]=w;d:do{if((v|0)==(c[g>>2]|0)){K=v}else{x=v;u=w;while(1){r=c[x>>2]|0;z=Gc(c[s>>2]|0)|0;G=EX(u,r,n)|0;if((z|0)!=0){Gc(z|0)|0}if((G|0)==-1){K=x;break d}z=(c[k>>2]|0)+G|0;c[k>>2]=z;G=x+4|0;if((G|0)==(c[g>>2]|0)){K=G;break}else{x=G;u=z}}}}while(0);c[g>>2]=K;C=2;i=l;return C|0}else if((B|0)==31){q=c[g>>2]|0;break}else if((B|0)==33){i=l;return C|0}}}while(0);C=(q|0)!=(f|0)|0;i=l;return C|0}function PV(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=i;i=i+8|0;m=l;n=m;o=(e|0)==(f|0);a:do{if(o){c[k>>2]=h;c[g>>2]=e;p=e}else{q=e;while(1){r=q+1|0;if((a[q]|0)==0){s=q;break}if((r|0)==(f|0)){s=f;break}else{q=r}}c[k>>2]=h;c[g>>2]=e;if(o|(h|0)==(j|0)){p=e;break}q=j;r=b+8|0;t=e;u=h;v=s;while(1){w=d;x=c[w+4>>2]|0;y=m;c[y>>2]=c[w>>2];c[y+4>>2]=x;z=v;x=Gc(c[r>>2]|0)|0;y=BX(u,g,z-t|0,q-u>>2,d)|0;if((x|0)!=0){Gc(x|0)|0}if((y|0)==0){A=2;B=32;break}else if((y|0)==-1){B=10;break}x=(c[k>>2]|0)+(y<<2)|0;c[k>>2]=x;if((x|0)==(j|0)){B=30;break}y=c[g>>2]|0;if((v|0)==(f|0)){C=y;D=x;E=f}else{w=Gc(c[r>>2]|0)|0;F=AX(x,y,1,d)|0;if((w|0)!=0){Gc(w|0)|0}if((F|0)!=0){A=2;B=32;break}c[k>>2]=(c[k>>2]|0)+4;F=(c[g>>2]|0)+1|0;c[g>>2]=F;b:do{if((F|0)==(f|0)){G=f}else{w=F;while(1){y=w+1|0;if((a[w]|0)==0){G=w;break b}if((y|0)==(f|0)){G=f;break}else{w=y}}}}while(0);C=F;D=c[k>>2]|0;E=G}if((C|0)==(f|0)|(D|0)==(j|0)){p=C;break a}else{t=C;u=D;v=E}}if((B|0)==10){c[k>>2]=u;c:do{if((t|0)==(c[g>>2]|0)){H=t}else{v=t;q=u;while(1){w=Gc(c[r>>2]|0)|0;y=AX(q,v,z-v|0,n)|0;if((w|0)!=0){Gc(w|0)|0}if((y|0)==-1){B=15;break}else if((y|0)==0){I=v+1|0}else if((y|0)==-2){B=16;break}else{I=v+y|0}y=(c[k>>2]|0)+4|0;c[k>>2]=y;if((I|0)==(c[g>>2]|0)){H=I;break c}else{v=I;q=y}}if((B|0)==15){c[g>>2]=v;A=2;i=l;return A|0}else if((B|0)==16){c[g>>2]=v;A=1;i=l;return A|0}}}while(0);c[g>>2]=H;A=(H|0)!=(f|0)|0;i=l;return A|0}else if((B|0)==30){p=c[g>>2]|0;break}else if((B|0)==32){i=l;return A|0}}}while(0);A=(p|0)!=(f|0)|0;i=l;return A|0}function QV(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h;j=Gc(c[b+8>>2]|0)|0;b=EX(e,0,d)|0;if((j|0)!=0){Gc(j|0)|0}if((b|0)==0|(b|0)==-1){k=2;i=h;return k|0}j=b+ -1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=b;m=j;n=e}while(1){e=a[n]|0;c[g>>2]=l+1;a[l]=e;e=m+ -1|0;if((e|0)==0){k=0;break}l=c[g>>2]|0;n=n+1|0;m=e}i=h;return k|0}function RV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+8|0;a=Gc(c[d>>2]|0)|0;e=DX(0,0,4)|0;if((a|0)!=0){Gc(a|0)|0}do{if((e|0)==0){a=c[d>>2]|0;if((a|0)==0){f=1;break}g=Gc(a|0)|0;if((g|0)==0){f=0;break}Gc(g|0)|0;f=0}else{f=-1}}while(0);i=b;return f|0}function SV(a){a=a|0;i=i;return 0}function TV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((f|0)==0|(d|0)==(e|0)){h=0;i=g;return h|0}j=e;k=a+8|0;a=d;d=0;l=0;while(1){m=Gc(c[k>>2]|0)|0;n=zX(a,j-a|0,b)|0;if((m|0)!=0){Gc(m|0)|0}if((n|0)==-2|(n|0)==-1){h=d;o=9;break}else if((n|0)==0){p=a+1|0;q=1}else{p=a+n|0;q=n}n=q+d|0;m=l+1|0;if(m>>>0>=f>>>0|(p|0)==(e|0)){h=n;o=9;break}else{a=p;d=n;l=m}}if((o|0)==9){i=g;return h|0}return 0}function UV(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;do{if((d|0)==0){e=1}else{a=Gc(d|0)|0;if((a|0)==0){e=4;break}Gc(a|0)|0;e=4}}while(0);i=b;return e|0}function VV(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function WV(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=XV(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function XV(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;c[g>>2]=d;c[k>>2]=h;do{if((m&2|0)!=0){if((j-h|0)<3){o=1;i=n;return o|0}else{c[k>>2]=h+1;a[h]=-17;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-69;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-65;break}}}while(0);h=f;m=c[g>>2]|0;if(!(m>>>0<f>>>0)){o=0;i=n;return o|0}d=j;j=m;a:while(1){m=b[j>>1]|0;p=m&65535;if(p>>>0>l>>>0){o=2;q=26;break}do{if((m&65535)<128){r=c[k>>2]|0;if((d-r|0)<1){o=1;q=26;break a}c[k>>2]=r+1;a[r]=m}else{if((m&65535)<2048){r=c[k>>2]|0;if((d-r|0)<2){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>6|192;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((m&65535)<55296){r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if(!((m&65535)<56320)){if((m&65535)<57344){o=2;q=26;break a}r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((h-j|0)<4){o=1;q=26;break a}r=j+2|0;s=e[r>>1]|0;if((s&64512|0)!=56320){o=2;q=26;break a}if((d-(c[k>>2]|0)|0)<4){o=1;q=26;break a}t=p&960;if(((t<<10)+65536|p<<10&64512|s&1023)>>>0>l>>>0){o=2;q=26;break a}c[g>>2]=r;r=(t>>>6)+1|0;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=r>>>2|240;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=p>>>2&15|r<<4&48|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p<<4&48|s>>>6&15|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=s&63|128}}while(0);p=(c[g>>2]|0)+2|0;c[g>>2]=p;if(p>>>0<f>>>0){j=p}else{o=0;q=26;break}}if((q|0)==26){i=n;return o|0}return 0}function YV(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=ZV(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function ZV(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;c[g>>2]=e;c[k>>2]=h;h=c[g>>2]|0;do{if((m&4|0)==0){o=h}else{if((f-h|0)<=2){o=h;break}if(!((a[h]|0)==-17)){o=h;break}if(!((a[h+1|0]|0)==-69)){o=h;break}if(!((a[h+2|0]|0)==-65)){o=h;break}e=h+3|0;c[g>>2]=e;o=e}}while(0);a:do{if(o>>>0<f>>>0){h=f;m=j;e=o;p=c[k>>2]|0;b:while(1){if(!(p>>>0<j>>>0)){q=e;break a}r=a[e]|0;s=r&255;if(s>>>0>l>>>0){t=2;u=41;break}do{if(r<<24>>24>-1){b[p>>1]=r&255;c[g>>2]=e+1}else{if((r&255)<194){t=2;u=41;break b}if((r&255)<224){if((h-e|0)<2){t=1;u=41;break b}v=d[e+1|0]|0;if((v&192|0)!=128){t=2;u=41;break b}w=v&63|s<<6&1984;if(w>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=w;c[g>>2]=e+2;break}if((r&255)<240){if((h-e|0)<3){t=1;u=41;break b}w=a[e+1|0]|0;v=a[e+2|0]|0;if((s|0)==237){if(!((w&-32)<<24>>24==-128)){t=2;u=41;break b}}else if((s|0)==224){if(!((w&-32)<<24>>24==-96)){t=2;u=41;break b}}else{if(!((w&-64)<<24>>24==-128)){t=2;u=41;break b}}x=v&255;if((x&192|0)!=128){t=2;u=41;break b}v=(w&255)<<6&4032|s<<12|x&63;if((v&65535)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=v;c[g>>2]=e+3;break}if(!((r&255)<245)){t=2;u=41;break b}if((h-e|0)<4){t=1;u=41;break b}v=a[e+1|0]|0;x=a[e+2|0]|0;w=a[e+3|0]|0;if((s|0)==244){if(!((v&-16)<<24>>24==-128)){t=2;u=41;break b}}else if((s|0)==240){if(!((v+112<<24>>24&255)<48)){t=2;u=41;break b}}else{if(!((v&-64)<<24>>24==-128)){t=2;u=41;break b}}y=x&255;if((y&192|0)!=128){t=2;u=41;break b}x=w&255;if((x&192|0)!=128){t=2;u=41;break b}if((m-p|0)<4){t=1;u=41;break b}w=s&7;z=v&255;v=y<<6;A=x&63;if((z<<12&258048|w<<18|v&4032|A)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=z<<2&60|y>>>4&3|((z>>>4&3|w<<2)<<6)+16320|55296;w=p+2|0;c[k>>2]=w;b[w>>1]=A|v&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);s=(c[k>>2]|0)+2|0;c[k>>2]=s;r=c[g>>2]|0;if(r>>>0<f>>>0){e=r;p=s}else{q=r;break a}}if((u|0)==41){i=n;return t|0}}else{q=o}}while(0);t=q>>>0<f>>>0|0;i=n;return t|0}function _V(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function $V(a){a=a|0;i=i;return 0}function aW(a){a=a|0;i=i;return 0}function bW(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=cW(c,d,e,1114111,0)|0;i=b;return a|0}function cW(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k]|0;n=m&255;if(n>>>0>f>>>0){o=k;break a}do{if(m<<24>>24>-1){p=k+1|0;q=l}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}r=d[k+1|0]|0;if((r&192|0)!=128){o=k;break a}if((r&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;q=l;break}if((m&255)<240){s=k;if((g-s|0)<3){o=k;break a}r=a[k+1|0]|0;t=a[k+2|0]|0;if((n|0)==237){if(!((r&-32)<<24>>24==-128)){u=23;break b}}else if((n|0)==224){if(!((r&-32)<<24>>24==-96)){u=21;break b}}else{if(!((r&-64)<<24>>24==-128)){u=25;break b}}v=t&255;if((v&192|0)!=128){o=k;break a}if(((r&255)<<6&4032|n<<12&61440|v&63)>>>0>f>>>0){o=k;break a}p=k+3|0;q=l;break}if(!((m&255)<245)){o=k;break a}w=k;if((g-w|0)<4){o=k;break a}if((e-l|0)>>>0<2){o=k;break a}v=a[k+1|0]|0;r=a[k+2|0]|0;t=a[k+3|0]|0;if((n|0)==240){if(!((v+112<<24>>24&255)<48)){u=34;break b}}else if((n|0)==244){if(!((v&-16)<<24>>24==-128)){u=36;break b}}else{if(!((v&-64)<<24>>24==-128)){u=38;break b}}x=r&255;if((x&192|0)!=128){o=k;break a}r=t&255;if((r&192|0)!=128){o=k;break a}if(((v&255)<<12&258048|n<<18&1835008|x<<6&4032|r&63)>>>0>f>>>0){o=k;break a}p=k+4|0;q=l+1|0}}while(0);n=q+1|0;if(p>>>0<c>>>0&n>>>0<e>>>0){k=p;l=n}else{o=p;break a}}if((u|0)==21){y=s-b|0;i=h;return y|0}else if((u|0)==23){y=s-b|0;i=h;return y|0}else if((u|0)==25){y=s-b|0;i=h;return y|0}else if((u|0)==34){y=w-b|0;i=h;return y|0}else if((u|0)==36){y=w-b|0;i=h;return y|0}else if((u|0)==38){y=w-b|0;i=h;return y|0}}else{o=j}}while(0);y=o-b|0;i=h;return y|0}function dW(a){a=a|0;i=i;return 4}function eW(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function fW(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=gW(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function gW(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;c[e>>2]=b;c[h>>2]=f;do{if((k&2|0)!=0){if((g-f|0)<3){m=1;i=l;return m|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(!(f>>>0<d>>>0)){m=0;i=l;return m|0}k=g;g=f;a:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>j>>>0){m=2;n=19;break}do{if(f>>>0<128){b=c[h>>2]|0;if((k-b|0)<1){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048){b=c[h>>2]|0;if((k-b|0)<2){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;o=k-b|0;if(f>>>0<65536){if((o|0)<3){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>12|224;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f>>>6&63|128;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f&63|128;break}else{if((o|0)<4){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{m=0;n=19;break}}if((n|0)==19){i=l;return m|0}return 0}function hW(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=iW(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function iW(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;c[f>>2]=b;c[j>>2]=g;g=c[f>>2]|0;do{if((l&4|0)==0){n=g}else{if((e-g|0)<=2){n=g;break}if(!((a[g]|0)==-17)){n=g;break}if(!((a[g+1|0]|0)==-69)){n=g;break}if(!((a[g+2|0]|0)==-65)){n=g;break}b=g+3|0;c[f>>2]=b;n=b}}while(0);a:do{if(n>>>0<e>>>0){g=e;l=n;b=c[j>>2]|0;b:while(1){if(!(b>>>0<h>>>0)){o=l;break a}p=a[l]|0;q=p&255;do{if(p<<24>>24>-1){if(q>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=q;c[f>>2]=l+1}else{if((p&255)<194){r=2;s=40;break b}if((p&255)<224){if((g-l|0)<2){r=1;s=40;break b}t=d[l+1|0]|0;if((t&192|0)!=128){r=2;s=40;break b}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+2;break}if((p&255)<240){if((g-l|0)<3){r=1;s=40;break b}u=a[l+1|0]|0;t=a[l+2|0]|0;if((q|0)==224){if(!((u&-32)<<24>>24==-96)){r=2;s=40;break b}}else if((q|0)==237){if(!((u&-32)<<24>>24==-128)){r=2;s=40;break b}}else{if(!((u&-64)<<24>>24==-128)){r=2;s=40;break b}}v=t&255;if((v&192|0)!=128){r=2;s=40;break b}t=(u&255)<<6&4032|q<<12&61440|v&63;if(t>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=t;c[f>>2]=l+3;break}if(!((p&255)<245)){r=2;s=40;break b}if((g-l|0)<4){r=1;s=40;break b}t=a[l+1|0]|0;v=a[l+2|0]|0;u=a[l+3|0]|0;if((q|0)==244){if(!((t&-16)<<24>>24==-128)){r=2;s=40;break b}}else if((q|0)==240){if(!((t+112<<24>>24&255)<48)){r=2;s=40;break b}}else{if(!((t&-64)<<24>>24==-128)){r=2;s=40;break b}}w=v&255;if((w&192|0)!=128){r=2;s=40;break b}v=u&255;if((v&192|0)!=128){r=2;s=40;break b}u=(t&255)<<12&258048|q<<18&1835008|w<<6&4032|v&63;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+4}}while(0);q=(c[j>>2]|0)+4|0;c[j>>2]=q;p=c[f>>2]|0;if(p>>>0<e>>>0){l=p;b=q}else{o=p;break a}}if((s|0)==40){i=m;return r|0}}else{o=n}}while(0);r=o>>>0<e>>>0|0;i=m;return r|0}function jW(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function kW(a){a=a|0;i=i;return 0}function lW(a){a=a|0;i=i;return 0}function mW(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=nW(c,d,e,1114111,0)|0;i=b;return a|0}function nW(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=1;b:while(1){m=a[k]|0;n=m&255;do{if(m<<24>>24>-1){if(n>>>0>f>>>0){o=k;break a}p=k+1|0}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}q=d[k+1|0]|0;if((q&192|0)!=128){o=k;break a}if((q&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;break}if((m&255)<240){r=k;if((g-r|0)<3){o=k;break a}q=a[k+1|0]|0;s=a[k+2|0]|0;if((n|0)==224){if(!((q&-32)<<24>>24==-96)){t=21;break b}}else if((n|0)==237){if(!((q&-32)<<24>>24==-128)){t=23;break b}}else{if(!((q&-64)<<24>>24==-128)){t=25;break b}}u=s&255;if((u&192|0)!=128){o=k;break a}if(((q&255)<<6&4032|n<<12&61440|u&63)>>>0>f>>>0){o=k;break a}p=k+3|0;break}if(!((m&255)<245)){o=k;break a}v=k;if((g-v|0)<4){o=k;break a}u=a[k+1|0]|0;q=a[k+2|0]|0;s=a[k+3|0]|0;if((n|0)==244){if(!((u&-16)<<24>>24==-128)){t=35;break b}}else if((n|0)==240){if(!((u+112<<24>>24&255)<48)){t=33;break b}}else{if(!((u&-64)<<24>>24==-128)){t=37;break b}}w=q&255;if((w&192|0)!=128){o=k;break a}q=s&255;if((q&192|0)!=128){o=k;break a}if(((u&255)<<12&258048|n<<18&1835008|w<<6&4032|q&63)>>>0>f>>>0){o=k;break a}p=k+4|0}}while(0);if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}k=p;l=l+1|0}if((t|0)==21){x=r-b|0;i=h;return x|0}else if((t|0)==23){x=r-b|0;i=h;return x|0}else if((t|0)==25){x=r-b|0;i=h;return x|0}else if((t|0)==33){x=v-b|0;i=h;return x|0}else if((t|0)==35){x=v-b|0;i=h;return x|0}else if((t|0)==37){x=v-b|0;i=h;return x|0}}else{o=j}}while(0);x=o-b|0;i=h;return x|0}function oW(a){a=a|0;i=i;return 4}function pW(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function qW(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function rW(a){a=a|0;var b=0;b=i;c[a>>2]=135640;uO(a+12|0);HY(a);i=b;return}function sW(a){a=a|0;var b=0;b=i;c[a>>2]=135640;uO(a+12|0);i=b;return}function tW(a){a=a|0;var b=0;b=i;c[a>>2]=135680;uO(a+16|0);HY(a);i=b;return}function uW(a){a=a|0;var b=0;b=i;c[a>>2]=135680;uO(a+16|0);i=b;return}function vW(b){b=b|0;i=i;return a[b+8|0]|0}function wW(a){a=a|0;i=i;return c[a+8>>2]|0}function xW(b){b=b|0;i=i;return a[b+9|0]|0}function yW(a){a=a|0;i=i;return c[a+12>>2]|0}function zW(a,b){a=a|0;b=b|0;var c=0;c=i;kO(a,b+12|0);i=c;return}function AW(a,b){a=a|0;b=b|0;var c=0;c=i;kO(a,b+16|0);i=c;return}function BW(a,b){a=a|0;b=b|0;b=i;mO(a,135712,4);i=b;return}function CW(a,b){a=a|0;b=b|0;b=i;WO(a,135720,$X(135720)|0);i=b;return}function DW(a,b){a=a|0;b=b|0;b=i;mO(a,135744,5);i=b;return}function EW(a,b){a=a|0;b=b|0;b=i;WO(a,135752,$X(135752)|0);i=b;return}function FW(b){b=b|0;var d=0,e=0;b=i;if((a[135784]|0)!=0){d=135776;e=c[33944]|0;i=b;return e|0}if((Wa(135784)|0)==0){d=135776;e=c[33944]|0;i=b;return e|0}do{if((a[142984]|0)==0){if((Wa(142984)|0)==0){break}fZ(142816,0,168)|0;Nd(284,0,q|0)|0;Ob(142984)}}while(0);xO(142816,142992)|0;xO(142828|0,143e3)|0;xO(142840|0,143008)|0;xO(142852|0,143016)|0;xO(142864|0,143032)|0;xO(142876|0,143048)|0;xO(142888|0,143056)|0;xO(142900|0,143072)|0;xO(142912|0,143080)|0;xO(142924|0,143088)|0;xO(142936|0,143096)|0;xO(142948|0,143104)|0;xO(142960|0,143112)|0;xO(142972|0,143120)|0;c[33944]=142816;Ob(135784);d=135776;e=c[33944]|0;i=b;return e|0}function GW(b){b=b|0;var d=0,e=0;b=i;if((a[135800]|0)!=0){d=135792;e=c[33948]|0;i=b;return e|0}if((Wa(135800)|0)==0){d=135792;e=c[33948]|0;i=b;return e|0}do{if((a[142448]|0)==0){if((Wa(142448)|0)==0){break}fZ(142280,0,168)|0;Nd(285,0,q|0)|0;Ob(142448)}}while(0);ZO(142280,142456)|0;ZO(142292|0,142488)|0;ZO(142304|0,142520)|0;ZO(142316|0,142552)|0;ZO(142328|0,142592)|0;ZO(142340|0,142632)|0;ZO(142352|0,142664)|0;ZO(142364|0,142704)|0;ZO(142376|0,142720)|0;ZO(142388|0,142736)|0;ZO(142400|0,142752)|0;ZO(142412|0,142768)|0;ZO(142424|0,142784)|0;ZO(142436|0,142800)|0;c[33948]=142280;Ob(135800);d=135792;e=c[33948]|0;i=b;return e|0}function HW(b){b=b|0;var d=0,e=0;b=i;if((a[135816]|0)!=0){d=135808;e=c[33952]|0;i=b;return e|0}if((Wa(135816)|0)==0){d=135808;e=c[33952]|0;i=b;return e|0}do{if((a[142056]|0)==0){if((Wa(142056)|0)==0){break}fZ(141768,0,288)|0;Nd(286,0,q|0)|0;Ob(142056)}}while(0);xO(141768,142064)|0;xO(141780|0,142072)|0;xO(141792|0,142088)|0;xO(141804|0,142096)|0;xO(141816|0,142104)|0;xO(141828|0,142112)|0;xO(141840|0,142120)|0;xO(141852|0,142128)|0;xO(141864|0,142136)|0;xO(141876|0,142152)|0;xO(141888|0,142160)|0;xO(141900|0,142176)|0;xO(141912|0,142192)|0;xO(141924|0,142200)|0;xO(141936|0,142208)|0;xO(141948|0,142216)|0;xO(141960|0,142104)|0;xO(141972|0,142224)|0;xO(141984|0,142232)|0;xO(141996|0,142240)|0;xO(142008|0,142248)|0;xO(142020|0,142256)|0;xO(142032|0,142264)|0;xO(142044|0,142272)|0;c[33952]=141768;Ob(135816);d=135808;e=c[33952]|0;i=b;return e|0}function IW(b){b=b|0;var d=0,e=0;b=i;if((a[135832]|0)!=0){d=135824;e=c[33956]|0;i=b;return e|0}if((Wa(135832)|0)==0){d=135824;e=c[33956]|0;i=b;return e|0}do{if((a[141216]|0)==0){if((Wa(141216)|0)==0){break}fZ(140928,0,288)|0;Nd(287,0,q|0)|0;Ob(141216)}}while(0);ZO(140928,141224)|0;ZO(140940|0,141256)|0;ZO(140952|0,141296)|0;ZO(140964|0,141320)|0;ZO(140976|0,141640)|0;ZO(140988|0,141344)|0;ZO(141e3|0,141368)|0;ZO(141012|0,141392)|0;ZO(141024|0,141424)|0;ZO(141036|0,141464)|0;ZO(141048|0,141496)|0;ZO(141060|0,141536)|0;ZO(141072|0,141576)|0;ZO(141084|0,141592)|0;ZO(141096|0,141608)|0;ZO(141108|0,141624)|0;ZO(141120|0,141640)|0;ZO(141132|0,141656)|0;ZO(141144|0,141672)|0;ZO(141156|0,141688)|0;ZO(141168|0,141704)|0;ZO(141180|0,141720)|0;ZO(141192|0,141736)|0;ZO(141204|0,141752)|0;c[33956]=140928;Ob(135832);d=135824;e=c[33956]|0;i=b;return e|0}function JW(b){b=b|0;var d=0,e=0;b=i;if((a[135848]|0)!=0){d=135840;e=c[33960]|0;i=b;return e|0}if((Wa(135848)|0)==0){d=135840;e=c[33960]|0;i=b;return e|0}do{if((a[140904]|0)==0){if((Wa(140904)|0)==0){break}fZ(140616,0,288)|0;Nd(288,0,q|0)|0;Ob(140904)}}while(0);xO(140616,140912)|0;xO(140628|0,140920)|0;c[33960]=140616;Ob(135848);d=135840;e=c[33960]|0;i=b;return e|0}function KW(b){b=b|0;var d=0,e=0;b=i;if((a[135864]|0)!=0){d=135856;e=c[33964]|0;i=b;return e|0}if((Wa(135864)|0)==0){d=135856;e=c[33964]|0;i=b;return e|0}do{if((a[140576]|0)==0){if((Wa(140576)|0)==0){break}fZ(140288,0,288)|0;Nd(289,0,q|0)|0;Ob(140576)}}while(0);ZO(140288,140584)|0;ZO(140300|0,140600)|0;c[33964]=140288;Ob(135864);d=135856;e=c[33964]|0;i=b;return e|0}function LW(b){b=b|0;var c=0;b=i;if((a[135888]|0)!=0){c=135872;i=b;return c|0}if((Wa(135888)|0)==0){c=135872;i=b;return c|0}mO(135872,135896,8);Nd(290,135872,q|0)|0;Ob(135888);c=135872;i=b;return c|0}function MW(b){b=b|0;var c=0;b=i;if((a[135928]|0)!=0){c=135912;i=b;return c|0}if((Wa(135928)|0)==0){c=135912;i=b;return c|0}WO(135912,135936,$X(135936)|0);Nd(291,135912,q|0)|0;Ob(135928);c=135912;i=b;return c|0}function NW(b){b=b|0;var c=0;b=i;if((a[135992]|0)!=0){c=135976;i=b;return c|0}if((Wa(135992)|0)==0){c=135976;i=b;return c|0}mO(135976,136e3,8);Nd(290,135976,q|0)|0;Ob(135992);c=135976;i=b;return c|0}function OW(b){b=b|0;var c=0;b=i;if((a[136032]|0)!=0){c=136016;i=b;return c|0}if((Wa(136032)|0)==0){c=136016;i=b;return c|0}WO(136016,136040,$X(136040)|0);Nd(291,136016,q|0)|0;Ob(136032);c=136016;i=b;return c|0}function PW(b){b=b|0;var c=0;b=i;if((a[136096]|0)!=0){c=136080;i=b;return c|0}if((Wa(136096)|0)==0){c=136080;i=b;return c|0}mO(136080,136104,20);Nd(290,136080,q|0)|0;Ob(136096);c=136080;i=b;return c|0}function QW(b){b=b|0;var c=0;b=i;if((a[136144]|0)!=0){c=136128;i=b;return c|0}if((Wa(136144)|0)==0){c=136128;i=b;return c|0}WO(136128,136152,$X(136152)|0);Nd(291,136128,q|0)|0;Ob(136144);c=136128;i=b;return c|0}function RW(b){b=b|0;var c=0;b=i;if((a[136256]|0)!=0){c=136240;i=b;return c|0}if((Wa(136256)|0)==0){c=136240;i=b;return c|0}mO(136240,136264,11);Nd(290,136240,q|0)|0;Ob(136256);c=136240;i=b;return c|0}function SW(b){b=b|0;var c=0;b=i;if((a[136296]|0)!=0){c=136280;i=b;return c|0}if((Wa(136296)|0)==0){c=136280;i=b;return c|0}WO(136280,136304,$X(136304)|0);Nd(291,136280,q|0)|0;Ob(136296);c=136280;i=b;return c|0}function TW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Ic()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);l=+XY(b,g,c[33840]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function UW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Ic()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);l=+XY(b,g,c[33840]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function VW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Ic()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);l=+XY(b,g,c[33840]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=l;i=f;return+h}function WW(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Ic()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);n=ib(b|0,h|0,f|0,c[33840]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)!=34){j=n;k=f;J=k;i=g;return j|0}c[e>>2]=4;j=-1;k=-1;J=k;i=g;return j|0}function XW(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Ic()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);m=ib(b|0,h|0,f|0,c[33840]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function YW(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Ic()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);m=ib(b|0,h|0,f|0,c[33840]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function ZW(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Ic()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);m=ib(b|0,h|0,f|0,c[33840]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>65535)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function _W(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Ic()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);n=Bc(b|0,h|0,f|0,c[33840]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)==34){c[e>>2]=4;e=(f|0)>0|(f|0)==0&n>>>0>0;J=e?2147483647:-2147483648;i=g;return(e?-1:0)|0}else{j=n;k=f;J=k;i=g;return j|0}return 0}function $W(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=Ic()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[135368]|0)==0){if((Wa(135368)|0)==0){break}c[33840]=Ub(2147483647,135376,0)|0;Ob(135368)}}while(0);m=Bc(b|0,h|0,f|0,c[33840]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}do{if((b|0)==34){c[e>>2]=4;if((f|0)>0|(f|0)==0&m>>>0>0){j=2147483647}else{break}i=g;return j|0}else{if((f|0)<-1|(f|0)==-1&m>>>0<2147483648){c[e>>2]=4;break}if((f|0)>0|(f|0)==0&m>>>0>2147483647){c[e>>2]=4;j=2147483647;i=g;return j|0}else{j=m;i=g;return j|0}}}while(0);j=-2147483648;i=g;return j|0}function aX(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;e=a+4|0;f=e;g=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=e+4|0;e=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=(c[a>>2]|0)+(e>>1)|0;a=f;if((e&1|0)==0){h=g;Vd[h&511](a);i=b;return}else{h=c[(c[f>>2]|0)+g>>2]|0;Vd[h&511](a);i=b;return}}function bX(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b+8|0;g=b+4|0;h=c[g>>2]|0;j=c[f>>2]|0;k=h;if(!(j-k>>2>>>0<d>>>0)){l=d;m=h;do{if((m|0)==0){n=0}else{c[m>>2]=0;n=c[g>>2]|0}m=n+4|0;c[g>>2]=m;l=l+ -1|0;}while((l|0)!=0);i=e;return}l=b+16|0;m=b;n=c[m>>2]|0;h=k-n>>2;k=h+d|0;if(k>>>0>1073741823){WU(0)}o=j-n|0;do{if(o>>2>>>0<536870911){n=o>>1;j=n>>>0<k>>>0?k:n;if((j|0)==0){p=0;q=0;break}n=b+128|0;if(!((a[n]|0)==0&j>>>0<29)){r=j;s=11;break}a[n]=1;p=j;q=l}else{r=1073741823;s=11}}while(0);if((s|0)==11){p=r;q=FY(r<<2)|0}r=d;d=q+(h<<2)|0;do{if((d|0)==0){t=0}else{c[d>>2]=0;t=d}d=t+4|0;r=r+ -1|0;}while((r|0)!=0);r=c[m>>2]|0;t=(c[g>>2]|0)-r|0;s=q+(h-(t>>2)<<2)|0;h=r;dZ(s|0,h|0,t|0)|0;c[m>>2]=s;c[g>>2]=d;c[f>>2]=q+(p<<2);if((r|0)==0){i=e;return}if((l|0)==(r|0)){a[b+128|0]=0;i=e;return}else{HY(h);i=e;return}}function cX(a){a=a|0;a=i;YO(140564|0);YO(140552|0);YO(140540|0);YO(140528|0);YO(140516|0);YO(140504|0);YO(140492|0);YO(140480|0);YO(140468|0);YO(140456|0);YO(140444|0);YO(140432|0);YO(140420|0);YO(140408|0);YO(140396|0);YO(140384|0);YO(140372|0);YO(140360|0);YO(140348|0);YO(140336|0);YO(140324|0);YO(140312|0);YO(140300|0);YO(140288);i=a;return}function dX(a){a=a|0;a=i;uO(140892|0);uO(140880|0);uO(140868|0);uO(140856|0);uO(140844|0);uO(140832|0);uO(140820|0);uO(140808|0);uO(140796|0);uO(140784|0);uO(140772|0);uO(140760|0);uO(140748|0);uO(140736|0);uO(140724|0);uO(140712|0);uO(140700|0);uO(140688|0);uO(140676|0);uO(140664|0);uO(140652|0);uO(140640|0);uO(140628|0);uO(140616);i=a;return}function eX(a){a=a|0;a=i;YO(141204|0);YO(141192|0);YO(141180|0);YO(141168|0);YO(141156|0);YO(141144|0);YO(141132|0);YO(141120|0);YO(141108|0);YO(141096|0);YO(141084|0);YO(141072|0);YO(141060|0);YO(141048|0);YO(141036|0);YO(141024|0);YO(141012|0);YO(141e3|0);YO(140988|0);YO(140976|0);YO(140964|0);YO(140952|0);YO(140940|0);YO(140928);i=a;return}function fX(a){a=a|0;a=i;uO(142044|0);uO(142032|0);uO(142020|0);uO(142008|0);uO(141996|0);uO(141984|0);uO(141972|0);uO(141960|0);uO(141948|0);uO(141936|0);uO(141924|0);uO(141912|0);uO(141900|0);uO(141888|0);uO(141876|0);uO(141864|0);uO(141852|0);uO(141840|0);uO(141828|0);uO(141816|0);uO(141804|0);uO(141792|0);uO(141780|0);uO(141768);i=a;return}function gX(a){a=a|0;a=i;YO(142436|0);YO(142424|0);YO(142412|0);YO(142400|0);YO(142388|0);YO(142376|0);YO(142364|0);YO(142352|0);YO(142340|0);YO(142328|0);YO(142316|0);YO(142304|0);YO(142292|0);YO(142280);i=a;return}function hX(a){a=a|0;a=i;uO(142972|0);uO(142960|0);uO(142948|0);uO(142936|0);uO(142924|0);uO(142912|0);uO(142900|0);uO(142888|0);uO(142876|0);uO(142864|0);uO(142852|0);uO(142840|0);uO(142828|0);uO(142816);i=a;return}function iX(a){a=a|0;var b=0,c=0;b=i;if((oX(a)|0)==0){c=(jX(a)|0)!=0|0}else{c=1}i=b;return c|0}function jX(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<131072){c=(d[143128+((d[143128+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}else{c=a>>>0<196606|0;i=b;return c|0}return 0}function kX(a){a=a|0;var b=0,c=0;b=i;c=ub(a|0)|0;i=b;return c|0}function lX(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<32|(a+ -127|0)>>>0<33|(a+ -8232|0)>>>0<2){c=1;i=b;return c|0}c=(a+ -65529|0)>>>0<3|0;i=b;return c|0}function mX(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;switch(b|0){case 7:{d=qX(a)|0;break};case 3:{d=kX(a)|0;break};case 8:{d=rX(a)|0;break};case 6:{d=pX(a)|0;break};case 1:{d=iX(a)|0;break};case 4:{d=lX(a)|0;break};case 10:{d=tX(a)|0;break};case 11:{d=uX(a)|0;break};case 12:{d=vX(a)|0;break};case 2:{d=jX(a)|0;break};case 5:{d=oX(a)|0;break};case 9:{d=sX(a)|0;break};default:{d=0}}i=c;return d|0}function nX(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;c=i;d=a[b]|0;e=97;f=1;g=146104;while(1){if(d<<24>>24==e<<24>>24){if((ZY(b,g)|0)==0){h=f;j=5;break}}k=g+6|0;l=a[k]|0;if(l<<24>>24==0){h=0;j=5;break}else{e=l;f=f+1|0;g=k}}if((j|0)==5){i=c;return h|0}return 0}function oX(a){a=a|0;i=i;return(a+ -48|0)>>>0<10|0}function pX(a){a=a|0;var b=0,c=0;b=i;if((tX(a)|0)==0){c=(rX(a)|0)!=0|0}else{c=0}i=b;return c|0}function qX(a){a=a|0;var b=0,c=0;b=i;if((wX(a)|0)==(a|0)){c=(a|0)==223|0}else{c=1}i=b;return c|0}function rX(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<255){c=(a+1&127)>>>0>32|0;i=b;return c|0}if(a>>>0<8232|(a+ -8234|0)>>>0<47062|(a+ -57344|0)>>>0<8185){c=1;i=b;return c|0}else{i=b;return((a+ -65532|0)>>>0>1048579|(a&65534|0)==65534)&1^1|0}return 0}function sX(a){a=a|0;var b=0,c=0;b=i;if(!(a>>>0<131072)){c=0;i=b;return c|0}c=(d[146184+((d[146184+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}function tX(a){a=a|0;var b=0,c=0;b=i;c=(_X(149352,a)|0)!=0|0;i=b;return c|0}function uX(a){a=a|0;var b=0,c=0;b=i;c=(yX(a)|0)!=(a|0)|0;i=b;return c|0}function vX(a){a=a|0;var b=0,c=0;b=i;if((a+ -48|0)>>>0<10){c=1;i=b;return c|0}c=((a|32)+ -97|0)>>>0<6|0;i=b;return c|0}function wX(a){a=a|0;var b=0,c=0;b=i;c=xX(a,0)|0;i=b;return c|0}function xX(c,f){c=c|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=(f<<1)+ -1|0;j=f+ -1|0;if((jX(c)|0)==0|(c+ -1536|0)>>>0<2560|(c+ -11776|0)>>>0<30784|(c+ -43008|0)>>>0<22272){k=c;i=g;return k|0}do{if((f|0)==0){if(!((c+ -11520|0)>>>0<38)){l=0;break}k=c+ -7264|0;i=g;return k|0}else{if(!((c+ -4256|0)>>>0<46)){l=0;break}do{if((c|0)>4293){if((c|0)==4295|(c|0)==4301){break}else{k=c}i=g;return k|0}}while(0);k=c+7264|0;i=g;return k|0}}while(0);while(1){m=a[149442+(l<<2)|0]|0;n=m<<24>>24;o=c-(e[149440+(l<<2)>>1]|0)|0;p=l+1|0;if((o-(n&j)|0)>>>0<(d[149443+(l<<2)|0]|0)>>>0){q=12;break}if((p|0)==61){break}else{l=p}}if((q|0)==12){if(m<<24>>24==1){k=f+c-(o&1)|0;i=g;return k|0}else{k=(fa(n,h)|0)+c|0;i=g;return k|0}}h=1-f|0;n=b[149688+(h<<1)>>1]|0;a:do{if(!(n<<16>>16==0)){o=n;m=0;while(1){q=m+1|0;if((o&65535|0)==(c|0)){break}l=b[149688+(q<<2)+(h<<1)>>1]|0;if(l<<16>>16==0){break a}else{o=l;m=q}}k=e[149688+(m<<2)+(f<<1)>>1]|0;i=g;return k|0}}while(0);if(!((c+ -66600+(f*40|0)|0)>>>0<40)){k=c;i=g;return k|0}k=c+ -40+(f*80|0)|0;i=g;return k|0}function yX(a){a=a|0;var b=0,c=0;b=i;c=xX(a,1)|0;i=b;return c|0}function zX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=AX(0,a,b,(c|0)!=0?c:150392)|0;i=d;return e|0}function AX(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+8|0;h=g;c[h>>2]=b;j=(f|0)==0?150400:f;f=c[j>>2]|0;a:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n+ -194|0;if(l>>>0>50){break a}o=e+ -1|0;p=c[150184+(l<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}}while(0);b:do{if((o|0)==0){r=p}else{l=a[q]|0;n=(l&255)>>>3;if((n+ -16|n+(p>>26))>>>0>7){break a}else{s=o;t=l;u=p;v=q}while(1){v=v+1|0;u=(t&255)+ -128|u<<6;s=s+ -1|0;if((u|0)>=0){break}if((s|0)==0){r=u;break b}t=a[v]|0;if(((t&255)+ -128|0)>>>0>63){break a}}c[j>>2]=0;c[m>>2]=u;k=e-s|0;i=g;return k|0}}while(0);c[j>>2]=r;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(Ic()|0)>>2]=84;k=-1;i=g;return k|0}function BX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+1032|0;h=g+1024|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=g;m=k?e:256;e=k?a:l;a:do{if((j|0)==0|(m|0)==0){n=d;o=m;p=j;q=0;r=e}else{a=d;s=m;t=j;u=0;v=e;while(1){w=a>>>2;x=w>>>0>=s>>>0;if(!(x|a>>>0>131)){n=a;o=s;p=t;q=u;r=v;break a}y=x?s:w;z=a-y|0;w=CX(v,h,y,f)|0;if((w|0)==-1){break}if((v|0)==(l|0)){A=s;B=l}else{A=s-w|0;B=v+(w<<2)|0}y=w+u|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){n=z;o=A;p=w;q=y;r=B;break a}else{a=z;s=A;t=w;u=y;v=B}}n=z;o=0;p=c[h>>2]|0;q=-1;r=v}}while(0);b:do{if((p|0)==0){C=q}else{if((o|0)==0|(n|0)==0){C=q;break}else{D=n;E=o;F=p;G=q;H=r}while(1){I=AX(H,F,D,f)|0;if((I+2|0)>>>0<3){break}z=(c[h>>2]|0)+I|0;c[h>>2]=z;B=E+ -1|0;A=G+1|0;if((B|0)==0|(D|0)==(I|0)){C=A;break b}else{D=D-I|0;E=B;F=z;G=A;H=H+4|0}}if((I|0)==-1){C=-1;break}else if((I|0)==0){c[h>>2]=0;C=G;break}else{c[f>>2]=0;C=G;break}}}while(0);if(!k){i=g;return C|0}c[b>>2]=c[h>>2];i=g;return C|0}function CX(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;h=i;j=c[e>>2]|0;do{if((g|0)==0){k=5}else{l=g;m=c[l>>2]|0;if((m|0)==0){k=5;break}if((b|0)==0){n=f;o=m;p=j;k=16;break}c[l>>2]=0;q=b;r=f;s=m;t=j;k=36}}while(0);if((k|0)==5){if((b|0)==0){u=f;v=j;k=7}else{w=b;x=f;y=j;k=6}}a:while(1){if((k|0)==6){k=0;if((x|0)==0){z=f;k=53;break}else{A=w;B=x;C=y}while(1){j=a[C]|0;do{if(((j&255)+ -1|0)>>>0<127){if((C&3|0)==0&B>>>0>3){D=A;E=B;F=C}else{G=A;H=B;I=j;J=C;break}while(1){K=c[F>>2]|0;if(((K+ -16843009|K)&-2139062144|0)!=0){k=30;break}c[D>>2]=K&255;c[D+4>>2]=d[F+1|0]|0;c[D+8>>2]=d[F+2|0]|0;L=F+4|0;M=D+16|0;c[D+12>>2]=d[F+3|0]|0;N=E+ -4|0;if(N>>>0>3){D=M;E=N;F=L}else{k=31;break}}if((k|0)==30){k=0;G=D;H=E;I=K&255;J=F;break}else if((k|0)==31){k=0;G=M;H=N;I=a[L]|0;J=L;break}}else{G=A;H=B;I=j;J=C}}while(0);O=I&255;if(!((O+ -1|0)>>>0<127)){break}c[G>>2]=O;j=H+ -1|0;if((j|0)==0){z=f;k=53;break a}else{A=G+4|0;B=j;C=J+1|0}}j=O+ -194|0;if(j>>>0>50){P=G;Q=H;R=J;k=47;break}q=G;r=H;s=c[150184+(j<<2)>>2]|0;t=J+1|0;k=36;continue}else if((k|0)==7){k=0;j=a[v]|0;do{if(((j&255)+ -1|0)>>>0<127){if((v&3|0)!=0){S=u;T=j;U=v;break}g=c[v>>2]|0;if(((g+ -16843009|g)&-2139062144|0)==0){V=u;W=v}else{S=u;T=g&255;U=v;break}do{W=W+4|0;V=V+ -4|0;X=c[W>>2]|0;}while(((X+ -16843009|X)&-2139062144|0)==0);S=V;T=X&255;U=W}else{S=u;T=j;U=v}}while(0);j=T&255;if((j+ -1|0)>>>0<127){u=S+ -1|0;v=U+1|0;k=7;continue}g=j+ -194|0;if(g>>>0>50){P=b;Q=S;R=U;k=47;break}n=S;o=c[150184+(g<<2)>>2]|0;p=U+1|0;k=16;continue}else if((k|0)==16){k=0;g=(d[p]|0)>>>3;if((g+ -16|g+(o>>26))>>>0>7){k=17;break}g=p+1|0;do{if((o&33554432|0)==0){Y=g}else{if(((d[g]|0)+ -128|0)>>>0>63){k=20;break a}j=p+2|0;if((o&524288|0)==0){Y=j;break}if(((d[j]|0)+ -128|0)>>>0>63){k=23;break a}Y=p+3|0}}while(0);u=n+ -1|0;v=Y;k=7;continue}else if((k|0)==36){k=0;g=d[t]|0;j=g>>>3;if((j+ -16|j+(s>>26))>>>0>7){k=37;break}j=t+1|0;Z=g+ -128|s<<6;do{if((Z|0)<0){g=(d[j]|0)+ -128|0;if(g>>>0>63){k=40;break a}m=t+2|0;_=g|Z<<6;if((_|0)>=0){$=_;aa=m;break}g=(d[m]|0)+ -128|0;if(g>>>0>63){k=43;break a}$=g|_<<6;aa=t+3|0}else{$=Z;aa=j}}while(0);c[q>>2]=$;w=q+4|0;x=r+ -1|0;y=aa;k=6;continue}}if((k|0)==17){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==20){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==23){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==37){ba=q;ca=r;da=s;ea=t+ -1|0;k=46}else if((k|0)==40){ba=q;ca=r;da=Z;ea=t+ -1|0;k=46}else if((k|0)==43){ba=q;ca=r;da=_;ea=t+ -1|0;k=46}else if((k|0)==53){i=h;return z|0}if((k|0)==46){if((da|0)==0){P=ba;Q=ca;R=ea;k=47}else{fa=ba;ga=ea}}do{if((k|0)==47){if((a[R]|0)!=0){fa=P;ga=R;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}z=f-Q|0;i=h;return z|0}}while(0);c[(Ic()|0)>>2]=84;if((fa|0)==0){z=-1;i=h;return z|0}c[e>>2]=ga;z=-1;i=h;return z|0}function DX(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m+ -194|0;if(k>>>0>50){break}m=e+1|0;n=c[150184+(k<<2)>>2]|0;if(f>>>0<4){if((n&-2147483648>>>((f*6|0)+ -6|0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m+ -16|m+(n>>26))>>>0>7){break}m=k+ -128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)+ -128|0;if(n>>>0>63){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)+ -128|0;if(m>>>0>63){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(Ic()|0)>>2]=84;j=-1;i=g;return j|0}function EX(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((b|0)==0){f=1;i=e;return f|0}if(d>>>0<128){a[b]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d+ -57344|0)>>>0<8192){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;i=e;return f|0}if((d+ -65536|0)>>>0<1048576){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;i=e;return f|0}else{c[(Ic()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function FX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+264|0;g=f+256|0;h=f;j=c[b>>2]|0;c[g>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:h;a:do{if((j|0)==0|(l|0)==0){m=d;n=l;o=j;p=0;q=e}else{a=d;r=l;s=j;t=0;u=e;while(1){v=a>>>0>=r>>>0;if(!(v|a>>>0>32)){m=a;n=r;o=s;p=t;q=u;break a}w=v?r:a;x=a-w|0;v=GX(u,g,w,0)|0;if((v|0)==-1){break}if((u|0)==(h|0)){y=r;z=h}else{y=r-v|0;z=u+v|0}w=v+t|0;v=c[g>>2]|0;if((v|0)==0|(y|0)==0){m=x;n=y;o=v;p=w;q=z;break a}else{a=x;r=y;s=v;t=w;u=z}}m=x;n=0;o=c[g>>2]|0;p=-1;q=u}}while(0);b:do{if((o|0)==0){A=p}else{if((n|0)==0|(m|0)==0){A=p;break}else{B=m;C=n;D=o;E=p;F=q}while(1){G=EX(F,c[D>>2]|0,0)|0;if((G+1|0)>>>0<2){break}x=(c[g>>2]|0)+4|0;c[g>>2]=x;z=B+ -1|0;y=E+1|0;if((C|0)==(G|0)|(z|0)==0){A=y;break b}else{B=z;C=C-G|0;D=x;E=y;F=F+G|0}}if((G|0)!=0){A=-1;break}c[g>>2]=0;A=E}}while(0);if(!k){i=f;return A|0}c[b>>2]=c[g>>2];i=f;return A|0}function GX(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f;if((b|0)==0){h=c[d>>2]|0;j=g;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=k;o=h}while(1){if(n>>>0>127){h=EX(j,n,0)|0;if((h|0)==-1){l=-1;p=26;break}else{q=h}}else{q=1}h=q+m|0;k=o+4|0;r=c[k>>2]|0;if((r|0)==0){l=h;p=26;break}else{m=h;n=r;o=k}}if((p|0)==26){i=f;return l|0}}a:do{if(e>>>0>3){o=b;n=e;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break a}if(q>>>0>127){j=EX(o,q,0)|0;if((j|0)==-1){l=-1;break}u=o+j|0;v=n-j|0;w=m}else{a[o]=q;u=o+1|0;v=n+ -1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3){o=u;n=v;m=q}else{s=u;t=v;break a}}i=f;return l|0}else{s=b;t=e}}while(0);b:do{if((t|0)==0){x=0}else{b=g;v=s;u=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127){n=EX(b,m,0)|0;if((n|0)==-1){l=-1;p=26;break}if(n>>>0>u>>>0){p=20;break}EX(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u+ -1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break b}else{v=y;u=z;w=m}}if((p|0)==20){l=e-u|0;i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}else if((p|0)==26){i=f;return l|0}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}



function wJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];aK(a,e);i=d;return}function xJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=SH(d)|0;d=UH(n,1)|0;OJ(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];NJ(j,d,h);PJ(0,sI((QJ(j)|0)+16|0)|0,e);a[(RJ(j)|0)+4|0]=1;SJ(m,j);yJ(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];wJ(b,g);zJ(m);zJ(j);i=f;return}function yJ(a,b){a=a|0;b=b|0;var c=0;c=i;LJ(a,b);i=c;return}function zJ(a){a=a|0;var b=0;b=i;GJ(a);i=b;return}function AJ(a){a=a|0;var b=0,d=0;b=i;d=c[(EJ(a)|0)>>2]|0;i=b;return d|0}function BJ(a){a=a|0;var b=0,d=0;b=i;d=CJ(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function CJ(a){a=a|0;var b=0,c=0;b=i;c=DJ(a)|0;i=b;return c|0}function DJ(a){a=a|0;i=i;return a|0}function EJ(a){a=a|0;var b=0,c=0;b=i;c=FJ(a)|0;i=b;return c|0}function FJ(a){a=a|0;i=i;return a|0}function GJ(a){a=a|0;var b=0;b=i;HJ(a,0);i=b;return}function HJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=CJ(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}JJ(IJ(e)|0,f);i=d;return}function IJ(a){a=a|0;var b=0,c=0;b=i;c=KJ(a)|0;i=b;return c|0}function JJ(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;rI(f,sI(d+16|0)|0)}if((d|0)==0){i=e;return}LH(c[b>>2]|0,d,1);i=e;return}function KJ(a){a=a|0;i=i;return a+4|0}function LJ(a,b){a=a|0;b=b|0;var c=0;c=i;MJ(a,b);i=c;return}function MJ(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function NJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];WJ(a,b,f);i=e;return}function OJ(a,b){a=a|0;b=b|0;var c=0;c=i;VJ(a,b);i=c;return}function PJ(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}TJ(b,c);i=a;return}function QJ(a){a=a|0;var b=0,d=0;b=i;d=c[(EJ(a)|0)>>2]|0;i=b;return d|0}function RJ(a){a=a|0;var b=0,c=0;b=i;c=IJ(a)|0;i=b;return c|0}function SJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;LJ(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];wJ(h,f);yJ(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];wJ(a,e);zJ(h);i=d;return}function TJ(a,b){a=a|0;b=b|0;var c=0;c=i;UJ(a,b);i=c;return}function UJ(a,b){a=a|0;b=b|0;var c=0;c=i;tJ(a,b);i=c;return}function VJ(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;i=i;return}function WJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(dI(g)|0)>>2]|0;g=YJ(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];XJ(b,a,f);i=e;return}function XJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];ZJ(a,b,f);i=e;return}function YJ(a){a=a|0;i=i;return a|0}function ZJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(hI(g)|0)>>2]|0;g=$J(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];_J(b,a,f);i=e;return}function _J(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(hI(f)|0)>>2];f=$J(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function $J(a){a=a|0;i=i;return a|0}function aK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=BJ(bK(b)|0)|0;h=$J(RJ(bK(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];XJ(g,a,e);i=d;return}function bK(a){a=a|0;i=i;return c[a>>2]|0}function cK(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function dK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];oK(a,e);i=d;return}function eK(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=XD(0,b,c)|0;i=a;return d|0}function fK(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function gK(a,b){a=a|0;b=b|0;var d=0;d=i;JF(a,c[(kH(b)|0)>>2]|0);i=d;return}function hK(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=mK(c[d>>2]|0)|0;i=b;return a|0}function iK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=RF(a)|0;Sz(e);if((h|0)==0){j=KF(a)|0;c[b>>2]=j;k=j;i=e;return k|0}j=TF(a)|0;a=h;while(1){h=a+16|0;if(eK(j,d,h)|0){l=a;m=c[l>>2]|0;Sz(f);if((m|0)==0){n=5;break}else{o=l}}else{p=a;if(!(eK(j,h,d)|0)){n=10;break}q=a+4|0;h=c[q>>2]|0;Sz(g);if((h|0)==0){n=9;break}else{o=q}}a=c[o>>2]|0}if((n|0)==5){c[b>>2]=a;k=l;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==10){c[b>>2]=p;k=b;i=e;return k|0}return 0}function jK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;kK(b,d);c[a>>2]=c[b>>2];i=e;return}function kK(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;lK(b,c,e);i=d;return}function lK(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;if(!((b|0)>-1)){d=b;do{hK(a)|0;d=d+1|0;}while((d|0)<0);i=c;return}if((b|0)>0){e=b}else{i=c;return}do{kJ(a)|0;e=e+ -1|0;}while((e|0)>0);i=c;return}function mK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;Sz(b);if((e|0)==0){e=a;while(1){a=GB(e)|0;f=c[e+8>>2]|0;if(a){e=f}else{g=f;break}}i=b;return g|0}else{g=nK(c[d>>2]|0)|0;i=b;return g|0}return 0}function nK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[e>>2]|0;Sz(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e+4|0;f=c[a>>2]|0;Sz(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function oK(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function pK(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(cK(a,b)|0)^1;i=c;return d|0}function qK(a){a=a|0;var b=0;b=i;i=i+128|0;ID(a,b);ID(a+12|0,b+8|0);rK(a+24|0,b+16|0);rK(a+36|0,b+24|0);rK(a+48|0,b+32|0);rK(a+60|0,b+40|0);rK(a+72|0,b+48|0);rK(a+84|0,b+56|0);rK(a+96|0,b+64|0);rK(a+108|0,b+72|0);rK(a+120|0,b+80|0);rK(a+132|0,b+88|0);rK(a+144|0,b+96|0);rK(a+156|0,b+104|0);rK(a+168|0,b+112|0);rK(a+180|0,b+120|0);i=b;return}function rK(a,b){a=a|0;b=b|0;b=i;sK(a,0);i=b;return}function sK(a,b){a=a|0;b=b|0;b=i;i=i+8|0;tK(a,b);i=b;return}function tK(a,b){a=a|0;b=b|0;b=i;uK(a,0);i=b;return}function uK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;vK(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;wK(f,0,e);e=rG(b)|0;c[(qG(b)|0)>>2]=e;i=d;return}function vK(a){a=a|0;var b=0;b=i;zK(a);i=b;return}function wK(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;xK(b,c,f);i=e;return}function xK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(uC(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;yK(d,b,f);i=e;return}function yK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(uC(e)|0)>>2];i=d;return}function zK(a){a=a|0;var b=0;b=i;AK(a);i=b;return}function AK(a){a=a|0;var b=0;b=i;xC(a);i=b;return}function BK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=c[118436>>2]|0;if((m|0)==0){n=0}else{o=FY(12)|0;oO(o,m);n=o}if((c[118352>>2]|0)!=0){c[15980]=1}if((n|0)==0){c[63932>>2]=1;c[63936>>2]=1;i=b;return}do{if((SO(n,108688,0)|0)==-1){kO(g,n);iO(h);o=c[15554]|0;m=(o|0)<28;while(1){p=SO(g,108696,0)|0;q=(p|0)!=-1;if(q){QO(j,g,0,p);vO(h,j)|0;uO(j);QO(k,g,p+1|0,-1);vO(g,k)|0;uO(k)}else{vO(h,g)|0}if(m){r=1;s=o}else{t=20;break}while(1){oO(l,c[62632+(s<<2)>>2]|0);p=CK(h,l)|0;uO(l);if(p){c[63928+(s<<2)>>2]=1;u=0}else{u=r}p=s+1|0;if((p|0)<28){r=u;s=p}else{break}}if((u|0)!=0){t=18;break}if(!q){t=23;break}}if((t|0)==18){Nu(1,1,108704,f);if(m){v=o}else{w=64480;x=c[16120]|0;Vd[x&511](1);y=RO(n)|0;z=a;A=z;c[A>>2]=y;B=4;C=B;D=108744;E=D;Pu(0,E,a)}do{p=c[63800+(v<<2)>>2]|0;c[e>>2]=c[62632+(v<<2)>>2];c[e+4>>2]=p;Nu(1,0,108728,e);v=v+1|0;}while((v|0)<28);w=64480;x=c[16120]|0;Vd[x&511](1);y=RO(n)|0;z=a;A=z;c[A>>2]=y;B=4;C=B;D=108744;E=D;Pu(0,E,a)}else if((t|0)==20){Nu(1,1,108704,d);w=64480;x=c[16120]|0;Vd[x&511](1);y=RO(n)|0;z=a;A=z;c[A>>2]=y;B=4;C=B;D=108744;E=D;Pu(0,E,a)}else if((t|0)==23){uO(h);uO(g);break}}else{o=1;do{c[63928+(o<<2)>>2]=1;o=o+1|0;}while((o|0)<28)}}while(0);c[63932>>2]=1;c[63936>>2]=1;if((c[63964>>2]|0)!=0){c[64024>>2]=1}if((c[64020>>2]|0)==1){c[64028>>2]=1}if((c[64e3>>2]|0)!=0){c[63996>>2]=1}if((c[64008>>2]|0)!=0){c[63996>>2]=1}if((c[63960>>2]|0)!=0){c[63956>>2]=1}if((c[64004>>2]|0)!=0){c[63996>>2]=1}if((c[63952>>2]|0)!=0){c[63948>>2]=1}uO(n);HY(n);i=b;return}function CK(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=sO(b)|0;if((e|0)!=(sO(c)|0)){f=0;i=d;return f|0}g=tO(b)|0;h=tO(c)|0;if(lO(b)|0){f=(ZD(g,h,e)|0)==0;i=d;return f|0}if((e|0)==0){f=1;i=d;return f|0}else{j=e;k=g;l=h}while(1){if((a[k]|0)!=(a[l]|0)){f=0;m=7;break}h=j+ -1|0;if((h|0)==0){f=1;m=7;break}else{j=h;k=k+1|0;l=l+1|0}}if((m|0)==7){i=d;return f|0}return 0}function DK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=c[118444>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=FY(12)|0;l=k;oO(l,h);if((k|0)==0){j=1;i=b;return j|0}else{m=1}while(1){k=m+1|0;if(EK(l,c[96208+(m<<2)>>2]|0)|0){j=m;n=6;break}if((k|0)<4){m=k}else{n=5;break}}if((n|0)==5){c[g>>2]=RO(l)|0;Nu(1,1,108776,g);g=c[96292>>2]|0;c[f>>2]=c[96212>>2];c[f+4>>2]=g;Nu(1,0,108728,f);f=c[96296>>2]|0;c[e>>2]=c[96216>>2];c[e+4>>2]=f;Nu(1,0,108728,e);e=c[96300>>2]|0;c[d>>2]=c[96220>>2];c[d+4>>2]=e;Nu(1,0,108728,d);Vd[c[16120]&511](1);Pu(0,108832,a)}else if((n|0)==6){i=b;return j|0}return 0}function EK(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(UO(a,b)|0)==0;i=c;return d|0}function FK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;a=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+16|0;g=i;i=i+16|0;h=c[118428>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=FY(12)|0;l=k;oO(l,h);if((k|0)==0){j=1;i=b;return j|0}oO(f,108856);k=CK(l,f)|0;uO(f);if(k){j=1;i=b;return j|0}oO(g,108864);k=CK(l,g)|0;uO(g);if(k){j=2;i=b;return j|0}else{c[e>>2]=RO(l)|0;Nu(1,1,108872,e);c[d>>2]=108856;c[d+4>>2]=108928;Nu(1,0,108728,d);c[a>>2]=108864;c[a+4>>2]=108944;Nu(1,0,108728,a);Vd[c[16120]&511](1);Pu(0,108832,b)}return 0}function GK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;DQ(f,a);if(!(GQ(f)|0)){EQ(f);i=d;return a|0}j=fE(b)|0;SK(g,a);k=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;l=k;if(((Wz(l)|0)&176|0)==32){m=b+j|0}else{m=b}n=oP(k)|0;k=b+j|0;j=e;o=g;c[j+0>>2]=c[o+0>>2];VK(h,e,b,m,k,l,n);if(!(TK(h)|0)){EQ(f);i=d;return a|0}iP(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,5);EQ(f);i=d;return a|0}function HK(a){a=a|0;var b=0;b=i;JQ(a,pP(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;qQ(a)|0;i=b;return a|0}function IK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+2128|0;g=f;h=f+32|0;j=f+48|0;k=f+64|0;l=f+80|0;oO(h,d);dP(k,108952,h);sD(j,k,108960);uO(k);k=RO(j)|0;d=b+104|0;do{if((c[d>>2]|0)>0){m=b;n=c[m>>2]|0;if((ZY(c[n+4>>2]|0,108968)|0)!=0){break}a[n+104|0]=1;a[(c[m>>2]|0)+((c[d>>2]|0)*112|0)+104|0]=1}}while(0);if((ZY(k,108976)|0)==0){uO(j);uO(h);i=f;return}d=HX(g,k,1)|0;if((d|0)!=0){m=l;fZ(m|0,0,2048)|0;UX(d,g,m,2048)|0;HQ(GK(GK(GK(GK(GK(130832,108984)|0,k)|0,109024)|0,m)|0,109040)|0,103)|0;uO(j);uO(h);i=f;return}m=b+108|0;k=c[m>>2]|0;if((k|0)>0){d=b;l=k;k=0;while(1){n=c[d>>2]|0;if((a[n+(k*112|0)+104|0]|0)==0){o=(VX(g,c[n+(k*112|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(k*112|0)+104|0]=o;p=c[m>>2]|0}else{p=l}o=k+1|0;if((o|0)<(p|0)){l=p;k=o}else{break}}}k=b+208|0;if((c[k>>2]|0)>0){p=b+32|0;l=b;m=(e|0)==0;d=b+16|0;o=0;do{n=c[p>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){q=a[n+(o*52|0)+8|0]|0;if(q<<24>>24==1){r=(VX(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=r;r=c[p>>2]|0;if((a[r+(o*52|0)+48|0]|0)!=0|m){break}a[(c[d>>2]|0)+((c[r+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else if(q<<24>>24==0){q=(VX(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=q;q=c[p>>2]|0;if((a[q+(o*52|0)+48|0]|0)!=0){break}a[(c[l>>2]|0)+((c[q+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else{break}}}while(0);o=o+1|0;}while((o|0)<(c[k>>2]|0))}k=b+116|0;o=c[k>>2]|0;if((o|0)>0){l=b+4|0;p=o;o=0;while(1){d=c[l>>2]|0;if((a[d+(o*60|0)+56|0]|0)==0){m=(VX(g,c[d+(o*60|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(o*60|0)+56|0]=m;s=c[k>>2]|0}else{s=p}m=o+1|0;if((m|0)<(s|0)){p=s;o=m}else{break}}}o=b+212|0;if((c[o>>2]|0)>0){s=b+36|0;p=b+4|0;k=(e|0)==0;l=b+20|0;m=0;do{d=c[s>>2]|0;do{if((a[d+(m*52|0)+48|0]|0)==0){n=a[d+(m*52|0)+8|0]|0;if(n<<24>>24==1){q=(VX(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=q;q=c[s>>2]|0;if((a[q+(m*52|0)+48|0]|0)!=0|k){break}a[(c[l>>2]|0)+((c[q+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else if(n<<24>>24==0){n=(VX(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=n;n=c[s>>2]|0;if((a[n+(m*52|0)+48|0]|0)!=0){break}a[(c[p>>2]|0)+((c[n+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else{break}}}while(0);m=m+1|0;}while((m|0)<(c[o>>2]|0))}o=b+120|0;m=c[o>>2]|0;if((m|0)>0){p=b+8|0;s=m;m=0;while(1){l=c[p>>2]|0;if((a[l+(m*48|0)+44|0]|0)==0){k=(VX(g,c[l+(m*48|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(m*48|0)+44|0]=k;t=c[o>>2]|0}else{t=s}k=m+1|0;if((k|0)<(t|0)){s=t;m=k}else{break}}}m=b+216|0;if((c[m>>2]|0)>0){t=b+40|0;s=b+8|0;o=(e|0)==0;p=b+24|0;k=0;do{l=c[t>>2]|0;do{if((a[l+(k*52|0)+48|0]|0)==0){d=a[l+(k*52|0)+8|0]|0;if(d<<24>>24==1){n=(VX(g,c[l+(k*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(k*52|0)+48|0]=n;n=c[t>>2]|0;if((a[n+(k*52|0)+48|0]|0)!=0|o){break}a[(c[p>>2]|0)+((c[n+(k*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else if(d<<24>>24==0){d=(VX(g,c[l+(k*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(k*52|0)+48|0]=d;d=c[t>>2]|0;if((a[d+(k*52|0)+48|0]|0)!=0){break}a[(c[s>>2]|0)+((c[d+(k*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else{break}}}while(0);k=k+1|0;}while((k|0)<(c[m>>2]|0))}m=b+124|0;k=c[m>>2]|0;if((k|0)>0){s=b+12|0;t=k;k=0;while(1){p=c[s>>2]|0;if((a[p+(k*52|0)+48|0]|0)==0){o=(VX(g,c[p+(k*52|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(k*52|0)+48|0]=o;u=c[m>>2]|0}else{u=t}o=k+1|0;if((o|0)<(u|0)){t=u;k=o}else{break}}}k=b+220|0;if((c[k>>2]|0)>0){u=b+44|0;t=b+12|0;m=(e|0)==0;e=b+28|0;b=0;do{s=c[u>>2]|0;do{if((a[s+(b*52|0)+48|0]|0)==0){o=a[s+(b*52|0)+8|0]|0;if(o<<24>>24==0){p=(VX(g,c[s+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=p;p=c[u>>2]|0;if((a[p+(b*52|0)+48|0]|0)!=0){break}a[(c[t>>2]|0)+((c[p+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else if(o<<24>>24==1){o=(VX(g,c[s+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=o;o=c[u>>2]|0;if((a[o+(b*52|0)+48|0]|0)!=0|m){break}a[(c[e>>2]|0)+((c[o+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else{break}}}while(0);b=b+1|0;}while((b|0)<(c[k>>2]|0))}LX(g);uO(j);uO(h);i=f;return}function JK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0;b=i;i=i+8|0;a=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[118292>>2]|0;H=c[118420>>2]|0;I=c[2]|0;if((c[64028>>2]|0)==0){if(!((c[118240>>2]|0)==0|(I|0)!=0)){J=3}}else{J=3}if((J|0)==3){c[2]=1}J=d+248|0;K=d+240|0;L=~~+xb(+((+h[J>>3]- +h[K>>3])/+h[d+264>>3]));c[d+256>>2]=L;c[l>>2]=L;Lu(23,0,109088,l);l=c[118364>>2]|0;do{if((l|0)==0){M=0}else{if((ZY(l,109112)|0)==0){M=1;break}if((ZY(l,109120)|0)==0){M=0;break}if((ZY(l,109128)|0)==0){M=2;break}c[j>>2]=l;Nu(1,0,109136,j);M=0}}while(0);if((Pv(M)|0)!=0){c[g>>2]=l;Nu(1,0,109208,g)}if((c[2]|0)!=0){QL(d+56|0);Uv((c[d+64>>2]|0)+13+(c[d+68>>2]|0)+(c[d+72>>2]|0)|0);Qv(0);Qv(6);Rv(3);Rv(4);Rv(1)}g=(G|0)!=0;if(g){if((H|0)==0){N=+h[K>>3]}else{N=+VY(H)}h[J>>3]=N;J=f;h[k>>3]=N;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];Lu(1,0,109296,f)}do{if((c[118348>>2]|0)!=0){f=FY(12)|0;J=f;oO(J,c[118476>>2]|0);if((f|0)==0){break}f=RO(J)|0;c[d+280>>2]=f;c[e>>2]=f;Lu(23,0,109352,e)}}while(0);e=c[118472>>2]|0;iO(m);if((e|0)==0){oO(p,c[d+88>>2]|0);oO(q,109400);KK(o,p,q);sD(n,o,c[d+284>>2]|0);vO(m,n)|0;uO(n);uO(o);uO(q);uO(p)}else{wO(m,e)|0}oO(r,109408);oO(s,109408);oO(t,109408);oO(u,109408);oO(v,109408);oO(w,109408);e=c[118240>>2]|0;if((c[118260>>2]|0)!=0){wO(r,c[118388>>2]|0)|0}if((c[118276>>2]|0)!=0){wO(s,c[118404>>2]|0)|0}if((c[118256>>2]|0)!=0){wO(t,c[118384>>2]|0)|0}if((c[118264>>2]|0)==0){O=0.0}else{wO(u,c[118392>>2]|0)|0;O=+VY(RO(u)|0)}if((c[118268>>2]|0)==0){P=1}else{wO(v,c[118396>>2]|0)|0;P=Ac(RO(v)|0)|0}if((c[118328>>2]|0)!=0){wO(w,c[118456>>2]|0)|0}kO(x,m);kO(y,r);kO(z,s);kO(A,t);kO(B,w);p=LK(d,x,y,z,A,O,P,B,e)|0;uO(B);uO(A);uO(z);uO(y);uO(x);if((p|0)!=0|g^1){Q=p}else{Qv(5);p=fL(d)|0;Tv(5);Lu(1,0,109416,a);Q=p}c[2]=I;if(!((Q|0)==0&(I|0)!=0)){R=Q;uO(w);uO(v);uO(u);uO(t);uO(s);uO(r);uO(m);i=b;return R|0}Q=d+88|0;oO(D,c[Q>>2]|0);sD(C,D,109448);uO(D);oO(F,c[Q>>2]|0);sD(E,F,109464);uO(F);Tv(0);F=c[118440>>2]|0;Q=RO(C)|0;D=RO(E)|0;I=c[d+280>>2]|0;p=c[d+284>>2]|0;EL(d,Q,D,(F|0)!=0?F:109480,I,p,RO(m)|0)|0;uO(E);uO(C);R=0;uO(w);uO(v);uO(u);uO(t);uO(s);uO(r);uO(m);i=b;return R|0}function KK(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;jO(a,d);e=sO(b)|0;f=sO(c)|0;VO(a,tO(b)|0,e,f+e|0);NO(a,tO(c)|0,f)|0;i=d;return}function LK(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;if((sO(j)|0)==0){u=0}else{u=RO(j)|0}kO(r,b);b=(MK(a,r,k)|0)==0;uO(r);if(!b){v=-1;i=l;return v|0}oO(s,109408);b=a+280|0;r=EK(s,c[b>>2]|0)|0;uO(s);do{if(r){w=3}else{s=1;k=0;do{oO(t,c[109624+(s<<2)>>2]|0);j=EK(t,c[b>>2]|0)|0;uO(t);k=j?s:k;s=s+1|0;}while((s|0)<20);if((k|0)!=0){w=k;break}c[q>>2]=c[b>>2];Nu(1,0,109704,q);Nu(1,0,108704,p);s=1;do{j=c[109736+(s<<2)>>2]|0;c[o>>2]=c[109624+(s<<2)>>2];c[o+4>>2]=j;Nu(1,0,108728,o);s=s+1|0;}while((s|0)<20);Pu(c[a+536>>2]|0,108832,n)}}while(0);c[m>>2]=c[109624+(w<<2)>>2];Lu(23,0,109816,m);m=RO(d)|0;d=RO(e)|0;e=jy(a,m,d,RO(f)|0,g,h,w,u)|0;Wd[c[103068>>2]&63](103040,a);v=e;i=l;return v|0}function MK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[a+256>>2]<<2;c[25760]=od(RO(b)|0)|0;c[103044>>2]=g;c[103048>>2]=d;d=a+284|0;do{if((c[27170]|0)==0){g=c[d>>2]|0;if((ZY(109488,g)|0)==0){h=0;break}if((ZY(109496,g)|0)==0){c[103056>>2]=45;c[103060>>2]=46;c[103068>>2]=47;h=0;break}if((ZY(109504,g)|0)==0){c[103056>>2]=48;c[103060>>2]=49;c[103064>>2]=50;c[103068>>2]=51;h=1;break}if((ZY(109512,g)|0)==0){c[103056>>2]=52;c[103060>>2]=53;c[103064>>2]=54;c[103068>>2]=55;h=1;break}if((ZY(109520,g)|0)==0){c[103056>>2]=56;c[103060>>2]=57;c[103068>>2]=58;h=0;break}g=GK(130832,109528)|0;HQ(GK(g,c[d>>2]|0)|0,103)|0;j=1;i=e;return j|0}else{h=0}}while(0);IK(a+8|0,c[a+288>>2]|0,h);Wd[c[103056>>2]&63](103040,a);a=c[25760]|0;c[f>>2]=c[d>>2];c[f+4>>2]=a;Lu(23,0,109552,f);j=0;i=e;return j|0}function NK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;Cu();do{if((YL(a,b)|0)==0){if((_L(a,b)|0)!=0){break}do{if((c[118296>>2]|0)!=0){w=c[118424>>2]|0;if((ZY(w,109936)|0)==0){Iu(1);break}if((ZY(w,109944)|0)==0){Iu(0);break}else{c[p>>2]=w;Nu(1,0,109952,p);jd(0)|0;qd(0)}}}while(0);if((c[118252>>2]|0)==0){BK(0,0);xx(d);if((d|0)==0){HQ(GK(130832,110320)|0,103)|0}c[d+300>>2]=DK(0,0)|0;c[d+292>>2]=FK(0,0)|0;pD(d+8|0,d+240|0);Gx(d)|0;Nx(d)|0;Wx(d)|0;do{if((c[d+116>>2]|0)==0){if((c[d+124>>2]|0)==0){break}if((c[d+128>>2]|0)==0){break}HQ(GK(130832,110384)|0,103)|0;x=1;i=e;return x|0}}while(0);c[27170]=c[118320>>2];x=0;i=e;return x|0}oO(u,c[118380>>2]|0);w=1;while(1){y=68160+(w<<2)|0;oO(v,c[y>>2]|0);z=CK(u,v)|0;uO(v);A=w+1|0;if(z){break}if((A|0)<31){w=A}else{B=33;break}}if((B|0)==33){c[g>>2]=RO(u)|0;Nu(1,0,110224,g);c[f>>2]=c[b>>2];Nu(1,0,110264,f);jd(0)|0;qd(0)}A=c[72184+(w<<2)>>2]|0;do{if((A|0)==1){z=c[72056+(w<<2)>>2]|0;c[o>>2]=c[y>>2];c[o+4>>2]=z;Lu(1,1,110024,o)}else{z=c[y>>2]|0;if((A|0)==2){C=c[72056+(w<<2)>>2]|0;c[n>>2]=z;c[n+4>>2]=z;c[n+8>>2]=C;Lu(1,1,110064,n);break}else{c[m>>2]=z;Nu(1,1,109904,m);break}}}while(0);if((w|0)==11){A=1;do{z=c[110192+(A<<2)>>2]|0;c[j>>2]=c[110160+(A<<2)>>2];c[j+4>>2]=z;Lu(1,0,108728,j);A=A+1|0;}while((A|0)<7);D=64480;E=c[16120]|0;Vd[E&511](1);F=jd(0)|0;qd(0)}else if((w|0)==29){A=1;do{z=c[109736+(A<<2)>>2]|0;c[h>>2]=c[109624+(A<<2)>>2];c[h+4>>2]=z;Lu(1,0,108728,h);A=A+1|0;}while((A|0)<20);D=64480;E=c[16120]|0;Vd[E&511](1);F=jd(0)|0;qd(0)}else if((w|0)==7){A=1;do{z=c[110144+(A<<2)>>2]|0;c[k>>2]=c[110128+(A<<2)>>2];c[k+4>>2]=z;Lu(1,0,108728,k);A=A+1|0;}while((A|0)<4);D=64480;E=c[16120]|0;Vd[E&511](1);F=jd(0)|0;qd(0)}else if((w|0)==19){A=c[15554]|0;if((A|0)<28){G=A}else{D=64480;E=c[16120]|0;Vd[E&511](1);F=jd(0)|0;qd(0)}do{A=c[63800+(G<<2)>>2]|0;c[l>>2]=c[62632+(G<<2)>>2];c[l+4>>2]=A;Lu(1,0,108728,l);G=G+1|0;}while((G|0)<28);D=64480;E=c[16120]|0;Vd[E&511](1);F=jd(0)|0;qd(0)}else{D=64480;E=c[16120]|0;Vd[E&511](1);F=jd(0)|0;qd(0)}}}while(0);c[t>>2]=c[b>>2];Lu(1,1,109840,t);t=1;do{b=c[72184+(t<<2)>>2]|0;do{if((b|0)==1){F=c[70064+(t<<2)>>2]|0;c[s>>2]=c[68160+(t<<2)>>2];c[s+4>>2]=F;Lu(1,0,109856,s)}else{F=c[68160+(t<<2)>>2]|0;if((b|0)==2){E=c[70064+(t<<2)>>2]|0;c[r>>2]=F;c[r+4>>2]=F;c[r+8>>2]=E;Lu(1,0,109872,r);break}else{c[q>>2]=F;Nu(1,0,109904,q);break}}}while(0);t=t+1|0;}while((t|0)<31);Vd[c[16120]&511](1);jd(0)|0;qd(0);return 0}function OK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0;a=i;i=i+8|0;b=a;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=c[27604]|0;qb(111952)|0;c[l>>2]=c[m+88>>2];cc(110424,l|0)|0;qb(111968)|0;l=j;h[k>>3]=+h[m+264>>3];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];cc(110448,j|0)|0;j=m+4|0;m=g;h[k>>3]=+h[c[(c[j>>2]|0)+4>>2]>>3];c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];cc(110488,g|0)|0;g=f;h[k>>3]=+h[c[(c[j>>2]|0)+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];cc(110520,f|0)|0;f=c[j>>2]|0;g=e;h[k>>3]=+h[c[f+4>>2]>>3]- +h[c[f+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];cc(110552,e|0)|0;e=d;h[k>>3]=+h[c[c[j>>2]>>2]>>3];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];cc(110584,d|0)|0;d=c[j>>2]|0;j=b;h[k>>3]=+h[c[d>>2]>>3]- +h[c[d+4>>2]>>3];c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];cc(110616,b|0)|0;qb(111992)|0;i=a;return}function PK(a,b){a=a|0;b=+b;i=i;return}function QK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;e=i;f=i;i=i+168|0;c[f>>2]=0;g=i;i=i+160|0;h=(c[d+536>>2]|0)+76|0;j=c[h>>2]|0;c[h>>2]=g;aZ(g,1,f|0)|0;u=0;g=u;u=0;if((g|0)!=0&(v|0)!=0){k=oZ(c[g>>2]|0,f)|0;if((k|0)==0){bb(g|0,v|0)}J=v}else{k=-1}if((k|0)==1){l=J}else{l=0}while(1){if((l|0)==0){u=0;k=va(40,a|0,b|0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){m=oZ(c[g>>2]|0,f)|0;if((m|0)==0){bb(g|0,v|0)}J=v}else{m=-1}if((m|0)==1){l=J;continue}if((k|0)!=0){n=1;o=17;break}c[27604]=d;u=0;Ha(54,10,277)|0;k=u;u=0;if((k|0)!=0&(v|0)!=0){p=oZ(c[k>>2]|0,f)|0;if((p|0)==0){bb(k|0,v|0)}J=v}else{p=-1}if((p|0)==1){l=J;continue}u=0;k=va(41,0,0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){q=oZ(c[g>>2]|0,f)|0;if((q|0)==0){bb(g|0,v|0)}J=v}else{q=-1}if((q|0)==1){l=J;continue}u=0;sa(108,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){r=oZ(c[g>>2]|0,f)|0;if((r|0)==0){bb(g|0,v|0)}J=v}else{r=-1}if((r|0)==1){l=J;continue}u=0;sa(109,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){s=oZ(c[g>>2]|0,f)|0;if((s|0)==0){bb(g|0,v|0)}J=v}else{s=-1}if((s|0)==1){l=J;continue}u=0;sa(110,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){t=oZ(c[g>>2]|0,f)|0;if((t|0)==0){bb(g|0,v|0)}J=v}else{t=-1}if((t|0)==1){l=J;continue}u=0;pa(c[(c[d+540>>2]|0)+8>>2]|0,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){w=oZ(c[g>>2]|0,f)|0;if((w|0)==0){bb(g|0,v|0)}J=v}else{w=-1}if((w|0)==1){l=J;continue}u=0;pa(278,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){x=oZ(c[g>>2]|0,f)|0;if((x|0)==0){bb(g|0,v|0)}J=v}else{x=-1}if((x|0)==1){l=J;continue}u=0;sa(99,0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){y=oZ(c[g>>2]|0,f)|0;if((y|0)==0){bb(g|0,v|0)}J=v}else{y=-1}if((y|0)==1){l=J;continue}z=k}else{z=-1}c[h>>2]=j;u=0;k=u;u=0;if((k|0)!=0&(v|0)!=0){A=oZ(c[k>>2]|0,f)|0;if((A|0)==0){bb(k|0,v|0)}J=v}else{A=-1}if((A|0)==1){l=J}else{break}}if((o|0)==17){i=e;return n|0}n=z;i=e;return n|0}function RK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=d;d=c[r>>2]|0;mc(110664,9,1,d|0)|0;yc(d|0,b|0,e|0)|0;Gd(10,d|0)|0;jd(0)|0;i=a;return}function SK(a,b){a=a|0;b=b|0;var c=0;c=i;UK(a,b);i=c;return}function TK(a){a=a|0;i=i;return(c[a>>2]|0)==0|0}function UK(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=nP(b+(c[(c[b>>2]|0)+ -12>>2]|0)|0)|0;i=d;return}function VK(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+8|0;l=j+16|0;m=j+32|0;n=j+40|0;o=b;b=c[o>>2]|0;Sz(j);if((b|0)==0){c[a>>2]=0;i=j;return}p=f;f=d;q=p-f|0;r=WK(g)|0;s=(r|0)>(q|0)?r-q|0:0;q=e;r=q-f|0;do{if((r|0)>0){if((zP(b,d,r)|0)==(r|0)){break}Sz(k);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);do{if((s|0)>0){pO(l,s,h);if((zP(b,tO(l)|0,s)|0)==(s|0)){uO(l);break}Sz(m);c[o>>2]=0;c[a>>2]=0;uO(l);i=j;return}}while(0);l=p-q|0;do{if((l|0)>0){if((zP(b,e,l)|0)==(l|0)){break}Sz(n);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);XK(g,0)|0;c[a>>2]=b;i=j;return}function WK(a){a=a|0;i=i;return c[a+12>>2]|0}function XK(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function YK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+136|0;g=f;ZK(g,16);_K(g+(c[(c[g>>2]|0)+ -12>>2]|0)|0,16)|0;if((d|0)<=0){$K(a,g);aL(g);i=f;return}j=e+ -1|0;k=(j|0)>0;l=(e|0)>0;m=g;n=(e|0)==0;e=0;do{if(k){o=0;p=e;while(1){GK(IQ(m,+h[b+(p<<3)>>3])|0,112008)|0;q=p+d|0;r=o+1|0;if((r|0)<(j|0)){p=q;o=r}else{s=q;break}}}else{s=e}if(l){IQ(m,+h[b+(s<<3)>>3])|0}e=e+1|0;if(!((e|0)==(d|0)|n)){GK(m,112016)|0}}while((e|0)<(d|0));$K(a,g);aL(g);i=f;return}function ZK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+56|0;rP(e);f=a;c[f>>2]=112388;g=e;c[g>>2]=112408;e=a+4|0;yQ(a,112420|0,e);c[f>>2]=112388;c[g>>2]=112408;mL(e,b|16);i=d;return}function _K(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function $K(a,b){a=a|0;b=b|0;var c=0;c=i;gL(a,b+4|0);i=c;return}function aL(a){a=a|0;var b=0;b=i;qL(a,112416);mP(a+56|0);i=b;return}function bL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+120>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[63984>>2]|0)!=0){qb(112712)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Lu(14,0,112024,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);Yd[c[(c[l>>2]|0)+160>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Lu(14,0,112096,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[63984>>2]|0)==0){i=d;return 0}Lu(14,0,112144,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];cc(112160,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}$b(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function cL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+124>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[63984>>2]|0)!=0){qb(112712)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Lu(14,0,112024,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);Yd[c[(c[l>>2]|0)+164>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Lu(14,0,112096,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[63984>>2]|0)==0){i=d;return 0}Lu(14,0,112144,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];cc(112160,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}$b(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function dL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+128>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[63984>>2]|0)!=0){qb(112712)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Lu(14,0,112024,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);Yd[c[(c[l>>2]|0)+168>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Lu(14,0,112096,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[63984>>2]|0)==0){i=d;return 0}Lu(14,0,112144,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];cc(112160,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}$b(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function eL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+132>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[63984>>2]|0)!=0){qb(112712)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Lu(14,0,112024,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);Yd[c[(c[l>>2]|0)+172>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Lu(14,0,112096,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[63984>>2]|0)==0){i=d;return 0}Lu(14,0,112144,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];cc(112160,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}$b(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function fL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+24|0;d=b;e=i;i=i+24|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=c[a+112>>2]|0;G=c[a+152>>2]|0;H=c[a+156>>2]|0;I=BY(fa(F,F)|0,8)|0;J=I;K=BY(fa(G,F)|0,8)|0;L=K;M=BY(fa(H,F)|0,8)|0;N=M;O=BY(fa(H,G)|0,8)|0;P=O;iO(p);iO(q);iO(r);iO(s);iO(t);iO(u);iO(v);Q=a+536|0;Ou(c[Q>>2]|0,(I|0)!=0|0,112168,o);Ou(c[Q>>2]|0,(K|0)!=0|0,112168,n);Ou(c[Q>>2]|0,(M|0)!=0|0,112168,m);Ou(c[Q>>2]|0,(O|0)!=0|0,112168,l);l=a+540|0;m=a;if((Yd[c[(c[l>>2]|0)+140>>2]&127](m)|0)==0){n=c[Q>>2]|0;bL(a,J)|0;Ou(n,1,112184,k)}YK(w,J,F,F);vO(p,w)|0;uO(w);if((Yd[c[(c[l>>2]|0)+144>>2]&127](m)|0)==0){w=c[Q>>2]|0;cL(a,L)|0;Ou(w,1,112216,j)}YK(x,L,F,G);vO(q,x)|0;uO(x);if((Yd[c[(c[l>>2]|0)+148>>2]&127](m)|0)==0){x=c[Q>>2]|0;dL(a,N)|0;Ou(x,1,112248,h)}YK(y,N,H,F);vO(r,y)|0;uO(y);if((Yd[c[(c[l>>2]|0)+152>>2]&127](m)|0)==0){m=c[Q>>2]|0;eL(a,P)|0;Ou(m,1,112280,g)}YK(z,P,H,G);vO(s,z)|0;uO(z);if((F|0)==0){wO(t,112312)|0}else{YK(A,c[(c[c[a+4>>2]>>2]|0)+8>>2]|0,1,F);vO(t,A)|0;uO(A)}if((G|0)==0){wO(u,112312)|0}else{YK(B,c[a+432>>2]|0,1,G);vO(u,B)|0;uO(B)}AY(I);AY(K);AY(M);AY(O);oO(E,c[a+84>>2]|0);dP(D,112328,E);sD(C,D,112336);vO(v,C)|0;uO(C);uO(D);uO(E);E=ec(RO(v)|0,112344)|0;D=c[Q>>2]|0;c[f>>2]=RO(v)|0;Ou(D,(E|0)!=0|0,112352,f);f=pe[c[(c[l>>2]|0)+176>>2]&7]()|0;D=RO(t)|0;Q=RO(u)|0;C=RO(p)|0;a=RO(q)|0;O=RO(r)|0;M=RO(s)|0;c[e>>2]=D;c[e+4>>2]=Q;c[e+8>>2]=C;c[e+12>>2]=a;c[e+16>>2]=O;c[e+20>>2]=M;ld(E|0,f|0,e|0)|0;if((c[64028>>2]|0)==0){R=jd(E|0)|0;S=Sc(E|0)|0;uO(v);uO(u);uO(t);uO(s);uO(r);uO(q);uO(p);i=b;return 0}e=pe[c[(c[l>>2]|0)+176>>2]&7]()|0;l=RO(t)|0;f=RO(u)|0;M=RO(p)|0;O=RO(q)|0;a=RO(r)|0;C=RO(s)|0;c[d>>2]=l;c[d+4>>2]=f;c[d+8>>2]=M;c[d+12>>2]=O;c[d+16>>2]=a;c[d+20>>2]=C;Lu(25,0,e,d);R=jd(E|0)|0;S=Sc(E|0)|0;uO(v);uO(u);uO(t);uO(s);uO(r);uO(q);uO(p);i=b;return 0}function gL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;h=c[b+48>>2]|0;if((h&16|0)!=0){j=b+44|0;k=c[j>>2]|0;l=b;m=HP(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}hL(a,GP(l)|0,n,e);i=d;return}if((h&8|0)==0){jO(a,g);i=d;return}else{g=b;b=BP(g)|0;hL(a,b,DP(g)|0,f);i=d;return}}function hL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;iL(a,b,c,0);i=d;return}function iL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;jL(a,b,c);i=d;return}function jL(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=kL(c,d)|0;if(g>>>0>4294967279){gO(0)}if(g>>>0<11){AO(b,g);h=zO(b)|0}else{j=HO(g)|0;k=j+1|0;j=cE(nO(b)|0,k)|0;JO(b,j);IO(b,k);yO(b,g);h=j}if((c|0)==(d|0)){l=h;a[f]=0;dE(l,f);i=e;return}j=d+(0-c)|0;g=c;c=h;while(1){dE(c,g);b=g+1|0;if((b|0)==(d|0)){break}else{c=c+1|0;g=b}}l=h+j|0;a[f]=0;dE(l,f);i=e;return}function kL(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=lL(b,c,e)|0;i=d;return g|0}function lL(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return b-a|0}function mL(a,b){a=a|0;b=b|0;var c=0;c=i;CL(a,b);i=c;return}function nL(a){a=a|0;var b=0;b=i;aL(a);HY(a);i=b;return}function oL(a){a=a|0;var b=0;b=i;aL(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function pL(a){a=a|0;var b=0;b=i;nL(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function qL(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];rL(a+4|0);i=d;return}function rL(a){a=a|0;var b=0;b=i;sL(a);i=b;return}function sL(a){a=a|0;var b=0;b=i;c[a>>2]=112568;uO(a+32|0);vP(a);i=b;return}function tL(a){a=a|0;var b=0;b=i;rL(a);HY(a);i=b;return}function uL(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=b+44|0;k=c[j>>2]|0;l=b;m=HP(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}k=g&24;do{if((k|0)==24){if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}ez(a,-1,-1);i=h;return}else if((k|0)==0){ez(a,-1,-1);i=h;return}else{if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}if((g&8|0)==0){m=HP(l)|0;j=m-(GP(l)|0)|0;p=j;q=((j|0)<0)<<31>>31;break}else{j=CP(l)|0;m=j-(BP(l)|0)|0;p=m;q=((m|0)<0)<<31>>31;break}}}while(0);if((o|0)==11){f=n-(tO(b+32|0)|0)|0;p=f;q=((f|0)<0)<<31>>31}else if((o|0)==12){ez(a,-1,-1);i=h;return}o=lZ(p|0,q|0,d|0,e|0)|0;e=J;do{if(!((e|0)<0|(e|0)==0&o>>>0<0)){d=n-(tO(b+32|0)|0)|0;q=((d|0)<0)<<31>>31;if((q|0)<(e|0)|(q|0)==(e|0)&d>>>0<o>>>0){break}d=g&8;do{if(!((o|0)==0&(e|0)==0)){do{if((d|0)!=0){if((CP(l)|0)!=0){break}ez(a,-1,-1);i=h;return}}while(0);if((g&16|0)==0){break}if((HP(l)|0)!=0){break}ez(a,-1,-1);i=h;return}}while(0);if((d|0)!=0){q=BP(l)|0;FP(l,q,q+o|0,n)}if((g&16|0)!=0){q=GP(l)|0;KP(l,q,IP(l)|0);JP(l,o)}ez(a,o,e);i=h;return}}while(0);ez(a,-1,-1);i=h;return}function vL(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[b>>2]|0)+16>>2]|0;h=sA(d)|0;fe[g&31](a,b,h,J,0,e);i=f;return}function wL(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+44|0;f=c[e>>2]|0;g=b;h=HP(g)|0;if(f>>>0<h>>>0){c[e>>2]=h;j=h}else{j=f}if((c[b+48>>2]&8|0)==0){k=-1;i=d;return k|0}if((DP(g)|0)>>>0<j>>>0){b=BP(g)|0;FP(g,b,CP(g)|0,j)}j=CP(g)|0;if(!(j>>>0<(DP(g)|0)>>>0)){k=-1;i=d;return k|0}k=QA(a[j]|0)|0;i=d;return k|0}function xL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+44|0;g=c[f>>2]|0;h=b;j=HP(h)|0;if(g>>>0<j>>>0){c[f>>2]=j;k=j}else{k=g}g=BP(h)|0;j=CP(h)|0;if(!(g>>>0<j>>>0)){l=-1;i=e;return l|0}if(MA(d,-1)|0){FP(h,g,j+ -1|0,k);l=PA(d)|0;i=e;return l|0}g=(c[b+48>>2]&16|0)==0;b=NA(d)|0;do{if(g){if(RA(b,a[j+ -1|0]|0)|0){break}else{l=-1}i=e;return l|0}}while(0);j=BP(h)|0;FP(h,j,(CP(h)|0)+ -1|0,k);a[CP(h)|0]=b;l=d;i=e;return l|0}function yL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;if(MA(b,-1)|0){f=PA(b)|0;i=d;return f|0}g=a;h=CP(g)|0;j=h-(BP(g)|0)|0;h=HP(g)|0;do{if((h|0)==(IP(g)|0)){k=a+48|0;if((c[k>>2]&16|0)==0){f=-1;i=d;return f|0}else{l=GP(g)|0;m=a+44|0;n=(c[m>>2]|0)-l|0;o=a+32|0;MO(o,0);FO(o,CO(o)|0);p=tO(o)|0;KP(g,p,p+(sO(o)|0)|0);JP(g,h-l|0);c[m>>2]=(GP(g)|0)+n;q=k;r=m;break}}else{q=a+48|0;r=a+44|0}}while(0);c[e>>2]=(HP(g)|0)+1;h=c[(zL(e,r)|0)>>2]|0;c[r>>2]=h;if((c[q>>2]&8|0)!=0){q=tO(a+32|0)|0;FP(g,q,q+j|0,h)}f=yP(g,b&255)|0;i=d;return f|0}function zL(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=AL(b,c,e)|0;i=d;return g|0}function AL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=BL(0,a,b)|0;i=c;return(d?b:a)|0}function BL(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function CL(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;AP(a);c[a>>2]=112568;iO(a+32|0);c[a+44>>2]=0;c[a+48>>2]=b;iO(e);DL(a,e);uO(e);i=d;return}function DL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+32|0;vO(e,b)|0;b=a+44|0;c[b>>2]=0;f=a+48|0;g=c[f>>2]|0;if((g&8|0)==0){h=g}else{g=tO(e)|0;j=g+(sO(e)|0)|0;c[b>>2]=j;g=tO(e)|0;FP(a,g,g,j);h=c[f>>2]|0}if((h&16|0)==0){i=d;return}h=sO(e)|0;c[b>>2]=(tO(e)|0)+h;FO(e,CO(e)|0);b=a;a=tO(e)|0;KP(b,a,a+(sO(e)|0)|0);if((c[f>>2]&3|0)==0){i=d;return}JP(b,h);i=d;return}function EL(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0;j=i;i=i+8|0;g=j;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=ec(d|0,112992)|0;J=Wc(113e3,112992)|0;K=(J|0)!=0;L=Ic()|0;if(K){M=c[b+536>>2]|0;N=Kd(c[L>>2]|0)|0;c[E>>2]=d;c[E+4>>2]=N;Ou(M,(I|0)!=0|0,113056,E);mc(113080,17,1,J|0)|0;mc(113104,10,1,J|0)|0;mc(113120,18,1,J|0)|0;FL(J,f,113144,c[b+88>>2]|0,(c[b+72>>2]|0)+(c[b+64>>2]|0)|0,-1,999,113176)}else{c[G>>2]=Kd(c[L>>2]|0)|0;Nu(26,0,113008,G);G=c[b+536>>2]|0;E=Kd(c[L>>2]|0)|0;c[F>>2]=d;c[F+4>>2]=E;Ou(G,(I|0)!=0|0,113056,F)}mc(113184,348,1,I|0)|0;if((nc(H|0)|0)<0){c[D>>2]=Kd(c[L>>2]|0)|0;Nu(26,0,113536,D);Sc(I|0)|0;Za(J|0)|0;O=1;i=j;return O|0}if((Nc(112736,250,113560,cd(H|0)|0)|0)==0){Nu(26,0,113584,C);Sc(I|0)|0;O=1;i=j;return O|0}mc(113608,13,1,I|0)|0;mc(113624,12,1,I|0)|0;GL(I,2);mc(113640,6,1,I|0)|0;HL(I,c[b+84>>2]|0);mc(113648,8,1,I|0)|0;GL(I,2);mc(113664,8,1,I|0)|0;C=b+88|0;HL(I,c[C>>2]|0);mc(113680,10,1,I|0)|0;GL(I,2);mc(113696,6,1,I|0)|0;HL(I,112736);mc(113704,8,1,I|0)|0;GL(I,2);mc(113720,8,1,I|0)|0;HL(I,c[b+280>>2]|0);mc(113736,10,1,I|0)|0;GL(I,2);mc(113752,14,1,I|0)|0;HL(I,c[b+284>>2]|0);mc(113768,16,1,I|0)|0;GL(I,2);mc(113792,16,1,I|0)|0;HL(I,l);mc(113816,18,1,I|0)|0;GL(I,2);c[B>>2]=IL(l)|0;ld(I|0,113840,B|0)|0;GL(I,2);P=+Lv(7);B=A;h[k>>3]=P;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];ld(I|0,113880,A|0)|0;GL(I,2);P=+Lv(6);A=z;h[k>>3]=P;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];ld(I|0,113920,z|0)|0;GL(I,2);P=+Lv(1);z=y;h[k>>3]=P;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];ld(I|0,113952,y|0)|0;GL(I,2);P=+Lv(4);y=x;h[k>>3]=P;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];ld(I|0,113984,x|0)|0;GL(I,2);P=+Lv(3);x=w;h[k>>3]=P;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];ld(I|0,114016,w|0)|0;GL(I,2);P=+Lv(5);w=v;h[k>>3]=P;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];ld(I|0,114048,v|0)|0;GL(I,2);P=+Lv(0);v=u;h[k>>3]=P;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];ld(I|0,114088,u|0)|0;GL(I,2);P=+Ov(2);u=t;h[k>>3]=P;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];ld(I|0,114120,t|0)|0;GL(I,2);c[s>>2]=Jv(2)|0;ld(I|0,114160,s|0)|0;GL(I,2);P=+Nv(2);s=r;h[k>>3]=P;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];ld(I|0,114184,r|0)|0;mc(114216,13,1,I|0)|0;mc(114232,16,1,I|0)|0;GL(I,2);P=+Lv(8);r=q;h[k>>3]=P;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];ld(I|0,114256,q|0)|0;GL(I,2);c[p>>2]=Gv(8)|0;ld(I|0,114280,p|0)|0;mc(114320,17,1,I|0)|0;mc(114344,22,1,I|0)|0;JL(I,b);mc(114368,23,1,I|0)|0;mc(114392,12,1,I|0)|0;p=b+116|0;if((c[p>>2]|0)>0){q=b+8|0;r=0;do{KL(I,(c[q>>2]|0)+(r*112|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+136|0;if((c[p>>2]|0)>0){r=b+24|0;q=0;do{KL(I,(c[r>>2]|0)+(q*112|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+124|0;if((c[p>>2]|0)>0){q=b+12|0;r=0;do{KL(I,(c[q>>2]|0)+(r*60|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+140|0;if((c[p>>2]|0)>0){r=b+28|0;q=0;do{KL(I,(c[r>>2]|0)+(q*60|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+128|0;if((c[p>>2]|0)>0){q=b+16|0;r=0;do{KL(I,(c[q>>2]|0)+(r*48|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+144|0;if((c[p>>2]|0)>0){r=b+32|0;q=0;do{KL(I,(c[r>>2]|0)+(q*48|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+132|0;if((c[p>>2]|0)>0){q=b+20|0;r=0;do{KL(I,(c[q>>2]|0)+(r*52|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+148|0;if((c[p>>2]|0)>0){r=b+36|0;q=0;do{KL(I,(c[r>>2]|0)+(q*52|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}mc(114408,13,1,I|0)|0;mc(114424,12,1,I|0)|0;LL(I,J,f,c[C>>2]|0,b);mc(114440,13,1,I|0)|0;mc(114456,12,1,I|0)|0;ML(I,c[b+68>>2]|0,b+56|0);mc(114472,13,1,I|0)|0;mc(114488,16,1,I|0)|0;NL(I,J,f,b);mc(114512,17,1,I|0)|0;mc(114536,14,1,I|0)|0;Sc(I|0)|0;if(!K){O=0;i=j;return O|0}K=c[b+508>>2]|0;b=((bZ(e|0)|0)<<1)+230|0;e=(K|0)!=0;if(e){Q=(bZ(K|0)|0)<<1}else{Q=0}I=zY(b+Q|0)|0;if((I|0)==0){$a(114552,114560,404,114584)}if((Za(J|0)|0)!=0){Nu(26,0,114600,o)}if(e){e=c[C>>2]|0;c[n>>2]=114632;c[n+4>>2]=e;c[n+8>>2]=K;c[n+12>>2]=e;dc(I|0,114648,n|0)|0;if((hd(I|0)|0)!=0){R=42}}else{n=I+0|0;e=114728|0;K=n+25|0;do{a[n]=a[e]|0;n=n+1|0;e=e+1|0}while((n|0)<(K|0));R=42}if((R|0)==42){c[m>>2]=I;Nu(1,0,114760,m)}m=c[C>>2]|0;c[g>>2]=m;c[g+4>>2]=m;Lu(1,0,114824,g);AY(I);O=0;i=j;return O|0}function FL(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0;m=i;i=i+24|0;n=m;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+24|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+24|0;C=i;i=i+8|0;D=i;i=i+16|0;if((a|0)==0){i=m;return}E=(g|0)>-1;if(E){F=g+9|0;G=Hv(F)|0;H=Iv(F)|0;if((G|0)==0){I=-.01}else{I=+(G>>>0)*.95}if((H|0)==0){J=.01}else{J=+(H>>>0)*1.05}K=H;L=G;M=+Nv(F)*1.01+1.0e-30;N=J;O=I}else{K=0;L=0;M=0.0;N=0.0;O=0.0}mc(113080,17,1,a|0)|0;mc(115992,12,1,a|0)|0;mc(116008,12,1,a|0)|0;mc(116024,13,1,a|0)|0;c[D>>2]=e;c[D+4>>2]=l;c[D+8>>2]=j;ld(a|0,116040,D|0)|0;mc(116080,10,1,a|0)|0;mc(116096,11,1,a|0)|0;mc(116112,11,1,a|0)|0;mc(116128,10,1,a|0)|0;if(E){D=C;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];ld(a|0,116144,C|0)|0}else{mc(116168,17,1,a|0)|0}C=g+3|0;c[B>>2]=e;c[B+4>>2]=f;c[B+8>>2]=f;c[B+12>>2]=C;c[B+16>>2]=C;c[B+20>>2]=4;ld(a|0,115768,B|0)|0;mc(116192,13,1,a|0)|0;if(E){mc(116008,12,1,a|0)|0;if((L|0)==(K|0)){B=A;h[k>>3]=O;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=N;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];ld(a|0,116208,A|0)|0}else{mc(116168,17,1,a|0)|0}c[z>>2]=e;c[z+4>>2]=l;c[z+8>>2]=j;ld(a|0,116232,z|0)|0;c[y>>2]=e;c[y+4>>2]=f;c[y+8>>2]=f;c[y+12>>2]=g+1;c[y+16>>2]=4;ld(a|0,115888,y|0)|0;mc(116280,10,1,a|0)|0;mc(116296,10,1,a|0)|0;mc(116280,10,1,a|0)|0;mc(116312,11,1,a|0)|0;c[x>>2]=b;ld(a|0,116328,x|0)|0;c[w>>2]=d;ld(a|0,116352,w|0)|0;mc(116368,33,1,a|0)|0;mc(116408,32,1,a|0)|0;c[v>>2]=e;c[v+4>>2]=l;c[v+8>>2]=j;c[v+12>>2]=b;ld(a|0,116448,v|0)|0;mc(116128,10,1,a|0)|0;v=u;h[k>>3]=M;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];ld(a|0,116144,u|0)|0}else{mc(116296,10,1,a|0)|0;mc(116280,10,1,a|0)|0;mc(116312,11,1,a|0)|0;c[t>>2]=b;ld(a|0,116328,t|0)|0;c[s>>2]=d;ld(a|0,116352,s|0)|0;mc(116368,33,1,a|0)|0;mc(116408,32,1,a|0)|0;c[r>>2]=e;c[r+4>>2]=l;c[r+8>>2]=j;c[r+12>>2]=b;ld(a|0,116448,r|0)|0;mc(116128,10,1,a|0)|0;mc(116168,17,1,a|0)|0}c[q>>2]=e;c[q+4>>2]=f;c[q+8>>2]=f;c[q+12>>2]=C;c[q+16>>2]=C;c[q+20>>2]=2;ld(a|0,115768,q|0)|0;mc(116192,13,1,a|0)|0;if(!E){i=m;return}if((L|0)==(K|0)){K=p;h[k>>3]=O;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=p+8|0;h[k>>3]=N;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];ld(a|0,116208,p|0)|0}else{mc(116168,17,1,a|0)|0}mc(116480,32,1,a|0)|0;mc(116520,29,1,a|0)|0;c[o>>2]=e;c[o+4>>2]=l;c[o+8>>2]=j;c[o+12>>2]=b;ld(a|0,116552,o|0)|0;c[n>>2]=e;c[n+4>>2]=f;c[n+8>>2]=f;c[n+12>>2]=g+1;c[n+16>>2]=2;ld(a|0,115888,n|0)|0;i=m;return}function GL(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)==0){i=c;return}else{d=b}do{d=d+ -1|0;Gd(32,a|0)|0;}while((d|0)!=0);i=c;return}function HL(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;e=a[c]|0;if(e<<24>>24==0){i=d;return}else{f=c;g=e}do{e=g<<24>>24;if((e|0)==60){mc(115736,4,1,b|0)|0}else if((e|0)==62){mc(115744,4,1,b|0)|0}else if((e|0)==39){mc(115752,6,1,b|0)|0}else if((e|0)==34){mc(115760,6,1,b|0)|0}else{Gd(e|0,b|0)|0}f=f+1|0;g=a[f]|0;}while(!(g<<24>>24==0));i=d;return}function IL(a){a=a|0;var b=0,c=0,d=0;b=i;c=ec(a|0,115728)|0;if((c|0)==0){d=-1;i=b;return d|0}Qc(c|0,0,2)|0;a=vb(c|0)|0;Sc(c|0)|0;d=a;i=b;return d|0}function JL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;h=i;i=i+24|0;j=i;i=i+32|0;k=i;i=i+24|0;l=c[b+88>>2]|0;m=zY((bZ(l|0)|0)+15|0)|0;c[f>>2]=l;dc(m|0,115456,f|0)|0;GL(a,2);mc(115472,10,1,a|0)|0;HL(a,m);mc(115488,12,1,a|0)|0;GL(a,2);c[e>>2]=IL(m)|0;ld(a|0,115504,e|0)|0;AY(m);GL(a,2);mc(115536,9,1,a|0)|0;GL(a,4);mc(115552,22,1,a|0)|0;GL(a,4);mc(115576,22,1,a|0)|0;GL(a,4);mc(115600,26,1,a|0)|0;m=b+56|0;e=b+64|0;f=c[e>>2]|0;if((f|0)>0){l=g+4|0;n=0;while(1){PL(g,m,n);o=c[l>>2]|0;GL(a,4);mc(115632,8,1,a|0)|0;HL(a,o);mc(115648,18,1,a|0)|0;o=n+1|0;p=c[e>>2]|0;if((o|0)<(p|0)){n=o}else{q=p;break}}}else{q=f}f=b+72|0;b=c[f>>2]|0;if((b|0)>0){n=h+8|0;l=0;do{UL(h,m,l);g=c[n>>2]|0;GL(a,4);mc(115632,8,1,a|0)|0;HL(a,g);mc(115648,18,1,a|0)|0;l=l+1|0;r=c[f>>2]|0;}while((l|0)<(r|0));s=r;t=c[e>>2]|0}else{s=b;t=q}if((t|0)>0){t=j+4|0;q=0;do{PL(j,m,q);b=c[t>>2]|0;GL(a,4);mc(115672,8,1,a|0)|0;HL(a,b);mc(115688,21,1,a|0)|0;q=q+1|0;}while((q|0)<(c[e>>2]|0));u=c[f>>2]|0}else{u=s}if((u|0)<=0){GL(a,2);v=115712;w=v;x=mc(w|0,10,1,a|0)|0;i=d;return}u=k+8|0;s=0;do{UL(k,m,s);e=c[u>>2]|0;GL(a,4);mc(115672,8,1,a|0)|0;HL(a,e);mc(115688,21,1,a|0)|0;s=s+1|0;}while((s|0)<(c[f>>2]|0));GL(a,2);v=115712;w=v;x=mc(w|0,10,1,a|0)|0;i=d;return}function KL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+24|0;GL(a,2);c[f>>2]=c[b>>2];ld(a|0,115392,f|0)|0;HL(a,c[b+4>>2]|0);mc(115424,11,1,a|0)|0;HL(a,c[b+8>>2]|0);mc(115096,3,1,a|0)|0;f=e;g=b+12|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];OL(a,4,e);GL(a,2);mc(115440,12,1,a|0)|0;i=d;return}function LL(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+32|0;q=f+64|0;if((c[q>>2]|0)<=0){i=g;return}r=f+56|0;s=p+4|0;t=f+72|0;f=p;u=p+8|0;v=0;do{PL(p,r,v);FL(b,d,c[s>>2]|0,e,(c[t>>2]|0)+(c[q>>2]|0)|0,v,c[f>>2]|0,115208);w=v+9|0;Rv(w);GL(a,2);c[o>>2]=c[f>>2];ld(a|0,115216,o|0)|0;GL(a,4);mc(113640,6,1,a|0)|0;HL(a,c[s>>2]|0);mc(113648,8,1,a|0)|0;GL(a,4);c[n>>2]=Jv(w)|0;ld(a|0,114992,n|0)|0;GL(a,4);x=+Ov(w);y=m;h[k>>3]=x;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];ld(a|0,115016,m|0)|0;GL(a,4);x=+Nv(w);w=l;h[k>>3]=x;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];ld(a|0,114184,l|0)|0;w=j;y=u;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];OL(a,6,j);GL(a,2);mc(115240,12,1,a|0)|0;v=v+1|0;}while((v|0)<(c[q>>2]|0));i=g;return}function ML(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;if((b|0)<=0){i=e;return}q=l;r=m+8|0;s=n+12|0;t=d+8|0;u=d+16|0;v=o;w=p;x=0;do{GL(a,2);TL(l,d,x);c[j>>2]=c[q>>2];ld(a|0,115064,j|0)|0;TL(m,d,x);HL(a,c[r>>2]|0);mc(115096,3,1,a|0)|0;GL(a,4);mc(115104,7,1,a|0)|0;TL(n,d,x);if((c[s>>2]|0)>0){y=0;do{GL(a,6);c[g>>2]=0;ld(a|0,115112,g|0)|0;y=y+1|0;TL(n,d,x);}while((y|0)<(c[s>>2]|0))}GL(a,4);mc(115136,8,1,a|0)|0;GL(a,4);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;TL(o,d,x);z=+Lv(y+(c[v>>2]|0)|0);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;TL(p,d,x);A=Gv(y+(c[w>>2]|0)|0)|0;y=f;h[k>>3]=z;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[f+8>>2]=A;ld(a|0,115152,f|0)|0;GL(a,2);mc(115192,12,1,a|0)|0;x=x+1|0;}while((x|0)<(b|0));i=e;return}function NL(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=e+56|0;p=e+64|0;q=c[p>>2]|0;r=e+72|0;if((c[r>>2]|0)<=0){i=f;return}s=n+8|0;t=e+88|0;e=n;u=q;v=q;do{UL(n,o,v-u|0);FL(b,d,c[s>>2]|0,c[t>>2]|0,(c[r>>2]|0)+(c[p>>2]|0)|0,v,c[e>>2]|0,114944);q=v+9|0;Rv(q);GL(a,2);mc(114952,15,1,a|0)|0;GL(a,4);c[m>>2]=c[e>>2];ld(a|0,114968,m|0)|0;GL(a,4);c[l>>2]=Jv(q)|0;ld(a|0,114992,l|0)|0;GL(a,4);w=+Ov(q);x=j;h[k>>3]=w;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];ld(a|0,115016,j|0)|0;GL(a,4);w=+Nv(q);q=g;h[k>>3]=w;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];ld(a|0,114184,g|0)|0;GL(a,2);mc(115040,16,1,a|0)|0;v=v+1|0;u=c[p>>2]|0;}while((v|0)<((c[r>>2]|0)+u|0));i=f;return}function OL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;GL(a,b);mc(115256,16,1,a|0)|0;HL(a,c[d>>2]|0);b=c[d+8>>2]|0;g=c[d+12>>2]|0;h=c[d+16>>2]|0;j=(c[d+20>>2]|0)!=0?115360:115376;c[f>>2]=c[d+4>>2];c[f+4>>2]=b;c[f+8>>2]=g;c[f+12>>2]=h;c[f+16>>2]=j;ld(a|0,115280,f|0)|0;i=e;return}function PL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+24>>2]|0)==0){QL(b)}f=a;a=(c[b+20>>2]|0)+(d<<5)|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];i=e;return}function QL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+1024|0;c[h>>2]=a;k=h+4|0;c[k>>2]=1;l=h+8|0;c[l>>2]=0;m=h+12|0;c[m>>2]=0;n=a+4|0;do{if((c[n>>2]|0)==0){o=a;p=ec(c[o>>2]|0,116592)|0;if((p|0)!=0){q=p;break}p=Kd(c[(Ic()|0)>>2]|0)|0;c[g>>2]=c[o>>2];c[g+4>>2]=p;Pu(0,116600,g)}else{q=0}}while(0);g=Mp(0)|0;if((g|0)==0){Pu(0,116632,f)}f=a+8|0;c[a+20>>2]=BY(c[f>>2]|0,32)|0;p=a+12|0;o=BY((c[p>>2]|0)+1|0,20)|0;c[a+24>>2]=o;c[o>>2]=0;c[o+4>>2]=-1;c[o+8>>2]=116664;c[o+12>>2]=0;c[o+16>>2]=0;Xp(g,h);Yp(g,8,59);h=c[n>>2]|0;do{if((h|0)==0){o=j;fZ(o|0,0,1024)|0;while(1){r=pb(o|0,1,1024,q|0)|0;s=r>>>0<1024;if((Zp(g,o,r,s&1)|0)==0){t=9;break}if(s){t=11;break}}if((t|0)==9){o=fq(cq(g)|0)|0;s=dq(g)|0;Sc(q|0)|0;Tp(g);r=c[a>>2]|0;c[e>>2]=116768;c[e+4>>2]=r;c[e+8>>2]=o;c[e+12>>2]=s;Pu(0,116704,e)}else if((t|0)==11){Sc(q|0)|0;break}}else{if((Zp(g,h,bZ(h|0)|0,1)|0)!=0){break}s=fq(cq(g)|0)|0;o=dq(g)|0;Tp(g);r=c[n>>2]|0;c[d>>2]=116768;c[d+4>>2]=r;c[d+8>>2]=s;c[d+12>>2]=o;Pu(0,116808,d)}}while(0);if((c[p>>2]|0)!=(c[k>>2]|0)){$a(116872,116768,295,116912)}c[a+16>>2]=c[l>>2];if((c[f>>2]|0)==(c[m>>2]|0)){i=b;return}else{$a(116936,116768,297,116912)}}function RL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=c[a>>2]|0;n=c[a+4>>2]|0;o=c[a+12>>2]|0;if((ZY(117344,b)|0)==0){if((ZY(c[d>>2]|0,117352)|0)==0){p=(c[d+8>>2]|0)==0|0}else{p=0}Ou(0,p,117360,l);l=c[29300]|0;p=c[29354]|0;do{if((l|0)==0|(p|0)==0){c[29354]=32;a=zY(1152)|0;c[29300]=a;q=m+24|0;r=a}else{a=m+24|0;s=a;if(((c[(c[a>>2]|0)+(n*20|0)+12>>2]|0)+2|0)<(p|0)){q=s;r=l;break}c[29354]=p<<1;a=CY(l,p*72|0)|0;c[29300]=a;q=s;r=a}}while(0);p=(c[q>>2]|0)+(n*20|0)+12|0;q=c[p>>2]|0;c[p>>2]=q+1;p=r+(q*36|0)+0|0;q=(XL(c[d+4>>2]|0)|0)+0|0;r=p+36|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=e;return}if((ZY(117424,b)|0)==0){q=c[d>>2]|0;if((q|0)==0){i=e;return}else{t=d;u=q}a:while(1){do{if((ZY(117432,u)|0)==0){c[29360]=od(c[t+4>>2]|0)|0}else{if((ZY(117464,u)|0)==0){c[117444>>2]=Qb(c[t+4>>2]|0,0,10)|0;break}if((ZY(117480,u)|0)==0){c[117452>>2]=Qb(c[t+4>>2]|0,0,10)|0;break}if((ZY(117488,u)|0)==0){c[117448>>2]=Qb(c[t+4>>2]|0,0,10)|0;break}if((ZY(117504,u)|0)==0){c[117456>>2]=Qb(c[t+4>>2]|0,0,10)|0;break}if((ZY(117512,u)|0)!=0){v=23;break a}c[117460>>2]=(ZY(c[t+4>>2]|0,117528)|0)==0}}while(0);q=t+8|0;p=c[q>>2]|0;if((p|0)==0){v=45;break}else{t=q;u=p}}if((v|0)==23){c[k>>2]=c[m>>2];Pu(0,117536,k)}else if((v|0)==45){i=e;return}}if((ZY(117184,b)|0)==0){v=c[m+12>>2]|0;if((n|0)>(v|0)){k=c[m>>2]|0;c[j>>2]=116768;c[j+4>>2]=k;c[j+8>>2]=v;Pu(0,117568,j)}if((ZY(117632,c[d>>2]|0)|0)!=0){j=c[m>>2]|0;c[h>>2]=116768;c[h+4>>2]=j;Pu(0,117640,h)}h=Qb(c[d+4>>2]|0,0,10)|0;if((n|0)!=(h|0)){j=c[m>>2]|0;c[g>>2]=116768;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=n;Pu(0,117696,g)}g=m+24|0;h=c[g>>2]|0;c[h+(n*20|0)>>2]=n;c[h+(n*20|0)+4>>2]=-1;c[h+(n*20|0)+8>>2]=117760;h=c[g>>2]|0;c[h+(n*20|0)+12>>2]=0;c[h+(n*20|0)+16>>2]=0;i=e;return}if((ZY(117128,b)|0)!=0){if((ZY(117320,b)|0)!=0){i=e;return}b=m+20|0;m=c[b>>2]|0;c[m+(o<<5)>>2]=o;c[m+(o<<5)+4>>2]=117864;m=od(c[d+4>>2]|0)|0;c[(c[b>>2]|0)+(o<<5)+4>>2]=m;c[(c[b>>2]|0)+(o<<5)+8>>2]=117872;i=e;return}c[117148>>2]=0;c[117152>>2]=0;o=c[d>>2]|0;do{if((o|0)==0){w=0}else{b=d;m=o;do{do{if((ZY(m,117352)|0)==0){c[117148>>2]=od(c[b+4>>2]|0)|0}else{if((ZY(m,117816)|0)!=0){break}c[117152>>2]=od(c[b+4>>2]|0)|0}}while(0);b=b+8|0;m=c[b>>2]|0;}while((m|0)!=0);if((c[117148>>2]|0)==0){w=0;break}w=(c[117152>>2]|0)!=0|0}}while(0);Ou(0,w,117824,f);c[29286]=-1;f=117156|0;w=117440;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[f+20>>2]=c[w+20>>2];i=e;return}function SL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d;f=d+40|0;g=i;i=i+8|0;h=c[a>>2]|0;j=a+4|0;k=c[j>>2]|0;l=a+8|0;m=c[l>>2]|0;n=a+12|0;a=c[n>>2]|0;if((ZY(117128,b)|0)==0){o=e+0|0;p=117144|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));WL(e);i=d;return}if((ZY(117184,b)|0)==0){e=h+24|0;r=zY((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)*36|0)|0;c[(c[e>>2]|0)+(k*20|0)+16>>2]=r;if((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)>0){r=0;do{s=zY(36)|0;t=s;o=s+0|0;p=(c[29300]|0)+(r*36|0)+0|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));c[(c[(c[e>>2]|0)+(k*20|0)+16>>2]|0)+(r<<2)>>2]=t;r=r+1|0;}while((r|0)<(c[(c[e>>2]|0)+(k*20|0)+12>>2]|0))}c[j>>2]=k+1;i=d;return}if((ZY(117208,b)|0)==0){j=h+24|0;e=c[j>>2]|0;r=c[e+(k*20|0)+12>>2]|0;c[g>>2]=k;c[g+4>>2]=r;pd(e+(k*20|0)+8|0,117216,g|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((ZY(117256,b)|0)==0){j=h+24|0;h=c[j>>2]|0;g=c[h+(k*20|0)+12>>2]|0;c[f>>2]=k;c[f+4>>2]=g;pd(h+(k*20|0)+8|0,117272,f|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((ZY(117320,b)|0)!=0){i=d;return}c[n>>2]=a+1;i=d;return}function TL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==0){QL(b);h=c[f>>2]|0}else{h=g}g=a;a=h+(d*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}function UL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=b+24|0;if((c[h>>2]|0)==0){QL(b)}j=c[b+16>>2]|0;if(j>>>0<d>>>0){c[g>>2]=d;c[g+4>>2]=j;Pu(0,116976,g)}g=c[b+12>>2]|0;if((g|0)<=0){k=f;l=k;c[l>>2]=d;m=4;n=m;o=117056;p=o;Pu(0,p,f)}b=c[h>>2]|0;h=0;while(1){j=h+1|0;if((c[b+(h*20|0)+4>>2]|0)==(d|0)){q=9;break}if((j|0)<(g|0)){h=j}else{q=10;break}}if((q|0)==9){g=a;a=b+(h*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}else if((q|0)==10){k=f;l=k;c[l>>2]=d;m=4;n=m;o=117056;p=o;Pu(0,p,f)}}function VL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){AY(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=a+12|0;if((c[f>>2]|0)>0){a=e;g=0;while(1){AY(c[a+(g*20|0)+16>>2]|0);c[(c[d>>2]|0)+(g*20|0)+16>>2]=0;h=g+1|0;j=c[d>>2]|0;if((h|0)<(c[f>>2]|0)){g=h;a=j}else{k=j;break}}}else{k=e}AY(k);c[d>>2]=0;i=b;return}function WL(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;b=i;e=zY(72)|0;f=c[a+4>>2]|0;c[e>>2]=f;g=e+4|0;h=a+0|0;a=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(a|0));h=e+40|0;j=h;c[e+48>>2]=0;c[e+60>>2]=f;k=bZ(f|0)|0;c[e+64>>2]=k;k=c[29334]|0;do{if((k|0)==0){c[29334]=e;c[e+44>>2]=0;l=zY(44)|0;m=l;c[e+40>>2]=m;if((l|0)==0){qc(-1)}g=l+0|0;a=g+44|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(a|0));c[l+16>>2]=e+40;c[l+4>>2]=32;c[l+8>>2]=5;c[l+20>>2]=40;n=zY(384)|0;c[l>>2]=n;if((n|0)==0){qc(-1)}else{fZ(n|0,0,384)|0;c[l+40>>2]=-1609490463;o=f;p=m;break}}else{c[(c[(c[k+40>>2]|0)+16>>2]|0)+8>>2]=e;n=(c[29334]|0)+40|0;q=c[n>>2]|0;c[e+44>>2]=(c[q+16>>2]|0)+(0-(c[q+20>>2]|0));c[(c[n>>2]|0)+16>>2]=j;o=c[e>>2]|0;p=c[(c[29334]|0)+40>>2]|0}}while(0);k=p+12|0;c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=p;p=e+68|0;c[p>>2]=-17973521;k=bZ(o|0)|0;if(k>>>0>11){f=-17973521;g=-1640531527;a=-1640531527;n=k;q=o;do{r=((d[q+5|0]|0)<<8|(d[q+4|0]|0)|(d[q+6|0]|0)<<16|(d[q+7|0]|0)<<24)+a|0;s=((d[q+9|0]|0)<<8|(d[q+8|0]|0)|(d[q+10|0]|0)<<16|(d[q+11|0]|0)<<24)+f|0;t=((d[q+1|0]|0)<<8|(d[q]|0)|(d[q+2|0]|0)<<16|(d[q+3|0]|0)<<24)+g-r-s^s>>>13;u=r-s-t^t<<8;r=s-t-u^u>>>13;s=t-u-r^r>>>12;t=u-r-s^s<<16;u=r-s-t^t>>>5;g=s-t-u^u>>>3;a=t-u-g^g<<10;f=u-g-a^a>>>15;c[p>>2]=f;q=q+12|0;n=n+ -12|0;}while(n>>>0>11);v=f;w=c[e>>2]|0;x=g;y=a;z=n;A=q}else{v=-17973521;w=o;x=-1640531527;y=-1640531527;z=k;A=o}o=v+(bZ(w|0)|0)|0;c[p>>2]=o;switch(z|0){case 4:{B=o;C=y;D=19;break};case 7:{E=o;F=y;D=16;break};case 8:{G=o;D=15;break};case 10:{H=o;D=13;break};case 9:{I=o;D=14;break};case 2:{J=o;K=x;L=y;D=21;break};case 6:{M=o;N=y;D=17;break};case 5:{O=o;P=y;D=18;break};case 11:{z=((d[A+10|0]|0)<<24)+o|0;c[p>>2]=z;H=z;D=13;break};case 3:{Q=o;R=x;S=y;D=20;break};case 1:{T=o;U=x;V=y;D=22;break};default:{W=o;X=x;Y=y}}if((D|0)==13){o=((d[A+9|0]|0)<<16)+H|0;c[p>>2]=o;I=o;D=14}if((D|0)==14){o=((d[A+8|0]|0)<<8)+I|0;c[p>>2]=o;G=o;D=15}if((D|0)==15){E=G;F=((d[A+7|0]|0)<<24)+y|0;D=16}if((D|0)==16){M=E;N=((d[A+6|0]|0)<<16)+F|0;D=17}if((D|0)==17){O=M;P=((d[A+5|0]|0)<<8)+N|0;D=18}if((D|0)==18){B=O;C=(d[A+4|0]|0)+P|0;D=19}if((D|0)==19){Q=B;R=((d[A+3|0]|0)<<24)+x|0;S=C;D=20}if((D|0)==20){J=Q;K=((d[A+2|0]|0)<<16)+R|0;L=S;D=21}if((D|0)==21){T=J;U=((d[A+1|0]|0)<<8)+K|0;V=L;D=22}if((D|0)==22){W=T;X=(d[A]|0)+U|0;Y=V}V=X-Y-W^W>>>13;X=Y-W-V^V<<8;Y=W-V-X^X>>>13;W=V-X-Y^Y>>>12;V=X-Y-W^W<<16;X=Y-W-V^V>>>5;Y=W-V-X^X>>>3;W=V-X-Y^Y<<10;V=X-Y-W^W>>>15;c[p>>2]=V;p=(c[29334]|0)+40|0;W=c[p>>2]|0;Y=V&(c[W+4>>2]|0)+ -1;V=c[W>>2]|0;W=V+(Y*12|0)+4|0;c[W>>2]=(c[W>>2]|0)+1;c[e+56>>2]=c[V+(Y*12|0)>>2];c[e+52>>2]=0;e=c[c[p>>2]>>2]|0;p=c[e+(Y*12|0)>>2]|0;if((p|0)==0){Z=e}else{c[p+12>>2]=j;Z=c[c[(c[29334]|0)+40>>2]>>2]|0}c[Z+(Y*12|0)>>2]=j;j=c[c[(c[29334]|0)+40>>2]>>2]|0;if((c[j+(Y*12|0)+4>>2]|0)>>>0<(((c[j+(Y*12|0)+8>>2]|0)*10|0)+10|0)>>>0){i=b;return}Y=c[h>>2]|0;if((c[Y+36>>2]|0)==1){i=b;return}j=Y+4|0;Z=zY((c[j>>2]|0)*24|0)|0;p=Z;if((Z|0)==0){qc(-1)}fZ(Z|0,0,(c[j>>2]|0)*24|0)|0;e=c[Y+12>>2]|0;V=c[j>>2]|0;c[Y+24>>2]=(((V<<1)+ -1&e|0)!=0)+(e>>>((c[Y+8>>2]|0)+1|0));c[Y+28>>2]=0;e=c[Y>>2]|0;if((V|0)==0){_=e}else{V=Y;Y=e;e=0;while(1){j=c[Y+(e*12|0)>>2]|0;if((j|0)==0){$=V}else{W=V;X=j;while(1){j=X+16|0;U=c[j>>2]|0;A=(c[W+4>>2]<<1)+ -1&c[X+28>>2];T=Z+(A*12|0)+4|0;D=(c[T>>2]|0)+1|0;c[T>>2]=D;L=c[W+24>>2]|0;if(D>>>0>L>>>0){D=W+28|0;c[D>>2]=(c[D>>2]|0)+1;c[Z+(A*12|0)+8>>2]=((c[T>>2]|0)>>>0)/(L>>>0)|0}c[X+12>>2]=0;L=Z+(A*12|0)|0;c[j>>2]=c[L>>2];j=c[L>>2]|0;if((j|0)!=0){c[j+12>>2]=X}c[L>>2]=X;L=c[h>>2]|0;if((U|0)==0){$=L;break}else{W=L;X=U}}}X=e+1|0;W=c[$>>2]|0;if(X>>>0<(c[$+4>>2]|0)>>>0){V=$;Y=W;e=X}else{_=W;break}}}AY(_);_=c[h>>2]|0;e=_+4|0;c[e>>2]=c[e>>2]<<1;e=_+8|0;c[e>>2]=(c[e>>2]|0)+1;c[_>>2]=p;p=c[h>>2]|0;h=p+32|0;if(!((c[p+28>>2]|0)>>>0>(c[p+12>>2]|0)>>>1>>>0)){c[h>>2]=0;i=b;return}_=(c[h>>2]|0)+1|0;c[h>>2]=_;if(!(_>>>0>1)){i=b;return}c[p+36>>2]=1;i=b;return}function XL(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+8|0;e=b;a:do{if((c[29334]|0)==0){f=24}else{g=bZ(a|0)|0;if(g>>>0>11){h=-17973521;j=-1640531527;k=-1640531527;l=g;m=a;while(1){n=((d[m+5|0]|0)<<8|(d[m+4|0]|0)|(d[m+6|0]|0)<<16|(d[m+7|0]|0)<<24)+k|0;o=((d[m+9|0]|0)<<8|(d[m+8|0]|0)|(d[m+10|0]|0)<<16|(d[m+11|0]|0)<<24)+h|0;p=((d[m+1|0]|0)<<8|(d[m]|0)|(d[m+2|0]|0)<<16|(d[m+3|0]|0)<<24)+j-n-o^o>>>13;q=n-o-p^p<<8;n=o-p-q^q>>>13;o=p-q-n^n>>>12;p=q-n-o^o<<16;q=n-o-p^p>>>5;n=o-p-q^q>>>3;o=p-q-n^n<<10;p=q-n-o^o>>>15;q=m+12|0;r=l+ -12|0;if(r>>>0>11){m=q;l=r;k=o;j=n;h=p}else{s=p;t=n;u=o;v=r;w=q;break}}}else{s=-17973521;t=-1640531527;u=-1640531527;v=g;w=a}h=(bZ(a|0)|0)+s|0;switch(v|0){case 5:{x=h;y=u;f=11;break};case 2:{z=h;A=t;B=u;f=14;break};case 3:{C=h;D=t;E=u;f=13;break};case 6:{F=h;G=u;f=10;break};case 10:{H=h;f=6;break};case 4:{I=h;J=u;f=12;break};case 1:{K=h;L=t;M=u;f=15;break};case 11:{H=((d[w+10|0]|0)<<24)+h|0;f=6;break};case 9:{N=h;f=7;break};case 7:{O=h;P=u;f=9;break};case 8:{Q=h;f=8;break};default:{R=h;S=t;T=u}}if((f|0)==6){N=((d[w+9|0]|0)<<16)+H|0;f=7}if((f|0)==7){Q=((d[w+8|0]|0)<<8)+N|0;f=8}if((f|0)==8){O=Q;P=((d[w+7|0]|0)<<24)+u|0;f=9}if((f|0)==9){F=O;G=((d[w+6|0]|0)<<16)+P|0;f=10}if((f|0)==10){x=F;y=((d[w+5|0]|0)<<8)+G|0;f=11}if((f|0)==11){I=x;J=(d[w+4|0]|0)+y|0;f=12}if((f|0)==12){C=I;D=((d[w+3|0]|0)<<24)+t|0;E=J;f=13}if((f|0)==13){z=C;A=((d[w+2|0]|0)<<16)+D|0;B=E;f=14}if((f|0)==14){K=z;L=((d[w+1|0]|0)<<8)+A|0;M=B;f=15}if((f|0)==15){R=K;S=(d[w]|0)+L|0;T=M}h=S-R-T^R>>>13;j=T-R-h^h<<8;k=R-h-j^j>>>13;l=h-j-k^k>>>12;h=j-k-l^l<<16;j=k-l-h^h>>>5;k=l-h-j^j>>>3;l=h-j-k^k<<10;h=c[(c[29334]|0)+40>>2]|0;m=c[(c[h>>2]|0)+(((j-k-l^l>>>15)&(c[h+4>>2]|0)+ -1)*12|0)>>2]|0;if((m|0)==0){f=24;break}l=m+(0-(c[h+20>>2]|0))|0;if((l|0)==0){f=24;break}m=bZ(a|0)|0;k=l;while(1){U=k;if((c[k+64>>2]|0)==(m|0)){if((YY(c[k+60>>2]|0,a,m)|0)==0){break}}l=c[k+56>>2]|0;if((l|0)==0){f=24;break a}j=l+(0-(c[h+20>>2]|0))|0;if((j|0)==0){f=24;break a}else{k=j}}if((k|0)==0){f=24}else{V=U}}}while(0);do{if((f|0)==24){if((Ab(a|0,117896)|0)==0){V=0;break}else{W=117920}i=b;return W|0}}while(0);c[e>>2]=a;Ou(0,(V|0)!=0|0,117968,e);W=V+4|0;i=b;return W|0}function YL(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((ZL(118024,a,b)|0)!=0){d=1;i=c;return d|0}d=(ZL(118032,a,b)|0)!=0|0;i=c;return d|0}function ZL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)>0){g=0}else{h=0;i=f;return h|0}while(1){j=c[e+(g<<2)>>2]|0;if((a[j]|0)==45){if((ZY(b,j+1|0)|0)==0){h=1;k=5;break}}j=g+1|0;if((j|0)<(d|0)){g=j}else{h=0;k=5;break}}if((k|0)==5){i=f;return h|0}return 0}function _L(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=(ZY(c[68284>>2]|0,118040)|0)==0|0;Ou(0,m,118056,l);l=(ZY(c[70188>>2]|0,118040)|0)==0|0;Ou(0,l,118112,k);k=(ZY(c[72180>>2]|0,118040)|0)==0|0;Ou(0,k,118168,j);j=118232|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=118360|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((a|0)>1){n=1}else{o=0;i=d;return o|0}a:while(1){p=b+(n<<2)|0;j=n+1|0;k=1;while(1){l=c[72184+(k<<2)>>2]|0;if((l|0)==1){if((ZL(c[68160+(k<<2)>>2]|0,1,p)|0)!=0){q=5;break}}else if((l|0)==2){r=c[68160+(k<<2)>>2]|0;if(!((ZL(r,1,p)|0)==0|(j|0)>=(a|0))){q=9;break}s=c[68160+(k<<2)>>2]|0;if((aM(s,p)|0)!=0){q=13;break}}l=k+1|0;if((l|0)<31){k=l}else{q=17;break a}}if((q|0)==5){q=0;l=118232+(k<<2)|0;if((c[l>>2]|0)!=0){q=6;break}c[l>>2]=1;t=n}else if((q|0)==9){q=0;l=118232+(k<<2)|0;if((c[l>>2]|0)!=0){q=10;break}c[l>>2]=1;c[118360+(k<<2)>>2]=$L(r,p)|0;t=j}else if((q|0)==13){q=0;l=118232+(k<<2)|0;if((c[l>>2]|0)!=0){q=14;break}c[l>>2]=1;c[118360+(k<<2)>>2]=bM(s,p)|0;t=n}l=t+1|0;if((l|0)<(a|0)){n=l}else{o=0;q=19;break}}if((q|0)==6){c[h>>2]=c[p>>2];Nu(1,0,118488,h);o=1;i=d;return o|0}else if((q|0)==10){c[g>>2]=c[p>>2];Nu(1,0,118488,g);o=1;i=d;return o|0}else if((q|0)==14){c[f>>2]=c[p>>2];Nu(1,0,118488,f);o=1;i=d;return o|0}else if((q|0)==17){c[e>>2]=c[p>>2];Nu(1,0,118544,e);o=1;i=d;return o|0}else if((q|0)==19){i=d;return o|0}return 0}function $L(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;do{if((a[f]|0)==45){if((ZY(b,f+1|0)|0)!=0){g=0;break}g=c[d+4>>2]|0}else{g=0}}while(0);i=e;return g|0}function aM(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(bM(a,b)|0)!=0|0;i=c;return d|0}function bM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=bZ(b|0)|0;g=c[d>>2]|0;if((a[g]|0)!=45){h=0;i=e;return h|0}if((_Y(b,g+1|0,f)|0)!=0){h=0;i=e;return h|0}if((a[g+(f+1)|0]|0)!=61){h=0;i=e;return h|0}h=g+(f+2)|0;i=e;return h|0}function cM(){i=i;return}function dM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)<=0){qc(0)}e=c[r>>2]|0;mc(118576,5,1,e|0)|0;f=b;b=0;while(1){Gd(a[f]|0,e|0)|0;g=b+1|0;if((g|0)<(d|0)){b=g;f=f+1|0}else{break}}mc(118584,20,1,e|0)|0;qc(0);return 0}function eM(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;e=d;d=c[r>>2]|0;c[e>>2]=a;ld(d|0,118608,e|0)|0;if((b|0)==0){qc(1)}else{jd(d|0)|0;kM();jd(d|0)|0;fb(6,0)|0;$c()}}function fM(a,b){a=a|0;b=b|0;var c=0.0;c=+W(+(+h[a>>3]),+(+h[b>>3]));i=i;return+c}function gM(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0.0,g=0.0,j=0,k=0.0,l=0.0;d=i;e=+h[a>>3];a=c[b>>2]|0;if((a|0)==0){f=1.0;i=d;return+f}if((a|0)<0){g=1.0;j=0-a|0;k=1.0/e}else{g=1.0;j=a;k=e}while(1){if((j&1|0)==0){l=g}else{l=g*k}a=j>>>1;if((a|0)==0){f=l;break}g=l;j=a;k=k*k}i=d;return+f}function hM(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0;c=i;d=+h[a>>3];if(!(d>=0.0)){e=-d}else{e=d}if(+h[b>>3]>=0.0){f=e;i=c;return+f}f=-e;i=c;return+f}function iM(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=c;h=b+d|0;if((d|0)<=(e|0)){do{if(b>>>0>c>>>0){j=c+d|0;if(!(j>>>0>b>>>0)){break}if((d|0)>0){k=j;l=h}else{i=f;return}do{k=k+ -1|0;l=l+ -1|0;a[l]=a[k]|0;}while(l>>>0>b>>>0);i=f;return}}while(0);if((d|0)>0){m=c;n=b}else{i=f;return}while(1){l=n+1|0;a[n]=a[m]|0;if(l>>>0<h>>>0){n=l;m=m+1|0}else{break}}i=f;return}m=c+e|0;do{if(b>>>0>c>>>0&m>>>0>b>>>0){n=b+e|0;if((e|0)>0){l=0-g-e|0;k=~g;j=~(c+(l>>>0>k>>>0?l:k));k=n;l=m;do{l=l+ -1|0;k=k+ -1|0;a[k]=a[l]|0;}while(l>>>0>c>>>0);o=b+j|0}else{o=n}p=o+e|0}else{if((e|0)<=0){p=b;break}l=c+1|0;k=(m>>>0>l>>>0?m:l)+(0-g)|0;l=b;q=c;while(1){r=q+1|0;a[l]=a[q]|0;if(r>>>0<m>>>0){q=r;l=l+1|0}else{break}}p=b+k|0}}while(0);if(!(p>>>0<h>>>0)){i=f;return}fZ(p|0,32,b+(d-p)|0)|0;i=f;return}function jM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+4>>2]|0;if((e|0)>99){i=d;return 0}f=119648+(e*48|0)|0;g=c[f>>2]|0;if((g|0)!=0){do{if((c[119692+(e*48|0)>>2]|0)==1){h=10}else{j=c[b+8>>2]|0;if((j|0)!=0){k=a[j]|0;if((k|0)==100|(k|0)==68){h=10;break}}if((c[119688+(e*48|0)>>2]|0)==1){lM(b)|0}k=119652+(e*48|0)|0;if((c[k>>2]|0)==0){break}Sc(c[f>>2]|0)|0;AY(c[k>>2]|0)}}while(0);do{if((h|0)==10){Sc(g|0)|0;b=119652+(e*48|0)|0;k=c[b>>2]|0;if((k|0)==0){break}xd(k|0)|0;AY(c[b>>2]|0)}}while(0);c[f>>2]=0}c[119684+(e*48|0)>>2]=0;c[119652+(e*48|0)>>2]=0;i=d;return 0}function kM(){var a=0,b=0;a=i;if((c[29654]|0)!=0){i=a;return}c[29654]=1;c[118624>>2]=0;b=0;do{c[118620>>2]=b;jM(118616)|0;b=b+1|0;}while((b|0)<100);i=a;return}function lM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+4>>2]|0;if((c[119664+(d*48|0)>>2]|0)!=0){e=0;i=b;return e|0}f=119648+(d*48|0)|0;g=c[f>>2]|0;h=vb(g|0)|0;Qc(g|0,0,2)|0;if((h|0)>=(vb(g|0)|0)){e=0;i=b;return e|0}if((c[119668+(d*48|0)>>2]|0)==0){e=0;i=b;return e|0}if((c[119676+(d*48|0)>>2]&2|0)!=0){jd(c[f>>2]|0)|0}d=Oc(ob(c[f>>2]|0)|0,h|0)|0;Qc(c[f>>2]|0,0,2)|0;if((d|0)==0){e=0;i=b;return e|0}if((c[a>>2]|0)==0){nM(111,118632);e=111;i=b;return e|0}else{c[(Ic()|0)>>2]=111;e=111;i=b;return e|0}return 0}function mM(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+80|0;d=b;do{if((Ya(ob(a|0)|0,d|0)|0)<0){e=0}else{f=c[d+12>>2]&61440;if((f|0)==24576){e=1;break}else if((f|0)==8192){e=(rb(ob(a|0)|0)|0)==0|0;break}else if((f|0)==32768|(f|0)==16384){e=(c[d+16>>2]|0)!=0|0;break}else{e=0;break}}}while(0);i=b;return e|0}function nM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;d=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;do{if(a>>>0<100){Lc(b|0);l=c[r>>2]|0}else{if((a+1|0)>>>0>132){m=c[r>>2]|0;c[k>>2]=b;c[k+4>>2]=a;ld(m|0,119544,k|0)|0;l=m;break}m=c[r>>2]|0;if((a|0)==-1){c[j>>2]=b;ld(m|0,119576,j|0)|0;l=m;break}else{n=c[119416+(a+ -100<<2)>>2]|0;c[h>>2]=b;c[h+4>>2]=n;ld(m|0,119600,h|0)|0;l=m;break}}}while(0);h=c[29902]|0;do{if((h|0)==0){mc(124480,29,1,l|0)|0}else{c[g>>2]=(h-119648|0)/48|0;ld(l|0,119616,g|0)|0;b=c[(c[29902]|0)+4>>2]|0;if((b|0)==0){mc(124464,10,1,l|0)|0;break}else{c[f>>2]=b;ld(l|0,124448,f|0)|0;break}}}while(0);f=c[31128]|0;if((f|0)!=0){c[d>>2]=f;ld(l|0,124520,d|0)|0}d=(c[31148]|0)!=0?124600:124616;f=(c[31156]|0)!=0?124632:124648;g=(c[31166]|0)!=0?124672:124688;c[e>>2]=(c[31142]|0)!=0?124576:124584;c[e+4>>2]=d;c[e+8>>2]=f;c[e+12>>2]=g;ld(l|0,124544,e|0)|0;eM(124704,1)}function oM(){var a=0,b=0;a=i;c[31178]=1;b=c[r>>2]|0;c[29912]=b;c[119668>>2]=mM(b)|0;c[119672>>2]=1;c[119688>>2]=1;b=c[s>>2]|0;c[119888>>2]=b;c[119908>>2]=mM(b)|0;c[119912>>2]=1;c[119928>>2]=0;b=c[t>>2]|0;c[119936>>2]=b;c[119956>>2]=mM(b)|0;c[119960>>2]=1;c[119976>>2]=1;i=a;return}function pM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+28|0;e=c[d>>2]|0;a:do{if((e&2|0)==0){f=a+4|0;g=c[f>>2]|0;do{if((g|0)!=0){if((c[a+16>>2]|0)==0){h=c[a+24>>2]|0}else{h=0}if((c[a+40>>2]|0)==3){j=a;k=sc(g|0,c[129960+(h<<2)>>2]|0,c[j>>2]|0)|0;c[j>>2]=k;c[31180]=k;if((k|0)==0){break}c[d>>2]=2;break a}k=a;j=vb(c[k>>2]|0)|0;l=sc(c[f>>2]|0,c[129960+((h|2)<<2)>>2]|0,c[k>>2]|0)|0;c[k>>2]=l;c[31180]=l;if((l|0)==0){c[k>>2]=0;break}else{c[d>>2]=3;Qc(c[k>>2]|0,j|0,0)|0;break a}}}while(0);c[(Ic()|0)>>2]=127;m=1;i=b;return m|0}else{if((e&1|0)==0){break}Qc(c[a>>2]|0,0,1)|0}}while(0);c[a+40>>2]=1;m=0;i=b;return m|0}function qM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((a|0)==0){nM(b,d)}d=c[31182]|0;if((d|0)!=0){pe[d&7]()|0}c[(Ic()|0)>>2]=b;i=e;return b|0}function rM(a){a=a|0;var b=0,d=0;b=i;c[31212]=0;c[31214]=0;c[31216]=0;d=((sM(a,0)|0)==0)<<31>>31;i=b;return d|0}function sM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b;while(1){b=a[f]|0;g=f+1|0;if(b<<24>>24==40){break}else if(b<<24>>24==32){f=g}else{h=0;j=8;break}}if((j|0)==8){i=e;return h|0}j=c[31216]|0;c[31216]=j+1;if((j|0)==1){c[31214]=d}if((xM(1,d,0,0)|0)<0){h=0;i=e;return h|0}d=yM(g)|0;if((d|0)==0){h=0;i=e;return h|0}else{k=d}while(1){if((a[k]|0)==32){k=k+1|0}else{h=k;break}}i=e;return h|0}



function Bn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26320]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+408>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+408>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(26328,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+408>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=50312;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[26320]=1;i=d;return}function Cn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26560]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+404>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+404>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(26568,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+404>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=49496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[26560]=1;i=d;return}function Dn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26824]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+400>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+400>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(26832,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+400>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=33008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[26824]=1;i=d;return}function En(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27088]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+396>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+396>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(27096,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+396>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=49496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[27088]=1;i=d;return}function Fn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27352]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+392>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+392>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(27360,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+392>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[27352]=1;i=d;return}function Gn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27592]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+388>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+388>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(27600,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+388>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=33008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[27592]=1;i=d;return}function Hn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27856]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+384>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+384>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(27864,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+384>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=51872;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[27856]=1;i=d;return}function In(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28088]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+380>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+380>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(28096,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+380>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=33520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[28088]=1;i=d;return}function Jn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28344]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+376>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+376>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(28352,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+376>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52168;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[28344]=1;i=d;return}function Kn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28616]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+372>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+372>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(28624,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+372>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[28616]=1;i=d;return}function Ln(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28896]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+368>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+368>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(28904,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+368>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=50312;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[28896]=1;i=d;return}function Mn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29136]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+364>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+364>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(29144,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+364>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=49496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[29136]=1;i=d;return}function Nn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29400]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+360>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+360>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(29408,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+360>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=33008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[29400]=1;i=d;return}function On(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29664]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+356>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+356>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(29672,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+356>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=49496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[29664]=1;i=d;return}function Pn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29928]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+352>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+352>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(29936,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+352>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[29928]=1;i=d;return}function Qn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30168]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+348>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+348>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(30176,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+348>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=33008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[30168]=1;i=d;return}function Rn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30432]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+344>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+344>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(30440,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+344>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=51872;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[30432]=1;i=d;return}function Sn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30664]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+340>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+340>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(30672,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+340>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=33520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[30664]=1;i=d;return}function Tn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30920]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+336>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+336>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(30928,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+336>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52168;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[30920]=1;i=d;return}function Un(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31192]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+332>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+332>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(31200,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+332>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[31192]=1;i=d;return}function Vn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31472]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+328>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+328>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(31480,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+328>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=50312;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[31472]=1;i=d;return}function Wn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31712]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+324>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+324>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(31720,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+324>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=49496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[31712]=1;i=d;return}function Xn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31976]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+320>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+320>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(31984,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+320>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=33008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[31976]=1;i=d;return}function Yn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32240]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+316>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+316>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(32248,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+316>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=49496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[32240]=1;i=d;return}function Zn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32504]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+312>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+312>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(32512,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+312>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[32504]=1;i=d;return}function _n(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32744]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+308>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+308>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(32752,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+308>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=33008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[32744]=1;i=d;return}function $n(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33032]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+304>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+304>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(33040,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+304>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=51872;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[33032]=1;i=d;return}function ao(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33264]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+300>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+300>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(33272,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+300>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=33520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[33264]=1;i=d;return}function bo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33544]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+296>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+296>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(33552,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+296>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52168;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[33544]=1;i=d;return}function co(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33816]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+292>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+292>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(33824,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+292>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[33816]=1;i=d;return}function eo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34096]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+288>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+288>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(34104,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+288>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=50312;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[34096]=1;i=d;return}function fo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34336]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+284>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+284>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(34344,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+284>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=51872;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[34336]=1;i=d;return}function go(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34568]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+280>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+280>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(34576,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+280>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=49496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[34568]=1;i=d;return}function ho(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34832]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+272>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+272>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(34840,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+272>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[34832]=1;i=d;return}function io(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35072]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+276>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+276>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(35080,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+276>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[35072]=1;i=d;return}function jo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35312]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+268>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+268>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(35320,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+268>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=49496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[35312]=1;i=d;return}function ko(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35576]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+264>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+264>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(35584,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+264>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52168;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[35576]=1;i=d;return}function lo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35848]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+260>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+260>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(35856,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+260>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[35848]=1;i=d;return}function mo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36128]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+256>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+256>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(36136,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+256>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=50312;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[36128]=1;i=d;return}function no(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36368]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+252>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+252>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(36376,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+252>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=51872;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[36368]=1;i=d;return}function oo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36600]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+248>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+248>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(36608,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+248>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52168;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[36600]=1;i=d;return}function po(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36872]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+244>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+244>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(36880,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+244>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[36872]=1;i=d;return}function qo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37128]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+240>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+240>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(37136,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+240>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[37128]=1;i=d;return}function ro(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37408]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+236>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+236>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(37416,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+236>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=53040;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[37408]=1;i=d;return}function so(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37672]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+232>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+232>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(37680,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+232>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=51872;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[37672]=1;i=d;return}function to(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37904]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+228>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+228>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(37912,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+228>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52168;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[37904]=1;i=d;return}function uo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38176]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+224>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+224>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(38184,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+224>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[38176]=1;i=d;return}function vo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38432]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+220>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+220>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(38440,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+220>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[38432]=1;i=d;return}function wo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38712]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+216>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+216>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(38720,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+216>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=53040;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[38712]=1;i=d;return}function xo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38976]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+212>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+212>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(38984,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+212>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=51872;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[38976]=1;i=d;return}function yo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39208]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+208>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+208>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(39216,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+208>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=49496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[39208]=1;i=d;return}function zo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39472]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+200>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+200>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(39480,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+200>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[39472]=1;i=d;return}function Ao(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39712]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+204>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+204>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(39720,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+204>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[39712]=1;i=d;return}function Bo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39952]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+196>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+196>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(39960,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+196>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=49496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[39952]=1;i=d;return}function Co(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40216]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+192>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+192>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(40224,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+192>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52168;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[40216]=1;i=d;return}function Do(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40488]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(40496,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[40488]=1;i=d;return}function Eo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40768]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(40776,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=50312;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[40768]=1;i=d;return}function Fo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41008]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(41016,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=51872;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[41008]=1;i=d;return}function Go(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41240]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(41248,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52168;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[41240]=1;i=d;return}function Ho(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41512]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(41520,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[41512]=1;i=d;return}function Io(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41768]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(41776,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[41768]=1;i=d;return}function Jo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42048]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(42056,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=53040;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[42048]=1;i=d;return}function Ko(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42312]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(42320,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=51872;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[42312]=1;i=d;return}function Lo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42544]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(42552,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52168;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[42544]=1;i=d;return}function Mo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42816]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(42824,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[42816]=1;i=d;return}function No(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43072]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(43080,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[43072]=1;i=d;return}function Oo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43352]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(43360,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=53040;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[43352]=1;i=d;return}function Po(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43616]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(43624,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=51872;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[43616]=1;i=d;return}function Qo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43848]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(43856,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=49496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[43848]=1;i=d;return}function Ro(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44112]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(44120,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[44112]=1;i=d;return}function So(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44352]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(44360,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[44352]=1;i=d;return}function To(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44592]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(44600,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=49496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[44592]=1;i=d;return}function Uo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44856]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(44864,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52168;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[44856]=1;i=d;return}function Vo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45128]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(45136,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[45128]=1;i=d;return}function Wo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45408]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(45416,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=50312;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[45408]=1;i=d;return}function Xo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45648]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(45656,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=51872;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[45648]=1;i=d;return}function Yo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45880]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+104>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+104>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(45888,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+104>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52168;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[45880]=1;i=d;return}function Zo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46152]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(46160,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[46152]=1;i=d;return}function _o(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46408]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(46416,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[46408]=1;i=d;return}function $o(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46688]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(46696,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=53040;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[46688]=1;i=d;return}function ap(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46952]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(46960,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=51872;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[46952]=1;i=d;return}function bp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47184]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(47192,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52168;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[47184]=1;i=d;return}function cp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47456]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(47464,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[47456]=1;i=d;return}function dp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47712]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(47720,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[47712]=1;i=d;return}function ep(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47992]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(48e3,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=53040;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[47992]=1;i=d;return}function fp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48256]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(48264,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=51872;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[48256]=1;i=d;return}function gp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48488]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(48496,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=49496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[48488]=1;i=d;return}function hp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48752]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(48760,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[48752]=1;i=d;return}function ip(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48992]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(49e3,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[48992]=1;i=d;return}function jp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49232]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(49240,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=49496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[49232]=1;i=d;return}function kp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49520]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(49528,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52168;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[49520]=1;i=d;return}function lp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49792]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+44>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+44>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(49800,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+44>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[49792]=1;i=d;return}function mp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50072]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(50080,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=50312;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[50072]=1;i=d;return}function np(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50336]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(50344,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=51872;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[50336]=1;i=d;return}function op(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50568]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(50576,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52168;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[50568]=1;i=d;return}function pp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50840]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(50848,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[50840]=1;i=d;return}function qp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51096]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(51104,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[51096]=1;i=d;return}function rp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51376]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(51384,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=53040;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[51376]=1;i=d;return}function sp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51640]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(51648,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=51872;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[51640]=1;i=d;return}function tp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51896]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(51904,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52168;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[51896]=1;i=d;return}function up(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52192]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(52200,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[52192]=1;i=d;return}function vp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52472]&1){i=d;return}g=b+4|0;b=Ex(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(52480,jv(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=52752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[52472]=1;i=d;return}function wp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52776]&1){i=d;return}g=b+4|0;b=Ex(+(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Cx(+(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0),9.0)|0)<<24>>24==0)){i=d;return}b=lv(52784,jv(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0,23448)|0)|0;g=c[27664]|0;h=e;j=53040;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];re[g&15](e,b,f);a[52776]=1;i=d;return}function xp(a){a=a|0;var b=0;b=i;qn(a);rn(a);sn(a);tn(a);un(a);vn(a);wn(a);xn(a);yn(a);zn(a);An(a);Bn(a);Cn(a);Dn(a);En(a);Fn(a);Gn(a);Hn(a);In(a);Jn(a);Kn(a);Ln(a);Mn(a);Nn(a);On(a);Pn(a);Qn(a);Rn(a);Sn(a);Tn(a);Un(a);Vn(a);Wn(a);Xn(a);Yn(a);Zn(a);_n(a);$n(a);ao(a);bo(a);co(a);eo(a);fo(a);go(a);ho(a);io(a);jo(a);ko(a);lo(a);mo(a);no(a);oo(a);po(a);qo(a);ro(a);so(a);to(a);uo(a);vo(a);wo(a);xo(a);yo(a);zo(a);Ao(a);Bo(a);Co(a);Do(a);Eo(a);Fo(a);Go(a);Ho(a);Io(a);Jo(a);Ko(a);Lo(a);Mo(a);No(a);Oo(a);Po(a);Qo(a);Ro(a);So(a);To(a);Uo(a);Vo(a);Wo(a);Xo(a);Yo(a);Zo(a);_o(a);$o(a);ap(a);bp(a);cp(a);dp(a);ep(a);fp(a);gp(a);hp(a);ip(a);jp(a);kp(a);lp(a);mp(a);np(a);op(a);pp(a);qp(a);rp(a);sp(a);tp(a);up(a);vp(a);wp(a);i=b;return 0}function yp(a){a=a|0;i=i;return 1}function zp(a){a=a|0;i=i;return 1}function Ap(a){a=a|0;i=i;return 1}function Bp(a){a=a|0;i=i;return 1}function Cp(a){a=a|0;i=i;return 1}function Dp(a){a=a|0;i=i;return 0}function Ep(a){a=a|0;i=i;return 0}function Fp(a){a=a|0;i=i;return 0}function Gp(a){a=a|0;i=i;return 0}function Hp(a){a=a|0;i=i;return 0}function Ip(a,b){a=a|0;b=b|0;i=i;return-1}function Jp(a,b){a=a|0;b=b|0;i=i;return-1}function Kp(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i;return-1}function Lp(){i=i;return 53064}function Mp(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=Np(a,0,0)|0;i=b;return c|0}function Np(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=Op(a,b,c,0)|0;i=d;return e|0}function Op(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+64|0;h=b;b=d;d=e;e=f;do{if((b|0)!=0){j=Yd[c[b>>2]&127](500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}else{j=zY(500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=29;c[f+4>>2]=47;c[f+8>>2]=258}}while(0);b=j;if((j|0)==0){k=b;l=k;i=g;return l|0}c[b+8>>2]=0;c[j+32>>2]=0;c[j+380>>2]=16;c[j+392>>2]=Yd[c[j+12>>2]&127](c[j+380>>2]<<4)|0;b=j+12|0;if((c[j+392>>2]|0)==0){Vd[c[b+8>>2]&511](j);k=0;l=k;i=g;return l|0}c[j+44>>2]=Yd[c[b>>2]&127](1024)|0;b=j;if((c[j+44>>2]|0)==0){Vd[c[b+20>>2]&511](c[j+392>>2]|0);Vd[c[j+20>>2]&511](j);k=0;l=k;i=g;return l|0}c[j+48>>2]=(c[b+44>>2]|0)+1024;do{if((e|0)!=0){c[j+356>>2]=e}else{c[j+356>>2]=Zq(j+12|0)|0;if((c[j+356>>2]|0)!=0){break}Vd[c[j+20>>2]&511](c[j+44>>2]|0);Vd[c[j+20>>2]&511](c[j+392>>2]|0);Vd[c[j+20>>2]&511](j);k=0;l=k;i=g;return l|0}}while(0);c[j+376>>2]=0;c[j+368>>2]=0;c[j+304>>2]=0;c[j+468>>2]=0;c[j+464>>2]=0;c[j+124>>2]=0;c[j+248>>2]=0;a[j+472|0]=33;a[j+236|0]=0;a[j+237|0]=0;c[j+396>>2]=0;c[j+400>>2]=0;a[j+404|0]=0;_q(j+416|0,j+12|0);_q(j+440|0,j+12|0);Qp(j,h);do{if((h|0)!=0){if((c[j+232>>2]|0)!=0){break}Tp(j);k=0;l=k;i=g;return l|0}}while(0);if((d|0)!=0){a[j+236|0]=1;c[j+228>>2]=sr()|0;a[j+472|0]=a[d]|0}else{c[j+228>>2]=jr()|0}k=j;l=k;i=g;return l|0}function Pp(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;a=c[d>>2]|0;a:do{if((c[d+4>>2]|0)!=0){e=a;while(1){if((e|0)==0){break a}f=c[e>>2]|0;c[e>>2]=c[d+4>>2];c[d+4>>2]=e;e=f}}else{c[d+4>>2]=a}}while(0);c[d>>2]=0;c[d+16>>2]=0;c[d+12>>2]=0;c[d+8>>2]=0;i=b;return}function Qp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=d;c[f+280>>2]=35;Bt(f+256|0);if((b|0)!=0){g=Rp(f+416|0,b)|0}else{g=0}c[f+232>>2]=g;c[f+360>>2]=0;kr(f+148|0,f+144|0,0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=0;c[f+64>>2]=0;c[f+68>>2]=0;c[f+72>>2]=0;c[f+76>>2]=0;c[f+80>>2]=0;c[f+84>>2]=0;c[f+88>>2]=0;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;c[f+104>>2]=0;c[f+108>>2]=0;c[f+112>>2]=0;c[f+116>>2]=f;c[f+120>>2]=0;c[f+128>>2]=0;c[f+132>>2]=0;c[f+136>>2]=0;c[f+140>>2]=0;c[f+24>>2]=c[f+8>>2];c[f+28>>2]=c[f+8>>2];c[f+36>>2]=0;c[f+40>>2]=0;c[f+344>>2]=0;c[f+348>>2]=0;c[f+316>>2]=0;c[f+320>>2]=0;c[f+324>>2]=0;c[f+328>>2]=0;c[f+332>>2]=0;c[f+336>>2]=0;c[f+340>>2]=0;a[f+352|0]=0;a[f+353|0]=0;g=f+408|0;c[g+0>>2]=0;c[g+4>>2]=0;c[f+284>>2]=0;c[f+288>>2]=0;c[f+292>>2]=0;c[f+296>>2]=0;c[f+300>>2]=0;a[f+308|0]=1;c[f+312>>2]=0;c[f+364>>2]=0;c[f+372>>2]=0;c[f+384>>2]=0;c[f+240>>2]=0;c[f+252>>2]=0;c[f+244>>2]=0;c[f+476>>2]=0;c[f+480>>2]=0;a[f+488|0]=0;a[f+489|0]=0;c[f+492>>2]=0;c[f+496>>2]=0;i=e;return}function Rp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+24|0;f=b;b=d;while(1){if((c[f+12>>2]|0)==(c[f+8>>2]|0)){if(!((gq(f)|0)<<24>>24!=0)){g=5;break}}d=a[b]|0;h=f+12|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j]=d;d=b;b=d+1|0;if((a[d]|0)==0){g=6;break}}if((g|0)==5){k=0;l=k;i=e;return l|0}else if((g|0)==6){b=c[f+16>>2]|0;c[f+16>>2]=c[f+12>>2];k=b;l=k;i=e;return l|0}return 0}function Sp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=b;a:while(1){if((a[b]|0)==0){h=45;break}do{if((a[g]|0)!=12){if((a[g]|0)==0){break}j=c[f+428>>2]|0;k=f+416|0;if((a[g]|0)!=61){if((j|0)==(c[k+8>>2]|0)){if(!((gq(f+416|0)|0)<<24>>24!=0)){h=44;break a}}l=a[g]|0;m=f+428|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;g=g+1|0;continue a}if((j-(c[k+16>>2]|0)|0)==0){o=d+152|0}else{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((gq(f+416|0)|0)<<24>>24!=0)){h=19;break a}}k=f+428|0;j=c[k>>2]|0;c[k>>2]=j+1;a[j]=0;o=jq(f,d+60|0,c[f+432>>2]|0,8)|0;if((o|0)==0){h=20;break a}if((c[o>>2]|0)==(c[f+432>>2]|0)){c[o>>2]=Rp(d+80|0,c[o>>2]|0)|0;if((c[o>>2]|0)==0){h=23;break a}}c[f+428>>2]=c[f+432>>2]}b=g+1|0;while(1){if((a[b]|0)!=12){p=(a[b]|0)!=0}else{p=0}q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if(!p){break}if(q){if(!((gq(f+416|0)|0)<<24>>24!=0)){h=32;break a}}j=a[b]|0;k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=j;b=b+1|0}if(q){if(!((gq(f+416|0)|0)<<24>>24!=0)){h=36;break a}}j=f+428|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;if((nq(f,o,0,c[f+432>>2]|0,f+372|0)|0)!=0){h=37;break a}c[f+428>>2]=c[f+432>>2];if((a[b]|0)!=0){b=b+1|0}g=b;continue a}}while(0);if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((gq(f+416|0)|0)<<24>>24!=0)){h=8;break}}l=f+428|0;j=c[l>>2]|0;c[l>>2]=j+1;a[j]=0;j=jq(f,d,c[f+432>>2]|0,0)|0;if((j|0)!=0){a[j+32|0]=1}if((a[g]|0)!=0){g=g+1|0}b=g;c[f+428>>2]=c[f+432>>2]}if((h|0)==8){r=0;s=r;i=e;return s|0}else if((h|0)==19){r=0;s=r;i=e;return s|0}else if((h|0)==20){r=0;s=r;i=e;return s|0}else if((h|0)==23){r=0;s=r;i=e;return s|0}else if((h|0)==32){r=0;s=r;i=e;return s|0}else if((h|0)==36){r=0;s=r;i=e;return s|0}else if((h|0)==37){r=0;s=r;i=e;return s|0}else if((h|0)==44){r=0;s=r;i=e;return s|0}else if((h|0)==45){r=1;s=r;i=e;return s|0}return 0}function Tp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=b;if((e|0)==0){i=d;return}b=c[e+364>>2]|0;while(1){if((b|0)==0){f=e;if((c[e+368>>2]|0)==0){break}b=c[f+368>>2]|0;c[e+368>>2]=0}g=b;b=c[b>>2]|0;Vd[c[e+20>>2]&511](c[g+36>>2]|0);Up(c[g+44>>2]|0,e);Vd[c[e+20>>2]&511](g)}b=c[f+300>>2]|0;while(1){if((b|0)==0){h=e;if((c[e+304>>2]|0)==0){break}b=c[h+304>>2]|0;c[e+304>>2]=0}f=b;b=c[b+8>>2]|0;Vd[c[e+20>>2]&511](f)}Up(c[h+376>>2]|0,e);Up(c[e+372>>2]|0,e);Vp(e+416|0);Vp(e+440|0);do{if((a[e+488|0]|0)==0){if((c[e+356>>2]|0)==0){break}Wp(c[e+356>>2]|0,((c[e+476>>2]|0)!=0^1)&1,e+12|0)}}while(0);Vd[c[e+20>>2]&511](c[e+392>>2]|0);Vd[c[e+20>>2]&511](c[e+464>>2]|0);Vd[c[e+20>>2]&511](c[e+8>>2]|0);Vd[c[e+20>>2]&511](c[e+44>>2]|0);Vd[c[e+20>>2]&511](c[e+396>>2]|0);Vd[c[e+20>>2]&511](c[e+240>>2]|0);if((c[e+252>>2]|0)!=0){Vd[c[e+252>>2]&511](c[e+244>>2]|0)}Vd[c[e+20>>2]&511](e);i=d;return}function Up(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+24|0;e=a;a=b;while(1){b=e;if((b|0)==0){break}e=c[b+4>>2]|0;Vd[c[a+20>>2]&511](c[b+16>>2]|0);Vd[c[a+20>>2]&511](b)}i=d;return}function Vp(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=a;a=c[d>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;Vd[c[(c[d+20>>2]|0)+8>>2]&511](a);a=e}a=c[d+4>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;Vd[c[(c[d+20>>2]|0)+8>>2]&511](a);a=e}i=b;return}function Wp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+40|0;f=e+24|0;g=a;a=b;b=d;hq(f,g+20|0);while(1){d=iq(f)|0;if((d|0)==0){break}if((c[d+16>>2]|0)==0){continue}Vd[c[b+8>>2]&511](c[d+20>>2]|0)}mq(g);mq(g+132|0);mq(g+20|0);mq(g+40|0);mq(g+60|0);Vp(g+80|0);Vp(g+104|0);if(!(a<<24>>24!=0)){h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;Vd[m&511](o);i=e;return}Vd[c[b+8>>2]&511](c[g+184>>2]|0);Vd[c[b+8>>2]&511](c[g+164>>2]|0);h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;Vd[m&511](o);i=e;return}function Xp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a;a=(c[e+4>>2]|0)==(c[e>>2]|0);f=b;c[e>>2]=f;if(!a){i=d;return}c[e+4>>2]=f;i=d;return}function Yp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+24|0;f=a;c[f+52>>2]=b;c[f+56>>2]=d;i=e;return}function Zp(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=d;d=e;e=f;f=c[h+480>>2]|0;do{if((f|0)==0){if((c[h+476>>2]|0)!=0){break}if((_p(h)|0)<<24>>24!=0){break}c[h+284>>2]=1;j=0;k=j;i=g;return k|0}else if((f|0)==3){c[h+284>>2]=33;j=0;k=j;i=g;return k|0}else if((f|0)==2){c[h+284>>2]=36;j=0;k=j;i=g;return k|0}}while(0);c[h+480>>2]=1;if((d|0)!=0){f=aq(h,d)|0;if((f|0)==0){j=0;k=j;i=g;return k|0}else{dZ(f|0,b|0,d|0)|0;j=bq(h,d,e)|0;k=j;i=g;return k|0}}a[h+484|0]=e;if((e|0)==0){j=1;k=j;i=g;return k|0}c[h+296>>2]=c[h+24>>2];c[h+40>>2]=c[h+28>>2];c[h+284>>2]=ue[c[h+280>>2]&63](h,c[h+24>>2]|0,c[h+40>>2]|0,h+24|0)|0;e=h;if((c[h+284>>2]|0)!=0){c[h+292>>2]=c[e+288>>2];c[h+280>>2]=36;j=0;k=j;i=g;return k|0}d=c[e+480>>2]|0;if((d|0)==1|(d|0)==0){c[h+480>>2]=2}else if((d|0)==3){ve[c[(c[h+144>>2]|0)+52>>2]&31](c[h+144>>2]|0,c[h+296>>2]|0,c[h+24>>2]|0,h+408|0);c[h+296>>2]=c[h+24>>2];j=2;k=j;i=g;return k|0}j=1;k=j;i=g;return k|0}function _p(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=b;if((c[e+496>>2]|0)==0){c[e+496>>2]=Xq()|0}if((a[e+236|0]|0)!=0){f=Sp(e,55456)|0;g=f;i=d;return g|0}else{f=1;g=f;i=d;return g|0}return 0}function $p(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+32|0;i=e;return c[a+284>>2]|0}function aq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+72|0;e=a;a=b;b=c[e+480>>2]|0;if((b|0)==2){c[e+284>>2]=36;f=0;g=f;i=d;return g|0}else if((b|0)==3){c[e+284>>2]=33;f=0;g=f;i=d;return g|0}else{if((a|0)>((c[e+32>>2]|0)-(c[e+28>>2]|0)|0)){b=a+((c[e+28>>2]|0)-(c[e+24>>2]|0))|0;a=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;h=a;h=(h|0)>1024?1024:a;b=b+h|0;do{if((b|0)<=((c[e+32>>2]|0)-(c[e+8>>2]|0)|0)){if((h|0)>=((c[e+24>>2]|0)-(c[e+8>>2]|0)|0)){break}a=(c[e+24>>2]|0)-(c[e+8>>2]|0)-h|0;eZ(c[e+8>>2]|0,(c[e+8>>2]|0)+a|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+h|0)|0;j=e+28|0;c[j>>2]=(c[j>>2]|0)+(0-a);j=e+24|0;c[j>>2]=(c[j>>2]|0)+(0-a)}else{a=(c[e+32>>2]|0)-(c[e+24>>2]|0)|0;j=a;j=(j|0)==0?1024:a;do{j=j<<1;}while((j|0)<(b|0));a=Yd[c[e+12>>2]&127](j)|0;if((a|0)==0){c[e+284>>2]=1;f=0;g=f;i=d;return g|0}c[e+32>>2]=a+j;if((c[e+24>>2]|0)!=0){k=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;l=k;l=(l|0)>1024?1024:k;dZ(a|0,(c[e+24>>2]|0)+(0-l)|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+l|0)|0;Vd[c[e+20>>2]&511](c[e+8>>2]|0);c[e+8>>2]=a;c[e+28>>2]=(c[e+8>>2]|0)+((c[e+28>>2]|0)-(c[e+24>>2]|0))+l;c[e+24>>2]=(c[e+8>>2]|0)+l;break}else{c[e+28>>2]=a+((c[e+28>>2]|0)-(c[e+24>>2]|0));l=a;c[e+8>>2]=l;c[e+24>>2]=l;break}}}while(0);c[e+292>>2]=0;c[e+288>>2]=0;c[e+296>>2]=0}f=c[e+28>>2]|0;g=f;i=d;return g|0}return 0}function bq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=b;b=d;d=e;e=1;h=c[g+480>>2]|0;do{if((h|0)==2){c[g+284>>2]=36;j=0;k=j;i=f;return k|0}else if((h|0)==3){c[g+284>>2]=33;j=0;k=j;i=f;return k|0}else if((h|0)==0){if((c[g+476>>2]|0)!=0){break}if((_p(g)|0)<<24>>24!=0){break}c[g+284>>2]=1;j=0;k=j;i=f;return k|0}}while(0);c[g+480>>2]=1;h=c[g+24>>2]|0;c[g+296>>2]=h;l=g+28|0;c[l>>2]=(c[l>>2]|0)+b;c[g+40>>2]=c[g+28>>2];l=g+36|0;c[l>>2]=(c[l>>2]|0)+b;a[g+484|0]=d;c[g+284>>2]=ue[c[g+280>>2]&63](g,h,c[g+40>>2]|0,g+24|0)|0;h=g;if((c[g+284>>2]|0)!=0){c[g+292>>2]=c[h+288>>2];c[g+280>>2]=36;j=0;k=j;i=f;return k|0}b=c[h+480>>2]|0;do{if((b|0)==1|(b|0)==0){if((d|0)==0){break}c[g+480>>2]=2;j=e;k=j;i=f;return k|0}else if((b|0)==3){e=2}}while(0);ve[c[(c[g+144>>2]|0)+52>>2]&31](c[g+144>>2]|0,c[g+296>>2]|0,c[g+24>>2]|0,g+408|0);c[g+296>>2]=c[g+24>>2];j=e;k=j;i=f;return k|0}function cq(a){a=a|0;var b=0;b=i;i=i+8|0;i=b;return c[a+284>>2]|0}function dq(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;do{if((c[d+288>>2]|0)!=0){if(!((c[d+288>>2]|0)>>>0>=(c[d+296>>2]|0)>>>0)){break}ve[c[(c[d+144>>2]|0)+52>>2]&31](c[d+144>>2]|0,c[d+296>>2]|0,c[d+288>>2]|0,d+408|0);c[d+296>>2]=c[d+288>>2]}}while(0);i=b;return(c[d+408>>2]|0)+1|0}function eq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+16|0;j=g+48|0;k=b;b=d;c[h>>2]=e;e=f;if((a[b+72|0]|0)!=0){re[c[k+80>>2]&15](c[k+4>>2]|0,c[h>>2]|0,e-(c[h>>2]|0)|0);i=g;return}f=k;if((b|0)==(c[k+144>>2]|0)){l=f+288|0;m=k+292|0}else{l=c[f+300>>2]|0;m=(c[k+300>>2]|0)+4|0}do{c[j>>2]=c[k+44>>2];Sd[c[b+60>>2]&31](b,h,e,j,c[k+48>>2]|0);c[m>>2]=c[h>>2];re[c[k+80>>2]&15](c[k+4>>2]|0,c[k+44>>2]|0,(c[j>>2]|0)-(c[k+44>>2]|0)|0);c[l>>2]=c[h>>2];}while((c[h>>2]|0)!=(e|0));i=g;return}function fq(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;if(d>>>0>0&d>>>0<41){e=c[53680+(d<<2)>>2]|0;f=e;i=b;return f|0}else{e=0;f=e;i=b;return f|0}return 0}function gq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;do{if((c[d+4>>2]|0)!=0){a=d;if((c[d+16>>2]|0)==0){c[d>>2]=c[a+4>>2];c[d+4>>2]=c[c[d+4>>2]>>2];c[c[d>>2]>>2]=0;c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);c[d+12>>2]=c[d+16>>2];e=1;f=e;i=b;return f|0}if(((c[a+8>>2]|0)-(c[d+16>>2]|0)|0)>=(c[(c[d+4>>2]|0)+4>>2]|0)){break}a=c[c[d+4>>2]>>2]|0;c[c[d+4>>2]>>2]=c[d>>2];c[d>>2]=c[d+4>>2];c[d+4>>2]=a;dZ((c[d>>2]|0)+8|0,c[d+16>>2]|0,(c[d+8>>2]|0)-(c[d+16>>2]|0)|0)|0;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);e=1;f=e;i=b;return f|0}}while(0);do{if((c[d>>2]|0)!=0){if((c[d+16>>2]|0)!=((c[d>>2]|0)+8|0)){g=11;break}a=(c[d+8>>2]|0)-(c[d+16>>2]|0)<<1;h=le[c[(c[d+20>>2]|0)+4>>2]&63](c[d>>2]|0,8+a|0)|0;if((h|0)!=0){c[d>>2]=h;c[(c[d>>2]|0)+4>>2]=a;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+a;break}e=0;f=e;i=b;return f|0}else{g=11}}while(0);if((g|0)==11){g=(c[d+8>>2]|0)-(c[d+16>>2]|0)|0;if((g|0)<1024){g=1024}else{g=g<<1}a=Yd[c[c[d+20>>2]>>2]&127](8+g|0)|0;if((a|0)==0){e=0;f=e;i=b;return f|0}c[a+4>>2]=g;c[a>>2]=c[d>>2];c[d>>2]=a;if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){dZ(a+8|0,c[d+16>>2]|0,(c[d+12>>2]|0)-(c[d+16>>2]|0)|0)|0}c[d+12>>2]=a+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=a+8;c[d+8>>2]=a+8+g}e=1;f=e;i=b;return f|0}function hq(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;a=b;c[e>>2]=c[a>>2];c[e+4>>2]=(c[e>>2]|0)+(c[a+8>>2]<<2);i=d;return}function iq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+24|0;d=a;while(1){if((c[d>>2]|0)==(c[d+4>>2]|0)){e=5;break}a=d;f=c[a>>2]|0;c[a>>2]=f+4;g=c[f>>2]|0;if((g|0)!=0){e=4;break}}if((e|0)==4){h=g;j=h;i=b;return j|0}else if((e|0)==5){h=0;j=h;i=b;return j|0}return 0}function jq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+136|0;j=b;b=e;e=f;f=g;a:do{if((c[b+8>>2]|0)==0){if((f|0)==0){k=0;l=k;i=h;return l|0}a[b+4|0]=6;c[b+8>>2]=64;g=c[b+8>>2]<<2;c[b>>2]=Yd[c[c[b+16>>2]>>2]&127](g)|0;m=b;if((c[b>>2]|0)!=0){fZ(c[m>>2]|0,0,g|0)|0;g=kq(j,e)|0;n=g&(c[b+8>>2]|0)-1;break}c[m+8>>2]=0;k=0;l=k;i=h;return l|0}else{m=kq(j,e)|0;g=(c[b+8>>2]|0)-1|0;o=0;n=m&g;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break}if((lq(e,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0)<<24>>24!=0){p=10;break}if(!(o<<24>>24!=0)){o=((m&~g)>>>((d[b+4|0]|0)-1|0)&g>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+((c[b+8>>2]|0)-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}if((p|0)==10){k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}if((f|0)==0){k=0;l=k;i=h;return l|0}if(((c[b+12>>2]|0)>>>((d[b+4|0]|0)-1|0)|0)==0){break}g=(d[b+4|0]|0)+1&255;q=1<<(g&255);r=q-1|0;s=q<<2;t=Yd[c[c[b+16>>2]>>2]&127](s)|0;if((t|0)==0){k=0;l=k;i=h;return l|0}fZ(t|0,0,s|0)|0;n=0;while(1){if(!(n>>>0<(c[b+8>>2]|0)>>>0)){break}if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){s=kq(j,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0;u=s&r;o=0;while(1){if((c[t+(u<<2)>>2]|0)==0){break}if(!(o<<24>>24!=0)){o=((s&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(u>>>0<(o&255)>>>0){u=u+(q-(o&255))|0;continue}else{u=u-(o&255)|0;continue}}c[t+(u<<2)>>2]=c[(c[b>>2]|0)+(n<<2)>>2]}n=n+1|0}Vd[c[(c[b+16>>2]|0)+8>>2]&511](c[b>>2]|0);c[b>>2]=t;a[b+4|0]=g;c[b+8>>2]=q;n=m&r;o=0;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break a}if(!(o<<24>>24!=0)){o=((m&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+(q-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}}}while(0);j=Yd[c[c[b+16>>2]>>2]&127](f)|0;c[(c[b>>2]|0)+(n<<2)>>2]=j;if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){fZ(c[(c[b>>2]|0)+(n<<2)>>2]|0,0,f|0)|0;c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]=e;e=b+12|0;c[e>>2]=(c[e>>2]|0)+1;k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}else{k=0;l=k;i=h;return l|0}return 0}function kq(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+24|0;g=e;e=c[b+496>>2]|0;while(1){h=e;if((a[g]|0)==0){break}b=g;g=b+1|0;e=h*1000003^d[b]}i=f;return h|0}function lq(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;while(1){if((a[e]|0)!=(a[b]|0)){f=6;break}if((a[e]|0)==0){f=4;break}e=e+1|0;b=b+1|0}if((f|0)==4){g=1;h=g;i=d;return h|0}else if((f|0)==6){g=0;h=g;i=d;return h|0}return 0}



function Nx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){j=c[e+(h<<6)+16>>2]|0;k=c[e+(h<<6)+12>>2]|0;l=j<<3;c[e+(h<<6)+28>>2]=zY(l)|0;c[e+(h<<6)+36>>2]=zY(l)|0;m=c[g>>2]|0;if((m|0)==1){c[e+(h<<6)+32>>2]=zY(fa(l,j)|0)|0;c[e+(h<<6)+8>>2]=1;Sx(j,e+(h<<6)+24|0)|0}else if((m|0)==2){c[e+(h<<6)+8>>2]=2;Ux(j,j,k,e+(h<<6)+24|0)|0}else{n=6;break}k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{n=8;break}}if((n|0)==6){Pu(c[a+536>>2]|0,95968,d)}else if((n|0)==8){i=b;return 0}return 0}function Ox(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=(fa(c[f+16>>2]|0,b)|0)+a|0;h[(c[f+32>>2]|0)+(e<<3)>>3]=d;i=i;return}function Px(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=i;sb(0,a|0,b|0,+d,c[c[f+24>>2]>>2]|0)|0;i=e;return}function Qx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){AY(c[e+(h<<6)+28>>2]|0);AY(c[e+(h<<6)+36>>2]|0);j=c[g>>2]|0;if((j|0)==1){Tx(e+(h<<6)+24|0)|0;AY(c[e+(h<<6)+32>>2]|0)}else if((j|0)==2){Vx(e+(h<<6)+24|0)|0}else{k=6;break}AY(c[e+(h<<6)+24>>2]|0);j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{k=8;break}}if((k|0)==6){Pu(c[a+536>>2]|0,95968,d)}else if((k|0)==8){i=b;return 0}return 0}function Rx(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+476>>2]|0;o=b+196|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+20|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p<<6)+56|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[63988>>2]|c[15980]|0)==0){z=w;A=1;break}TL(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Nu(15,1,96e3,g);TL(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;TL(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;Nu(15,0,96032,f);TL(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}Vd[c[16120]&511](15);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function Sx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=zY(12)|0;f=zY(a<<2)|0;c[e>>2]=f;Ou(0,(f|0)!=0|0,96040,d);c[e+4>>2]=1;c[e+8>>2]=0;c[b>>2]=e;i=d;return 0}function Tx(a){a=a|0;var b=0;b=i;AY(c[c[a>>2]>>2]|0);i=b;return 0}function Ux(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=zY(32)|0;Ou(0,(g|0)!=0|0,96096,f);c[g+20>>2]=b;b=g+24|0;c[b>>2]=a;c[g+28>>2]=d;d=g+8|0;Md(0,d|0)|0;Bd(c[d>>2]|0,c[b>>2]|0,0)|0;Md(0,g+4|0)|0;Bd(c[d>>2]|0,c[b>>2]|0,0)|0;b=g+12|0;_a(b|0)|0;Gb(96144,c[b>>2]|0)|0;c[e>>2]=g;i=f;return 0}function Vx(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Id(c[d+12>>2]|0)|0;Fb(c[d+8>>2]|0)|0;Fb(c[d+4>>2]|0)|0;i=b;return 0}function Wx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=c[a+468>>2]|0;h=a+200|0;if((c[h>>2]|0)<=0){i=b;return 0}j=a+536|0;k=a;l=a+300|0;m=0;a:while(1){n=g+(m*80|0)|0;o=c[n>>2]|0;Ou(c[j>>2]|0,(c[g+(m*80|0)+32>>2]|0)!=0|0,96312,f);p=g+(m*80|0)+28|0;do{if(!((c[p>>2]|0)==-1)){Ou(c[j>>2]|0,(c[g+(m*80|0)+20>>2]|0)!=0|0,96352,e);if((Yd[c[g+(m*80|0)+24>>2]&127](k)|0)==0){break}c[p>>2]=-1}}while(0);p=o<<3;c[g+(m*80|0)+44>>2]=zY(p)|0;c[g+(m*80|0)+52>>2]=zY(p)|0;c[g+(m*80|0)+48>>2]=zY(p)|0;c[g+(m*80|0)+16>>2]=zY(p)|0;c[g+(m*80|0)+8>>2]=zY(p)|0;c[g+(m*80|0)+12>>2]=zY(p)|0;Wd[c[g+(m*80|0)+36>>2]&63](k,n);do{if((c[g+(m*80|0)+56>>2]|0)==1){$x(o,g+(m*80|0)+40|0)|0}else{p=c[l>>2]|0;if((p|0)==3){$x(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==2){Lx(a,n)|0;break}else if((p|0)==1){Zx(o,g+(m*80|0)+40|0)|0;break}else{q=12;break a}}}while(0);o=m+1|0;if((o|0)<(c[h>>2]|0)){m=o}else{q=14;break}}if((q|0)==12){Pu(c[j>>2]|0,96392,d)}else if((q|0)==14){i=b;return 0}return 0}function Xx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+468>>2]|0;f=a+200|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+300|0;h=0;a:while(1){j=e+(h*80|0)|0;AY(c[e+(h*80|0)+44>>2]|0);AY(c[e+(h*80|0)+52>>2]|0);AY(c[e+(h*80|0)+48>>2]|0);AY(c[e+(h*80|0)+16>>2]|0);AY(c[e+(h*80|0)+8>>2]|0);AY(c[e+(h*80|0)+12>>2]|0);do{if((c[e+(h*80|0)+56>>2]|0)==1){k=e+(h*80|0)+40|0;ay(k)|0;l=k}else{k=c[g>>2]|0;if((k|0)==1){m=e+(h*80|0)+40|0;_x(m)|0;l=m;break}else if((k|0)==3){m=e+(h*80|0)+40|0;ay(m)|0;l=m;break}else if((k|0)==2){n=7;break a}else{n=9;break a}}}while(0);AY(c[l>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{n=11;break}}if((n|0)==7){Mx(j)|0}else if((n|0)==9){Pu(c[a+536>>2]|0,96392,d)}else if((n|0)==11){i=b;return 0}return 0}function Yx(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=c[b+468>>2]|0;v=c[b+200>>2]|0;if((v|0)>0){w=0}else{x=0;i=e;return x|0}while(1){y=w+1|0;if((a[u+(w*80|0)+72|0]|0)==0){break}if((y|0)<(v|0)){w=y}else{x=0;z=22;break}}if((z|0)==22){i=e;return x|0}v=u+(w*80|0)+4|0;w=c[v>>2]|0;u=n;c[u>>2]=1;c[n+4>>2]=w;if((d|0)==0){x=1;i=e;return x|0}d=b+56|0;TL(o,d,w);A=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[o+8>>2];o=m+4|0;h[k>>3]=A;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Mu(17,1,u,96424,m);do{if((a[b+312|0]|0)==0){TL(s,d,c[v>>2]|0);m=s+12|0;if((c[m>>2]|0)<=0){break}u=t+16|0;o=0;while(1){w=o+1|0;TL(t,d,c[v>>2]|0);n=c[(c[(c[u>>2]|0)+(o<<2)>>2]|0)+4>>2]|0;c[f>>2]=w;c[f+4>>2]=n;Nu(17,0,96624,f);TL(s,d,c[v>>2]|0);if((w|0)<(c[m>>2]|0)){o=w}else{break}}}else{Nu(17,1,96464,l);TL(p,d,c[v>>2]|0);o=p+12|0;if((c[o>>2]|0)>0){m=b+116|0;u=r+16|0;w=b+8|0;n=q+16|0;y=0;while(1){a:do{if((c[m>>2]|0)>0){B=y+1|0;C=0;while(1){D=c[(c[w>>2]|0)+(C*112|0)+4>>2]|0;TL(q,d,c[v>>2]|0);if((ZY(D,c[(c[(c[n>>2]|0)+(y<<2)>>2]|0)+4>>2]|0)|0)==0){break}D=C+1|0;if((D|0)<(c[m>>2]|0)){C=D}else{z=15;break a}}D=c[w>>2]|0;E=c[D+(C*112|0)+4>>2]|0;A=+h[D+(C*112|0)+96>>3];F=+h[D+(C*112|0)+80>>3];c[j>>2]=B;c[j+4>>2]=E;E=j+8|0;h[k>>3]=A;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=j+16|0;h[k>>3]=F;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Nu(17,0,96544,j);G=y+1|0}else{z=15}}while(0);if((z|0)==15){z=0;E=y+1|0;TL(r,d,c[v>>2]|0);D=c[(c[(c[u>>2]|0)+(y<<2)>>2]|0)+4>>2]|0;c[g>>2]=E;c[g+4>>2]=D;Nu(17,0,96584,g);G=E}TL(p,d,c[v>>2]|0);if((G|0)<(c[o>>2]|0)){y=G}else{break}}}if((c[63996>>2]|c[15980]|0)==0){break}Vd[c[16120]&511](17)}}while(0);if((c[63996>>2]|c[15980]|0)==0){x=1;i=e;return x|0}Vd[c[16120]&511](17);x=1;i=e;return x|0}function Zx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=i;i=i+8|0;f=zY(144)|0;c[b>>2]=f;Ou(0,(f|0)!=0|0,96640,e);c[f>>2]=0;e=a<<3;g=zY(e)|0;c[f+4>>2]=g;g=zY(e)|0;c[f+16>>2]=g;c[f+8>>2]=1;g=zY(e)|0;c[f+12>>2]=g;c[f+20>>2]=a;g=zY(e)|0;c[f+24>>2]=g;g=BY(a,8)|0;c[f+28>>2]=g;h[f+32>>3]=1.0e-12;c[f+40>>2]=a*1e4;g=a+ -1|0;c[f+44>>2]=g;c[f+48>>2]=g;h[f+56>>3]=1.0e-12;g=zY(e)|0;c[f+64>>2]=g;g=zY(e)|0;c[f+68>>2]=g;c[f+72>>2]=1;h[f+80>>3]=100.0;c[f+88>>2]=-1;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;g=fa(a,a)|0;j=BY(g,8)|0;c[f+104>>2]=j;j=BY(g,8)|0;c[f+108>>2]=j;c[f+112>>2]=a;j=(fa(a+1|0,a)|0)/2|0;a=zY(j<<3)|0;c[f+116>>2]=a;c[f+120>>2]=j;j=zY(e)|0;c[f+124>>2]=j;j=zY(e)|0;c[f+128>>2]=j;j=zY(e)|0;c[f+132>>2]=j;j=zY(e)|0;c[f+136>>2]=j;j=zY(e)|0;c[f+140>>2]=j;Ou(0,(c[b>>2]|0)!=0|0,96672,d);i=d;return 0}function _x(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;AY(c[d+4>>2]|0);AY(c[d+16>>2]|0);AY(c[d+12>>2]|0);AY(c[d+24>>2]|0);AY(c[d+28>>2]|0);AY(c[d+64>>2]|0);AY(c[d+68>>2]|0);AY(c[d+104>>2]|0);AY(c[d+108>>2]|0);AY(c[d+116>>2]|0);AY(c[d+124>>2]|0);AY(c[d+128>>2]|0);AY(c[d+132>>2]|0);AY(c[d+136>>2]|0);AY(c[d+140>>2]|0);i=b;return 0}function $x(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=i;i=i+8|0;f=zY(80)|0;c[b>>2]=f;Ou(0,(f|0)!=0|0,96712,e);c[f>>2]=0;e=a<<3;g=zY(e)|0;c[f+4>>2]=g;g=zY(e)|0;c[f+8>>2]=g;c[f+12>>2]=a;g=zY(e)|0;c[f+16>>2]=g;g=BY(a,8)|0;c[f+20>>2]=g;h[f+24>>3]=1.0e-8;h[f+32>>3]=1.0e-8;c[f+44>>2]=a*100;h[f+56>>3]=2.220446049250313e-16;g=zY(fa(e,a)|0)|0;c[f+64>>2]=g;g=zY(e)|0;c[f+68>>2]=g;g=zY(a<<2)|0;c[f+72>>2]=g;Ou(0,(c[b>>2]|0)!=0|0,96744,d);i=d;return 0}function ay(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;AY(c[d+4>>2]|0);AY(c[d+8>>2]|0);AY(c[d+16>>2]|0);AY(c[d+20>>2]|0);AY(c[d+64>>2]|0);AY(c[d+68>>2]|0);AY(c[d+72>>2]|0);i=b;return 0}function by(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[b+24>>2]|0;if((e|0)==3){f=Jw(a,b)|0;i=d;return f|0}else if((e|0)==2){cy(a,b);f=0;i=d;return f|0}else if((e|0)==4){he[c[(c[a+540>>2]|0)+56>>2]&1](a,+h[b+8>>3])|0;h[b>>3]=+h[c[c[a+4>>2]>>2]>>3];f=0;i=d;return f|0}else if((e|0)==1){e=c[a+4>>2]|0;g=c[e+4>>2]|0;dy(c[e>>2]|0,+h[g>>3],c[g+8>>2]|0,c[a+112>>2]|0,b);f=0;i=d;return f|0}else{f=1;i=d;return f|0}return 0}function cy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0;d=i;e=c[c[b+48>>2]>>2]|0;f=c[a+4>>2]|0;g=c[f>>2]|0;j=c[f+4>>2]|0;f=g+8|0;k=c[f>>2]|0;l=a+112|0;m=c[l>>2]|0;n=j+8|0;o=c[n>>2]|0;p=j;j=b+8|0;q=b;h[q>>3]=+h[p>>3]+ +h[j>>3];if((m|0)>0){b=c[e>>2]|0;r=0;do{h[b+(r<<3)>>3]=+h[o+(r+m<<3)>>3];r=r+1|0;}while((r|0)<(m|0))}r=g;g=a+540|0;o=m;b=1;do{if((o|0)>0){s=c[n>>2]|0;t=+h[96784+(b<<3)>>3];u=c[e+(b+ -1<<2)>>2]|0;v=c[f>>2]|0;w=0;while(1){h[v+(w<<3)>>3]=+h[s+(w<<3)>>3]+ +h[j>>3]*t*+h[u+(w<<3)>>3];x=w+1|0;if((x|0)<(o|0)){w=x}else{y=t;break}}}else{y=+h[96784+(b<<3)>>3]}h[r>>3]=+h[p>>3]+y*+h[j>>3];Yd[c[(c[g>>2]|0)+28>>2]&127](a)|0;o=c[l>>2]|0;z=(o|0)>0;if(z){w=c[e+(b<<2)>>2]|0;u=0;do{h[w+(u<<3)>>3]=+h[k+(u+m<<3)>>3];u=u+1|0;}while((u|0)<(o|0))}b=b+1|0;}while((b|0)<4);if(!z){A=+h[q>>3];h[r>>3]=A;i=d;return}z=c[n>>2]|0;n=c[f>>2]|0;f=c[e>>2]|0;b=c[e+4>>2]|0;m=c[e+8>>2]|0;k=c[e+12>>2]|0;e=0;do{h[n+(e<<3)>>3]=+h[z+(e<<3)>>3]+(+h[f+(e<<3)>>3]*.16666666666666666+0.0+ +h[b+(e<<3)>>3]*.3333333333333333+ +h[m+(e<<3)>>3]*.3333333333333333+ +h[k+(e<<3)>>3]*.16666666666666666)*+h[j>>3];e=e+1|0;}while((e|0)<(o|0));A=+h[q>>3];h[r>>3]=A;i=d;return}function dy(a,b,d,e,f){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0;g=i;j=f+8|0;k=+h[j>>3];l=k+b;m=f;h[m>>3]=l;if((e|0)<=0){n=l;o=a;p=o;h[p>>3]=n;i=g;return}f=c[a+8>>2]|0;l=k;q=0;while(1){h[f+(q<<3)>>3]=+h[d+(q<<3)>>3]+ +h[d+(q+e<<3)>>3]*l;r=q+1|0;if((r|0)>=(e|0)){break}l=+h[j>>3];q=r}n=+h[m>>3];o=a;p=o;h[p>>3]=n;i=g;return}function ey(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+8|0;f=e;h[d>>3]=+h[b+240>>3];h[d+8>>3]=+h[b+264>>3];h[d+16>>3]=0.0;a[d+28|0]=0;c[d+32>>2]=Su(4)|0;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;g=c[d+24>>2]|0;a:do{if((g|0)==2){j=zY(8)|0;c[j+4>>2]=4;k=zY(20)|0;c[j>>2]=k;l=c[b+112>>2]|0;m=k;k=0;while(1){c[m+(k<<2)>>2]=BY(l,8)|0;if((k|0)>=4){break}m=c[j>>2]|0;k=k+1|0}c[d+48>>2]=j;n=0}else if((g|0)==4){k=c[234]|0;m=zY(k<<2)|0;c[24210]=m;if((k|0)<=0){n=0;break}l=c[b+116>>2]|0;o=m;m=0;while(1){c[o+(m<<2)>>2]=BY(l,8)|0;p=m+1|0;if((p|0)>=(k|0)){n=0;break a}o=c[24210]|0;m=p}}else if((g|0)==3){m=zY(88)|0;Lu(23,0,96816,f);o=Hw(b,d,m)|0;c[d+48>>2]=m;n=o}else{n=0}}while(0);ry(b)|0;if((c[2]|0)==0){i=e;return n|0}Tv(6);Qv(1);i=e;return n|0}function fy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+24>>2]|0;if((e|0)==3){Iw(c[b+48>>2]|0)|0}else if((e|0)==2){f=b+48|0;b=c[f>>2]|0;g=c[b>>2]|0;if((c[b+4>>2]|0)>-1){b=g;h=0;while(1){AY(c[b+(h<<2)>>2]|0);j=c[f>>2]|0;k=c[j>>2]|0;if((h|0)<(c[j+4>>2]|0)){h=h+1|0;b=k}else{l=k;break}}}else{l=g}AY(l);AY(c[f>>2]|0)}else if((e|0)==4){e=c[234]|0;f=c[24210]|0;if((e|0)>0){l=f;g=0;while(1){AY(c[l+(g<<2)>>2]|0);b=g+1|0;h=c[24210]|0;if((b|0)<(e|0)){g=b;l=h}else{m=h;break}}}else{m=f}AY(m)}sy(a)|0;my(a);i=d;return 0}function gy(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+168|0;c[o>>2]=0;p=i;i=i+160|0;q=b+536|0;r=c[q>>2]|0;u=0;pa(265,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){t=oZ(c[s>>2]|0,o)|0;if((t|0)==0){bb(s|0,v|0)}J=v}else{t=-1}do{if((t|0)==1){w=0;x=0;y=0;z=0;A=J}else{u=0;sa(97,b|0)|0;s=u;u=0;if((s|0)!=0&(v|0)!=0){B=oZ(c[s>>2]|0,o)|0;if((B|0)==0){bb(s|0,v|0)}J=v}else{B=-1}if((B|0)==1){w=0;x=0;y=0;z=0;A=J;break}s=b+540|0;u=0;sa(c[(c[s>>2]|0)+40>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){D=oZ(c[C>>2]|0,o)|0;if((D|0)==0){bb(C|0,v|0)}J=v}else{D=-1}if((D|0)==1){w=0;x=0;y=0;z=0;A=J;break}if((a[b+440|0]|0)!=0){u=0;sa(c[(c[s>>2]|0)+44>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){E=oZ(c[C>>2]|0,o)|0;if((E|0)==0){bb(C|0,v|0)}J=v}else{E=-1}if((E|0)==1){w=0;x=0;y=0;z=0;A=J;break}}C=b+240|0;h[c[c[b+4>>2]>>2]>>3]=+h[C>>3];u=0;pa(c[(c[s>>2]|0)+4>>2]|0,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){F=oZ(c[s>>2]|0,o)|0;if((F|0)==0){bb(s|0,v|0)}J=v}else{F=-1}if((F|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;pa(266,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){G=oZ(c[s>>2]|0,o)|0;if((G|0)==0){bb(s|0,v|0)}J=v}else{G=-1}if((G|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;oa(1,+(+h[b+272>>3]));s=u;u=0;if((s|0)!=0&(v|0)!=0){H=oZ(c[s>>2]|0,o)|0;if((H|0)==0){bb(s|0,v|0)}J=v}else{H=-1}if((H|0)==1){w=0;x=0;y=0;z=C;A=J;break}c[(c[q>>2]|0)+84>>2]=1;s=p;I=r+80|0;K=c[I>>2]|0;c[I>>2]=p;aZ(p,1,o|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=oZ(c[L>>2]|0,o)|0;if((M|0)==0){bb(L|0,v|0)}J=v}else{M=-1}if((M|0)==1){w=K;x=I;y=s;z=C;A=J;break}w=K;x=I;y=s;z=C;A=0}}while(0);a:while(1){do{if((A|0)==0){u=0;M=Ja(1,b|0,d|0,e|0,f|0,+g,j|0)|0;p=u;u=0;if((p|0)!=0&(v|0)!=0){N=oZ(c[p>>2]|0,o)|0;if((N|0)==0){bb(p|0,v|0)}J=v}else{N=-1}if((N|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}if((M|0)==0){S=0;T=1;break}u=0;Ra(13,1,0,96848,n|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){U=oZ(c[M>>2]|0,o)|0;if((U|0)==0){bb(M|0,v|0)}J=v}else{U=-1}if((U|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}h[b+248>>3]=+h[z>>3];S=-1;T=1}else{S=0;T=0}}while(0);c[x>>2]=w;u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){V=oZ(c[M>>2]|0,o)|0;if((V|0)==0){bb(M|0,v|0)}J=v}else{V=-1}if((V|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if(T){W=S}else{u=0;Ra(14,2,0,96944,m|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){X=oZ(c[M>>2]|0,o)|0;if((X|0)==0){bb(M|0,v|0)}J=v}else{X=-1}if((X|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}W=-1}u=0;qa(c[103064>>2]|0,103040,b|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Y=oZ(c[M>>2]|0,o)|0;if((Y|0)==0){bb(M|0,v|0)}J=v}else{Y=-1}if((Y|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}u=0;Ra(14,23,0,97e3,l|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Z=oZ(c[M>>2]|0,o)|0;if((Z|0)==0){bb(M|0,v|0)}J=v}else{Z=-1}if((Z|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if((c[2]|0)==0){_=26;break}u=0;pa(267,1);M=u;u=0;if((M|0)!=0&(v|0)!=0){$=oZ(c[M>>2]|0,o)|0;if(($|0)==0){bb(M|0,v|0)}J=v}else{$=-1}if(($|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R}else{break}}if((_|0)==26){i=k;return W|0}i=k;return W|0}function hy(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=+h[d>>3];do{if(H>=+h[b+248>>3]){if((c[d+24>>2]|0)==5){break}I=G;h[k>>3]=H;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];Lu(8,0,97096,G);I=b+313|0;a[I]=1;ix(b);if((c[118324>>2]|0)==0){Wd[c[103060>>2]&63](103040,b)}a[I]=0}}while(0);if((e|0)!=0){iy(od(e|0)|0,b)}if((c[64028>>2]|0)==0){i=f;return 0}Tv(0);Lu(25,0,97144,F);Lu(25,1,97168,E);H=+Lv(6);J=+Lv(6);K=J/+Lv(0)*100.0;E=D;h[k>>3]=H;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=K;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Lu(25,0,97176,D);K=+Lv(1);H=+Lv(1);J=H/+Lv(0)*100.0;D=C;h[k>>3]=K;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=J;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];Lu(25,0,97216,C);J=+Lv(2);K=+Lv(2);H=K/+Lv(0)*100.0;C=B;h[k>>3]=J;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+8|0;h[k>>3]=H;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Lu(25,0,97248,B);H=+Lv(3);J=+Lv(3);K=J/+Lv(0)*100.0;B=A;h[k>>3]=H;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=K;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];Lu(25,0,97272,A);K=+Lv(4);H=+Lv(4);J=H/+Lv(0)*100.0;A=z;h[k>>3]=K;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=J;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Lu(25,0,97312,z);J=+Lv(7);K=+Lv(7);H=K/+Lv(0)*100.0;z=y;h[k>>3]=J;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Lu(25,0,97344,y);y=d+24|0;z=(c[y>>2]|0)==5;H=+Lv(0);J=H- +Lv(7);H=J- +Lv(4);J=H- +Lv(3);H=J- +Lv(2);J=H- +Lv(1);H=J- +Lv(6);J=+Lv(0);K=J- +Lv(7);J=K- +Lv(4);K=J- +Lv(3);J=K- +Lv(2);K=J- +Lv(1);J=K- +Lv(6);K=J/+Lv(0)*100.0;if(z){z=w;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=w+8|0;h[k>>3]=K;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Lu(25,0,97408,w)}else{w=x;h[k>>3]=H;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=x+8|0;h[k>>3]=K;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Lu(25,0,97376,x)}K=+Lv(0);H=+Lv(0);J=H/+Lv(0)*100.0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=v+8|0;h[k>>3]=J;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Lu(25,0,97440,v);Vd[c[16120]&511](25);Lu(25,1,97464,u);c[t>>2]=c[d+40>>2];Lu(25,0,97472,t);c[s>>2]=c[d+44>>2];Lu(25,0,97496,s);Vd[c[16120]&511](25);s=c[y>>2]|0;if((s|0)==3){y=d+48|0;d=c[y>>2]|0;t=c[d+8>>2]|0;u=c[d+4>>2]|0;c[u>>2]=(c[u>>2]|0)+(c[t>>2]|0);d=u+4|0;c[d>>2]=(c[d>>2]|0)+(c[t+4>>2]|0);d=u+8|0;c[d>>2]=(c[d>>2]|0)+(c[t+8>>2]|0);d=u+12|0;c[d>>2]=(c[d>>2]|0)+(c[t+12>>2]|0);d=u+16|0;c[d>>2]=(c[d>>2]|0)+(c[t+16>>2]|0);Lu(25,1,97520,r);c[q>>2]=c[c[(c[y>>2]|0)+4>>2]>>2];Lu(25,0,97536,q);c[p>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+4>>2];Lu(25,0,97552,p);c[o>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+8>>2];Lu(25,0,97584,o);c[n>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+12>>2];Lu(25,0,97616,n);c[m>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+16>>2];Lu(25,0,97640,m);Vd[c[16120]&511](25)}else if((s|0)!=5){Lu(25,1,97672,l);Lu(25,0,97680,j);Vd[c[16120]&511](25)}Lu(25,0,97744,g);Qv(0);i=f;return 0}function iy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+16|0;y=i;i=i+8|0;z=Sb(b|0,98216)|0;b=c[t>>2]|0;A=d+4|0;B=y;h[k>>3]=+h[c[c[A>>2]>>2]>>3];c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];ld(b|0,98224,y|0)|0;if((z|0)==0){C=Gd(10,b|0)|0;D=jd(b|0)|0;i=e;return}y=d+116|0;B=d+124|0;E=d+128|0;F=d+132|0;G=d+216|0;H=d+220|0;I=d+224|0;J=d+228|0;K=d+136|0;L=d+140|0;M=d+144|0;N=d+148|0;O=d+36|0;P=d+428|0;Q=d+32|0;R=d+424|0;S=d+28|0;T=d+420|0;U=d+24|0;V=d+416|0;W=d+52|0;X=d+48|0;Y=d+44|0;Z=d+40|0;_=d+20|0;$=d+16|0;aa=d+12|0;ba=d+8|0;d=z;do{z=c[y>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((ZY(d,c[(c[ba>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];c[x>>2]=d;ea=x+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];ld(b|0,98240,x|0)|0;fa=c[y>>2]|0}else{fa=ca}ea=z+1|0;if((ea|0)<(fa|0)){ca=fa;z=ea}else{break}}}z=c[B>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((ZY(d,c[(c[aa>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(z<<2)>>2]|0;c[w>>2]=d;c[w+4>>2]=ea;ld(b|0,98256,w|0)|0;ga=c[B>>2]|0}else{ga=ca}ea=z+1|0;if((ea|0)<(ga|0)){ca=ga;z=ea}else{break}}}z=c[E>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((ZY(d,c[(c[$>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+z|0]|0;c[v>>2]=d;c[v+4>>2]=ea;ld(b|0,98264,v|0)|0;ha=c[E>>2]|0}else{ha=ca}ea=z+1|0;if((ea|0)<(ha|0)){ca=ha;z=ea}else{break}}}z=c[F>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((ZY(d,c[(c[_>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(z<<2)>>2]|0;c[u>>2]=d;c[u+4>>2]=ea;ld(b|0,98272,u|0)|0;ia=c[F>>2]|0}else{ia=ca}ea=z+1|0;if((ea|0)<(ia|0)){ca=ia;z=ea}else{break}}}if((c[G>>2]|0)>0){z=0;do{ca=c[Z>>2]|0;do{if((ZY(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(c[ca+(z*52|0)+4>>2]<<3)>>3];if((c[ca+(z*52|0)>>2]|0)==0){c[r>>2]=d;ea=r+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];ld(b|0,98240,r|0)|0;break}else{c[s>>2]=d;ea=s+4|0;h[k>>3]=-da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];ld(b|0,98240,s|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[G>>2]|0))}if((c[H>>2]|0)>0){z=0;do{ca=c[Y>>2]|0;do{if((ZY(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(c[ca+(z*52|0)+4>>2]<<2)>>2]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[p>>2]=d;c[p+4>>2]=ea;ld(b|0,98256,p|0)|0;break}else{c[q>>2]=d;c[q+4>>2]=0-ea;ld(b|0,98256,q|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[H>>2]|0))}if((c[I>>2]|0)>0){z=0;do{ca=c[X>>2]|0;do{if((ZY(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+(c[ca+(z*52|0)+4>>2]|0)|0]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[n>>2]=d;c[n+4>>2]=ea;ld(b|0,98264,n|0)|0;break}else{c[o>>2]=d;c[o+4>>2]=0-ea;ld(b|0,98264,o|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[I>>2]|0))}z=c[J>>2]|0;if((z|0)>0){ca=z;z=0;while(1){ea=c[W>>2]|0;if((ZY(d,c[ea+(z*52|0)+16>>2]|0)|0)==0){ja=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(c[ea+(z*52|0)+4>>2]<<2)>>2]|0;c[m>>2]=d;c[m+4>>2]=ja;ld(b|0,98272,m|0)|0;ka=c[J>>2]|0}else{ka=ca}ja=z+1|0;if((ja|0)<(ka|0)){ca=ka;z=ja}else{break}}}z=c[K>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((ZY(d,c[(c[U>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[V>>2]|0)+(z<<3)>>3];c[l>>2]=d;ja=l+4|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ld(b|0,98240,l|0)|0;la=c[K>>2]|0}else{la=ca}ja=z+1|0;if((ja|0)<(la|0)){ca=la;z=ja}else{break}}}z=c[L>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((ZY(d,c[(c[S>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ja=c[(c[T>>2]|0)+(z<<2)>>2]|0;c[j>>2]=d;c[j+4>>2]=ja;ld(b|0,98256,j|0)|0;ma=c[L>>2]|0}else{ma=ca}ja=z+1|0;if((ja|0)<(ma|0)){ca=ma;z=ja}else{break}}}z=c[M>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((ZY(d,c[(c[Q>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ja=a[(c[R>>2]|0)+z|0]|0;c[g>>2]=d;c[g+4>>2]=ja;ld(b|0,98264,g|0)|0;na=c[M>>2]|0}else{na=ca}ja=z+1|0;if((ja|0)<(na|0)){ca=na;z=ja}else{break}}}z=c[N>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((ZY(d,c[(c[O>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ja=c[(c[P>>2]|0)+(z<<2)>>2]|0;c[f>>2]=d;c[f+4>>2]=ja;ld(b|0,98272,f|0)|0;oa=c[N>>2]|0}else{oa=ca}ja=z+1|0;if((ja|0)<(oa|0)){ca=oa;z=ja}else{break}}}d=Sb(0,98216)|0;}while((d|0)!=0);C=Gd(10,b|0)|0;D=jd(b|0)|0;i=e;return}function jy(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;m=i;i=i+16|0;n=m;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+56|0;t=s;u=s+24|0;c[u>>2]=j;a:do{switch(j|0){case 11:case 10:case 9:case 6:case 7:case 8:{Nu(1,0,97768,r);v=1;i=m;return v|0};case 18:{w=c[232]|0;do{if((w|0)!=0){if((ZY(w,98024)|0)!=0){break}c[u>>2]=4;break a}}while(0);Lu(23,0,98048,o);v=1;i=m;return v|0};case 5:{Nu(1,0,97840,q);v=1;i=m;return v|0};case 17:case 16:case 15:case 14:case 13:case 12:{c[u>>2]=3;break};case 4:{w=c[232]|0;if((w|0)!=0){if((ZY(w,97880)|0)==0){break a}}Lu(23,0,97896,p);v=1;i=m;return v|0};default:{}}}while(0);p=ey(a,s)|0;pe[c[64716>>2]&7]()|0;do{if((p|0)==0){q=gy(a,b,d,e,f,g)|0;pe[c[64716>>2]&7]()|0;if((q|0)!=0){x=q;break}if((c[u>>2]|0)!=5){Wd[c[103060>>2]&63](103040,a);sx(a)}y=+h[a+248>>3];q=n;h[k>>3]=+h[a+240>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];q=n+8|0;h[k>>3]=y;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];Lu(23,0,98176,n);q=le[c[c[a+540>>2]>>2]&63](a,t)|0;pe[c[64716>>2]&7]()|0;hy(a,s,l)|0;pe[c[64716>>2]&7]()|0;x=q}else{pe[c[64716>>2]&7]()|0;x=p}}while(0);fy(a,s)|0;v=x;i=m;return v|0}function ky(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=a+204|0;if((c[e>>2]|0)<=0){ly(a);i=b;return}f=a+488|0;g=a;h=0;while(1){j=h+1|0;if((Yd[c[(c[f>>2]|0)+(h*48|0)+40>>2]&127](g)|0)!=0){k=5;break}if((j|0)<(c[e>>2]|0)){h=j}else{k=6;break}}if((k|0)==5){Pu(c[a+536>>2]|0,98288,d)}else if((k|0)==6){ly(a);i=b;return}}function ly(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;f=a+12|0;g=a+4|0;a=0;do{h=c[e>>2]|0;j=(c[c[h+(a*48|0)+12>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0;k=c[(c[c[g>>2]>>2]|0)+12>>2]|0;l=h+(a*48|0)|0;m=h+(a*48|0)+4|0;fZ(k+(j<<2)|0,0,fa(c[l>>2]<<2,c[m>>2]|0)|0)|0;n=h+(a*48|0)+8|0;if((c[n>>2]|0)>0){o=c[h+(a*48|0)+16>>2]|0;p=0;do{c[o+(p<<2)>>2]=p;p=p+1|0;}while((p|0)<(c[n>>2]|0))}n=c[l>>2]|0;if((n|0)>0){p=c[h+(a*48|0)+20>>2]|0;o=n;n=0;do{c[p+(n<<2)>>2]=o+~n;n=n+1|0;o=c[l>>2]|0;}while((n|0)<(o|0))}o=c[m>>2]|0;if((o|0)>0){n=o;o=0;do{c[k+(o+j+(fa(n,o)|0)<<2)>>2]=1;o=o+1|0;n=c[m>>2]|0;}while((o|0)<(n|0))}a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function my(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;a=0;do{f=c[e>>2]|0;AY(c[f+(a*48|0)+28>>2]|0);AY(c[f+(a*48|0)+32>>2]|0);AY(c[f+(a*48|0)+16>>2]|0);AY(c[f+(a*48|0)+20>>2]|0);AY(c[f+(a*48|0)+24>>2]|0);a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function ny(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+4096|0;p=b+204|0;if((c[p>>2]|0)<=0){q=0;i=f;return q|0}r=b+488|0;s=d<<24>>24==0;d=(e|0)==0;t=0;u=0;while(1){v=c[r>>2]|0;w=v+(u*48|0)|0;x=zY(c[w>>2]<<2)|0;y=v+(u*48|0)+8|0;z=zY(c[y>>2]<<2)|0;oy(b,u);A=v+(u*48|0)+20|0;B=c[A>>2]|0;C=c[w>>2]|0;dZ(x|0,B|0,C<<2|0)|0;D=v+(u*48|0)+16|0;E=c[D>>2]|0;F=c[y>>2]|0;dZ(z|0,E|0,F<<2|0)|0;G=v+(u*48|0)+24|0;if(!((Gw(c[G>>2]|0,F,C,E,B)|0)==0|s)){break}B=py(x,c[A>>2]|0,c[w>>2]|0,c[y>>2]|0,c[v+(u*48|0)+4>>2]|0,c[v+(u*48|0)+12>>2]|0,c[v+(u*48|0)+28>>2]|0,c[v+(u*48|0)+32>>2]|0,b,e)|0;if(d){dZ(c[A>>2]|0,x|0,c[w>>2]<<2|0)|0;dZ(c[D>>2]|0,z|0,c[y>>2]<<2|0)|0}y=(B|0)==0?t:1;AY(x);AY(z);z=u+1|0;if((z|0)<(c[p>>2]|0)){t=y;u=z}else{q=y;H=15;break}}if((H|0)==15){i=f;return q|0}q=o;o=v+(u*48|0)+44|0;f=c[o>>2]|0;H=b+464|0;t=c[H>>2]|0;p=c[t+(f*44|0)>>2]|0;c[n>>2]=c[t+(f*44|0)+4>>2];c[n+4>>2]=p;c[n+8>>2]=f;Nu(5,1,98344,n);n=c[H>>2]|0;if((c[n+((c[o>>2]|0)*44|0)+4>>2]|0)!=0){f=n;n=0;do{a[q]=0;p=c[f+((c[o>>2]|0)*44|0)>>2]|0;if((p|0)!=0){t=p;p=0;do{d=(fa(t,n)|0)+p|0;I=+h[(c[G>>2]|0)+(d<<3)>>3];c[m>>2]=q;d=m+4|0;h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];dc(q|0,98376,m|0)|0;p=p+1|0;t=c[(c[H>>2]|0)+((c[o>>2]|0)*44|0)>>2]|0;}while(p>>>0<t>>>0)}c[l>>2]=q;Nu(5,0,98384,l);n=n+1|0;f=c[H>>2]|0;}while(n>>>0<(c[f+((c[o>>2]|0)*44|0)+4>>2]|0)>>>0)}if((c[w>>2]|0)<=0){J=64480;K=c[16120]|0;Vd[K&511](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=4;_=Z;$=98392;aa=$;Pu(O,aa,g)}o=v+(u*48|0)+32|0;u=0;do{c[j>>2]=c[(c[(c[o>>2]|0)+(u<<2)>>2]|0)+4>>2];Nu(5,0,98384,j);u=u+1|0;}while((u|0)<(c[w>>2]|0));J=64480;K=c[16120]|0;Vd[K&511](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=4;_=Z;$=98392;aa=$;Pu(O,aa,g);return 0}function oy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+488|0;f=c[e>>2]|0;g=c[f+(b*48|0)+44>>2]|0;j=a+464|0;k=c[j>>2]|0;l=c[f+(b*48|0)+24>>2]|0;fZ(l|0,0,fa(c[k+(g*44|0)+4>>2]<<3,c[k+(g*44|0)>>2]|0)|0)|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=d;return}f=a;a=c[k+(g*44|0)>>2]|0;m=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[m+(g*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}Yd[c[(c[e>>2]|0)+(b*48|0)+36>>2]&127](f)|0;m=c[j>>2]|0;a=c[m+(g*44|0)>>2]|0;do{if((a|0)!=0){n=c[m+(g*44|0)+28>>2]|0;o=0;do{do{if(+h[n+(o<<3)>>3]==1.0){if((o|0)==0){p=m+(g*44|0)+8|0;q=0}else{r=m+(g*44|0)+8|0;p=r;q=c[(c[r>>2]|0)+(o+ -1<<2)>>2]|0}r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if(!(q>>>0<r>>>0)){break}s=c[m+(g*44|0)+12>>2]|0;t=c[m+(g*44|0)+4>>2]|0;u=c[m+(g*44|0)+36>>2]|0;v=q;do{w=c[s+(v<<2)>>2]|0;x=(fa(t,o)|0)+w|0;h[l+(x<<3)>>3]=+h[u+(w<<3)>>3];v=v+1|0;}while(v>>>0<r>>>0)}}while(0);o=o+1|0;}while(o>>>0<a>>>0);if((a|0)==0){break}o=c[m+(g*44|0)+20>>2]|0;n=0;do{if(((c[o+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=0.0}n=n+1|0;}while(n>>>0<a>>>0)}}while(0);k=k+1|0;}while(k>>>0<(c[m+(g*44|0)+24>>2]|0)>>>0);i=d;return}function py(a,b,d,e,f,g,j,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;o=i;i=i+8|0;p=o;q=BY(d,4)|0;r=BY(d,4)|0;s=r;t=(d|0)>0;if(t){u=0}else{v=0;AY(q);AY(r);i=o;return v|0}do{w=(u|0)<(e|0)?1:2;c[r+(c[b+(u<<2)>>2]<<2)>>2]=w;c[q+(c[a+(u<<2)>>2]<<2)>>2]=w;u=u+1|0;}while((u|0)<(d|0));if(t){x=0}else{v=0;AY(q);AY(r);i=o;return v|0}while(1){t=x+1|0;if((c[r+(x<<2)>>2]|0)!=(c[q+(x<<2)>>2]|0)){break}if((t|0)<(d|0)){x=t}else{v=0;y=9;break}}if((y|0)==9){AY(q);AY(r);i=o;return v|0}if((n|0)==0){v=-1;AY(q);AY(r);i=o;return v|0}n=p;h[k>>3]=+h[c[c[m+4>>2]>>2]>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Lu(5,1,98496,p);qy(s,d,f,c[g>>2]|0,j,l,m);if((c[63948>>2]|0)==0){v=-1;AY(q);AY(r);i=o;return v|0}Vd[c[16120]&511](5);v=-1;AY(q);AY(r);i=o;return v|0}function qy(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+8|0;l=k;m=e-(c[c[j+12>>2]>>2]|0)|0;e=j+4|0;n=c[(c[c[e>>2]>>2]|0)+12>>2]|0;fZ(n+(m<<2)|0,0,fa(b<<2,d)|0)|0;if((b|0)<=0){i=k;return}o=j+8|0;j=0;p=0;while(1){if((c[a+(j<<2)>>2]|0)==2){q=c[c[o>>2]>>2]|0;r=c[g+(j<<2)>>2]|0;s=(c[r>>2]|0)-q|0;t=(c[c[f+(p<<2)>>2]>>2]|0)-q|0;c[l>>2]=c[r+4>>2];Lu(5,0,98528,l);c[n+(p+m+(fa(j,d)|0)<<2)>>2]=1;r=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[r+(t<<3)>>3]=+h[r+(s<<3)>>3];u=p+1|0}else{u=p}s=j+1|0;if((s|0)<(b|0)){j=s;p=u}else{break}}i=k;return}function ry(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=ec(98544,98568)|0;o=(n|0)!=0;a[b+440|0]=o&1;if(o){p=0}else{i=d;return 0}a:while(1){while(1){o=Yc(n|0)|0;if((o|0)==10){break}else if((o|0)==-1){break a}}p=p+1|0}o=p+ -1|0;p=b+456|0;c[p>>2]=o;c[b+452>>2]=o;mb(n|0);do{}while((Yc(n|0)|0)!=10);q=c[b+152>>2]|0;r=BY(o,4)|0;o=b+444|0;c[o>>2]=r;s=c[p>>2]|0;t=(s|0)>0;b:do{if(t){u=r;v=0;while(1){c[u+(v<<2)>>2]=BY(q,8)|0;w=v+1|0;if((w|0)>=(s|0)){break}u=c[o>>2]|0;v=w}v=BY(s,8)|0;u=b+448|0;c[u>>2]=v;if(!t){x=u;break}w=(q|0)>0;y=v;v=0;while(1){c[m>>2]=y+(v<<3);z=Zb(n|0,98576,m|0)|0;if(w){A=0;while(1){c[l>>2]=(c[(c[o>>2]|0)+(v<<2)>>2]|0)+(A<<3);B=Zb(n|0,98576,l|0)|0;C=A+1|0;if((C|0)<(q|0)){A=C}else{D=B;break}}}else{D=z}if((D|0)<0){c[p>>2]=v;E=v}else{E=c[p>>2]|0}A=v+1|0;if((A|0)>=(E|0)){x=u;break b}y=c[u>>2]|0;v=A}}else{v=b+448|0;c[v>>2]=BY(s,8)|0;x=v}}while(0);cc(98584,j|0)|0;cc(98640,g|0)|0;if((c[p>>2]|0)>0){g=(q|0)>0;j=0;do{s=f;h[k>>3]=+h[(c[x>>2]|0)+(j<<3)>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];cc(98600,f|0)|0;if(g){s=0;while(1){E=s+1|0;F=+h[(c[(c[o>>2]|0)+(j<<2)>>2]|0)+(s<<3)>>3];c[e>>2]=E;D=e+4|0;h[k>>3]=F;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];cc(98624,e|0)|0;if((E|0)<(q|0)){s=E}else{break}}}j=j+1|0;}while((j|0)<(c[p>>2]|0))}qb(98640)|0;Sc(n|0)|0;c[b+460>>2]=0;i=d;return 0}function sy(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((a[b+440|0]|0)==0){i=d;return 0}AY(c[b+448>>2]|0);e=b+452|0;f=b+444|0;b=c[f>>2]|0;if((c[e>>2]|0)>0){g=b;h=0;while(1){AY(c[g+(h<<2)>>2]|0);j=h+1|0;k=c[f>>2]|0;if((j|0)<(c[e>>2]|0)){h=j;g=k}else{l=k;break}}}else{l=b}AY(l);i=d;return 0}function ty(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;d=i;if((a[b+440|0]|0)==0){e=-1;i=d;return e|0}f=+h[c[c[b+4>>2]>>2]>>3];g=b+460|0;j=c[g>>2]|0;k=c[b+448>>2]|0;l=+h[k+(j<<3)>>3];if(f==l){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;p=0;while(1){h[o+(p<<3)>>3]=+h[n+(p<<3)>>3];q=p+1|0;if((q|0)<(m|0)){p=q}else{e=1;break}}i=d;return e|0}p=j+1|0;r=+h[k+(p<<3)>>3];if(f==r){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;q=0;while(1){s=q+1|0;h[o+(q<<3)>>3]=+h[n+(s<<3)>>3];if((s|0)<(m|0)){q=s}else{e=1;break}}i=d;return e|0}a:do{if(f>r){q=(c[b+456>>2]|0)+ -1|0;m=j;n=p;while(1){if((n|0)>=(q|0)){t=m;break a}c[g>>2]=n;o=n+1|0;if(f>+h[k+(o<<3)>>3]){s=n;n=o;m=s}else{t=n;break}}}else{t=j}}while(0);j=t+1|0;r=+h[k+(j<<3)>>3]- +h[k+(t<<3)>>3];k=c[b+152>>2]|0;if((k|0)<=0){e=0;i=d;return e|0}g=c[b+444>>2]|0;p=c[g+(t<<2)>>2]|0;t=c[g+(j<<2)>>2]|0;u=l+r;j=b+432|0;v=u-f;w=f-l;b=0;while(1){x=+h[p+(b<<3)>>3];y=+h[t+(b<<3)>>3];do{if(x!=y){if(x>0.0){z=1}else{z=(x<0.0)<<31>>31}if(y>0.0){A=1}else{A=(y<0.0)<<31>>31}if((z|0)==(A|0)){h[(c[j>>2]|0)+(b<<3)>>3]=(u*x+f*y-(f*x+l*y))/r;break}else{h[(c[j>>2]|0)+(b<<3)>>3]=(v*x+w*y)/r;break}}else{h[(c[j>>2]|0)+(b<<3)>>3]=x}}while(0);g=b+1|0;if((g|0)<(k|0)){b=g}else{e=0;break}}i=d;return e|0}function uy(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=+vy(a,1.0);if(!(f>1.0e-5)){g=0;i=b;return g|0}if((c[63964>>2]|0)==0){g=1;i=b;return g|0}j=e;h[k>>3]=f;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];Lu(9,1,98704,e);e=a+16|0;j=c[e>>2]|0;if((j|0)>0){l=a+48|0;a=j;j=0;while(1){f=+h[(c[l>>2]|0)+(j<<3)>>3];m=j+1|0;if(+U(+f)>1.0e-5){c[d>>2]=m;n=d+4|0;h[k>>3]=f;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Lu(9,0,98816,d);o=c[e>>2]|0}else{o=a}if((m|0)<(o|0)){a=o;j=m}else{break}}}Vd[c[16120]&511](9);g=1;i=b;return g|0}function vy(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0,K=0,L=0.0;e=i;f=c[b+60>>2]|0;Ky(b);g=f+540|0;Yd[c[(c[g>>2]|0)+84>>2]&127](f)|0;Yd[c[(c[g>>2]|0)+36>>2]&127](f)|0;Yd[c[(c[g>>2]|0)+32>>2]&127](f)|0;j=b+48|0;le[c[(c[g>>2]|0)+68>>2]&63](f,c[j>>2]|0)|0;g=f+8|0;k=c[f+184>>2]|0;if((k|0)>0){l=c[b+52>>2]|0;m=(l|0)==0;n=c[j>>2]|0;o=0.0;j=0;while(1){if(m){p=1.0}else{p=+h[l+(j<<3)>>3]}q=+h[n+(j<<3)>>3]/p;r=o+q*q;s=j+1|0;if((s|0)<(k|0)){o=r;j=s}else{t=r;break}}}else{t=0.0}if(!(d<1.0)){u=t;i=e;return+u}o=t*d;j=c[f+116>>2]|0;if((j|0)>0){k=c[g>>2]|0;n=b+56|0;t=1.0-d;l=f+4|0;p=o;m=0;s=0;while(1){if((a[k+(m*112|0)+88|0]|0)==0){v=p;w=s}else{x=c[n>>2]|0;if((x|0)==0){y=s;z=1.0}else{y=s+1|0;z=+h[x+(s<<3)>>3]}r=(+h[k+(m*112|0)+96>>3]- +h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+(m<<3)>>3])/z;v=p+r*t*r;w=y}x=m+1|0;if((x|0)<(j|0)){p=v;m=x;s=w}else{A=v;B=w;break}}}else{A=o;B=0}w=c[f+136>>2]|0;if((w|0)>0){s=c[f+24>>2]|0;m=b+56|0;o=1.0-d;y=f+416|0;v=A;l=0;k=B;while(1){do{if((a[s+(l*112|0)+88|0]|0)==0){C=v;D=k}else{if((a[s+(l*112|0)+72|0]|0)!=0){C=v;D=k;break}n=c[m>>2]|0;if((n|0)==0){E=k;F=1.0}else{E=k+1|0;F=+h[n+(k<<3)>>3]}p=(+h[s+(l*112|0)+96>>3]- +h[(c[y>>2]|0)+(l<<3)>>3])/F;C=v+p*o*p;D=E}}while(0);n=l+1|0;if((n|0)<(w|0)){v=C;l=n;k=D}else{G=C;H=D;break}}}else{G=A;H=B}B=c[f+120>>2]|0;D=j-B|0;if((D|0)>=(B|0)){u=G;i=e;return+u}j=c[g>>2]|0;g=b+56|0;A=1.0-d;b=f+416|0;d=G;f=D;D=H;while(1){do{if((a[j+(f*112|0)+88|0]|0)==0){I=d;J=D}else{if((a[j+(f*112|0)+72|0]|0)!=0){I=d;J=D;break}H=c[g>>2]|0;if((H|0)==0){K=D;L=1.0}else{K=D+1|0;L=+h[H+(D<<3)>>3]}G=(+h[j+(f*112|0)+96>>3]- +h[(c[b>>2]|0)+(f<<3)>>3])/L;I=d+G*A*G;J=K}}while(0);H=f+1|0;if((H|0)<(B|0)){d=I;f=H;D=J}else{u=I;break}}i=e;return+u}function wy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+16|0;e=d;f=i;i=i+24|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+16|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;u=+vy(b,1.0);if((c[63964>>2]|0)==0){i=d;return}v=b+16|0;w=c[v>>2]|0;if((w|0)>0){x=c[b+48>>2]|0;y=0.0;z=0;while(1){A=+h[x+(z<<3)>>3];B=y+A*A;C=z+1|0;if((C|0)<(w|0)){z=C;y=B}else{D=B;break}}}else{D=0.0}Lu(9,1,98840,t);t=b+52|0;if((c[t>>2]|0)==0){z=r;h[k>>3]=D;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Lu(9,0,98904,r)}else{r=s;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=s+8|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Lu(9,0,98864,s)}Lu(9,1,98928,q);q=b+4|0;s=c[q>>2]|0;if((s|0)>0){r=b+40|0;z=b+24|0;w=b+44|0;x=0;while(1){C=c[r>>2]|0;E=x+1|0;u=+h[(c[z>>2]|0)+(x<<3)>>3];F=c[(c[w>>2]|0)+(x<<2)>>2]|0;if((C|0)==0){c[o>>2]=E;G=o+4|0;h[k>>3]=u;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];c[o+12>>2]=F;Lu(9,0,99e3,o)}else{D=+h[C+(x<<3)>>3];c[p>>2]=E;C=p+4|0;h[k>>3]=u;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[p+12>>2]=F;F=p+16|0;h[k>>3]=D;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];Lu(9,0,98952,p)}F=c[q>>2]|0;if((E|0)<(F|0)){x=E}else{H=F;I=E;break}}}else{H=s;I=0}s=b+8|0;if((I|0)<((c[s>>2]|0)+H|0)){H=b+40|0;x=b+24|0;p=b+44|0;o=I;while(1){w=c[H>>2]|0;z=o+1|0;D=+h[(c[x>>2]|0)+(o<<3)>>3];r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if((w|0)==0){c[m>>2]=z;E=m+4|0;h[k>>3]=D;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];c[m+12>>2]=r;Lu(9,0,99088,m)}else{u=+h[w+(o<<3)>>3];c[n>>2]=z;w=n+4|0;h[k>>3]=D;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[n+12>>2]=r;r=n+16|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Lu(9,0,99024,n)}if((z|0)<((c[s>>2]|0)+(c[q>>2]|0)|0)){o=z}else{J=z;break}}}else{J=I}I=b;if((J|0)<(c[I>>2]|0)){o=b+40|0;q=b+24|0;s=b+44|0;n=J;while(1){J=c[o>>2]|0;m=n+1|0;u=+h[(c[q>>2]|0)+(n<<3)>>3];p=c[(c[s>>2]|0)+(n<<2)>>2]|0;if((J|0)==0){c[j>>2]=m;x=j+4|0;h[k>>3]=u;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];c[j+12>>2]=p;Lu(9,0,99176,j)}else{D=+h[J+(n<<3)>>3];c[l>>2]=m;J=l+4|0;h[k>>3]=u;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];c[l+12>>2]=p;p=l+16|0;h[k>>3]=D;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Lu(9,0,99120,l)}if((m|0)<(c[I>>2]|0)){n=m}else{break}}}Vd[c[16120]&511](9);Lu(9,1,99208,g);if((c[v>>2]|0)>0){g=b+48|0;b=a+540|0;a=0;while(1){n=(c[t>>2]|0)==0;I=a+1|0;D=+h[(c[g>>2]|0)+(a<<3)>>3];l=Yd[c[(c[b>>2]|0)+64>>2]&127](a)|0;if(n){c[e>>2]=I;n=e+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[e+12>>2]=l;Lu(9,0,99e3,e)}else{u=+h[(c[t>>2]|0)+(a<<3)>>3];c[f>>2]=I;n=f+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[f+12>>2]=l;l=f+16|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];Lu(9,0,98952,f)}if((I|0)<(c[v>>2]|0)){a=I}else{break}}}Vd[c[16120]&511](9);Vd[c[16120]&511](9);i=d;return}function xy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0;d=i;i=i+24|0;e=d;f=i;i=i+8|0;g=i;i=i+24|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+8|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+40|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b+8|0;if((c[63964>>2]|0)!=0){tx(b,9)}if((c[64024>>2]|0)==0){i=d;return}Lu(24,1,99232,t);t=b+112|0;v=c[t>>2]|0;do{if((v|0)>0){Lu(24,1,99272,s);if((c[t>>2]|0)>0){w=u;x=b+4|0;y=b+400|0;z=0;while(1){A=z+1|0;B=c[w>>2]|0;C=c[B+(z*112|0)+4>>2]|0;D=+h[B+(z*112|0)+96>>3];E=+h[B+(z*112|0)+80>>3];F=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];G=+h[(c[y>>2]|0)+(z<<3)>>3];c[r>>2]=A;c[r+4>>2]=C;C=r+8|0;h[k>>3]=D;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+16|0;h[k>>3]=E;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+24|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+32|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Lu(24,0,99296,r);if((A|0)<(c[t>>2]|0)){z=A}else{break}}}Vd[c[16120]&511](24);z=c[t>>2]|0;if((z|0)<=0){H=z;break}Lu(24,1,99352,q);z=c[t>>2]|0;if((z|0)<(z<<1|0)){y=u;x=b+4|0;w=b+400|0;A=z;while(1){z=A+1|0;C=c[(c[y>>2]|0)+(A*112|0)+4>>2]|0;G=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];F=+h[(c[w>>2]|0)+(A<<3)>>3];c[p>>2]=z;c[p+4>>2]=C;C=p+8|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=p+16|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Lu(24,0,99376,p);if((z|0)<(c[t>>2]<<1|0)){A=z}else{break}}}Vd[c[16120]&511](24);H=c[t>>2]|0}else{H=v}}while(0);v=b+116|0;if((H<<1|0)<(c[v>>2]|0)){Lu(24,1,99408,o);o=c[t>>2]<<1;if((o|0)<(c[v>>2]|0)){t=u;u=b+4|0;H=b+400|0;p=o;while(1){o=p+1|0;q=c[t>>2]|0;r=c[q+(p*112|0)+4>>2]|0;F=+h[q+(p*112|0)+96>>3];G=+h[q+(p*112|0)+80>>3];E=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+(p<<3)>>3];D=+h[(c[H>>2]|0)+(p<<3)>>3];c[n>>2]=o;c[n+4>>2]=r;r=n+8|0;h[k>>3]=F;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+16|0;h[k>>3]=G;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+24|0;h[k>>3]=E;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+32|0;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Lu(24,0,99296,n);if((o|0)<(c[v>>2]|0)){p=o}else{break}}}Vd[c[16120]&511](24)}p=b+124|0;if((c[p>>2]|0)>0){Lu(24,1,99432,m);if((c[p>>2]|0)>0){m=b+12|0;v=b+4|0;n=b+404|0;H=0;while(1){u=H+1|0;t=c[m>>2]|0;o=c[t+(H*60|0)+4>>2]|0;r=c[t+(H*60|0)+52>>2]|0;t=c[(c[(c[c[v>>2]>>2]|0)+12>>2]|0)+(H<<2)>>2]|0;q=c[(c[n>>2]|0)+(H<<2)>>2]|0;c[l>>2]=u;c[l+4>>2]=o;c[l+8>>2]=r;c[l+12>>2]=t;c[l+16>>2]=q;Lu(24,0,99456,l);if((u|0)<(c[p>>2]|0)){H=u}else{break}}}Vd[c[16120]&511](24)}H=b+128|0;if((c[H>>2]|0)>0){Lu(24,1,99504,j);if((c[H>>2]|0)>0){j=b+16|0;p=b+4|0;l=b+408|0;n=0;while(1){v=n+1|0;m=c[j>>2]|0;u=c[m+(n*48|0)+4>>2]|0;q=(a[m+(n*48|0)+42|0]|0)!=0?99576:99584;m=(a[(c[(c[c[p>>2]>>2]|0)+16>>2]|0)+n|0]|0)!=0?99576:99584;t=(a[(c[l>>2]|0)+n|0]|0)!=0?99576:99584;c[g>>2]=v;c[g+4>>2]=u;c[g+8>>2]=q;c[g+12>>2]=m;c[g+16>>2]=t;Lu(24,0,99528,g);if((v|0)<(c[H>>2]|0)){n=v}else{break}}}Vd[c[16120]&511](24)}n=b+132|0;if((c[n>>2]|0)>0){Lu(24,1,99592,f);if((c[n>>2]|0)>0){f=b+20|0;H=b+4|0;g=b+412|0;b=0;while(1){l=b+1|0;p=c[f>>2]|0;j=c[p+(b*52|0)+4>>2]|0;v=c[p+(b*52|0)+44>>2]|0;p=c[(c[(c[c[H>>2]>>2]|0)+20>>2]|0)+(b<<2)>>2]|0;t=c[(c[g>>2]|0)+(b<<2)>>2]|0;c[e>>2]=l;c[e+4>>2]=j;c[e+8>>2]=v;c[e+12>>2]=p;c[e+16>>2]=t;Lu(24,0,99616,e);if((l|0)<(c[n>>2]|0)){b=l}else{break}}}Vd[c[16120]&511](24)}Vd[c[16120]&511](24);i=d;return}function yy(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=b+540|0;B=(c[(c[A>>2]|0)+72>>2]|0)!=0?3:2;Lu(9,0,99664,z);if((f|0)==0){qx(b);rx(b);C=6}else{if((a[f]|0)!=0){zy(b,f,g)}qx(b);rx(b);if((a[f]|0)==0){C=6}}if((C|0)==6){Yd[c[(c[A>>2]|0)+84>>2]&127](b)|0;Yd[c[(c[A>>2]|0)+60>>2]&127](b)|0}do{if((d|0)==0){D=B}else{if((a[d]|0)==0){D=B;break}C=(ZY(d,101152)|0)==0|0;f=(ZY(d,101160)|0)==0;z=(ZY(d,101168)|0)==0;E=z?3:f?2:C;if((E|0)!=0){D=E;break}c[y>>2]=d;Nu(1,0,99712,y);Nu(1,0,99744,x);c[w>>2]=101152;c[w+4>>2]=100960;Nu(1,0,99768,w);c[v>>2]=101160;c[v+4>>2]=101040;Nu(1,0,99768,v);c[u>>2]=101168;c[u+4>>2]=101088;Nu(1,0,99768,u);Pu(c[b+536>>2]|0,99800,t)}}while(0);do{if((e|0)==0){F=3}else{if((a[e]|0)==0){F=3;break}else{G=1;H=0}do{t=(ZY(e,c[99824+(G<<2)>>2]|0)|0)==0;H=t?G:H;G=G+1|0;}while((G|0)<7);if((H|0)!=0){F=H;break}c[s>>2]=e;Nu(1,0,99856,s);Nu(1,0,99744,r);t=1;do{u=c[99888+(t<<2)>>2]|0;c[q>>2]=c[99824+(t<<2)>>2];c[q+4>>2]=u;Nu(1,0,99768,q);t=t+1|0;}while((t|0)<7);Pu(c[b+536>>2]|0,99800,p)}}while(0);p=c[99784+(D<<2)>>2]|0;c[o>>2]=c[99696+(D<<2)>>2];c[o+4>>2]=p;Lu(9,0,99920,o);o=(D|0)==2;if(o){p=c[99888+(F<<2)>>2]|0;c[n>>2]=c[99824+(F<<2)>>2];c[n+4>>2]=p;Lu(9,0,99960,n)}n=b+312|0;a[n]=1;p=b+200|0;if((c[p>>2]|0)>0){q=b+468|0;r=0;do{a[(c[q>>2]|0)+(r*80|0)+72|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+196|0;if((c[p>>2]|0)>0){r=b+476|0;q=0;do{a[(c[r>>2]|0)+(q<<6)+56|0]=1;q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+192|0;if((c[p>>2]|0)>0){q=b+484|0;r=0;do{a[(c[q>>2]|0)+(r*40|0)+36|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}do{if((D|0)==1){I=0}else{if(o){I=Ay(b,F,j)|0;break}if((D|0)==3){By(b,j);I=0;break}else{Pu(c[b+536>>2]|0,1e5,m)}}}while(0);if((Yx(b,1)|0)!=0){J=-2;xy(b);K=14;L=K;M=100024;N=M;Lu(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];$w(b,R,V);W=262;nx(b);X=268;sx(b);Y=263;ix(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=Yd[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=le[ha&63](b,1)|0;ja=271;ox(b);i=k;return J|0}if((Rx(b,1)|0)!=0){J=-3;xy(b);K=14;L=K;M=100024;N=M;Lu(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];$w(b,R,V);W=262;nx(b);X=268;sx(b);Y=263;ix(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=Yd[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=le[ha&63](b,1)|0;ja=271;ox(b);i=k;return J|0}m=(Ix(b,1)|0)==0;J=m?I:-4;xy(b);K=14;L=K;M=100024;N=M;Lu(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];$w(b,R,V);W=262;nx(b);X=268;sx(b);Y=263;ix(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=Yd[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=le[ha&63](b,1)|0;ja=271;ox(b);i=k;return J|0}function zy(b,d,e){b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+48|0;B=i;i=i+8|0;c[z>>2]=d;C=z+4|0;h[k>>3]=e;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Lu(9,0,101184,z);z=qv(d,A)|0;if((z|0)!=0){C=c[b+536>>2]|0;c[y>>2]=d;c[y+4>>2]=z;Pu(C,101224,y)}Lu(9,0,101264,x);x=b+116|0;if((c[x>>2]|0)>0){y=b+8|0;C=0;do{z=rv(A,c[(c[y>>2]|0)+(C*112|0)+4>>2]|0)|0;d=c[y>>2]|0;do{if((z|0)==0){D=Ey(c[d+(C*112|0)+4>>2]|0)|0;E=rv(A,D)|0;AY(D);D=c[y>>2]|0;if((E|0)!=0){F=D;G=E;H=7;break}E=c[D+(C*112|0)+4>>2]|0;if((_Y(E,101304,6)|0)==0){if((c[63964>>2]|0)==0){break}}else{D=_Y(E,101312,6)|0;if((c[63964>>2]|D|0)==0){break}}c[v>>2]=E;Nu(9,0,101320,v)}else{F=d;G=z;H=7}}while(0);if((H|0)==7){H=0;xv(F+(C*112|0)+96|0,A,G,e)|0;z=c[y>>2]|0;I=+h[z+(C*112|0)+96>>3];c[w>>2]=c[z+(C*112|0)+4>>2];z=w+4|0;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Lu(9,0,101288,w)}C=C+1|0;}while((C|0)<(c[x>>2]|0))}Lu(9,0,101376,u);u=b+136|0;if((c[u>>2]|0)>0){C=b+24|0;w=0;do{y=rv(A,c[(c[C>>2]|0)+(w*112|0)+4>>2]|0)|0;G=c[C>>2]|0;do{if((y|0)==0){F=Ey(c[G+(w*112|0)+4>>2]|0)|0;v=rv(A,F)|0;AY(F);F=c[C>>2]|0;if((v|0)!=0){J=F;K=v;H=17;break}c[s>>2]=c[F+(w*112|0)+4>>2];Nu(9,0,101400,s)}else{J=G;K=y;H=17}}while(0);if((H|0)==17){H=0;xv(J+(w*112|0)+96|0,A,K,e)|0;y=c[C>>2]|0;I=+h[y+(w*112|0)+96>>3];c[t>>2]=c[y+(w*112|0)+4>>2];y=t+4|0;h[k>>3]=I;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];Lu(9,0,101288,t)}w=w+1|0;}while((w|0)<(c[u>>2]|0))}Lu(9,0,101456,r);r=b+120|0;u=c[r>>2]|0;w=(c[x>>2]|0)-u|0;if((w|0)<(u|0)){u=b+24|0;x=w;do{w=rv(A,c[(c[u>>2]|0)+(x*112|0)+4>>2]|0)|0;t=c[u>>2]|0;do{if((w|0)==0){C=Ey(c[t+(x*112|0)+4>>2]|0)|0;K=rv(A,C)|0;AY(C);C=c[u>>2]|0;if((K|0)!=0){L=C;M=K;H=24;break}c[p>>2]=c[C+(x*112|0)+4>>2];Nu(9,0,101400,p)}else{L=t;M=w;H=24}}while(0);if((H|0)==24){H=0;xv(L+(x*112|0)+96|0,A,M,e)|0;w=c[u>>2]|0;I=+h[w+(x*112|0)+96>>3];c[q>>2]=c[w+(x*112|0)+4>>2];w=q+4|0;h[k>>3]=I;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Lu(9,0,101288,q)}x=x+1|0;}while((x|0)<(c[r>>2]|0))}Lu(9,0,101480,o);o=b+140|0;if((c[o>>2]|0)>0){r=b+28|0;x=0;do{q=rv(A,c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;do{if((q|0)==0){u=Ey(c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;M=rv(A,u)|0;AY(u);if((M|0)!=0){N=M;H=31;break}c[m>>2]=c[(c[r>>2]|0)+(x*60|0)+4>>2];Nu(9,0,101528,m)}else{N=q;H=31}}while(0);if((H|0)==31){H=0;xv(B,A,N,e)|0;q=~~+h[B>>3];M=c[r>>2]|0;c[M+(x*60|0)+52>>2]=q;c[n>>2]=c[M+(x*60|0)+4>>2];c[n+4>>2]=q;Lu(9,0,101512,n)}x=x+1|0;}while((x|0)<(c[o>>2]|0))}Lu(9,0,101584,l);l=b+144|0;if((c[l>>2]|0)<=0){ov(A);i=f;return}o=b+32|0;b=0;do{x=rv(A,c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;do{if((x|0)==0){n=Ey(c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;r=rv(A,n)|0;AY(n);if((r|0)!=0){O=r;H=38;break}c[g>>2]=c[(c[o>>2]|0)+(b*48|0)+4>>2];Nu(9,0,101632,g)}else{O=x;H=38}}while(0);if((H|0)==38){H=0;xv(B,A,O,e)|0;a[(c[o>>2]|0)+(b*48|0)+42|0]=~~+h[B>>3];x=c[o>>2]|0;r=(a[x+(b*48|0)+42|0]|0)!=0?99576:99584;c[j>>2]=c[x+(b*48|0)+4>>2];c[j+4>>2]=r;Lu(9,0,101616,j)}b=b+1|0;}while((b|0)<(c[l>>2]|0));ov(A);i=f;return}function Ay(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;Xw(a,+h[a+240>>3]);nx(a);sx(a);ix(a);ux(a);ly(a);jx(a);nx(a);e=Cy(a,b,c)|0;sx(a);ix(a);ox(a);sx(a);i=d;return e|0}function By(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+4096|0;Xw(b,+h[b+240>>3]);nx(b);sx(b);ny(b,0,1)|0;v=b+540|0;w=c[v>>2]|0;if((c[w+76>>2]|0)!=0&(d|0)>1){x=u;u=b+8|0;y=b+116|0;z=BY(c[y>>2]|0,8)|0;A=b+124|0;B=BY(c[A>>2]|0,4)|0;C=b+128|0;D=BY(c[C>>2]|0,1)|0;E=b+132|0;F=BY(c[E>>2]|0,4)|0;G=b+536|0;Ou(c[G>>2]|0,(z|0)!=0|0,100056,t);Ou(c[G>>2]|0,(B|0)!=0|0,100056,s);Ou(c[G>>2]|0,(D|0)!=0|0,100056,r);Ou(c[G>>2]|0,(F|0)!=0|0,100056,q);q=c[y>>2]|0;if((q|0)>0){G=c[u>>2]|0;r=0;do{h[z+(r<<3)>>3]=+h[G+(r*112|0)+96>>3];r=r+1|0;}while((r|0)<(q|0))}q=c[A>>2]|0;if((q|0)>0){r=c[b+12>>2]|0;G=0;do{c[B+(G<<2)>>2]=c[r+(G*60|0)+52>>2];G=G+1|0;}while((G|0)<(q|0))}q=c[C>>2]|0;if((q|0)>0){G=c[b+16>>2]|0;r=0;do{a[D+r|0]=a[G+(r*48|0)+42|0]|0;r=r+1|0;}while((r|0)<(q|0))}q=c[E>>2]|0;if((q|0)>0){r=c[b+20>>2]|0;G=0;do{c[F+(G<<2)>>2]=c[r+(G*52|0)+44>>2];G=G+1|0;}while((G|0)<(q|0))}if((c[63964>>2]|0)==0){H=0}else{c[p>>2]=c[b+88>>2];dc(x|0,100072,p|0)|0;p=ec(x|0,100088)|0;c[o>>2]=100104;ld(p|0,100096,o|0)|0;if((c[y>>2]|0)>0){o=u;x=0;do{c[n>>2]=c[(c[o>>2]|0)+(x*112|0)+4>>2];ld(p|0,100096,n|0)|0;x=x+1|0;}while((x|0)<(c[y>>2]|0))}Gd(10,p|0)|0;H=p}Lu(9,1,100112,m);a:do{if((d|0)>0){I=+(d+ -1|0);m=b+304|0;p=b+4|0;x=0;do{J=+(x|0)/I;h[m>>3]=J>1.0?1.0:J;Yd[c[(c[v>>2]|0)+80>>2]&127](b)|0;n=l;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Lu(9,0,100136,l);if((c[63964>>2]|0)!=0){n=j;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];ld(H|0,100160,j|0)|0;if((c[y>>2]|0)>0){n=0;do{o=g;h[k>>3]=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+(n<<3)>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];ld(H|0,100160,g|0)|0;n=n+1|0;}while((n|0)<(c[y>>2]|0))}Gd(10,H|0)|0}if((Yx(b,0)|0)!=0){break a}if((Rx(b,0)|0)!=0){break a}if((Ix(b,0)|0)!=0){break a}vx(b);x=x+1|0;}while((x|0)<(d|0))}}while(0);Vd[c[16120]&511](9);if((c[63964>>2]|0)!=0){Sc(H|0)|0}H=c[y>>2]|0;if((H|0)>0){y=c[u>>2]|0;u=0;do{h[y+(u*112|0)+96>>3]=+h[z+(u<<3)>>3];u=u+1|0;}while((u|0)<(H|0))}if((c[A>>2]|0)>0){H=c[b+12>>2]|0;u=0;do{c[H+(u*60|0)+52>>2]=c[B+(u<<2)>>2];u=u+1|0;}while((u|0)<(c[A>>2]|0))}if((c[C>>2]|0)>0){A=b+16|0;u=0;do{a[(c[A>>2]|0)+(u*48|0)+42|0]=a[D+u|0]|0;u=u+1|0;}while((u|0)<(c[C>>2]|0))}C=c[E>>2]|0;if((C|0)>0){E=b+20|0;u=0;do{c[(c[E>>2]|0)+(u*52|0)+44>>2]=c[F+(u<<2)>>2];u=u+1|0;}while((u|0)<(C|0))}AY(z);AY(B);AY(D);AY(F)}else{h[b+304>>3]=1.0;Yd[c[w+80>>2]&127](b)|0}kx(b);if((ny(b,1,1)|0)!=1){i=e;return}Yd[c[(c[v>>2]|0)+80>>2]&127](b)|0;kx(b);if((ny(b,1,1)|0)!=1){i=e;return}Nu(1,0,100168,f);i=e;return}function Cy(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=Fy(b)|0;w=v;x=c[w>>2]|0;if((x|0)==0){Lu(9,0,100272,u);if((c[b+184>>2]|0)==0){le[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0}AY(v);y=0;i=f;return y|0}u=b+184|0;z=c[u>>2]|0;if((z|0)==0){Lu(9,0,100304,t);le[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0;AY(v);y=0;i=f;return y|0}do{if((c[v+16>>2]|0)<(x|0)){Lu(9,1,100376,s);t=zY(c[w>>2]<<3)|0;A=v+40|0;B=c[A>>2]|0;c[A>>2]=0;C=+vy(v,1.0);c[A>>2]=B;D=c[w>>2]|0;if((D|0)>0){E=v+24|0;F=c[E>>2]|0;G=0;while(1){H=F+(G<<3)|0;h[H>>3]=+h[H>>3]+1.0e-6;c[A>>2]=0;h[t+(G<<3)>>3]=+U(+(+vy(v,1.0)-C))/1.0e-6;c[A>>2]=B;H=c[E>>2]|0;I=H+(G<<3)|0;h[I>>3]=+h[I>>3]+-1.0e-6;I=G+1|0;J=c[w>>2]|0;if((I|0)<(J|0)){G=I;F=H}else{K=J;break}}}else{K=D}F=c[u>>2]|0;if((F|0)>0){G=(K|0)>1;E=0;do{if(G){B=1;A=0;while(1){J=+h[t+(B<<3)>>3]>+h[t+(A<<3)>>3]?B:A;H=B+1|0;if((H|0)<(K|0)){A=J;B=H}else{L=J;break}}}else{L=0}h[t+(L<<3)>>3]=-1.0;E=E+1|0;}while((E|0)<(F|0))}Lu(9,1,100400,r);F=b+112|0;E=c[F>>2]|0;if((E|0)>0){G=b+8|0;D=v+44|0;B=v+24|0;A=E;E=0;J=0;while(1){H=(c[G>>2]|0)+(E*112|0)+72|0;if((a[H]|0)==0){if(!(+h[t+(J<<3)>>3]>=0.0)){M=A}else{a[H]=1;C=+h[(c[B>>2]|0)+(J<<3)>>3];c[q>>2]=c[(c[D>>2]|0)+(J<<2)>>2];H=q+4|0;h[k>>3]=C;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];Lu(9,0,100424,q);M=c[F>>2]|0}N=M;O=J+1|0}else{N=A;O=J}H=E+1|0;if((H|0)<(N|0)){A=N;E=H;J=O}else{P=O;break}}}else{P=0}J=b+136|0;if((c[J>>2]|0)>0){E=b+24|0;A=v+44|0;F=v+24|0;D=b+116|0;B=b+120|0;G=0;H=P;while(1){I=(c[E>>2]|0)+(G*112|0)+72|0;if((a[I]|0)==0){if(+h[t+(H<<3)>>3]>=0.0){a[I]=1;C=+h[(c[F>>2]|0)+(H<<3)>>3];c[p>>2]=c[(c[A>>2]|0)+(H<<2)>>2];I=p+4|0;h[k>>3]=C;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];Lu(9,0,100424,p)}Q=H+1|0}else{Q=H}I=c[B>>2]|0;R=(c[D>>2]|0)-I|0;if((R|0)<(I|0)){S=I;I=R;T=Q;while(1){V=(c[E>>2]|0)+(I*112|0)+72|0;if((a[V]|0)==0){if(!(+h[t+(T<<3)>>3]>=0.0)){W=S}else{a[V]=1;C=+h[(c[F>>2]|0)+(T<<3)>>3];c[o>>2]=c[(c[A>>2]|0)+(T<<2)>>2];V=o+4|0;h[k>>3]=C;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];Lu(9,0,100424,o);W=c[B>>2]|0}X=W;Y=T+1|0}else{X=S;Y=T}V=I+1|0;if((V|0)<(X|0)){S=X;I=V;T=Y}else{Z=V;_=Y;break}}}else{Z=R;_=Q}T=Z+1|0;if((T|0)<(c[J>>2]|0)){G=T;H=_}else{break}}}if((c[63964>>2]|0)!=0){Vd[c[16120]&511](9);Vd[c[16120]&511](9)}AY(t);Gy(v);H=Fy(b)|0;if((c[H>>2]|0)!=0){$=H;break}Lu(9,0,100448,n);AY(H);y=0;i=f;return y|0}else{if((z|0)<=(x|0)){$=v;break}Lu(9,0,100480,m);$=v}}while(0);do{if((d|0)==3|(d|0)==5){Lu(9,0,100496,l);Dy($,d,1,e);wy(b,$);v=c[$>>2]|0;if((v|0)<=0){break}m=c[$+24>>2]|0;x=c[$+28>>2]|0;z=0;do{h[x+(z<<3)>>3]=+h[m+(z<<3)>>3];z=z+1|0;}while((z|0)<(v|0))}}while(0);if(+vy($,1.0)>1.0e-9){l=$+40|0;v=c[l>>2]|0;if((v|0)!=0){AY(v);c[l>>2]=0}l=$+52|0;v=c[l>>2]|0;if((v|0)!=0){AY(v);c[l>>2]=0}l=$+56|0;v=c[l>>2]|0;if((v|0)!=0){AY(v);c[l>>2]=0}Dy($,d,0,e);wy(b,$);+vy($,1.0)}else{Lu(9,0,100520,j)}Lu(9,1,100544,g);wy(b,$);b=uy($)|0;if((c[63964>>2]|0)!=0){Vd[c[16120]&511](9)}Gy($);y=b;i=f;return y|0}function Dy(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=c[a+60>>2]|0;h[n>>3]=0.0;p=a;q=zY(c[p>>2]<<3)|0;r=q;s=+vy(a,1.0);t=c[p>>2]|0;if((t|0)>0){u=c[a+28>>2]|0;v=c[a+24>>2]|0;w=0;do{x=+h[u+(w<<3)>>3];h[v+(w<<3)>>3]=x;h[q+(w<<3)>>3]=x;w=w+1|0;}while((w|0)<(t|0))}if(!(s>1.0e-12)){y=1;Iy(a,r);AY(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=14;D=C;E=100672;F=E;Lu(9,0,F,g);i=f;return}t=(d|0)==0;d=a+24|0;x=s;w=1;a:while(1){c[m>>2]=w;Lu(9,0,100584,m);if(!t){Hy(a)}switch(b|0){case 2:{G=Ny(a)|0;break};case 4:{H=12;break a;break};case 3:{G=Ry(a,n,e)|0;break};case 6:{H=14;break a;break};case 5:{H=13;break a;break};case 1:{G=Py(a)|0;break};default:{H=15;break a}}sx(o);ix(o);ox(o);sx(o);s=+vy(a,1.0);v=(G|0)>-1;if(v&s<x){u=c[p>>2]|0;if((u|0)>0){I=c[d>>2]|0;J=0;do{h[q+(J<<3)>>3]=+h[I+(J<<3)>>3];J=J+1|0;}while((J|0)<(u|0))}Lu(9,0,100632,k);wy(o,a);K=s}else{Lu(9,0,100648,j);if(v&s==x){y=w;H=23;break}else{K=x}}u=w+1|0;if((u|0)<201&s>1.0e-12){x=K;w=u}else{y=u;H=23;break}}if((H|0)==12){My(a)|0}else if((H|0)==13){My(a)|0}else if((H|0)==14){Ly(o,a,0)|0}else if((H|0)==15){Pu(c[o+536>>2]|0,100608,l)}else if((H|0)==23){Iy(a,r);AY(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=14;D=C;E=100672;F=E;Lu(9,0,F,g);i=f;return}}function Ey(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=i;d=bZ(b|0)|0;do{if((d|0)==0){e=zY(1)|0;f=0}else{g=0;h=0;j=d;while(1){k=a[b+g|0]|0;if(k<<24>>24==91){l=h+1|0}else if(k<<24>>24==93){l=h+ -1|0}else{l=h}if((l|0)!=0&k<<24>>24==44){m=((a[b+(g+1)|0]|0)!=32)+j|0}else{m=j}k=g+1|0;if(k>>>0<d>>>0){g=k;h=l;j=m}else{break}}j=zY(m+1|0)|0;if((m|0)==0){e=j;f=0;break}else{n=0;o=0;p=l}while(1){h=a[b+o|0]|0;if(h<<24>>24==93){q=p+ -1|0}else if(h<<24>>24==91){q=p+1|0}else{q=p}a[j+n|0]=h;do{if((q|0)!=0&h<<24>>24==44){if((a[b+(o+1)|0]|0)==32){r=n;break}g=n+1|0;a[j+g|0]=32;r=g}else{r=n}}while(0);h=r+1|0;if(h>>>0<m>>>0){n=h;o=o+1|0;p=q}else{e=j;f=m;break}}}}while(0);a[e+f|0]=0;if((YY(e,101688,4)|0)!=0){i=c;return e|0}m=f>>>0>3;q=e+4|0;while(1){a:do{if(m){p=f;while(1){o=p+ -1|0;if((a[e+p|0]|0)==46){s=p;break a}if(o>>>0>3){p=o}else{s=o;break}}}else{s=f}}while(0);if((s|0)==3){t=24;break}p=s+ -3|0;dZ(e|0,q|0,p|0)|0;o=e+p|0;a[o]=678585700;a[o+1|0]=2650725;a[o+2|0]=10354;a[o+3|0]=40;if((YY(e,101688,4)|0)!=0){t=24;break}}if((t|0)==24){i=c;return e|0}return 0}function Fy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+32|0;o=i;i=i+32|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=zY(64)|0;z=y;Ou(0,(y|0)!=0|0,101696,x);x=y+4|0;A=y+8|0;B=y+12|0;C=y+16|0;D=y+20|0;E=y+24|0;F=y+28|0;G=y+32|0;H=y+36|0;I=y+40|0;J=y+44|0;K=y+48|0;L=y+52|0;M=y+56|0;N=y+60|0;O=y+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));c[N>>2]=b;N=b+8|0;O=b+112|0;P=c[O>>2]|0;if((P|0)>0){Q=c[N>>2]|0;R=0;S=0;while(1){if((a[Q+(S*112|0)+72|0]|0)==0){T=R+1|0;c[x>>2]=T;V=T}else{V=R}T=S+1|0;if((T|0)<(P|0)){R=V;S=T}else{W=V;break}}}else{W=0}V=b+136|0;S=c[V>>2]|0;if((S|0)>0){R=c[b+24>>2]|0;P=0;x=0;while(1){if((a[R+(x*112|0)+72|0]|0)==0){Q=P+1|0;c[A>>2]=Q;X=Q}else{X=P}Q=x+1|0;if((Q|0)<(S|0)){P=X;x=Q}else{Y=X;break}}}else{Y=0}X=b+116|0;x=b+120|0;P=c[x>>2]|0;if((P|0)>0){S=c[X>>2]|0;A=c[N>>2]|0;R=0;Q=S-P|0;while(1){if((a[A+(Q*112|0)+72|0]|0)==0){P=R+1|0;c[B>>2]=P;Z=P}else{Z=R}P=Q+1|0;if((P|0)<(S|0)){R=Z;Q=P}else{_=Z;break}}}else{_=0}Z=Y+W+_|0;c[y>>2]=Z;if((Z|0)==0){i=d;return z|0}y=BY(Z,8)|0;c[E>>2]=y;Ou(0,(y|0)!=0|0,101696,w);w=BY(Z,8)|0;c[F>>2]=w;Ou(0,(w|0)!=0|0,101696,v);v=BY(Z,8)|0;c[G>>2]=v;Ou(0,(v|0)!=0|0,101696,u);u=BY(Z,8)|0;c[H>>2]=u;Ou(0,(u|0)!=0|0,101696,t);t=BY(Z,8)|0;c[I>>2]=t;Ou(0,(t|0)!=0|0,101696,s);s=BY(Z,4)|0;t=s;c[J>>2]=t;Ou(0,(s|0)!=0|0,101696,r);Lu(9,0,101712,q);c[p>>2]=Z;c[p+4>>2]=W;c[p+8>>2]=Y;c[p+12>>2]=_;Lu(9,0,101736,p);p=c[O>>2]|0;if((p|0)>0){_=N;Y=p;p=t;W=0;Z=0;while(1){q=c[_>>2]|0;if((a[q+(W*112|0)+72|0]|0)==0){c[p+(Z<<2)>>2]=c[q+(W*112|0)+4>>2];q=c[_>>2]|0;do{if((a[q+(W*112|0)+73|0]|0)==0){$=(c[I>>2]|0)+(Z<<3)|0;aa=1.0}else{ba=+h[q+(W*112|0)+80>>3];ca=+U(+ba);r=(c[I>>2]|0)+(Z<<3)|0;if(!(ba==0.0)){$=r;aa=ca;break}$=r;aa=1.0}}while(0);h[$>>3]=aa;r=q+(W*112|0)+96|0;s=(c[E>>2]|0)+(Z<<3)|0;h[s>>3]=+h[r>>3];u=(c[F>>2]|0)+(Z<<3)|0;h[u>>3]=+h[r>>3];h[(c[G>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+56>>3];h[(c[H>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+64>>3];r=Z+1|0;v=c[J>>2]|0;w=c[v+(Z<<2)>>2]|0;ca=+h[u>>3];ba=+h[$>>3];da=+h[s>>3];c[o>>2]=r;c[o+4>>2]=w;w=o+8|0;h[k>>3]=ca;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+16|0;h[k>>3]=ba;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+24|0;h[k>>3]=da;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Lu(9,0,101824,o);ea=c[O>>2]|0;fa=v;ga=r}else{ea=Y;fa=p;ga=Z}r=W+1|0;if((r|0)<(ea|0)){Y=ea;p=fa;W=r;Z=ga}else{ha=fa;ia=ga;break}}}else{ha=t;ia=0}t=c[V>>2]|0;if((t|0)>0){ga=b+24|0;fa=t;t=ha;Z=0;W=ia;while(1){p=c[ga>>2]|0;if((a[p+(Z*112|0)+72|0]|0)==0){c[t+(W<<2)>>2]=c[p+(Z*112|0)+4>>2];p=c[ga>>2]|0;aa=+h[p+(Z*112|0)+80>>3];da=+U(+aa);ea=(c[I>>2]|0)+(W<<3)|0;h[ea>>3]=aa==0.0?1.0:da;Y=p+(Z*112|0)+96|0;O=(c[E>>2]|0)+(W<<3)|0;h[O>>3]=+h[Y>>3];o=(c[F>>2]|0)+(W<<3)|0;h[o>>3]=+h[Y>>3];h[(c[G>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+56>>3];h[(c[H>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+64>>3];p=W+1|0;Y=c[J>>2]|0;$=c[Y+(W<<2)>>2]|0;da=+h[o>>3];aa=+h[ea>>3];ba=+h[O>>3];c[n>>2]=p;c[n+4>>2]=$;$=n+8|0;h[k>>3]=da;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+16|0;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+24|0;h[k>>3]=ba;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];Lu(9,0,101872,n);ja=c[V>>2]|0;ka=Y;la=p}else{ja=fa;ka=t;la=W}p=Z+1|0;if((p|0)<(ja|0)){fa=ja;t=ka;Z=p;W=la}else{ma=ka;na=la;break}}}else{ma=ha;na=ia}ia=c[x>>2]|0;if((ia|0)>0){ha=c[X>>2]|0;la=N;ka=ha;W=ma;ma=ha-ia|0;ia=na;while(1){na=c[la>>2]|0;if((a[na+(ma*112|0)+72|0]|0)==0){c[W+(ia<<2)>>2]=c[na+(ma*112|0)+4>>2];na=c[la>>2]|0;do{if((a[na+(ma*112|0)+73|0]|0)==0){oa=(c[I>>2]|0)+(ia<<3)|0;pa=1.0}else{ba=+h[na+(ma*112|0)+80>>3];aa=+U(+ba);ha=(c[I>>2]|0)+(ia<<3)|0;if(!(ba==0.0)){oa=ha;pa=aa;break}oa=ha;pa=1.0}}while(0);h[oa>>3]=pa;q=na+(ma*112|0)+96|0;ha=(c[E>>2]|0)+(ia<<3)|0;h[ha>>3]=+h[q>>3];Z=(c[F>>2]|0)+(ia<<3)|0;h[Z>>3]=+h[q>>3];h[(c[G>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+56>>3];h[(c[H>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+64>>3];q=ia+1|0;t=c[J>>2]|0;ja=c[t+(ia<<2)>>2]|0;aa=+h[Z>>3];ba=+h[oa>>3];da=+h[ha>>3];c[m>>2]=q;c[m+4>>2]=ja;ja=m+8|0;h[k>>3]=aa;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+16|0;h[k>>3]=ba;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+24|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];Lu(9,0,101928,m);qa=c[X>>2]|0;ra=t;sa=q}else{qa=ka;ra=W;sa=ia}q=ma+1|0;if((q|0)<(qa|0)){ka=qa;W=ra;ma=q;ia=sa}else{break}}}sa=c[b+184>>2]|0;c[C>>2]=sa;c[D>>2]=0;C=c[X>>2]|0;if((C|0)>0){X=c[N>>2]|0;ia=0;ma=0;while(1){if((a[X+(ma*112|0)+88|0]|0)==0){ta=ia}else{ra=ia+1|0;c[D>>2]=ra;ta=ra}ra=ma+1|0;if((ra|0)<(C|0)){ia=ta;ma=ra}else{ua=ta;break}}}else{ua=0}ta=c[V>>2]|0;if((ta|0)>0){V=c[b+24>>2]|0;ma=ua;ia=0;while(1){do{if((a[V+(ia*112|0)+88|0]|0)==0){va=ma}else{if((a[V+(ia*112|0)+72|0]|0)!=0){va=ma;break}X=ma+1|0;c[D>>2]=X;va=X}}while(0);na=ia+1|0;if((na|0)<(ta|0)){ma=va;ia=na}else{wa=va;break}}}else{wa=ua}ua=c[x>>2]|0;if((ua|0)>0){x=c[N>>2]|0;N=wa;va=C-ua|0;while(1){do{if((a[x+(va*112|0)+88|0]|0)==0){xa=N}else{if((a[x+(va*112|0)+72|0]|0)!=0){xa=N;break}ua=N+1|0;c[D>>2]=ua;xa=ua}}while(0);ua=va+1|0;if((ua|0)<(C|0)){N=xa;va=ua}else{ya=xa;break}}}else{ya=wa}wa=c[b+176>>2]|0;xa=c[b+180>>2]|0;c[l>>2]=sa;c[l+4>>2]=wa;c[l+8>>2]=xa;Lu(9,0,101984,l);c[j>>2]=ya;Lu(9,0,102056,j);j=BY(sa,8)|0;c[K>>2]=j;Ou(0,(j|0)!=0|0,101696,g);g=zY(sa<<3)|0;c[L>>2]=g;Ou(0,(g|0)!=0|0,101696,f);f=zY(ya<<3)|0;c[M>>2]=f;Ou(0,(f|0)!=0|0,101696,e);if((sa|0)>0){e=0;do{h[g+(e<<3)>>3]=1.0;e=e+1|0;}while((e|0)<(sa|0))}if((ya|0)>0){za=0}else{i=d;return z|0}do{h[f+(za<<3)>>3]=1.0;za=za+1|0;}while((za|0)<(ya|0));i=d;return z|0}function Gy(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;if((d|0)!=0){AY(d)}d=c[a+28>>2]|0;if((d|0)!=0){AY(d)}d=c[a+32>>2]|0;if((d|0)!=0){AY(d)}d=c[a+36>>2]|0;if((d|0)!=0){AY(d)}d=c[a+40>>2]|0;if((d|0)!=0){AY(d)}d=c[a+44>>2]|0;if((d|0)!=0){AY(d)}d=c[a+48>>2]|0;if((d|0)!=0){AY(d)}d=c[a+52>>2]|0;if((d|0)!=0){AY(d)}d=c[a+56>>2]|0;if((d|0)==0){e=a;AY(e);i=b;return}AY(d);e=a;AY(e);i=b;return}function Hy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0,W=0;d=i;i=i+8|0;e=d;f=c[b+60>>2]|0;g=b+40|0;if((c[g>>2]|0)==0){i=d;return}j=b+52|0;k=c[j>>2]|0;if((k|0)==0){i=d;return}l=b+56|0;m=c[l>>2]|0;if((m|0)==0){i=d;return}n=b+16|0;o=c[n>>2]|0;p=BY(o,8)|0;q=BY(o,8)|0;r=b+20|0;s=c[r>>2]|0;t=BY(s,8)|0;u=BY(s,8)|0;v=BY(o,8)|0;w=BY(s,8)|0;if((o|0)>0){x=0;do{h[k+(x<<3)>>3]=1.0;x=x+1|0;}while((x|0)<(o|0))}if((s|0)>0){o=0;do{h[m+(o<<3)>>3]=1.0;o=o+1|0;}while((o|0)<(s|0))}+vy(b,1.0);s=c[n>>2]|0;if((s|0)>0){dZ(p|0,c[b+48>>2]|0,((s|0)>1?s<<3:8)|0)|0}o=f+8|0;m=f+116|0;x=c[m>>2]|0;if((x|0)>0){k=c[o>>2]|0;y=f+4|0;z=0;A=0;while(1){if((a[k+(z*112|0)+88|0]|0)==0){B=A}else{h[t+(A<<3)>>3]=+h[k+(z*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];B=A+1|0}C=z+1|0;if((C|0)<(x|0)){z=C;A=B}else{D=B;break}}}else{D=0}B=f+136|0;A=c[B>>2]|0;if((A|0)>0){z=c[f+24>>2]|0;y=f+4|0;k=0;C=D;while(1){do{if((a[z+(k*112|0)+88|0]|0)==0){E=C}else{if((a[z+(k*112|0)+72|0]|0)!=0){E=C;break}h[t+(C<<3)>>3]=+h[z+(k*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3];E=C+1|0}}while(0);F=k+1|0;if((F|0)<(A|0)){k=F;C=E}else{G=E;break}}}else{G=D}D=f+120|0;E=c[D>>2]|0;if((E|0)>0){C=c[o>>2]|0;k=f+4|0;A=x-E|0;E=G;while(1){do{if((a[C+(A*112|0)+88|0]|0)==0){H=E}else{if((a[C+(A*112|0)+72|0]|0)!=0){H=E;break}h[t+(E<<3)>>3]=+h[C+(A*112|0)+96>>3]- +h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];H=E+1|0}}while(0);G=A+1|0;if((G|0)<(x|0)){A=G;E=H}else{break}}}H=b;if((c[H>>2]|0)>0){E=b+24|0;A=o;o=f+4|0;x=f+24|0;f=b+48|0;k=c[E>>2]|0;C=0;while(1){G=k+(C<<3)|0;h[G>>3]=+h[G>>3]+1.0e-6;+vy(b,1.0);G=c[n>>2]|0;y=(G|0)>0;if(y){dZ(q|0,c[f>>2]|0,((G|0)>1?G<<3:8)|0)|0}z=c[m>>2]|0;if((z|0)>0){F=c[A>>2]|0;I=0;J=0;while(1){if((a[F+(J*112|0)+88|0]|0)==0){K=I}else{h[u+(I<<3)>>3]=+h[F+(J*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(J<<3)>>3];K=I+1|0}L=J+1|0;if((L|0)<(z|0)){I=K;J=L}else{M=K;break}}}else{M=0}J=c[B>>2]|0;if((J|0)>0){I=c[x>>2]|0;F=M;L=0;while(1){do{if((a[I+(L*112|0)+88|0]|0)==0){N=F}else{if((a[I+(L*112|0)+72|0]|0)!=0){N=F;break}h[u+(F<<3)>>3]=+h[I+(L*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(L<<3)>>3];N=F+1|0}}while(0);O=L+1|0;if((O|0)<(J|0)){F=N;L=O}else{P=N;break}}}else{P=M}L=c[D>>2]|0;if((L|0)>0){F=c[A>>2]|0;J=P;I=z-L|0;while(1){do{if((a[F+(I*112|0)+88|0]|0)==0){Q=J}else{if((a[F+(I*112|0)+72|0]|0)!=0){Q=J;break}h[u+(J<<3)>>3]=+h[F+(I*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(I<<3)>>3];Q=J+1|0}}while(0);L=I+1|0;if((L|0)<(z|0)){J=Q;I=L}else{break}}}if(y){R=+h[(c[g>>2]|0)+(C<<3)>>3];I=0;do{S=+U(+(R*(+h[q+(I<<3)>>3]- +h[p+(I<<3)>>3])/1.0e-6));J=v+(I<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}I=I+1|0;}while((I|0)<(G|0))}I=c[r>>2]|0;if((I|0)>0){R=+h[(c[g>>2]|0)+(C<<3)>>3];y=0;do{S=+U(+(R*(+h[u+(y<<3)>>3]- +h[t+(y<<3)>>3])/1.0e-6));J=w+(y<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}y=y+1|0;}while((y|0)<(I|0))}I=c[E>>2]|0;y=I+(C<<3)|0;h[y>>3]=+h[y>>3]+-1.0e-6;y=C+1|0;if((y|0)<(c[H>>2]|0)){k=I;C=y}else{T=G;break}}}else{T=s}if((T|0)>0){s=T;T=0;while(1){R=+h[v+(T<<3)>>3];C=(c[j>>2]|0)+(T<<3)|0;if(R<1.0e-42){h[C>>3]=1.0;k=T+1|0;c[e>>2]=k;Lu(9,0,102096,e);V=k;W=c[n>>2]|0}else{h[C>>3]=R;V=T+1|0;W=s}if((V|0)<(W|0)){s=W;T=V}else{break}}}V=c[r>>2]|0;if((V|0)>0){r=c[l>>2]|0;l=0;do{R=+h[w+(l<<3)>>3];h[r+(l<<3)>>3]=R<1.0e-42?1.0:R;l=l+1|0;}while((l|0)<(V|0))}AY(p);AY(q);AY(t);AY(u);AY(v);AY(w);i=d;return}function Iy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+24>>2]|0;a=0;do{h[f+(a<<3)>>3]=+h[b+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=d;return}function Jy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+40>>2]|0;g=(f|0)==0;j=c[a+24>>2]|0;a=0;do{k=+h[b+(a<<3)>>3];if(g){l=k}else{l=k*+h[f+(a<<3)>>3]}h[j+(a<<3)>>3]=l;a=a+1|0;}while((a|0)<(e|0));i=d;return}function Ky(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=c[b+60>>2]|0;f=c[e+112>>2]|0;if((f|0)>0){g=b+24|0;j=c[e+8>>2]|0;k=0;l=0;while(1){if((a[j+(k*112|0)+72|0]|0)==0){h[(c[(c[c[e+4>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3]=+h[(c[g>>2]|0)+(l<<3)>>3];m=l+1|0}else{m=l}n=k+1|0;if((n|0)<(f|0)){k=n;l=m}else{o=m;break}}}else{o=0}m=c[e+136>>2]|0;if((m|0)>0){l=b+24|0;k=c[e+24>>2]|0;f=0;g=o;while(1){if((a[k+(f*112|0)+72|0]|0)==0){h[(c[e+416>>2]|0)+(f<<3)>>3]=+h[(c[l>>2]|0)+(g<<3)>>3];p=g+1|0}else{p=g}j=f+1|0;if((j|0)<(m|0)){f=j;g=p}else{q=p;break}}}else{q=o}o=c[e+116>>2]|0;p=c[e+120>>2]|0;if((p|0)<=0){i=d;return}g=b+24|0;b=c[e+8>>2]|0;f=o-p|0;p=q;while(1){if((a[b+(f*112|0)+72|0]|0)==0){h[(c[e+400>>2]|0)+(f<<3)>>3]=+h[(c[g>>2]|0)+(p<<3)>>3];r=p+1|0}else{r=p}q=f+1|0;if((q|0)<(o|0)){f=q;p=r}else{break}}i=d;return}function Ly(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+8|0;Pu(c[a+536>>2]|0,102168,d);return 0}function My(a){a=a|0;a=i;i=i+8|0;Pu(0,102200,a);return 0}function Ny(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;c[d>>2]=(c[63964>>2]|0)!=0?1e3:0;k=a;l=c[k>>2]|0;c[e>>2]=l*1e3;h[f>>3]=1.0e-12;h[g>>3]=10.0;m=l<<1|1;c[j>>2]=m;n=BY((fa(m+13|0,m+l|0)|0)+((fa(l*3|0,l+3|0)|0)/2|0)|0,8)|0;Ou(0,(n|0)!=0|0,102240,b);c[25564]=c[a+60>>2];c[25566]=c[a+48>>2];Bw(k,j,c[a+24>>2]|0,g,f,d,e,n,5)|0;AY(n);c[25564]=0;c[25566]=0;n=uy(a)|0;i=b;return n|0}function Oy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[25566];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[25564];h[d>>3]=+vy(f,1.0);i=e;return}function Py(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;h[o>>3]=0.0;h[p>>3]=0.0;h[q>>3]=0.0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;w=a;x=c[w>>2]<<3;y=zY(x)|0;z=y;A=zY(x)|0;x=A;Ou(0,(y|0)!=0|0,102272,n);Ou(0,(A|0)!=0|0,102272,m);m=c[w>>2]|0;if((m|0)>0){n=c[a+24>>2]|0;B=0;do{C=+h[n+(B<<3)>>3];if(C!=0.0){D=+U(+C)/1.0e3}else{D=1.0}h[y+(B<<3)>>3]=D;h[A+(B<<3)>>3]=0.0;B=B+1|0;}while((B|0)<(m|0))}B=m*1e3|0;c[v>>2]=B;if((c[63964>>2]|0)==0){E=-1}else{E=(B|0)/10|0}c[r>>2]=E;h[p>>3]=1.0e-12;c[s>>2]=m;c[t>>2]=0;h[q>>3]=1.0e-12;D=+vy(a,1.0);h[o>>3]=D;if(D!=0.0){c[25572]=c[a+60>>2];c[25574]=c[a+48>>2];yw(c[a+24>>2]|0,z,w,o,v,r,p,s,t,q,x,6,u)|0;c[25572]=0;c[25574]=0}else{x=l;h[k>>3]=D;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Lu(9,0,102304,l)}D=+vy(a,1.0);h[o>>3]=D;l=j;h[k>>3]=D;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];Lu(9,0,102408,j);j=c[u>>2]|0;do{if((j|0)==3){Nu(9,0,102568,e);F=-3;i=b;return F|0}else if((j|0)==4){Nu(9,0,102640,d);F=-4;i=b;return F|0}else if((j|0)==1){if(!(+h[q>>3]<+h[o>>3])){break}c[g>>2]=c[v>>2];Nu(9,0,102424,g);F=-1;i=b;return F|0}else if((j|0)==2){Nu(9,0,102504,f);F=-2;i=b;return F|0}}while(0);F=uy(a)|0;i=b;return F|0}function Qy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[25574];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[25572];h[d>>3]=+vy(f,1.0);i=e;return}function Ry(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=fa(d*1e3|0,c[a>>2]|0)|0;c[j>>2]=0;Lu(9,1,102696,g);if((c[63964>>2]|0)==0){l=0}else{l=(k|0)/10|0}Sy(a,d,k,l,b,j);c[f>>2]=c[j>>2];Lu(9,0,102720,f);Vd[c[16120]&511](9);if(+h[b>>3]<1.0){m=-1;i=e;return m|0}b=uy(a)|0;if((b|0)==0){m=0;i=e;return m|0}Nu(9,0,102736,e);m=b;i=e;return m|0}



function sY(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+56|0;j=h;k=c[d>>2]|0;l=d+(c[k+ -8>>2]|0)|0;m=c[k+ -4>>2]|0;k=m;c[j>>2]=f;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=g;g=j+16|0;e=j+20|0;d=j+24|0;n=j+28|0;o=j+32|0;p=j+40|0;q=(m|0)==(f|0);f=g;r=f+0|0;s=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));b[f+36>>1]=0;a[f+38|0]=0;if(q){c[j+48>>2]=1;fe[c[(c[m>>2]|0)+20>>2]&31](k,j,l,l,1,0);t=(c[d>>2]|0)==1?l:0;i=h;return t|0}Sd[c[(c[m>>2]|0)+24>>2]&31](k,j,l,1,0);l=c[j+36>>2]|0;if((l|0)==0){if((c[p>>2]|0)!=1){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}t=(c[o>>2]|0)==1?c[e>>2]|0:0;i=h;return t|0}else if((l|0)==1){do{if((c[d>>2]|0)!=1){if((c[p>>2]|0)!=0){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}if((c[o>>2]|0)==1){break}else{t=0}i=h;return t|0}}while(0);t=c[g>>2]|0;i=h;return t|0}else{t=0;i=h;return t|0}return 0}function tY(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=c[b+12>>2]|0;m=b+16+(l<<3)|0;a:do{if((l|0)>0){n=d+52|0;o=d+53|0;p=d+54|0;q=b+8|0;r=d+24|0;s=0;t=0;u=b+16|0;b:while(1){a[n]=0;a[o]=0;v=c[u+4>>2]|0;w=v>>8;if((v&1|0)==0){x=w}else{x=c[(c[e>>2]|0)+w>>2]|0}w=c[u>>2]|0;fe[c[(c[w>>2]|0)+20>>2]&31](w,d,e,e+x|0,2-(v>>>1&1)|0,g);if((a[p]|0)!=0){y=s;z=t;break}do{if((a[o]|0)==0){A=s;B=t}else{if((a[n]|0)==0){if((c[q>>2]&1|0)==0){y=s;z=1;break b}else{A=s;B=1;break}}if((c[r>>2]|0)==1){C=27;break a}if((c[q>>2]&2|0)==0){C=27;break a}else{A=1;B=1}}}while(0);v=u+8|0;if(v>>>0<m>>>0){s=A;t=B;u=v}else{y=A;z=B;break}}if(y){D=z;C=26}else{E=z;C=23}}else{E=0;C=23}}while(0);do{if((C|0)==23){c[j>>2]=e;m=d+40|0;c[m>>2]=(c[m>>2]|0)+1;if((c[d+36>>2]|0)!=1){D=E;C=26;break}if((c[d+24>>2]|0)!=2){D=E;C=26;break}a[d+54|0]=1;if(E){C=27}else{C=28}}}while(0);if((C|0)==26){if(D){C=27}else{C=28}}if((C|0)==27){c[k>>2]=3;i=h;return}else if((C|0)==28){c[k>>2]=4;i=h;return}}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}D=c[b+12>>2]|0;E=b+16+(D<<3)|0;z=c[b+20>>2]|0;y=z>>8;if((z&1|0)==0){F=y}else{F=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;Sd[c[(c[y>>2]|0)+24>>2]&31](y,d,e+F|0,(z&2|0)!=0?f:2,g);z=b+24|0;if((D|0)<=1){i=h;return}D=c[b+8>>2]|0;do{if((D&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((D&1|0)==0){F=d+54|0;y=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){C=53;break}B=c[y+4>>2]|0;A=B>>8;if((B&1|0)==0){G=A}else{G=c[(c[e>>2]|0)+A>>2]|0}A=c[y>>2]|0;Sd[c[(c[A>>2]|0)+24>>2]&31](A,d,e+G|0,(B&2|0)!=0?f:2,g);B=y+8|0;if(B>>>0<E>>>0){y=B}else{C=53;break}}if((C|0)==53){i=h;return}}y=d+24|0;F=d+54|0;k=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){if((c[y>>2]|0)==1){C=53;break}}B=c[k+4>>2]|0;A=B>>8;if((B&1|0)==0){H=A}else{H=c[(c[e>>2]|0)+A>>2]|0}A=c[k>>2]|0;Sd[c[(c[A>>2]|0)+24>>2]&31](A,d,e+H|0,(B&2|0)!=0?f:2,g);B=k+8|0;if(B>>>0<E>>>0){k=B}else{C=53;break}}if((C|0)==53){i=h;return}}}while(0);H=d+54|0;G=z;while(1){if((a[H]|0)!=0){C=53;break}z=c[G+4>>2]|0;D=z>>8;if((z&1|0)==0){I=D}else{I=c[(c[e>>2]|0)+D>>2]|0}D=c[G>>2]|0;Sd[c[(c[D>>2]|0)+24>>2]&31](D,d,e+I|0,(z&2|0)!=0?f:2,g);z=G+8|0;if(z>>>0<E>>>0){G=z}else{C=53;break}}if((C|0)==53){i=h;return}}function uY(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;Sd[c[(c[j>>2]|0)+24>>2]&31](j,d,e,f,g);i=h;return}do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=d+52|0;a[l]=0;m=d+53|0;a[m]=0;n=c[b+8>>2]|0;fe[c[(c[n>>2]|0)+20>>2]&31](n,d,e,e,1,g);if((a[m]|0)==0){o=0;p=13}else{if((a[l]|0)==0){o=1;p=13}}a:do{if((p|0)==13){c[j>>2]=e;l=d+40|0;c[l>>2]=(c[l>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){p=16;break}a[d+54|0]=1;if(o){break a}}else{p=16}}while(0);if((p|0)==16){if(o){break}}c[k>>2]=4;i=h;return}}while(0);c[k>>2]=3;i=h;return}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function vY(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){i=g;return}h=d+28|0;if((c[h>>2]|0)==1){i=g;return}c[h>>2]=f;i=g;return}if((c[d>>2]|0)!=(b|0)){i=g;return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;i=g;return}}while(0);if((f|0)!=1){i=g;return}c[d+32>>2]=1;i=g;return}function wY(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=d+52|0;l=a[k]|0;m=d+53|0;n=a[m]|0;o=c[b+12>>2]|0;p=b+16+(o<<3)|0;a[k]=0;a[m]=0;q=c[b+20>>2]|0;r=q>>8;if((q&1|0)==0){s=r}else{s=c[(c[f>>2]|0)+r>>2]|0}r=c[b+16>>2]|0;fe[c[(c[r>>2]|0)+20>>2]&31](r,d,e,f+s|0,(q&2|0)!=0?g:2,h);a:do{if((o|0)>1){q=d+24|0;s=b+8|0;r=d+54|0;t=b+24|0;do{if((a[r]|0)!=0){break a}do{if((a[k]|0)==0){if((a[m]|0)==0){break}if((c[s>>2]&1|0)==0){break a}}else{if((c[q>>2]|0)==1){break a}if((c[s>>2]&2|0)==0){break a}}}while(0);a[k]=0;a[m]=0;u=c[t+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[f>>2]|0)+v>>2]|0}v=c[t>>2]|0;fe[c[(c[v>>2]|0)+20>>2]&31](v,d,e,f+w|0,(u&2|0)!=0?g:2,h);t=t+8|0;}while(t>>>0<p>>>0)}}while(0);a[k]=l;a[m]=n;i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;n=c[f>>2]|0;if((n|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((n|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;n=c[e>>2]|0;if((n|0)==2){c[e>>2]=g;x=g}else{x=n}if(!((c[d+48>>2]|0)==1&(x|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function xY(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=c[b+8>>2]|0;fe[c[(c[k>>2]|0)+20>>2]&31](k,d,e,f,g,h);i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;l=g}else{l=h}if(!((c[d+48>>2]|0)==1&(l|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function yY(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;if((c[d+8>>2]|0)!=(b|0)){i=h;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=h;return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=h;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;j=g}else{j=b}if(!((c[d+48>>2]|0)==1&(j|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}function zY(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;b=i;do{if(a>>>0<245){if(a>>>0<11){d=16}else{d=a+11&-8}e=d>>>3;f=c[37848]|0;g=f>>>e;if((g&3|0)!=0){h=(g&1^1)+e|0;j=h<<1;k=151432+(j<<2)|0;l=151432+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do{if((k|0)==(n|0)){c[37848]=f&~(1<<h)}else{if(n>>>0<(c[151408>>2]|0)>>>0){$c()}o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else{$c()}}}while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}if(!(d>>>0>(c[151400>>2]|0)>>>0)){q=d;break}if((g|0)!=0){l=2<<e;n=g<<e&(l|0-l);l=(n&0-n)+ -1|0;n=l>>>12&16;k=l>>>n;l=k>>>5&8;o=k>>>l;k=o>>>2&4;r=o>>>k;o=r>>>1&2;s=r>>>o;r=s>>>1&1;t=(l|n|k|o|r)+(s>>>r)|0;r=t<<1;s=151432+(r<<2)|0;o=151432+(r+2<<2)|0;r=c[o>>2]|0;k=r+8|0;n=c[k>>2]|0;do{if((s|0)==(n|0)){c[37848]=f&~(1<<t)}else{if(n>>>0<(c[151408>>2]|0)>>>0){$c()}l=n+12|0;if((c[l>>2]|0)==(r|0)){c[l>>2]=s;c[o>>2]=n;break}else{$c()}}}while(0);n=t<<3;o=n-d|0;c[r+4>>2]=d|3;s=r+d|0;c[r+(d|4)>>2]=o|1;c[r+n>>2]=o;n=c[151400>>2]|0;if((n|0)!=0){f=c[151412>>2]|0;e=n>>>3;n=e<<1;g=151432+(n<<2)|0;m=c[37848]|0;j=1<<e;do{if((m&j|0)==0){c[37848]=m|j;u=151432+(n+2<<2)|0;v=g}else{e=151432+(n+2<<2)|0;h=c[e>>2]|0;if(!(h>>>0<(c[151408>>2]|0)>>>0)){u=e;v=h;break}$c()}}while(0);c[u>>2]=f;c[v+12>>2]=f;c[f+8>>2]=v;c[f+12>>2]=g}c[151400>>2]=o;c[151412>>2]=s;p=k;i=b;return p|0}n=c[151396>>2]|0;if((n|0)==0){q=d;break}j=(n&0-n)+ -1|0;n=j>>>12&16;m=j>>>n;j=m>>>5&8;r=m>>>j;m=r>>>2&4;t=r>>>m;r=t>>>1&2;h=t>>>r;t=h>>>1&1;e=c[151696+((j|n|m|r|t)+(h>>>t)<<2)>>2]|0;t=(c[e+4>>2]&-8)-d|0;h=e;r=e;while(1){e=c[h+16>>2]|0;if((e|0)==0){m=c[h+20>>2]|0;if((m|0)==0){break}else{w=m}}else{w=e}e=(c[w+4>>2]&-8)-d|0;m=e>>>0<t>>>0;t=m?e:t;h=w;r=m?w:r}h=r;k=c[151408>>2]|0;if(h>>>0<k>>>0){$c()}s=r+d|0;o=s;if(!(h>>>0<s>>>0)){$c()}s=c[r+24>>2]|0;h=c[r+12>>2]|0;do{if((h|0)==(r|0)){g=r+20|0;f=c[g>>2]|0;if((f|0)==0){m=r+16|0;e=c[m>>2]|0;if((e|0)==0){x=0;break}else{y=e;z=m}}else{y=f;z=g}while(1){g=y+20|0;f=c[g>>2]|0;if((f|0)!=0){z=g;y=f;continue}f=y+16|0;g=c[f>>2]|0;if((g|0)==0){break}else{y=g;z=f}}if(z>>>0<k>>>0){$c()}else{c[z>>2]=0;x=y;break}}else{f=c[r+8>>2]|0;if(f>>>0<k>>>0){$c()}g=f+12|0;if((c[g>>2]|0)!=(r|0)){$c()}m=h+8|0;if((c[m>>2]|0)==(r|0)){c[g>>2]=h;c[m>>2]=f;x=h;break}else{$c()}}}while(0);a:do{if((s|0)!=0){h=c[r+28>>2]|0;k=151696+(h<<2)|0;do{if((r|0)==(c[k>>2]|0)){c[k>>2]=x;if((x|0)!=0){break}c[151396>>2]=c[151396>>2]&~(1<<h);break a}else{if(s>>>0<(c[151408>>2]|0)>>>0){$c()}f=s+16|0;if((c[f>>2]|0)==(r|0)){c[f>>2]=x}else{c[s+20>>2]=x}if((x|0)==0){break a}}}while(0);if(x>>>0<(c[151408>>2]|0)>>>0){$c()}c[x+24>>2]=s;h=c[r+16>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[151408>>2]|0)>>>0){$c()}else{c[x+16>>2]=h;c[h+24>>2]=x;break}}}while(0);h=c[r+20>>2]|0;if((h|0)==0){break}if(h>>>0<(c[151408>>2]|0)>>>0){$c()}else{c[x+20>>2]=h;c[h+24>>2]=x;break}}}while(0);if(t>>>0<16){s=t+d|0;c[r+4>>2]=s|3;h=r+(s+4)|0;c[h>>2]=c[h>>2]|1}else{c[r+4>>2]=d|3;c[r+(d|4)>>2]=t|1;c[r+(t+d)>>2]=t;h=c[151400>>2]|0;if((h|0)!=0){s=c[151412>>2]|0;k=h>>>3;h=k<<1;f=151432+(h<<2)|0;m=c[37848]|0;g=1<<k;do{if((m&g|0)==0){c[37848]=m|g;A=151432+(h+2<<2)|0;B=f}else{k=151432+(h+2<<2)|0;e=c[k>>2]|0;if(!(e>>>0<(c[151408>>2]|0)>>>0)){A=k;B=e;break}$c()}}while(0);c[A>>2]=s;c[B+12>>2]=s;c[s+8>>2]=B;c[s+12>>2]=f}c[151400>>2]=t;c[151412>>2]=o}p=r+8|0;i=b;return p|0}else{if(a>>>0>4294967231){q=-1;break}h=a+11|0;g=h&-8;m=c[151396>>2]|0;if((m|0)==0){q=g;break}e=0-g|0;k=h>>>8;do{if((k|0)==0){C=0}else{if(g>>>0>16777215){C=31;break}h=(k+1048320|0)>>>16&8;n=k<<h;j=(n+520192|0)>>>16&4;l=n<<j;n=(l+245760|0)>>>16&2;D=14-(j|h|n)+(l<<n>>>15)|0;C=g>>>(D+7|0)&1|D<<1}}while(0);k=c[151696+(C<<2)>>2]|0;b:do{if((k|0)==0){E=e;F=0;G=0}else{if((C|0)==31){H=0}else{H=25-(C>>>1)|0}r=e;o=0;t=g<<H;f=k;s=0;while(1){D=c[f+4>>2]&-8;n=D-g|0;if(n>>>0<r>>>0){if((D|0)==(g|0)){E=n;F=f;G=f;break b}else{I=n;J=f}}else{I=r;J=s}n=c[f+20>>2]|0;D=c[f+16+(t>>>31<<2)>>2]|0;l=(n|0)==0|(n|0)==(D|0)?o:n;if((D|0)==0){E=I;F=l;G=J;break}else{r=I;o=l;t=t<<1;f=D;s=J}}}}while(0);if((F|0)==0&(G|0)==0){k=2<<C;e=m&(k|0-k);if((e|0)==0){q=g;break}k=(e&0-e)+ -1|0;e=k>>>12&16;s=k>>>e;k=s>>>5&8;f=s>>>k;s=f>>>2&4;t=f>>>s;f=t>>>1&2;o=t>>>f;t=o>>>1&1;K=c[151696+((k|e|s|f|t)+(o>>>t)<<2)>>2]|0}else{K=F}if((K|0)==0){L=E;M=G}else{t=E;o=K;f=G;while(1){s=(c[o+4>>2]&-8)-g|0;e=s>>>0<t>>>0;k=e?s:t;s=e?o:f;e=c[o+16>>2]|0;if((e|0)!=0){N=s;O=k;f=N;o=e;t=O;continue}e=c[o+20>>2]|0;if((e|0)==0){L=k;M=s;break}else{N=s;O=k;o=e;f=N;t=O}}}if((M|0)==0){q=g;break}if(!(L>>>0<((c[151400>>2]|0)-g|0)>>>0)){q=g;break}t=M;f=c[151408>>2]|0;if(t>>>0<f>>>0){$c()}o=M+g|0;m=o;if(!(t>>>0<o>>>0)){$c()}t=c[M+24>>2]|0;e=c[M+12>>2]|0;do{if((e|0)==(M|0)){k=M+20|0;s=c[k>>2]|0;if((s|0)==0){r=M+16|0;D=c[r>>2]|0;if((D|0)==0){P=0;break}else{Q=D;R=r}}else{Q=s;R=k}while(1){k=Q+20|0;s=c[k>>2]|0;if((s|0)!=0){R=k;Q=s;continue}s=Q+16|0;k=c[s>>2]|0;if((k|0)==0){break}else{Q=k;R=s}}if(R>>>0<f>>>0){$c()}else{c[R>>2]=0;P=Q;break}}else{s=c[M+8>>2]|0;if(s>>>0<f>>>0){$c()}k=s+12|0;if((c[k>>2]|0)!=(M|0)){$c()}r=e+8|0;if((c[r>>2]|0)==(M|0)){c[k>>2]=e;c[r>>2]=s;P=e;break}else{$c()}}}while(0);c:do{if((t|0)!=0){e=c[M+28>>2]|0;f=151696+(e<<2)|0;do{if((M|0)==(c[f>>2]|0)){c[f>>2]=P;if((P|0)!=0){break}c[151396>>2]=c[151396>>2]&~(1<<e);break c}else{if(t>>>0<(c[151408>>2]|0)>>>0){$c()}s=t+16|0;if((c[s>>2]|0)==(M|0)){c[s>>2]=P}else{c[t+20>>2]=P}if((P|0)==0){break c}}}while(0);if(P>>>0<(c[151408>>2]|0)>>>0){$c()}c[P+24>>2]=t;e=c[M+16>>2]|0;do{if((e|0)!=0){if(e>>>0<(c[151408>>2]|0)>>>0){$c()}else{c[P+16>>2]=e;c[e+24>>2]=P;break}}}while(0);e=c[M+20>>2]|0;if((e|0)==0){break}if(e>>>0<(c[151408>>2]|0)>>>0){$c()}else{c[P+20>>2]=e;c[e+24>>2]=P;break}}}while(0);d:do{if(L>>>0<16){t=L+g|0;c[M+4>>2]=t|3;e=M+(t+4)|0;c[e>>2]=c[e>>2]|1}else{c[M+4>>2]=g|3;c[M+(g|4)>>2]=L|1;c[M+(L+g)>>2]=L;e=L>>>3;if(L>>>0<256){t=e<<1;f=151432+(t<<2)|0;s=c[37848]|0;r=1<<e;do{if((s&r|0)==0){c[37848]=s|r;S=151432+(t+2<<2)|0;T=f}else{e=151432+(t+2<<2)|0;k=c[e>>2]|0;if(!(k>>>0<(c[151408>>2]|0)>>>0)){S=e;T=k;break}$c()}}while(0);c[S>>2]=m;c[T+12>>2]=m;c[M+(g+8)>>2]=T;c[M+(g+12)>>2]=f;break}t=o;r=L>>>8;do{if((r|0)==0){U=0}else{if(L>>>0>16777215){U=31;break}s=(r+1048320|0)>>>16&8;k=r<<s;e=(k+520192|0)>>>16&4;D=k<<e;k=(D+245760|0)>>>16&2;l=14-(e|s|k)+(D<<k>>>15)|0;U=L>>>(l+7|0)&1|l<<1}}while(0);r=151696+(U<<2)|0;c[M+(g+28)>>2]=U;c[M+(g+20)>>2]=0;c[M+(g+16)>>2]=0;f=c[151396>>2]|0;l=1<<U;if((f&l|0)==0){c[151396>>2]=f|l;c[r>>2]=t;c[M+(g+24)>>2]=r;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break}l=c[r>>2]|0;if((U|0)==31){V=0}else{V=25-(U>>>1)|0}e:do{if((c[l+4>>2]&-8|0)==(L|0)){W=l}else{r=L<<V;f=l;while(1){X=f+16+(r>>>31<<2)|0;k=c[X>>2]|0;if((k|0)==0){break}if((c[k+4>>2]&-8|0)==(L|0)){W=k;break e}else{r=r<<1;f=k}}if(X>>>0<(c[151408>>2]|0)>>>0){$c()}else{c[X>>2]=t;c[M+(g+24)>>2]=f;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break d}}}while(0);l=W+8|0;r=c[l>>2]|0;k=c[151408>>2]|0;if(W>>>0<k>>>0){$c()}if(r>>>0<k>>>0){$c()}else{c[r+12>>2]=t;c[l>>2]=t;c[M+(g+8)>>2]=r;c[M+(g+12)>>2]=W;c[M+(g+24)>>2]=0;break}}}while(0);p=M+8|0;i=b;return p|0}}while(0);M=c[151400>>2]|0;if(!(q>>>0>M>>>0)){W=M-q|0;X=c[151412>>2]|0;if(W>>>0>15){c[151412>>2]=X+q;c[151400>>2]=W;c[X+(q+4)>>2]=W|1;c[X+M>>2]=W;c[X+4>>2]=q|3}else{c[151400>>2]=0;c[151412>>2]=0;c[X+4>>2]=M|3;W=X+(M+4)|0;c[W>>2]=c[W>>2]|1}p=X+8|0;i=b;return p|0}X=c[151404>>2]|0;if(q>>>0<X>>>0){W=X-q|0;c[151404>>2]=W;X=c[151416>>2]|0;c[151416>>2]=X+q;c[X+(q+4)>>2]=W|1;c[X+4>>2]=q|3;p=X+8|0;i=b;return p|0}do{if((c[37966]|0)==0){X=Zc(30)|0;if((X+ -1&X|0)==0){c[151872>>2]=X;c[151868>>2]=X;c[151876>>2]=-1;c[151880>>2]=-1;c[151884>>2]=0;c[151836>>2]=0;c[37966]=(nc(0)|0)&-16^1431655768;break}else{$c()}}}while(0);X=q+48|0;W=c[151872>>2]|0;M=q+47|0;L=W+M|0;V=0-W|0;W=L&V;if(!(W>>>0>q>>>0)){p=0;i=b;return p|0}U=c[151832>>2]|0;do{if((U|0)!=0){T=c[151824>>2]|0;S=T+W|0;if(S>>>0<=T>>>0|S>>>0>U>>>0){p=0}else{break}i=b;return p|0}}while(0);f:do{if((c[151836>>2]&4|0)==0){U=c[151416>>2]|0;g:do{if((U|0)==0){Y=182}else{S=U;T=151840|0;while(1){Z=T;P=c[Z>>2]|0;if(!(P>>>0>S>>>0)){_=T+4|0;if((P+(c[_>>2]|0)|0)>>>0>S>>>0){break}}P=c[T+8>>2]|0;if((P|0)==0){Y=182;break g}else{T=P}}if((T|0)==0){Y=182;break}S=L-(c[151404>>2]|0)&V;if(!(S>>>0<2147483647)){$=0;break}t=hb(S|0)|0;P=(t|0)==((c[Z>>2]|0)+(c[_>>2]|0)|0);aa=t;ba=S;ca=P?t:-1;da=P?S:0;Y=191}}while(0);do{if((Y|0)==182){U=hb(0)|0;if((U|0)==(-1|0)){$=0;break}S=U;P=c[151868>>2]|0;t=P+ -1|0;if((t&S|0)==0){ea=W}else{ea=W-S+(t+S&0-P)|0}P=c[151824>>2]|0;S=P+ea|0;if(!(ea>>>0>q>>>0&ea>>>0<2147483647)){$=0;break}t=c[151832>>2]|0;if((t|0)!=0){if(S>>>0<=P>>>0|S>>>0>t>>>0){$=0;break}}t=hb(ea|0)|0;S=(t|0)==(U|0);aa=t;ba=ea;ca=S?U:-1;da=S?ea:0;Y=191}}while(0);h:do{if((Y|0)==191){S=0-ba|0;if((ca|0)!=(-1|0)){fa=ca;ga=da;Y=202;break f}do{if((aa|0)!=(-1|0)&ba>>>0<2147483647&ba>>>0<X>>>0){U=c[151872>>2]|0;t=M-ba+U&0-U;if(!(t>>>0<2147483647)){ha=ba;break}if((hb(t|0)|0)==(-1|0)){hb(S|0)|0;$=da;break h}else{ha=t+ba|0;break}}else{ha=ba}}while(0);if((aa|0)==(-1|0)){$=da}else{fa=aa;ga=ha;Y=202;break f}}}while(0);c[151836>>2]=c[151836>>2]|4;ia=$;Y=199}else{ia=0;Y=199}}while(0);do{if((Y|0)==199){if(!(W>>>0<2147483647)){break}$=hb(W|0)|0;ha=hb(0)|0;if(!((ha|0)!=(-1|0)&($|0)!=(-1|0)&$>>>0<ha>>>0)){break}aa=ha-$|0;ha=aa>>>0>(q+40|0)>>>0;if(ha){fa=$;ga=ha?aa:ia;Y=202}}}while(0);do{if((Y|0)==202){ia=(c[151824>>2]|0)+ga|0;c[151824>>2]=ia;if(ia>>>0>(c[151828>>2]|0)>>>0){c[151828>>2]=ia}ia=c[151416>>2]|0;W=151840|0;i:do{if((ia|0)==0){aa=c[151408>>2]|0;if((aa|0)==0|fa>>>0<aa>>>0){c[151408>>2]=fa}c[151840>>2]=fa;c[151844>>2]=ga;c[151852>>2]=0;c[151428>>2]=c[37966];c[151424>>2]=-1;aa=0;do{ha=aa<<1;$=151432+(ha<<2)|0;c[151432+(ha+3<<2)>>2]=$;c[151432+(ha+2<<2)>>2]=$;aa=aa+1|0;}while(aa>>>0<32);aa=fa+8|0;if((aa&7|0)==0){ja=0}else{ja=0-aa&7}aa=ga+ -40-ja|0;c[151416>>2]=fa+ja;c[151404>>2]=aa;c[fa+(ja+4)>>2]=aa|1;c[fa+(ga+ -36)>>2]=40;c[151420>>2]=c[151880>>2]}else{aa=W;while(1){ka=c[aa>>2]|0;la=aa+4|0;ma=c[la>>2]|0;if((fa|0)==(ka+ma|0)){Y=214;break}$=c[aa+8>>2]|0;if(($|0)==0){break}else{aa=$}}do{if((Y|0)==214){if((c[aa+12>>2]&8|0)!=0){break}$=ia;if(!($>>>0>=ka>>>0&$>>>0<fa>>>0)){break}c[la>>2]=ma+ga;$=(c[151404>>2]|0)+ga|0;ha=ia+8|0;if((ha&7|0)==0){na=0}else{na=0-ha&7}ha=$-na|0;c[151416>>2]=ia+na;c[151404>>2]=ha;c[ia+(na+4)>>2]=ha|1;c[ia+($+4)>>2]=40;c[151420>>2]=c[151880>>2];break i}}while(0);if(fa>>>0<(c[151408>>2]|0)>>>0){c[151408>>2]=fa}aa=fa+ga|0;$=151840|0;while(1){oa=$;if((c[oa>>2]|0)==(aa|0)){Y=224;break}ha=c[$+8>>2]|0;if((ha|0)==0){break}else{$=ha}}do{if((Y|0)==224){if((c[$+12>>2]&8|0)!=0){break}c[oa>>2]=fa;aa=$+4|0;c[aa>>2]=(c[aa>>2]|0)+ga;aa=fa+8|0;if((aa&7|0)==0){pa=0}else{pa=0-aa&7}aa=fa+(ga+8)|0;if((aa&7|0)==0){qa=0}else{qa=0-aa&7}aa=fa+(qa+ga)|0;ha=aa;da=pa+q|0;ba=fa+da|0;M=ba;X=aa-(fa+pa)-q|0;c[fa+(pa+4)>>2]=q|3;j:do{if((ha|0)==(c[151416>>2]|0)){ca=(c[151404>>2]|0)+X|0;c[151404>>2]=ca;c[151416>>2]=M;c[fa+(da+4)>>2]=ca|1}else{if((ha|0)==(c[151412>>2]|0)){ca=(c[151400>>2]|0)+X|0;c[151400>>2]=ca;c[151412>>2]=M;c[fa+(da+4)>>2]=ca|1;c[fa+(ca+da)>>2]=ca;break}ca=ga+4|0;ea=c[fa+(ca+qa)>>2]|0;if((ea&3|0)==1){_=ea&-8;Z=ea>>>3;k:do{if(ea>>>0<256){V=c[fa+((qa|8)+ga)>>2]|0;L=c[fa+(ga+12+qa)>>2]|0;S=151432+(Z<<1<<2)|0;do{if((V|0)!=(S|0)){if(V>>>0<(c[151408>>2]|0)>>>0){$c()}if((c[V+12>>2]|0)==(ha|0)){break}$c()}}while(0);if((L|0)==(V|0)){c[37848]=c[37848]&~(1<<Z);break}do{if((L|0)==(S|0)){ra=L+8|0}else{if(L>>>0<(c[151408>>2]|0)>>>0){$c()}T=L+8|0;if((c[T>>2]|0)==(ha|0)){ra=T;break}$c()}}while(0);c[V+12>>2]=L;c[ra>>2]=V}else{S=aa;T=c[fa+((qa|24)+ga)>>2]|0;t=c[fa+(ga+12+qa)>>2]|0;do{if((t|0)==(S|0)){U=qa|16;P=fa+(ca+U)|0;Q=P;R=c[P>>2]|0;if((R|0)==0){P=fa+(U+ga)|0;U=c[P>>2]|0;if((U|0)==0){sa=0;break}else{ta=U;ua=P}}else{ta=R;ua=Q}while(1){Q=ta+20|0;R=c[Q>>2]|0;if((R|0)!=0){ua=Q;ta=R;continue}R=ta+16|0;Q=c[R>>2]|0;if((Q|0)==0){break}else{ta=Q;ua=R}}if(ua>>>0<(c[151408>>2]|0)>>>0){$c()}else{c[ua>>2]=0;sa=ta;break}}else{R=c[fa+((qa|8)+ga)>>2]|0;if(R>>>0<(c[151408>>2]|0)>>>0){$c()}Q=R+12|0;if((c[Q>>2]|0)!=(S|0)){$c()}P=t+8|0;if((c[P>>2]|0)==(S|0)){c[Q>>2]=t;c[P>>2]=R;sa=t;break}else{$c()}}}while(0);if((T|0)==0){break}t=c[fa+(ga+28+qa)>>2]|0;V=151696+(t<<2)|0;do{if((S|0)==(c[V>>2]|0)){c[V>>2]=sa;if((sa|0)!=0){break}c[151396>>2]=c[151396>>2]&~(1<<t);break k}else{if(T>>>0<(c[151408>>2]|0)>>>0){$c()}L=T+16|0;if((c[L>>2]|0)==(S|0)){c[L>>2]=sa}else{c[T+20>>2]=sa}if((sa|0)==0){break k}}}while(0);if(sa>>>0<(c[151408>>2]|0)>>>0){$c()}c[sa+24>>2]=T;S=qa|16;t=c[fa+(S+ga)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[151408>>2]|0)>>>0){$c()}else{c[sa+16>>2]=t;c[t+24>>2]=sa;break}}}while(0);t=c[fa+(ca+S)>>2]|0;if((t|0)==0){break}if(t>>>0<(c[151408>>2]|0)>>>0){$c()}else{c[sa+20>>2]=t;c[t+24>>2]=sa;break}}}while(0);va=fa+((_|qa)+ga)|0;wa=_+X|0}else{va=ha;wa=X}ca=va+4|0;c[ca>>2]=c[ca>>2]&-2;c[fa+(da+4)>>2]=wa|1;c[fa+(wa+da)>>2]=wa;ca=wa>>>3;if(wa>>>0<256){Z=ca<<1;ea=151432+(Z<<2)|0;t=c[37848]|0;T=1<<ca;do{if((t&T|0)==0){c[37848]=t|T;xa=151432+(Z+2<<2)|0;ya=ea}else{ca=151432+(Z+2<<2)|0;V=c[ca>>2]|0;if(!(V>>>0<(c[151408>>2]|0)>>>0)){xa=ca;ya=V;break}$c()}}while(0);c[xa>>2]=M;c[ya+12>>2]=M;c[fa+(da+8)>>2]=ya;c[fa+(da+12)>>2]=ea;break}Z=ba;T=wa>>>8;do{if((T|0)==0){za=0}else{if(wa>>>0>16777215){za=31;break}t=(T+1048320|0)>>>16&8;_=T<<t;V=(_+520192|0)>>>16&4;ca=_<<V;_=(ca+245760|0)>>>16&2;L=14-(V|t|_)+(ca<<_>>>15)|0;za=wa>>>(L+7|0)&1|L<<1}}while(0);T=151696+(za<<2)|0;c[fa+(da+28)>>2]=za;c[fa+(da+20)>>2]=0;c[fa+(da+16)>>2]=0;ea=c[151396>>2]|0;L=1<<za;if((ea&L|0)==0){c[151396>>2]=ea|L;c[T>>2]=Z;c[fa+(da+24)>>2]=T;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break}L=c[T>>2]|0;if((za|0)==31){Aa=0}else{Aa=25-(za>>>1)|0}l:do{if((c[L+4>>2]&-8|0)==(wa|0)){Ba=L}else{T=wa<<Aa;ea=L;while(1){Ca=ea+16+(T>>>31<<2)|0;_=c[Ca>>2]|0;if((_|0)==0){break}if((c[_+4>>2]&-8|0)==(wa|0)){Ba=_;break l}else{T=T<<1;ea=_}}if(Ca>>>0<(c[151408>>2]|0)>>>0){$c()}else{c[Ca>>2]=Z;c[fa+(da+24)>>2]=ea;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break j}}}while(0);L=Ba+8|0;T=c[L>>2]|0;S=c[151408>>2]|0;if(Ba>>>0<S>>>0){$c()}if(T>>>0<S>>>0){$c()}else{c[T+12>>2]=Z;c[L>>2]=Z;c[fa+(da+8)>>2]=T;c[fa+(da+12)>>2]=Ba;c[fa+(da+24)>>2]=0;break}}}while(0);p=fa+(pa|8)|0;i=b;return p|0}}while(0);$=ia;da=151840|0;while(1){Da=c[da>>2]|0;if(!(Da>>>0>$>>>0)){Ea=c[da+4>>2]|0;Fa=Da+Ea|0;if(Fa>>>0>$>>>0){break}}da=c[da+8>>2]|0}da=Da+(Ea+ -39)|0;if((da&7|0)==0){Ga=0}else{Ga=0-da&7}da=Da+(Ea+ -47+Ga)|0;ba=da>>>0<(ia+16|0)>>>0?$:da;da=ba+8|0;M=da;X=fa+8|0;if((X&7|0)==0){Ha=0}else{Ha=0-X&7}X=ga+ -40-Ha|0;c[151416>>2]=fa+Ha;c[151404>>2]=X;c[fa+(Ha+4)>>2]=X|1;c[fa+(ga+ -36)>>2]=40;c[151420>>2]=c[151880>>2];c[ba+4>>2]=27;X=151840|0;c[da+0>>2]=c[X+0>>2];c[da+4>>2]=c[X+4>>2];c[da+8>>2]=c[X+8>>2];c[da+12>>2]=c[X+12>>2];c[151840>>2]=fa;c[151844>>2]=ga;c[151852>>2]=0;c[151848>>2]=M;M=ba+28|0;c[M>>2]=7;if((ba+32|0)>>>0<Fa>>>0){X=M;while(1){M=X+4|0;c[M>>2]=7;if((X+8|0)>>>0<Fa>>>0){X=M}else{break}}}if((ba|0)==($|0)){break}X=ba-ia|0;M=ia+(X+4)|0;c[M>>2]=c[M>>2]&-2;c[ia+4>>2]=X|1;c[ia+X>>2]=X;M=X>>>3;if(X>>>0<256){da=M<<1;ha=151432+(da<<2)|0;aa=c[37848]|0;f=1<<M;do{if((aa&f|0)==0){c[37848]=aa|f;Ia=151432+(da+2<<2)|0;Ja=ha}else{M=151432+(da+2<<2)|0;T=c[M>>2]|0;if(!(T>>>0<(c[151408>>2]|0)>>>0)){Ia=M;Ja=T;break}$c()}}while(0);c[Ia>>2]=ia;c[Ja+12>>2]=ia;c[ia+8>>2]=Ja;c[ia+12>>2]=ha;break}da=ia;f=X>>>8;do{if((f|0)==0){Ka=0}else{if(X>>>0>16777215){Ka=31;break}aa=(f+1048320|0)>>>16&8;ba=f<<aa;$=(ba+520192|0)>>>16&4;T=ba<<$;ba=(T+245760|0)>>>16&2;M=14-($|aa|ba)+(T<<ba>>>15)|0;Ka=X>>>(M+7|0)&1|M<<1}}while(0);f=151696+(Ka<<2)|0;c[ia+28>>2]=Ka;c[ia+20>>2]=0;c[ia+16>>2]=0;ha=c[151396>>2]|0;M=1<<Ka;if((ha&M|0)==0){c[151396>>2]=ha|M;c[f>>2]=da;c[ia+24>>2]=f;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break}M=c[f>>2]|0;if((Ka|0)==31){La=0}else{La=25-(Ka>>>1)|0}m:do{if((c[M+4>>2]&-8|0)==(X|0)){Ma=M}else{f=X<<La;ha=M;while(1){Na=ha+16+(f>>>31<<2)|0;ba=c[Na>>2]|0;if((ba|0)==0){break}if((c[ba+4>>2]&-8|0)==(X|0)){Ma=ba;break m}else{f=f<<1;ha=ba}}if(Na>>>0<(c[151408>>2]|0)>>>0){$c()}else{c[Na>>2]=da;c[ia+24>>2]=ha;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break i}}}while(0);X=Ma+8|0;M=c[X>>2]|0;f=c[151408>>2]|0;if(Ma>>>0<f>>>0){$c()}if(M>>>0<f>>>0){$c()}else{c[M+12>>2]=da;c[X>>2]=da;c[ia+8>>2]=M;c[ia+12>>2]=Ma;c[ia+24>>2]=0;break}}}while(0);ia=c[151404>>2]|0;if(!(ia>>>0>q>>>0)){break}W=ia-q|0;c[151404>>2]=W;ia=c[151416>>2]|0;c[151416>>2]=ia+q;c[ia+(q+4)>>2]=W|1;c[ia+4>>2]=q|3;p=ia+8|0;i=b;return p|0}}while(0);c[(Ic()|0)>>2]=12;p=0;i=b;return p|0}function AY(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=i;if((a|0)==0){i=b;return}d=a+ -8|0;e=d;f=c[151408>>2]|0;if(d>>>0<f>>>0){$c()}g=c[a+ -4>>2]|0;h=g&3;if((h|0)==1){$c()}j=g&-8;k=a+(j+ -8)|0;l=k;a:do{if((g&1|0)==0){m=c[d>>2]|0;if((h|0)==0){i=b;return}n=-8-m|0;o=a+n|0;p=o;q=m+j|0;if(o>>>0<f>>>0){$c()}if((p|0)==(c[151412>>2]|0)){r=a+(j+ -4)|0;if((c[r>>2]&3|0)!=3){s=p;t=q;break}c[151400>>2]=q;c[r>>2]=c[r>>2]&-2;c[a+(n+4)>>2]=q|1;c[k>>2]=q;i=b;return}r=m>>>3;if(m>>>0<256){m=c[a+(n+8)>>2]|0;u=c[a+(n+12)>>2]|0;v=151432+(r<<1<<2)|0;do{if((m|0)!=(v|0)){if(m>>>0<f>>>0){$c()}if((c[m+12>>2]|0)==(p|0)){break}$c()}}while(0);if((u|0)==(m|0)){c[37848]=c[37848]&~(1<<r);s=p;t=q;break}do{if((u|0)==(v|0)){w=u+8|0}else{if(u>>>0<f>>>0){$c()}x=u+8|0;if((c[x>>2]|0)==(p|0)){w=x;break}$c()}}while(0);c[m+12>>2]=u;c[w>>2]=m;s=p;t=q;break}v=o;r=c[a+(n+24)>>2]|0;x=c[a+(n+12)>>2]|0;do{if((x|0)==(v|0)){y=a+(n+20)|0;z=y;A=c[y>>2]|0;if((A|0)==0){y=a+(n+16)|0;B=c[y>>2]|0;if((B|0)==0){C=0;break}else{D=B;E=y}}else{D=A;E=z}while(1){z=D+20|0;A=c[z>>2]|0;if((A|0)!=0){E=z;D=A;continue}A=D+16|0;z=c[A>>2]|0;if((z|0)==0){break}else{D=z;E=A}}if(E>>>0<f>>>0){$c()}else{c[E>>2]=0;C=D;break}}else{A=c[a+(n+8)>>2]|0;if(A>>>0<f>>>0){$c()}z=A+12|0;if((c[z>>2]|0)!=(v|0)){$c()}y=x+8|0;if((c[y>>2]|0)==(v|0)){c[z>>2]=x;c[y>>2]=A;C=x;break}else{$c()}}}while(0);if((r|0)==0){s=p;t=q;break}x=c[a+(n+28)>>2]|0;o=151696+(x<<2)|0;do{if((v|0)==(c[o>>2]|0)){c[o>>2]=C;if((C|0)!=0){break}c[151396>>2]=c[151396>>2]&~(1<<x);s=p;t=q;break a}else{if(r>>>0<(c[151408>>2]|0)>>>0){$c()}m=r+16|0;if((c[m>>2]|0)==(v|0)){c[m>>2]=C}else{c[r+20>>2]=C}if((C|0)==0){s=p;t=q;break a}}}while(0);if(C>>>0<(c[151408>>2]|0)>>>0){$c()}c[C+24>>2]=r;v=c[a+(n+16)>>2]|0;do{if((v|0)!=0){if(v>>>0<(c[151408>>2]|0)>>>0){$c()}else{c[C+16>>2]=v;c[v+24>>2]=C;break}}}while(0);v=c[a+(n+20)>>2]|0;if((v|0)==0){s=p;t=q;break}if(v>>>0<(c[151408>>2]|0)>>>0){$c()}else{c[C+20>>2]=v;c[v+24>>2]=C;s=p;t=q;break}}else{s=e;t=j}}while(0);if(!(s>>>0<k>>>0)){$c()}e=a+(j+ -4)|0;C=c[e>>2]|0;if((C&1|0)==0){$c()}do{if((C&2|0)==0){if((l|0)==(c[151416>>2]|0)){f=(c[151404>>2]|0)+t|0;c[151404>>2]=f;c[151416>>2]=s;c[s+4>>2]=f|1;if((s|0)!=(c[151412>>2]|0)){i=b;return}c[151412>>2]=0;c[151400>>2]=0;i=b;return}if((l|0)==(c[151412>>2]|0)){f=(c[151400>>2]|0)+t|0;c[151400>>2]=f;c[151412>>2]=s;c[s+4>>2]=f|1;c[s+f>>2]=f;i=b;return}f=(C&-8)+t|0;D=C>>>3;b:do{if(C>>>0<256){E=c[a+j>>2]|0;w=c[a+(j|4)>>2]|0;h=151432+(D<<1<<2)|0;do{if((E|0)!=(h|0)){if(E>>>0<(c[151408>>2]|0)>>>0){$c()}if((c[E+12>>2]|0)==(l|0)){break}$c()}}while(0);if((w|0)==(E|0)){c[37848]=c[37848]&~(1<<D);break}do{if((w|0)==(h|0)){F=w+8|0}else{if(w>>>0<(c[151408>>2]|0)>>>0){$c()}d=w+8|0;if((c[d>>2]|0)==(l|0)){F=d;break}$c()}}while(0);c[E+12>>2]=w;c[F>>2]=E}else{h=k;d=c[a+(j+16)>>2]|0;g=c[a+(j|4)>>2]|0;do{if((g|0)==(h|0)){v=a+(j+12)|0;r=v;x=c[v>>2]|0;if((x|0)==0){v=a+(j+8)|0;o=c[v>>2]|0;if((o|0)==0){G=0;break}else{H=o;I=v}}else{H=x;I=r}while(1){r=H+20|0;x=c[r>>2]|0;if((x|0)!=0){I=r;H=x;continue}x=H+16|0;r=c[x>>2]|0;if((r|0)==0){break}else{H=r;I=x}}if(I>>>0<(c[151408>>2]|0)>>>0){$c()}else{c[I>>2]=0;G=H;break}}else{x=c[a+j>>2]|0;if(x>>>0<(c[151408>>2]|0)>>>0){$c()}r=x+12|0;if((c[r>>2]|0)!=(h|0)){$c()}v=g+8|0;if((c[v>>2]|0)==(h|0)){c[r>>2]=g;c[v>>2]=x;G=g;break}else{$c()}}}while(0);if((d|0)==0){break}g=c[a+(j+20)>>2]|0;E=151696+(g<<2)|0;do{if((h|0)==(c[E>>2]|0)){c[E>>2]=G;if((G|0)!=0){break}c[151396>>2]=c[151396>>2]&~(1<<g);break b}else{if(d>>>0<(c[151408>>2]|0)>>>0){$c()}w=d+16|0;if((c[w>>2]|0)==(h|0)){c[w>>2]=G}else{c[d+20>>2]=G}if((G|0)==0){break b}}}while(0);if(G>>>0<(c[151408>>2]|0)>>>0){$c()}c[G+24>>2]=d;h=c[a+(j+8)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[151408>>2]|0)>>>0){$c()}else{c[G+16>>2]=h;c[h+24>>2]=G;break}}}while(0);h=c[a+(j+12)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[151408>>2]|0)>>>0){$c()}else{c[G+20>>2]=h;c[h+24>>2]=G;break}}}while(0);c[s+4>>2]=f|1;c[s+f>>2]=f;if((s|0)!=(c[151412>>2]|0)){J=f;break}c[151400>>2]=f;i=b;return}else{c[e>>2]=C&-2;c[s+4>>2]=t|1;c[s+t>>2]=t;J=t}}while(0);t=J>>>3;if(J>>>0<256){C=t<<1;e=151432+(C<<2)|0;G=c[37848]|0;j=1<<t;do{if((G&j|0)==0){c[37848]=G|j;K=151432+(C+2<<2)|0;L=e}else{t=151432+(C+2<<2)|0;a=c[t>>2]|0;if(!(a>>>0<(c[151408>>2]|0)>>>0)){K=t;L=a;break}$c()}}while(0);c[K>>2]=s;c[L+12>>2]=s;c[s+8>>2]=L;c[s+12>>2]=e;i=b;return}e=s;L=J>>>8;do{if((L|0)==0){M=0}else{if(J>>>0>16777215){M=31;break}K=(L+1048320|0)>>>16&8;C=L<<K;j=(C+520192|0)>>>16&4;G=C<<j;C=(G+245760|0)>>>16&2;a=14-(j|K|C)+(G<<C>>>15)|0;M=J>>>(a+7|0)&1|a<<1}}while(0);L=151696+(M<<2)|0;c[s+28>>2]=M;c[s+20>>2]=0;c[s+16>>2]=0;a=c[151396>>2]|0;C=1<<M;c:do{if((a&C|0)==0){c[151396>>2]=a|C;c[L>>2]=e;c[s+24>>2]=L;c[s+12>>2]=s;c[s+8>>2]=s}else{G=c[L>>2]|0;if((M|0)==31){N=0}else{N=25-(M>>>1)|0}d:do{if((c[G+4>>2]&-8|0)==(J|0)){O=G}else{K=J<<N;j=G;while(1){P=j+16+(K>>>31<<2)|0;t=c[P>>2]|0;if((t|0)==0){break}if((c[t+4>>2]&-8|0)==(J|0)){O=t;break d}else{K=K<<1;j=t}}if(P>>>0<(c[151408>>2]|0)>>>0){$c()}else{c[P>>2]=e;c[s+24>>2]=j;c[s+12>>2]=s;c[s+8>>2]=s;break c}}}while(0);G=O+8|0;f=c[G>>2]|0;K=c[151408>>2]|0;if(O>>>0<K>>>0){$c()}if(f>>>0<K>>>0){$c()}else{c[f+12>>2]=e;c[G>>2]=e;c[s+8>>2]=f;c[s+12>>2]=O;c[s+24>>2]=0;break}}}while(0);s=(c[151424>>2]|0)+ -1|0;c[151424>>2]=s;if((s|0)==0){Q=151848|0}else{i=b;return}while(1){s=c[Q>>2]|0;if((s|0)==0){break}else{Q=s+8|0}}c[151424>>2]=-1;i=b;return}function BY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{if((a|0)==0){e=0}else{f=fa(b,a)|0;if(!((b|a)>>>0>65535)){e=f;break}e=((f>>>0)/(a>>>0)|0|0)==(b|0)?f:-1}}while(0);b=zY(e)|0;if((b|0)==0){i=d;return b|0}if((c[b+ -4>>2]&3|0)==0){i=d;return b|0}fZ(b|0,0,e|0)|0;i=d;return b|0}function CY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if((a|0)==0){e=zY(b)|0;i=d;return e|0}if(b>>>0>4294967231){c[(Ic()|0)>>2]=12;e=0;i=d;return e|0}if(b>>>0<11){f=16}else{f=b+11&-8}g=DY(a+ -8|0,f)|0;if((g|0)!=0){e=g+8|0;i=d;return e|0}g=zY(b)|0;if((g|0)==0){e=0;i=d;return e|0}f=c[a+ -4>>2]|0;h=(f&-8)-((f&3|0)==0?8:4)|0;dZ(g|0,a|0,(h>>>0<b>>>0?h:b)|0)|0;AY(a);e=g;i=d;return e|0}function DY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a;j=a+g|0;k=j;l=c[151408>>2]|0;if(h>>>0<l>>>0){$c()}m=f&3;if(!((m|0)!=1&h>>>0<j>>>0)){$c()}h=a+(g|4)|0;n=c[h>>2]|0;if((n&1|0)==0){$c()}if((m|0)==0){if(b>>>0<256){o=0;i=d;return o|0}do{if(!(g>>>0<(b+4|0)>>>0)){if((g-b|0)>>>0>c[151872>>2]<<1>>>0){break}else{o=a}i=d;return o|0}}while(0);o=0;i=d;return o|0}if(!(g>>>0<b>>>0)){m=g-b|0;if(!(m>>>0>15)){o=a;i=d;return o|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|3;c[h>>2]=c[h>>2]|1;EY(a+b|0,m);o=a;i=d;return o|0}if((k|0)==(c[151416>>2]|0)){m=(c[151404>>2]|0)+g|0;if(!(m>>>0>b>>>0)){o=0;i=d;return o|0}h=m-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=h|1;c[151416>>2]=a+b;c[151404>>2]=h;o=a;i=d;return o|0}if((k|0)==(c[151412>>2]|0)){h=(c[151400>>2]|0)+g|0;if(h>>>0<b>>>0){o=0;i=d;return o|0}m=h-b|0;if(m>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|1;c[a+h>>2]=m;p=a+(h+4)|0;c[p>>2]=c[p>>2]&-2;q=a+b|0;r=m}else{c[e>>2]=f&1|h|2;f=a+(h+4)|0;c[f>>2]=c[f>>2]|1;q=0;r=0}c[151400>>2]=r;c[151412>>2]=q;o=a;i=d;return o|0}if((n&2|0)!=0){o=0;i=d;return o|0}q=(n&-8)+g|0;if(q>>>0<b>>>0){o=0;i=d;return o|0}r=q-b|0;f=n>>>3;a:do{if(n>>>0<256){h=c[a+(g+8)>>2]|0;m=c[a+(g+12)>>2]|0;p=151432+(f<<1<<2)|0;do{if((h|0)!=(p|0)){if(h>>>0<l>>>0){$c()}if((c[h+12>>2]|0)==(k|0)){break}$c()}}while(0);if((m|0)==(h|0)){c[37848]=c[37848]&~(1<<f);break}do{if((m|0)==(p|0)){s=m+8|0}else{if(m>>>0<l>>>0){$c()}t=m+8|0;if((c[t>>2]|0)==(k|0)){s=t;break}$c()}}while(0);c[h+12>>2]=m;c[s>>2]=h}else{p=j;t=c[a+(g+24)>>2]|0;u=c[a+(g+12)>>2]|0;do{if((u|0)==(p|0)){v=a+(g+20)|0;w=v;x=c[v>>2]|0;if((x|0)==0){v=a+(g+16)|0;y=c[v>>2]|0;if((y|0)==0){z=0;break}else{A=y;B=v}}else{A=x;B=w}while(1){w=A+20|0;x=c[w>>2]|0;if((x|0)!=0){B=w;A=x;continue}x=A+16|0;w=c[x>>2]|0;if((w|0)==0){break}else{A=w;B=x}}if(B>>>0<l>>>0){$c()}else{c[B>>2]=0;z=A;break}}else{x=c[a+(g+8)>>2]|0;if(x>>>0<l>>>0){$c()}w=x+12|0;if((c[w>>2]|0)!=(p|0)){$c()}v=u+8|0;if((c[v>>2]|0)==(p|0)){c[w>>2]=u;c[v>>2]=x;z=u;break}else{$c()}}}while(0);if((t|0)==0){break}u=c[a+(g+28)>>2]|0;h=151696+(u<<2)|0;do{if((p|0)==(c[h>>2]|0)){c[h>>2]=z;if((z|0)!=0){break}c[151396>>2]=c[151396>>2]&~(1<<u);break a}else{if(t>>>0<(c[151408>>2]|0)>>>0){$c()}m=t+16|0;if((c[m>>2]|0)==(p|0)){c[m>>2]=z}else{c[t+20>>2]=z}if((z|0)==0){break a}}}while(0);if(z>>>0<(c[151408>>2]|0)>>>0){$c()}c[z+24>>2]=t;p=c[a+(g+16)>>2]|0;do{if((p|0)!=0){if(p>>>0<(c[151408>>2]|0)>>>0){$c()}else{c[z+16>>2]=p;c[p+24>>2]=z;break}}}while(0);p=c[a+(g+20)>>2]|0;if((p|0)==0){break}if(p>>>0<(c[151408>>2]|0)>>>0){$c()}else{c[z+20>>2]=p;c[p+24>>2]=z;break}}}while(0);if(r>>>0<16){c[e>>2]=q|c[e>>2]&1|2;z=a+(q|4)|0;c[z>>2]=c[z>>2]|1;o=a;i=d;return o|0}else{c[e>>2]=c[e>>2]&1|b|2;c[a+(b+4)>>2]=r|3;e=a+(q|4)|0;c[e>>2]=c[e>>2]|1;EY(a+b|0,r);o=a;i=d;return o|0}return 0}function EY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+b|0;f=e;g=c[a+4>>2]|0;a:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){i=d;return}j=a+(0-h)|0;k=j;l=h+b|0;m=c[151408>>2]|0;if(j>>>0<m>>>0){$c()}if((k|0)==(c[151412>>2]|0)){n=a+(b+4)|0;if((c[n>>2]&3|0)!=3){o=k;p=l;break}c[151400>>2]=l;c[n>>2]=c[n>>2]&-2;c[a+(4-h)>>2]=l|1;c[e>>2]=l;i=d;return}n=h>>>3;if(h>>>0<256){q=c[a+(8-h)>>2]|0;r=c[a+(12-h)>>2]|0;s=151432+(n<<1<<2)|0;do{if((q|0)!=(s|0)){if(q>>>0<m>>>0){$c()}if((c[q+12>>2]|0)==(k|0)){break}$c()}}while(0);if((r|0)==(q|0)){c[37848]=c[37848]&~(1<<n);o=k;p=l;break}do{if((r|0)==(s|0)){t=r+8|0}else{if(r>>>0<m>>>0){$c()}u=r+8|0;if((c[u>>2]|0)==(k|0)){t=u;break}$c()}}while(0);c[q+12>>2]=r;c[t>>2]=q;o=k;p=l;break}s=j;n=c[a+(24-h)>>2]|0;u=c[a+(12-h)>>2]|0;do{if((u|0)==(s|0)){v=16-h|0;w=a+(v+4)|0;x=w;y=c[w>>2]|0;if((y|0)==0){w=a+v|0;v=c[w>>2]|0;if((v|0)==0){z=0;break}else{A=v;B=w}}else{A=y;B=x}while(1){x=A+20|0;y=c[x>>2]|0;if((y|0)!=0){B=x;A=y;continue}y=A+16|0;x=c[y>>2]|0;if((x|0)==0){break}else{A=x;B=y}}if(B>>>0<m>>>0){$c()}else{c[B>>2]=0;z=A;break}}else{y=c[a+(8-h)>>2]|0;if(y>>>0<m>>>0){$c()}x=y+12|0;if((c[x>>2]|0)!=(s|0)){$c()}w=u+8|0;if((c[w>>2]|0)==(s|0)){c[x>>2]=u;c[w>>2]=y;z=u;break}else{$c()}}}while(0);if((n|0)==0){o=k;p=l;break}u=c[a+(28-h)>>2]|0;m=151696+(u<<2)|0;do{if((s|0)==(c[m>>2]|0)){c[m>>2]=z;if((z|0)!=0){break}c[151396>>2]=c[151396>>2]&~(1<<u);o=k;p=l;break a}else{if(n>>>0<(c[151408>>2]|0)>>>0){$c()}j=n+16|0;if((c[j>>2]|0)==(s|0)){c[j>>2]=z}else{c[n+20>>2]=z}if((z|0)==0){o=k;p=l;break a}}}while(0);if(z>>>0<(c[151408>>2]|0)>>>0){$c()}c[z+24>>2]=n;s=16-h|0;u=c[a+s>>2]|0;do{if((u|0)!=0){if(u>>>0<(c[151408>>2]|0)>>>0){$c()}else{c[z+16>>2]=u;c[u+24>>2]=z;break}}}while(0);u=c[a+(s+4)>>2]|0;if((u|0)==0){o=k;p=l;break}if(u>>>0<(c[151408>>2]|0)>>>0){$c()}else{c[z+20>>2]=u;c[u+24>>2]=z;o=k;p=l;break}}else{o=a;p=b}}while(0);z=c[151408>>2]|0;if(e>>>0<z>>>0){$c()}A=a+(b+4)|0;B=c[A>>2]|0;do{if((B&2|0)==0){if((f|0)==(c[151416>>2]|0)){t=(c[151404>>2]|0)+p|0;c[151404>>2]=t;c[151416>>2]=o;c[o+4>>2]=t|1;if((o|0)!=(c[151412>>2]|0)){i=d;return}c[151412>>2]=0;c[151400>>2]=0;i=d;return}if((f|0)==(c[151412>>2]|0)){t=(c[151400>>2]|0)+p|0;c[151400>>2]=t;c[151412>>2]=o;c[o+4>>2]=t|1;c[o+t>>2]=t;i=d;return}t=(B&-8)+p|0;g=B>>>3;b:do{if(B>>>0<256){u=c[a+(b+8)>>2]|0;h=c[a+(b+12)>>2]|0;n=151432+(g<<1<<2)|0;do{if((u|0)!=(n|0)){if(u>>>0<z>>>0){$c()}if((c[u+12>>2]|0)==(f|0)){break}$c()}}while(0);if((h|0)==(u|0)){c[37848]=c[37848]&~(1<<g);break}do{if((h|0)==(n|0)){C=h+8|0}else{if(h>>>0<z>>>0){$c()}m=h+8|0;if((c[m>>2]|0)==(f|0)){C=m;break}$c()}}while(0);c[u+12>>2]=h;c[C>>2]=u}else{n=e;m=c[a+(b+24)>>2]|0;j=c[a+(b+12)>>2]|0;do{if((j|0)==(n|0)){q=a+(b+20)|0;r=q;y=c[q>>2]|0;if((y|0)==0){q=a+(b+16)|0;w=c[q>>2]|0;if((w|0)==0){D=0;break}else{E=w;F=q}}else{E=y;F=r}while(1){r=E+20|0;y=c[r>>2]|0;if((y|0)!=0){F=r;E=y;continue}y=E+16|0;r=c[y>>2]|0;if((r|0)==0){break}else{E=r;F=y}}if(F>>>0<z>>>0){$c()}else{c[F>>2]=0;D=E;break}}else{y=c[a+(b+8)>>2]|0;if(y>>>0<z>>>0){$c()}r=y+12|0;if((c[r>>2]|0)!=(n|0)){$c()}q=j+8|0;if((c[q>>2]|0)==(n|0)){c[r>>2]=j;c[q>>2]=y;D=j;break}else{$c()}}}while(0);if((m|0)==0){break}j=c[a+(b+28)>>2]|0;u=151696+(j<<2)|0;do{if((n|0)==(c[u>>2]|0)){c[u>>2]=D;if((D|0)!=0){break}c[151396>>2]=c[151396>>2]&~(1<<j);break b}else{if(m>>>0<(c[151408>>2]|0)>>>0){$c()}h=m+16|0;if((c[h>>2]|0)==(n|0)){c[h>>2]=D}else{c[m+20>>2]=D}if((D|0)==0){break b}}}while(0);if(D>>>0<(c[151408>>2]|0)>>>0){$c()}c[D+24>>2]=m;n=c[a+(b+16)>>2]|0;do{if((n|0)!=0){if(n>>>0<(c[151408>>2]|0)>>>0){$c()}else{c[D+16>>2]=n;c[n+24>>2]=D;break}}}while(0);n=c[a+(b+20)>>2]|0;if((n|0)==0){break}if(n>>>0<(c[151408>>2]|0)>>>0){$c()}else{c[D+20>>2]=n;c[n+24>>2]=D;break}}}while(0);c[o+4>>2]=t|1;c[o+t>>2]=t;if((o|0)!=(c[151412>>2]|0)){G=t;break}c[151400>>2]=t;i=d;return}else{c[A>>2]=B&-2;c[o+4>>2]=p|1;c[o+p>>2]=p;G=p}}while(0);p=G>>>3;if(G>>>0<256){B=p<<1;A=151432+(B<<2)|0;D=c[37848]|0;b=1<<p;do{if((D&b|0)==0){c[37848]=D|b;H=151432+(B+2<<2)|0;I=A}else{p=151432+(B+2<<2)|0;a=c[p>>2]|0;if(!(a>>>0<(c[151408>>2]|0)>>>0)){H=p;I=a;break}$c()}}while(0);c[H>>2]=o;c[I+12>>2]=o;c[o+8>>2]=I;c[o+12>>2]=A;i=d;return}A=o;I=G>>>8;do{if((I|0)==0){J=0}else{if(G>>>0>16777215){J=31;break}H=(I+1048320|0)>>>16&8;B=I<<H;b=(B+520192|0)>>>16&4;D=B<<b;B=(D+245760|0)>>>16&2;a=14-(b|H|B)+(D<<B>>>15)|0;J=G>>>(a+7|0)&1|a<<1}}while(0);I=151696+(J<<2)|0;c[o+28>>2]=J;c[o+20>>2]=0;c[o+16>>2]=0;a=c[151396>>2]|0;B=1<<J;if((a&B|0)==0){c[151396>>2]=a|B;c[I>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}B=c[I>>2]|0;if((J|0)==31){K=0}else{K=25-(J>>>1)|0}c:do{if((c[B+4>>2]&-8|0)==(G|0)){L=B}else{J=G<<K;I=B;while(1){M=I+16+(J>>>31<<2)|0;a=c[M>>2]|0;if((a|0)==0){break}if((c[a+4>>2]&-8|0)==(G|0)){L=a;break c}else{J=J<<1;I=a}}if(M>>>0<(c[151408>>2]|0)>>>0){$c()}c[M>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}}while(0);M=L+8|0;G=c[M>>2]|0;B=c[151408>>2]|0;if(L>>>0<B>>>0){$c()}if(G>>>0<B>>>0){$c()}c[G+12>>2]=A;c[M>>2]=A;c[o+8>>2]=G;c[o+12>>2]=L;c[o+24>>2]=0;i=d;return}function FY(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(a|0)==0?1:a;while(1){e=zY(d)|0;if((e|0)!=0){f=6;break}a=c[37972]|0;c[37972]=0+a;if((a|0)==0){f=5;break}se[a&7]()}if((f|0)==5){d=zc(4)|0;c[d>>2]=151904;Hd(d|0,151952,135)}else if((f|0)==6){i=b;return e|0}return 0}function GY(a){a=a|0;var b=0,c=0;b=i;c=FY(a)|0;i=b;return c|0}function HY(a){a=a|0;var b=0;b=i;if((a|0)!=0){AY(a)}i=b;return}function IY(a){a=a|0;var b=0;b=i;HY(a);i=b;return}function JY(a){a=a|0;var b=0;b=i;wb(a|0);HY(a);i=b;return}function KY(a){a=a|0;var b=0;b=i;wb(a|0);i=b;return}function LY(a){a=a|0;i=i;return 151920}function MY(){var a=0;a=zc(4)|0;c[a>>2]=151904;Hd(a|0,151952,135)}function NY(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0.0,tc=0,vc=0,wc=0.0,xc=0.0,yc=0.0,zc=0.0,Ac=0.0,Bc=0.0,Cc=0,Dc=0,Ec=0.0,Fc=0,Gc=0.0,Hc=0,Jc=0,Kc=0,Lc=0,Mc=0;g=i;i=i+512|0;h=g;if((e|0)==0){j=24;k=-149}else if((e|0)==1){j=53;k=-1074}else if((e|0)==2){j=53;k=-1074}else{l=0.0;i=g;return+l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n]|0}else{o=QY(b)|0}}while((bd(o|0)|0)!=0);do{if((o|0)==43|(o|0)==45){n=1-(((o|0)==45)<<1)|0;p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;q=d[p]|0;r=n;break}else{q=QY(b)|0;r=n;break}}else{q=o;r=1}}while(0);o=q;q=0;while(1){if((o|32|0)!=(a[151968+q|0]|0)){s=o;t=q;break}do{if(q>>>0<7){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;u=d[n]|0;break}else{u=QY(b)|0;break}}else{u=o}}while(0);n=q+1|0;if(n>>>0<8){o=u;q=n}else{s=u;t=n;break}}do{if((t|0)==3){v=23}else if((t|0)!=8){u=(f|0)==0;if(!(t>>>0<4|u)){if((t|0)==8){break}else{v=23;break}}a:do{if((t|0)==0){q=s;o=0;while(1){if((q|32|0)!=(a[151984+o|0]|0)){w=q;x=o;break a}do{if(o>>>0<2){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;A=d[n]|0;break}else{A=QY(b)|0;break}}else{A=q}}while(0);n=o+1|0;if(n>>>0<3){q=A;o=n}else{w=A;x=n;break}}}else{w=s;x=t}}while(0);if((x|0)==0){do{if((w|0)==48){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;B=d[o]|0}else{B=QY(b)|0}if((B|32|0)!=120){if((c[m>>2]|0)==0){C=48;break}c[e>>2]=(c[e>>2]|0)+ -1;C=48;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=0}else{D=QY(b)|0;E=0}while(1){if((D|0)==46){v=70;break}else if((D|0)!=48){F=0;G=0;H=0;I=0;K=D;L=E;M=0;N=0;O=1.0;P=0;Q=0.0;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=1;continue}else{D=QY(b)|0;E=1;continue}}b:do{if((v|0)==70){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;R=d[o]|0}else{R=QY(b)|0}if((R|0)==48){S=-1;T=-1}else{F=0;G=0;H=0;I=0;K=R;L=E;M=1;N=0;O=1.0;P=0;Q=0.0;break}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;V=d[o]|0}else{V=QY(b)|0}if((V|0)!=48){F=S;G=T;H=0;I=0;K=V;L=1;M=1;N=0;O=1.0;P=0;Q=0.0;break b}o=lZ(S|0,T|0,-1,-1)|0;S=o;T=J}}}while(0);c:while(1){o=K+ -48|0;do{if(o>>>0<10){W=o;v=84}else{q=K|32;n=(K|0)==46;if(!((q+ -97|0)>>>0<6|n)){X=K;break c}if(n){if((M|0)==0){Y=H;Z=I;_=H;$=I;aa=L;ba=1;ca=N;da=O;ea=P;ga=Q;break}else{X=46;break c}}else{W=(K|0)>57?q+ -87|0:o;v=84;break}}}while(0);if((v|0)==84){v=0;do{if((I|0)<0|(I|0)==0&H>>>0<8){ha=N;ia=O;ja=W+(P<<4)|0;ka=Q}else{if((I|0)<0|(I|0)==0&H>>>0<14){la=O*.0625;ha=N;ia=la;ja=P;ka=Q+la*+(W|0);break}if(!((W|0)!=0&(N|0)==0)){ha=N;ia=O;ja=P;ka=Q;break}ha=1;ia=O;ja=P;ka=Q+O*.5}}while(0);o=lZ(H|0,I|0,1,0)|0;Y=F;Z=G;_=o;$=J;aa=1;ba=M;ca=ha;da=ia;ea=ja;ga=ka}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;F=Y;G=Z;H=_;I=$;K=d[o]|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}else{F=Y;G=Z;H=_;I=$;K=QY(b)|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}}if((L|0)==0){o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}do{if(u){PY(b,0)}else{if(o){break}q=c[e>>2]|0;c[e>>2]=q+ -1;if((M|0)==0){break}c[e>>2]=q+ -2}}while(0);l=+(r|0)*0.0;i=g;return+l}o=(M|0)==0;q=o?H:F;n=o?I:G;if((I|0)<0|(I|0)==0&H>>>0<8){o=H;p=I;ma=P;while(1){na=ma<<4;oa=lZ(o|0,p|0,1,0)|0;pa=J;if((pa|0)<0|(pa|0)==0&oa>>>0<8){ma=na;p=pa;o=oa}else{qa=na;break}}}else{qa=P}do{if((X|32|0)==112){o=OY(b,f)|0;p=J;if(!((o|0)==0&(p|0)==-2147483648)){ra=o;sa=p;break}if(u){PY(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0;break}}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0}}while(0);p=gZ(q|0,n|0,2)|0;o=lZ(p|0,J|0,-32,-1)|0;p=lZ(o|0,J|0,ra|0,sa|0)|0;o=J;if((qa|0)==0){l=+(r|0)*0.0;i=g;return+l}if((o|0)>0|(o|0)==0&p>>>0>(0-k|0)>>>0){c[(Ic()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}ma=k+ -106|0;na=((ma|0)<0)<<31>>31;if((o|0)<(na|0)|(o|0)==(na|0)&p>>>0<ma>>>0){c[(Ic()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((qa|0)>-1){ma=p;na=o;oa=qa;la=Q;while(1){pa=oa<<1;if(!(la>=.5)){ta=la;ua=pa}else{ta=la+-1.0;ua=pa|1}va=la+ta;pa=lZ(ma|0,na|0,-1,-1)|0;wa=J;if((ua|0)>-1){ma=pa;na=wa;oa=ua;la=va}else{xa=pa;ya=wa;za=ua;Aa=va;break}}}else{xa=p;ya=o;za=qa;Aa=Q}oa=kZ(32,0,k|0,((k|0)<0)<<31>>31|0)|0;na=lZ(xa|0,ya|0,oa|0,J|0)|0;oa=J;if(0>(oa|0)|0==(oa|0)&j>>>0>na>>>0){Ba=(na|0)<0?0:na}else{Ba=j}do{if((Ba|0)<53){la=+(r|0);va=+Fd(+(+RY(1.0,84-Ba|0)),+la);if(!((Ba|0)<32&Aa!=0.0)){Ca=la;Da=va;Ea=za;Fa=Aa;break}na=za&1;Ca=la;Da=va;Ea=(na^1)+za|0;Fa=(na|0)==0?0.0:Aa}else{Ca=+(r|0);Da=0.0;Ea=za;Fa=Aa}}while(0);va=Ca*Fa+(Da+Ca*+(Ea>>>0))-Da;if(!(va!=0.0)){c[(Ic()|0)>>2]=34}l=+SY(va,xa);i=g;return+l}else{C=w}}while(0);o=k+j|0;p=0-o|0;na=C;oa=0;while(1){if((na|0)==46){v=139;break}else if((na|0)!=48){Ga=na;Ha=0;Ia=0;Ja=oa;Ka=0;break}ma=c[e>>2]|0;if(ma>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ma+1;na=d[ma]|0;oa=1;continue}else{na=QY(b)|0;oa=1;continue}}d:do{if((v|0)==139){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;La=d[na]|0}else{La=QY(b)|0}if((La|0)==48){Ma=-1;Na=-1}else{Ga=La;Ha=0;Ia=0;Ja=oa;Ka=1;break}while(1){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;Oa=d[na]|0}else{Oa=QY(b)|0}if((Oa|0)!=48){Ga=Oa;Ha=Ma;Ia=Na;Ja=1;Ka=1;break d}na=lZ(Ma|0,Na|0,-1,-1)|0;Ma=na;Na=J}}}while(0);oa=h;c[oa>>2]=0;na=Ga+ -48|0;ma=(Ga|0)==46;e:do{if(na>>>0<10|ma){n=h+496|0;q=Ga;wa=ma;pa=na;Pa=0;Qa=0;Ra=Ha;Sa=Ia;Ta=Ja;Ua=Ka;Va=0;Wa=0;Xa=0;while(1){do{if(wa){if((Ua|0)==0){Ya=Pa;Za=Qa;_a=Pa;$a=Qa;ab=Ta;bb=1;cb=Va;db=Wa;eb=Xa}else{fb=q;gb=Pa;hb=Qa;ib=Ra;jb=Sa;kb=Ta;lb=Va;mb=Wa;nb=Xa;break e}}else{ob=lZ(Pa|0,Qa|0,1,0)|0;pb=J;qb=(q|0)!=48;if((Wa|0)>=125){if(!qb){Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}c[n>>2]=c[n>>2]|1;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}rb=h+(Wa<<2)|0;if((Va|0)==0){sb=pa}else{sb=q+ -48+((c[rb>>2]|0)*10|0)|0}c[rb>>2]=sb;rb=Va+1|0;tb=(rb|0)==9;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=1;bb=Ua;cb=tb?0:rb;db=(tb&1)+Wa|0;eb=qb?ob:Xa}}while(0);ob=c[e>>2]|0;if(ob>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ob+1;ub=d[ob]|0}else{ub=QY(b)|0}ob=ub+ -48|0;qb=(ub|0)==46;if(ob>>>0<10|qb){q=ub;wa=qb;pa=ob;Pa=_a;Qa=$a;Ra=Ya;Sa=Za;Ta=ab;Ua=bb;Va=cb;Wa=db;Xa=eb}else{vb=ub;wb=_a;xb=$a;yb=Ya;zb=Za;Ab=ab;Bb=bb;Cb=cb;Db=db;Eb=eb;v=162;break}}}else{vb=Ga;wb=0;xb=0;yb=Ha;zb=Ia;Ab=Ja;Bb=Ka;Cb=0;Db=0;Eb=0;v=162}}while(0);if((v|0)==162){na=(Bb|0)==0;fb=vb;gb=wb;hb=xb;ib=na?wb:yb;jb=na?xb:zb;kb=Ab;lb=Cb;mb=Db;nb=Eb}na=(kb|0)!=0;do{if(na){if((fb|32|0)!=101){v=171;break}ma=OY(b,f)|0;Xa=J;do{if((ma|0)==0&(Xa|0)==-2147483648){if(u){PY(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){Fb=0;Gb=0;break}c[e>>2]=(c[e>>2]|0)+ -1;Fb=0;Gb=0;break}}else{Fb=ma;Gb=Xa}}while(0);Xa=lZ(Fb|0,Gb|0,ib|0,jb|0)|0;Hb=Xa;Ib=J}else{v=171}}while(0);do{if((v|0)==171){if(!((fb|0)>-1)){Hb=ib;Ib=jb;break}if((c[m>>2]|0)==0){Hb=ib;Ib=jb;break}c[e>>2]=(c[e>>2]|0)+ -1;Hb=ib;Ib=jb}}while(0);if(!na){c[(Ic()|0)>>2]=22;PY(b,0);l=0.0;i=g;return+l}Xa=c[oa>>2]|0;if((Xa|0)==0){l=+(r|0)*0.0;i=g;return+l}do{if((Hb|0)==(gb|0)&(Ib|0)==(hb|0)&((hb|0)<0|(hb|0)==0&gb>>>0<10)){if(!(j>>>0>30)){if((Xa>>>j|0)!=0){break}}l=+(r|0)*+(Xa>>>0);i=g;return+l}}while(0);Xa=(k|0)/-2|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)>(na|0)|(Ib|0)==(na|0)&Hb>>>0>Xa>>>0){c[(Ic()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}Xa=k+ -106|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)<(na|0)|(Ib|0)==(na|0)&Hb>>>0<Xa>>>0){c[(Ic()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((lb|0)==0){Jb=mb}else{if((lb|0)<9){Xa=h+(mb<<2)|0;na=c[Xa>>2]|0;ma=lb;do{na=na*10|0;ma=ma+1|0;}while((ma|0)<9);c[Xa>>2]=na}Jb=mb+1|0}do{if((nb|0)<9){if(!((nb|0)<=(Hb|0)&(Hb|0)<18)){break}if((Hb|0)==9){l=+(r|0)*+((c[oa>>2]|0)>>>0);i=g;return+l}if((Hb|0)<9){l=+(r|0)*+((c[oa>>2]|0)>>>0)/+(c[152e3+(8-Hb<<2)>>2]|0);i=g;return+l}ma=j+27+(fa(Hb,-3)|0)|0;Wa=c[oa>>2]|0;if((ma|0)<=30){if((Wa>>>ma|0)!=0){break}}l=+(r|0)*+(Wa>>>0)*+(c[152e3+(Hb+ -10<<2)>>2]|0);i=g;return+l}}while(0);oa=(Hb|0)%9|0;if((oa|0)==0){Kb=0;Lb=0;Mb=Hb;Nb=Jb}else{na=(Hb|0)>-1?oa:oa+9|0;oa=c[152e3+(8-na<<2)>>2]|0;do{if((Jb|0)==0){Ob=0;Pb=Hb;Qb=0}else{Xa=1e9/(oa|0)|0;Wa=0;ma=0;Va=0;Ua=Hb;while(1){Ta=h+(Va<<2)|0;Sa=c[Ta>>2]|0;Ra=((Sa>>>0)/(oa>>>0)|0)+ma|0;c[Ta>>2]=Ra;Rb=fa((Sa>>>0)%(oa>>>0)|0,Xa)|0;Sa=Va+1|0;if((Va|0)==(Wa|0)&(Ra|0)==0){Sb=Sa&127;Tb=Ua+ -9|0}else{Sb=Wa;Tb=Ua}if((Sa|0)==(Jb|0)){break}else{Wa=Sb;Ua=Tb;Va=Sa;ma=Rb}}if((Rb|0)==0){Ob=Sb;Pb=Tb;Qb=Jb;break}c[h+(Jb<<2)>>2]=Rb;Ob=Sb;Pb=Tb;Qb=Jb+1|0}}while(0);Kb=Ob;Lb=0;Mb=9-na+Pb|0;Nb=Qb}f:while(1){oa=h+(Kb<<2)|0;if((Mb|0)<18){ma=Lb;Va=Nb;while(1){Ua=0;Wa=Va+127|0;Xa=Va;while(1){Sa=Wa&127;Ra=h+(Sa<<2)|0;Ta=gZ(c[Ra>>2]|0,0,29)|0;Qa=lZ(Ta|0,J|0,Ua|0,0)|0;Ta=J;if(Ta>>>0>0|(Ta|0)==0&Qa>>>0>1e9){Pa=vZ(Qa|0,Ta|0,1e9,0)|0;pa=wZ(Qa|0,Ta|0,1e9,0)|0;Ub=pa;Vb=Pa}else{Ub=Qa;Vb=0}c[Ra>>2]=Ub;Ra=(Sa|0)==(Kb|0);if((Sa|0)!=(Xa+127&127|0)|Ra){Wb=Xa}else{Wb=(Ub|0)==0?Sa:Xa}if(Ra){break}else{Ua=Vb;Wa=Sa+ -1|0;Xa=Wb}}Xa=ma+ -29|0;if((Vb|0)==0){ma=Xa;Va=Wb}else{Xb=Xa;Yb=Vb;Zb=Wb;break}}}else{if((Mb|0)==18){_b=Lb;$b=Nb}else{ac=Kb;bc=Lb;cc=Mb;dc=Nb;break}while(1){if(!((c[oa>>2]|0)>>>0<9007199)){ac=Kb;bc=_b;cc=18;dc=$b;break f}Va=0;ma=$b+127|0;Xa=$b;while(1){Wa=ma&127;Ua=h+(Wa<<2)|0;Sa=gZ(c[Ua>>2]|0,0,29)|0;Ra=lZ(Sa|0,J|0,Va|0,0)|0;Sa=J;if(Sa>>>0>0|(Sa|0)==0&Ra>>>0>1e9){Qa=vZ(Ra|0,Sa|0,1e9,0)|0;Pa=wZ(Ra|0,Sa|0,1e9,0)|0;ec=Pa;fc=Qa}else{ec=Ra;fc=0}c[Ua>>2]=ec;Ua=(Wa|0)==(Kb|0);if((Wa|0)!=(Xa+127&127|0)|Ua){gc=Xa}else{gc=(ec|0)==0?Wa:Xa}if(Ua){break}else{Va=fc;ma=Wa+ -1|0;Xa=gc}}Xa=_b+ -29|0;if((fc|0)==0){_b=Xa;$b=gc}else{Xb=Xa;Yb=fc;Zb=gc;break}}}oa=Kb+127&127;if((oa|0)==(Zb|0)){Xa=Zb+127&127;ma=h+((Zb+126&127)<<2)|0;c[ma>>2]=c[ma>>2]|c[h+(Xa<<2)>>2];hc=Xa}else{hc=Zb}c[h+(oa<<2)>>2]=Yb;Kb=oa;Lb=Xb;Mb=Mb+9|0;Nb=hc}g:while(1){ic=dc+1&127;na=h+((dc+127&127)<<2)|0;oa=ac;Xa=bc;ma=cc;while(1){Va=(ma|0)==18;Wa=(ma|0)>27?9:1;jc=oa;kc=Xa;while(1){Ua=0;while(1){Ra=Ua+jc&127;if((Ra|0)==(dc|0)){lc=2;break}Qa=c[h+(Ra<<2)>>2]|0;Ra=c[151992+(Ua<<2)>>2]|0;if(Qa>>>0<Ra>>>0){lc=2;break}Pa=Ua+1|0;if(Qa>>>0>Ra>>>0){lc=Ua;break}if((Pa|0)<2){Ua=Pa}else{lc=Pa;break}}if((lc|0)==2&Va){break g}mc=Wa+kc|0;if((jc|0)==(dc|0)){jc=dc;kc=mc}else{break}}Va=(1<<Wa)+ -1|0;Ua=1e9>>>Wa;nc=jc;oc=0;Pa=jc;pc=ma;do{Ra=h+(Pa<<2)|0;Qa=c[Ra>>2]|0;Sa=(Qa>>>Wa)+oc|0;c[Ra>>2]=Sa;oc=fa(Qa&Va,Ua)|0;Qa=(Pa|0)==(nc|0)&(Sa|0)==0;Pa=Pa+1&127;pc=Qa?pc+ -9|0:pc;nc=Qa?Pa:nc;}while((Pa|0)!=(dc|0));if((oc|0)==0){oa=nc;Xa=mc;ma=pc;continue}if((ic|0)!=(nc|0)){break}c[na>>2]=c[na>>2]|1;oa=nc;Xa=mc;ma=pc}c[h+(dc<<2)>>2]=oc;ac=nc;bc=mc;cc=pc;dc=ic}ma=jc&127;if((ma|0)==(dc|0)){c[h+(ic+ -1<<2)>>2]=0;qc=ic}else{qc=dc}va=+((c[h+(ma<<2)>>2]|0)>>>0);ma=jc+1&127;if((ma|0)==(qc|0)){Xa=qc+1&127;c[h+(Xa+ -1<<2)>>2]=0;rc=Xa}else{rc=qc}la=+(r|0);sc=la*(va*1.0e9+ +((c[h+(ma<<2)>>2]|0)>>>0));ma=kc+53|0;Xa=ma-k|0;if((Xa|0)<(j|0)){tc=(Xa|0)<0?0:Xa;vc=1}else{tc=j;vc=0}if((tc|0)<53){va=+Fd(+(+RY(1.0,105-tc|0)),+sc);wc=+uc(+sc,+(+RY(1.0,53-tc|0)));xc=va;yc=wc;zc=va+(sc-wc)}else{xc=0.0;yc=0.0;zc=sc}oa=jc+2&127;do{if((oa|0)==(rc|0)){Ac=yc}else{na=c[h+(oa<<2)>>2]|0;do{if(na>>>0<5e8){if((na|0)==0){if((jc+3&127|0)==(rc|0)){Bc=yc;break}}Bc=la*.25+yc}else{if(na>>>0>5e8){Bc=la*.75+yc;break}if((jc+3&127|0)==(rc|0)){Bc=la*.5+yc;break}else{Bc=la*.75+yc;break}}}while(0);if((53-tc|0)<=1){Ac=Bc;break}if(+uc(+Bc,1.0)!=0.0){Ac=Bc;break}Ac=Bc+1.0}}while(0);la=zc+Ac-xc;do{if((ma&2147483647|0)>(-2-o|0)){if(!(+U(+la)>=9007199254740992.0)){Cc=vc;Dc=kc;Ec=la}else{Cc=(vc|0)!=0&(tc|0)==(Xa|0)?0:vc;Dc=kc+1|0;Ec=la*.5}if((Dc+50|0)<=(p|0)){if(!((Cc|0)!=0&Ac!=0.0)){Fc=Dc;Gc=Ec;break}}c[(Ic()|0)>>2]=34;Fc=Dc;Gc=Ec}else{Fc=kc;Gc=la}}while(0);l=+SY(Gc,Fc);i=g;return+l}else if((x|0)==3){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Hc=d[p]|0}else{Hc=QY(b)|0}if((Hc|0)==40){Jc=1}else{if((c[m>>2]|0)==0){l=+y;i=g;return+l}c[e>>2]=(c[e>>2]|0)+ -1;l=+y;i=g;return+l}while(1){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Kc=d[p]|0}else{Kc=QY(b)|0}if(!((Kc+ -48|0)>>>0<10|(Kc+ -65|0)>>>0<26)){if(!((Kc+ -97|0)>>>0<26|(Kc|0)==95)){break}}Jc=Jc+1|0}if((Kc|0)==41){l=+y;i=g;return+l}p=(c[m>>2]|0)==0;if(!p){c[e>>2]=(c[e>>2]|0)+ -1}if(u){c[(Ic()|0)>>2]=22;PY(b,0);l=0.0;i=g;return+l}if((Jc|0)==0|p){l=+y;i=g;return+l}else{Lc=Jc}while(1){p=Lc+ -1|0;c[e>>2]=(c[e>>2]|0)+ -1;if((p|0)==0){l=+y;break}else{Lc=p}}i=g;return+l}else{if((c[m>>2]|0)!=0){c[e>>2]=(c[e>>2]|0)+ -1}c[(Ic()|0)>>2]=22;PY(b,0);l=0.0;i=g;return+l}}}while(0);do{if((v|0)==23){b=(c[m>>2]|0)==0;if(!b){c[e>>2]=(c[e>>2]|0)+ -1}if(t>>>0<4|(f|0)==0|b){break}else{Mc=t}do{c[e>>2]=(c[e>>2]|0)+ -1;Mc=Mc+ -1|0;}while(Mc>>>0>3)}}while(0);l=+(r|0)*+z;i=g;return+l}function OY(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g]|0}else{j=QY(a)|0}do{if((j|0)==43|(j|0)==45){g=(j|0)==45|0;k=c[f>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[f>>2]=k+1;l=d[k]|0}else{l=QY(a)|0}if((l+ -48|0)>>>0<10|(b|0)==0){m=l;n=g;break}if((c[h>>2]|0)==0){m=l;n=g;break}c[f>>2]=(c[f>>2]|0)+ -1;m=l;n=g}else{m=j;n=0}}while(0);if((m+ -48|0)>>>0>9){if((c[h>>2]|0)==0){o=0;p=-2147483648;J=p;i=e;return o|0}c[f>>2]=(c[f>>2]|0)+ -1;o=0;p=-2147483648;J=p;i=e;return o|0}else{q=m;r=0}while(1){s=q+ -48+r|0;m=c[f>>2]|0;if(m>>>0<(c[h>>2]|0)>>>0){c[f>>2]=m+1;t=d[m]|0}else{t=QY(a)|0}if(!((t+ -48|0)>>>0<10&(s|0)<214748364)){break}q=t;r=s*10|0}r=((s|0)<0)<<31>>31;if((t+ -48|0)>>>0<10){q=s;m=r;j=t;while(1){l=uZ(q|0,m|0,10,0)|0;b=J;g=lZ(j|0,((j|0)<0)<<31>>31|0,-48,-1)|0;k=lZ(g|0,J|0,l|0,b|0)|0;b=J;l=c[f>>2]|0;if(l>>>0<(c[h>>2]|0)>>>0){c[f>>2]=l+1;u=d[l]|0}else{u=QY(a)|0}if((u+ -48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&k>>>0<2061584302)){j=u;m=b;q=k}else{v=k;w=b;x=u;break}}}else{v=s;w=r;x=t}if((x+ -48|0)>>>0<10){do{x=c[f>>2]|0;if(x>>>0<(c[h>>2]|0)>>>0){c[f>>2]=x+1;y=d[x]|0}else{y=QY(a)|0}}while((y+ -48|0)>>>0<10)}if((c[h>>2]|0)!=0){c[f>>2]=(c[f>>2]|0)+ -1}f=(n|0)!=0;n=kZ(0,0,v|0,w|0)|0;o=f?n:v;p=f?J:w;J=p;i=e;return o|0}function PY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if((b|0)!=0&(g|0)>(b|0)){c[a+100>>2]=f+b;i=d;return}else{c[a+100>>2]=e;i=d;return}}function QY(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+104|0;g=c[f>>2]|0;if((g|0)==0){h=3}else{if((c[b+108>>2]|0)<(g|0)){h=3}}do{if((h|0)==3){g=UY(b)|0;if((g|0)<0){break}j=c[f>>2]|0;k=c[b+8>>2]|0;do{if((j|0)==0){h=8}else{l=c[b+4>>2]|0;m=j-(c[b+108>>2]|0)+ -1|0;if((k-l|0)<=(m|0)){h=8;break}c[b+100>>2]=l+m}}while(0);if((h|0)==8){c[b+100>>2]=k}j=c[b+4>>2]|0;if((k|0)!=0){m=b+108|0;c[m>>2]=k+1-j+(c[m>>2]|0)}m=j+ -1|0;if((d[m]|0|0)==(g|0)){n=g;i=e;return n|0}a[m]=g;n=g;i=e;return n|0}}while(0);c[b+100>>2]=0;n=-1;i=e;return n|0}function RY(a,b){a=+a;b=b|0;var d=0,e=0.0,f=0,g=0,j=0.0;d=i;do{if((b|0)>1023){e=a*8.98846567431158e+307;f=b+ -1023|0;if((f|0)<=1023){g=f;j=e;break}f=b+ -2046|0;g=(f|0)>1023?1023:f;j=e*8.98846567431158e+307}else{if(!((b|0)<-1022)){g=b;j=a;break}e=a*1.2882297539194267e-231;f=b+1022|0;if(!((f|0)<-1022)){g=f;j=e;break}f=b+2044|0;g=(f|0)<-1022?-1022:f;j=e*1.2882297539194267e-231}}while(0);b=gZ(g+1023|0,0,52)|0;g=J;c[k>>2]=b;c[k+4>>2]=g;a=j*+h[k>>3];i=d;return+a}function SY(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+RY(a,b);i=c;return+d}function TY(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+74|0;f=a[e]|0;a[e]=f+ -1<<24>>24|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0){$d[c[b+36>>2]&63](b,0,0)|0}c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=b;g=c[f>>2]|0;if((g&20|0)==0){h=c[e>>2]|0;c[b+8>>2]=h;c[b+4>>2]=h;j=0;i=d;return j|0}if((g&4|0)==0){j=-1;i=d;return j|0}c[f>>2]=g|32;j=-1;i=d;return j|0}function UY(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+8|0;e=b;do{if((c[a+8>>2]|0)==0){if((TY(a)|0)==0){break}else{f=-1}i=b;return f|0}}while(0);if(($d[c[a+32>>2]&63](a,e,1)|0)!=1){f=-1;i=b;return f|0}f=d[e]|0;i=b;return f|0}function VY(a){a=a|0;var b=0,c=0.0;b=i;c=+WY(a,0);i=b;return+c}function WY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;PY(e,0);h=+NY(e,1,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function XY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;PY(e,0);h=+NY(e,2,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function YY(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)==0){f=0;i=e;return f|0}else{g=d;h=b;j=c}while(1){k=a[h]|0;l=a[j]|0;if(!(k<<24>>24==l<<24>>24)){break}c=g+ -1|0;if((c|0)==0){f=0;m=5;break}else{g=c;h=h+1|0;j=j+1|0}}if((m|0)==5){i=e;return f|0}f=(k&255)-(l&255)|0;i=e;return f|0}function ZY(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a[b]|0;f=a[c]|0;if(e<<24>>24!=f<<24>>24|e<<24>>24==0|f<<24>>24==0){g=e;h=f;j=g&255;k=h&255;l=j-k|0;i=d;return l|0}else{m=b;n=c}while(1){c=m+1|0;b=n+1|0;f=a[c]|0;e=a[b]|0;if(f<<24>>24!=e<<24>>24|f<<24>>24==0|e<<24>>24==0){g=f;h=e;break}else{n=b;m=c}}j=g&255;k=h&255;l=j-k|0;i=d;return l|0}function _Y(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;if((e|0)==0){g=0;i=f;return g|0}h=a[b]|0;a:do{if(h<<24>>24==0){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){p=l+ -1|0;q=a[o]|0;if(!((p|0)!=0&q<<24>>24!=0&m<<24>>24==q<<24>>24)){j=m;k=o;break a}q=n+1|0;r=o+1|0;s=a[q]|0;if(s<<24>>24==0){j=0;k=r;break}else{m=s;n=q;o=r;l=p}}}}while(0);g=(j&255)-(d[k]|0)|0;i=f;return g|0}function $Y(){c[33076]=p;c[33118]=p;c[37760]=p;c[37990]=p}function aZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;w=w+1|0;c[a>>2]=w;while((e|0)<40){if((c[d+(e<<2)>>2]|0)==0){c[d+(e<<2)>>2]=w;c[d+((e<<2)+4)>>2]=b;c[d+((e<<2)+8)>>2]=0;return 0}e=e+2|0}$b(116);$b(111);$b(111);$b(32);$b(109);$b(97);$b(110);$b(121);$b(32);$b(115);$b(101);$b(116);$b(106);$b(109);$b(112);$b(115);$b(32);$b(105);$b(110);$b(32);$b(97);$b(32);$b(102);$b(117);$b(110);$b(99);$b(116);$b(105);$b(111);$b(110);$b(32);$b(99);$b(97);$b(108);$b(108);$b(44);$b(32);$b(98);$b(117);$b(105);$b(108);$b(100);$b(32);$b(119);$b(105);$b(116);$b(104);$b(32);$b(97);$b(32);$b(104);$b(105);$b(103);$b(104);$b(101);$b(114);$b(32);$b(118);$b(97);$b(108);$b(117);$b(101);$b(32);$b(102);$b(111);$b(114);$b(32);$b(77);$b(65);$b(88);$b(95);$b(83);$b(69);$b(84);$b(74);$b(77);$b(80);$b(83);$b(10);ga(0);return 0}function bZ(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function cZ(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function dZ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return jb(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function eZ(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{dZ(b,c,d)|0}return b|0}function fZ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function gZ(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function hZ(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function iZ(a){a=a|0;var b=0;b=(fa(c[a>>2]|0,31010991)|0)+1735287159&2147483647;c[a>>2]=b;return b|0}function jZ(){return iZ(o)|0}function kZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(J=e,a-c>>>0|0)|0}function lZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function mZ(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e|0]=f?0:a[c+e|0]|0;f=f?1:(a[c+e|0]|0)==0;e=e+1|0}return b|0}function nZ(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function oZ(a,b){a=a|0;b=b|0;var d=0,e=0;while((d|0)<20){e=c[b+(d<<2)>>2]|0;if((e|0)==0)break;if((e|0)==(a|0)){return c[b+((d<<2)+4)>>2]|0}d=d+2|0}return 0}function pZ(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function qZ(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function rZ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=fa(d,c)|0;f=a>>>16;a=(e>>>16)+(fa(d,f)|0)|0;d=b>>>16;b=fa(d,c)|0;return(J=(a>>>16)+(fa(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function sZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=kZ(e^a,f^b,e,f)|0;b=J;a=g^e;e=h^f;f=kZ((xZ(i,b,kZ(g^c,h^d,g,h)|0,J,0)|0)^a,J^e,a,e)|0;return(J=J,f)|0}function tZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=kZ(h^a,j^b,h,j)|0;b=J;xZ(m,b,kZ(k^d,l^e,k,l)|0,J,g)|0;l=kZ(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=J;i=f;return(J=j,l)|0}function uZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=rZ(e,a)|0;f=J;return(J=(fa(b,a)|0)+(fa(d,e)|0)+f|f&0,c|0|0)|0}function vZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=xZ(a,b,c,d,0)|0;return(J=J,e)|0}function wZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;xZ(a,b,d,e,g)|0;i=f;return(J=c[g+4>>2]|0,c[g>>2]|0)|0}function xZ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(J=n,o)|0}else{if(!m){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(J=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(J=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(J=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((qZ(l|0)|0)>>>0);return(J=n,o)|0}p=(pZ(l|0)|0)-(pZ(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}else{if(!m){r=(pZ(l|0)|0)-(pZ(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(pZ(j|0)|0)+33-(pZ(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(J=n,o)|0}else{p=qZ(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(J=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=lZ(g,d,-1,-1)|0;k=J;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;kZ(e,k,j,a)|0;b=J;h=b>>31|((b|0)<0?-1:0)<<1;K=h&1;L=kZ(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=J;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=K}}B=H;C=I;D=M;E=L;F=0;G=K}K=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(K|0)>>>31|(B|C)<<1|(C<<1|K>>>31)&0|F;o=(K<<1|0>>>31)&-2|G;return(J=n,o)|0}function yZ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Rd[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function zZ(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Sd[a&31](b|0,c|0,d|0,e|0,f|0)}function AZ(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return Td[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function BZ(a,b){a=a|0;b=+b;Ud[a&1](+b)}function CZ(a,b){a=a|0;b=b|0;Vd[a&511](b|0)}function DZ(a,b,c){a=a|0;b=b|0;c=c|0;Wd[a&63](b|0,c|0)}function EZ(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return Xd[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function FZ(a,b){a=a|0;b=b|0;return Yd[a&127](b|0)|0}function GZ(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;return Zd[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0)|0}function HZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;_d[a&1](b|0,c|0,+d,+e,+f,+g)}function IZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return $d[a&63](b|0,c|0,d|0)|0}function JZ(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;return ae[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0)|0}function KZ(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;return be[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0)|0}function LZ(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;return ce[a&1](+b,c|0,d|0)|0}function MZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;de[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function NZ(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ee[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function OZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;fe[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function PZ(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;ge[a&3](b|0,c|0,+d,e|0,f|0)}function QZ(a,b,c){a=a|0;b=b|0;c=+c;return he[a&1](b|0,+c)|0}function RZ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ie[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function SZ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;je[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function TZ(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ke[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function UZ(a,b,c){a=a|0;b=b|0;c=c|0;return le[a&63](b|0,c|0)|0}function VZ(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return me[a&63](b|0,c|0,d|0,e|0,f|0)|0}function WZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return ne[a&1](b|0,c|0,d|0,e|0,+f,g|0)|0}function XZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;return+oe[a&1](b|0,c|0,+d,+e,+f,+g)}function YZ(a){a=a|0;return pe[a&7]()|0}function ZZ(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return qe[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function _Z(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;re[a&15](b|0,c|0,d|0)}function $Z(a){a=a|0;se[a&7]()}function a_(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return te[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function b_(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ue[a&63](b|0,c|0,d|0,e|0)|0}function c_(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ve[a&31](b|0,c|0,d|0,e|0)}function d_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(0);return 0}function e_(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(1)}function f_(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ga(2);return 0}function g_(a){a=+a;ga(3)}function h_(a){a=a|0;ga(4)}function i_(a){a=a|0;qd(a|0)}function j_(a,b){a=a|0;b=b|0;ga(5)}function k_(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ga(6);return 0}function l_(a){a=a|0;ga(7);return 0}function m_(a){a=a|0;return Jc(a|0)|0}function n_(a){a=a|0;return zd(a|0)|0}function o_(a){a=a|0;return rc(a|0)|0}function p_(a){a=a|0;return od(a|0)|0}function q_(a){a=a|0;return dd(a|0)|0}function r_(a){a=a|0;return jd(a|0)|0}function s_(a){a=a|0;return Sc(a|0)|0}function t_(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;ga(8);return 0}function u_(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;ga(9)}function v_(a,b,c){a=a|0;b=b|0;c=c|0;ga(10);return 0}function w_(a,b,c){a=a|0;b=b|0;c=c|0;return ld(a|0,b|0,c|0)|0}function x_(a,b,c){a=a|0;b=b|0;c=c|0;return dc(a|0,b|0,c|0)|0}function y_(a,b,c){a=a|0;b=b|0;c=c|0;return Zb(a|0,b|0,c|0)|0}function z_(a,b,c){a=a|0;b=b|0;c=c|0;return pd(a|0,b|0,c|0)|0}function A_(a,b,c){a=a|0;b=b|0;c=c|0;return md(a|0,b|0,c|0)|0}function B_(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;ga(11);return 0}function C_(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;ga(12);return 0}function D_(a,b,c){a=+a;b=b|0;c=c|0;ga(13);return 0}function E_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ga(14)}function F_(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(15)}function G_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ga(16)}function H_(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ga(17)}function I_(a,b){a=a|0;b=+b;ga(18);return 0}function J_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(19)}function K_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ga(20)}function L_(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(21)}function M_(a,b){a=a|0;b=b|0;ga(22);return 0}function N_(a,b){a=a|0;b=b|0;return Ed(a|0,b|0)|0}function O_(a,b){a=a|0;b=b|0;return cc(a|0,b|0)|0}function P_(a,b){a=a|0;b=b|0;return fb(a|0,b|0)|0}function Q_(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(23);return 0}function R_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ga(24);return 0}function S_(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;ga(25);return 0.0}function T_(){ga(26);return 0}function U_(){return gb()|0}function V_(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(27);return 0}function W_(a,b,c){a=a|0;b=b|0;c=c|0;ga(28)}function X_(){ga(29)}function Y_(){Pc()}function Z_(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(30);return 0}function __(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(31);return 0}function $_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return mc(a|0,b|0,c|0,d|0)|0}function a$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Hc(a|0,b|0,c|0,d|0)|0}function b$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(32)}



function Zu(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;Ou(0,(a|0)!=0|0,64576,d);d=a;Ou(0,(c[d>>2]|0)!=0|0,64616,b);i=b;return c[d>>2]|0}function _u(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=(a|0)!=0;Ou(0,d&1,64648,b);if(!d){e=0;i=b;return e|0}e=c[a+4>>2]|0;i=b;return e|0}function $u(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;Ou(0,(a|0)!=0|0,64648,d);d=a;Ou(0,(c[d>>2]|0)!=0|0,64672,b);i=b;return c[d>>2]|0}function av(){var a=0,b=0,d=0;a=i;b=zY(16)|0;c[16186]=b;c[b+4>>2]=0;c[b+8>>2]=2097152;d=zY(2097152)|0;c[b>>2]=d;c[b+12>>2]=0;i=a;return}function bv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=dv(a)|0;oc(64752)|0;ev(d);a=c[16186]|0;e=a+4|0;f=c[e>>2]|0;g=(c[a>>2]|0)+f|0;c[e>>2]=f+d;bc(64752)|0;fZ(g|0,0,d|0)|0;i=b;return g|0}function cv(){var a=0,b=0,d=0,e=0;a=i;b=c[16186]|0;d=c[b+12>>2]|0;if((d|0)==0){e=b}else{b=d;while(1){d=c[b+12>>2]|0;AY(c[b>>2]|0);AY(b);if((d|0)==0){break}else{b=d}}e=c[16186]|0}c[e+4>>2]=0;c[e+12>>2]=0;i=a;return 0}function dv(a){a=a|0;i=i;return a+7&-8|0}function ev(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[16186]|0;e=d+8|0;if(!(((c[e>>2]|0)-(c[d+4>>2]|0)|0)>>>0<a>>>0)){i=b;return}f=zY(16)|0;c[f+12>>2]=d;c[16186]=f;c[f+4>>2]=0;d=fv((((c[e>>2]|0)*3|0)>>>1)+a|0)|0;c[f+8>>2]=d;a=zY(d)|0;c[f>>2]=a;i=b;return}function fv(a){a=a|0;var b=0;b=a+ -1|0;a=b>>>1|b;b=a>>>2|a;a=b>>>4|b;b=a>>>8|a;i=i;return(b>>>16|b)+1|0}function gv(a){a=a|0;var b=0,c=0;b=i;c=bZ(a|0)|0;i=b;return c|0}function hv(b,d){b=+b;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;j=i;i=i+400|0;l=g;m=j;a[l]=37;hZ(g+1|0,d|0)|0;d=f;h[k>>3]=b;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];dc(m|0,l|0,f|0)|0;f=iv(m)|0;i=e;return f|0}function iv(a){a=a|0;var b=0,c=0,d=0;b=i;c=bZ(a|0)|0;d=kv(c)|0;dZ(d|0,a|0,c|0)|0;i=b;return d|0}function jv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;h=i;i=i+400|0;j=g;k=h;a[j]=37;hZ(g+1|0,d|0)|0;c[f>>2]=b;dc(k|0,j|0,f|0)|0;f=iv(k)|0;i=e;return f|0}function kv(b){b=b|0;var d=0,e=0;d=i;e=Yd[c[64708>>2]&127](b+1|0)|0;if((e|0)==0){i=d;return e|0}a[e+b|0]=0;i=d;return e|0}function lv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=i;d=gv(a)|0;e=gv(b)|0;f=kv(e+d|0)|0;dZ(f|0,a|0,d|0)|0;dZ(f+d|0,b|0,e|0)|0;i=c;return f|0}function mv(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=ZY(c[a>>2]|0,c[b>>2]|0)|0;i=d;return e|0}function nv(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=(a|0)%100|0;d=(c|0)/10|0;e=(a|0)%10|0;a:do{if((a+999|0)>>>0>1998){f=-1}else{if((((a|0)%1e3|0)+99|0)>>>0>198){f=-1;break}if((e|0)==1){if((c+ -50|0)>>>0>9){f=-1;break}}else if((e|0)==2){f=-1;break}switch(d|0){case 4:{f=2;break a;break};case 2:{f=4;break a;break};case 0:{f=8;break a;break};case 1:{f=4;break a;break};case 5:{f=1;break a;break};case 3:{f=2;break a;break};default:{f=-1;break a}}}}while(0);i=b;return f|0}function ov(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a;e=c[d>>2]|0;if((e|0)!=0){Sc(e|0)|0;c[d>>2]=0}e=a+4|0;f=c[e>>2]|0;if((f|0)!=0){AY(f);c[e>>2]=0}e=a+8|0;if((c[e>>2]|0)!=0){f=a+12|0;g=0;do{AY(c[(c[f>>2]|0)+(g<<4)>>2]|0);AY(c[(c[f>>2]|0)+(g<<4)+4>>2]|0);g=g+1|0;}while(g>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;if((c[d>>2]|0)!=0){d=a+12|0;AY(c[d>>2]|0);c[d>>2]=0}d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){AY(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;g=a+40|0;if((e&2147483647|0)!=0){a=e;e=0;while(1){f=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((f|0)==0){h=a}else{AY(f);h=c[d>>2]|0}f=e+1|0;if(f>>>0<h<<1>>>0){a=h;e=f}else{break}}}c[d>>2]=0;d=c[g>>2]|0;if((d|0)==0){i=b;return}AY(d);c[g>>2]=0;i=b;return}function pv(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=i;d=0;e=0;while(1){f=a[b+d|0]|0;if(f<<24>>24==32){g=e}else{a[b+e|0]=f;g=e+1|0}f=d+1|0;if(f>>>0>(bZ(b|0)|0)>>>0){break}else{d=f;e=g}}i=c;return}function qv(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+88|0;f=e;j=e+24|0;k=e+72|0;l=d+0|0;m=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=ec(b|0,64936)|0;m=d;c[m>>2]=l;if((l|0)==0){n=Kd(c[(Ic()|0)>>2]|0)|0;i=e;return n|0}c[d+4>>2]=od(b|0)|0;c[d+36>>2]=0;b=f;l=d+44|0;o=f;p=f+12|0;q=f+16|0;r=f+4|0;s=f+8|0;f=j;t=k;u=d+8|0;v=d+12|0;w=d+16|0;x=d+20|0;y=d+28|0;z=d+24|0;A=d+32|0;B=d+40|0;d=1;C=0;a:while(1){D=pb(b|0,20,1,c[m>>2]|0)|0;a[l]=1;if((D|0)!=1){n=64944;E=131;break}D=c[o>>2]|0;if((D|0)!=(c[64912+(C<<2)>>2]|0)){if(!((C|0)>3&(D|0)==10)){n=64968;E=131;break}a[l]=0}F=c[p>>2]|0;if(F>>>0>1){n=64992;E=131;break}G=nv(D)|0;if((G|0)==-1){n=65024;E=131;break}D=c[q>>2]|0;H=zY(D)|0;if((pb(H|0,D|0,1,c[m>>2]|0)|0)!=1){n=65072;E=131;break}if((a[H+(D+ -1)|0]|0)!=0){n=65096;E=131;break}D=c[r>>2]|0;I=c[s>>2]|0;J=fa(fa(fa(D,G)|0,I)|0,F+1|0)|0;if((ZY(H,c[64888+(C<<2)>>2]|0)|0)!=0){n=65120;E=131;break}AY(H);H=65696;b:do{switch(C|0){case 0:{if((D|0)!=4){n=65144;E=131;break a}if((I|0)!=11){n=65184;E=131;break a}if((pb(f|0,44,1,c[m>>2]|0)|0)==1){K=0}else{n=65224;E=131;break a}while(1){F=0;do{a[k+F|0]=a[j+((F<<2)+K)|0]|0;F=F+1|0;}while(F>>>0<11);a[k+11|0]=0;if((K|0)==3){break}F=K+1|0;if(F>>>0<4){K=F}else{L=d;E=130;break b}}if((_Y(t,c[16198]|0,8)|0)==0){L=1;E=130;break b}if((_Y(t,c[16204]|0,9)|0)==0){L=0;E=130}else{n=65256;E=131;break a}break};case 5:{if(d<<24>>24==1){c[y>>2]=I;if(I>>>0<2){n=65632;E=131;break a}c[z>>2]=D;c[A>>2]=vb(c[m>>2]|0)|0;c[B>>2]=BY(c[z>>2]<<1,4)|0;if((Qc(c[m>>2]|0,J|0,1)|0)==-1){n=65664;E=131;break a}else{L=1;E=130;break b}}else if(!(d<<24>>24==0)){n=0;E=131;break a}c[y>>2]=D;if(D>>>0<2){n=65632;E=131;break a}c[z>>2]=I;c[A>>2]=vb(c[m>>2]|0)|0;c[B>>2]=BY(c[z>>2]<<1,4)|0;F=fa(I,D)|0;if((a[l]|0)==1){G=zY(F<<3)|0;if((pb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=65664;E=131;break a}if((I|0)!=0){M=D<<3;N=(D|0)==0;O=D<<3;P=0;do{Q=zY(M)|0;c[(c[B>>2]|0)+(P<<2)>>2]=Q;if(!N){Q=G+(fa(O,P)|0)|0;dZ(c[(c[B>>2]|0)+(P<<2)>>2]|0,Q|0,O|0)|0}P=P+1|0;}while(P>>>0<I>>>0)}P=c[z>>2]|0;O=P<<1;if(P>>>0<O>>>0){N=D<<3;M=(D|0)==0;Q=P;do{R=zY(N)|0;c[(c[B>>2]|0)+(Q<<2)>>2]=R;if(!M){R=c[B>>2]|0;S=c[R+(Q-P<<2)>>2]|0;T=c[R+(Q<<2)>>2]|0;R=0;do{h[T+(R<<3)>>3]=-+h[S+(R<<3)>>3];R=R+1|0;}while(R>>>0<D>>>0)}Q=Q+1|0;}while(Q>>>0<O>>>0)}AY(G)}else{O=zY(F<<2)|0;if((pb(O|0,J|0,1,c[m>>2]|0)|0)!=1){n=65664;E=131;break a}if((I|0)!=0){Q=D<<3;P=(D|0)==0;M=0;do{N=zY(Q)|0;c[(c[B>>2]|0)+(M<<2)>>2]=N;if(!P){N=c[(c[B>>2]|0)+(M<<2)>>2]|0;R=0;do{h[N+(R<<3)>>3]=+g[O+((fa(D,M)|0)+R<<2)>>2];R=R+1|0;}while(R>>>0<D>>>0)}M=M+1|0;}while(M>>>0<I>>>0)}M=c[z>>2]|0;P=M<<1;if(M>>>0<P>>>0){Q=D<<3;F=(D|0)==0;G=M;do{R=zY(Q)|0;c[(c[B>>2]|0)+(G<<2)>>2]=R;if(!F){R=c[B>>2]|0;N=c[R+(G-M<<2)>>2]|0;S=c[R+(G<<2)>>2]|0;R=0;do{h[S+(R<<3)>>3]=-+h[N+(R<<3)>>3];R=R+1|0;}while(R>>>0<D>>>0)}G=G+1|0;}while(G>>>0<P>>>0)}AY(O)}if((Qc(c[m>>2]|0,J|0,1)|0)==-1){n=65664;E=131;break a}else{L=d;E=130}break};case 2:{if(d<<24>>24==1){if((I|0)==0){U=1;E=129;break b}P=D+1|0;G=0;while(1){M=zY(P)|0;c[(c[v>>2]|0)+(G<<4)+4>>2]=M;if((pb(c[(c[v>>2]|0)+(G<<4)+4>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=65320;E=131;break a}a[(c[(c[v>>2]|0)+(G<<4)+4>>2]|0)+D|0]=0;M=G+1|0;if(M>>>0<I>>>0){G=M}else{L=1;E=130;break b}}}else if(!(d<<24>>24==0)){U=d;E=129;break b}G=fa(D,I)|0;V=zY(G+1|0)|0;if((pb(V|0,G|0,1,c[m>>2]|0)|0)!=1){E=46;break a}if((D|0)!=0){G=I+1|0;P=(I|0)==0;O=0;do{M=zY(G)|0;c[(c[v>>2]|0)+(O<<4)+4>>2]=M;if(!P){M=0;do{F=a[V+((fa(D,M)|0)+O)|0]|0;a[(c[(c[v>>2]|0)+(O<<4)+4>>2]|0)+M|0]=F;M=M+1|0;}while(M>>>0<I>>>0)}a[(c[(c[v>>2]|0)+(O<<4)+4>>2]|0)+I|0]=0;O=O+1|0;}while(O>>>0<D>>>0)}AY(V);L=0;E=130;break};case 4:{if(d<<24>>24==1){if((D|0)==0){n=65384;E=131;break a}if(!((I+ -1|0)>>>0<2)){n=65440;E=131;break a}c[w>>2]=D;O=fa(I,D)|0;if((a[l]|0)==1){P=zY(O<<3)|0;c[x>>2]=P;if((pb(P|0,J|0,1,c[m>>2]|0)|0)!=1){n=65480;E=131;break a}}else{P=zY(O<<2)|0;c[x>>2]=zY(fa(D<<3,I)|0)|0;if((pb(P|0,J|0,1,c[m>>2]|0)|0)!=1){n=65480;E=131;break a}if((O|0)!=0){G=c[x>>2]|0;M=0;do{h[G+(M<<3)>>3]=+g[P+(M<<2)>>2];M=M+1|0;}while(M>>>0<O>>>0)}AY(P)}O=c[w>>2]|0;if(!(O>>>0>1)){L=1;E=130;break b}M=(I|0)==2;G=1;while(1){if(M){F=c[x>>2]|0;if(+h[F+(G<<3)>>3]!=+h[F+(O+G<<3)>>3]){n=65512;E=131;break a}}F=G+1|0;if(F>>>0<O>>>0){G=F}else{L=1;E=130;break b}}}else if(!(d<<24>>24==0)){U=d;E=129;break b}if((I|0)==0){n=65384;E=131;break a}if(!((D+ -1|0)>>>0<2)){n=65592;E=131;break a}c[w>>2]=I;G=fa(I,D)|0;if((a[l]|0)==1){O=zY(G<<3)|0;c[x>>2]=zY(fa(D<<3,I)|0)|0;if((pb(O|0,J|0,1,c[m>>2]|0)|0)!=1){n=65480;E=131;break a}if((D|0)!=0){M=0;do{P=c[x>>2]|0;F=0;do{h[P+((fa(I,M)|0)+F<<3)>>3]=+h[O+((fa(D,F)|0)+M<<3)>>3];F=F+1|0;}while(F>>>0<I>>>0);M=M+1|0;}while(M>>>0<D>>>0)}AY(O)}else{M=zY(G<<2)|0;c[x>>2]=zY(fa(D<<3,I)|0)|0;if((pb(M|0,J|0,1,c[m>>2]|0)|0)!=1){n=65480;E=131;break a}if((D|0)!=0){F=0;do{P=c[x>>2]|0;Q=0;do{h[P+((fa(I,F)|0)+Q<<3)>>3]=+g[M+((fa(D,Q)|0)+F<<2)>>2];Q=Q+1|0;}while(Q>>>0<I>>>0);F=F+1|0;}while(F>>>0<D>>>0)}AY(M)}F=c[w>>2]|0;if(!(F>>>0>1)){L=d;E=130;break b}G=(D|0)==2;O=1;while(1){if(G){Q=c[x>>2]|0;if(+h[Q+(O<<3)>>3]!=+h[Q+(F+O<<3)>>3]){n=65512;E=131;break a}}Q=O+1|0;if(Q>>>0<F>>>0){O=Q}else{L=d;E=130;break}}break};case 1:{O=d<<24>>24==0;c[u>>2]=O?D:I;F=zY((O?D:I)<<4)|0;c[v>>2]=F;c:do{if(d<<24>>24==1){if((I|0)==0){W=0;break}G=D+1|0;M=F;Q=0;while(1){c[M+(Q<<4)>>2]=zY(G)|0;if((pb(c[(c[v>>2]|0)+(Q<<4)>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=65320;E=131;break a}a[(c[(c[v>>2]|0)+(Q<<4)>>2]|0)+D|0]=0;P=c[v>>2]|0;c[P+(Q<<4)+8>>2]=-1;c[P+(Q<<4)+12>>2]=-1;pv(c[P+(Q<<4)>>2]|0);P=Q+1|0;if(!(P>>>0<I>>>0)){W=I;break c}M=c[v>>2]|0;Q=P}}else{W=I}}while(0);if(!O){L=d;E=130;break b}F=fa(D,W)|0;X=zY(F+1|0)|0;if((pb(X|0,F|0,1,c[m>>2]|0)|0)!=1){E=33;break a}if((D|0)!=0){F=W+1|0;Q=(W|0)==0;M=0;do{G=zY(F)|0;c[(c[v>>2]|0)+(M<<4)>>2]=G;if(!Q){G=0;do{P=a[X+((fa(D,G)|0)+M)|0]|0;a[(c[(c[v>>2]|0)+(M<<4)>>2]|0)+G|0]=P;G=G+1|0;}while(G>>>0<W>>>0)}a[(c[(c[v>>2]|0)+(M<<4)>>2]|0)+W|0]=0;G=c[v>>2]|0;c[G+(M<<4)+8>>2]=-1;c[G+(M<<4)+12>>2]=-1;pv(c[G+(M<<4)>>2]|0);M=M+1|0;}while(M>>>0<D>>>0)}AY(X);L=0;E=130;break};case 3:{M=fa(I<<2,D)|0;Y=zY(M)|0;if((pb(Y|0,M|0,1,c[m>>2]|0)|0)!=1){E=52;break a}do{if(d<<24>>24==0){if((D|0)==0){break}M=c[v>>2]|0;Q=0;do{c[M+(Q<<4)+8>>2]=(c[Y+(Q<<2)>>2]|0)==1;c[M+(Q<<4)+12>>2]=c[Y+(D+Q<<2)>>2];Q=Q+1|0;}while(Q>>>0<D>>>0)}else if(d<<24>>24==1){if((I|0)==0){break}Q=c[v>>2]|0;M=0;do{F=fa(D,M)|0;c[Q+(M<<4)+8>>2]=(c[Y+(F<<2)>>2]|0)==1;c[Q+(M<<4)+12>>2]=c[Y+(F+1<<2)>>2];M=M+1|0;}while(M>>>0<I>>>0)}}while(0);AY(Y);_b(c[v>>2]|0,c[u>>2]|0,16,52);L=d;E=130;break};default:{n=H;E=131;break a}}}while(0);if((E|0)==129){E=0;d=U;C=C+1|0;continue}else if((E|0)==130){E=0;H=C+1|0;if((H|0)<6){d=L;C=H;continue}else{n=0;E=131;break}}}if((E|0)==33){AY(X);n=65320;i=e;return n|0}else if((E|0)==46){AY(V);n=65320;i=e;return n|0}else if((E|0)==52){AY(Y);n=65352;i=e;return n|0}else if((E|0)==131){i=e;return n|0}return 0}function rv(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=sd(e|0,c[a+12>>2]|0,c[a+8>>2]|0,16,52)|0;i=d;return b|0}function sv(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=(d|0)>-1?d:0-d|0;j=(d|0)<0;do{if(j){k=c[b+24>>2]|0;l=k+f|0;m=k}else{if((d|0)==0){n=65736;o=n;p=65784;q=p;r=65808;s=r;$a(o|0,q|0,399,s|0)}else{l=f;m=c[b+24>>2]|0;break}}}while(0);d=l+ -1|0;l=b+24|0;if(f>>>0>m>>>0){n=65736;o=n;p=65784;q=p;r=65808;s=r;$a(o|0,q|0,399,s|0)}s=b+40|0;q=c[(c[s>>2]|0)+(d<<2)>>2]|0;if((q|0)!=0){t=q;i=e;return t|0}q=b+28|0;o=c[q>>2]|0;r=zY(o<<3)|0;p=r;a:do{if((a[b+44|0]|0)==1){if((o|0)==0){break}n=b;m=b+32|0;k=0;while(1){Qc(c[n>>2]|0,(c[m>>2]|0)+ -8+((fa(c[l>>2]|0,k)|0)+f<<3)|0,0)|0;u=r+(k<<3)|0;if((pb(u|0,8,1,c[n>>2]|0)|0)!=1){break}if(j){h[u>>3]=-+h[u>>3]}k=k+1|0;if(!(k>>>0<(c[q>>2]|0)>>>0)){break a}}AY(r);t=0;i=e;return t|0}else{k=zY(o<<2)|0;b:do{if((o|0)==0){v=0}else{n=b;m=b+32|0;u=0;while(1){Qc(c[n>>2]|0,(c[m>>2]|0)+ -4+((fa(c[l>>2]|0,u)|0)+f<<2)|0,0)|0;w=u+1|0;if((pb(k+(u<<2)|0,4,1,c[n>>2]|0)|0)!=1){break}x=c[q>>2]|0;if(w>>>0<x>>>0){u=w}else{v=x;break b}}AY(k);AY(r);t=0;i=e;return t|0}}while(0);u=(v|0)==0;do{if(j){if(u){break}else{y=0}do{h[r+(y<<3)>>3]=-+g[k+(y<<2)>>2];y=y+1|0;}while(y>>>0<v>>>0)}else{if(u){break}else{z=0}do{h[r+(z<<3)>>3]=+g[k+(z<<2)>>2];z=z+1|0;}while(z>>>0<v>>>0)}}while(0);AY(k)}}while(0);c[(c[s>>2]|0)+(d<<2)>>2]=p;t=c[(c[s>>2]|0)+(d<<2)>>2]|0;i=e;return t|0}function tv(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;j=i;i=i+8|0;k=j;l=(e|0)>-1?e:0-e|0;m=(e|0)<0;do{if(m){n=c[d+24>>2]|0;o=n+l|0;p=n}else{if((e|0)==0){q=65736;r=q;s=65784;t=s;u=65832;v=u;$a(r|0,t|0,519,v|0)}else{o=l;p=c[d+24>>2]|0;break}}}while(0);if(l>>>0>p>>>0){q=65736;r=q;s=65784;t=s;u=65832;v=u;$a(r|0,t|0,519,v|0)}v=c[(c[d+40>>2]|0)+(o+ -1<<2)>>2]|0;if((v|0)!=0){h[b>>3]=+h[v+(f<<3)>>3];w=0.0;i=j;return+w}v=d;o=c[v>>2]|0;t=c[d+32>>2]|0;r=l+ -1+(fa(p,f)|0)|0;do{if((a[d+44|0]|0)==1){Qc(o|0,t+(r<<3)|0,0)|0;f=(pb(b|0,8,1,c[v>>2]|0)|0)!=1;if(f|m^1){w=f?1.0:0.0;i=j;return+w}else{x=+h[b>>3];break}}else{Qc(o|0,t+(r<<2)|0,0)|0;if((pb(k|0,4,1,c[v>>2]|0)|0)!=1){w=1.0;i=j;return+w}y=+g[k>>2];h[b>>3]=y;if(m){x=y;break}else{w=0.0}i=j;return+w}}while(0);h[b>>3]=-x;w=0.0;i=j;return+w}function uv(a,b,d,e,f,g,j){a=+a;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0;k=i;l=d+ -1|0;d=0;while(1){m=((l-d|0)/2|0)+d|0;n=+h[b+(m<<3)>>3];if(n==a){o=n;p=m;q=3;break}r=n<a;s=r?m+1|0:d;t=r?l:m+ -1|0;if((t|0)>(s|0)){l=t;d=s}else{break}}if((q|0)==3){while(1){q=0;if((p|0)>=(l|0)){break}d=p+1|0;n=+h[b+(d<<3)>>3];if(o==n){o=n;p=d;q=3}else{break}}c[e>>2]=p;h[f>>3]=1.0;c[g>>2]=-1;u=0.0;h[j>>3]=u;i=k;return}do{if((t|0)==(s|0)){if(+h[b+(s<<3)>>3]<a){v=s+1|0;w=s;break}else{v=s;w=s+ -1|0;break}}else{v=t;w=s}}while(0);c[e>>2]=v;c[g>>2]=w;o=+h[b+(w<<3)>>3];n=(a-o)/(+h[b+(v<<3)>>3]-o);h[f>>3]=n;u=1.0-n;h[j>>3]=u;i=k;return}function vv(a){a=a|0;i=i;return+(+h[c[a+20>>2]>>3])}function wv(a){a=a|0;i=i;return+(+h[(c[a+20>>2]|0)+(c[a+16>>2]<<3)>>3])}function xv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;f=i;i=i+48|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;if((c[d+8>>2]|0)!=0){o=c[d+12>>2]|0;if((o|0)<0){p=-+h[(c[b+20>>2]|0)+(~o<<3)>>3]}else{p=+h[(c[b+20>>2]|0)+(o+ -1<<3)>>3]}h[a>>3]=p;q=0;i=f;return q|0}if(+wv(b)<e){q=1;i=f;return q|0}if(+vv(b)>e){q=1;i=f;return q|0}if((sv(b,1)|0)==0){q=1;i=f;return q|0}uv(e,c[c[b+40>>2]>>2]|0,c[b+28>>2]|0,m,g,n,j);o=c[n>>2]|0;if((o|0)==-1){q=~~+tv(a,b,c[d+12>>2]|0,c[m>>2]|0);i=f;return q|0}n=c[m>>2]|0;m=d+12|0;d=c[m>>2]|0;if((n|0)==-1){q=~~+tv(a,b,d,o);i=f;return q|0}if(+tv(k,b,d,n)!=0.0){q=1;i=f;return q|0}if(+tv(l,b,c[m>>2]|0,o)!=0.0){q=1;i=f;return q|0}h[a>>3]=+h[g>>3]*+h[k>>3]+ +h[j>>3]*+h[l>>3];q=0;i=f;return q|0}function yv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=zY(20)|0;Ou(0,(f|0)!=0|0,65864,e);c[f+8>>2]=0;c[f+12>>2]=0;e=(a|0)<1?1:a;c[f+16>>2]=e;c[f+4>>2]=b;a=BY(e,b)|0;c[f>>2]=a;Ou(0,(a|0)!=0|0,65864,d);i=d;return f|0}function zv(a){a=a|0;var b=0;b=i;AY(c[a>>2]|0);AY(a);i=b;return}function Av(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=a+12|0;Ou(0,(c[h>>2]|0)>0|0,65880,g);g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=1-g;c[f+8>>2]=g+ -1;Ou(0,(g|0)>(b|0)|0,65904,f);f=c[h>>2]|0;c[e>>2]=b;c[e+4>>2]=1-f;c[e+8>>2]=f+ -1;Ou(0,(0-f|0)<(b|0)|0,65904,e);e=(c[a>>2]|0)+(fa(c[a+4>>2]|0,((c[a+8>>2]|0)+b|0)%(c[a+16>>2]|0)|0)|0)|0;i=d;return e|0}function Bv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=a+16|0;e=a+4|0;f=BY(c[d>>2]<<1,c[e>>2]|0)|0;Ou(0,(f|0)!=0|0,65864,b);g=a+12|0;if((c[g>>2]|0)>0){h=c[e>>2]|0;j=0;do{k=f+(fa(h,j)|0)|0;l=Av(a,j)|0;h=c[e>>2]|0;dZ(k|0,l|0,h|0)|0;j=j+1|0;}while((j|0)<(c[g>>2]|0))}g=a;AY(c[g>>2]|0);c[g>>2]=f;c[d>>2]=c[d>>2]<<1;c[a+8>>2]=0;i=b;return}function Cv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+16|0;f=c[e>>2]|0;g=a+12|0;h=c[g>>2]|0;if((f|0)<(h+1|0)){Bv(a);j=c[e>>2]|0;k=c[g>>2]|0}else{j=f;k=h}h=c[a+4>>2]|0;dZ((c[a>>2]|0)+(fa(h,(k+(c[a+8>>2]|0)|0)%(j|0)|0)|0)|0,b|0,h|0)|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function Dv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=a+12|0;Ou(0,(c[h>>2]|0)>0|0,65880,g);g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=0;c[f+8>>2]=g+ -1;Ou(0,(g|0)>(b|0)|0,65904,f);f=(c[h>>2]|0)+ -1|0;c[e>>2]=b;c[e+4>>2]=0;c[e+8>>2]=f;Ou(0,b>>>31^1,65904,e);e=a+8|0;c[e>>2]=((c[e>>2]|0)+b|0)%(c[a+16>>2]|0)|0;c[h>>2]=(c[h>>2]|0)-b;i=d;return}function Ev(a){a=a|0;i=i;return c[a+12>>2]|0}function Fv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=a+12|0;Ou(0,(c[j>>2]|0)>0|0,65880,h);h=c[j>>2]|0;c[g>>2]=b;c[g+4>>2]=0;c[g+8>>2]=h+ -1;Ou(0,(h|0)>(b|0)|0,65904,g);g=(c[j>>2]|0)+ -1|0;c[f>>2]=b;c[f+4>>2]=0;c[f+8>>2]=g;Ou(0,b>>>31^1,65904,f);f=a+8|0;g=c[a+16>>2]|0;c[f>>2]=((fa(g+ -1|0,b)|0)+(c[f>>2]|0)|0)%(g|0)|0;if((d|0)==0){i=e;return}if((c[j>>2]|0)>0){k=0}else{i=e;return}do{c[d+(k<<2)>>2]=Av(a,k)|0;k=k+1|0;}while((k|0)<(c[j>>2]|0));i=e;return}function Gv(a){a=a|0;i=i;return c[(c[16484]|0)+(a<<2)>>2]|0}function Hv(a){a=a|0;i=i;return c[(c[16486]|0)+(a<<2)>>2]|0}function Iv(a){a=a|0;i=i;return c[(c[16488]|0)+(a<<2)>>2]|0}function Jv(a){a=a|0;i=i;return c[(c[16490]|0)+(a<<2)>>2]|0}function Kv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=(c[16486]|0)+(a<<2)|0;e=c[d>>2]|0;f=(c[16488]|0)+(a<<2)|0;g=c[f>>2]|0;h=c[(c[16484]|0)+(a<<2)>>2]|0;if((h|0)==0){i=b;return}c[d>>2]=(e|0)!=0&e>>>0<h>>>0?e:h;c[f>>2]=g>>>0>h>>>0?g:h;i=b;return}function Lv(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[16492]|0;e=+Mv(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Mv(a,b){a=a|0;b=b|0;i=i;return+(+(a|0)+ +(b|0)*1.0e-9)}function Nv(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[16494]|0;e=+Mv(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Ov(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[16496]|0;e=+Mv(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Pv(a){a=a|0;i=i;return 0}function Qv(a){a=a|0;var b=0,d=0;b=i;db(4,(c[16498]|0)+(a<<3)|0)|0;d=(c[16484]|0)+(a<<2)|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function Rv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[16492]|0;f=e+(a<<3)|0;g=c[16496]|0;h=g+(a<<3)|0;c[h>>2]=(c[h>>2]|0)+(c[f>>2]|0);h=e+(a<<3)+4|0;e=g+(a<<3)+4|0;c[e>>2]=(c[e>>2]|0)+(c[h>>2]|0);e=(c[16490]|0)+(a<<2)|0;c[e>>2]=(c[e>>2]|0)+(c[(c[16484]|0)+(a<<2)>>2]|0);e=c[16494]|0;g=e+(a<<3)|0;Sv(d,c[g>>2]|0,c[e+(a<<3)+4>>2]|0,c[f>>2]|0,c[h>>2]|0);h=d;d=c[h+4>>2]|0;f=g;c[f>>2]=c[h>>2];c[f+4>>2]=d;Kv(a);d=c[16492]|0;c[d+(a<<3)>>2]=0;c[d+(a<<3)+4>>2]=0;c[(c[16484]|0)+(a<<2)>>2]=0;i=b;return}function Sv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(Vv(b,d,e,f)|0)<0;if(h){j=e;k=f}else{j=b;k=d}d=a;c[d>>2]=j;c[d+4>>2]=k;i=g;return}function Tv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+8|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;db(4,d|0)|0;e=c[16498]|0;f=c[16492]|0;g=f+(a<<3)|0;h=(c[d>>2]|0)-(c[e+(a<<3)>>2]|0)+(c[g>>2]|0)|0;c[g>>2]=h;j=f+(a<<3)+4|0;f=(c[d+4>>2]|0)-(c[e+(a<<3)+4>>2]|0)+(c[j>>2]|0)|0;c[j>>2]=f;if((f|0)<=999999999){i=b;return}c[g>>2]=h+1;c[j>>2]=~~(+(f|0)+-1.0e9);i=b;return}function Uv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((a|0)<33){i=b;return}d=BY(a,8)|0;c[16492]=d;e=BY(a,8)|0;c[16494]=e;f=BY(a,8)|0;c[16496]=f;g=BY(a,8)|0;c[16498]=g;h=BY(a,4)|0;c[16484]=h;j=BY(a,4)|0;c[16490]=j;k=a<<2;l=zY(k)|0;c[16486]=l;m=BY(a,4)|0;c[16488]=m;fZ(l|0,-1,k|0)|0;if((d|0)==0){$a(66e3,66016,393,66032)}if((e|0)==0){$a(66040,66016,394,66032)}if((f|0)==0){$a(66056,66016,395,66032)}if((g|0)==0){$a(66072,66016,396,66032)}if((h|0)==0){$a(66088,66016,397,66032)}if((l|0)==0){$a(66112,66016,398,66032)}if((m|0)==0){$a(66136,66016,399,66032)}if((j|0)==0){$a(66160,66016,400,66032)}else{i=b;return}}function Vv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;i=i;return((a|0)==(c|0)?b-d|0:a-c|0)|0}function Wv(a){a=a|0;var b=0;b=i;AY(c[a+12>>2]|0);AY(c[a+4>>2]|0);AY(c[a+8>>2]|0);i=b;return}function Xv(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;z=~y;h[9072]=.5;h[9058]=1.0;h[9095]=.25;h[9070]=2.0;h[9097]=6.283185307179586;A=w+ -1-(c[b>>2]|0)|0;c[18152]=A;B=c[d>>2]|0;c[18082]=1;if((B|0)>=1){C=1;while(1){h[p+(C+ -1+(c[b>>2]|0)<<3)>>3]=0.0;D=C+1|0;c[18082]=D;if((C|0)<(B|0)){C=D}else{break}}}c[18080]=1;if((A|0)>=1){C=1;while(1){B=fa(C,w)|0;E=+h[j+(B+x+(c[n>>2]|0)<<3)>>3];h[9073]=E;if((C|0)<(c[k>>2]|0)){F=-E;h[9073]=F;G=F}else{G=E}D=c[d>>2]|0;c[18082]=1;a:do{if((D|0)>=1){E=G;H=1;while(1){I=p+(H+ -1+(c[b>>2]|0)<<3)|0;h[I>>3]=E*+h[j+(H+x+B<<3)>>3]+ +h[I>>3];I=H+1|0;c[18082]=I;if((H|0)>=(D|0)){break a}E=+h[9073];H=I}}}while(0);D=C+1|0;c[18080]=D;if((C|0)<(A|0)){C=D}else{break}}}C=c[b>>2]|0;h[9077]=+h[p+(C+ -1+(c[n>>2]|0)<<3)>>3];h[9042]=0.0;h[9044]=0.0;h[9048]=0.0;h[9105]=0.0;c[18078]=1;if((C|0)<1){J=0.0;K=0.0;L=0.0}else{G=0.0;A=1;while(1){D=A+ -1|0;B=o+(D<<3)|0;E=+h[B>>3];h[9042]=G+E*E;E=+h[f+((c[n>>2]|0)+x+(fa(A,w)|0)<<3)>>3];H=e+(D<<3)|0;F=E- +h[H>>3];I=s+(D<<3)|0;h[I>>3]=F;E=+h[9044]+ +h[B>>3]*F;h[9044]=E;F=+h[I>>3];M=+h[9048]+F*F;h[9048]=M;F=+h[H>>3];h[9105]=+h[9105]+F*F;H=A+1|0;c[18078]=H;F=+h[9042];if((A|0)<(C|0)){A=H;G=F}else{J=M;K=F;L=E;break}}}G=L*L;do{if(G>K*.99*J){A=c[n>>2]|0;c[18148]=A;E=G/J;h[9094]=E;C=c[d>>2]|0;c[18082]=1;if((C|0)<1){N=J;O=L;P=A}else{F=J;M=L;Q=E;H=A;A=1;while(1){do{if((A|0)==(c[m>>2]|0)){R=F;S=M;T=Q;U=H}else{h[9102]=0.0;h[9104]=0.0;I=c[b>>2]|0;c[18078]=1;if((I|0)<1){W=0.0;Z=0.0}else{E=0.0;_=0.0;B=1;while(1){$=+h[f+((fa(B,w)|0)+x+A<<3)>>3];aa=$- +h[e+(B+ -1<<3)>>3];h[9071]=aa;ba=_+aa*+h[o+(B+ -1<<3)>>3];h[9102]=ba;ca=E+aa*aa;h[9104]=ca;if((B|0)<(I|0)){B=B+1|0;_=ba;E=ca}else{break}}c[18078]=I+1;W=ca;Z=ba}E=Z*Z/W;if(!(E<Q)){R=F;S=M;T=Q;U=H;break}c[18148]=A;h[9094]=E;h[9044]=Z;h[9048]=W;R=W;S=Z;T=E;U=A}}while(0);B=A+1|0;c[18082]=B;if((A|0)<(C|0)){F=R;M=S;Q=T;H=U;A=B}else{N=R;O=S;P=U;break}}}A=c[b>>2]|0;c[18078]=1;if((A|0)<1){da=O;ea=N;ga=K;break}else{ha=1}while(1){Q=+h[f+((fa(ha,w)|0)+x+P<<3)>>3];H=ha+ -1|0;h[s+(H<<3)>>3]=Q- +h[e+(H<<3)>>3];if((ha|0)<(A|0)){ha=ha+1|0}else{break}}c[18078]=A+1;da=+h[9044];ea=+h[9048];ga=+h[9042]}else{da=L;ea=J;ga=K}}while(0);K=ga*ea-da*da;h[9093]=K;c[18176]=0;h[9101]=0.0;ha=(y<<1)+z|0;P=(y<<2)+z|0;U=(y*3|0)+z|0;H=(y*5|0)+z|0;ea=da;da=ga;ga=K;C=1;while(1){c[18176]=C;K=+h[9058]/+V(+ga);h[9073]=K;h[9096]=0.0;h[9098]=0.0;B=c[b>>2]|0;c[18078]=1;if((B|0)<1){ia=da;ja=0.0;ka=0.0}else{J=ea;L=da;N=K;D=1;la=0;while(1){ma=s+(la<<3)|0;h[ma>>3]=N*(L*+h[ma>>3]-J*+h[o+(la<<3)>>3]);ma=D+ -1|0;na=e+(ma<<3)|0;oa=+h[9096]+ +h[na>>3]*+h[o+(ma<<3)>>3];h[9096]=oa;pa=+h[9098]+ +h[na>>3]*+h[s+(ma<<3)>>3];h[9098]=pa;if((D|0)>=(B|0)){break}ma=D;J=+h[9044];L=+h[9042];N=+h[9073];D=D+1|0;la=ma}c[18078]=B+1;ia=+h[9042];ja=pa;ka=oa}N=+h[9072];L=ka*N*ka;h[9089]=L;J=ja*N*ja;h[9090]=J;h[9049]=J+(L+ia*(+h[9105]+ia*N));N=+h[9070];h[72400>>3]=N*ka*ia;h[72408>>3]=N*ja*ia;h[72416>>3]=L-J;h[72424>>3]=ka*ja;la=72432|0;c[la+0>>2]=0;c[la+4>>2]=0;c[la+8>>2]=0;c[la+12>>2]=0;c[la+16>>2]=0;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=0;c[18078]=10;la=c[d>>2]|0;c[18082]=1;if((la|0)>=1){D=1;while(1){h[9089]=0.0;h[9090]=0.0;h[9091]=0.0;A=c[b>>2]|0;c[18078]=1;if((A|0)<1){qa=0.0;ra=0.0}else{ma=D+x|0;J=0.0;L=0.0;N=0.0;na=1;while(1){K=+h[f+((fa(na,w)|0)+x+D<<3)>>3];sa=N+K*+h[o+(na+ -1<<3)>>3];h[9089]=sa;ta=f+(ma+(fa(na,w)|0)<<3)|0;ua=na+ -1|0;va=L+ +h[ta>>3]*+h[s+(ua<<3)>>3];h[9090]=va;K=J+ +h[ta>>3]*+h[e+(ua<<3)>>3];h[9091]=K;if((na|0)<(A|0)){na=na+1|0;N=sa;L=va;J=K}else{break}}c[18078]=A+1;qa=va;ra=sa}h[t+(D+ -1<<3)>>3]=+h[9095]*(ra*ra+qa*qa);h[t+(ha+D<<3)>>3]=+h[9089]*+h[9091];h[t+(U+D<<3)>>3]=+h[9090]*+h[9091];J=+h[9089];L=+h[9090];h[t+(P+D<<3)>>3]=+h[9095]*(J*J-L*L);h[t+(H+D<<3)>>3]=+h[9072]*+h[9089]*+h[9090];na=D+1|0;c[18082]=na;if((D|0)<(la|0)){D=na}else{break}}}D=c[b>>2]|0;c[18078]=1;if((D|0)>=1){la=1;while(1){B=(c[d>>2]|0)+la|0;c[18090]=B;h[t+(B+ -1<<3)>>3]=0.0;na=la+ -1|0;h[t+(ha+B<<3)>>3]=+h[o+(na<<3)>>3];h[t+(U+B<<3)>>3]=+h[s+(na<<3)>>3];h[t+(P+B<<3)>>3]=0.0;h[t+(H+B<<3)>>3]=0.0;B=la+1|0;c[18078]=B;if((la|0)<(D|0)){la=B}else{break}}}c[18086]=1;la=1;do{D=c[d>>2]|0;c[18094]=D;if((la&-2|0)==2){B=c[l>>2]|0;c[18094]=B;wa=B}else{wa=D}D=c[d>>2]|0;c[18082]=1;if((D|0)>=1){B=fa(la,y)|0;na=1;while(1){h[u+(na+z+B<<3)>>3]=0.0;if((na|0)<(D|0)){na=na+1|0}else{break}}c[18082]=D+1}na=c[18152]|0;c[18080]=1;if((na|0)<1){xa=la}else{B=1;A=la;while(1){h[9069]=0.0;ma=c[d>>2]|0;c[18082]=1;if((ma|0)<1){ya=0.0;za=A}else{ua=fa(la,y)|0;L=0.0;ta=1;while(1){J=+h[j+(ta+x+(fa(B,w)|0)<<3)>>3];Aa=L+J*+h[t+(ta+z+ua<<3)>>3];h[9069]=Aa;if((ta|0)<(ma|0)){ta=ta+1|0;L=Aa}else{break}}c[18082]=ma+1;ya=Aa;za=la}if((B|0)<(c[k>>2]|0)){L=-ya;h[9069]=L;Ba=L}else{Ba=ya}ta=c[d>>2]|0;c[18082]=1;if((ta|0)>=1){ua=fa(B,w)|0;I=fa(za,y)|0;L=Ba;Ca=1;while(1){Da=u+(Ca+z+I<<3)|0;h[Da>>3]=L*+h[j+(Ca+x+ua<<3)>>3]+ +h[Da>>3];if((Ca|0)>=(ta|0)){break}L=+h[9069];Ca=Ca+1|0}c[18082]=ta+1}Ca=B+1|0;c[18080]=Ca;if((B|0)<(na|0)){B=Ca;A=za}else{xa=za;break}}}do{if((wa|0)==(c[l>>2]|0)){A=c[d>>2]|0;c[18082]=1;if((A|0)<1){break}else{Ea=1}while(1){h[9069]=0.0;B=c[b>>2]|0;c[18080]=1;if((B|0)<1){Fa=fa(xa,y)|0;Ga=0.0}else{L=0.0;na=1;while(1){J=+h[g+((fa(na,y)|0)+z+Ea<<3)>>3];D=fa(xa,y)|0;N=L+J*+h[t+(na+z+(c[d>>2]|0)+D<<3)>>3];h[9069]=N;Ca=na+1|0;c[18080]=Ca;if((na|0)<(B|0)){na=Ca;L=N}else{Fa=D;Ga=N;break}}}na=u+(Ea+z+Fa<<3)|0;h[na>>3]=Ga+ +h[na>>3];na=Ea+1|0;c[18082]=na;if((Ea|0)<(A|0)){Ea=na}else{break}}}}while(0);A=c[b>>2]|0;c[18080]=1;if((A|0)>=1){ta=1;while(1){h[9069]=0.0;c[18078]=1;if((wa|0)<1){Ha=fa(xa,y)|0;Ia=0.0}else{na=fa(ta,y)|0;B=fa(xa,y)|0;L=0.0;D=1;while(1){Ca=D+z|0;Ja=L+ +h[g+(Ca+na<<3)>>3]*+h[t+(Ca+B<<3)>>3];h[9069]=Ja;if((D|0)<(wa|0)){D=D+1|0;L=Ja}else{break}}c[18078]=wa+1;Ha=B;Ia=Ja}h[u+((c[d>>2]|0)+z+ta+Ha<<3)>>3]=Ia;D=ta+1|0;c[18080]=D;if((ta|0)<(A|0)){ta=D}else{break}}}la=xa+1|0;c[18086]=la;}while((la|0)<6);la=c[l>>2]|0;c[18082]=1;h[9069]=0.0;c[18078]=1;L=+h[9072];if((la|0)<1){Ka=L}else{N=L;ta=1;while(1){L=0.0;A=1;do{D=(fa(A,y)|0)+z+ta|0;h[72472+(A+ -1<<3)>>3]=N*+h[u+(D<<3)>>3]*+h[t+(D<<3)>>3];L=+h[72472+(A+ -1<<3)>>3]+L;h[9069]=L;A=A+1|0;}while((A|0)<6);h[9049]=+h[9049]- +h[9059]-L;A=ta+ -1|0;D=u+(A<<3)|0;na=ha+ta|0;Ca=t+(na<<3)|0;ua=u+(na<<3)|0;na=t+(A<<3)|0;J=+h[D>>3]*+h[Ca>>3]+ +h[ua>>3]*+h[na>>3];h[9089]=J;A=P+ta|0;I=t+(A<<3)|0;ma=u+(A<<3)|0;K=+h[ua>>3]*+h[I>>3]+ +h[ma>>3]*+h[Ca>>3];h[9090]=K;A=U+ta|0;Da=u+(A<<3)|0;La=H+ta|0;Ma=t+(La<<3)|0;Na=u+(La<<3)|0;La=t+(A<<3)|0;O=+h[Da>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[La>>3];h[9091]=O;h[72400>>3]=+h[72400>>3]-J-N*(O+K);h[72432>>3]=+h[72432>>3]-N*(K-O);O=+h[D>>3]*+h[La>>3]+ +h[Da>>3]*+h[na>>3];h[9089]=O;K=+h[ua>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[Ca>>3];h[9090]=K;J=+h[Da>>3]*+h[I>>3]+ +h[ma>>3]*+h[La>>3];h[9091]=J;h[72408>>3]=+h[72408>>3]-O-N*(K-J);h[72440>>3]=+h[72440>>3]-N*(K+J);J=+h[D>>3]*+h[I>>3]+ +h[ma>>3]*+h[na>>3];h[9089]=J;h[72416>>3]=+h[72488>>3]+(+h[72416>>3]-J- +h[72480>>3]);J=+h[D>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[na>>3];h[9089]=J;K=+h[ua>>3]*+h[La>>3]+ +h[Da>>3]*+h[Ca>>3];h[9090]=K;Oa=+h[9072];h[72424>>3]=+h[72424>>3]-J-K*Oa;h[72448>>3]=+h[72448>>3]- +h[72496>>3]+ +h[72504>>3];K=+h[ma>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[I>>3];h[9089]=K;h[72456>>3]=+h[72456>>3]-Oa*K;h[9069]=0.0;if((ta|0)<(la|0)){N=Oa;ta=ta+1|0}else{break}}c[18082]=la+1;c[18078]=1;Ka=Oa}N=0.0;ta=1;do{K=+h[u+((fa(ta,y)|0)+z+(c[n>>2]|0)<<3)>>3];h[72472+(ta+ -1<<3)>>3]=Ka*K*K;N=+h[72472+(ta+ -1<<3)>>3]+N;h[9069]=N;ta=ta+1|0;c[18078]=ta;}while((ta|0)<6);K=+h[9077];h[9079]=K*+h[9049]+ +h[9059]+N;J=+h[9070];ta=c[n>>2]|0;la=u+(ta+ -1<<3)|0;I=u+(ha+ta<<3)|0;O=J*+h[la>>3]*+h[I>>3];h[9089]=O;Na=u+(P+ta<<3)|0;S=+h[I>>3]*+h[Na>>3];h[9090]=S;Ma=u+(U+ta<<3)|0;ma=u+(H+ta<<3)|0;R=+h[Ma>>3]*+h[ma>>3];h[9091]=R;T=R+(K*+h[72400>>3]+O+S);h[72640>>3]=T;O=K*+h[72432>>3]+S-R;h[72672>>3]=O;R=J*+h[la>>3]*+h[Ma>>3];h[9089]=R;S=+h[I>>3]*+h[ma>>3];h[9090]=S;Z=+h[Ma>>3]*+h[Na>>3];h[9091]=Z;h[72648>>3]=K*+h[72408>>3]+R+S-Z;h[72680>>3]=K*+h[72440>>3]+S+Z;Z=J*+h[la>>3]*+h[Na>>3];h[9089]=Z;R=+h[72480>>3]+(Z+K*+h[72416>>3])- +h[72488>>3];h[72656>>3]=R;Z=J*+h[la>>3]*+h[ma>>3];h[9089]=Z;h[72664>>3]=Z+K*+h[72424>>3]+ +h[I>>3]*+h[Ma>>3];J=K*+h[72448>>3]+ +h[72496>>3]- +h[72504>>3];h[72688>>3]=J;h[72696>>3]=+h[9077]*+h[72456>>3]+ +h[Na>>3]*+h[ma>>3];K=+h[9079]+T+R+O+J;h[9069]=K;h[9099]=K;h[9100]=K;c[18184]=0;J=+h[9097]/50.0;h[9073]=J;h[9059]=+h[9058];c[18078]=1;O=K;ma=0;R=K;T=S;S=Z;Na=1;while(1){Pa=+(Na|0)*J;Z=+X(+Pa);h[72480>>3]=Z;W=+Y(+Pa);h[72488>>3]=W;ba=W;ca=Z;G=W;W=Z;Ma=4;while(1){Z=ca*W-ba*G;h[72472+(Ma+ -1<<3)>>3]=Z;Q=+h[72480>>3]*G+ +h[72488>>3]*W;h[72472+(Ma<<3)>>3]=Q;I=Ma+2|0;if((I|0)>=9){Qa=1;Ra=0.0;break}ba=+h[72488>>3];ca=+h[72480>>3];Ma=I;W=Z;G=Q}do{Ma=Qa+ -1|0;Ra=Ra+ +h[72632+(Ma<<3)>>3]*+h[72472+(Ma<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<10);if(!(Ra>=0.0)){Sa=-Ra}else{Sa=Ra}if(!(R>=0.0)){Ta=-R}else{Ta=R}do{if(Sa>Ta){h[9100]=Ra;c[18184]=Na;h[9089]=O;Ua=Ra;Va=T;Wa=O;Xa=Na}else{if((Na|0)!=(ma+1|0)){Ua=R;Va=T;Wa=S;Xa=ma;break}h[9090]=Ra;Ua=R;Va=Ra;Wa=S;Xa=ma}}while(0);if((Na|0)>48){break}else{O=Ra;ma=Xa;R=Ua;T=Va;S=Wa;Na=Na+1|0}}c[18080]=10;h[9069]=Ra;h[9078]=Pa;h[9103]=O;c[18078]=50;if((Xa|0)==0){h[9089]=Ra;Ya=Ra;Za=Va}else if((Xa|0)==49){h[9090]=K;Ya=Wa;Za=K}else{Ya=Wa;Za=Va}h[9075]=0.0;if(Ya!=Za){S=Ya-Ua;h[9089]=S;T=Za-Ua;h[9090]=T;R=+h[9072]*(S-T)/(S+T);h[9075]=R;_a=R}else{_a=0.0}R=J*(+(Xa|0)+_a);h[9078]=R;T=+X(+R);h[72480>>3]=T;S=+Y(+R);h[72488>>3]=S;c[18080]=4;R=S;N=T;G=S;S=T;Na=4;while(1){T=N*S-R*G;h[72472+(Na+ -1<<3)>>3]=T;W=+h[72480>>3]*G+ +h[72488>>3]*S;h[72472+(Na<<3)>>3]=W;ma=Na+2|0;if((ma|0)>=9){break}R=+h[72488>>3];N=+h[72480>>3];Na=ma;S=T;G=W}h[r>>3]=0.0;h[9100]=0.0;c[18080]=1;Na=1;do{ma=Na+ -1|0;Ma=72472+(ma<<3)|0;h[r>>3]=+h[r>>3]+ +h[72392+(ma<<3)>>3]*+h[Ma>>3];h[9100]=+h[9100]+ +h[72632+(ma<<3)>>3]*+h[Ma>>3];Na=Na+1|0;}while((Na|0)<10);c[18080]=10;Na=c[l>>2]|0;c[18082]=1;if((Na|0)>=1){Ma=1;while(1){h[q+(Ma+ -1<<3)>>3]=0.0;ma=1;do{G=+h[u+((fa(ma,y)|0)+z+Ma<<3)>>3];I=q+(Ma+ -1<<3)|0;h[I>>3]=+h[I>>3]+G*+h[72472+(ma+ -1<<3)>>3];ma=ma+1|0;}while((ma|0)<6);if((Ma|0)<(Na|0)){Ma=Ma+1|0}else{break}}c[18080]=6;c[18082]=Na+1}h[9068]=+h[q+((c[n>>2]|0)+ -1<<3)>>3];h[9042]=0.0;h[9089]=0.0;h[9090]=0.0;Ma=c[b>>2]|0;c[18078]=1;if((Ma|0)<1){$a=0.0;ab=0.0}else{ma=1;while(1){I=ma+ -1|0;la=o+(I<<3)|0;h[la>>3]=+h[72480>>3]*+h[la>>3]+ +h[72488>>3]*+h[s+(I<<3)>>3];I=ma+ -1|0;la=o+(I<<3)|0;ta=p+(I<<3)|0;h[ta>>3]=+h[e+(I<<3)>>3]+ +h[la>>3];G=+h[la>>3];h[9042]=+h[9042]+G*G;bb=+h[9089]+ +h[la>>3]*+h[ta>>3];h[9089]=bb;G=+h[ta>>3];cb=+h[9090]+G*G;h[9090]=cb;if((ma|0)<(Ma|0)){ma=ma+1|0}else{break}}c[18078]=Ma+1;$a=cb;ab=bb}ma=c[18176]|0;Na=c[b>>2]|0;if((ma|0)>=(Na|0)){break}if((ma|0)>1){G=+h[9101];S=+h[9099];h[9101]=G>=S?G:S}S=+h[9100];if(!(S>=0.0)){db=-S}else{db=S}G=+h[9101];if(!(G>=0.0)){eb=-G}else{eb=G}if(db<=eb*1.1){break}h[9101]=S;c[18078]=1;b:do{if((Na|0)>=1){S=$a;G=ab;ta=1;while(1){la=ta+ -1|0;N=G*+h[e+(la<<3)>>3]+S*+h[o+(la<<3)>>3]- +h[q+(la+(c[d>>2]|0)<<3)>>3];h[9073]=N;R=+h[9068]*+h[g+((c[n>>2]|0)+z+(fa(ta,y)|0)<<3)>>3];h[s+(la<<3)>>3]=R+N*+h[9077];la=ta+1|0;c[18078]=la;if((ta|0)>=(Na|0)){break b}S=+h[9090];G=+h[9089];ta=la}}}while(0);Na=c[d>>2]|0;c[18082]=1;if((Na|0)>=1){Ma=1;while(1){h[9069]=0.0;ta=c[b>>2]|0;c[18080]=1;if((ta|0)<1){fb=0.0}else{G=0.0;la=1;while(1){S=+h[f+((fa(la,w)|0)+x+Ma<<3)>>3];gb=G+S*+h[p+(la+ -1<<3)>>3];h[9069]=gb;if((la|0)<(ta|0)){la=la+1|0;G=gb}else{break}}c[18080]=ta+1;fb=gb}la=c[b>>2]|0;G=fb*(+h[9068]*+h[p+(la+ -1+Ma<<3)>>3]- +h[9077]*+h[q+(Ma+ -1<<3)>>3]);h[9073]=G;c[18078]=1;if((la|0)>=1){S=G;I=1;while(1){G=S*+h[f+((fa(I,w)|0)+x+Ma<<3)>>3];Ca=s+(I+ -1<<3)|0;h[Ca>>3]=+h[Ca>>3]+G;if((I|0)>=(la|0)){break}S=+h[9073];I=I+1|0}c[18078]=la+1}I=Ma+1|0;c[18082]=I;if((Ma|0)<(Na|0)){Ma=I}else{break}}}h[9048]=0.0;h[9044]=0.0;Ma=c[b>>2]|0;c[18078]=1;if((Ma|0)<1){hb=0.0;ib=0.0}else{S=0.0;G=0.0;Na=1;while(1){N=+h[s+(Na+ -1<<3)>>3];jb=G+N*N;h[9048]=jb;I=Na+ -1|0;kb=S+ +h[o+(I<<3)>>3]*+h[s+(I<<3)>>3];h[9044]=kb;if((Na|0)<(Ma|0)){Na=Na+1|0;G=jb;S=kb}else{break}}c[18078]=Ma+1;hb=kb;ib=jb}S=+h[9042];G=S*ib-hb*hb;h[9093]=G;if(!(G>=S*1.0e-8*ib)){break}ea=hb;da=S;ga=G;C=ma+1|0}a[72368]=1;C=c[l>>2]|0;c[18082]=1;if((C|0)<1){lb=72464;mb=+h[9058];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}else{vb=1}while(1){h[p+(vb+ -1<<3)>>3]=0.0;l=1;do{ga=+h[t+((fa(l,y)|0)+z+vb<<3)>>3];s=p+(vb+ -1<<3)|0;h[s>>3]=+h[s>>3]+ga*+h[72472+(l+ -1<<3)>>3];l=l+1|0;}while((l|0)<6);if((vb|0)<(C|0)){vb=vb+1|0}else{break}}c[18080]=6;c[18082]=C+1;lb=72464;mb=+h[9058];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}function Yv(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;l=~y;h[9125]=.5;h[9121]=1.0;h[9137]=6.283185307179586;z=+h[n>>3];h[9134]=z*z;A=w+ -1-(c[b>>2]|0)|0;c[18256]=A;c[18264]=0;B=c[d>>2]|0;c[18216]=1;if((B|0)>=1){C=1;while(1){h[q+(C+ -1<<3)>>3]=0.0;if((C|0)<(B|0)){C=C+1|0}else{break}}c[18216]=B+1}c[18214]=1;B=c[m>>2]|0;if((A|0)<1){D=B}else{C=B;B=1;while(1){E=fa(B,w)|0;z=+h[j+(E+x+C<<3)>>3];h[9126]=z;if((B|0)<(c[k>>2]|0)){F=-z;h[9126]=F;G=F}else{G=z}H=c[d>>2]|0;c[18216]=1;if((H|0)>=1){z=G;I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]+z*+h[j+(I+x+E<<3)>>3];if((I|0)>=(H|0)){break}z=+h[9126];I=I+1|0}c[18216]=H+1}I=B+1|0;c[18214]=I;E=c[m>>2]|0;if((B|0)<(A|0)){C=E;B=I}else{D=E;break}}}h[p>>3]=+h[q+(D+ -1<<3)>>3];h[9109]=0.0;D=c[b>>2]|0;c[18212]=1;if((D|0)>=1){p=1;while(1){B=c[m>>2]|0;G=+h[f+((fa(p,w)|0)+x+B<<3)>>3];C=p+ -1|0;A=o+(C<<3)|0;h[A>>3]=G- +h[e+(C<<3)>>3];h[r+(C<<3)>>3]=+h[g+(B+l+(fa(p,y)|0)<<3)>>3];h[s+(C<<3)>>3]=0.0;G=+h[A>>3];h[9109]=+h[9109]+G*G;A=p+1|0;c[18212]=A;if((p|0)<(D|0)){p=A}else{break}}}p=c[d>>2]|0;c[18216]=1;if((p|0)>=1){D=1;while(1){h[9126]=0.0;h[9124]=0.0;y=c[b>>2]|0;c[18214]=1;if((y|0)<1){K=0.0;L=0.0}else{l=D+x|0;G=0.0;z=0.0;g=1;while(1){F=+h[f+((fa(g,w)|0)+x+D<<3)>>3];M=z+F*+h[e+(g+ -1<<3)>>3];h[9126]=M;F=+h[f+(l+(fa(g,w)|0)<<3)>>3];N=G+F*+h[o+(g+ -1<<3)>>3];h[9124]=N;if((g|0)<(y|0)){g=g+1|0;z=M;G=N}else{break}}c[18214]=y+1;K=M;L=N}g=q+(D+ -1<<3)|0;G=+h[g>>3]*K;h[9126]=G;h[9124]=+h[g>>3]*L;g=c[b>>2]|0;c[18212]=1;if((g|0)>=1){l=D+x|0;z=G;H=1;while(1){G=z*+h[f+((fa(H,w)|0)+x+D<<3)>>3];m=r+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;G=+h[9124]*+h[f+(l+(fa(H,w)|0)<<3)>>3];m=s+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;if((H|0)>=(g|0)){break}z=+h[9126];H=H+1|0}c[18212]=g+1}H=D+1|0;c[18216]=H;if((D|0)<(p|0)){D=H}else{break}}}h[9110]=0.0;h[9112]=0.0;h[9119]=0.0;D=c[b>>2]|0;c[18212]=1;if((D|0)<1){O=0.0;P=0.0;Q=0.0}else{L=0.0;K=0.0;N=0.0;p=1;while(1){M=+h[r+(p+ -1<<3)>>3];R=N+M*M;h[9110]=R;e=p+ -1|0;H=o+(e<<3)|0;S=K+ +h[H>>3]*+h[r+(e<<3)>>3];h[9112]=S;T=L+ +h[H>>3]*+h[s+(e<<3)>>3];h[9119]=T;if((p|0)<(D|0)){p=p+1|0;N=R;K=S;L=T}else{break}}c[18212]=D+1;O=R;P=T;Q=S}S=+h[9109];T=+h[n>>3]/+V(+S);if(Q*P<0.0){U=-T}else{U=T}h[9130]=U;h[9126]=0.0;if(Q*Q>S*.99*O){h[9126]=+h[9121]}if(!(Q>=0.0)){W=-Q}else{W=Q}if(!(P>=0.0)){Z=-P}else{Z=P}P=U*(W+ +h[9125]*U*Z);h[9122]=P;if(O*+h[9134]<P*P*.01){h[9126]=+h[9121]}n=c[b>>2]|0;c[18212]=1;if((n|0)<1){_=0}else{P=U;D=1;p=0;while(1){e=o+(p<<3)|0;h[e>>3]=P*+h[e>>3];e=D+ -1|0;H=s+(e<<3)|0;U=+h[9130]*+h[H>>3];h[H>>3]=U;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+ +h[9126]*U;if((D|0)>=(n|0)){break}e=D;P=+h[9130];D=D+1|0;p=e}c[18212]=n+1;_=0}while(1){n=_+1|0;c[18264]=n;h[9109]=0.0;h[9112]=0.0;h[9113]=0.0;p=c[b>>2]|0;c[18212]=1;if((p|0)<1){$=0.0;aa=0.0;ba=0.0}else{P=0.0;U=0.0;O=0.0;D=1;while(1){Z=+h[o+(D+ -1<<3)>>3];ca=O+Z*Z;h[9109]=ca;e=D+ -1|0;H=t+(e<<3)|0;da=U+ +h[o+(e<<3)>>3]*+h[H>>3];h[9112]=da;Z=+h[H>>3];ea=P+Z*Z;h[9113]=ea;if((D|0)<(p|0)){D=D+1|0;O=ca;U=da;P=ea}else{break}}c[18212]=p+1;$=da;aa=ea;ba=ca}P=ba*aa-$*$;h[9126]=P;if(P<=ba*1.0e-8*aa){ga=88;break}U=+V(+P);h[9131]=U;D=c[b>>2]|0;c[18212]=1;if((D|0)>=1){P=U;U=$;O=ba;g=1;H=0;while(1){e=t+(H<<3)|0;h[e>>3]=(O*+h[e>>3]-U*+h[o+(H<<3)>>3])/P;h[u+(g+ -1<<3)>>3]=0.0;if((g|0)>=(D|0)){break}e=g;P=+h[9131];U=+h[9112];O=+h[9109];g=g+1|0;H=e}c[18212]=D+1}H=c[d>>2]|0;c[18216]=1;if((H|0)>=1){g=1;while(1){h[9124]=0.0;p=c[b>>2]|0;c[18214]=1;if((p|0)<1){ha=0.0}else{O=0.0;e=1;while(1){U=+h[f+((fa(e,w)|0)+x+g<<3)>>3];ia=O+U*+h[t+(e+ -1<<3)>>3];h[9124]=ia;if((e|0)<(p|0)){e=e+1|0;O=ia}else{break}}c[18214]=p+1;ha=ia}O=+h[q+(g+ -1<<3)>>3]*ha;h[9124]=O;e=c[b>>2]|0;c[18212]=1;if((e|0)>=1){U=O;l=1;while(1){O=U*+h[f+((fa(l,w)|0)+x+g<<3)>>3];y=u+(l+ -1<<3)|0;h[y>>3]=+h[y>>3]+O;if((l|0)>=(e|0)){break}U=+h[9124];l=l+1|0}c[18212]=e+1}l=g+1|0;c[18216]=l;if((g|0)<(H|0)){g=l}else{break}}}h[9114]=0.0;h[9115]=0.0;h[9116]=0.0;h[9117]=0.0;h[9118]=0.0;g=c[b>>2]|0;c[18212]=1;if((g|0)<1){ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0}else{U=0.0;O=0.0;P=0.0;Z=0.0;W=0.0;H=1;while(1){D=H+ -1|0;oa=W+ +h[t+(D<<3)>>3]*+h[u+(D<<3)>>3];h[9114]=oa;D=H+ -1|0;l=o+(D<<3)|0;p=r+(D<<3)|0;pa=Z+ +h[l>>3]*+h[p>>3];h[9115]=pa;y=t+(D<<3)|0;qa=P+ +h[y>>3]*+h[p>>3];h[9116]=qa;p=s+(D<<3)|0;ra=O+ +h[l>>3]*+h[p>>3];h[9117]=ra;sa=U+ +h[y>>3]*+h[p>>3];h[9118]=sa;if((H|0)<(g|0)){H=H+1|0;W=oa;Z=pa;P=qa;O=ra;U=sa}else{break}}c[18212]=g+1;ja=sa;ka=qa;la=pa;ma=ra;na=oa}U=+h[9125];O=U*na;h[9114]=O;P=U*ma-O;h[9117]=P;Z=O+la+P;h[9138]=Z;h[9140]=Z;h[9139]=Z;c[18266]=0;a[72888]=1;W=+h[9137]/50.0;h[9126]=W;c[18212]=1;H=0;Q=Z;S=Z;p=1;while(1){ta=+(p|0)*W;ua=+X(+ta);va=+Y(+ta);wa=O+ua*(la+ua*P)+va*(ka+ua*ja);if(!(wa>=0.0)){xa=-wa}else{xa=wa}if(!(Q>=0.0)){ya=-Q}else{ya=Q}do{if(xa>ya){h[9140]=wa;c[18266]=p;h[9135]=S;za=p;Aa=wa}else{if((p|0)!=(H+1|0)){za=H;Aa=Q;break}h[9136]=wa;za=H;Aa=Q}}while(0);e=p+1|0;if((e|0)<50){H=za;Q=Aa;p=e;S=wa}else{break}}h[9129]=ta;h[9120]=ua;h[9123]=va;h[9122]=wa;c[18212]=50;h[9139]=wa;if((za|0)==49){h[9136]=Z;Ba=Z}else if((za|0)==0){h[9135]=wa;ga=74}else{ga=74}if((ga|0)==74){ga=0;Ba=+h[9136]}h[9127]=0.0;S=+h[9135];if(S!=Ba){Q=S-Aa;h[9135]=Q;S=Ba-Aa;h[9136]=S;T=U*(Q-S)/(Q+S);h[9127]=T;Ca=T}else{Ca=0.0}T=W*(+(za|0)+Ca);h[9129]=T;S=+X(+T);h[9120]=S;Q=+Y(+T);h[9123]=Q;T=O+S*(la+S*P)+Q*(ka+S*ja);h[9122]=T;p=c[b>>2]|0;c[18212]=1;if((p|0)<1){Da=T}else{T=Q;Q=S;H=1;g=0;while(1){e=o+(g<<3)|0;h[e>>3]=Q*+h[e>>3]+T*+h[t+(g<<3)>>3];e=H+ -1|0;y=s+(e<<3)|0;S=+h[9120]*+h[y>>3]+ +h[9123]*+h[u+(e<<3)>>3];h[y>>3]=S;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+S;if((H|0)>=(p|0)){break}e=H;T=+h[9123];Q=+h[9120];H=H+1|0;g=e}c[18212]=p+1;Da=+h[9122]}if(!(Da>=0.0)){Ea=-Da}else{Ea=Da}Q=+h[9138];if(!(Q>=0.0)){Fa=-Q}else{Fa=Q}if(Ea<=Fa*1.1){ga=88;break}if((n|0)<(c[b>>2]|0)){_=n}else{ga=88;break}}if((ga|0)==88){i=v;return 0}return 0}function Zv(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;n=i;a[73344]=1;a[73336]=1;c[73356>>2]=6;cN(73352)|0;e=c[d>>2]|0;c[18332]=1;if((e|0)>=1){d=1;do{tM(73472,b+(d+ -1)|0,1)|0;o=c[18332]|0;d=o+1|0;c[18332]=d;}while((o|0)<(e|0))}MM()|0;e=c[g>>2]|0;if((e|0)==1){c[73380>>2]=a[73336]&1?6:0;cN(73376)|0;tM(73472,h,4)|0;MM()|0;p=c[g>>2]|0}else{p=e}if((p|0)==2){c[73404>>2]=a[73336]&1?6:0;cN(73400)|0;tM(73472,h,4)|0;tM(73472,j,4)|0;MM()|0}j=c[k>>2]|0;if((j|0)==1){c[73428>>2]=a[73336]&1?6:0;cN(73424)|0;tM(73472,l,8)|0;MM()|0;q=c[k>>2]|0}else{q=j}if((q|0)==2){c[73452>>2]=a[73336]&1?6:0;cN(73448)|0;tM(73472,l,8)|0;tM(73472,m,8)|0;MM()|0}if((c[f>>2]|0)==2){dM(73480,0)|0}else{i=n;return 0}return 0}function _v(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0;y=i;i=i+8|0;z=y;A=c[k>>2]|0;a:do{if((A|0)==1){c[q+36>>2]=c[q+40>>2];B=27}else if((A|0)==-1){iM(73552,73784,80,49);C=73856;D=73864;Zv(73552,73840,73848,C,C,C,C,C,D,D,80)|0;iM(73552,73872,80,47);D=73856;C=73864;Zv(73552,73920,73928,D,73936,n,D,D,C,C,80)|0;iM(73552,73944,80,41);C=73856;D=73864;Zv(73552,73992,74e3,73936,C,C,C,C,D,D,80)|0;i=y;return 0}else if((A|0)==0){c[18374]=2;D=2;while(1){C=D+1|0;if(!((c[k+(D+ -1<<2)>>2]|0)>>>0<2)){B=210;break a}c[18374]=C;if((C|0)<12){D=C}else{break}}if((c[d>>2]|0)<1){iM(73552,75248,80,25);D=73856;C=73864;Zv(73552,75280,74032,D,73936,d,D,D,C,C,80)|0;break}c[18438]=5;C=q+8|0;do{if((c[k+32>>2]|0)==0){E=5}else{D=c[C>>2]|0;c[18438]=D;if(!((D+ -1|0)>>>0>4)){E=D;break}iM(73552,75288,80,34);D=73856;F=73864;Zv(73552,75328,74024,D,73936,73752,D,D,F,F,80)|0;break a}}while(0);c[C>>2]=E;b:do{if((c[k+20>>2]|0)==0){F=c[d>>2]|0;D=fa(F,F)|0;c[18424]=D;c[18436]=D+50+(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0);D=q+12|0;if((c[k+16>>2]|0)==0){c[D>>2]=2;break}else{c[D>>2]=1;break}}else{D=c[q>>2]|0;do{if((D|0)>=0){F=c[d>>2]|0;if((D|0)>=(F|0)){break}G=q+4|0;H=c[G>>2]|0;if(!((H|0)>-1&(H|0)<(F|0))){iM(73552,76112,80,52);I=73856;J=73864;Zv(73552,76096,76168,I,73936,G,I,I,J,J,80)|0;break a}c[18424]=fa((D<<1|1)+H|0,F)|0;F=q+12|0;if((c[k+16>>2]|0)==0){c[F>>2]=5;H=c[d>>2]|0;J=fa((c[C>>2]|0)+4|0,H)|0;c[18436]=(((H|0)/((c[q>>2]|0)+1+(c[G>>2]|0)|0)|0)<<1)+52+(c[18424]|0)+J;break b}else{c[F>>2]=4;F=(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0)+50|0;c[18436]=F+(c[18424]|0);break b}}}while(0);iM(73552,76040,80,52);D=73856;F=73864;Zv(73552,76096,76104,D,73936,q,D,D,F,F,80)|0;break a}}while(0);c[18428]=(c[d>>2]|0)+20;c[q+64>>2]=c[18424];if((c[p>>2]|0)<(c[18436]|0)){iM(73552,75336,80,60);C=73856;F=73864;Zv(73552,75400,75408,C,74032,73744,p,C,F,F,80)|0;break}if((c[r>>2]|0)<(c[18428]|0)){iM(73552,75416,80,60);F=73856;C=73864;Zv(73552,75400,75480,F,74032,73712,r,F,C,C,80)|0;break}if(+h[j>>3]==+h[e>>3]){B=227;break}if((c[w>>2]|0)<0){iM(73552,76224,80,24);C=73936;F=73856;D=73864;Zv(73552,76256,76264,C,C,w,F,F,D,D,80)|0;break}do{if((c[k+24>>2]|0)!=0){K=+h[o+8>>3];h[9209]=K;if(!(K<=0.0)){break}iM(73552,75720,80,28);D=73856;Zv(73552,74432,75752,D,D,D,D,73936,73672,73864,80)|0;break a}}while(0);c[q+60>>2]=0;D=q+36|0;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[D+12>>2]=0;c[n>>2]=1;B=27}else{B=210}}while(0);c:do{if((B|0)==27){a[73728]=0;K=+h[l>>3];h[9220]=K;L=+h[m>>3];h[9213]=L;r=c[d>>2]|0;c[18374]=1;do{if((r|0)>=1){p=k+4|0;E=0;A=1;M=L;N=K;while(1){if((c[p>>2]|0)==1){D=A+ -1|0;O=+h[l+(D<<3)>>3];h[9220]=O;P=+h[m+(D<<3)>>3];h[9213]=P;Q=O;R=P}else{Q=N;R=M}if(Q>0.0|R>0.0){a[73728]=1;S=1}else{S=E}if(Q<0.0){B=215;break}if(R<0.0){B=216;break}D=A+1|0;c[18374]=D;if((A|0)<(r|0)){E=S;A=D;M=R;N=Q}else{B=36;break}}if((B|0)==36){if(!S){break}A=c[d>>2]|0;E=A+51|0;c[18384]=E;p=E+(c[w>>2]|0)|0;c[18386]=p;E=p+(c[w>>2]|0)|0;c[18408]=E;D=E+(c[w>>2]|0)|0;c[18378]=D;F=D+(c[d>>2]|0)|0;c[18414]=F;C=F+(c[d>>2]|0)|0;c[18420]=C;c[18410]=(fa((c[q+8>>2]|0)+1|0,c[d>>2]|0)|0)+C;c[18434]=(c[q+64>>2]|0)+1;d:do{if((c[k>>2]|0)==1){F=o+64|0;h[9222]=+h[F>>3];a[73664]=0;h[9191]=+h[o+24>>3];J=o+16|0;h[9186]=+h[J>>3];do{if((c[w>>2]|0)!=0){$v(74032,v,w,d,73528,j,f,o+(D+ -1<<3)|0,o+(C+ -1<<3)|0,o+224|0,q+28|0,o+(A+50<<3)|0,o+(p+ -1<<3)|0,o+(E+ -1<<3)|0,x,73648,F,0,o,q,s,t)|0;if((c[18504]|0)>0){i=y;return 0}if((c[18412]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];G=73936;ww(d,o+((c[18378]|0)+ -1<<3)|0,G,g,G)|0;a[73664]=1;B=197;break d}}while(0);do{if((c[k+24>>2]|0)!=0){N=+h[9186];if(!(N>=0.0)){T=-N}else{T=N}M=T/+h[o+8>>3];if(!(M>1.0)){break}h[9186]=N/M}}while(0);M=+h[e>>3];N=+h[j>>3];if(M==N){B=227;break c}P=+h[9186];if((M-N)*P>0.0){B=220;break}F=(c[k+8>>2]|0)==1;do{if((c[k+12>>2]|0)==1){O=+h[o>>3];h[9221]=O;U=+h[9191];V=U-O;G=V*P>0.0;do{if(F){if(G){B=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){B=218;break d}if(P*(U- +h[e>>3])<=0.0){break}H=q+28|0;I=o+((c[18420]|0)+ -1<<3)|0;X=o+224|0;if(P*(U-W)>0.0){ew(73528,j,f,g,d,H,I,X)|0;if((c[18504]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[73664]=1;B=197;break d}}else{Y=73528;ew(Y,Y,f,g,d,H,I,X)|0;if((c[18504]|0)>0){i=y;return 0}else{h[e>>3]=+h[9191];c[n>>2]=1;a[73664]=1;B=197;break d}}}else{if(G){B=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){B=218;break d}if(P*(U-W)<0.0){break}ew(73528,j,f,g,d,q+28|0,o+((c[18420]|0)+ -1<<3)|0,o+224|0)|0;if((c[18504]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[73664]=1;B=197;break d}}}while(0);h[z>>3]=V;if(!(V>=0.0)){Z=-V}else{Z=V}if(!(U>=0.0)){_=-U}else{_=U}if(!(P>=0.0)){$=-P}else{$=P}if(Z>+h[9222]*100.0*(_+$)){if(P*(U+P-O)<=0.0){break}W=O-U;h[9186]=W;h[J>>3]=W;break}ew(73528,73768,f,g,d,q+28|0,o+((c[18420]|0)+ -1<<3)|0,o+224|0)|0;if((c[18504]|0)>0){i=y;return 0}else{c[n>>2]=2;h[e>>3]=+h[9221];a[73664]=1;B=197;break d}}else{W=+h[9191];if(!F){if(P*(W-N)<0.0){break}ew(73528,j,f,g,d,q+28|0,o+((c[18420]|0)+ -1<<3)|0,o+224|0)|0;if((c[18504]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[73664]=1;B=197;break d}}if(P*(W-M)<=0.0){break}G=q+28|0;X=o+((c[18420]|0)+ -1<<3)|0;I=o+224|0;if(P*(W-N)>0.0){ew(73528,j,f,g,d,G,X,I)|0;if((c[18504]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[73664]=1;B=197;break d}}else{H=73528;ew(H,H,f,g,d,G,X,I)|0;if((c[18504]|0)>0){i=y;return 0}else{h[e>>3]=+h[9191];c[n>>2]=1;a[73664]=1;B=197;break d}}}}while(0);if(a[73664]&1){B=197}else{B=128}}else{h[9191]=+h[e>>3];c[n>>2]=1;bw(d,k+4|0,l,m,f,o+((c[18414]|0)+ -1<<3)|0,s,t)|0;F=c[d>>2]|0;c[18374]=1;e:do{if((F|0)>=1){J=c[18414]|0;I=1;while(1){X=I+1|0;if(+h[o+(I+ -2+J<<3)>>3]<=0.0){break}c[18374]=X;if((I|0)<(F|0)){I=X}else{break e}}iM(73552,75856,80,39);I=73856;J=73864;Zv(73552,75528,75896,I,I,I,I,I,J,J,80)|0;break c}}while(0);U=+iw(74008,1);h[9222]=U;F=o+64|0;h[F>>3]=U;U=+h[e>>3];if(!(U>=0.0)){aa=-U}else{aa=U}h[z>>3]=aa;U=+h[j>>3];if(!(U>=0.0)){ba=-U}else{ba=U}U=+h[9222]*4.0*(aa>=ba?aa:ba);h[9211]=U;O=+h[j>>3]- +h[e>>3];h[z>>3]=O;if(!(O>=0.0)){ca=-O}else{ca=O}if(ca<U){iM(73552,75904,80,60);J=73856;Zv(73552,75400,75968,J,J,J,J,74032,j,e,80)|0;break c}do{if((c[k+28>>2]|0)==0){h[9190]=ca*.001;U=+cw(d,g,o+((c[18414]|0)+ -1<<3)|0,s,t);if(U>.5/+h[9190]){h[9190]=.5/U}h[z>>3]=+h[j>>3]- +h[e>>3];U=+hM(73520,z);h[9190]=U;da=U}else{U=+h[o+16>>3];h[9190]=U;if(U*(+h[j>>3]- +h[e>>3])<0.0){B=220;break d}if(!(U==0.0)){da=U;break}iM(73552,75808,80,29);J=73856;I=73864;Zv(73552,75840,75848,J,J,J,J,J,I,I,80)|0;break c}}while(0);do{if((c[k+24>>2]|0)==0){ea=da}else{if(!(da>=0.0)){ga=-da}else{ga=da}U=ga/+h[o+8>>3];if(!(U>1.0)){ea=da;break}O=da/U;h[9190]=O;ea=O}}while(0);if((c[k+12>>2]|0)==0){ha=ea}else{O=+h[o>>3];h[9221]=O;U=+h[e>>3];V=O-U;if(V*ea<0.0){B=224;break}if(ea*(U+ea-O)>0.0){h[9190]=V;ia=V}else{ia=ea}if((O- +h[j>>3])*ia<0.0){B=218;break}else{ha=ia}}I=k+40|0;if((c[I>>2]|0)==0){ja=ha}else{dw(73528,f,g,d,b,u,73520,o+((c[18414]|0)+ -1<<3)|0,n,s,t,o+((c[18420]|0)+ -1<<3)|0,o+400|0,o+((c[18378]|0)+ -1<<3)|0,o+((c[18410]|0)+ -1<<3)|0,q,73688,F,k+36|0,73736)|0;if((c[18504]|0)>0){i=y;return 0}J=c[n>>2]|0;if((J|0)<0){ka=J;B=129;break}ja=+h[9190]}h[9186]=ja;h[o+16>>3]=ja;J=c[18420]|0;X=(c[d>>2]|0)+J|0;c[18430]=X;G=c[d>>2]|0;c[18374]=1;if((G|0)>=1){H=1;while(1){h[o+(H+ -2+J<<3)>>3]=+h[f+(H+ -1<<3)>>3];h[o+(H+ -2+X<<3)>>3]=+h[9186]*+h[g+(H+ -1<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[18374]=G+1}H=o+320|0;h[H>>3]=+h[e>>3];X=q+68|0;c[X>>2]=0;J=o+224|0;h[J>>3]=+h[9186];h[o+232>>3]=+h[9186]*2.0;Y=q+28|0;c[Y>>2]=1;if((c[w>>2]|0)==0){B=128;break}$v(73936,v,w,d,e,j,f,o+((c[18378]|0)+ -1<<3)|0,o+((c[18420]|0)+ -1<<3)|0,J,Y,o+((c[18384]|0)+ -1<<3)|0,o+((c[18386]|0)+ -1<<3)|0,o+((c[18408]|0)+ -1<<3)|0,x,73648,F,0,o,q,s,t)|0;if((c[18504]|0)>0){i=y;return 0}if((c[18412]|0)!=0){iM(73552,76272,80,47);la=73856;ma=73864;Zv(73552,73920,76320,73936,la,la,la,la,ma,ma,80)|0;iM(73552,76328,80,38);ma=73856;la=73864;Zv(73552,74080,76320,73936,ma,ma,ma,ma,la,la,80)|0;break c}if((c[w>>2]|0)==0){B=128;break}if((c[I>>2]|0)==0){B=128;break}$v(74024,v,w,d,73528,j,f,o+((c[18378]|0)+ -1<<3)|0,o+((c[18420]|0)+ -1<<3)|0,J,Y,o+((c[18384]|0)+ -1<<3)|0,o+((c[18386]|0)+ -1<<3)|0,o+((c[18408]|0)+ -1<<3)|0,x,73648,F,0,o,q,s,t)|0;if((c[18504]|0)>0){i=y;return 0}if((c[18412]|0)!=1){B=128;break}c[X>>2]=1;c[n>>2]=4;h[e>>3]=+h[H>>3];H=73936;ww(d,o+((c[18378]|0)+ -1<<3)|0,H,g,H)|0;B=197}}while(0);if((B|0)==218){iM(73552,75648,80,54);E=73856;Zv(73552,75704,75712,E,E,E,E,74032,73768,j,80)|0;break c}else if((B|0)==220){iM(73552,75760,80,34);E=73856;Zv(73552,75328,75800,E,E,E,E,74032,j,e,80)|0;break c}else if((B|0)==224){iM(73552,75976,80,49);E=73856;Zv(73552,73840,76032,E,E,E,E,74032,73768,e,80)|0;break c}f:while(1){if((B|0)==128){B=0;ka=c[n>>2]|0;B=129;continue}else if((B|0)==129){B=0;if((ka|0)==-12){na=-12;break}if(((c[q+40>>2]|0)-(c[q+36>>2]|0)|0)>=500){B=131;break}oa=k+4|0;bw(d,oa,l,m,o+((c[18420]|0)+ -1<<3)|0,o+((c[18414]|0)+ -1<<3)|0,s,t)|0;if((c[18504]|0)>0){B=233;break}E=c[d>>2]|0;c[18374]=1;p=c[18414]|0;if((E|0)>=1){A=1;while(1){C=A+1|0;if(!(+h[o+(A+ -2+p<<3)>>3]>0.0)){B=136;break f}c[18374]=C;if((A|0)<(E|0)){A=C}else{break}}}O=+cw(d,o+((c[18420]|0)+ -1<<3)|0,o+(p+ -1<<3)|0,s,t)*100.0;V=+h[9222];pa=O*V;h[9188]=pa;if(!(pa<=1.0)){B=138;break}O=+h[9191];if(!(O>=0.0)){qa=-O}else{qa=O}h[z>>3]=qa;O=+h[j>>3];if(!(O>=0.0)){ra=-O}else{ra=O}h[9211]=V*4.0*(qa>=ra?qa:ra);do{if((c[k+24>>2]|0)!=0){V=+h[9186];if(!(V>=0.0)){sa=-V}else{sa=V}O=sa/+h[o+8>>3];if(!(O>1.0)){break}h[9186]=V/O}}while(0);fw(73528,f,g,d,b,u,73488,o+((c[18414]|0)+ -1<<3)|0,k,n,s,t,o+((c[18420]|0)+ -1<<3)|0,o+400|0,o+((c[18378]|0)+ -1<<3)|0,o+((c[18410]|0)+ -1<<3)|0,q,o+80|0,o+128|0,o+176|0,o+224|0,o+272|0,o+32|0,o+40|0,o+48|0,o+56|0,73688,o+64|0,q+20|0,q+16|0,q+24|0,q+28|0,q+32|0,k+36|0,73736)|0;if((c[18504]|0)>0){B=233;break}p=c[n>>2]|0;if((p|0)<0){na=p;break}do{if((c[w>>2]|0)!=0){$v(74024,v,w,d,73528,j,f,o+((c[18378]|0)+ -1<<3)|0,o+((c[18420]|0)+ -1<<3)|0,o+224|0,q+28|0,o+((c[18384]|0)+ -1<<3)|0,o+((c[18386]|0)+ -1<<3)|0,o+((c[18408]|0)+ -1<<3)|0,x,73648,o+64|0,0,o,q,s,t)|0;if((c[18504]|0)>0){B=233;break f}if((c[18412]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];p=73936;ww(d,o+((c[18378]|0)+ -1<<3)|0,p,g,p)|0;B=197;continue f}}while(0);p=(c[k+8>>2]|0)!=0;O=+h[9191];V=+h[9186];U=(O- +h[j>>3])*V;if((c[k+12>>2]|0)==0){if(!p){if(U<0.0){B=128;continue}ew(73528,j,f,g,d,q+28|0,o+((c[18420]|0)+ -1<<3)|0,o+224|0)|0;if((c[18504]|0)>0){B=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];B=197;continue}if(!(U>=0.0)){h[e>>3]=O;c[n>>2]=1;B=197;continue}ew(73528,j,f,g,d,q+28|0,o+((c[18420]|0)+ -1<<3)|0,o+224|0)|0;if((c[18504]|0)>0){B=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];B=197;continue}if(p){if(U>=0.0){ew(73528,j,f,g,d,q+28|0,o+((c[18420]|0)+ -1<<3)|0,o+224|0)|0;if((c[18504]|0)>0){B=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;B=197;continue}N=O- +h[9221];h[z>>3]=N;if(!(N>=0.0)){ta=-N}else{ta=N}if(!(O>=0.0)){ua=-O}else{ua=O}if(!(V>=0.0)){va=-V}else{va=V}if(!(ta<=+h[9222]*100.0*(ua+va))){h[e>>3]=O;c[n>>2]=1;B=197;continue}ew(73528,73768,f,g,d,q+28|0,o+((c[18420]|0)+ -1<<3)|0,o+224|0)|0;if((c[18504]|0)>0){B=233;break}c[n>>2]=2;h[e>>3]=+h[9221];B=197;continue}if(!(U<0.0)){ew(73528,j,f,g,d,q+28|0,o+((c[18420]|0)+ -1<<3)|0,o+224|0)|0;if((c[18504]|0)>0){B=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;B=197;continue}U=+h[9221];N=O-U;h[z>>3]=N;if(!(N>=0.0)){wa=-N}else{wa=N}if(!(O>=0.0)){xa=-O}else{xa=O}if(!(V>=0.0)){ya=-V}else{ya=V}if(!(wa<=+h[9222]*100.0*(xa+ya))){if(V*(O+V-U)<=0.0){B=128;continue}h[9186]=U-O;B=128;continue}else{ew(73528,73768,f,g,d,q+28|0,o+((c[18420]|0)+ -1<<3)|0,o+224|0)|0;if((c[18504]|0)>0){B=233;break}c[n>>2]=2;h[e>>3]=+h[9221];B=197;continue}}else if((B|0)==197){B=0;h[o+24>>3]=+h[9191];h[o+16>>3]=+h[9186];h[o+328>>3]=+h[e>>3];B=233;break}}do{if((B|0)==131){c[n>>2]=-1;na=-1}else if((B|0)==136){c[n>>2]=-3;na=-3}else if((B|0)==138){if((c[oa>>2]|0)!=1){h[l>>3]=pa*+h[l>>3];h[m>>3]=+h[9188]*+h[m>>3];c[n>>2]=-2;na=-2;break}p=c[d>>2]|0;c[18374]=1;if((p|0)>=1){O=pa;A=1;E=0;while(1){F=l+(E<<3)|0;h[F>>3]=O*+h[F>>3];F=m+(A+ -1<<3)|0;h[F>>3]=+h[9188]*+h[F>>3];if((A|0)>=(p|0)){break}F=A;O=+h[9188];A=A+1|0;E=F}c[18374]=p+1}c[n>>2]=-2;na=-2}else if((B|0)==233){i=y;return 0}}while(0);E=0-na|0;c[18430]=E;switch(E|0){case 2:{iM(73552,74168,80,47);E=73856;Zv(73552,73920,74216,E,E,E,E,73936,73528,73864,80)|0;iM(73552,74224,80,48);E=73856;A=73864;Zv(73552,74152,74280,E,E,E,E,E,A,A,80)|0;iM(73552,74288,80,45);A=73856;E=73864;Zv(73552,74336,74344,A,A,A,A,A,E,E,80)|0;break};case 3:{iM(73552,74352,80,38);E=73856;Zv(73552,74080,74392,E,E,E,E,73936,73528,73864,80)|0;iM(73552,74400,80,28);E=73856;A=73864;Zv(73552,74432,74440,E,E,E,E,E,A,A,80)|0;break};case 6:{iM(73552,74448,80,44);A=73856;Zv(73552,74496,74504,A,A,A,A,74032,73528,73488,80)|0;iM(73552,74512,80,57);A=73856;E=73864;Zv(73552,74576,74584,A,A,A,A,A,E,E,80)|0;break};case 7:{iM(73552,74448,80,44);E=73856;Zv(73552,74496,74592,E,E,E,E,74032,73528,73488,80)|0;iM(73552,74600,80,48);E=73856;A=73864;Zv(73552,74152,74656,E,E,E,E,E,A,A,80)|0;iM(73552,74664,80,28);A=73856;E=73864;Zv(73552,74432,74696,A,A,A,A,A,E,E,80)|0;break};case 8:{iM(73552,74448,80,44);E=73856;Zv(73552,74496,74704,E,E,E,E,74032,73528,73488,80)|0;iM(73552,74712,80,37);E=73856;A=73864;Zv(73552,74752,74760,E,E,E,E,E,A,A,80)|0;break};case 9:{iM(73552,74448,80,44);A=73856;Zv(73552,74496,74768,A,A,A,A,74032,73528,73488,80)|0;iM(73552,74776,80,49);A=73856;E=73864;Zv(73552,73840,74832,A,A,A,A,A,E,E,80)|0;iM(73552,74840,80,38);E=73856;A=73864;Zv(73552,74080,74880,E,E,E,E,E,A,A,80)|0;break};case 10:{iM(73552,74448,80,44);A=73856;Zv(73552,74496,74888,A,A,A,A,74032,73528,73488,80)|0;iM(73552,74896,80,45);A=73856;E=73864;Zv(73552,74336,74944,A,A,A,A,A,E,E,80)|0;iM(73552,74952,80,36);E=73856;A=73864;Zv(73552,74992,75e3,E,E,E,E,E,A,A,80)|0;break};case 11:{iM(73552,75008,80,40);A=73856;Zv(73552,75056,75064,A,A,A,A,74032,73528,73488,80)|0;iM(73552,75072,80,36);A=73856;E=73864;Zv(73552,74992,75112,A,A,A,A,A,E,E,80)|0;break};case 12:{iM(73552,74448,80,44);E=73856;Zv(73552,74496,75120,E,E,E,E,74032,73528,73520,80)|0;iM(73552,75128,80,45);E=73856;A=73864;Zv(73552,74336,75176,E,E,E,E,E,A,A,80)|0;break};case 5:case 4:{break};default:{iM(73552,74040,80,38);A=73856;Zv(73552,74080,74088,A,A,A,A,73936,73528,73864,80)|0;iM(73552,74096,80,48);A=73856;E=73864;Zv(73552,74152,74160,A,A,A,A,A,E,E,80)|0}}c[k>>2]=-1;h[e>>3]=+h[9191];h[o+24>>3]=+h[9191];h[o+16>>3]=+h[9186];i=y;return 0}else if((B|0)==215){iM(73552,75488,80,39);E=73856;A=73864;Zv(73552,75528,75536,E,E,E,E,E,A,A,80)|0;break c}else if((B|0)==216){iM(73552,75544,80,39);A=73856;E=73864;Zv(73552,75528,75584,A,A,A,A,A,E,E,80)|0;break c}}}while(0);iM(73552,75592,80,47);r=73856;E=73864;Zv(73552,73920,75640,r,r,r,r,r,E,E,80)|0}else if((B|0)==210){iM(73552,75184,80,55);E=73856;r=73864;Zv(73552,75240,73936,E,E,E,E,E,r,r,80)|0}}while(0);if((B|0)==227){iM(73552,76176,80,39);B=73856;Zv(73552,75528,76216,B,B,B,B,74032,j,e,80)|0}if((c[k>>2]|0)==-1){iM(73552,76368,80,46);e=73856;j=73864;Zv(73552,76416,76424,e,e,e,e,e,j,j,80)|0;iM(73552,76432,80,47);j=73856;e=73864;Zv(73552,73920,76480,73936,j,j,j,j,e,e,80)|0;i=y;return 0}else{c[k>>2]=-1;c[n>>2]=-33;i=y;return 0}return 0}function $v(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;var A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0;v=i;A=c[f>>2]|0;B=~A;C=+h[n>>3];h[9561]=C;c[t>>2]=0;D=c[e>>2]|0;c[19124]=1;if((D|0)>=1){E=1;do{c[s+(E+ -1<<2)>>2]=0;F=c[19124]|0;E=F+1|0;c[19124]=E;}while((F|0)<(D|0))}G=+h[g>>3];if(!(G>=0.0)){H=-G}else{H=G}if(!(C>=0.0)){I=-C}else{I=C}h[9568]=(H+I)*+h[u>>3]*100.0;u=c[b>>2]|0;do{if((u|0)==2){do{if((c[x+68>>2]|0)!=0){b=w+320|0;ew(g,b,k,l,f,o,m,n)|0;if((c[18504]|0)>0){i=v;return 0}D=d;Rd[D&7](f,b,k,e,p,y,z)|0;if((c[18504]|0)>0){i=v;return 0}E=x+60|0;c[E>>2]=(c[E>>2]|0)+1;a[76552]=0;F=c[e>>2]|0;c[19124]=1;if((F|0)<1){break}else{J=0;K=1}while(1){I=+h[p+(K+ -1<<3)>>3];if(!(I>=0.0)){L=-I}else{L=I}if(!(L<=0.0)){M=J}else{a[76552]=1;M=1}if((K|0)<(F|0)){J=M;K=K+1|0}else{break}}c[19124]=F+1;if(!M){break}I=+hM(76544,76488);h[9565]=I;H=I+ +h[b>>3];h[b>>3]=H;I=+h[9561];do{if((H- +h[g>>3])*I<0.0){ew(g,b,k,l,f,o,m,n)|0;if((c[18504]|0)<=0){break}i=v;return 0}else{G=+h[9565]/I;h[9566]=G;N=c[f>>2]|0;c[19124]=1;if((N|0)<1){break}O=(A<<1)+B|0;P=G;Q=1;while(1){R=k+(Q+ -1<<3)|0;h[R>>3]=+h[R>>3]+P*+h[m+(O+Q<<3)>>3];if((Q|0)>=(N|0)){break}P=+h[9566];Q=Q+1|0}c[19124]=N+1}}while(0);Rd[D&7](f,b,k,e,p,y,z)|0;if((c[18504]|0)>0){i=v;return 0}c[E>>2]=(c[E>>2]|0)+1;a[76552]=0;F=c[e>>2]|0;c[19124]=1;if((F|0)<1){break}else{S=0;T=1}while(1){Q=T+ -1|0;I=+h[p+(Q<<3)>>3];if(!(I>=0.0)){U=-I}else{U=I}if(U>0.0){V=S;W=T}else{c[s+(Q<<2)>>2]=1;a[76552]=1;V=1;W=c[19124]|0}Q=W+1|0;c[19124]=Q;if((W|0)<(F|0)){S=V;T=Q}else{break}}if(!V){break}c[t>>2]=1;i=v;return 0}}while(0);I=+h[g>>3];if(I==+h[w+328>>3]){i=v;return 0}else{X=+h[9561];Y=I;break}}else if((u|0)==3){X=C;Y=+h[g>>3]}else{F=w+320|0;ew(g,F,k,l,f,o,m,n)|0;if((c[18504]|0)>0){i=v;return 0}E=d;Rd[E&7](f,F,k,e,p,y,z)|0;if((c[18504]|0)>0){i=v;return 0}b=x+60|0;c[b>>2]=1;a[76552]=0;D=c[e>>2]|0;c[19124]=1;if((D|0)<1){i=v;return 0}else{Z=0;_=1}while(1){I=+h[p+(_+ -1<<3)>>3];if(!(I>=0.0)){$=-I}else{$=I}if(!($<=0.0)){aa=Z}else{a[76552]=1;aa=1}if((_|0)<(D|0)){Z=aa;_=_+1|0}else{break}}c[19124]=D+1;if(!aa){i=v;return 0}I=+hM(76544,76488);h[9565]=I;h[F>>3]=I+ +h[F>>3];I=+h[9565]/+h[9561];h[9566]=I;Q=c[f>>2]|0;c[19124]=1;if((Q|0)>=1){O=(A<<1)+B|0;H=I;R=1;while(1){ba=k+(R+ -1<<3)|0;h[ba>>3]=+h[ba>>3]+H*+h[m+(O+R<<3)>>3];if((R|0)>=(Q|0)){break}H=+h[9566];R=R+1|0}c[19124]=Q+1}Rd[E&7](f,F,k,e,p,y,z)|0;if((c[18504]|0)>0){i=v;return 0}c[b>>2]=(c[b>>2]|0)+1;a[76552]=0;R=c[e>>2]|0;c[19124]=1;if((R|0)<1){i=v;return 0}else{ca=0;da=1}while(1){H=+h[p+(da+ -1<<3)>>3];if(!(H>=0.0)){ea=-H}else{ea=H}if(!(ea<=0.0)){fa=ca}else{a[76552]=1;fa=1}if((da|0)<(R|0)){ca=fa;da=da+1|0}else{break}}c[19124]=R+1;if(!fa){i=v;return 0}c[t>>2]=-1;i=v;return 0}}while(0);ea=+h[j>>3];do{if(!((ea-Y)*X>=0.0)){h[9564]=ea;if((ea- +h[w+320>>3])*X<=0.0){i=v;return 0}ew(g,76512,k,l,f,o,m,n)|0;if((c[18504]|0)<=0){break}i=v;return 0}else{h[9564]=Y;j=c[f>>2]|0;c[19124]=1;if((j|0)<1){break}else{ga=1}while(1){fa=ga+ -1|0;h[k+(fa<<3)>>3]=+h[m+(fa<<3)>>3];if((ga|0)<(j|0)){ga=ga+1|0}else{break}}c[19124]=j+1}}while(0);ga=d;Rd[ga&7](f,76512,k,e,q,y,z)|0;if((c[18504]|0)>0){i=v;return 0}d=x+60|0;c[d>>2]=(c[d>>2]|0)+1;c[19134]=0;R=w+320|0;fa=x+76|0;da=x+72|0;x=w+336|0;ca=w+344|0;while(1){aw(e,76544,76536,R,76512,p,q,r,76504,s,fa,da,x,ca)|0;if((c[18504]|0)>0){ha=76;break}if((c[19134]|0)>1){ha=73;break}ew(g,76504,k,l,f,o,m,n)|0;if((c[18504]|0)>0){ha=76;break}Rd[ga&7](f,76504,k,e,r,y,z)|0;if((c[18504]|0)>0){ha=76;break}c[d>>2]=(c[d>>2]|0)+1}if((ha|0)==73){h[R>>3]=+h[9563];R=73936;ww(e,r,R,p,R)|0;if((c[19134]|0)==4){i=v;return 0}ew(g,76504,k,l,f,o,m,n)|0;if((c[18504]|0)>0){i=v;return 0}c[t>>2]=1;i=v;return 0}else if((ha|0)==76){i=v;return 0}return 0}function aw(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;s=i;do{if((c[e>>2]|0)==1){c[19150]=c[o>>2];c[o>>2]=0;h[9571]=0.0;a[76584]=0;t=c[b>>2]|0;c[19140]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;w=+h[l+(v<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}do{if(x>0.0){w=+hM(76616,j+(v<<3)|0);if(w==+hM(76616,l+((c[19140]|0)+ -1<<3)|0)){break}y=c[19140]|0;z=y+ -1|0;w=+h[l+(z<<3)>>3];A=w/(w- +h[j+(z<<3)>>3]);if(!(A>=0.0)){B=-A}else{B=A}if(B<=+h[9571]){break}h[9571]=B;c[o>>2]=y}else{a[76584]=1}}while(0);v=c[19140]|0;u=v+1|0;c[19140]=u;}while((v|0)<(t|0))}do{if((c[o>>2]|0)>0){a[76592]=1;c[19152]=c[p>>2];h[g>>3]=+h[r>>3];t=73936;ww(b,l,t,k,t)|0;c[p>>2]=1;a[76576]=0;C=0}else{a[76592]=0;c[o>>2]=c[19150];c[19152]=c[p>>2];if(a[76584]&1){h[g>>3]=+h[r>>3];t=73936;ww(b,l,t,k,t)|0;a[76576]=1;C=1;break}else{t=73936;ww(b,l,t,j,t)|0;h[f>>3]=+h[r>>3];c[p>>2]=0;a[76576]=0;C=0;break}}}while(0);A=+h[g>>3];w=A- +h[f>>3];if(!(w>=0.0)){D=-w}else{D=w}if(!(D<=+h[d>>3])){if(!C){break}E=+h[g>>3]}else{a[76576]=1;E=A}c[e>>2]=2;h[m>>3]=E;t=73936;ww(b,k,t,l,t)|0;t=c[b>>2]|0;c[19140]=1;if((t|0)<1){i=s;return 0}else{F=1}do{c[n+(F+ -1<<2)>>2]=0;u=(c[19140]|0)+ -1|0;A=+h[k+(u<<3)>>3];if(!(A>=0.0)){G=-A}else{G=A}do{if(G>0.0){A=+hM(76616,j+(u<<3)|0);if(!(A!=+hM(76616,k+((c[19140]|0)+ -1<<3)|0))){break}c[n+((c[19140]|0)+ -1<<2)>>2]=1}else{c[n+(u<<2)>>2]=1}}while(0);u=c[19140]|0;F=u+1|0;c[19140]=F;}while((u|0)<(t|0));i=s;return 0}else{c[o>>2]=0;h[9571]=0.0;a[76584]=0;t=c[b>>2]|0;c[19140]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;A=+h[k+(v<<3)>>3];if(!(A>=0.0)){H=-A}else{H=A}do{if(H>0.0){A=+hM(76616,j+(v<<3)|0);if(A==+hM(76616,k+((c[19140]|0)+ -1<<3)|0)){break}y=c[19140]|0;z=y+ -1|0;A=+h[k+(z<<3)>>3];w=A/(A- +h[j+(z<<3)>>3]);if(!(w>=0.0)){I=-w}else{I=w}if(I<=+h[9571]){break}h[9571]=I;c[o>>2]=y}else{a[76584]=1}}while(0);v=c[19140]|0;u=v+1|0;c[19140]=u;}while((v|0)<(t|0))}t=(c[o>>2]|0)>0;a[76592]=t&1;if(t){a[76576]=0;c[19152]=0;c[p>>2]=1;break}if(!(a[76584]&1)){t=73936;ww(b,k,t,l,t)|0;h[m>>3]=+h[g>>3];c[e>>2]=4;i=s;return 0}h[m>>3]=+h[g>>3];t=73936;ww(b,k,t,l,t)|0;t=c[b>>2]|0;c[19140]=1;if((t|0)>=1){u=1;do{c[n+(u+ -1<<2)>>2]=0;v=c[19140]|0;y=v+ -1|0;w=+h[k+(y<<3)>>3];if(!(w>=0.0)){J=-w}else{J=w}if(!(J<=0.0)){K=v}else{c[n+(y<<2)>>2]=1;K=c[19140]|0}u=K+1|0;c[19140]=u;}while((K|0)<(t|0))}c[e>>2]=3;i=s;return 0}}while(0);K=c[19152]|0;do{if((K|0)==(c[p>>2]|0)){J=+h[q>>3];if((K|0)==0){I=J*2.0;h[q>>3]=I;L=I;break}else{I=J*.5;h[q>>3]=I;L=I;break}}else{h[q>>3]=1.0;L=1.0}}while(0);I=+h[g>>3];q=(c[o>>2]|0)+ -1|0;J=+h[k+(q<<3)>>3];H=I-(I- +h[f>>3])*J/(J-L*+h[j+(q<<3)>>3]);h[r>>3]=H;L=+h[f>>3];J=H-L;if(!(J>=0.0)){M=-J}else{M=J}J=+h[d>>3];do{if(M<J){I=+h[g>>3]-L;if(!(I>=0.0)){N=-I}else{N=I}if(!(N>J*10.0)){O=H;break}G=L+I*.1;h[r>>3]=G;O=G}else{O=H}}while(0);c[e>>2]=1;h[m>>3]=O;i=s;return 0}function bw(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0.0,o=0.0,p=0.0;k=i;h[9580]=+h[d>>3];h[9579]=+h[e>>3];j=c[a>>2]|0;c[19156]=1;if((j|0)<1){i=k;return 0}else{l=1}while(1){if((c[b>>2]|0)==0){m=l+ -1|0;n=+h[9580]}else{a=l+ -1|0;o=+h[d+(a<<3)>>3];h[9580]=o;h[9579]=+h[e+(a<<3)>>3];m=a;n=o}o=+h[f+(m<<3)>>3];if(!(o>=0.0)){p=-o}else{p=o}h[g+(m<<3)>>3]=n*p+ +h[9579];a=l+1|0;c[19156]=a;if((l|0)<(j|0)){l=a}else{break}}i=k;return 0}function cw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;f=i;h[9583]=0.0;e=c[a>>2]|0;c[19162]=1;if((e|0)<1){g=0.0;i=f;return+g}else{j=0.0;k=1}while(1){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){n=-m}else{n=m}if(n>j){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){o=-m}else{o=m}h[9583]=o;p=o}else{p=j}if((k|0)<(e|0)){j=p;k=k+1|0}else{break}}c[19162]=e+1;if(p<=0.0){g=0.0;i=f;return+g}h[9582]=0.0;e=c[a>>2]|0;c[19162]=1;if((e|0)<1){q=0.0}else{j=0.0;k=1;while(1){l=k+ -1|0;o=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3]/p;r=j+o*o;h[9582]=r;if((k|0)<(e|0)){k=k+1|0;j=r}else{break}}c[19162]=e+1;q=r}g=p*+V(+(q/+(c[a>>2]|0)));i=f;return+g}function dw(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;y=i;i=i+16|0;z=y;A=y+8|0;B=c[f>>2]|0;c[m>>2]=1;c[19180]=0;c[19178]=0;c[19184]=0;h[9595]=+h[b>>3];h[9597]=+cw(f,d,l,0,0);C=c[f>>2]|0;c[19168]=1;D=(B<<1)+~B|0;if((C|0)>=1){B=1;while(1){E=B+ -1|0;h[p+(E<<3)>>3]=+h[d+(E<<3)>>3];h[p+(D+B<<3)>>3]=+h[e+(B+ -1<<3)>>3];if((B|0)<(C|0)){B=B+1|0}else{break}}c[19168]=C+1}C=t+44|0;B=g;E=t+48|0;F=+h[k>>3];a:while(1){h[9588]=1.0/F;h[b>>3]=+h[k>>3]+ +h[b>>3];G=c[f>>2]|0;c[19168]=1;if((G|0)>=1){H=1;while(1){I=H+ -1|0;J=d+(I<<3)|0;h[J>>3]=+h[J>>3]+ +h[k>>3]*+h[e+(I<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[19168]=G+1}a[76768]=1;c[19170]=0;a[76784]=1;c[C>>2]=(c[C>>2]|0)+1;c[19188]=0;Rd[B&7](b,d,e,q,76752,n,o)|0;b:do{if((c[19188]|0)<0){K=35}else{while(1){if(a[76768]&1){c[E>>2]=(c[E>>2]|0)+1;a[76768]=0;gw(f,b,d,e,q,76704,k,76728,l,r,s,t,g,76752,v,j,n,o,x)|0;h[9587]=1.0e6;if((c[19188]|0)<0|(c[19182]|0)!=0){K=35;break b}c[19184]=0}H=c[f>>2]|0;c[19168]=1;if((H|0)>=1){I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]*.75;if((I|0)<(H|0)){I=I+1|0}else{break}}c[19168]=H+1}hw(f,q,s,t)|0;I=c[f>>2]|0;c[19168]=1;if((I|0)>=1){J=1;while(1){L=J+ -1|0;M=d+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[q+(L<<3)>>3];L=J+ -1|0;M=e+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[9588]*+h[q+(L<<3)>>3];if((J|0)<(I|0)){J=J+1|0}else{break}}c[19168]=I+1}N=+cw(f,q,l,0,0);h[9599]=N;if(N<=+h[v>>3]*100.0*+h[9597]){break}J=c[19170]|0;if((J|0)>0){h[z>>3]=N/+h[9600];h[A>>3]=1.0/+(J|0);O=+fM(z,A);if(O>.9){K=35;break b}P=O/(1.0-O);h[9587]=P;Q=+h[9599];R=P}else{h[9600]=N;Q=N;R=+h[9587]}if(R*Q<=.33){break}J=c[19170]|0;H=J+1|0;c[19170]=H;if((J|0)>8){K=35;break b}if(((H|0)%5|0|0)==0){a[76768]=1}c[C>>2]=(c[C>>2]|0)+1;c[19188]=0;Rd[B&7](b,d,e,q,76752,n,o)|0;if((c[19188]|0)<0){K=35;break b}}do{if((c[w>>2]|0)!=0){H=c[f>>2]|0;c[19168]=1;if((H|0)>=1){J=1;while(1){S=+h[d+(J+ -1<<3)>>3];h[q+(J+ -1<<3)>>3]=S<=0.0?S:0.0;if((J|0)<(H|0)){J=J+1|0}else{break}}h[z>>3]=S;c[19168]=H+1}N=+cw(f,q,l,0,0);h[9599]=N;if(N>.33){K=35;break b}J=c[f>>2]|0;c[19168]=1;if((J|0)<1){break}else{T=1}while(1){I=T+ -1|0;L=d+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[q+(I<<3)>>3];I=T+ -1|0;L=e+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[9588]*+h[q+(I<<3)>>3];if((T|0)<(J|0)){T=T+1|0}else{break}}c[19168]=J+1}}while(0);if(!(a[76784]&1)){break}H=c[f>>2]|0;c[19168]=1;if((H|0)>=1){I=1;while(1){L=I+ -1|0;h[r+(L<<3)>>3]=+h[d+(L<<3)>>3]- +h[p+(L<<3)>>3];if((I|0)<(H|0)){I=I+1|0}else{break}}c[19168]=H+1}N=+cw(f,r,l,0,0);h[9593]=N;if(N<=1.0){K=63;break a}}}while(0);if((K|0)==35){K=0;a[76784]=0}h[b>>3]=+h[9595];G=c[f>>2]|0;c[19168]=1;if((G|0)>=1){I=1;while(1){L=I+ -1|0;h[d+(L<<3)>>3]=+h[p+(L<<3)>>3];h[e+(I+ -1<<3)>>3]=+h[p+(D+I<<3)>>3];if((I|0)<(G|0)){I=I+1|0}else{break}}c[19168]=G+1}if(a[76784]&1){I=(c[19180]|0)+1|0;c[19180]=I;N=.9/(+h[9593]*2.0+1.0e-4);h[z>>3]=.1;P=N>=.5?.5:N;h[A>>3]=P;N=P<=.1?.1:P;h[9586]=N;P=+h[k>>3]*N;h[k>>3]=P;if(!(P>=0.0)){U=-P}else{U=P}if(U>=+h[u>>3]&(I|0)<10){F=P;continue}else{K=62;break}}if((c[19182]|0)!=0){I=(c[19184]|0)+1|0;c[19184]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=3){K=51;break}if(!(P>=0.0)){V=-P}else{V=P}if(!(V>=+h[u>>3])){K=51;break}else{F=P;continue}}if(!((c[19188]|0)>-2)){K=53;break}I=(c[19178]|0)+1|0;c[19178]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=10){K=58;break}if(!(P>=0.0)){W=-P}else{W=P}if(!(W>=+h[u>>3])){K=58;break}else{F=P}}if((K|0)==51){c[m>>2]=-12;i=y;return 0}else if((K|0)==53){c[m>>2]=-12;i=y;return 0}else if((K|0)==58){c[m>>2]=-12;i=y;return 0}else if((K|0)==62){c[m>>2]=-12;i=y;return 0}else if((K|0)==63){i=y;return 0}return 0}function ew(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;l=i;m=c[f>>2]|0;n=~m;o=(c[g>>2]|0)+1|0;c[19214]=o;p=+h[b>>3]- +h[a>>3];h[9605]=p;a=c[f>>2]|0;c[19206]=1;if((a|0)<1){q=p}else{b=1;while(1){g=b+ -1|0;h[d+(g<<3)>>3]=+h[j+(g<<3)>>3];h[e+(b+ -1<<3)>>3]=0.0;if((b|0)<(a|0)){b=b+1|0}else{break}}c[19206]=a+1;q=+h[9605]}h[9601]=1.0;h[9602]=0.0;p=q/+h[k>>3];h[9606]=p;c[19208]=2;if((o|0)<2){i=l;return 0}else{r=q;s=1.0;t=p;u=0.0;v=2}while(1){a=k+(v+ -2<<3)|0;h[9602]=u*t+s/+h[a>>3];p=t*s;h[9601]=p;h[9606]=(r+ +h[a>>3])/+h[k+(v+ -1<<3)>>3];a=c[f>>2]|0;c[19206]=1;if((a|0)>=1){b=fa(v,m)|0;q=p;g=1;while(1){w=d+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+q*+h[j+(g+n+b<<3)>>3];w=e+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+ +h[9602]*+h[j+(g+n+b<<3)>>3];if((g|0)>=(a|0)){break}q=+h[9601];g=g+1|0}c[19206]=a+1}g=v+1|0;c[19208]=g;if((v|0)>=(o|0)){break}r=+h[9605];s=+h[9601];t=+h[9606];u=+h[9602];v=g}i=l;return 0}



function pD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+200|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+16|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+1024|0;Ba=i;i=i+8|0;Ca=i;i=i+16|0;Da=i;i=i+8|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;sb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+8|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+8|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+8|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+8|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;dc=i;i=i+16|0;fc=i;i=i+8|0;gc=i;i=i+16|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+8|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+8|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+8|0;sc=i;i=i+16|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+8|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+8|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+8|0;Ec=i;i=i+16|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+8|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+8|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+8|0;Qc=i;i=i+16|0;Rc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+16|0;Vc=i;i=i+16|0;Wc=qa;qD(qa);iO(ra);rD(sa,ta);rD(ua,va);va=b+92|0;do{if((c[va>>2]|0)==0){if((c[118248>>2]|0)==0){oO(za,c[b+80>>2]|0);sD(ya,za,105336);vO(ra,ya)|0;uO(ya);uO(za)}else{wO(ra,c[118376>>2]|0)|0}ta=ec(RO(ra)|0,105352)|0;if((ta|0)!=0){Xc=ta;break}c[pa>>2]=RO(ra)|0;Pu(0,105360,pa)}else{Xc=0}}while(0);pa=Mp(0)|0;if((pa|0)==0){Sc(Xc|0)|0;Pu(0,105464,oa)}Xp(pa,Wc);Yp(pa,7,44);Wc=c[va>>2]|0;do{if((Wc|0)==0){oa=Aa;fZ(oa|0,0,1024)|0;while(1){za=pb(oa|0,1,1024,Xc|0)|0;ya=za>>>0<1024;if((Zp(pa,oa,za,ya&1)|0)==0){Yc=12;break}if(ya){Yc=14;break}}if((Yc|0)==12){Sc(Xc|0)|0;oa=RO(ra)|0;ya=fq(cq(pa)|0)|0;za=dq(pa)|0;c[na>>2]=oa;c[na+4>>2]=ya;c[na+8>>2]=za;Nu(1,0,105544,na);Tp(pa);Pu(0,105632,ma)}else if((Yc|0)==14){Sc(Xc|0)|0;break}}else{if((Zp(pa,Wc,bZ(Wc|0)|0,1)|0)!=0){break}za=c[r>>2]|0;ya=c[va>>2]|0;oa=fq(cq(pa)|0)|0;ta=dq(pa)|0;c[la>>2]=ya;c[la+4>>2]=oa;c[la+8>>2]=ta;ld(za|0,105656,la|0)|0;za=c[va>>2]|0;ta=fq(cq(pa)|0)|0;oa=dq(pa)|0;c[ka>>2]=za;c[ka+4>>2]=ta;c[ka+8>>2]=oa;Nu(1,0,105672,ka);Tp(pa);Pu(0,105632,ja)}}while(0);ja=qa;oO(Ca,105760);wD(Ba,ja,Ca);xD(Da,ja);ka=vD(Ba,Da)|0;uO(Ca);Ca=b+88|0;Da=c[Ca>>2]|0;do{if(ka){Ba=RO(ra)|0;c[ia>>2]=Da;c[ia+4>>2]=Ba;Nu(1,0,105768,ia)}else{oO(Ea,105760);Ba=ZY(Da,RO(gD(ja,Ea)|0)|0)|0;uO(Ea);if((Ba|0)==0){break}Tp(pa);oO(Fa,105760);Ba=RO(gD(ja,Fa)|0)|0;va=RO(ra)|0;la=c[Ca>>2]|0;c[ha>>2]=Ba;c[ha+4>>2]=va;c[ha+8>>2]=la;Nu(1,0,105816,ha);uO(Fa);Pu(0,105632,ga)}}while(0);yD(qa,b,c[118460>>2]|0,c[118464>>2]|0);Lu(23,1,105912,fa);fa=qa+12|0;oO(Ha,105952);kO(Ga,gD(fa,Ha)|0);ga=d;lD(Ga,ga,0.0);uO(Ga);uO(Ha);Ha=ea;h[k>>3]=+h[ga>>3];c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];Lu(23,0,105968,ea);oO(Ja,105984);kO(Ia,gD(fa,Ja)|0);ea=d+8|0;lD(Ia,ea,1.0);uO(Ia);uO(Ja);Ja=da;h[k>>3]=+h[ea>>3];c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];Lu(23,0,106e3,da);oO(La,106016);kO(Ka,gD(fa,La)|0);da=d+24|0;lD(Ka,da,(+h[ea>>3]- +h[ga>>3])/500.0);uO(Ka);uO(La);La=ca;h[k>>3]=+h[da>>3];c[La>>2]=c[k>>2];c[La+4>>2]=c[k+4>>2];Lu(23,0,106032,ca);oO(Na,106048);kO(Ma,gD(fa,Na)|0);ca=d+32|0;lD(Ma,ca,1.0e-5);uO(Ma);uO(Na);Na=ba;h[k>>3]=+h[ca>>3];c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];Lu(23,0,106064,ba);oO(Pa,106080);kO(Oa,gD(fa,Pa)|0);ba=d+40|0;fD(Oa,ba);uO(Oa);uO(Pa);c[aa>>2]=c[ba>>2];Lu(23,0,106088,aa);oO(Ra,106112);kO(Qa,gD(fa,Ra)|0);aa=d+44|0;fD(Qa,aa);uO(Qa);uO(Ra);c[$>>2]=c[aa>>2];Lu(23,0,106128,$);oO(Ta,106152);kO(Sa,gD(fa,Ta)|0);fa=d+48|0;fD(Sa,fa);uO(Sa);uO(Ta);c[_>>2]=c[fa>>2];Lu(23,0,106168,_);oO(Va,106192);kO(Ua,gD(ja,Va)|0);_=d+268|0;fD(Ua,_);uO(Ua);uO(Va);c[Z>>2]=c[_>>2];Lu(23,0,106216,Z);if((c[64020>>2]|0)!=0){Vd[c[16120]&511](23)}oO(eb,106240);kO(db,gD(ja,eb)|0);iD(db,Wa,0);uO(db);uO(eb);oO(gb,106272);kO(fb,gD(ja,gb)|0);iD(fb,Xa,0);uO(fb);uO(gb);oO(ib,106304);kO(hb,gD(ja,ib)|0);iD(hb,Ya,0);uO(hb);uO(ib);oO(kb,106328);kO(jb,gD(ja,kb)|0);iD(jb,_a,0);uO(jb);uO(kb);oO(mb,106360);kO(lb,gD(ja,mb)|0);iD(lb,Za,0);uO(lb);uO(mb);oO(ob,106400);kO(nb,gD(ja,ob)|0);iD(nb,ab,0);uO(nb);uO(ob);oO(rb,106432);kO(qb,gD(ja,rb)|0);iD(qb,$a,0);uO(qb);uO(rb);oO(tb,106472);kO(sb,gD(ja,tb)|0);iD(sb,cb,0);uO(sb);uO(tb);oO(vb,106504);kO(ub,gD(ja,vb)|0);iD(ub,bb,0);uO(ub);uO(vb);vb=c[Wa>>2]|0;Wa=b+104|0;do{if((vb|0)==(c[Wa>>2]|0)){ub=b+108|0;if((c[Xa>>2]|0)!=((c[ub>>2]|0)-(vb<<1)|0)){break}ja=b+128|0;if((c[Ya>>2]|0)!=(c[ja>>2]|0)){break}tb=b+132|0;if((c[_a>>2]|0)!=(c[tb>>2]|0)){break}sb=b+116|0;if((c[Za>>2]|0)!=(c[sb>>2]|0)){break}rb=b+136|0;if((c[ab>>2]|0)!=(c[rb>>2]|0)){break}qb=b+120|0;if((c[$a>>2]|0)!=(c[qb>>2]|0)){break}ob=b+140|0;if((c[cb>>2]|0)!=(c[ob>>2]|0)){break}nb=b+124|0;if((c[bb>>2]|0)!=(c[nb>>2]|0)){break}c[O>>2]=107048;Lu(4,1,107024,O);if((c[Wa>>2]|0)>0){mb=b;lb=qa+24|0;kb=0;do{jb=c[mb>>2]|0;c[wb>>2]=kb;ib=zD(lb,wb)|0;eD(ib,jb+(kb*112|0)|0);jD(ib,jb+(kb*112|0)+40|0);hb=jb+(kb*112|0)+4|0;do{if((a[c[hb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}else{if((c[118244>>2]|0)!=0){break}oO(xb,107064);jb=(UO(gD(ib,xb)|0,105200)|0)==0;uO(xb);if(!jb){break}c[N>>2]=c[hb>>2];Lu(4,0,107080,N);a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}}while(0);oO(yb,c[hb>>2]|0);c[(AD(sa,yb)|0)>>2]=kb;uO(yb);kb=kb+1|0;}while((kb|0)<(c[Wa>>2]|0))}if((c[63944>>2]|0)!=0){Vd[c[16120]&511](4)}c[M>>2]=107112;Lu(4,1,107024,M);kb=c[Wa>>2]|0;if((kb|0)>0){mb=b;lb=qa+36|0;ib=kb;kb=0;do{jb=ib+kb|0;gb=c[mb>>2]|0;c[zb>>2]=kb;fb=zD(lb,zb)|0;eD(fb,gb+(jb*112|0)|0);jD(fb,gb+(jb*112|0)+40|0);eb=gb+(jb*112|0)+4|0;do{if((a[c[eb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}else{if((c[118244>>2]|0)!=0){break}oO(Ab,107064);gb=(UO(gD(fb,Ab)|0,105200)|0)==0;uO(Ab);if(!gb){break}c[L>>2]=c[eb>>2];Lu(4,0,107080,L);a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}}while(0);oO(Bb,c[eb>>2]|0);c[(AD(sa,Bb)|0)>>2]=jb;uO(Bb);kb=kb+1|0;ib=c[Wa>>2]|0;}while((kb|0)<(ib|0))}if((c[63944>>2]|0)!=0){Vd[c[16120]&511](4)}c[K>>2]=107136;Lu(4,1,107024,K);ib=c[Wa>>2]<<1;if(((c[ub>>2]|0)-ib|0)>0){kb=b;mb=qa+48|0;lb=ib;ib=0;do{fb=lb+ib|0;hb=c[kb>>2]|0;c[Cb>>2]=ib;gb=zD(mb,Cb)|0;eD(gb,hb+(fb*112|0)|0);jD(gb,hb+(fb*112|0)+40|0);db=hb+(fb*112|0)+4|0;do{if((a[c[db>>2]|0]|0)==36){a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}else{if((c[118244>>2]|0)!=0){break}oO(Db,107064);hb=(UO(gD(gb,Db)|0,105200)|0)==0;uO(Db);if(!hb){break}c[J>>2]=c[db>>2];Lu(4,0,107080,J);a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}}while(0);oO(Eb,c[db>>2]|0);c[(AD(sa,Eb)|0)>>2]=fb;uO(Eb);ib=ib+1|0;lb=c[Wa>>2]<<1;}while((ib|0)<((c[ub>>2]|0)-lb|0))}if((c[63944>>2]|0)!=0){Vd[c[16120]&511](4)}c[I>>2]=107152;Lu(4,1,107024,I);if((c[sb>>2]|0)>0){lb=b+4|0;ub=qa+84|0;ib=0;do{kb=c[lb>>2]|0;c[Fb>>2]=ib;mb=zD(ub,Fb)|0;eD(mb,kb+(ib*60|0)|0);mD(mb,kb+(ib*60|0)+36|0);gb=kb+(ib*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}else{if((c[118244>>2]|0)!=0){break}oO(Gb,107064);kb=(UO(gD(mb,Gb)|0,105200)|0)==0;uO(Gb);if(!kb){break}c[H>>2]=c[gb>>2];Lu(4,0,107080,H);a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}}while(0);oO(Hb,c[gb>>2]|0);c[(AD(sa,Hb)|0)>>2]=ib;uO(Hb);ib=ib+1|0;}while((ib|0)<(c[sb>>2]|0))}if((c[63944>>2]|0)!=0){Vd[c[16120]&511](4)}c[G>>2]=107176;Lu(4,1,107024,G);if((c[qb>>2]|0)>0){sb=b+8|0;ib=qa+120|0;lb=0;do{ub=c[sb>>2]|0;c[Ib>>2]=lb;mb=zD(ib,Ib)|0;eD(mb,ub+(lb*48|0)|0);nD(mb,ub+(lb*48|0)+36|0);fb=ub+(lb*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[sb>>2]|0)+(lb*48|0)+44|0]=1}else{if((c[118244>>2]|0)!=0){break}oO(Jb,107064);ub=(UO(gD(mb,Jb)|0,105200)|0)==0;uO(Jb);if(!ub){break}c[F>>2]=c[fb>>2];Lu(4,0,107080,F);a[(c[sb>>2]|0)+(lb*48|0)+44|0]=1}}while(0);oO(Kb,c[fb>>2]|0);c[(AD(sa,Kb)|0)>>2]=lb;uO(Kb);lb=lb+1|0;}while((lb|0)<(c[qb>>2]|0))}if((c[63944>>2]|0)!=0){Vd[c[16120]&511](4)}c[E>>2]=107200;Lu(4,1,107024,E);if((c[nb>>2]|0)>0){qb=b+12|0;lb=qa+156|0;sb=0;do{ib=c[qb>>2]|0;c[Lb>>2]=sb;mb=zD(lb,Lb)|0;eD(mb,ib+(sb*52|0)|0);oD(mb,ib+(sb*52|0)+36|0);gb=ib+(sb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[qb>>2]|0)+(sb*52|0)+48|0]=1}else{if((c[118244>>2]|0)!=0){break}oO(Mb,107064);ib=(UO(gD(mb,Mb)|0,105200)|0)==0;uO(Mb);if(!ib){break}c[D>>2]=c[gb>>2];Lu(4,0,107080,D);a[(c[qb>>2]|0)+(sb*52|0)+48|0]=1}}while(0);oO(Nb,c[gb>>2]|0);c[(AD(sa,Nb)|0)>>2]=sb;uO(Nb);sb=sb+1|0;}while((sb|0)<(c[nb>>2]|0))}if((c[63944>>2]|0)!=0){Vd[c[16120]&511](4)}c[C>>2]=107224;Lu(4,1,107024,C);if((c[ja>>2]|0)>0){nb=b+16|0;sb=qa+60|0;qb=0;do{lb=c[nb>>2]|0;c[Ob>>2]=qb;mb=zD(sb,Ob)|0;eD(mb,lb+(qb*112|0)|0);jD(mb,lb+(qb*112|0)+40|0);fb=lb+(qb*112|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[nb>>2]|0)+(qb*112|0)+104|0]=1}else{if((c[118244>>2]|0)!=0){break}oO(Pb,107064);lb=(UO(gD(mb,Pb)|0,105200)|0)==0;uO(Pb);if(!lb){break}c[B>>2]=c[fb>>2];Lu(4,0,107080,B);a[(c[nb>>2]|0)+(qb*112|0)+104|0]=1}}while(0);oO(Qb,c[fb>>2]|0);c[(AD(ua,Qb)|0)>>2]=qb;uO(Qb);qb=qb+1|0;}while((qb|0)<(c[ja>>2]|0))}if((c[63944>>2]|0)!=0){Vd[c[16120]&511](4)}c[A>>2]=107240;Lu(4,1,107024,A);if((c[tb>>2]|0)>0){ja=b+20|0;qb=qa+96|0;nb=0;do{sb=c[ja>>2]|0;c[Rb>>2]=nb;mb=zD(qb,Rb)|0;eD(mb,sb+(nb*60|0)|0);mD(mb,sb+(nb*60|0)+36|0);gb=sb+(nb*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}else{if((c[118244>>2]|0)!=0){break}oO(Sb,107064);sb=(UO(gD(mb,Sb)|0,105200)|0)==0;uO(Sb);if(!sb){break}c[z>>2]=c[gb>>2];Lu(4,0,107080,z);a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}}while(0);oO(Tb,c[gb>>2]|0);c[(AD(ua,Tb)|0)>>2]=nb;uO(Tb);nb=nb+1|0;}while((nb|0)<(c[tb>>2]|0))}if((c[63944>>2]|0)!=0){Vd[c[16120]&511](4)}c[y>>2]=107264;Lu(4,1,107024,y);if((c[rb>>2]|0)>0){tb=b+24|0;nb=qa+132|0;ja=0;do{qb=c[tb>>2]|0;c[Ub>>2]=ja;mb=zD(nb,Ub)|0;eD(mb,qb+(ja*48|0)|0);nD(mb,qb+(ja*48|0)+36|0);fb=qb+(ja*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}else{if((c[118244>>2]|0)!=0){break}oO(Vb,107064);qb=(UO(gD(mb,Vb)|0,105200)|0)==0;uO(Vb);if(!qb){break}c[x>>2]=c[fb>>2];Lu(4,0,107080,x);a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}}while(0);oO(Wb,c[fb>>2]|0);c[(AD(ua,Wb)|0)>>2]=ja;uO(Wb);ja=ja+1|0;}while((ja|0)<(c[rb>>2]|0))}if((c[63944>>2]|0)!=0){Vd[c[16120]&511](4)}c[w>>2]=107288;Lu(4,1,107024,w);if((c[ob>>2]|0)>0){rb=b+28|0;ja=qa+168|0;tb=0;do{nb=c[rb>>2]|0;c[Xb>>2]=tb;mb=zD(ja,Xb)|0;eD(mb,nb+(tb*52|0)|0);oD(mb,nb+(tb*52|0)+36|0);gb=nb+(tb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[rb>>2]|0)+(tb*52|0)+48|0]=1}else{if((c[118244>>2]|0)!=0){break}oO(Yb,107064);nb=(UO(gD(mb,Yb)|0,105200)|0)==0;uO(Yb);if(!nb){break}c[v>>2]=c[gb>>2];Lu(4,0,107080,v);a[(c[rb>>2]|0)+(tb*52|0)+48|0]=1}}while(0);oO(Zb,c[gb>>2]|0);c[(AD(ua,Zb)|0)>>2]=tb;uO(Zb);tb=tb+1|0;}while((tb|0)<(c[ob>>2]|0))}if((c[63944>>2]|0)!=0){Vd[c[16120]&511](4)}Lu(4,1,107312,u);ob=b+208|0;a:do{if((c[ob>>2]|0)>0){tb=qa+72|0;rb=b+32|0;ja=0;b:while(1){c[_b>>2]=ja;mb=zD(tb,_b)|0;eD(mb,(c[rb>>2]|0)+(ja*52|0)+12|0);iO($b);c[bc>>2]=ja;mb=zD(tb,bc)|0;oO(cc,107352);kO(ac,gD(mb,cc)|0);BD(ac,$b);uO(ac);uO(cc);mb=(UO($b,107360)|0)==0;fb=c[rb>>2]|0;nb=mb&1;c[fb+(ja*52|0)>>2]=nb;c[t>>2]=c[fb+(ja*52|0)+16>>2];c[t+4>>2]=nb;Lu(4,0,107376,t);nb=c[rb>>2]|0;if((a[c[nb+(ja*52|0)+16>>2]|0]|0)==36){a[nb+(ja*52|0)+48|0]=1}c[fc>>2]=ja;nb=zD(tb,fc)|0;oO(gc,107416);kO(dc,gD(nb,gc)|0);BD(dc,$b);uO(dc);uO(gc);CD(wa,sa,$b);CD(xa,ua,$b);ED(hc,sa);do{if(DD(wa,hc)|0){nb=c[(FD(wa)|0)+12>>2]|0;fb=c[rb>>2]|0;c[fb+(ja*52|0)+4>>2]=nb;a[fb+(ja*52|0)+8|0]=0}else{ED(ic,ua);if(DD(xa,ic)|0){fb=c[(FD(xa)|0)+12>>2]|0;nb=c[rb>>2]|0;c[nb+(ja*52|0)+4>>2]=fb;a[nb+(ja*52|0)+8|0]=1;break}if((UO($b,107432)|0)!=0){break b}a[(c[rb>>2]|0)+(ja*52|0)+8|0]=2}}while(0);uO($b);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break a}}dP(kc,107440,$b);sD(jc,kc,107464);uO(kc);c[s>>2]=RO(jc)|0;Pu(0,107480,s)}}while(0);if((c[63944>>2]|0)!=0){Vd[c[16120]&511](4)}Lu(4,1,107488,q);ob=b+212|0;c:do{if((c[ob>>2]|0)>0){ja=qa+108|0;rb=b+36|0;tb=0;while(1){c[lc>>2]=tb;gb=zD(ja,lc)|0;eD(gb,(c[rb>>2]|0)+(tb*52|0)+12|0);iO(mc);c[oc>>2]=tb;gb=zD(ja,oc)|0;oO(pc,107352);kO(nc,gD(gb,pc)|0);BD(nc,mc);uO(nc);uO(pc);gb=(UO(mc,107360)|0)==0;nb=c[rb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[p>>2]=c[nb+(tb*52|0)+16>>2];c[p+4>>2]=fb;Lu(4,0,107376,p);fb=c[rb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[rc>>2]=tb;fb=zD(ja,rc)|0;oO(sc,107416);kO(qc,gD(fb,sc)|0);BD(qc,mc);uO(qc);uO(sc);CD(wa,sa,mc);CD(xa,ua,mc);ED(tc,sa);if(DD(wa,tc)|0){fb=c[(FD(wa)|0)+12>>2]|0;nb=c[rb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{ED(uc,ua);if(!(DD(xa,uc)|0)){break}nb=c[(FD(xa)|0)+12>>2]|0;fb=c[rb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}uO(mc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break c}}dP(wc,107528,mc);sD(vc,wc,107464);uO(wc);c[o>>2]=RO(vc)|0;Pu(0,107480,o)}}while(0);if((c[63944>>2]|0)!=0){Vd[c[16120]&511](4)}Lu(4,1,107552,n);ob=b+216|0;d:do{if((c[ob>>2]|0)>0){tb=qa+144|0;rb=b+40|0;ja=0;while(1){c[xc>>2]=ja;fb=zD(tb,xc)|0;eD(fb,(c[rb>>2]|0)+(ja*52|0)+12|0);iO(yc);c[Ac>>2]=ja;fb=zD(tb,Ac)|0;oO(Bc,107352);kO(zc,gD(fb,Bc)|0);BD(zc,yc);uO(zc);uO(Bc);fb=(UO(yc,107360)|0)==0;nb=c[rb>>2]|0;gb=fb&1;c[nb+(ja*52|0)>>2]=gb;c[m>>2]=c[nb+(ja*52|0)+16>>2];c[m+4>>2]=gb;Lu(4,0,107376,m);gb=c[rb>>2]|0;if((a[c[gb+(ja*52|0)+16>>2]|0]|0)==36){a[gb+(ja*52|0)+48|0]=1}c[Dc>>2]=ja;gb=zD(tb,Dc)|0;oO(Ec,107416);kO(Cc,gD(gb,Ec)|0);BD(Cc,yc);uO(Cc);uO(Ec);CD(wa,sa,yc);CD(xa,ua,yc);ED(Fc,sa);if(DD(wa,Fc)|0){gb=c[(FD(wa)|0)+12>>2]|0;nb=c[rb>>2]|0;c[nb+(ja*52|0)+4>>2]=gb;a[nb+(ja*52|0)+8|0]=0}else{ED(Gc,ua);if(!(DD(xa,Gc)|0)){break}nb=c[(FD(xa)|0)+12>>2]|0;gb=c[rb>>2]|0;c[gb+(ja*52|0)+4>>2]=nb;a[gb+(ja*52|0)+8|0]=1}uO(yc);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break d}}dP(Ic,107592,yc);sD(Hc,Ic,107464);uO(Ic);c[l>>2]=RO(Hc)|0;Pu(0,107480,l)}}while(0);if((c[63944>>2]|0)!=0){Vd[c[16120]&511](4)}Lu(4,1,107616,j);ob=b+220|0;e:do{if((c[ob>>2]|0)>0){ja=qa+180|0;rb=b+44|0;tb=0;while(1){c[Jc>>2]=tb;gb=zD(ja,Jc)|0;eD(gb,(c[rb>>2]|0)+(tb*52|0)+12|0);iO(Kc);c[Mc>>2]=tb;gb=zD(ja,Mc)|0;oO(Nc,107352);kO(Lc,gD(gb,Nc)|0);BD(Lc,Kc);uO(Lc);uO(Nc);gb=(UO(Kc,107360)|0)==0;nb=c[rb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[g>>2]=c[nb+(tb*52|0)+16>>2];c[g+4>>2]=fb;Lu(4,0,107376,g);fb=c[rb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[Pc>>2]=tb;fb=zD(ja,Pc)|0;oO(Qc,107416);kO(Oc,gD(fb,Qc)|0);BD(Oc,Kc);uO(Oc);uO(Qc);CD(wa,sa,Kc);CD(xa,ua,Kc);ED(Rc,sa);if(DD(wa,Rc)|0){fb=c[(FD(wa)|0)+12>>2]|0;nb=c[rb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{ED(Tc,ua);if(!(DD(xa,Tc)|0)){break}nb=c[(FD(xa)|0)+12>>2]|0;fb=c[rb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}uO(Kc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break e}}dP(Vc,107656,Kc);sD(Uc,Vc,107464);uO(Vc);c[f>>2]=RO(Uc)|0;Pu(0,107480,f)}}while(0);if((c[63944>>2]|0)==0){Tp(pa);GD(ua);GD(sa);uO(ra);HD(qa);i=e;return}Vd[c[16120]&511](4);Tp(pa);GD(ua);GD(sa);uO(ra);HD(qa);i=e;return}}while(0);if((c[64016>>2]|c[15980]|0)==0){Tp(pa);Zc=jd(0)|0;qd(-1)}Nu(22,1,106544,Y);Y=c[Wa>>2]|0;c[X>>2]=vb;c[X+4>>2]=Y;Nu(22,0,106592,X);X=(c[b+108>>2]|0)-(c[Wa>>2]<<1)|0;c[W>>2]=c[Xa>>2];c[W+4>>2]=X;Nu(22,0,106640,W);W=c[b+128>>2]|0;c[V>>2]=c[Ya>>2];c[V+4>>2]=W;Nu(22,0,106688,V);V=c[b+132>>2]|0;c[U>>2]=c[_a>>2];c[U+4>>2]=V;Nu(22,0,106736,U);U=c[b+116>>2]|0;c[T>>2]=c[Za>>2];c[T+4>>2]=U;Nu(22,0,106784,T);T=c[b+136>>2]|0;c[S>>2]=c[ab>>2];c[S+4>>2]=T;Nu(22,0,106832,S);S=c[b+120>>2]|0;c[R>>2]=c[$a>>2];c[R+4>>2]=S;Nu(22,0,106880,R);R=c[b+140>>2]|0;c[Q>>2]=c[cb>>2];c[Q+4>>2]=R;Nu(22,0,106928,Q);Q=c[b+124>>2]|0;c[P>>2]=c[bb>>2];c[P+4>>2]=Q;Nu(22,0,106976,P);Vd[c[16120]&511](22);Tp(pa);Zc=jd(0)|0;qd(-1)}function qD(a){a=a|0;var b=0;b=i;qK(a);i=b;return}function rD(a,b){a=a|0;b=b|0;b=i;XF(a,0);i=b;return}function sD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;jO(a,d);e=sO(b)|0;f=fE(c)|0;VO(a,tO(b)|0,e,f+e|0);NO(a,c,f)|0;i=d;return}function tD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;if((ZY(b,108288)|0)==0){t=c[d>>2]|0;if((t|0)==0){i=e;return}u=a;v=t;t=0;do{oO(g,v);w=gD(u,g)|0;wO(w,c[d+((t|1)<<2)>>2]|0)|0;uO(g);t=t+2|0;v=c[d+(t<<2)>>2]|0;}while((v|0)!=0);i=e;return}if((ZY(b,108312)|0)==0){v=c[d>>2]|0;if((v|0)==0){i=e;return}t=a+12|0;g=v;v=0;do{oO(h,g);u=gD(t,h)|0;wO(u,c[d+((v|1)<<2)>>2]|0)|0;uO(h);v=v+2|0;g=c[d+(v<<2)>>2]|0;}while((g|0)!=0);i=e;return}if((ZY(b,108336)|0)!=0){do{if((ZY(b,108592)|0)!=0){if((ZY(b,108600)|0)==0){break}if((ZY(b,108608)|0)==0){break}if((ZY(b,108616)|0)==0){break}i=e;return}}while(0);g=(c[d>>2]|0)==0;v=a+196|0;h=a+192|0;t=zD(c[v>>2]|0,h)|0;if(g){x=t}else{g=t;t=d;u=0;while(1){oO(r,c[t>>2]|0);w=gD(g,r)|0;wO(w,c[d+((u|1)<<2)>>2]|0)|0;uO(r);w=u+2|0;y=d+(w<<2)|0;z=(c[y>>2]|0)==0;A=zD(c[v>>2]|0,h)|0;if(z){x=A;break}else{u=w;t=y;g=A}}}oO(s,108624);wO(gD(x,s)|0,b)|0;uO(s);i=e;return}ID(j,k);iO(l);iO(m);k=a+192|0;s=k;c[k>>2]=-1;b=a+196|0;c[b>>2]=0;x=c[d>>2]|0;if((x|0)!=0){g=x;x=0;do{oO(n,g);t=gD(j,n)|0;wO(t,c[d+((x|1)<<2)>>2]|0)|0;uO(n);x=x+2|0;g=c[d+(x<<2)>>2]|0;}while((g|0)!=0)}oO(o,108352);vO(l,gD(j,o)|0)|0;uO(o);oO(p,108368);vO(m,gD(j,p)|0)|0;uO(p);c[k>>2]=Ac(RO(l)|0)|0;if((UO(m,108384)|0)==0){B=a+24|0}else{B=c[b>>2]|0}c[b>>2]=B;if((UO(m,108392)|0)==0){C=a+36|0}else{C=c[b>>2]|0}c[b>>2]=C;if((UO(m,108400)|0)==0){D=a+48|0}else{D=c[b>>2]|0}c[b>>2]=D;if((UO(m,108408)|0)==0){E=a+60|0}else{E=c[b>>2]|0}c[b>>2]=E;if((UO(m,108416)|0)==0){F=a+72|0}else{F=c[b>>2]|0}c[b>>2]=F;if((UO(m,108424)|0)==0){G=a+84|0}else{G=c[b>>2]|0}c[b>>2]=G;if((UO(m,108432)|0)==0){H=a+96|0}else{H=c[b>>2]|0}c[b>>2]=H;if((UO(m,108440)|0)==0){I=a+108|0}else{I=c[b>>2]|0}c[b>>2]=I;if((UO(m,108448)|0)==0){J=a+120|0}else{J=c[b>>2]|0}c[b>>2]=J;if((UO(m,108456)|0)==0){K=a+132|0}else{K=c[b>>2]|0}c[b>>2]=K;if((UO(m,108464)|0)==0){L=a+144|0}else{L=c[b>>2]|0}c[b>>2]=L;if((UO(m,108472)|0)==0){M=a+156|0}else{M=c[b>>2]|0}c[b>>2]=M;if((UO(m,108480)|0)==0){N=a+168|0}else{N=c[b>>2]|0}c[b>>2]=N;if((UO(m,108488)|0)==0){O=a+180|0}else{O=c[b>>2]|0}c[b>>2]=O;a=RO(m)|0;oO(q,104912);N=RO(gD(j,q)|0)|0;c[f>>2]=a;c[f+4>>2]=N;Ou(0,(O|0)!=0|0,108496,f);uO(q);VI(zD(c[b>>2]|0,s)|0,j)|0;uO(m);uO(l);QD(j);i=e;return}function uD(a,b){a=a|0;b=b|0;i=i;return}function vD(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=GF(a,b)|0;i=c;return d|0}function wD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;PF(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];HF(a,f);i=e;return}function xD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;IF(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];HF(a,e);i=d;return}function yD(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,pd=0,qd=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+192|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+8|0;$=i;i=i+16|0;aa=i;i=i+8|0;ba=i;i=i+16|0;ca=i;i=i+8|0;da=i;i=i+16|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+16|0;qa=i;i=i+8|0;ra=i;i=i+16|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+16|0;wa=i;i=i+8|0;xa=i;i=i+16|0;ya=i;i=i+8|0;za=i;i=i+16|0;Aa=i;i=i+8|0;Ba=i;i=i+16|0;Ca=i;i=i+8|0;Da=i;i=i+16|0;Ea=i;i=i+8|0;Fa=i;i=i+16|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;Ka=i;i=i+8|0;La=i;i=i+16|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+16|0;Sa=i;i=i+8|0;Ta=i;i=i+16|0;Ua=i;i=i+8|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;Ya=i;i=i+8|0;Za=i;i=i+16|0;_a=i;i=i+8|0;$a=i;i=i+16|0;ab=i;i=i+8|0;bb=i;i=i+16|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+8|0;fb=i;i=i+16|0;gb=i;i=i+8|0;hb=i;i=i+16|0;ib=i;i=i+8|0;jb=i;i=i+16|0;kb=i;i=i+8|0;lb=i;i=i+16|0;mb=i;i=i+8|0;nb=i;i=i+16|0;ob=i;i=i+8|0;pb=i;i=i+16|0;qb=i;i=i+8|0;rb=i;i=i+16|0;sb=i;i=i+8|0;tb=i;i=i+16|0;ub=i;i=i+8|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+8|0;zb=i;i=i+16|0;Ab=i;i=i+8|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;Gb=i;i=i+8|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+8|0;Lb=i;i=i+16|0;Mb=i;i=i+8|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+8|0;Rb=i;i=i+16|0;Tb=i;i=i+8|0;Ub=i;i=i+16|0;Vb=i;i=i+8|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+8|0;_b=i;i=i+16|0;$b=i;i=i+8|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;ID(o,p);p=(d|0)!=0;dc=(e|0)==0;if(!(dc|p^1)){Pu(0,107680,n)}if(p){ec=od(d|0)|0}else{ec=0}if(dc){fc=ec}else{c[m>>2]=e;Lu(23,0,107824,m);JD(q);KD(q,e,8);if(!(LD(q)|0)){c[l>>2]=e;Pu(0,107864,l)}iO(r);l=q;MD(l,r)|0;kO(s,r);while(1){e=MD(l,r)|0;if(!(eP(e+(c[(c[e>>2]|0)+ -12>>2]|0)|0)|0)){break}dP(t,107944,r);LO(s,t)|0;uO(t)}t=od(RO(s)|0)|0;ND(q);uO(s);uO(r);OD(q);fc=t}if((fc|0)==0){Lu(23,0,108032,g);QD(o);i=f;return}iO(u);iO(v);c[k>>2]=fc;Lu(23,0,107952,k);k=Sb(fc|0,107944)|0;if((k|0)!=0){g=k;do{k=FY(12)|0;oO(k,g);t=SO(k,107984,0)|0;QO(w,k,0,t);vO(u,w)|0;uO(w);QO(x,k,t+1|0,(BO(k)|0)+~t|0);vO(v,x)|0;uO(x);vO(gD(o,u)|0,v)|0;t=RO(u)|0;k=RO(v)|0;c[j>>2]=t;c[j+4>>2]=k;Lu(23,0,107992,j);g=Sb(0,107944)|0;}while((g|0)!=0)}AY(fc);fc=a+12|0;oO(y,106080);g=gD(fc,y)|0;oO(z,106080);if((PD(o,z)|0)==0){oO(B,106080);gc=1;hc=0;ic=gD(fc,B)|0}else{oO(A,106080);gc=0;hc=1;ic=gD(o,A)|0}vO(g,ic)|0;if(gc){uO(B)}if(hc){uO(A)}uO(z);uO(y);oO(C,105952);y=gD(fc,C)|0;oO(D,105952);if((PD(o,D)|0)==0){oO(F,105952);jc=1;kc=0;lc=gD(fc,F)|0}else{oO(E,105952);jc=0;kc=1;lc=gD(o,E)|0}vO(y,lc)|0;if(jc){uO(F)}if(kc){uO(E)}uO(D);uO(C);oO(G,105984);C=gD(fc,G)|0;oO(H,105984);if((PD(o,H)|0)==0){oO(J,105984);mc=1;nc=0;oc=gD(fc,J)|0}else{oO(I,105984);mc=0;nc=1;oc=gD(o,I)|0}vO(C,oc)|0;if(mc){uO(J)}if(nc){uO(I)}uO(H);uO(G);oO(K,106016);G=gD(fc,K)|0;oO(L,106016);if((PD(o,L)|0)==0){oO(N,106016);pc=0;qc=1;rc=gD(fc,N)|0}else{oO(M,106016);pc=1;qc=0;rc=gD(o,M)|0}vO(G,rc)|0;if(qc){uO(N)}if(pc){uO(M)}uO(L);uO(K);oO(O,106048);K=gD(fc,O)|0;oO(P,106048);if((PD(o,P)|0)==0){oO(R,106048);sc=1;tc=0;uc=gD(fc,R)|0}else{oO(Q,106048);sc=0;tc=1;uc=gD(o,Q)|0}vO(K,uc)|0;if(sc){uO(R)}if(tc){uO(Q)}uO(P);uO(O);oO(S,106112);O=gD(fc,S)|0;oO(T,106112);if((PD(o,T)|0)==0){oO(V,106112);vc=1;wc=0;xc=gD(fc,V)|0}else{oO(U,106112);vc=0;wc=1;xc=gD(o,U)|0}vO(O,xc)|0;if(vc){uO(V)}if(wc){uO(U)}uO(T);uO(S);oO(W,106152);S=gD(fc,W)|0;oO(X,106152);if((PD(o,X)|0)==0){oO(Z,106152);yc=1;zc=0;Ac=gD(fc,Z)|0}else{oO(Y,106152);yc=0;zc=1;Ac=gD(o,Y)|0}vO(S,Ac)|0;if(yc){uO(Z)}if(zc){uO(Y)}uO(X);uO(W);W=b+104|0;X=c[W>>2]|0;if((X|0)>0){Y=a+24|0;zc=a+36|0;Z=0;while(1){c[_>>2]=Z;yc=zD(Y,_)|0;oO($,105056);Ac=gD(yc,$)|0;c[aa>>2]=Z;yc=zD(Y,aa)|0;oO(ba,104912);if((PD(o,gD(yc,ba)|0)|0)==0){c[ea>>2]=Z;yc=zD(Y,ea)|0;oO(fa,105056);Bc=1;Cc=0;Dc=gD(yc,fa)|0}else{c[ca>>2]=Z;yc=zD(Y,ca)|0;oO(da,104912);Bc=0;Cc=1;Dc=gD(o,gD(yc,da)|0)|0}vO(Ac,Dc)|0;if(Bc){uO(fa)}if(Cc){uO(da)}uO(ba);uO($);c[ga>>2]=Z;Ac=zD(zc,ga)|0;oO(ha,105056);yc=gD(Ac,ha)|0;c[ia>>2]=Z;Ac=zD(zc,ia)|0;oO(ja,104912);if((PD(o,gD(Ac,ja)|0)|0)==0){c[ma>>2]=Z;Ac=zD(zc,ma)|0;oO(na,105056);Ec=1;Fc=0;Gc=gD(Ac,na)|0}else{c[ka>>2]=Z;Ac=zD(zc,ka)|0;oO(la,104912);Ec=0;Fc=1;Gc=gD(o,gD(Ac,la)|0)|0}vO(yc,Gc)|0;if(Ec){uO(na)}if(Fc){uO(la)}uO(ja);uO(ha);yc=Z+1|0;Ac=c[W>>2]|0;if((yc|0)<(Ac|0)){Z=yc}else{Hc=Ac;break}}}else{Hc=X}X=b+108|0;if(((c[X>>2]|0)-(Hc<<1)|0)>0){Hc=a+48|0;Z=0;do{c[oa>>2]=Z;ha=zD(Hc,oa)|0;oO(pa,105056);ja=gD(ha,pa)|0;c[qa>>2]=Z;ha=zD(Hc,qa)|0;oO(ra,104912);if((PD(o,gD(ha,ra)|0)|0)==0){c[ua>>2]=Z;ha=zD(Hc,ua)|0;oO(va,105056);Ic=1;Jc=0;Kc=gD(ha,va)|0}else{c[sa>>2]=Z;ha=zD(Hc,sa)|0;oO(ta,104912);Ic=0;Jc=1;Kc=gD(o,gD(ha,ta)|0)|0}vO(ja,Kc)|0;if(Ic){uO(va)}if(Jc){uO(ta)}uO(ra);uO(pa);Z=Z+1|0;}while((Z|0)<((c[X>>2]|0)-(c[W>>2]<<1)|0))}W=b+116|0;if((c[W>>2]|0)>0){X=a+84|0;Z=0;do{c[wa>>2]=Z;pa=zD(X,wa)|0;oO(xa,105056);ra=gD(pa,xa)|0;c[ya>>2]=Z;pa=zD(X,ya)|0;oO(za,104912);if((PD(o,gD(pa,za)|0)|0)==0){c[Ca>>2]=Z;pa=zD(X,Ca)|0;oO(Da,105056);Lc=1;Mc=0;Nc=gD(pa,Da)|0}else{c[Aa>>2]=Z;pa=zD(X,Aa)|0;oO(Ba,104912);Lc=0;Mc=1;Nc=gD(o,gD(pa,Ba)|0)|0}vO(ra,Nc)|0;if(Lc){uO(Da)}if(Mc){uO(Ba)}uO(za);uO(xa);Z=Z+1|0;}while((Z|0)<(c[W>>2]|0))}W=b+120|0;if((c[W>>2]|0)>0){Z=a+120|0;xa=0;do{c[Ea>>2]=xa;za=zD(Z,Ea)|0;oO(Fa,105056);Ba=gD(za,Fa)|0;c[Ga>>2]=xa;za=zD(Z,Ga)|0;oO(Ha,104912);if((PD(o,gD(za,Ha)|0)|0)==0){c[Ka>>2]=xa;za=zD(Z,Ka)|0;oO(La,105056);Oc=1;Pc=0;Qc=gD(za,La)|0}else{c[Ia>>2]=xa;za=zD(Z,Ia)|0;oO(Ja,104912);Oc=0;Pc=1;Qc=gD(o,gD(za,Ja)|0)|0}vO(Ba,Qc)|0;if(Oc){uO(La)}if(Pc){uO(Ja)}uO(Ha);uO(Fa);xa=xa+1|0;}while((xa|0)<(c[W>>2]|0))}W=b+124|0;if((c[W>>2]|0)>0){xa=a+156|0;Fa=0;do{c[Ma>>2]=Fa;Ha=zD(xa,Ma)|0;oO(Na,105056);Ja=gD(Ha,Na)|0;c[Oa>>2]=Fa;Ha=zD(xa,Oa)|0;oO(Pa,104912);if((PD(o,gD(Ha,Pa)|0)|0)==0){c[Sa>>2]=Fa;Ha=zD(xa,Sa)|0;oO(Ta,105056);Rc=1;Sc=0;Tc=gD(Ha,Ta)|0}else{c[Qa>>2]=Fa;Ha=zD(xa,Qa)|0;oO(Ra,104912);Rc=0;Sc=1;Tc=gD(o,gD(Ha,Ra)|0)|0}vO(Ja,Tc)|0;if(Rc){uO(Ta)}if(Sc){uO(Ra)}uO(Pa);uO(Na);Fa=Fa+1|0;}while((Fa|0)<(c[W>>2]|0))}W=b+128|0;if((c[W>>2]|0)>0){Fa=a+60|0;Na=0;do{c[Ua>>2]=Na;Pa=zD(Fa,Ua)|0;oO(Va,105056);Ra=gD(Pa,Va)|0;c[Wa>>2]=Na;Pa=zD(Fa,Wa)|0;oO(Xa,104912);if((PD(o,gD(Pa,Xa)|0)|0)==0){c[_a>>2]=Na;Pa=zD(Fa,_a)|0;oO($a,105056);Uc=1;Vc=0;Wc=gD(Pa,$a)|0}else{c[Ya>>2]=Na;Pa=zD(Fa,Ya)|0;oO(Za,104912);Uc=0;Vc=1;Wc=gD(o,gD(Pa,Za)|0)|0}vO(Ra,Wc)|0;if(Uc){uO($a)}if(Vc){uO(Za)}uO(Xa);uO(Va);Na=Na+1|0;}while((Na|0)<(c[W>>2]|0))}W=b+132|0;if((c[W>>2]|0)>0){Na=a+96|0;Va=0;do{c[ab>>2]=Va;Xa=zD(Na,ab)|0;oO(bb,105056);Za=gD(Xa,bb)|0;c[cb>>2]=Va;Xa=zD(Na,cb)|0;oO(db,104912);if((PD(o,gD(Xa,db)|0)|0)==0){c[gb>>2]=Va;Xa=zD(Na,gb)|0;oO(hb,105056);Xc=1;Yc=0;Zc=gD(Xa,hb)|0}else{c[eb>>2]=Va;Xa=zD(Na,eb)|0;oO(fb,104912);Xc=0;Yc=1;Zc=gD(o,gD(Xa,fb)|0)|0}vO(Za,Zc)|0;if(Xc){uO(hb)}if(Yc){uO(fb)}uO(db);uO(bb);Va=Va+1|0;}while((Va|0)<(c[W>>2]|0))}W=b+136|0;if((c[W>>2]|0)>0){Va=a+132|0;bb=0;do{c[ib>>2]=bb;db=zD(Va,ib)|0;oO(jb,105056);fb=gD(db,jb)|0;c[kb>>2]=bb;db=zD(Va,kb)|0;oO(lb,104912);if((PD(o,gD(db,lb)|0)|0)==0){c[ob>>2]=bb;db=zD(Va,ob)|0;oO(pb,105056);_c=1;$c=0;ad=gD(db,pb)|0}else{c[mb>>2]=bb;db=zD(Va,mb)|0;oO(nb,104912);_c=0;$c=1;ad=gD(o,gD(db,nb)|0)|0}vO(fb,ad)|0;if(_c){uO(pb)}if($c){uO(nb)}uO(lb);uO(jb);bb=bb+1|0;}while((bb|0)<(c[W>>2]|0))}W=b+140|0;if((c[W>>2]|0)>0){bb=a+168|0;jb=0;do{c[qb>>2]=jb;lb=zD(bb,qb)|0;oO(rb,105056);nb=gD(lb,rb)|0;c[sb>>2]=jb;lb=zD(bb,sb)|0;oO(tb,104912);if((PD(o,gD(lb,tb)|0)|0)==0){c[wb>>2]=jb;lb=zD(bb,wb)|0;oO(xb,105056);bd=1;cd=0;dd=gD(lb,xb)|0}else{c[ub>>2]=jb;lb=zD(bb,ub)|0;oO(vb,104912);bd=0;cd=1;dd=gD(o,gD(lb,vb)|0)|0}vO(nb,dd)|0;if(bd){uO(xb)}if(cd){uO(vb)}uO(tb);uO(rb);jb=jb+1|0;}while((jb|0)<(c[W>>2]|0))}W=b+208|0;if((c[W>>2]|0)>0){jb=a+72|0;rb=0;do{c[yb>>2]=rb;tb=zD(jb,yb)|0;oO(zb,105056);vb=gD(tb,zb)|0;c[Ab>>2]=rb;tb=zD(jb,Ab)|0;oO(Bb,104912);if((PD(o,gD(tb,Bb)|0)|0)==0){c[Eb>>2]=rb;tb=zD(jb,Eb)|0;oO(Fb,105056);ed=1;fd=0;gd=gD(tb,Fb)|0}else{c[Cb>>2]=rb;tb=zD(jb,Cb)|0;oO(Db,104912);ed=0;fd=1;gd=gD(o,gD(tb,Db)|0)|0}vO(vb,gd)|0;if(ed){uO(Fb)}if(fd){uO(Db)}uO(Bb);uO(zb);rb=rb+1|0;}while((rb|0)<(c[W>>2]|0))}W=b+212|0;if((c[W>>2]|0)>0){rb=a+108|0;zb=0;do{c[Gb>>2]=zb;Bb=zD(rb,Gb)|0;oO(Hb,105056);Db=gD(Bb,Hb)|0;c[Ib>>2]=zb;Bb=zD(rb,Ib)|0;oO(Jb,104912);if((PD(o,gD(Bb,Jb)|0)|0)==0){c[Mb>>2]=zb;Bb=zD(rb,Mb)|0;oO(Nb,105056);hd=0;id=1;jd=gD(Bb,Nb)|0}else{c[Kb>>2]=zb;Bb=zD(rb,Kb)|0;oO(Lb,104912);hd=1;id=0;jd=gD(o,gD(Bb,Lb)|0)|0}vO(Db,jd)|0;if(id){uO(Nb)}if(hd){uO(Lb)}uO(Jb);uO(Hb);zb=zb+1|0;}while((zb|0)<(c[W>>2]|0))}W=b+216|0;if((c[W>>2]|0)>0){zb=a+144|0;Hb=0;do{c[Ob>>2]=Hb;Jb=zD(zb,Ob)|0;oO(Pb,105056);Lb=gD(Jb,Pb)|0;c[Qb>>2]=Hb;Jb=zD(zb,Qb)|0;oO(Rb,104912);if((PD(o,gD(Jb,Rb)|0)|0)==0){c[Vb>>2]=Hb;Jb=zD(zb,Vb)|0;oO(Wb,105056);kd=1;ld=0;md=gD(Jb,Wb)|0}else{c[Tb>>2]=Hb;Jb=zD(zb,Tb)|0;oO(Ub,104912);kd=0;ld=1;md=gD(o,gD(Jb,Ub)|0)|0}vO(Lb,md)|0;if(kd){uO(Wb)}if(ld){uO(Ub)}uO(Rb);uO(Pb);Hb=Hb+1|0;}while((Hb|0)<(c[W>>2]|0))}W=b+220|0;if((c[W>>2]|0)>0){b=a+180|0;a=0;do{c[Xb>>2]=a;Hb=zD(b,Xb)|0;oO(Yb,105056);Pb=gD(Hb,Yb)|0;c[Zb>>2]=a;Hb=zD(b,Zb)|0;oO(_b,104912);if((PD(o,gD(Hb,_b)|0)|0)==0){c[bc>>2]=a;Hb=zD(b,bc)|0;oO(cc,105056);nd=1;pd=0;qd=gD(Hb,cc)|0}else{c[$b>>2]=a;Hb=zD(b,$b)|0;oO(ac,104912);nd=0;pd=1;qd=gD(o,gD(Hb,ac)|0)|0}vO(Pb,qd)|0;if(nd){uO(cc)}if(pd){uO(ac)}uO(_b);uO(Yb);a=a+1|0;}while((a|0)<(c[W>>2]|0))}Lu(23,0,108016,h);uO(v);uO(u);QD(o);i=f;return}function zD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=eG(a,f,b)|0;l=c[k>>2]|0;Sz(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}gG(j,a,b);hG(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];fG(g,e);iG(j);j=c[f>>2]|0;jG(a,j,k,kG(g)|0);k=lG(g)|0;iG(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function AD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=IE(a,f,b)|0;l=c[k>>2]|0;Sz(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}KE(j,a,b);LE(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];JE(g,e);ME(j);j=c[f>>2]|0;NE(a,j,k,OE(g)|0);k=PE(g)|0;ME(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function BD(a,b){a=a|0;b=b|0;var c=0;c=i;vO(b,a)|0;i=c;return}function CD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;zE(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];rE(a,f);i=e;return}function DD(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=pE(a,b)|0;i=c;return d|0}function ED(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;sE(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];rE(a,e);i=d;return}function FD(a){a=a|0;var b=0,c=0;b=i;c=mE(a)|0;i=b;return c|0}function GD(a){a=a|0;var b=0;b=i;LI(a);i=b;return}function HD(a){a=a|0;var b=0;b=i;yI(a);i=b;return}function ID(a,b){a=a|0;b=b|0;b=i;fH(a,0);i=b;return}function JD(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+108|0;rP(d);e=a;c[e>>2]=108084;f=d;c[f>>2]=108104;d=a+8|0;jQ(a,108116|0,d);c[e>>2]=108084;c[f>>2]=108104;zC(d);i=b;return}function KD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(_z(a+8|0,b,d|8)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){iP(d,4);i=e;return}else{gP(d,0);i=e;return}}function LD(a){a=a|0;var b=0,c=0;b=i;c=hE(a+8|0)|0;i=b;return c|0}function MD(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=gE(a,b,pP(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;i=d;return e|0}function ND(a){a=a|0;var b=0;b=i;if((aA(a+8|0)|0)!=0){i=b;return}iP(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function OD(a){a=a|0;var b=0;b=i;lE(a,108112);mP(a+108|0);i=b;return}function PD(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=RD(a,b)|0;i=c;return d|0}function QD(a){a=a|0;var b=0;b=i;nI(a);i=b;return}function RD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d;f=TD(a)|0;Sz(e);if((f|0)==0){g=0;i=d;return g|0}h=UD(a)|0;a=f;while(1){f=a+16|0;if(VD(h,b,f)|0){j=a}else{if(!(WD(h,f,b)|0)){g=1;k=8;break}j=a+4|0}f=c[j>>2]|0;Sz(e);if((f|0)==0){g=0;k=8;break}else{a=f}}if((k|0)==8){i=d;return g|0}return 0}function SD(a){a=a|0;var b=0,c=0;b=i;c=Dz(aE(a+4|0)|0)|0;i=b;return c|0}function TD(a){a=a|0;var b=0,d=0;b=i;d=c[(SD(a)|0)>>2]|0;i=b;return d|0}function UD(a){a=a|0;var b=0,c=0;b=i;c=_D(a+8|0)|0;i=b;return c|0}function VD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=XD(0,b,c)|0;i=a;return d|0}function WD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=XD(0,b,c)|0;i=a;return d|0}function XD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=YD(b,c)|0;i=a;return d|0}function YD(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(TO(a,b)|0)<0;i=c;return d|0}function ZD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=YY(a,b,c)|0;i=d;return e|0}function _D(a){a=a|0;var b=0,c=0;b=i;c=$D(a)|0;i=b;return c|0}function $D(a){a=a|0;i=i;return a|0}function aE(a){a=a|0;var b=0,c=0;b=i;c=bE(a)|0;i=b;return c|0}function bE(a){a=a|0;i=i;return a|0}function cE(a,b){a=a|0;b=b|0;var c=0;a=i;c=eE(0,b,0)|0;i=a;return c|0}function dE(b,c){b=b|0;c=c|0;a[b]=a[c]|0;i=i;return}function eE(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=FY(b)|0;i=c;return a|0}function fE(a){a=a|0;var b=0,c=0;b=i;c=bZ(a|0)|0;i=b;return c|0}function gE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;oQ(f,a,1);if(!(rQ(f)|0)){i=e;return a|0}KO(b);f=0;while(1){g=xP(nP(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0)|0)|0;if(MA(g,-1)|0){h=2;j=f;break}k=f+1|0;l=NA(g)|0;if(RA(l,d)|0){h=0;j=k;break}MO(b,l);if((sO(b)|0)==-17){h=4;j=k;break}else{f=k}}iP(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,(j|0)==0?h|4:h);i=e;return a|0}function hE(a){a=a|0;i=i;return(c[a+64>>2]|0)!=0|0}function iE(a){a=a|0;var b=0;b=i;OD(a);HY(a);i=b;return}function jE(a){a=a|0;var b=0;b=i;OD(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function kE(a){a=a|0;var b=0;b=i;iE(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function lE(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];AA(a+8|0);i=d;return}function mE(a){a=a|0;var b=0,d=0;b=i;d=nE((c[a>>2]|0)+16|0)|0;i=b;return d|0}function nE(a){a=a|0;var b=0,c=0;b=i;c=oE(a)|0;i=b;return c|0}function oE(a){a=a|0;i=i;return a|0}function pE(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(qE(a,b)|0)^1;i=c;return d|0}function qE(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function rE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];yE(a,e);i=d;return}function sE(a,b){a=a|0;b=b|0;var c=0;c=i;tE(a,uE(b)|0);i=c;return}function tE(a,b){a=a|0;b=b|0;var c=0;c=i;xE(a,b);i=c;return}function uE(a){a=a|0;var b=0,c=0;b=i;c=Dz(vE(a+4|0)|0)|0;i=b;return c|0}function vE(a){a=a|0;var b=0,c=0;b=i;c=wE(a)|0;i=b;return c|0}function wE(a){a=a|0;i=i;return a|0}function xE(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function yE(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function zE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=BE(b)|0;AE(f,b,d,h,uE(b)|0);sE(g,b);do{if(pE(f,g)|0){h=CE(b)|0;if(DE(h,d,EE(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);sE(a,b);i=e;return}function AE(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;Sz(h);a:do{if((e|0)==0){j=f}else{k=CE(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(HE(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;Sz(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;Sz(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);tE(a,j);i=g;return}function BE(a){a=a|0;var b=0,d=0;b=i;d=c[(uE(a)|0)>>2]|0;i=b;return d|0}function CE(a){a=a|0;var b=0,c=0;b=i;c=FE(a+8|0)|0;i=b;return c|0}function DE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=XD(0,b,c)|0;i=a;return d|0}function EE(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function FE(a){a=a|0;var b=0,c=0;b=i;c=GE(a)|0;i=b;return c|0}function GE(a){a=a|0;i=i;return a|0}function HE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=XD(0,b,c)|0;i=a;return d|0}function IE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=BE(h)|0;Sz(e);if((a|0)==0){j=uE(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(XD(0,d,a)|0){m=l;j=c[m>>2]|0;Sz(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(XD(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;Sz(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function JE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];EF(a,e);i=d;return}function KE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=jF(d)|0;d=lF(n,1)|0;mF(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];kF(j,d,h);nF(0,cF((oF(j)|0)+16|0)|0,e);e=pF(j)|0;a[e+4|0]=1;qF(0,aF((oF(j)|0)+28|0)|0);a[e+5|0]=1;rF(m,j);LE(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];JE(b,g);ME(m);ME(j);i=f;return}function LE(a,b){a=a|0;b=b|0;var c=0;c=i;hF(a,b);i=c;return}function ME(a){a=a|0;var b=0;b=i;YE(a);i=b;return}function NE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;Sz(f);c[e>>2]=0;Sz(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=UE(a)|0;b=c[c[e>>2]>>2]|0;Sz(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(uE(a)|0)>>2]|0;CB(e,c[d>>2]|0);d=VE(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function OE(a){a=a|0;var b=0,d=0;b=i;d=c[(SE(a)|0)>>2]|0;i=b;return d|0}function PE(a){a=a|0;var b=0,d=0;b=i;d=QE(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function QE(a){a=a|0;var b=0,c=0;b=i;c=RE(a)|0;i=b;return c|0}function RE(a){a=a|0;i=i;return a|0}function SE(a){a=a|0;var b=0,c=0;b=i;c=TE(a)|0;i=b;return c|0}function TE(a){a=a|0;i=i;return a|0}function UE(a){a=a|0;i=i;return a|0}function VE(a){a=a|0;var b=0,c=0;b=i;c=WE(a+8|0)|0;i=b;return c|0}function WE(a){a=a|0;var b=0,c=0;b=i;c=XE(a)|0;i=b;return c|0}function XE(a){a=a|0;i=i;return a|0}function YE(a){a=a|0;var b=0;b=i;ZE(a,0);i=b;return}function ZE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=QE(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}$E(_E(e)|0,f);i=d;return}function _E(a){a=a|0;var b=0,c=0;b=i;c=gF(a)|0;i=b;return c|0}function $E(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;bF(f,cF(d+16|0)|0)}if((d|0)==0){i=e;return}dF(c[b>>2]|0,d,1);i=e;return}function aF(a){a=a|0;i=i;return a|0}function bF(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;fF(d,0,c);i=b;return}function cF(a){a=a|0;i=i;return a|0}function dF(a,b,c){a=a|0;b=b|0;c=c|0;c=i;eF(0,b,0);i=c;return}function eF(a,b,c){a=a|0;b=b|0;c=c|0;c=i;HY(b);i=c;return}function fF(a,b,c){a=a|0;b=b|0;c=c|0;b=i;uO(c);i=b;return}function gF(a){a=a|0;i=i;return a+4|0}function hF(a,b){a=a|0;b=b|0;var c=0;c=i;iF(a,b);i=c;return}function iF(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function jF(a){a=a|0;var b=0,c=0;b=i;c=CF(a+4|0)|0;i=b;return c|0}function kF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];uF(a,b,f);i=e;return}function lF(a,b){a=a|0;b=b|0;var c=0;a=i;c=tF(0,b,0)|0;i=a;return c|0}function mF(a,b){a=a|0;b=b|0;var c=0;c=i;sF(a,b);i=c;return}function nF(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}kO(b,c);i=a;return}function oF(a){a=a|0;var b=0,d=0;b=i;d=c[(SE(a)|0)>>2]|0;i=b;return d|0}function pF(a){a=a|0;var b=0,c=0;b=i;c=_E(a)|0;i=b;return c|0}function qF(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function rF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;hF(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];JE(h,f);LE(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];JE(a,e);ME(h);i=d;return}function sF(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function tF(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=FY(b<<5)|0;i=c;return a|0}function uF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(wF(g)|0)>>2]|0;g=xF(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];vF(b,a,f);i=e;return}function vF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];yF(a,b,f);i=e;return}function wF(a){a=a|0;i=i;return a|0}function xF(a){a=a|0;i=i;return a|0}function yF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(AF(g)|0)>>2]|0;g=BF(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];zF(b,a,f);i=e;return}function zF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(AF(f)|0)>>2];f=BF(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function AF(a){a=a|0;i=i;return a|0}function BF(a){a=a|0;i=i;return a|0}function CF(a){a=a|0;var b=0,c=0;b=i;c=DF(a)|0;i=b;return c|0}function DF(a){a=a|0;i=i;return a|0}function EF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=PE(FF(b)|0)|0;h=BF(pF(FF(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];vF(g,a,e);i=d;return}function FF(a){a=a|0;i=i;return c[a>>2]|0}function GF(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function HF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];OF(a,e);i=d;return}function IF(a,b){a=a|0;b=b|0;var c=0;c=i;JF(a,KF(b)|0);i=c;return}function JF(a,b){a=a|0;b=b|0;var c=0;c=i;NF(a,b);i=c;return}function KF(a){a=a|0;var b=0,c=0;b=i;c=Dz(LF(a+4|0)|0)|0;i=b;return c|0}function LF(a){a=a|0;var b=0,c=0;b=i;c=MF(a)|0;i=b;return c|0}function MF(a){a=a|0;i=i;return a|0}function NF(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function OF(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function PF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=RF(b)|0;QF(f,b,d,h,KF(b)|0);IF(g,b);do{if(SF(f,g)|0){h=TF(b)|0;if(VD(h,d,UF(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);IF(a,b);i=e;return}function QF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;Sz(h);a:do{if((e|0)==0){j=f}else{k=TF(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(WD(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;Sz(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;Sz(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);JF(a,j);i=g;return}function RF(a){a=a|0;var b=0,d=0;b=i;d=c[(KF(a)|0)>>2]|0;i=b;return d|0}function SF(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(GF(a,b)|0)^1;i=c;return d|0}function TF(a){a=a|0;var b=0,c=0;b=i;c=VF(a+8|0)|0;i=b;return c|0}function UF(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function VF(a){a=a|0;var b=0,c=0;b=i;c=WF(a)|0;i=b;return c|0}function WF(a){a=a|0;i=i;return a|0}function XF(a,b){a=a|0;b=b|0;b=i;i=i+8|0;YF(a,b);i=b;return}function YF(a,b){a=a|0;b=b|0;b=i;ZF(a,0);i=b;return}function ZF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;_F(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;$F(f,0,e);e=uE(b)|0;c[(UE(b)|0)>>2]=e;i=d;return}function _F(a){a=a|0;var b=0;b=i;cG(a);i=b;return}function $F(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;aG(b,c,f);i=e;return}function aG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(uC(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;bG(d,b,f);i=e;return}function bG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(uC(e)|0)>>2];i=d;return}function cG(a){a=a|0;var b=0;b=i;dG(a);i=b;return}function dG(a){a=a|0;var b=0;b=i;xC(a);i=b;return}function eG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=eH(h)|0;Sz(e);if((a|0)==0){j=rG(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(Pz(0,d,a)|0){m=l;j=c[m>>2]|0;Sz(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(Pz(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;Sz(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function fG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];cH(a,e);i=d;return}function gG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=JG(d)|0;d=LG(n,1)|0;MG(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];KG(j,d,h);NG(0,OB((OG(j)|0)+16|0)|0,e);e=PG(j)|0;a[e+4|0]=1;QG(0,CG((OG(j)|0)+20|0)|0);a[e+5|0]=1;RG(m,j);hG(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];fG(b,g);iG(m);iG(j);i=f;return}function hG(a,b){a=a|0;b=b|0;var c=0;c=i;HG(a,b);i=c;return}function iG(a){a=a|0;var b=0;b=i;xG(a);i=b;return}function jG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;Sz(f);c[e>>2]=0;Sz(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=qG(a)|0;b=c[c[e>>2]>>2]|0;Sz(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(rG(a)|0)>>2]|0;CB(e,c[d>>2]|0);d=sG(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function kG(a){a=a|0;var b=0,d=0;b=i;d=c[(oG(a)|0)>>2]|0;i=b;return d|0}function lG(a){a=a|0;var b=0,d=0;b=i;d=mG(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function mG(a){a=a|0;var b=0,c=0;b=i;c=nG(a)|0;i=b;return c|0}function nG(a){a=a|0;i=i;return a|0}function oG(a){a=a|0;var b=0,c=0;b=i;c=pG(a)|0;i=b;return c|0}function pG(a){a=a|0;i=i;return a|0}function qG(a){a=a|0;i=i;return a|0}function rG(a){a=a|0;var b=0,c=0;b=i;c=Dz(vG(a+4|0)|0)|0;i=b;return c|0}function sG(a){a=a|0;var b=0,c=0;b=i;c=tG(a+8|0)|0;i=b;return c|0}function tG(a){a=a|0;var b=0,c=0;b=i;c=uG(a)|0;i=b;return c|0}function uG(a){a=a|0;i=i;return a|0}function vG(a){a=a|0;var b=0,c=0;b=i;c=wG(a)|0;i=b;return c|0}function wG(a){a=a|0;i=i;return a|0}function xG(a){a=a|0;var b=0;b=i;yG(a,0);i=b;return}function yG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=mG(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}AG(zG(e)|0,f);i=d;return}function zG(a){a=a|0;var b=0,c=0;b=i;c=GG(a)|0;i=b;return c|0}function AG(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;BG(f,CG(d+20|0)|0)}if((d|0)==0){i=e;return}DG(c[b>>2]|0,d,1);i=e;return}function BG(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;FG(d,0,c);i=b;return}function CG(a){a=a|0;i=i;return a|0}function DG(a,b,c){a=a|0;b=b|0;c=c|0;c=i;EG(0,b,0);i=c;return}function EG(a,b,c){a=a|0;b=b|0;c=c|0;c=i;HY(b);i=c;return}function FG(a,b,c){a=a|0;b=b|0;c=c|0;b=i;QD(c);i=b;return}function GG(a){a=a|0;i=i;return a+4|0}function HG(a,b){a=a|0;b=b|0;var c=0;c=i;IG(a,b);i=c;return}function IG(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function JG(a){a=a|0;var b=0,c=0;b=i;c=aH(a+4|0)|0;i=b;return c|0}function KG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];UG(a,b,f);i=e;return}function LG(a,b){a=a|0;b=b|0;var c=0;a=i;c=TG(0,b,0)|0;i=a;return c|0}function MG(a,b){a=a|0;b=b|0;var c=0;c=i;SG(a,b);i=c;return}function NG(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function OG(a){a=a|0;var b=0,d=0;b=i;d=c[(oG(a)|0)>>2]|0;i=b;return d|0}function PG(a){a=a|0;var b=0,c=0;b=i;c=zG(a)|0;i=b;return c|0}function QG(a,b){a=a|0;b=b|0;a=i;i=i+8|0;if((b|0)==0){i=a;return}ID(b,a);i=a;return}function RG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;HG(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];fG(h,f);hG(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];fG(a,e);iG(h);i=d;return}function SG(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function TG(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=FY(b<<5)|0;i=c;return a|0}function UG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(WG(g)|0)>>2]|0;g=XG(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];VG(b,a,f);i=e;return}function VG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];YG(a,b,f);i=e;return}function WG(a){a=a|0;i=i;return a|0}function XG(a){a=a|0;i=i;return a|0}function YG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(_G(g)|0)>>2]|0;g=$G(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];ZG(b,a,f);i=e;return}function ZG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(_G(f)|0)>>2];f=$G(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function _G(a){a=a|0;i=i;return a|0}function $G(a){a=a|0;i=i;return a|0}function aH(a){a=a|0;var b=0,c=0;b=i;c=bH(a)|0;i=b;return c|0}function bH(a){a=a|0;i=i;return a|0}function cH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=lG(dH(b)|0)|0;h=$G(PG(dH(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];VG(g,a,e);i=d;return}function dH(a){a=a|0;i=i;return c[a>>2]|0}function eH(a){a=a|0;var b=0,d=0;b=i;d=c[(rG(a)|0)>>2]|0;i=b;return d|0}function fH(a,b){a=a|0;b=b|0;b=i;i=i+8|0;gH(a,b);i=b;return}function gH(a,b){a=a|0;b=b|0;b=i;hH(a,0);i=b;return}function hH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;iH(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;jH(f,0,e);e=KF(b)|0;c[(kH(b)|0)>>2]=e;i=d;return}function iH(a){a=a|0;var b=0;b=i;nH(a);i=b;return}function jH(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;lH(b,c,f);i=e;return}function kH(a){a=a|0;i=i;return a|0}function lH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(uC(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;mH(d,b,f);i=e;return}function mH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(uC(e)|0)>>2];i=d;return}function nH(a){a=a|0;var b=0;b=i;oH(a);i=b;return}function oH(a){a=a|0;var b=0;b=i;xC(a);i=b;return}function pH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=RF(h)|0;Sz(e);if((a|0)==0){j=KF(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(XD(0,d,a)|0){m=l;j=c[m>>2]|0;Sz(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(XD(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;Sz(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function qH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];lI(a,e);i=d;return}function rH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=SH(d)|0;d=UH(n,1)|0;VH(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];TH(j,d,h);WH(0,cF((XH(j)|0)+16|0)|0,e);e=YH(j)|0;a[e+4|0]=1;ZH(0,JH((XH(j)|0)+28|0)|0);a[e+5|0]=1;_H(m,j);sH(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];qH(b,g);tH(m);tH(j);i=f;return}function sH(a,b){a=a|0;b=b|0;var c=0;c=i;QH(a,b);i=c;return}function tH(a){a=a|0;var b=0;b=i;EH(a);i=b;return}function uH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;Sz(f);c[e>>2]=0;Sz(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=kH(a)|0;b=c[c[e>>2]>>2]|0;Sz(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(KF(a)|0)>>2]|0;CB(e,c[d>>2]|0);d=BH(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function vH(a){a=a|0;var b=0,d=0;b=i;d=c[(zH(a)|0)>>2]|0;i=b;return d|0}function wH(a){a=a|0;var b=0,d=0;b=i;d=xH(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function xH(a){a=a|0;var b=0,c=0;b=i;c=yH(a)|0;i=b;return c|0}function yH(a){a=a|0;i=i;return a|0}function zH(a){a=a|0;var b=0,c=0;b=i;c=AH(a)|0;i=b;return c|0}function AH(a){a=a|0;i=i;return a|0}function BH(a){a=a|0;var b=0,c=0;b=i;c=CH(a+8|0)|0;i=b;return c|0}function CH(a){a=a|0;var b=0,c=0;b=i;c=DH(a)|0;i=b;return c|0}function DH(a){a=a|0;i=i;return a|0}function EH(a){a=a|0;var b=0;b=i;FH(a,0);i=b;return}function FH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=xH(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}HH(GH(e)|0,f);i=d;return}function GH(a){a=a|0;var b=0,c=0;b=i;c=PH(a)|0;i=b;return c|0}function HH(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;IH(f,JH(d+28|0)|0)}if((a[b+4|0]|0)!=0){f=c[b>>2]|0;KH(f,cF(d+16|0)|0)}if((d|0)==0){i=e;return}LH(c[b>>2]|0,d,1);i=e;return}function IH(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;OH(d,0,c);i=b;return}function JH(a){a=a|0;i=i;return a|0}function KH(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;NH(d,0,c);i=b;return}function LH(a,b,c){a=a|0;b=b|0;c=c|0;c=i;MH(0,b,0);i=c;return}function MH(a,b,c){a=a|0;b=b|0;c=c|0;c=i;HY(b);i=c;return}function NH(a,b,c){a=a|0;b=b|0;c=c|0;b=i;uO(c);i=b;return}function OH(a,b,c){a=a|0;b=b|0;c=c|0;b=i;uO(c);i=b;return}function PH(a){a=a|0;i=i;return a+4|0}function QH(a,b){a=a|0;b=b|0;var c=0;c=i;RH(a,b);i=c;return}function RH(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function SH(a){a=a|0;var b=0,c=0;b=i;c=jI(a+4|0)|0;i=b;return c|0}function TH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];bI(a,b,f);i=e;return}function UH(a,b){a=a|0;b=b|0;var c=0;a=i;c=aI(0,b,0)|0;i=a;return c|0}function VH(a,b){a=a|0;b=b|0;var c=0;c=i;$H(a,b);i=c;return}function WH(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}kO(b,c);i=a;return}function XH(a){a=a|0;var b=0,d=0;b=i;d=c[(zH(a)|0)>>2]|0;i=b;return d|0}function YH(a){a=a|0;var b=0,c=0;b=i;c=GH(a)|0;i=b;return c|0}function ZH(a,b){a=a|0;b=b|0;a=i;if((b|0)==0){i=a;return}iO(b);i=a;return}function _H(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;QH(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];qH(h,f);sH(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];qH(a,e);tH(h);i=d;return}function $H(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function aI(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=FY(b*40|0)|0;i=c;return a|0}function bI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(dI(g)|0)>>2]|0;g=eI(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];cI(b,a,f);i=e;return}function cI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];fI(a,b,f);i=e;return}function dI(a){a=a|0;i=i;return a|0}function eI(a){a=a|0;i=i;return a|0}function fI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(hI(g)|0)>>2]|0;g=iI(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];gI(b,a,f);i=e;return}function gI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(hI(f)|0)>>2];f=iI(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function hI(a){a=a|0;i=i;return a|0}function iI(a){a=a|0;i=i;return a|0}function jI(a){a=a|0;var b=0,c=0;b=i;c=kI(a)|0;i=b;return c|0}function kI(a){a=a|0;i=i;return a|0}function lI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=wH(mI(b)|0)|0;h=iI(YH(mI(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];cI(g,a,e);i=d;return}function mI(a){a=a|0;i=i;return c[a>>2]|0}function nI(a){a=a|0;var b=0;b=i;oI(a);i=b;return}function oI(a){a=a|0;var b=0;b=i;pI(a);i=b;return}function pI(a){a=a|0;var b=0;b=i;qI(a,RF(a)|0);i=b;return}function qI(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;Sz(d);if((b|0)==0){i=d;return}qI(a,c[b>>2]|0);qI(a,c[b+4>>2]|0);e=SH(a)|0;rI(e,sI(b+16|0)|0);LH(e,b,1);i=d;return}function rI(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;tI(d,0,c);i=b;return}function sI(a){a=a|0;i=i;return a|0}function tI(a,b,c){a=a|0;b=b|0;c=c|0;b=i;uI(c);i=b;return}function uI(a){a=a|0;var b=0;b=i;vI(a);i=b;return}function vI(a){a=a|0;var b=0;b=i;wI(a);i=b;return}function wI(a){a=a|0;var b=0;b=i;xI(a);i=b;return}function xI(a){a=a|0;var b=0;b=i;uO(a+12|0);uO(a);i=b;return}function yI(a){a=a|0;var b=0;b=i;zI(a+180|0);zI(a+168|0);zI(a+156|0);zI(a+144|0);zI(a+132|0);zI(a+120|0);zI(a+108|0);zI(a+96|0);zI(a+84|0);zI(a+72|0);zI(a+60|0);zI(a+48|0);zI(a+36|0);zI(a+24|0);QD(a+12|0);QD(a);i=b;return}function zI(a){a=a|0;var b=0;b=i;AI(a);i=b;return}function AI(a){a=a|0;var b=0;b=i;BI(a);i=b;return}function BI(a){a=a|0;var b=0;b=i;CI(a);i=b;return}function CI(a){a=a|0;var b=0;b=i;DI(a,eH(a)|0);i=b;return}function DI(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;Sz(d);if((b|0)==0){i=d;return}DI(a,c[b>>2]|0);DI(a,c[b+4>>2]|0);e=JG(a)|0;EI(e,FI(b+16|0)|0);DG(e,b,1);i=d;return}function EI(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;GI(d,0,c);i=b;return}function FI(a){a=a|0;i=i;return a|0}function GI(a,b,c){a=a|0;b=b|0;c=c|0;b=i;HI(c);i=b;return}function HI(a){a=a|0;var b=0;b=i;II(a);i=b;return}function II(a){a=a|0;var b=0;b=i;JI(a);i=b;return}function JI(a){a=a|0;var b=0;b=i;KI(a);i=b;return}function KI(a){a=a|0;var b=0;b=i;QD(a+4|0);i=b;return}function LI(a){a=a|0;var b=0;b=i;MI(a);i=b;return}function MI(a){a=a|0;var b=0;b=i;NI(a);i=b;return}function NI(a){a=a|0;var b=0;b=i;OI(a,BE(a)|0);i=b;return}function OI(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;Sz(d);if((b|0)==0){i=d;return}OI(a,c[b>>2]|0);OI(a,c[b+4>>2]|0);e=jF(a)|0;PI(e,oE(b+16|0)|0);dF(e,b,1);i=d;return}function PI(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;QI(d,0,c);i=b;return}function QI(a,b,c){a=a|0;b=b|0;c=c|0;b=i;RI(c);i=b;return}function RI(a){a=a|0;var b=0;b=i;SI(a);i=b;return}function SI(a){a=a|0;var b=0;b=i;TI(a);i=b;return}function TI(a){a=a|0;var b=0;b=i;UI(a);i=b;return}function UI(a){a=a|0;var b=0;b=i;uO(a);i=b;return}function VI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;WI(a);YI(g,b);ZI(h,b);b=f;j=g;c[b+0>>2]=c[j+0>>2];j=e;b=h;c[j+0>>2]=c[b+0>>2];XI(a,f,e);i=d;return a|0}function WI(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;qI(a,RF(a)|0);c[(BH(a)|0)>>2]=0;d=KF(a)|0;c[(kH(a)|0)>>2]=d;Sz(b);c[d>>2]=0;i=b;return}function XI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;fJ(h,a);if(!(gJ(b,d)|0)){i=e;return}m=c[h>>2]|0;h=k;do{c[h>>2]=m;n=g;o=k;c[n+0>>2]=c[o+0>>2];_I(j,g);o=iJ(b)|0;n=f;p=j;c[n+0>>2]=c[p+0>>2];hJ(l,a,f,o);jJ(b)|0;}while(gJ(b,d)|0);i=e;return}function YI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;dJ(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];_I(a,e);i=d;return}function ZI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;$I(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];_I(a,e);i=d;return}function _I(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];cJ(a,e);i=d;return}function $I(a,b){a=a|0;b=b|0;var c=0;c=i;aJ(a,SD(b)|0);i=c;return}function aJ(a,b){a=a|0;b=b|0;var c=0;c=i;bJ(a,b);i=c;return}function bJ(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function cJ(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function dJ(a,b){a=a|0;b=b|0;var d=0;d=i;aJ(a,c[(eJ(b)|0)>>2]|0);i=d;return}function eJ(a){a=a|0;i=i;return a|0}function fJ(a,b){a=a|0;b=b|0;var c=0;c=i;ZI(a,b);i=c;return}function gJ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=pK(a,b)|0;i=c;return d|0}function hJ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+56|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=b;c[k>>2]=c[d>>2];rJ(l,e);e=h;d=k;c[e+0>>2]=c[d+0>>2];qJ(j,m,h,l);h=g;m=j;c[h+0>>2]=c[m+0>>2];HF(a,g);uI(l);i=f;return}function iJ(a){a=a|0;var b=0,c=0;b=i;c=nJ(a)|0;i=b;return c|0}function jJ(a){a=a|0;var b=0;b=i;kJ(a)|0;i=b;return a|0}function kJ(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=lJ(c[d>>2]|0)|0;i=b;return a|0}function lJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;Sz(b);if((e|0)==0){e=a;while(1){a=GB(e)|0;f=c[e+8>>2]|0;if(a){g=f;break}else{e=f}}i=b;return g|0}else{g=mJ(c[d>>2]|0)|0;i=b;return g|0}return 0}function mJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a;f=c[e>>2]|0;Sz(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e;f=c[a>>2]|0;Sz(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function nJ(a){a=a|0;var b=0,d=0;b=i;d=oJ((c[a>>2]|0)+16|0)|0;i=b;return d|0}function oJ(a){a=a|0;var b=0,c=0;b=i;c=pJ(a)|0;i=b;return c|0}function pJ(a){a=a|0;i=i;return a|0}function qJ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+56|0;o=f+64|0;c[k>>2]=c[d>>2];d=h;p=k;c[d+0>>2]=c[p+0>>2];p=vJ(b,h,j,e)|0;h=c[p>>2]|0;Sz(l);if((h|0)!=0){q=h;JF(a,q);i=f;return}xJ(o,b,e);yJ(n,o);e=g;h=n;c[e+0>>2]=c[h+0>>2];wJ(m,g);zJ(o);o=c[j>>2]|0;uH(b,o,p,AJ(m)|0);p=BJ(m)|0;zJ(m);q=p;JF(a,q);i=f;return}function rJ(a,b){a=a|0;b=b|0;var c=0;c=i;sJ(a,b);i=c;return}function sJ(a,b){a=a|0;b=b|0;var c=0;c=i;tJ(a,b);i=c;return}function tJ(a,b){a=a|0;b=b|0;var c=0;c=i;uJ(a,b);i=c;return}function uJ(a,b){a=a|0;b=b|0;var c=0;c=i;kO(a,b);kO(a+12|0,b+12|0);i=c;return}function vJ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+120|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=f+64|0;q=f+72|0;r=f+80|0;s=f+88|0;t=f+96|0;u=f+104|0;v=f+112|0;IF(m,a);w=k;x=m;c[w+0>>2]=c[x+0>>2];dK(l,k);do{if(!(cK(b,l)|0)){k=TF(a)|0;x=fK(b)|0;if(eK(k,e,x)|0){break}w=eK(k,x,e)|0;x=c[b>>2]|0;if(!w){c[d>>2]=x;y=d;i=f;return y|0}c[s>>2]=x;w=h;m=s;c[w+0>>2]=c[m+0>>2];jK(r,h,1,0);IF(u,a);m=g;w=u;c[m+0>>2]=c[w+0>>2];dK(t,g);do{if(!(cK(r,t)|0)){if(eK(k,e,fK(r)|0)|0){break}y=iK(a,d,e)|0;i=f;return y|0}}while(0);k=x+4|0;w=c[k>>2]|0;Sz(v);if((w|0)==0){c[d>>2]=x;y=k;i=f;return y|0}else{k=c[r>>2]|0;c[d>>2]=k;y=k;i=f;return y|0}}}while(0);r=c[b>>2]|0;b=n;c[b>>2]=r;gK(p,a);v=j;t=p;c[v+0>>2]=c[t+0>>2];dK(o,j);do{if(!(cK(n,o)|0)){j=TF(a)|0;if(eK(j,fK(hK(n)|0)|0,e)|0){break}y=iK(a,d,e)|0;i=f;return y|0}}while(0);e=r;a=c[e>>2]|0;Sz(q);if((a|0)==0){c[d>>2]=r;y=e;i=f;return y|0}else{e=c[b>>2]|0;c[d>>2]=e;y=e+4|0;i=f;return y|0}return 0}



function mq(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;a=0;while(1){e=c[(c[d+16>>2]|0)+8>>2]|0;if(!(a>>>0<(c[d+8>>2]|0)>>>0)){break}Vd[e&511](c[(c[d>>2]|0)+(a<<2)>>2]|0);a=a+1|0}Vd[e&511](c[d>>2]|0);i=b;return}function nq(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+96|0;j=b;b=d;d=e;e=f;f=g;g=0;k=1;l=1;do{if((a[e]|0)==0){if((c[b>>2]|0)==0){break}m=28;n=m;i=h;return n|0}}while(0);do{if((c[b>>2]|0)!=0){if((a[c[b>>2]|0]|0)!=120){break}if((a[(c[b>>2]|0)+1|0]|0)!=109){break}if((a[(c[b>>2]|0)+2|0]|0)!=108){break}do{if((a[(c[b>>2]|0)+3|0]|0)==110){if((a[(c[b>>2]|0)+4|0]|0)!=115){break}if((a[(c[b>>2]|0)+5|0]|0)!=0){break}m=39;n=m;i=h;return n|0}}while(0);if((a[(c[b>>2]|0)+3|0]|0)!=0){break}g=1}}while(0);o=0;while(1){p=(k&255|0)!=0;if((a[e+o|0]|0)==0){break}do{if(p){if((o|0)<=36){if((a[e+o|0]|0)==(a[55264+o|0]|0)){break}}k=0}}while(0);do{if(!(g<<24>>24!=0)){if((l&255|0)==0){break}if((o|0)<=29){if((a[e+o|0]|0)==(a[55304+o|0]|0)){break}}l=0}}while(0);o=o+1|0}if(p){q=(o|0)==36}else{q=0}k=q&1;if((l&255|0)!=0){r=(o|0)==29}else{r=0}l=r&1;if((g&255|0)!=(k&255|0)){m=(g&255|0)!=0?38:40;n=m;i=h;return n|0}if(l<<24>>24!=0){m=40;n=m;i=h;return n|0}if((a[j+472|0]|0)!=0){o=o+1|0}l=j;do{if((c[j+376>>2]|0)!=0){s=c[l+376>>2]|0;do{if((o|0)>(c[s+24>>2]|0)){g=le[c[j+16>>2]&63](c[s+16>>2]|0,o+24|0)|0;if((g|0)!=0){c[s+16>>2]=g;c[s+24>>2]=o+24;break}m=1;n=m;i=h;return n|0}}while(0);c[j+376>>2]=c[s+4>>2]}else{s=Yd[c[l+12>>2]&127](28)|0;if((s|0)==0){m=1;n=m;i=h;return n|0}c[s+16>>2]=Yd[c[j+12>>2]&127](o+24|0)|0;if((c[s+16>>2]|0)!=0){c[s+24>>2]=o+24;break}Vd[c[j+20>>2]&511](s);m=1;n=m;i=h;return n|0}}while(0);c[s+20>>2]=o;dZ(c[s+16>>2]|0,e|0,o|0)|0;if((a[j+472|0]|0)!=0){a[(c[s+16>>2]|0)+(o-1)|0]=a[j+472|0]|0}c[s>>2]=b;c[s+12>>2]=d;c[s+8>>2]=c[b+4>>2];do{if((a[e]|0)==0){if((b|0)!=((c[j+356>>2]|0)+152|0)){t=52;break}c[b+4>>2]=0}else{t=52}}while(0);if((t|0)==52){c[b+4>>2]=s}c[s+4>>2]=c[f>>2];c[f>>2]=s;do{if((d|0)!=0){if((c[j+100>>2]|0)==0){break}re[c[j+100>>2]&15](c[j+4>>2]|0,c[b>>2]|0,(c[b+4>>2]|0)!=0?e:0)}}while(0);m=0;n=m;i=h;return n|0}function oq(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=b;if(($d[((a[e+236|0]&255|0)!=0?32:33)&63](e+148|0,e+144|0,c[e+232>>2]|0)|0)!=0){f=0;g=f;i=d;return g|0}else{f=Wq(e,c[e+232>>2]|0)|0;g=f;i=d;return g|0}return 0}function pq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+32|0;j=b;b=d;d=e;c[h>>2]=b;e=ue[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=qq(j,c[j+144>>2]|0,b,d,e,c[h>>2]|0,f,((a[j+484|0]|0)!=0^1)&1)|0;i=g;return k|0}function qq(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+368|0;n=m+48|0;o=b;b=e;e=f;f=g;g=h;c[n>>2]=j;j=k;k=l;l=c[o+356>>2]|0;h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}a:while(1){h=1;c[p>>2]=e;c[q>>2]=c[n>>2];b:do{if((g|0)<=0){if((k&255|0)!=0){if((g|0)!=0){r=7;break a}}switch(g|0){case 0:{r=9;break a;break};case-1:{r=10;break a;break};case-2:{r=11;break a;break};case-15:{g=0-g|0;break b;break};case-4:{r=13;break a;break};default:{g=0-g|0;c[n>>2]=f;break b}}}}while(0);s=me[c[o+256>>2]&63](o+256|0,g,e,c[n>>2]|0,b)|0;c:do{switch(s|0){case 1:{t=rq(o,0,e,c[n>>2]|0)|0;if((t|0)!=0){r=25;break a}b=c[o+144>>2]|0;h=0;break};case 6:{a[o+489|0]=0;c[o+316>>2]=jq(o,l+132|0,55336,36)|0;if((c[o+316>>2]|0)==0){r=38;break a}a[l+129|0]=1;if((c[o+84>>2]|0)==0){r=45;break c}if((ue[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=41;break a}u=sq(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((u|0)==0){r=43;break a}tq(u);c[o+432>>2]=c[o+428>>2];c[o+328>>2]=u;h=0;r=47;break};case 4:{if((c[o+84>>2]|0)!=0){c[o+320>>2]=sq(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+320>>2]|0)==0){r=29;break a}c[o+432>>2]=c[o+428>>2];c[o+328>>2]=0;h=0}c[o+324>>2]=0;break};case 7:{if((c[o+84>>2]|0)==0){break c}Sd[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,1);c[o+320>>2]=0;Pp(o+416|0);h=0;break};case 57:{v=rq(o,1,e,c[n>>2]|0)|0;if((v|0)!=0){r=35;break a}b=c[o+144>>2]|0;h=0;break};case 22:{c[o+348>>2]=wq(o,b,e,c[n>>2]|0)|0;if((c[o+348>>2]|0)==0){r=92;break a}a[o+352|0]=0;c[o+332>>2]=0;a[o+353|0]=0;r=102;break};case 14:{r=45;break};case 8:{if((c[o+320>>2]|0)!=0){Sd[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,0);Pp(o+416|0);h=0}if((c[o+324>>2]|0)!=0){r=57}else{if((d[o+489|0]|0)!=0){r=57}}if((r|0)==57){r=0;u=a[l+129|0]|0;a[l+129|0]=1;do{if((c[o+492>>2]|0)!=0){if((c[o+112>>2]|0)==0){break}w=jq(o,l+132|0,55336,36)|0;if((w|0)==0){r=60;break a}if((a[o+489|0]|0)!=0){c[w+20>>2]=c[o+360>>2]}a[l+131|0]=0;if((me[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)==0){r=64;break a}if((a[l+131|0]|0)==0){if((c[o+324>>2]|0)!=0){break}a[l+129|0]=u;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((Yd[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=69;break a}}}while(0);a[o+489|0]=0}if((c[o+88>>2]|0)==0){break c}Vd[c[o+88>>2]&511](c[o+4>>2]|0);h=0;break};case 2:{r=75;break a;break};case 34:{c[o+344>>2]=vq(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)!=0){r=102}else{r=90;break a}break};case 23:{a[o+352|0]=1;c[o+332>>2]=55344;r=102;break};case 24:{a[o+353|0]=1;c[o+332>>2]=55352;r=102;break};case 25:{c[o+332>>2]=55360;r=102;break};case 26:{c[o+332>>2]=55368;r=102;break};case 27:{c[o+332>>2]=55376;r=102;break};case 28:{c[o+332>>2]=55384;r=102;break};case 29:{c[o+332>>2]=55400;r=102;break};case 30:{c[o+332>>2]=55408;r=102;break};case 5:{a[o+489|0]=0;a[l+129|0]=1;u=o;if((c[o+84>>2]|0)!=0){c[o+324>>2]=sq(u+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((c[o+324>>2]|0)==0){r=156;break a}c[o+432>>2]=c[o+428>>2];h=0}else{c[u+324>>2]=55336}do{if((a[l+130|0]|0)==0){if((c[o+492>>2]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((Yd[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=163;break a}}}while(0);if((c[o+316>>2]|0)!=0){r=168;break c}c[o+316>>2]=jq(o,l+132|0,55336,36)|0;if((c[o+316>>2]|0)==0){r=166;break a}c[(c[o+316>>2]|0)+24>>2]=0;r=168;break};case 32:case 31:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)!=0){x=55440}else{x=(s|0)==32?55424:55448}if((xq(o+416|0,x)|0)==0){r=111;break a}if((yq(o+416|0,b,e,c[n>>2]|0)|0)==0){r=113;break a}c[o+332>>2]=c[o+432>>2];h=0;break};case 36:case 35:{if((a[l+128|0]|0)==0){break c}if((zq(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,a[o+353|0]|0,0,o)|0)==0){r=117;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=123}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=123}}}while(0);if((r|0)==123){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((gq(o+416|0)|0)<<24>>24!=0)){r=128;break a}}u=o+428|0;w=c[u>>2]|0;c[u>>2]=w+1;a[w]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((gq(o+416|0)|0)<<24>>24!=0)){r=128;break a}}w=o+428|0;u=c[w>>2]|0;c[w>>2]=u+1;a[u]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;fe[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,0,(s|0)==36|0);Pp(o+416|0);h=0;break};case 38:case 37:{if((a[l+128|0]|0)==0){break c}y=Aq(o,b,a[o+352|0]|0,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0,l+80|0)|0;if((y|0)!=0){r=132;break a}u=c[l+96>>2]|0;c[l+96>>2]=c[l+92>>2];if((zq(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,0,u,o)|0)==0){r=134;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=140}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=140}}}while(0);if((r|0)==140){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((gq(o+416|0)|0)<<24>>24!=0)){r=145;break a}}w=o+428|0;z=c[w>>2]|0;c[w>>2]=z+1;a[z]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((gq(o+416|0)|0)<<24>>24!=0)){r=145;break a}}z=o+428|0;w=c[z>>2]|0;c[z>>2]=w+1;a[w]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;fe[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,u,(s|0)==38|0);Pp(o+416|0);h=0;break};case 12:{if((a[l+128|0]|0)==0){break c}A=Bq(o,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;w=c[l+120>>2]|0;do{if((c[o+316>>2]|0)!=0){c[(c[o+316>>2]|0)+4>>2]=w;c[(c[o+316>>2]|0)+8>>2]=(c[l+116>>2]|0)-(c[l+120>>2]|0);c[l+120>>2]=c[l+116>>2];if((c[o+136>>2]|0)==0){break}c[q>>2]=e;ke[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,c[(c[o+316>>2]|0)+4>>2]|0,c[(c[o+316>>2]|0)+8>>2]|0,c[o+360>>2]|0,0,0,0);h=0}else{c[l+116>>2]=w}}while(0);if((A|0)!=0){r=153;break a}break};case 13:{r=168;break};case 15:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;ke[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,0);h=0;break};case 16:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}w=sq(l+80|0,b,e,c[n>>2]|0)|0;c[(c[o+316>>2]|0)+28>>2]=w;if((c[(c[o+316>>2]|0)+28>>2]|0)==0){r=181;break a}c[l+96>>2]=c[l+92>>2];if((c[o+92>>2]|0)!=0){c[q>>2]=e;fe[c[o+92>>2]&31](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;ke[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break};case 9:{if(($d[c[b+48>>2]&63](b,e,c[n>>2]|0)|0)!=0){c[o+316>>2]=0;break c}w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=sq(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=190;break a}c[o+316>>2]=jq(o,l,u,36)|0;if((c[o+316>>2]|0)==0){r=192;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=0;if((c[o+476>>2]|0)!=0){B=1}else{B=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(B^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 10:{w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=sq(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=202;break a}c[o+316>>2]=jq(o,l+132|0,u,36)|0;if((c[o+316>>2]|0)==0){r=204;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=1;if((c[o+476>>2]|0)!=0){C=1}else{C=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(C^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 58:{if((c[o+80>>2]|0)!=0){eq(o,b,e,c[n>>2]|0)}h=0;D=Cq(o,b,n,f,j,k)|0;if((D|0)!=0){r=239;break a}if((c[n>>2]|0)==0){r=241;break a}break};case 18:{c[o+340>>2]=0;c[o+336>>2]=0;if((c[o+96>>2]|0)==0){break c}c[o+336>>2]=sq(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+336>>2]|0)==0){r=214;break a}c[o+432>>2]=c[o+428>>2];h=0;break};case 21:{if((ue[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=217;break a}if((c[o+336>>2]|0)==0){break c}w=sq(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=220;break a}tq(w);c[o+340>>2]=w;c[o+432>>2]=c[o+428>>2];h=0;break};case 19:{do{if((c[o+336>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}w=sq(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=225;break a}c[q>>2]=e;Sd[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,w,c[o+340>>2]|0);h=0}}while(0);Pp(o+416|0);break};case 20:{do{if((c[o+340>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}c[q>>2]=e;Sd[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,0,c[o+340>>2]|0);h=0}}while(0);Pp(o+416|0);break};case-1:{r=232;break a;break};case 44:{do{if((c[o+260>>2]|0)>>>0>=(c[o+468>>2]|0)>>>0){w=o+12|0;if((c[o+468>>2]|0)==0){u=c[w>>2]|0;c[o+468>>2]=32;c[o+464>>2]=Yd[u&127](32)|0;if((c[o+464>>2]|0)!=0){break}else{r=251;break a}}u=c[w+4>>2]|0;w=c[o+464>>2]|0;z=o+468|0;E=c[z>>2]<<1;c[z>>2]=E;z=le[u&63](w,E)|0;if((z|0)==0){r=245;break a}c[o+464>>2]=z;if((c[l+184>>2]|0)==0){break}z=le[c[o+16>>2]&63](c[l+184>>2]|0,c[o+468>>2]<<2)|0;if((z|0)==0){r=248;break a}c[l+184>>2]=z}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=0;if((a[l+160|0]|0)==0){break c}z=Eq(o)|0;if((z|0)<0){r=254;break a}c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]=z;E=l+180|0;c[E>>2]=(c[E>>2]|0)+1;c[(c[l+164>>2]|0)+(z*28|0)>>2]=6;if((c[o+128>>2]|0)==0){break c}h=0;break};case 50:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==124){r=258;break a}a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=44;if((d[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)==0){break c}h=0;break};case 49:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==44){r=263;break a}do{if((d[l+160|0]|0)!=0){if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)!=0){break}if((c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]|0)==3){break}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=5;if((c[o+128>>2]|0)==0){break}h=0}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=124;break};case 59:case 60:{a[l+129|0]=1;z=l;do{if((c[o+492>>2]|0)!=0){E=sq(z+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=273;break a}w=jq(o,l+132|0,E,0)|0;c[l+92>>2]=c[l+96>>2];do{if((c[o+272>>2]|0)!=0){if((d[l+130|0]|0)!=0){if((c[o+300>>2]|0)!=0){r=282;break}}else{if((a[l+129|0]|0)!=0){r=282;break}}if((w|0)==0){r=279;break a}if((a[w+34|0]|0)==0){r=281;break a}}else{r=282}}while(0);do{if((r|0)==282){r=0;if((w|0)!=0){break}a[l+128|0]=a[l+130|0]|0;if((s|0)!=60){break c}if((c[o+120>>2]|0)==0){break c}re[c[o+120>>2]&15](c[o+4>>2]|0,E,1);h=0;break c}}while(0);if((a[w+32|0]|0)!=0){r=287;break a}if((c[w+4>>2]|0)!=0){F=Fq(o,w,((s|0)==60?1:0)&255)|0;if((F|0)!=0){r=290;break a}h=0;break c}E=l;if((c[o+112>>2]|0)==0){a[l+128|0]=a[E+130|0]|0;break c}a[E+131|0]=0;a[w+32|0]=1;E=(me[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)!=0;a[w+32|0]=0;if(!E){r=294;break a}h=0;if((a[l+131|0]|0)!=0){break}a[l+128|0]=a[l+130|0]|0;break c}else{a[l+128|0]=a[z+130|0]|0}}while(0);if((a[l+130|0]|0)!=0){break c}if((c[o+108>>2]|0)==0){break c}if((Yd[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=301;break a}break};case 53:{G=1;r=319;break};case 52:{G=2;r=319;break};case 54:{G=3;r=319;break};case 40:{if((c[o+128>>2]|0)==0){break c}c[o+344>>2]=vq(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)==0){r=304;break a}c[l+180>>2]=0;c[l+176>>2]=0;a[l+160|0]=1;h=0;break};case 42:case 41:{if((a[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)!=0){z=Yd[c[o+12>>2]&127](20)|0;if((z|0)==0){r=309;break a}c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;c[z+16>>2]=0;c[z>>2]=(s|0)==41?2:1;c[q>>2]=e;re[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,z);h=0}a[l+160|0]=0;break};case 43:{if((a[l+160|0]|0)==0){break c}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=3;if((c[o+128>>2]|0)==0){break c}h=0;break};case 51:{G=0;r=319;break};case 47:{G=1;r=334;break};case 46:{G=2;r=334;break};case 48:{G=3;r=334;break};case 45:{G=0;r=334;break};case 56:{if((Iq(o,b,e,c[n>>2]|0)|0)==0){r=347;break a}h=0;break};case 0:{if((g|0)!=14){break c}h=0;break};case 3:{if((c[o+84>>2]|0)==0){break c}h=0;break};case 11:{if((d[l+128|0]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}h=0;break};case 55:{if((Hq(o,b,e,c[n>>2]|0)|0)==0){r=344;break a}h=0;break};case 33:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}h=0;break};case 39:{if((c[o+128>>2]|0)==0){break c}h=0;break};case 17:{if((c[o+96>>2]|0)==0){break c}h=0;break};default:{}}}while(0);do{if((r|0)==45){r=0;if((ue[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)!=0){r=47}else{r=46;break a}}else if((r|0)==102){r=0;if((d[l+128|0]|0)==0){break}if((c[o+132>>2]|0)==0){break}h=0}else if((r|0)==168){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}s=sq(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;c[(c[o+316>>2]|0)+16>>2]=s;if((c[(c[o+316>>2]|0)+16>>2]|0)==0){r=171;break a}c[(c[o+316>>2]|0)+20>>2]=c[o+360>>2];c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}else if((r|0)==319){r=0;if((a[l+160|0]|0)==0){break}s=c[n>>2]|0;if((G|0)==0){H=s}else{H=s+(0-(c[b+68>>2]|0))|0}s=Eq(o)|0;if((s|0)<0){r=323;break a}c[(c[l+164>>2]|0)+(s*28|0)>>2]=4;c[(c[l+164>>2]|0)+(s*28|0)+4>>2]=G;z=vq(o,b,e,H)|0;if((z|0)==0){r=325;break a}E=c[z>>2]|0;c[(c[l+164>>2]|0)+(s*28|0)+8>>2]=E;s=0;do{z=s;s=z+1|0;}while((a[E+z|0]|0)!=0);E=l+168|0;c[E>>2]=(c[E>>2]|0)+s;if((c[o+128>>2]|0)==0){break}h=0}else if((r|0)==334){r=0;if((a[l+160|0]|0)==0){break}if((c[o+128>>2]|0)!=0){h=0}E=l+180|0;c[E>>2]=(c[E>>2]|0)+ -1;c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]|0)*28|0)+4>>2]=G;if((c[l+180>>2]|0)!=0){break}if(!(h<<24>>24!=0)){E=Gq(o)|0;if((E|0)==0){r=340;break a}c[q>>2]=e;re[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,E)}a[l+160|0]=0;c[l+168>>2]=0}}while(0);do{if((r|0)==47){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}E=sq(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=50;break a}tq(E);c[(c[o+316>>2]|0)+24>>2]=E;c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}}while(0);do{if((h&255|0)!=0){if((c[o+80>>2]|0)==0){break}eq(o,b,e,c[n>>2]|0)}}while(0);h=c[o+480>>2]|0;if((h|0)==3){r=367;break}else if((h|0)==2){r=368;break}e=c[n>>2]|0;g=ue[c[b>>2]&63](b,e,f,n)|0}if((r|0)==7){c[j>>2]=e;I=0;J=I;i=m;return J|0}else if((r|0)==9){c[p>>2]=c[n>>2];I=4;J=I;i=m;return J|0}else if((r|0)==10){I=5;J=I;i=m;return J|0}else if((r|0)==11){I=6;J=I;i=m;return J|0}else if((r|0)==13){do{if((b|0)!=(c[o+144>>2]|0)){if((a[(c[o+300>>2]|0)+20|0]|0)!=0){break}c[j>>2]=e;I=0;J=I;i=m;return J|0}}while(0);do{if((d[o+488|0]|0)==0){if((b|0)!=(c[o+144>>2]|0)){break}I=3;J=I;i=m;return J|0}}while(0);if((me[c[o+256>>2]&63](o+256|0,-4,f,f,b)|0)==-1){I=29;J=I;i=m;return J|0}else{c[j>>2]=e;I=0;J=I;i=m;return J|0}}else if((r|0)==25){I=t;J=I;i=m;return J|0}else if((r|0)==29){I=1;J=I;i=m;return J|0}else if((r|0)==35){I=v;J=I;i=m;return J|0}else if((r|0)==38){I=1;J=I;i=m;return J|0}else if((r|0)==41){I=32;J=I;i=m;return J|0}else if((r|0)==43){I=1;J=I;i=m;return J|0}else if((r|0)==46){I=32;J=I;i=m;return J|0}else if((r|0)==50){I=1;J=I;i=m;return J|0}else if((r|0)==60){I=1;J=I;i=m;return J|0}else if((r|0)==64){I=21;J=I;i=m;return J|0}else if((r|0)==69){I=22;J=I;i=m;return J|0}else if((r|0)==75){do{if((a[o+489|0]|0)!=0){v=a[l+129|0]|0;a[l+129|0]=1;if((c[o+492>>2]|0)==0){break}if((c[o+112>>2]|0)==0){break}t=jq(o,l+132|0,55336,36)|0;if((t|0)==0){I=1;J=I;i=m;return J|0}c[t+20>>2]=c[o+360>>2];a[l+131|0]=0;if((me[c[o+112>>2]&63](c[o+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)==0){I=21;J=I;i=m;return J|0}if((a[l+131|0]|0)==0){a[l+129|0]=v;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((Yd[c[o+108>>2]&127](c[o+4>>2]|0)|0)!=0){break}I=22;J=I;i=m;return J|0}}while(0);c[o+280>>2]=37;I=uq(o,e,f,j)|0;J=I;i=m;return J|0}else if((r|0)==90){I=1;J=I;i=m;return J|0}else if((r|0)==92){I=1;J=I;i=m;return J|0}else if((r|0)==111){I=1;J=I;i=m;return J|0}else if((r|0)==113){I=1;J=I;i=m;return J|0}else if((r|0)==117){I=1;J=I;i=m;return J|0}else if((r|0)==128){I=1;J=I;i=m;return J|0}else if((r|0)==132){I=y;J=I;i=m;return J|0}else if((r|0)==134){I=1;J=I;i=m;return J|0}else if((r|0)==145){I=1;J=I;i=m;return J|0}else if((r|0)==153){I=A;J=I;i=m;return J|0}else if((r|0)==156){I=1;J=I;i=m;return J|0}else if((r|0)==163){I=22;J=I;i=m;return J|0}else if((r|0)==166){I=1;J=I;i=m;return J|0}else if((r|0)==171){I=1;J=I;i=m;return J|0}else if((r|0)==181){I=1;J=I;i=m;return J|0}else if((r|0)==190){I=1;J=I;i=m;return J|0}else if((r|0)==192){I=1;J=I;i=m;return J|0}else if((r|0)==202){I=1;J=I;i=m;return J|0}else if((r|0)==204){I=1;J=I;i=m;return J|0}else if((r|0)==214){I=1;J=I;i=m;return J|0}else if((r|0)==217){I=32;J=I;i=m;return J|0}else if((r|0)==220){I=1;J=I;i=m;return J|0}else if((r|0)==225){I=1;J=I;i=m;return J|0}else if((r|0)==232){A=g;if((A|0)==28){I=10;J=I;i=m;return J|0}else if((A|0)==12){I=17;J=I;i=m;return J|0}else{I=2;J=I;i=m;return J|0}}else if((r|0)==239){I=D;J=I;i=m;return J|0}else if((r|0)==241){c[o+280>>2]=38;I=D;J=I;i=m;return J|0}else if((r|0)==245){I=1;J=I;i=m;return J|0}else if((r|0)==248){I=1;J=I;i=m;return J|0}else if((r|0)==251){I=1;J=I;i=m;return J|0}else if((r|0)==254){I=1;J=I;i=m;return J|0}else if((r|0)==258){I=2;J=I;i=m;return J|0}else if((r|0)==263){I=2;J=I;i=m;return J|0}else if((r|0)==273){I=1;J=I;i=m;return J|0}else if((r|0)==279){I=11;J=I;i=m;return J|0}else if((r|0)==281){I=24;J=I;i=m;return J|0}else if((r|0)==287){I=12;J=I;i=m;return J|0}else if((r|0)==290){I=F;J=I;i=m;return J|0}else if((r|0)==294){I=21;J=I;i=m;return J|0}else if((r|0)==301){I=22;J=I;i=m;return J|0}else if((r|0)==304){I=1;J=I;i=m;return J|0}else if((r|0)==309){I=1;J=I;i=m;return J|0}else if((r|0)==323){I=1;J=I;i=m;return J|0}else if((r|0)==325){I=1;J=I;i=m;return J|0}else if((r|0)==340){I=1;J=I;i=m;return J|0}else if((r|0)==344){I=1;J=I;i=m;return J|0}else if((r|0)==347){I=1;J=I;i=m;return J|0}else if((r|0)==367){c[j>>2]=c[n>>2];I=0;J=I;i=m;return J|0}else if((r|0)==368){I=35;J=I;i=m;return J|0}return 0}function rq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+104|0;h=g+40|0;j=g+56|0;k=g+64|0;l=g+72|0;m=g+88|0;n=b;b=d;d=e;e=f;c[h>>2]=0;f=0;c[j>>2]=0;c[k>>2]=0;o=0;c[m>>2]=-1;p=(b|0)!=0;if((Xd[((a[n+236|0]&255|0)!=0?1:2)&7](b,c[n+144>>2]|0,d,e,n+288|0,k,l,h,j,m)|0)==0){if(p){q=31;r=q;i=g;return r|0}else{q=30;r=q;i=g;return r|0}}do{if(!p){if((c[m>>2]|0)!=1){break}a[(c[n+356>>2]|0)+130|0]=1;if((c[n+492>>2]|0)!=1){break}c[n+492>>2]=0}}while(0);do{if((c[n+140>>2]|0)!=0){do{if((c[h>>2]|0)!=0){p=c[n+144>>2]|0;b=c[h>>2]|0;s=c[h>>2]|0;f=sq(n+440|0,p,b,s+(le[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){c[n+456>>2]=c[n+452>>2];break}q=1;r=q;i=g;return r|0}}while(0);do{if((c[k>>2]|0)!=0){o=sq(n+440|0,c[n+144>>2]|0,c[k>>2]|0,(c[l>>2]|0)+(0-(c[(c[n+144>>2]|0)+68>>2]|0))|0)|0;if((o|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);ve[c[n+140>>2]&31](c[n+4>>2]|0,o,f,c[m>>2]|0)}else{if((c[n+80>>2]|0)==0){break}eq(n,c[n+144>>2]|0,d,e)}}while(0);do{if((c[n+232>>2]|0)==0){if((c[j>>2]|0)!=0){if((c[(c[j>>2]|0)+68>>2]|0)==(c[(c[n+144>>2]|0)+68>>2]|0)){c[n+144>>2]=c[j>>2];break}c[n+288>>2]=c[h>>2];q=19;r=q;i=g;return r|0}if((c[h>>2]|0)==0){break}do{if((f|0)==0){e=c[n+144>>2]|0;d=c[h>>2]|0;m=c[h>>2]|0;f=sq(n+440|0,e,d,m+(le[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);m=Wq(n,f)|0;Pp(n+440|0);if((m|0)==18){c[n+288>>2]=c[h>>2]}q=m;r=q;i=g;return r|0}}while(0);if((f|0)!=0){t=34}else{if((o|0)!=0){t=34}}if((t|0)==34){Pp(n+440|0)}q=0;r=q;i=g;return r|0}function sq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+40|0;h=b;if((yq(h,d,e,f)|0)==0){j=0;k=j;i=g;return k|0}do{if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if((gq(h)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);f=h+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e]=0;j=c[h+16>>2]|0;k=j;i=g;return k|0}function tq(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;i=i+24|0;d=b;b=d;e=d;while(1){if((a[e]|0)==0){break}f=a[e]|0;do{if((f|0)==10|(f|0)==13|(f|0)==32){if((b|0)==(d|0)){break}if((a[b+ -1|0]|0)==32){break}g=b;b=g+1|0;a[g]=32}else{g=b;b=g+1|0;a[g]=a[e]|0}}while(0);e=e+1|0}if((b|0)==(d|0)){h=b;a[h]=0;i=c;return}if((a[b+ -1|0]|0)!=32){h=b;a[h]=0;i=c;return}b=b+ -1|0;h=b;a[h]=0;i=c;return}function uq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=Lq(h,0,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((Tq(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function vq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=c[g+356>>2]|0;h=sq(a+80|0,b,d,e)|0;if((h|0)==0){j=0;k=j;i=f;return k|0}e=jq(g,a+20|0,h,24)|0;if((e|0)==0){j=0;k=j;i=f;return k|0}d=a+80|0;do{if((c[e>>2]|0)!=(h|0)){c[a+92>>2]=c[d+16>>2]}else{c[a+96>>2]=c[d+12>>2];if((Uq(g,e)|0)!=0){break}j=0;k=j;i=f;return k|0}}while(0);j=e;k=j;i=f;return k|0}function wq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=b;b=d;d=e;e=f;f=c[h+356>>2]|0;do{if((c[f+92>>2]|0)==(c[f+88>>2]|0)){if((gq(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m]=0;m=sq(f+80|0,b,d,e)|0;if((m|0)==0){j=0;k=j;i=g;return k|0}m=m+1|0;e=jq(h,f+40|0,m,12)|0;if((e|0)==0){j=0;k=j;i=g;return k|0}d=f+80|0;a:do{if((c[e>>2]|0)!=(m|0)){c[f+92>>2]=c[d+16>>2]}else{c[f+96>>2]=c[d+12>>2];if((a[h+236|0]|0)==0){break}do{if((a[m]|0)==120){if((a[m+1|0]|0)!=109){break}if((a[m+2|0]|0)!=108){break}if((a[m+3|0]|0)!=110){break}if((a[m+4|0]|0)!=115){break}if((a[m+5|0]|0)!=0){if((a[m+5|0]|0)!=58){break}}if((a[m+5|0]|0)==0){c[e+4>>2]=f+152}else{c[e+4>>2]=jq(h,f+60|0,m+6|0,8)|0}a[e+9|0]=1;break a}}while(0);b=0;while(1){if((a[m+b|0]|0)==0){break a}if((a[m+b|0]|0)==58){break}b=b+1|0}l=0;while(1){n=(c[f+92>>2]|0)==(c[f+88>>2]|0);if((l|0)>=(b|0)){break}if(n){if(!((gq(f+80|0)|0)<<24>>24!=0)){o=30;break}}p=a[m+l|0]|0;q=f+92|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;l=l+1|0}if((o|0)==30){j=0;k=j;i=g;return k|0}do{if(n){if((gq(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;b=c[l>>2]|0;c[l>>2]=b+1;a[b]=0;c[e+4>>2]=jq(h,f+60|0,c[f+96>>2]|0,8)|0;b=f+80|0;if((c[c[e+4>>2]>>2]|0)==(c[f+96>>2]|0)){c[f+96>>2]=c[b+12>>2];break}else{c[f+92>>2]=c[b+16>>2];break}}}while(0);j=e;k=j;i=g;return k|0}function xq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=b;b=d;while(1){g=f;if((a[b]|0)==0){h=7;break}if((c[g+12>>2]|0)==(c[f+8>>2]|0)){if(!((gq(f)|0)<<24>>24!=0)){h=6;break}}d=a[b]|0;j=f+12|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k]=d;b=b+1|0}if((h|0)==6){l=0;m=l;i=e;return m|0}else if((h|0)==7){l=c[g+16>>2]|0;m=l;i=e;return m|0}return 0}function yq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=f+24|0;h=a;a=b;c[g>>2]=d;d=e;do{if((c[h+12>>2]|0)==0){if((gq(h)|0)<<24>>24!=0){break}j=0;k=j;i=f;return k|0}}while(0);while(1){Sd[c[a+60>>2]&31](a,g,d,h+12|0,c[h+8>>2]|0);l=h;if((c[g>>2]|0)==(d|0)){m=7;break}if(!((gq(l)|0)<<24>>24!=0)){m=6;break}}if((m|0)==6){j=0;k=j;i=f;return k|0}else if((m|0)==7){j=c[l+16>>2]|0;k=j;i=f;return k|0}return 0}function zq(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+88|0;k=b;b=d;d=e;e=f;f=g;g=h;if((f|0)!=0){l=3}else{if((e&255|0)!=0){l=3}}do{if((l|0)==3){h=0;while(1){if((h|0)>=(c[k+12>>2]|0)){break}if((b|0)==(c[(c[k+20>>2]|0)+(h*12|0)>>2]|0)){l=6;break}h=h+1|0}if((l|0)==6){m=1;n=m;i=j;return n|0}if((e&255|0)==0){break}if((c[k+8>>2]|0)!=0){break}if((a[b+9|0]|0)!=0){break}c[k+8>>2]=b}}while(0);do{if((c[k+12>>2]|0)==(c[k+16>>2]|0)){e=k+16|0;if((c[k+16>>2]|0)==0){c[e>>2]=8;c[k+20>>2]=Yd[c[g+12>>2]&127]((c[k+16>>2]|0)*12|0)|0;if((c[k+20>>2]|0)!=0){break}m=0;n=m;i=j;return n|0}l=c[e>>2]<<1;e=le[c[g+16>>2]&63](c[k+20>>2]|0,l*12|0)|0;if((e|0)!=0){c[k+16>>2]=l;c[k+20>>2]=e;break}m=0;n=m;i=j;return n|0}}while(0);g=(c[k+20>>2]|0)+((c[k+12>>2]|0)*12|0)|0;c[g>>2]=b;c[g+8>>2]=f;a[g+4|0]=d;if(!(d<<24>>24!=0)){a[b+8|0]=1}b=k+12|0;c[b>>2]=(c[b>>2]|0)+1;m=1;n=m;i=j;return n|0}function Aq(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+64|0;k=e;e=h;h=Vq(b,d,k,f,g,e)|0;if((h|0)!=0){l=h;m=l;i=j;return m|0}do{if(!(k<<24>>24!=0)){if(((c[e+12>>2]|0)-(c[e+16>>2]|0)|0)==0){break}if((a[(c[e+12>>2]|0)+ -1|0]|0)!=32){break}h=e+12|0;c[h>>2]=(c[h>>2]|0)+ -1}}while(0);do{if((c[e+12>>2]|0)==(c[e+8>>2]|0)){if((gq(e)|0)<<24>>24!=0){break}l=1;m=l;i=j;return m|0}}while(0);k=e+12|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e]=0;l=0;m=l;i=j;return m|0}function Bq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+128|0;j=h+72|0;k=h+104|0;l=b;b=e;e=f;f=g;g=c[l+356>>2]|0;m=g+104|0;n=0;o=c[l+276>>2]|0;c[l+276>>2]=1;do{if((c[m>>2]|0)==0){if((gq(m)|0)<<24>>24!=0){break}p=1;q=p;i=h;return q|0}}while(0);a:while(1){b:do{switch(ue[c[b+20>>2]&63](b,e,f,j)|0){case 0:{r=49;break a;break};case-4:{r=24;break a;break};case-1:{r=46;break a;break};case 7:{r=28;break};case 10:{s=le[c[b+44>>2]&63](b,e)|0;if((s|0)<0){r=33;break a}s=ar(s,k)|0;if((s|0)==0){r=37;break a}t=0;while(1){if((t|0)>=(s|0)){break b}if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((gq(m)|0)<<24>>24!=0)){r=44;break a}}u=a[k+t|0]|0;v=m+12|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=u;t=t+1|0}break};case 28:{if((d[l+488|0]|0)==0){if((b|0)==(c[l+144>>2]|0)){r=23;break a}}t=sq(l+416|0,b,e+(c[b+68>>2]|0)|0,(c[j>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((t|0)==0){r=8;break a}s=jq(l,g+132|0,t,0)|0;c[l+428>>2]=c[l+432>>2];if((s|0)==0){r=10;break a}if((a[s+32|0]|0)!=0){r=12;break a}if((c[s+16>>2]|0)==0){a[s+32|0]=1;n=Bq(l,c[l+228>>2]|0,c[s+4>>2]|0,(c[s+4>>2]|0)+(c[s+8>>2]|0)|0)|0;a[s+32|0]=0;if((n|0)!=0){break a}else{break b}}t=g;if((c[l+112>>2]|0)==0){a[g+128|0]=a[t+130|0]|0;break b}a[t+131|0]=0;a[s+32|0]=1;t=(me[c[l+112>>2]&63](c[l+116>>2]|0,0,c[s+20>>2]|0,c[s+16>>2]|0,c[s+24>>2]|0)|0)!=0;a[s+32|0]=0;if(!t){r=18;break a}if((a[g+131|0]|0)!=0){break b}a[g+128|0]=a[g+130|0]|0;break};case-3:{c[j>>2]=e+(c[b+68>>2]|0);r=28;break};case 6:case 9:{if((yq(m,b,e,c[j>>2]|0)|0)==0){r=26;break a}break};default:{r=52;break a}}}while(0);if((r|0)==28){r=0;if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((gq(m)|0)<<24>>24!=0)){r=30;break}}t=m+12|0;s=c[t>>2]|0;c[t>>2]=s+1;a[s]=10}e=c[j>>2]|0}if((r|0)==8){n=1}else if((r|0)==10){a[g+128|0]=a[g+130|0]|0}else if((r|0)==12){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=12}else if((r|0)==18){n=21}else if((r|0)==23){c[l+288>>2]=e;n=10}else if((r|0)==24){n=0}else if((r|0)==26){n=1}else if((r|0)==30){n=1}else if((r|0)==33){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==37){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==44){n=1}else if((r|0)==46){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=4}else if((r|0)==49){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=c[j>>2]}n=4}else if((r|0)==52){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=23}c[l+276>>2]=o;p=n;q=p;i=h;return q|0}function Cq(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+96|0;j=h+56|0;k=a;a=b;b=d;d=f;f=g;g=c[b>>2]|0;l=k;if((a|0)==(c[k+144>>2]|0)){m=l+288|0;c[m>>2]=g;n=k+292|0}else{m=c[l+300>>2]|0;n=(c[k+300>>2]|0)+4|0}c[m>>2]=g;c[b>>2]=0;l=ue[c[a+12>>2]&63](a,g,e,j)|0;c[n>>2]=c[j>>2];switch(l|0){case-2:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=6;p=o;i=h;return p|0}break};case 0:{c[m>>2]=c[j>>2];o=4;p=o;i=h;return p|0};case-4:case-1:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=2;p=o;i=h;return p|0}break};case 42:{if((c[k+80>>2]|0)!=0){eq(k,a,g,c[j>>2]|0)}c[b>>2]=c[j>>2];c[d>>2]=c[j>>2];if((c[k+480>>2]|0)==2){o=35;p=o;i=h;return p|0}else{o=0;p=o;i=h;return p|0}break};default:{c[m>>2]=c[j>>2];o=23;p=o;i=h;return p|0}}return 0}function Dq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=Cq(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)!=0){c[j+280>>2]=39;k=pq(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{k=f;l=k;i=g;return l|0}return 0}function Eq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;a=c[d+356>>2]|0;do{if((c[a+184>>2]|0)==0){c[a+184>>2]=Yd[c[d+12>>2]&127](c[d+468>>2]<<2)|0;if((c[a+184>>2]|0)!=0){c[c[a+184>>2]>>2]=0;break}e=-1;f=e;i=b;return f|0}}while(0);if((c[a+176>>2]|0)>>>0>=(c[a+172>>2]|0)>>>0){g=d+12|0;do{if((c[a+164>>2]|0)!=0){h=le[c[g+4>>2]&63](c[a+164>>2]|0,(c[a+172>>2]<<1)*28|0)|0;if((h|0)!=0){d=a+172|0;c[d>>2]=c[d>>2]<<1;break}e=-1;f=e;i=b;return f|0}else{h=Yd[c[g>>2]&127](896)|0;if((h|0)!=0){c[a+172>>2]=32;break}e=-1;f=e;i=b;return f|0}}while(0);c[a+164>>2]=h}h=a+176|0;g=c[h>>2]|0;c[h>>2]=g+1;h=g;g=(c[a+164>>2]|0)+(h*28|0)|0;if((c[a+180>>2]|0)!=0){d=(c[a+164>>2]|0)+((c[(c[a+184>>2]|0)+((c[a+180>>2]|0)-1<<2)>>2]|0)*28|0)|0;if((c[d+16>>2]|0)!=0){c[(c[a+164>>2]|0)+((c[d+16>>2]|0)*28|0)+24>>2]=h}if((c[d+20>>2]|0)==0){c[d+12>>2]=h}c[d+16>>2]=h;a=d+20|0;c[a>>2]=(c[a>>2]|0)+1}c[g+24>>2]=0;c[g+20>>2]=0;c[g+16>>2]=0;c[g+12>>2]=0;e=h;f=e;i=b;return f|0}function Fq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+80|0;g=f+48|0;h=b;b=d;d=e;e=h;do{if((c[h+304>>2]|0)!=0){j=c[e+304>>2]|0;c[h+304>>2]=c[j+8>>2]}else{j=Yd[c[e+12>>2]&127](24)|0;if((j|0)!=0){break}k=1;l=k;i=f;return l|0}}while(0);a[b+32|0]=1;c[b+12>>2]=0;c[j+8>>2]=c[h+300>>2];c[h+300>>2]=j;c[j+12>>2]=b;c[j+16>>2]=c[h+312>>2];a[j+20|0]=d;c[j>>2]=0;c[j+4>>2]=0;d=c[b+4>>2]|0;e=(c[b+4>>2]|0)+(c[b+8>>2]|0)|0;m=h;if((a[b+33|0]|0)!=0){n=ue[c[c[m+228>>2]>>2]&63](c[h+228>>2]|0,d,e,g)|0;o=qq(h,c[h+228>>2]|0,d,e,n,c[g>>2]|0,g,0)|0}else{o=Lq(m,c[h+312>>2]|0,c[h+228>>2]|0,d,e,g,0)|0}a:do{if((o|0)==0){do{if((e|0)!=(c[g>>2]|0)){if((c[h+480>>2]|0)!=3){break}c[b+12>>2]=(c[g>>2]|0)-d;c[h+280>>2]=40;break a}}while(0);a[b+32|0]=0;c[h+300>>2]=c[j+8>>2];c[j+8>>2]=c[h+304>>2];c[h+304>>2]=j}}while(0);k=o;l=k;i=f;return l|0}function Gq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+56|0;d=b+32|0;e=b+40|0;f=a;a=c[f+356>>2]|0;g=Yd[c[f+12>>2]&127](((c[a+176>>2]|0)*20|0)+(c[a+168>>2]|0)|0)|0;if((g|0)!=0){c[e>>2]=g+((c[a+176>>2]|0)*20|0);c[d>>2]=g+20;Kq(f,0,g,d,e);h=g;j=h;i=b;return j|0}else{h=0;j=h;i=b;return j|0}return 0}function Hq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=b;b=d;d=e;if((c[g+64>>2]|0)==0){if((c[g+80>>2]|0)!=0){eq(g,a,b,d)}h=1;j=h;i=f;return j|0}b=b+(c[a+68>>2]<<1)|0;e=b+(le[c[a+32>>2]&63](a,b)|0)|0;k=sq(g+416|0,a,b,e)|0;if((k|0)==0){h=0;j=h;i=f;return j|0}c[g+432>>2]=c[g+428>>2];b=le[c[a+36>>2]&63](a,e)|0;e=sq(g+416|0,a,b,d+(0-(c[a+68>>2]<<1))|0)|0;if((e|0)!=0){Jq(e);re[c[g+64>>2]&15](c[g+4>>2]|0,k,e);Pp(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function Iq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=a;a=b;b=d;d=e;e=g;if((c[g+68>>2]|0)==0){if((c[e+80>>2]|0)!=0){eq(g,a,b,d)}h=1;j=h;i=f;return j|0}k=sq(e+416|0,a,b+(c[a+68>>2]<<2)|0,d+(0-((c[a+68>>2]|0)*3|0))|0)|0;if((k|0)!=0){Jq(k);Wd[c[g+68>>2]&63](c[g+4>>2]|0,k);Pp(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function Jq(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=b;while(1){if((a[d]|0)==0){e=12;break}f=d;if((a[d]|0)==13){break}d=f+1|0}if((e|0)==12){i=c;return}e=f;do{do{if((a[d]|0)==13){f=e;e=f+1|0;a[f]=10;f=d+1|0;d=f;if((a[f]|0)!=10){break}d=d+1|0}else{f=d;d=f+1|0;b=e;e=b+1|0;a[b]=a[f]|0}}while(0);}while((a[d]|0)!=0);a[e]=0;i=c;return}function Kq(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+72|0;j=b;b=d;d=e;e=f;f=g;g=c[j+356>>2]|0;c[d>>2]=c[(c[g+164>>2]|0)+(b*28|0)>>2];c[d+4>>2]=c[(c[g+164>>2]|0)+(b*28|0)+4>>2];if((c[d>>2]|0)==4){c[d+8>>2]=c[f>>2];k=c[(c[g+164>>2]|0)+(b*28|0)+8>>2]|0;while(1){l=a[k]|0;m=f;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;if((a[k]|0)==0){break}k=k+1|0}c[d+12>>2]=0;c[d+16>>2]=0;i=h;return}else{c[d+12>>2]=c[(c[g+164>>2]|0)+(b*28|0)+20>>2];c[d+16>>2]=c[e>>2];k=e;c[k>>2]=(c[k>>2]|0)+((c[d+12>>2]|0)*20|0);k=0;l=c[(c[g+164>>2]|0)+(b*28|0)+12>>2]|0;while(1){if(!(k>>>0<(c[d+12>>2]|0)>>>0)){break}Kq(j,l,(c[d+16>>2]|0)+(k*20|0)|0,e,f);k=k+1|0;l=c[(c[g+164>>2]|0)+(l*28|0)+24>>2]|0}c[d+8>>2]=0;i=h;return}}function Lq(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;l=i;i=i+392|0;m=l+32|0;n=l+88|0;o=l+104|0;p=l+128|0;q=l+168|0;r=l+184|0;s=l+232|0;t=l+248|0;u=l+344|0;v=l+352|0;w=l+368|0;x=l+384|0;y=b;b=e;e=f;c[m>>2]=g;g=h;h=j;j=k;k=c[y+356>>2]|0;f=y;if((e|0)==(c[y+144>>2]|0)){z=f+288|0;A=y+292|0}else{z=c[f+300>>2]|0;A=(c[y+300>>2]|0)+4|0}c[z>>2]=c[m>>2];a:while(1){c[n>>2]=c[m>>2];f=ue[c[e+4>>2]&63](e,c[m>>2]|0,g,n)|0;c[A>>2]=c[n>>2];b:do{switch(f|0){case-3:{B=6;break a;break};case-4:{B=17;break a;break};case 9:{a[p]=$d[c[e+48>>2]&63](e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((a[p]|0)!=0){C=y;if((c[y+60>>2]|0)!=0){re[c[C+60>>2]&15](c[y+4>>2]|0,p,1);break b}if((c[C+80>>2]|0)==0){break b}eq(y,e,c[m>>2]|0,c[n>>2]|0);break b}C=sq(k+80|0,e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((C|0)==0){B=37;break a}D=jq(y,k,C,0)|0;c[k+92>>2]=c[k+96>>2];do{if((a[k+129|0]|0)!=0){if((d[k+130|0]|0)!=0){B=40;break}if((D|0)!=0){break}E=y;if((c[y+120>>2]|0)!=0){re[c[E+120>>2]&15](c[y+4>>2]|0,C,0);break b}if((c[E+80>>2]|0)==0){break b}eq(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{B=40}}while(0);if((B|0)==40){B=0;if((D|0)==0){B=41;break a}if((a[D+34|0]|0)==0){B=43;break a}}if((a[D+32|0]|0)!=0){B=50;break a}if((c[D+28>>2]|0)!=0){B=52;break a}C=y;if((c[D+4>>2]|0)!=0){E=y;if((a[C+308|0]|0)!=0){F=Fq(E,D,0)|0;if((F|0)!=0){B=60;break a}else{break b}}G=y;if((c[E+120>>2]|0)!=0){re[c[G+120>>2]&15](c[y+4>>2]|0,c[D>>2]|0,0);break b}if((c[G+80>>2]|0)==0){break b}eq(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{if((c[C+112>>2]|0)==0){if((c[y+80>>2]|0)==0){break b}eq(y,e,c[m>>2]|0,c[n>>2]|0);break b}a[D+32|0]=1;C=Nq(y)|0;a[D+32|0]=0;if((C|0)==0){B=63;break a}if((me[c[y+112>>2]&63](c[y+116>>2]|0,C,c[D+20>>2]|0,c[D+16>>2]|0,c[D+24>>2]|0)|0)==0){B=65;break a}c[y+428>>2]=c[y+432>>2];break b}break};case 3:case 4:{C=(c[m>>2]|0)+(c[e+68>>2]|0)|0;c[s>>2]=0;G=1;c[t>>2]=sq(y+416|0,e,C,C+(le[c[e+32>>2]&63](e,C)|0)|0)|0;if((c[t>>2]|0)==0){B=89;break a}c[y+432>>2]=c[y+428>>2];H=Oq(y,e,c[m>>2]|0,t,s)|0;if((H|0)!=0){B=91;break a}c[y+432>>2]=c[y+428>>2];if((c[y+52>>2]|0)!=0){re[c[y+52>>2]&15](c[y+4>>2]|0,c[t>>2]|0,c[y+392>>2]|0);G=0}if((c[y+56>>2]|0)!=0){if((c[y+52>>2]|0)!=0){c[z>>2]=c[A>>2]}Wd[c[y+56>>2]&63](c[y+4>>2]|0,c[t>>2]|0);G=0}do{if((G&255|0)!=0){if((c[y+80>>2]|0)==0){break}eq(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);Pp(y+416|0);while(1){if((c[s>>2]|0)==0){break}G=c[s>>2]|0;if((c[y+104>>2]|0)!=0){Wd[c[y+104>>2]&63](c[y+4>>2]|0,c[c[G>>2]>>2]|0)}c[s>>2]=c[(c[s>>2]|0)+4>>2];c[G+4>>2]=c[y+376>>2];c[y+376>>2]=G;c[(c[G>>2]|0)+4>>2]=c[G+8>>2]}if((c[y+312>>2]|0)==0){B=107;break a}break};case 5:{if((c[y+312>>2]|0)==(b|0)){B=109;break a}G=c[y+364>>2]|0;c[y+364>>2]=c[G>>2];c[G>>2]=c[y+368>>2];c[y+368>>2]=G;I=(c[m>>2]|0)+(c[e+68>>2]<<1)|0;D=le[c[e+32>>2]&63](e,I)|0;if((D|0)!=(c[G+8>>2]|0)){B=112;break a}if((YY(c[G+4>>2]|0,I,D)|0)!=0){B=112;break a}D=y+312|0;c[D>>2]=(c[D>>2]|0)+ -1;do{if((c[y+56>>2]|0)!=0){D=c[G+16>>2]|0;do{if((d[y+236|0]|0)!=0){if((D|0)==0){break}C=(c[G+12>>2]|0)+(c[G+28>>2]|0)|0;while(1){if((a[D]|0)==0){break}E=D;D=E+1|0;J=C;C=J+1|0;a[J]=a[E]|0}E=c[G+20>>2]|0;c:do{if((d[y+237|0]|0)!=0){if((E|0)==0){break}J=C;C=J+1|0;a[J]=a[y+472|0]|0;while(1){if((a[E]|0)==0){break c}J=E;E=J+1|0;K=C;C=K+1|0;a[K]=a[J]|0}}}while(0);a[C]=0}}while(0);Wd[c[y+56>>2]&63](c[y+4>>2]|0,c[G+12>>2]|0)}else{if((c[y+80>>2]|0)==0){break}eq(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);while(1){if((c[G+44>>2]|0)==0){break}D=c[G+44>>2]|0;if((c[y+104>>2]|0)!=0){Wd[c[y+104>>2]&63](c[y+4>>2]|0,c[c[D>>2]>>2]|0)}c[G+44>>2]=c[(c[G+44>>2]|0)+4>>2];c[D+4>>2]=c[y+376>>2];c[y+376>>2]=D;c[(c[D>>2]|0)+4>>2]=c[D+8>>2]}if((c[y+312>>2]|0)==0){B=133;break a}break};case 12:{B=140;break a;break};case 7:{if((c[y+60>>2]|0)!=0){a[v]=10;re[c[y+60>>2]&15](c[y+4>>2]|0,v,1);break b}if((c[y+80>>2]|0)==0){break b}eq(y,e,c[m>>2]|0,c[n>>2]|0);break};case 10:{G=le[c[e+44>>2]&63](e,c[m>>2]|0)|0;if((G|0)<0){B=135;break a}D=y;if((c[y+60>>2]|0)!=0){E=c[D+60>>2]|0;J=c[y+4>>2]|0;K=ar(G,u)|0;re[E&15](J,u,K);break b}if((c[D+80>>2]|0)==0){break b}eq(y,e,c[m>>2]|0,c[n>>2]|0);break};case 8:{D=y;do{if((c[y+72>>2]|0)!=0){Vd[c[D+72>>2]&511](c[y+4>>2]|0)}else{if((c[D+80>>2]|0)==0){break}eq(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);L=Qq(y,e,n,g,h,j)|0;if((L|0)!=0){B=150;break a}if((c[n>>2]|0)==0){B=152;break a}break};case-5:{B=153;break a;break};case 6:{D=c[y+60>>2]|0;if((D|0)==0){if((c[y+80>>2]|0)==0){break b}eq(y,e,c[m>>2]|0,c[n>>2]|0);break b}if((a[e+72|0]|0)!=0){re[D&15](c[y+4>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0);break b}while(1){c[x>>2]=c[y+44>>2];Sd[c[e+60>>2]&31](e,m,c[n>>2]|0,x,c[y+48>>2]|0);c[A>>2]=c[m>>2];re[D&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[x>>2]|0)-(c[y+44>>2]|0)|0);if((c[m>>2]|0)==(c[n>>2]|0)){break b}c[z>>2]=c[m>>2]}break};case 11:{if((Hq(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=174;break a}break};case 13:{if((Iq(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=176;break a}break};case 1:case 2:{D=y;if((c[y+368>>2]|0)!=0){M=c[D+368>>2]|0;c[y+368>>2]=c[c[y+368>>2]>>2]}else{M=Yd[c[D+12>>2]&127](48)|0;if((M|0)==0){B=72;break a}c[M+36>>2]=Yd[c[y+12>>2]&127](32)|0;if((c[M+36>>2]|0)==0){B=74;break a}c[M+40>>2]=(c[M+36>>2]|0)+32}c[M+44>>2]=0;c[M>>2]=c[y+364>>2];c[y+364>>2]=M;c[M+16>>2]=0;c[M+20>>2]=0;c[M+4>>2]=(c[m>>2]|0)+(c[e+68>>2]|0);c[M+8>>2]=le[c[e+32>>2]&63](e,c[M+4>>2]|0)|0;D=y+312|0;c[D>>2]=(c[D>>2]|0)+1;D=(c[M+4>>2]|0)+(c[M+8>>2]|0)|0;c[r>>2]=c[M+4>>2];c[q>>2]=c[M+36>>2];while(1){Sd[c[e+60>>2]&31](e,r,D,q,(c[M+40>>2]|0)+ -1|0);N=(c[q>>2]|0)-(c[M+36>>2]|0)|0;if((c[r>>2]|0)==(D|0)){break}K=(c[M+40>>2]|0)-(c[M+36>>2]|0)<<1;J=le[c[y+16>>2]&63](c[M+36>>2]|0,K)|0;if((J|0)==0){B=80;break a}c[M+36>>2]=J;c[M+40>>2]=J+K;c[q>>2]=J+N}c[M+24>>2]=N;c[M+12>>2]=c[M+36>>2];a[c[q>>2]|0]=0;O=Oq(y,e,c[m>>2]|0,M+12|0,M+44|0)|0;if((O|0)!=0){B=82;break a}D=y;do{if((c[y+52>>2]|0)!=0){re[c[D+52>>2]&15](c[y+4>>2]|0,c[M+12>>2]|0,c[y+392>>2]|0)}else{if((c[D+80>>2]|0)==0){break}eq(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);Pp(y+416|0);break};case 0:{B=24;break a;break};case-1:{B=25;break a;break};case-2:{B=28;break a;break};default:{if((c[y+80>>2]|0)==0){break b}eq(y,e,c[m>>2]|0,c[n>>2]|0)}}}while(0);f=c[n>>2]|0;c[m>>2]=f;c[z>>2]=f;f=c[y+480>>2]|0;if((f|0)==3){B=180;break}else if((f|0)==2){B=181;break}}if((B|0)==6){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}c[A>>2]=g;do{if((c[y+60>>2]|0)!=0){a[o]=10;re[c[y+60>>2]&15](c[y+4>>2]|0,o,1)}else{if((c[y+80>>2]|0)==0){break}eq(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=g;P=0;Q=P;i=l;return Q|0}}else if((B|0)==17){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}if((b|0)<=0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}}else if((B|0)==24){c[z>>2]=c[n>>2];P=4;Q=P;i=l;return Q|0}else if((B|0)==25){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=5;Q=P;i=l;return Q|0}}else if((B|0)==28){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=6;Q=P;i=l;return Q|0}}else if((B|0)==37){P=1;Q=P;i=l;return Q|0}else if((B|0)==41){P=11;Q=P;i=l;return Q|0}else if((B|0)==43){P=24;Q=P;i=l;return Q|0}else if((B|0)==50){P=12;Q=P;i=l;return Q|0}else if((B|0)==52){P=15;Q=P;i=l;return Q|0}else if((B|0)==60){P=F;Q=P;i=l;return Q|0}else if((B|0)==63){P=1;Q=P;i=l;return Q|0}else if((B|0)==65){P=21;Q=P;i=l;return Q|0}else if((B|0)==72){P=1;Q=P;i=l;return Q|0}else if((B|0)==74){Vd[c[y+20>>2]&511](M);P=1;Q=P;i=l;return Q|0}else if((B|0)==80){P=1;Q=P;i=l;return Q|0}else if((B|0)==82){P=O;Q=P;i=l;return Q|0}else if((B|0)==89){P=1;Q=P;i=l;return Q|0}else if((B|0)==91){P=H;Q=P;i=l;return Q|0}else if((B|0)==107){P=Pq(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==109){P=13;Q=P;i=l;return Q|0}else if((B|0)==112){c[z>>2]=I;P=7;Q=P;i=l;return Q|0}else if((B|0)==133){P=Pq(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==135){P=14;Q=P;i=l;return Q|0}else if((B|0)==140){P=17;Q=P;i=l;return Q|0}else if((B|0)==150){P=L;Q=P;i=l;return Q|0}else if((B|0)==152){c[y+280>>2]=41;P=L;Q=P;i=l;return Q|0}else if((B|0)==153){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}do{if((c[y+60>>2]|0)!=0){j=y;if((a[e+72|0]|0)!=0){re[c[j+60>>2]&15](c[y+4>>2]|0,c[m>>2]|0,g-(c[m>>2]|0)|0);break}else{c[w>>2]=c[j+44>>2];Sd[c[e+60>>2]&31](e,m,g,w,c[y+48>>2]|0);re[c[y+60>>2]&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[w>>2]|0)-(c[y+44>>2]|0)|0);break}}else{if((c[y+80>>2]|0)==0){break}eq(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){c[z>>2]=g;P=3;Q=P;i=l;return Q|0}m=g;if((c[y+312>>2]|0)!=(b|0)){c[z>>2]=m;P=13;Q=P;i=l;return Q|0}else{c[h>>2]=m;P=0;Q=P;i=l;return Q|0}}else if((B|0)==174){P=1;Q=P;i=l;return Q|0}else if((B|0)==176){P=1;Q=P;i=l;return Q|0}else if((B|0)==180){c[h>>2]=c[n>>2];P=0;Q=P;i=l;return Q|0}else if((B|0)==181){P=35;Q=P;i=l;return Q|0}return 0}function Mq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+104|0;h=g+64|0;j=b;b=d;d=e;e=f;f=c[j+300>>2]|0;if((f|0)==0){k=23;l=k;i=g;return l|0}m=c[f+12>>2]|0;n=(c[m+4>>2]|0)+(c[m+12>>2]|0)|0;o=(c[m+4>>2]|0)+(c[m+8>>2]|0)|0;p=j;if((a[m+33|0]|0)!=0){q=ue[c[c[p+228>>2]>>2]&63](c[j+228>>2]|0,n,o,h)|0;r=qq(j,c[j+228>>2]|0,n,o,q,c[h>>2]|0,h,0)|0}else{r=Lq(p,c[f+16>>2]|0,c[j+228>>2]|0,n,o,h,0)|0}if((r|0)!=0){k=r;l=k;i=g;return l|0}do{if((o|0)!=(c[h>>2]|0)){if((c[j+480>>2]|0)!=3){break}c[m+12>>2]=(c[h>>2]|0)-(c[m+4>>2]|0);k=r;l=k;i=g;return l|0}}while(0);a[m+32|0]=0;c[j+300>>2]=c[f+8>>2];c[f+8>>2]=c[j+304>>2];c[j+304>>2]=f;f=j+280|0;if((a[m+33|0]|0)!=0){c[f>>2]=39;m=ue[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=qq(j,c[j+144>>2]|0,b,d,m,c[h>>2]|0,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}else{c[f>>2]=37;k=Lq(j,(c[j+476>>2]|0)!=0?1:0,c[j+144>>2]|0,b,d,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}return 0}function Nq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d+24|0;f=b;b=c[f+356>>2]|0;g=0;do{if((c[b+156>>2]|0)!=0){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((gq(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=61;l=c[(c[b+156>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}k=0;while(1){if((k|0)>=(l|0)){m=13;break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((gq(f+416|0)|0)<<24>>24!=0)){break}}n=a[(c[(c[b+156>>2]|0)+16>>2]|0)+k|0]|0;o=f+428|0;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n;k=k+1|0}if((m|0)==13){g=1;break}h=0;j=h;i=d;return j|0}}while(0);hq(e,b+60|0);a:while(1){k=iq(e)|0;if((k|0)==0){m=40;break}if((c[k+4>>2]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((gq(f+416|0)|0)<<24>>24!=0)){m=21;break}}l=f+428|0;n=c[l>>2]|0;c[l>>2]=n+1;a[n]=12}n=c[k>>2]|0;while(1){q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if((a[n]|0)==0){break}if(q){if(!((gq(f+416|0)|0)<<24>>24!=0)){m=27;break a}}l=a[n]|0;p=f+428|0;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=l;n=n+1|0}if(q){if(!((gq(f+416|0)|0)<<24>>24!=0)){m=31;break}}n=f+428|0;l=c[n>>2]|0;c[n>>2]=l+1;a[l]=61;l=c[(c[k+4>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}n=0;while(1){if((n|0)>=(l|0)){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((gq(f+416|0)|0)<<24>>24!=0)){m=38;break a}}o=a[(c[(c[k+4>>2]|0)+16>>2]|0)+n|0]|0;p=f+428|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=o;n=n+1|0}g=1}if((m|0)==21){h=0;j=h;i=d;return j|0}else if((m|0)==27){h=0;j=h;i=d;return j|0}else if((m|0)==31){h=0;j=h;i=d;return j|0}else if((m|0)==38){h=0;j=h;i=d;return j|0}else if((m|0)==40){hq(e,b);b:while(1){b=iq(e)|0;if((b|0)==0){m=55;break}if((a[b+32|0]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((gq(f+416|0)|0)<<24>>24!=0)){m=47;break}}q=f+428|0;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=12}n=c[b>>2]|0;while(1){if((a[n]|0)==0){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((gq(f+416|0)|0)<<24>>24!=0)){m=53;break b}}b=a[n]|0;q=f+428|0;k=c[q>>2]|0;c[q>>2]=k+1;a[k]=b;n=n+1|0}g=1}if((m|0)==47){h=0;j=h;i=d;return j|0}else if((m|0)==53){h=0;j=h;i=d;return j|0}else if((m|0)==55){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((gq(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);m=f+428|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g]=0;h=c[f+432>>2]|0;j=h;i=d;return j|0}}return 0}function Oq(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+352|0;k=b;b=e;e=f;f=g;g=h;h=c[k+356>>2]|0;l=0;m=0;n=jq(k,h+20|0,c[f>>2]|0,0)|0;do{if((n|0)==0){o=Rp(h+80|0,c[f>>2]|0)|0;if((o|0)==0){p=1;q=p;i=j;return q|0}n=jq(k,h+20|0,o,24)|0;if((n|0)==0){p=1;q=p;i=j;return q|0}if((d[k+236|0]|0)==0){break}if((Uq(k,n)|0)!=0){break}p=1;q=p;i=j;return q|0}}while(0);o=c[n+12>>2]|0;r=ue[c[b+40>>2]&63](b,e,c[k+380>>2]|0,c[k+392>>2]|0)|0;do{if((r+o|0)>(c[k+380>>2]|0)){s=c[k+380>>2]|0;c[k+380>>2]=r+o+16;t=le[c[k+16>>2]&63](c[k+392>>2]|0,c[k+380>>2]<<4)|0;if((t|0)==0){p=1;q=p;i=j;return q|0}else{c[k+392>>2]=t;if((r|0)<=(s|0)){break}ue[c[b+40>>2]&63](b,e,r,c[k+392>>2]|0)|0;break}}}while(0);e=c[k+392>>2]|0;s=0;a:while(1){if((s|0)>=(r|0)){u=43;break}t=(c[k+392>>2]|0)+(s<<4)|0;v=c[t>>2]|0;w=c[t>>2]|0;x=wq(k,b,v,w+(le[c[b+32>>2]&63](b,c[t>>2]|0)|0)|0)|0;if((x|0)==0){u=17;break}if((a[(c[x>>2]|0)+ -1|0]|0)!=0){u=19;break}a[(c[x>>2]|0)+ -1|0]=1;t=l;l=t+1|0;c[e+(t<<2)>>2]=c[x>>2];if((a[(c[k+392>>2]|0)+(s<<4)+12|0]|0)!=0){c[e+(l<<2)>>2]=sq(k+416|0,b,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0)|0;if((c[e+(l<<2)>>2]|0)==0){u=33;break}c[k+432>>2]=c[k+428>>2]}else{t=1;b:do{if((a[x+8|0]|0)!=0){w=0;while(1){if((w|0)>=(o|0)){break b}y=w;if((x|0)==(c[(c[n+20>>2]|0)+(w*12|0)>>2]|0)){break}w=y+1|0}t=a[(c[n+20>>2]|0)+(y*12|0)+4|0]|0}}while(0);z=Aq(k,b,t,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0,k+416|0)|0;if((z|0)!=0){u=30;break}c[e+(l<<2)>>2]=c[k+432>>2];c[k+432>>2]=c[k+428>>2]}do{if((c[x+4>>2]|0)!=0){if((a[x+9|0]|0)==0){l=l+1|0;m=m+1|0;a[(c[x>>2]|0)+ -1|0]=2;break}A=nq(k,c[x+4>>2]|0,x,c[e+(l<<2)>>2]|0,g)|0;if((A|0)!=0){u=38;break a}l=l+ -1|0}else{l=l+1|0}}while(0);s=s+1|0}if((u|0)==17){p=1;q=p;i=j;return q|0}else if((u|0)==19){if((b|0)==(c[k+144>>2]|0)){c[k+288>>2]=c[(c[k+392>>2]|0)+(s<<4)>>2]}p=8;q=p;i=j;return q|0}else if((u|0)==30){p=z;q=p;i=j;return q|0}else if((u|0)==33){p=1;q=p;i=j;return q|0}else if((u|0)==38){p=A;q=p;i=j;return q|0}else if((u|0)==43){c[k+384>>2]=l;c:do{if((c[n+8>>2]|0)!=0){if((a[(c[c[n+8>>2]>>2]|0)+ -1|0]|0)==0){u=50;break}s=0;while(1){if((s|0)>=(l|0)){break c}B=s;if((c[e+(s<<2)>>2]|0)==(c[c[n+8>>2]>>2]|0)){break}s=B+2|0}c[k+388>>2]=B}else{u=50}}while(0);if((u|0)==50){c[k+388>>2]=-1}s=0;d:while(1){if((s|0)>=(o|0)){break}B=(c[n+20>>2]|0)+(s*12|0)|0;do{if((a[(c[c[B>>2]>>2]|0)+ -1|0]|0)==0){if((c[B+8>>2]|0)==0){break}A=c[B>>2]|0;if((c[(c[B>>2]|0)+4>>2]|0)==0){a[(c[A>>2]|0)+ -1|0]=1;z=l;l=z+1|0;c[e+(z<<2)>>2]=c[c[B>>2]>>2];z=l;l=z+1|0;c[e+(z<<2)>>2]=c[B+8>>2];break}if((a[A+9|0]|0)!=0){C=nq(k,c[(c[B>>2]|0)+4>>2]|0,c[B>>2]|0,c[B+8>>2]|0,g)|0;if((C|0)!=0){u=58;break d}else{break}}else{a[(c[c[B>>2]>>2]|0)+ -1|0]=2;m=m+1|0;A=l;l=A+1|0;c[e+(A<<2)>>2]=c[c[B>>2]>>2];A=l;l=A+1|0;c[e+(A<<2)>>2]=c[B+8>>2];break}}}while(0);s=s+1|0}if((u|0)==58){p=C;q=p;i=j;return q|0}c[e+(l<<2)>>2]=0;s=0;e:do{if((m|0)!=0){C=c[k+400>>2]|0;o=1<<d[k+404|0];do{if((m<<1>>d[k+404|0]|0)!=0){do{B=k+404|0;A=a[B]|0;a[B]=A+1<<24>>24;}while((m>>(A&255)|0)!=0);if((d[k+404|0]|0)<3){a[k+404|0]=3}o=1<<d[k+404|0];A=le[c[k+16>>2]&63](c[k+396>>2]|0,o*12|0)|0;if((A|0)!=0){c[k+396>>2]=A;C=0;break}p=1;q=p;i=j;return q|0}}while(0);f:do{if((C|0)==0){C=-1;D=o;while(1){if((D|0)==0){break f}A=D+ -1|0;D=A;c[(c[k+396>>2]|0)+(A*12|0)>>2]=C}}}while(0);A=C+ -1|0;C=A;c[k+400>>2]=A;g:while(1){if((s|0)>=(l|0)){break e}A=c[e+(s<<2)>>2]|0;if((a[A+ -1|0]|0)==2){B=c[k+496>>2]|0;a[A+ -1|0]=0;z=c[(c[(jq(k,h+40|0,A,0)|0)+4>>2]|0)+4>>2]|0;if((z|0)==0){u=78;break}D=0;while(1){if((D|0)>=(c[z+20>>2]|0)){break}b=a[(c[z+16>>2]|0)+D|0]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((gq(k+416|0)|0)<<24>>24!=0)){u=84;break g}}y=k+428|0;x=c[y>>2]|0;c[y>>2]=x+1;a[x]=b;B=B*1000003^b&255;D=D+1|0}do{b=A;A=b+1|0;}while((a[b]|0)!=58);do{b=a[A]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((gq(k+416|0)|0)<<24>>24!=0)){u=89;break g}}x=a[A]|0;y=k+428|0;t=c[y>>2]|0;c[y>>2]=t+1;a[t]=x;B=B*1000003^b&255;b=A;A=b+1|0;}while((a[b]|0)!=0);b=0;x=o-1|0;D=B&x;while(1){if((c[(c[k+396>>2]|0)+(D*12|0)>>2]|0)!=(C|0)){break}if((B|0)==(c[(c[k+396>>2]|0)+(D*12|0)+4>>2]|0)){t=c[k+432>>2]|0;y=c[(c[k+396>>2]|0)+(D*12|0)+8>>2]|0;while(1){if((a[t]|0)!=(a[y]|0)){break}if((a[t]|0)==0){break}t=t+1|0;y=y+1|0}if((a[t]|0)==0){u=98;break g}}if(!(b<<24>>24!=0)){b=((B&~x)>>>((d[k+404|0]|0)-1|0)&x>>>2|1)&255}if((D|0)<(b&255|0)){D=D+(o-(b&255))|0;continue}else{D=D-(b&255)|0;continue}}if((a[k+237|0]|0)!=0){a[(c[k+428>>2]|0)+ -1|0]=a[k+472|0]|0;A=c[c[z>>2]>>2]|0;do{if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((gq(k+416|0)|0)<<24>>24!=0)){u=109;break g}}b=a[A]|0;x=k+428|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=b;b=A;A=b+1|0;}while((a[b]|0)!=0)}A=c[k+432>>2]|0;c[k+432>>2]=c[k+428>>2];c[e+(s<<2)>>2]=A;c[(c[k+396>>2]|0)+(D*12|0)>>2]=C;c[(c[k+396>>2]|0)+(D*12|0)+4>>2]=B;c[(c[k+396>>2]|0)+(D*12|0)+8>>2]=A;z=m+ -1|0;m=z;if((z|0)==0){u=111;break}}else{a[A+ -1|0]=0}s=s+2|0}if((u|0)==78){p=27;q=p;i=j;return q|0}else if((u|0)==84){p=1;q=p;i=j;return q|0}else if((u|0)==89){p=1;q=p;i=j;return q|0}else if((u|0)==98){p=8;q=p;i=j;return q|0}else if((u|0)==109){p=1;q=p;i=j;return q|0}else if((u|0)==111){s=s+2|0;break}}}while(0);while(1){if((s|0)>=(l|0)){break}a[(c[e+(s<<2)>>2]|0)+ -1|0]=0;s=s+2|0}e=c[g>>2]|0;while(1){if((e|0)==0){break}a[(c[c[e+12>>2]>>2]|0)+ -1|0]=0;e=c[e+4>>2]|0}if((a[k+236|0]|0)==0){p=0;q=p;i=j;return q|0}do{if((c[n+4>>2]|0)!=0){e=c[(c[n+4>>2]|0)+4>>2]|0;if((e|0)!=0){E=c[f>>2]|0;do{g=E;E=g+1|0;}while((a[g]|0)!=58)}else{p=27;q=p;i=j;return q|0}}else{if((c[h+156>>2]|0)!=0){e=c[h+156>>2]|0;E=c[f>>2]|0;break}p=0;q=p;i=j;return q|0}}while(0);h=0;do{if((d[k+237|0]|0)!=0){if((c[c[e>>2]>>2]|0)==0){break}do{n=h;h=n+1|0;}while((a[(c[c[e>>2]>>2]|0)+n|0]|0)!=0)}}while(0);c[f+4>>2]=E;c[f+16>>2]=c[e+20>>2];c[f+8>>2]=c[c[e>>2]>>2];c[f+20>>2]=h;s=0;do{n=s;s=n+1|0;}while((a[E+n|0]|0)!=0);r=s+(c[e+20>>2]|0)+h|0;if((r|0)>(c[e+24>>2]|0)){F=Yd[c[k+12>>2]&127](r+24|0)|0;if((F|0)==0){p=1;q=p;i=j;return q|0}c[e+24>>2]=r+24;dZ(F|0,c[e+16>>2]|0,c[e+20>>2]|0)|0;r=c[k+364>>2]|0;while(1){if((r|0)==0){break}if((c[r+12>>2]|0)==(c[e+16>>2]|0)){c[r+12>>2]=F}r=c[r>>2]|0}Vd[c[k+20>>2]&511](c[e+16>>2]|0);c[e+16>>2]=F}F=(c[e+16>>2]|0)+(c[e+20>>2]|0)|0;dZ(F|0,E|0,s|0)|0;if((h|0)!=0){F=F+(s-1)|0;a[F]=a[k+472|0]|0;dZ(F+1|0,c[c[e>>2]>>2]|0,h|0)|0}c[f>>2]=c[e+16>>2];p=0;q=p;i=j;return q|0}return 0}function Pq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+40|0;j=b;b=d;d=e;e=f;c[j+280>>2]=42;c[j+288>>2]=b;a:while(1){c[h>>2]=0;f=ue[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;c[j+292>>2]=c[h>>2];b:do{switch(f|0){case-1:{k=15;break a;break};case 13:{if((Iq(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=13;break a}break};case 0:{k=14;break a;break};case-2:{k=18;break a;break};case 11:{if((Hq(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=11;break a}break};case 15:{if((c[j+80>>2]|0)==0){break b}eq(j,c[j+144>>2]|0,b,c[h>>2]|0);break};case-15:{k=3;break a;break};case-4:{k=7;break a;break};default:{k=21;break a}}}while(0);f=c[h>>2]|0;b=f;c[j+288>>2]=f;f=c[j+480>>2]|0;if((f|0)==2){k=24;break}else if((f|0)==3){k=23;break}}if((k|0)==3){do{if((c[j+80>>2]|0)!=0){eq(j,c[j+144>>2]|0,b,c[h>>2]|0);if((c[j+480>>2]|0)!=2){break}l=35;m=l;i=g;return m|0}}while(0);c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==7){c[e>>2]=b;l=0;m=l;i=g;return m|0}else if((k|0)==11){l=1;m=l;i=g;return m|0}else if((k|0)==13){l=1;m=l;i=g;return m|0}else if((k|0)==14){c[j+288>>2]=c[h>>2];l=4;m=l;i=g;return m|0}else if((k|0)==15){if((a[j+484|0]|0)!=0){l=5;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==18){if((a[j+484|0]|0)!=0){l=6;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==21){l=9;m=l;i=g;return m|0}else if((k|0)==23){c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==24){l=35;m=l;i=g;return m|0}return 0}function Qq(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+120|0;k=j+56|0;l=j+80|0;m=j+96|0;n=j+112|0;o=b;b=d;d=e;e=f;f=g;g=h;c[k>>2]=c[d>>2];h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;c[p>>2]=c[k>>2];q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}c[p>>2]=c[k>>2];c[d>>2]=0;a:while(1){h=ue[c[b+8>>2]&63](b,c[k>>2]|0,e,l)|0;c[q>>2]=c[l>>2];b:do{switch(h|0){case-2:{r=25;break a;break};case 7:{if((c[o+60>>2]|0)!=0){a[m]=10;re[c[o+60>>2]&15](c[o+4>>2]|0,m,1);break b}if((c[o+80>>2]|0)==0){break b}eq(o,b,c[k>>2]|0,c[l>>2]|0);break};case-4:case-1:{r=28;break a;break};case 40:{r=6;break a;break};case 6:{s=c[o+60>>2]|0;if((s|0)==0){if((c[o+80>>2]|0)==0){break b}eq(o,b,c[k>>2]|0,c[l>>2]|0);break b}if((a[b+72|0]|0)!=0){re[s&15](c[o+4>>2]|0,c[k>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0);break b}while(1){c[n>>2]=c[o+44>>2];Sd[c[b+60>>2]&31](b,k,c[l>>2]|0,n,c[o+48>>2]|0);c[q>>2]=c[l>>2];re[s&15](c[o+4>>2]|0,c[o+44>>2]|0,(c[n>>2]|0)-(c[o+44>>2]|0)|0);if((c[k>>2]|0)==(c[l>>2]|0)){break b}c[p>>2]=c[k>>2]}break};case 0:{r=24;break a;break};default:{r=31;break a}}}while(0);h=c[l>>2]|0;c[k>>2]=h;c[p>>2]=h;h=c[o+480>>2]|0;if((h|0)==2){r=34;break}else if((h|0)==3){r=33;break}}if((r|0)==6){n=o;do{if((c[o+76>>2]|0)!=0){Vd[c[n+76>>2]&511](c[o+4>>2]|0)}else{if((c[n+80>>2]|0)==0){break}eq(o,b,c[k>>2]|0,c[l>>2]|0)}}while(0);c[d>>2]=c[l>>2];c[f>>2]=c[l>>2];if((c[o+480>>2]|0)==2){t=35;u=t;i=j;return u|0}else{t=0;u=t;i=j;return u|0}}else if((r|0)==24){c[p>>2]=c[l>>2];t=4;u=t;i=j;return u|0}else if((r|0)==25){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=6;u=t;i=j;return u|0}}else if((r|0)==28){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=20;u=t;i=j;return u|0}}else if((r|0)==31){c[p>>2]=c[l>>2];t=23;u=t;i=j;return u|0}else if((r|0)==33){c[f>>2]=c[l>>2];t=0;u=t;i=j;return u|0}else if((r|0)==34){t=35;u=t;i=j;return u|0}return 0}function Rq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=Qq(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)==0){k=f;l=k;i=g;return l|0}f=j+280|0;if((c[j+476>>2]|0)!=0){c[f>>2]=43;k=Sq(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{c[f>>2]=37;k=uq(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}return 0}function Sq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=Lq(h,1,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((Tq(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function Tq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+56|0;d=a;a=c[d+364>>2]|0;while(1){if((a|0)==0){e=13;break}f=(c[a+24>>2]|0)+1|0;g=(c[a+36>>2]|0)+f|0;if((c[a+4>>2]|0)==(g|0)){e=13;break}h=f+((c[a+8>>2]|0)+0)|0;if((h|0)>((c[a+40>>2]|0)-(c[a+36>>2]|0)|0)){j=le[c[d+16>>2]&63](c[a+36>>2]|0,h)|0;if((j|0)==0){e=6;break}if((c[a+12>>2]|0)==(c[a+36>>2]|0)){c[a+12>>2]=j}if((c[a+16>>2]|0)!=0){c[a+16>>2]=j+((c[a+16>>2]|0)-(c[a+36>>2]|0))}c[a+36>>2]=j;c[a+40>>2]=j+h;g=j+f|0}dZ(g|0,c[a+4>>2]|0,c[a+8>>2]|0)|0;c[a+4>>2]=g;a=c[a>>2]|0}if((e|0)==6){k=0;l=k;i=b;return l|0}else if((e|0)==13){k=1;l=k;i=b;return l|0}return 0}function Uq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=c[b>>2]|0;a:while(1){if((a[g]|0)==0){h=20;break}if((a[g]|0)==58){j=c[b>>2]|0;while(1){k=(c[d+92>>2]|0)==(c[d+88>>2]|0);if((j|0)==(g|0)){break}if(k){if(!((gq(d+80|0)|0)<<24>>24!=0)){h=9;break a}}l=a[j]|0;m=d+92|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;j=j+1|0}if(k){if(!((gq(d+80|0)|0)<<24>>24!=0)){h=13;break}}j=d+92|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;l=jq(f,d+60|0,c[d+96>>2]|0,8)|0;if((l|0)==0){h=14;break}j=d+80|0;if((c[l>>2]|0)==(c[d+96>>2]|0)){c[d+96>>2]=c[j+12>>2]}else{c[d+92>>2]=c[j+16>>2]}c[b+4>>2]=l}g=g+1|0}if((h|0)==9){o=0;p=o;i=e;return p|0}else if((h|0)==13){o=0;p=o;i=e;return p|0}else if((h|0)==14){o=0;p=o;i=e;return p|0}else if((h|0)==20){o=1;p=o;i=e;return p|0}return 0}function Vq(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+152|0;l=k+64|0;m=k+80|0;n=b;b=e;e=f;f=g;g=h;h=j;j=c[n+356>>2]|0;a:while(1){b:do{switch(ue[c[b+16>>2]&63](b,f,g,l)|0){case 10:{o=le[c[b+44>>2]&63](b,f)|0;if((o|0)<0){p=11;break a}do{if(!(e<<24>>24!=0)){if((o|0)!=32){break}if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break b}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break b}}}while(0);o=ar(o,m)|0;if((o|0)==0){p=19;break a}q=0;while(1){if((q|0)>=(o|0)){break b}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((gq(h)|0)<<24>>24!=0)){p=27;break a}}r=a[m+q|0]|0;s=h+12|0;t=c[s>>2]|0;c[s>>2]=t+1;a[t]=r;q=q+1|0}break};case 6:{if((yq(h,b,f,c[l>>2]|0)|0)==0){p=29;break a}break};case 0:{p=4;break a;break};case-4:{p=3;break a;break};case 7:case 39:{p=31;break};case-3:{c[l>>2]=f+(c[b+68>>2]|0);p=31;break};case 9:{q=($d[c[b+48>>2]&63](b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0)&255;if(q<<24>>24!=0){if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((gq(h)|0)<<24>>24!=0)){p=42;break a}}o=h+12|0;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;break b}q=sq(n+440|0,b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((q|0)==0){p=44;break a}r=jq(n,j,q,0)|0;c[n+452>>2]=c[n+456>>2];if((h|0)==(j+80|0)){if((c[n+272>>2]|0)!=0){if((d[j+130|0]|0)!=0){u=(c[n+300>>2]|0)!=0}else{u=(a[j+129|0]|0)!=0}v=((u^1)&1|0)!=0}else{v=0}w=v&1}else{if((a[j+129|0]|0)!=0){x=(d[j+130|0]|0)!=0}else{x=1}w=x&1}q=(r|0)!=0;if(w<<24>>24!=0){if(!q){p=57;break a}if((a[r+34|0]|0)==0){p=59;break a}}else{if(!q){break b}}if((a[r+32|0]|0)!=0){p=62;break a}if((c[r+28>>2]|0)!=0){p=66;break a}if((c[r+4>>2]|0)==0){p=70;break a}q=(c[r+4>>2]|0)+(c[r+8>>2]|0)|0;a[r+32|0]=1;y=Vq(n,c[n+228>>2]|0,e,c[r+4>>2]|0,q,h)|0;a[r+32|0]=0;if((y|0)!=0){p=74;break a}break};case-1:{p=7;break a;break};default:{p=75;break a}}}while(0);do{if((p|0)==31){p=0;if(!(e<<24>>24!=0)){if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break}}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((gq(h)|0)<<24>>24!=0)){p=37;break a}}r=h+12|0;q=c[r>>2]|0;c[r>>2]=q+1;a[q]=32}}while(0);f=c[l>>2]|0}if((p|0)==3){z=0;A=z;i=k;return A|0}else if((p|0)==4){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=c[l>>2]}z=4;A=z;i=k;return A|0}else if((p|0)==7){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=4;A=z;i=k;return A|0}else if((p|0)==11){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((p|0)==19){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((p|0)==27){z=1;A=z;i=k;return A|0}else if((p|0)==29){z=1;A=z;i=k;return A|0}else if((p|0)==37){z=1;A=z;i=k;return A|0}else if((p|0)==42){z=1;A=z;i=k;return A|0}else if((p|0)==44){z=1;A=z;i=k;return A|0}else if((p|0)==57){z=11;A=z;i=k;return A|0}else if((p|0)==59){z=24;A=z;i=k;return A|0}else if((p|0)==62){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=12;A=z;i=k;return A|0}else if((p|0)==66){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=15;A=z;i=k;return A|0}else if((p|0)==70){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=16;A=z;i=k;return A|0}else if((p|0)==74){z=y;A=z;i=k;return A|0}else if((p|0)==75){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=23;A=z;i=k;return A|0}return 0}



function fw(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;F=F|0;G=G|0;H=H|0;I=I|0;J=J|0;K=K|0;L=L|0;M=M|0;var N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0;N=i;i=i+16|0;O=N;P=N+8|0;Q=c[f>>2]|0;R=~Q;c[n>>2]=1;h[9628]=+h[b>>3];c[19234]=0;c[19242]=0;c[19236]=0;S=u+52|0;if((c[m>>2]|0)==0){c[S>>2]=0;T=u+56|0;c[T>>2]=0;c[I>>2]=1;c[J>>2]=0;h[C>>3]=0.0;c[m>>2]=1;h[y>>3]=+h[k>>3];U=1.0/+h[k>>3];h[B>>3]=U;h[A>>3]=U;h[D>>3]=100.0;c[H>>2]=-1;h[9640]=1.0;c[G>>2]=0;c[K>>2]=0;V=T}else{V=u+56|0}T=u+44|0;m=g;W=u+48|0;while(1){c[19230]=(c[I>>2]|0)+1;c[19232]=(c[I>>2]|0)+2;c[19228]=(c[I>>2]|0)+ -1;h[9628]=+h[b>>3];do{if(+h[k>>3]!=+h[C>>3]){X=8}else{Y=c[I>>2]|0;if((Y|0)!=(c[J>>2]|0)){X=8;break}Z=(c[K>>2]|0)+1|0;_=Y}}while(0);if((X|0)==8){X=0;c[K>>2]=0;Z=1;_=c[J>>2]|0}Y=_+2|0;$=(Z|0)<=(Y|0)?Z:Y;c[K>>2]=$;c[19246]=$+1;$=c[19230]|0;if(($|0)>=(c[K>>2]|0)){h[w>>3]=1.0;h[v>>3]=1.0;h[9631]=+h[k>>3];h[x>>3]=0.0;h[z>>3]=1.0;c[19216]=2;if(($|0)>=2){Y=2;while(1){h[9632]=+h[y+(Y+ -2<<3)>>3];U=+h[9631];aa=Y+ -2|0;h[y+(aa<<3)>>3]=U;ba=Y+ -1|0;h[w+(ba<<3)>>3]=+h[w+(aa<<3)>>3]*U/+h[9632];U=+h[9632]+ +h[k>>3];h[9631]=U;ca=+h[k>>3]/U;h[v+(ba<<3)>>3]=ca;h[z+(ba<<3)>>3]=ca*+h[z+(aa<<3)>>3]*+(ba|0);h[x+(ba<<3)>>3]=+h[x+(aa<<3)>>3]+ +h[v+(aa<<3)>>3]/+h[k>>3];if((Y|0)<($|0)){Y=Y+1|0}else{break}}c[19216]=$+1}h[y+($+ -1<<3)>>3]=+h[9631]}h[9638]=0.0;h[9636]=0.0;Y=c[I>>2]|0;c[19216]=1;if((Y|0)<1){da=0.0}else{ca=0.0;U=0.0;aa=1;while(1){ea=U-1.0/+(aa|0);h[9638]=ea;ga=ca- +h[v+(aa+ -1<<3)>>3];h[9636]=ga;if((aa|0)<(Y|0)){aa=aa+1|0;U=ea;ca=ga}else{break}}c[19216]=Y+1;da=ea}h[9639]=+h[A>>3];h[A>>3]=-da/+h[k>>3];aa=v+($+ -1<<3)|0;ca=+h[aa>>3]+ +h[9638]- +h[9636];h[O>>3]=ca;if(!(ca>=0.0)){ha=-ca}else{ha=ca}h[9613]=ha;h[O>>3]=ha;ca=+h[aa>>3];h[P>>3]=ca;h[9613]=ha>=ca?ha:ca;h[9631]=.6;h[9632]=1.6666666666666667;ca=+h[A>>3];U=ca/+h[B>>3];if(U<.6|U>1.6666666666666667){c[H>>2]=-1}if(ca!=+h[9639]){h[D>>3]=100.0}aa=c[19230]|0;ba=c[19246]|0;if((aa|0)>=(ba|0)){c[19218]=ba;ia=ba;while(1){ba=c[f>>2]|0;c[19216]=1;if((ba|0)>=1){ja=1;while(1){ka=q+(ja+R+(fa(ia,Q)|0)<<3)|0;h[ka>>3]=+h[w+(ia+ -1<<3)>>3]*+h[ka>>3];if((ja|0)<(ba|0)){ja=ja+1|0}else{break}}c[19216]=ba+1}ja=ia+1|0;c[19218]=ja;if((ia|0)<(aa|0)){ia=ja}else{break}}}h[b>>3]=+h[k>>3]+ +h[b>>3];a:while(1){ia=c[f>>2]|0;c[19216]=1;if((ia|0)>=1){aa=1;while(1){$=aa+ -1|0;h[d+($<<3)>>3]=+h[q+($<<3)>>3];h[e+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ia|0)){aa=aa+1|0}else{break}}c[19216]=ia+1}aa=c[19230]|0;c[19218]=2;if((aa|0)>=2){ba=2;while(1){$=c[f>>2]|0;c[19216]=1;if(($|0)>=1){Y=x+(ba+ -1<<3)|0;ja=fa(ba,Q)|0;ka=ja+R|0;la=1;while(1){ma=d+(la+ -1<<3)|0;h[ma>>3]=+h[q+(la+R+ja<<3)>>3]+ +h[ma>>3];ma=e+(la+ -1<<3)|0;h[ma>>3]=+h[ma>>3]+ +h[Y>>3]*+h[q+(ka+la<<3)>>3];if((la|0)<($|0)){la=la+1|0}else{break}}c[19216]=$+1}la=ba+1|0;c[19218]=la;if((ba|0)<(aa|0)){ba=la}else{break}}}h[9635]=+cw(f,d,l,0,0);a[77128]=1;c[19220]=0;c[T>>2]=(c[T>>2]|0)+1;c[19250]=0;Rd[m&7](b,d,e,r,77e3,o,p)|0;if((c[19250]|0)<0){X=70;break}if((c[H>>2]|0)==-1){c[W>>2]=(c[W>>2]|0)+1;c[H>>2]=0;gw(f,b,d,e,r,A,k,76952,l,s,t,u,g,77e3,F,j,o,p,M)|0;h[B>>3]=+h[A>>3];h[D>>3]=100.0;if((c[19250]|0)<0|(c[19238]|0)!=0){X=70;break}c[19242]=0}ba=c[f>>2]|0;c[19216]=1;if((ba|0)>=1){aa=1;while(1){h[s+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[19216]=ba+1}while(1){ca=2.0/(+h[A>>3]/+h[B>>3]+1.0);h[9631]=ca;aa=c[f>>2]|0;c[19216]=1;if((aa|0)>=1){U=ca;ia=1;la=0;while(1){ka=r+(la<<3)|0;h[ka>>3]=U*+h[ka>>3];if((ia|0)>=(aa|0)){break}ka=ia;U=+h[9631];ia=ia+1|0;la=ka}c[19216]=aa+1}hw(f,r,t,u)|0;la=c[f>>2]|0;c[19216]=1;if((la|0)>=1){ia=1;while(1){$=ia+ -1|0;ka=d+($<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+($<<3)>>3];$=ia+ -1|0;ka=r+($<<3)|0;Y=s+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[ka>>3];Y=e+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[A>>3]*+h[ka>>3];if((ia|0)<(la|0)){ia=ia+1|0}else{break}}c[19216]=la+1}U=+cw(f,r,l,0,0);h[9640]=U;if(U<=+h[F>>3]*100.0*+h[9635]){X=63;break a}ia=c[19220]|0;if((ia|0)>0){h[O>>3]=U/+h[9642];h[P>>3]=1.0/+(ia|0);ca=+fM(O,P);if(ca>.9){break}ga=ca/(1.0-ca);h[D>>3]=ga;na=+h[9640];oa=ga}else{h[9642]=U;na=U;oa=+h[D>>3]}if(oa*na<=.33){X=63;break a}ia=c[19220]|0;c[19220]=ia+1;if((ia|0)>2){break}c[T>>2]=(c[T>>2]|0)+1;c[19250]=0;Rd[m&7](b,d,e,r,77e3,o,p)|0;if((c[19250]|0)<0){X=70;break a}}if((c[H>>2]|0)==0){X=70;break}c[H>>2]=-1}do{if((X|0)==63){X=0;if((c[L>>2]|0)==0){break}ba=c[f>>2]|0;c[19216]=1;if((ba|0)>=1){ia=1;while(1){pa=+h[d+(ia+ -1<<3)>>3];h[r+(ia+ -1<<3)>>3]=pa<=0.0?pa:0.0;if((ia|0)<(ba|0)){ia=ia+1|0}else{break}}h[O>>3]=pa;c[19216]=ba+1}U=+cw(f,r,l,0,0);h[9640]=U;if(U>.33){X=70;break}ia=c[f>>2]|0;c[19216]=1;if((ia|0)<1){break}else{qa=1}while(1){aa=qa+ -1|0;ka=s+(aa<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+(aa<<3)>>3];if((qa|0)<(ia|0)){qa=qa+1|0}else{break}}c[19216]=ia+1}}while(0);if((X|0)==70){X=0;a[77128]=0}c[H>>2]=1;if(a[77128]&1){U=+cw(f,s,l,0,0);h[9634]=U;ba=c[I>>2]|0;ga=U*+h[z+(ba<<3)>>3];h[9620]=ga;h[9627]=ga*+(ba+1|0);h[9622]=ga;c[19252]=ba;do{if((c[I>>2]|0)!=1){ba=c[f>>2]|0;c[19216]=1;if((ba|0)>=1){aa=fa(c[19230]|0,Q)|0;ka=1;while(1){Y=ka+ -1|0;h[r+(Y<<3)>>3]=+h[q+(ka+R+aa<<3)>>3]+ +h[s+(Y<<3)>>3];if((ka|0)<(ba|0)){ka=ka+1|0}else{break}}c[19216]=ba+1}ga=+h[z+((c[I>>2]|0)+ -1<<3)>>3];U=ga*+cw(f,r,l,0,0);h[9629]=U;ka=c[I>>2]|0;ga=U*+(ka|0);h[9637]=ga;if((ka|0)>2){aa=c[f>>2]|0;c[19216]=1;ia=c[I>>2]|0;if((aa|0)<1){ra=ia}else{Y=ia;ia=1;while(1){ca=+h[q+(ia+R+(fa(Y,Q)|0)<<3)>>3];$=r+(ia+ -1<<3)|0;h[$>>3]=ca+ +h[$>>3];$=ia+1|0;c[19216]=$;ja=c[I>>2]|0;if((ia|0)<(aa|0)){ia=$;Y=ja}else{ra=ja;break}}}ca=+h[z+(ra+ -2<<3)>>3];sa=ca*+cw(f,r,l,0,0);Y=c[I>>2]|0;ca=sa*+(Y+ -1|0);sa=+h[9637];if((sa>=ca?sa:ca)>+h[9627]){break}ta=+h[9629];ua=Y}else{if(!(ga<=+h[9627]*.5)){break}else{ta=U;ua=ka}}c[19252]=ua+ -1;h[9622]=ta}}while(0);if(!(+h[9613]*+h[9634]>1.0)){X=86;break}}c[G>>2]=1;h[b>>3]=+h[9628];Y=c[19230]|0;ia=c[19246]|0;if((Y|0)>=(ia|0)){c[19218]=ia;aa=ia;while(1){ca=1.0/+h[w+(aa+ -1<<3)>>3];h[9631]=ca;ia=c[f>>2]|0;c[19216]=1;if((ia|0)>=1){ba=fa(aa,Q)|0;sa=ca;ja=1;while(1){$=q+(ja+R+ba<<3)|0;h[$>>3]=sa*+h[$>>3];if((ja|0)>=(ia|0)){break}sa=+h[9631];ja=ja+1|0}c[19216]=ia+1}ja=aa+1|0;c[19218]=ja;if((aa|0)<(Y|0)){aa=ja}else{break}}}c[19216]=2;if((Y|0)>=2){aa=2;while(1){h[y+(aa+ -2<<3)>>3]=+h[y+(aa+ -1<<3)>>3]- +h[k>>3];if((aa|0)<(Y|0)){aa=aa+1|0}else{break}}c[19216]=Y+1}if(!(a[77128]&1)){c[V>>2]=(c[V>>2]|0)+1;if((c[19238]|0)!=0){aa=(c[19242]|0)+1|0;c[19242]=aa;h[9611]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=3){X=144;break}if(!(sa>=0.0)){va=-sa}else{va=sa}if(!(va>=+h[E>>3])){X=144;break}else{continue}}if(!((c[19250]|0)>-2)){X=146;break}aa=(c[19234]|0)+1|0;c[19234]=aa;h[9611]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=10){X=151;break}if(!(sa>=0.0)){wa=-sa}else{wa=sa}if(!(wa>=+h[E>>3])){X=151;break}else{continue}}c[19236]=(c[19236]|0)+1;c[S>>2]=(c[S>>2]|0)+1;aa=c[19236]|0;if((aa|0)<=1){ja=c[19252]|0;c[I>>2]=ja;sa=+(ja+1|0);h[9632]=sa;h[O>>3]=+h[9622]*2.0+1.0e-4;h[P>>3]=-1.0/sa;sa=+fM(O,P)*.9;h[O>>3]=.25;U=sa>=.9?.9:sa;h[P>>3]=U;sa=U<=.25?.25:U;h[9611]=sa;U=+h[k>>3]*sa;h[k>>3]=U;if(!(U>=0.0)){xa=-U}else{xa=U}if(!(xa>=+h[E>>3])){X=156;break}else{continue}}if((aa|0)>2){c[I>>2]=1;U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){ya=-U}else{ya=U}if(!(ya>=+h[E>>3])){X=165;break}else{continue}}else{c[I>>2]=c[19252];U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){za=-U}else{za=U}if(!(za>=+h[E>>3])){X=161;break}else{continue}}}if((X|0)==86){c[n>>2]=1;E=u+40|0;c[E>>2]=(c[E>>2]|0)+1;c[19266]=(c[I>>2]|0)-(c[J>>2]|0);c[J>>2]=c[I>>2];h[C>>3]=+h[k>>3];C=c[19252]|0;E=c[19228]|0;do{if((C|0)==(E|0)){X=88}else{S=u+8|0;if((c[I>>2]|0)==(c[S>>2]|0)){X=88;break}if((c[G>>2]|0)!=0){Aa=E;Ba=C;X=90;break}c[I>>2]=c[19230];za=+h[k>>3]*2.0;h[9624]=za;Ca=S;Da=za}}while(0);if((X|0)==88){c[G>>2]=1;Aa=c[19228]|0;Ba=c[19252]|0;X=90}if((X|0)==90){do{if((Ba|0)==(Aa|0)){Ea=Aa;X=104}else{G=c[I>>2]|0;C=u+8|0;if((G|0)==(c[C>>2]|0)){Fa=G;break}if((c[19230]|0)>=(c[K>>2]|0)|(c[19266]|0)==1){Fa=G;break}G=c[f>>2]|0;c[19216]=1;if((G|0)>=1){E=fa(c[19232]|0,Q)|0;S=1;while(1){V=S+ -1|0;h[r+(V<<3)>>3]=+h[s+(V<<3)>>3]- +h[q+(S+R+E<<3)>>3];if((S|0)<(G|0)){S=S+1|0}else{break}}c[19216]=G+1}za=1.0/+((c[I>>2]|0)+2|0);ya=za*+cw(f,r,l,0,0);h[9630]=ya;S=c[I>>2]|0;za=ya*+(S+2|0);if((S|0)>1){xa=+h[9627];E=xa<=za;if(+h[9637]<=(E?xa:za)){Ea=c[19228]|0;X=104;break}if(E){Fa=S;break}if((S|0)==(c[C>>2]|0)){Fa=S;break}}else{if(za>=+h[9627]*.5){Fa=S;break}}S=c[19230]|0;c[I>>2]=S;h[9622]=ya;Fa=S}}while(0);if((X|0)==104){c[I>>2]=Ea;h[9622]=+h[9629];Fa=Ea}h[9624]=+h[k>>3];ya=+(Fa+1|0);h[9632]=ya;h[O>>3]=+h[9622]*2.0+1.0e-4;h[P>>3]=-1.0/ya;ya=+fM(O,P);h[9611]=ya;do{if(ya<2.0){if(ya>1.0){Ga=+h[9624];break}else{h[O>>3]=.5;za=ya>=.9?.9:ya;h[P>>3]=za;xa=za<=.5?.5:za;h[9611]=xa;za=+h[k>>3]*xa;h[9624]=za;Ga=za;break}}else{za=+h[k>>3]*2.0;h[9624]=za;Ga=za}}while(0);Ca=u+8|0;Da=Ga}h[k>>3]=Da;do{if((c[J>>2]|0)!=(c[Ca>>2]|0)){k=c[f>>2]|0;c[19216]=1;if((k|0)<1){break}u=fa(c[19232]|0,Q)|0;P=1;while(1){h[q+(P+R+u<<3)>>3]=+h[s+(P+ -1<<3)>>3];if((P|0)<(k|0)){P=P+1|0}else{break}}c[19216]=k+1}}while(0);Ca=c[f>>2]|0;c[19216]=1;if((Ca|0)>=1){J=fa(c[19230]|0,Q)|0;P=1;while(1){u=q+(P+R+J<<3)|0;h[u>>3]=+h[s+(P+ -1<<3)>>3]+ +h[u>>3];if((P|0)<(Ca|0)){P=P+1|0}else{break}}c[19216]=Ca+1}Ca=c[19230]|0;c[19224]=2;if((Ca|0)<2){i=N;return 0}else{Ha=2}while(1){P=1-Ha+Ca|0;c[19218]=P;s=c[f>>2]|0;c[19216]=1;if((s|0)>=1){J=fa(P+1|0,Q)|0;u=fa(P,Q)|0;P=1;while(1){C=P+R|0;G=q+(C+u<<3)|0;h[G>>3]=+h[q+(C+J<<3)>>3]+ +h[G>>3];if((P|0)<(s|0)){P=P+1|0}else{break}}c[19216]=s+1}P=Ha+1|0;c[19224]=P;if((Ha|0)<(Ca|0)){Ha=P}else{break}}i=N;return 0}else if((X|0)==144){c[n>>2]=-8}else if((X|0)==146){c[n>>2]=-11}else if((X|0)==151){c[n>>2]=-7;Ha=(c[19250]>>31&-3)+ -7|0;c[n>>2]=Ha;c[n>>2]=(c[19236]|0)>2?-9:Ha}else if((X|0)==156){c[n>>2]=-6}else if((X|0)==161){c[n>>2]=-6}else if((X|0)==165){c[n>>2]=-6}ew(b,b,d,e,f,I,q,y)|0;i=N;return 0}function gw(b,d,e,f,g,j,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,W=0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+16|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;c[m>>2]=0;O=c[q+12>>2]|0;a:do{if((O|0)==2){c[s>>2]=0;c[19308]=0;h[9655]=+V(+(+h[t>>3]));P=c[b>>2]|0;c[19286]=1;b:do{if((P|0)>=1){Q=r;R=1;while(1){S=R+ -1|0;T=+h[e+(S<<3)>>3];h[N>>3]=T;if(!(T>=0.0)){U=-T}else{U=T}W=f+(S<<3)|0;T=+h[l>>3]*+h[W>>3];if(!(T>=0.0)){X=-T}else{X=T}T=U>=X?U:X;Y=+h[n+(S<<3)>>3];if(!(Y>=0.0)){Z=-Y}else{Z=Y}h[9652]=+h[9655]*(T>=Z?T:Z);h[N>>3]=+h[l>>3]*+h[W>>3];T=+hM(77216,N);h[9652]=T;W=(c[19286]|0)+ -1|0;S=e+(W<<3)|0;Y=+h[S>>3];_=T+Y-Y;h[9652]=_;h[9659]=+h[S>>3];$=f+(W<<3)|0;h[9663]=+h[$>>3];h[S>>3]=_+ +h[S>>3];h[$>>3]=+h[j>>3]*+h[9652]+ +h[$>>3];Rd[Q&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}_=1.0/+h[9652];h[9661]=_;$=c[b>>2]|0;c[19292]=1;S=c[19308]|0;if(($|0)>=1){Y=_;W=1;aa=0;while(1){h[p+(aa+S<<3)>>3]=(+h[o+(aa<<3)>>3]- +h[g+(aa<<3)>>3])*Y;if((W|0)>=($|0)){break}ba=W;Y=+h[9661];W=W+1|0;aa=ba}c[19292]=$+1}c[19308]=S+(c[b>>2]|0);aa=c[19286]|0;W=aa+ -1|0;h[e+(W<<3)>>3]=+h[9659];h[f+(W<<3)>>3]=+h[9663];R=aa+1|0;c[19286]=R;if((aa|0)>=(P|0)){break b}}i=y;return 0}}while(0);if((c[w>>2]|0)==0){ca=42;break}c[19308]=0;P=c[b>>2]|0;if((c[63984>>2]|0)==0){ca=42;break}R=zY(P*20|0)|0;Q=F;h[k>>3]=+h[d>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];Lu(14,1,77312,F);Q=E;h[k>>3]=+h[j>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];Lu(14,0,77336,E);Lu(14,1,77344,D);c[19290]=0;if((c[b>>2]|0)>0){Q=0;do{Y=+h[e+(Q<<3)>>3];c[C>>2]=Q+1;aa=C+4|0;h[k>>3]=Y;c[aa>>2]=c[k>>2];c[aa+4>>2]=c[k+4>>2];Lu(14,0,77352,C);Q=(c[19290]|0)+1|0;c[19290]=Q;}while((Q|0)<(c[b>>2]|0))}Vd[c[16120]&511](14);Lu(14,1,77408,B);c[19286]=1;if((P|0)>=1){Q=R+1|0;aa=c[19308]|0;W=1;do{ba=p+(W+ -1+aa<<3)|0;h[ba>>3]=+h[j>>3]+ +h[ba>>3];a[R]=0;a[Q]=0;c[19292]=1;ba=aa;da=0;while(1){Y=+h[p+(da+ba<<3)>>3];c[A>>2]=R;ea=A+4|0;h[k>>3]=Y;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];dc(R|0,77392,A|0)|0;ea=c[19292]|0;c[19292]=ea+1;if((ea|0)>=(P|0)){break}ba=c[19308]|0;da=ea}c[z>>2]=R;Lu(14,0,77400,z);da=c[19308]|0;ba=c[19286]|0;ea=p+(da+ -1+ba<<3)|0;h[ea>>3]=+h[ea>>3]- +h[j>>3];aa=da+(c[b>>2]|0)|0;c[19308]=aa;W=ba+1|0;c[19286]=W;}while((ba|0)<(P|0))}Vd[c[16120]&511](14);Vd[c[16120]&511](14);AY(R);ca=42}else if((O|0)==5){P=q+4|0;W=(c[P>>2]|0)+(c[q>>2]|0)|0;aa=W+1|0;c[19312]=aa;Q=c[b>>2]|0;c[19302]=(W|0)<(Q|0)?aa:Q;Q=c[q>>2]|0;c[19320]=aa+Q;c[19306]=Q+W;W=(c[b>>2]|0)/(aa|0)|0;c[19316]=W+1;aa=c[x>>2]|0;c[19314]=aa+ -1;c[19324]=aa+W;c[s>>2]=0;h[9655]=+V(+(+h[t>>3]));W=c[19302]|0;c[19288]=1;if((W|0)<1){ca=75;break}aa=r;Q=1;while(1){ba=c[b>>2]|0;da=c[19312]|0;c[19294]=Q;ea=(da|0)<0;c:do{if(ea?(Q|0)>=(ba|0):(Q|0)<=(ba|0)){ga=da;ha=Q;ia=Q;while(1){ja=(ia-ha|0)/(ga|0)|0;c[19290]=ja+1;ka=ia+ -1|0;la=e+(ka<<3)|0;h[p+((c[19314]|0)+ja<<3)>>3]=+h[la>>3];ma=f+(ka<<3)|0;h[p+((c[19324]|0)+ja<<3)>>3]=+h[ma>>3];Y=+h[la>>3];h[N>>3]=Y;if(!(Y>=0.0)){na=-Y}else{na=Y}Y=+h[l>>3]*+h[ma>>3];if(!(Y>=0.0)){oa=-Y}else{oa=Y}Y=na>=oa?na:oa;_=+h[n+(ka<<3)>>3];if(!(_>=0.0)){pa=-_}else{pa=_}h[9652]=+h[9655]*(Y>=pa?Y:pa);h[N>>3]=+h[l>>3]*+h[ma>>3];Y=+hM(77216,N);h[9652]=Y;ma=c[19294]|0;ka=ma+ -1|0;la=e+(ka<<3)|0;_=+h[la>>3];T=Y+_-_;h[9652]=T;h[la>>3]=+h[la>>3]+T;la=f+(ka<<3)|0;h[la>>3]=+h[j>>3]*+h[9652]+ +h[la>>3];la=ma+da|0;c[19294]=la;if(!(ea?(la|0)>=(ba|0):(la|0)<=(ba|0))){break c}ga=c[19312]|0;ha=c[19288]|0;ia=la}}}while(0);Rd[aa&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}ba=c[b>>2]|0;ea=c[19312]|0;da=c[19288]|0;c[19294]=da;ia=(ea|0)<0;d:do{if(ia?(da|0)>=(ba|0):(da|0)<=(ba|0)){ha=ea;ga=da;S=da;while(1){$=(S-ga|0)/(ha|0)|0;c[19290]=$+1;la=S+ -1|0;ma=e+(la<<3)|0;h[ma>>3]=+h[p+((c[19314]|0)+$<<3)>>3];T=+h[p+((c[19324]|0)+$<<3)>>3];$=f+(la<<3)|0;h[$>>3]=T;_=+h[ma>>3];h[N>>3]=_;if(!(_>=0.0)){qa=-_}else{qa=_}_=+h[l>>3]*T;if(!(_>=0.0)){ra=-_}else{ra=_}_=qa>=ra?qa:ra;T=+h[n+(la<<3)>>3];if(!(T>=0.0)){sa=-T}else{sa=T}h[9652]=+h[9655]*(_>=sa?_:sa);h[N>>3]=+h[l>>3]*+h[$>>3];_=+hM(77216,N);h[9652]=_;$=c[19294]|0;T=+h[e+($+ -1<<3)>>3];Y=_+T-T;h[9652]=Y;T=1.0/Y;h[9661]=T;la=$-(c[P>>2]|0)|0;ma=(la|0)>1?la:1;c[19296]=ma;la=c[b>>2]|0;ka=(c[q>>2]|0)+$|0;ja=(la|0)<=(ka|0)?la:ka;c[19298]=ja;ta=fa(c[19306]|0,$)|0;ua=ta-(c[q>>2]|0)|0;c[19300]=ua;c[19286]=ma;if((ma|0)<=(ja|0)){ta=~la;la=~ka;ka=~((ta|0)>(la|0)?ta:la);la=(ma|0)>(ka|0)?ma:ka;Y=T;ka=ma;while(1){ma=ka+ -1|0;h[p+(ma+ua<<3)>>3]=(+h[o+(ma<<3)>>3]- +h[g+(ma<<3)>>3])*Y;if((ka|0)>=(ja|0)){break}Y=+h[9661];ka=ka+1|0}c[19286]=la+1}ka=$+ea|0;c[19294]=ka;ja=c[19288]|0;if(!(ia?(ka|0)>=(ba|0):(ka|0)<=(ba|0))){va=ja;break d}ha=c[19312]|0;ga=ja;S=ka}}else{va=da}}while(0);da=va+1|0;c[19288]=da;if((va|0)<(W|0)){Q=da}else{ca=75;break a}}i=y;return 0}else if((O|0)==3){i=y;return 0}else if((O|0)==4){Q=c[q>>2]|0;W=q+4|0;P=c[W>>2]|0;aa=c[b>>2]|0;R=fa(P+1+(Q<<1)|0,aa)|0;c[19286]=1;if((R|0)>=1){da=fa(aa,P+(Q<<1)+1|0)|0;Q=(da|0)<1;P=1;while(1){h[p+(P+ -1<<3)>>3]=0.0;if((P|0)<(R|0)){P=P+1|0}else{break}}c[19286]=Q?2:da+1|0}Xd[u&7](d,e,f,g,p,j,l,n,v,w)|0;c[19320]=(c[W>>2]|0)+1+(c[q>>2]<<1);ca=75}else{P=c[b>>2]|0;R=fa(P,P)|0;c[19286]=1;if((R|0)!=0){P=(R|0)<1;aa=1;while(1){h[p+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(R|0)){aa=aa+1|0}else{break}}c[19286]=P?2:R+1|0}Xd[u&7](d,e,f,g,p,j,l,n,v,w)|0;if((c[w>>2]|0)==0){ca=42;break}c[19308]=0;aa=c[b>>2]|0;if((c[63984>>2]|0)==0){ca=42;break}W=zY(aa*20|0)|0;da=M;h[k>>3]=+h[d>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];Lu(14,1,77312,M);da=L;h[k>>3]=+h[j>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];Lu(14,0,77336,L);Lu(14,1,77344,K);c[19290]=0;if((c[b>>2]|0)>0){da=0;do{Y=+h[e+(da<<3)>>3];c[J>>2]=da+1;Q=J+4|0;h[k>>3]=Y;c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];Lu(14,0,77352,J);da=(c[19290]|0)+1|0;c[19290]=da;}while((da|0)<(c[b>>2]|0))}Vd[c[16120]&511](14);Lu(14,1,77368,I);c[19286]=1;if((aa|0)>=1){da=W+1|0;R=c[19308]|0;P=1;do{Q=p+(P+ -1+R<<3)|0;h[Q>>3]=+h[j>>3]+ +h[Q>>3];a[W]=0;a[da]=0;c[19292]=1;Q=R;ba=0;while(1){Y=+h[p+(ba+Q<<3)>>3];c[H>>2]=W;ia=H+4|0;h[k>>3]=Y;c[ia>>2]=c[k>>2];c[ia+4>>2]=c[k+4>>2];dc(W|0,77392,H|0)|0;ia=c[19292]|0;c[19292]=ia+1;if((ia|0)>=(aa|0)){break}Q=c[19308]|0;ba=ia}c[G>>2]=W;Lu(14,0,77400,G);ba=c[19308]|0;Q=c[19286]|0;ia=p+(ba+ -1+Q<<3)|0;h[ia>>3]=+h[ia>>3]- +h[j>>3];R=ba+(c[b>>2]|0)|0;c[19308]=R;P=Q+1|0;c[19286]=P;}while((Q|0)<(aa|0))}Vd[c[16120]&511](14);Vd[c[16120]&511](14);AY(W);ca=42}}while(0);if((ca|0)==42){ow(p,b,b,q+80|0,m)|0;i=y;return 0}else if((ca|0)==75){uw(p,77280,b,q,q+4|0,q+80|0,m)|0;i=y;return 0}return 0}function hw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[e+12>>2]|0;if((g|0)==4|(g|0)==5){h=e+4|0;c[19358]=(c[h>>2]|0)+1+(c[e>>2]<<1);vw(d,77432,a,e,h,e+80|0,b,77440)|0;i=f;return 0}else if((g|0)==3){i=f;return 0}else{sw(d,a,a,e+80|0,b,77440)|0;i=f;return 0}return 0}function iw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0;d=i;i=i+8|0;e=d;do{if(!(a[77448]&1)){a[77448]=1;jw(77496,77464,77544,77480,77528,77552,77536,77560)|0;h[9686]=+(c[19374]|0);f=c[19366]|0;h[9682]=+(f|0);if((c[19386]|0)==0){h[9684]=0.0;c[e>>2]=1-f;g=+gM(77488,e)}else{h[9684]=1.0;c[e>>2]=1-f;g=+gM(77488,e)*.5}h[9685]=g;h[9689]=g*+h[9686];h[9688]=+(c[19382]|0);h[9690]=+(c[19384]|0);j=+h[9694];h[9697]=j;k=1.0/+h[9695];if(!(k>=j)){break}h[9697]=k*(g+1.0)}}while(0);if((xw(b,77584,1,1)|0)!=0){g=+h[9685];h[9696]=g;l=g;i=d;return+l}if((xw(b,77592,1,1)|0)!=0){g=+h[9697];h[9696]=g;l=g;i=d;return+l}if((xw(b,77600,1,1)|0)!=0){g=+h[9686];h[9696]=g;l=g;i=d;return+l}if((xw(b,77608,1,1)|0)!=0){g=+h[9689];h[9696]=g;l=g;i=d;return+l}if((xw(b,77616,1,1)|0)!=0){g=+h[9682];h[9696]=g;l=g;i=d;return+l}if((xw(b,77624,1,1)|0)!=0){g=+h[9684];h[9696]=g;l=g;i=d;return+l}if((xw(b,77632,1,1)|0)!=0){g=+h[9688];h[9696]=g;l=g;i=d;return+l}if((xw(b,77640,1,1)|0)!=0){g=+h[9694];h[9696]=g;l=g;i=d;return+l}if((xw(b,77648,1,1)|0)!=0){g=+h[9690];h[9696]=g;l=g;i=d;return+l}if((xw(b,77656,1,1)|0)==0){l=+h[9696];i=d;return+l}else{g=+h[9695];h[9696]=g;l=g;i=d;return+l}return 0.0}function jw(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;m=i;i=i+24|0;n=m;o=m+8|0;p=m+16|0;if(a[77768]&1){q=78136;r=c[19534]|0;c[b>>2]=r;s=78072;t=c[19518]|0;c[d>>2]=t;u=78112;v=c[19528]|0;c[e>>2]=v;w=78120;x=+h[9765];h[f>>3]=x;y=78152;z=c[19538]|0;c[g>>2]=z;A=78200;B=+h[9775];h[j>>3]=B;C=78160;D=c[19540]|0;c[k>>2]=D;E=78208;F=+h[9776];h[l>>3]=F;i=m;return 0}a[77768]=1;h[9766]=0.0;h[9760]=1.0;h[9761]=2.0;kw(78136,78072,78112,78224)|0;h[9756]=+(c[19534]|0);c[n>>2]=0-(c[19518]|0);G=+gM(78048,n);h[9755]=G;h[9765]=G;H=+h[9761];h[9756]=H/3.0;I=+h[9760];J=I*.5;h[9763]=J;K=-J;h[o>>3]=K;h[9777]=+lw(78048,o);L=78216;h[9774]=+lw(L,L);h[o>>3]=K;h[9756]=+lw(78192,o);K=+lw(78048,78216);h[9756]=K;if(!(K>=0.0)){M=-K}else{M=K}K=M<G?G:M;h[9756]=K;h[9765]=1.0;M=+h[9766];if(K<1.0&K>M){N=K;while(1){h[9765]=N;h[o>>3]=N*J;K=H*H;h[p>>3]=N*N*H*K*K;K=+lw(o,p);h[9757]=K;h[o>>3]=-K;h[9757]=+lw(78104,o);K=+lw(78104,78056);h[9756]=K;h[o>>3]=-K;h[9757]=+lw(78104,o);K=+lw(78104,78056);h[9756]=K;if(N>K&K>M){N=K}else{O=N;break}}}else{O=1.0}if(G<O){h[9765]=G}G=I/+(c[19534]|0);h[9768]=G;h[9772]=I;c[19516]=1;p=1;O=I;do{h[o>>3]=O*G;O=+lw(o,78128);h[9772]=O;p=p+1|0;c[19516]=p;}while((p|0)<4);h[9755]=+lw(78080,78176);mw(78240,78080,78136)|0;h[o>>3]=-+h[9760];mw(78232,o,78136)|0;mw(78184,78040,78136)|0;h[o>>3]=-+h[9755];mw(78168,o,78136)|0;c[19524]=0;p=c[19560]|0;L=c[19558]|0;P=c[19546]|0;Q=(p|0)==(P|0);do{if((p|0)==(L|0)&(P|0)==(c[19542]|0)){if(Q){c[19538]=p;R=0;S=25;break}if((P-p|0)==3){c[19538]=p+ -1+(c[19518]|0);c[19524]=1;R=1;S=25;break}else{c[19538]=(p|0)<=(P|0)?p:P;a[77776]=1;S=26;break}}else{T=Q&(L|0)==(c[19542]|0);U=p-L|0;c[n>>2]=U;V=(((U|0)>-1?U:0-U|0)|0)==1;if(T){if(V){c[19538]=(p|0)>=(L|0)?p:L;R=0;S=25;break}else{c[19538]=(p|0)<=(L|0)?p:L;a[77776]=1;S=26;break}}T=c[19542]|0;U=(p|0)<=(L|0)?p:L;if(!(V&(P|0)==(T|0))){V=(U|0)<=(P|0)?U:P;c[n>>2]=V;c[19538]=(V|0)<=(T|0)?V:T;a[77776]=1;S=26;break}if((P-U|0)==3){c[19538]=((p|0)>=(L|0)?p:L)+ -1+(c[19518]|0);R=0;S=25;break}else{c[19538]=U;a[77776]=1;S=26;break}}}while(0);if((S|0)==25){if(a[77776]&1){S=26}else{W=R}}if((S|0)==26){a[77768]=0;cN(78248)|0;tM(78272,78152,4)|0;MM()|0;W=c[19524]|0}if((W|0)==0){X=(c[19556]|0)!=0|0}else{X=1}c[19524]=X;h[9775]=1.0;X=c[19538]|0;W=1-X|0;c[n>>2]=W;c[19516]=1;if((X|0)<=0){O=+h[9768];X=1;G=1.0;while(1){h[o>>3]=G*O;I=+lw(o,78128);h[9775]=I;n=X+1|0;c[19516]=n;if((X|0)<(W|0)){G=I;X=n}else{break}}}nw(78136,78072,78152,78096,78160,78208)|0;q=78136;r=c[19534]|0;c[b>>2]=r;s=78072;t=c[19518]|0;c[d>>2]=t;u=78112;v=c[19528]|0;c[e>>2]=v;w=78120;x=+h[9765];h[f>>3]=x;y=78152;z=c[19538]|0;c[g>>2]=z;A=78200;B=+h[9775];h[j>>3]=B;C=78160;D=c[19540]|0;c[k>>2]=D;E=78208;F=+h[9776];h[l>>3]=F;i=m;return 0}function kw(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;if(a[77664]&1){l=a[77736]&1;m=c[19436]|0;c[b>>2]=m;n=77712;o=c[19428]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=77760;r=c[19440]|0;c[f>>2]=r;i=g;return 0}a[77664]=1;h[9715]=1.0;h[9709]=1.0;h[9711]=1.0;s=1.0;do{s=s*2.0;h[9709]=s;h[9711]=+lw(77672,77720);h[j>>3]=-s;t=+lw(77688,j);h[9711]=t;}while(t==1.0);h[9710]=1.0;t=+lw(77672,77680);h[9711]=t;if(t==s){u=1.0;while(1){v=u*2.0;h[9710]=v;w=+lw(77672,77680);h[9711]=w;if(w==s){u=v}else{x=w;break}}}else{x=t}h[9716]=.25;h[9719]=x;h[j>>3]=-s;t=+lw(77688,j);h[9711]=t;y=~~(t+.25);c[19436]=y;t=+(y|0);h[9710]=t;u=t*.5;h[j>>3]=u;h[k>>3]=-t/100.0;h[9712]=+lw(j,k);w=+lw(77696,77672);h[9711]=w;z=w==s;a[77736]=z&1;h[j>>3]=u;h[k>>3]=t/100.0;h[9712]=+lw(j,k);w=+lw(77696,77672);h[9711]=w;if(z&w==s){a[77736]=0;A=0}else{A=z}h[j>>3]=u;w=+lw(j,77672);h[9713]=w;h[j>>3]=u;z=w==s&+lw(j,77752)>x;c[19440]=z?A&1:0;c[19428]=0;h[9709]=1.0;h[9711]=1.0;x=1.0;z=0;while(1){k=z+1|0;c[19428]=k;s=x*t;h[9709]=s;h[9711]=+lw(77672,77720);h[j>>3]=-s;w=+lw(77688,j);h[9711]=w;if(w==1.0){z=k;x=s}else{l=A;m=y;break}}c[b>>2]=m;n=77712;o=c[19428]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=77760;r=c[19440]|0;c[f>>2]=r;i=g;return 0}function lw(a,b){a=a|0;b=b|0;i=i;return+(+h[a>>3]+ +h[b>>3])}function mw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];h[9785]=g;j=1.0/+(c[d>>2]|0);h[9794]=j;h[9793]=0.0;c[a>>2]=1;h[f>>3]=g*j;k=+lw(f,78344);h[9787]=k;h[9789]=g;h[9790]=g;h[9791]=g;h[9792]=g;if(g==g&0.0==0.0){l=0;m=k}else{i=e;return 0}while(1){c[a>>2]=l;h[9785]=m;b=c[d>>2]|0;k=+(b|0);h[f>>3]=m/k;g=+lw(f,78344);h[9787]=g;h[f>>3]=g*k;k=+lw(f,78344);h[9789]=k;h[9791]=0.0;c[19572]=1;if((b|0)<1){n=0.0}else{o=1;p=0.0;while(1){q=g+p;if((o|0)<(b|0)){p=q;o=o+1|0}else{break}}h[9791]=q;c[19572]=b+1;n=q}h[f>>3]=m*j;p=+lw(f,78344);h[9788]=p;h[f>>3]=p/j;r=+lw(f,78344);h[9790]=r;h[9792]=0.0;o=c[d>>2]|0;c[19572]=1;if((o|0)<1){s=0.0}else{t=1;u=0.0;while(1){v=p+u;if((t|0)<(o|0)){u=v;t=t+1|0}else{break}}h[9792]=v;c[19572]=o+1;s=v}if(!(k==m&r==m&n==m&s==m)){break}l=(c[a>>2]|0)+ -1|0;m=g}i=e;return 0}function nw(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0;j=i;i=i+8|0;k=j;c[19596]=1;c[19604]=1;l=0-(c[d>>2]|0)|0;if((l|0)<2){m=2;n=l;o=2;p=1}else{l=1;q=2;while(1){c[19596]=q;r=l+1|0;c[19604]=r;s=q<<1;t=0-(c[d>>2]|0)|0;if((s|0)>(t|0)){break}else{q=s;l=r}}m=s;n=t;o=l+2|0;p=q}if((p|0)==(n|0)){c[19600]=n;u=n}else{c[19600]=m;c[19604]=o;u=m}m=c[d>>2]|0;o=((m+u|0)>(0-(p+m)|0)?p:u)<<1;c[19606]=o;u=o+(c[d>>2]|0)|0;d=u+ -1|0;c[f>>2]=d;do{if((((c[19604]|0)+1+(c[b>>2]|0)|0)%2|0|0)==1){if((c[a>>2]|0)!=2){v=d;break}o=u+ -2|0;c[f>>2]=o;v=o}else{v=d}}while(0);if((c[e>>2]|0)!=0){c[f>>2]=v+ -1}w=+(c[a>>2]|0);x=1.0/w;h[9801]=x;y=w+-1.0;h[9797]=y;h[9796]=0.0;v=c[b>>2]|0;c[19590]=1;do{if((v|0)<1){z=0.0}else{b=1;w=0.0;A=y;while(1){B=x*A;h[9797]=B;if(w<1.0){h[9799]=w}C=+lw(78368,78376);h[9796]=C;e=b+1|0;c[19590]=e;if((b|0)<(v|0)){b=e;w=C;A=B}else{break}}if(!(C>=1.0)){z=C;break}A=+h[9799];h[9796]=A;z=A}}while(0);v=c[f>>2]|0;c[19590]=1;if((v|0)<1){D=z;h[g>>3]=D;i=j;return 0}else{E=1;F=z}while(1){h[k>>3]=F*+(c[a>>2]|0);z=+lw(k,78432);h[9796]=z;f=E+1|0;c[19590]=f;if((E|0)<(v|0)){F=z;E=f}else{D=z;break}}h[g>>3]=D;i=j;return 0}function ow(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;l=c[b>>2]|0;b=~l;c[f>>2]=0;m=c[d>>2]|0;n=m+ -1|0;if((m|0)<2){o=m}else{c[19612]=1;m=1;do{c[19618]=m+1;c[j>>2]=(c[d>>2]|0)+1-m;p=pw(j,a+(m+b+(fa(m,l)|0)<<3)|0,78480)|0;q=c[19612]|0;r=p+ -1+q|0;c[19614]=r;c[e+(q+ -1<<2)>>2]=r;r=c[19614]|0;q=c[19612]|0;p=fa(q,l)|0;s=+h[a+(r+b+p<<3)>>3];do{if(s==0.0){c[f>>2]=q}else{if((r|0)==(q|0)){t=r}else{h[9808]=s;u=a+(q+b+p<<3)|0;h[a+(p+b+r<<3)>>3]=+h[u>>3];h[u>>3]=+h[9808];t=q}u=fa(t,l)|0;h[9808]=-1.0/+h[a+(t+b+u<<3)>>3];c[j>>2]=(c[d>>2]|0)-t;qw(j,78464,a+(t-l+u<<3)|0,78480)|0;u=c[d>>2]|0;c[j>>2]=u;v=c[19618]|0;c[19610]=v;if((v|0)>(u|0)){break}else{w=v}do{v=c[19614]|0;x=fa(w,l)|0;h[9808]=+h[a+(x+b+v<<3)>>3];y=c[19612]|0;if((v|0)==(y|0)){z=v}else{A=a+(y+b+x<<3)|0;h[a+(v+b+x<<3)>>3]=+h[A>>3];h[A>>3]=+h[9808];z=y}c[k>>2]=(c[d>>2]|0)-z;y=z+1|0;A=78480;rw(k,78464,a+((fa(z,l)|0)+b+y<<3)|0,A,a+(y+b+x<<3)|0,A)|0;A=c[19610]|0;w=A+1|0;c[19610]=w;}while((A|0)<(u|0))}}while(0);q=c[19612]|0;m=q+1|0;c[19612]=m;}while((q|0)<(n|0));o=c[d>>2]|0}c[e+(o+ -1<<2)>>2]=o;o=c[d>>2]|0;if(!(+h[a+(o+b+(fa(o,l)|0)<<3)>>3]==0.0)){i=g;return 0}c[f>>2]=o;i=g;return 0}function pw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}if((c[d>>2]|0)!=1){c[19710]=1;j=+h[b>>3];if(!(j>=0.0)){k=-j}else{k=j}h[9856]=k;l=(c[d>>2]|0)+1|0;c[19710]=l;m=c[a>>2]|0;c[19708]=2;if((m|0)<2){g=1;i=e;return g|0}else{n=2;o=k;p=l;q=1}while(1){k=+h[b+(p+ -1<<3)>>3];l=!(k>=0.0);if(l){r=-k}else{r=k}if(!(r<=o)){if(l){s=-k}else{s=k}h[9856]=s;t=s;u=n}else{t=o;u=q}l=p+(c[d>>2]|0)|0;c[19710]=l;a=n+1|0;c[19708]=a;if((n|0)<(m|0)){n=a;o=t;p=l;q=u}else{g=u;break}}i=e;return g|0}t=+h[b>>3];if(!(t>=0.0)){v=-t}else{v=t}h[9856]=v;c[19708]=2;if((f|0)<2){g=1;i=e;return g|0}else{w=v;x=2;y=1}while(1){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){z=-v}else{z=v}if(!(z<=w)){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){A=-v}else{A=v}h[9856]=A;B=A;C=x}else{B=w;C=y}if((x|0)<(f|0)){w=B;x=x+1|0;y=C}else{break}}c[19708]=f+1;g=C;i=e;return g|0}function qw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)!=1){e=fa(j,g)|0;c[19694]=1;k=(j|0)<0;if(k?(e|0)<2:(e|0)>0){l=1}else{i=f;return 0}do{m=d+(l+ -1<<3)|0;h[m>>3]=+h[b>>3]*+h[m>>3];l=l+j|0;}while(k?(l|0)>=(e|0):(l|0)<=(e|0));c[19694]=l;i=f;return 0}l=(g|0)%5|0;c[19696]=l;do{if((l|0)==0){n=c[a>>2]|0}else{c[19694]=1;if((l|0)>=1){g=1;while(1){e=d+(g+ -1<<3)|0;h[e>>3]=+h[b>>3]*+h[e>>3];if((g|0)<(l|0)){g=g+1|0}else{break}}c[19694]=l+1}g=c[a>>2]|0;if((g|0)>=5){n=g;break}i=f;return 0}}while(0);a=l+1|0;c[19694]=a;if((l|0)<(n|0)){o=a}else{i=f;return 0}do{a=d+(o+ -1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+2<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+3<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];o=o+5|0;}while((o|0)<=(n|0));c[19694]=o;i=f;return 0}function rw(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0;j=i;k=c[a>>2]|0;if((k|0)<1){i=j;return 0}l=+h[b>>3];if(l==0.0){i=j;return 0}do{if((c[e>>2]|0)==1){if((c[g>>2]|0)!=1){break}m=(k|0)%4|0;c[19680]=m;do{if((m|0)==0){n=c[a>>2]|0}else{c[19678]=1;if((m|0)>=1){o=l;p=1;q=0;while(1){r=f+(q<<3)|0;h[r>>3]=+h[r>>3]+o*+h[d+(q<<3)>>3];if((p|0)>=(m|0)){break}r=p;o=+h[b>>3];p=p+1|0;q=r}c[19678]=m+1}q=c[a>>2]|0;if((q|0)>=4){n=q;break}i=j;return 0}}while(0);q=m+1|0;c[19678]=q;if((m|0)<(n|0)){s=q}else{i=j;return 0}do{q=s+ -1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=f+(s<<3)|0;h[q>>3]=+h[q>>3]+ +h[b>>3]*+h[d+(s<<3)>>3];q=s+1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=s+2|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];s=s+4|0;}while((s|0)<=(n|0));c[19678]=s;i=j;return 0}}while(0);c[19682]=1;c[19684]=1;s=c[e>>2]|0;if((s|0)<0){n=(fa(1-(c[a>>2]|0)|0,s)|0)+1|0;c[19682]=n;t=n}else{t=1}n=c[g>>2]|0;if((n|0)<0){s=(fa(1-(c[a>>2]|0)|0,n)|0)+1|0;c[19684]=s;u=s}else{u=1}s=c[a>>2]|0;c[19678]=1;if((s|0)<1){i=j;return 0}else{v=l;w=1;x=u;y=t}while(1){t=f+(x+ -1<<3)|0;h[t>>3]=v*+h[d+(y+ -1<<3)>>3]+ +h[t>>3];t=y+(c[e>>2]|0)|0;c[19682]=t;u=x+(c[g>>2]|0)|0;c[19684]=u;a=w+1|0;c[19678]=a;if((w|0)>=(s|0)){break}v=+h[b>>3];y=t;x=u;w=a}i=j;return 0}function sw(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;j=i;i=i+8|0;k=j;l=c[b>>2]|0;b=~l;m=c[d>>2]|0;n=m+ -1|0;c[19630]=n;if((c[g>>2]|0)==0){if((m|0)>=2){c[19622]=1;m=1;do{g=m+ -1|0;o=c[e+(g<<2)>>2]|0;c[19624]=o;p=f+(o+ -1<<3)|0;h[9813]=+h[p>>3];if((o|0)!=(m|0)){o=f+(g<<3)|0;h[p>>3]=+h[o>>3];h[o>>3]=+h[9813]}c[k>>2]=(c[d>>2]|0)-m;o=78480;rw(k,78504,a+(m-l+(fa(m,l)|0)<<3)|0,o,f+(m<<3)|0,o)|0;o=c[19622]|0;m=o+1|0;c[19622]=m;}while((o|0)<(n|0))}m=c[d>>2]|0;c[19628]=1;if((m|0)<1){i=j;return 0}else{q=1}do{o=1-q+(c[d>>2]|0)|0;c[19622]=o;p=fa(o,l)|0;g=o+ -1|0;r=f+(g<<3)|0;s=+h[r>>3]/+h[a+(o+b+p<<3)>>3];h[r>>3]=s;h[9813]=-s;c[k>>2]=g;g=78480;rw(k,78504,a+(p-l<<3)|0,g,f,g)|0;g=c[19628]|0;q=g+1|0;c[19628]=q;}while((g|0)<(m|0));i=j;return 0}m=c[d>>2]|0;c[19622]=1;if((m|0)<1){t=n}else{n=1;do{c[k>>2]=n+ -1;q=78480;s=+tw(k,a+((fa(n,l)|0)-l<<3)|0,q,f,q);h[9813]=s;q=c[19622]|0;g=f+(q+ -1<<3)|0;h[g>>3]=(+h[g>>3]-s)/+h[a+(q+b+(fa(q,l)|0)<<3)>>3];n=q+1|0;c[19622]=n;}while((q|0)<(m|0));t=c[19630]|0}if((t|0)<1){i=j;return 0}c[19628]=1;m=1;do{n=(c[d>>2]|0)-m|0;c[19622]=n;c[k>>2]=(c[d>>2]|0)-n;b=78480;s=+tw(k,a+(n-l+(fa(n,l)|0)<<3)|0,b,f+(n<<3)|0,b);b=c[19622]|0;n=b+ -1|0;q=f+(n<<3)|0;h[q>>3]=s+ +h[q>>3];g=c[e+(n<<2)>>2]|0;c[19624]=g;if((g|0)!=(b|0)){b=f+(g+ -1<<3)|0;h[9813]=+h[b>>3];h[b>>3]=+h[q>>3];h[q>>3]=+h[9813]}q=c[19628]|0;m=q+1|0;c[19628]=m;}while((q|0)<(t|0));i=j;return 0}function tw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0;g=i;h[9853]=0.0;j=c[a>>2]|0;if((j|0)<1){k=0.0;i=g;return+k}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}l=(j|0)%5|0;c[19700]=l;do{if((l|0)==0){m=c[a>>2]|0;n=0.0}else{c[19698]=1;if((l|0)<1){o=0.0}else{p=0.0;q=1;while(1){r=q+ -1|0;s=p+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3];h[9853]=s;if((q|0)<(l|0)){q=q+1|0;p=s}else{break}}c[19698]=l+1;o=s}q=c[a>>2]|0;if((q|0)<5){k=o}else{m=q;n=o;break}i=g;return+k}}while(0);q=l+1|0;c[19698]=q;if((l|0)<(m|0)){t=n;u=q}else{k=n;i=g;return+k}do{q=u+ -1|0;r=u+1|0;v=u+2|0;w=u+3|0;t=t+ +h[b+(q<<3)>>3]*+h[e+(q<<3)>>3]+ +h[b+(u<<3)>>3]*+h[e+(u<<3)>>3]+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3]+ +h[b+(v<<3)>>3]*+h[e+(v<<3)>>3]+ +h[b+(w<<3)>>3]*+h[e+(w<<3)>>3];h[9853]=t;u=u+5|0;}while((u|0)<=(m|0));c[19698]=u;k=t;i=g;return+k}}while(0);c[19702]=1;c[19704]=1;u=c[d>>2]|0;if((u|0)<0){m=(fa(1-(c[a>>2]|0)|0,u)|0)+1|0;c[19702]=m;x=m}else{x=1}m=c[f>>2]|0;if((m|0)<0){u=(fa(1-(c[a>>2]|0)|0,m)|0)+1|0;c[19704]=u;y=u}else{y=1}u=c[a>>2]|0;c[19698]=1;if((u|0)<1){k=0.0;i=g;return+k}else{z=1;A=0.0;B=y;C=x}while(1){t=A+ +h[b+(C+ -1<<3)>>3]*+h[e+(B+ -1<<3)>>3];h[9853]=t;x=C+(c[d>>2]|0)|0;c[19702]=x;y=B+(c[f>>2]|0)|0;c[19704]=y;a=z+1|0;c[19698]=a;if((z|0)<(u|0)){C=x;B=y;A=t;z=a}else{k=t;break}}i=g;return+k}function uw(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+8|0;l=k;m=c[b>>2]|0;b=~m;c[19640]=(c[e>>2]|0)+1+(c[f>>2]|0);c[j>>2]=0;n=(c[f>>2]|0)+2|0;c[19646]=n;o=c[d>>2]|0;p=c[19640]|0;q=(o|0)>(p|0)?p:o;o=q+ -1|0;c[19648]=o;do{if((q|0)>(n|0)){c[19656]=n;if((n|0)>(o|0)){break}else{r=n}while(1){s=1-r+p|0;c[19644]=s;t=c[e>>2]|0;c[19632]=s;if((s|0)<=(t|0)){u=s;while(1){h[a+(u+b+(fa(r,m)|0)<<3)>>3]=0.0;if((u|0)<(t|0)){u=u+1|0}else{break}}c[19632]=t+1}u=r+1|0;c[19656]=u;if((r|0)<(o|0)){r=u}else{break}}c[l>>2]=t}}while(0);c[19656]=o;c[19654]=0;t=c[d>>2]|0;r=t+ -1|0;if((t|0)<2){v=t}else{c[19636]=1;t=o;o=1;while(1){c[19658]=o+1;p=t+1|0;c[19656]=p;n=c[d>>2]|0;do{if((t|0)<(n|0)){q=c[e>>2]|0;if((q|0)<1){w=n;break}c[l>>2]=q;c[19632]=1;u=fa(p,m)|0;s=1;while(1){h[a+(s+b+u<<3)>>3]=0.0;if((s|0)<(q|0)){s=s+1|0}else{break}}c[19632]=q+1;w=c[d>>2]|0}else{w=n}}while(0);n=c[e>>2]|0;p=w-o|0;s=(n|0)<=(p|0)?n:p;c[19650]=s;c[l>>2]=s+1;s=pw(l,a+((c[19640]|0)+b+(fa(o,m)|0)<<3)|0,78480)|0;p=s+ -1|0;c[19638]=p+(c[19640]|0);s=c[19636]|0;c[g+(s+ -1<<2)>>2]=p+s;s=c[19638]|0;p=c[19636]|0;n=fa(p,m)|0;x=+h[a+(s+b+n<<3)>>3];a:do{if(x==0.0){c[j>>2]=p}else{u=c[19640]|0;if((s|0)==(u|0)){y=s}else{h[9821]=x;z=a+(u+b+n<<3)|0;h[a+(n+b+s<<3)>>3]=+h[z>>3];h[z>>3]=+h[9821];y=u}h[9821]=-1.0/+h[a+(y+b+n<<3)>>3];qw(78600,78568,a+(y-m+n<<3)|0,78480)|0;u=c[19654]|0;z=(c[g+((c[19636]|0)+ -1<<2)>>2]|0)+(c[f>>2]|0)|0;A=(u|0)>=(z|0)?u:z;c[l>>2]=A;z=c[d>>2]|0;u=(A|0)>(z|0)?z:A;c[19654]=u;A=c[19640]|0;c[19652]=A;z=c[19658]|0;if((u|0)<(z|0)){break}c[l>>2]=u;c[19634]=z;B=z;z=A;while(1){A=(c[19638]|0)+ -1|0;c[19638]=A;C=z+ -1|0;c[19652]=C;D=fa(B,m)|0;E=a+(A+b+D<<3)|0;h[9821]=+h[E>>3];if((A|0)==(C|0)){F=A}else{A=a+(C+b+D<<3)|0;h[E>>3]=+h[A>>3];h[A>>3]=+h[9821];F=C}C=78480;rw(78600,78568,a+((c[19640]|0)-m+(fa(c[19636]|0,m)|0)<<3)|0,C,a+(F-m+D<<3)|0,C)|0;C=c[19634]|0;D=C+1|0;c[19634]=D;if((C|0)>=(u|0)){break a}B=D;z=c[19652]|0}}}while(0);n=c[19636]|0;s=n+1|0;c[19636]=s;if((n|0)>=(r|0)){break}t=c[19656]|0;o=s}v=c[d>>2]|0}c[g+(v+ -1<<2)>>2]=v;v=c[d>>2]|0;if(!(+h[a+((c[19640]|0)+b+(fa(v,m)|0)<<3)>>3]==0.0)){i=k;return 0}c[j>>2]=v;i=k;return 0}function vw(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0;l=i;m=c[b>>2]|0;b=~m;n=(c[f>>2]|0)+1+(c[e>>2]|0)|0;c[19664]=n;f=c[d>>2]|0;o=f+ -1|0;c[19676]=o;if((c[k>>2]|0)==0){if(!((c[e>>2]|0)==0|(f|0)<2)){c[19660]=1;f=1;do{k=c[e>>2]|0;p=(c[d>>2]|0)-f|0;c[19674]=(k|0)<=(p|0)?k:p;p=f+ -1|0;k=c[g+(p<<2)>>2]|0;c[19662]=k;q=j+(k+ -1<<3)|0;h[9833]=+h[q>>3];if((k|0)!=(f|0)){k=j+(p<<3)|0;h[q>>3]=+h[k>>3];h[k>>3]=+h[9833]}k=78480;rw(78696,78664,a+((c[19664]|0)-m+(fa(f,m)|0)<<3)|0,k,j+(f<<3)|0,k)|0;k=c[19660]|0;f=k+1|0;c[19660]=f;}while((k|0)<(o|0))}f=c[d>>2]|0;c[19668]=1;if((f|0)<1){i=l;return 0}else{r=1}do{k=1-r+(c[d>>2]|0)|0;c[19660]=k;q=c[19664]|0;p=fa(k,m)|0;s=j+(k+ -1<<3)|0;t=+h[s>>3]/+h[a+(q+b+p<<3)>>3];h[s>>3]=t;s=((k|0)<=(q|0)?k:q)+ -1|0;c[19674]=s;u=q-s|0;c[19670]=u;q=k-s|0;c[19672]=q;h[9833]=-t;s=78480;rw(78696,78664,a+(u+b+p<<3)|0,s,j+(q+ -1<<3)|0,s)|0;s=c[19668]|0;r=s+1|0;c[19668]=r;}while((s|0)<(f|0));i=l;return 0}f=c[d>>2]|0;c[19660]=1;if((f|0)<1){v=n;w=o}else{o=n;n=1;do{r=((n|0)<=(o|0)?n:o)+ -1|0;c[19674]=r;s=o-r|0;c[19670]=s;q=n-r|0;c[19672]=q;r=78480;t=+tw(78696,a+((fa(n,m)|0)+b+s<<3)|0,r,j+(q+ -1<<3)|0,r);h[9833]=t;r=c[19660]|0;q=j+(r+ -1<<3)|0;o=c[19664]|0;h[q>>3]=(+h[q>>3]-t)/+h[a+((fa(r,m)|0)+b+o<<3)>>3];n=r+1|0;c[19660]=n;}while((r|0)<(f|0));v=o;w=c[19676]|0}if((c[e>>2]|0)==0|(w|0)<1){i=l;return 0}c[19668]=1;o=v;v=1;while(1){f=(c[d>>2]|0)-v|0;c[19660]=f;n=c[e>>2]|0;b=(c[d>>2]|0)-f|0;c[19674]=(n|0)<=(b|0)?n:b;b=78480;t=+tw(78696,a+(o-m+(fa(f,m)|0)<<3)|0,b,j+(f<<3)|0,b);b=c[19660]|0;f=b+ -1|0;n=j+(f<<3)|0;h[n>>3]=t+ +h[n>>3];r=c[g+(f<<2)>>2]|0;c[19662]=r;if((r|0)!=(b|0)){b=j+(r+ -1<<3)|0;h[9833]=+h[b>>3];h[b>>3]=+h[n>>3];h[n>>3]=+h[9833]}n=c[19668]|0;b=n+1|0;c[19668]=b;if((n|0)>=(w|0)){break}o=c[19664]|0;v=b}i=l;return 0}function ww(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}k=(j|0)%7|0;c[19688]=k;do{if((k|0)==0){l=c[a>>2]|0}else{c[19686]=1;if((k|0)>=1){m=1;while(1){n=m+ -1|0;h[e+(n<<3)>>3]=+h[b+(n<<3)>>3];if((m|0)<(k|0)){m=m+1|0}else{break}}c[19686]=k+1}m=c[a>>2]|0;if((m|0)>=7){l=m;break}i=g;return 0}}while(0);m=k+1|0;c[19686]=m;if((k|0)<(l|0)){o=m}else{i=g;return 0}do{m=o+ -1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];h[e+(o<<3)>>3]=+h[b+(o<<3)>>3];m=o+1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+2|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+3|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+4|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+5|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];o=o+7|0;}while((o|0)<=(l|0));c[19686]=o;i=g;return 0}}while(0);c[19690]=1;c[19692]=1;o=c[d>>2]|0;if((o|0)<0){l=(fa(1-(c[a>>2]|0)|0,o)|0)+1|0;c[19690]=l;p=l}else{p=1}l=c[f>>2]|0;if((l|0)<0){o=(fa(1-(c[a>>2]|0)|0,l)|0)+1|0;c[19692]=o;q=o}else{q=1}o=c[a>>2]|0;c[19686]=1;if((o|0)<1){i=g;return 0}else{r=1;s=q;t=p}while(1){h[e+(s+ -1<<3)>>3]=+h[b+(t+ -1<<3)>>3];p=t+(c[d>>2]|0)|0;c[19690]=p;q=s+(c[f>>2]|0)|0;c[19692]=q;a=r+1|0;c[19686]=a;if((r|0)<(o|0)){t=p;s=q;r=a}else{break}}i=g;return 0}function xw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;if((a[b]|0)==(a[e]|0)){h=1;i=g;return h|0}a[78872]=1;f=d[b]|0;c[19714]=f;b=d[e]|0;c[19716]=b;if((f+ -97|0)>>>0<26){e=f+ -32|0;c[19714]=e;j=e}else{j=f}if((b+ -97|0)>>>0<26){f=b+ -32|0;c[19716]=f;k=f}else{k=b}h=(j|0)==(k|0)|0;i=g;return h|0}function yw(b,d,e,f,g,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0.0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;r=i;if((c[j>>2]|0)>0){c[88404>>2]=6;cN(88400)|0;tM(89144,j,4)|0;MM()|0}c[q>>2]=0;s=(c[e>>2]|0)<1?3:0;c[q>>2]=s;t=(c[l>>2]|0)<1?4:s;c[q>>2]=t;if((t|0)!=0){i=r;return 0}c[21402]=0;c[22008]=0;c[21996]=0;a[88008]=0;t=c[e>>2]|0;c[20956]=1;do{if((t|0)>=1){s=0;u=1;while(1){if(+h[d+(u+ -1<<3)>>3]!=0.0){v=s+1|0;c[21402]=v;w=v}else{w=s}if((u|0)<(t|0)){s=w;u=u+1|0}else{break}}c[20956]=t+1;if((w|0)<=0){break}u=p;s=f;a:while(1){v=c[e>>2]|0;c[20956]=1;if((v|0)>=1){x=1;while(1){h[80296+((x*21|0)+ -21<<3)>>3]=+h[b+(x+ -1<<3)>>3];if((x|0)<(v|0)){x=x+1|0}else{break}}c[20956]=v+1}c[22e3]=2;x=c[e>>2]|0;c[20956]=1;if((x|0)>=1){y=2;z=1;while(1){A=z+ -1|0;B=d+(A<<3)|0;C=+h[B>>3];if(C==0.0){D=y}else{E=c[e>>2]|0;c[20958]=1;if((E|0)<1){F=C}else{G=1;while(1){h[80296+((G*21|0)+ -22+y<<3)>>3]=+h[b+(G+ -1<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[20958]=E+1;F=+h[B>>3]}h[80296+((z*21|0)+ -22+y<<3)>>3]=+h[b+(A<<3)>>3]+F;G=y+1|0;c[22e3]=G;D=G}G=z+1|0;c[20956]=G;if((z|0)<(x|0)){y=D;z=G}else{break}}}z=c[21402]|0;y=z+1|0;c[21398]=y;c[20956]=1;if((z|0)>=0){z=1;do{x=c[e>>2]|0;c[20958]=1;if((x|0)>=1){v=1;while(1){h[b+(v+ -1<<3)>>3]=+h[80296+((v*21|0)+ -22+z<<3)>>3];if((v|0)<(x|0)){v=v+1|0}else{break}}c[20958]=x+1}$d[u&63](e,b,83656+(z+ -1<<3)|0)|0;c[22008]=(c[22008]|0)+1;if((c[j>>2]|0)>=1){c[88428>>2]=6;cN(88424)|0;tM(89144,88032,4)|0;tM(89144,83656+((c[20956]|0)+ -1<<3)|0,8)|0;v=c[e>>2]|0;c[20958]=1;if((v|0)>=1){A=1;do{tM(89144,b+(A+ -1<<3)|0,8)|0;B=c[20958]|0;A=B+1|0;c[20958]=A;}while((B|0)<(v|0))}MM()|0}v=c[20956]|0;z=v+1|0;c[20956]=z;}while((v|0)<(y|0))}y=c[21996]|0;b:while(1){c[21996]=y+1;c[21908]=1;c[21904]=1;C=+h[10457];h[10953]=C;h[10955]=C;z=c[21398]|0;c[20956]=2;if((z|0)<2){H=1}else{I=C;K=C;v=1;A=2;while(1){C=+h[83656+(A+ -1<<3)>>3];do{if(!(C<=K)){c[21908]=A;L=+h[83656+(A+ -1<<3)>>3];h[10953]=L;M=I;N=L;O=A}else{if(C>=I){M=I;N=K;O=v;break}c[21904]=A;L=+h[83656+(A+ -1<<3)>>3];h[10955]=L;M=L;N=K;O=v}}while(0);if((A|0)<(z|0)){I=M;K=N;v=O;A=A+1|0}else{break}}c[20956]=z+1;H=O}A=c[e>>2]|0;c[20956]=1;if((A|0)>=1){v=1;while(1){h[85776+(v+ -1<<3)>>3]=0.0;if((v|0)<(A|0)){v=v+1|0}else{break}}c[20956]=A+1}c[20956]=1;if((z|0)>=1){v=1;do{do{if((v|0)==(H|0)){P=H}else{x=c[e>>2]|0;c[20958]=1;if((x|0)<1){P=v;break}else{Q=1}while(1){B=85776+(Q+ -1<<3)|0;h[B>>3]=+h[80296+((Q*21|0)+ -22+v<<3)>>3]+ +h[B>>3];if((Q|0)<(x|0)){Q=Q+1|0}else{break}}c[20958]=x+1;P=v}}while(0);v=P+1|0;c[20956]=v;}while((P|0)<(z|0))}z=c[e>>2]|0;c[20958]=1;if((z|0)>=1){K=+(c[21402]|0);v=1;while(1){A=85776+(v+ -1<<3)|0;h[A>>3]=+h[A>>3]/K;if((v|0)<(z|0)){v=v+1|0}else{break}}c[20958]=z+1}v=c[e>>2]|0;c[20956]=1;if((v|0)>=1){A=1;while(1){B=A+ -1|0;K=+h[85776+(B<<3)>>3];h[88056+(B<<3)>>3]=K+(K- +h[80296+((A*21|0)+ -22+H<<3)>>3]);if((A|0)<(v|0)){A=A+1|0}else{break}}c[20956]=v+1}$d[u&63](e,88056,88048)|0;A=(c[22008]|0)+1|0;c[22008]=A;z=c[j>>2]|0;do{if((z|0)>=1){if(((A|0)%(z|0)|0|0)!=0){break}c[88452>>2]=6;cN(88448)|0;tM(89144,88032,4)|0;tM(89144,88048,8)|0;B=c[e>>2]|0;c[20958]=1;if((B|0)>=1){E=1;do{tM(89144,88056+(E+ -1<<3)|0,8)|0;G=c[20958]|0;E=G+1|0;c[20958]=E;}while((G|0)<(B|0))}MM()|0}}while(0);K=+h[11006];c:do{if(!(K>=+h[10955])){z=c[e>>2]|0;c[20956]=1;if((z|0)>=1){A=1;while(1){v=A+ -1|0;I=+h[85776+(v<<3)>>3];h[88224+(v<<3)>>3]=I+(+h[88056+(v<<3)>>3]-I)*2.0;if((A|0)<(z|0)){A=A+1|0}else{break}}c[20956]=z+1}$d[u&63](e,88224,88216)|0;A=(c[22008]|0)+1|0;c[22008]=A;v=c[j>>2]|0;do{if((v|0)>=1){if(((A|0)%(v|0)|0|0)!=0){break}c[88476>>2]=6;cN(88472)|0;tM(89144,88032,4)|0;tM(89144,88216,8)|0;B=c[e>>2]|0;c[20958]=1;if((B|0)>=1){E=1;do{tM(89144,88224+(E+ -1<<3)|0,8)|0;G=c[20958]|0;E=G+1|0;c[20958]=E;}while((G|0)<(B|0))}MM()|0}}while(0);I=+h[11027];if(I>=+h[10955]){R=118;break}v=c[e>>2]|0;c[20956]=1;A=c[21908]|0;if((v|0)>=1){z=1;while(1){B=z+ -1|0;if(+h[d+(B<<3)>>3]!=0.0){h[80296+((z*21|0)+ -22+A<<3)>>3]=+h[88224+(B<<3)>>3]}if((z|0)<(v|0)){z=z+1|0}else{break}}c[20956]=v+1}h[83656+(A+ -1<<3)>>3]=I}else{z=c[21398]|0;c[20956]=1;if((z|0)>=1){B=c[21908]|0;E=1;while(1){if((E|0)!=(B|0)){if(K<+h[83656+(E+ -1<<3)>>3]){R=118;break c}}x=E+1|0;c[20956]=x;if((E|0)<(z|0)){E=x}else{break}}}if(!(K>+h[10953])){E=c[e>>2]|0;c[20956]=1;z=c[21908]|0;if((E|0)>=1){B=1;while(1){A=B+ -1|0;if(+h[d+(A<<3)>>3]!=0.0){h[80296+((B*21|0)+ -22+z<<3)>>3]=+h[88056+(A<<3)>>3]}if((B|0)<(E|0)){B=B+1|0}else{break}}c[20956]=E+1}h[10953]=K;h[83656+(z+ -1<<3)>>3]=K}B=c[e>>2]|0;c[20956]=1;if((B|0)>=1){A=c[21908]|0;v=1;while(1){x=v+ -1|0;h[88224+(x<<3)>>3]=+h[80296+((v*21|0)+ -22+A<<3)>>3]*.5+ +h[85776+(x<<3)>>3]*.5;if((v|0)<(B|0)){v=v+1|0}else{break}}c[20956]=B+1}$d[u&63](e,88224,88216)|0;v=(c[22008]|0)+1|0;c[22008]=v;A=c[j>>2]|0;do{if((A|0)>=1){if(((v|0)%(A|0)|0|0)!=0){break}c[88500>>2]=6;cN(88496)|0;tM(89144,88032,4)|0;tM(89144,88216,8)|0;z=c[e>>2]|0;c[20958]=1;if((z|0)>=1){E=1;do{tM(89144,88224+(E+ -1<<3)|0,8)|0;x=c[20958]|0;E=x+1|0;c[20958]=E;}while((x|0)<(z|0))}MM()|0}}while(0);I=+h[11027];if(!(I>+h[10953])){A=c[e>>2]|0;c[20956]=1;v=c[21908]|0;if((A|0)>=1){B=1;while(1){z=B+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[80296+((B*21|0)+ -22+v<<3)>>3]=+h[88224+(z<<3)>>3]}if((B|0)<(A|0)){B=B+1|0}else{break}}c[20956]=A+1}h[83656+(v+ -1<<3)>>3]=I;break}B=c[21398]|0;c[20956]=1;if((B|0)<1){break}else{S=1}do{z=c[21904]|0;do{if((S|0)!=(z|0)){E=c[e>>2]|0;c[20958]=1;if((E|0)>=1){x=S+ -22|0;G=1;while(1){if(+h[d+(G+ -1<<3)>>3]!=0.0){T=(G*21|0)+ -22|0;U=80296+(T+S<<3)|0;h[U>>3]=(+h[U>>3]+ +h[80296+(T+z<<3)>>3])*.5}h[b+(G+ -1<<3)>>3]=+h[80296+(x+(G*21|0)<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[20958]=E+1}$d[u&63](e,b,83656+(S+ -1<<3)|0)|0;G=(c[22008]|0)+1|0;c[22008]=G;x=c[j>>2]|0;if((x|0)<1){break}if(((G|0)%(x|0)|0|0)!=0){break}c[88524>>2]=6;cN(88520)|0;tM(89144,88032,4)|0;tM(89144,83656+((c[20956]|0)+ -1<<3)|0,8)|0;x=c[e>>2]|0;c[20958]=1;if((x|0)>=1){G=1;do{tM(89144,b+(G+ -1<<3)|0,8)|0;T=c[20958]|0;G=T+1|0;c[20958]=G;}while((T|0)<(x|0))}MM()|0}}while(0);z=c[20956]|0;S=z+1|0;c[20956]=S;}while((z|0)<(B|0))}}while(0);if((R|0)==118){R=0;B=c[e>>2]|0;c[20956]=1;v=c[21908]|0;if((B|0)>=1){A=1;while(1){z=A+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[80296+((A*21|0)+ -22+v<<3)>>3]=+h[88056+(z<<3)>>3]}if((A|0)<(B|0)){A=A+1|0}else{break}}c[20956]=B+1}h[83656+(v+ -1<<3)>>3]=+h[11006]}A=c[21996]|0;if((A|0)<(c[l>>2]|0)){y=A;continue}h[10956]=0.0;h[11002]=0.0;A=c[21398]|0;c[20956]=1;z=(A|0)<1;do{if(z){K=+(A|0);h[11002]=0.0/K;c[20956]=1;W=K;X=0.0}else{x=1;K=0.0;while(1){Y=+h[83656+(x+ -1<<3)>>3]+K;if((x|0)<(A|0)){K=Y;x=x+1|0}else{break}}K=+(A|0);I=Y/K;h[11002]=I;c[20956]=1;if(z){W=K;X=0.0;break}else{Z=1;_=0.0}while(1){C=+h[83656+(Z+ -1<<3)>>3]-I;$=_+C*C;if((Z|0)<(A|0)){_=$;Z=Z+1|0}else{break}}h[10956]=$;c[20956]=A+1;W=K;X=$}}while(0);I=+V(+(X/W));h[10956]=I;do{if(!(I<=+h[k>>3])){if((c[22008]|0)>(c[g>>2]|0)){break}a[88008]=0;c[21996]=0;y=0;continue b}}while(0);v=c[e>>2]|0;c[20956]=1;if((v|0)>=1){B=1;while(1){x=B+ -1|0;if(!(+h[d+(x<<3)>>3]==0.0)){h[b+(x<<3)>>3]=0.0;c[20958]=1;if(z){aa=b+(B+ -1<<3)|0}else{x=B*21|0;G=b+(B+ -1<<3)|0;I=+h[G>>3];E=1;while(1){C=+h[80296+(E+ -22+x<<3)>>3]+I;h[G>>3]=C;if((E|0)<(A|0)){E=E+1|0;I=C}else{break}}c[20958]=A+1;aa=G}h[aa>>3]=+h[aa>>3]/W}if((B|0)<(v|0)){B=B+1|0}else{break}}c[20956]=v+1}$d[u&63](e,b,f)|0;B=(c[22008]|0)+1|0;c[22008]=B;A=c[j>>2]|0;do{if((A|0)<1){ba=B}else{if(((B|0)%(A|0)|0|0)!=0){ba=B;break}c[88548>>2]=6;cN(88544)|0;tM(89144,88032,4)|0;tM(89144,s,8)|0;z=c[e>>2]|0;c[20958]=1;if((z|0)>=1){E=1;do{tM(89144,b+(E+ -1<<3)|0,8)|0;x=c[20958]|0;E=x+1|0;c[20958]=E;}while((x|0)<(z|0))}MM()|0;ba=c[22008]|0}}while(0);if((ba|0)>(c[g>>2]|0)){R=150;break a}if((c[j>>2]|0)>=0){c[88668>>2]=6;cN(88664)|0;MM()|0;c[88692>>2]=6;cN(88688)|0;B=c[e>>2]|0;c[20956]=1;if((B|0)>=1){A=1;do{tM(89144,b+(A+ -1<<3)|0,8)|0;v=c[20956]|0;A=v+1|0;c[20956]=A;}while((v|0)<(B|0))}MM()|0;c[88716>>2]=6;cN(88712)|0;tM(89144,s,8)|0;MM()|0}if(a[88008]&1){I=+h[11002];K=+h[11048]-I;if(!(K>=0.0)){ca=-K}else{ca=K}if(!(ca>=+h[k>>3])){break}else{da=I}}else{a[88008]=1;da=+h[11002]}h[11048]=da;c[21996]=0;y=0}if((c[j>>2]|0)>=0){c[88740>>2]=6;cN(88736)|0;tM(89144,88032,4)|0;MM()|0;c[88764>>2]=6;cN(88760)|0;y=c[e>>2]|0;c[20956]=1;if((y|0)>=1){B=1;do{tM(89144,b+(B+ -1<<3)|0,8)|0;A=c[20956]|0;B=A+1|0;c[20956]=B;}while((A|0)<(y|0))}MM()|0;c[88788>>2]=6;cN(88784)|0;tM(89144,s,8)|0;MM()|0}if((c[m>>2]|0)<1){R=312;break}if((c[j>>2]|0)>-1){c[88812>>2]=6;cN(88808)|0;MM()|0}h[10955]=+h[f>>3];c[22010]=0;y=c[21398]|0;c[20956]=1;if((y|0)>=1){B=1;while(1){A=83656+(B+ -1<<3)|0;I=+h[A>>3]- +h[f>>3];if(!(I>=0.0)){ea=-I}else{ea=I}if(ea>=+h[n>>3]){v=B+1|0;c[20956]=v;if((B|0)<(y|0)){B=v;continue}else{break}}v=c[e>>2]|0;c[20958]=1;if((v|0)>=1){z=B+ -22|0;E=1;while(1){G=E+ -1|0;if(+h[d+(G<<3)>>3]!=0.0){x=80296+((E*21|0)+ -22+B<<3)|0;I=+h[x>>3];h[x>>3]=I+(I- +h[b+(G<<3)>>3])}h[88224+(E+ -1<<3)>>3]=+h[80296+(z+(E*21|0)<<3)>>3];if((E|0)<(v|0)){E=E+1|0}else{break}}c[20958]=v+1}$d[u&63](e,88224,A)|0;c[22010]=(c[22010]|0)+1;c[22008]=(c[22008]|0)+1;E=c[20956]|0;I=+h[83656+(E+ -1<<3)>>3];if(I>=+h[10955]){B=E;continue}h[10955]=I;if(!((c[j>>2]|0)>-1)){B=E;continue}c[88836>>2]=6;cN(88832)|0;tM(89144,88032,4)|0;tM(89144,87640,8)|0;E=c[e>>2]|0;c[20958]=1;if((E|0)>=1){z=1;do{tM(89144,88224+(z+ -1<<3)|0,8)|0;G=c[20958]|0;z=G+1|0;c[20958]=z;}while((G|0)<(E|0))}MM()|0;B=c[20956]|0}}B=c[21402]|0;c[20956]=1;do{if((B|0)<1){h[10482]=+h[10457];c[20956]=1;ga=B;R=202}else{y=1;do{E=y+1|0;c[20966]=E;z=c[e>>2]|0;c[20958]=1;if((z|0)>=1){A=1;while(1){v=A*21|0;h[88056+(A+ -1<<3)>>3]=(+h[80296+(v+ -21<<3)>>3]+ +h[80296+(v+ -22+E<<3)>>3])*.5;if((A|0)<(z|0)){A=A+1|0}else{break}}c[20958]=z+1}$d[u&63](e,88056,85616+(y+ -1<<3)|0)|0;c[22010]=(c[22010]|0)+1;c[22008]=(c[22008]|0)+1;A=c[20956]|0;y=A+1|0;c[20956]=y;}while((A|0)<(B|0));y=c[21402]|0;I=+h[10457];h[10482]=I;c[20956]=1;if((y|0)<1){ga=y;R=202;break}else{ha=I;ia=1}while(1){A=ia+ -1|0;c[20966]=A;c[20968]=ia+1;if((ia|0)<2){ja=ia;ka=ha}else{c[20958]=1;E=1;while(1){v=E+1|0;c[20970]=v;G=c[e>>2]|0;c[20960]=1;if((G|0)>=1){x=c[20968]|0;T=1;while(1){U=(T*21|0)+ -22|0;h[88224+(T+ -1<<3)>>3]=(+h[80296+(U+x<<3)>>3]+ +h[80296+(U+v<<3)>>3])*.5;if((T|0)<(G|0)){T=T+1|0}else{break}}c[20960]=G+1}$d[u&63](e,88224,88216)|0;c[22010]=(c[22010]|0)+1;c[22008]=(c[22008]|0)+1;T=c[20956]|0;v=T+ -1|0;x=(fa(v,T)|0)/2|0;U=c[20958]|0;la=U+x|0;c[20962]=la;I=+h[10482];h[85936+(la+ -1<<3)>>3]=(+h[11027]+I- +h[85616+(v<<3)>>3]- +h[85616+(U+ -1<<3)>>3])*2.0;v=U+1|0;c[20958]=v;if((U|0)<(A|0)){E=v}else{ja=T;ka=I;break}}}E=ja+1|0;c[20956]=E;if((ja|0)<(y|0)){ha=ka;ia=E}else{break}}y=c[21402]|0;c[20962]=0;c[20956]=1;E=(y|0)<1;if(E){c[20956]=1;ma=1;na=y;break}A=y+ -1|0;z=A<<1;T=uZ(A|0,0,y+ -2|0,0)|0;A=nZ(T|0,J&1|0,1)|0;T=0;v=1;while(1){U=T+v|0;h[85936+(U+ -1<<3)>>3]=(+h[83656+(v<<3)>>3]+ka- +h[85616+(v+ -1<<3)>>3]*2.0)*2.0;if((v|0)<(y|0)){v=v+1|0;T=U}else{break}}c[20966]=v+1;c[20962]=(z|1)+A;c[20956]=1;if(E){ma=1;na=y;break}I=ka*3.0;T=1;while(1){U=85616+(T+ -1<<3)|0;h[U>>3]=+h[U>>3]*2.0-(+h[83656+(T<<3)>>3]+I)*.5;if((T|0)<(y|0)){T=T+1|0}else{break}}c[20966]=T+1;c[20956]=y+1;ma=E;na=y}}while(0);if((R|0)==202){R=0;c[20962]=0;c[20956]=1;ma=(ga|0)<1;na=ga}B=c[e>>2]|0;c[20956]=1;if((B|0)>=1){A=1;while(1){h[87656+(A+ -1<<3)>>3]=+h[80296+((A*21|0)+ -21<<3)>>3];if((A|0)<(B|0)){A=A+1|0}else{break}}c[20956]=B+1}c[20956]=1;do{if(ma){c[20956]=1}else{A=1;while(1){z=A+1|0;c[20966]=z;v=c[e>>2]|0;c[20958]=1;if((v|0)>=1){U=1;while(1){la=U*21|0;x=80296+(la+ -22+z<<3)|0;h[x>>3]=+h[x>>3]- +h[80296+(la+ -21<<3)>>3];if((U|0)<(v|0)){U=U+1|0}else{break}}c[20958]=v+1}c[20956]=z;if((A|0)<(na|0)){A=z}else{break}}c[20956]=1;if(ma){break}else{oa=1}while(1){A=oa+1|0;c[20966]=A;y=c[e>>2]|0;c[20958]=1;if((y|0)>=1){E=1;while(1){T=(E*21|0)+ -22|0;h[80296+(T+oa<<3)>>3]=+h[80296+(T+A<<3)>>3];if((E|0)<(y|0)){E=E+1|0}else{break}}c[20958]=y+1}c[20956]=A;if((oa|0)<(na|0)){oa=A}else{break}}}}while(0);B=85936;zw(B,85608,B,87816,88392,q,87976)|0;if((c[q>>2]|0)==0){R=226;break}if((c[j>>2]|0)>-1){c[88860>>2]=6;cN(88856)|0;MM()|0}c[q>>2]=2;if((c[22008]|0)>(c[g>>2]|0)){R=312;break}c[88884>>2]=6;cN(88880)|0;MM()|0;B=c[e>>2]|0;c[20956]=1;if((B|0)<1){continue}else{pa=1}while(1){E=d+(pa+ -1<<3)|0;h[E>>3]=+h[E>>3]*.5;if((pa|0)<(B|0)){pa=pa+1|0}else{break}}c[20956]=B+1}if((R|0)==150){c[q>>2]=1;if((c[j>>2]|0)<0){i=r;return 0}c[88572>>2]=6;cN(88568)|0;tM(89144,g,4)|0;MM()|0;c[88596>>2]=6;cN(88592)|0;tM(89144,87648,8)|0;MM()|0;c[88620>>2]=6;cN(88616)|0;u=c[e>>2]|0;c[20956]=1;if((u|0)>=1){E=1;do{tM(89144,b+(E+ -1<<3)|0,8)|0;z=c[20956]|0;E=z+1|0;c[20956]=E;}while((z|0)<(u|0))}MM()|0;c[88644>>2]=6;cN(88640)|0;tM(89144,s,8)|0;MM()|0;i=r;return 0}else if((R|0)==226){u=c[21402]|0;c[22006]=u-(c[22098]|0);c[20956]=1;E=(u|0)<1;do{if(E){h[10999]=0.0;c[20956]=1;qa=0.0}else{z=u+1|0;v=1;while(1){h[83656+(v+ -1<<3)>>3]=0.0;T=v+ -1|0;U=83656+(T<<3)|0;I=+h[U>>3];la=1;while(1){if((la|0)>(v|0)){x=la+ -1|0;ra=x;sa=((fa(x,la)|0)/2|0)+v|0}else{ra=la+ -1|0;sa=((fa(T,v)|0)/2|0)+la|0}ta=+h[85936+(sa+ -1<<3)>>3]*+h[85616+(ra<<3)>>3]+I;if((la|0)<(u|0)){I=ta;la=la+1|0}else{break}}c[20962]=sa;h[U>>3]=ta;if((v|0)<(u|0)){v=v+1|0}else{break}}c[20958]=z;h[10999]=0.0;c[20956]=1;if(E){qa=0.0;break}else{ua=1;va=0.0}while(1){v=ua+ -1|0;wa=va+ +h[83656+(v<<3)>>3]*+h[85616+(v<<3)>>3];if((ua|0)<(u|0)){va=wa;ua=ua+1|0}else{break}}h[10999]=wa;c[20956]=u+1;qa=wa}}while(0);h[10999]=+h[10482]-qa;s=c[e>>2]|0;c[20956]=1;if((s|0)>=1){z=u+1|0;v=1;while(1){h[88224+(v+ -1<<3)>>3]=0.0;if(E){xa=1}else{B=v*21|0;la=88224+(v+ -1<<3)|0;T=1;I=+h[la>>3];while(1){ya=I+ +h[83656+(T+ -1<<3)>>3]*+h[80296+(T+ -22+B<<3)>>3];if((T|0)<(u|0)){I=ya;T=T+1|0}else{break}}h[la>>3]=ya;xa=z}if((v|0)<(s|0)){v=v+1|0}else{break}}c[20956]=s+1;c[20958]=xa}v=c[e>>2]|0;c[20956]=1;if((v|0)>=1){z=1;while(1){u=z+ -1|0;E=87656+(u<<3)|0;h[E>>3]=+h[E>>3]- +h[88224+(u<<3)>>3];if((z|0)<(v|0)){z=z+1|0}else{break}}c[20956]=v+1}if((c[j>>2]|0)>=0){c[88908>>2]=6;cN(88904)|0;tM(89144,87992,8)|0;z=c[e>>2]|0;c[20956]=1;if((z|0)>=1){s=1;do{tM(89144,87656+(s+ -1<<3)|0,8)|0;u=c[20956]|0;s=u+1|0;c[20956]=s;}while((u|0)<(z|0))}MM()|0;c[88932>>2]=6;cN(88928)|0;MM()|0}z=c[e>>2]|0;c[20956]=1;if((z|0)>=1){s=c[21402]|0;v=1;while(1){c[20958]=1;if((s|0)>=1){u=v*21|0;E=s+1|0;T=1;while(1){h[83656+(T+ -1<<3)>>3]=0.0;B=T+ -1|0;x=83656+(B<<3)|0;I=+h[x>>3];za=1;while(1){if((za|0)>(T|0)){Aa=((fa(za+ -1|0,za)|0)/2|0)+T|0}else{Aa=((fa(B,T)|0)/2|0)+za|0}Ba=I+ +h[85936+(Aa+ -1<<3)>>3]*+h[80296+(za+ -22+u<<3)>>3]*.5;if((za|0)<(s|0)){I=Ba;za=za+1|0}else{break}}c[20962]=Aa;h[x>>3]=Ba;if((T|0)<(s|0)){T=T+1|0}else{break}}c[20960]=E;c[20958]=s+1}T=c[e>>2]|0;c[20958]=v;if((v|0)<=(T|0)){u=(s|0)<1;la=s+1|0;za=v;while(1){Ca=v+((fa(za+ -1|0,za)|0)/2|0)|0;B=83912+(Ca+ -1<<3)|0;h[B>>3]=0.0;if(u){Da=1}else{U=za*21|0;Ea=1;I=0.0;while(1){Fa=+h[83656+(Ea+ -1<<3)>>3]*+h[80296+(Ea+ -22+U<<3)>>3]+I;if((Ea|0)<(s|0)){I=Fa;Ea=Ea+1|0}else{break}}h[B>>3]=Fa;Da=la}if((za|0)<(T|0)){za=za+1|0}else{break}}c[20958]=T+1;c[20962]=Ca;c[20960]=Da}za=v+1|0;c[20956]=za;if((v|0)<(z|0)){v=za}else{break}}}c[20958]=0;v=c[e>>2]|0;c[20956]=1;if((v|0)>=1){z=1;s=0;while(1){Ga=s+z|0;h[o+(z+ -1<<3)>>3]=+h[83912+(Ga+ -1<<3)>>3];if((z|0)<(v|0)){s=Ga;z=z+1|0}else{break}}c[20958]=Ga;c[20956]=v+1}if((c[j>>2]|0)<0){i=r;return 0}c[88956>>2]=6;cN(88952)|0;tM(89144,88024,4)|0;MM()|0;c[21400]=1;z=1;d:while(1){c[20962]=z;do{if((z|0)>(c[e>>2]|0)){s=c[21400]|0;if((s|0)==1){c[88980>>2]=6;cN(88976)|0;MM()|0;zw(83912,85608,85936,87816,88392,q,87976)|0;c[89004>>2]=6;cN(89e3)|0;MM()|0;c[21400]=3;z=1;continue d}else if((s|0)==2){break d}else if((s|0)!=3){break}c[21400]=2;c[20972]=0;c[20974]=0;s=c[e>>2]|0;c[20956]=1;if((s|0)>=1){za=0;la=1;u=0;E=0;while(1){Ea=(E|0)>1?E:1;U=Ea+1|0;x=uZ(Ea+ -1|0,0,Ea+ -2|0,0)|0;Ha=nZ(x|0,J&1|0,1)|0;x=(Ea<<1)+ -1+Ha|0;Ia=u+la|0;Ha=83912+(Ia+ -1<<3)|0;I=+h[Ha>>3];if(I>0.0){Ja=1.0/+V(+I)}else{Ja=0.0}h[Ha>>3]=Ja;Ka=la+ -1|0;if((la|0)<2){La=za;Ma=1;Na=0}else{I=Ja;Oa=1;Pa=za;Qa=0;while(1){Ra=Qa+Oa|0;Sa=83912+(Pa<<3)|0;h[Sa>>3]=+h[Sa>>3]*I*+h[83912+(Ra+ -1<<3)>>3];if((Oa|0)>=(Ka|0)){break}I=+h[Ha>>3];Oa=Oa+1|0;Pa=Pa+1|0;Qa=Ra}La=za+Ea|0;Ma=U;Na=x}Ta=La+1|0;if((la|0)<(s|0)){za=Ta;la=la+1|0;E=E+1|0;u=Ia}else{break}}c[20976]=Na;c[20974]=Ta;c[20972]=Ia;c[20958]=Ma;c[20956]=s+1}c[89028>>2]=6;cN(89024)|0;MM()|0;c[20972]=0;u=c[e>>2]|0;c[20956]=1;if((u|0)<1){z=1;continue d}else{Ua=1;Va=0}while(1){Wa=Va+Ua|0;E=83912+(Wa+ -1<<3)|0;if(+h[E>>3]!=0.0){h[E>>3]=1.0}if((Ua|0)<(u|0)){Ua=Ua+1|0;Va=Wa}else{break}}c[20972]=Wa;c[20956]=u+1;z=1;continue d}}while(0);T=(fa(z+ -1|0,z)|0)/2|0;c[20972]=T;s=c[e>>2]|0;c[20956]=z;e:do{if((z|0)<=(s|0)){E=z;la=T;za=z;while(1){B=E+la|0;c[20966]=B;Qa=za+la|0;c[20972]=Qa;Pa=B+5|0;c[20968]=(Qa|0)<=(Pa|0)?Qa:Pa;if((c[21400]|0)==3){c[89100>>2]=6;cN(89096)|0;Pa=c[20968]|0;Qa=c[20966]|0;c[20958]=Qa;if((Qa|0)<=(Pa|0)){B=Qa;do{tM(89144,85936+(B+ -1<<3)|0,8)|0;Qa=c[20958]|0;B=Qa+1|0;c[20958]=B;}while((Qa|0)<(Pa|0))}MM()|0}else{c[89076>>2]=6;cN(89072)|0;Pa=c[20968]|0;B=c[20966]|0;c[20958]=B;if((B|0)<=(Pa|0)){x=B;do{tM(89144,83912+(x+ -1<<3)|0,8)|0;B=c[20958]|0;x=B+1|0;c[20958]=x;}while((B|0)<(Pa|0))}MM()|0}Pa=c[20956]|0;x=Pa+1|0;c[20956]=x;if((Pa|0)>=(s|0)){break e}E=c[20962]|0;la=c[20972]|0;za=x}}}while(0);c[89124>>2]=6;cN(89120)|0;MM()|0;z=(c[20962]|0)+6|0}c[89052>>2]=6;cN(89048)|0;tM(89144,88040,4)|0;MM()|0;i=r;return 0}else if((R|0)==312){i=r;return 0}}}while(0);$d[p&63](e,b,f)|0;i=r;return 0}function zw(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0;k=i;c[22306]=c[b>>2];c[g>>2]=1;if((c[22306]|0)<1){i=k;return 0}c[g>>2]=0;Aw(a,89224,d,f,g,j,e)|0;if((c[g>>2]|0)!=0){i=k;return 0}g=c[22306]|0;j=g+1|0;f=(fa(j,g)|0)/2|0;c[22298]=f;c[22304]=g;c[22310]=f;a=g+ -1|0;b=f+(fa(a,1-g|0)|0)|0;l=uZ(a|0,0,g+ -2|0,0)|0;m=nZ(l|0,J&1|0,1)|0;l=b+m|0;m=0-g|0;b=f;n=g;while(1){if(+h[d+(b+ -1<<3)>>3]==0.0){c[22290]=n;if((n|0)>(g|0)){o=b}else{p=g-n|0;q=fa(p,n+1|0)|0;r=uZ(p|0,0,a-n|0,0)|0;p=nZ(r|0,J&1|0,1)|0;r=n;s=b;while(1){h[d+(s+ -1<<3)>>3]=0.0;if((r|0)<(g|0)){s=s+r|0;r=r+1|0}else{break}}c[22290]=j;o=n+b+q+p|0}t=o;u=n+ -1|0}else{c[22288]=n;if((n|0)<=(g|0)){r=n;s=b;while(1){h[e+(r+ -1<<3)>>3]=+h[d+(s+ -1<<3)>>3];if((r|0)>=(g|0)){break}v=s+r|0;r=r+1|0;s=v}c[22288]=j}c[22300]=g;c[22302]=f;c[22308]=f;s=n+ -1|0;r=e+(s<<3)|0;p=(g|0)==(n|0);q=f;v=g;w=f;while(1){h[11148]=0.0;x=(v|0)==(n|0);if(x){y=1.0/+h[r>>3];h[11148]=y;z=y}else{z=0.0}if(p){A=g;B=w;C=z}else{y=z;D=g;E=w;while(1){F=D+ -1|0;G=E+ -1|0;H=y- +h[e+(F<<3)>>3]*+h[d+(G<<3)>>3];h[11148]=H;if((G|0)>(q|0)){I=E+(1-D)|0}else{I=G}if((F|0)==(n|0)){A=n;B=I;C=H;break}else{E=I;D=F;y=H}}}h[d+(B+ -1<<3)>>3]=C/+h[r>>3];if(x){break}D=q-v|0;c[22308]=D;E=v+ -1|0;c[22300]=E;F=w+ -1|0;c[22302]=F;q=D;v=E;w=F}c[22292]=A;t=B;u=s}w=b+m|0;if((u|0)==0){break}else{m=m+1|0;b=w;n=u}}c[22294]=t;c[22304]=0;c[22310]=l-g;i=k;return 0}function Aw(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0;k=i;h[11162]=.5;l=.5;do{l=l*.5;}while(l+1.0>1.0);m=l*2.0;h[11162]=m;c[f>>2]=1;if((c[b>>2]|0)<1){i=k;return 0}c[f>>2]=2;c[e>>2]=0;h[g>>3]=m;h[j>>3]=+h[11162];c[22314]=1;c[22316]=0;n=c[b>>2]|0;c[22328]=1;a:do{if((n|0)>=1){b=1;o=1;b:while(1){c[22318]=0;c[22330]=1;do{if((o|0)>=1){p=1;q=c[22316]|0;r=0;while(1){s=q+1|0;t=a+(q<<3)|0;m=+h[t>>3];h[11161]=m;u=(p|0)==(o|0);if(u){l=m*+h[11162];h[11163]=l*l}do{if((p|0)<1){v=m;w=r;x=b;y=1}else{l=m;z=b;A=1;B=r;while(1){C=B+1|0;if((A|0)==(p|0)){D=14;break}E=d+(B<<3)|0;F=l- +h[E>>3]*+h[d+(z+ -1<<3)>>3];h[11161]=F;if(u){G=+h[E>>3];H=G*G*+h[j+(A+ -1<<3)>>3];h[11163]=+h[11163]+H*H}I=z+1|0;J=A+1|0;if((A|0)<(p|0)){l=F;z=I;A=J;B=C}else{D=15;break}}if((D|0)==14){D=0;c[22318]=C;v=l;w=C;x=z;y=p;break}else if((D|0)==15){D=0;c[22318]=C;v=F;w=C;x=I;y=J;break}}}while(0);if(u){D=25;break}m=+h[d+(w+ -1<<3)>>3];if(m==0.0){h[d+(q<<3)>>3]=0.0;H=+h[11161];if(!(H>=0.0)){K=-H}else{K=H}H=+h[g>>3]*+h[t>>3];if(!(H>=0.0)){L=-H}else{L=H}if(K>L){break b}}else{h[d+(q<<3)>>3]=v/m}B=p+1|0;c[22330]=B;if((p|0)<(o|0)){p=B;r=w;q=s}else{D=26;break}}if((D|0)==25){D=0;c[22312]=y;c[22320]=x;c[22316]=s;break}else if((D|0)==26){D=0;c[22312]=y;c[22320]=x;c[22316]=s;break}}}while(0);m=+V(+(+h[11163]));h[11163]=m;H=+h[11161];if(!(H>=0.0)){M=-H}else{M=H}do{if(!(M<=m*5.0)){if(H<0.0){D=37;break b}G=+V(+H);h[d+((c[22316]|0)+ -1<<3)>>3]=G;G=+h[11163]/+h[11161];h[j+((c[22312]|0)+ -1<<3)>>3]=G;if(!(G>+h[g>>3])){N=b;O=o;break}h[g>>3]=G;N=b;O=o}else{h[d+((c[22316]|0)+ -1<<3)>>3]=0.0;c[e>>2]=(c[e>>2]|0)+1;N=c[22314]|0;O=c[22328]|0}}while(0);b=N+O|0;c[22314]=b;o=O+1|0;c[22328]=o;if((O|0)>=(n|0)){break a}}if((D|0)==37){i=k;return 0}c[22312]=y;c[22320]=x;c[22316]=s;i=k;return 0}}while(0);c[f>>2]=0;i=k;return 0}function Bw(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;n=(c[b>>2]|0)+1|0;c[22354]=n;o=(c[d>>2]|0)-n|0;c[22376]=o;p=c[d>>2]|0;q=c[b>>2]|0;r=q+2|0;do{if((p|0)>=(r|0)){if((p|0)>((fa(n,r)|0)/2|0|0)){break}s=q+p|0;c[22374]=s;a[89440]=1;t=c[b>>2]|0;u=t+1|0;c[22370]=u;v=c[b>>2]|0;w=u+v|0;c[22368]=w;u=w+(c[b>>2]|0)|0;c[22372]=u;w=(fa(c[d>>2]|0,c[b>>2]|0)|0)+u|0;c[22362]=w;x=w+(c[d>>2]|0)|0;c[22356]=x;y=x+(c[b>>2]|0)|0;c[22358]=y;z=((fa(n,c[b>>2]|0)|0)/2|0)+y|0;c[22364]=z;A=z+(c[d>>2]|0)|0;c[22378]=A;B=(fa(c[b>>2]|0,s)|0)+A|0;c[22380]=B;C=(fa(o,c[d>>2]|0)|0)+B|0;c[22352]=C;D=C+(c[b>>2]|0)|0;c[22366]=D;Cw(b,d,e,f,g,h,j,k,k+(t<<3)|0,k+(t+v<<3)|0,k+(u+ -1<<3)|0,k+(w+ -1<<3)|0,k+(x+ -1<<3)|0,k+(y+ -1<<3)|0,k+(z+ -1<<3)|0,k+(A+ -1<<3)|0,k+(B+ -1<<3)|0,89496,k+(C+ -1<<3)|0,k+(D+ -1<<3)|0,k+(s+ -1+D<<3)|0,l)|0;i=m;return 0}}while(0);cN(89528)|0;MM()|0;i=m;return 0}




// EMSCRIPTEN_END_FUNCS
var Rd=[d_,Kw,Mw,Rw,EL,d_,d_,d_];var Sd=[e_,Pr,Qr,ts,us,Ys,Zs,ut,vt,wt,vY,uY,tY,hr,ir,Ku,Mu,e_,e_,e_,e_,e_,e_,e_,e_,e_,e_,e_,e_,e_,e_,e_];var Td=[f_,jy];var Ud=[g_,zx];var Vd=[h_,kh,lh,mh,nh,ol,ph,Hu,vA,yA,xA,zA,AQ,zQ,CQ,BQ,AA,CA,OD,iE,jE,kE,lQ,kQ,nQ,mQ,aL,nL,oL,pL,rL,tL,hN,iN,oN,pN,vN,wN,CN,DN,PN,ON,UN,TN,WN,XN,eO,dO,lP,kP,uP,tP,YP,XP,uQ,tQ,wQ,vQ,OQ,NQ,QQ,PQ,WQ,VQ,jP,XQ,UQ,YQ,_Q,ZQ,gV,eR,dR,jR,iR,IR,HR,kS,jS,yS,xS,MS,LS,_S,ZS,lT,kT,oT,nT,sT,rT,DT,CT,OT,NT,ZT,YT,iU,hU,sU,rU,AU,zU,GU,FU,MU,LU,RU,QU,_U,ZU,wV,vV,VU,NV,sW,rW,uW,tW,$Q,fV,iV,FV,VV,eW,pW,qW,gY,fY,iY,lY,jY,kY,mY,nY,KY,JY,hh,i_,jg,kg,mg,ng,og,pg,qg,rg,sg,tg,ug,vg,wg,xg,yg,zg,Ag,Bg,Cg,Dg,Eg,Fg,Gg,Hg,Ig,Jg,Kg,Lg,Mg,Ng,Og,Pg,Qg,Rg,Sg,Tg,Ug,Vg,Wg,Xg,Yg,Zg,_g,$g,ah,bh,ch,bg,cg,dg,eg,fg,gg,hg,ig,Yf,Zf,_f,$f,ag,Tf,Uf,Vf,Wf,Xf,Lf,Mf,Nf,Of,Pf,Qf,Rf,Sf,Gf,Hf,If,Jf,Kf,Bf,Cf,Df,Ef,Ff,tf,uf,vf,wf,xf,yf,zf,Af,of,pf,qf,rf,sf,jf,kf,lf,mf,nf,af,bf,cf,df,ef,ff,gf,hf,Xe,Ye,Ze,_e,$e,Se,Te,Ue,Ve,We,AY,Ju,Me,jx,nx,ix,my,px,ky,Tv,sx,qx,rx,ox,ux,ly,vx,kx,xx,OK,yx,HM,gN,hV,aX,kU,hX,gX,fX,eX,dX,cX,uO,YO,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_,h_];var Wd=[j_,oh,Ty,DA,LP,jN,qN,xN,EN,ZP,vT,wT,xT,yT,AT,BT,GT,HT,IT,JT,LT,MT,RT,ST,TT,UT,WT,XT,aU,bU,cU,dU,fU,gU,PU,UU,zW,BW,DW,AW,CW,EW,ax,tx,uD,Vy,Uy,Wy,az,mz,Xy,kz,JC,VC,UC,WC,EC,CC,GC,SL,j_,j_,j_,j_];var Xd=[k_,wr,pr,Lw,Nw,Ow,Pw,Qw];var Yd=[l_,eh,on,dh,Oe,Pe,Qe,pl,rl,vh,nl,nn,xp,uh,sh,yp,zp,Ap,Bp,Cp,Dp,Ep,Fp,Gp,Hp,m_,n_,o_,bv,zY,p_,HA,QP,IA,TP,PP,wL,kN,cQ,eQ,fQ,bQ,rN,sN,yN,SP,FN,GN,QN,VN,SQ,NS,FW,HW,JW,PW,RW,LW,NW,$S,GW,IW,KW,QW,SW,MW,OW,tT,uT,zT,ET,FT,KT,PT,QT,VT,_T,$T,eU,RV,SV,UV,vW,xW,wW,yW,JV,KV,MV,$V,aW,dW,kW,lW,oW,hY,LY,ty,q_,r_,ry,sy,s_,HK,fL,Gx,Nx,Wx,Hx,Qx,Xx,_M,UY,l_,l_,l_,l_,l_,l_,l_,l_,l_,l_,l_,l_,l_,l_,l_];var Zd=[t_,yw];var _d=[u_,Yw];var $d=[v_,rh,Gr,Mr,ks,qs,Ps,Vs,EA,RP,VP,MP,_P,dQ,lN,hQ,zN,_N,$N,cR,hR,NU,SU,yV,AV,DV,jV,oV,qV,tV,oY,QK,tr,kr,rr,xr,w_,x_,y_,ny,NK,JK,z_,SM,A_,v_,v_,v_,v_,v_,v_,v_,v_,v_,v_,v_,v_,v_,v_,v_,v_,v_,v_,v_];var ae=[B_,Cw];var be=[C_,_v];var ce=[D_,Fx];var de=[E_,sS,vS,GS,IS,E_,E_,E_];var ee=[F_,mT,pT,jU,nU,tU,vU,F_];var fe=[G_,Eu,FA,uL,$P,NP,lS,mS,qS,wS,zS,AS,ES,JS,OU,TU,yY,xY,wY,Fu,G_,G_,G_,G_,G_,G_,G_,G_,G_,G_,G_,G_];var ge=[H_,Ox,Px,H_];var he=[I_,gh];var ie=[J_,kR,mR,oR,qR,sR,uR,wR,yR,AR,CR,ER,JR,LR,NR,PR,RR,TR,VR,XR,ZR,$R,bS,pS,rS,DS,FS,OS,PS,QS,RS,SS,aT,bT,cT,dT,eT,EU,KU,J_,J_,J_,J_,J_,J_,J_,J_,J_,J_,J_,J_,J_,J_,J_,J_,J_,J_,J_,J_,J_,J_,J_,J_,J_];var je=[K_,BU,HU,K_];var ke=[L_,TS,fT,L_];var le=[M_,Ne,wh,th,qh,Ip,Jp,Ir,Jr,Lr,ms,ns,ps,Rs,Ss,Us,_s,$s,at,bt,ct,dt,et,ft,JA,KA,xL,yL,gQ,mN,tN,iQ,UP,AN,HN,WP,xV,zV,BV,nV,pV,rV,by,Yx,Rx,Ix,N_,CY,er,fr,gr,O_,mv,Lx,P_,TX,M_,M_,M_,M_,M_,M_,M_,M_];var me=[Q_,aR,fR,EV,QV,TV,uV,IV,LV,_V,bW,jW,mW,Ct,tu,uu,Ht,Et,ru,su,It,Jt,Kt,Lt,Mt,hu,iu,_t,Tt,Ot,Nt,Pt,Qt,St,Rt,Ft,Dt,Ut,Vt,Wt,Xt,Yt,Zt,$t,au,bu,cu,gu,eu,du,fu,nu,ju,ku,lu,mu,ou,pu,qu,vu,wu,xu,yu,nS];var ne=[R_,yy];var oe=[S_,_w];var pe=[T_,Lp,U_,cv,dN,eN,bN,T_];var qe=[V_,Bw];var re=[W_,RK,ZN,TQ,Pu,Oy,Qy,tD,RL,W_,W_,W_,W_,W_,W_,W_];var se=[X_,Y_,av,Bu,jh,X_,X_,X_];var te=[Z_,Kp,OV,PV,GV,HV,WV,YV,fW,hW,Z_,Z_,Z_,Z_,Z_,Z_];var ue=[__,Ar,Br,Cr,Dr,Er,Fr,Hr,Kr,Or,es,fs,gs,hs,is,js,ls,os,ss,Js,Ks,Ls,Ms,Ns,Os,Qs,Ts,Xs,CV,kV,lV,mV,sV,cx,$_,Yq,$p,uq,Dq,pq,Mq,Rq,Pq,Sq,yr,cr,mr,nr,ur,vr,GR,tS,a$,__,__,__,__,__,__,__,__,__,__,__];var ve=[b$,Nr,rs,Ws,GA,vL,aQ,OP,bR,gR,pY,qY,rY,Nu,Lu,ex,Ou,or,iM,b$,b$,b$,b$,b$,b$,b$,b$,b$,b$,b$,b$,b$];return{_testSetjmp:oZ,_saveSetjmp:aZ,_free:AY,_main:ih,_rand_r:iZ,_realloc:CY,_i64Add:lZ,_memmove:eZ,_bitshift64Ashr:cZ,_memset:fZ,_malloc:zY,_strncpy:mZ,_memcpy:dZ,_strlen:bZ,_bitshift64Lshr:nZ,_bitshift64Shl:gZ,_i64Subtract:kZ,_strcpy:hZ,_calloc:BY,_rand:jZ,__GLOBAL__I_a:JN,runPostSets:$Y,stackAlloc:we,stackSave:xe,stackRestore:ye,setThrew:ze,setTempRet0:Ce,setTempRet1:De,setTempRet2:Ee,setTempRet3:Fe,setTempRet4:Ge,setTempRet5:He,setTempRet6:Ie,setTempRet7:Je,setTempRet8:Ke,setTempRet9:Le,dynCall_iiiiiiii:yZ,dynCall_viiiii:zZ,dynCall_iiiiidiii:AZ,dynCall_vd:BZ,dynCall_vi:CZ,dynCall_vii:DZ,dynCall_iiiiiiiiiii:EZ,dynCall_ii:FZ,dynCall_iiiiiiiiiiiiii:GZ,dynCall_viidddd:HZ,dynCall_iiii:IZ,dynCall_iiiiiiiiiiiiiiiiiiiiiii:JZ,dynCall_iiiiiiiiiiiiiiiiiiiii:KZ,dynCall_idii:LZ,dynCall_viiiiid:MZ,dynCall_viiiiiiii:NZ,dynCall_viiiiii:OZ,dynCall_viidii:PZ,dynCall_iid:QZ,dynCall_viiiiiii:RZ,dynCall_viiiiiid:SZ,dynCall_viiiiiiiii:TZ,dynCall_iii:UZ,dynCall_iiiiii:VZ,dynCall_iiiiidi:WZ,dynCall_diidddd:XZ,dynCall_i:YZ,dynCall_iiiiiiiiii:ZZ,dynCall_viii:_Z,dynCall_v:$Z,dynCall_iiiiiiiii:a_,dynCall_iiiii:b_,dynCall_viiii:c_}})


// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_viiiii": invoke_viiiii, "invoke_iiiiidiii": invoke_iiiiidiii, "invoke_vd": invoke_vd, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiiiiiii": invoke_iiiiiiiiiii, "invoke_ii": invoke_ii, "invoke_iiiiiiiiiiiiii": invoke_iiiiiiiiiiiiii, "invoke_viidddd": invoke_viidddd, "invoke_iiii": invoke_iiii, "invoke_iiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiii, "invoke_idii": invoke_idii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_viidii": invoke_viidii, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_iii": invoke_iii, "invoke_iiiiii": invoke_iiiiii, "invoke_iiiiidi": invoke_iiiiidi, "invoke_diidddd": invoke_diidddd, "invoke_i": invoke_i, "invoke_iiiiiiiiii": invoke_iiiiiiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_fabs": _fabs, "_strrchr": _strrchr, "_vsscanf": _vsscanf, "__ZSt9terminatev": __ZSt9terminatev, "___cxa_guard_acquire": ___cxa_guard_acquire, "__reallyNegative": __reallyNegative, "_fstat": _fstat, "_pclose": _pclose, "_lis_solver_create": _lis_solver_create, "___assert_fail": ___assert_fail, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "_longjmp": _longjmp, "__isLeapYear": __isLeapYear, "_clock_gettime": _clock_gettime, "_fsync": _fsync, "_signal": _signal, "_GC_collect_a_little": _GC_collect_a_little, "_sbrk": _sbrk, "_strtoull": _strtoull, "_emscripten_memcpy_big": _emscripten_memcpy_big, "__parseInt64": __parseInt64, "_close": _close, "_rewind": _rewind, "_cos": _cos, "_fileno": _fileno, "_fread": _fread, "_puts": _puts, "_isatty": _isatty, "_lis_matrix_set_value": _lis_matrix_set_value, "_write": _write, "_isblank": _isblank, "_ftell": _ftell, "__ZNSt9exceptionD2Ev": __ZNSt9exceptionD2Ev, "_round": _round, "___cxa_does_inherit": ___cxa_does_inherit, "_strtoll_l": _strtoll_l, "_strstr": _strstr, "___cxa_rethrow": ___cxa_rethrow, "_llvm_lifetime_end": _llvm_lifetime_end, "_catclose": _catclose, "_tmpnam": _tmpnam, "_lis_vector_destroy": _lis_vector_destroy, "_lis_solver_set_option": _lis_solver_set_option, "_tmpfile": _tmpfile, "_send": _send, "_pow": _pow, "___cxa_is_number_type": ___cxa_is_number_type, "___cxa_free_exception": ___cxa_free_exception, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_isxdigit_l": _isxdigit_l, "___cxa_guard_release": ___cxa_guard_release, "_truncate": _truncate, "_strtol": _strtol, "_sin": _sin, "_strtok": _strtok, "___setErrNo": ___setErrNo, "_newlocale": _newlocale, "_isdigit_l": _isdigit_l, "___resumeException": ___resumeException, "_freelocale": _freelocale, "_srand": _srand, "_fscanf": _fscanf, "_qsort": _qsort, "_putchar": _putchar, "_floor": _floor, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_printf": _printf, "_sprintf": _sprintf, "_fopen": _fopen, "_strtok_r": _strtok_r, "_emscripten_get_now": _emscripten_get_now, "_stat": _stat, "_vsnprintf": _vsnprintf, "_strtoull_l": _strtoull_l, "_read": _read, "__addDays": __addDays, "_fwrite": _fwrite, "_time": _time, "_pthread_mutex_lock": _pthread_mutex_lock, "_catopen": _catopen, "_exit": _exit, "_GC_strdup": _GC_strdup, "_freopen": _freopen, "___ctype_b_loc": ___ctype_b_loc, "_fmod": _fmod, "_vasprintf": _vasprintf, "_lseek": _lseek, "_access": _access, "_vfprintf": _vfprintf, "___cxa_allocate_exception": ___cxa_allocate_exception, "_atoi": _atoi, "_strtoll": _strtoll, "_pwrite": _pwrite, "_localtime_r": _localtime_r, "_tzset": _tzset, "_open": _open, "_uselocale": _uselocale, "_snprintf": _snprintf, "___errno_location": ___errno_location, "_GC_malloc": _GC_malloc, "___cxa_end_catch": ___cxa_end_catch, "_perror": _perror, "___cxa_begin_catch": ___cxa_begin_catch, "_strftime": _strftime, "_ftruncate": _ftruncate, "_GC_init": _GC_init, "_fseek": _fseek, "_isxdigit": _isxdigit, "_fclose": _fclose, "__parseInt": __parseInt, "_pthread_key_create": _pthread_key_create, "_pthread_cond_broadcast": _pthread_cond_broadcast, "_popen": _popen, "_recv": _recv, "_fgetc": _fgetc, "_sysconf": _sysconf, "__getFloat": __getFloat, "_abort": _abort, "_ceil": _ceil, "_isspace": _isspace, "_localtime": _localtime, "_pthread_getspecific": _pthread_getspecific, "_pthread_cond_wait": _pthread_cond_wait, "_llvm_lifetime_start": _llvm_lifetime_start, "_ungetc": _ungetc, "_system": _system, "_fmax": _fmax, "_fflush": _fflush, "_strftime_l": _strftime_l, "_fprintf": _fprintf, "_sscanf": _sscanf, "_catgets": _catgets, "_strdup": _strdup, "_asprintf": _asprintf, "__exit": __exit, "___ctype_toupper_loc": ___ctype_toupper_loc, "_bsearch": _bsearch, "__arraySum": __arraySum, "__formatString": __formatString, "_htonl": _htonl, "___ctype_tolower_loc": ___ctype_tolower_loc, "_unlink": _unlink, "_fputs": _fputs, "_GC_malloc_atomic": _GC_malloc_atomic, "_pread": _pread, "_lis_vector_set_size": _lis_vector_set_size, "_mkport": _mkport, "__scanString": __scanString, "_pthread_setspecific": _pthread_setspecific, "_copysign": _copysign, "_fputc": _fputc, "___cxa_throw": ___cxa_throw, "_lis_solver_destroy": _lis_solver_destroy, "_isdigit": _isdigit, "_strerror": _strerror, "_emscripten_longjmp": _emscripten_longjmp, "_lis_vector_create": _lis_vector_create, "_atexit": _atexit, "_sqrt": _sqrt, "_strerror_r": _strerror_r, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "___rand_seed": ___rand_seed, "NaN": NaN, "Infinity": Infinity, "__ZTISt9exception": __ZTISt9exception, "___dso_handle": ___dso_handle, "_stderr": _stderr, "_stdin": _stdin, "_stdout": _stdout }, buffer);
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _rand_r = Module["_rand_r"] = asm["_rand_r"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _rand = Module["_rand"] = asm["_rand"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_iiiiidiii = Module["dynCall_iiiiidiii"] = asm["dynCall_iiiiidiii"];
var dynCall_vd = Module["dynCall_vd"] = asm["dynCall_vd"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiiiiiii = Module["dynCall_iiiiiiiiiii"] = asm["dynCall_iiiiiiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_iiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiii"];
var dynCall_viidddd = Module["dynCall_viidddd"] = asm["dynCall_viidddd"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiii"];
var dynCall_idii = Module["dynCall_idii"] = asm["dynCall_idii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_viidii = Module["dynCall_viidii"] = asm["dynCall_viidii"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiidi = Module["dynCall_iiiiidi"] = asm["dynCall_iiiiidi"];
var dynCall_diidddd = Module["dynCall_diidddd"] = asm["dynCall_diidddd"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];

Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };


// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======



// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}






