var Module = {};
var preloadComplete = false;

Module['noInitialRun'] = true;
Module['OpenModelica_readFile'] = function(fname) {
  return intArrayToString(FS.findObject(fname).contents);
};
Module['OpenModelica_readFileBuffer'] = function(fname) {
  return FS.findObject(fname).contents;
};

try { // Try to add an event listener like a webworker thread
  self.addEventListener('message', function(e) {
    var data = e.data;
    if (!data) return;
    if (data.preload) {
      var error = function() {console.log('error...'); /* self.postError({message: "Preload failed"}); */ };
      if (!preloadComplete) {
        FS.createPreloadedFile('/', data.basename + "_init.xml", data.basename + "_init.xml", true, false, function() {
        FS.createLazyFile('/', data.basename + "_info.xml", data.basename + "_info.xml", true, false);
        preloadComplete = true;
        self.postMessage({preloaded:true});
      }, error);
      } else {
        self.postMessage({preloaded:true});
      }
      return;
    }
    var result = {};
    result.status = "Simulation failed"
    try {
      shouldRunNow = true;
      var args = ['-override','outputFormat=csv,stopTime=' +  data.stopTime +',tolerance=' + data.tolerance + ',stepSize=' + data.stepSize];
      Module.callMain(args);
      result.csv = intArrayToString(FS.findObject(data.basename + "_res.csv").contents);
      result.status = "Simulation finished";

  } catch(e) {
  }
  self.postMessage(result);
  }, false);
} catch (e) {
}

// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 536870912;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===
var __ZTVN10__cxxabiv117__class_type_infoE = 160920;
var __ZTVN10__cxxabiv120__si_class_type_infoE = 160960;




STATIC_BASE = 8;

STATICTOP = STATIC_BASE + Runtime.alignMemory(161787);
/* global initializers */ __ATINIT__.push({ func: function() { __GLOBAL__I_a() } });


/* memory initializer */ allocate([0,0,0,0,0,0,0,0,95,112,114,111,102,46,100,97,116,97,0,0,0,0,0,0,119,98,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,111,112,101,110,101,100,58,32,37,115,0,0,0,0,0,0,0,0,111,102,102,115,101,116,32,118,97,108,117,101,32,102,111,114,32,116,104,101,32,110,101,120,116,32,115,116,101,112,58,32,37,46,49,48,102,0,0,0,99,97,108,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,32,40,115,116,101,112,83,105,122,101,58,32,37,103,41,0,0,0,0,0,0,0,0,82,117,110,110,105,110,103,0,37,115,32,101,118,101,110,116,32,97,116,32,116,105,109,101,32,37,46,49,50,103,0,0,116,105,109,101,0,0,0,0,115,116,97,116,101,0,0,0,68,105,115,97,98,108,101,100,32,116,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,98,101,99,97,117,115,101,32,116,104,101,32,111,117,116,112,117,116,32,102,105,108,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,103,101,110,101,114,97,116,101,100,58,32,37,115,0,0,0,83,105,109,117,108,97,116,105,111,110,32,99,97,108,108,32,116,101,114,109,105,110,97,116,101,40,41,32,97,116,32,116,105,109,101,32,37,102,10,77,101,115,115,97,103,101,32,58,32,37,115,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,73,110,116,101,103,114,97,116,111,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,109,105,120,101,100,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,112,114,111,98,97,98,108,121,32,97,32,115,116,114,111,110,103,32,99,111,109,112,111,110,101,110,116,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,102,108,97,103,115,32,45,108,118,32,76,79,71,95,78,76,83,44,32,76,79,71,95,76,83,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,81,117,97,115,105,83,116,97,116,105,111,110,97,114,121,47,83,105,110,103,108,101,80,104,97,115,101,46,109,111,0,0,84,101,109,112,101,114,97,116,117,114,101,32,111,117,116,115,105,100,101,32,115,99,111,112,101,32,111,102,32,109,111,100,101,108,33,0,0,0,0,0,96,3,0,0,175,1,0,0,7,0,0,0,175,1,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,1,0,0,0,3,0,0,0,13,0,0,0,4,0,0,0,14,0,0,0,6,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,69,114,114,111,114,32,119,104,105,108,101,32,105,110,105,116,105,97,108,105,122,101,32,68,97,116,97,0,0,0,0,0,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,81,117,97,115,105,83,116,97,116,105,111,110,97,114,121,46,77,97,99,104,105,110,101,115,46,69,120,97,109,112,108,101,115,46,84,114,97,110,115,102,111,114,109,101,114,84,101,115,116,98,101,110,99,104,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,81,117,97,115,105,83,116,97,116,105,111,110,97,114,121,0,123,56,99,52,101,56,49,48,102,45,51,100,102,51,45,52,97,48,48,45,56,50,55,54,45,49,55,54,102,97,51,99,57,102,57,101,48,125,0,0,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,81,117,97,115,105,83,116,97,116,105,111,110,97,114,121,46,77,97,99,104,105,110,101,115,46,69,120,97,109,112,108,101,115,46,84,114,97,110,115,102,111,114,109,101,114,84,101,115,116,98,101,110,99,104,95,105,110,102,111,46,120,109,108,0,0,0,0,0,83,116,97,99,107,32,111,118,101,114,102,108,111,119,32,100,101,116,101,99,116,101,100,32,97,110,100,32,119,97,115,32,110,111,116,32,99,97,117,103,104,116,46,10,83,101,110,100,32,117,115,32,97,32,98,117,103,32,114,101,112,111,114,116,32,97,116,32,104,116,116,112,115,58,47,47,116,114,97,99,46,111,112,101,110,109,111,100,101,108,105,99,97,46,111,114,103,47,79,112,101,110,77,111,100,101,108,105,99,97,47,110,101,119,116,105,99,107,101,116,10,32,32,32,32,73,110,99,108,117,100,101,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,116,114,97,99,101,58,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,1,0,0,0,46,1,0,0,116,114,97,110,115,102,111,114,109,101,114,46,99,111,114,101,46,110,49,51,0,0,0,0,116,114,97,110,115,102,111,114,109,101,114,46,99,111,114,101,46,110,49,50,0,0,0,0,1,0,0,0,85,1,0,0,1,0,0,0,98,1,0,0,1,0,0,0,101,1,0,0,1,0,0,0,111,1,0,0,1,0,0,0,115,1,0,0,1,0,0,0,180,5,0,0,1,0,0,0,181,5,0,0,1,0,0,0,184,5,0,0,1,0,0,0,185,5,0,0,1,0,0,0,196,5,0,0,1,0,0,0,197,5,0,0,1,0,0,0,219,5,0,0,1,0,0,0,220,5,0,0,1,0,0,0,60,6,0,0,1,0,0,0,62,6,0,0,1,0,0,0,66,6,0,0,1,0,0,0,68,6,0,0,1,0,0,0,100,6,0,0,1,0,0,0,101,6,0,0,101,109,112,116,121,0,0,0,99,104,101,99,107,32,102,111,114,32,100,105,115,99,114,101,116,101,32,99,104,97,110,103,101,115,0,0,0,0,0,0,115,111,117,114,99,101,46,118,111,108,116,97,103,101,83,111,117,114,99,101,91,49,93,46,112,105,110,95,112,46,114,101,102,101,114,101,110,99,101,46,103,97,109,109,97,0,0,0,115,111,117,114,99,101,46,118,111,108,116,97,103,101,83,111,117,114,99,101,91,50,93,46,112,105,110,95,112,46,114,101,102,101,114,101,110,99,101,46,103,97,109,109,97,0,0,0,115,111,117,114,99,101,46,118,111,108,116,97,103,101,83,111,117,114,99,101,91,51,93,46,112,105,110,95,112,46,114,101,102,101,114,101,110,99,101,46,103,97,109,109,97,0,0,0,24,8,0,0,72,8,0,0,120,8,0,0,0,0,0,0,117,112,100,97,116,105,110,103,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,91,37,100,93,58,32,37,115,32,61,32,37,103,0,0,0,1,0,0,0,1,0,0,0,49,46,48,32,43,32,116,114,97,110,115,102,111,114,109,101,114,46,97,108,112,104,97,50,48,95,50,32,42,32,40,45,50,57,51,46,49,53,32,43,32,116,114,97,110,115,102,111,114,109,101,114,46,84,50,82,101,102,41,0,0,0,0,0,1,0,0,0,3,0,0,0,1,0,0,0,5,0,0,0,1,0,0,0,13,0,0,0,49,46,48,32,43,32,116,114,97,110,115,102,111,114,109,101,114,46,97,108,112,104,97,50,48,95,49,32,42,32,40,45,50,57,51,46,49,53,32,43,32,116,114,97,110,115,102,111,114,109,101,114,46,84,49,82,101,102,41,0,0,0,0,0,1,0,0,0,15,0,0,0,1,0,0,0,17,0,0,0,1,0,0,0,29,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,48,46,48,48,48,54,50,53,48,48,48,48,48,48,48,48,48,48,48,48,49,32,45,32,116,114,97,110,115,102,111,114,109,101,114,68,97,116,97,46,82,50,32,94,32,50,46,48,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,116,114,97,110,115,102,111,114,109,101,114,68,97,116,97,46,102,32,42,32,54,46,50,56,51,49,56,53,51,48,55,49,55,57,53,56,54,0,0,0,1,0,0,0,45,0,0,0,160,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,54,46,57,52,52,52,52,52,52,52,52,52,52,52,52,53,101,45,48,53,32,45,32,116,114,97,110,115,102,111,114,109,101,114,68,97,116,97,46,82,49,32,94,32,50,46,48,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,1,0,0,0,60,0,0,0,116,114,97,110,115,102,111,114,109,101,114,68,97,116,97,46,86,50,0,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,105,110,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,97,120,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,110,111,109,105,110,97,108,45,118,97,108,117,101,115,0,117,112,100,97,116,105,110,103,32,115,116,97,114,116,45,118,97,108,117,101,115,0,0,0,1,0,0,0,116,8,0,0,116,114,97,110,115,102,111,114,109,101,114,68,97,116,97,46,86,50,0,0,0,0,0,0,1,0,0,0,119,8,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,54,46,57,52,52,52,52,52,52,52,52,52,52,52,52,53,101,45,48,53,32,45,32,116,114,97,110,115,102,111,114,109,101,114,68,97,116,97,46,82,49,32,94,32,50,46,48,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,116,114,97,110,115,102,111,114,109,101,114,68,97,116,97,46,102,32,42,32,54,46,50,56,51,49,56,53,51,48,55,49,55,57,53,56,54,0,0,0,1,0,0,0,120,8,0,0,104,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,48,46,48,48,48,54,50,53,48,48,48,48,48,48,48,48,48,48,48,48,49,32,45,32,116,114,97,110,115,102,111,114,109,101,114,68,97,116,97,46,82,50,32,94,32,50,46,48,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,1,0,0,0,141,8,0,0,49,46,48,32,43,32,116,114,97,110,115,102,111,114,109,101,114,46,97,108,112,104,97,50,48,95,49,32,42,32,40,45,50,57,51,46,49,53,32,43,32,116,114,97,110,115,102,111,114,109,101,114,46,84,49,82,101,102,41,0,0,0,0,0,1,0,0,0,142,8,0,0,1,0,0,0,143,8,0,0,1,0,0,0,175,8,0,0,49,46,48,32,43,32,116,114,97,110,115,102,111,114,109,101,114,46,97,108,112,104,97,50,48,95,50,32,42,32,40,45,50,57,51,46,49,53,32,43,32,116,114,97,110,115,102,111,114,109,101,114,46,84,50,82,101,102,41,0,0,0,0,0,1,0,0,0,176,8,0,0,1,0,0,0,177,8,0,0,0,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,99,111,114,101,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,99,111,114,101,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,81,117,97,115,105,83,116,97,116,105,111,110,97,114,121,47,77,97,99,104,105,110,101,115,46,109,111,0,0,0,0,0,168,13,0,0,64,8,0,0,9,0,0,0,64,8,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,81,117,97,115,105,83,116,97,116,105,111,110,97,114,121,47,77,117,108,116,105,80,104,97,115,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,50,115,105,103,109,97,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,114,101,115,105,115,116,111,114,91,51,93,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,114,101,115,105,115,116,111,114,91,51,93,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,81,117,97,115,105,83,116,97,116,105,111,110,97,114,121,47,83,105,110,103,108,101,80,104,97,115,101,46,109,111,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,114,101,115,105,115,116,111,114,91,51,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,114,101,115,105,115,116,111,114,91,51,93,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,65,110,97,108,111,103,47,73,110,116,101,114,102,97,99,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,114,101,115,105,115,116,111,114,91,50,93,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,114,101,115,105,115,116,111,114,91,50,93,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,114,101,115,105,115,116,111,114,91,50,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,114,101,115,105,115,116,111,114,91,50,93,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,114,101,115,105,115,116,111,114,91,49,93,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,114,101,115,105,115,116,111,114,91,49,93,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,114,101,115,105,115,116,111,114,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,114,101,115,105,115,116,111,114,91,49,93,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,84,95,114,101,102,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,84,95,114,101,102,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,84,95,114,101,102,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,84,95,114,101,102,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,84,95,114,101,102,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,84,95,114,101,102,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,84,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,84,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,77,117,108,116,105,80,104,97,115,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,84,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,84,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,84,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,84,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,109,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,109,104,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
/* memory initializer */ allocate([91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,50,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,108,49,115,105,103,109,97,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,114,101,115,105,115,116,111,114,91,51,93,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,114,101,115,105,115,116,111,114,91,51,93,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,114,101,115,105,115,116,111,114,91,51,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,114,101,115,105,115,116,111,114,91,51,93,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,114,101,115,105,115,116,111,114,91,50,93,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,114,101,115,105,115,116,111,114,91,50,93,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,114,101,115,105,115,116,111,114,91,50,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,114,101,115,105,115,116,111,114,91,50,93,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,114,101,115,105,115,116,111,114,91,49,93,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,114,101,115,105,115,116,111,114,91,49,93,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,114,101,115,105,115,116,111,114,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,114,101,115,105,115,116,111,114,91,49,93,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,84,95,114,101,102,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,84,95,114,101,102,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,84,95,114,101,102,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,84,95,114,101,102,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,84,95,114,101,102,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,84,95,114,101,102,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,84,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,84,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,84,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,84,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,84,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,84,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,109,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,109,104,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,114,49,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,116,104,101,114,109,97,108,65,109,98,105,101,110,116,46,116,101,109,112,101,114,97,116,117,114,101,67,111,114,101,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,116,104,101,114,109,97,108,65,109,98,105,101,110,116,46,116,101,109,112,101,114,97,116,117,114,101,67,111,114,101,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,84,104,101,114,109,97,108,47,72,101,97,116,84,114,97,110,115,102,101,114,46,109,111,0,0,0,0,64,69,0,0,108,5,0,0,7,0,0,0,108,5,0,0,75,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,116,104,101,114,109,97,108,65,109,98,105,101,110,116,46,84,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,116,104,101,114,109,97,108,65,109,98,105,101,110,116,46,84,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,77,97,99,104,105,110,101,115,46,109,111,0,0,0,0,0,40,70,0,0,43,50,0,0,7,0,0,0,45,50,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,116,104,101,114,109,97,108,65,109,98,105,101,110,116,46,84,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,116,104,101,114,109,97,108,65,109,98,105,101,110,116,46,84,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,40,70,0,0,40,50,0,0,7,0,0,0,42,50,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,116,104,101,114,109,97,108,65,109,98,105,101,110,116,46,116,104,101,114,109,97,108,67,111,108,108,101,99,116,111,114,50,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,116,104,101,114,109,97,108,65,109,98,105,101,110,116,46,116,104,101,114,109,97,108,67,111,108,108,101,99,116,111,114,50,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,116,104,101,114,109,97,108,65,109,98,105,101,110,116,46,116,104,101,114,109,97,108,67,111,108,108,101,99,116,111,114,49,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,116,104,101,114,109,97,108,65,109,98,105,101,110,116,46,116,104,101,114,109,97,108,67,111,108,108,101,99,116,111,114,49,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,64,69,0,0,209,3,0,0,7,0,0,0,209,3,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,116,104,101,114,109,97,108,65,109,98,105,101,110,116,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,116,104,101,114,109,97,108,65,109,98,105,101,110,116,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,40,70,0,0,34,50,0,0,7,0,0,0,34,50,0,0,56,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+10240);
/* memory initializer */ allocate([46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,68,101,108,116,97,50,46,109,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,115,116,97,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,115,116,97,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,115,116,97,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,115,116,97,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,115,116,97,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,115,116,97,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,115,116,97,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,115,116,97,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,115,116,97,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,115,116,97,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,115,116,97,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,115,116,97,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,46,115,116,97,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,115,116,97,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,115,116,97,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,115,116,97,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,115,116,97,114,49,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,115,116,97,114,49,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,115,116,97,114,49,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,84,50,79,112,101,114,97,116,105,111,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,84,50,79,112,101,114,97,116,105,111,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,168,13,0,0,251,8,0,0,7,0,0,0,253,8,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,84,49,79,112,101,114,97,116,105,111,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,84,49,79,112,101,114,97,116,105,111,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,168,13,0,0,248,8,0,0,7,0,0,0,250,8,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,84,50,82,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,84,50,82,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,168,13,0,0,234,8,0,0,7,0,0,0,236,8,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,46,84,49,82,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,46,84,49,82,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,168,13,0,0,220,8,0,0,7,0,0,0,222,8,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,110,115,102,111,114,109,101,114,68,97,116,97,46,118,95,115,99,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,110,115,102,111,114,109,101,114,68,97,116,97,46,118,95,115,99,32,62,61,32,48,46,48,32,97,110,100,32,116,114,97,110,115,102,111,114,109,101,114,68,97,116,97,46,118,95,115,99,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,40,70,0,0,227,62,0,0,7,0,0,0,228,62,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,115,116,97,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,115,116,97,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,115,116,97,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,76,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,76,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,114,101,115,105,115,116,111,114,91,51,93,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,114,101,115,105,115,116,111,114,91,51,93,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,114,101,115,105,115,116,111,114,91,51,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,114,101,115,105,115,116,111,114,91,51,93,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,114,101,115,105,115,116,111,114,91,50,93,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,114,101,115,105,115,116,111,114,91,50,93,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,114,101,115,105,115,116,111,114,91,50,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,114,101,115,105,115,116,111,114,91,50,93,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,114,101,115,105,115,116,111,114,91,49,93,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,114,101,115,105,115,116,111,114,91,49,93,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,114,101,115,105,115,116,111,114,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,114,101,115,105,115,116,111,114,91,49,93,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,84,95,114,101,102,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,84,95,114,101,102,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,84,95,114,101,102,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,84,95,114,101,102,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,84,95,114,101,102,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,84,95,114,101,102,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,15,0,0,64,2,0,0,7,0,0,0,65,2,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,84,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,84,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,84,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,84,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,84,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,84,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,192,30,0,0,218,12,0,0,7,0,0,0,219,12,0,0,102,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,109,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,109,104,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,192,30,0,0,214,12,0,0,7,0,0,0,214,12,0,0,75,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+20480);
/* memory initializer */ allocate([116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,76,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,76,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,76,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,76,46,109,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+30720);
/* memory initializer */ allocate([105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,76,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,97,114,116,104,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,97,114,116,104,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,160,26,0,0,50,1,0,0,5,0,0,0,51,1,0,0,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,97,114,116,104,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,97,114,116,104,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,192,25,0,0,167,1,0,0,7,0,0,0,168,1,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,101,108,116,97,83,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,101,108,116,97,83,46,109,32,62,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,15,0,0,68,1,0,0,7,0,0,0,68,1,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,101,110,115,111,114,83,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,83,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+40960);
/* memory initializer */ allocate([78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,101,108,101,99,116,114,105,99,97,108,80,111,119,101,114,83,101,110,115,111,114,83,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,15,0,0,248,6,0,0,7,0,0,0,248,6,0,0,56,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,115,116,97,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,115,116,97,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,115,116,97,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,83,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,83,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,83,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,15,0,0,18,1,0,0,7,0,0,0,18,1,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,15,0,0,174,1,0,0,7,0,0,0,176,1,0,0,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,15,0,0,173,1,0,0,7,0,0,0,173,1,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,15,0,0,14,2,0,0,7,0,0,0,14,2,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,15,0,0,124,1,0,0,7,0,0,0,126,1,0,0,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,15,0,0,123,1,0,0,7,0,0,0,123,1,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,15,0,0,223,1,0,0,7,0,0,0,223,1,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,15,0,0,188,8,0,0,7,0,0,0,188,8,0,0,56,0,0,0,0,0,0,0,109,111,100,101,108,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,69,108,101,99,116,114,105,99,97,108,95,81,117,97,115,105,83,116,97,116,105,111,110,97,114,121,95,77,97,99,104,105,110,101,115,95,69,120,97,109,112,108,101,115,95,84,114,97,110,115,102,111,114,109,101,114,84,101,115,116,98,101,110,99,104,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,110,32,61,32,51,59,32,47,47,32,115,116,97,116,101,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,107,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,105,110,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,108,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,111,117,116,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,120,48,91,51,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,117,48,91,48,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,65,91,51,44,51,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,66,91,51,44,48,93,32,61,32,122,101,114,111,115,40,51,44,48,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,67,91,48,44,51,93,32,61,32,122,101,114,111,115,40,48,44,51,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,68,91,48,44,48,93,32,61,32,122,101,114,111,115,40,48,44,48,41,59,37,115,10,32,32,82,101,97,108,32,120,91,51,93,40,115,116,97,114,116,61,120,48,41,59,10,32,32,105,110,112,117,116,32,82,101,97,108,32,117,91,48,93,59,10,32,32,111,117,116,112,117,116,32,82,101,97,108,32,121,91,48,93,59,10,10,32,32,82,101,97,108,32,120,95,80,115,111,117,114,99,101,80,118,111,108,116,97,103,101,83,111,117,114,99,101,108,66,49,114,66,80,112,105,110,95,112,80,114,101,102,101,114,101,110,99,101,80,103,97,109,109,97,32,61,32,120,91,49,93,59,10,32,32,82,101,97,108,32,120,95,80,115,111,117,114,99,101,80,118,111,108,116,97,103,101,83,111,117,114,99,101,108,66,51,114,66,80,112,105,110,95,112,80,114,101,102,101,114,101,110,99,101,80,103,97,109,109,97,32,61,32,120,91,50,93,59,10,32,32,82,101,97,108,32,120,95,80,115,111,117,114,99,101,80,118,111,108,116,97,103,101,83,111,117,114,99,101,108,66,50,114,66,80,112,105,110,95,112,80,114,101,102,101,114,101,110,99,101,80,103,97,109,109,97,32,61,32,120,91,51,93,59,10,32,32,32,32,32,32,10,101,113,117,97,116,105,111,110,10,32,32,100,101,114,40,120,41,32,61,32,65,32,42,32,120,32,43,32,66,32,42,32,117,59,10,32,32,121,32,61,32,67,32,42,32,120,32,43,32,68,32,42,32,117,59,10,101,110,100,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,69,108,101,99,116,114,105,99,97,108,95,81,117,97,115,105,83,116,97,116,105,111,110,97,114,121,95,77,97,99,104,105,110,101,115,95,69,120,97,109,112,108,101,115,95,84,114,97,110,115,102,111,114,109,101,114,84,101,115,116,98,101,110,99,104,59,10,0,0,0,0,0,0,0,0,68,71,69,82,32,32,0,0,78,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,68,71,69,77,77,32,0,0,76,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,84,82,83,77,32,0,0,68,71,69,83,86,32,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,68,71,69,84,70,50,0,0,83,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,68,71,69,84,82,70,0,0,1,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,191,78,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,71,69,84,82,83,0,0,1,0,0,0,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,85,112,112,101,114,0,0,0,78,111,110,45,117,110,105,116,0,0,0,0,0,0,0,0,84,114,97,110,115,112,111,115,101,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,71,69,0,0,0,0,0,0,84,82,70,0,0,0,0,0,81,82,70,0,0,0,0,0,82,81,70,0,0,0,0,0,76,81,70,0,0,0,0,0,81,76,70,0,0,0,0,0,72,82,68,0,0,0,0,0,66,82,68,0,0,0,0,0,84,82,73,0,0,0,0,0,80,79,0,0,0,0,0,0,83,89,0,0,0,0,0,0,84,82,68,0,0,0,0,0,71,83,84,0,0,0,0,0,72,69,0,0,0,0,0,0,79,82,0,0,0,0,0,0,81,82,0,0,0,0,0,0,82,81,0,0,0,0,0,0,76,81,0,0,0,0,0,0,81,76,0,0,0,0,0,0,72,82,0,0,0,0,0,0,84,82,0,0,0,0,0,0,66,82,0,0,0,0,0,0,85,78,0,0,0,0,0,0,71,66,0,0,0,0,0,0,80,66,0,0,0,0,0,0,76,65,0,0,0,0,0,0,85,85,77,0,0,0,0,0,83,84,0,0,0,0,0,0,69,66,90,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,234,0,0,16,234,0,0,32,234,0,0,56,234,0,0,88,234,0,0,104,234,0,0,128,234,0,0,144,234,0,0,168,234,0,0,200,234,0,0,240,234,0,0,8,235,0,0,40,235,0,0,64,235,0,0,104,235,0,0,136,235,0,0,184,235,0,0,232,235,0,0,0,236,0,0,56,236,0,0,80,236,0,0,128,236,0,0,160,236,0,0,216,236,0,0,0,237,0,0,56,237,0,0,104,237,0,0,120,237,0,0,152,237,0,0,192,237,0,0,224,237,0,0,8,238,0,0,48,238,0,0,72,238,0,0,96,238,0,0,112,238,0,0,136,238,0,0,184,238,0,0,8,239,0,0,72,239,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,115,121,110,116,97,120,32,101,114,114,111,114,0,0,0,0,110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0,0,0,0,0,0,0,0,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0,117,110,99,108,111,115,101,100,32,116,111,107,101,110,0,0,112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,109,105,115,109,97,116,99,104,101,100,32,116,97,103,0,0,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0,0,0,0,0,0,0,0,114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0,0,101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0,0,0,0,0,0,101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0,0,0,0,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0,0,0,0,117,110,98,111,117,110,100,32,112,114,101,102,105,120,0,0,109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0,0,0,0,0,0,0,105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0,0,0,0,0,0,0,112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0,0,0,0,0,0,0,0,112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0,0,0,0,112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0,112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0,0,0,0,0,0,112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,35,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,89,0,0,69,78,84,73,84,73,69,83], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+51200);
/* memory initializer */ allocate([0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,40,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,4,254,255,255,135,254,255,255,7,0,0,0,0,0,0,0,0,255,255,127,255,255,255,127,255,255,255,255,255,255,255,243,127,254,253,255,255,255,255,255,127,255,255,255,255,255,255,255,255,15,224,255,255,255,255,49,252,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,3,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,0,0,0,0,0,0,0,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,254,7,0,0,0,0,254,255,255,255,255,255,255,255,255,124,255,127,47,0,96,0,0,0,224,255,255,255,255,255,255,35,0,0,0,255,3,0,0,0,224,159,249,255,255,253,197,3,0,0,0,176,3,0,3,0,224,135,249,255,255,253,109,3,0,0,0,94,0,0,28,0,224,175,251,255,255,253,237,35,0,0,0,0,1,0,0,0,224,159,249,255,255,253,205,35,0,0,0,176,3,0,0,0,224,199,61,214,24,199,191,3,0,0,0,0,0,0,0,0,224,223,253,255,255,253,239,3,0,0,0,0,3,0,0,0,224,223,253,255,255,253,239,3,0,0,0,64,3,0,0,0,224,223,253,255,255,253,255,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,13,0,63,0,0,0,0,0,0,0,150,37,240,254,174,108,13,32,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,254,255,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,63,0,255,255,255,255,127,0,237,218,7,0,0,0,0,80,1,80,49,130,171,98,44,0,0,0,0,64,0,201,128,245,7,0,0,0,0,8,1,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,3,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,64,76,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,254,3,0,0,254,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,7,224,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,7,254,255,255,135,254,255,255,7,0,0,0,0,0,0,128,0,255,255,127,255,255,255,127,255,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,3,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,3,0,0,0,192,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,123,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,254,255,251,255,255,187,22,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,255,255,7,0,255,3,255,255,255,255,255,255,255,255,255,124,255,127,239,255,255,61,255,3,238,255,255,255,255,255,255,243,255,63,30,255,207,255,0,0,238,159,249,255,255,253,197,211,159,57,128,176,207,255,3,0,228,135,249,255,255,253,109,211,135,57,0,94,192,255,31,0,238,175,251,255,255,253,237,243,191,59,0,0,193,255,0,0,238,159,249,255,255,253,205,243,143,57,192,176,195,255,0,0,236,199,61,214,24,199,191,195,199,61,128,0,128,255,0,0,238,223,253,255,255,253,239,195,223,61,96,0,195,255,0,0,236,223,253,255,255,253,239,195,223,61,96,64,195,255,0,0,236,223,253,255,255,253,255,195,207,61,128,0,195,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,255,7,255,127,255,3,0,0,0,0,150,37,240,254,174,108,255,59,95,63,255,3,0,0,0,0,0,0,0,3,255,3,160,194,255,254,255,255,255,3,254,255,223,15,191,254,255,63,254,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,31,2,0,0,0,160,0,0,0,254,255,62,0,254,255,255,255,255,255,255,255,255,255,31,102,254,255,255,255,255,255,255,255,255,255,255,119,25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,120,253,0,0,8,252,0,0,144,250,0,0,24,249,0,0,24,249,0,0,160,247,0,0,144,250,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,64,8,1,0,200,4,1,0,88,3,1,0,232,1,1,0,232,1,1,0,120,0,1,0,88,3,1,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,101,114,115,105,111,110,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,121,101,115,0,0,0,0,0,110,111,0,0,0,0,0,0,136,6,1,0,152,6,1,0,168,6,1,0,120,247,0,0,176,6,1,0,192,6,1,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,65,84,84,76,73,83,84,0,69,76,69,77,69,78,84,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,69,77,80,84,89,0,0,0,65,78,89,0,0,0,0,0,80,67,68,65,84,65,0,0,32,10,1,0,40,10,1,0,48,10,1,0,56,10,1,0,176,9,1,0,64,10,1,0,80,10,1,0,88,10,1,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,73,77,80,76,73,69,68,0,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,0,70,73,88,69,68,0,0,0,78,68,65,84,65,0,0,0,73,78,67,76,85,68,69,0,73,71,78,79,82,69,0,0,68,79,67,84,89,80,69,0,0,0,0,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,105,115,32,78,85,76,76,33,10,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,97,114,101,32,60,32,48,33,10,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,115,105,122,101,115,32,97,114,101,32,78,85,76,76,33,10,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,32,115,105,122,101,32,102,111,114,32,100,105,109,101,110,115,105,111,110,32,37,100,32,105,115,32,37,100,32,60,32,48,33,10,0,117,116,105,108,47,98,97,115,101,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,97,45,62,110,100,105,109,115,32,33,61,32,98,45,62,110,100,105,109,115,44,32,37,100,32,33,61,32,37,100,10,0,97,45,62,100,105,109,95,115,105,122,101,91,37,100,93,32,33,61,32,98,45,62,100,105,109,95,115,105,122,101,91,37,100,93,44,32,37,100,32,33,61,32,37,100,10,0,0,0,105,110,100,101,120,32,115,112,101,99,32,100,105,109,101,110,115,105,111,110,115,32,97,110,100,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,100,111,32,110,111,116,32,97,103,114,101,101,32,37,100,32,33,61,32,37,100,10,0,0,0,0,0,0,0,115,99,97,108,97,114,32,115,45,62,105,110,100,101,120,91,37,100,93,91,48,93,32,61,61,32,37,100,32,105,110,99,111,114,114,101,99,116,44,32,97,45,62,100,105,109,95,115,105,122,101,91,37,100,93,32,61,61,32,37,100,10,0,0,97,114,114,97,121,32,115,45,62,105,110,100,101,120,91,37,100,93,91,37,100,93,32,61,61,32,37,100,32,105,110,99,111,114,114,101,99,116,44,32,97,45,62,100,105,109,95,115,105,122,101,91,37,100,93,32,61,61,32,37,100,10,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,115,111,117,114,99,101,41,0,0,0,99,108,111,110,101,95,98,97,115,101,95,97,114,114,97,121,95,115,112,101,99,0,0,0,100,101,115,116,45,62,100,105,109,95,115,105,122,101,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,114,114,41,0,0,0,0,0,0,99,97,108,99,95,98,97,115,101,95,105,110,100,101,120,95,115,112,101,99,0,0,0,0,105,110,100,101,120,95,115,112,101,99,95,111,107,40,115,112,101,99,41,0,0,0,0,0,105,110,100,101,120,95,115,112,101,99,95,102,105,116,95,98,97,115,101,95,97,114,114,97,121,40,115,112,101,99,44,32,97,114,114,41,0,0,0,0,40,110,100,105,109,115,32,61,61,32,97,114,114,45,62,110,100,105,109,115,41,32,38,38,32,40,110,100,105,109,115,32,61,61,32,115,112,101,99,45,62,110,100,105,109,115,41,0,0,0,0,0,0,0,0,0,136,13,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,68,105,109,101,110,115,105,111,110,32,37,100,32,104,97,115,32,98,111,117,110,100,115,32,49,46,46,37,100,44,32,103,111,116,32,97,114,114,97,121,32,115,117,98,115,99,114,105,112,116,32,37,100,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,115,105,122,101,95,111,102,95,100,105,109,101,110,115,105,111,110,95,98,97,115,101,95,97,114,114,97,121,0,0,0,0,40,105,32,62,32,48,41,32,38,38,32,40,105,32,60,61,32,97,45,62,110,100,105,109,115,41,0,0,0,0,0,0,3,0,0,0,0,0,0,0,76,79,71,95,85,78,75,78,79,87,78,0,0,0,0,0,115,116,100,111,117,116,0,0,97,115,115,101,114,116,0,0,76,79,71,95,68,68,65,83,82,84,0,0,0,0,0,0,76,79,71,95,68,69,66,85,71,0,0,0,0,0,0,0,76,79,71,95,68,83,83,0,76,79,71,95,68,83,83,95,74,65,67,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,0,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,95,86,0,0,0,0,76,79,71,95,73,78,73,84,0,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,95,70,85,76,76,0,0,76,79,71,95,73,80,79,80,84,95,74,65,67,0,0,0,76,79,71,95,73,80,79,80,84,95,72,69,83,83,69,0,76,79,71,95,74,65,67,0,76,79,71,95,76,83,0,0,76,79,71,95,76,83,95,86,0,0,0,0,0,0,0,0,76,79,71,95,78,76,83,0,76,79,71,95,78,76,83,95,86,0,0,0,0,0,0,0,76,79,71,95,78,76,83,95,74,65,67,0,0,0,0,0,76,79,71,95,78,76,83,95,82,69,83,0,0,0,0,0,76,79,71,95,82,69,83,95,73,78,73,84,0,0,0,0,76,79,71,95,83,73,77,85,76,65,84,73,79,78,0,0,76,79,71,95,83,79,76,86,69,82,0,0,0,0,0,0,76,79,71,95,83,79,84,73,0,0,0,0,0,0,0,0,76,79,71,95,83,84,65,84,83,0,0,0,0,0,0,0,76,79,71,95,85,84,73,76,0,0,0,0,0,0,0,0,76,79,71,95,90,69,82,79,67,82,79,83,83,73,78,71,83,0,0,0,0,0,0,0,64,14,1,0,80,14,1,0,88,14,1,0,96,14,1,0,112,14,1,0,128,14,1,0,136,14,1,0,152,14,1,0,168,14,1,0,184,14,1,0,200,14,1,0,216,14,1,0,232,14,1,0,248,14,1,0,8,15,1,0,16,15,1,0,24,15,1,0,40,15,1,0,48,15,1,0,64,15,1,0,80,15,1,0,96,15,1,0,112,15,1,0,128,15,1,0,144,15,1,0,160,15,1,0,176,15,1,0,192,15,1,0,117,110,107,110,111,119,110,0,116,104,105,115,32,115,116,114,101,97,109,32,105,115,32,97,108,119,97,121,115,32,97,99,116,105,118,101,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,97,115,115,108,32,115,111,108,118,101,114,0,0,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,100,101,98,117,103,32,105,110,102,111,114,109,97,116,105,111,110,0,0,0,0,111,117,116,112,117,116,115,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,106,97,99,111,98,105,97,110,32,111,102,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,101,118,101,110,116,32,115,121,115,116,101,109,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,0,0,0,99,104,101,99,107,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,0,0,0,0,0,0,0,99,104,101,99,107,32,104,101,115,115,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,117,115,101,100,32,98,121,32,100,97,115,115,108,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,101,118,101,114,121,32,101,118,97,108,117,97,116,105,111,110,32,111,102,32,116,104,101,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,114,101,115,105,100,117,97,108,115,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,105,109,117,108,97,116,105,111,110,32,112,114,111,99,101,115,115,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,111,108,118,101,114,32,112,114,111,99,101,115,115,0,0,0,0,0,102,105,110,97,108,32,115,111,108,117,116,105,111,110,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,115,116,97,116,105,115,116,105,99,115,32,97,98,111,117,116,32,116,105,109,101,114,47,101,118,101,110,116,115,47,115,111,108,118,101,114,0,63,63,63,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,116,104,101,32,122,101,114,111,99,114,111,115,115,105,110,103,115,0,0,72,16,1,0,80,16,1,0,80,16,1,0,112,16,1,0,160,16,1,0,192,16,1,0,248,16,1,0,40,17,1,0,88,17,1,0,120,17,1,0,168,17,1,0,192,17,1,0,224,17,1,0,8,18,1,0,40,18,1,0,88,18,1,0,120,18,1,0,160,18,1,0,192,18,1,0,232,18,1,0,24,19,1,0,80,19,1,0,120,19,1,0,168,19,1,0,216,19,1,0,0,20,1,0,48,20,1,0,56,20,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91,37,115,58,37,100,58,37,100,45,37,100,58,37,100,58,37,115,93,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,37,45,49,55,115,32,124,32,0,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,37,45,55,115,32,124,32,0,72,16,1,0,56,23,1,0,64,23,1,0,72,23,1,0,88,14,1,0,80,23,1,0,124,32,0,0,0,0,0,0,60,109,101,115,115,97,103,101,32,115,116,114,101,97,109,61,34,37,115,34,32,116,121,112,101,61,34,37,115,34,32,116,101,120,116,61,34,0,0,0,34,62,10,0,0,0,0,0,60,117,115,101,100,32,105,110,100,101,120,61,34,37,100,34,32,47,62,10,0,0,0,0,60,47,109,101,115,115,97,103,101,62,10,0,0,0,0,0,34,32,47,62,10,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,38,97,109,112,59,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,105,110,102,111,0,0,0,0,119,97,114,110,105,110,103,0,101,114,114,111,114,0,0,0,100,101,98,117,103,0,0,0,34,62,0,0,0,0,0,0,115,111,108,118,101,114,32,119,105,108,108,32,116,114,121,32,116,111,32,104,97,110,100,108,101,32,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,58,32,37,115,0,0,0,0,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,44,32,100,105,118,105,115,111,114,58,32,37,115,0,0,0,0,0,105,110,100,101,120,95,115,112,101,99,95,111,107,58,32,116,104,101,32,105,110,100,101,120,32,115,112,101,99,32,105,115,32,78,85,76,76,33,10,0,105,110,100,101,120,95,115,112,101,99,95,111,107,58,32,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+61440);
/* memory initializer */ allocate([104,101,32,105,110,100,101,120,32,115,112,101,99,32,100,105,109,101,110,115,105,111,110,115,32,97,114,101,32,110,101,103,97,116,105,118,101,58,32,37,100,33,10,0,0,0,0,0,105,110,100,101,120,95,115,112,101,99,95,111,107,58,32,116,104,101,32,105,110,100,101,120,32,115,112,101,99,32,100,105,109,101,110,115,105,111,110,115,32,115,105,122,101,115,32,105,115,32,78,85,76,76,33,10,0,0,0,0,0,0,0,0,105,110,100,101,120,95,115,112,101,99,95,111,107,58,32,116,104,101,32,105,110,100,101,120,32,115,112,101,99,32,105,110,100,101,120,32,97,114,114,97,121,32,105,115,32,78,85,76,76,33,10,0,0,0,0,0,105,110,100,101,120,95,115,112,101,99,95,111,107,58,32,116,104,101,32,105,110,100,101,120,32,115,112,101,99,32,100,105,109,101,110,115,105,111,110,32,115,105,122,101,32,102,111,114,32,100,105,109,101,110,115,105,111,110,32,37,100,32,105,115,32,110,101,103,97,116,105,118,101,58,32,37,100,33,10,0,105,110,100,101,120,91,37,100,93,32,61,61,32,48,44,32,115,105,122,101,32,61,61,32,37,100,10,0,0,0,0,0,117,116,105,108,47,105,110,116,101,103,101,114,95,97,114,114,97,121,46,99,0,0,0,0,115,116,101,112,32,33,61,32,48,0,0,0,0,0,0,0,99,114,101,97,116,101,95,105,110,116,101,103,101,114,95,97,114,114,97,121,95,102,114,111,109,95,114,97,110,103,101,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,101,109,112,116,121,32,108,105,115,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,102,105,115,116,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,110,111,100,101,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,100,97,116,97,32,110,111,100,101,0,0,0,0,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,27,0,0,0,2,0,0,0,2,0,0,0,28,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,105,110,84,114,97,110,115,0,0,0,0,0,0,0,0,64,26,1,0,0,0,0,0,98,105,110,78,111,114,109,97,108,0,0,0,0,0,0,0,88,26,1,0,0,0,0,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,100,97,116,97,95,50,0,0,112,26,1,0,120,26,1,0,128,26,1,0,144,26,1,0,160,26,1,0,168,26,1,0,51,0,0,0,51,0,0,0,51,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,49,41,0,0,0,0,0,0,77,97,116,114,105,120,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,0,0,0,77,97,116,114,105,120,32,117,115,101,115,32,105,109,97,103,105,110,97,114,121,32,110,117,109,98,101,114,115,0,0,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,105,122,101,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,50,41,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,51,41,0,0,0,0,0,0,77,97,116,114,105,120,32,110,97,109,101,32,109,105,115,109,97,116,99,104,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,52,32,114,111,119,115,0,0,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,49,32,99,111,108,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,65,99,108,97,115,115,32,109,97,116,114,105,120,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,98,105,110,84,114,97,110,115,32,111,114,32,98,105,110,78,111,114,109,97,108,32,102,111,114,109,97,116,0,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,110,97,109,101,115,32,109,97,116,114,105,120,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,73,110,102,111,32,109,97,116,114,105,120,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,49,32,118,97,114,105,97,98,108,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,99,111,108,115,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,49,32,109,97,116,114,105,120,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,99,111,110,116,97,105,110,101,100,32,112,97,114,97,109,101,116,101,114,32,116,104,97,116,32,99,104,97,110,103,101,100,32,98,101,116,119,101,101,110,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,45,116,105,109,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,114,111,119,115,0,84,111,111,32,102,101,119,32,114,111,119,115,32,105,110,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,73,109,112,108,101,109,101,110,116,97,116,105,111,110,32,101,114,114,111,114,58,32,85,110,107,110,111,119,110,32,99,97,115,101,0,0,0,0,0,0,97,98,115,86,97,114,73,110,100,101,120,32,62,32,48,32,38,38,32,97,98,115,86,97,114,73,110,100,101,120,32,60,61,32,114,101,97,100,101,114,45,62,110,118,97,114,0,0,117,116,105,108,47,114,101,97,100,95,109,97,116,108,97,98,52,46,99,0,0,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,118,97,108,115,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,115,105,110,103,108,101,95,118,97,108,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,115,111,117,114,99,101,41,0,0,0,117,116,105,108,47,114,101,97,108,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,99,111,112,121,95,114,101,97,108,95,97,114,114,97,121,95,100,97,116,97,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,100,101,115,116,41,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,115,104,97,112,101,95,101,113,40,115,111,117,114,99,101,44,32,100,101,115,116,41,0,0,0,0,0,0,0,105,110,100,101,120,101,100,95,97,115,115,105,103,110,95,114,101,97,108,95,97,114,114,97,121,0,0,0,0,0,0,0,105,110,100,101,120,95,115,112,101,99,95,111,107,40,100,101,115,116,95,115,112,101,99,41,0,0,0,0,0,0,0,0,105,110,100,101,120,95,115,112,101,99,95,102,105,116,95,98,97,115,101,95,97,114,114,97,121,40,100,101,115,116,95,115,112,101,99,44,32,100,101,115,116,41,0,0,0,0,0,0,106,32,61,61,32,115,111,117,114,99,101,45,62,110,100,105,109,115,0,0,0,0,0,0,106,32,61,61,32,98,97,115,101,95,97,114,114,97,121,95,110,114,95,111,102,95,101,108,101,109,101,110,116,115,40,115,111,117,114,99,101,41,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,109,112,116,121,32,82,105,110,103,66,117,102,102,101,114,0,0,0,0,0,0,0,0,105,110,100,101,120,32,91,37,100,93,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,100,58,37,100,93,0,184,38,1,0,0,0,0,0,48,38,1,0,0,0,0,0,168,37,1,0,0,0,0,0,32,37,1,0,0,0,0,0,24,36,1,0,0,0,0,0,16,35,1,0,0,0,0,0,8,34,1,0,0,0,0,0,0,33,1,0,0,0,0,0,97,99,99,95,116,112,32,33,61,32,48,0,0,0,0,0,117,116,105,108,47,114,116,99,108,111,99,107,46,99,0,0,114,116,95,105,110,105,116,0,109,97,120,95,116,112,32,33,61,32,48,0,0,0,0,0,116,111,116,97,108,95,116,112,32,33,61,32,48,0,0,0,116,105,99,107,95,116,112,32,33,61,32,48,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,32,33,61,32,48,0,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,105,110,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,97,120,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,116,111,116,97,108,32,33,61,32,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+71680);
/* memory initializer */ allocate([69,114,114,111,114,32,115,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,119,105,116,104,32,100,105,102,102,101,114,101,110,116,32,115,116,97,114,116,105,110,103,32,112,111,105,110,116,115,32,40,43,37,103,41,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,116,111,32,100,101,99,114,101,97,115,101,32,102,97,99,116,111,114,32,116,111,32,37,103,0,0,0,0,0,105,109,112,114,111,112,101,114,32,105,110,112,117,116,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,110,111,110,108,105,110,101,97,114,32,101,113,46,32,115,121,115,116,58,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,85,110,107,110,111,119,110,32,101,113,117,97,116,105,111,110,32,115,121,115,116,101,109,32,101,114,114,111,114,58,32,37,100,32,37,115,32,37,103,0,70,76,65,71,95,85,78,75,78,79,87,78,0,0,0,0,99,108,111,99,107,0,0,0,99,112,117,0,0,0,0,0,101,109,105,116,95,112,114,111,116,101,99,116,101,100,0,0,102,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,105,105,102,0,0,0,0,0,105,105,109,0,0,0,0,0,105,105,116,0,0,0,0,0,105,108,115,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,0,0,0,0,0,105,111,109,0,0,0,0,0,105,112,111,112,116,95,104,101,115,115,101,0,0,0,0,0,105,112,111,112,116,95,106,97,99,0,0,0,0,0,0,0,105,112,111,112,116,95,105,110,105,116,0,0,0,0,0,0,108,0,0,0,0,0,0,0,108,111,103,70,111,114,109,97,116,0,0,0,0,0,0,0,108,115,0,0,0,0,0,0,108,115,95,105,112,111,112,116,0,0,0,0,0,0,0,0,108,118,0,0,0,0,0,0,109,101,97,115,117,114,101,84,105,109,101,80,108,111,116,70,111,114,109,97,116,0,0,0,110,108,115,0,0,0,0,0,110,111,101,109,105,116,0,0,110,111,69,118,101,110,116,69,109,105,116,0,0,0,0,0,111,117,116,112,117,116,0,0,111,118,101,114,114,105,100,101,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,70,105,108,101,0,0,0,0,112,111,114,116,0,0,0,0,114,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,160,40,1,0,176,40,1,0,184,40,1,0,192,40,1,0,208,40,1,0,216,40,1,0,224,40,1,0,232,40,1,0,240,40,1,0,248,40,1,0,0,41,1,0,16,41,1,0,24,41,1,0,40,41,1,0,56,41,1,0,72,41,1,0,80,41,1,0,96,41,1,0,104,41,1,0,120,41,1,0,128,41,1,0,152,41,1,0,160,41,1,0,168,41,1,0,184,41,1,0,192,41,1,0,208,41,1,0,224,41,1,0,232,41,1,0,240,41,1,0,248,41,1,0,0,42,1,0,117,110,107,110,111,119,110,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,0,0,0,0,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,115,45,102,105,108,101,0,0,0,0,0,0,0,0,101,109,105,116,115,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,115,101,116,117,112,32,88,77,76,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,110,32,101,120,116,101,114,110,97,108,32,102,105,108,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,0,91,100,111,117,98,108,101,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,91,105,110,116,93,32,100,101,102,97,117,108,116,58,32,49,0,0,0,0,0,0,0,0,115,112,101,99,105,102,121,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,119,104,101,114,101,32,116,104,101,32,108,105,110,101,97,114,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,32,115,104,111,117,108,100,32,98,101,32,112,101,114,102,111,114,109,101,100,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,46,32,45,108,111,103,70,111,114,109,97,116,61,116,101,120,116,32,40,100,101,102,97,117,108,116,41,32,111,114,32,45,108,111,103,70,111,114,109,97,116,61,120,109,108,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,105,112,111,112,116,0,0,0,0,0,0,91,115,116,114,105,110,103,32,108,105,115,116,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,97,110,121,32,114,101,115,117,108,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,101,118,101,110,116,32,112,111,105,110,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,32,112,111,114,116,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,114,101,115,117,108,116,32,102,105,108,101,32,116,104,97,110,32,116,104,101,32,100,101,102,97,117,108,116,32,77,111,100,101,108,95,114,101,115,46,109,97,116,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,115,111,108,118,101,114,0,0,0,0,0,0,115,104,111,119,115,32,97,108,108,32,119,97,114,110,105,110,103,115,32,101,118,101,110,32,105,102,32,97,32,114,101,108,97,116,101,100,32,108,111,103,45,115,116,114,101,97,109,32,105,115,32,105,110,97,99,116,105,118,101,0,0,0,0,0,144,42,1,0,152,42,1,0,224,42,1,0,16,43,1,0,64,43,1,0,136,43,1,0,200,43,1,0,16,44,1,0,64,44,1,0,136,44,1,0,160,44,1,0,192,44,1,0,248,44,1,0,32,45,1,0,72,45,1,0,128,45,1,0,208,45,1,0,48,46,1,0,96,46,1,0,152,46,1,0,200,46,1,0,16,47,1,0,56,47,1,0,104,47,1,0,152,47,1,0,240,47,1,0,56,48,1,0,168,48,1,0,216,48,1,0,32,49,1,0,64,49,1,0,0,42,1,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,10,32,32,82,84,61,109,111,110,111,116,111,110,105,99,32,114,101,97,108,45,116,105,109,101,32,99,108,111,99,107,44,32,67,80,85,61,112,114,111,99,101,115,115,45,98,97,115,101,100,32,67,80,85,45,116,105,109,101,44,32,67,89,67,61,99,112,117,32,99,121,99,108,101,115,32,109,101,97,115,117,114,101,100,32,119,105,116,104,32,82,68,84,83,67,0,0,0,0,0,32,32,45,32,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,10,32,32,45,32,36,99,112,117,84,105,109,101,32,105,115,32,116,104,101,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,105,110,115,105,100,101,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,10,32,32,101,46,103,46,32,45,104,101,108,112,61,102,32,112,114,105,110,116,115,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,32,102,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,102,111,114,32,104,111,109,111,116,111,112,121,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,115,121,109,98,111,108,105,99,41,32,111,114,10,39,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,39,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,110,117,109,101,114,105,99,32,45,105,111,109,61,110,101,108,100,101,114,95,109,101,97,100,95,101,120,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,101,109,97,116,114,105,120,32,102,111,114,32,73,112,111,112,116,40,79,77,67,44,32,66,70,71,83,44,32,99,111,110,115,116,41,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,40,83,89,77,44,32,78,85,77,44,32,78,85,77,68,69,78,83,69,41,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,32,40,115,105,109,44,32,99,111,110,115,116,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,10,32,32,108,97,112,97,99,107,44,32,108,105,115,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,73,112,111,112,116,44,32,100,101,102,97,117,108,116,32,109,117,109,112,115,46,10,32,78,111,116,101,58,32,85,115,101,32,105,102,32,121,111,117,32,98,117,105,108,100,32,105,112,111,112,116,32,119,105,116,104,32,111,116,104,101,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,105,107,101,32,109,97,50,55,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,10,32,32,115,118,103,10,32,32,106,112,103,10,32,32,112,115,10,32,32,103,105,102,10,32,32,46,46,46,0,0,0,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,10,32,32,116,105,109,101,32,61,32,118,97,108,117,101,44,32,97,32,61,32,118,97,108,117,101,44,32,98,32,61,32,118,97,108,117,101,44,32,99,32,61,32,118,97,108,117,101,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,10,32,32,101,46,103,46,32,118,97,114,49,61,115,116,97,114,116,49,44,118,97,114,50,61,115,116,97,114,116,50,44,112,97,114,51,61,115,116,97,114,116,51,44,115,116,97,114,116,84,105,109,101,61,118,97,108,49,44,115,116,111,112,84,105,109,101,61,118,97,108,50,44,115,116,101,112,83,105,122,101,61,118,97,108,51,44,10,32,32,32,32,32,32,32,116,111,108,101,114,97,110,99,101,61,118,97,108,52,44,115,111,108,118,101,114,61,34,115,101,101,32,45,115,34,44,111,117,116,112,117,116,70,111,114,109,97,116,61,34,109,97,116,124,112,108,116,124,99,115,118,124,101,109,112,116,121,34,44,118,97,114,105,97,98,108,101,70,105,108,116,101,114,61,34,102,105,108,116,101,114,34,0,0,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,10,32,32,110,111,116,101,32,116,104,97,116,58,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,67,65,78,78,79,84,32,98,101,32,117,115,101,100,32,119,105,116,104,32,45,111,118,101,114,114,105,100,101,10,32,32,117,115,101,32,119,104,101,110,32,118,97,114,105,97,98,108,101,115,32,102,111,114,32,45,111,118,101,114,114,105,100,101,32,97,114,101,32,116,111,111,32,109,97,110,121,32,97,110,100,32,100,111,32,110,111,116,32,102,105,116,32,105,110,32,99,111,109,109,97,110,100,32,108,105,110,101,32,115,105,122,101,10,32,32,111,118,101,114,114,105,100,101,70,105,108,101,78,97,109,101,32,99,111,110,116,97,105,110,115,32,108,105,110,101,115,32,111,102,32,116,104,101,32,102,111,114,109,58,32,118,97,114,49,61,115,116,97,114,116,49,0,0,0,0,0,0,144,42,1,0,0,50,1,0,168,50,1,0,16,43,1,0,64,43,1,0,16,51,1,0,200,43,1,0,16,44,1,0,152,51,1,0,216,51,1,0,160,44,1,0,192,44,1,0,120,52,1,0,184,52,1,0,248,52,1,0,128,45,1,0,208,45,1,0,56,53,1,0,112,53,1,0,248,53,1,0,32,54,1,0,16,47,1,0,56,47,1,0,104,47,1,0,136,54,1,0,16,55,1,0,16,56,1,0,168,48,1,0,216,48,1,0,32,49,1,0,64,49,1,0,0,42,1,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,49,120,44,56,48,97,49,41,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,41,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,44,51,120,44,2,73,50,32,61,2,44,105,49,48,41,0,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,41,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,44,51,120,44,2,82,50,32,61,2,44,101,50,49,46,49,51,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,61,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,61,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,61,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,61,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,62,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,72,69,32,76,65,83,84,32,83,84,69,80,32,84,69,82,77,73,78,65,84,69,68,32,87,73,84,72,32,65,32,78,69,71,65,84,73,86,69,0,0,0,0,0,0,0,49,0,0,0,0,0,0,0,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,86,65,76,85,69,32,40,61,73,49,41,32,79,70,32,73,68,73,68,32,65,78,68,32,78,79,32,65,80,80,82,79,80,82,73,65,84,69,0,47,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,67,84,73,79,78,32,87,65,83,32,84,65,75,69,78,46,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,203,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,67,85,82,82,69,78,84,32,84,32,40,61,82,49,41,32,32,53,48,48,32,83,84,69,80,83,0,0,38,0,0,0,0,0,0,0,98,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,65,75,69,78,32,79,78,32,84,72,73,83,32,67,65,76,76,32,66,69,70,79,82,69,32,82,69,65,67,72,73,78,71,32,84,79,85,84,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,99,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,84,79,79,32,77,85,67,72,32,65,67,67,85,82,65,67,89,32,82,69,81,85,69,83,84,69,68,0,108,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,70,79,82,32,80,82,69,67,73,83,73,79,78,32,79,70,32,77,65,67,72,73,78,69,46,32,82,84,79,76,32,65,78,68,32,65,84,79,76,0,0,0,0,0,0,0,0,109,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,87,69,82,69,32,73,78,67,82,69,65,83,69,68,32,84,79,32,65,80,80,82,79,80,82,73,65,84,69,32,86,65,76,85,69,83,0,0,0,45,0,0,0,0,0,0,0,110,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,0,0,118,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,65,83,32,66,69,67,79,77,69,32,46,76,69,46,32,48,46,48,0,0,0,0,28,0,0,0,0,0,0,0,119,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,32,84,72,69,0,0,0,0,44,0,0,0,0,0,0,0,128,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,129,2,0,0,0,0,0,0,138,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,70,65,73,76,69,68,32,84,79,32,67,79,78,86,69,82,71,69,32,82,69,80,69,65,84,69,68,76,89,0,0,0,0,0,0,0,0,139,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,140,2,0,0,0,0,0,0,148,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,84,69,82,65,84,73,79,78,32,77,65,84,82,73,88,32,73,83,32,83,73,78,71,85,76,65,82,0,0,0,37,0,0,0,0,0,0,0,149,2,0,0,0,0,0,0,158,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,46,32,32,65,76,83,79,44,32,84,72,69,0,0,0,0,0,0,0,159,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,46,0,0,160,2,0,0,0,0,0,0,163,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,32,66,69,67,65,85,83,69,0,0,0,164,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,79,78,69,0,0,0,0,36,0,0,0,0,0,0,0,165,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,0,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,168,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,84,87,79,0,0,0,0,169,2,0,0,0,0,0,0,173,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,73,84,73,65,76,32,89,80,82,73,77,69,32,67,79,85,76,68,32,78,79,84,32,66,69,32,67,79,77,80,85,84,69,68,0,0,0,174,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,73,78,70,79,32,86,69,67,84,79,82,32,73,83,32,78,79,84,32,90,69,82,79,32,79,82,32,79,78,69,0,55,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,69,81,32,40,61,73,49,41,32,46,76,69,46,32,48,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,65,88,79,82,68,32,40,61,73,49,41,32,78,79,84,32,73,78,32,82,65,78,71,69,0,0,0,0,0,0,34,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,82,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,82,87,32,40,61,73,50,41,0,0,0,0,60,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,73,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,73,87,32,40,61,73,50,41,0,0,0,0,5,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,82,84,79,76,32,73,83,32,46,76,84,46,32,48,0,39,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,65,84,79,76,32,73,83,32,46,76,84,46,32,48,0,7,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,76,76,32,69,76,69,77,69,78,84,83,32,79,70,32,82,84,79,76,32,65,78,68,32,65,84,79,76,32,65,82,69,32,90,69,82,79,0,8,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,32,61,32,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,79,85,84,32,40,61,82,50,41,0,0,54,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,77,65,88,32,40,61,82,49,41,32,46,76,84,46,32,48,46,48,0,0,0,0,10,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,11,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,56,41,61,49,32,65,78,68,32,72,48,61,48,46,48,0,0,0,29,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,32,73,83,32,46,76,69,46,32,48,46,48,0,13,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,84,79,85,84,32,40,61,82,49,41,32,84,79,79,32,67,76,79,83,69,32,84,79,32,84,32,40,61,82,50,41,32,84,79,32,83,84,65,82,84,32,73,78,84,69,71,82,65,84,73,79,78,0,0,0,0,14,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,61,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,76,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,52,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,85,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,18,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,73,83,32,69,81,85,65,76,32,84,79,32,84,32,40,61,82,50,41,0,19,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,71,32,40,61,73,49,41,32,46,76,84,46,32,48,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,78,69,32,79,82,32,77,79,82,69,32,67,79,77,80,79,78,69,78,84,83,32,79,70,32,71,32,72,65,83,32,65,32,82,79,79,84,0,32,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,84,79,79,32,78,69,65,82,32,84,79,32,84,72,69,32,73,78,73,84,73,65,76,32,80,79,73,78,84,0,0,68,65,83,83,76,45,45,32,32,82,69,80,69,65,84,69,68,32,79,67,67,85,82,82,69,78,67,69,83,32,79,70,32,73,76,76,69,71,65,76,32,73,78,80,85,84,0,0,46,0,0,0,0,0,0,0,33,3,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,46,32,65,80,80,65,82,69,78,84,32,73,78,70,73,78,73,84,69,32,76,79,79,80,0,34,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,116,32,112,111,105,110,116,32,105,110,32,116,105,109,101,58,32,37,103,0,0,0,0,99,106,58,32,37,103,0,0,115,116,97,116,101,115,0,0,91,37,108,100,93,32,37,103,0,0,0,0,0,0,0,0,97,110,97,108,121,116,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,37,115,37,103,32,0,0,0,37,115,0,0,0,0,0,0,110,117,109,101,114,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,66,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,77,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,76,0,0,0,0,0,0,0,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+75576);
/* memory initializer */ allocate([40,47,47,2,32,87,65,82,78,73,78,71,46,32,84,104,101,32,118,97,108,117,101,32,69,77,73,78,32,109,97,121,32,98,101,32,105,110,99,111,114,114,101,99,116,58,45,2,44,2,32,32,69,77,73,78,32,61,32,2,44,105,56,44,47,2,32,73,102,44,32,97,102,116,101,114,32,105,110,115,112,101,99,116,105,111,110,44,32,116,104,101,32,118,97,108,117,101,32,69,77,73,78,32,108,111,111,107,115,2,44,2,32,97,99,99,101,112,116,97,98,108,101,32,112,108,101,97,115,101,32,99,111,109,109,101,110,116,32,111,117,116,32,2,44,47,2,32,116,104,101,32,73,70,32,98,108,111,99,107,32,97,115,32,109,97,114,107,101,100,32,119,105,116,104,105,110,32,116,104,101,32,99,111,100,101,32,111,102,32,114,111,117,116,105,110,101,2,44,2,32,68,76,65,77,67,50,44,2,44,47,2,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,108,121,32,69,77,73,78,32,101,120,112,108,105,99,105,116,108,121,46,2,44,47,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,168,79,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,191,76,0,0,0,0,176,60,49,101,0,0,0,0,16,0,244,14,255,255,255,255,239,127,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,2,32,80,114,111,103,114,101,115,115,32,82,101,112,111,114,116,32,101,118,101,114,121,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,47,44,2,32,69,86,65,76,46,32,32,32,70,85,78,67,46,86,65,76,85,69,46,2,44,49,48,120,44,2,80,65,82,65,77,69,84,69,82,32,86,65,76,85,69,83,2,41,0,0,0,0,40,47,49,120,44,105,52,44,50,120,44,103,49,50,46,53,44,50,120,44,53,103,49,49,46,52,44,51,40,47,50,49,120,44,53,103,49,49,46,52,41,41,0,0,0,0,0,0,40,2,32,78,111,46,32,111,102,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,62,32,2,44,105,53,41,0,0,40,2,32,82,77,83,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,103,49,52,46,54,41,0,0,0,0,0,40,2,32,67,101,110,116,114,111,105,100,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,99,101,110,116,114,111,105,100,32,61,2,44,103,49,52,46,54,41,0,40,47,2,32,69,86,73,68,69,78,67,69,32,79,70,32,67,79,78,86,69,82,71,69,78,67,69,2,41,0,0,0,40,47,47,2,32,77,105,110,105,109,117,109,32,102,111,117,110,100,32,97,102,116,101,114,2,44,105,53,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,41,0,0,0,40,2,32,77,105,110,105,109,117,109,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,54,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,109,105,110,105,109,117,109,32,61,2,44,103,49,52,46,54,41,0,0,40,47,2,32,70,105,116,116,105,110,103,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,97,98,111,117,116,32,115,117,112,112,111,115,101,100,32,109,105,110,105,109,117,109,2,47,41,0,40,47,2,32,77,65,84,82,73,88,32,79,70,32,69,83,84,73,77,65,84,69,68,32,83,69,67,79,78,68,32,68,69,82,73,86,65,84,73,86,69,83,32,78,79,84,32,43,86,69,32,68,69,70,78,46,2,47,2,32,77,73,78,73,77,85,77,32,80,82,79,66,65,66,76,89,32,78,79,84,32,70,79,85,78,68,2,47,41,0,0,0,0,0,0,0,40,47,49,48,120,44,2,83,101,97,114,99,104,32,114,101,115,116,97,114,116,105,110,103,2,47,41,0,0,0,0,0,40,2,32,77,105,110,105,109,117,109,32,111,102,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,61,2,44,103,49,52,46,54,44,2,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,73,70,32,84,72,73,83,32,68,73,70,70,69,82,83,32,66,89,32,77,85,67,72,32,70,82,79,77,32,84,72,69,32,77,73,78,73,77,85,77,32,69,83,84,73,77,65,84,69,68,2,44,49,120,44,2,70,82,79,77,32,84,72,69,32,77,73,78,73,77,73,90,65,84,73,79,78,44,2,47,2,32,84,72,69,32,77,73,78,73,77,85,77,32,77,65,89,32,66,69,32,70,65,76,83,69,32,38,47,79,82,32,84,72,69,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,32,77,65,89,32,66,69,2,44,49,120,44,2,73,78,65,67,67,85,82,65,84,69,2,47,41,0,0,0,0,0,40,2,32,82,97,110,107,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,32,61,2,44,105,51,47,2,32,73,110,118,101,114,115,101,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,58,45,2,41,0,40,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,109,105,110,105,109,105,122,101,100,32,119,97,115,32,45,76,79,71,40,76,73,75,69,76,73,72,79,79,68,41,44,2,47,2,32,116,104,105,115,32,105,115,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,32,111,102,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,46,2,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,119,97,115,32,97,32,115,117,109,32,111,102,32,115,113,117,97,114,101,115,32,111,102,32,114,101,115,105,100,117,97,108,115,44,2,47,2,32,116,104,105,115,32,109,97,116,114,105,120,32,109,117,115,116,32,98,101,32,109,117,108,116,105,112,108,105,101,100,32,98,121,32,116,119,105,99,101,32,116,104,101,32,101,115,116,105,109,97,116,101,100,2,44,49,120,44,2,114,101,115,105,100,117,97,108,32,118,97,114,105,97,110,99,101,2,47,2,32,116,111,32,111,98,116,97,105,110,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,46,2,47,41,0,0,0,0,40,2,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,47,41,0,0,0,0,0,0,40,47,47,2,32,67,79,82,82,69,76,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,41,0,0,0,0,0,40,47,2,32,65,32,102,117,114,116,104,101,114,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,104,97,118,101,32,98,101,101,110,32,117,115,101,100,2,47,41,0,0,0,0,0,0,40,49,120,44,54,103,49,51,46,53,41,0,0,0,0,0,40,47,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+85920);
/* memory initializer */ allocate([40,84,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,84,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,84,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,84,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,84,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,84,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,84,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,84,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,84,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,85,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,85,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,85,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,85,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,85,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,85,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,85,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,85,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,86,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,84,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,86,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,86,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,86,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,87,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,87,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,89,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,89,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,89,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,89,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,89,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,89,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,78,80,84,32,105,115,32,110,111,116,32,105,110,2,44,2,32,116,104,101,32,114,101,113,117,105,114,101,100,32,105,110,116,101,114,118,97,108,2,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,248,124,1,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,67,65,76,70,85,78,32,104,97,115,32,98,101,101,110,2,44,2,32,99,97,108,108,101,100,32,77,65,88,70,85,78,32,116,105,109,101,115,46,2,41,0,0,0,0,0,0,40,47,52,120,44,2,70,117,110,99,116,105,111,110,32,110,117,109,98,101,114,2,44,105,54,44,2,32,32,32,32,70,32,61,2,44,49,112,100,49,56,46,49,48,44,2,32,32,32,32,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,97,32,116,114,117,115,116,2,44,2,32,114,101,103,105,111,110,32,115,116,101,112,32,104,97,115,32,102,97,105,108,101,100,32,116,111,32,114,101,100,117,99,101,32,81,46,2,41,0,0,0,0,0,0,0,40,53,120,41,0,0,0,0,40,47,52,120,44,2,78,101,119,32,82,72,79,32,61,2,44,49,112,100,49,49,46,52,44,53,120,44,2,78,117,109,98,101,114,32,111,102,2,44,2,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,40,52,120,44,2,76,101,97,115,116,32,118,97,108,117,101,32,111,102,32,70,32,61,2,44,49,112,100,50,51,46,49,53,44,57,120,44,2,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,0,0,0,0,40,47,52,120,44,2,65,116,32,116,104,101,32,114,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,2,44,53,120,44,2,78,117,109,98,101,114,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,216,125,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,40,126,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,128,126,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,216,126,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,224,126,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,40,127,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,120,127,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,40,127,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,105,118,111,116,32,33,61,32,48,0,0,0,0,0,0,109,97,116,104,45,115,117,112,112,111,114,116,47,112,105,118,111,116,46,99,0,0,0,0,112,105,118,111,116,0,0,0,176,139,1,0,208,140,1,0,216,140,1,0,232,140,1,0,248,140,1,0,8,141,1,0,32,141,1,0,56,141,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,176,139,1,0,184,139,1,0,0,140,1,0,40,140,1,0,72,140,1,0,104,140,1,0,144,140,1,0,184,140,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,100,97,115,115,108,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,0,0,0,0,0,124,32,115,111,108,118,101,114,32,124,32,85,115,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,9,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,78,111,32,83,112,97,114,115,101,80,97,116,116,101,114,110,44,32,115,105,110,99,101,32,116,104,101,114,101,32,97,114,101,32,110,111,32,115,116,97,116,101,115,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,74,97,99,111,98,105,97,110,32,111,114,32,83,112,97,114,115,101,80,97,116,116,101,114,110,32,105,115,32,110,111,116,32,103,101,110,101,114,97,116,101,100,32,111,114,32,102,97,105,108,101,100,32,116,111,32,105,110,105,116,105,97,108,105,122,101,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,112,97,115,115,101,100,32,116,111,32,68,68,65,83,82,84,0,0,0,0,0,0,68,101,115,105,114,101,100,32,115,116,101,112,32,116,111,32,115,109,97,108,108,32,116,114,121,32,110,101,120,116,32,111,110,101,0,0,0,0,0,0,73,110,116,101,114,112,111,108,97,116,101,32,108,105,110,101,97,114,0,0,0,0,0,0,67,97,108,108,105,110,103,32,68,68,65,83,82,84,32,102,114,111,109,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,83,116,97,114,116,32,115,116,101,112,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,0,65,32,108,97,114,103,101,32,97,109,111,117,110,116,32,111,102,32,119,111,114,107,32,104,97,115,32,98,101,101,110,32,101,120,112,101,110,100,101,100,46,40,65,98,111,117,116,32,53,48,48,32,115,116,101,112,115,41,46,32,84,114,121,105,110,103,32,116,111,32,99,111,110,116,105,110,117,101,32,46,46,46,0,0,0,0,0,0,68,65,83,83,76,32,119,105,108,108,32,116,114,121,32,97,103,97,105,110,46,46,46,0,99,97,110,39,116,32,99,111,110,116,105,110,117,101,46,32,116,105,109,101,32,61,32,37,102,0,0,0,0,0,0,0,100,97,115,115,108,32,99,97,108,108,32,115,116,97,105,115,116,105,99,115,58,32,0,0,118,97,108,117,101,32,111,102,32,105,100,105,100,58,32,37,100,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,105,110,116,101,103,114,97,116,105,111,110,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,115,116,101,112,32,115,105,122,101,32,72,32,116,111,32,98,101,32,97,116,116,101,109,112,116,101,100,32,111,110,32,110,101,120,116,32,115,116,101,112,58,32,37,48,46,52,103,0,115,116,101,112,32,115,105,122,101,32,117,115,101,100,32,111,110,32,108,97,115,116,32,115,117,99,99,101,115,115,102,117,108,32,115,116,101,112,58,32,37,48,46,52,103,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,116,97,107,101,110,32,115,111,32,102,97,114,58,32,37,100,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,40,41,32,58,32,37,100,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,99,117,108,97,116,105,111,110,32,111,102,32,106,97,99,111,98,105,97,110,32,58,32,37,100,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,49,48,32,43,32,117,105,32,60,32,100,97,115,115,108,68,97,116,97,45,62,108,105,119,0,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,100,97,115,115,108,46,99,0,0,0,0,0,0,0,100,97,115,114,116,95,115,116,101,112,0,0,0,0,0,0,70,105,110,105,115,104,101,100,32,68,68,65,83,82,84,32,115,116,101,112,46,0,0,0,84,104,101,32,101,114,114,111,114,32,116,111,108,101,114,97,110,99,101,115,32,97,114,101,32,116,111,111,32,115,116,114,105,110,103,101,110,116,0,0,68,68,65,83,83,76,32,104,97,100,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,111,110,32,116,104,101,32,108,97,115,116,32,97,116,116,101,109,112,116,101,100,32,115,116,101,112,46,0,0,0,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,0,0,0,0,0,0,0,84,104,101,32,109,97,116,114,105,120,32,111,102,32,112,97,114,116,105,97,108,32,100,101,114,105,118,97,116,105,118,101,115,32,105,115,32,115,105,110,103,117,108,97,114,46,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,32,84,104,101,114,101,32,119,101,114,101,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,105,110,32,116,104,105,115,32,115,116,101,112,46,0,65,32,77,111,100,101,108,105,99,97,32,97,115,115,101,114,116,32,112,114,101,118,101,110,116,115,32,116,104,101,32,105,110,116,101,103,114,97,116,111,114,32,116,111,32,99,111,110,116,105,110,117,101,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,45,108,118,32,76,79,71,95,68,68,65,83,82,84,0,0,73,82,69,83,32,101,113,117,97,108,32,116,111,32,45,50,32,119,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,97,110,100,32,99,111,110,116,114,111,108,32,105,115,32,98,101,105,110,103,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,99,97,108,108,105,110,103,32,112,114,111,103,114,97,109,46,0,0,68,68,65,83,83,76,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,116,104,101,32,105,110,105,116,105,97,108,32,89,80,82,73,77,69,46,0,0,0,0,84,104,101,32,99,111,100,101,32,104,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,116,114,111,117,98,108,101,32,102,114,111,109,32,119,104,105,99,104,32,105,116,32,99,97,110,110,111,116,32,114,101,99,111,118,101,114,46,0,0,117,110,107,110,111,119,110,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,84,82,85,69,0,0,0,0,70,65,76,83,69,0,0,0,91,37,108,100,93,32,115,97,109,112,108,101,40,37,103,44,32,37,103,41,0,0,0,0,91,37,108,100,93,32,37,115,0,0,0,0,0,0,0,0,67,104,97,116,116,101,114,105,110,103,32,100,101,116,101,99,116,101,100,32,97,114,111,117,110,100,32,116,105,109,101,32,37,46,49,50,103,46,46,37,46,49,50,103,32,40,37,100,32,115,116,97,116,101,32,101,118,101,110,116,115,32,105,110,32,97,32,114,111,119,32,119,105,116,104,32,97,32,116,111,116,97,108,32,116,105,109,101,32,100,101,108,116,97,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,115,116,101,112,32,115,105,122,101,32,37,46,49,50,103,41,46,32,84,104,105,115,32,99,97,110,32,98,101,32,97,32,112,101,114,102,111,114,109,97,110,99,101,32,98,111,116,116,108,101,110,101,99,107,46,32,85,115,101,32,45,108,118,32,76,79,71,95,69,86,69,78,84,83,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,32,84,104,101,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,119,97,115,58,32,37,115,0,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,114,105,103,104,116,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,101,118,101,110,116,115,46,99,0,0,0,0,0,0,102,105,110,100,82,111,111,116,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,108,101,102,116,0,0,0,0,0,115,101,97,114,99,104,32,102,111,114,32,99,117,114,114,101,110,116,32,101,118,101,110,116,46,32,69,118,101,110,116,115,32,105,110,32,108,105,115,116,58,32,37,108,100,0,0,0,77,105,110,105,109,117,109,32,118,97,108,117,101,58,32,37,101,0,0,0,0,0,0,0,97,100,100,101,100,32,116,109,112,32,101,118,101,110,116,32,58,32,37,108,100,0,0,0,37,108,100,32,0,0,0,0,98,97,99,107,117,112,95,103,111,117,116,0,0,0,0,0,98,105,115,101,99,116,105,111,110,0,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,109,101,116,104,111,100,32,115,116,97,114,116,115,32,105,110,32,105,110,116,101,114,118,97,108,32,91,37,101,44,32,37,101,93,0,0,0,0,84,84,79,76,32,105,115,32,115,101,116,32,116,111,58,32,37,101,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,99,104,101,99,107,115,32,102,111,114,32,99,111,110,100,105,116,105,111,110,32,99,104,97,110,103,101,115,0,0,37,108,100,32,99,104,97,110,103,101,100,32,102,114,111,109,32,37,115,32,116,111,32,99,117,114,114,101,110,116,32,37,115,0,0,0,0,0,0,0,115,97,118,101,32,97,108,108,32,122,101,114,111,99,114,111,115,115,105,110,103,115,32,97,102,116,101,114,32,97,110,32,101,118,101,110,116,0,0,0,69,82,82,79,82,58,32,84,111,111,32,109,97,110,121,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,115,46,32,83,121,115,116,101,109,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,46,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,112,97,114,97,109,101,116,101,114,32,118,97,108,117,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,103,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,108,100,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,115,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,0,0,0,0,115,116,97,116,117,115,32,111,102,32,114,101,108,97,116,105,111,110,115,0,0,0,0,0,91,37,108,100,93,32,37,115,32,61,32,37,99,32,124,32,112,114,101,40,37,115,41,32,61,32,37,99,0,0,0,0,89,111,117,114,32,109,101,109,111,114,121,32,105,115,32,110,111,116,32,115,116,114,111,110,103,32,101,110,111,117,103,104,32,102,111,114,32,111,117,114,32,82,105,110,103,98,117,102,102,101,114,33,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,101,120,116,101,114,110,97,108,32,111,98,106,101,99,116,115,0,0,0,0,0,0,0,187,189,215,217,223,124,219,61,83,101,116,32,116,111,108,101,114,97,110,99,101,32,102,111,114,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,104,121,115,116,101,114,101,115,105,115,32,116,111,58,32,37,101,0,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,109,105,120,101,100,32,115,111,108,118,101,114,0,0,0,0,0,0,0,109,105,120,101,100,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,91,37,100,93,32,37,115,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,101,77,105,120,101,100,83,101,97,114,99,104,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,0,0,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,91,37,100,93,32,37,115,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,97,112,97,99,107,46,0,0,0,0,0,0,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,76,105,115,46,0,0,45,105,32,102,103,109,114,101,115,32,0,0,0,0,0,0,78,76,83,95,85,78,75,78,79,87,78,0,0,0,0,0,104,121,98,114,105,100,0,0,107,105,110,115,111,108,0,0,110,101,119,116,111,110,0,0,78,76,83,95,77,65,88,0,24,148,1,0,40,148,1,0,48,148,1,0,56,148,1,0,64,148,1,0,0,0,0,0,117,110,107,110,111,119,110,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,78,101,119,116,111,110,32,82,97,112,104,115,111,110,0,0,96,148,1,0,104,148,1,0,120,148,1,0,136,148,1,0,64,148,1,0,0,0,0,0,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,106,97,99,111,98,105,97,110,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,0,0,0,0,112,114,111,112,101,114,32,115,116,97,114,116,45,118,97,108,117,101,115,32,102,111,114,32,115,111,109,101,32,111,102,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,115,32,109,105,103,104,116,32,104,101,108,112,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,63,44,32,110,111,109,105,110,97,108,61,63,41,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,115,116,97,114,116,32,115,111,108,118,105,110,103,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,62,62,37,115,60,60,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,102,0,0,0,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,10,111,108,100,32,61,32,37,102,10,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,102,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,32,40,115,99,97,108,101,100,41,0,0,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,102,111,114,32,114,101,115,105,100,117,97,108,32,118,101,99,116,111,114,0,0,0,0,0,115,99,97,108,101,100,32,114,101,115,105,100,117,97,108,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,115,121,115,116,101,109,32,115,111,108,118,101,100,0,0,0,37,100,32,114,101,116,114,105,101,115,10,37,100,32,114,101,115,116,97,114,116,115,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,101,99,114,101,97,115,105,110,103,32,105,110,105,116,105,97,108,32,115,116,101,112,32,98,111,117,110,100,32,116,111,32,37,102,46,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,32,97,115,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,111,117,116,32,115,99,97,108,105,110,103,32,97,116,32,97,108,108,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,116,111,32,115,111,108,118,101,32,97,32,100,105,115,99,111,110,116,105,110,117,111,117,115,32,115,121,115,116,101,109,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,117,115,101,32,111,108,100,32,118,97,108,117,101,115,32,105,110,115,116,101,97,100,32,101,120,116,114,97,112,111,108,97,116,101,100,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,97,100,100,105,110,103,32,49,37,37,46,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,45,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,97,115,32,105,110,105,116,105,97,108,32,112,111,105,110,116,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,32,111,119,110,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,105,115,97,98,108,101,32,115,111,108,118,101,114,32,105,110,116,101,114,110,97,108,32,115,99,97,108,105,110,103,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,114,101,100,117,99,101,32,116,104,101,32,116,111,108,101,114,97,110,99,101,32,115,108,105,103,104,116,108,121,32,116,111,32,37,101,46,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,110,108,115,32,115,116,97,116,117,115,0,0,0,0,0,0,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,0,0,102,117,110,99,116,105,111,110,115,0,0,0,0,0,0,0,114,101,115,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,115,116,97,116,105,115,116,105,99,115,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,10,101,114,114,111,114,32,61,32,37,46,50,48,101,10,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,50,48,101,0,0,0,91,37,50,100,93,32,37,50,48,46,49,50,103,0,0,0,45,45,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,45,45,32,101,110,100,32,111,102,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,0,45,45,32,98,101,103,105,110,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,0,0,0,0,0,0,45,45,32,101,110,100,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,87,101,108,108,44,32,116,104,105,115,32,105,115,32,101,109,98,97,114,114,97,115,105,110,103,46,32,84,104,101,32,110,111,110,45,108,105,110,101,97,114,32,115,111,108,118,101,114,32,115,104,111,117,108,100,32,110,101,118,101,114,32,99,97,108,108,32,116,104,105,115,32,99,97,115,101,46,37,100,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,83,116,97,114,116,32,115,111,108,118,105,110,103,32,78,111,110,45,76,105,110,101,97,114,32,83,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,32,119,105,116,104,32,78,101,119,116,111,110,32,83,111,108,118,101,114,0,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,32,43,43,43,32,111,108,100,32,61,32,37,101,32,43,43,43,32,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,101,0,42,42,42,32,83,121,115,116,101,109,32,115,111,108,118,101,100,32,42,42,42,10,37,100,32,114,101,115,116,97,114,116,115,0,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,32,43,43,43,32,101,114,114,111,114,32,61,32,37,46,49,53,101,32,43,43,43,32,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,49,53,101,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,10,9,114,101,115,105,100,117,97,108,32,61,32,37,101,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,46,0,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,110,111,109,105,110,97,108,32,118,97,108,117,101,115,32,97,115,32,105,110,105,116,105,97,108,32,115,111,108,117,116,105,111,110,46,0,0,0,0,0,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,35,35,35,35,35,35,35,35,35,32,83,116,97,114,116,32,78,101,119,116,111,110,32,109,97,120,102,101,118,58,32,37,100,32,35,35,35,35,35,35,35,35,35,0,0,0,0,0,120,91,37,100,93,58,32,37,101,32,0,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,74,97,99,111,98,105,97,110,32,77,97,116,114,105,120,32,115,105,110,103,117,108,97,114,33,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,32,105,110,112,117,116,32,105,110,32,97,114,103,117,109,101,110,116,32,37,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,240,63,73,110,105,116,105,97,108,105,122,105,110,103,32,68,65,83,83,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,116,111,114,105,110,103,32,114,101,115,117,108,116,115,32,97,110,100,32,101,120,105,116,105,110,103,46,10,85,115,101,32,45,108,118,61,76,79,71,95,73,78,73,84,32,45,119,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,0,115,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,97,110,32,97,115,115,101,114,116,105,111,110,32,97,116,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,87,114,111,116,101,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,116,104,101,32,102,105,108,101,32,97,102,116,101,114,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,40,102,111,114,32,111,117,116,112,117,116,32,102,111,114,109,97,116,115,32,116,104,97,116,32,115,117,112,112,111,114,116,32,116,104,105,115,41,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,108,32,101,118,101,110,116,32,97,116,32,115,116,111,112,32,116,105,109,101,32,37,103,0,0,70,105,110,105,115,104,101,100], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+96604);
/* memory initializer */ allocate([35,35,35,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,0,0,0,0,116,105,109,101,114,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,112,114,101,45,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,116,101,112,115,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,45,102,105,108,101,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,101,118,101,110,116,45,104,97,110,100,108,105,110,103,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,118,101,114,104,101,97,100,0,0,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,105,109,117,108,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,116,111,116,97,108,0,0,0,101,118,101,110,116,115,0,0,37,53,108,100,32,115,116,97,116,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,37,53,108,100,32,116,105,109,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,0,115,111,108,118,101,114,58,32,68,65,83,83,76,0,0,0,37,53,100,32,115,116,101,112,115,32,116,97,107,101,110,0,37,53,100,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,0,0,0,0,0,0,0,0,37,53,100,32,101,118,97,108,117,97,116,105,111,110,115,32,111,102,32,106,97,99,111,98,105,97,110,0,0,0,0,0,37,53,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,37,53,100,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,0,0,115,111,108,118,101,114,0,0,115,111,114,114,121,32,45,32,110,111,32,115,111,108,118,101,114,32,115,116,97,116,105,115,116,105,99,115,32,97,118,97,105,108,97,98,108,101,46,32,91,110,111,116,32,121,101,116,32,105,109,112,108,101,109,101,110,116,101,100,93,0,0,0,35,35,35,32,69,78,68,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,83,117,110,100,105,97,108,47,107,105,110,115,111,108,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,32,80,108,101,97,115,101,32,99,104,111,111,115,101,32,111,116,104,101,114,32,115,111,108,118,101,114,46,0,73,112,111,112,116,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,0,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,101,117,108,101,114,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,69,85,76,69,82,46,0,0,0,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,82,75,46,0,0,0,83,116,97,114,116,32,110,117,109,101,114,105,99,97,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,44,0,0,0,0,0,0,0,116,105,109,101,61,37,46,50,48,103,0,0,0,0,0,0,44,37,115,61,37,46,50,48,103,0,0,0,0,0,0,0,44,37,115,61,37,108,105,0,44,37,115,61,37,105,0,0,44,37,115,61,34,37,115,34,0,0,0,0,0,0,0,0,99,97,110,32,110,111,116,32,105,110,105,116,105,97,108,122,101,32,74,97,99,111,98,105,97,110,115,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,106,97,99,111,98,105,97,110,32,37,100,120,37,100,32,91,105,100,58,32,37,108,100,93,0,0,0,0,0,0,0,0,37,115,37,46,53,101,32,0,37,115,0,0,0,0,0,0,69,114,114,111,114,44,32,115,105,110,103,117,108,97,114,32,74,97,99,111,98,105,97,110,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,32,97,116,32,116,105,109,101,32,37,102,10,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,95,74,65,67,32,116,111,32,103,101,116,32,116,104,101,32,74,97,99,111,98,105,97,110,0,115,101,108,101,99,116,32,110,101,119,32,115,116,97,116,101,115,32,97,116,32,116,105,109,101,32,37,102,0,0,0,0,115,101,108,101,99,116,32,37,115,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,73,110,112,117,116,46,99,115,118,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,37,108,102,0,0,0,0,0,10,69,120,116,101,114,110,97,108,32,73,110,112,117,116,0,10,73,110,112,117,116,58,32,116,61,37,102,32,32,32,9,0,0,0,0,0,0,0,0,117,37,100,40,116,41,61,32,37,102,32,9,0,0,0,0,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,0,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,121,115,116,101,109,32,111,102,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,97,114,101,32,110,111,116,32,99,111,110,115,105,115,116,101,110,116,10,40,108,101,97,115,116,32,115,113,117,97,114,101,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,32,105,115,32,37,103,41,0,0,0,0,0,114,101,115,105,100,117,97,108,91,37,108,100,93,32,61,32,37,103,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,115,116,97,116,117,115,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,32,91,115,99,97,108,101,100,58,32,37,103,93,0,0,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,0,0,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,0,0,0,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,35,35,35,32,83,79,76,85,84,73,79,78,32,79,70,32,84,72,69,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,115,116,97,116,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,0,0,100,101,114,105,118,97,116,105,118,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,111,116,104,101,114,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,41,32,61,32,37,108,100,32,40,112,114,101,58,32,37,108,100,41,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,41,32,61,32,37,115,32,40,112,114,101,58,32,37,115,41,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,32,40,112,114,101,58,32,34,37,115,34,41,0,0,35,35,35,32,83,84,65,82,84,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,72,175,1,0,16,177,1,0,24,177,1,0,32,177,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,105,109,32,37,115,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,124,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,72,175,1,0,80,176,1,0,160,176,1,0,208,176,1,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,72,175,1,0,16,176,1,0,24,176,1,0,32,176,1,0,48,176,1,0,56,176,1,0,72,176,1,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,111,109,32,37,115,0,0,0,0,0,72,175,1,0,80,175,1,0,104,175,1,0,120,175,1,0,192,175,1,0,208,175,1,0,240,175,1,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,105,109,0,35,35,35,32,69,78,68,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,37,115,95,104,111,109,111,116,111,112,121,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,108,97,109,98,100,97,0,0,104,111,109,111,116,111,112,121,32,112,114,111,99,101,115,115,0,0,0,0,0,0,0,0,108,97,109,98,100,97,32,61,32,37,103,32,100,111,110,101,0,0,0,0,0,0,0,0,37,46,49,54,103,44,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,117,110,105,113,117,101,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,46,32,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,32,116,111,32,115,101,101,32,116,104,101,32,115,119,105,116,99,104,105,110,103,32,115,116,97,116,101,32,115,101,116,46,0,0,0,110,111,32,118,97,114,105,97,98,108,101,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,0,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,32,40,110,101,105,116,104,101,114,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,110,111,114,32,105,110,105,116,105,97,108,32,97,108,103,111,114,105,116,104,109,115,41,0,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,0,0,0,0,0,0,0,0,115,101,116,116,105,110,103,32,102,105,120,101,100,61,116,114,117,101,32,102,111,114,58,0,37,115,40,102,105,120,101,100,61,116,114,117,101,41,32,61,32,37,103,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,0,0,111,118,101,114,45,100,101,116,101,114,109,105,110,101,100,0,115,116,97,114,116,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,0,0,115,107,105,112,32,119,47,111,32,115,99,97,108,105,110,103,0,0,0,0,0,0,0,0,35,35,35,32,70,73,78,65,76,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,82,69,83,85,76,84,83,32,35,35,35,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,45,110,114,46,32,37,108,100,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,111,109,0,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,110,111,116,32,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,45,99,97,108,108,115,58,32,37,108,100,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,105,109,112,111,114,116,32,115,116,97,114,116,32,118,97,108,117,101,115,10,102,105,108,101,58,32,37,115,10,116,105,109,101,58,32,37,103,0,0,0,117,110,97,98,108,101,32,116,111,32,114,101,97,100,32,105,110,112,117,116,45,102,105,108,101,32,60,37,115,62,32,91,37,115,93,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,103,41,0,0,36,90,69,82,79,46,0,0,36,112,68,69,82,46,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,100,105,115,99,114,101,116,101,0,0,0,0,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,108,100,41,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,115,41,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,100,101,114,40,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,105,116,105,97,108,32,112,114,111,98,108,101,109,58,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,58,32,32,37,108,100,32,40,37,108,100,32,115,116,97,116,101,115,32,43,32,37,108,100,32,112,97,114,97,109,101,116,101,114,115,32,43,32,37,108,100,32,100,105,115,99,114,101,116,101,32,114,101,97,108,115,41,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,91,37,108,100,93,32,100,105,115,99,114,101,116,101,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,58,32,32,37,108,100,32,40,37,108,100,32,101,113,117,97,116,105,111,110,115,32,43,32,37,108,100,32,97,108,103,111,114,105,116,104,109,115,41,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,97,114,116,32,118,97,108,117,101,32,114,101,115,105,100,117,97,108,115,58,32,37,108,100,0,0,0,0,91,37,108,100,93,32,114,101,115,105,100,117,97,108,32,105,115,32,105,110,101,102,102,101,99,116,105,118,101,32,40,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,32,105,115,32,115,101,116,32,116,111,32,49,46,48,41,0,0,0,0,0,0,0,110,111,32,105,112,111,112,116,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,124,32,82,101,115,117,108,116,32,111,102,32,108,101,97,115,116,83,113,117,97,114,101,32,109,101,116,104,111,100,32,61,32,37,103,46,32,84,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,105,116,115,32,116,111,32,116,104,101,32,115,121,115,116,101,109,0,0,0,0,0,0,0,0,108,101,97,115,116,83,113,117,97,114,101,61,37,103,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,111,108,118,101,114,32,105,116,101,114,97,116,101,100,32,37,100,32,116,105,109,101,115,32,119,105,116,104,111,117,116,32,102,105,110,100,105,110,103,32,97,32,115,111,108,117,116,105,111,110,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,99,111,110,115,105,115,116,101,110,116,32,105,110,105,116,105,97,108,32,99,111,110,100,105,116,105,111,110,115,46,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,78,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,32,60,32,49,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,78,76,79,79,80,32,60,32,49,46,0,0,0,0,0,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,105,116,101,114,97,116,105,111,110,115,58,32,37,108,100,0,116,114,121,32,45,105,108,115,32,116,111,32,97,99,116,105,118,97,116,101,32,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,0,0,0,0,0,0,0,37,115,95,105,110,105,116,80,97,116,104,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,105,116,101,114,97,116,105,111,110,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,37,108,100,44,0,0,0,0,37,46,49,54,103,44,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,108,97,109,98,100,97,32,105,115,32,37,45,51,103,32,105,110,32,115,116,101,112,61,37,54,100,32,97,116,32,102,61,37,103,32,91,37,103,93,0,105,110,99,114,101,97,115,105,110,103,32,108,97,109,98,100,97,32,116,111,32,37,45,51,103,32,105,110,32,115,116,101,112,32,37,54,100,32,97,116,32,102,61,37,103,0,0,0,102,120,114,32,61,32,37,103,0,0,0,0,0,0,0,0,102,120,107,32,61,32,37,103,0,0,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,114,114,111,114,32,105,110,32,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,37,46,49,54,103,44,0,0,37,105,44,0,0,0,0,0,34,37,115,34,44,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,116,105,109,101,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,65,49,32,98,116,46,32,105,114,49,32,110,97,32,32,84,106,32,32,114,101,32,32,97,99,32,32,110,116,32,32,115,111,32,32,32,114,32,32,32,121,32,32,32,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,50,0,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,102,105,108,101,32,37,115,0,0,0,0,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,0,0,67,97,110,110,111,116,32,119,114,105,116,101,32,116,111,32,102,105,108,101,32,37,115,0,67,97,110,110,111,116,32,97,108,108,111,99,32,109,101,109,111,114,121,0,0,0,0,0,77,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,119,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,114,43,0,0,0,0,0,0,119,43,0,0,0,0,0,0,97,43,0,0,0,0,0,0,119,98,0,0,0,0,0,0,97,98,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,119,43,98,0,0,0,0,0,97,43,98,0,0,0,0,0,100,101,114,40,0,0,0,0,104,0,0,0,0,0,0,0,248,186,1,0,8,0,0,0,9,0,0,0,152,255,255,255,152,255,255,255,248,186,1,0,10,0,0,0,11,0,0,0,156,186,1,0,20,187,1,0,40,187,1,0,176,186,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,111,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,200,116,2,0,200,186,1,0,80,48,2,0,0,0,0,0,104,0,0,0,0,0,0,0,80,48,2,0,12,0,0,0,13,0,0,0,152,255,255,255,152,255,255,255,80,48,2,0,14,0,0,0,15,0,0,0,0,0,0,0,160,187,1,0,16,0,0,0,17,0,0,0,3,0,0,0,8,0,0,0,2,0,0,0,4,0,0,0,31,0,0,0,32,0,0,0,9,0,0,0,33,0,0,0,34,0,0,0,24,0,0,0,10,0,0,0,25,0,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,200,116,2,0,112,187,1,0,72,47,2,0,0,0,0,0,0,0,0,0,40,188,1,0,48,188,1,0,32,188,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,188,1,0,16,188,1,0,32,188,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,99,112,117,32,116,105,109,101,32,91,115,93,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,83,105,109,117,108,97,116,105,111,110,32,116,105,109,101,32,91,115,93,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,0,0,0,0,0,65,117,116,111,109,97,116,105,99,32,111,117,116,112,117,116,32,115,116,101,112,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,79,112,101,110,77,111,100,101,108,105,99,97,32,121,101,116,46,32,83,101,116,32,110,117,109,112,111,105,110,116,115,32,62,61,32,48,46,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,32,102,97,105,108,101,100,0,0,0,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,35,80,116,111,108,101,109,121,32,80,108,111,116,32,102,105,108,101,44,32,103,101,110,101,114,97,116,101,100,32,98,121,32,79,112,101,110,77,111,100,101,108,105,99,97,10,0,0,35,78,117,109,98,101,114,111,102,86,97,114,105,97,98,108,101,115,61,37,100,10,0,0,35,73,110,116,101,114,118,97,108,83,105,122,101,61,37,108,100,10,0,0,0,0,0,0,84,105,116,108,101,84,101,120,116,58,32,79,112,101,110,77,111,100,101,108,105,99,97,32,115,105,109,117,108,97,116,105,111,110,32,112,108,111,116,10,0,0,0,0,0,0,0,0,88,76,97,98,101,108,58,32,116,10,10,0,0,0,0,0,68,97,116,97,83,101,116,58,32,116,105,109,101,10,0,0,68,97,116,97,83,101,116,58,32,36,99,112,117,84,105,109,101,10,0,0,0,0,0,0,68,97,116,97,83,101,116,58,32,37,115,10,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,119,114,105,116,101,32,116,111,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,37,46,49,54,103,44,32,37,46,49,54,103,10,0,0,0,114,101,99,111,110,58,119,97,108,108,58,118,48,49,0,0,0,0,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,112,97,114,97,109,115,0,0,99,111,110,116,105,110,117,111,117,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,101,116,97,0,0,0,116,97,98,115,0,0,0,0,111,98,106,115,0,0,0,0,116,109,101,116,97,0,0,0,115,105,103,115,0,0,0,0,116,105,109,101,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,118,109,101,116,97,0,0,0,84,105,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,97,108,115,0,0,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,105,110,118,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,118,97,108,117,101,82,101,102,101,114,101,110,99,101,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,102,105,108,101,78,97,109,101,0,0,0,0,0,0,0,0,115,116,97,114,116,76,105,110,101,0,0,0,0,0,0,0,115,116,97,114,116,67,111,108,117,109,110,0,0,0,0,0,101,110,100,76,105,110,101,0,101,110,100,67,111,108,117,109,110,0,0,0,0,0,0,0,102,105,108,101,87,114,105,116,97,98,108,101,0,0,0,0,117,115,101,83,116,97,114,116,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,102,105,120,101,100,0,0,0,117,115,101,78,111,109,105,110,97,108,0,0,0,0,0,0,110,111,109,105,110,97,108,0,109,105,110,0,0,0,0,0,109,97,120,0,0,0,0,0,82,101,97,108,32,37,115,40,37,115,115,116,97,114,116,61,37,103,37,115,44,32,102,105,120,101,100,61,37,115,44,32,37,115,110,111,109,105,110,97,108,61,37,103,37,115,44,32,109,105,110,61,37,103,44,32,109,97,120,61,37,103,41,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,116,101,103,101,114,32,37,115,40,37,115,115,116,97,114,116,61,37,108,100,37,115,44,32,102,105,120,101,100,61,37,115,44,32,109,105,110,61,37,108,100,44,32,109,97,120,61,37,108,100,41,0,0,0,66,111,111,108,101,97,110,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,44,32,102,105,120,101,100,61,37,115,41,0,0,0,0,0,0,83,116,114,105,110,103,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,41,0,95,105,110,105,116,46,120,109,108,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,97,110,32,110,111,116,32,114,101,97,100,32,102,105,108,101,32,37,115,32,97,115,32,115,101,116,117,112,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,46,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,88,77,76,32,112,97,114,115,101,114,33,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,37,115,44,32,37,115,32,37,108,117,10,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,103,117,105,100,0,0,0,0,84,104,101,32,77,111,100,101,108,32,71,85,73,68,58,32,37,115,32,105,115,32,110,111,116,32,115,101,116,32,105,110,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,0,69,114,114,111,114,44,32,116,104,101,32,71,85,73,68,58,32,37,115,32,102,114,111,109,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,58,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,71,85,73,68,32,99,111,109,112,105,108,101,100,32,105,110,32,116,104,101,32,109,111,100,101,108,58,32,37,115,0,0,114,101,97,100,32,97,108,108,32,116,104,101,32,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,32,118,97,108,117,101,115,58,0,0,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,115,116,97,114,116,84,105,109,101,32,61,32,37,103,0,0,115,116,111,112,84,105,109,101,0,0,0,0,0,0,0,0,115,116,111,112,84,105,109,101,32,61,32,37,103,0,0,0,115,116,101,112,83,105,122,101,0,0,0,0,0,0,0,0,115,116,101,112,83,105,122,101,32,61,32,37,103,0,0,0,116,111,108,101,114,97,110,99,101,0,0,0,0,0,0,0,116,111,108,101,114,97,110,99,101,32,61,32,37,103,0,0,115,111,108,118,101,114,0,0,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,0,0,0,0,0,0,0,111,117,116,112,117,116,70,111,114,109,97,116,0,0,0,0,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,37,115,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,70,105,108,116,101,114,0,0,118,97,114,105,97,98,108,101,32,102,105,108,116,101,114,58,32,37,115,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,0,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,58,32,37,115,0,0,0,0,110,117,109,98,101,114,79,102,67,111,110,116,105,110,117,111,117,115,83,116,97,116,101,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,82,101,97,108,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,110,117,109,98,101,114,79,102,82,101,97,108,80,97,114,97,109,101,116,101,114,115,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,111,100,101,108,46,0,0,0,0,110,120,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,100,0,0,0,0,0,0,0,110,121,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,112,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,121,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,112,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,37,115,0,0,0,0,114,101,97,108,32,115,116,97,116,101,115,0,0,0,0,0,105,115,80,114,111,116,101,99,116,101,100,0,0,0,0,0,102,105,108,116,101,114,105,110,103,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,32,37,115,0,114,101,97,108,32,115,116,97,116,101,32,100,101,114,105,118,97,116,105,118,101,115,0,0,114,101,97,108,32,97,108,103,101,98,114,97,105,99,115,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,114,101,97,108,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,0,0,97,108,105,97,115,0,0,0,110,101,103,97,116,101,100,65,108,105,97,115,0,0,0,0,114,101,97,100,32,102,111,114], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+106848);
/* memory initializer */ allocate([32,37,115,32,110,101,103,97,116,101,100,32,37,100,32,102,114,111,109,32,115,101,116,117,112,32,102,105,108,101,0,0,97,108,105,97,115,86,97,114,105,97,98,108,101,0,0,0,116,105,109,101,0,0,0,0,82,101,97,108,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,0,0,32,110,111,116,32,102,111,117,110,100,46,0,0,0,0,0,37,115,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,105,110,116,101,103,101,114,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,73,110,116,101,103,101,114,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,98,111,111,108,101,97,110,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,66,111,111,108,101,97,110,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,115,116,114,105,110,103,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,83,116,114,105,110,103,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,117,115,97,103,101,32,101,114,114,111,114,32,121,111,117,32,99,97,110,110,111,116,32,104,97,118,101,32,98,111,116,104,32,45,111,118,101,114,114,105,100,101,32,97,110,100,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,97,99,116,105,118,101,32,97,116,32,116,104,101,32,115,97,109,101,32,116,105,109,101,46,32,115,101,101,32,77,111,100,101,108,32,45,63,32,102,111,114,32,109,111,114,101,32,105,110,102,111,33,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,32,102,114,111,109,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,99,111,117,108,100,32,110,111,116,32,111,112,101,110,32,116,104,101,32,102,105,108,101,32,103,105,118,101,110,32,116,111,32,45,111,118,101,114,114,105,100,101,70,105,108,101,61,37,115,0,0,0,0,0,44,0,0,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,58,32,37,115,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,37,115,32,61,32,37,115,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,100,111,110,101,33,0,0,78,79,32,111,118,101,114,114,105,100,101,32,103,105,118,101,110,32,111,110,32,116,104,101,32,99,111,109,109,97,110,100,32,108,105,110,101,46,0,0,108,0,0,0,0,0,0,0,128,204,1,0,18,0,0,0,19,0,0,0,148,255,255,255,148,255,255,255,128,204,1,0,20,0,0,0,21,0,0,0,36,204,1,0,156,204,1,0,176,204,1,0,56,204,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,200,116,2,0,80,204,1,0,192,47,2,0,0,0,0,0,108,0,0,0,0,0,0,0,192,47,2,0,22,0,0,0,23,0,0,0,148,255,255,255,148,255,255,255,192,47,2,0,24,0,0,0,25,0,0,0,101,114,114,111,114,32,114,101,97,100,95,118,97,108,117,101,44,32,110,111,32,100,97,116,97,32,97,108,108,111,99,97,116,101,100,32,102,111,114,32,115,116,111,114,105,110,103,32,115,116,114,105,110,103,0,0,102,109,105,77,111,100,101,108,68,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,0,0,0,0,0,0,0,83,99,97,108,97,114,86,97,114,105,97,98,108,101,0,0,99,108,97,115,115,73,110,100,101,120,0,0,0,0,0,0,99,108,97,115,115,84,121,112,101,0,0,0,0,0,0,0,114,83,116,97,0,0,0,0,114,68,101,114,0,0,0,0,114,65,108,103,0,0,0,0,114,80,97,114,0,0,0,0,114,65,108,105,0,0,0,0,105,65,108,103,0,0,0,0,105,80,97,114,0,0,0,0,105,65,108,105,0,0,0,0,98,65,108,103,0,0,0,0,98,80,97,114,0,0,0,0,98,65,108,105,0,0,0,0,115,65,108,103,0,0,0,0,115,80,97,114,0,0,0,0,115,65,108,105,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,101,114,114,111,114,32,114,101,97,100,105,110,103,32,116,104,101,32,120,109,108,32,102,105,108,101,44,32,102,111,117,110,100,32,117,110,107,110,111,119,110,32,99,108,97,115,115,58,32,37,115,32,32,102,111,114,32,118,97,114,105,97,98,108,101,58,32,37,115,0,82,101,97,108,0,0,0,0,73,110,116,101,103,101,114,0,66,111,111,108,101,97,110,0,83,116,114,105,110,103,0,0,118,97,114,105,97,98,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,79,71,95,65,76,76,0,44,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,37,45,49,56,115,32,91,37,115,93,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,118,32,37,115,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,110,108,115,61,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,108,97,112,97,99,107,0,0,108,105,115,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,115,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,76,105,115,0,0,0,0,0,94,40,0,0,0,0,0,0,41,36,0,0,0,0,0,0,36,100,117,109,109,121,0,0,46,42,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,58,32,0,0,32,119,105,116,104,32,101,114,114,111,114,58,32,0,0,0,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,111,117,116,112,117,116,116,105,110,103,32,97,108,108,32,118,97,114,105,97,98,108,101,115,46,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,114,118,97,108,115,32,61,32,37,108,100,0,67,80,85,0,0,0,0,0,82,84,0,0,0,0,0,0,67,89,67,0,0,0,0,0,91,117,110,107,110,111,119,110,32,99,108,111,99,107,45,116,121,112,101,93,32,103,111,116,32,37,115,44,32,101,120,112,101,99,116,101,100,32,67,80,85,124,82,84,124,67,89,67,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,82,84,46,0,0,0,0,0,67,104,111,115,101,110,32,99,108,111,99,107,45,116,121,112,101,58,32,37,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,114,101,97,108,45,116,105,109,101,46,0,0,76,105,110,101,97,114,105,122,97,116,105,111,110,32,119,105,108,108,32,112,101,114,102,111,114,109,101,100,32,97,116,32,112,111,105,110,116,32,111,102,32,116,105,109,101,58,32,37,102,0,0,0,0,0,0,0,111,118,101,114,119,114,105,116,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,32,91,102,114,111,109,32,99,111,109,109,97,110,100,32,108,105,110,101,93,0,95,114,101,115,46,0,0,0,0,0,0,0,0,0,0,0,76,105,110,101,97,114,32,109,111,100,101,108,32,105,115,32,99,114,101,97,116,101,100,33,0,0,0,0,0,0,0,0,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,95,112,114,111,102,46,112,108,116,0,0,0,0,0,0,0,115,118,103,0,0,0,0,0,101,109,112,116,121,0,0,0,99,115,118,0,0,0,0,0,109,97,116,0,0,0,0,0,119,97,108,108,0,0,0,0,112,108,116,0,0,0,0,0,85,110,107,110,111,119,110,32,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,0,65,108,108,111,99,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,115,116,111,114,97,103,101,32,102,111,114,32,109,101,116,104,111,100,32,39,37,115,39,32,97,110,100,32,102,105,108,101,61,39,37,115,39,0,0,120,214,1,0,96,216,1,0,104,216,1,0,176,218,1,0,200,216,1,0,216,216,1,0,184,218,1,0,192,218,1,0,200,218,1,0,208,218,1,0,224,218,1,0,240,218,1,0,0,219,1,0,16,219,1,0,32,219,1,0,48,219,1,0,64,219,1,0,88,219,1,0,144,218,1,0,168,218,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,115,32,37,115,0,0,0,0,0,0,0,120,214,1,0,96,216,1,0,104,216,1,0,120,216,1,0,200,216,1,0,216,216,1,0,232,216,1,0,8,217,1,0,40,217,1,0,72,217,1,0,112,217,1,0,152,217,1,0,192,217,1,0,232,217,1,0,0,218,1,0,32,218,1,0,64,218,1,0,104,218,1,0,144,218,1,0,168,218,1,0,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,37,115,0,0,0,117,115,97,103,101,58,32,37,115,0,0,0,0,0,0,0,60,45,37,115,62,10,32,32,37,115,0,0,0,0,0,0,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,32,32,37,115,0,91,117,110,107,110,111,119,110,32,102,108,97,103,45,116,121,112,101,93,32,60,45,37,115,62,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,108,111,103,70,111,114,109,97,116,61,37,115,44,32,101,120,112,101,99,116,101,100,32,116,101,120,116,32,111,114,32,120,109,108,0,0,0,0,0,0,0,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,62,10,37,115,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,37,115,0,0,0,0,120,214,1,0,64,216,1,0,72,216,1,0,80,216,1,0,120,214,1,0,128,215,1,0,208,215,1,0,0,216,1,0,120,214,1,0,64,215,1,0,72,215,1,0,80,215,1,0,96,215,1,0,104,215,1,0,120,215,1,0,0,0,0,0,120,214,1,0,128,214,1,0,152,214,1,0,168,214,1,0,240,214,1,0,0,215,1,0,32,215,1,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,104,101,108,112,61,37,115,0,0,0,117,115,101,32,37,115,32,45,104,101,108,112,32,102,111,114,32,97,32,108,105,115,116,32,111,102,32,97,108,108,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,67,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,103,108,111,98,97,108,32,100,97,116,97,32,115,116,114,117,99,116,117,114,101,32,102,105,108,101,0,0,0,0,0,0,78,111,32,118,97,114,105,97,98,108,101,115,32,105,110,32,116,104,101,32,109,111,100,101,108,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,109,111,100,101,108,62,37,115,60,47,109,111,100,101,108,62,10,0,0,0,0,0,0,60,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,37,103,60,47,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,10,0,0,60,111,108,100,84,105,109,101,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,62,10,0,0,0,0,0,0,0,60,111,108,100,84,105,109,101,50,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,50,62,10,0,0,0,0,0,60,100,105,102,102,79,108,100,84,105,109,101,62,37,103,60,47,100,105,102,102,79,108,100,84,105,109,101,62,10,0,0,60,99,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,99,117,114,114,101,110,116,84,105,109,101,62,10,0,0,60,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,10,0,0,5,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,69,114,114,111,114,58,32,0,85,110,104,97,110,100,108,101,100,32,65,115,115,101,114,116,105,111,110,45,69,114,114,111,114,0,0,0,0,0,0,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,101,117,108,101,114,0,0,0,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,114,97,100,97,117,53,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,51,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,49,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,108,111,98,97,116,116,111,50,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,113,115,115,0,0,0,0,0,100,97,115,115,108,0,0,0,114,97,100,97,117,53,0,0,114,97,100,97,117,51,0,0,114,97,100,97,117,49,0,0,108,111,98,97,116,116,111,50,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,0,0,0,0,0,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,60,115,116,97,116,117,115,62,0,0,0,0,0,0,0,0,60,112,104,97,115,101,62,85,78,75,78,79,87,78,60,47,112,104,97,115,101,62,0,0,60,47,115,116,97,116,117,115,62,0,0,0,0,0,0,0,44,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,115,101,101,100,58,32,100,97,116,97,45,62,115,105,109,117,108,97,116,105,111,110,73,110,102,111,46,97,110,97,108,121,116,105,99,74,97,99,111,98,105,97,110,115,91,105,110,100,101,120,93,46,115,101,101,100,86,97,114,115,91,37,100,93,61,32,37,102,0,0,0,0,119,114,105,116,101,32,105,110,32,106,97,99,91,37,100,93,45,91,37,100,44,37,100,93,61,37,103,32,102,114,111,109,32,114,111,119,91,37,100,93,61,37,103,0,0,0,0,0,80,114,105,110,116,32,106,97,99,58,0,0,0,0,0,0,37,32,46,53,101,32,0,0,99,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,65,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,66,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,67,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,68,32,0,0,0,0,105,32,102,111,114,32,105,32,105,110,32,49,58,48,0,0,108,105,110,101,97,114,95,0,46,109,111,0,0,0,0,0,119,98,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,0,0,0,0,0,56,0,0,0,0,0,0,0,152,221,1,0,26,0,0,0,27,0,0,0,200,255,255,255,200,255,255,255,152,221,1,0,28,0,0,0,29,0,0,0,36,221,1,0,180,221,1,0,200,221,1,0,56,221,1,0,78,83,116,51,95,95,49,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,200,116,2,0,80,221,1,0,80,48,2,0,0,0,0,0,56,0,0,0,0,0,0,0,80,48,2,0,12,0,0,0,13,0,0,0,200,255,255,255,200,255,255,255,80,48,2,0,14,0,0,0,15,0,0,0,0,0,0,0,88,222,1,0,30,0,0,0,31,0,0,0,4,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,36,0,0,0,34,0,0,0,26,0,0,0,10,0,0,0,27,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,200,116,2,0,16,222,1,0,72,47,2,0,0,0,0,0,67,97,108,117,99,117,108,97,116,101,32,111,110,101,32,99,111,108,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,103,110,117,112,108,111,116,0,80,108,111,116,115,32,111,102,32,112,114,111,102,105,108,105,110,103,32,100,97,116,97,32,119,101,114,101,32,100,105,115,97,98,108,101,100,58,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,58,32,37,115,10,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,115,118,103,10,0,0,0,0,0,0,0,115,101,116,32,110,111,107,101,121,10,0,0,0,0,0,0,115,101,116,32,102,111,114,109,97,116,32,121,32,34,37,103,34,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,111,102,32,103,108,111,98,97,108,32,115,116,101,112,115,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,100,111,99,32,91,32,32,60,33,69,76,69,77,69,78,84,32,115,105,109,117,108,97,116,105,111,110,32,40,109,111,100,101,108,105,110,102,111,44,32,118,97,114,105,97,98,108,101,115,44,32,102,117,110,99,116,105,111,110,115,44,32,101,113,117,97,116,105,111,110,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,118,97,114,105,97,98,108,101,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,101,113,117,97,116,105,111,110,32,40,114,101,102,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,101,113,117,97,116,105,111,110,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,115,32,40,112,114,111,102,105,108,101,98,108,111,99,107,42,41,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,32,40,114,101,102,115,44,32,110,99,97,108,108,44,32,116,105,109,101,44,32,109,97,120,84,105,109,101,41,62,32,32,60,33,69,76,69,77,69,78,84,32,114,101,102,115,32,40,114,101,102,42,41,62,32,32,60,33,65,84,84,76,73,83,84,32,114,101,102,32,114,101,102,105,100,32,73,68,82,69,70,32,35,82,69,81,85,73,82,69,68,62,32,32,93,62,10,0,0,0,0,116,105,109,101,40,41,32,102,97,105,108,101,100,58,32,37,115,0,0,0,0,0,0,0,37,89,45,37,109,45,37,100,32,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,115,116,114,102,116,105,109,101,40,41,32,102,97,105,108,101,100,0,0,0,0,0,0,0,60,115,105,109,117,108,97,116,105,111,110,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,62,10,0,0,0,0,60,110,97,109,101,62,0,0,60,47,110,97,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,102,105,120,62,0,0,0,0,0,0,0,0,60,47,112,114,101,102,105,120,62,10,0,0,0,0,0,0,60,100,97,116,101,62,0,0,60,47,100,97,116,101,62,10,0,0,0,0,0,0,0,0,60,109,101,116,104,111,100,62,0,0,0,0,0,0,0,0,60,47,109,101,116,104,111,100,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,111,114,109,97,116,62,0,0,60,47,111,117,116,112,117,116,70,111,114,109,97,116,62,10,0,0,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,0,0,0,0,0,0,0,0,60,47,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,37,108,100,60,47,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,10,0,0,0,60,111,118,101,114,104,101,97,100,84,105,109,101,62,37,102,60,47,111,118,101,114,104,101,97,100,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,105,110,105,116,84,105,109,101,62,37,102,60,47,112,114,101,105,110,105,116,84,105,109,101,62,10,0,0,60,105,110,105,116,84,105,109,101,62,37,102,60,47,105,110,105,116,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,101,118,101,110,116,84,105,109,101,62,37,102,60,47,101,118,101,110,116,84,105,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,84,105,109,101,62,37,102,60,47,111,117,116,112,117,116,84,105,109,101,62,10,0,0,0,0,60,108,105,110,101,97,114,105,122,101,84,105,109,101,62,37,102,60,47,108,105,110,101,97,114,105,122,101,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,84,105,109,101,62,37,102,60,47,116,111,116,97,108,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,37,102,60,47,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,10,0,0,0,0,60,110,117,109,83,116,101,112,62,37,100,60,47,110,117,109,83,116,101,112,62,10,0,0,60,109,97,120,84,105,109,101,62,37,46,57,102,60,47,109,97,120,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,0,60,111,100,101,84,105,109,101,62,37,102,60,47,111,100,101,84,105,109,101,62,10,0,0,60,111,100,101,84,105,109,101,84,105,99,107,115,62,37,108,117,60,47,111,100,101,84,105,109,101,84,105,99,107,115,62,10,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,60,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,0,60,47,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,60,118,97,114,105,97,98,108,101,115,62,10,0,0,0,0,60,47,118,97,114,105,97,98,108,101,115,62,10,0,0,0,60,102,117,110,99,116,105,111,110,115,62,10,0,0,0,0,60,47,102,117,110,99,116,105,111,110,115,62,10,0,0,0,60,101,113,117,97,116,105,111,110,115,62,10,0,0,0,0,60,47,101,113,117,97,116,105,111,110,115,62,10,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,60,47,115,105,109,117,108,97,116,105,111,110,62,10,0,0,98,117,102,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,109,111,100,101,108,105,110,102,111,46,99,0,0,112,114,105,110,116,77,111,100,101,108,73,110,102,111,0,0,87,97,114,110,105,110,103,58,32,80,108,111,116,32,99,111,109,109,97,110,100,32,102,97,105,108,101,100,10,0,0,0,120,115,108,116,112,114,111,99,0,0,0,0,0,0,0,0,37,115,32,45,111,32,37,115,95,112,114,111,102,46,104,116,109,108,32,37,115,47,115,104,97,114,101,47,111,109,99,47,115,99,114,105,112,116,115,47,100,101,102,97,117,108,116,95,112,114,111,102,105,108,105,110,103,46,120,115,108,32,37,115,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,103,101,110,101,114,97,116,101,32,104,116,109,108,32,118,101,114,115,105,111,110,32,111,102,32,112,114,111,102,105,108,105,110,103,32,114,101,115,117,108,116,115,58,32,37,115,10,0,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,97,114,101,32,115,116,111,114,101,100,32,105,110,32,37,115,95,112,114,111,102,46,104,116,109,108,32,40,104,117,109,97,110,45,114,101,97,100,97,98,108,101,41,32,97,110,100,32,37,115,95,112,114,111,102,46,120,109,108,32,40,102,111,114,32,88,83,76,32,116,114,97,110,115,102,111,114,109,115,32,111,114,32,109,111,114,101,32,100,101,116,97,105,108,115,41,0,0,0,0,0,0,101,113,0,0,0,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,101,113,37,100,34,47,62,10,0,0,0,0,60,110,99,97,108,108,62,37,100,60,47,110,99,97,108,108,62,10,0,0,0,0,0,0,60,116,105,109,101,62,37,46,57,102,60,47,116,105,109,101,62,10,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,0,0,0,0,0,0,0,60,101,113,117,97,116,105,111,110,32,105,100,61,34,101,113,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,0,34,62,10,0,0,0,0,0,60,114,101,102,115,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,118,97,114,37,100,34,32,47,62,10,0,0,60,47,114,101,102,115,62,10,0,0,0,0,0,0,0,0,60,99,97,108,99,105,110,102,111,32,116,105,109,101,61,34,37,102,34,32,99,111,117,110,116,61,34,37,108,117,34,47,62,10,0,0,0,0,0,0,60,47,101,113,117,97,116,105,111,110,62,10,0,0,0,0,102,117,110,0,0,0,0,0,60,102,117,110,99,116,105,111,110,32,105,100,61,34,102,117,110,37,100,34,62,10,0,0,60,47,102,117,110,99,116,105,111,110,62,10,0,0,0,0,60,105,110,102,111,32,102,105,108,101,110,97,109,101,61,34,0,0,0,0,0,0,0,0,34,32,115,116,97,114,116,108,105,110,101,61,34,37,100,34,32,115,116,97,114,116,99,111,108,61,34,37,100,34,32,101,110,100,108,105,110,101,61,34,37,100,34,32,101,110,100,99,111,108,61,34,37,100,34,32,114,101,97,100,111,110,108,121,61,34,37,115,34,32,47,62,10,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,60,118,97,114,105,97,98,108,101,32,105,100,61,34,118,97,114,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,34,32,99,111,109,109,101,110,116,61,34,0,0,0,0,0,60,47,118,97,114,105,97,98,108,101,62,10,0,0,0,0,37,115,95,112,114,111,102,46,100,97,116,97,0,0,0,0,60,102,105,108,101,110,97,109,101,62,0,0,0,0,0,0,60,47,102,105,108,101,110,97,109,101,62,10,0,0,0,0,60,102,105,108,101,115,105,122,101,62,37,108,100,60,47,102,105,108,101,115,105,122,101,62,10,0,0,0,0,0,0,0,60,102,111,114,109,97,116,62,10,0,0,0,0,0,0,0,60,117,105,110,116,51,50,62,115,116,101,112,60,47,117,105,110,116,51,50,62,10,0,0,60,100,111,117,98,108,101,62,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,60,100,111,117,98,108,101,62,99,112,117,32,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,0,0,0,0,60,117,105,110,116,51,50,62,0,0,0,0,0,0,0,0,32,40,99,97,108,108,115,41,60,47,117,105,110,116,51,50,62,10,0,0,0,0,0,0,60,100,111,117,98,108,101,62,0,0,0,0,0,0,0,0,32,40,99,112,117,32,116,105,109,101,41,60,47,100,111,117,98,108,101,62,10,0,0,0,60,47,102,111,114,109,97,116,62,10,0,0,0,0,0,0,114,98,0,0,0,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,112,111,115,59,0,0,38,113,117,111,116,59,0,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,50,100,111,117,98,108,101,37,37,42,37,100,117,105,110,116,51,50,37,37,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,49,58,40,36,37,100,62,49,101,45,57,32,63,32,36,37,100,32,58,32,49,101,45,51,48,41,32,119,32,108,32,108,119,32,37,100,10,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,42,50,100,111,117,98,108,101,37,37,37,100,117,105,110,116,51,50,37,37,42,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,37,100,32,119,32,108,32,108,119,32,37,100,10,0,0,0,0,0,0,0,0,117,110,115,101,116,32,120,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,121,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,98,111,114,100,101,114,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,115,101,116,32,116,105,116,108,101,10,0,0,0,0,0,0,115,101,116,32,120,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,108,111,103,32,121,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,37,103,93,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,42,93,10,0,0,0,0,0,0,0,115,101,116,32,110,111,108,111,103,32,120,121,10,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,37,103,58,37,103,93,10,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,0,0,115,101,116,32,121,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,120,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,98,111,114,100,101,114,10,0,0,0,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,37,115,10,0,0,0,0,0,0,0,0,115,101,116,32,116,105,116,108,101,32,34,37,115,34,10,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,97,116,32,116,105,109,101,34,10,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,91,115,93,34,10,0,0,0,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,37,115,34,10,0,0,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,110,117,109,98,101,114,34,10,0,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,99,111,117,110,116,34,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,37,115,58,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,101,120,112,97,116,32,111,98,106,101,99,116,0,0,0,68,117,109,109,121,32,101,113,117,97,116,105,111,110,32,115,111,32,119,101,32,99,97,110,32,105,110,100,101,120,32,102,114,111,109,32,49,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,105,109,117,108,97,116,105,111,110,95,105,110,102,111,95,120,109,108,46,99,0,0,0,0,0,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,120,109,108,45,62,110,69,113,117,97,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,49,93,0,0,0,109,111,100,101,108,73,110,102,111,88,109,108,73,110,105,116,0,0,0,0,0,0,0,0,120,109,108,45,62,110,70,117,110,99,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,51,93,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,119,101,32,111,110,108,121,32,104,97,118,101,32,37,108,100,32,115,117,99,104,32,98,108,111,99,107,115,0,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,105,116,33,0,0,0,0,0,0,118,97,114,105,97,98,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,113,117,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,97,114,0,0,76,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,105,110,100,101,120,32,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,0,110,111,110,108,105,110,101,97,114,0,0,0,0,0,0,0,78,111,110,108,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,114,101,115,105,100,117,97,108,70,117,110,99,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,101,102,105,110,101,115,0,110,97,109,101,0,0,0,0,60,100,101,102,105,110,101,115,62,32,110,101,101,100,115,32,116,111,32,104,97,118,101,32,101,120,97,99,116,108,121,32,111,110,101,32,97,116,116,114,105,98,117,116,101,58,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,0,0,0,0,102,105,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,83,116,97,114,116,0,0,0,0,0,0,0,108,105,110,101,69,110,100,0,99,111,108,83,116,97,114,116,0,0,0,0,0,0,0,0,99,111,108,69,110,100,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,37,115,58,32,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,105,110,32,60,105,110,102,111,62,0,37,115,58,32,73,110,102,111], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+117088);
/* memory initializer */ allocate([32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,109,111,114,101,32,101,113,117,97,116,105,111,110,115,32,116,104,97,110,32,101,120,112,101,99,116,101,100,32,40,37,108,100,41,0,0,0,0,105,110,100,101,120,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,111,117,116,32,105,110,100,101,120,0,0,0,0,0,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,103,111,116,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,105,110,100,101,120,32,37,108,100,44,32,101,120,112,101,99,116,101,100,32,37,108,100,0,0,0,0,0,0,0,83,79,77,69,32,78,73,67,69,32,69,81,85,65,84,73,79,78,32,78,65,77,69,32,40,116,111,32,98,101,32,115,101,116,32,97,32,108,105,116,116,108,101,32,108,97,116,101,114,41,0,0,0,0,0,0,99,111,109,109,101,110,116,0,60,118,97,114,62,45,116,97,103,32,100,105,100,32,110,111,116,32,115,101,116,32,110,97,109,101,32,97,110,100,32,99,111,109,109,101,110,116,0,0,35,70,73,88,77,69,35,0,84,79,68,79,58,32,83,101,116,32,109,101,32,117,112,33,33,33,0,0,0,0,0,0,100,117,109,109,121,86,97,114,83,116,97,116,101,83,101,116,74,97,99,0,0,0,0,0,255,255,255,255,232,242,1,0,232,242,1,0,232,242,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,100,32,39,37,115,39,32,116,104,97,116,32,119,97,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,97,115,32,60,118,97,114,105,97,98,108,101,62,0,0,0,0,0,63,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,78,65,77,69,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,83,67,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,84,65,73,76,69,68,95,68,69,83,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,97,99,104,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,111,110,99,101,58,32,37,115,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,37,115,0,83,84,79,80,32,0,0,0,32,115,116,97,116,101,109,101,110,116,32,101,120,101,99,117,116,101,100,10,0,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,110,100,102,105,108,101,0,101,114,114,111,114,32,105,110,32,102,111,114,109,97,116,0,105,108,108,101,103,97,108,32,117,110,105,116,32,110,117,109,98,101,114,0,0,0,0,0,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,100,105,114,101,99,116,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,115,101,113,117,101,110,116,105,97,108,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,99,97,110,39,116,32,98,97,99,107,115,112,97,99,101,32,102,105,108,101,0,0,0,0,110,117,108,108,32,102,105,108,101,32,110,97,109,101,0,0,99,97,110,39,116,32,115,116,97,116,32,102,105,108,101,0,117,110,105,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,111,102,102,32,101,110,100,32,111,102,32,114,101,99,111,114,100,0,0,0,0,0,0,0,116,114,117,110,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,101,110,100,102,105,108,101,0,0,0,0,105,110,99,111,109,112,114,101,104,101,110,115,105,98,108,101,32,108,105,115,116,32,105,110,112,117,116,0,0,0,0,0,111,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,0,0,0,0,0,0,0,114,101,97,100,32,117,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,98,97,100,32,108,111,103,105,99,97,108,32,105,110,112,117,116,32,102,105,101,108,100,0,98,97,100,32,118,97,114,105,97,98,108,101,32,116,121,112,101,0,0,0,0,0,0,0,98,97,100,32,110,97,109,101,108,105,115,116,32,110,97,109,101,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,32,110,111,116,32,105,110,32,110,97,109,101,108,105,115,116,0,0,0,0,0,0,0,0,110,111,32,101,110,100,32,114,101,99,111,114,100,0,0,0,118,97,114,105,97,98,108,101,32,99,111,117,110,116,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,32,102,111,114,32,115,99,97,108,97,114,32,118,97,114,105,97,98,108,101,0,0,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,115,101,99,116,105,111,110,0,0,0,115,117,98,115,116,114,105,110,103,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,115,117,98,115,99,114,105,112,116,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,99,97,110,39,116,32,114,101,97,100,32,102,105,108,101,0,99,97,110,39,116,32,119,114,105,116,101,32,102,105,108,101,0,0,0,0,0,0,0,0,39,110,101,119,39,32,102,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,0,0,99,97,110,39,116,32,97,112,112,101,110,100,32,116,111,32,102,105,108,101,0,0,0,0,110,111,110,45,112,111,115,105,116,105,118,101,32,114,101,99,111,114,100,32,110,117,109,98,101,114,0,0,0,0,0,0,110,109,76,98,117,102,32,111,118,101,114,102,108,111,119,0,144,245,1,0,160,245,1,0,184,245,1,0,216,245,1,0,248,245,1,0,16,246,1,0,48,246,1,0,72,246,1,0,88,246,1,0,104,246,1,0,128,246,1,0,152,246,1,0,184,246,1,0,216,246,1,0,104,246,1,0,240,246,1,0,16,247,1,0,40,247,1,0,64,247,1,0,88,247,1,0,120,247,1,0,136,247,1,0,168,247,1,0,200,247,1,0,224,247,1,0,248,247,1,0,16,248,1,0,32,248,1,0,56,248,1,0,80,248,1,0,104,248,1,0,136,248,1,0,37,115,58,32,105,108,108,101,103,97,108,32,101,114,114,111,114,32,110,117,109,98,101,114,32,37,100,10,0,0,0,0,37,115,58,32,101,110,100,32,111,102,32,102,105,108,101,10,0,0,0,0,0,0,0,0,37,115,58,32,37,115,10,0,0,0,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,117,110,105,116,32,37,100,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+127328);
/* memory initializer */ allocate([110,97,109,101,100,32,37,115,10,0,0,0,0,0,0,0,40,117,110,110,97,109,101,100,41,10,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,105,110,116,101,114,110,97,108,32,73,47,79,10,0,0,0,0,0,0,0,0,0,0,0,108,97,115,116,32,102,111,114,109,97,116,58,32,37,115,10,0,0,0,0,0,0,0,0,108,97,116,101,108,121,32,37,115,32,37,115,32,37,115,32,37,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,101,97,100,105,110,103,0,119,114,105,116,105,110,103,0,0,0,0,0,0,0,0,0,115,101,113,117,101,110,116,105,97,108,0,0,0,0,0,0,100,105,114,101,99,116,0,0,0,0,0,0,0,0,0,0,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,105,110,116,101,114,110,97,108,0,0,0,0,0,0,0,0,32,73,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+134200);
/* memory initializer */ allocate([117,110,107,110,111,119,110,32,99,111,100,101,32,105,110,32,100,111,95,102,105,111,58,32,37,100,10,37,115,10,0,0,100,111,95,102,105,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,100,32,115,116,114,105,110,103,0,0,0,0,0,0,102,111,114,109,97,116,32,116,111,111,32,99,111,109,112,108,105,99,97,116,101,100,58,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,0,0,0,0,0,0,0,144,33,2,0,152,33,2,0,119,98,0,0,0,0,0,0,119,0,0,0,0,0,0,0,114,43,98,0,0,0,0,0,114,43,0,0,0,0,0,0,168,33,2,0,176,33,2,0,184,33,2,0,192,33,2,0,144,1,0,0,0,0,0,0,48,34,2,0,0,0,0,0,111,112,101,110,0,0,0,0,102,111,114,116,46,37,108,100,0,0,0,0,0,0,0,0,110,111,32,115,112,97,99,101,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,102,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,117,114,101,0,0,115,116,97,114,116,105,111,0,115,102,101,0,0,0,0,0,37,35,46,42,69,0,0,0,37,43,46,50,100,0,0,0,37,35,46,42,102,0,0,0,119,95,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,0,119,95,110,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,108,101,102,116,32,111,102,102,0,0,0,0,0,0,0,0,114,101,99,101,110,100,0,0,115,116,97,114,116,105,111,0,119,114,105,116,101,32,115,116,97,114,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+139424);
/* memory initializer */ allocate([8,41,2,0,32,0,0,0,33,0,0,0,5,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,37,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,200,116,2,0,232,40,2,0,136,47,2,0,0,0,0,0,0,0,0,0,112,41,2,0,34,0,0,0,35,0,0,0,6,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,42,0,0,0,43,0,0,0,30,0,0,0,15,0,0,0,31,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,200,116,2,0,88,41,2,0,136,47,2,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,0,0,0,0,8,42,2,0,36,0,0,0,37,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,44,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,16,0,0,0,33,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,200,116,2,0,232,41,2,0,72,47,2,0,0,0,0,0,0,0,0,0,112,42,2,0,38,0,0,0,39,0,0,0,8,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,46,0,0,0,47,0,0,0,34,0,0,0,10,0,0,0,35,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,200,116,2,0,88,42,2,0,72,47,2,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,160,116,2,0,128,42,2,0,0,0,0,0,232,42,2,0,40,0,0,0,41,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,144,43,2,0,42,0,0,0,43,0,0,0,49,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,200,116,2,0,216,42,2,0,0,0,0,0,0,0,0,0,0,0,0,0,40,43,2,0,40,0,0,0,44,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,200,116,2,0,16,43,2,0,232,42,2,0,0,0,0,0,0,0,0,0,104,43,2,0,40,0,0,0,45,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,200,116,2,0,80,43,2,0,232,42,2,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,200,116,2,0,120,43,2,0,0,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,0,0,0,0,216,43,2,0,46,0,0,0,47,0,0,0,49,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,200,116,2,0,192,43,2,0,144,43,2,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,160,116,2,0,232,43,2,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,200,116,2,0,16,44,2,0,8,44,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,0,0,0,0,192,46,2,0,48,0,0,0,49,0,0,0,0,0,0,0,72,47,2,0,50,0,0,0,51,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,10,0,0,0,35,0,0,0,0,0,0,0,136,47,2,0,52,0,0,0,53,0,0,0,9,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,15,0,0,0,31,0,0,0,8,0,0,0,0,0,0,0,192,47,2,0,22,0,0,0,23,0,0,0,248,255,255,255,248,255,255,255,192,47,2,0,24,0,0,0,25,0,0,0,8,0,0,0,0,0,0,0,8,48,2,0,54,0,0,0,55,0,0,0,248,255,255,255,248,255,255,255,8,48,2,0,56,0,0,0,57,0,0,0,4,0,0,0,0,0,0,0,80,48,2,0,12,0,0,0,13,0,0,0,252,255,255,255,252,255,255,255,80,48,2,0,14,0,0,0,15,0,0,0,4,0,0,0,0,0,0,0,152,48,2,0,58,0,0,0,59,0,0,0,252,255,255,255,252,255,255,255,152,48,2,0,60,0,0,0,61,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,46,2,0,62,0,0,0,63,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,136,46,2,0,64,0,0,0,65,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,200,116,2,0,64,46,2,0,216,43,2,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,160,116,2,0,112,46,2,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,200,116,2,0,144,46,2,0,136,46,2,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,200,116,2,0,208,46,2,0,136,46,2,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,160,116,2,0,16,47,2,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,160,116,2,0,80,47,2,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,40,117,2,0,144,47,2,0,0,0,0,0,1,0,0,0,192,46,2,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,40,117,2,0,216,47,2,0,0,0,0,0,1,0,0,0,0,47,2,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,40,117,2,0,32,48,2,0,0,0,0,0,1,0,0,0,192,46,2,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,40,117,2,0,104,48,2,0,0,0,0,0,1,0,0,0,0,47,2,0,3,244,255,255,0,0,0,0,248,48,2,0,66,0,0,0,67,0,0,0,50,0,0,0,2,0,0,0,17,0,0,0,18,0,0,0,3,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,200,116,2,0,216,48,2,0,40,44,2,0,0,0,0,0,0,0,0,0,32,63,2,0,68,0,0,0,69,0,0,0,70,0,0,0,1,0,0,0,9,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,63,2,0,71,0,0,0,72,0,0,0,70,0,0,0,2,0,0,0,10,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,67,2,0,73,0,0,0,74,0,0,0,70,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,144,68,2,0,75,0,0,0,76,0,0,0,70,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,69,2,0,77,0,0,0,78,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,23,0,0,0,8,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,69,2,0,79,0,0,0,80,0,0,0,70,0,0,0,10,0,0,0,11,0,0,0,25,0,0,0,12,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,16,65,2,0,81,0,0,0,82,0,0,0,70,0,0,0,51,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,16,65,2,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,72,58,37,77,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,176,65,2,0,83,0,0,0,84,0,0,0,70,0,0,0,59,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,176,65,2,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,64,66,2,0,85,0,0,0,86,0,0,0,70,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,66,2,0,87,0,0,0,88,0,0,0,70,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,63,2,0,89,0,0,0,90,0,0,0,70,0,0,0,67,0,0,0,68,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,69,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,63,2,0,91,0,0,0,92,0,0,0,70,0,0,0,70,0,0,0,71,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,72,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,64,2,0,93,0,0,0,94,0,0,0,70,0,0,0,73,0,0,0,74,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,75,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,64,2,0,95,0,0,0,96,0,0,0,70,0,0,0,76,0,0,0,77,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,78,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,70,2,0,97,0,0,0,98,0,0,0,70,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,76,102,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,0,0,0,0,8,71,2,0,99,0,0,0,100,0,0,0,70,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,0,0,0,0,152,71,2,0,101,0,0,0,102,0,0,0,70,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,0,0,0,0,40,72,2,0,103,0,0,0,104,0,0,0,70,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,2,0,105,0,0,0,106,0,0,0,70,0,0,0,21,0,0,0,14,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,67,2,0,107,0,0,0,108,0,0,0,70,0,0,0,22,0,0,0,15,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,118,101,99,116,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,248,62,2,0,109,0,0,0,110,0,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,59,2,0,111,0,0,0,112,0,0,0,70,0,0,0,36,0,0,0,23,0,0,0,37,0,0,0,24,0,0,0,38,0,0,0,28,0,0,0,25,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,60,2,0,113,0,0,0,114,0,0,0,70,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,79,0,0,0,80,0,0,0,5,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,62,2,0,115,0,0,0,116,0,0,0,70,0,0,0,82,0,0,0,83,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,208,62,2,0,117,0,0,0,118,0,0,0,70,0,0,0,84,0,0,0,85,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,116,114,117,101,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,0,0,0,0,8,59,2,0,119,0,0,0,120,0,0,0,70,0,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,200,116,2,0,240,58,2,0,160,42,2,0,0,0,0,0,0,0,0,0,152,59,2,0,119,0,0,0,121,0,0,0,70,0,0,0,26,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,39,0,0,0,27,0,0,0,40,0,0,0,28,0,0,0,41,0,0,0,32,0,0,0,29,0,0,0,6,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,160,116,2,0,120,59,2,0,40,117,2,0,96,59,2,0,0,0,0,0,2,0,0,0,8,59,2,0,2,0,0,0,144,59,2,0,2,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,40,117,2,0,184,59,2,0,0,0,0,0,2,0,0,0,8,59,2,0,2,0,0,0,144,59,2,0,2,0,0,0,0,0,0,0,104,60,2,0,119,0,0,0,122,0,0,0,70,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,86,0,0,0,87,0,0,0,8,0,0,0,88,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,160,116,2,0,72,60,2,0,40,117,2,0,32,60,2,0,0,0,0,0,2,0,0,0,8,59,2,0,2,0,0,0,96,60,2,0,2,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,40,117,2,0,136,60,2,0,0,0,0,0,2,0,0,0,8,59,2,0,2,0,0,0,96,60,2,0,2,0,0,0,0,0,0,0,40,61,2,0,119,0,0,0,123,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,9,0,0,0,89,0,0,0,90,0,0,0,10,0,0,0,91,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,40,117,2,0,0,61,2,0,0,0,0,0,2,0,0,0,8,59,2,0,2,0,0,0,96,60,2,0,2,0,0,0,0,0,0,0,160,61,2,0,119,0,0,0,124,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,40,117,2,0,120,61,2,0,0,0,0,0,2,0,0,0,8,59,2,0,2,0,0,0,96,60,2,0,2,0,0,0,0,0,0,0,24,62,2,0,119,0,0,0,125,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,200,116,2,0,240,61,2,0,160,61,2,0,0,0,0,0,0,0,0,0,128,62,2,0,119,0,0,0,126,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,200,116,2,0,88,62,2,0,160,61,2,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,200,116,2,0,144,62,2,0,8,59,2,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,200,116,2,0,184,62,2,0,8,59,2,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,200,116,2,0,224,62,2,0,8,59,2,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,200,116,2,0,8,63,2,0,8,59,2,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,200,116,2,0,48,63,2,0,8,59,2,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,160,116,2,0,120,63,2,0,40,117,2,0,88,63,2,0,0,0,0,0,2,0,0,0,8,59,2,0,2,0,0,0,144,63,2,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,40,117,2,0,184,63,2,0,0,0,0,0,2,0,0,0,8,59,2,0,2,0,0,0,144,63,2,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,40,117,2,0,248,63,2,0,0,0,0,0,2,0,0,0,8,59,2,0,2,0,0,0,144,63,2,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,40,117,2,0,56,64,2,0,0,0,0,0,2,0,0,0,8,59,2,0,2,0,0,0,144,63,2,0,2,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,160,116,2,0,192,64,2,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,160,116,2,0,224,64,2,0,40,117,2,0,120,64,2,0,0,0,0,0,3,0,0,0,8,59,2,0,2,0,0,0,216,64,2,0,2,0,0,0,8,65,2,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,160,116,2,0,128,65,2,0,40,117,2,0,56,65,2,0,0,0,0,0,3,0,0,0,8,59,2,0,2,0,0,0,216,64,2,0,2,0,0,0,168,65,2,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,160,116,2,0,32,66,2,0,40,117,2,0,216,65,2,0,0,0,0,0,2,0,0,0,8,59,2,0,2,0,0,0,56,66,2,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,40,117,2,0,96,66,2,0,0,0,0,0,2,0,0,0,8,59,2,0,2,0,0,0,56,66,2,0,0,8,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,160,116,2,0,224,66,2,0,40,117,2,0,200,66,2,0,0,0,0,0,2,0,0,0,8,59,2,0,2,0,0,0,248,66,2,0,2,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,40,117,2,0,32,67,2,0,0,0,0,0,2,0,0,0,8,59,2,0,2,0,0,0,248,66,2,0,2,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,160,116,2,0,184,67,2,0,40,117,2,0,160,67,2,0,0,0,0,0,1,0,0,0,216,67,2,0,0,0,0,0,40,117,2,0,88,67,2,0,0,0,0,0,2,0,0,0,8,59,2,0,2,0,0,0,224,67,2,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,40,117,2,0,96,68,2,0,0,0,0,0,1,0,0,0,216,67,2,0,0,0,0,0,40,117,2,0,24,68,2,0,0,0,0,0,2,0,0,0,8,59,2,0,2,0,0,0,120,68,2,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,160,116,2,0,16,69,2,0,40,117,2,0,248,68,2,0,0,0,0,0,1,0,0,0,48,69,2,0,0,0,0,0,40,117,2,0,176,68,2,0,0,0,0,0,2,0,0,0,8,59,2,0,2,0,0,0,56,69,2,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,40,117,2,0,184,69,2,0,0,0,0,0,1,0,0,0,48,69,2,0,0,0,0,0,40,117,2,0,112,69,2,0,0,0,0,0,2,0,0,0,8,59,2,0,2,0,0,0,208,69,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,160,116,2,0,80,70,2,0,40,117,2,0,8,70,2,0,0,0,0,0,2,0,0,0,8,59,2,0,2,0,0,0,112,70,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,160,116,2,0,224,70,2,0,40,117,2,0,152,70,2,0,0,0,0,0,2,0,0,0,8,59,2,0,2,0,0,0,0,71,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,160,116,2,0,112,71,2,0,40,117,2,0,40,71,2,0,0,0,0,0,2,0,0,0,8,59,2,0,2,0,0,0,144,71,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,160,116,2,0,0,72,2,0,40,117,2,0,184,71,2,0,0,0,0,0,2,0,0,0,8,59,2,0,2,0,0,0,32,72,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+141476);
/* memory initializer */ allocate([74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,77,97,114,99,104,0,0,0,65,112,114,105,108,0,0,0,77,97,121,0,0,0,0,0,74,117,110,101,0,0,0,0,74,117,108,121,0,0,0,0,65,117,103,117,115,116,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,74,97,110,0,0,0,0,0,70,101,98,0,0,0,0,0,77,97,114,0,0,0,0,0,65,112,114,0,0,0,0,0,74,117,110,0,0,0,0,0,74,117,108,0,0,0,0,0,65,117,103,0,0,0,0,0,83,101,112,0,0,0,0,0,79,99,116,0,0,0,0,0,78,111,118,0,0,0,0,0,68,101,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,117,110,100,97,121,0,0,77,111,110,100,97,121,0,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,83,117,110,0,0,0,0,0,77,111,110,0,0,0,0,0,84,117,101,0,0,0,0,0,87,101,100,0,0,0,0,0,84,104,117,0,0,0,0,0,70,114,105,0,0,0,0,0,83,97,116,0,0,0,0,0,18,17,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,17,34,35,36,17,37,38,39,40,41,42,43,44,17,45,46,47,16,16,48,16,16,16,16,16,16,16,49,50,51,16,52,53,16,16,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,54,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,55,17,17,17,17,56,17,57,58,59,60,61,62,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,63,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,64,65,17,66,67,68,69,70,71,72,73,16,16,16,74,75,76,77,78,16,16,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,17,17,17,82,83,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,84,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,17,85,16,16,16,16,86,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,87,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,88,89,90,91,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,92,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,254,255,255,7,254,255,255,7,0,0,0,0,0,4,32,4,255,255,127,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,195,255,3,0,31,80,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,223,60,64,215,255,255,251,255,255,255,255,255,255,255,255,255,191,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,254,255,255,255,127,2,254,255,255,255,255,0,0,0,0,0,255,191,182,0,255,255,255,7,7,0,0,0,255,7,255,255,255,255,255,255,255,254,255,195,255,255,255,255,255,255,255,255,255,255,255,255,239,31,254,225,255,159,0,0,255,255,255,255,255,255,0,224,255,255,255,255,255,255,255,255,255,255,255,255,3,0,255,255,255,255,255,7,48,4,255,255,255,252,255,31,0,0,255,255,255,1,0,0,0,0,0,0,0,0,253,31,0,0,0,0,0,0,240,3,255,127,255,255,255,255,255,255,255,239,255,223,225,255,207,255,254,254,238,159,249,255,255,253,197,227,159,89,128,176,207,255,3,0,238,135,249,255,255,253,109,195,135,25,2,94,192,255,63,0,238,191,251,255,255,253,237,227,191,27,1,0,207,255,0,0,238,159,249,255,255,253,237,227,159,25,192,176,207,255,2,0,236,199,61,214,24,199,255,195,199,29,129,0,192,255,0,0,238,223,253,255,255,253,239,227,223,29,96,3,207,255,0,0,236,223,253,255,255,253,239,227,223,29,96,64,207,255,6,0,236,223,253,255,255,255,255,231,223,93,128,0,207,255,0,252,236,255,127,252,255,255,251,47,127,128,95,255,0,0,12,0,254,255,255,255,255,127,255,7,63,32,255,3,0,0,0,0,150,37,240,254,174,236,255,59,95,32,255,243,0,0,0,0,1,0,0,0,255,3,0,0,255,254,255,255,255,31,254,255,3,255,255,254,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,249,255,3,255,255,231,193,255,255,127,64,255,51,255,255,255,255,191,32,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,61,127,61,255,255,255,255,255,61,255,255,255,255,61,127,61,255,127,255,255,255,255,255,255,255,61,255,255,255,255,255,255,255,255,135,0,0,0,0,255,255,0,0,255,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,159,255,255,254,255,255,7,255,255,255,255,255,255,255,255,255,199,1,0,255,223,15,0,255,255,15,0,255,255,15,0,255,223,13,0,255,255,255,255,255,255,207,255,255,1,128,16,255,3,0,0,0,0,255,3,255,255,255,255,255,255,255,255,255,255,255,0,255,255,255,255,255,7,255,255,255,255,255,255,255,255,63,0,255,255,255,31,255,15,255,1,192,255,255,255,255,63,31,0,255,255,255,255,255,15,255,255,255,3,255,3,0,0,0,0,255,255,255,15,255,255,255,255,255,255,255,127,254,255,31,0,255,3,255,3,128,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,239,255,239,15,255,3,0,0,0,0,255,255,255,255,255,243,255,255,255,255,255,255,191,255,3,0,255,255,255,255,255,255,63,0,255,227,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,222,111,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,0,0,255,31,0,0,0,0,0,0,0,0,0,0,0,0,132,252,47,62,80,189,255,243,224,67,0,0,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,255,255,255,3,0,0,255,255,255,255,255,127,255,255,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,120,12,0,255,255,255,255,191,32,255,255,255,255,255,255,255,128,0,0,255,255,127,0,127,127,127,127,127,127,127,127,255,255,255,255,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,254,3,62,31,254,255,255,255,255,255,255,255,255,255,127,224,254,255,255,255,255,255,255,255,255,255,255,247,224,255,255,255,255,63,254,255,255,255,255,255,255,255,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,63,255,31,255,255,255,15,0,0,255,255,255,255,255,127,240,143,255,255,255,128,255,255,255,255,255,255,255,255,255,255,0,0,0,0,128,255,252,255,255,255,255,255,255,255,255,255,255,255,255,121,15,0,255,7,0,0,0,0,0,0,0,0,0,255,187,247,255,255,255,0,0,0,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,15,0,255,3,0,0,252,8,255,255,255,255,255,7,255,255,255,255,7,0,255,255,255,31,255,255,255,255,255,255,247,255,0,128,255,3,0,0,0,0,255,255,255,255,255,255,127,0,255,63,255,3,255,255,127,4,255,255,255,255,255,255,255,127,5,0,0,56,255,255,60,0,126,126,126,0,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,7,255,3,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,127,248,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,0,127,0,248,224,255,253,127,95,219,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,248,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,255,255,255,255,255,255,255,255,252,255,255,255,255,255,255,0,0,0,0,0,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,255,3,254,255,255,7,254,255,255,7,192,255,255,255,255,255,255,255,255,255,255,127,252,252,252,28,0,0,0,0,255,239,255,255,127,255,255,183,255,63,255,63,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,31,255,255,255,255,255,255,1,0,0,0,0,0,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,63,255,255,255,255,15,255,62,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,3,0,0,0,0,0,0,0,0,0,0,63,253,255,255,255,255,191,145,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,63,0,255,255,255,3,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,192,0,0,0,0,0,0,0,0,111,240,239,254,255,255,15,0,0,0,0,0,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,255,63,0,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,192,255,0,0,252,255,255,255,255,255,255,1,0,0,255,255,255,1,255,3,255,255,255,255,255,255,199,255,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,30,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,3,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,31,0,255,255,255,255,255,127,0,0,248,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,223,100,222,255,235,239,255,255,255,255,255,255,255,191,231,223,223,255,255,255,123,95,252,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,253,255,255,247,255,255,255,247,255,255,223,255,255,255,223,255,255,127,255,255,255,127,255,255,255,253,255,255,255,253,255,255,247,207,255,255,255,255,255,255,239,255,255,255,150,254,247,10,132,234,150,170,150,247,247,94,255,251,255,15,238,251,255,15,0,0,0,0,0,0,0,0,97,108,110,117,109,0,97,108,112,104,97,0,98,108,97,110,107,0,99,110,116,114,108,0,100,105,103,105,116,0,103,114,97,112,104,0,108,111,119,101,114,0,112,114,105,110,116,0,112,117,110,99,116,0,115,112,97,99,101,0,117,112,112,101,114,0,120,100,105,103,105,116,0,0,0,0,0,0,0,0,18,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,16,16,34,35,16,36,37,38,39,40,41,42,43,16,44,45,46,17,47,48,17,17,49,17,17,17,50,51,52,53,54,55,56,57,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,58,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,59,16,60,61,62,63,64,65,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,66,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,67,16,16,68,16,69,70,71,16,72,16,73,16,16,16,16,74,75,76,77,16,16,78,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,16,16,16,16,82,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,83,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,84,85,86,87,16,16,88,89,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,90,16,91,92,93,94,95,96,97,98,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,254,255,0,252,1,0,0,248,1,0,0,120,0,0,0,0,255,251,223,251,0,0,128,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,252,255,224,175,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,32,64,176,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,134,254,255,255,255,0,64,73,0,0,0,0,0,24,0,223,255,0,200,0,0,0,0,0,0,0,1,0,60,0,0,0,0,0,0,0,0,0,0,0,0,16,224,1,30,0,96,255,191,0,0,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,207,3,0,0,0,3,0,32,255,127,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,0,0,0,16,0,32,30,0,48,0,1,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,252,15,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,3,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,253,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,255,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,63,2,0,0,0,0,0,0,0,0,0,4,0,0,0,0,16,0,0,0,0,0,0,128,0,128,192,223,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,254,255,255,255,0,252,255,255,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,192,255,223,255,7,0,0,0,0,0,0,0,0,0,0,128,6,0,252,0,0,24,62,0,0,128,191,0,204,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,31,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,0,0,24,0,0,0,0,0,0,0,0,0,56,0,0,0,0,16,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,254,127,47,0,0,255,3,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,196,255,255,255,255,0,0,0,192,0,0,0,0,0,0,0,0,1,0,224,159,0,0,0,0,127,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,16,0,0,252,255,255,255,31,0,0,0,0,0,12,0,0,0,0,0,0,64,0,12,240,0,0,0,0,0,0,192,248,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,255,0,255,255,255,33,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,127,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,3,224,0,224,0,224,0,96,128,248,255,255,255,252,255,255,255,255,255,127,31,252,241,127,255,127,0,0,255,255,255,3,0,0,255,255,255,255,1,0,123,3,208,193,175,66,0,12,31,188,255,255,0,0,0,0,0,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,127,0,0,0,255,7,0,0,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,252,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,255,15,0,0,0,0,0,0,0,0,255,255,255,251,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,255,15,30,255,255,255,1,252,193,224,0,0,0,0,0,0,0,0,0,0,0,30,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,255,255,255,255,15,0,0,0,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,0,0,0,0,0,0,192,0,224,0,0,0,0,0,0,0,0,0,0,0,128,15,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,255,255,127,0,3,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,8,0,0,0,15,255,3,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,16,192,0,0,255,255,3,7,0,0,0,0,0,248,0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,8,0,255,63,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,128,11,0,0,0,0,0,0,0,128,2,0,0,192,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,255,255,255,3,127,0,255,255,255,255,247,255,127,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,254,255,0,252,1,0,0,248,1,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,0,48,135,255,255,255,255,255,143,255,0,0,0,0,0,0,224,255,255,7,255,15,0,0,0,0,0,0,255,255,255,255,255,63,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,143,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,255,0,255,1,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,63,252,255,63,0,0,0,3,0,0,0,0,0,0,254,3,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,7,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,255,255,255,255,127,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,127,0,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8,0,0,0,8,0,0,32,0,0,0,32,0,0,128,0,0,0,128,0,0,0,2,0,0,0,2,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,127,254,127,254,255,254,255,0,0,0,0,255,7,255,255,255,127,255,255,255,255,255,255,255,15,255,255,255,255,255,7,0,0,0,0,0,0,0,0,192,255,255,255,7,0,255,255,255,255,255,7,255,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,1,0,191,255,255,255,255,255,255,255,255,31,255,255,15,0,255,255,255,255,223,7,0,0,255,255,1,0,255,255,255,255,255,255,255,127,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,30,255,255,255,255,255,255,255,63,15,0,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,255,255,255,255,255,255,255,255,225,255,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,9,0,0,0,10,0,0,0,13,0,0,0,11,0,0,0,12,0,0,0,133,0,0,0,0,32,0,0,1,32,0,0,2,32,0,0,3,32,0,0,4,32,0,0,5,32,0,0,6,32,0,0,8,32,0,0,9,32,0,0,10,32,0,0,40,32,0,0,41,32,0,0,95,32,0,0,0,48,0,0,0,0,0,0,65,0,32,26,192,0,32,31,0,1,1,47,50,1,1,5,57,1,1,15,74,1,1,45,121,1,1,5,112,3,1,3,145,3,32,17,163,3,32,9,0,4,80,16,16,4,32,32,96,4,1,33,138,4,1,53,193,4,1,13,208,4,1,63,20,5,1,19,49,5,48,38,160,1,1,5,179,1,1,3,205,1,1,15,222,1,1,17,248,1,1,39,34,2,1,17,216,3,1,23,0,30,1,149,160,30,1,95,8,31,248,8,24,31,248,6,40,31,248,8,56,31,248,8,72,31,248,6,104,31,248,8,136,31,248,8,152,31,248,8,168,31,248,8,184,31,248,2,186,31,182,2,200,31,170,4,216,31,248,2,218,31,156,2,232,31,248,2,234,31,144,2,248,31,128,2,250,31,130,2,70,2,1,9,16,5,1,3,96,33,16,16,0,44,48,47,103,44,1,5,128,44,1,99,235,44,1,3,64,166,1,45,128,166,1,23,34,167,1,13,50,167,1,61,121,167,1,3,126,167,1,9,144,167,1,3,160,167,1,9,33,255,32,26,0,0,0,0,73,0,49,1,83,0,127,1,48,1,105,0,120,1,255,0,129,1,83,2,130,1,131,1,132,1,133,1,134,1,84,2,135,1,136,1,137,1,86,2,138,1,87,2,139,1,140,1,142,1,221,1,143,1,89,2,144,1,91,2,145,1,146,1,147,1,96,2,148,1,99,2,150,1,105,2,151,1,104,2,152,1,153,1,156,1,111,2,157,1,114,2,159,1,117,2,166,1,128,2,167,1,168,1,169,1,131,2,172,1,173,1,174,1,136,2,175,1,176,1,177,1,138,2,178,1,139,2,183,1,146,2,184,1,185,1,188,1,189,1,196,1,198,1,196,1,197,1,197,1,198,1,199,1,201,1,199,1,200,1,200,1,201,1,202,1,204,1,202,1,203,1,203,1,204,1,241,1,243,1,241,1,242,1,242,1,243,1,244,1,245,1,246,1,149,1,247,1,191,1,32,2,158,1,134,3,172,3,136,3,173,3,137,3,174,3,138,3,175,3,140,3,204,3,142,3,205,3,143,3,206,3,153,3,69,3,153,3,190,31,163,3,194,3,247,3,248,3,250,3,251,3,96,30,155,30,223,0,223,0,158,30,223,0,89,31,81,31,91,31,83,31,93,31,85,31,95,31,87,31,188,31,179,31,204,31,195,31,236,31,229,31,252,31,243,31,58,2,101,44,59,2,60,2,61,2,154,1,62,2,102,44,65,2,66,2,67,2,128,1,68,2,137,2,69,2,140,2,244,3,184,3,249,3,242,3,253,3,123,3,254,3,124,3,255,3,125,3,192,4,207,4,38,33,201,3,42,33,107,0,43,33,229,0,50,33,78,33,131,33,132,33,96,44,97,44,98,44,107,2,99,44,125,29,100,44,125,2,109,44,81,2,110,44,113,2,111,44,80,2,112,44,82,2,114,44,115,44,117,44,118,44,126,44,63,2,127,44,64,2,242,44,243,44,125,167,121,29,139,167,140,167,141,167,101,2,170,167,102,2,199,16,39,45,205,16,45,45,118,3,119,3,156,3,181,0,146,3,208,3,152,3,209,3,166,3,213,3,160,3,214,3,154,3,240,3,161,3,241,3,149,3,245,3,207,3,215,3,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,16,114,2,0,110,0,0,0,24,114,2,0,114,0,0,0,32,114,2,0,102,0,0,0,40,114,2,0,97,0,0,0,48,114,2,0,101,0,0,0,56,114,2,0,119,0,0,0,64,114,2,0,87,0,0,0,80,114,2,0,115,0,0,0,96,114,2,0,83,0,0,0,112,114,2,0,100,0,0,0,128,114,2,0,68,0,0,0,144,114,2,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,27,0,0,0,0,0,0,0,91,91,58,97,108,110,117,109,58,93,95,93,0,0,0,0,91,94,91,58,97,108,110,117,109,58,93,95,93,0,0,0,91,91,58,115,112,97,99,101,58,93,93,0,0,0,0,0,91,94,91,58,115,112,97,99,101,58,93,93,0,0,0,0,91,91,58,100,105,103,105,116,58,93,93,0,0,0,0,0,91,94,91,58,100,105,103,105,116,58,93,93,0,0,0,0,78,111,32,101,114,114,111,114,0,78,111,32,109,97,116,99,104,0,73,110,118,97,108,105,100,32,114,101,103,101,120,112,0,85,110,107,110,111,119,110,32,99,111,108,108,97,116,105,110,103,32,101,108,101,109,101,110,116,0,85,110,107,110,111,119,110,32,99,104,97,114,97,99,116,101,114,32,99,108,97,115,115,32,110,97,109,101,0,84,114,97,105,108,105,110,103,32,98,97,99,107,115,108,97,115,104,0,73,110,118,97,108,105,100,32,98,97,99,107,32,114,101,102,101,114,101,110,99,101,0,77,105,115,115,105,110,103,32,39,93,39,0,77,105,115,115,105,110,103,32,39,41,39,0,77,105,115,115,105,110,103,32,39,125,39,0,73,110,118,97,108,105,100,32,99,111,110,116,101,110,116,115,32,111,102,32,123,125,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,114,97,110,103,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,112,101,116,105,116,105,111,110,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,0,0,0,37,115,0,0,0,0,0,0,0,0,0,0,24,116,2,0,127,0,0,0,128,0,0,0,95,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,160,116,2,0,240,115,2,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,200,116,2,0,8,116,2,0,0,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,200,116,2,0,40,116,2,0,0,116,2,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,200,116,2,0,96,116,2,0,80,116,2,0,0,0,0,0,0,0,0,0,136,116,2,0,129,0,0,0,130,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,16,117,2,0,129,0,0,0,133,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,17,0,0,0,11,0,0,0,12,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,200,116,2,0,232,116,2,0,136,116,2,0,0,0,0,0,0,0,0,0,112,117,2,0,129,0,0,0,134,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,18,0,0,0,12,0,0,0,13,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,200,116,2,0,72,117,2,0,136,116,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,119,2,0,135,0,0,0,136,0,0,0,96,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,200,116,2,0,160,119,2,0,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+151816);




var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  function _llvm_lifetime_end() {}

  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function _pthread_mutex_lock() {}

  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
  
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
  
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
  
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }


  function _lis_solver_create() {
  Module['printErr']('missing function: lis_solver_create'); abort(-1);
  }

  var _emscripten_check_longjmp=true;

  
  function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }

  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var fd = _fileno(stream);
      var ret = _write(fd, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }

  
  var ___strtok_state=0;
  
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
  
  
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
  
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
  
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
  
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }

  function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  
  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    } 
  Module["_saveSetjmp"] = _saveSetjmp;

  
   
  Module["_strlen"] = _strlen;function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      var fd = _fileno(stream);
      return _write(fd, s, _strlen(s));
    }

  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};


  
  function _malloc(bytes) {
      /* Over-allocate to make sure it is byte-aligned by 8.
       * This will leak memory, but this is only the dummy
       * implementation (replaced by dlmalloc normally) so
       * not an issue.
       */
      var ptr = Runtime.dynamicAlloc(bytes + 8);
      return (ptr+8) & 0xFFFFFFF8;
    }
  Module["_malloc"] = _malloc;
  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

   
  Module["_bitshift64Ashr"] = _bitshift64Ashr;

  
  var PTHREAD_SPECIFIC={};function _pthread_setspecific(key, value) {
      if (!(key in PTHREAD_SPECIFIC)) {
        return ERRNO_CODES.EINVAL;
      }
      PTHREAD_SPECIFIC[key] = value;
      return 0;
    }

  function _GC_init() {
  Module['printErr']('missing function: GC_init'); abort(-1);
  }

  var _ceil=Math_ceil;

  function _GC_strdup() {
  Module['printErr']('missing function: GC_strdup'); abort(-1);
  }

  function _GC_malloc_atomic() {
  Module['printErr']('missing function: GC_malloc_atomic'); abort(-1);
  }

  
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }function _isxdigit_l(chr) {
      return _isxdigit(chr); // no locale support yet
    }

  
  function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }
  
  
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  
  function ___errno_location() {
      return ___errno_state;
    }function _perror(s) {
      // void perror(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/perror.html
      var stdout = HEAP32[((_stdout)>>2)];
      if (s) {
        _fputs(s, stdout);
        _fputc(58, stdout);
        _fputc(32, stdout);
      }
      var errnum = HEAP32[((___errno_location())>>2)];
      _puts(_strerror(errnum));
    }

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 
  Module["_memcpy"] = _memcpy;


  function _strstr(ptr1, ptr2) {
      var check = 0, start;
      do {
        if (!check) {
          start = ptr1;
          check = ptr2;
        }
        var curr1 = HEAP8[((ptr1++)|0)];
        var curr2 = HEAP8[((check++)|0)];
        if (curr2 == 0) return start;
        if (curr2 != curr1) {
          // rewind to one character after start, to find ez in eeez
          ptr1 = start + 1;
          check = 0;
        }
      } while (curr1);
      return 0;
    }

   
  Module["_memmove"] = _memmove;

  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }

  function _signal(sig, func) {
      // TODO
      return 0;
    }

  
  
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
  
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
  
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
                if (next === 0) return i > 0 ? fields : fields-1; // we failed to read the full length of this field
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
  
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
  
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
  
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
  
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
  
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
  
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
  
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16);
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text);
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text);
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j];
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }
  
  
  
  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }
  
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }function _fscanf(stream, format, varargs) {
      // int fscanf(FILE *restrict stream, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        return -1;
      }
      var buffer = [];
      function get() {
        var c = _fgetc(stream);
        buffer.push(c);
        return c;
      };
      function unget() {
        _ungetc(buffer.pop(), stream);
      };
      return __scanString(format, get, unget, varargs);
    }

  var _emscripten_preinvoke=true;

  function _pthread_cond_wait() {
      return 0;
    }

  
  
  
  var ___cxa_exception_header_size=8;
  
  function _free() {
  }
  Module["_free"] = _free;function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr - ___cxa_exception_header_size);
      } catch(e) { // XXX FIXME
      }
    }
  
  var ___cxa_last_thrown_exception=0;
  
  var ___cxa_caught_exceptions=[];function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Call destructor if one is registered then clear it.
      var ptr = ___cxa_caught_exceptions.pop();
      if (ptr) {
        header = ptr - ___cxa_exception_header_size;
        var destructor = HEAP32[(((header)+(4))>>2)];
        if (destructor) {
          Runtime.dynCall('vi', destructor, [ptr]);
          HEAP32[(((header)+(4))>>2)]=0;
        }
        ___cxa_free_exception(ptr);
        ___cxa_last_thrown_exception = 0;
      }
    }function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      var ptr = ___cxa_caught_exceptions.pop();
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }function _freopen(filename, mode, stream) {
      // FILE *freopen(const char *restrict filename, const char *restrict mode, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/freopen.html
      if (!filename) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (!streamObj) {
          ___setErrNo(ERRNO_CODES.EBADF);
          return 0;
        }
        if (_freopen.buffer) _free(_freopen.buffer);
        filename = intArrayFromString(streamObj.path);
        filename = allocate(filename, 'i8', ALLOC_NORMAL);
      }
      _fclose(stream);
      return _fopen(filename, mode);
    }

  function _round(x) {
      return (x < 0) ? -Math.round(-x) : Math.round(x);
    }

  
  function _emscripten_get_now() {
      if (!_emscripten_get_now.actual) {
        if (ENVIRONMENT_IS_NODE) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() {
            var t = process['hrtime']();
            return t[0] * 1e3 + t[1] / 1e6;
          }
        } else if (typeof dateNow !== 'undefined') {
          _emscripten_get_now.actual = dateNow;
        } else if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() { return window['performance']['now'](); };
        } else {
          _emscripten_get_now.actual = Date.now;
        }
      }
      return _emscripten_get_now.actual();
    }function _clock_gettime(clk_id, tp) {
      // int clock_gettime(clockid_t clk_id, struct timespec *tp);
      var now;
      if (clk_id === 0) {
        now = Date.now();
      } else {
        now = _emscripten_get_now();
      }
      HEAP32[((tp)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((tp)+(4))>>2)]=Math.floor((now % 1000)*1000*1000); // nanoseconds
      return 0;
    }

  
  function _tmpnam(s, dir, prefix) {
      // char *tmpnam(char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpnam.html
      // NOTE: The dir and prefix arguments are for internal use only.
      var folder = FS.findObject(dir || '/tmp');
      if (!folder || !folder.isFolder) {
        dir = '/tmp';
        folder = FS.findObject(dir);
        if (!folder || !folder.isFolder) return 0;
      }
      var name = prefix || 'file';
      do {
        name += String.fromCharCode(65 + Math.floor(Math.random() * 25));
      } while (name in folder.contents);
      var result = dir + '/' + name;
      if (!_tmpnam.buffer) _tmpnam.buffer = _malloc(256);
      if (!s) s = _tmpnam.buffer;
      writeAsciiToMemory(result, s);
      return s;
    }function _tmpfile() {
      // FILE *tmpfile(void);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpfile.html
      // TODO: Delete the created file on closing.
      if (_tmpfile.mode) {
        _tmpfile.mode = allocate(intArrayFromString('w+'), 'i8', ALLOC_NORMAL);
      }
      return _fopen(_tmpnam(0), _tmpfile.mode);
    }

  
  function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }

  
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = (HEAP32[((tempDoublePtr)>>2)]=HEAP32[(((varargs)+(argIndex))>>2)],HEAP32[(((tempDoublePtr)+(4))>>2)]=HEAP32[(((varargs)+((argIndex)+(4)))>>2)],(+(HEAPF64[(tempDoublePtr)>>3])));
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+4))>>2)]];
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Runtime.getNativeFieldSize(type);
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision < 0) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }


  function _pclose(stream) {
      // int pclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/pclose.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.ECHILD);
      return -1;
    }

   
  Module["_memset"] = _memset;

  var _BDtoILow=true;


   
  Module["_bitshift64Shl"] = _bitshift64Shl;

  var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  function ___assert_fail(condition, filename, line, func) {
      ABORT = true;
      throw 'Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'] + ' at ' + stackTrace();
    }

  
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }function _isdigit_l(chr) {
      return _isdigit(chr); // no locale support yet
    }

  var _emscripten_prep_setjmp=true;


  function _access(path, amode) {
      // int access(const char *path, int amode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/access.html
      path = Pointer_stringify(path);
      if (amode & ~7) {
        // need a valid mode
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      }
      var node;
      try {
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
      var perms = '';
      if (amode & 4) perms += 'r';
      if (amode & 2) perms += 'w';
      if (amode & 1) perms += 'x';
      if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      }
      return 0;
    }

  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }

  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }

  var _emscripten_get_longjmp_result=true;

  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i];
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }

  function _freelocale(locale) {
      _free(locale);
    }

  function _catgets(catd, set_id, msg_id, s) {
      // char *catgets (nl_catd catd, int set_id, int msg_id, const char *s)
      return s;
    }

  function _fmod(x, y) {
      return x % y;
    }

  function _fmax(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.max(x, y);
    }

  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }

  function _GC_malloc() {
  Module['printErr']('missing function: GC_malloc'); abort(-1);
  }

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function _lis_vector_destroy() {
  Module['printErr']('missing function: lis_vector_destroy'); abort(-1);
  }

  
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      ___cxa_caught_exceptions.push(___cxa_last_thrown_exception);
      return ptr;
    }

  function _lis_vector_create() {
  Module['printErr']('missing function: lis_vector_create'); abort(-1);
  }


  var _cos=Math_cos;

  var _fseeko=_fseek;



  function __ZNSt9exceptionD2Ev() {}

  function _lis_solver_destroy() {
  Module['printErr']('missing function: lis_solver_destroy'); abort(-1);
  }

  function _popen(command, mode) {
      // FILE *popen(const char *command, const char *mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/popen.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.EMFILE);
      return 0;
    }

  function _isblank(chr) {
      return chr == 32 || chr == 9;
    }

   
  Module["_strcpy"] = _strcpy;

  function _copysign(a, b) {
      return __reallyNegative(a) === __reallyNegative(b) ? a : -a;
    }

  function _bsearch(key, base, num, size, compar) {
      function cmp(x, y) {
        return Module['dynCall_iii'](compar, x, y);
      };
      var left = 0;
      var right = num;
      var mid, test, addr;
  
      while (left < right) {
        mid = (left + right) >>> 1;
        addr = base + (mid * size);
        test = cmp(key, addr);
        if (test < 0) {
          right = mid;
        } else if (test > 0) {
          left = mid + 1;
        } else {
          return addr;
        }
      }
  
      return 0;
    }

  
  var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key, destructor) {
      if (key == 0) {
        return ERRNO_CODES.EINVAL;
      }
      HEAP32[((key)>>2)]=PTHREAD_SPECIFIC_NEXT_KEY;
      // values start at 0
      PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
      PTHREAD_SPECIFIC_NEXT_KEY++;
      return 0;
    }


  
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  
  
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
  
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
  
      var pattern = Pointer_stringify(format);
  
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
  
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
  
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
  
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
  
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
  
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
  
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
  
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
  
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
  
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
  
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
  
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
  
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
  
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
  
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }

  
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;

  
   
  Module["_rand_r"] = _rand_r;
  
  var ___rand_seed=allocate([0x0273459b, 0, 0, 0], "i32", ALLOC_STATIC); 
  Module["_rand"] = _rand;

  var _llvm_memset_p0i8_i32=_memset;

   
  Module["_i64Subtract"] = _i64Subtract;

   
  Module["_i64Add"] = _i64Add;

  var _pow=Math_pow;

  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  
  function ___resumeException(ptr) {
      if (!___cxa_last_thrown_exception) { ___cxa_last_thrown_exception = ptr; }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = ___cxa_last_thrown_exception;
      header = thrown - ___cxa_exception_header_size;
      if (throwntype == -1) throwntype = HEAP32[((header)>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
  
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      var header = ptr - ___cxa_exception_header_size;
      HEAP32[((header)>>2)]=type;
      HEAP32[(((header)+(4))>>2)]=destructor;
      ___cxa_last_thrown_exception = ptr;
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }


  
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }

  function _htonl(value) {
      return ((value & 0xff) << 24) + ((value & 0xff00) << 8) +
             ((value & 0xff0000) >>> 8) + ((value & 0xff000000) >>> 24);
    }


   
  Module["_strncpy"] = _strncpy;

  function _strtoull_l(str, endptr, base) {
      return _strtoull(str, endptr, base); // no locale support yet
    }

  var _log=Math_log;

  var _emscripten_postinvoke=true;

  function _xerbla_() {
  Module['printErr']('missing function: xerbla_'); abort(-1);
  }

  var _copysignl=_copysign;

  
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }function _strtoll_l(str, endptr, base) {
      return _strtoll(str, endptr, base); // no locale support yet
    }

  function _qsort(base, num, size, cmp) {
      if (num == 0 || size == 0) return;
      // forward calls to the JavaScript sort method
      // first, sort the items logically
      var keys = [];
      for (var i = 0; i < num; i++) keys.push(i);
      keys.sort(function(a, b) {
        return Module['dynCall_iii'](cmp, base+a*size, base+b*size);
      });
      // apply the sort
      var temp = _malloc(num*size);
      _memcpy(temp, base, num*size);
      for (var i = 0; i < num; i++) {
        if (keys[i] == i) continue; // already in place
        _memcpy(base+i*size, temp+keys[i]*size, size);
      }
      _free(temp);
    }

  function _system(command) {
      // int system(const char *command);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/system.html
      // Can't call external programs.
      ___setErrNo(ERRNO_CODES.EAGAIN);
      return -1;
    }

  var _putc=_fputc;

  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }

   
  Module["_bitshift64Lshr"] = _bitshift64Lshr;

  function _srand(seed) {
      HEAP32[((___rand_seed)>>2)]=seed
    }

  function _isatty(fildes) {
      // int isatty(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/isatty.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      // HACK - implement tcgetattr
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return 0;
      }
      return 1;
    }

  var _BDtoIHigh=true;

  function _pthread_cond_broadcast() {
      return 0;
    }

  
  
   
  Module["_testSetjmp"] = _testSetjmp;function _longjmp(env, value) {
      asm['setThrew'](env, value || 1);
      throw 'longjmp';
    }function _emscripten_longjmp(env, value) {
      _longjmp(env, value);
    }

  function __ZSt9terminatev() {
      _exit(-1234);
    }

  function _lis_matrix_set_value() {
  Module['printErr']('missing function: lis_matrix_set_value'); abort(-1);
  }

  function _vfprintf(s, f, va_arg) {
      return _fprintf(s, f, HEAP32[((va_arg)>>2)]);
    }

  
  function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }var _atol=_atoi;

  function _pthread_mutex_unlock() {}

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }



  var _BItoD=true;

  
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000);
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000);
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000);
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fstat(fildes, buf) {
      // int fstat(int fildes, struct stat *buf);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/fstat.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      return _stat(stream.path, buf);
    }

  function _catclose(catd) {
      // int catclose (nl_catd catd)
      return 0;
    }

  function _llvm_lifetime_start() {}

  function ___cxa_guard_release() {}


  
  function _truncate(path, length) {
      // int truncate(const char *path, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/truncate.html
      // NOTE: The path argument may be a string, to simplify ftruncate().
      if (typeof path !== 'string') path = Pointer_stringify(path);
      try {
        FS.truncate(path, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _ftruncate(fildes, length) {
      // int ftruncate(int fildes, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftruncate.html
      try {
        FS.ftruncate(fildes, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  function _uselocale(locale) {
      return 0;
    }

  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }


  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }

  var _llvm_memmove_p0i8_p0i8_i32=_memmove;

  var _ftello=_ftell;

  function _strftime_l(s, maxsize, format, tm) {
      return _strftime(s, maxsize, format, tm); // no locale support yet
    }

  function _abort() {
      Module['abort']();
    }





  function _pthread_getspecific(key) {
      return PTHREAD_SPECIFIC[key] || 0;
    }

  var _fabs=Math_abs;

  function _GC_collect_a_little() {
  Module['printErr']('missing function: GC_collect_a_little'); abort(-1);
  }

  var _getc=_fgetc;

  var _sqrt=Math_sqrt;

  function _rewind(stream) {
      // void rewind(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rewind.html
      _fseek(stream, 0, 0);  // SEEK_SET.
      var streamObj = FS.getStreamFromPtr(stream);
      if (streamObj) streamObj.error = false;
    }

  function ___cxa_allocate_exception(size) {
      var ptr = _malloc(size + ___cxa_exception_header_size);
      return ptr + ___cxa_exception_header_size;
    }

  var _sin=Math_sin;

  var _fmodl=_fmod;



  function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }

  function _catopen(name, oflag) {
      // nl_catd catopen (const char *name, int oflag)
      return -1;
    }

  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_vector_set_size() {
  Module['printErr']('missing function: lis_vector_set_size'); abort(-1);
  }

  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = Pointer_stringify(path);
      try {
        FS.unlink(path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  var _emscripten_setjmp=true;

  var _floor=Math_floor;

  var _atan2=Math_atan2;


  function _lis_solver_set_option() {
  Module['printErr']('missing function: lis_solver_set_option'); abort(-1);
  }

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  var __ZTISt9exception=allocate([allocate([1,0,0,0,0,0,0], "i8", ALLOC_STATIC)+8, 0], "i32", ALLOC_STATIC);

  var ___dso_handle=allocate(1, "i32*", ALLOC_STATIC);



FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
___strtok_state = Runtime.staticAlloc(4);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vd(index,a1) {
  try {
    Module["dynCall_vd"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) {
  try {
    return Module["dynCall_iiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vidii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_vidii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viidii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_didd(index,a1,a2,a3) {
  try {
    return Module["dynCall_didd"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_dii(index,a1,a2) {
  try {
    return Module["dynCall_dii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.___rand_seed|0;var p=env.__ZTISt9exception|0;var q=env.___dso_handle|0;var r=env._stderr|0;var s=env._stdin|0;var t=env._stdout|0;var u=0;var v=0;var w=0;var x=0;var y=+env.NaN,z=+env.Infinity;var A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=global.Math.floor;var U=global.Math.abs;var V=global.Math.sqrt;var W=global.Math.pow;var X=global.Math.cos;var Y=global.Math.sin;var Z=global.Math.tan;var _=global.Math.acos;var $=global.Math.asin;var aa=global.Math.atan;var ba=global.Math.atan2;var ca=global.Math.exp;var da=global.Math.log;var ea=global.Math.ceil;var fa=global.Math.imul;var ga=env.abort;var ha=env.assert;var ia=env.asmPrintInt;var ja=env.asmPrintFloat;var ka=env.min;var la=env.invoke_iiiiiiii;var ma=env.invoke_viiiii;var na=env.invoke_iiiiidiii;var oa=env.invoke_vd;var pa=env.invoke_vi;var qa=env.invoke_vii;var ra=env.invoke_iiiiiiiiiii;var sa=env.invoke_ii;var ta=env.invoke_iiiiiiiiiiiiii;var ua=env.invoke_vidii;var va=env.invoke_iiii;var wa=env.invoke_iiiiiiiiiiiiiiiiiiiiiii;var xa=env.invoke_iiiiiiiiiiiiiiiiiiiii;var ya=env.invoke_viiiiid;var za=env.invoke_viiiiiiii;var Aa=env.invoke_iiiiiiiiiiiiiiiiiiiiiiiii;var Ba=env.invoke_viiiiii;var Ca=env.invoke_viidii;var Da=env.invoke_iid;var Ea=env.invoke_viiiiiii;var Fa=env.invoke_viiiiiid;var Ga=env.invoke_viiiiiiiii;var Ha=env.invoke_iii;var Ia=env.invoke_iiiiii;var Ja=env.invoke_iiiiidi;var Ka=env.invoke_didd;var La=env.invoke_dii;var Ma=env.invoke_i;var Na=env.invoke_iiiiiiiiii;var Oa=env.invoke_viii;var Pa=env.invoke_v;var Qa=env.invoke_iiiiiiiii;var Ra=env.invoke_iiiii;var Sa=env.invoke_viiii;var Ta=env._fabs;var Ua=env._strrchr;var Va=env._pthread_key_create;var Wa=env._vsscanf;var Xa=env.__ZSt9terminatev;var Ya=env.___cxa_guard_acquire;var Za=env.__reallyNegative;var _a=env._fstat;var $a=env._pclose;var ab=env._lis_solver_create;var bb=env.___assert_fail;var cb=env.__ZSt18uncaught_exceptionv;var db=env._longjmp;var eb=env.__isLeapYear;var fb=env._clock_gettime;var gb=env._fsync;var hb=env._signal;var ib=env._GC_collect_a_little;var jb=env._sbrk;var kb=env._strtoull;var lb=env._emscripten_memcpy_big;var mb=env.__parseInt64;var nb=env._close;var ob=env._rewind;var pb=env._cos;var qb=env._fileno;var rb=env._fread;var sb=env._puts;var tb=env._isatty;var ub=env._lis_matrix_set_value;var vb=env._write;var wb=env._isblank;var xb=env._ftell;var yb=env.__ZNSt9exceptionD2Ev;var zb=env._xerbla_;var Ab=env._round;var Bb=env.___cxa_does_inherit;var Cb=env._strtoll_l;var Db=env._strstr;var Eb=env.___cxa_rethrow;var Fb=env._llvm_lifetime_end;var Gb=env._catclose;var Hb=env._tmpnam;var Ib=env._lis_vector_destroy;var Jb=env._lis_solver_set_option;var Kb=env._tmpfile;var Lb=env._send;var Mb=env._pow;var Nb=env._atan2;var Ob=env.___cxa_is_number_type;var Pb=env.___cxa_free_exception;var Qb=env.___cxa_find_matching_catch;var Rb=env._isxdigit_l;var Sb=env.___cxa_guard_release;var Tb=env._truncate;var Ub=env._strtol;var Vb=env._sin;var Wb=env._strtok;var Xb=env.___setErrNo;var Yb=env._newlocale;var Zb=env._isdigit_l;var _b=env.___resumeException;var $b=env._freelocale;var ac=env._srand;var bc=env._fscanf;var cc=env._qsort;var dc=env._putchar;var ec=env._floor;var fc=env._pthread_mutex_unlock;var gc=env._printf;var hc=env._sprintf;var ic=env._fopen;var jc=env._vasprintf;var kc=env._emscripten_get_now;var lc=env._stat;var mc=env._vsnprintf;var nc=env._strtoull_l;var oc=env._read;var pc=env.__addDays;var qc=env._fwrite;var rc=env._time;var sc=env._pthread_mutex_lock;var tc=env._catopen;var uc=env._exit;var vc=env._GC_strdup;var wc=env._freopen;var xc=env.___ctype_b_loc;var yc=env._fmod;var zc=env._strtok_r;var Ac=env._lseek;var Bc=env._access;var Cc=env._vfprintf;var Dc=env.___cxa_allocate_exception;var Ec=env._atoi;var Fc=env._strtoll;var Gc=env._pwrite;var Hc=env._localtime_r;var Ic=env._tzset;var Jc=env._open;var Kc=env._uselocale;var Lc=env._snprintf;var Mc=env.___errno_location;var Nc=env._GC_malloc;var Oc=env.___cxa_end_catch;var Pc=env._perror;var Qc=env.___cxa_begin_catch;var Rc=env._strftime;var Sc=env._ftruncate;var Tc=env._GC_init;var Uc=env._fseek;var Vc=env._isxdigit;var Wc=env._fclose;var Xc=env.__parseInt;var Yc=env._log;var Zc=env._pthread_cond_broadcast;var _c=env._popen;var $c=env._recv;var ad=env._fgetc;var bd=env._sysconf;var cd=env.__getFloat;var dd=env._abort;var ed=env._ceil;var fd=env._isspace;var gd=env._localtime;var hd=env._pthread_getspecific;var id=env._pthread_cond_wait;var jd=env._llvm_lifetime_start;var kd=env._ungetc;var ld=env._system;var md=env._fmax;var nd=env._fflush;var od=env._strftime_l;var pd=env._fprintf;var qd=env._sscanf;var rd=env._catgets;var sd=env._strdup;var td=env._asprintf;var ud=env.__exit;var vd=env.___ctype_toupper_loc;var wd=env._bsearch;var xd=env.__arraySum;var yd=env.__formatString;var zd=env._htonl;var Ad=env.___ctype_tolower_loc;var Bd=env._unlink;var Cd=env._fputs;var Dd=env._GC_malloc_atomic;var Ed=env._pread;var Fd=env._lis_vector_set_size;var Gd=env._mkport;var Hd=env.__scanString;var Id=env._pthread_setspecific;var Jd=env._copysign;var Kd=env._fputc;var Ld=env.___cxa_throw;var Md=env._lis_solver_destroy;var Nd=env._isdigit;var Od=env._strerror;var Pd=env._emscripten_longjmp;var Qd=env._lis_vector_create;var Rd=env._atexit;var Sd=env._sqrt;var Td=env._strerror_r;var Ud=0.0;
// EMSCRIPTEN_START_FUNCS
function Ela(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]|0)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;a:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=ad(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break a}}i=e;return n|0}}while(0);b:do{if((a[b+53|0]|0)==0){l=b+40|0;m=b+36|0;o=f;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=ye[c[(c[t>>2]|0)+16>>2]&15](t,s,o,w,h,g,p,j)|0;if((x|0)==2){n=-1;y=22;break}else if((x|0)==3){y=14;break}else if((x|0)!=1){z=r;break b}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=22;break}v=ad(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=22;break}a[w]=v;r=r+1|0}if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==22){i=e;return n|0}}else{c[g>>2]=a[f]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b+ -1|0;if((kd(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=22;break}else{b=z}}if((y|0)==22){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function Fla(a){a=a|0;var b=0;b=i;c[a>>2]=142504;mta(a+4|0);i=b;return}function Gla(a){a=a|0;var b=0;b=i;c[a>>2]=142504;mta(a+4|0);Rwa(a);i=b;return}function Hla(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;ae[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=ota(d,145296)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(ae[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function Ila(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=qe[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((qc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((nd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function Jla(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((a[b+44|0]|0)!=0){h=qc(e|0,1,f|0,c[b+32>>2]|0)|0;i=g;return h|0}if((f|0)>0){j=e;k=0}else{h=0;i=g;return h|0}while(1){if((pe[c[(c[b>>2]|0)+52>>2]&63](b,d[j]|0)|0)==-1){h=k;l=6;break}e=k+1|0;if((e|0)<(f|0)){j=j+1|0;k=e}else{h=e;l=6;break}}if((l|0)==6){i=g;return h|0}return 0}function Kla(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){a[g]=d;if((a[b+44|0]|0)!=0){if((qc(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=ye[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((qc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((qc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function Lla(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=142504;j=b+4|0;kta(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=141856;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;lta(g,j);j=ota(g,145296)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=ae[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(ae[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){wsa(141696)}else{mta(g);i=f;return}}function Mla(a){a=a|0;var b=0;b=i;c[a>>2]=142504;mta(a+4|0);i=b;return}function Nla(a){a=a|0;var b=0;b=i;c[a>>2]=142504;mta(a+4|0);Rwa(a);i=b;return}function Ola(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=ota(d,145296)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=ae[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(ae[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){wsa(141696)}else{i=e;return}}function Pla(a){a=a|0;var b=0,c=0;b=i;c=Sla(a,0)|0;i=b;return c|0}function Qla(a){a=a|0;var b=0,c=0;b=i;c=Sla(a,1)|0;i=b;return c|0}function Rla(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f;q=ye[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((kd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function Sla(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]|0)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;a:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=ad(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break a}}i=f;return o|0}}while(0);b:do{if((a[b+53|0]|0)==0){m=b+40|0;n=b+36|0;p=g;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=ye[c[(c[u>>2]|0)+16>>2]&15](u,t,p,x,j,h,q,k)|0;if((y|0)==2){o=-1;z=23;break}else if((y|0)==3){z=14;break}else if((y|0)!=1){A=s;break b}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=23;break}w=ad(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=23;break}a[x]=w;s=s+1|0}if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==23){i=f;return o|0}}else{a[h]=a[g]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k+ -1|0;if((kd(d[g+j|0]|0,c[l>>2]|0)|0)==-1){o=-1;z=23;break}else{k=j}}if((z|0)==21){B=a[h]|0;break}else if((z|0)==23){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function Tla(){var a=0;a=i;pla(0);Rd(963,141120,q|0)|0;i=a;return}function Ula(a){a=a|0;i=i;return}function Vla(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=1+(c[b>>2]|0);i=i;return}function Wla(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=-1+e;if((e|0)!=0){f=0;i=b;return f|0}Zd[c[(c[a>>2]|0)+8>>2]&1023](a);f=1;i=b;return f|0}function Xla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=142e3;e=lxa(b|0)|0;f=Qwa(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;nxa(g|0,b|0,e+1|0)|0;i=d;return}function Yla(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=142e3;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;yb(h|0);j=a;Rwa(j);i=b;return}Swa((c[d>>2]|0)+ -12|0);g=a;h=g;yb(h|0);j=a;Rwa(j);i=b;return}function Zla(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=142e3;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;yb(h|0);i=b;return}Swa((c[d>>2]|0)+ -12|0);g=a;h=g;yb(h|0);i=b;return}function _la(a){a=a|0;i=i;return c[a+4>>2]|0}function $la(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;c[b>>2]=142024;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=lxa(f|0)|0;g=Qwa(d+13|0)|0;c[g+4>>2]=d;c[g>>2]=d;h=g+12|0;c[b+4>>2]=h;c[g+8>>2]=0;nxa(h|0,f|0,d+1|0)|0;i=e;return}function ama(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=142024;e=lxa(b|0)|0;f=Qwa(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;nxa(g|0,b|0,e+1|0)|0;i=d;return}function bma(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=142024;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;yb(h|0);j=a;Rwa(j);i=b;return}Swa((c[d>>2]|0)+ -12|0);g=a;h=g;yb(h|0);j=a;Rwa(j);i=b;return}function cma(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=142024;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;yb(h|0);i=b;return}Swa((c[d>>2]|0)+ -12|0);g=a;h=g;yb(h|0);i=b;return}function dma(a){a=a|0;i=i;return c[a+4>>2]|0}function ema(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=142e3;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;yb(h|0);j=a;Rwa(j);i=b;return}Swa((c[d>>2]|0)+ -12|0);g=a;h=g;yb(h|0);j=a;Rwa(j);i=b;return}function fma(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=142e3;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;yb(h|0);j=a;Rwa(j);i=b;return}Swa((c[d>>2]|0)+ -12|0);g=a;h=g;yb(h|0);j=a;Rwa(j);i=b;return}function gma(a){a=a|0;i=i;return}function hma(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;i=i;return}function ima(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;we[c[(c[a>>2]|0)+12>>2]&15](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function jma(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+4>>2]|0)!=(a|0)){f=0;i=e;return f|0}f=(c[b>>2]|0)==(d|0);i=e;return f|0}function kma(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=Od(e|0)|0;e=lxa(f|0)|0;if(e>>>0>4294967279){qma(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0;nxa(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}else{l=e+16&-16;m=Pwa(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=e;g=m;nxa(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}}function lma(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=d;j=c[h>>2]|0;k=e;do{if((j|0)!=0){l=a[e]|0;if((l&1)==0){m=(l&255)>>>1}else{m=c[e+4>>2]|0}if((m|0)==0){n=j}else{Xma(e,142240,2)|0;n=c[h>>2]|0}l=c[d+4>>2]|0;we[c[(c[l>>2]|0)+24>>2]&15](g,l,n);l=a[g]|0;if((l&1)==0){o=g+1|0;p=(l&255)>>>1}else{o=c[g+8>>2]|0;p=c[g+4>>2]|0}Xma(e,o,p)|0;if((a[g]&1)==0){break}Rwa(c[g+8>>2]|0)}}while(0);g=b;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;i=f;return}function mma(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=lxa(e|0)|0;if(j>>>0>4294967279){qma(0)}if(j>>>0<11){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=Pwa(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}nxa(k|0,e|0,j|0)|0;a[k+j|0]=0;lma(g,d,h);$la(b,g);if(!((a[g]&1)==0)){Rwa(c[g+8>>2]|0)}if(!((a[h]&1)==0)){Rwa(c[h+8>>2]|0)}c[b>>2]=142256;h=d;d=c[h+4>>2]|0;g=b+8|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;i=f;return}function nma(a){a=a|0;var b=0;b=i;cma(a);Rwa(a);i=b;return}function oma(a){a=a|0;var b=0;b=i;cma(a);i=b;return}function pma(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;sc(142392)|0;if((c[a>>2]|0)==1){do{id(142416,142392)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)==0){c[a>>2]=1;fc(142392)|0;Zd[d&1023](b);sc(142392)|0;c[a>>2]=-1;fc(142392)|0;Zc(142416)|0;i=e;return}else{fc(142392)|0;i=e;return}}function qma(a){a=a|0;a=Dc(8)|0;Xla(a,142464);c[a>>2]=142080;Ld(a|0,142120,40)}function rma(a){a=a|0;a=Dc(8)|0;Xla(a,142464);c[a>>2]=142144;Ld(a|0,142184,40)}function sma(a){a=a|0;var b=0,d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function tma(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function uma(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d;if((a[d]&1)==0){g=b;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];i=e;return}f=c[d+8>>2]|0;g=c[d+4>>2]|0;if(g>>>0>4294967279){qma(0)}if(g>>>0<11){a[b]=g<<1;h=b+1|0}else{d=g+16&-16;j=Pwa(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=g;h=j}nxa(h|0,f|0,g|0)|0;a[h+g|0]=0;i=e;return}function vma(b){b=b|0;i=i;return(a[b]&1)!=0|0}function wma(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>4294967279){qma(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0}else{h=e+16&-16;j=Pwa(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}nxa(g|0,d|0,e|0)|0;a[g+e|0]=0;i=f;return}function xma(a){a=a|0;i=i;return a|0}function yma(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=lxa(d|0)|0;if(f>>>0>4294967279){qma(0)}if(f>>>0<11){a[b]=f<<1;g=b+1|0;nxa(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}else{l=f+16&-16;m=Pwa(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=f;g=m;nxa(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}}function zma(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>4294967279){qma(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0}else{h=d+16&-16;j=Pwa(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}pxa(g|0,e|0,d|0)|0;a[g+d|0]=0;i=f;return}function Ama(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if(d>>>0>4294967279){qma(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0;pxa(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}else{l=d+16&-16;m=Pwa(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=d;g=m;pxa(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}}function Bma(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=a[d]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[d+4>>2]|0}if(k>>>0<e>>>0){rma(0)}if(j){l=d+1|0}else{l=c[d+8>>2]|0}d=l+e|0;l=k-e|0;e=l>>>0<f>>>0?l:f;if(e>>>0>4294967279){qma(0)}if(e>>>0<11){a[b]=e<<1;m=b+1|0;nxa(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}else{f=e+16&-16;l=Pwa(f)|0;c[b+8>>2]=l;c[b>>2]=f|1;c[b+4>>2]=e;m=l;nxa(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}}function Cma(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function Dma(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function Ema(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}Rwa(c[b+8>>2]|0);i=d;return}function Fma(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((b|0)==(d|0)){i=e;return b|0}f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=a[b]|0;if((d&1)==0){j=d;k=10}else{d=c[b>>2]|0;j=d&255;k=(d&-2)+ -1|0}d=(j&1)==0;if(k>>>0<h>>>0){if(d){l=(j&255)>>>1}else{l=c[b+4>>2]|0}Yma(b,k,h-k|0,l,0,l,h,g);i=e;return b|0}if(d){m=b+1|0}else{m=c[b+8>>2]|0}oxa(m|0,g|0,h|0)|0;a[m+h|0]=0;if((a[b]&1)==0){a[b]=h<<1;i=e;return b|0}else{c[b+4>>2]=h;i=e;return b|0}return 0}function Gma(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Hma(a,b)|0;i=c;return d|0}function Hma(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=lxa(d|0)|0;g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}g=(h&1)==0;if(j>>>0<f>>>0){if(g){k=(h&255)>>>1}else{k=c[b+4>>2]|0}Yma(b,j,f-j|0,k,0,k,f,d);i=e;return b|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}oxa(l|0,d|0,f|0)|0;a[l+f|0]=0;if((a[b]&1)==0){a[b]=f<<1;i=e;return b|0}else{c[b+4>>2]=f;i=e;return b|0}return 0}function Ima(a,b){a=a|0;b=b|0;c[a+4>>2]=b;i=i;return}function Jma(a){a=a|0;i=i;return a+1|0}function Kma(b,c){b=b|0;c=c|0;a[b]=c<<1;i=i;return}function Lma(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function Mma(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=10;i=d;return e|0}e=(c[b>>2]&-2)+ -1|0;i=d;return e|0}function Nma(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){Oma(b,d-j|0,e)|0;i=f;return}if(h){a[b+1+d|0]=0;a[b]=d<<1;i=f;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=f;return}}function Oma(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)==0){i=f;return b|0}g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}if((h&1)==0){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if((j-k|0)>>>0<d>>>0){Zma(b,j,d-j+k|0,k,k,0,0);l=a[b]|0}else{l=h}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}pxa(m+k|0,e|0,d|0)|0;e=k+d|0;if((a[b]&1)==0){a[b]=e<<1}else{c[b+4>>2]=e}a[m+e|0]=0;i=f;return b|0}function Pma(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}if(h>>>0<d>>>0){Oma(b,d-h|0,0)|0;i=e;return}if(g){a[b+1+d|0]=0;a[b]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=e;return}}function Qma(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>4294967279){qma(0)}f=a[b]|0;if((f&1)==0){g=f;h=10}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<11){k=10}else{k=(f+16&-16)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==10){l=b+1|0;m=0;n=c[b+8>>2]|0;o=1}else{f=k+1|0;if(k>>>0>h>>>0){p=Pwa(f)|0}else{p=Pwa(f)|0}if((g&1)==0){l=p;m=1;n=b+1|0;o=0;break}else{l=p;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}nxa(l|0,n|0,q+1|0)|0;if(o){Rwa(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function Rma(a){a=a|0;var b=0;if(a>>>0<11){b=10}else{b=(a+16&-16)+ -1|0}i=i;return b|0}function Sma(a,b){a=a|0;b=b|0;c[a>>2]=b|1;i=i;return}function Tma(a,b){a=a|0;b=b|0;c[a+8>>2]=b;i=i;return}function Uma(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){a[b+1|0]=0;a[b]=0;i=d;return}else{a[c[b+8>>2]|0]=0;c[b+4>>2]=0;i=d;return}}function Vma(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=Xma(b,g,h)|0;i=e;return d|0}function Wma(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=10;j=(f&255)>>>1}if((j|0)==(h|0)){Zma(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+1|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}a[l+j|0]=d;a[l+m|0]=0;i=e;return}function Xma(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}if((j&1)==0){k=(j&255)>>>1}else{k=c[b+4>>2]|0}if((h-k|0)>>>0<e>>>0){Yma(b,h,e-h+k|0,k,k,0,e,d);i=f;return b|0}if((e|0)==0){i=f;return b|0}if((j&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}nxa(l+k|0,d|0,e|0)|0;d=k+e|0;if((a[b]&1)==0){a[b]=d<<1}else{c[b+4>>2]=d}a[l+d|0]=0;i=f;return b|0}function Yma(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((-18-d|0)>>>0<e>>>0){qma(0)}if((a[b]&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}do{if(d>>>0<2147483623){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<11){q=11;break}q=p+16&-16}else{q=-17}}while(0);e=Pwa(q)|0;if((g|0)!=0){nxa(e|0,m|0,g|0)|0}if((j|0)!=0){nxa(e+g|0,k|0,j|0)|0}k=f-h|0;if((k|0)!=(g|0)){nxa(e+(j+g)|0,m+(h+g)|0,k-g|0)|0}if((d|0)!=10){Rwa(m)}c[b+8>>2]=e;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;a[e+q|0]=0;i=l;return}function Zma(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((-17-d|0)>>>0<e>>>0){qma(0)}if((a[b]&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}do{if(d>>>0<2147483623){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<11){p=11;break}p=o+16&-16}else{p=-17}}while(0);e=Pwa(p)|0;if((g|0)!=0){nxa(e|0,l|0,g|0)|0}o=f-h|0;if((o|0)!=(g|0)){nxa(e+(j+g)|0,l+(h+g)|0,o-g|0)|0}if((d|0)==10){q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}Rwa(l);q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function _ma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;Bma(a,b,c,d,0);i=e;return}function $ma(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function ana(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=lxa(d|0)|0;h=a[b]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if(k>>>0<e>>>0|(k-e|0)>>>0<g>>>0){l=-1;i=f;return l|0}if((g|0)==0){l=e;i=f;return l|0}if(j){m=b+1|0}else{m=c[b+8>>2]|0}b=m+e|0;j=m+k|0;h=d+g|0;if((j-b|0)<(g|0)){l=-1;i=f;return l|0}n=k+(1-g)|0;g=m+n|0;if((n|0)==(e|0)){l=-1;i=f;return l|0}e=a[d]|0;n=b;a:while(1){if((a[n]|0)==e<<24>>24){b=n;k=d;do{k=k+1|0;if((k|0)==(h|0)){break a}b=b+1|0;}while((a[b]|0)==(a[k]|0))}k=n+1|0;if((k|0)==(g|0)){l=-1;o=18;break}else{n=k}}if((o|0)==18){i=f;return l|0}if((n|0)==(j|0)){l=-1;i=f;return l|0}l=n-m|0;i=f;return l|0}function bna(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}f=a[d]|0;j=(f&1)==0;if(j){k=(f&255)>>>1}else{k=c[d+4>>2]|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}if(j){m=d+1|0}else{m=c[d+8>>2]|0}d=k>>>0<h>>>0;j=gxa(l,m,d?k:h)|0;if((j|0)==0){i=e;return(h>>>0<k>>>0?-1:d&1)|0}else{i=e;return j|0}return 0}function cna(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=lxa(d|0)|0;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if((f|0)==-1){rma(0)}if(h){k=b+1|0}else{k=c[b+8>>2]|0}b=j>>>0>f>>>0;h=gxa(k,d,b?f:j)|0;if((h|0)==0){i=e;return(j>>>0<f>>>0?-1:b&1)|0}else{i=e;return h|0}return 0}function dna(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(f>>>0>4294967279){qma(0)}if(f>>>0<11){a[b]=e<<1;h=b+1|0;nxa(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}else{m=f+16&-16;f=Pwa(m)|0;c[b+8>>2]=f;c[b>>2]=m|1;c[b+4>>2]=e;h=f;nxa(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}}function ena(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>1073741807){qma(0)}if(e>>>0<2){a[b]=e<<1;g=b+4|0}else{h=e+4&-4;j=Pwa(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}kwa(g,d,e)|0;c[g+(e<<2)>>2]=0;i=f;return}function fna(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>1073741807){qma(0)}if(d>>>0<2){a[b]=d<<1;g=b+4|0}else{h=d+4&-4;j=Pwa(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}mwa(g,e,d)|0;c[g+(d<<2)>>2]=0;i=f;return}function gna(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}Rwa(c[b+8>>2]|0);i=d;return}function hna(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ina(a,b,jwa(b)|0)|0;i=c;return d|0}function ina(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=1;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g){k=(j&255)>>>1}else{k=c[b+4>>2]|0}lna(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g){l=b+4|0}else{l=c[b+8>>2]|0}lwa(l,d,e)|0;c[l+(e<<2)>>2]=0;if((a[b]&1)==0){a[b]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function jna(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>1073741807){qma(0)}f=a[b]|0;if((f&1)==0){g=f;h=1}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<2){k=1}else{k=(f+4&-4)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==1){l=b+4|0;m=0;n=c[b+8>>2]|0;o=1}else{f=(k<<2)+4|0;if(k>>>0>h>>>0){p=Pwa(f)|0}else{p=Pwa(f)|0}f=p;if((g&1)==0){l=f;m=1;n=b+4|0;o=0;break}else{l=f;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}kwa(l,n,q+1|0)|0;if(o){Rwa(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function kna(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=1;j=(f&255)>>>1}if((j|0)==(h|0)){mna(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+4|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}c[l+(j<<2)>>2]=d;c[l+(m<<2)>>2]=0;i=e;return}function lna(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((1073741806-d|0)>>>0<e>>>0){qma(0)}if((a[b]&1)==0){m=b+4|0}else{m=c[b+8>>2]|0}do{if(d>>>0<536870887){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<2){q=2;break}q=p+4&-4}else{q=1073741807}}while(0);e=Pwa(q<<2)|0;p=e;if((g|0)!=0){kwa(p,m,g)|0}if((j|0)!=0){kwa(e+(g<<2)|0,k,j)|0}k=f-h|0;if((k|0)!=(g|0)){kwa(e+(j+g<<2)|0,m+(h+g<<2)|0,k-g|0)|0}if((d|0)!=1){Rwa(m)}c[b+8>>2]=p;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;c[e+(q<<2)>>2]=0;i=l;return}function mna(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((1073741807-d|0)>>>0<e>>>0){qma(0)}if((a[b]&1)==0){l=b+4|0}else{l=c[b+8>>2]|0}do{if(d>>>0<536870887){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<2){p=2;break}p=o+4&-4}else{p=1073741807}}while(0);e=Pwa(p<<2)|0;o=e;if((g|0)!=0){kwa(o,l,g)|0}m=f-h|0;if((m|0)!=(g|0)){kwa(e+(j+g<<2)|0,l+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}Rwa(l);q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function nna(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;g=lxa(d|0)|0;h=a[e]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[e+4>>2]|0}h=j+g|0;if(h>>>0>4294967279){qma(0)}if(h>>>0<11){a[b]=g<<1;k=b+1|0}else{l=h+16&-16;h=Pwa(l)|0;c[b+8>>2]=h;c[b>>2]=l|1;c[b+4>>2]=g;k=h}nxa(k|0,d|0,g|0)|0;a[k+g|0]=0;if((a[e]&1)==0){m=e+1|0;n=Xma(b,m,j)|0;i=f;return}else{m=c[e+8>>2]|0;n=Xma(b,m,j)|0;i=f;return}}function ona(a){a=a|0;i=i;return(c[a+16>>2]&5|0)==0|0}function pna(a){a=a|0;i=i;return(c[a+16>>2]&5|0)!=0|0}function qna(a,b){a=a|0;b=b|0;var c=0;c=i;rna(a,b);i=c;return}function rna(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(c[b+24>>2]|0)==0;if(h){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((h&1|d)&c[b+20>>2]|0)==0){i=e;return}e=Dc(16)|0;do{if((a[142848]|0)==0){if((Ya(142848)|0)==0){break}c[35710]=143544;Rd(66,142840,q|0)|0;Sb(142848)}}while(0);b=e;d=g;c[d>>2]=1;c[d+4>>2]=142840;d=f;h=g;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];mma(b,f,142896);c[e>>2]=142864;Ld(e|0,142944,62)}function sna(a,b){a=a|0;b=b|0;var d=0;d=i;rna(a,c[a+16>>2]|b);i=d;return}function tna(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=142888;d=c[a+40>>2]|0;e=a+32|0;f=a+36|0;if((d|0)!=0){g=d;do{g=g+ -1|0;we[c[(c[e>>2]|0)+(g<<2)>>2]&15](0,a,c[(c[f>>2]|0)+(g<<2)>>2]|0);}while((g|0)!=0)}mta(a+28|0);Kwa(c[e>>2]|0);Kwa(c[f>>2]|0);Kwa(c[a+48>>2]|0);Kwa(c[a+60>>2]|0);i=b;return}function una(a){a=a|0;var b=0;b=i;tna(a);Rwa(a);i=b;return}function vna(a){a=a|0;var b=0;b=i;tna(a);i=b;return}function wna(a){a=a|0;var b=0;b=i;tna(a);i=b;return}function xna(a){a=a|0;i=i;return c[a+24>>2]|0}function yna(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+76|0;f=c[e>>2]|0;if(!((f|0)==-1)){g=f&255;i=b;return g|0}lta(d,a+28|0);a=ota(d,145232)|0;f=pe[c[(c[a>>2]|0)+28>>2]&63](a,32)|0;mta(d);c[e>>2]=f<<24>>24;g=f;i=b;return g|0}function zna(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;lta(e,a+28|0);a=ota(e,145232)|0;f=pe[c[(c[a>>2]|0)+28>>2]&63](a,b)|0;mta(e);i=d;return f|0}function Ana(a,b){a=a|0;b=b|0;var c=0;c=i;lta(a,b+28|0);i=c;return}function Bna(a){a=a|0;c[a>>2]=142488;i=i;return}function Cna(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;e=a+32|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));kta(b);i=d;return}function Dna(a){a=a|0;var b=0;b=i;c[a>>2]=142504;mta(a+4|0);Rwa(a);i=b;return}function Ena(a){a=a|0;var b=0;b=i;c[a>>2]=142504;mta(a+4|0);i=b;return}function Fna(a){a=a|0;var b=0;b=i;c[a>>2]=142504;mta(a+4|0);i=b;return}function Gna(a,b){a=a|0;b=b|0;var c=0;c=i;lta(a,b+4|0);i=c;return}function Hna(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;e=a+12|0;f=c[e>>2]|0;if((f|0)==(c[a+16>>2]|0)){g=ae[c[(c[a>>2]|0)+40>>2]&127](a)|0;i=b;return g|0}else{c[e>>2]=f+1;g=d[f]|0;i=b;return g|0}return 0}function Ina(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==(c[b+28>>2]|0)){h=pe[c[(c[b>>2]|0)+52>>2]&63](b,d&255)|0;i=e;return h|0}else{c[f>>2]=g+1;a[g]=d;h=d&255;i=e;return h|0}return 0}function Jna(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=de[c[(c[a>>2]|0)+48>>2]&63](a,b,d)|0;i=e;return f|0}function Kna(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=142504;kta(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function Lna(a){a=a|0;i=i;return c[a+8>>2]|0}function Mna(a){a=a|0;i=i;return c[a+12>>2]|0}function Nna(a){a=a|0;i=i;return c[a+16>>2]|0}function Ona(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function Pna(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;i=i;return}function Qna(a){a=a|0;i=i;return c[a+20>>2]|0}function Rna(a){a=a|0;i=i;return c[a+24>>2]|0}function Sna(a){a=a|0;i=i;return c[a+28>>2]|0}function Tna(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function Una(a,b,d){a=a|0;b=b|0;d=d|0;c[a+24>>2]=b;c[a+20>>2]=b;c[a+28>>2]=d;i=i;return}function Vna(a,b){a=a|0;b=b|0;i=i;return}function Wna(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function Xna(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function Yna(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function Zna(a){a=a|0;i=i;return 0}function _na(a){a=a|0;i=i;return 0}function $na(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((e|0)<=0){g=0;i=f;return g|0}h=b+12|0;j=b+16|0;k=d;d=0;while(1){l=c[h>>2]|0;if(l>>>0<(c[j>>2]|0)>>>0){c[h>>2]=l+1;m=a[l]|0}else{l=ae[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((l|0)==-1){g=d;n=8;break}m=l&255}a[k]=m;l=d+1|0;if((l|0)<(e|0)){k=k+1|0;d=l}else{g=l;n=8;break}}if((n|0)==8){i=f;return g|0}return 0}function aoa(a){a=a|0;i=i;return-1}function boa(a){a=a|0;var b=0,e=0,f=0;b=i;if((ae[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){e=-1;i=b;return e|0}f=a+12|0;a=c[f>>2]|0;c[f>>2]=a+1;e=d[a]|0;i=b;return e|0}function coa(a,b){a=a|0;b=b|0;i=i;return-1}function doa(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((f|0)<=0){h=0;i=g;return h|0}j=b+24|0;k=b+28|0;l=e;e=0;while(1){m=c[j>>2]|0;if(m>>>0<(c[k>>2]|0)>>>0){n=a[l]|0;c[j>>2]=m+1;a[m]=n}else{if((pe[c[(c[b>>2]|0)+52>>2]&63](b,d[l]|0)|0)==-1){h=e;o=7;break}}n=e+1|0;if((n|0)<(f|0)){l=l+1|0;e=n}else{h=n;o=7;break}}if((o|0)==7){i=g;return h|0}return 0}function eoa(a,b){a=a|0;b=b|0;i=i;return-1}function foa(a){a=a|0;var b=0;b=i;c[a>>2]=142568;mta(a+4|0);Rwa(a);i=b;return}function goa(a){a=a|0;var b=0;b=i;c[a>>2]=142568;mta(a+4|0);i=b;return}function hoa(a,b){a=a|0;b=b|0;i=i;return}function ioa(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function joa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function koa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function loa(a){a=a|0;i=i;return 0}function moa(a){a=a|0;i=i;return 0}function noa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+12|0;h=a+16|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[g>>2]=k+4;l=c[k>>2]|0}else{k=ae[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((k|0)==-1){f=b;m=8;break}else{l=k}}c[j>>2]=l;k=b+1|0;if((k|0)>=(d|0)){f=k;m=8;break}j=j+4|0;b=k}if((m|0)==8){i=e;return f|0}return 0}function ooa(a){a=a|0;i=i;return-1}function poa(a){a=a|0;var b=0,d=0,e=0;b=i;if((ae[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){d=-1;i=b;return d|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+4;d=c[a>>2]|0;i=b;return d|0}function qoa(a,b){a=a|0;b=b|0;i=i;return-1}function roa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;h=a+28|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){l=c[j>>2]|0;c[g>>2]=k+4;c[k>>2]=l}else{if((pe[c[(c[a>>2]|0)+52>>2]&63](a,c[j>>2]|0)|0)==-1){f=b;m=8;break}}l=b+1|0;if((l|0)>=(d|0)){f=l;m=8;break}j=j+4|0;b=l}if((m|0)==8){i=e;return f|0}return 0}function soa(a,b){a=a|0;b=b|0;i=i;return-1}function toa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];c[a+4>>2]=0;b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));kta(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function uoa(a){a=a|0;var b=0;b=i;tna(a+8|0);Rwa(a);i=b;return}function voa(a){a=a|0;var b=0;b=i;tna(a+8|0);i=b;return}function woa(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;tna(a+(d+8)|0);Rwa(a+d|0);i=b;return}function xoa(a){a=a|0;var b=0;b=i;tna(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function yoa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;zoa(a,b,c);i=d;return}function zoa(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;h=g;j=d;a[j]=0;d=c[(c[e>>2]|0)+ -12>>2]|0;k=c[e+(d+16)>>2]|0;if((k|0)!=0){rna(e+d|0,k|4);i=g;return}k=c[e+(d+72)>>2]|0;if((k|0)!=0){Aoa(k)|0}a:do{if(!f){k=c[(c[e>>2]|0)+ -12>>2]|0;if((c[e+(k+4)>>2]&4096|0)==0){break}lta(h,e+(k+28)|0);k=ota(h,145232)|0;mta(h);d=k+8|0;k=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;while(1){if((k|0)==0){break}if((c[k+12>>2]|0)==(c[k+16>>2]|0)){l=(ae[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;m=l?0:k;if((m|0)==0){break}else{n=m}}else{n=k}m=n+12|0;l=c[m>>2]|0;o=n+16|0;if((l|0)==(c[o>>2]|0)){p=(ae[c[(c[n>>2]|0)+36>>2]&127](n)|0)&255}else{p=a[l]|0}if(!(p<<24>>24>-1)){q=18;break}if((b[(c[d>>2]|0)+(p<<24>>24<<1)>>1]&8192)==0){q=18;break}l=c[m>>2]|0;if((l|0)==(c[o>>2]|0)){ae[c[(c[n>>2]|0)+40>>2]&127](n)|0;k=n;continue}else{c[m>>2]=l+1;k=n;continue}}do{if((q|0)==18){if((n|0)==0){break}if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){break a}if(!((ae[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1|(n|0)==0)){break a}}}while(0);k=c[(c[e>>2]|0)+ -12>>2]|0;rna(e+k|0,c[e+(k+16)>>2]|6)}}while(0);a[j]=(c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+16)>>2]|0)==0|0;i=g;return}function Aoa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{Aoa(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((ae[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;rna(b+h|0,c[b+(h+16)>>2]|1)}}while(0);Poa(e);i=d;return b|0}function Boa(b){b=b|0;i=i;return(a[b]|0)!=0|0}function Coa(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){i=i;return}else{Eb()}}function Doa(a){a=a|0;var b=0;b=i;tna(a+8|0);Rwa(a);i=b;return}function Eoa(a){a=a|0;var b=0;b=i;tna(a+8|0);i=b;return}function Foa(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;tna(a+(d+8)|0);Rwa(a+d|0);i=b;return}function Goa(a){a=a|0;var b=0;b=i;tna(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function Hoa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{Hoa(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((ae[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;rna(b+h|0,c[b+(h+16)>>2]|1)}}while(0);$oa(e);i=d;return b|0}function Ioa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));kta(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function Joa(a){a=a|0;var b=0;b=i;tna(a+4|0);Rwa(a);i=b;return}function Koa(a){a=a|0;var b=0;b=i;tna(a+4|0);i=b;return}function Loa(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;tna(a+(d+4)|0);Rwa(a+d|0);i=b;return}function Moa(a){a=a|0;var b=0;b=i;tna(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function Noa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b;a[f]=0;c[b+4>>2]=d;b=c[(c[d>>2]|0)+ -12>>2]|0;if((c[d+(b+16)>>2]|0)!=0){i=e;return}g=c[d+(b+72)>>2]|0;if((g|0)!=0){Aoa(g)|0}a[f]=1;i=e;return}function Ooa(a){a=a|0;var b=0;b=i;Poa(a);i=b;return}function Poa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(cb()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((ae[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;rna(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function Qoa(b){b=b|0;i=i;return(a[b]|0)!=0|0}function Roa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ae[b&127](a)|0;i=c;return d|0}function Soa(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=j;a[m]=0;c[j+4>>2]=b;n=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(n+16)>>2]|0)!=0){Poa(j);i=e;return b|0}o=c[b+(n+72)>>2]|0;if((o|0)==0){p=n}else{Aoa(o)|0;p=c[(c[b>>2]|0)+ -12>>2]|0}a[m]=1;lta(k,b+(p+28)|0);p=ota(k,143952)|0;m=p;mta(k);k=c[(c[b>>2]|0)+ -12>>2]|0;o=c[b+(k+24)>>2]|0;n=b+(k+76)|0;q=c[n>>2]|0;if((q|0)==-1){lta(h,b+(k+28)|0);r=ota(h,145232)|0;s=pe[c[(c[r>>2]|0)+28>>2]&63](r,32)|0;mta(h);c[n>>2]=s<<24>>24;t=s}else{t=q&255}q=b+k|0;k=c[(c[p>>2]|0)+32>>2]|0;c[g>>2]=o;o=f;p=g;c[o+0>>2]=c[p+0>>2];ge[k&7](l,m,f,q,t,d);if((c[l>>2]|0)!=0){Poa(j);i=e;return b|0}l=c[(c[b>>2]|0)+ -12>>2]|0;rna(b+l|0,c[b+(l+16)>>2]|5);Poa(j);i=e;return b|0}function Toa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=f;a[g]=0;c[f+4>>2]=b;h=c[b>>2]|0;j=c[h+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){Poa(f);i=e;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)==0){l=h;m=j}else{Aoa(k)|0;k=c[b>>2]|0;l=k;m=c[k+ -12>>2]|0}a[g]=1;g=c[b+(m+24)>>2]|0;m=g;do{if((g|0)==0){n=l}else{k=g+24|0;j=c[k>>2]|0;if((j|0)!=(c[g+28>>2]|0)){c[k>>2]=j+1;a[j]=d;Poa(f);i=e;return b|0}if((pe[c[(c[g>>2]|0)+52>>2]&63](m,d&255)|0)==-1){n=c[b>>2]|0;break}else{Poa(f);i=e;return b|0}}}while(0);d=c[n+ -12>>2]|0;rna(b+d|0,c[b+(d+16)>>2]|1);Poa(f);i=e;return b|0}function Uoa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=g;a[h]=0;c[g+4>>2]=b;j=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){Poa(g);i=f;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)!=0){Aoa(k)|0}a[h]=1;if((e|0)==0){Poa(g);i=f;return b|0}h=c[b+((c[(c[b>>2]|0)+ -12>>2]|0)+24)>>2]|0;if((de[c[(c[h>>2]|0)+48>>2]&63](h,d,e)|0)==(e|0)){Poa(g);i=f;return b|0}e=c[(c[b>>2]|0)+ -12>>2]|0;rna(b+e|0,c[b+(e+16)>>2]|1);Poa(g);i=f;return b|0}function Voa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(e+16)>>2]&5|0)==0){f=c[b+(e+24)>>2]|0;je[c[(c[f>>2]|0)+16>>2]&31](a,f,0,0,1,16);i=d;return}else{f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;i=d;return}}function Woa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=e;g=e+16|0;h=e+32|0;j=e+40|0;k=h;a[k]=0;c[h+4>>2]=b;l=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(l+16)>>2]|0)!=0){Poa(h);i=e;return b|0}m=c[b+(l+72)>>2]|0;if((m|0)==0){n=l}else{Aoa(m)|0;n=c[(c[b>>2]|0)+ -12>>2]|0}a[k]=1;k=c[b+(n+24)>>2]|0;n=k;m=d;d=g;l=c[(c[k>>2]|0)+20>>2]|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];m=f;d=g;c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];Ae[l&63](j,n,f,16);f=j+8|0;if(!((c[f>>2]|0)==-1&(c[f+4>>2]|0)==-1)){Poa(h);i=e;return b|0}f=c[(c[b>>2]|0)+ -12>>2]|0;rna(b+f|0,c[b+(f+16)>>2]|4);Poa(h);i=e;return b|0}function Xoa(a){a=a|0;var b=0;b=i;tna(a+4|0);Rwa(a);i=b;return}function Yoa(a){a=a|0;var b=0;b=i;tna(a+4|0);i=b;return}function Zoa(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;tna(a+(d+4)|0);Rwa(a+d|0);i=b;return}function _oa(a){a=a|0;var b=0;b=i;tna(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function $oa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(cb()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((ae[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;rna(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function apa(a){a=a|0;i=i;return 142784}function bpa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((c|0)==1){wma(a,142800,35);i=d;return}else{kma(a,b,c);i=d;return}}function cpa(a){a=a|0;i=i;return}function dpa(a){a=a|0;var b=0;b=i;oma(a);Rwa(a);i=b;return}function epa(a){a=a|0;var b=0;b=i;oma(a);i=b;return}function fpa(a){a=a|0;var b=0;b=i;tna(a);Rwa(a);i=b;return}function gpa(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function hpa(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function ipa(a){a=a|0;i=i;return}function jpa(a){a=a|0;i=i;return}function kpa(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;a:do{if((e|0)==(f|0)){g=c;h=6}else{j=e;k=c;while(1){if((k|0)==(d|0)){l=-1;break a}m=a[k]|0;n=a[j]|0;if(m<<24>>24<n<<24>>24){l=-1;break a}if(n<<24>>24<m<<24>>24){l=1;break a}m=k+1|0;n=j+1|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=b;return l|0}function lpa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;g=e;h=f-g|0;if(h>>>0>4294967279){qma(b)}if(h>>>0<11){a[b]=h<<1;j=b+1|0}else{k=h+16&-16;l=Pwa(k)|0;c[b+8>>2]=l;c[b>>2]=k|1;c[b+4>>2]=h;j=l}if((e|0)==(f|0)){m=j;a[m]=0;i=d;return}else{n=e;o=j}while(1){a[o]=a[n]|0;e=n+1|0;if((e|0)==(f|0)){break}else{o=o+1|0;n=e}}m=j+(f+(0-g))|0;a[m]=0;i=d;return}function mpa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)==(d|0)){e=0;i=b;return e|0}else{f=0;g=c}while(1){c=(a[g]|0)+(f<<4)|0;h=c&-268435456;j=(h>>>24|h)^c;c=g+1|0;if((c|0)==(d|0)){e=j;break}else{g=c;f=j}}i=b;return e|0}function npa(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function opa(a){a=a|0;i=i;return}function ppa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;a:do{if((e|0)==(f|0)){g=b;h=6}else{j=e;k=b;while(1){if((k|0)==(d|0)){l=-1;break a}m=c[k>>2]|0;n=c[j>>2]|0;if((m|0)<(n|0)){l=-1;break a}if((n|0)<(m|0)){l=1;break a}m=k+4|0;n=j+4|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=a;return l|0}function qpa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;g=e;h=f-g|0;j=h>>2;if(j>>>0>1073741807){qma(b)}if(j>>>0<2){a[b]=h>>>1;k=b+4|0}else{h=j+4&-4;l=Pwa(h<<2)|0;c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;k=l}if((e|0)==(f|0)){m=k;c[m>>2]=0;i=d;return}l=f+ -4+(0-g)|0;g=e;e=k;while(1){c[e>>2]=c[g>>2];j=g+4|0;if((j|0)==(f|0)){break}else{e=e+4|0;g=j}}m=k+((l>>>2)+1<<2)|0;c[m>>2]=0;i=d;return}function rpa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=0;i=a;return e|0}else{f=0;g=b}while(1){b=(c[g>>2]|0)+(f<<4)|0;h=b&-268435456;j=(h>>>24|h)^b;b=g+4|0;if((b|0)==(d|0)){e=j;break}else{g=b;f=j}}i=a;return e|0}function spa(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function tpa(a){a=a|0;i=i;return}function upa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];me[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==1){a[j]=1}else if((z|0)==0){a[j]=0}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}Ana(u,g);m=u;u=c[m>>2]|0;if(!((c[36308]|0)==-1)){c[p>>2]=145232;c[p+4>>2]=964;c[p+8>>2]=0;pma(145232,p,965)}p=(c[145236>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Dc(4)|0;D=C;owa(D);E=160792;F=127;Ld(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Dc(4)|0;D=C;owa(D);E=160792;F=127;Ld(C|0,E|0,F|0)}F=u;Wla(c[m>>2]|0)|0;Ana(v,g);g=v;v=c[g>>2]|0;if(!((c[36344]|0)==-1)){c[o>>2]=145376;c[o+4>>2]=964;c[o+8>>2]=0;pma(145376,o,965)}o=(c[145380>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Dc(4)|0;H=G;owa(H);I=160792;J=127;Ld(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Dc(4)|0;H=G;owa(H);I=160792;J=127;Ld(G|0,I|0,J|0)}J=v;Wla(c[g>>2]|0)|0;g=w;_d[c[(c[v>>2]|0)+24>>2]&127](g,J);_d[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=vpa(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];Ema(w+12|0);Ema(w);i=k;return}function vpa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=Jwa(l)|0;if((n|0)!=0){o=n;p=n;break}Wwa()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){y=r;break}if((ae[c[(c[r>>2]|0)+36>>2]&127](r)|0)==-1){c[l>>2]=0;y=0;break}else{y=c[l>>2]|0;break}}}while(0);r=(y|0)==0;t=c[b>>2]|0;do{if((t|0)==0){z=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){z=t;break}if(!((ae[c[(c[t>>2]|0)+36>>2]&127](t)|0)==-1)){z=t;break}c[b>>2]=0;z=0}}while(0);A=(z|0)==0;B=c[l>>2]|0;if(!((r^A)&(q|0)!=0)){break}t=c[B+12>>2]|0;if((t|0)==(c[B+16>>2]|0)){C=(ae[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[t]|0}if(j){D=C}else{D=pe[c[(c[g>>2]|0)+12>>2]&63](g,C)|0}t=d+1|0;if(m){d=t;q=q;x=x;continue}b:do{if(j){w=0;s=e;n=x;v=q;u=p;while(1){do{if((a[u]|0)==1){E=a[s]|0;F=(E&1)==0;if(F){G=s+1|0}else{G=c[s+8>>2]|0}if(!(D<<24>>24==(a[G+d|0]|0))){a[u]=0;H=w;I=n;J=v+ -1|0;break}if(F){K=(E&255)>>>1}else{K=c[s+4>>2]|0}if((K|0)!=(t|0)){H=1;I=n;J=v;break}a[u]=2;H=1;I=n+1|0;J=v+ -1|0}else{H=w;I=n;J=v}}while(0);E=s+12|0;if((E|0)==(f|0)){L=H;M=I;N=J;break b}w=H;s=E;n=I;v=J;u=u+1|0}}else{u=0;v=e;n=x;s=q;w=p;while(1){do{if((a[w]|0)==1){if((a[v]&1)==0){O=v+1|0}else{O=c[v+8>>2]|0}if(!(D<<24>>24==(pe[c[(c[g>>2]|0)+12>>2]&63](g,a[O+d|0]|0)|0)<<24>>24)){a[w]=0;P=u;Q=n;R=s+ -1|0;break}E=a[v]|0;if((E&1)==0){S=(E&255)>>>1}else{S=c[v+4>>2]|0}if((S|0)!=(t|0)){P=1;Q=n;R=s;break}a[w]=2;P=1;Q=n+1|0;R=s+ -1|0}else{P=u;Q=n;R=s}}while(0);E=v+12|0;if((E|0)==(f|0)){L=P;M=Q;N=R;break b}u=P;v=E;n=Q;s=R;w=w+1|0}}}while(0);if(!L){d=t;x=M;q=N;continue}r=c[l>>2]|0;w=r+12|0;s=c[w>>2]|0;if((s|0)==(c[r+16>>2]|0)){ae[c[(c[r>>2]|0)+40>>2]&127](r)|0}else{c[w>>2]=s+1}if((N+M|0)>>>0<2){d=t;x=M;q=N;continue}else{T=e;U=M;V=p}while(1){do{if((a[V]|0)==2){s=a[T]|0;if((s&1)==0){W=(s&255)>>>1}else{W=c[T+4>>2]|0}if((W|0)==(t|0)){X=U;break}a[V]=0;X=U+ -1|0}else{X=U}}while(0);s=T+12|0;if((s|0)==(f|0)){d=t;x=X;q=N;continue a}else{T=s;U=X;V=V+1|0}}}do{if((B|0)==0){Y=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){Y=B;break}if((ae[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[l>>2]=0;Y=0;break}else{Y=c[l>>2]|0;break}}}while(0);l=(Y|0)==0;do{if(A){Z=78}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){if(l){break}else{Z=80;break}}if((ae[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1){c[b>>2]=0;Z=78;break}else{if(l){break}else{Z=80;break}}}}while(0);if((Z|0)==78){if(l){Z=80}}if((Z|0)==80){c[h>>2]=c[h>>2]|2}c:do{if(m){Z=85}else{if((a[p]|0)==2){_=e;break}else{$=e;aa=p}while(1){l=$+12|0;b=aa+1|0;if((l|0)==(f|0)){Z=85;break c}if((a[b]|0)==2){_=l;break}else{aa=b;$=l}}}}while(0);if((Z|0)==85){c[h>>2]=c[h>>2]|4;_=f}if((o|0)==0){i=k;return _|0}Kwa(o);i=k;return _|0}function wpa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];xpa(a,0,k,j,f,g,h);i=b;return}function xpa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;nqa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Nma(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ae[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ae[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}Nma(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}Nma(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(ae[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((Ppa(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){ae[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=jva(F,c[o>>2]|0,h,t)|0;Asa(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((ae[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;Ema(n);Ema(m);i=d;return}if((ae[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;Ema(n);Ema(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;Ema(n);Ema(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;Ema(n);Ema(m);i=d;return}function ypa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];zpa(a,0,k,j,f,g,h);i=b;return}function zpa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;nqa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Nma(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ae[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ae[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}Nma(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}Nma(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(ae[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((Ppa(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){ae[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=iva(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;Asa(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((ae[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;Ema(n);Ema(m);i=d;return}if((ae[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;Ema(n);Ema(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;Ema(n);Ema(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;Ema(n);Ema(m);i=d;return}function Apa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Bpa(a,0,k,j,f,g,h);i=b;return}function Bpa(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;l=e;m=e+32|0;n=e+40|0;o=e+56|0;p=e+72|0;q=e+80|0;r=e+240|0;s=e+248|0;t=c[h+4>>2]&74;if((t|0)==8){u=16}else if((t|0)==0){u=0}else if((t|0)==64){u=8}else{u=10}t=l;nqa(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Nma(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=a[m]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){B=m;break}if(!((ae[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){B=m;break}c[l>>2]=0;B=0}}while(0);x=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){D=18}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){if(x){E=C;break}else{F=C;G=A;break a}}if((ae[c[(c[C>>2]|0)+36>>2]&127](C)|0)==-1){c[f>>2]=0;D=18;break}else{if(x){E=C;break}else{F=C;G=A;break a}}}}while(0);if((D|0)==18){D=0;if(x){F=0;G=A;break}else{E=0}}C=a[o]|0;H=(C&1)==0;if(H){I=(C&255)>>>1}else{I=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(I|0)){if(H){J=(C&255)>>>1;K=(C&255)>>>1}else{C=c[y>>2]|0;J=C;K=C}Nma(o,K<<1,0);if((a[o]&1)==0){L=10}else{L=(c[g>>2]&-2)+ -1|0}Nma(o,L,0);if((a[o]&1)==0){M=v}else{M=c[w>>2]|0}c[p>>2]=M+J;N=M}else{N=A}C=B+12|0;H=c[C>>2]|0;O=B+16|0;if((H|0)==(c[O>>2]|0)){P=(ae[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{P=a[H]|0}if((Ppa(P,u,N,p,s,z,n,h,r,t)|0)!=0){F=E;G=N;break}H=c[C>>2]|0;if((H|0)==(c[O>>2]|0)){ae[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=N;continue}else{c[C>>2]=H+1;m=B;A=N;continue}}N=a[n]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[n+4>>2]|0}do{if((Q|0)!=0){N=c[r>>2]|0;if((N-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=N+4;c[N>>2]=A}}while(0);b[k>>1]=hva(G,c[p>>2]|0,j,u)|0;Asa(n,h,c[r>>2]|0,j);do{if((B|0)==0){R=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){R=B;break}if(!((ae[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1)){R=B;break}c[l>>2]=0;R=0}}while(0);l=(R|0)==0;do{if((F|0)==0){D=54}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(!l){break}S=d;T=S;c[T>>2]=R;Ema(o);Ema(n);i=e;return}if((ae[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1){c[f>>2]=0;D=54;break}if(!(l^(F|0)==0)){break}S=d;T=S;c[T>>2]=R;Ema(o);Ema(n);i=e;return}}while(0);do{if((D|0)==54){if(l){break}S=d;T=S;c[T>>2]=R;Ema(o);Ema(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;S=d;T=S;c[T>>2]=R;Ema(o);Ema(n);i=e;return}function Cpa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Dpa(a,0,k,j,f,g,h);i=b;return}function Dpa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;nqa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Nma(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ae[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ae[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}Nma(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}Nma(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(ae[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((Ppa(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){ae[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=gva(F,c[o>>2]|0,h,t)|0;Asa(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((ae[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;Ema(n);Ema(m);i=d;return}if((ae[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;Ema(n);Ema(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;Ema(n);Ema(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;Ema(n);Ema(m);i=d;return}function Epa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Fpa(a,0,k,j,f,g,h);i=b;return}function Fpa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;nqa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Nma(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ae[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ae[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}Nma(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}Nma(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(ae[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((Ppa(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){ae[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=fva(F,c[o>>2]|0,h,t)|0;Asa(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((ae[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;Ema(n);Ema(m);i=d;return}if((ae[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;Ema(n);Ema(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;Ema(n);Ema(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;Ema(n);Ema(m);i=d;return}function Gpa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Hpa(a,0,k,j,f,g,h);i=b;return}function Hpa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;nqa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Nma(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ae[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ae[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}Nma(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}Nma(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(ae[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((Ppa(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){ae[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=eva(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;Asa(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((ae[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;Ema(n);Ema(m);i=d;return}if((ae[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;Ema(n);Ema(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;Ema(n);Ema(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;Ema(n);Ema(m);i=d;return}function Ipa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Jpa(a,0,k,j,f,g,h);i=b;return}function Jpa(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;oqa(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Nma(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((ae[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((ae[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}Nma(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}Nma(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(ae[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((pqa(R,t,u,P,p,B,l,n,h,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){ae[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);g[k>>2]=+dva(I,c[p>>2]|0,j);Asa(n,h,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((ae[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;Ema(o);Ema(n);i=d;return}if((ae[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;Ema(o);Ema(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;Ema(o);Ema(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;Ema(o);Ema(n);i=d;return}function Kpa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Lpa(a,0,k,j,f,g,h);i=b;return}function Lpa(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;oqa(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Nma(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((ae[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((ae[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}Nma(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}Nma(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(ae[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((pqa(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){ae[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+cva(I,c[p>>2]|0,j);Asa(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((ae[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;Ema(o);Ema(n);i=d;return}if((ae[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;Ema(o);Ema(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;Ema(o);Ema(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;Ema(o);Ema(n);i=d;return}function Mpa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Npa(a,0,k,j,f,g,h);i=b;return}function Npa(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;oqa(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Nma(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((ae[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((ae[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}Nma(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}Nma(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(ae[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((pqa(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){ae[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+bva(I,c[p>>2]|0,j);Asa(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((ae[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;Ema(o);Ema(n);i=d;return}if((ae[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;Ema(o);Ema(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;Ema(o);Ema(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;Ema(o);Ema(n);i=d;return}function Opa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Ana(o,g);g=o;o=c[g>>2]|0;if(!((c[36308]|0)==-1)){c[l>>2]=145232;c[l+4>>2]=964;c[l+8>>2]=0;pma(145232,l,965)}l=(c[145236>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Dc(4)|0;w=v;owa(w);x=160792;y=127;Ld(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Dc(4)|0;w=v;owa(w);x=160792;y=127;Ld(v|0,x|0,y|0)}y=m;ze[c[(c[o>>2]|0)+32>>2]&63](o,143776,143802|0,y)|0;Wla(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Nma(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){C=m;break}if(!((ae[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){C=m;break}c[r>>2]=0;C=0}}while(0);B=(C|0)==0;v=c[e>>2]|0;do{if((v|0)==0){D=19}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){if(B){break}else{E=x;break a}}if((ae[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1){c[e>>2]=0;D=19;break}else{if(B){break}else{E=x;break a}}}}while(0);if((D|0)==19){D=0;if(B){E=x;break}}v=a[p]|0;w=(v&1)==0;if(w){F=(v&255)>>>1}else{F=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(F|0)){if(w){G=(v&255)>>>1;H=(v&255)>>>1}else{v=c[o>>2]|0;G=v;H=v}Nma(p,H<<1,0);if((a[p]&1)==0){I=10}else{I=(c[f>>2]&-2)+ -1|0}Nma(p,I,0);if((a[p]&1)==0){J=z}else{J=c[A>>2]|0}c[q>>2]=J+G;K=J}else{K=x}v=C+12|0;w=c[v>>2]|0;l=C+16|0;if((w|0)==(c[l>>2]|0)){L=(ae[c[(c[C>>2]|0)+36>>2]&127](C)|0)&255}else{L=a[w]|0}if((Ppa(L,16,K,q,t,0,n,g,s,y)|0)!=0){E=K;break}w=c[v>>2]|0;if((w|0)==(c[l>>2]|0)){ae[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=K;continue}else{c[v>>2]=w+1;m=C;x=K;continue}}a[E+3|0]=0;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);K=c[36280]|0;c[k>>2]=j;if((Qpa(E,K,143816,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){M=0}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){M=k;break}if(!((ae[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1)){M=k;break}c[r>>2]=0;M=0}}while(0);r=(M|0)==0;k=c[e>>2]|0;do{if((k|0)==0){D=54}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){if(!r){break}N=b;O=N;c[O>>2]=M;Ema(p);Ema(n);i=d;return}if((ae[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1){c[e>>2]=0;D=54;break}if(!(r^(k|0)==0)){break}N=b;O=N;c[O>>2]=M;Ema(p);Ema(n);i=d;return}}while(0);do{if((D|0)==54){if(r){break}N=b;O=N;c[O>>2]=M;Ema(p);Ema(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;N=b;O=N;c[O>>2]=M;Ema(p);Ema(n);i=d;return}function Ppa(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(a[m+24|0]|0)==b<<24>>24;if(!q){if(!((a[m+25|0]|0)==b<<24>>24)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&b<<24>>24==h<<24>>24){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+26|0;h=m;while(1){l=h+1|0;if((a[h]|0)==b<<24>>24){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;if((h|0)>23){r=-1;i=n;return r|0}do{if((d|0)==16){if((h|0)<22){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;m=a[143776+h|0]|0;c[f>>2]=o+1;a[o]=m;r=0;i=n;return r|0}else if((d|0)==10|(d|0)==8){if((h|0)<(d|0)){break}else{r=-1}i=n;return r|0}}while(0);d=a[143776+h|0]|0;c[f>>2]=o+1;a[o]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function Qpa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Kc(b|0)|0;b=Wa(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Kc(e|0)|0;i=f;return b|0}function Rpa(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function Spa(a){a=a|0;i=i;return}function Tpa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];me[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}Ana(u,g);m=u;u=c[m>>2]|0;if(!((c[36306]|0)==-1)){c[p>>2]=145224;c[p+4>>2]=964;c[p+8>>2]=0;pma(145224,p,965)}p=(c[145228>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Dc(4)|0;D=C;owa(D);E=160792;F=127;Ld(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Dc(4)|0;D=C;owa(D);E=160792;F=127;Ld(C|0,E|0,F|0)}F=u;Wla(c[m>>2]|0)|0;Ana(v,g);g=v;v=c[g>>2]|0;if(!((c[36346]|0)==-1)){c[o>>2]=145384;c[o+4>>2]=964;c[o+8>>2]=0;pma(145384,o,965)}o=(c[145388>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Dc(4)|0;H=G;owa(H);I=160792;J=127;Ld(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Dc(4)|0;H=G;owa(H);I=160792;J=127;Ld(G|0,I|0,J|0)}J=v;Wla(c[g>>2]|0)|0;g=w;_d[c[(c[v>>2]|0)+24>>2]&127](g,J);_d[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=Upa(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];gna(w+12|0);gna(w);i=k;return}function Upa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=Jwa(l)|0;if((n|0)!=0){o=n;p=n;break}Wwa()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){z=ae[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{z=c[t>>2]|0}if((z|0)==-1){c[l>>2]=0;y=1;break}else{y=(c[l>>2]|0)==0;break}}}while(0);r=c[b>>2]|0;do{if((r|0)==0){A=0;B=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){C=ae[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{C=c[t>>2]|0}if(!((C|0)==-1)){A=r;B=0;break}c[b>>2]=0;A=0;B=1}}while(0);D=c[l>>2]|0;if(!((y^B)&(q|0)!=0)){break}r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){E=ae[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{E=c[r>>2]|0}if(j){F=E}else{F=pe[c[(c[g>>2]|0)+28>>2]&63](g,E)|0}r=d+1|0;if(m){d=r;q=q;x=x;continue}b:do{if(j){t=0;w=e;s=x;n=q;v=p;while(1){do{if((a[v]|0)==1){u=a[w]|0;G=(u&1)==0;if(G){H=w+4|0}else{H=c[w+8>>2]|0}if((F|0)!=(c[H+(d<<2)>>2]|0)){a[v]=0;I=t;J=s;K=n+ -1|0;break}if(G){L=(u&255)>>>1}else{L=c[w+4>>2]|0}if((L|0)!=(r|0)){I=1;J=s;K=n;break}a[v]=2;I=1;J=s+1|0;K=n+ -1|0}else{I=t;J=s;K=n}}while(0);u=w+12|0;if((u|0)==(f|0)){M=I;N=J;O=K;break b}t=I;w=u;s=J;n=K;v=v+1|0}}else{v=0;n=e;s=x;w=q;t=p;while(1){do{if((a[t]|0)==1){if((a[n]&1)==0){P=n+4|0}else{P=c[n+8>>2]|0}if((F|0)!=(pe[c[(c[g>>2]|0)+28>>2]&63](g,c[P+(d<<2)>>2]|0)|0)){a[t]=0;Q=v;R=s;S=w+ -1|0;break}u=a[n]|0;if((u&1)==0){T=(u&255)>>>1}else{T=c[n+4>>2]|0}if((T|0)!=(r|0)){Q=1;R=s;S=w;break}a[t]=2;Q=1;R=s+1|0;S=w+ -1|0}else{Q=v;R=s;S=w}}while(0);u=n+12|0;if((u|0)==(f|0)){M=Q;N=R;O=S;break b}v=Q;n=u;s=R;w=S;t=t+1|0}}}while(0);if(!M){d=r;x=N;q=O;continue}t=c[l>>2]|0;w=t+12|0;s=c[w>>2]|0;if((s|0)==(c[t+16>>2]|0)){ae[c[(c[t>>2]|0)+40>>2]&127](t)|0}else{c[w>>2]=s+4}if((O+N|0)>>>0<2){d=r;x=N;q=O;continue}else{U=e;V=N;W=p}while(1){do{if((a[W]|0)==2){s=a[U]|0;if((s&1)==0){X=(s&255)>>>1}else{X=c[U+4>>2]|0}if((X|0)==(r|0)){Y=V;break}a[W]=0;Y=V+ -1|0}else{Y=V}}while(0);s=U+12|0;if((s|0)==(f|0)){d=r;x=Y;q=O;continue a}else{U=s;V=Y;W=W+1|0}}}do{if((D|0)==0){Z=1}else{W=c[D+12>>2]|0;if((W|0)==(c[D+16>>2]|0)){_=ae[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{_=c[W>>2]|0}if((_|0)==-1){c[l>>2]=0;Z=1;break}else{Z=(c[l>>2]|0)==0;break}}}while(0);do{if((A|0)==0){$=85}else{l=c[A+12>>2]|0;if((l|0)==(c[A+16>>2]|0)){aa=ae[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{aa=c[l>>2]|0}if((aa|0)==-1){c[b>>2]=0;$=85;break}else{if(Z){break}else{$=87;break}}}}while(0);if(($|0)==85){if(Z){$=87}}if(($|0)==87){c[h>>2]=c[h>>2]|2}c:do{if(m){$=92}else{if((a[p]|0)==2){ba=e;break}else{ca=e;da=p}while(1){Z=ca+12|0;b=da+1|0;if((Z|0)==(f|0)){$=92;break c}if((a[b]|0)==2){ba=Z;break}else{da=b;ca=Z}}}}while(0);if(($|0)==92){c[h>>2]=c[h>>2]|4;ba=f}if((o|0)==0){i=k;return ba|0}Kwa(o);i=k;return ba|0}function Vpa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Wpa(a,0,k,j,f,g,h);i=b;return}function Wpa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;qqa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Nma(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ae[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ae[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}Nma(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}Nma(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=ae[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((mqa(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){ae[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=jva(I,c[o>>2]|0,h,t)|0;Asa(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=ae[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=ae[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;Ema(n);Ema(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;Ema(n);Ema(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;Ema(n);Ema(m);i=d;return}function Xpa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Ypa(a,0,k,j,f,g,h);i=b;return}function Ypa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;qqa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Nma(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ae[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ae[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}Nma(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}Nma(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=ae[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((mqa(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){ae[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=iva(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;Asa(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=ae[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=ae[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;Ema(n);Ema(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;Ema(n);Ema(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;Ema(n);Ema(m);i=d;return}function Zpa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];_pa(a,0,k,j,f,g,h);i=b;return}function _pa(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+328|0;l=e;m=e+104|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+152|0;r=e+312|0;s=e+320|0;t=c[h+4>>2]&74;if((t|0)==64){u=8}else if((t|0)==8){u=16}else if((t|0)==0){u=0}else{u=10}t=l;qqa(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Nma(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=c[m>>2]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0;C=1}else{x=c[m+12>>2]|0;if((x|0)==(c[m+16>>2]|0)){D=ae[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{D=c[x>>2]|0}if(!((D|0)==-1)){B=m;C=0;break}c[l>>2]=0;B=0;C=1}}while(0);x=c[f>>2]|0;do{if((x|0)==0){E=21}else{F=c[x+12>>2]|0;if((F|0)==(c[x+16>>2]|0)){G=ae[c[(c[x>>2]|0)+36>>2]&127](x)|0}else{G=c[F>>2]|0}if((G|0)==-1){c[f>>2]=0;E=21;break}else{if(C){H=x;break}else{I=x;J=A;break a}}}}while(0);if((E|0)==21){E=0;if(C){I=0;J=A;break}else{H=0}}x=a[o]|0;F=(x&1)==0;if(F){K=(x&255)>>>1}else{K=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(K|0)){if(F){L=(x&255)>>>1;M=(x&255)>>>1}else{x=c[y>>2]|0;L=x;M=x}Nma(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[g>>2]&-2)+ -1|0}Nma(o,N,0);if((a[o]&1)==0){O=v}else{O=c[w>>2]|0}c[p>>2]=O+L;P=O}else{P=A}x=B+12|0;F=c[x>>2]|0;Q=B+16|0;if((F|0)==(c[Q>>2]|0)){R=ae[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{R=c[F>>2]|0}if((mqa(R,u,P,p,s,z,n,h,r,t)|0)!=0){I=H;J=P;break}F=c[x>>2]|0;if((F|0)==(c[Q>>2]|0)){ae[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=P;continue}else{c[x>>2]=F+4;m=B;A=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){P=c[r>>2]|0;if((P-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=A}}while(0);b[k>>1]=hva(J,c[p>>2]|0,j,u)|0;Asa(n,h,c[r>>2]|0,j);do{if((B|0)==0){T=0;U=1}else{r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){V=ae[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{V=c[r>>2]|0}if(!((V|0)==-1)){T=B;U=0;break}c[l>>2]=0;T=0;U=1}}while(0);do{if((I|0)==0){E=60}else{l=c[I+12>>2]|0;if((l|0)==(c[I+16>>2]|0)){W=ae[c[(c[I>>2]|0)+36>>2]&127](I)|0}else{W=c[l>>2]|0}if((W|0)==-1){c[f>>2]=0;E=60;break}if(!U){break}X=d;Y=X;c[Y>>2]=T;Ema(o);Ema(n);i=e;return}}while(0);do{if((E|0)==60){if(U){break}X=d;Y=X;c[Y>>2]=T;Ema(o);Ema(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;X=d;Y=X;c[Y>>2]=T;Ema(o);Ema(n);i=e;return}function $pa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];aqa(a,0,k,j,f,g,h);i=b;return}function aqa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;qqa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Nma(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ae[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ae[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}Nma(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}Nma(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=ae[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((mqa(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){ae[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=gva(I,c[o>>2]|0,h,t)|0;Asa(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=ae[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=ae[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;Ema(n);Ema(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;Ema(n);Ema(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;Ema(n);Ema(m);i=d;return}function bqa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];cqa(a,0,k,j,f,g,h);i=b;return}function cqa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;qqa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Nma(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ae[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ae[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}Nma(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}Nma(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=ae[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((mqa(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){ae[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=fva(I,c[o>>2]|0,h,t)|0;Asa(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=ae[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=ae[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;Ema(n);Ema(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;Ema(n);Ema(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;Ema(n);Ema(m);i=d;return}function dqa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];eqa(a,0,k,j,f,g,h);i=b;return}



function j0(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;a:do{if((a|0)!=(b|0)){f=a;if(!(((d[h+76+(d[a]|0)|0]|0)+ -24|0)>>>0<2)){c[e>>2]=f;j=0;k=j;i=g;return k|0}a=f+1|0;while(1){if((a|0)==(b|0)){break a}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==18){l=7;break}else if(!((f|0)==24|(f|0)==25)){l=8;break}a=a+1|0}if((l|0)==7){c[e>>2]=a+1;j=10;k=j;i=g;return k|0}else if((l|0)==8){c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);j=-1;k=j;i=g;return k|0}function k0(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((pe[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 15:{k=n0(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 17:{k=o0(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 16:{g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==27){k=l0(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else if((g|0)==20){k=m0(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{b=b+1|0;break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((pe[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((pe[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 29:{c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);g=0;b:while(1){if((b|0)==(e|0)){m=104;break}switch(d[j+76+(d[b]|0)|0]|0){case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 29:{m=33;break b;break};case 6:{if((e-b|0)<3){m=41;break b}n=b;if((pe[c[j+336>>2]&63](j,b)|0)==0){m=43;break b}b=n+3|0;continue b;break};case 11:{m=97;break b;break};case 23:{if((g|0)!=0){m=51;break b}g=1;b=b+1|0;if((b|0)==(e|0)){m=53;break b}switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){m=58;break b}o=b;if((pe[c[j+344>>2]&63](j,b)|0)==0){m=60;break b}b=o+2|0;continue b;break};case 29:{m=55;break b;break};case 6:{if((e-b|0)<3){m=63;break b}p=b;if((pe[c[j+348>>2]&63](j,b)|0)==0){m=65;break b}b=p+3|0;continue b;break};case 24:case 22:{b=b+1|0;continue b;break};case 7:{if((e-b|0)<4){m=68;break b}q=b;if((pe[c[j+352>>2]&63](j,b)|0)==0){m=70;break b}b=q+4|0;continue b;break};default:{m=72;break b}}break};case 7:{if((e-b|0)<4){m=46;break b}r=b;if((pe[c[j+340>>2]&63](j,b)|0)==0){m=48;break b}b=r+4|0;continue b;break};case 10:case 9:case 21:{m=73;break b;break};case 5:{if((e-b|0)<2){m=36;break b}s=b;if((pe[c[j+332>>2]&63](j,b)|0)==0){m=38;break b}b=s+2|0;continue b;break};case 17:{break b;break};default:{m=103;break b}}}c:do{if((m|0)==33){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==36){k=-2;l=k;i=h;return l|0}else if((m|0)==38){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==41){k=-2;l=k;i=h;return l|0}else if((m|0)==43){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==46){k=-2;l=k;i=h;return l|0}else if((m|0)==48){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==51){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==53){k=-1;l=k;i=h;return l|0}else if((m|0)==55){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==58){k=-2;l=k;i=h;return l|0}else if((m|0)==60){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==63){k=-2;l=k;i=h;return l|0}else if((m|0)==65){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==68){k=-2;l=k;i=h;return l|0}else if((m|0)==70){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==72){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==73){b=b+1|0;d:while(1){if((b|0)==(e|0)){m=96;break}switch(d[j+76+(d[b]|0)|0]|0){case 11:{m=97;break c;break};case 6:{m=83;break d;break};case 10:case 9:case 21:{break};case 24:case 22:{m=77;break d;break};case 29:{m=76;break d;break};case 7:{m=88;break d;break};case 17:{break c;break};case 5:{m=78;break d;break};default:{m=94;break d}}b=b+1|0}do{if((m|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==77){b=b+1|0}else if((m|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((pe[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==83){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((pe[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==88){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((pe[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==94){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==96){k=-1;l=k;i=h;return l|0}}while(0);k=p0(j,b,e,f)|0;l=k;i=h;return l|0}else if((m|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-1;l=k;i=h;return l|0}}while(0);if((m|0)==97){c[f>>2]=b+1;k=2;l=k;i=h;return l|0}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}e=b;if((a[b]|0)==62){c[f>>2]=e+1;k=4;l=k;i=h;return l|0}else{c[f>>2]=e;k=0;l=k;i=h;return l|0}return 0}function l0(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)!=45){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;b:while(1){if((b|0)==(e|0)){break a}switch(d[j+76+(d[b]|0)|0]|0){case 8:case 1:case 0:{m=22;break b;break};case 7:{if((e-b|0)<4){m=18;break b}n=b;if((pe[c[j+364>>2]&63](j,b)|0)!=0){m=20;break b}b=n+4|0;continue b;break};case 5:{if((e-b|0)<2){m=8;break b}o=b;if((pe[c[j+356>>2]&63](j,b)|0)!=0){m=10;break b}b=o+2|0;continue b;break};case 27:{g=b+1|0;b=g;if((g|0)==(e|0)){m=24;break b}if((a[b]|0)==45){m=26;break b}else{continue b}break};case 6:{if((e-b|0)<3){m=13;break b}p=b;if((pe[c[j+360>>2]&63](j,b)|0)!=0){m=15;break b}b=p+3|0;continue b;break};default:{b=b+1|0;continue b}}}if((m|0)==8){k=-2;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==13){k=-2;l=k;i=h;return l|0}else if((m|0)==15){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==18){k=-2;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==22){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==24){k=-1;l=k;i=h;return l|0}else if((m|0)==26){g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==62){c[f>>2]=g+1;k=13;l=k;i=h;return l|0}else{c[f>>2]=g;k=0;l=k;i=h;return l|0}}}}while(0);k=-1;l=k;i=h;return l|0}function m0(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<6){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=8;break}if((a[k]|0)!=(a[64512+e|0]|0)){l=6;break}e=e+1|0;g=g+1|0}if((l|0)==6){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==8){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function n0(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}a:do{switch(d[k+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}n=b;if((pe[c[k+348>>2]&63](k,b)|0)!=0){b=n+3|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 24:case 22:{b=b+1|0;break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}n=b;if((pe[c[k+344>>2]&63](k,b)|0)!=0){b=n+2|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}n=b;if((pe[c[k+352>>2]&63](k,b)|0)!=0){b=n+4|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 29:{c[f>>2]=b;l=0;m=l;i=h;return m|0};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b:while(1){if((b|0)==(e|0)){o=75;break}switch(d[k+76+(d[b]|0)|0]|0){case 29:{o=24;break b;break};case 5:{if((e-b|0)<2){o=27;break b}p=b;if((pe[c[k+332>>2]&63](k,b)|0)==0){o=29;break b}b=p+2|0;continue b;break};case 6:{if((e-b|0)<3){o=32;break b}q=b;if((pe[c[k+336>>2]&63](k,b)|0)==0){o=34;break b}b=q+3|0;continue b;break};case 15:{o=68;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 7:{if((e-b|0)<4){o=37;break b}r=b;if((pe[c[k+340>>2]&63](k,b)|0)==0){o=39;break b}b=r+4|0;continue b;break};case 10:case 9:case 21:{o=41;break b;break};default:{break b}}}do{if((o|0)==24){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==27){l=-2;m=l;i=h;return m|0}else if((o|0)==29){c[f>>2]=p;l=0;m=l;i=h;return m|0}else if((o|0)==32){l=-2;m=l;i=h;return m|0}else if((o|0)==34){c[f>>2]=q;l=0;m=l;i=h;return m|0}else if((o|0)==37){l=-2;m=l;i=h;return m|0}else if((o|0)==39){c[f>>2]=r;l=0;m=l;i=h;return m|0}else if((o|0)==41){n=b;if((q0(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;c:while(1){if((b|0)==(e|0)){o=67;break}switch(d[k+76+(d[b]|0)|0]|0){case 15:{b=b+1|0;if((b|0)==(e|0)){o=63;break c}if((a[b]|0)==62){o=65;break c}else{continue c}break};case 8:case 1:case 0:{o=61;break c;break};case 7:{if((e-b|0)<4){o=57;break c}s=b;if((pe[c[k+364>>2]&63](k,b)|0)!=0){o=59;break c}b=s+4|0;continue c;break};case 6:{if((e-b|0)<3){o=52;break c}t=b;if((pe[c[k+360>>2]&63](k,b)|0)!=0){o=54;break c}b=t+3|0;continue c;break};case 5:{if((e-b|0)<2){o=47;break c}u=b;if((pe[c[k+356>>2]&63](k,b)|0)!=0){o=49;break c}b=u+2|0;continue c;break};default:{b=b+1|0;continue c}}}if((o|0)==47){l=-2;m=l;i=h;return m|0}else if((o|0)==49){c[f>>2]=u;l=0;m=l;i=h;return m|0}else if((o|0)==52){l=-2;m=l;i=h;return m|0}else if((o|0)==54){c[f>>2]=t;l=0;m=l;i=h;return m|0}else if((o|0)==57){l=-2;m=l;i=h;return m|0}else if((o|0)==59){c[f>>2]=s;l=0;m=l;i=h;return m|0}else if((o|0)==61){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==63){l=-1;m=l;i=h;return m|0}else if((o|0)==65){c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==67){l=-1;m=l;i=h;return m|0}}else if((o|0)==68){n=b;if((q0(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=62){break}c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==75){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function o0(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((pe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((pe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((pe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=51;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 11:{l=49;break b;break};case 23:{a=a+1|0;continue b;break};case 29:{l=24;break b;break};case 5:{if((b-a|0)<2){l=27;break b}m=a;if((pe[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=m+2|0;continue b;break};case 6:{if((b-a|0)<3){l=32;break b}n=a;if((pe[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=n+3|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 7:{if((b-a|0)<4){l=37;break b}o=a;if((pe[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=o+4|0;continue b;break};case 10:case 9:case 21:{l=41;break b;break};default:{l=50;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==41){a=a+1|0;while(1){if((a|0)==(b|0)){l=47;break}o=d[h+76+(d[a]|0)|0]|0;if((o|0)==11){l=44;break}else if(!((o|0)==10|(o|0)==9|(o|0)==21)){l=45;break}a=a+1|0}if((l|0)==44){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==45){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==47){j=-1;k=j;i=g;return k|0}}else if((l|0)==49){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==50){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==51){j=-1;k=j;i=g;return k|0}return 0}function p0(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=114;break}b:do{switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=45;break a}b=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((b|0)==14){break b}m=b;if(!((m|0)==9|(m|0)==10|(m|0)==21)){l=48;break a}}break};case 14:{break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=12;break a}m=(pe[c[k+336>>2]&63](k,c[j>>2]|0)|0)!=0;n=c[j>>2]|0;if(!m){l=14;break a}c[j>>2]=n+3;continue a;break};case 29:{l=4;break a;break};case 23:{if((g|0)!=0){l=22;break a}g=1;c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=24;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=34;break a}m=(pe[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;o=c[j>>2]|0;if(!m){l=36;break a}c[j>>2]=o+3;continue a;break};case 29:{l=26;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=39;break a}m=(pe[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;p=c[j>>2]|0;if(!m){l=41;break a}c[j>>2]=p+4;continue a;break};case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=29;break a}m=(pe[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;q=c[j>>2]|0;if(!m){l=31;break a}c[j>>2]=q+2;continue a;break};default:{l=43;break a}}break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=7;break a}m=(pe[c[k+332>>2]&63](k,c[j>>2]|0)|0)!=0;r=c[j>>2]|0;if(!m){l=9;break a}c[j>>2]=r+2;continue a;break};case 27:case 26:case 25:case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=17;break a}m=(pe[c[k+340>>2]&63](k,c[j>>2]|0)|0)!=0;s=c[j>>2]|0;if(!m){l=19;break a}c[j>>2]=s+4;continue a;break};default:{l=113;break a}}}while(0);g=0;while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=51;break a}t=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((t|0)==12|(t|0)==13){break}m=t;if(!((m|0)==9|(m|0)==10|(m|0)==21)){l=54;break a}}c[j>>2]=(c[j>>2]|0)+1;c:while(1){if((c[j>>2]|0)==(e|0)){l=57;break a}m=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((m|0)==(t|0)){break}switch(m|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=66;break a}m=(pe[c[k+360>>2]&63](k,c[j>>2]|0)|0)!=0;u=c[j>>2]|0;if(m){l=68;break a}c[j>>2]=u+3;continue c;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=61;break a}m=(pe[c[k+356>>2]&63](k,c[j>>2]|0)|0)!=0;v=c[j>>2]|0;if(m){l=63;break a}c[j>>2]=v+2;continue c;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=71;break a}m=(pe[c[k+364>>2]&63](k,c[j>>2]|0)|0)!=0;w=c[j>>2]|0;if(m){l=73;break a}c[j>>2]=w+4;continue c;break};case 3:{x=g0(k,(c[j>>2]|0)+1|0,e,j)|0;if((x|0)<=0){l=77;break a}else{continue c}break};case 8:case 1:case 0:{l=75;break a;break};case 2:{l=80;break a;break};default:{c[j>>2]=(c[j>>2]|0)+1;continue c}}}c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=83;break}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 10:case 9:case 21:{break};case 11:{l=106;break a;break};case 17:{l=107;break a;break};default:{l=85;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=87;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 29:{l=89;break a;break};case 6:{l=96;break d;break};case 7:{l=101;break d;break};case 10:case 9:case 21:{break};case 11:{l=106;break a;break};case 24:case 22:{l=90;break d;break};case 5:{l=91;break d;break};case 17:{l=107;break a;break};default:{l=112;break a}}}if((l|0)==90){l=0;c[j>>2]=(c[j>>2]|0)+1;continue}else if((l|0)==91){l=0;if((e-(c[j>>2]|0)|0)<2){l=92;break}m=(pe[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;y=c[j>>2]|0;if(!m){l=94;break}c[j>>2]=y+2;continue}else if((l|0)==96){l=0;if((e-(c[j>>2]|0)|0)<3){l=97;break}m=(pe[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;z=c[j>>2]|0;if(!m){l=99;break}c[j>>2]=z+3;continue}else if((l|0)==101){l=0;if((e-(c[j>>2]|0)|0)<4){l=102;break}m=(pe[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;A=c[j>>2]|0;if(!m){l=104;break}c[j>>2]=A+4;continue}}if((l|0)==4){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==7){B=-2;C=B;i=h;return C|0}else if((l|0)==9){c[f>>2]=r;B=0;C=B;i=h;return C|0}else if((l|0)==12){B=-2;C=B;i=h;return C|0}else if((l|0)==14){c[f>>2]=n;B=0;C=B;i=h;return C|0}else if((l|0)==17){B=-2;C=B;i=h;return C|0}else if((l|0)==19){c[f>>2]=s;B=0;C=B;i=h;return C|0}else if((l|0)==22){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==24){B=-1;C=B;i=h;return C|0}else if((l|0)==26){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==29){B=-2;C=B;i=h;return C|0}else if((l|0)==31){c[f>>2]=q;B=0;C=B;i=h;return C|0}else if((l|0)==34){B=-2;C=B;i=h;return C|0}else if((l|0)==36){c[f>>2]=o;B=0;C=B;i=h;return C|0}else if((l|0)==39){B=-2;C=B;i=h;return C|0}else if((l|0)==41){c[f>>2]=p;B=0;C=B;i=h;return C|0}else if((l|0)==43){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==45){B=-1;C=B;i=h;return C|0}else if((l|0)==48){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==51){B=-1;C=B;i=h;return C|0}else if((l|0)==54){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==57){B=-1;C=B;i=h;return C|0}else if((l|0)==61){B=-2;C=B;i=h;return C|0}else if((l|0)==63){c[f>>2]=v;B=0;C=B;i=h;return C|0}else if((l|0)==66){B=-2;C=B;i=h;return C|0}else if((l|0)==68){c[f>>2]=u;B=0;C=B;i=h;return C|0}else if((l|0)==71){B=-2;C=B;i=h;return C|0}else if((l|0)==73){c[f>>2]=w;B=0;C=B;i=h;return C|0}else if((l|0)==75){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==77){if((x|0)==0){c[f>>2]=c[j>>2]}B=x;C=B;i=h;return C|0}else if((l|0)==80){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==83){B=-1;C=B;i=h;return C|0}else if((l|0)==85){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==87){B=-1;C=B;i=h;return C|0}else if((l|0)==89){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==92){B=-2;C=B;i=h;return C|0}else if((l|0)==94){c[f>>2]=y;B=0;C=B;i=h;return C|0}else if((l|0)==97){B=-2;C=B;i=h;return C|0}else if((l|0)==99){c[f>>2]=z;B=0;C=B;i=h;return C|0}else if((l|0)==102){B=-2;C=B;i=h;return C|0}else if((l|0)==104){c[f>>2]=A;B=0;C=B;i=h;return C|0}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+1;B=1;C=B;i=h;return C|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){B=-1;C=B;i=h;return C|0}e=c[j>>2]|0;if((a[c[j>>2]|0]|0)==62){c[f>>2]=e+1;B=3;C=B;i=h;return C|0}else{c[f>>2]=e;B=0;C=B;i=h;return C|0}}else if((l|0)==112){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==113){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==114){B=-1;C=B;i=h;return C|0}return 0}function q0(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;do{if((e-g|0)!=3){h=1}else{j=a[g]|0;if((j|0)==88){f=1}else if((j|0)!=120){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==77){f=1}else if((j|0)!=109){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==76){f=1}else if((j|0)!=108){h=1;break}if((f|0)!=0){h=0;break}else{c[d>>2]=12;h=1;break}}}while(0);i=b;return h|0}function r0(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+56|0;j=a;a=b;b=e;e=f;f=g;a:while(1){if((b|0)==(e|0)){k=27;break}g=d[a+76+(d[b]|0)|0]|0;switch(g|0){case 6:{if((e-b|0)<3){k=10;break a}l=b;if((pe[c[a+360>>2]&63](a,b)|0)!=0){k=12;break a}b=l+3|0;continue a;break};case 5:{if((e-b|0)<2){k=5;break a}m=b;if((pe[c[a+356>>2]&63](a,b)|0)!=0){k=7;break a}b=m+2|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}n=b;if((pe[c[a+364>>2]&63](a,b)|0)!=0){k=17;break a}b=n+4|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 13:case 12:{b=b+1|0;if((g|0)!=(j|0)){continue a}else{k=21;break a}break};default:{b=b+1|0;continue a}}}if((k|0)==5){o=-2;p=o;i=h;return p|0}else if((k|0)==7){c[f>>2]=m;o=0;p=o;i=h;return p|0}else if((k|0)==10){o=-2;p=o;i=h;return p|0}else if((k|0)==12){c[f>>2]=l;o=0;p=o;i=h;return p|0}else if((k|0)==15){o=-2;p=o;i=h;return p|0}else if((k|0)==17){c[f>>2]=n;o=0;p=o;i=h;return p|0}else if((k|0)==19){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==21){if((b|0)==(e|0)){o=-27;p=o;i=h;return p|0}c[f>>2]=b;switch(d[a+76+(d[b]|0)|0]|0|0){case 20:case 30:case 11:case 10:case 9:case 21:{o=27;p=o;i=h;return p|0};default:{o=0;p=o;i=h;return p|0}}}else if((k|0)==27){o=-1;p=o;i=h;return p|0}return 0}function s0(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==24|(f|0)==22){a=a+1|0;a:while(1){if((a|0)==(b|0)){l=17;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 30:{l=10;break a;break};case 24:case 22:{break};case 10:case 9:case 21:{break a;break};default:{l=16;break a}}a=a+1|0}do{if((l|0)==10){if((a+1|0)==(b|0)){j=-1;k=j;i=g;return k|0}m=d[h+76+(d[a+1|0]|0)|0]|0;if(!((m|0)==30|(m|0)==10|(m|0)==9|(m|0)==21)){break}c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==16){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==17){j=-1;k=j;i=g;return k|0}}while(0);c[e>>2]=a;j=16;k=j;i=g;return k|0}else if((f|0)==20){c[e>>2]=a+1;j=33;k=j;i=g;return k|0}else if((f|0)==27){j=l0(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=0;k=j;i=g;return k|0}return 0}function t0(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((pe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((pe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((pe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=43;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{l=24;break b;break};case 5:{if((b-a|0)<2){l=27;break b}m=a;if((pe[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=m+2|0;continue b;break};case 7:{if((b-a|0)<4){l=37;break b}n=a;if((pe[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=n+4|0;continue b;break};case 6:{if((b-a|0)<3){l=32;break b}o=a;if((pe[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=o+3|0;continue b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{l=41;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};default:{l=42;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==41){c[e>>2]=a;j=20;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==43){j=-20;k=j;i=g;return k|0}return 0}function u0(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+40|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=5;break}if((c[e>>2]|0)==(f|0)){j=5;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g}if((j|0)==5){i=b;return}}function v0(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;a=i;i=i+40|0;j=e;e=f;f=g;g=h;while(1){if((c[j>>2]|0)==(e|0)){k=5;break}if((c[f>>2]|0)==(g|0)){k=5;break}h=j;l=c[h>>2]|0;c[h>>2]=l+1;h=d[l]|0;l=f;m=c[l>>2]|0;c[l>>2]=m+2;b[m>>1]=h}if((k|0)==5){i=a;return}}function w0(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+48|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=8;break}g=a[c[h>>2]|0]|0;if((g&128|0)!=0){if((f-(c[e>>2]|0)|0)<2){j=8;break}k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=(g&255)>>6|192;l=e;k=c[l>>2]|0;c[l>>2]=k+1;a[k]=g&63|128;g=h;c[g>>2]=(c[g>>2]|0)+1;continue}else{if((c[e>>2]|0)==(f|0)){j=8;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g;continue}}if((j|0)==8){i=b;return}}function x0(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;i=i+72|0;l=b;b=e;e=f;f=g;g=h;h=j;if((f|0)==(g|0)){m=-4;n=m;i=k;return n|0}j=c[b+76>>2]|0;a:do{if((f+1|0)==(g|0)){if(((a[b+73|0]|0)+ -3|0)>>>0<3){m=-1;n=m;i=k;return n|0}b:do{switch(d[f]|0){case 60:case 0:{break};case 239:case 255:case 254:{if((a[b+73|0]|0)!=0){break b}if((e|0)==1){break a}break};default:{break a}}}while(0);m=-1;n=m;i=k;return n|0}else{o=d[f]<<8|d[f+1|0];if((o|0)==65279){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+16>>2];m=14;n=m;i=k;return n|0}else if((o|0)==61371){if((e|0)==1){p=a[b+73|0]|0;if((p|0)==0|(p|0)==4|(p|0)==5|(p|0)==3){break}}if((f+2|0)==(g|0)){m=-1;n=m;i=k;return n|0}if((d[f+2|0]|0)!=191){break}c[h>>2]=f+3;c[j>>2]=c[l+8>>2];m=14;n=m;i=k;return n|0}else if((o|0)==65534){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+20>>2];m=14;n=m;i=k;return n|0}else if((o|0)==15360){if((a[b+73|0]|0)==4){q=16}else{if((a[b+73|0]|0)==3){q=16}}if((q|0)==16){if((e|0)==1){break}}c[j>>2]=c[l+20>>2];m=ze[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f]|0)==0){if((e|0)==1){if((a[b+73|0]|0)==5){break}}c[j>>2]=c[l+16>>2];m=ze[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f+1|0]|0)!=0){break}if((e|0)==1){break}c[j>>2]=c[l+20>>2];m=ze[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}}}}while(0);c[j>>2]=c[l+(a[b+73|0]<<2)>>2];m=ze[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}function y0(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+80|0;k=a;a=b;b=d;d=e;e=f;f=g;g=h;if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}if((A0(z0(k,a,b)|0)|0)==0){c[g>>2]=a;l=0;m=l;i=j;return m|0}do{a=a+(c[k+68>>2]|0)|0;}while((A0(z0(k,a,b)|0)|0)!=0);if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}c[d>>2]=a;while(1){n=z0(k,a,b)|0;if((n|0)==-1){o=10;break}if((n|0)==61){o=12;break}if((A0(n)|0)!=0){o=14;break}a=a+(c[k+68>>2]|0)|0}do{if((o|0)==10){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==12){c[e>>2]=a}else if((o|0)==14){c[e>>2]=a;do{a=a+(c[k+68>>2]|0)|0;h=z0(k,a,b)|0;n=h;}while((A0(h)|0)!=0);if((n|0)==61){break}c[g>>2]=a;l=0;m=l;i=j;return m|0}}while(0);if((a|0)==(c[d>>2]|0)){c[g>>2]=a;l=0;m=l;i=j;return m|0}a=a+(c[k+68>>2]|0)|0;n=z0(k,a,b)|0;while(1){if((A0(n)|0)==0){break}a=a+(c[k+68>>2]|0)|0;n=z0(k,a,b)|0}if((n|0)!=34&(n|0)!=39){c[g>>2]=a;l=0;m=l;i=j;return m|0}d=n&255;a=a+(c[k+68>>2]|0)|0;c[f>>2]=a;a:while(1){n=z0(k,a,b)|0;if((n|0)==(d<<24>>24|0)){o=33;break}do{if(!(97<=(n|0)&(n|0)<=122)){if(65<=(n|0)&(n|0)<=90){break}if((48<=(n|0)&(n|0)<=57^1)&(n|0)!=46&(n|0)!=45&(n|0)!=95){o=31;break a}}}while(0);a=a+(c[k+68>>2]|0)|0}if((o|0)==31){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==33){c[g>>2]=a+(c[k+68>>2]|0);l=1;m=l;i=j;return m|0}return 0}function z0(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f+40|0;k=b;c[g>>2]=d;c[j>>2]=h;Wd[c[k+60>>2]&31](k,g,e,j,(c[j>>2]|0)+1|0);if((c[j>>2]|0)==(h|0)){l=-1;m=l;i=f;return m|0}else{l=a[h]|0;m=l;i=f;return m|0}return 0}function A0(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=a;if((c|0)==9|(c|0)==10|(c|0)==13|(c|0)==32){d=1}else{d=0}i=b;return d|0}function B0(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d>>2]=13;c[d+16>>2]=1;c[d+12>>2]=0;c[d+20>>2]=0;i=b;return}function C0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 15:{c[h>>2]=14;j=0;break};case 12:{c[h>>2]=14;j=1;break};case 11:{c[h>>2]=14;j=55;break};case 29:{c[h>>2]=16;j=2;break};case 14:{j=0;break};case 13:{c[h>>2]=14;j=56;break};case 16:{if((ze[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,68256)|0)==0){k=10;break a}c[h>>2]=15;j=3;break};default:{k=10}}}while(0);if((k|0)==10){j=G0(h,a)|0}i=g;return j|0}function D0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;a:do{switch(a|0){case 33:{c[h>>2]=17;j=0;break};case-4:{if((c[h+12>>2]|0)!=0){k=9;break a}j=0;break};case 26:{k=9;break};case 34:{if((c[h+12>>2]|0)==0){k=9;break a}b=h+12|0;c[b>>2]=(c[b>>2]|0)-1;j=0;break};case 15:{j=0;break};default:{j=F0(h,a,d,e,f)|0}}}while(0);if((k|0)==9){j=G0(h,a)|0}i=g;return j|0}function E0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==18){j=3}else if((f|0)==15){k=0;l=k;i=g;return l|0}do{if((j|0)==3){if((ze[c[e+28>>2]&63](e,b,d,68240)|0)!=0){c[h>>2]=18;k=0;l=k;i=g;return l|0}if((ze[c[e+28>>2]&63](e,b,d,68248)|0)==0){break}c[h>>2]=19;k=0;l=k;i=g;return l|0}}while(0);k=G0(h,a)|0;l=k;i=g;return l|0}function F0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;a:do{switch(a|0){case 13:{j=56;k=j;i=g;return k|0};case 11:{j=55;k=j;i=g;return k|0};case 28:{j=60;k=j;i=g;return k|0};case 16:{if((ze[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,68016)|0)!=0){c[h>>2]=20;j=11;k=j;i=g;return k|0}if((ze[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,68024)|0)!=0){c[h>>2]=21;j=33;k=j;i=g;return k|0}if((ze[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,68032)|0)!=0){c[h>>2]=22;j=39;k=j;i=g;return k|0}if((ze[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,68040)|0)==0){break a}c[h>>2]=23;j=17;k=j;i=g;return k|0};case 26:{c[h>>2]=24;j=3;k=j;i=g;return k|0};case-4:{j=0;k=j;i=g;return k|0};case 15:{j=0;k=j;i=g;return k|0};default:{}}}while(0);j=G0(h,a)|0;k=j;i=g;return k|0}function G0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=a;do{if((c[e+16>>2]|0)==0){if((b|0)!=28){break}f=59;g=f;i=d;return g|0}}while(0);c[e>>2]=16;f=-1;g=f;i=d;return g|0}function H0(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;i=e;return 0}function I0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=26;g=9}else if((b|0)==22){c[e>>2]=25;g=11}else{g=G0(e,a)|0}i=f;return g|0}function J0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=27;g=34}else if((b|0)==15){g=33}else{g=G0(e,a)|0}i=f;return g|0}function K0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=28;g=40}else{g=G0(e,a)|0}i=f;return g|0}function L0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==18){c[e>>2]=29;g=18}else{g=G0(e,a)|0}i=f;return g|0}function M0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==17){c[e>>2]=30;g=8}else{g=G0(e,a)|0}i=f;return g|0}function N0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0}else if((b|0)==13){g=56}else if((b|0)==11){g=55}else if((b|0)==29){c[e>>2]=16;g=2}else{g=G0(e,a)|0}i=f;return g|0}function O0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=17;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((ze[c[e+28>>2]&63](e,b,d,68056)|0)!=0){c[h>>2]=31;j=17;k=j;i=g;return k|0}if((ze[c[e+28>>2]&63](e,b,d,68064)|0)==0){break}c[h>>2]=32;j=17;k=j;i=g;return k|0}}while(0);j=G0(h,a)|0;k=j;i=g;return k|0}function P0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==15){g=17}else{g=G0(e,a)|0}i=f;return g|0}function Q0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=34;g=21}else if((b|0)==15){g=17}else{g=G0(e,a)|0}i=f;return g|0}function R0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=20}else{g=G0(e,a)|0}i=f;return g|0}function S0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=c[e+8>>2]|0;h=g;i=f;return h|0}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=c[e+8>>2]|0;h=g;i=f;return h|0}else{g=G0(e,a)|0;h=g;i=f;return h|0}return 0}function T0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=39;k=j;i=g;return k|0}else if((f|0)==18){if((ze[c[e+28>>2]&63](e,b,d,68072)|0)!=0){c[h>>2]=33;c[h+8>>2]=39;j=42;k=j;i=g;return k|0}if((ze[c[e+28>>2]&63](e,b,d,68080)|0)==0){break}c[h>>2]=33;c[h+8>>2]=39;j=41;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=37;c[h+4>>2]=1;j=44;k=j;i=g;return k|0}}while(0);j=G0(h,a)|0;k=j;i=g;return k|0}function U0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 31:{c[h>>2]=40;j=52;break};case 20:{if((ze[c[b+28>>2]&63](b,d+(c[b+68>>2]|0)|0,e,68088)|0)==0){k=10;break a}c[h>>2]=38;j=43;break};case 41:case 18:{c[h>>2]=40;j=51;break};case 30:{c[h>>2]=40;j=53;break};case 23:{c[h+4>>2]=2;c[h>>2]=39;j=44;break};case 15:{j=39;break};case 32:{c[h>>2]=40;j=54;break};default:{k=10}}}while(0);if((k|0)==10){j=G0(h,a)|0}i=g;return j|0}function V0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==24){c[e>>2]=33;c[e+8>>2]=39;g=45}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==15){g=39}else{g=G0(e,a)|0}i=f;return g|0}function W0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 30:{c[e>>2]=40;g=53;break};case 41:case 18:{c[e>>2]=40;g=51;break};case 23:{b=e+4|0;c[b>>2]=(c[b>>2]|0)+1;g=44;break};case 15:{g=39;break};case 32:{c[e>>2]=40;g=54;break};case 31:{c[e>>2]=40;g=52;break};default:{g=G0(e,a)|0}}i=f;return g|0}function X0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 36:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=46;h=g;i=f;return h|0};case 35:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=47;h=g;i=f;return h|0};case 24:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=45;h=g;i=f;return h|0};case 21:{c[e>>2]=39;g=49;h=g;i=f;return h|0};case 37:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=48;h=g;i=f;return h|0};case 38:{c[e>>2]=39;g=50;h=g;i=f;return h|0};case 15:{g=39;h=g;i=f;return h|0};default:{g=G0(e,a)|0;h=g;i=f;return h|0}}return 0}function Y0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=42;g=51}else if((b|0)==15){g=39}else{g=G0(e,a)|0}i=f;return g|0}function Z0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==21){c[e>>2]=41;g=39}else{g=G0(e,a)|0}i=f;return g|0}function _0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=43;g=22}else{g=G0(e,a)|0}i=f;return g|0}function $0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+56|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=46;j=33;k=j;i=g;return k|0}else if((f|0)==18){l=0;while(1){m=c[e+28>>2]|0;n=e;o=b;p=d;if((l|0)>=8){break}if((ze[m&63](n,o,p,c[68096+(l<<2)>>2]|0)|0)!=0){q=6;break}l=l+1|0}if((q|0)==6){c[h>>2]=44;j=23+l|0;k=j;i=g;return k|0}if((ze[m&63](n,o,p,68040)|0)==0){break}c[h>>2]=45;j=33;k=j;i=g;return k|0}}while(0);j=G0(h,a)|0;k=j;i=g;return k|0}function a1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=27;j=37;k=j;i=g;return k|0}else if((f|0)==20){if((ze[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,68200)|0)!=0){c[h>>2]=27;j=35;k=j;i=g;return k|0}if((ze[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,68208)|0)!=0){c[h>>2]=27;j=36;k=j;i=g;return k|0}if((ze[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,68224)|0)==0){break}c[h>>2]=47;j=33;k=j;i=g;return k|0}}while(0);j=G0(h,a)|0;k=j;i=g;return k|0}function b1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==23){c[e>>2]=48;g=33}else{g=G0(e,a)|0}i=f;return g|0}function c1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18|(b|0)==19){c[e>>2]=49;g=31}else if((b|0)==15){g=33}else{g=G0(e,a)|0}i=f;return g|0}function d1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=46;g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==15){g=33}else{g=G0(e,a)|0}i=f;return g|0}function e1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=50;g=32}else if((b|0)==15){g=33}else{g=G0(e,a)|0}i=f;return g|0}function f1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==21){c[e>>2]=48;g=33}else if((b|0)==15){g=33}else{g=G0(e,a)|0}i=f;return g|0}function g1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=27;g=38}else if((b|0)==15){g=33}else{g=G0(e,a)|0}i=f;return g|0}function h1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=51;g=10}else if((b|0)==15){g=11}else{g=G0(e,a)|0}i=f;return g|0}function i1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((ze[c[e+28>>2]&63](e,b,d,68056)|0)!=0){c[h>>2]=52;j=11;k=j;i=g;return k|0}if((ze[c[e+28>>2]&63](e,b,d,68064)|0)==0){break}c[h>>2]=53;j=11;k=j;i=g;return k|0}}while(0);j=G0(h,a)|0;k=j;i=g;return k|0}function j1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=54;g=13}else{g=G0(e,a)|0}i=f;return g|0}function k1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=52;g=14}else{g=G0(e,a)|0}i=f;return g|0}function l1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;f=a;do{if((f|0)==18){if((ze[c[b+28>>2]&63](b,d,e,68232)|0)==0){break}c[h>>2]=55;j=11;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=(c[h+16>>2]|0)!=0?35:36;j=15;k=j;i=g;return k|0}}while(0);j=G0(h,a)|0;k=j;i=g;return k|0}function m1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=33;c[e+8>>2]=11;g=16}else if((b|0)==15){g=11}else{g=G0(e,a)|0}i=f;return g|0}function n1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((ze[c[e+28>>2]&63](e,b,d,68056)|0)!=0){c[h>>2]=56;j=11;k=j;i=g;return k|0}if((ze[c[e+28>>2]&63](e,b,d,68064)|0)==0){break}c[h>>2]=57;j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=G0(h,a)|0;k=j;i=g;return k|0}function o1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=58;g=13}else if((b|0)==15){g=11}else{g=G0(e,a)|0}i=f;return g|0}function p1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=56;g=14}else if((b|0)==15){g=11}else{g=G0(e,a)|0}i=f;return g|0}function q1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11;h=g;i=f;return h|0}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=15;h=g;i=f;return h|0}else{g=G0(e,a)|0;h=g;i=f;return h|0}return 0}function r1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0;h=g;i=f;return h|0}else if((b|0)==25){c[e>>2]=36;b=e+12|0;c[b>>2]=(c[b>>2]|0)+1;g=0;h=g;i=f;return h|0}else{g=G0(e,a)|0;h=g;i=f;return h|0}return 0}function s1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=36;g=58}else if((b|0)==15){g=0}else{g=G0(e,a)|0}i=f;return g|0}function t1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 14:{j=0;break};case 11:{j=55;break};case 15:{j=0;break};case 13:{j=56;break};case 29:{c[h>>2]=16;j=2;break};case 16:{if((ze[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,68256)|0)==0){k=9;break a}c[h>>2]=15;j=3;break};default:{k=9}}}while(0);if((k|0)==9){j=G0(h,a)|0}i=g;return j|0}function u1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==41|(b|0)==18){c[e>>2]=59;g=4}else{g=G0(e,a)|0}i=f;return g|0}function v1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==17){c[h>>2]=30;j=8;k=j;i=g;return k|0}else if((f|0)==15){j=3;k=j;i=g;return k|0}else if((f|0)==18){if((ze[c[e+28>>2]&63](e,b,d,68056)|0)!=0){c[h>>2]=60;j=3;k=j;i=g;return k|0}if((ze[c[e+28>>2]&63](e,b,d,68064)|0)==0){break}c[h>>2]=61;j=3;k=j;i=g;return k|0}else if((f|0)==25){c[h>>2]=35;j=7;k=j;i=g;return k|0}}while(0);j=G0(h,a)|0;k=j;i=g;return k|0}function w1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=62;g=5}else if((b|0)==15){g=3}else{g=G0(e,a)|0}i=f;return g|0}function x1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=60;g=6}else if((b|0)==15){g=3}else{g=G0(e,a)|0}i=f;return g|0}function y1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==25){c[e>>2]=35;g=7}else if((b|0)==15){g=3}else{g=G0(e,a)|0}i=f;return g|0}function z1(){i=i;return}function A1(){i=i;return}function B1(){var a=0;a=i;Va(68264,0)|0;i=a;return}function C1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;if((a|0)==0){e=c[r>>2]|0;qc(68272,29,1,e|0)|0;nd(e|0)|0;f=0;i=b;return f|0}e=c[a>>2]|0;if((e|0)<0){g=c[r>>2]|0;qc(68304,54,1,g|0)|0;nd(g|0)|0;f=0;i=b;return f|0}g=c[a+4>>2]|0;if((g|0)==0){a=c[r>>2]|0;qc(68360,47,1,a|0)|0;nd(a|0)|0;f=0;i=b;return f|0}if((e|0)>0){h=0}else{f=1;i=b;return f|0}while(1){j=c[g+(h<<2)>>2]|0;a=h+1|0;if((j|0)<0){break}if((a|0)<(e|0)){h=a}else{f=1;k=11;break}}if((k|0)==11){i=b;return f|0}k=c[r>>2]|0;c[d>>2]=h;c[d+4>>2]=j;pd(k|0,68408,d|0)|0;nd(k|0)|0;f=0;i=b;return f|0}function D1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=c[a>>2]|0;h=c[b>>2]|0;if((g|0)!=(h|0)){j=c[r>>2]|0;c[f>>2]=g;c[f+4>>2]=h;pd(j|0,68496,f|0)|0;k=0;i=d;return k|0}if((g|0)<=0){k=1;i=d;return k|0}f=c[a+4>>2]|0;a=c[b+4>>2]|0;b=0;while(1){l=c[f+(b<<2)>>2]|0;m=c[a+(b<<2)>>2]|0;j=b+1|0;if((l|0)!=(m|0)){break}if((j|0)<(g|0)){b=j}else{k=1;n=8;break}}if((n|0)==8){i=d;return k|0}n=c[r>>2]|0;c[e>>2]=b;c[e+4>>2]=b;c[e+8>>2]=l;c[e+12>>2]=m;pd(n|0,68528,e|0)|0;k=0;i=d;return k|0}function E1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;d=i;i=i+24|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=c[a>>2]|0;j=c[b>>2]|0;if((h|0)!=(j|0)){k=c[r>>2]|0;c[g>>2]=h;c[g+4>>2]=j;pd(k|0,68576,g|0)|0;nd(k|0)|0;l=0;i=d;return l|0}if((h|0)<=0){l=1;i=d;return l|0}k=c[a+4>>2]|0;g=a+12|0;a=b+4|0;b=0;a:while(1){j=c[k+(b<<2)>>2]|0;m=c[(c[g>>2]|0)+(b<<2)>>2]|0;if((j|0)==0){n=c[m>>2]|0;o=c[(c[a>>2]|0)+(b<<2)>>2]|0;if((n|0)<1|(n|0)>(o|0)){p=7;break}}if((m|0)!=0&(j|0)>0){q=0;while(1){s=c[m+(q<<2)>>2]|0;t=c[(c[a>>2]|0)+(b<<2)>>2]|0;if((s|0)<1){p=12;break a}u=q+1|0;if((s|0)>(t|0)){p=12;break a}if((u|0)<(j|0)){q=u}else{break}}}j=b+1|0;if((j|0)<(h|0)){b=j}else{l=1;p=14;break}}if((p|0)==7){h=c[r>>2]|0;c[f>>2]=b;c[f+4>>2]=n;c[f+8>>2]=b;c[f+12>>2]=o;pd(h|0,68648,f|0)|0;nd(h|0)|0;l=0;i=d;return l|0}else if((p|0)==12){h=c[r>>2]|0;c[e>>2]=b;c[e+4>>2]=q;c[e+8>>2]=s;c[e+12>>2]=b;c[e+16>>2]=t;pd(h|0,68712,e|0)|0;nd(h|0)|0;l=0;i=d;return l|0}else if((p|0)==14){i=d;return l|0}return 0}function F1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a>>2]|0;if((d|0)<=0){e=1;i=b;return e|0}f=c[a+4>>2]|0;a=0;g=1;while(1){h=fa(c[f+(a<<2)>>2]|0,g)|0;j=a+1|0;if((j|0)<(d|0)){g=h;a=j}else{e=h;break}}i=b;return e|0}function G1(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a>>2]=1;f=D2(1)|0;c[a+4>>2]=f;c[f>>2]=b;c[a+8>>2]=d;i=e;return}function H1(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;c[a>>2]=b;f=a+4|0;c[f>>2]=D2(b)|0;if((b|0)>0){g=0;h=1}else{j=1;i=e;return j|0}while(1){a=c[d>>2]|0;k=c[a>>2]|0;c[d>>2]=a+4;c[(c[f>>2]|0)+(g<<2)>>2]=k;a=fa(k,h)|0;k=g+1|0;if((k|0)<(b|0)){h=a;g=k}else{j=a;break}}i=e;return j|0}function I1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((C1(a)|0)==0){bb(68776,68472,262,68800)}e=c[a>>2]|0;f=b;c[f>>2]=e;g=D2(e)|0;c[b+4>>2]=g;if((g|0)==0){bb(68824,68472,266,68800)}b=c[f>>2]|0;if((b|0)<=0){i=d;return}f=c[a+4>>2]|0;a=0;do{c[g+(a<<2)>>2]=c[f+(a<<2)>>2];a=a+1|0;}while((a|0)<(b|0));i=d;return}function J1(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;if((C1(d)|0)==0){bb(68840,68472,286,68864)}if((d2(e)|0)==0){bb(68888,68472,287,68864)}if((E1(e,d)|0)==0){bb(68912,68472,288,68864)}if((c[d>>2]|0)!=(a|0)){g=68952;h=g;j=68472;k=j;l=68864;m=l;bb(h|0,k|0,289,m|0)}if((c[e>>2]|0)!=(a|0)){g=68952;h=g;j=68472;k=j;l=68864;m=l;bb(h|0,k|0,289,m|0)}if((a|0)<=0){n=0;i=f;return n|0}m=c[e+12>>2]|0;e=c[d+4>>2]|0;d=0;k=0;while(1){h=c[b+(d<<2)>>2]|0;l=c[m+(d<<2)>>2]|0;if((l|0)==0){o=h}else{o=(c[l+(h<<2)>>2]|0)+ -1|0}h=(fa(c[e+(d<<2)>>2]|0,k)|0)+o|0;l=d+1|0;if((l|0)<(a|0)){d=l;k=h}else{n=h;break}}i=f;return n|0}function K1(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+40|0;f=e;g=e+24|0;if((b|0)<=0){h=0;i=e;return h|0}j=a+4|0;a=0;k=0;while(1){l=c[d>>2]|0;m=c[l>>2]|0;c[d>>2]=l+4;l=c[(c[j>>2]|0)+(a<<2)>>2]|0;if((m|0)<1|(m|0)>(l|0)){n=c[30092]|0;o=a+1|0;c[g>>2]=o;c[g+4>>2]=l;c[g+8>>2]=m;p=n;n=f;q=69008;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ae[p&63](0,f,69032,g);r=o;s=c[(c[j>>2]|0)+(a<<2)>>2]|0}else{r=a+1|0;s=l}l=m+ -1+(fa(s,k)|0)|0;if((r|0)<(b|0)){a=r;k=l}else{h=l;break}}i=e;return h|0}function L1(a,b){a=a|0;b=b|0;var d=0;d=i;if((C1(a)|0)==0){bb(69088,68472,347,69112)}do{if((b|0)>0){if((c[a>>2]|0)<(b|0)){break}i=d;return c[(c[a+4>>2]|0)+(b+ -1<<2)>>2]|0}}while(0);bb(69144,68472,348,69112);return 0}function M1(){var a=0,b=0,d=0;a=i;b=70888|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=71e3|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=71112|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));c[70892>>2]=1;c[70896>>2]=1;i=a;return}function N1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+24|0;e=d;f=c[b+4>>2]|0;g=c[b+8>>2]|0;h=c[b+12>>2]|0;j=c[b+16>>2]|0;k=(c[b+20>>2]|0)!=0?71248:71264;c[e>>2]=c[b>>2];c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=h;c[e+16>>2]=j;c[e+20>>2]=k;pd(a|0,71224,e|0)|0;i=d;return}function O1(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=71112+(d<<2)|0;o=71e3+(d<<2)|0;p=71312+(b<<2)|0;q=69592+(d<<2)|0;r=e;e=f;f=(g|0)!=0;a:while(1){b:do{if(f){c[l>>2]=71296;gc(71280,l|0)|0;s=71296}else{if((c[17718]|0)==(d|0)){if((c[o>>2]|0)>0){t=71296}else{u=5}}else{u=5}if((u|0)==5){u=0;t=c[q>>2]|0}c[m>>2]=t;gc(71280,m|0)|0;do{if((c[17718]|0)==(d|0)){if((c[n>>2]|0)!=(b|0)){break}if((c[o>>2]|0)>0){s=71296;break b}}}while(0);s=c[p>>2]|0}}while(0);c[k>>2]=s;gc(71304,k|0)|0;c[n>>2]=b;c[17718]=d;if((c[o>>2]|0)>0){g=0;while(1){gc(71336,j|0)|0;v=g+1|0;if((v|0)<(c[o>>2]|0)){g=v}else{w=0;break}}}else{w=0}while(1){x=e+w|0;g=a[x]|0;if(g<<24>>24==0){break a}else if(g<<24>>24==10){break}w=w+1|0}a[x]=0;sb(e|0)|0;r=0;e=e+(w+1)|0;f=1}sb(e|0)|0;nd(0)|0;if((r|0)==0){i=h;return}c[o>>2]=(c[o>>2]|0)+1;i=h;return}function P1(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;h=f;j=i;i=i+8|0;k=c[71312+(a<<2)>>2]|0;c[j>>2]=c[69592+(b<<2)>>2];c[j+4>>2]=k;gc(71344,j|0)|0;Q1(e);if((g|0)==0){Cd(((d|0)!=0?71384:71432)|0,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=nd(m|0)|0;i=f;return}sb(71512)|0;if((c[g>>2]|0)>=1){e=1;while(1){c[h>>2]=c[g+(e<<2)>>2];gc(71392,h|0)|0;if((e|0)<(c[g>>2]|0)){e=e+1|0}else{break}}}if((d|0)!=0){l=t;m=c[t>>2]|0;n=nd(m|0)|0;i=f;return}qc(71416,11,1,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=nd(m|0)|0;i=f;return}function Q1(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[t>>2]|0;f=b;while(1){b=a[f]|0;if(b<<24>>24==0){break}else if(b<<24>>24==60){qc(71464,4,1,e|0)|0}else if(b<<24>>24==62){qc(71472,4,1,e|0)|0}else if(b<<24>>24==38){qc(71456,5,1,e|0)|0}else{Kd(b<<24>>24|0,e|0)|0}f=f+1|0}i=d;return}function R1(a){a=a|0;var b=0;b=71e3+(a<<2)|0;c[b>>2]=(c[b>>2]|0)+ -1;i=i;return}function S1(a){a=a|0;var b=0;b=(a|0)==0;c[17862]=b?1:19;c[17860]=b?7:942;i=i;return}function T1(a){a=a|0;var b=0;a=i;b=c[t>>2]|0;qc(71416,11,1,b|0)|0;nd(b|0)|0;i=a;return}function U1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+2064|0;h=g+2048|0;if((c[70888+(a<<2)>>2]|0)==0){i=g;return}j=g;c[h>>2]=f;mc(j|0,2048,e|0,h|0)|0;je[c[17862]&31](1,a,b,j,0,d);i=g;return}function V1(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((c[70888+(a<<2)>>2]|0)==0){i=f;return}h=f;c[g>>2]=e;mc(h|0,2048,d|0,g|0)|0;je[c[17862]&31](1,a,b,h,0,0);i=f;return}function W1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+2064|0;h=g;j=g+2048|0;do{if((c[17720]|0)==0){if((c[70888+(a<<2)>>2]|0)!=0){break}i=g;return}}while(0);k=h;c[j>>2]=f;mc(k|0,2048,e|0,j|0)|0;je[c[17862]&31](2,a,b,k,0,d);i=g;return}function X1(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f;h=f+2048|0;do{if((c[17720]|0)==0){if((c[70888+(a<<2)>>2]|0)!=0){break}i=f;return}}while(0);j=g;c[h>>2]=e;mc(j|0,2048,d|0,h|0)|0;je[c[17862]&31](2,a,b,j,0,0);i=f;return}function Y1(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((b|0)!=0){i=f;return}b=f;c[g>>2]=e;mc(b|0,2048,d|0,g|0)|0;je[c[17862]&31](4,2,0,b,0,0);if((a|0)==0){h=hd(c[17066]|0)|0}else{h=a}db(c[h+76>>2]|0,1)}function Z1(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+2064|0;f=e+2048|0;g=e;c[f>>2]=d;mc(g|0,2048,b|0,f|0)|0;je[c[17862]&31](5,2,0,g,0,0);if((a|0)==0){h=hd(c[17066]|0)|0}else{h=a}db(c[h+76>>2]|0,1)}function _1(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f+2048|0;h=f;c[g>>2]=e;mc(h|0,2048,d|0,g|0)|0;je[c[17862]&31](5,2,0,h,0,b);if((a|0)==0){j=hd(c[17066]|0)|0}else{j=a}db(c[j+76>>2]|0,1)}function $1(a,b,d,e,f,g){a=a|0;b=+b;d=d|0;e=e|0;f=+f;g=g|0;var j=0,l=0,m=0;j=i;i=i+16|0;l=j;m=i;i=i+16|0;if(g<<24>>24==0){g=l;h[k>>3]=f;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[l+8>>2]=d;_1(a,e,71584,l)}else{l=m;h[k>>3]=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[m+8>>2]=d;W1(26,0,e,71520,m);i=j;return+b}return 0.0}function a2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=(c[a+8>>2]|0)+(fa(d,b)|0)|0;i=i;return e|0}function b2(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;c[a+8>>2]=F2(H1(a,d,g)|0,b)|0;i=f;return}function c2(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=a2(a,K1(a,d,g)|0,b)|0;i=f;return e|0}function d2(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;if((a|0)==0){g=c[r>>2]|0;qc(71632,39,1,g|0)|0;nd(g|0)|0;h=0;i=b;return h|0}g=c[a>>2]|0;if((g|0)<0){j=c[r>>2]|0;c[f>>2]=g;pd(j|0,71672,f|0)|0;nd(j|0)|0;h=0;i=b;return h|0}j=c[a+4>>2]|0;if((j|0)==0){f=c[r>>2]|0;qc(71736,56,1,f|0)|0;nd(f|0)|0;h=0;i=b;return h|0}f=c[a+12>>2]|0;if((f|0)==0){a=c[r>>2]|0;qc(71800,51,1,a|0)|0;nd(a|0)|0;h=0;i=b;return h|0}if((g|0)>0){k=0}else{h=1;i=b;return h|0}while(1){l=c[j+(k<<2)>>2]|0;if((l|0)<0){m=12;break}a=k+1|0;if(!((c[f+(k<<2)>>2]|0)!=0|(l|0)==1)){m=14;break}if((a|0)<(g|0)){k=a}else{h=1;m=15;break}}if((m|0)==12){g=c[r>>2]|0;c[e>>2]=k;c[e+4>>2]=l;pd(g|0,71856,e|0)|0;nd(g|0)|0;h=0;i=b;return h|0}else if((m|0)==14){g=c[r>>2]|0;c[d>>2]=k;c[d+4>>2]=l;pd(g|0,71936,d|0)|0;nd(g|0)|0;h=0;i=b;return h|0}else if((m|0)==15){i=b;return h|0}return 0}function e2(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;h=g;c[g>>2]=e;c[b>>2]=d;e=b+4|0;c[e>>2]=D2(d)|0;g=b+12|0;c[g>>2]=E2(d)|0;j=b+8|0;c[j>>2]=F2(d+1|0,1)|0;if((d|0)>0){k=0}else{i=f;return}do{b=c[h>>2]|0;l=c[b>>2]|0;c[h>>2]=b+4;c[(c[e>>2]|0)+(k<<2)>>2]=l;l=c[h>>2]|0;b=c[l>>2]|0;c[h>>2]=l+4;c[(c[g>>2]|0)+(k<<2)>>2]=b;b=c[h>>2]|0;l=c[b>>2]|0;c[h>>2]=b+4;a[(c[j>>2]|0)+k|0]=l;k=k+1|0;}while((k|0)<(d|0));i=f;return}function f2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=a+ -1|0;a=b+(f<<2)|0;g=(c[a>>2]|0)+1|0;c[a>>2]=g;if((g|0)<(c[d+(f<<2)>>2]|0)){h=0;i=e;return h|0}else{j=f}while(1){c[b+(j<<2)>>2]=0;if((j|0)==0){h=1;k=4;break}f=j+ -1|0;g=b+(f<<2)|0;a=(c[g>>2]|0)+1|0;c[g>>2]=a;if((a|0)<(c[d+(f<<2)>>2]|0)){h=0;k=4;break}else{j=f}}if((k|0)==4){i=e;return h|0}return 0}function g2(a,b){a=a|0;b=b|0;var c=0;c=i;G1(a,b,C2(b)|0);i=c;return}function h2(a,b,d){a=a|0;b=b|0;d=d|0;c[a+(b<<2)>>2]=d;i=i;return}function i2(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;if((d|0)==0){bb(71992,71968,176,72008)}if((pe[((d|0)>0?53:54)&63](b,e)|0)==0){g2(a,0);i=f;return}g=((e-b|0)/(d|0)|0)+1|0;g2(a,g);if((g|0)==0){i=f;return}e=a+8|0;a=b;b=0;while(1){h2(c[e>>2]|0,b,a);h=b+1|0;if(h>>>0<g>>>0){b=h;a=a+d|0}else{break}}i=f;return}function j2(a,b){a=a|0;b=b|0;i=i;return(a|0)<=(b|0)|0}function k2(a,b){a=a|0;b=b|0;i=i;return(a|0)>=(b|0)|0}function l2(a,b){a=a|0;b=b|0;i=i;return a+(b<<2)|0}function m2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;b=i;e=l2(c[a+8>>2]|0,d+ -1|0)|0;i=b;return e|0}function n2(a){a=a|0;i=i;return c[a+8>>2]|0}function o2(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=Jwa(16)|0;Y1(0,(d|0)!=0|0,72040,b);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=a;c[d+12>>2]=0;i=b;return d|0}function p2(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)!=0){f=e;while(1){e=c[f+4>>2]|0;Kwa(c[f>>2]|0);Kwa(f);if((e|0)==0){break}else{f=e}}}c[a+12>>2]=0;c[d>>2]=0;c[a+4>>2]=0;i=b;return}function q2(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;Y1(0,(a|0)!=0|0,72056,f);f=Jwa(8)|0;g=f;Y1(0,(f|0)!=0|0,72040,e);e=a+8|0;h=Jwa(c[e>>2]|0)|0;c[f>>2]=h;Y1(0,(h|0)!=0|0,72040,d);nxa(c[f>>2]|0,b|0,c[e>>2]|0)|0;e=a;c[f+4>>2]=c[e>>2];f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=g;e=a+4|0;if((c[e>>2]|0)!=0){i=d;return}c[e>>2]=g;i=d;return}function r2(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;Y1(0,(a|0)!=0|0,72056,f);f=Jwa(8)|0;g=f;Y1(0,(f|0)!=0|0,72040,e);e=a+8|0;h=Jwa(c[e>>2]|0)|0;c[f>>2]=h;Y1(0,(h|0)!=0|0,72040,d);nxa(c[f>>2]|0,b|0,c[e>>2]|0)|0;c[f+4>>2]=0;f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;f=a+4|0;e=c[f>>2]|0;if((e|0)!=0){c[e+4>>2]=g}c[f>>2]=g;f=a;if((c[f>>2]|0)!=0){i=d;return}c[f>>2]=g;i=d;return}function s2(a){a=a|0;var b=0;b=i;i=i+8|0;Y1(0,(a|0)!=0|0,72056,b);i=b;return c[a+12>>2]|0}function t2(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;Y1(0,(a|0)!=0|0,72056,d);d=a;Y1(0,(c[d>>2]|0)!=0|0,72080,b);i=b;return c[c[d>>2]>>2]|0}function u2(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=c[e+4>>2]|0;Kwa(c[e>>2]|0);Kwa(c[d>>2]|0);c[d>>2]=f;d=a+12|0;c[d>>2]=(c[d>>2]|0)+ -1;if((f|0)!=0){i=b;return}c[a+4>>2]=0;i=b;return}function v2(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;Y1(0,(a|0)!=0|0,72056,d);d=a;Y1(0,(c[d>>2]|0)!=0|0,72096,b);i=b;return c[d>>2]|0}function w2(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=(a|0)!=0;Y1(0,d&1,72128,b);if(!d){e=0;i=b;return e|0}e=c[a+4>>2]|0;i=b;return e|0}function x2(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;Y1(0,(a|0)!=0|0,72128,d);d=a;Y1(0,(c[d>>2]|0)!=0|0,72152,b);i=b;return c[d>>2]|0}function y2(){var a=0,b=0,d=0;a=i;b=Jwa(16)|0;c[18056]=b;c[b+4>>2]=0;c[b+8>>2]=2097152;d=Jwa(2097152)|0;c[b>>2]=d;c[b+12>>2]=0;i=a;return}function z2(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=G2(a)|0;sc(72232)|0;H2(d);a=c[18056]|0;e=a+4|0;f=c[e>>2]|0;g=(c[a>>2]|0)+f|0;c[e>>2]=f+d;fc(72232)|0;pxa(g|0,0,d|0)|0;i=b;return g|0}function A2(){var a=0,b=0,d=0,e=0;a=i;b=c[18056]|0;d=c[b+12>>2]|0;if((d|0)==0){e=b}else{b=d;while(1){d=c[b+12>>2]|0;Kwa(c[b>>2]|0);Kwa(b);if((d|0)==0){break}else{b=d}}e=c[18056]|0}c[e+4>>2]=0;c[e+12>>2]=0;i=a;return 0}function B2(a){a=a|0;var b=0,d=0;b=i;d=ae[c[72184>>2]&127](a<<3)|0;i=b;return d|0}function C2(a){a=a|0;var b=0,d=0;b=i;d=ae[c[72184>>2]&127](a<<2)|0;i=b;return d|0}function D2(a){a=a|0;var b=0,d=0;b=i;d=ae[c[72184>>2]&127](a<<2)|0;i=b;return d|0}function E2(a){a=a|0;var b=0,d=0;b=i;d=ae[c[72180>>2]&127](a<<2)|0;i=b;return d|0}function F2(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=fa(b,a)|0;a=ae[c[72180>>2]&127](e)|0;i=d;return a|0}function G2(a){a=a|0;i=i;return a+7&-8|0}function H2(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[18056]|0;e=d+8|0;if(!(((c[e>>2]|0)-(c[d+4>>2]|0)|0)>>>0<a>>>0)){i=b;return}f=Jwa(16)|0;c[f+12>>2]=d;c[18056]=f;c[f+4>>2]=0;d=I2((((c[e>>2]|0)*3|0)>>>1)+a|0)|0;c[f+8>>2]=d;a=Jwa(d)|0;c[f>>2]=a;i=b;return}function I2(a){a=a|0;var b=0;b=a+ -1|0;a=b>>>1|b;b=a>>>2|a;a=b>>>4|b;b=a>>>8|a;i=i;return(b>>>16|b)+1|0}function J2(a){a=a|0;var b=0,c=0;b=i;c=lxa(a|0)|0;i=b;return c|0}function K2(b,d){b=+b;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;j=i;i=i+400|0;l=g;m=j;a[l]=37;rxa(g+1|0,d|0)|0;d=f;h[k>>3]=b;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];hc(m|0,l|0,f|0)|0;f=L2(m)|0;i=e;return f|0}function L2(a){a=a|0;var b=0,c=0,d=0;b=i;c=lxa(a|0)|0;d=N2(c)|0;nxa(d|0,a|0,c|0)|0;i=b;return d|0}function M2(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;h=i;i=i+400|0;j=g;k=h;a[j]=37;rxa(g+1|0,d|0)|0;c[f>>2]=b;hc(k|0,j|0,f|0)|0;f=L2(k)|0;i=e;return f|0}function N2(b){b=b|0;var d=0,e=0;d=i;e=ae[c[72188>>2]&127](b+1|0)|0;if((e|0)==0){i=d;return e|0}a[e+b|0]=0;i=d;return e|0}function O2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=i;d=J2(a)|0;e=J2(b)|0;f=N2(e+d|0)|0;nxa(f|0,a|0,d|0)|0;nxa(f+d|0,b|0,e|0)|0;i=c;return f|0}function P2(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=hxa(c[a>>2]|0,c[b>>2]|0)|0;i=d;return e|0}function Q2(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=(a|0)%100|0;d=(c|0)/10|0;e=(a|0)%10|0;a:do{if((a+999|0)>>>0>1998){f=-1}else{if((((a|0)%1e3|0)+99|0)>>>0>198){f=-1;break}if((e|0)==1){if((c+ -50|0)>>>0>9){f=-1;break}}else if((e|0)==2){f=-1;break}switch(d|0){case 2:{f=4;break a;break};case 4:{f=2;break a;break};case 5:{f=1;break a;break};case 1:{f=4;break a;break};case 0:{f=8;break a;break};case 3:{f=2;break a;break};default:{f=-1;break a}}}}while(0);i=b;return f|0}function R2(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a;e=c[d>>2]|0;if((e|0)!=0){Wc(e|0)|0;c[d>>2]=0}e=a+4|0;f=c[e>>2]|0;if((f|0)!=0){Kwa(f);c[e>>2]=0}e=a+8|0;if((c[e>>2]|0)!=0){f=a+12|0;g=0;do{Kwa(c[(c[f>>2]|0)+(g<<4)>>2]|0);Kwa(c[(c[f>>2]|0)+(g<<4)+4>>2]|0);g=g+1|0;}while(g>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;if((c[d>>2]|0)!=0){d=a+12|0;Kwa(c[d>>2]|0);c[d>>2]=0}d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){Kwa(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;g=a+40|0;if((e&2147483647|0)!=0){a=e;e=0;while(1){f=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((f|0)==0){h=a}else{Kwa(f);h=c[d>>2]|0}f=e+1|0;if(f>>>0<h<<1>>>0){a=h;e=f}else{break}}}c[d>>2]=0;d=c[g>>2]|0;if((d|0)==0){i=b;return}Kwa(d);c[g>>2]=0;i=b;return}function S2(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=i;d=0;e=0;while(1){f=a[b+d|0]|0;if(f<<24>>24==32){g=e}else{a[b+e|0]=f;g=e+1|0}f=d+1|0;if(f>>>0>(lxa(b|0)|0)>>>0){break}else{d=f;e=g}}i=c;return}function T2(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+88|0;f=e;j=e+24|0;k=e+72|0;l=d+0|0;m=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=ic(b|0,72416)|0;m=d;c[m>>2]=l;if((l|0)==0){n=Od(c[(Mc()|0)>>2]|0)|0;i=e;return n|0}c[d+4>>2]=sd(b|0)|0;c[d+36>>2]=0;b=f;l=d+44|0;o=f;p=f+12|0;q=f+16|0;r=f+4|0;s=f+8|0;f=j;t=k;u=d+8|0;v=d+12|0;w=d+16|0;x=d+20|0;y=d+28|0;z=d+24|0;A=d+32|0;B=d+40|0;d=1;C=0;a:while(1){D=rb(b|0,20,1,c[m>>2]|0)|0;a[l]=1;if((D|0)!=1){n=72424;E=131;break}D=c[o>>2]|0;if((D|0)!=(c[72392+(C<<2)>>2]|0)){if(!((C|0)>3&(D|0)==10)){n=72448;E=131;break}a[l]=0}F=c[p>>2]|0;if(F>>>0>1){n=72472;E=131;break}G=Q2(D)|0;if((G|0)==-1){n=72504;E=131;break}D=c[q>>2]|0;H=Jwa(D)|0;if((rb(H|0,D|0,1,c[m>>2]|0)|0)!=1){n=72552;E=131;break}if((a[H+(D+ -1)|0]|0)!=0){n=72576;E=131;break}D=c[r>>2]|0;I=c[s>>2]|0;J=fa(fa(fa(D,G)|0,I)|0,F+1|0)|0;if((hxa(H,c[72368+(C<<2)>>2]|0)|0)!=0){n=72600;E=131;break}Kwa(H);H=73176;b:do{switch(C|0){case 1:{F=d<<24>>24==0;c[u>>2]=F?D:I;G=Jwa((F?D:I)<<4)|0;c[v>>2]=G;c:do{if(d<<24>>24==1){if((I|0)==0){K=0;break}L=D+1|0;M=G;N=0;while(1){c[M+(N<<4)>>2]=Jwa(L)|0;if((rb(c[(c[v>>2]|0)+(N<<4)>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=72800;E=131;break a}a[(c[(c[v>>2]|0)+(N<<4)>>2]|0)+D|0]=0;O=c[v>>2]|0;c[O+(N<<4)+8>>2]=-1;c[O+(N<<4)+12>>2]=-1;S2(c[O+(N<<4)>>2]|0);O=N+1|0;if(!(O>>>0<I>>>0)){K=I;break c}M=c[v>>2]|0;N=O}}else{K=I}}while(0);if(!F){P=d;E=130;break b}G=fa(D,K)|0;Q=Jwa(G+1|0)|0;if((rb(Q|0,G|0,1,c[m>>2]|0)|0)!=1){E=33;break a}if((D|0)!=0){G=K+1|0;N=(K|0)==0;M=0;do{L=Jwa(G)|0;c[(c[v>>2]|0)+(M<<4)>>2]=L;if(!N){L=0;do{O=a[Q+((fa(D,L)|0)+M)|0]|0;a[(c[(c[v>>2]|0)+(M<<4)>>2]|0)+L|0]=O;L=L+1|0;}while(L>>>0<K>>>0)}a[(c[(c[v>>2]|0)+(M<<4)>>2]|0)+K|0]=0;L=c[v>>2]|0;c[L+(M<<4)+8>>2]=-1;c[L+(M<<4)+12>>2]=-1;S2(c[L+(M<<4)>>2]|0);M=M+1|0;}while(M>>>0<D>>>0)}Kwa(Q);P=0;E=130;break};case 0:{if((D|0)!=4){n=72624;E=131;break a}if((I|0)!=11){n=72664;E=131;break a}if((rb(f|0,44,1,c[m>>2]|0)|0)==1){R=0}else{n=72704;E=131;break a}while(1){M=0;do{a[k+M|0]=a[j+((M<<2)+R)|0]|0;M=M+1|0;}while(M>>>0<11);a[k+11|0]=0;if((R|0)==3){break}M=R+1|0;if(M>>>0<4){R=M}else{P=d;E=130;break b}}if((ixa(t,c[18068]|0,8)|0)==0){P=1;E=130;break b}if((ixa(t,c[18074]|0,9)|0)==0){P=0;E=130}else{n=72736;E=131;break a}break};case 2:{if(d<<24>>24==1){if((I|0)==0){S=1;E=129;break b}M=D+1|0;N=0;while(1){G=Jwa(M)|0;c[(c[v>>2]|0)+(N<<4)+4>>2]=G;if((rb(c[(c[v>>2]|0)+(N<<4)+4>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=72800;E=131;break a}a[(c[(c[v>>2]|0)+(N<<4)+4>>2]|0)+D|0]=0;G=N+1|0;if(G>>>0<I>>>0){N=G}else{P=1;E=130;break b}}}else if(!(d<<24>>24==0)){S=d;E=129;break b}N=fa(D,I)|0;T=Jwa(N+1|0)|0;if((rb(T|0,N|0,1,c[m>>2]|0)|0)!=1){E=46;break a}if((D|0)!=0){N=I+1|0;M=(I|0)==0;G=0;do{F=Jwa(N)|0;c[(c[v>>2]|0)+(G<<4)+4>>2]=F;if(!M){F=0;do{L=a[T+((fa(D,F)|0)+G)|0]|0;a[(c[(c[v>>2]|0)+(G<<4)+4>>2]|0)+F|0]=L;F=F+1|0;}while(F>>>0<I>>>0)}a[(c[(c[v>>2]|0)+(G<<4)+4>>2]|0)+I|0]=0;G=G+1|0;}while(G>>>0<D>>>0)}Kwa(T);P=0;E=130;break};case 3:{G=fa(I<<2,D)|0;U=Jwa(G)|0;if((rb(U|0,G|0,1,c[m>>2]|0)|0)!=1){E=52;break a}do{if(d<<24>>24==0){if((D|0)==0){break}G=c[v>>2]|0;M=0;do{c[G+(M<<4)+8>>2]=(c[U+(M<<2)>>2]|0)==1;c[G+(M<<4)+12>>2]=c[U+(D+M<<2)>>2];M=M+1|0;}while(M>>>0<D>>>0)}else if(d<<24>>24==1){if((I|0)==0){break}M=c[v>>2]|0;G=0;do{N=fa(D,G)|0;c[M+(G<<4)+8>>2]=(c[U+(N<<2)>>2]|0)==1;c[M+(G<<4)+12>>2]=c[U+(N+1<<2)>>2];G=G+1|0;}while(G>>>0<I>>>0)}}while(0);Kwa(U);cc(c[v>>2]|0,c[u>>2]|0,16,55);P=d;E=130;break};case 5:{if(d<<24>>24==1){c[y>>2]=I;if(I>>>0<2){n=73112;E=131;break a}c[z>>2]=D;c[A>>2]=xb(c[m>>2]|0)|0;c[B>>2]=Lwa(c[z>>2]<<1,4)|0;if((Uc(c[m>>2]|0,J|0,1)|0)==-1){n=73144;E=131;break a}else{P=1;E=130;break b}}else if(!(d<<24>>24==0)){n=0;E=131;break a}c[y>>2]=D;if(D>>>0<2){n=73112;E=131;break a}c[z>>2]=I;c[A>>2]=xb(c[m>>2]|0)|0;c[B>>2]=Lwa(c[z>>2]<<1,4)|0;G=fa(I,D)|0;if((a[l]|0)==1){M=Jwa(G<<3)|0;if((rb(M|0,J|0,1,c[m>>2]|0)|0)!=1){n=73144;E=131;break a}if((I|0)!=0){N=D<<3;F=(D|0)==0;L=D<<3;O=0;do{V=Jwa(N)|0;c[(c[B>>2]|0)+(O<<2)>>2]=V;if(!F){V=M+(fa(L,O)|0)|0;nxa(c[(c[B>>2]|0)+(O<<2)>>2]|0,V|0,L|0)|0}O=O+1|0;}while(O>>>0<I>>>0)}O=c[z>>2]|0;L=O<<1;if(O>>>0<L>>>0){F=D<<3;N=(D|0)==0;V=O;do{W=Jwa(F)|0;c[(c[B>>2]|0)+(V<<2)>>2]=W;if(!N){W=c[B>>2]|0;X=c[W+(V-O<<2)>>2]|0;Y=c[W+(V<<2)>>2]|0;W=0;do{h[Y+(W<<3)>>3]=-+h[X+(W<<3)>>3];W=W+1|0;}while(W>>>0<D>>>0)}V=V+1|0;}while(V>>>0<L>>>0)}Kwa(M)}else{L=Jwa(G<<2)|0;if((rb(L|0,J|0,1,c[m>>2]|0)|0)!=1){n=73144;E=131;break a}if((I|0)!=0){V=D<<3;O=(D|0)==0;N=0;do{F=Jwa(V)|0;c[(c[B>>2]|0)+(N<<2)>>2]=F;if(!O){F=c[(c[B>>2]|0)+(N<<2)>>2]|0;W=0;do{h[F+(W<<3)>>3]=+g[L+((fa(D,N)|0)+W<<2)>>2];W=W+1|0;}while(W>>>0<D>>>0)}N=N+1|0;}while(N>>>0<I>>>0)}N=c[z>>2]|0;O=N<<1;if(N>>>0<O>>>0){V=D<<3;G=(D|0)==0;M=N;do{W=Jwa(V)|0;c[(c[B>>2]|0)+(M<<2)>>2]=W;if(!G){W=c[B>>2]|0;F=c[W+(M-N<<2)>>2]|0;X=c[W+(M<<2)>>2]|0;W=0;do{h[X+(W<<3)>>3]=-+h[F+(W<<3)>>3];W=W+1|0;}while(W>>>0<D>>>0)}M=M+1|0;}while(M>>>0<O>>>0)}Kwa(L)}if((Uc(c[m>>2]|0,J|0,1)|0)==-1){n=73144;E=131;break a}else{P=d;E=130}break};case 4:{if(d<<24>>24==1){if((D|0)==0){n=72864;E=131;break a}if(!((I+ -1|0)>>>0<2)){n=72920;E=131;break a}c[w>>2]=D;O=fa(I,D)|0;if((a[l]|0)==1){M=Jwa(O<<3)|0;c[x>>2]=M;if((rb(M|0,J|0,1,c[m>>2]|0)|0)!=1){n=72960;E=131;break a}}else{M=Jwa(O<<2)|0;c[x>>2]=Jwa(fa(D<<3,I)|0)|0;if((rb(M|0,J|0,1,c[m>>2]|0)|0)!=1){n=72960;E=131;break a}if((O|0)!=0){N=c[x>>2]|0;G=0;do{h[N+(G<<3)>>3]=+g[M+(G<<2)>>2];G=G+1|0;}while(G>>>0<O>>>0)}Kwa(M)}O=c[w>>2]|0;if(!(O>>>0>1)){P=1;E=130;break b}G=(I|0)==2;N=1;while(1){if(G){L=c[x>>2]|0;if(+h[L+(N<<3)>>3]!=+h[L+(O+N<<3)>>3]){n=72992;E=131;break a}}L=N+1|0;if(L>>>0<O>>>0){N=L}else{P=1;E=130;break b}}}else if(!(d<<24>>24==0)){S=d;E=129;break b}if((I|0)==0){n=72864;E=131;break a}if(!((D+ -1|0)>>>0<2)){n=73072;E=131;break a}c[w>>2]=I;N=fa(I,D)|0;if((a[l]|0)==1){O=Jwa(N<<3)|0;c[x>>2]=Jwa(fa(D<<3,I)|0)|0;if((rb(O|0,J|0,1,c[m>>2]|0)|0)!=1){n=72960;E=131;break a}if((D|0)!=0){G=0;do{M=c[x>>2]|0;L=0;do{h[M+((fa(I,G)|0)+L<<3)>>3]=+h[O+((fa(D,L)|0)+G<<3)>>3];L=L+1|0;}while(L>>>0<I>>>0);G=G+1|0;}while(G>>>0<D>>>0)}Kwa(O)}else{G=Jwa(N<<2)|0;c[x>>2]=Jwa(fa(D<<3,I)|0)|0;if((rb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=72960;E=131;break a}if((D|0)!=0){L=0;do{M=c[x>>2]|0;V=0;do{h[M+((fa(I,L)|0)+V<<3)>>3]=+g[G+((fa(D,V)|0)+L<<2)>>2];V=V+1|0;}while(V>>>0<I>>>0);L=L+1|0;}while(L>>>0<D>>>0)}Kwa(G)}L=c[w>>2]|0;if(!(L>>>0>1)){P=d;E=130;break b}N=(D|0)==2;O=1;while(1){if(N){V=c[x>>2]|0;if(+h[V+(O<<3)>>3]!=+h[V+(L+O<<3)>>3]){n=72992;E=131;break a}}V=O+1|0;if(V>>>0<L>>>0){O=V}else{P=d;E=130;break}}break};default:{n=H;E=131;break a}}}while(0);if((E|0)==129){E=0;d=S;C=C+1|0;continue}else if((E|0)==130){E=0;H=C+1|0;if((H|0)<6){d=P;C=H;continue}else{n=0;E=131;break}}}if((E|0)==33){Kwa(Q);n=72800;i=e;return n|0}else if((E|0)==46){Kwa(T);n=72800;i=e;return n|0}else if((E|0)==52){Kwa(U);n=72832;i=e;return n|0}else if((E|0)==131){i=e;return n|0}return 0}function U2(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=wd(e|0,c[a+12>>2]|0,c[a+8>>2]|0,16,55)|0;i=d;return b|0}function V2(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=(d|0)>-1?d:0-d|0;j=(d|0)<0;do{if(j){k=c[b+24>>2]|0;l=k+f|0;m=k}else{if((d|0)==0){n=73216;o=n;p=73264;q=p;r=73288;s=r;bb(o|0,q|0,399,s|0)}else{l=f;m=c[b+24>>2]|0;break}}}while(0);d=l+ -1|0;l=b+24|0;if(f>>>0>m>>>0){n=73216;o=n;p=73264;q=p;r=73288;s=r;bb(o|0,q|0,399,s|0)}s=b+40|0;q=c[(c[s>>2]|0)+(d<<2)>>2]|0;if((q|0)!=0){t=q;i=e;return t|0}q=b+28|0;o=c[q>>2]|0;r=Jwa(o<<3)|0;p=r;a:do{if((a[b+44|0]|0)==1){if((o|0)==0){break}n=b;m=b+32|0;k=0;while(1){Uc(c[n>>2]|0,(c[m>>2]|0)+ -8+((fa(c[l>>2]|0,k)|0)+f<<3)|0,0)|0;u=r+(k<<3)|0;if((rb(u|0,8,1,c[n>>2]|0)|0)!=1){break}if(j){h[u>>3]=-+h[u>>3]}k=k+1|0;if(!(k>>>0<(c[q>>2]|0)>>>0)){break a}}Kwa(r);t=0;i=e;return t|0}else{k=Jwa(o<<2)|0;b:do{if((o|0)==0){v=0}else{n=b;m=b+32|0;u=0;while(1){Uc(c[n>>2]|0,(c[m>>2]|0)+ -4+((fa(c[l>>2]|0,u)|0)+f<<2)|0,0)|0;w=u+1|0;if((rb(k+(u<<2)|0,4,1,c[n>>2]|0)|0)!=1){break}x=c[q>>2]|0;if(w>>>0<x>>>0){u=w}else{v=x;break b}}Kwa(k);Kwa(r);t=0;i=e;return t|0}}while(0);u=(v|0)==0;do{if(j){if(u){break}else{y=0}do{h[r+(y<<3)>>3]=-+g[k+(y<<2)>>2];y=y+1|0;}while(y>>>0<v>>>0)}else{if(u){break}else{z=0}do{h[r+(z<<3)>>3]=+g[k+(z<<2)>>2];z=z+1|0;}while(z>>>0<v>>>0)}}while(0);Kwa(k)}}while(0);c[(c[s>>2]|0)+(d<<2)>>2]=p;t=c[(c[s>>2]|0)+(d<<2)>>2]|0;i=e;return t|0}function W2(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;j=i;i=i+8|0;k=j;l=(e|0)>-1?e:0-e|0;m=(e|0)<0;do{if(m){n=c[d+24>>2]|0;o=n+l|0;p=n}else{if((e|0)==0){q=73216;r=q;s=73264;t=s;u=73312;v=u;bb(r|0,t|0,519,v|0)}else{o=l;p=c[d+24>>2]|0;break}}}while(0);if(l>>>0>p>>>0){q=73216;r=q;s=73264;t=s;u=73312;v=u;bb(r|0,t|0,519,v|0)}v=c[(c[d+40>>2]|0)+(o+ -1<<2)>>2]|0;if((v|0)!=0){h[b>>3]=+h[v+(f<<3)>>3];w=0.0;i=j;return+w}v=d;o=c[v>>2]|0;t=c[d+32>>2]|0;r=l+ -1+(fa(p,f)|0)|0;do{if((a[d+44|0]|0)==1){Uc(o|0,t+(r<<3)|0,0)|0;f=(rb(b|0,8,1,c[v>>2]|0)|0)!=1;if(f|m^1){w=f?1.0:0.0;i=j;return+w}else{x=+h[b>>3];break}}else{Uc(o|0,t+(r<<2)|0,0)|0;if((rb(k|0,4,1,c[v>>2]|0)|0)!=1){w=1.0;i=j;return+w}y=+g[k>>2];h[b>>3]=y;if(m){x=y;break}else{w=0.0}i=j;return+w}}while(0);h[b>>3]=-x;w=0.0;i=j;return+w}function X2(a,b,d,e,f,g,j){a=+a;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0;k=i;l=d+ -1|0;d=0;while(1){m=((l-d|0)/2|0)+d|0;n=+h[b+(m<<3)>>3];if(n==a){o=n;p=m;q=3;break}r=n<a;s=r?m+1|0:d;t=r?l:m+ -1|0;if((t|0)>(s|0)){l=t;d=s}else{break}}if((q|0)==3){while(1){q=0;if((p|0)>=(l|0)){break}d=p+1|0;n=+h[b+(d<<3)>>3];if(o==n){o=n;p=d;q=3}else{break}}c[e>>2]=p;h[f>>3]=1.0;c[g>>2]=-1;u=0.0;h[j>>3]=u;i=k;return}do{if((t|0)==(s|0)){if(+h[b+(s<<3)>>3]<a){v=s+1|0;w=s;break}else{v=s;w=s+ -1|0;break}}else{v=t;w=s}}while(0);c[e>>2]=v;c[g>>2]=w;o=+h[b+(w<<3)>>3];n=(a-o)/(+h[b+(v<<3)>>3]-o);h[f>>3]=n;u=1.0-n;h[j>>3]=u;i=k;return}function Y2(a){a=a|0;i=i;return+(+h[c[a+20>>2]>>3])}function Z2(a){a=a|0;i=i;return+(+h[(c[a+20>>2]|0)+(c[a+16>>2]<<3)>>3])}function _2(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;f=i;i=i+48|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;if((c[d+8>>2]|0)!=0){o=c[d+12>>2]|0;if((o|0)<0){p=-+h[(c[b+20>>2]|0)+(~o<<3)>>3]}else{p=+h[(c[b+20>>2]|0)+(o+ -1<<3)>>3]}h[a>>3]=p;q=0;i=f;return q|0}if(+Z2(b)<e){q=1;i=f;return q|0}if(+Y2(b)>e){q=1;i=f;return q|0}if((V2(b,1)|0)==0){q=1;i=f;return q|0}X2(e,c[c[b+40>>2]>>2]|0,c[b+28>>2]|0,m,g,n,j);o=c[n>>2]|0;if((o|0)==-1){q=~~+W2(a,b,c[d+12>>2]|0,c[m>>2]|0);i=f;return q|0}n=c[m>>2]|0;m=d+12|0;d=c[m>>2]|0;if((n|0)==-1){q=~~+W2(a,b,d,o);i=f;return q|0}if(+W2(k,b,d,n)!=0.0){q=1;i=f;return q|0}if(+W2(l,b,c[m>>2]|0,o)!=0.0){q=1;i=f;return q|0}h[a>>3]=+h[g>>3]*+h[k>>3]+ +h[j>>3]*+h[l>>3];q=0;i=f;return q|0}function $2(a,b){a=a|0;b=b|0;i=i;return+(+h[(c[a+8>>2]|0)+(b<<3)>>3])}function a3(a,b){a=a|0;b=b|0;var c=0;c=i;G1(a,b,B2(b)|0);i=c;return}function b3(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[a+8>>2]=B2(H1(a,b,f)|0)|0;i=e;return}function c3(a){a=a|0;var b=0;b=i;c[a+8>>2]=B2(F1(a)|0)|0;i=b;return}function d3(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0;d=i;if((C1(a)|0)==0){bb(73344,73368,127,73392)}if((C1(b)|0)==0){bb(73416,73368,128,73392)}if((D1(a,b)|0)==0){bb(73440,73368,129,73392)}e=F1(a)|0;if((e|0)==0){i=d;return}f=b+8|0;b=0;do{g=+$2(a,b);e3(c[f>>2]|0,b,g);b=b+1|0;}while(b>>>0<e>>>0);i=d;return}function e3(a,b,c){a=a|0;b=b|0;c=+c;h[a+(b<<3)>>3]=c;i=i;return}function f3(a,b){a=a|0;b=b|0;var c=0;c=i;I1(a,b);c3(b);d3(a,b);i=c;return}function g3(a,b){a=a|0;b=b|0;i=i;return a+(b<<3)|0}function h3(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0.0;e=i;if((C1(a)|0)==0){bb(73344,73368,317,73480)}if((C1(b)|0)==0){bb(73416,73368,318,73480)}if((d2(d)|0)==0){bb(73512,73368,319,73480)}if((E1(d,b)|0)==0){bb(73544,73368,320,73480)}f=d;g=c[f>>2]|0;if((g|0)>0){h=c[d+4>>2]|0;j=0;k=0;while(1){l=((c[h+(j<<2)>>2]|0)!=0)+k|0;m=j+1|0;if((m|0)<(g|0)){k=l;j=m}else{n=l;break}}}else{n=0}if((n|0)!=(c[a>>2]|0)){bb(73592,73368,326,73480)}n=b;j=D2(c[n>>2]|0)|0;k=D2(c[f>>2]|0)|0;if((c[f>>2]|0)>0){g=c[d+12>>2]|0;h=b+4|0;l=d+4|0;m=0;do{c[j+(m<<2)>>2]=0;if((c[g+(m<<2)>>2]|0)==0){c[k+(m<<2)>>2]=c[(c[h>>2]|0)+(m<<2)>>2]}else{c[k+(m<<2)>>2]=i3(c[(c[l>>2]|0)+(m<<2)>>2]|0)|0}m=m+1|0;}while((m|0)<(c[f>>2]|0))}m=b+8|0;l=0;do{h=J1(c[n>>2]|0,j,b,d)|0;o=+$2(a,l);e3(c[m>>2]|0,h,o);l=l+1|0;}while((f2(c[f>>2]|0,j,k)|0)==0);if((l|0)==(F1(a)|0)){i=e;return}else{bb(73616,73368,367,73480)}}function i3(a){a=a|0;i=i;return((a|0)<1?1:a)|0}function j3(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;b=i;e=g3(c[a+8>>2]|0,d+ -1|0)|0;i=b;return e|0}function k3(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=K1(a,b,f)|0;f=g3(c[a+8>>2]|0,d)|0;i=e;return f|0}function l3(a,b){a=a|0;b=b|0;var c=0;c=i;I1(a,b);i=c;return}function m3(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0;d=i;l3(a,b);c3(b);e=F1(b)|0;if((e|0)==0){i=d;return}f=b+8|0;b=0;do{g=-+$2(a,b);e3(c[f>>2]|0,b,g);b=b+1|0;}while(b>>>0<e>>>0);i=d;return}function n3(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0.0;e=i;f=F1(a)|0;if((f|0)==0){i=e;return}g=d+8|0;d=0;do{h=+$2(a,d);j=h- +$2(b,d);e3(c[g>>2]|0,d,j);d=d+1|0;}while(d>>>0<f>>>0);i=e;return}function o3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;l3(a,c);c3(c);n3(a,b,c);i=d;return}function p3(a,b,d,e){a=a|0;b=+b;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=H1(a,d,g)|0;g=B2(e)|0;d=a+8|0;c[d>>2]=g;if((e|0)==0){i=f;return}else{h=g;j=0}while(1){e3(h,j,b);g=j+1|0;if(!(g>>>0<e>>>0)){break}h=c[d>>2]|0;j=g}i=f;return}function q3(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=Jwa(20)|0;Y1(0,(f|0)!=0|0,73656,e);c[f+8>>2]=0;c[f+12>>2]=0;e=(a|0)<1?1:a;c[f+16>>2]=e;c[f+4>>2]=b;a=Lwa(e,b)|0;c[f>>2]=a;Y1(0,(a|0)!=0|0,73656,d);i=d;return f|0}function r3(a){a=a|0;var b=0;b=i;Kwa(c[a>>2]|0);Kwa(a);i=b;return}function s3(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=a+12|0;Y1(0,(c[h>>2]|0)>0|0,73672,g);g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=1-g;c[f+8>>2]=g+ -1;Y1(0,(g|0)>(b|0)|0,73696,f);f=c[h>>2]|0;c[e>>2]=b;c[e+4>>2]=1-f;c[e+8>>2]=f+ -1;Y1(0,(0-f|0)<(b|0)|0,73696,e);e=(c[a>>2]|0)+(fa(c[a+4>>2]|0,((c[a+8>>2]|0)+b|0)%(c[a+16>>2]|0)|0)|0)|0;i=d;return e|0}function t3(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=a+16|0;e=a+4|0;f=Lwa(c[d>>2]<<1,c[e>>2]|0)|0;Y1(0,(f|0)!=0|0,73656,b);g=a+12|0;if((c[g>>2]|0)>0){h=c[e>>2]|0;j=0;do{k=f+(fa(h,j)|0)|0;l=s3(a,j)|0;h=c[e>>2]|0;nxa(k|0,l|0,h|0)|0;j=j+1|0;}while((j|0)<(c[g>>2]|0))}g=a;Kwa(c[g>>2]|0);c[g>>2]=f;c[d>>2]=c[d>>2]<<1;c[a+8>>2]=0;i=b;return}function u3(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+16|0;f=c[e>>2]|0;g=a+12|0;h=c[g>>2]|0;if((f|0)<(h+1|0)){t3(a);j=c[e>>2]|0;k=c[g>>2]|0}else{j=f;k=h}h=c[a+4>>2]|0;nxa((c[a>>2]|0)+(fa(h,(k+(c[a+8>>2]|0)|0)%(j|0)|0)|0)|0,b|0,h|0)|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function v3(a){a=a|0;i=i;return c[a+12>>2]|0}function w3(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=a+12|0;Y1(0,(c[j>>2]|0)>0|0,73672,h);h=c[j>>2]|0;c[g>>2]=b;c[g+4>>2]=0;c[g+8>>2]=h+ -1;Y1(0,(h|0)>(b|0)|0,73696,g);g=(c[j>>2]|0)+ -1|0;c[f>>2]=b;c[f+4>>2]=0;c[f+8>>2]=g;Y1(0,b>>>31^1,73696,f);f=a+8|0;g=c[a+16>>2]|0;c[f>>2]=((fa(g+ -1|0,b)|0)+(c[f>>2]|0)|0)%(g|0)|0;if((d|0)==0){i=e;return}if((c[j>>2]|0)>0){k=0}else{i=e;return}do{c[d+(k<<2)>>2]=s3(a,k)|0;k=k+1|0;}while((k|0)<(c[j>>2]|0));i=e;return}function x3(a){a=a|0;i=i;return c[(c[18432]|0)+(a<<2)>>2]|0}function y3(a){a=a|0;i=i;return c[(c[18434]|0)+(a<<2)>>2]|0}function z3(a){a=a|0;i=i;return c[(c[18436]|0)+(a<<2)>>2]|0}function A3(a){a=a|0;i=i;return c[(c[18438]|0)+(a<<2)>>2]|0}function B3(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=(c[18434]|0)+(a<<2)|0;e=c[d>>2]|0;f=(c[18436]|0)+(a<<2)|0;g=c[f>>2]|0;h=c[(c[18432]|0)+(a<<2)>>2]|0;if((h|0)==0){i=b;return}c[d>>2]=(e|0)!=0&e>>>0<h>>>0?e:h;c[f>>2]=g>>>0>h>>>0?g:h;i=b;return}function C3(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[18440]|0;e=+D3(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function D3(a,b){a=a|0;b=b|0;i=i;return+(+(a|0)+ +(b|0)*1.0e-9)}function E3(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[18442]|0;e=+D3(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function F3(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[18444]|0;e=+D3(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function G3(a){a=a|0;i=i;return 0}function H3(a){a=a|0;var b=0,d=0;b=i;fb(4,(c[18446]|0)+(a<<3)|0)|0;d=(c[18432]|0)+(a<<2)|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function I3(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[18440]|0;f=e+(a<<3)|0;g=c[18444]|0;h=g+(a<<3)|0;c[h>>2]=(c[h>>2]|0)+(c[f>>2]|0);h=e+(a<<3)+4|0;e=g+(a<<3)+4|0;c[e>>2]=(c[e>>2]|0)+(c[h>>2]|0);e=(c[18438]|0)+(a<<2)|0;c[e>>2]=(c[e>>2]|0)+(c[(c[18432]|0)+(a<<2)>>2]|0);e=c[18442]|0;g=e+(a<<3)|0;J3(d,c[g>>2]|0,c[e+(a<<3)+4>>2]|0,c[f>>2]|0,c[h>>2]|0);h=d;d=c[h+4>>2]|0;f=g;c[f>>2]=c[h>>2];c[f+4>>2]=d;B3(a);d=c[18440]|0;c[d+(a<<3)>>2]=0;c[d+(a<<3)+4>>2]=0;c[(c[18432]|0)+(a<<2)>>2]=0;i=b;return}function J3(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(M3(b,d,e,f)|0)<0;if(h){j=e;k=f}else{j=b;k=d}d=a;c[d>>2]=j;c[d+4>>2]=k;i=g;return}function K3(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+8|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;fb(4,d|0)|0;e=c[18446]|0;f=c[18440]|0;g=f+(a<<3)|0;h=(c[d>>2]|0)-(c[e+(a<<3)>>2]|0)+(c[g>>2]|0)|0;c[g>>2]=h;j=f+(a<<3)+4|0;f=(c[d+4>>2]|0)-(c[e+(a<<3)+4>>2]|0)+(c[j>>2]|0)|0;c[j>>2]=f;if((f|0)<=999999999){i=b;return}c[g>>2]=h+1;c[j>>2]=~~(+(f|0)+-1.0e9);i=b;return}function L3(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((a|0)<33){i=b;return}d=Lwa(a,8)|0;c[18440]=d;e=Lwa(a,8)|0;c[18442]=e;f=Lwa(a,8)|0;c[18444]=f;g=Lwa(a,8)|0;c[18446]=g;h=Lwa(a,4)|0;c[18432]=h;j=Lwa(a,4)|0;c[18438]=j;k=a<<2;l=Jwa(k)|0;c[18434]=l;m=Lwa(a,4)|0;c[18436]=m;pxa(l|0,-1,k|0)|0;if((d|0)==0){bb(73792,73808,393,73824)}if((e|0)==0){bb(73832,73808,394,73824)}if((f|0)==0){bb(73848,73808,395,73824)}if((g|0)==0){bb(73864,73808,396,73824)}if((h|0)==0){bb(73880,73808,397,73824)}if((l|0)==0){bb(73904,73808,398,73824)}if((m|0)==0){bb(73928,73808,399,73824)}if((j|0)==0){bb(73952,73808,400,73824)}else{i=b;return}}function M3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;i=i;return((a|0)==(c|0)?b-d|0:a-c|0)|0}function N3(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+8|0;o=n;c[o>>2]=1;c[n+4>>2]=c[b>>2];if((a|0)==3){c[g>>2]=c[b+8>>2];n=g+4|0;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];W1(17,0,o,75832,g);i=e;return}else if((a|0)==2){c[j>>2]=c[b+8>>2];g=j+4|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];W1(17,0,o,75736,j);i=e;return}else if((a|0)==1){c[l>>2]=c[b+8>>2];j=l+4|0;h[k>>3]=d;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];W1(17,0,o,75632,l);i=e;return}else if((a|0)==0){c[m>>2]=c[b+8>>2];l=m+4|0;h[k>>3]=d;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];W1(17,0,o,75584,m);i=e;return}else{m=c[b+8>>2]|0;c[f>>2]=a;c[f+4>>2]=m;m=f+8|0;h[k>>3]=d;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];W1(17,0,o,75896,f);i=e;return}}function O3(a){a=a|0;var b=0;b=i;Kwa(c[a+12>>2]|0);Kwa(c[a+4>>2]|0);Kwa(c[a+8>>2]|0);i=b;return}function P3(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;z=~y;h[10090]=.5;h[10076]=1.0;h[10113]=.25;h[10088]=2.0;h[10115]=6.283185307179586;A=w+ -1-(c[b>>2]|0)|0;c[20188]=A;B=c[d>>2]|0;c[20118]=1;if((B|0)>=1){C=1;while(1){h[p+(C+ -1+(c[b>>2]|0)<<3)>>3]=0.0;D=C+1|0;c[20118]=D;if((C|0)<(B|0)){C=D}else{break}}}c[20116]=1;if((A|0)>=1){C=1;while(1){B=fa(C,w)|0;E=+h[j+(B+x+(c[n>>2]|0)<<3)>>3];h[10091]=E;if((C|0)<(c[k>>2]|0)){F=-E;h[10091]=F;G=F}else{G=E}D=c[d>>2]|0;c[20118]=1;a:do{if((D|0)>=1){E=G;H=1;while(1){I=p+(H+ -1+(c[b>>2]|0)<<3)|0;h[I>>3]=E*+h[j+(H+x+B<<3)>>3]+ +h[I>>3];I=H+1|0;c[20118]=I;if((H|0)>=(D|0)){break a}E=+h[10091];H=I}}}while(0);D=C+1|0;c[20116]=D;if((C|0)<(A|0)){C=D}else{break}}}C=c[b>>2]|0;h[10095]=+h[p+(C+ -1+(c[n>>2]|0)<<3)>>3];h[10060]=0.0;h[10062]=0.0;h[10066]=0.0;h[10123]=0.0;c[20114]=1;if((C|0)<1){J=0.0;K=0.0;L=0.0}else{G=0.0;A=1;while(1){D=A+ -1|0;B=o+(D<<3)|0;E=+h[B>>3];h[10060]=G+E*E;E=+h[f+((c[n>>2]|0)+x+(fa(A,w)|0)<<3)>>3];H=e+(D<<3)|0;F=E- +h[H>>3];I=s+(D<<3)|0;h[I>>3]=F;E=+h[10062]+ +h[B>>3]*F;h[10062]=E;F=+h[I>>3];M=+h[10066]+F*F;h[10066]=M;F=+h[H>>3];h[10123]=+h[10123]+F*F;H=A+1|0;c[20114]=H;F=+h[10060];if((A|0)<(C|0)){A=H;G=F}else{J=M;K=F;L=E;break}}}G=L*L;do{if(G>K*.99*J){A=c[n>>2]|0;c[20184]=A;E=G/J;h[10112]=E;C=c[d>>2]|0;c[20118]=1;if((C|0)<1){N=J;O=L;P=A}else{F=J;M=L;Q=E;H=A;A=1;while(1){do{if((A|0)==(c[m>>2]|0)){R=F;S=M;T=Q;U=H}else{h[10120]=0.0;h[10122]=0.0;I=c[b>>2]|0;c[20114]=1;if((I|0)<1){W=0.0;Z=0.0}else{E=0.0;_=0.0;B=1;while(1){$=+h[f+((fa(B,w)|0)+x+A<<3)>>3];aa=$- +h[e+(B+ -1<<3)>>3];h[10089]=aa;ba=_+aa*+h[o+(B+ -1<<3)>>3];h[10120]=ba;ca=E+aa*aa;h[10122]=ca;if((B|0)<(I|0)){B=B+1|0;_=ba;E=ca}else{break}}c[20114]=I+1;W=ca;Z=ba}E=Z*Z/W;if(!(E<Q)){R=F;S=M;T=Q;U=H;break}c[20184]=A;h[10112]=E;h[10062]=Z;h[10066]=W;R=W;S=Z;T=E;U=A}}while(0);B=A+1|0;c[20118]=B;if((A|0)<(C|0)){F=R;M=S;Q=T;H=U;A=B}else{N=R;O=S;P=U;break}}}A=c[b>>2]|0;c[20114]=1;if((A|0)<1){da=O;ea=N;ga=K;break}else{ha=1}while(1){Q=+h[f+((fa(ha,w)|0)+x+P<<3)>>3];H=ha+ -1|0;h[s+(H<<3)>>3]=Q- +h[e+(H<<3)>>3];if((ha|0)<(A|0)){ha=ha+1|0}else{break}}c[20114]=A+1;da=+h[10062];ea=+h[10066];ga=+h[10060]}else{da=L;ea=J;ga=K}}while(0);K=ga*ea-da*da;h[10111]=K;c[20212]=0;h[10119]=0.0;ha=(y<<1)+z|0;P=(y<<2)+z|0;U=(y*3|0)+z|0;H=(y*5|0)+z|0;ea=da;da=ga;ga=K;C=1;while(1){c[20212]=C;K=+h[10076]/+V(+ga);h[10091]=K;h[10114]=0.0;h[10116]=0.0;B=c[b>>2]|0;c[20114]=1;if((B|0)<1){ia=da;ja=0.0;ka=0.0}else{J=ea;L=da;N=K;D=1;la=0;while(1){ma=s+(la<<3)|0;h[ma>>3]=N*(L*+h[ma>>3]-J*+h[o+(la<<3)>>3]);ma=D+ -1|0;na=e+(ma<<3)|0;oa=+h[10114]+ +h[na>>3]*+h[o+(ma<<3)>>3];h[10114]=oa;pa=+h[10116]+ +h[na>>3]*+h[s+(ma<<3)>>3];h[10116]=pa;if((D|0)>=(B|0)){break}ma=D;J=+h[10062];L=+h[10060];N=+h[10091];D=D+1|0;la=ma}c[20114]=B+1;ia=+h[10060];ja=pa;ka=oa}N=+h[10090];L=ka*N*ka;h[10107]=L;J=ja*N*ja;h[10108]=J;h[10067]=J+(L+ia*(+h[10123]+ia*N));N=+h[10088];h[80544>>3]=N*ka*ia;h[80552>>3]=N*ja*ia;h[80560>>3]=L-J;h[80568>>3]=ka*ja;la=80576|0;c[la+0>>2]=0;c[la+4>>2]=0;c[la+8>>2]=0;c[la+12>>2]=0;c[la+16>>2]=0;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=0;c[20114]=10;la=c[d>>2]|0;c[20118]=1;if((la|0)>=1){D=1;while(1){h[10107]=0.0;h[10108]=0.0;h[10109]=0.0;A=c[b>>2]|0;c[20114]=1;if((A|0)<1){qa=0.0;ra=0.0}else{ma=D+x|0;J=0.0;L=0.0;N=0.0;na=1;while(1){K=+h[f+((fa(na,w)|0)+x+D<<3)>>3];sa=N+K*+h[o+(na+ -1<<3)>>3];h[10107]=sa;ta=f+(ma+(fa(na,w)|0)<<3)|0;ua=na+ -1|0;va=L+ +h[ta>>3]*+h[s+(ua<<3)>>3];h[10108]=va;K=J+ +h[ta>>3]*+h[e+(ua<<3)>>3];h[10109]=K;if((na|0)<(A|0)){na=na+1|0;N=sa;L=va;J=K}else{break}}c[20114]=A+1;qa=va;ra=sa}h[t+(D+ -1<<3)>>3]=+h[10113]*(ra*ra+qa*qa);h[t+(ha+D<<3)>>3]=+h[10107]*+h[10109];h[t+(U+D<<3)>>3]=+h[10108]*+h[10109];J=+h[10107];L=+h[10108];h[t+(P+D<<3)>>3]=+h[10113]*(J*J-L*L);h[t+(H+D<<3)>>3]=+h[10090]*+h[10107]*+h[10108];na=D+1|0;c[20118]=na;if((D|0)<(la|0)){D=na}else{break}}}D=c[b>>2]|0;c[20114]=1;if((D|0)>=1){la=1;while(1){B=(c[d>>2]|0)+la|0;c[20126]=B;h[t+(B+ -1<<3)>>3]=0.0;na=la+ -1|0;h[t+(ha+B<<3)>>3]=+h[o+(na<<3)>>3];h[t+(U+B<<3)>>3]=+h[s+(na<<3)>>3];h[t+(P+B<<3)>>3]=0.0;h[t+(H+B<<3)>>3]=0.0;B=la+1|0;c[20114]=B;if((la|0)<(D|0)){la=B}else{break}}}c[20122]=1;la=1;do{D=c[d>>2]|0;c[20130]=D;if((la&-2|0)==2){B=c[l>>2]|0;c[20130]=B;wa=B}else{wa=D}D=c[d>>2]|0;c[20118]=1;if((D|0)>=1){B=fa(la,y)|0;na=1;while(1){h[u+(na+z+B<<3)>>3]=0.0;if((na|0)<(D|0)){na=na+1|0}else{break}}c[20118]=D+1}na=c[20188]|0;c[20116]=1;if((na|0)<1){xa=la}else{B=1;A=la;while(1){h[10087]=0.0;ma=c[d>>2]|0;c[20118]=1;if((ma|0)<1){ya=0.0;za=A}else{ua=fa(la,y)|0;L=0.0;ta=1;while(1){J=+h[j+(ta+x+(fa(B,w)|0)<<3)>>3];Aa=L+J*+h[t+(ta+z+ua<<3)>>3];h[10087]=Aa;if((ta|0)<(ma|0)){ta=ta+1|0;L=Aa}else{break}}c[20118]=ma+1;ya=Aa;za=la}if((B|0)<(c[k>>2]|0)){L=-ya;h[10087]=L;Ba=L}else{Ba=ya}ta=c[d>>2]|0;c[20118]=1;if((ta|0)>=1){ua=fa(B,w)|0;I=fa(za,y)|0;L=Ba;Ca=1;while(1){Da=u+(Ca+z+I<<3)|0;h[Da>>3]=L*+h[j+(Ca+x+ua<<3)>>3]+ +h[Da>>3];if((Ca|0)>=(ta|0)){break}L=+h[10087];Ca=Ca+1|0}c[20118]=ta+1}Ca=B+1|0;c[20116]=Ca;if((B|0)<(na|0)){B=Ca;A=za}else{xa=za;break}}}do{if((wa|0)==(c[l>>2]|0)){A=c[d>>2]|0;c[20118]=1;if((A|0)<1){break}else{Ea=1}while(1){h[10087]=0.0;B=c[b>>2]|0;c[20116]=1;if((B|0)<1){Fa=fa(xa,y)|0;Ga=0.0}else{L=0.0;na=1;while(1){J=+h[g+((fa(na,y)|0)+z+Ea<<3)>>3];D=fa(xa,y)|0;N=L+J*+h[t+(na+z+(c[d>>2]|0)+D<<3)>>3];h[10087]=N;Ca=na+1|0;c[20116]=Ca;if((na|0)<(B|0)){na=Ca;L=N}else{Fa=D;Ga=N;break}}}na=u+(Ea+z+Fa<<3)|0;h[na>>3]=Ga+ +h[na>>3];na=Ea+1|0;c[20118]=na;if((Ea|0)<(A|0)){Ea=na}else{break}}}}while(0);A=c[b>>2]|0;c[20116]=1;if((A|0)>=1){ta=1;while(1){h[10087]=0.0;c[20114]=1;if((wa|0)<1){Ha=fa(xa,y)|0;Ia=0.0}else{na=fa(ta,y)|0;B=fa(xa,y)|0;L=0.0;D=1;while(1){Ca=D+z|0;Ja=L+ +h[g+(Ca+na<<3)>>3]*+h[t+(Ca+B<<3)>>3];h[10087]=Ja;if((D|0)<(wa|0)){D=D+1|0;L=Ja}else{break}}c[20114]=wa+1;Ha=B;Ia=Ja}h[u+((c[d>>2]|0)+z+ta+Ha<<3)>>3]=Ia;D=ta+1|0;c[20116]=D;if((ta|0)<(A|0)){ta=D}else{break}}}la=xa+1|0;c[20122]=la;}while((la|0)<6);la=c[l>>2]|0;c[20118]=1;h[10087]=0.0;c[20114]=1;L=+h[10090];if((la|0)<1){Ka=L}else{N=L;ta=1;while(1){L=0.0;A=1;do{D=(fa(A,y)|0)+z+ta|0;h[80616+(A+ -1<<3)>>3]=N*+h[u+(D<<3)>>3]*+h[t+(D<<3)>>3];L=+h[80616+(A+ -1<<3)>>3]+L;h[10087]=L;A=A+1|0;}while((A|0)<6);h[10067]=+h[10067]- +h[10077]-L;A=ta+ -1|0;D=u+(A<<3)|0;na=ha+ta|0;Ca=t+(na<<3)|0;ua=u+(na<<3)|0;na=t+(A<<3)|0;J=+h[D>>3]*+h[Ca>>3]+ +h[ua>>3]*+h[na>>3];h[10107]=J;A=P+ta|0;I=t+(A<<3)|0;ma=u+(A<<3)|0;K=+h[ua>>3]*+h[I>>3]+ +h[ma>>3]*+h[Ca>>3];h[10108]=K;A=U+ta|0;Da=u+(A<<3)|0;La=H+ta|0;Ma=t+(La<<3)|0;Na=u+(La<<3)|0;La=t+(A<<3)|0;O=+h[Da>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[La>>3];h[10109]=O;h[80544>>3]=+h[80544>>3]-J-N*(O+K);h[80576>>3]=+h[80576>>3]-N*(K-O);O=+h[D>>3]*+h[La>>3]+ +h[Da>>3]*+h[na>>3];h[10107]=O;K=+h[ua>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[Ca>>3];h[10108]=K;J=+h[Da>>3]*+h[I>>3]+ +h[ma>>3]*+h[La>>3];h[10109]=J;h[80552>>3]=+h[80552>>3]-O-N*(K-J);h[80584>>3]=+h[80584>>3]-N*(K+J);J=+h[D>>3]*+h[I>>3]+ +h[ma>>3]*+h[na>>3];h[10107]=J;h[80560>>3]=+h[80632>>3]+(+h[80560>>3]-J- +h[80624>>3]);J=+h[D>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[na>>3];h[10107]=J;K=+h[ua>>3]*+h[La>>3]+ +h[Da>>3]*+h[Ca>>3];h[10108]=K;Oa=+h[10090];h[80568>>3]=+h[80568>>3]-J-K*Oa;h[80592>>3]=+h[80592>>3]- +h[80640>>3]+ +h[80648>>3];K=+h[ma>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[I>>3];h[10107]=K;h[80600>>3]=+h[80600>>3]-Oa*K;h[10087]=0.0;if((ta|0)<(la|0)){N=Oa;ta=ta+1|0}else{break}}c[20118]=la+1;c[20114]=1;Ka=Oa}N=0.0;ta=1;do{K=+h[u+((fa(ta,y)|0)+z+(c[n>>2]|0)<<3)>>3];h[80616+(ta+ -1<<3)>>3]=Ka*K*K;N=+h[80616+(ta+ -1<<3)>>3]+N;h[10087]=N;ta=ta+1|0;c[20114]=ta;}while((ta|0)<6);K=+h[10095];h[10097]=K*+h[10067]+ +h[10077]+N;J=+h[10088];ta=c[n>>2]|0;la=u+(ta+ -1<<3)|0;I=u+(ha+ta<<3)|0;O=J*+h[la>>3]*+h[I>>3];h[10107]=O;Na=u+(P+ta<<3)|0;S=+h[I>>3]*+h[Na>>3];h[10108]=S;Ma=u+(U+ta<<3)|0;ma=u+(H+ta<<3)|0;R=+h[Ma>>3]*+h[ma>>3];h[10109]=R;T=R+(K*+h[80544>>3]+O+S);h[80784>>3]=T;O=K*+h[80576>>3]+S-R;h[80816>>3]=O;R=J*+h[la>>3]*+h[Ma>>3];h[10107]=R;S=+h[I>>3]*+h[ma>>3];h[10108]=S;Z=+h[Ma>>3]*+h[Na>>3];h[10109]=Z;h[80792>>3]=K*+h[80552>>3]+R+S-Z;h[80824>>3]=K*+h[80584>>3]+S+Z;Z=J*+h[la>>3]*+h[Na>>3];h[10107]=Z;R=+h[80624>>3]+(Z+K*+h[80560>>3])- +h[80632>>3];h[80800>>3]=R;Z=J*+h[la>>3]*+h[ma>>3];h[10107]=Z;h[80808>>3]=Z+K*+h[80568>>3]+ +h[I>>3]*+h[Ma>>3];J=K*+h[80592>>3]+ +h[80640>>3]- +h[80648>>3];h[80832>>3]=J;h[80840>>3]=+h[10095]*+h[80600>>3]+ +h[Na>>3]*+h[ma>>3];K=+h[10097]+T+R+O+J;h[10087]=K;h[10117]=K;h[10118]=K;c[20220]=0;J=+h[10115]/50.0;h[10091]=J;h[10077]=+h[10076];c[20114]=1;O=K;ma=0;R=K;T=S;S=Z;Na=1;while(1){Pa=+(Na|0)*J;Z=+X(+Pa);h[80624>>3]=Z;W=+Y(+Pa);h[80632>>3]=W;ba=W;ca=Z;G=W;W=Z;Ma=4;while(1){Z=ca*W-ba*G;h[80616+(Ma+ -1<<3)>>3]=Z;Q=+h[80624>>3]*G+ +h[80632>>3]*W;h[80616+(Ma<<3)>>3]=Q;I=Ma+2|0;if((I|0)>=9){Qa=1;Ra=0.0;break}ba=+h[80632>>3];ca=+h[80624>>3];Ma=I;W=Z;G=Q}do{Ma=Qa+ -1|0;Ra=Ra+ +h[80776+(Ma<<3)>>3]*+h[80616+(Ma<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<10);if(!(Ra>=0.0)){Sa=-Ra}else{Sa=Ra}if(!(R>=0.0)){Ta=-R}else{Ta=R}do{if(Sa>Ta){h[10118]=Ra;c[20220]=Na;h[10107]=O;Ua=Ra;Va=T;Wa=O;Xa=Na}else{if((Na|0)!=(ma+1|0)){Ua=R;Va=T;Wa=S;Xa=ma;break}h[10108]=Ra;Ua=R;Va=Ra;Wa=S;Xa=ma}}while(0);if((Na|0)>48){break}else{O=Ra;ma=Xa;R=Ua;T=Va;S=Wa;Na=Na+1|0}}c[20116]=10;h[10087]=Ra;h[10096]=Pa;h[10121]=O;c[20114]=50;if((Xa|0)==0){h[10107]=Ra;Ya=Ra;Za=Va}else if((Xa|0)==49){h[10108]=K;Ya=Wa;Za=K}else{Ya=Wa;Za=Va}h[10093]=0.0;if(Ya!=Za){S=Ya-Ua;h[10107]=S;T=Za-Ua;h[10108]=T;R=+h[10090]*(S-T)/(S+T);h[10093]=R;_a=R}else{_a=0.0}R=J*(+(Xa|0)+_a);h[10096]=R;T=+X(+R);h[80624>>3]=T;S=+Y(+R);h[80632>>3]=S;c[20116]=4;R=S;N=T;G=S;S=T;Na=4;while(1){T=N*S-R*G;h[80616+(Na+ -1<<3)>>3]=T;W=+h[80624>>3]*G+ +h[80632>>3]*S;h[80616+(Na<<3)>>3]=W;ma=Na+2|0;if((ma|0)>=9){break}R=+h[80632>>3];N=+h[80624>>3];Na=ma;S=T;G=W}h[r>>3]=0.0;h[10118]=0.0;c[20116]=1;Na=1;do{ma=Na+ -1|0;Ma=80616+(ma<<3)|0;h[r>>3]=+h[r>>3]+ +h[80536+(ma<<3)>>3]*+h[Ma>>3];h[10118]=+h[10118]+ +h[80776+(ma<<3)>>3]*+h[Ma>>3];Na=Na+1|0;}while((Na|0)<10);c[20116]=10;Na=c[l>>2]|0;c[20118]=1;if((Na|0)>=1){Ma=1;while(1){h[q+(Ma+ -1<<3)>>3]=0.0;ma=1;do{G=+h[u+((fa(ma,y)|0)+z+Ma<<3)>>3];I=q+(Ma+ -1<<3)|0;h[I>>3]=+h[I>>3]+G*+h[80616+(ma+ -1<<3)>>3];ma=ma+1|0;}while((ma|0)<6);if((Ma|0)<(Na|0)){Ma=Ma+1|0}else{break}}c[20116]=6;c[20118]=Na+1}h[10086]=+h[q+((c[n>>2]|0)+ -1<<3)>>3];h[10060]=0.0;h[10107]=0.0;h[10108]=0.0;Ma=c[b>>2]|0;c[20114]=1;if((Ma|0)<1){$a=0.0;ab=0.0}else{ma=1;while(1){I=ma+ -1|0;la=o+(I<<3)|0;h[la>>3]=+h[80624>>3]*+h[la>>3]+ +h[80632>>3]*+h[s+(I<<3)>>3];I=ma+ -1|0;la=o+(I<<3)|0;ta=p+(I<<3)|0;h[ta>>3]=+h[e+(I<<3)>>3]+ +h[la>>3];G=+h[la>>3];h[10060]=+h[10060]+G*G;bb=+h[10107]+ +h[la>>3]*+h[ta>>3];h[10107]=bb;G=+h[ta>>3];cb=+h[10108]+G*G;h[10108]=cb;if((ma|0)<(Ma|0)){ma=ma+1|0}else{break}}c[20114]=Ma+1;$a=cb;ab=bb}ma=c[20212]|0;Na=c[b>>2]|0;if((ma|0)>=(Na|0)){break}if((ma|0)>1){G=+h[10119];S=+h[10117];h[10119]=G>=S?G:S}S=+h[10118];if(!(S>=0.0)){db=-S}else{db=S}G=+h[10119];if(!(G>=0.0)){eb=-G}else{eb=G}if(db<=eb*1.1){break}h[10119]=S;c[20114]=1;b:do{if((Na|0)>=1){S=$a;G=ab;ta=1;while(1){la=ta+ -1|0;N=G*+h[e+(la<<3)>>3]+S*+h[o+(la<<3)>>3]- +h[q+(la+(c[d>>2]|0)<<3)>>3];h[10091]=N;R=+h[10086]*+h[g+((c[n>>2]|0)+z+(fa(ta,y)|0)<<3)>>3];h[s+(la<<3)>>3]=R+N*+h[10095];la=ta+1|0;c[20114]=la;if((ta|0)>=(Na|0)){break b}S=+h[10108];G=+h[10107];ta=la}}}while(0);Na=c[d>>2]|0;c[20118]=1;if((Na|0)>=1){Ma=1;while(1){h[10087]=0.0;ta=c[b>>2]|0;c[20116]=1;if((ta|0)<1){fb=0.0}else{G=0.0;la=1;while(1){S=+h[f+((fa(la,w)|0)+x+Ma<<3)>>3];gb=G+S*+h[p+(la+ -1<<3)>>3];h[10087]=gb;if((la|0)<(ta|0)){la=la+1|0;G=gb}else{break}}c[20116]=ta+1;fb=gb}la=c[b>>2]|0;G=fb*(+h[10086]*+h[p+(la+ -1+Ma<<3)>>3]- +h[10095]*+h[q+(Ma+ -1<<3)>>3]);h[10091]=G;c[20114]=1;if((la|0)>=1){S=G;I=1;while(1){G=S*+h[f+((fa(I,w)|0)+x+Ma<<3)>>3];Ca=s+(I+ -1<<3)|0;h[Ca>>3]=+h[Ca>>3]+G;if((I|0)>=(la|0)){break}S=+h[10091];I=I+1|0}c[20114]=la+1}I=Ma+1|0;c[20118]=I;if((Ma|0)<(Na|0)){Ma=I}else{break}}}h[10066]=0.0;h[10062]=0.0;Ma=c[b>>2]|0;c[20114]=1;if((Ma|0)<1){hb=0.0;ib=0.0}else{S=0.0;G=0.0;Na=1;while(1){N=+h[s+(Na+ -1<<3)>>3];jb=G+N*N;h[10066]=jb;I=Na+ -1|0;kb=S+ +h[o+(I<<3)>>3]*+h[s+(I<<3)>>3];h[10062]=kb;if((Na|0)<(Ma|0)){Na=Na+1|0;G=jb;S=kb}else{break}}c[20114]=Ma+1;hb=kb;ib=jb}S=+h[10060];G=S*ib-hb*hb;h[10111]=G;if(!(G>=S*1.0e-8*ib)){break}ea=hb;da=S;ga=G;C=ma+1|0}a[80512]=1;C=c[l>>2]|0;c[20118]=1;if((C|0)<1){lb=80608;mb=+h[10076];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}else{vb=1}while(1){h[p+(vb+ -1<<3)>>3]=0.0;l=1;do{ga=+h[t+((fa(l,y)|0)+z+vb<<3)>>3];s=p+(vb+ -1<<3)|0;h[s>>3]=+h[s>>3]+ga*+h[80616+(l+ -1<<3)>>3];l=l+1|0;}while((l|0)<6);if((vb|0)<(C|0)){vb=vb+1|0}else{break}}c[20116]=6;c[20118]=C+1;lb=80608;mb=+h[10076];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}



function eqa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;qqa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Nma(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ae[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ae[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}Nma(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}Nma(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=ae[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((mqa(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){ae[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=eva(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;Asa(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=ae[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=ae[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;Ema(n);Ema(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;Ema(n);Ema(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;Ema(n);Ema(m);i=d;return}function fqa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];gqa(a,0,k,j,f,g,h);i=b;return}function gqa(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;rqa(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Nma(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=ae[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=ae[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}Nma(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}Nma(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=ae[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((sqa(T,t,u,R,p,B,l,n,h,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){ae[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);g[k>>2]=+dva(L,c[p>>2]|0,j);Asa(n,h,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=ae[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=ae[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;Ema(o);Ema(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;Ema(o);Ema(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;Ema(o);Ema(n);i=d;return}function hqa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];iqa(a,0,k,j,f,g,h);i=b;return}function iqa(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;rqa(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Nma(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=ae[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=ae[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}Nma(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}Nma(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=ae[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((sqa(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){ae[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+cva(L,c[p>>2]|0,j);Asa(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=ae[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=ae[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;Ema(o);Ema(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;Ema(o);Ema(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;Ema(o);Ema(n);i=d;return}function jqa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];kqa(a,0,k,j,f,g,h);i=b;return}function kqa(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;rqa(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Nma(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=ae[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=ae[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}Nma(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}Nma(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=ae[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((sqa(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){ae[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+bva(L,c[p>>2]|0,j);Asa(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=ae[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=ae[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;Ema(o);Ema(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;Ema(o);Ema(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;Ema(o);Ema(n);i=d;return}function lqa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+104|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Ana(o,g);g=o;o=c[g>>2]|0;if(!((c[36306]|0)==-1)){c[l>>2]=145224;c[l+4>>2]=964;c[l+8>>2]=0;pma(145224,l,965)}l=(c[145228>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Dc(4)|0;w=v;owa(w);x=160792;y=127;Ld(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Dc(4)|0;w=v;owa(w);x=160792;y=127;Ld(v|0,x|0,y|0)}y=m;ze[c[(c[o>>2]|0)+48>>2]&63](o,143776,143802|0,y)|0;Wla(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Nma(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0;D=1}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){E=ae[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{E=c[B>>2]|0}if(!((E|0)==-1)){C=m;D=0;break}c[r>>2]=0;C=0;D=1}}while(0);B=c[e>>2]|0;do{if((B|0)==0){F=22}else{v=c[B+12>>2]|0;if((v|0)==(c[B+16>>2]|0)){G=ae[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{G=c[v>>2]|0}if((G|0)==-1){c[e>>2]=0;F=22;break}else{if(D){break}else{H=x;break a}}}}while(0);if((F|0)==22){F=0;if(D){H=x;break}}B=a[p]|0;v=(B&1)==0;if(v){I=(B&255)>>>1}else{I=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(I|0)){if(v){J=(B&255)>>>1;K=(B&255)>>>1}else{B=c[o>>2]|0;J=B;K=B}Nma(p,K<<1,0);if((a[p]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}Nma(p,L,0);if((a[p]&1)==0){M=z}else{M=c[A>>2]|0}c[q>>2]=M+J;N=M}else{N=x}B=C+12|0;v=c[B>>2]|0;w=C+16|0;if((v|0)==(c[w>>2]|0)){O=ae[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{O=c[v>>2]|0}if((mqa(O,16,N,q,t,0,n,g,s,y)|0)!=0){H=N;break}v=c[B>>2]|0;if((v|0)==(c[w>>2]|0)){ae[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=N;continue}else{c[B>>2]=v+4;m=C;x=N;continue}}a[H+3|0]=0;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);N=c[36280]|0;c[k>>2]=j;if((Qpa(H,N,143816,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){P=0;Q=1}else{N=c[k+12>>2]|0;if((N|0)==(c[k+16>>2]|0)){R=ae[c[(c[k>>2]|0)+36>>2]&127](k)|0}else{R=c[N>>2]|0}if(!((R|0)==-1)){P=k;Q=0;break}c[r>>2]=0;P=0;Q=1}}while(0);r=c[e>>2]|0;do{if((r|0)==0){F=60}else{k=c[r+12>>2]|0;if((k|0)==(c[r+16>>2]|0)){S=ae[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{S=c[k>>2]|0}if((S|0)==-1){c[e>>2]=0;F=60;break}if(!Q){break}T=b;U=T;c[U>>2]=P;Ema(p);Ema(n);i=d;return}}while(0);do{if((F|0)==60){if(Q){break}T=b;U=T;c[U>>2]=P;Ema(p);Ema(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;T=b;U=T;c[U>>2]=P;Ema(p);Ema(n);i=d;return}function mqa(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(c[m+96>>2]|0)==(b|0);if(!q){if((c[m+100>>2]|0)!=(b|0)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&(b|0)==(h|0)){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+104|0;h=m;while(1){l=h+4|0;if((c[h>>2]|0)==(b|0)){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;m=h>>2;if((h|0)>92){r=-1;i=n;return r|0}do{if((d|0)==16){if((h|0)<88){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;t=a[143776+m|0]|0;c[f>>2]=o+1;a[o]=t;r=0;i=n;return r|0}else if((d|0)==10|(d|0)==8){if((m|0)<(d|0)){break}else{r=-1}i=n;return r|0}}while(0);d=a[143776+m|0]|0;c[f>>2]=o+1;a[o]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function nqa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;Ana(k,d);d=k;k=c[d>>2]|0;if(!((c[36308]|0)==-1)){c[j>>2]=145232;c[j+4>>2]=964;c[j+8>>2]=0;pma(145232,j,965)}j=(c[145236>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Dc(4)|0;n=m;owa(n);o=160792;p=127;Ld(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Dc(4)|0;n=m;owa(n);o=160792;p=127;Ld(m|0,o|0,p|0)}ze[c[(c[k>>2]|0)+32>>2]&63](k,143776,143802|0,e)|0;e=c[d>>2]|0;if(!((c[36344]|0)==-1)){c[h>>2]=145376;c[h+4>>2]=964;c[h+8>>2]=0;pma(145376,h,965)}h=(c[145380>>2]|0)+ -1|0;k=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-k>>2>>>0>h>>>0)){q=Dc(4)|0;r=q;owa(r);s=160792;t=127;Ld(q|0,s|0,t|0)}e=c[k+(h<<2)>>2]|0;if((e|0)==0){q=Dc(4)|0;r=q;owa(r);s=160792;t=127;Ld(q|0,s|0,t|0)}else{t=e;a[f]=ae[c[(c[e>>2]|0)+16>>2]&127](t)|0;_d[c[(c[e>>2]|0)+20>>2]&127](b,t);Wla(c[d>>2]|0)|0;i=g;return}}function oqa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h;k=h+16|0;l=h+32|0;Ana(l,d);d=l;l=c[d>>2]|0;if(!((c[36308]|0)==-1)){c[k>>2]=145232;c[k+4>>2]=964;c[k+8>>2]=0;pma(145232,k,965)}k=(c[145236>>2]|0)+ -1|0;m=c[l+8>>2]|0;if(!((c[l+12>>2]|0)-m>>2>>>0>k>>>0)){n=Dc(4)|0;o=n;owa(o);p=160792;q=127;Ld(n|0,p|0,q|0)}l=c[m+(k<<2)>>2]|0;if((l|0)==0){n=Dc(4)|0;o=n;owa(o);p=160792;q=127;Ld(n|0,p|0,q|0)}ze[c[(c[l>>2]|0)+32>>2]&63](l,143776,143808|0,e)|0;e=c[d>>2]|0;if(!((c[36344]|0)==-1)){c[j>>2]=145376;c[j+4>>2]=964;c[j+8>>2]=0;pma(145376,j,965)}j=(c[145380>>2]|0)+ -1|0;l=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-l>>2>>>0>j>>>0)){r=Dc(4)|0;s=r;owa(s);t=160792;u=127;Ld(r|0,t|0,u|0)}e=c[l+(j<<2)>>2]|0;if((e|0)==0){r=Dc(4)|0;s=r;owa(s);t=160792;u=127;Ld(r|0,t|0,u|0)}else{u=e;a[f]=ae[c[(c[e>>2]|0)+12>>2]&127](u)|0;a[g]=ae[c[(c[e>>2]|0)+16>>2]&127](u)|0;_d[c[(c[e>>2]|0)+20>>2]&127](b,u);Wla(c[d>>2]|0)|0;i=h;return}}function pqa(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if(b<<24>>24==h<<24>>24){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if(b<<24>>24==j<<24>>24){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+32|0;j=o;while(1){r=j+1|0;if((a[j]|0)==b<<24>>24){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;if((j|0)>31){q=-1;i=p;return q|0}o=a[143776+j|0]|0;if((j|0)==23|(j|0)==22){a[e]=80;t=c[g>>2]|0;c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else if((j|0)==24|(j|0)==25){t=c[g>>2]|0;do{if((t|0)!=(f|0)){if((a[t+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else{t=a[e]|0;do{if((o&95|0)==(t<<24>>24|0)){a[e]=t|-128;if((a[d]|0)==0){break}a[d]=0;f=a[k]|0;if((f&1)==0){u=(f&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}f=c[m>>2]|0;if((f-l|0)>=160){break}s=c[n>>2]|0;c[m>>2]=f+4;c[f>>2]=s}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=o;if((j|0)>21){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}return 0}function qqa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+40|0;g=f;h=f+16|0;j=f+32|0;Ana(j,b);b=j;j=c[b>>2]|0;if(!((c[36306]|0)==-1)){c[h>>2]=145224;c[h+4>>2]=964;c[h+8>>2]=0;pma(145224,h,965)}h=(c[145228>>2]|0)+ -1|0;k=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-k>>2>>>0>h>>>0)){l=Dc(4)|0;m=l;owa(m);n=160792;o=127;Ld(l|0,n|0,o|0)}j=c[k+(h<<2)>>2]|0;if((j|0)==0){l=Dc(4)|0;m=l;owa(m);n=160792;o=127;Ld(l|0,n|0,o|0)}ze[c[(c[j>>2]|0)+48>>2]&63](j,143776,143802|0,d)|0;d=c[b>>2]|0;if(!((c[36346]|0)==-1)){c[g>>2]=145384;c[g+4>>2]=964;c[g+8>>2]=0;pma(145384,g,965)}g=(c[145388>>2]|0)+ -1|0;j=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-j>>2>>>0>g>>>0)){p=Dc(4)|0;q=p;owa(q);r=160792;s=127;Ld(p|0,r|0,s|0)}d=c[j+(g<<2)>>2]|0;if((d|0)==0){p=Dc(4)|0;q=p;owa(q);r=160792;s=127;Ld(p|0,r|0,s|0)}else{s=d;c[e>>2]=ae[c[(c[d>>2]|0)+16>>2]&127](s)|0;_d[c[(c[d>>2]|0)+20>>2]&127](a,s);Wla(c[b>>2]|0)|0;i=f;return}}function rqa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;Ana(k,b);b=k;k=c[b>>2]|0;if(!((c[36306]|0)==-1)){c[j>>2]=145224;c[j+4>>2]=964;c[j+8>>2]=0;pma(145224,j,965)}j=(c[145228>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Dc(4)|0;n=m;owa(n);o=160792;p=127;Ld(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Dc(4)|0;n=m;owa(n);o=160792;p=127;Ld(m|0,o|0,p|0)}ze[c[(c[k>>2]|0)+48>>2]&63](k,143776,143808|0,d)|0;d=c[b>>2]|0;if(!((c[36346]|0)==-1)){c[h>>2]=145384;c[h+4>>2]=964;c[h+8>>2]=0;pma(145384,h,965)}h=(c[145388>>2]|0)+ -1|0;k=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-k>>2>>>0>h>>>0)){q=Dc(4)|0;r=q;owa(r);s=160792;t=127;Ld(q|0,s|0,t|0)}d=c[k+(h<<2)>>2]|0;if((d|0)==0){q=Dc(4)|0;r=q;owa(r);s=160792;t=127;Ld(q|0,s|0,t|0)}else{t=d;c[e>>2]=ae[c[(c[d>>2]|0)+12>>2]&127](t)|0;c[f>>2]=ae[c[(c[d>>2]|0)+16>>2]&127](t)|0;_d[c[(c[d>>2]|0)+20>>2]&127](a,t);Wla(c[b>>2]|0)|0;i=g;return}}function sqa(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if((b|0)==(h|0)){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if((b|0)==(j|0)){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+128|0;j=o;while(1){r=j+4|0;if((c[j>>2]|0)==(b|0)){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;o=j>>2;if((j|0)>124){q=-1;i=p;return q|0}t=a[143776+o|0]|0;do{if((o|0)==24|(o|0)==25){s=c[g>>2]|0;do{if((s|0)!=(f|0)){if((a[s+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=s+1;a[s]=t;q=0;i=p;return q|0}else if((o|0)==23|(o|0)==22){a[e]=80}else{b=a[e]|0;if((t&95|0)!=(b<<24>>24|0)){break}a[e]=b|-128;if((a[d]|0)==0){break}a[d]=0;b=a[k]|0;if((b&1)==0){u=(b&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}b=c[m>>2]|0;if((b-l|0)>=160){break}r=c[n>>2]|0;c[m>>2]=b+4;c[b>>2]=r}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=t;if((j|0)>84){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}function tqa(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function uqa(a){a=a|0;i=i;return}function vqa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];je[p&31](b,d,k,f,g,q);i=j;return}Ana(n,f);f=n;n=c[f>>2]|0;if(!((c[36344]|0)==-1)){c[l>>2]=145376;c[l+4>>2]=964;c[l+8>>2]=0;pma(145376,l,965)}l=(c[145380>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Dc(4)|0;u=t;owa(u);v=160792;w=127;Ld(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Dc(4)|0;u=t;owa(u);v=160792;w=127;Ld(t|0,v|0,w|0)}w=n;Wla(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){_d[c[f+24>>2]&127](o,w)}else{_d[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+1|0;x=f;y=f;z=o+8|0}else{f=o+8|0;x=c[f>>2]|0;y=o+1|0;z=f}f=e;e=o+4|0;h=w;w=x;while(1){if((h&1)==0){A=y;B=(h&255)>>>1}else{A=c[z>>2]|0;B=c[e>>2]|0}if((w|0)==(A+B|0)){break}x=a[w]|0;n=c[f>>2]|0;do{if((n|0)!=0){v=n+24|0;t=c[v>>2]|0;if((t|0)!=(c[n+28>>2]|0)){c[v>>2]=t+1;a[t]=x;break}if(!((pe[c[(c[n>>2]|0)+52>>2]&63](n,x&255)|0)==-1)){break}c[f>>2]=0}}while(0);h=a[o]|0;w=w+1|0}c[b>>2]=c[f>>2];Ema(o);i=j;return}function wqa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=144024;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=100}}while(0);w=m;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);x=c[36280]|0;c[k>>2]=h;h=xqa(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;Ana(q,f);yqa(w,y,k,z,o,p,q);Wla(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];bja(b,j,z,e,o,f,g);i=d;return}function xqa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;f=Kc(d|0)|0;d=mc(a|0,b|0,e|0,h|0)|0;if((f|0)==0){i=g;return d|0}Kc(f|0)|0;i=g;return d|0}function yqa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[36308]|0)==-1)){c[m>>2]=145232;c[m+4>>2]=964;c[m+8>>2]=0;pma(145232,m,965)}m=(c[145236>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Dc(4)|0;r=q;owa(r);s=160792;t=127;Ld(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Dc(4)|0;r=q;owa(r);s=160792;t=127;Ld(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[36344]|0)==-1)){c[l>>2]=145376;c[l+4>>2]=964;c[l+8>>2]=0;pma(145376,l,965)}l=(c[145380>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Dc(4)|0;v=u;owa(v);w=160792;x=127;Ld(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Dc(4)|0;v=u;owa(v);w=160792;x=127;Ld(u|0,w|0,x|0)}x=s;_d[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){ze[c[(c[j>>2]|0)+32>>2]&63](t,b,e,f)|0;c[h>>2]=f+(e-b)}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=pe[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;z=b+1|0}else{z=b}do{if((e-z|0)>1){if((a[z]|0)!=48){A=z;break}u=z+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){A=z;break}w=pe[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+1;a[v]=w;w=pe[c[(c[j>>2]|0)+28>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+1;a[u]=w;A=z+2|0}else{A=z}}while(0);do{if((A|0)!=(e|0)){w=e+ -1|0;if(w>>>0>A>>>0){B=A;C=w}else{break}do{w=a[B]|0;a[B]=a[C]|0;a[C]=w;B=B+1|0;C=C+ -1|0;}while(B>>>0<C>>>0)}}while(0);w=ae[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(A>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=A;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){D=o;E=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){D=o;E=q;break}p=c[h>>2]|0;c[h>>2]=p+1;a[p]=w;p=a[n]|0;if((p&1)==0){F=(p&255)>>>1}else{F=c[v>>2]|0}D=0;E=(q>>>0<(F+ -1|0)>>>0)+q|0}}while(0);m=pe[c[(c[j>>2]|0)+28>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=m;m=r+1|0;if(m>>>0<e>>>0){o=D+1|0;q=E;r=m}else{break}}}r=f+(A-b)|0;q=c[h>>2]|0;if((r|0)==(q|0)){break}o=q+ -1|0;if(o>>>0>r>>>0){G=r;H=o}else{break}do{o=a[G]|0;a[G]=a[H]|0;a[H]=o;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);if((d|0)==(e|0)){I=c[h>>2]|0;c[g>>2]=I;Ema(n);i=k;return}else{I=f+(d-b)|0;c[g>>2]=I;Ema(n);i=k;return}}function zqa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=100}}while(0);x=n;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);w=c[36280]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=xqa(x,22,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;Ana(r,f);yqa(x,z,l,A,p,q,r);Wla(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];bja(b,k,A,e,p,f,g);i=d;return}function Aqa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=144024;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=117}}while(0);w=m;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);x=c[36280]|0;c[k>>2]=h;h=xqa(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;Ana(q,f);yqa(w,y,k,z,o,p,q);Wla(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];bja(b,j,z,e,o,f,g);i=d;return}function Bqa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=117}}while(0);x=n;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);w=c[36280]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=xqa(x,23,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;Ana(r,f);yqa(x,z,l,A,p,q,r);Wla(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];bja(b,k,A,e,p,f,g);i=d;return}function Cqa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);r=c[36280]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=xqa(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=xqa(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[145128]|0)==0;if(F){do{if(o){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);r=c[36280]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=Dqa(s,r,z,n)|0}else{do{if(o){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);o=c[36280]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=Dqa(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}Wwa()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=Jwa(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}Wwa()}}while(0);Ana(w,f);Eqa(N,L,G,P,u,v,w);Wla(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];bja(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){Kwa(O)}if((J|0)==0){i=d;return}Kwa(J);i=d;return}function Dqa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Kc(b|0)|0;b=jc(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Kc(e|0)|0;i=f;return b|0}function Eqa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[36308]|0)==-1)){c[m>>2]=145232;c[m+4>>2]=964;c[m+8>>2]=0;pma(145232,m,965)}m=(c[145236>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Dc(4)|0;r=q;owa(r);s=160792;t=127;Ld(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Dc(4)|0;r=q;owa(r);s=160792;t=127;Ld(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[36344]|0)==-1)){c[l>>2]=145376;c[l+4>>2]=964;c[l+8>>2]=0;pma(145376,l,965)}l=(c[145380>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Dc(4)|0;v=u;owa(v);w=160792;x=127;Ld(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Dc(4)|0;v=u;owa(v);w=160792;x=127;Ld(u|0,w|0,x|0)}x=s;_d[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=pe[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=pe[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+1;a[l]=v;v=y+2|0;l=pe[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);w=A+1|0;if((Vc(l<<24>>24|0,c[36280]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);l=D+1|0;if((Nd(A<<24>>24|0,c[36280]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){ze[c[(c[j>>2]|0)+32>>2]&63](t,B,C,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(C-B)}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){F=B;G=y}else{break}do{y=a[F]|0;a[F]=a[G]|0;a[G]=y;F=F+1|0;G=G+ -1|0;}while(F>>>0<G>>>0)}}while(0);A=ae[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){H=l;I=v;break}q=c[h>>2]|0;c[h>>2]=q+1;a[q]=A;q=a[n]|0;if((q&1)==0){J=(q&255)>>>1}else{J=c[D>>2]|0}H=0;I=(v>>>0<(J+ -1|0)>>>0)+v|0}else{H=l;I=v}}while(0);o=pe[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q]=o;o=w+1|0;if(o>>>0<C>>>0){l=H+1|0;v=I;w=o}else{break}}}w=f+(B-b)|0;v=c[h>>2]|0;if((w|0)==(v|0)){break}l=v+ -1|0;if(l>>>0>w>>>0){K=w;L=l}else{break}do{l=a[K]|0;a[K]=a[L]|0;a[L]=l;K=K+1|0;L=L+ -1|0;}while(K>>>0<L>>>0)}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){K=a[L]|0;if(K<<24>>24==46){break}B=pe[c[(c[j>>2]|0)+28>>2]&63](t,K)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;B=L+1|0;if(B>>>0<e>>>0){L=B}else{M=B;break c}}B=ae[c[(c[s>>2]|0)+12>>2]&127](x)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;M=L+1|0}else{M=C}}while(0);ze[c[(c[j>>2]|0)+32>>2]&63](t,M,e,c[h>>2]|0)|0;t=(c[h>>2]|0)+(u-M)|0;c[h>>2]=t;if((d|0)==(e|0)){N=t;c[g>>2]=N;Ema(n);i=k;return}N=f+(d-b)|0;c[g>>2]=N;Ema(n);i=k;return}function Fqa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);r=c[36280]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=xqa(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=xqa(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[145128]|0)==0;if(F){do{if(o){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);r=c[36280]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=Dqa(s,r,z,n)|0}else{do{if(o){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);o=c[36280]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=Dqa(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}Wwa()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=Jwa(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}Wwa()}}while(0);Ana(w,f);Eqa(N,L,G,P,u,v,w);Wla(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];bja(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){Kwa(O)}if((J|0)==0){i=d;return}Kwa(J);i=d;return}function Gqa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+40|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=144032;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);s=c[36280]|0;c[k>>2]=h;h=xqa(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else if((r|0)==32){t=k}else{u=10}}while(0);if((u|0)==10){t=m}u=o;Ana(p,f);r=p;p=c[r>>2]|0;if(!((c[36308]|0)==-1)){c[l>>2]=145232;c[l+4>>2]=964;c[l+8>>2]=0;pma(145232,l,965)}l=(c[145236>>2]|0)+ -1|0;s=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-s>>2>>>0>l>>>0)){v=Dc(4)|0;w=v;owa(w);x=160792;y=127;Ld(v|0,x|0,y|0)}p=c[s+(l<<2)>>2]|0;if((p|0)==0){v=Dc(4)|0;w=v;owa(w);x=160792;y=127;Ld(v|0,x|0,y|0)}Wla(c[r>>2]|0)|0;ze[c[(c[p>>2]|0)+32>>2]&63](p,m,k,u)|0;m=o+h|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];bja(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];bja(b,j,u,z,m,f,g);I=j;i=d;return}function Hqa(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function Iqa(a){a=a|0;i=i;return}function Jqa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];je[p&31](b,d,k,f,g,q);i=j;return}Ana(n,f);f=n;n=c[f>>2]|0;if(!((c[36346]|0)==-1)){c[l>>2]=145384;c[l+4>>2]=964;c[l+8>>2]=0;pma(145384,l,965)}l=(c[145388>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Dc(4)|0;u=t;owa(u);v=160792;w=127;Ld(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Dc(4)|0;u=t;owa(u);v=160792;w=127;Ld(t|0,v|0,w|0)}w=n;Wla(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){_d[c[f+24>>2]&127](o,w)}else{_d[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+4|0;x=f;y=o+8|0;z=f}else{f=o+8|0;x=c[f>>2]|0;y=f;z=o+4|0}f=e;e=w;w=x;while(1){if((e&1)==0){A=z;B=(e&255)>>>1}else{A=c[y>>2]|0;B=c[z>>2]|0}if((w|0)==(A+(B<<2)|0)){break}x=c[w>>2]|0;h=c[f>>2]|0;do{if((h|0)!=0){n=h+24|0;v=c[n>>2]|0;if((v|0)==(c[h+28>>2]|0)){C=pe[c[(c[h>>2]|0)+52>>2]&63](h,x)|0}else{c[n>>2]=v+4;c[v>>2]=x;C=x}if(!((C|0)==-1)){break}c[f>>2]=0}}while(0);e=a[o]|0;w=w+4|0}c[b>>2]=c[f>>2];gna(o);i=j;return}function Kqa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=144024;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=100}}while(0);w=m;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);x=c[36280]|0;c[k>>2]=h;h=xqa(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;Ana(q,f);Lqa(w,y,k,z,o,p,q);Wla(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];Mqa(b,j,z,e,o,f,g);i=d;return}function Lqa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[36306]|0)==-1)){c[m>>2]=145224;c[m+4>>2]=964;c[m+8>>2]=0;pma(145224,m,965)}m=(c[145228>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Dc(4)|0;r=q;owa(r);s=160792;t=127;Ld(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Dc(4)|0;r=q;owa(r);s=160792;t=127;Ld(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[36346]|0)==-1)){c[l>>2]=145384;c[l+4>>2]=964;c[l+8>>2]=0;pma(145384,l,965)}l=(c[145388>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Dc(4)|0;v=u;owa(v);w=160792;x=127;Ld(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Dc(4)|0;v=u;owa(v);w=160792;x=127;Ld(u|0,w|0,x|0)}x=s;_d[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){ze[c[(c[j>>2]|0)+48>>2]&63](t,b,e,f)|0;w=f+(e-b<<2)|0;c[h>>2]=w;z=w}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=pe[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;A=b+1|0}else{A=b}do{if((e-A|0)>1){if((a[A]|0)!=48){B=A;break}u=A+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){B=A;break}w=pe[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=w;w=pe[c[(c[j>>2]|0)+44>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=w;B=A+2|0}else{B=A}}while(0);do{if((B|0)!=(e|0)){w=e+ -1|0;if(w>>>0>B>>>0){C=B;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D+ -1|0;}while(C>>>0<D>>>0)}}while(0);w=ae[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=B;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){E=o;F=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){E=o;F=q;break}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=w;p=a[n]|0;if((p&1)==0){G=(p&255)>>>1}else{G=c[v>>2]|0}E=0;F=(q>>>0<(G+ -1|0)>>>0)+q|0}}while(0);m=pe[c[(c[j>>2]|0)+44>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;H=p+4|0;c[h>>2]=H;c[p>>2]=m;m=r+1|0;if(m>>>0<e>>>0){o=E+1|0;q=F;r=m}else{I=H;break}}}else{I=c[h>>2]|0}r=f+(B-b<<2)|0;if((r|0)==(I|0)){z=I;break}q=I+ -4|0;if(q>>>0>r>>>0){J=r;K=q}else{z=I;break}while(1){q=c[J>>2]|0;c[J>>2]=c[K>>2];c[K>>2]=q;q=J+4|0;r=K+ -4|0;if(q>>>0<r>>>0){K=r;J=q}else{z=I;break}}}}while(0);if((d|0)==(e|0)){L=z;c[g>>2]=L;Ema(n);i=k;return}L=f+(d-b<<2)|0;c[g>>2]=L;Ema(n);i=k;return}function Mqa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=d;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if((de[c[(c[d>>2]|0)+48>>2]&63](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){fna(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}if((de[c[(c[d>>2]|0)+48>>2]&63](d,r,q)|0)==(q|0)){gna(l);break}c[m>>2]=0;c[b>>2]=0;gna(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if((de[c[(c[d>>2]|0)+48>>2]&63](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function Nqa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+168|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);y=c[36280]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=xqa(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;Ana(r,f);Lqa(x,z,l,A,p,q,r);Wla(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];Mqa(b,k,A,e,p,f,g);i=d;return}function Oqa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=144024;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);v=c[36280]|0;c[k>>2]=h;h=xqa(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;Ana(q,f);Lqa(w,y,k,z,o,p,q);Wla(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];Mqa(b,j,z,e,o,f,g);i=d;return}function Pqa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+176|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);y=c[36280]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=xqa(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;Ana(r,f);Lqa(x,z,l,A,p,q,r);Wla(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];Mqa(b,k,A,e,p,f,g);i=d;return}function Qqa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);r=c[36280]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=xqa(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=xqa(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[145128]|0)==0;if(F){do{if(o){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);r=c[36280]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=Dqa(s,r,z,n)|0}else{do{if(o){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);o=c[36280]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=Dqa(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}Wwa()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=Jwa(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}Wwa()}}while(0);Ana(w,f);Rqa(N,L,G,P,u,v,w);Wla(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];Mqa(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){Kwa(O)}if((J|0)==0){i=d;return}Kwa(J);i=d;return}function Rqa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[36306]|0)==-1)){c[m>>2]=145224;c[m+4>>2]=964;c[m+8>>2]=0;pma(145224,m,965)}m=(c[145228>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Dc(4)|0;r=q;owa(r);s=160792;t=127;Ld(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Dc(4)|0;r=q;owa(r);s=160792;t=127;Ld(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[36346]|0)==-1)){c[l>>2]=145384;c[l+4>>2]=964;c[l+8>>2]=0;pma(145384,l,965)}l=(c[145388>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Dc(4)|0;v=u;owa(v);w=160792;x=127;Ld(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Dc(4)|0;v=u;owa(v);w=160792;x=127;Ld(u|0,w|0,x|0)}x=s;_d[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=pe[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=pe[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=v;v=y+2|0;l=pe[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);w=A+1|0;if((Vc(l<<24>>24|0,c[36280]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);l=D+1|0;if((Nd(A<<24>>24|0,c[36280]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){ze[c[(c[j>>2]|0)+48>>2]&63](t,B,C,c[h>>2]|0)|0;y=(c[h>>2]|0)+(C-B<<2)|0;c[h>>2]=y;F=y}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){G=B;H=y}else{break}do{y=a[G]|0;a[G]=a[H]|0;a[H]=y;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);A=ae[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){I=l;J=v;break}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=A;q=a[n]|0;if((q&1)==0){K=(q&255)>>>1}else{K=c[D>>2]|0}I=0;J=(v>>>0<(K+ -1|0)>>>0)+v|0}else{I=l;J=v}}while(0);o=pe[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;r=q+4|0;c[h>>2]=r;c[q>>2]=o;o=w+1|0;if(o>>>0<C>>>0){l=I+1|0;v=J;w=o}else{L=r;break}}}else{L=c[h>>2]|0}w=f+(B-b<<2)|0;if((w|0)==(L|0)){F=L;break}v=L+ -4|0;if(v>>>0>w>>>0){M=w;N=v}else{F=L;break}while(1){v=c[M>>2]|0;c[M>>2]=c[N>>2];c[N>>2]=v;v=M+4|0;w=N+ -4|0;if(v>>>0<w>>>0){N=w;M=v}else{F=L;break}}}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){M=a[L]|0;if(M<<24>>24==46){break}N=pe[c[(c[j>>2]|0)+44>>2]&63](t,M)|0;M=c[h>>2]|0;B=M+4|0;c[h>>2]=B;c[M>>2]=N;N=L+1|0;if(N>>>0<e>>>0){L=N}else{O=B;P=N;break c}}N=ae[c[(c[s>>2]|0)+12>>2]&127](x)|0;B=c[h>>2]|0;M=B+4|0;c[h>>2]=M;c[B>>2]=N;O=M;P=L+1|0}else{O=F;P=C}}while(0);ze[c[(c[j>>2]|0)+48>>2]&63](t,P,e,O)|0;O=(c[h>>2]|0)+(u-P<<2)|0;c[h>>2]=O;if((d|0)==(e|0)){Q=O;c[g>>2]=Q;Ema(n);i=k;return}Q=f+(d-b<<2)|0;c[g>>2]=Q;Ema(n);i=k;return}function Sqa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);r=c[36280]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=xqa(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=xqa(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[145128]|0)==0;if(F){do{if(o){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);r=c[36280]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=Dqa(s,r,z,n)|0}else{do{if(o){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);o=c[36280]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=Dqa(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}Wwa()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=Jwa(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}Wwa()}}while(0);Ana(w,f);Rqa(N,L,G,P,u,v,w);Wla(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];Mqa(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){Kwa(O)}if((J|0)==0){i=d;return}Kwa(J);i=d;return}function Tqa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+152|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=144032;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);s=c[36280]|0;c[k>>2]=h;h=xqa(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else if((r|0)==32){t=k}else{u=10}}while(0);if((u|0)==10){t=m}Ana(p,f);u=p;p=c[u>>2]|0;if(!((c[36306]|0)==-1)){c[l>>2]=145224;c[l+4>>2]=964;c[l+8>>2]=0;pma(145224,l,965)}l=(c[145228>>2]|0)+ -1|0;r=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-r>>2>>>0>l>>>0)){v=Dc(4)|0;w=v;owa(w);x=160792;y=127;Ld(v|0,x|0,y|0)}p=c[r+(l<<2)>>2]|0;if((p|0)==0){v=Dc(4)|0;w=v;owa(w);x=160792;y=127;Ld(v|0,x|0,y|0)}Wla(c[u>>2]|0)|0;u=o;ze[c[(c[p>>2]|0)+48>>2]&63](p,m,k,u)|0;m=o+(h<<2)|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];Mqa(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n<<2)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];Mqa(b,j,u,z,m,f,g);I=j;i=d;return}function Uqa(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;n=i;i=i+64|0;o=n;p=n+8|0;q=n+16|0;r=n+32|0;s=n+40|0;t=n+48|0;u=n+56|0;Ana(r,h);v=r;r=c[v>>2]|0;if(!((c[36308]|0)==-1)){c[q>>2]=145232;c[q+4>>2]=964;c[q+8>>2]=0;pma(145232,q,965)}q=(c[145236>>2]|0)+ -1|0;w=c[r+8>>2]|0;if(!((c[r+12>>2]|0)-w>>2>>>0>q>>>0)){x=Dc(4)|0;y=x;owa(y);z=160792;A=127;Ld(x|0,z|0,A|0)}r=c[w+(q<<2)>>2]|0;if((r|0)==0){x=Dc(4)|0;y=x;owa(y);z=160792;A=127;Ld(x|0,z|0,A|0)}A=r;Wla(c[v>>2]|0)|0;c[j>>2]=0;v=f;a:do{if((l|0)==(m|0)){B=65}else{z=g;x=r+8|0;y=t;q=u;w=s;C=l;D=0;b:while(1){E=D;while(1){if((E|0)!=0){B=65;break a}F=c[v>>2]|0;do{if((F|0)==0){G=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){G=F;break}if(!((ae[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){G=F;break}c[v>>2]=0;G=0}}while(0);F=(G|0)==0;H=c[z>>2]|0;c:do{if((H|0)==0){B=19}else{do{if((c[H+12>>2]|0)==(c[H+16>>2]|0)){if(!((ae[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1)){break}c[z>>2]=0;B=19;break c}}while(0);if(F){I=H}else{B=20;break b}}}while(0);if((B|0)==19){B=0;if(F){B=20;break b}else{I=0}}if((de[c[(c[r>>2]|0)+36>>2]&63](A,a[C]|0,0)|0)<<24>>24==37){B=22;break}H=a[C]|0;if(H<<24>>24>-1){J=c[x>>2]|0;if(!((b[J+(H<<24>>24<<1)>>1]&8192)==0)){K=C;B=33;break}}L=G+12|0;H=c[L>>2]|0;M=G+16|0;if((H|0)==(c[M>>2]|0)){N=(ae[c[(c[G>>2]|0)+36>>2]&127](G)|0)&255}else{N=a[H]|0}H=pe[c[(c[r>>2]|0)+12>>2]&63](A,N)|0;if(H<<24>>24==(pe[c[(c[r>>2]|0)+12>>2]&63](A,a[C]|0)|0)<<24>>24){B=60;break}c[j>>2]=4;E=4}d:do{if((B|0)==22){B=0;E=C+1|0;if((E|0)==(m|0)){B=23;break b}H=de[c[(c[r>>2]|0)+36>>2]&63](A,a[E]|0,0)|0;if(H<<24>>24==48|H<<24>>24==69){O=C+2|0;if((O|0)==(m|0)){B=26;break b}P=O;Q=de[c[(c[r>>2]|0)+36>>2]&63](A,a[O]|0,0)|0;R=H}else{P=E;Q=H;R=0}H=c[(c[e>>2]|0)+36>>2]|0;c[y>>2]=G;c[q>>2]=I;E=p;O=t;c[E+0>>2]=c[O+0>>2];O=o;E=u;c[O+0>>2]=c[E+0>>2];oe[H&3](s,e,p,o,h,j,k,Q,R);c[v>>2]=c[w>>2];S=P+1|0}else if((B|0)==33){while(1){B=0;H=K+1|0;if((H|0)==(m|0)){T=m;break}E=a[H]|0;if(!(E<<24>>24>-1)){T=H;break}if((b[J+(E<<24>>24<<1)>>1]&8192)==0){T=H;break}else{K=H;B=33}}F=G;H=I;E=I;while(1){do{if((F|0)==0){U=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){U=F;break}if(!((ae[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){U=F;break}c[v>>2]=0;U=0}}while(0);O=(U|0)==0;do{if((E|0)==0){V=H;B=46}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(O){W=H;X=E;break}else{S=T;break d}}if((ae[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[z>>2]=0;V=0;B=46;break}else{if(O^(H|0)==0){W=H;X=H;break}else{S=T;break d}}}}while(0);if((B|0)==46){B=0;if(O){S=T;break d}else{W=V;X=0}}Y=U+12|0;Z=c[Y>>2]|0;_=U+16|0;if((Z|0)==(c[_>>2]|0)){$=(ae[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{$=a[Z]|0}if(!($<<24>>24>-1)){S=T;break d}if((b[(c[x>>2]|0)+($<<24>>24<<1)>>1]&8192)==0){S=T;break d}Z=c[Y>>2]|0;if((Z|0)==(c[_>>2]|0)){ae[c[(c[U>>2]|0)+40>>2]&127](U)|0;F=U;H=W;E=X;continue}else{c[Y>>2]=Z+1;F=U;H=W;E=X;continue}}}else if((B|0)==60){B=0;E=c[L>>2]|0;if((E|0)==(c[M>>2]|0)){ae[c[(c[G>>2]|0)+40>>2]&127](G)|0}else{c[L>>2]=E+1}S=C+1|0}}while(0);if((S|0)==(m|0)){B=65;break a}C=S;D=c[j>>2]|0}if((B|0)==20){c[j>>2]=4;aa=G;break}else if((B|0)==23){c[j>>2]=4;aa=G;break}else if((B|0)==26){c[j>>2]=4;aa=G;break}}}while(0);if((B|0)==65){aa=c[v>>2]|0}v=f;do{if((aa|0)==0){ba=0}else{if((c[aa+12>>2]|0)!=(c[aa+16>>2]|0)){ba=aa;break}if(!((ae[c[(c[aa>>2]|0)+36>>2]&127](aa)|0)==-1)){ba=aa;break}c[v>>2]=0;ba=0}}while(0);v=(ba|0)==0;aa=g;g=c[aa>>2]|0;e:do{if((g|0)==0){B=75}else{do{if((c[g+12>>2]|0)==(c[g+16>>2]|0)){if(!((ae[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1)){break}c[aa>>2]=0;B=75;break e}}while(0);if(!v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);do{if((B|0)==75){if(v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ca=d;da=ca;c[da>>2]=ba;i=n;return}function Vqa(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function Wqa(a){a=a|0;i=i;return}function Xqa(a){a=a|0;i=i;return 2}function Yqa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];Uqa(a,b,l,k,f,g,h,144136,144144|0);i=j;return}function Zqa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=ae[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+1|0;s=q+1|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+t|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];Uqa(b,d,m,l,g,h,j,s,q);i=k;return}function _qa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;Ana(n,f);f=n;n=c[f>>2]|0;if(!((c[36308]|0)==-1)){c[m>>2]=145232;c[m+4>>2]=964;c[m+8>>2]=0;pma(145232,m,965)}m=(c[145236>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Dc(4)|0;q=p;owa(q);r=160792;s=127;Ld(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Dc(4)|0;q=p;owa(q);r=160792;s=127;Ld(p|0,r|0,s|0)}s=n;Wla(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ae[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=vpa(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function $qa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;Ana(n,f);f=n;n=c[f>>2]|0;if(!((c[36308]|0)==-1)){c[m>>2]=145232;c[m+4>>2]=964;c[m+8>>2]=0;pma(145232,m,965)}m=(c[145236>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Dc(4)|0;q=p;owa(q);r=160792;s=127;Ld(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Dc(4)|0;q=p;owa(q);r=160792;s=127;Ld(p|0,r|0,s|0)}s=n;Wla(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ae[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=vpa(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function ara(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;Ana(m,f);f=m;m=c[f>>2]|0;if(!((c[36308]|0)==-1)){c[l>>2]=145232;c[l+4>>2]=964;c[l+8>>2]=0;pma(145232,l,965)}l=(c[145236>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Dc(4)|0;p=o;owa(p);q=160792;r=127;Ld(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Dc(4)|0;p=o;owa(p);q=160792;r=127;Ld(o|0,q|0,r|0)}r=m;Wla(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=fra(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function bra(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;Ana(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[36308]|0)==-1)){c[ba>>2]=145232;c[ba+4>>2]=964;c[ba+8>>2]=0;pma(145232,ba,965)}ba=(c[145236>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Dc(4)|0;Ga=Fa;owa(Ga);Ha=160792;Ia=127;Ld(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Dc(4)|0;Ga=Fa;owa(Ga);Ha=160792;Ia=127;Ld(Fa|0,Ha|0,Ia|0)}Ia=ca;Wla(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 101:case 100:{Da=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];ca=fra(e,M,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((ca+ -1|0)>>>0<31)){break}c[Da>>2]=ca;break a}}while(0);c[h>>2]=Ha|4;break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];ca=fra(e,H,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<24){c[j+8>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Da=fra(e,F,h,Ia,3)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<366){c[j+28>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 88:{ca=d+8|0;Da=ae[c[(c[ca>>2]|0)+24>>2]&127](ca)|0;ca=e;c[Aa>>2]=c[ca>>2];c[Ba>>2]=c[f>>2];Fa=a[Da]|0;if((Fa&1)==0){Ja=Da+1|0;Ka=Da+1|0;La=(Fa&255)>>>1}else{Fa=c[Da+8>>2]|0;Ja=Fa;Ka=Fa;La=c[Da+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];Uqa(za,d,q,p,g,h,j,Ka,Ja+La|0);c[ca>>2]=c[za>>2];break};case 73:{ca=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Da=fra(e,G,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Da+ -1|0)>>>0<12)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Fa|4;break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];dra(d,j+8|0,e,B,h,Ia);break};case 120:{Da=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];me[Da&63](b,d,s,r,g,h,j);i=l;return};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Da=fra(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<60){c[j+4>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];cra(0,e,C,h,Ia);break};case 99:{ca=d+8|0;Da=ae[c[(c[ca>>2]|0)+12>>2]&127](ca)|0;ca=e;c[ea>>2]=c[ca>>2];c[fa>>2]=c[f>>2];Ha=a[Da]|0;if((Ha&1)==0){Ma=Da+1|0;Na=Da+1|0;Oa=(Ha&255)>>>1}else{Ha=c[Da+8>>2]|0;Ma=Ha;Na=Ha;Oa=c[Da+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];Uqa(da,d,O,N,g,h,j,Na,Ma+Oa|0);c[ca>>2]=c[da>>2];break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];ca=fra(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((ca|0)<69){Pa=ca+2e3|0}else{Pa=(ca+ -69|0)>>>0<31?ca+1900|0:ca}c[j+20>>2]=Pa+ -1900;break};case 82:{ca=e;c[sa>>2]=c[ca>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];Uqa(ra,d,y,x,g,h,j,144176,144181|0);c[ca>>2]=c[ra>>2];break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];ca=fra(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=ca+ -1900;break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];ca=fra(e,t,h,Ia,1)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<7){c[j+24>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 114:{Da=e;c[pa>>2]=c[Da>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];Uqa(oa,d,A,z,g,h,j,144160,144171|0);c[Da>>2]=c[oa>>2];break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=fra(e,w,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 68:{ca=e;c[ha>>2]=c[ca>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];Uqa(ga,d,L,K,g,h,j,144144,144152|0);c[ca>>2]=c[ga>>2];break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];ca=fra(e,E,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<13){c[j+16>>2]=ca+ -1;break a}else{c[h>>2]=Da|4;break a}break};case 84:{Da=e;c[va>>2]=c[Da>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];Uqa(ua,d,v,u,g,h,j,144184,144192|0);c[Da>>2]=c[ua>>2];break};case 65:case 97:{Da=c[f>>2]|0;ca=d+8|0;Ha=ae[c[c[ca>>2]>>2]&127](ca)|0;c[aa>>2]=Da;c[Q+0>>2]=c[aa+0>>2];Da=(vpa(e,Q,Ha,Ha+168|0,Ia,h,0)|0)-Ha|0;if((Da|0)>=168){break a}c[j+24>>2]=((Da|0)/12|0|0)%7|0;break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];era(0,e,m,h,Ia);break};case 104:case 66:case 98:{Da=c[f>>2]|0;Ha=d+8|0;ca=ae[c[(c[Ha>>2]|0)+4>>2]&127](Ha)|0;c[$>>2]=Da;c[P+0>>2]=c[$+0>>2];Da=(vpa(e,P,ca,ca+288|0,Ia,h,0)|0)-ca|0;if((Da|0)>=288){break a}c[j+16>>2]=((Da|0)/12|0|0)%12|0;break};case 70:{Da=e;c[ka>>2]=c[Da>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];Uqa(ja,d,J,I,g,h,j,144152,144160|0);c[Da>>2]=c[ja>>2];break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function cra(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;j=e;e=f;f=h+8|0;a:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if((ae[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;do{if((l|0)==0){m=12}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(h){n=l;break}else{o=l;break a}}if((ae[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;m=12;break}else{if(h){n=l;break}else{o=l;break a}}}}while(0);if((m|0)==12){m=0;if(h){o=0;break}else{n=0}}l=c[j>>2]|0;p=c[l+12>>2]|0;if((p|0)==(c[l+16>>2]|0)){q=(ae[c[(c[l>>2]|0)+36>>2]&127](l)|0)&255}else{q=a[p]|0}if(!(q<<24>>24>-1)){o=n;break}if((b[(c[f>>2]|0)+(q<<24>>24<<1)>>1]&8192)==0){o=n;break}p=c[j>>2]|0;l=p+12|0;r=c[l>>2]|0;if((r|0)==(c[p+16>>2]|0)){ae[c[(c[p>>2]|0)+40>>2]&127](p)|0;continue}else{c[l>>2]=r+1;continue}}n=c[j>>2]|0;do{if((n|0)==0){s=0}else{if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){s=n;break}if((ae[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1){c[j>>2]=0;s=0;break}else{s=c[j>>2]|0;break}}}while(0);j=(s|0)==0;b:do{if((o|0)==0){m=32}else{do{if((c[o+12>>2]|0)==(c[o+16>>2]|0)){if(!((ae[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1)){break}c[e>>2]=0;m=32;break b}}while(0);if(!j){break}i=d;return}}while(0);do{if((m|0)==32){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function dra(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=ae[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=vpa(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function era(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;b=i;h=d;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if((ae[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e;e=c[j>>2]|0;a:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((ae[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[j>>2]=0;k=11;break a}}while(0);if(d){l=e}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){m=(ae[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{m=a[e]|0}if(!((de[c[(c[g>>2]|0)+36>>2]&63](g,m,0)|0)<<24>>24==37)){c[f>>2]=c[f>>2]|4;i=b;return}m=c[h>>2]|0;g=m+12|0;e=c[g>>2]|0;if((e|0)==(c[m+16>>2]|0)){ae[c[(c[m>>2]|0)+40>>2]&127](m)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){n=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){n=e;break}if((ae[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[h>>2]=0;n=0;break}else{n=c[h>>2]|0;break}}}while(0);h=(n|0)==0;b:do{if((l|0)==0){k=31}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if(!((ae[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){break}c[j>>2]=0;k=31;break b}}while(0);if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function fra(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=d;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if((ae[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e;e=c[l>>2]|0;a:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((ae[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[l>>2]=0;m=11;break a}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=(ae[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>-1){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=(de[c[(c[g>>2]|0)+36>>2]&63](g,p,0)|0)<<24>>24;q=c[k>>2]|0;r=q+12|0;s=c[r>>2]|0;if((s|0)==(c[q+16>>2]|0)){ae[c[(c[q>>2]|0)+40>>2]&127](q)|0;t=h;u=n;v=n;w=d}else{c[r>>2]=s+1;t=h;u=n;v=n;w=d}while(1){x=w+ -48|0;d=t+ -1|0;s=c[k>>2]|0;do{if((s|0)==0){y=0}else{if((c[s+12>>2]|0)!=(c[s+16>>2]|0)){y=s;break}if((ae[c[(c[s>>2]|0)+36>>2]&127](s)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);s=(y|0)==0;do{if((v|0)==0){z=u;A=0}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){z=u;A=v;break}if(!((ae[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1)){z=u;A=u;break}c[l>>2]=0;z=0;A=0}}while(0);B=c[k>>2]|0;if(!((s^(A|0)==0)&(d|0)>0)){m=40;break}r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){C=(ae[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[r]|0}if(!(C<<24>>24>-1)){o=x;m=52;break}if((b[(c[e>>2]|0)+(C<<24>>24<<1)>>1]&2048)==0){o=x;m=52;break}r=((de[c[(c[g>>2]|0)+36>>2]&63](g,C,0)|0)<<24>>24)+(x*10|0)|0;q=c[k>>2]|0;D=q+12|0;E=c[D>>2]|0;if((E|0)==(c[q+16>>2]|0)){ae[c[(c[q>>2]|0)+40>>2]&127](q)|0;F=d;u=z;v=A;w=r;t=F;continue}else{c[D>>2]=E+1;F=d;u=z;v=A;w=r;t=F;continue}}if((m|0)==40){do{if((B|0)==0){G=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){G=B;break}if((ae[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);e=(G|0)==0;b:do{if((z|0)==0){m=50}else{do{if((c[z+12>>2]|0)==(c[z+16>>2]|0)){if(!((ae[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1)){break}c[l>>2]=0;m=50;break b}}while(0);if(e){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==50){if(e){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==52){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function gra(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;l=i;i=i+64|0;m=l;n=l+8|0;o=l+16|0;p=l+32|0;q=l+40|0;r=l+48|0;s=l+56|0;Ana(p,f);t=p;p=c[t>>2]|0;if(!((c[36306]|0)==-1)){c[o>>2]=145224;c[o+4>>2]=964;c[o+8>>2]=0;pma(145224,o,965)}o=(c[145228>>2]|0)+ -1|0;u=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-u>>2>>>0>o>>>0)){v=Dc(4)|0;w=v;owa(w);x=160792;y=127;Ld(v|0,x|0,y|0)}p=c[u+(o<<2)>>2]|0;if((p|0)==0){v=Dc(4)|0;w=v;owa(w);x=160792;y=127;Ld(v|0,x|0,y|0)}y=p;Wla(c[t>>2]|0)|0;c[g>>2]=0;t=d;a:do{if((j|0)==(k|0)){z=69}else{x=e;v=r;w=s;o=q;u=j;A=0;b:while(1){B=A;while(1){if((B|0)!=0){z=69;break a}C=c[t>>2]|0;do{if((C|0)==0){D=0;E=1}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){G=ae[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[F>>2]|0}if(!((G|0)==-1)){D=C;E=0;break}c[t>>2]=0;D=0;E=1}}while(0);C=c[x>>2]|0;do{if((C|0)==0){z=22}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){H=ae[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{H=c[F>>2]|0}if((H|0)==-1){c[x>>2]=0;z=22;break}else{if(E){I=C;break}else{z=24;break b}}}}while(0);if((z|0)==22){z=0;if(E){z=24;break b}else{I=0}}if((de[c[(c[p>>2]|0)+52>>2]&63](y,c[u>>2]|0,0)|0)<<24>>24==37){z=26;break}if(de[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[u>>2]|0)|0){J=u;z=36;break}K=D+12|0;C=c[K>>2]|0;L=D+16|0;if((C|0)==(c[L>>2]|0)){M=ae[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{M=c[C>>2]|0}C=pe[c[(c[p>>2]|0)+28>>2]&63](y,M)|0;if((C|0)==(pe[c[(c[p>>2]|0)+28>>2]&63](y,c[u>>2]|0)|0)){z=64;break}c[g>>2]=4;B=4}c:do{if((z|0)==26){z=0;B=u+4|0;if((B|0)==(k|0)){z=27;break b}C=de[c[(c[p>>2]|0)+52>>2]&63](y,c[B>>2]|0,0)|0;if(C<<24>>24==48|C<<24>>24==69){F=u+8|0;if((F|0)==(k|0)){z=30;break b}N=F;O=de[c[(c[p>>2]|0)+52>>2]&63](y,c[F>>2]|0,0)|0;P=C}else{N=B;O=C;P=0}C=c[(c[b>>2]|0)+36>>2]|0;c[v>>2]=D;c[w>>2]=I;B=n;F=r;c[B+0>>2]=c[F+0>>2];F=m;B=s;c[F+0>>2]=c[B+0>>2];oe[C&3](q,b,n,m,f,g,h,O,P);c[t>>2]=c[o>>2];Q=N+4|0}else if((z|0)==36){while(1){z=0;C=J+4|0;if((C|0)==(k|0)){R=k;break}if(de[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[C>>2]|0)|0){J=C;z=36}else{R=C;break}}C=D;B=I;F=I;while(1){do{if((C|0)==0){S=0;T=1}else{U=c[C+12>>2]|0;if((U|0)==(c[C+16>>2]|0)){V=ae[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{V=c[U>>2]|0}if(!((V|0)==-1)){S=C;T=0;break}c[t>>2]=0;S=0;T=1}}while(0);do{if((F|0)==0){W=B;z=51}else{U=c[F+12>>2]|0;if((U|0)==(c[F+16>>2]|0)){X=ae[c[(c[F>>2]|0)+36>>2]&127](F)|0}else{X=c[U>>2]|0}if((X|0)==-1){c[x>>2]=0;W=0;z=51;break}else{if(T^(B|0)==0){Y=B;Z=B;break}else{Q=R;break c}}}}while(0);if((z|0)==51){z=0;if(T){Q=R;break c}else{Y=W;Z=0}}U=S+12|0;_=c[U>>2]|0;$=S+16|0;if((_|0)==(c[$>>2]|0)){aa=ae[c[(c[S>>2]|0)+36>>2]&127](S)|0}else{aa=c[_>>2]|0}if(!(de[c[(c[p>>2]|0)+12>>2]&63](y,8192,aa)|0)){Q=R;break c}_=c[U>>2]|0;if((_|0)==(c[$>>2]|0)){ae[c[(c[S>>2]|0)+40>>2]&127](S)|0;C=S;B=Y;F=Z;continue}else{c[U>>2]=_+4;C=S;B=Y;F=Z;continue}}}else if((z|0)==64){z=0;F=c[K>>2]|0;if((F|0)==(c[L>>2]|0)){ae[c[(c[D>>2]|0)+40>>2]&127](D)|0}else{c[K>>2]=F+4}Q=u+4|0}}while(0);if((Q|0)==(k|0)){z=69;break a}u=Q;A=c[g>>2]|0}if((z|0)==24){c[g>>2]=4;ba=D;break}else if((z|0)==27){c[g>>2]=4;ba=D;break}else if((z|0)==30){c[g>>2]=4;ba=D;break}}}while(0);if((z|0)==69){ba=c[t>>2]|0}t=d;do{if((ba|0)==0){ca=0;da=1}else{d=c[ba+12>>2]|0;if((d|0)==(c[ba+16>>2]|0)){ea=ae[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ea=c[d>>2]|0}if(!((ea|0)==-1)){ca=ba;da=0;break}c[t>>2]=0;ca=0;da=1}}while(0);t=e;e=c[t>>2]|0;do{if((e|0)==0){z=82}else{ba=c[e+12>>2]|0;if((ba|0)==(c[e+16>>2]|0)){fa=ae[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{fa=c[ba>>2]|0}if((fa|0)==-1){c[t>>2]=0;z=82;break}if(!da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);do{if((z|0)==82){if(da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;ga=a;ha=ga;c[ha>>2]=ca;i=l;return}function hra(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function ira(a){a=a|0;i=i;return}function jra(a){a=a|0;i=i;return 2}function kra(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];gra(a,b,l,k,f,g,h,144288,144320|0);i=j;return}function lra(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=ae[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+4|0;s=q+4|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+(t<<2)|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];gra(b,d,m,l,g,h,j,s,q);i=k;return}function mra(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;Ana(n,f);f=n;n=c[f>>2]|0;if(!((c[36306]|0)==-1)){c[m>>2]=145224;c[m+4>>2]=964;c[m+8>>2]=0;pma(145224,m,965)}m=(c[145228>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Dc(4)|0;q=p;owa(q);r=160792;s=127;Ld(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Dc(4)|0;q=p;owa(q);r=160792;s=127;Ld(p|0,r|0,s|0)}s=n;Wla(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ae[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=Upa(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function nra(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;Ana(n,f);f=n;n=c[f>>2]|0;if(!((c[36306]|0)==-1)){c[m>>2]=145224;c[m+4>>2]=964;c[m+8>>2]=0;pma(145224,m,965)}m=(c[145228>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Dc(4)|0;q=p;owa(q);r=160792;s=127;Ld(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Dc(4)|0;q=p;owa(q);r=160792;s=127;Ld(p|0,r|0,s|0)}s=n;Wla(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ae[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=Upa(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function ora(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;Ana(m,f);f=m;m=c[f>>2]|0;if(!((c[36306]|0)==-1)){c[l>>2]=145224;c[l+4>>2]=964;c[l+8>>2]=0;pma(145224,l,965)}l=(c[145228>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Dc(4)|0;p=o;owa(p);q=160792;r=127;Ld(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Dc(4)|0;p=o;owa(p);q=160792;r=127;Ld(o|0,q|0,r|0)}r=m;Wla(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=tra(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function pra(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;Ana(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[36306]|0)==-1)){c[ba>>2]=145224;c[ba+4>>2]=964;c[ba+8>>2]=0;pma(145224,ba,965)}ba=(c[145228>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Dc(4)|0;Ga=Fa;owa(Ga);Ha=160792;Ia=127;Ld(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Dc(4)|0;Ga=Fa;owa(Ga);Ha=160792;Ia=127;Ld(Fa|0,Ha|0,Ia|0)}Ia=ca;Wla(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 104:case 66:case 98:{Da=c[f>>2]|0;ca=d+8|0;Ha=ae[c[(c[ca>>2]|0)+4>>2]&127](ca)|0;c[$>>2]=Da;c[P+0>>2]=c[$+0>>2];Da=(Upa(e,P,Ha,Ha+288|0,Ia,h,0)|0)-Ha|0;if((Da|0)>=288){break a}c[j+16>>2]=((Da|0)/12|0|0)%12|0;break};case 68:{Da=e;c[ha>>2]=c[Da>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];gra(ga,d,L,K,g,h,j,144320,144352|0);c[Da>>2]=c[ga>>2];break};case 65:case 97:{Da=c[f>>2]|0;Ha=d+8|0;ca=ae[c[c[Ha>>2]>>2]&127](Ha)|0;c[aa>>2]=Da;c[Q+0>>2]=c[aa+0>>2];Da=(Upa(e,Q,ca,ca+168|0,Ia,h,0)|0)-ca|0;if((Da|0)>=168){break a}c[j+24>>2]=((Da|0)/12|0|0)%7|0;break};case 73:{Da=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];ca=tra(e,G,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((ca+ -1|0)>>>0<12)){break}c[Da>>2]=ca;break a}}while(0);c[h>>2]=Ha|4;break};case 101:case 100:{ca=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Da=tra(e,M,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Da+ -1|0)>>>0<31)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Fa|4;break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Da=tra(e,H,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<24){c[j+8>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];ca=tra(e,E,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<13){c[j+16>>2]=ca+ -1;break a}else{c[h>>2]=Da|4;break a}break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Da=tra(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Da|0)<69){Ja=Da+2e3|0}else{Ja=(Da+ -69|0)>>>0<31?Da+1900|0:Da}c[j+20>>2]=Ja+ -1900;break};case 99:{Da=d+8|0;ca=ae[c[(c[Da>>2]|0)+12>>2]&127](Da)|0;Da=e;c[ea>>2]=c[Da>>2];c[fa>>2]=c[f>>2];Ha=a[ca]|0;if((Ha&1)==0){Ka=ca+4|0;La=ca+4|0;Ma=(Ha&255)>>>1}else{Ha=c[ca+8>>2]|0;Ka=Ha;La=Ha;Ma=c[ca+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];gra(da,d,O,N,g,h,j,La,Ka+(Ma<<2)|0);c[Da>>2]=c[da>>2];break};case 70:{Da=e;c[ka>>2]=c[Da>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];gra(ja,d,J,I,g,h,j,144352,144384|0);c[Da>>2]=c[ja>>2];break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Da=tra(e,F,h,Ia,3)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<366){c[j+28>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 88:{ca=d+8|0;Da=ae[c[(c[ca>>2]|0)+24>>2]&127](ca)|0;ca=e;c[Aa>>2]=c[ca>>2];c[Ba>>2]=c[f>>2];Ha=a[Da]|0;if((Ha&1)==0){Na=Da+4|0;Oa=Da+4|0;Pa=(Ha&255)>>>1}else{Ha=c[Da+8>>2]|0;Na=Ha;Oa=Ha;Pa=c[Da+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];gra(za,d,q,p,g,h,j,Oa,Na+(Pa<<2)|0);c[ca>>2]=c[za>>2];break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];ca=tra(e,D,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<60){c[j+4>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];rra(d,j+8|0,e,B,h,Ia);break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Da=tra(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Da+ -1900;break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];sra(0,e,m,h,Ia);break};case 82:{Da=e;c[sa>>2]=c[Da>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];gra(ra,d,y,x,g,h,j,144432,144452|0);c[Da>>2]=c[ra>>2];break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=tra(e,w,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];qra(0,e,C,h,Ia);break};case 120:{ca=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];me[ca&63](b,d,s,r,g,h,j);i=l;return};case 114:{ca=e;c[pa>>2]=c[ca>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];gra(oa,d,A,z,g,h,j,144384,144428|0);c[ca>>2]=c[oa>>2];break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];ca=tra(e,t,h,Ia,1)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<7){c[j+24>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 84:{Da=e;c[va>>2]=c[Da>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];gra(ua,d,v,u,g,h,j,144456,144488|0);c[Da>>2]=c[ua>>2];break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function qra(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;g=b;b=d;a:while(1){d=c[g>>2]|0;do{if((d|0)==0){h=1}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){k=ae[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);d=c[b>>2]|0;do{if((d|0)==0){l=15}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){m=ae[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[j>>2]|0}if((m|0)==-1){c[b>>2]=0;l=15;break}else{if(h){n=d;break}else{o=d;break a}}}}while(0);if((l|0)==15){l=0;if(h){o=0;break}else{n=0}}d=c[g>>2]|0;j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){p=ae[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{p=c[j>>2]|0}if(!(de[c[(c[f>>2]|0)+12>>2]&63](f,8192,p)|0)){o=n;break}j=c[g>>2]|0;d=j+12|0;q=c[d>>2]|0;if((q|0)==(c[j+16>>2]|0)){ae[c[(c[j>>2]|0)+40>>2]&127](j)|0;continue}else{c[d>>2]=q+4;continue}}n=c[g>>2]|0;do{if((n|0)==0){r=1}else{p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){s=ae[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{s=c[p>>2]|0}if((s|0)==-1){c[g>>2]=0;r=1;break}else{r=(c[g>>2]|0)==0;break}}}while(0);do{if((o|0)==0){l=37}else{g=c[o+12>>2]|0;if((g|0)==(c[o+16>>2]|0)){t=ae[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{t=c[g>>2]|0}if((t|0)==-1){c[b>>2]=0;l=37;break}if(!r){break}i=a;return}}while(0);do{if((l|0)==37){if(r){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function rra(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=ae[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=Upa(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}



function Z_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b+1|0]|0)==0){o=d[k+76+(d[n]|0)|0]|0}else{o=R_(a[n+1|0]|0,a[b]|0)|0}a:do{switch(o|0){case 24:case 22:{break};case 29:{if((c[61816+((d[61560+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=R_(a[o+1|0]|0,a[b]|0)|0}switch(q|0){case 6:{p=31;break b;break};case 29:{if((c[61816+((d[63096+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=26;break b}break};case 15:{p=62;break b;break};case 10:case 9:case 21:{p=37;break b;break};case 5:{p=28;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{p=34;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((a$(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b+1|0]|0)==0){r=d[k+76+(d[q]|0)|0]|0}else{r=R_(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b+1|0]|0)!=0){continue c}if((a[b]|0)==62){p=59;break c}else{continue c}break};case 8:case 1:case 0:{p=54;break c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((a$(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b+1|0]|0)!=0){break}if((a[b]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function __(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=R_(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 29:{if((c[61816+((d[61560+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=R_(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 5:{n=28;break b;break};case 10:case 9:case 21:{n=37;break b;break};case 23:{b=b+2|0;continue b;break};case 29:{if((c[61816+((d[63096+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 7:{n=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 11:{n=48;break b;break};case 6:{n=31;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=R_(a[o+1|0]|0,a[b]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function $_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){m=d[k+76+(d[b]|0)|0]|0}else{m=R_(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b:do{switch(m|0){case 7:{l=16;break a;break};case 14:{break};case 29:{if((c[61816+((d[63096+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 5:{l=10;break a;break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){n=d[k+76+(d[b]|0)|0]|0}else{n=R_(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}switch(n|0){case 29:{if((c[61816+((d[61560+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=28;break a}break};case 7:{l=36;break a;break};case 24:case 22:{break};case 6:{l=33;break a;break};case 5:{l=30;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 6:{l=13;break a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){o=d[k+76+(d[b]|0)|0]|0}else{o=R_(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){q=d[k+76+(d[p]|0)|0]|0}else{q=R_(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){s=d[k+76+(d[p]|0)|0]|0}else{s=R_(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 2:{l=79;break a;break};case 3:{t=S_(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 8:case 1:case 0:{l=74;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){u=d[k+76+(d[p]|0)|0]|0}else{u=R_(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(u|0){case 17:{l=107;break a;break};case 11:{l=106;break a;break};case 10:case 9:case 21:{break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){v=d[k+76+(d[p]|0)|0]|0}else{v=R_(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(v|0){case 17:{l=107;break a;break};case 5:{l=97;break a;break};case 6:{l=100;break a;break};case 24:case 22:{break d;break};case 11:{l=106;break a;break};case 10:case 9:case 21:{break};case 7:{l=103;break a;break};case 29:{l=94;break d;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[61816+((d[61560+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[(c[j>>2]|0)+1|0]|0)==0){if((a[c[j>>2]|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function a$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g+1|0]|0)==0){k=a[g]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){l=a[g]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){m=a[g]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function b$(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e+1|0]|0)==0){m=d[b+76+(d[h]|0)|0]|0}else{m=R_(a[h+1|0]|0,a[e]|0)|0}h=m;switch(h|0){case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e+1|0]|0)==0){p=d[b+76+(d[g]|0)|0]|0}else{p=R_(a[g+1|0]|0,a[e]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function c$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=R_(a[g+1|0]|0,a[b]|0)|0}if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=R_(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 30:{n=16;break a;break};case 24:case 22:{break};case 10:case 9:case 21:{break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+3|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=R_(a[o+1|0]|0,a[b+2|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==27){k=X_(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function d$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=R_(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[61816+((d[61560+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=R_(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 29:{if((c[61816+((d[63096+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 6:{n=31;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=34;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 5:{n=28;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function e$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=R_(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 30:{k=w$(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=R_(a[g]|0,a[b+1|0]|0)|0}switch(n|0){case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 9:{if((b+2|0)!=(e|0)){o=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+2|0]|0)!=0){break}if((a[b+3|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 12:{k=G$(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){p=d[j+76+(d[g+1|0]|0)|0]|0}else{p=R_(a[g]|0,a[b+1|0]|0)|0}switch(p|0){case 15:{k=C$(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 16:{k=H$(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 10:case 21:{o=25;break};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 29:{g=b;if((c[61816+((d[61560+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){b=g+2|0;q=18;o=77;break a}if((c[61816+((d[63096+(d[g]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=76;break a}b=b+2|0;q=19;o=77;break};case 23:case 27:case 26:case 25:{q=19;b=b+2|0;o=77;break};case 24:case 22:{q=18;b=b+2|0;o=77;break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=I$(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 13:{k=G$(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};default:{o=76}}}while(0);if((o|0)==25){while(1){o=0;b=b+2|0;r=b;if((b|0)==(e|0)){o=32;break}p=b;if((a[r]|0)==0){s=d[j+76+(d[p+1|0]|0)|0]|0}else{s=R_(a[p]|0,a[b+1|0]|0)|0}if((s|0)==10|(s|0)==21){o=25;continue}else if((s|0)!=9){o=31;break}if((b+2|0)!=(e|0)){o=25}else{o=31;break}}if((o|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((o|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((o|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==77){b:while(1){o=0;if((b|0)==(e|0)){o=126;break}r=b;if((a[b]|0)==0){t=d[j+76+(d[r+1|0]|0)|0]|0}else{t=R_(a[r]|0,a[b+1|0]|0)|0}switch(t|0){case 29:{if((c[61816+((d[63096+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=83;break b}break};case 5:{o=85;break b;break};case 33:{o=119;break b;break};case 6:{o=88;break b;break};case 15:{o=122;break b;break};case 23:{b=b+2|0;r=q;if((r|0)==41){q=19;o=77;continue b}else if((r|0)!=18){o=77;continue b}if((b|0)==(e|0)){o=97;break b}q=41;r=b;if((a[b]|0)==0){u=d[j+76+(d[r+1|0]|0)|0]|0}else{u=R_(a[r]|0,a[b+1|0]|0)|0}switch(u|0){case 29:{if((c[61816+((d[63096+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=103;break b}break};case 6:{o=108;break b;break};case 5:{o=105;break b;break};case 7:{o=111;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{q=19;o=77;continue b}}b=b+2|0;o=77;continue b;break};case 27:case 26:case 25:case 24:case 22:{break};case 34:{o=116;break b;break};case 7:{o=91;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{o=94;break b;break};default:{o=125;break b}}b=b+2|0;o=77}if((o|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==94){c[f>>2]=b;k=q;l=k;i=h;return l|0}else if((o|0)==97){k=-1;l=k;i=h;return l|0}else if((o|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==116){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((o|0)==119){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((o|0)==122){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((o|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==126){k=0-q|0;l=k;i=h;return l|0}}return 0}function f$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=R_(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 2:{k=z$(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=R_(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 3:{k=v$(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=R_(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+2|0]|0)==0){if((a[b+3|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+4|0]|0)==0){if((a[b+5|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 6:{r=b;if((e-b|0)<3){p=52;break b}b=r+3|0;continue b;break};case 5:{s=b;if((e-b|0)<2){p=49;break b}b=s+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 7:{t=b;if((e-b|0)<4){p=55;break b}b=t+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function g$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=R_(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=R_(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=R_(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 6:{r=b;if((e-b|0)<3){p=50;break b}b=r+3|0;continue b;break};case 5:{s=b;if((e-b|0)<2){p=47;break b}b=s+2|0;continue b;break};case 7:{t=b;if((e-b|0)<4){p=53;break b}b=t+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function h$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b]|0)==0){m=d[j+76+(d[k+1|0]|0)|0]|0}else{m=R_(a[k]|0,a[b+1|0]|0)|0}switch(m|0){case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function i$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=R_(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 21:{n=29;break a;break};case 9:{n=19;break a;break};case 5:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 2:{n=15;break a;break};case 7:{b=b+4|0;continue a;break};case 3:{n=12;break a;break};case 10:{n=16;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=v$(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=R_(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function j$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=R_(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 5:{b=b+2|0;continue a;break};case 9:{n=21;break a;break};case 30:{n=15;break a;break};case 10:{n=18;break a;break};case 6:{b=b+3|0;continue a;break};case 3:{n=12;break a;break};case 7:{b=b+4|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=v$(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=w$(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=R_(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function k$(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b]|0)==0){h=d[g+76+(d[e+1|0]|0)|0]|0}else{h=R_(a[e]|0,a[b+1|0]|0)|0}switch(h|0){case 6:{j=8;break};case 5:{break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;k=b;b=k+1|0;if((a[e]|0)!=(a[k]|0)){j=15;break a}k=c;c=k+1|0;e=b;b=e+1|0;if((a[k]|0)!=(a[e]|0)){j=17;break a}else{continue a}break};case 7:{e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=7;break a}else{j=8}break};default:{j=18;break a}}if((j|0)==8){j=0;k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=9;break}}e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=11;break}k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=13;break}}if((j|0)==7){l=0;m=l;i=f;return m|0}else if((j|0)==9){l=0;m=l;i=f;return m|0}else if((j|0)==11){l=0;m=l;i=f;return m|0}else if((j|0)==13){l=0;m=l;i=f;return m|0}else if((j|0)==15){l=0;m=l;i=f;return m|0}else if((j|0)==17){l=0;m=l;i=f;return m|0}else if((j|0)==18){j=c;if((a[c]|0)==0){n=d[g+76+(d[j+1|0]|0)|0]|0}else{n=R_(a[j]|0,a[c+1|0]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function l$(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f]|0)!=0){h=7;break}if((a[f+1|0]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function m$(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b]|0)==0){h=d[f+76+(d[g+1|0]|0)|0]|0}else{h=R_(a[g]|0,a[b+1|0]|0)|0}switch(h|0){case 5:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};default:{break a}}}i=e;return b-c|0}function n$(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b]|0)==0){g=d[f+76+(d[c+1|0]|0)|0]|0}else{g=R_(a[c]|0,a[b+1|0]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function o$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b]|0)==0){n=d[j+76+(d[m+1|0]|0)|0]|0}else{n=R_(a[m]|0,a[b+1|0]|0)|0}b:do{switch(n|0){case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)==0){o=a[b+1|0]|0}else{o=-1}if((o|0)!=32){break}if((a[b+2|0]|0)==0){p=a[b+3|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+2|0]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=R_(a[m]|0,a[b+3|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function p$(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d]|0)==0){if((a[d+1|0]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d]|0)==0){f=(a[d+1|0]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d]|0)==0){g=a[d+1|0]|0}else{g=-1}h=g;switch(h|0){case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d]|0)==0){l=(a[d+1|0]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d]|0)==0){m=a[d+1|0]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=d_(c)|0;k=j;i=b;return k|0}function q$(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==2){if((a[e+2|0]|0)!=0){break}if((a[e+3|0]|0)!=116){break}if((a[e]|0)==0){f=a[e+1|0]|0}else{f=-1}if((f|0)==103){g=62;h=g;i=b;return h|0}else if((f|0)==108){g=60;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=97){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=109){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}g=38;h=g;i=b;return h|0}else if((c|0)==4){if((a[e]|0)==0){j=a[e+1|0]|0}else{j=-1}if((j|0)==97){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=115){break}g=39;h=g;i=b;return h|0}else if((j|0)==113){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=117){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=116){break}g=34;h=g;i=b;return h|0}else{break}}}while(0);g=0;h=g;i=b;return h|0}function r$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=R_(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 6:{b=b+3|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=R_(a[g]|0,a[b+1|0]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 5:{b=b+2|0;break};case 7:{b=b+4|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function s$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=R_(a[g]|0,a[b+1|0]|0)|0}b:do{switch(l|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 21:{if((a[b]|0)!=0){break b}if((a[b+1|0]|0)==9){k=9;break a}break};case 22:case 26:{if((a[b]|0)==0){m=a[b+1|0]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b]|0)==0){n=a[b+1|0]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function t$(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j+1|0]|0;m=a[g]|0;b:do{switch(m&255|0){case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}n=((m&3)<<2|(l&255)>>6&3)+1|0;o=e;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n>>2|240;p=e;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=(l&255)>>2&15|(n&3)<<4|128;g=g+2|0;n=a[g+1|0]|0;o=((l&3)<<4|(a[g]&3)<<2|(n&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=o;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=n&63|128;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=l;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=(m&255)>>4|224;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(m&15)<<2|(l&255)>>6|128;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(l&255)>>6|(m&255)<<2|192;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function u$(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[c[k>>2]|0]|0)<<8|(d[(c[k>>2]|0)+1|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function v$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=R_(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=x$(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[61816+((d[61560+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=R_(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 29:{if((c[61816+((d[63096+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 6:{n=32;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=35;break b;break};case 5:{n=29;break b;break};case 18:{n=38;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function w$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=R_(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[61816+((d[61560+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=R_(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 6:{n=32;break b;break};case 7:{n=35;break b;break};case 29:{if((c[61816+((d[63096+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 18:{n=38;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=29;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function x$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=120){break}k=y$(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=R_(a[g]|0,a[b+1|0]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=R_(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function y$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=R_(a[g]|0,a[b+1|0]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=R_(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function z$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=R_(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 15:{k=C$(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{if((c[61816+((d[61560+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=R_(a[g]|0,a[b+1|0]|0)|0}if((n|0)==27){k=A$(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=B$(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=D$(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b]|0)==0){p=d[j+76+(d[m+1|0]|0)|0]|0}else{p=R_(a[m]|0,a[b+1|0]|0)|0}switch(p|0){case 7:{o=45;break b;break};case 11:{o=90;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 10:case 9:case 21:{o=69;break b;break};case 6:{o=42;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=R_(a[m]|0,a[b+1|0]|0)|0}switch(q|0){case 7:{o=65;break b;break};case 29:{if((c[61816+((d[61560+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=57;break b}break};case 5:{o=59;break b;break};case 6:{o=62;break b;break};case 24:case 22:{break};default:{o=68;break b}}b=b+2|0;continue b;break};case 17:{break b;break};case 29:{if((c[61816+((d[63096+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=37;break b}break};case 5:{o=39;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b]|0)==0){r=d[j+76+(d[q+1|0]|0)|0]|0}else{r=R_(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 11:{o=90;break c;break};case 17:{break c;break};case 29:{o=75;break d;break};case 5:{o=78;break d;break};case 10:case 9:case 21:{break};case 24:case 22:{break d;break};case 7:{o=84;break d;break};case 6:{o=81;break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[61816+((d[61560+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=E$(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function A$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=R_(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b]|0)!=0){continue b}if((a[b+1|0]|0)==45){l=25;break b}else{continue b}break};case 8:case 1:case 0:{l=20;break b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function B$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k]|0)!=0){l=7;break}if((a[g+1|0]|0)!=(a[64136+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function C$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b]|0)==0){o=d[k+76+(d[n+1|0]|0)|0]|0}else{o=R_(a[n]|0,a[b+1|0]|0)|0}a:do{switch(o|0){case 24:case 22:{break};case 29:{if((c[61816+((d[61560+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=R_(a[o]|0,a[b+1|0]|0)|0}switch(q|0){case 10:case 9:case 21:{p=37;break b;break};case 29:{if((c[61816+((d[63096+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=26;break b}break};case 6:{p=31;break b;break};case 15:{p=62;break b;break};case 5:{p=28;break b;break};case 7:{p=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((F$(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b]|0)==0){r=d[k+76+(d[q+1|0]|0)|0]|0}else{r=R_(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b]|0)!=0){continue c}if((a[b+1|0]|0)==62){p=59;break c}else{continue c}break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((F$(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=0){break}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function D$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=R_(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 29:{if((c[61816+((d[61560+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=R_(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 7:{n=34;break b;break};case 29:{if((c[61816+((d[63096+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 10:case 9:case 21:{n=37;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=28;break b;break};case 11:{n=48;break b;break};case 6:{n=31;break b;break};case 23:{b=b+2|0;continue b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=R_(a[o]|0,a[b+1|0]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function E$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){m=d[k+76+(d[b+1|0]|0)|0]|0}else{m=R_(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b:do{switch(m|0){case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){n=d[k+76+(d[b+1|0]|0)|0]|0}else{n=R_(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(n|0){case 6:{l=33;break a;break};case 24:case 22:{break};case 7:{l=36;break a;break};case 29:{if((c[61816+((d[61560+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=28;break a}break};case 5:{l=30;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 14:{break};case 29:{if((c[61816+((d[63096+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 5:{l=10;break a;break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 7:{l=16;break a;break};case 6:{l=13;break a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){o=d[k+76+(d[b+1|0]|0)|0]|0}else{o=R_(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){q=d[k+76+(d[p+1|0]|0)|0]|0}else{q=R_(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){s=d[k+76+(d[p+1|0]|0)|0]|0}else{s=R_(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 2:{l=79;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 8:case 1:case 0:{l=74;break a;break};case 3:{t=v$(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){u=d[k+76+(d[p+1|0]|0)|0]|0}else{u=R_(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(u|0){case 10:case 9:case 21:{break};case 11:{l=106;break a;break};case 17:{l=107;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){v=d[k+76+(d[p+1|0]|0)|0]|0}else{v=R_(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(v|0){case 7:{l=103;break a;break};case 10:case 9:case 21:{break};case 5:{l=97;break a;break};case 11:{l=106;break a;break};case 29:{l=94;break d;break};case 6:{l=100;break a;break};case 17:{l=107;break a;break};case 24:case 22:{break d;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[61816+((d[61560+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[c[j>>2]|0]|0)==0){if((a[(c[j>>2]|0)+1|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function F$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g]|0)==0){k=a[g+1|0]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){l=a[g+1|0]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){m=a[g+1|0]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function G$(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e]|0)==0){m=d[b+76+(d[h+1|0]|0)|0]|0}else{m=R_(a[h]|0,a[e+1|0]|0)|0}h=m;switch(h|0){case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e]|0)==0){p=d[b+76+(d[g+1|0]|0)|0]|0}else{p=R_(a[g]|0,a[e+1|0]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function H$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=R_(a[g]|0,a[b+1|0]|0)|0}if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b]|0)==0){o=d[j+76+(d[g+1|0]|0)|0]|0}else{o=R_(a[g]|0,a[b+1|0]|0)|0}switch(o|0){case 24:case 22:{break};case 10:case 9:case 21:{break a;break};case 30:{n=16;break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+2|0]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=R_(a[o]|0,a[b+3|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==27){k=A$(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function I$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=R_(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[61816+((d[61560+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=R_(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 29:{if((c[61816+((d[63096+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 5:{n=28;break b;break};case 6:{n=31;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=34;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function J$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 9:{if((b+1|0)!=(e|0)){m=15;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 2:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 15:{k=n0(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 16:{k=s0(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -1;k=29;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 30:{k=h0(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 19:{k=t0(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}if((pe[c[j+348>>2]&63](j,b)|0)!=0){b=b+3|0;n=18;break a}g=b;if((pe[c[j+336>>2]&63](j,b)|0)!=0){b=g+3|0;n=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}if((pe[c[j+344>>2]&63](j,b)|0)!=0){b=b+2|0;n=18;break a}g=b;if((pe[c[j+332>>2]&63](j,b)|0)!=0){b=g+2|0;n=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==93){if((b+1|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 20:{c[f>>2]=b+1;k=25;l=k;i=h;return l|0};case 10:case 21:{m=15;break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}if((pe[c[j+352>>2]&63](j,b)|0)!=0){b=b+4|0;n=18;break a}g=b;if((pe[c[j+340>>2]&63](j,b)|0)!=0){b=g+4|0;n=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 11:{c[f>>2]=b+1;k=17;l=k;i=h;return l|0};case 31:{c[f>>2]=b+1;k=23;l=k;i=h;return l|0};case 36:{c[f>>2]=b+1;k=21;l=k;i=h;return l|0};case 13:{k=r0(13,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{n=18;b=b+1|0;break};case 23:case 27:case 26:case 25:{n=19;b=b+1|0;break};case 35:{c[f>>2]=b+1;k=38;l=k;i=h;return l|0};case 32:{b=b+1|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 15:{c[f>>2]=b+1;k=35;l=k;i=h;return l|0};case 34:{c[f>>2]=b+1;k=37;l=k;i=h;return l|0};case 33:{c[f>>2]=b+1;k=36;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 12:{k=r0(12,j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);if((m|0)==15){while(1){m=0;b=b+1|0;o=b;if((b|0)==(e|0)){m=19;break}g=d[j+76+(d[o]|0)|0]|0;if((g|0)==10|(g|0)==21){m=15;continue}else if((g|0)!=9){m=18;break}if((b+1|0)!=(e|0)){m=15}else{m=18;break}}if((m|0)==18){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((m|0)==19){c[f>>2]=o;k=15;l=k;i=h;return l|0}}b:while(1){if((b|0)==(e|0)){m=120;break}switch(d[j+76+(d[b]|0)|0]|0){case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 29:{m=69;break b;break};case 34:{m=110;break b;break};case 7:{if((e-b|0)<4){m=82;break b}p=b;if((pe[c[j+340>>2]&63](j,b)|0)==0){m=84;break b}b=p+4|0;continue b;break};case 15:{m=116;break b;break};case 33:{m=113;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{m=86;break b;break};case 23:{b=b+1|0;o=n;if((o|0)==41){n=19;continue b}else if((o|0)!=18){continue b}if((b|0)==(e|0)){m=89;break b}n=41;switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){m=104;break b}q=b;if((pe[c[j+340>>2]&63](j,b)|0)==0){m=106;break b}b=q+4|0;continue b;break};case 5:{if((e-b|0)<2){m=94;break b}r=b;if((pe[c[j+332>>2]&63](j,b)|0)==0){m=96;break b}b=r+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 6:{if((e-b|0)<3){m=99;break b}s=b;if((pe[c[j+336>>2]&63](j,b)|0)==0){m=101;break b}b=s+3|0;continue b;break};case 29:{m=91;break b;break};default:{n=19;continue b}}break};case 6:{if((e-b|0)<3){m=77;break b}t=b;if((pe[c[j+336>>2]&63](j,b)|0)==0){m=79;break b}b=t+3|0;continue b;break};case 5:{if((e-b|0)<2){m=72;break b}u=b;if((pe[c[j+332>>2]&63](j,b)|0)==0){m=74;break b}b=u+2|0;continue b;break};default:{m=119;break b}}}if((m|0)==69){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==72){k=-2;l=k;i=h;return l|0}else if((m|0)==74){c[f>>2]=u;k=0;l=k;i=h;return l|0}else if((m|0)==77){k=-2;l=k;i=h;return l|0}else if((m|0)==79){c[f>>2]=t;k=0;l=k;i=h;return l|0}else if((m|0)==82){k=-2;l=k;i=h;return l|0}else if((m|0)==84){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==86){c[f>>2]=b;k=n;l=k;i=h;return l|0}else if((m|0)==89){k=-1;l=k;i=h;return l|0}else if((m|0)==91){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==94){k=-2;l=k;i=h;return l|0}else if((m|0)==96){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==99){k=-2;l=k;i=h;return l|0}else if((m|0)==101){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-2;l=k;i=h;return l|0}else if((m|0)==106){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==110){q=b;if((n|0)==19){c[f>>2]=q;k=0;l=k;i=h;return l|0}else{c[f>>2]=q+1;k=32;l=k;i=h;return l|0}}else if((m|0)==113){q=b;if((n|0)==19){c[f>>2]=q;k=0;l=k;i=h;return l|0}else{c[f>>2]=q+1;k=31;l=k;i=h;return l|0}}else if((m|0)==116){q=b;if((n|0)==19){c[f>>2]=q;k=0;l=k;i=h;return l|0}else{c[f>>2]=q+1;k=30;l=k;i=h;return l|0}}else if((m|0)==119){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==120){k=0-n|0;l=k;i=h;return l|0}return 0}function K$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((pe[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((pe[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((pe[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 3:{k=g0(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 2:{k=k0(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=60;break}switch(d[j+76+(d[m]|0)|0]|0){case 4:{if((b+1|0)==(e|0)){n=58;break b}g=b;if((a[b+1|0]|0)!=93){b=g+1|0;continue b}if((g+2|0)==(e|0)){n=58;break b}o=b;if((a[b+2|0]|0)==62){n=57;break b}b=o+1|0;continue b;break};case 7:{if((e-b|0)<4){n=49;break b}if((pe[c[j+364>>2]&63](j,b)|0)!=0){n=49;break b}b=b+4|0;continue b;break};case 6:{if((e-b|0)<3){n=45;break b}if((pe[c[j+360>>2]&63](j,b)|0)!=0){n=45;break b}b=b+3|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{n=58;break b;break};case 5:{if((e-b|0)<2){n=41;break b}if((pe[c[j+356>>2]&63](j,b)|0)!=0){n=41;break b}b=b+2|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==41){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==45){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==57){c[f>>2]=o+2;k=0;l=k;i=h;return l|0}else if((n|0)==58){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==60){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function L$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((pe[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((pe[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((pe[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g+1;k=40;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=51;break}switch(d[j+76+(d[m]|0)|0]|0){case 5:{if((e-b|0)<2){n=39;break b}if((pe[c[j+356>>2]&63](j,b)|0)!=0){n=39;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){n=47;break b}if((pe[c[j+364>>2]&63](j,b)|0)!=0){n=47;break b}b=b+4|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{n=49;break b;break};case 6:{if((e-b|0)<3){n=43;break b}if((pe[c[j+360>>2]&63](j,b)|0)!=0){n=43;break b}b=b+3|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==39){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==43){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==47){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==51){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function M$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;g=0;a:while(1){if((b|0)==(e|0)){k=37;break}switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){k=15;break a}l=b;if((pe[c[j+364>>2]&63](j,b)|0)!=0){k=17;break a}b=l+4|0;continue a;break};case 5:{if((e-b|0)<2){k=5;break a}m=b;if((pe[c[j+356>>2]&63](j,b)|0)!=0){k=7;break a}b=m+2|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}n=b;if((pe[c[j+360>>2]&63](j,b)|0)!=0){k=12;break a}b=n+3|0;continue a;break};case 4:{o=b+1|0;b=o;if((o|0)==(e|0)){k=28;break a}if((a[b]|0)!=93){continue a}o=b+1|0;b=o;if((o|0)==(e|0)){k=31;break a}if((a[b]|0)!=62){continue a}b=b+1|0;if((g|0)==0){k=34;break a}g=g+ -1|0;continue a;break};case 2:{o=b+1|0;b=o;if((o|0)==(e|0)){k=21;break a}if((a[b]|0)!=33){continue a}o=b+1|0;b=o;if((o|0)==(e|0)){k=24;break a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+1|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){p=-2;q=p;i=h;return q|0}else if((k|0)==7){c[f>>2]=m;p=0;q=p;i=h;return q|0}else if((k|0)==10){p=-2;q=p;i=h;return q|0}else if((k|0)==12){c[f>>2]=n;p=0;q=p;i=h;return q|0}else if((k|0)==15){p=-2;q=p;i=h;return q|0}else if((k|0)==17){c[f>>2]=l;p=0;q=p;i=h;return q|0}else if((k|0)==19){c[f>>2]=b;p=0;q=p;i=h;return q|0}else if((k|0)==21){p=-1;q=p;i=h;return q|0}else if((k|0)==24){p=-1;q=p;i=h;return q|0}else if((k|0)==28){p=-1;q=p;i=h;return q|0}else if((k|0)==31){p=-1;q=p;i=h;return q|0}else if((k|0)==34){c[f>>2]=b;p=42;q=p;i=h;return q|0}else if((k|0)==37){p=-1;q=p;i=h;return q|0}return 0}function N$(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=27;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 21:{m=23;break a;break};case 9:{m=16;break a;break};case 3:{m=9;break a;break};case 7:{a=a+4|0;continue a;break};case 2:{m=12;break a;break};case 10:{m=13;break a;break};case 5:{a=a+2|0;continue a;break};case 6:{a=a+3|0;continue a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=g0(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((m|0)==13){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==16){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==23){h=a;if((a|0)==(f|0)){c[e>>2]=h+1;j=39;k=j;i=g;return k|0}else{c[e>>2]=h;j=6;k=j;i=g;return k|0}}else if((m|0)==27){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function O$(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+56|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=26;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 10:{m=15;break a;break};case 7:{a=a+4|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 9:{m=18;break a;break};case 3:{m=9;break a;break};case 5:{a=a+2|0;continue a;break};case 30:{m=12;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=g0(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){if((a|0)==(f|0)){n=h0(h,a+1|0,b,e)|0;j=(n|0)==22?0:n;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==15){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==18){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==26){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function P$(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){switch(d[g+76+(d[b]|0)|0]|0){case 7:{e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=4;break a}else{j=5}break};case 6:{j=5;break};case 5:{break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{h=c;c=h+1|0;e=b;b=e+1|0;if((a[h]|0)!=(a[e]|0)){j=12;break a}else{continue a}break};default:{j=13;break a}}if((j|0)==5){j=0;e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=6;break}}h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=8;break}e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=10;break}}if((j|0)==4){k=0;l=k;i=f;return l|0}else if((j|0)==6){k=0;l=k;i=f;return l|0}else if((j|0)==8){k=0;l=k;i=f;return l|0}else if((j|0)==10){k=0;l=k;i=f;return l|0}else if((j|0)==12){k=0;l=k;i=f;return l|0}else if((j|0)==13){if((a[b]|0)==(a[c]|0)){k=1;l=k;i=f;return l|0}switch(d[g+76+(d[c]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{k=0;l=k;i=f;return l|0};default:{k=1;l=k;i=f;return l|0}}}return 0}function Q$(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=8;break}if(g){h=4;break}if((a[f]|0)!=(a[d]|0)){h=6;break}f=f+1|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==6){j=0;k=j;i=b;return k|0}else if((h|0)==8){j=g&1;k=j;i=b;return k|0}return 0}function R$(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+24|0;e=a;a=b;b=a;a:while(1){switch(d[e+76+(d[a]|0)|0]|0|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{a=a+1|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 5:{a=a+2|0;continue a;break};default:{break a}}}i=c;return a-b|0}function S$(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+16|0;e=a;a=b;while(1){b=d[e+76+(d[a]|0)|0]|0;if(!((b|0)==21|(b|0)==9|(b|0)==10)){break}a=a+1|0}i=c;return a|0}function T$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+1|0;a:while(1){b:do{switch(d[j+76+(d[b]|0)|0]|0){case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)!=32){break}if((a[b+1|0]|0)==32){break}if((d[j+76+(d[b+1|0]|0)|0]|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+3|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};default:{}}}while(0);b=b+1|0}i=h;return k|0}function U$(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=c;c=0;d=d+2|0;a:do{if((a[d]|0)==120){d=d+1|0;while(1){if(!((a[d]|0)==59^1)){break a}e=a[d]|0;switch(e|0){case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|e-48;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(e-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(e-97))|0;break};default:{}}if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}else{while(1){if(!((a[d]|0)==59^1)){break a}c=c*10|0;c=c+((a[d]|0)-48)|0;if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}}while(0);f=d_(c)|0;g=f;i=b;return g|0}function V$(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+32|0;e=c;c=(d-e|0)/1|0;do{if((c|0)==2){if((a[e+1|0]|0)!=116){break}d=a[e]|0;if((d|0)==103){f=62;g=f;i=b;return g|0}else if((d|0)==108){f=60;g=f;i=b;return g|0}else{break}}else if((c|0)==4){d=a[e]|0;if((d|0)==113){e=e+1|0;if((a[e]|0)!=117){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else if((d|0)==97){e=e+1|0;if((a[e]|0)!=112){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else{break}}else if((c|0)==3){if((a[e]|0)!=97){break}e=e+1|0;if((a[e]|0)!=109){break}e=e+1|0;if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}}while(0);f=0;g=f;i=b;return g|0}function W$(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=a;a=b;b=e;e=f;while(1){if(!(a>>>0<b>>>0)){break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{a=a+2|0;break};case 9:{f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;do{if((a|0)!=(b|0)){if((d[h+76+(d[a]|0)|0]|0|0)!=10){break}a=a+1|0}}while(0);c[e+4>>2]=-1;break};case 7:{a=a+4|0;break};case 10:{c[e+4>>2]=-1;f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;break};case 6:{a=a+3|0;break};default:{a=a+1|0}}f=e+4|0;c[f>>2]=(c[f>>2]|0)+1}i=g;return}function X$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+1|0;e=e+ -1|0;a:while(1){if((b|0)==(e|0)){k=10;break}switch(d[j+76+(d[b]|0)|0]|0){case 22:case 26:{if((a[b]&-128|0)!=0){k=7}break};case 21:{if((a[b]|0)==9){k=5;break a}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=7}}if((k|0)==7){k=0;g=a[b]|0;if(!((g|0)==64|(g|0)==36)){k=8;break}}b=b+1|0}if((k|0)==5){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==8){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==10){l=1;m=l;i=h;return m|0}return 0}function Y$(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+56|0;h=d;d=e;e=f;f=g;a:do{if((d-(c[h>>2]|0)|0)>(f-(c[e>>2]|0)|0)){d=(c[h>>2]|0)+(f-(c[e>>2]|0))|0;while(1){if(!(d>>>0>(c[h>>2]|0)>>>0)){break a}if((a[d+ -1|0]&192|0)!=128){break a}d=d+ -1|0}}}while(0);f=c[e>>2]|0;g=c[h>>2]|0;while(1){j=g;if((g|0)==(d|0)){break}a[f]=a[j]|0;g=g+1|0;f=f+1|0}c[h>>2]=j;c[e>>2]=f;i=b;return}function Z$(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+64|0;l=e;e=f;f=g;g=h;h=j;j=c[g>>2]|0;m=c[e>>2]|0;while(1){if((m|0)==(f|0)){n=10;break}if((j|0)==(h|0)){n=10;break}o=d[l+76+(d[m]|0)|0]|0;if((o|0)==5){p=j;j=p+2|0;b[p>>1]=(a[m]&31)<<6|a[m+1|0]&63;m=m+2|0;continue}else if((o|0)==7){if((j+2|0)==(h|0)){n=10;break}p=(a[m]&7)<<18|(a[m+1|0]&63)<<12|(a[m+2|0]&63)<<6|a[m+3|0]&63;p=p-65536|0;b[j>>1]=p>>>10|55296;b[j+2>>1]=p&1023|56320;j=j+4|0;m=m+4|0;continue}else if((o|0)==6){o=j;j=o+2|0;b[o>>1]=(a[m]&15)<<12|(a[m+1|0]&63)<<6|a[m+2|0]&63;m=m+3|0;continue}else{o=m;m=o+1|0;p=j;j=p+2|0;b[p>>1]=a[o]|0;continue}}if((n|0)==10){c[e>>2]=m;c[g>>2]=j;i=k;return}}function _$(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[61816+(((d[63096+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function $$(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[61816+(((d[63096+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function a0(a,b){a=a|0;b=b|0;b=i;i=i+16|0;i=b;return 0}function b0(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[61816+(((d[61560+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function c0(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[61816+(((d[61560+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function d0(b,c){b=b|0;c=c|0;var e=0,f=0;b=i;i=i+16|0;e=c;do{if((d[e]|0|0)<194){f=1}else{if((a[e+1|0]&128|0)==0){f=1;break}f=(a[e+1|0]&192|0)==192}}while(0);i=b;return f&1|0}function e0(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}do{if((d[e]|0|0)==239){if((d[e+1|0]|0|0)!=191){h=5;break}if((d[e+2|0]|0|0)>189){f=1}else{break}g=f&1;i=b;return g|0}else{h=5}}while(0);do{if((h|0)==5){if((a[e+2|0]&192|0)==192){f=1}else{break}g=f&1;i=b;return g|0}}while(0);h=d[e+1|0]|0;do{if((d[e]|0|0)==224){if((h|0)<160){j=1;break}j=(a[e+1|0]&192|0)==192}else{if((h&128|0)==0){j=1;break}c=d[e+1|0]|0;if((d[e]|0|0)==237){k=(c|0)>159}else{k=(c&192|0)==192}j=(k&1|0)!=0}}while(0);f=(j&1|0)!=0;g=f&1;i=b;return g|0}function f0(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+3|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+3|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}c=d[e+1|0]|0;do{if((d[e]|0|0)==240){if((c|0)<144){h=1;break}h=(a[e+1|0]&192|0)==192}else{if((c&128|0)==0){h=1;break}j=d[e+1|0]|0;if((d[e]|0|0)==244){k=(j|0)>143}else{k=(j&192|0)==192}h=(k&1|0)!=0}}while(0);f=(h&1|0)!=0;g=f&1;i=b;return g|0}function g0(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 19:{j=i0(h,a+1|0,b,e)|0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((pe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((pe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((pe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{l=25;break b;break};case 7:{if((b-a|0)<4){l=38;break b}m=a;if((pe[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=m+4|0;continue b;break};case 6:{if((b-a|0)<3){l=33;break b}n=a;if((pe[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=n+3|0;continue b;break};case 18:{l=42;break b;break};case 5:{if((b-a|0)<2){l=28;break b}o=a;if((pe[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=o+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=9;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function h0(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((pe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((pe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 30:case 9:case 10:case 21:{c[e>>2]=a;j=22;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((pe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}m=a;if((pe[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=m+4|0;continue b;break};case 5:{if((b-a|0)<2){l=28;break b}n=a;if((pe[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=n+2|0;continue b;break};case 6:{if((b-a|0)<3){l=33;break b}o=a;if((pe[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=o+3|0;continue b;break};case 29:{l=25;break b;break};case 18:{l=42;break b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=28;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function i0(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){if((a[b]|0)==120){k=j0(j,b+1|0,e,f)|0;l=k;i=h;return l|0}g=b;if((d[j+76+(d[b]|0)|0]|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;while(1){if((b|0)==(e|0)){break a}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==18){m=9;break}else if((g|0)!=25){m=10;break}b=b+1|0}if((m|0)==9){c[f>>2]=b+1;k=10;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}



function sra(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;g=b;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=ae[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=ae[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{if(h){n=d;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){o=ae[c[(c[h>>2]|0)+36>>2]&127](h)|0}else{o=c[d>>2]|0}if(!((de[c[(c[f>>2]|0)+52>>2]&63](f,o,0)|0)<<24>>24==37)){c[e>>2]=c[e>>2]|4;i=a;return}o=c[g>>2]|0;f=o+12|0;d=c[f>>2]|0;if((d|0)==(c[o+16>>2]|0)){ae[c[(c[o>>2]|0)+40>>2]&127](o)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){p=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){q=ae[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{q=c[f>>2]|0}if((q|0)==-1){c[g>>2]=0;p=1;break}else{p=(c[g>>2]|0)==0;break}}}while(0);do{if((n|0)==0){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){r=ae[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{r=c[g>>2]|0}if((r|0)==-1){c[k>>2]=0;l=38;break}if(!p){break}i=a;return}}while(0);do{if((l|0)==38){if(p){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function tra(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;h=a;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=ae[c[(c[a>>2]|0)+36>>2]&127](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=ae[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=ae[c[(c[j>>2]|0)+36>>2]&127](j)|0}else{q=c[b>>2]|0}if(!(de[c[(c[e>>2]|0)+12>>2]&63](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}b=(de[c[(c[e>>2]|0)+52>>2]&63](e,q,0)|0)<<24>>24;q=c[h>>2]|0;j=q+12|0;n=c[j>>2]|0;if((n|0)==(c[q+16>>2]|0)){ae[c[(c[q>>2]|0)+40>>2]&127](q)|0;r=f;s=o;t=o;u=b}else{c[j>>2]=n+4;r=f;s=o;t=o;u=b}while(1){v=u+ -48|0;b=r+ -1|0;o=c[h>>2]|0;do{if((o|0)==0){w=1}else{f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0)){x=ae[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{x=c[f>>2]|0}if((x|0)==-1){c[h>>2]=0;w=1;break}else{w=(c[h>>2]|0)==0;break}}}while(0);do{if((t|0)==0){y=s;z=0;A=1}else{o=c[t+12>>2]|0;if((o|0)==(c[t+16>>2]|0)){B=ae[c[(c[t>>2]|0)+36>>2]&127](t)|0}else{B=c[o>>2]|0}if((B|0)==-1){c[l>>2]=0;y=0;z=0;A=1;break}else{y=s;z=s;A=(s|0)==0;break}}}while(0);C=c[h>>2]|0;if(!((w^A)&(b|0)>0)){break}o=c[C+12>>2]|0;if((o|0)==(c[C+16>>2]|0)){D=ae[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{D=c[o>>2]|0}if(!(de[c[(c[e>>2]|0)+12>>2]&63](e,2048,D)|0)){p=v;m=63;break}o=((de[c[(c[e>>2]|0)+52>>2]&63](e,D,0)|0)<<24>>24)+(v*10|0)|0;f=c[h>>2]|0;n=f+12|0;j=c[n>>2]|0;if((j|0)==(c[f+16>>2]|0)){ae[c[(c[f>>2]|0)+40>>2]&127](f)|0;E=b;s=y;t=z;u=o;r=E;continue}else{c[n>>2]=j+4;E=b;s=y;t=z;u=o;r=E;continue}}if((m|0)==63){i=g;return p|0}do{if((C|0)==0){F=1}else{E=c[C+12>>2]|0;if((E|0)==(c[C+16>>2]|0)){G=ae[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[h>>2]=0;F=1;break}else{F=(c[h>>2]|0)==0;break}}}while(0);do{if((y|0)==0){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){H=ae[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{H=c[h>>2]|0}if((H|0)==-1){c[l>>2]=0;m=60;break}if(F){p=v}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(F){break}else{p=v}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=v;i=g;return p|0}function ura(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);if((f|0)==(c[36280]|0)){g=b;Rwa(g);i=d;return}$b(c[e>>2]|0);g=b;Rwa(g);i=d;return}function vra(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);if((b|0)==(c[36280]|0)){i=d;return}$b(c[e>>2]|0);i=d;return}function wra(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;f=g;l=g+8|0;m=l;n=f;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(!(k<<24>>24==0)){a[o]=k;a[p]=j}j=Rc(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b;s=r;c[s>>2]=q;i=g;return}else{t=m;u=l;v=l}while(1){l=a[t]|0;do{if((v|0)==0){w=u;x=0}else{m=v+24|0;j=c[m>>2]|0;if((j|0)==(c[v+28>>2]|0)){e=(pe[c[(c[v>>2]|0)+52>>2]&63](v,l&255)|0)==-1;w=e?0:u;x=e?0:v;break}else{c[m>>2]=j+1;a[j]=l;w=u;x=v;break}}}while(0);l=t+1|0;if((l|0)==(d|0)){q=w;break}else{t=l;u=w;v=x}}r=b;s=r;c[s>>2]=q;i=g;return}function xra(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);if((f|0)==(c[36280]|0)){g=b;Rwa(g);i=d;return}$b(c[e>>2]|0);g=b;Rwa(g);i=d;return}function yra(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);if((b|0)==(c[36280]|0)){i=d;return}$b(c[e>>2]|0);i=d;return}function zra(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+408|0;e=f;k=f+400|0;l=e;c[k>>2]=e+400;Ara(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a;o=n;c[o>>2]=m;i=f;return}else{p=l;q=k;r=k}while(1){k=c[p>>2]|0;if((q|0)==0){s=r;t=0}else{l=q+24|0;d=c[l>>2]|0;if((d|0)==(c[q+28>>2]|0)){u=pe[c[(c[q>>2]|0)+52>>2]&63](q,k)|0}else{c[l>>2]=d+4;c[d>>2]=k;u=k}k=(u|0)==-1;s=k?0:r;t=k?0:q}k=p+4|0;if((k|0)==(j|0)){m=s;break}else{p=k;q=t;r=s}}n=a;o=n;c[o>>2]=m;i=f;return}function Ara(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j;l=j+112|0;m=i;i=i+8|0;n=j+8|0;o=k;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(!(h<<24>>24==0)){a[p]=h;a[q]=g}g=b;Rc(n|0,100,o|0,f|0,c[g>>2]|0)|0;f=l;c[f>>2]=0;c[f+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=Kc(c[g>>2]|0)|0;g=Mva(d,m,n,l)|0;if((f|0)!=0){Kc(f|0)|0}if((g|0)==-1){wsa(146112)}else{c[e>>2]=d+(g<<2);i=j;return}}function Bra(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function Cra(a){a=a|0;i=i;return}function Dra(a){a=a|0;i=i;return 127}function Era(a){a=a|0;i=i;return 127}function Fra(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Gra(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Hra(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Ira(a,b){a=a|0;b=b|0;b=i;Ama(a,1,45);i=b;return}function Jra(a){a=a|0;i=i;return 0}function Kra(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function Lra(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function Mra(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function Nra(a){a=a|0;i=i;return}function Ora(a){a=a|0;i=i;return 127}function Pra(a){a=a|0;i=i;return 127}function Qra(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Rra(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Sra(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Tra(a,b){a=a|0;b=b|0;b=i;Ama(a,1,45);i=b;return}function Ura(a){a=a|0;i=i;return 0}function Vra(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function Wra(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function Xra(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function Yra(a){a=a|0;i=i;return}function Zra(a){a=a|0;i=i;return 2147483647}function _ra(a){a=a|0;i=i;return 2147483647}function $ra(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function asa(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function bsa(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function csa(a,b){a=a|0;b=b|0;b=i;fna(a,1,45);i=b;return}function dsa(a){a=a|0;i=i;return 0}function esa(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function fsa(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function gsa(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function hsa(a){a=a|0;i=i;return}function isa(a){a=a|0;i=i;return 2147483647}function jsa(a){a=a|0;i=i;return 2147483647}function ksa(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function lsa(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function msa(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function nsa(a,b){a=a|0;b=b|0;b=i;fna(a,1,45);i=b;return}function osa(a){a=a|0;i=i;return 0}function psa(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function qsa(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function rsa(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function ssa(a){a=a|0;i=i;return}function tsa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+104|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=966;y=o+100|0;Ana(r,h);o=r;z=c[o>>2]|0;if(!((c[36308]|0)==-1)){c[n>>2]=145232;c[n+4>>2]=964;c[n+8>>2]=0;pma(145232,n,965)}n=(c[145236>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Dc(4)|0;C=B;owa(C);D=160792;E=127;Ld(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Dc(4)|0;C=B;owa(C);D=160792;E=127;Ld(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=vsa(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;ze[c[(c[z>>2]|0)+32>>2]&63](E,144848,144858|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>98){l=Jwa(g+2|0)|0;if((l|0)!=0){F=l;G=l;break}Wwa()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+10|0;l=u;h=H;t=r;while(1){C=a[t]|0;n=y;while(1){A=n+1|0;if((a[n]|0)==C<<24>>24){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[144848+(I-l)|0]|0;n=t+1|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((qd(p|0,144864,m|0)|0)!=1){t=Dc(8)|0;ama(t,144872);Ld(t|0,142224,42)}if((F|0)==0){break}Kwa(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){K=e;break}if(!((ae[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){K=e;break}c[F>>2]=0;K=0}}while(0);F=(K|0)==0;e=c[D>>2]|0;do{if((e|0)==0){L=31}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){if(F){break}else{L=33;break}}if((ae[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[D>>2]=0;L=31;break}else{if(F){break}else{L=33;break}}}}while(0);if((L|0)==31){if(F){L=33}}if((L|0)==33){c[j>>2]=c[j>>2]|2}c[b>>2]=K;Wla(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}Zd[c[x>>2]&1023](o);i=d;return}function usa(a){a=a|0;i=i;return}function vsa(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0;q=i;i=i+408|0;r=q;s=q+400|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=r;c[s>>2]=0;E=w;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=x;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=y;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=z;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=A;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;zsa(g,h,t,u,v,w,x,y,z,B);t=n;c[o>>2]=c[t>>2];h=e;e=f;f=m+8|0;m=z+1|0;g=z+4|0;E=z+8|0;F=y+1|0;G=y+4|0;H=y+8|0;I=(j&512|0)!=0;j=x+1|0;J=x+8|0;K=x+4|0;L=A+1|0;M=A+8|0;N=A+4|0;O=s+3|0;P=n+4|0;n=w+4|0;Q=r+400|0;r=D;R=D;D=p;p=0;S=0;T=966;a:while(1){U=c[h>>2]|0;do{if((U|0)==0){V=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){V=U;break}if((ae[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;V=0;break}else{V=c[h>>2]|0;break}}}while(0);U=(V|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=12}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}if((ae[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=12;break}else{if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}}}while(0);if((X|0)==12){X=0;if(U){Z=R;_=r;$=S;aa=T;X=269;break}else{Y=0}}b:do{switch(a[s+p|0]|0){case 1:{if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}W=c[h>>2]|0;ba=c[W+12>>2]|0;if((ba|0)==(c[W+16>>2]|0)){ca=(ae[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255}else{ca=a[ba]|0}if(!(ca<<24>>24>-1)){X=25;break a}if((b[(c[f>>2]|0)+(ca<<24>>24<<1)>>1]&8192)==0){X=25;break a}ba=c[h>>2]|0;W=ba+12|0;da=c[W>>2]|0;if((da|0)==(c[ba+16>>2]|0)){ea=(ae[c[(c[ba>>2]|0)+40>>2]&127](ba)|0)&255}else{c[W>>2]=da+1;ea=a[da]|0}Wma(A,ea);X=26;break};case 3:{da=a[y]|0;W=(da&1)==0;if(W){fa=(da&255)>>>1}else{fa=c[G>>2]|0}ba=a[z]|0;ga=(ba&1)==0;if(ga){ha=(ba&255)>>>1}else{ha=c[g>>2]|0}if((fa|0)==(0-ha|0)){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break b}if(W){oa=(da&255)>>>1}else{oa=c[G>>2]|0}do{if((oa|0)!=0){if(ga){pa=(ba&255)>>>1}else{pa=c[g>>2]|0}if((pa|0)==0){break}qa=c[h>>2]|0;ra=c[qa+12>>2]|0;sa=c[qa+16>>2]|0;if((ra|0)==(sa|0)){ta=(ae[c[(c[qa>>2]|0)+36>>2]&127](qa)|0)&255;ua=c[h>>2]|0;va=ta;wa=c[ua+16>>2]|0;xa=c[ua+12>>2]|0;ya=ua;za=a[y]|0}else{va=a[ra]|0;wa=sa;xa=ra;ya=qa;za=da}qa=ya+12|0;ra=(xa|0)==(wa|0);if(va<<24>>24==(a[(za&1)==0?F:c[H>>2]|0]|0)){if(ra){ae[c[(c[ya>>2]|0)+40>>2]&127](ya)|0}else{c[qa>>2]=xa+1}qa=a[y]|0;if((qa&1)==0){Aa=(qa&255)>>>1}else{Aa=c[G>>2]|0}ia=D;ja=R;ka=r;la=Q;ma=Aa>>>0>1?y:S;na=T;break b}if(ra){Ba=(ae[c[(c[ya>>2]|0)+36>>2]&127](ya)|0)&255}else{Ba=a[xa]|0}if(!(Ba<<24>>24==(a[(a[z]&1)==0?m:c[E>>2]|0]|0))){X=112;break a}ra=c[h>>2]|0;qa=ra+12|0;sa=c[qa>>2]|0;if((sa|0)==(c[ra+16>>2]|0)){ae[c[(c[ra>>2]|0)+40>>2]&127](ra)|0}else{c[qa>>2]=sa+1}a[l]=1;sa=a[z]|0;if((sa&1)==0){Ca=(sa&255)>>>1}else{Ca=c[g>>2]|0}ia=D;ja=R;ka=r;la=Q;ma=Ca>>>0>1?z:S;na=T;break b}}while(0);if(W){Da=(da&255)>>>1}else{Da=c[G>>2]|0}ga=c[h>>2]|0;sa=c[ga+12>>2]|0;qa=(sa|0)==(c[ga+16>>2]|0);if((Da|0)==0){if(qa){ra=(ae[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)&255;Ea=ra;Fa=a[z]|0}else{Ea=a[sa]|0;Fa=ba}if(!(Ea<<24>>24==(a[(Fa&1)==0?m:c[E>>2]|0]|0))){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break b}ra=c[h>>2]|0;ua=ra+12|0;ta=c[ua>>2]|0;if((ta|0)==(c[ra+16>>2]|0)){ae[c[(c[ra>>2]|0)+40>>2]&127](ra)|0}else{c[ua>>2]=ta+1}a[l]=1;ta=a[z]|0;if((ta&1)==0){Ga=(ta&255)>>>1}else{Ga=c[g>>2]|0}ia=D;ja=R;ka=r;la=Q;ma=Ga>>>0>1?z:S;na=T;break b}if(qa){qa=(ae[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)&255;Ha=qa;Ia=a[y]|0}else{Ha=a[sa]|0;Ia=da}if(!(Ha<<24>>24==(a[(Ia&1)==0?F:c[H>>2]|0]|0))){a[l]=1;ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break b}sa=c[h>>2]|0;qa=sa+12|0;ga=c[qa>>2]|0;if((ga|0)==(c[sa+16>>2]|0)){ae[c[(c[sa>>2]|0)+40>>2]&127](sa)|0}else{c[qa>>2]=ga+1}ga=a[y]|0;if((ga&1)==0){Ja=(ga&255)>>>1}else{Ja=c[G>>2]|0}ia=D;ja=R;ka=r;la=Q;ma=Ja>>>0>1?y:S;na=T;break};case 2:{if(!((S|0)!=0|p>>>0<2)){if((p|0)==2){Ka=(a[O]|0)!=0}else{Ka=0}if(!(I|Ka)){ia=D;ja=R;ka=r;la=Q;ma=0;na=T;break b}}ga=a[x]|0;qa=(ga&1)==0;sa=qa?j:c[J>>2]|0;c:do{if((p|0)==0){La=Y;Ma=Y;Na=ga;Oa=sa}else{if((d[s+(p+ -1)|0]|0)>=2){La=Y;Ma=Y;Na=ga;Oa=sa;break}ta=sa+(qa?(ga&255)>>>1:c[K>>2]|0)|0;ua=sa;while(1){if((ua|0)==(ta|0)){Pa=ta;break}ra=a[ua]|0;if(!(ra<<24>>24>-1)){Pa=ua;break}if((b[(c[f>>2]|0)+(ra<<24>>24<<1)>>1]&8192)==0){Pa=ua;break}else{ua=ua+1|0}}ua=Pa-sa|0;ta=a[A]|0;ra=(ta&1)==0;if(ra){Qa=(ta&255)>>>1}else{Qa=c[N>>2]|0}if(ua>>>0>Qa>>>0){La=Y;Ma=Y;Na=ga;Oa=sa;break}if(ra){ra=(ta&255)>>>1;Ra=A+1+(ra-ua)|0;Sa=L;Ta=ra}else{ra=c[M>>2]|0;ta=c[N>>2]|0;Ra=ra+(ta-ua)|0;Sa=ra;Ta=ta}ta=Sa+Ta|0;if((Ra|0)==(ta|0)){La=Y;Ma=Y;Na=ga;Oa=Pa;break}else{Ua=sa;Va=Ra}while(1){if((a[Va]|0)!=(a[Ua]|0)){La=Y;Ma=Y;Na=ga;Oa=sa;break c}ra=Va+1|0;if((ra|0)==(ta|0)){La=Y;Ma=Y;Na=ga;Oa=Pa;break}else{Ua=Ua+1|0;Va=ra}}}}while(0);d:while(1){if((Na&1)==0){Wa=j;Xa=(Na&255)>>>1}else{Wa=c[J>>2]|0;Xa=c[K>>2]|0}if((Oa|0)==(Wa+Xa|0)){break}ga=c[h>>2]|0;do{if((ga|0)==0){Ya=0}else{if((c[ga+12>>2]|0)!=(c[ga+16>>2]|0)){Ya=ga;break}if((ae[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)==-1){c[h>>2]=0;Ya=0;break}else{Ya=c[h>>2]|0;break}}}while(0);ga=(Ya|0)==0;do{if((Ma|0)==0){Za=La;X=147}else{if((c[Ma+12>>2]|0)!=(c[Ma+16>>2]|0)){if(ga){_a=La;$a=Ma;break}else{break d}}if((ae[c[(c[Ma>>2]|0)+36>>2]&127](Ma)|0)==-1){c[e>>2]=0;Za=0;X=147;break}else{if(ga^(La|0)==0){_a=La;$a=La;break}else{break d}}}}while(0);if((X|0)==147){X=0;if(ga){break}else{_a=Za;$a=0}}sa=c[h>>2]|0;qa=c[sa+12>>2]|0;if((qa|0)==(c[sa+16>>2]|0)){ab=(ae[c[(c[sa>>2]|0)+36>>2]&127](sa)|0)&255}else{ab=a[qa]|0}if(!(ab<<24>>24==(a[Oa]|0))){break}qa=c[h>>2]|0;sa=qa+12|0;da=c[sa>>2]|0;if((da|0)==(c[qa+16>>2]|0)){ae[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[sa>>2]=da+1}La=_a;Ma=$a;Na=a[x]|0;Oa=Oa+1|0}if(!I){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break b}da=a[x]|0;if((da&1)==0){bb=j;cb=(da&255)>>>1}else{bb=c[J>>2]|0;cb=c[K>>2]|0}if((Oa|0)==(bb+cb|0)){ia=D;ja=R;ka=r;la=Q;ma=S;na=T}else{X=162;break a}break};case 4:{da=D;sa=R;qa=r;ba=Q;W=0;ta=T;e:while(1){ra=c[h>>2]|0;do{if((ra|0)==0){db=0}else{if((c[ra+12>>2]|0)!=(c[ra+16>>2]|0)){db=ra;break}if((ae[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)==-1){c[h>>2]=0;db=0;break}else{db=c[h>>2]|0;break}}}while(0);ra=(db|0)==0;ga=c[e>>2]|0;do{if((ga|0)==0){X=173}else{if((c[ga+12>>2]|0)!=(c[ga+16>>2]|0)){if(ra){break}else{break e}}if((ae[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)==-1){c[e>>2]=0;X=173;break}else{if(ra){break}else{break e}}}}while(0);if((X|0)==173){X=0;if(ra){break}}ga=c[h>>2]|0;ua=c[ga+12>>2]|0;if((ua|0)==(c[ga+16>>2]|0)){eb=(ae[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)&255}else{eb=a[ua]|0}do{if(eb<<24>>24>-1){if((b[(c[f>>2]|0)+(eb<<24>>24<<1)>>1]&2048)==0){X=189;break}ua=c[o>>2]|0;if((ua|0)==(da|0)){ga=(c[P>>2]|0)!=966;fb=c[t>>2]|0;gb=da-fb|0;hb=gb>>>0<2147483647?gb<<1:-1;ib=Mwa(ga?fb:0,hb)|0;if((ib|0)==0){X=182;break a}do{if(ga){c[t>>2]=ib;jb=ib}else{fb=c[t>>2]|0;c[t>>2]=ib;if((fb|0)==0){jb=ib;break}Zd[c[P>>2]&1023](fb);jb=c[t>>2]|0}}while(0);c[P>>2]=941;ib=jb+gb|0;c[o>>2]=ib;kb=ib;lb=(c[t>>2]|0)+hb|0}else{kb=ua;lb=da}c[o>>2]=kb+1;a[kb]=eb;mb=lb;nb=sa;ob=qa;pb=ba;qb=W+1|0;rb=ta}else{X=189}}while(0);if((X|0)==189){X=0;ra=a[w]|0;if((ra&1)==0){sb=(ra&255)>>>1}else{sb=c[n>>2]|0}if((sb|0)==0|(W|0)==0){break}if(!(eb<<24>>24==(a[v]|0))){break}if((qa|0)==(ba|0)){ra=qa-sa|0;ib=ra>>>0<2147483647?ra<<1:-1;if((ta|0)==966){tb=0}else{tb=sa}ga=Mwa(tb,ib)|0;if((ga|0)==0){X=198;break a}ub=ga;vb=ga+(ra>>2<<2)|0;wb=ga+(ib>>>2<<2)|0;xb=941}else{ub=sa;vb=qa;wb=ba;xb=ta}c[vb>>2]=W;mb=da;nb=ub;ob=vb+4|0;pb=wb;qb=0;rb=xb}ib=c[h>>2]|0;ga=ib+12|0;ra=c[ga>>2]|0;if((ra|0)==(c[ib+16>>2]|0)){ae[c[(c[ib>>2]|0)+40>>2]&127](ib)|0;da=mb;sa=nb;qa=ob;ba=pb;W=qb;ta=rb;continue}else{c[ga>>2]=ra+1;da=mb;sa=nb;qa=ob;ba=pb;W=qb;ta=rb;continue}}if((sa|0)==(qa|0)|(W|0)==0){yb=sa;zb=qa;Ab=ba;Bb=ta}else{if((qa|0)==(ba|0)){ra=qa-sa|0;ga=ra>>>0<2147483647?ra<<1:-1;if((ta|0)==966){Cb=0}else{Cb=sa}ib=Mwa(Cb,ga)|0;if((ib|0)==0){X=209;break a}Db=ib;Eb=ib+(ra>>2<<2)|0;Fb=ib+(ga>>>2<<2)|0;Gb=941}else{Db=sa;Eb=qa;Fb=ba;Gb=ta}c[Eb>>2]=W;yb=Db;zb=Eb+4|0;Ab=Fb;Bb=Gb}if((c[B>>2]|0)>0){ga=c[h>>2]|0;do{if((ga|0)==0){Hb=0}else{if((c[ga+12>>2]|0)!=(c[ga+16>>2]|0)){Hb=ga;break}if((ae[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)==-1){c[h>>2]=0;Hb=0;break}else{Hb=c[h>>2]|0;break}}}while(0);ga=(Hb|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=223}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(ga){Ib=W;break}else{X=229;break a}}if((ae[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=223;break}else{if(ga){Ib=W;break}else{X=229;break a}}}}while(0);if((X|0)==223){X=0;if(ga){X=229;break a}else{Ib=0}}W=c[h>>2]|0;ta=c[W+12>>2]|0;if((ta|0)==(c[W+16>>2]|0)){Jb=(ae[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255}else{Jb=a[ta]|0}if(!(Jb<<24>>24==(a[u]|0))){X=229;break a}ta=c[h>>2]|0;W=ta+12|0;ba=c[W>>2]|0;if((ba|0)==(c[ta+16>>2]|0)){ae[c[(c[ta>>2]|0)+40>>2]&127](ta)|0;Kb=Ib;Lb=Ib;Mb=da}else{c[W>>2]=ba+1;Kb=Ib;Lb=Ib;Mb=da}while(1){ba=c[h>>2]|0;do{if((ba|0)==0){Nb=0}else{if((c[ba+12>>2]|0)!=(c[ba+16>>2]|0)){Nb=ba;break}if((ae[c[(c[ba>>2]|0)+36>>2]&127](ba)|0)==-1){c[h>>2]=0;Nb=0;break}else{Nb=c[h>>2]|0;break}}}while(0);ba=(Nb|0)==0;do{if((Lb|0)==0){Ob=Kb;X=243}else{if((c[Lb+12>>2]|0)!=(c[Lb+16>>2]|0)){if(ba){Pb=Kb;Qb=Lb;break}else{X=250;break a}}if((ae[c[(c[Lb>>2]|0)+36>>2]&127](Lb)|0)==-1){c[e>>2]=0;Ob=0;X=243;break}else{if(ba^(Kb|0)==0){Pb=Kb;Qb=Kb;break}else{X=250;break a}}}}while(0);if((X|0)==243){X=0;if(ba){X=250;break a}else{Pb=Ob;Qb=0}}W=c[h>>2]|0;ta=c[W+12>>2]|0;if((ta|0)==(c[W+16>>2]|0)){Rb=(ae[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255}else{Rb=a[ta]|0}if(!(Rb<<24>>24>-1)){X=250;break a}if((b[(c[f>>2]|0)+(Rb<<24>>24<<1)>>1]&2048)==0){X=250;break a}ta=c[o>>2]|0;if((ta|0)==(Mb|0)){W=(c[P>>2]|0)!=966;qa=c[t>>2]|0;sa=Mb-qa|0;ib=sa>>>0<2147483647?sa<<1:-1;ra=Mwa(W?qa:0,ib)|0;if((ra|0)==0){X=253;break a}do{if(W){c[t>>2]=ra;Sb=ra}else{qa=c[t>>2]|0;c[t>>2]=ra;if((qa|0)==0){Sb=ra;break}Zd[c[P>>2]&1023](qa);Sb=c[t>>2]|0}}while(0);c[P>>2]=941;ra=Sb+sa|0;c[o>>2]=ra;Tb=ra;Ub=(c[t>>2]|0)+ib|0}else{Tb=ta;Ub=Mb}ra=c[h>>2]|0;W=c[ra+12>>2]|0;if((W|0)==(c[ra+16>>2]|0)){ba=(ae[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)&255;Vb=ba;Wb=c[o>>2]|0}else{Vb=a[W]|0;Wb=Tb}c[o>>2]=Wb+1;a[Wb]=Vb;W=(c[B>>2]|0)+ -1|0;c[B>>2]=W;ba=c[h>>2]|0;ra=ba+12|0;qa=c[ra>>2]|0;if((qa|0)==(c[ba+16>>2]|0)){ae[c[(c[ba>>2]|0)+40>>2]&127](ba)|0}else{c[ra>>2]=qa+1}if((W|0)>0){Kb=Pb;Lb=Qb;Mb=Ub}else{Xb=Ub;break}}}else{Xb=da}if((c[o>>2]|0)==(c[t>>2]|0)){X=267;break a}else{ia=Xb;ja=yb;ka=zb;la=Ab;ma=S;na=Bb}break};case 0:{X=26;break};default:{ia=D;ja=R;ka=r;la=Q;ma=S;na=T}}}while(0);f:do{if((X|0)==26){X=0;if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}else{Yb=Y;Zb=Y}while(1){U=c[h>>2]|0;do{if((U|0)==0){_b=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){_b=U;break}if((ae[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;_b=0;break}else{_b=c[h>>2]|0;break}}}while(0);U=(_b|0)==0;do{if((Zb|0)==0){$b=Yb;X=37}else{if((c[Zb+12>>2]|0)!=(c[Zb+16>>2]|0)){if(U){ac=Yb;bc=Zb;break}else{ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}}if((ae[c[(c[Zb>>2]|0)+36>>2]&127](Zb)|0)==-1){c[e>>2]=0;$b=0;X=37;break}else{if(U^(Yb|0)==0){ac=Yb;bc=Yb;break}else{ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}}}}while(0);if((X|0)==37){X=0;if(U){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}else{ac=$b;bc=0}}ta=c[h>>2]|0;ib=c[ta+12>>2]|0;if((ib|0)==(c[ta+16>>2]|0)){cc=(ae[c[(c[ta>>2]|0)+36>>2]&127](ta)|0)&255}else{cc=a[ib]|0}if(!(cc<<24>>24>-1)){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}if((b[(c[f>>2]|0)+(cc<<24>>24<<1)>>1]&8192)==0){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}ib=c[h>>2]|0;ta=ib+12|0;sa=c[ta>>2]|0;if((sa|0)==(c[ib+16>>2]|0)){dc=(ae[c[(c[ib>>2]|0)+40>>2]&127](ib)|0)&255}else{c[ta>>2]=sa+1;dc=a[sa]|0}Wma(A,dc);Yb=ac;Zb=bc}}}while(0);da=p+1|0;if(da>>>0<4){Q=la;r=ka;R=ja;D=ia;p=da;S=ma;T=na}else{Z=ja;_=ka;$=ma;aa=na;X=269;break}}g:do{if((X|0)==25){c[k>>2]=c[k>>2]|4;ec=0;fc=R;gc=T}else if((X|0)==112){c[k>>2]=c[k>>2]|4;ec=0;fc=R;gc=T}else if((X|0)==162){c[k>>2]=c[k>>2]|4;ec=0;fc=R;gc=T}else if((X|0)==182){Wwa()}else if((X|0)==198){Wwa()}else if((X|0)==209){Wwa()}else if((X|0)==229){c[k>>2]=c[k>>2]|4;ec=0;fc=yb;gc=Bb}else if((X|0)==250){c[k>>2]=c[k>>2]|4;ec=0;fc=yb;gc=Bb}else if((X|0)==253){Wwa()}else if((X|0)==267){c[k>>2]=c[k>>2]|4;ec=0;fc=yb;gc=Bb}else if((X|0)==269){h:do{if(($|0)!=0){na=$+1|0;ma=$+8|0;ka=$+4|0;ja=1;i:while(1){S=a[$]|0;if((S&1)==0){hc=(S&255)>>>1}else{hc=c[ka>>2]|0}if(!(ja>>>0<hc>>>0)){break h}S=c[h>>2]|0;do{if((S|0)==0){ic=0}else{if((c[S+12>>2]|0)!=(c[S+16>>2]|0)){ic=S;break}if((ae[c[(c[S>>2]|0)+36>>2]&127](S)|0)==-1){c[h>>2]=0;ic=0;break}else{ic=c[h>>2]|0;break}}}while(0);S=(ic|0)==0;U=c[e>>2]|0;do{if((U|0)==0){X=285}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){if(S){break}else{break i}}if((ae[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[e>>2]=0;X=285;break}else{if(S){break}else{break i}}}}while(0);if((X|0)==285){X=0;if(S){break}}U=c[h>>2]|0;p=c[U+12>>2]|0;if((p|0)==(c[U+16>>2]|0)){jc=(ae[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{jc=a[p]|0}if((a[$]&1)==0){kc=na}else{kc=c[ma>>2]|0}if(!(jc<<24>>24==(a[kc+ja|0]|0))){break}p=ja+1|0;U=c[h>>2]|0;ia=U+12|0;D=c[ia>>2]|0;if((D|0)==(c[U+16>>2]|0)){ae[c[(c[U>>2]|0)+40>>2]&127](U)|0;ja=p;continue}else{c[ia>>2]=D+1;ja=p;continue}}c[k>>2]=c[k>>2]|4;ec=0;fc=Z;gc=aa;break g}}while(0);if((Z|0)==(_|0)){ec=1;fc=_;gc=aa;break}c[C>>2]=0;Asa(w,Z,_,C);if((c[C>>2]|0)==0){ec=1;fc=Z;gc=aa;break}c[k>>2]=c[k>>2]|4;ec=0;fc=Z;gc=aa}}while(0);Ema(A);Ema(z);Ema(y);Ema(x);Ema(w);if((fc|0)==0){i=q;return ec|0}Zd[gc&1023](fc);i=q;return ec|0}function wsa(a){a=a|0;var b=0;b=Dc(8)|0;ama(b,a);Ld(b|0,142224,42)}function xsa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+168|0;l=d;m=d+8|0;n=d+24|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=966;v=n+100|0;Ana(q,h);n=q;w=c[n>>2]|0;if(!((c[36308]|0)==-1)){c[m>>2]=145232;c[m+4>>2]=964;c[m+8>>2]=0;pma(145232,m,965)}m=(c[145236>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Dc(4)|0;z=y;owa(z);A=160792;B=127;Ld(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Dc(4)|0;z=y;owa(z);A=160792;B=127;Ld(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=vsa(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}if((a[r]|0)!=0){Wma(k,pe[c[(c[w>>2]|0)+28>>2]&63](B,45)|0)}r=pe[c[(c[w>>2]|0)+28>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -1|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+1|0;if(!((a[z]|0)==r<<24>>24)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);ysa(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){D=e;break}if(!((ae[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){D=e;break}c[w>>2]=0;D=0}}while(0);w=(D|0)==0;do{if((f|0)==0){E=25}else{if((c[f+12>>2]|0)!=(c[f+16>>2]|0)){if(w){break}else{E=27;break}}if((ae[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1){c[A>>2]=0;E=25;break}else{if(w^(f|0)==0){break}else{E=27;break}}}}while(0);if((E|0)==25){if(w){E=27}}if((E|0)==27){c[j>>2]=c[j>>2]|2}c[b>>2]=D;Wla(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}Zd[c[u>>2]&1023](n);i=d;return}function ysa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=10}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g|0;if((e|0)==(d|0)){i=f;return b|0}if((l-j|0)>>>0<h>>>0){Zma(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;k=g+1|0;if((k|0)==(e|0)){break}else{d=d+1|0;g=k}}a[n+m|0]=0;m=j+h|0;if((a[b]&1)==0){a[b]=m<<1;i=f;return b|0}else{c[b+4>>2]=m;i=f;return b|0}return 0}function zsa(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[36168]|0)==-1)){c[p>>2]=144672;c[p+4>>2]=964;c[p+8>>2]=0;pma(144672,p,965)}p=(c[144676>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Dc(4)|0;C=B;owa(C);D=160792;E=127;Ld(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Dc(4)|0;C=B;owa(C);D=160792;E=127;Ld(B|0,D|0,E|0)}E=b;_d[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;_d[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}Qma(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Ema(r);_d[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}Qma(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Ema(s);a[f]=ae[c[(c[b>>2]|0)+12>>2]&127](E)|0;a[g]=ae[c[(c[b>>2]|0)+16>>2]&127](E)|0;_d[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}Qma(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Ema(t);_d[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}Qma(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Ema(u);F=ae[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[36152]|0)==-1)){c[o>>2]=144608;c[o+4>>2]=964;c[o+8>>2]=0;pma(144608,o,965)}o=(c[144612>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Dc(4)|0;H=G;owa(H);I=160792;J=127;Ld(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Dc(4)|0;H=G;owa(H);I=160792;J=127;Ld(G|0,I|0,J|0)}J=E;_d[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;_d[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}Qma(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;Ema(w);_d[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}Qma(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Ema(x);a[f]=ae[c[(c[E>>2]|0)+12>>2]&127](J)|0;a[g]=ae[c[(c[E>>2]|0)+16>>2]&127](J)|0;_d[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}Qma(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Ema(y);_d[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}Qma(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Ema(z);F=ae[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function Asa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[b+4>>2]|0}if((j|0)==0){i=g;return}do{if((d|0)==(e|0)){k=h}else{j=e+ -4|0;if(j>>>0>d>>>0){l=d;m=j}else{k=h;break}do{j=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=j;l=l+4|0;m=m+ -4|0;}while(l>>>0<m>>>0);k=a[b]|0}}while(0);if((k&1)==0){n=b+1|0;o=(k&255)>>>1}else{n=c[b+8>>2]|0;o=c[b+4>>2]|0}b=e+ -4|0;e=a[n]|0;k=e<<24>>24<1|e<<24>>24==127;a:do{if(b>>>0>d>>>0){m=n+o|0;l=e;h=n;j=d;p=k;while(1){if(!p){if((l<<24>>24|0)!=(c[j>>2]|0)){break}}q=(m-h|0)>1?h+1|0:h;r=j+4|0;s=a[q]|0;t=s<<24>>24<1|s<<24>>24==127;if(r>>>0<b>>>0){l=s;h=q;j=r;p=t}else{u=s;v=t;break a}}c[f>>2]=4;i=g;return}else{u=e;v=k}}while(0);if(v){i=g;return}v=c[b>>2]|0;if(!(u<<24>>24>>>0<v>>>0|(v|0)==0)){i=g;return}c[f>>2]=4;i=g;return}function Bsa(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function Csa(a){a=a|0;i=i;return}function Dsa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+400|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+40|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=966;y=o+400|0;Ana(r,h);o=r;z=c[o>>2]|0;if(!((c[36306]|0)==-1)){c[n>>2]=145224;c[n+4>>2]=964;c[n+8>>2]=0;pma(145224,n,965)}n=(c[145228>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Dc(4)|0;C=B;owa(C);D=160792;E=127;Ld(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Dc(4)|0;C=B;owa(C);D=160792;E=127;Ld(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=Esa(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;ze[c[(c[z>>2]|0)+48>>2]&63](E,144928,144938|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>392){l=Jwa((g>>2)+2|0)|0;if((l|0)!=0){F=l;G=l;break}Wwa()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+40|0;l=u;h=H;t=r;while(1){C=c[t>>2]|0;n=y;while(1){A=n+4|0;if((c[n>>2]|0)==(C|0)){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[144928+(I-l>>2)|0]|0;n=t+4|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((qd(p|0,144864,m|0)|0)!=1){t=Dc(8)|0;ama(t,144872);Ld(t|0,142224,42)}if((F|0)==0){break}Kwa(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=1}else{m=c[e+12>>2]|0;if((m|0)==(c[e+16>>2]|0)){L=ae[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{L=c[m>>2]|0}if((L|0)==-1){c[F>>2]=0;K=1;break}else{K=(c[F>>2]|0)==0;break}}}while(0);L=c[D>>2]|0;do{if((L|0)==0){M=35}else{e=c[L+12>>2]|0;if((e|0)==(c[L+16>>2]|0)){N=ae[c[(c[L>>2]|0)+36>>2]&127](L)|0}else{N=c[e>>2]|0}if((N|0)==-1){c[D>>2]=0;M=35;break}else{if(K){break}else{M=37;break}}}}while(0);if((M|0)==35){if(K){M=37}}if((M|0)==37){c[j>>2]=c[j>>2]|2}c[b>>2]=c[F>>2];Wla(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}Zd[c[x>>2]&1023](o);i=d;return}function Esa(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0;p=i;i=i+416|0;q=p;r=p+8|0;s=p+408|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;c[q>>2]=o;o=r;c[s>>2]=0;D=w;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=x;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=y;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=z;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=A;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Hsa(f,g,t,u,v,w,x,y,z,B);t=m;c[n>>2]=c[t>>2];g=b;b=e;e=z+4|0;f=z+8|0;D=y+4|0;E=y+8|0;F=(h&512|0)!=0;h=x+4|0;G=x+8|0;H=A+4|0;I=A+8|0;J=s+3|0;K=w+4|0;L=r+400|0;r=o;M=o;o=0;N=0;O=966;a:while(1){P=c[g>>2]|0;do{if((P|0)==0){Q=1}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=ae[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{S=c[R>>2]|0}if((S|0)==-1){c[g>>2]=0;Q=1;break}else{Q=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=15}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){U=ae[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{U=c[R>>2]|0}if((U|0)==-1){c[b>>2]=0;T=15;break}else{if(Q){V=P;break}else{W=M;X=r;Y=N;Z=O;T=276;break a}}}}while(0);if((T|0)==15){T=0;if(Q){W=M;X=r;Y=N;Z=O;T=276;break}else{V=0}}b:do{switch(a[s+o|0]|0){case 2:{if(!((N|0)!=0|o>>>0<2)){if((o|0)==2){_=(a[J]|0)!=0}else{_=0}if(!(F|_)){$=M;aa=r;ba=L;ca=0;da=O;break b}}P=a[x]|0;R=(P&1)==0?h:c[G>>2]|0;c:do{if((o|0)==0){ea=V;fa=V;ga=P;ha=R}else{if((d[s+(o+ -1)|0]|0)<2){ia=P;ja=R}else{ea=V;fa=V;ga=P;ha=R;break}while(1){if((ia&1)==0){ka=h;la=(ia&255)>>>1}else{ka=c[G>>2]|0;la=c[h>>2]|0}if((ja|0)==(ka+(la<<2)|0)){ma=ia;break}if(!(de[c[(c[l>>2]|0)+12>>2]&63](l,8192,c[ja>>2]|0)|0)){T=129;break}ia=a[x]|0;ja=ja+4|0}if((T|0)==129){T=0;ma=a[x]|0}na=(ma&1)==0;oa=ja-(na?h:c[G>>2]|0)>>2;pa=a[A]|0;qa=(pa&1)==0;if(qa){ra=(pa&255)>>>1}else{ra=c[H>>2]|0}d:do{if(!(oa>>>0>ra>>>0)){if(qa){sa=H+(((pa&255)>>>1)-oa<<2)|0;ta=H;ua=(pa&255)>>>1}else{va=c[I>>2]|0;wa=c[H>>2]|0;sa=va+(wa-oa<<2)|0;ta=va;ua=wa}wa=ta+(ua<<2)|0;if((sa|0)==(wa|0)){ea=V;fa=V;ga=ma;ha=ja;break c}else{xa=na?h:c[G>>2]|0;ya=sa}while(1){if((c[ya>>2]|0)!=(c[xa>>2]|0)){break d}va=ya+4|0;if((va|0)==(wa|0)){ea=V;fa=V;ga=ma;ha=ja;break c}xa=xa+4|0;ya=va}}}while(0);ea=V;fa=V;ga=ma;ha=na?h:c[G>>2]|0}}while(0);e:while(1){if((ga&1)==0){za=h;Aa=(ga&255)>>>1}else{za=c[G>>2]|0;Aa=c[h>>2]|0}if((ha|0)==(za+(Aa<<2)|0)){break}R=c[g>>2]|0;do{if((R|0)==0){Ba=1}else{P=c[R+12>>2]|0;if((P|0)==(c[R+16>>2]|0)){Ca=ae[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Ca=c[P>>2]|0}if((Ca|0)==-1){c[g>>2]=0;Ba=1;break}else{Ba=(c[g>>2]|0)==0;break}}}while(0);do{if((fa|0)==0){Da=ea;T=159}else{R=c[fa+12>>2]|0;if((R|0)==(c[fa+16>>2]|0)){Ea=ae[c[(c[fa>>2]|0)+36>>2]&127](fa)|0}else{Ea=c[R>>2]|0}if((Ea|0)==-1){c[b>>2]=0;Da=0;T=159;break}else{if(Ba^(ea|0)==0){Fa=ea;Ga=ea;break}else{break e}}}}while(0);if((T|0)==159){T=0;if(Ba){break}else{Fa=Da;Ga=0}}R=c[g>>2]|0;na=c[R+12>>2]|0;if((na|0)==(c[R+16>>2]|0)){Ha=ae[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Ha=c[na>>2]|0}if((Ha|0)!=(c[ha>>2]|0)){break}na=c[g>>2]|0;R=na+12|0;P=c[R>>2]|0;if((P|0)==(c[na+16>>2]|0)){ae[c[(c[na>>2]|0)+40>>2]&127](na)|0}else{c[R>>2]=P+4}ea=Fa;fa=Ga;ga=a[x]|0;ha=ha+4|0}if(!F){$=M;aa=r;ba=L;ca=N;da=O;break b}P=a[x]|0;if((P&1)==0){Ia=h;Ja=(P&255)>>>1}else{Ia=c[G>>2]|0;Ja=c[h>>2]|0}if((ha|0)==(Ia+(Ja<<2)|0)){$=M;aa=r;ba=L;ca=N;da=O}else{T=174;break a}break};case 0:{T=28;break};case 3:{P=a[y]|0;R=(P&1)==0;if(R){Ka=(P&255)>>>1}else{Ka=c[D>>2]|0}na=a[z]|0;oa=(na&1)==0;if(oa){La=(na&255)>>>1}else{La=c[e>>2]|0}if((Ka|0)==(0-La|0)){$=M;aa=r;ba=L;ca=N;da=O;break b}if(R){Ma=(P&255)>>>1}else{Ma=c[D>>2]|0}do{if((Ma|0)!=0){if(oa){Na=(na&255)>>>1}else{Na=c[e>>2]|0}if((Na|0)==0){break}pa=c[g>>2]|0;qa=c[pa+12>>2]|0;if((qa|0)==(c[pa+16>>2]|0)){wa=ae[c[(c[pa>>2]|0)+36>>2]&127](pa)|0;Oa=wa;Pa=a[y]|0}else{Oa=c[qa>>2]|0;Pa=P}qa=c[g>>2]|0;wa=qa+12|0;pa=c[wa>>2]|0;va=(pa|0)==(c[qa+16>>2]|0);if((Oa|0)==(c[((Pa&1)==0?D:c[E>>2]|0)>>2]|0)){if(va){ae[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[wa>>2]=pa+4}wa=a[y]|0;if((wa&1)==0){Qa=(wa&255)>>>1}else{Qa=c[D>>2]|0}$=M;aa=r;ba=L;ca=Qa>>>0>1?y:N;da=O;break b}if(va){Ra=ae[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{Ra=c[pa>>2]|0}if((Ra|0)!=(c[((a[z]&1)==0?e:c[f>>2]|0)>>2]|0)){T=116;break a}pa=c[g>>2]|0;qa=pa+12|0;va=c[qa>>2]|0;if((va|0)==(c[pa+16>>2]|0)){ae[c[(c[pa>>2]|0)+40>>2]&127](pa)|0}else{c[qa>>2]=va+4}a[k]=1;va=a[z]|0;if((va&1)==0){Sa=(va&255)>>>1}else{Sa=c[e>>2]|0}$=M;aa=r;ba=L;ca=Sa>>>0>1?z:N;da=O;break b}}while(0);if(R){Ta=(P&255)>>>1}else{Ta=c[D>>2]|0}oa=c[g>>2]|0;va=c[oa+12>>2]|0;qa=(va|0)==(c[oa+16>>2]|0);if((Ta|0)==0){if(qa){pa=ae[c[(c[oa>>2]|0)+36>>2]&127](oa)|0;Ua=pa;Va=a[z]|0}else{Ua=c[va>>2]|0;Va=na}if((Ua|0)!=(c[((Va&1)==0?e:c[f>>2]|0)>>2]|0)){$=M;aa=r;ba=L;ca=N;da=O;break b}pa=c[g>>2]|0;wa=pa+12|0;Wa=c[wa>>2]|0;if((Wa|0)==(c[pa+16>>2]|0)){ae[c[(c[pa>>2]|0)+40>>2]&127](pa)|0}else{c[wa>>2]=Wa+4}a[k]=1;Wa=a[z]|0;if((Wa&1)==0){Xa=(Wa&255)>>>1}else{Xa=c[e>>2]|0}$=M;aa=r;ba=L;ca=Xa>>>0>1?z:N;da=O;break b}if(qa){qa=ae[c[(c[oa>>2]|0)+36>>2]&127](oa)|0;Ya=qa;Za=a[y]|0}else{Ya=c[va>>2]|0;Za=P}if((Ya|0)!=(c[((Za&1)==0?D:c[E>>2]|0)>>2]|0)){a[k]=1;$=M;aa=r;ba=L;ca=N;da=O;break b}va=c[g>>2]|0;qa=va+12|0;oa=c[qa>>2]|0;if((oa|0)==(c[va+16>>2]|0)){ae[c[(c[va>>2]|0)+40>>2]&127](va)|0}else{c[qa>>2]=oa+4}oa=a[y]|0;if((oa&1)==0){_a=(oa&255)>>>1}else{_a=c[D>>2]|0}$=M;aa=r;ba=L;ca=_a>>>0>1?y:N;da=O;break};case 4:{oa=M;qa=r;va=L;Wa=0;wa=O;f:while(1){pa=c[g>>2]|0;do{if((pa|0)==0){$a=1}else{ab=c[pa+12>>2]|0;if((ab|0)==(c[pa+16>>2]|0)){bb=ae[c[(c[pa>>2]|0)+36>>2]&127](pa)|0}else{bb=c[ab>>2]|0}if((bb|0)==-1){c[g>>2]=0;$a=1;break}else{$a=(c[g>>2]|0)==0;break}}}while(0);pa=c[b>>2]|0;do{if((pa|0)==0){T=188}else{ab=c[pa+12>>2]|0;if((ab|0)==(c[pa+16>>2]|0)){cb=ae[c[(c[pa>>2]|0)+36>>2]&127](pa)|0}else{cb=c[ab>>2]|0}if((cb|0)==-1){c[b>>2]=0;T=188;break}else{if($a){break}else{break f}}}}while(0);if((T|0)==188){T=0;if($a){break}}pa=c[g>>2]|0;ab=c[pa+12>>2]|0;if((ab|0)==(c[pa+16>>2]|0)){db=ae[c[(c[pa>>2]|0)+36>>2]&127](pa)|0}else{db=c[ab>>2]|0}if(de[c[(c[l>>2]|0)+12>>2]&63](l,2048,db)|0){ab=c[n>>2]|0;if((ab|0)==(c[q>>2]|0)){Isa(m,n,q);eb=c[n>>2]|0}else{eb=ab}c[n>>2]=eb+4;c[eb>>2]=db;fb=oa;gb=qa;hb=va;ib=Wa+1|0;jb=wa}else{ab=a[w]|0;if((ab&1)==0){kb=(ab&255)>>>1}else{kb=c[K>>2]|0}if((kb|0)==0|(Wa|0)==0){break}if((db|0)!=(c[v>>2]|0)){break}if((qa|0)==(va|0)){ab=qa-oa|0;pa=ab>>>0<2147483647?ab<<1:-1;if((wa|0)!=966){lb=oa}else{lb=0}mb=Mwa(lb,pa)|0;if((mb|0)==0){T=206;break a}nb=mb;ob=mb+(ab>>2<<2)|0;pb=mb+(pa>>>2<<2)|0;qb=941}else{nb=oa;ob=qa;pb=va;qb=wa}c[ob>>2]=Wa;fb=nb;gb=ob+4|0;hb=pb;ib=0;jb=qb}pa=c[g>>2]|0;mb=pa+12|0;ab=c[mb>>2]|0;if((ab|0)==(c[pa+16>>2]|0)){ae[c[(c[pa>>2]|0)+40>>2]&127](pa)|0;oa=fb;qa=gb;va=hb;Wa=ib;wa=jb;continue}else{c[mb>>2]=ab+4;oa=fb;qa=gb;va=hb;Wa=ib;wa=jb;continue}}if((oa|0)==(qa|0)|(Wa|0)==0){rb=oa;sb=qa;tb=va;ub=wa}else{if((qa|0)==(va|0)){P=qa-oa|0;na=P>>>0<2147483647?P<<1:-1;if((wa|0)!=966){vb=oa}else{vb=0}R=Mwa(vb,na)|0;if((R|0)==0){T=217;break a}wb=R;xb=R+(P>>2<<2)|0;yb=R+(na>>>2<<2)|0;zb=941}else{wb=oa;xb=qa;yb=va;zb=wa}c[xb>>2]=Wa;rb=wb;sb=xb+4|0;tb=yb;ub=zb}na=c[B>>2]|0;if((na|0)>0){R=c[g>>2]|0;do{if((R|0)==0){Ab=1}else{P=c[R+12>>2]|0;if((P|0)==(c[R+16>>2]|0)){Bb=ae[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Bb=c[P>>2]|0}if((Bb|0)==-1){c[g>>2]=0;Ab=1;break}else{Ab=(c[g>>2]|0)==0;break}}}while(0);R=c[b>>2]|0;do{if((R|0)==0){T=234}else{Wa=c[R+12>>2]|0;if((Wa|0)==(c[R+16>>2]|0)){Cb=ae[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Cb=c[Wa>>2]|0}if((Cb|0)==-1){c[b>>2]=0;T=234;break}else{if(Ab){Db=R;break}else{T=240;break a}}}}while(0);if((T|0)==234){T=0;if(Ab){T=240;break a}else{Db=0}}R=c[g>>2]|0;Wa=c[R+12>>2]|0;if((Wa|0)==(c[R+16>>2]|0)){Eb=ae[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Eb=c[Wa>>2]|0}if((Eb|0)!=(c[u>>2]|0)){T=240;break a}Wa=c[g>>2]|0;R=Wa+12|0;wa=c[R>>2]|0;if((wa|0)==(c[Wa+16>>2]|0)){ae[c[(c[Wa>>2]|0)+40>>2]&127](Wa)|0;Fb=Db;Gb=na;Hb=Db}else{c[R>>2]=wa+4;Fb=Db;Gb=na;Hb=Db}while(1){wa=c[g>>2]|0;do{if((wa|0)==0){Ib=1}else{R=c[wa+12>>2]|0;if((R|0)==(c[wa+16>>2]|0)){Jb=ae[c[(c[wa>>2]|0)+36>>2]&127](wa)|0}else{Jb=c[R>>2]|0}if((Jb|0)==-1){c[g>>2]=0;Ib=1;break}else{Ib=(c[g>>2]|0)==0;break}}}while(0);do{if((Hb|0)==0){Kb=Fb;T=257}else{wa=c[Hb+12>>2]|0;if((wa|0)==(c[Hb+16>>2]|0)){Lb=ae[c[(c[Hb>>2]|0)+36>>2]&127](Hb)|0}else{Lb=c[wa>>2]|0}if((Lb|0)==-1){c[b>>2]=0;Kb=0;T=257;break}else{if(Ib^(Fb|0)==0){Mb=Fb;Nb=Fb;break}else{T=263;break a}}}}while(0);if((T|0)==257){T=0;if(Ib){T=263;break a}else{Mb=Kb;Nb=0}}wa=c[g>>2]|0;R=c[wa+12>>2]|0;if((R|0)==(c[wa+16>>2]|0)){Ob=ae[c[(c[wa>>2]|0)+36>>2]&127](wa)|0}else{Ob=c[R>>2]|0}if(!(de[c[(c[l>>2]|0)+12>>2]&63](l,2048,Ob)|0)){T=263;break a}if((c[n>>2]|0)==(c[q>>2]|0)){Isa(m,n,q)}R=c[g>>2]|0;wa=c[R+12>>2]|0;if((wa|0)==(c[R+16>>2]|0)){Pb=ae[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Pb=c[wa>>2]|0}wa=c[n>>2]|0;c[n>>2]=wa+4;c[wa>>2]=Pb;wa=Gb+ -1|0;c[B>>2]=wa;R=c[g>>2]|0;Wa=R+12|0;va=c[Wa>>2]|0;if((va|0)==(c[R+16>>2]|0)){ae[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[Wa>>2]=va+4}if((wa|0)>0){Fb=Mb;Gb=wa;Hb=Nb}else{break}}}if((c[n>>2]|0)==(c[t>>2]|0)){T=274;break a}else{$=rb;aa=sb;ba=tb;ca=N;da=ub}break};case 1:{if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}na=c[g>>2]|0;wa=c[na+12>>2]|0;if((wa|0)==(c[na+16>>2]|0)){Qb=ae[c[(c[na>>2]|0)+36>>2]&127](na)|0}else{Qb=c[wa>>2]|0}if(!(de[c[(c[l>>2]|0)+12>>2]&63](l,8192,Qb)|0)){T=27;break a}wa=c[g>>2]|0;na=wa+12|0;va=c[na>>2]|0;if((va|0)==(c[wa+16>>2]|0)){Rb=ae[c[(c[wa>>2]|0)+40>>2]&127](wa)|0}else{c[na>>2]=va+4;Rb=c[va>>2]|0}kna(A,Rb);T=28;break};default:{$=M;aa=r;ba=L;ca=N;da=O}}}while(0);g:do{if((T|0)==28){T=0;if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}else{Sb=V;Tb=V}while(1){va=c[g>>2]|0;do{if((va|0)==0){Ub=1}else{na=c[va+12>>2]|0;if((na|0)==(c[va+16>>2]|0)){Vb=ae[c[(c[va>>2]|0)+36>>2]&127](va)|0}else{Vb=c[na>>2]|0}if((Vb|0)==-1){c[g>>2]=0;Ub=1;break}else{Ub=(c[g>>2]|0)==0;break}}}while(0);do{if((Tb|0)==0){Wb=Sb;T=42}else{va=c[Tb+12>>2]|0;if((va|0)==(c[Tb+16>>2]|0)){Xb=ae[c[(c[Tb>>2]|0)+36>>2]&127](Tb)|0}else{Xb=c[va>>2]|0}if((Xb|0)==-1){c[b>>2]=0;Wb=0;T=42;break}else{if(Ub^(Sb|0)==0){Yb=Sb;Zb=Sb;break}else{$=M;aa=r;ba=L;ca=N;da=O;break g}}}}while(0);if((T|0)==42){T=0;if(Ub){$=M;aa=r;ba=L;ca=N;da=O;break g}else{Yb=Wb;Zb=0}}va=c[g>>2]|0;na=c[va+12>>2]|0;if((na|0)==(c[va+16>>2]|0)){_b=ae[c[(c[va>>2]|0)+36>>2]&127](va)|0}else{_b=c[na>>2]|0}if(!(de[c[(c[l>>2]|0)+12>>2]&63](l,8192,_b)|0)){$=M;aa=r;ba=L;ca=N;da=O;break g}na=c[g>>2]|0;va=na+12|0;wa=c[va>>2]|0;if((wa|0)==(c[na+16>>2]|0)){$b=ae[c[(c[na>>2]|0)+40>>2]&127](na)|0}else{c[va>>2]=wa+4;$b=c[wa>>2]|0}kna(A,$b);Sb=Yb;Tb=Zb}}}while(0);wa=o+1|0;if(wa>>>0<4){L=ba;r=aa;M=$;o=wa;N=ca;O=da}else{W=$;X=aa;Y=ca;Z=da;T=276;break}}h:do{if((T|0)==27){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==116){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==174){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==206){Wwa()}else if((T|0)==217){Wwa()}else if((T|0)==240){c[j>>2]=c[j>>2]|4;ac=0;bc=rb;cc=ub}else if((T|0)==263){c[j>>2]=c[j>>2]|4;ac=0;bc=rb;cc=ub}else if((T|0)==274){c[j>>2]=c[j>>2]|4;ac=0;bc=rb;cc=ub}else if((T|0)==276){i:do{if((Y|0)!=0){da=Y+4|0;ca=Y+8|0;aa=1;j:while(1){$=a[Y]|0;if(($&1)==0){dc=($&255)>>>1}else{dc=c[da>>2]|0}if(!(aa>>>0<dc>>>0)){break i}$=c[g>>2]|0;do{if(($|0)==0){ec=1}else{N=c[$+12>>2]|0;if((N|0)==(c[$+16>>2]|0)){fc=ae[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{fc=c[N>>2]|0}if((fc|0)==-1){c[g>>2]=0;ec=1;break}else{ec=(c[g>>2]|0)==0;break}}}while(0);$=c[b>>2]|0;do{if(($|0)==0){T=295}else{N=c[$+12>>2]|0;if((N|0)==(c[$+16>>2]|0)){gc=ae[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{gc=c[N>>2]|0}if((gc|0)==-1){c[b>>2]=0;T=295;break}else{if(ec){break}else{break j}}}}while(0);if((T|0)==295){T=0;if(ec){break}}$=c[g>>2]|0;N=c[$+12>>2]|0;if((N|0)==(c[$+16>>2]|0)){hc=ae[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{hc=c[N>>2]|0}if((a[Y]&1)==0){ic=da}else{ic=c[ca>>2]|0}if((hc|0)!=(c[ic+(aa<<2)>>2]|0)){break}N=aa+1|0;$=c[g>>2]|0;o=$+12|0;r=c[o>>2]|0;if((r|0)==(c[$+16>>2]|0)){ae[c[(c[$>>2]|0)+40>>2]&127]($)|0;aa=N;continue}else{c[o>>2]=r+4;aa=N;continue}}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z;break h}}while(0);if((W|0)==(X|0)){ac=1;bc=X;cc=Z;break}c[C>>2]=0;Asa(w,W,X,C);if((c[C>>2]|0)==0){ac=1;bc=W;cc=Z;break}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z}}while(0);gna(A);gna(z);gna(y);gna(x);Ema(w);if((bc|0)==0){i=p;return ac|0}Zd[cc&1023](bc);i=p;return ac|0}function Fsa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+464|0;l=d;m=d+8|0;n=d+24|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=966;v=n+400|0;Ana(q,h);n=q;w=c[n>>2]|0;if(!((c[36306]|0)==-1)){c[m>>2]=145224;c[m+4>>2]=964;c[m+8>>2]=0;pma(145224,m,965)}m=(c[145228>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Dc(4)|0;z=y;owa(z);A=160792;B=127;Ld(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Dc(4)|0;z=y;owa(z);A=160792;B=127;Ld(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=Esa(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}if((a[r]|0)!=0){kna(k,pe[c[(c[w>>2]|0)+44>>2]&63](B,45)|0)}r=pe[c[(c[w>>2]|0)+44>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -4|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+4|0;if((c[z>>2]|0)!=(r|0)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);Gsa(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=1}else{C=c[e+12>>2]|0;if((C|0)==(c[e+16>>2]|0)){E=ae[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{E=c[C>>2]|0}if((E|0)==-1){c[w>>2]=0;D=1;break}else{D=(c[w>>2]|0)==0;break}}}while(0);do{if((f|0)==0){F=29}else{E=c[f+12>>2]|0;if((E|0)==(c[f+16>>2]|0)){G=ae[c[(c[f>>2]|0)+36>>2]&127](f)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[A>>2]=0;F=29;break}else{if(D){break}else{F=31;break}}}}while(0);if((F|0)==29){if(D){F=31}}if((F|0)==31){c[j>>2]=c[j>>2]|2}c[b>>2]=c[w>>2];Wla(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}Zd[c[u>>2]&1023](n);i=d;return}function Gsa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=1}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g>>2;if((h|0)==0){i=f;return b|0}if((l-j|0)>>>0<h>>>0){mna(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{k=j+((e+ -4+(0-g)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{d=d+4|0;g=m}}o=n+(k<<2)|0}c[o>>2]=0;o=j+h|0;if((a[b]&1)==0){a[b]=o<<1;i=f;return b|0}else{c[b+4>>2]=o;i=f;return b|0}return 0}function Hsa(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[36200]|0)==-1)){c[p>>2]=144800;c[p+4>>2]=964;c[p+8>>2]=0;pma(144800,p,965)}p=(c[144804>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Dc(4)|0;C=B;owa(C);D=160792;E=127;Ld(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Dc(4)|0;C=B;owa(C);D=160792;E=127;Ld(B|0,D|0,E|0)}E=b;_d[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;_d[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}jna(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;gna(r);_d[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}jna(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;gna(s);c[f>>2]=ae[c[(c[b>>2]|0)+12>>2]&127](E)|0;c[g>>2]=ae[c[(c[b>>2]|0)+16>>2]&127](E)|0;_d[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}Qma(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Ema(t);_d[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}jna(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;gna(u);F=ae[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[36184]|0)==-1)){c[o>>2]=144736;c[o+4>>2]=964;c[o+8>>2]=0;pma(144736,o,965)}o=(c[144740>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Dc(4)|0;H=G;owa(H);I=160792;J=127;Ld(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Dc(4)|0;H=G;owa(H);I=160792;J=127;Ld(G|0,I|0,J|0)}J=E;_d[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;_d[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}jna(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;gna(w);_d[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}jna(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;gna(x);c[f>>2]=ae[c[(c[E>>2]|0)+12>>2]&127](J)|0;c[g>>2]=ae[c[(c[E>>2]|0)+16>>2]&127](J)|0;_d[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}Qma(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Ema(y);_d[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}jna(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;gna(z);F=ae[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function Isa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=966;h=a;a=c[h>>2]|0;j=a;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;if(g){m=a}else{m=0}a=Mwa(m,l)|0;m=a;if((a|0)==0){Wwa()}do{if(g){c[h>>2]=m;n=m}else{a=c[h>>2]|0;c[h>>2]=m;if((a|0)==0){n=m;break}Zd[c[f>>2]&1023](a);n=c[h>>2]|0}}while(0);c[f>>2]=941;c[b>>2]=n+(k<<2);c[d>>2]=(c[h>>2]|0)+(l>>>2<<2);i=e;return}function Jsa(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function Ksa(a){a=a|0;i=i;return}function Lsa(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+104|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+104|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Lc(G|0,100,144984,o|0)|0;do{if(s>>>0>99){do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);o=c[36280]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=Dqa(r,o,144984,n)|0;o=c[r>>2]|0;if((o|0)==0){Wwa()}H=Jwa(G)|0;if((H|0)!=0){I=o;J=H;K=H;L=G;break}Wwa()}else{I=0;J=0;K=q;L=s}}while(0);Ana(t,g);s=t;q=c[s>>2]|0;if(!((c[36308]|0)==-1)){c[p>>2]=145232;c[p+4>>2]=964;c[p+8>>2]=0;pma(145232,p,965)}p=(c[145236>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){M=Dc(4)|0;N=M;owa(N);O=160792;P=127;Ld(M|0,O|0,P|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){M=Dc(4)|0;N=M;owa(N);O=160792;P=127;Ld(M|0,O|0,P|0)}P=q;O=c[r>>2]|0;ze[c[(c[q>>2]|0)+32>>2]&63](P,O,O+L|0,K)|0;if((L|0)==0){Q=0}else{Q=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Msa(f,Q,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((L|0)>(C|0)){B=a[A]|0;if((B&1)==0){R=(B&255)>>>1}else{R=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[z+4>>2]|0}T=R+(L-C<<1|1)+S|0}else{S=a[A]|0;if((S&1)==0){U=(S&255)>>>1}else{U=c[A+4>>2]|0}S=a[z]|0;if((S&1)==0){V=(S&255)>>>1}else{V=c[z+4>>2]|0}T=U+2+V|0}V=T+C|0;do{if(V>>>0>100){T=Jwa(V)|0;if((T|0)!=0){W=T;X=T;break}Wwa()}else{W=0;X=t}}while(0);Nsa(X,D,E,c[g+4>>2]|0,K,K+L|0,P,Q,v,a[w]|0,a[x]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];bja(b,m,X,e,D,g,j);if((W|0)!=0){Kwa(W)}Ema(A);Ema(z);Ema(y);Wla(c[s>>2]|0)|0;if((J|0)!=0){Kwa(J)}if((I|0)==0){i=d;return}Kwa(I);i=d;return}function Msa(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[36168]|0)==-1)){c[p>>2]=144672;c[p+4>>2]=964;c[p+8>>2]=0;pma(144672,p,965)}p=(c[144676>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Dc(4)|0;I=H;owa(I);J=160792;K=127;Ld(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Dc(4)|0;I=H;owa(I);J=160792;K=127;Ld(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){_d[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;_d[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}Qma(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;Ema(s)}else{_d[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;_d[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}Qma(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Ema(v)}a[g]=ae[c[(c[e>>2]|0)+12>>2]&127](K)|0;a[h]=ae[c[(c[e>>2]|0)+16>>2]&127](K)|0;_d[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}Qma(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Ema(w);_d[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}Qma(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Ema(x);L=ae[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[36152]|0)==-1)){c[o>>2]=144608;c[o+4>>2]=964;c[o+8>>2]=0;pma(144608,o,965)}o=(c[144612>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Dc(4)|0;N=M;owa(N);O=160792;P=127;Ld(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Dc(4)|0;N=M;owa(N);O=160792;P=127;Ld(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){_d[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;_d[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}Qma(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;Ema(A)}else{_d[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;_d[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}Qma(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;Ema(D)}a[g]=ae[c[(c[G>>2]|0)+12>>2]&127](P)|0;a[h]=ae[c[(c[G>>2]|0)+16>>2]&127](P)|0;_d[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}Qma(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Ema(E);_d[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}Qma(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Ema(F);L=ae[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function Nsa(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;t=i;c[f>>2]=d;u=r+1|0;v=r+8|0;w=r+4|0;x=(g&512|0)==0;y=q+1|0;z=q+8|0;A=q+4|0;B=(s|0)>0;C=p+1|0;D=p+8|0;E=p+4|0;F=k+8|0;G=0-s|0;H=h;h=0;while(1){a:do{switch(a[m+h|0]|0){case 1:{c[e>>2]=c[f>>2];I=pe[c[(c[k>>2]|0)+28>>2]&63](k,32)|0;J=c[f>>2]|0;c[f>>2]=J+1;a[J]=I;K=H;break};case 0:{c[e>>2]=c[f>>2];K=H;break};case 2:{I=a[q]|0;J=(I&1)==0;if(J){L=(I&255)>>>1}else{L=c[A>>2]|0}if((L|0)==0|x){K=H;break a}if(J){M=y;N=(I&255)>>>1}else{M=c[z>>2]|0;N=c[A>>2]|0}I=M+N|0;J=c[f>>2]|0;if((M|0)==(I|0)){O=J}else{P=J;J=M;while(1){a[P]=a[J]|0;Q=J+1|0;R=P+1|0;if((Q|0)==(I|0)){O=R;break}else{J=Q;P=R}}}c[f>>2]=O;K=H;break};case 3:{P=a[r]|0;J=(P&1)==0;if(J){S=(P&255)>>>1}else{S=c[w>>2]|0}if((S|0)==0){K=H;break a}if(J){T=u}else{T=c[v>>2]|0}J=a[T]|0;P=c[f>>2]|0;c[f>>2]=P+1;a[P]=J;K=H;break};case 4:{J=c[f>>2]|0;P=l?H+1|0:H;b:do{if(P>>>0<j>>>0){I=P;while(1){R=a[I]|0;if(!(R<<24>>24>-1)){U=I;break b}Q=I+1|0;if((b[(c[F>>2]|0)+(R<<24>>24<<1)>>1]&2048)==0){U=I;break b}if(Q>>>0<j>>>0){I=Q}else{U=Q;break}}}else{U=P}}while(0);I=U;if(B){if(U>>>0>P>>>0){Q=P+(0-I)|0;I=Q>>>0<G>>>0?G:Q;Q=I+s|0;R=J;V=U;W=s;while(1){X=V+ -1|0;Y=a[X]|0;c[f>>2]=R+1;a[R]=Y;Y=W+ -1|0;Z=(Y|0)>0;if(!(X>>>0>P>>>0&Z)){break}R=c[f>>2]|0;W=Y;V=X}V=U+I|0;if(Z){_=V;$=Q;aa=32}else{ba=0;ca=V;da=Q}}else{_=U;$=s;aa=32}if((aa|0)==32){aa=0;ba=pe[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;ca=_;da=$}V=c[f>>2]|0;c[f>>2]=V+1;if((da|0)>0){W=V;R=da;while(1){a[W]=ba;X=R+ -1|0;Y=c[f>>2]|0;c[f>>2]=Y+1;if((X|0)>0){R=X;W=Y}else{ea=Y;break}}}else{ea=V}a[ea]=n;fa=ca}else{fa=U}if((fa|0)==(P|0)){W=pe[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;R=c[f>>2]|0;c[f>>2]=R+1;a[R]=W}else{W=a[p]|0;R=(W&1)==0;if(R){ga=(W&255)>>>1}else{ga=c[E>>2]|0}if((ga|0)==0){ha=fa;ia=-1;ja=0;ka=0}else{if(R){la=C}else{la=c[D>>2]|0}ha=fa;ia=a[la]|0;ja=0;ka=0}while(1){do{if((ka|0)==(ia|0)){R=c[f>>2]|0;c[f>>2]=R+1;a[R]=o;R=ja+1|0;W=a[p]|0;Q=(W&1)==0;if(Q){ma=(W&255)>>>1}else{ma=c[E>>2]|0}if(!(R>>>0<ma>>>0)){na=ia;oa=R;pa=0;break}if(Q){qa=C}else{qa=c[D>>2]|0}if((a[qa+R|0]|0)==127){na=-1;oa=R;pa=0;break}if(Q){ra=C}else{ra=c[D>>2]|0}na=a[ra+R|0]|0;oa=R;pa=0}else{na=ia;oa=ja;pa=ka}}while(0);R=ha+ -1|0;Q=a[R]|0;W=c[f>>2]|0;c[f>>2]=W+1;a[W]=Q;if((R|0)==(P|0)){break}else{ha=R;ia=na;ja=oa;ka=pa+1|0}}}V=c[f>>2]|0;if((J|0)==(V|0)){K=P;break a}R=V+ -1|0;if(R>>>0>J>>>0){sa=J;ta=R}else{K=P;break a}while(1){R=a[sa]|0;a[sa]=a[ta]|0;a[ta]=R;R=sa+1|0;V=ta+ -1|0;if(R>>>0<V>>>0){ta=V;sa=R}else{K=P;break}}break};default:{K=H}}}while(0);P=h+1|0;if(P>>>0<4){H=K;h=P}else{break}}h=a[r]|0;r=(h&1)==0;if(r){ua=(h&255)>>>1}else{ua=c[w>>2]|0}if(ua>>>0>1){if(r){va=u;wa=(h&255)>>>1}else{va=c[v>>2]|0;wa=c[w>>2]|0}w=va+1|0;v=va+wa|0;wa=c[f>>2]|0;if((w|0)==(v|0)){xa=wa}else{va=wa;wa=w;while(1){a[va]=a[wa]|0;w=wa+1|0;h=va+1|0;if((w|0)==(v|0)){xa=h;break}else{wa=w;va=h}}}c[f>>2]=xa}xa=g&176;if((xa|0)==32){c[e>>2]=c[f>>2];i=t;return}else if((xa|0)==16){i=t;return}else{c[e>>2]=d;i=t;return}}function Osa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+104|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;Ana(m,g);z=m;A=c[z>>2]|0;if(!((c[36308]|0)==-1)){c[l>>2]=145232;c[l+4>>2]=964;c[l+8>>2]=0;pma(145232,l,965)}l=(c[145236>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Dc(4)|0;D=C;owa(D);E=160792;F=127;Ld(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Dc(4)|0;D=C;owa(D);E=160792;F=127;Ld(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+1|0}else{I=c[j+8>>2]|0}C=a[I]|0;H=C<<24>>24==(pe[c[(c[A>>2]|0)+28>>2]&63](F,45)|0)<<24>>24}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Msa(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=Jwa(P)|0;if((N|0)!=0){Q=N;R=N;break}Wwa()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+1|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}Nsa(R,w,x,c[g+4>>2]|0,S,S+T|0,F,H,o,a[p]|0,a[q]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];bja(b,k,R,e,w,g,h);if((Q|0)==0){Ema(t);Ema(s);Ema(r);U=c[z>>2]|0;V=U;W=V;X=Wla(W)|0;i=d;return}Kwa(Q);Ema(t);Ema(s);Ema(r);U=c[z>>2]|0;V=U;W=V;X=Wla(W)|0;i=d;return}function Psa(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function Qsa(a){a=a|0;i=i;return}function Rsa(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+400|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+400|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Lc(G|0,100,144984,o|0)|0;do{if(s>>>0>99){do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);o=c[36280]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=Dqa(r,o,144984,n)|0;o=c[r>>2]|0;if((o|0)==0){Wwa()}H=Jwa(G<<2)|0;I=H;if((H|0)!=0){J=o;K=I;L=I;M=G;break}Wwa()}else{J=0;K=0;L=q;M=s}}while(0);Ana(t,g);s=t;q=c[s>>2]|0;if(!((c[36306]|0)==-1)){c[p>>2]=145224;c[p+4>>2]=964;c[p+8>>2]=0;pma(145224,p,965)}p=(c[145228>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){N=Dc(4)|0;O=N;owa(O);P=160792;Q=127;Ld(N|0,P|0,Q|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){N=Dc(4)|0;O=N;owa(O);P=160792;Q=127;Ld(N|0,P|0,Q|0)}Q=q;P=c[r>>2]|0;ze[c[(c[q>>2]|0)+48>>2]&63](Q,P,P+M|0,L)|0;if((M|0)==0){R=0}else{R=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Ssa(f,R,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((M|0)>(C|0)){B=a[A]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){T=(B&255)>>>1}else{T=c[z+4>>2]|0}U=S+(M-C<<1|1)+T|0}else{T=a[A]|0;if((T&1)==0){V=(T&255)>>>1}else{V=c[A+4>>2]|0}T=a[z]|0;if((T&1)==0){W=(T&255)>>>1}else{W=c[z+4>>2]|0}U=V+2+W|0}W=U+C|0;do{if(W>>>0>100){U=Jwa(W<<2)|0;V=U;if((U|0)!=0){X=V;Y=V;break}Wwa()}else{X=0;Y=t}}while(0);Tsa(Y,D,E,c[g+4>>2]|0,L,L+(M<<2)|0,Q,R,v,c[w>>2]|0,c[x>>2]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];Mqa(b,m,Y,e,D,g,j);if((X|0)!=0){Kwa(X)}gna(A);gna(z);Ema(y);Wla(c[s>>2]|0)|0;if((K|0)!=0){Kwa(K)}if((J|0)==0){i=d;return}Kwa(J);i=d;return}function Ssa(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[36200]|0)==-1)){c[p>>2]=144800;c[p+4>>2]=964;c[p+8>>2]=0;pma(144800,p,965)}p=(c[144804>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Dc(4)|0;I=H;owa(I);J=160792;K=127;Ld(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Dc(4)|0;I=H;owa(I);J=160792;K=127;Ld(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){_d[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;_d[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}jna(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;gna(s)}else{_d[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;_d[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}jna(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;gna(v)}c[g>>2]=ae[c[(c[e>>2]|0)+12>>2]&127](K)|0;c[h>>2]=ae[c[(c[e>>2]|0)+16>>2]&127](K)|0;_d[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}Qma(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Ema(w);_d[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}jna(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;gna(x);L=ae[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[36184]|0)==-1)){c[o>>2]=144736;c[o+4>>2]=964;c[o+8>>2]=0;pma(144736,o,965)}o=(c[144740>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Dc(4)|0;N=M;owa(N);O=160792;P=127;Ld(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Dc(4)|0;N=M;owa(N);O=160792;P=127;Ld(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){_d[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;_d[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}jna(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;gna(A)}else{_d[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;_d[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}jna(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;gna(D)}c[g>>2]=ae[c[(c[G>>2]|0)+12>>2]&127](P)|0;c[h>>2]=ae[c[(c[G>>2]|0)+16>>2]&127](P)|0;_d[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}Qma(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Ema(E);_d[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}jna(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;gna(F);L=ae[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function Tsa(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;s=i;c[e>>2]=b;t=q+4|0;u=q+8|0;v=(f&512|0)==0;w=p+4|0;x=p+8|0;y=(r|0)>0;z=o+1|0;A=o+8|0;B=o+4|0;C=g;g=0;while(1){a:do{switch(a[l+g|0]|0){case 4:{D=c[e>>2]|0;E=k?C+4|0:C;b:do{if(E>>>0<h>>>0){F=E;while(1){G=F+4|0;if(!(de[c[(c[j>>2]|0)+12>>2]&63](j,2048,c[F>>2]|0)|0)){H=F;break b}if(G>>>0<h>>>0){F=G}else{H=G;break}}}else{H=E}}while(0);if(y){do{if(H>>>0>E>>>0){F=c[e>>2]|0;G=H;I=r;while(1){J=G+ -4|0;K=F+4|0;c[F>>2]=c[J>>2];L=I+ -1|0;M=(L|0)>0;if(J>>>0>E>>>0&M){I=L;G=J;F=K}else{break}}c[e>>2]=K;if(M){N=J;O=L;P=34;break}F=c[e>>2]|0;c[e>>2]=F+4;Q=F;R=J}else{N=H;O=r;P=34}}while(0);do{if((P|0)==34){P=0;F=pe[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;G=c[e>>2]|0;I=G+4|0;c[e>>2]=I;if((O|0)>0){S=I;T=G;U=O}else{Q=G;R=N;break}while(1){c[T>>2]=F;I=U+ -1|0;if((I|0)>0){U=I;T=S;S=S+4|0}else{break}}c[e>>2]=G+(O+1<<2);Q=G+(O<<2)|0;R=N}}while(0);c[Q>>2]=m;V=R}else{V=H}if((V|0)==(E|0)){F=pe[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;I=c[e>>2]|0;W=I+4|0;c[e>>2]=W;c[I>>2]=F;X=W}else{W=a[o]|0;F=(W&1)==0;if(F){Y=(W&255)>>>1}else{Y=c[B>>2]|0}if((Y|0)==0){Z=V;_=-1;$=0;aa=0}else{if(F){ba=z}else{ba=c[A>>2]|0}Z=V;_=a[ba]|0;$=0;aa=0}while(1){F=c[e>>2]|0;do{if((aa|0)==(_|0)){W=F+4|0;c[e>>2]=W;c[F>>2]=n;I=$+1|0;ca=a[o]|0;da=(ca&1)==0;if(da){ea=(ca&255)>>>1}else{ea=c[B>>2]|0}if(!(I>>>0<ea>>>0)){fa=W;ga=_;ha=I;ia=0;break}if(da){ja=z}else{ja=c[A>>2]|0}if((a[ja+I|0]|0)==127){fa=W;ga=-1;ha=I;ia=0;break}if(da){ka=z}else{ka=c[A>>2]|0}fa=W;ga=a[ka+I|0]|0;ha=I;ia=0}else{fa=F;ga=_;ha=$;ia=aa}}while(0);F=Z+ -4|0;G=c[F>>2]|0;I=fa+4|0;c[e>>2]=I;c[fa>>2]=G;if((F|0)==(E|0)){X=I;break}else{Z=F;_=ga;$=ha;aa=ia+1|0}}}if((D|0)==(X|0)){la=E;break a}F=X+ -4|0;if(F>>>0>D>>>0){ma=D;na=F}else{la=E;break a}while(1){F=c[ma>>2]|0;c[ma>>2]=c[na>>2];c[na>>2]=F;F=ma+4|0;I=na+ -4|0;if(F>>>0<I>>>0){na=I;ma=F}else{la=E;break}}break};case 1:{c[d>>2]=c[e>>2];E=pe[c[(c[j>>2]|0)+44>>2]&63](j,32)|0;D=c[e>>2]|0;c[e>>2]=D+4;c[D>>2]=E;la=C;break};case 3:{E=a[q]|0;D=(E&1)==0;if(D){oa=(E&255)>>>1}else{oa=c[t>>2]|0}if((oa|0)==0){la=C;break a}if(D){pa=t}else{pa=c[u>>2]|0}D=c[pa>>2]|0;E=c[e>>2]|0;c[e>>2]=E+4;c[E>>2]=D;la=C;break};case 0:{c[d>>2]=c[e>>2];la=C;break};case 2:{D=a[p]|0;E=(D&1)==0;if(E){qa=(D&255)>>>1}else{qa=c[w>>2]|0}if((qa|0)==0|v){la=C;break a}if(E){ra=w;sa=(D&255)>>>1}else{ra=c[x>>2]|0;sa=c[w>>2]|0}D=ra+(sa<<2)|0;E=c[e>>2]|0;if((ra|0)==(D|0)){ta=E}else{F=(ra+(sa+ -1<<2)+(0-ra)|0)>>>2;I=E;G=ra;while(1){c[I>>2]=c[G>>2];W=G+4|0;if((W|0)==(D|0)){break}I=I+4|0;G=W}ta=E+(F+1<<2)|0}c[e>>2]=ta;la=C;break};default:{la=C}}}while(0);G=g+1|0;if(G>>>0<4){C=la;g=G}else{break}}g=a[q]|0;q=(g&1)==0;if(q){ua=(g&255)>>>1}else{ua=c[t>>2]|0}if(ua>>>0>1){if(q){va=t;wa=(g&255)>>>1}else{va=c[u>>2]|0;wa=c[t>>2]|0}t=va+4|0;u=va+(wa<<2)|0;g=c[e>>2]|0;if((t|0)==(u|0)){xa=g}else{q=(va+(wa+ -1<<2)+(0-t)|0)>>>2;wa=g;va=t;while(1){c[wa>>2]=c[va>>2];t=va+4|0;if((t|0)==(u|0)){break}else{va=t;wa=wa+4|0}}xa=g+(q+1<<2)|0}c[e>>2]=xa}xa=f&176;if((xa|0)==32){c[d>>2]=c[e>>2];i=s;return}else if((xa|0)==16){i=s;return}else{c[d>>2]=b;i=s;return}}function Usa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+400|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;Ana(m,g);z=m;A=c[z>>2]|0;if(!((c[36306]|0)==-1)){c[l>>2]=145224;c[l+4>>2]=964;c[l+8>>2]=0;pma(145224,l,965)}l=(c[145228>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Dc(4)|0;D=C;owa(D);E=160792;F=127;Ld(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Dc(4)|0;D=C;owa(D);E=160792;F=127;Ld(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+4|0}else{I=c[j+8>>2]|0}C=c[I>>2]|0;H=(C|0)==(pe[c[(c[A>>2]|0)+44>>2]&63](F,45)|0)}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Ssa(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=Jwa(P<<2)|0;O=N;if((N|0)!=0){Q=O;R=O;break}Wwa()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+4|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}Tsa(R,w,x,c[g+4>>2]|0,S,S+(T<<2)|0,F,H,o,c[p>>2]|0,c[q>>2]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];Mqa(b,k,R,e,w,g,h);if((Q|0)==0){gna(t);gna(s);Ema(r);U=c[z>>2]|0;V=U;W=V;X=Wla(W)|0;i=d;return}Kwa(Q);gna(t);gna(s);Ema(r);U=c[z>>2]|0;V=U;W=V;X=Wla(W)|0;i=d;return}function Vsa(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function Wsa(a){a=a|0;i=i;return}function Xsa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=tc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function Ysa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;j=d;k=j;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;k=a[h]|0;if((k&1)==0){l=h+1|0;m=h+1|0;n=(k&255)>>>1}else{k=c[h+8>>2]|0;l=k;m=k;n=c[h+4>>2]|0}h=l+n|0;do{if(m>>>0<h>>>0){n=m;do{Wma(j,a[n]|0);n=n+1|0;}while(n>>>0<h>>>0);n=(e|0)==-1?-1:e<<1;if((a[j]&1)==0){o=n;p=9;break}q=n;r=c[j+8>>2]|0}else{o=(e|0)==-1?-1:e<<1;p=9}}while(0);if((p|0)==9){q=o;r=j+1|0}o=rd(q|0,f|0,g|0,r|0)|0;r=b;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;r=lxa(o|0)|0;g=o+r|0;if((r|0)>0){s=o}else{Ema(j);i=d;return}do{Wma(b,a[s]|0);s=s+1|0;}while(s>>>0<g>>>0);Ema(j);i=d;return}function Zsa(a,b){a=a|0;b=b|0;a=i;Gb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function _sa(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function $sa(a){a=a|0;i=i;return}function ata(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=tc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function bta(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+240|0;j=d;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=d+224|0;t=d+232|0;u=r;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[s+4>>2]=0;c[s>>2]=146888;u=a[h]|0;if((u&1)==0){v=h+4|0;w=h+4|0;x=(u&255)>>>1}else{u=c[h+8>>2]|0;v=u;w=u;x=c[h+4>>2]|0}h=v+(x<<2)|0;x=k;v=j;u=j;c[u>>2]=0;c[u+4>>2]=0;a:do{if(w>>>0<h>>>0){u=s;j=k+32|0;y=w;z=146888|0;while(1){c[m>>2]=y;A=(ye[c[z+12>>2]&15](u,v,y,h,m,x,j,l)|0)==2;B=c[m>>2]|0;if(A|(B|0)==(y|0)){break}if(x>>>0<(c[l>>2]|0)>>>0){A=x;do{Wma(r,a[A]|0);A=A+1|0;}while(A>>>0<(c[l>>2]|0)>>>0);C=c[m>>2]|0}else{C=B}if(!(C>>>0<h>>>0)){break a}y=C;z=c[s>>2]|0}wsa(146112)}}while(0);if((a[r]&1)==0){D=r+1|0}else{D=c[r+8>>2]|0}s=rd(((e|0)==-1?-1:e<<1)|0,f|0,g|0,D|0)|0;D=b;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[t+4>>2]=0;c[t>>2]=146992;D=lxa(s|0)|0;g=s+D|0;f=n;e=n;c[e>>2]=0;c[e+4>>2]=0;if((D|0)<=0){Ema(r);i=d;return}D=t;e=g;n=o;C=o+128|0;o=s;s=146992|0;while(1){c[q>>2]=o;h=(ye[c[s+16>>2]&15](D,f,o,(e-o|0)>32?o+32|0:g,q,n,C,p)|0)==2;m=c[q>>2]|0;if(h|(m|0)==(o|0)){E=20;break}if(n>>>0<(c[p>>2]|0)>>>0){h=n;do{kna(b,c[h>>2]|0);h=h+4|0;}while(h>>>0<(c[p>>2]|0)>>>0);F=c[q>>2]|0}else{F=m}if(!(F>>>0<g>>>0)){E=25;break}o=F;s=c[t>>2]|0}if((E|0)==20){wsa(146112)}else if((E|0)==25){Ema(r);i=d;return}}function cta(a,b){a=a|0;b=b|0;a=i;Gb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function dta(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=145320;e=b+8|0;b=c[e>>2]|0;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);if((b|0)==(c[36280]|0)){i=d;return}$b(c[e>>2]|0);i=d;return}function eta(a){a=a|0;a=Dc(8)|0;Xla(a,145112);c[a>>2]=142080;Ld(a|0,142120,40)}function fta(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+448|0;f=e;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;z=e+304|0;A=e+320|0;B=e+336|0;C=e+352|0;D=e+368|0;E=e+384|0;F=e+400|0;G=e+416|0;H=e+432|0;c[b+4>>2]=d+ -1;c[b>>2]=145152;d=b+8|0;I=b+12|0;J=b+136|0;a[J]=1;K=b+24|0;c[I>>2]=K;c[d>>2]=K;c[b+16>>2]=J;J=28;L=K;do{if((L|0)==0){M=0}else{c[L>>2]=0;M=c[I>>2]|0}L=M+4|0;c[I>>2]=L;J=J+ -1|0;}while((J|0)!=0);wma(b+144|0,145136,1);J=c[d>>2]|0;d=c[I>>2]|0;if((d|0)!=(J|0)){c[I>>2]=d+(~((d+ -4+(0-J)|0)>>>2)<<2)}c[150044>>2]=0;c[37510]=143632;if(!((c[35914]|0)==-1)){c[G>>2]=143656;c[G+4>>2]=964;c[G+8>>2]=0;pma(143656,G,965)}gta(b,150040,(c[143660>>2]|0)+ -1|0);c[150036>>2]=0;c[37508]=143672;if(!((c[35924]|0)==-1)){c[F>>2]=143696;c[F+4>>2]=964;c[F+8>>2]=0;pma(143696,F,965)}gta(b,150032,(c[143700>>2]|0)+ -1|0);c[150020>>2]=0;c[37504]=145248;c[150024>>2]=0;a[150028|0]=0;F=c[(xc()|0)>>2]|0;c[150024>>2]=F;if(!((c[36308]|0)==-1)){c[E>>2]=145232;c[E+4>>2]=964;c[E+8>>2]=0;pma(145232,E,965)}gta(b,150016,(c[145236>>2]|0)+ -1|0);c[150012>>2]=0;c[37502]=146208;if(!((c[36306]|0)==-1)){c[D>>2]=145224;c[D+4>>2]=964;c[D+8>>2]=0;pma(145224,D,965)}gta(b,150008,(c[145228>>2]|0)+ -1|0);c[150004>>2]=0;c[37500]=146424;if(!((c[36324]|0)==-1)){c[C>>2]=145296;c[C+4>>2]=964;c[C+8>>2]=0;pma(145296,C,965)}gta(b,15e4,(c[145300>>2]|0)+ -1|0);c[149988>>2]=0;c[37496]=145320;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);c[149992>>2]=c[36280];if(!((c[36326]|0)==-1)){c[B>>2]=145304;c[B+4>>2]=964;c[B+8>>2]=0;pma(145304,B,965)}gta(b,149984,(c[145308>>2]|0)+ -1|0);c[149980>>2]=0;c[37494]=146648;if(!((c[36340]|0)==-1)){c[A>>2]=145360;c[A+4>>2]=964;c[A+8>>2]=0;pma(145360,A,965)}gta(b,149976,(c[145364>>2]|0)+ -1|0);c[149972>>2]=0;c[37492]=146768;if(!((c[36342]|0)==-1)){c[z>>2]=145368;c[z+4>>2]=964;c[z+8>>2]=0;pma(145368,z,965)}gta(b,149968,(c[145372>>2]|0)+ -1|0);c[149948>>2]=0;c[37486]=145400;a[149952|0]=46;a[149953|0]=44;z=149956|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;if(!((c[36344]|0)==-1)){c[y>>2]=145376;c[y+4>>2]=964;c[y+8>>2]=0;pma(145376,y,965)}gta(b,149944,(c[145380>>2]|0)+ -1|0);c[149916>>2]=0;c[37478]=145440;c[149920>>2]=46;c[149924>>2]=44;y=149928|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(!((c[36346]|0)==-1)){c[x>>2]=145384;c[x+4>>2]=964;c[x+8>>2]=0;pma(145384,x,965)}gta(b,149912,(c[145388>>2]|0)+ -1|0);c[149908>>2]=0;c[37476]=143712;if(!((c[35942]|0)==-1)){c[w>>2]=143768;c[w+4>>2]=964;c[w+8>>2]=0;pma(143768,w,965)}gta(b,149904,(c[143772>>2]|0)+ -1|0);c[149900>>2]=0;c[37474]=143832;if(!((c[35972]|0)==-1)){c[v>>2]=143888;c[v+4>>2]=964;c[v+8>>2]=0;pma(143888,v,965)}gta(b,149896,(c[143892>>2]|0)+ -1|0);c[149892>>2]=0;c[37472]=143904;if(!((c[35988]|0)==-1)){c[u>>2]=143952;c[u+4>>2]=964;c[u+8>>2]=0;pma(143952,u,965)}gta(b,149888,(c[143956>>2]|0)+ -1|0);c[149884>>2]=0;c[37470]=143968;if(!((c[36004]|0)==-1)){c[t>>2]=144016;c[t+4>>2]=964;c[t+8>>2]=0;pma(144016,t,965)}gta(b,149880,(c[144020>>2]|0)+ -1|0);c[149876>>2]=0;c[37468]=144560;if(!((c[36152]|0)==-1)){c[s>>2]=144608;c[s+4>>2]=964;c[s+8>>2]=0;pma(144608,s,965)}gta(b,149872,(c[144612>>2]|0)+ -1|0);c[149868>>2]=0;c[37466]=144624;if(!((c[36168]|0)==-1)){c[r>>2]=144672;c[r+4>>2]=964;c[r+8>>2]=0;pma(144672,r,965)}gta(b,149864,(c[144676>>2]|0)+ -1|0);c[149860>>2]=0;c[37464]=144688;if(!((c[36184]|0)==-1)){c[q>>2]=144736;c[q+4>>2]=964;c[q+8>>2]=0;pma(144736,q,965)}gta(b,149856,(c[144740>>2]|0)+ -1|0);c[149852>>2]=0;c[37462]=144752;if(!((c[36200]|0)==-1)){c[p>>2]=144800;c[p+4>>2]=964;c[p+8>>2]=0;pma(144800,p,965)}gta(b,149848,(c[144804>>2]|0)+ -1|0);c[149844>>2]=0;c[37460]=144816;if(!((c[36210]|0)==-1)){c[o>>2]=144840;c[o+4>>2]=964;c[o+8>>2]=0;pma(144840,o,965)}gta(b,149840,(c[144844>>2]|0)+ -1|0);c[149836>>2]=0;c[37458]=144896;if(!((c[36230]|0)==-1)){c[n>>2]=144920;c[n+4>>2]=964;c[n+8>>2]=0;pma(144920,n,965)}gta(b,149832,(c[144924>>2]|0)+ -1|0);c[149828>>2]=0;c[37456]=144952;if(!((c[36244]|0)==-1)){c[m>>2]=144976;c[m+4>>2]=964;c[m+8>>2]=0;pma(144976,m,965)}gta(b,149824,(c[144980>>2]|0)+ -1|0);c[149820>>2]=0;c[37454]=145e3;if(!((c[36256]|0)==-1)){c[l>>2]=145024;c[l+4>>2]=964;c[l+8>>2]=0;pma(145024,l,965)}gta(b,149816,(c[145028>>2]|0)+ -1|0);c[149804>>2]=0;c[37450]=144048;c[149808>>2]=144096;if(!((c[36032]|0)==-1)){c[k>>2]=144128;c[k+4>>2]=964;c[k+8>>2]=0;pma(144128,k,965)}gta(b,149800,(c[144132>>2]|0)+ -1|0);c[149788>>2]=0;c[37446]=144200;c[149792>>2]=144248;if(!((c[36070]|0)==-1)){c[j>>2]=144280;c[j+4>>2]=964;c[j+8>>2]=0;pma(144280,j,965)}gta(b,149784,(c[144284>>2]|0)+ -1|0);c[149772>>2]=0;c[37442]=146144;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);c[149776>>2]=c[36280];c[37442]=144496;if(!((c[36128]|0)==-1)){c[h>>2]=144512;c[h+4>>2]=964;c[h+8>>2]=0;pma(144512,h,965)}gta(b,149768,(c[144516>>2]|0)+ -1|0);c[149756>>2]=0;c[37438]=146144;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);c[149760>>2]=c[36280];c[37438]=144528;if(!((c[36136]|0)==-1)){c[g>>2]=144544;c[g+4>>2]=964;c[g+8>>2]=0;pma(144544,g,965)}gta(b,149752,(c[144548>>2]|0)+ -1|0);c[149748>>2]=0;c[37436]=145040;if(!((c[36266]|0)==-1)){c[f>>2]=145064;c[f+4>>2]=964;c[f+8>>2]=0;pma(145064,f,965)}gta(b,149744,(c[145068>>2]|0)+ -1|0);c[149740>>2]=0;c[37434]=145080;if((c[36276]|0)==-1){N=145104;O=145104;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=149736;gta(b,T,S);i=e;return}c[H>>2]=145104;c[H+4>>2]=964;c[H+8>>2]=0;pma(145104,H,965);N=145104;O=145104;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=149736;gta(b,T,S);i=e;return}function gta(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;Vla(b);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f;j=c[h>>2]|0;k=a-j>>2;do{if(k>>>0>d>>>0){l=j}else{m=d+1|0;if(k>>>0<m>>>0){lva(f,m-k|0);l=c[h>>2]|0;break}if(!(k>>>0>m>>>0)){l=j;break}n=j+(m<<2)|0;if((a|0)==(n|0)){l=j;break}c[g>>2]=a+(~((a+ -4+(0-n)|0)>>>2)<<2);l=j}}while(0);j=c[l+(d<<2)>>2]|0;if((j|0)==0){o=l;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}Wla(j)|0;o=c[h>>2]|0;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}function hta(a){a=a|0;var b=0;b=i;ita(a);Rwa(a);i=b;return}function ita(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[b>>2]=145152;e=b+12|0;f=c[e>>2]|0;g=b+8|0;h=c[g>>2]|0;if((f|0)!=(h|0)){j=f;f=h;h=0;while(1){k=c[f+(h<<2)>>2]|0;if((k|0)==0){l=f;m=j}else{Wla(k)|0;l=c[g>>2]|0;m=c[e>>2]|0}k=h+1|0;if(k>>>0<m-l>>2>>>0){j=m;f=l;h=k}else{break}}}Ema(b+144|0);h=c[g>>2]|0;if((h|0)==0){i=d;return}g=c[e>>2]|0;if((g|0)!=(h|0)){c[e>>2]=g+(~((g+ -4+(0-h)|0)>>>2)<<2)}if((b+24|0)==(h|0)){a[b+136|0]=0;i=d;return}else{Rwa(h);i=d;return}}function jta(){var b=0,d=0,e=0,f=0;b=i;if((a[145208]|0)!=0){d=145200;e=c[36300]|0;i=b;return e|0}if((Ya(145208)|0)==0){d=145200;e=c[36300]|0;i=b;return e|0}do{if((a[145184]|0)==0){if((Ya(145184)|0)==0){break}fta(149576,1);c[36292]=149576;c[36294]=145168;Sb(145184)}}while(0);f=c[c[36294]>>2]|0;c[36298]=f;Vla(f);c[36300]=145192;Sb(145208);d=145200;e=c[36300]|0;i=b;return e|0}function kta(a){a=a|0;var b=0,d=0;b=i;d=c[(jta()|0)>>2]|0;c[a>>2]=d;Vla(d);i=b;return}function lta(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;Vla(e);i=d;return}function mta(a){a=a|0;var b=0;b=i;Wla(c[a>>2]|0)|0;i=b;return}function nta(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=964;c[e+8>>2]=0;pma(a,e,965)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function ota(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=964;c[e+8>>2]=0;pma(a,e,965)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=Dc(4)|0;h=g;owa(h);j=160792;k=127;Ld(g|0,j|0,k|0)}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=Dc(4)|0;h=g;owa(h);j=160792;k=127;Ld(g|0,j|0,k|0)}else{i=d;return f|0}return 0}function pta(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function qta(a){a=a|0;var b=0;b=i;if((a|0)==0){i=b;return}Zd[c[(c[a>>2]|0)+4>>2]&1023](a);i=b;return}function rta(a){a=a|0;var b=0;b=c[36304]|0;c[36304]=1+b;c[a+4>>2]=b+1;i=i;return}function sta(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function tta(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;a=i;if(!(e>>>0<128)){f=0;i=a;return f|0}f=(b[(c[(xc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;i=a;return f|0}function uta(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;if((d|0)==(e|0)){g=d;i=a;return g|0}else{h=d;j=f}while(1){f=c[h>>2]|0;if(f>>>0<128){k=b[(c[(xc()|0)>>2]|0)+(f<<1)>>1]|0}else{k=0}b[j>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;break}else{h=f;j=j+2|0}}i=a;return g|0}function vta(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;if((e|0)==(f|0)){g=e;i=a;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128){if(!((b[(c[(xc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16==0)){g=h;j=5;break}}e=h+4|0;if((e|0)==(f|0)){g=f;j=5;break}else{h=e}}if((j|0)==5){i=a;return g|0}return 0}function wta(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;a:do{if((e|0)==(f|0)){g=e}else{h=e;while(1){j=c[h>>2]|0;if(!(j>>>0<128)){g=h;break a}k=h+4|0;if((b[(c[(xc()|0)>>2]|0)+(j<<1)>>1]&d)<<16>>16==0){g=h;break a}if((k|0)==(f|0)){g=f;break}else{h=k}}}}while(0);i=a;return g|0}function xta(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(vd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function yta(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(vd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function zta(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Ad()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function Ata(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Ad()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function Bta(a,b){a=a|0;b=b|0;i=i;return b<<24>>24|0}



function Xia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;e=i;f=i;i=i+168|0;c[f>>2]=0;g=i;i=i+160|0;h=(c[d+536>>2]|0)+76|0;j=c[h>>2]|0;c[h>>2]=g;kxa(g,1,f|0)|0;u=0;g=u;u=0;if((g|0)!=0&(v|0)!=0){k=yxa(c[g>>2]|0,f)|0;if((k|0)==0){db(g|0,v|0)}J=v}else{k=-1}if((k|0)==1){l=J}else{l=0}while(1){if((l|0)==0){u=0;k=va(41,a|0,b|0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){m=yxa(c[g>>2]|0,f)|0;if((m|0)==0){db(g|0,v|0)}J=v}else{m=-1}if((m|0)==1){l=J;continue}if((k|0)!=0){n=1;o=17;break}c[30032]=d;u=0;Ha(60,10,960)|0;k=u;u=0;if((k|0)!=0&(v|0)!=0){p=yxa(c[k>>2]|0,f)|0;if((p|0)==0){db(k|0,v|0)}J=v}else{p=-1}if((p|0)==1){l=J;continue}u=0;k=va(42,0,0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){q=yxa(c[g>>2]|0,f)|0;if((q|0)==0){db(g|0,v|0)}J=v}else{q=-1}if((q|0)==1){l=J;continue}u=0;sa(108,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){r=yxa(c[g>>2]|0,f)|0;if((r|0)==0){db(g|0,v|0)}J=v}else{r=-1}if((r|0)==1){l=J;continue}u=0;sa(109,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){s=yxa(c[g>>2]|0,f)|0;if((s|0)==0){db(g|0,v|0)}J=v}else{s=-1}if((s|0)==1){l=J;continue}u=0;sa(110,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){t=yxa(c[g>>2]|0,f)|0;if((t|0)==0){db(g|0,v|0)}J=v}else{t=-1}if((t|0)==1){l=J;continue}u=0;pa(c[(c[d+540>>2]|0)+8>>2]|0,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){w=yxa(c[g>>2]|0,f)|0;if((w|0)==0){db(g|0,v|0)}J=v}else{w=-1}if((w|0)==1){l=J;continue}u=0;pa(961,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){x=yxa(c[g>>2]|0,f)|0;if((x|0)==0){db(g|0,v|0)}J=v}else{x=-1}if((x|0)==1){l=J;continue}u=0;sa(99,0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){y=yxa(c[g>>2]|0,f)|0;if((y|0)==0){db(g|0,v|0)}J=v}else{y=-1}if((y|0)==1){l=J;continue}z=k}else{z=-1}c[h>>2]=j;u=0;k=u;u=0;if((k|0)!=0&(v|0)!=0){A=yxa(c[k>>2]|0,f)|0;if((A|0)==0){db(k|0,v|0)}J=v}else{A=-1}if((A|0)==1){l=J}else{break}}if((o|0)==17){i=e;return n|0}n=z;i=e;return n|0}function Yia(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;f=i;i=i+16|0;if((a|0)==0){g=hd(c[17066]|0)|0}else{g=a}switch(c[g+84>>2]|0){case 1:{c[f>>2]=e;a=c[r>>2]|0;qc(120400,7,1,a|0)|0;Cc(a|0,d|0,f|0)|0;Kd(10,a|0)|0;nd(0)|0;db(c[g+80>>2]|0,1);break};case 2:{if((c[70900>>2]|0)==0){h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;db(n|0,1)}c[f>>2]=e;a=c[r>>2]|0;qc(120400,7,1,a|0)|0;Cc(a|0,d|0,f|0)|0;Kd(10,a|0)|0;nd(0)|0;h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;db(n|0,1);break};case 3:{if((c[70956>>2]|0)==0){i=b;return}c[f>>2]=e;e=c[r>>2]|0;qc(120400,7,1,e|0)|0;Cc(e|0,d|0,f|0)|0;Kd(10,e|0)|0;nd(0)|0;i=b;return};case 5:case 4:{i=b;return};default:{Z1(g,120408,b)}}}function Zia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=d;d=c[r>>2]|0;qc(120384,9,1,d|0)|0;Cc(d|0,b|0,e|0)|0;Kd(10,d|0)|0;nd(0)|0;i=a;return}function _ia(a,b){a=a|0;b=b|0;var c=0;c=i;aja(a,b);i=c;return}function $ia(a){a=a|0;i=i;return(c[a>>2]|0)==0|0}function aja(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=xna(b+(c[(c[b>>2]|0)+ -12>>2]|0)|0)|0;i=d;return}function bja(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+8|0;l=j+16|0;m=j+32|0;n=j+40|0;o=b;b=c[o>>2]|0;Z7(j);if((b|0)==0){c[a>>2]=0;i=j;return}p=f;f=d;q=p-f|0;r=cja(g)|0;s=(r|0)>(q|0)?r-q|0:0;q=e;r=q-f|0;do{if((r|0)>0){if((Jna(b,d,r)|0)==(r|0)){break}Z7(k);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);do{if((s|0)>0){zma(l,s,h);if((Jna(b,Dma(l)|0,s)|0)==(s|0)){Ema(l);break}Z7(m);c[o>>2]=0;c[a>>2]=0;Ema(l);i=j;return}}while(0);l=p-q|0;do{if((l|0)>0){if((Jna(b,e,l)|0)==(l|0)){break}Z7(n);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);dja(g,0)|0;c[a>>2]=b;i=j;return}function cja(a){a=a|0;i=i;return c[a+12>>2]|0}function dja(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function eja(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+136|0;g=f;fja(g,16);gja(g+(c[(c[g>>2]|0)+ -12>>2]|0)|0,16)|0;if((d|0)<=0){hja(a,g);ija(g);i=f;return}j=e+ -1|0;k=(j|0)>0;l=(e|0)>0;m=g;n=(e|0)==0;e=0;do{if(k){o=0;p=e;while(1){Nia(Soa(m,+h[b+(p<<3)>>3])|0,121768)|0;q=p+d|0;r=o+1|0;if((r|0)<(j|0)){p=q;o=r}else{s=q;break}}}else{s=e}if(l){Soa(m,+h[b+(s<<3)>>3])|0}e=e+1|0;if(!((e|0)==(d|0)|n)){Nia(m,121776)|0}}while((e|0)<(d|0));hja(a,g);ija(g);i=f;return}function fja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+56|0;Bna(e);f=a;c[f>>2]=122148;g=e;c[g>>2]=122168;e=a+4|0;Ioa(a,122180|0,e);c[f>>2]=122148;c[g>>2]=122168;uja(e,b|16);i=d;return}function gja(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function hja(a,b){a=a|0;b=b|0;var c=0;c=i;oja(a,b+4|0);i=c;return}function ija(a){a=a|0;var b=0;b=i;yja(a,122176);wna(a+56|0);i=b;return}function jja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+120>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[70944>>2]|0)!=0){sb(122472)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];V1(14,0,121784,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ae[c[(c[l>>2]|0)+160>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];V1(14,0,121856,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[70944>>2]|0)==0){i=d;return 0}V1(14,0,121904,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gc(121920,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}dc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function kja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+124>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[70944>>2]|0)!=0){sb(122472)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];V1(14,0,121784,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ae[c[(c[l>>2]|0)+164>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];V1(14,0,121856,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[70944>>2]|0)==0){i=d;return 0}V1(14,0,121904,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gc(121920,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}dc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function lja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+128>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[70944>>2]|0)!=0){sb(122472)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];V1(14,0,121784,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ae[c[(c[l>>2]|0)+168>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];V1(14,0,121856,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[70944>>2]|0)==0){i=d;return 0}V1(14,0,121904,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gc(121920,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}dc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function mja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+132>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[70944>>2]|0)!=0){sb(122472)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];V1(14,0,121784,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ae[c[(c[l>>2]|0)+172>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];V1(14,0,121856,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[70944>>2]|0)==0){i=d;return 0}V1(14,0,121904,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gc(121920,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}dc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function nja(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+24|0;d=b;e=i;i=i+24|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=c[a+112>>2]|0;G=c[a+152>>2]|0;H=c[a+156>>2]|0;I=Lwa(fa(F,F)|0,8)|0;J=I;K=Lwa(fa(G,F)|0,8)|0;L=K;M=Lwa(fa(H,F)|0,8)|0;N=M;O=Lwa(fa(H,G)|0,8)|0;P=O;sma(p);sma(q);sma(r);sma(s);sma(t);sma(u);sma(v);Q=a+536|0;Y1(c[Q>>2]|0,(I|0)!=0|0,121928,o);Y1(c[Q>>2]|0,(K|0)!=0|0,121928,n);Y1(c[Q>>2]|0,(M|0)!=0|0,121928,m);Y1(c[Q>>2]|0,(O|0)!=0|0,121928,l);l=a+540|0;m=a;if((ae[c[(c[l>>2]|0)+140>>2]&127](m)|0)==0){n=c[Q>>2]|0;jja(a,J)|0;Y1(n,1,121944,k)}eja(w,J,F,F);Fma(p,w)|0;Ema(w);if((ae[c[(c[l>>2]|0)+144>>2]&127](m)|0)==0){w=c[Q>>2]|0;kja(a,L)|0;Y1(w,1,121976,j)}eja(x,L,F,G);Fma(q,x)|0;Ema(x);if((ae[c[(c[l>>2]|0)+148>>2]&127](m)|0)==0){x=c[Q>>2]|0;lja(a,N)|0;Y1(x,1,122008,h)}eja(y,N,H,F);Fma(r,y)|0;Ema(y);if((ae[c[(c[l>>2]|0)+152>>2]&127](m)|0)==0){m=c[Q>>2]|0;mja(a,P)|0;Y1(m,1,122040,g)}eja(z,P,H,G);Fma(s,z)|0;Ema(z);if((F|0)==0){Gma(t,122072)|0}else{eja(A,c[(c[c[a+4>>2]>>2]|0)+8>>2]|0,1,F);Fma(t,A)|0;Ema(A)}if((G|0)==0){Gma(u,122072)|0}else{eja(B,c[a+432>>2]|0,1,G);Fma(u,B)|0;Ema(B)}Kwa(I);Kwa(K);Kwa(M);Kwa(O);yma(E,c[a+84>>2]|0);nna(D,122088,E);zba(C,D,122096);Fma(v,C)|0;Ema(C);Ema(D);Ema(E);E=ic($ma(v)|0,122104)|0;D=c[Q>>2]|0;c[f>>2]=$ma(v)|0;Y1(D,(E|0)!=0|0,122112,f);f=ue[c[(c[l>>2]|0)+176>>2]&7]()|0;D=$ma(t)|0;Q=$ma(u)|0;C=$ma(p)|0;a=$ma(q)|0;O=$ma(r)|0;M=$ma(s)|0;c[e>>2]=D;c[e+4>>2]=Q;c[e+8>>2]=C;c[e+12>>2]=a;c[e+16>>2]=O;c[e+20>>2]=M;pd(E|0,f|0,e|0)|0;if((c[70988>>2]|0)==0){R=nd(E|0)|0;S=Wc(E|0)|0;Ema(v);Ema(u);Ema(t);Ema(s);Ema(r);Ema(q);Ema(p);i=b;return 0}e=ue[c[(c[l>>2]|0)+176>>2]&7]()|0;l=$ma(t)|0;f=$ma(u)|0;M=$ma(p)|0;O=$ma(q)|0;a=$ma(r)|0;C=$ma(s)|0;c[d>>2]=l;c[d+4>>2]=f;c[d+8>>2]=M;c[d+12>>2]=O;c[d+16>>2]=a;c[d+20>>2]=C;V1(25,0,e,d);R=nd(E|0)|0;S=Wc(E|0)|0;Ema(v);Ema(u);Ema(t);Ema(s);Ema(r);Ema(q);Ema(p);i=b;return 0}function oja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;h=c[b+48>>2]|0;if((h&16|0)!=0){j=b+44|0;k=c[j>>2]|0;l=b;m=Rna(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}pja(a,Qna(l)|0,n,e);i=d;return}if((h&8|0)==0){tma(a,g);i=d;return}else{g=b;b=Lna(g)|0;pja(a,b,Nna(g)|0,f);i=d;return}}function pja(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;qja(a,b,c,0);i=d;return}function qja(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;rja(a,b,c);i=d;return}function rja(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=sja(c,d)|0;if(g>>>0>4294967279){qma(0)}if(g>>>0<11){Kma(b,g);h=Jma(b)|0}else{j=Rma(g)|0;k=j+1|0;j=jca(xma(b)|0,k)|0;Tma(b,j);Sma(b,k);Ima(b,g);h=j}if((c|0)==(d|0)){l=h;a[f]=0;kca(l,f);i=e;return}j=d+(0-c)|0;g=c;c=h;while(1){kca(c,g);b=g+1|0;if((b|0)==(d|0)){break}else{c=c+1|0;g=b}}l=h+j|0;a[f]=0;kca(l,f);i=e;return}function sja(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=tja(b,c,e)|0;i=d;return g|0}function tja(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return b-a|0}function uja(a,b){a=a|0;b=b|0;var c=0;c=i;Kja(a,b);i=c;return}function vja(a){a=a|0;var b=0;b=i;ija(a);Rwa(a);i=b;return}function wja(a){a=a|0;var b=0;b=i;ija(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function xja(a){a=a|0;var b=0;b=i;vja(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function yja(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];zja(a+4|0);i=d;return}function zja(a){a=a|0;var b=0;b=i;Aja(a);i=b;return}function Aja(a){a=a|0;var b=0;b=i;c[a>>2]=122328;Ema(a+32|0);Fna(a);i=b;return}function Bja(a){a=a|0;var b=0;b=i;zja(a);Rwa(a);i=b;return}function Cja(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=b+44|0;k=c[j>>2]|0;l=b;m=Rna(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}k=g&24;do{if((k|0)==0){l7(a,-1,-1);i=h;return}else if((k|0)==24){if((f|0)==0){o=0;p=0;break}else if((f|0)==2){q=11;break}else if((f|0)!=1){q=12;break}l7(a,-1,-1);i=h;return}else{if((f|0)==0){o=0;p=0;break}else if((f|0)==2){q=11;break}else if((f|0)!=1){q=12;break}if((g&8|0)==0){m=Rna(l)|0;j=m-(Qna(l)|0)|0;o=j;p=((j|0)<0)<<31>>31;break}else{j=Mna(l)|0;m=j-(Lna(l)|0)|0;o=m;p=((m|0)<0)<<31>>31;break}}}while(0);if((q|0)==11){f=n-(Dma(b+32|0)|0)|0;o=f;p=((f|0)<0)<<31>>31}else if((q|0)==12){l7(a,-1,-1);i=h;return}q=vxa(o|0,p|0,d|0,e|0)|0;e=J;do{if(!((e|0)<0|(e|0)==0&q>>>0<0)){d=n-(Dma(b+32|0)|0)|0;p=((d|0)<0)<<31>>31;if((p|0)<(e|0)|(p|0)==(e|0)&d>>>0<q>>>0){break}d=g&8;do{if(!((q|0)==0&(e|0)==0)){do{if((d|0)!=0){if((Mna(l)|0)!=0){break}l7(a,-1,-1);i=h;return}}while(0);if((g&16|0)==0){break}if((Rna(l)|0)!=0){break}l7(a,-1,-1);i=h;return}}while(0);if((d|0)!=0){p=Lna(l)|0;Pna(l,p,p+q|0,n)}if((g&16|0)!=0){p=Qna(l)|0;Una(l,p,Sna(l)|0);Tna(l,q)}l7(a,q,e);i=h;return}}while(0);l7(a,-1,-1);i=h;return}function Dja(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[b>>2]|0)+16>>2]|0;h=z8(d)|0;je[g&31](a,b,h,J,0,e);i=f;return}function Eja(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+44|0;f=c[e>>2]|0;g=b;h=Rna(g)|0;if(f>>>0<h>>>0){c[e>>2]=h;j=h}else{j=f}if((c[b+48>>2]&8|0)==0){k=-1;i=d;return k|0}if((Nna(g)|0)>>>0<j>>>0){b=Lna(g)|0;Pna(g,b,Mna(g)|0,j)}j=Mna(g)|0;if(!(j>>>0<(Nna(g)|0)>>>0)){k=-1;i=d;return k|0}k=X8(a[j]|0)|0;i=d;return k|0}function Fja(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+44|0;g=c[f>>2]|0;h=b;j=Rna(h)|0;if(g>>>0<j>>>0){c[f>>2]=j;k=j}else{k=g}g=Lna(h)|0;j=Mna(h)|0;if(!(g>>>0<j>>>0)){l=-1;i=e;return l|0}if(T8(d,-1)|0){Pna(h,g,j+ -1|0,k);l=W8(d)|0;i=e;return l|0}g=(c[b+48>>2]&16|0)==0;b=U8(d)|0;do{if(g){if(Y8(b,a[j+ -1|0]|0)|0){break}else{l=-1}i=e;return l|0}}while(0);j=Lna(h)|0;Pna(h,j,(Mna(h)|0)+ -1|0,k);a[Mna(h)|0]=b;l=d;i=e;return l|0}function Gja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;if(T8(b,-1)|0){f=W8(b)|0;i=d;return f|0}g=a;h=Mna(g)|0;j=h-(Lna(g)|0)|0;h=Rna(g)|0;do{if((h|0)==(Sna(g)|0)){k=a+48|0;if((c[k>>2]&16|0)==0){f=-1;i=d;return f|0}else{l=Qna(g)|0;m=a+44|0;n=(c[m>>2]|0)-l|0;o=a+32|0;Wma(o,0);Pma(o,Mma(o)|0);p=Dma(o)|0;Una(g,p,p+(Cma(o)|0)|0);Tna(g,h-l|0);c[m>>2]=(Qna(g)|0)+n;q=k;r=m;break}}else{q=a+48|0;r=a+44|0}}while(0);c[e>>2]=(Rna(g)|0)+1;h=c[(Hja(e,r)|0)>>2]|0;c[r>>2]=h;if((c[q>>2]&8|0)!=0){q=Dma(a+32|0)|0;Pna(g,q,q+j|0,h)}f=Ina(g,b&255)|0;i=d;return f|0}function Hja(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=Ija(b,c,e)|0;i=d;return g|0}function Ija(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=Jja(0,a,b)|0;i=c;return(d?b:a)|0}function Jja(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function Kja(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;Kna(a);c[a>>2]=122328;sma(a+32|0);c[a+44>>2]=0;c[a+48>>2]=b;sma(e);Lja(a,e);Ema(e);i=d;return}function Lja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+32|0;Fma(e,b)|0;b=a+44|0;c[b>>2]=0;f=a+48|0;g=c[f>>2]|0;if((g&8|0)==0){h=g}else{g=Dma(e)|0;j=g+(Cma(e)|0)|0;c[b>>2]=j;g=Dma(e)|0;Pna(a,g,g,j);h=c[f>>2]|0}if((h&16|0)==0){i=d;return}h=Cma(e)|0;c[b>>2]=(Dma(e)|0)+h;Pma(e,Mma(e)|0);b=a;a=Dma(e)|0;Una(b,a,a+(Cma(e)|0)|0);if((c[f>>2]&3|0)==0){i=d;return}Tna(b,h);i=d;return}function Mja(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0;j=i;i=i+8|0;g=j;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=ic(d|0,122752)|0;J=_c(122760,122752)|0;K=(J|0)!=0;L=Mc()|0;if(K){M=c[b+536>>2]|0;N=Od(c[L>>2]|0)|0;c[E>>2]=d;c[E+4>>2]=N;Y1(M,(I|0)!=0|0,122816,E);qc(122840,17,1,J|0)|0;qc(122864,10,1,J|0)|0;qc(122880,18,1,J|0)|0;Nja(J,f,122904,c[b+88>>2]|0,(c[b+72>>2]|0)+(c[b+64>>2]|0)|0,-1,999,122936)}else{c[G>>2]=Od(c[L>>2]|0)|0;X1(26,0,122768,G);G=c[b+536>>2]|0;E=Od(c[L>>2]|0)|0;c[F>>2]=d;c[F+4>>2]=E;Y1(G,(I|0)!=0|0,122816,F)}qc(122944,348,1,I|0)|0;if((rc(H|0)|0)<0){c[D>>2]=Od(c[L>>2]|0)|0;X1(26,0,123296,D);Wc(I|0)|0;$a(J|0)|0;O=1;i=j;return O|0}if((Rc(122496,250,123320,gd(H|0)|0)|0)==0){X1(26,0,123344,C);Wc(I|0)|0;O=1;i=j;return O|0}qc(123368,13,1,I|0)|0;qc(123384,12,1,I|0)|0;Oja(I,2);qc(123400,6,1,I|0)|0;Pja(I,c[b+84>>2]|0);qc(123408,8,1,I|0)|0;Oja(I,2);qc(123424,8,1,I|0)|0;C=b+88|0;Pja(I,c[C>>2]|0);qc(123440,10,1,I|0)|0;Oja(I,2);qc(123456,6,1,I|0)|0;Pja(I,122496);qc(123464,8,1,I|0)|0;Oja(I,2);qc(123480,8,1,I|0)|0;Pja(I,c[b+280>>2]|0);qc(123496,10,1,I|0)|0;Oja(I,2);qc(123512,14,1,I|0)|0;Pja(I,c[b+284>>2]|0);qc(123528,16,1,I|0)|0;Oja(I,2);qc(123552,16,1,I|0)|0;Pja(I,l);qc(123576,18,1,I|0)|0;Oja(I,2);c[B>>2]=Qja(l)|0;pd(I|0,123600,B|0)|0;Oja(I,2);P=+C3(7);B=A;h[k>>3]=P;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];pd(I|0,123640,A|0)|0;Oja(I,2);P=+C3(6);A=z;h[k>>3]=P;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];pd(I|0,123680,z|0)|0;Oja(I,2);P=+C3(1);z=y;h[k>>3]=P;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];pd(I|0,123712,y|0)|0;Oja(I,2);P=+C3(4);y=x;h[k>>3]=P;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];pd(I|0,123744,x|0)|0;Oja(I,2);P=+C3(3);x=w;h[k>>3]=P;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];pd(I|0,123776,w|0)|0;Oja(I,2);P=+C3(5);w=v;h[k>>3]=P;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];pd(I|0,123808,v|0)|0;Oja(I,2);P=+C3(0);v=u;h[k>>3]=P;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];pd(I|0,123848,u|0)|0;Oja(I,2);P=+F3(2);u=t;h[k>>3]=P;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];pd(I|0,123880,t|0)|0;Oja(I,2);c[s>>2]=A3(2)|0;pd(I|0,123920,s|0)|0;Oja(I,2);P=+E3(2);s=r;h[k>>3]=P;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];pd(I|0,123944,r|0)|0;qc(123976,13,1,I|0)|0;qc(123992,16,1,I|0)|0;Oja(I,2);P=+C3(8);r=q;h[k>>3]=P;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];pd(I|0,124016,q|0)|0;Oja(I,2);c[p>>2]=x3(8)|0;pd(I|0,124040,p|0)|0;qc(124080,17,1,I|0)|0;qc(124104,22,1,I|0)|0;Rja(I,b);qc(124128,23,1,I|0)|0;qc(124152,12,1,I|0)|0;p=b+116|0;if((c[p>>2]|0)>0){q=b+8|0;r=0;do{Sja(I,(c[q>>2]|0)+(r*112|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+136|0;if((c[p>>2]|0)>0){r=b+24|0;q=0;do{Sja(I,(c[r>>2]|0)+(q*112|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+124|0;if((c[p>>2]|0)>0){q=b+12|0;r=0;do{Sja(I,(c[q>>2]|0)+(r*60|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+140|0;if((c[p>>2]|0)>0){r=b+28|0;q=0;do{Sja(I,(c[r>>2]|0)+(q*60|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+128|0;if((c[p>>2]|0)>0){q=b+16|0;r=0;do{Sja(I,(c[q>>2]|0)+(r*48|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+144|0;if((c[p>>2]|0)>0){r=b+32|0;q=0;do{Sja(I,(c[r>>2]|0)+(q*48|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+132|0;if((c[p>>2]|0)>0){q=b+20|0;r=0;do{Sja(I,(c[q>>2]|0)+(r*52|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+148|0;if((c[p>>2]|0)>0){r=b+36|0;q=0;do{Sja(I,(c[r>>2]|0)+(q*52|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}qc(124168,13,1,I|0)|0;qc(124184,12,1,I|0)|0;Tja(I,J,f,c[C>>2]|0,b);qc(124200,13,1,I|0)|0;qc(124216,12,1,I|0)|0;Uja(I,c[b+68>>2]|0,b+56|0);qc(124232,13,1,I|0)|0;qc(124248,16,1,I|0)|0;Vja(I,J,f,b);qc(124272,17,1,I|0)|0;qc(124296,14,1,I|0)|0;Wc(I|0)|0;if(!K){O=0;i=j;return O|0}K=c[b+508>>2]|0;b=((lxa(e|0)|0)<<1)+230|0;e=(K|0)!=0;if(e){Q=(lxa(K|0)|0)<<1}else{Q=0}I=Jwa(b+Q|0)|0;if((I|0)==0){bb(124312,124320,404,124344)}if(($a(J|0)|0)!=0){X1(26,0,124360,o)}if(e){e=c[C>>2]|0;c[n>>2]=124392;c[n+4>>2]=e;c[n+8>>2]=K;c[n+12>>2]=e;hc(I|0,124408,n|0)|0;if((ld(I|0)|0)!=0){R=42}}else{n=I+0|0;e=124488|0;K=n+25|0;do{a[n]=a[e]|0;n=n+1|0;e=e+1|0}while((n|0)<(K|0));R=42}if((R|0)==42){c[m>>2]=I;X1(1,0,124520,m)}m=c[C>>2]|0;c[g>>2]=m;c[g+4>>2]=m;V1(1,0,124584,g);Kwa(I);O=0;i=j;return O|0}function Nja(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0;m=i;i=i+24|0;n=m;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+24|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+24|0;C=i;i=i+8|0;D=i;i=i+16|0;if((a|0)==0){i=m;return}E=(g|0)>-1;if(E){F=g+9|0;G=y3(F)|0;H=z3(F)|0;if((G|0)==0){I=-.01}else{I=+(G>>>0)*.95}if((H|0)==0){J=.01}else{J=+(H>>>0)*1.05}K=H;L=G;M=+E3(F)*1.01+1.0e-30;N=J;O=I}else{K=0;L=0;M=0.0;N=0.0;O=0.0}qc(122840,17,1,a|0)|0;qc(125752,12,1,a|0)|0;qc(125768,12,1,a|0)|0;qc(125784,13,1,a|0)|0;c[D>>2]=e;c[D+4>>2]=l;c[D+8>>2]=j;pd(a|0,125800,D|0)|0;qc(125840,10,1,a|0)|0;qc(125856,11,1,a|0)|0;qc(125872,11,1,a|0)|0;qc(125888,10,1,a|0)|0;if(E){D=C;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];pd(a|0,125904,C|0)|0}else{qc(125928,17,1,a|0)|0}C=g+3|0;c[B>>2]=e;c[B+4>>2]=f;c[B+8>>2]=f;c[B+12>>2]=C;c[B+16>>2]=C;c[B+20>>2]=4;pd(a|0,125528,B|0)|0;qc(125952,13,1,a|0)|0;if(E){qc(125768,12,1,a|0)|0;if((L|0)==(K|0)){B=A;h[k>>3]=O;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=N;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];pd(a|0,125968,A|0)|0}else{qc(125928,17,1,a|0)|0}c[z>>2]=e;c[z+4>>2]=l;c[z+8>>2]=j;pd(a|0,125992,z|0)|0;c[y>>2]=e;c[y+4>>2]=f;c[y+8>>2]=f;c[y+12>>2]=g+1;c[y+16>>2]=4;pd(a|0,125648,y|0)|0;qc(126040,10,1,a|0)|0;qc(126056,10,1,a|0)|0;qc(126040,10,1,a|0)|0;qc(126072,11,1,a|0)|0;c[x>>2]=b;pd(a|0,126088,x|0)|0;c[w>>2]=d;pd(a|0,126112,w|0)|0;qc(126128,33,1,a|0)|0;qc(126168,32,1,a|0)|0;c[v>>2]=e;c[v+4>>2]=l;c[v+8>>2]=j;c[v+12>>2]=b;pd(a|0,126208,v|0)|0;qc(125888,10,1,a|0)|0;v=u;h[k>>3]=M;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];pd(a|0,125904,u|0)|0}else{qc(126056,10,1,a|0)|0;qc(126040,10,1,a|0)|0;qc(126072,11,1,a|0)|0;c[t>>2]=b;pd(a|0,126088,t|0)|0;c[s>>2]=d;pd(a|0,126112,s|0)|0;qc(126128,33,1,a|0)|0;qc(126168,32,1,a|0)|0;c[r>>2]=e;c[r+4>>2]=l;c[r+8>>2]=j;c[r+12>>2]=b;pd(a|0,126208,r|0)|0;qc(125888,10,1,a|0)|0;qc(125928,17,1,a|0)|0}c[q>>2]=e;c[q+4>>2]=f;c[q+8>>2]=f;c[q+12>>2]=C;c[q+16>>2]=C;c[q+20>>2]=2;pd(a|0,125528,q|0)|0;qc(125952,13,1,a|0)|0;if(!E){i=m;return}if((L|0)==(K|0)){K=p;h[k>>3]=O;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=p+8|0;h[k>>3]=N;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];pd(a|0,125968,p|0)|0}else{qc(125928,17,1,a|0)|0}qc(126240,32,1,a|0)|0;qc(126280,29,1,a|0)|0;c[o>>2]=e;c[o+4>>2]=l;c[o+8>>2]=j;c[o+12>>2]=b;pd(a|0,126312,o|0)|0;c[n>>2]=e;c[n+4>>2]=f;c[n+8>>2]=f;c[n+12>>2]=g+1;c[n+16>>2]=2;pd(a|0,125648,n|0)|0;i=m;return}function Oja(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)==0){i=c;return}else{d=b}do{d=d+ -1|0;Kd(32,a|0)|0;}while((d|0)!=0);i=c;return}function Pja(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;e=a[c]|0;if(e<<24>>24==0){i=d;return}else{f=c;g=e}do{e=g<<24>>24;if((e|0)==34){qc(125520,6,1,b|0)|0}else if((e|0)==60){qc(125496,4,1,b|0)|0}else if((e|0)==39){qc(125512,6,1,b|0)|0}else if((e|0)==62){qc(125504,4,1,b|0)|0}else{Kd(e|0,b|0)|0}f=f+1|0;g=a[f]|0;}while(!(g<<24>>24==0));i=d;return}function Qja(a){a=a|0;var b=0,c=0,d=0;b=i;c=ic(a|0,125488)|0;if((c|0)==0){d=-1;i=b;return d|0}Uc(c|0,0,2)|0;a=xb(c|0)|0;Wc(c|0)|0;d=a;i=b;return d|0}function Rja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;h=i;i=i+24|0;j=i;i=i+32|0;k=i;i=i+24|0;l=c[b+88>>2]|0;m=Jwa((lxa(l|0)|0)+15|0)|0;c[f>>2]=l;hc(m|0,125216,f|0)|0;Oja(a,2);qc(125232,10,1,a|0)|0;Pja(a,m);qc(125248,12,1,a|0)|0;Oja(a,2);c[e>>2]=Qja(m)|0;pd(a|0,125264,e|0)|0;Kwa(m);Oja(a,2);qc(125296,9,1,a|0)|0;Oja(a,4);qc(125312,22,1,a|0)|0;Oja(a,4);qc(125336,22,1,a|0)|0;Oja(a,4);qc(125360,26,1,a|0)|0;m=b+56|0;e=b+64|0;f=c[e>>2]|0;if((f|0)>0){l=g+4|0;n=0;while(1){Xja(g,m,n);o=c[l>>2]|0;Oja(a,4);qc(125392,8,1,a|0)|0;Pja(a,o);qc(125408,18,1,a|0)|0;o=n+1|0;p=c[e>>2]|0;if((o|0)<(p|0)){n=o}else{q=p;break}}}else{q=f}f=b+72|0;b=c[f>>2]|0;if((b|0)>0){n=h+8|0;l=0;do{aka(h,m,l);g=c[n>>2]|0;Oja(a,4);qc(125392,8,1,a|0)|0;Pja(a,g);qc(125408,18,1,a|0)|0;l=l+1|0;r=c[f>>2]|0;}while((l|0)<(r|0));s=r;t=c[e>>2]|0}else{s=b;t=q}if((t|0)>0){t=j+4|0;q=0;do{Xja(j,m,q);b=c[t>>2]|0;Oja(a,4);qc(125432,8,1,a|0)|0;Pja(a,b);qc(125448,21,1,a|0)|0;q=q+1|0;}while((q|0)<(c[e>>2]|0));u=c[f>>2]|0}else{u=s}if((u|0)<=0){Oja(a,2);v=125472;w=v;x=qc(w|0,10,1,a|0)|0;i=d;return}u=k+8|0;s=0;do{aka(k,m,s);e=c[u>>2]|0;Oja(a,4);qc(125432,8,1,a|0)|0;Pja(a,e);qc(125448,21,1,a|0)|0;s=s+1|0;}while((s|0)<(c[f>>2]|0));Oja(a,2);v=125472;w=v;x=qc(w|0,10,1,a|0)|0;i=d;return}function Sja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+24|0;Oja(a,2);c[f>>2]=c[b>>2];pd(a|0,125152,f|0)|0;Pja(a,c[b+4>>2]|0);qc(125184,11,1,a|0)|0;Pja(a,c[b+8>>2]|0);qc(124856,3,1,a|0)|0;f=e;g=b+12|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];Wja(a,4,e);Oja(a,2);qc(125200,12,1,a|0)|0;i=d;return}function Tja(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+32|0;q=f+64|0;if((c[q>>2]|0)<=0){i=g;return}r=f+56|0;s=p+4|0;t=f+72|0;f=p;u=p+8|0;v=0;do{Xja(p,r,v);Nja(b,d,c[s>>2]|0,e,(c[t>>2]|0)+(c[q>>2]|0)|0,v,c[f>>2]|0,124968);w=v+9|0;I3(w);Oja(a,2);c[o>>2]=c[f>>2];pd(a|0,124976,o|0)|0;Oja(a,4);qc(123400,6,1,a|0)|0;Pja(a,c[s>>2]|0);qc(123408,8,1,a|0)|0;Oja(a,4);c[n>>2]=A3(w)|0;pd(a|0,124752,n|0)|0;Oja(a,4);x=+F3(w);y=m;h[k>>3]=x;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];pd(a|0,124776,m|0)|0;Oja(a,4);x=+E3(w);w=l;h[k>>3]=x;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];pd(a|0,123944,l|0)|0;w=j;y=u;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];Wja(a,6,j);Oja(a,2);qc(125e3,12,1,a|0)|0;v=v+1|0;}while((v|0)<(c[q>>2]|0));i=g;return}function Uja(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;if((b|0)<=0){i=e;return}q=l;r=m+8|0;s=n+12|0;t=d+8|0;u=d+16|0;v=o;w=p;x=0;do{Oja(a,2);$ja(l,d,x);c[j>>2]=c[q>>2];pd(a|0,124824,j|0)|0;$ja(m,d,x);Pja(a,c[r>>2]|0);qc(124856,3,1,a|0)|0;Oja(a,4);qc(124864,7,1,a|0)|0;$ja(n,d,x);if((c[s>>2]|0)>0){y=0;do{Oja(a,6);c[g>>2]=0;pd(a|0,124872,g|0)|0;y=y+1|0;$ja(n,d,x);}while((y|0)<(c[s>>2]|0))}Oja(a,4);qc(124896,8,1,a|0)|0;Oja(a,4);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;$ja(o,d,x);z=+C3(y+(c[v>>2]|0)|0);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;$ja(p,d,x);A=x3(y+(c[w>>2]|0)|0)|0;y=f;h[k>>3]=z;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[f+8>>2]=A;pd(a|0,124912,f|0)|0;Oja(a,2);qc(124952,12,1,a|0)|0;x=x+1|0;}while((x|0)<(b|0));i=e;return}function Vja(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=e+56|0;p=e+64|0;q=c[p>>2]|0;r=e+72|0;if((c[r>>2]|0)<=0){i=f;return}s=n+8|0;t=e+88|0;e=n;u=q;v=q;do{aka(n,o,v-u|0);Nja(b,d,c[s>>2]|0,c[t>>2]|0,(c[r>>2]|0)+(c[p>>2]|0)|0,v,c[e>>2]|0,124704);q=v+9|0;I3(q);Oja(a,2);qc(124712,15,1,a|0)|0;Oja(a,4);c[m>>2]=c[e>>2];pd(a|0,124728,m|0)|0;Oja(a,4);c[l>>2]=A3(q)|0;pd(a|0,124752,l|0)|0;Oja(a,4);w=+F3(q);x=j;h[k>>3]=w;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];pd(a|0,124776,j|0)|0;Oja(a,4);w=+E3(q);q=g;h[k>>3]=w;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];pd(a|0,123944,g|0)|0;Oja(a,2);qc(124800,16,1,a|0)|0;v=v+1|0;u=c[p>>2]|0;}while((v|0)<((c[r>>2]|0)+u|0));i=f;return}function Wja(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;Oja(a,b);qc(125016,16,1,a|0)|0;Pja(a,c[d>>2]|0);b=c[d+8>>2]|0;g=c[d+12>>2]|0;h=c[d+16>>2]|0;j=(c[d+20>>2]|0)!=0?125120:125136;c[f>>2]=c[d+4>>2];c[f+4>>2]=b;c[f+8>>2]=g;c[f+12>>2]=h;c[f+16>>2]=j;pd(a|0,125040,f|0)|0;i=e;return}function Xja(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+24>>2]|0)==0){Yja(b)}f=a;a=(c[b+20>>2]|0)+(d<<5)|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];i=e;return}function Yja(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+1024|0;c[h>>2]=a;k=h+4|0;c[k>>2]=1;l=h+8|0;c[l>>2]=0;m=h+12|0;c[m>>2]=0;n=a+4|0;do{if((c[n>>2]|0)==0){o=a;p=ic(c[o>>2]|0,126352)|0;if((p|0)!=0){q=p;break}p=Od(c[(Mc()|0)>>2]|0)|0;c[g>>2]=c[o>>2];c[g+4>>2]=p;Z1(0,126360,g)}else{q=0}}while(0);g=MY(0)|0;if((g|0)==0){Z1(0,126392,f)}f=a+8|0;c[a+20>>2]=Lwa(c[f>>2]|0,32)|0;p=a+12|0;o=Lwa((c[p>>2]|0)+1|0,20)|0;c[a+24>>2]=o;c[o>>2]=0;c[o+4>>2]=-1;c[o+8>>2]=126424;c[o+12>>2]=0;c[o+16>>2]=0;XY(g,h);YY(g,10,75);h=c[n>>2]|0;do{if((h|0)==0){o=j;pxa(o|0,0,1024)|0;while(1){r=rb(o|0,1,1024,q|0)|0;s=r>>>0<1024;if((ZY(g,o,r,s&1)|0)==0){t=9;break}if(s){t=11;break}}if((t|0)==9){o=fZ(cZ(g)|0)|0;s=dZ(g)|0;Wc(q|0)|0;TY(g);r=c[a>>2]|0;c[e>>2]=126528;c[e+4>>2]=r;c[e+8>>2]=o;c[e+12>>2]=s;Z1(0,126464,e)}else if((t|0)==11){Wc(q|0)|0;break}}else{if((ZY(g,h,lxa(h|0)|0,1)|0)!=0){break}s=fZ(cZ(g)|0)|0;o=dZ(g)|0;TY(g);r=c[n>>2]|0;c[d>>2]=126528;c[d+4>>2]=r;c[d+8>>2]=s;c[d+12>>2]=o;Z1(0,126568,d)}}while(0);if((c[p>>2]|0)!=(c[k>>2]|0)){bb(126632,126528,295,126672)}c[a+16>>2]=c[l>>2];if((c[f>>2]|0)==(c[m>>2]|0)){i=b;return}else{bb(126696,126528,297,126672)}}function Zja(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=c[a>>2]|0;n=c[a+4>>2]|0;o=c[a+12>>2]|0;if((hxa(127104,b)|0)==0){if((hxa(c[d>>2]|0,127112)|0)==0){p=(c[d+8>>2]|0)==0|0}else{p=0}Y1(0,p,127120,l);l=c[31740]|0;p=c[31794]|0;do{if((l|0)==0|(p|0)==0){c[31794]=32;a=Jwa(1152)|0;c[31740]=a;q=m+24|0;r=a}else{a=m+24|0;s=a;if(((c[(c[a>>2]|0)+(n*20|0)+12>>2]|0)+2|0)<(p|0)){q=s;r=l;break}c[31794]=p<<1;a=Mwa(l,p*72|0)|0;c[31740]=a;q=s;r=a}}while(0);p=(c[q>>2]|0)+(n*20|0)+12|0;q=c[p>>2]|0;c[p>>2]=q+1;p=r+(q*36|0)+0|0;q=(dka(c[d+4>>2]|0)|0)+0|0;r=p+36|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=e;return}if((hxa(127184,b)|0)==0){q=c[d>>2]|0;if((q|0)==0){i=e;return}else{t=d;u=q}a:while(1){do{if((hxa(127192,u)|0)==0){c[31800]=sd(c[t+4>>2]|0)|0}else{if((hxa(127224,u)|0)==0){c[127204>>2]=Ub(c[t+4>>2]|0,0,10)|0;break}if((hxa(127240,u)|0)==0){c[127212>>2]=Ub(c[t+4>>2]|0,0,10)|0;break}if((hxa(127248,u)|0)==0){c[127208>>2]=Ub(c[t+4>>2]|0,0,10)|0;break}if((hxa(127264,u)|0)==0){c[127216>>2]=Ub(c[t+4>>2]|0,0,10)|0;break}if((hxa(127272,u)|0)!=0){v=23;break a}c[127220>>2]=(hxa(c[t+4>>2]|0,127288)|0)==0}}while(0);q=t+8|0;p=c[q>>2]|0;if((p|0)==0){v=45;break}else{t=q;u=p}}if((v|0)==23){c[k>>2]=c[m>>2];Z1(0,127296,k)}else if((v|0)==45){i=e;return}}if((hxa(126944,b)|0)==0){v=c[m+12>>2]|0;if((n|0)>(v|0)){k=c[m>>2]|0;c[j>>2]=126528;c[j+4>>2]=k;c[j+8>>2]=v;Z1(0,127328,j)}if((hxa(127392,c[d>>2]|0)|0)!=0){j=c[m>>2]|0;c[h>>2]=126528;c[h+4>>2]=j;Z1(0,127400,h)}h=Ub(c[d+4>>2]|0,0,10)|0;if((n|0)!=(h|0)){j=c[m>>2]|0;c[g>>2]=126528;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=n;Z1(0,127456,g)}g=m+24|0;h=c[g>>2]|0;c[h+(n*20|0)>>2]=n;c[h+(n*20|0)+4>>2]=-1;c[h+(n*20|0)+8>>2]=127520;h=c[g>>2]|0;c[h+(n*20|0)+12>>2]=0;c[h+(n*20|0)+16>>2]=0;i=e;return}if((hxa(126888,b)|0)!=0){if((hxa(127080,b)|0)!=0){i=e;return}b=m+20|0;m=c[b>>2]|0;c[m+(o<<5)>>2]=o;c[m+(o<<5)+4>>2]=127624;m=sd(c[d+4>>2]|0)|0;c[(c[b>>2]|0)+(o<<5)+4>>2]=m;c[(c[b>>2]|0)+(o<<5)+8>>2]=127632;i=e;return}c[126908>>2]=0;c[126912>>2]=0;o=c[d>>2]|0;do{if((o|0)==0){w=0}else{b=d;m=o;do{do{if((hxa(m,127112)|0)==0){c[126908>>2]=sd(c[b+4>>2]|0)|0}else{if((hxa(m,127576)|0)!=0){break}c[126912>>2]=sd(c[b+4>>2]|0)|0}}while(0);b=b+8|0;m=c[b>>2]|0;}while((m|0)!=0);if((c[126908>>2]|0)==0){w=0;break}w=(c[126912>>2]|0)!=0|0}}while(0);Y1(0,w,127584,f);c[31726]=-1;f=126916|0;w=127200;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[f+20>>2]=c[w+20>>2];i=e;return}function _ja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d;f=d+40|0;g=i;i=i+8|0;h=c[a>>2]|0;j=a+4|0;k=c[j>>2]|0;l=a+8|0;m=c[l>>2]|0;n=a+12|0;a=c[n>>2]|0;if((hxa(126888,b)|0)==0){o=e+0|0;p=126904|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));cka(e);i=d;return}if((hxa(126944,b)|0)==0){e=h+24|0;r=Jwa((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)*36|0)|0;c[(c[e>>2]|0)+(k*20|0)+16>>2]=r;if((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)>0){r=0;do{s=Jwa(36)|0;t=s;o=s+0|0;p=(c[31740]|0)+(r*36|0)+0|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));c[(c[(c[e>>2]|0)+(k*20|0)+16>>2]|0)+(r<<2)>>2]=t;r=r+1|0;}while((r|0)<(c[(c[e>>2]|0)+(k*20|0)+12>>2]|0))}c[j>>2]=k+1;i=d;return}if((hxa(126968,b)|0)==0){j=h+24|0;e=c[j>>2]|0;r=c[e+(k*20|0)+12>>2]|0;c[g>>2]=k;c[g+4>>2]=r;td(e+(k*20|0)+8|0,126976,g|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((hxa(127016,b)|0)==0){j=h+24|0;h=c[j>>2]|0;g=c[h+(k*20|0)+12>>2]|0;c[f>>2]=k;c[f+4>>2]=g;td(h+(k*20|0)+8|0,127032,f|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((hxa(127080,b)|0)!=0){i=d;return}c[n>>2]=a+1;i=d;return}function $ja(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==0){Yja(b);h=c[f>>2]|0}else{h=g}g=a;a=h+(d*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}function aka(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=b+24|0;if((c[h>>2]|0)==0){Yja(b)}j=c[b+16>>2]|0;if(j>>>0<d>>>0){c[g>>2]=d;c[g+4>>2]=j;Z1(0,126736,g)}g=c[b+12>>2]|0;if((g|0)<=0){k=f;l=k;c[l>>2]=d;m=6;n=m;o=126816;p=o;Z1(0,p,f)}b=c[h>>2]|0;h=0;while(1){j=h+1|0;if((c[b+(h*20|0)+4>>2]|0)==(d|0)){q=9;break}if((j|0)<(g|0)){h=j}else{q=10;break}}if((q|0)==9){g=a;a=b+(h*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}else if((q|0)==10){k=f;l=k;c[l>>2]=d;m=6;n=m;o=126816;p=o;Z1(0,p,f)}}function bka(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){Kwa(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=a+12|0;if((c[f>>2]|0)>0){a=e;g=0;while(1){Kwa(c[a+(g*20|0)+16>>2]|0);c[(c[d>>2]|0)+(g*20|0)+16>>2]=0;h=g+1|0;j=c[d>>2]|0;if((h|0)<(c[f>>2]|0)){g=h;a=j}else{k=j;break}}}else{k=e}Kwa(k);c[d>>2]=0;i=b;return}function cka(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;b=i;e=Jwa(72)|0;f=c[a+4>>2]|0;c[e>>2]=f;g=e+4|0;h=a+0|0;a=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(a|0));h=e+40|0;j=h;c[e+48>>2]=0;c[e+60>>2]=f;k=lxa(f|0)|0;c[e+64>>2]=k;k=c[31774]|0;do{if((k|0)==0){c[31774]=e;c[e+44>>2]=0;l=Jwa(44)|0;m=l;c[e+40>>2]=m;if((l|0)==0){uc(-1)}g=l+0|0;a=g+44|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(a|0));c[l+16>>2]=e+40;c[l+4>>2]=32;c[l+8>>2]=5;c[l+20>>2]=40;n=Jwa(384)|0;c[l>>2]=n;if((n|0)==0){uc(-1)}else{pxa(n|0,0,384)|0;c[l+40>>2]=-1609490463;o=f;p=m;break}}else{c[(c[(c[k+40>>2]|0)+16>>2]|0)+8>>2]=e;n=(c[31774]|0)+40|0;q=c[n>>2]|0;c[e+44>>2]=(c[q+16>>2]|0)+(0-(c[q+20>>2]|0));c[(c[n>>2]|0)+16>>2]=j;o=c[e>>2]|0;p=c[(c[31774]|0)+40>>2]|0}}while(0);k=p+12|0;c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=p;p=e+68|0;c[p>>2]=-17973521;k=lxa(o|0)|0;if(k>>>0>11){f=-17973521;g=-1640531527;a=-1640531527;n=k;q=o;do{r=((d[q+5|0]|0)<<8|(d[q+4|0]|0)|(d[q+6|0]|0)<<16|(d[q+7|0]|0)<<24)+a|0;s=((d[q+9|0]|0)<<8|(d[q+8|0]|0)|(d[q+10|0]|0)<<16|(d[q+11|0]|0)<<24)+f|0;t=((d[q+1|0]|0)<<8|(d[q]|0)|(d[q+2|0]|0)<<16|(d[q+3|0]|0)<<24)+g-r-s^s>>>13;u=r-s-t^t<<8;r=s-t-u^u>>>13;s=t-u-r^r>>>12;t=u-r-s^s<<16;u=r-s-t^t>>>5;g=s-t-u^u>>>3;a=t-u-g^g<<10;f=u-g-a^a>>>15;c[p>>2]=f;q=q+12|0;n=n+ -12|0;}while(n>>>0>11);v=f;w=c[e>>2]|0;x=g;y=a;z=n;A=q}else{v=-17973521;w=o;x=-1640531527;y=-1640531527;z=k;A=o}o=v+(lxa(w|0)|0)|0;c[p>>2]=o;switch(z|0){case 2:{B=o;C=x;D=y;E=21;break};case 7:{F=o;G=y;E=16;break};case 3:{H=o;I=x;J=y;E=20;break};case 10:{K=o;E=13;break};case 1:{L=o;M=x;N=y;E=22;break};case 4:{O=o;P=y;E=19;break};case 5:{Q=o;R=y;E=18;break};case 11:{z=((d[A+10|0]|0)<<24)+o|0;c[p>>2]=z;K=z;E=13;break};case 6:{S=o;T=y;E=17;break};case 8:{U=o;E=15;break};case 9:{V=o;E=14;break};default:{W=o;X=x;Y=y}}if((E|0)==13){o=((d[A+9|0]|0)<<16)+K|0;c[p>>2]=o;V=o;E=14}if((E|0)==14){o=((d[A+8|0]|0)<<8)+V|0;c[p>>2]=o;U=o;E=15}if((E|0)==15){F=U;G=((d[A+7|0]|0)<<24)+y|0;E=16}if((E|0)==16){S=F;T=((d[A+6|0]|0)<<16)+G|0;E=17}if((E|0)==17){Q=S;R=((d[A+5|0]|0)<<8)+T|0;E=18}if((E|0)==18){O=Q;P=(d[A+4|0]|0)+R|0;E=19}if((E|0)==19){H=O;I=((d[A+3|0]|0)<<24)+x|0;J=P;E=20}if((E|0)==20){B=H;C=((d[A+2|0]|0)<<16)+I|0;D=J;E=21}if((E|0)==21){L=B;M=((d[A+1|0]|0)<<8)+C|0;N=D;E=22}if((E|0)==22){W=L;X=(d[A]|0)+M|0;Y=N}N=X-Y-W^W>>>13;X=Y-W-N^N<<8;Y=W-N-X^X>>>13;W=N-X-Y^Y>>>12;N=X-Y-W^W<<16;X=Y-W-N^N>>>5;Y=W-N-X^X>>>3;W=N-X-Y^Y<<10;N=X-Y-W^W>>>15;c[p>>2]=N;p=(c[31774]|0)+40|0;W=c[p>>2]|0;Y=N&(c[W+4>>2]|0)+ -1;N=c[W>>2]|0;W=N+(Y*12|0)+4|0;c[W>>2]=(c[W>>2]|0)+1;c[e+56>>2]=c[N+(Y*12|0)>>2];c[e+52>>2]=0;e=c[c[p>>2]>>2]|0;p=c[e+(Y*12|0)>>2]|0;if((p|0)==0){Z=e}else{c[p+12>>2]=j;Z=c[c[(c[31774]|0)+40>>2]>>2]|0}c[Z+(Y*12|0)>>2]=j;j=c[c[(c[31774]|0)+40>>2]>>2]|0;if((c[j+(Y*12|0)+4>>2]|0)>>>0<(((c[j+(Y*12|0)+8>>2]|0)*10|0)+10|0)>>>0){i=b;return}Y=c[h>>2]|0;if((c[Y+36>>2]|0)==1){i=b;return}j=Y+4|0;Z=Jwa((c[j>>2]|0)*24|0)|0;p=Z;if((Z|0)==0){uc(-1)}pxa(Z|0,0,(c[j>>2]|0)*24|0)|0;e=c[Y+12>>2]|0;N=c[j>>2]|0;c[Y+24>>2]=(((N<<1)+ -1&e|0)!=0)+(e>>>((c[Y+8>>2]|0)+1|0));c[Y+28>>2]=0;e=c[Y>>2]|0;if((N|0)==0){_=e}else{N=Y;Y=e;e=0;while(1){j=c[Y+(e*12|0)>>2]|0;if((j|0)==0){$=N}else{W=N;X=j;while(1){j=X+16|0;M=c[j>>2]|0;A=(c[W+4>>2]<<1)+ -1&c[X+28>>2];L=Z+(A*12|0)+4|0;E=(c[L>>2]|0)+1|0;c[L>>2]=E;D=c[W+24>>2]|0;if(E>>>0>D>>>0){E=W+28|0;c[E>>2]=(c[E>>2]|0)+1;c[Z+(A*12|0)+8>>2]=((c[L>>2]|0)>>>0)/(D>>>0)|0}c[X+12>>2]=0;D=Z+(A*12|0)|0;c[j>>2]=c[D>>2];j=c[D>>2]|0;if((j|0)!=0){c[j+12>>2]=X}c[D>>2]=X;D=c[h>>2]|0;if((M|0)==0){$=D;break}else{W=D;X=M}}}X=e+1|0;W=c[$>>2]|0;if(X>>>0<(c[$+4>>2]|0)>>>0){N=$;Y=W;e=X}else{_=W;break}}}Kwa(_);_=c[h>>2]|0;e=_+4|0;c[e>>2]=c[e>>2]<<1;e=_+8|0;c[e>>2]=(c[e>>2]|0)+1;c[_>>2]=p;p=c[h>>2]|0;h=p+32|0;if(!((c[p+28>>2]|0)>>>0>(c[p+12>>2]|0)>>>1>>>0)){c[h>>2]=0;i=b;return}_=(c[h>>2]|0)+1|0;c[h>>2]=_;if(!(_>>>0>1)){i=b;return}c[p+36>>2]=1;i=b;return}function dka(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+8|0;e=b;a:do{if((c[31774]|0)==0){f=24}else{g=lxa(a|0)|0;if(g>>>0>11){h=-17973521;j=-1640531527;k=-1640531527;l=g;m=a;while(1){n=((d[m+5|0]|0)<<8|(d[m+4|0]|0)|(d[m+6|0]|0)<<16|(d[m+7|0]|0)<<24)+k|0;o=((d[m+9|0]|0)<<8|(d[m+8|0]|0)|(d[m+10|0]|0)<<16|(d[m+11|0]|0)<<24)+h|0;p=((d[m+1|0]|0)<<8|(d[m]|0)|(d[m+2|0]|0)<<16|(d[m+3|0]|0)<<24)+j-n-o^o>>>13;q=n-o-p^p<<8;n=o-p-q^q>>>13;o=p-q-n^n>>>12;p=q-n-o^o<<16;q=n-o-p^p>>>5;n=o-p-q^q>>>3;o=p-q-n^n<<10;p=q-n-o^o>>>15;q=m+12|0;r=l+ -12|0;if(r>>>0>11){m=q;l=r;k=o;j=n;h=p}else{s=p;t=n;u=o;v=r;w=q;break}}}else{s=-17973521;t=-1640531527;u=-1640531527;v=g;w=a}h=(lxa(a|0)|0)+s|0;switch(v|0){case 7:{x=h;y=u;f=9;break};case 5:{z=h;A=u;f=11;break};case 1:{B=h;C=t;D=u;f=15;break};case 6:{E=h;F=u;f=10;break};case 9:{G=h;f=7;break};case 4:{H=h;I=u;f=12;break};case 11:{J=((d[w+10|0]|0)<<24)+h|0;f=6;break};case 3:{K=h;L=t;M=u;f=13;break};case 10:{J=h;f=6;break};case 8:{N=h;f=8;break};case 2:{O=h;P=t;Q=u;f=14;break};default:{R=h;S=t;T=u}}if((f|0)==6){G=((d[w+9|0]|0)<<16)+J|0;f=7}if((f|0)==7){N=((d[w+8|0]|0)<<8)+G|0;f=8}if((f|0)==8){x=N;y=((d[w+7|0]|0)<<24)+u|0;f=9}if((f|0)==9){E=x;F=((d[w+6|0]|0)<<16)+y|0;f=10}if((f|0)==10){z=E;A=((d[w+5|0]|0)<<8)+F|0;f=11}if((f|0)==11){H=z;I=(d[w+4|0]|0)+A|0;f=12}if((f|0)==12){K=H;L=((d[w+3|0]|0)<<24)+t|0;M=I;f=13}if((f|0)==13){O=K;P=((d[w+2|0]|0)<<16)+L|0;Q=M;f=14}if((f|0)==14){B=O;C=((d[w+1|0]|0)<<8)+P|0;D=Q;f=15}if((f|0)==15){R=B;S=(d[w]|0)+C|0;T=D}h=S-R-T^R>>>13;j=T-R-h^h<<8;k=R-h-j^j>>>13;l=h-j-k^k>>>12;h=j-k-l^l<<16;j=k-l-h^h>>>5;k=l-h-j^j>>>3;l=h-j-k^k<<10;h=c[(c[31774]|0)+40>>2]|0;m=c[(c[h>>2]|0)+(((j-k-l^l>>>15)&(c[h+4>>2]|0)+ -1)*12|0)>>2]|0;if((m|0)==0){f=24;break}l=m+(0-(c[h+20>>2]|0))|0;if((l|0)==0){f=24;break}m=lxa(a|0)|0;k=l;while(1){U=k;if((c[k+64>>2]|0)==(m|0)){if((gxa(c[k+60>>2]|0,a,m)|0)==0){break}}l=c[k+56>>2]|0;if((l|0)==0){f=24;break a}j=l+(0-(c[h+20>>2]|0))|0;if((j|0)==0){f=24;break a}else{k=j}}if((k|0)==0){f=24}else{V=U}}}while(0);do{if((f|0)==24){if((Db(a|0,127656)|0)==0){V=0;break}else{W=127680}i=b;return W|0}}while(0);c[e>>2]=a;Y1(0,(V|0)!=0|0,127728,e);W=V+4|0;i=b;return W|0}function eka(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((fka(127784,a,b)|0)!=0){d=1;i=c;return d|0}d=(fka(127792,a,b)|0)!=0|0;i=c;return d|0}function fka(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)>0){g=0}else{h=0;i=f;return h|0}while(1){j=c[e+(g<<2)>>2]|0;if((a[j]|0)==45){if((hxa(b,j+1|0)|0)==0){h=1;k=5;break}}j=g+1|0;if((j|0)<(d|0)){g=j}else{h=0;k=5;break}}if((k|0)==5){i=f;return h|0}return 0}function gka(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=(hxa(c[76428>>2]|0,127800)|0)==0|0;Y1(0,m,127816,l);l=(hxa(c[78332>>2]|0,127800)|0)==0|0;Y1(0,l,127872,k);k=(hxa(c[80324>>2]|0,127800)|0)==0|0;Y1(0,k,127928,j);j=127992|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=128120|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((a|0)>1){n=1}else{o=0;i=d;return o|0}a:while(1){p=b+(n<<2)|0;j=n+1|0;k=1;while(1){l=c[80328+(k<<2)>>2]|0;if((l|0)==1){if((fka(c[76304+(k<<2)>>2]|0,1,p)|0)!=0){q=5;break}}else if((l|0)==2){r=c[76304+(k<<2)>>2]|0;if(!((fka(r,1,p)|0)==0|(j|0)>=(a|0))){q=9;break}s=c[76304+(k<<2)>>2]|0;if((ika(s,p)|0)!=0){q=13;break}}l=k+1|0;if((l|0)<31){k=l}else{q=17;break a}}if((q|0)==5){q=0;l=127992+(k<<2)|0;if((c[l>>2]|0)!=0){q=6;break}c[l>>2]=1;t=n}else if((q|0)==9){q=0;l=127992+(k<<2)|0;if((c[l>>2]|0)!=0){q=10;break}c[l>>2]=1;c[128120+(k<<2)>>2]=hka(r,p)|0;t=j}else if((q|0)==13){q=0;l=127992+(k<<2)|0;if((c[l>>2]|0)!=0){q=14;break}c[l>>2]=1;c[128120+(k<<2)>>2]=jka(s,p)|0;t=n}l=t+1|0;if((l|0)<(a|0)){n=l}else{o=0;q=19;break}}if((q|0)==6){c[h>>2]=c[p>>2];X1(1,0,128248,h);o=1;i=d;return o|0}else if((q|0)==10){c[g>>2]=c[p>>2];X1(1,0,128248,g);o=1;i=d;return o|0}else if((q|0)==14){c[f>>2]=c[p>>2];X1(1,0,128248,f);o=1;i=d;return o|0}else if((q|0)==17){c[e>>2]=c[p>>2];X1(1,0,128304,e);o=1;i=d;return o|0}else if((q|0)==19){i=d;return o|0}return 0}function hka(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;do{if((a[f]|0)==45){if((hxa(b,f+1|0)|0)!=0){g=0;break}g=c[d+4>>2]|0}else{g=0}}while(0);i=e;return g|0}function ika(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(jka(a,b)|0)!=0|0;i=c;return d|0}function jka(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=lxa(b|0)|0;g=c[d>>2]|0;if((a[g]|0)!=45){h=0;i=e;return h|0}if((ixa(b,g+1|0,f)|0)!=0){h=0;i=e;return h|0}if((a[g+(f+1)|0]|0)!=61){h=0;i=e;return h|0}h=g+(f+2)|0;i=e;return h|0}function kka(){i=i;return}function lka(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)<=0){uc(0)}e=c[r>>2]|0;qc(128336,5,1,e|0)|0;f=b;b=0;while(1){Kd(a[f]|0,e|0)|0;g=b+1|0;if((g|0)<(d|0)){b=g;f=f+1|0}else{break}}qc(128344,20,1,e|0)|0;uc(0);return 0}function mka(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;e=d;d=c[r>>2]|0;c[e>>2]=a;pd(d|0,128368,e|0)|0;if((b|0)==0){uc(1)}else{nd(d|0)|0;uka();nd(d|0)|0;hb(6,0)|0;dd()}}function nka(a,b){a=a|0;b=b|0;var c=0.0;c=+W(+(+h[a>>3]),+(+h[b>>3]));i=i;return+c}function oka(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0.0,g=0.0,j=0,k=0.0,l=0.0;d=i;e=+h[a>>3];a=c[b>>2]|0;if((a|0)==0){f=1.0;i=d;return+f}if((a|0)<0){g=1.0;j=0-a|0;k=1.0/e}else{g=1.0;j=a;k=e}while(1){if((j&1|0)==0){l=g}else{l=g*k}a=j>>>1;if((a|0)==0){f=l;break}g=l;j=a;k=k*k}i=d;return+f}function pka(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0;c=i;d=+h[a>>3];if(!(d>=0.0)){e=-d}else{e=d}if(+h[b>>3]>=0.0){f=e;i=c;return+f}f=-e;i=c;return+f}function qka(a){a=a|0;var b=0.0,c=0.0,d=0.0;b=+g[a>>2];c=b;if(!(b>=0.0)){d=-+T(+(.5-c))}else{d=+T(+(c+.5))}i=i;return~~d|0}function rka(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=b+d|0;h=c+e|0;if((d|0)>(e|0)){a:do{if((e|0)>0){j=b;k=c;while(1){l=a[j]|0;m=a[k]|0;if(!(l<<24>>24==m<<24>>24)){break}n=j+1|0;o=k+1|0;if(o>>>0<h>>>0){j=n;k=o}else{p=n;break a}}q=(l&255)-(m&255)|0;i=f;return q|0}else{p=b}}while(0);if(p>>>0<g>>>0){r=p}else{q=0;i=f;return q|0}while(1){s=a[r]|0;p=r+1|0;if(!(s<<24>>24==32)){break}if(p>>>0<g>>>0){r=p}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=(s&255)+ -32|0;i=f;return q|0}else{b:do{if((d|0)>0){s=b;r=c;while(1){u=a[s]|0;v=a[r]|0;if(!(u<<24>>24==v<<24>>24)){break}p=s+1|0;m=r+1|0;if(p>>>0<g>>>0){s=p;r=m}else{w=m;break b}}q=(u&255)-(v&255)|0;i=f;return q|0}else{w=c}}while(0);if(w>>>0<h>>>0){x=w}else{q=0;i=f;return q|0}while(1){y=a[x]|0;w=x+1|0;if(!(y<<24>>24==32)){break}if(w>>>0<h>>>0){x=w}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=32-(y&255)|0;i=f;return q|0}return 0}function ska(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=c;h=b+d|0;if((d|0)<=(e|0)){do{if(b>>>0>c>>>0){j=c+d|0;if(!(j>>>0>b>>>0)){break}if((d|0)>0){k=j;l=h}else{i=f;return}do{k=k+ -1|0;l=l+ -1|0;a[l]=a[k]|0;}while(l>>>0>b>>>0);i=f;return}}while(0);if((d|0)>0){m=c;n=b}else{i=f;return}while(1){l=n+1|0;a[n]=a[m]|0;if(l>>>0<h>>>0){n=l;m=m+1|0}else{break}}i=f;return}m=c+e|0;do{if(b>>>0>c>>>0&m>>>0>b>>>0){n=b+e|0;if((e|0)>0){l=0-g-e|0;k=~g;j=~(c+(l>>>0>k>>>0?l:k));k=n;l=m;do{l=l+ -1|0;k=k+ -1|0;a[k]=a[l]|0;}while(l>>>0>c>>>0);o=b+j|0}else{o=n}p=o+e|0}else{if((e|0)<=0){p=b;break}l=c+1|0;k=(m>>>0>l>>>0?m:l)+(0-g)|0;l=b;q=c;while(1){r=q+1|0;a[l]=a[q]|0;if(r>>>0<m>>>0){q=r;l=l+1|0}else{break}}p=b+k|0}}while(0);if(!(p>>>0<h>>>0)){i=f;return}pxa(p|0,32,b+(d-p)|0)|0;i=f;return}function tka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+4>>2]|0;if((e|0)>99){i=d;return 0}f=129408+(e*48|0)|0;g=c[f>>2]|0;if((g|0)!=0){do{if((c[129452+(e*48|0)>>2]|0)==1){h=10}else{j=c[b+8>>2]|0;if((j|0)!=0){k=a[j]|0;if((k|0)==100|(k|0)==68){h=10;break}}if((c[129448+(e*48|0)>>2]|0)==1){vka(b)|0}k=129412+(e*48|0)|0;if((c[k>>2]|0)==0){break}Wc(c[f>>2]|0)|0;Kwa(c[k>>2]|0)}}while(0);do{if((h|0)==10){Wc(g|0)|0;b=129412+(e*48|0)|0;k=c[b>>2]|0;if((k|0)==0){break}Bd(k|0)|0;Kwa(c[b>>2]|0)}}while(0);c[f>>2]=0}c[129444+(e*48|0)>>2]=0;c[129412+(e*48|0)>>2]=0;i=d;return 0}function uka(){var a=0,b=0;a=i;if((c[32094]|0)!=0){i=a;return}c[32094]=1;c[128384>>2]=0;b=0;do{c[128380>>2]=b;tka(128376)|0;b=b+1|0;}while((b|0)<100);i=a;return}function vka(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+4>>2]|0;if((c[129424+(d*48|0)>>2]|0)!=0){e=0;i=b;return e|0}f=129408+(d*48|0)|0;g=c[f>>2]|0;h=xb(g|0)|0;Uc(g|0,0,2)|0;if((h|0)>=(xb(g|0)|0)){e=0;i=b;return e|0}if((c[129428+(d*48|0)>>2]|0)==0){e=0;i=b;return e|0}if((c[129436+(d*48|0)>>2]&2|0)!=0){nd(c[f>>2]|0)|0}d=Sc(qb(c[f>>2]|0)|0,h|0)|0;Uc(c[f>>2]|0,0,2)|0;if((d|0)==0){e=0;i=b;return e|0}if((c[a>>2]|0)==0){xka(111,128392);e=111;i=b;return e|0}else{c[(Mc()|0)>>2]=111;e=111;i=b;return e|0}return 0}function wka(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+80|0;d=b;do{if((_a(qb(a|0)|0,d|0)|0)<0){e=0}else{f=c[d+12>>2]&61440;if((f|0)==32768|(f|0)==16384){e=(c[d+16>>2]|0)!=0|0;break}else if((f|0)==24576){e=1;break}else if((f|0)==8192){e=(tb(qb(a|0)|0)|0)==0|0;break}else{e=0;break}}}while(0);i=b;return e|0}function xka(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;d=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;do{if(a>>>0<100){Pc(b|0);l=c[r>>2]|0}else{if((a+1|0)>>>0>132){m=c[r>>2]|0;c[k>>2]=b;c[k+4>>2]=a;pd(m|0,129304,k|0)|0;l=m;break}m=c[r>>2]|0;if((a|0)==-1){c[j>>2]=b;pd(m|0,129336,j|0)|0;l=m;break}else{n=c[129176+(a+ -100<<2)>>2]|0;c[h>>2]=b;c[h+4>>2]=n;pd(m|0,129360,h|0)|0;l=m;break}}}while(0);h=c[32342]|0;do{if((h|0)==0){qc(134240,29,1,l|0)|0}else{c[g>>2]=(h-129408|0)/48|0;pd(l|0,129376,g|0)|0;b=c[(c[32342]|0)+4>>2]|0;if((b|0)==0){qc(134224,10,1,l|0)|0;break}else{c[f>>2]=b;pd(l|0,134208,f|0)|0;break}}}while(0);f=c[33568]|0;if((f|0)!=0){c[d>>2]=f;pd(l|0,134280,d|0)|0}d=(c[33588]|0)!=0?134360:134376;f=(c[33596]|0)!=0?134392:134408;g=(c[33606]|0)!=0?134432:134448;c[e>>2]=(c[33582]|0)!=0?134336:134344;c[e+4>>2]=d;c[e+8>>2]=f;c[e+12>>2]=g;pd(l|0,134304,e|0)|0;mka(134464,1)}function yka(){var a=0,b=0;a=i;c[33618]=1;b=c[r>>2]|0;c[32352]=b;c[129428>>2]=wka(b)|0;c[129432>>2]=1;c[129448>>2]=1;b=c[s>>2]|0;c[129648>>2]=b;c[129668>>2]=wka(b)|0;c[129672>>2]=1;c[129688>>2]=0;b=c[t>>2]|0;c[129696>>2]=b;c[129716>>2]=wka(b)|0;c[129720>>2]=1;c[129736>>2]=1;i=a;return}function zka(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+28|0;e=c[d>>2]|0;a:do{if((e&2|0)==0){f=a+4|0;g=c[f>>2]|0;do{if((g|0)!=0){if((c[a+16>>2]|0)==0){h=c[a+24>>2]|0}else{h=0}if((c[a+40>>2]|0)==3){j=a;k=wc(g|0,c[139720+(h<<2)>>2]|0,c[j>>2]|0)|0;c[j>>2]=k;c[33620]=k;if((k|0)==0){break}c[d>>2]=2;break a}k=a;j=xb(c[k>>2]|0)|0;l=wc(c[f>>2]|0,c[139720+((h|2)<<2)>>2]|0,c[k>>2]|0)|0;c[k>>2]=l;c[33620]=l;if((l|0)==0){c[k>>2]=0;break}else{c[d>>2]=3;Uc(c[k>>2]|0,j|0,0)|0;break a}}}while(0);c[(Mc()|0)>>2]=127;m=1;i=b;return m|0}else{if((e&1|0)==0){break}Uc(c[a>>2]|0,0,1)|0}}while(0);c[a+40>>2]=1;m=0;i=b;return m|0}function Aka(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((a|0)==0){xka(b,d)}d=c[33622]|0;if((d|0)!=0){ue[d&7]()|0}c[(Mc()|0)>>2]=b;i=e;return b|0}function Bka(a){a=a|0;var b=0,d=0;b=i;c[33652]=0;c[33654]=0;c[33656]=0;d=((Cka(a,0)|0)==0)<<31>>31;i=b;return d|0}function Cka(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b;while(1){b=a[f]|0;g=f+1|0;if(b<<24>>24==32){f=g}else if(b<<24>>24==40){break}else{h=0;j=8;break}}if((j|0)==8){i=e;return h|0}j=c[33656]|0;c[33656]=j+1;if((j|0)==1){c[33654]=d}if((Hka(1,d,0,0)|0)<0){h=0;i=e;return h|0}d=Ika(g)|0;if((d|0)==0){h=0;i=e;return h|0}else{k=d}while(1){if((a[k]|0)==32){k=k+1|0}else{h=k;break}}i=e;return h|0}function Dka(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;e=i;i=i+8|0;f=e;if((c[a>>2]|0)>0){g=b;h=0}else{j=0;i=e;return j|0}a:while(1){b=(g|0)==0;b:while(1){k=c[33652]|0;l=134632+(k<<4)|0;m=c[l>>2]|0;switch(Eka(m)|0){case 3:{n=c[34868]|0;o=139480+(n<<2)|0;p=c[o>>2]|0;c[o>>2]=p+ -1;if((p|0)<2){c[34868]=n+ -1;c[34884]=(c[34884]|0)+ -1;c[33652]=k+1;continue b}else{n=c[34884]|0;c[34884]=n+ -1;c[33652]=(c[139544+(n<<2)>>2]|0)+1;continue b}break};case 9:{n=(ae[c[33636]&127](l)|0)==0;c[33652]=(c[33652]|0)+1;if(n){break b}else{continue b}break};case 22:{c[33630]=1;c[33652]=k+1;continue b;break};case 19:case 17:{c[33628]=0;c[33652]=k+1;continue b;break};case 18:{c[33628]=1;c[33652]=k+1;continue b;break};case 16:{if(b){q=28;break a}c[33652]=k+1;continue b;break};case 8:{n=c[34868]|0;s=139480+(n<<2)|0;t=c[s>>2]|0;if((t|0)>=1){q=10;break b}c[34868]=n+ -1;c[33652]=k+1;continue b;break};case 20:{c[33648]=c[134636+(k<<4)>>2];c[33652]=k+1;continue b;break};case 1:{n=c[134636+(k<<4)>>2]|0;p=(c[34884]|0)+1|0;c[34884]=p;c[139544+(p<<2)>>2]=n;c[33652]=k+1;continue b;break};case 33:{c[34896]=1;c[33652]=k+1;continue b;break};case 21:{c[33630]=0;c[33652]=k+1;continue b;break};case 6:{n=c[134636+(k<<4)>>2]|0;p=(c[34868]|0)+1|0;c[34868]=p;c[139480+(p<<2)>>2]=n;c[33652]=k+1;continue b;break};case 2:{c[34868]=0;c[34884]=0;c[33652]=c[134636+(k<<4)>>2];if(b){q=24;break a}if((c[34880]|0)==0){j=0;q=37;break a}k=ue[c[33638]&7]()|0;if((k|0)==0){continue b}else{j=k;q=37;break a}break};default:{q=4;break a}}}if((q|0)==10){q=0;if(b){q=11;break}c[s>>2]=t+ -1;c[34880]=1;k=de[c[33634]&63](l,g,d)|0;if((k|0)>0){q=13;break}if((k|0)<0){q=15;break}}k=h+1|0;if((k|0)<(c[a>>2]|0)){g=g+d|0;h=k}else{j=0;q=37;break}}if((q|0)==4){h=c[r>>2]|0;d=c[33568]|0;c[f>>2]=m;c[f+4>>2]=d;pd(h|0,139432,f|0)|0;if((c[c[33624]>>2]|0)==0){xka(100,139464);j=100;i=e;return j|0}else{c[(Mc()|0)>>2]=100;j=100;i=e;return j|0}}else if((q|0)==11){j=ue[c[33622]&7]()|0;i=e;return j|0}else if((q|0)==13){f=c[c[33624]>>2]|0;j=Aka(f,c[(Mc()|0)>>2]|0,139528)|0;i=e;return j|0}else if((q|0)==15){if((c[(c[33624]|0)+8>>2]|0)==0){xka(-1,139528);j=-1;i=e;return j|0}else{c[(Mc()|0)>>2]=-1;j=-1;i=e;return j|0}}else if((q|0)==24){j=ue[c[33622]&7]()|0;i=e;return j|0}else if((q|0)==28){j=ue[c[33622]&7]()|0;i=e;return j|0}else if((q|0)==37){i=e;return j|0}return 0}function Eka(a){a=a|0;var b=0;switch(a|0){case 26:case 25:case 24:case 29:case 34:case 32:case 31:case 30:case 10:case 7:case 23:case 27:case 28:case 35:case 36:{b=8;break};case 14:case 13:case 15:case 12:case 11:case 5:case 4:{b=9;break};default:{b=a}}i=i;return b|0}function Fka(){var a=0,b=0,d=0;a=i;i=i+8|0;b=a;c[b>>2]=1;d=Dka(b,0,0)|0;i=a;return d|0}function Gka(){c[33644]=0;c[33652]=0;c[34884]=0;c[34868]=0;c[34880]=0;c[34886]=0;c[34870]=0;i=i;return}function Hka(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[33652]|0;if((g|0)>299){qc(139608,24,1,c[r>>2]|0)|0;mka(c[33568]|0,1)}else{c[134632+(g<<4)>>2]=a;c[134636+(g<<4)>>2]=b;c[134640+(g<<4)>>2]=d;c[134644+(g<<4)>>2]=e;c[33652]=g+1;i=f;return g|0}return 0}function Ika(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a[b]|0;if(e<<24>>24==0){f=0;i=d;return f|0}else{g=b;h=e}a:while(1){e=g+1|0;if(h<<24>>24==32){h=a[e]|0;g=e;continue}e=Jka(g)|0;if((e|0)==0){f=0;j=12;break}else{k=e}while(1){e=a[k]|0;if(e<<24>>24==44){j=7;break}else if(e<<24>>24==41){j=9;break a}else if(!(e<<24>>24==32)){l=k;break}k=k+1|0}if((j|0)==7){j=0;l=k+1|0}e=a[l]|0;if(e<<24>>24==0){f=0;j=12;break}else{g=l;h=e}}if((j|0)==9){h=(c[33656]|0)+ -1|0;c[33656]=h;if((h|0)==0){Hka(2,c[33654]|0,0,0)|0;f=k+1|0;i=d;return f|0}else{Hka(3,0,0,0)|0;f=k+1|0;i=d;return f|0}}else if((j|0)==12){i=d;return f|0}return 0}function Jka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;do{if((a[b]|0)==41){g=b}else{if((Kka(b,e)|0)!=0){g=c[e>>2]|0;break}if((Lka(b,e)|0)!=0){g=c[e>>2]|0;break}h=Mka(b,f,1)|0;j=Hka(6,c[f>>2]|0,0,0)|0;if((j|0)<0){g=0;break}g=Cka(h,j)|0}}while(0);i=d;return g|0}function Kka(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;a:do{switch(a[b]|0){case 39:case 34:case 2:{c[134640+((Hka(11,0,0,0)|0)<<4)>>2]=b;g=Nka(b)|0;c[d>>2]=g;h=(g|0)!=0|0;i=e;return h|0};case 36:{Hka(33,0,0,0)|0;j=b;k=30;break};case 43:{l=0;k=13;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{m=b;n=0;k=14;break};case 116:case 84:{g=b+1|0;o=a[g]|0;if(o<<24>>24==82|o<<24>>24==114){p=g;q=14}else if(o<<24>>24==76|o<<24>>24==108){p=g;q=13}else{p=b;q=15}g=Mka(p+1|0,f,0)|0;if((g|0)==0){k=15;break a}Hka(q,c[f>>2]|0,0,0)|0;j=g+ -1|0;k=30;break};case 98:case 66:{g=b+1|0;o=a[g]|0;if(o<<24>>24==90|o<<24>>24==122){Hka(22,0,0,0)|0;j=g;k=30;break a}else{Hka(21,0,0,0)|0;j=g;k=30;break a}break};case 112:case 80:{Hka(20,1,0,0)|0;j=b;k=30;break};case 47:{Hka(5,0,0,0)|0;j=b;k=30;break};case 45:{l=1;k=13;break};case 58:{Hka(16,0,0,0)|0;j=b;k=30;break};case 120:case 88:{Hka(4,1,0,0)|0;j=b;k=30;break};case 115:case 83:{g=b+1|0;o=a[g]|0;if(o<<24>>24==80|o<<24>>24==112){r=g;s=18}else if(o<<24>>24==83|o<<24>>24==115){r=g;s=19}else{r=b;s=17}Hka(s,0,0,0)|0;j=r;k=30;break};default:{h=0;i=e;return h|0}}}while(0);if((k|0)==13){m=b+1|0;n=l;k=14}b:do{if((k|0)==14){l=Mka(m,f,0)|0;if((l|0)==0){k=15;break}switch(a[l]|0){case 104:case 72:{b=c[f>>2]|0;c[134640+((Hka(12,b,0,0)|0)<<4)>>2]=l+1;j=l+b|0;k=30;break b;break};case 120:case 88:{Hka(4,c[f>>2]|0,0,0)|0;j=l;k=30;break b;break};case 112:case 80:{b=c[f>>2]|0;if((n|0)==0){t=b}else{r=0-b|0;c[f>>2]=r;t=r}Hka(20,t,0,0)|0;j=l;k=30;break b;break};default:{h=0;i=e;return h|0}}}}while(0);if((k|0)==15){c[d>>2]=0;h=1;i=e;return h|0}else if((k|0)==30){c[d>>2]=j+1;h=1;i=e;return h|0}return 0}function Lka(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=Mka(b,f,1)|0;Hka(6,c[f>>2]|0,0,0)|0;f=k+1|0;a:do{switch(a[k]|0){case 111:case 79:{l=32;m=34;n=38;break};case 103:case 71:{o=0;n=3;break};case 105:case 73:{l=7;m=10;n=38;break};case 122:case 90:{l=35;m=36;n=38;break};case 101:case 69:{o=1;n=3;break};case 108:case 76:{p=Mka(f,g,0)|0;if((p|0)==0){n=4;break a}q=c[g>>2]|0;if((q|0)==0){r=p;n=45;break a}Hka(29,q,0,0)|0;r=p;n=45;break};case 100:case 68:{p=Mka(f,g,0)|0;if((p|0)==0){n=4;break a}q=c[g>>2]|0;if((q|0)==0){r=p;n=45;break a}if((a[p]|0)==46){s=Mka(p+1|0,h,0)|0;if((s|0)==0){n=4;break a}t=s;u=c[h>>2]|0}else{c[h>>2]=0;t=p;u=0}Hka(26,q,u,0)|0;r=t;n=45;break};case 97:case 65:{q=f;while(1){v=a[q]|0;if(v<<24>>24==32){q=q+1|0}else{break}}if(!((v+ -48<<24>>24&255)<10)){Hka(30,0,0,0)|0;r=q;n=45;break a}p=Mka(q,g,1)|0;s=c[g>>2]|0;if((s|0)==0){r=p;n=45;break a}Hka(31,s,0,0)|0;r=p;n=45;break};case 102:case 70:{p=Mka(f,g,0)|0;if((p|0)==0){n=4;break a}s=c[g>>2]|0;if((s|0)==0){r=p;n=45;break a}if((a[p]|0)==46){w=Mka(p+1|0,h,0)|0;if((w|0)==0){n=4;break a}x=w;y=c[h>>2]|0}else{c[h>>2]=0;x=p;y=0}Hka(23,s,y,0)|0;r=x;n=45;break};default:{c[33652]=(c[33652]|0)+ -1;c[d>>2]=b;z=0;i=e;return z|0}}}while(0);do{if((n|0)==3){b=Mka(f,g,0)|0;if((b|0)==0){n=4;break}x=c[g>>2]|0;if((x|0)==0){r=b;n=45;break}y=a[b]|0;if(y<<24>>24==46){v=Mka(b+1|0,h,0)|0;if((v|0)==0){n=4;break}A=v;B=a[v]|0}else{c[h>>2]=0;A=b;B=y}if(!(B<<24>>24==101|B<<24>>24==69)){Hka((o|0)==1?24:27,x,c[h>>2]|0,0)|0;r=A;n=45;break}y=Mka(A+1|0,j,0)|0;if((y|0)==0){n=4;break}Hka((o|0)==1?25:28,x,c[h>>2]|0,c[j>>2]|0)|0;r=y;n=45}else if((n|0)==38){y=Mka(f,g,0)|0;if((y|0)==0){n=4;break}x=c[g>>2]|0;if((x|0)==0){r=y;n=45;break}if((a[y]|0)!=46){Hka(l,x,0,0)|0;r=y;n=45;break}b=Mka(y+1|0,h,0)|0;if((b|0)==0){n=4;break}Hka(m,x,c[h>>2]|0,0)|0;r=b;n=45}}while(0);if((n|0)==4){c[d>>2]=0;z=1;i=e;return z|0}else if((n|0)==45){c[d>>2]=r;z=1;i=e;return z|0}return 0}function Mka(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b;b=0;h=0;while(1){j=a[g]|0;k=j<<24>>24;if(j<<24>>24==32){l=b;m=h}else{if((j+ -48<<24>>24&255)>9){break}l=b+1|0;m=(h*10|0)+ -48+k|0}g=g+1|0;b=l;h=m}if((b|0)!=0){n=g;o=h;c[d>>2]=o;i=f;return n|0}n=(e|0)==0?0:g;o=e;c[d>>2]=o;i=f;return n|0}function Nka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a[b]|0;f=b+1|0;g=a[f]|0;a:do{if(!(g<<24>>24==0)){h=f;j=g;k=b;while(1){if(j<<24>>24==e<<24>>24){l=k+2|0;if((a[l]|0)==e<<24>>24){m=l}else{n=l;break}}else{m=h}l=m+1|0;o=a[l]|0;if(o<<24>>24==0){break a}else{h=l;j=o;k=m}}i=d;return n|0}}while(0);if((c[c[33624]>>2]|0)==0){xka(100,139592);n=0;i=d;return n|0}else{c[(Mc()|0)>>2]=100;n=0;i=d;return n|0}return 0}function Oka(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;do{if((b|0)>0){h=0;j=b}else{if((b|0)<0){h=1;j=0-b|0;break}c[e>>2]=0;c[d>>2]=1;a[139662|0]=48;k=139662|0;i=g;return k|0}}while(0);c[e>>2]=h;h=23;e=j;while(1){j=h+ -1|0;l=139640+j|0;a[l]=((e>>>0)%(f>>>0)|0)+48;b=(e>>>0)/(f>>>0)|0;if((b|0)==0){break}else{e=b;h=j}}c[d>>2]=24-h;k=l;i=g;return k|0}function Pka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[33646]|0;f=c[33642]|0;if((e|0)>(f|0)){c[33642]=e;g=e}else{g=f}f=g+1|0;if((f|0)<(c[34934]|0)){h=g}else{Qka(f,g);h=c[33642]|0}g=c[34936]|0;f=g+h|0;if((b|0)==0){j=f}else{a[f]=b;j=g+(h+1)|0}a[j]=0;Cd(g|0,c[33620]|0)|0;h=lxa(g|0)|0;b=g+h|0;if(b>>>0<j>>>0){k=b;l=h;m=g}else{i=d;return 0}while(1){g=l+1|0;h=m+g|0;Kd(a[k]|0,c[33620]|0)|0;Cd(h|0,c[33620]|0)|0;b=lxa(h|0)|0;f=m+(g+b)|0;if(f>>>0<j>>>0){m=h;l=b;k=f}else{break}}i=d;return 0}function Qka(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[34936]|0;if((f|0)==139824){c[34934]=1024;g=1024}else{g=c[34934]|0}if((g|0)>(b|0)){h=g}else{j=g;do{j=j<<1;}while((j|0)<=(b|0));c[34934]=j;h=j}j=Jwa(h)|0;if((j|0)==0){xka(113,140224);k=c[34936]|0}else{k=f}f=k+d|0;if((d|0)>0){d=j;h=k;while(1){b=h+1|0;a[d]=a[h]|0;if(b>>>0<f>>>0){h=b;d=d+1|0}else{break}}l=c[34936]|0}else{l=k}if((l|0)==139824){m=139744;c[34936]=j;i=e;return}Kwa(l);m=139744;c[34936]=j;i=e;return}function Rka(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[33642]|0;f=c[34934]|0;if((e|0)<(f|0)){g=e}else{Qka(e,f);g=c[33642]|0}c[33642]=g+1;a[(c[34936]|0)+g|0]=b;i=d;return}function Ska(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d;f=i;i=i+256|0;g=i;i=i+16|0;h=i;i=i+8|0;j=f;c[33606]=1;f=b+4|0;k=c[f>>2]|0;if(k>>>0>99){if((c[b>>2]|0)==0){xka(101,139752);l=101;i=d;return l|0}else{c[(Mc()|0)>>2]=101;l=101;i=d;return l|0}}if((c[33618]|0)==0){yka();m=c[f>>2]|0}else{m=k}k=129408+(m*48|0)|0;c[32342]=k;n=k;a:do{if((c[n>>2]|0)!=0){k=c[b+8>>2]|0;do{if((k|0)!=0){Xka(k,c[b+12>>2]|0,j);o=Yka(j,h)|0;if((o|0)==(c[129416+(m*48|0)>>2]|0)){if((c[h>>2]|0)==(c[129420+(m*48|0)>>2]|0)){break}}c[g+4>>2]=c[f>>2];c[g+8>>2]=0;c[g>>2]=c[b>>2];o=tka(g)|0;if((o|0)==0){break a}else{l=o}i=d;return l|0}}while(0);k=c[b+32>>2]|0;if((k|0)==0){l=0;i=d;return l|0}o=a[k]|0;if(o<<24>>24==122){p=1}else{p=o<<24>>24==90|0}c[129440+(m*48|0)>>2]=p;l=0;i=d;return l|0}}while(0);p=b+28|0;g=c[p>>2]|0;h=129424+(m*48|0)|0;c[h>>2]=g;o=c[b+32>>2]|0;do{if((o|0)==0){q=0}else{k=a[o]|0;if(k<<24>>24==122){q=1;break}q=k<<24>>24==90|0}}while(0);c[129440+(m*48|0)>>2]=q;q=c[b+24>>2]|0;do{if((q|0)==0){o=129432+(m*48|0)|0;if((g|0)>0){c[o>>2]=0;r=0;break}else{c[o>>2]=1;r=1;break}}else{o=a[q]|0;if(o<<24>>24==70|o<<24>>24==102){c[129432+(m*48|0)>>2]=1;r=1;break}else{c[129432+(m*48|0)>>2]=0;r=0;break}}}while(0);q=c[b+8>>2]|0;do{if((q|0)==0){c[e>>2]=c[f>>2];hc(j|0,139760,e|0)|0}else{Xka(q,c[b+12>>2]|0,j);if((a[j]|0)!=0){break}if((c[b>>2]|0)==0){Tka(107,139752,b);l=107;i=d;return l|0}else{c[(Mc()|0)>>2]=107;l=107;i=d;return l|0}}}while(0);q=129452+(m*48|0)|0;c[q>>2]=0;c[129444+(m*48|0)>>2]=0;e=129448+(m*48|0)|0;c[e>>2]=0;c[n>>2]=0;f=129436+(m*48|0)|0;c[f>>2]=3;g=c[b+16>>2]|0;b:do{if((g|0)!=0){c:do{switch(a[g]|0){case 79:case 111:{if((Bc(j|0,0)|0)==0){break b}o=(c[b>>2]|0)==0;k=Mc()|0;s=c[k>>2]|0;if(o){Tka(s,139752,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=s;l=s;i=d;return l|0}break};case 83:case 115:{c[q>>2]=1;s=Kb()|0;c[n>>2]=s;if((s|0)!=0){c[129412+(m*48|0)>>2]=0;c[129420+(m*48|0)>>2]=-1;c[129416+(m*48|0)>>2]=-1;c[129428+(m*48|0)>>2]=1;l=0;i=d;return l|0}s=(c[b>>2]|0)==0;k=Mc()|0;o=c[k>>2]|0;if(s){Tka(o,139752,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=o;l=o;i=d;return l|0}break};case 82:case 114:{break};case 78:case 110:{if((Bc(j|0,0)|0)!=0){break c}if((c[b>>2]|0)==0){Tka(128,139752,b);l=128;i=d;return l|0}else{c[(Mc()|0)>>2]=128;l=128;i=d;return l|0}break};default:{break b}}}while(0);o=ic(j|0,c[34930]|0)|0;if((o|0)==0){break}Wc(o|0)|0}}while(0);q=Jwa((lxa(j|0)|0)+1|0)|0;c[129412+(m*48|0)>>2]=q;if((q|0)==0){if((c[b>>2]|0)==0){Tka(113,139776,b);l=113;i=d;return l|0}else{c[(Mc()|0)>>2]=113;l=113;i=d;return l|0}}rxa(q|0,j|0)|0;q=b+20|0;if((c[q>>2]|0)==0){t=r}else{t=(c[h>>2]|0)==0?r:0}r=ic(j|0,c[139720+((t|2)<<2)>>2]|0)|0;do{if((r|0)==0){h=ic(j|0,c[139680+(t<<2)>>2]|0)|0;if((h|0)!=0){c[f>>2]=1;u=h;break}h=ic(j|0,c[139720+(t<<2)>>2]|0)|0;if((h|0)!=0){c[e>>2]=1;c[f>>2]=2;u=h;break}h=(c[b>>2]|0)==0;g=Mc()|0;o=c[g>>2]|0;if(h){xka(o,139752);l=c[g>>2]|0;i=d;return l|0}else{c[g>>2]=o;l=o;i=d;return l|0}}else{u=r}}while(0);c[n>>2]=u;r=129428+(m*48|0)|0;c[r>>2]=wka(u)|0;u=Yka(j,129420+(m*48|0)|0)|0;c[129416+(m*48|0)>>2]=u;if((u|0)==-1){if((c[b>>2]|0)==0){Tka(108,139752,b);l=108;i=d;return l|0}else{c[(Mc()|0)>>2]=108;l=108;i=d;return l|0}}if((c[r>>2]|0)==0){l=0;i=d;return l|0}if((c[p>>2]|0)!=0){ob(c[n>>2]|0);l=0;i=d;return l|0}p=c[q>>2]|0;if((p|0)==0){l=0;i=d;return l|0}q=a[p]|0;if(!(q<<24>>24==65|q<<24>>24==97)){l=0;i=d;return l|0}if((Uc(c[n>>2]|0,0,2)|0)==0){l=0;i=d;return l|0}if((c[b>>2]|0)==0){Tka(129,139752,b);l=129;i=d;return l|0}else{c[(Mc()|0)>>2]=129;l=129;i=d;return l|0}return 0}function Tka(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d+8|0;g=c[f>>2]|0;if((g|0)==0){xka(a,b);i=e;return}h=d+12|0;d=c[h>>2]|0;if((d|0)<(c[34934]|0)){j=d;k=g}else{Qka(d,0);j=c[h>>2]|0;k=c[f>>2]|0}f=c[34936]|0;c[(c[32342]|0)+4>>2]=f;Xka(k,j,f);xka(a,b);i=e;return}function Uka(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+40|0;j=g;c[f>>2]=d;hc(j|0,139760,f|0)|0;c[h>>2]=1;c[h+4>>2]=d;c[h+8>>2]=j;c[h+12>>2]=lxa(j|0)|0;c[h+16>>2]=0;c[h+20>>2]=(a|0)==3?139792:139800;c[h+24>>2]=(b|0)==5?139808:139816;c[h+28>>2]=(a|0)==4;c[h+32>>2]=0;a=Ska(h)|0;i=e;return a|0}function Vka(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=129408+(d*48|0)|0;c[32342]=e;if(d>>>0>99){if((c[a>>2]|0)==0){xka(101,140240);f=101;i=b;return f|0}else{c[(Mc()|0)>>2]=101;f=101;i=b;return f|0}}do{if((c[e>>2]|0)==0){if((Uka(3,5,d)|0)==0){break}if((c[a>>2]|0)==0){xka(114,140248);f=114;i=b;return f|0}else{c[(Mc()|0)>>2]=114;f=114;i=b;return f|0}}}while(0);if((c[129432+(d*48|0)>>2]|0)!=0){f=0;i=b;return f|0}if((c[a>>2]|0)==0){xka(102,140248);f=102;i=b;return f|0}else{c[(Mc()|0)>>2]=102;f=102;i=b;return f|0}return 0}function Wka(){var a=0,b=0;a=i;b=Fka()|0;c[33568]=0;i=a;return b|0}function Xka(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+c|0;g=d+c|0;while(1){if(!(f>>>0>b>>>0)){h=3;break}j=f+ -1|0;k=g+ -1|0;if((a[j]|0)==32){f=j;g=k}else{break}}if((h|0)==3){a[d]=0;i=e;return}a[g]=0;g=j;j=k;while(1){a[j]=a[g]|0;if(g>>>0>b>>>0){j=j+ -1|0;g=g+ -1|0}else{break}}i=e;return}function Yka(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+80|0;e=d;if((lc(a|0,e|0)|0)<0){f=-1;i=d;return f|0}c[b>>2]=c[e>>2];f=c[e+72>>2]|0;i=d;return f|0}function Zka(b,d,e,f,j){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=i;i=i+56|0;p=o;q=(f|0)<1?2:f;r=c[33648]|0;if((r|0)==0){s=3}else{if((r|0)<(e+2|0)&(r|0)>(0-e|0)){s=3}}a:do{if((s|0)==3){t=(((r|0)<1)<<31>>31)+e|0;if((j|0)==4){u=+g[b>>2]}else{u=+h[b>>3]}do{if(u<0.0){v=-u;w=1;x=1}else{y=c[33628]|0;if(u!=0.0){v=u;w=0;x=y;break}v=0.0;w=0;x=y}}while(0);y=d+ -4-q-t-x|0;if((y|0)<0){break}z=((r|0)<0?r:0)+t|0;A=(z|0)>40;B=A?40:z;C=A?z+ -40|0:0;c[n>>2]=B;z=n+4|0;h[k>>3]=v;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];hc(p|0,140256,n|0)|0;z=a[p]|0;if(!((z+ -48|0)>>>0<10)){if((z|0)==78|(z|0)==110){D=0}else{D=x}z=d-(lxa(p|0)|0)-D|0;if((z|0)<0){break}if((z|0)>0){A=z;do{A=A+ -1|0;Zd[c[33632]&1023](32);}while((A|0)>0)}if((D|0)!=0){Zd[c[33632]&1023]((w|0)!=0?45:43)}A=a[p]|0;if(A<<24>>24==0){i=l;return 0}else{E=A;F=p}do{Zd[c[33632]&1023](E<<24>>24);F=F+1|0;E=a[F]|0;}while(!(E<<24>>24==0));i=l;return 0}A=o+(B+3)|0;if(v!=0.0){t=(Ec(A|0)|0)+1|0;c[m>>2]=t-(c[33648]|0);hc(A|0,140264,m|0)|0}else{t=A;a[t]=3158059;a[t+1|0]=12336;a[t+2|0]=48;a[t+3|0]=0}t=o+(B+4)|0;A=(q|0)<2;if(A){if((a[t]|0)!=48){break}}z=o+(B+6)|0;G=(a[z]|0)==0;b:do{if(G){H=2}else{if((f|0)==0){I=o+(B+2)|0;while(1){J=I+1|0;K=a[J]|0;a[I]=K;if(K<<24>>24==0){H=2;break b}else{I=J}}}I=(f|0)<0;if(I|G){H=I?q:2;break}else{L=2;M=z}while(1){if((L|0)>=(q|0)){break a}I=L+1|0;J=M+1|0;if((a[J]|0)==0){H=I;break}else{L=I;M=J}}}}while(0);if((y|0)>0){z=y;do{z=z+ -1|0;Zd[c[33632]&1023](32);}while((z|0)>0)}if((x|0)!=0){Zd[c[33632]&1023]((w|0)!=0?45:43)}z=c[33648]|0;do{if((z|0)<1){Zd[c[33632]&1023](46);y=c[33632]|0;if((z|0)<0){G=y;J=z;while(1){Zd[G&1023](48);I=J+1|0;K=c[33632]|0;if((I|0)<0){J=I;G=K}else{N=K;break}}}else{N=y}Zd[N&1023](a[p]|0);O=o+2|0}else{if((z|0)<=1){O=p;break}Zd[c[33632]&1023](a[p]|0);G=o+2|0;J=z+ -1|0;K=c[33632]|0;if((J|0)>0){I=z+1|0;P=K;Q=J;J=G;while(1){Zd[P&1023](a[J]|0);R=Q+ -1|0;S=c[33632]|0;if((R|0)>0){J=J+1|0;Q=R;P=S}else{break}}T=S;U=o+I|0}else{T=K;U=G}Zd[T&1023](46);O=U}}while(0);if((C|0)==0){V=O}else{z=o+(B+2)|0;if(O>>>0<z>>>0){P=O;while(1){Q=P+1|0;Zd[c[33632]&1023](a[P]|0);if(Q>>>0<z>>>0){P=Q}else{W=Q;break}}}else{W=O}P=C;while(1){Zd[c[33632]&1023](48);z=P+ -1|0;if((z|0)>0){P=z}else{V=W;break}}}if(V>>>0<t>>>0){P=V;while(1){C=P+1|0;Zd[c[33632]&1023](a[P]|0);if(C>>>0<t>>>0){P=C}else{X=C;break}}}else{X=V}if(A){Zd[c[33632]&1023](a[X+1|0]|0);i=l;return 0}if((H|0)<(q|0)){P=H;do{P=P+1|0;Zd[c[33632]&1023](48);}while((P|0)<(q|0))}P=a[X]|0;if(P<<24>>24==0){i=l;return 0}else{Y=P;Z=X}do{Z=Z+1|0;Zd[c[33632]&1023](Y<<24>>24);Y=a[Z]|0;}while(!(Y<<24>>24==0));i=l;return 0}}while(0);if((d|0)>0){_=d}else{i=l;return 0}do{_=_+ -1|0;Zd[c[33632]&1023](42);}while((_|0)>0);i=l;return 0}function _ka(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;l=j;m=i;i=i+656|0;n=m;if((f|0)==4){o=+g[b>>2]}else{o=+h[b>>3]}b=(e|0)<344;f=b?e:344;p=b?0:e+ -344|0;do{if(o<0.0){q=1;r=-o}else{if(o!=0.0){q=0;r=o;break}q=0;r=0.0}}while(0);e=c[33648]|0;if((e|0)==0){s=r}else{if((e|0)>0){b=e;o=r;while(1){t=o*10.0;u=b+ -1|0;if((u|0)>0){o=t;b=u}else{s=t;break}}}else{b=e;o=r;while(1){r=o*.1;e=b+1|0;if((e|0)<0){o=r;b=e}else{s=r;break}}}}c[l>>2]=f;b=l+4|0;h[k>>3]=s;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=(hc(n|0,140272,l|0)|0)+p|0;if((a[n]|0)!=48|(f|0)==0){v=n;w=b}else{v=m+1|0;w=b+ -1|0}a:do{if((q|0)==1){b=v;while(1){m=a[b]|0;if(!(m<<24>>24==48)){n=m<<24>>24;if((n|0)==0){x=0;break a}else if((n|0)!=46){break}}b=b+1|0}x=1}else{x=q}}while(0);q=(x|0)==0;b=((c[33628]|x|0)!=0)+w|0;if((b|0)>(d|0)){if((d|0)>0){y=d}else{i=j;return 0}do{y=y+ -1|0;Zd[c[33632]&1023](42);}while((y|0)>0);i=j;return 0}y=d-b|0;if((y|0)>0){b=y;do{b=b+ -1|0;Zd[c[33632]&1023](32);}while((b|0)>0)}do{if(q){if((c[33628]|0)==0){break}Zd[c[33632]&1023](43)}else{Zd[c[33632]&1023](45)}}while(0);q=a[v]|0;if(!(q<<24>>24==0)){b=q;q=v;do{q=q+1|0;Zd[c[33632]&1023](b<<24>>24);b=a[q]|0;}while(!(b<<24>>24==0))}if((p|0)>0){z=p}else{i=j;return 0}do{z=z+ -1|0;Zd[c[33632]&1023](48);}while((z|0)>0);i=j;return 0}function $ka(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((f|0)==4){h=c[d>>2]|0}else if((f|0)==1){h=a[d]|0}else{h=b[d>>1]|0}d=e+ -1|0;if((d|0)>0){e=0;do{Zd[c[33632]&1023](32);e=e+1|0;}while((e|0)<(d|0))}d=c[33632]|0;if((h|0)==0){Zd[d&1023](70);i=g;return 0}else{Zd[d&1023](84);i=g;return 0}return 0}function ala(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;do{if((c[33644]|0)!=0){g=bla()|0;if((g|0)==0){break}else{h=g}i=e;return h|0}}while(0);g=c[a>>2]|0;switch(g|0){case 7:{cla(b,c[a+4>>2]|0,d,10);h=0;i=e;return h|0};case 32:{cla(b,c[a+4>>2]|0,d,8);h=0;i=e;return h|0};case 35:{hla(b,c[a+4>>2]|0,0,d);h=0;i=e;return h|0};case 36:{hla(b,c[a+4>>2]|0,c[a+8>>2]|0,d);h=0;i=e;return h|0};case 23:{h=_ka(b,c[a+4>>2]|0,c[a+8>>2]|0,d)|0;i=e;return h|0};case 34:{dla(b,c[a+4>>2]|0,c[a+8>>2]|0,d,8);h=0;i=e;return h|0};case 29:{$ka(b,c[a+4>>2]|0,d)|0;h=0;i=e;return h|0};case 30:{ela(b,d);h=0;i=e;return h|0};case 10:{dla(b,c[a+4>>2]|0,c[a+8>>2]|0,d,10);h=0;i=e;return h|0};case 25:case 24:case 26:{h=Zka(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 28:case 27:{h=gla(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 31:{fla(b,c[a+4>>2]|0,d);h=0;i=e;return h|0};default:{h=c[r>>2]|0;c[f>>2]=g;pd(h|0,140280,f|0)|0;mka(c[33568]|0,1)}}return 0}function bla(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=c[33644]|0;c[33644]=0;if((c[33606]|0)!=0){if((b|0)>0){d=c[33646]|0;e=c[33642]|0;if((d|0)<=(e|0)){f=b;while(1){Zd[c[33632]&1023](32);g=f+ -1|0;if((g|0)>0){f=g}else{h=0;break}}i=a;return h|0}f=e+b|0;if((d|0)>(f|0)){c[33642]=f;h=0;i=a;return h|0}f=b-d+e|0;c[33642]=d;if((f|0)>0){j=f}else{h=0;i=a;return h|0}while(1){Zd[c[33632]&1023](32);f=j+ -1|0;if((f|0)>0){j=f}else{h=0;break}}i=a;return h|0}if((b|0)>=0){h=0;i=a;return h|0}j=c[33642]|0;f=j+b|0;if((f|0)>=0){if((c[33646]|0)<(j|0)){c[33646]=j}c[33642]=f;h=0;i=a;return h|0}if((c[c[33624]>>2]|0)==0){xka(110,140368);h=110;i=a;return h|0}else{c[(Mc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<0){f=c[33642]|0;if((c[33646]|0)<(f|0)){c[33646]=f}j=f+b|0;c[33642]=j;c[33650]=(c[33650]|0)+b;if((j|0)>=0){h=0;i=a;return h|0}if((c[c[33624]>>2]|0)==0){xka(110,140368);h=110;i=a;return h|0}else{c[(Mc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<=0){h=0;i=a;return h|0}j=c[33642]|0;f=j+b|0;if((f|0)>=(c[(c[33626]|0)+16>>2]|0)){if((c[c[33624]>>2]|0)==0){xka(110,140384);h=110;i=a;return h|0}else{c[(Mc()|0)>>2]=110;h=110;i=a;return h|0}}d=c[33646]|0;if((d|0)<=(j|0)){e=b;while(1){Zd[c[33632]&1023](32);g=e+ -1|0;if((g|0)>0){e=g}else{h=0;break}}i=a;return h|0}if((d|0)>(f|0)){c[33650]=(c[33650]|0)+b;c[33642]=f;h=0;i=a;return h|0}f=d-j|0;j=b-f|0;c[33650]=(c[33650]|0)+f;c[33642]=d;if((j|0)>0){k=j}else{h=0;i=a;return h|0}while(1){Zd[c[33632]&1023](32);j=k+ -1|0;if((j|0)>0){k=j}else{h=0;break}}i=a;return h|0}function cla(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;k=h+8|0;if((f|0)==4){l=c[d>>2]|0}else if((f|0)==1){l=a[d]|0}else{l=b[d>>1]|0}d=Oka(l,j,k,g)|0;g=c[k>>2]|0;l=(((c[33628]|g|0)!=0)<<31>>31)+(e-(c[j>>2]|0))|0;if((l|0)<0){if((e|0)>0){m=0}else{i=h;return}do{Zd[c[33632]&1023](42);m=m+1|0;}while((m|0)<(e|0));i=h;return}if((l|0)>0){e=0;do{Zd[c[33632]&1023](32);e=e+1|0;}while((e|0)<(l|0));n=c[k>>2]|0}else{n=g}do{if((n|0)==0){if((c[33628]|0)==0){break}Zd[c[33632]&1023](43)}else{Zd[c[33632]&1023](45)}}while(0);if((c[j>>2]|0)>0){o=d;p=0}else{i=h;return}while(1){Zd[c[33632]&1023](a[o]|0);d=p+1|0;if((d|0)<(c[j>>2]|0)){p=d;o=o+1|0}else{break}}i=h;return}function dla(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;l=j+8|0;if((g|0)==1){m=a[d]|0}else if((g|0)==4){m=c[d>>2]|0}else{m=b[d>>1]|0}d=Oka(m,k,l,h)|0;h=c[l>>2]|0;g=(c[33628]|h|0)!=0;n=g&1;o=c[k>>2]|0;do{if((n+o|0)<=(e|0)){if((n+f|0)>(e|0)){break}if((m|f|0)==0){if((e|0)>0){p=0}else{i=j;return}do{Zd[c[33632]&1023](32);p=p+1|0;}while((p|0)<(e|0));i=j;return}q=e-((o|0)<(f|0)?f:o)+(g<<31>>31)|0;if((q|0)>0){r=0;do{Zd[c[33632]&1023](32);r=r+1|0;}while((r|0)<(q|0));s=c[l>>2]|0}else{s=h}do{if((s|0)==0){if((c[33628]|0)==0){break}Zd[c[33632]&1023](43)}else{Zd[c[33632]&1023](45)}}while(0);q=c[k>>2]|0;if((f-q|0)>0){r=0;while(1){Zd[c[33632]&1023](48);t=r+1|0;u=c[k>>2]|0;if((t|0)<(f-u|0)){r=t}else{v=u;break}}}else{v=q}if((v|0)>0){w=d;x=0}else{i=j;return}while(1){Zd[c[33632]&1023](a[w]|0);r=x+1|0;if((r|0)<(c[k>>2]|0)){x=r;w=w+1|0}else{break}}i=j;return}}while(0);if((e|0)>0){y=0}else{i=j;return}do{Zd[c[33632]&1023](42);y=y+1|0;}while((y|0)<(e|0));i=j;return}function ela(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)>0){f=b;g=d}else{i=e;return}while(1){d=g+ -1|0;Zd[c[33632]&1023](a[f]|0);if((d|0)>0){g=d;f=f+1|0}else{break}}i=e;return}function fla(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if((d|0)>(e|0)){g=d;while(1){h=g+ -1|0;Zd[c[33632]&1023](32);if((h|0)>(e|0)){g=h}else{j=e;break}}}else{j=d}if((j|0)>0){k=b;l=j}else{i=f;return}while(1){j=l+ -1|0;Zd[c[33632]&1023](a[k]|0);if((j|0)>0){l=j;k=k+1|0}else{break}}i=f;return}function gla(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0,n=0,o=0,p=0;j=i;if((f|0)==4){k=+g[a>>2]}else{k=+h[a>>3]}if(k<0.0){l=-k}else{l=k}a:do{if(l<.1){if(!(l!=0.0)){m=1;break}n=Zka(a,b,d,e,f)|0;i=j;return n|0}else{if((d|0)>=0){o=0;k=1.0;while(1){if(!(l>=k)){m=o;break a}if((o|0)<(d|0)){o=o+1|0;k=k*10.0}else{break}}}n=Zka(a,b,d,e,f)|0;i=j;return n|0}}while(0);o=c[33648]|0;c[33648]=0;p=(e|0)==0?4:e+2|0;e=_ka(a,b-p|0,d-m|0,f)|0;if((p|0)>0){f=0;do{Zd[c[33632]&1023](32);f=f+1|0;}while((f|0)<(p|0))}c[33648]=o;n=e;i=j;return n|0}function hla(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;k=b+(g+ -1)|0;a:do{if((k|0)==(j|0)){l=1;m=j}else{g=k;while(1){n=g+ -1|0;if((a[g]|0)!=0){l=0;m=g;break a}if((n|0)==(j|0)){l=1;m=j;break}else{g=n}}}}while(0);k=((d[m]|0)>15)+(m-b<<1|1)|0;if((k|0)>(e|0)){if((e|0)>0){o=0}else{i=h;return}do{Zd[c[33632]&1023](42);o=o+1|0;}while((o|0)<(e|0));i=h;return}o=f-k|0;b=(o|0)>0;g=b?f:k;if((g|0)<(e|0)){k=e;do{k=k+ -1|0;Zd[c[33632]&1023](32);}while((k|0)>(g|0))}if(b){b=o;do{b=b+ -1|0;Zd[c[33632]&1023](48);}while((b|0)>0)}b=a[m]|0;do{if((b&240|0)==0){Zd[c[33632]&1023](a[140344+(b&15)|0]|0);if(l){i=h;return}else{p=m+ -1|0;break}}else{p=m}}while(0);while(1){Zd[c[33632]&1023](a[140344+((d[p]|0)>>>4)|0]|0);Zd[c[33632]&1023](a[140344+(a[p]&15)|0]|0);if((p|0)==(j|0)){break}p=p+ -1|0}i=h;return}function ila(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[a>>2]|0;switch(e|0){case 5:{f=ue[c[33640]&7]()|0;i=b;return f|0};case 13:{g=(c[33644]|0)-(c[a+4>>2]|0)|0;h=0-(c[33642]|0)|0;c[33644]=(g|0)<(h|0)?h:g;f=1;i=b;return f|0};case 4:case 14:{c[33644]=(c[33644]|0)+(c[a+4>>2]|0);f=1;i=b;return f|0};case 11:{f=jla(c[a+8>>2]|0)|0;i=b;return f|0};case 15:{c[33644]=(c[a+4>>2]|0)+ -1-(c[33642]|0);f=1;i=b;return f|0};case 12:{f=kla(c[a+4>>2]|0,c[a+8>>2]|0)|0;i=b;return f|0};default:{f=c[r>>2]|0;c[d>>2]=e;pd(f|0,140312,d|0)|0;mka(c[33568]|0,1)}}return 0}function jla(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;do{if((c[33644]|0)!=0){e=bla()|0;if((e|0)==0){break}else{f=e}i=d;return f|0}}while(0);e=a[b]|0;g=b+1|0;h=a[g]|0;if(h<<24>>24==0){f=1;i=d;return f|0}else{j=g;k=h;l=b}while(1){if(k<<24>>24==e<<24>>24){b=l+2|0;if(!((a[b]|0)==e<<24>>24)){f=1;m=9;break}Zd[c[33632]&1023](e<<24>>24);n=b}else{Zd[c[33632]&1023](k<<24>>24);n=j}b=n+1|0;h=a[b]|0;if(h<<24>>24==0){f=1;m=9;break}else{j=b;k=h;l=n}}if((m|0)==9){i=d;return f|0}return 0}function kla(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;do{if((c[33644]|0)!=0){f=bla()|0;if((f|0)==0){break}else{g=f}i=e;return g|0}}while(0);if((b|0)==0){g=1;i=e;return g|0}else{h=d;j=b}while(1){b=j+ -1|0;Zd[c[33632]&1023](a[h]|0);if((b|0)==0){g=1;break}else{j=b;h=h+1|0}}i=e;return g|0}function lla(){var a=0,b=0;a=i;b=Pka(10)|0;c[33644]=0;c[33642]=0;c[33646]=0;i=a;return(b|0)==0|0}function mla(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((c[33618]|0)==0){yka()}c[33582]=0;c[33588]=1;c[33596]=1;c[33606]=1;d=Vka(a)|0;if((d|0)!=0){e=d;i=b;return e|0}c[33624]=a;c[33642]=0;c[33644]=0;c[33646]=0;c[34896]=0;c[33648]=0;d=c[a+12>>2]|0;c[33568]=d;c[33620]=c[c[32342]>>2];if((Bka(d)|0)<0){if((c[a>>2]|0)==0){xka(100,140392);e=100;i=b;return e|0}else{c[(Mc()|0)>>2]=100;e=100;i=b;return e|0}}c[33632]=962;c[33634]=44;c[33636]=111;c[33622]=4;c[33638]=5;c[33640]=6;Gka();c[33628]=0;d=c[32342]|0;c[33630]=c[d+32>>2];if((c[d+40>>2]|0)==1){e=0;i=b;return e|0}if((zka(d)|0)==0){e=0;i=b;return e|0}d=(c[a>>2]|0)==0;a=Mc()|0;f=c[a>>2]|0;if(d){xka(f,140400);e=c[a>>2]|0;i=b;return e|0}else{c[a>>2]=f;e=f;i=b;return e|0}return 0}function nla(){var a=0,b=0;a=i;if((c[34896]|0)==0){b=Pka(10)|0}else{Pka(0)|0;nd(c[33620]|0)|0;b=0}c[33644]=0;c[33642]=0;c[33646]=0;i=a;return b|0}function ola(){var a=0,b=0,d=0;a=i;if((c[34880]|0)==0){b=0}else{d=Pka(10)|0;c[34880]=0;b=d}c[33644]=0;c[33642]=0;c[33646]=0;i=a;return b|0}function pla(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;Lla(141128,h,141184);c[35104]=142636;c[140424>>2]=142656;c[140420>>2]=0;Cna(140424|0,141128);c[140496>>2]=0;c[140500>>2]=-1;j=c[t>>2]|0;c[35308]=142504;kta(141236|0);k=141240|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[35308]=141744;c[141264>>2]=j;lta(g,141236|0);k=ota(g,145296)|0;l=k;mta(g);c[141268>>2]=l;c[141272>>2]=141192;a[141276|0]=(ae[c[(c[k>>2]|0)+28>>2]&127](l)|0)&1;c[35126]=142716;c[140508>>2]=142736;Cna(140508|0,141232);c[140580>>2]=0;c[140584>>2]=-1;l=c[r>>2]|0;c[35320]=142504;kta(141284|0);k=141288|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[35320]=141744;c[141312>>2]=l;lta(f,141284|0);k=ota(f,145296)|0;g=k;mta(f);c[141316>>2]=g;c[141320>>2]=141200;a[141324|0]=(ae[c[(c[k>>2]|0)+28>>2]&127](g)|0)&1;c[35148]=142716;c[140596>>2]=142736;Cna(140596|0,141280);c[140668>>2]=0;c[140672>>2]=-1;g=c[(c[(c[35148]|0)+ -12>>2]|0)+140616>>2]|0;c[35170]=142716;c[140684>>2]=142736;Cna(140684|0,g);c[140756>>2]=0;c[140760>>2]=-1;c[(c[(c[35104]|0)+ -12>>2]|0)+140488>>2]=140504;g=(c[(c[35148]|0)+ -12>>2]|0)+140596|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[35148]|0)+ -12>>2]|0)+140664>>2]=140504;xla(141328,h,141208|0);c[35192]=142676;c[140776>>2]=142696;c[140772>>2]=0;Cna(140776|0,141328);c[140848>>2]=0;c[140852>>2]=-1;c[35346]=142568;kta(141388|0);h=141392|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[35346]=141488;c[141416>>2]=j;lta(e,141388|0);j=ota(e,145304)|0;h=j;mta(e);c[141420>>2]=h;c[141424>>2]=141216;a[141428|0]=(ae[c[(c[j>>2]|0)+28>>2]&127](h)|0)&1;c[35214]=142756;c[140860>>2]=142776;Cna(140860|0,141384);c[140932>>2]=0;c[140936>>2]=-1;c[35358]=142568;kta(141436|0);h=141440|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[35358]=141488;c[141464>>2]=l;lta(d,141436|0);l=ota(d,145304)|0;h=l;mta(d);c[141468>>2]=h;c[141472>>2]=141224;a[141476|0]=(ae[c[(c[l>>2]|0)+28>>2]&127](h)|0)&1;c[35236]=142756;c[140948>>2]=142776;Cna(140948|0,141432);c[141020>>2]=0;c[141024>>2]=-1;h=c[(c[(c[35236]|0)+ -12>>2]|0)+140968>>2]|0;c[35258]=142756;c[141036>>2]=142776;Cna(141036|0,h);c[141108>>2]=0;c[141112>>2]=-1;c[(c[(c[35192]|0)+ -12>>2]|0)+140840>>2]=140856;h=(c[(c[35236]|0)+ -12>>2]|0)+140948|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[35236]|0)+ -12>>2]|0)+141016>>2]=140856;i=b;return}function qla(a){a=a|0;a=i;Aoa(140504)|0;Aoa(140680)|0;Hoa(140856)|0;Hoa(141032)|0;i=a;return}function rla(a){a=a|0;var b=0;b=i;c[a>>2]=142568;mta(a+4|0);i=b;return}function sla(a){a=a|0;var b=0;b=i;c[a>>2]=142568;mta(a+4|0);Rwa(a);i=b;return}function tla(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;ae[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=ota(d,145304)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(ae[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function ula(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=qe[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((qc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((nd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function vla(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((a[b+44|0]|0)!=0){g=qc(d|0,4,e|0,c[b+32>>2]|0)|0;i=f;return g|0}if((e|0)>0){h=d;j=0}else{g=0;i=f;return g|0}while(1){if((pe[c[(c[b>>2]|0)+52>>2]&63](b,c[h>>2]|0)|0)==-1){g=j;k=6;break}d=j+1|0;if((d|0)<(e|0)){h=h+4|0;j=d}else{g=d;k=6;break}}if((k|0)==6){i=f;return g|0}return 0}function wla(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){c[g>>2]=d;if((a[b+44|0]|0)!=0){if((qc(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=ye[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((qc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((qc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function xla(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=142568;j=b+4|0;kta(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=141600;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;lta(g,j);j=ota(g,145304)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=ae[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(ae[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){wsa(141696)}else{mta(g);i=f;return}}function yla(a){a=a|0;var b=0;b=i;c[a>>2]=142568;mta(a+4|0);i=b;return}function zla(a){a=a|0;var b=0;b=i;c[a>>2]=142568;mta(a+4|0);Rwa(a);i=b;return}function Ala(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=ota(d,145304)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=ae[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(ae[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){wsa(141696)}else{i=e;return}}function Bla(a){a=a|0;var b=0,c=0;b=i;c=Ela(a,0)|0;i=b;return c|0}function Cla(a){a=a|0;var b=0,c=0;b=i;c=Ela(a,1)|0;i=b;return c|0}function Dla(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f;q=ye[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((kd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}



function Q3(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;l=~y;h[10143]=.5;h[10139]=1.0;h[10155]=6.283185307179586;z=+h[n>>3];h[10152]=z*z;A=w+ -1-(c[b>>2]|0)|0;c[20292]=A;c[20300]=0;B=c[d>>2]|0;c[20252]=1;if((B|0)>=1){C=1;while(1){h[q+(C+ -1<<3)>>3]=0.0;if((C|0)<(B|0)){C=C+1|0}else{break}}c[20252]=B+1}c[20250]=1;B=c[m>>2]|0;if((A|0)<1){D=B}else{C=B;B=1;while(1){E=fa(B,w)|0;z=+h[j+(E+x+C<<3)>>3];h[10144]=z;if((B|0)<(c[k>>2]|0)){F=-z;h[10144]=F;G=F}else{G=z}H=c[d>>2]|0;c[20252]=1;if((H|0)>=1){z=G;I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]+z*+h[j+(I+x+E<<3)>>3];if((I|0)>=(H|0)){break}z=+h[10144];I=I+1|0}c[20252]=H+1}I=B+1|0;c[20250]=I;E=c[m>>2]|0;if((B|0)<(A|0)){C=E;B=I}else{D=E;break}}}h[p>>3]=+h[q+(D+ -1<<3)>>3];h[10127]=0.0;D=c[b>>2]|0;c[20248]=1;if((D|0)>=1){p=1;while(1){B=c[m>>2]|0;G=+h[f+((fa(p,w)|0)+x+B<<3)>>3];C=p+ -1|0;A=o+(C<<3)|0;h[A>>3]=G- +h[e+(C<<3)>>3];h[r+(C<<3)>>3]=+h[g+(B+l+(fa(p,y)|0)<<3)>>3];h[s+(C<<3)>>3]=0.0;G=+h[A>>3];h[10127]=+h[10127]+G*G;A=p+1|0;c[20248]=A;if((p|0)<(D|0)){p=A}else{break}}}p=c[d>>2]|0;c[20252]=1;if((p|0)>=1){D=1;while(1){h[10144]=0.0;h[10142]=0.0;y=c[b>>2]|0;c[20250]=1;if((y|0)<1){K=0.0;L=0.0}else{l=D+x|0;G=0.0;z=0.0;g=1;while(1){F=+h[f+((fa(g,w)|0)+x+D<<3)>>3];M=z+F*+h[e+(g+ -1<<3)>>3];h[10144]=M;F=+h[f+(l+(fa(g,w)|0)<<3)>>3];N=G+F*+h[o+(g+ -1<<3)>>3];h[10142]=N;if((g|0)<(y|0)){g=g+1|0;z=M;G=N}else{break}}c[20250]=y+1;K=M;L=N}g=q+(D+ -1<<3)|0;G=+h[g>>3]*K;h[10144]=G;h[10142]=+h[g>>3]*L;g=c[b>>2]|0;c[20248]=1;if((g|0)>=1){l=D+x|0;z=G;H=1;while(1){G=z*+h[f+((fa(H,w)|0)+x+D<<3)>>3];m=r+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;G=+h[10142]*+h[f+(l+(fa(H,w)|0)<<3)>>3];m=s+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;if((H|0)>=(g|0)){break}z=+h[10144];H=H+1|0}c[20248]=g+1}H=D+1|0;c[20252]=H;if((D|0)<(p|0)){D=H}else{break}}}h[10128]=0.0;h[10130]=0.0;h[10137]=0.0;D=c[b>>2]|0;c[20248]=1;if((D|0)<1){O=0.0;P=0.0;Q=0.0}else{L=0.0;K=0.0;N=0.0;p=1;while(1){M=+h[r+(p+ -1<<3)>>3];R=N+M*M;h[10128]=R;e=p+ -1|0;H=o+(e<<3)|0;S=K+ +h[H>>3]*+h[r+(e<<3)>>3];h[10130]=S;T=L+ +h[H>>3]*+h[s+(e<<3)>>3];h[10137]=T;if((p|0)<(D|0)){p=p+1|0;N=R;K=S;L=T}else{break}}c[20248]=D+1;O=R;P=T;Q=S}S=+h[10127];T=+h[n>>3]/+V(+S);if(Q*P<0.0){U=-T}else{U=T}h[10148]=U;h[10144]=0.0;if(Q*Q>S*.99*O){h[10144]=+h[10139]}if(!(Q>=0.0)){W=-Q}else{W=Q}if(!(P>=0.0)){Z=-P}else{Z=P}P=U*(W+ +h[10143]*U*Z);h[10140]=P;if(O*+h[10152]<P*P*.01){h[10144]=+h[10139]}n=c[b>>2]|0;c[20248]=1;if((n|0)<1){_=0}else{P=U;D=1;p=0;while(1){e=o+(p<<3)|0;h[e>>3]=P*+h[e>>3];e=D+ -1|0;H=s+(e<<3)|0;U=+h[10148]*+h[H>>3];h[H>>3]=U;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+ +h[10144]*U;if((D|0)>=(n|0)){break}e=D;P=+h[10148];D=D+1|0;p=e}c[20248]=n+1;_=0}while(1){n=_+1|0;c[20300]=n;h[10127]=0.0;h[10130]=0.0;h[10131]=0.0;p=c[b>>2]|0;c[20248]=1;if((p|0)<1){$=0.0;aa=0.0;ba=0.0}else{P=0.0;U=0.0;O=0.0;D=1;while(1){Z=+h[o+(D+ -1<<3)>>3];ca=O+Z*Z;h[10127]=ca;e=D+ -1|0;H=t+(e<<3)|0;da=U+ +h[o+(e<<3)>>3]*+h[H>>3];h[10130]=da;Z=+h[H>>3];ea=P+Z*Z;h[10131]=ea;if((D|0)<(p|0)){D=D+1|0;O=ca;U=da;P=ea}else{break}}c[20248]=p+1;$=da;aa=ea;ba=ca}P=ba*aa-$*$;h[10144]=P;if(P<=ba*1.0e-8*aa){ga=88;break}U=+V(+P);h[10149]=U;D=c[b>>2]|0;c[20248]=1;if((D|0)>=1){P=U;U=$;O=ba;g=1;H=0;while(1){e=t+(H<<3)|0;h[e>>3]=(O*+h[e>>3]-U*+h[o+(H<<3)>>3])/P;h[u+(g+ -1<<3)>>3]=0.0;if((g|0)>=(D|0)){break}e=g;P=+h[10149];U=+h[10130];O=+h[10127];g=g+1|0;H=e}c[20248]=D+1}H=c[d>>2]|0;c[20252]=1;if((H|0)>=1){g=1;while(1){h[10142]=0.0;p=c[b>>2]|0;c[20250]=1;if((p|0)<1){ha=0.0}else{O=0.0;e=1;while(1){U=+h[f+((fa(e,w)|0)+x+g<<3)>>3];ia=O+U*+h[t+(e+ -1<<3)>>3];h[10142]=ia;if((e|0)<(p|0)){e=e+1|0;O=ia}else{break}}c[20250]=p+1;ha=ia}O=+h[q+(g+ -1<<3)>>3]*ha;h[10142]=O;e=c[b>>2]|0;c[20248]=1;if((e|0)>=1){U=O;l=1;while(1){O=U*+h[f+((fa(l,w)|0)+x+g<<3)>>3];y=u+(l+ -1<<3)|0;h[y>>3]=+h[y>>3]+O;if((l|0)>=(e|0)){break}U=+h[10142];l=l+1|0}c[20248]=e+1}l=g+1|0;c[20252]=l;if((g|0)<(H|0)){g=l}else{break}}}h[10132]=0.0;h[10133]=0.0;h[10134]=0.0;h[10135]=0.0;h[10136]=0.0;g=c[b>>2]|0;c[20248]=1;if((g|0)<1){ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0}else{U=0.0;O=0.0;P=0.0;Z=0.0;W=0.0;H=1;while(1){D=H+ -1|0;oa=W+ +h[t+(D<<3)>>3]*+h[u+(D<<3)>>3];h[10132]=oa;D=H+ -1|0;l=o+(D<<3)|0;p=r+(D<<3)|0;pa=Z+ +h[l>>3]*+h[p>>3];h[10133]=pa;y=t+(D<<3)|0;qa=P+ +h[y>>3]*+h[p>>3];h[10134]=qa;p=s+(D<<3)|0;ra=O+ +h[l>>3]*+h[p>>3];h[10135]=ra;sa=U+ +h[y>>3]*+h[p>>3];h[10136]=sa;if((H|0)<(g|0)){H=H+1|0;W=oa;Z=pa;P=qa;O=ra;U=sa}else{break}}c[20248]=g+1;ja=sa;ka=qa;la=pa;ma=ra;na=oa}U=+h[10143];O=U*na;h[10132]=O;P=U*ma-O;h[10135]=P;Z=O+la+P;h[10156]=Z;h[10158]=Z;h[10157]=Z;c[20302]=0;a[81032]=1;W=+h[10155]/50.0;h[10144]=W;c[20248]=1;H=0;Q=Z;S=Z;p=1;while(1){ta=+(p|0)*W;ua=+X(+ta);va=+Y(+ta);wa=O+ua*(la+ua*P)+va*(ka+ua*ja);if(!(wa>=0.0)){xa=-wa}else{xa=wa}if(!(Q>=0.0)){ya=-Q}else{ya=Q}do{if(xa>ya){h[10158]=wa;c[20302]=p;h[10153]=S;za=p;Aa=wa}else{if((p|0)!=(H+1|0)){za=H;Aa=Q;break}h[10154]=wa;za=H;Aa=Q}}while(0);e=p+1|0;if((e|0)<50){H=za;Q=Aa;p=e;S=wa}else{break}}h[10147]=ta;h[10138]=ua;h[10141]=va;h[10140]=wa;c[20248]=50;h[10157]=wa;if((za|0)==49){h[10154]=Z;Ba=Z}else if((za|0)==0){h[10153]=wa;ga=74}else{ga=74}if((ga|0)==74){ga=0;Ba=+h[10154]}h[10145]=0.0;S=+h[10153];if(S!=Ba){Q=S-Aa;h[10153]=Q;S=Ba-Aa;h[10154]=S;T=U*(Q-S)/(Q+S);h[10145]=T;Ca=T}else{Ca=0.0}T=W*(+(za|0)+Ca);h[10147]=T;S=+X(+T);h[10138]=S;Q=+Y(+T);h[10141]=Q;T=O+S*(la+S*P)+Q*(ka+S*ja);h[10140]=T;p=c[b>>2]|0;c[20248]=1;if((p|0)<1){Da=T}else{T=Q;Q=S;H=1;g=0;while(1){e=o+(g<<3)|0;h[e>>3]=Q*+h[e>>3]+T*+h[t+(g<<3)>>3];e=H+ -1|0;y=s+(e<<3)|0;S=+h[10138]*+h[y>>3]+ +h[10141]*+h[u+(e<<3)>>3];h[y>>3]=S;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+S;if((H|0)>=(p|0)){break}e=H;T=+h[10141];Q=+h[10138];H=H+1|0;g=e}c[20248]=p+1;Da=+h[10140]}if(!(Da>=0.0)){Ea=-Da}else{Ea=Da}Q=+h[10156];if(!(Q>=0.0)){Fa=-Q}else{Fa=Q}if(Ea<=Fa*1.1){ga=88;break}if((n|0)<(c[b>>2]|0)){_=n}else{ga=88;break}}if((ga|0)==88){i=v;return 0}return 0}function R3(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;n=i;a[81488]=1;a[81480]=1;c[81500>>2]=6;mla(81496)|0;e=c[d>>2]|0;c[20368]=1;if((e|0)>=1){d=1;do{Dka(81616,b+(d+ -1)|0,1)|0;o=c[20368]|0;d=o+1|0;c[20368]=d;}while((o|0)<(e|0))}Wka()|0;e=c[g>>2]|0;if((e|0)==1){c[81524>>2]=a[81480]&1?6:0;mla(81520)|0;Dka(81616,h,4)|0;Wka()|0;p=c[g>>2]|0}else{p=e}if((p|0)==2){c[81548>>2]=a[81480]&1?6:0;mla(81544)|0;Dka(81616,h,4)|0;Dka(81616,j,4)|0;Wka()|0}j=c[k>>2]|0;if((j|0)==1){c[81572>>2]=a[81480]&1?6:0;mla(81568)|0;Dka(81616,l,8)|0;Wka()|0;q=c[k>>2]|0}else{q=j}if((q|0)==2){c[81596>>2]=a[81480]&1?6:0;mla(81592)|0;Dka(81616,l,8)|0;Dka(81616,m,8)|0;Wka()|0}if((c[f>>2]|0)==2){lka(81624,0)|0}else{i=n;return 0}return 0}function S3(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0;y=i;i=i+8|0;z=y;A=c[k>>2]|0;a:do{if((A|0)==0){c[20410]=2;B=2;while(1){C=B+1|0;if(!((c[k+(B+ -1<<2)>>2]|0)>>>0<2)){D=210;break a}c[20410]=C;if((C|0)<12){B=C}else{break}}if((c[d>>2]|0)<1){ska(81696,83392,80,25);B=82e3;C=82008;R3(81696,83424,82176,B,82080,d,B,B,C,C,80)|0;break}c[20474]=5;C=q+8|0;do{if((c[k+32>>2]|0)==0){E=5}else{B=c[C>>2]|0;c[20474]=B;if(!((B+ -1|0)>>>0>4)){E=B;break}ska(81696,83432,80,34);B=82e3;F=82008;R3(81696,83472,82168,B,82080,81896,B,B,F,F,80)|0;break a}}while(0);c[C>>2]=E;b:do{if((c[k+20>>2]|0)==0){F=c[d>>2]|0;B=fa(F,F)|0;c[20460]=B;c[20472]=B+50+(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0);B=q+12|0;if((c[k+16>>2]|0)==0){c[B>>2]=2;break}else{c[B>>2]=1;break}}else{B=c[q>>2]|0;do{if((B|0)>=0){F=c[d>>2]|0;if((B|0)>=(F|0)){break}G=q+4|0;H=c[G>>2]|0;if(!((H|0)>-1&(H|0)<(F|0))){ska(81696,84256,80,52);I=82e3;J=82008;R3(81696,84240,84312,I,82080,G,I,I,J,J,80)|0;break a}c[20460]=fa((B<<1|1)+H|0,F)|0;F=q+12|0;if((c[k+16>>2]|0)==0){c[F>>2]=5;H=c[d>>2]|0;J=fa((c[C>>2]|0)+4|0,H)|0;c[20472]=(((H|0)/((c[q>>2]|0)+1+(c[G>>2]|0)|0)|0)<<1)+52+(c[20460]|0)+J;break b}else{c[F>>2]=4;F=(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0)+50|0;c[20472]=F+(c[20460]|0);break b}}}while(0);ska(81696,84184,80,52);B=82e3;F=82008;R3(81696,84240,84248,B,82080,q,B,B,F,F,80)|0;break a}}while(0);c[20464]=(c[d>>2]|0)+20;c[q+64>>2]=c[20460];if((c[p>>2]|0)<(c[20472]|0)){ska(81696,83480,80,60);C=82e3;F=82008;R3(81696,83544,83552,C,82176,81888,p,C,F,F,80)|0;break}if((c[r>>2]|0)<(c[20464]|0)){ska(81696,83560,80,60);F=82e3;C=82008;R3(81696,83544,83624,F,82176,81856,r,F,C,C,80)|0;break}if(+h[j>>3]==+h[e>>3]){D=227;break}if((c[w>>2]|0)<0){ska(81696,84368,80,24);C=82080;F=82e3;B=82008;R3(81696,84400,84408,C,C,w,F,F,B,B,80)|0;break}do{if((c[k+24>>2]|0)!=0){K=+h[o+8>>3];h[10227]=K;if(!(K<=0.0)){break}ska(81696,83864,80,28);B=82e3;R3(81696,82576,83896,B,B,B,B,82080,81816,82008,80)|0;break a}}while(0);c[q+60>>2]=0;B=q+36|0;c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[B+12>>2]=0;c[n>>2]=1;D=27}else if((A|0)==1){c[q+36>>2]=c[q+40>>2];D=27}else if((A|0)==-1){ska(81696,81928,80,49);B=82e3;F=82008;R3(81696,81984,81992,B,B,B,B,B,F,F,80)|0;ska(81696,82016,80,47);F=82e3;B=82008;R3(81696,82064,82072,F,82080,n,F,F,B,B,80)|0;ska(81696,82088,80,41);B=82e3;F=82008;R3(81696,82136,82144,82080,B,B,B,B,F,F,80)|0;i=y;return 0}else{D=210}}while(0);c:do{if((D|0)==27){a[81872]=0;K=+h[l>>3];h[10238]=K;L=+h[m>>3];h[10231]=L;A=c[d>>2]|0;c[20410]=1;do{if((A|0)>=1){r=k+4|0;p=0;E=1;M=L;N=K;while(1){if((c[r>>2]|0)==1){F=E+ -1|0;O=+h[l+(F<<3)>>3];h[10238]=O;P=+h[m+(F<<3)>>3];h[10231]=P;Q=O;R=P}else{Q=N;R=M}if(Q>0.0|R>0.0){a[81872]=1;S=1}else{S=p}if(Q<0.0){D=215;break}if(R<0.0){D=216;break}F=E+1|0;c[20410]=F;if((E|0)<(A|0)){p=S;E=F;M=R;N=Q}else{D=36;break}}if((D|0)==36){if(!S){break}E=c[d>>2]|0;p=E+51|0;c[20420]=p;r=p+(c[w>>2]|0)|0;c[20422]=r;p=r+(c[w>>2]|0)|0;c[20444]=p;F=p+(c[w>>2]|0)|0;c[20414]=F;B=F+(c[d>>2]|0)|0;c[20450]=B;C=B+(c[d>>2]|0)|0;c[20456]=C;c[20446]=(fa((c[q+8>>2]|0)+1|0,c[d>>2]|0)|0)+C;c[20470]=(c[q+64>>2]|0)+1;d:do{if((c[k>>2]|0)==1){B=o+64|0;h[10240]=+h[B>>3];a[81808]=0;h[10209]=+h[o+24>>3];J=o+16|0;h[10204]=+h[J>>3];do{if((c[w>>2]|0)!=0){T3(82176,v,w,d,81672,j,f,o+(F+ -1<<3)|0,o+(C+ -1<<3)|0,o+224|0,q+28|0,o+(E+50<<3)|0,o+(r+ -1<<3)|0,o+(p+ -1<<3)|0,x,81792,B,0,o,q,s,t)|0;if((c[20540]|0)>0){i=y;return 0}if((c[20448]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];G=82080;o4(d,o+((c[20414]|0)+ -1<<3)|0,G,g,G)|0;a[81808]=1;D=197;break d}}while(0);do{if((c[k+24>>2]|0)!=0){N=+h[10204];if(!(N>=0.0)){T=-N}else{T=N}M=T/+h[o+8>>3];if(!(M>1.0)){break}h[10204]=N/M}}while(0);M=+h[e>>3];N=+h[j>>3];if(M==N){D=227;break c}P=+h[10204];if((M-N)*P>0.0){D=220;break}B=(c[k+8>>2]|0)==1;do{if((c[k+12>>2]|0)==1){O=+h[o>>3];h[10239]=O;U=+h[10209];V=U-O;G=V*P>0.0;do{if(B){if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U- +h[e>>3])<=0.0){break}H=q+28|0;I=o+((c[20456]|0)+ -1<<3)|0;X=o+224|0;if(P*(U-W)>0.0){Y3(81672,j,f,g,d,H,I,X)|0;if((c[20540]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[81808]=1;D=197;break d}}else{Y=81672;Y3(Y,Y,f,g,d,H,I,X)|0;if((c[20540]|0)>0){i=y;return 0}else{h[e>>3]=+h[10209];c[n>>2]=1;a[81808]=1;D=197;break d}}}else{if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U-W)<0.0){break}Y3(81672,j,f,g,d,q+28|0,o+((c[20456]|0)+ -1<<3)|0,o+224|0)|0;if((c[20540]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[81808]=1;D=197;break d}}}while(0);h[z>>3]=V;if(!(V>=0.0)){Z=-V}else{Z=V}if(!(U>=0.0)){_=-U}else{_=U}if(!(P>=0.0)){$=-P}else{$=P}if(Z>+h[10240]*100.0*(_+$)){if(P*(U+P-O)<=0.0){break}W=O-U;h[10204]=W;h[J>>3]=W;break}Y3(81672,81912,f,g,d,q+28|0,o+((c[20456]|0)+ -1<<3)|0,o+224|0)|0;if((c[20540]|0)>0){i=y;return 0}else{c[n>>2]=2;h[e>>3]=+h[10239];a[81808]=1;D=197;break d}}else{W=+h[10209];if(!B){if(P*(W-N)<0.0){break}Y3(81672,j,f,g,d,q+28|0,o+((c[20456]|0)+ -1<<3)|0,o+224|0)|0;if((c[20540]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[81808]=1;D=197;break d}}if(P*(W-M)<=0.0){break}G=q+28|0;X=o+((c[20456]|0)+ -1<<3)|0;I=o+224|0;if(P*(W-N)>0.0){Y3(81672,j,f,g,d,G,X,I)|0;if((c[20540]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[81808]=1;D=197;break d}}else{H=81672;Y3(H,H,f,g,d,G,X,I)|0;if((c[20540]|0)>0){i=y;return 0}else{h[e>>3]=+h[10209];c[n>>2]=1;a[81808]=1;D=197;break d}}}}while(0);if(a[81808]&1){D=197}else{D=128}}else{h[10209]=+h[e>>3];c[n>>2]=1;V3(d,k+4|0,l,m,f,o+((c[20450]|0)+ -1<<3)|0,s,t)|0;B=c[d>>2]|0;c[20410]=1;e:do{if((B|0)>=1){J=c[20450]|0;I=1;while(1){X=I+1|0;if(+h[o+(I+ -2+J<<3)>>3]<=0.0){break}c[20410]=X;if((I|0)<(B|0)){I=X}else{break e}}ska(81696,84e3,80,39);I=82e3;J=82008;R3(81696,83672,84040,I,I,I,I,I,J,J,80)|0;break c}}while(0);U=+a4(82152,1);h[10240]=U;B=o+64|0;h[B>>3]=U;U=+h[e>>3];if(!(U>=0.0)){aa=-U}else{aa=U}h[z>>3]=aa;U=+h[j>>3];if(!(U>=0.0)){ba=-U}else{ba=U}U=+h[10240]*4.0*(aa>=ba?aa:ba);h[10229]=U;O=+h[j>>3]- +h[e>>3];h[z>>3]=O;if(!(O>=0.0)){ca=-O}else{ca=O}if(ca<U){ska(81696,84048,80,60);J=82e3;R3(81696,83544,84112,J,J,J,J,82176,j,e,80)|0;break c}do{if((c[k+28>>2]|0)==0){h[10208]=ca*.001;U=+W3(d,g,o+((c[20450]|0)+ -1<<3)|0,s,t);if(U>.5/+h[10208]){h[10208]=.5/U}h[z>>3]=+h[j>>3]- +h[e>>3];U=+pka(81664,z);h[10208]=U;da=U}else{U=+h[o+16>>3];h[10208]=U;if(U*(+h[j>>3]- +h[e>>3])<0.0){D=220;break d}if(!(U==0.0)){da=U;break}ska(81696,83952,80,29);J=82e3;I=82008;R3(81696,83984,83992,J,J,J,J,J,I,I,80)|0;break c}}while(0);do{if((c[k+24>>2]|0)==0){ea=da}else{if(!(da>=0.0)){ga=-da}else{ga=da}U=ga/+h[o+8>>3];if(!(U>1.0)){ea=da;break}O=da/U;h[10208]=O;ea=O}}while(0);if((c[k+12>>2]|0)==0){ha=ea}else{O=+h[o>>3];h[10239]=O;U=+h[e>>3];V=O-U;if(V*ea<0.0){D=224;break}if(ea*(U+ea-O)>0.0){h[10208]=V;ia=V}else{ia=ea}if((O- +h[j>>3])*ia<0.0){D=218;break}else{ha=ia}}I=k+40|0;if((c[I>>2]|0)==0){ja=ha}else{X3(81672,f,g,d,b,u,81664,o+((c[20450]|0)+ -1<<3)|0,n,s,t,o+((c[20456]|0)+ -1<<3)|0,o+400|0,o+((c[20414]|0)+ -1<<3)|0,o+((c[20446]|0)+ -1<<3)|0,q,81832,B,k+36|0,81880)|0;if((c[20540]|0)>0){i=y;return 0}J=c[n>>2]|0;if((J|0)<0){ka=J;D=129;break}ja=+h[10208]}h[10204]=ja;h[o+16>>3]=ja;J=c[20456]|0;X=(c[d>>2]|0)+J|0;c[20466]=X;G=c[d>>2]|0;c[20410]=1;if((G|0)>=1){H=1;while(1){h[o+(H+ -2+J<<3)>>3]=+h[f+(H+ -1<<3)>>3];h[o+(H+ -2+X<<3)>>3]=+h[10204]*+h[g+(H+ -1<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[20410]=G+1}H=o+320|0;h[H>>3]=+h[e>>3];X=q+68|0;c[X>>2]=0;J=o+224|0;h[J>>3]=+h[10204];h[o+232>>3]=+h[10204]*2.0;Y=q+28|0;c[Y>>2]=1;if((c[w>>2]|0)==0){D=128;break}T3(82080,v,w,d,e,j,f,o+((c[20414]|0)+ -1<<3)|0,o+((c[20456]|0)+ -1<<3)|0,J,Y,o+((c[20420]|0)+ -1<<3)|0,o+((c[20422]|0)+ -1<<3)|0,o+((c[20444]|0)+ -1<<3)|0,x,81792,B,0,o,q,s,t)|0;if((c[20540]|0)>0){i=y;return 0}if((c[20448]|0)!=0){ska(81696,84416,80,47);la=82e3;ma=82008;R3(81696,82064,84464,82080,la,la,la,la,ma,ma,80)|0;ska(81696,84472,80,38);ma=82e3;la=82008;R3(81696,82224,84464,82080,ma,ma,ma,ma,la,la,80)|0;break c}if((c[w>>2]|0)==0){D=128;break}if((c[I>>2]|0)==0){D=128;break}T3(82168,v,w,d,81672,j,f,o+((c[20414]|0)+ -1<<3)|0,o+((c[20456]|0)+ -1<<3)|0,J,Y,o+((c[20420]|0)+ -1<<3)|0,o+((c[20422]|0)+ -1<<3)|0,o+((c[20444]|0)+ -1<<3)|0,x,81792,B,0,o,q,s,t)|0;if((c[20540]|0)>0){i=y;return 0}if((c[20448]|0)!=1){D=128;break}c[X>>2]=1;c[n>>2]=4;h[e>>3]=+h[H>>3];H=82080;o4(d,o+((c[20414]|0)+ -1<<3)|0,H,g,H)|0;D=197}}while(0);if((D|0)==218){ska(81696,83792,80,54);p=82e3;R3(81696,83848,83856,p,p,p,p,82176,81912,j,80)|0;break c}else if((D|0)==220){ska(81696,83904,80,34);p=82e3;R3(81696,83472,83944,p,p,p,p,82176,j,e,80)|0;break c}else if((D|0)==224){ska(81696,84120,80,49);p=82e3;R3(81696,81984,84176,p,p,p,p,82176,81912,e,80)|0;break c}f:while(1){if((D|0)==128){D=0;ka=c[n>>2]|0;D=129;continue}else if((D|0)==129){D=0;if((ka|0)==-12){na=-12;break}if(((c[q+40>>2]|0)-(c[q+36>>2]|0)|0)>=500){D=131;break}oa=k+4|0;V3(d,oa,l,m,o+((c[20456]|0)+ -1<<3)|0,o+((c[20450]|0)+ -1<<3)|0,s,t)|0;if((c[20540]|0)>0){D=233;break}p=c[d>>2]|0;c[20410]=1;r=c[20450]|0;if((p|0)>=1){E=1;while(1){C=E+1|0;if(!(+h[o+(E+ -2+r<<3)>>3]>0.0)){D=136;break f}c[20410]=C;if((E|0)<(p|0)){E=C}else{break}}}O=+W3(d,o+((c[20456]|0)+ -1<<3)|0,o+(r+ -1<<3)|0,s,t)*100.0;V=+h[10240];pa=O*V;h[10206]=pa;if(!(pa<=1.0)){D=138;break}O=+h[10209];if(!(O>=0.0)){qa=-O}else{qa=O}h[z>>3]=qa;O=+h[j>>3];if(!(O>=0.0)){ra=-O}else{ra=O}h[10229]=V*4.0*(qa>=ra?qa:ra);do{if((c[k+24>>2]|0)!=0){V=+h[10204];if(!(V>=0.0)){sa=-V}else{sa=V}O=sa/+h[o+8>>3];if(!(O>1.0)){break}h[10204]=V/O}}while(0);Z3(81672,f,g,d,b,u,81632,o+((c[20450]|0)+ -1<<3)|0,k,n,s,t,o+((c[20456]|0)+ -1<<3)|0,o+400|0,o+((c[20414]|0)+ -1<<3)|0,o+((c[20446]|0)+ -1<<3)|0,q,o+80|0,o+128|0,o+176|0,o+224|0,o+272|0,o+32|0,o+40|0,o+48|0,o+56|0,81832,o+64|0,q+20|0,q+16|0,q+24|0,q+28|0,q+32|0,k+36|0,81880)|0;if((c[20540]|0)>0){D=233;break}r=c[n>>2]|0;if((r|0)<0){na=r;break}do{if((c[w>>2]|0)!=0){T3(82168,v,w,d,81672,j,f,o+((c[20414]|0)+ -1<<3)|0,o+((c[20456]|0)+ -1<<3)|0,o+224|0,q+28|0,o+((c[20420]|0)+ -1<<3)|0,o+((c[20422]|0)+ -1<<3)|0,o+((c[20444]|0)+ -1<<3)|0,x,81792,o+64|0,0,o,q,s,t)|0;if((c[20540]|0)>0){D=233;break f}if((c[20448]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];r=82080;o4(d,o+((c[20414]|0)+ -1<<3)|0,r,g,r)|0;D=197;continue f}}while(0);r=(c[k+8>>2]|0)!=0;O=+h[10209];V=+h[10204];U=(O- +h[j>>3])*V;if((c[k+12>>2]|0)==0){if(!r){if(U<0.0){D=128;continue}Y3(81672,j,f,g,d,q+28|0,o+((c[20456]|0)+ -1<<3)|0,o+224|0)|0;if((c[20540]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(!(U>=0.0)){h[e>>3]=O;c[n>>2]=1;D=197;continue}Y3(81672,j,f,g,d,q+28|0,o+((c[20456]|0)+ -1<<3)|0,o+224|0)|0;if((c[20540]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(r){if(U>=0.0){Y3(81672,j,f,g,d,q+28|0,o+((c[20456]|0)+ -1<<3)|0,o+224|0)|0;if((c[20540]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}N=O- +h[10239];h[z>>3]=N;if(!(N>=0.0)){ta=-N}else{ta=N}if(!(O>=0.0)){ua=-O}else{ua=O}if(!(V>=0.0)){va=-V}else{va=V}if(!(ta<=+h[10240]*100.0*(ua+va))){h[e>>3]=O;c[n>>2]=1;D=197;continue}Y3(81672,81912,f,g,d,q+28|0,o+((c[20456]|0)+ -1<<3)|0,o+224|0)|0;if((c[20540]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[10239];D=197;continue}if(!(U<0.0)){Y3(81672,j,f,g,d,q+28|0,o+((c[20456]|0)+ -1<<3)|0,o+224|0)|0;if((c[20540]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}U=+h[10239];N=O-U;h[z>>3]=N;if(!(N>=0.0)){wa=-N}else{wa=N}if(!(O>=0.0)){xa=-O}else{xa=O}if(!(V>=0.0)){ya=-V}else{ya=V}if(!(wa<=+h[10240]*100.0*(xa+ya))){if(V*(O+V-U)<=0.0){D=128;continue}h[10204]=U-O;D=128;continue}else{Y3(81672,81912,f,g,d,q+28|0,o+((c[20456]|0)+ -1<<3)|0,o+224|0)|0;if((c[20540]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[10239];D=197;continue}}else if((D|0)==197){D=0;h[o+24>>3]=+h[10209];h[o+16>>3]=+h[10204];h[o+328>>3]=+h[e>>3];D=233;break}}do{if((D|0)==131){c[n>>2]=-1;na=-1}else if((D|0)==136){c[n>>2]=-3;na=-3}else if((D|0)==138){if((c[oa>>2]|0)!=1){h[l>>3]=pa*+h[l>>3];h[m>>3]=+h[10206]*+h[m>>3];c[n>>2]=-2;na=-2;break}r=c[d>>2]|0;c[20410]=1;if((r|0)>=1){O=pa;E=1;p=0;while(1){B=l+(p<<3)|0;h[B>>3]=O*+h[B>>3];B=m+(E+ -1<<3)|0;h[B>>3]=+h[10206]*+h[B>>3];if((E|0)>=(r|0)){break}B=E;O=+h[10206];E=E+1|0;p=B}c[20410]=r+1}c[n>>2]=-2;na=-2}else if((D|0)==233){i=y;return 0}}while(0);p=0-na|0;c[20466]=p;switch(p|0){case 9:{ska(81696,82592,80,44);p=82e3;R3(81696,82640,82912,p,p,p,p,82176,81672,81632,80)|0;ska(81696,82920,80,49);p=82e3;E=82008;R3(81696,81984,82976,p,p,p,p,p,E,E,80)|0;ska(81696,82984,80,38);E=82e3;p=82008;R3(81696,82224,83024,E,E,E,E,E,p,p,80)|0;break};case 10:{ska(81696,82592,80,44);p=82e3;R3(81696,82640,83032,p,p,p,p,82176,81672,81632,80)|0;ska(81696,83040,80,45);p=82e3;E=82008;R3(81696,82480,83088,p,p,p,p,p,E,E,80)|0;ska(81696,83096,80,36);E=82e3;p=82008;R3(81696,83136,83144,E,E,E,E,E,p,p,80)|0;break};case 11:{ska(81696,83152,80,40);p=82e3;R3(81696,83200,83208,p,p,p,p,82176,81672,81632,80)|0;ska(81696,83216,80,36);p=82e3;E=82008;R3(81696,83136,83256,p,p,p,p,p,E,E,80)|0;break};case 12:{ska(81696,82592,80,44);E=82e3;R3(81696,82640,83264,E,E,E,E,82176,81672,81664,80)|0;ska(81696,83272,80,45);E=82e3;p=82008;R3(81696,82480,83320,E,E,E,E,E,p,p,80)|0;break};case 5:case 4:{break};case 2:{ska(81696,82312,80,47);p=82e3;R3(81696,82064,82360,p,p,p,p,82080,81672,82008,80)|0;ska(81696,82368,80,48);p=82e3;E=82008;R3(81696,82296,82424,p,p,p,p,p,E,E,80)|0;ska(81696,82432,80,45);E=82e3;p=82008;R3(81696,82480,82488,E,E,E,E,E,p,p,80)|0;break};case 3:{ska(81696,82496,80,38);p=82e3;R3(81696,82224,82536,p,p,p,p,82080,81672,82008,80)|0;ska(81696,82544,80,28);p=82e3;E=82008;R3(81696,82576,82584,p,p,p,p,p,E,E,80)|0;break};case 6:{ska(81696,82592,80,44);E=82e3;R3(81696,82640,82648,E,E,E,E,82176,81672,81632,80)|0;ska(81696,82656,80,57);E=82e3;p=82008;R3(81696,82720,82728,E,E,E,E,E,p,p,80)|0;break};case 7:{ska(81696,82592,80,44);p=82e3;R3(81696,82640,82736,p,p,p,p,82176,81672,81632,80)|0;ska(81696,82744,80,48);p=82e3;E=82008;R3(81696,82296,82800,p,p,p,p,p,E,E,80)|0;ska(81696,82808,80,28);E=82e3;p=82008;R3(81696,82576,82840,E,E,E,E,E,p,p,80)|0;break};case 8:{ska(81696,82592,80,44);p=82e3;R3(81696,82640,82848,p,p,p,p,82176,81672,81632,80)|0;ska(81696,82856,80,37);p=82e3;E=82008;R3(81696,82896,82904,p,p,p,p,p,E,E,80)|0;break};default:{ska(81696,82184,80,38);E=82e3;R3(81696,82224,82232,E,E,E,E,82080,81672,82008,80)|0;ska(81696,82240,80,48);E=82e3;p=82008;R3(81696,82296,82304,E,E,E,E,E,p,p,80)|0}}c[k>>2]=-1;h[e>>3]=+h[10209];h[o+24>>3]=+h[10209];h[o+16>>3]=+h[10204];i=y;return 0}else if((D|0)==215){ska(81696,83632,80,39);p=82e3;E=82008;R3(81696,83672,83680,p,p,p,p,p,E,E,80)|0;break c}else if((D|0)==216){ska(81696,83688,80,39);E=82e3;p=82008;R3(81696,83672,83728,E,E,E,E,E,p,p,80)|0;break c}}}while(0);ska(81696,83736,80,47);A=82e3;p=82008;R3(81696,82064,83784,A,A,A,A,A,p,p,80)|0}else if((D|0)==210){ska(81696,83328,80,55);p=82e3;A=82008;R3(81696,83384,82080,p,p,p,p,p,A,A,80)|0}}while(0);if((D|0)==227){ska(81696,84320,80,39);D=82e3;R3(81696,83672,84360,D,D,D,D,82176,j,e,80)|0}if((c[k>>2]|0)==-1){ska(81696,84512,80,46);e=82e3;j=82008;R3(81696,84560,84568,e,e,e,e,e,j,j,80)|0;ska(81696,84576,80,47);j=82e3;e=82008;R3(81696,82064,84624,82080,j,j,j,j,e,e,80)|0;i=y;return 0}else{c[k>>2]=-1;c[n>>2]=-33;i=y;return 0}return 0}function T3(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;var A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0.0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0;v=i;A=c[f>>2]|0;B=~A;C=+h[n>>3];h[10579]=C;c[t>>2]=0;D=c[e>>2]|0;c[21160]=1;if((D|0)>=1){E=1;do{c[s+(E+ -1<<2)>>2]=0;F=c[21160]|0;E=F+1|0;c[21160]=E;}while((F|0)<(D|0))}G=+h[g>>3];if(!(G>=0.0)){H=-G}else{H=G}if(!(C>=0.0)){I=-C}else{I=C}h[10586]=(H+I)*+h[u>>3]*100.0;u=c[b>>2]|0;do{if((u|0)==3){J=C;K=+h[g>>3]}else if((u|0)==2){do{if((c[x+68>>2]|0)!=0){b=w+320|0;Y3(g,b,k,l,f,o,m,n)|0;if((c[20540]|0)>0){i=v;return 0}D=d;Vd[D&7](f,b,k,e,p,y,z)|0;if((c[20540]|0)>0){i=v;return 0}E=x+60|0;c[E>>2]=(c[E>>2]|0)+1;a[84696]=0;F=c[e>>2]|0;c[21160]=1;if((F|0)<1){break}else{L=0;M=1}while(1){I=+h[p+(M+ -1<<3)>>3];if(!(I>=0.0)){N=-I}else{N=I}if(!(N<=0.0)){O=L}else{a[84696]=1;O=1}if((M|0)<(F|0)){L=O;M=M+1|0}else{break}}c[21160]=F+1;if(!O){break}I=+pka(84688,84632);h[10583]=I;H=I+ +h[b>>3];h[b>>3]=H;I=+h[10579];do{if((H- +h[g>>3])*I<0.0){Y3(g,b,k,l,f,o,m,n)|0;if((c[20540]|0)<=0){break}i=v;return 0}else{G=+h[10583]/I;h[10584]=G;P=c[f>>2]|0;c[21160]=1;if((P|0)<1){break}Q=(A<<1)+B|0;R=G;S=1;while(1){T=k+(S+ -1<<3)|0;h[T>>3]=+h[T>>3]+R*+h[m+(Q+S<<3)>>3];if((S|0)>=(P|0)){break}R=+h[10584];S=S+1|0}c[21160]=P+1}}while(0);Vd[D&7](f,b,k,e,p,y,z)|0;if((c[20540]|0)>0){i=v;return 0}c[E>>2]=(c[E>>2]|0)+1;a[84696]=0;F=c[e>>2]|0;c[21160]=1;if((F|0)<1){break}else{U=0;V=1}while(1){S=V+ -1|0;I=+h[p+(S<<3)>>3];if(!(I>=0.0)){W=-I}else{W=I}if(W>0.0){X=U;Y=V}else{c[s+(S<<2)>>2]=1;a[84696]=1;X=1;Y=c[21160]|0}S=Y+1|0;c[21160]=S;if((Y|0)<(F|0)){U=X;V=S}else{break}}if(!X){break}c[t>>2]=1;i=v;return 0}}while(0);I=+h[g>>3];if(I==+h[w+328>>3]){i=v;return 0}else{J=+h[10579];K=I;break}}else{F=w+320|0;Y3(g,F,k,l,f,o,m,n)|0;if((c[20540]|0)>0){i=v;return 0}E=d;Vd[E&7](f,F,k,e,p,y,z)|0;if((c[20540]|0)>0){i=v;return 0}b=x+60|0;c[b>>2]=1;a[84696]=0;D=c[e>>2]|0;c[21160]=1;if((D|0)<1){i=v;return 0}else{Z=0;_=1}while(1){I=+h[p+(_+ -1<<3)>>3];if(!(I>=0.0)){$=-I}else{$=I}if(!($<=0.0)){aa=Z}else{a[84696]=1;aa=1}if((_|0)<(D|0)){Z=aa;_=_+1|0}else{break}}c[21160]=D+1;if(!aa){i=v;return 0}I=+pka(84688,84632);h[10583]=I;h[F>>3]=I+ +h[F>>3];I=+h[10583]/+h[10579];h[10584]=I;S=c[f>>2]|0;c[21160]=1;if((S|0)>=1){Q=(A<<1)+B|0;H=I;T=1;while(1){ba=k+(T+ -1<<3)|0;h[ba>>3]=+h[ba>>3]+H*+h[m+(Q+T<<3)>>3];if((T|0)>=(S|0)){break}H=+h[10584];T=T+1|0}c[21160]=S+1}Vd[E&7](f,F,k,e,p,y,z)|0;if((c[20540]|0)>0){i=v;return 0}c[b>>2]=(c[b>>2]|0)+1;a[84696]=0;T=c[e>>2]|0;c[21160]=1;if((T|0)<1){i=v;return 0}else{ca=0;da=1}while(1){H=+h[p+(da+ -1<<3)>>3];if(!(H>=0.0)){ea=-H}else{ea=H}if(!(ea<=0.0)){fa=ca}else{a[84696]=1;fa=1}if((da|0)<(T|0)){ca=fa;da=da+1|0}else{break}}c[21160]=T+1;if(!fa){i=v;return 0}c[t>>2]=-1;i=v;return 0}}while(0);ea=+h[j>>3];do{if(!((ea-K)*J>=0.0)){h[10582]=ea;if((ea- +h[w+320>>3])*J<=0.0){i=v;return 0}Y3(g,84656,k,l,f,o,m,n)|0;if((c[20540]|0)<=0){break}i=v;return 0}else{h[10582]=K;j=c[f>>2]|0;c[21160]=1;if((j|0)<1){break}else{ga=1}while(1){fa=ga+ -1|0;h[k+(fa<<3)>>3]=+h[m+(fa<<3)>>3];if((ga|0)<(j|0)){ga=ga+1|0}else{break}}c[21160]=j+1}}while(0);ga=d;Vd[ga&7](f,84656,k,e,q,y,z)|0;if((c[20540]|0)>0){i=v;return 0}d=x+60|0;c[d>>2]=(c[d>>2]|0)+1;c[21170]=0;T=w+320|0;fa=x+76|0;da=x+72|0;x=w+336|0;ca=w+344|0;while(1){U3(e,84688,84680,T,84656,p,q,r,84648,s,fa,da,x,ca)|0;if((c[20540]|0)>0){ha=76;break}if((c[21170]|0)>1){ha=73;break}Y3(g,84648,k,l,f,o,m,n)|0;if((c[20540]|0)>0){ha=76;break}Vd[ga&7](f,84648,k,e,r,y,z)|0;if((c[20540]|0)>0){ha=76;break}c[d>>2]=(c[d>>2]|0)+1}if((ha|0)==73){h[T>>3]=+h[10581];T=82080;o4(e,r,T,p,T)|0;if((c[21170]|0)==4){i=v;return 0}Y3(g,84648,k,l,f,o,m,n)|0;if((c[20540]|0)>0){i=v;return 0}c[t>>2]=1;i=v;return 0}else if((ha|0)==76){i=v;return 0}return 0}function U3(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;s=i;do{if((c[e>>2]|0)==1){c[21186]=c[o>>2];c[o>>2]=0;h[10589]=0.0;a[84728]=0;t=c[b>>2]|0;c[21176]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;w=+h[l+(v<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}do{if(x>0.0){w=+pka(84760,j+(v<<3)|0);if(w==+pka(84760,l+((c[21176]|0)+ -1<<3)|0)){break}y=c[21176]|0;z=y+ -1|0;w=+h[l+(z<<3)>>3];A=w/(w- +h[j+(z<<3)>>3]);if(!(A>=0.0)){B=-A}else{B=A}if(B<=+h[10589]){break}h[10589]=B;c[o>>2]=y}else{a[84728]=1}}while(0);v=c[21176]|0;u=v+1|0;c[21176]=u;}while((v|0)<(t|0))}do{if((c[o>>2]|0)>0){a[84736]=1;c[21188]=c[p>>2];h[g>>3]=+h[r>>3];t=82080;o4(b,l,t,k,t)|0;c[p>>2]=1;a[84720]=0;C=0}else{a[84736]=0;c[o>>2]=c[21186];c[21188]=c[p>>2];if(a[84728]&1){h[g>>3]=+h[r>>3];t=82080;o4(b,l,t,k,t)|0;a[84720]=1;C=1;break}else{t=82080;o4(b,l,t,j,t)|0;h[f>>3]=+h[r>>3];c[p>>2]=0;a[84720]=0;C=0;break}}}while(0);A=+h[g>>3];w=A- +h[f>>3];if(!(w>=0.0)){D=-w}else{D=w}if(!(D<=+h[d>>3])){if(!C){break}E=+h[g>>3]}else{a[84720]=1;E=A}c[e>>2]=2;h[m>>3]=E;t=82080;o4(b,k,t,l,t)|0;t=c[b>>2]|0;c[21176]=1;if((t|0)<1){i=s;return 0}else{F=1}do{c[n+(F+ -1<<2)>>2]=0;u=(c[21176]|0)+ -1|0;A=+h[k+(u<<3)>>3];if(!(A>=0.0)){G=-A}else{G=A}do{if(G>0.0){A=+pka(84760,j+(u<<3)|0);if(!(A!=+pka(84760,k+((c[21176]|0)+ -1<<3)|0))){break}c[n+((c[21176]|0)+ -1<<2)>>2]=1}else{c[n+(u<<2)>>2]=1}}while(0);u=c[21176]|0;F=u+1|0;c[21176]=F;}while((u|0)<(t|0));i=s;return 0}else{c[o>>2]=0;h[10589]=0.0;a[84728]=0;t=c[b>>2]|0;c[21176]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;A=+h[k+(v<<3)>>3];if(!(A>=0.0)){H=-A}else{H=A}do{if(H>0.0){A=+pka(84760,j+(v<<3)|0);if(A==+pka(84760,k+((c[21176]|0)+ -1<<3)|0)){break}y=c[21176]|0;z=y+ -1|0;A=+h[k+(z<<3)>>3];w=A/(A- +h[j+(z<<3)>>3]);if(!(w>=0.0)){I=-w}else{I=w}if(I<=+h[10589]){break}h[10589]=I;c[o>>2]=y}else{a[84728]=1}}while(0);v=c[21176]|0;u=v+1|0;c[21176]=u;}while((v|0)<(t|0))}t=(c[o>>2]|0)>0;a[84736]=t&1;if(t){a[84720]=0;c[21188]=0;c[p>>2]=1;break}if(!(a[84728]&1)){t=82080;o4(b,k,t,l,t)|0;h[m>>3]=+h[g>>3];c[e>>2]=4;i=s;return 0}h[m>>3]=+h[g>>3];t=82080;o4(b,k,t,l,t)|0;t=c[b>>2]|0;c[21176]=1;if((t|0)>=1){u=1;do{c[n+(u+ -1<<2)>>2]=0;v=c[21176]|0;y=v+ -1|0;w=+h[k+(y<<3)>>3];if(!(w>=0.0)){J=-w}else{J=w}if(!(J<=0.0)){K=v}else{c[n+(y<<2)>>2]=1;K=c[21176]|0}u=K+1|0;c[21176]=u;}while((K|0)<(t|0))}c[e>>2]=3;i=s;return 0}}while(0);K=c[21188]|0;do{if((K|0)==(c[p>>2]|0)){J=+h[q>>3];if((K|0)==0){I=J*2.0;h[q>>3]=I;L=I;break}else{I=J*.5;h[q>>3]=I;L=I;break}}else{h[q>>3]=1.0;L=1.0}}while(0);I=+h[g>>3];q=(c[o>>2]|0)+ -1|0;J=+h[k+(q<<3)>>3];H=I-(I- +h[f>>3])*J/(J-L*+h[j+(q<<3)>>3]);h[r>>3]=H;L=+h[f>>3];J=H-L;if(!(J>=0.0)){M=-J}else{M=J}J=+h[d>>3];do{if(M<J){I=+h[g>>3]-L;if(!(I>=0.0)){N=-I}else{N=I}if(!(N>J*10.0)){O=H;break}G=L+I*.1;h[r>>3]=G;O=G}else{O=H}}while(0);c[e>>2]=1;h[m>>3]=O;i=s;return 0}function V3(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0.0,o=0.0,p=0.0;k=i;h[10598]=+h[d>>3];h[10597]=+h[e>>3];j=c[a>>2]|0;c[21192]=1;if((j|0)<1){i=k;return 0}else{l=1}while(1){if((c[b>>2]|0)==0){m=l+ -1|0;n=+h[10598]}else{a=l+ -1|0;o=+h[d+(a<<3)>>3];h[10598]=o;h[10597]=+h[e+(a<<3)>>3];m=a;n=o}o=+h[f+(m<<3)>>3];if(!(o>=0.0)){p=-o}else{p=o}h[g+(m<<3)>>3]=n*p+ +h[10597];a=l+1|0;c[21192]=a;if((l|0)<(j|0)){l=a}else{break}}i=k;return 0}function W3(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;f=i;h[10601]=0.0;e=c[a>>2]|0;c[21198]=1;if((e|0)<1){g=0.0;i=f;return+g}else{j=0.0;k=1}while(1){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){n=-m}else{n=m}if(n>j){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){o=-m}else{o=m}h[10601]=o;p=o}else{p=j}if((k|0)<(e|0)){j=p;k=k+1|0}else{break}}c[21198]=e+1;if(p<=0.0){g=0.0;i=f;return+g}h[10600]=0.0;e=c[a>>2]|0;c[21198]=1;if((e|0)<1){q=0.0}else{j=0.0;k=1;while(1){l=k+ -1|0;o=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3]/p;r=j+o*o;h[10600]=r;if((k|0)<(e|0)){k=k+1|0;j=r}else{break}}c[21198]=e+1;q=r}g=p*+V(+(q/+(c[a>>2]|0)));i=f;return+g}function X3(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;y=i;i=i+16|0;z=y;A=y+8|0;B=c[f>>2]|0;c[m>>2]=1;c[21216]=0;c[21214]=0;c[21220]=0;h[10613]=+h[b>>3];h[10615]=+W3(f,d,l,0,0);C=c[f>>2]|0;c[21204]=1;D=(B<<1)+~B|0;if((C|0)>=1){B=1;while(1){E=B+ -1|0;h[p+(E<<3)>>3]=+h[d+(E<<3)>>3];h[p+(D+B<<3)>>3]=+h[e+(B+ -1<<3)>>3];if((B|0)<(C|0)){B=B+1|0}else{break}}c[21204]=C+1}C=t+44|0;B=g;E=t+48|0;F=+h[k>>3];a:while(1){h[10606]=1.0/F;h[b>>3]=+h[k>>3]+ +h[b>>3];G=c[f>>2]|0;c[21204]=1;if((G|0)>=1){H=1;while(1){I=H+ -1|0;J=d+(I<<3)|0;h[J>>3]=+h[J>>3]+ +h[k>>3]*+h[e+(I<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[21204]=G+1}a[84912]=1;c[21206]=0;a[84928]=1;c[C>>2]=(c[C>>2]|0)+1;c[21224]=0;Vd[B&7](b,d,e,q,84896,n,o)|0;b:do{if((c[21224]|0)<0){K=35}else{while(1){if(a[84912]&1){c[E>>2]=(c[E>>2]|0)+1;a[84912]=0;_3(f,b,d,e,q,84848,k,84872,l,r,s,t,g,84896,v,j,n,o,x)|0;h[10605]=1.0e6;if((c[21224]|0)<0|(c[21218]|0)!=0){K=35;break b}c[21220]=0}H=c[f>>2]|0;c[21204]=1;if((H|0)>=1){I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]*.75;if((I|0)<(H|0)){I=I+1|0}else{break}}c[21204]=H+1}$3(f,q,s,t)|0;I=c[f>>2]|0;c[21204]=1;if((I|0)>=1){J=1;while(1){L=J+ -1|0;M=d+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[q+(L<<3)>>3];L=J+ -1|0;M=e+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[10606]*+h[q+(L<<3)>>3];if((J|0)<(I|0)){J=J+1|0}else{break}}c[21204]=I+1}N=+W3(f,q,l,0,0);h[10617]=N;if(N<=+h[v>>3]*100.0*+h[10615]){break}J=c[21206]|0;if((J|0)>0){h[z>>3]=N/+h[10618];h[A>>3]=1.0/+(J|0);O=+nka(z,A);if(O>.9){K=35;break b}P=O/(1.0-O);h[10605]=P;Q=+h[10617];R=P}else{h[10618]=N;Q=N;R=+h[10605]}if(R*Q<=.33){break}J=c[21206]|0;H=J+1|0;c[21206]=H;if((J|0)>8){K=35;break b}if(((H|0)%5|0|0)==0){a[84912]=1}c[C>>2]=(c[C>>2]|0)+1;c[21224]=0;Vd[B&7](b,d,e,q,84896,n,o)|0;if((c[21224]|0)<0){K=35;break b}}do{if((c[w>>2]|0)!=0){H=c[f>>2]|0;c[21204]=1;if((H|0)>=1){J=1;while(1){S=+h[d+(J+ -1<<3)>>3];h[q+(J+ -1<<3)>>3]=S<=0.0?S:0.0;if((J|0)<(H|0)){J=J+1|0}else{break}}h[z>>3]=S;c[21204]=H+1}N=+W3(f,q,l,0,0);h[10617]=N;if(N>.33){K=35;break b}J=c[f>>2]|0;c[21204]=1;if((J|0)<1){break}else{T=1}while(1){I=T+ -1|0;L=d+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[q+(I<<3)>>3];I=T+ -1|0;L=e+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[10606]*+h[q+(I<<3)>>3];if((T|0)<(J|0)){T=T+1|0}else{break}}c[21204]=J+1}}while(0);if(!(a[84928]&1)){break}H=c[f>>2]|0;c[21204]=1;if((H|0)>=1){I=1;while(1){L=I+ -1|0;h[r+(L<<3)>>3]=+h[d+(L<<3)>>3]- +h[p+(L<<3)>>3];if((I|0)<(H|0)){I=I+1|0}else{break}}c[21204]=H+1}N=+W3(f,r,l,0,0);h[10611]=N;if(N<=1.0){K=63;break a}}}while(0);if((K|0)==35){K=0;a[84928]=0}h[b>>3]=+h[10613];G=c[f>>2]|0;c[21204]=1;if((G|0)>=1){I=1;while(1){L=I+ -1|0;h[d+(L<<3)>>3]=+h[p+(L<<3)>>3];h[e+(I+ -1<<3)>>3]=+h[p+(D+I<<3)>>3];if((I|0)<(G|0)){I=I+1|0}else{break}}c[21204]=G+1}if(a[84928]&1){I=(c[21216]|0)+1|0;c[21216]=I;N=.9/(+h[10611]*2.0+1.0e-4);h[z>>3]=.1;P=N>=.5?.5:N;h[A>>3]=P;N=P<=.1?.1:P;h[10604]=N;P=+h[k>>3]*N;h[k>>3]=P;if(!(P>=0.0)){U=-P}else{U=P}if(U>=+h[u>>3]&(I|0)<10){F=P;continue}else{K=62;break}}if((c[21218]|0)!=0){I=(c[21220]|0)+1|0;c[21220]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=3){K=51;break}if(!(P>=0.0)){V=-P}else{V=P}if(!(V>=+h[u>>3])){K=51;break}else{F=P;continue}}if(!((c[21224]|0)>-2)){K=53;break}I=(c[21214]|0)+1|0;c[21214]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=10){K=58;break}if(!(P>=0.0)){W=-P}else{W=P}if(!(W>=+h[u>>3])){K=58;break}else{F=P}}if((K|0)==51){c[m>>2]=-12;i=y;return 0}else if((K|0)==53){c[m>>2]=-12;i=y;return 0}else if((K|0)==58){c[m>>2]=-12;i=y;return 0}else if((K|0)==62){c[m>>2]=-12;i=y;return 0}else if((K|0)==63){i=y;return 0}return 0}function Y3(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;l=i;m=c[f>>2]|0;n=~m;o=(c[g>>2]|0)+1|0;c[21250]=o;p=+h[b>>3]- +h[a>>3];h[10623]=p;a=c[f>>2]|0;c[21242]=1;if((a|0)<1){q=p}else{b=1;while(1){g=b+ -1|0;h[d+(g<<3)>>3]=+h[j+(g<<3)>>3];h[e+(b+ -1<<3)>>3]=0.0;if((b|0)<(a|0)){b=b+1|0}else{break}}c[21242]=a+1;q=+h[10623]}h[10619]=1.0;h[10620]=0.0;p=q/+h[k>>3];h[10624]=p;c[21244]=2;if((o|0)<2){i=l;return 0}else{r=q;s=1.0;t=p;u=0.0;v=2}while(1){a=k+(v+ -2<<3)|0;h[10620]=u*t+s/+h[a>>3];p=t*s;h[10619]=p;h[10624]=(r+ +h[a>>3])/+h[k+(v+ -1<<3)>>3];a=c[f>>2]|0;c[21242]=1;if((a|0)>=1){b=fa(v,m)|0;q=p;g=1;while(1){w=d+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+q*+h[j+(g+n+b<<3)>>3];w=e+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+ +h[10620]*+h[j+(g+n+b<<3)>>3];if((g|0)>=(a|0)){break}q=+h[10619];g=g+1|0}c[21242]=a+1}g=v+1|0;c[21244]=g;if((v|0)>=(o|0)){break}r=+h[10623];s=+h[10619];t=+h[10624];u=+h[10620];v=g}i=l;return 0}function Z3(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;F=F|0;G=G|0;H=H|0;I=I|0;J=J|0;K=K|0;L=L|0;M=M|0;var N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0;N=i;i=i+16|0;O=N;P=N+8|0;Q=c[f>>2]|0;R=~Q;c[n>>2]=1;h[10646]=+h[b>>3];c[21270]=0;c[21278]=0;c[21272]=0;S=u+52|0;if((c[m>>2]|0)==0){c[S>>2]=0;T=u+56|0;c[T>>2]=0;c[I>>2]=1;c[J>>2]=0;h[C>>3]=0.0;c[m>>2]=1;h[y>>3]=+h[k>>3];U=1.0/+h[k>>3];h[B>>3]=U;h[A>>3]=U;h[D>>3]=100.0;c[H>>2]=-1;h[10658]=1.0;c[G>>2]=0;c[K>>2]=0;V=T}else{V=u+56|0}T=u+44|0;m=g;W=u+48|0;while(1){c[21266]=(c[I>>2]|0)+1;c[21268]=(c[I>>2]|0)+2;c[21264]=(c[I>>2]|0)+ -1;h[10646]=+h[b>>3];do{if(+h[k>>3]!=+h[C>>3]){X=8}else{Y=c[I>>2]|0;if((Y|0)!=(c[J>>2]|0)){X=8;break}Z=(c[K>>2]|0)+1|0;_=Y}}while(0);if((X|0)==8){X=0;c[K>>2]=0;Z=1;_=c[J>>2]|0}Y=_+2|0;$=(Z|0)<=(Y|0)?Z:Y;c[K>>2]=$;c[21282]=$+1;$=c[21266]|0;if(($|0)>=(c[K>>2]|0)){h[w>>3]=1.0;h[v>>3]=1.0;h[10649]=+h[k>>3];h[x>>3]=0.0;h[z>>3]=1.0;c[21252]=2;if(($|0)>=2){Y=2;while(1){h[10650]=+h[y+(Y+ -2<<3)>>3];U=+h[10649];aa=Y+ -2|0;h[y+(aa<<3)>>3]=U;ba=Y+ -1|0;h[w+(ba<<3)>>3]=+h[w+(aa<<3)>>3]*U/+h[10650];U=+h[10650]+ +h[k>>3];h[10649]=U;ca=+h[k>>3]/U;h[v+(ba<<3)>>3]=ca;h[z+(ba<<3)>>3]=ca*+h[z+(aa<<3)>>3]*+(ba|0);h[x+(ba<<3)>>3]=+h[x+(aa<<3)>>3]+ +h[v+(aa<<3)>>3]/+h[k>>3];if((Y|0)<($|0)){Y=Y+1|0}else{break}}c[21252]=$+1}h[y+($+ -1<<3)>>3]=+h[10649]}h[10656]=0.0;h[10654]=0.0;Y=c[I>>2]|0;c[21252]=1;if((Y|0)<1){da=0.0}else{ca=0.0;U=0.0;aa=1;while(1){ea=U-1.0/+(aa|0);h[10656]=ea;ga=ca- +h[v+(aa+ -1<<3)>>3];h[10654]=ga;if((aa|0)<(Y|0)){aa=aa+1|0;U=ea;ca=ga}else{break}}c[21252]=Y+1;da=ea}h[10657]=+h[A>>3];h[A>>3]=-da/+h[k>>3];aa=v+($+ -1<<3)|0;ca=+h[aa>>3]+ +h[10656]- +h[10654];h[O>>3]=ca;if(!(ca>=0.0)){ha=-ca}else{ha=ca}h[10631]=ha;h[O>>3]=ha;ca=+h[aa>>3];h[P>>3]=ca;h[10631]=ha>=ca?ha:ca;h[10649]=.6;h[10650]=1.6666666666666667;ca=+h[A>>3];U=ca/+h[B>>3];if(U<.6|U>1.6666666666666667){c[H>>2]=-1}if(ca!=+h[10657]){h[D>>3]=100.0}aa=c[21266]|0;ba=c[21282]|0;if((aa|0)>=(ba|0)){c[21254]=ba;ia=ba;while(1){ba=c[f>>2]|0;c[21252]=1;if((ba|0)>=1){ja=1;while(1){ka=q+(ja+R+(fa(ia,Q)|0)<<3)|0;h[ka>>3]=+h[w+(ia+ -1<<3)>>3]*+h[ka>>3];if((ja|0)<(ba|0)){ja=ja+1|0}else{break}}c[21252]=ba+1}ja=ia+1|0;c[21254]=ja;if((ia|0)<(aa|0)){ia=ja}else{break}}}h[b>>3]=+h[k>>3]+ +h[b>>3];a:while(1){ia=c[f>>2]|0;c[21252]=1;if((ia|0)>=1){aa=1;while(1){$=aa+ -1|0;h[d+($<<3)>>3]=+h[q+($<<3)>>3];h[e+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ia|0)){aa=aa+1|0}else{break}}c[21252]=ia+1}aa=c[21266]|0;c[21254]=2;if((aa|0)>=2){ba=2;while(1){$=c[f>>2]|0;c[21252]=1;if(($|0)>=1){Y=x+(ba+ -1<<3)|0;ja=fa(ba,Q)|0;ka=ja+R|0;la=1;while(1){ma=d+(la+ -1<<3)|0;h[ma>>3]=+h[q+(la+R+ja<<3)>>3]+ +h[ma>>3];ma=e+(la+ -1<<3)|0;h[ma>>3]=+h[ma>>3]+ +h[Y>>3]*+h[q+(ka+la<<3)>>3];if((la|0)<($|0)){la=la+1|0}else{break}}c[21252]=$+1}la=ba+1|0;c[21254]=la;if((ba|0)<(aa|0)){ba=la}else{break}}}h[10653]=+W3(f,d,l,0,0);a[85272]=1;c[21256]=0;c[T>>2]=(c[T>>2]|0)+1;c[21286]=0;Vd[m&7](b,d,e,r,85144,o,p)|0;if((c[21286]|0)<0){X=70;break}if((c[H>>2]|0)==-1){c[W>>2]=(c[W>>2]|0)+1;c[H>>2]=0;_3(f,b,d,e,r,A,k,85096,l,s,t,u,g,85144,F,j,o,p,M)|0;h[B>>3]=+h[A>>3];h[D>>3]=100.0;if((c[21286]|0)<0|(c[21274]|0)!=0){X=70;break}c[21278]=0}ba=c[f>>2]|0;c[21252]=1;if((ba|0)>=1){aa=1;while(1){h[s+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[21252]=ba+1}while(1){ca=2.0/(+h[A>>3]/+h[B>>3]+1.0);h[10649]=ca;aa=c[f>>2]|0;c[21252]=1;if((aa|0)>=1){U=ca;ia=1;la=0;while(1){ka=r+(la<<3)|0;h[ka>>3]=U*+h[ka>>3];if((ia|0)>=(aa|0)){break}ka=ia;U=+h[10649];ia=ia+1|0;la=ka}c[21252]=aa+1}$3(f,r,t,u)|0;la=c[f>>2]|0;c[21252]=1;if((la|0)>=1){ia=1;while(1){$=ia+ -1|0;ka=d+($<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+($<<3)>>3];$=ia+ -1|0;ka=r+($<<3)|0;Y=s+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[ka>>3];Y=e+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[A>>3]*+h[ka>>3];if((ia|0)<(la|0)){ia=ia+1|0}else{break}}c[21252]=la+1}U=+W3(f,r,l,0,0);h[10658]=U;if(U<=+h[F>>3]*100.0*+h[10653]){X=63;break a}ia=c[21256]|0;if((ia|0)>0){h[O>>3]=U/+h[10660];h[P>>3]=1.0/+(ia|0);ca=+nka(O,P);if(ca>.9){break}ga=ca/(1.0-ca);h[D>>3]=ga;na=+h[10658];oa=ga}else{h[10660]=U;na=U;oa=+h[D>>3]}if(oa*na<=.33){X=63;break a}ia=c[21256]|0;c[21256]=ia+1;if((ia|0)>2){break}c[T>>2]=(c[T>>2]|0)+1;c[21286]=0;Vd[m&7](b,d,e,r,85144,o,p)|0;if((c[21286]|0)<0){X=70;break a}}if((c[H>>2]|0)==0){X=70;break}c[H>>2]=-1}do{if((X|0)==63){X=0;if((c[L>>2]|0)==0){break}ba=c[f>>2]|0;c[21252]=1;if((ba|0)>=1){ia=1;while(1){pa=+h[d+(ia+ -1<<3)>>3];h[r+(ia+ -1<<3)>>3]=pa<=0.0?pa:0.0;if((ia|0)<(ba|0)){ia=ia+1|0}else{break}}h[O>>3]=pa;c[21252]=ba+1}U=+W3(f,r,l,0,0);h[10658]=U;if(U>.33){X=70;break}ia=c[f>>2]|0;c[21252]=1;if((ia|0)<1){break}else{qa=1}while(1){aa=qa+ -1|0;ka=s+(aa<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+(aa<<3)>>3];if((qa|0)<(ia|0)){qa=qa+1|0}else{break}}c[21252]=ia+1}}while(0);if((X|0)==70){X=0;a[85272]=0}c[H>>2]=1;if(a[85272]&1){U=+W3(f,s,l,0,0);h[10652]=U;ba=c[I>>2]|0;ga=U*+h[z+(ba<<3)>>3];h[10638]=ga;h[10645]=ga*+(ba+1|0);h[10640]=ga;c[21288]=ba;do{if((c[I>>2]|0)!=1){ba=c[f>>2]|0;c[21252]=1;if((ba|0)>=1){aa=fa(c[21266]|0,Q)|0;ka=1;while(1){Y=ka+ -1|0;h[r+(Y<<3)>>3]=+h[q+(ka+R+aa<<3)>>3]+ +h[s+(Y<<3)>>3];if((ka|0)<(ba|0)){ka=ka+1|0}else{break}}c[21252]=ba+1}ga=+h[z+((c[I>>2]|0)+ -1<<3)>>3];U=ga*+W3(f,r,l,0,0);h[10647]=U;ka=c[I>>2]|0;ga=U*+(ka|0);h[10655]=ga;if((ka|0)>2){aa=c[f>>2]|0;c[21252]=1;ia=c[I>>2]|0;if((aa|0)<1){ra=ia}else{Y=ia;ia=1;while(1){ca=+h[q+(ia+R+(fa(Y,Q)|0)<<3)>>3];$=r+(ia+ -1<<3)|0;h[$>>3]=ca+ +h[$>>3];$=ia+1|0;c[21252]=$;ja=c[I>>2]|0;if((ia|0)<(aa|0)){ia=$;Y=ja}else{ra=ja;break}}}ca=+h[z+(ra+ -2<<3)>>3];sa=ca*+W3(f,r,l,0,0);Y=c[I>>2]|0;ca=sa*+(Y+ -1|0);sa=+h[10655];if((sa>=ca?sa:ca)>+h[10645]){break}ta=+h[10647];ua=Y}else{if(!(ga<=+h[10645]*.5)){break}else{ta=U;ua=ka}}c[21288]=ua+ -1;h[10640]=ta}}while(0);if(!(+h[10631]*+h[10652]>1.0)){X=86;break}}c[G>>2]=1;h[b>>3]=+h[10646];Y=c[21266]|0;ia=c[21282]|0;if((Y|0)>=(ia|0)){c[21254]=ia;aa=ia;while(1){ca=1.0/+h[w+(aa+ -1<<3)>>3];h[10649]=ca;ia=c[f>>2]|0;c[21252]=1;if((ia|0)>=1){ba=fa(aa,Q)|0;sa=ca;ja=1;while(1){$=q+(ja+R+ba<<3)|0;h[$>>3]=sa*+h[$>>3];if((ja|0)>=(ia|0)){break}sa=+h[10649];ja=ja+1|0}c[21252]=ia+1}ja=aa+1|0;c[21254]=ja;if((aa|0)<(Y|0)){aa=ja}else{break}}}c[21252]=2;if((Y|0)>=2){aa=2;while(1){h[y+(aa+ -2<<3)>>3]=+h[y+(aa+ -1<<3)>>3]- +h[k>>3];if((aa|0)<(Y|0)){aa=aa+1|0}else{break}}c[21252]=Y+1}if(!(a[85272]&1)){c[V>>2]=(c[V>>2]|0)+1;if((c[21274]|0)!=0){aa=(c[21278]|0)+1|0;c[21278]=aa;h[10629]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=3){X=144;break}if(!(sa>=0.0)){va=-sa}else{va=sa}if(!(va>=+h[E>>3])){X=144;break}else{continue}}if(!((c[21286]|0)>-2)){X=146;break}aa=(c[21270]|0)+1|0;c[21270]=aa;h[10629]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=10){X=151;break}if(!(sa>=0.0)){wa=-sa}else{wa=sa}if(!(wa>=+h[E>>3])){X=151;break}else{continue}}c[21272]=(c[21272]|0)+1;c[S>>2]=(c[S>>2]|0)+1;aa=c[21272]|0;if((aa|0)<=1){ja=c[21288]|0;c[I>>2]=ja;sa=+(ja+1|0);h[10650]=sa;h[O>>3]=+h[10640]*2.0+1.0e-4;h[P>>3]=-1.0/sa;sa=+nka(O,P)*.9;h[O>>3]=.25;U=sa>=.9?.9:sa;h[P>>3]=U;sa=U<=.25?.25:U;h[10629]=sa;U=+h[k>>3]*sa;h[k>>3]=U;if(!(U>=0.0)){xa=-U}else{xa=U}if(!(xa>=+h[E>>3])){X=156;break}else{continue}}if((aa|0)>2){c[I>>2]=1;U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){ya=-U}else{ya=U}if(!(ya>=+h[E>>3])){X=165;break}else{continue}}else{c[I>>2]=c[21288];U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){za=-U}else{za=U}if(!(za>=+h[E>>3])){X=161;break}else{continue}}}if((X|0)==86){c[n>>2]=1;E=u+40|0;c[E>>2]=(c[E>>2]|0)+1;c[21302]=(c[I>>2]|0)-(c[J>>2]|0);c[J>>2]=c[I>>2];h[C>>3]=+h[k>>3];C=c[21288]|0;E=c[21264]|0;do{if((C|0)==(E|0)){X=88}else{S=u+8|0;if((c[I>>2]|0)==(c[S>>2]|0)){X=88;break}if((c[G>>2]|0)!=0){Aa=E;Ba=C;X=90;break}c[I>>2]=c[21266];za=+h[k>>3]*2.0;h[10642]=za;Ca=S;Da=za}}while(0);if((X|0)==88){c[G>>2]=1;Aa=c[21264]|0;Ba=c[21288]|0;X=90}if((X|0)==90){do{if((Ba|0)==(Aa|0)){Ea=Aa;X=104}else{G=c[I>>2]|0;C=u+8|0;if((G|0)==(c[C>>2]|0)){Fa=G;break}if((c[21266]|0)>=(c[K>>2]|0)|(c[21302]|0)==1){Fa=G;break}G=c[f>>2]|0;c[21252]=1;if((G|0)>=1){E=fa(c[21268]|0,Q)|0;S=1;while(1){V=S+ -1|0;h[r+(V<<3)>>3]=+h[s+(V<<3)>>3]- +h[q+(S+R+E<<3)>>3];if((S|0)<(G|0)){S=S+1|0}else{break}}c[21252]=G+1}za=1.0/+((c[I>>2]|0)+2|0);ya=za*+W3(f,r,l,0,0);h[10648]=ya;S=c[I>>2]|0;za=ya*+(S+2|0);if((S|0)>1){xa=+h[10645];E=xa<=za;if(+h[10655]<=(E?xa:za)){Ea=c[21264]|0;X=104;break}if(E){Fa=S;break}if((S|0)==(c[C>>2]|0)){Fa=S;break}}else{if(za>=+h[10645]*.5){Fa=S;break}}S=c[21266]|0;c[I>>2]=S;h[10640]=ya;Fa=S}}while(0);if((X|0)==104){c[I>>2]=Ea;h[10640]=+h[10647];Fa=Ea}h[10642]=+h[k>>3];ya=+(Fa+1|0);h[10650]=ya;h[O>>3]=+h[10640]*2.0+1.0e-4;h[P>>3]=-1.0/ya;ya=+nka(O,P);h[10629]=ya;do{if(ya<2.0){if(ya>1.0){Ga=+h[10642];break}else{h[O>>3]=.5;za=ya>=.9?.9:ya;h[P>>3]=za;xa=za<=.5?.5:za;h[10629]=xa;za=+h[k>>3]*xa;h[10642]=za;Ga=za;break}}else{za=+h[k>>3]*2.0;h[10642]=za;Ga=za}}while(0);Ca=u+8|0;Da=Ga}h[k>>3]=Da;do{if((c[J>>2]|0)!=(c[Ca>>2]|0)){k=c[f>>2]|0;c[21252]=1;if((k|0)<1){break}u=fa(c[21268]|0,Q)|0;P=1;while(1){h[q+(P+R+u<<3)>>3]=+h[s+(P+ -1<<3)>>3];if((P|0)<(k|0)){P=P+1|0}else{break}}c[21252]=k+1}}while(0);Ca=c[f>>2]|0;c[21252]=1;if((Ca|0)>=1){J=fa(c[21266]|0,Q)|0;P=1;while(1){u=q+(P+R+J<<3)|0;h[u>>3]=+h[s+(P+ -1<<3)>>3]+ +h[u>>3];if((P|0)<(Ca|0)){P=P+1|0}else{break}}c[21252]=Ca+1}Ca=c[21266]|0;c[21260]=2;if((Ca|0)<2){i=N;return 0}else{Ha=2}while(1){P=1-Ha+Ca|0;c[21254]=P;s=c[f>>2]|0;c[21252]=1;if((s|0)>=1){J=fa(P+1|0,Q)|0;u=fa(P,Q)|0;P=1;while(1){C=P+R|0;G=q+(C+u<<3)|0;h[G>>3]=+h[q+(C+J<<3)>>3]+ +h[G>>3];if((P|0)<(s|0)){P=P+1|0}else{break}}c[21252]=s+1}P=Ha+1|0;c[21260]=P;if((Ha|0)<(Ca|0)){Ha=P}else{break}}i=N;return 0}else if((X|0)==144){c[n>>2]=-8}else if((X|0)==146){c[n>>2]=-11}else if((X|0)==151){c[n>>2]=-7;Ha=(c[21286]>>31&-3)+ -7|0;c[n>>2]=Ha;c[n>>2]=(c[21272]|0)>2?-9:Ha}else if((X|0)==156){c[n>>2]=-6}else if((X|0)==161){c[n>>2]=-6}else if((X|0)==165){c[n>>2]=-6}Y3(b,b,d,e,f,I,q,y)|0;i=N;return 0}function _3(b,d,e,f,g,j,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,W=0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0,xa=0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+16|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;c[m>>2]=0;O=c[q+12>>2]|0;a:do{if((O|0)==2){c[s>>2]=0;c[21344]=0;h[10673]=+V(+(+h[t>>3]));P=c[b>>2]|0;c[21322]=1;b:do{if((P|0)>=1){Q=r;R=1;while(1){S=R+ -1|0;T=+h[e+(S<<3)>>3];h[N>>3]=T;if(!(T>=0.0)){U=-T}else{U=T}W=f+(S<<3)|0;T=+h[l>>3]*+h[W>>3];if(!(T>=0.0)){X=-T}else{X=T}T=U>=X?U:X;Y=+h[n+(S<<3)>>3];if(!(Y>=0.0)){Z=-Y}else{Z=Y}h[10670]=+h[10673]*(T>=Z?T:Z);h[N>>3]=+h[l>>3]*+h[W>>3];T=+pka(85360,N);h[10670]=T;W=(c[21322]|0)+ -1|0;S=e+(W<<3)|0;Y=+h[S>>3];_=T+Y-Y;h[10670]=_;h[10677]=+h[S>>3];$=f+(W<<3)|0;h[10681]=+h[$>>3];h[S>>3]=_+ +h[S>>3];h[$>>3]=+h[j>>3]*+h[10670]+ +h[$>>3];Vd[Q&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}_=1.0/+h[10670];h[10679]=_;$=c[b>>2]|0;c[21328]=1;S=c[21344]|0;if(($|0)>=1){Y=_;W=1;aa=0;while(1){h[p+(aa+S<<3)>>3]=(+h[o+(aa<<3)>>3]- +h[g+(aa<<3)>>3])*Y;if((W|0)>=($|0)){break}ba=W;Y=+h[10679];W=W+1|0;aa=ba}c[21328]=$+1}c[21344]=S+(c[b>>2]|0);aa=c[21322]|0;W=aa+ -1|0;h[e+(W<<3)>>3]=+h[10677];h[f+(W<<3)>>3]=+h[10681];R=aa+1|0;c[21322]=R;if((aa|0)>=(P|0)){break b}}i=y;return 0}}while(0);if((c[w>>2]|0)==0){ca=42;break}c[21344]=0;P=c[b>>2]|0;if((c[70944>>2]|0)==0){ca=42;break}R=Jwa(P*20|0)|0;Q=F;h[k>>3]=+h[d>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];V1(14,1,85456,F);Q=E;h[k>>3]=+h[j>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];V1(14,0,85480,E);V1(14,1,85488,D);c[21326]=0;if((c[b>>2]|0)>0){Q=0;do{Y=+h[e+(Q<<3)>>3];c[C>>2]=Q+1;aa=C+4|0;h[k>>3]=Y;c[aa>>2]=c[k>>2];c[aa+4>>2]=c[k+4>>2];V1(14,0,85496,C);Q=(c[21326]|0)+1|0;c[21326]=Q;}while((Q|0)<(c[b>>2]|0))}Zd[c[17860]&1023](14);V1(14,1,85552,B);c[21322]=1;if((P|0)>=1){Q=R+1|0;aa=c[21344]|0;W=1;do{ba=p+(W+ -1+aa<<3)|0;h[ba>>3]=+h[j>>3]+ +h[ba>>3];a[R]=0;a[Q]=0;c[21328]=1;ba=aa;da=0;while(1){Y=+h[p+(da+ba<<3)>>3];c[A>>2]=R;ea=A+4|0;h[k>>3]=Y;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];hc(R|0,85536,A|0)|0;ea=c[21328]|0;c[21328]=ea+1;if((ea|0)>=(P|0)){break}ba=c[21344]|0;da=ea}c[z>>2]=R;V1(14,0,85544,z);da=c[21344]|0;ba=c[21322]|0;ea=p+(da+ -1+ba<<3)|0;h[ea>>3]=+h[ea>>3]- +h[j>>3];aa=da+(c[b>>2]|0)|0;c[21344]=aa;W=ba+1|0;c[21322]=W;}while((ba|0)<(P|0))}Zd[c[17860]&1023](14);Zd[c[17860]&1023](14);Kwa(R);ca=42}else if((O|0)==4){P=c[q>>2]|0;W=q+4|0;aa=c[W>>2]|0;Q=c[b>>2]|0;ba=fa(aa+1+(P<<1)|0,Q)|0;c[21322]=1;if((ba|0)>=1){da=fa(Q,aa+(P<<1)+1|0)|0;P=(da|0)<1;aa=1;while(1){h[p+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[21322]=P?2:da+1|0}$d[u&7](d,e,f,g,p,j,l,n,v,w)|0;c[21356]=(c[W>>2]|0)+1+(c[q>>2]<<1);ca=75}else if((O|0)==5){aa=q+4|0;ba=(c[aa>>2]|0)+(c[q>>2]|0)|0;R=ba+1|0;c[21348]=R;Q=c[b>>2]|0;c[21338]=(ba|0)<(Q|0)?R:Q;Q=c[q>>2]|0;c[21356]=R+Q;c[21342]=Q+ba;ba=(c[b>>2]|0)/(R|0)|0;c[21352]=ba+1;R=c[x>>2]|0;c[21350]=R+ -1;c[21360]=R+ba;c[s>>2]=0;h[10673]=+V(+(+h[t>>3]));ba=c[21338]|0;c[21324]=1;if((ba|0)<1){ca=75;break}R=r;Q=1;while(1){ea=c[b>>2]|0;ga=c[21348]|0;c[21330]=Q;ha=(ga|0)<0;c:do{if(ha?(Q|0)>=(ea|0):(Q|0)<=(ea|0)){ia=ga;ja=Q;ka=Q;while(1){la=(ka-ja|0)/(ia|0)|0;c[21326]=la+1;ma=ka+ -1|0;na=e+(ma<<3)|0;h[p+((c[21350]|0)+la<<3)>>3]=+h[na>>3];oa=f+(ma<<3)|0;h[p+((c[21360]|0)+la<<3)>>3]=+h[oa>>3];Y=+h[na>>3];h[N>>3]=Y;if(!(Y>=0.0)){pa=-Y}else{pa=Y}Y=+h[l>>3]*+h[oa>>3];if(!(Y>=0.0)){qa=-Y}else{qa=Y}Y=pa>=qa?pa:qa;_=+h[n+(ma<<3)>>3];if(!(_>=0.0)){ra=-_}else{ra=_}h[10670]=+h[10673]*(Y>=ra?Y:ra);h[N>>3]=+h[l>>3]*+h[oa>>3];Y=+pka(85360,N);h[10670]=Y;oa=c[21330]|0;ma=oa+ -1|0;na=e+(ma<<3)|0;_=+h[na>>3];T=Y+_-_;h[10670]=T;h[na>>3]=+h[na>>3]+T;na=f+(ma<<3)|0;h[na>>3]=+h[j>>3]*+h[10670]+ +h[na>>3];na=oa+ga|0;c[21330]=na;if(!(ha?(na|0)>=(ea|0):(na|0)<=(ea|0))){break c}ia=c[21348]|0;ja=c[21324]|0;ka=na}}}while(0);Vd[R&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}ea=c[b>>2]|0;ha=c[21348]|0;ga=c[21324]|0;c[21330]=ga;ka=(ha|0)<0;d:do{if(ka?(ga|0)>=(ea|0):(ga|0)<=(ea|0)){ja=ha;ia=ga;S=ga;while(1){$=(S-ia|0)/(ja|0)|0;c[21326]=$+1;na=S+ -1|0;oa=e+(na<<3)|0;h[oa>>3]=+h[p+((c[21350]|0)+$<<3)>>3];T=+h[p+((c[21360]|0)+$<<3)>>3];$=f+(na<<3)|0;h[$>>3]=T;_=+h[oa>>3];h[N>>3]=_;if(!(_>=0.0)){sa=-_}else{sa=_}_=+h[l>>3]*T;if(!(_>=0.0)){ta=-_}else{ta=_}_=sa>=ta?sa:ta;T=+h[n+(na<<3)>>3];if(!(T>=0.0)){ua=-T}else{ua=T}h[10670]=+h[10673]*(_>=ua?_:ua);h[N>>3]=+h[l>>3]*+h[$>>3];_=+pka(85360,N);h[10670]=_;$=c[21330]|0;T=+h[e+($+ -1<<3)>>3];Y=_+T-T;h[10670]=Y;T=1.0/Y;h[10679]=T;na=$-(c[aa>>2]|0)|0;oa=(na|0)>1?na:1;c[21332]=oa;na=c[b>>2]|0;ma=(c[q>>2]|0)+$|0;la=(na|0)<=(ma|0)?na:ma;c[21334]=la;va=fa(c[21342]|0,$)|0;wa=va-(c[q>>2]|0)|0;c[21336]=wa;c[21322]=oa;if((oa|0)<=(la|0)){va=~na;na=~ma;ma=~((va|0)>(na|0)?va:na);na=(oa|0)>(ma|0)?oa:ma;Y=T;ma=oa;while(1){oa=ma+ -1|0;h[p+(oa+wa<<3)>>3]=(+h[o+(oa<<3)>>3]- +h[g+(oa<<3)>>3])*Y;if((ma|0)>=(la|0)){break}Y=+h[10679];ma=ma+1|0}c[21322]=na+1}ma=$+ha|0;c[21330]=ma;la=c[21324]|0;if(!(ka?(ma|0)>=(ea|0):(ma|0)<=(ea|0))){xa=la;break d}ja=c[21348]|0;ia=la;S=ma}}else{xa=ga}}while(0);ga=xa+1|0;c[21324]=ga;if((xa|0)<(ba|0)){Q=ga}else{ca=75;break a}}i=y;return 0}else if((O|0)==3){i=y;return 0}else{Q=c[b>>2]|0;ba=fa(Q,Q)|0;c[21322]=1;if((ba|0)!=0){Q=(ba|0)<1;aa=1;while(1){h[p+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[21322]=Q?2:ba+1|0}$d[u&7](d,e,f,g,p,j,l,n,v,w)|0;if((c[w>>2]|0)==0){ca=42;break}c[21344]=0;aa=c[b>>2]|0;if((c[70944>>2]|0)==0){ca=42;break}R=Jwa(aa*20|0)|0;W=M;h[k>>3]=+h[d>>3];c[W>>2]=c[k>>2];c[W+4>>2]=c[k+4>>2];V1(14,1,85456,M);W=L;h[k>>3]=+h[j>>3];c[W>>2]=c[k>>2];c[W+4>>2]=c[k+4>>2];V1(14,0,85480,L);V1(14,1,85488,K);c[21326]=0;if((c[b>>2]|0)>0){W=0;do{Y=+h[e+(W<<3)>>3];c[J>>2]=W+1;da=J+4|0;h[k>>3]=Y;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];V1(14,0,85496,J);W=(c[21326]|0)+1|0;c[21326]=W;}while((W|0)<(c[b>>2]|0))}Zd[c[17860]&1023](14);V1(14,1,85512,I);c[21322]=1;if((aa|0)>=1){W=R+1|0;ba=c[21344]|0;Q=1;do{da=p+(Q+ -1+ba<<3)|0;h[da>>3]=+h[j>>3]+ +h[da>>3];a[R]=0;a[W]=0;c[21328]=1;da=ba;P=0;while(1){Y=+h[p+(P+da<<3)>>3];c[H>>2]=R;ga=H+4|0;h[k>>3]=Y;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];hc(R|0,85536,H|0)|0;ga=c[21328]|0;c[21328]=ga+1;if((ga|0)>=(aa|0)){break}da=c[21344]|0;P=ga}c[G>>2]=R;V1(14,0,85544,G);P=c[21344]|0;da=c[21322]|0;ga=p+(P+ -1+da<<3)|0;h[ga>>3]=+h[ga>>3]- +h[j>>3];ba=P+(c[b>>2]|0)|0;c[21344]=ba;Q=da+1|0;c[21322]=Q;}while((da|0)<(aa|0))}Zd[c[17860]&1023](14);Zd[c[17860]&1023](14);Kwa(R);ca=42}}while(0);if((ca|0)==42){g4(p,b,b,q+80|0,m)|0;i=y;return 0}else if((ca|0)==75){m4(p,85424,b,q,q+4|0,q+80|0,m)|0;i=y;return 0}return 0}function $3(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[e+12>>2]|0;if((g|0)==3){i=f;return 0}else if((g|0)==4|(g|0)==5){g=e+4|0;c[21394]=(c[g>>2]|0)+1+(c[e>>2]<<1);n4(d,85576,a,e,g,e+80|0,b,85584)|0;i=f;return 0}else{k4(d,a,a,e+80|0,b,85584)|0;i=f;return 0}return 0}function a4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0;d=i;i=i+8|0;e=d;do{if(!(a[85592]&1)){a[85592]=1;b4(85640,85608,85688,85624,85672,85696,85680,85704)|0;h[10704]=+(c[21410]|0);f=c[21402]|0;h[10700]=+(f|0);if((c[21422]|0)==0){h[10702]=0.0;c[e>>2]=1-f;g=+oka(85632,e)}else{h[10702]=1.0;c[e>>2]=1-f;g=+oka(85632,e)*.5}h[10703]=g;h[10707]=g*+h[10704];h[10706]=+(c[21418]|0);h[10708]=+(c[21420]|0);j=+h[10712];h[10715]=j;k=1.0/+h[10713];if(!(k>=j)){break}h[10715]=k*(g+1.0)}}while(0);if((t4(b,85728,1,1)|0)!=0){g=+h[10703];h[10714]=g;l=g;i=d;return+l}if((t4(b,85736,1,1)|0)!=0){g=+h[10715];h[10714]=g;l=g;i=d;return+l}if((t4(b,85744,1,1)|0)!=0){g=+h[10704];h[10714]=g;l=g;i=d;return+l}if((t4(b,85752,1,1)|0)!=0){g=+h[10707];h[10714]=g;l=g;i=d;return+l}if((t4(b,85760,1,1)|0)!=0){g=+h[10700];h[10714]=g;l=g;i=d;return+l}if((t4(b,85768,1,1)|0)!=0){g=+h[10702];h[10714]=g;l=g;i=d;return+l}if((t4(b,85776,1,1)|0)!=0){g=+h[10706];h[10714]=g;l=g;i=d;return+l}if((t4(b,85784,1,1)|0)!=0){g=+h[10712];h[10714]=g;l=g;i=d;return+l}if((t4(b,85792,1,1)|0)!=0){g=+h[10708];h[10714]=g;l=g;i=d;return+l}if((t4(b,85800,1,1)|0)==0){l=+h[10714];i=d;return+l}else{g=+h[10713];h[10714]=g;l=g;i=d;return+l}return 0.0}function b4(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;m=i;i=i+24|0;n=m;o=m+8|0;p=m+16|0;if(a[85912]&1){q=86280;r=c[21570]|0;c[b>>2]=r;s=86216;t=c[21554]|0;c[d>>2]=t;u=86256;v=c[21564]|0;c[e>>2]=v;w=86264;x=+h[10783];h[f>>3]=x;y=86296;z=c[21574]|0;c[g>>2]=z;A=86344;B=+h[10793];h[j>>3]=B;C=86304;D=c[21576]|0;c[k>>2]=D;E=86352;F=+h[10794];h[l>>3]=F;i=m;return 0}a[85912]=1;h[10784]=0.0;h[10778]=1.0;h[10779]=2.0;c4(86280,86216,86256,86368)|0;h[10774]=+(c[21570]|0);c[n>>2]=0-(c[21554]|0);G=+oka(86192,n);h[10773]=G;h[10783]=G;H=+h[10779];h[10774]=H/3.0;I=+h[10778];J=I*.5;h[10781]=J;K=-J;h[o>>3]=K;h[10795]=+d4(86192,o);L=86360;h[10792]=+d4(L,L);h[o>>3]=K;h[10774]=+d4(86336,o);K=+d4(86192,86360);h[10774]=K;if(!(K>=0.0)){M=-K}else{M=K}K=M<G?G:M;h[10774]=K;h[10783]=1.0;M=+h[10784];if(K<1.0&K>M){N=K;while(1){h[10783]=N;h[o>>3]=N*J;K=H*H;h[p>>3]=N*N*H*K*K;K=+d4(o,p);h[10775]=K;h[o>>3]=-K;h[10775]=+d4(86248,o);K=+d4(86248,86200);h[10774]=K;h[o>>3]=-K;h[10775]=+d4(86248,o);K=+d4(86248,86200);h[10774]=K;if(N>K&K>M){N=K}else{O=N;break}}}else{O=1.0}if(G<O){h[10783]=G}G=I/+(c[21570]|0);h[10786]=G;h[10790]=I;c[21552]=1;p=1;O=I;do{h[o>>3]=O*G;O=+d4(o,86272);h[10790]=O;p=p+1|0;c[21552]=p;}while((p|0)<4);h[10773]=+d4(86224,86320);e4(86384,86224,86280)|0;h[o>>3]=-+h[10778];e4(86376,o,86280)|0;e4(86328,86184,86280)|0;h[o>>3]=-+h[10773];e4(86312,o,86280)|0;c[21560]=0;p=c[21596]|0;L=c[21594]|0;P=c[21582]|0;Q=(p|0)==(P|0);do{if((p|0)==(L|0)&(P|0)==(c[21578]|0)){if(Q){c[21574]=p;R=0;S=25;break}if((P-p|0)==3){c[21574]=p+ -1+(c[21554]|0);c[21560]=1;R=1;S=25;break}else{c[21574]=(p|0)<=(P|0)?p:P;a[85920]=1;S=26;break}}else{T=Q&(L|0)==(c[21578]|0);U=p-L|0;c[n>>2]=U;V=(((U|0)>-1?U:0-U|0)|0)==1;if(T){if(V){c[21574]=(p|0)>=(L|0)?p:L;R=0;S=25;break}else{c[21574]=(p|0)<=(L|0)?p:L;a[85920]=1;S=26;break}}T=c[21578]|0;U=(p|0)<=(L|0)?p:L;if(!(V&(P|0)==(T|0))){V=(U|0)<=(P|0)?U:P;c[n>>2]=V;c[21574]=(V|0)<=(T|0)?V:T;a[85920]=1;S=26;break}if((P-U|0)==3){c[21574]=((p|0)>=(L|0)?p:L)+ -1+(c[21554]|0);R=0;S=25;break}else{c[21574]=U;a[85920]=1;S=26;break}}}while(0);if((S|0)==25){if(a[85920]&1){S=26}else{W=R}}if((S|0)==26){a[85912]=0;mla(86392)|0;Dka(86416,86296,4)|0;Wka()|0;W=c[21560]|0}if((W|0)==0){X=(c[21592]|0)!=0|0}else{X=1}c[21560]=X;h[10793]=1.0;X=c[21574]|0;W=1-X|0;c[n>>2]=W;c[21552]=1;if((X|0)<=0){O=+h[10786];X=1;G=1.0;while(1){h[o>>3]=G*O;I=+d4(o,86272);h[10793]=I;n=X+1|0;c[21552]=n;if((X|0)<(W|0)){G=I;X=n}else{break}}}f4(86280,86216,86296,86240,86304,86352)|0;q=86280;r=c[21570]|0;c[b>>2]=r;s=86216;t=c[21554]|0;c[d>>2]=t;u=86256;v=c[21564]|0;c[e>>2]=v;w=86264;x=+h[10783];h[f>>3]=x;y=86296;z=c[21574]|0;c[g>>2]=z;A=86344;B=+h[10793];h[j>>3]=B;C=86304;D=c[21576]|0;c[k>>2]=D;E=86352;F=+h[10794];h[l>>3]=F;i=m;return 0}function c4(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;if(a[85808]&1){l=a[85880]&1;m=c[21472]|0;c[b>>2]=m;n=85856;o=c[21464]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=85904;r=c[21476]|0;c[f>>2]=r;i=g;return 0}a[85808]=1;h[10733]=1.0;h[10727]=1.0;h[10729]=1.0;s=1.0;do{s=s*2.0;h[10727]=s;h[10729]=+d4(85816,85864);h[j>>3]=-s;t=+d4(85832,j);h[10729]=t;}while(t==1.0);h[10728]=1.0;t=+d4(85816,85824);h[10729]=t;if(t==s){u=1.0;while(1){v=u*2.0;h[10728]=v;w=+d4(85816,85824);h[10729]=w;if(w==s){u=v}else{x=w;break}}}else{x=t}h[10734]=.25;h[10737]=x;h[j>>3]=-s;t=+d4(85832,j);h[10729]=t;y=~~(t+.25);c[21472]=y;t=+(y|0);h[10728]=t;u=t*.5;h[j>>3]=u;h[k>>3]=-t/100.0;h[10730]=+d4(j,k);w=+d4(85840,85816);h[10729]=w;z=w==s;a[85880]=z&1;h[j>>3]=u;h[k>>3]=t/100.0;h[10730]=+d4(j,k);w=+d4(85840,85816);h[10729]=w;if(z&w==s){a[85880]=0;A=0}else{A=z}h[j>>3]=u;w=+d4(j,85816);h[10731]=w;h[j>>3]=u;z=w==s&+d4(j,85896)>x;c[21476]=z?A&1:0;c[21464]=0;h[10727]=1.0;h[10729]=1.0;x=1.0;z=0;while(1){k=z+1|0;c[21464]=k;s=x*t;h[10727]=s;h[10729]=+d4(85816,85864);h[j>>3]=-s;w=+d4(85832,j);h[10729]=w;if(w==1.0){z=k;x=s}else{l=A;m=y;break}}c[b>>2]=m;n=85856;o=c[21464]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=85904;r=c[21476]|0;c[f>>2]=r;i=g;return 0}function d4(a,b){a=a|0;b=b|0;i=i;return+(+h[a>>3]+ +h[b>>3])}function e4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];h[10803]=g;j=1.0/+(c[d>>2]|0);h[10812]=j;h[10811]=0.0;c[a>>2]=1;h[f>>3]=g*j;k=+d4(f,86488);h[10805]=k;h[10807]=g;h[10808]=g;h[10809]=g;h[10810]=g;if(g==g&0.0==0.0){l=0;m=k}else{i=e;return 0}while(1){c[a>>2]=l;h[10803]=m;b=c[d>>2]|0;k=+(b|0);h[f>>3]=m/k;g=+d4(f,86488);h[10805]=g;h[f>>3]=g*k;k=+d4(f,86488);h[10807]=k;h[10809]=0.0;c[21608]=1;if((b|0)<1){n=0.0}else{o=1;p=0.0;while(1){q=g+p;if((o|0)<(b|0)){p=q;o=o+1|0}else{break}}h[10809]=q;c[21608]=b+1;n=q}h[f>>3]=m*j;p=+d4(f,86488);h[10806]=p;h[f>>3]=p/j;r=+d4(f,86488);h[10808]=r;h[10810]=0.0;o=c[d>>2]|0;c[21608]=1;if((o|0)<1){s=0.0}else{t=1;u=0.0;while(1){v=p+u;if((t|0)<(o|0)){u=v;t=t+1|0}else{break}}h[10810]=v;c[21608]=o+1;s=v}if(!(k==m&r==m&n==m&s==m)){break}l=(c[a>>2]|0)+ -1|0;m=g}i=e;return 0}function f4(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0;j=i;i=i+8|0;k=j;c[21632]=1;c[21640]=1;l=0-(c[d>>2]|0)|0;if((l|0)<2){m=2;n=l;o=2;p=1}else{l=1;q=2;while(1){c[21632]=q;r=l+1|0;c[21640]=r;s=q<<1;t=0-(c[d>>2]|0)|0;if((s|0)>(t|0)){break}else{q=s;l=r}}m=s;n=t;o=l+2|0;p=q}if((p|0)==(n|0)){c[21636]=n;u=n}else{c[21636]=m;c[21640]=o;u=m}m=c[d>>2]|0;o=((m+u|0)>(0-(p+m)|0)?p:u)<<1;c[21642]=o;u=o+(c[d>>2]|0)|0;d=u+ -1|0;c[f>>2]=d;do{if((((c[21640]|0)+1+(c[b>>2]|0)|0)%2|0|0)==1){if((c[a>>2]|0)!=2){v=d;break}o=u+ -2|0;c[f>>2]=o;v=o}else{v=d}}while(0);if((c[e>>2]|0)!=0){c[f>>2]=v+ -1}w=+(c[a>>2]|0);x=1.0/w;h[10819]=x;y=w+-1.0;h[10815]=y;h[10814]=0.0;v=c[b>>2]|0;c[21626]=1;do{if((v|0)<1){z=0.0}else{b=1;w=0.0;A=y;while(1){B=x*A;h[10815]=B;if(w<1.0){h[10817]=w}C=+d4(86512,86520);h[10814]=C;e=b+1|0;c[21626]=e;if((b|0)<(v|0)){b=e;w=C;A=B}else{break}}if(!(C>=1.0)){z=C;break}A=+h[10817];h[10814]=A;z=A}}while(0);v=c[f>>2]|0;c[21626]=1;if((v|0)<1){D=z;h[g>>3]=D;i=j;return 0}else{E=1;F=z}while(1){h[k>>3]=F*+(c[a>>2]|0);z=+d4(k,86576);h[10814]=z;f=E+1|0;c[21626]=f;if((E|0)<(v|0)){F=z;E=f}else{D=z;break}}h[g>>3]=D;i=j;return 0}function g4(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;l=c[b>>2]|0;b=~l;c[f>>2]=0;m=c[d>>2]|0;n=m+ -1|0;if((m|0)<2){o=m}else{c[21648]=1;m=1;do{c[21654]=m+1;c[j>>2]=(c[d>>2]|0)+1-m;p=h4(j,a+(m+b+(fa(m,l)|0)<<3)|0,86624)|0;q=c[21648]|0;r=p+ -1+q|0;c[21650]=r;c[e+(q+ -1<<2)>>2]=r;r=c[21650]|0;q=c[21648]|0;p=fa(q,l)|0;s=+h[a+(r+b+p<<3)>>3];do{if(s==0.0){c[f>>2]=q}else{if((r|0)==(q|0)){t=r}else{h[10826]=s;u=a+(q+b+p<<3)|0;h[a+(p+b+r<<3)>>3]=+h[u>>3];h[u>>3]=+h[10826];t=q}u=fa(t,l)|0;h[10826]=-1.0/+h[a+(t+b+u<<3)>>3];c[j>>2]=(c[d>>2]|0)-t;i4(j,86608,a+(t-l+u<<3)|0,86624)|0;u=c[d>>2]|0;c[j>>2]=u;v=c[21654]|0;c[21646]=v;if((v|0)>(u|0)){break}else{w=v}do{v=c[21650]|0;x=fa(w,l)|0;h[10826]=+h[a+(x+b+v<<3)>>3];y=c[21648]|0;if((v|0)==(y|0)){z=v}else{A=a+(y+b+x<<3)|0;h[a+(v+b+x<<3)>>3]=+h[A>>3];h[A>>3]=+h[10826];z=y}c[k>>2]=(c[d>>2]|0)-z;y=z+1|0;A=86624;j4(k,86608,a+((fa(z,l)|0)+b+y<<3)|0,A,a+(y+b+x<<3)|0,A)|0;A=c[21646]|0;w=A+1|0;c[21646]=w;}while((A|0)<(u|0))}}while(0);q=c[21648]|0;m=q+1|0;c[21648]=m;}while((q|0)<(n|0));o=c[d>>2]|0}c[e+(o+ -1<<2)>>2]=o;o=c[d>>2]|0;if(!(+h[a+(o+b+(fa(o,l)|0)<<3)>>3]==0.0)){i=g;return 0}c[f>>2]=o;i=g;return 0}function h4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}if((c[d>>2]|0)!=1){c[21746]=1;j=+h[b>>3];if(!(j>=0.0)){k=-j}else{k=j}h[10874]=k;l=(c[d>>2]|0)+1|0;c[21746]=l;m=c[a>>2]|0;c[21744]=2;if((m|0)<2){g=1;i=e;return g|0}else{n=2;o=k;p=l;q=1}while(1){k=+h[b+(p+ -1<<3)>>3];l=!(k>=0.0);if(l){r=-k}else{r=k}if(!(r<=o)){if(l){s=-k}else{s=k}h[10874]=s;t=s;u=n}else{t=o;u=q}l=p+(c[d>>2]|0)|0;c[21746]=l;a=n+1|0;c[21744]=a;if((n|0)<(m|0)){n=a;o=t;p=l;q=u}else{g=u;break}}i=e;return g|0}t=+h[b>>3];if(!(t>=0.0)){v=-t}else{v=t}h[10874]=v;c[21744]=2;if((f|0)<2){g=1;i=e;return g|0}else{w=v;x=2;y=1}while(1){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){z=-v}else{z=v}if(!(z<=w)){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){A=-v}else{A=v}h[10874]=A;B=A;C=x}else{B=w;C=y}if((x|0)<(f|0)){w=B;x=x+1|0;y=C}else{break}}c[21744]=f+1;g=C;i=e;return g|0}function i4(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)!=1){e=fa(j,g)|0;c[21730]=1;k=(j|0)<0;if(k?(e|0)<2:(e|0)>0){l=1}else{i=f;return 0}do{m=d+(l+ -1<<3)|0;h[m>>3]=+h[b>>3]*+h[m>>3];l=l+j|0;}while(k?(l|0)>=(e|0):(l|0)<=(e|0));c[21730]=l;i=f;return 0}l=(g|0)%5|0;c[21732]=l;do{if((l|0)==0){n=c[a>>2]|0}else{c[21730]=1;if((l|0)>=1){g=1;while(1){e=d+(g+ -1<<3)|0;h[e>>3]=+h[b>>3]*+h[e>>3];if((g|0)<(l|0)){g=g+1|0}else{break}}c[21730]=l+1}g=c[a>>2]|0;if((g|0)>=5){n=g;break}i=f;return 0}}while(0);a=l+1|0;c[21730]=a;if((l|0)<(n|0)){o=a}else{i=f;return 0}do{a=d+(o+ -1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+2<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+3<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];o=o+5|0;}while((o|0)<=(n|0));c[21730]=o;i=f;return 0}function j4(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0;j=i;k=c[a>>2]|0;if((k|0)<1){i=j;return 0}l=+h[b>>3];if(l==0.0){i=j;return 0}do{if((c[e>>2]|0)==1){if((c[g>>2]|0)!=1){break}m=(k|0)%4|0;c[21716]=m;do{if((m|0)==0){n=c[a>>2]|0}else{c[21714]=1;if((m|0)>=1){o=l;p=1;q=0;while(1){r=f+(q<<3)|0;h[r>>3]=+h[r>>3]+o*+h[d+(q<<3)>>3];if((p|0)>=(m|0)){break}r=p;o=+h[b>>3];p=p+1|0;q=r}c[21714]=m+1}q=c[a>>2]|0;if((q|0)>=4){n=q;break}i=j;return 0}}while(0);q=m+1|0;c[21714]=q;if((m|0)<(n|0)){s=q}else{i=j;return 0}do{q=s+ -1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=f+(s<<3)|0;h[q>>3]=+h[q>>3]+ +h[b>>3]*+h[d+(s<<3)>>3];q=s+1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=s+2|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];s=s+4|0;}while((s|0)<=(n|0));c[21714]=s;i=j;return 0}}while(0);c[21718]=1;c[21720]=1;s=c[e>>2]|0;if((s|0)<0){n=(fa(1-(c[a>>2]|0)|0,s)|0)+1|0;c[21718]=n;t=n}else{t=1}n=c[g>>2]|0;if((n|0)<0){s=(fa(1-(c[a>>2]|0)|0,n)|0)+1|0;c[21720]=s;u=s}else{u=1}s=c[a>>2]|0;c[21714]=1;if((s|0)<1){i=j;return 0}else{v=l;w=1;x=u;y=t}while(1){t=f+(x+ -1<<3)|0;h[t>>3]=v*+h[d+(y+ -1<<3)>>3]+ +h[t>>3];t=y+(c[e>>2]|0)|0;c[21718]=t;u=x+(c[g>>2]|0)|0;c[21720]=u;a=w+1|0;c[21714]=a;if((w|0)>=(s|0)){break}v=+h[b>>3];y=t;x=u;w=a}i=j;return 0}function k4(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;j=i;i=i+8|0;k=j;l=c[b>>2]|0;b=~l;m=c[d>>2]|0;n=m+ -1|0;c[21666]=n;if((c[g>>2]|0)==0){if((m|0)>=2){c[21658]=1;m=1;do{g=m+ -1|0;o=c[e+(g<<2)>>2]|0;c[21660]=o;p=f+(o+ -1<<3)|0;h[10831]=+h[p>>3];if((o|0)!=(m|0)){o=f+(g<<3)|0;h[p>>3]=+h[o>>3];h[o>>3]=+h[10831]}c[k>>2]=(c[d>>2]|0)-m;o=86624;j4(k,86648,a+(m-l+(fa(m,l)|0)<<3)|0,o,f+(m<<3)|0,o)|0;o=c[21658]|0;m=o+1|0;c[21658]=m;}while((o|0)<(n|0))}m=c[d>>2]|0;c[21664]=1;if((m|0)<1){i=j;return 0}else{q=1}do{o=1-q+(c[d>>2]|0)|0;c[21658]=o;p=fa(o,l)|0;g=o+ -1|0;r=f+(g<<3)|0;s=+h[r>>3]/+h[a+(o+b+p<<3)>>3];h[r>>3]=s;h[10831]=-s;c[k>>2]=g;g=86624;j4(k,86648,a+(p-l<<3)|0,g,f,g)|0;g=c[21664]|0;q=g+1|0;c[21664]=q;}while((g|0)<(m|0));i=j;return 0}m=c[d>>2]|0;c[21658]=1;if((m|0)<1){t=n}else{n=1;do{c[k>>2]=n+ -1;q=86624;s=+l4(k,a+((fa(n,l)|0)-l<<3)|0,q,f,q);h[10831]=s;q=c[21658]|0;g=f+(q+ -1<<3)|0;h[g>>3]=(+h[g>>3]-s)/+h[a+(q+b+(fa(q,l)|0)<<3)>>3];n=q+1|0;c[21658]=n;}while((q|0)<(m|0));t=c[21666]|0}if((t|0)<1){i=j;return 0}c[21664]=1;m=1;do{n=(c[d>>2]|0)-m|0;c[21658]=n;c[k>>2]=(c[d>>2]|0)-n;b=86624;s=+l4(k,a+(n-l+(fa(n,l)|0)<<3)|0,b,f+(n<<3)|0,b);b=c[21658]|0;n=b+ -1|0;q=f+(n<<3)|0;h[q>>3]=s+ +h[q>>3];g=c[e+(n<<2)>>2]|0;c[21660]=g;if((g|0)!=(b|0)){b=f+(g+ -1<<3)|0;h[10831]=+h[b>>3];h[b>>3]=+h[q>>3];h[q>>3]=+h[10831]}q=c[21664]|0;m=q+1|0;c[21664]=m;}while((q|0)<(t|0));i=j;return 0}function l4(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0;g=i;h[10871]=0.0;j=c[a>>2]|0;if((j|0)<1){k=0.0;i=g;return+k}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}l=(j|0)%5|0;c[21736]=l;do{if((l|0)==0){m=c[a>>2]|0;n=0.0}else{c[21734]=1;if((l|0)<1){o=0.0}else{p=0.0;q=1;while(1){r=q+ -1|0;s=p+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3];h[10871]=s;if((q|0)<(l|0)){q=q+1|0;p=s}else{break}}c[21734]=l+1;o=s}q=c[a>>2]|0;if((q|0)<5){k=o}else{m=q;n=o;break}i=g;return+k}}while(0);q=l+1|0;c[21734]=q;if((l|0)<(m|0)){t=n;u=q}else{k=n;i=g;return+k}do{q=u+ -1|0;r=u+1|0;v=u+2|0;w=u+3|0;t=t+ +h[b+(q<<3)>>3]*+h[e+(q<<3)>>3]+ +h[b+(u<<3)>>3]*+h[e+(u<<3)>>3]+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3]+ +h[b+(v<<3)>>3]*+h[e+(v<<3)>>3]+ +h[b+(w<<3)>>3]*+h[e+(w<<3)>>3];h[10871]=t;u=u+5|0;}while((u|0)<=(m|0));c[21734]=u;k=t;i=g;return+k}}while(0);c[21738]=1;c[21740]=1;u=c[d>>2]|0;if((u|0)<0){m=(fa(1-(c[a>>2]|0)|0,u)|0)+1|0;c[21738]=m;x=m}else{x=1}m=c[f>>2]|0;if((m|0)<0){u=(fa(1-(c[a>>2]|0)|0,m)|0)+1|0;c[21740]=u;y=u}else{y=1}u=c[a>>2]|0;c[21734]=1;if((u|0)<1){k=0.0;i=g;return+k}else{z=1;A=0.0;B=y;C=x}while(1){t=A+ +h[b+(C+ -1<<3)>>3]*+h[e+(B+ -1<<3)>>3];h[10871]=t;x=C+(c[d>>2]|0)|0;c[21738]=x;y=B+(c[f>>2]|0)|0;c[21740]=y;a=z+1|0;c[21734]=a;if((z|0)<(u|0)){C=x;B=y;A=t;z=a}else{k=t;break}}i=g;return+k}function m4(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+8|0;l=k;m=c[b>>2]|0;b=~m;c[21676]=(c[e>>2]|0)+1+(c[f>>2]|0);c[j>>2]=0;n=(c[f>>2]|0)+2|0;c[21682]=n;o=c[d>>2]|0;p=c[21676]|0;q=(o|0)>(p|0)?p:o;o=q+ -1|0;c[21684]=o;do{if((q|0)>(n|0)){c[21692]=n;if((n|0)>(o|0)){break}else{r=n}while(1){s=1-r+p|0;c[21680]=s;t=c[e>>2]|0;c[21668]=s;if((s|0)<=(t|0)){u=s;while(1){h[a+(u+b+(fa(r,m)|0)<<3)>>3]=0.0;if((u|0)<(t|0)){u=u+1|0}else{break}}c[21668]=t+1}u=r+1|0;c[21692]=u;if((r|0)<(o|0)){r=u}else{break}}c[l>>2]=t}}while(0);c[21692]=o;c[21690]=0;t=c[d>>2]|0;r=t+ -1|0;if((t|0)<2){v=t}else{c[21672]=1;t=o;o=1;while(1){c[21694]=o+1;p=t+1|0;c[21692]=p;n=c[d>>2]|0;do{if((t|0)<(n|0)){q=c[e>>2]|0;if((q|0)<1){w=n;break}c[l>>2]=q;c[21668]=1;u=fa(p,m)|0;s=1;while(1){h[a+(s+b+u<<3)>>3]=0.0;if((s|0)<(q|0)){s=s+1|0}else{break}}c[21668]=q+1;w=c[d>>2]|0}else{w=n}}while(0);n=c[e>>2]|0;p=w-o|0;s=(n|0)<=(p|0)?n:p;c[21686]=s;c[l>>2]=s+1;s=h4(l,a+((c[21676]|0)+b+(fa(o,m)|0)<<3)|0,86624)|0;p=s+ -1|0;c[21674]=p+(c[21676]|0);s=c[21672]|0;c[g+(s+ -1<<2)>>2]=p+s;s=c[21674]|0;p=c[21672]|0;n=fa(p,m)|0;x=+h[a+(s+b+n<<3)>>3];a:do{if(x==0.0){c[j>>2]=p}else{u=c[21676]|0;if((s|0)==(u|0)){y=s}else{h[10839]=x;z=a+(u+b+n<<3)|0;h[a+(n+b+s<<3)>>3]=+h[z>>3];h[z>>3]=+h[10839];y=u}h[10839]=-1.0/+h[a+(y+b+n<<3)>>3];i4(86744,86712,a+(y-m+n<<3)|0,86624)|0;u=c[21690]|0;z=(c[g+((c[21672]|0)+ -1<<2)>>2]|0)+(c[f>>2]|0)|0;A=(u|0)>=(z|0)?u:z;c[l>>2]=A;z=c[d>>2]|0;u=(A|0)>(z|0)?z:A;c[21690]=u;A=c[21676]|0;c[21688]=A;z=c[21694]|0;if((u|0)<(z|0)){break}c[l>>2]=u;c[21670]=z;B=z;z=A;while(1){A=(c[21674]|0)+ -1|0;c[21674]=A;C=z+ -1|0;c[21688]=C;D=fa(B,m)|0;E=a+(A+b+D<<3)|0;h[10839]=+h[E>>3];if((A|0)==(C|0)){F=A}else{A=a+(C+b+D<<3)|0;h[E>>3]=+h[A>>3];h[A>>3]=+h[10839];F=C}C=86624;j4(86744,86712,a+((c[21676]|0)-m+(fa(c[21672]|0,m)|0)<<3)|0,C,a+(F-m+D<<3)|0,C)|0;C=c[21670]|0;D=C+1|0;c[21670]=D;if((C|0)>=(u|0)){break a}B=D;z=c[21688]|0}}}while(0);n=c[21672]|0;s=n+1|0;c[21672]=s;if((n|0)>=(r|0)){break}t=c[21692]|0;o=s}v=c[d>>2]|0}c[g+(v+ -1<<2)>>2]=v;v=c[d>>2]|0;if(!(+h[a+((c[21676]|0)+b+(fa(v,m)|0)<<3)>>3]==0.0)){i=k;return 0}c[j>>2]=v;i=k;return 0}function n4(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0;l=i;m=c[b>>2]|0;b=~m;n=(c[f>>2]|0)+1+(c[e>>2]|0)|0;c[21700]=n;f=c[d>>2]|0;o=f+ -1|0;c[21712]=o;if((c[k>>2]|0)==0){if(!((c[e>>2]|0)==0|(f|0)<2)){c[21696]=1;f=1;do{k=c[e>>2]|0;p=(c[d>>2]|0)-f|0;c[21710]=(k|0)<=(p|0)?k:p;p=f+ -1|0;k=c[g+(p<<2)>>2]|0;c[21698]=k;q=j+(k+ -1<<3)|0;h[10851]=+h[q>>3];if((k|0)!=(f|0)){k=j+(p<<3)|0;h[q>>3]=+h[k>>3];h[k>>3]=+h[10851]}k=86624;j4(86840,86808,a+((c[21700]|0)-m+(fa(f,m)|0)<<3)|0,k,j+(f<<3)|0,k)|0;k=c[21696]|0;f=k+1|0;c[21696]=f;}while((k|0)<(o|0))}f=c[d>>2]|0;c[21704]=1;if((f|0)<1){i=l;return 0}else{r=1}do{k=1-r+(c[d>>2]|0)|0;c[21696]=k;q=c[21700]|0;p=fa(k,m)|0;s=j+(k+ -1<<3)|0;t=+h[s>>3]/+h[a+(q+b+p<<3)>>3];h[s>>3]=t;s=((k|0)<=(q|0)?k:q)+ -1|0;c[21710]=s;u=q-s|0;c[21706]=u;q=k-s|0;c[21708]=q;h[10851]=-t;s=86624;j4(86840,86808,a+(u+b+p<<3)|0,s,j+(q+ -1<<3)|0,s)|0;s=c[21704]|0;r=s+1|0;c[21704]=r;}while((s|0)<(f|0));i=l;return 0}f=c[d>>2]|0;c[21696]=1;if((f|0)<1){v=n;w=o}else{o=n;n=1;do{r=((n|0)<=(o|0)?n:o)+ -1|0;c[21710]=r;s=o-r|0;c[21706]=s;q=n-r|0;c[21708]=q;r=86624;t=+l4(86840,a+((fa(n,m)|0)+b+s<<3)|0,r,j+(q+ -1<<3)|0,r);h[10851]=t;r=c[21696]|0;q=j+(r+ -1<<3)|0;o=c[21700]|0;h[q>>3]=(+h[q>>3]-t)/+h[a+((fa(r,m)|0)+b+o<<3)>>3];n=r+1|0;c[21696]=n;}while((r|0)<(f|0));v=o;w=c[21712]|0}if((c[e>>2]|0)==0|(w|0)<1){i=l;return 0}c[21704]=1;o=v;v=1;while(1){f=(c[d>>2]|0)-v|0;c[21696]=f;n=c[e>>2]|0;b=(c[d>>2]|0)-f|0;c[21710]=(n|0)<=(b|0)?n:b;b=86624;t=+l4(86840,a+(o-m+(fa(f,m)|0)<<3)|0,b,j+(f<<3)|0,b);b=c[21696]|0;f=b+ -1|0;n=j+(f<<3)|0;h[n>>3]=t+ +h[n>>3];r=c[g+(f<<2)>>2]|0;c[21698]=r;if((r|0)!=(b|0)){b=j+(r+ -1<<3)|0;h[10851]=+h[b>>3];h[b>>3]=+h[n>>3];h[n>>3]=+h[10851]}n=c[21704]|0;b=n+1|0;c[21704]=b;if((n|0)>=(w|0)){break}o=c[21700]|0;v=b}i=l;return 0}function o4(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}k=(j|0)%7|0;c[21724]=k;do{if((k|0)==0){l=c[a>>2]|0}else{c[21722]=1;if((k|0)>=1){m=1;while(1){n=m+ -1|0;h[e+(n<<3)>>3]=+h[b+(n<<3)>>3];if((m|0)<(k|0)){m=m+1|0}else{break}}c[21722]=k+1}m=c[a>>2]|0;if((m|0)>=7){l=m;break}i=g;return 0}}while(0);m=k+1|0;c[21722]=m;if((k|0)<(l|0)){o=m}else{i=g;return 0}do{m=o+ -1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];h[e+(o<<3)>>3]=+h[b+(o<<3)>>3];m=o+1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+2|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+3|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+4|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+5|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];o=o+7|0;}while((o|0)<=(l|0));c[21722]=o;i=g;return 0}}while(0);c[21726]=1;c[21728]=1;o=c[d>>2]|0;if((o|0)<0){l=(fa(1-(c[a>>2]|0)|0,o)|0)+1|0;c[21726]=l;p=l}else{p=1}l=c[f>>2]|0;if((l|0)<0){o=(fa(1-(c[a>>2]|0)|0,l)|0)+1|0;c[21728]=o;q=o}else{q=1}o=c[a>>2]|0;c[21722]=1;if((o|0)<1){i=g;return 0}else{r=1;s=q;t=p}while(1){h[e+(s+ -1<<3)>>3]=+h[b+(t+ -1<<3)>>3];p=t+(c[d>>2]|0)|0;c[21726]=p;q=s+(c[f>>2]|0)|0;c[21728]=q;a=r+1|0;c[21722]=a;if((r|0)<(o|0)){t=p;s=q;r=a}else{break}}i=g;return 0}function p4(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0;d=i;m=+q4(87e3);n=c[a>>2]|0;o=(n|0)<1;do{if(!o){p=((fa(n+1|0,n)|0)/2|0)+1|0;q=1;while(1){r=n-q|0;s=r+1|0;t=r+2|0;u=p-q|0;if((n|0)<(t|0)){v=0.0}else{w=t;t=u;x=0.0;while(1){y=x+ +h[b+(t<<3)>>3]*+h[j+(w+ -1<<3)>>3];if((w|0)<(n|0)){x=y;t=t+1|0;w=w+1|0}else{v=y;break}}}x=+h[b+(u+ -1<<3)>>3];do{if(x!=0.0){z=x}else{if((r|0)<0){A=x}else{w=1;t=s;y=x;while(1){B=+h[b+(t+ -1<<3)>>3];if(!(B>=0.0)){C=-B}else{C=B}B=y>=C?y:C;D=t-w+n|0;if((w|0)<(s|0)){w=w+1|0;t=D;y=B}else{A=B;break}}}y=m*A;if(!(y==0.0)){z=y;break}z=m}}while(0);h[j+(r<<3)>>3]=(+h[f+(r<<3)>>3]-v)/z;if((q|0)<(n|0)){q=q+1|0;p=u}else{break}}if(o){break}else{E=1}while(1){p=E+ -1|0;h[k+(p<<3)>>3]=0.0;h[l+(p<<3)>>3]=+h[e+(p<<3)>>3]*+h[j+(p<<3)>>3];if((E|0)<(n|0)){E=E+1|0}else{break}}}}while(0);z=+r4(a,l);if(z<=+h[g>>3]){i=d;return 0}E=c[a>>2]|0;if((E|0)>=1){n=E;o=1;p=1;while(1){q=o+ -1|0;v=+h[f+(q<<3)>>3];if((o|0)>(E|0)){F=p}else{s=o;t=p;while(1){w=k+(s+ -1<<3)|0;h[w>>3]=+h[w>>3]+v*+h[b+(t+ -1<<3)>>3];if((s|0)<(E|0)){t=t+1|0;s=s+1|0}else{break}}F=p+n|0}s=k+(q<<3)|0;h[s>>3]=+h[s>>3]/+h[e+(q<<3)>>3];if((o|0)<(E|0)){n=n+ -1|0;o=o+1|0;p=F}else{break}}}v=+r4(a,k);m=+h[g>>3];do{if(v==0.0){G=m;H=m/z;I=0.0}else{F=c[a>>2]|0;p=(F|0)<1;do{if(!p){o=1;while(1){n=o+ -1|0;E=k+(n<<3)|0;h[E>>3]=+h[E>>3]/v/+h[e+(n<<3)>>3];if((o|0)<(F|0)){o=o+1|0}else{break}}if(p){break}else{J=F;K=1;L=1}while(1){if((K|0)>(F|0)){M=L;N=0.0}else{o=K;u=L;A=0.0;while(1){O=A+ +h[b+(u+ -1<<3)>>3]*+h[k+(o+ -1<<3)>>3];if((o|0)<(F|0)){A=O;u=u+1|0;o=o+1|0}else{break}}M=L+J|0;N=O}h[l+(K+ -1<<3)>>3]=N;if((K|0)<(F|0)){J=J+ -1|0;K=K+1|0;L=M}else{break}}}}while(0);A=+r4(a,l);C=v/A/A;A=+h[g>>3];if(C>=A){G=A;H=0.0;I=C;break}A=+r4(a,f);x=+h[g>>3];y=C/x;B=A/v*(A/z)*y;A=x/z;P=B-A;Q=y*y;y=1.0-Q;G=x;H=A*y/(+V(+(P*P+y*(1.0-A*A)))+(B-A*Q));I=C}}while(0);z=(1.0-H)*(!(I<=G)?G:I);g=c[a>>2]|0;if((g|0)<1){i=d;return 0}else{R=1}while(1){a=R+ -1|0;f=j+(a<<3)|0;h[f>>3]=z*+h[k+(a<<3)>>3]+H*+h[f>>3];if((R|0)<(g|0)){R=R+1|0}else{break}}i=d;return 0}function q4(a){a=a|0;i=i;return+(+h[87008+((((c[a>>2]<<3)+ -8|0)/8|0)<<3)>>3])}function r4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;d=i;e=c[a>>2]|0;f=1304.0e16/+(e|0);do{if((e|0)<1){g=0.0;j=0.0}else{a=1;k=0.0;l=0.0;m=0.0;n=0.0;o=0.0;while(1){p=+h[b+(a+ -1<<3)>>3];if(!(p>=0.0)){q=-p}else{q=p}do{if(q>3.834e-20&q<f){r=k;s=l+q*q;t=m;u=n;v=o}else{if(!(q<=3.834e-20)){if(!(q<=n)){p=n/q;r=k*p*p+1.0;s=l;t=m;u=q;v=o;break}else{p=q/n;r=k+p*p;s=l;t=m;u=n;v=o;break}}if(!(q<=o)){p=o/q;r=k;s=l;t=m*p*p+1.0;u=n;v=q;break}if(!(q!=0.0)){r=k;s=l;t=m;u=n;v=o;break}p=q/o;r=k;s=l;t=m+p*p;u=n;v=o}}while(0);if((a|0)<(e|0)){a=a+1|0;k=r;l=s;m=t;n=u;o=v}else{break}}if(!(r==0.0)){w=u*+V(+(r+s/u/u));i=d;return+w}if(s==0.0){g=t;j=v;break}if(!(s>=v)){x=0.0}else{x=+V(+(s*(t*v*(v/s)+1.0)))}if(!(s<v)){w=x;i=d;return+w}w=+V(+(v*(t*v+s/v)));i=d;return+w}}while(0);w=j*+V(+g);i=d;return+w}function s4(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;var B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0.0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0;B=i;i=i+32|0;C=B;D=B+8|0;E=B+16|0;F=B+24|0;G=c[g>>2]|0;H=~G;I=+q4(87040);c[p>>2]=0;c[E>>2]=0;c[q>>2]=0;c[r>>2]=0;K=c[b>>2]|0;a:do{if((K|0)<1){L=97}else{if((c[g>>2]|0)<(K|0)){L=97;break}if(+h[j>>3]<0.0){L=97;break}if((c[k>>2]|0)<1){L=97;break}if(+h[n>>3]<=0.0){L=97;break}if((c[t>>2]|0)<((fa(K+1|0,K)|0)/2|0|0)){L=97;break}if((c[m>>2]|0)==2){M=1;while(1){if(+h[l+(M+ -1<<3)>>3]<=0.0){L=97;break a}if((M|0)<(K|0)){M=M+1|0}else{break}}}c[E>>2]=1;M=a;ye[M&15](b,d,e,f,g,E,z,A)|0;c[q>>2]=1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}P=+r4(b,e);c[E>>2]=2;ye[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}N=C;Q=P;R=1;S=0;T=0;U=0;V=0;P=0.0;b:while(1){A4(b,b,f,g,87048,N,87040,v,w,x)|0;do{if((R|0)==1){W=c[b>>2]|0;do{if((c[m>>2]|0)==2){L=20}else{if((W|0)<1){break}else{X=1}while(1){Y=X+ -1|0;Z=w+(Y<<3)|0;_=l+(Y<<3)|0;h[_>>3]=+h[Z>>3];if(+h[Z>>3]==0.0){h[_>>3]=1.0}if((X|0)<(W|0)){X=X+1|0}else{L=20;break}}}}while(0);do{if((L|0)==20){L=0;if((W|0)<1){break}else{$=1}while(1){_=$+ -1|0;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[d+(_<<3)>>3];if(($|0)<(W|0)){$=$+1|0}else{break}}}}while(0);aa=+r4(b,x);ba=+h[n>>3];ca=aa*ba;h[F>>3]=ca;if(!(ca==0.0)){da=aa;break}h[F>>3]=ba;da=aa}else{da=P}}while(0);W=c[b>>2]|0;_=(W|0)<1;do{if(_){L=35}else{Z=1;while(1){Y=Z+ -1|0;h[u+(Y<<3)>>3]=+h[e+(Y<<3)>>3];if((Z|0)<(W|0)){Z=Z+1|0}else{break}}if(_){L=35;break}else{ea=1}while(1){Z=fa(ea,G)|0;aa=+h[f+(ea+H+Z<<3)>>3];do{if(!(aa==0.0)){Y=(ea|0)>(W|0);if(Y){break}ga=Z+H|0;ha=ea;ba=0.0;while(1){ia=ba+ +h[f+(ga+ha<<3)>>3]*+h[u+(ha+ -1<<3)>>3];if((ha|0)<(W|0)){ba=ia;ha=ha+1|0}else{break}}ba=-ia/aa;if(Y){break}ha=Z+H|0;ga=ea;while(1){ja=u+(ga+ -1<<3)|0;h[ja>>3]=+h[ja>>3]+ba*+h[f+(ha+ga<<3)>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}}while(0);if((ea|0)<(W|0)){ea=ea+1|0}else{break}}c[D>>2]=0;if(_){break}else{ka=0;la=1}while(1){Z=(ka|0)>1?ka:1;ga=Z+ -1|0;ha=Exa(ga|0,0,Z+ -2|0,0)|0;Z=xxa(ha|0,J&1|0,1)|0;ha=la+ -1|0;if((la|0)<2){ma=la}else{Y=(fa(la,G)|0)+H|0;ja=W+ka+(fa(ga,W+ -2|0)|0)|0;ga=1;na=la;while(1){h[s+(na+ -1<<3)>>3]=+h[f+(Y+ga<<3)>>3];if((ga|0)<(ha|0)){na=na-ga+W|0;ga=ga+1|0}else{break}}ma=ja-Z|0}ga=v+(ha<<3)|0;h[s+(ma+ -1<<3)>>3]=+h[ga>>3];if(+h[ga>>3]==0.0){c[D>>2]=1}if((la|0)<(W|0)){ka=ka+1|0;la=la+1|0}else{break}}}}while(0);if((L|0)==35){L=0;c[D>>2]=0}z4(b,b,f,g,v)|0;do{if((c[m>>2]|0)==2){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da}else{W=c[b>>2]|0;if((W|0)<1){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}else{wa=1}while(1){_=wa+ -1|0;ga=l+(_<<3)|0;aa=+h[ga>>3];ba=+h[w+(_<<3)>>3];h[ga>>3]=aa>=ba?aa:ba;if((wa|0)<(W|0)){wa=wa+1|0}else{oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}}}}while(0);while(1){W=c[o>>2]|0;do{if((W|0)>=1){c[E>>2]=0;if(((pa+ -1|0)%(W|0)|0|0)!=0){break}ye[M&15](b,d,e,f,g,E,z,A)|0;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}}}while(0);p4(b,s,t,l,u,F,v,w,x)|0;W=c[b>>2]|0;if((W|0)>=1){ga=1;while(1){_=ga+ -1|0;na=v+(_<<3)|0;ba=+h[na>>3];h[na>>3]=-ba;h[w+(_<<3)>>3]=+h[d+(_<<3)>>3]-ba;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[na>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}ba=+r4(b,x);if((pa|0)==1){aa=+h[F>>3];h[F>>3]=aa<=ba?aa:ba}c[E>>2]=1;ye[M&15](b,w,y,f,g,E,z,A)|0;c[q>>2]=(c[q>>2]|0)+1;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}aa=+r4(b,y);if(aa<oa){ca=aa/oa;xa=1.0-ca*ca}else{xa=-1.0}ga=c[b>>2]|0;if((ga|0)>=1){W=1;na=ga;_=1;while(1){if((W|0)>(ga|0)){ya=_;za=0.0}else{Y=W;Aa=_;ca=0.0;while(1){Ba=ca+ +h[s+(Aa+ -1<<3)>>3]*+h[v+(Y+ -1<<3)>>3];if((Y|0)<(ga|0)){ca=Ba;Aa=Aa+1|0;Y=Y+1|0}else{break}}ya=_+na|0;za=Ba}Y=W+ -1|0;h[x+(Y<<3)>>3]=za+ +h[u+(Y<<3)>>3];if((W|0)<(ga|0)){W=W+1|0;na=na+ -1|0;_=ya}else{break}}}ca=+r4(b,x);do{if(ca<oa){Ca=ca/oa;Da=1.0-Ca*Ca;if(!(Da>0.0)){Ea=0.0;L=65;break}Ca=xa/Da;if(!(Ca>=.1)){Ea=Ca;L=65;break}_=sa+1|0;if(Ca>=.5|(sa|0)>0){Da=+h[F>>3];Fa=ba*2.0;h[F>>3]=Da>=Fa?Da:Fa}Fa=Ca+-1.0;if(!(Fa>=0.0)){Ga=-Fa}else{Ga=Fa}if(!(Ga<=.1)){Ha=0;Ia=_;Ja=Ca;break}h[F>>3]=ba*2.0;Ha=0;Ia=_;Ja=Ca}else{Ea=0.0;L=65}}while(0);if((L|0)==65){L=0;h[F>>3]=+h[F>>3]*.5;Ha=ra+1|0;Ia=0;Ja=Ea}if(Ja<1.0e-4){Ka=oa;La=pa;Ma=va}else{_=c[b>>2]|0;if((_|0)>=1){na=1;while(1){W=na+ -1|0;ga=w+(W<<3)|0;ca=+h[ga>>3];h[d+(W<<3)>>3]=ca;h[ga>>3]=ca*+h[l+(W<<3)>>3];h[e+(W<<3)>>3]=+h[y+(W<<3)>>3];if((na|0)<(_|0)){na=na+1|0}else{break}}}Ka=aa;La=pa+1|0;Ma=+r4(b,w)}Na=!(xa>=.001)?ta+1|0:0;Oa=!(xa>=.1)?ua+qa|0:0;ca=+h[F>>3];if(ca<=Ma*+h[j>>3]|Ka==0.0){L=77;break b}if((c[p>>2]|0)!=0){L=97;break a}if((c[q>>2]|0)<(c[k>>2]|0)){Pa=0}else{c[p>>2]=2;Pa=2}Ca=ca*.1;if(!((Ca>=ba?Ca:ba)*.1<=I*Ma)){Qa=Pa}else{c[p>>2]=3;Qa=3}if((Oa|0)==5){c[p>>2]=4;Ra=4}else{Ra=Qa}if((Na|0)==10){L=86;break b}if((Ra|0)!=0){L=97;break a}if((Ha|0)==2){break}na=c[b>>2]|0;if((na|0)>=1){_=!(Ja>=1.0e-4);W=1;while(1){ga=(fa(W,G)|0)+H|0;Y=1;Ca=0.0;while(1){Sa=Ca+ +h[f+(ga+Y<<3)>>3]*+h[y+(Y+ -1<<3)>>3];if((Y|0)<(na|0)){Ca=Sa;Y=Y+1|0}else{break}}Y=W+ -1|0;h[w+(Y<<3)>>3]=(Sa- +h[x+(Y<<3)>>3])/ba;Ca=+h[l+(Y<<3)>>3];ga=v+(Y<<3)|0;h[ga>>3]=Ca*(Ca*+h[ga>>3]/ba);if(!_){h[u+(Y<<3)>>3]=Sa}if((W|0)<(na|0)){W=W+1|0}else{break}}}C4(b,b,s,t,v,w,x,D)|0;B4(b,b,f,g,w,x)|0;W=87040;B4(W,b,u,W,w,x)|0;oa=Ka;pa=La;qa=0;ra=Ha;sa=Ia;ta=Na;ua=Oa;va=Ma}c[E>>2]=2;ye[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;W=c[E>>2]|0;if((W|0)<0){O=W;L=98;break a}else{Q=Ka;R=La;S=2;T=Ia;U=Na;V=Oa;P=Ma}}if((L|0)==77){c[p>>2]=1;L=97;break}else if((L|0)==86){c[p>>2]=5;L=97;break}}}while(0);if((L|0)==97){Oa=c[E>>2]|0;if((Oa|0)<0){O=Oa;L=98}}if((L|0)==98){c[p>>2]=O}c[E>>2]=0;if((c[o>>2]|0)<=0){i=B;return 0}ye[a&15](b,d,e,f,g,E,z,A)|0;i=B;return 0}



function Cta(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((d|0)==(e|0)){g=d;i=b;return g|0}else{h=d;j=f}while(1){c[j>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{j=j+4|0;h=f}}i=b;return g|0}function Dta(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b>>>0<128?b&255:c)|0}function Eta(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;if((d|0)==(e|0)){h=d;i=b;return h|0}j=((e+ -4+(0-d)|0)>>>2)+1|0;k=d;l=g;while(1){g=c[k>>2]|0;a[l]=g>>>0<128?g&255:f;g=k+4|0;if((g|0)==(e|0)){break}else{l=l+1|0;k=g}}h=d+(j<<2)|0;i=b;return h|0}function Fta(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=145248;e=c[b+8>>2]|0;do{if((e|0)!=0){if((a[b+12|0]|0)==0){break}Swa(e)}}while(0);Rwa(b);i=d;return}function Gta(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=145248;e=c[b+8>>2]|0;if((e|0)==0){i=d;return}if((a[b+12|0]|0)==0){i=d;return}Swa(e);i=d;return}function Hta(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(vd()|0)>>2]|0)+((b&255)<<2)>>2]&255;i=a;return d|0}function Ita(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(vd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function Jta(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Ad()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;i=a;return d|0}function Kta(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Ad()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function Lta(a,b){a=a|0;b=b|0;i=i;return b|0}function Mta(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((c|0)==(d|0)){f=c;i=b;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{h=h+1|0;g=e}}i=b;return f|0}function Nta(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b<<24>>24>-1?b:c)|0}function Ota(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((c|0)==(d|0)){g=c;i=b;return g|0}else{h=c;j=f}while(1){f=a[h]|0;a[j]=f<<24>>24>-1?f:e;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{j=j+1|0;h=f}}i=b;return g|0}function Pta(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function Qta(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function Rta(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function Sta(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function Tta(a){a=a|0;i=i;return 1}function Uta(a){a=a|0;i=i;return 1}function Vta(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;i=i;return(b>>>0<e>>>0?b:e)|0}function Wta(a){a=a|0;i=i;return 1}function Xta(a){a=a|0;var b=0;b=i;dta(a);Rwa(a);i=b;return}function Yta(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+8|0;m=l;n=m;o=i;i=i+8|0;p=(e|0)==(f|0);a:do{if(p){c[k>>2]=h;c[g>>2]=e;q=e}else{r=e;while(1){s=r+4|0;if((c[r>>2]|0)==0){t=r;break}if((s|0)==(f|0)){t=f;break}else{r=s}}c[k>>2]=h;c[g>>2]=e;if(p|(h|0)==(j|0)){q=e;break}r=j;s=b+8|0;u=o;v=e;w=h;x=t;while(1){y=d;z=c[y+4>>2]|0;A=m;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=Kc(c[s>>2]|0)|0;A=Pva(w,g,x-v>>2,r-w|0,d)|0;if((z|0)!=0){Kc(z|0)|0}if((A|0)==-1){B=10;break}else if((A|0)==0){C=1;B=33;break}z=(c[k>>2]|0)+A|0;c[k>>2]=z;if((z|0)==(j|0)){B=31;break}if((x|0)==(f|0)){D=c[g>>2]|0;E=z;F=f}else{z=Kc(c[s>>2]|0)|0;A=Ova(u,0,d)|0;if((z|0)!=0){Kc(z|0)|0}if((A|0)==-1){C=2;B=33;break}z=c[k>>2]|0;if(A>>>0>(r-z|0)>>>0){C=1;B=33;break}b:do{if((A|0)!=0){y=z;G=A;H=u;while(1){I=a[H]|0;c[k>>2]=y+1;a[y]=I;I=G+ -1|0;if((I|0)==0){break b}y=c[k>>2]|0;H=H+1|0;G=I}}}while(0);A=(c[g>>2]|0)+4|0;c[g>>2]=A;c:do{if((A|0)==(f|0)){J=f}else{z=A;while(1){G=z+4|0;if((c[z>>2]|0)==0){J=z;break c}if((G|0)==(f|0)){J=f;break}else{z=G}}}}while(0);D=A;E=c[k>>2]|0;F=J}if((D|0)==(f|0)|(E|0)==(j|0)){q=D;break a}else{v=D;w=E;x=F}}if((B|0)==10){c[k>>2]=w;d:do{if((v|0)==(c[g>>2]|0)){K=v}else{x=v;u=w;while(1){r=c[x>>2]|0;z=Kc(c[s>>2]|0)|0;G=Ova(u,r,n)|0;if((z|0)!=0){Kc(z|0)|0}if((G|0)==-1){K=x;break d}z=(c[k>>2]|0)+G|0;c[k>>2]=z;G=x+4|0;if((G|0)==(c[g>>2]|0)){K=G;break}else{x=G;u=z}}}}while(0);c[g>>2]=K;C=2;i=l;return C|0}else if((B|0)==31){q=c[g>>2]|0;break}else if((B|0)==33){i=l;return C|0}}}while(0);C=(q|0)!=(f|0)|0;i=l;return C|0}function Zta(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=i;i=i+8|0;m=l;n=m;o=(e|0)==(f|0);a:do{if(o){c[k>>2]=h;c[g>>2]=e;p=e}else{q=e;while(1){r=q+1|0;if((a[q]|0)==0){s=q;break}if((r|0)==(f|0)){s=f;break}else{q=r}}c[k>>2]=h;c[g>>2]=e;if(o|(h|0)==(j|0)){p=e;break}q=j;r=b+8|0;t=e;u=h;v=s;while(1){w=d;x=c[w+4>>2]|0;y=m;c[y>>2]=c[w>>2];c[y+4>>2]=x;z=v;x=Kc(c[r>>2]|0)|0;y=Lva(u,g,z-t|0,q-u>>2,d)|0;if((x|0)!=0){Kc(x|0)|0}if((y|0)==-1){A=10;break}else if((y|0)==0){B=2;A=32;break}x=(c[k>>2]|0)+(y<<2)|0;c[k>>2]=x;if((x|0)==(j|0)){A=30;break}y=c[g>>2]|0;if((v|0)==(f|0)){C=y;D=x;E=f}else{w=Kc(c[r>>2]|0)|0;F=Kva(x,y,1,d)|0;if((w|0)!=0){Kc(w|0)|0}if((F|0)!=0){B=2;A=32;break}c[k>>2]=(c[k>>2]|0)+4;F=(c[g>>2]|0)+1|0;c[g>>2]=F;b:do{if((F|0)==(f|0)){G=f}else{w=F;while(1){y=w+1|0;if((a[w]|0)==0){G=w;break b}if((y|0)==(f|0)){G=f;break}else{w=y}}}}while(0);C=F;D=c[k>>2]|0;E=G}if((C|0)==(f|0)|(D|0)==(j|0)){p=C;break a}else{t=C;u=D;v=E}}if((A|0)==10){c[k>>2]=u;c:do{if((t|0)==(c[g>>2]|0)){H=t}else{v=t;q=u;while(1){w=Kc(c[r>>2]|0)|0;y=Kva(q,v,z-v|0,n)|0;if((w|0)!=0){Kc(w|0)|0}if((y|0)==-2){A=16;break}else if((y|0)==0){I=v+1|0}else if((y|0)==-1){A=15;break}else{I=v+y|0}y=(c[k>>2]|0)+4|0;c[k>>2]=y;if((I|0)==(c[g>>2]|0)){H=I;break c}else{v=I;q=y}}if((A|0)==15){c[g>>2]=v;B=2;i=l;return B|0}else if((A|0)==16){c[g>>2]=v;B=1;i=l;return B|0}}}while(0);c[g>>2]=H;B=(H|0)!=(f|0)|0;i=l;return B|0}else if((A|0)==30){p=c[g>>2]|0;break}else if((A|0)==32){i=l;return B|0}}}while(0);B=(p|0)!=(f|0)|0;i=l;return B|0}function _ta(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h;j=Kc(c[b+8>>2]|0)|0;b=Ova(e,0,d)|0;if((j|0)!=0){Kc(j|0)|0}if((b|0)==0|(b|0)==-1){k=2;i=h;return k|0}j=b+ -1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=b;m=j;n=e}while(1){e=a[n]|0;c[g>>2]=l+1;a[l]=e;e=m+ -1|0;if((e|0)==0){k=0;break}l=c[g>>2]|0;n=n+1|0;m=e}i=h;return k|0}function $ta(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+8|0;a=Kc(c[d>>2]|0)|0;e=Nva(0,0,4)|0;if((a|0)!=0){Kc(a|0)|0}do{if((e|0)==0){a=c[d>>2]|0;if((a|0)==0){f=1;break}g=Kc(a|0)|0;if((g|0)==0){f=0;break}Kc(g|0)|0;f=0}else{f=-1}}while(0);i=b;return f|0}function aua(a){a=a|0;i=i;return 0}function bua(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((f|0)==0|(d|0)==(e|0)){h=0;i=g;return h|0}j=e;k=a+8|0;a=d;d=0;l=0;while(1){m=Kc(c[k>>2]|0)|0;n=Jva(a,j-a|0,b)|0;if((m|0)!=0){Kc(m|0)|0}if((n|0)==-2|(n|0)==-1){h=d;o=9;break}else if((n|0)==0){p=a+1|0;q=1}else{p=a+n|0;q=n}n=q+d|0;m=l+1|0;if(m>>>0>=f>>>0|(p|0)==(e|0)){h=n;o=9;break}else{a=p;d=n;l=m}}if((o|0)==9){i=g;return h|0}return 0}function cua(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;do{if((d|0)==0){e=1}else{a=Kc(d|0)|0;if((a|0)==0){e=4;break}Kc(a|0)|0;e=4}}while(0);i=b;return e|0}function dua(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function eua(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=fua(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function fua(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;c[g>>2]=d;c[k>>2]=h;do{if((m&2|0)!=0){if((j-h|0)<3){o=1;i=n;return o|0}else{c[k>>2]=h+1;a[h]=-17;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-69;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-65;break}}}while(0);h=f;m=c[g>>2]|0;if(!(m>>>0<f>>>0)){o=0;i=n;return o|0}d=j;j=m;a:while(1){m=b[j>>1]|0;p=m&65535;if(p>>>0>l>>>0){o=2;q=26;break}do{if((m&65535)<128){r=c[k>>2]|0;if((d-r|0)<1){o=1;q=26;break a}c[k>>2]=r+1;a[r]=m}else{if((m&65535)<2048){r=c[k>>2]|0;if((d-r|0)<2){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>6|192;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((m&65535)<55296){r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if(!((m&65535)<56320)){if((m&65535)<57344){o=2;q=26;break a}r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((h-j|0)<4){o=1;q=26;break a}r=j+2|0;s=e[r>>1]|0;if((s&64512|0)!=56320){o=2;q=26;break a}if((d-(c[k>>2]|0)|0)<4){o=1;q=26;break a}t=p&960;if(((t<<10)+65536|p<<10&64512|s&1023)>>>0>l>>>0){o=2;q=26;break a}c[g>>2]=r;r=(t>>>6)+1|0;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=r>>>2|240;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=p>>>2&15|r<<4&48|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p<<4&48|s>>>6&15|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=s&63|128}}while(0);p=(c[g>>2]|0)+2|0;c[g>>2]=p;if(p>>>0<f>>>0){j=p}else{o=0;q=26;break}}if((q|0)==26){i=n;return o|0}return 0}function gua(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=hua(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function hua(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;c[g>>2]=e;c[k>>2]=h;h=c[g>>2]|0;do{if((m&4|0)==0){o=h}else{if((f-h|0)<=2){o=h;break}if(!((a[h]|0)==-17)){o=h;break}if(!((a[h+1|0]|0)==-69)){o=h;break}if(!((a[h+2|0]|0)==-65)){o=h;break}e=h+3|0;c[g>>2]=e;o=e}}while(0);a:do{if(o>>>0<f>>>0){h=f;m=j;e=o;p=c[k>>2]|0;b:while(1){if(!(p>>>0<j>>>0)){q=e;break a}r=a[e]|0;s=r&255;if(s>>>0>l>>>0){t=2;u=41;break}do{if(r<<24>>24>-1){b[p>>1]=r&255;c[g>>2]=e+1}else{if((r&255)<194){t=2;u=41;break b}if((r&255)<224){if((h-e|0)<2){t=1;u=41;break b}v=d[e+1|0]|0;if((v&192|0)!=128){t=2;u=41;break b}w=v&63|s<<6&1984;if(w>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=w;c[g>>2]=e+2;break}if((r&255)<240){if((h-e|0)<3){t=1;u=41;break b}w=a[e+1|0]|0;v=a[e+2|0]|0;if((s|0)==237){if(!((w&-32)<<24>>24==-128)){t=2;u=41;break b}}else if((s|0)==224){if(!((w&-32)<<24>>24==-96)){t=2;u=41;break b}}else{if(!((w&-64)<<24>>24==-128)){t=2;u=41;break b}}x=v&255;if((x&192|0)!=128){t=2;u=41;break b}v=(w&255)<<6&4032|s<<12|x&63;if((v&65535)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=v;c[g>>2]=e+3;break}if(!((r&255)<245)){t=2;u=41;break b}if((h-e|0)<4){t=1;u=41;break b}v=a[e+1|0]|0;x=a[e+2|0]|0;w=a[e+3|0]|0;if((s|0)==244){if(!((v&-16)<<24>>24==-128)){t=2;u=41;break b}}else if((s|0)==240){if(!((v+112<<24>>24&255)<48)){t=2;u=41;break b}}else{if(!((v&-64)<<24>>24==-128)){t=2;u=41;break b}}y=x&255;if((y&192|0)!=128){t=2;u=41;break b}x=w&255;if((x&192|0)!=128){t=2;u=41;break b}if((m-p|0)<4){t=1;u=41;break b}w=s&7;z=v&255;v=y<<6;A=x&63;if((z<<12&258048|w<<18|v&4032|A)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=z<<2&60|y>>>4&3|((z>>>4&3|w<<2)<<6)+16320|55296;w=p+2|0;c[k>>2]=w;b[w>>1]=A|v&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);s=(c[k>>2]|0)+2|0;c[k>>2]=s;r=c[g>>2]|0;if(r>>>0<f>>>0){e=r;p=s}else{q=r;break a}}if((u|0)==41){i=n;return t|0}}else{q=o}}while(0);t=q>>>0<f>>>0|0;i=n;return t|0}function iua(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function jua(a){a=a|0;i=i;return 0}function kua(a){a=a|0;i=i;return 0}function lua(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=mua(c,d,e,1114111,0)|0;i=b;return a|0}function mua(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k]|0;n=m&255;if(n>>>0>f>>>0){o=k;break a}do{if(m<<24>>24>-1){p=k+1|0;q=l}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}r=d[k+1|0]|0;if((r&192|0)!=128){o=k;break a}if((r&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;q=l;break}if((m&255)<240){s=k;if((g-s|0)<3){o=k;break a}r=a[k+1|0]|0;t=a[k+2|0]|0;if((n|0)==224){if(!((r&-32)<<24>>24==-96)){u=21;break b}}else if((n|0)==237){if(!((r&-32)<<24>>24==-128)){u=23;break b}}else{if(!((r&-64)<<24>>24==-128)){u=25;break b}}v=t&255;if((v&192|0)!=128){o=k;break a}if(((r&255)<<6&4032|n<<12&61440|v&63)>>>0>f>>>0){o=k;break a}p=k+3|0;q=l;break}if(!((m&255)<245)){o=k;break a}w=k;if((g-w|0)<4){o=k;break a}if((e-l|0)>>>0<2){o=k;break a}v=a[k+1|0]|0;r=a[k+2|0]|0;t=a[k+3|0]|0;if((n|0)==244){if(!((v&-16)<<24>>24==-128)){u=36;break b}}else if((n|0)==240){if(!((v+112<<24>>24&255)<48)){u=34;break b}}else{if(!((v&-64)<<24>>24==-128)){u=38;break b}}x=r&255;if((x&192|0)!=128){o=k;break a}r=t&255;if((r&192|0)!=128){o=k;break a}if(((v&255)<<12&258048|n<<18&1835008|x<<6&4032|r&63)>>>0>f>>>0){o=k;break a}p=k+4|0;q=l+1|0}}while(0);n=q+1|0;if(p>>>0<c>>>0&n>>>0<e>>>0){k=p;l=n}else{o=p;break a}}if((u|0)==21){y=s-b|0;i=h;return y|0}else if((u|0)==23){y=s-b|0;i=h;return y|0}else if((u|0)==25){y=s-b|0;i=h;return y|0}else if((u|0)==34){y=w-b|0;i=h;return y|0}else if((u|0)==36){y=w-b|0;i=h;return y|0}else if((u|0)==38){y=w-b|0;i=h;return y|0}}else{o=j}}while(0);y=o-b|0;i=h;return y|0}function nua(a){a=a|0;i=i;return 4}function oua(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function pua(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=qua(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function qua(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;c[e>>2]=b;c[h>>2]=f;do{if((k&2|0)!=0){if((g-f|0)<3){m=1;i=l;return m|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(!(f>>>0<d>>>0)){m=0;i=l;return m|0}k=g;g=f;a:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>j>>>0){m=2;n=19;break}do{if(f>>>0<128){b=c[h>>2]|0;if((k-b|0)<1){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048){b=c[h>>2]|0;if((k-b|0)<2){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;o=k-b|0;if(f>>>0<65536){if((o|0)<3){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>12|224;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f>>>6&63|128;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f&63|128;break}else{if((o|0)<4){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{m=0;n=19;break}}if((n|0)==19){i=l;return m|0}return 0}function rua(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=sua(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function sua(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;c[f>>2]=b;c[j>>2]=g;g=c[f>>2]|0;do{if((l&4|0)==0){n=g}else{if((e-g|0)<=2){n=g;break}if(!((a[g]|0)==-17)){n=g;break}if(!((a[g+1|0]|0)==-69)){n=g;break}if(!((a[g+2|0]|0)==-65)){n=g;break}b=g+3|0;c[f>>2]=b;n=b}}while(0);a:do{if(n>>>0<e>>>0){g=e;l=n;b=c[j>>2]|0;b:while(1){if(!(b>>>0<h>>>0)){o=l;break a}p=a[l]|0;q=p&255;do{if(p<<24>>24>-1){if(q>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=q;c[f>>2]=l+1}else{if((p&255)<194){r=2;s=40;break b}if((p&255)<224){if((g-l|0)<2){r=1;s=40;break b}t=d[l+1|0]|0;if((t&192|0)!=128){r=2;s=40;break b}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+2;break}if((p&255)<240){if((g-l|0)<3){r=1;s=40;break b}u=a[l+1|0]|0;t=a[l+2|0]|0;if((q|0)==237){if(!((u&-32)<<24>>24==-128)){r=2;s=40;break b}}else if((q|0)==224){if(!((u&-32)<<24>>24==-96)){r=2;s=40;break b}}else{if(!((u&-64)<<24>>24==-128)){r=2;s=40;break b}}v=t&255;if((v&192|0)!=128){r=2;s=40;break b}t=(u&255)<<6&4032|q<<12&61440|v&63;if(t>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=t;c[f>>2]=l+3;break}if(!((p&255)<245)){r=2;s=40;break b}if((g-l|0)<4){r=1;s=40;break b}t=a[l+1|0]|0;v=a[l+2|0]|0;u=a[l+3|0]|0;if((q|0)==240){if(!((t+112<<24>>24&255)<48)){r=2;s=40;break b}}else if((q|0)==244){if(!((t&-16)<<24>>24==-128)){r=2;s=40;break b}}else{if(!((t&-64)<<24>>24==-128)){r=2;s=40;break b}}w=v&255;if((w&192|0)!=128){r=2;s=40;break b}v=u&255;if((v&192|0)!=128){r=2;s=40;break b}u=(t&255)<<12&258048|q<<18&1835008|w<<6&4032|v&63;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+4}}while(0);q=(c[j>>2]|0)+4|0;c[j>>2]=q;p=c[f>>2]|0;if(p>>>0<e>>>0){l=p;b=q}else{o=p;break a}}if((s|0)==40){i=m;return r|0}}else{o=n}}while(0);r=o>>>0<e>>>0|0;i=m;return r|0}function tua(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function uua(a){a=a|0;i=i;return 0}function vua(a){a=a|0;i=i;return 0}function wua(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=xua(c,d,e,1114111,0)|0;i=b;return a|0}function xua(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=1;b:while(1){m=a[k]|0;n=m&255;do{if(m<<24>>24>-1){if(n>>>0>f>>>0){o=k;break a}p=k+1|0}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}q=d[k+1|0]|0;if((q&192|0)!=128){o=k;break a}if((q&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;break}if((m&255)<240){r=k;if((g-r|0)<3){o=k;break a}q=a[k+1|0]|0;s=a[k+2|0]|0;if((n|0)==224){if(!((q&-32)<<24>>24==-96)){t=21;break b}}else if((n|0)==237){if(!((q&-32)<<24>>24==-128)){t=23;break b}}else{if(!((q&-64)<<24>>24==-128)){t=25;break b}}u=s&255;if((u&192|0)!=128){o=k;break a}if(((q&255)<<6&4032|n<<12&61440|u&63)>>>0>f>>>0){o=k;break a}p=k+3|0;break}if(!((m&255)<245)){o=k;break a}v=k;if((g-v|0)<4){o=k;break a}u=a[k+1|0]|0;q=a[k+2|0]|0;s=a[k+3|0]|0;if((n|0)==240){if(!((u+112<<24>>24&255)<48)){t=33;break b}}else if((n|0)==244){if(!((u&-16)<<24>>24==-128)){t=35;break b}}else{if(!((u&-64)<<24>>24==-128)){t=37;break b}}w=q&255;if((w&192|0)!=128){o=k;break a}q=s&255;if((q&192|0)!=128){o=k;break a}if(((u&255)<<12&258048|n<<18&1835008|w<<6&4032|q&63)>>>0>f>>>0){o=k;break a}p=k+4|0}}while(0);if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}k=p;l=l+1|0}if((t|0)==21){x=r-b|0;i=h;return x|0}else if((t|0)==23){x=r-b|0;i=h;return x|0}else if((t|0)==25){x=r-b|0;i=h;return x|0}else if((t|0)==33){x=v-b|0;i=h;return x|0}else if((t|0)==35){x=v-b|0;i=h;return x|0}else if((t|0)==37){x=v-b|0;i=h;return x|0}}else{o=j}}while(0);x=o-b|0;i=h;return x|0}function yua(a){a=a|0;i=i;return 4}function zua(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function Aua(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function Bua(a){a=a|0;var b=0;b=i;c[a>>2]=145400;Ema(a+12|0);Rwa(a);i=b;return}function Cua(a){a=a|0;var b=0;b=i;c[a>>2]=145400;Ema(a+12|0);i=b;return}function Dua(a){a=a|0;var b=0;b=i;c[a>>2]=145440;Ema(a+16|0);Rwa(a);i=b;return}function Eua(a){a=a|0;var b=0;b=i;c[a>>2]=145440;Ema(a+16|0);i=b;return}function Fua(b){b=b|0;i=i;return a[b+8|0]|0}function Gua(a){a=a|0;i=i;return c[a+8>>2]|0}function Hua(b){b=b|0;i=i;return a[b+9|0]|0}function Iua(a){a=a|0;i=i;return c[a+12>>2]|0}function Jua(a,b){a=a|0;b=b|0;var c=0;c=i;uma(a,b+12|0);i=c;return}function Kua(a,b){a=a|0;b=b|0;var c=0;c=i;uma(a,b+16|0);i=c;return}function Lua(a,b){a=a|0;b=b|0;b=i;wma(a,145472,4);i=b;return}function Mua(a,b){a=a|0;b=b|0;b=i;ena(a,145480,jwa(145480)|0);i=b;return}function Nua(a,b){a=a|0;b=b|0;b=i;wma(a,145504,5);i=b;return}function Oua(a,b){a=a|0;b=b|0;b=i;ena(a,145512,jwa(145512)|0);i=b;return}function Pua(b){b=b|0;var d=0,e=0;b=i;if((a[145544]|0)!=0){d=145536;e=c[36384]|0;i=b;return e|0}if((Ya(145544)|0)==0){d=145536;e=c[36384]|0;i=b;return e|0}do{if((a[152744]|0)==0){if((Ya(152744)|0)==0){break}pxa(152576,0,168)|0;Rd(967,0,q|0)|0;Sb(152744)}}while(0);Hma(152576,152752)|0;Hma(152588|0,152760)|0;Hma(152600|0,152768)|0;Hma(152612|0,152776)|0;Hma(152624|0,152792)|0;Hma(152636|0,152808)|0;Hma(152648|0,152816)|0;Hma(152660|0,152832)|0;Hma(152672|0,152840)|0;Hma(152684|0,152848)|0;Hma(152696|0,152856)|0;Hma(152708|0,152864)|0;Hma(152720|0,152872)|0;Hma(152732|0,152880)|0;c[36384]=152576;Sb(145544);d=145536;e=c[36384]|0;i=b;return e|0}function Qua(b){b=b|0;var d=0,e=0;b=i;if((a[145560]|0)!=0){d=145552;e=c[36388]|0;i=b;return e|0}if((Ya(145560)|0)==0){d=145552;e=c[36388]|0;i=b;return e|0}do{if((a[152208]|0)==0){if((Ya(152208)|0)==0){break}pxa(152040,0,168)|0;Rd(968,0,q|0)|0;Sb(152208)}}while(0);hna(152040,152216)|0;hna(152052|0,152248)|0;hna(152064|0,152280)|0;hna(152076|0,152312)|0;hna(152088|0,152352)|0;hna(152100|0,152392)|0;hna(152112|0,152424)|0;hna(152124|0,152464)|0;hna(152136|0,152480)|0;hna(152148|0,152496)|0;hna(152160|0,152512)|0;hna(152172|0,152528)|0;hna(152184|0,152544)|0;hna(152196|0,152560)|0;c[36388]=152040;Sb(145560);d=145552;e=c[36388]|0;i=b;return e|0}function Rua(b){b=b|0;var d=0,e=0;b=i;if((a[145576]|0)!=0){d=145568;e=c[36392]|0;i=b;return e|0}if((Ya(145576)|0)==0){d=145568;e=c[36392]|0;i=b;return e|0}do{if((a[151816]|0)==0){if((Ya(151816)|0)==0){break}pxa(151528,0,288)|0;Rd(969,0,q|0)|0;Sb(151816)}}while(0);Hma(151528,151824)|0;Hma(151540|0,151832)|0;Hma(151552|0,151848)|0;Hma(151564|0,151856)|0;Hma(151576|0,151864)|0;Hma(151588|0,151872)|0;Hma(151600|0,151880)|0;Hma(151612|0,151888)|0;Hma(151624|0,151896)|0;Hma(151636|0,151912)|0;Hma(151648|0,151920)|0;Hma(151660|0,151936)|0;Hma(151672|0,151952)|0;Hma(151684|0,151960)|0;Hma(151696|0,151968)|0;Hma(151708|0,151976)|0;Hma(151720|0,151864)|0;Hma(151732|0,151984)|0;Hma(151744|0,151992)|0;Hma(151756|0,152e3)|0;Hma(151768|0,152008)|0;Hma(151780|0,152016)|0;Hma(151792|0,152024)|0;Hma(151804|0,152032)|0;c[36392]=151528;Sb(145576);d=145568;e=c[36392]|0;i=b;return e|0}function Sua(b){b=b|0;var d=0,e=0;b=i;if((a[145592]|0)!=0){d=145584;e=c[36396]|0;i=b;return e|0}if((Ya(145592)|0)==0){d=145584;e=c[36396]|0;i=b;return e|0}do{if((a[150976]|0)==0){if((Ya(150976)|0)==0){break}pxa(150688,0,288)|0;Rd(970,0,q|0)|0;Sb(150976)}}while(0);hna(150688,150984)|0;hna(150700|0,151016)|0;hna(150712|0,151056)|0;hna(150724|0,151080)|0;hna(150736|0,151400)|0;hna(150748|0,151104)|0;hna(150760|0,151128)|0;hna(150772|0,151152)|0;hna(150784|0,151184)|0;hna(150796|0,151224)|0;hna(150808|0,151256)|0;hna(150820|0,151296)|0;hna(150832|0,151336)|0;hna(150844|0,151352)|0;hna(150856|0,151368)|0;hna(150868|0,151384)|0;hna(150880|0,151400)|0;hna(150892|0,151416)|0;hna(150904|0,151432)|0;hna(150916|0,151448)|0;hna(150928|0,151464)|0;hna(150940|0,151480)|0;hna(150952|0,151496)|0;hna(150964|0,151512)|0;c[36396]=150688;Sb(145592);d=145584;e=c[36396]|0;i=b;return e|0}function Tua(b){b=b|0;var d=0,e=0;b=i;if((a[145608]|0)!=0){d=145600;e=c[36400]|0;i=b;return e|0}if((Ya(145608)|0)==0){d=145600;e=c[36400]|0;i=b;return e|0}do{if((a[150664]|0)==0){if((Ya(150664)|0)==0){break}pxa(150376,0,288)|0;Rd(971,0,q|0)|0;Sb(150664)}}while(0);Hma(150376,150672)|0;Hma(150388|0,150680)|0;c[36400]=150376;Sb(145608);d=145600;e=c[36400]|0;i=b;return e|0}function Uua(b){b=b|0;var d=0,e=0;b=i;if((a[145624]|0)!=0){d=145616;e=c[36404]|0;i=b;return e|0}if((Ya(145624)|0)==0){d=145616;e=c[36404]|0;i=b;return e|0}do{if((a[150336]|0)==0){if((Ya(150336)|0)==0){break}pxa(150048,0,288)|0;Rd(972,0,q|0)|0;Sb(150336)}}while(0);hna(150048,150344)|0;hna(150060|0,150360)|0;c[36404]=150048;Sb(145624);d=145616;e=c[36404]|0;i=b;return e|0}function Vua(b){b=b|0;var c=0;b=i;if((a[145648]|0)!=0){c=145632;i=b;return c|0}if((Ya(145648)|0)==0){c=145632;i=b;return c|0}wma(145632,145656,8);Rd(973,145632,q|0)|0;Sb(145648);c=145632;i=b;return c|0}function Wua(b){b=b|0;var c=0;b=i;if((a[145688]|0)!=0){c=145672;i=b;return c|0}if((Ya(145688)|0)==0){c=145672;i=b;return c|0}ena(145672,145696,jwa(145696)|0);Rd(974,145672,q|0)|0;Sb(145688);c=145672;i=b;return c|0}function Xua(b){b=b|0;var c=0;b=i;if((a[145752]|0)!=0){c=145736;i=b;return c|0}if((Ya(145752)|0)==0){c=145736;i=b;return c|0}wma(145736,145760,8);Rd(973,145736,q|0)|0;Sb(145752);c=145736;i=b;return c|0}function Yua(b){b=b|0;var c=0;b=i;if((a[145792]|0)!=0){c=145776;i=b;return c|0}if((Ya(145792)|0)==0){c=145776;i=b;return c|0}ena(145776,145800,jwa(145800)|0);Rd(974,145776,q|0)|0;Sb(145792);c=145776;i=b;return c|0}function Zua(b){b=b|0;var c=0;b=i;if((a[145856]|0)!=0){c=145840;i=b;return c|0}if((Ya(145856)|0)==0){c=145840;i=b;return c|0}wma(145840,145864,20);Rd(973,145840,q|0)|0;Sb(145856);c=145840;i=b;return c|0}function _ua(b){b=b|0;var c=0;b=i;if((a[145904]|0)!=0){c=145888;i=b;return c|0}if((Ya(145904)|0)==0){c=145888;i=b;return c|0}ena(145888,145912,jwa(145912)|0);Rd(974,145888,q|0)|0;Sb(145904);c=145888;i=b;return c|0}function $ua(b){b=b|0;var c=0;b=i;if((a[146016]|0)!=0){c=146e3;i=b;return c|0}if((Ya(146016)|0)==0){c=146e3;i=b;return c|0}wma(146e3,146024,11);Rd(973,146e3,q|0)|0;Sb(146016);c=146e3;i=b;return c|0}function ava(b){b=b|0;var c=0;b=i;if((a[146056]|0)!=0){c=146040;i=b;return c|0}if((Ya(146056)|0)==0){c=146040;i=b;return c|0}ena(146040,146064,jwa(146064)|0);Rd(974,146040,q|0)|0;Sb(146056);c=146040;i=b;return c|0}function bva(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Mc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);l=+fxa(b,g,c[36280]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function cva(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Mc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);l=+fxa(b,g,c[36280]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function dva(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Mc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);l=+fxa(b,g,c[36280]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=l;i=f;return+h}function eva(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Mc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);n=kb(b|0,h|0,f|0,c[36280]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)!=34){j=n;k=f;J=k;i=g;return j|0}c[e>>2]=4;j=-1;k=-1;J=k;i=g;return j|0}function fva(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Mc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);m=kb(b|0,h|0,f|0,c[36280]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function gva(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Mc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);m=kb(b|0,h|0,f|0,c[36280]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function hva(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Mc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);m=kb(b|0,h|0,f|0,c[36280]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>65535)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function iva(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Mc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);n=Fc(b|0,h|0,f|0,c[36280]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)==34){c[e>>2]=4;e=(f|0)>0|(f|0)==0&n>>>0>0;J=e?2147483647:-2147483648;i=g;return(e?-1:0)|0}else{j=n;k=f;J=k;i=g;return j|0}return 0}function jva(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=Mc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[145128]|0)==0){if((Ya(145128)|0)==0){break}c[36280]=Yb(2147483647,145136,0)|0;Sb(145128)}}while(0);m=Fc(b|0,h|0,f|0,c[36280]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}do{if((b|0)==34){c[e>>2]=4;if((f|0)>0|(f|0)==0&m>>>0>0){j=2147483647}else{break}i=g;return j|0}else{if((f|0)<-1|(f|0)==-1&m>>>0<2147483648){c[e>>2]=4;break}if((f|0)>0|(f|0)==0&m>>>0>2147483647){c[e>>2]=4;j=2147483647;i=g;return j|0}else{j=m;i=g;return j|0}}}while(0);j=-2147483648;i=g;return j|0}function kva(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;e=a+4|0;f=e;g=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=e+4|0;e=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=(c[a>>2]|0)+(e>>1)|0;a=f;if((e&1|0)==0){h=g;Zd[h&1023](a);i=b;return}else{h=c[(c[f>>2]|0)+g>>2]|0;Zd[h&1023](a);i=b;return}}function lva(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b+8|0;g=b+4|0;h=c[g>>2]|0;j=c[f>>2]|0;k=h;if(!(j-k>>2>>>0<d>>>0)){l=d;m=h;do{if((m|0)==0){n=0}else{c[m>>2]=0;n=c[g>>2]|0}m=n+4|0;c[g>>2]=m;l=l+ -1|0;}while((l|0)!=0);i=e;return}l=b+16|0;m=b;n=c[m>>2]|0;h=k-n>>2;k=h+d|0;if(k>>>0>1073741823){eta(0)}o=j-n|0;do{if(o>>2>>>0<536870911){n=o>>1;j=n>>>0<k>>>0?k:n;if((j|0)==0){p=0;q=0;break}n=b+128|0;if(!((a[n]|0)==0&j>>>0<29)){r=j;s=11;break}a[n]=1;p=j;q=l}else{r=1073741823;s=11}}while(0);if((s|0)==11){p=r;q=Pwa(r<<2)|0}r=d;d=q+(h<<2)|0;do{if((d|0)==0){t=0}else{c[d>>2]=0;t=d}d=t+4|0;r=r+ -1|0;}while((r|0)!=0);r=c[m>>2]|0;t=(c[g>>2]|0)-r|0;s=q+(h-(t>>2)<<2)|0;h=r;nxa(s|0,h|0,t|0)|0;c[m>>2]=s;c[g>>2]=d;c[f>>2]=q+(p<<2);if((r|0)==0){i=e;return}if((l|0)==(r|0)){a[b+128|0]=0;i=e;return}else{Rwa(h);i=e;return}}function mva(a){a=a|0;a=i;gna(150324|0);gna(150312|0);gna(150300|0);gna(150288|0);gna(150276|0);gna(150264|0);gna(150252|0);gna(150240|0);gna(150228|0);gna(150216|0);gna(150204|0);gna(150192|0);gna(150180|0);gna(150168|0);gna(150156|0);gna(150144|0);gna(150132|0);gna(150120|0);gna(150108|0);gna(150096|0);gna(150084|0);gna(150072|0);gna(150060|0);gna(150048);i=a;return}function nva(a){a=a|0;a=i;Ema(150652|0);Ema(150640|0);Ema(150628|0);Ema(150616|0);Ema(150604|0);Ema(150592|0);Ema(150580|0);Ema(150568|0);Ema(150556|0);Ema(150544|0);Ema(150532|0);Ema(150520|0);Ema(150508|0);Ema(150496|0);Ema(150484|0);Ema(150472|0);Ema(150460|0);Ema(150448|0);Ema(150436|0);Ema(150424|0);Ema(150412|0);Ema(150400|0);Ema(150388|0);Ema(150376);i=a;return}function ova(a){a=a|0;a=i;gna(150964|0);gna(150952|0);gna(150940|0);gna(150928|0);gna(150916|0);gna(150904|0);gna(150892|0);gna(150880|0);gna(150868|0);gna(150856|0);gna(150844|0);gna(150832|0);gna(150820|0);gna(150808|0);gna(150796|0);gna(150784|0);gna(150772|0);gna(150760|0);gna(150748|0);gna(150736|0);gna(150724|0);gna(150712|0);gna(150700|0);gna(150688);i=a;return}function pva(a){a=a|0;a=i;Ema(151804|0);Ema(151792|0);Ema(151780|0);Ema(151768|0);Ema(151756|0);Ema(151744|0);Ema(151732|0);Ema(151720|0);Ema(151708|0);Ema(151696|0);Ema(151684|0);Ema(151672|0);Ema(151660|0);Ema(151648|0);Ema(151636|0);Ema(151624|0);Ema(151612|0);Ema(151600|0);Ema(151588|0);Ema(151576|0);Ema(151564|0);Ema(151552|0);Ema(151540|0);Ema(151528);i=a;return}function qva(a){a=a|0;a=i;gna(152196|0);gna(152184|0);gna(152172|0);gna(152160|0);gna(152148|0);gna(152136|0);gna(152124|0);gna(152112|0);gna(152100|0);gna(152088|0);gna(152076|0);gna(152064|0);gna(152052|0);gna(152040);i=a;return}function rva(a){a=a|0;a=i;Ema(152732|0);Ema(152720|0);Ema(152708|0);Ema(152696|0);Ema(152684|0);Ema(152672|0);Ema(152660|0);Ema(152648|0);Ema(152636|0);Ema(152624|0);Ema(152612|0);Ema(152600|0);Ema(152588|0);Ema(152576);i=a;return}function sva(a){a=a|0;var b=0,c=0;b=i;if((yva(a)|0)==0){c=(tva(a)|0)!=0|0}else{c=1}i=b;return c|0}function tva(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<131072){c=(d[152888+((d[152888+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}else{c=a>>>0<196606|0;i=b;return c|0}return 0}function uva(a){a=a|0;var b=0,c=0;b=i;c=wb(a|0)|0;i=b;return c|0}function vva(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<32|(a+ -127|0)>>>0<33|(a+ -8232|0)>>>0<2){c=1;i=b;return c|0}c=(a+ -65529|0)>>>0<3|0;i=b;return c|0}function wva(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;switch(b|0){case 7:{d=Ava(a)|0;break};case 9:{d=Cva(a)|0;break};case 10:{d=Dva(a)|0;break};case 8:{d=Bva(a)|0;break};case 12:{d=Fva(a)|0;break};case 5:{d=yva(a)|0;break};case 3:{d=uva(a)|0;break};case 4:{d=vva(a)|0;break};case 11:{d=Eva(a)|0;break};case 6:{d=zva(a)|0;break};case 2:{d=tva(a)|0;break};case 1:{d=sva(a)|0;break};default:{d=0}}i=c;return d|0}function xva(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;c=i;d=a[b]|0;e=97;f=1;g=155864;while(1){if(d<<24>>24==e<<24>>24){if((hxa(b,g)|0)==0){h=f;j=5;break}}k=g+6|0;l=a[k]|0;if(l<<24>>24==0){h=0;j=5;break}else{e=l;f=f+1|0;g=k}}if((j|0)==5){i=c;return h|0}return 0}function yva(a){a=a|0;i=i;return(a+ -48|0)>>>0<10|0}function zva(a){a=a|0;var b=0,c=0;b=i;if((Dva(a)|0)==0){c=(Bva(a)|0)!=0|0}else{c=0}i=b;return c|0}function Ava(a){a=a|0;var b=0,c=0;b=i;if((Gva(a)|0)==(a|0)){c=(a|0)==223|0}else{c=1}i=b;return c|0}function Bva(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<255){c=(a+1&127)>>>0>32|0;i=b;return c|0}if(a>>>0<8232|(a+ -8234|0)>>>0<47062|(a+ -57344|0)>>>0<8185){c=1;i=b;return c|0}else{i=b;return((a+ -65532|0)>>>0>1048579|(a&65534|0)==65534)&1^1|0}return 0}function Cva(a){a=a|0;var b=0,c=0;b=i;if(!(a>>>0<131072)){c=0;i=b;return c|0}c=(d[155944+((d[155944+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}function Dva(a){a=a|0;var b=0,c=0;b=i;c=(iwa(159112,a)|0)!=0|0;i=b;return c|0}function Eva(a){a=a|0;var b=0,c=0;b=i;c=(Iva(a)|0)!=(a|0)|0;i=b;return c|0}function Fva(a){a=a|0;var b=0,c=0;b=i;if((a+ -48|0)>>>0<10){c=1;i=b;return c|0}c=((a|32)+ -97|0)>>>0<6|0;i=b;return c|0}function Gva(a){a=a|0;var b=0,c=0;b=i;c=Hva(a,0)|0;i=b;return c|0}function Hva(c,f){c=c|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=(f<<1)+ -1|0;j=f+ -1|0;if((tva(c)|0)==0|(c+ -1536|0)>>>0<2560|(c+ -11776|0)>>>0<30784|(c+ -43008|0)>>>0<22272){k=c;i=g;return k|0}do{if((f|0)==0){if(!((c+ -11520|0)>>>0<38)){l=0;break}k=c+ -7264|0;i=g;return k|0}else{if(!((c+ -4256|0)>>>0<46)){l=0;break}do{if((c|0)>4293){if((c|0)==4295|(c|0)==4301){break}else{k=c}i=g;return k|0}}while(0);k=c+7264|0;i=g;return k|0}}while(0);while(1){m=a[159202+(l<<2)|0]|0;n=m<<24>>24;o=c-(e[159200+(l<<2)>>1]|0)|0;p=l+1|0;if((o-(n&j)|0)>>>0<(d[159203+(l<<2)|0]|0)>>>0){q=12;break}if((p|0)==61){break}else{l=p}}if((q|0)==12){if(m<<24>>24==1){k=f+c-(o&1)|0;i=g;return k|0}else{k=(fa(n,h)|0)+c|0;i=g;return k|0}}h=1-f|0;n=b[159448+(h<<1)>>1]|0;a:do{if(!(n<<16>>16==0)){o=n;m=0;while(1){q=m+1|0;if((o&65535|0)==(c|0)){break}l=b[159448+(q<<2)+(h<<1)>>1]|0;if(l<<16>>16==0){break a}else{o=l;m=q}}k=e[159448+(m<<2)+(f<<1)>>1]|0;i=g;return k|0}}while(0);if(!((c+ -66600+(f*40|0)|0)>>>0<40)){k=c;i=g;return k|0}k=c+ -40+(f*80|0)|0;i=g;return k|0}function Iva(a){a=a|0;var b=0,c=0;b=i;c=Hva(a,1)|0;i=b;return c|0}function Jva(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=Kva(0,a,b,(c|0)!=0?c:160152)|0;i=d;return e|0}function Kva(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+8|0;h=g;c[h>>2]=b;j=(f|0)==0?160160:f;f=c[j>>2]|0;a:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n+ -194|0;if(l>>>0>50){break a}o=e+ -1|0;p=c[159944+(l<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}}while(0);b:do{if((o|0)==0){r=p}else{l=a[q]|0;n=(l&255)>>>3;if((n+ -16|n+(p>>26))>>>0>7){break a}else{s=o;t=l;u=p;v=q}while(1){v=v+1|0;u=(t&255)+ -128|u<<6;s=s+ -1|0;if((u|0)>=0){break}if((s|0)==0){r=u;break b}t=a[v]|0;if(((t&255)+ -128|0)>>>0>63){break a}}c[j>>2]=0;c[m>>2]=u;k=e-s|0;i=g;return k|0}}while(0);c[j>>2]=r;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(Mc()|0)>>2]=84;k=-1;i=g;return k|0}function Lva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+1032|0;h=g+1024|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=g;m=k?e:256;e=k?a:l;a:do{if((j|0)==0|(m|0)==0){n=d;o=m;p=j;q=0;r=e}else{a=d;s=m;t=j;u=0;v=e;while(1){w=a>>>2;x=w>>>0>=s>>>0;if(!(x|a>>>0>131)){n=a;o=s;p=t;q=u;r=v;break a}y=x?s:w;z=a-y|0;w=Mva(v,h,y,f)|0;if((w|0)==-1){break}if((v|0)==(l|0)){A=s;B=l}else{A=s-w|0;B=v+(w<<2)|0}y=w+u|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){n=z;o=A;p=w;q=y;r=B;break a}else{a=z;s=A;t=w;u=y;v=B}}n=z;o=0;p=c[h>>2]|0;q=-1;r=v}}while(0);b:do{if((p|0)==0){C=q}else{if((o|0)==0|(n|0)==0){C=q;break}else{D=n;E=o;F=p;G=q;H=r}while(1){I=Kva(H,F,D,f)|0;if((I+2|0)>>>0<3){break}z=(c[h>>2]|0)+I|0;c[h>>2]=z;B=E+ -1|0;A=G+1|0;if((B|0)==0|(D|0)==(I|0)){C=A;break b}else{D=D-I|0;E=B;F=z;G=A;H=H+4|0}}if((I|0)==0){c[h>>2]=0;C=G;break}else if((I|0)==-1){C=-1;break}else{c[f>>2]=0;C=G;break}}}while(0);if(!k){i=g;return C|0}c[b>>2]=c[h>>2];i=g;return C|0}function Mva(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;h=i;j=c[e>>2]|0;do{if((g|0)==0){k=5}else{l=g;m=c[l>>2]|0;if((m|0)==0){k=5;break}if((b|0)==0){n=f;o=m;p=j;k=16;break}c[l>>2]=0;q=b;r=f;s=m;t=j;k=36}}while(0);if((k|0)==5){if((b|0)==0){u=f;v=j;k=7}else{w=b;x=f;y=j;k=6}}a:while(1){if((k|0)==6){k=0;if((x|0)==0){z=f;k=53;break}else{A=w;B=x;C=y}while(1){j=a[C]|0;do{if(((j&255)+ -1|0)>>>0<127){if((C&3|0)==0&B>>>0>3){D=A;E=B;F=C}else{G=A;H=B;I=j;J=C;break}while(1){K=c[F>>2]|0;if(((K+ -16843009|K)&-2139062144|0)!=0){k=30;break}c[D>>2]=K&255;c[D+4>>2]=d[F+1|0]|0;c[D+8>>2]=d[F+2|0]|0;L=F+4|0;M=D+16|0;c[D+12>>2]=d[F+3|0]|0;N=E+ -4|0;if(N>>>0>3){D=M;E=N;F=L}else{k=31;break}}if((k|0)==30){k=0;G=D;H=E;I=K&255;J=F;break}else if((k|0)==31){k=0;G=M;H=N;I=a[L]|0;J=L;break}}else{G=A;H=B;I=j;J=C}}while(0);O=I&255;if(!((O+ -1|0)>>>0<127)){break}c[G>>2]=O;j=H+ -1|0;if((j|0)==0){z=f;k=53;break a}else{A=G+4|0;B=j;C=J+1|0}}j=O+ -194|0;if(j>>>0>50){P=G;Q=H;R=J;k=47;break}q=G;r=H;s=c[159944+(j<<2)>>2]|0;t=J+1|0;k=36;continue}else if((k|0)==7){k=0;j=a[v]|0;do{if(((j&255)+ -1|0)>>>0<127){if((v&3|0)!=0){S=u;T=j;U=v;break}g=c[v>>2]|0;if(((g+ -16843009|g)&-2139062144|0)==0){V=u;W=v}else{S=u;T=g&255;U=v;break}do{W=W+4|0;V=V+ -4|0;X=c[W>>2]|0;}while(((X+ -16843009|X)&-2139062144|0)==0);S=V;T=X&255;U=W}else{S=u;T=j;U=v}}while(0);j=T&255;if((j+ -1|0)>>>0<127){u=S+ -1|0;v=U+1|0;k=7;continue}g=j+ -194|0;if(g>>>0>50){P=b;Q=S;R=U;k=47;break}n=S;o=c[159944+(g<<2)>>2]|0;p=U+1|0;k=16;continue}else if((k|0)==16){k=0;g=(d[p]|0)>>>3;if((g+ -16|g+(o>>26))>>>0>7){k=17;break}g=p+1|0;do{if((o&33554432|0)==0){Y=g}else{if(((d[g]|0)+ -128|0)>>>0>63){k=20;break a}j=p+2|0;if((o&524288|0)==0){Y=j;break}if(((d[j]|0)+ -128|0)>>>0>63){k=23;break a}Y=p+3|0}}while(0);u=n+ -1|0;v=Y;k=7;continue}else if((k|0)==36){k=0;g=d[t]|0;j=g>>>3;if((j+ -16|j+(s>>26))>>>0>7){k=37;break}j=t+1|0;Z=g+ -128|s<<6;do{if((Z|0)<0){g=(d[j]|0)+ -128|0;if(g>>>0>63){k=40;break a}m=t+2|0;_=g|Z<<6;if((_|0)>=0){$=_;aa=m;break}g=(d[m]|0)+ -128|0;if(g>>>0>63){k=43;break a}$=g|_<<6;aa=t+3|0}else{$=Z;aa=j}}while(0);c[q>>2]=$;w=q+4|0;x=r+ -1|0;y=aa;k=6;continue}}if((k|0)==17){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==20){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==23){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==37){ba=q;ca=r;da=s;ea=t+ -1|0;k=46}else if((k|0)==40){ba=q;ca=r;da=Z;ea=t+ -1|0;k=46}else if((k|0)==43){ba=q;ca=r;da=_;ea=t+ -1|0;k=46}else if((k|0)==53){i=h;return z|0}if((k|0)==46){if((da|0)==0){P=ba;Q=ca;R=ea;k=47}else{fa=ba;ga=ea}}do{if((k|0)==47){if((a[R]|0)!=0){fa=P;ga=R;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}z=f-Q|0;i=h;return z|0}}while(0);c[(Mc()|0)>>2]=84;if((fa|0)==0){z=-1;i=h;return z|0}c[e>>2]=ga;z=-1;i=h;return z|0}function Nva(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m+ -194|0;if(k>>>0>50){break}m=e+1|0;n=c[159944+(k<<2)>>2]|0;if(f>>>0<4){if((n&-2147483648>>>((f*6|0)+ -6|0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m+ -16|m+(n>>26))>>>0>7){break}m=k+ -128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)+ -128|0;if(n>>>0>63){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)+ -128|0;if(m>>>0>63){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(Mc()|0)>>2]=84;j=-1;i=g;return j|0}function Ova(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((b|0)==0){f=1;i=e;return f|0}if(d>>>0<128){a[b]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d+ -57344|0)>>>0<8192){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;i=e;return f|0}if((d+ -65536|0)>>>0<1048576){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;i=e;return f|0}else{c[(Mc()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function Pva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+264|0;g=f+256|0;h=f;j=c[b>>2]|0;c[g>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:h;a:do{if((j|0)==0|(l|0)==0){m=d;n=l;o=j;p=0;q=e}else{a=d;r=l;s=j;t=0;u=e;while(1){v=a>>>0>=r>>>0;if(!(v|a>>>0>32)){m=a;n=r;o=s;p=t;q=u;break a}w=v?r:a;x=a-w|0;v=Qva(u,g,w,0)|0;if((v|0)==-1){break}if((u|0)==(h|0)){y=r;z=h}else{y=r-v|0;z=u+v|0}w=v+t|0;v=c[g>>2]|0;if((v|0)==0|(y|0)==0){m=x;n=y;o=v;p=w;q=z;break a}else{a=x;r=y;s=v;t=w;u=z}}m=x;n=0;o=c[g>>2]|0;p=-1;q=u}}while(0);b:do{if((o|0)==0){A=p}else{if((n|0)==0|(m|0)==0){A=p;break}else{B=m;C=n;D=o;E=p;F=q}while(1){G=Ova(F,c[D>>2]|0,0)|0;if((G+1|0)>>>0<2){break}x=(c[g>>2]|0)+4|0;c[g>>2]=x;z=B+ -1|0;y=E+1|0;if((C|0)==(G|0)|(z|0)==0){A=y;break b}else{B=z;C=C-G|0;D=x;E=y;F=F+G|0}}if((G|0)!=0){A=-1;break}c[g>>2]=0;A=E}}while(0);if(!k){i=f;return A|0}c[b>>2]=c[g>>2];i=f;return A|0}function Qva(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f;if((b|0)==0){h=c[d>>2]|0;j=g;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=k;o=h}while(1){if(n>>>0>127){h=Ova(j,n,0)|0;if((h|0)==-1){l=-1;p=26;break}else{q=h}}else{q=1}h=q+m|0;k=o+4|0;r=c[k>>2]|0;if((r|0)==0){l=h;p=26;break}else{m=h;n=r;o=k}}if((p|0)==26){i=f;return l|0}}a:do{if(e>>>0>3){o=b;n=e;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break a}if(q>>>0>127){j=Ova(o,q,0)|0;if((j|0)==-1){l=-1;break}u=o+j|0;v=n-j|0;w=m}else{a[o]=q;u=o+1|0;v=n+ -1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3){o=u;n=v;m=q}else{s=u;t=v;break a}}i=f;return l|0}else{s=b;t=e}}while(0);b:do{if((t|0)==0){x=0}else{b=g;v=s;u=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127){n=Ova(b,m,0)|0;if((n|0)==-1){l=-1;p=26;break}if(n>>>0>u>>>0){p=20;break}Ova(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u+ -1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break b}else{v=y;u=z;w=m}}if((p|0)==20){l=e-u|0;i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}else if((p|0)==26){i=f;return l|0}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}function Rva(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;f=i;i=i+104|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=Jwa(20)|0;q=p;if((p|0)==0){r=12;i=f;return r|0}s=Jwa(2048)|0;c[p+16>>2]=s;if((s|0)==0){Kwa(p);r=12;i=f;return r|0}c[p>>2]=512;c[p+4>>2]=10240;c[p+8>>2]=128;c[p+12>>2]=0;s=fwa(0,0)|0;if((s|0)==0){Kwa(c[p+16>>2]|0);Kwa(p);r=12;i=f;return r|0}t=o+0|0;u=t+44|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));c[o>>2]=s;c[o+4>>2]=q;c[o+12>>2]=d;c[o+36>>2]=e;d=o+28|0;c[d>>2]=-1;t=Sva(o)|0;a:do{if((t|0)==0){u=o+20|0;v=c[u>>2]|0;w=v+ -1|0;c[b>>2]=w;x=c[o+8>>2]|0;y=c[d>>2]|0;if((y|0)>-1){if((c[o+32>>2]|0)!=0){z=0;A=2;B=0;C=0;break}}if((y|0)>(w|0)){z=0;A=6;B=0;C=0;break}w=Lwa(1,68)|0;D=w;if((w|0)==0){z=0;A=12;B=0;C=D;break}E=y>>>31;c[w+60>>2]=E^1;c[w+64>>2]=c[o+32>>2];c[w+28>>2]=v;if((E|0)==1){if((e&8|0)==0){F=13}else{G=0}}else{F=13}if((F|0)==13){E=Tva(0,q,x,D)|0;if((E|0)!=0){z=0;A=E;B=0;C=D;break}E=c[w+40>>2]|0;if((E|0)>0){v=(E<<2)+4|0;y=Jwa(v)|0;H=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[w+32>>2]=H;pxa(y|0,-1,v|0)|0;I=H}else{I=0}H=Lwa(E<<1|1,4)|0;c[w+36>>2]=H;if((H|0)==0){z=0;A=12;B=0;C=D;break}H=Lwa(c[u>>2]|0,12)|0;if((H|0)==0){z=0;A=12;B=0;C=D;break}c[w+16>>2]=H;H=Tva(s,q,x,D)|0;if((H|0)==0){G=I}else{z=0;A=H;B=0;C=D;break}}H=o+24|0;u=p+12|0;E=c[u>>2]|0;c[j>>2]=0;c[k>>2]=0;v=Zva(q,x)|0;b:do{if((v|0)==0){y=Zva(q,0)|0;if((y|0)!=0){J=y;break}y=p+16|0;K=c[u>>2]|0;c:do{if((K|0)>(E|0)){L=0;M=0;N=0;O=K;d:while(1){P=O+ -1|0;c[u>>2]=P;Q=c[y>>2]|0;R=c[Q+(P<<2)>>2]|0;P=O+ -2|0;c[u>>2]=P;S=c[Q+(P<<2)>>2]|0;do{if((R|0)==0){P=c[S>>2]|0;if((P|0)==3){T=c[S+4>>2]|0;U=Zva(q,c[T+4>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}U=Zva(q,0)|0;if((U|0)!=0){V=N;W=U;break c}U=Zva(q,c[T>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}X=Zva(q,0)|0}else if((P|0)==1){U=c[S+4>>2]|0;T=Zva(q,c[U+4>>2]|0)|0;if((T|0)!=0){V=N;W=T;break c}T=Zva(q,0)|0;if((T|0)!=0){V=N;W=T;break c}T=Zva(q,c[U>>2]|0)|0;if((T|0)!=0){V=N;W=T;break c}X=Zva(q,0)|0}else if((P|0)==2){T=c[S+4>>2]|0;U=Zva(q,L)|0;if((U|0)!=0){V=N;W=U;break c}U=Zva(q,S)|0;if((U|0)!=0){V=N;W=U;break c}U=Zva(q,1)|0;if((U|0)!=0){V=N;W=U;break c}U=Zva(q,c[T>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}U=Zva(q,0)|0;if((U|0)!=0){V=N;W=U;break c}if((c[T+4>>2]|0)>1){F=45}else{if((c[T+8>>2]|0)>1){F=45}else{Y=L}}if((F|0)==45){F=0;c[j>>2]=0;Y=0}Z=Y;_=M+1|0;$=N;break}else if((P|0)==0){P=c[S+4>>2]|0;T=c[P>>2]|0;if(!((T|0)>-1|(T|0)==-4)){Z=L;_=M;$=N;break}T=P+8|0;P=(c[T>>2]|0)+L|0;c[T>>2]=P;if((P|0)<=(c[k>>2]|0)){Z=L;_=M;$=N;break}c[k>>2]=P;Z=L;_=M;$=N;break}else{Z=L;_=M;$=N;break}if((X|0)==0){Z=L;_=M;$=N}else{V=N;W=X;break c}}else if((R|0)==1){P=S+4|0;T=c[P>>2]|0;U=O+ -3|0;c[u>>2]=U;aa=c[Q+(U<<2)>>2]|0;c[j>>2]=aa;U=T+4|0;ba=c[U>>2]|0;do{if((ba|0)>1){c[l>>2]=0;ca=T;F=51}else{if((c[T+8>>2]|0)<=1){da=aa;break}c[l>>2]=0;ea=T;if((ba|0)>0){ca=ea;F=51}else{fa=ba;ga=ea;ha=aa;ia=0;F=60}}}while(0);e:do{if((F|0)==51){F=0;ea=aa;ja=ba;ka=1;la=0;while(1){ma=_va(s,q,c[ca>>2]|0,(ka|0)<(ja|0)?1:2,j,G,m,k)|0;if((ma|0)!=0){J=ma;break b}ma=c[m>>2]|0;if((la|0)==0){na=ma}else{oa=hwa(s,0,0,1,32)|0;if((oa|0)==0){J=12;break b}pa=hwa(s,0,0,1,8)|0;qa=oa+4|0;c[qa>>2]=pa;if((pa|0)==0){J=12;break b}c[oa>>2]=1;c[oa+8>>2]=-1;c[oa+12>>2]=-1;c[pa>>2]=la;c[(c[qa>>2]|0)+4>>2]=ma;c[oa+16>>2]=(c[ma+16>>2]|0)+(c[la+16>>2]|0);na=oa}if((na|0)==0){J=12;break b}oa=c[U>>2]|0;if((ka|0)>=(oa|0)){fa=oa;ga=ca;ha=ea;ia=na;F=60;break e}ea=c[j>>2]|0;ja=oa;ka=ka+1|0;la=na}}}while(0);if((F|0)==60){F=0;U=T+8|0;ba=c[U>>2]|0;do{if((ba|0)==-1){la=c[j>>2]|0;ka=_va(s,q,c[ga>>2]|0,0,j,0,l,k)|0;if((ka|0)!=0){J=ka;break b}ka=c[l>>2]|0;ja=hwa(s,0,0,1,32)|0;ea=ja;if((ja|0)==0){F=65;break d}oa=hwa(s,0,0,1,16)|0;c[ja+4>>2]=oa;if((oa|0)==0){F=65;break d}c[ja>>2]=2;c[ja+8>>2]=-1;c[ja+12>>2]=-1;c[oa>>2]=ka;c[oa+4>>2]=0;c[oa+8>>2]=-1;ma=oa+12|0;a[ma]=a[ma]&-2;c[ja+16>>2]=c[ka+16>>2];c[l>>2]=ea;ra=ea;sa=la}else{if((fa|0)<(ba|0)){ta=0;ua=fa}else{ra=0;sa=ha;break}while(1){la=c[j>>2]|0;ea=_va(s,q,c[ga>>2]|0,0,j,0,n,k)|0;if((ea|0)!=0){J=ea;break b}ea=c[n>>2]|0;if((ta|0)==0){va=ea}else{ka=hwa(s,0,0,1,32)|0;if((ka|0)==0){F=73;break d}ja=hwa(s,0,0,1,8)|0;ma=ka+4|0;c[ma>>2]=ja;if((ja|0)==0){F=73;break d}c[ka>>2]=1;c[ka+8>>2]=-1;c[ka+12>>2]=-1;c[ja>>2]=ea;c[(c[ma>>2]|0)+4>>2]=ta;c[ka+16>>2]=(c[ta+16>>2]|0)+(c[ea+16>>2]|0);va=ka}c[l>>2]=va;if((va|0)==0){J=12;break b}ka=hwa(s,0,0,1,32)|0;if((ka|0)==0){J=12;break b}ea=hwa(s,0,0,1,20)|0;c[ka+4>>2]=ea;if((ea|0)==0){J=12;break b}c[ka>>2]=0;c[ka+8>>2]=-1;c[ka+12>>2]=-1;c[ea>>2]=-1;c[ea+4>>2]=-1;c[ea+8>>2]=-1;ea=hwa(s,0,0,1,32)|0;ma=ea;if((ea|0)==0){F=79;break d}ja=hwa(s,0,0,1,8)|0;oa=ea+4|0;c[oa>>2]=ja;if((ja|0)==0){F=79;break d}c[ea>>2]=3;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[ja>>2]=ka;c[(c[oa>>2]|0)+4>>2]=va;c[ea+16>>2]=(c[va+16>>2]|0)+(c[ka+16>>2]|0);c[l>>2]=ma;ka=ua+1|0;if((ka|0)<(c[U>>2]|0)){ta=ma;ua=ka}else{ra=ma;sa=la;break}}}}while(0);c[j>>2]=sa;do{if((ia|0)==0){wa=ra;F=85}else{if((ra|0)==0){xa=ia;break}U=hwa(s,0,0,1,32)|0;if((U|0)==0){J=12;break b}ba=hwa(s,0,0,1,8)|0;T=U+4|0;c[T>>2]=ba;if((ba|0)==0){J=12;break b}c[U>>2]=1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[ba>>2]=ia;c[(c[T>>2]|0)+4>>2]=ra;c[U+16>>2]=(c[ra+16>>2]|0)+(c[ia+16>>2]|0);wa=U;F=85}}while(0);if((F|0)==85){F=0;if((wa|0)==0){J=12;break b}else{xa=wa}}c[P>>2]=c[xa+4>>2];c[S>>2]=c[xa>>2];da=sa}U=M+ -1|0;T=da-aa+N|0;if((U|0)!=0){Z=da;_=U;$=T;break}c[j>>2]=T;Z=T;_=0;$=T}else{Z=L;_=M;$=N}}while(0);S=c[u>>2]|0;if((S|0)>(E|0)){L=Z;M=_;N=$;O=S}else{V=$;W=0;break c}}if((F|0)==65){c[l>>2]=0;J=12;break b}else if((F|0)==73){c[l>>2]=0;J=12;break b}else if((F|0)==79){c[l>>2]=0;J=12;break b}}else{V=0;W=0}}while(0);y=(c[H>>2]|0)+V|0;K=c[k>>2]|0;c[H>>2]=(K|0)>(y|0)?K:y;J=W}else{J=v}}while(0);if((J|0)!=0){z=0;A=J;B=0;C=D;break}v=c[H>>2]|0;c[H>>2]=v+1;E=hwa(s,0,0,1,32)|0;if((E|0)==0){z=0;A=12;B=0;C=D;break}y=hwa(s,0,0,1,20)|0;c[E+4>>2]=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[E>>2]=0;c[E+8>>2]=-1;c[E+12>>2]=-1;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=v;v=hwa(s,0,0,1,32)|0;y=v;if((v|0)==0){z=0;A=12;B=0;C=D;break}K=hwa(s,0,0,1,8)|0;O=v+4|0;c[O>>2]=K;if((K|0)==0){z=0;A=12;B=0;C=D;break}c[v>>2]=1;c[v+8>>2]=-1;c[v+12>>2]=-1;c[K>>2]=x;c[(c[O>>2]|0)+4>>2]=E;c[v+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);E=c[u>>2]|0;O=Zva(q,v)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=Zva(q,0)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=c[u>>2]|0;f:do{if((O|0)>(E|0)){K=p+16|0;N=O;g:while(1){M=N+ -1|0;c[u>>2]=M;L=c[K>>2]|0;S=c[L+(M<<2)>>2]|0;M=N+ -2|0;c[u>>2]=M;ya=c[L+(M<<2)>>2]|0;do{if((S|0)==0){M=c[ya>>2]|0;if((M|0)==0){L=c[ya+4>>2]|0;Q=c[L>>2]|0;if((Q|0)==-4){c[ya+8>>2]=0;R=L+8|0;T=c[R>>2]|0;U=hwa(s,0,0,1,64)|0;if((U|0)==0){F=104;break g}ba=U;c[U>>2]=T;c[U+4>>2]=0;c[U+8>>2]=1114111;c[U+20>>2]=0;c[U+24>>2]=0;T=U+28|0;U=ya+24|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[U>>2]=ba;ba=c[R>>2]|0;R=c[L+4>>2]|0;U=hwa(s,0,0,1,64)|0;if((U|0)==0){F=106;break g}c[U>>2]=ba;c[U+4>>2]=0;c[U+8>>2]=1114111;c[U+20>>2]=0;c[U+24>>2]=0;c[U+28>>2]=R;c[U+32>>2]=-1;c[U+36>>2]=-1;c[U+40>>2]=-1;c[ya+28>>2]=U;break}U=ya+8|0;if((Q|0)<0){c[U>>2]=1;R=hwa(s,0,0,1,32)|0;if((R|0)==0){F=110;break g}c[R>>2]=-1;c[R+4>>2]=-1;c[R+8>>2]=-1;c[ya+24>>2]=R;R=hwa(s,0,0,1,32)|0;if((R|0)==0){F=112;break g}c[R>>2]=-1;c[R+4>>2]=-1;c[R+8>>2]=-1;c[ya+28>>2]=R;break}else{c[U>>2]=0;U=L+8|0;R=c[U>>2]|0;ba=L+4|0;T=c[ba>>2]|0;la=hwa(s,0,0,1,64)|0;if((la|0)==0){F=115;break g}ma=la;c[la>>2]=R;c[la+4>>2]=Q;c[la+8>>2]=T;c[la+20>>2]=0;c[la+24>>2]=0;T=la+28|0;la=ya+24|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[la>>2]=ma;ma=c[U>>2]|0;U=c[L>>2]|0;la=c[ba>>2]|0;ba=c[L+12>>2]|0;T=c[L+16>>2]|0;L=hwa(s,0,0,1,64)|0;if((L|0)==0){F=117;break g}Q=L;c[L>>2]=ma;c[L+4>>2]=U;c[L+8>>2]=la;c[L+20>>2]=ba;c[L+24>>2]=T;T=L+28|0;L=ya+28|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[L>>2]=Q;break}}else if((M|0)==1){Q=Zva(q,ya)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=Zva(q,2)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=ya+4|0;L=Zva(q,c[(c[Q>>2]|0)+4>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=Zva(q,0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=Zva(q,c[c[Q>>2]>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=Zva(q,0)|0;if((L|0)==0){break}else{z=0;A=L;B=0;C=D;break a}}else if((M|0)==3){L=Zva(q,ya)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=Zva(q,1)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=ya+4|0;Q=Zva(q,c[(c[L>>2]|0)+4>>2]|0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=Zva(q,0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=Zva(q,c[c[L>>2]>>2]|0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=Zva(q,0)|0;if((Q|0)==0){break}else{z=0;A=Q;B=0;C=D;break a}}else if((M|0)==2){M=Zva(q,ya)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=Zva(q,3)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=Zva(q,c[c[ya+4>>2]>>2]|0)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=Zva(q,0)|0;if((M|0)==0){break}else{z=0;A=M;B=0;C=D;break a}}else{break}}else if((S|0)==1){M=c[ya+4>>2]|0;Q=c[M>>2]|0;L=M+4|0;T=c[L>>2]|0;if((c[Q+8>>2]|0)==0){za=(c[T+8>>2]|0)!=0|0}else{za=1}c[ya+8>>2]=za;ba=Xva(s,c[Q+24>>2]|0,c[T+24>>2]|0,0,0)|0;c[ya+24>>2]=ba;if((ba|0)==0){z=0;A=12;B=0;C=D;break a}ba=Xva(s,c[(c[M>>2]|0)+28>>2]|0,c[(c[L>>2]|0)+28>>2]|0,0,0)|0;c[ya+28>>2]=ba;if((ba|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==2){ba=c[ya+4>>2]|0;L=c[ba>>2]|0;M=L+8|0;if((c[M>>2]|0)==0){Aa=0}else{Aa=(c[(c[ba+4>>2]|0)+8>>2]|0)!=0|0}c[ya+8>>2]=Aa;if((c[M>>2]|0)==0){c[ya+24>>2]=c[L+24>>2];Ba=ba+4|0}else{M=Yva(q,L,0,0,g)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}Ca=Jwa((c[g>>2]<<2)+4|0)|0;M=Ca;if((Ca|0)==0){z=0;A=12;B=0;C=D;break a}c[Ca>>2]=-1;c[h>>2]=0;Da=Yva(q,c[ba>>2]|0,M,h,0)|0;if((Da|0)!=0){F=150;break g}L=ba+4|0;T=Xva(s,c[(c[L>>2]|0)+24>>2]|0,c[(c[ba>>2]|0)+24>>2]|0,M,c[h>>2]|0)|0;M=ya+24|0;c[M>>2]=T;Kwa(Ca);if((c[M>>2]|0)==0){z=0;A=12;B=0;C=D;break a}else{Ba=L}}L=c[Ba>>2]|0;if((c[L+8>>2]|0)==0){c[ya+28>>2]=c[L+28>>2];break}M=Yva(q,L,0,0,g)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}Ea=Jwa((c[g>>2]<<2)+4|0)|0;M=Ea;if((Ea|0)==0){z=0;A=12;B=0;C=D;break a}c[Ea>>2]=-1;c[h>>2]=0;Fa=Yva(q,c[Ba>>2]|0,M,h,0)|0;if((Fa|0)!=0){F=157;break g}L=Xva(s,c[(c[ba>>2]|0)+28>>2]|0,c[(c[Ba>>2]|0)+28>>2]|0,M,c[h>>2]|0)|0;M=ya+28|0;c[M>>2]=L;Kwa(Ea);if((c[M>>2]|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==3){M=c[ya+4>>2]|0;L=c[M>>2]|0;do{if((c[M+4>>2]|0)==0){F=141}else{if((c[L+8>>2]|0)!=0){F=141;break}c[ya+8>>2]=0}}while(0);if((F|0)==141){F=0;c[ya+8>>2]=1}c[ya+24>>2]=c[L+24>>2];c[ya+28>>2]=c[(c[M>>2]|0)+28>>2]}}while(0);N=c[u>>2]|0;if((N|0)<=(E|0)){break f}}if((F|0)==104){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==106){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==110){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==112){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==115){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==117){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==150){Kwa(Ca);z=0;A=Da;B=0;C=D;break a}else if((F|0)==157){Kwa(Ea);z=0;A=Fa;B=0;C=D;break a}}}while(0);E=c[H>>2]|0;u=E<<2;O=Jwa(u)|0;x=O;if((O|0)==0){z=x;A=12;B=0;C=D;break}N=Jwa(u)|0;u=N;if((N|0)==0){z=x;A=12;B=u;C=D;break}if((E|0)>0){pxa(O|0,0,((E|0)>1?E<<2:4)|0)|0}Uva(y,0,x,0)|0;E=c[H>>2]|0;if((E|0)>0){K=0;S=0;while(1){c[N+(S<<2)>>2]=K;ba=O+(S<<2)|0;T=K+1+(c[ba>>2]|0)|0;c[ba>>2]=0;ba=S+1|0;if((ba|0)<(E|0)){S=ba;K=T}else{Ga=T;break}}}else{Ga=0}K=Lwa(Ga+1|0,32)|0;S=K;if((K|0)==0){z=x;A=12;B=u;C=D;break}c[w>>2]=S;E=w+4|0;c[E>>2]=Ga;T=Uva(y,S,x,u)|0;if((T|0)!=0){z=x;A=T;B=u;C=D;break}c[w+20>>2]=0;T=v+24|0;S=c[T>>2]|0;if((c[S>>2]|0)>-1){ba=1;Q=S;while(1){S=Q+32|0;la=ba+1|0;if((c[S>>2]|0)>-1){Q=S;ba=la}else{Ha=la;break}}}else{Ha=1}ba=Lwa(Ha,32)|0;if((ba|0)==0){z=x;A=12;B=u;C=D;break}c[w+8>>2]=ba;Q=c[T>>2]|0;y=c[Q>>2]|0;if((y|0)>-1){la=y;y=Q;Q=0;while(1){c[ba+(Q<<5)+8>>2]=K+(c[N+(la<<2)>>2]<<5);c[ba+(Q<<5)+12>>2]=la;S=ba+(Q<<5)+16|0;c[S>>2]=0;U=y+12|0;ma=c[U>>2]|0;if((ma|0)!=0){R=0;while(1){Ia=R+1|0;if((c[ma+(R<<2)>>2]|0)>-1){R=Ia}else{break}}R=Ia<<2;ma=Jwa(R)|0;c[S>>2]=ma;if((ma|0)==0){z=x;A=12;B=u;C=D;break a}nxa(ma|0,c[U>>2]|0,R|0)|0}c[ba+(Q<<5)+20>>2]=c[y+16>>2];R=Q+1|0;ma=y+32|0;ka=c[ma>>2]|0;if((ka|0)>-1){la=ka;y=ma;Q=R}else{Ja=R;break}}}else{Ja=0}c[ba+(Ja<<5)+8>>2]=0;c[E>>2]=Ga;c[w+12>>2]=K+(c[N+(c[c[v+28>>2]>>2]<<2)>>2]<<5);c[w+52>>2]=c[H>>2];c[w+56>>2]=e;gwa(s);Kwa(c[p+16>>2]|0);Kwa(p);Kwa(O);Kwa(N);c[b+4>>2]=w;r=0;i=f;return r|0}else{z=0;A=t;B=0;C=0}}while(0);gwa(s);Kwa(c[p+16>>2]|0);Kwa(p);if((z|0)!=0){Kwa(z)}if((B|0)!=0){Kwa(B)}c[b+4>>2]=C;Vva(b);r=A;i=f;return r|0}function Sva(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;d=i;i=i+424|0;e=d;f=d+8|0;g=d+72|0;h=d+328|0;j=d+336|0;k=d+384|0;l=d+392|0;m=c[b+4>>2]|0;n=m+12|0;o=c[n>>2]|0;if((c[b+40>>2]|0)==0){p=b+20|0;Zva(m,c[p>>2]|0)|0;Zva(m,2)|0;c[p>>2]=(c[p>>2]|0)+1}p=Zva(m,0)|0;q=b+12|0;r=b+16|0;c[r>>2]=c[q>>2];s=c[n>>2]|0;t=(p|0)==0;a:do{if((s|0)>(o|0)&t){u=m+16|0;v=b+36|0;w=b;x=b+24|0;y=b+20|0;z=g;A=f;B=b+28|0;C=l;D=k;E=k+1|0;F=j;G=b;H=j+12|0;I=j+40|0;J=j+24|0;K=j+8|0;L=s;M=0;N=0;b:while(1){O=L+ -1|0;c[n>>2]=O;P=c[u>>2]|0;c:do{switch(c[P+(O<<2)>>2]|0){case 4:{Q=Zva(m,9)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}U=M;V=N;W=Zva(m,1)|0;break};case 2:{Q=L+ -2|0;c[n>>2]=Q;X=c[P+(Q<<2)>>2]|0;if((c[N+12>>2]|0)>-1){Q=c[w>>2]|0;Y=hwa(Q,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}_=hwa(Q,0,0,1,20)|0;c[Y+4>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[_>>2]=-1;c[_+4>>2]=-1;c[_+8>>2]=-1;_=c[w>>2]|0;Q=hwa(_,0,0,1,32)|0;if((Q|0)==0){Z=12;T=294;break b}$=hwa(_,0,0,1,8)|0;_=Q+4|0;c[_>>2]=$;if(($|0)==0){Z=12;T=294;break b}c[Q>>2]=1;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[$>>2]=Y;c[(c[_>>2]|0)+4>>2]=N;_=N+16|0;$=Q+16|0;c[$>>2]=(c[_>>2]|0)+(c[Y+16>>2]|0);c[$>>2]=c[_>>2];aa=Q}else{aa=N}c[aa+12>>2]=X;X=aa+16|0;c[X>>2]=(c[X>>2]|0)+1;U=M;V=aa;W=0;break};case 7:{X=c[q>>2]|0;Q=a[X]|0;if((Q|0)==41){c[q>>2]=X+1;U=M;V=N;W=0;break c}else if((Q|0)!=124){U=M;V=N;W=0;break c}Q=Zva(m,7)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}Q=Zva(m,N)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}Q=Zva(m,8)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}Q=Zva(m,3)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}c[q>>2]=(c[q>>2]|0)+1;U=M;V=N;W=0;break};case 1:{Q=c[q>>2]|0;d:do{switch(a[Q]|0){case 91:{X=Q+1|0;c[q>>2]=X;_=Jwa(128)|0;if((_|0)==0){Z=12;T=294;break b}if((a[X]|0)==94){$=Q+2|0;c[q>>2]=$;ba=$;ca=1}else{ba=X;ca=0}X=(ca|0)==0;$=_;_=0;Y=0;da=32;ea=ba;e:while(1){fa=a[ea]|0;if(fa<<24>>24==93){if(ea>>>0>(c[q>>2]|0)>>>0){T=85;break}}else if(fa<<24>>24==0){ga=$;ha=ea;ia=7;T=140;break}fa=Nva(e,ea,-1)|0;if((fa|0)<0){c[e>>2]=-1;ja=1}else{ja=fa}fa=ea+ja|0;do{if((a[fa]|0)==45){ka=ja+1|0;la=ea+ka|0;if((a[la]|0)==93){T=94;break}ma=c[e>>2]|0;na=Nva(e,la,-1)|0;if((na|0)<0){c[e>>2]=-1;oa=-1;pa=1}else{oa=c[e>>2]|0;pa=na}qa=0;ra=oa;sa=ma;ta=ea+(pa+ka)|0;ua=ma>>>0>oa>>>0?11:0}else{T=94}}while(0);f:do{if((T|0)==94){T=0;ma=a[ea]|0;do{if(ma<<24>>24==45){if((a[ea+1|0]|0)==93){va=0;break}va=(c[q>>2]|0)==(ea|0)?0:11}else if(ma<<24>>24==91){ka=a[ea+1|0]|0;if(ka<<24>>24==61|ka<<24>>24==46){ga=$;ha=ea;ia=3;T=140;break e}else if(!(ka<<24>>24==58)){va=0;break}ka=ea+2|0;na=ka;while(1){la=a[na]|0;wa=la<<24>>24==0;if(la<<24>>24!=58&(wa^1)){na=na+1|0}else{break}}if(wa){ga=$;ha=ea;ia=4;T=140;break e}la=na-ea+ -2|0;xa=(la|0)>63?63:la;wxa(A|0,ka|0,xa|0)|0;a[f+xa|0]=0;xa=xva(A)|0;qa=xa;ra=1114111;sa=0;ta=na+2|0;ua=(xa|0)==0?4:0;break f}else{va=0}}while(0);ma=c[e>>2]|0;qa=0;ra=ma;sa=ma;ta=fa;ua=va}}while(0);if((ua|0)!=0){ga=$;ha=ta;ia=ua;T=140;break}fa=(qa|0)!=0;do{if(X|fa^1){ma=c[w>>2]|0;if((Y|0)<(da|0)){ya=$;za=da}else{if((da|0)>1024){ga=$;ha=ta;ia=12;T=140;break e}xa=Mwa($,da<<3)|0;if((xa|0)==0){ga=$;ha=ta;ia=12;T=140;break e}else{ya=xa;za=da<<1}}xa=hwa(ma,0,0,1,32)|0;if((xa|0)==0){T=112;break e}la=hwa(ma,0,0,1,20)|0;ma=xa+4|0;c[ma>>2]=la;if((la|0)==0){T=112;break e}c[xa>>2]=0;c[xa+8>>2]=-1;c[xa+12>>2]=-1;c[la>>2]=sa;c[la+4>>2]=ra;c[la+8>>2]=-1;c[ya+(Y<<2)>>2]=xa;c[(c[ma>>2]|0)+12>>2]=qa;Aa=ya;Ba=_;Ca=Y+1|0;Da=za;Ea=0}else{if((_|0)>63){Aa=$;Ba=_;Ca=Y;Da=da;Ea=12;break}c[g+(_<<2)>>2]=qa;Aa=$;Ba=_+1|0;Ca=Y;Da=da;Ea=0}}while(0);ma=(Ea|0)==0;if(ma&(((c[v>>2]&2|0)==0|fa)^1)){Fa=Aa;Ga=Ca;Ha=Da;Ia=sa}else{if(ma){$=Aa;_=Ba;Y=Ca;da=Da;ea=ta;continue}else{ga=Aa;ha=ta;ia=Ea;T=140;break}}while(1){ma=Ia;while(1){if(ma>>>0>ra>>>0){$=Fa;_=Ba;Y=Ga;da=Ha;ea=ta;continue e}if((Ava(ma)|0)!=0){T=118;break}Ja=ma+1|0;if((Eva(ma)|0)==0){ma=Ja}else{T=129;break}}if((T|0)==118){T=0;xa=Gva(ma)|0;la=ma+1|0;g:do{if((Ava(la)|0)==0){Ka=xa;La=la}else{Ma=xa;Na=la;while(1){if((Gva(Na)|0)!=(Ma+1|0)|Na>>>0>ra>>>0){Ka=Ma;La=Na;break g}Oa=Gva(Na)|0;Pa=Na+1|0;if((Ava(Pa)|0)==0){Ka=Oa;La=Pa;break}else{Ma=Oa;Na=Pa}}}}while(0);la=c[w>>2]|0;if((Ga|0)<(Ha|0)){Qa=Fa;Ra=Ha}else{if((Ha|0)>1024){ga=Fa;ha=ta;ia=12;T=140;break e}Na=Mwa(Fa,Ha<<3)|0;if((Na|0)==0){ga=Fa;ha=ta;ia=12;T=140;break e}else{Qa=Na;Ra=Ha<<1}}Na=hwa(la,0,0,1,32)|0;Ma=Na;do{if((Na|0)==0){Sa=0}else{na=hwa(la,0,0,1,20)|0;c[Na+4>>2]=na;if((na|0)==0){Sa=0;break}c[Na>>2]=0;c[Na+8>>2]=-1;c[Na+12>>2]=-1;c[na>>2]=xa;c[na+4>>2]=Ka;c[na+8>>2]=-1;Sa=Ma}}while(0);c[Qa+(Ga<<2)>>2]=Sa;Ta=Sa;Ua=Qa;Va=Ra;Wa=La}else if((T|0)==129){T=0;Ma=Iva(ma)|0;h:do{if((Eva(Ja)|0)==0){Xa=Ma;Ya=Ja}else{xa=Ma;Na=Ja;while(1){if((Iva(Na)|0)!=(xa+1|0)|Na>>>0>ra>>>0){Xa=xa;Ya=Na;break h}la=Na+1|0;na=Iva(Na)|0;if((Eva(la)|0)==0){Xa=na;Ya=la;break}else{xa=na;Na=la}}}}while(0);ma=c[w>>2]|0;if((Ga|0)<(Ha|0)){Za=Fa;_a=Ha}else{if((Ha|0)>1024){ga=Fa;ha=ta;ia=12;T=140;break e}Na=Mwa(Fa,Ha<<3)|0;if((Na|0)==0){ga=Fa;ha=ta;ia=12;T=140;break e}else{Za=Na;_a=Ha<<1}}Na=hwa(ma,0,0,1,32)|0;xa=Na;do{if((Na|0)==0){$a=0}else{la=hwa(ma,0,0,1,20)|0;c[Na+4>>2]=la;if((la|0)==0){$a=0;break}c[Na>>2]=0;c[Na+8>>2]=-1;c[Na+12>>2]=-1;c[la>>2]=Ma;c[la+4>>2]=Xa;c[la+8>>2]=-1;$a=xa}}while(0);c[Za+(Ga<<2)>>2]=$a;Ta=$a;Ua=Za;Va=_a;Wa=Ya}if((Ta|0)==0){T=141;break e}else{Fa=Ua;Ga=Ga+1|0;Ha=Va;Ia=Wa}}}i:do{if((T|0)==85){T=0;c[q>>2]=ea+1;da=(ca|0)!=0;if(da){cc($|0,Y|0,4,61)}j:do{if((Y|0)>0){X=(_|0)>0;fa=_<<2;xa=fa+4|0;if(da){ab=0;bb=0;cb=0;db=0}else{Ma=0;Na=0;while(1){ma=$+(Ma<<2)|0;la=c[(c[ma>>2]|0)+4>>2]|0;do{if((la|0)==0){eb=Na;fb=0}else{c[la+8>>2]=c[x>>2];if(X){na=hwa(c[w>>2]|0,0,0,0,xa)|0;ka=la+16|0;c[ka>>2]=na;if((na|0)==0){gb=$;hb=Na;ib=12;break i}nxa(na|0,z|0,fa|0)|0;c[(c[ka>>2]|0)+(_<<2)>>2]=0}else{c[la+16>>2]=0}if((Na|0)==0){eb=c[ma>>2]|0;fb=0;break}ka=c[w>>2]|0;na=c[ma>>2]|0;Pa=hwa(ka,0,0,1,32)|0;Oa=Pa;do{if((Pa|0)==0){jb=0}else{kb=hwa(ka,0,0,1,8)|0;lb=Pa+4|0;c[lb>>2]=kb;if((kb|0)==0){jb=0;break}c[Pa>>2]=3;c[Pa+8>>2]=-1;c[Pa+12>>2]=-1;c[kb>>2]=Na;c[(c[lb>>2]|0)+4>>2]=na;c[Pa+16>>2]=(c[na+16>>2]|0)+(c[Na+16>>2]|0);jb=Oa}}while(0);eb=jb;fb=(jb|0)==0?12:0}}while(0);ma=Ma+1|0;if((ma|0)<(Y|0)&(fb|0)==0){Ma=ma;Na=eb}else{mb=0;nb=eb;ob=fb;break j}}}while(1){Na=$+(cb<<2)|0;Ma=c[(c[Na>>2]|0)+4>>2]|0;ma=c[Ma>>2]|0;la=Ma+4|0;Oa=c[la>>2]|0;do{if((ma|0)<(ab|0)){na=Oa+1|0;pb=(na|0)<(ab|0)?ab:na;qb=bb;rb=db;sb=0}else{if((ma|0)<=(bb|0)){na=Oa+1|0;pb=na;qb=na;rb=db;sb=0;break}c[Ma>>2]=bb;c[la>>2]=ma+ -1;na=Oa+1|0;if((Ma|0)==0){pb=na;qb=na;rb=db;sb=0;break}c[Ma+8>>2]=c[x>>2];if(X){Pa=hwa(c[w>>2]|0,0,0,0,xa)|0;ka=Ma+16|0;c[ka>>2]=Pa;if((Pa|0)==0){gb=$;hb=db;ib=12;break i}nxa(Pa|0,z|0,fa|0)|0;c[(c[ka>>2]|0)+(_<<2)>>2]=0}else{c[Ma+16>>2]=0}if((db|0)==0){pb=na;qb=na;rb=c[Na>>2]|0;sb=0;break}ka=c[w>>2]|0;Pa=c[Na>>2]|0;lb=hwa(ka,0,0,1,32)|0;kb=lb;do{if((lb|0)==0){tb=0}else{ub=hwa(ka,0,0,1,8)|0;vb=lb+4|0;c[vb>>2]=ub;if((ub|0)==0){tb=0;break}c[lb>>2]=3;c[lb+8>>2]=-1;c[lb+12>>2]=-1;c[ub>>2]=db;c[(c[vb>>2]|0)+4>>2]=Pa;c[lb+16>>2]=(c[Pa+16>>2]|0)+(c[db+16>>2]|0);tb=kb}}while(0);pb=na;qb=na;rb=tb;sb=(tb|0)==0?12:0}}while(0);Na=cb+1|0;if((Na|0)<(Y|0)&(sb|0)==0){ab=pb;bb=qb;cb=Na;db=rb}else{mb=qb;nb=rb;ob=sb;break}}}else{mb=0;nb=0;ob=0}}while(0);if((ob|0)!=0|da^1){gb=$;hb=nb;ib=ob;break}fa=c[w>>2]|0;xa=c[x>>2]|0;X=hwa(fa,0,0,1,32)|0;Na=X;if((X|0)==0){gb=$;hb=nb;ib=12;break}Ma=hwa(fa,0,0,1,20)|0;c[X+4>>2]=Ma;if((Ma|0)==0){gb=$;hb=nb;ib=12;break}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[Ma>>2]=mb;c[Ma+4>>2]=1114111;c[Ma+8>>2]=xa;if((_|0)>0){xa=_<<2;fa=hwa(c[w>>2]|0,0,0,0,xa+4|0)|0;Oa=Ma+16|0;c[Oa>>2]=fa;if((fa|0)==0){gb=$;hb=nb;ib=12;break}nxa(fa|0,z|0,xa|0)|0;c[(c[Oa>>2]|0)+(_<<2)>>2]=0}else{c[Ma+16>>2]=0}if((nb|0)==0){gb=$;hb=Na;ib=0;break}Ma=c[w>>2]|0;Oa=hwa(Ma,0,0,1,32)|0;xa=Oa;do{if((Oa|0)==0){wb=0}else{fa=hwa(Ma,0,0,1,8)|0;ma=Oa+4|0;c[ma>>2]=fa;if((fa|0)==0){wb=0;break}c[Oa>>2]=3;c[Oa+8>>2]=-1;c[Oa+12>>2]=-1;c[fa>>2]=nb;c[(c[ma>>2]|0)+4>>2]=Na;c[Oa+16>>2]=(c[X+16>>2]|0)+(c[nb+16>>2]|0);wb=xa}}while(0);gb=$;hb=wb;ib=(wb|0)==0?12:0}else if((T|0)==112){T=0;c[ya+(Y<<2)>>2]=0;ga=ya;ha=ta;ia=12;T=140}else if((T|0)==141){T=0;c[q>>2]=ta;gb=Ua;hb=0;ib=12}}while(0);if((T|0)==140){T=0;c[q>>2]=ha;gb=ga;hb=0;ib=ia}Kwa(gb);c[x>>2]=(c[x>>2]|0)+1;if((ib|0)==0){U=M;V=hb;W=0;break c}else{Z=ib;T=294;break b}break};case 0:{T=265;break};case 46:{Y=(c[v>>2]&4|0)==0;$=c[w>>2]|0;_=c[x>>2]|0;ea=hwa($,0,0,1,32)|0;xa=ea;X=(ea|0)==0;if(Y){if(X){Z=12;T=294;break b}Y=hwa($,0,0,1,20)|0;c[ea+4>>2]=Y;if((Y|0)==0){Z=12;T=294;break b}c[ea>>2]=0;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[Y>>2]=0;c[Y+4>>2]=1114111;c[Y+8>>2]=_;xb=xa;yb=(c[x>>2]|0)+1|0}else{if(X){Z=12;T=294;break b}X=hwa($,0,0,1,20)|0;c[ea+4>>2]=X;if((X|0)==0){Z=12;T=294;break b}c[ea>>2]=0;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[X>>2]=0;c[X+4>>2]=9;c[X+8>>2]=_;_=c[w>>2]|0;X=(c[x>>2]|0)+1|0;$=hwa(_,0,0,1,32)|0;if(($|0)==0){Z=12;T=294;break b}Y=hwa(_,0,0,1,20)|0;c[$+4>>2]=Y;if((Y|0)==0){Z=12;T=294;break b}c[$>>2]=0;c[$+8>>2]=-1;c[$+12>>2]=-1;c[Y>>2]=11;c[Y+4>>2]=1114111;c[Y+8>>2]=X;X=c[w>>2]|0;Y=hwa(X,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}_=hwa(X,0,0,1,8)|0;X=Y+4|0;c[X>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[Y>>2]=3;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[_>>2]=xa;c[(c[X>>2]|0)+4>>2]=$;c[Y+16>>2]=(c[$+16>>2]|0)+(c[ea+16>>2]|0);xb=Y;yb=(c[x>>2]|0)+2|0}c[x>>2]=yb;c[q>>2]=(c[q>>2]|0)+1;U=M;V=xb;W=0;break c;break};case 36:{if((c[v>>2]&1|0)==0){if((a[Q+1|0]|0)!=0){break d}}Y=c[w>>2]|0;ea=hwa(Y,0,0,1,32)|0;if((ea|0)==0){Z=12;T=294;break b}$=hwa(Y,0,0,1,20)|0;c[ea+4>>2]=$;if(($|0)==0){Z=12;T=294;break b}c[ea>>2]=0;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[$>>2]=-2;c[$+4>>2]=2;c[$+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=ea;W=0;break c;break};case 41:{if((M|0)!=0){T=264}break};case 63:case 43:case 123:case 124:case 42:{T=264;break};case 94:{if((c[v>>2]&1|0)==0){if((Q|0)!=(c[r>>2]|0)){break d}ea=Zva(m,5)|0;if((ea|0)!=0){R=M;S=ea;T=6;break b}}ea=c[w>>2]|0;$=hwa(ea,0,0,1,32)|0;if(($|0)==0){Z=12;T=294;break b}Y=hwa(ea,0,0,1,20)|0;c[$+4>>2]=Y;if((Y|0)==0){Z=12;T=294;break b}c[$>>2]=0;c[$+8>>2]=-1;c[$+12>>2]=-1;c[Y>>2]=-2;c[Y+4>>2]=1;c[Y+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=$;W=0;break c;break};case 40:{if((c[v>>2]&1|0)!=0){zb=Q;T=74}break};case 92:{$=Q+1|0;Y=a[$]|0;do{if((c[v>>2]&1|0)==0){if(Y<<24>>24==40){c[q>>2]=$;zb=$;T=74;break d}else{ea=a[Q+1|0]|0;if(ea<<24>>24==41){T=265;break d}else{Ab=ea;break}}}else{Ab=Y}}while(0);Y=Q+1|0;$=Ab<<24>>24==0;if($){Z=5;T=294;break b}else{Bb=160172|0;Cb=0}while(1){ea=Cb+1|0;if((a[160168+(Cb<<3)|0]|0)==Ab<<24>>24){Db=Bb;break}X=160172+(ea<<3)|0;if((ea|0)==12){Db=X;break}else{Bb=X;Cb=ea}}ea=c[Db>>2]|0;if((ea|0)!=0){X=F+0|0;xa=G+0|0;_=X+40|0;do{c[X>>2]=c[xa>>2];X=X+4|0;xa=xa+4|0}while((X|0)<(_|0));c[H>>2]=ea;c[I>>2]=1;xa=Sva(j)|0;if((xa|0)!=0){Z=xa;T=294;break b}c[q>>2]=(c[q>>2]|0)+2;c[x>>2]=c[J>>2];U=M;V=c[K>>2]|0;W=0;break c}if($){Z=5;T=294;break b}c[q>>2]=Y;xa=a[Y]|0;k:do{switch(xa|0){case 66:{X=c[w>>2]|0;_=hwa(X,0,0,1,32)|0;Oa=_;do{if((_|0)==0){Eb=0}else{Na=hwa(X,0,0,1,20)|0;c[_+4>>2]=Na;if((Na|0)==0){Eb=0;break}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[Na>>2]=-2;c[Na+4>>2]=128;c[Na+8>>2]=-1;Eb=Oa}}while(0);c[q>>2]=(c[q>>2]|0)+1;Fb=Eb;break};case 60:{Oa=c[w>>2]|0;_=hwa(Oa,0,0,1,32)|0;X=_;do{if((_|0)==0){Gb=0}else{Na=hwa(Oa,0,0,1,20)|0;c[_+4>>2]=Na;if((Na|0)==0){Gb=0;break}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[Na>>2]=-2;c[Na+4>>2]=16;c[Na+8>>2]=-1;Gb=X}}while(0);c[q>>2]=(c[q>>2]|0)+1;Fb=Gb;break};case 98:{X=c[w>>2]|0;_=hwa(X,0,0,1,32)|0;Oa=_;do{if((_|0)==0){Hb=0}else{Na=hwa(X,0,0,1,20)|0;c[_+4>>2]=Na;if((Na|0)==0){Hb=0;break}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[Na>>2]=-2;c[Na+4>>2]=64;c[Na+8>>2]=-1;Hb=Oa}}while(0);c[q>>2]=(c[q>>2]|0)+1;Fb=Hb;break};case 62:{Oa=c[w>>2]|0;_=hwa(Oa,0,0,1,32)|0;X=_;do{if((_|0)==0){Ib=0}else{Na=hwa(Oa,0,0,1,20)|0;c[_+4>>2]=Na;if((Na|0)==0){Ib=0;break}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[Na>>2]=-2;c[Na+4>>2]=32;c[Na+8>>2]=-1;Ib=X}}while(0);c[q>>2]=(c[q>>2]|0)+1;Fb=Ib;break};case 120:{X=Q+2|0;c[q>>2]=X;_=a[X]|0;if(_<<24>>24==123){X=Q+3|0;c[q>>2]=X;Oa=X;X=0;while(1){Na=a[Oa]|0;if(Na<<24>>24==0|Na<<24>>24==125){Jb=X;Kb=Oa;break}if((Fva(Na<<24>>24)|0)==0){Z=9;T=294;break b}Na=c[q>>2]|0;a[l+X|0]=a[Na]|0;Ma=X+1|0;da=Na+1|0;c[q>>2]=da;if(Ma>>>0>31){Jb=Ma;Kb=da;break}else{Oa=da;X=Ma}}c[q>>2]=Kb+1;a[l+Jb|0]=0;X=Ub(C|0,0,16)|0;Oa=c[w>>2]|0;Ma=c[x>>2]|0;da=hwa(Oa,0,0,1,32)|0;Na=da;do{if((da|0)==0){Lb=0}else{ma=hwa(Oa,0,0,1,20)|0;c[da+4>>2]=ma;if((ma|0)==0){Lb=0;break}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[ma>>2]=X;c[ma+4>>2]=X;c[ma+8>>2]=Ma;Lb=Na}}while(0);c[x>>2]=(c[x>>2]|0)+1;Fb=Lb;break k}else{a[D+0|0]=0;a[D+1|0]=0;a[D+2|0]=0;Na=(Fva(_<<24>>24)|0)==0;Ma=c[q>>2]|0;if(Na){Mb=Ma}else{a[D]=a[Ma]|0;Na=Ma+1|0;c[q>>2]=Na;Mb=Na}if((Fva(a[Mb]|0)|0)!=0){Na=c[q>>2]|0;a[E]=a[Na]|0;c[q>>2]=Na+1}Na=Ub(D|0,0,16)|0;Ma=c[w>>2]|0;X=c[x>>2]|0;da=hwa(Ma,0,0,1,32)|0;Oa=da;do{if((da|0)==0){Nb=0}else{ma=hwa(Ma,0,0,1,20)|0;c[da+4>>2]=ma;if((ma|0)==0){Nb=0;break}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[ma>>2]=Na;c[ma+4>>2]=Na;c[ma+8>>2]=X;Nb=Oa}}while(0);c[x>>2]=(c[x>>2]|0)+1;Fb=Nb;break k}break};default:{if((yva(xa)|0)!=0){Oa=(a[c[q>>2]|0]|0)+ -48|0;X=c[w>>2]|0;Na=c[x>>2]|0;da=hwa(X,0,0,1,32)|0;if((da|0)==0){Z=12;T=294;break b}Ma=hwa(X,0,0,1,20)|0;c[da+4>>2]=Ma;if((Ma|0)==0){Z=12;T=294;break b}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[Ma>>2]=-4;c[Ma+4>>2]=Oa;c[Ma+8>>2]=Na;c[x>>2]=(c[x>>2]|0)+1;Na=c[B>>2]|0;c[B>>2]=(Oa|0)<(Na|0)?Na:Oa;c[q>>2]=(c[q>>2]|0)+1;U=M;V=da;W=0;break c}da=c[w>>2]|0;Oa=a[c[q>>2]|0]|0;Na=c[x>>2]|0;Ma=hwa(da,0,0,1,32)|0;X=Ma;do{if((Ma|0)==0){Ob=0}else{_=hwa(da,0,0,1,20)|0;c[Ma+4>>2]=_;if((_|0)==0){Ob=0;break}c[Ma>>2]=0;c[Ma+8>>2]=-1;c[Ma+12>>2]=-1;c[_>>2]=Oa;c[_+4>>2]=Oa;c[_+8>>2]=Na;Ob=X}}while(0);c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1;Fb=Ob}}}while(0);if((Fb|0)==0){Z=12;T=294;break b}else{U=M;V=Fb;W=0;break c}break};default:{}}}while(0);if((T|0)==74){T=0;xa=M+1|0;c[q>>2]=zb+1;Y=Zva(m,c[y>>2]|0)|0;if((Y|0)!=0){R=xa;S=Y;T=6;break b}Y=Zva(m,2)|0;if((Y|0)!=0){R=xa;S=Y;T=6;break b}Y=Zva(m,0)|0;if((Y|0)!=0){R=xa;S=Y;T=6;break b}c[y>>2]=(c[y>>2]|0)+1;U=xa;V=N;W=0;break c}else if((T|0)==264){T=0;if((c[v>>2]&1|0)!=0){T=265}}if((T|0)==265){T=0;xa=c[w>>2]|0;Y=hwa(xa,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}$=hwa(xa,0,0,1,20)|0;c[Y+4>>2]=$;if(($|0)==0){Z=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[$>>2]=-1;c[$+4>>2]=-1;c[$+8>>2]=-1;U=M;V=Y;W=0;break c}Y=Nva(h,Q,-1)|0;if((Y|0)<0){c[h>>2]=-1;Pb=1}else{Pb=Y}do{if((c[v>>2]&2|0)==0){T=280}else{if((Eva(c[h>>2]|0)|0)==0){if((Ava(c[h>>2]|0)|0)==0){T=280;break}}Y=c[w>>2]|0;$=Gva(c[h>>2]|0)|0;xa=Gva(c[h>>2]|0)|0;ea=c[x>>2]|0;X=hwa(Y,0,0,1,32)|0;if((X|0)==0){Z=12;T=294;break b}Na=hwa(Y,0,0,1,20)|0;c[X+4>>2]=Na;if((Na|0)==0){Z=12;T=294;break b}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[Na>>2]=$;c[Na+4>>2]=xa;c[Na+8>>2]=ea;ea=c[w>>2]|0;Na=Iva(c[h>>2]|0)|0;xa=Iva(c[h>>2]|0)|0;$=c[x>>2]|0;Y=hwa(ea,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}Oa=hwa(ea,0,0,1,20)|0;c[Y+4>>2]=Oa;if((Oa|0)==0){Z=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[Oa>>2]=Na;c[Oa+4>>2]=xa;c[Oa+8>>2]=$;$=c[w>>2]|0;Oa=hwa($,0,0,1,32)|0;if((Oa|0)==0){Z=12;T=294;break b}xa=hwa($,0,0,1,8)|0;$=Oa+4|0;c[$>>2]=xa;if((xa|0)==0){Z=12;T=294;break b}c[Oa>>2]=3;c[Oa+8>>2]=-1;c[Oa+12>>2]=-1;c[xa>>2]=X;c[(c[$>>2]|0)+4>>2]=Y;c[Oa+16>>2]=(c[Y+16>>2]|0)+(c[X+16>>2]|0);Qb=Oa}}while(0);if((T|0)==280){T=0;Q=c[w>>2]|0;Oa=c[h>>2]|0;X=c[x>>2]|0;Y=hwa(Q,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}$=hwa(Q,0,0,1,20)|0;c[Y+4>>2]=$;if(($|0)==0){Z=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[$>>2]=Oa;c[$+4>>2]=Oa;c[$+8>>2]=X;Qb=Y}c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+Pb;U=M;V=Qb;W=0;break};case 8:{Y=L+ -2|0;c[n>>2]=Y;X=c[P+(Y<<2)>>2]|0;Y=c[w>>2]|0;$=hwa(Y,0,0,1,32)|0;if(($|0)==0){Z=12;T=294;break b}Oa=hwa(Y,0,0,1,8)|0;Y=$+4|0;c[Y>>2]=Oa;if((Oa|0)==0){Z=12;T=294;break b}c[$>>2]=3;c[$+8>>2]=-1;c[$+12>>2]=-1;c[Oa>>2]=X;c[(c[Y>>2]|0)+4>>2]=N;c[$+16>>2]=(c[N+16>>2]|0)+(c[X+16>>2]|0);U=M;V=$;W=0;break};case 3:{$=Zva(m,5)|0;if(($|0)!=0){R=M;S=$;T=6;break b}U=M;V=N;W=Zva(m,4)|0;break};case 6:{$=L+ -2|0;c[n>>2]=$;X=c[P+($<<2)>>2]|0;$=c[w>>2]|0;Y=hwa($,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}Oa=hwa($,0,0,1,8)|0;$=Y+4|0;c[$>>2]=Oa;if((Oa|0)==0){Z=12;T=294;break b}c[Y>>2]=1;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[Oa>>2]=X;c[(c[$>>2]|0)+4>>2]=N;c[Y+16>>2]=(c[N+16>>2]|0)+(c[X+16>>2]|0);U=M;V=Y;W=0;break};case 5:{Y=c[q>>2]|0;X=a[Y]|0;if(X<<24>>24==0){U=M;V=N;W=0;break c}$=c[v>>2]&1;Oa=($|0)!=0;if(Oa&X<<24>>24==124){U=M;V=N;W=0;break c}do{if(!(Oa&X<<24>>24==41&(M|0)>0)){if(($|0)==0&X<<24>>24==92){if((a[Y+1|0]|0)==41){break}}Q=Zva(m,5)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}Q=Zva(m,N)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}Q=Zva(m,6)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}U=M;V=N;W=Zva(m,4)|0;break c}}while(0);X=($|M|0)==0?8:0;Oa=M+ -1|0;if(($|0)!=0){U=Oa;V=N;W=X;break c}c[q>>2]=Y+2;U=Oa;V=N;W=X;break};case 0:{if((c[v>>2]&1|0)!=0){X=Zva(m,7)|0;if((X|0)!=0){R=M;S=X;T=6;break b}}U=M;V=N;W=Zva(m,3)|0;break};case 9:{X=c[q>>2]|0;Oa=a[X]|0;switch(Oa<<24>>24|0){case 123:{Q=c[v>>2]|0;if((Q&1|0)==0){U=M;V=N;W=0;break c}else{Rb=Q;Sb=X}break};case 63:case 43:{if((c[v>>2]&1|0)==0){U=M;V=N;W=0;break c}else{T=41}break};case 42:{T=41;break};case 92:{Q=c[v>>2]|0;if((Q&1|0)!=0){U=M;V=N;W=0;break c}xa=X+1|0;if((a[xa]|0)!=123){U=M;V=N;W=0;break c}c[q>>2]=xa;Rb=Q;Sb=xa;break};default:{U=M;V=N;W=0;break c}}if((T|0)==41){T=0;c[q>>2]=X+1;X=c[w>>2]|0;xa=hwa(X,0,0,1,32)|0;if((xa|0)==0){Z=12;T=294;break b}Q=hwa(X,0,0,1,16)|0;c[xa+4>>2]=Q;if((Q|0)==0){Z=12;T=294;break b}c[xa>>2]=2;c[xa+8>>2]=-1;c[xa+12>>2]=-1;c[Q>>2]=N;c[Q+4>>2]=Oa<<24>>24==43;c[Q+8>>2]=Oa<<24>>24==63?1:-1;Oa=Q+12|0;a[Oa]=a[Oa]&-2;c[xa+16>>2]=c[N+16>>2];U=M;V=xa;W=Zva(m,9)|0;break c}xa=Sb+1|0;c[q>>2]=xa;Oa=a[xa]|0;if((Oa+ -48<<24>>24&255)<10){Q=Oa<<24>>24;if((Q+ -48|0)>>>0<10){Tb=Q;Vb=-1;Wb=xa}else{Z=10;T=294;break b}while(1){Q=((Vb|0)<0?-48:(Vb*10|0)+ -48|0)+Tb|0;X=Wb+1|0;Na=a[X]|0;ea=Na<<24>>24;if((ea+ -48|0)>>>0<10){Wb=X;Vb=Q;Tb=ea}else{Xb=Na;Yb=Q;Zb=X;break}}}else{Xb=Oa;Yb=-1;Zb=xa}do{if(Xb<<24>>24==44){Y=Zb+1|0;$=a[Y]|0;X=$<<24>>24;if((X+ -48|0)>>>0<10){_b=X;$b=-1;ac=Y}else{bc=$;dc=-1;ec=Y;break}while(1){Y=(($b|0)<0?-48:($b*10|0)+ -48|0)+_b|0;$=ac+1|0;X=a[$]|0;Q=X<<24>>24;if((Q+ -48|0)>>>0<10){ac=$;$b=Y;_b=Q}else{fc=X;gc=Y;hc=$;T=54;break}}}else{fc=Xb;gc=Yb;hc=Zb;T=54}}while(0);do{if((T|0)==54){T=0;if(!((gc|0)>-1)){bc=fc;dc=gc;ec=hc;break}if((Yb|0)>(gc|0)|(gc|0)>255){Z=10;T=294;break b}else{bc=fc;dc=gc;ec=hc}}}while(0);if(bc<<24>>24==0){Z=9;T=294;break b}if((ec|0)==(xa|0)){Z=10;T=294;break b}if((Rb&1|0)==0){if(!(bc<<24>>24==92)){Z=10;T=294;break b}if((a[ec+1|0]|0)!=125){Z=10;T=294;break b}ic=ec+2|0}else{if(!(bc<<24>>24==125)){Z=10;T=294;break b}ic=ec+1|0}if((dc|Yb|0)==0){Oa=c[w>>2]|0;$=hwa(Oa,0,0,1,32)|0;if(($|0)==0){Z=12;T=294;break b}Y=hwa(Oa,0,0,1,20)|0;c[$+4>>2]=Y;if((Y|0)==0){Z=12;T=294;break b}c[$>>2]=0;c[$+8>>2]=-1;c[$+12>>2]=-1;c[Y>>2]=-1;c[Y+4>>2]=-1;c[Y+8>>2]=-1;jc=$}else{$=(dc&Yb|0)<0;Y=c[w>>2]|0;Oa=hwa(Y,0,0,1,32)|0;if((Oa|0)==0){Z=12;T=294;break b}X=hwa(Y,0,0,1,16)|0;c[Oa+4>>2]=X;if((X|0)==0){Z=12;T=294;break b}c[Oa>>2]=2;c[Oa+8>>2]=-1;c[Oa+12>>2]=-1;c[X>>2]=N;c[X+4>>2]=$?1:Yb;c[X+8>>2]=$?1:dc;$=X+12|0;a[$]=a[$]&-2;c[Oa+16>>2]=c[N+16>>2];jc=Oa}c[q>>2]=ic;U=M;V=jc;W=Zva(m,9)|0;break};case 10:{Oa=L+ -2|0;c[n>>2]=Oa;c[v>>2]=c[P+(Oa<<2)>>2];U=M;V=N;W=0;break};default:{U=M;V=N;W=0}}}while(0);P=c[n>>2]|0;O=(W|0)==0;if((P|0)>(o|0)&O){L=P;M=U;N=V}else{kc=O;lc=U;mc=V;nc=W;break a}}if((T|0)==6){kc=(S|0)==0;lc=R;mc=N;nc=S;break}else if((T|0)==294){i=d;return Z|0}}else{kc=t;lc=0;mc=0;nc=p}}while(0);p=(lc|0)>0;if(p|kc^1){Z=p?8:nc;i=d;return Z|0}c[b+8>>2]=mc;Z=0;i=d;return Z|0}



function W4(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;n=i;j=c[(c[a+540>>2]|0)+120>>2]|0;o=c[m+4>>2]|0;p=+h[o+64>>3];q=c[o+76>>2]|0;r=c[o+72>>2]|0;s=a+464|0;a=c[s>>2]|0;if((c[a+(j*44|0)+24>>2]|0)==0){i=n;return 0}t=o+80|0;o=c[a+(j*44|0)>>2]|0;u=a;a=0;do{if((o|0)!=0){v=0;do{if(((c[(c[u+(j*44|0)+20>>2]|0)+(v<<2)>>2]|0)+ -1|0)==(a|0)){w=+h[k>>3]*+h[e+(v<<3)>>3];x=d+(v<<3)|0;y=+h[x>>3];if(!(y>=0.0)){z=-y}else{z=y}A=w>=0.0;if(A){B=w}else{B=-w}w=+md(+z,+B);y=+h[l+(v<<3)>>3];if(!(y>=0.0)){C=-y}else{C=y}y=p*+md(+w,+C);D=q+(v<<3)|0;h[D>>3]=y;if(A){E=y}else{E=-y}h[D>>3]=E;y=+h[x>>3];h[D>>3]=E+y-y;h[r+(v<<3)>>3]=+h[x>>3];h[x>>3]=+h[D>>3]+ +h[x>>3];h[D>>3]=1.0/+h[D>>3]}v=v+1|0;}while(v>>>0<o>>>0)}K4(b,0,e,c[t>>2]|0,0,m,0)|0;u=c[s>>2]|0;o=c[u+(j*44|0)>>2]|0;if((o|0)!=0){v=c[u+(j*44|0)+20>>2]|0;D=0;do{if(((c[v+(D<<2)>>2]|0)+ -1|0)==(a|0)){if((D|0)==0){F=u+(j*44|0)+8|0;G=0}else{x=u+(j*44|0)+8|0;F=x;G=c[(c[x>>2]|0)+(D+ -1<<2)>>2]|0}x=c[(c[F>>2]|0)+(D<<2)>>2]|0;if(G>>>0<x>>>0){A=c[t>>2]|0;H=q+(D<<3)|0;I=c[u+(j*44|0)+12>>2]|0;J=c[u+(j*44|0)+4>>2]|0;K=G;do{L=c[I+(K<<2)>>2]|0;M=(fa(J,D)|0)+L|0;h[g+(M<<3)>>3]=(+h[A+(L<<3)>>3]- +h[f+(L<<3)>>3])*+h[H>>3];K=K+1|0;}while(K>>>0<x>>>0)}h[d+(D<<3)>>3]=+h[r+(D<<3)>>3]}D=D+1|0;}while(D>>>0<o>>>0)}a=a+1|0;}while(a>>>0<(c[u+(j*44|0)+24>>2]|0)>>>0);i=n;return 0}function X4(a,b){a=a|0;b=+b;h[a+496>>3]=b;i=i;return}function Y4(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0;e=i;Zd[c[(c[a+540>>2]|0)+112>>2]&1023](a);f=a+328|0;h[f>>3]=d+1.0;g=c[a+104>>2]|0;if((g|0)<=0){i=e;return}j=c[a+108>>2]|0;k=a+336|0;a=0;do{d=+h[j+(a*24|0)+8>>3];if(d>b){h[(c[k>>2]|0)+(a<<3)>>3]=d;l=d}else{m=+h[j+(a*24|0)+16>>3];n=d+m*+ea(+((b-d)/m));h[(c[k>>2]|0)+(a<<3)>>3]=n;l=n}if((a|0)==0){o=8}else{if(l<+h[f>>3]){o=8}}if((o|0)==8){o=0;h[f>>3]=l}a=a+1|0;}while((a|0)<(g|0));i=e;return}function Z4(b,c){b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0;d=i;e=+h[c>>3];f=c+8|0;g=+h[b+328>>3];if(!(g<=e+ +h[f>>3]+1.0e-14)){i=d;return}h[f>>3]=g-e;a[b+317|0]=1;i=d;return}function _4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;d=i;i=i+8|0;e=d;f=a+160|0;if((c[f>>2]|0)<=0){g=s2(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}l=a+540|0;m=a+344|0;n=a+348|0;o=a+368|0;a=0;do{pe[c[(c[l>>2]|0)+104>>2]&63](a,e)|0;p=+h[(c[m>>2]|0)+(a<<3)>>3];if(p==1.0){if(+h[(c[n>>2]|0)+(a<<3)>>3]==-1.0){q=7}else{q=5}}else{q=5}do{if((q|0)==5){q=0;if(!(p==-1.0)){break}if(+h[(c[n>>2]|0)+(a<<3)>>3]==1.0){q=7}}}while(0);if((q|0)==7){q=0;q2(b,(c[o>>2]|0)+(a<<2)|0)}a=a+1|0;}while((a|0)<(c[f>>2]|0));g=s2(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}function $4(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;e=i;g=f+32|0;do{if((_4(b,c[g>>2]|0)|0)!=0){if((a[f+28|0]|0)!=0){break}a5(b,c[g>>2]|0,f)}}while(0);if((a[b+317|0]|0)==1){h=1;i=e;return h|0}b=(s2(d)|0)>0;h=b?2:0;i=e;return h|0}function a5(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=a+112|0;q=c[p>>2]<<3;r=Jwa(q)|0;s=r;t=Jwa(q)|0;q=t;h[n>>3]=+h[a+376>>3];u=a+4|0;h[o>>3]=+h[c[c[u>>2]>>2]>>3];c[25498]=o2(4)|0;if((r|0)==0){bb(102e3,102016,308,102048)}if((t|0)==0){bb(102064,102016,309,102048)}v=v2(b)|0;if((v|0)!=0){w=v;do{v=x2(w)|0;c[l>>2]=c[v>>2];V1(27,0,102080,l);w=w2(w)|0;}while((w|0)!=0)}w=c[p>>2]|0;if((w|0)>0){l=c[(c[c[u>>2]>>2]|0)+8>>2]|0;v=(w|0)>1?w<<3:8;nxa(t|0,c[a+384>>2]|0,v|0)|0;nxa(r|0,l|0,v|0)|0}h[d>>3]=+d5(a,n,o,q,s,c[25498]|0,b);do{if((s2(c[25498]|0)|0)==0){s=t2(b)|0;q=a+344|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));s=v2(b)|0;if((s|0)==0){y=x}else{v=s;z=x;while(1){s=x2(v)|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));A=z>x?x:z;s=w2(v)|0;if((s|0)==0){y=A;break}else{z=A;v=s}}}v=j;h[k>>3]=y;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];V1(27,0,102128,j);v=v2(b)|0;if((v|0)==0){break}else{B=v}do{v=x2(B)|0;if(y==+U(+(+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]))){v=c[25498]|0;r2(v,x2(B)|0);v=x2(B)|0;c[g>>2]=c[v>>2];V1(27,0,102152,g)}B=w2(B)|0;}while((B|0)!=0)}}while(0);p2(b);if((c[70916>>2]|0)!=0){s2(c[25498]|0)|0}if((s2(c[25498]|0)|0)>0){B=m;do{g=t2(c[25498]|0)|0;c[m>>2]=c[g>>2];u2(c[25498]|0);c[f>>2]=c[m>>2];V1(7,0,102176,f);q2(b,B);}while((s2(c[25498]|0)|0)>0)}h[d>>3]=+h[o>>3];o=c[c[u>>2]>>2]|0;h[o>>3]=+h[n>>3];n=c[p>>2]|0;if((n|0)>0){nxa(c[o+8>>2]|0,t|0,((n|0)>1?n<<3:8)|0)|0}Re(a);g5(a);a=c[c[u>>2]>>2]|0;h[a>>3]=+h[d>>3];d=c[p>>2]|0;if((d|0)<=0){Kwa(t);Kwa(r);i=e;return}nxa(c[a+8>>2]|0,r|0,((d|0)>1?d<<3:8)|0)|0;Kwa(t);Kwa(r);i=e;return}function b5(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0;g=i;i=i+32|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+8|0;p=b+4|0;q=+h[c[c[p>>2]>>2]>>3];r=b+317|0;do{if((a[r]|0)!=0){k5(b);s=b+104|0;t=c[s>>2]|0;if((t|0)<=0){break}u=b+336|0;v=q+1.0e-14;w=b+340|0;x=b+108|0;y=t;t=0;while(1){if(!(+h[(c[u>>2]|0)+(t<<3)>>3]<=v)){z=y}else{a[(c[w>>2]|0)+t|0]=1;A=c[x>>2]|0;B=+h[A+(t*24|0)+8>>3];C=+h[A+(t*24|0)+16>>3];c[m>>2]=c[A+(t*24|0)>>2];A=m+4|0;h[k>>3]=B;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=m+12|0;h[k>>3]=C;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];V1(7,0,101720,m);z=c[s>>2]|0}A=t+1|0;if((A|0)<(z|0)){y=z;t=A}else{break}}}}while(0);z=b+512|0;m=b+524|0;t=b+516|0;y=b+528|0;c[y>>2]=(c[y>>2]|0)-(c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]|0);if((s2(d)|0)>0){h[c[c[p>>2]>>2]>>3]=+h[e>>3];do{if((c[70916>>2]|0)!=0){e=v2(d)|0;if((e|0)==0){break}p=b+540|0;s=e;do{e=x2(s)|0;x=c[e>>2]|0;e=pe[c[(c[p>>2]|0)+104>>2]&63](x,n)|0;w=c[n>>2]|0;c[l>>2]=x;c[l+4>>2]=e;U1(7,0,w,101744,l);s=w2(s)|0;}while((s|0)!=0)}}while(0);l=f+40|0;c[l>>2]=(c[l>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+1;c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=1;l=c[m>>2]|0;n=c[b+520>>2]|0;h[n+(l<<3)>>3]=q;s=b+532|0;do{if((c[s>>2]|0)==0){p=c[y>>2]|0;if((p|0)!=(c[z>>2]|0)){break}v=+h[n+(((l+1|0)%(p|0)|0)<<3)>>3];w=b+264|0;if(!(q-v<+h[w>>3])){break}e=x2(v2(d)|0)|0;x=pe[c[(c[b+540>>2]|0)+104>>2]&63](c[e>>2]|0,o)|0;e=c[o>>2]|0;C=+h[w>>3];w=j;h[k>>3]=v;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=j+8|0;h[k>>3]=q;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[j+16>>2]=p;p=j+20|0;h[k>>3]=C;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[j+28>>2]=x;U1(1,0,e,101760,j);c[s>>2]=1}}while(0);p2(d)}else{c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=0}c[m>>2]=((c[m>>2]|0)+1|0)%(c[z>>2]|0)|0;f5(b);c5(b);if((a[r]|0)==0){i=g;return}z=b+104|0;m=c[z>>2]|0;do{if((m|0)>0){t=b+340|0;d=b+108|0;s=b+336|0;j=m;o=0;while(1){l=(c[t>>2]|0)+o|0;if((a[l]|0)==0){D=j}else{a[l]=0;l=(c[s>>2]|0)+(o<<3)|0;h[l>>3]=+h[(c[d>>2]|0)+(o*24|0)+16>>3]+ +h[l>>3];D=c[z>>2]|0}l=o+1|0;if((l|0)<(D|0)){j=D;o=l}else{break}}if((D|0)<=0){break}o=b+336|0;j=b+328|0;d=0;do{s=c[o>>2]|0;if((d|0)==0){E=+h[s>>3];F=29}else{q=+h[s+(d<<3)>>3];if(q<+h[j>>3]){E=q;F=29}}if((F|0)==29){F=0;h[j>>3]=E}d=d+1|0;}while((d|0)<(D|0))}}while(0);a[r]=0;r=f+44|0;c[r>>2]=(c[r>>2]|0)+1;i=g;return}function c5(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;V1(27,0,102368,b);d=a+344|0;de[c[(c[a+540>>2]|0)+92>>2]&63](a,c[d>>2]|0,c[c[a+4>>2]>>2]|0)|0;e=c[a+160>>2]|0;if((e|0)<=0){i=b;return}f=c[d>>2]|0;d=c[a+348>>2]|0;a=0;do{h[d+(a<<3)>>3]=+h[f+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=b;return}function d5(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=a+160|0;p=c[o>>2]|0;q=Jwa(p<<3)|0;if((q|0)==0){bb(102184,102016,409,102200)}if((p|0)>0){nxa(q|0,c[a+344>>2]|0,((p|0)>1?p<<3:8)|0)|0}r=+h[d>>3];p=n;h[k>>3]=+h[b>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=r;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];V1(27,0,102216,n);n=m;h[k>>3]=1.0e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];V1(27,0,102264,m);r=+h[d>>3];s=+h[b>>3];if(!(+U(+(r-s))>1.0e-9)){Kwa(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}m=a+4|0;n=a+112|0;p=a+540|0;x=a+344|0;y=a+348|0;z=c[n>>2]|0;A=s;s=r;while(1){r=(s+A)*.5;B=c[c[m>>2]>>2]|0;h[B>>3]=r;if((z|0)>0){C=c[B+8>>2]|0;B=0;do{h[C+(B<<3)>>3]=(+h[e+(B<<3)>>3]+ +h[f+(B<<3)>>3])*.5;B=B+1|0;}while((B|0)<(z|0))}A6(a)|0;ae[c[(c[p>>2]|0)+40>>2]&127](a)|0;ae[c[(c[p>>2]|0)+28>>2]&127](a)|0;ae[c[(c[p>>2]|0)+32>>2]&127](a)|0;de[c[(c[p>>2]|0)+92>>2]&63](a,c[x>>2]|0,c[c[m>>2]>>2]|0)|0;B=(e5(a,g,j)|0)==0;C=c[n>>2]|0;D=(C|0)>0;do{if(B){if(D){E=c[(c[c[m>>2]>>2]|0)+8>>2]|0;F=0;do{h[e+(F<<3)>>3]=+h[E+(F<<3)>>3];F=F+1|0;}while((F|0)<(C|0))}h[b>>3]=r;F=c[o>>2]|0;if((F|0)>0){E=c[x>>2]|0;G=c[y>>2]|0;H=0;do{I=E+(H<<3)|0;h[G+(H<<3)>>3]=+h[I>>3];h[I>>3]=+h[q+(H<<3)>>3];H=H+1|0;}while((H|0)<(F|0))}J=+h[d>>3]}else{if(D){F=c[(c[c[m>>2]>>2]|0)+8>>2]|0;H=0;do{h[f+(H<<3)>>3]=+h[F+(H<<3)>>3];H=H+1|0;}while((H|0)<(C|0))}h[d>>3]=r;H=c[o>>2]|0;if((H|0)<=0){J=r;break}nxa(q|0,c[x>>2]|0,((H|0)>1?H<<3:8)|0)|0;J=r}}while(0);r=+h[b>>3];if(+U(+(J-r))>1.0e-9){z=C;A=r;s=J}else{break}}Kwa(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}function e5(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;p2(b);V1(27,0,102288,g);g=v2(d)|0;if((g|0)==0){j=s2(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}d=a+344|0;m=a+348|0;a=g;do{g=x2(a)|0;if(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){g=x2(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==1.0){n=7}else{n=5}}else{n=5}do{if((n|0)==5){n=0;g=x2(a)|0;if(!(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==1.0)){break}g=x2(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){n=7}}}while(0);if((n|0)==7){n=0;g=x2(a)|0;o=c[g>>2]|0;g=x2(a)|0;p=+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]>0.0?101704:101712;g=x2(a)|0;q=+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]>0.0?101704:101712;c[f>>2]=o;c[f+4>>2]=p;c[f+8>>2]=q;V1(27,0,102328,f);q2(b,x2(a)|0)}a=w2(a)|0;}while((a|0)!=0);j=s2(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}function f5(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+8|0;e=d;f=b+315|0;a[f]=0;g=b+540|0;pe[c[(c[g>>2]|0)+96>>2]&63](b,1)|0;g5(b);h5(b);ae[c[(c[g>>2]|0)+36>>2]&127](b)|0;i5(b,8);h=j5(b)|0;j=ae[c[(c[g>>2]|0)+100>>2]&127](b)|0;k=b+312|0;if((a[k]|0)==0){l=1;m=j;n=h}else{h5(b);i=d;return}while(1){if((m|0)==0){if((a[f]|n)<<24>>24==0){o=7;break}}k5(b);g5(b);i5(b,8);ae[c[(c[g>>2]|0)+36>>2]&127](b)|0;if((l|0)>200){o=5;break}h=j5(b)|0;j=ae[c[(c[g>>2]|0)+100>>2]&127](b)|0;if((a[k]|0)==0){l=l+1|0;m=j;n=h}else{o=7;break}}if((o|0)==5){Z1(c[b+536>>2]|0,102408,e)}else if((o|0)==7){h5(b);i=d;return}}function g5(a){a=a|0;var b=0;b=i;nxa(c[a+356>>2]|0,c[a+352>>2]|0,c[a+164>>2]|0)|0;i=b;return}function h5(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+164|0;if((c[e>>2]|0)<=0){i=d;return}f=b+352|0;g=b+360|0;b=0;do{a[(c[g>>2]|0)+b|0]=(a[(c[f>>2]|0)+b|0]|0)!=0|0;b=b+1|0;}while((b|0)<(c[e>>2]|0));i=d;return}function i5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+8|0;if((c[70888+(d<<2)>>2]|0)==0){i=e;return}V1(d,1,102832,g);g=b+164|0;if((c[g>>2]|0)>0){h=b+540|0;j=b+352|0;k=b+356|0;b=0;do{l=ae[c[(c[h>>2]|0)+108>>2]&127](b)|0;m=(a[(c[j>>2]|0)+b|0]|0)!=0?84:70;n=ae[c[(c[h>>2]|0)+108>>2]&127](b)|0;o=(a[(c[k>>2]|0)+b|0]|0)!=0?84:70;c[f>>2]=b;c[f+4>>2]=l;c[f+8>>2]=m;c[f+12>>2]=n;c[f+16>>2]=o;V1(d,0,102856,f);b=b+1|0;}while((b|0)<(c[g>>2]|0))}Zd[c[17860]&1023](d);i=e;return}function j5(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+164>>2]|0;if((e|0)<=0){f=0;i=d;return f|0}g=c[b+356>>2]|0;h=c[b+352>>2]|0;b=0;while(1){j=b+1|0;if((a[g+b|0]|0)!=(a[h+b|0]|0)){f=1;k=5;break}if((j|0)<(e|0)){b=j}else{f=0;k=5;break}}if((k|0)==5){i=d;return f|0}return 0}function k5(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;nxa(c[a+400>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;nxa(c[a+404>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;nxa(c[a+408>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;nxa(c[a+412>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function l5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+160>>2]|0;e=c[a+344>>2]|0;if((d|0)>0){f=c[a+348>>2]|0;g=0;do{h[f+(g<<3)>>3]=+h[e+(g<<3)>>3];g=g+1|0;}while((g|0)<(d|0))}de[c[(c[a+540>>2]|0)+92>>2]&63](a,e,c[c[a+4>>2]>>2]|0)|0;i=b;return}function m5(a){a=a|0;var b=0;b=i;n5(a);o5(a);k5(a);p5(a);i=b;return}function n5(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+136>>2]|0;if((e|0)>0){f=c[b+24>>2]|0;g=c[b+416>>2]|0;j=0;do{h[g+(j<<3)>>3]=+h[f+(j*112|0)+96>>3];j=j+1|0;}while((j|0)<(e|0))}e=b+140|0;if((c[e>>2]|0)>0){j=c[b+28>>2]|0;f=c[b+420>>2]|0;g=0;do{c[f+(g<<2)>>2]=c[j+(g*60|0)+52>>2];g=g+1|0;}while((g|0)<(c[e>>2]|0))}e=b+144|0;if((c[e>>2]|0)>0){g=b+32|0;j=b+424|0;f=0;do{a[(c[j>>2]|0)+f|0]=a[(c[g>>2]|0)+(f*48|0)+42|0]|0;f=f+1|0;}while((f|0)<(c[e>>2]|0))}e=c[b+148>>2]|0;if((e|0)<=0){i=d;return}f=b+36|0;g=b+428|0;b=0;do{c[(c[g>>2]|0)+(b<<2)>>2]=c[(c[f>>2]|0)+(b*52|0)+44>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function o5(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[b+8>>2]|0;j=c[e+8>>2]|0;k=0;do{h[j+(k<<3)>>3]=+h[g+(k*112|0)+96>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[b+12>>2]|0;g=c[e+12>>2]|0;j=0;do{c[g+(j<<2)>>2]=c[k+(j*60|0)+52>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=b+16|0;k=e+16|0;g=0;do{a[(c[k>>2]|0)+g|0]=a[(c[j>>2]|0)+(g*48|0)+42|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=b+20|0;b=e+20|0;e=0;do{c[(c[b>>2]|0)+(e<<2)>>2]=c[(c[g>>2]|0)+(e*52|0)+44>>2];e=e+1|0;}while((e|0)<(f|0));i=d;return}function p5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((v3(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=a+ -1|0;m=c[e>>2]|0;n=c[m+(l<<2)>>2]|0;o=c[m+(a<<2)>>2]|0;h[o>>3]=+h[n>>3];nxa(c[o+8>>2]|0,c[n+8>>2]|0,c[f>>2]<<3|0)|0;n=c[e>>2]|0;nxa(c[(c[n+(a<<2)>>2]|0)+12>>2]|0,c[(c[n+(l<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;n=c[e>>2]|0;nxa(c[(c[n+(a<<2)>>2]|0)+16>>2]|0,c[(c[n+(l<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;n=c[e>>2]|0;nxa(c[(c[n+(a<<2)>>2]|0)+20>>2]|0,c[(c[n+(l<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(v3(c[d>>2]|0)|0));i=b;return}function q5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[70888+(d<<2)>>2]|0)==0){i=e;return}V1(d,1,102504,q);q=b+136|0;if((c[q>>2]|0)>0){V1(d,1,102528,p);if((c[q>>2]|0)>0){p=b+24|0;r=b+416|0;s=0;while(1){t=s+1|0;u=c[p>>2]|0;v=c[u+(s*112|0)+4>>2]|0;w=+h[u+(s*112|0)+96>>3];x=(a[u+(s*112|0)+72|0]|0)!=0?102488:102496;y=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=t;c[o+4>>2]=v;v=o+8|0;h[k>>3]=w;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[o+16>>2]=x;x=o+20|0;h[k>>3]=y;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];V1(d,0,102544,o);if((t|0)<(c[q>>2]|0)){s=t}else{break}}}Zd[c[17860]&1023](d)}s=b+140|0;if((c[s>>2]|0)>0){V1(d,1,102600,n);if((c[s>>2]|0)>0){n=b+28|0;q=b+420|0;o=0;while(1){r=o+1|0;p=c[n>>2]|0;t=c[p+(o*60|0)+4>>2]|0;x=c[p+(o*60|0)+52>>2]|0;v=(a[p+(o*60|0)+48|0]|0)!=0?102488:102496;p=c[(c[q>>2]|0)+(o<<2)>>2]|0;c[m>>2]=r;c[m+4>>2]=t;c[m+8>>2]=x;c[m+12>>2]=v;c[m+16>>2]=p;V1(d,0,102624,m);if((r|0)<(c[s>>2]|0)){o=r}else{break}}}Zd[c[17860]&1023](d)}o=b+144|0;if((c[o>>2]|0)>0){V1(d,1,102680,l);if((c[o>>2]|0)>0){l=b+32|0;s=b+424|0;m=0;while(1){q=m+1|0;n=c[l>>2]|0;r=c[n+(m*48|0)+4>>2]|0;p=(a[n+(m*48|0)+42|0]|0)!=0?102488:102496;v=(a[n+(m*48|0)+40|0]|0)!=0?102488:102496;n=(a[(c[s>>2]|0)+m|0]|0)!=0?102488:102496;c[j>>2]=q;c[j+4>>2]=r;c[j+8>>2]=p;c[j+12>>2]=v;c[j+16>>2]=n;V1(d,0,102704,j);if((q|0)<(c[o>>2]|0)){m=q}else{break}}}Zd[c[17860]&1023](d)}m=b+148|0;if((c[m>>2]|0)>0){V1(d,1,102760,g);if((c[m>>2]|0)>0){g=b+36|0;o=b+428|0;b=0;while(1){j=b+1|0;s=c[g>>2]|0;l=c[s+(b*52|0)+4>>2]|0;q=c[s+(b*52|0)+44>>2]|0;s=c[(c[o>>2]|0)+(b<<2)>>2]|0;c[f>>2]=j;c[f+4>>2]=l;c[f+8>>2]=q;c[f+12>>2]=s;V1(d,0,102784,f);if((j|0)<(c[m>>2]|0)){b=j}else{break}}}Zd[c[17860]&1023](d)}Zd[c[17860]&1023](d);i=e;return}function r5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((v3(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=c[e>>2]|0;m=c[l+(a<<2)>>2]|0;n=a+ -1|0;o=c[l+(n<<2)>>2]|0;h[o>>3]=+h[m>>3];nxa(c[o+8>>2]|0,c[m+8>>2]|0,c[f>>2]<<3|0)|0;m=c[e>>2]|0;nxa(c[(c[m+(n<<2)>>2]|0)+12>>2]|0,c[(c[m+(a<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;m=c[e>>2]|0;nxa(c[(c[m+(n<<2)>>2]|0)+16>>2]|0,c[(c[m+(a<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;m=c[e>>2]|0;nxa(c[(c[m+(n<<2)>>2]|0)+20>>2]|0,c[(c[m+(a<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(v3(c[d>>2]|0)|0));i=b;return}function s5(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[e+8>>2]|0;j=c[b+8>>2]|0;k=0;do{h[j+(k*112|0)+96>>3]=+h[g+(k<<3)>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[e+12>>2]|0;g=c[b+12>>2]|0;j=0;do{c[g+(j*60|0)+52>>2]=c[k+(j<<2)>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=e+16|0;k=b+16|0;g=0;do{a[(c[k>>2]|0)+(g*48|0)+42|0]=a[(c[j>>2]|0)+g|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=e+20|0;e=b+20|0;b=0;do{c[(c[e>>2]|0)+(b*52|0)+44>>2]=c[(c[g>>2]|0)+(b<<2)>>2];b=b+1|0;}while((b|0)<(f|0));i=d;return}function t5(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;h[a+376>>3]=+h[d>>3];nxa(c[a+384>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;nxa(c[a+388>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;nxa(c[a+392>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;nxa(c[a+396>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function u5(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+32|0;o=b;c[o>>2]=0;p=q3(3,32)|0;c[o>>2]=p;if((p|0)==0){Z1(c[b+536>>2]|0,102888,m)}m=n;p=b+116|0;q=n+8|0;r=b+536|0;s=b+124|0;t=n+12|0;u=b+128|0;v=n+16|0;w=b+132|0;x=n+20|0;y=n;n=0;do{h[m>>3]=0.0;z=Lwa(c[p>>2]|0,8)|0;c[q>>2]=z;Y1(c[r>>2]|0,(z|0)!=0|0,102944,l);z=Lwa(c[s>>2]|0,4)|0;c[t>>2]=z;Y1(c[r>>2]|0,(z|0)!=0|0,102944,k);z=Lwa(c[u>>2]|0,1)|0;c[v>>2]=z;Y1(c[r>>2]|0,(z|0)!=0|0,102944,j);z=Lwa(c[w>>2]|0,4)|0;c[x>>2]=z;Y1(c[r>>2]|0,(z|0)!=0|0,102944,g);u3(c[o>>2]|0,y);n=n+1|0;}while(n>>>0<3);n=Lwa(3,4)|0;c[b+4>>2]=n;w3(c[o>>2]|0,0,n);c[b+8>>2]=Lwa(c[p>>2]|0,112)|0;c[b+12>>2]=Lwa(c[s>>2]|0,60)|0;c[b+16>>2]=Lwa(c[u>>2]|0,48)|0;c[b+20>>2]=Lwa(c[w>>2]|0,52)|0;n=b+136|0;c[b+24>>2]=Lwa(c[n>>2]|0,112)|0;o=c[b+140>>2]|0;c[b+28>>2]=Lwa(o,60)|0;y=c[b+144>>2]|0;c[b+32>>2]=Lwa(y,48)|0;g=c[b+148>>2]|0;c[b+36>>2]=Lwa(g,52)|0;c[b+40>>2]=Lwa(c[b+216>>2]|0,52)|0;c[b+44>>2]=Lwa(c[b+220>>2]|0,52)|0;c[b+48>>2]=Lwa(c[b+224>>2]|0,52)|0;c[b+52>>2]=Lwa(c[b+228>>2]|0,52)|0;x=c[b+104>>2]|0;c[b+108>>2]=Lwa(x,24)|0;h[b+328>>3]=+h[b+240>>3];c[b+336>>2]=Lwa(x,8)|0;c[b+340>>2]=Lwa(x,1)|0;c[b+300>>2]=1;c[b+292>>2]=1;c[b+296>>2]=1;x=c[b+160>>2]|0;c[b+344>>2]=Lwa(x,8)|0;c[b+348>>2]=Lwa(x,8)|0;j=c[b+164>>2]|0;c[b+352>>2]=Lwa(j,1)|0;c[b+356>>2]=Lwa(j,1)|0;c[b+360>>2]=Lwa(j,1)|0;j=Jwa(x<<2)|0;c[b+368>>2]=j;c[b+364>>2]=Jwa(c[b+168>>2]<<3)|0;if((x|0)!=0){v=0;do{c[j+(v<<2)>>2]=v;v=v+1|0;}while(v>>>0<x>>>0)}x=c[p>>2]|0;c[b+384>>2]=Lwa(x,8)|0;p=c[s>>2]|0;c[b+388>>2]=Lwa(p,4)|0;s=c[u>>2]|0;c[b+392>>2]=Lwa(s,1)|0;u=c[w>>2]|0;c[b+396>>2]=Lwa(u,4)|0;c[b+400>>2]=Lwa(x,8)|0;c[b+404>>2]=Lwa(p,4)|0;c[b+408>>2]=Lwa(s,1)|0;c[b+412>>2]=Lwa(u,4)|0;c[b+416>>2]=Lwa(c[n>>2]|0,8)|0;c[b+420>>2]=Lwa(o,4)|0;c[b+424>>2]=Lwa(y,1)|0;c[b+428>>2]=Lwa(g,4)|0;c[b+432>>2]=Lwa(c[b+152>>2]|0,8)|0;c[b+436>>2]=Lwa(c[b+156>>2]|0,8)|0;g=Jwa((c[b+192>>2]|0)*40|0)|0;c[b+484>>2]=g;y=b+540|0;Zd[c[(c[y>>2]|0)+20>>2]&1023](g);g=Jwa((c[b+196>>2]|0)*80|0)|0;c[b+476>>2]=g;Zd[c[(c[y>>2]|0)+16>>2]&1023](g);g=Jwa((c[b+200>>2]|0)*80|0)|0;c[b+468>>2]=g;Zd[c[(c[y>>2]|0)+12>>2]&1023](g);g=Jwa((c[b+204>>2]|0)*48|0)|0;c[b+488>>2]=g;_d[c[(c[y>>2]|0)+24>>2]&127](g,b);c[b+464>>2]=Jwa((c[b+232>>2]|0)*44|0)|0;c[b+76>>2]=0;c[b+80>>2]=0;g=Lwa(c[b+188>>2]|0,4)|0;c[b+320>>2]=g;Y1(c[r>>2]|0,(g|0)!=0|0,102960,f);c[b+512>>2]=100;c[b+516>>2]=Lwa(100,4)|0;c[b+520>>2]=Lwa(100,8)|0;c[b+524>>2]=0;c[b+528>>2]=0;c[b+532>>2]=0;h[b+304>>3]=1.0;a[b+313|0]=0;a[b+312|0]=0;a[b+314|0]=0;f=b+172|0;g=b+316|0;a[g]=0;a[g+1|0]=0;a[g+2|0]=0;a[g+3|0]=0;g=Jwa(c[f>>2]<<2)|0;y=b+504|0;c[y>>2]=g;Y1(c[r>>2]|0,(g|0)!=0|0,102944,e);if((c[f>>2]|0)==0){i=d;return}else{A=0}do{e=q3(1024,16)|0;c[(c[y>>2]|0)+(A<<2)>>2]=e;A=A+1|0;}while(A>>>0<(c[f>>2]|0)>>>0);i=d;return}function v5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;d=a+4|0;e=c[d>>2]|0;f=0;do{g=c[e+(f<<2)>>2]|0;Kwa(c[g+8>>2]|0);Kwa(c[g+12>>2]|0);Kwa(c[g+16>>2]|0);Kwa(c[g+20>>2]|0);f=f+1|0;e=c[d>>2]|0}while(f>>>0<3);Kwa(e);r3(c[a>>2]|0);e=a+116|0;f=a+8|0;d=c[f>>2]|0;if((c[e>>2]|0)==0){h=d}else{g=d;d=0;while(1){O3(g+(d*112|0)|0);j=d+1|0;k=c[f>>2]|0;if(j>>>0<(c[e>>2]|0)>>>0){d=j;g=k}else{h=k;break}}}Kwa(h);h=a+124|0;g=a+12|0;d=c[g>>2]|0;if((c[h>>2]|0)==0){l=d}else{e=d;d=0;while(1){O3(e+(d*60|0)|0);f=d+1|0;k=c[g>>2]|0;if(f>>>0<(c[h>>2]|0)>>>0){d=f;e=k}else{l=k;break}}}Kwa(l);l=a+128|0;e=a+16|0;d=c[e>>2]|0;if((c[l>>2]|0)==0){m=d}else{h=d;d=0;while(1){O3(h+(d*48|0)|0);g=d+1|0;k=c[e>>2]|0;if(g>>>0<(c[l>>2]|0)>>>0){d=g;h=k}else{m=k;break}}}Kwa(m);m=a+132|0;h=a+20|0;d=c[h>>2]|0;if((c[m>>2]|0)==0){n=d}else{l=d;d=0;while(1){O3(l+(d*52|0)|0);e=d+1|0;k=c[h>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){d=e;l=k}else{n=k;break}}}Kwa(n);n=a+136|0;l=a+24|0;d=c[l>>2]|0;if((c[n>>2]|0)==0){o=d}else{m=d;d=0;while(1){O3(m+(d*112|0)|0);h=d+1|0;k=c[l>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){d=h;m=k}else{o=k;break}}}Kwa(o);o=a+140|0;m=a+28|0;d=c[m>>2]|0;if((c[o>>2]|0)==0){p=d}else{n=d;d=0;while(1){O3(n+(d*60|0)|0);l=d+1|0;k=c[m>>2]|0;if(l>>>0<(c[o>>2]|0)>>>0){d=l;n=k}else{p=k;break}}}Kwa(p);p=a+144|0;n=a+32|0;d=c[n>>2]|0;if((c[p>>2]|0)==0){q=d}else{o=d;d=0;while(1){O3(o+(d*48|0)|0);m=d+1|0;k=c[n>>2]|0;if(m>>>0<(c[p>>2]|0)>>>0){d=m;o=k}else{q=k;break}}}Kwa(q);q=a+148|0;o=a+36|0;d=c[o>>2]|0;if((c[q>>2]|0)==0){r=d}else{p=d;d=0;while(1){O3(p+(d*52|0)|0);n=d+1|0;k=c[o>>2]|0;if(n>>>0<(c[q>>2]|0)>>>0){d=n;p=k}else{r=k;break}}}Kwa(r);r=a+216|0;p=a+40|0;d=c[p>>2]|0;if((c[r>>2]|0)==0){s=d}else{q=d;d=0;while(1){O3(q+(d*52|0)+12|0);o=d+1|0;k=c[p>>2]|0;if(o>>>0<(c[r>>2]|0)>>>0){d=o;q=k}else{s=k;break}}}Kwa(s);s=a+220|0;q=a+44|0;d=c[q>>2]|0;if((c[s>>2]|0)==0){t=d}else{r=d;d=0;while(1){O3(r+(d*52|0)+12|0);p=d+1|0;k=c[q>>2]|0;if(p>>>0<(c[s>>2]|0)>>>0){d=p;r=k}else{t=k;break}}}Kwa(t);t=a+224|0;r=a+48|0;d=c[r>>2]|0;if((c[t>>2]|0)==0){u=d}else{s=d;d=0;while(1){O3(s+(d*52|0)+12|0);q=d+1|0;k=c[r>>2]|0;if(q>>>0<(c[t>>2]|0)>>>0){d=q;s=k}else{u=k;break}}}Kwa(u);u=a+228|0;s=a+52|0;d=c[s>>2]|0;if((c[u>>2]|0)==0){v=d}else{t=d;d=0;while(1){O3(t+(d*52|0)+12|0);r=d+1|0;k=c[s>>2]|0;if(r>>>0<(c[u>>2]|0)>>>0){d=r;t=k}else{v=k;break}}}Kwa(v);Kwa(c[a+108>>2]|0);Kwa(c[a+336>>2]|0);Kwa(c[a+340>>2]|0);Kwa(c[a+344>>2]|0);Kwa(c[a+348>>2]|0);Kwa(c[a+352>>2]|0);Kwa(c[a+356>>2]|0);Kwa(c[a+360>>2]|0);Kwa(c[a+368>>2]|0);Kwa(c[a+384>>2]|0);Kwa(c[a+388>>2]|0);Kwa(c[a+392>>2]|0);Kwa(c[a+396>>2]|0);Kwa(c[a+400>>2]|0);Kwa(c[a+404>>2]|0);Kwa(c[a+408>>2]|0);Kwa(c[a+412>>2]|0);Kwa(c[a+416>>2]|0);Kwa(c[a+420>>2]|0);Kwa(c[a+424>>2]|0);Kwa(c[a+428>>2]|0);Kwa(c[a+488>>2]|0);Kwa(c[a+484>>2]|0);Kwa(c[a+476>>2]|0);Kwa(c[a+468>>2]|0);Kwa(c[a+464>>2]|0);Kwa(c[a+432>>2]|0);Kwa(c[a+436>>2]|0);Kwa(c[a+320>>2]|0);Kwa(c[a+516>>2]|0);Kwa(c[a+520>>2]|0);bka(a+56|0);v=a+172|0;t=a+504|0;a=c[t>>2]|0;if((c[v>>2]|0)==0){w=a;x=w;Kwa(x);i=b;return}else{y=a;z=0}while(1){r3(c[y+(z<<2)>>2]|0);a=z+1|0;d=c[t>>2]|0;if(a>>>0<(c[v>>2]|0)>>>0){z=a;y=d}else{w=d;break}}x=w;Kwa(x);i=b;return}function w5(a){a=+a;var b=0,d=0,e=0.0,f=0;b=i;i=i+8|0;d=b;e=a*1.0e-4;h[12875]=e;f=d;h[k>>3]=e;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];V1(8,0,103008,d);i=b;return}function x5(a,b){a=+a;b=+b;i=i;return a<=b|0}function y5(a,b){a=+a;b=+b;i=i;return a>=b|0}function z5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){j=c[e+(h*40|0)>>2]|0;k=j<<2;c[e+(h*40|0)+20>>2]=Jwa(k)|0;c[e+(h*40|0)+24>>2]=Jwa(k)|0;if((c[g>>2]|0)!=1){l=5;break}C5(j,e+(h*40|0)+28|0)|0;j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{l=6;break}}if((l|0)==5){Z1(c[a+536>>2]|0,103064,d)}else if((l|0)==6){i=b;return 0}return 0}function A5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){Kwa(c[e+(h*40|0)+20>>2]|0);Kwa(c[e+(h*40|0)+24>>2]|0);if((c[g>>2]|0)!=1){j=5;break}k=e+(h*40|0)+28|0;D5(k)|0;Kwa(c[k>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{j=6;break}}if((j|0)==5){Z1(c[a+536>>2]|0,103064,d)}else if((j|0)==6){i=b;return 0}return 0}function B5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+484>>2]|0;o=b+192|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+4|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p*40|0)+36|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[70956>>2]|c[17720]|0)==0){z=w;A=1;break}$ja(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];X1(17,1,103096,g);$ja(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;$ja(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;X1(17,0,103128,f);$ja(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}Zd[c[17860]&1023](17);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function C5(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=Jwa(20)|0;c[b>>2]=f;Y1(0,(f|0)!=0|0,103136,e);e=Jwa(a)|0;c[f>>2]=e;e=Jwa(a)|0;c[f+4>>2]=e;e=Jwa(a)|0;c[f+8>>2]=e;e=Jwa(a)|0;c[f+16>>2]=e;Y1(0,(c[b>>2]|0)!=0|0,103168,d);i=d;return 0}function D5(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Kwa(c[d>>2]|0);Kwa(c[d+4>>2]|0);Kwa(c[d+8>>2]|0);Kwa(c[d+16>>2]|0);i=b;return 0}function E5(a,b){a=a|0;b=b|0;b=i;i=i+8|0;Z1(c[a+536>>2]|0,103216,b);return 0}function F5(a){a=a|0;a=i;i=i+8|0;Z1(0,103216,a);return 0}function G5(a,b){a=a|0;b=b|0;b=i;i=i+8|0;Z1(c[a+536>>2]|0,103216,b);return 0}function H5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){j=c[e+(h<<6)+16>>2]|0;k=c[e+(h<<6)+12>>2]|0;l=j<<3;c[e+(h<<6)+28>>2]=Jwa(l)|0;c[e+(h<<6)+36>>2]=Jwa(l)|0;m=c[g>>2]|0;if((m|0)==2){c[e+(h<<6)+8>>2]=2;O5(j,j,k,e+(h<<6)+24|0)|0}else if((m|0)==1){c[e+(h<<6)+32>>2]=Jwa(fa(l,j)|0)|0;c[e+(h<<6)+8>>2]=1;M5(j,e+(h<<6)+24|0)|0}else{n=6;break}j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{n=8;break}}if((n|0)==6){Z1(c[a+536>>2]|0,103256,d)}else if((n|0)==8){i=b;return 0}return 0}function I5(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=(fa(c[f+16>>2]|0,b)|0)+a|0;h[(c[f+32>>2]|0)+(e<<3)>>3]=d;i=i;return}function J5(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=i;ub(0,a|0,b|0,+d,c[c[f+24>>2]>>2]|0)|0;i=e;return}function K5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){Kwa(c[e+(h<<6)+28>>2]|0);Kwa(c[e+(h<<6)+36>>2]|0);j=c[g>>2]|0;if((j|0)==2){P5(e+(h<<6)+24|0)|0}else if((j|0)==1){N5(e+(h<<6)+24|0)|0;Kwa(c[e+(h<<6)+32>>2]|0)}else{k=6;break}Kwa(c[e+(h<<6)+24>>2]|0);j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{k=8;break}}if((k|0)==6){Z1(c[a+536>>2]|0,103256,d)}else if((k|0)==8){i=b;return 0}return 0}function L5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+476>>2]|0;o=b+196|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+20|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p<<6)+56|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[70948>>2]|c[17720]|0)==0){z=w;A=1;break}$ja(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];X1(15,1,103288,g);$ja(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;$ja(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;X1(15,0,103320,f);$ja(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}Zd[c[17860]&1023](15);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function M5(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=Jwa(12)|0;f=Jwa(a<<2)|0;c[e>>2]=f;Y1(0,(f|0)!=0|0,103328,d);c[e+4>>2]=1;c[e+8>>2]=0;c[b>>2]=e;i=d;return 0}function N5(a){a=a|0;var b=0;b=i;Kwa(c[c[a>>2]>>2]|0);i=b;return 0}function O5(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=Jwa(32)|0;Y1(0,(g|0)!=0|0,103384,f);c[g+20>>2]=b;b=g+24|0;c[b>>2]=a;c[g+28>>2]=d;d=g+8|0;Qd(0,d|0)|0;Fd(c[d>>2]|0,c[b>>2]|0,0)|0;Qd(0,g+4|0)|0;Fd(c[d>>2]|0,c[b>>2]|0,0)|0;b=g+12|0;ab(b|0)|0;Jb(103432,c[b>>2]|0)|0;c[e>>2]=g;i=f;return 0}function P5(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Md(c[d+12>>2]|0)|0;Ib(c[d+8>>2]|0)|0;Ib(c[d+4>>2]|0)|0;i=b;return 0}function Q5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=c[a+468>>2]|0;h=a+200|0;if((c[h>>2]|0)<=0){i=b;return 0}j=a+536|0;k=a;l=a+300|0;m=0;a:while(1){n=g+(m*80|0)|0;o=c[n>>2]|0;Y1(c[j>>2]|0,(c[g+(m*80|0)+32>>2]|0)!=0|0,103600,f);p=g+(m*80|0)+28|0;do{if(!((c[p>>2]|0)==-1)){Y1(c[j>>2]|0,(c[g+(m*80|0)+20>>2]|0)!=0|0,103640,e);if((ae[c[g+(m*80|0)+24>>2]&127](k)|0)==0){break}c[p>>2]=-1}}while(0);p=o<<3;c[g+(m*80|0)+44>>2]=Jwa(p)|0;c[g+(m*80|0)+52>>2]=Jwa(p)|0;c[g+(m*80|0)+48>>2]=Jwa(p)|0;c[g+(m*80|0)+16>>2]=Jwa(p)|0;c[g+(m*80|0)+8>>2]=Jwa(p)|0;c[g+(m*80|0)+12>>2]=Jwa(p)|0;_d[c[g+(m*80|0)+36>>2]&127](k,n);do{if((c[g+(m*80|0)+56>>2]|0)==1){b6(o,g+(m*80|0)+40|0)|0}else{p=c[l>>2]|0;if((p|0)==3){b6(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==2){E5(a,n)|0;break}else if((p|0)==1){V5(o,g+(m*80|0)+40|0)|0;break}else{q=12;break a}}}while(0);o=m+1|0;if((o|0)<(c[h>>2]|0)){m=o}else{q=14;break}}if((q|0)==12){Z1(c[j>>2]|0,103680,d)}else if((q|0)==14){i=b;return 0}return 0}function R5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+468>>2]|0;f=a+200|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+300|0;h=0;a:while(1){j=e+(h*80|0)|0;Kwa(c[e+(h*80|0)+44>>2]|0);Kwa(c[e+(h*80|0)+52>>2]|0);Kwa(c[e+(h*80|0)+48>>2]|0);Kwa(c[e+(h*80|0)+16>>2]|0);Kwa(c[e+(h*80|0)+8>>2]|0);Kwa(c[e+(h*80|0)+12>>2]|0);do{if((c[e+(h*80|0)+56>>2]|0)==1){k=e+(h*80|0)+40|0;c6(k)|0;l=k}else{k=c[g>>2]|0;if((k|0)==3){m=e+(h*80|0)+40|0;c6(m)|0;l=m;break}else if((k|0)==1){m=e+(h*80|0)+40|0;W5(m)|0;l=m;break}else if((k|0)==2){n=7;break a}else{n=9;break a}}}while(0);Kwa(c[l>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{n=11;break}}if((n|0)==7){F5(j)|0}else if((n|0)==9){Z1(c[a+536>>2]|0,103680,d)}else if((n|0)==11){i=b;return 0}return 0}function S5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=e;g=c[b+468>>2]|0;c[b+472>>2]=d;h=b+319|0;a[h]=1;do{if((c[g+(d*80|0)+56>>2]|0)==1){j=(e6(b,d)|0)&255}else{k=c[b+300>>2]|0;if((k|0)==2){j=(G5(b,d)|0)&255;break}else if((k|0)==3){j=(e6(b,d)|0)&255;break}else if((k|0)==1){k=b+536|0;l=(c[k>>2]|0)+84|0;m=c[l>>2]|0;c[l>>2]=3;l=X5(b,d)|0;c[(c[k>>2]|0)+84>>2]=m;j=l&255;break}else{Z1(c[b+536>>2]|0,103680,f)}}}while(0);a[g+(d*80|0)+72|0]=j;a[h]=0;i=e;return 0}function T5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=c[b+468>>2]|0;v=c[b+200>>2]|0;if((v|0)>0){w=0}else{x=0;i=e;return x|0}while(1){y=w+1|0;if((a[u+(w*80|0)+72|0]|0)==0){break}if((y|0)<(v|0)){w=y}else{x=0;z=22;break}}if((z|0)==22){i=e;return x|0}v=u+(w*80|0)+4|0;w=c[v>>2]|0;u=n;c[u>>2]=1;c[n+4>>2]=w;if((d|0)==0){x=1;i=e;return x|0}d=b+56|0;$ja(o,d,w);A=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[o+8>>2];o=m+4|0;h[k>>3]=A;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];W1(17,1,u,103712,m);do{if((a[b+312|0]|0)==0){$ja(s,d,c[v>>2]|0);m=s+12|0;if((c[m>>2]|0)<=0){break}u=t+16|0;o=0;while(1){w=o+1|0;$ja(t,d,c[v>>2]|0);n=c[(c[(c[u>>2]|0)+(o<<2)>>2]|0)+4>>2]|0;c[f>>2]=w;c[f+4>>2]=n;X1(17,0,103912,f);$ja(s,d,c[v>>2]|0);if((w|0)<(c[m>>2]|0)){o=w}else{break}}}else{X1(17,1,103752,l);$ja(p,d,c[v>>2]|0);o=p+12|0;if((c[o>>2]|0)>0){m=b+116|0;u=r+16|0;w=b+8|0;n=q+16|0;y=0;while(1){a:do{if((c[m>>2]|0)>0){B=y+1|0;C=0;while(1){D=c[(c[w>>2]|0)+(C*112|0)+4>>2]|0;$ja(q,d,c[v>>2]|0);if((hxa(D,c[(c[(c[n>>2]|0)+(y<<2)>>2]|0)+4>>2]|0)|0)==0){break}D=C+1|0;if((D|0)<(c[m>>2]|0)){C=D}else{z=15;break a}}D=c[w>>2]|0;E=c[D+(C*112|0)+4>>2]|0;A=+h[D+(C*112|0)+96>>3];F=+h[D+(C*112|0)+80>>3];c[j>>2]=B;c[j+4>>2]=E;E=j+8|0;h[k>>3]=A;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=j+16|0;h[k>>3]=F;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];X1(17,0,103832,j);G=y+1|0}else{z=15}}while(0);if((z|0)==15){z=0;E=y+1|0;$ja(r,d,c[v>>2]|0);D=c[(c[(c[u>>2]|0)+(y<<2)>>2]|0)+4>>2]|0;c[g>>2]=E;c[g+4>>2]=D;X1(17,0,103872,g);G=E}$ja(p,d,c[v>>2]|0);if((G|0)<(c[o>>2]|0)){y=G}else{break}}}if((c[70956>>2]|c[17720]|0)==0){break}Zd[c[17860]&1023](17)}}while(0);if((c[70956>>2]|c[17720]|0)==0){x=1;i=e;return x|0}Zd[c[17860]&1023](17);x=1;i=e;return x|0}function U5(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0;e=i;f=c[a+4>>2]|0;g=+h[c[f+4>>2]>>3];j=+h[c[f+8>>2]>>3];if(g==j){k=b;i=e;return+k}k=(b-d)*((+h[c[f>>2]>>3]-j)/(g-j))+d;i=e;return+k}function V5(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=i;i=i+8|0;f=Jwa(144)|0;c[b>>2]=f;Y1(0,(f|0)!=0|0,103928,e);c[f>>2]=0;e=a<<3;g=Jwa(e)|0;c[f+4>>2]=g;g=Jwa(e)|0;c[f+16>>2]=g;c[f+8>>2]=1;g=Jwa(e)|0;c[f+12>>2]=g;c[f+20>>2]=a;g=Jwa(e)|0;c[f+24>>2]=g;g=Lwa(a,8)|0;c[f+28>>2]=g;h[f+32>>3]=1.0e-12;c[f+40>>2]=a*1e4;g=a+ -1|0;c[f+44>>2]=g;c[f+48>>2]=g;h[f+56>>3]=1.0e-12;g=Jwa(e)|0;c[f+64>>2]=g;g=Jwa(e)|0;c[f+68>>2]=g;c[f+72>>2]=1;h[f+80>>3]=100.0;c[f+88>>2]=-1;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;g=fa(a,a)|0;j=Lwa(g,8)|0;c[f+104>>2]=j;j=Lwa(g,8)|0;c[f+108>>2]=j;c[f+112>>2]=a;j=(fa(a+1|0,a)|0)/2|0;a=Jwa(j<<3)|0;c[f+116>>2]=a;c[f+120>>2]=j;j=Jwa(e)|0;c[f+124>>2]=j;j=Jwa(e)|0;c[f+128>>2]=j;j=Jwa(e)|0;c[f+132>>2]=j;j=Jwa(e)|0;c[f+136>>2]=j;j=Jwa(e)|0;c[f+140>>2]=j;Y1(0,(c[b>>2]|0)!=0|0,103960,d);i=d;return 0}function W5(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Kwa(c[d+4>>2]|0);Kwa(c[d+16>>2]|0);Kwa(c[d+12>>2]|0);Kwa(c[d+24>>2]|0);Kwa(c[d+28>>2]|0);Kwa(c[d+64>>2]|0);Kwa(c[d+68>>2]|0);Kwa(c[d+104>>2]|0);Kwa(c[d+108>>2]|0);Kwa(c[d+116>>2]|0);Kwa(c[d+124>>2]|0);Kwa(c[d+128>>2]|0);Kwa(c[d+132>>2]|0);Kwa(c[d+136>>2]|0);Kwa(c[d+140>>2]|0);i=b;return 0}function X5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0,kb=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+24|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+24|0;N=i;i=i+24|0;O=i;i=i+4096|0;P=i;i=i+24|0;Q=c[b+468>>2]|0;R=c[Q+(d*80|0)+40>>2]|0;S=R;T=c[Q+(d*80|0)+4>>2]|0;c[I>>2]=1;V=R+80|0;W=V;X=+h[V>>3];c[L>>2]=0;Y=b+164|0;Z=Jwa(c[Y>>2]|0)|0;if((c[70956>>2]|0)!=0){$ja(M,b+56|0,T);_=+h[c[c[b+4>>2]>>2]>>3];c[H>>2]=c[M+8>>2];M=H+4|0;h[k>>3]=_;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];V1(17,1,104e3,H);H=R+20|0;if((c[H>>2]|0)>0){M=Q+(d*80|0)+44|0;$=Q+(d*80|0)+16|0;aa=Q+(d*80|0)+48|0;ba=Q+(d*80|0)+52|0;ca=0;do{_=+h[(c[M>>2]|0)+(ca<<3)>>3];c[G>>2]=ca;da=G+4|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];V1(17,1,104056,G);_=+h[(c[aa>>2]|0)+(ca<<3)>>3];ea=+h[(c[ba>>2]|0)+(ca<<3)>>3];da=F;h[k>>3]=+h[(c[$>>2]|0)+(ca<<3)>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+8|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+16|0;h[k>>3]=ea;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];V1(17,0,104072,F);Zd[c[17860]&1023](17);ca=ca+1|0;}while((ca|0)<(c[H>>2]|0))}Zd[c[17860]&1023](17)}H=b+314|0;ca=R+24|0;F=c[ca>>2]|0;if((a[H]|0)==0){nxa(F|0,c[Q+(d*80|0)+52>>2]|0,c[R+20>>2]<<3|0)|0}else{nxa(F|0,c[Q+(d*80|0)+44>>2]|0,c[R+20>>2]<<3|0)|0}F=R+20|0;$=F;ba=c[F>>2]|0;if((ba|0)>0){aa=c[ca>>2]|0;G=c[Q+(d*80|0)+16>>2]|0;M=c[R+12>>2]|0;da=0;do{ea=+U(+(+h[aa+(da<<3)>>3]));h[M+(da<<3)>>3]=+md(+ea,+(+h[G+(da<<3)>>3]));da=da+1|0;}while((da|0)<(ba|0))}ba=R+8|0;da=(c[ba>>2]|0)!=0;if(da){c[ba>>2]=0}G=R+28|0;M=R+104|0;aa=R+112|0;ga=b;Y5($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(da){c[ba>>2]=1}da=b+318|0;ha=R+32|0;ia=R+40|0;ja=R+64|0;ka=R+72|0;la=ka;ma=R+88|0;na=R+92|0;oa=na;pa=R+96|0;qa=pa;ra=R+100|0;sa=R+116|0;ta=R+120|0;ua=R+124|0;va=R+128|0;wa=R+132|0;xa=R+136|0;ya=R+140|0;za=b+56|0;Aa=b+4|0;Ba=Q+(d*80|0)+52|0;Ca=Q+(d*80|0)+44|0;Da=Q+(d*80|0)+48|0;Ea=Q+(d*80|0)+16|0;Q=R+12|0;Fa=b+356|0;Ga=R+4|0;Ha=b+312|0;Ia=R+16|0;Ja=O;O=R+108|0;R=1;ea=1.0e-12;Ka=0;La=0;Ma=0;Na=0;a:while(1){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=c[Ea>>2]|0;Ra=c[Q>>2]|0;Sa=0;do{_=+U(+(+h[Pa+(Sa<<3)>>3]));h[Ra+(Sa<<3)>>3]=+md(+_,+(+h[Qa+(Sa<<3)>>3]));Sa=Sa+1|0;}while((Sa|0)<(Oa|0))}if((c[70960>>2]|0)!=0){Z5(c[Q>>2]|0,$,18,104112);Z5(c[ca>>2]|0,$,18,104144)}do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Sa=c[Q>>2]|0;Qa=c[ca>>2]|0;Ra=0;do{Pa=Qa+(Ra<<3)|0;h[Pa>>3]=1.0/+h[Sa+(Ra<<3)>>3]*+h[Pa>>3];Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}}while(0);if((c[70960>>2]|0)!=0){Z5(c[ca>>2]|0,$,18,104176)}a[da]=R;s4(10,$,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,ha,ia,c[ja>>2]|0,la,W,ma,oa,qa,ra,c[sa>>2]|0,ta,c[ua>>2]|0,c[va>>2]|0,c[wa>>2]|0,c[xa>>2]|0,c[ya>>2]|0,ga,d)|0;a[da]=R^1;do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Ra=c[ca>>2]|0;Sa=c[Q>>2]|0;Qa=0;do{Pa=Ra+(Qa<<3)|0;h[Pa>>3]=+h[Pa>>3]*+h[Sa+(Qa<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}}while(0);Oa=c[na>>2]|0;if((Oa|0)==0){$ja(N,za,T);_=+h[c[c[Aa>>2]>>2]>>3];Qa=g;Sa=N;c[Qa+0>>2]=c[Sa+0>>2];c[Qa+4>>2]=c[Sa+4>>2];c[Qa+8>>2]=c[Sa+8>>2];c[Qa+12>>2]=c[Sa+12>>2];c[Qa+16>>2]=c[Sa+16>>2];N3(3,g,_);Ta=c[na>>2]|0}else{Ta=Oa}do{if(!((Ta|0)==-1)){if((a[H]|0)==0){Ua=Ta}else{if((c[ba>>2]|0)==0){a[da]=0;Y5($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0}else{c[ba>>2]=0;a[da]=0;Y5($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;c[ba>>2]=1}g5(b);Ua=c[na>>2]|0}if((Ua|0)==-1){break}Oa=c[F>>2]|0;if((Oa|0)>0){Sa=c[Ga>>2]|0;Qa=c[G>>2]|0;Ra=c[Ia>>2]|0;Pa=0;Va=0;while(1){Wa=Sa+(Pa<<3)|0;h[Wa>>3]=1.0e-16;Xa=c[O>>2]|0;Ya=(Oa|0)>1?Oa:1;_=1.0e-16;Za=0;_a=Va;while(1){$a=+U(+(+h[Xa+(_a<<3)>>3]));ab=$a>_?$a:_;h[Wa>>3]=ab;bb=Za+1|0;if((bb|0)<(Oa|0)){_a=_a+1|0;Za=bb;_=ab}else{break}}h[Ra+(Pa<<3)>>3]=+h[Qa+(Pa<<3)>>3]*(1.0/ab);Za=Pa+1|0;if((Za|0)<(Oa|0)){Pa=Za;Va=Va+Ya|0}else{break}}}if((c[70960>>2]|0)!=0){V1(18,1,104216,E);if((c[F>>2]|0)>0){Va=0;do{_=+h[(c[Ia>>2]|0)+(Va<<3)>>3];c[D>>2]=Va;Pa=D+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];V1(18,1,104256,D);_=+h[(c[Ga>>2]|0)+(Va<<3)>>3];c[C>>2]=Va;Pa=C+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];V1(18,0,104288,C);Zd[c[17860]&1023](18);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}Zd[c[17860]&1023](18)}if((c[70964>>2]|0)!=0){Va=c[F>>2]|0;c[B>>2]=Va;c[B+4>>2]=Va;V1(19,1,104320,B);if((c[F>>2]|0)>0){Va=0;do{a[Ja]=0;Pa=c[F>>2]|0;if((Pa|0)>0){Oa=Pa;Pa=0;do{Qa=(fa(Oa,Va)|0)+Pa|0;_=+h[(c[O>>2]|0)+(Qa<<3)>>3];c[A>>2]=Ja;Qa=A+4|0;h[k>>3]=_;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];hc(Ja|0,104344,A|0)|0;Pa=Pa+1|0;Oa=c[F>>2]|0;}while((Pa|0)<(Oa|0))}c[z>>2]=Ja;V1(19,0,104352,z);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}Zd[c[17860]&1023](19)}h[K>>3]=+r4($,c[Ia>>2]|0);h[J>>3]=+r4($,c[G>>2]|0)}}while(0);do{if((Ka|0)==0){cb=0}else{if(!(+h[J>>3]>ea)){cb=Ka;break}if(!(+h[K>>3]>ea)){cb=Ka;break}nxa(c[Fa>>2]|0,Z|0,c[Y>>2]|0)|0;cb=0}}while(0);Va=c[na>>2]|0;_=+h[J>>3];b:do{if((Va|0)<4){do{if(_>ea){if(!(+h[K>>3]>ea)){break}c[na>>2]=4;db=4;break b}}while(0);if((Va|0)==1){eb=68;break a}else{db=Va}}else{db=Va}}while(0);if(_<=ea){eb=68;break}if(+h[K>>3]<=ea){eb=68;break}Va=(db+ -4|0)>>>0<2;if(Va&(La|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){nxa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{nxa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}$a=+h[V>>3]/10.0;h[V>>3]=$a;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[70956>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Pa=w;h[k>>3]=$a;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];V1(17,0,104400,w);_5(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<4){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[Ea>>2]|0;Ya=c[ca>>2]|0;Qa=0;do{Ra=Ya+(Qa<<3)|0;h[Ra>>3]=+h[Pa+(Qa<<3)>>3]*.1+ +h[Ra>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}h[V>>3]=X;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[70956>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}V1(17,0,104472,v);_5(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){nxa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{nxa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Da>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Ra=0;do{_=+U(+(+h[Qa+(Ra<<3)>>3]));h[Ya+(Ra<<3)>>3]=+md(+_,+(+h[Pa+(Ra<<3)>>3]));Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[70956>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}V1(17,0,104536,u);_5(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<6){Oa=c[ca>>2]|0;if((a[H]|0)==0){nxa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{nxa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}if((c[ba>>2]|0)!=0){c[ba>>2]=0}Oa=c[F>>2]|0;if((Oa|0)>0){Ra=c[ca>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Qa=0;do{_=+U(+(+h[Ra+(Qa<<3)>>3]));h[Ya+(Qa<<3)>>3]=+md(+_,+(+h[Pa+(Qa<<3)>>3]));Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[70956>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}V1(17,0,104608,t);_5(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}do{if(Va&(La|0)<7){if((a[H]|0)==0){break}nxa(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;Oa=La+1|0;nxa(Z|0,c[Fa>>2]|0,c[Y>>2]|0)|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[70956>>2]|0)==0){fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}V1(17,0,104672,s);_5(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}}while(0);if(Va&(Ma|0)<1){nxa(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;if((c[ba>>2]|0)==0){c[ba>>2]=1}h[V>>3]=X;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[70956>>2]|0)==0){fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}V1(17,0,104744,r);_5(S,L,J,K,18);fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}if(Va&(Ma|0)<2){Oa=c[ca>>2]|0;if((a[H]|0)==0){nxa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{nxa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[ca>>2]|0;Pa=0;do{Ya=Qa+(Pa<<3)|0;h[Ya>>3]=+h[Ya>>3]*1.01;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[70956>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}V1(17,0,104816,q);_5(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){nxa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{nxa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=0;do{Ya=Pa+(Qa<<3)|0;h[Ya>>3]=+h[Ya>>3]*.99;Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[70956>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}V1(17,0,104888,p);_5(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<4){nxa(c[ca>>2]|0,c[Ea>>2]|0,c[F>>2]<<3|0)|0;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[70956>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}V1(17,0,104952,o);_5(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){nxa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{nxa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Ga>>2]|0;Pa=c[ja>>2]|0;Ya=0;do{_=+U(+(+h[Qa+(Ya<<3)>>3]));h[Pa+(Ya<<3)>>3]=!(_<=1.0e-16)?_:1.0e-16;Ya=Ya+1|0;}while((Ya|0)<(Oa|0))}Oa=Ma+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[70956>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}V1(17,0,105024,n);_5(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(!(Va&(Na|0)<1)){if(!(Va&(Na|0)<6)){eb=160;break}Oa=c[ca>>2]|0;if((a[H]|0)==0){nxa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{nxa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}_=ea*10.0;h[V>>3]=X;c[ka>>2]=1;Oa=Na+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[70956>>2]|0)==0){ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Ya=l;h[k>>3]=_;c[Ya>>2]=c[k>>2];c[Ya+4>>2]=c[k+4>>2];V1(17,0,105160,l);_5(S,L,J,K,18);ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Oa=c[ca>>2]|0;if((a[H]|0)==0){nxa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{nxa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Ya=c[ja>>2]|0;Pa=0;do{h[Ya+(Pa<<3)>>3]=1.0;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}c[ba>>2]=1;Oa=Na+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[70956>>2]|0)==0){hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib;continue}V1(17,0,105088,m);_5(S,L,J,K,18);hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib}if((eb|0)==68){c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[70956>>2]|0)!=0){V1(17,1,104360,y);c[x>>2]=La;c[x+4>>2]=Na+Ma;V1(17,0,104376,x);Zd[c[17860]&1023](17);_5(S,L,J,K,17)}x=(c[ba>>2]|0)!=0;if(x){c[ba>>2]=0;jb=x}else{jb=0}nxa(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;Y5($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(!jb){kb=1;h[V>>3]=X;c[ka>>2]=1;Kwa(Z);i=e;return kb|0}c[ba>>2]=1;kb=1;h[V>>3]=X;c[ka>>2]=1;Kwa(Z);i=e;return kb|0}else if((eb|0)==160){if(!((db+ -2|0)>>>0<4)){kb=0;h[V>>3]=X;c[ka>>2]=1;Kwa(Z);i=e;return kb|0}if((a[Ha]|0)==0){$ja(P,za,T);hb=+h[c[c[Aa>>2]>>2]>>3];Aa=f;T=P;c[Aa+0>>2]=c[T+0>>2];c[Aa+4>>2]=c[T+4>>2];c[Aa+8>>2]=c[T+8>>2];c[Aa+12>>2]=c[T+12>>2];c[Aa+16>>2]=c[T+16>>2];N3(0,f,hb);}if((c[70956>>2]|0)!=0){c[j>>2]=fa(fa(Ma,La)|0,Na)|0;V1(17,0,105232,j);_5(S,L,J,K,17)}nxa(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;kb=0;h[V>>3]=X;c[ka>>2]=1;Kwa(Z);i=e;return kb|0}return 0}function Y5(b,d,e,f,g,j,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0;g=i;i=i+8|0;n=g;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16384|0;w=l;x=c[l+468>>2]|0;y=c[x+(m*80|0)+40>>2]|0;z=l+318|0;A=c[j>>2]|0;if((A|0)==1){B=y+8|0;do{if((c[B>>2]|0)!=0){C=c[b>>2]|0;if((C|0)<=0){break}D=c[y+12>>2]|0;E=0;do{F=d+(E<<3)|0;h[F>>3]=+h[F>>3]*+h[D+(E<<3)>>3];E=E+1|0;}while((E|0)<(C|0))}}while(0);if((c[70968>>2]|0)!=0){c[u>>2]=c[y+96>>2];V1(20,0,105480,u);Z5(d,b,20,105512)}Ae[c[x+(m*80|0)+32>>2]&63](l,d,e,j);if((c[70968>>2]|0)!=0){Z5(e,b,20,105528);c[t>>2]=c[y+96>>2];V1(20,0,105544,t)}if((c[B>>2]|0)==0){i=g;return 0}B=c[b>>2]|0;if((B|0)<=0){i=g;return 0}t=c[y+12>>2]|0;j=0;do{u=d+(j<<3)|0;h[u>>3]=1.0/+h[t+(j<<3)>>3]*+h[u>>3];j=j+1|0;}while((j|0)<(B|0));i=g;return 0}else if((A|0)==2){B=(a[z]|0)!=0;if(B){a[z]=0}if((c[70968>>2]|0)!=0){V1(20,0,105584,s)}if((c[x+(m*80|0)+28>>2]|0)==-1){a6(w,f,d,e,m)}else{$5(w,f,m)}do{if((c[70968>>2]|0)!=0){V1(20,0,105624,r);if((c[70964>>2]|0)==0){break}m=v;w=c[b>>2]|0;c[q>>2]=w;c[q+4>>2]=w;V1(19,1,104320,q);w=c[b>>2]|0;if((w|0)>0){e=y+20|0;d=w;w=0;do{a[m]=0;if((d|0)>0){x=0;do{G=+h[f+((fa(c[e>>2]|0,w)|0)+x<<3)>>3];c[p>>2]=m;s=p+4|0;h[k>>3]=G;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];hc(m|0,105656,p|0)|0;x=x+1|0;}while((x|0)<(c[b>>2]|0))}c[o>>2]=m;V1(19,0,104352,o);w=w+1|0;d=c[b>>2]|0;}while((w|0)<(d|0))}Zd[c[17860]&1023](19)}}while(0);if(!B){i=g;return 0}a[z]=1;i=g;return 0}else{g=c[l+536>>2]|0;c[n>>2]=A;Z1(g,105672,n)}return 0}function Z5(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0.0;f=i;i=i+16|0;g=f;j=i;i=i+8|0;if((c[70888+(d<<2)>>2]|0)==0){i=f;return}c[j>>2]=e;V1(d,1,104352,j);if((c[b>>2]|0)>0){j=0;do{l=+h[a+(j<<3)>>3];c[g>>2]=j;e=g+4|0;h[k>>3]=l;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];V1(d,0,105464,g);j=j+1|0;}while((j|0)<(c[b>>2]|0))}Zd[c[17860]&1023](d);i=f;return}function _5(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0;g=i;i=i+24|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[70888+(f<<2)>>2]|0)==0){i=g;return}V1(f,1,105272,q);V1(f,1,105288,p);p=a+20|0;if((c[p>>2]|0)>0){q=a+24|0;r=a+64|0;s=0;do{t=+h[(c[q>>2]|0)+(s<<3)>>3];u=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=s;v=o+4|0;h[k>>3]=t;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=o+12|0;h[k>>3]=u;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];V1(f,0,105304,o);s=s+1|0;}while((s|0)<(c[p>>2]|0))}Zd[c[17860]&1023](f);V1(f,1,105344,n);if((c[p>>2]|0)>0){n=a+28|0;s=a+4|0;a=0;do{u=+h[(c[n>>2]|0)+(a<<3)>>3];t=+h[(c[s>>2]|0)+(a<<3)>>3];c[m>>2]=a;o=m+4|0;h[k>>3]=u;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=m+12|0;h[k>>3]=t;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];V1(f,0,105360,m);a=a+1|0;}while((a|0)<(c[p>>2]|0))}Zd[c[17860]&1023](f);V1(f,1,105400,l);t=+h[d>>3];u=+h[e>>3];c[j>>2]=c[b>>2];b=j+4|0;h[k>>3]=t;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=j+12|0;h[k>>3]=u;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];V1(f,0,105416,j);Zd[c[17860]&1023](f);Zd[c[17860]&1023](f);i=g;return}function $5(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+40>>2]|0;j=c[f+(d*80|0)+28>>2]|0;k=g+20|0;l=c[k>>2]|0;pxa(b|0,0,fa(l<<3,l)|0)|0;l=g+108|0;g=c[k>>2]|0;pxa(c[l>>2]|0,0,fa(g<<3,g)|0)|0;g=a+464|0;k=c[g>>2]|0;if((c[k+(j*44|0)+24>>2]|0)==0){i=e;return}m=f+(d*80|0)+20|0;d=a;a=c[k+(j*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[f+(j*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(j*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}ae[c[m>>2]&127](d)|0;f=c[g>>2]|0;a=c[f+(j*44|0)>>2]|0;if((a|0)!=0){n=c[f+(j*44|0)+20>>2]|0;o=c[f+(j*44|0)+28>>2]|0;p=0;do{q=o+(p<<3)|0;do{if(+h[q>>3]==1.0){if((p|0)==0){r=f+(j*44|0)+8|0;s=0}else{t=f+(j*44|0)+8|0;r=t;s=c[(c[t>>2]|0)+(p+ -1<<2)>>2]|0}t=c[(c[r>>2]|0)+(p<<2)>>2]|0;if(!(s>>>0<t>>>0)){break}u=c[l>>2]|0;v=c[f+(j*44|0)+12>>2]|0;w=c[f+(j*44|0)+4>>2]|0;x=c[f+(j*44|0)+36>>2]|0;y=s;do{z=c[v+(y<<2)>>2]|0;A=(fa(w,p)|0)+z|0;B=+h[x+(z<<3)>>3];h[b+(A<<3)>>3]=B;h[u+(A<<3)>>3]=B;y=y+1|0;}while(y>>>0<t>>>0)}}while(0);if(((c[n+(p<<2)>>2]|0)+ -1|0)==(k|0)){h[q>>3]=0.0}p=p+1|0;}while(p>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(j*44|0)+24>>2]|0)>>>0);i=e;return}function a6(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0;g=i;i=i+8|0;j=g;k=c[(c[a+468>>2]|0)+(f*80|0)+40>>2]|0;l=k+56|0;m=+h[l>>3];n=+V(+m);c[j>>2]=1;o=k+20|0;p=o;if((c[o>>2]|0)<=0){i=g;return}q=k+128|0;r=k+108|0;s=k+112|0;k=a;t=m;a=0;while(1){m=+h[e+(a<<3)>>3];u=t*m;v=d+(a<<3)|0;w=+h[v>>3];if(!(w>=0.0)){x=-w}else{x=w}if(!(u>=0.0)){y=-u}else{y=u}u=+md(+(n*+md(+x,+y)),+n);if(!(m>=0.0)){z=-u}else{z=u}u=z+w-w;m=1.0/u;h[v>>3]=w+u;Y5(p,d,c[q>>2]|0,c[r>>2]|0,s,j,k,f)|0;A=c[o>>2]|0;if((A|0)>0){B=c[q>>2]|0;C=c[r>>2]|0;D=0;do{E=(fa(A,a)|0)+D|0;u=m*(+h[B+(D<<3)>>3]- +h[e+(D<<3)>>3]);h[b+(E<<3)>>3]=u;h[C+(E<<3)>>3]=u;D=D+1|0;}while((D|0)<(A|0))}h[v>>3]=w;D=a+1|0;if((D|0)>=(A|0)){break}t=+h[l>>3];a=D}i=g;return}function b6(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=i;i=i+8|0;f=Jwa(80)|0;c[b>>2]=f;Y1(0,(f|0)!=0|0,105752,e);c[f>>2]=0;e=a<<3;g=Jwa(e)|0;c[f+4>>2]=g;g=Jwa(e)|0;c[f+8>>2]=g;c[f+12>>2]=a;g=Jwa(e)|0;c[f+16>>2]=g;g=Lwa(a,8)|0;c[f+20>>2]=g;h[f+24>>3]=1.0e-8;h[f+32>>3]=1.0e-8;c[f+44>>2]=a*100;h[f+56>>3]=2.220446049250313e-16;g=Jwa(fa(e,a)|0)|0;c[f+64>>2]=g;g=Jwa(e)|0;c[f+68>>2]=g;g=Jwa(a<<2)|0;c[f+72>>2]=g;Y1(0,(c[b>>2]|0)!=0|0,105784,d);i=d;return 0}function c6(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Kwa(c[d+4>>2]|0);Kwa(c[d+8>>2]|0);Kwa(c[d+16>>2]|0);Kwa(c[d+20>>2]|0);Kwa(c[d+64>>2]|0);Kwa(c[d+68>>2]|0);Kwa(c[d+72>>2]|0);i=b;return 0}function d6(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+28>>2]|0;j=c[(c[f+(d*80|0)+40>>2]|0)+12>>2]|0;pxa(b|0,0,fa(j<<3,j)|0)|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=e;return 0}l=f+(d*80|0)+20|0;d=a;a=c[k+(g*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){m=0;do{if(((c[(c[f+(g*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(g*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}ae[c[l>>2]&127](d)|0;f=c[j>>2]|0;a=c[f+(g*44|0)>>2]|0;if((a|0)!=0){m=c[f+(g*44|0)+20>>2]|0;n=c[f+(g*44|0)+28>>2]|0;o=0;do{p=n+(o<<3)|0;do{if(+h[p>>3]==1.0){if((o|0)==0){q=f+(g*44|0)+8|0;r=0}else{s=f+(g*44|0)+8|0;q=s;r=c[(c[s>>2]|0)+(o+ -1<<2)>>2]|0}s=c[(c[q>>2]|0)+(o<<2)>>2]|0;if(!(r>>>0<s>>>0)){break}t=c[f+(g*44|0)+12>>2]|0;u=c[f+(g*44|0)+4>>2]|0;v=c[f+(g*44|0)+36>>2]|0;w=r;do{x=c[t+(w<<2)>>2]|0;y=(fa(u,o)|0)+x|0;h[b+(y<<3)>>3]=+h[v+(x<<3)>>3];w=w+1|0;}while(w>>>0<s>>>0)}}while(0);if(((c[m+(o<<2)>>2]|0)+ -1|0)==(k|0)){h[p>>3]=0.0}o=o+1|0;}while(o>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(g*44|0)+24>>2]|0)>>>0);i=e;return 0}function e6(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=i;i=i+72|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+8|0;t=i;i=i+24|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+24|0;x=i;i=i+24|0;y=i;i=i+24|0;z=c[b+468>>2]|0;A=c[z+(d*80|0)+40>>2]|0;B=c[z+(d*80|0)+4>>2]|0;C=A+40|0;D=C;c[C>>2]=0;E=A+16|0;F=z+(d*80|0)+52|0;G=A+12|0;H=G;nxa(c[E>>2]|0,c[F>>2]|0,c[G>>2]<<3|0)|0;I=b+56|0;if((c[70956>>2]|0)==0){J=b+4|0}else{$ja(w,I,B);K=b+4|0;L=+h[c[c[K>>2]>>2]>>3];c[v>>2]=c[w+8>>2];w=v+4|0;h[k>>3]=L;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];V1(17,1,105824,v);if((c[G>>2]|0)>0){v=z+(d*80|0)+44|0;w=z+(d*80|0)+16|0;M=z+(d*80|0)+48|0;N=0;do{L=+h[(c[v>>2]|0)+(N<<3)>>3];c[u>>2]=N;O=u+4|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];V1(17,1,105896,u);L=+h[(c[M>>2]|0)+(N<<3)>>3];P=+h[(c[F>>2]|0)+(N<<3)>>3];O=t;h[k>>3]=+h[(c[w>>2]|0)+(N<<3)>>3];c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+8|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+16|0;h[k>>3]=P;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];V1(17,0,105912,t);Zd[c[17860]&1023](17);N=N+1|0;}while((N|0)<(c[G>>2]|0))}Zd[c[17860]&1023](17);J=K}K=b+318|0;N=A+20|0;t=A+24|0;w=A+56|0;F=A+44|0;M=A+64|0;u=A+68|0;v=A+72|0;O=A+48|0;Q=O;R=b;b=A+4|0;S=A+32|0;A=z+(d*80|0)+48|0;T=z+(d*80|0)+16|0;U=0;V=0;a:while(1){a[K]=1;W=c[E>>2]|0;X=c[N>>2]|0;Y=c[M>>2]|0;Z=c[u>>2]|0;_=c[v>>2]|0;c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];f6(H,W,X,+h[k>>3],w,c[F>>2]|0,D,Y,Z,_,Q,R,d);a[K]=0;if((c[O>>2]|0)==0){$ja(x,I,B);P=+h[c[c[J>>2]>>2]>>3];_=g;Z=x;c[_+0>>2]=c[Z+0>>2];c[_+4>>2]=c[Z+4>>2];c[_+8>>2]=c[Z+8>>2];c[_+12>>2]=c[Z+12>>2];c[_+16>>2]=c[Z+16>>2];N3(3,g,P);}$=+r4(H,c[b>>2]|0);aa=+r4(H,c[N>>2]|0);P=+h[S>>3];if(!(!(aa<=P)&!($<=P))){if((c[O>>2]|0)>0){ba=12;break}}do{if((V|0)<1){nxa(c[E>>2]|0,c[A>>2]|0,c[G>>2]<<3|0)|0;Z=c[C>>2]|0;V1(17,0,106088,p);ca=Z}else{if((V|0)<2){Z=c[G>>2]|0;if((Z|0)>0){_=c[T>>2]|0;Y=c[E>>2]|0;X=0;do{W=Y+(X<<3)|0;h[W>>3]=+h[_+(X<<3)>>3]*.01+ +h[W>>3];X=X+1|0;}while((X|0)<(Z|0))}Z=c[C>>2]|0;V1(17,0,106144,o);ca=Z;break}if((V|0)>=3){ba=28;break a}Z=c[G>>2]|0;if((Z|0)>0){X=c[T>>2]|0;_=c[E>>2]|0;Y=0;do{h[_+(Y<<3)>>3]=+h[X+(Y<<3)>>3];Y=Y+1|0;}while((Y|0)<(Z|0))}Z=c[C>>2]|0;V1(17,0,106208,n);ca=Z}}while(0);U=ca+U|0;V=V+1|0}do{if((ba|0)==12){if((c[70956>>2]|0)==0){da=1;break}ca=(c[C>>2]|0)+U|0;c[s>>2]=V;V1(17,0,105960,s);c[r>>2]=ca;ca=r+4|0;h[k>>3]=aa;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=r+12|0;h[k>>3]=$;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];V1(17,0,106e3,r);if((c[G>>2]|0)>0){ea=0}else{da=1;break}while(1){P=+h[(c[E>>2]|0)+(ea<<3)>>3];L=+h[(c[N>>2]|0)+(ea<<3)>>3];c[q>>2]=ea;ca=q+4|0;h[k>>3]=P;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=q+12|0;h[k>>3]=L;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];V1(17,0,106056,q);ca=ea+1|0;if((ca|0)<(c[G>>2]|0)){ea=ca}else{da=1;break}}}else if((ba|0)==28){$ja(y,I,B);L=+h[c[c[J>>2]>>2]>>3];ca=f;n=y;c[ca+0>>2]=c[n+0>>2];c[ca+4>>2]=c[n+4>>2];c[ca+8>>2]=c[n+8>>2];c[ca+12>>2]=c[n+12>>2];c[ca+16>>2]=c[n+16>>2];N3(0,f,L);if((c[70956>>2]|0)==0){da=0;break}c[m>>2]=V;V1(17,0,106288,m);c[l>>2]=U;n=l+4|0;h[k>>3]=aa;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l+12|0;h[k>>3]=$;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];V1(17,0,106e3,l);if((c[70956>>2]|0)==0){da=0;break}if((c[G>>2]|0)>0){fa=0}else{da=0;break}while(1){L=+h[(c[E>>2]|0)+(fa<<3)>>3];P=+h[(c[N>>2]|0)+(fa<<3)>>3];c[j>>2]=fa;n=j+4|0;h[k>>3]=L;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=j+12|0;h[k>>3]=P;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];V1(17,0,106056,j);n=fa+1|0;if((n|0)<(c[G>>2]|0)){fa=n}else{da=0;break}}}}while(0);if((c[70956>>2]|0)==0){ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;nxa(ma|0,oa|0,qa|0)|0;i=e;return da|0}Zd[c[17860]&1023](17);ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;nxa(ma|0,oa|0,qa|0)|0;i=e;return da|0}function f6(b,d,e,f,g,j,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0;s=i;i=i+8|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+4096|0;E=q;F=c[q+468>>2]|0;G=c[F+(r*80|0)+40>>2]|0;H=+h[G+32>>3];c[B>>2]=1;c[C>>2]=1;do{if((c[70960>>2]|0)!=0){c[z>>2]=j;V1(18,0,106328,z);if((c[b>>2]|0)>0){I=0}else{break}do{J=+h[d+(I<<3)>>3];c[y>>2]=I;K=y+4|0;h[k>>3]=J;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];V1(18,0,106376,y);I=I+1|0;}while((I|0)<(c[b>>2]|0))}}while(0);c[p>>2]=1;I=F+(r*80|0)+28|0;F=D;D=G+12|0;y=G+8|0;z=G+4|0;K=G+20|0;L=G+64|0;G=j;a:while(1){g6(d,e,A,q,r)|0;c[l>>2]=(c[l>>2]|0)+1;if((c[I>>2]|0)==-1){h6(b,d,e,m,+h[g>>3],A,n,q,r);c[l>>2]=(c[b>>2]|0)+(c[l>>2]|0)}else{d6(E,m,r)|0}if((c[70964>>2]|0)!=0){j=c[b>>2]|0;c[x>>2]=j;c[x+4>>2]=j;V1(19,1,106392,x);if((c[D>>2]|0)>0){j=0;do{a[F]=0;if((c[D>>2]|0)>0){M=0;do{J=+h[m+((fa(c[b>>2]|0,j)|0)+M<<3)>>3];c[w>>2]=F;N=w+4|0;h[k>>3]=J;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];hc(F|0,106416,w|0)|0;M=M+1|0;}while((M|0)<(c[D>>2]|0))}c[v>>2]=F;V1(19,0,106424,v);j=j+1|0;}while((j|0)<(c[D>>2]|0))}Zd[c[17860]&1023](19)}j=c[D>>2]|0;if((j|0)>0){M=c[z>>2]|0;N=c[K>>2]|0;O=c[y>>2]|0;P=0;Q=0;while(1){R=M+(P<<3)|0;h[R>>3]=1.0e-16;S=c[L>>2]|0;T=(j|0)>1?j:1;J=1.0e-16;V=0;W=Q;while(1){X=+U(+(+h[S+(W<<3)>>3]));Y=X>J?X:J;h[R>>3]=Y;Z=V+1|0;if((Z|0)<(j|0)){W=W+1|0;V=Z;J=Y}else{break}}h[O+(P<<3)>>3]=+h[N+(P<<3)>>3]*(1.0/Y);V=P+1|0;if((V|0)<(j|0)){P=V;Q=Q+T|0}else{_=O;break}}}else{_=c[y>>2]|0}J=+r4(b,_);if(!(!(J<=H)&!(+r4(b,e)<=H))){$=31;break}EY(b,B,m,b,o,e,b,C)|0;O=c[C>>2]|0;do{if((O|0)>0){c[p>>2]=-1;X1(17,0,106432,u)}else{if((O|0)<0){c[p>>2]=-1;c[t>>2]=O;X1(17,0,106464,t);break}Q=c[b>>2]|0;if((Q|0)>0){P=0;do{j=d+(P<<3)|0;h[j>>3]=+h[j>>3]- +h[e+(P<<3)>>3];P=P+1|0;}while((P|0)<(Q|0))}if(+r4(b,e)<=f){$=31;break a}}}while(0);if((G|0)<1){$=30;break}if((c[p>>2]|0)>-1){G=G+ -1|0}else{$=31;break}}if(($|0)==30){c[p>>2]=-1;i=s;return}else if(($|0)==31){i=s;return}}function g6(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;Ae[c[(c[e+468>>2]|0)+(f*80|0)+32>>2]&63](e,a,b,d);i=g;return 0}function h6(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0;m=i;n=+V(+f);if((c[a>>2]|0)<=0){i=m;return}o=(c[(c[k+468>>2]|0)+(l*80|0)+56>>2]|0)==0;p=0;do{f=+h[b+(p<<3)>>3];if(o){if(!(f>=0.0)){q=-f}else{q=f}r=n*+md(1.0,+q);if(!(+h[d+(p<<3)>>3]>=0.0)){s=-r}else{s=r}t=s+f-f}else{t=1.0}u=b+(p<<3)|0;h[u>>3]=t+f;r=1.0/t;g6(b,j,g,k,l)|0;v=c[a>>2]|0;if((v|0)>0){w=0;do{x=(fa(v,p)|0)+w|0;h[e+(x<<3)>>3]=r*(+h[j+(w<<3)>>3]- +h[d+(w<<3)>>3]);w=w+1|0;}while((w|0)<(v|0))}h[u>>3]=f;p=p+1|0;}while((p|0)<(v|0));i=m;return}function i6(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+24>>2]|0;if((e|0)==3){f=J4(a,b)|0;i=d;return f|0}else if((e|0)==2){j6(a,b);f=0;i=d;return f|0}else if((e|0)==1){g=c[a+4>>2]|0;j=c[g+4>>2]|0;k6(c[g>>2]|0,+h[j>>3],c[j+8>>2]|0,c[a+112>>2]|0,b);f=0;i=d;return f|0}else if((e|0)==4){le[c[(c[a+540>>2]|0)+56>>2]&1](a,+h[b+8>>3])|0;h[b>>3]=+h[c[c[a+4>>2]>>2]>>3];f=0;i=d;return f|0}else{f=1;i=d;return f|0}return 0}function j6(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0;d=i;e=c[c[b+48>>2]>>2]|0;f=c[a+4>>2]|0;g=c[f>>2]|0;j=c[f+4>>2]|0;f=g+8|0;k=c[f>>2]|0;l=a+112|0;m=c[l>>2]|0;n=j+8|0;o=c[n>>2]|0;p=j;j=b+8|0;q=b;h[q>>3]=+h[p>>3]+ +h[j>>3];if((m|0)>0){b=c[e>>2]|0;r=0;do{h[b+(r<<3)>>3]=+h[o+(r+m<<3)>>3];r=r+1|0;}while((r|0)<(m|0))}r=g;g=a+540|0;o=m;b=1;do{if((o|0)>0){s=c[n>>2]|0;t=+h[106496+(b<<3)>>3];u=c[e+(b+ -1<<2)>>2]|0;v=c[f>>2]|0;w=0;while(1){h[v+(w<<3)>>3]=+h[s+(w<<3)>>3]+ +h[j>>3]*t*+h[u+(w<<3)>>3];x=w+1|0;if((x|0)<(o|0)){w=x}else{y=t;break}}}else{y=+h[106496+(b<<3)>>3]}h[r>>3]=+h[p>>3]+y*+h[j>>3];ae[c[(c[g>>2]|0)+28>>2]&127](a)|0;o=c[l>>2]|0;z=(o|0)>0;if(z){w=c[e+(b<<2)>>2]|0;u=0;do{h[w+(u<<3)>>3]=+h[k+(u+m<<3)>>3];u=u+1|0;}while((u|0)<(o|0))}b=b+1|0;}while((b|0)<4);if(!z){A=+h[q>>3];h[r>>3]=A;i=d;return}z=c[n>>2]|0;n=c[f>>2]|0;f=c[e>>2]|0;b=c[e+4>>2]|0;m=c[e+8>>2]|0;k=c[e+12>>2]|0;e=0;do{h[n+(e<<3)>>3]=+h[z+(e<<3)>>3]+(+h[f+(e<<3)>>3]*.16666666666666666+0.0+ +h[b+(e<<3)>>3]*.3333333333333333+ +h[m+(e<<3)>>3]*.3333333333333333+ +h[k+(e<<3)>>3]*.16666666666666666)*+h[j>>3];e=e+1|0;}while((e|0)<(o|0));A=+h[q>>3];h[r>>3]=A;i=d;return}function k6(a,b,d,e,f){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0;g=i;j=f+8|0;k=+h[j>>3];l=k+b;m=f;h[m>>3]=l;if((e|0)<=0){n=l;o=a;p=o;h[p>>3]=n;i=g;return}f=c[a+8>>2]|0;l=k;q=0;while(1){h[f+(q<<3)>>3]=+h[d+(q<<3)>>3]+ +h[d+(q+e<<3)>>3]*l;r=q+1|0;if((r|0)>=(e|0)){break}l=+h[j>>3];q=r}n=+h[m>>3];o=a;p=o;h[p>>3]=n;i=g;return}function l6(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+8|0;h[d>>3]=+h[b+240>>3];h[d+8>>3]=+h[b+264>>3];h[d+16>>3]=0.0;a[d+28|0]=0;c[d+32>>2]=o2(4)|0;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;f=c[d+24>>2]|0;a:do{if((f|0)==3){g=Jwa(88)|0;V1(23,0,106528,e);j=H4(b,d,g)|0;c[d+48>>2]=g;k=j}else if((f|0)==2){j=Jwa(8)|0;c[j+4>>2]=4;g=Jwa(20)|0;c[j>>2]=g;l=c[b+112>>2]|0;m=g;g=0;while(1){c[m+(g<<2)>>2]=Lwa(l,8)|0;if((g|0)>=4){break}m=c[j>>2]|0;g=g+1|0}c[d+48>>2]=j;k=0}else if((f|0)==4){g=c[258]|0;m=Jwa(g<<2)|0;c[26638]=m;if((g|0)<=0){k=0;break}l=c[b+116>>2]|0;n=m;m=0;while(1){c[n+(m<<2)>>2]=Lwa(l,8)|0;o=m+1|0;if((o|0)>=(g|0)){k=0;break a}n=c[26638]|0;m=o}}else{k=0}}while(0);y6(b)|0;if((c[2]|0)==0){i=e;return k|0}K3(6);H3(1);i=e;return k|0}function m6(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[b+24>>2]|0;if((e|0)==2){f=b+48|0;g=c[f>>2]|0;h=c[g>>2]|0;if((c[g+4>>2]|0)>-1){g=h;j=0;while(1){Kwa(c[g+(j<<2)>>2]|0);k=c[f>>2]|0;l=c[k>>2]|0;if((j|0)<(c[k+4>>2]|0)){j=j+1|0;g=l}else{m=l;break}}}else{m=h}Kwa(m);Kwa(c[f>>2]|0)}else if((e|0)==3){I4(c[b+48>>2]|0)|0}else if((e|0)==4){e=c[258]|0;b=c[26638]|0;if((e|0)>0){f=b;m=0;while(1){Kwa(c[f+(m<<2)>>2]|0);h=m+1|0;g=c[26638]|0;if((h|0)<(e|0)){m=h;f=g}else{n=g;break}}}else{n=b}Kwa(n)}z6(a)|0;t6(a);i=d;return 0}function n6(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+168|0;c[o>>2]=0;p=i;i=i+160|0;q=b+536|0;r=c[q>>2]|0;u=0;pa(948,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){t=yxa(c[s>>2]|0,o)|0;if((t|0)==0){db(s|0,v|0)}J=v}else{t=-1}do{if((t|0)==1){w=0;x=0;y=0;z=0;A=J}else{u=0;sa(97,b|0)|0;s=u;u=0;if((s|0)!=0&(v|0)!=0){B=yxa(c[s>>2]|0,o)|0;if((B|0)==0){db(s|0,v|0)}J=v}else{B=-1}if((B|0)==1){w=0;x=0;y=0;z=0;A=J;break}s=b+540|0;u=0;sa(c[(c[s>>2]|0)+40>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){D=yxa(c[C>>2]|0,o)|0;if((D|0)==0){db(C|0,v|0)}J=v}else{D=-1}if((D|0)==1){w=0;x=0;y=0;z=0;A=J;break}if((a[b+440|0]|0)!=0){u=0;sa(c[(c[s>>2]|0)+44>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){E=yxa(c[C>>2]|0,o)|0;if((E|0)==0){db(C|0,v|0)}J=v}else{E=-1}if((E|0)==1){w=0;x=0;y=0;z=0;A=J;break}}C=b+240|0;h[c[c[b+4>>2]>>2]>>3]=+h[C>>3];u=0;pa(c[(c[s>>2]|0)+4>>2]|0,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){F=yxa(c[s>>2]|0,o)|0;if((F|0)==0){db(s|0,v|0)}J=v}else{F=-1}if((F|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;pa(949,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){G=yxa(c[s>>2]|0,o)|0;if((G|0)==0){db(s|0,v|0)}J=v}else{G=-1}if((G|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;oa(1,+(+h[b+272>>3]));s=u;u=0;if((s|0)!=0&(v|0)!=0){H=yxa(c[s>>2]|0,o)|0;if((H|0)==0){db(s|0,v|0)}J=v}else{H=-1}if((H|0)==1){w=0;x=0;y=0;z=C;A=J;break}c[(c[q>>2]|0)+84>>2]=1;s=p;I=r+80|0;K=c[I>>2]|0;c[I>>2]=p;kxa(p,1,o|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=yxa(c[L>>2]|0,o)|0;if((M|0)==0){db(L|0,v|0)}J=v}else{M=-1}if((M|0)==1){w=K;x=I;y=s;z=C;A=J;break}w=K;x=I;y=s;z=C;A=0}}while(0);a:while(1){do{if((A|0)==0){u=0;M=Ja(1,b|0,d|0,e|0,f|0,+g,j|0)|0;p=u;u=0;if((p|0)!=0&(v|0)!=0){N=yxa(c[p>>2]|0,o)|0;if((N|0)==0){db(p|0,v|0)}J=v}else{N=-1}if((N|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}if((M|0)==0){S=0;T=1;break}u=0;Sa(14,1,0,106560,n|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){U=yxa(c[M>>2]|0,o)|0;if((U|0)==0){db(M|0,v|0)}J=v}else{U=-1}if((U|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}h[b+248>>3]=+h[z>>3];S=-1;T=1}else{S=0;T=0}}while(0);c[x>>2]=w;u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){V=yxa(c[M>>2]|0,o)|0;if((V|0)==0){db(M|0,v|0)}J=v}else{V=-1}if((V|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if(T){W=S}else{u=0;Sa(15,2,0,106656,m|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){X=yxa(c[M>>2]|0,o)|0;if((X|0)==0){db(M|0,v|0)}J=v}else{X=-1}if((X|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}W=-1}u=0;qa(c[112776>>2]|0,112752,b|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Y=yxa(c[M>>2]|0,o)|0;if((Y|0)==0){db(M|0,v|0)}J=v}else{Y=-1}if((Y|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}u=0;Sa(15,23,0,106712,l|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Z=yxa(c[M>>2]|0,o)|0;if((Z|0)==0){db(M|0,v|0)}J=v}else{Z=-1}if((Z|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if((c[2]|0)==0){_=26;break}u=0;pa(950,1);M=u;u=0;if((M|0)!=0&(v|0)!=0){$=yxa(c[M>>2]|0,o)|0;if(($|0)==0){db(M|0,v|0)}J=v}else{$=-1}if(($|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R}else{break}}if((_|0)==26){i=k;return W|0}i=k;return W|0}function o6(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=+h[d>>3];do{if(H>=+h[b+248>>3]){if((c[d+24>>2]|0)==5){break}I=G;h[k>>3]=H;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];V1(8,0,106808,G);I=b+313|0;a[I]=1;f5(b);if((c[128084>>2]|0)==0){_d[c[112772>>2]&127](112752,b)}a[I]=0}}while(0);if((e|0)!=0){p6(sd(e|0)|0,b)}if((c[70988>>2]|0)==0){i=f;return 0}K3(0);V1(25,0,106856,F);V1(25,1,106880,E);H=+C3(6);J=+C3(6);K=J/+C3(0)*100.0;E=D;h[k>>3]=H;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=K;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];V1(25,0,106888,D);K=+C3(1);H=+C3(1);J=H/+C3(0)*100.0;D=C;h[k>>3]=K;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=J;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];V1(25,0,106928,C);J=+C3(2);K=+C3(2);H=K/+C3(0)*100.0;C=B;h[k>>3]=J;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+8|0;h[k>>3]=H;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];V1(25,0,106960,B);H=+C3(3);J=+C3(3);K=J/+C3(0)*100.0;B=A;h[k>>3]=H;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=K;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];V1(25,0,106984,A);K=+C3(4);H=+C3(4);J=H/+C3(0)*100.0;A=z;h[k>>3]=K;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=J;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];V1(25,0,107024,z);J=+C3(7);K=+C3(7);H=K/+C3(0)*100.0;z=y;h[k>>3]=J;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];V1(25,0,107056,y);y=d+24|0;z=(c[y>>2]|0)==5;H=+C3(0);J=H- +C3(7);H=J- +C3(4);J=H- +C3(3);H=J- +C3(2);J=H- +C3(1);H=J- +C3(6);J=+C3(0);K=J- +C3(7);J=K- +C3(4);K=J- +C3(3);J=K- +C3(2);K=J- +C3(1);J=K- +C3(6);K=J/+C3(0)*100.0;if(z){z=w;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=w+8|0;h[k>>3]=K;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];V1(25,0,107120,w)}else{w=x;h[k>>3]=H;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=x+8|0;h[k>>3]=K;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];V1(25,0,107088,x)}K=+C3(0);H=+C3(0);J=H/+C3(0)*100.0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=v+8|0;h[k>>3]=J;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];V1(25,0,107152,v);Zd[c[17860]&1023](25);V1(25,1,107176,u);c[t>>2]=c[d+40>>2];V1(25,0,107184,t);c[s>>2]=c[d+44>>2];V1(25,0,107208,s);Zd[c[17860]&1023](25);s=c[y>>2]|0;if((s|0)==3){y=d+48|0;d=c[y>>2]|0;t=c[d+8>>2]|0;u=c[d+4>>2]|0;c[u>>2]=(c[u>>2]|0)+(c[t>>2]|0);d=u+4|0;c[d>>2]=(c[d>>2]|0)+(c[t+4>>2]|0);d=u+8|0;c[d>>2]=(c[d>>2]|0)+(c[t+8>>2]|0);d=u+12|0;c[d>>2]=(c[d>>2]|0)+(c[t+12>>2]|0);d=u+16|0;c[d>>2]=(c[d>>2]|0)+(c[t+16>>2]|0);V1(25,1,107232,r);c[q>>2]=c[c[(c[y>>2]|0)+4>>2]>>2];V1(25,0,107248,q);c[p>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+4>>2];V1(25,0,107264,p);c[o>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+8>>2];V1(25,0,107296,o);c[n>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+12>>2];V1(25,0,107328,n);c[m>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+16>>2];V1(25,0,107352,m);Zd[c[17860]&1023](25)}else if((s|0)!=5){V1(25,1,107384,l);V1(25,0,107392,j);Zd[c[17860]&1023](25)}V1(25,0,107456,g);H3(0);i=f;return 0}function p6(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+16|0;y=i;i=i+8|0;z=Wb(b|0,107928)|0;b=c[t>>2]|0;A=d+4|0;B=y;h[k>>3]=+h[c[c[A>>2]>>2]>>3];c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];pd(b|0,107936,y|0)|0;if((z|0)==0){C=Kd(10,b|0)|0;D=nd(b|0)|0;i=e;return}y=d+116|0;B=d+124|0;E=d+128|0;F=d+132|0;G=d+216|0;H=d+220|0;I=d+224|0;J=d+228|0;K=d+136|0;L=d+140|0;M=d+144|0;N=d+148|0;O=d+36|0;P=d+428|0;Q=d+32|0;R=d+424|0;S=d+28|0;T=d+420|0;U=d+24|0;V=d+416|0;W=d+52|0;X=d+48|0;Y=d+44|0;Z=d+40|0;_=d+20|0;$=d+16|0;aa=d+12|0;ba=d+8|0;d=z;do{z=c[y>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((hxa(d,c[(c[ba>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];c[x>>2]=d;ea=x+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];pd(b|0,107952,x|0)|0;fa=c[y>>2]|0}else{fa=ca}ea=z+1|0;if((ea|0)<(fa|0)){ca=fa;z=ea}else{break}}}z=c[B>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((hxa(d,c[(c[aa>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(z<<2)>>2]|0;c[w>>2]=d;c[w+4>>2]=ea;pd(b|0,107968,w|0)|0;ga=c[B>>2]|0}else{ga=ca}ea=z+1|0;if((ea|0)<(ga|0)){ca=ga;z=ea}else{break}}}z=c[E>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((hxa(d,c[(c[$>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+z|0]|0;c[v>>2]=d;c[v+4>>2]=ea;pd(b|0,107976,v|0)|0;ha=c[E>>2]|0}else{ha=ca}ea=z+1|0;if((ea|0)<(ha|0)){ca=ha;z=ea}else{break}}}z=c[F>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((hxa(d,c[(c[_>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(z<<2)>>2]|0;c[u>>2]=d;c[u+4>>2]=ea;pd(b|0,107984,u|0)|0;ia=c[F>>2]|0}else{ia=ca}ea=z+1|0;if((ea|0)<(ia|0)){ca=ia;z=ea}else{break}}}if((c[G>>2]|0)>0){z=0;do{ca=c[Z>>2]|0;do{if((hxa(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(c[ca+(z*52|0)+4>>2]<<3)>>3];if((c[ca+(z*52|0)>>2]|0)==0){c[r>>2]=d;ea=r+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];pd(b|0,107952,r|0)|0;break}else{c[s>>2]=d;ea=s+4|0;h[k>>3]=-da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];pd(b|0,107952,s|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[G>>2]|0))}if((c[H>>2]|0)>0){z=0;do{ca=c[Y>>2]|0;do{if((hxa(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(c[ca+(z*52|0)+4>>2]<<2)>>2]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[p>>2]=d;c[p+4>>2]=ea;pd(b|0,107968,p|0)|0;break}else{c[q>>2]=d;c[q+4>>2]=0-ea;pd(b|0,107968,q|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[H>>2]|0))}if((c[I>>2]|0)>0){z=0;do{ca=c[X>>2]|0;do{if((hxa(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+(c[ca+(z*52|0)+4>>2]|0)|0]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[n>>2]=d;c[n+4>>2]=ea;pd(b|0,107976,n|0)|0;break}else{c[o>>2]=d;c[o+4>>2]=0-ea;pd(b|0,107976,o|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[I>>2]|0))}z=c[J>>2]|0;if((z|0)>0){ca=z;z=0;while(1){ea=c[W>>2]|0;if((hxa(d,c[ea+(z*52|0)+16>>2]|0)|0)==0){ja=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(c[ea+(z*52|0)+4>>2]<<2)>>2]|0;c[m>>2]=d;c[m+4>>2]=ja;pd(b|0,107984,m|0)|0;ka=c[J>>2]|0}else{ka=ca}ja=z+1|0;if((ja|0)<(ka|0)){ca=ka;z=ja}else{break}}}z=c[K>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((hxa(d,c[(c[U>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[V>>2]|0)+(z<<3)>>3];c[l>>2]=d;ja=l+4|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];pd(b|0,107952,l|0)|0;la=c[K>>2]|0}else{la=ca}ja=z+1|0;if((ja|0)<(la|0)){ca=la;z=ja}else{break}}}z=c[L>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((hxa(d,c[(c[S>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ja=c[(c[T>>2]|0)+(z<<2)>>2]|0;c[j>>2]=d;c[j+4>>2]=ja;pd(b|0,107968,j|0)|0;ma=c[L>>2]|0}else{ma=ca}ja=z+1|0;if((ja|0)<(ma|0)){ca=ma;z=ja}else{break}}}z=c[M>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((hxa(d,c[(c[Q>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ja=a[(c[R>>2]|0)+z|0]|0;c[g>>2]=d;c[g+4>>2]=ja;pd(b|0,107976,g|0)|0;na=c[M>>2]|0}else{na=ca}ja=z+1|0;if((ja|0)<(na|0)){ca=na;z=ja}else{break}}}z=c[N>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((hxa(d,c[(c[O>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ja=c[(c[P>>2]|0)+(z<<2)>>2]|0;c[f>>2]=d;c[f+4>>2]=ja;pd(b|0,107984,f|0)|0;oa=c[N>>2]|0}else{oa=ca}ja=z+1|0;if((ja|0)<(oa|0)){ca=oa;z=ja}else{break}}}d=Wb(0,107928)|0;}while((d|0)!=0);C=Kd(10,b|0)|0;D=nd(b|0)|0;i=e;return}function q6(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;m=i;i=i+16|0;n=m;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+56|0;t=s;u=s+24|0;c[u>>2]=j;a:do{switch(j|0){case 5:{X1(1,0,107552,q);v=1;i=m;return v|0};case 17:case 16:case 15:case 14:case 13:case 12:{c[u>>2]=3;break};case 4:{w=c[256]|0;if((w|0)!=0){if((hxa(w,107592)|0)==0){break a}}V1(23,0,107608,p);v=1;i=m;return v|0};case 18:{w=c[256]|0;do{if((w|0)!=0){if((hxa(w,107736)|0)!=0){break}c[u>>2]=4;break a}}while(0);V1(23,0,107760,o);v=1;i=m;return v|0};case 11:case 10:case 9:case 6:case 7:case 8:{X1(1,0,107480,r);v=1;i=m;return v|0};default:{}}}while(0);r=l6(a,s)|0;ue[c[72196>>2]&7]()|0;do{if((r|0)==0){o=n6(a,b,d,e,f,g)|0;ue[c[72196>>2]&7]()|0;if((o|0)!=0){x=o;break}if((c[u>>2]|0)!=5){_d[c[112772>>2]&127](112752,a);p5(a)}y=+h[a+248>>3];o=n;h[k>>3]=+h[a+240>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=y;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];V1(23,0,107888,n);o=pe[c[c[a+540>>2]>>2]&63](a,t)|0;ue[c[72196>>2]&7]()|0;o6(a,s,l)|0;ue[c[72196>>2]&7]()|0;x=o}else{ue[c[72196>>2]&7]()|0;x=r}}while(0);m6(a,s)|0;v=x;i=m;return v|0}function r6(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=a+204|0;if((c[e>>2]|0)<=0){s6(a);i=b;return}f=a+488|0;g=a;h=0;while(1){j=h+1|0;if((ae[c[(c[f>>2]|0)+(h*48|0)+40>>2]&127](g)|0)!=0){k=5;break}if((j|0)<(c[e>>2]|0)){h=j}else{k=6;break}}if((k|0)==5){Z1(c[a+536>>2]|0,108e3,d)}else if((k|0)==6){s6(a);i=b;return}}function s6(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;f=a+12|0;g=a+4|0;a=0;do{h=c[e>>2]|0;j=(c[c[h+(a*48|0)+12>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0;k=c[(c[c[g>>2]>>2]|0)+12>>2]|0;l=h+(a*48|0)|0;m=h+(a*48|0)+4|0;pxa(k+(j<<2)|0,0,fa(c[l>>2]<<2,c[m>>2]|0)|0)|0;n=h+(a*48|0)+8|0;if((c[n>>2]|0)>0){o=c[h+(a*48|0)+16>>2]|0;p=0;do{c[o+(p<<2)>>2]=p;p=p+1|0;}while((p|0)<(c[n>>2]|0))}n=c[l>>2]|0;if((n|0)>0){p=c[h+(a*48|0)+20>>2]|0;o=n;n=0;do{c[p+(n<<2)>>2]=o+~n;n=n+1|0;o=c[l>>2]|0;}while((n|0)<(o|0))}o=c[m>>2]|0;if((o|0)>0){n=o;o=0;do{c[k+(o+j+(fa(n,o)|0)<<2)>>2]=1;o=o+1|0;n=c[m>>2]|0;}while((o|0)<(n|0))}a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function t6(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;a=0;do{f=c[e>>2]|0;Kwa(c[f+(a*48|0)+28>>2]|0);Kwa(c[f+(a*48|0)+32>>2]|0);Kwa(c[f+(a*48|0)+16>>2]|0);Kwa(c[f+(a*48|0)+20>>2]|0);Kwa(c[f+(a*48|0)+24>>2]|0);a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}



function u6(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+4096|0;p=b+204|0;if((c[p>>2]|0)<=0){q=0;i=f;return q|0}r=b+488|0;s=d<<24>>24==0;d=(e|0)==0;t=0;u=0;while(1){v=c[r>>2]|0;w=v+(u*48|0)|0;x=Jwa(c[w>>2]<<2)|0;y=v+(u*48|0)+8|0;z=Jwa(c[y>>2]<<2)|0;v6(b,u);A=v+(u*48|0)+20|0;B=c[A>>2]|0;C=c[w>>2]|0;nxa(x|0,B|0,C<<2|0)|0;D=v+(u*48|0)+16|0;E=c[D>>2]|0;F=c[y>>2]|0;nxa(z|0,E|0,F<<2|0)|0;G=v+(u*48|0)+24|0;if(!((G4(c[G>>2]|0,F,C,E,B)|0)==0|s)){break}B=w6(x,c[A>>2]|0,c[w>>2]|0,c[y>>2]|0,c[v+(u*48|0)+4>>2]|0,c[v+(u*48|0)+12>>2]|0,c[v+(u*48|0)+28>>2]|0,c[v+(u*48|0)+32>>2]|0,b,e)|0;if(d){nxa(c[A>>2]|0,x|0,c[w>>2]<<2|0)|0;nxa(c[D>>2]|0,z|0,c[y>>2]<<2|0)|0}y=(B|0)==0?t:1;Kwa(x);Kwa(z);z=u+1|0;if((z|0)<(c[p>>2]|0)){t=y;u=z}else{q=y;H=15;break}}if((H|0)==15){i=f;return q|0}q=o;o=v+(u*48|0)+44|0;f=c[o>>2]|0;H=b+464|0;t=c[H>>2]|0;p=c[t+(f*44|0)>>2]|0;c[n>>2]=c[t+(f*44|0)+4>>2];c[n+4>>2]=p;c[n+8>>2]=f;X1(5,1,108056,n);n=c[H>>2]|0;if((c[n+((c[o>>2]|0)*44|0)+4>>2]|0)!=0){f=n;n=0;do{a[q]=0;p=c[f+((c[o>>2]|0)*44|0)>>2]|0;if((p|0)!=0){t=p;p=0;do{d=(fa(t,n)|0)+p|0;I=+h[(c[G>>2]|0)+(d<<3)>>3];c[m>>2]=q;d=m+4|0;h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];hc(q|0,108088,m|0)|0;p=p+1|0;t=c[(c[H>>2]|0)+((c[o>>2]|0)*44|0)>>2]|0;}while(p>>>0<t>>>0)}c[l>>2]=q;X1(5,0,108096,l);n=n+1|0;f=c[H>>2]|0;}while(n>>>0<(c[f+((c[o>>2]|0)*44|0)+4>>2]|0)>>>0)}if((c[w>>2]|0)<=0){J=71440;K=c[17860]|0;Zd[K&1023](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=6;_=Z;$=108104;aa=$;Z1(O,aa,g)}o=v+(u*48|0)+32|0;u=0;do{c[j>>2]=c[(c[(c[o>>2]|0)+(u<<2)>>2]|0)+4>>2];X1(5,0,108096,j);u=u+1|0;}while((u|0)<(c[w>>2]|0));J=71440;K=c[17860]|0;Zd[K&1023](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=6;_=Z;$=108104;aa=$;Z1(O,aa,g);return 0}function v6(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+488|0;f=c[e>>2]|0;g=c[f+(b*48|0)+44>>2]|0;j=a+464|0;k=c[j>>2]|0;l=c[f+(b*48|0)+24>>2]|0;pxa(l|0,0,fa(c[k+(g*44|0)+4>>2]<<3,c[k+(g*44|0)>>2]|0)|0)|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=d;return}f=a;a=c[k+(g*44|0)>>2]|0;m=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[m+(g*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}ae[c[(c[e>>2]|0)+(b*48|0)+36>>2]&127](f)|0;m=c[j>>2]|0;a=c[m+(g*44|0)>>2]|0;do{if((a|0)!=0){n=c[m+(g*44|0)+28>>2]|0;o=0;do{do{if(+h[n+(o<<3)>>3]==1.0){if((o|0)==0){p=m+(g*44|0)+8|0;q=0}else{r=m+(g*44|0)+8|0;p=r;q=c[(c[r>>2]|0)+(o+ -1<<2)>>2]|0}r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if(!(q>>>0<r>>>0)){break}s=c[m+(g*44|0)+12>>2]|0;t=c[m+(g*44|0)+4>>2]|0;u=c[m+(g*44|0)+36>>2]|0;v=q;do{w=c[s+(v<<2)>>2]|0;x=(fa(t,o)|0)+w|0;h[l+(x<<3)>>3]=+h[u+(w<<3)>>3];v=v+1|0;}while(v>>>0<r>>>0)}}while(0);o=o+1|0;}while(o>>>0<a>>>0);if((a|0)==0){break}o=c[m+(g*44|0)+20>>2]|0;n=0;do{if(((c[o+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=0.0}n=n+1|0;}while(n>>>0<a>>>0)}}while(0);k=k+1|0;}while(k>>>0<(c[m+(g*44|0)+24>>2]|0)>>>0);i=d;return}function w6(a,b,d,e,f,g,j,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;o=i;i=i+8|0;p=o;q=Lwa(d,4)|0;r=Lwa(d,4)|0;s=r;t=(d|0)>0;if(t){u=0}else{v=0;Kwa(q);Kwa(r);i=o;return v|0}do{w=(u|0)<(e|0)?1:2;c[r+(c[b+(u<<2)>>2]<<2)>>2]=w;c[q+(c[a+(u<<2)>>2]<<2)>>2]=w;u=u+1|0;}while((u|0)<(d|0));if(t){x=0}else{v=0;Kwa(q);Kwa(r);i=o;return v|0}while(1){t=x+1|0;if((c[r+(x<<2)>>2]|0)!=(c[q+(x<<2)>>2]|0)){break}if((t|0)<(d|0)){x=t}else{v=0;y=9;break}}if((y|0)==9){Kwa(q);Kwa(r);i=o;return v|0}if((n|0)==0){v=-1;Kwa(q);Kwa(r);i=o;return v|0}n=p;h[k>>3]=+h[c[c[m+4>>2]>>2]>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];V1(5,1,108208,p);x6(s,d,f,c[g>>2]|0,j,l,m);if((c[70908>>2]|0)==0){v=-1;Kwa(q);Kwa(r);i=o;return v|0}Zd[c[17860]&1023](5);v=-1;Kwa(q);Kwa(r);i=o;return v|0}function x6(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+8|0;l=k;m=e-(c[c[j+12>>2]>>2]|0)|0;e=j+4|0;n=c[(c[c[e>>2]>>2]|0)+12>>2]|0;pxa(n+(m<<2)|0,0,fa(b<<2,d)|0)|0;if((b|0)<=0){i=k;return}o=j+8|0;j=0;p=0;while(1){if((c[a+(j<<2)>>2]|0)==2){q=c[c[o>>2]>>2]|0;r=c[g+(j<<2)>>2]|0;s=(c[r>>2]|0)-q|0;t=(c[c[f+(p<<2)>>2]>>2]|0)-q|0;c[l>>2]=c[r+4>>2];V1(5,0,108240,l);c[n+(p+m+(fa(j,d)|0)<<2)>>2]=1;r=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[r+(t<<3)>>3]=+h[r+(s<<3)>>3];u=p+1|0}else{u=p}s=j+1|0;if((s|0)<(b|0)){j=s;p=u}else{break}}i=k;return}function y6(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=ic(108256,108280)|0;o=(n|0)!=0;a[b+440|0]=o&1;if(o){p=0}else{i=d;return 0}a:while(1){while(1){o=ad(n|0)|0;if((o|0)==-1){break a}else if((o|0)==10){break}}p=p+1|0}o=p+ -1|0;p=b+456|0;c[p>>2]=o;c[b+452>>2]=o;ob(n|0);do{}while((ad(n|0)|0)!=10);q=c[b+152>>2]|0;r=Lwa(o,4)|0;o=b+444|0;c[o>>2]=r;s=c[p>>2]|0;t=(s|0)>0;b:do{if(t){u=r;v=0;while(1){c[u+(v<<2)>>2]=Lwa(q,8)|0;w=v+1|0;if((w|0)>=(s|0)){break}u=c[o>>2]|0;v=w}v=Lwa(s,8)|0;u=b+448|0;c[u>>2]=v;if(!t){x=u;break}w=(q|0)>0;y=v;v=0;while(1){c[m>>2]=y+(v<<3);z=bc(n|0,108288,m|0)|0;if(w){A=0;while(1){c[l>>2]=(c[(c[o>>2]|0)+(v<<2)>>2]|0)+(A<<3);B=bc(n|0,108288,l|0)|0;C=A+1|0;if((C|0)<(q|0)){A=C}else{D=B;break}}}else{D=z}if((D|0)<0){c[p>>2]=v;E=v}else{E=c[p>>2]|0}A=v+1|0;if((A|0)>=(E|0)){x=u;break b}y=c[u>>2]|0;v=A}}else{v=b+448|0;c[v>>2]=Lwa(s,8)|0;x=v}}while(0);gc(108296,j|0)|0;gc(108352,g|0)|0;if((c[p>>2]|0)>0){g=(q|0)>0;j=0;do{s=f;h[k>>3]=+h[(c[x>>2]|0)+(j<<3)>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];gc(108312,f|0)|0;if(g){s=0;while(1){E=s+1|0;F=+h[(c[(c[o>>2]|0)+(j<<2)>>2]|0)+(s<<3)>>3];c[e>>2]=E;D=e+4|0;h[k>>3]=F;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];gc(108336,e|0)|0;if((E|0)<(q|0)){s=E}else{break}}}j=j+1|0;}while((j|0)<(c[p>>2]|0))}sb(108352)|0;Wc(n|0)|0;c[b+460>>2]=0;i=d;return 0}function z6(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((a[b+440|0]|0)==0){i=d;return 0}Kwa(c[b+448>>2]|0);e=b+452|0;f=b+444|0;b=c[f>>2]|0;if((c[e>>2]|0)>0){g=b;h=0;while(1){Kwa(c[g+(h<<2)>>2]|0);j=h+1|0;k=c[f>>2]|0;if((j|0)<(c[e>>2]|0)){h=j;g=k}else{l=k;break}}}else{l=b}Kwa(l);i=d;return 0}function A6(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;d=i;if((a[b+440|0]|0)==0){e=-1;i=d;return e|0}f=+h[c[c[b+4>>2]>>2]>>3];g=b+460|0;j=c[g>>2]|0;k=c[b+448>>2]|0;l=+h[k+(j<<3)>>3];if(f==l){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;p=0;while(1){h[o+(p<<3)>>3]=+h[n+(p<<3)>>3];q=p+1|0;if((q|0)<(m|0)){p=q}else{e=1;break}}i=d;return e|0}p=j+1|0;r=+h[k+(p<<3)>>3];if(f==r){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;q=0;while(1){s=q+1|0;h[o+(q<<3)>>3]=+h[n+(s<<3)>>3];if((s|0)<(m|0)){q=s}else{e=1;break}}i=d;return e|0}a:do{if(f>r){q=(c[b+456>>2]|0)+ -1|0;m=j;n=p;while(1){if((n|0)>=(q|0)){t=m;break a}c[g>>2]=n;o=n+1|0;if(f>+h[k+(o<<3)>>3]){s=n;n=o;m=s}else{t=n;break}}}else{t=j}}while(0);j=t+1|0;r=+h[k+(j<<3)>>3]- +h[k+(t<<3)>>3];k=c[b+152>>2]|0;if((k|0)<=0){e=0;i=d;return e|0}g=c[b+444>>2]|0;p=c[g+(t<<2)>>2]|0;t=c[g+(j<<2)>>2]|0;u=l+r;j=b+432|0;v=u-f;w=f-l;b=0;while(1){x=+h[p+(b<<3)>>3];y=+h[t+(b<<3)>>3];do{if(x!=y){if(x>0.0){z=1}else{z=(x<0.0)<<31>>31}if(y>0.0){A=1}else{A=(y<0.0)<<31>>31}if((z|0)==(A|0)){h[(c[j>>2]|0)+(b<<3)>>3]=(u*x+f*y-(f*x+l*y))/r;break}else{h[(c[j>>2]|0)+(b<<3)>>3]=(v*x+w*y)/r;break}}else{h[(c[j>>2]|0)+(b<<3)>>3]=x}}while(0);g=b+1|0;if((g|0)<(k|0)){b=g}else{e=0;break}}i=d;return e|0}function B6(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=+C6(a,1.0);if(!(f>1.0e-5)){g=0;i=b;return g|0}if((c[70924>>2]|0)==0){g=1;i=b;return g|0}j=e;h[k>>3]=f;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];V1(9,1,108416,e);e=a+16|0;j=c[e>>2]|0;if((j|0)>0){l=a+48|0;a=j;j=0;while(1){f=+h[(c[l>>2]|0)+(j<<3)>>3];m=j+1|0;if(+U(+f)>1.0e-5){c[d>>2]=m;n=d+4|0;h[k>>3]=f;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];V1(9,0,108528,d);o=c[e>>2]|0}else{o=a}if((m|0)<(o|0)){a=o;j=m}else{break}}}Zd[c[17860]&1023](9);g=1;i=b;return g|0}function C6(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0,K=0,L=0.0;e=i;f=c[b+60>>2]|0;R6(b);g=f+540|0;ae[c[(c[g>>2]|0)+84>>2]&127](f)|0;ae[c[(c[g>>2]|0)+36>>2]&127](f)|0;ae[c[(c[g>>2]|0)+32>>2]&127](f)|0;j=b+48|0;pe[c[(c[g>>2]|0)+68>>2]&63](f,c[j>>2]|0)|0;g=f+8|0;k=c[f+184>>2]|0;if((k|0)>0){l=c[b+52>>2]|0;m=(l|0)==0;n=c[j>>2]|0;o=0.0;j=0;while(1){if(m){p=1.0}else{p=+h[l+(j<<3)>>3]}q=+h[n+(j<<3)>>3]/p;r=o+q*q;s=j+1|0;if((s|0)<(k|0)){o=r;j=s}else{t=r;break}}}else{t=0.0}if(!(d<1.0)){u=t;i=e;return+u}o=t*d;j=c[f+116>>2]|0;if((j|0)>0){k=c[g>>2]|0;n=b+56|0;t=1.0-d;l=f+4|0;p=o;m=0;s=0;while(1){if((a[k+(m*112|0)+88|0]|0)==0){v=p;w=s}else{x=c[n>>2]|0;if((x|0)==0){y=s;z=1.0}else{y=s+1|0;z=+h[x+(s<<3)>>3]}r=(+h[k+(m*112|0)+96>>3]- +h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+(m<<3)>>3])/z;v=p+r*t*r;w=y}x=m+1|0;if((x|0)<(j|0)){p=v;m=x;s=w}else{A=v;B=w;break}}}else{A=o;B=0}w=c[f+136>>2]|0;if((w|0)>0){s=c[f+24>>2]|0;m=b+56|0;o=1.0-d;y=f+416|0;v=A;l=0;k=B;while(1){do{if((a[s+(l*112|0)+88|0]|0)==0){C=v;D=k}else{if((a[s+(l*112|0)+72|0]|0)!=0){C=v;D=k;break}n=c[m>>2]|0;if((n|0)==0){E=k;F=1.0}else{E=k+1|0;F=+h[n+(k<<3)>>3]}p=(+h[s+(l*112|0)+96>>3]- +h[(c[y>>2]|0)+(l<<3)>>3])/F;C=v+p*o*p;D=E}}while(0);n=l+1|0;if((n|0)<(w|0)){v=C;l=n;k=D}else{G=C;H=D;break}}}else{G=A;H=B}B=c[f+120>>2]|0;D=j-B|0;if((D|0)>=(B|0)){u=G;i=e;return+u}j=c[g>>2]|0;g=b+56|0;A=1.0-d;b=f+416|0;d=G;f=D;D=H;while(1){do{if((a[j+(f*112|0)+88|0]|0)==0){I=d;J=D}else{if((a[j+(f*112|0)+72|0]|0)!=0){I=d;J=D;break}H=c[g>>2]|0;if((H|0)==0){K=D;L=1.0}else{K=D+1|0;L=+h[H+(D<<3)>>3]}G=(+h[j+(f*112|0)+96>>3]- +h[(c[b>>2]|0)+(f<<3)>>3])/L;I=d+G*A*G;J=K}}while(0);H=f+1|0;if((H|0)<(B|0)){d=I;f=H;D=J}else{u=I;break}}i=e;return+u}function D6(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+16|0;e=d;f=i;i=i+24|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+16|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;u=+C6(b,1.0);if((c[70924>>2]|0)==0){i=d;return}v=b+16|0;w=c[v>>2]|0;if((w|0)>0){x=c[b+48>>2]|0;y=0.0;z=0;while(1){A=+h[x+(z<<3)>>3];B=y+A*A;C=z+1|0;if((C|0)<(w|0)){z=C;y=B}else{D=B;break}}}else{D=0.0}V1(9,1,108552,t);t=b+52|0;if((c[t>>2]|0)==0){z=r;h[k>>3]=D;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];V1(9,0,108616,r)}else{r=s;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=s+8|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];V1(9,0,108576,s)}V1(9,1,108640,q);q=b+4|0;s=c[q>>2]|0;if((s|0)>0){r=b+40|0;z=b+24|0;w=b+44|0;x=0;while(1){C=c[r>>2]|0;E=x+1|0;u=+h[(c[z>>2]|0)+(x<<3)>>3];F=c[(c[w>>2]|0)+(x<<2)>>2]|0;if((C|0)==0){c[o>>2]=E;G=o+4|0;h[k>>3]=u;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];c[o+12>>2]=F;V1(9,0,108712,o)}else{D=+h[C+(x<<3)>>3];c[p>>2]=E;C=p+4|0;h[k>>3]=u;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[p+12>>2]=F;F=p+16|0;h[k>>3]=D;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];V1(9,0,108664,p)}F=c[q>>2]|0;if((E|0)<(F|0)){x=E}else{H=F;I=E;break}}}else{H=s;I=0}s=b+8|0;if((I|0)<((c[s>>2]|0)+H|0)){H=b+40|0;x=b+24|0;p=b+44|0;o=I;while(1){w=c[H>>2]|0;z=o+1|0;D=+h[(c[x>>2]|0)+(o<<3)>>3];r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if((w|0)==0){c[m>>2]=z;E=m+4|0;h[k>>3]=D;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];c[m+12>>2]=r;V1(9,0,108800,m)}else{u=+h[w+(o<<3)>>3];c[n>>2]=z;w=n+4|0;h[k>>3]=D;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[n+12>>2]=r;r=n+16|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];V1(9,0,108736,n)}if((z|0)<((c[s>>2]|0)+(c[q>>2]|0)|0)){o=z}else{J=z;break}}}else{J=I}I=b;if((J|0)<(c[I>>2]|0)){o=b+40|0;q=b+24|0;s=b+44|0;n=J;while(1){J=c[o>>2]|0;m=n+1|0;u=+h[(c[q>>2]|0)+(n<<3)>>3];p=c[(c[s>>2]|0)+(n<<2)>>2]|0;if((J|0)==0){c[j>>2]=m;x=j+4|0;h[k>>3]=u;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];c[j+12>>2]=p;V1(9,0,108888,j)}else{D=+h[J+(n<<3)>>3];c[l>>2]=m;J=l+4|0;h[k>>3]=u;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];c[l+12>>2]=p;p=l+16|0;h[k>>3]=D;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];V1(9,0,108832,l)}if((m|0)<(c[I>>2]|0)){n=m}else{break}}}Zd[c[17860]&1023](9);V1(9,1,108920,g);if((c[v>>2]|0)>0){g=b+48|0;b=a+540|0;a=0;while(1){n=(c[t>>2]|0)==0;I=a+1|0;D=+h[(c[g>>2]|0)+(a<<3)>>3];l=ae[c[(c[b>>2]|0)+64>>2]&127](a)|0;if(n){c[e>>2]=I;n=e+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[e+12>>2]=l;V1(9,0,108712,e)}else{u=+h[(c[t>>2]|0)+(a<<3)>>3];c[f>>2]=I;n=f+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[f+12>>2]=l;l=f+16|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];V1(9,0,108664,f)}if((I|0)<(c[v>>2]|0)){a=I}else{break}}}Zd[c[17860]&1023](9);Zd[c[17860]&1023](9);i=d;return}function E6(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0;d=i;i=i+24|0;e=d;f=i;i=i+8|0;g=i;i=i+24|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+8|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+40|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b+8|0;if((c[70924>>2]|0)!=0){q5(b,9)}if((c[70984>>2]|0)==0){i=d;return}V1(24,1,108944,t);t=b+112|0;v=c[t>>2]|0;do{if((v|0)>0){V1(24,1,108984,s);if((c[t>>2]|0)>0){w=u;x=b+4|0;y=b+400|0;z=0;while(1){A=z+1|0;B=c[w>>2]|0;C=c[B+(z*112|0)+4>>2]|0;D=+h[B+(z*112|0)+96>>3];E=+h[B+(z*112|0)+80>>3];F=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];G=+h[(c[y>>2]|0)+(z<<3)>>3];c[r>>2]=A;c[r+4>>2]=C;C=r+8|0;h[k>>3]=D;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+16|0;h[k>>3]=E;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+24|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+32|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];V1(24,0,109008,r);if((A|0)<(c[t>>2]|0)){z=A}else{break}}}Zd[c[17860]&1023](24);z=c[t>>2]|0;if((z|0)<=0){H=z;break}V1(24,1,109064,q);z=c[t>>2]|0;if((z|0)<(z<<1|0)){y=u;x=b+4|0;w=b+400|0;A=z;while(1){z=A+1|0;C=c[(c[y>>2]|0)+(A*112|0)+4>>2]|0;G=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];F=+h[(c[w>>2]|0)+(A<<3)>>3];c[p>>2]=z;c[p+4>>2]=C;C=p+8|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=p+16|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];V1(24,0,109088,p);if((z|0)<(c[t>>2]<<1|0)){A=z}else{break}}}Zd[c[17860]&1023](24);H=c[t>>2]|0}else{H=v}}while(0);v=b+116|0;if((H<<1|0)<(c[v>>2]|0)){V1(24,1,109120,o);o=c[t>>2]<<1;if((o|0)<(c[v>>2]|0)){t=u;u=b+4|0;H=b+400|0;p=o;while(1){o=p+1|0;q=c[t>>2]|0;r=c[q+(p*112|0)+4>>2]|0;F=+h[q+(p*112|0)+96>>3];G=+h[q+(p*112|0)+80>>3];E=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+(p<<3)>>3];D=+h[(c[H>>2]|0)+(p<<3)>>3];c[n>>2]=o;c[n+4>>2]=r;r=n+8|0;h[k>>3]=F;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+16|0;h[k>>3]=G;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+24|0;h[k>>3]=E;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+32|0;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];V1(24,0,109008,n);if((o|0)<(c[v>>2]|0)){p=o}else{break}}}Zd[c[17860]&1023](24)}p=b+124|0;if((c[p>>2]|0)>0){V1(24,1,109144,m);if((c[p>>2]|0)>0){m=b+12|0;v=b+4|0;n=b+404|0;H=0;while(1){u=H+1|0;t=c[m>>2]|0;o=c[t+(H*60|0)+4>>2]|0;r=c[t+(H*60|0)+52>>2]|0;t=c[(c[(c[c[v>>2]>>2]|0)+12>>2]|0)+(H<<2)>>2]|0;q=c[(c[n>>2]|0)+(H<<2)>>2]|0;c[l>>2]=u;c[l+4>>2]=o;c[l+8>>2]=r;c[l+12>>2]=t;c[l+16>>2]=q;V1(24,0,109168,l);if((u|0)<(c[p>>2]|0)){H=u}else{break}}}Zd[c[17860]&1023](24)}H=b+128|0;if((c[H>>2]|0)>0){V1(24,1,109216,j);if((c[H>>2]|0)>0){j=b+16|0;p=b+4|0;l=b+408|0;n=0;while(1){v=n+1|0;m=c[j>>2]|0;u=c[m+(n*48|0)+4>>2]|0;q=(a[m+(n*48|0)+42|0]|0)!=0?109288:109296;m=(a[(c[(c[c[p>>2]>>2]|0)+16>>2]|0)+n|0]|0)!=0?109288:109296;t=(a[(c[l>>2]|0)+n|0]|0)!=0?109288:109296;c[g>>2]=v;c[g+4>>2]=u;c[g+8>>2]=q;c[g+12>>2]=m;c[g+16>>2]=t;V1(24,0,109240,g);if((v|0)<(c[H>>2]|0)){n=v}else{break}}}Zd[c[17860]&1023](24)}n=b+132|0;if((c[n>>2]|0)>0){V1(24,1,109304,f);if((c[n>>2]|0)>0){f=b+20|0;H=b+4|0;g=b+412|0;b=0;while(1){l=b+1|0;p=c[f>>2]|0;j=c[p+(b*52|0)+4>>2]|0;v=c[p+(b*52|0)+44>>2]|0;p=c[(c[(c[c[H>>2]>>2]|0)+20>>2]|0)+(b<<2)>>2]|0;t=c[(c[g>>2]|0)+(b<<2)>>2]|0;c[e>>2]=l;c[e+4>>2]=j;c[e+8>>2]=v;c[e+12>>2]=p;c[e+16>>2]=t;V1(24,0,109328,e);if((l|0)<(c[n>>2]|0)){b=l}else{break}}}Zd[c[17860]&1023](24)}Zd[c[17860]&1023](24);i=d;return}function F6(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=b+540|0;B=(c[(c[A>>2]|0)+72>>2]|0)!=0?3:2;V1(9,0,109376,z);if((f|0)==0){n5(b);o5(b);C=6}else{if((a[f]|0)!=0){G6(b,f,g)}n5(b);o5(b);if((a[f]|0)==0){C=6}}if((C|0)==6){ae[c[(c[A>>2]|0)+84>>2]&127](b)|0;ae[c[(c[A>>2]|0)+60>>2]&127](b)|0}do{if((d|0)==0){D=B}else{if((a[d]|0)==0){D=B;break}C=(hxa(d,110864)|0)==0|0;f=(hxa(d,110872)|0)==0;z=(hxa(d,110880)|0)==0;E=z?3:f?2:C;if((E|0)!=0){D=E;break}c[y>>2]=d;X1(1,0,109424,y);X1(1,0,109456,x);c[w>>2]=110864;c[w+4>>2]=110672;X1(1,0,109480,w);c[v>>2]=110872;c[v+4>>2]=110752;X1(1,0,109480,v);c[u>>2]=110880;c[u+4>>2]=110800;X1(1,0,109480,u);Z1(c[b+536>>2]|0,109512,t)}}while(0);do{if((e|0)==0){F=3}else{if((a[e]|0)==0){F=3;break}else{G=1;H=0}do{t=(hxa(e,c[109536+(G<<2)>>2]|0)|0)==0;H=t?G:H;G=G+1|0;}while((G|0)<7);if((H|0)!=0){F=H;break}c[s>>2]=e;X1(1,0,109568,s);X1(1,0,109456,r);t=1;do{u=c[109600+(t<<2)>>2]|0;c[q>>2]=c[109536+(t<<2)>>2];c[q+4>>2]=u;X1(1,0,109480,q);t=t+1|0;}while((t|0)<7);Z1(c[b+536>>2]|0,109512,p)}}while(0);p=c[109496+(D<<2)>>2]|0;c[o>>2]=c[109408+(D<<2)>>2];c[o+4>>2]=p;V1(9,0,109632,o);o=(D|0)==2;if(o){p=c[109600+(F<<2)>>2]|0;c[n>>2]=c[109536+(F<<2)>>2];c[n+4>>2]=p;V1(9,0,109672,n)}n=b+312|0;a[n]=1;p=b+200|0;if((c[p>>2]|0)>0){q=b+468|0;r=0;do{a[(c[q>>2]|0)+(r*80|0)+72|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+196|0;if((c[p>>2]|0)>0){r=b+476|0;q=0;do{a[(c[r>>2]|0)+(q<<6)+56|0]=1;q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+192|0;if((c[p>>2]|0)>0){q=b+484|0;r=0;do{a[(c[q>>2]|0)+(r*40|0)+36|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}do{if((D|0)==1){I=0}else{if(o){I=H6(b,F,j)|0;break}if((D|0)==3){I6(b,j);I=0;break}else{Z1(c[b+536>>2]|0,109712,m)}}}while(0);if((T5(b,1)|0)!=0){J=-2;E6(b);K=15;L=K;M=109736;N=M;V1(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];Y4(b,R,V);W=945;k5(b);X=951;p5(b);Y=946;f5(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=ae[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=pe[ha&63](b,1)|0;ja=954;l5(b);i=k;return J|0}if((L5(b,1)|0)!=0){J=-3;E6(b);K=15;L=K;M=109736;N=M;V1(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];Y4(b,R,V);W=945;k5(b);X=951;p5(b);Y=946;f5(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=ae[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=pe[ha&63](b,1)|0;ja=954;l5(b);i=k;return J|0}m=(B5(b,1)|0)==0;J=m?I:-4;E6(b);K=15;L=K;M=109736;N=M;V1(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];Y4(b,R,V);W=945;k5(b);X=951;p5(b);Y=946;f5(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=ae[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=pe[ha&63](b,1)|0;ja=954;l5(b);i=k;return J|0}function G6(b,d,e){b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+48|0;B=i;i=i+8|0;c[z>>2]=d;C=z+4|0;h[k>>3]=e;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];V1(9,0,110896,z);z=T2(d,A)|0;if((z|0)!=0){C=c[b+536>>2]|0;c[y>>2]=d;c[y+4>>2]=z;Z1(C,110936,y)}V1(9,0,110976,x);x=b+116|0;if((c[x>>2]|0)>0){y=b+8|0;C=0;do{z=U2(A,c[(c[y>>2]|0)+(C*112|0)+4>>2]|0)|0;d=c[y>>2]|0;do{if((z|0)==0){D=L6(c[d+(C*112|0)+4>>2]|0)|0;E=U2(A,D)|0;Kwa(D);D=c[y>>2]|0;if((E|0)!=0){F=D;G=E;H=7;break}E=c[D+(C*112|0)+4>>2]|0;if((ixa(E,111016,6)|0)==0){if((c[70924>>2]|0)==0){break}}else{D=ixa(E,111024,6)|0;if((c[70924>>2]|D|0)==0){break}}c[v>>2]=E;X1(9,0,111032,v)}else{F=d;G=z;H=7}}while(0);if((H|0)==7){H=0;_2(F+(C*112|0)+96|0,A,G,e)|0;z=c[y>>2]|0;I=+h[z+(C*112|0)+96>>3];c[w>>2]=c[z+(C*112|0)+4>>2];z=w+4|0;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];V1(9,0,111e3,w)}C=C+1|0;}while((C|0)<(c[x>>2]|0))}V1(9,0,111088,u);u=b+136|0;if((c[u>>2]|0)>0){C=b+24|0;w=0;do{y=U2(A,c[(c[C>>2]|0)+(w*112|0)+4>>2]|0)|0;G=c[C>>2]|0;do{if((y|0)==0){F=L6(c[G+(w*112|0)+4>>2]|0)|0;v=U2(A,F)|0;Kwa(F);F=c[C>>2]|0;if((v|0)!=0){J=F;K=v;H=17;break}c[s>>2]=c[F+(w*112|0)+4>>2];X1(9,0,111112,s)}else{J=G;K=y;H=17}}while(0);if((H|0)==17){H=0;_2(J+(w*112|0)+96|0,A,K,e)|0;y=c[C>>2]|0;I=+h[y+(w*112|0)+96>>3];c[t>>2]=c[y+(w*112|0)+4>>2];y=t+4|0;h[k>>3]=I;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];V1(9,0,111e3,t)}w=w+1|0;}while((w|0)<(c[u>>2]|0))}V1(9,0,111168,r);r=b+120|0;u=c[r>>2]|0;w=(c[x>>2]|0)-u|0;if((w|0)<(u|0)){u=b+24|0;x=w;do{w=U2(A,c[(c[u>>2]|0)+(x*112|0)+4>>2]|0)|0;t=c[u>>2]|0;do{if((w|0)==0){C=L6(c[t+(x*112|0)+4>>2]|0)|0;K=U2(A,C)|0;Kwa(C);C=c[u>>2]|0;if((K|0)!=0){L=C;M=K;H=24;break}c[p>>2]=c[C+(x*112|0)+4>>2];X1(9,0,111112,p)}else{L=t;M=w;H=24}}while(0);if((H|0)==24){H=0;_2(L+(x*112|0)+96|0,A,M,e)|0;w=c[u>>2]|0;I=+h[w+(x*112|0)+96>>3];c[q>>2]=c[w+(x*112|0)+4>>2];w=q+4|0;h[k>>3]=I;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];V1(9,0,111e3,q)}x=x+1|0;}while((x|0)<(c[r>>2]|0))}V1(9,0,111192,o);o=b+140|0;if((c[o>>2]|0)>0){r=b+28|0;x=0;do{q=U2(A,c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;do{if((q|0)==0){u=L6(c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;M=U2(A,u)|0;Kwa(u);if((M|0)!=0){N=M;H=31;break}c[m>>2]=c[(c[r>>2]|0)+(x*60|0)+4>>2];X1(9,0,111240,m)}else{N=q;H=31}}while(0);if((H|0)==31){H=0;_2(B,A,N,e)|0;q=~~+h[B>>3];M=c[r>>2]|0;c[M+(x*60|0)+52>>2]=q;c[n>>2]=c[M+(x*60|0)+4>>2];c[n+4>>2]=q;V1(9,0,111224,n)}x=x+1|0;}while((x|0)<(c[o>>2]|0))}V1(9,0,111296,l);l=b+144|0;if((c[l>>2]|0)<=0){R2(A);i=f;return}o=b+32|0;b=0;do{x=U2(A,c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;do{if((x|0)==0){n=L6(c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;r=U2(A,n)|0;Kwa(n);if((r|0)!=0){O=r;H=38;break}c[g>>2]=c[(c[o>>2]|0)+(b*48|0)+4>>2];X1(9,0,111344,g)}else{O=x;H=38}}while(0);if((H|0)==38){H=0;_2(B,A,O,e)|0;a[(c[o>>2]|0)+(b*48|0)+42|0]=~~+h[B>>3];x=c[o>>2]|0;r=(a[x+(b*48|0)+42|0]|0)!=0?109288:109296;c[j>>2]=c[x+(b*48|0)+4>>2];c[j+4>>2]=r;V1(9,0,111328,j)}b=b+1|0;}while((b|0)<(c[l>>2]|0));R2(A);i=f;return}function H6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;X4(a,+h[a+240>>3]);k5(a);p5(a);f5(a);r5(a);s6(a);g5(a);k5(a);e=J6(a,b,c)|0;p5(a);f5(a);l5(a);p5(a);i=d;return e|0}function I6(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+4096|0;X4(b,+h[b+240>>3]);k5(b);p5(b);u6(b,0,1)|0;v=b+540|0;w=c[v>>2]|0;if((c[w+76>>2]|0)!=0&(d|0)>1){x=u;u=b+8|0;y=b+116|0;z=Lwa(c[y>>2]|0,8)|0;A=b+124|0;B=Lwa(c[A>>2]|0,4)|0;C=b+128|0;D=Lwa(c[C>>2]|0,1)|0;E=b+132|0;F=Lwa(c[E>>2]|0,4)|0;G=b+536|0;Y1(c[G>>2]|0,(z|0)!=0|0,109768,t);Y1(c[G>>2]|0,(B|0)!=0|0,109768,s);Y1(c[G>>2]|0,(D|0)!=0|0,109768,r);Y1(c[G>>2]|0,(F|0)!=0|0,109768,q);q=c[y>>2]|0;if((q|0)>0){G=c[u>>2]|0;r=0;do{h[z+(r<<3)>>3]=+h[G+(r*112|0)+96>>3];r=r+1|0;}while((r|0)<(q|0))}q=c[A>>2]|0;if((q|0)>0){r=c[b+12>>2]|0;G=0;do{c[B+(G<<2)>>2]=c[r+(G*60|0)+52>>2];G=G+1|0;}while((G|0)<(q|0))}q=c[C>>2]|0;if((q|0)>0){G=c[b+16>>2]|0;r=0;do{a[D+r|0]=a[G+(r*48|0)+42|0]|0;r=r+1|0;}while((r|0)<(q|0))}q=c[E>>2]|0;if((q|0)>0){r=c[b+20>>2]|0;G=0;do{c[F+(G<<2)>>2]=c[r+(G*52|0)+44>>2];G=G+1|0;}while((G|0)<(q|0))}if((c[70924>>2]|0)==0){H=0}else{c[p>>2]=c[b+88>>2];hc(x|0,109784,p|0)|0;p=ic(x|0,109800)|0;c[o>>2]=109816;pd(p|0,109808,o|0)|0;if((c[y>>2]|0)>0){o=u;x=0;do{c[n>>2]=c[(c[o>>2]|0)+(x*112|0)+4>>2];pd(p|0,109808,n|0)|0;x=x+1|0;}while((x|0)<(c[y>>2]|0))}Kd(10,p|0)|0;H=p}V1(9,1,109824,m);a:do{if((d|0)>0){I=+(d+ -1|0);m=b+304|0;p=b+4|0;x=0;do{J=+(x|0)/I;h[m>>3]=J>1.0?1.0:J;ae[c[(c[v>>2]|0)+80>>2]&127](b)|0;n=l;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];V1(9,0,109848,l);if((c[70924>>2]|0)!=0){n=j;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];pd(H|0,109872,j|0)|0;if((c[y>>2]|0)>0){n=0;do{o=g;h[k>>3]=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+(n<<3)>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];pd(H|0,109872,g|0)|0;n=n+1|0;}while((n|0)<(c[y>>2]|0))}Kd(10,H|0)|0}if((T5(b,0)|0)!=0){break a}if((L5(b,0)|0)!=0){break a}if((B5(b,0)|0)!=0){break a}s5(b);x=x+1|0;}while((x|0)<(d|0))}}while(0);Zd[c[17860]&1023](9);if((c[70924>>2]|0)!=0){Wc(H|0)|0}H=c[y>>2]|0;if((H|0)>0){y=c[u>>2]|0;u=0;do{h[y+(u*112|0)+96>>3]=+h[z+(u<<3)>>3];u=u+1|0;}while((u|0)<(H|0))}if((c[A>>2]|0)>0){H=c[b+12>>2]|0;u=0;do{c[H+(u*60|0)+52>>2]=c[B+(u<<2)>>2];u=u+1|0;}while((u|0)<(c[A>>2]|0))}if((c[C>>2]|0)>0){A=b+16|0;u=0;do{a[(c[A>>2]|0)+(u*48|0)+42|0]=a[D+u|0]|0;u=u+1|0;}while((u|0)<(c[C>>2]|0))}C=c[E>>2]|0;if((C|0)>0){E=b+20|0;u=0;do{c[(c[E>>2]|0)+(u*52|0)+44>>2]=c[F+(u<<2)>>2];u=u+1|0;}while((u|0)<(C|0))}Kwa(z);Kwa(B);Kwa(D);Kwa(F)}else{h[b+304>>3]=1.0;ae[c[w+80>>2]&127](b)|0}h5(b);if((u6(b,1,1)|0)!=1){i=e;return}ae[c[(c[v>>2]|0)+80>>2]&127](b)|0;h5(b);if((u6(b,1,1)|0)!=1){i=e;return}X1(1,0,109880,f);i=e;return}function J6(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=M6(b)|0;w=v;x=c[w>>2]|0;if((x|0)==0){V1(9,0,109984,u);if((c[b+184>>2]|0)==0){pe[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0}Kwa(v);y=0;i=f;return y|0}u=b+184|0;z=c[u>>2]|0;if((z|0)==0){V1(9,0,110016,t);pe[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0;Kwa(v);y=0;i=f;return y|0}do{if((c[v+16>>2]|0)<(x|0)){V1(9,1,110088,s);t=Jwa(c[w>>2]<<3)|0;A=v+40|0;B=c[A>>2]|0;c[A>>2]=0;C=+C6(v,1.0);c[A>>2]=B;D=c[w>>2]|0;if((D|0)>0){E=v+24|0;F=c[E>>2]|0;G=0;while(1){H=F+(G<<3)|0;h[H>>3]=+h[H>>3]+1.0e-6;c[A>>2]=0;h[t+(G<<3)>>3]=+U(+(+C6(v,1.0)-C))/1.0e-6;c[A>>2]=B;H=c[E>>2]|0;I=H+(G<<3)|0;h[I>>3]=+h[I>>3]+-1.0e-6;I=G+1|0;J=c[w>>2]|0;if((I|0)<(J|0)){G=I;F=H}else{K=J;break}}}else{K=D}F=c[u>>2]|0;if((F|0)>0){G=(K|0)>1;E=0;do{if(G){B=1;A=0;while(1){J=+h[t+(B<<3)>>3]>+h[t+(A<<3)>>3]?B:A;H=B+1|0;if((H|0)<(K|0)){A=J;B=H}else{L=J;break}}}else{L=0}h[t+(L<<3)>>3]=-1.0;E=E+1|0;}while((E|0)<(F|0))}V1(9,1,110112,r);F=b+112|0;E=c[F>>2]|0;if((E|0)>0){G=b+8|0;D=v+44|0;B=v+24|0;A=E;E=0;J=0;while(1){H=(c[G>>2]|0)+(E*112|0)+72|0;if((a[H]|0)==0){if(!(+h[t+(J<<3)>>3]>=0.0)){M=A}else{a[H]=1;C=+h[(c[B>>2]|0)+(J<<3)>>3];c[q>>2]=c[(c[D>>2]|0)+(J<<2)>>2];H=q+4|0;h[k>>3]=C;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];V1(9,0,110136,q);M=c[F>>2]|0}N=M;O=J+1|0}else{N=A;O=J}H=E+1|0;if((H|0)<(N|0)){A=N;E=H;J=O}else{P=O;break}}}else{P=0}J=b+136|0;if((c[J>>2]|0)>0){E=b+24|0;A=v+44|0;F=v+24|0;D=b+116|0;B=b+120|0;G=0;H=P;while(1){I=(c[E>>2]|0)+(G*112|0)+72|0;if((a[I]|0)==0){if(+h[t+(H<<3)>>3]>=0.0){a[I]=1;C=+h[(c[F>>2]|0)+(H<<3)>>3];c[p>>2]=c[(c[A>>2]|0)+(H<<2)>>2];I=p+4|0;h[k>>3]=C;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];V1(9,0,110136,p)}Q=H+1|0}else{Q=H}I=c[B>>2]|0;R=(c[D>>2]|0)-I|0;if((R|0)<(I|0)){S=I;I=R;T=Q;while(1){V=(c[E>>2]|0)+(I*112|0)+72|0;if((a[V]|0)==0){if(!(+h[t+(T<<3)>>3]>=0.0)){W=S}else{a[V]=1;C=+h[(c[F>>2]|0)+(T<<3)>>3];c[o>>2]=c[(c[A>>2]|0)+(T<<2)>>2];V=o+4|0;h[k>>3]=C;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];V1(9,0,110136,o);W=c[B>>2]|0}X=W;Y=T+1|0}else{X=S;Y=T}V=I+1|0;if((V|0)<(X|0)){S=X;I=V;T=Y}else{Z=V;_=Y;break}}}else{Z=R;_=Q}T=Z+1|0;if((T|0)<(c[J>>2]|0)){G=T;H=_}else{break}}}if((c[70924>>2]|0)!=0){Zd[c[17860]&1023](9);Zd[c[17860]&1023](9)}Kwa(t);N6(v);H=M6(b)|0;if((c[H>>2]|0)!=0){$=H;break}V1(9,0,110160,n);Kwa(H);y=0;i=f;return y|0}else{if((z|0)<=(x|0)){$=v;break}V1(9,0,110192,m);$=v}}while(0);do{if((d|0)==3|(d|0)==5){V1(9,0,110208,l);K6($,d,1,e);D6(b,$);v=c[$>>2]|0;if((v|0)<=0){break}m=c[$+24>>2]|0;x=c[$+28>>2]|0;z=0;do{h[x+(z<<3)>>3]=+h[m+(z<<3)>>3];z=z+1|0;}while((z|0)<(v|0))}}while(0);if(+C6($,1.0)>1.0e-9){l=$+40|0;v=c[l>>2]|0;if((v|0)!=0){Kwa(v);c[l>>2]=0}l=$+52|0;v=c[l>>2]|0;if((v|0)!=0){Kwa(v);c[l>>2]=0}l=$+56|0;v=c[l>>2]|0;if((v|0)!=0){Kwa(v);c[l>>2]=0}K6($,d,0,e);D6(b,$);+C6($,1.0)}else{V1(9,0,110232,j)}V1(9,1,110256,g);D6(b,$);b=B6($)|0;if((c[70924>>2]|0)!=0){Zd[c[17860]&1023](9)}N6($);y=b;i=f;return y|0}function K6(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=c[a+60>>2]|0;h[n>>3]=0.0;p=a;q=Jwa(c[p>>2]<<3)|0;r=q;s=+C6(a,1.0);t=c[p>>2]|0;if((t|0)>0){u=c[a+28>>2]|0;v=c[a+24>>2]|0;w=0;do{x=+h[u+(w<<3)>>3];h[v+(w<<3)>>3]=x;h[q+(w<<3)>>3]=x;w=w+1|0;}while((w|0)<(t|0))}if(!(s>1.0e-12)){y=1;P6(a,r);Kwa(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=110384;F=E;V1(9,0,F,g);i=f;return}t=(d|0)==0;d=a+24|0;x=s;w=1;a:while(1){c[m>>2]=w;V1(9,0,110296,m);if(!t){O6(a)}switch(b|0){case 5:{G=13;break a;break};case 4:{G=12;break a;break};case 3:{H=Y6(a,n,e)|0;break};case 1:{H=W6(a)|0;break};case 6:{G=14;break a;break};case 2:{H=U6(a)|0;break};default:{G=15;break a}}p5(o);f5(o);l5(o);p5(o);s=+C6(a,1.0);v=(H|0)>-1;if(v&s<x){u=c[p>>2]|0;if((u|0)>0){I=c[d>>2]|0;J=0;do{h[q+(J<<3)>>3]=+h[I+(J<<3)>>3];J=J+1|0;}while((J|0)<(u|0))}V1(9,0,110344,k);D6(o,a);K=s}else{V1(9,0,110360,j);if(v&s==x){y=w;G=23;break}else{K=x}}u=w+1|0;if((u|0)<201&s>1.0e-12){x=K;w=u}else{y=u;G=23;break}}if((G|0)==12){T6(a)|0}else if((G|0)==13){T6(a)|0}else if((G|0)==14){S6(o,a,0)|0}else if((G|0)==15){Z1(c[o+536>>2]|0,110320,l)}else if((G|0)==23){P6(a,r);Kwa(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=110384;F=E;V1(9,0,F,g);i=f;return}}function L6(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=i;d=lxa(b|0)|0;do{if((d|0)==0){e=Jwa(1)|0;f=0}else{g=0;h=0;j=d;while(1){k=a[b+g|0]|0;if(k<<24>>24==93){l=h+ -1|0}else if(k<<24>>24==91){l=h+1|0}else{l=h}if((l|0)!=0&k<<24>>24==44){m=((a[b+(g+1)|0]|0)!=32)+j|0}else{m=j}k=g+1|0;if(k>>>0<d>>>0){g=k;h=l;j=m}else{break}}j=Jwa(m+1|0)|0;if((m|0)==0){e=j;f=0;break}else{n=0;o=0;p=l}while(1){h=a[b+o|0]|0;if(h<<24>>24==91){q=p+1|0}else if(h<<24>>24==93){q=p+ -1|0}else{q=p}a[j+n|0]=h;do{if((q|0)!=0&h<<24>>24==44){if((a[b+(o+1)|0]|0)==32){r=n;break}g=n+1|0;a[j+g|0]=32;r=g}else{r=n}}while(0);h=r+1|0;if(h>>>0<m>>>0){n=h;o=o+1|0;p=q}else{e=j;f=m;break}}}}while(0);a[e+f|0]=0;if((gxa(e,111400,4)|0)!=0){i=c;return e|0}m=f>>>0>3;q=e+4|0;while(1){a:do{if(m){p=f;while(1){o=p+ -1|0;if((a[e+p|0]|0)==46){s=p;break a}if(o>>>0>3){p=o}else{s=o;break}}}else{s=f}}while(0);if((s|0)==3){t=24;break}p=s+ -3|0;nxa(e|0,q|0,p|0)|0;o=e+p|0;a[o]=678585700;a[o+1|0]=2650725;a[o+2|0]=10354;a[o+3|0]=40;if((gxa(e,111400,4)|0)!=0){t=24;break}}if((t|0)==24){i=c;return e|0}return 0}function M6(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+32|0;o=i;i=i+32|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=Jwa(64)|0;z=y;Y1(0,(y|0)!=0|0,111408,x);x=y+4|0;A=y+8|0;B=y+12|0;C=y+16|0;D=y+20|0;E=y+24|0;F=y+28|0;G=y+32|0;H=y+36|0;I=y+40|0;J=y+44|0;K=y+48|0;L=y+52|0;M=y+56|0;N=y+60|0;O=y+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));c[N>>2]=b;N=b+8|0;O=b+112|0;P=c[O>>2]|0;if((P|0)>0){Q=c[N>>2]|0;R=0;S=0;while(1){if((a[Q+(S*112|0)+72|0]|0)==0){T=R+1|0;c[x>>2]=T;V=T}else{V=R}T=S+1|0;if((T|0)<(P|0)){R=V;S=T}else{W=V;break}}}else{W=0}V=b+136|0;S=c[V>>2]|0;if((S|0)>0){R=c[b+24>>2]|0;P=0;x=0;while(1){if((a[R+(x*112|0)+72|0]|0)==0){Q=P+1|0;c[A>>2]=Q;X=Q}else{X=P}Q=x+1|0;if((Q|0)<(S|0)){P=X;x=Q}else{Y=X;break}}}else{Y=0}X=b+116|0;x=b+120|0;P=c[x>>2]|0;if((P|0)>0){S=c[X>>2]|0;A=c[N>>2]|0;R=0;Q=S-P|0;while(1){if((a[A+(Q*112|0)+72|0]|0)==0){P=R+1|0;c[B>>2]=P;Z=P}else{Z=R}P=Q+1|0;if((P|0)<(S|0)){R=Z;Q=P}else{_=Z;break}}}else{_=0}Z=Y+W+_|0;c[y>>2]=Z;if((Z|0)==0){i=d;return z|0}y=Lwa(Z,8)|0;c[E>>2]=y;Y1(0,(y|0)!=0|0,111408,w);w=Lwa(Z,8)|0;c[F>>2]=w;Y1(0,(w|0)!=0|0,111408,v);v=Lwa(Z,8)|0;c[G>>2]=v;Y1(0,(v|0)!=0|0,111408,u);u=Lwa(Z,8)|0;c[H>>2]=u;Y1(0,(u|0)!=0|0,111408,t);t=Lwa(Z,8)|0;c[I>>2]=t;Y1(0,(t|0)!=0|0,111408,s);s=Lwa(Z,4)|0;t=s;c[J>>2]=t;Y1(0,(s|0)!=0|0,111408,r);V1(9,0,111424,q);c[p>>2]=Z;c[p+4>>2]=W;c[p+8>>2]=Y;c[p+12>>2]=_;V1(9,0,111448,p);p=c[O>>2]|0;if((p|0)>0){_=N;Y=p;p=t;W=0;Z=0;while(1){q=c[_>>2]|0;if((a[q+(W*112|0)+72|0]|0)==0){c[p+(Z<<2)>>2]=c[q+(W*112|0)+4>>2];q=c[_>>2]|0;do{if((a[q+(W*112|0)+73|0]|0)==0){$=(c[I>>2]|0)+(Z<<3)|0;aa=1.0}else{ba=+h[q+(W*112|0)+80>>3];ca=+U(+ba);r=(c[I>>2]|0)+(Z<<3)|0;if(!(ba==0.0)){$=r;aa=ca;break}$=r;aa=1.0}}while(0);h[$>>3]=aa;r=q+(W*112|0)+96|0;s=(c[E>>2]|0)+(Z<<3)|0;h[s>>3]=+h[r>>3];u=(c[F>>2]|0)+(Z<<3)|0;h[u>>3]=+h[r>>3];h[(c[G>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+56>>3];h[(c[H>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+64>>3];r=Z+1|0;v=c[J>>2]|0;w=c[v+(Z<<2)>>2]|0;ca=+h[u>>3];ba=+h[$>>3];da=+h[s>>3];c[o>>2]=r;c[o+4>>2]=w;w=o+8|0;h[k>>3]=ca;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+16|0;h[k>>3]=ba;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+24|0;h[k>>3]=da;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];V1(9,0,111536,o);ea=c[O>>2]|0;fa=v;ga=r}else{ea=Y;fa=p;ga=Z}r=W+1|0;if((r|0)<(ea|0)){Y=ea;p=fa;W=r;Z=ga}else{ha=fa;ia=ga;break}}}else{ha=t;ia=0}t=c[V>>2]|0;if((t|0)>0){ga=b+24|0;fa=t;t=ha;Z=0;W=ia;while(1){p=c[ga>>2]|0;if((a[p+(Z*112|0)+72|0]|0)==0){c[t+(W<<2)>>2]=c[p+(Z*112|0)+4>>2];p=c[ga>>2]|0;aa=+h[p+(Z*112|0)+80>>3];da=+U(+aa);ea=(c[I>>2]|0)+(W<<3)|0;h[ea>>3]=aa==0.0?1.0:da;Y=p+(Z*112|0)+96|0;O=(c[E>>2]|0)+(W<<3)|0;h[O>>3]=+h[Y>>3];o=(c[F>>2]|0)+(W<<3)|0;h[o>>3]=+h[Y>>3];h[(c[G>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+56>>3];h[(c[H>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+64>>3];p=W+1|0;Y=c[J>>2]|0;$=c[Y+(W<<2)>>2]|0;da=+h[o>>3];aa=+h[ea>>3];ba=+h[O>>3];c[n>>2]=p;c[n+4>>2]=$;$=n+8|0;h[k>>3]=da;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+16|0;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+24|0;h[k>>3]=ba;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];V1(9,0,111584,n);ja=c[V>>2]|0;ka=Y;la=p}else{ja=fa;ka=t;la=W}p=Z+1|0;if((p|0)<(ja|0)){fa=ja;t=ka;Z=p;W=la}else{ma=ka;na=la;break}}}else{ma=ha;na=ia}ia=c[x>>2]|0;if((ia|0)>0){ha=c[X>>2]|0;la=N;ka=ha;W=ma;ma=ha-ia|0;ia=na;while(1){na=c[la>>2]|0;if((a[na+(ma*112|0)+72|0]|0)==0){c[W+(ia<<2)>>2]=c[na+(ma*112|0)+4>>2];na=c[la>>2]|0;do{if((a[na+(ma*112|0)+73|0]|0)==0){oa=(c[I>>2]|0)+(ia<<3)|0;pa=1.0}else{ba=+h[na+(ma*112|0)+80>>3];aa=+U(+ba);ha=(c[I>>2]|0)+(ia<<3)|0;if(!(ba==0.0)){oa=ha;pa=aa;break}oa=ha;pa=1.0}}while(0);h[oa>>3]=pa;q=na+(ma*112|0)+96|0;ha=(c[E>>2]|0)+(ia<<3)|0;h[ha>>3]=+h[q>>3];Z=(c[F>>2]|0)+(ia<<3)|0;h[Z>>3]=+h[q>>3];h[(c[G>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+56>>3];h[(c[H>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+64>>3];q=ia+1|0;t=c[J>>2]|0;ja=c[t+(ia<<2)>>2]|0;aa=+h[Z>>3];ba=+h[oa>>3];da=+h[ha>>3];c[m>>2]=q;c[m+4>>2]=ja;ja=m+8|0;h[k>>3]=aa;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+16|0;h[k>>3]=ba;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+24|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];V1(9,0,111640,m);qa=c[X>>2]|0;ra=t;sa=q}else{qa=ka;ra=W;sa=ia}q=ma+1|0;if((q|0)<(qa|0)){ka=qa;W=ra;ma=q;ia=sa}else{break}}}sa=c[b+184>>2]|0;c[C>>2]=sa;c[D>>2]=0;C=c[X>>2]|0;if((C|0)>0){X=c[N>>2]|0;ia=0;ma=0;while(1){if((a[X+(ma*112|0)+88|0]|0)==0){ta=ia}else{ra=ia+1|0;c[D>>2]=ra;ta=ra}ra=ma+1|0;if((ra|0)<(C|0)){ia=ta;ma=ra}else{ua=ta;break}}}else{ua=0}ta=c[V>>2]|0;if((ta|0)>0){V=c[b+24>>2]|0;ma=ua;ia=0;while(1){do{if((a[V+(ia*112|0)+88|0]|0)==0){va=ma}else{if((a[V+(ia*112|0)+72|0]|0)!=0){va=ma;break}X=ma+1|0;c[D>>2]=X;va=X}}while(0);na=ia+1|0;if((na|0)<(ta|0)){ma=va;ia=na}else{wa=va;break}}}else{wa=ua}ua=c[x>>2]|0;if((ua|0)>0){x=c[N>>2]|0;N=wa;va=C-ua|0;while(1){do{if((a[x+(va*112|0)+88|0]|0)==0){xa=N}else{if((a[x+(va*112|0)+72|0]|0)!=0){xa=N;break}ua=N+1|0;c[D>>2]=ua;xa=ua}}while(0);ua=va+1|0;if((ua|0)<(C|0)){N=xa;va=ua}else{ya=xa;break}}}else{ya=wa}wa=c[b+176>>2]|0;xa=c[b+180>>2]|0;c[l>>2]=sa;c[l+4>>2]=wa;c[l+8>>2]=xa;V1(9,0,111696,l);c[j>>2]=ya;V1(9,0,111768,j);j=Lwa(sa,8)|0;c[K>>2]=j;Y1(0,(j|0)!=0|0,111408,g);g=Jwa(sa<<3)|0;c[L>>2]=g;Y1(0,(g|0)!=0|0,111408,f);f=Jwa(ya<<3)|0;c[M>>2]=f;Y1(0,(f|0)!=0|0,111408,e);if((sa|0)>0){e=0;do{h[g+(e<<3)>>3]=1.0;e=e+1|0;}while((e|0)<(sa|0))}if((ya|0)>0){za=0}else{i=d;return z|0}do{h[f+(za<<3)>>3]=1.0;za=za+1|0;}while((za|0)<(ya|0));i=d;return z|0}function N6(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;if((d|0)!=0){Kwa(d)}d=c[a+28>>2]|0;if((d|0)!=0){Kwa(d)}d=c[a+32>>2]|0;if((d|0)!=0){Kwa(d)}d=c[a+36>>2]|0;if((d|0)!=0){Kwa(d)}d=c[a+40>>2]|0;if((d|0)!=0){Kwa(d)}d=c[a+44>>2]|0;if((d|0)!=0){Kwa(d)}d=c[a+48>>2]|0;if((d|0)!=0){Kwa(d)}d=c[a+52>>2]|0;if((d|0)!=0){Kwa(d)}d=c[a+56>>2]|0;if((d|0)==0){e=a;Kwa(e);i=b;return}Kwa(d);e=a;Kwa(e);i=b;return}function O6(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0,W=0;d=i;i=i+8|0;e=d;f=c[b+60>>2]|0;g=b+40|0;if((c[g>>2]|0)==0){i=d;return}j=b+52|0;k=c[j>>2]|0;if((k|0)==0){i=d;return}l=b+56|0;m=c[l>>2]|0;if((m|0)==0){i=d;return}n=b+16|0;o=c[n>>2]|0;p=Lwa(o,8)|0;q=Lwa(o,8)|0;r=b+20|0;s=c[r>>2]|0;t=Lwa(s,8)|0;u=Lwa(s,8)|0;v=Lwa(o,8)|0;w=Lwa(s,8)|0;if((o|0)>0){x=0;do{h[k+(x<<3)>>3]=1.0;x=x+1|0;}while((x|0)<(o|0))}if((s|0)>0){o=0;do{h[m+(o<<3)>>3]=1.0;o=o+1|0;}while((o|0)<(s|0))}+C6(b,1.0);s=c[n>>2]|0;if((s|0)>0){nxa(p|0,c[b+48>>2]|0,((s|0)>1?s<<3:8)|0)|0}o=f+8|0;m=f+116|0;x=c[m>>2]|0;if((x|0)>0){k=c[o>>2]|0;y=f+4|0;z=0;A=0;while(1){if((a[k+(z*112|0)+88|0]|0)==0){B=A}else{h[t+(A<<3)>>3]=+h[k+(z*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];B=A+1|0}C=z+1|0;if((C|0)<(x|0)){z=C;A=B}else{D=B;break}}}else{D=0}B=f+136|0;A=c[B>>2]|0;if((A|0)>0){z=c[f+24>>2]|0;y=f+4|0;k=0;C=D;while(1){do{if((a[z+(k*112|0)+88|0]|0)==0){E=C}else{if((a[z+(k*112|0)+72|0]|0)!=0){E=C;break}h[t+(C<<3)>>3]=+h[z+(k*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3];E=C+1|0}}while(0);F=k+1|0;if((F|0)<(A|0)){k=F;C=E}else{G=E;break}}}else{G=D}D=f+120|0;E=c[D>>2]|0;if((E|0)>0){C=c[o>>2]|0;k=f+4|0;A=x-E|0;E=G;while(1){do{if((a[C+(A*112|0)+88|0]|0)==0){H=E}else{if((a[C+(A*112|0)+72|0]|0)!=0){H=E;break}h[t+(E<<3)>>3]=+h[C+(A*112|0)+96>>3]- +h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];H=E+1|0}}while(0);G=A+1|0;if((G|0)<(x|0)){A=G;E=H}else{break}}}H=b;if((c[H>>2]|0)>0){E=b+24|0;A=o;o=f+4|0;x=f+24|0;f=b+48|0;k=c[E>>2]|0;C=0;while(1){G=k+(C<<3)|0;h[G>>3]=+h[G>>3]+1.0e-6;+C6(b,1.0);G=c[n>>2]|0;y=(G|0)>0;if(y){nxa(q|0,c[f>>2]|0,((G|0)>1?G<<3:8)|0)|0}z=c[m>>2]|0;if((z|0)>0){F=c[A>>2]|0;I=0;J=0;while(1){if((a[F+(J*112|0)+88|0]|0)==0){K=I}else{h[u+(I<<3)>>3]=+h[F+(J*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(J<<3)>>3];K=I+1|0}L=J+1|0;if((L|0)<(z|0)){I=K;J=L}else{M=K;break}}}else{M=0}J=c[B>>2]|0;if((J|0)>0){I=c[x>>2]|0;F=M;L=0;while(1){do{if((a[I+(L*112|0)+88|0]|0)==0){N=F}else{if((a[I+(L*112|0)+72|0]|0)!=0){N=F;break}h[u+(F<<3)>>3]=+h[I+(L*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(L<<3)>>3];N=F+1|0}}while(0);O=L+1|0;if((O|0)<(J|0)){F=N;L=O}else{P=N;break}}}else{P=M}L=c[D>>2]|0;if((L|0)>0){F=c[A>>2]|0;J=P;I=z-L|0;while(1){do{if((a[F+(I*112|0)+88|0]|0)==0){Q=J}else{if((a[F+(I*112|0)+72|0]|0)!=0){Q=J;break}h[u+(J<<3)>>3]=+h[F+(I*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(I<<3)>>3];Q=J+1|0}}while(0);L=I+1|0;if((L|0)<(z|0)){J=Q;I=L}else{break}}}if(y){R=+h[(c[g>>2]|0)+(C<<3)>>3];I=0;do{S=+U(+(R*(+h[q+(I<<3)>>3]- +h[p+(I<<3)>>3])/1.0e-6));J=v+(I<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}I=I+1|0;}while((I|0)<(G|0))}I=c[r>>2]|0;if((I|0)>0){R=+h[(c[g>>2]|0)+(C<<3)>>3];y=0;do{S=+U(+(R*(+h[u+(y<<3)>>3]- +h[t+(y<<3)>>3])/1.0e-6));J=w+(y<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}y=y+1|0;}while((y|0)<(I|0))}I=c[E>>2]|0;y=I+(C<<3)|0;h[y>>3]=+h[y>>3]+-1.0e-6;y=C+1|0;if((y|0)<(c[H>>2]|0)){k=I;C=y}else{T=G;break}}}else{T=s}if((T|0)>0){s=T;T=0;while(1){R=+h[v+(T<<3)>>3];C=(c[j>>2]|0)+(T<<3)|0;if(R<1.0e-42){h[C>>3]=1.0;k=T+1|0;c[e>>2]=k;V1(9,0,111808,e);V=k;W=c[n>>2]|0}else{h[C>>3]=R;V=T+1|0;W=s}if((V|0)<(W|0)){s=W;T=V}else{break}}}V=c[r>>2]|0;if((V|0)>0){r=c[l>>2]|0;l=0;do{R=+h[w+(l<<3)>>3];h[r+(l<<3)>>3]=R<1.0e-42?1.0:R;l=l+1|0;}while((l|0)<(V|0))}Kwa(p);Kwa(q);Kwa(t);Kwa(u);Kwa(v);Kwa(w);i=d;return}function P6(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+24>>2]|0;a=0;do{h[f+(a<<3)>>3]=+h[b+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=d;return}function Q6(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+40>>2]|0;g=(f|0)==0;j=c[a+24>>2]|0;a=0;do{k=+h[b+(a<<3)>>3];if(g){l=k}else{l=k*+h[f+(a<<3)>>3]}h[j+(a<<3)>>3]=l;a=a+1|0;}while((a|0)<(e|0));i=d;return}function R6(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=c[b+60>>2]|0;f=c[e+112>>2]|0;if((f|0)>0){g=b+24|0;j=c[e+8>>2]|0;k=0;l=0;while(1){if((a[j+(k*112|0)+72|0]|0)==0){h[(c[(c[c[e+4>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3]=+h[(c[g>>2]|0)+(l<<3)>>3];m=l+1|0}else{m=l}n=k+1|0;if((n|0)<(f|0)){k=n;l=m}else{o=m;break}}}else{o=0}m=c[e+136>>2]|0;if((m|0)>0){l=b+24|0;k=c[e+24>>2]|0;f=0;g=o;while(1){if((a[k+(f*112|0)+72|0]|0)==0){h[(c[e+416>>2]|0)+(f<<3)>>3]=+h[(c[l>>2]|0)+(g<<3)>>3];p=g+1|0}else{p=g}j=f+1|0;if((j|0)<(m|0)){f=j;g=p}else{q=p;break}}}else{q=o}o=c[e+116>>2]|0;p=c[e+120>>2]|0;if((p|0)<=0){i=d;return}g=b+24|0;b=c[e+8>>2]|0;f=o-p|0;p=q;while(1){if((a[b+(f*112|0)+72|0]|0)==0){h[(c[e+400>>2]|0)+(f<<3)>>3]=+h[(c[g>>2]|0)+(p<<3)>>3];r=p+1|0}else{r=p}q=f+1|0;if((q|0)<(o|0)){f=q;p=r}else{break}}i=d;return}function S6(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+8|0;Z1(c[a+536>>2]|0,111880,d);return 0}function T6(a){a=a|0;a=i;i=i+8|0;Z1(0,111912,a);return 0}function U6(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;c[d>>2]=(c[70924>>2]|0)!=0?1e3:0;k=a;l=c[k>>2]|0;c[e>>2]=l*1e3;h[f>>3]=1.0e-12;h[g>>3]=10.0;m=l<<1|1;c[j>>2]=m;n=Lwa((fa(m+13|0,m+l|0)|0)+((fa(l*3|0,l+3|0)|0)/2|0)|0,8)|0;Y1(0,(n|0)!=0|0,111952,b);c[27992]=c[a+60>>2];c[27994]=c[a+48>>2];x4(k,j,c[a+24>>2]|0,g,f,d,e,n,7)|0;Kwa(n);c[27992]=0;c[27994]=0;n=B6(a)|0;i=b;return n|0}function V6(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[27994];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[27992];h[d>>3]=+C6(f,1.0);i=e;return}function W6(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;h[o>>3]=0.0;h[p>>3]=0.0;h[q>>3]=0.0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;w=a;x=c[w>>2]<<3;y=Jwa(x)|0;z=y;A=Jwa(x)|0;x=A;Y1(0,(y|0)!=0|0,111984,n);Y1(0,(A|0)!=0|0,111984,m);m=c[w>>2]|0;if((m|0)>0){n=c[a+24>>2]|0;B=0;do{C=+h[n+(B<<3)>>3];if(C!=0.0){D=+U(+C)/1.0e3}else{D=1.0}h[y+(B<<3)>>3]=D;h[A+(B<<3)>>3]=0.0;B=B+1|0;}while((B|0)<(m|0))}B=m*1e3|0;c[v>>2]=B;if((c[70924>>2]|0)==0){E=-1}else{E=(B|0)/10|0}c[r>>2]=E;h[p>>3]=1.0e-12;c[s>>2]=m;c[t>>2]=0;h[q>>3]=1.0e-12;D=+C6(a,1.0);h[o>>3]=D;if(D!=0.0){c[28e3]=c[a+60>>2];c[28002]=c[a+48>>2];u4(c[a+24>>2]|0,z,w,o,v,r,p,s,t,q,x,8,u)|0;c[28e3]=0;c[28002]=0}else{x=l;h[k>>3]=D;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];V1(9,0,112016,l)}D=+C6(a,1.0);h[o>>3]=D;l=j;h[k>>3]=D;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];V1(9,0,112120,j);j=c[u>>2]|0;do{if((j|0)==3){X1(9,0,112280,e);F=-3;i=b;return F|0}else if((j|0)==4){X1(9,0,112352,d);F=-4;i=b;return F|0}else if((j|0)==1){if(!(+h[q>>3]<+h[o>>3])){break}c[g>>2]=c[v>>2];X1(9,0,112136,g);F=-1;i=b;return F|0}else if((j|0)==2){X1(9,0,112216,f);F=-2;i=b;return F|0}}while(0);F=B6(a)|0;i=b;return F|0}function X6(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[28002];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[28e3];h[d>>3]=+C6(f,1.0);i=e;return}function Y6(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=fa(d*1e3|0,c[a>>2]|0)|0;c[j>>2]=0;V1(9,1,112408,g);if((c[70924>>2]|0)==0){l=0}else{l=(k|0)/10|0}Z6(a,d,k,l,b,j);c[f>>2]=c[j>>2];V1(9,0,112432,f);Zd[c[17860]&1023](9);if(+h[b>>3]<1.0){m=-1;i=e;return m|0}b=B6(a)|0;if((b|0)==0){m=0;i=e;return m|0}X1(9,0,112448,e);m=b;i=e;return m|0}function Z6(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0;j=i;i=i+8|0;l=j;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+24|0;v=i;i=i+32|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+4096|0;K=a;L=c[K>>2]|0;M=L+1|0;N=L<<3;O=Jwa(fa(N,M)|0)|0;P=Jwa(M<<3)|0;Q=Jwa(N)|0;R=Q;S=Jwa(N)|0;T=S;V=Jwa(N)|0;W=V;X=Jwa(N)|0;Y=+h[f>>3];if((c[70924>>2]|0)!=0&Y<1.0){N=J;c[I>>2]=c[(c[a+60>>2]|0)+88>>2];hc(N|0,112496,I|0)|0;I=ic(N|0,112512)|0;c[H>>2]=112528;pd(I|0,112520,H|0)|0;c[G>>2]=112544;pd(I|0,112520,G|0)|0;if((c[K>>2]|0)>0){G=a+44|0;H=0;do{c[F>>2]=c[(c[G>>2]|0)+(H<<2)>>2];pd(I|0,112520,F|0)|0;H=H+1|0;}while((H|0)<(c[K>>2]|0))}Kd(10,I|0)|0;c[E>>2]=0;pd(I|0,112552,E|0)|0;E=D;h[k>>3]=Y;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];pd(I|0,112560,D|0)|0;if((c[K>>2]|0)>0){D=a+24|0;E=0;do{H=C;h[k>>3]=+h[(c[D>>2]|0)+(E<<3)>>3];c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];pd(I|0,112560,C|0)|0;E=E+1|0;}while((E|0)<(c[K>>2]|0))}Kd(10,I|0)|0;Z=I}else{Z=0}Y1(0,(O|0)!=0|0,112568,B);Y1(0,(P|0)!=0|0,112568,A);Y1(0,(Q|0)!=0|0,112568,z);Y1(0,(S|0)!=0|0,112568,y);Y1(0,(V|0)!=0|0,112568,x);Y1(0,(X|0)!=0|0,112568,w);w=c[a+40>>2]|0;x=(L|0)>0;do{if((w|0)==0){if(!x){_=0;break}y=a+24|0;z=0;while(1){A=(c[y>>2]|0)+(z<<3)|0;B=0;do{h[O+((fa(B,L)|0)+z<<3)>>3]=+h[A>>3];B=B+1|0;}while((B|0)<(M|0));B=z+1|0;if((B|0)<(L|0)){z=B}else{$=14;break}}}else{if(!x){_=0;break}z=c[a+24>>2]|0;y=0;while(1){aa=+h[z+(y<<3)>>3]/+h[w+(y<<3)>>3];B=0;do{h[O+((fa(B,L)|0)+y<<3)>>3]=aa;B=B+1|0;}while((B|0)<(M|0));B=y+1|0;if((B|0)<(L|0)){y=B}else{$=14;break}}}}while(0);do{if(($|0)==14){w=(L|0)>0;if(w){ba=0}else{_=0;break}while(1){x=O+((fa(ba,L)|0)+ba<<3)|0;h[x>>3]=+h[x>>3]+1.0;x=ba+1|0;if((x|0)<(L|0)){ba=x}else{_=w;break}}}}while(0);ba=(L|0)>-1;w=a+16|0;aa=+(M|0);ca=+(L|0);x=(e|0)==0;y=a+48|0;da=1.0/+(b+ -1|0);b=(Z|0)==0;z=a+24|0;B=L<<3;ea=0.0;A=0;ga=Y;a:while(1){I=!(ga>=1.0);E=ga<1.0;ha=ea;C=A;b:while(1){D=C;c:while(1){ia=D+1|0;if(ba){H=0;do{Q6(a,O+((fa(H,L)|0)<<3)|0);h[P+(H<<3)>>3]=+C6(a,ga);H=H+1|0;}while((H|0)<(M|0))}if(_){H=1;F=0;while(1){G=+h[P+(H<<3)>>3]<+h[P+(F<<3)>>3]?H:F;N=H+1|0;if((N|0)<(M|0)){F=G;H=N}else{ja=G;break}}}else{ja=0}ka=fa(ja,L)|0;la=O+(ka<<3)|0;Q6(a,la);+C6(a,ga);H=c[w>>2]|0;if((H|0)>0){F=c[y>>2]|0;Y=0.0;G=0;do{ma=+U(+(+h[F+(G<<3)>>3]));Y=ma>Y?ma:Y;G=G+1|0;}while((G|0)<(H|0));na=!(Y<1.0e-12)}else{na=0}if(!((na|I)&(D|0)<(d|0))){break a}do{if(ba){H=0;G=ja;F=ja;while(1){ma=+h[P+(H<<3)>>3];N=ma>+h[P+(G<<3)>>3];oa=N?H:G;J=N?G:F;pa=!(ma>+h[P+(J<<3)>>3])|(H|0)==(oa|0)?J:H;J=H+1|0;if((J|0)<(M|0)){F=pa;G=oa;H=J}else{break}}if(ba){qa=0.0;ra=0}else{sa=0.0;ta=oa;ua=pa;break}do{qa=qa+ +h[P+(ra<<3)>>3];ra=ra+1|0;}while((ra|0)<(M|0));ma=qa/aa;if(ba){va=0.0;wa=0}else{sa=0.0;ta=oa;ua=pa;break}while(1){xa=+h[P+(wa<<3)>>3]-ma;ya=va+xa*xa;H=wa+1|0;if((H|0)<(M|0)){wa=H;va=ya}else{sa=ya;ta=oa;ua=pa;break}}}else{sa=0.0;ta=ja;ua=ja}}while(0);Y=sa/ca;do{if(!x){if(((ia|0)%(e|0)|0|0)!=0){break}ma=+h[P+(ja<<3)>>3];ya=+h[P+(ta<<3)>>3];H=v;h[k>>3]=ga;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];c[v+8>>2]=ia;H=v+12|0;h[k>>3]=ma;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=v+20|0;h[k>>3]=ya;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];V1(9,0,112584,v)}}while(0);if(Y<1.0e-8&E){break b}if(_){pxa(X|0,0,B|0)|0}if(ba){H=0;do{if(!((H|0)==(ta|0)|_^1)){G=fa(H,L)|0;F=0;do{J=X+(F<<3)|0;h[J>>3]=+h[O+(F+G<<3)>>3]+ +h[J>>3];F=F+1|0;}while((F|0)<(L|0))}H=H+1|0;}while((H|0)<(M|0))}do{if(_){H=0;do{F=X+(H<<3)|0;h[F>>3]=+h[F>>3]/ca;H=H+1|0;}while((H|0)<(L|0));if(!_){break}H=fa(ta,L)|0;F=0;do{Y=+h[X+(F<<3)>>3];h[Q+(F<<3)>>3]=Y+(Y- +h[O+(F+H<<3)>>3]);F=F+1|0;}while((F|0)<(L|0))}}while(0);Q6(a,R);za=+C6(a,ga);Y=+h[P+(ja<<3)>>3];do{if(Y<=za){if(!(za<=+h[P+(ua<<3)>>3])){break}if(!_){Aa=ia;D=Aa;continue c}nxa(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue c}}while(0);if(!(za<=Y)){break}if(_){F=0;do{ya=+h[X+(F<<3)>>3];h[S+(F<<3)>>3]=ya+(+h[Q+(F<<3)>>3]-ya)*2.0;F=F+1|0;}while((F|0)<(L|0))}Q6(a,T);if(+C6(a,ga)<za){if(!_){Aa=ia;D=Aa;continue}nxa(O+(fa(B,ta)|0)|0,S|0,B|0)|0;Aa=ia;D=Aa;continue}else{if(!_){Aa=ia;D=Aa;continue}nxa(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue}}if(!(+h[P+(ua<<3)>>3]<=za)){$=89;break a}Y=+h[P+(ta<<3)>>3];if(!(za>=Y)){if(_){D=0;do{ya=+h[X+(D<<3)>>3];h[V+(D<<3)>>3]=ya+(+h[Q+(D<<3)>>3]-ya)*.5;D=D+1|0;}while((D|0)<(L|0))}Q6(a,W);Ba=+C6(a,ga)}else{if(_){D=fa(ta,L)|0;F=0;do{ya=+h[X+(F<<3)>>3];h[V+(F<<3)>>3]=ya+(+h[O+(F+D<<3)>>3]-ya)*.5;F=F+1|0;}while((F|0)<(L|0))}Q6(a,W);Ba=+C6(a,ga)}if(Ba<Y){if(!_){ha=Ba;C=ia;continue}nxa(O+(fa(B,ta)|0)|0,V|0,B|0)|0;ha=Ba;C=ia;continue}if(ba){Ca=0}else{ha=Ba;C=ia;continue}while(1){if(_){F=fa(Ca,L)|0;D=0;do{H=O+(D+F<<3)|0;h[H>>3]=(+h[H>>3]+ +h[O+(D+ka<<3)>>3])*.5;D=D+1|0;}while((D|0)<(L|0))}D=Ca+1|0;if((D|0)<(M|0)){Ca=D}else{ha=Ba;C=ia;continue b}}}Y=ga+da;ya=Y>1.0?1.0:Y;Y=+h[P+(ja<<3)>>3];C=u;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[u+8>>2]=ia;C=u+12|0;h[k>>3]=Y;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];V1(9,0,112624,u);if(b){ea=ha;A=ia;ga=ya;continue}c[t>>2]=ia;pd(Z|0,112552,t|0)|0;C=s;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];pd(Z|0,112560,s|0)|0;if((c[K>>2]|0)>0){C=0;do{E=r;h[k>>3]=+h[(c[z>>2]|0)+(C<<3)>>3];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];pd(Z|0,112560,r|0)|0;C=C+1|0;}while((C|0)<(c[K>>2]|0))}Kd(10,Z|0)|0;ea=ha;A=ia;ga=ya}if(($|0)==89){$=q;h[k>>3]=za;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];X1(9,0,112672,q);q=p;h[k>>3]=ha;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];X1(9,0,112688,p);Z1(0,112704,o)}Q6(a,la);if((f|0)!=0){h[f>>3]=ga}if((g|0)!=0){c[g>>2]=ia}if(b){Kwa(S);Kwa(Q);Kwa(V);Kwa(X);Kwa(P);Kwa(O);i=j;return}c[n>>2]=ia;pd(Z|0,112552,n|0)|0;n=m;h[k>>3]=ga;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];pd(Z|0,112560,m|0)|0;if((c[K>>2]|0)>0){m=0;do{n=l;h[k>>3]=+h[(c[z>>2]|0)+(m<<3)>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];pd(Z|0,112560,l|0)|0;m=m+1|0;}while((m|0)<(c[K>>2]|0))}Kd(10,Z|0)|0;Wc(Z|0)|0;Kwa(S);Kwa(Q);Kwa(V);Kwa(X);Kwa(P);Kwa(O);i=j;return}function _6(a,b){a=a|0;b=b|0;i=i;return}function $6(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=c[b+12>>2]|0;H3(3);K3(0);w=+C3(0);H3(0);x=d+4|0;y=u;h[k>>3]=+h[c[c[x>>2]>>2]>>3];c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];pd(v|0,112784,u|0)|0;if((c[b+8>>2]|0)!=0){b=t;h[k>>3]=w;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];pd(v|0,112784,t|0)|0}t=d+116|0;b=c[t>>2]|0;if((b|0)>0){u=d+8|0;y=b;b=0;while(1){if((a[(c[u>>2]|0)+(b*112|0)+104|0]|0)==0){z=s;h[k>>3]=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(b<<3)>>3];c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];pd(v|0,112784,s|0)|0;A=c[t>>2]|0}else{A=y}z=b+1|0;if((z|0)<(A|0)){y=A;b=z}else{break}}}b=d+124|0;A=c[b>>2]|0;if((A|0)>0){y=d+12|0;t=A;A=0;while(1){if((a[(c[y>>2]|0)+(A*60|0)+56|0]|0)==0){c[r>>2]=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(A<<2)>>2];pd(v|0,112792,r|0)|0;B=c[b>>2]|0}else{B=t}s=A+1|0;if((s|0)<(B|0)){t=B;A=s}else{break}}}A=d+128|0;B=c[A>>2]|0;if((B|0)>0){t=d+16|0;b=B;B=0;while(1){if((a[(c[t>>2]|0)+(B*48|0)+44|0]|0)==0){c[q>>2]=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+B|0]|0;pd(v|0,112792,q|0)|0;C=c[A>>2]|0}else{C=b}r=B+1|0;if((r|0)<(C|0)){b=C;B=r}else{break}}}B=d+132|0;C=c[B>>2]|0;if((C|0)>0){b=d+20|0;A=C;C=0;while(1){if((a[(c[b>>2]|0)+(C*52|0)+48|0]|0)==0){c[p>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(C<<2)>>2];pd(v|0,112800,p|0)|0;D=c[B>>2]|0}else{D=A}q=C+1|0;if((q|0)<(D|0)){A=D;C=q}else{break}}}C=d+216|0;if((c[C>>2]|0)>0){D=d+40|0;A=0;do{B=c[D>>2]|0;do{if((a[B+(A*52|0)+48|0]|0)==0){p=a[B+(A*52|0)+8|0]|0;if(p<<24>>24==1){break}else if(p<<24>>24==2){E=c[c[x>>2]>>2]|0}else{E=(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(c[B+(A*52|0)+4>>2]<<3)|0}w=+h[E>>3];if((c[B+(A*52|0)>>2]|0)==0){p=n;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];pd(v|0,112784,n|0)|0;break}else{p=o;h[k>>3]=-w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];pd(v|0,112784,o|0)|0;break}}}while(0);A=A+1|0;}while((A|0)<(c[C>>2]|0))}C=d+220|0;if((c[C>>2]|0)>0){A=d+44|0;o=0;do{n=c[A>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){if((a[n+(o*52|0)+8|0]|0)==1){break}E=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(c[n+(o*52|0)+4>>2]<<2)>>2]|0;if((c[n+(o*52|0)>>2]|0)==0){c[l>>2]=E;pd(v|0,112792,l|0)|0;break}else{c[m>>2]=0-E;pd(v|0,112792,m|0)|0;break}}}while(0);o=o+1|0;}while((o|0)<(c[C>>2]|0))}C=d+224|0;if((c[C>>2]|0)>0){o=d+48|0;m=0;do{l=c[o>>2]|0;do{if((a[l+(m*52|0)+48|0]|0)==0){if((a[l+(m*52|0)+8|0]|0)==1){break}A=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+(c[l+(m*52|0)+4>>2]|0)|0]|0;if((c[l+(m*52|0)>>2]|0)==0){c[g>>2]=A<<24>>24;pd(v|0,112792,g|0)|0;break}else{c[j>>2]=A<<24>>24!=1;pd(v|0,112792,j|0)|0;break}}}while(0);m=m+1|0;}while((m|0)<(c[C>>2]|0))}C=d+228|0;m=c[C>>2]|0;if((m|0)<=0){F=Kd(10,v|0)|0;K3(3);i=e;return}j=d+52|0;d=m;m=0;while(1){g=c[j>>2]|0;do{if((a[g+(m*52|0)+48|0]|0)==0){if((a[g+(m*52|0)+8|0]|0)==1){G=d;break}c[f>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(c[g+(m*52|0)+4>>2]<<2)>>2];pd(v|0,112800,f|0)|0;G=c[C>>2]|0}else{G=d}}while(0);g=m+1|0;if((g|0)<(G|0)){d=G;m=g}else{break}}F=Kd(10,v|0)|0;K3(3);i=e;return}function a7(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b;s=ic(c[r>>2]|0,112808)|0;t=c[d+536>>2]|0;u=c[r>>2]|0;r=Od(c[(Mc()|0)>>2]|0)|0;c[q>>2]=u;c[q+4>>2]=r;Y1(t,(s|0)!=0|0,112816,q);c[p>>2]=112872;pd(s|0,112800,p|0)|0;if((c[b+8>>2]|0)!=0){c[o>>2]=112880;pd(s|0,112800,o|0)|0}o=d+116|0;p=c[o>>2]|0;if((p|0)>0){q=d+8|0;t=p;p=0;while(1){r=c[q>>2]|0;if((a[r+(p*112|0)+104|0]|0)==0){c[n>>2]=c[r+(p*112|0)+4>>2];pd(s|0,112800,n|0)|0;v=c[o>>2]|0}else{v=t}r=p+1|0;if((r|0)<(v|0)){t=v;p=r}else{break}}}p=d+124|0;v=c[p>>2]|0;if((v|0)>0){t=d+12|0;o=v;v=0;while(1){n=c[t>>2]|0;if((a[n+(v*60|0)+56|0]|0)==0){c[m>>2]=c[n+(v*60|0)+4>>2];pd(s|0,112800,m|0)|0;w=c[p>>2]|0}else{w=o}n=v+1|0;if((n|0)<(w|0)){o=w;v=n}else{break}}}v=d+128|0;w=c[v>>2]|0;if((w|0)>0){o=d+16|0;p=w;w=0;while(1){m=c[o>>2]|0;if((a[m+(w*48|0)+44|0]|0)==0){c[l>>2]=c[m+(w*48|0)+4>>2];pd(s|0,112800,l|0)|0;x=c[v>>2]|0}else{x=p}m=w+1|0;if((m|0)<(x|0)){p=x;w=m}else{break}}}w=d+132|0;x=c[w>>2]|0;if((x|0)>0){p=d+20|0;v=x;x=0;while(1){l=c[p>>2]|0;if((a[l+(x*52|0)+48|0]|0)==0){c[k>>2]=c[l+(x*52|0)+4>>2];pd(s|0,112800,k|0)|0;y=c[w>>2]|0}else{y=v}l=x+1|0;if((l|0)<(y|0)){v=y;x=l}else{break}}}x=d+216|0;y=c[x>>2]|0;if((y|0)>0){v=d+40|0;w=y;y=0;while(1){k=c[v>>2]|0;do{if((a[k+(y*52|0)+48|0]|0)==0){if((a[k+(y*52|0)+8|0]|0)==1){z=w;break}c[j>>2]=c[k+(y*52|0)+16>>2];pd(s|0,112800,j|0)|0;z=c[x>>2]|0}else{z=w}}while(0);k=y+1|0;if((k|0)<(z|0)){w=z;y=k}else{break}}}y=d+220|0;z=c[y>>2]|0;if((z|0)>0){w=d+44|0;x=z;z=0;while(1){j=c[w>>2]|0;do{if((a[j+(z*52|0)+48|0]|0)==0){if((a[j+(z*52|0)+8|0]|0)==1){A=x;break}c[h>>2]=c[j+(z*52|0)+16>>2];pd(s|0,112800,h|0)|0;A=c[y>>2]|0}else{A=x}}while(0);j=z+1|0;if((j|0)<(A|0)){x=A;z=j}else{break}}}z=d+224|0;A=c[z>>2]|0;if((A|0)>0){x=d+48|0;y=A;A=0;while(1){h=c[x>>2]|0;do{if((a[h+(A*52|0)+48|0]|0)==0){if((a[h+(A*52|0)+8|0]|0)==1){B=y;break}c[g>>2]=c[h+(A*52|0)+16>>2];pd(s|0,112800,g|0)|0;B=c[z>>2]|0}else{B=y}}while(0);h=A+1|0;if((h|0)<(B|0)){y=B;A=h}else{break}}}A=d+228|0;B=c[A>>2]|0;if((B|0)<=0){C=Kd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}y=d+52|0;d=B;B=0;while(1){z=c[y>>2]|0;do{if((a[z+(B*52|0)+48|0]|0)==0){if((a[z+(B*52|0)+8|0]|0)==1){H=d;break}c[f>>2]=c[z+(B*52|0)+16>>2];pd(s|0,112800,f|0)|0;H=c[A>>2]|0}else{H=d}}while(0);z=B+1|0;if((z|0)<(H|0)){d=H;B=z}else{break}}C=Kd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}function b7(a,b){a=a|0;b=b|0;var d=0;b=i;d=c[a+12>>2]|0;H3(3);Wc(d|0)|0;K3(3);i=b;return}function c7(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d;f=d+16|0;g=d+32|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+88|0;o=c[a+12>>2]|0;c[k>>2]=0;p=o;Voa(l,p);q=o+184|0;r=m;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=f;r=m;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];Woa(p,f)|0;d7(b,k,g,j,+h[o+224>>3],+h[o+232>>3]);o=c[k>>2]|0;e7(a,b,112896,c[j>>2]|0,c[g>>2]|0,o,8);Kwa(o);c[k>>2]=0;k=n;o=l;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=e;k=n;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];Woa(p,e)|0;i=d;return}function d7(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+8|0;c[e>>2]=2;l=b+136|0;m=b+140|0;n=b+144|0;o=(c[l>>2]|0)+1+(c[m>>2]|0)+(c[n>>2]|0)|0;c[f>>2]=o;p=Lwa(fa(c[e>>2]|0,o)|0,8)|0;c[d>>2]=p;Y1(c[b+536>>2]|0,(p|0)!=0|0,113176,k);p=c[d>>2]|0;h[p>>3]=g;d=c[f>>2]|0;h[p+(d<<3)>>3]=j;f=c[l>>2]|0;if((f|0)>0){l=c[b+416>>2]|0;o=0;do{e=l+(o<<3)|0;o=o+1|0;h[p+(o<<3)>>3]=+h[e>>3];h[p+(d+o<<3)>>3]=+h[e>>3];}while((o|0)<(f|0))}o=f+1|0;f=c[m>>2]|0;if((f|0)>0){m=c[b+420>>2]|0;l=0;do{j=+(c[m+(l<<2)>>2]|0);e=l+o|0;h[p+(e<<3)>>3]=j;h[p+(d+e<<3)>>3]=j;l=l+1|0;}while((l|0)<(f|0))}l=f+o|0;o=c[n>>2]|0;if((o|0)<=0){i=k;return}n=c[b+424>>2]|0;b=0;do{f=n+b|0;m=l+b|0;h[p+(m<<3)>>3]=+(a[f]|0);h[p+(d+m<<3)>>3]=+(a[f]|0);b=b+1|0;}while((b|0)<(o|0));i=k;return}function e7(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+8|0;k=j;l=c[a+12>>2]|0;p7(a,b,d,e,f,h);Uoa(l,g,fa(fa(f,e)|0,h)|0)|0;if(pna(l+(c[(c[l>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];Z1(l,113128,k)}else{i=j;return}}function f7(a){a=a|0;var b=0;b=i;if((h8(a+4|0)|0)!=0){i=b;return}sna(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function g7(a){a=a|0;Qc(a|0)|0;Xa()}function h7(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=Pwa(320)|0;pxa(q|0,0,320)|0;i7(q);r=a+12|0;c[r>>2]=q;s=(c[b+140>>2]|0)+(c[b+136>>2]|0)+(c[b+144>>2]|0)|0;c[f>>2]=0;c[k>>2]=0;c[l>>2]=0;H3(3);t=a+8|0;u=j7(c[t>>2]|0,c[r>>2]|0,b)|0;r=q+316|0;c[r>>2]=u;v=k7(a,b,u+s|0)|0;u=q+184|0;l7(m,-1,-1);w=m;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];w=q+200|0;l7(n,-1,-1);m=n;c[w+0>>2]=c[m+0>>2];c[w+4>>2]=c[m+4>>2];c[w+8>>2]=c[m+8>>2];c[w+12>>2]=c[m+12>>2];c[q+216>>2]=0;m=q+224|0;h[m>>3]=+h[b+240>>3];n=q+232|0;h[n>>3]=+h[b+248>>3];x=a;m7(q,c[x>>2]|0,36);if(pna(q+(c[(c[q>>2]|0)+ -12>>2]|0)|0)|0){y=c[b+536>>2]|0;c[e>>2]=c[x>>2];Z1(y,112952,e)}else{e7(a,b,112984,4,11,112904,1);n7((c[r>>2]|0)+s|0,v,f,g,j,0,0)|0;e=c[f>>2]|0;e7(a,b,112992,c[g>>2]|0,c[j>>2]|0,e,1);Kwa(e);c[f>>2]=0;n7((c[r>>2]|0)+s|0,v,f,g,j,0,1)|0;e=c[f>>2]|0;e7(a,b,113e3,c[g>>2]|0,c[j>>2]|0,e,1);Kwa(e);c[f>>2]=0;o7(a,b,k,g,j,c[r>>2]|0,s);e7(a,b,113016,c[j>>2]|0,c[g>>2]|0,c[k>>2]|0,4);s=q;Voa(o,s);r=o;c[u+0>>2]=c[r+0>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];d7(b,l,g,j,+h[m>>3],+h[n>>3]);n=c[l>>2]|0;e7(a,b,112896,c[j>>2]|0,c[g>>2]|0,n,8);Voa(p,s);g=p;c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2];c[w+12>>2]=c[g+12>>2];g=q7(q+240|0)|0;w=q7(q+264|0)|0;p=q7(q+288|0)|0;p7(a,b,113032,g+1+w+p+(c[q+312>>2]|0)+(c[t>>2]|0)|0,0,8);Kwa(n);Kwa(c[k>>2]|0);c[l>>2]=0;c[k>>2]=0;Aoa(s)|0;Kwa(v);K3(3);i=d;return}}function i7(a){a=a|0;var b=0;b=i;raa(a);i=b;return}function j7(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=(b|0)==0?1:2;c[g>>2]=0;b=e+116|0;l=c[b>>2]|0;if((l|0)>0){m=e+8|0;n=d+240|0;o=l;l=0;p=k;while(1){if((a[(c[m>>2]|0)+(l*112|0)+104|0]|0)==0){c[(v9(n,g)|0)>>2]=p;q=c[b>>2]|0;r=c[g>>2]|0;s=p+1|0}else{q=o;r=l;s=p}t=r+1|0;c[g>>2]=t;if((t|0)<(q|0)){o=q;l=t;p=s}else{u=s;break}}}else{u=k}c[h>>2]=0;k=e+124|0;s=c[k>>2]|0;if((s|0)>0){p=e+12|0;l=d+264|0;q=s;s=0;o=u;while(1){if((a[(c[p>>2]|0)+(s*60|0)+56|0]|0)==0){c[(v9(l,h)|0)>>2]=o;v=c[k>>2]|0;w=c[h>>2]|0;x=o+1|0}else{v=q;w=s;x=o}g=w+1|0;c[h>>2]=g;if((g|0)<(v|0)){q=v;s=g;o=x}else{y=x;break}}}else{y=u}c[j>>2]=0;u=e+128|0;x=c[u>>2]|0;if((x|0)>0){o=e+16|0;s=d+288|0;v=x;x=0;q=y;while(1){if((a[(c[o>>2]|0)+(x*48|0)+44|0]|0)==0){c[(v9(s,j)|0)>>2]=q;z=c[u>>2]|0;A=c[j>>2]|0;B=q+1|0}else{z=v;A=x;B=q}h=A+1|0;c[j>>2]=h;if((h|0)<(z|0)){v=z;x=h;q=B}else{C=B;break}}}else{C=y}y=c[e+216>>2]|0;if((y|0)>0){B=c[e+40>>2]|0;q=0;x=C;while(1){z=((a[B+(q*52|0)+48|0]|0)==0)+x|0;v=q+1|0;if((v|0)<(y|0)){x=z;q=v}else{D=z;break}}}else{D=C}C=c[e+220>>2]|0;if((C|0)>0){q=c[e+44>>2]|0;x=0;y=D;while(1){B=((a[q+(x*52|0)+48|0]|0)==0)+y|0;z=x+1|0;if((z|0)<(C|0)){y=B;x=z}else{E=B;break}}}else{E=D}D=d+312|0;c[D>>2]=0;d=c[e+224>>2]|0;if((d|0)<=0){F=E;i=f;return F|0}x=c[e+48>>2]|0;e=0;y=0;C=E;while(1){if((a[x+(y*52|0)+48|0]|0)==0){if((c[x+(y*52|0)>>2]|0)==0){G=e}else{E=e+1|0;c[D>>2]=E;G=E}H=G;I=C+1|0}else{H=e;I=C}E=y+1|0;if((E|0)<(d|0)){e=H;y=E;C=I}else{F=I;break}}i=f;return F|0}function k7(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=c[b+12>>2]|0;l=Jwa(e<<2)|0;e=l;c[l>>2]=113584;if((c[b+8>>2]|0)==0){m=1}else{c[l+4>>2]=113624;m=2}b=c[d+116>>2]|0;if((b|0)>0){n=c[d+8>>2]|0;o=m;p=0;while(1){if((a[n+(p*112|0)+104|0]|0)==0){c[l+(o<<2)>>2]=n+(p*112|0);q=o+1|0}else{q=o}r=p+1|0;if((r|0)<(b|0)){o=q;p=r}else{s=q;break}}}else{s=m}m=c[d+124>>2]|0;if((m|0)>0){q=c[d+12>>2]|0;p=s;o=0;while(1){if((a[q+(o*60|0)+56|0]|0)==0){c[l+(p<<2)>>2]=q+(o*60|0);t=p+1|0}else{t=p}b=o+1|0;if((b|0)<(m|0)){p=t;o=b}else{u=t;break}}}else{u=s}s=c[d+128>>2]|0;if((s|0)>0){t=c[d+16>>2]|0;o=u;p=0;while(1){if((a[t+(p*48|0)+44|0]|0)==0){c[l+(o<<2)>>2]=t+(p*48|0);v=o+1|0}else{v=o}m=p+1|0;if((m|0)<(s|0)){o=v;p=m}else{w=v;break}}}else{w=u}u=c[d+216>>2]|0;if((u|0)>0){v=c[d+40>>2]|0;p=w;o=0;while(1){if((a[v+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=v+(o*52|0)+12;x=p+1|0}else{x=p}s=o+1|0;if((s|0)<(u|0)){p=x;o=s}else{y=x;break}}}else{y=w}w=c[d+220>>2]|0;if((w|0)>0){x=c[d+44>>2]|0;o=y;p=0;while(1){if((a[x+(p*52|0)+48|0]|0)==0){c[l+(o<<2)>>2]=x+(p*52|0)+12;z=o+1|0}else{z=o}u=p+1|0;if((u|0)<(w|0)){o=z;p=u}else{A=z;break}}}else{A=y}y=c[d+224>>2]|0;if((y|0)>0){z=c[d+48>>2]|0;p=A;o=0;while(1){if((a[z+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=z+(o*52|0)+12;B=p+1|0}else{B=p}w=o+1|0;if((w|0)<(y|0)){p=B;o=w}else{C=B;break}}}else{C=A}c[g>>2]=0;A=d+136|0;if((c[A>>2]|0)>0){B=d+24|0;o=k+252|0;p=C;y=0;z=1;while(1){w=p+1|0;c[l+(p<<2)>>2]=(c[B>>2]|0)+(y*112|0);c[(v9(o,g)|0)>>2]=z;x=z+1|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;if((u|0)<(c[A>>2]|0)){z=x;y=u;p=w}else{D=w;E=x;break}}}else{D=C;E=1}c[h>>2]=0;C=d+140|0;if((c[C>>2]|0)>0){p=d+28|0;y=k+276|0;z=D;A=0;g=E;while(1){o=z+1|0;c[l+(z<<2)>>2]=(c[p>>2]|0)+(A*60|0);c[(v9(y,h)|0)>>2]=g;B=g+1|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;if((x|0)<(c[C>>2]|0)){g=B;A=x;z=o}else{F=o;G=B;break}}}else{F=D;G=E}c[j>>2]=0;E=d+144|0;if((c[E>>2]|0)<=0){i=f;return e|0}D=d+32|0;d=k+300|0;k=F;F=0;z=G;while(1){c[l+(k<<2)>>2]=(c[D>>2]|0)+(F*48|0);c[(v9(d,j)|0)>>2]=z;G=(c[j>>2]|0)+1|0;c[j>>2]=G;if((G|0)<(c[E>>2]|0)){z=z+1|0;F=G;k=k+1|0}else{break}}i=f;return e|0}function l7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;g8(a,b,c);i=d;return}function m7(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(f8(a+4|0,b,d|16)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){sna(d,4);i=e;return}else{qna(d,0);i=e;return}}function n7(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+8|0;k=j;l=i;i=i+8|0;c[f>>2]=a;c[e>>2]=0;m=(a|0)>0;do{if(m){n=0;o=0;while(1){p=c[b+(o<<2)>>2]|0;q=lxa(c[(h?p+8|0:p+4|0)>>2]|0)|0;if((q|0)>(n|0)){c[e>>2]=q;r=q}else{r=n}q=o+1|0;if((q|0)<(a|0)){n=r;o=q}else{break}}o=Lwa((fa(c[f>>2]|0,r)|0)+1|0,1)|0;c[d>>2]=o;Y1(0,(o|0)!=0|0,113104,l);if(!m){break}o=c[e>>2]|0;n=0;q=c[d>>2]|0;while(1){p=b+(n<<2)|0;s=c[p>>2]|0;wxa(q|0,c[(h?s+8|0:s+4|0)>>2]|0,o+1|0)|0;if(g){s=c[p>>2]|0;u7(q,lxa(c[(h?s+8|0:s+4|0)>>2]|0)|0)}s=c[e>>2]|0;p=n+1|0;if((p|0)<(a|0)){o=s;n=p;q=q+s|0}else{t=s;break}}u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}else{q=Lwa(1,1)|0;c[d>>2]=q;Y1(0,(q|0)!=0|0,113104,k)}}while(0);t=c[e>>2]|0;u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}function o7(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=c[b+12>>2]|0;c[f>>2]=j+h;c[g>>2]=4;g=Lwa(c[f>>2]<<2,4)|0;c[e>>2]=g;Y1(c[d+536>>2]|0,(g|0)!=0|0,113152,k);g=s+240|0;f=q7(g)|0;h=s+264|0;t=q7(h)|0;u=s+288|0;v=q7(u)|0;w=b+8|0;if((f+1+t+v|0)==(0-(c[w>>2]|0)|0)){x=0;y=1}else{v=c[e>>2]|0;t=0;f=0;b=1;while(1){c[v+(t<<2)>>2]=2;c[v+((t|1)<<2)>>2]=b;c[v+((t|2)<<2)>>2]=0;z=t+4|0;c[v+((t|3)<<2)>>2]=-1;A=b+1|0;B=f+1|0;C=q7(g)|0;D=q7(h)|0;E=q7(u)|0;if(B>>>0<(C+1+D+E+(c[w>>2]|0)|0)>>>0){b=A;f=B;t=z}else{x=z;y=A;break}}}t=d+216|0;if((c[t>>2]|0)>0){f=d+40|0;b=s+252|0;w=x;v=0;while(1){A=c[f>>2]|0;do{if((a[A+(v*52|0)+48|0]|0)==0){z=a[A+(v*52|0)+8|0]|0;if(z<<24>>24==1){v7(l,b,A+(v*52|0)+4|0);x7(n,b);if(!(w7(l,n)|0)){F=w;break}G=(c[(y7(l)|0)+4>>2]|0)+1|0;H=1}else if(z<<24>>24==0){v7(l,g,A+(v*52|0)+4|0);x7(m,g);if(!(w7(l,m)|0)){F=w;break}G=(c[(y7(l)|0)+4>>2]|0)+1|0;H=2}else if(z<<24>>24==2){G=1;H=2}else{F=w;break}z=c[e>>2]|0;c[z+(w<<2)>>2]=H;if((c[(c[f>>2]|0)+(v*52|0)>>2]|0)==0){c[z+(w+1<<2)>>2]=G}else{c[z+(w+1<<2)>>2]=0-G}c[z+(w+2<<2)>>2]=0;c[z+(w+3<<2)>>2]=-1;F=w+4|0}else{F=w}}while(0);A=v+1|0;if((A|0)<(c[t>>2]|0)){w=F;v=A}else{I=F;break}}}else{I=x}x=d+220|0;if((c[x>>2]|0)>0){F=d+44|0;v=s+276|0;w=I;t=0;while(1){G=c[F>>2]|0;do{if((a[G+(t*52|0)+48|0]|0)==0){f=a[G+(t*52|0)+8|0]|0;if(f<<24>>24==0){v7(l,h,G+(t*52|0)+4|0);x7(o,h);H=w7(l,o)|0;J=H?2:0}else if(f<<24>>24==1){v7(l,v,G+(t*52|0)+4|0);x7(p,v);J=(w7(l,p)|0)&1}else{K=w;break}if((J|0)==0){K=w;break}f=c[e>>2]|0;c[f+(w<<2)>>2]=J;H=(c[(c[F>>2]|0)+(t*52|0)>>2]|0)==0;m=c[(y7(l)|0)+4>>2]|0;if(H){c[f+(w+1<<2)>>2]=m+1}else{c[f+(w+1<<2)>>2]=~m}c[f+(w+2<<2)>>2]=0;c[f+(w+3<<2)>>2]=-1;K=w+4|0}else{K=w}}while(0);G=t+1|0;if((G|0)<(c[x>>2]|0)){w=K;t=G}else{L=K;break}}}else{L=I}I=d+224|0;if((c[I>>2]|0)>0){K=d+48|0;d=s+300|0;s=L;t=0;w=y;while(1){y=c[K>>2]|0;do{if((a[y+(t*52|0)+48|0]|0)==0){if((c[y+(t*52|0)>>2]|0)==0){x=a[y+(t*52|0)+8|0]|0;if(x<<24>>24==0){v7(l,u,y+(t*52|0)+4|0);x7(q,u);F=w7(l,q)|0;M=F?2:0}else if(x<<24>>24==1){v7(l,d,y+(t*52|0)+4|0);x7(r,d);M=(w7(l,r)|0)&1}else{N=s;O=w;break}if((M|0)==0){N=s;O=w;break}P=c[K>>2]|0;Q=M}else{P=y;Q=2}x=c[e>>2]|0;c[x+(s<<2)>>2]=Q;if((c[P+(t*52|0)>>2]|0)==0){c[x+(s+1<<2)>>2]=(c[(y7(l)|0)+4>>2]|0)+1;R=w}else{c[x+(s+1<<2)>>2]=w;R=w+1|0}c[x+(s+2<<2)>>2]=0;c[x+(s+3<<2)>>2]=-1;N=s+4|0;O=R}else{N=s;O=w}}while(0);y=t+1|0;if((y|0)<(c[I>>2]|0)){s=N;t=y;w=O}else{S=N;break}}}else{S=L}if((j|0)==0){i=k;return}L=c[e>>2]|0;e=0;do{N=(e<<2)+S|0;c[L+(N<<2)>>2]=1;c[L+(N+1<<2)>>2]=e+2;c[L+(N+2<<2)>>2]=0;c[L+(N+3<<2)>>2]=0;e=e+1|0;}while(e>>>0<j>>>0);i=k;return}function p7(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+24|0;m=c[a+12>>2]|0;c[l>>2]=(g|0)==4?20:(g|0)==1?51:0;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;f=l+16|0;c[f>>2]=(lxa(d|0)|0)+1;e=m;Uoa(e,l,20)|0;if(pna(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];Z1(l,113128,k)}Uoa(e,d,c[f>>2]|0)|0;if(pna(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){m=c[b+536>>2]|0;c[j>>2]=c[a>>2];Z1(m,113128,j)}else{i=h;return}}function q7(a){a=a|0;var b=0,d=0;b=i;d=c[(c8(a)|0)>>2]|0;i=b;return d|0}function r7(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=a+12|0;h=c[g>>2]|0;j=h;H3(3);do{if(ona(h+(c[(c[h>>2]|0)+ -12>>2]|0)|0)|0){k=h;l=h+200|0;m=f;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];l=e;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];Woa(k,e)|0;k=q7(h+240|0)|0;m=q7(h+264|0)|0;l=q7(h+288|0)|0;p7(a,b,113032,k+1+m+l+(c[h+312>>2]|0)+(c[a+8>>2]|0)|0,c[h+216>>2]|0,8);f7(h)}else{if((h|0)!=0){break}c[g>>2]=0;K3(3);i=d;return}}while(0);s7(j);Rwa(h);c[g>>2]=0;K3(3);i=d;return}function s7(a){a=a|0;var b=0;b=i;A8(a);i=b;return}function t7(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=c[b+12>>2]|0;h[g>>3]=0.0;H3(3);K3(0);h[j>>3]=+C3(0);H3(0);l=k;m=d+4|0;Uoa(l,c[c[m>>2]>>2]|0,8)|0;if((c[b+8>>2]|0)!=0){Uoa(l,j,8)|0}j=d+116|0;n=c[j>>2]|0;if((n|0)>0){o=d+8|0;p=n;n=0;while(1){if((a[(c[o>>2]|0)+(n*112|0)+104|0]|0)==0){Uoa(l,(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+(n<<3)|0,8)|0;q=c[j>>2]|0}else{q=p}r=n+1|0;if((r|0)<(q|0)){p=q;n=r}else{break}}}n=d+124|0;q=c[n>>2]|0;if((q|0)>0){p=d+12|0;j=g;o=q;q=0;while(1){if((a[(c[p>>2]|0)+(q*60|0)+56|0]|0)==0){h[g>>3]=+(c[(c[(c[c[m>>2]>>2]|0)+12>>2]|0)+(q<<2)>>2]|0);Uoa(l,j,8)|0;s=c[n>>2]|0}else{s=o}r=q+1|0;if((r|0)<(s|0)){o=s;q=r}else{break}}}q=d+128|0;s=c[q>>2]|0;if((s|0)>0){o=d+16|0;n=g;j=s;s=0;while(1){if((a[(c[o>>2]|0)+(s*48|0)+44|0]|0)==0){h[g>>3]=+(a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+s|0]|0);Uoa(l,n,8)|0;t=c[q>>2]|0}else{t=j}p=s+1|0;if((p|0)<(t|0)){j=t;s=p}else{break}}}s=d+224|0;t=c[s>>2]|0;if((t|0)>0){j=d+48|0;q=g;n=t;t=0;while(1){o=c[j>>2]|0;do{if((a[o+(t*52|0)+48|0]|0)==0){if((c[o+(t*52|0)>>2]|0)==0){u=n;break}h[g>>3]=+((a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+(c[o+(t*52|0)+4>>2]|0)|0]|0)!=1|0);Uoa(l,q,8)|0;u=c[s>>2]|0}else{u=n}}while(0);o=t+1|0;if((o|0)<(u|0)){n=u;t=o}else{break}}}if(pna(k+(c[(c[k>>2]|0)+ -12>>2]|0)|0)|0){t=c[d+536>>2]|0;c[f>>2]=c[b>>2];Z1(t,113072,f)}else{f=k+216|0;c[f>>2]=(c[f>>2]|0)+1;K3(3);i=e;return}}function u7(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(c>>>0<6){i=d;return}if((ixa(b,113288,4)|0)!=0){i=d;return}c=b;while(1){e=Ua(b|0,46)|0;if((e|0)==0){f=8;break}g=e-c|0;e=g+1|0;if(e>>>0>4){h=4;do{a[b+(h+ -4)|0]=a[b+h|0]|0;h=h+1|0;}while(h>>>0<e>>>0)}e=b+(g+ -3)|0;a[e]=678585700;a[e+1|0]=2650725;a[e+2|0]=10354;a[e+3|0]=40;if((ixa(b,113288,4)|0)!=0){f=8;break}}if((f|0)==8){i=d;return}}function v7(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;Q7(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];G7(a,f);i=e;return}function w7(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=E7(a,b)|0;i=c;return d|0}function x7(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;H7(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];G7(a,e);i=d;return}function y7(a){a=a|0;var b=0,c=0;b=i;c=z7(A7(a)|0)|0;i=b;return c|0}function z7(a){a=a|0;var b=0,c=0;b=i;c=D7(a)|0;i=b;return c|0}function A7(a){a=a|0;var b=0,d=0;b=i;d=B7((c[a>>2]|0)+16|0)|0;i=b;return d|0}function B7(a){a=a|0;var b=0,c=0;b=i;c=C7(a)|0;i=b;return c|0}function C7(a){a=a|0;i=i;return a|0}function D7(a){a=a|0;i=i;return a|0}function E7(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(F7(a,b)|0)^1;i=c;return d|0}function F7(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function G7(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];P7(a,e);i=d;return}function H7(a,b){a=a|0;b=b|0;var c=0;c=i;I7(a,J7(b)|0);i=c;return}function I7(a,b){a=a|0;b=b|0;var c=0;c=i;O7(a,b);i=c;return}function J7(a){a=a|0;var b=0,c=0;b=i;c=K7(L7(a+4|0)|0)|0;i=b;return c|0}function K7(a){a=a|0;var b=0,c=0;b=i;c=N7(a)|0;i=b;return c|0}function L7(a){a=a|0;var b=0,c=0;b=i;c=M7(a)|0;i=b;return c|0}function M7(a){a=a|0;i=i;return a|0}function N7(a){a=a|0;i=i;return a|0}function O7(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function P7(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function Q7(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=S7(b)|0;R7(f,b,d,h,J7(b)|0);H7(g,b);do{if(E7(f,g)|0){h=T7(b)|0;if(U7(h,d,V7(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);H7(a,b);i=e;return}function R7(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;Z7(h);a:do{if((e|0)==0){j=f}else{k=T7(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(_7(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;Z7(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;Z7(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);I7(a,j);i=g;return}function S7(a){a=a|0;var b=0,d=0;b=i;d=c[(J7(a)|0)>>2]|0;i=b;return d|0}function T7(a){a=a|0;var b=0,c=0;b=i;c=X7(a+8|0)|0;i=b;return c|0}function U7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=W7(0,b,c)|0;i=a;return d|0}function V7(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function W7(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function X7(a){a=a|0;var b=0,c=0;b=i;c=Y7(a)|0;i=b;return c|0}function Y7(a){a=a|0;i=i;return a|0}function Z7(a){a=a|0;var b=0;b=i;$7(a,-1);i=b;return}function _7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=W7(0,b,c)|0;i=a;return d|0}function $7(a,b){a=a|0;b=b|0;b=i;a8(a,0);i=b;return}function a8(a,b){a=a|0;b=b|0;c[a>>2]=0;i=i;return}function b8(a){a=a|0;i=i;return c[a+4>>2]|0}function c8(a){a=a|0;var b=0,c=0;b=i;c=d8(a+8|0)|0;i=b;return c|0}function d8(a){a=a|0;var b=0,c=0;b=i;c=e8(a)|0;i=b;return c|0}function e8(a){a=a|0;i=i;return a|0}function f8(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+64|0;if((c[f>>2]|0)!=0){g=0;i=e;return g|0}switch(d&-3|0){case 5:case 21:{h=113248;break};case 9:case 25:{h=113232;break};case 8:{h=113208;break};case 13:case 29:{h=113280;break};case 48:case 16:{h=113192;break};case 1:case 17:{h=113200;break};case 12:{h=113256;break};case 60:{h=113272;break};case 52:case 20:{h=113240;break};case 24:{h=113216;break};case 56:{h=113224;break};case 28:{h=113264;break};default:{g=0;i=e;return g|0}}if((a|0)==0){g=0;i=e;return g|0}j=ic(b|0,h|0)|0;c[f>>2]=j;if((j|0)==0){g=0;i=e;return g|0}c[a+88>>2]=d;if((d&2|0)==0){g=a;i=e;return g|0}if((Uc(j|0,0,2)|0)==0){g=a;i=e;return g|0}Wc(c[f>>2]|0)|0;c[f>>2]=0;g=0;i=e;return g|0}function g8(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=b;c[e+4>>2]=d;i=i;return}function h8(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+64|0;f=c[e>>2]|0;if((f|0)==0){g=0;i=b;return g|0}i8(d,f,102);f=ae[c[(c[a>>2]|0)+24>>2]&127](a)|0;if((Wc(j8(d)|0)|0)==0){c[e>>2]=0;h=(f|0)==0?a:0}else{h=0}k8(d);g=h;i=b;return g|0}function i8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;r8(a,b,c);i=d;return}



function t4(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;if((a[b]|0)==(a[e]|0)){h=1;i=g;return h|0}a[87072]=1;f=d[b]|0;c[21764]=f;b=d[e]|0;c[21766]=b;if((f+ -97|0)>>>0<26){e=f+ -32|0;c[21764]=e;j=e}else{j=f}if((b+ -97|0)>>>0<26){f=b+ -32|0;c[21766]=f;k=f}else{k=b}h=(j|0)==(k|0)|0;i=g;return h|0}function u4(b,d,e,f,g,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0.0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;r=i;if((c[j>>2]|0)>0){c[96604>>2]=6;mla(96600)|0;Dka(97344,j,4)|0;Wka()|0}c[q>>2]=0;s=(c[e>>2]|0)<1?3:0;c[q>>2]=s;t=(c[l>>2]|0)<1?4:s;c[q>>2]=t;if((t|0)!=0){i=r;return 0}c[23452]=0;c[24058]=0;c[24046]=0;a[96208]=0;t=c[e>>2]|0;c[23006]=1;do{if((t|0)>=1){s=0;u=1;while(1){if(+h[d+(u+ -1<<3)>>3]!=0.0){v=s+1|0;c[23452]=v;w=v}else{w=s}if((u|0)<(t|0)){s=w;u=u+1|0}else{break}}c[23006]=t+1;if((w|0)<=0){break}u=p;s=f;a:while(1){v=c[e>>2]|0;c[23006]=1;if((v|0)>=1){x=1;while(1){h[88496+((x*21|0)+ -21<<3)>>3]=+h[b+(x+ -1<<3)>>3];if((x|0)<(v|0)){x=x+1|0}else{break}}c[23006]=v+1}c[24050]=2;x=c[e>>2]|0;c[23006]=1;if((x|0)>=1){y=2;z=1;while(1){A=z+ -1|0;B=d+(A<<3)|0;C=+h[B>>3];if(C==0.0){D=y}else{E=c[e>>2]|0;c[23008]=1;if((E|0)<1){F=C}else{G=1;while(1){h[88496+((G*21|0)+ -22+y<<3)>>3]=+h[b+(G+ -1<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[23008]=E+1;F=+h[B>>3]}h[88496+((z*21|0)+ -22+y<<3)>>3]=+h[b+(A<<3)>>3]+F;G=y+1|0;c[24050]=G;D=G}G=z+1|0;c[23006]=G;if((z|0)<(x|0)){y=D;z=G}else{break}}}z=c[23452]|0;y=z+1|0;c[23448]=y;c[23006]=1;if((z|0)>=0){z=1;do{x=c[e>>2]|0;c[23008]=1;if((x|0)>=1){v=1;while(1){h[b+(v+ -1<<3)>>3]=+h[88496+((v*21|0)+ -22+z<<3)>>3];if((v|0)<(x|0)){v=v+1|0}else{break}}c[23008]=x+1}de[u&63](e,b,91856+(z+ -1<<3)|0)|0;c[24058]=(c[24058]|0)+1;if((c[j>>2]|0)>=1){c[96628>>2]=6;mla(96624)|0;Dka(97344,96232,4)|0;Dka(97344,91856+((c[23006]|0)+ -1<<3)|0,8)|0;v=c[e>>2]|0;c[23008]=1;if((v|0)>=1){A=1;do{Dka(97344,b+(A+ -1<<3)|0,8)|0;B=c[23008]|0;A=B+1|0;c[23008]=A;}while((B|0)<(v|0))}Wka()|0}v=c[23006]|0;z=v+1|0;c[23006]=z;}while((v|0)<(y|0))}y=c[24046]|0;b:while(1){c[24046]=y+1;c[23958]=1;c[23954]=1;C=+h[11482];h[11978]=C;h[11980]=C;z=c[23448]|0;c[23006]=2;if((z|0)<2){H=1}else{I=C;K=C;v=1;A=2;while(1){C=+h[91856+(A+ -1<<3)>>3];do{if(!(C<=K)){c[23958]=A;L=+h[91856+(A+ -1<<3)>>3];h[11978]=L;M=I;N=L;O=A}else{if(C>=I){M=I;N=K;O=v;break}c[23954]=A;L=+h[91856+(A+ -1<<3)>>3];h[11980]=L;M=L;N=K;O=v}}while(0);if((A|0)<(z|0)){I=M;K=N;v=O;A=A+1|0}else{break}}c[23006]=z+1;H=O}A=c[e>>2]|0;c[23006]=1;if((A|0)>=1){v=1;while(1){h[93976+(v+ -1<<3)>>3]=0.0;if((v|0)<(A|0)){v=v+1|0}else{break}}c[23006]=A+1}c[23006]=1;if((z|0)>=1){v=1;do{do{if((v|0)==(H|0)){P=H}else{x=c[e>>2]|0;c[23008]=1;if((x|0)<1){P=v;break}else{Q=1}while(1){B=93976+(Q+ -1<<3)|0;h[B>>3]=+h[88496+((Q*21|0)+ -22+v<<3)>>3]+ +h[B>>3];if((Q|0)<(x|0)){Q=Q+1|0}else{break}}c[23008]=x+1;P=v}}while(0);v=P+1|0;c[23006]=v;}while((P|0)<(z|0))}z=c[e>>2]|0;c[23008]=1;if((z|0)>=1){K=+(c[23452]|0);v=1;while(1){A=93976+(v+ -1<<3)|0;h[A>>3]=+h[A>>3]/K;if((v|0)<(z|0)){v=v+1|0}else{break}}c[23008]=z+1}v=c[e>>2]|0;c[23006]=1;if((v|0)>=1){A=1;while(1){B=A+ -1|0;K=+h[93976+(B<<3)>>3];h[96256+(B<<3)>>3]=K+(K- +h[88496+((A*21|0)+ -22+H<<3)>>3]);if((A|0)<(v|0)){A=A+1|0}else{break}}c[23006]=v+1}de[u&63](e,96256,96248)|0;A=(c[24058]|0)+1|0;c[24058]=A;z=c[j>>2]|0;do{if((z|0)>=1){if(((A|0)%(z|0)|0|0)!=0){break}c[96652>>2]=6;mla(96648)|0;Dka(97344,96232,4)|0;Dka(97344,96248,8)|0;B=c[e>>2]|0;c[23008]=1;if((B|0)>=1){E=1;do{Dka(97344,96256+(E+ -1<<3)|0,8)|0;G=c[23008]|0;E=G+1|0;c[23008]=E;}while((G|0)<(B|0))}Wka()|0}}while(0);K=+h[12031];c:do{if(!(K>=+h[11980])){z=c[e>>2]|0;c[23006]=1;if((z|0)>=1){A=1;while(1){v=A+ -1|0;I=+h[93976+(v<<3)>>3];h[96424+(v<<3)>>3]=I+(+h[96256+(v<<3)>>3]-I)*2.0;if((A|0)<(z|0)){A=A+1|0}else{break}}c[23006]=z+1}de[u&63](e,96424,96416)|0;A=(c[24058]|0)+1|0;c[24058]=A;v=c[j>>2]|0;do{if((v|0)>=1){if(((A|0)%(v|0)|0|0)!=0){break}c[96676>>2]=6;mla(96672)|0;Dka(97344,96232,4)|0;Dka(97344,96416,8)|0;B=c[e>>2]|0;c[23008]=1;if((B|0)>=1){E=1;do{Dka(97344,96424+(E+ -1<<3)|0,8)|0;G=c[23008]|0;E=G+1|0;c[23008]=E;}while((G|0)<(B|0))}Wka()|0}}while(0);I=+h[12052];if(I>=+h[11980]){R=118;break}v=c[e>>2]|0;c[23006]=1;A=c[23958]|0;if((v|0)>=1){z=1;while(1){B=z+ -1|0;if(+h[d+(B<<3)>>3]!=0.0){h[88496+((z*21|0)+ -22+A<<3)>>3]=+h[96424+(B<<3)>>3]}if((z|0)<(v|0)){z=z+1|0}else{break}}c[23006]=v+1}h[91856+(A+ -1<<3)>>3]=I}else{z=c[23448]|0;c[23006]=1;if((z|0)>=1){B=c[23958]|0;E=1;while(1){if((E|0)!=(B|0)){if(K<+h[91856+(E+ -1<<3)>>3]){R=118;break c}}x=E+1|0;c[23006]=x;if((E|0)<(z|0)){E=x}else{break}}}if(!(K>+h[11978])){E=c[e>>2]|0;c[23006]=1;z=c[23958]|0;if((E|0)>=1){B=1;while(1){A=B+ -1|0;if(+h[d+(A<<3)>>3]!=0.0){h[88496+((B*21|0)+ -22+z<<3)>>3]=+h[96256+(A<<3)>>3]}if((B|0)<(E|0)){B=B+1|0}else{break}}c[23006]=E+1}h[11978]=K;h[91856+(z+ -1<<3)>>3]=K}B=c[e>>2]|0;c[23006]=1;if((B|0)>=1){A=c[23958]|0;v=1;while(1){x=v+ -1|0;h[96424+(x<<3)>>3]=+h[88496+((v*21|0)+ -22+A<<3)>>3]*.5+ +h[93976+(x<<3)>>3]*.5;if((v|0)<(B|0)){v=v+1|0}else{break}}c[23006]=B+1}de[u&63](e,96424,96416)|0;v=(c[24058]|0)+1|0;c[24058]=v;A=c[j>>2]|0;do{if((A|0)>=1){if(((v|0)%(A|0)|0|0)!=0){break}c[96700>>2]=6;mla(96696)|0;Dka(97344,96232,4)|0;Dka(97344,96416,8)|0;z=c[e>>2]|0;c[23008]=1;if((z|0)>=1){E=1;do{Dka(97344,96424+(E+ -1<<3)|0,8)|0;x=c[23008]|0;E=x+1|0;c[23008]=E;}while((x|0)<(z|0))}Wka()|0}}while(0);I=+h[12052];if(!(I>+h[11978])){A=c[e>>2]|0;c[23006]=1;v=c[23958]|0;if((A|0)>=1){B=1;while(1){z=B+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[88496+((B*21|0)+ -22+v<<3)>>3]=+h[96424+(z<<3)>>3]}if((B|0)<(A|0)){B=B+1|0}else{break}}c[23006]=A+1}h[91856+(v+ -1<<3)>>3]=I;break}B=c[23448]|0;c[23006]=1;if((B|0)<1){break}else{S=1}do{z=c[23954]|0;do{if((S|0)!=(z|0)){E=c[e>>2]|0;c[23008]=1;if((E|0)>=1){x=S+ -22|0;G=1;while(1){if(+h[d+(G+ -1<<3)>>3]!=0.0){T=(G*21|0)+ -22|0;U=88496+(T+S<<3)|0;h[U>>3]=(+h[U>>3]+ +h[88496+(T+z<<3)>>3])*.5}h[b+(G+ -1<<3)>>3]=+h[88496+(x+(G*21|0)<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[23008]=E+1}de[u&63](e,b,91856+(S+ -1<<3)|0)|0;G=(c[24058]|0)+1|0;c[24058]=G;x=c[j>>2]|0;if((x|0)<1){break}if(((G|0)%(x|0)|0|0)!=0){break}c[96724>>2]=6;mla(96720)|0;Dka(97344,96232,4)|0;Dka(97344,91856+((c[23006]|0)+ -1<<3)|0,8)|0;x=c[e>>2]|0;c[23008]=1;if((x|0)>=1){G=1;do{Dka(97344,b+(G+ -1<<3)|0,8)|0;T=c[23008]|0;G=T+1|0;c[23008]=G;}while((T|0)<(x|0))}Wka()|0}}while(0);z=c[23006]|0;S=z+1|0;c[23006]=S;}while((z|0)<(B|0))}}while(0);if((R|0)==118){R=0;B=c[e>>2]|0;c[23006]=1;v=c[23958]|0;if((B|0)>=1){A=1;while(1){z=A+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[88496+((A*21|0)+ -22+v<<3)>>3]=+h[96256+(z<<3)>>3]}if((A|0)<(B|0)){A=A+1|0}else{break}}c[23006]=B+1}h[91856+(v+ -1<<3)>>3]=+h[12031]}A=c[24046]|0;if((A|0)<(c[l>>2]|0)){y=A;continue}h[11981]=0.0;h[12027]=0.0;A=c[23448]|0;c[23006]=1;z=(A|0)<1;do{if(z){K=+(A|0);h[12027]=0.0/K;c[23006]=1;W=K;X=0.0}else{x=1;K=0.0;while(1){Y=+h[91856+(x+ -1<<3)>>3]+K;if((x|0)<(A|0)){K=Y;x=x+1|0}else{break}}K=+(A|0);I=Y/K;h[12027]=I;c[23006]=1;if(z){W=K;X=0.0;break}else{Z=1;_=0.0}while(1){C=+h[91856+(Z+ -1<<3)>>3]-I;$=_+C*C;if((Z|0)<(A|0)){_=$;Z=Z+1|0}else{break}}h[11981]=$;c[23006]=A+1;W=K;X=$}}while(0);I=+V(+(X/W));h[11981]=I;do{if(!(I<=+h[k>>3])){if((c[24058]|0)>(c[g>>2]|0)){break}a[96208]=0;c[24046]=0;y=0;continue b}}while(0);v=c[e>>2]|0;c[23006]=1;if((v|0)>=1){B=1;while(1){x=B+ -1|0;if(!(+h[d+(x<<3)>>3]==0.0)){h[b+(x<<3)>>3]=0.0;c[23008]=1;if(z){aa=b+(B+ -1<<3)|0}else{x=B*21|0;G=b+(B+ -1<<3)|0;I=+h[G>>3];E=1;while(1){C=+h[88496+(E+ -22+x<<3)>>3]+I;h[G>>3]=C;if((E|0)<(A|0)){E=E+1|0;I=C}else{break}}c[23008]=A+1;aa=G}h[aa>>3]=+h[aa>>3]/W}if((B|0)<(v|0)){B=B+1|0}else{break}}c[23006]=v+1}de[u&63](e,b,f)|0;B=(c[24058]|0)+1|0;c[24058]=B;A=c[j>>2]|0;do{if((A|0)<1){ba=B}else{if(((B|0)%(A|0)|0|0)!=0){ba=B;break}c[96748>>2]=6;mla(96744)|0;Dka(97344,96232,4)|0;Dka(97344,s,8)|0;z=c[e>>2]|0;c[23008]=1;if((z|0)>=1){E=1;do{Dka(97344,b+(E+ -1<<3)|0,8)|0;x=c[23008]|0;E=x+1|0;c[23008]=E;}while((x|0)<(z|0))}Wka()|0;ba=c[24058]|0}}while(0);if((ba|0)>(c[g>>2]|0)){R=150;break a}if((c[j>>2]|0)>=0){c[96868>>2]=6;mla(96864)|0;Wka()|0;c[96892>>2]=6;mla(96888)|0;B=c[e>>2]|0;c[23006]=1;if((B|0)>=1){A=1;do{Dka(97344,b+(A+ -1<<3)|0,8)|0;v=c[23006]|0;A=v+1|0;c[23006]=A;}while((v|0)<(B|0))}Wka()|0;c[96916>>2]=6;mla(96912)|0;Dka(97344,s,8)|0;Wka()|0}if(a[96208]&1){I=+h[12027];K=+h[12073]-I;if(!(K>=0.0)){ca=-K}else{ca=K}if(!(ca>=+h[k>>3])){break}else{da=I}}else{a[96208]=1;da=+h[12027]}h[12073]=da;c[24046]=0;y=0}if((c[j>>2]|0)>=0){c[96940>>2]=6;mla(96936)|0;Dka(97344,96232,4)|0;Wka()|0;c[96964>>2]=6;mla(96960)|0;y=c[e>>2]|0;c[23006]=1;if((y|0)>=1){B=1;do{Dka(97344,b+(B+ -1<<3)|0,8)|0;A=c[23006]|0;B=A+1|0;c[23006]=B;}while((A|0)<(y|0))}Wka()|0;c[96988>>2]=6;mla(96984)|0;Dka(97344,s,8)|0;Wka()|0}if((c[m>>2]|0)<1){R=312;break}if((c[j>>2]|0)>-1){c[97012>>2]=6;mla(97008)|0;Wka()|0}h[11980]=+h[f>>3];c[24060]=0;y=c[23448]|0;c[23006]=1;if((y|0)>=1){B=1;while(1){A=91856+(B+ -1<<3)|0;I=+h[A>>3]- +h[f>>3];if(!(I>=0.0)){ea=-I}else{ea=I}if(ea>=+h[n>>3]){v=B+1|0;c[23006]=v;if((B|0)<(y|0)){B=v;continue}else{break}}v=c[e>>2]|0;c[23008]=1;if((v|0)>=1){z=B+ -22|0;E=1;while(1){G=E+ -1|0;if(+h[d+(G<<3)>>3]!=0.0){x=88496+((E*21|0)+ -22+B<<3)|0;I=+h[x>>3];h[x>>3]=I+(I- +h[b+(G<<3)>>3])}h[96424+(E+ -1<<3)>>3]=+h[88496+(z+(E*21|0)<<3)>>3];if((E|0)<(v|0)){E=E+1|0}else{break}}c[23008]=v+1}de[u&63](e,96424,A)|0;c[24060]=(c[24060]|0)+1;c[24058]=(c[24058]|0)+1;E=c[23006]|0;I=+h[91856+(E+ -1<<3)>>3];if(I>=+h[11980]){B=E;continue}h[11980]=I;if(!((c[j>>2]|0)>-1)){B=E;continue}c[97036>>2]=6;mla(97032)|0;Dka(97344,96232,4)|0;Dka(97344,95840,8)|0;E=c[e>>2]|0;c[23008]=1;if((E|0)>=1){z=1;do{Dka(97344,96424+(z+ -1<<3)|0,8)|0;G=c[23008]|0;z=G+1|0;c[23008]=z;}while((G|0)<(E|0))}Wka()|0;B=c[23006]|0}}B=c[23452]|0;c[23006]=1;do{if((B|0)<1){h[11507]=+h[11482];c[23006]=1;ga=B;R=202}else{y=1;do{E=y+1|0;c[23016]=E;z=c[e>>2]|0;c[23008]=1;if((z|0)>=1){A=1;while(1){v=A*21|0;h[96256+(A+ -1<<3)>>3]=(+h[88496+(v+ -21<<3)>>3]+ +h[88496+(v+ -22+E<<3)>>3])*.5;if((A|0)<(z|0)){A=A+1|0}else{break}}c[23008]=z+1}de[u&63](e,96256,93816+(y+ -1<<3)|0)|0;c[24060]=(c[24060]|0)+1;c[24058]=(c[24058]|0)+1;A=c[23006]|0;y=A+1|0;c[23006]=y;}while((A|0)<(B|0));y=c[23452]|0;I=+h[11482];h[11507]=I;c[23006]=1;if((y|0)<1){ga=y;R=202;break}else{ha=I;ia=1}while(1){A=ia+ -1|0;c[23016]=A;c[23018]=ia+1;if((ia|0)<2){ja=ia;ka=ha}else{c[23008]=1;E=1;while(1){v=E+1|0;c[23020]=v;G=c[e>>2]|0;c[23010]=1;if((G|0)>=1){x=c[23018]|0;T=1;while(1){U=(T*21|0)+ -22|0;h[96424+(T+ -1<<3)>>3]=(+h[88496+(U+x<<3)>>3]+ +h[88496+(U+v<<3)>>3])*.5;if((T|0)<(G|0)){T=T+1|0}else{break}}c[23010]=G+1}de[u&63](e,96424,96416)|0;c[24060]=(c[24060]|0)+1;c[24058]=(c[24058]|0)+1;T=c[23006]|0;v=T+ -1|0;x=(fa(v,T)|0)/2|0;U=c[23008]|0;la=U+x|0;c[23012]=la;I=+h[11507];h[94136+(la+ -1<<3)>>3]=(+h[12052]+I- +h[93816+(v<<3)>>3]- +h[93816+(U+ -1<<3)>>3])*2.0;v=U+1|0;c[23008]=v;if((U|0)<(A|0)){E=v}else{ja=T;ka=I;break}}}E=ja+1|0;c[23006]=E;if((ja|0)<(y|0)){ha=ka;ia=E}else{break}}y=c[23452]|0;c[23012]=0;c[23006]=1;E=(y|0)<1;if(E){c[23006]=1;ma=1;na=y;break}A=y+ -1|0;z=A<<1;T=Exa(A|0,0,y+ -2|0,0)|0;A=xxa(T|0,J&1|0,1)|0;T=0;v=1;while(1){U=T+v|0;h[94136+(U+ -1<<3)>>3]=(+h[91856+(v<<3)>>3]+ka- +h[93816+(v+ -1<<3)>>3]*2.0)*2.0;if((v|0)<(y|0)){v=v+1|0;T=U}else{break}}c[23016]=v+1;c[23012]=(z|1)+A;c[23006]=1;if(E){ma=1;na=y;break}I=ka*3.0;T=1;while(1){U=93816+(T+ -1<<3)|0;h[U>>3]=+h[U>>3]*2.0-(+h[91856+(T<<3)>>3]+I)*.5;if((T|0)<(y|0)){T=T+1|0}else{break}}c[23016]=T+1;c[23006]=y+1;ma=E;na=y}}while(0);if((R|0)==202){R=0;c[23012]=0;c[23006]=1;ma=(ga|0)<1;na=ga}B=c[e>>2]|0;c[23006]=1;if((B|0)>=1){A=1;while(1){h[95856+(A+ -1<<3)>>3]=+h[88496+((A*21|0)+ -21<<3)>>3];if((A|0)<(B|0)){A=A+1|0}else{break}}c[23006]=B+1}c[23006]=1;do{if(ma){c[23006]=1}else{A=1;while(1){z=A+1|0;c[23016]=z;v=c[e>>2]|0;c[23008]=1;if((v|0)>=1){U=1;while(1){la=U*21|0;x=88496+(la+ -22+z<<3)|0;h[x>>3]=+h[x>>3]- +h[88496+(la+ -21<<3)>>3];if((U|0)<(v|0)){U=U+1|0}else{break}}c[23008]=v+1}c[23006]=z;if((A|0)<(na|0)){A=z}else{break}}c[23006]=1;if(ma){break}else{oa=1}while(1){A=oa+1|0;c[23016]=A;y=c[e>>2]|0;c[23008]=1;if((y|0)>=1){E=1;while(1){T=(E*21|0)+ -22|0;h[88496+(T+oa<<3)>>3]=+h[88496+(T+A<<3)>>3];if((E|0)<(y|0)){E=E+1|0}else{break}}c[23008]=y+1}c[23006]=A;if((oa|0)<(na|0)){oa=A}else{break}}}}while(0);B=94136;v4(B,93808,B,96016,96592,q,96176)|0;if((c[q>>2]|0)==0){R=226;break}if((c[j>>2]|0)>-1){c[97060>>2]=6;mla(97056)|0;Wka()|0}c[q>>2]=2;if((c[24058]|0)>(c[g>>2]|0)){R=312;break}c[97084>>2]=6;mla(97080)|0;Wka()|0;B=c[e>>2]|0;c[23006]=1;if((B|0)<1){continue}else{pa=1}while(1){E=d+(pa+ -1<<3)|0;h[E>>3]=+h[E>>3]*.5;if((pa|0)<(B|0)){pa=pa+1|0}else{break}}c[23006]=B+1}if((R|0)==150){c[q>>2]=1;if((c[j>>2]|0)<0){i=r;return 0}c[96772>>2]=6;mla(96768)|0;Dka(97344,g,4)|0;Wka()|0;c[96796>>2]=6;mla(96792)|0;Dka(97344,95848,8)|0;Wka()|0;c[96820>>2]=6;mla(96816)|0;u=c[e>>2]|0;c[23006]=1;if((u|0)>=1){E=1;do{Dka(97344,b+(E+ -1<<3)|0,8)|0;z=c[23006]|0;E=z+1|0;c[23006]=E;}while((z|0)<(u|0))}Wka()|0;c[96844>>2]=6;mla(96840)|0;Dka(97344,s,8)|0;Wka()|0;i=r;return 0}else if((R|0)==226){u=c[23452]|0;c[24056]=u-(c[24148]|0);c[23006]=1;E=(u|0)<1;do{if(E){h[12024]=0.0;c[23006]=1;qa=0.0}else{z=u+1|0;v=1;while(1){h[91856+(v+ -1<<3)>>3]=0.0;T=v+ -1|0;U=91856+(T<<3)|0;I=+h[U>>3];la=1;while(1){if((la|0)>(v|0)){x=la+ -1|0;ra=x;sa=((fa(x,la)|0)/2|0)+v|0}else{ra=la+ -1|0;sa=((fa(T,v)|0)/2|0)+la|0}ta=+h[94136+(sa+ -1<<3)>>3]*+h[93816+(ra<<3)>>3]+I;if((la|0)<(u|0)){I=ta;la=la+1|0}else{break}}c[23012]=sa;h[U>>3]=ta;if((v|0)<(u|0)){v=v+1|0}else{break}}c[23008]=z;h[12024]=0.0;c[23006]=1;if(E){qa=0.0;break}else{ua=1;va=0.0}while(1){v=ua+ -1|0;wa=va+ +h[91856+(v<<3)>>3]*+h[93816+(v<<3)>>3];if((ua|0)<(u|0)){va=wa;ua=ua+1|0}else{break}}h[12024]=wa;c[23006]=u+1;qa=wa}}while(0);h[12024]=+h[11507]-qa;s=c[e>>2]|0;c[23006]=1;if((s|0)>=1){z=u+1|0;v=1;while(1){h[96424+(v+ -1<<3)>>3]=0.0;if(E){xa=1}else{B=v*21|0;la=96424+(v+ -1<<3)|0;T=1;I=+h[la>>3];while(1){ya=I+ +h[91856+(T+ -1<<3)>>3]*+h[88496+(T+ -22+B<<3)>>3];if((T|0)<(u|0)){I=ya;T=T+1|0}else{break}}h[la>>3]=ya;xa=z}if((v|0)<(s|0)){v=v+1|0}else{break}}c[23006]=s+1;c[23008]=xa}v=c[e>>2]|0;c[23006]=1;if((v|0)>=1){z=1;while(1){u=z+ -1|0;E=95856+(u<<3)|0;h[E>>3]=+h[E>>3]- +h[96424+(u<<3)>>3];if((z|0)<(v|0)){z=z+1|0}else{break}}c[23006]=v+1}if((c[j>>2]|0)>=0){c[97108>>2]=6;mla(97104)|0;Dka(97344,96192,8)|0;z=c[e>>2]|0;c[23006]=1;if((z|0)>=1){s=1;do{Dka(97344,95856+(s+ -1<<3)|0,8)|0;u=c[23006]|0;s=u+1|0;c[23006]=s;}while((u|0)<(z|0))}Wka()|0;c[97132>>2]=6;mla(97128)|0;Wka()|0}z=c[e>>2]|0;c[23006]=1;if((z|0)>=1){s=c[23452]|0;v=1;while(1){c[23008]=1;if((s|0)>=1){u=v*21|0;E=s+1|0;T=1;while(1){h[91856+(T+ -1<<3)>>3]=0.0;B=T+ -1|0;x=91856+(B<<3)|0;I=+h[x>>3];za=1;while(1){if((za|0)>(T|0)){Aa=((fa(za+ -1|0,za)|0)/2|0)+T|0}else{Aa=((fa(B,T)|0)/2|0)+za|0}Ba=I+ +h[94136+(Aa+ -1<<3)>>3]*+h[88496+(za+ -22+u<<3)>>3]*.5;if((za|0)<(s|0)){I=Ba;za=za+1|0}else{break}}c[23012]=Aa;h[x>>3]=Ba;if((T|0)<(s|0)){T=T+1|0}else{break}}c[23010]=E;c[23008]=s+1}T=c[e>>2]|0;c[23008]=v;if((v|0)<=(T|0)){u=(s|0)<1;la=s+1|0;za=v;while(1){Ca=v+((fa(za+ -1|0,za)|0)/2|0)|0;B=92112+(Ca+ -1<<3)|0;h[B>>3]=0.0;if(u){Da=1}else{U=za*21|0;Ea=1;I=0.0;while(1){Fa=+h[91856+(Ea+ -1<<3)>>3]*+h[88496+(Ea+ -22+U<<3)>>3]+I;if((Ea|0)<(s|0)){I=Fa;Ea=Ea+1|0}else{break}}h[B>>3]=Fa;Da=la}if((za|0)<(T|0)){za=za+1|0}else{break}}c[23008]=T+1;c[23012]=Ca;c[23010]=Da}za=v+1|0;c[23006]=za;if((v|0)<(z|0)){v=za}else{break}}}c[23008]=0;v=c[e>>2]|0;c[23006]=1;if((v|0)>=1){z=1;s=0;while(1){Ga=s+z|0;h[o+(z+ -1<<3)>>3]=+h[92112+(Ga+ -1<<3)>>3];if((z|0)<(v|0)){s=Ga;z=z+1|0}else{break}}c[23008]=Ga;c[23006]=v+1}if((c[j>>2]|0)<0){i=r;return 0}c[97156>>2]=6;mla(97152)|0;Dka(97344,96224,4)|0;Wka()|0;c[23450]=1;z=1;d:while(1){c[23012]=z;do{if((z|0)>(c[e>>2]|0)){s=c[23450]|0;if((s|0)==1){c[97180>>2]=6;mla(97176)|0;Wka()|0;v4(92112,93808,94136,96016,96592,q,96176)|0;c[97204>>2]=6;mla(97200)|0;Wka()|0;c[23450]=3;z=1;continue d}else if((s|0)==2){break d}else if((s|0)!=3){break}c[23450]=2;c[23022]=0;c[23024]=0;s=c[e>>2]|0;c[23006]=1;if((s|0)>=1){za=0;la=1;u=0;E=0;while(1){Ea=(E|0)>1?E:1;U=Ea+1|0;x=Exa(Ea+ -1|0,0,Ea+ -2|0,0)|0;Ha=xxa(x|0,J&1|0,1)|0;x=(Ea<<1)+ -1+Ha|0;Ia=u+la|0;Ha=92112+(Ia+ -1<<3)|0;I=+h[Ha>>3];if(I>0.0){Ja=1.0/+V(+I)}else{Ja=0.0}h[Ha>>3]=Ja;Ka=la+ -1|0;if((la|0)<2){La=za;Ma=1;Na=0}else{I=Ja;Oa=1;Pa=za;Qa=0;while(1){Ra=Qa+Oa|0;Sa=92112+(Pa<<3)|0;h[Sa>>3]=+h[Sa>>3]*I*+h[92112+(Ra+ -1<<3)>>3];if((Oa|0)>=(Ka|0)){break}I=+h[Ha>>3];Oa=Oa+1|0;Pa=Pa+1|0;Qa=Ra}La=za+Ea|0;Ma=U;Na=x}Ta=La+1|0;if((la|0)<(s|0)){za=Ta;la=la+1|0;E=E+1|0;u=Ia}else{break}}c[23026]=Na;c[23024]=Ta;c[23022]=Ia;c[23008]=Ma;c[23006]=s+1}c[97228>>2]=6;mla(97224)|0;Wka()|0;c[23022]=0;u=c[e>>2]|0;c[23006]=1;if((u|0)<1){z=1;continue d}else{Ua=1;Va=0}while(1){Wa=Va+Ua|0;E=92112+(Wa+ -1<<3)|0;if(+h[E>>3]!=0.0){h[E>>3]=1.0}if((Ua|0)<(u|0)){Ua=Ua+1|0;Va=Wa}else{break}}c[23022]=Wa;c[23006]=u+1;z=1;continue d}}while(0);T=(fa(z+ -1|0,z)|0)/2|0;c[23022]=T;s=c[e>>2]|0;c[23006]=z;e:do{if((z|0)<=(s|0)){E=z;la=T;za=z;while(1){B=E+la|0;c[23016]=B;Qa=za+la|0;c[23022]=Qa;Pa=B+5|0;c[23018]=(Qa|0)<=(Pa|0)?Qa:Pa;if((c[23450]|0)==3){c[97300>>2]=6;mla(97296)|0;Pa=c[23018]|0;Qa=c[23016]|0;c[23008]=Qa;if((Qa|0)<=(Pa|0)){B=Qa;do{Dka(97344,94136+(B+ -1<<3)|0,8)|0;Qa=c[23008]|0;B=Qa+1|0;c[23008]=B;}while((Qa|0)<(Pa|0))}Wka()|0}else{c[97276>>2]=6;mla(97272)|0;Pa=c[23018]|0;B=c[23016]|0;c[23008]=B;if((B|0)<=(Pa|0)){x=B;do{Dka(97344,92112+(x+ -1<<3)|0,8)|0;B=c[23008]|0;x=B+1|0;c[23008]=x;}while((B|0)<(Pa|0))}Wka()|0}Pa=c[23006]|0;x=Pa+1|0;c[23006]=x;if((Pa|0)>=(s|0)){break e}E=c[23012]|0;la=c[23022]|0;za=x}}}while(0);c[97324>>2]=6;mla(97320)|0;Wka()|0;z=(c[23012]|0)+6|0}c[97252>>2]=6;mla(97248)|0;Dka(97344,96240,4)|0;Wka()|0;i=r;return 0}else if((R|0)==312){i=r;return 0}}}while(0);de[p&63](e,b,f)|0;i=r;return 0}function v4(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0;k=i;c[24356]=c[b>>2];c[g>>2]=1;if((c[24356]|0)<1){i=k;return 0}c[g>>2]=0;w4(a,97424,d,f,g,j,e)|0;if((c[g>>2]|0)!=0){i=k;return 0}g=c[24356]|0;j=g+1|0;f=(fa(j,g)|0)/2|0;c[24348]=f;c[24354]=g;c[24360]=f;a=g+ -1|0;b=f+(fa(a,1-g|0)|0)|0;l=Exa(a|0,0,g+ -2|0,0)|0;m=xxa(l|0,J&1|0,1)|0;l=b+m|0;m=0-g|0;b=f;n=g;while(1){if(+h[d+(b+ -1<<3)>>3]==0.0){c[24340]=n;if((n|0)>(g|0)){o=b}else{p=g-n|0;q=fa(p,n+1|0)|0;r=Exa(p|0,0,a-n|0,0)|0;p=xxa(r|0,J&1|0,1)|0;r=n;s=b;while(1){h[d+(s+ -1<<3)>>3]=0.0;if((r|0)<(g|0)){s=s+r|0;r=r+1|0}else{break}}c[24340]=j;o=n+b+q+p|0}t=o;u=n+ -1|0}else{c[24338]=n;if((n|0)<=(g|0)){r=n;s=b;while(1){h[e+(r+ -1<<3)>>3]=+h[d+(s+ -1<<3)>>3];if((r|0)>=(g|0)){break}v=s+r|0;r=r+1|0;s=v}c[24338]=j}c[24350]=g;c[24352]=f;c[24358]=f;s=n+ -1|0;r=e+(s<<3)|0;p=(g|0)==(n|0);q=f;v=g;w=f;while(1){h[12173]=0.0;x=(v|0)==(n|0);if(x){y=1.0/+h[r>>3];h[12173]=y;z=y}else{z=0.0}if(p){A=g;B=w;C=z}else{y=z;D=g;E=w;while(1){F=D+ -1|0;G=E+ -1|0;H=y- +h[e+(F<<3)>>3]*+h[d+(G<<3)>>3];h[12173]=H;if((G|0)>(q|0)){I=E+(1-D)|0}else{I=G}if((F|0)==(n|0)){A=n;B=I;C=H;break}else{E=I;D=F;y=H}}}h[d+(B+ -1<<3)>>3]=C/+h[r>>3];if(x){break}D=q-v|0;c[24358]=D;E=v+ -1|0;c[24350]=E;F=w+ -1|0;c[24352]=F;q=D;v=E;w=F}c[24342]=A;t=B;u=s}w=b+m|0;if((u|0)==0){break}else{m=m+1|0;b=w;n=u}}c[24344]=t;c[24354]=0;c[24360]=l-g;i=k;return 0}function w4(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0;k=i;h[12187]=.5;l=.5;do{l=l*.5;}while(l+1.0>1.0);m=l*2.0;h[12187]=m;c[f>>2]=1;if((c[b>>2]|0)<1){i=k;return 0}c[f>>2]=2;c[e>>2]=0;h[g>>3]=m;h[j>>3]=+h[12187];c[24364]=1;c[24366]=0;n=c[b>>2]|0;c[24378]=1;a:do{if((n|0)>=1){b=1;o=1;b:while(1){c[24368]=0;c[24380]=1;do{if((o|0)>=1){p=1;q=c[24366]|0;r=0;while(1){s=q+1|0;t=a+(q<<3)|0;m=+h[t>>3];h[12186]=m;u=(p|0)==(o|0);if(u){l=m*+h[12187];h[12188]=l*l}do{if((p|0)<1){v=m;w=r;x=b;y=1}else{l=m;z=b;A=1;B=r;while(1){C=B+1|0;if((A|0)==(p|0)){D=14;break}E=d+(B<<3)|0;F=l- +h[E>>3]*+h[d+(z+ -1<<3)>>3];h[12186]=F;if(u){G=+h[E>>3];H=G*G*+h[j+(A+ -1<<3)>>3];h[12188]=+h[12188]+H*H}I=z+1|0;J=A+1|0;if((A|0)<(p|0)){l=F;z=I;A=J;B=C}else{D=15;break}}if((D|0)==14){D=0;c[24368]=C;v=l;w=C;x=z;y=p;break}else if((D|0)==15){D=0;c[24368]=C;v=F;w=C;x=I;y=J;break}}}while(0);if(u){D=25;break}m=+h[d+(w+ -1<<3)>>3];if(m==0.0){h[d+(q<<3)>>3]=0.0;H=+h[12186];if(!(H>=0.0)){K=-H}else{K=H}H=+h[g>>3]*+h[t>>3];if(!(H>=0.0)){L=-H}else{L=H}if(K>L){break b}}else{h[d+(q<<3)>>3]=v/m}B=p+1|0;c[24380]=B;if((p|0)<(o|0)){p=B;r=w;q=s}else{D=26;break}}if((D|0)==25){D=0;c[24362]=y;c[24370]=x;c[24366]=s;break}else if((D|0)==26){D=0;c[24362]=y;c[24370]=x;c[24366]=s;break}}}while(0);m=+V(+(+h[12188]));h[12188]=m;H=+h[12186];if(!(H>=0.0)){M=-H}else{M=H}do{if(!(M<=m*5.0)){if(H<0.0){D=37;break b}G=+V(+H);h[d+((c[24366]|0)+ -1<<3)>>3]=G;G=+h[12188]/+h[12186];h[j+((c[24362]|0)+ -1<<3)>>3]=G;if(!(G>+h[g>>3])){N=b;O=o;break}h[g>>3]=G;N=b;O=o}else{h[d+((c[24366]|0)+ -1<<3)>>3]=0.0;c[e>>2]=(c[e>>2]|0)+1;N=c[24364]|0;O=c[24378]|0}}while(0);b=N+O|0;c[24364]=b;o=O+1|0;c[24378]=o;if((O|0)>=(n|0)){break a}}if((D|0)==37){i=k;return 0}c[24362]=y;c[24370]=x;c[24366]=s;i=k;return 0}}while(0);c[f>>2]=0;i=k;return 0}function x4(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;n=(c[b>>2]|0)+1|0;c[24404]=n;o=(c[d>>2]|0)-n|0;c[24426]=o;p=c[d>>2]|0;q=c[b>>2]|0;r=q+2|0;do{if((p|0)>=(r|0)){if((p|0)>((fa(n,r)|0)/2|0|0)){break}s=q+p|0;c[24424]=s;a[97640]=1;t=c[b>>2]|0;u=t+1|0;c[24420]=u;v=c[b>>2]|0;w=u+v|0;c[24418]=w;u=w+(c[b>>2]|0)|0;c[24422]=u;w=(fa(c[d>>2]|0,c[b>>2]|0)|0)+u|0;c[24412]=w;x=w+(c[d>>2]|0)|0;c[24406]=x;y=x+(c[b>>2]|0)|0;c[24408]=y;z=((fa(n,c[b>>2]|0)|0)/2|0)+y|0;c[24414]=z;A=z+(c[d>>2]|0)|0;c[24428]=A;B=(fa(c[b>>2]|0,s)|0)+A|0;c[24430]=B;C=(fa(o,c[d>>2]|0)|0)+B|0;c[24402]=C;D=C+(c[b>>2]|0)|0;c[24416]=D;y4(b,d,e,f,g,h,j,k,k+(t<<3)|0,k+(t+v<<3)|0,k+(u+ -1<<3)|0,k+(w+ -1<<3)|0,k+(x+ -1<<3)|0,k+(y+ -1<<3)|0,k+(z+ -1<<3)|0,k+(A+ -1<<3)|0,k+(B+ -1<<3)|0,97696,k+(C+ -1<<3)|0,k+(D+ -1<<3)|0,k+(s+ -1+D<<3)|0,l)|0;i=m;return 0}}while(0);mla(97728)|0;Wka()|0;i=m;return 0}function y4(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0.0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0;z=i;i=i+8|0;A=z;B=c[b>>2]|0;C=~B;D=c[u>>2]|0;E=~D;h[12301]=.5;h[12292]=1.0;h[12332]=.1;F=(c[a>>2]|0)+1|0;c[24580]=F;G=fa(c[a>>2]|0,F)|0;H=(G|0)/2|0;c[24572]=H;I=(c[b>>2]|0)-F|0;c[24626]=I;F=c[j>>2]|0;c[24680]=(F|0)<1?1:F;F=c[a>>2]|0;c[24564]=1;if((F|0)>=1){j=1;while(1){J=j+ -1|0;h[k+(J<<3)>>3]=+h[d+(J<<3)>>3];J=c[b>>2]|0;c[24566]=1;if((J|0)>=1){K=fa(j,B)|0;L=1;while(1){h[n+(L+C+K<<3)>>3]=0.0;if((L|0)<(J|0)){L=L+1|0}else{break}}c[24566]=J+1}L=c[u>>2]|0;c[24562]=1;if((L|0)>=1){K=1;while(1){h[s+(K+E+(fa(j,D)|0)<<3)>>3]=0.0;if((K|0)<(L|0)){K=K+1|0}else{break}}c[24562]=L+1}K=j+1|0;c[24564]=K;if((j|0)<(F|0)){j=K}else{break}}}c[24568]=1;if((G|0)>=2){G=1;while(1){h[q+(G+ -1<<3)>>3]=0.0;if((G|0)<(H|0)){G=G+1|0}else{break}}c[24568]=H+1}H=c[b>>2]|0;c[24566]=1;if((H|0)>=1){G=(I|0)<1;j=I+1|0;F=1;while(1){h[r+(F+ -1<<3)>>3]=0.0;if(G){M=1}else{K=1;while(1){h[t+((fa(K,B)|0)+C+F<<3)>>3]=0.0;if((K|0)<(I|0)){K=K+1|0}else{M=j;break}}}if((F|0)<(H|0)){F=F+1|0}else{break}}c[24564]=M;c[24566]=H+1}N=+h[e>>3];O=N*N;h[12337]=O;h[12323]=+h[12292]/O;h[12324]=+V(+(+h[12301]))/O;c[24570]=0;H=y;y=A;M=0;a:while(1){c[24582]=M;F=M-(c[a>>2]|0)|0;c[24606]=F;j=M+1|0;c[24570]=j;I=c[a>>2]|0;do{if((M|0)>(I<<1|0)){G=(F+ -1|0)/(I|0)|0;c[24656]=G;K=c[a>>2]|0;L=M-(fa(K,G)|0)-K|0;c[24594]=L;K=L+G|0;c[24592]=K;if((K|0)>(c[a>>2]|0)){c[24656]=L;G=K-(c[a>>2]|0)|0;c[24594]=G;c[24592]=L;P=L;Q=G}else{P=K;Q=L}O=+h[e>>3];h[12314]=O;L=c[24580]|0;if(+h[o+(P+ -1+L<<3)>>3]<+h[o+(P<<3)>>3]){N=-O;h[12314]=N;R=N}else{R=O}O=+h[e>>3];h[12315]=O;if(+h[o+(Q+ -1+L<<3)>>3]<+h[o+(Q<<3)>>3]){h[12315]=-O}L=j+C|0;h[n+(L+(fa(P,B)|0)<<3)>>3]=R;h[n+(L+(fa(Q,B)|0)<<3)>>3]=+h[12315];S=c[a>>2]|0}else{L=(M|0)>(I|0);if(!((M|0)<1|L)){h[n+((fa(M,B)|0)+C+j<<3)>>3]=+h[e>>3];S=I;break}if(!L){S=I;break}h[n+(j+C+(fa(F,B)|0)<<3)>>3]=-+h[e>>3];S=I}}while(0);c[24564]=1;if((S|0)>=1){I=1;while(1){O=+h[n+((fa(I,B)|0)+C+j<<3)>>3];F=I+ -1|0;h[d+(F<<3)>>3]=O+ +h[k+(F<<3)>>3];if((I|0)<(S|0)){I=I+1|0}else{break}}c[24564]=S+1}if((M|0)>=(c[24680]|0)){T=j;U=159;break}while(1){de[H&63](a,d,98240)|0;if((c[g>>2]|0)==3){mla(98768)|0;Dka(98936,98280,4)|0;Dka(98936,98240,8)|0;I=c[a>>2]|0;c[24562]=1;if((I|0)>=1){F=1;do{Dka(98936,d+(F+ -1<<3)|0,8)|0;L=c[24562]|0;F=L+1|0;c[24562]=F;}while((L|0)<(I|0))}Wka()|0}I=c[24570]|0;do{if((I|0)>(c[b>>2]|0)){F=c[24610]|0;if((F|0)==-1){break a}h[12333]=0.0;c[24568]=0;L=c[a>>2]|0;c[24564]=1;if((L|0)<1){W=0.0}else{O=0.0;K=2;G=1;J=0;while(1){X=G+ -1|0;N=O+ +h[v+(X<<3)>>3]*+h[p+(X<<3)>>3];h[12333]=N;if((G|0)<1){Y=1;Z=N;_=J}else{X=G+ -1|0;$=m+(X<<3)|0;aa=v+(X<<3)|0;ba=N;X=1;ca=J;while(1){da=X+ -1|0;N=+h[v+(da<<3)>>3]*+h[$>>3]+ +h[aa>>3]*+h[l+(da<<3)>>3];h[12306]=N;if((X|0)==(G|0)){ea=N*+h[12301];h[12306]=ea;ga=ea}else{ga=N}ha=ba+ga*+h[q+(ca<<3)>>3];h[12333]=ha;if((X|0)<(G|0)){ba=ha;X=X+1|0;ca=ca+1|0}else{break}}ca=J+G|0;c[24568]=ca;Y=K;Z=ha;_=ca}if((G|0)<(L|0)){O=Z;K=K+1|0;G=G+1|0;J=_}else{break}}c[24562]=Y;c[24564]=L+1;W=Z}J=c[b>>2]|0;c[24566]=1;if((J|0)<1){ia=W}else{O=W;G=1;while(1){K=G+ -1|0;ja=O+ +h[r+(K<<3)>>3]*+h[x+(K<<3)>>3];h[12333]=ja;if((G|0)<(J|0)){G=G+1|0;O=ja}else{break}}c[24566]=J+1;ia=ja}O=+h[12280];ba=+h[12309];N=O-ba-ia;h[12300]=N;h[12319]=+h[12318];h[12318]=+h[12317];if(!(N>=0.0)){ka=-N}else{ka=N}h[12317]=ka;if(+h[12329]>+h[12295]){c[24654]=I}h[12325]=ba;do{if(O<ba){h[12309]=O;h[12342]=0.0;G=c[a>>2]|0;c[24562]=1;if((G|0)<1){break}else{la=1}while(1){L=la+ -1|0;h[l+(L<<3)>>3]=+h[m+(L<<3)>>3];ma=+h[l+(la+ -1<<3)>>3];h[12342]=+h[12342]+ma*ma;if((la|0)<(G|0)){la=la+1|0}else{break}}c[24562]=G+1;h[A>>3]=ma}}while(0);c[24652]=F;if((F|0)<=0){O=+h[12333];if(O>=0.0){U=190;break a}ba=+h[12280];N=+h[12325];ea=(ba-N)/O;h[12330]=ea;O=+h[12332];do{if(!(ea<=O)){na=+h[12301]*+h[12322];h[A>>3]=na;oa=+h[12329];if(!(ea<=.7)){pa=oa+oa;qa=na>=pa?na:pa;h[12322]=qa;ra=qa;break}else{qa=na>=oa?na:oa;h[12322]=qa;ra=qa;break}}else{qa=+h[12301]*+h[12329];h[12322]=qa;ra=qa}}while(0);ea=+h[12295];if(!(ra<=ea*1.5)){sa=ra}else{h[12322]=ea;sa=ea}qa=O*sa;oa=qa>=ea?qa:ea;h[A>>3]=oa;ea=oa*oa;h[12337]=ea;c[24668]=0;h[12338]=0.0;if(!(ba>=N)){ta=0;ua=0.0}else{J=c[24624]|0;c[24668]=J;oa=+h[12292];h[12338]=oa;ta=J;ua=oa}J=c[b>>2]|0;c[24566]=1;if((J|0)<1){va=F}else{L=c[24626]|0;oa=ua;K=1;ca=F;while(1){h[12320]=0.0;c[24564]=1;if((L|0)<1){wa=0.0}else{X=c[24586]|0;aa=K+C|0;qa=+h[12292];na=0.0;$=1;while(1){if(($|0)<(X|0)){xa=-qa}else{xa=qa}h[12306]=xa;pa=+h[t+(aa+(fa($,B)|0)<<3)>>3];ya=na+xa*pa*pa;h[12320]=ya;if(($|0)<(L|0)){na=ya;$=$+1|0}else{break}}c[24564]=L+1;wa=ya}na=+h[w+(K+ -1<<3)>>3];qa=na*na+ +h[12302]*wa;if(!(qa>=0.0)){za=-qa}else{za=qa}h[12306]=za;h[12341]=0.0;$=c[a>>2]|0;c[24564]=1;if(($|0)<1){Aa=qa;Ba=0.0}else{qa=0.0;aa=1;while(1){na=+h[n+((fa(aa,B)|0)+C+K<<3)>>3];Ca=na- +h[l+(aa+ -1<<3)>>3];Da=qa+Ca*Ca;h[12341]=Da;if((aa|0)<($|0)){aa=aa+1|0;qa=Da}else{break}}c[24564]=$+1;Aa=Ca;Ba=Da}if(Ba>ea){qa=Ba/ea;na=za*qa*qa*qa;h[12306]=na;Ea=qa;Fa=na}else{Ea=Aa;Fa=za}if(!(Fa>oa)|(K|0)==(ta|0)){Ga=oa;Ha=ca}else{h[12338]=Fa;c[24610]=K;Ga=Fa;Ha=K}aa=K+1|0;c[24566]=aa;if((K|0)<(J|0)){oa=Ga;K=aa;ca=Ha}else{break}}h[A>>3]=Ea;va=Ha}if((va|0)==0){Ia=0;Ja=sa;Ka=O;U=286;break}}E4(a,b,s,t,98344,u,w,98416,98440,x)|0;ca=c[24610]|0;K=ca+ -1|0;h[o+(K<<3)>>3]=+h[12280];c[24568]=0;J=c[a>>2]|0;c[24562]=1;L=r+(K<<3)|0;if((J|0)>=1){K=ca+C|0;F=2;aa=1;X=0;while(1){oa=+h[L>>3]*+h[n+((fa(aa,B)|0)+C+ca<<3)>>3];h[12306]=oa;if((aa|0)<1){La=1;Ma=X}else{ea=oa;G=1;da=X;while(1){oa=ea*+h[n+(K+(fa(G,B)|0)<<3)>>3];Na=q+(da<<3)|0;h[Na>>3]=+h[Na>>3]+oa;if((G|0)>=(aa|0)){break}ea=+h[12306];G=G+1|0;da=da+1|0}da=X+aa|0;c[24568]=da;La=F;Ma=da}if((aa|0)<(J|0)){F=F+1|0;aa=aa+1|0;X=Ma}else{break}}c[24564]=La;c[24562]=J+1}h[L>>3]=0.0;X=c[24626]|0;c[24564]=1;aa=(X|0)<1;if(!aa){F=c[24586]|0;K=1;while(1){da=fa(K,B)|0;O=+h[12300]*+h[t+(da+C+ca<<3)>>3];if((K|0)<(F|0)){Oa=-O}else{Oa=O}h[12306]=Oa;G=c[b>>2]|0;c[24566]=1;if((G|0)>=1){O=Oa;$=1;while(1){Na=r+($+ -1<<3)|0;h[Na>>3]=+h[Na>>3]+O*+h[t+($+C+da<<3)>>3];if(($|0)>=(G|0)){break}O=+h[12306];$=$+1|0}c[24566]=G+1}$=K+1|0;c[24564]=$;if((K|0)<(X|0)){K=$}else{break}}}h[12311]=0.0;K=c[a>>2]|0;c[24562]=1;if((K|0)>=1){F=1;while(1){O=+h[12300]*+h[s+((fa(F,D)|0)+E+ca<<3)>>3];L=p+(F+ -1<<3)|0;h[L>>3]=+h[L>>3]+O;L=F+ -1|0;Pa=+h[p+(L<<3)>>3];h[12311]=+h[12311]+Pa*Pa;h[n+((fa(F,B)|0)+C+ca<<3)>>3]=+h[m+(L<<3)>>3];if((F|0)<(K|0)){F=F+1|0}else{break}}c[24562]=K+1;h[A>>3]=Pa}F=c[24652]|0;do{if((F|0)==0){if(!(+h[12322]==+h[12295])){break}O=+h[12330];if(!(O>=0.0)){Qa=-O}else{Qa=O}if(Qa>.01){c[24672]=0;break}L=c[b>>2]|0;c[24566]=1;if((L|0)>=1){J=o+((c[24624]|0)+ -1<<3)|0;$=1;while(1){da=$+ -1|0;h[w+(da<<3)>>3]=+h[o+(da<<3)>>3]- +h[J>>3];if(($|0)<(L|0)){$=$+1|0}else{break}}c[24566]=L+1}h[12304]=0.0;$=c[a>>2]|0;c[24562]=1;if(($|0)<1){Ra=0.0}else{J=1;while(1){h[12298]=0.0;G=c[b>>2]|0;c[24566]=1;if((G|0)<1){Sa=0.0}else{da=fa(J,D)|0;O=0.0;Na=1;while(1){Ta=O+ +h[s+(Na+E+da<<3)>>3]*+h[w+(Na+ -1<<3)>>3];h[12298]=Ta;if((Na|0)<(G|0)){Na=Na+1|0;O=Ta}else{break}}c[24566]=G+1;Sa=Ta}h[12304]=+h[12304]+Sa*Sa;h[x+(J+ -1<<3)>>3]=Sa;Na=J+1|0;c[24562]=Na;if((J|0)<($|0)){J=Na}else{break}}Ra=+h[12304]*100.0}J=c[24672]|0;c[24672]=J+1;if(+h[12311]<Ra){c[24672]=0;break}if((J|0)<=1){break}J=c[a>>2]|0;c[24562]=1;if((J|0)>=1){$=1;while(1){L=$+ -1|0;h[p+(L<<3)>>3]=+h[x+(L<<3)>>3];if(($|0)<(J|0)){$=$+1|0}else{break}}c[24562]=J+1}$=c[24572]|0;c[24568]=1;if(($|0)>=1){L=1;while(1){h[q+(L+ -1<<3)>>3]=0.0;if((L|0)<($|0)){L=L+1|0}else{break}}c[24568]=$+1}c[24564]=1;if(!aa){L=1;while(1){J=x+(L+ -1<<3)|0;h[J>>3]=0.0;Na=c[b>>2]|0;c[24566]=1;if((Na|0)<1){Ua=0.0}else{da=fa(L,B)|0;O=0.0;Va=1;while(1){Wa=O+ +h[w+(Va+ -1<<3)>>3]*+h[t+(Va+C+da<<3)>>3];h[J>>3]=Wa;if((Va|0)<(Na|0)){Va=Va+1|0;O=Wa}else{break}}c[24566]=Na+1;Ua=Wa}if((L|0)<(c[24586]|0)){h[J>>3]=-Ua}Va=L+1|0;c[24564]=Va;if((L|0)<(X|0)){L=Va}else{break}}}L=c[b>>2]|0;c[24566]=1;if((L|0)>=1){$=X+1|0;Va=1;while(1){h[r+(Va+ -1<<3)>>3]=0.0;if(aa){Xa=1}else{da=1;while(1){O=+h[t+((fa(da,B)|0)+C+Va<<3)>>3];G=r+(Va+ -1<<3)|0;h[G>>3]=+h[G>>3]+O*+h[x+(da+ -1<<3)>>3];if((da|0)<(X|0)){da=da+1|0}else{Xa=$;break}}}if((Va|0)<(L|0)){Va=Va+1|0}else{break}}c[24564]=Xa;c[24566]=L+1}c[24672]=0}}while(0);O=+h[12280];ea=+h[12325];if(O<ea){c[24624]=ca}oa=+h[12332];if(O<=ea+oa*+h[12333]|(F|0)>0){U=54;break}c[24610]=0;Ia=0;Ja=+h[12322];Ka=oa;U=286}else{h[o+(I+ -1<<3)>>3]=+h[12280];oa=+h[12280];do{if((I|0)==1){h[12299]=oa;h[12309]=oa;c[24624]=1;Ya=1}else{if(!(oa<+h[12309])){Ya=I;break}h[12309]=oa;c[24624]=I;Ya=I}}while(0);F=c[24582]|0;ca=c[a>>2]|0;do{if((F|0)>(ca<<1|0)){X=c[24592]|0;aa=(fa(X+ -1|0,X)|0)/2|0;K=c[24594]|0;Va=K+aa|0;c[24568]=Va;if(+h[12314]<0.0){aa=X+(c[a>>2]|0)|0;c[24592]=aa;Za=aa}else{Za=X}if(+h[12315]<0.0){X=K+(c[a>>2]|0)|0;c[24594]=X;_a=X}else{_a=K}K=fa(c[24606]|0,B)|0;h[t+(K-B<<3)>>3]=+h[12323];h[t+(Ya+C+K<<3)>>3]=+h[12323];h[t+(Za-B+K<<3)>>3]=-+h[12323];h[t+(_a-B+K<<3)>>3]=-+h[12323];h[q+(Va+ -1<<3)>>3]=(+h[12299]- +h[o+(Za<<3)>>3]- +h[o+(_a<<3)>>3]+ +h[12280])/(+h[12314]*+h[12315])}else{Va=(F|0)>(ca|0);if((F|0)<1|Va){if(!Va){break}Va=c[24606]|0;K=fa(Va,D)|0;h[s+(E-ca+Ya+K<<3)>>3]=+h[12301]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=-+h[12301]/+h[e>>3];ea=+h[12324];K=fa(Va,B)|0;h[t+(K-B<<3)>>3]=-ea-ea;X=Ya+C|0;h[t+(X-ca+K<<3)>>3]=+h[12324];h[t+(X+K<<3)>>3]=+h[12324];K=(fa(Va+1|0,Va)|0)/2|0;c[24568]=K;ea=(+h[12299]- +h[12280])/+h[e>>3];h[12306]=ea;X=p+(Va+ -1<<3)|0;h[q+(K+ -1<<3)>>3]=(+h[X>>3]-ea)/+h[e>>3];h[X>>3]=+h[12301]*(+h[X>>3]+ +h[12306]);break}else{h[p+(F+ -1<<3)>>3]=(oa- +h[12299])/+h[e>>3];X=c[b>>2]|0;if((X|0)>=(ca+Ya|0)){break}K=fa(F,D)|0;h[s+(K-D<<3)>>3]=-+h[12292]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=+h[12292]/+h[e>>3];h[s+(X+E+F+K<<3)>>3]=-(+h[12301]*+h[12337]);break}}}while(0);if((Ya|0)<(c[b>>2]|0)){M=Ya;continue a}oa=+h[e>>3];h[12295]=oa;h[12322]=oa;c[24586]=1;h[12317]=0.0;h[12318]=0.0;c[24672]=0;h[12342]=0.0;F=c[a>>2]|0;c[24562]=1;if((F|0)<1){U=53;break}ca=c[24624]|0;K=1;while(1){h[l+(K+ -1<<3)>>3]=+h[n+((fa(K,B)|0)+C+ca<<3)>>3];$a=+h[l+(K+ -1<<3)>>3];h[12342]=+h[12342]+$a*$a;if((K|0)<(F|0)){K=K+1|0}else{break}}c[24562]=F+1;h[A>>3]=$a;U=53}}while(0);while(1){if((U|0)==53){U=0;c[24654]=c[24570];U=54;continue}else if((U|0)==54){U=0;c[24610]=0;I=(c[24580]|0)+ -1|0;K=c[a>>2]|0;D4(a,b,l,n,p,q,r,98576,v,x,x+(I<<3)|0,x+(I+K<<3)|0,x+(I+(K<<1)<<3)|0,98712)|0;h[12294]=0.0;K=c[a>>2]|0;c[24562]=1;if((K|0)<1){ab=0.0}else{oa=0.0;I=1;while(1){bb=+h[v+(I+ -1<<3)>>3];cb=oa+bb*bb;h[12294]=cb;if((I|0)<(K|0)){I=I+1|0;oa=cb}else{break}}h[A>>3]=bb;c[24562]=K+1;ab=cb}oa=+h[12322];h[A>>3]=oa;ea=+V(+ab);O=oa<=ea?oa:ea;h[12329]=O;ea=+h[12295];if(!(O<+h[12301]*ea)){db=ab;U=62;break}c[24610]=-1;O=+h[12332];N=O*oa;h[12322]=N;h[12330]=-1.0;if(!(N<=ea*1.5)){eb=N}else{h[12322]=ea;eb=ea}if((c[24570]|0)<=((c[24654]|0)+2|0)){Ia=-1;Ja=eb;Ka=O;U=286;continue}N=ea*+h[12339]*.125*ea;h[12306]=N;oa=+h[12317];ba=+h[12318];na=oa>=ba?oa:ba;h[A>>3]=na;ba=+h[12319];if(!(N<=(na>=ba?na:ba))){fb=-1;gb=O;hb=ea}else{Ia=-1;Ja=eb;Ka=O;U=286;continue}}else if((U|0)==286){U=0;O=Ja*Ja*4.0;h[12341]=O;I=c[b>>2]|0;c[24566]=1;if((I|0)<1){ib=Ia}else{F=1;ea=O;ca=Ia;while(1){h[12298]=0.0;X=c[a>>2]|0;c[24564]=1;if((X|0)<1){jb=0.0}else{O=0.0;Va=1;while(1){ba=+h[n+((fa(Va,B)|0)+C+F<<3)>>3];kb=ba- +h[l+(Va+ -1<<3)>>3];lb=O+kb*kb;h[12298]=lb;if((Va|0)<(X|0)){Va=Va+1|0;O=lb}else{break}}h[A>>3]=kb;c[24564]=X+1;jb=lb}if(jb>ea){c[24610]=F;h[12341]=jb;mb=jb;nb=F}else{mb=ea;nb=ca}Va=F+1|0;c[24566]=Va;if((F|0)<(I|0)){F=Va;ea=mb;ca=nb}else{break}}if((nb|0)>0){U=294;break}else{ib=nb}}if(+h[12330]>0.0){U=54;continue}ea=+h[12329];O=+h[12295];if((Ja>=ea?Ja:ea)>O){U=54;continue}else{fb=ib;gb=Ka;hb=O}}if(!(hb>+h[f>>3])){U=309;break}O=hb*+h[12301];h[12322]=O;ea=hb/+h[f>>3];h[12330]=ea;do{if(!(ea<=16.0)){if(!(ea<=250.0)){ba=gb*hb;h[12295]=ba;ob=ba;break}else{ba=+V(+ea);na=ba*+h[f>>3];h[12295]=na;ob=na;break}}else{na=+h[f>>3];h[12295]=na;ob=na}}while(0);h[12322]=O>=ob?O:ob;ca=c[g>>2]|0;if((ca|0)<=1){U=53;continue}if((ca|0)>2){mla(98816)|0;Wka()|0}mla(98840)|0;Dka(98936,98360,8)|0;Dka(98936,98280,4)|0;Wka()|0;mla(98864)|0;Dka(98936,98472,8)|0;ca=c[a>>2]|0;c[24562]=1;if((ca|0)>=1){F=1;do{I=F+ -1|0;h[A>>3]=+h[k+(I<<3)>>3]+ +h[l+(I<<3)>>3];Dka(98936,y,8)|0;I=c[24562]|0;F=I+1|0;c[24562]=F;}while((I|0)<(ca|0))}Wka()|0;U=53}if((U|0)==294){U=0;O=Ka*+V(+mb);ea=+h[12301]*Ja;na=O<=ea?O:ea;h[A>>3]=na;ea=+h[12295];O=na>=ea?na:ea;h[12331]=O;ea=O*O;h[12294]=ea;db=ea;U=62}else if((U|0)==309){U=0;if(!((fb|0)==-1)){break a}}do{if((U|0)==62){U=0;ea=+h[12342];if(db<=ea*.001){h[12335]=ea*.25;ca=c[b>>2]|0;c[24566]=1;if((ca|0)>=1){F=1;while(1){h[12298]=0.0;I=c[a>>2]|0;c[24562]=1;if((I|0)<1){pb=0.0}else{ea=0.0;K=1;while(1){O=+h[n+((fa(K,B)|0)+C+F<<3)>>3];qb=ea+O*+h[l+(K+ -1<<3)>>3];h[12298]=qb;if((K|0)<(I|0)){K=K+1|0;ea=qb}else{break}}c[24562]=I+1;pb=qb}h[12306]=+h[r+(F+ -1<<3)>>3]*pb;ea=pb- +h[12301]*+h[12342];h[12298]=ea;h[x+((c[b>>2]|0)+ -1+F<<3)>>3]=ea;K=c[a>>2]|0;c[24562]=1;if((K|0)>=1){X=1;while(1){Va=fa(X,B)|0;L=n+(Va+C+F<<3)|0;aa=X+ -1|0;$=p+(aa<<3)|0;h[$>>3]=+h[$>>3]+ +h[12306]*+h[L>>3];$=l+(aa<<3)|0;h[L>>3]=+h[L>>3]- +h[12301]*+h[$>>3];L=w+(aa<<3)|0;h[L>>3]=+h[s+(F+E+(fa(X,D)|0)<<3)>>3];ea=+h[12298]*+h[n+(F+C+Va<<3)>>3]+ +h[12335]*+h[$>>3];$=x+(aa<<3)|0;h[$>>3]=ea;aa=X+(c[b>>2]|0)|0;c[24574]=aa;c[24564]=1;if((X|0)<1){rb=X+1|0}else{O=ea;Va=1;while(1){da=s+((fa(Va,D)|0)+E+aa<<3)|0;J=Va+ -1|0;h[da>>3]=+h[da>>3]+ +h[L>>3]*+h[x+(J<<3)>>3]+O*+h[w+(J<<3)>>3];if((Va|0)>=(X|0)){break}O=+h[$>>3];Va=Va+1|0}Va=X+1|0;c[24564]=Va;rb=Va}c[24562]=rb;if((X|0)<(K|0)){X=rb}else{break}}}X=F+1|0;c[24566]=X;if((F|0)<(ca|0)){F=X}else{break}}}F=c[24626]|0;c[24566]=1;if((F|0)>=1){ca=1;while(1){h[12316]=0.0;X=c[b>>2]|0;c[24562]=1;b:do{if((X|0)>=1){O=0.0;K=1;while(1){I=t+(K+C+(fa(ca,B)|0)<<3)|0;h[12316]=+h[I>>3]+O;h[x+(K+ -1<<3)>>3]=+h[x+((c[b>>2]|0)+ -1+K<<3)>>3]*+h[I>>3];I=K+1|0;c[24562]=I;if((K|0)>=(X|0)){break b}O=+h[12316];K=I}}}while(0);X=c[a>>2]|0;c[24564]=1;if((X|0)>=1){K=1;while(1){I=K+ -1|0;O=+h[12335]*+h[12316]*+h[l+(I<<3)>>3];h[12298]=O;Va=c[b>>2]|0;c[24562]=1;if((Va|0)<1){sb=O}else{$=fa(K,B)|0;ea=O;L=1;while(1){tb=ea+ +h[x+(L+ -1<<3)>>3]*+h[n+(L+C+$<<3)>>3];h[12298]=tb;if((L|0)<(Va|0)){L=L+1|0;ea=tb}else{break}}c[24562]=Va+1;sb=tb}h[w+(I<<3)>>3]=sb;if((ca|0)<(c[24586]|0)){h[12298]=-+h[12298]}L=c[b>>2]|0;c[24562]=1;if((L|0)>=1){$=fa(ca,B)|0;aa=fa(K,D)|0;J=1;while(1){da=s+(J+E+aa<<3)|0;h[da>>3]=+h[12298]*+h[t+(J+C+$<<3)>>3]+ +h[da>>3];if((J|0)<(L|0)){J=J+1|0}else{break}}c[24562]=L+1}J=K+1|0;c[24564]=J;if((K|0)<(X|0)){K=J}else{break}}}K=c[a>>2]|0;c[24562]=1;if((K|0)>=1){X=c[24586]|0;J=1;while(1){$=(c[b>>2]|0)+J|0;c[24574]=$;ea=+h[w+(J+ -1<<3)>>3];if((ca|0)<(X|0)){ub=-ea}else{ub=ea}h[12306]=ub;c[24564]=1;if((J|0)<1){vb=J+1|0}else{ea=ub;aa=1;while(1){I=s+((fa(aa,D)|0)+E+$<<3)|0;h[I>>3]=ea*+h[w+(aa+ -1<<3)>>3]+ +h[I>>3];if((aa|0)>=(J|0)){break}ea=+h[12306];aa=aa+1|0}aa=J+1|0;c[24564]=aa;vb=aa}c[24562]=vb;if((J|0)<(K|0)){J=vb}else{break}}}J=ca+1|0;c[24566]=J;if((ca|0)<(F|0)){ca=J}else{break}}}c[24568]=0;ca=c[a>>2]|0;c[24564]=1;if((ca|0)>=1){F=0;J=1;while(1){K=J+ -1|0;X=x+(K<<3)|0;h[X>>3]=0.0;aa=c[b>>2]|0;c[24566]=1;if((aa|0)>=1){$=fa(J,B)|0;L=l+(K<<3)|0;I=$+C|0;ea=0.0;Va=1;while(1){h[X>>3]=ea+ +h[r+(Va+ -1<<3)>>3]*+h[n+(Va+C+$<<3)>>3];da=n+(I+Va<<3)|0;h[da>>3]=+h[da>>3]- +h[12301]*+h[L>>3];if((Va|0)>=(aa|0)){break}ea=+h[X>>3];Va=Va+1|0}c[24566]=aa+1}c[24562]=1;if((J|0)<1){wb=F}else{Va=1;L=F;while(1){I=L+1|0;c[24568]=I;$=(Va|0)<(J|0);da=q+(L<<3)|0;if($){Na=Va+ -1|0;G=l+(Na<<3)|0;xb=p+(K<<3)|0;h[xb>>3]=+h[xb>>3]+ +h[da>>3]*+h[G>>3];yb=G;zb=Na}else{Na=Va+ -1|0;yb=l+(Na<<3)|0;zb=Na}Na=l+(K<<3)|0;G=p+(zb<<3)|0;h[G>>3]=+h[da>>3]*+h[Na>>3]+ +h[G>>3];h[da>>3]=+h[da>>3]+ +h[x+(zb<<3)>>3]*+h[Na>>3]+ +h[yb>>3]*+h[X>>3];Na=(c[b>>2]|0)+E|0;h[s+(Na+Va+(fa(J,D)|0)<<3)>>3]=+h[s+(Na+J+(fa(Va,D)|0)<<3)>>3];Na=Va+1|0;c[24562]=Na;if($){Va=Na;L=I}else{wb=I;break}}}L=J+1|0;c[24564]=L;if((J|0)<(ca|0)){F=wb;J=L}else{break}}}J=c[a>>2]|0;c[24564]=1;if((J|0)>=1){F=1;while(1){ca=F+ -1|0;L=k+(ca<<3)|0;h[L>>3]=+h[l+(ca<<3)>>3]+ +h[L>>3];h[l+(F+ -1<<3)>>3]=0.0;if((F|0)<(J|0)){F=F+1|0}else{break}}c[24564]=J+1}h[12342]=0.0}if((c[24610]|0)>0){F=(c[24580]|0)+ -1|0;Q3(a,b,l,n,s,t,98344,u,98440,98648,v,98568,w,w+(c[b>>2]<<3)|0,x,x+(F<<3)|0,x+(F+(c[a>>2]|0)<<3)|0)|0}F=c[b>>2]|0;c[24566]=1;if((F|0)>=1){L=1;while(1){h[12307]=0.0;h[12308]=0.0;h[12298]=0.0;ca=c[a>>2]|0;c[24564]=1;if((ca|0)<1){Ab=0.0;Bb=0.0}else{Va=L+C|0;X=L+E|0;ea=0.0;O=0.0;na=0.0;K=1;while(1){ba=+h[n+((fa(K,B)|0)+C+L<<3)>>3];Cb=na+ba*+h[v+(K+ -1<<3)>>3];h[12307]=Cb;ba=+h[n+(Va+(fa(K,B)|0)<<3)>>3];aa=K+ -1|0;Db=O+ba*+h[l+(aa<<3)>>3];h[12308]=Db;ba=+h[s+(X+(fa(K,D)|0)<<3)>>3];N=ea+ba*+h[v+(aa<<3)>>3];h[12298]=N;if((K|0)<(ca|0)){K=K+1|0;na=Cb;O=Db;ea=N}else{break}}c[24564]=ca+1;Ab=Db;Bb=Cb}K=L+ -1|0;h[x+(K<<3)>>3]=Bb*(Bb*+h[12301]+Ab);h[w+(K<<3)>>3]=+h[12298];K=L+1|0;c[24566]=K;if((L|0)<(F|0)){L=K}else{break}}}h[12302]=0.0;L=c[24626]|0;c[24566]=1;if((L|0)>=1){F=1;while(1){h[12298]=0.0;J=c[b>>2]|0;c[24562]=1;if((J|0)<1){Eb=0.0}else{ea=0.0;K=1;while(1){O=+h[t+(K+C+(fa(F,B)|0)<<3)>>3];Fb=ea+O*+h[x+(K+ -1<<3)>>3];h[12298]=Fb;if((K|0)<(J|0)){K=K+1|0;ea=Fb}else{break}}c[24562]=J+1;Eb=Fb}ea=Eb*Eb;O=+h[12302];if((F|0)<(c[24586]|0)){h[12302]=O+ea;na=-Eb;h[12298]=na;Gb=na}else{h[12302]=O-ea;Gb=Eb}K=c[b>>2]|0;c[24562]=1;if((K|0)>=1){ca=fa(F,B)|0;ea=Gb;X=1;while(1){Va=w+(X+ -1<<3)|0;h[Va>>3]=+h[Va>>3]+ea*+h[t+(X+C+ca<<3)>>3];if((X|0)>=(K|0)){break}ea=+h[12298];X=X+1|0}c[24562]=K+1}X=F+1|0;c[24566]=X;if((F|0)<(L|0)){F=X}else{break}}}h[12310]=0.0;h[12289]=0.0;F=c[a>>2]|0;c[24564]=1;if((F|0)<1){Hb=0.0;Ib=0.0}else{ea=0.0;L=1;while(1){h[12298]=0.0;X=c[b>>2]|0;c[24562]=1;if((X|0)<1){Jb=0.0}else{ca=fa(L,D)|0;O=0.0;J=1;while(1){Kb=O+ +h[x+(J+ -1<<3)>>3]*+h[s+(J+E+ca<<3)>>3];h[12298]=Kb;if((J|0)<(X|0)){J=J+1|0;O=Kb}else{break}}c[24562]=X+1;Jb=Kb}J=L+ -1|0;ca=v+(J<<3)|0;h[12310]=ea+Jb*+h[ca>>3];K=L+(c[b>>2]|0)|0;c[24576]=K;Va=c[a>>2]|0;c[24566]=1;if((Va|0)<1){Lb=Jb}else{O=Jb;aa=1;while(1){na=+h[s+((fa(aa,D)|0)+E+K<<3)>>3];Mb=O+na*+h[v+(aa+ -1<<3)>>3];h[12298]=Mb;if((aa|0)<(Va|0)){aa=aa+1|0;O=Mb}else{break}}c[24566]=Va+1;Lb=Mb}h[w+(K+ -1<<3)>>3]=Lb;O=+h[12310]+ +h[12298]*+h[ca>>3];h[12310]=O;na=+h[12289]+ +h[ca>>3]*+h[l+(J<<3)>>3];h[12289]=na;aa=L+1|0;c[24564]=aa;if((L|0)<(F|0)){ea=O;L=aa}else{Hb=O;Ib=na;break}}}ea=+h[12294];h[12302]=+h[12302]+(Ib*Ib+ea*(Ib+(Ib+ +h[12342])+ea*+h[12301]))-Hb;L=w+((c[24624]|0)+ -1<<3)|0;h[L>>3]=+h[12292]+ +h[L>>3];L=c[24610]|0;if((L|0)<=0){break}ea=+h[w+(L+ -1<<3)>>3];h[A>>3]=ea;na=+h[12292]+ +h[12321]*+h[12302]/(ea*ea);h[12306]=na;if(!(na>=0.0)){Nb=-na}else{Nb=na}if(!(Nb<=.8)){break}L=c[u>>2]|0;P3(a,b,l,n,s,t,98344,u,98496,98440,v,x,w,98416,m,x+(L<<3)|0,x+((L*6|1)+ -1<<3)|0)|0}}while(0);L=c[a>>2]|0;c[24562]=1;if((L|0)>=1){F=1;while(1){aa=F+ -1|0;h[m+(aa<<3)>>3]=+h[l+(aa<<3)>>3]+ +h[v+(aa<<3)>>3];aa=F+ -1|0;h[d+(aa<<3)>>3]=+h[k+(aa<<3)>>3]+ +h[m+(aa<<3)>>3];if((F|0)<(L|0)){F=F+1|0}else{break}}c[24562]=L+1}F=c[24570]|0;aa=F+1|0;c[24570]=aa;if((F|0)>=(c[24680]|0)){T=aa;U=159;break a}}}do{if((U|0)==159){c[24570]=T+ -1;if((c[g>>2]|0)<=0){break}mla(98744)|0;Wka()|0}else if((U|0)==190){if((c[g>>2]|0)<=0){break}mla(98792)|0;Wka()|0}}while(0);Nb=+h[12309];if(Nb<=+h[12280]){U=c[a>>2]|0;c[24562]=1;if((U|0)<1){Ob=Nb}else{T=1;while(1){m=T+ -1|0;h[d+(m<<3)>>3]=+h[k+(m<<3)>>3]+ +h[l+(m<<3)>>3];if((T|0)<(U|0)){T=T+1|0}else{break}}c[24562]=U+1;Ob=+h[12309]}h[12280]=Ob}if((c[g>>2]|0)<=0){i=z;return 0}mla(98888)|0;Dka(98936,98280,4)|0;Wka()|0;mla(98912)|0;Dka(98936,98240,8)|0;g=c[a>>2]|0;c[24562]=1;if((g|0)>=1){a=1;do{Dka(98936,d+(a+ -1<<3)|0,8)|0;U=c[24562]|0;a=U+1|0;c[24562]=a;}while((U|0)<(g|0))}Wka()|0;i=z;return 0}function z4(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0;g=i;j=c[e>>2]|0;e=~j;k=c[a>>2]|0;l=c[b>>2]|0;m=(k|0)>(l|0)?l:k;if((m|0)<2){n=k;o=l}else{l=0;k=2;while(1){if((k|0)>=2){pxa(d+(j+(fa(j,l)|0)<<3)|0,0,(l<<3)+8|0)|0}if((k|0)<(m|0)){l=l+1|0;k=k+1|0}else{break}}n=c[a>>2]|0;o=c[b>>2]|0}b=o+1|0;if((n|0)>=(b|0)&(o|0)<(n|0)){k=(n|0)<1;l=n<<3;p=0;q=b;while(1){b=fa(q,j)|0;if(!k){pxa(d+((fa(o+p|0,j)|0)<<3)|0,0,l|0)|0}h[d+(q+e+b<<3)>>3]=1.0;if((q|0)<(n|0)){p=p+1|0;q=q+1|0}else{break}}}if((m|0)<1){i=g;return 0}q=c[a>>2]|0;a=1;while(1){p=m-a|0;n=p+1|0;l=(p|0)<(q|0);o=fa(n,j)|0;if(l){k=o+e|0;b=n;while(1){r=d+(k+b<<3)|0;h[f+(b+ -1<<3)>>3]=+h[r>>3];h[r>>3]=0.0;if((b|0)<(q|0)){b=b+1|0}else{break}}}h[d+(n+e+o<<3)>>3]=1.0;b=f+(p<<3)|0;if(!(+h[b>>3]==0.0|l^1)){k=n;while(1){r=(fa(k,j)|0)+e|0;s=n;t=0.0;while(1){u=t+ +h[d+(r+s<<3)>>3]*+h[f+(s+ -1<<3)>>3];if((s|0)>=(q|0)){break}s=s+1|0;t=u}t=+h[b>>3];v=u/t;s=(fa(k,j)|0)+e|0;w=t;r=n;while(1){x=d+(s+r<<3)|0;h[x>>3]=+h[x>>3]-v*w;if((r|0)>=(q|0)){break}w=+h[f+(r<<3)>>3];r=r+1|0}if((k|0)<(q|0)){k=k+1|0}else{break}}}if((a|0)<(m|0)){a=a+1|0}else{break}}i=g;return 0}function A4(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0.0,S=0.0;j=i;i=i+16|0;n=j;o=j+8|0;p=c[e>>2]|0;e=~p;q=+q4(98944);r=c[b>>2]|0;if((r|0)<1){s=r}else{t=1;while(1){u=+r4(a,d+((fa(t,p)|0)-p<<3)|0);v=t+ -1|0;h[l+(v<<3)>>3]=u;h[k+(v<<3)>>3]=u;h[m+(v<<3)>>3]=u;if((c[f>>2]|0)!=0){c[g+(v<<2)>>2]=t}if((t|0)<(r|0)){t=t+1|0}else{break}}s=c[b>>2]|0}t=c[a>>2]|0;r=(t|0)>(s|0)?s:t;if((r|0)<1){i=j;return 0}else{w=1}while(1){do{if((c[f>>2]|0)!=0){t=c[b>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){break}else{x=w;y=w}while(1){z=+h[k+(x+ -1<<3)>>3]>+h[k+(y+ -1<<3)>>3]?x:y;if((x|0)<(t|0)){y=z;x=x+1|0}else{break}}if((z|0)==(w|0)){break}t=c[a>>2]|0;c[n>>2]=t;if((t|0)>=1){s=(fa(w,p)|0)+e|0;l=(fa(z,p)|0)+e|0;v=1;while(1){A=d+(s+v<<3)|0;u=+h[A>>3];B=d+(l+v<<3)|0;h[A>>3]=+h[B>>3];h[B>>3]=u;if((v|0)<(t|0)){v=v+1|0}else{break}}}v=w+ -1|0;t=z+ -1|0;h[k+(t<<3)>>3]=+h[k+(v<<3)>>3];h[m+(t<<3)>>3]=+h[m+(v<<3)>>3];l=g+(v<<2)|0;v=c[l>>2]|0;s=g+(t<<2)|0;c[l>>2]=c[s>>2];c[s>>2]=v}}while(0);c[n>>2]=1-w+(c[a>>2]|0);v=fa(w,p)|0;s=w+e|0;l=d+(s+v<<3)|0;u=+r4(n,l);a:do{if(u==0.0){C=w+1|0;D=u}else{E=+h[l>>3];if(E<0.0){F=-u}else{F=u}t=c[a>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){G=E}else{B=v+e|0;A=w;while(1){H=d+(B+A<<3)|0;h[H>>3]=+h[H>>3]/F;if((A|0)<(t|0)){A=A+1|0}else{break}}G=+h[l>>3]}h[l>>3]=G+1.0;A=w+1|0;B=c[b>>2]|0;if((B|0)<(A|0)){C=A;D=F;break}c[n>>2]=B;if((w|0)>=(B|0)){C=A;D=F;break}H=A+e|0;I=v+e|0;J=t;K=B;B=A;while(1){c[o>>2]=J;L=(w|0)>(J|0);do{if(L){c[o>>2]=J}else{M=(fa(B,p)|0)+e|0;N=w;E=0.0;while(1){O=E+ +h[d+(I+N<<3)>>3]*+h[d+(M+N<<3)>>3];if((N|0)<(J|0)){E=O;N=N+1|0}else{break}}E=O/+h[l>>3];c[o>>2]=J;if(L){break}N=(fa(B,p)|0)+e|0;M=w;while(1){P=d+(N+M<<3)|0;h[P>>3]=+h[P>>3]-E*+h[d+(I+M<<3)>>3];if((M|0)<(J|0)){M=M+1|0}else{break}}}}while(0);do{if((c[f>>2]|0)==0){Q=K}else{L=B+ -1|0;M=k+(L<<3)|0;E=+h[M>>3];if(E==0.0){Q=K;break}N=fa(B,p)|0;R=+h[d+(s+N<<3)>>3]/E;S=1.0-R*R;R=E*+V(+(S<=0.0?0.0:S));h[M>>3]=R;P=m+(L<<3)|0;S=R/+h[P>>3];if(S*S*.05>q){Q=K;break}c[o>>2]=J-w;S=+r4(o,d+(H+N<<3)|0);h[M>>3]=S;h[P>>3]=S;Q=c[n>>2]|0}}while(0);if((B|0)>=(Q|0)){C=A;D=F;break a}J=c[a>>2]|0;K=Q;B=B+1|0}}}while(0);h[k+(w+ -1<<3)>>3]=-D;if((w|0)<(r|0)){w=C}else{break}}i=j;return 0}function B4(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;j=i;k=c[e>>2]|0;e=~k;l=c[b>>2]|0;b=l+ -1|0;if((l|0)<2){i=j;return 0}m=c[a>>2]|0;n=(m|0)<1;o=0.0;p=1;q=0.0;while(1){r=l-p|0;s=+h[f+(r+ -1<<3)>>3];t=!(s>=0.0);if(t){u=-s}else{u=s}if(u>1.0){v=1.0/s}else{v=o}if(t){w=-s}else{w=s}if(w>1.0){x=+V(+(1.0-v*v))}else{x=q}if(t){y=-s;z=!(s>=-1.0)?x:s}else{y=s;z=!(s<=1.0)?x:s}if(!(y<=1.0)){A=v}else{A=+V(+(1.0-z*z))}if(!n){t=(fa(r,k)|0)+e|0;r=fa(l,k)|0;B=1;while(1){C=d+(t+B<<3)|0;s=+h[C>>3];D=d+(B+e+r<<3)|0;E=+h[D>>3];h[D>>3]=z*s+A*E;h[C>>3]=A*s-z*E;if((B|0)<(m|0)){B=B+1|0}else{break}}}if((p|0)<(b|0)){o=A;p=p+1|0;q=z}else{break}}p=c[a>>2]|0;a=(p|0)<1;q=A;m=1;A=z;while(1){z=+h[g+(m+ -1<<3)>>3];n=!(z>=0.0);if(n){F=-z}else{F=z}if(F>1.0){G=1.0/z}else{G=q}if(n){H=-z}else{H=z}if(H>1.0){I=+V(+(1.0-G*G))}else{I=A}if(n){J=-z;K=!(z>=-1.0)?I:z}else{J=z;K=!(z<=1.0)?I:z}if(!(J<=1.0)){L=G}else{L=+V(+(1.0-K*K))}if(!a){n=(fa(m,k)|0)+e|0;f=fa(l,k)|0;B=1;while(1){r=d+(n+B<<3)|0;z=+h[r>>3];t=d+(B+e+f<<3)|0;o=+h[t>>3];h[t>>3]=L*o-K*z;h[r>>3]=L*z+K*o;if((B|0)<(p|0)){B=B+1|0}else{break}}}if((m|0)<(b|0)){q=L;m=m+1|0;A=K}else{break}}i=j;return 0}function C4(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0;e=i;l=+q4(98952);m=c[b>>2]|0;n=c[a>>2]|0;o=(fa(1-m+(n<<1)|0,m)|0)/2|0;p=o+(m-n)|0;if((m|0)<=(n|0)){q=m;r=p;while(1){h[j+(q+ -1<<3)>>3]=+h[d+(r+ -1<<3)>>3];if((q|0)<(n|0)){r=r+1|0;q=q+1|0}else{break}}}q=m+ -1|0;r=(m|0)<2;if(r){s=p}else{t=(q|0)>1?q:1;u=t+ -1|0;v=(m<<1)+o+(fa(u,m+ -3-n|0)|0)+ -2-n|0;o=Exa(u|0,0,t+ -2|0,0)|0;t=xxa(o|0,J&1|0,1)|0;o=p;p=1;while(1){u=m-p|0;w=o+ -1+u-n|0;x=u+ -1|0;h[j+(x<<3)>>3]=0.0;y=g+(x<<3)|0;z=+h[y>>3];do{if(!(z==0.0)){x=g+(q<<3)|0;A=+h[x>>3];if(!(A>=0.0)){B=-A}else{B=A}if(!(z>=0.0)){C=-z}else{C=z}do{if(!(B>=C)){D=A/z;E=.5/+V(+(D*D*.25+.25));F=D*E;if(!(F>=0.0)){G=-F}else{G=F}if(!(l*G>1.0)){H=F;I=E;K=1.0;break}H=F;I=E;K=1.0/F}else{F=z/A;E=.5/+V(+(F*F*.25+.25));D=F*E;H=E;I=D;K=D}}while(0);h[x>>3]=I*z+H*A;h[y>>3]=K;if((u|0)>(n|0)){break}else{L=u;M=w}while(1){N=d+(M+ -1<<3)|0;D=+h[N>>3];O=j+(L+ -1<<3)|0;E=+h[O>>3];h[O>>3]=I*D+H*E;h[N>>3]=H*D-I*E;if((L|0)<(n|0)){M=M+1|0;L=L+1|0}else{break}}}}while(0);if((p|0)<(q|0)){p=p+1|0;o=w}else{break}}s=v-n-t|0}if((n|0)>=1){t=g+(q<<3)|0;g=1;while(1){v=g+ -1|0;o=j+(v<<3)|0;h[o>>3]=+h[o>>3]+ +h[t>>3]*+h[f+(v<<3)>>3];if((g|0)<(n|0)){g=g+1|0}else{break}}}c[k>>2]=0;if(r){P=s}else{r=1;g=s;while(1){s=j+(r+ -1<<3)|0;I=+h[s>>3];n=d+(g+ -1<<3)|0;if(!(I==0.0)){H=+h[n>>3];if(!(H>=0.0)){Q=-H}else{Q=H}if(!(I>=0.0)){R=-I}else{R=I}do{if(!(Q>=R)){K=H/I;G=.5/+V(+(K*K*.25+.25));C=K*G;if(!(C>=0.0)){S=-C}else{S=C}if(!(l*S>1.0)){T=C;U=G;W=1.0;break}T=C;U=G;W=1.0/C}else{C=I/H;G=.5/+V(+(C*C*.25+.25));K=C*G;T=G;U=K;W=K}}while(0);w=c[a>>2]|0;a:do{if((r|0)<=(w|0)){K=I;G=H;f=r;t=g;while(1){h[j+(f+ -1<<3)>>3]=T*K-U*G;h[d+(t+ -1<<3)>>3]=T*G+U*K;if((f|0)>=(w|0)){break a}K=+h[j+(f<<3)>>3];G=+h[d+(t<<3)>>3];f=f+1|0;t=t+1|0}}}while(0);h[s>>3]=W}if(+h[n>>3]==0.0){c[k>>2]=1}w=1-r+g+(c[a>>2]|0)|0;if((r|0)<(q|0)){r=r+1|0;g=w}else{P=w;break}}}g=c[a>>2]|0;a=c[b>>2]|0;if((a|0)<=(g|0)){b=a;a=P;while(1){h[d+(a+ -1<<3)>>3]=+h[j+(b+ -1<<3)>>3];if((b|0)<(g|0)){a=a+1|0;b=b+1|0}else{break}}}if(!(+h[d+(P+ -1<<3)>>3]==0.0)){i=e;return 0}c[k>>2]=1;i=e;return 0}function D4(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0;s=i;t=c[d>>2]|0;u=~t;h[12389]=.5;h[12407]=6.283185307179586;v=+h[l>>3];h[12402]=v*v;c[24800]=0;l=c[b>>2]|0;c[24818]=l;c[24816]=l;w=c[b>>2]|0;c[24740]=1;if((w|0)<1){x=l;y=0}else{z=1;while(1){A=z+ -1|0;h[n+(A<<3)>>3]=+h[e+(A<<3)>>3];if((z|0)<(w|0)){z=z+1|0}else{break}}c[24740]=w+1;x=l;y=0}a:while(1){w=c[b>>2]|0;c[24740]=1;if((w|0)>=1){z=1;while(1){h[p+(z+ -1<<3)>>3]=0.0;if((z|0)<(w|0)){z=z+1|0}else{break}}c[24740]=w+1}z=c[d>>2]|0;c[24744]=1;if((z|0)>=1){e=1;while(1){h[12393]=0.0;A=c[b>>2]|0;c[24742]=1;if((A|0)<1){B=0.0}else{v=0.0;C=1;while(1){D=+h[f+((fa(C,t)|0)+u+e<<3)>>3];E=v+D*+h[n+(C+ -1<<3)>>3];h[12393]=E;if((C|0)<(A|0)){C=C+1|0;v=E}else{break}}c[24742]=A+1;B=E}v=+h[k+(e+ -1<<3)>>3]*B;h[12393]=v;C=c[b>>2]|0;c[24740]=1;if((C|0)>=1){D=v;F=1;while(1){v=D*+h[f+((fa(F,t)|0)+u+e<<3)>>3];G=p+(F+ -1<<3)|0;h[G>>3]=+h[G>>3]+v;if((F|0)>=(C|0)){break}D=+h[12393];F=F+1|0}c[24740]=C+1}F=e+1|0;c[24744]=F;if((e|0)<(z|0)){e=F}else{break}}}c[24754]=0;e=c[b>>2]|0;c[24742]=1;if((e|0)>=1){z=1;w=0;while(1){if((z|0)<1){H=1;I=w}else{F=z+ -1|0;A=p+(F<<3)|0;G=n+(F<<3)|0;F=z+1|0;J=1;K=w;while(1){L=j+(K<<3)|0;if((J|0)<(z|0)){M=J+ -1|0;h[A>>3]=+h[A>>3]+ +h[L>>3]*+h[n+(M<<3)>>3];N=M}else{N=J+ -1|0}M=p+(N<<3)|0;h[M>>3]=+h[L>>3]*+h[G>>3]+ +h[M>>3];if((J|0)<(z|0)){J=J+1|0;K=K+1|0}else{break}}K=z+w|0;c[24754]=K;H=F;I=K}if((z|0)<(e|0)){z=z+1|0;w=I}else{break}}c[24740]=H;c[24742]=e+1}do{if((y|0)==0){h[12391]=0.0;h[12373]=0.0;w=c[b>>2]|0;c[24740]=1;if((w|0)>=1){z=1;while(1){h[m+(z+ -1<<3)>>3]=0.0;K=z+ -1|0;h[q+(K<<3)>>3]=0.0;D=+h[g+(K<<3)>>3]+ +h[p+(K<<3)>>3];h[o+(K<<3)>>3]=D;h[n+(K<<3)>>3]=-D;h[12373]=+h[12373]+D*D;if((z|0)<(w|0)){z=z+1|0}else{break}}c[24740]=w+1}h[r>>3]=0.0;D=+h[12373];if(D==0.0){O=55;break a}h[12378]=0.0;h[12381]=0.0;h[12376]=D;h[12396]=D;P=D;Q=0.0;R=0.0;S=+h[12402];T=0}else{if((y|0)>(x|0)){h[12375]=0.0;h[12382]=0.0;h[12383]=0.0;z=c[b>>2]|0;c[24740]=1;if((z|0)<1){U=0.0;W=0.0;Z=0.0}else{D=0.0;v=0.0;_=0.0;F=1;while(1){K=F+ -1|0;$=_+ +h[n+(K<<3)>>3]*+h[o+(K<<3)>>3];h[12375]=$;K=F+ -1|0;J=p+(K<<3)|0;aa=v+ +h[J>>3]*+h[n+(K<<3)>>3];h[12382]=aa;ba=D+ +h[J>>3]*+h[m+(K<<3)>>3];h[12383]=ba;if((F|0)<(z|0)){F=F+1|0;_=$;v=aa;D=ba}else{break}}c[24740]=z+1;U=ba;W=$;Z=aa}D=+h[12389];v=D*(+h[12386]-Z);h[12374]=v;_=+h[12379];ca=_+v;h[12390]=ca;h[12394]=ca;h[12392]=ca;c[24810]=0;a[99040]=1;da=+h[12407]/50.0;h[12393]=da;c[24740]=1;F=0;ea=ca;ga=ca;w=1;while(1){ha=+(w|0)*da;ia=+X(+ha);ja=+Y(+ha);ka=ia*(_+ia*v)+ja*(W+ia*U);do{if(ka<ea){h[12392]=ka;c[24810]=w;h[12403]=ga;la=w;ma=ka}else{if((w|0)!=(F+1|0)){la=F;ma=ea;break}h[12404]=ka;la=F;ma=ea}}while(0);K=w+1|0;if((K|0)<50){F=la;ea=ma;w=K;ga=ka}else{break}}h[12398]=ha;h[12384]=ia;h[12387]=ja;h[12395]=ka;c[24740]=50;h[12394]=ka;if((la|0)==0){h[12403]=ka;O=46}else if((la|0)==49){h[12404]=ca;na=ca}else{O=46}if((O|0)==46){O=0;na=+h[12404]}h[12398]=0.0;ga=+h[12403];if(ga!=na){ea=ga-ma;h[12403]=ea;ga=na-ma;h[12404]=ga;oa=D*(ea-ga)/(ea+ga);h[12398]=oa;pa=oa}else{pa=0.0}oa=da*(+(la|0)+pa);h[12398]=oa;ga=+X(+oa);h[12384]=ga;ea=+Y(+oa);h[12387]=ea;oa=ca-ga*(_+ga*v)-ea*(W+ga*U);h[12399]=oa;h[12376]=0.0;w=c[b>>2]|0;c[24740]=1;if((w|0)<1){qa=0.0;ra=oa}else{oa=ea;ea=ga;F=1;z=0;while(1){K=m+(z<<3)|0;h[K>>3]=ea*+h[K>>3]+oa*+h[n+(z<<3)>>3];K=F+ -1|0;J=q+(K<<3)|0;ga=+h[12384]*+h[J>>3]+ +h[12387]*+h[p+(K<<3)>>3];h[J>>3]=ga;sa=+h[o+(K<<3)>>3]+ga;ta=+h[12376]+sa*sa;h[12376]=ta;if((F|0)>=(w|0)){break}K=F;oa=+h[12387];ea=+h[12384];F=F+1|0;z=K}c[24740]=w+1;qa=ta;ra=+h[12399]}ea=ra+ +h[12391];h[12391]=ea;if((y|0)<(l|0)&ra/ea>.01){ua=qa;va=x}else{O=55;break a}}else{h[12382]=0.0;z=c[b>>2]|0;c[24742]=1;do{if((z|0)<1){ea=+h[12406];h[12397]=ea;wa=ea;xa=0.0;O=11}else{ea=0.0;F=1;while(1){K=F+ -1|0;ya=ea+ +h[n+(K<<3)>>3]*+h[p+(K<<3)>>3];h[12382]=ya;if((F|0)<(z|0)){F=F+1|0;ea=ya}else{break}}c[24742]=z+1;ea=+h[12406];h[12397]=ea;if(!(ya>0.0)){wa=ea;xa=ya;O=11;break}ea=ya/+h[12373];h[12393]=ea;if((y|0)==1){h[r>>3]=ea;za=ea;Aa=+h[12393]}else{za=+h[r>>3];Aa=ea}h[r>>3]=!(za<=Aa)?Aa:za;ea=+h[12397];oa=+h[12376];v=+h[12382];_=oa/v;ca=ea<=_?ea:_;h[12397]=ca;Ba=oa;Ca=v;Da=ca}}while(0);if((O|0)==11){O=0;Ba=+h[12376];Ca=xa;Da=wa}ca=Da*(Ba-Da*+h[12389]*Ca);h[12388]=ca;h[12391]=+h[12391]+ca;h[12401]=Ba;h[12376]=0.0;z=c[b>>2]|0;c[24740]=1;if((z|0)<1){Ea=Da;Fa=0.0}else{w=1;ca=Da;while(1){F=w+ -1|0;K=m+(F<<3)|0;h[K>>3]=+h[K>>3]+ca*+h[n+(F<<3)>>3];F=w+ -1|0;K=q+(F<<3)|0;v=+h[K>>3]+ +h[12397]*+h[p+(F<<3)>>3];h[K>>3]=v;oa=+h[o+(F<<3)>>3]+v;Ga=+h[12376]+oa*oa;h[12376]=Ga;Ha=+h[12397];if((w|0)<(z|0)){ca=Ha;w=w+1|0}else{break}}c[24740]=z+1;Ea=Ha;Fa=Ga}if(Ea<+h[12406]){if(+h[12388]<=+h[12391]*.01){O=55;break a}if(Fa<=+h[12396]*1.0e-4|(y|0)==(l|0)){O=55;break a}ca=Fa/+h[12401];h[12393]=ca;h[12373]=0.0;h[12378]=0.0;h[12381]=0.0;w=c[b>>2]|0;c[24740]=1;if((w|0)<1){O=55;break a}else{Ia=ca;Ja=1;Ka=0}while(1){F=n+(Ka<<3)|0;h[F>>3]=Ia*+h[F>>3]- +h[o+(Ka<<3)>>3]- +h[q+(Ka<<3)>>3];F=Ja+ -1|0;K=n+(F<<3)|0;ca=+h[K>>3];La=+h[12373]+ca*ca;h[12373]=La;J=m+(F<<3)|0;Ma=+h[12378]+ +h[K>>3]*+h[J>>3];h[12378]=Ma;ca=+h[J>>3];Na=+h[12381]+ca*ca;h[12381]=Na;if((Ja|0)>=(w|0)){break}J=Ja;Ia=+h[12393];Ja=Ja+1|0;Ka=J}c[24740]=w+1;if(Ma<=0.0){O=55;break a}ca=+h[12402];if(Na<ca){P=La;Q=Ma;R=Na;S=ca;T=y;break}}h[r>>3]=0.0;c[24816]=y;ua=+h[12376];va=y}if(ua<=+h[12396]*1.0e-4){O=55;break a}h[12379]=0.0;h[12386]=0.0;z=c[b>>2]|0;c[24740]=1;if((z|0)<1){Oa=0.0;Pa=0.0}else{ca=0.0;oa=0.0;J=1;while(1){K=J+ -1|0;Qa=oa+ +h[m+(K<<3)>>3]*+h[o+(K<<3)>>3];h[12379]=Qa;K=J+ -1|0;Ra=ca+ +h[m+(K<<3)>>3]*+h[q+(K<<3)>>3];h[12386]=Ra;if((J|0)<(z|0)){J=J+1|0;oa=Qa;ca=Ra}else{break}}c[24740]=z+1;Oa=Ra;Pa=Qa}ca=Pa+Oa;h[12385]=ca;oa=+h[12402];v=ua*oa;if(ca/+V(+v)<=-.99){O=55;break a}J=y+1|0;c[24800]=J;_=+V(+(v-ca*ca));h[12393]=_;v=oa/_;h[12403]=v;oa=ca/_;h[12404]=oa;w=c[b>>2]|0;c[24740]=1;if((w|0)<1){x=va;y=J;continue a}else{Sa=oa;Ta=v;Ua=1;Va=0}while(1){h[n+(Va<<3)>>3]=Ta*(+h[o+(Va<<3)>>3]+ +h[q+(Va<<3)>>3])-Sa*+h[m+(Va<<3)>>3];if((Ua|0)>=(w|0)){break}K=Ua;Sa=+h[12404];Ta=+h[12403];Ua=Ua+1|0;Va=K}c[24740]=w+1;x=va;y=J;continue a}}while(0);e=T+1|0;c[24800]=e;v=S-R;h[12393]=v;h[12406]=v/(Q+ +V(+(Q*Q+v*P)));y=e;x=x}if((O|0)==55){i=s;return 0}return 0}function E4(b,d,e,f,g,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0,R=0;o=i;p=c[d>>2]|0;q=~p;r=c[j>>2]|0;j=~r;h[12416]=1.0;s=p-(c[b>>2]|0)|0;t=s+ -1|0;c[24838]=t;c[24828]=1;c[24822]=2;if((s|0)<3){u=1}else{s=2;v=1;while(1){do{if((s|0)==(c[g>>2]|0)){c[24828]=s;w=s}else{x=c[m>>2]|0;y=fa(s,p)|0;z=+h[f+(y+q+x<<3)>>3];if(!(z!=0.0)){w=v;break}A=fa(v,p)|0;B=x+q|0;x=f+(B+A<<3)|0;C=+h[x>>3];D=+V(+(z*z+C*C));h[12418]=D;C=+h[x>>3]/D;h[12425]=C;z=+h[f+(B+y<<3)>>3]/D;h[12426]=z;B=c[d>>2]|0;c[24820]=1;if((B|0)>=1){D=z;z=C;x=1;while(1){E=x+q|0;h[12418]=z*+h[f+(E+A<<3)>>3]+D*+h[f+(E+y<<3)>>3];E=x+q|0;F=f+(E+y<<3)|0;G=f+(E+A<<3)|0;h[F>>3]=z*+h[F>>3]-D*+h[G>>3];h[G>>3]=+h[12418];if((x|0)>=(B|0)){break}D=+h[12426];z=+h[12425];x=x+1|0}c[24820]=B+1}h[f+((c[m>>2]|0)+q+y<<3)>>3]=0.0;w=v}}while(0);x=s+1|0;c[24822]=x;if((s|0)<(t|0)){s=x;v=w}else{u=w;break}}}w=c[m>>2]|0;z=+h[f+(w+ -1<<3)>>3];h[12425]=z;if((c[g>>2]|0)>1){D=-z;h[12425]=D;H=D}else{H=z}v=(u|0)>1;if(v){h[12426]=+h[f+((fa(u,p)|0)+q+w<<3)>>3]}w=c[d>>2]|0;c[24820]=1;if((w|0)>=1){s=(fa(u,p)|0)+q|0;z=H;t=1;x=0;while(1){h[n+(x<<3)>>3]=z*+h[f+(x<<3)>>3];if(v){A=n+(t+ -1<<3)|0;h[A>>3]=+h[A>>3]+ +h[12426]*+h[f+(s+t<<3)>>3]}if((t|0)>=(w|0)){break}A=t;z=+h[12425];t=t+1|0;x=A}c[24820]=w+1}w=(c[m>>2]|0)+ -1|0;z=+h[n+(w<<3)>>3];h[12423]=z;x=k+(w<<3)|0;H=+h[x>>3];h[12417]=H;D=H*H;h[12427]=D;h[12424]=D+z*+h[l>>3];h[x>>3]=+h[x>>3]- +h[12416];a[99360]=0;do{if((u|0)==1){z=+h[12424];if(!(z>=0.0)){I=-z}else{I=z}z=+V(+I);h[12418]=z;D=+h[12425]/z;h[12426]=D;H=+h[12417]/z;h[12425]=H;x=c[d>>2]|0;c[24820]=1;if((x|0)<1){J=z}else{z=D;D=H;w=1;t=0;while(1){s=f+(t<<3)|0;h[s>>3]=D*+h[s>>3]-z*+h[k+(t<<3)>>3];if((w|0)>=(x|0)){break}s=w;z=+h[12426];D=+h[12425];w=w+1|0;t=s}c[24820]=x+1;J=+h[12418]}t=c[g>>2]|0;if((t|0)==1&J<0.0){c[g>>2]=2;K=2}else{K=t}if(!((K|0)<2|!(J>=0.0))){L=46}}else{c[24824]=1;if(!(+h[l>>3]>=0.0)){M=1}else{c[24824]=u;M=u}t=u+1-M|0;c[24826]=t;w=fa(t,p)|0;t=(c[m>>2]|0)+q|0;D=+h[12424];z=+h[f+(t+w<<3)>>3]/D;h[12418]=z;h[12425]=z*+h[l>>3];H=+h[12417];h[12426]=z*H;s=fa(M,p)|0;z=+h[f+(t+s<<3)>>3];h[12418]=z;C=+h[l>>3];if(!(C>=0.0)){N=-C}else{N=C}C=+h[12416]/+V(+(+h[12427]+z*N*z));h[12421]=C;if(!(D>=0.0)){O=-D}else{O=D}h[12422]=C*+V(+O);t=c[d>>2]|0;c[24820]=1;if((t|0)<1){P=D}else{D=z;z=H;H=C;v=1;while(1){A=f+(v+q+s<<3)|0;h[A>>3]=H*(z*+h[A>>3]-D*+h[k+(v+ -1<<3)>>3]);A=f+(v+q+w<<3)|0;G=v+ -1|0;h[A>>3]=+h[12422]*(+h[A>>3]- +h[12425]*+h[n+(G<<3)>>3]- +h[12426]*+h[k+(G<<3)>>3]);if((v|0)>=(t|0)){break}D=+h[12418];z=+h[12417];H=+h[12421];v=v+1|0}c[24820]=t+1;P=+h[12424]}if(!(P<=0.0)){break}H=+h[l>>3];if(H<0.0){c[g>>2]=(c[g>>2]|0)+1}if(H>=0.0){L=46}}}while(0);do{if((L|0)==46){a[99360]=1;c[g>>2]=(c[g>>2]|0)+ -1;M=c[d>>2]|0;c[24820]=1;if((M|0)<1){break}else{Q=1}while(1){u=f+(Q+ -1<<3)|0;h[12418]=+h[u>>3];K=f+(Q+q+(fa(c[g>>2]|0,p)|0)<<3)|0;h[u>>3]=+h[K>>3];h[K>>3]=+h[12418];K=Q+1|0;c[24820]=K;if((Q|0)<(M|0)){Q=K}else{break}}}}while(0);Q=c[b>>2]|0;c[24822]=1;if((Q|0)<1){i=o;return 0}else{R=1}while(1){b=(c[d>>2]|0)+R|0;c[24830]=b;p=fa(R,r)|0;P=+h[e+((c[m>>2]|0)+j+p<<3)>>3];g=b+ -1|0;q=n+(g<<3)|0;h[q>>3]=P;f=k+(g<<3)|0;O=+h[12417];N=+h[12424];J=(+h[12423]*+h[f>>3]-O*P)/N;h[12425]=J;P=(-(+h[l>>3]*+h[q>>3])-O*+h[f>>3])/N;h[12426]=P;c[24820]=1;a:do{if((b|0)>=1){N=P;O=J;f=1;while(1){q=e+(f+j+p<<3)|0;g=f+ -1|0;I=+h[q>>3]+O*+h[k+(g<<3)>>3]+N*+h[n+(g<<3)>>3];h[q>>3]=I;q=c[d>>2]|0;if((f|0)>(q|0)){h[e+((fa(f-q|0,r)|0)+j+b<<3)>>3]=I}q=f+1|0;c[24820]=q;if((f|0)>=(b|0)){break a}N=+h[12426];O=+h[12425];f=q}}}while(0);b=R+1|0;c[24822]=b;if((R|0)<(Q|0)){R=b}else{break}}i=o;return 0}function F4(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0;m=i;if((b|0)<(d|0)){n=(b|0)<(e|0);o=0.0;p=-1;q=-1;r=b;while(1){if(n){s=c[f+(r<<2)>>2]|0;t=b;u=o;v=p;w=q;while(1){x=+U(+(+h[a+((fa(c[g+(t<<2)>>2]|0,d)|0)+s<<3)>>3]));y=x>u;z=y?r:w;A=y?t:v;B=y?x:u;y=t+1|0;if((y|0)<(e|0)){w=z;v=A;u=B;t=y}else{C=B;D=A;E=z;break}}}else{C=o;D=p;E=q}t=r+1|0;if((t|0)<(d|0)){o=C;p=D;q=E;r=t}else{F=C;G=D;H=E;break}}}else{F=0.0;G=-1;H=-1}if((G|H|0)<0){I=-1;i=m;return I|0}c[j>>2]=H;c[k>>2]=G;h[l>>3]=F;I=0;i=m;return I|0}function G4(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;m=(b|0)<=(d|0)?b:d;if((m|0)>0){n=0}else{o=0;i=g;return o|0}while(1){p=e+(n<<2)|0;q=f+(n<<2)|0;r=+h[a+((fa(c[q>>2]|0,b)|0)+(c[p>>2]|0)<<3)>>3];if((F4(a,n,b,d,e,f,j,k,l)|0)!=0){o=-1;s=14;break}t=+U(+r);if(+h[l>>3]>t*1.125){u=c[p>>2]|0;v=e+(c[j>>2]<<2)|0;c[p>>2]=c[v>>2];c[v>>2]=u;u=c[q>>2]|0;v=f+(c[k>>2]<<2)|0;c[q>>2]=c[v>>2];c[v>>2]=u}u=c[p>>2]|0;p=fa(c[q>>2]|0,b)|0;t=+h[a+(p+u<<3)>>3];if(!(t!=0.0)){s=7;break}q=n+1|0;if((q|0)<(b|0)){v=(q|0)<(d|0);w=q;do{x=c[e+(w<<2)>>2]|0;y=a+(p+x<<3)|0;r=+h[y>>3];do{if(r!=0.0){z=-r/t;h[y>>3]=0.0;if(v){A=q}else{break}do{B=fa(c[f+(A<<2)>>2]|0,b)|0;C=a+(B+x<<3)|0;h[C>>3]=+h[C>>3]+z*+h[a+(u+B<<3)>>3];A=A+1|0;}while((A|0)<(d|0))}}while(0);w=w+1|0;}while((w|0)<(b|0))}if((q|0)<(m|0)){n=q}else{o=0;s=14;break}}if((s|0)==7){bb(99424,99440,116,99464)}else if((s|0)==14){i=g;return o|0}return 0}function H4(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=e;c[u>>2]=0;v=b+280|0;w=c[v>>2]|0;x=1;while(1){y=x+1|0;if((hxa(w,c[99472+(x<<2)>>2]|0)|0)==0){z=4;break}if((y|0)<8){x=y}else{break}}do{if((z|0)==4){c[u>>2]=x;if((x|0)==0){break}y=c[99576+(x<<2)>>2]|0;c[q>>2]=c[99472+(x<<2)>>2];c[q+4>>2]=y;V1(23,0,99648,q);y=b+112|0;A=e+28|0;c[A>>2]=(c[y>>2]|0)+20;B=c[y>>2]|0;C=b+160|0;D=((c[C>>2]|0)*3|0)+50+(fa(B+9|0,B)|0)|0;c[e+32>>2]=D;B=Lwa(D,8)|0;c[e+40>>2]=B;D=b+536|0;Y1(c[D>>2]|0,(B|0)!=0|0,99688,p);B=Lwa(c[A>>2]|0,4)|0;c[e+36>>2]=B;Y1(c[D>>2]|0,(B|0)!=0|0,99688,o);c[e+56>>2]=c[C>>2];c[e+52>>2]=0;c[e+60>>2]=Lwa(c[C>>2]|0,4)|0;c[e+24>>2]=Jwa(8)|0;C=Jwa(4)|0;c[e+20>>2]=C;c[C>>2]=c[70944>>2];Y1(c[D>>2]|0,(C|0)!=0|0,99688,n);C=c[y>>2]<<3;B=e+48|0;c[B>>2]=Jwa(C)|0;A=e+44|0;c[A>>2]=Jwa(C)|0;C=Lwa(15,4)|0;E=e+12|0;c[E>>2]=C;Y1(c[D>>2]|0,(C|0)!=0|0,99688,m);C=Lwa(5,4)|0;c[e+4>>2]=C;Y1(c[D>>2]|0,(C|0)!=0|0,99688,l);C=Lwa(5,4)|0;c[e+8>>2]=C;Y1(c[D>>2]|0,(C|0)!=0|0,99688,k);c[e+16>>2]=0;h[e+64>>3]=1.4901161193847656e-8;C=c[y>>2]<<3;c[e+72>>2]=Jwa(C)|0;c[e+76>>2]=Jwa(C)|0;c[e+80>>2]=Jwa(C)|0;C=c[E>>2]|0;c[C+8>>2]=1;D=c[u>>2]|0;a:do{switch(D|0){case 7:case 1:case 2:case 4:case 5:case 3:{if((ae[c[(c[b+540>>2]|0)+140>>2]&127](b)|0)==0){F=c[E>>2]|0;c[F+16>>2]=1;G=F;H=c[u>>2]|0;z=17;break a}if((c[y>>2]|0)==1){V1(23,0,99704,j)}else{V1(1,0,99776,g)}c[u>>2]=6;z=18;break};default:{G=C;H=D;z=17}}}while(0);if((z|0)==17){if((H|0)==2){I=G}else{z=18}}if((z|0)==18){a[d+28|0]=1;I=c[E>>2]|0}c[I+4>>2]=1;D=c[y>>2]|0;if((D|0)<=0){i=f;return 0}C=b+272|0;F=c[A>>2]|0;J=c[b+8>>2]|0;K=c[B>>2]|0;L=0;do{h[F+(L<<3)>>3]=+h[C>>3];h[K+(L<<3)>>3]=+h[C>>3]*+h[J+(L*112|0)+80>>3];L=L+1|0;}while((L|0)<(D|0));i=f;return 0}}while(0);if((c[70980>>2]|c[17720]|0)==0){M=w;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=6;U=T;V=99608;W=V;Z1(Q,W,r)}c[t>>2]=w;X1(23,1,99504,t);t=1;do{w=c[99576+(t<<2)>>2]|0;c[s>>2]=c[99472+(t<<2)>>2];c[s+4>>2]=w;X1(23,0,99560,s);t=t+1|0;}while((t|0)<8);Zd[c[17860]&1023](23);M=c[v>>2]|0;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=6;U=T;V=99608;W=V;Z1(Q,W,r);return 0}function I4(a){a=a|0;var b=0;b=i;Kwa(c[a+40>>2]|0);Kwa(c[a+36>>2]|0);Kwa(c[a+20>>2]|0);Kwa(c[a+12>>2]|0);Kwa(c[a+4>>2]|0);Kwa(c[a+8>>2]|0);Kwa(a);i=b;return 0}function J4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;h[D>>3]=0.0;E=a+4|0;F=c[E>>2]|0;G=c[F>>2]|0;H=c[b+48>>2]|0;I=(c[F+4>>2]|0)+8|0;F=c[I>>2]|0;J=a+112|0;K=c[J>>2]|0;L=F+(K<<3)|0;M=H+24|0;c[c[M>>2]>>2]=a;c[(c[M>>2]|0)+4>>2]=H;N=a+536|0;Y1(c[N>>2]|0,(c[M>>2]|0)!=0|0,99872,C);if((c[b+36>>2]|0)!=0){c[c[H+12>>2]>>2]=0;c[H+16>>2]=0}C=b;O=+h[C>>3];P=b+8|0;Q=O+ +h[P>>3];h[D>>3]=Q;if(O-Q>=-1.0e-13){V1(3,0,99904,B);V1(3,0,99944,A);A=c[J>>2]|0;if((A|0)>0){B=c[I>>2]|0;I=c[G+8>>2]|0;R=0;do{h[I+(R<<3)>>3]=+h[B+(R<<3)>>3]+ +h[F+(R+K<<3)>>3]*+h[P>>3];R=R+1|0;}while((R|0)<(A|0))}h[G>>3]=+h[D>>3];ae[c[(c[a+540>>2]|0)+28>>2]&127](a)|0;h[C>>3]=+h[D>>3];S=0;i=d;return S|0}A=z;h[k>>3]=O;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];V1(3,0,99968,z);z=H+16|0;A=z;R=a;P=b+24|0;b=H+12|0;K=H+44|0;F=H+48|0;B=H+40|0;I=H+32|0;T=H+36|0;U=H+28|0;V=U;W=H+20|0;X=H+52|0;Y=H+56|0;Z=H+60|0;_=c[r>>2]|0;$=c[t>>2]|0;aa=a+248|0;ba=a+540|0;ca=G;G=L;a:while(1){Q=+h[D>>3];L=y;h[k>>3]=+h[C>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=y+8|0;h[k>>3]=Q;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];V1(23,0,100008,y);if((c[z>>2]|0)==1){w3(c[R>>2]|0,1,c[E>>2]|0);L=c[E>>2]|0;da=c[L>>2]|0;ea=(c[(c[L+4>>2]|0)+8>>2]|0)+(c[J>>2]<<3)|0;h[da>>3]=+h[C>>3];fa=da;ga=ea}else{fa=ca;ga=G}if((c[P>>2]|0)!=5){A6(a)|0;ae[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ea=c[H>>2]|0;b:do{switch(ea|0){case 7:{S3(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,7,3,X,0)|0;break};case 3:{S3(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,3,2,Y,c[Z>>2]|0)|0;break};case 6:{S3(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,6,2,Y,c[Z>>2]|0)|0;break};case 4:{S3(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,4,2,Y,c[Z>>2]|0)|0;break};case 5:{S3(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,5,2,Y,c[Z>>2]|0)|0;break};default:{da=c[fa+8>>2]|0;L=c[b>>2]|0;ha=c[K>>2]|0;ia=c[F>>2]|0;ja=c[B>>2]|0;ka=c[T>>2]|0;la=c[M>>2]|0;ma=c[W>>2]|0;if((ea|0)==2){S3(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,3,X,0)|0;break b}else{S3(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,2,Y,c[Z>>2]|0)|0;break b}}}}while(0);ea=c[z>>2]|0;do{if((ea|0)==-1){nd(_|0)|0;nd($|0)|0;X1(3,0,100040,x);V1(3,0,100128,w);c[c[b>>2]>>2]=1}else{if((ea|0)<0){na=25;break a}if((ea|0)!=4){break}c[(c[N>>2]|0)+84>>2]=4}}while(0);ea=c[z>>2]|0;if((ea|0)==1){ca=fa;G=ga;continue}else if(!((ea|0)==-1)){na=31;break}Q=+h[C>>3];if(!(Q<=+h[aa>>3])){oa=Q;break}else{ca=fa;G=ga}}if((na|0)==25){nd(_|0)|0;nd($|0)|0;$=S4(c[z>>2]|0)|0;if((c[P>>2]|0)!=5){A6(a)|0;ae[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ae[c[(c[ba>>2]|0)+28>>2]&127](a)|0;a=v;h[k>>3]=+h[fa>>3];c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];X1(1,0,100152,v);S=$;i=d;return S|0}else if((na|0)==31){oa=+h[C>>3]}h[fa>>3]=oa;if((c[70900>>2]|0)!=0){V1(3,1,100184,u);c[s>>2]=c[z>>2];V1(3,0,100208,s);s=q;h[k>>3]=+h[C>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];V1(3,0,100232,q);q=p;h[k>>3]=+h[(c[B>>2]|0)+24>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];V1(3,0,100264,p);p=o;h[k>>3]=+h[(c[B>>2]|0)+16>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];V1(3,0,100304,o);o=n;h[k>>3]=+h[(c[B>>2]|0)+48>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];V1(3,0,100352,n);c[m>>2]=c[(c[T>>2]|0)+40>>2];V1(3,0,100400,m);c[l>>2]=c[(c[T>>2]|0)+44>>2];V1(3,0,100440,l);c[j>>2]=c[(c[T>>2]|0)+48>>2];V1(3,0,100480,j);c[g>>2]=c[(c[T>>2]|0)+52>>2];V1(3,0,100520,g);c[f>>2]=c[(c[T>>2]|0)+56>>2];V1(3,0,100568,f);Zd[c[17860]&1023](3)}f=c[U>>2]|0;U=H+8|0;H=0;do{g=H+10|0;if(!(g>>>0<f>>>0)){na=37;break}c[(c[U>>2]|0)+(H<<2)>>2]=c[(c[T>>2]|0)+(g<<2)>>2];H=H+1|0;}while(H>>>0<5);if((na|0)==37){bb(100608,100640,410,100672)}V1(3,0,100688,e);S=0;i=d;return S|0}function K4(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;f=c[g>>2]|0;g=f;b=f+536|0;k=f+4|0;l=c[c[k>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[a>>3];a=(c[b>>2]|0)+84|0;l=c[a>>2]|0;c[a>>2]=2;A6(g)|0;a=f+540|0;ae[c[(c[a>>2]|0)+40>>2]&127](g)|0;ae[c[(c[a>>2]|0)+28>>2]&127](g)|0;g=c[f+112>>2]|0;if((g|0)<=0){n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;a=0;do{h[e+(a<<3)>>3]=+h[f+(g+a<<3)>>3]- +h[d+(a<<3)>>3];a=a+1|0;}while((a|0)<(g|0));n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}function L4(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;A6(l)|0;b=k+540|0;ae[c[(c[b>>2]|0)+40>>2]&127](l)|0;ae[c[(c[b>>2]|0)+28>>2]&127](l)|0;U4(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function M4(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0;j=i;e=c[g>>2]|0;g=e;d=e+536|0;a=(c[d>>2]|0)+84|0;k=c[a>>2]|0;c[a>>2]=4;a=e+4|0;l=c[c[a>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[b>>3];A6(g)|0;l=e+540|0;ae[c[(c[l>>2]|0)+40>>2]&127](g)|0;ae[c[(c[l>>2]|0)+28>>2]&127](g)|0;ae[c[(c[l>>2]|0)+32>>2]&127](g)|0;de[c[(c[l>>2]|0)+92>>2]&63](g,f,b)|0;c[(c[d>>2]|0)+84>>2]=k;h[c[c[a>>2]>>2]>>3]=m;i=j;return 0}function N4(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;V4(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function O4(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;A6(l)|0;b=k+540|0;ae[c[(c[b>>2]|0)+40>>2]&127](l)|0;ae[c[(c[b>>2]|0)+28>>2]&127](l)|0;T4(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function P4(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;i=i;return 0}function Q4(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;W4(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function R4(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i;return 0}function S4(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;c=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;switch(a|0){case-10:{X1(1,0,101e3,e);m=-10;i=b;return m|0};case-11:{X1(1,0,101096,d);m=-11;i=b;return m|0};case-9:{X1(1,0,100912,f);m=-9;i=b;return m|0};case-1:{X1(3,0,100040,l);m=1;i=b;return m|0};case-7:{X1(1,0,100824,h);m=-7;i=b;return m|0};case-12:{X1(1,0,101184,c);m=-12;i=b;return m|0};case-3:{m=-3;i=b;return m|0};case-6:{X1(1,0,100752,j);m=-6;i=b;return m|0};case-8:{X1(1,0,100864,g);m=-8;i=b;return m|0};case-2:{X1(1,0,100712,k);m=-2;i=b;return m|0};case-33:{X1(1,0,101232,b);m=-33;i=b;return m|0};default:{m=-1;i=b;return m|0}}return 0}function T4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+540|0;f=c[(c[e>>2]|0)+120>>2]|0;g=a+464|0;j=c[g>>2]|0;if((c[j+(f*44|0)+24>>2]|0)==0){i=d;return 0}k=a;a=c[j+(f*44|0)>>2]|0;l=j;j=0;do{if((a|0)!=0){m=0;do{if(((c[(c[l+(f*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}ae[c[(c[e>>2]|0)+160>>2]&127](k)|0;l=c[g>>2]|0;a=c[l+(f*44|0)>>2]|0;do{if((a|0)!=0){m=c[l+(f*44|0)+28>>2]|0;n=0;do{do{if(+h[m+(n<<3)>>3]==1.0){if((n|0)==0){o=l+(f*44|0)+8|0;p=0}else{q=l+(f*44|0)+8|0;o=q;p=c[(c[q>>2]|0)+(n+ -1<<2)>>2]|0}q=c[(c[o>>2]|0)+(n<<2)>>2]|0;if(!(p>>>0<q>>>0)){break}r=c[l+(f*44|0)+12>>2]|0;s=c[l+(f*44|0)+4>>2]|0;t=c[l+(f*44|0)+36>>2]|0;u=p;do{v=c[r+(u<<2)>>2]|0;w=(fa(s,n)|0)+v|0;h[b+(w<<3)>>3]=+h[t+(v<<3)>>3];u=u+1|0;}while(u>>>0<q>>>0)}}while(0);n=n+1|0;}while(n>>>0<a>>>0);if((a|0)==0){break}n=c[l+(f*44|0)+20>>2]|0;m=0;do{if(((c[n+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=0.0}m=m+1|0;}while(m>>>0<a>>>0)}}while(0);j=j+1|0;}while(j>>>0<(c[l+(f*44|0)+24>>2]|0)>>>0);i=d;return 0}function U4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+540|0;f=c[e>>2]|0;g=c[f+120>>2]|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)>>2]|0)==0){i=d;return 0}l=a;a=f;f=c[k+(g*44|0)+28>>2]|0;k=0;m=0;while(1){h[f+(k<<3)>>3]=1.0;ae[c[a+160>>2]&127](l)|0;n=c[j>>2]|0;o=c[n+(g*44|0)+4>>2]|0;if((o|0)==0){p=m}else{q=o>>>0>1?o:1;r=c[n+(g*44|0)+36>>2]|0;s=0;t=m;while(1){h[b+(t<<3)>>3]=+h[r+(s<<3)>>3];u=s+1|0;if(u>>>0<o>>>0){t=t+1|0;s=u}else{break}}p=m+q|0}s=c[n+(g*44|0)+28>>2]|0;h[s+(k<<3)>>3]=0.0;t=k+1|0;if(!(t>>>0<(c[n+(g*44|0)>>2]|0)>>>0)){break}a=c[e>>2]|0;f=s;k=t;m=p}i=d;return 0}function V4(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;n=i;j=c[m+4>>2]|0;o=+h[j+64>>3];p=a+112|0;a=c[p>>2]|0;if((a|0)<=0){i=n;return 0}q=j+80|0;j=a;do{j=j+ -1|0;r=+h[k>>3]*+h[e+(j<<3)>>3];a=d+(j<<3)|0;s=+h[a>>3];if(!(s>=0.0)){t=-s}else{t=s}u=r>=0.0;if(u){v=r}else{v=-r}r=+md(+t,+v);w=+h[l+(j<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}w=o*+md(+r,+x);if(u){y=w}else{y=-w}w=y+s-s;r=1.0/w;h[a>>3]=s+w;K4(b,0,e,c[q>>2]|0,0,m,0)|0;u=c[p>>2]|0;if((u|0)>0){z=c[q>>2]|0;A=fa(u,j)|0;B=u;do{B=B+ -1|0;h[g+(A+B<<3)>>3]=r*(+h[z+(B<<3)>>3]- +h[f+(B<<3)>>3]);}while((B|0)>0)}h[a>>3]=s;}while((j|0)>0);i=n;return 0}



function LZ(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;l=i;i=i+392|0;m=l+32|0;n=l+88|0;o=l+104|0;p=l+128|0;q=l+168|0;r=l+184|0;s=l+232|0;t=l+248|0;u=l+344|0;v=l+352|0;w=l+368|0;x=l+384|0;y=b;b=e;e=f;c[m>>2]=g;g=h;h=j;j=k;k=c[y+356>>2]|0;f=y;if((e|0)==(c[y+144>>2]|0)){z=f+288|0;A=y+292|0}else{z=c[f+300>>2]|0;A=(c[y+300>>2]|0)+4|0}c[z>>2]=c[m>>2];a:while(1){c[n>>2]=c[m>>2];f=ze[c[e+4>>2]&63](e,c[m>>2]|0,g,n)|0;c[A>>2]=c[n>>2];b:do{switch(f|0){case 0:{B=24;break a;break};case 1:case 2:{C=y;if((c[y+368>>2]|0)!=0){D=c[C+368>>2]|0;c[y+368>>2]=c[c[y+368>>2]>>2]}else{D=ae[c[C+12>>2]&127](48)|0;if((D|0)==0){B=72;break a}c[D+36>>2]=ae[c[y+12>>2]&127](32)|0;if((c[D+36>>2]|0)==0){B=74;break a}c[D+40>>2]=(c[D+36>>2]|0)+32}c[D+44>>2]=0;c[D>>2]=c[y+364>>2];c[y+364>>2]=D;c[D+16>>2]=0;c[D+20>>2]=0;c[D+4>>2]=(c[m>>2]|0)+(c[e+68>>2]|0);c[D+8>>2]=pe[c[e+32>>2]&63](e,c[D+4>>2]|0)|0;C=y+312|0;c[C>>2]=(c[C>>2]|0)+1;C=(c[D+4>>2]|0)+(c[D+8>>2]|0)|0;c[r>>2]=c[D+4>>2];c[q>>2]=c[D+36>>2];while(1){Wd[c[e+60>>2]&31](e,r,C,q,(c[D+40>>2]|0)+ -1|0);E=(c[q>>2]|0)-(c[D+36>>2]|0)|0;if((c[r>>2]|0)==(C|0)){break}F=(c[D+40>>2]|0)-(c[D+36>>2]|0)<<1;G=pe[c[y+16>>2]&63](c[D+36>>2]|0,F)|0;if((G|0)==0){B=80;break a}c[D+36>>2]=G;c[D+40>>2]=G+F;c[q>>2]=G+E}c[D+24>>2]=E;c[D+12>>2]=c[D+36>>2];a[c[q>>2]|0]=0;H=OZ(y,e,c[m>>2]|0,D+12|0,D+44|0)|0;if((H|0)!=0){B=82;break a}C=y;do{if((c[y+52>>2]|0)!=0){we[c[C+52>>2]&15](c[y+4>>2]|0,c[D+12>>2]|0,c[y+392>>2]|0)}else{if((c[C+80>>2]|0)==0){break}eZ(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);PY(y+416|0);break};case-4:{B=17;break a;break};case 9:{a[p]=de[c[e+48>>2]&63](e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((a[p]|0)!=0){C=y;if((c[y+60>>2]|0)!=0){we[c[C+60>>2]&15](c[y+4>>2]|0,p,1);break b}if((c[C+80>>2]|0)==0){break b}eZ(y,e,c[m>>2]|0,c[n>>2]|0);break b}C=sZ(k+80|0,e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((C|0)==0){B=37;break a}G=jZ(y,k,C,0)|0;c[k+92>>2]=c[k+96>>2];do{if((a[k+129|0]|0)!=0){if((d[k+130|0]|0)!=0){B=40;break}if((G|0)!=0){break}F=y;if((c[y+120>>2]|0)!=0){we[c[F+120>>2]&15](c[y+4>>2]|0,C,0);break b}if((c[F+80>>2]|0)==0){break b}eZ(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{B=40}}while(0);if((B|0)==40){B=0;if((G|0)==0){B=41;break a}if((a[G+34|0]|0)==0){B=43;break a}}if((a[G+32|0]|0)!=0){B=50;break a}if((c[G+28>>2]|0)!=0){B=52;break a}C=y;if((c[G+4>>2]|0)!=0){F=y;if((a[C+308|0]|0)!=0){I=FZ(F,G,0)|0;if((I|0)!=0){B=60;break a}else{break b}}J=y;if((c[F+120>>2]|0)!=0){we[c[J+120>>2]&15](c[y+4>>2]|0,c[G>>2]|0,0);break b}if((c[J+80>>2]|0)==0){break b}eZ(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{if((c[C+112>>2]|0)==0){if((c[y+80>>2]|0)==0){break b}eZ(y,e,c[m>>2]|0,c[n>>2]|0);break b}a[G+32|0]=1;C=NZ(y)|0;a[G+32|0]=0;if((C|0)==0){B=63;break a}if((qe[c[y+112>>2]&63](c[y+116>>2]|0,C,c[G+20>>2]|0,c[G+16>>2]|0,c[G+24>>2]|0)|0)==0){B=65;break a}c[y+428>>2]=c[y+432>>2];break b}break};case 3:case 4:{C=(c[m>>2]|0)+(c[e+68>>2]|0)|0;c[s>>2]=0;J=1;c[t>>2]=sZ(y+416|0,e,C,C+(pe[c[e+32>>2]&63](e,C)|0)|0)|0;if((c[t>>2]|0)==0){B=89;break a}c[y+432>>2]=c[y+428>>2];K=OZ(y,e,c[m>>2]|0,t,s)|0;if((K|0)!=0){B=91;break a}c[y+432>>2]=c[y+428>>2];if((c[y+52>>2]|0)!=0){we[c[y+52>>2]&15](c[y+4>>2]|0,c[t>>2]|0,c[y+392>>2]|0);J=0}if((c[y+56>>2]|0)!=0){if((c[y+52>>2]|0)!=0){c[z>>2]=c[A>>2]}_d[c[y+56>>2]&127](c[y+4>>2]|0,c[t>>2]|0);J=0}do{if((J&255|0)!=0){if((c[y+80>>2]|0)==0){break}eZ(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);PY(y+416|0);while(1){if((c[s>>2]|0)==0){break}J=c[s>>2]|0;if((c[y+104>>2]|0)!=0){_d[c[y+104>>2]&127](c[y+4>>2]|0,c[c[J>>2]>>2]|0)}c[s>>2]=c[(c[s>>2]|0)+4>>2];c[J+4>>2]=c[y+376>>2];c[y+376>>2]=J;c[(c[J>>2]|0)+4>>2]=c[J+8>>2]}if((c[y+312>>2]|0)==0){B=107;break a}break};case 5:{if((c[y+312>>2]|0)==(b|0)){B=109;break a}J=c[y+364>>2]|0;c[y+364>>2]=c[J>>2];c[J>>2]=c[y+368>>2];c[y+368>>2]=J;L=(c[m>>2]|0)+(c[e+68>>2]<<1)|0;G=pe[c[e+32>>2]&63](e,L)|0;if((G|0)!=(c[J+8>>2]|0)){B=112;break a}if((gxa(c[J+4>>2]|0,L,G)|0)!=0){B=112;break a}G=y+312|0;c[G>>2]=(c[G>>2]|0)+ -1;do{if((c[y+56>>2]|0)!=0){G=c[J+16>>2]|0;do{if((d[y+236|0]|0)!=0){if((G|0)==0){break}C=(c[J+12>>2]|0)+(c[J+28>>2]|0)|0;while(1){if((a[G]|0)==0){break}F=G;G=F+1|0;M=C;C=M+1|0;a[M]=a[F]|0}F=c[J+20>>2]|0;c:do{if((d[y+237|0]|0)!=0){if((F|0)==0){break}M=C;C=M+1|0;a[M]=a[y+472|0]|0;while(1){if((a[F]|0)==0){break c}M=F;F=M+1|0;N=C;C=N+1|0;a[N]=a[M]|0}}}while(0);a[C]=0}}while(0);_d[c[y+56>>2]&127](c[y+4>>2]|0,c[J+12>>2]|0)}else{if((c[y+80>>2]|0)==0){break}eZ(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);while(1){if((c[J+44>>2]|0)==0){break}G=c[J+44>>2]|0;if((c[y+104>>2]|0)!=0){_d[c[y+104>>2]&127](c[y+4>>2]|0,c[c[G>>2]>>2]|0)}c[J+44>>2]=c[(c[J+44>>2]|0)+4>>2];c[G+4>>2]=c[y+376>>2];c[y+376>>2]=G;c[(c[G>>2]|0)+4>>2]=c[G+8>>2]}if((c[y+312>>2]|0)==0){B=133;break a}break};case 12:{B=140;break a;break};case 7:{if((c[y+60>>2]|0)!=0){a[v]=10;we[c[y+60>>2]&15](c[y+4>>2]|0,v,1);break b}if((c[y+80>>2]|0)==0){break b}eZ(y,e,c[m>>2]|0,c[n>>2]|0);break};case 10:{J=pe[c[e+44>>2]&63](e,c[m>>2]|0)|0;if((J|0)<0){B=135;break a}G=y;if((c[y+60>>2]|0)!=0){F=c[G+60>>2]|0;M=c[y+4>>2]|0;N=a_(J,u)|0;we[F&15](M,u,N);break b}if((c[G+80>>2]|0)==0){break b}eZ(y,e,c[m>>2]|0,c[n>>2]|0);break};case 8:{G=y;do{if((c[y+72>>2]|0)!=0){Zd[c[G+72>>2]&1023](c[y+4>>2]|0)}else{if((c[G+80>>2]|0)==0){break}eZ(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);O=QZ(y,e,n,g,h,j)|0;if((O|0)!=0){B=150;break a}if((c[n>>2]|0)==0){B=152;break a}break};case-5:{B=153;break a;break};case 6:{G=c[y+60>>2]|0;if((G|0)==0){if((c[y+80>>2]|0)==0){break b}eZ(y,e,c[m>>2]|0,c[n>>2]|0);break b}if((a[e+72|0]|0)!=0){we[G&15](c[y+4>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0);break b}while(1){c[x>>2]=c[y+44>>2];Wd[c[e+60>>2]&31](e,m,c[n>>2]|0,x,c[y+48>>2]|0);c[A>>2]=c[m>>2];we[G&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[x>>2]|0)-(c[y+44>>2]|0)|0);if((c[m>>2]|0)==(c[n>>2]|0)){break b}c[z>>2]=c[m>>2]}break};case 13:{if((IZ(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=176;break a}break};case 11:{if((HZ(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=174;break a}break};case-2:{B=28;break a;break};case-3:{B=6;break a;break};case-1:{B=25;break a;break};default:{if((c[y+80>>2]|0)==0){break b}eZ(y,e,c[m>>2]|0,c[n>>2]|0)}}}while(0);f=c[n>>2]|0;c[m>>2]=f;c[z>>2]=f;f=c[y+480>>2]|0;if((f|0)==2){B=181;break}else if((f|0)==3){B=180;break}}if((B|0)==6){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}c[A>>2]=g;do{if((c[y+60>>2]|0)!=0){a[o]=10;we[c[y+60>>2]&15](c[y+4>>2]|0,o,1)}else{if((c[y+80>>2]|0)==0){break}eZ(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=g;P=0;Q=P;i=l;return Q|0}}else if((B|0)==17){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}if((b|0)<=0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}}else if((B|0)==24){c[z>>2]=c[n>>2];P=4;Q=P;i=l;return Q|0}else if((B|0)==25){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=5;Q=P;i=l;return Q|0}}else if((B|0)==28){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=6;Q=P;i=l;return Q|0}}else if((B|0)==37){P=1;Q=P;i=l;return Q|0}else if((B|0)==41){P=11;Q=P;i=l;return Q|0}else if((B|0)==43){P=24;Q=P;i=l;return Q|0}else if((B|0)==50){P=12;Q=P;i=l;return Q|0}else if((B|0)==52){P=15;Q=P;i=l;return Q|0}else if((B|0)==60){P=I;Q=P;i=l;return Q|0}else if((B|0)==63){P=1;Q=P;i=l;return Q|0}else if((B|0)==65){P=21;Q=P;i=l;return Q|0}else if((B|0)==72){P=1;Q=P;i=l;return Q|0}else if((B|0)==74){Zd[c[y+20>>2]&1023](D);P=1;Q=P;i=l;return Q|0}else if((B|0)==80){P=1;Q=P;i=l;return Q|0}else if((B|0)==82){P=H;Q=P;i=l;return Q|0}else if((B|0)==89){P=1;Q=P;i=l;return Q|0}else if((B|0)==91){P=K;Q=P;i=l;return Q|0}else if((B|0)==107){P=PZ(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==109){P=13;Q=P;i=l;return Q|0}else if((B|0)==112){c[z>>2]=L;P=7;Q=P;i=l;return Q|0}else if((B|0)==133){P=PZ(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==135){P=14;Q=P;i=l;return Q|0}else if((B|0)==140){P=17;Q=P;i=l;return Q|0}else if((B|0)==150){P=O;Q=P;i=l;return Q|0}else if((B|0)==152){c[y+280>>2]=43;P=O;Q=P;i=l;return Q|0}else if((B|0)==153){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}do{if((c[y+60>>2]|0)!=0){j=y;if((a[e+72|0]|0)!=0){we[c[j+60>>2]&15](c[y+4>>2]|0,c[m>>2]|0,g-(c[m>>2]|0)|0);break}else{c[w>>2]=c[j+44>>2];Wd[c[e+60>>2]&31](e,m,g,w,c[y+48>>2]|0);we[c[y+60>>2]&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[w>>2]|0)-(c[y+44>>2]|0)|0);break}}else{if((c[y+80>>2]|0)==0){break}eZ(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){c[z>>2]=g;P=3;Q=P;i=l;return Q|0}m=g;if((c[y+312>>2]|0)!=(b|0)){c[z>>2]=m;P=13;Q=P;i=l;return Q|0}else{c[h>>2]=m;P=0;Q=P;i=l;return Q|0}}else if((B|0)==174){P=1;Q=P;i=l;return Q|0}else if((B|0)==176){P=1;Q=P;i=l;return Q|0}else if((B|0)==180){c[h>>2]=c[n>>2];P=0;Q=P;i=l;return Q|0}else if((B|0)==181){P=35;Q=P;i=l;return Q|0}return 0}function MZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+104|0;h=g+64|0;j=b;b=d;d=e;e=f;f=c[j+300>>2]|0;if((f|0)==0){k=23;l=k;i=g;return l|0}m=c[f+12>>2]|0;n=(c[m+4>>2]|0)+(c[m+12>>2]|0)|0;o=(c[m+4>>2]|0)+(c[m+8>>2]|0)|0;p=j;if((a[m+33|0]|0)!=0){q=ze[c[c[p+228>>2]>>2]&63](c[j+228>>2]|0,n,o,h)|0;r=qZ(j,c[j+228>>2]|0,n,o,q,c[h>>2]|0,h,0)|0}else{r=LZ(p,c[f+16>>2]|0,c[j+228>>2]|0,n,o,h,0)|0}if((r|0)!=0){k=r;l=k;i=g;return l|0}do{if((o|0)!=(c[h>>2]|0)){if((c[j+480>>2]|0)!=3){break}c[m+12>>2]=(c[h>>2]|0)-(c[m+4>>2]|0);k=r;l=k;i=g;return l|0}}while(0);a[m+32|0]=0;c[j+300>>2]=c[f+8>>2];c[f+8>>2]=c[j+304>>2];c[j+304>>2]=f;f=j+280|0;if((a[m+33|0]|0)!=0){c[f>>2]=41;m=ze[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=qZ(j,c[j+144>>2]|0,b,d,m,c[h>>2]|0,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}else{c[f>>2]=39;k=LZ(j,(c[j+476>>2]|0)!=0?1:0,c[j+144>>2]|0,b,d,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}return 0}function NZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d+24|0;f=b;b=c[f+356>>2]|0;g=0;do{if((c[b+156>>2]|0)!=0){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((gZ(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=61;l=c[(c[b+156>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}k=0;while(1){if((k|0)>=(l|0)){m=13;break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((gZ(f+416|0)|0)<<24>>24!=0)){break}}n=a[(c[(c[b+156>>2]|0)+16>>2]|0)+k|0]|0;o=f+428|0;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n;k=k+1|0}if((m|0)==13){g=1;break}h=0;j=h;i=d;return j|0}}while(0);hZ(e,b+60|0);a:while(1){k=iZ(e)|0;if((k|0)==0){m=40;break}if((c[k+4>>2]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((gZ(f+416|0)|0)<<24>>24!=0)){m=21;break}}l=f+428|0;n=c[l>>2]|0;c[l>>2]=n+1;a[n]=12}n=c[k>>2]|0;while(1){q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if((a[n]|0)==0){break}if(q){if(!((gZ(f+416|0)|0)<<24>>24!=0)){m=27;break a}}l=a[n]|0;p=f+428|0;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=l;n=n+1|0}if(q){if(!((gZ(f+416|0)|0)<<24>>24!=0)){m=31;break}}n=f+428|0;l=c[n>>2]|0;c[n>>2]=l+1;a[l]=61;l=c[(c[k+4>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}n=0;while(1){if((n|0)>=(l|0)){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((gZ(f+416|0)|0)<<24>>24!=0)){m=38;break a}}o=a[(c[(c[k+4>>2]|0)+16>>2]|0)+n|0]|0;p=f+428|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=o;n=n+1|0}g=1}if((m|0)==21){h=0;j=h;i=d;return j|0}else if((m|0)==27){h=0;j=h;i=d;return j|0}else if((m|0)==31){h=0;j=h;i=d;return j|0}else if((m|0)==38){h=0;j=h;i=d;return j|0}else if((m|0)==40){hZ(e,b);b:while(1){b=iZ(e)|0;if((b|0)==0){m=55;break}if((a[b+32|0]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((gZ(f+416|0)|0)<<24>>24!=0)){m=47;break}}q=f+428|0;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=12}n=c[b>>2]|0;while(1){if((a[n]|0)==0){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((gZ(f+416|0)|0)<<24>>24!=0)){m=53;break b}}b=a[n]|0;q=f+428|0;k=c[q>>2]|0;c[q>>2]=k+1;a[k]=b;n=n+1|0}g=1}if((m|0)==47){h=0;j=h;i=d;return j|0}else if((m|0)==53){h=0;j=h;i=d;return j|0}else if((m|0)==55){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((gZ(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);m=f+428|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g]=0;h=c[f+432>>2]|0;j=h;i=d;return j|0}}return 0}function OZ(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+352|0;k=b;b=e;e=f;f=g;g=h;h=c[k+356>>2]|0;l=0;m=0;n=jZ(k,h+20|0,c[f>>2]|0,0)|0;do{if((n|0)==0){o=RY(h+80|0,c[f>>2]|0)|0;if((o|0)==0){p=1;q=p;i=j;return q|0}n=jZ(k,h+20|0,o,24)|0;if((n|0)==0){p=1;q=p;i=j;return q|0}if((d[k+236|0]|0)==0){break}if((UZ(k,n)|0)!=0){break}p=1;q=p;i=j;return q|0}}while(0);o=c[n+12>>2]|0;r=ze[c[b+40>>2]&63](b,e,c[k+380>>2]|0,c[k+392>>2]|0)|0;do{if((r+o|0)>(c[k+380>>2]|0)){s=c[k+380>>2]|0;c[k+380>>2]=r+o+16;t=pe[c[k+16>>2]&63](c[k+392>>2]|0,c[k+380>>2]<<4)|0;if((t|0)==0){p=1;q=p;i=j;return q|0}else{c[k+392>>2]=t;if((r|0)<=(s|0)){break}ze[c[b+40>>2]&63](b,e,r,c[k+392>>2]|0)|0;break}}}while(0);e=c[k+392>>2]|0;s=0;a:while(1){if((s|0)>=(r|0)){u=43;break}t=(c[k+392>>2]|0)+(s<<4)|0;v=c[t>>2]|0;w=c[t>>2]|0;x=wZ(k,b,v,w+(pe[c[b+32>>2]&63](b,c[t>>2]|0)|0)|0)|0;if((x|0)==0){u=17;break}if((a[(c[x>>2]|0)+ -1|0]|0)!=0){u=19;break}a[(c[x>>2]|0)+ -1|0]=1;t=l;l=t+1|0;c[e+(t<<2)>>2]=c[x>>2];if((a[(c[k+392>>2]|0)+(s<<4)+12|0]|0)!=0){c[e+(l<<2)>>2]=sZ(k+416|0,b,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0)|0;if((c[e+(l<<2)>>2]|0)==0){u=33;break}c[k+432>>2]=c[k+428>>2]}else{t=1;b:do{if((a[x+8|0]|0)!=0){w=0;while(1){if((w|0)>=(o|0)){break b}y=w;if((x|0)==(c[(c[n+20>>2]|0)+(w*12|0)>>2]|0)){break}w=y+1|0}t=a[(c[n+20>>2]|0)+(y*12|0)+4|0]|0}}while(0);z=AZ(k,b,t,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0,k+416|0)|0;if((z|0)!=0){u=30;break}c[e+(l<<2)>>2]=c[k+432>>2];c[k+432>>2]=c[k+428>>2]}do{if((c[x+4>>2]|0)!=0){if((a[x+9|0]|0)==0){l=l+1|0;m=m+1|0;a[(c[x>>2]|0)+ -1|0]=2;break}A=nZ(k,c[x+4>>2]|0,x,c[e+(l<<2)>>2]|0,g)|0;if((A|0)!=0){u=38;break a}l=l+ -1|0}else{l=l+1|0}}while(0);s=s+1|0}if((u|0)==17){p=1;q=p;i=j;return q|0}else if((u|0)==19){if((b|0)==(c[k+144>>2]|0)){c[k+288>>2]=c[(c[k+392>>2]|0)+(s<<4)>>2]}p=8;q=p;i=j;return q|0}else if((u|0)==30){p=z;q=p;i=j;return q|0}else if((u|0)==33){p=1;q=p;i=j;return q|0}else if((u|0)==38){p=A;q=p;i=j;return q|0}else if((u|0)==43){c[k+384>>2]=l;c:do{if((c[n+8>>2]|0)!=0){if((a[(c[c[n+8>>2]>>2]|0)+ -1|0]|0)==0){u=50;break}s=0;while(1){if((s|0)>=(l|0)){break c}B=s;if((c[e+(s<<2)>>2]|0)==(c[c[n+8>>2]>>2]|0)){break}s=B+2|0}c[k+388>>2]=B}else{u=50}}while(0);if((u|0)==50){c[k+388>>2]=-1}s=0;d:while(1){if((s|0)>=(o|0)){break}B=(c[n+20>>2]|0)+(s*12|0)|0;do{if((a[(c[c[B>>2]>>2]|0)+ -1|0]|0)==0){if((c[B+8>>2]|0)==0){break}A=c[B>>2]|0;if((c[(c[B>>2]|0)+4>>2]|0)==0){a[(c[A>>2]|0)+ -1|0]=1;z=l;l=z+1|0;c[e+(z<<2)>>2]=c[c[B>>2]>>2];z=l;l=z+1|0;c[e+(z<<2)>>2]=c[B+8>>2];break}if((a[A+9|0]|0)!=0){C=nZ(k,c[(c[B>>2]|0)+4>>2]|0,c[B>>2]|0,c[B+8>>2]|0,g)|0;if((C|0)!=0){u=58;break d}else{break}}else{a[(c[c[B>>2]>>2]|0)+ -1|0]=2;m=m+1|0;A=l;l=A+1|0;c[e+(A<<2)>>2]=c[c[B>>2]>>2];A=l;l=A+1|0;c[e+(A<<2)>>2]=c[B+8>>2];break}}}while(0);s=s+1|0}if((u|0)==58){p=C;q=p;i=j;return q|0}c[e+(l<<2)>>2]=0;s=0;e:do{if((m|0)!=0){C=c[k+400>>2]|0;o=1<<d[k+404|0];do{if((m<<1>>d[k+404|0]|0)!=0){do{B=k+404|0;A=a[B]|0;a[B]=A+1<<24>>24;}while((m>>(A&255)|0)!=0);if((d[k+404|0]|0)<3){a[k+404|0]=3}o=1<<d[k+404|0];A=pe[c[k+16>>2]&63](c[k+396>>2]|0,o*12|0)|0;if((A|0)!=0){c[k+396>>2]=A;C=0;break}p=1;q=p;i=j;return q|0}}while(0);f:do{if((C|0)==0){C=-1;D=o;while(1){if((D|0)==0){break f}A=D+ -1|0;D=A;c[(c[k+396>>2]|0)+(A*12|0)>>2]=C}}}while(0);A=C+ -1|0;C=A;c[k+400>>2]=A;g:while(1){if((s|0)>=(l|0)){break e}A=c[e+(s<<2)>>2]|0;if((a[A+ -1|0]|0)==2){B=c[k+496>>2]|0;a[A+ -1|0]=0;z=c[(c[(jZ(k,h+40|0,A,0)|0)+4>>2]|0)+4>>2]|0;if((z|0)==0){u=78;break}D=0;while(1){if((D|0)>=(c[z+20>>2]|0)){break}b=a[(c[z+16>>2]|0)+D|0]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((gZ(k+416|0)|0)<<24>>24!=0)){u=84;break g}}y=k+428|0;x=c[y>>2]|0;c[y>>2]=x+1;a[x]=b;B=B*1000003^b&255;D=D+1|0}do{b=A;A=b+1|0;}while((a[b]|0)!=58);do{b=a[A]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((gZ(k+416|0)|0)<<24>>24!=0)){u=89;break g}}x=a[A]|0;y=k+428|0;t=c[y>>2]|0;c[y>>2]=t+1;a[t]=x;B=B*1000003^b&255;b=A;A=b+1|0;}while((a[b]|0)!=0);b=0;x=o-1|0;D=B&x;while(1){if((c[(c[k+396>>2]|0)+(D*12|0)>>2]|0)!=(C|0)){break}if((B|0)==(c[(c[k+396>>2]|0)+(D*12|0)+4>>2]|0)){t=c[k+432>>2]|0;y=c[(c[k+396>>2]|0)+(D*12|0)+8>>2]|0;while(1){if((a[t]|0)!=(a[y]|0)){break}if((a[t]|0)==0){break}t=t+1|0;y=y+1|0}if((a[t]|0)==0){u=98;break g}}if(!(b<<24>>24!=0)){b=((B&~x)>>>((d[k+404|0]|0)-1|0)&x>>>2|1)&255}if((D|0)<(b&255|0)){D=D+(o-(b&255))|0;continue}else{D=D-(b&255)|0;continue}}if((a[k+237|0]|0)!=0){a[(c[k+428>>2]|0)+ -1|0]=a[k+472|0]|0;A=c[c[z>>2]>>2]|0;do{if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((gZ(k+416|0)|0)<<24>>24!=0)){u=109;break g}}b=a[A]|0;x=k+428|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=b;b=A;A=b+1|0;}while((a[b]|0)!=0)}A=c[k+432>>2]|0;c[k+432>>2]=c[k+428>>2];c[e+(s<<2)>>2]=A;c[(c[k+396>>2]|0)+(D*12|0)>>2]=C;c[(c[k+396>>2]|0)+(D*12|0)+4>>2]=B;c[(c[k+396>>2]|0)+(D*12|0)+8>>2]=A;z=m+ -1|0;m=z;if((z|0)==0){u=111;break}}else{a[A+ -1|0]=0}s=s+2|0}if((u|0)==78){p=27;q=p;i=j;return q|0}else if((u|0)==84){p=1;q=p;i=j;return q|0}else if((u|0)==89){p=1;q=p;i=j;return q|0}else if((u|0)==98){p=8;q=p;i=j;return q|0}else if((u|0)==109){p=1;q=p;i=j;return q|0}else if((u|0)==111){s=s+2|0;break}}}while(0);while(1){if((s|0)>=(l|0)){break}a[(c[e+(s<<2)>>2]|0)+ -1|0]=0;s=s+2|0}e=c[g>>2]|0;while(1){if((e|0)==0){break}a[(c[c[e+12>>2]>>2]|0)+ -1|0]=0;e=c[e+4>>2]|0}if((a[k+236|0]|0)==0){p=0;q=p;i=j;return q|0}do{if((c[n+4>>2]|0)!=0){e=c[(c[n+4>>2]|0)+4>>2]|0;if((e|0)!=0){E=c[f>>2]|0;do{g=E;E=g+1|0;}while((a[g]|0)!=58)}else{p=27;q=p;i=j;return q|0}}else{if((c[h+156>>2]|0)!=0){e=c[h+156>>2]|0;E=c[f>>2]|0;break}p=0;q=p;i=j;return q|0}}while(0);h=0;do{if((d[k+237|0]|0)!=0){if((c[c[e>>2]>>2]|0)==0){break}do{n=h;h=n+1|0;}while((a[(c[c[e>>2]>>2]|0)+n|0]|0)!=0)}}while(0);c[f+4>>2]=E;c[f+16>>2]=c[e+20>>2];c[f+8>>2]=c[c[e>>2]>>2];c[f+20>>2]=h;s=0;do{n=s;s=n+1|0;}while((a[E+n|0]|0)!=0);r=s+(c[e+20>>2]|0)+h|0;if((r|0)>(c[e+24>>2]|0)){F=ae[c[k+12>>2]&127](r+24|0)|0;if((F|0)==0){p=1;q=p;i=j;return q|0}c[e+24>>2]=r+24;nxa(F|0,c[e+16>>2]|0,c[e+20>>2]|0)|0;r=c[k+364>>2]|0;while(1){if((r|0)==0){break}if((c[r+12>>2]|0)==(c[e+16>>2]|0)){c[r+12>>2]=F}r=c[r>>2]|0}Zd[c[k+20>>2]&1023](c[e+16>>2]|0);c[e+16>>2]=F}F=(c[e+16>>2]|0)+(c[e+20>>2]|0)|0;nxa(F|0,E|0,s|0)|0;if((h|0)!=0){F=F+(s-1)|0;a[F]=a[k+472|0]|0;nxa(F+1|0,c[c[e>>2]>>2]|0,h|0)|0}c[f>>2]=c[e+16>>2];p=0;q=p;i=j;return q|0}return 0}function PZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+40|0;j=b;b=d;d=e;e=f;c[j+280>>2]=44;c[j+288>>2]=b;a:while(1){c[h>>2]=0;f=ze[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;c[j+292>>2]=c[h>>2];b:do{switch(f|0){case 0:{k=14;break a;break};case-4:{k=7;break a;break};case 15:{if((c[j+80>>2]|0)==0){break b}eZ(j,c[j+144>>2]|0,b,c[h>>2]|0);break};case-2:{k=18;break a;break};case 11:{if((HZ(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=11;break a}break};case-15:{k=3;break a;break};case 13:{if((IZ(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=13;break a}break};case-1:{k=15;break a;break};default:{k=21;break a}}}while(0);f=c[h>>2]|0;b=f;c[j+288>>2]=f;f=c[j+480>>2]|0;if((f|0)==3){k=23;break}else if((f|0)==2){k=24;break}}if((k|0)==3){do{if((c[j+80>>2]|0)!=0){eZ(j,c[j+144>>2]|0,b,c[h>>2]|0);if((c[j+480>>2]|0)!=2){break}l=35;m=l;i=g;return m|0}}while(0);c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==7){c[e>>2]=b;l=0;m=l;i=g;return m|0}else if((k|0)==11){l=1;m=l;i=g;return m|0}else if((k|0)==13){l=1;m=l;i=g;return m|0}else if((k|0)==14){c[j+288>>2]=c[h>>2];l=4;m=l;i=g;return m|0}else if((k|0)==15){if((a[j+484|0]|0)!=0){l=5;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==18){if((a[j+484|0]|0)!=0){l=6;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==21){l=9;m=l;i=g;return m|0}else if((k|0)==23){c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==24){l=35;m=l;i=g;return m|0}return 0}function QZ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+120|0;k=j+56|0;l=j+80|0;m=j+96|0;n=j+112|0;o=b;b=d;d=e;e=f;f=g;g=h;c[k>>2]=c[d>>2];h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;c[p>>2]=c[k>>2];q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}c[p>>2]=c[k>>2];c[d>>2]=0;a:while(1){h=ze[c[b+8>>2]&63](b,c[k>>2]|0,e,l)|0;c[q>>2]=c[l>>2];b:do{switch(h|0){case-4:case-1:{r=28;break a;break};case 7:{if((c[o+60>>2]|0)!=0){a[m]=10;we[c[o+60>>2]&15](c[o+4>>2]|0,m,1);break b}if((c[o+80>>2]|0)==0){break b}eZ(o,b,c[k>>2]|0,c[l>>2]|0);break};case 40:{r=6;break a;break};case 6:{s=c[o+60>>2]|0;if((s|0)==0){if((c[o+80>>2]|0)==0){break b}eZ(o,b,c[k>>2]|0,c[l>>2]|0);break b}if((a[b+72|0]|0)!=0){we[s&15](c[o+4>>2]|0,c[k>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0);break b}while(1){c[n>>2]=c[o+44>>2];Wd[c[b+60>>2]&31](b,k,c[l>>2]|0,n,c[o+48>>2]|0);c[q>>2]=c[l>>2];we[s&15](c[o+4>>2]|0,c[o+44>>2]|0,(c[n>>2]|0)-(c[o+44>>2]|0)|0);if((c[k>>2]|0)==(c[l>>2]|0)){break b}c[p>>2]=c[k>>2]}break};case 0:{r=24;break a;break};case-2:{r=25;break a;break};default:{r=31;break a}}}while(0);h=c[l>>2]|0;c[k>>2]=h;c[p>>2]=h;h=c[o+480>>2]|0;if((h|0)==3){r=33;break}else if((h|0)==2){r=34;break}}if((r|0)==6){n=o;do{if((c[o+76>>2]|0)!=0){Zd[c[n+76>>2]&1023](c[o+4>>2]|0)}else{if((c[n+80>>2]|0)==0){break}eZ(o,b,c[k>>2]|0,c[l>>2]|0)}}while(0);c[d>>2]=c[l>>2];c[f>>2]=c[l>>2];if((c[o+480>>2]|0)==2){t=35;u=t;i=j;return u|0}else{t=0;u=t;i=j;return u|0}}else if((r|0)==24){c[p>>2]=c[l>>2];t=4;u=t;i=j;return u|0}else if((r|0)==25){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=6;u=t;i=j;return u|0}}else if((r|0)==28){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=20;u=t;i=j;return u|0}}else if((r|0)==31){c[p>>2]=c[l>>2];t=23;u=t;i=j;return u|0}else if((r|0)==33){c[f>>2]=c[l>>2];t=0;u=t;i=j;return u|0}else if((r|0)==34){t=35;u=t;i=j;return u|0}return 0}function RZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=QZ(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)==0){k=f;l=k;i=g;return l|0}f=j+280|0;if((c[j+476>>2]|0)!=0){c[f>>2]=45;k=SZ(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{c[f>>2]=39;k=uZ(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}return 0}function SZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=LZ(h,1,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((TZ(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function TZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+56|0;d=a;a=c[d+364>>2]|0;while(1){if((a|0)==0){e=13;break}f=(c[a+24>>2]|0)+1|0;g=(c[a+36>>2]|0)+f|0;if((c[a+4>>2]|0)==(g|0)){e=13;break}h=f+((c[a+8>>2]|0)+0)|0;if((h|0)>((c[a+40>>2]|0)-(c[a+36>>2]|0)|0)){j=pe[c[d+16>>2]&63](c[a+36>>2]|0,h)|0;if((j|0)==0){e=6;break}if((c[a+12>>2]|0)==(c[a+36>>2]|0)){c[a+12>>2]=j}if((c[a+16>>2]|0)!=0){c[a+16>>2]=j+((c[a+16>>2]|0)-(c[a+36>>2]|0))}c[a+36>>2]=j;c[a+40>>2]=j+h;g=j+f|0}nxa(g|0,c[a+4>>2]|0,c[a+8>>2]|0)|0;c[a+4>>2]=g;a=c[a>>2]|0}if((e|0)==6){k=0;l=k;i=b;return l|0}else if((e|0)==13){k=1;l=k;i=b;return l|0}return 0}function UZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=c[b>>2]|0;a:while(1){if((a[g]|0)==0){h=20;break}if((a[g]|0)==58){j=c[b>>2]|0;while(1){k=(c[d+92>>2]|0)==(c[d+88>>2]|0);if((j|0)==(g|0)){break}if(k){if(!((gZ(d+80|0)|0)<<24>>24!=0)){h=9;break a}}l=a[j]|0;m=d+92|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;j=j+1|0}if(k){if(!((gZ(d+80|0)|0)<<24>>24!=0)){h=13;break}}j=d+92|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;l=jZ(f,d+60|0,c[d+96>>2]|0,8)|0;if((l|0)==0){h=14;break}j=d+80|0;if((c[l>>2]|0)==(c[d+96>>2]|0)){c[d+96>>2]=c[j+12>>2]}else{c[d+92>>2]=c[j+16>>2]}c[b+4>>2]=l}g=g+1|0}if((h|0)==9){o=0;p=o;i=e;return p|0}else if((h|0)==13){o=0;p=o;i=e;return p|0}else if((h|0)==14){o=0;p=o;i=e;return p|0}else if((h|0)==20){o=1;p=o;i=e;return p|0}return 0}function VZ(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+152|0;l=k+64|0;m=k+80|0;n=b;b=e;e=f;f=g;g=h;h=j;j=c[n+356>>2]|0;a:while(1){b:do{switch(ze[c[b+16>>2]&63](b,f,g,l)|0){case-3:{c[l>>2]=f+(c[b+68>>2]|0);o=31;break};case-4:{o=3;break a;break};case 6:{if((yZ(h,b,f,c[l>>2]|0)|0)==0){o=29;break a}break};case 10:{p=pe[c[b+44>>2]&63](b,f)|0;if((p|0)<0){o=11;break a}do{if(!(e<<24>>24!=0)){if((p|0)!=32){break}if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break b}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break b}}}while(0);p=a_(p,m)|0;if((p|0)==0){o=19;break a}q=0;while(1){if((q|0)>=(p|0)){break b}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((gZ(h)|0)<<24>>24!=0)){o=27;break a}}r=a[m+q|0]|0;s=h+12|0;t=c[s>>2]|0;c[s>>2]=t+1;a[t]=r;q=q+1|0}break};case 0:{o=4;break a;break};case-1:{o=7;break a;break};case 9:{q=(de[c[b+48>>2]&63](b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0)&255;if(q<<24>>24!=0){if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((gZ(h)|0)<<24>>24!=0)){o=42;break a}}p=h+12|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=q;break b}q=sZ(n+440|0,b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((q|0)==0){o=44;break a}r=jZ(n,j,q,0)|0;c[n+452>>2]=c[n+456>>2];if((h|0)==(j+80|0)){if((c[n+272>>2]|0)!=0){if((d[j+130|0]|0)!=0){u=(c[n+300>>2]|0)!=0}else{u=(a[j+129|0]|0)!=0}v=((u^1)&1|0)!=0}else{v=0}w=v&1}else{if((a[j+129|0]|0)!=0){x=(d[j+130|0]|0)!=0}else{x=1}w=x&1}q=(r|0)!=0;if(w<<24>>24!=0){if(!q){o=57;break a}if((a[r+34|0]|0)==0){o=59;break a}}else{if(!q){break b}}if((a[r+32|0]|0)!=0){o=62;break a}if((c[r+28>>2]|0)!=0){o=66;break a}if((c[r+4>>2]|0)==0){o=70;break a}q=(c[r+4>>2]|0)+(c[r+8>>2]|0)|0;a[r+32|0]=1;y=VZ(n,c[n+228>>2]|0,e,c[r+4>>2]|0,q,h)|0;a[r+32|0]=0;if((y|0)!=0){o=74;break a}break};case 7:case 39:{o=31;break};default:{o=75;break a}}}while(0);do{if((o|0)==31){o=0;if(!(e<<24>>24!=0)){if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break}}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((gZ(h)|0)<<24>>24!=0)){o=37;break a}}r=h+12|0;q=c[r>>2]|0;c[r>>2]=q+1;a[q]=32}}while(0);f=c[l>>2]|0}if((o|0)==3){z=0;A=z;i=k;return A|0}else if((o|0)==4){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=c[l>>2]}z=4;A=z;i=k;return A|0}else if((o|0)==7){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=4;A=z;i=k;return A|0}else if((o|0)==11){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==19){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==27){z=1;A=z;i=k;return A|0}else if((o|0)==29){z=1;A=z;i=k;return A|0}else if((o|0)==37){z=1;A=z;i=k;return A|0}else if((o|0)==42){z=1;A=z;i=k;return A|0}else if((o|0)==44){z=1;A=z;i=k;return A|0}else if((o|0)==57){z=11;A=z;i=k;return A|0}else if((o|0)==59){z=24;A=z;i=k;return A|0}else if((o|0)==62){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=12;A=z;i=k;return A|0}else if((o|0)==66){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=15;A=z;i=k;return A|0}else if((o|0)==70){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=16;A=z;i=k;return A|0}else if((o|0)==74){z=y;A=z;i=k;return A|0}else if((o|0)==75){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=23;A=z;i=k;return A|0}return 0}function WZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1080|0;f=e+24|0;g=b;b=d;do{if((c[g+124>>2]|0)!=0){d=0;while(1){if((d|0)>=256){break}c[f+(d<<2)>>2]=-1;d=d+1|0}c[f+1028>>2]=0;c[f+1024>>2]=0;c[f+1032>>2]=0;do{if((de[c[g+124>>2]&63](c[g+248>>2]|0,b,f)|0)!=0){d=c[g+12>>2]|0;h=b_()|0;c[g+240>>2]=ae[d&127](h)|0;if((c[g+240>>2]|0)!=0){h=ze[((a[g+236|0]&255|0)!=0?46:47)&63](c[g+240>>2]|0,f,c[f+1028>>2]|0,c[f+1024>>2]|0)|0;if((h|0)==0){break}c[g+244>>2]=c[f+1024>>2];c[g+252>>2]=c[f+1032>>2];c[g+144>>2]=h;j=0;k=j;i=e;return k|0}if((c[f+1032>>2]|0)!=0){Zd[c[f+1032>>2]&1023](c[f+1024>>2]|0)}j=1;k=j;i=e;return k|0}}while(0);if((c[f+1032>>2]|0)==0){break}Zd[c[f+1032>>2]&1023](c[f+1024>>2]|0)}}while(0);j=18;k=j;i=e;return k|0}function XZ(){var a=0,b=0;a=i;i=i+8|0;ac(((rc(0)|0)>>>0)%4294967295|0|0);b=txa()|0;i=a;return b|0}function YZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+48|0;g=a;a=oZ(g)|0;if((a|0)!=0){h=a;j=h;i=f;return j|0}else{c[g+280>>2]=41;h=pZ(g,b,d,e)|0;j=h;i=f;return j|0}return 0}function ZZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=ae[c[e>>2]&127](188)|0;f=b;if((b|0)==0){g=f;h=g;i=d;return h|0}else{_Z(f+80|0,e);_Z(b+104|0,e);$Z(b,e);$Z(b+20|0,e);$Z(b+40|0,e);$Z(b+60|0,e);a[b+131|0]=0;$Z(b+132|0,e);c[b+152>>2]=0;c[b+156>>2]=0;a[b+160|0]=0;c[b+184>>2]=0;c[b+164>>2]=0;c[b+180>>2]=0;c[b+172>>2]=0;c[b+176>>2]=0;c[b+168>>2]=0;a[b+128|0]=1;a[b+129|0]=0;a[b+130|0]=0;g=b;h=g;i=d;return h|0}return 0}function _Z(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;c[e>>2]=0;c[e+4>>2]=0;c[e+16>>2]=0;c[e+12>>2]=0;c[e+8>>2]=0;c[e+20>>2]=b;i=d;return}function $Z(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=b;a[f+4|0]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f>>2]=0;c[f+16>>2]=d;i=e;return}function a_(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;if((e|0)<0){f=0;g=f;i=d;return g|0}c=e;if((e|0)<128){a[b]=c;f=1;g=f;i=d;return g|0}h=e;if((c|0)<2048){a[b]=h>>6|192;a[b+1|0]=e&63|128;f=2;g=f;i=d;return g|0}c=e;if((h|0)<65536){a[b]=c>>12|224;a[b+1|0]=e>>6&63|128;a[b+2|0]=e&63|128;f=3;g=f;i=d;return g|0}if((c|0)<1114112){a[b]=e>>18|240;a[b+1|0]=e>>12&63|128;a[b+2|0]=e>>6&63|128;a[b+3|0]=e&63|128;f=4;g=f;i=d;return g|0}else{f=0;g=f;i=d;return g|0}return 0}function b_(){i=i;return 1912}function c_(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+64|0;k=e;e=f;f=g;g=h;h=k;l=0;while(1){if((l|0)>=368){break}a[k+l|0]=a[67648+l|0]|0;l=l+1|0}l=0;a:while(1){if((l|0)>=128){break}do{if((d[67724+l|0]|0|0)!=28){if((d[67724+l|0]|0|0)==0){break}if((c[e+(l<<2)>>2]|0)!=(l|0)){m=9;break a}}}while(0);l=l+1|0}if((m|0)==9){n=0;o=n;i=j;return o|0}l=0;b:while(1){if((l|0)>=256){m=36;break}k=c[e+(l<<2)>>2]|0;do{if((k|0)==-1){a[h+76+l|0]=1;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0}else{p=k;if((k|0)<0){if((p|0)<-4){m=17;break b}a[h+76+l|0]=5-(k+2);a[h+888+(l<<2)|0]=0;b[h+376+(l<<1)>>1]=0;break}q=k;if((p|0)<128){do{if((d[67724+q|0]|0|0)!=28){if((d[67724+k|0]|0|0)==0){break}if((k|0)!=(l|0)){m=23;break b}}}while(0);a[h+76+l|0]=a[67724+k|0]|0;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=k;b[h+376+(l<<1)>>1]=(k|0)==0?65535:k;break}if((d_(q)|0)<0){a[h+76+l|0]=0;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0;break}if((k|0)>65535){m=28;break b}do{if((c[61816+(((d[61560+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[h+76+l|0]=22}else{p=h+76+l|0;if((c[61816+(((d[63096+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[p]=26;break}else{a[p]=28;break}}}while(0);a[h+888+(l<<2)|0]=a_(k,h+888+(l<<2)+1|0)|0;b[h+376+(l<<1)>>1]=k}}while(0);l=l+1|0}if((m|0)==17){n=0;o=n;i=j;return o|0}else if((m|0)==23){n=0;o=n;i=j;return o|0}else if((m|0)==28){n=0;o=n;i=j;return o|0}else if((m|0)==36){c[h+372>>2]=g;c[h+368>>2]=f;if((f|0)!=0){c[h+332>>2]=49;c[h+336>>2]=49;c[h+340>>2]=49;c[h+344>>2]=50;c[h+348>>2]=50;c[h+352>>2]=50;c[h+356>>2]=51;c[h+360>>2]=51;c[h+364>>2]=51}c[h+60>>2]=13;c[h+64>>2]=14;n=h;o=n;i=j;return o|0}return 0}function d_(a){a=a|0;var b=0,c=0,e=0,f=0;b=i;i=i+16|0;c=a;a:do{switch(c>>8|0){case 255:{if(!((c|0)==65534|(c|0)==65535)){e=7;break a}f=-1;break};case 0:{if((d[67724+c|0]|0|0)!=0){e=7;break a}f=-1;break};case 223:case 222:case 221:case 220:case 219:case 218:case 217:case 216:{f=-1;break};default:{e=7}}}while(0);if((e|0)==7){f=c}i=b;return f|0}function e_(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=pe[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[61816+(((d[63096+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function f_(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=pe[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[61816+(((d[61560+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function g_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=a;a=pe[c[e+368>>2]&63](c[e+372>>2]|0,b)|0;if((a&-65536|0)!=0){f=1;g=f&1;i=d;return g|0}f=(d_(a)|0)<0;g=f&1;i=d;return g|0}function h_(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+80|0;k=j+48|0;l=b;b=e;e=f;f=g;g=h;h=l;a:while(1){if((c[b>>2]|0)==(e|0)){m=9;break}n=h+888+(d[c[b>>2]|0]<<2)|0;o=n;n=o+1|0;p=a[o]|0;if((p|0)==0){p=a_(pe[c[h+368>>2]&63](c[h+372>>2]|0,c[b>>2]|0)|0,k)|0;if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}n=k;o=b;c[o>>2]=(c[o>>2]|0)+((d[l+76+(d[c[b>>2]|0]|0)|0]|0)-3)}else{if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}o=b;c[o>>2]=(c[o>>2]|0)+1}while(1){o=n;n=o+1|0;q=a[o]|0;o=f;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;q=p+ -1|0;p=q;if((q|0)==0){continue a}}}if((m|0)==9){i=j;return}}function i_(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+56|0;k=a;a=e;e=f;f=g;g=h;h=k;while(1){if((c[a>>2]|0)==(e|0)){l=8;break}if((c[f>>2]|0)==(g|0)){l=8;break}m=b[h+376+((d[c[a>>2]|0]|0)<<1)>>1]|0;if((m&65535|0)==0){m=(pe[c[h+368>>2]&63](c[h+372>>2]|0,c[a>>2]|0)|0)&65535;n=a;c[n>>2]=(c[n>>2]|0)+((d[k+76+(d[c[a>>2]|0]|0)|0]|0)-3)}else{n=a;c[n>>2]=(c[n>>2]|0)+1}n=f;o=c[n>>2]|0;c[n>>2]=o+2;b[o>>1]=m}if((l|0)==8){i=j;return}}function j_(){i=i;return 67280}function k_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=l_(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=48;c[g+4>>2]=49;c[g+52>>2]=36;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function l_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+24|0;d=a;if((d|0)==0){e=6;f=e;i=b;return f|0}a=0;while(1){if((a|0)>=6){g=8;break}h=a;if((z_(d,c[67184+(a<<2)>>2]|0)|0)!=0){g=6;break}a=h+1|0}if((g|0)==6){e=h;f=e;i=b;return f|0}else if((g|0)==8){e=-1;f=e;i=b;return f|0}return 0}function m_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=x0(65624,a,0,b,c,d)|0;i=e;return f|0}function n_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=x0(65624,a,1,b,c,d)|0;i=e;return f|0}function o_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;i=i+32|0;W$(66392,b,c,d);i=a;return}function p_(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=q_(35,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function q_(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+128|0;o=n+32|0;p=n+96|0;q=n+104|0;r=n+112|0;s=a;a=b;b=d;c[o>>2]=e;e=f;f=g;g=h;h=j;j=k;k=l;l=m;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[o>>2]=(c[o>>2]|0)+((c[b+68>>2]|0)*5|0);e=e+(0-(c[b+68>>2]<<1))|0;m=(y0(b,c[o>>2]|0,e,q,r,p,o)|0)!=0;if(!(m&(c[q>>2]|0)!=0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}do{if((ze[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,67128)|0)!=0){if((g|0)!=0){c[g>>2]=c[p>>2]}if((h|0)!=0){c[h>>2]=c[o>>2]}if((y0(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}if((a|0)!=0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}else{if((a|0)!=0){break}c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}}while(0);do{if((ze[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,67136)|0)!=0){h=z0(b,c[p>>2]|0,e)|0;do{if(!(97<=(h|0)&(h|0)<=122)){if(65<=(h|0)&(h|0)<=90){break}c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}while(0);if((j|0)!=0){c[j>>2]=c[p>>2]}if((k|0)!=0){c[k>>2]=de[s&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0)|0}if((y0(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}t=1;u=t;i=n;return u|0}}while(0);do{if((ze[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,67152)|0)!=0){if((a|0)!=0){break}do{if((ze[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,67168)|0)!=0){if((l|0)==0){break}c[l>>2]=1}else{if((ze[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,67176)|0)!=0){if((l|0)==0){break}c[l>>2]=0;break}else{c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}}while(0);while(1){if((A0(z0(b,c[o>>2]|0,e)|0)|0)==0){break}c[o>>2]=(c[o>>2]|0)+(c[b+68>>2]|0)}if((c[o>>2]|0)!=(e|0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}}while(0);c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}function r_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;Wd[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((z_(h,63352)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=l_(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[65624+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function s_(){i=i;return 65256}function t_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=l_(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=50;c[g+4>>2]=51;c[g+52>>2]=36;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function u_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=x0(63360,a,0,b,c,d)|0;i=e;return f|0}function v_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=x0(63360,a,1,b,c,d)|0;i=e;return f|0}function w_(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=q_(36,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function x_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;Wd[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((z_(h,63352)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=l_(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[63360+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function y_(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+40|0;g=c_(b,c,d,e)|0;if((g|0)==0){h=g;i=f;return h|0}a[g+134|0]=23;h=g;i=f;return h|0}function z_(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+40|0;e=b;b=c;while(1){c=e;e=c+1|0;f=a[c]|0;c=b;b=c+1|0;g=a[c]|0;do{if(97<=(f<<24>>24|0)){if((f<<24>>24|0)>122){break}f=(f<<24>>24)+ -32&255}}while(0);do{if(97<=(g<<24>>24|0)){if((g<<24>>24|0)>122){break}g=(g<<24>>24)+ -32&255}}while(0);if((f<<24>>24|0)!=(g<<24>>24|0)){h=9;break}if(!(f<<24>>24!=0)){h=11;break}}if((h|0)==9){j=0;k=j;i=d;return k|0}else if((h|0)==11){j=1;k=j;i=d;return k|0}return 0}function A_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=R_(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 10:case 21:{n=25;break};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+3|0]|0)!=0){break}if((a[b+2|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 13:{k=b$(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=R_(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 30:{k=T_(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[g]|0)|0]|0}else{p=R_(a[g+1|0]|0,a[b]|0)|0}switch(p|0){case 16:{k=c$(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=Z_(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{q=18;b=b+2|0;n=77;break};case 23:case 27:case 26:case 25:{q=19;b=b+2|0;n=77;break};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 9:{if((b+2|0)!=(e|0)){n=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 12:{k=b$(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{g=b;if((c[61816+((d[61560+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){b=g+2|0;q=18;n=77;break a}if((c[61816+((d[63096+(d[g+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=76;break a}b=b+2|0;q=19;n=77;break};case 19:{k=d$(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{n=76}}}while(0);if((n|0)==25){while(1){n=0;b=b+2|0;r=b;if((b|0)==(e|0)){n=32;break}p=b;if((a[r+1|0]|0)==0){s=d[j+76+(d[p]|0)|0]|0}else{s=R_(a[p+1|0]|0,a[b]|0)|0}if((s|0)==10|(s|0)==21){n=25;continue}else if((s|0)!=9){n=31;break}if((b+2|0)!=(e|0)){n=25}else{n=31;break}}if((n|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((n|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==77){b:while(1){n=0;if((b|0)==(e|0)){n=126;break}r=b;if((a[b+1|0]|0)==0){t=d[j+76+(d[r]|0)|0]|0}else{t=R_(a[r+1|0]|0,a[b]|0)|0}switch(t|0){case 27:case 26:case 25:case 24:case 22:{break};case 33:{n=119;break b;break};case 29:{if((c[61816+((d[63096+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=83;break b}break};case 7:{n=91;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=94;break b;break};case 15:{n=122;break b;break};case 5:{n=85;break b;break};case 6:{n=88;break b;break};case 34:{n=116;break b;break};case 23:{b=b+2|0;r=q;if((r|0)==41){q=19;n=77;continue b}else if((r|0)!=18){n=77;continue b}if((b|0)==(e|0)){n=97;break b}q=41;r=b;if((a[b+1|0]|0)==0){u=d[j+76+(d[r]|0)|0]|0}else{u=R_(a[r+1|0]|0,a[b]|0)|0}switch(u|0){case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=111;break b;break};case 6:{n=108;break b;break};case 5:{n=105;break b;break};case 29:{if((c[61816+((d[63096+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=103;break b}break};default:{q=19;n=77;continue b}}b=b+2|0;n=77;continue b;break};default:{n=125;break b}}b=b+2|0;n=77}if((n|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==94){c[f>>2]=b;k=q;l=k;i=h;return l|0}else if((n|0)==97){k=-1;l=k;i=h;return l|0}else if((n|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==116){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((n|0)==119){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((n|0)==122){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((n|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==126){k=0-q|0;l=k;i=h;return l|0}}return 0}function B_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=R_(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 3:{k=S_(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=R_(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 2:{k=W_(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=R_(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{r=b;if((e-b|0)<2){p=49;break b}b=r+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 7:{s=b;if((e-b|0)<4){p=55;break b}b=s+4|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+3|0]|0)==0){if((a[b+2|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+5|0]|0)==0){if((a[b+4|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=52;break b}b=t+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function C_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=R_(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=R_(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=R_(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{r=b;if((e-b|0)<2){p=47;break b}b=r+2|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=53;break b}b=s+4|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 6:{t=b;if((e-b|0)<3){p=50;break b}b=t+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function D_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[k]|0)|0]|0}else{m=R_(a[k+1|0]|0,a[b]|0)|0}switch(m|0){case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function E_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=R_(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 10:{n=16;break a;break};case 2:{n=15;break a;break};case 9:{n=19;break a;break};case 6:{b=b+3|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 21:{n=29;break a;break};case 7:{b=b+4|0;continue a;break};case 3:{n=12;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=S_(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=R_(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function F_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=R_(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 7:{b=b+4|0;continue a;break};case 9:{n=21;break a;break};case 6:{b=b+3|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 10:{n=18;break a;break};case 3:{n=12;break a;break};case 30:{n=15;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=S_(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=T_(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=R_(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function G_(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b+1|0]|0)==0){h=d[g+76+(d[e]|0)|0]|0}else{h=R_(a[e+1|0]|0,a[b]|0)|0}switch(h|0){case 5:{break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=15;break a}j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=17;break a}else{continue a}break};case 6:{k=8;break};case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c+1|0]|0)==0){n=d[g+76+(d[k]|0)|0]|0}else{n=R_(a[k+1|0]|0,a[c]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function H_(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f+1|0]|0)!=0){h=7;break}if((a[f]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function I_(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b+1|0]|0)==0){h=d[f+76+(d[g]|0)|0]|0}else{h=R_(a[g+1|0]|0,a[b]|0)|0}switch(h|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 5:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function J_(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b+1|0]|0)==0){g=d[f+76+(d[c]|0)|0]|0}else{g=R_(a[c+1|0]|0,a[b]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function K_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[m]|0)|0]|0}else{n=R_(a[m+1|0]|0,a[b]|0)|0}b:do{switch(n|0){case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b+1|0]|0)==0){o=a[b]|0}else{o=-1}if((o|0)!=32){break}if((a[b+3|0]|0)==0){p=a[b+2|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+3|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=R_(a[m+1|0]|0,a[b+2|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function L_(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d+1|0]|0)==0){if((a[d]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d+1|0]|0)==0){f=(a[d]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d+1|0]|0)==0){g=a[d]|0}else{g=-1}h=g;switch(h|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d+1|0]|0)==0){l=(a[d]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d+1|0]|0)==0){m=a[d]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=d_(c)|0;k=j;i=b;return k|0}function M_(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==2){if((a[e+3|0]|0)!=0){break}if((a[e+2|0]|0)!=116){break}if((a[e+1|0]|0)==0){f=a[e]|0}else{f=-1}if((f|0)==103){g=62;h=g;i=b;return h|0}else if((f|0)==108){g=60;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=97){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=109){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}g=38;h=g;i=b;return h|0}else if((c|0)==4){if((a[e+1|0]|0)==0){j=a[e]|0}else{j=-1}if((j|0)==97){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=115){break}g=39;h=g;i=b;return h|0}else if((j|0)==113){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=117){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=116){break}g=34;h=g;i=b;return h|0}else{break}}}while(0);g=0;h=g;i=b;return h|0}function N_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=R_(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 6:{b=b+3|0;break};case 5:{b=b+2|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=R_(a[g+1|0]|0,a[b]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 7:{b=b+4|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function O_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=R_(a[g+1|0]|0,a[b]|0)|0}b:do{switch(l|0){case 21:{if((a[b+1|0]|0)!=0){break b}if((a[b]|0)==9){k=9;break a}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 22:case 26:{if((a[b+1|0]|0)==0){m=a[b]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b+1|0]|0)==0){n=a[b]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function P_(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j]|0;m=a[g+1|0]|0;b:do{switch(m&255|0){case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}n=((m&3)<<2|(l&255)>>6&3)+1|0;o=e;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n>>2|240;p=e;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=(l&255)>>2&15|(n&3)<<4|128;g=g+2|0;n=a[g]|0;o=((l&3)<<4|(a[g+1|0]&3)<<2|(n&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=o;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=n&63|128;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=l;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=(m&255)>>4|224;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(m&15)<<2|(l&255)>>6|128;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(l&255)>>6|(m&255)<<2|192;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function Q_(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2+1|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[(c[k>>2]|0)+1|0]|0)<<8|(d[c[k>>2]|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function R_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+24|0;a:do{switch(a&255|0){case 223:case 222:case 221:case 220:{d=8;break};case 255:{if(!(((b&255)+ -254|0)>>>0<2)){e=6;break a}d=0;break};case 219:case 218:case 217:case 216:{d=7;break};default:{e=6}}}while(0);if((e|0)==6){d=29}i=c;return d|0}function S_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=R_(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 29:{if((c[61816+((d[61560+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 19:{k=U_(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=R_(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 5:{n=29;break b;break};case 18:{n=38;break b;break};case 29:{if((c[61816+((d[63096+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=35;break b;break};case 6:{n=32;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function T_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=R_(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[61816+((d[61560+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=R_(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 18:{n=38;break b;break};case 5:{n=29;break b;break};case 6:{n=32;break b;break};case 7:{n=35;break b;break};case 29:{if((c[61816+((d[63096+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function U_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=120){break}k=V_(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=R_(a[g+1|0]|0,a[b]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=R_(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function V_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=R_(a[g+1|0]|0,a[b]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=R_(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function W_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=R_(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=R_(a[g+1|0]|0,a[b]|0)|0}if((n|0)==27){k=X_(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=Y_(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[61816+((d[61560+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 15:{k=Z_(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=__(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[m]|0)|0]|0}else{p=R_(a[m+1|0]|0,a[b]|0)|0}switch(p|0){case 29:{if((c[61816+((d[63096+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=37;break b}break};case 6:{o=42;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=R_(a[m+1|0]|0,a[b]|0)|0}switch(q|0){case 29:{if((c[61816+((d[61560+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=57;break b}break};case 24:case 22:{break};case 5:{o=59;break b;break};case 7:{o=65;break b;break};case 6:{o=62;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 5:{o=39;break b;break};case 10:case 9:case 21:{o=69;break b;break};case 17:{break b;break};case 11:{o=90;break b;break};case 7:{o=45;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b+1|0]|0)==0){r=d[j+76+(d[q]|0)|0]|0}else{r=R_(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 7:{o=84;break d;break};case 17:{break c;break};case 11:{o=90;break c;break};case 6:{o=81;break d;break};case 29:{o=75;break d;break};case 10:case 9:case 21:{break};case 5:{o=78;break d;break};case 24:case 22:{break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[61816+((d[61560+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=$_(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function X_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=R_(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b+1|0]|0)!=0){continue b}if((a[b]|0)==45){l=25;break b}else{continue b}break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function Y_(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k+1|0]|0)!=0){l=7;break}if((a[g]|0)!=(a[63760+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}



function KT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18216]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1776>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(18224,M2(c[(c[g>>2]|0)+1776>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=18536;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[18216]=1;i=d;return}function LT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18376]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1772>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(18384,M2(c[(c[g>>2]|0)+1772>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=18536;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[18376]=1;i=d;return}function MT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18560]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1764>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(18568,M2(c[(c[g>>2]|0)+1764>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=18680;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[18560]=1;i=d;return}function NT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18704]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1036>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1036>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(18712,M2(c[(c[g>>2]|0)+1036>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[18704]=1;i=d;return}function OT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18928]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1032>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(18936,M2(c[(c[g>>2]|0)+1032>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[18928]=1;i=d;return}function PT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19088]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1024>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1024>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(19096,M2(c[(c[g>>2]|0)+1024>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[19088]=1;i=d;return}function QT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19312]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1020>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(19320,M2(c[(c[g>>2]|0)+1020>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[19312]=1;i=d;return}function RT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19472]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1012>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1012>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(19480,M2(c[(c[g>>2]|0)+1012>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[19472]=1;i=d;return}function ST(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19696]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1008>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(19704,M2(c[(c[g>>2]|0)+1008>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[19696]=1;i=d;return}function TT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19856]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1756>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(19864,M2(c[(c[g>>2]|0)+1756>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[19856]=1;i=d;return}function UT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19992]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1e3>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1e3>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(2e4,M2(c[(c[g>>2]|0)+1e3>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[19992]=1;i=d;return}function VT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20216]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+996>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(20224,M2(c[(c[g>>2]|0)+996>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[20216]=1;i=d;return}function WT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20376]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+988>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+988>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(20384,M2(c[(c[g>>2]|0)+988>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[20376]=1;i=d;return}function XT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20600]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+984>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(20608,M2(c[(c[g>>2]|0)+984>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[20600]=1;i=d;return}function YT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20760]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+976>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+976>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(20768,M2(c[(c[g>>2]|0)+976>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[20760]=1;i=d;return}function ZT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20984]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+972>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(20992,M2(c[(c[g>>2]|0)+972>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[20984]=1;i=d;return}function _T(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21144]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1748>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(21152,M2(c[(c[g>>2]|0)+1748>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58112;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[21144]=1;i=d;return}function $T(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21280]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1736>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=O2(21288,M2(c[(c[g>>2]|0)+1736>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=43704;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[21280]=1;i=d;return}function aU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21384]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+964>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+964>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(21392,M2(c[(c[g>>2]|0)+964>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[21384]=1;i=d;return}function bU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21600]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+960>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(21608,M2(c[(c[g>>2]|0)+960>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[21600]=1;i=d;return}function cU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21760]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+952>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+952>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(21768,M2(c[(c[g>>2]|0)+952>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[21760]=1;i=d;return}function dU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21976]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+948>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(21984,M2(c[(c[g>>2]|0)+948>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[21976]=1;i=d;return}function eU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22136]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+940>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+940>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(22144,M2(c[(c[g>>2]|0)+940>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[22136]=1;i=d;return}function fU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22352]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+936>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(22360,M2(c[(c[g>>2]|0)+936>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[22352]=1;i=d;return}function gU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22512]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1728>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(22520,M2(c[(c[g>>2]|0)+1728>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58112;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[22512]=1;i=d;return}function hU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22640]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1720>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(22648,M2(c[(c[g>>2]|0)+1720>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=55824;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[22640]=1;i=d;return}function iU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22744]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+1168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(22752,K2(+h[(c[g>>2]|0)+1168>>3],6456)|0)|0;g=c[30094]|0;j=e;k=22864;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[22744]=1;i=d;return}function jU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22888]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+1160>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(22896,K2(+h[(c[g>>2]|0)+1160>>3],6456)|0)|0;g=c[30094]|0;j=e;k=23008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[22888]=1;i=d;return}function kU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23032]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+1136>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(23040,K2(+h[(c[g>>2]|0)+1136>>3],6456)|0)|0;g=c[30094]|0;j=e;k=23136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[23032]=1;i=d;return}function lU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23160]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+1104>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(23168,K2(+h[(c[g>>2]|0)+1104>>3],6456)|0)|0;g=c[30094]|0;j=e;k=23264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[23160]=1;i=d;return}function mU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23288]&1){i=d;return}g=b+416|0;b=y5(+h[(c[g>>2]|0)+984>>3],0.0)|0;if(!(b<<24>>24==0|(x5(+h[(c[g>>2]|0)+984>>3],1.0)|0)<<24>>24==0)){i=d;return}b=O2(23296,K2(+h[(c[g>>2]|0)+984>>3],6456)|0)|0;g=c[30094]|0;j=e;k=23432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[23288]=1;i=d;return}function nU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23456]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+928>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+928>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(23464,M2(c[(c[g>>2]|0)+928>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[23456]=1;i=d;return}function oU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23640]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+924>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(23648,M2(c[(c[g>>2]|0)+924>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[23640]=1;i=d;return}function pU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23776]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+916>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+916>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(23784,M2(c[(c[g>>2]|0)+916>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[23776]=1;i=d;return}function qU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23960]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+912>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(23968,M2(c[(c[g>>2]|0)+912>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[23960]=1;i=d;return}function rU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24096]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+904>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+904>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(24104,M2(c[(c[g>>2]|0)+904>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[24096]=1;i=d;return}function sU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24280]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+900>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(24288,M2(c[(c[g>>2]|0)+900>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[24280]=1;i=d;return}function tU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24416]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1700>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(24424,M2(c[(c[g>>2]|0)+1700>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58112;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[24416]=1;i=d;return}function uU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24520]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1692>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(24528,M2(c[(c[g>>2]|0)+1692>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=55824;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[24520]=1;i=d;return}function vU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24600]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+416>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(24608,K2(+h[(c[g>>2]|0)+416>>3],6456)|0)|0;g=c[30094]|0;j=e;k=41456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[24600]=1;i=d;return}function wU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24712]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+400>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(24720,K2(+h[(c[g>>2]|0)+400>>3],6456)|0)|0;g=c[30094]|0;j=e;k=41344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[24712]=1;i=d;return}function xU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24816]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+384>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(24824,K2(+h[(c[g>>2]|0)+384>>3],6456)|0)|0;g=c[30094]|0;j=e;k=41456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[24816]=1;i=d;return}function yU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24928]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+368>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(24936,K2(+h[(c[g>>2]|0)+368>>3],6456)|0)|0;g=c[30094]|0;j=e;k=41344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[24928]=1;i=d;return}function zU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25032]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+352>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(25040,K2(+h[(c[g>>2]|0)+352>>3],6456)|0)|0;g=c[30094]|0;j=e;k=41456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[25032]=1;i=d;return}function AU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25144]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(25152,K2(+h[(c[g>>2]|0)+336>>3],6456)|0)|0;g=c[30094]|0;j=e;k=41344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[25144]=1;i=d;return}function BU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25248]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(25256,K2(+h[(c[g>>2]|0)+304>>3],6456)|0)|0;g=c[30094]|0;j=e;k=25536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[25248]=1;i=d;return}function CU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25344]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(25352,K2(+h[(c[g>>2]|0)+296>>3],6456)|0)|0;g=c[30094]|0;j=e;k=25536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[25344]=1;i=d;return}function DU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25440]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(25448,K2(+h[(c[g>>2]|0)+288>>3],6456)|0)|0;g=c[30094]|0;j=e;k=25536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[25440]=1;i=d;return}function EU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25560]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+256>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(25568,K2(+h[(c[g>>2]|0)+256>>3],6456)|0)|0;g=c[30094]|0;j=e;k=25824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[25560]=1;i=d;return}function FU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25648]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(25656,K2(+h[(c[g>>2]|0)+248>>3],6456)|0)|0;g=c[30094]|0;j=e;k=25824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[25648]=1;i=d;return}function GU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25736]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(25744,K2(+h[(c[g>>2]|0)+240>>3],6456)|0)|0;g=c[30094]|0;j=e;k=25824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[25736]=1;i=d;return}function HU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25848]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1688>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(25856,M2(c[(c[g>>2]|0)+1688>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=25928;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[25848]=1;i=d;return}function IU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25952]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+892>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+892>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(25960,M2(c[(c[g>>2]|0)+892>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[25952]=1;i=d;return}function JU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26128]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+888>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(26136,M2(c[(c[g>>2]|0)+888>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[26128]=1;i=d;return}function KU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26264]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+880>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+880>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(26272,M2(c[(c[g>>2]|0)+880>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[26264]=1;i=d;return}function LU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26440]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+876>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(26448,M2(c[(c[g>>2]|0)+876>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[26440]=1;i=d;return}function MU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26576]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+868>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+868>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(26584,M2(c[(c[g>>2]|0)+868>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[26576]=1;i=d;return}function NU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26752]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+864>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(26760,M2(c[(c[g>>2]|0)+864>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[26752]=1;i=d;return}function OU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26888]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1680>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(26896,M2(c[(c[g>>2]|0)+1680>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[26888]=1;i=d;return}function PU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26992]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+856>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+856>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(27e3,M2(c[(c[g>>2]|0)+856>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[26992]=1;i=d;return}function QU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27168]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+852>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(27176,M2(c[(c[g>>2]|0)+852>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[27168]=1;i=d;return}function RU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27304]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+844>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+844>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(27312,M2(c[(c[g>>2]|0)+844>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[27304]=1;i=d;return}function SU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27480]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+840>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(27488,M2(c[(c[g>>2]|0)+840>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[27480]=1;i=d;return}function TU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27616]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+832>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+832>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(27624,M2(c[(c[g>>2]|0)+832>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[27616]=1;i=d;return}function UU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27792]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+828>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(27800,M2(c[(c[g>>2]|0)+828>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[27792]=1;i=d;return}function VU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27928]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1672>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(27936,M2(c[(c[g>>2]|0)+1672>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58112;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[27928]=1;i=d;return}function WU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28032]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1660>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(28040,M2(c[(c[g>>2]|0)+1660>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[28032]=1;i=d;return}function XU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28112]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+820>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+820>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(28120,M2(c[(c[g>>2]|0)+820>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[28112]=1;i=d;return}function YU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28360]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+816>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(28368,M2(c[(c[g>>2]|0)+816>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[28360]=1;i=d;return}function ZU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28544]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+808>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+808>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(28552,M2(c[(c[g>>2]|0)+808>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[28544]=1;i=d;return}function _U(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28792]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+804>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(28800,M2(c[(c[g>>2]|0)+804>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[28792]=1;i=d;return}function $U(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28976]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+796>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+796>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(28984,M2(c[(c[g>>2]|0)+796>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[28976]=1;i=d;return}function aV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29224]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+792>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(29232,M2(c[(c[g>>2]|0)+792>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[29224]=1;i=d;return}function bV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29408]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1648>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(29416,M2(c[(c[g>>2]|0)+1648>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[29408]=1;i=d;return}function cV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29560]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+784>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+784>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(29568,M2(c[(c[g>>2]|0)+784>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[29560]=1;i=d;return}function dV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29808]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+780>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(29816,M2(c[(c[g>>2]|0)+780>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[29808]=1;i=d;return}function eV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29992]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+772>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+772>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(3e4,M2(c[(c[g>>2]|0)+772>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[29992]=1;i=d;return}function fV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30240]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+768>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(30248,M2(c[(c[g>>2]|0)+768>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[30240]=1;i=d;return}function gV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30424]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+760>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+760>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(30432,M2(c[(c[g>>2]|0)+760>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[30424]=1;i=d;return}function hV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30672]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+756>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(30680,M2(c[(c[g>>2]|0)+756>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[30672]=1;i=d;return}function iV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30856]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1640>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(30864,M2(c[(c[g>>2]|0)+1640>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[30856]=1;i=d;return}function jV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31008]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+748>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+748>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(31016,M2(c[(c[g>>2]|0)+748>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[31008]=1;i=d;return}function kV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31256]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+744>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(31264,M2(c[(c[g>>2]|0)+744>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[31256]=1;i=d;return}function lV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31440]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+736>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+736>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(31448,M2(c[(c[g>>2]|0)+736>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[31440]=1;i=d;return}function mV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31688]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+732>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(31696,M2(c[(c[g>>2]|0)+732>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[31688]=1;i=d;return}function nV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31872]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+724>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+724>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(31880,M2(c[(c[g>>2]|0)+724>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[31872]=1;i=d;return}function oV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32120]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+720>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(32128,M2(c[(c[g>>2]|0)+720>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[32120]=1;i=d;return}function pV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32304]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1632>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(32312,M2(c[(c[g>>2]|0)+1632>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58112;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[32304]=1;i=d;return}function qV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32456]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+712>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+712>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(32464,M2(c[(c[g>>2]|0)+712>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[32456]=1;i=d;return}function rV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32704]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+708>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(32712,M2(c[(c[g>>2]|0)+708>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[32704]=1;i=d;return}function sV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32888]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+700>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+700>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(32896,M2(c[(c[g>>2]|0)+700>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[32888]=1;i=d;return}function tV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33136]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+696>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(33144,M2(c[(c[g>>2]|0)+696>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[33136]=1;i=d;return}function uV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33320]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+688>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+688>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(33328,M2(c[(c[g>>2]|0)+688>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[33320]=1;i=d;return}function vV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33568]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+684>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(33576,M2(c[(c[g>>2]|0)+684>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[33568]=1;i=d;return}function wV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33752]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1624>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(33760,M2(c[(c[g>>2]|0)+1624>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58112;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[33752]=1;i=d;return}function xV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33904]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1604>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(33912,M2(c[(c[g>>2]|0)+1604>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=54656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[33904]=1;i=d;return}function yV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34016]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+676>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+676>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(34024,M2(c[(c[g>>2]|0)+676>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[34016]=1;i=d;return}function zV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34224]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+672>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(34232,M2(c[(c[g>>2]|0)+672>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[34224]=1;i=d;return}function AV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34376]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+664>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+664>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(34384,M2(c[(c[g>>2]|0)+664>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[34376]=1;i=d;return}function BV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34584]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+660>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(34592,M2(c[(c[g>>2]|0)+660>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[34584]=1;i=d;return}function CV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34736]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+652>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+652>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(34744,M2(c[(c[g>>2]|0)+652>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[34736]=1;i=d;return}function DV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34944]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+648>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(34952,M2(c[(c[g>>2]|0)+648>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[34944]=1;i=d;return}function EV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35096]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1596>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(35104,M2(c[(c[g>>2]|0)+1596>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[35096]=1;i=d;return}function FV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35224]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+640>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+640>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(35232,M2(c[(c[g>>2]|0)+640>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[35224]=1;i=d;return}function GV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35432]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+636>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(35440,M2(c[(c[g>>2]|0)+636>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[35432]=1;i=d;return}function HV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35584]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+628>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+628>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(35592,M2(c[(c[g>>2]|0)+628>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[35584]=1;i=d;return}function IV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35792]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+624>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(35800,M2(c[(c[g>>2]|0)+624>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[35792]=1;i=d;return}function JV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35944]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+616>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+616>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(35952,M2(c[(c[g>>2]|0)+616>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[35944]=1;i=d;return}function KV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36152]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+612>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(36160,M2(c[(c[g>>2]|0)+612>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[36152]=1;i=d;return}function LV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36304]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1588>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(36312,M2(c[(c[g>>2]|0)+1588>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58112;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[36304]=1;i=d;return}function MV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36432]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1576>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(36440,M2(c[(c[g>>2]|0)+1576>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[36432]=1;i=d;return}function NV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36528]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+604>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+604>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(36536,M2(c[(c[g>>2]|0)+604>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[36528]=1;i=d;return}function OV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36712]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+600>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(36720,M2(c[(c[g>>2]|0)+600>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[36712]=1;i=d;return}function PV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36848]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+592>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+592>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(36856,M2(c[(c[g>>2]|0)+592>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[36848]=1;i=d;return}function QV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37032]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+588>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(37040,M2(c[(c[g>>2]|0)+588>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[37032]=1;i=d;return}function RV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37168]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+580>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+580>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(37176,M2(c[(c[g>>2]|0)+580>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[37168]=1;i=d;return}function SV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37352]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+576>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(37360,M2(c[(c[g>>2]|0)+576>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[37352]=1;i=d;return}function TV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37488]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1568>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(37496,M2(c[(c[g>>2]|0)+1568>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[37488]=1;i=d;return}function UV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37600]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+568>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+568>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(37608,M2(c[(c[g>>2]|0)+568>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[37600]=1;i=d;return}function VV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37784]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+564>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(37792,M2(c[(c[g>>2]|0)+564>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[37784]=1;i=d;return}function WV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37920]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+556>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+556>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(37928,M2(c[(c[g>>2]|0)+556>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[37920]=1;i=d;return}function XV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38104]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+552>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(38112,M2(c[(c[g>>2]|0)+552>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[38104]=1;i=d;return}function YV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38240]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+544>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+544>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(38248,M2(c[(c[g>>2]|0)+544>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[38240]=1;i=d;return}function ZV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38424]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+540>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(38432,M2(c[(c[g>>2]|0)+540>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[38424]=1;i=d;return}function _V(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38560]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1560>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(38568,M2(c[(c[g>>2]|0)+1560>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58112;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[38560]=1;i=d;return}function $V(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38672]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1548>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=O2(38680,M2(c[(c[g>>2]|0)+1548>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=43704;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[38672]=1;i=d;return}function aW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38752]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+532>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+532>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(38760,M2(c[(c[g>>2]|0)+532>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[38752]=1;i=d;return}function bW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38960]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+528>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(38968,M2(c[(c[g>>2]|0)+528>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[38960]=1;i=d;return}function cW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39112]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+520>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+520>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(39120,M2(c[(c[g>>2]|0)+520>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[39112]=1;i=d;return}function dW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39320]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+516>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(39328,M2(c[(c[g>>2]|0)+516>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[39320]=1;i=d;return}function eW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39472]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+508>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+508>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(39480,M2(c[(c[g>>2]|0)+508>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[39472]=1;i=d;return}function fW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39680]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+504>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(39688,M2(c[(c[g>>2]|0)+504>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[39680]=1;i=d;return}function gW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39832]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1540>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(39840,M2(c[(c[g>>2]|0)+1540>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[39832]=1;i=d;return}function hW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39960]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+496>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+496>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(39968,M2(c[(c[g>>2]|0)+496>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[39960]=1;i=d;return}function iW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40168]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+492>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(40176,M2(c[(c[g>>2]|0)+492>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[40168]=1;i=d;return}function jW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40320]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+484>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+484>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(40328,M2(c[(c[g>>2]|0)+484>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[40320]=1;i=d;return}function kW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40528]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+480>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(40536,M2(c[(c[g>>2]|0)+480>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[40528]=1;i=d;return}function lW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40680]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+472>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+472>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(40688,M2(c[(c[g>>2]|0)+472>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[40680]=1;i=d;return}function mW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40888]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+468>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(40896,M2(c[(c[g>>2]|0)+468>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[40888]=1;i=d;return}function nW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41040]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1532>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(41048,M2(c[(c[g>>2]|0)+1532>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58112;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[41040]=1;i=d;return}function oW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41168]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1520>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(41176,M2(c[(c[g>>2]|0)+1520>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[41168]=1;i=d;return}function pW(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41264]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+944>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(41272,K2(+h[(c[g>>2]|0)+944>>3],6456)|0)|0;g=c[30094]|0;j=e;k=41344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[41264]=1;i=d;return}function qW(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41368]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(41376,K2(+h[(c[g>>2]|0)+928>>3],6456)|0)|0;g=c[30094]|0;j=e;k=41456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[41368]=1;i=d;return}function rW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41480]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+460>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+460>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(41488,M2(c[(c[g>>2]|0)+460>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[41480]=1;i=d;return}function sW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41664]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+456>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(41672,M2(c[(c[g>>2]|0)+456>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[41664]=1;i=d;return}function tW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41800]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+448>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+448>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(41808,M2(c[(c[g>>2]|0)+448>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[41800]=1;i=d;return}function uW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41984]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+444>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(41992,M2(c[(c[g>>2]|0)+444>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[41984]=1;i=d;return}function vW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42120]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+436>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+436>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(42128,M2(c[(c[g>>2]|0)+436>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[42120]=1;i=d;return}function wW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42304]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+432>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(42312,M2(c[(c[g>>2]|0)+432>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[42304]=1;i=d;return}function xW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42440]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1512>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(42448,M2(c[(c[g>>2]|0)+1512>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[42440]=1;i=d;return}function yW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42552]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+424>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+424>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(42560,M2(c[(c[g>>2]|0)+424>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[42552]=1;i=d;return}function zW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42736]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+420>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(42744,M2(c[(c[g>>2]|0)+420>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[42736]=1;i=d;return}function AW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42872]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+412>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+412>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(42880,M2(c[(c[g>>2]|0)+412>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[42872]=1;i=d;return}function BW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43056]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+408>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(43064,M2(c[(c[g>>2]|0)+408>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[43056]=1;i=d;return}function CW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43192]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+400>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+400>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(43200,M2(c[(c[g>>2]|0)+400>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[43192]=1;i=d;return}function DW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43376]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+396>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(43384,M2(c[(c[g>>2]|0)+396>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[43376]=1;i=d;return}function EW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43512]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1504>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(43520,M2(c[(c[g>>2]|0)+1504>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58112;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[43512]=1;i=d;return}function FW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43624]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1492>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=O2(43632,M2(c[(c[g>>2]|0)+1492>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=43704;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[43624]=1;i=d;return}function GW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43728]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+388>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+388>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(43736,M2(c[(c[g>>2]|0)+388>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[43728]=1;i=d;return}function HW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43936]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+384>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(43944,M2(c[(c[g>>2]|0)+384>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[43936]=1;i=d;return}function IW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44088]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+376>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+376>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(44096,M2(c[(c[g>>2]|0)+376>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[44088]=1;i=d;return}



function Tva(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;g=i;h=d+12|0;j=c[h>>2]|0;k=(b|0)==0|(f|0)==0;if(!k){c[f+48>>2]=0;c[c[f+36>>2]>>2]=-1}l=c[f+28>>2]|0;m=Jwa((l<<3)+8|0)|0;n=m;if((m|0)==0){o=12;i=g;return o|0}c[m>>2]=-1;p=Jwa((l<<2)+4|0)|0;if((p|0)==0){Kwa(m);o=12;i=g;return o|0}c[p>>2]=-1;q=0;while(1){if(q>>>0>l>>>0){break}else{q=q+1|0}}Zva(d,e)|0;e=Zva(d,0)|0;q=c[h>>2]|0;a:do{if((q|0)>(j|0)&(e|0)==0){l=d+16|0;r=f+32|0;s=f+16|0;t=f+36|0;u=q;v=0;w=-1;x=1;y=0;z=0;A=n;B=0;while(1){C=u+ -1|0;c[h>>2]=C;D=c[l>>2]|0;b:do{switch(c[D+(C<<2)>>2]|0){case 5:{E=u+ -2|0;c[h>>2]=E;F=c[D+(E<<2)>>2]|0;if(!k){G=v;H=w;I=x;J=y;K=z;L=A;M=0;N=B;break b}E=c[F+4>>2]|0;c[F+20>>2]=(c[(c[E+4>>2]|0)+20>>2]|0)+(c[(c[E>>2]|0)+20>>2]|0);G=v;H=w;I=x;J=y;K=z;L=A;M=0;N=B;break};case 0:{E=u+ -2|0;c[h>>2]=E;F=c[D+(E<<2)>>2]|0;E=F;O=F+12|0;P=c[O>>2]|0;if((P|0)>-1){Q=0;do{R=A+(Q<<2)|0;Q=Q+1|0}while((c[R>>2]|0)>-1);c[R>>2]=P<<1;c[A+(Q<<2)>>2]=-1;do{if(!k){S=0;while(1){if((c[p+(S<<2)>>2]|0)>-1){S=S+1|0}else{break}}c[(c[s>>2]|0)+(P*12|0)+8>>2]=0;if((S|0)<=0){break}T=Jwa((S<<2)+4|0)|0;U=T;if((T|0)==0){V=w;W=y;X=z;Y=A;Z=12;_=B;break a}c[(c[s>>2]|0)+(P*12|0)+8>>2]=U;$=c[p>>2]|0;if(($|0)>-1){aa=U;ba=$;$=0;while(1){c[aa>>2]=ba;ca=$+1|0;da=c[p+(ca<<2)>>2]|0;ea=T+(ca<<2)|0;if((da|0)>-1){$=ca;ba=da;aa=ea}else{fa=ea;break}}}else{fa=U}c[fa>>2]=-1}}while(0);P=Zva(d,c[O>>2]|0)|0;if((P|0)!=0){V=w;W=y;X=z;Y=A;Z=P;_=B;break a}P=Zva(d,6)|0;if((P|0)!=0){V=w;W=y;X=z;Y=A;Z=P;_=B;break a}}P=c[F>>2]|0;do{if((P|0)==0){Q=c[c[F+4>>2]>>2]|0;if(!((Q|0)>-1|(Q|0)==-4)){ga=v;ha=w;ia=x;ja=y;ka=z;la=0;ma=B;break}if(!((c[A>>2]|0)>-1)){ga=v;ha=w;ia=x;ja=y;ka=z;la=0;ma=B;break}if(k){c[F+20>>2]=1;na=w;oa=y;pa=0}else{Q=$va(b,E,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){aa=c[t>>2]|0;ba=0;while(1){qa=aa+(ba<<2)|0;ra=ba+1|0;if((c[qa>>2]|0)>-1){ba=ra}else{break}}c[qa>>2]=B;c[aa+(ra<<2)>>2]=w;c[aa+(ba+2<<2)>>2]=-1;sa=-1;ta=y+1|0}else{sa=w;ta=y}U=c[A>>2]|0;if((U|0)>-1){$=c[s>>2]|0;T=U;U=0;do{S=(T|0)/2|0;if((T&1|0)==0){c[$+(S*12|0)>>2]=B}else{c[$+(S*12|0)+4>>2]=B}U=U+1|0;T=c[A+(U<<2)>>2]|0;}while((T|0)>-1)}c[A>>2]=-1;na=sa;oa=ta;pa=Q}c[A>>2]=-1;ga=v;ha=na;ia=x+1|0;ja=oa;ka=z+1|0;la=pa;ma=x}else if((P|0)==3){T=c[F+4>>2]|0;U=c[T>>2]|0;$=c[T+4>>2]|0;T=(c[A>>2]|0)>-1;ba=x+1|0;aa=Zva(d,T?ba:x)|0;if((aa|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=aa;ma=B;break}aa=Zva(d,T?x:B)|0;if((aa|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=aa;ma=B;break}aa=Zva(d,A)|0;if((aa|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=aa;ma=B;break}aa=Zva(d,(c[A>>2]|0)>>>31^1)|0;if((aa|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=aa;ma=B;break}aa=Zva(d,F)|0;if((aa|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=aa;ma=B;break}aa=$;$=Zva(d,aa)|0;if(($|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=$;ma=B;break}$=U;U=Zva(d,$)|0;if((U|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=U;ma=B;break}U=Zva(d,3)|0;if((U|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=U;ma=B;break}U=Zva(d,aa)|0;if((U|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=U;ma=B;break}U=Zva(d,0)|0;if((U|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=U;ma=B;break}U=Zva(d,2)|0;if((U|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=U;ma=B;break}U=Zva(d,$)|0;if((U|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=U;ma=B;break}U=Zva(d,0)|0;if((U|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=U;ma=B;break}if((c[A>>2]|0)>-1){if(k){ua=w;va=y;wa=0}else{U=$va(b,E,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){$=c[t>>2]|0;aa=0;while(1){xa=$+(aa<<2)|0;ya=aa+1|0;if((c[xa>>2]|0)>-1){aa=ya}else{break}}c[xa>>2]=B;c[$+(ya<<2)>>2]=w;c[$+(aa+2<<2)>>2]=-1;za=-1;Aa=y+1|0}else{za=w;Aa=y}Q=c[A>>2]|0;if((Q|0)>-1){T=c[s>>2]|0;S=Q;Q=0;do{ea=(S|0)/2|0;if((S&1|0)==0){c[T+(ea*12|0)>>2]=B}else{c[T+(ea*12|0)+4>>2]=B}Q=Q+1|0;S=c[A+(Q<<2)>>2]|0;}while((S|0)>-1)}c[A>>2]=-1;ua=za;va=Aa;wa=U}c[A>>2]=-1;Ba=ua;Ca=ba;Da=va;Ea=z+1|0;Fa=wa;Ga=x}else{Ba=w;Ca=x;Da=y;Ea=z;Fa=0;Ga=B}if((c[F+16>>2]|0)<=0){ga=v;ha=Ba;ia=Ca;ja=Da;ka=Ea;la=Fa;ma=Ga;break}ga=v;ha=Ba;ia=Ca+2|0;ja=Da;ka=Ea;la=Fa;ma=Ca+1|0}else if((P|0)==1){S=c[F+4>>2]|0;Q=c[S>>2]|0;T=c[S+4>>2]|0;S=Zva(d,F)|0;if((S|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=S;ma=B;break}S=Zva(d,5)|0;if((S|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=S;ma=B;break}S=Zva(d,T)|0;if((S|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=S;ma=B;break}S=Zva(d,0)|0;if((S|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=S;ma=B;break}S=Q+20|0;aa=Zva(d,(c[S>>2]|0)+x|0)|0;if((aa|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=aa;ma=B;break}if((c[S>>2]|0)>0){S=(c[T+20>>2]|0)>0;Ha=(S&1)+x|0;Ia=S?x:-1}else{Ha=x;Ia=-1}S=Zva(d,Ia)|0;if((S|0)!=0){ga=v;ha=w;ia=Ha;ja=y;ka=z;la=S;ma=B;break}S=Zva(d,4)|0;if((S|0)!=0){ga=v;ha=w;ia=Ha;ja=y;ka=z;la=S;ma=B;break}S=Zva(d,Q)|0;if((S|0)!=0){ga=v;ha=w;ia=Ha;ja=y;ka=z;la=S;ma=B;break}ga=v;ha=w;ia=Ha;ja=y;ka=z;la=Zva(d,0)|0;ma=B}else if((P|0)==2){S=c[F+4>>2]|0;if(k){if((c[A>>2]|0)>-1){Ja=1}else{Ja=a[S+12|0]&1}Q=Zva(d,Ja)|0;if((Q|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=Q;ma=B;break}}else{Q=Zva(d,B)|0;if((Q|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=Q;ma=B;break}Q=Zva(d,a[S+12|0]&1)|0;if((Q|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=Q;ma=B;break}}Q=Zva(d,F)|0;if((Q|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=Q;ma=B;break}Q=Zva(d,1)|0;if((Q|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=Q;ma=B;break}Q=Zva(d,c[S>>2]|0)|0;if((Q|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=Q;ma=B;break}Q=Zva(d,0)|0;if((Q|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=Q;ma=B;break}if(!((c[A>>2]|0)>-1)){if((a[S+12|0]&1)==0){ga=0;ha=w;ia=x;ja=y;ka=z;la=0;ma=B;break}}if(k){Ka=w;La=y;Ma=0}else{Q=$va(b,E,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=(a[S+12|0]&1)==0?v:1;if((w|0)>-1){S=c[t>>2]|0;T=0;while(1){Na=S+(T<<2)|0;Oa=T+1|0;if((c[Na>>2]|0)>-1){T=Oa}else{break}}c[Na>>2]=B;c[S+(Oa<<2)>>2]=w;c[S+(T+2<<2)>>2]=-1;Pa=-1;Qa=y+1|0}else{Pa=w;Qa=y}ba=c[A>>2]|0;if((ba|0)>-1){U=c[s>>2]|0;aa=ba;ba=0;do{$=(aa|0)/2|0;if((aa&1|0)==0){c[U+($*12|0)>>2]=B}else{c[U+($*12|0)+4>>2]=B}ba=ba+1|0;aa=c[A+(ba<<2)>>2]|0;}while((aa|0)>-1)}c[A>>2]=-1;Ka=Pa;La=Qa;Ma=Q}c[A>>2]=-1;ga=0;ha=Ka;ia=x+1|0;ja=La;ka=z+1|0;la=Ma;ma=x}else{ga=v;ha=w;ia=x;ja=y;ka=z;la=0;ma=B}}while(0);E=c[O>>2]|0;if((E|0)>-1){Ra=0}else{G=ga;H=ha;I=ia;J=ja;K=ka;L=A;M=la;N=ma;break b}do{Sa=p+(Ra<<2)|0;Ra=Ra+1|0}while((c[Sa>>2]|0)>-1);c[Sa>>2]=E;c[p+(Ra<<2)>>2]=-1;G=ga;H=ha;I=ia;J=ja;K=ka;L=A;M=la;N=ma;break};case 2:{O=A;while(1){if((c[O>>2]|0)>-1){O=O+4|0}else{G=v;H=w;I=x;J=y;K=z;L=O;M=0;N=B;break}}break};case 6:{O=u+ -2|0;c[h>>2]=O;E=c[D+(O<<2)>>2]|0;O=0;do{Ta=A+(O<<2)|0;O=O+1|0}while((c[Ta>>2]|0)>-1);c[Ta>>2]=E<<1|1;c[A+(O<<2)>>2]=-1;F=0;while(1){if((c[p+(F<<2)>>2]|0)>-1){F=F+1|0}else{break}}c[p+(F+ -1<<2)>>2]=-1;G=v;H=w;I=x;J=y;K=z;L=A;M=0;N=B;break};case 3:{O=c[D+(u+ -2<<2)>>2]|0;E=c[D+(u+ -3<<2)>>2]|0;P=c[D+(u+ -4<<2)>>2]|0;aa=u+ -5|0;c[h>>2]=aa;if(k){ba=c[P+4>>2]|0;U=P+16|0;c[P+20>>2]=(c[(c[ba>>2]|0)+20>>2]|0)+(c[D+(aa<<2)>>2]|0)+(c[(c[ba+4>>2]|0)+20>>2]|0)+((c[U>>2]|0)>0?2:0);Ua=U;Va=c[h>>2]|0}else{Ua=P+16|0;Va=aa}aa=c[D+(Va+ -1<<2)>>2]|0;P=Va+ -2|0;c[h>>2]=P;U=c[D+(P<<2)>>2]|0;P=Va+ -3|0;c[h>>2]=P;ba=c[D+(P<<2)>>2]|0;if((c[Ua>>2]|0)<=0){G=1;H=w;I=x;J=y;K=z;L=aa;M=0;N=B;break b}if(k){Wa=0}else{awa(b,O,U)|0;c[(c[r>>2]|0)+(U<<2)>>2]=1;U=awa(b,E,ba)|0;c[(c[r>>2]|0)+(ba<<2)>>2]=1;Wa=U}G=1;H=w;I=x;J=y;K=z+2|0;L=aa;M=Wa;N=B;break};case 4:{aa=u+ -2|0;c[h>>2]=aa;U=c[D+(aa<<2)>>2]|0;aa=u+ -3|0;c[h>>2]=aa;G=v;H=w;I=c[D+(aa<<2)>>2]|0;J=y;K=z;L=A;M=0;N=(U|0)>-1?U:B;break};case 1:{U=u+ -2|0;c[h>>2]=U;aa=c[D+(U<<2)>>2]|0;if(k){U=c[(c[c[aa+4>>2]>>2]|0)+20>>2]|0;ba=u+ -3|0;c[h>>2]=ba;c[aa+20>>2]=(c[D+(ba<<2)>>2]|0)+U;G=v;H=-1;I=x;J=y;K=z;L=A;M=0;N=B;break b}else{U=u+ -3|0;c[h>>2]=U;ba=c[D+(U<<2)>>2]|0;U=u+ -4|0;c[h>>2]=U;aa=(ba|0)==0;G=aa&1;H=aa?w:c[D+(U<<2)>>2]|0;I=x;J=y;K=z;L=A;M=0;N=B;break b}break};default:{G=v;H=w;I=x;J=y;K=z;L=A;M=0;N=B}}}while(0);D=c[h>>2]|0;if((D|0)>(j|0)&(M|0)==0){u=D;v=G;w=H;x=I;y=J;z=K;A=L;B=N}else{V=H;W=J;X=K;Y=L;Z=M;_=N;break a}}}else{V=-1;W=0;X=0;Y=n;Z=e;_=0}}while(0);do{if(k){Xa=W}else{e=c[Y>>2]|0;if((e|0)>-1){n=c[f+16>>2]|0;N=e;e=0;do{M=(N|0)/2|0;if((N&1|0)==0){c[n+(M*12|0)>>2]=_}else{c[n+(M*12|0)+4>>2]=_}e=e+1|0;N=c[Y+(e<<2)>>2]|0;}while((N|0)>-1)}c[Y>>2]=-1;if(!((V|0)>-1)){Xa=W;break}N=c[f+36>>2]|0;e=0;while(1){Ya=N+(e<<2)|0;Za=e+1|0;if((c[Ya>>2]|0)>-1){e=Za}else{break}}c[Ya>>2]=_;c[N+(Za<<2)>>2]=V;c[N+(e+2<<2)>>2]=-1;Xa=W+1|0}}while(0);c[f+48>>2]=X;c[f+40>>2]=X;c[f+44>>2]=Xa;Kwa(m);Kwa(p);o=Z;i=g;return o|0}function Uva(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a;a:while(1){a=c[g>>2]|0;do{if((a|0)==3){h=c[g+4>>2]|0;j=Uva(c[h>>2]|0,b,d,e)|0;if((j|0)!=0){k=j;l=10;break a}m=h+4|0}else if((a|0)==1){h=c[g+4>>2]|0;j=h+4|0;n=Wva(c[(c[h>>2]|0)+28>>2]|0,c[(c[j>>2]|0)+24>>2]|0,b,d,e)|0;if((n|0)!=0){k=n;l=10;break a}n=Uva(c[h>>2]|0,b,d,e)|0;if((n|0)==0){m=j}else{k=n;l=10;break a}}else if((a|0)==2){n=c[g+4>>2]|0;j=n;if(!((c[n+8>>2]|0)==-1)){m=j;break}h=c[n>>2]|0;n=Wva(c[h+28>>2]|0,c[h+24>>2]|0,b,d,e)|0;if((n|0)==0){m=j}else{k=n;l=10;break a}}else{k=0;l=10;break a}}while(0);g=c[m>>2]|0}if((l|0)==10){i=f;return k|0}return 0}function Vva(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+4>>2]|0;if((d|0)==0){i=b;return}a=d+4|0;e=c[d>>2]|0;if((c[a>>2]|0)==0){f=e}else{g=e;e=0;while(1){do{if((c[g+(e<<5)+8>>2]|0)==0){h=g}else{j=c[g+(e<<5)+16>>2]|0;if((j|0)==0){k=g}else{Kwa(j);k=c[d>>2]|0}j=c[k+(e<<5)+28>>2]|0;if((j|0)==0){h=k;break}Kwa(j);h=c[d>>2]|0}}while(0);j=e+1|0;if(j>>>0<(c[a>>2]|0)>>>0){g=h;e=j}else{f=h;break}}}if((f|0)!=0){Kwa(f)}f=d+8|0;h=c[f>>2]|0;if((h|0)!=0){if((c[h+8>>2]|0)==0){l=h}else{e=h;while(1){h=c[e+16>>2]|0;if((h|0)!=0){Kwa(h)}if((c[e+40>>2]|0)==0){break}else{e=e+32|0}}l=c[f>>2]|0}Kwa(l)}l=d+16|0;f=c[l>>2]|0;if((f|0)!=0){e=d+28|0;h=c[e>>2]|0;if((h|0)==0){m=f}else{g=h;h=f;f=0;while(1){a=c[h+(f*12|0)+8>>2]|0;if((a|0)==0){n=h;o=g}else{Kwa(a);n=c[l>>2]|0;o=c[e>>2]|0}a=f+1|0;if(a>>>0<o>>>0){g=o;h=n;f=a}else{m=n;break}}}Kwa(m)}m=c[d+32>>2]|0;if((m|0)!=0){Kwa(m)}m=c[d+20>>2]|0;if((m|0)!=0){Kwa(m)}m=c[d+36>>2]|0;if((m|0)!=0){Kwa(m)}Kwa(d);i=b;return}function Wva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;h=a;a=c[h>>2]|0;j=(a|0)>-1;if((d|0)==0){if(!j){k=0;i=g;return k|0}l=b;m=a;a=h;while(1){a:do{if((c[l>>2]|0)>-1){n=b;o=m;while(1){p=e+(o<<2)|0;c[p>>2]=(c[p>>2]|0)+1;p=n+32|0;if(!((c[p>>2]|0)>-1)){break a}o=c[a>>2]|0;n=p}}}while(0);n=a+32|0;o=c[n>>2]|0;if((o|0)>-1){m=o;a=n}else{k=0;break}}i=g;return k|0}if(!j){k=0;i=g;return k|0}j=b;a=h;b:while(1){h=c[j>>2]|0;c:do{if((h|0)>-1){m=a+4|0;e=a+8|0;l=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+12|0;r=b;s=h;t=j;u=-1;while(1){v=r;w=s;x=t;while(1){y=v+32|0;if((w|0)!=(u|0)){break}z=y;A=c[z>>2]|0;if((A|0)>-1){w=A;x=z;v=y}else{break c}}z=d+(c[f+(c[a>>2]<<2)>>2]<<5)|0;while(1){B=z+8|0;if((c[B>>2]|0)==0){break}else{z=z+32|0}}c[z+40>>2]=0;c[z>>2]=c[m>>2];c[z+4>>2]=c[e>>2];A=c[x>>2]|0;c[B>>2]=d+(c[f+(A<<2)>>2]<<5);c[z+12>>2]=A;A=c[n>>2]|0;C=c[o>>2]|0;D=c[v+16>>2]|c[l>>2]|((A|0)!=0?4:0)|((C|0)!=0?8:0);E=z+20|0;c[E>>2]=D;F=c[p>>2]|0;G=z+24|0;if((F|0)>-1){c[G>>2]=F;c[E>>2]=D|256}else{c[G>>2]=A}if((C|0)==0){c[z+28>>2]=0}else{A=0;while(1){H=A+1|0;if((c[C+(A<<2)>>2]|0)==0){break}else{A=H}}A=Jwa(H<<2)|0;C=A;c[z+28>>2]=C;if((A|0)==0){k=12;I=49;break b}x=c[o>>2]|0;G=c[x>>2]|0;if((G|0)==0){J=C}else{D=C;C=G;G=0;while(1){c[D>>2]=C;E=G+1|0;F=c[x+(E<<2)>>2]|0;K=A+(E<<2)|0;if((F|0)==0){J=K;break}else{G=E;C=F;D=K}}}c[J>>2]=0}D=c[q>>2]|0;if((D|0)==0){L=0}else{C=0;while(1){if((c[D+(C<<2)>>2]|0)>-1){C=C+1|0}else{L=C;break}}}C=v+12|0;D=c[C>>2]|0;if((D|0)==0){M=0}else{G=0;while(1){if((c[D+(G<<2)>>2]|0)>-1){G=G+1|0}else{M=G;break}}}G=z+16|0;D=c[G>>2]|0;if((D|0)!=0){Kwa(D)}c[G>>2]=0;D=M+L|0;if((D|0)>0){v=Jwa((D<<2)+4|0)|0;c[G>>2]=v;if((v|0)==0){k=12;I=49;break b}G=c[q>>2]|0;do{if((G|0)==0){N=0}else{D=c[G>>2]|0;if((D|0)>-1){O=D;P=0}else{N=0;break}while(1){c[v+(P<<2)>>2]=O;D=P+1|0;A=c[G+(D<<2)>>2]|0;if((A|0)>-1){P=D;O=A}else{N=D;break}}}}while(0);G=c[C>>2]|0;do{if((G|0)==0){Q=N}else{z=c[G>>2]|0;if(!((z|0)>-1)){Q=N;break}D=(N|0)>0;A=z;z=0;x=N;while(1){d:do{if(D){K=0;while(1){F=K+1|0;if((c[v+(K<<2)>>2]|0)==(A|0)){R=x;break d}if((F|0)<(N|0)){K=F}else{I=40;break}}}else{I=40}}while(0);if((I|0)==40){I=0;c[v+(x<<2)>>2]=A;R=x+1|0}K=z+1|0;F=c[G+(K<<2)>>2]|0;if((F|0)>-1){A=F;z=K;x=R}else{Q=R;break}}}}while(0);c[v+(Q<<2)>>2]=-1}G=y;C=c[G>>2]|0;if((C|0)>-1){r=y;s=C;t=G;u=w}else{break}}}}while(0);h=a+32|0;if((c[h>>2]|0)>-1){a=h}else{k=0;I=49;break}}if((I|0)==49){i=g;return k|0}return 0}function Xva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=(e|0)==0;a:do{if(h){j=0}else{k=0;while(1){if(!((c[e+(k<<2)>>2]|0)>-1)){j=k;break a}k=k+1|0}}}while(0);k=0;while(1){if((c[b+(k<<5)>>2]|0)>-1){k=k+1|0}else{l=0;break}}while(1){if((c[d+(l<<5)>>2]|0)>-1){l=l+1|0}else{break}}m=hwa(a,0,0,1,(l+k<<5)+32|0)|0;k=m;if((m|0)==0){n=0;i=g;return n|0}l=c[b>>2]|0;b:do{if((l|0)>-1){o=(j|0)>0;p=l;q=0;while(1){c[m+(q<<5)>>2]=p;c[m+(q<<5)+4>>2]=c[b+(q<<5)+4>>2];c[m+(q<<5)+8>>2]=c[b+(q<<5)+8>>2];c[m+(q<<5)+16>>2]=c[b+(q<<5)+16>>2]|f;c[m+(q<<5)+20>>2]=c[b+(q<<5)+20>>2];c[m+(q<<5)+24>>2]=c[b+(q<<5)+24>>2];c[m+(q<<5)+28>>2]=c[b+(q<<5)+28>>2];r=b+(q<<5)+12|0;s=c[r>>2]|0;t=(s|0)==0;if(t&h){c[m+(q<<5)+12>>2]=0}else{c:do{if(t){u=0}else{v=0;while(1){if(!((c[s+(v<<2)>>2]|0)>-1)){u=v;break c}v=v+1|0}}}while(0);s=hwa(a,0,0,0,(u+j<<2)+4|0)|0;t=s;if((s|0)==0){n=0;break}if((u|0)>0){v=c[r>>2]|0;w=0;while(1){c[s+(w<<2)>>2]=c[v+(w<<2)>>2];x=w+1|0;if((x|0)<(u|0)){w=x}else{y=u;break}}}else{y=0}if(o){w=0;while(1){c[s+(w+y<<2)>>2]=c[e+(w<<2)>>2];v=w+1|0;if((v|0)<(j|0)){w=v}else{z=j;break}}}else{z=0}c[s+(z+y<<2)>>2]=-1;c[m+(q<<5)+12>>2]=t}w=q+1|0;v=c[b+(w<<5)>>2]|0;if((v|0)>-1){p=v;q=w}else{A=w;break b}}i=g;return n|0}else{A=0}}while(0);b=c[d>>2]|0;y=m+(A<<5)|0;d:do{if((b|0)>-1){z=y;j=A;e=b;u=0;while(1){c[z>>2]=e;c[m+(j<<5)+4>>2]=c[d+(u<<5)+4>>2];c[m+(j<<5)+8>>2]=c[d+(u<<5)+8>>2];c[m+(j<<5)+16>>2]=c[d+(u<<5)+16>>2];c[m+(j<<5)+20>>2]=c[d+(u<<5)+20>>2];c[m+(j<<5)+24>>2]=c[d+(u<<5)+24>>2];c[m+(j<<5)+28>>2]=c[d+(u<<5)+28>>2];h=d+(u<<5)+12|0;f=c[h>>2]|0;if((f|0)==0){c[m+(j<<5)+12>>2]=0}else{l=0;while(1){if((c[f+(l<<2)>>2]|0)>-1){l=l+1|0}else{break}}f=hwa(a,0,0,0,(l<<2)+4|0)|0;t=f;if((f|0)==0){n=0;break}if((l|0)>0){s=c[h>>2]|0;q=0;while(1){c[f+(q<<2)>>2]=c[s+(q<<2)>>2];p=q+1|0;if((p|0)<(l|0)){q=p}else{B=l;break}}}else{B=0}c[f+(B<<2)>>2]=-1;c[m+(j<<5)+12>>2]=t}l=u+1|0;q=c[d+(l<<5)>>2]|0;s=l+A|0;h=m+(s<<5)|0;if((q|0)>-1){z=h;j=s;e=q;u=l}else{C=h;break d}}i=g;return n|0}else{C=y}}while(0);c[C>>2]=-1;n=k;i=g;return n|0}function Yva(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=a+12|0;j=c[h>>2]|0;k=(f|0)!=0;if(k){c[f>>2]=0}l=Zva(a,b)|0;if((l|0)!=0){m=l;i=g;return m|0}l=a+16|0;b=(d|0)==0;n=(e|0)==0;a:while(1){o=c[h>>2]|0;if((o|0)<=(j|0)){m=0;p=28;break}q=o+ -1|0;c[h>>2]=q;o=c[(c[l>>2]|0)+(q<<2)>>2]|0;q=c[o>>2]|0;do{if((q|0)==0){r=c[o+4>>2]|0;s=c[r>>2]|0;if((s|0)==-2){if(n){continue a}c[e>>2]=c[e>>2]|c[r+4>>2];continue a}else if(!((s|0)==-3)){continue a}s=c[r+4>>2]|0;if(!((s|0)>-1)){continue a}b:do{if(!b){r=c[d>>2]|0;c:do{if((r|0)>-1){t=r;u=d;v=0;while(1){w=v+1|0;if((t|0)==(s|0)){break}x=d+(w<<2)|0;y=c[x>>2]|0;if((y|0)>-1){t=y;u=x;v=w}else{z=x;A=w;break c}}if((s|0)<0){z=u;A=v}else{break b}}else{z=d;A=0}}while(0);c[z>>2]=s;c[d+(A+1<<2)>>2]=-1}}while(0);if(!k){continue a}c[f>>2]=(c[f>>2]|0)+1;continue a}else if((q|0)==2){s=c[c[o+4>>2]>>2]|0;if((c[s+8>>2]|0)==0){continue a}B=Zva(a,s)|0}else if((q|0)==1){s=c[o+4>>2]|0;r=Zva(a,c[s>>2]|0)|0;if((r|0)!=0){m=r;p=28;break a}B=Zva(a,c[s+4>>2]|0)|0}else if((q|0)==3){s=c[o+4>>2]|0;r=c[s>>2]|0;if((c[r+8>>2]|0)!=0){B=Zva(a,r)|0;break}r=c[s+4>>2]|0;if((c[r+8>>2]|0)==0){continue a}B=Zva(a,r)|0}else{continue a}}while(0);if((B|0)!=0){m=B;p=28;break}}if((p|0)==28){i=g;return m|0}return 0}function Zva(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a;h=c[g>>2]|0;if((f|0)<(h|0)){c[(c[a+16>>2]|0)+(f<<2)>>2]=b;c[e>>2]=(c[e>>2]|0)+1;j=0;i=d;return j|0}e=c[a+4>>2]|0;if((h|0)>=(e|0)){j=12;i=d;return j|0}f=(c[a+8>>2]|0)+h|0;h=(f|0)>(e|0)?e:f;f=a+16|0;e=Mwa(c[f>>2]|0,h<<2)|0;if((e|0)==0){j=12;i=d;return j|0}else{c[g>>2]=h;c[f>>2]=e;Zva(a,b)|0;i=d;return 0}return 0}function _va(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;l=i;m=d+12|0;n=c[m>>2]|0;Zva(d,e)|0;e=Zva(d,0)|0;a:do{if((e|0)==0){o=d+16|0;p=(f&1|0)==0;q=(f&2|0)==0;r=1;s=0;t=j;b:while(1){u=c[m>>2]|0;if((u|0)<=(n|0)){v=s;w=0;break a}x=u+ -1|0;c[m>>2]=x;y=c[o>>2]|0;z=c[y+(x<<2)>>2]|0;if((z|0)==1){x=u+ -2|0;c[m>>2]=x;A=s;B=r;t=c[y+(x<<2)>>2]|0;s=A;r=B;continue}else if((z|0)!=0){C=t;A=s;B=r;t=C;s=A;r=B;continue}z=u+ -2|0;c[m>>2]=z;u=c[y+(z<<2)>>2]|0;z=c[u>>2]|0;do{if((z|0)==1){y=c[u+4>>2]|0;x=c[y>>2]|0;D=y+4|0;E=c[D>>2]|0;F=hwa(b,0,0,1,32)|0;if((F|0)==0){G=29;break b}H=hwa(b,0,0,1,8)|0;I=F+4|0;c[I>>2]=H;if((H|0)==0){G=29;break b}c[F>>2]=1;c[F+8>>2]=-1;c[F+12>>2]=-1;c[H>>2]=x;c[(c[I>>2]|0)+4>>2]=E;c[F+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);c[t>>2]=F;F=c[I>>2]|0;c[F>>2]=0;I=F+4|0;c[I>>2]=0;x=Zva(d,c[D>>2]|0)|0;if((x|0)!=0){v=s;w=x;break a}x=Zva(d,0)|0;if((x|0)!=0){v=s;w=x;break a}x=Zva(d,I)|0;if((x|0)!=0){v=s;w=x;break a}x=Zva(d,1)|0;if((x|0)!=0){v=s;w=x;break a}x=Zva(d,c[y>>2]|0)|0;if((x|0)!=0){v=s;w=x;break a}J=r;K=s;L=F;M=Zva(d,0)|0}else if((z|0)==3){F=c[u+4>>2]|0;x=c[F>>2]|0;y=F+4|0;I=c[y>>2]|0;D=hwa(b,0,0,1,32)|0;if((D|0)==0){G=20;break b}E=hwa(b,0,0,1,8)|0;H=D+4|0;c[H>>2]=E;if((E|0)==0){G=20;break b}c[D>>2]=3;c[D+8>>2]=-1;c[D+12>>2]=-1;c[E>>2]=x;c[(c[H>>2]|0)+4>>2]=I;c[D+16>>2]=(c[I+16>>2]|0)+(c[x+16>>2]|0);c[t>>2]=D;D=c[H>>2]|0;H=Zva(d,c[y>>2]|0)|0;if((H|0)!=0){v=s;w=H;break a}H=Zva(d,0)|0;if((H|0)!=0){v=s;w=H;break a}H=Zva(d,D+4|0)|0;if((H|0)!=0){v=s;w=H;break a}H=Zva(d,1)|0;if((H|0)!=0){v=s;w=H;break a}H=Zva(d,c[F>>2]|0)|0;if((H|0)!=0){v=s;w=H;break a}J=r;K=s;L=D;M=Zva(d,0)|0}else if((z|0)==0){D=c[u+4>>2]|0;H=c[D+8>>2]|0;F=c[D>>2]|0;y=c[D+4>>2]|0;do{if((F|0)>-1|(F|0)==-4){N=r;O=y;P=F;Q=s+1|0;R=(c[g>>2]|0)+H|0}else{if(!((F|0)==-3)){N=r;O=y;P=F;Q=s;R=H;break}if(!p){N=r;O=-1;P=-1;Q=s;R=-1;break}if(q|(r|0)==0){N=r;O=y;P=-3;Q=s;R=H;break}c[h+(y<<2)>>2]=1;N=0;O=y;P=-3;Q=s;R=H}}while(0);H=hwa(b,0,0,1,32)|0;y=H;do{if((H|0)==0){S=0}else{F=hwa(b,0,0,1,20)|0;c[H+4>>2]=F;if((F|0)==0){S=0;break}c[H>>2]=0;c[H+8>>2]=-1;c[H+12>>2]=-1;c[F>>2]=P;c[F+4>>2]=O;c[F+8>>2]=R;S=y}}while(0);c[t>>2]=S;y=(S|0)==0?12:0;if((R|0)<=(c[k>>2]|0)){J=N;K=Q;L=t;M=y;break}c[k>>2]=R;J=N;K=Q;L=t;M=y}else if((z|0)==2){y=c[u+4>>2]|0;H=Zva(d,c[y>>2]|0)|0;if((H|0)!=0){v=s;w=H;break a}H=Zva(d,0)|0;if((H|0)!=0){v=s;w=H;break a}H=c[y>>2]|0;F=c[y+4>>2]|0;D=c[y+8>>2]|0;x=a[y+12|0]|0;y=hwa(b,0,0,1,32)|0;if((y|0)==0){G=40;break b}I=hwa(b,0,0,1,16)|0;E=y+4|0;c[E>>2]=I;if((I|0)==0){G=40;break b}c[y>>2]=2;c[y+8>>2]=-1;c[y+12>>2]=-1;c[I>>2]=H;c[I+4>>2]=F;c[I+8>>2]=D;D=I+12|0;a[D]=a[D]&-2|x&1;c[y+16>>2]=c[H+16>>2];c[t>>2]=y;A=s;B=r;t=c[E>>2]|0;s=A;r=B;continue b}else{C=t;A=s;B=r;t=C;s=A;r=B;continue b}}while(0);if((M|0)==0){r=J;s=K;t=L}else{v=K;w=M;break a}}if((G|0)==20){c[t>>2]=0;v=s;w=12;break}else if((G|0)==29){c[t>>2]=0;v=s;w=12;break}else if((G|0)==40){c[t>>2]=0;v=s;w=12;break}}else{v=0;w=e}}while(0);c[g>>2]=(c[g>>2]|0)+v;i=l;return w|0}function $va(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=hwa(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=hwa(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=hwa(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f>>2]=j;k=hwa(a,0,0,0,32)|0;l=f+4|0;c[l>>2]=k;if((k|0)==0){g=12;i=e;return g|0}m=b+4|0;c[k+4>>2]=c[m>>2];k=b;c[c[l>>2]>>2]=c[k>>2];n=c[l>>2]|0;c[n+8>>2]=-1;c[n+12>>2]=-1;c[n+24>>2]=0;c[(c[l>>2]|0)+28>>2]=0;c[(c[l>>2]|0)+20>>2]=0;c[m>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f>>2]=0;g=12;i=e;return g|0}function awa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=hwa(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=hwa(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=hwa(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f+4>>2]=j;k=hwa(a,0,0,0,32)|0;c[f>>2]=k;if((k|0)==0){g=12;i=e;return g|0}l=b+4|0;c[k+4>>2]=c[l>>2];k=b;c[c[f>>2]>>2]=c[k>>2];m=c[f>>2]|0;c[m+8>>2]=-1;c[m+12>>2]=-1;c[m+24>>2]=0;c[(c[f>>2]|0)+28>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[l>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f+4>>2]=0;g=12;i=e;return g|0}function bwa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[c[(c[b>>2]|0)+4>>2]>>2]|0;if((e|0)<(a|0)){f=-1;i=d;return f|0}f=(e|0)>(a|0)|0;i=d;return f|0}function cwa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;g=d;a:do{if((b|0)==0){h=160416}else{j=b;k=160416;while(1){if((a[k]|0)==0){h=k;break a}l=j+ -1|0;m=k+((lxa(k|0)|0)+1)|0;if((l|0)==0){h=m;break}else{j=l;k=m}}}}while(0);c[g>>2]=(a[h]|0)==0?h+1|0:h;h=(Lc(e|0,f|0,160704,g|0)|0)+1|0;i=d;return h|0}function dwa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0;g=i;i=i+16|0;h=g;j=g+8|0;k=c[a+4>>2]|0;a=k;l=k+40|0;m=c[l>>2]|0;do{if((m|0)<1|(d|0)==0){n=0}else{o=Jwa(m<<2)|0;if((o|0)==0){p=12}else{n=o;break}i=g;return p|0}}while(0);m=n;a:do{if((c[k+60>>2]|0)==0){c[h>>2]=0;o=f&1;q=f&2;r=k+56|0;s=c[r>>2]&4;if((n|0)==0){t=0}else{t=c[l>>2]|0}u=t<<2;v=c[k+52>>2]|0;w=v<<3;x=w+8|0;y=u+12+w+(x+(fa(u,v)|0)<<1)|0;z=Jwa(y)|0;if((z|0)==0){A=12;break}pxa(z|0,0,y|0)|0;y=z;B=z+u&3;C=((B|0)==0?0:4-B|0)+u|0;B=z+C|0;D=B;E=C+x|0;C=z+E&3;F=((C|0)==0?0:4-C|0)+E|0;E=z+F|0;C=E;G=F+x|0;x=z+G&3;F=((x|0)==0?0:4-x|0)+G|0;G=z+F|0;x=F+w|0;w=z+x&3;if((v|0)>0){F=t<<3;H=0;I=z+(((w|0)==0?0:4-w|0)+x)|0;while(1){c[E+(H<<3)+4>>2]=I;c[B+(H<<3)+4>>2]=I+u;x=H+1|0;if((x|0)<(v|0)){I=I+F|0;H=x}else{J=0;break}}do{c[G+(J<<3)>>2]=-1;J=J+1|0;}while((J|0)<(v|0))}v=Nva(h,b,4)|0;if((v|0)<1){if((v|0)<0){A=1;break}K=v+1|0}else{K=v}v=k+8|0;H=(s|0)==0;F=(o|0)==0;I=(t|0)>0;B=k+12|0;E=k+44|0;x=k+32|0;w=k+36|0;L=(t|0)==0;M=I^1;N=-1;O=0;P=0;Q=K;R=0;S=C;T=D;U=D;V=b+K|0;W=y;while(1){if((N|0)<0){X=c[v>>2]|0;Y=X+8|0;b:do{if((c[Y>>2]|0)==0){Z=N;_=O;$=U}else{aa=(P|0)==0;ba=(R|0)==95;ca=(P|0)<1&F;da=((R|0)!=10|H)^1;ea=Y;ga=N;ha=O;ia=U;ja=X;while(1){ka=ea;la=ja;c:while(1){ma=la+12|0;if((c[G+(c[ma>>2]<<3)>>2]|0)>=(P|0)){na=ga;oa=ha;pa=ia;break}qa=la+20|0;ra=c[qa>>2]|0;if((ra|0)==0){sa=260;break}d:do{if((ra&1|0)==0|ca|da){if((ra&2|0)!=0){ta=c[h>>2]|0;if((ta|q|0)!=0&((ta|0)!=10|H)){break}}do{if((ra&16|0)!=0){if(ba){break d}if((sva(R)|0)!=0){break d}ta=c[h>>2]|0;if((ta|0)==95){break}if((sva(ta)|0)==0){break d}}}while(0);ta=c[qa>>2]|0;if((ta&32|0)==0){ua=ta}else{if(!ba){if((sva(R)|0)==0){break}}ta=c[h>>2]|0;if((ta|0)==95){break}if((sva(ta)|0)!=0){break}ua=c[qa>>2]|0}do{if((ua&64|0)==0|aa){va=ua}else{ta=c[h>>2]|0;if((ta|0)==0){va=ua;break}if(ba){wa=ta;xa=1}else{ta=(sva(R)|0)!=0|0;wa=c[h>>2]|0;xa=ta}if((wa|0)==95){ya=1}else{ya=(sva(wa)|0)!=0|0}if((xa|0)==(ya|0)){break d}va=c[qa>>2]|0}}while(0);if((va&128|0)==0){sa=260;break c}if(aa){break}ta=c[h>>2]|0;if((ta|0)==0){break}if(ba){za=ta;Aa=1}else{ta=(sva(R)|0)!=0|0;za=c[h>>2]|0;Aa=ta}if((za|0)==95){Ba=1}else{Ba=(sva(za)|0)!=0|0}if((Aa|0)==(Ba|0)){sa=260;break c}}}while(0);qa=la+40|0;if((c[qa>>2]|0)==0){Z=ga;_=ha;$=ia;break b}else{ka=qa;la=la+32|0}}if((sa|0)==260){sa=0;qa=ia;c[qa>>2]=c[ka>>2];if(I){pxa(c[ia+4>>2]|0,-1,u|0)|0}ra=c[la+16>>2]|0;do{if((ra|0)!=0){ta=c[ra>>2]|0;if(!((ta|0)>-1)){break}Ca=ia+4|0;Da=ta;ta=ra;do{if((Da|0)<(t|0)){c[(c[Ca>>2]|0)+(Da<<2)>>2]=P}ta=ta+4|0;Da=c[ta>>2]|0;}while((Da|0)>-1)}}while(0);ra=(c[qa>>2]|0)!=(c[B>>2]|0);if(ra|M){Ea=ia+4|0;Fa=ra?ga:P;Ga=ra?ha:1}else{ra=ia+4|0;ka=c[ra>>2]|0;Da=0;while(1){c[n+(Da<<2)>>2]=c[ka+(Da<<2)>>2];ta=Da+1|0;if((ta|0)<(t|0)){Da=ta}else{Ea=ra;Fa=P;Ga=1;break}}}c[G+(c[ma>>2]<<3)>>2]=P;c[G+(c[ma>>2]<<3)+4>>2]=Ea;na=Fa;oa=Ga;pa=ia+8|0}ra=la+40|0;if((c[ra>>2]|0)==0){Z=na;_=oa;$=pa;break}else{ea=ra;ga=na;ha=oa;ia=pa;ja=la+32|0}}}}while(0);c[$>>2]=0;Ha=Z;Ia=_}else{if(L|(U|0)==(T|0)){Ja=N;break}else{Ha=N;Ia=O}}X=c[h>>2]|0;if((X|0)==0){Ja=Ha;break}Y=P+Q|0;ja=Nva(h,V,4)|0;if((ja|0)<1){if((ja|0)<0){A=1;break a}Ka=ja+1|0}else{Ka=ja}ja=V+Ka|0;if((c[E>>2]|0)==0|(Ia|0)==0){La=Ia;Ma=T;Na=S}else{ia=T;ha=c[ia>>2]|0;if((ha|0)==0){Oa=S}else{ga=ha;ha=ia;ia=S;while(1){ea=c[w>>2]|0;ba=c[ea>>2]|0;aa=ha+4|0;e:do{if((ba|0)>-1){da=ba;ca=0;while(1){ra=c[ea+((ca|1)<<2)>>2]|0;if((da|0)>=(t|0)){Pa=ia;break e}Da=c[aa>>2]|0;if((c[Da+(ra<<2)>>2]|0)==(c[n+(ra<<2)>>2]|0)){if((c[Da+(da<<2)>>2]|0)<(c[n+(da<<2)>>2]|0)){Pa=ia;break e}}Da=ca+2|0;ra=c[ea+(Da<<2)>>2]|0;if((ra|0)>-1){da=ra;ca=Da}else{sa=287;break}}}else{sa=287}}while(0);if((sa|0)==287){sa=0;c[ia>>2]=ga;ea=ia+4|0;ba=c[ea>>2]|0;c[ea>>2]=c[aa>>2];c[aa>>2]=ba;Pa=ia+8|0}ba=ha+8|0;ea=c[ba>>2]|0;if((ea|0)==0){Oa=Pa;break}else{ga=ea;ha=ba;ia=Pa}}}c[Oa>>2]=0;La=0;Ma=S;Na=T}ia=c[Ma>>2]|0;if((ia|0)==0){Qa=Ha;Ra=La;Sa=Na;Ta=W}else{ha=(Y|0)==0;ga=(X|0)==95;ba=(Y|0)<1&F;ea=((X|0)!=10|H)^1;ca=ia;ia=Ha;da=La;la=Ma;Da=Na;ra=W;while(1){ka=ca+8|0;if((c[ka>>2]|0)==0){Ua=ia;Va=da;Wa=Da;Xa=ra}else{qa=la+4|0;ta=ka;ka=ia;Ca=da;Ya=Da;Za=ra;_a=ca;while(1){f:do{if((c[_a>>2]|0)>>>0>X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za}else{if((c[_a+4>>2]|0)>>>0<X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za;break}db=_a+20|0;eb=c[db>>2]|0;g:do{if((eb|0)!=0){if(!((eb&1|0)==0|ba|ea)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((eb&2|0)!=0){fb=c[h>>2]|0;if((fb|q|0)!=0&((fb|0)!=10|H)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}do{if((eb&16|0)!=0){if(ga){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((sva(X)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==95){break}if((sva(fb)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);fb=c[db>>2]|0;if((fb&32|0)==0){gb=fb}else{if(!ga){if((sva(X)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}fb=c[h>>2]|0;if((fb|0)==95){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((sva(fb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}gb=c[db>>2]|0}do{if((gb&64|0)==0|ha){hb=gb}else{fb=c[h>>2]|0;if((fb|0)==0){hb=gb;break}if(ga){ib=fb;jb=1}else{fb=(sva(X)|0)!=0|0;ib=c[h>>2]|0;jb=fb}if((ib|0)==95){kb=1}else{kb=(sva(ib)|0)!=0|0}if((jb|0)==(kb|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}hb=c[db>>2]|0}}while(0);if((hb&128|0)==0){lb=hb}else{if(ha){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if(ga){mb=fb;nb=1}else{fb=(sva(X)|0)!=0|0;mb=c[h>>2]|0;nb=fb}if((mb|0)==95){ob=1}else{ob=(sva(mb)|0)!=0|0}if((nb|0)!=(ob|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}lb=c[db>>2]|0}do{if((lb&4|0)==0){pb=lb}else{if((c[r>>2]&2|0)!=0){pb=lb;break}if((wva(X,c[_a+24>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}pb=c[db>>2]|0}}while(0);do{if((pb&4|0)!=0){if((c[r>>2]&2|0)==0){break}fb=Iva(X)|0;qb=_a+24|0;if((wva(fb,c[qb>>2]|0)|0)!=0){break}fb=Gva(X)|0;if((wva(fb,c[qb>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);if((c[db>>2]&8|0)==0){break}qb=c[_a+28>>2]|0;fb=c[qb>>2]|0;if((fb|0)==0){break}if((c[r>>2]&2|0)==0){rb=qb;sb=fb;while(1){if((wva(X,sb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}rb=rb+4|0;sb=c[rb>>2]|0;if((sb|0)==0){break g}}}else{tb=qb}do{sb=Gva(X)|0;if((wva(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}sb=Iva(X)|0;if((wva(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}tb=tb+4|0;}while((c[tb>>2]|0)!=0)}}while(0);if(I){db=c[qa>>2]|0;eb=0;do{c[Za+(eb<<2)>>2]=c[db+(eb<<2)>>2];eb=eb+1|0;}while((eb|0)<(t|0))}eb=c[_a+16>>2]|0;do{if((eb|0)!=0){db=c[eb>>2]|0;if((db|0)>-1){ub=db;vb=eb}else{break}do{if((ub|0)<(t|0)){c[Za+(ub<<2)>>2]=Y}vb=vb+4|0;ub=c[vb>>2]|0;}while((ub|0)>-1)}}while(0);eb=_a+12|0;db=c[eb>>2]|0;qb=G+(db<<3)|0;if((c[qb>>2]|0)<(Y|0)){sb=Ya;c[sb>>2]=c[ta>>2];rb=Ya+4|0;fb=c[rb>>2]|0;c[rb>>2]=Za;c[qb>>2]=Y;c[G+(c[eb>>2]<<3)+4>>2]=rb;do{if((c[sb>>2]|0)==(c[B>>2]|0)){if((ka|0)==-1){if(!I){wb=Y;xb=1;break}yb=c[rb>>2]|0}else{if(!I){wb=ka;xb=Ca;break}eb=c[rb>>2]|0;if((c[eb>>2]|0)>(c[n>>2]|0)){wb=ka;xb=Ca;break}else{yb=eb}}eb=0;while(1){c[n+(eb<<2)>>2]=c[yb+(eb<<2)>>2];qb=eb+1|0;if((qb|0)<(t|0)){eb=qb}else{wb=Y;xb=1;break}}}else{wb=ka;xb=Ca}}while(0);$a=wb;ab=xb;bb=Ya+8|0;cb=fb;break}else{rb=c[x>>2]|0;sb=c[G+(db<<3)+4>>2]|0;eb=c[sb>>2]|0;if(I){zb=0}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break}while(1){qb=c[Za+(zb<<2)>>2]|0;Ab=c[eb+(zb<<2)>>2]|0;if((c[rb+(zb<<2)>>2]|0)==0){if((qb|0)<(Ab|0)){break}if((qb|0)>(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}else{if((qb|0)>(Ab|0)){break}if((qb|0)<(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}Ab=zb+1|0;if((Ab|0)<(t|0)){zb=Ab}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}c[sb>>2]=Za;if((c[ta>>2]|0)==(c[B>>2]|0)){Bb=0}else{$a=ka;ab=Ca;bb=Ya;cb=eb;break}while(1){c[n+(Bb<<2)>>2]=c[Za+(Bb<<2)>>2];rb=Bb+1|0;if((rb|0)<(t|0)){Bb=rb}else{$a=Y;ab=1;bb=Ya;cb=eb;break}}}}}while(0);eb=_a+40|0;if((c[eb>>2]|0)==0){Ua=$a;Va=ab;Wa=bb;Xa=cb;break}else{ta=eb;ka=$a;Ca=ab;Ya=bb;Za=cb;_a=_a+32|0}}}_a=la+8|0;Za=c[_a>>2]|0;if((Za|0)==0){Qa=Ua;Ra=Va;Sa=Wa;Ta=Xa;break}else{ca=Za;ia=Ua;da=Va;la=_a;Da=Wa;ra=Xa}}}c[Sa>>2]=0;N=Qa;O=Ra;P=Y;Q=Ka;R=X;S=Ma;T=Na;U=Sa;V=ja;W=Ta}Kwa(z);Cb=Ja;Db=Ja>>>31;sa=375}else{c[j>>2]=0;W=f&1;V=f&2;U=k+56|0;T=c[U>>2]&4;S=fwa(0,0)|0;if((S|0)==0){A=12;break}R=hwa(S,0,0,0,32)|0;Q=R;if((R|0)==0){gwa(S);A=12;break}c[R+24>>2]=0;c[R+28>>2]=0;R=c[l>>2]|0;if((R|0)==0){Eb=0;sa=9}else{P=Jwa(R<<2)|0;O=P;if((P|0)==0){Fb=0;Gb=0;Hb=12;Ib=0;Jb=O}else{Eb=O;sa=9}}do{if((sa|0)==9){O=Eb;P=c[k+28>>2]|0;if((P|0)==0){Kb=0}else{N=Jwa(P<<3)|0;P=N;if((N|0)==0){Fb=0;Gb=P;Hb=12;Ib=0;Jb=Eb;break}else{Kb=P}}P=k+52|0;N=c[P>>2]|0;if((N|0)==0){Lb=0}else{B=Jwa(N<<2)|0;N=B;if((B|0)==0){Fb=0;Gb=Kb;Hb=12;Ib=N;Jb=Eb;break}else{Lb=N}}N=Lb;B=(n|0)==0;I=k+8|0;G=k+12|0;x=k+32|0;r=(T|0)==0;H=(W|0)==0;q=R;F=-1;w=1;E=-1;L=Q;M=b;h:while(1){do{if((q|0)>0){if(B){pxa(O|0,-1,q<<2|0)|0;break}else{u=0;do{c[Eb+(u<<2)>>2]=-1;c[n+(u<<2)>>2]=-1;u=u+1|0;}while((u|0)<(c[l>>2]|0))}}}while(0);u=c[P>>2]|0;if((u|0)>0){pxa(N|0,0,u<<2|0)|0}u=c[j>>2]|0;v=w+E|0;y=Nva(j,M,4)|0;if((y|0)<1){if((y|0)<0){A=1;break a}Mb=y+1|0}else{Mb=y}y=M+Mb|0;D=c[j>>2]|0;C=c[I>>2]|0;o=C+8|0;if((c[o>>2]|0)==0){Nb=F;Ob=0;Pb=Mb;Qb=L;sa=196}else{s=(v|0)==0;ra=(u|0)==95;Da=(v|0)<1&H;la=((u|0)!=10|r)^1;da=o;o=0;ia=L;ca=0;ga=C;while(1){C=ga+20|0;ha=c[C>>2]|0;i:do{if((ha|0)==0){sa=56}else{if(!((ha&1|0)==0|Da|la)){Rb=o;Sb=ia;Tb=ca;break}if((ha&2|0)!=0){ea=c[j>>2]|0;if((ea|V|0)!=0&((ea|0)!=10|r)){Rb=o;Sb=ia;Tb=ca;break}}do{if((ha&16|0)!=0){if(ra){Rb=o;Sb=ia;Tb=ca;break i}if((sva(u)|0)!=0){Rb=o;Sb=ia;Tb=ca;break i}ea=c[j>>2]|0;if((ea|0)==95){break}if((sva(ea)|0)==0){Rb=o;Sb=ia;Tb=ca;break i}}}while(0);ea=c[C>>2]|0;if((ea&32|0)==0){Ub=ea}else{if(!ra){if((sva(u)|0)==0){Rb=o;Sb=ia;Tb=ca;break}}ea=c[j>>2]|0;if((ea|0)==95){Rb=o;Sb=ia;Tb=ca;break}if((sva(ea)|0)!=0){Rb=o;Sb=ia;Tb=ca;break}Ub=c[C>>2]|0}do{if((Ub&64|0)==0|s){Vb=Ub}else{ea=c[j>>2]|0;if((ea|0)==0){Vb=Ub;break}if(ra){Wb=ea;Xb=1}else{ea=(sva(u)|0)!=0|0;Wb=c[j>>2]|0;Xb=ea}if((Wb|0)==95){Yb=1}else{Yb=(sva(Wb)|0)!=0|0}if((Xb|0)==(Yb|0)){Rb=o;Sb=ia;Tb=ca;break i}Vb=c[C>>2]|0}}while(0);if((Vb&128|0)==0){sa=56;break}if(s){Rb=o;Sb=ia;Tb=ca;break}ea=c[j>>2]|0;if((ea|0)==0){Rb=o;Sb=ia;Tb=ca;break}if(ra){Zb=ea;_b=1}else{ea=(sva(u)|0)!=0|0;Zb=c[j>>2]|0;_b=ea}if((Zb|0)==95){$b=1}else{$b=(sva(Zb)|0)!=0|0}if((_b|0)==($b|0)){sa=56}else{Rb=o;Sb=ia;Tb=ca}}}while(0);do{if((sa|0)==56){sa=0;if((ca|0)==0){Rb=c[ga+16>>2]|0;Sb=ia;Tb=c[da>>2]|0;break}C=ia+28|0;ha=c[C>>2]|0;if((ha|0)==0){ea=hwa(S,0,0,0,32)|0;ba=ea;if((ea|0)==0){sa=60;break h}c[ea+24>>2]=ia;c[ea+28>>2]=0;_a=hwa(S,0,0,0,c[l>>2]<<2)|0;c[ea+20>>2]=_a;if((_a|0)==0){sa=67;break h}c[C>>2]=ba;ac=ba}else{ac=ha}c[ac>>2]=v;c[ac+4>>2]=y;c[ac+8>>2]=c[da>>2];c[ac+12>>2]=c[ga+12>>2];c[ac+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ha=c[ac+20>>2]|0;ba=0;do{c[ha+(ba<<2)>>2]=c[Eb+(ba<<2)>>2];ba=ba+1|0;}while((ba|0)<(c[l>>2]|0))}ba=c[ga+16>>2]|0;if((ba|0)==0){Rb=o;Sb=ac;Tb=ca;break}ha=c[ba>>2]|0;if(!((ha|0)>-1)){Rb=o;Sb=ac;Tb=ca;break}C=c[ac+20>>2]|0;_a=ha;ha=ba;while(1){ba=ha+4|0;c[C+(_a<<2)>>2]=v;ea=c[ba>>2]|0;if((ea|0)>-1){ha=ba;_a=ea}else{Rb=o;Sb=ac;Tb=ca;break}}}}while(0);_a=ga+40|0;if((c[_a>>2]|0)==0){break}else{da=_a;o=Rb;ia=Sb;ca=Tb;ga=ga+32|0}}do{if((Rb|0)==0){bc=0}else{ga=c[Rb>>2]|0;if((ga|0)>-1){cc=ga;dc=Rb}else{bc=Rb;break}while(1){c[Eb+(cc<<2)>>2]=v;ga=dc+4|0;ca=c[ga>>2]|0;if((ca|0)>-1){dc=ga;cc=ca}else{bc=ga;break}}}}while(0);if((Tb|0)==0){Nb=F;Ob=bc;Pb=Mb;Qb=Sb;sa=196}else{ec=F;fc=bc;gc=v;hc=Mb;ic=Sb;jc=Tb;kc=y}}j:while(1){if((sa|0)==196){sa=0;ga=c[Qb+24>>2]|0;if((ga|0)==0){break}ca=c[Qb+8>>2]|0;if((c[ca+20>>2]&256|0)!=0){c[Lb+(c[Qb+12>>2]<<2)>>2]=0}ia=c[Qb>>2]|0;o=c[Qb+4>>2]|0;c[j>>2]=c[Qb+16>>2];da=c[l>>2]|0;if((da|0)<=0){ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue}u=c[Qb+20>>2]|0;ra=0;while(1){c[Eb+(ra<<2)>>2]=c[u+(ra<<2)>>2];s=ra+1|0;if((s|0)<(da|0)){ra=s}else{ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue j}}}if((jc|0)==(c[G>>2]|0)){lc=fc;mc=gc;nc=hc;oc=ic}else{o=fc;ca=gc;ga=hc;ia=ic;ra=jc;da=kc;while(1){u=ra+8|0;do{if((c[u>>2]|0)==0){sa=109}else{if((c[ra+20>>2]&256|0)==0){sa=109;break}s=c[ra+24>>2]|0;ewa(s+1|0,Kb,c[U>>2]&-9,a,Eb,ca);la=c[Kb+(s<<3)>>2]|0;Da=c[Kb+(s<<3)+4>>2]|0;s=Da-la|0;if((ixa(b+la|0,da+ -1|0,s)|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}_a=(Da|0)==(la|0);la=_a&1;Da=Lb+(c[ra+12>>2]<<2)|0;if(_a){if((c[Da>>2]|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}}c[Da>>2]=la;la=s+ -1|0;s=la+ca|0;Da=c[j>>2]|0;_a=Nva(j,da+la|0,4)|0;if((_a|0)<1){if((_a|0)<0){A=1;break a}pc=_a+1|0}else{pc=_a}qc=s;rc=pc+la|0;sc=pc;tc=Da}}while(0);do{if((sa|0)==109){sa=0;Da=c[j>>2]|0;if((Da|0)==0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}la=Nva(j,da,4)|0;if((la|0)>=1){qc=ca;rc=la;sc=la;tc=Da;break}if((la|0)<0){A=1;break a}s=la+1|0;qc=ca;rc=s;sc=s;tc=Da}}while(0);Da=da+rc|0;s=qc+ga|0;if((c[u>>2]|0)==0){Nb=ec;Ob=o;Pb=sc;Qb=ia;sa=196;continue j}la=(s|0)==0;_a=(tc|0)==95;ha=(s|0)<1&H;C=((tc|0)!=10|r)^1;ea=u;ba=0;Za=o;Ya=ia;Ca=ra;while(1){k:do{if((c[Ca>>2]|0)>>>0>tc>>>0){uc=ba;vc=Za;wc=Ya}else{if((c[Ca+4>>2]|0)>>>0<tc>>>0){uc=ba;vc=Za;wc=Ya;break}ka=Ca+20|0;ta=c[ka>>2]|0;l:do{if((ta|0)!=0){if(!((ta&1|0)==0|ha|C)){uc=ba;vc=Za;wc=Ya;break k}if((ta&2|0)!=0){qa=c[j>>2]|0;if((qa|V|0)!=0&((qa|0)!=10|r)){uc=ba;vc=Za;wc=Ya;break k}}do{if((ta&16|0)!=0){if(_a){uc=ba;vc=Za;wc=Ya;break k}if((sva(tc)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==95){break}if((sva(qa)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);qa=c[ka>>2]|0;if((qa&32|0)==0){xc=qa}else{if(!_a){if((sva(tc)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}qa=c[j>>2]|0;if((qa|0)==95){uc=ba;vc=Za;wc=Ya;break k}if((sva(qa)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}xc=c[ka>>2]|0}do{if((xc&64|0)==0|la){yc=xc}else{qa=c[j>>2]|0;if((qa|0)==0){yc=xc;break}if(_a){zc=qa;Ac=1}else{qa=(sva(tc)|0)!=0|0;zc=c[j>>2]|0;Ac=qa}if((zc|0)==95){Bc=1}else{Bc=(sva(zc)|0)!=0|0}if((Ac|0)==(Bc|0)){uc=ba;vc=Za;wc=Ya;break k}yc=c[ka>>2]|0}}while(0);if((yc&128|0)==0){Cc=yc}else{if(la){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==0){uc=ba;vc=Za;wc=Ya;break k}if(_a){Dc=qa;Ec=1}else{qa=(sva(tc)|0)!=0|0;Dc=c[j>>2]|0;Ec=qa}if((Dc|0)==95){Fc=1}else{Fc=(sva(Dc)|0)!=0|0}if((Ec|0)!=(Fc|0)){uc=ba;vc=Za;wc=Ya;break k}Cc=c[ka>>2]|0}do{if((Cc&4|0)==0){Gc=Cc}else{if((c[U>>2]&2|0)!=0){Gc=Cc;break}if((wva(tc,c[Ca+24>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}Gc=c[ka>>2]|0}}while(0);do{if((Gc&4|0)!=0){if((c[U>>2]&2|0)==0){break}qa=Iva(tc)|0;aa=Ca+24|0;if((wva(qa,c[aa>>2]|0)|0)!=0){break}qa=Gva(tc)|0;if((wva(qa,c[aa>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);if((c[ka>>2]&8|0)==0){break}aa=c[Ca+28>>2]|0;qa=c[aa>>2]|0;if((qa|0)==0){break}if((c[U>>2]&2|0)==0){eb=aa;sb=qa;while(1){if((wva(tc,sb)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}eb=eb+4|0;sb=c[eb>>2]|0;if((sb|0)==0){break l}}}else{Hc=aa}do{sb=Gva(tc)|0;if((wva(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}sb=Iva(tc)|0;if((wva(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}Hc=Hc+4|0;}while((c[Hc>>2]|0)!=0)}}while(0);if((ba|0)==0){uc=c[ea>>2]|0;vc=c[Ca+16>>2]|0;wc=Ya;break}ka=Ya+28|0;ta=c[ka>>2]|0;if((ta|0)==0){aa=hwa(S,0,0,0,32)|0;sb=aa;if((aa|0)==0){sa=169;break h}c[aa+24>>2]=Ya;c[aa+28>>2]=0;eb=hwa(S,0,0,0,c[l>>2]<<2)|0;c[aa+20>>2]=eb;if((eb|0)==0){sa=176;break h}c[ka>>2]=sb;Ic=sb}else{Ic=ta}c[Ic>>2]=s;c[Ic+4>>2]=Da;c[Ic+8>>2]=c[ea>>2];c[Ic+12>>2]=c[Ca+12>>2];c[Ic+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ta=c[Ic+20>>2]|0;sb=0;do{c[ta+(sb<<2)>>2]=c[Eb+(sb<<2)>>2];sb=sb+1|0;}while((sb|0)<(c[l>>2]|0))}sb=c[Ca+16>>2]|0;if((sb|0)==0){uc=ba;vc=Za;wc=Ic;break}ta=c[sb>>2]|0;if(!((ta|0)>-1)){uc=ba;vc=Za;wc=Ic;break}ka=c[Ic+20>>2]|0;eb=ta;ta=sb;while(1){c[ka+(eb<<2)>>2]=s;sb=ta+4|0;aa=c[sb>>2]|0;if((aa|0)>-1){ta=sb;eb=aa}else{uc=ba;vc=Za;wc=Ic;break}}}}while(0);eb=Ca+40|0;if((c[eb>>2]|0)==0){break}else{ea=eb;ba=uc;Za=vc;Ya=wc;Ca=Ca+32|0}}if((uc|0)==0){Nb=ec;Ob=vc;Pb=sc;Qb=wc;sa=196;continue j}do{if((vc|0)==0){Jc=0}else{Ca=c[vc>>2]|0;if((Ca|0)>-1){Kc=Ca;Lc=vc}else{Jc=vc;break}while(1){Ca=Lc+4|0;c[Eb+(Kc<<2)>>2]=s;Ya=c[Ca>>2]|0;if((Ya|0)>-1){Lc=Ca;Kc=Ya}else{Jc=Ca;break}}}}while(0);if((uc|0)==(c[G>>2]|0)){lc=Jc;mc=s;nc=sc;oc=wc;break}else{o=Jc;ca=s;ga=sc;ia=wc;ra=uc;da=Da}}}m:do{if((ec|0)<(mc|0)){sa=96}else{if((ec|0)!=(mc|0)|B){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}da=c[l>>2]|0;ra=c[x>>2]|0;if((da|0)>0){Mc=0}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}while(1){ia=c[Eb+(Mc<<2)>>2]|0;ga=c[n+(Mc<<2)>>2]|0;if((c[ra+(Mc<<2)>>2]|0)==0){if((ia|0)<(ga|0)){sa=96;break m}if((ia|0)>(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}else{if((ia|0)>(ga|0)){Nc=da;break m}if((ia|0)<(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}ga=Mc+1|0;if((ga|0)<(da|0)){Mc=ga}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}}while(0);if((sa|0)==96){sa=0;if(B){Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}Nc=c[l>>2]|0}if((Nc|0)>0){Oc=0}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}while(1){c[n+(Oc<<2)>>2]=c[Eb+(Oc<<2)>>2];da=Oc+1|0;if((da|0)<(c[l>>2]|0)){Oc=da}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}if((Nb|0)>=0){sa=205;break}if((c[j>>2]|0)==0){sa=205;break}c[j>>2]=D;q=c[l>>2]|0;F=Nb;w=Pb;E=v;L=Qb;M=y}if((sa|0)==60){gwa(S);if((Eb|0)!=0){Kwa(O)}if((Kb|0)!=0){Kwa(Kb)}if((Lb|0)==0){A=12;break a}Kwa(N);A=12;break a}else if((sa|0)==67){gwa(S);if((Eb|0)!=0){Kwa(O)}if((Kb|0)!=0){Kwa(Kb)}if((Lb|0)==0){A=12;break a}Kwa(N);A=12;break a}else if((sa|0)==169){gwa(S);if((Eb|0)!=0){Kwa(O)}if((Kb|0)!=0){Kwa(Kb)}if((Lb|0)==0){A=12;break a}Kwa(N);A=12;break a}else if((sa|0)==176){gwa(S);if((Eb|0)!=0){Kwa(O)}if((Kb|0)!=0){Kwa(Kb)}if((Lb|0)==0){A=12;break a}Kwa(N);A=12;break a}else if((sa|0)==205){Fb=Nb;Gb=Kb;Hb=Nb>>>31;Ib=Lb;Jb=Eb;break}}}while(0);gwa(S);if((Jb|0)!=0){Kwa(Jb)}if((Gb|0)!=0){Kwa(Gb)}if((Ib|0)==0){Cb=Fb;Db=Hb;sa=375;break}Kwa(Ib);Cb=Fb;Db=Hb;sa=375}}while(0);do{if((sa|0)==375){if((Db|0)!=0){A=Db;break}ewa(d,e,c[k+56>>2]|0,a,n,Cb);A=0}}while(0);if((n|0)==0){p=A;i=g;return p|0}Kwa(m);p=A;i=g;return p|0}function ewa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;do{if((g|0)>-1){if((d&8|0)!=0){j=0;break}k=c[e+16>>2]|0;l=e+28|0;m=c[l>>2]|0;n=(a|0)!=0;if((m|0)!=0&n){o=e+48|0;p=0;while(1){q=c[k+(p*12|0)>>2]|0;if((q|0)==(c[o>>2]|0)){c[b+(p<<3)>>2]=g;r=g}else{s=c[f+(q<<2)>>2]|0;c[b+(p<<3)>>2]=s;r=s}s=c[k+(p*12|0)+4>>2]|0;if((s|0)==(c[o>>2]|0)){c[b+(p<<3)+4>>2]=g;t=g}else{q=c[f+(s<<2)>>2]|0;c[b+(p<<3)+4>>2]=q;t=q}if((r|0)==-1|(t|0)==-1){c[b+(p<<3)+4>>2]=-1;c[b+(p<<3)>>2]=-1}q=p+1|0;s=c[l>>2]|0;if(q>>>0<s>>>0&q>>>0<a>>>0){p=q}else{u=s;break}}}else{u=m}if((u|0)!=0&n){v=u;w=0}else{j=0;break}while(1){p=b+(w<<3)+4|0;o=c[k+(w*12|0)+8>>2]|0;do{if((o|0)==0){x=v}else{s=c[o>>2]|0;if(!((s|0)>-1)){x=v;break}q=b+(w<<3)|0;y=c[q>>2]|0;z=s;s=0;while(1){if((y|0)<(c[b+(z<<3)>>2]|0)){A=21}else{if((c[p>>2]|0)>(c[b+(z<<3)+4>>2]|0)){A=21}else{B=y}}if((A|0)==21){A=0;c[p>>2]=-1;c[q>>2]=-1;B=-1}C=s+1|0;D=c[o+(C<<2)>>2]|0;if((D|0)>-1){y=B;z=D;s=C}else{break}}x=c[l>>2]|0}}while(0);o=w+1|0;if(o>>>0<x>>>0&o>>>0<a>>>0){v=x;w=o}else{j=o;break}}}else{j=0}}while(0);if(j>>>0<a>>>0){E=j}else{i=h;return}do{c[b+(E<<3)>>2]=-1;c[b+(E<<3)+4>>2]=-1;E=E+1|0;}while(E>>>0<a>>>0);i=h;return}function fwa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)==0){e=Lwa(1,24)|0}else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;e=b}if((e|0)==0){f=0;i=d;return f|0}f=e;i=d;return f|0}function gwa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;if((d|0)==0){e=a;Kwa(e);i=b;return}else{f=d}while(1){Kwa(c[f>>2]|0);d=c[f+4>>2]|0;Kwa(f);if((d|0)==0){break}else{f=d}}e=a;Kwa(e);i=b;return}function hwa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=a+16|0;if((c[h>>2]|0)!=0){j=0;i=g;return j|0}k=a+12|0;l=c[k>>2]|0;do{if(l>>>0<f>>>0){if((b|0)!=0){if((d|0)!=0){c[a+8>>2]=d;c[k>>2]=1024;m=d;n=1024;break}c[h>>2]=1;j=0;i=g;return j|0}o=f<<3;p=o>>>0>1024?o:1024;o=Jwa(8)|0;q=o;if((o|0)==0){c[h>>2]=1;j=0;i=g;return j|0}r=Jwa(p)|0;c[o>>2]=r;if((r|0)==0){Kwa(o);c[h>>2]=1;j=0;i=g;return j|0}c[o+4>>2]=0;r=a+4|0;s=c[r>>2]|0;if((s|0)!=0){c[s+4>>2]=q}s=a;if((c[s>>2]|0)==0){c[s>>2]=q}c[r>>2]=q;q=c[o>>2]|0;c[a+8>>2]=q;c[k>>2]=p;m=q;n=p}else{m=c[a+8>>2]|0;n=l}}while(0);l=m+f&3;h=((l|0)==0?0:4-l|0)+f|0;c[a+8>>2]=m+h;c[k>>2]=n-h;if((e|0)==0){j=m;i=g;return j|0}pxa(m|0,0,h|0)|0;j=m;i=g;return j|0}function iwa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==0){e=a+((jwa(a)|0)<<2)|0;i=d;return e|0}else{f=a}while(1){g=c[f>>2]|0;if((g|0)==0|(g|0)==(b|0)){break}else{f=f+4|0}}e=(g|0)!=0?f:0;i=d;return e|0}function jwa(a){a=a|0;var b=0,d=0;b=i;d=a;while(1){if((c[d>>2]|0)==0){break}else{d=d+4|0}}i=b;return d-a>>2|0}function kwa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=b;h=a}while(1){b=f+ -1|0;c[h>>2]=c[g>>2];if((b|0)==0){break}else{h=h+4|0;g=g+4|0;f=b}}i=e;return a|0}function lwa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(f){i=e;return a|0}else{g=d}do{g=g+ -1|0;c[a+(g<<2)>>2]=c[b+(g<<2)>>2];}while((g|0)!=0);i=e;return a|0}else{if(f){i=e;return a|0}else{h=b;j=a;k=d}while(1){d=k+ -1|0;c[j>>2]=c[h>>2];if((d|0)==0){break}else{k=d;j=j+4|0;h=h+4|0}}i=e;return a|0}return 0}function mwa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=a}while(1){d=f+ -1|0;c[g>>2]=b;if((d|0)==0){break}else{g=g+4|0;f=d}}i=e;return a|0}function nwa(a){a=a|0;i=i;return}function owa(a){a=a|0;c[a>>2]=160720;i=i;return}function pwa(a){a=a|0;var b=0;b=i;yb(a|0);Rwa(a);i=b;return}function qwa(a){a=a|0;var b=0;b=i;yb(a|0);i=b;return}function rwa(a){a=a|0;i=i;return 160736}function swa(a){a=a|0;i=i;return}function twa(a){a=a|0;i=i;return}function uwa(a){a=a|0;i=i;return}function vwa(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function wwa(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function xwa(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function ywa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+56|0;f=e;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=Cwa(b,160848,160904,0)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}j=f+0|0;k=j+56|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;Ae[c[(c[h>>2]|0)+28>>2]&63](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function zwa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((c[d+8>>2]|0)!=(b|0)){i=g;return}b=d+16|0;h=c[b>>2]|0;if((h|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function Awa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((b|0)!=(c[d+8>>2]|0)){h=c[b+8>>2]|0;Ae[c[(c[h>>2]|0)+28>>2]&63](h,d,e,f);i=g;return}h=d+16|0;b=c[h>>2]|0;if((b|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function Bwa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((b|0)==(c[d+8>>2]|0)){h=d+16|0;j=c[h>>2]|0;if((j|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((j|0)!=(e|0)){j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}j=d+24|0;if((c[j>>2]|0)!=2){i=g;return}c[j>>2]=f;i=g;return}j=c[b+12>>2]|0;h=b+16+(j<<3)|0;k=c[b+20>>2]|0;l=k>>8;if((k&1|0)==0){m=l}else{m=c[(c[e>>2]|0)+l>>2]|0}l=c[b+16>>2]|0;Ae[c[(c[l>>2]|0)+28>>2]&63](l,d,e+m|0,(k&2|0)!=0?f:2);if((j|0)<=1){i=g;return}j=d+54|0;k=b+24|0;while(1){b=c[k+4>>2]|0;m=b>>8;if((b&1|0)==0){n=m}else{n=c[(c[e>>2]|0)+m>>2]|0}m=c[k>>2]|0;Ae[c[(c[m>>2]|0)+28>>2]&63](m,d,e+n|0,(b&2|0)!=0?f:2);if((a[j]|0)!=0){o=16;break}b=k+8|0;if(b>>>0<h>>>0){k=b}else{o=16;break}}if((o|0)==16){i=g;return}}function Cwa(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+56|0;j=h;k=c[d>>2]|0;l=d+(c[k+ -8>>2]|0)|0;m=c[k+ -4>>2]|0;k=m;c[j>>2]=f;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=g;g=j+16|0;e=j+20|0;d=j+24|0;n=j+28|0;o=j+32|0;p=j+40|0;q=(m|0)==(f|0);f=g;r=f+0|0;s=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));b[f+36>>1]=0;a[f+38|0]=0;if(q){c[j+48>>2]=1;je[c[(c[m>>2]|0)+20>>2]&31](k,j,l,l,1,0);t=(c[d>>2]|0)==1?l:0;i=h;return t|0}Wd[c[(c[m>>2]|0)+24>>2]&31](k,j,l,1,0);l=c[j+36>>2]|0;if((l|0)==1){do{if((c[d>>2]|0)!=1){if((c[p>>2]|0)!=0){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}if((c[o>>2]|0)==1){break}else{t=0}i=h;return t|0}}while(0);t=c[g>>2]|0;i=h;return t|0}else if((l|0)==0){if((c[p>>2]|0)!=1){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}t=(c[o>>2]|0)==1?c[e>>2]|0:0;i=h;return t|0}else{t=0;i=h;return t|0}return 0}function Dwa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=c[b+12>>2]|0;m=b+16+(l<<3)|0;a:do{if((l|0)>0){n=d+52|0;o=d+53|0;p=d+54|0;q=b+8|0;r=d+24|0;s=0;t=0;u=b+16|0;b:while(1){a[n]=0;a[o]=0;v=c[u+4>>2]|0;w=v>>8;if((v&1|0)==0){x=w}else{x=c[(c[e>>2]|0)+w>>2]|0}w=c[u>>2]|0;je[c[(c[w>>2]|0)+20>>2]&31](w,d,e,e+x|0,2-(v>>>1&1)|0,g);if((a[p]|0)!=0){y=s;z=t;break}do{if((a[o]|0)==0){A=s;B=t}else{if((a[n]|0)==0){if((c[q>>2]&1|0)==0){y=s;z=1;break b}else{A=s;B=1;break}}if((c[r>>2]|0)==1){C=27;break a}if((c[q>>2]&2|0)==0){C=27;break a}else{A=1;B=1}}}while(0);v=u+8|0;if(v>>>0<m>>>0){s=A;t=B;u=v}else{y=A;z=B;break}}if(y){D=z;C=26}else{E=z;C=23}}else{E=0;C=23}}while(0);do{if((C|0)==23){c[j>>2]=e;m=d+40|0;c[m>>2]=(c[m>>2]|0)+1;if((c[d+36>>2]|0)!=1){D=E;C=26;break}if((c[d+24>>2]|0)!=2){D=E;C=26;break}a[d+54|0]=1;if(E){C=27}else{C=28}}}while(0);if((C|0)==26){if(D){C=27}else{C=28}}if((C|0)==27){c[k>>2]=3;i=h;return}else if((C|0)==28){c[k>>2]=4;i=h;return}}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}D=c[b+12>>2]|0;E=b+16+(D<<3)|0;z=c[b+20>>2]|0;y=z>>8;if((z&1|0)==0){F=y}else{F=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;Wd[c[(c[y>>2]|0)+24>>2]&31](y,d,e+F|0,(z&2|0)!=0?f:2,g);z=b+24|0;if((D|0)<=1){i=h;return}D=c[b+8>>2]|0;do{if((D&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((D&1|0)==0){F=d+54|0;y=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){C=53;break}B=c[y+4>>2]|0;A=B>>8;if((B&1|0)==0){G=A}else{G=c[(c[e>>2]|0)+A>>2]|0}A=c[y>>2]|0;Wd[c[(c[A>>2]|0)+24>>2]&31](A,d,e+G|0,(B&2|0)!=0?f:2,g);B=y+8|0;if(B>>>0<E>>>0){y=B}else{C=53;break}}if((C|0)==53){i=h;return}}y=d+24|0;F=d+54|0;k=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){if((c[y>>2]|0)==1){C=53;break}}B=c[k+4>>2]|0;A=B>>8;if((B&1|0)==0){H=A}else{H=c[(c[e>>2]|0)+A>>2]|0}A=c[k>>2]|0;Wd[c[(c[A>>2]|0)+24>>2]&31](A,d,e+H|0,(B&2|0)!=0?f:2,g);B=k+8|0;if(B>>>0<E>>>0){k=B}else{C=53;break}}if((C|0)==53){i=h;return}}}while(0);H=d+54|0;G=z;while(1){if((a[H]|0)!=0){C=53;break}z=c[G+4>>2]|0;D=z>>8;if((z&1|0)==0){I=D}else{I=c[(c[e>>2]|0)+D>>2]|0}D=c[G>>2]|0;Wd[c[(c[D>>2]|0)+24>>2]&31](D,d,e+I|0,(z&2|0)!=0?f:2,g);z=G+8|0;if(z>>>0<E>>>0){G=z}else{C=53;break}}if((C|0)==53){i=h;return}}function Ewa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;Wd[c[(c[j>>2]|0)+24>>2]&31](j,d,e,f,g);i=h;return}do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=d+52|0;a[l]=0;m=d+53|0;a[m]=0;n=c[b+8>>2]|0;je[c[(c[n>>2]|0)+20>>2]&31](n,d,e,e,1,g);if((a[m]|0)==0){o=0;p=13}else{if((a[l]|0)==0){o=1;p=13}}a:do{if((p|0)==13){c[j>>2]=e;l=d+40|0;c[l>>2]=(c[l>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){p=16;break}a[d+54|0]=1;if(o){break a}}else{p=16}}while(0);if((p|0)==16){if(o){break}}c[k>>2]=4;i=h;return}}while(0);c[k>>2]=3;i=h;return}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function Fwa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){i=g;return}h=d+28|0;if((c[h>>2]|0)==1){i=g;return}c[h>>2]=f;i=g;return}if((c[d>>2]|0)!=(b|0)){i=g;return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;i=g;return}}while(0);if((f|0)!=1){i=g;return}c[d+32>>2]=1;i=g;return}function Gwa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=d+52|0;l=a[k]|0;m=d+53|0;n=a[m]|0;o=c[b+12>>2]|0;p=b+16+(o<<3)|0;a[k]=0;a[m]=0;q=c[b+20>>2]|0;r=q>>8;if((q&1|0)==0){s=r}else{s=c[(c[f>>2]|0)+r>>2]|0}r=c[b+16>>2]|0;je[c[(c[r>>2]|0)+20>>2]&31](r,d,e,f+s|0,(q&2|0)!=0?g:2,h);a:do{if((o|0)>1){q=d+24|0;s=b+8|0;r=d+54|0;t=b+24|0;do{if((a[r]|0)!=0){break a}do{if((a[k]|0)==0){if((a[m]|0)==0){break}if((c[s>>2]&1|0)==0){break a}}else{if((c[q>>2]|0)==1){break a}if((c[s>>2]&2|0)==0){break a}}}while(0);a[k]=0;a[m]=0;u=c[t+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[f>>2]|0)+v>>2]|0}v=c[t>>2]|0;je[c[(c[v>>2]|0)+20>>2]&31](v,d,e,f+w|0,(u&2|0)!=0?g:2,h);t=t+8|0;}while(t>>>0<p>>>0)}}while(0);a[k]=l;a[m]=n;i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;n=c[f>>2]|0;if((n|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((n|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;n=c[e>>2]|0;if((n|0)==2){c[e>>2]=g;x=g}else{x=n}if(!((c[d+48>>2]|0)==1&(x|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function Hwa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=c[b+8>>2]|0;je[c[(c[k>>2]|0)+20>>2]&31](k,d,e,f,g,h);i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;l=g}else{l=h}if(!((c[d+48>>2]|0)==1&(l|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function Iwa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;if((c[d+8>>2]|0)!=(b|0)){i=h;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=h;return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=h;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;j=g}else{j=b}if(!((c[d+48>>2]|0)==1&(j|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}function Jwa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;b=i;do{if(a>>>0<245){if(a>>>0<11){d=16}else{d=a+11&-8}e=d>>>3;f=c[40288]|0;g=f>>>e;if((g&3|0)!=0){h=(g&1^1)+e|0;j=h<<1;k=161192+(j<<2)|0;l=161192+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do{if((k|0)==(n|0)){c[40288]=f&~(1<<h)}else{if(n>>>0<(c[161168>>2]|0)>>>0){dd()}o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else{dd()}}}while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}if(!(d>>>0>(c[161160>>2]|0)>>>0)){q=d;break}if((g|0)!=0){l=2<<e;n=g<<e&(l|0-l);l=(n&0-n)+ -1|0;n=l>>>12&16;k=l>>>n;l=k>>>5&8;o=k>>>l;k=o>>>2&4;r=o>>>k;o=r>>>1&2;s=r>>>o;r=s>>>1&1;t=(l|n|k|o|r)+(s>>>r)|0;r=t<<1;s=161192+(r<<2)|0;o=161192+(r+2<<2)|0;r=c[o>>2]|0;k=r+8|0;n=c[k>>2]|0;do{if((s|0)==(n|0)){c[40288]=f&~(1<<t)}else{if(n>>>0<(c[161168>>2]|0)>>>0){dd()}l=n+12|0;if((c[l>>2]|0)==(r|0)){c[l>>2]=s;c[o>>2]=n;break}else{dd()}}}while(0);n=t<<3;o=n-d|0;c[r+4>>2]=d|3;s=r+d|0;c[r+(d|4)>>2]=o|1;c[r+n>>2]=o;n=c[161160>>2]|0;if((n|0)!=0){f=c[161172>>2]|0;e=n>>>3;n=e<<1;g=161192+(n<<2)|0;m=c[40288]|0;j=1<<e;do{if((m&j|0)==0){c[40288]=m|j;u=161192+(n+2<<2)|0;v=g}else{e=161192+(n+2<<2)|0;h=c[e>>2]|0;if(!(h>>>0<(c[161168>>2]|0)>>>0)){u=e;v=h;break}dd()}}while(0);c[u>>2]=f;c[v+12>>2]=f;c[f+8>>2]=v;c[f+12>>2]=g}c[161160>>2]=o;c[161172>>2]=s;p=k;i=b;return p|0}n=c[161156>>2]|0;if((n|0)==0){q=d;break}j=(n&0-n)+ -1|0;n=j>>>12&16;m=j>>>n;j=m>>>5&8;r=m>>>j;m=r>>>2&4;t=r>>>m;r=t>>>1&2;h=t>>>r;t=h>>>1&1;e=c[161456+((j|n|m|r|t)+(h>>>t)<<2)>>2]|0;t=(c[e+4>>2]&-8)-d|0;h=e;r=e;while(1){e=c[h+16>>2]|0;if((e|0)==0){m=c[h+20>>2]|0;if((m|0)==0){break}else{w=m}}else{w=e}e=(c[w+4>>2]&-8)-d|0;m=e>>>0<t>>>0;t=m?e:t;h=w;r=m?w:r}h=r;k=c[161168>>2]|0;if(h>>>0<k>>>0){dd()}s=r+d|0;o=s;if(!(h>>>0<s>>>0)){dd()}s=c[r+24>>2]|0;h=c[r+12>>2]|0;do{if((h|0)==(r|0)){g=r+20|0;f=c[g>>2]|0;if((f|0)==0){m=r+16|0;e=c[m>>2]|0;if((e|0)==0){x=0;break}else{y=e;z=m}}else{y=f;z=g}while(1){g=y+20|0;f=c[g>>2]|0;if((f|0)!=0){z=g;y=f;continue}f=y+16|0;g=c[f>>2]|0;if((g|0)==0){break}else{y=g;z=f}}if(z>>>0<k>>>0){dd()}else{c[z>>2]=0;x=y;break}}else{f=c[r+8>>2]|0;if(f>>>0<k>>>0){dd()}g=f+12|0;if((c[g>>2]|0)!=(r|0)){dd()}m=h+8|0;if((c[m>>2]|0)==(r|0)){c[g>>2]=h;c[m>>2]=f;x=h;break}else{dd()}}}while(0);a:do{if((s|0)!=0){h=c[r+28>>2]|0;k=161456+(h<<2)|0;do{if((r|0)==(c[k>>2]|0)){c[k>>2]=x;if((x|0)!=0){break}c[161156>>2]=c[161156>>2]&~(1<<h);break a}else{if(s>>>0<(c[161168>>2]|0)>>>0){dd()}f=s+16|0;if((c[f>>2]|0)==(r|0)){c[f>>2]=x}else{c[s+20>>2]=x}if((x|0)==0){break a}}}while(0);if(x>>>0<(c[161168>>2]|0)>>>0){dd()}c[x+24>>2]=s;h=c[r+16>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[161168>>2]|0)>>>0){dd()}else{c[x+16>>2]=h;c[h+24>>2]=x;break}}}while(0);h=c[r+20>>2]|0;if((h|0)==0){break}if(h>>>0<(c[161168>>2]|0)>>>0){dd()}else{c[x+20>>2]=h;c[h+24>>2]=x;break}}}while(0);if(t>>>0<16){s=t+d|0;c[r+4>>2]=s|3;h=r+(s+4)|0;c[h>>2]=c[h>>2]|1}else{c[r+4>>2]=d|3;c[r+(d|4)>>2]=t|1;c[r+(t+d)>>2]=t;h=c[161160>>2]|0;if((h|0)!=0){s=c[161172>>2]|0;k=h>>>3;h=k<<1;f=161192+(h<<2)|0;m=c[40288]|0;g=1<<k;do{if((m&g|0)==0){c[40288]=m|g;A=161192+(h+2<<2)|0;B=f}else{k=161192+(h+2<<2)|0;e=c[k>>2]|0;if(!(e>>>0<(c[161168>>2]|0)>>>0)){A=k;B=e;break}dd()}}while(0);c[A>>2]=s;c[B+12>>2]=s;c[s+8>>2]=B;c[s+12>>2]=f}c[161160>>2]=t;c[161172>>2]=o}p=r+8|0;i=b;return p|0}else{if(a>>>0>4294967231){q=-1;break}h=a+11|0;g=h&-8;m=c[161156>>2]|0;if((m|0)==0){q=g;break}e=0-g|0;k=h>>>8;do{if((k|0)==0){C=0}else{if(g>>>0>16777215){C=31;break}h=(k+1048320|0)>>>16&8;n=k<<h;j=(n+520192|0)>>>16&4;l=n<<j;n=(l+245760|0)>>>16&2;D=14-(j|h|n)+(l<<n>>>15)|0;C=g>>>(D+7|0)&1|D<<1}}while(0);k=c[161456+(C<<2)>>2]|0;b:do{if((k|0)==0){E=e;F=0;G=0}else{if((C|0)==31){H=0}else{H=25-(C>>>1)|0}r=e;o=0;t=g<<H;f=k;s=0;while(1){D=c[f+4>>2]&-8;n=D-g|0;if(n>>>0<r>>>0){if((D|0)==(g|0)){E=n;F=f;G=f;break b}else{I=n;J=f}}else{I=r;J=s}n=c[f+20>>2]|0;D=c[f+16+(t>>>31<<2)>>2]|0;l=(n|0)==0|(n|0)==(D|0)?o:n;if((D|0)==0){E=I;F=l;G=J;break}else{r=I;o=l;t=t<<1;f=D;s=J}}}}while(0);if((F|0)==0&(G|0)==0){k=2<<C;e=m&(k|0-k);if((e|0)==0){q=g;break}k=(e&0-e)+ -1|0;e=k>>>12&16;s=k>>>e;k=s>>>5&8;f=s>>>k;s=f>>>2&4;t=f>>>s;f=t>>>1&2;o=t>>>f;t=o>>>1&1;K=c[161456+((k|e|s|f|t)+(o>>>t)<<2)>>2]|0}else{K=F}if((K|0)==0){L=E;M=G}else{t=E;o=K;f=G;while(1){s=(c[o+4>>2]&-8)-g|0;e=s>>>0<t>>>0;k=e?s:t;s=e?o:f;e=c[o+16>>2]|0;if((e|0)!=0){N=s;O=k;f=N;o=e;t=O;continue}e=c[o+20>>2]|0;if((e|0)==0){L=k;M=s;break}else{N=s;O=k;o=e;f=N;t=O}}}if((M|0)==0){q=g;break}if(!(L>>>0<((c[161160>>2]|0)-g|0)>>>0)){q=g;break}t=M;f=c[161168>>2]|0;if(t>>>0<f>>>0){dd()}o=M+g|0;m=o;if(!(t>>>0<o>>>0)){dd()}t=c[M+24>>2]|0;e=c[M+12>>2]|0;do{if((e|0)==(M|0)){k=M+20|0;s=c[k>>2]|0;if((s|0)==0){r=M+16|0;D=c[r>>2]|0;if((D|0)==0){P=0;break}else{Q=D;R=r}}else{Q=s;R=k}while(1){k=Q+20|0;s=c[k>>2]|0;if((s|0)!=0){R=k;Q=s;continue}s=Q+16|0;k=c[s>>2]|0;if((k|0)==0){break}else{Q=k;R=s}}if(R>>>0<f>>>0){dd()}else{c[R>>2]=0;P=Q;break}}else{s=c[M+8>>2]|0;if(s>>>0<f>>>0){dd()}k=s+12|0;if((c[k>>2]|0)!=(M|0)){dd()}r=e+8|0;if((c[r>>2]|0)==(M|0)){c[k>>2]=e;c[r>>2]=s;P=e;break}else{dd()}}}while(0);c:do{if((t|0)!=0){e=c[M+28>>2]|0;f=161456+(e<<2)|0;do{if((M|0)==(c[f>>2]|0)){c[f>>2]=P;if((P|0)!=0){break}c[161156>>2]=c[161156>>2]&~(1<<e);break c}else{if(t>>>0<(c[161168>>2]|0)>>>0){dd()}s=t+16|0;if((c[s>>2]|0)==(M|0)){c[s>>2]=P}else{c[t+20>>2]=P}if((P|0)==0){break c}}}while(0);if(P>>>0<(c[161168>>2]|0)>>>0){dd()}c[P+24>>2]=t;e=c[M+16>>2]|0;do{if((e|0)!=0){if(e>>>0<(c[161168>>2]|0)>>>0){dd()}else{c[P+16>>2]=e;c[e+24>>2]=P;break}}}while(0);e=c[M+20>>2]|0;if((e|0)==0){break}if(e>>>0<(c[161168>>2]|0)>>>0){dd()}else{c[P+20>>2]=e;c[e+24>>2]=P;break}}}while(0);d:do{if(L>>>0<16){t=L+g|0;c[M+4>>2]=t|3;e=M+(t+4)|0;c[e>>2]=c[e>>2]|1}else{c[M+4>>2]=g|3;c[M+(g|4)>>2]=L|1;c[M+(L+g)>>2]=L;e=L>>>3;if(L>>>0<256){t=e<<1;f=161192+(t<<2)|0;s=c[40288]|0;r=1<<e;do{if((s&r|0)==0){c[40288]=s|r;S=161192+(t+2<<2)|0;T=f}else{e=161192+(t+2<<2)|0;k=c[e>>2]|0;if(!(k>>>0<(c[161168>>2]|0)>>>0)){S=e;T=k;break}dd()}}while(0);c[S>>2]=m;c[T+12>>2]=m;c[M+(g+8)>>2]=T;c[M+(g+12)>>2]=f;break}t=o;r=L>>>8;do{if((r|0)==0){U=0}else{if(L>>>0>16777215){U=31;break}s=(r+1048320|0)>>>16&8;k=r<<s;e=(k+520192|0)>>>16&4;D=k<<e;k=(D+245760|0)>>>16&2;l=14-(e|s|k)+(D<<k>>>15)|0;U=L>>>(l+7|0)&1|l<<1}}while(0);r=161456+(U<<2)|0;c[M+(g+28)>>2]=U;c[M+(g+20)>>2]=0;c[M+(g+16)>>2]=0;f=c[161156>>2]|0;l=1<<U;if((f&l|0)==0){c[161156>>2]=f|l;c[r>>2]=t;c[M+(g+24)>>2]=r;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break}l=c[r>>2]|0;if((U|0)==31){V=0}else{V=25-(U>>>1)|0}e:do{if((c[l+4>>2]&-8|0)==(L|0)){W=l}else{r=L<<V;f=l;while(1){X=f+16+(r>>>31<<2)|0;k=c[X>>2]|0;if((k|0)==0){break}if((c[k+4>>2]&-8|0)==(L|0)){W=k;break e}else{r=r<<1;f=k}}if(X>>>0<(c[161168>>2]|0)>>>0){dd()}else{c[X>>2]=t;c[M+(g+24)>>2]=f;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break d}}}while(0);l=W+8|0;r=c[l>>2]|0;k=c[161168>>2]|0;if(W>>>0<k>>>0){dd()}if(r>>>0<k>>>0){dd()}else{c[r+12>>2]=t;c[l>>2]=t;c[M+(g+8)>>2]=r;c[M+(g+12)>>2]=W;c[M+(g+24)>>2]=0;break}}}while(0);p=M+8|0;i=b;return p|0}}while(0);M=c[161160>>2]|0;if(!(q>>>0>M>>>0)){W=M-q|0;X=c[161172>>2]|0;if(W>>>0>15){c[161172>>2]=X+q;c[161160>>2]=W;c[X+(q+4)>>2]=W|1;c[X+M>>2]=W;c[X+4>>2]=q|3}else{c[161160>>2]=0;c[161172>>2]=0;c[X+4>>2]=M|3;W=X+(M+4)|0;c[W>>2]=c[W>>2]|1}p=X+8|0;i=b;return p|0}X=c[161164>>2]|0;if(q>>>0<X>>>0){W=X-q|0;c[161164>>2]=W;X=c[161176>>2]|0;c[161176>>2]=X+q;c[X+(q+4)>>2]=W|1;c[X+4>>2]=q|3;p=X+8|0;i=b;return p|0}do{if((c[40406]|0)==0){X=bd(30)|0;if((X+ -1&X|0)==0){c[161632>>2]=X;c[161628>>2]=X;c[161636>>2]=-1;c[161640>>2]=-1;c[161644>>2]=0;c[161596>>2]=0;c[40406]=(rc(0)|0)&-16^1431655768;break}else{dd()}}}while(0);X=q+48|0;W=c[161632>>2]|0;M=q+47|0;L=W+M|0;V=0-W|0;W=L&V;if(!(W>>>0>q>>>0)){p=0;i=b;return p|0}U=c[161592>>2]|0;do{if((U|0)!=0){T=c[161584>>2]|0;S=T+W|0;if(S>>>0<=T>>>0|S>>>0>U>>>0){p=0}else{break}i=b;return p|0}}while(0);f:do{if((c[161596>>2]&4|0)==0){U=c[161176>>2]|0;g:do{if((U|0)==0){Y=182}else{S=U;T=161600|0;while(1){Z=T;P=c[Z>>2]|0;if(!(P>>>0>S>>>0)){_=T+4|0;if((P+(c[_>>2]|0)|0)>>>0>S>>>0){break}}P=c[T+8>>2]|0;if((P|0)==0){Y=182;break g}else{T=P}}if((T|0)==0){Y=182;break}S=L-(c[161164>>2]|0)&V;if(!(S>>>0<2147483647)){$=0;break}t=jb(S|0)|0;P=(t|0)==((c[Z>>2]|0)+(c[_>>2]|0)|0);aa=t;ba=S;ca=P?t:-1;da=P?S:0;Y=191}}while(0);do{if((Y|0)==182){U=jb(0)|0;if((U|0)==(-1|0)){$=0;break}S=U;P=c[161628>>2]|0;t=P+ -1|0;if((t&S|0)==0){ea=W}else{ea=W-S+(t+S&0-P)|0}P=c[161584>>2]|0;S=P+ea|0;if(!(ea>>>0>q>>>0&ea>>>0<2147483647)){$=0;break}t=c[161592>>2]|0;if((t|0)!=0){if(S>>>0<=P>>>0|S>>>0>t>>>0){$=0;break}}t=jb(ea|0)|0;S=(t|0)==(U|0);aa=t;ba=ea;ca=S?U:-1;da=S?ea:0;Y=191}}while(0);h:do{if((Y|0)==191){S=0-ba|0;if((ca|0)!=(-1|0)){fa=ca;ga=da;Y=202;break f}do{if((aa|0)!=(-1|0)&ba>>>0<2147483647&ba>>>0<X>>>0){U=c[161632>>2]|0;t=M-ba+U&0-U;if(!(t>>>0<2147483647)){ha=ba;break}if((jb(t|0)|0)==(-1|0)){jb(S|0)|0;$=da;break h}else{ha=t+ba|0;break}}else{ha=ba}}while(0);if((aa|0)==(-1|0)){$=da}else{fa=aa;ga=ha;Y=202;break f}}}while(0);c[161596>>2]=c[161596>>2]|4;ia=$;Y=199}else{ia=0;Y=199}}while(0);do{if((Y|0)==199){if(!(W>>>0<2147483647)){break}$=jb(W|0)|0;ha=jb(0)|0;if(!((ha|0)!=(-1|0)&($|0)!=(-1|0)&$>>>0<ha>>>0)){break}aa=ha-$|0;ha=aa>>>0>(q+40|0)>>>0;if(ha){fa=$;ga=ha?aa:ia;Y=202}}}while(0);do{if((Y|0)==202){ia=(c[161584>>2]|0)+ga|0;c[161584>>2]=ia;if(ia>>>0>(c[161588>>2]|0)>>>0){c[161588>>2]=ia}ia=c[161176>>2]|0;W=161600|0;i:do{if((ia|0)==0){aa=c[161168>>2]|0;if((aa|0)==0|fa>>>0<aa>>>0){c[161168>>2]=fa}c[161600>>2]=fa;c[161604>>2]=ga;c[161612>>2]=0;c[161188>>2]=c[40406];c[161184>>2]=-1;aa=0;do{ha=aa<<1;$=161192+(ha<<2)|0;c[161192+(ha+3<<2)>>2]=$;c[161192+(ha+2<<2)>>2]=$;aa=aa+1|0;}while(aa>>>0<32);aa=fa+8|0;if((aa&7|0)==0){ja=0}else{ja=0-aa&7}aa=ga+ -40-ja|0;c[161176>>2]=fa+ja;c[161164>>2]=aa;c[fa+(ja+4)>>2]=aa|1;c[fa+(ga+ -36)>>2]=40;c[161180>>2]=c[161640>>2]}else{aa=W;while(1){ka=c[aa>>2]|0;la=aa+4|0;ma=c[la>>2]|0;if((fa|0)==(ka+ma|0)){Y=214;break}$=c[aa+8>>2]|0;if(($|0)==0){break}else{aa=$}}do{if((Y|0)==214){if((c[aa+12>>2]&8|0)!=0){break}$=ia;if(!($>>>0>=ka>>>0&$>>>0<fa>>>0)){break}c[la>>2]=ma+ga;$=(c[161164>>2]|0)+ga|0;ha=ia+8|0;if((ha&7|0)==0){na=0}else{na=0-ha&7}ha=$-na|0;c[161176>>2]=ia+na;c[161164>>2]=ha;c[ia+(na+4)>>2]=ha|1;c[ia+($+4)>>2]=40;c[161180>>2]=c[161640>>2];break i}}while(0);if(fa>>>0<(c[161168>>2]|0)>>>0){c[161168>>2]=fa}aa=fa+ga|0;$=161600|0;while(1){oa=$;if((c[oa>>2]|0)==(aa|0)){Y=224;break}ha=c[$+8>>2]|0;if((ha|0)==0){break}else{$=ha}}do{if((Y|0)==224){if((c[$+12>>2]&8|0)!=0){break}c[oa>>2]=fa;aa=$+4|0;c[aa>>2]=(c[aa>>2]|0)+ga;aa=fa+8|0;if((aa&7|0)==0){pa=0}else{pa=0-aa&7}aa=fa+(ga+8)|0;if((aa&7|0)==0){qa=0}else{qa=0-aa&7}aa=fa+(qa+ga)|0;ha=aa;da=pa+q|0;ba=fa+da|0;M=ba;X=aa-(fa+pa)-q|0;c[fa+(pa+4)>>2]=q|3;j:do{if((ha|0)==(c[161176>>2]|0)){ca=(c[161164>>2]|0)+X|0;c[161164>>2]=ca;c[161176>>2]=M;c[fa+(da+4)>>2]=ca|1}else{if((ha|0)==(c[161172>>2]|0)){ca=(c[161160>>2]|0)+X|0;c[161160>>2]=ca;c[161172>>2]=M;c[fa+(da+4)>>2]=ca|1;c[fa+(ca+da)>>2]=ca;break}ca=ga+4|0;ea=c[fa+(ca+qa)>>2]|0;if((ea&3|0)==1){_=ea&-8;Z=ea>>>3;k:do{if(ea>>>0<256){V=c[fa+((qa|8)+ga)>>2]|0;L=c[fa+(ga+12+qa)>>2]|0;S=161192+(Z<<1<<2)|0;do{if((V|0)!=(S|0)){if(V>>>0<(c[161168>>2]|0)>>>0){dd()}if((c[V+12>>2]|0)==(ha|0)){break}dd()}}while(0);if((L|0)==(V|0)){c[40288]=c[40288]&~(1<<Z);break}do{if((L|0)==(S|0)){ra=L+8|0}else{if(L>>>0<(c[161168>>2]|0)>>>0){dd()}T=L+8|0;if((c[T>>2]|0)==(ha|0)){ra=T;break}dd()}}while(0);c[V+12>>2]=L;c[ra>>2]=V}else{S=aa;T=c[fa+((qa|24)+ga)>>2]|0;t=c[fa+(ga+12+qa)>>2]|0;do{if((t|0)==(S|0)){U=qa|16;P=fa+(ca+U)|0;Q=P;R=c[P>>2]|0;if((R|0)==0){P=fa+(U+ga)|0;U=c[P>>2]|0;if((U|0)==0){sa=0;break}else{ta=U;ua=P}}else{ta=R;ua=Q}while(1){Q=ta+20|0;R=c[Q>>2]|0;if((R|0)!=0){ua=Q;ta=R;continue}R=ta+16|0;Q=c[R>>2]|0;if((Q|0)==0){break}else{ta=Q;ua=R}}if(ua>>>0<(c[161168>>2]|0)>>>0){dd()}else{c[ua>>2]=0;sa=ta;break}}else{R=c[fa+((qa|8)+ga)>>2]|0;if(R>>>0<(c[161168>>2]|0)>>>0){dd()}Q=R+12|0;if((c[Q>>2]|0)!=(S|0)){dd()}P=t+8|0;if((c[P>>2]|0)==(S|0)){c[Q>>2]=t;c[P>>2]=R;sa=t;break}else{dd()}}}while(0);if((T|0)==0){break}t=c[fa+(ga+28+qa)>>2]|0;V=161456+(t<<2)|0;do{if((S|0)==(c[V>>2]|0)){c[V>>2]=sa;if((sa|0)!=0){break}c[161156>>2]=c[161156>>2]&~(1<<t);break k}else{if(T>>>0<(c[161168>>2]|0)>>>0){dd()}L=T+16|0;if((c[L>>2]|0)==(S|0)){c[L>>2]=sa}else{c[T+20>>2]=sa}if((sa|0)==0){break k}}}while(0);if(sa>>>0<(c[161168>>2]|0)>>>0){dd()}c[sa+24>>2]=T;S=qa|16;t=c[fa+(S+ga)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[161168>>2]|0)>>>0){dd()}else{c[sa+16>>2]=t;c[t+24>>2]=sa;break}}}while(0);t=c[fa+(ca+S)>>2]|0;if((t|0)==0){break}if(t>>>0<(c[161168>>2]|0)>>>0){dd()}else{c[sa+20>>2]=t;c[t+24>>2]=sa;break}}}while(0);va=fa+((_|qa)+ga)|0;wa=_+X|0}else{va=ha;wa=X}ca=va+4|0;c[ca>>2]=c[ca>>2]&-2;c[fa+(da+4)>>2]=wa|1;c[fa+(wa+da)>>2]=wa;ca=wa>>>3;if(wa>>>0<256){Z=ca<<1;ea=161192+(Z<<2)|0;t=c[40288]|0;T=1<<ca;do{if((t&T|0)==0){c[40288]=t|T;xa=161192+(Z+2<<2)|0;ya=ea}else{ca=161192+(Z+2<<2)|0;V=c[ca>>2]|0;if(!(V>>>0<(c[161168>>2]|0)>>>0)){xa=ca;ya=V;break}dd()}}while(0);c[xa>>2]=M;c[ya+12>>2]=M;c[fa+(da+8)>>2]=ya;c[fa+(da+12)>>2]=ea;break}Z=ba;T=wa>>>8;do{if((T|0)==0){za=0}else{if(wa>>>0>16777215){za=31;break}t=(T+1048320|0)>>>16&8;_=T<<t;V=(_+520192|0)>>>16&4;ca=_<<V;_=(ca+245760|0)>>>16&2;L=14-(V|t|_)+(ca<<_>>>15)|0;za=wa>>>(L+7|0)&1|L<<1}}while(0);T=161456+(za<<2)|0;c[fa+(da+28)>>2]=za;c[fa+(da+20)>>2]=0;c[fa+(da+16)>>2]=0;ea=c[161156>>2]|0;L=1<<za;if((ea&L|0)==0){c[161156>>2]=ea|L;c[T>>2]=Z;c[fa+(da+24)>>2]=T;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break}L=c[T>>2]|0;if((za|0)==31){Aa=0}else{Aa=25-(za>>>1)|0}l:do{if((c[L+4>>2]&-8|0)==(wa|0)){Ba=L}else{T=wa<<Aa;ea=L;while(1){Ca=ea+16+(T>>>31<<2)|0;_=c[Ca>>2]|0;if((_|0)==0){break}if((c[_+4>>2]&-8|0)==(wa|0)){Ba=_;break l}else{T=T<<1;ea=_}}if(Ca>>>0<(c[161168>>2]|0)>>>0){dd()}else{c[Ca>>2]=Z;c[fa+(da+24)>>2]=ea;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break j}}}while(0);L=Ba+8|0;T=c[L>>2]|0;S=c[161168>>2]|0;if(Ba>>>0<S>>>0){dd()}if(T>>>0<S>>>0){dd()}else{c[T+12>>2]=Z;c[L>>2]=Z;c[fa+(da+8)>>2]=T;c[fa+(da+12)>>2]=Ba;c[fa+(da+24)>>2]=0;break}}}while(0);p=fa+(pa|8)|0;i=b;return p|0}}while(0);$=ia;da=161600|0;while(1){Da=c[da>>2]|0;if(!(Da>>>0>$>>>0)){Ea=c[da+4>>2]|0;Fa=Da+Ea|0;if(Fa>>>0>$>>>0){break}}da=c[da+8>>2]|0}da=Da+(Ea+ -39)|0;if((da&7|0)==0){Ga=0}else{Ga=0-da&7}da=Da+(Ea+ -47+Ga)|0;ba=da>>>0<(ia+16|0)>>>0?$:da;da=ba+8|0;M=da;X=fa+8|0;if((X&7|0)==0){Ha=0}else{Ha=0-X&7}X=ga+ -40-Ha|0;c[161176>>2]=fa+Ha;c[161164>>2]=X;c[fa+(Ha+4)>>2]=X|1;c[fa+(ga+ -36)>>2]=40;c[161180>>2]=c[161640>>2];c[ba+4>>2]=27;X=161600|0;c[da+0>>2]=c[X+0>>2];c[da+4>>2]=c[X+4>>2];c[da+8>>2]=c[X+8>>2];c[da+12>>2]=c[X+12>>2];c[161600>>2]=fa;c[161604>>2]=ga;c[161612>>2]=0;c[161608>>2]=M;M=ba+28|0;c[M>>2]=7;if((ba+32|0)>>>0<Fa>>>0){X=M;while(1){M=X+4|0;c[M>>2]=7;if((X+8|0)>>>0<Fa>>>0){X=M}else{break}}}if((ba|0)==($|0)){break}X=ba-ia|0;M=ia+(X+4)|0;c[M>>2]=c[M>>2]&-2;c[ia+4>>2]=X|1;c[ia+X>>2]=X;M=X>>>3;if(X>>>0<256){da=M<<1;ha=161192+(da<<2)|0;aa=c[40288]|0;f=1<<M;do{if((aa&f|0)==0){c[40288]=aa|f;Ia=161192+(da+2<<2)|0;Ja=ha}else{M=161192+(da+2<<2)|0;T=c[M>>2]|0;if(!(T>>>0<(c[161168>>2]|0)>>>0)){Ia=M;Ja=T;break}dd()}}while(0);c[Ia>>2]=ia;c[Ja+12>>2]=ia;c[ia+8>>2]=Ja;c[ia+12>>2]=ha;break}da=ia;f=X>>>8;do{if((f|0)==0){Ka=0}else{if(X>>>0>16777215){Ka=31;break}aa=(f+1048320|0)>>>16&8;ba=f<<aa;$=(ba+520192|0)>>>16&4;T=ba<<$;ba=(T+245760|0)>>>16&2;M=14-($|aa|ba)+(T<<ba>>>15)|0;Ka=X>>>(M+7|0)&1|M<<1}}while(0);f=161456+(Ka<<2)|0;c[ia+28>>2]=Ka;c[ia+20>>2]=0;c[ia+16>>2]=0;ha=c[161156>>2]|0;M=1<<Ka;if((ha&M|0)==0){c[161156>>2]=ha|M;c[f>>2]=da;c[ia+24>>2]=f;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break}M=c[f>>2]|0;if((Ka|0)==31){La=0}else{La=25-(Ka>>>1)|0}m:do{if((c[M+4>>2]&-8|0)==(X|0)){Ma=M}else{f=X<<La;ha=M;while(1){Na=ha+16+(f>>>31<<2)|0;ba=c[Na>>2]|0;if((ba|0)==0){break}if((c[ba+4>>2]&-8|0)==(X|0)){Ma=ba;break m}else{f=f<<1;ha=ba}}if(Na>>>0<(c[161168>>2]|0)>>>0){dd()}else{c[Na>>2]=da;c[ia+24>>2]=ha;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break i}}}while(0);X=Ma+8|0;M=c[X>>2]|0;f=c[161168>>2]|0;if(Ma>>>0<f>>>0){dd()}if(M>>>0<f>>>0){dd()}else{c[M+12>>2]=da;c[X>>2]=da;c[ia+8>>2]=M;c[ia+12>>2]=Ma;c[ia+24>>2]=0;break}}}while(0);ia=c[161164>>2]|0;if(!(ia>>>0>q>>>0)){break}W=ia-q|0;c[161164>>2]=W;ia=c[161176>>2]|0;c[161176>>2]=ia+q;c[ia+(q+4)>>2]=W|1;c[ia+4>>2]=q|3;p=ia+8|0;i=b;return p|0}}while(0);c[(Mc()|0)>>2]=12;p=0;i=b;return p|0}



function sm(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+5520>>3]=+h[b>>3];h[a+5536>>3]=+h[b+8>>3];h[a+5504>>3]=+h[b+16>>3];h[a+5512>>3]=+h[b+24>>3];h[a+5528>>3]=+h[b+32>>3];h[a+5496>>3]=+h[b+40>>3];cm(f);dm(f);em(f);fm(f);gm(f);hm(f);im(f);jm(f);km(f);lm(f);mm(f);nm(f);om(f);pm(f);qm(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+5568>>3]- +h[f+11552>>3];h[d+8>>3]=+h[f+5560>>3]- +h[f+11544>>3];h[d+16>>3]=+h[f+5552>>3]- +h[f+11536>>3];h[d+24>>3]=+h[f+5544>>3]- +h[f+11528>>3];h[d+32>>3]=+h[f+5584>>3]- +h[f+11520>>3];h[d+40>>3]=+h[f+5576>>3]- +h[f+11512>>3];i=e;return}function tm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+504>>3]=+h[b+312>>3]*+h[(c[a+416>>2]|0)+1232>>3];i=i;return}function um(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2200>>3]=+h[b+2184>>3]*+h[b+9296>>3];i=i;return}function vm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1984>>3]=+h[b+9336>>3]- +h[b+2200>>3];i=i;return}function wm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1084>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2184>>3],-+h[j+2176>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2328>>3]=l;h[e+2320>>3]=m;i=b;return}function xm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1084>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2184>>3],-+h[j+2176>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2312>>3]=l;h[e+2304>>3]=m;i=b;return}function ym(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+512>>3]=+h[b+320>>3]*+h[(c[a+416>>2]|0)+1232>>3];i=i;return}function zm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2624>>3]=+h[b+3656>>3]*+h[b+9320>>3];i=i;return}function Am(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+844>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+3640>>3],+h[j+3632>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3904>>3]=l;h[e+3896>>3]=m;i=b;return}function Bm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+844>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+3640>>3],+h[j+3632>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3888>>3]=l;h[e+3880>>3]=m;i=b;return}function Cm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+712>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4080>>3],+h[j+4072>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4624>>3]=l;h[e+4616>>3]=m;i=b;return}function Dm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+712>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4080>>3],+h[j+4072>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4608>>3]=l;h[e+4600>>3]=m;i=b;return}function Em(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+712>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4080>>3],+h[j+4072>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4592>>3]=l;h[e+4584>>3]=m;i=b;return}function Fm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+700>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4112>>3],+h[j+4104>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4672>>3]=l;h[e+4664>>3]=m;i=b;return}function Gm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+688>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4144>>3],+h[j+4136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4720>>3]=l;h[e+4712>>3]=m;i=b;return}function Hm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4856>>3]=+h[b+4712>>3]+(+h[b+4616>>3]+ +h[b+4664>>3]);i=i;return}function Im(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5288>>3]=-+h[b+4856>>3]- +h[b+4808>>3];i=i;return}function Jm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+640>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4928>>3],+h[j+4920>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5152>>3]=l;h[e+5144>>3]=m;i=b;return}function Km(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+640>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4928>>3],+h[j+4920>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5136>>3]=l;h[e+5128>>3]=m;i=b;return}function Lm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+640>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4928>>3],+h[j+4920>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5120>>3]=l;h[e+5112>>3]=m;i=b;return}function Mm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+616>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4960>>3],+h[j+4952>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5248>>3]=l;h[e+5240>>3]=m;i=b;return}function Nm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+616>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4960>>3],+h[j+4952>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5232>>3]=l;h[e+5224>>3]=m;i=b;return}function Om(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+628>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4944>>3],+h[j+4936>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5200>>3]=l;h[e+5192>>3]=m;i=b;return}function Pm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5344>>3]=+h[b+5248>>3]+(+h[b+5152>>3]+ +h[b+5200>>3]);i=i;return}function Qm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2584>>3]=-+h[b+5728>>3]- +h[b+5344>>3]- +h[b+6208>>3];i=i;return}function Rm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1216>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1024>>3],+h[j+1016>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1296>>3]=l;h[e+1288>>3]=m;i=b;return}function Sm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1216>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1024>>3],+h[j+1016>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1280>>3]=l;h[e+1272>>3]=m;i=b;return}function Tm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1040>>3]=+h[b+1024>>3]*+h[b+9256>>3];i=i;return}function Um(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1204>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1064>>3],+h[j+1056>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1344>>3]=l;h[e+1336>>3]=m;i=b;return}function Vm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+544>>3]=+h[b+9328>>3]*+h[(c[a+416>>2]|0)+904>>3]*+h[b+536>>3];i=i;return}function Wm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1288>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+536>>3],+h[j+528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+808>>3]=l;h[e+800>>3]=m;i=b;return}function Xm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1288>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+536>>3],+h[j+528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+792>>3]=l;h[e+784>>3]=m;i=b;return}function Ym(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1288>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+536>>3],+h[j+528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+776>>3]=l;h[e+768>>3]=m;i=b;return}function Zm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1276>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+568>>3],+h[j+560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+856>>3]=l;h[e+848>>3]=m;i=b;return}function _m(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1576>>3]=+h[b+9328>>3]*+h[(c[a+416>>2]|0)+664>>3]*+h[b+1568>>3];i=i;return}function $m(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1132>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1600>>3],+h[j+1592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1888>>3]=l;h[e+1880>>3]=m;i=b;return}function an(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1132>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1600>>3],+h[j+1592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1872>>3]=l;h[e+1864>>3]=m;i=b;return}function bn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1132>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1600>>3],+h[j+1592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1856>>3]=l;h[e+1848>>3]=m;i=b;return}function cn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1168>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1600>>3],-+h[j+1592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1744>>3]=l;h[e+1736>>3]=m;i=b;return}function dn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1144>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1568>>3],+h[j+1560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1840>>3]=l;h[e+1832>>3]=m;i=b;return}function en(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1144>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1568>>3],+h[j+1560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1824>>3]=l;h[e+1816>>3]=m;i=b;return}function fn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1096>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2144>>3],-+h[j+2136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2296>>3]=l;h[e+2288>>3]=m;i=b;return}function gn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1108>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2104>>3],-+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2248>>3]=l;h[e+2240>>3]=m;i=b;return}function hn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1084>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2184>>3],-+h[j+2176>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2344>>3]=l;h[e+2336>>3]=m;i=b;return}function jn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2024>>3]=-+h[b+2288>>3]- +h[b+2240>>3]- +h[b+2336>>3];i=i;return}function kn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1928>>3]=+h[b+2024>>3]- +h[b+1832>>3]- +h[b+1880>>3];i=i;return}function ln(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1640>>3]=+h[b+9328>>3]*+h[(c[a+416>>2]|0)+648>>3]*+h[b+1632>>3];i=i;return}function mn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2032>>3]=-+h[b+2296>>3]- +h[b+2248>>3]- +h[b+2344>>3];i=i;return}function nn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1936>>3]=+h[b+2032>>3]- +h[b+1840>>3]- +h[b+1888>>3];i=i;return}function on(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2120>>3]=+h[b+2104>>3]*+h[b+9280>>3];i=i;return}function pn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1952>>3]=+h[b+9368>>3]- +h[b+2120>>3];i=i;return}function qn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1108>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2104>>3],-+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2232>>3]=l;h[e+2224>>3]=m;i=b;return}function rn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1096>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2144>>3],-+h[j+2136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2280>>3]=l;h[e+2272>>3]=m;i=b;return}function sn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2008>>3]=-+h[b+2272>>3]- +h[b+2224>>3]- +h[b+2320>>3];i=i;return}function tn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1912>>3]=+h[b+2008>>3]- +h[b+1816>>3]- +h[b+1864>>3];i=i;return}function un(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2152>>3]=+h[b+2136>>3]*+h[b+9288>>3];i=i;return}function vn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1960>>3]=+h[b+9360>>3]- +h[b+2152>>3];i=i;return}function wn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1096>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2144>>3],-+h[j+2136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2264>>3]=l;h[e+2256>>3]=m;i=b;return}function xn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2016>>3]=-+h[b+2280>>3]- +h[b+2232>>3]- +h[b+2328>>3];i=i;return}function yn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1920>>3]=+h[b+2016>>3]- +h[b+1824>>3]- +h[b+1872>>3];i=i;return}function zn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1108>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2104>>3],-+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2216>>3]=l;h[e+2208>>3]=m;i=b;return}function An(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2112>>3]=+h[b+2096>>3]*+h[b+9280>>3];i=i;return}function Bn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1944>>3]=+h[b+9376>>3]- +h[b+2112>>3];i=i;return}function Cn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+144>>3]=+h[b+1944>>3]- +h[b+1576>>3];i=i;return}function Dn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1992>>3]=-+h[b+2256>>3]- +h[b+2208>>3]- +h[b+2304>>3];i=i;return}function En(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1144>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1568>>3],+h[j+1560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1808>>3]=l;h[e+1800>>3]=m;i=b;return}function Fn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1896>>3]=+h[b+1992>>3]- +h[b+1800>>3]- +h[b+1848>>3];i=i;return}function Gn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1584>>3]=-(+h[b+9328>>3]*+h[(c[a+416>>2]|0)+664>>3]*+h[b+1560>>3]);i=i;return}function Hn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+152>>3]=+h[b+1952>>3]- +h[b+1584>>3];i=i;return}function In(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1180>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1568>>3],-+h[j+1560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1664>>3]=l;h[e+1656>>3]=m;i=b;return}function Jn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1180>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1568>>3],-+h[j+1560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1696>>3]=l;h[e+1688>>3]=m;i=b;return}function Kn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1264>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+600>>3],+h[j+592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+904>>3]=l;h[e+896>>3]=m;i=b;return}function Ln(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+376>>3]=-+h[b+856>>3]- +h[b+808>>3]- +h[b+904>>3];i=i;return}function Mn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1264>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+600>>3],+h[j+592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+888>>3]=l;h[e+880>>3]=m;i=b;return}function Nn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+608>>3]=+h[b+9328>>3]*+h[(c[a+416>>2]|0)+888>>3]*+h[b+600>>3];i=i;return}function On(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+368>>3]=-+h[b+848>>3]- +h[b+800>>3]- +h[b+896>>3];i=i;return}function Pn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+224>>3];k=b+416|0;l=c[k>>2]|0;m=+h[l+1232>>3];n=+h[g+272>>3];o=-n;do{if(m!=0.0){p=g;q=f;r=l;s=o/m}else{if(n==-0.0){p=g;q=f;r=l;s=o;break}t=o/+$1(c[b+536>>2]|0,m,1832,1824,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;p=c[u+8>>2]|0;q=u;r=c[k>>2]|0;s=t}}while(0);m=+h[r+1224>>3];o=+h[p+368>>3];if(m!=0.0){v=p;w=o/m;x=s-w;y=j+x;z=v;A=z+464|0;B=A;h[B>>3]=y;i=d;return}if(o==0.0){v=p;w=o;x=s-w;y=j+x;z=v;A=z+464|0;B=A;h[B>>3]=y;i=d;return}n=o/+$1(c[b+536>>2]|0,m,1856,1824,+h[q>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[e>>2]>>2]|0)+8>>2]|0;w=n;x=s-w;y=j+x;z=v;A=z+464|0;B=A;h[B>>3]=y;i=d;return}function Qn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1036>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2840>>3],-+h[j+2832>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2728>>3]=l;h[e+2720>>3]=m;i=b;return}function Rn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1036>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2840>>3],-+h[j+2832>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2712>>3]=l;h[e+2704>>3]=m;i=b;return}function Sn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1036>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2840>>3],-+h[j+2832>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2696>>3]=l;h[e+2688>>3]=m;i=b;return}function Tn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+952>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3288>>3],-+h[j+3280>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3208>>3]=l;h[e+3200>>3]=m;i=b;return}function Un(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+952>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3288>>3],-+h[j+3280>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3192>>3]=l;h[e+3184>>3]=m;i=b;return}function Vn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3296>>3]=-+h[b+3280>>3]- +h[b+3264>>3];i=i;return}function Wn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+940>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3304>>3],-+h[j+3296>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3256>>3]=l;h[e+3248>>3]=m;i=b;return}function Xn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+940>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3304>>3],-+h[j+3296>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3240>>3]=l;h[e+3232>>3]=m;i=b;return}function Yn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+940>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3304>>3],-+h[j+3296>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3224>>3]=l;h[e+3216>>3]=m;i=b;return}function Zn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+952>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3288>>3],-+h[j+3280>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3176>>3]=l;h[e+3168>>3]=m;i=b;return}function _n(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3272>>3]=-+h[b+3304>>3]- +h[b+3288>>3];i=i;return}function $n(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+964>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3272>>3],-+h[j+3264>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3160>>3]=l;h[e+3152>>3]=m;i=b;return}function ao(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3344>>3]=+h[b+3248>>3]+(+h[b+3152>>3]+ +h[b+3200>>3]);i=i;return}function bo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3352>>3]=+h[b+3256>>3]+(+h[b+3160>>3]+ +h[b+3208>>3]);i=i;return}function co(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+964>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3272>>3],-+h[j+3264>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3144>>3]=l;h[e+3136>>3]=m;i=b;return}function eo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3328>>3]=+h[b+3232>>3]+(+h[b+3136>>3]+ +h[b+3184>>3]);i=i;return}function fo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3336>>3]=+h[b+3240>>3]+(+h[b+3144>>3]+ +h[b+3192>>3]);i=i;return}function go(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+964>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3272>>3],-+h[j+3264>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3128>>3]=l;h[e+3120>>3]=m;i=b;return}function ho(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3312>>3]=+h[b+3216>>3]+(+h[b+3120>>3]+ +h[b+3168>>3]);i=i;return}function io(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3320>>3]=+h[b+3224>>3]+(+h[b+3128>>3]+ +h[b+3176>>3]);i=i;return}function jo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1e3>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2856>>3],+h[j+2848>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2920>>3]=l;h[e+2912>>3]=m;i=b;return}function ko(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1e3>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2856>>3],+h[j+2848>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2904>>3]=l;h[e+2896>>3]=m;i=b;return}function lo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1e3>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2856>>3],+h[j+2848>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2888>>3]=l;h[e+2880>>3]=m;i=b;return}function mo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1024>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2856>>3],-+h[j+2848>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2776>>3]=l;h[e+2768>>3]=m;i=b;return}function no(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1024>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2856>>3],-+h[j+2848>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2744>>3]=l;h[e+2736>>3]=m;i=b;return}function oo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+988>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2872>>3],+h[j+2864>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2968>>3]=l;h[e+2960>>3]=m;i=b;return}function po(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+988>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2872>>3],+h[j+2864>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2952>>3]=l;h[e+2944>>3]=m;i=b;return}function qo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+988>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2872>>3],+h[j+2864>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2936>>3]=l;h[e+2928>>3]=m;i=b;return}function ro(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1012>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2872>>3],-+h[j+2864>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2808>>3]=l;h[e+2800>>3]=m;i=b;return}function so(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1012>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2872>>3],-+h[j+2864>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2824>>3]=l;h[e+2816>>3]=m;i=b;return}function to(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1024>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2856>>3],-+h[j+2848>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2760>>3]=l;h[e+2752>>3]=m;i=b;return}function uo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3048>>3]=+h[b+2808>>3]+(+h[b+2712>>3]+ +h[b+2760>>3]);i=i;return}function vo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3040>>3]=+h[b+2800>>3]+(+h[b+2704>>3]+ +h[b+2752>>3]);i=i;return}function wo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3064>>3]=+h[b+2824>>3]+(+h[b+2728>>3]+ +h[b+2776>>3]);i=i;return}function xo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1012>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2872>>3],-+h[j+2864>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2792>>3]=l;h[e+2784>>3]=m;i=b;return}function yo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3032>>3]=+h[b+2792>>3]+(+h[b+2696>>3]+ +h[b+2744>>3]);i=i;return}function zo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3024>>3]=+h[b+2784>>3]+(+h[b+2688>>3]+ +h[b+2736>>3]);i=i;return}function Ao(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3056>>3]=+h[b+2816>>3]+(+h[b+2720>>3]+ +h[b+2768>>3]);i=i;return}function Bo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+232>>3];k=b+416|0;l=c[k>>2]|0;m=+h[l+1232>>3];n=+h[g+280>>3];o=-n;do{if(m!=0.0){p=g;q=f;r=l;s=o/m}else{if(n==-0.0){p=g;q=f;r=l;s=o;break}t=o/+$1(c[b+536>>2]|0,m,1832,1880,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;p=c[u+8>>2]|0;q=u;r=c[k>>2]|0;s=t}}while(0);m=+h[r+1224>>3];o=+h[p+376>>3];if(m!=0.0){v=p;w=o/m;x=s-w;y=j+x;z=v;A=z+472|0;B=A;h[B>>3]=y;i=d;return}if(o==0.0){v=p;w=o;x=s-w;y=j+x;z=v;A=z+472|0;B=A;h[B>>3]=y;i=d;return}n=o/+$1(c[b+536>>2]|0,m,1856,1880,+h[q>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[e>>2]>>2]|0)+8>>2]|0;w=n;x=s-w;y=j+x;z=v;A=z+472|0;B=A;h[B>>3]=y;i=d;return}function Co(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1792>>3]=-+h[b+1696>>3]- +h[b+472>>3]- +h[b+1744>>3];i=i;return}function Do(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1784>>3]=-+h[b+1688>>3]- +h[b+464>>3]- +h[b+1736>>3];i=i;return}function Eo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1168>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1600>>3],-+h[j+1592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1728>>3]=l;h[e+1720>>3]=m;i=b;return}function Fo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1168>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1600>>3],-+h[j+1592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1712>>3]=l;h[e+1704>>3]=m;i=b;return}function Go(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1616>>3]=-(+h[b+9328>>3]*+h[(c[a+416>>2]|0)+656>>3]*+h[b+1592>>3]);i=i;return}function Ho(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1608>>3]=+h[b+9328>>3]*+h[(c[a+416>>2]|0)+656>>3]*+h[b+1600>>3];i=i;return}function Io(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+160>>3]=+h[b+1960>>3]- +h[b+1608>>3];i=i;return}function Jo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1180>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1568>>3],-+h[j+1560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1680>>3]=l;h[e+1672>>3]=m;i=b;return}function Ko(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1648>>3]=-(+h[b+9328>>3]*+h[(c[a+416>>2]|0)+648>>3]*+h[b+1624>>3]);i=i;return}function Lo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+184>>3]=+h[b+1984>>3]- +h[b+1648>>3];i=i;return}function Mo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1276>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+568>>3],+h[j+560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+840>>3]=l;h[e+832>>3]=m;i=b;return}function No(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+360>>3]=-+h[b+840>>3]- +h[b+792>>3]- +h[b+888>>3];i=i;return}function Oo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+216>>3];k=b+416|0;l=c[k>>2]|0;m=+h[l+1232>>3];n=+h[g+264>>3];o=-n;do{if(m!=0.0){p=g;q=f;r=l;s=o/m}else{if(n==-0.0){p=g;q=f;r=l;s=o;break}t=o/+$1(c[b+536>>2]|0,m,1832,1888,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;p=c[u+8>>2]|0;q=u;r=c[k>>2]|0;s=t}}while(0);m=+h[r+1224>>3];o=+h[p+360>>3];if(m!=0.0){v=p;w=o/m;x=s-w;y=j+x;z=v;A=z+456|0;B=A;h[B>>3]=y;i=d;return}if(o==0.0){v=p;w=o;x=s-w;y=j+x;z=v;A=z+456|0;B=A;h[B>>3]=y;i=d;return}n=o/+$1(c[b+536>>2]|0,m,1856,1888,+h[q>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[e>>2]>>2]|0)+8>>2]|0;w=n;x=s-w;y=j+x;z=v;A=z+456|0;B=A;h[B>>3]=y;i=d;return}function Po(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1776>>3]=-+h[b+1680>>3]- +h[b+456>>3]- +h[b+1728>>3];i=i;return}function Qo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+352>>3]=-+h[b+832>>3]- +h[b+784>>3]- +h[b+880>>3];i=i;return}function Ro(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+208>>3];k=b+416|0;l=c[k>>2]|0;m=+h[l+1232>>3];n=+h[g+256>>3];o=-n;do{if(m!=0.0){p=g;q=f;r=l;s=o/m}else{if(n==-0.0){p=g;q=f;r=l;s=o;break}t=o/+$1(c[b+536>>2]|0,m,1832,1896,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;p=c[u+8>>2]|0;q=u;r=c[k>>2]|0;s=t}}while(0);m=+h[r+1224>>3];o=+h[p+352>>3];if(m!=0.0){v=p;w=o/m;x=s-w;y=j+x;z=v;A=z+448|0;B=A;h[B>>3]=y;i=d;return}if(o==0.0){v=p;w=o;x=s-w;y=j+x;z=v;A=z+448|0;B=A;h[B>>3]=y;i=d;return}n=o/+$1(c[b+536>>2]|0,m,1856,1896,+h[q>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[e>>2]>>2]|0)+8>>2]|0;w=n;x=s-w;y=j+x;z=v;A=z+448|0;B=A;h[B>>3]=y;i=d;return}function So(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1768>>3]=-+h[b+1672>>3]- +h[b+448>>3]- +h[b+1720>>3];i=i;return}function To(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+584>>3]=-(+h[b+9328>>3]*+h[(c[a+416>>2]|0)+896>>3]*+h[b+560>>3]);i=i;return}function Uo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+576>>3]=+h[b+9328>>3]*+h[(c[a+416>>2]|0)+896>>3]*+h[b+568>>3];i=i;return}function Vo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1312>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+568>>3],-+h[j+560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+712>>3]=l;h[e+704>>3]=m;i=b;return}function Wo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1312>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+568>>3],-+h[j+560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+696>>3]=l;h[e+688>>3]=m;i=b;return}function Xo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1312>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+568>>3],-+h[j+560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+680>>3]=l;h[e+672>>3]=m;i=b;return}function Yo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1276>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+568>>3],+h[j+560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+824>>3]=l;h[e+816>>3]=m;i=b;return}function Zo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1264>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+600>>3],+h[j+592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+872>>3]=l;h[e+864>>3]=m;i=b;return}function _o(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+336>>3]=-+h[b+816>>3]- +h[b+768>>3]- +h[b+864>>3];i=i;return}function $o(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+192>>3];k=b+416|0;l=c[k>>2]|0;m=+h[l+1232>>3];n=+h[g+240>>3];o=-n;do{if(m!=0.0){p=g;q=f;r=l;s=o/m}else{if(n==-0.0){p=g;q=f;r=l;s=o;break}t=o/+$1(c[b+536>>2]|0,m,1832,1904,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;p=c[u+8>>2]|0;q=u;r=c[k>>2]|0;s=t}}while(0);m=+h[r+1224>>3];o=+h[p+336>>3];if(m!=0.0){v=p;w=o/m;x=s-w;y=j+x;z=v;A=z+432|0;B=A;h[B>>3]=y;i=d;return}if(o==0.0){v=p;w=o;x=s-w;y=j+x;z=v;A=z+432|0;B=A;h[B>>3]=y;i=d;return}n=o/+$1(c[b+536>>2]|0,m,1856,1904,+h[q>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[e>>2]>>2]|0)+8>>2]|0;w=n;x=s-w;y=j+x;z=v;A=z+432|0;B=A;h[B>>3]=y;i=d;return}function ap(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1752>>3]=-+h[b+1656>>3]- +h[b+432>>3]- +h[b+1704>>3];i=i;return}function bp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+616>>3]=-(+h[b+9328>>3]*+h[(c[a+416>>2]|0)+888>>3]*+h[b+592>>3]);i=i;return}function cp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+344>>3]=-+h[b+824>>3]- +h[b+776>>3]- +h[b+872>>3];i=i;return}function dp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+200>>3];k=b+416|0;l=c[k>>2]|0;m=+h[l+1232>>3];n=+h[g+248>>3];o=-n;do{if(m!=0.0){p=g;q=f;r=l;s=o/m}else{if(n==-0.0){p=g;q=f;r=l;s=o;break}t=o/+$1(c[b+536>>2]|0,m,1832,1912,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;p=c[u+8>>2]|0;q=u;r=c[k>>2]|0;s=t}}while(0);m=+h[r+1224>>3];o=+h[p+344>>3];if(m!=0.0){v=p;w=o/m;x=s-w;y=j+x;z=v;A=z+440|0;B=A;h[B>>3]=y;i=d;return}if(o==0.0){v=p;w=o;x=s-w;y=j+x;z=v;A=z+440|0;B=A;h[B>>3]=y;i=d;return}n=o/+$1(c[b+536>>2]|0,m,1856,1912,+h[q>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[e>>2]>>2]|0)+8>>2]|0;w=n;x=s-w;y=j+x;z=v;A=z+440|0;B=A;h[B>>3]=y;i=d;return}function ep(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1760>>3]=-+h[b+1664>>3]- +h[b+440>>3]- +h[b+1712>>3];i=i;return}function fp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1324>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+536>>3],-+h[j+528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+664>>3]=l;h[e+656>>3]=m;i=b;return}function gp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1112>>3]=+h[b+1096>>3]*+h[b+9272>>3];i=i;return}function hp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1192>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1104>>3],+h[j+1096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1392>>3]=l;h[e+1384>>3]=m;i=b;return}function ip(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1488>>3]=+h[b+1392>>3]+(+h[b+1296>>3]+ +h[b+1344>>3]);i=i;return}function jp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1192>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1104>>3],+h[j+1096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1376>>3]=l;h[e+1368>>3]=m;i=b;return}function kp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1480>>3]=+h[b+1384>>3]+(+h[b+1288>>3]+ +h[b+1336>>3]);i=i;return}function lp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1324>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+536>>3],-+h[j+528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+648>>3]=l;h[e+640>>3]=m;i=b;return}function mp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+744>>3]=-+h[b+648>>3]- +h[b+1488>>3]- +h[b+696>>3];i=i;return}function np(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+736>>3]=-+h[b+640>>3]- +h[b+1480>>3]- +h[b+688>>3];i=i;return}function op(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+552>>3]=-(+h[b+9328>>3]*+h[(c[a+416>>2]|0)+904>>3]*+h[b+528>>3]);i=i;return}function pp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1324>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+536>>3],-+h[j+528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+632>>3]=l;h[e+624>>3]=m;i=b;return}function qp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1204>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1064>>3],+h[j+1056>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1328>>3]=l;h[e+1320>>3]=m;i=b;return}function rp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1472>>3]=+h[b+1376>>3]+(+h[b+1280>>3]+ +h[b+1328>>3]);i=i;return}function sp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+728>>3]=-+h[b+632>>3]- +h[b+1472>>3]- +h[b+680>>3];i=i;return}function tp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1240>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1064>>3],-+h[j+1056>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1216>>3]=l;h[e+1208>>3]=m;i=b;return}function up(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1080>>3]=+h[b+1064>>3]*+h[b+9264>>3];i=i;return}function vp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1240>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1064>>3],-+h[j+1056>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1200>>3]=l;h[e+1192>>3]=m;i=b;return}function wp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1072>>3]=+h[b+1056>>3]*+h[b+9264>>3];i=i;return}function xp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1240>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1064>>3],-+h[j+1056>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1184>>3]=l;h[e+1176>>3]=m;i=b;return}function yp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1204>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1064>>3],+h[j+1056>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1360>>3]=l;h[e+1352>>3]=m;i=b;return}function zp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1216>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1024>>3],+h[j+1016>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1312>>3]=l;h[e+1304>>3]=m;i=b;return}function Ap(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1464>>3]=+h[b+1368>>3]+(+h[b+1272>>3]+ +h[b+1320>>3]);i=i;return}function Bp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+720>>3]=-+h[b+624>>3]- +h[b+1464>>3]- +h[b+672>>3];i=i;return}function Cp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1228>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1104>>3],-+h[j+1096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1264>>3]=l;h[e+1256>>3]=m;i=b;return}function Dp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1228>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1104>>3],-+h[j+1096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1248>>3]=l;h[e+1240>>3]=m;i=b;return}function Ep(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1228>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1104>>3],-+h[j+1096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1232>>3]=l;h[e+1224>>3]=m;i=b;return}function Fp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1120>>3]=+h[b+1104>>3]*+h[b+9272>>3];i=i;return}function Gp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1192>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1104>>3],+h[j+1096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1408>>3]=l;h[e+1400>>3]=m;i=b;return}function Hp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1496>>3]=+h[b+1400>>3]+(+h[b+1304>>3]+ +h[b+1352>>3]);i=i;return}function Ip(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+752>>3]=-+h[b+656>>3]- +h[b+1496>>3]- +h[b+704>>3];i=i;return}function Jp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1504>>3]=+h[b+1408>>3]+(+h[b+1312>>3]+ +h[b+1360>>3]);i=i;return}function Kp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+760>>3]=-+h[b+664>>3]- +h[b+1504>>3]- +h[b+712>>3];i=i;return}function Lp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1252>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1024>>3],-+h[j+1016>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1152>>3]=l;h[e+1144>>3]=m;i=b;return}function Mp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1252>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1024>>3],-+h[j+1016>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1136>>3]=l;h[e+1128>>3]=m;i=b;return}function Np(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1416>>3]=+h[b+1224>>3]+(+h[b+1128>>3]+ +h[b+1176>>3]);i=i;return}function Op(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1424>>3]=+h[b+1232>>3]+(+h[b+1136>>3]+ +h[b+1184>>3]);i=i;return}function Pp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1032>>3]=+h[b+1016>>3]*+h[b+9256>>3];i=i;return}function Qp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1252>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1024>>3],-+h[j+1016>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1168>>3]=l;h[e+1160>>3]=m;i=b;return}function Rp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1448>>3]=+h[b+1256>>3]+(+h[b+1160>>3]+ +h[b+1208>>3]);i=i;return}function Sp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1456>>3]=+h[b+1264>>3]+(+h[b+1168>>3]+ +h[b+1216>>3]);i=i;return}function Tp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3112>>3]=+h[b+2584>>3]- +h[b+1456>>3];i=i;return}function Up(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3016>>3]=+h[b+3112>>3]- +h[b+2920>>3]- +h[b+2968>>3];i=i;return}function Vp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5336>>3]=+h[b+5240>>3]+(+h[b+5144>>3]+ +h[b+5192>>3]);i=i;return}function Wp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2576>>3]=-+h[b+5720>>3]- +h[b+5336>>3]- +h[b+6200>>3];i=i;return}function Xp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3104>>3]=+h[b+2576>>3]- +h[b+1448>>3];i=i;return}function Yp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3008>>3]=+h[b+3104>>3]- +h[b+2912>>3]- +h[b+2960>>3];i=i;return}function Zp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+628>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4944>>3],+h[j+4936>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5184>>3]=l;h[e+5176>>3]=m;i=b;return}function _p(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5328>>3]=+h[b+5232>>3]+(+h[b+5136>>3]+ +h[b+5184>>3]);i=i;return}function $p(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2568>>3]=-+h[b+5712>>3]- +h[b+5328>>3]- +h[b+6192>>3];i=i;return}function aq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1440>>3]=+h[b+1248>>3]+(+h[b+1152>>3]+ +h[b+1200>>3]);i=i;return}function bq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3096>>3]=+h[b+2568>>3]- +h[b+1440>>3];i=i;return}function cq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3e3>>3]=+h[b+3096>>3]- +h[b+2904>>3]- +h[b+2952>>3];i=i;return}function dq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1432>>3]=+h[b+1240>>3]+(+h[b+1144>>3]+ +h[b+1192>>3]);i=i;return}function eq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5320>>3]=+h[b+5224>>3]+(+h[b+5128>>3]+ +h[b+5176>>3]);i=i;return}function fq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2560>>3]=-+h[b+5704>>3]- +h[b+5320>>3]- +h[b+6184>>3];i=i;return}function gq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3088>>3]=+h[b+2560>>3]- +h[b+1432>>3];i=i;return}function hq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2992>>3]=+h[b+3088>>3]- +h[b+2896>>3]- +h[b+2944>>3];i=i;return}function iq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+616>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4960>>3],+h[j+4952>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5216>>3]=l;h[e+5208>>3]=m;i=b;return}function jq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+652>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4960>>3],-+h[j+4952>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5104>>3]=l;h[e+5096>>3]=m;i=b;return}function kq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+652>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4960>>3],-+h[j+4952>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5088>>3]=l;h[e+5080>>3]=m;i=b;return}function lq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+628>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4944>>3],+h[j+4936>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5168>>3]=l;h[e+5160>>3]=m;i=b;return}function mq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5312>>3]=+h[b+5216>>3]+(+h[b+5120>>3]+ +h[b+5168>>3]);i=i;return}function nq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2552>>3]=-+h[b+5696>>3]- +h[b+5312>>3]- +h[b+6176>>3];i=i;return}function oq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3080>>3]=+h[b+2552>>3]- +h[b+1424>>3];i=i;return}function pq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2984>>3]=+h[b+3080>>3]- +h[b+2888>>3]- +h[b+2936>>3];i=i;return}function qq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5304>>3]=+h[b+5208>>3]+(+h[b+5112>>3]+ +h[b+5160>>3]);i=i;return}function rq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2544>>3]=-+h[b+5688>>3]- +h[b+5304>>3]- +h[b+6168>>3];i=i;return}function sq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3072>>3]=+h[b+2544>>3]- +h[b+1416>>3];i=i;return}function tq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2976>>3]=+h[b+3072>>3]- +h[b+2880>>3]- +h[b+2928>>3];i=i;return}function uq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+676>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4928>>3],-+h[j+4920>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4992>>3]=l;h[e+4984>>3]=m;i=b;return}function vq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+676>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4928>>3],-+h[j+4920>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5008>>3]=l;h[e+5e3>>3]=m;i=b;return}function wq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4864>>3]=+h[b+4720>>3]+(+h[b+4624>>3]+ +h[b+4672>>3]);i=i;return}function xq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5296>>3]=-+h[b+4864>>3]- +h[b+4816>>3];i=i;return}function yq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5056>>3]=+h[b+5296>>3]- +h[b+5008>>3]- +h[b+5104>>3];i=i;return}function zq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+688>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4144>>3],+h[j+4136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4704>>3]=l;h[e+4696>>3]=m;i=b;return}function Aq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+700>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4112>>3],+h[j+4104>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4656>>3]=l;h[e+4648>>3]=m;i=b;return}function Bq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4848>>3]=+h[b+4704>>3]+(+h[b+4608>>3]+ +h[b+4656>>3]);i=i;return}function Cq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5280>>3]=-+h[b+4848>>3]- +h[b+4800>>3];i=i;return}function Dq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5040>>3]=+h[b+5280>>3]- +h[b+4992>>3]- +h[b+5088>>3];i=i;return}function Eq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+700>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4112>>3],+h[j+4104>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4640>>3]=l;h[e+4632>>3]=m;i=b;return}function Fq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+772>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4112>>3],-+h[j+4104>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4368>>3]=l;h[e+4360>>3]=m;i=b;return}function Gq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+772>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4112>>3],-+h[j+4104>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4384>>3]=l;h[e+4376>>3]=m;i=b;return}function Hq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4840>>3]=+h[b+4696>>3]+(+h[b+4600>>3]+ +h[b+4648>>3]);i=i;return}function Iq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5272>>3]=-+h[b+4840>>3]- +h[b+4792>>3];i=i;return}function Jq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5032>>3]=+h[b+5272>>3]- +h[b+4984>>3]- +h[b+5080>>3];i=i;return}function Kq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+652>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4960>>3],-+h[j+4952>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5072>>3]=l;h[e+5064>>3]=m;i=b;return}function Lq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5048>>3]=+h[b+5288>>3]- +h[b+5e3>>3]- +h[b+5096>>3];i=i;return}function Mq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+676>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4928>>3],-+h[j+4920>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4976>>3]=l;h[e+4968>>3]=m;i=b;return}function Nq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+688>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4144>>3],+h[j+4136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4688>>3]=l;h[e+4680>>3]=m;i=b;return}function Oq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4832>>3]=+h[b+4688>>3]+(+h[b+4592>>3]+ +h[b+4640>>3]);i=i;return}function Pq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5264>>3]=-+h[b+4832>>3]- +h[b+4784>>3];i=i;return}function Qq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5024>>3]=+h[b+5264>>3]- +h[b+4976>>3]- +h[b+5072>>3];i=i;return}function Rq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+760>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4144>>3],-+h[j+4136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4432>>3]=l;h[e+4424>>3]=m;i=b;return}function Sq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+760>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4144>>3],-+h[j+4136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4416>>3]=l;h[e+4408>>3]=m;i=b;return}function Tq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+760>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4144>>3],-+h[j+4136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4400>>3]=l;h[e+4392>>3]=m;i=b;return}function Uq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4824>>3]=+h[b+4680>>3]+(+h[b+4584>>3]+ +h[b+4632>>3]);i=i;return}function Vq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5256>>3]=-+h[b+4824>>3]- +h[b+4776>>3];i=i;return}function Wq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5016>>3]=+h[b+5256>>3]- +h[b+4968>>3]- +h[b+5064>>3];i=i;return}function Xq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+784>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4080>>3],-+h[j+4072>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4336>>3]=l;h[e+4328>>3]=m;i=b;return}function Yq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+856>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+3616>>3],+h[j+3608>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3824>>3]=l;h[e+3816>>3]=m;i=b;return}function Zq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2592>>3]=+h[b+3608>>3]*+h[b+9304>>3];i=i;return}function _q(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+64>>3]=+h[b+304>>3]+ +h[b+2592>>3];i=i;return}function $q(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+912>>3]=+h[b+1032>>3]+ +h[b+2592>>3];i=i;return}function ar(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+96>>3]=+h[b+544>>3]+ +h[b+912>>3];i=i;return}function br(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+48>>3]=+h[b+96>>3]- +h[b+384>>3];i=i;return}function cr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+856>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+3616>>3],+h[j+3608>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3840>>3]=l;h[e+3832>>3]=m;i=b;return}function dr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+784>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4080>>3],-+h[j+4072>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4320>>3]=l;h[e+4312>>3]=m;i=b;return}function er(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4024>>3]=-+h[b+4360>>3]- +h[b+4312>>3]- +h[b+4408>>3];i=i;return}function fr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3928>>3]=+h[b+4024>>3]- +h[b+3832>>3]- +h[b+3880>>3];i=i;return}function gr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+784>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4080>>3],-+h[j+4072>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4304>>3]=l;h[e+4296>>3]=m;i=b;return}function hr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4032>>3]=-+h[b+4368>>3]- +h[b+4320>>3]- +h[b+4416>>3];i=i;return}function ir(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3936>>3]=+h[b+4032>>3]- +h[b+3840>>3]- +h[b+3888>>3];i=i;return}function jr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2632>>3]=+h[b+3664>>3]*+h[b+9320>>3];i=i;return}function kr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+952>>3]=+h[b+1120>>3]+ +h[b+2632>>3];i=i;return}function lr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+136>>3]=+h[b+616>>3]+ +h[b+952>>3];i=i;return}function mr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2600>>3]=+h[b+3616>>3]*+h[b+9304>>3];i=i;return}function nr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+72>>3]=+h[b+312>>3]+ +h[b+2600>>3];i=i;return}function or(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+920>>3]=+h[b+1040>>3]+ +h[b+2600>>3];i=i;return}function pr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+104>>3]=+h[b+552>>3]+ +h[b+920>>3];i=i;return}function qr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+56>>3]=+h[b+104>>3]- +h[b+392>>3];i=i;return}function rr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+296>>3]=+h[b+56>>3]- +h[b+2632>>3];i=i;return}function sr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+856>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+3616>>3],+h[j+3608>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3856>>3]=l;h[e+3848>>3]=m;i=b;return}function tr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4048>>3]=-+h[b+4384>>3]- +h[b+4336>>3]- +h[b+4432>>3];i=i;return}function ur(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3952>>3]=+h[b+4048>>3]- +h[b+3856>>3]- +h[b+3904>>3];i=i;return}function vr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4040>>3]=-+h[b+4376>>3]- +h[b+4328>>3]- +h[b+4424>>3];i=i;return}function wr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3944>>3]=+h[b+4040>>3]- +h[b+3848>>3]- +h[b+3896>>3];i=i;return}function xr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+772>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4112>>3],-+h[j+4104>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4352>>3]=l;h[e+4344>>3]=m;i=b;return}function yr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4016>>3]=-+h[b+4352>>3]- +h[b+4304>>3]- +h[b+4400>>3];i=i;return}function zr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4008>>3]=-+h[b+4344>>3]- +h[b+4296>>3]- +h[b+4392>>3];i=i;return}function Ar(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+844>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+3640>>3],+h[j+3632>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3872>>3]=l;h[e+3864>>3]=m;i=b;return}function Br(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3920>>3]=+h[b+4016>>3]- +h[b+3824>>3]- +h[b+3872>>3];i=i;return}function Cr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3912>>3]=+h[b+4008>>3]- +h[b+3816>>3]- +h[b+3864>>3];i=i;return}function Dr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2608>>3]=+h[b+3632>>3]*+h[b+9312>>3];i=i;return}function Er(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+80>>3]=+h[b+320>>3]+ +h[b+2608>>3];i=i;return}function Fr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+928>>3]=+h[b+1072>>3]+ +h[b+2608>>3];i=i;return}function Gr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+112>>3]=+h[b+576>>3]+ +h[b+928>>3];i=i;return}function Hr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+400>>3]=+h[b+112>>3]- +h[b+64>>3];i=i;return}function Ir(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+288>>3]=+h[b+48>>3]- +h[b+2624>>3];i=i;return}function Jr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+944>>3]=+h[b+1112>>3]+ +h[b+2624>>3];i=i;return}



function Ru(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+6408>>3]=+h[b>>3];h[a+6448>>3]=+h[b+8>>3];h[a+6432>>3]=+h[b+16>>3];h[a+6424>>3]=+h[b+24>>3];h[a+6416>>3]=+h[b+32>>3];h[a+6440>>3]=+h[b+40>>3];Bu(f);Cu(f);Du(f);Eu(f);Fu(f);Gu(f);Hu(f);Iu(f);Ju(f);Ku(f);Lu(f);Mu(f);Nu(f);Ou(f);Pu(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+6592>>3]- +h[f+10752>>3];h[d+8>>3]=+h[f+6584>>3]- +h[f+10744>>3];h[d+16>>3]=+h[f+6560>>3]- +h[f+10736>>3];h[d+24>>3]=+h[f+6552>>3]- +h[f+10728>>3];h[d+32>>3]=+h[f+6576>>3]- +h[f+10720>>3];h[d+40>>3]=+h[f+6568>>3]- +h[f+10712>>3];i=e;return}function Su(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+556>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+5536>>3],+h[j+5528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5600>>3]=l;h[e+5592>>3]=m;i=b;return}function Tu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+556>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+5536>>3],+h[j+5528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5616>>3]=l;h[e+5608>>3]=m;i=b;return}function Uu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+568>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+5520>>3],+h[j+5512>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5568>>3]=l;h[e+5560>>3]=m;i=b;return}function Vu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5664>>3]=+h[b+5760>>3]- +h[b+5568>>3]- +h[b+5616>>3];i=i;return}function Wu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5656>>3]=+h[b+5752>>3]- +h[b+5560>>3]- +h[b+5608>>3];i=i;return}function Xu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+568>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+5520>>3],+h[j+5512>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5552>>3]=l;h[e+5544>>3]=m;i=b;return}function Yu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5648>>3]=+h[b+5744>>3]- +h[b+5552>>3]- +h[b+5600>>3];i=i;return}function Zu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+568>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+5520>>3],+h[j+5512>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5584>>3]=l;h[e+5576>>3]=m;i=b;return}function _u(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+556>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+5536>>3],+h[j+5528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5632>>3]=l;h[e+5624>>3]=m;i=b;return}function $u(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5680>>3]=+h[b+5776>>3]- +h[b+5584>>3]- +h[b+5632>>3];i=i;return}function av(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5672>>3]=+h[b+5768>>3]- +h[b+5576>>3]- +h[b+5624>>3];i=i;return}function bv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5640>>3]=+h[b+5736>>3]- +h[b+5544>>3]- +h[b+5592>>3];i=i;return}function cv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+544>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+5504>>3],+h[j+5496>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10704>>3]=l;h[e+10696>>3]=m;i=b;return}function dv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+544>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+5504>>3],+h[j+5496>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10688>>3]=l;h[e+10680>>3]=m;i=b;return}function ev(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+544>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+5504>>3],+h[j+5496>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10672>>3]=l;h[e+10664>>3]=m;i=b;return}function fv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+77136>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+77112>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+77120>>3];h[a+8>>3]=+h[d+77472>>3];h[e+8>>3]=+h[d+77448>>3];h[f+8>>3]=+h[d+77456>>3];h[a+16>>3]=+h[d+77360>>3];h[e+16>>3]=+h[d+77336>>3];h[f+16>>3]=+h[d+77344>>3];h[a+24>>3]=+h[d+77024>>3];h[e+24>>3]=+h[d+77e3>>3];h[f+24>>3]=+h[d+77008>>3];h[a+32>>3]=+h[d+77248>>3];h[e+32>>3]=+h[d+77224>>3];h[f+32>>3]=+h[d+77232>>3];h[a+40>>3]=+h[d+77584>>3];h[e+40>>3]=+h[d+77560>>3];h[f+40>>3]=+h[d+77568>>3];i=i;return}function gv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+5504>>3]=+h[b>>3];h[a+5528>>3]=+h[b+8>>3];h[a+5520>>3]=+h[b+16>>3];h[a+5496>>3]=+h[b+24>>3];h[a+5512>>3]=+h[b+32>>3];h[a+5536>>3]=+h[b+40>>3];Su(f);Tu(f);Uu(f);Vu(f);Wu(f);Xu(f);Yu(f);Zu(f);_u(f);$u(f);av(f);bv(f);cv(f);dv(f);ev(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+5648>>3]- +h[f+10704>>3];h[d+8>>3]=+h[f+5640>>3]- +h[f+10696>>3];h[d+16>>3]=+h[f+5664>>3]- +h[f+10688>>3];h[d+24>>3]=+h[f+5656>>3]- +h[f+10680>>3];h[d+32>>3]=+h[f+5680>>3]- +h[f+10672>>3];h[d+40>>3]=+h[f+5672>>3]- +h[f+10664>>3];i=e;return}function hv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1072>>3]=+h[b+1056>>3]*+h[b+9264>>3];i=i;return}function iv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1080>>3]=+h[b+1064>>3]*+h[b+9264>>3];i=i;return}function jv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+576>>3]=+h[b+9328>>3]*+h[(c[a+416>>2]|0)+896>>3]*+h[b+568>>3];i=i;return}function kv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+584>>3]=-(+h[b+9328>>3]*+h[(c[a+416>>2]|0)+896>>3]*+h[b+560>>3]);i=i;return}function lv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1312>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+568>>3],-+h[j+560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+680>>3]=l;h[e+672>>3]=m;i=b;return}function mv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1312>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+568>>3],-+h[j+560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+712>>3]=l;h[e+704>>3]=m;i=b;return}function nv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1276>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+568>>3],+h[j+560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+824>>3]=l;h[e+816>>3]=m;i=b;return}function ov(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1276>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+568>>3],+h[j+560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+840>>3]=l;h[e+832>>3]=m;i=b;return}function pv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+544>>3]=+h[b+9328>>3]*+h[(c[a+416>>2]|0)+904>>3]*+h[b+536>>3];i=i;return}function qv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1036>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2840>>3],-+h[j+2832>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2696>>3]=l;h[e+2688>>3]=m;i=b;return}function rv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1036>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2840>>3],-+h[j+2832>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2712>>3]=l;h[e+2704>>3]=m;i=b;return}function sv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1036>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2840>>3],-+h[j+2832>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2728>>3]=l;h[e+2720>>3]=m;i=b;return}function tv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+976>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2840>>3],+h[j+2832>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2984>>3]=l;h[e+2976>>3]=m;i=b;return}function uv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1040>>3]=+h[b+1024>>3]*+h[b+9256>>3];i=i;return}function vv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+552>>3]=-(+h[b+9328>>3]*+h[(c[a+416>>2]|0)+904>>3]*+h[b+528>>3]);i=i;return}function wv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1324>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+536>>3],-+h[j+528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+632>>3]=l;h[e+624>>3]=m;i=b;return}function xv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1324>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+536>>3],-+h[j+528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+648>>3]=l;h[e+640>>3]=m;i=b;return}function yv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1324>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+536>>3],-+h[j+528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+664>>3]=l;h[e+656>>3]=m;i=b;return}function zv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+608>>3]=+h[b+9328>>3]*+h[(c[a+416>>2]|0)+888>>3]*+h[b+600>>3];i=i;return}function Av(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1300>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+600>>3],-+h[j+592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+728>>3]=l;h[e+720>>3]=m;i=b;return}function Bv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1472>>3]=-+h[b+680>>3]- +h[b+632>>3]- +h[b+728>>3];i=i;return}function Cv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1464>>3]=-+h[b+672>>3]- +h[b+624>>3]- +h[b+720>>3];i=i;return}function Dv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+616>>3]=-(+h[b+9328>>3]*+h[(c[a+416>>2]|0)+888>>3]*+h[b+592>>3]);i=i;return}function Ev(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1300>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+600>>3],-+h[j+592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+744>>3]=l;h[e+736>>3]=m;i=b;return}function Fv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1120>>3]=+h[b+1104>>3]*+h[b+9272>>3];i=i;return}function Gv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1228>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1104>>3],-+h[j+1096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1232>>3]=l;h[e+1224>>3]=m;i=b;return}function Hv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1228>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1104>>3],-+h[j+1096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1248>>3]=l;h[e+1240>>3]=m;i=b;return}function Iv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1228>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1104>>3],-+h[j+1096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1264>>3]=l;h[e+1256>>3]=m;i=b;return}function Jv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1032>>3]=+h[b+1016>>3]*+h[b+9256>>3];i=i;return}function Kv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1252>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1024>>3],-+h[j+1016>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1136>>3]=l;h[e+1128>>3]=m;i=b;return}function Lv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1252>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1024>>3],-+h[j+1016>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1152>>3]=l;h[e+1144>>3]=m;i=b;return}function Mv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1252>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1024>>3],-+h[j+1016>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1168>>3]=l;h[e+1160>>3]=m;i=b;return}function Nv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1216>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1024>>3],+h[j+1016>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1312>>3]=l;h[e+1304>>3]=m;i=b;return}function Ov(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1216>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1024>>3],+h[j+1016>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1280>>3]=l;h[e+1272>>3]=m;i=b;return}function Pv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1192>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1104>>3],+h[j+1096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1376>>3]=l;h[e+1368>>3]=m;i=b;return}function Qv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1328>>3]=+h[b+1472>>3]- +h[b+1280>>3]- +h[b+1376>>3];i=i;return}function Rv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1320>>3]=+h[b+1464>>3]- +h[b+1272>>3]- +h[b+1368>>3];i=i;return}function Sv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1192>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1104>>3],+h[j+1096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1392>>3]=l;h[e+1384>>3]=m;i=b;return}function Tv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2632>>3]=+h[b+3664>>3]*+h[b+9320>>3];i=i;return}function Uv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+952>>3]=+h[b+1120>>3]+ +h[b+2632>>3];i=i;return}function Vv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+136>>3]=+h[b+616>>3]+ +h[b+952>>3];i=i;return}function Wv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2608>>3]=+h[b+3632>>3]*+h[b+9312>>3];i=i;return}function Xv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+928>>3]=+h[b+1072>>3]+ +h[b+2608>>3];i=i;return}function Yv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+112>>3]=+h[b+576>>3]+ +h[b+928>>3];i=i;return}function Zv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+784>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4080>>3],-+h[j+4072>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4304>>3]=l;h[e+4296>>3]=m;i=b;return}function _v(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+784>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4080>>3],-+h[j+4072>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4320>>3]=l;h[e+4312>>3]=m;i=b;return}function $v(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+64>>3]=+h[b+112>>3]- +h[b+400>>3];i=i;return}function aw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+496>>3]=+h[b+400>>3]*+h[(c[a+416>>2]|0)+1224>>3];i=i;return}function bw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1576>>3]=+h[b+9328>>3]*+h[(c[a+416>>2]|0)+664>>3]*+h[b+1568>>3];i=i;return}function cw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1024>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2856>>3],-+h[j+2848>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2760>>3]=l;h[e+2752>>3]=m;i=b;return}function dw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1024>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2856>>3],-+h[j+2848>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2744>>3]=l;h[e+2736>>3]=m;i=b;return}function ew(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1024>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2856>>3],-+h[j+2848>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2776>>3]=l;h[e+2768>>3]=m;i=b;return}function fw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1e3>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2856>>3],+h[j+2848>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2888>>3]=l;h[e+2880>>3]=m;i=b;return}function gw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1012>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2872>>3],-+h[j+2864>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2792>>3]=l;h[e+2784>>3]=m;i=b;return}function hw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3024>>3]=+h[b+2784>>3]+(+h[b+2688>>3]+ +h[b+2736>>3]);i=i;return}function iw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1012>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2872>>3],-+h[j+2864>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2824>>3]=l;h[e+2816>>3]=m;i=b;return}function jw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3064>>3]=+h[b+2824>>3]+(+h[b+2728>>3]+ +h[b+2776>>3]);i=i;return}function kw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1012>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2872>>3],-+h[j+2864>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2808>>3]=l;h[e+2800>>3]=m;i=b;return}function lw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3048>>3]=+h[b+2808>>3]+(+h[b+2712>>3]+ +h[b+2760>>3]);i=i;return}function mw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+988>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2872>>3],+h[j+2864>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2936>>3]=l;h[e+2928>>3]=m;i=b;return}function nw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3080>>3]=+h[b+2984>>3]+(+h[b+2888>>3]+ +h[b+2936>>3]);i=i;return}function ow(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3072>>3]=+h[b+2976>>3]+(+h[b+2880>>3]+ +h[b+2928>>3]);i=i;return}function pw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+988>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2872>>3],+h[j+2864>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2952>>3]=l;h[e+2944>>3]=m;i=b;return}function qw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+988>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2872>>3],+h[j+2864>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2968>>3]=l;h[e+2960>>3]=m;i=b;return}function rw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3056>>3]=+h[b+2816>>3]+(+h[b+2720>>3]+ +h[b+2768>>3]);i=i;return}function sw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3280>>3]=-+h[b+3296>>3]- +h[b+3264>>3];i=i;return}function tw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1640>>3]=+h[b+9328>>3]*+h[(c[a+416>>2]|0)+648>>3]*+h[b+1632>>3];i=i;return}function uw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1648>>3]=-(+h[b+9328>>3]*+h[(c[a+416>>2]|0)+648>>3]*+h[b+1624>>3]);i=i;return}function vw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1608>>3]=+h[b+9328>>3]*+h[(c[a+416>>2]|0)+656>>3]*+h[b+1600>>3];i=i;return}function ww(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1616>>3]=-(+h[b+9328>>3]*+h[(c[a+416>>2]|0)+656>>3]*+h[b+1592>>3]);i=i;return}function xw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1168>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1600>>3],-+h[j+1592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1712>>3]=l;h[e+1704>>3]=m;i=b;return}function yw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1168>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1600>>3],-+h[j+1592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1728>>3]=l;h[e+1720>>3]=m;i=b;return}function zw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1168>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1600>>3],-+h[j+1592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1744>>3]=l;h[e+1736>>3]=m;i=b;return}function Aw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1132>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1600>>3],+h[j+1592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1856>>3]=l;h[e+1848>>3]=m;i=b;return}function Bw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1132>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1600>>3],+h[j+1592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1872>>3]=l;h[e+1864>>3]=m;i=b;return}function Cw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1132>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1600>>3],+h[j+1592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1888>>3]=l;h[e+1880>>3]=m;i=b;return}function Dw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1180>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1568>>3],-+h[j+1560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1680>>3]=l;h[e+1672>>3]=m;i=b;return}function Ew(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1180>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1568>>3],-+h[j+1560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1664>>3]=l;h[e+1656>>3]=m;i=b;return}function Fw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1584>>3]=-(+h[b+9328>>3]*+h[(c[a+416>>2]|0)+664>>3]*+h[b+1560>>3]);i=i;return}function Gw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1156>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1632>>3],-+h[j+1624>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1760>>3]=l;h[e+1752>>3]=m;i=b;return}function Hw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+440>>3]=-+h[b+1712>>3]- +h[b+1664>>3]- +h[b+1760>>3];i=i;return}function Iw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+432>>3]=-+h[b+1704>>3]- +h[b+1656>>3]- +h[b+1752>>3];i=i;return}function Jw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1156>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1632>>3],-+h[j+1624>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1792>>3]=l;h[e+1784>>3]=m;i=b;return}function Kw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1120>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1632>>3],+h[j+1624>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1904>>3]=l;h[e+1896>>3]=m;i=b;return}function Lw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1120>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1632>>3],+h[j+1624>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1920>>3]=l;h[e+1912>>3]=m;i=b;return}function Mw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1120>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1632>>3],+h[j+1624>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1936>>3]=l;h[e+1928>>3]=m;i=b;return}function Nw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1156>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1632>>3],-+h[j+1624>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1776>>3]=l;h[e+1768>>3]=m;i=b;return}function Ow(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+456>>3]=-+h[b+1728>>3]- +h[b+1680>>3]- +h[b+1776>>3];i=i;return}function Pw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+448>>3]=-+h[b+1720>>3]- +h[b+1672>>3]- +h[b+1768>>3];i=i;return}function Qw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+952>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3288>>3],-+h[j+3280>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3176>>3]=l;h[e+3168>>3]=m;i=b;return}function Rw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+952>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3288>>3],-+h[j+3280>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3192>>3]=l;h[e+3184>>3]=m;i=b;return}function Sw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3304>>3]=-+h[b+3288>>3]- +h[b+3272>>3];i=i;return}function Tw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+964>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3272>>3],-+h[j+3264>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3128>>3]=l;h[e+3120>>3]=m;i=b;return}function Uw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+940>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3304>>3],-+h[j+3296>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3224>>3]=l;h[e+3216>>3]=m;i=b;return}function Vw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3320>>3]=+h[b+3224>>3]+(+h[b+3128>>3]+ +h[b+3176>>3]);i=i;return}function Ww(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3312>>3]=+h[b+3216>>3]+(+h[b+3120>>3]+ +h[b+3168>>3]);i=i;return}function Xw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+940>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3304>>3],-+h[j+3296>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3256>>3]=l;h[e+3248>>3]=m;i=b;return}function Yw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+940>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3304>>3],-+h[j+3296>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3240>>3]=l;h[e+3232>>3]=m;i=b;return}function Zw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+964>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3272>>3],-+h[j+3264>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3144>>3]=l;h[e+3136>>3]=m;i=b;return}function _w(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3336>>3]=+h[b+3240>>3]+(+h[b+3144>>3]+ +h[b+3192>>3]);i=i;return}function $w(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3328>>3]=+h[b+3232>>3]+(+h[b+3136>>3]+ +h[b+3184>>3]);i=i;return}function ax(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+964>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3272>>3],-+h[j+3264>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3160>>3]=l;h[e+3152>>3]=m;i=b;return}function bx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+952>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3288>>3],-+h[j+3280>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3208>>3]=l;h[e+3200>>3]=m;i=b;return}function cx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3344>>3]=+h[b+3248>>3]+(+h[b+3152>>3]+ +h[b+3200>>3]);i=i;return}function dx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3352>>3]=+h[b+3256>>3]+(+h[b+3160>>3]+ +h[b+3208>>3]);i=i;return}function ex(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1180>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1568>>3],-+h[j+1560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1696>>3]=l;h[e+1688>>3]=m;i=b;return}function fx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+472>>3]=-+h[b+1744>>3]- +h[b+1696>>3]- +h[b+1792>>3];i=i;return}function gx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+464>>3]=-+h[b+1736>>3]- +h[b+1688>>3]- +h[b+1784>>3];i=i;return}function hx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1144>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1568>>3],+h[j+1560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1808>>3]=l;h[e+1800>>3]=m;i=b;return}function ix(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2e3>>3]=+h[b+1904>>3]+(+h[b+1808>>3]+ +h[b+1856>>3]);i=i;return}function jx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1992>>3]=+h[b+1896>>3]+(+h[b+1800>>3]+ +h[b+1848>>3]);i=i;return}function kx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2160>>3]=+h[b+2144>>3]*+h[b+9288>>3];i=i;return}function lx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1968>>3]=+h[b+9352>>3]- +h[b+2160>>3];i=i;return}function mx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+168>>3]=+h[b+1968>>3]- +h[b+1616>>3];i=i;return}function nx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2200>>3]=+h[b+2184>>3]*+h[b+9296>>3];i=i;return}function ox(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1984>>3]=+h[b+9336>>3]- +h[b+2200>>3];i=i;return}function px(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+184>>3]=+h[b+1984>>3]- +h[b+1648>>3];i=i;return}function qx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+56>>3]=+h[b+296>>3]+ +h[b+2632>>3];i=i;return}function rx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+488>>3]=+h[b+296>>3]*+h[(c[a+416>>2]|0)+1232>>3];i=i;return}function sx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2600>>3]=+h[b+3616>>3]*+h[b+9304>>3];i=i;return}function tx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+772>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4112>>3],-+h[j+4104>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4384>>3]=l;h[e+4376>>3]=m;i=b;return}function ux(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+772>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4112>>3],-+h[j+4104>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4352>>3]=l;h[e+4344>>3]=m;i=b;return}function vx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+772>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4112>>3],-+h[j+4104>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4368>>3]=l;h[e+4360>>3]=m;i=b;return}function wx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+844>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+3640>>3],+h[j+3632>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3872>>3]=l;h[e+3864>>3]=m;i=b;return}function xx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+844>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+3640>>3],+h[j+3632>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3888>>3]=l;h[e+3880>>3]=m;i=b;return}function yx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2616>>3]=+h[b+3640>>3]*+h[b+9312>>3];i=i;return}function zx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+936>>3]=+h[b+1080>>3]+ +h[b+2616>>3];i=i;return}function Ax(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+120>>3]=+h[b+584>>3]+ +h[b+936>>3];i=i;return}function Bx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+920>>3]=+h[b+1040>>3]+ +h[b+2600>>3];i=i;return}function Cx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+104>>3]=+h[b+552>>3]+ +h[b+920>>3];i=i;return}function Dx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+392>>3]=+h[b+104>>3]- +h[b+56>>3];i=i;return}function Ex(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2120>>3]=+h[b+2104>>3]*+h[b+9280>>3];i=i;return}function Fx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1952>>3]=+h[b+9368>>3]- +h[b+2120>>3];i=i;return}function Gx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+152>>3]=+h[b+1952>>3]- +h[b+1584>>3];i=i;return}function Hx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9792>>3]=+h[b+152>>3]- +h[b+488>>3];i=i;return}function Ix(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+520>>3]=+h[b+184>>3]- +h[b+9792>>3];i=i;return}function Jx(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+1232>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+520>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+328|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+328|0;p=o;h[p>>3]=m;i=d;return}q=k/+$1(c[b+536>>2]|0,e,1832,1920,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+328|0;p=o;h[p>>3]=m;i=d;return}function Kx(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+1224>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+520>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+424|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+424|0;p=o;h[p>>3]=m;i=d;return}q=k/+$1(c[b+536>>2]|0,e,1856,1928,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+424|0;p=o;h[p>>3]=m;i=d;return}function Lx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+88>>3]=+h[b+136>>3]- +h[b+424>>3];i=i;return}function Mx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+504>>3]=+h[b+168>>3]- +h[b+9792>>3];i=i;return}function Nx(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+1224>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+504>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+408|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+408|0;p=o;h[p>>3]=m;i=d;return}q=k/+$1(c[b+536>>2]|0,e,1856,1936,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+408|0;p=o;h[p>>3]=m;i=d;return}function Ox(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+1232>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+504>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+312|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+312|0;p=o;h[p>>3]=m;i=d;return}q=k/+$1(c[b+536>>2]|0,e,1832,1944,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+312|0;p=o;h[p>>3]=m;i=d;return}function Px(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+72>>3]=+h[b+312>>3]+ +h[b+2600>>3];i=i;return}function Qx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2192>>3]=+h[b+2176>>3]*+h[b+9296>>3];i=i;return}function Rx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1976>>3]=+h[b+9344>>3]- +h[b+2192>>3];i=i;return}function Sx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+176>>3]=+h[b+1976>>3]- +h[b+1640>>3];i=i;return}function Tx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1084>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2184>>3],-+h[j+2176>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2312>>3]=l;h[e+2304>>3]=m;i=b;return}function Ux(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2152>>3]=+h[b+2136>>3]*+h[b+9288>>3];i=i;return}function Vx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1960>>3]=+h[b+9360>>3]- +h[b+2152>>3];i=i;return}function Wx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+160>>3]=+h[b+1960>>3]- +h[b+1608>>3];i=i;return}function Xx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9784>>3]=+h[b+160>>3]- +h[b+496>>3];i=i;return}function Yx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+512>>3]=+h[b+176>>3]- +h[b+9784>>3];i=i;return}function Zx(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+1232>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+512>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+320|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+320|0;p=o;h[p>>3]=m;i=d;return}q=k/+$1(c[b+536>>2]|0,e,1832,1952,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+320|0;p=o;h[p>>3]=m;i=d;return}function _x(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+1224>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+512>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+416|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+416|0;p=o;h[p>>3]=m;i=d;return}q=k/+$1(c[b+536>>2]|0,e,1856,1960,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+416|0;p=o;h[p>>3]=m;i=d;return}function $x(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1096>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2144>>3],-+h[j+2136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2264>>3]=l;h[e+2256>>3]=m;i=b;return}function ay(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2208>>3]=-+h[b+2256>>3]- +h[b+1992>>3]- +h[b+2304>>3];i=i;return}function by(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2216>>3]=-+h[b+2264>>3]- +h[b+2e3>>3]- +h[b+2312>>3];i=i;return}function cy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1084>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2184>>3],-+h[j+2176>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2328>>3]=l;h[e+2320>>3]=m;i=b;return}function dy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1084>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2184>>3],-+h[j+2176>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2344>>3]=l;h[e+2336>>3]=m;i=b;return}function ey(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1096>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2144>>3],-+h[j+2136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2296>>3]=l;h[e+2288>>3]=m;i=b;return}function fy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1096>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2144>>3],-+h[j+2136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2280>>3]=l;h[e+2272>>3]=m;i=b;return}function gy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1144>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1568>>3],+h[j+1560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1824>>3]=l;h[e+1816>>3]=m;i=b;return}function hy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2016>>3]=+h[b+1920>>3]+(+h[b+1824>>3]+ +h[b+1872>>3]);i=i;return}function iy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2232>>3]=-+h[b+2280>>3]- +h[b+2016>>3]- +h[b+2328>>3];i=i;return}function jy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2008>>3]=+h[b+1912>>3]+(+h[b+1816>>3]+ +h[b+1864>>3]);i=i;return}function ky(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2224>>3]=-+h[b+2272>>3]- +h[b+2008>>3]- +h[b+2320>>3];i=i;return}function ly(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1144>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1568>>3],+h[j+1560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1840>>3]=l;h[e+1832>>3]=m;i=b;return}function my(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2032>>3]=+h[b+1936>>3]+(+h[b+1840>>3]+ +h[b+1888>>3]);i=i;return}function ny(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2248>>3]=-+h[b+2296>>3]- +h[b+2032>>3]- +h[b+2344>>3];i=i;return}function oy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2024>>3]=+h[b+1928>>3]+(+h[b+1832>>3]+ +h[b+1880>>3]);i=i;return}function py(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2240>>3]=-+h[b+2288>>3]- +h[b+2024>>3]- +h[b+2336>>3];i=i;return}function qy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2112>>3]=+h[b+2096>>3]*+h[b+9280>>3];i=i;return}function ry(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1944>>3]=+h[b+9376>>3]- +h[b+2112>>3];i=i;return}function sy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+144>>3]=+h[b+1944>>3]- +h[b+1576>>3];i=i;return}function ty(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+480>>3]=+h[b+144>>3]- +h[b+9784>>3];i=i;return}function uy(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+1224>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+480>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+384|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+384|0;p=o;h[p>>3]=m;i=d;return}q=k/+$1(c[b+536>>2]|0,e,1856,1968,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+384|0;p=o;h[p>>3]=m;i=d;return}function vy(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+1232>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+480>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+288|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+288|0;p=o;h[p>>3]=m;i=d;return}q=k/+$1(c[b+536>>2]|0,e,1832,1976,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+288|0;p=o;h[p>>3]=m;i=d;return}function wy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2592>>3]=+h[b+3608>>3]*+h[b+9304>>3];i=i;return}function xy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+912>>3]=+h[b+1032>>3]+ +h[b+2592>>3];i=i;return}function yy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+96>>3]=+h[b+544>>3]+ +h[b+912>>3];i=i;return}function zy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+48>>3]=+h[b+96>>3]- +h[b+384>>3];i=i;return}function Ay(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+304>>3]=+h[b+64>>3]- +h[b+2592>>3];i=i;return}function By(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+856>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+3616>>3],+h[j+3608>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3840>>3]=l;h[e+3832>>3]=m;i=b;return}function Cy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+856>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+3616>>3],+h[j+3608>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3856>>3]=l;h[e+3848>>3]=m;i=b;return}function Dy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+856>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+3616>>3],+h[j+3608>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3824>>3]=l;h[e+3816>>3]=m;i=b;return}function Ey(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+760>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4144>>3],-+h[j+4136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4400>>3]=l;h[e+4392>>3]=m;i=b;return}function Fy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4016>>3]=-+h[b+4352>>3]- +h[b+4304>>3]- +h[b+4400>>3];i=i;return}function Gy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3920>>3]=+h[b+4016>>3]- +h[b+3824>>3]- +h[b+3872>>3];i=i;return}function Hy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4008>>3]=-+h[b+4344>>3]- +h[b+4296>>3]- +h[b+4392>>3];i=i;return}function Iy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3912>>3]=+h[b+4008>>3]- +h[b+3816>>3]- +h[b+3864>>3];i=i;return}function Jy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+760>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4144>>3],-+h[j+4136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4416>>3]=l;h[e+4408>>3]=m;i=b;return}function Ky(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4032>>3]=-+h[b+4368>>3]- +h[b+4320>>3]- +h[b+4416>>3];i=i;return}function Ly(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3936>>3]=+h[b+4032>>3]- +h[b+3840>>3]- +h[b+3888>>3];i=i;return}function My(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4024>>3]=-+h[b+4360>>3]- +h[b+4312>>3]- +h[b+4408>>3];i=i;return}function Ny(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+760>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4144>>3],-+h[j+4136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4432>>3]=l;h[e+4424>>3]=m;i=b;return}function Oy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+688>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4144>>3],+h[j+4136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4688>>3]=l;h[e+4680>>3]=m;i=b;return}function Py(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+688>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4144>>3],+h[j+4136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4704>>3]=l;h[e+4696>>3]=m;i=b;return}function Qy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+784>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4080>>3],-+h[j+4072>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4336>>3]=l;h[e+4328>>3]=m;i=b;return}function Ry(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4048>>3]=-+h[b+4384>>3]- +h[b+4336>>3]- +h[b+4432>>3];i=i;return}function Sy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+664>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4944>>3],-+h[j+4936>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5024>>3]=l;h[e+5016>>3]=m;i=b;return}function Ty(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+664>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4944>>3],-+h[j+4936>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5040>>3]=l;h[e+5032>>3]=m;i=b;return}function Uy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+664>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4944>>3],-+h[j+4936>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5056>>3]=l;h[e+5048>>3]=m;i=b;return}function Vy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+628>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4944>>3],+h[j+4936>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5168>>3]=l;h[e+5160>>3]=m;i=b;return}function Wy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+628>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4944>>3],+h[j+4936>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5184>>3]=l;h[e+5176>>3]=m;i=b;return}function Xy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+628>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4944>>3],+h[j+4936>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5200>>3]=l;h[e+5192>>3]=m;i=b;return}function Yy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+652>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4960>>3],-+h[j+4952>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5072>>3]=l;h[e+5064>>3]=m;i=b;return}function Zy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+652>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4960>>3],-+h[j+4952>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5088>>3]=l;h[e+5080>>3]=m;i=b;return}function _y(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+652>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4960>>3],-+h[j+4952>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5104>>3]=l;h[e+5096>>3]=m;i=b;return}function $y(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+616>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4960>>3],+h[j+4952>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5216>>3]=l;h[e+5208>>3]=m;i=b;return}function az(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+676>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4928>>3],-+h[j+4920>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5008>>3]=l;h[e+5e3>>3]=m;i=b;return}function bz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5296>>3]=+h[b+5104>>3]+(+h[b+5008>>3]+ +h[b+5056>>3]);i=i;return}function cz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4864>>3]=-+h[b+5296>>3]- +h[b+4816>>3];i=i;return}function dz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5288>>3]=+h[b+5096>>3]+(+h[b+5e3>>3]+ +h[b+5048>>3]);i=i;return}function ez(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4856>>3]=-+h[b+5288>>3]- +h[b+4808>>3];i=i;return}function fz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+676>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4928>>3],-+h[j+4920>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4992>>3]=l;h[e+4984>>3]=m;i=b;return}function gz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+640>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4928>>3],+h[j+4920>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5120>>3]=l;h[e+5112>>3]=m;i=b;return}function hz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5312>>3]=+h[b+5216>>3]+(+h[b+5120>>3]+ +h[b+5168>>3]);i=i;return}function iz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2552>>3]=-+h[b+5696>>3]- +h[b+5312>>3]- +h[b+6176>>3];i=i;return}function jz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1424>>3]=+h[b+2552>>3]- +h[b+3080>>3];i=i;return}function kz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1184>>3]=+h[b+1424>>3]- +h[b+1136>>3]- +h[b+1232>>3];i=i;return}function lz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5304>>3]=+h[b+5208>>3]+(+h[b+5112>>3]+ +h[b+5160>>3]);i=i;return}function mz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2544>>3]=-+h[b+5688>>3]- +h[b+5304>>3]- +h[b+6168>>3];i=i;return}function nz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1416>>3]=+h[b+2544>>3]- +h[b+3072>>3];i=i;return}function oz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1176>>3]=+h[b+1416>>3]- +h[b+1128>>3]- +h[b+1224>>3];i=i;return}function pz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+640>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4928>>3],+h[j+4920>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5136>>3]=l;h[e+5128>>3]=m;i=b;return}function qz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+640>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4928>>3],+h[j+4920>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5152>>3]=l;h[e+5144>>3]=m;i=b;return}function rz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+676>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4928>>3],-+h[j+4920>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4976>>3]=l;h[e+4968>>3]=m;i=b;return}function sz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5264>>3]=+h[b+5072>>3]+(+h[b+4976>>3]+ +h[b+5024>>3]);i=i;return}function tz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4832>>3]=-+h[b+5264>>3]- +h[b+4784>>3];i=i;return}function uz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5256>>3]=+h[b+5064>>3]+(+h[b+4968>>3]+ +h[b+5016>>3]);i=i;return}function vz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4824>>3]=-+h[b+5256>>3]- +h[b+4776>>3];i=i;return}function wz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+712>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4080>>3],+h[j+4072>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4592>>3]=l;h[e+4584>>3]=m;i=b;return}function xz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4640>>3]=+h[b+4832>>3]- +h[b+4592>>3]- +h[b+4688>>3];i=i;return}function yz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4632>>3]=+h[b+4824>>3]- +h[b+4584>>3]- +h[b+4680>>3];i=i;return}function zz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+712>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4080>>3],+h[j+4072>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4608>>3]=l;h[e+4600>>3]=m;i=b;return}function Az(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5272>>3]=+h[b+5080>>3]+(+h[b+4984>>3]+ +h[b+5032>>3]);i=i;return}function Bz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4840>>3]=-+h[b+5272>>3]- +h[b+4792>>3];i=i;return}function Cz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4648>>3]=+h[b+4840>>3]- +h[b+4600>>3]- +h[b+4696>>3];i=i;return}function Dz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5280>>3]=+h[b+5088>>3]+(+h[b+4992>>3]+ +h[b+5040>>3]);i=i;return}function Ez(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4848>>3]=-+h[b+5280>>3]- +h[b+4800>>3];i=i;return}function Fz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4656>>3]=+h[b+4848>>3]- +h[b+4608>>3]- +h[b+4704>>3];i=i;return}function Gz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+688>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4144>>3],+h[j+4136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4720>>3]=l;h[e+4712>>3]=m;i=b;return}function Hz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+712>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4080>>3],+h[j+4072>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+4624>>3]=l;h[e+4616>>3]=m;i=b;return}function Iz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4672>>3]=+h[b+4864>>3]- +h[b+4624>>3]- +h[b+4720>>3];i=i;return}function Jz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4664>>3]=+h[b+4856>>3]- +h[b+4616>>3]- +h[b+4712>>3];i=i;return}function Kz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4040>>3]=-+h[b+4376>>3]- +h[b+4328>>3]- +h[b+4424>>3];i=i;return}function Lz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+844>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+3640>>3],+h[j+3632>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3904>>3]=l;h[e+3896>>3]=m;i=b;return}function Mz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3952>>3]=+h[b+4048>>3]- +h[b+3856>>3]- +h[b+3904>>3];i=i;return}function Nz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3944>>3]=+h[b+4040>>3]- +h[b+3848>>3]- +h[b+3896>>3];i=i;return}function Oz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3928>>3]=+h[b+4024>>3]- +h[b+3832>>3]- +h[b+3880>>3];i=i;return}function Pz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2624>>3]=+h[b+3656>>3]*+h[b+9320>>3];i=i;return}function Qz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1112>>3]=+h[b+1096>>3]*+h[b+9272>>3];i=i;return}function Rz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+944>>3]=+h[b+1112>>3]+ +h[b+2624>>3];i=i;return}function Sz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+128>>3]=+h[b+608>>3]+ +h[b+944>>3];i=i;return}function Tz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+80>>3]=+h[b+128>>3]- +h[b+416>>3];i=i;return}function Uz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1192>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1104>>3],+h[j+1096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1408>>3]=l;h[e+1400>>3]=m;i=b;return}function Vz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1300>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+600>>3],-+h[j+592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+760>>3]=l;h[e+752>>3]=m;i=b;return}function Wz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1504>>3]=-+h[b+712>>3]- +h[b+664>>3]- +h[b+760>>3];i=i;return}function Xz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1360>>3]=+h[b+1504>>3]- +h[b+1312>>3]- +h[b+1408>>3];i=i;return}function Yz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1496>>3]=-+h[b+704>>3]- +h[b+656>>3]- +h[b+752>>3];i=i;return}function Zz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1352>>3]=+h[b+1496>>3]- +h[b+1304>>3]- +h[b+1400>>3];i=i;return}function _z(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1264>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+600>>3],+h[j+592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+888>>3]=l;h[e+880>>3]=m;i=b;return}function $z(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1264>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+600>>3],+h[j+592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+904>>3]=l;h[e+896>>3]=m;i=b;return}function aA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1264>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+600>>3],+h[j+592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+872>>3]=l;h[e+864>>3]=m;i=b;return}function bA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1288>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+536>>3],+h[j+528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+776>>3]=l;h[e+768>>3]=m;i=b;return}function cA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+344>>3]=-+h[b+824>>3]- +h[b+776>>3]- +h[b+872>>3];i=i;return}function dA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+336>>3]=-+h[b+816>>3]- +h[b+768>>3]- +h[b+864>>3];i=i;return}



function $h(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6240>>3]=+h[b+2616>>3]- +h[b+2632>>3];i=i;return}function ai(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1536>>3]=+h[b+936>>3]- +h[b+2616>>3];i=i;return}function bi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+984>>3]=+h[b+120>>3]- +h[b+936>>3];i=i;return}function ci(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5792>>3]=+h[b+2600>>3]- +h[b+2616>>3];i=i;return}function di(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6224>>3]=+h[b+2600>>3]- +h[b+2616>>3];i=i;return}function ei(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5856>>3]=+h[b+2632>>3]- +h[b+2600>>3];i=i;return}function fi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6256>>3]=+h[b+2632>>3]- +h[b+2600>>3];i=i;return}function gi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1520>>3]=+h[b+920>>3]- +h[b+2600>>3];i=i;return}function hi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+968>>3]=+h[b+104>>3]- +h[b+920>>3];i=i;return}function ii(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2504>>3]=+h[b+9368>>3]- +h[b+1952>>3];i=i;return}function ji(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2048>>3]=+h[b+1952>>3]- +h[b+152>>3];i=i;return}function ki(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2528>>3]=+h[b+9344>>3]- +h[b+1976>>3];i=i;return}function li(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2072>>3]=+h[b+1976>>3]- +h[b+176>>3];i=i;return}function mi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+992>>3]=+h[b+128>>3]- +h[b+944>>3];i=i;return}function ni(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2512>>3]=+h[b+9360>>3]- +h[b+1960>>3];i=i;return}function oi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2056>>3]=+h[b+1960>>3]- +h[b+160>>3];i=i;return}function pi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1048>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2184>>3],+h[j+2176>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2488>>3]=l;h[e+2480>>3]=m;i=b;return}function qi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1048>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2184>>3],+h[j+2176>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2472>>3]=l;h[e+2464>>3]=m;i=b;return}function ri(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1048>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2184>>3],+h[j+2176>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2456>>3]=l;h[e+2448>>3]=m;i=b;return}function si(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2168>>3]=+h[b+2200>>3]*+h[b+2184>>3]+ +h[b+2192>>3]*+h[b+2176>>3];i=i;return}function ti(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1060>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2144>>3],+h[j+2136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2440>>3]=l;h[e+2432>>3]=m;i=b;return}function ui(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1060>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2144>>3],+h[j+2136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2424>>3]=l;h[e+2416>>3]=m;i=b;return}function vi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1060>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2144>>3],+h[j+2136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2408>>3]=l;h[e+2400>>3]=m;i=b;return}function wi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2128>>3]=+h[b+2160>>3]*+h[b+2144>>3]+ +h[b+2152>>3]*+h[b+2136>>3];i=i;return}function xi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1072>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2104>>3],+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2392>>3]=l;h[e+2384>>3]=m;i=b;return}function yi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2672>>3]=+h[b+2480>>3]+(+h[b+2384>>3]+ +h[b+2432>>3]);i=i;return}function zi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7448>>3]=-+h[b+6632>>3]- +h[b+2672>>3]- +h[b+7016>>3];i=i;return}function Ai(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2680>>3]=+h[b+2488>>3]+(+h[b+2392>>3]+ +h[b+2440>>3]);i=i;return}function Bi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7456>>3]=-+h[b+6640>>3]- +h[b+2680>>3]- +h[b+7024>>3];i=i;return}function Ci(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1072>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2104>>3],+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2376>>3]=l;h[e+2368>>3]=m;i=b;return}function Di(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2656>>3]=+h[b+2464>>3]+(+h[b+2368>>3]+ +h[b+2416>>3]);i=i;return}function Ei(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7432>>3]=-+h[b+6616>>3]- +h[b+2656>>3]- +h[b+7e3>>3];i=i;return}function Fi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2664>>3]=+h[b+2472>>3]+(+h[b+2376>>3]+ +h[b+2424>>3]);i=i;return}function Gi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7440>>3]=-+h[b+6624>>3]- +h[b+2664>>3]- +h[b+7008>>3];i=i;return}function Hi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1072>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2104>>3],+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2360>>3]=l;h[e+2352>>3]=m;i=b;return}function Ii(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2648>>3]=+h[b+2456>>3]+(+h[b+2360>>3]+ +h[b+2408>>3]);i=i;return}function Ji(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7424>>3]=-+h[b+6608>>3]- +h[b+2648>>3]- +h[b+6992>>3];i=i;return}function Ki(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2640>>3]=+h[b+2448>>3]+(+h[b+2352>>3]+ +h[b+2400>>3]);i=i;return}function Li(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7416>>3]=-+h[b+6600>>3]- +h[b+2640>>3]- +h[b+6984>>3];i=i;return}function Mi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+924>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+7080>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+7080|0;h[c[g+928>>2]>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+7080>>3]);e=c[f>>2]|0;h[c[e+932>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+924>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+7104>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+7104|0;h[(c[e+928>>2]|0)+8>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+7104>>3]);j=c[f>>2]|0;h[(c[j+932>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+924>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+7112>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+7112|0;h[(c[j+928>>2]|0)+16>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+7112>>3]);g=c[f>>2]|0;h[(c[g+932>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+924>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+7088>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+7088|0;h[(c[g+928>>2]|0)+24>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+7088>>3]);e=c[f>>2]|0;h[(c[e+932>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+924>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+7096>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+7096|0;h[(c[e+928>>2]|0)+32>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+7096>>3]);j=c[f>>2]|0;h[(c[j+932>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+924>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+7120>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+7120|0;h[(c[j+928>>2]|0)+40>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+7120>>3]);h[(c[(c[f>>2]|0)+932>>2]|0)+40>>3]=k;S5(a,11)|0;g=c[(c[f>>2]|0)+924>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+7080>>3]=+h[g>>3];h[f+7104>>3]=+h[g+8>>3];h[f+7112>>3]=+h[g+16>>3];h[f+7088>>3]=+h[g+24>>3];h[f+7096>>3]=+h[g+32>>3];h[f+7120>>3]=+h[g+40>>3];xB(a);yB(a);zB(a);AB(a);BB(a);CB(a);DB(a);EB(a);FB(a);GB(a);HB(a);IB(a);JB(a);KB(a);LB(a);i=b;return}function Ni(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+7088>>3];e=+h[b+7080>>3];h[b+7040>>3]=+V(+(d*d+e*e));i=i;return}function Oi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7032>>3]=+ba(+(+h[b+7080>>3]),+(+h[b+7088>>3]));i=i;return}function Pi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+280>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7088>>3],+h[j+7080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7280>>3]=l;h[e+7272>>3]=m;i=b;return}function Qi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+280>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7088>>3],+h[j+7080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7296>>3]=l;h[e+7288>>3]=m;i=b;return}function Ri(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+280>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7088>>3],+h[j+7080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7312>>3]=l;h[e+7304>>3]=m;i=b;return}function Si(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+7104>>3];e=+h[b+7096>>3];h[b+7056>>3]=+V(+(d*d+e*e));i=i;return}function Ti(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7048>>3]=+ba(+(+h[b+7096>>3]),+(+h[b+7104>>3]));i=i;return}function Ui(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+268>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7104>>3],+h[j+7096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7328>>3]=l;h[e+7320>>3]=m;i=b;return}function Vi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+268>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7104>>3],+h[j+7096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7344>>3]=l;h[e+7336>>3]=m;i=b;return}function Wi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+268>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7104>>3],+h[j+7096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7360>>3]=l;h[e+7352>>3]=m;i=b;return}function Xi(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+7120>>3];e=+h[b+7112>>3];h[b+7072>>3]=+V(+(d*d+e*e));i=i;return}function Yi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7064>>3]=+ba(+(+h[b+7112>>3]),+(+h[b+7120>>3]));i=i;return}function Zi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+256>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7120>>3],+h[j+7112>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7376>>3]=l;h[e+7368>>3]=m;i=b;return}function _i(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7472>>3]=+h[b+7376>>3]+(+h[b+7280>>3]+ +h[b+7328>>3]);i=i;return}function $i(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7464>>3]=+h[b+7368>>3]+(+h[b+7272>>3]+ +h[b+7320>>3]);i=i;return}function aj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+256>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7120>>3],+h[j+7112>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7392>>3]=l;h[e+7384>>3]=m;i=b;return}function bj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7488>>3]=+h[b+7392>>3]+(+h[b+7296>>3]+ +h[b+7344>>3]);i=i;return}function cj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7480>>3]=+h[b+7384>>3]+(+h[b+7288>>3]+ +h[b+7336>>3]);i=i;return}function dj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+256>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7120>>3],+h[j+7112>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7408>>3]=l;h[e+7400>>3]=m;i=b;return}function ej(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7504>>3]=+h[b+7408>>3]+(+h[b+7312>>3]+ +h[b+7360>>3]);i=i;return}function fj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7496>>3]=+h[b+7400>>3]+(+h[b+7304>>3]+ +h[b+7352>>3]);i=i;return}function gj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1004>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+7528>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+7528|0;h[c[g+1008>>2]>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+7528>>3]);e=c[f>>2]|0;h[c[e+1012>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1004>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+7600>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+7600|0;h[(c[e+1008>>2]|0)+8>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+7600>>3]);j=c[f>>2]|0;h[(c[j+1012>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+1004>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+7568>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+7568|0;h[(c[j+1008>>2]|0)+16>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+7568>>3]);g=c[f>>2]|0;h[(c[g+1012>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+1004>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+7536>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+7536|0;h[(c[g+1008>>2]|0)+24>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+7536>>3]);e=c[f>>2]|0;h[(c[e+1012>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+1004>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+7592>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+7592|0;h[(c[e+1008>>2]|0)+32>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+7592>>3]);j=c[f>>2]|0;h[(c[j+1012>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+1004>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+7560>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+7560|0;h[(c[j+1008>>2]|0)+40>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+7560>>3]);h[(c[(c[f>>2]|0)+1012>>2]|0)+40>>3]=k;S5(a,12)|0;g=c[(c[f>>2]|0)+1004>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+7528>>3]=+h[g>>3];h[f+7600>>3]=+h[g+8>>3];h[f+7568>>3]=+h[g+16>>3];h[f+7536>>3]=+h[g+24>>3];h[f+7592>>3]=+h[g+32>>3];h[f+7560>>3]=+h[g+40>>3];OB(a);PB(a);QB(a);RB(a);SB(a);TB(a);UB(a);VB(a);WB(a);XB(a);YB(a);ZB(a);_B(a);$B(a);aC(a);i=b;return}function hj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7512>>3]=+h[b+9376>>3]*+h[b+7536>>3]- +h[b+9368>>3]*+h[b+7528>>3];i=i;return}function ij(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7520>>3]=+h[b+9368>>3]*+h[b+7536>>3]+ +h[b+9376>>3]*+h[b+7528>>3];i=i;return}function jj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+136>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7536>>3],+h[j+7528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8048>>3]=l;h[e+8040>>3]=m;i=b;return}function kj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+136>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7536>>3],+h[j+7528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8064>>3]=l;h[e+8056>>3]=m;i=b;return}function lj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+136>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7536>>3],+h[j+7528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8080>>3]=l;h[e+8072>>3]=m;i=b;return}function mj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7576>>3]=+h[b+9344>>3]*+h[b+7600>>3]- +h[b+9336>>3]*+h[b+7592>>3];i=i;return}function nj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7584>>3]=+h[b+9336>>3]*+h[b+7600>>3]+ +h[b+9344>>3]*+h[b+7592>>3];i=i;return}function oj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+112>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7600>>3],+h[j+7592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8144>>3]=l;h[e+8136>>3]=m;i=b;return}function pj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+112>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7600>>3],+h[j+7592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8160>>3]=l;h[e+8152>>3]=m;i=b;return}function qj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+112>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7600>>3],+h[j+7592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8176>>3]=l;h[e+8168>>3]=m;i=b;return}function rj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7544>>3]=+h[b+9360>>3]*+h[b+7568>>3]- +h[b+9352>>3]*+h[b+7560>>3];i=i;return}function sj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7552>>3]=+h[b+9352>>3]*+h[b+7568>>3]+ +h[b+9360>>3]*+h[b+7560>>3];i=i;return}function tj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;b=i;i=i+40|0;d=b;e=b+16|0;f=b+32|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;c[o>>2]=3;b2(p,16,1,o);o=a+536|0;y=a+416|0;z=c[y>>2]|0;Wl(q,c[o>>2]|0,+h[z+144>>3],+h[z+152>>3]);z=q;q=c[y>>2]|0;Wl(r,c[o>>2]|0,+h[q+160>>3],+h[q+168>>3]);q=r;r=c[y>>2]|0;Wl(s,c[o>>2]|0,+h[r+176>>3],+h[r+184>>3]);r=s;c[n>>2]=1;s=c2(p,16,1,n)|0;c[s+0>>2]=c[z+0>>2];c[s+4>>2]=c[z+4>>2];c[s+8>>2]=c[z+8>>2];c[s+12>>2]=c[z+12>>2];c[m>>2]=2;z=c2(p,16,1,m)|0;c[z+0>>2]=c[q+0>>2];c[z+4>>2]=c[q+4>>2];c[z+8>>2]=c[q+8>>2];c[z+12>>2]=c[q+12>>2];c[l>>2]=3;q=c2(p,16,1,l)|0;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];c[k>>2]=3;b2(t,16,1,k);k=a+4|0;a=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Wl(u,c[o>>2]|0,+h[a+7584>>3],+h[a+7576>>3]);a=u;u=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Wl(v,c[o>>2]|0,+h[u+7552>>3],+h[u+7544>>3]);u=v;v=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Wl(w,c[o>>2]|0,+h[v+7520>>3],+h[v+7512>>3]);v=w;c[j>>2]=1;w=c2(t,16,1,j)|0;c[w+0>>2]=c[a+0>>2];c[w+4>>2]=c[a+4>>2];c[w+8>>2]=c[a+8>>2];c[w+12>>2]=c[a+12>>2];c[g>>2]=2;a=c2(t,16,1,g)|0;c[a+0>>2]=c[u+0>>2];c[a+4>>2]=c[u+4>>2];c[a+8>>2]=c[u+8>>2];c[a+12>>2]=c[u+12>>2];c[f>>2]=3;u=c2(t,16,1,f)|0;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];v=c[o>>2]|0;o=e;u=p;c[o+0>>2]=c[u+0>>2];c[o+4>>2]=c[u+4>>2];c[o+8>>2]=c[u+8>>2];u=d;o=t;c[u+0>>2]=c[o+0>>2];c[u+4>>2]=c[o+4>>2];c[u+8>>2]=c[o+8>>2];Sl(x,v,e,d);A=+h[x+8>>3];d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[d+10176>>3]=+h[x>>3];h[d+10168>>3]=A;i=b;return}function uj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9840>>3]=+h[b+10176>>3];i=i;return}function vj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9832>>3]=+h[b+10168>>3];i=i;return}function wj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+124>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7568>>3],+h[j+7560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8096>>3]=l;h[e+8088>>3]=m;i=b;return}function xj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8280>>3]=+h[b+8136>>3]+(+h[b+8040>>3]+ +h[b+8088>>3]);i=i;return}function yj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8952>>3]=-+h[b+8280>>3]- +h[b+8232>>3];i=i;return}function zj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8288>>3]=+h[b+8144>>3]+(+h[b+8048>>3]+ +h[b+8096>>3]);i=i;return}function Aj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8960>>3]=-+h[b+8288>>3]- +h[b+8240>>3];i=i;return}function Bj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+124>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7568>>3],+h[j+7560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8112>>3]=l;h[e+8104>>3]=m;i=b;return}function Cj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8296>>3]=+h[b+8152>>3]+(+h[b+8056>>3]+ +h[b+8104>>3]);i=i;return}function Dj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8968>>3]=-+h[b+8296>>3]- +h[b+8248>>3];i=i;return}function Ej(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8304>>3]=+h[b+8160>>3]+(+h[b+8064>>3]+ +h[b+8112>>3]);i=i;return}function Fj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8976>>3]=-+h[b+8304>>3]- +h[b+8256>>3];i=i;return}function Gj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+124>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7568>>3],+h[j+7560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8128>>3]=l;h[e+8120>>3]=m;i=b;return}function Hj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8312>>3]=+h[b+8168>>3]+(+h[b+8072>>3]+ +h[b+8120>>3]);i=i;return}function Ij(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8984>>3]=-+h[b+8312>>3]- +h[b+8264>>3];i=i;return}function Jj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8320>>3]=+h[b+8176>>3]+(+h[b+8080>>3]+ +h[b+8128>>3]);i=i;return}function Kj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8992>>3]=-+h[b+8320>>3]- +h[b+8272>>3];i=i;return}function Lj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1084>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+8576>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+8576|0;h[c[g+1088>>2]>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+8576>>3]);e=c[f>>2]|0;h[c[e+1092>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1084>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+8608>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+8608|0;h[(c[e+1088>>2]|0)+8>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+8608>>3]);j=c[f>>2]|0;h[(c[j+1092>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+1084>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+8592>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+8592|0;h[(c[j+1088>>2]|0)+16>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+8592>>3]);g=c[f>>2]|0;h[(c[g+1092>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+1084>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+8584>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+8584|0;h[(c[g+1088>>2]|0)+24>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+8584>>3]);e=c[f>>2]|0;h[(c[e+1092>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+1084>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+8568>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+8568|0;h[(c[e+1088>>2]|0)+32>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+8568>>3]);j=c[f>>2]|0;h[(c[j+1092>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+1084>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+8600>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+8600|0;h[(c[j+1088>>2]|0)+40>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+8600>>3]);h[(c[(c[f>>2]|0)+1092>>2]|0)+40>>3]=k;S5(a,13)|0;g=c[(c[f>>2]|0)+1084>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+8576>>3]=+h[g>>3];h[f+8608>>3]=+h[g+8>>3];h[f+8592>>3]=+h[g+16>>3];h[f+8584>>3]=+h[g+24>>3];h[f+8568>>3]=+h[g+32>>3];h[f+8600>>3]=+h[g+40>>3];dC(a);eC(a);fC(a);gC(a);hC(a);iC(a);jC(a);kC(a);lC(a);mC(a);nC(a);oC(a);pC(a);qC(a);rC(a);i=b;return}function Mj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+52>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8592>>3],-+h[j+8584>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8704>>3]=l;h[e+8696>>3]=m;i=b;return}function Nj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+52>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8592>>3],-+h[j+8584>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8688>>3]=l;h[e+8680>>3]=m;i=b;return}function Oj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+52>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8592>>3],-+h[j+8584>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8672>>3]=l;h[e+8664>>3]=m;i=b;return}function Pj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+64>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8576>>3],-+h[j+8568>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8656>>3]=l;h[e+8648>>3]=m;i=b;return}function Qj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+64>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8576>>3],-+h[j+8568>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8640>>3]=l;h[e+8632>>3]=m;i=b;return}function Rj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+64>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8576>>3],-+h[j+8568>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8624>>3]=l;h[e+8616>>3]=m;i=b;return}function Sj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+40>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8608>>3],-+h[j+8600>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8752>>3]=l;h[e+8744>>3]=m;i=b;return}function Tj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8944>>3]=+h[b+8752>>3]+(+h[b+8656>>3]+ +h[b+8704>>3]);i=i;return}function Uj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8560>>3]=-+h[b+8944>>3]- +h[b+8224>>3];i=i;return}function Vj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8936>>3]=+h[b+8744>>3]+(+h[b+8648>>3]+ +h[b+8696>>3]);i=i;return}function Wj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8552>>3]=-+h[b+8936>>3]- +h[b+8216>>3];i=i;return}function Xj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+40>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8608>>3],-+h[j+8600>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8736>>3]=l;h[e+8728>>3]=m;i=b;return}function Yj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8920>>3]=+h[b+8728>>3]+(+h[b+8632>>3]+ +h[b+8680>>3]);i=i;return}function Zj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8536>>3]=-+h[b+8920>>3]- +h[b+8200>>3];i=i;return}function _j(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8928>>3]=+h[b+8736>>3]+(+h[b+8640>>3]+ +h[b+8688>>3]);i=i;return}function $j(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8544>>3]=-+h[b+8928>>3]- +h[b+8208>>3];i=i;return}function ak(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+40>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8608>>3],-+h[j+8600>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8720>>3]=l;h[e+8712>>3]=m;i=b;return}function bk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8904>>3]=+h[b+8712>>3]+(+h[b+8616>>3]+ +h[b+8664>>3]);i=i;return}function ck(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8520>>3]=-+h[b+8904>>3]- +h[b+8184>>3];i=i;return}function dk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8912>>3]=+h[b+8720>>3]+(+h[b+8624>>3]+ +h[b+8672>>3]);i=i;return}function ek(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8528>>3]=-+h[b+8912>>3]- +h[b+8192>>3];i=i;return}function fk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1164>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+8472>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+8472|0;h[c[g+1168>>2]>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+8472>>3]);e=c[f>>2]|0;h[c[e+1172>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1164>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+8496>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+8496|0;h[(c[e+1168>>2]|0)+8>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+8496>>3]);j=c[f>>2]|0;h[(c[j+1172>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+1164>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+8512>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+8512|0;h[(c[j+1168>>2]|0)+16>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+8512>>3]);g=c[f>>2]|0;h[(c[g+1172>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+1164>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+8488>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+8488|0;h[(c[g+1168>>2]|0)+24>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+8488>>3]);e=c[f>>2]|0;h[(c[e+1172>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+1164>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+8480>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+8480|0;h[(c[e+1168>>2]|0)+32>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+8480>>3]);j=c[f>>2]|0;h[(c[j+1172>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+1164>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+8504>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+8504|0;h[(c[j+1168>>2]|0)+40>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+8504>>3]);h[(c[(c[f>>2]|0)+1172>>2]|0)+40>>3]=k;S5(a,14)|0;g=c[(c[f>>2]|0)+1164>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+8472>>3]=+h[g>>3];h[f+8496>>3]=+h[g+8>>3];h[f+8512>>3]=+h[g+16>>3];h[f+8488>>3]=+h[g+24>>3];h[f+8480>>3]=+h[g+32>>3];h[f+8504>>3]=+h[g+40>>3];uC(a);vC(a);wC(a);xC(a);yC(a);zC(a);AC(a);BC(a);CC(a);DC(a);EC(a);FC(a);GC(a);HC(a);IC(a);i=b;return}function gk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9856>>3]=-+h[b+8496>>3]- +h[b+8480>>3]- +h[b+8512>>3];i=i;return}function hk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9848>>3]=-+h[b+8488>>3]- +h[b+8472>>3]- +h[b+8504>>3];i=i;return}function ik(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9752>>3]=+h[b+9336>>3]*+h[b+2680>>3]+(+h[b+9352>>3]*+h[b+2664>>3]+(+h[b+9368>>3]*+h[b+2648>>3]+(+h[b+9360>>3]*+h[b+2656>>3]+(+h[b+9344>>3]*+h[b+2672>>3]+ +h[b+9376>>3]*+h[b+2640>>3]))));i=i;return}function jk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2088>>3]=+h[b+2120>>3]*+h[b+2104>>3]+ +h[b+2112>>3]*+h[b+2096>>3];i=i;return}function kk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9776>>3]=+h[b+2168>>3]+(+h[b+2088>>3]+ +h[b+2128>>3]);i=i;return}function lk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9736>>3]=-+h[b+2168>>3]- +h[b+2128>>3]- +h[b+2088>>3];i=i;return}function mk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2496>>3]=+h[b+9376>>3]- +h[b+1944>>3];i=i;return}function nk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2040>>3]=+h[b+1944>>3]- +h[b+144>>3];i=i;return}function ok(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+960>>3]=+h[b+96>>3]- +h[b+912>>3];i=i;return}function pk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1512>>3]=+h[b+912>>3]- +h[b+2592>>3];i=i;return}function qk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5784>>3]=+h[b+2592>>3]- +h[b+2608>>3];i=i;return}function rk(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5792>>3];e=+h[b+5784>>3];h[b+5808>>3]=+V(+(d*d+e*e));i=i;return}function sk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5800>>3]=+ba(+(+h[b+5784>>3]),+(+h[b+5792>>3]));i=i;return}function tk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6216>>3]=+h[b+2592>>3]- +h[b+2608>>3];i=i;return}function uk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+892>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3616>>3],-+h[j+3608>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3712>>3]=l;h[e+3704>>3]=m;i=b;return}function vk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+892>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3616>>3],-+h[j+3608>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3696>>3]=l;h[e+3688>>3]=m;i=b;return}function wk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+892>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3616>>3],-+h[j+3608>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3680>>3]=l;h[e+3672>>3]=m;i=b;return}function xk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3600>>3]=+h[b+2600>>3]*+h[b+3616>>3]+ +h[b+2592>>3]*+h[b+3608>>3];i=i;return}function yk(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4944>>3];e=+h[b+4936>>3];h[b+4896>>3]=+V(+(d*d+e*e));i=i;return}function zk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4888>>3]=+ba(+(+h[b+4936>>3]),+(+h[b+4944>>3]));i=i;return}function Ak(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4928>>3];e=+h[b+4920>>3];h[b+4880>>3]=+V(+(d*d+e*e));i=i;return}function Bk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4872>>3]=+ba(+(+h[b+4920>>3]),+(+h[b+4928>>3]));i=i;return}function Ck(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4088>>3]=+h[b+2608>>3]*+h[b+4112>>3]- +h[b+2616>>3]*+h[b+4104>>3];i=i;return}function Dk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4096>>3]=+h[b+2616>>3]*+h[b+4112>>3]+ +h[b+2608>>3]*+h[b+4104>>3];i=i;return}function Ek(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4056>>3]=+h[b+2592>>3]*+h[b+4080>>3]- +h[b+2600>>3]*+h[b+4072>>3];i=i;return}function Fk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4064>>3]=+h[b+2600>>3]*+h[b+4080>>3]+ +h[b+2592>>3]*+h[b+4072>>3];i=i;return}function Gk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+880>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3640>>3],-+h[j+3632>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3760>>3]=l;h[e+3752>>3]=m;i=b;return}function Hk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+880>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3640>>3],-+h[j+3632>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3744>>3]=l;h[e+3736>>3]=m;i=b;return}function Ik(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+880>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3640>>3],-+h[j+3632>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3728>>3]=l;h[e+3720>>3]=m;i=b;return}function Jk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3624>>3]=+h[b+2616>>3]*+h[b+3640>>3]+ +h[b+2608>>3]*+h[b+3632>>3];i=i;return}function Kk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+868>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3664>>3],-+h[j+3656>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3808>>3]=l;h[e+3800>>3]=m;i=b;return}function Lk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4e3>>3]=+h[b+3808>>3]+(+h[b+3712>>3]+ +h[b+3760>>3]);i=i;return}function Mk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3592>>3]=-+h[b+4768>>3]- +h[b+4e3>>3];i=i;return}function Nk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3992>>3]=+h[b+3800>>3]+(+h[b+3704>>3]+ +h[b+3752>>3]);i=i;return}function Ok(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3584>>3]=-+h[b+4760>>3]- +h[b+3992>>3];i=i;return}function Pk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+868>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3664>>3],-+h[j+3656>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3792>>3]=l;h[e+3784>>3]=m;i=b;return}function Qk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3976>>3]=+h[b+3784>>3]+(+h[b+3688>>3]+ +h[b+3736>>3]);i=i;return}function Rk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3568>>3]=-+h[b+4744>>3]- +h[b+3976>>3];i=i;return}function Sk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3984>>3]=+h[b+3792>>3]+(+h[b+3696>>3]+ +h[b+3744>>3]);i=i;return}function Tk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3576>>3]=-+h[b+4752>>3]- +h[b+3984>>3];i=i;return}function Uk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+868>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3664>>3],-+h[j+3656>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3776>>3]=l;h[e+3768>>3]=m;i=b;return}function Vk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3968>>3]=+h[b+3776>>3]+(+h[b+3680>>3]+ +h[b+3728>>3]);i=i;return}function Wk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3560>>3]=-+h[b+4736>>3]- +h[b+3968>>3];i=i;return}function Xk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3960>>3]=+h[b+3768>>3]+(+h[b+3672>>3]+ +h[b+3720>>3]);i=i;return}function Yk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3552>>3]=-+h[b+4728>>3]- +h[b+3960>>3];i=i;return}function Zk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1244>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+3528>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+3528|0;h[c[g+1248>>2]>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+3528>>3]);e=c[f>>2]|0;h[c[e+1252>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1244>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+3520>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+3520|0;h[(c[e+1248>>2]|0)+8>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+3520>>3]);j=c[f>>2]|0;h[(c[j+1252>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+1244>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+3536>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+3536|0;h[(c[j+1248>>2]|0)+16>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+3536>>3]);g=c[f>>2]|0;h[(c[g+1252>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+1244>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+3512>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+3512|0;h[(c[g+1248>>2]|0)+24>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+3512>>3]);e=c[f>>2]|0;h[(c[e+1252>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+1244>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+3504>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+3504|0;h[(c[e+1248>>2]|0)+32>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+3504>>3]);j=c[f>>2]|0;h[(c[j+1252>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+1244>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+3544>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+3544|0;h[(c[j+1248>>2]|0)+40>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+3544>>3]);h[(c[(c[f>>2]|0)+1252>>2]|0)+40>>3]=k;S5(a,15)|0;g=c[(c[f>>2]|0)+1244>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+3528>>3]=+h[g>>3];h[f+3520>>3]=+h[g+8>>3];h[f+3536>>3]=+h[g+16>>3];h[f+3512>>3]=+h[g+24>>3];h[f+3504>>3]=+h[g+32>>3];h[f+3544>>3]=+h[g+40>>3];LC(a);MC(a);NC(a);OC(a);PC(a);QC(a);RC(a);SC(a);TC(a);UC(a);VC(a);WC(a);XC(a);YC(a);ZC(a);i=b;return}function _k(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9800>>3]=-+h[b+3520>>3]- +h[b+3504>>3]- +h[b+3536>>3];i=i;return}function $k(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9808>>3]=-+h[b+3528>>3]- +h[b+3512>>3]- +h[b+3544>>3];i=i;return}function al(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5848>>3]=+h[b+2624>>3]- +h[b+2592>>3];i=i;return}function bl(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5856>>3];e=+h[b+5848>>3];h[b+5872>>3]=+V(+(d*d+e*e));i=i;return}function cl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5864>>3]=+ba(+(+h[b+5848>>3]),+(+h[b+5856>>3]));i=i;return}function dl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6248>>3]=+h[b+2624>>3]- +h[b+2592>>3];i=i;return}function el(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5816>>3]=+h[b+2608>>3]- +h[b+2624>>3];i=i;return}function fl(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5824>>3];e=+h[b+5816>>3];h[b+5840>>3]=+V(+(d*d+e*e));i=i;return}function gl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5832>>3]=+ba(+(+h[b+5816>>3]),+(+h[b+5824>>3]));i=i;return}function hl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6232>>3]=+h[b+2608>>3]- +h[b+2624>>3];i=i;return}function il(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3648>>3]=+h[b+2632>>3]*+h[b+3664>>3]+ +h[b+2624>>3]*+h[b+3656>>3];i=i;return}function jl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1544>>3]=+h[b+944>>3]- +h[b+2624>>3];i=i;return}function kl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4120>>3]=+h[b+2624>>3]*+h[b+4144>>3]- +h[b+2632>>3]*+h[b+4136>>3];i=i;return}function ll(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4128>>3]=+h[b+2632>>3]*+h[b+4144>>3]+ +h[b+2624>>3]*+h[b+4136>>3];i=i;return}function ml(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;b=i;i=i+40|0;d=b;e=b+16|0;f=b+32|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;c[o>>2]=3;b2(p,16,1,o);o=a+536|0;y=a+416|0;z=c[y>>2]|0;Wl(q,c[o>>2]|0,+h[z+192>>3],+h[z+200>>3]);z=q;q=c[y>>2]|0;Wl(r,c[o>>2]|0,+h[q+208>>3],+h[q+216>>3]);q=r;r=c[y>>2]|0;Wl(s,c[o>>2]|0,+h[r+224>>3],+h[r+232>>3]);r=s;c[n>>2]=1;s=c2(p,16,1,n)|0;c[s+0>>2]=c[z+0>>2];c[s+4>>2]=c[z+4>>2];c[s+8>>2]=c[z+8>>2];c[s+12>>2]=c[z+12>>2];c[m>>2]=2;z=c2(p,16,1,m)|0;c[z+0>>2]=c[q+0>>2];c[z+4>>2]=c[q+4>>2];c[z+8>>2]=c[q+8>>2];c[z+12>>2]=c[q+12>>2];c[l>>2]=3;q=c2(p,16,1,l)|0;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];c[k>>2]=3;b2(t,16,1,k);k=a+4|0;a=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Wl(u,c[o>>2]|0,+h[a+4128>>3],+h[a+4120>>3]);a=u;u=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Wl(v,c[o>>2]|0,+h[u+4096>>3],+h[u+4088>>3]);u=v;v=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Wl(w,c[o>>2]|0,+h[v+4064>>3],+h[v+4056>>3]);v=w;c[j>>2]=1;w=c2(t,16,1,j)|0;c[w+0>>2]=c[a+0>>2];c[w+4>>2]=c[a+4>>2];c[w+8>>2]=c[a+8>>2];c[w+12>>2]=c[a+12>>2];c[g>>2]=2;a=c2(t,16,1,g)|0;c[a+0>>2]=c[u+0>>2];c[a+4>>2]=c[u+4>>2];c[a+8>>2]=c[u+8>>2];c[a+12>>2]=c[u+12>>2];c[f>>2]=3;u=c2(t,16,1,f)|0;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];v=c[o>>2]|0;o=e;u=p;c[o+0>>2]=c[u+0>>2];c[o+4>>2]=c[u+4>>2];c[o+8>>2]=c[u+8>>2];u=d;o=t;c[u+0>>2]=c[o+0>>2];c[u+4>>2]=c[o+4>>2];c[u+8>>2]=c[o+8>>2];Sl(x,v,e,d);A=+h[x+8>>3];d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[d+10016>>3]=+h[x>>3];h[d+10008>>3]=A;i=b;return}function nl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9824>>3]=+h[b+10016>>3];i=i;return}function ol(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9816>>3]=+h[b+10008>>3];i=i;return}function pl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1088>>3]=+h[b+1120>>3]*+h[b+1104>>3]+ +h[b+1112>>3]*+h[b+1096>>3];i=i;return}function ql(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1008>>3]=+h[b+1040>>3]*+h[b+1024>>3]+ +h[b+1032>>3]*+h[b+1016>>3];i=i;return}function rl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1048>>3]=+h[b+1080>>3]*+h[b+1064>>3]+ +h[b+1072>>3]*+h[b+1056>>3];i=i;return}function sl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9768>>3]=+h[b+1088>>3]+(+h[b+1008>>3]+ +h[b+1048>>3]);i=i;return}function tl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9760>>3]=+h[b+9776>>3]+ +h[b+9768>>3];i=i;return}function ul(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9728>>3]=-+h[b+1088>>3]- +h[b+1048>>3]- +h[b+1008>>3];i=i;return}function vl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9720>>3]=+h[b+9736>>3]+ +h[b+9728>>3];i=i;return}function wl(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4960>>3];e=+h[b+4952>>3];h[b+4912>>3]=+V(+(d*d+e*e));i=i;return}function xl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4904>>3]=+ba(+(+h[b+4952>>3]),+(+h[b+4960>>3]));i=i;return}function yl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9744>>3]=-(+h[b+2624>>3]*+h[b+2576>>3])- +h[b+2592>>3]*+h[b+2544>>3]- +h[b+2608>>3]*+h[b+2560>>3]- +h[b+2600>>3]*+h[b+2552>>3]- +h[b+2616>>3]*+h[b+2568>>3]- +h[b+2632>>3]*+h[b+2584>>3];i=i;return}function zl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+32>>3]=+h[b+9056>>3];i=i;return}function Al(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+40>>3]=+h[b+9048>>3];i=i;return}function Bl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((y5(+h[f+936>>3]*(+h[f+944>>3]- +h[f+928>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[30092]|0;g=d;j=1e3;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ae[a&63](f,d,960,e);i=b;return}function Cl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((y5(+h[f+360>>3]*(+h[f+336>>3]- +h[f+352>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[30092]|0;g=d;j=1e3;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ae[a&63](f,d,960,e);i=b;return}function Dl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((y5(+h[f+392>>3]*(+h[f+368>>3]- +h[f+384>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[30092]|0;g=d;j=1e3;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ae[a&63](f,d,960,e);i=b;return}function El(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((y5(+h[f+424>>3]*(+h[f+400>>3]- +h[f+416>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[30092]|0;g=d;j=1e3;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ae[a&63](f,d,960,e);i=b;return}function Fl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((y5(+h[f+552>>3]*(+h[f+1208>>3]- +h[f+544>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[30092]|0;g=d;j=1e3;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ae[a&63](f,d,960,e);i=b;return}function Gl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((y5(+h[f+584>>3]*(+h[f+1208>>3]- +h[f+576>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[30092]|0;g=d;j=1e3;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ae[a&63](f,d,960,e);i=b;return}function Hl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((y5(+h[f+616>>3]*(+h[f+1208>>3]- +h[f+608>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[30092]|0;g=d;j=1e3;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ae[a&63](f,d,960,e);i=b;return}function Il(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((y5(+h[f+792>>3]*(+h[f+1216>>3]- +h[f+784>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[30092]|0;g=d;j=1e3;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ae[a&63](f,d,960,e);i=b;return}function Jl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((y5(+h[f+824>>3]*(+h[f+1216>>3]- +h[f+816>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[30092]|0;g=d;j=1e3;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ae[a&63](f,d,960,e);i=b;return}function Kl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((y5(+h[f+856>>3]*(+h[f+1216>>3]- +h[f+848>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[30092]|0;g=d;j=1e3;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ae[a&63](f,d,960,e);i=b;return}function Ll(b){b=b|0;var c=0;c=i;a[b+315|0]=0;a[b+314|0]=1;We(b);Xe(b);Ye(b);Ze(b);_e(b);$e(b);af(b);bf(b);cf(b);df(b);ef(b);ff(b);gf(b);hf(b);jf(b);kf(b);lf(b);mf(b);nf(b);of(b);pf(b);qf(b);rf(b);sf(b);tf(b);uf(b);vf(b);wf(b);xf(b);yf(b);zf(b);Af(b);Bf(b);Cf(b);Df(b);Ef(b);Ff(b);Gf(b);Hf(b);If(b);Jf(b);Kf(b);Lf(b);Mf(b);Nf(b);Of(b);Pf(b);Qf(b);Rf(b);Sf(b);Tf(b);Uf(b);Vf(b);Wf(b);Xf(b);Yf(b);Zf(b);_f(b);$f(b);ag(b);bg(b);cg(b);dg(b);eg(b);fg(b);gg(b);hg(b);ig(b);jg(b);kg(b);lg(b);mg(b);ng(b);og(b);pg(b);qg(b);rg(b);sg(b);tg(b);ug(b);vg(b);wg(b);xg(b);yg(b);zg(b);Ag(b);Bg(b);Cg(b);Dg(b);Eg(b);Fg(b);Gg(b);Hg(b);Ig(b);Jg(b);Kg(b);Lg(b);Mg(b);Ng(b);Og(b);Pg(b);Qg(b);Rg(b);Sg(b);Tg(b);Ug(b);Vg(b);Wg(b);Xg(b);Yg(b);Zg(b);_g(b);$g(b);ah(b);bh(b);ch(b);dh(b);eh(b);fh(b);gh(b);hh(b);ih(b);jh(b);kh(b);lh(b);mh(b);nh(b);oh(b);ph(b);qh(b);rh(b);sh(b);th(b);uh(b);vh(b);wh(b);xh(b);yh(b);zh(b);Ah(b);Bh(b);Ch(b);Dh(b);Eh(b);Fh(b);Gh(b);Hh(b);Ih(b);Jh(b);Kh(b);Lh(b);Mh(b);Nh(b);Oh(b);Ph(b);Qh(b);Rh(b);Sh(b);Th(b);Uh(b);Vh(b);Wh(b);Xh(b);Yh(b);Zh(b);_h(b);$h(b);ai(b);bi(b);ci(b);di(b);ei(b);fi(b);gi(b);hi(b);ii(b);ji(b);ki(b);li(b);mi(b);ni(b);oi(b);pi(b);qi(b);ri(b);si(b);ti(b);ui(b);vi(b);wi(b);xi(b);yi(b);zi(b);Ai(b);Bi(b);Ci(b);Di(b);Ei(b);Fi(b);Gi(b);Hi(b);Ii(b);Ji(b);Ki(b);Li(b);Mi(b);Ni(b);Oi(b);Pi(b);Qi(b);Ri(b);Si(b);Ti(b);Ui(b);Vi(b);Wi(b);Xi(b);Yi(b);Zi(b);_i(b);$i(b);aj(b);bj(b);cj(b);dj(b);ej(b);fj(b);gj(b);hj(b);ij(b);jj(b);kj(b);lj(b);mj(b);nj(b);oj(b);pj(b);qj(b);rj(b);sj(b);tj(b);uj(b);vj(b);wj(b);xj(b);yj(b);zj(b);Aj(b);Bj(b);Cj(b);Dj(b);Ej(b);Fj(b);Gj(b);Hj(b);Ij(b);Jj(b);Kj(b);Lj(b);Mj(b);Nj(b);Oj(b);Pj(b);Qj(b);Rj(b);Sj(b);Tj(b);Uj(b);Vj(b);Wj(b);Xj(b);Yj(b);Zj(b);_j(b);$j(b);ak(b);bk(b);ck(b);dk(b);ek(b);fk(b);gk(b);hk(b);ik(b);jk(b);kk(b);lk(b);mk(b);nk(b);ok(b);pk(b);qk(b);rk(b);sk(b);tk(b);uk(b);vk(b);wk(b);xk(b);yk(b);zk(b);Ak(b);Bk(b);Ck(b);Dk(b);Ek(b);Fk(b);Gk(b);Hk(b);Ik(b);Jk(b);Kk(b);Lk(b);Mk(b);Nk(b);Ok(b);Pk(b);Qk(b);Rk(b);Sk(b);Tk(b);Uk(b);Vk(b);Wk(b);Xk(b);Yk(b);Zk(b);_k(b);$k(b);al(b);bl(b);cl(b);dl(b);el(b);fl(b);gl(b);hl(b);il(b);jl(b);kl(b);ll(b);ml(b);nl(b);ol(b);pl(b);ql(b);rl(b);sl(b);tl(b);ul(b);vl(b);wl(b);xl(b);yl(b);zl(b);Al(b);Bl(b);Cl(b);Dl(b);El(b);Fl(b);Gl(b);Hl(b);Il(b);Jl(b);Kl(b);i=c;return 0}function Ml(b){b=b|0;var c=0;c=i;a[b+314|0]=0;Nl(b);i=c;return 0}function Nl(a){a=a|0;var b=0;b=i;Al(a);zl(a);We(a);i=b;return}function Ol(a,b){a=a|0;b=+b;i=i;return 0}function Pl(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;Y1(c[a+536>>2]|0,(a|0)!=0|0,1232,b);c[a+540>>2]=1040;c[a+84>>2]=1264;c[a+88>>2]=1264;c[a+92>>2]=1344;c[a+96>>2]=1424;c[a+100>>2]=0;c[a+60>>2]=0;c[a+112>>2]=3;c[a+116>>2]=1445;d=a+136|0;e=a+120|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[d>>2]=155;c[a+140>>2]=482;c[a+144>>2]=15;c[a+148>>2]=2;c[a+152>>2]=0;c[a+156>>2]=0;c[a+232>>2]=5;c[a+216>>2]=3459;c[a+220>>2]=0;c[a+224>>2]=0;c[a+228>>2]=0;c[a+160>>2]=0;c[a+104>>2]=0;c[a+164>>2]=0;c[a+168>>2]=0;c[a+176>>2]=3;c[a+180>>2]=0;c[a+184>>2]=3;c[a+188>>2]=0;c[a+56>>2]=1464;c[a+64>>2]=13;c[a+72>>2]=0;c[a+68>>2]=2579;c[a+192>>2]=0;c[a+196>>2]=0;c[a+200>>2]=16;c[a+204>>2]=0;c[a+208>>2]=0;c[a+212>>2]=0;c[a+172>>2]=0;i=b;return}function Ql(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=i;e=i;i=i+168|0;c[e>>2]=0;f=i;i=i+544|0;g=i;i=i+88|0;h=i;i=i+160|0;j=i;i=i+160|0;u=0;Pa(3);k=u;u=0;if((k|0)!=0&(v|0)!=0){l=yxa(c[k>>2]|0,e)|0;if((l|0)==0){db(k|0,v|0)}J=v}else{l=-1}k=J;do{if((l|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=k}else if((l|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=k;D=7}else{E=72176;F=72200;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[E+12>>2]=c[F+12>>2];c[E+16>>2]=c[F+16>>2];c[E+20>>2]=c[F+20>>2];u=0;Pa(c[18044]|0);F=u;u=0;if((F|0)!=0&(v|0)!=0){G=yxa(c[F>>2]|0,e)|0;if((G|0)==0){db(F|0,v|0)}J=v}else{G=-1}F=J;if((G|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=F;break}else if((G|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=F;D=7;break}F=g;E=F+0|0;H=E+88|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(H|0));u=0;E=sa(98,c[17066]|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){I=yxa(c[H>>2]|0,e)|0;if((I|0)==0){db(H|0,v|0)}J=v}else{I=-1}H=J;if((I|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((I|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}u=0;Ha(47,c[17066]|0,F|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){K=yxa(c[H>>2]|0,e)|0;if((K|0)==0){db(H|0,v|0)}J=v}else{K=-1}H=J;if((K|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((K|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}H=h;c[g>>2]=h;kxa(h,2,e|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=yxa(c[L>>2]|0,e)|0;if((M|0)==0){db(L|0,v|0)}J=v}else{M=-1}L=J;if((M|0)==1){m=0;n=0;o=0;p=H;q=E;s=F;t=L;break}else if((M|0)==2){w=0;x=0;y=0;z=H;A=E;B=F;C=L;D=7;break}w=0;x=0;y=0;z=H;A=E;B=F;C=0;D=7}}while(0);while(1){if((D|0)==7){D=0;if((C|0)==0){M=j;h=g+4|0;K=c[h>>2]|0;c[h>>2]=j;kxa(j,1,e|0)|0;u=0;I=u;u=0;if((I|0)!=0&(v|0)!=0){N=yxa(c[I>>2]|0,e)|0;if((N|0)==0){db(I|0,v|0)}J=v}else{N=-1}I=J;if((N|0)==1){m=K;n=h;o=M;p=z;q=A;s=B;t=I;continue}else if((N|0)==2){O=B;P=A;Q=z;w=K;x=h;y=M;C=I;B=O;A=P;z=Q;D=7;continue}m=K;n=h;o=M;p=z;q=A;s=B;t=0;continue}else{u=0;Ha(47,c[17066]|0,A|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){R=yxa(c[M>>2]|0,e)|0;if((R|0)==0){db(M|0,v|0)}J=v}else{R=-1}M=J;if((R|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((R|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){V=yxa(c[M>>2]|0,e)|0;if((V|0)==0){db(M|0,v|0)}J=v}else{V=-1}M=J;if((V|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((V|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}else{D=18;break}}}if((t|0)!=0){u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){W=yxa(c[M>>2]|0,e)|0;if((W|0)==0){db(M|0,v|0)}J=v}else{W=-1}M=J;if((W|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((W|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}M=c[r>>2]|0;u=0;Ra(35,1552,154,1,M|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ba=yxa(c[M>>2]|0,e)|0;if((ba|0)==0){db(M|0,v|0)}J=v}else{ba=-1}M=J;if((ba|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ba|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ca=yxa(c[M>>2]|0,e)|0;if((ca|0)==0){db(M|0,v|0)}J=v}else{ca=-1}M=J;if((ca|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ca|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;sa(99,0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){da=yxa(c[M>>2]|0,e)|0;if((da|0)==0){db(M|0,v|0)}J=v}else{da=-1}M=J;if((da|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((da|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}else{D=15;break}}u=0;pa(137,f|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ea=yxa(c[M>>2]|0,e)|0;if((ea|0)==0){db(M|0,v|0)}J=v}else{ea=-1}M=J;if((ea|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ea|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}c[f+536>>2]=g;u=0;M=va(31,a|0,b|0,f|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){fa=yxa(c[h>>2]|0,e)|0;if((fa|0)==0){db(h|0,v|0)}J=v}else{fa=-1}h=J;if((fa|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((fa|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}c[n>>2]=m;u=0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ga=yxa(c[h>>2]|0,e)|0;if((ga|0)==0){db(h|0,v|0)}J=v}else{ga=-1}h=J;if((ga|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ga|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;Ha(47,c[17066]|0,q|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ha=yxa(c[h>>2]|0,e)|0;if((ha|0)==0){db(h|0,v|0)}J=v}else{ha=-1}h=J;if((ha|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ha|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ia=yxa(c[h>>2]|0,e)|0;if((ia|0)==0){db(h|0,v|0)}J=v}else{ia=-1}h=J;if((ia|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ia|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ja=yxa(c[h>>2]|0,e)|0;if((ja|0)==0){db(h|0,v|0)}J=v}else{ja=-1}h=J;if((ja|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ja|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;pa(138,M|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ka=yxa(c[M>>2]|0,e)|0;if((ka|0)==0){db(M|0,v|0)}J=v}else{ka=-1}M=J;if((ka|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa}else if((ka|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7}else{D=26;break}}if((D|0)==15){la=p;ma=s;i=d;return 1}else if((D|0)==18){la=z;ma=B;i=d;return 1}return 0}function Rl(){var a=0;a=i;nd(0)|0;qc(1712,18,1,c[r>>2]|0)|0;nd(0)|0;i=a;return}function Sl(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0;f=i;i=i+72|0;g=f;j=f+16|0;k=f+32|0;l=f+48|0;m=f+64|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=o;s=o+8|0;t=o;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;t=L1(d,1)|0;if((t|0)<1){u=o;v=a;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[v+12>>2]=c[u+12>>2];i=f;return}if((Tl(1,t)|0)==0){u=o;v=a;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[v+12>>2]=c[u+12>>2];i=f;return}w=p;x=q;y=q+8|0;z=1;do{c[n>>2]=z;A=c2(d,16,1,n)|0;c[m>>2]=z;B=c2(e,16,1,m)|0;C=l;D=A;c[C+0>>2]=c[D+0>>2];c[C+4>>2]=c[D+4>>2];c[C+8>>2]=c[D+8>>2];c[C+12>>2]=c[D+12>>2];D=k;C=B;c[D+0>>2]=c[C+0>>2];c[D+4>>2]=c[C+4>>2];c[D+8>>2]=c[C+8>>2];c[D+12>>2]=c[C+12>>2];Ul(p,b,l,k);C=j;D=o;c[C+0>>2]=c[D+0>>2];c[C+4>>2]=c[D+4>>2];c[C+8>>2]=c[D+8>>2];c[C+12>>2]=c[D+12>>2];D=g;C=w;c[D+0>>2]=c[C+0>>2];c[D+4>>2]=c[C+4>>2];c[D+8>>2]=c[C+8>>2];c[D+12>>2]=c[C+12>>2];Vl(q,b,j,g);E=+h[y>>3];h[r>>3]=+h[x>>3];h[s>>3]=E;z=z+1|0;}while((Tl(z,t)|0)!=0);u=o;v=a;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[v+12>>2]=c[u+12>>2];i=f;return}function Tl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;if((b|0)>0){if((a|0)<1|(a|0)>(b|0)){d=4}else{e=1}}else{if((a|0)>=(b|0)&(a|0)<2){e=1}else{d=4}}if((d|0)==4){e=0}i=c;return e|0}function Ul(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,j=0.0,k=0.0;b=i;i=i+16|0;e=b;f=+h[c>>3];g=+h[d>>3];j=+h[c+8>>3];k=+h[d+8>>3];Wl(e,0,f*g-j*k,g*j+f*k);k=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=k;i=b;return}function Vl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0;b=i;i=i+16|0;e=b;Wl(e,0,+h[c>>3]+ +h[d>>3],+h[c+8>>3]+ +h[d+8>>3]);f=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=f;i=b;return}function Wl(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;h[a>>3]=c;h[a+8>>3]=d;i=i;return}function Xl(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;b=i;Wl(a,0,c,d);i=b;return}function Yl(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=o;c[n>>2]=d;b3(C,1,n);c[m>>2]=d;b3(p,1,m);if((Zl(d)|0)==0){if((d|0)==2){c[l>>2]=1;h[(k3(p,1,l)|0)>>3]=0.0;c[k>>2]=2;h[(k3(p,1,k)|0)>>3]=1.570796326794897;d3(p,C);D=a;E=o;c[D+0>>2]=c[E+0>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];i=e;return}else{F=+(d|0);k=~~+T(+(F*.5));Yl(q,b,k);i2(r,1,1,k);l=_l(r)|0;m=n2(r)|0;c[j>>2]=l;c[j+4>>2]=m;c[j+8>>2]=65;e2(s,1,j);h3(q,p,s);Yl(t,b,k);c[g>>2]=k;p3(u,3.141592653589793/F,1,g);o3(t,u,v);i2(w,k+1|0,1,d);k=_l(w)|0;u=n2(w)|0;c[f>>2]=k;c[f+4>>2]=u;c[f+8>>2]=65;e2(x,1,f);h3(v,p,x);d3(p,C);D=a;E=o;c[D+0>>2]=c[E+0>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];i=e;return}}else{i2(A,1,1,d);x=z;v=A;c[x+0>>2]=c[v+0>>2];c[x+4>>2]=c[v+4>>2];c[x+8>>2]=c[v+8>>2];a3(B,L1(z,1)|0);if((_l(z)|0)>=1){F=+(d|0);d=1;while(1){G=+((c[(m2(z,1,d)|0)>>2]<<1)+ -2|0)/F*3.141592653589793;h[(j3(B,1,d)|0)>>3]=G;if((d|0)<(_l(z)|0)){d=d+1|0}else{break}}}d=y;z=B;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];f3(y,p);d3(p,C);D=a;E=o;c[D+0>>2]=c[E+0>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];i=e;return}}function Zl(a){a=a|0;i=i;return(a|0)%2|0|0}function _l(a){a=a|0;var b=0,c=0;b=i;c=L1(a,1)|0;i=b;return c|0}function $l(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;h[a>>3]=c;h[a+8>>3]=d;i=i;return}function am(a){a=a|0;var b=0;a=i;i=i+8|0;b=i;i=i+8|0;V1(4,0,1736,b);V1(4,0,1776,a);i=a;return}function bm(a){a=a|0;var b=0,d=0;b=i;d=a+320|0;a=c[d>>2]|0;if((a|0)==0){i=b;return}Kwa(a);c[d>>2]=0;i=b;return}function cm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+556>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+5536>>3],+h[j+5528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5632>>3]=l;h[e+5624>>3]=m;i=b;return}function dm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+556>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+5536>>3],+h[j+5528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5616>>3]=l;h[e+5608>>3]=m;i=b;return}function em(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+544>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+5504>>3],+h[j+5496>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5664>>3]=l;h[e+5656>>3]=m;i=b;return}function fm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5568>>3]=+h[b+5760>>3]- +h[b+5616>>3]- +h[b+5664>>3];i=i;return}function gm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5560>>3]=+h[b+5752>>3]- +h[b+5608>>3]- +h[b+5656>>3];i=i;return}function hm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+556>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+5536>>3],+h[j+5528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5600>>3]=l;h[e+5592>>3]=m;i=b;return}function im(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+544>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+5504>>3],+h[j+5496>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5648>>3]=l;h[e+5640>>3]=m;i=b;return}function jm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5552>>3]=+h[b+5744>>3]- +h[b+5600>>3]- +h[b+5648>>3];i=i;return}function km(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5544>>3]=+h[b+5736>>3]- +h[b+5592>>3]- +h[b+5640>>3];i=i;return}function lm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+544>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+5504>>3],+h[j+5496>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5680>>3]=l;h[e+5672>>3]=m;i=b;return}function mm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5576>>3]=+h[b+5768>>3]- +h[b+5624>>3]- +h[b+5672>>3];i=i;return}function nm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5584>>3]=+h[b+5776>>3]- +h[b+5632>>3]- +h[b+5680>>3];i=i;return}function om(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+568>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+5520>>3],+h[j+5512>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11552>>3]=l;h[e+11544>>3]=m;i=b;return}function pm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+568>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+5520>>3],+h[j+5512>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11536>>3]=l;h[e+11528>>3]=m;i=b;return}function qm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+568>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+5520>>3],+h[j+5512>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11520>>3]=l;h[e+11512>>3]=m;i=b;return}function rm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+77360>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+77336>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+77344>>3];h[a+8>>3]=+h[d+77584>>3];h[e+8>>3]=+h[d+77560>>3];h[f+8>>3]=+h[d+77568>>3];h[a+16>>3]=+h[d+77136>>3];h[e+16>>3]=+h[d+77112>>3];h[f+16>>3]=+h[d+77120>>3];h[a+24>>3]=+h[d+77248>>3];h[e+24>>3]=+h[d+77224>>3];h[f+24>>3]=+h[d+77232>>3];h[a+32>>3]=+h[d+77472>>3];h[e+32>>3]=+h[d+77448>>3];h[f+32>>3]=+h[d+77456>>3];h[a+40>>3]=+h[d+77024>>3];h[e+40>>3]=+h[d+77e3>>3];h[f+40>>3]=+h[d+77008>>3];i=i;return}



function Fba(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+192|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+8|0;$=i;i=i+16|0;aa=i;i=i+8|0;ba=i;i=i+16|0;ca=i;i=i+8|0;da=i;i=i+16|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+16|0;qa=i;i=i+8|0;ra=i;i=i+16|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+16|0;wa=i;i=i+8|0;xa=i;i=i+16|0;ya=i;i=i+8|0;za=i;i=i+16|0;Aa=i;i=i+8|0;Ba=i;i=i+16|0;Ca=i;i=i+8|0;Da=i;i=i+16|0;Ea=i;i=i+8|0;Fa=i;i=i+16|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;Ka=i;i=i+8|0;La=i;i=i+16|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+16|0;Sa=i;i=i+8|0;Ta=i;i=i+16|0;Ua=i;i=i+8|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;Ya=i;i=i+8|0;Za=i;i=i+16|0;_a=i;i=i+8|0;$a=i;i=i+16|0;ab=i;i=i+8|0;bb=i;i=i+16|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+8|0;fb=i;i=i+16|0;gb=i;i=i+8|0;hb=i;i=i+16|0;ib=i;i=i+8|0;jb=i;i=i+16|0;kb=i;i=i+8|0;lb=i;i=i+16|0;mb=i;i=i+8|0;nb=i;i=i+16|0;ob=i;i=i+8|0;pb=i;i=i+16|0;qb=i;i=i+8|0;rb=i;i=i+16|0;sb=i;i=i+8|0;tb=i;i=i+16|0;ub=i;i=i+8|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+8|0;zb=i;i=i+16|0;Ab=i;i=i+8|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;Gb=i;i=i+8|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+8|0;Lb=i;i=i+16|0;Mb=i;i=i+8|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+8|0;Rb=i;i=i+16|0;Sb=i;i=i+8|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+8|0;_b=i;i=i+16|0;$b=i;i=i+8|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;Pba(o,p);p=(d|0)!=0;dc=(e|0)==0;if(!(dc|p^1)){Z1(0,117392,n)}if(p){ec=sd(d|0)|0}else{ec=0}if(dc){fc=ec}else{c[m>>2]=e;V1(23,0,117536,m);Qba(q);Rba(q,e,8);if(!(Sba(q)|0)){c[l>>2]=e;Z1(0,117576,l)}sma(r);l=q;Tba(l,r)|0;uma(s,r);while(1){e=Tba(l,r)|0;if(!(ona(e+(c[(c[e>>2]|0)+ -12>>2]|0)|0)|0)){break}nna(t,117656,r);Vma(s,t)|0;Ema(t)}t=sd($ma(s)|0)|0;Uba(q);Ema(s);Ema(r);Vba(q);fc=t}if((fc|0)==0){V1(23,0,117744,g);Xba(o);i=f;return}sma(u);sma(v);c[k>>2]=fc;V1(23,0,117664,k);k=Wb(fc|0,117656)|0;if((k|0)!=0){g=k;do{k=Pwa(12)|0;yma(k,g);t=ana(k,117696,0)|0;_ma(w,k,0,t);Fma(u,w)|0;Ema(w);_ma(x,k,t+1|0,(Lma(k)|0)+~t|0);Fma(v,x)|0;Ema(x);Fma(nba(o,u)|0,v)|0;t=$ma(u)|0;k=$ma(v)|0;c[j>>2]=t;c[j+4>>2]=k;V1(23,0,117704,j);g=Wb(0,117656)|0;}while((g|0)!=0)}Kwa(fc);fc=a+12|0;yma(y,115792);g=nba(fc,y)|0;yma(z,115792);if((Wba(o,z)|0)==0){yma(B,115792);gc=1;hc=0;ic=nba(fc,B)|0}else{yma(A,115792);gc=0;hc=1;ic=nba(o,A)|0}Fma(g,ic)|0;if(gc){Ema(B)}if(hc){Ema(A)}Ema(z);Ema(y);yma(C,115664);y=nba(fc,C)|0;yma(D,115664);if((Wba(o,D)|0)==0){yma(F,115664);jc=1;kc=0;lc=nba(fc,F)|0}else{yma(E,115664);jc=0;kc=1;lc=nba(o,E)|0}Fma(y,lc)|0;if(jc){Ema(F)}if(kc){Ema(E)}Ema(D);Ema(C);yma(G,115696);C=nba(fc,G)|0;yma(H,115696);if((Wba(o,H)|0)==0){yma(J,115696);mc=1;nc=0;oc=nba(fc,J)|0}else{yma(I,115696);mc=0;nc=1;oc=nba(o,I)|0}Fma(C,oc)|0;if(mc){Ema(J)}if(nc){Ema(I)}Ema(H);Ema(G);yma(K,115728);G=nba(fc,K)|0;yma(L,115728);if((Wba(o,L)|0)==0){yma(N,115728);pc=0;qc=1;rc=nba(fc,N)|0}else{yma(M,115728);pc=1;qc=0;rc=nba(o,M)|0}Fma(G,rc)|0;if(qc){Ema(N)}if(pc){Ema(M)}Ema(L);Ema(K);yma(O,115760);K=nba(fc,O)|0;yma(P,115760);if((Wba(o,P)|0)==0){yma(R,115760);sc=1;tc=0;uc=nba(fc,R)|0}else{yma(Q,115760);sc=0;tc=1;uc=nba(o,Q)|0}Fma(K,uc)|0;if(sc){Ema(R)}if(tc){Ema(Q)}Ema(P);Ema(O);yma(S,115824);O=nba(fc,S)|0;yma(T,115824);if((Wba(o,T)|0)==0){yma(V,115824);vc=1;wc=0;xc=nba(fc,V)|0}else{yma(U,115824);vc=0;wc=1;xc=nba(o,U)|0}Fma(O,xc)|0;if(vc){Ema(V)}if(wc){Ema(U)}Ema(T);Ema(S);yma(W,115864);S=nba(fc,W)|0;yma(X,115864);if((Wba(o,X)|0)==0){yma(Z,115864);yc=1;zc=0;Ac=nba(fc,Z)|0}else{yma(Y,115864);yc=0;zc=1;Ac=nba(o,Y)|0}Fma(S,Ac)|0;if(yc){Ema(Z)}if(zc){Ema(Y)}Ema(X);Ema(W);W=b+104|0;X=c[W>>2]|0;if((X|0)>0){Y=a+24|0;zc=a+36|0;Z=0;while(1){c[_>>2]=Z;yc=Gba(Y,_)|0;yma($,114768);Ac=nba(yc,$)|0;c[aa>>2]=Z;yc=Gba(Y,aa)|0;yma(ba,114624);if((Wba(o,nba(yc,ba)|0)|0)==0){c[ea>>2]=Z;yc=Gba(Y,ea)|0;yma(fa,114768);Bc=1;Cc=0;Dc=nba(yc,fa)|0}else{c[ca>>2]=Z;yc=Gba(Y,ca)|0;yma(da,114624);Bc=0;Cc=1;Dc=nba(o,nba(yc,da)|0)|0}Fma(Ac,Dc)|0;if(Bc){Ema(fa)}if(Cc){Ema(da)}Ema(ba);Ema($);c[ga>>2]=Z;Ac=Gba(zc,ga)|0;yma(ha,114768);yc=nba(Ac,ha)|0;c[ia>>2]=Z;Ac=Gba(zc,ia)|0;yma(ja,114624);if((Wba(o,nba(Ac,ja)|0)|0)==0){c[ma>>2]=Z;Ac=Gba(zc,ma)|0;yma(na,114768);Ec=1;Fc=0;Gc=nba(Ac,na)|0}else{c[ka>>2]=Z;Ac=Gba(zc,ka)|0;yma(la,114624);Ec=0;Fc=1;Gc=nba(o,nba(Ac,la)|0)|0}Fma(yc,Gc)|0;if(Ec){Ema(na)}if(Fc){Ema(la)}Ema(ja);Ema(ha);yc=Z+1|0;Ac=c[W>>2]|0;if((yc|0)<(Ac|0)){Z=yc}else{Hc=Ac;break}}}else{Hc=X}X=b+108|0;if(((c[X>>2]|0)-(Hc<<1)|0)>0){Hc=a+48|0;Z=0;do{c[oa>>2]=Z;ha=Gba(Hc,oa)|0;yma(pa,114768);ja=nba(ha,pa)|0;c[qa>>2]=Z;ha=Gba(Hc,qa)|0;yma(ra,114624);if((Wba(o,nba(ha,ra)|0)|0)==0){c[ua>>2]=Z;ha=Gba(Hc,ua)|0;yma(va,114768);Ic=1;Jc=0;Kc=nba(ha,va)|0}else{c[sa>>2]=Z;ha=Gba(Hc,sa)|0;yma(ta,114624);Ic=0;Jc=1;Kc=nba(o,nba(ha,ta)|0)|0}Fma(ja,Kc)|0;if(Ic){Ema(va)}if(Jc){Ema(ta)}Ema(ra);Ema(pa);Z=Z+1|0;}while((Z|0)<((c[X>>2]|0)-(c[W>>2]<<1)|0))}W=b+116|0;if((c[W>>2]|0)>0){X=a+84|0;Z=0;do{c[wa>>2]=Z;pa=Gba(X,wa)|0;yma(xa,114768);ra=nba(pa,xa)|0;c[ya>>2]=Z;pa=Gba(X,ya)|0;yma(za,114624);if((Wba(o,nba(pa,za)|0)|0)==0){c[Ca>>2]=Z;pa=Gba(X,Ca)|0;yma(Da,114768);Lc=1;Mc=0;Nc=nba(pa,Da)|0}else{c[Aa>>2]=Z;pa=Gba(X,Aa)|0;yma(Ba,114624);Lc=0;Mc=1;Nc=nba(o,nba(pa,Ba)|0)|0}Fma(ra,Nc)|0;if(Lc){Ema(Da)}if(Mc){Ema(Ba)}Ema(za);Ema(xa);Z=Z+1|0;}while((Z|0)<(c[W>>2]|0))}W=b+120|0;if((c[W>>2]|0)>0){Z=a+120|0;xa=0;do{c[Ea>>2]=xa;za=Gba(Z,Ea)|0;yma(Fa,114768);Ba=nba(za,Fa)|0;c[Ga>>2]=xa;za=Gba(Z,Ga)|0;yma(Ha,114624);if((Wba(o,nba(za,Ha)|0)|0)==0){c[Ka>>2]=xa;za=Gba(Z,Ka)|0;yma(La,114768);Oc=1;Pc=0;Qc=nba(za,La)|0}else{c[Ia>>2]=xa;za=Gba(Z,Ia)|0;yma(Ja,114624);Oc=0;Pc=1;Qc=nba(o,nba(za,Ja)|0)|0}Fma(Ba,Qc)|0;if(Oc){Ema(La)}if(Pc){Ema(Ja)}Ema(Ha);Ema(Fa);xa=xa+1|0;}while((xa|0)<(c[W>>2]|0))}W=b+124|0;if((c[W>>2]|0)>0){xa=a+156|0;Fa=0;do{c[Ma>>2]=Fa;Ha=Gba(xa,Ma)|0;yma(Na,114768);Ja=nba(Ha,Na)|0;c[Oa>>2]=Fa;Ha=Gba(xa,Oa)|0;yma(Pa,114624);if((Wba(o,nba(Ha,Pa)|0)|0)==0){c[Sa>>2]=Fa;Ha=Gba(xa,Sa)|0;yma(Ta,114768);Rc=1;Sc=0;Tc=nba(Ha,Ta)|0}else{c[Qa>>2]=Fa;Ha=Gba(xa,Qa)|0;yma(Ra,114624);Rc=0;Sc=1;Tc=nba(o,nba(Ha,Ra)|0)|0}Fma(Ja,Tc)|0;if(Rc){Ema(Ta)}if(Sc){Ema(Ra)}Ema(Pa);Ema(Na);Fa=Fa+1|0;}while((Fa|0)<(c[W>>2]|0))}W=b+128|0;if((c[W>>2]|0)>0){Fa=a+60|0;Na=0;do{c[Ua>>2]=Na;Pa=Gba(Fa,Ua)|0;yma(Va,114768);Ra=nba(Pa,Va)|0;c[Wa>>2]=Na;Pa=Gba(Fa,Wa)|0;yma(Xa,114624);if((Wba(o,nba(Pa,Xa)|0)|0)==0){c[_a>>2]=Na;Pa=Gba(Fa,_a)|0;yma($a,114768);Uc=1;Vc=0;Wc=nba(Pa,$a)|0}else{c[Ya>>2]=Na;Pa=Gba(Fa,Ya)|0;yma(Za,114624);Uc=0;Vc=1;Wc=nba(o,nba(Pa,Za)|0)|0}Fma(Ra,Wc)|0;if(Uc){Ema($a)}if(Vc){Ema(Za)}Ema(Xa);Ema(Va);Na=Na+1|0;}while((Na|0)<(c[W>>2]|0))}W=b+132|0;if((c[W>>2]|0)>0){Na=a+96|0;Va=0;do{c[ab>>2]=Va;Xa=Gba(Na,ab)|0;yma(bb,114768);Za=nba(Xa,bb)|0;c[cb>>2]=Va;Xa=Gba(Na,cb)|0;yma(db,114624);if((Wba(o,nba(Xa,db)|0)|0)==0){c[gb>>2]=Va;Xa=Gba(Na,gb)|0;yma(hb,114768);Xc=1;Yc=0;Zc=nba(Xa,hb)|0}else{c[eb>>2]=Va;Xa=Gba(Na,eb)|0;yma(fb,114624);Xc=0;Yc=1;Zc=nba(o,nba(Xa,fb)|0)|0}Fma(Za,Zc)|0;if(Xc){Ema(hb)}if(Yc){Ema(fb)}Ema(db);Ema(bb);Va=Va+1|0;}while((Va|0)<(c[W>>2]|0))}W=b+136|0;if((c[W>>2]|0)>0){Va=a+132|0;bb=0;do{c[ib>>2]=bb;db=Gba(Va,ib)|0;yma(jb,114768);fb=nba(db,jb)|0;c[kb>>2]=bb;db=Gba(Va,kb)|0;yma(lb,114624);if((Wba(o,nba(db,lb)|0)|0)==0){c[ob>>2]=bb;db=Gba(Va,ob)|0;yma(pb,114768);_c=1;$c=0;ad=nba(db,pb)|0}else{c[mb>>2]=bb;db=Gba(Va,mb)|0;yma(nb,114624);_c=0;$c=1;ad=nba(o,nba(db,nb)|0)|0}Fma(fb,ad)|0;if(_c){Ema(pb)}if($c){Ema(nb)}Ema(lb);Ema(jb);bb=bb+1|0;}while((bb|0)<(c[W>>2]|0))}W=b+140|0;if((c[W>>2]|0)>0){bb=a+168|0;jb=0;do{c[qb>>2]=jb;lb=Gba(bb,qb)|0;yma(rb,114768);nb=nba(lb,rb)|0;c[sb>>2]=jb;lb=Gba(bb,sb)|0;yma(tb,114624);if((Wba(o,nba(lb,tb)|0)|0)==0){c[wb>>2]=jb;lb=Gba(bb,wb)|0;yma(xb,114768);bd=1;cd=0;dd=nba(lb,xb)|0}else{c[ub>>2]=jb;lb=Gba(bb,ub)|0;yma(vb,114624);bd=0;cd=1;dd=nba(o,nba(lb,vb)|0)|0}Fma(nb,dd)|0;if(bd){Ema(xb)}if(cd){Ema(vb)}Ema(tb);Ema(rb);jb=jb+1|0;}while((jb|0)<(c[W>>2]|0))}W=b+208|0;if((c[W>>2]|0)>0){jb=a+72|0;rb=0;do{c[yb>>2]=rb;tb=Gba(jb,yb)|0;yma(zb,114768);vb=nba(tb,zb)|0;c[Ab>>2]=rb;tb=Gba(jb,Ab)|0;yma(Bb,114624);if((Wba(o,nba(tb,Bb)|0)|0)==0){c[Eb>>2]=rb;tb=Gba(jb,Eb)|0;yma(Fb,114768);ed=1;fd=0;gd=nba(tb,Fb)|0}else{c[Cb>>2]=rb;tb=Gba(jb,Cb)|0;yma(Db,114624);ed=0;fd=1;gd=nba(o,nba(tb,Db)|0)|0}Fma(vb,gd)|0;if(ed){Ema(Fb)}if(fd){Ema(Db)}Ema(Bb);Ema(zb);rb=rb+1|0;}while((rb|0)<(c[W>>2]|0))}W=b+212|0;if((c[W>>2]|0)>0){rb=a+108|0;zb=0;do{c[Gb>>2]=zb;Bb=Gba(rb,Gb)|0;yma(Hb,114768);Db=nba(Bb,Hb)|0;c[Ib>>2]=zb;Bb=Gba(rb,Ib)|0;yma(Jb,114624);if((Wba(o,nba(Bb,Jb)|0)|0)==0){c[Mb>>2]=zb;Bb=Gba(rb,Mb)|0;yma(Nb,114768);hd=0;id=1;jd=nba(Bb,Nb)|0}else{c[Kb>>2]=zb;Bb=Gba(rb,Kb)|0;yma(Lb,114624);hd=1;id=0;jd=nba(o,nba(Bb,Lb)|0)|0}Fma(Db,jd)|0;if(id){Ema(Nb)}if(hd){Ema(Lb)}Ema(Jb);Ema(Hb);zb=zb+1|0;}while((zb|0)<(c[W>>2]|0))}W=b+216|0;if((c[W>>2]|0)>0){zb=a+144|0;Hb=0;do{c[Ob>>2]=Hb;Jb=Gba(zb,Ob)|0;yma(Pb,114768);Lb=nba(Jb,Pb)|0;c[Qb>>2]=Hb;Jb=Gba(zb,Qb)|0;yma(Rb,114624);if((Wba(o,nba(Jb,Rb)|0)|0)==0){c[Ub>>2]=Hb;Jb=Gba(zb,Ub)|0;yma(Vb,114768);kd=1;ld=0;md=nba(Jb,Vb)|0}else{c[Sb>>2]=Hb;Jb=Gba(zb,Sb)|0;yma(Tb,114624);kd=0;ld=1;md=nba(o,nba(Jb,Tb)|0)|0}Fma(Lb,md)|0;if(kd){Ema(Vb)}if(ld){Ema(Tb)}Ema(Rb);Ema(Pb);Hb=Hb+1|0;}while((Hb|0)<(c[W>>2]|0))}W=b+220|0;if((c[W>>2]|0)>0){b=a+180|0;a=0;do{c[Xb>>2]=a;Hb=Gba(b,Xb)|0;yma(Yb,114768);Pb=nba(Hb,Yb)|0;c[Zb>>2]=a;Hb=Gba(b,Zb)|0;yma(_b,114624);if((Wba(o,nba(Hb,_b)|0)|0)==0){c[bc>>2]=a;Hb=Gba(b,bc)|0;yma(cc,114768);nd=1;od=0;pd=nba(Hb,cc)|0}else{c[$b>>2]=a;Hb=Gba(b,$b)|0;yma(ac,114624);nd=0;od=1;pd=nba(o,nba(Hb,ac)|0)|0}Fma(Pb,pd)|0;if(nd){Ema(cc)}if(od){Ema(ac)}Ema(_b);Ema(Yb);a=a+1|0;}while((a|0)<(c[W>>2]|0))}V1(23,0,117728,h);Ema(v);Ema(u);Xba(o);i=f;return}function Gba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=lea(a,f,b)|0;l=c[k>>2]|0;Z7(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}nea(j,a,b);oea(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];mea(g,e);pea(j);j=c[f>>2]|0;qea(a,j,k,rea(g)|0);k=sea(g)|0;pea(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function Hba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=Pca(a,f,b)|0;l=c[k>>2]|0;Z7(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}Rca(j,a,b);Sca(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];Qca(g,e);Tca(j);j=c[f>>2]|0;Uca(a,j,k,Vca(g)|0);k=Wca(g)|0;Tca(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function Iba(a,b){a=a|0;b=b|0;var c=0;c=i;Fma(b,a)|0;i=c;return}function Jba(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;Gca(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];yca(a,f);i=e;return}function Kba(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=wca(a,b)|0;i=c;return d|0}function Lba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;zca(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];yca(a,e);i=d;return}function Mba(a){a=a|0;var b=0,c=0;b=i;c=tca(a)|0;i=b;return c|0}function Nba(a){a=a|0;var b=0;b=i;Sga(a);i=b;return}function Oba(a){a=a|0;var b=0;b=i;Fga(a);i=b;return}function Pba(a,b){a=a|0;b=b|0;b=i;mfa(a,0);i=b;return}function Qba(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+108|0;Bna(d);e=a;c[e>>2]=117796;f=d;c[f>>2]=117816;d=a+8|0;toa(a,117828|0,d);c[e>>2]=117796;c[f>>2]=117816;Gaa(d);i=b;return}function Rba(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(f8(a+8|0,b,d|8)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){sna(d,4);i=e;return}else{qna(d,0);i=e;return}}function Sba(a){a=a|0;var b=0,c=0;b=i;c=oca(a+8|0)|0;i=b;return c|0}function Tba(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=nca(a,b,zna(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;i=d;return e|0}function Uba(a){a=a|0;var b=0;b=i;if((h8(a+8|0)|0)!=0){i=b;return}sna(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function Vba(a){a=a|0;var b=0;b=i;sca(a,117824);wna(a+108|0);i=b;return}function Wba(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Yba(a,b)|0;i=c;return d|0}function Xba(a){a=a|0;var b=0;b=i;uga(a);i=b;return}function Yba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d;f=_ba(a)|0;Z7(e);if((f|0)==0){g=0;i=d;return g|0}h=$ba(a)|0;a=f;while(1){f=a+16|0;if(aca(h,b,f)|0){j=a}else{if(!(bca(h,f,b)|0)){g=1;k=8;break}j=a+4|0}f=c[j>>2]|0;Z7(e);if((f|0)==0){g=0;k=8;break}else{a=f}}if((k|0)==8){i=d;return g|0}return 0}function Zba(a){a=a|0;var b=0,c=0;b=i;c=K7(hca(a+4|0)|0)|0;i=b;return c|0}function _ba(a){a=a|0;var b=0,d=0;b=i;d=c[(Zba(a)|0)>>2]|0;i=b;return d|0}function $ba(a){a=a|0;var b=0,c=0;b=i;c=fca(a+8|0)|0;i=b;return c|0}function aca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=cca(0,b,c)|0;i=a;return d|0}function bca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=cca(0,b,c)|0;i=a;return d|0}function cca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=dca(b,c)|0;i=a;return d|0}function dca(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(bna(a,b)|0)<0;i=c;return d|0}function eca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=gxa(a,b,c)|0;i=d;return e|0}function fca(a){a=a|0;var b=0,c=0;b=i;c=gca(a)|0;i=b;return c|0}function gca(a){a=a|0;i=i;return a|0}function hca(a){a=a|0;var b=0,c=0;b=i;c=ica(a)|0;i=b;return c|0}function ica(a){a=a|0;i=i;return a|0}function jca(a,b){a=a|0;b=b|0;var c=0;a=i;c=lca(0,b,0)|0;i=a;return c|0}function kca(b,c){b=b|0;c=c|0;a[b]=a[c]|0;i=i;return}function lca(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Pwa(b)|0;i=c;return a|0}function mca(a){a=a|0;var b=0,c=0;b=i;c=lxa(a|0)|0;i=b;return c|0}function nca(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;yoa(f,a,1);if(!(Boa(f)|0)){i=e;return a|0}Uma(b);f=0;while(1){g=Hna(xna(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0)|0)|0;if(T8(g,-1)|0){h=2;j=f;break}k=f+1|0;l=U8(g)|0;if(Y8(l,d)|0){h=0;j=k;break}Wma(b,l);if((Cma(b)|0)==-17){h=4;j=k;break}else{f=k}}sna(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,(j|0)==0?h|4:h);i=e;return a|0}function oca(a){a=a|0;i=i;return(c[a+64>>2]|0)!=0|0}function pca(a){a=a|0;var b=0;b=i;Vba(a);Rwa(a);i=b;return}function qca(a){a=a|0;var b=0;b=i;Vba(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function rca(a){a=a|0;var b=0;b=i;pca(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function sca(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];H8(a+8|0);i=d;return}function tca(a){a=a|0;var b=0,d=0;b=i;d=uca((c[a>>2]|0)+16|0)|0;i=b;return d|0}function uca(a){a=a|0;var b=0,c=0;b=i;c=vca(a)|0;i=b;return c|0}function vca(a){a=a|0;i=i;return a|0}function wca(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(xca(a,b)|0)^1;i=c;return d|0}function xca(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function yca(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Fca(a,e);i=d;return}function zca(a,b){a=a|0;b=b|0;var c=0;c=i;Aca(a,Bca(b)|0);i=c;return}function Aca(a,b){a=a|0;b=b|0;var c=0;c=i;Eca(a,b);i=c;return}function Bca(a){a=a|0;var b=0,c=0;b=i;c=K7(Cca(a+4|0)|0)|0;i=b;return c|0}function Cca(a){a=a|0;var b=0,c=0;b=i;c=Dca(a)|0;i=b;return c|0}function Dca(a){a=a|0;i=i;return a|0}function Eca(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Fca(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function Gca(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=Ica(b)|0;Hca(f,b,d,h,Bca(b)|0);zca(g,b);do{if(wca(f,g)|0){h=Jca(b)|0;if(Kca(h,d,Lca(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);zca(a,b);i=e;return}function Hca(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;Z7(h);a:do{if((e|0)==0){j=f}else{k=Jca(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(Oca(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;Z7(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;Z7(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);Aca(a,j);i=g;return}function Ica(a){a=a|0;var b=0,d=0;b=i;d=c[(Bca(a)|0)>>2]|0;i=b;return d|0}function Jca(a){a=a|0;var b=0,c=0;b=i;c=Mca(a+8|0)|0;i=b;return c|0}function Kca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=cca(0,b,c)|0;i=a;return d|0}function Lca(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function Mca(a){a=a|0;var b=0,c=0;b=i;c=Nca(a)|0;i=b;return c|0}function Nca(a){a=a|0;i=i;return a|0}function Oca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=cca(0,b,c)|0;i=a;return d|0}function Pca(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=Ica(h)|0;Z7(e);if((a|0)==0){j=Bca(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(cca(0,d,a)|0){m=l;j=c[m>>2]|0;Z7(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(cca(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;Z7(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function Qca(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Lda(a,e);i=d;return}function Rca(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=qda(d)|0;d=sda(n,1)|0;tda(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];rda(j,d,h);uda(0,jda((vda(j)|0)+16|0)|0,e);e=wda(j)|0;a[e+4|0]=1;xda(0,hda((vda(j)|0)+28|0)|0);a[e+5|0]=1;yda(m,j);Sca(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];Qca(b,g);Tca(m);Tca(j);i=f;return}function Sca(a,b){a=a|0;b=b|0;var c=0;c=i;oda(a,b);i=c;return}function Tca(a){a=a|0;var b=0;b=i;dda(a);i=b;return}function Uca(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;Z7(f);c[e>>2]=0;Z7(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=$ca(a)|0;b=c[c[e>>2]>>2]|0;Z7(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(Bca(a)|0)>>2]|0;J9(e,c[d>>2]|0);d=ada(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function Vca(a){a=a|0;var b=0,d=0;b=i;d=c[(Zca(a)|0)>>2]|0;i=b;return d|0}function Wca(a){a=a|0;var b=0,d=0;b=i;d=Xca(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function Xca(a){a=a|0;var b=0,c=0;b=i;c=Yca(a)|0;i=b;return c|0}function Yca(a){a=a|0;i=i;return a|0}function Zca(a){a=a|0;var b=0,c=0;b=i;c=_ca(a)|0;i=b;return c|0}function _ca(a){a=a|0;i=i;return a|0}function $ca(a){a=a|0;i=i;return a|0}function ada(a){a=a|0;var b=0,c=0;b=i;c=bda(a+8|0)|0;i=b;return c|0}function bda(a){a=a|0;var b=0,c=0;b=i;c=cda(a)|0;i=b;return c|0}function cda(a){a=a|0;i=i;return a|0}function dda(a){a=a|0;var b=0;b=i;eda(a,0);i=b;return}function eda(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=Xca(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}gda(fda(e)|0,f);i=d;return}function fda(a){a=a|0;var b=0,c=0;b=i;c=nda(a)|0;i=b;return c|0}function gda(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;ida(f,jda(d+16|0)|0)}if((d|0)==0){i=e;return}kda(c[b>>2]|0,d,1);i=e;return}function hda(a){a=a|0;i=i;return a|0}function ida(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;mda(d,0,c);i=b;return}function jda(a){a=a|0;i=i;return a|0}function kda(a,b,c){a=a|0;b=b|0;c=c|0;c=i;lda(0,b,0);i=c;return}function lda(a,b,c){a=a|0;b=b|0;c=c|0;c=i;Rwa(b);i=c;return}function mda(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Ema(c);i=b;return}function nda(a){a=a|0;i=i;return a+4|0}function oda(a,b){a=a|0;b=b|0;var c=0;c=i;pda(a,b);i=c;return}function pda(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function qda(a){a=a|0;var b=0,c=0;b=i;c=Jda(a+4|0)|0;i=b;return c|0}function rda(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];Bda(a,b,f);i=e;return}function sda(a,b){a=a|0;b=b|0;var c=0;a=i;c=Ada(0,b,0)|0;i=a;return c|0}function tda(a,b){a=a|0;b=b|0;var c=0;c=i;zda(a,b);i=c;return}function uda(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}uma(b,c);i=a;return}function vda(a){a=a|0;var b=0,d=0;b=i;d=c[(Zca(a)|0)>>2]|0;i=b;return d|0}function wda(a){a=a|0;var b=0,c=0;b=i;c=fda(a)|0;i=b;return c|0}function xda(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function yda(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;oda(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];Qca(h,f);Sca(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];Qca(a,e);Tca(h);i=d;return}function zda(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function Ada(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Pwa(b<<5)|0;i=c;return a|0}function Bda(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(Dda(g)|0)>>2]|0;g=Eda(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];Cda(b,a,f);i=e;return}function Cda(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];Fda(a,b,f);i=e;return}function Dda(a){a=a|0;i=i;return a|0}function Eda(a){a=a|0;i=i;return a|0}function Fda(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(Hda(g)|0)>>2]|0;g=Ida(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];Gda(b,a,f);i=e;return}function Gda(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(Hda(f)|0)>>2];f=Ida(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function Hda(a){a=a|0;i=i;return a|0}function Ida(a){a=a|0;i=i;return a|0}function Jda(a){a=a|0;var b=0,c=0;b=i;c=Kda(a)|0;i=b;return c|0}function Kda(a){a=a|0;i=i;return a|0}function Lda(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=Wca(Mda(b)|0)|0;h=Ida(wda(Mda(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];Cda(g,a,e);i=d;return}function Mda(a){a=a|0;i=i;return c[a>>2]|0}function Nda(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function Oda(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Vda(a,e);i=d;return}function Pda(a,b){a=a|0;b=b|0;var c=0;c=i;Qda(a,Rda(b)|0);i=c;return}function Qda(a,b){a=a|0;b=b|0;var c=0;c=i;Uda(a,b);i=c;return}function Rda(a){a=a|0;var b=0,c=0;b=i;c=K7(Sda(a+4|0)|0)|0;i=b;return c|0}function Sda(a){a=a|0;var b=0,c=0;b=i;c=Tda(a)|0;i=b;return c|0}function Tda(a){a=a|0;i=i;return a|0}function Uda(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Vda(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function Wda(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=Yda(b)|0;Xda(f,b,d,h,Rda(b)|0);Pda(g,b);do{if(Zda(f,g)|0){h=_da(b)|0;if(aca(h,d,$da(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);Pda(a,b);i=e;return}function Xda(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;Z7(h);a:do{if((e|0)==0){j=f}else{k=_da(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(bca(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;Z7(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;Z7(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);Qda(a,j);i=g;return}function Yda(a){a=a|0;var b=0,d=0;b=i;d=c[(Rda(a)|0)>>2]|0;i=b;return d|0}function Zda(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(Nda(a,b)|0)^1;i=c;return d|0}function _da(a){a=a|0;var b=0,c=0;b=i;c=aea(a+8|0)|0;i=b;return c|0}function $da(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function aea(a){a=a|0;var b=0,c=0;b=i;c=bea(a)|0;i=b;return c|0}function bea(a){a=a|0;i=i;return a|0}function cea(a,b){a=a|0;b=b|0;b=i;i=i+8|0;dea(a,b);i=b;return}function dea(a,b){a=a|0;b=b|0;b=i;eea(a,0);i=b;return}function eea(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;fea(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;gea(f,0,e);e=Bca(b)|0;c[($ca(b)|0)>>2]=e;i=d;return}function fea(a){a=a|0;var b=0;b=i;jea(a);i=b;return}function gea(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;hea(b,c,f);i=e;return}function hea(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(Baa(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;iea(d,b,f);i=e;return}function iea(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(Baa(e)|0)>>2];i=d;return}function jea(a){a=a|0;var b=0;b=i;kea(a);i=b;return}function kea(a){a=a|0;var b=0;b=i;Eaa(a);i=b;return}function lea(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=lfa(h)|0;Z7(e);if((a|0)==0){j=yea(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(W7(0,d,a)|0){m=l;j=c[m>>2]|0;Z7(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(W7(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;Z7(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function mea(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];jfa(a,e);i=d;return}function nea(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=Qea(d)|0;d=Sea(n,1)|0;Tea(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];Rea(j,d,h);Uea(0,V9((Vea(j)|0)+16|0)|0,e);e=Wea(j)|0;a[e+4|0]=1;Xea(0,Jea((Vea(j)|0)+20|0)|0);a[e+5|0]=1;Yea(m,j);oea(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];mea(b,g);pea(m);pea(j);i=f;return}function oea(a,b){a=a|0;b=b|0;var c=0;c=i;Oea(a,b);i=c;return}function pea(a){a=a|0;var b=0;b=i;Eea(a);i=b;return}function qea(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;Z7(f);c[e>>2]=0;Z7(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=xea(a)|0;b=c[c[e>>2]>>2]|0;Z7(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(yea(a)|0)>>2]|0;J9(e,c[d>>2]|0);d=zea(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function rea(a){a=a|0;var b=0,d=0;b=i;d=c[(vea(a)|0)>>2]|0;i=b;return d|0}function sea(a){a=a|0;var b=0,d=0;b=i;d=tea(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function tea(a){a=a|0;var b=0,c=0;b=i;c=uea(a)|0;i=b;return c|0}function uea(a){a=a|0;i=i;return a|0}function vea(a){a=a|0;var b=0,c=0;b=i;c=wea(a)|0;i=b;return c|0}function wea(a){a=a|0;i=i;return a|0}function xea(a){a=a|0;i=i;return a|0}function yea(a){a=a|0;var b=0,c=0;b=i;c=K7(Cea(a+4|0)|0)|0;i=b;return c|0}function zea(a){a=a|0;var b=0,c=0;b=i;c=Aea(a+8|0)|0;i=b;return c|0}function Aea(a){a=a|0;var b=0,c=0;b=i;c=Bea(a)|0;i=b;return c|0}function Bea(a){a=a|0;i=i;return a|0}function Cea(a){a=a|0;var b=0,c=0;b=i;c=Dea(a)|0;i=b;return c|0}function Dea(a){a=a|0;i=i;return a|0}function Eea(a){a=a|0;var b=0;b=i;Fea(a,0);i=b;return}function Fea(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=tea(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}Hea(Gea(e)|0,f);i=d;return}function Gea(a){a=a|0;var b=0,c=0;b=i;c=Nea(a)|0;i=b;return c|0}function Hea(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;Iea(f,Jea(d+20|0)|0)}if((d|0)==0){i=e;return}Kea(c[b>>2]|0,d,1);i=e;return}function Iea(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;Mea(d,0,c);i=b;return}function Jea(a){a=a|0;i=i;return a|0}function Kea(a,b,c){a=a|0;b=b|0;c=c|0;c=i;Lea(0,b,0);i=c;return}function Lea(a,b,c){a=a|0;b=b|0;c=c|0;c=i;Rwa(b);i=c;return}function Mea(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Xba(c);i=b;return}function Nea(a){a=a|0;i=i;return a+4|0}function Oea(a,b){a=a|0;b=b|0;var c=0;c=i;Pea(a,b);i=c;return}function Pea(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Qea(a){a=a|0;var b=0,c=0;b=i;c=hfa(a+4|0)|0;i=b;return c|0}function Rea(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];$ea(a,b,f);i=e;return}function Sea(a,b){a=a|0;b=b|0;var c=0;a=i;c=_ea(0,b,0)|0;i=a;return c|0}function Tea(a,b){a=a|0;b=b|0;var c=0;c=i;Zea(a,b);i=c;return}function Uea(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function Vea(a){a=a|0;var b=0,d=0;b=i;d=c[(vea(a)|0)>>2]|0;i=b;return d|0}function Wea(a){a=a|0;var b=0,c=0;b=i;c=Gea(a)|0;i=b;return c|0}function Xea(a,b){a=a|0;b=b|0;a=i;i=i+8|0;if((b|0)==0){i=a;return}Pba(b,a);i=a;return}function Yea(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;Oea(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];mea(h,f);oea(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];mea(a,e);pea(h);i=d;return}function Zea(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function _ea(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Pwa(b<<5)|0;i=c;return a|0}function $ea(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(bfa(g)|0)>>2]|0;g=cfa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];afa(b,a,f);i=e;return}function afa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];dfa(a,b,f);i=e;return}function bfa(a){a=a|0;i=i;return a|0}function cfa(a){a=a|0;i=i;return a|0}function dfa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(ffa(g)|0)>>2]|0;g=gfa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];efa(b,a,f);i=e;return}function efa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(ffa(f)|0)>>2];f=gfa(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function ffa(a){a=a|0;i=i;return a|0}function gfa(a){a=a|0;i=i;return a|0}function hfa(a){a=a|0;var b=0,c=0;b=i;c=ifa(a)|0;i=b;return c|0}function ifa(a){a=a|0;i=i;return a|0}function jfa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=sea(kfa(b)|0)|0;h=gfa(Wea(kfa(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];afa(g,a,e);i=d;return}function kfa(a){a=a|0;i=i;return c[a>>2]|0}function lfa(a){a=a|0;var b=0,d=0;b=i;d=c[(yea(a)|0)>>2]|0;i=b;return d|0}function mfa(a,b){a=a|0;b=b|0;b=i;i=i+8|0;nfa(a,b);i=b;return}function nfa(a,b){a=a|0;b=b|0;b=i;ofa(a,0);i=b;return}function ofa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;pfa(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;qfa(f,0,e);e=Rda(b)|0;c[(rfa(b)|0)>>2]=e;i=d;return}function pfa(a){a=a|0;var b=0;b=i;ufa(a);i=b;return}function qfa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;sfa(b,c,f);i=e;return}function rfa(a){a=a|0;i=i;return a|0}function sfa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(Baa(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;tfa(d,b,f);i=e;return}function tfa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(Baa(e)|0)>>2];i=d;return}function ufa(a){a=a|0;var b=0;b=i;vfa(a);i=b;return}function vfa(a){a=a|0;var b=0;b=i;Eaa(a);i=b;return}function wfa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=Yda(h)|0;Z7(e);if((a|0)==0){j=Rda(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(cca(0,d,a)|0){m=l;j=c[m>>2]|0;Z7(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(cca(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;Z7(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function xfa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];sga(a,e);i=d;return}function yfa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=Zfa(d)|0;d=$fa(n,1)|0;aga(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];_fa(j,d,h);bga(0,jda((cga(j)|0)+16|0)|0,e);e=dga(j)|0;a[e+4|0]=1;ega(0,Qfa((cga(j)|0)+28|0)|0);a[e+5|0]=1;fga(m,j);zfa(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];xfa(b,g);Afa(m);Afa(j);i=f;return}function zfa(a,b){a=a|0;b=b|0;var c=0;c=i;Xfa(a,b);i=c;return}function Afa(a){a=a|0;var b=0;b=i;Lfa(a);i=b;return}function Bfa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;Z7(f);c[e>>2]=0;Z7(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=rfa(a)|0;b=c[c[e>>2]>>2]|0;Z7(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(Rda(a)|0)>>2]|0;J9(e,c[d>>2]|0);d=Ifa(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function Cfa(a){a=a|0;var b=0,d=0;b=i;d=c[(Gfa(a)|0)>>2]|0;i=b;return d|0}function Dfa(a){a=a|0;var b=0,d=0;b=i;d=Efa(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function Efa(a){a=a|0;var b=0,c=0;b=i;c=Ffa(a)|0;i=b;return c|0}function Ffa(a){a=a|0;i=i;return a|0}function Gfa(a){a=a|0;var b=0,c=0;b=i;c=Hfa(a)|0;i=b;return c|0}function Hfa(a){a=a|0;i=i;return a|0}function Ifa(a){a=a|0;var b=0,c=0;b=i;c=Jfa(a+8|0)|0;i=b;return c|0}function Jfa(a){a=a|0;var b=0,c=0;b=i;c=Kfa(a)|0;i=b;return c|0}function Kfa(a){a=a|0;i=i;return a|0}function Lfa(a){a=a|0;var b=0;b=i;Mfa(a,0);i=b;return}function Mfa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=Efa(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}Ofa(Nfa(e)|0,f);i=d;return}function Nfa(a){a=a|0;var b=0,c=0;b=i;c=Wfa(a)|0;i=b;return c|0}function Ofa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;Pfa(f,Qfa(d+28|0)|0)}if((a[b+4|0]|0)!=0){f=c[b>>2]|0;Rfa(f,jda(d+16|0)|0)}if((d|0)==0){i=e;return}Sfa(c[b>>2]|0,d,1);i=e;return}function Pfa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;Vfa(d,0,c);i=b;return}function Qfa(a){a=a|0;i=i;return a|0}function Rfa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;Ufa(d,0,c);i=b;return}function Sfa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;Tfa(0,b,0);i=c;return}function Tfa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;Rwa(b);i=c;return}function Ufa(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Ema(c);i=b;return}function Vfa(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Ema(c);i=b;return}function Wfa(a){a=a|0;i=i;return a+4|0}function Xfa(a,b){a=a|0;b=b|0;var c=0;c=i;Yfa(a,b);i=c;return}function Yfa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Zfa(a){a=a|0;var b=0,c=0;b=i;c=qga(a+4|0)|0;i=b;return c|0}function _fa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];iga(a,b,f);i=e;return}function $fa(a,b){a=a|0;b=b|0;var c=0;a=i;c=hga(0,b,0)|0;i=a;return c|0}function aga(a,b){a=a|0;b=b|0;var c=0;c=i;gga(a,b);i=c;return}function bga(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}uma(b,c);i=a;return}function cga(a){a=a|0;var b=0,d=0;b=i;d=c[(Gfa(a)|0)>>2]|0;i=b;return d|0}function dga(a){a=a|0;var b=0,c=0;b=i;c=Nfa(a)|0;i=b;return c|0}function ega(a,b){a=a|0;b=b|0;a=i;if((b|0)==0){i=a;return}sma(b);i=a;return}function fga(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;Xfa(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];xfa(h,f);zfa(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];xfa(a,e);Afa(h);i=d;return}function gga(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function hga(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Pwa(b*40|0)|0;i=c;return a|0}function iga(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(kga(g)|0)>>2]|0;g=lga(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];jga(b,a,f);i=e;return}function jga(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];mga(a,b,f);i=e;return}function kga(a){a=a|0;i=i;return a|0}function lga(a){a=a|0;i=i;return a|0}function mga(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(oga(g)|0)>>2]|0;g=pga(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];nga(b,a,f);i=e;return}function nga(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(oga(f)|0)>>2];f=pga(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function oga(a){a=a|0;i=i;return a|0}function pga(a){a=a|0;i=i;return a|0}function qga(a){a=a|0;var b=0,c=0;b=i;c=rga(a)|0;i=b;return c|0}function rga(a){a=a|0;i=i;return a|0}function sga(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=Dfa(tga(b)|0)|0;h=pga(dga(tga(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];jga(g,a,e);i=d;return}function tga(a){a=a|0;i=i;return c[a>>2]|0}function uga(a){a=a|0;var b=0;b=i;vga(a);i=b;return}function vga(a){a=a|0;var b=0;b=i;wga(a);i=b;return}function wga(a){a=a|0;var b=0;b=i;xga(a,Yda(a)|0);i=b;return}function xga(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;Z7(d);if((b|0)==0){i=d;return}xga(a,c[b>>2]|0);xga(a,c[b+4>>2]|0);e=Zfa(a)|0;yga(e,zga(b+16|0)|0);Sfa(e,b,1);i=d;return}function yga(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;Aga(d,0,c);i=b;return}function zga(a){a=a|0;i=i;return a|0}function Aga(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Bga(c);i=b;return}function Bga(a){a=a|0;var b=0;b=i;Cga(a);i=b;return}function Cga(a){a=a|0;var b=0;b=i;Dga(a);i=b;return}function Dga(a){a=a|0;var b=0;b=i;Ega(a);i=b;return}function Ega(a){a=a|0;var b=0;b=i;Ema(a+12|0);Ema(a);i=b;return}function Fga(a){a=a|0;var b=0;b=i;Gga(a+180|0);Gga(a+168|0);Gga(a+156|0);Gga(a+144|0);Gga(a+132|0);Gga(a+120|0);Gga(a+108|0);Gga(a+96|0);Gga(a+84|0);Gga(a+72|0);Gga(a+60|0);Gga(a+48|0);Gga(a+36|0);Gga(a+24|0);Xba(a+12|0);Xba(a);i=b;return}function Gga(a){a=a|0;var b=0;b=i;Hga(a);i=b;return}function Hga(a){a=a|0;var b=0;b=i;Iga(a);i=b;return}function Iga(a){a=a|0;var b=0;b=i;Jga(a);i=b;return}function Jga(a){a=a|0;var b=0;b=i;Kga(a,lfa(a)|0);i=b;return}function Kga(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;Z7(d);if((b|0)==0){i=d;return}Kga(a,c[b>>2]|0);Kga(a,c[b+4>>2]|0);e=Qea(a)|0;Lga(e,Mga(b+16|0)|0);Kea(e,b,1);i=d;return}function Lga(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;Nga(d,0,c);i=b;return}function Mga(a){a=a|0;i=i;return a|0}function Nga(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Oga(c);i=b;return}function Oga(a){a=a|0;var b=0;b=i;Pga(a);i=b;return}function Pga(a){a=a|0;var b=0;b=i;Qga(a);i=b;return}function Qga(a){a=a|0;var b=0;b=i;Rga(a);i=b;return}function Rga(a){a=a|0;var b=0;b=i;Xba(a+4|0);i=b;return}function Sga(a){a=a|0;var b=0;b=i;Tga(a);i=b;return}function Tga(a){a=a|0;var b=0;b=i;Uga(a);i=b;return}function Uga(a){a=a|0;var b=0;b=i;Vga(a,Ica(a)|0);i=b;return}function Vga(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;Z7(d);if((b|0)==0){i=d;return}Vga(a,c[b>>2]|0);Vga(a,c[b+4>>2]|0);e=qda(a)|0;Wga(e,vca(b+16|0)|0);kda(e,b,1);i=d;return}function Wga(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;Xga(d,0,c);i=b;return}function Xga(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Yga(c);i=b;return}function Yga(a){a=a|0;var b=0;b=i;Zga(a);i=b;return}function Zga(a){a=a|0;var b=0;b=i;_ga(a);i=b;return}function _ga(a){a=a|0;var b=0;b=i;$ga(a);i=b;return}function $ga(a){a=a|0;var b=0;b=i;Ema(a);i=b;return}function aha(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;bha(a);dha(g,b);eha(h,b);b=f;j=g;c[b+0>>2]=c[j+0>>2];j=e;b=h;c[j+0>>2]=c[b+0>>2];cha(a,f,e);i=d;return a|0}function bha(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;xga(a,Yda(a)|0);c[(Ifa(a)|0)>>2]=0;d=Rda(a)|0;c[(rfa(a)|0)>>2]=d;Z7(b);c[d>>2]=0;i=b;return}function cha(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;mha(h,a);if(!(nha(b,d)|0)){i=e;return}m=c[h>>2]|0;h=k;do{c[h>>2]=m;n=g;o=k;c[n+0>>2]=c[o+0>>2];fha(j,g);o=pha(b)|0;n=f;p=j;c[n+0>>2]=c[p+0>>2];oha(l,a,f,o);qha(b)|0;}while(nha(b,d)|0);i=e;return}function dha(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;kha(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];fha(a,e);i=d;return}function eha(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;gha(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];fha(a,e);i=d;return}function fha(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];jha(a,e);i=d;return}function gha(a,b){a=a|0;b=b|0;var c=0;c=i;hha(a,Zba(b)|0);i=c;return}function hha(a,b){a=a|0;b=b|0;var c=0;c=i;iha(a,b);i=c;return}function iha(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function jha(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function kha(a,b){a=a|0;b=b|0;var d=0;d=i;hha(a,c[(lha(b)|0)>>2]|0);i=d;return}function lha(a){a=a|0;i=i;return a|0}function mha(a,b){a=a|0;b=b|0;var c=0;c=i;eha(a,b);i=c;return}function nha(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=wia(a,b)|0;i=c;return d|0}function oha(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+56|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=b;c[k>>2]=c[d>>2];yha(l,e);e=h;d=k;c[e+0>>2]=c[d+0>>2];xha(j,m,h,l);h=g;m=j;c[h+0>>2]=c[m+0>>2];Oda(a,g);Bga(l);i=f;return}function pha(a){a=a|0;var b=0,c=0;b=i;c=uha(a)|0;i=b;return c|0}function qha(a){a=a|0;var b=0;b=i;rha(a)|0;i=b;return a|0}function rha(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=sha(c[d>>2]|0)|0;i=b;return a|0}function sha(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;Z7(b);if((e|0)==0){e=a;while(1){a=N9(e)|0;f=c[e+8>>2]|0;if(a){g=f;break}else{e=f}}i=b;return g|0}else{g=tha(c[d>>2]|0)|0;i=b;return g|0}return 0}function tha(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a;f=c[e>>2]|0;Z7(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e;f=c[a>>2]|0;Z7(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function uha(a){a=a|0;var b=0,d=0;b=i;d=vha((c[a>>2]|0)+16|0)|0;i=b;return d|0}function vha(a){a=a|0;var b=0,c=0;b=i;c=wha(a)|0;i=b;return c|0}function wha(a){a=a|0;i=i;return a|0}function xha(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+56|0;o=f+64|0;c[k>>2]=c[d>>2];d=h;p=k;c[d+0>>2]=c[p+0>>2];p=Cha(b,h,j,e)|0;h=c[p>>2]|0;Z7(l);if((h|0)!=0){q=h;Qda(a,q);i=f;return}Eha(o,b,e);Fha(n,o);e=g;h=n;c[e+0>>2]=c[h+0>>2];Dha(m,g);Gha(o);o=c[j>>2]|0;Bfa(b,o,p,Hha(m)|0);p=Iha(m)|0;Gha(m);q=p;Qda(a,q);i=f;return}function yha(a,b){a=a|0;b=b|0;var c=0;c=i;zha(a,b);i=c;return}function zha(a,b){a=a|0;b=b|0;var c=0;c=i;Aha(a,b);i=c;return}function Aha(a,b){a=a|0;b=b|0;var c=0;c=i;Bha(a,b);i=c;return}function Bha(a,b){a=a|0;b=b|0;var c=0;c=i;uma(a,b);uma(a+12|0,b+12|0);i=c;return}function Cha(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+120|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=f+64|0;q=f+72|0;r=f+80|0;s=f+88|0;t=f+96|0;u=f+104|0;v=f+112|0;Pda(m,a);w=k;x=m;c[w+0>>2]=c[x+0>>2];kia(l,k);do{if(!(jia(b,l)|0)){k=_da(a)|0;x=mia(b)|0;if(lia(k,e,x)|0){break}w=lia(k,x,e)|0;x=c[b>>2]|0;if(!w){c[d>>2]=x;y=d;i=f;return y|0}c[s>>2]=x;w=h;m=s;c[w+0>>2]=c[m+0>>2];qia(r,h,1,0);Pda(u,a);m=g;w=u;c[m+0>>2]=c[w+0>>2];kia(t,g);do{if(!(jia(r,t)|0)){if(lia(k,e,mia(r)|0)|0){break}y=pia(a,d,e)|0;i=f;return y|0}}while(0);k=x+4|0;w=c[k>>2]|0;Z7(v);if((w|0)==0){c[d>>2]=x;y=k;i=f;return y|0}else{k=c[r>>2]|0;c[d>>2]=k;y=k;i=f;return y|0}}}while(0);r=c[b>>2]|0;b=n;c[b>>2]=r;nia(p,a);v=j;t=p;c[v+0>>2]=c[t+0>>2];kia(o,j);do{if(!(jia(n,o)|0)){j=_da(a)|0;if(lia(j,mia(oia(n)|0)|0,e)|0){break}y=pia(a,d,e)|0;i=f;return y|0}}while(0);e=r;a=c[e>>2]|0;Z7(q);if((a|0)==0){c[d>>2]=r;y=e;i=f;return y|0}else{e=c[b>>2]|0;c[d>>2]=e;y=e+4|0;i=f;return y|0}return 0}function Dha(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];hia(a,e);i=d;return}function Eha(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=Zfa(d)|0;d=$fa(n,1)|0;Vha(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];Uha(j,d,h);Wha(0,zga((Xha(j)|0)+16|0)|0,e);a[(Yha(j)|0)+4|0]=1;Zha(m,j);Fha(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];Dha(b,g);Gha(m);Gha(j);i=f;return}function Fha(a,b){a=a|0;b=b|0;var c=0;c=i;Sha(a,b);i=c;return}function Gha(a){a=a|0;var b=0;b=i;Nha(a);i=b;return}function Hha(a){a=a|0;var b=0,d=0;b=i;d=c[(Lha(a)|0)>>2]|0;i=b;return d|0}function Iha(a){a=a|0;var b=0,d=0;b=i;d=Jha(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function Jha(a){a=a|0;var b=0,c=0;b=i;c=Kha(a)|0;i=b;return c|0}function Kha(a){a=a|0;i=i;return a|0}function Lha(a){a=a|0;var b=0,c=0;b=i;c=Mha(a)|0;i=b;return c|0}function Mha(a){a=a|0;i=i;return a|0}function Nha(a){a=a|0;var b=0;b=i;Oha(a,0);i=b;return}function Oha(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=Jha(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}Qha(Pha(e)|0,f);i=d;return}function Pha(a){a=a|0;var b=0,c=0;b=i;c=Rha(a)|0;i=b;return c|0}function Qha(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;yga(f,zga(d+16|0)|0)}if((d|0)==0){i=e;return}Sfa(c[b>>2]|0,d,1);i=e;return}function Rha(a){a=a|0;i=i;return a+4|0}function Sha(a,b){a=a|0;b=b|0;var c=0;c=i;Tha(a,b);i=c;return}function Tha(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Uha(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];bia(a,b,f);i=e;return}function Vha(a,b){a=a|0;b=b|0;var c=0;c=i;aia(a,b);i=c;return}function Wha(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}_ha(b,c);i=a;return}function Xha(a){a=a|0;var b=0,d=0;b=i;d=c[(Lha(a)|0)>>2]|0;i=b;return d|0}function Yha(a){a=a|0;var b=0,c=0;b=i;c=Pha(a)|0;i=b;return c|0}function Zha(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;Sha(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];Dha(h,f);Fha(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];Dha(a,e);Gha(h);i=d;return}function _ha(a,b){a=a|0;b=b|0;var c=0;c=i;$ha(a,b);i=c;return}function $ha(a,b){a=a|0;b=b|0;var c=0;c=i;Aha(a,b);i=c;return}function aia(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;i=i;return}function bia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(kga(g)|0)>>2]|0;g=dia(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];cia(b,a,f);i=e;return}function cia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];eia(a,b,f);i=e;return}function dia(a){a=a|0;i=i;return a|0}function eia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(oga(g)|0)>>2]|0;g=gia(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];fia(b,a,f);i=e;return}function fia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(oga(f)|0)>>2];f=gia(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function gia(a){a=a|0;i=i;return a|0}function hia(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=Iha(iia(b)|0)|0;h=gia(Yha(iia(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];cia(g,a,e);i=d;return}function iia(a){a=a|0;i=i;return c[a>>2]|0}function jia(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function kia(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];via(a,e);i=d;return}function lia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=cca(0,b,c)|0;i=a;return d|0}function mia(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function nia(a,b){a=a|0;b=b|0;var d=0;d=i;Qda(a,c[(rfa(b)|0)>>2]|0);i=d;return}function oia(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=tia(c[d>>2]|0)|0;i=b;return a|0}function pia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=Yda(a)|0;Z7(e);if((h|0)==0){j=Rda(a)|0;c[b>>2]=j;k=j;i=e;return k|0}j=_da(a)|0;a=h;while(1){h=a+16|0;if(lia(j,d,h)|0){l=a;m=c[l>>2]|0;Z7(f);if((m|0)==0){n=5;break}else{o=l}}else{p=a;if(!(lia(j,h,d)|0)){n=10;break}q=a+4|0;h=c[q>>2]|0;Z7(g);if((h|0)==0){n=9;break}else{o=q}}a=c[o>>2]|0}if((n|0)==5){c[b>>2]=a;k=l;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==10){c[b>>2]=p;k=b;i=e;return k|0}return 0}function qia(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;ria(b,d);c[a>>2]=c[b>>2];i=e;return}function ria(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;sia(b,c,e);i=d;return}function sia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;if(!((b|0)>-1)){d=b;do{oia(a)|0;d=d+1|0;}while((d|0)<0);i=c;return}if((b|0)>0){e=b}else{i=c;return}do{rha(a)|0;e=e+ -1|0;}while((e|0)>0);i=c;return}function tia(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;Z7(b);if((e|0)==0){e=a;while(1){a=N9(e)|0;f=c[e+8>>2]|0;if(a){e=f}else{g=f;break}}i=b;return g|0}else{g=uia(c[d>>2]|0)|0;i=b;return g|0}return 0}function uia(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[e>>2]|0;Z7(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e+4|0;f=c[a>>2]|0;Z7(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function via(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function wia(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(jia(a,b)|0)^1;i=c;return d|0}function xia(a){a=a|0;var b=0;b=i;i=i+128|0;Pba(a,b);Pba(a+12|0,b+8|0);yia(a+24|0,b+16|0);yia(a+36|0,b+24|0);yia(a+48|0,b+32|0);yia(a+60|0,b+40|0);yia(a+72|0,b+48|0);yia(a+84|0,b+56|0);yia(a+96|0,b+64|0);yia(a+108|0,b+72|0);yia(a+120|0,b+80|0);yia(a+132|0,b+88|0);yia(a+144|0,b+96|0);yia(a+156|0,b+104|0);yia(a+168|0,b+112|0);yia(a+180|0,b+120|0);i=b;return}function yia(a,b){a=a|0;b=b|0;b=i;zia(a,0);i=b;return}function zia(a,b){a=a|0;b=b|0;b=i;i=i+8|0;Aia(a,b);i=b;return}function Aia(a,b){a=a|0;b=b|0;b=i;Bia(a,0);i=b;return}function Bia(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;Cia(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;Dia(f,0,e);e=yea(b)|0;c[(xea(b)|0)>>2]=e;i=d;return}function Cia(a){a=a|0;var b=0;b=i;Gia(a);i=b;return}function Dia(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;Eia(b,c,f);i=e;return}function Eia(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(Baa(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;Fia(d,b,f);i=e;return}function Fia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(Baa(e)|0)>>2];i=d;return}function Gia(a){a=a|0;var b=0;b=i;Hia(a);i=b;return}function Hia(a){a=a|0;var b=0;b=i;Eaa(a);i=b;return}function Iia(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=c[128196>>2]|0;if((m|0)==0){n=0}else{o=Pwa(12)|0;yma(o,m);n=o}if((c[128112>>2]|0)!=0){c[17720]=1}if((n|0)==0){c[70892>>2]=1;c[70896>>2]=1;i=b;return}do{if((ana(n,118400,0)|0)==-1){uma(g,n);sma(h);o=c[17294]|0;m=(o|0)<28;while(1){p=ana(g,118408,0)|0;q=(p|0)!=-1;if(q){_ma(j,g,0,p);Fma(h,j)|0;Ema(j);_ma(k,g,p+1|0,-1);Fma(g,k)|0;Ema(k)}else{Fma(h,g)|0}if(m){r=1;s=o}else{t=20;break}while(1){yma(l,c[69592+(s<<2)>>2]|0);p=Jia(h,l)|0;Ema(l);if(p){c[70888+(s<<2)>>2]=1;u=0}else{u=r}p=s+1|0;if((p|0)<28){r=u;s=p}else{break}}if((u|0)!=0){t=18;break}if(!q){t=23;break}}if((t|0)==18){X1(1,1,118416,f);if(m){v=o}else{w=71440;x=c[17860]|0;Zd[x&1023](1);y=$ma(n)|0;z=a;A=z;c[A>>2]=y;B=6;C=B;D=118456;E=D;Z1(0,E,a)}do{p=c[70760+(v<<2)>>2]|0;c[e>>2]=c[69592+(v<<2)>>2];c[e+4>>2]=p;X1(1,0,118440,e);v=v+1|0;}while((v|0)<28);w=71440;x=c[17860]|0;Zd[x&1023](1);y=$ma(n)|0;z=a;A=z;c[A>>2]=y;B=6;C=B;D=118456;E=D;Z1(0,E,a)}else if((t|0)==20){X1(1,1,118416,d);w=71440;x=c[17860]|0;Zd[x&1023](1);y=$ma(n)|0;z=a;A=z;c[A>>2]=y;B=6;C=B;D=118456;E=D;Z1(0,E,a)}else if((t|0)==23){Ema(h);Ema(g);break}}else{o=1;do{c[70888+(o<<2)>>2]=1;o=o+1|0;}while((o|0)<28)}}while(0);c[70892>>2]=1;c[70896>>2]=1;if((c[70924>>2]|0)!=0){c[70984>>2]=1}if((c[70980>>2]|0)==1){c[70988>>2]=1}if((c[70960>>2]|0)!=0){c[70956>>2]=1}if((c[70968>>2]|0)!=0){c[70956>>2]=1}if((c[70920>>2]|0)!=0){c[70916>>2]=1}if((c[70964>>2]|0)!=0){c[70956>>2]=1}if((c[70912>>2]|0)!=0){c[70908>>2]=1}Ema(n);Rwa(n);i=b;return}function Jia(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=Cma(b)|0;if((e|0)!=(Cma(c)|0)){f=0;i=d;return f|0}g=Dma(b)|0;h=Dma(c)|0;if(vma(b)|0){f=(eca(g,h,e)|0)==0;i=d;return f|0}if((e|0)==0){f=1;i=d;return f|0}else{j=e;k=g;l=h}while(1){if((a[k]|0)!=(a[l]|0)){f=0;m=7;break}h=j+ -1|0;if((h|0)==0){f=1;m=7;break}else{j=h;k=k+1|0;l=l+1|0}}if((m|0)==7){i=d;return f|0}return 0}function Kia(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=c[128204>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=Pwa(12)|0;l=k;yma(l,h);if((k|0)==0){j=1;i=b;return j|0}else{m=1}while(1){k=m+1|0;if(Lia(l,c[103496+(m<<2)>>2]|0)|0){j=m;n=6;break}if((k|0)<4){m=k}else{n=5;break}}if((n|0)==5){c[g>>2]=$ma(l)|0;X1(1,1,118488,g);g=c[103580>>2]|0;c[f>>2]=c[103500>>2];c[f+4>>2]=g;X1(1,0,118440,f);f=c[103584>>2]|0;c[e>>2]=c[103504>>2];c[e+4>>2]=f;X1(1,0,118440,e);e=c[103588>>2]|0;c[d>>2]=c[103508>>2];c[d+4>>2]=e;X1(1,0,118440,d);Zd[c[17860]&1023](1);Z1(0,118544,a)}else if((n|0)==6){i=b;return j|0}return 0}function Lia(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(cna(a,b)|0)==0;i=c;return d|0}function Mia(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;a=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+16|0;g=i;i=i+16|0;h=c[128188>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=Pwa(12)|0;l=k;yma(l,h);if((k|0)==0){j=1;i=b;return j|0}yma(f,118568);k=Jia(l,f)|0;Ema(f);if(k){j=1;i=b;return j|0}yma(g,118576);k=Jia(l,g)|0;Ema(g);if(k){j=2;i=b;return j|0}else{c[e>>2]=$ma(l)|0;X1(1,1,118584,e);c[d>>2]=118568;c[d+4>>2]=118640;X1(1,0,118440,d);c[a>>2]=118576;c[a+4>>2]=118656;X1(1,0,118440,a);Zd[c[17860]&1023](1);Z1(0,118544,b)}return 0}function Nia(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;Noa(f,a);if(!(Qoa(f)|0)){Ooa(f);i=d;return a|0}j=mca(b)|0;_ia(g,a);k=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;l=k;if(((b8(l)|0)&176|0)==32){m=b+j|0}else{m=b}n=yna(k)|0;k=b+j|0;j=e;o=g;c[j+0>>2]=c[o+0>>2];bja(h,e,b,m,k,l,n);if(!($ia(h)|0)){Ooa(f);i=d;return a|0}sna(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,5);Ooa(f);i=d;return a|0}function Oia(a){a=a|0;var b=0;b=i;Toa(a,zna(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;Aoa(a)|0;i=b;return a|0}function Pia(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+2128|0;g=f;h=f+32|0;j=f+48|0;k=f+64|0;l=f+80|0;yma(h,d);nna(k,118664,h);zba(j,k,118672);Ema(k);k=$ma(j)|0;d=b+104|0;do{if((c[d>>2]|0)>0){m=b;n=c[m>>2]|0;if((hxa(c[n+4>>2]|0,118680)|0)!=0){break}a[n+104|0]=1;a[(c[m>>2]|0)+((c[d>>2]|0)*112|0)+104|0]=1}}while(0);if((hxa(k,118688)|0)==0){Ema(j);Ema(h);i=f;return}d=Rva(g,k,1)|0;if((d|0)!=0){m=l;pxa(m|0,0,2048)|0;cwa(d,g,m,2048)|0;Roa(Nia(Nia(Nia(Nia(Nia(140592,118696)|0,k)|0,118736)|0,m)|0,118752)|0,103)|0;Ema(j);Ema(h);i=f;return}m=b+108|0;k=c[m>>2]|0;if((k|0)>0){d=b;l=k;k=0;while(1){n=c[d>>2]|0;if((a[n+(k*112|0)+104|0]|0)==0){o=(dwa(g,c[n+(k*112|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(k*112|0)+104|0]=o;p=c[m>>2]|0}else{p=l}o=k+1|0;if((o|0)<(p|0)){l=p;k=o}else{break}}}k=b+208|0;if((c[k>>2]|0)>0){p=b+32|0;l=b;m=(e|0)==0;d=b+16|0;o=0;do{n=c[p>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){q=a[n+(o*52|0)+8|0]|0;if(q<<24>>24==1){r=(dwa(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=r;r=c[p>>2]|0;if((a[r+(o*52|0)+48|0]|0)!=0|m){break}a[(c[d>>2]|0)+((c[r+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else if(q<<24>>24==0){q=(dwa(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=q;q=c[p>>2]|0;if((a[q+(o*52|0)+48|0]|0)!=0){break}a[(c[l>>2]|0)+((c[q+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else{break}}}while(0);o=o+1|0;}while((o|0)<(c[k>>2]|0))}k=b+116|0;o=c[k>>2]|0;if((o|0)>0){l=b+4|0;p=o;o=0;while(1){d=c[l>>2]|0;if((a[d+(o*60|0)+56|0]|0)==0){m=(dwa(g,c[d+(o*60|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(o*60|0)+56|0]=m;s=c[k>>2]|0}else{s=p}m=o+1|0;if((m|0)<(s|0)){p=s;o=m}else{break}}}o=b+212|0;if((c[o>>2]|0)>0){s=b+36|0;p=b+4|0;k=(e|0)==0;l=b+20|0;m=0;do{d=c[s>>2]|0;do{if((a[d+(m*52|0)+48|0]|0)==0){n=a[d+(m*52|0)+8|0]|0;if(n<<24>>24==0){q=(dwa(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=q;q=c[s>>2]|0;if((a[q+(m*52|0)+48|0]|0)!=0){break}a[(c[p>>2]|0)+((c[q+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else if(n<<24>>24==1){n=(dwa(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=n;n=c[s>>2]|0;if((a[n+(m*52|0)+48|0]|0)!=0|k){break}a[(c[l>>2]|0)+((c[n+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else{break}}}while(0);m=m+1|0;}while((m|0)<(c[o>>2]|0))}o=b+120|0;m=c[o>>2]|0;if((m|0)>0){l=b+8|0;k=m;m=0;while(1){s=c[l>>2]|0;if((a[s+(m*48|0)+44|0]|0)==0){p=(dwa(g,c[s+(m*48|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(m*48|0)+44|0]=p;t=c[o>>2]|0}else{t=k}p=m+1|0;if((p|0)<(t|0)){k=t;m=p}else{break}}}m=b+216|0;if((c[m>>2]|0)>0){t=b+40|0;k=b+8|0;o=(e|0)==0;l=b+24|0;p=0;do{s=c[t>>2]|0;do{if((a[s+(p*52|0)+48|0]|0)==0){d=a[s+(p*52|0)+8|0]|0;if(d<<24>>24==0){n=(dwa(g,c[s+(p*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(p*52|0)+48|0]=n;n=c[t>>2]|0;if((a[n+(p*52|0)+48|0]|0)!=0){break}a[(c[k>>2]|0)+((c[n+(p*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else if(d<<24>>24==1){d=(dwa(g,c[s+(p*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(p*52|0)+48|0]=d;d=c[t>>2]|0;if((a[d+(p*52|0)+48|0]|0)!=0|o){break}a[(c[l>>2]|0)+((c[d+(p*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else{break}}}while(0);p=p+1|0;}while((p|0)<(c[m>>2]|0))}m=b+124|0;p=c[m>>2]|0;if((p|0)>0){l=b+12|0;o=p;p=0;while(1){t=c[l>>2]|0;if((a[t+(p*52|0)+48|0]|0)==0){k=(dwa(g,c[t+(p*52|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(p*52|0)+48|0]=k;u=c[m>>2]|0}else{u=o}k=p+1|0;if((k|0)<(u|0)){o=u;p=k}else{break}}}p=b+220|0;if((c[p>>2]|0)>0){u=b+44|0;o=b+12|0;m=(e|0)==0;e=b+28|0;b=0;do{l=c[u>>2]|0;do{if((a[l+(b*52|0)+48|0]|0)==0){k=a[l+(b*52|0)+8|0]|0;if(k<<24>>24==0){t=(dwa(g,c[l+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=t;t=c[u>>2]|0;if((a[t+(b*52|0)+48|0]|0)!=0){break}a[(c[o>>2]|0)+((c[t+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else if(k<<24>>24==1){k=(dwa(g,c[l+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=k;k=c[u>>2]|0;if((a[k+(b*52|0)+48|0]|0)!=0|m){break}a[(c[e>>2]|0)+((c[k+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else{break}}}while(0);b=b+1|0;}while((b|0)<(c[p>>2]|0))}Vva(g);Ema(j);Ema(h);i=f;return}function Qia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0;b=i;i=i+8|0;a=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[128052>>2]|0;H=c[128180>>2]|0;I=c[2]|0;if((c[70988>>2]|0)==0){if(!((c[128e3>>2]|0)==0|(I|0)!=0)){J=3}}else{J=3}if((J|0)==3){c[2]=1}J=d+248|0;K=d+240|0;L=~~+Ab(+((+h[J>>3]- +h[K>>3])/+h[d+264>>3]));c[d+256>>2]=L;c[l>>2]=L;V1(23,0,118800,l);l=c[128124>>2]|0;do{if((l|0)==0){M=0}else{if((hxa(l,118824)|0)==0){M=1;break}if((hxa(l,118832)|0)==0){M=0;break}if((hxa(l,118840)|0)==0){M=2;break}c[j>>2]=l;X1(1,0,118848,j);M=0}}while(0);if((G3(M)|0)!=0){c[g>>2]=l;X1(1,0,118920,g)}if((c[2]|0)!=0){Yja(d+56|0);L3((c[d+64>>2]|0)+13+(c[d+68>>2]|0)+(c[d+72>>2]|0)|0);H3(0);H3(6);I3(3);I3(4);I3(1)}g=(G|0)!=0;if(g){if((H|0)==0){N=+h[K>>3]}else{N=+dxa(H)}h[J>>3]=N;J=f;h[k>>3]=N;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];V1(1,0,119008,f)}do{if((c[128108>>2]|0)!=0){f=Pwa(12)|0;J=f;yma(J,c[128236>>2]|0);if((f|0)==0){break}f=$ma(J)|0;c[d+280>>2]=f;c[e>>2]=f;V1(23,0,119064,e)}}while(0);e=c[128232>>2]|0;sma(m);if((e|0)==0){yma(p,c[d+88>>2]|0);yma(q,119112);Ria(o,p,q);zba(n,o,c[d+284>>2]|0);Fma(m,n)|0;Ema(n);Ema(o);Ema(q);Ema(p)}else{Gma(m,e)|0}yma(r,119120);yma(s,119120);yma(t,119120);yma(u,119120);yma(v,119120);yma(w,119120);e=c[128e3>>2]|0;if((c[128020>>2]|0)!=0){Gma(r,c[128148>>2]|0)|0}if((c[128036>>2]|0)!=0){Gma(s,c[128164>>2]|0)|0}if((c[128016>>2]|0)!=0){Gma(t,c[128144>>2]|0)|0}if((c[128024>>2]|0)==0){O=0.0}else{Gma(u,c[128152>>2]|0)|0;O=+dxa($ma(u)|0)}if((c[128028>>2]|0)==0){P=1}else{Gma(v,c[128156>>2]|0)|0;P=Ec($ma(v)|0)|0}if((c[128088>>2]|0)!=0){Gma(w,c[128216>>2]|0)|0}uma(x,m);uma(y,r);uma(z,s);uma(A,t);uma(B,w);p=Sia(d,x,y,z,A,O,P,B,e)|0;Ema(B);Ema(A);Ema(z);Ema(y);Ema(x);if((p|0)!=0|g^1){Q=p}else{H3(5);p=nja(d)|0;K3(5);V1(1,0,119128,a);Q=p}c[2]=I;if(!((Q|0)==0&(I|0)!=0)){R=Q;Ema(w);Ema(v);Ema(u);Ema(t);Ema(s);Ema(r);Ema(m);i=b;return R|0}Q=d+88|0;yma(D,c[Q>>2]|0);zba(C,D,119160);Ema(D);yma(F,c[Q>>2]|0);zba(E,F,119176);Ema(F);K3(0);F=c[128200>>2]|0;Q=$ma(C)|0;D=$ma(E)|0;I=c[d+280>>2]|0;p=c[d+284>>2]|0;Mja(d,Q,D,(F|0)!=0?F:119192,I,p,$ma(m)|0)|0;Ema(E);Ema(C);R=0;Ema(w);Ema(v);Ema(u);Ema(t);Ema(s);Ema(r);Ema(m);i=b;return R|0}function Ria(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;tma(a,d);e=Cma(b)|0;f=Cma(c)|0;dna(a,Dma(b)|0,e,f+e|0);Xma(a,Dma(c)|0,f)|0;i=d;return}function Sia(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;if((Cma(j)|0)==0){u=0}else{u=$ma(j)|0}uma(r,b);b=(Tia(a,r,k)|0)==0;Ema(r);if(!b){v=-1;i=l;return v|0}yma(s,119120);b=a+280|0;r=Lia(s,c[b>>2]|0)|0;Ema(s);do{if(r){w=3}else{s=1;k=0;do{yma(t,c[119336+(s<<2)>>2]|0);j=Lia(t,c[b>>2]|0)|0;Ema(t);k=j?s:k;s=s+1|0;}while((s|0)<20);if((k|0)!=0){w=k;break}c[q>>2]=c[b>>2];X1(1,0,119416,q);X1(1,0,118416,p);s=1;do{j=c[119448+(s<<2)>>2]|0;c[o>>2]=c[119336+(s<<2)>>2];c[o+4>>2]=j;X1(1,0,118440,o);s=s+1|0;}while((s|0)<20);Z1(c[a+536>>2]|0,118544,n)}}while(0);c[m>>2]=c[119336+(w<<2)>>2];V1(23,0,119528,m);m=$ma(d)|0;d=$ma(e)|0;e=q6(a,m,d,$ma(f)|0,g,h,w,u)|0;_d[c[112780>>2]&127](112752,a);v=e;i=l;return v|0}function Tia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[a+256>>2]<<2;c[28188]=sd($ma(b)|0)|0;c[112756>>2]=g;c[112760>>2]=d;d=a+284|0;do{if((c[29598]|0)==0){g=c[d>>2]|0;if((hxa(119200,g)|0)==0){h=0;break}if((hxa(119208,g)|0)==0){c[112768>>2]=61;c[112772>>2]=62;c[112780>>2]=63;h=0;break}if((hxa(119216,g)|0)==0){c[112768>>2]=64;c[112772>>2]=65;c[112776>>2]=66;c[112780>>2]=67;h=1;break}if((hxa(119224,g)|0)==0){c[112768>>2]=68;c[112772>>2]=69;c[112776>>2]=70;c[112780>>2]=71;h=1;break}if((hxa(119232,g)|0)==0){c[112768>>2]=72;c[112772>>2]=73;c[112780>>2]=74;h=0;break}g=Nia(140592,119240)|0;Roa(Nia(g,c[d>>2]|0)|0,103)|0;j=1;i=e;return j|0}else{h=0}}while(0);Pia(a+8|0,c[a+288>>2]|0,h);_d[c[112768>>2]&127](112752,a);a=c[28188]|0;c[f>>2]=c[d>>2];c[f+4>>2]=a;V1(23,0,119264,f);j=0;i=e;return j|0}function Uia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;M1();do{if((eka(a,b)|0)==0){if((gka(a,b)|0)!=0){break}do{if((c[128056>>2]|0)!=0){w=c[128184>>2]|0;if((hxa(w,119648)|0)==0){S1(1);break}if((hxa(w,119656)|0)==0){S1(0);break}else{c[p>>2]=w;X1(1,0,119664,p);nd(0)|0;ud(0)}}}while(0);if((c[128012>>2]|0)==0){Iia(0,0);u5(d);if((d|0)==0){Roa(Nia(140592,120032)|0,103)|0}c[d+300>>2]=Kia(0,0)|0;c[d+292>>2]=Mia(0,0)|0;wba(d+8|0,d+240|0);z5(d)|0;H5(d)|0;Q5(d)|0;do{if((c[d+116>>2]|0)==0){if((c[d+124>>2]|0)==0){break}if((c[d+128>>2]|0)==0){break}Roa(Nia(140592,120096)|0,103)|0;x=1;i=e;return x|0}}while(0);c[29598]=c[128080>>2];x=0;i=e;return x|0}yma(u,c[128140>>2]|0);w=1;while(1){y=76304+(w<<2)|0;yma(v,c[y>>2]|0);z=Jia(u,v)|0;Ema(v);A=w+1|0;if(z){break}if((A|0)<31){w=A}else{B=33;break}}if((B|0)==33){c[g>>2]=$ma(u)|0;X1(1,0,119936,g);c[f>>2]=c[b>>2];X1(1,0,119976,f);nd(0)|0;ud(0)}A=c[80328+(w<<2)>>2]|0;do{if((A|0)==1){z=c[80200+(w<<2)>>2]|0;c[o>>2]=c[y>>2];c[o+4>>2]=z;V1(1,1,119736,o)}else{z=c[y>>2]|0;if((A|0)==2){C=c[80200+(w<<2)>>2]|0;c[n>>2]=z;c[n+4>>2]=z;c[n+8>>2]=C;V1(1,1,119776,n);break}else{c[m>>2]=z;X1(1,1,119616,m);break}}}while(0);if((w|0)==29){A=1;do{z=c[119448+(A<<2)>>2]|0;c[h>>2]=c[119336+(A<<2)>>2];c[h+4>>2]=z;V1(1,0,118440,h);A=A+1|0;}while((A|0)<20);D=71440;E=c[17860]|0;Zd[E&1023](1);F=nd(0)|0;ud(0)}else if((w|0)==19){A=c[17294]|0;if((A|0)<28){G=A}else{D=71440;E=c[17860]|0;Zd[E&1023](1);F=nd(0)|0;ud(0)}do{A=c[70760+(G<<2)>>2]|0;c[l>>2]=c[69592+(G<<2)>>2];c[l+4>>2]=A;V1(1,0,118440,l);G=G+1|0;}while((G|0)<28);D=71440;E=c[17860]|0;Zd[E&1023](1);F=nd(0)|0;ud(0)}else if((w|0)==7){A=1;do{z=c[119856+(A<<2)>>2]|0;c[k>>2]=c[119840+(A<<2)>>2];c[k+4>>2]=z;V1(1,0,118440,k);A=A+1|0;}while((A|0)<4);D=71440;E=c[17860]|0;Zd[E&1023](1);F=nd(0)|0;ud(0)}else if((w|0)==11){A=1;do{z=c[119904+(A<<2)>>2]|0;c[j>>2]=c[119872+(A<<2)>>2];c[j+4>>2]=z;V1(1,0,118440,j);A=A+1|0;}while((A|0)<7);D=71440;E=c[17860]|0;Zd[E&1023](1);F=nd(0)|0;ud(0)}else{D=71440;E=c[17860]|0;Zd[E&1023](1);F=nd(0)|0;ud(0)}}}while(0);c[t>>2]=c[b>>2];V1(1,1,119552,t);t=1;do{b=c[80328+(t<<2)>>2]|0;do{if((b|0)==1){F=c[78208+(t<<2)>>2]|0;c[s>>2]=c[76304+(t<<2)>>2];c[s+4>>2]=F;V1(1,0,119568,s)}else{F=c[76304+(t<<2)>>2]|0;if((b|0)==2){E=c[78208+(t<<2)>>2]|0;c[r>>2]=F;c[r+4>>2]=F;c[r+8>>2]=E;V1(1,0,119584,r);break}else{c[q>>2]=F;X1(1,0,119616,q);break}}}while(0);t=t+1|0;}while((t|0)<31);Zd[c[17860]&1023](1);nd(0)|0;ud(0);return 0}function Via(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0;a=i;i=i+8|0;b=a;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=c[30032]|0;sb(121712)|0;c[l>>2]=c[m+88>>2];gc(120136,l|0)|0;sb(121728)|0;l=j;h[k>>3]=+h[m+264>>3];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];gc(120160,j|0)|0;j=m+4|0;m=g;h[k>>3]=+h[c[(c[j>>2]|0)+4>>2]>>3];c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];gc(120200,g|0)|0;g=f;h[k>>3]=+h[c[(c[j>>2]|0)+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];gc(120232,f|0)|0;f=c[j>>2]|0;g=e;h[k>>3]=+h[c[f+4>>2]>>3]- +h[c[f+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];gc(120264,e|0)|0;e=d;h[k>>3]=+h[c[c[j>>2]>>2]>>3];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];gc(120296,d|0)|0;d=c[j>>2]|0;j=b;h[k>>3]=+h[c[d>>2]>>3]- +h[c[d+4>>2]>>3];c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];gc(120328,b|0)|0;sb(121752)|0;i=a;return}function Wia(a,b){a=a|0;b=+b;i=i;return}



function IN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9072>>3]=0.0;i=i;return}function JN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9064>>3]=0.0;i=i;return}function KN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9936>>3]=0.0;i=i;return}function LN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9928>>3]=0.0;i=i;return}function MN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9920>>3]=0.0;i=i;return}function NN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9912>>3]=0.0;i=i;return}function ON(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9896>>3]=0.0;i=i;return}function PN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9888>>3]=0.0;i=i;return}function QN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9880>>3]=0.0;i=i;return}function RN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9872>>3]=0.0;i=i;return}function SN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9864>>3]=0.0;i=i;return}function TN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8>>3]=0.0;i=i;return}function UN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16>>3]=0.0;i=i;return}function VN(a){a=a|0;h[c[(c[c[a+4>>2]>>2]|0)+8>>2]>>3]=0.0;i=i;return}function WN(b){b=b|0;var c=0,d=0;c=i;d=b+314|0;a[d]=1;lD(b);mD(b);nD(b);oD(b);pD(b);qD(b);rD(b);sD(b);tD(b);uD(b);vD(b);wD(b);xD(b);yD(b);zD(b);AD(b);BD(b);CD(b);DD(b);ED(b);FD(b);GD(b);HD(b);ID(b);JD(b);KD(b);LD(b);MD(b);ND(b);OD(b);PD(b);QD(b);RD(b);SD(b);TD(b);UD(b);VD(b);WD(b);XD(b);YD(b);ZD(b);_D(b);$D(b);aE(b);bE(b);cE(b);dE(b);eE(b);fE(b);gE(b);hE(b);iE(b);jE(b);kE(b);lE(b);mE(b);nE(b);oE(b);pE(b);qE(b);rE(b);sE(b);tE(b);uE(b);vE(b);wE(b);xE(b);yE(b);zE(b);AE(b);BE(b);CE(b);DE(b);EE(b);FE(b);GE(b);HE(b);IE(b);JE(b);KE(b);LE(b);ME(b);NE(b);OE(b);PE(b);QE(b);RE(b);SE(b);TE(b);UE(b);VE(b);WE(b);XE(b);YE(b);ZE(b);_E(b);$E(b);aF(b);bF(b);cF(b);dF(b);eF(b);fF(b);gF(b);hF(b);iF(b);jF(b);kF(b);lF(b);mF(b);nF(b);oF(b);pF(b);qF(b);rF(b);sF(b);tF(b);uF(b);vF(b);wF(b);xF(b);yF(b);zF(b);AF(b);BF(b);CF(b);DF(b);EF(b);FF(b);GF(b);HF(b);IF(b);JF(b);KF(b);LF(b);MF(b);NF(b);OF(b);PF(b);QF(b);RF(b);SF(b);TF(b);UF(b);VF(b);WF(b);XF(b);YF(b);ZF(b);_F(b);$F(b);aG(b);bG(b);cG(b);dG(b);eG(b);fG(b);gG(b);hG(b);iG(b);jG(b);kG(b);lG(b);mG(b);nG(b);oG(b);pG(b);qG(b);rG(b);sG(b);tG(b);uG(b);vG(b);wG(b);xG(b);yG(b);zG(b);AG(b);BG(b);CG(b);DG(b);EG(b);FG(b);GG(b);HG(b);IG(b);JG(b);KG(b);LG(b);MG(b);NG(b);OG(b);PG(b);QG(b);RG(b);SG(b);TG(b);UG(b);VG(b);WG(b);XG(b);YG(b);ZG(b);_G(b);$G(b);aH(b);bH(b);cH(b);dH(b);eH(b);fH(b);gH(b);hH(b);iH(b);jH(b);kH(b);lH(b);mH(b);nH(b);oH(b);pH(b);qH(b);rH(b);sH(b);tH(b);uH(b);vH(b);wH(b);xH(b);yH(b);zH(b);AH(b);BH(b);CH(b);DH(b);EH(b);FH(b);GH(b);HH(b);IH(b);JH(b);KH(b);LH(b);MH(b);NH(b);OH(b);PH(b);QH(b);RH(b);SH(b);TH(b);UH(b);VH(b);WH(b);XH(b);YH(b);ZH(b);_H(b);$H(b);aI(b);bI(b);cI(b);dI(b);eI(b);fI(b);gI(b);hI(b);iI(b);jI(b);kI(b);lI(b);mI(b);nI(b);oI(b);pI(b);qI(b);rI(b);sI(b);tI(b);uI(b);vI(b);wI(b);xI(b);yI(b);zI(b);AI(b);BI(b);CI(b);DI(b);EI(b);FI(b);GI(b);HI(b);II(b);JI(b);KI(b);LI(b);MI(b);NI(b);OI(b);PI(b);QI(b);RI(b);SI(b);TI(b);UI(b);VI(b);WI(b);XI(b);YI(b);ZI(b);_I(b);$I(b);aJ(b);bJ(b);cJ(b);dJ(b);eJ(b);fJ(b);gJ(b);hJ(b);iJ(b);jJ(b);kJ(b);lJ(b);mJ(b);nJ(b);oJ(b);pJ(b);qJ(b);rJ(b);sJ(b);tJ(b);uJ(b);vJ(b);wJ(b);xJ(b);yJ(b);zJ(b);AJ(b);BJ(b);CJ(b);DJ(b);EJ(b);FJ(b);GJ(b);HJ(b);IJ(b);JJ(b);KJ(b);LJ(b);MJ(b);NJ(b);OJ(b);PJ(b);QJ(b);RJ(b);SJ(b);TJ(b);UJ(b);VJ(b);WJ(b);XJ(b);YJ(b);ZJ(b);_J(b);$J(b);aK(b);bK(b);cK(b);dK(b);eK(b);fK(b);gK(b);hK(b);iK(b);jK(b);kK(b);lK(b);mK(b);nK(b);oK(b);pK(b);qK(b);rK(b);sK(b);tK(b);uK(b);vK(b);wK(b);xK(b);yK(b);zK(b);AK(b);BK(b);CK(b);DK(b);EK(b);FK(b);GK(b);HK(b);IK(b);JK(b);KK(b);LK(b);MK(b);NK(b);OK(b);PK(b);QK(b);RK(b);SK(b);TK(b);UK(b);VK(b);WK(b);XK(b);YK(b);ZK(b);_K(b);$K(b);aL(b);bL(b);cL(b);dL(b);eL(b);fL(b);gL(b);hL(b);iL(b);jL(b);kL(b);lL(b);mL(b);nL(b);oL(b);pL(b);qL(b);rL(b);sL(b);tL(b);uL(b);vL(b);wL(b);xL(b);yL(b);zL(b);AL(b);BL(b);CL(b);DL(b);EL(b);FL(b);GL(b);HL(b);IL(b);JL(b);KL(b);LL(b);ML(b);NL(b);OL(b);PL(b);QL(b);RL(b);SL(b);TL(b);UL(b);VL(b);WL(b);XL(b);YL(b);ZL(b);_L(b);$L(b);aM(b);bM(b);cM(b);dM(b);eM(b);fM(b);gM(b);hM(b);iM(b);jM(b);kM(b);lM(b);mM(b);nM(b);oM(b);pM(b);qM(b);rM(b);sM(b);tM(b);uM(b);vM(b);wM(b);xM(b);yM(b);zM(b);AM(b);BM(b);CM(b);DM(b);EM(b);FM(b);GM(b);HM(b);IM(b);JM(b);KM(b);LM(b);MM(b);NM(b);OM(b);PM(b);QM(b);RM(b);SM(b);TM(b);UM(b);VM(b);WM(b);XM(b);YM(b);ZM(b);_M(b);$M(b);aN(b);bN(b);cN(b);dN(b);eN(b);fN(b);gN(b);hN(b);iN(b);jN(b);kN(b);lN(b);mN(b);nN(b);oN(b);pN(b);qN(b);rN(b);sN(b);tN(b);uN(b);vN(b);wN(b);xN(b);yN(b);zN(b);AN(b);BN(b);CN(b);DN(b);EN(b);FN(b);GN(b);HN(b);IN(b);JN(b);KN(b);LN(b);MN(b);NN(b);ON(b);PN(b);QN(b);RN(b);SN(b);TN(b);UN(b);VN(b);a[d]=0;i=c;return 0}function XN(a){a=a|0;i=i;return}function YN(a){a=a|0;i=i;return 0}function ZN(a){a=a|0;var b=0,d=0,e=0;a=i;i=i+8|0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;V1(9,1,2784,e);if((c[70924>>2]|0)!=0){Zd[c[17860]&1023](9)}V1(9,1,2808,d);if((c[70924>>2]|0)!=0){Zd[c[17860]&1023](9)}V1(9,1,2832,b);if((c[70924>>2]|0)!=0){Zd[c[17860]&1023](9)}V1(9,1,2856,a);if((c[70924>>2]|0)==0){i=a;return 0}Zd[c[17860]&1023](9);i=a;return 0}function _N(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9864>>3]=0.0;i=i;return}function $N(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9872>>3]=0.0;i=i;return}function aO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9880>>3]=0.0;i=i;return}function bO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9888>>3]=0.0;i=i;return}function cO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9896>>3]=0.0;i=i;return}function dO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9912>>3]=0.0;i=i;return}function eO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9920>>3]=0.0;i=i;return}function fO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9928>>3]=0.0;i=i;return}function gO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9936>>3]=0.0;i=i;return}function hO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9064>>3]=0.0;i=i;return}function iO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9072>>3]=0.0;i=i;return}function jO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9080>>3]=0.0;i=i;return}function kO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9088>>3]=0.0;i=i;return}function lO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9096>>3]=0.0;i=i;return}function mO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9104>>3]=0.0;i=i;return}function nO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9208>>3]=0.0;i=i;return}function oO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9216>>3]=0.0;i=i;return}function pO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9224>>3]=0.0;i=i;return}function qO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9232>>3]=0.0;i=i;return}function rO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9240>>3]=0.0;i=i;return}function sO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9248>>3]=0.0;i=i;return}function tO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9944>>3]=0.0;i=i;return}function uO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9384>>3]=0.0;i=i;return}function vO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9392>>3]=0.0;i=i;return}function wO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9400>>3]=0.0;i=i;return}function xO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9408>>3]=0.0;i=i;return}function yO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9416>>3]=0.0;i=i;return}function zO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9424>>3]=0.0;i=i;return}function AO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9432>>3]=0.0;i=i;return}function BO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9440>>3]=0.0;i=i;return}function CO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9448>>3]=0.0;i=i;return}function DO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9456>>3]=0.0;i=i;return}function EO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9464>>3]=0.0;i=i;return}function FO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9472>>3]=0.0;i=i;return}function GO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9480>>3]=0.0;i=i;return}function HO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9488>>3]=0.0;i=i;return}function IO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9496>>3]=0.0;i=i;return}function JO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9504>>3]=0.0;i=i;return}function KO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9512>>3]=0.0;i=i;return}function LO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9520>>3]=0.0;i=i;return}function MO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9528>>3]=0.0;i=i;return}function NO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9536>>3]=0.0;i=i;return}function OO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9544>>3]=0.0;i=i;return}function PO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9552>>3]=0.0;i=i;return}function QO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9560>>3]=0.0;i=i;return}function RO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9568>>3]=0.0;i=i;return}function SO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9576>>3]=0.0;i=i;return}function TO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9584>>3]=0.0;i=i;return}function UO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9592>>3]=0.0;i=i;return}function VO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9600>>3]=0.0;i=i;return}function WO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9608>>3]=0.0;i=i;return}function XO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9616>>3]=0.0;i=i;return}function YO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9624>>3]=0.0;i=i;return}function ZO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9632>>3]=0.0;i=i;return}function _O(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9640>>3]=0.0;i=i;return}function $O(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9648>>3]=0.0;i=i;return}function aP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9656>>3]=0.0;i=i;return}function bP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9664>>3]=0.0;i=i;return}function cP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9672>>3]=0.0;i=i;return}function dP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9680>>3]=0.0;i=i;return}function eP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9688>>3]=0.0;i=i;return}function fP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9696>>3]=0.0;i=i;return}function gP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9704>>3]=0.0;i=i;return}function hP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9712>>3]=0.0;i=i;return}function iP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9952>>3]=0.0;i=i;return}function jP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9960>>3]=0.0;i=i;return}function kP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9968>>3]=0.0;i=i;return}function lP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9976>>3]=0.0;i=i;return}function mP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9984>>3]=0.0;i=i;return}function nP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9992>>3]=0.0;i=i;return}function oP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1e4>>3]=0.0;i=i;return}function pP(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;i=i+32|0;d=b;e=b+16|0;Yl(d,c[a+536>>2]|0,3);m3(d,e);f=+$2(e,0);h[(c[a+416>>2]|0)+48>>3]=f;i=b;return}function qP(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;i=i+32|0;d=b;e=b+16|0;Yl(d,c[a+536>>2]|0,3);m3(d,e);f=+$2(e,1);h[(c[a+416>>2]|0)+56>>3]=f;i=b;return}function rP(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;i=i+32|0;d=b;e=b+16|0;Yl(d,c[a+536>>2]|0,3);m3(d,e);f=+$2(e,2);h[(c[a+416>>2]|0)+64>>3]=f;i=b;return}function sP(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+72>>3]=+h[b+912>>3];i=i;return}function tP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9328>>3]=+h[(c[a+416>>2]|0)+72>>3]*6.283185307179586;i=i;return}function uP(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+80>>3]=+h[b+24>>3];i=i;return}function vP(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+88>>3]=+h[b+48>>3];i=i;return}function wP(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+Y(+(+h[b+88>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9344>>3]=d*+h[b+80>>3];i=i;return}function xP(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+X(+(+h[b+88>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9336>>3]=d*+h[b+80>>3];i=i;return}function yP(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+96>>3]=+h[b+912>>3];i=i;return}function zP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9048>>3]=+h[(c[a+416>>2]|0)+96>>3]*6.283185307179586;i=i;return}function AP(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+104>>3]=+h[b+32>>3];i=i;return}function BP(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+112>>3]=+h[b+56>>3];i=i;return}function CP(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+Y(+(+h[b+112>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9360>>3]=d*+h[b+104>>3];i=i;return}function DP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9176>>3]=+h[b+9360>>3]- +h[b+9344>>3];i=i;return}function EP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9128>>3]=+h[b+9360>>3]- +h[b+9344>>3];i=i;return}function FP(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+X(+(+h[b+112>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9352>>3]=d*+h[b+104>>3];i=i;return}function GP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9184>>3]=+h[b+9352>>3]- +h[b+9336>>3];i=i;return}function HP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9136>>3]=+h[b+9352>>3]- +h[b+9336>>3];i=i;return}function IP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9024>>3]=+ba(+(+h[b+9128>>3]),+(+h[b+9136>>3]));i=i;return}function JP(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+9136>>3];e=+h[b+9128>>3];h[b+9016>>3]=+V(+(d*d+e*e));i=i;return}function KP(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+120>>3]=+h[b+912>>3];i=i;return}function LP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9056>>3]=+h[(c[a+416>>2]|0)+120>>3]*6.283185307179586;i=i;return}function MP(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+128>>3]=+h[b+40>>3];i=i;return}function NP(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+136>>3]=+h[b+64>>3];i=i;return}function OP(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+Y(+(+h[b+136>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9376>>3]=d*+h[b+128>>3];i=i;return}function PP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9192>>3]=+h[b+9376>>3]- +h[b+9360>>3];i=i;return}function QP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9160>>3]=+h[b+9344>>3]- +h[b+9376>>3];i=i;return}function RP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9144>>3]=+h[b+9376>>3]- +h[b+9360>>3];i=i;return}function SP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9112>>3]=+h[b+9344>>3]- +h[b+9376>>3];i=i;return}function TP(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+X(+(+h[b+136>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9368>>3]=d*+h[b+128>>3];i=i;return}function UP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9200>>3]=+h[b+9368>>3]- +h[b+9352>>3];i=i;return}function VP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9168>>3]=+h[b+9336>>3]- +h[b+9368>>3];i=i;return}function WP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9152>>3]=+h[b+9368>>3]- +h[b+9352>>3];i=i;return}function XP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9040>>3]=+ba(+(+h[b+9144>>3]),+(+h[b+9152>>3]));i=i;return}function YP(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+9152>>3];e=+h[b+9144>>3];h[b+9032>>3]=+V(+(d*d+e*e));i=i;return}function ZP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9120>>3]=+h[b+9336>>3]- +h[b+9368>>3];i=i;return}function _P(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9008>>3]=+ba(+(+h[b+9112>>3]),+(+h[b+9120>>3]));i=i;return}function $P(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+9120>>3];e=+h[b+9112>>3];h[b+9e3>>3]=+V(+(d*d+e*e));i=i;return}function aQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+944>>3]=+h[b+928>>3];i=i;return}function bQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9904>>3]=+h[b+920>>3]*(+h[b+936>>3]*(+h[b+944>>3]- +h[b+928>>3])+1.0);i=i;return}function cQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+240>>3]=+h[b+288>>3];i=i;return}function dQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+248>>3]=+h[b+296>>3];i=i;return}function eQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+256>>3]=+h[b+304>>3];i=i;return}function fQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+264>>3]=+h[b>>3];i=i;return}function gQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+272>>3]=+h[b+8>>3];i=i;return}function hQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+280>>3]=+h[b+16>>3];i=i;return}function iQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+336>>3]=+h[b+240>>3];i=i;return}function jQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+344>>3]=+h[b+264>>3];i=i;return}function kQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+352>>3]=+h[b+288>>3];i=i;return}function lQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+360>>3]=+h[b+312>>3];i=i;return}function mQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9320>>3]=+h[b+344>>3]*(+h[b+360>>3]*(+h[b+336>>3]- +h[b+352>>3])+1.0);i=i;return}function nQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+368>>3]=+h[b+248>>3];i=i;return}function oQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+376>>3]=+h[b+272>>3];i=i;return}function pQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+384>>3]=+h[b+296>>3];i=i;return}function qQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+392>>3]=+h[b+320>>3];i=i;return}function rQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9312>>3]=+h[b+376>>3]*(+h[b+392>>3]*(+h[b+368>>3]- +h[b+384>>3])+1.0);i=i;return}function sQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+400>>3]=+h[b+256>>3];i=i;return}function tQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+408>>3]=+h[b+280>>3];i=i;return}function uQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+416>>3]=+h[b+304>>3];i=i;return}function vQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+424>>3]=+h[b+328>>3];i=i;return}function wQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9304>>3]=+h[b+408>>3]*(+h[b+424>>3]*(+h[b+400>>3]- +h[b+416>>3])+1.0);i=i;return}function xQ(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+968>>3];j=+h[f+960>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$1(c[b+536>>2]|0,g,2888,2880,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1016>>3]=l;i=d;return}function yQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1048>>3]=+h[b+992>>3]/89999.99999999997*.5;i=i;return}function zQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1064>>3]=+h[b+992>>3]/3.0e4*.5;i=i;return}function AQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0,w=0,x=0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+1048>>3];m=694444444444445.0e-19-l*l;if(!(m>=0.0)){n=c[30092]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=3080;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ae[p&63](o,e,2928,f);r=c[g>>2]|0}else{r=j}l=+h[r+952>>3]*6.283185307179586;s=+V(+m);if(l!=0.0){t=r;u=s/l;v=t;w=v+1072|0;x=w;h[x>>3]=u;i=d;return}if(s==0.0){t=r;u=s;v=t;w=v+1072|0;x=w;h[x>>3]=u;i=d;return}m=s/+$1(c[b+536>>2]|0,l,3032,2912,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);t=c[g>>2]|0;u=m;v=t;w=v+1072|0;x=w;h[x>>3]=u;i=d;return}function BQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0,w=0,x=0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+1064>>3];m=.0006250000000000001-l*l;if(!(m>=0.0)){n=c[30092]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=3080;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ae[p&63](o,e,3104,f);r=c[g>>2]|0}else{r=j}l=+h[r+952>>3]*6.283185307179586;s=+V(+m);if(l!=0.0){t=r;u=s/l;v=t;w=v+1080|0;x=w;h[x>>3]=u;i=d;return}if(s==0.0){t=r;u=s;v=t;w=v+1080|0;x=w;h[x>>3]=u;i=d;return}m=s/+$1(c[b+536>>2]|0,l,3032,3072,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);t=c[g>>2]|0;u=m;v=t;w=v+1080|0;x=w;h[x>>3]=u;i=d;return}function CQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1088>>3]=+h[b+1016>>3];i=i;return}function DQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1096>>3]=+h[b+1048>>3];i=i;return}function EQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1120>>3]=+h[b+1072>>3];i=i;return}function FQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1128>>3]=+h[b+1064>>3];i=i;return}function GQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1152>>3]=+h[b+1080>>3];i=i;return}function HQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1176>>3]=+h[b+1088>>3]*1.154700538379252;i=i;return}function IQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1184>>3]=+h[b+1160>>3];i=i;return}function JQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1192>>3]=+h[b+1168>>3];i=i;return}function KQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1208>>3]=+h[b+1184>>3];i=i;return}function LQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1216>>3]=+h[b+1184>>3];i=i;return}function MQ(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+1808>>2]=c[b+1780>>2];i=i;return}function NQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+432>>3]=+h[b+1104>>3];i=i;return}function OQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+440>>3]=+h[b+1104>>3];i=i;return}function PQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+448>>3]=+h[b+1104>>3];i=i;return}function QQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+456>>3]=+h[b+1096>>3];i=i;return}function RQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+464>>3]=+h[b+1096>>3];i=i;return}function SQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+472>>3]=+h[b+1096>>3];i=i;return}function TQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+480>>3]=+h[b+1104>>3];i=i;return}function UQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+488>>3]=+h[b+1104>>3];i=i;return}function VQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+496>>3]=+h[b+1104>>3];i=i;return}function WQ(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1112>>3];j=g*(+h[f+1104>>3]+-293.15)+1.0;do{if(j!=0.0){k=f;l=g/j}else{if(g==0.0){k=f;l=g;break}m=g/+$1(c[b+536>>2]|0,j,3216,3208,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+504>>3]=l;i=d;return}function XQ(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1112>>3];j=g*(+h[f+1104>>3]+-293.15)+1.0;do{if(j!=0.0){k=f;l=g/j}else{if(g==0.0){k=f;l=g;break}m=g/+$1(c[b+536>>2]|0,j,3216,3280,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+512>>3]=l;i=d;return}function YQ(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1112>>3];j=g*(+h[f+1104>>3]+-293.15)+1.0;do{if(j!=0.0){k=f;l=g/j}else{if(g==0.0){k=f;l=g;break}m=g/+$1(c[b+536>>2]|0,j,3216,3288,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+520>>3]=l;i=d;return}function ZQ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+528>>3]=+h[b+432>>3];i=i;return}function _Q(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+536>>3]=+h[b+456>>3];i=i;return}function $Q(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+544>>3]=+h[b+480>>3];i=i;return}function aR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+552>>3]=+h[b+504>>3];i=i;return}function bR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9296>>3]=+h[b+536>>3]*(+h[b+552>>3]*(+h[b+1208>>3]- +h[b+544>>3])+1.0);i=i;return}function cR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+560>>3]=+h[b+440>>3];i=i;return}function dR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+568>>3]=+h[b+464>>3];i=i;return}function eR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+576>>3]=+h[b+488>>3];i=i;return}function fR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+584>>3]=+h[b+512>>3];i=i;return}function gR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9288>>3]=+h[b+568>>3]*(+h[b+584>>3]*(+h[b+1208>>3]- +h[b+576>>3])+1.0);i=i;return}function hR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+592>>3]=+h[b+448>>3];i=i;return}function iR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+600>>3]=+h[b+472>>3];i=i;return}function jR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+608>>3]=+h[b+496>>3];i=i;return}function kR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+616>>3]=+h[b+520>>3];i=i;return}function lR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9280>>3]=+h[b+600>>3]*(+h[b+616>>3]*(+h[b+1208>>3]- +h[b+608>>3])+1.0);i=i;return}function mR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+624>>3]=+h[b+1120>>3];i=i;return}function nR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+632>>3]=+h[b+1120>>3];i=i;return}function oR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+640>>3]=+h[b+1120>>3];i=i;return}function pR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+648>>3]=+h[b+624>>3];i=i;return}function qR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+656>>3]=+h[b+632>>3];i=i;return}function rR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+664>>3]=+h[b+640>>3];i=i;return}function sR(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+1868>>2]=c[b+1840>>2];i=i;return}function tR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+672>>3]=+h[b+1136>>3];i=i;return}function uR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+680>>3]=+h[b+1136>>3];i=i;return}function vR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+688>>3]=+h[b+1136>>3];i=i;return}function wR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+696>>3]=+h[b+1128>>3];i=i;return}function xR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+704>>3]=+h[b+1128>>3];i=i;return}function yR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+712>>3]=+h[b+1128>>3];i=i;return}function zR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+720>>3]=+h[b+1136>>3];i=i;return}function AR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+728>>3]=+h[b+1136>>3];i=i;return}function BR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+736>>3]=+h[b+1136>>3];i=i;return}function CR(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1144>>3];j=g*(+h[f+1136>>3]+-293.15)+1.0;do{if(j!=0.0){k=f;l=g/j}else{if(g==0.0){k=f;l=g;break}m=g/+$1(c[b+536>>2]|0,j,3304,3296,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+744>>3]=l;i=d;return}function DR(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1144>>3];j=g*(+h[f+1136>>3]+-293.15)+1.0;do{if(j!=0.0){k=f;l=g/j}else{if(g==0.0){k=f;l=g;break}m=g/+$1(c[b+536>>2]|0,j,3304,3368,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+752>>3]=l;i=d;return}function ER(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1144>>3];j=g*(+h[f+1136>>3]+-293.15)+1.0;do{if(j!=0.0){k=f;l=g/j}else{if(g==0.0){k=f;l=g;break}m=g/+$1(c[b+536>>2]|0,j,3304,3376,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+760>>3]=l;i=d;return}function FR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+768>>3]=+h[b+672>>3];i=i;return}function GR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+776>>3]=+h[b+696>>3];i=i;return}function HR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+784>>3]=+h[b+720>>3];i=i;return}function IR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+792>>3]=+h[b+744>>3];i=i;return}function JR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9272>>3]=+h[b+776>>3]*(+h[b+792>>3]*(+h[b+1216>>3]- +h[b+784>>3])+1.0);i=i;return}function KR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+800>>3]=+h[b+680>>3];i=i;return}function LR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+808>>3]=+h[b+704>>3];i=i;return}function MR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+816>>3]=+h[b+728>>3];i=i;return}function NR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+824>>3]=+h[b+752>>3];i=i;return}function OR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9264>>3]=+h[b+808>>3]*(+h[b+824>>3]*(+h[b+1216>>3]- +h[b+816>>3])+1.0);i=i;return}function PR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+832>>3]=+h[b+688>>3];i=i;return}function QR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+840>>3]=+h[b+712>>3];i=i;return}function RR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+848>>3]=+h[b+736>>3];i=i;return}function SR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+856>>3]=+h[b+760>>3];i=i;return}function TR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9256>>3]=+h[b+840>>3]*(+h[b+856>>3]*(+h[b+1216>>3]- +h[b+848>>3])+1.0);i=i;return}function UR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+864>>3]=+h[b+1152>>3];i=i;return}function VR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+872>>3]=+h[b+1152>>3];i=i;return}function WR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+880>>3]=+h[b+1152>>3];i=i;return}function XR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+888>>3]=+h[b+864>>3];i=i;return}function YR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+896>>3]=+h[b+872>>3];i=i;return}function ZR(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+904>>3]=+h[b+880>>3];i=i;return}function _R(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1224>>3]=+h[b+1176>>3];i=i;return}function $R(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1232>>3]=+h[b+1176>>3];i=i;return}function aS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[3384]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1900>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(3400,M2(c[(c[g>>2]|0)+1900>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=3592;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[3384]=1;i=d;return}function bS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[3616]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1324>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1324>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(3624,M2(c[(c[g>>2]|0)+1324>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[3616]=1;i=d;return}function cS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[3936]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1320>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(3944,M2(c[(c[g>>2]|0)+1320>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[3936]=1;i=d;return}function dS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[4104]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1312>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1312>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(4112,M2(c[(c[g>>2]|0)+1312>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[4104]=1;i=d;return}function eS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[4328]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1308>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(4336,M2(c[(c[g>>2]|0)+1308>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[4328]=1;i=d;return}function fS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[4496]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1300>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1300>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(4504,M2(c[(c[g>>2]|0)+1300>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[4496]=1;i=d;return}function gS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[4720]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1296>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(4728,M2(c[(c[g>>2]|0)+1296>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[4720]=1;i=d;return}function hS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[4888]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1892>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(4896,M2(c[(c[g>>2]|0)+1892>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[4888]=1;i=d;return}function iS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[5024]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1288>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1288>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(5032,M2(c[(c[g>>2]|0)+1288>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[5024]=1;i=d;return}function jS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[5248]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1284>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(5256,M2(c[(c[g>>2]|0)+1284>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[5248]=1;i=d;return}function kS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[5416]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1276>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1276>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(5424,M2(c[(c[g>>2]|0)+1276>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[5416]=1;i=d;return}function lS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[5640]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1272>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(5648,M2(c[(c[g>>2]|0)+1272>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[5640]=1;i=d;return}function mS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[5808]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1264>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1264>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(5816,M2(c[(c[g>>2]|0)+1264>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[5808]=1;i=d;return}function nS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6032]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1260>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(6040,M2(c[(c[g>>2]|0)+1260>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[6032]=1;i=d;return}function oS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6200]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1884>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(6208,M2(c[(c[g>>2]|0)+1884>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58112;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[6200]=1;i=d;return}function pS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6336]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1872>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(6344,M2(c[(c[g>>2]|0)+1872>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[6336]=1;i=d;return}function qS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6448]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+848>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(6464,K2(+h[(c[g>>2]|0)+848>>3],6456)|0)|0;g=c[30094]|0;j=e;k=41456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[6448]=1;i=d;return}function rS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6688]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(6696,K2(+h[(c[g>>2]|0)+832>>3],6456)|0)|0;g=c[30094]|0;j=e;k=41344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[6688]=1;i=d;return}function sS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6904]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+816>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(6912,K2(+h[(c[g>>2]|0)+816>>3],6456)|0)|0;g=c[30094]|0;j=e;k=41456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[6904]=1;i=d;return}function tS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7040]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+800>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(7048,K2(+h[(c[g>>2]|0)+800>>3],6456)|0)|0;g=c[30094]|0;j=e;k=41344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[7040]=1;i=d;return}function uS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7168]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+784>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(7176,K2(+h[(c[g>>2]|0)+784>>3],6456)|0)|0;g=c[30094]|0;j=e;k=41456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[7168]=1;i=d;return}function vS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7304]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+768>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(7312,K2(+h[(c[g>>2]|0)+768>>3],6456)|0)|0;g=c[30094]|0;j=e;k=41344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[7304]=1;i=d;return}function wS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7432]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(7440,K2(+h[(c[g>>2]|0)+736>>3],6456)|0)|0;g=c[30094]|0;j=e;k=25536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[7432]=1;i=d;return}function xS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7544]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+728>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(7552,K2(+h[(c[g>>2]|0)+728>>3],6456)|0)|0;g=c[30094]|0;j=e;k=25536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[7544]=1;i=d;return}function yS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7656]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+720>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(7664,K2(+h[(c[g>>2]|0)+720>>3],6456)|0)|0;g=c[30094]|0;j=e;k=25536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[7656]=1;i=d;return}function zS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7768]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(7776,K2(+h[(c[g>>2]|0)+688>>3],6456)|0)|0;g=c[30094]|0;j=e;k=25824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[7768]=1;i=d;return}function AS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7952]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(7960,K2(+h[(c[g>>2]|0)+680>>3],6456)|0)|0;g=c[30094]|0;j=e;k=25824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[7952]=1;i=d;return}function BS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8056]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+672>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(8064,K2(+h[(c[g>>2]|0)+672>>3],6456)|0)|0;g=c[30094]|0;j=e;k=25824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[8056]=1;i=d;return}function CS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8160]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1868>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(8168,M2(c[(c[g>>2]|0)+1868>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=25928;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[8160]=1;i=d;return}function DS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8264]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1252>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1252>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(8272,M2(c[(c[g>>2]|0)+1252>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[8264]=1;i=d;return}function ES(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8472]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1248>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(8480,M2(c[(c[g>>2]|0)+1248>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[8472]=1;i=d;return}function FS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8624]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1240>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1240>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(8632,M2(c[(c[g>>2]|0)+1240>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[8624]=1;i=d;return}function GS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8832]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1236>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(8840,M2(c[(c[g>>2]|0)+1236>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[8832]=1;i=d;return}function HS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8984]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1228>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1228>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(8992,M2(c[(c[g>>2]|0)+1228>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[8984]=1;i=d;return}function IS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9192]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1224>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(9200,M2(c[(c[g>>2]|0)+1224>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[9192]=1;i=d;return}function JS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9344]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1860>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(9352,M2(c[(c[g>>2]|0)+1860>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[9344]=1;i=d;return}function KS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9472]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1216>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1216>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(9480,M2(c[(c[g>>2]|0)+1216>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[9472]=1;i=d;return}function LS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9680]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1212>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(9688,M2(c[(c[g>>2]|0)+1212>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[9680]=1;i=d;return}function MS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9832]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1204>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1204>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(9840,M2(c[(c[g>>2]|0)+1204>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[9832]=1;i=d;return}function NS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10040]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1200>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(10048,M2(c[(c[g>>2]|0)+1200>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[10040]=1;i=d;return}function OS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10192]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1192>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1192>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(10200,M2(c[(c[g>>2]|0)+1192>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[10192]=1;i=d;return}function PS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10400]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1188>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(10408,M2(c[(c[g>>2]|0)+1188>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[10400]=1;i=d;return}function QS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10552]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1852>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(10560,M2(c[(c[g>>2]|0)+1852>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58112;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[10552]=1;i=d;return}function RS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10680]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1840>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(10688,M2(c[(c[g>>2]|0)+1840>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[10680]=1;i=d;return}function SS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10776]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1180>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1180>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(10784,M2(c[(c[g>>2]|0)+1180>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[10776]=1;i=d;return}function TS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11e3]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1176>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(11008,M2(c[(c[g>>2]|0)+1176>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[11e3]=1;i=d;return}function US(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11168]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1168>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1168>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(11176,M2(c[(c[g>>2]|0)+1168>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[11168]=1;i=d;return}function VS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11392]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1164>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(11400,M2(c[(c[g>>2]|0)+1164>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[11392]=1;i=d;return}function WS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11560]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1156>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1156>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(11568,M2(c[(c[g>>2]|0)+1156>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[11560]=1;i=d;return}function XS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11784]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1152>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(11792,M2(c[(c[g>>2]|0)+1152>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[11784]=1;i=d;return}function YS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11952]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1832>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(11960,M2(c[(c[g>>2]|0)+1832>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[11952]=1;i=d;return}function ZS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12088]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1144>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1144>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(12096,M2(c[(c[g>>2]|0)+1144>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[12088]=1;i=d;return}function _S(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12312]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1140>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(12320,M2(c[(c[g>>2]|0)+1140>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[12312]=1;i=d;return}function $S(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12480]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1132>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1132>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(12488,M2(c[(c[g>>2]|0)+1132>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[12480]=1;i=d;return}function aT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12704]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1128>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(12712,M2(c[(c[g>>2]|0)+1128>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[12704]=1;i=d;return}function bT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12872]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1120>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1120>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(12880,M2(c[(c[g>>2]|0)+1120>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[12872]=1;i=d;return}function cT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13096]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1116>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(13104,M2(c[(c[g>>2]|0)+1116>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[13096]=1;i=d;return}function dT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13264]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1824>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(13272,M2(c[(c[g>>2]|0)+1824>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58112;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[13264]=1;i=d;return}function eT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13400]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1812>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(13408,M2(c[(c[g>>2]|0)+1812>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[13400]=1;i=d;return}function fT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13512]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+608>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(13520,K2(+h[(c[g>>2]|0)+608>>3],6456)|0)|0;g=c[30094]|0;j=e;k=41456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[13512]=1;i=d;return}function gT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13648]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+592>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(13656,K2(+h[(c[g>>2]|0)+592>>3],6456)|0)|0;g=c[30094]|0;j=e;k=41344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[13648]=1;i=d;return}function hT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13776]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+576>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(13784,K2(+h[(c[g>>2]|0)+576>>3],6456)|0)|0;g=c[30094]|0;j=e;k=41456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[13776]=1;i=d;return}function iT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13912]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+560>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(13920,K2(+h[(c[g>>2]|0)+560>>3],6456)|0)|0;g=c[30094]|0;j=e;k=41344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[13912]=1;i=d;return}function jT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14040]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+544>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(14048,K2(+h[(c[g>>2]|0)+544>>3],6456)|0)|0;g=c[30094]|0;j=e;k=41456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[14040]=1;i=d;return}function kT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14176]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+528>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(14184,K2(+h[(c[g>>2]|0)+528>>3],6456)|0)|0;g=c[30094]|0;j=e;k=41344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[14176]=1;i=d;return}function lT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14304]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+496>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(14312,K2(+h[(c[g>>2]|0)+496>>3],6456)|0)|0;g=c[30094]|0;j=e;k=25536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[14304]=1;i=d;return}function mT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14416]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+488>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(14424,K2(+h[(c[g>>2]|0)+488>>3],6456)|0)|0;g=c[30094]|0;j=e;k=25536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[14416]=1;i=d;return}function nT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14528]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+480>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(14536,K2(+h[(c[g>>2]|0)+480>>3],6456)|0)|0;g=c[30094]|0;j=e;k=25536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[14528]=1;i=d;return}function oT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14640]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+448>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(14648,K2(+h[(c[g>>2]|0)+448>>3],6456)|0)|0;g=c[30094]|0;j=e;k=25824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[14640]=1;i=d;return}function pT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14744]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+440>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(14752,K2(+h[(c[g>>2]|0)+440>>3],6456)|0)|0;g=c[30094]|0;j=e;k=25824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[14744]=1;i=d;return}function qT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14848]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+432>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(14856,K2(+h[(c[g>>2]|0)+432>>3],6456)|0)|0;g=c[30094]|0;j=e;k=25824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[14848]=1;i=d;return}function rT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14952]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1808>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(14960,M2(c[(c[g>>2]|0)+1808>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=25928;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[14952]=1;i=d;return}function sT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15056]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1108>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1108>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(15064,M2(c[(c[g>>2]|0)+1108>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[15056]=1;i=d;return}function tT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15264]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1104>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(15272,M2(c[(c[g>>2]|0)+1104>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[15264]=1;i=d;return}function uT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15416]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1096>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1096>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(15424,M2(c[(c[g>>2]|0)+1096>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[15416]=1;i=d;return}function vT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15624]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1092>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(15632,M2(c[(c[g>>2]|0)+1092>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[15624]=1;i=d;return}function wT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15776]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1084>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1084>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(15784,M2(c[(c[g>>2]|0)+1084>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[15776]=1;i=d;return}function xT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15984]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1080>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(15992,M2(c[(c[g>>2]|0)+1080>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[15984]=1;i=d;return}function yT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16136]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1800>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(16144,M2(c[(c[g>>2]|0)+1800>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[16136]=1;i=d;return}function zT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16264]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1072>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1072>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(16272,M2(c[(c[g>>2]|0)+1072>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[16264]=1;i=d;return}function AT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16472]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1068>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(16480,M2(c[(c[g>>2]|0)+1068>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[16472]=1;i=d;return}function BT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16624]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1060>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1060>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(16632,M2(c[(c[g>>2]|0)+1060>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[16624]=1;i=d;return}function CT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16832]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1056>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(16840,M2(c[(c[g>>2]|0)+1056>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[16832]=1;i=d;return}function DT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16984]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+1048>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+1048>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(16992,M2(c[(c[g>>2]|0)+1048>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[16984]=1;i=d;return}function ET(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17192]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1044>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(17200,M2(c[(c[g>>2]|0)+1044>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[17192]=1;i=d;return}function FT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17344]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1792>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(17352,M2(c[(c[g>>2]|0)+1792>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58112;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[17344]=1;i=d;return}function GT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17472]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1780>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(17480,M2(c[(c[g>>2]|0)+1780>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[17472]=1;i=d;return}function HT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17568]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+1200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(17576,K2(+h[(c[g>>2]|0)+1200>>3],6456)|0)|0;g=c[30094]|0;j=e;k=17808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[17568]=1;i=d;return}function IT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17832]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+1192>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(17840,K2(+h[(c[g>>2]|0)+1192>>3],6456)|0)|0;g=c[30094]|0;j=e;k=18040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[17832]=1;i=d;return}function JT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18064]&1){i=d;return}g=b+416|0;if(!((y5(+h[(c[g>>2]|0)+1184>>3],0.0)|0)<<24>>24==0)){i=d;return}b=O2(18072,K2(+h[(c[g>>2]|0)+1184>>3],6456)|0)|0;g=c[30094]|0;j=e;k=18192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];we[g&15](e,b,f);a[18064]=1;i=d;return}



function j8(a){a=a|0;var b=0,d=0;b=i;d=n8(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function k8(a){a=a|0;var b=0;b=i;l8(a);i=b;return}function l8(a){a=a|0;var b=0;b=i;m8(a,0);i=b;return}function m8(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=n8(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}ae[c[(o8(e)|0)>>2]&127](f)|0;i=d;return}function n8(a){a=a|0;var b=0,c=0;b=i;c=q8(a)|0;i=b;return c|0}function o8(a){a=a|0;var b=0,c=0;b=i;c=p8(a)|0;i=b;return c|0}function p8(a){a=a|0;i=i;return a+4|0}function q8(a){a=a|0;i=i;return a|0}function r8(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(t8(f)|0)>>2]|0;s8(a,d,c[(u8(g)|0)>>2]|0);i=e;return}function s8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;v8(a,b,c);i=d;return}function t8(a){a=a|0;i=i;return a|0}function u8(a){a=a|0;i=i;return a|0}function v8(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(x8(f)|0)>>2]|0;w8(a,d,c[(y8(g)|0)>>2]|0);i=e;return}function w8(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;c[a>>2]=c[(x8(f)|0)>>2];c[a+4>>2]=c[(y8(g)|0)>>2];i=e;return}function x8(a){a=a|0;i=i;return a|0}function y8(a){a=a|0;i=i;return a|0}function z8(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;J=c[d+4>>2]|0;i=b;return c[d>>2]|0}function A8(a){a=a|0;var b=0;b=i;B8(a+300|0);B8(a+288|0);B8(a+276|0);B8(a+264|0);B8(a+252|0);B8(a+240|0);C8(a);i=b;return}function B8(a){a=a|0;var b=0;b=i;m9(a);i=b;return}function C8(a){a=a|0;var b=0;b=i;D8(a,113336);wna(a+104|0);i=b;return}function D8(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];H8(a+4|0);i=d;return}function E8(a){a=a|0;var b=0;b=i;C8(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function F8(a){a=a|0;var b=0;b=i;C8(a);Rwa(a);i=b;return}function G8(a){a=a|0;var b=0;b=i;F8(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function H8(a){a=a|0;var b=0;b=i;I8(a);i=b;return}function I8(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=113464;h8(b)|0;do{if((a[b+96|0]|0)!=0){e=c[b+32>>2]|0;if((e|0)==0){break}Swa(e)}}while(0);do{if((a[b+97|0]|0)!=0){e=c[b+56>>2]|0;if((e|0)==0){break}Swa(e)}}while(0);Fna(b);i=d;return}function J8(a){a=a|0;var b=0;b=i;H8(a);Rwa(a);i=b;return}function K8(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;ae[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=k9(d)|0;c[b+68>>2]=f;d=b+98|0;g=a[d]|0;h=l9(f)|0;a[d]=h&1;if((g&255|0)==(h&1|0)){i=e;return}h=b;Pna(h,0,0,0);Una(h,0,0);h=b+96|0;g=(a[h]|0)!=0;if((a[d]|0)!=0){d=b+32|0;do{if(g){f=c[d>>2]|0;if((f|0)==0){break}Swa(f)}}while(0);f=b+97|0;a[h]=a[f]|0;j=b+60|0;c[b+52>>2]=c[j>>2];k=b+56|0;c[d>>2]=c[k>>2];c[j>>2]=0;c[k>>2]=0;a[f]=0;i=e;return}do{if(!g){f=b+32|0;k=c[f>>2]|0;if((k|0)==(b+44|0)){break}j=c[b+52>>2]|0;c[b+60>>2]=j;c[b+56>>2]=k;a[b+97|0]=0;c[f>>2]=Qwa(j)|0;a[h]=1;i=e;return}}while(0);h=c[b+52>>2]|0;c[b+60>>2]=h;c[b+56>>2]=Qwa(h)|0;a[b+97|0]=1;i=e;return}function L8(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=f+8|0;c[g>>2]=e;e=b;Pna(e,0,0,0);Una(e,0,0);j=b+96|0;do{if((a[j]|0)!=0){k=c[b+32>>2]|0;if((k|0)==0){break}Swa(k)}}while(0);k=b+97|0;do{if((a[k]|0)!=0){l=c[b+56>>2]|0;if((l|0)==0){break}Swa(l)}}while(0);l=c[g>>2]|0;m=b+52|0;c[m>>2]=l;do{if(l>>>0>8){n=a[b+98|0]|0;if(n<<24>>24==0|(d|0)==0){c[b+32>>2]=Qwa(l)|0;a[j]=1;o=n;break}else{c[b+32>>2]=d;a[j]=0;o=n;break}}else{c[b+32>>2]=b+44;c[m>>2]=8;a[j]=0;o=a[b+98|0]|0}}while(0);if(!(o<<24>>24==0)){c[b+60>>2]=0;c[b+56>>2]=0;a[k]=0;i=f;return e|0}c[h>>2]=8;o=c[(h9(g,h)|0)>>2]|0;c[b+60>>2]=o;if((d|0)!=0&o>>>0>7){c[b+56>>2]=d;a[k]=0;i=f;return e|0}else{c[b+56>>2]=Qwa(o)|0;a[k]=1;i=f;return e|0}return 0}function M8(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g;j=g+8|0;k=g+24|0;l=k;m=c[b+68>>2]|0;if((m|0)==0){n=Dc(4)|0;owa(n);Ld(n|0,160792,127)}n=d9(m)|0;m=b+64|0;do{if((c[m>>2]|0)!=0){o=(n|0)>0;if(!(o|(d|0)==0&(e|0)==0)){break}if((ae[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}if(!(f>>>0<3)){l7(a,-1,-1);i=g;return}p=c[m>>2]|0;if(o){o=Exa(n|0,((n|0)<0)<<31>>31|0,d|0,e|0)|0;q=o}else{q=0}if((Uc(p|0,q|0,f|0)|0)==0){p=xb(c[m>>2]|0)|0;l7(j,p,((p|0)<0)<<31>>31);p=b+72|0;o=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=o;o=h;r=l;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];g9(j,h);r=a;o=j;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];i=g;return}else{l7(a,-1,-1);i=g;return}}}while(0);l7(a,-1,-1);i=g;return}function N8(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=f;h=b+64|0;do{if((c[h>>2]|0)!=0){if((ae[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}j=c[h>>2]|0;k=z8(d)|0;if((Uc(j|0,k|0,0)|0)==0){f9(g,d);k=f;j=c[k+4>>2]|0;l=b+72|0;c[l>>2]=c[k>>2];c[l+4>>2]=j;j=a;l=d;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=e;return}else{l7(a,-1,-1);i=e;return}}}while(0);l7(a,-1,-1);i=e;return}function O8(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=Dc(4)|0;owa(m);Ld(m|0,160792,127)}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;do{if((a[b+98|0]|0)==0){p=d9(l)|0;q=b+36|0;o=c[q>>2]|0;r=(c[b+40>>2]|0)-o|0;s=b;if((p|0)>0){t=Nna(s)|0;u=(fa(t-(Mna(s)|0)|0,p)|0)+r|0;v=0;break}p=Mna(s)|0;if((p|0)==(Nna(s)|0)){u=r;v=0;break}t=c[k>>2]|0;w=b+32|0;x=c[w>>2]|0;y=e9(t,g,x,o,p-(Lna(s)|0)|0)|0;u=r-y+(c[q>>2]|0)-(c[w>>2]|0)|0;v=1}else{w=b;q=Nna(w)|0;u=q-(Mna(w)|0)|0;v=0}}while(0);if((Uc(c[h>>2]|0,0-u|0,1)|0)!=0){j=-1;i=d;return j|0}if(v){w=f;q=c[w+4>>2]|0;y=b+72|0;c[y>>2]=c[w>>2];c[y+4>>2]=q}q=c[b+32>>2]|0;c[b+40>>2]=q;c[b+36>>2]=q;Pna(b,0,0,0);c[m>>2]=0}else{q=b;y=Rna(q)|0;do{if((y|0)!=(Qna(q)|0)){if((pe[c[(c[b>>2]|0)+52>>2]&63](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);q=b+72|0;y=b+32|0;w=b+52|0;while(1){r=c[y>>2]|0;s=c9(c[k>>2]|0,q,r,r+(c[w>>2]|0)|0,e)|0;r=c[y>>2]|0;p=(c[e>>2]|0)-r|0;if((qc(r|0,1,p|0,c[h>>2]|0)|0)!=(p|0)){j=-1;z=23;break}if((s|0)==2){j=-1;z=23;break}else if((s|0)!=1){z=10;break}}if((z|0)==10){if((nd(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((z|0)==23){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function P8(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=b+64|0;if((c[l>>2]|0)==0){m=-1;i=d;return m|0}n=Z8(b)|0;o=b;if((Mna(o)|0)==0){p=e+1|0;Pna(o,e,p,p)}if(n){q=0}else{n=Nna(o)|0;c[f>>2]=(n-(Lna(o)|0)|0)/2|0;c[g>>2]=4;q=c[(_8(f,g)|0)>>2]|0}g=Mna(o)|0;do{if((g|0)==(Nna(o)|0)){oxa(Lna(o)|0,g+(0-q)|0,q|0)|0;if((a[b+98|0]|0)!=0){f=Nna(o)|0;n=Lna(o)|0;p=rb(n+q|0,1,f-q-n|0,c[l>>2]|0)|0;if((p|0)==0){r=-1;break}n=Lna(o)|0;Pna(o,n,n+q|0,n+(p+q)|0);r=X8(a[Mna(o)|0]|0)|0;break}p=b+32|0;n=b+36|0;f=c[n>>2]|0;s=b+40|0;oxa(c[p>>2]|0,f|0,(c[s>>2]|0)-f|0)|0;f=c[p>>2]|0;t=f+((c[s>>2]|0)-(c[n>>2]|0))|0;c[n>>2]=t;if((f|0)==(b+44|0)){u=8}else{u=c[b+52>>2]|0}v=f+u|0;c[s>>2]=v;f=b+60|0;c[h>>2]=(c[f>>2]|0)-q;c[j>>2]=v-t;v=c[(_8(h,j)|0)>>2]|0;w=b+72|0;x=w;y=c[x+4>>2]|0;z=b+80|0;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=rb(t|0,1,v|0,c[l>>2]|0)|0;if((y|0)==0){r=-1;break}v=c[b+68>>2]|0;if((v|0)==0){t=Dc(4)|0;owa(t);Ld(t|0,160792,127)}t=(c[n>>2]|0)+y|0;c[s>>2]=t;y=c[p>>2]|0;z=Lna(o)|0;if(($8(v,w,y,t,n,z+q|0,z+(c[f>>2]|0)|0,k)|0)==3){f=c[p>>2]|0;Pna(o,f,f,c[s>>2]|0);r=X8(a[Mna(o)|0]|0)|0;break}s=c[k>>2]|0;f=Lna(o)|0;p=f+q|0;if((s|0)==(p|0)){r=-1;break}Pna(o,f,p,s);r=X8(a[Mna(o)|0]|0)|0}else{r=X8(a[g]|0)|0}}while(0);if((Lna(o)|0)!=(e|0)){m=r;i=d;return m|0}Pna(o,0,0,0);m=r;i=d;return m|0}function Q8(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[b+64>>2]|0)==0){f=-1;i=e;return f|0}g=b;h=Lna(g)|0;j=Mna(g)|0;if(!(h>>>0<j>>>0)){f=-1;i=e;return f|0}if(T8(d,-1)|0){Ona(g,-1);f=W8(d)|0;i=e;return f|0}h=(c[b+88>>2]&16|0)==0;b=U8(d)|0;do{if(h){if(Y8(b,a[j+ -1|0]|0)|0){break}else{f=-1}i=e;return f|0}}while(0);Ona(g,-1);a[Mna(g)|0]=b;f=d;i=e;return f|0}function R8(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}S8(b);l=b;m=Qna(l)|0;n=Sna(l)|0;if(!(T8(d,-1)|0)){if((Rna(l)|0)==0){Una(l,f,f+1|0)}f=U8(d)|0;a[Rna(l)|0]=f;Tna(l,1)}f=Rna(l)|0;o=Qna(l)|0;if((f|0)!=(o|0)){a:do{if((a[b+98|0]|0)==0){p=b+32|0;q=c[p>>2]|0;c[g>>2]=q;r=b+68|0;s=c[r>>2]|0;if((s|0)==0){t=Dc(4)|0;u=t;owa(u);v=160792;w=127;Ld(t|0,v|0,w|0)}x=b+72|0;y=b+52|0;z=q;q=s;while(1){s=Qna(l)|0;A=Rna(l)|0;B=V8(q,x,s,A,h,z,z+(c[y>>2]|0)|0,g)|0;A=c[h>>2]|0;C=Qna(l)|0;if((A|0)==(C|0)){k=-1;D=22;break}if((B|0)==3){D=14;break}if(!(B>>>0<2)){k=-1;D=22;break}A=c[p>>2]|0;s=(c[g>>2]|0)-A|0;if((qc(A|0,1,s|0,c[j>>2]|0)|0)!=(s|0)){k=-1;D=22;break}if((B|0)!=1){break a}B=c[h>>2]|0;Una(l,B,Rna(l)|0);B=Sna(l)|0;Tna(l,B-(Qna(l)|0)|0);B=c[r>>2]|0;if((B|0)==0){D=11;break}z=c[p>>2]|0;q=B}if((D|0)==11){t=Dc(4)|0;u=t;owa(u);v=160792;w=127;Ld(t|0,v|0,w|0)}else if((D|0)==14){q=(Rna(l)|0)-C|0;if((qc(C|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((D|0)==22){i=e;return k|0}}else{q=f-o|0;if((qc(o|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);Una(l,m,n)}k=W8(d)|0;i=e;return k|0}function S8(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+92|0;if((c[e>>2]&16|0)!=0){i=d;return}f=b;Pna(f,0,0,0);g=c[b+52>>2]|0;do{if(g>>>0>8){if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;Una(f,h,h+((c[b+60>>2]|0)+ -1)|0);break}else{h=c[b+32>>2]|0;Una(f,h,h+(g+ -1)|0);break}}else{Una(f,0,0)}}while(0);c[e>>2]=16;i=d;return}function T8(a,b){a=a|0;b=b|0;i=i;return(a|0)==(b|0)|0}function U8(a){a=a|0;i=i;return a&255|0}function V8(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=ye[c[(c[a>>2]|0)+12>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function W8(a){a=a|0;var b=0,c=0;b=i;c=T8(a,-1)|0;i=b;return(c?0:a)|0}function X8(a){a=a|0;i=i;return a&255|0}function Y8(a,b){a=a|0;b=b|0;i=i;return a<<24>>24==b<<24>>24|0}function Z8(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+92|0;if((c[e>>2]&8|0)!=0){f=0;i=d;return f|0}g=b;Una(g,0,0);if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;j=h+(c[b+60>>2]|0)|0;Pna(g,h,j,j)}else{j=c[b+32>>2]|0;h=j+(c[b+52>>2]|0)|0;Pna(g,j,h,h)}c[e>>2]=8;f=1;i=d;return f|0}function _8(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=a9(b,c,e)|0;i=d;return g|0}function $8(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=ye[c[(c[a>>2]|0)+16>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function a9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=b9(0,b,a)|0;i=c;return(d?b:a)|0}function b9(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function c9(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=qe[c[(c[a>>2]|0)+20>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function d9(a){a=a|0;var b=0,d=0;b=i;d=ae[c[(c[a>>2]|0)+24>>2]&127](a)|0;i=b;return d|0}function e9(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=qe[c[(c[a>>2]|0)+32>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function f9(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function g9(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function h9(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=i9(b,c,e)|0;i=d;return g|0}function i9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=j9(0,a,b)|0;i=c;return(d?b:a)|0}function j9(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function k9(a){a=a|0;var b=0,c=0;b=i;c=ota(a,145296)|0;i=b;return c|0}function l9(a){a=a|0;var b=0,d=0;b=i;d=ae[c[(c[a>>2]|0)+28>>2]&127](a)|0;i=b;return d|0}function m9(a){a=a|0;var b=0;b=i;n9(a);i=b;return}function n9(a){a=a|0;var b=0;b=i;o9(a);i=b;return}function o9(a){a=a|0;var b=0;b=i;p9(a,S7(a)|0);i=b;return}function p9(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;Z7(d);if((b|0)==0){i=d;return}p9(a,c[b>>2]|0);p9(a,c[b+4>>2]|0);r9(q9(a)|0,b,1);i=d;return}function q9(a){a=a|0;var b=0,c=0;b=i;c=t9(a+4|0)|0;i=b;return c|0}function r9(a,b,c){a=a|0;b=b|0;c=c|0;c=i;s9(0,b,0);i=c;return}function s9(a,b,c){a=a|0;b=b|0;c=c|0;c=i;Rwa(b);i=c;return}function t9(a){a=a|0;var b=0,c=0;b=i;c=u9(a)|0;i=b;return c|0}function u9(a){a=a|0;i=i;return a|0}function v9(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=w9(a,f,b)|0;l=c[k>>2]|0;Z7(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}y9(j,a,b);z9(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];x9(g,e);A9(j);j=c[f>>2]|0;B9(a,j,k,C9(g)|0);k=D9(g)|0;A9(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function w9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=S7(h)|0;Z7(e);if((a|0)==0){j=J7(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(W7(0,d,a)|0){m=l;j=c[m>>2]|0;Z7(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(W7(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;Z7(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function x9(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];paa(a,e);i=d;return}function y9(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=q9(d)|0;d=_9(n,1)|0;$9(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];Z9(j,d,h);aaa(0,V9((baa(j)|0)+16|0)|0,e);e=caa(j)|0;a[e+4|0]=1;daa(0,U9((baa(j)|0)+20|0)|0);a[e+5|0]=1;eaa(m,j);z9(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];x9(b,g);A9(m);A9(j);i=f;return}function z9(a,b){a=a|0;b=b|0;var c=0;c=i;X9(a,b);i=c;return}function A9(a){a=a|0;var b=0;b=i;Q9(a);i=b;return}function B9(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;Z7(f);c[e>>2]=0;Z7(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=I9(a)|0;b=c[c[e>>2]>>2]|0;Z7(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(J7(a)|0)>>2]|0;J9(e,c[d>>2]|0);d=K9(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function C9(a){a=a|0;var b=0,d=0;b=i;d=c[(G9(a)|0)>>2]|0;i=b;return d|0}function D9(a){a=a|0;var b=0,d=0;b=i;d=E9(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function E9(a){a=a|0;var b=0,c=0;b=i;c=F9(a)|0;i=b;return c|0}function F9(a){a=a|0;i=i;return a|0}function G9(a){a=a|0;var b=0,c=0;b=i;c=H9(a)|0;i=b;return c|0}function H9(a){a=a|0;i=i;return a|0}function I9(a){a=a|0;i=i;return a|0}function J9(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(d|0)==(b|0);a[d+12|0]=h&1;if(h){i=e;return}else{j=d}while(1){k=j+8|0;d=c[k>>2]|0;if((a[d+12|0]|0)!=0){l=17;break}h=N9(d)|0;m=c[d+8>>2]|0;if(h){h=c[m+4>>2]|0;Z7(f);if((h|0)==0){l=7;break}d=h+12|0;if((a[d]|0)!=0){l=7;break}h=c[k>>2]|0;a[h+12|0]=1;n=c[h+8>>2]|0;a[n+12|0]=(n|0)==(b|0)|0;a[d]=1;o=n}else{n=c[m>>2]|0;Z7(g);if((n|0)==0){l=14;break}m=n+12|0;if((a[m]|0)!=0){l=14;break}n=c[k>>2]|0;a[n+12|0]=1;d=c[n+8>>2]|0;a[d+12|0]=(d|0)==(b|0)|0;a[m]=1;o=d}if((o|0)==(b|0)){l=17;break}else{j=o}}if((l|0)==7){if(N9(j)|0){p=j}else{o=c[k>>2]|0;O9(o);p=o}o=c[p+8>>2]|0;a[o+12|0]=1;p=c[o+8>>2]|0;a[p+12|0]=0;P9(p);i=e;return}else if((l|0)==14){if(N9(j)|0){p=c[k>>2]|0;P9(p);q=p}else{q=j}j=c[q+8>>2]|0;a[j+12|0]=1;q=c[j+8>>2]|0;a[q+12|0]=0;O9(q);i=e;return}else if((l|0)==17){i=e;return}}function K9(a){a=a|0;var b=0,c=0;b=i;c=L9(a+8|0)|0;i=b;return c|0}function L9(a){a=a|0;var b=0,c=0;b=i;c=M9(a)|0;i=b;return c|0}function M9(a){a=a|0;i=i;return a|0}function N9(a){a=a|0;i=i;return(c[c[a+8>>2]>>2]|0)==(a|0)|0}function O9(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;f=e;g=c[f>>2]|0;c[d>>2]=g;Z7(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=N9(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function P9(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;f=e+4|0;g=c[f>>2]|0;c[d>>2]=g;Z7(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=N9(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function Q9(a){a=a|0;var b=0;b=i;R9(a,0);i=b;return}function R9(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=E9(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}T9(S9(e)|0,f);i=d;return}function S9(a){a=a|0;var b=0,c=0;b=i;c=W9(a)|0;i=b;return c|0}function T9(a,b){a=a|0;b=b|0;var d=0;d=i;if((b|0)==0){i=d;return}r9(c[a>>2]|0,b,1);i=d;return}function U9(a){a=a|0;i=i;return a|0}function V9(a){a=a|0;i=i;return a|0}function W9(a){a=a|0;i=i;return a+4|0}function X9(a,b){a=a|0;b=b|0;var c=0;c=i;Y9(a,b);i=c;return}function Y9(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Z9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];haa(a,b,f);i=e;return}function _9(a,b){a=a|0;b=b|0;var c=0;a=i;c=gaa(0,b,0)|0;i=a;return c|0}function $9(a,b){a=a|0;b=b|0;var c=0;c=i;faa(a,b);i=c;return}function aaa(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function baa(a){a=a|0;var b=0,d=0;b=i;d=c[(G9(a)|0)>>2]|0;i=b;return d|0}function caa(a){a=a|0;var b=0,c=0;b=i;c=S9(a)|0;i=b;return c|0}function daa(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function eaa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;X9(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];x9(h,f);z9(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];x9(a,e);A9(h);i=d;return}function faa(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function gaa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Pwa(b*24|0)|0;i=c;return a|0}function haa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(jaa(g)|0)>>2]|0;g=kaa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];iaa(b,a,f);i=e;return}function iaa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];laa(a,b,f);i=e;return}function jaa(a){a=a|0;i=i;return a|0}function kaa(a){a=a|0;i=i;return a|0}function laa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(naa(g)|0)>>2]|0;g=oaa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];maa(b,a,f);i=e;return}function maa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(naa(f)|0)>>2];f=oaa(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function naa(a){a=a|0;i=i;return a|0}function oaa(a){a=a|0;i=i;return a|0}function paa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=D9(qaa(b)|0)|0;h=oaa(caa(qaa(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];iaa(g,a,e);i=d;return}function qaa(a){a=a|0;i=i;return c[a>>2]|0}function raa(a){a=a|0;var b=0;b=i;i=i+48|0;saa(a);l7(a+184|0,0,0);l7(a+200|0,0,0);taa(a+240|0,b);taa(a+252|0,b+8|0);taa(a+264|0,b+16|0);taa(a+276|0,b+24|0);taa(a+288|0,b+32|0);taa(a+300|0,b+40|0);i=b;return}function saa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+104|0;Bna(d);e=a;c[e>>2]=113308;f=d;c[f>>2]=113328;d=a+4|0;Ioa(a,113340|0,d);c[e>>2]=113308;c[f>>2]=113328;Gaa(d);i=b;return}function taa(a,b){a=a|0;b=b|0;b=i;uaa(a,0);i=b;return}function uaa(a,b){a=a|0;b=b|0;b=i;i=i+8|0;vaa(a,b);i=b;return}function vaa(a,b){a=a|0;b=b|0;b=i;waa(a,0);i=b;return}function waa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;xaa(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;yaa(f,0,e);e=J7(b)|0;c[(I9(b)|0)>>2]=e;i=d;return}function xaa(a){a=a|0;var b=0;b=i;Caa(a);i=b;return}function yaa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;zaa(b,c,f);i=e;return}function zaa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(Baa(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;Aaa(d,b,f);i=e;return}function Aaa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(Baa(e)|0)>>2];i=d;return}function Baa(a){a=a|0;i=i;return a|0}function Caa(a){a=a|0;var b=0;b=i;Daa(a);i=b;return}function Daa(a){a=a|0;var b=0;b=i;Eaa(a);i=b;return}function Eaa(a){a=a|0;var b=0;b=i;Faa(a);i=b;return}function Faa(a){a=a|0;c[a>>2]=0;i=i;return}function Gaa(a){a=a|0;var b=0;b=i;Haa(a);i=b;return}function Haa(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=d;Kna(j);c[d>>2]=113464;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;k=d+68|0;l=d+52|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;Z7(f);f=d+98|0;l=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;b[l+28>>1]=0;a[l+30|0]=0;Gna(g,j);l=Iaa(g)|0;mta(g);if(!l){m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=de[r&63](d,0,4096)|0;i=e;return}Gna(h,j);c[k>>2]=k9(h)|0;mta(h);a[f]=(l9(c[k>>2]|0)|0)&1;m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=de[r&63](d,0,4096)|0;i=e;return}function Iaa(a){a=a|0;var b=0,c=0;b=i;c=nta(a,145296)|0;i=b;return c|0}function Jaa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+8|0;e=d;f=c[a+12>>2]|0;H3(3);g=f+8|0;h=g;j=c[g>>2]|0;g=f+12|0;k=c[g>>2]|0;if((j|0)<(k|0)){Kaa(a,b,c[f>>2]|0,h);K3(3);i=d;return}l=~~(+(k|0)*1.4+ +(k-j|0)+2.0e3);c[g>>2]=l;j=f+16|0;k=Mwa(c[f>>2]|0,fa(l<<3,c[j>>2]|0)|0)|0;l=k;c[f>>2]=l;if((k|0)==0){k=c[b+536>>2]|0;c[e>>2]=fa(c[j>>2]|0,c[g>>2]|0)|0;Z1(k,113736,e)}Kaa(a,b,l,h);K3(3);i=d;return}function Kaa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;j=c[b+12>>2]|0;K3(0);k=+C3(0);H3(0);l=c[c[d+4>>2]>>2]|0;m=l;n=+h[m>>3];o=j+4|0;j=c[o>>2]|0;p=j+1|0;c[o>>2]=p;h[e+(j<<3)>>3]=n;if((c[b+8>>2]|0)==0){q=p}else{b=j+2|0;c[o>>2]=b;h[e+(p<<3)>>3]=k;q=b}b=d+116|0;p=c[b>>2]|0;if((p|0)>0){j=c[d+8>>2]|0;r=p;p=q;s=0;while(1){if((a[j+(s*112|0)+104|0]|0)==0){k=+h[(c[l+8>>2]|0)+(s<<3)>>3];t=p+1|0;c[o>>2]=t;h[e+(p<<3)>>3]=k;u=c[b>>2]|0;v=t}else{u=r;v=p}t=s+1|0;if((t|0)<(u|0)){r=u;p=v;s=t}else{w=v;break}}}else{w=q}q=d+124|0;v=c[q>>2]|0;if((v|0)>0){s=c[d+12>>2]|0;p=v;v=w;u=0;while(1){if((a[s+(u*60|0)+56|0]|0)==0){k=+(c[(c[l+12>>2]|0)+(u<<2)>>2]|0);r=v+1|0;c[o>>2]=r;h[e+(v<<3)>>3]=k;x=c[q>>2]|0;y=r}else{x=p;y=v}r=u+1|0;if((r|0)<(x|0)){p=x;v=y;u=r}else{z=y;break}}}else{z=w}w=d+128|0;y=c[w>>2]|0;if((y|0)>0){u=c[d+16>>2]|0;v=y;y=z;x=0;while(1){if((a[u+(x*48|0)+44|0]|0)==0){k=+(a[(c[l+16>>2]|0)+x|0]|0);p=y+1|0;c[o>>2]=p;h[e+(y<<3)>>3]=k;A=c[w>>2]|0;B=p}else{A=v;B=y}p=x+1|0;if((p|0)<(A|0)){v=A;y=B;x=p}else{C=B;break}}}else{C=z}z=d+216|0;if((c[z>>2]|0)>0){B=d+416|0;x=c[d+40>>2]|0;y=C;A=0;while(1){do{if((a[x+(A*52|0)+48|0]|0)==0){v=a[x+(A*52|0)+8|0]|0;do{if(v<<24>>24==2){D=m}else{w=c[x+(A*52|0)+4>>2]|0;if(v<<24>>24==1){D=(c[B>>2]|0)+(w<<3)|0;break}else{D=(c[l+8>>2]|0)+(w<<3)|0;break}}}while(0);k=+h[D>>3];if((c[x+(A*52|0)>>2]|0)==0){v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=k;E=v;break}else{v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=-k;E=v;break}}else{E=y}}while(0);v=A+1|0;if((v|0)<(c[z>>2]|0)){y=E;A=v}else{F=E;break}}}else{F=C}C=d+220|0;if((c[C>>2]|0)>0){E=d+40|0;A=d+420|0;y=c[d+44>>2]|0;z=F;x=0;while(1){do{if((a[y+(x*52|0)+48|0]|0)==0){D=c[(c[((a[y+(x*52|0)+8|0]|0)==1?A:l+12|0)>>2]|0)+(c[(c[E>>2]|0)+(x*52|0)+4>>2]<<2)>>2]|0;if((c[y+(x*52|0)>>2]|0)==0){B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(D|0);G=B;break}else{B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(0-D|0);G=B;break}}else{G=z}}while(0);B=x+1|0;if((B|0)<(c[C>>2]|0)){z=G;x=B}else{H=G;break}}}else{H=F}F=d+224|0;if((c[F>>2]|0)<=0){I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}G=d+44|0;x=d+40|0;z=d+424|0;C=c[d+48>>2]|0;d=H;H=0;while(1){do{if((a[C+(H*52|0)+48|0]|0)==0){y=a[(c[((a[(c[G>>2]|0)+(H*52|0)+8|0]|0)==1?z:l+16|0)>>2]|0)+(c[(c[x>>2]|0)+(H*52|0)+4>>2]|0)|0]|0;if((c[C+(H*52|0)>>2]|0)==0){E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24);K=E;break}else{E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24!=1|0);K=E;break}}else{K=d}}while(0);E=H+1|0;if((E|0)<(c[F>>2]|0)){d=K;H=E}else{break}}I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}function Laa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=Jwa(24)|0;H3(3);c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=g+16|0;c[j>>2]=0;k=a+4|0;l=c[k>>2]|0;c[g+12>>2]=l;m=b+536|0;Y1(c[m>>2]|0,l>>>31^1,113792,f);f=b+8|0;b=c[a+8>>2]|0;l=Maa(b,f)|0;c[g+20>>2]=l;l=Maa(b,f)|0;c[j>>2]=l;j=c[k>>2]|0;k=Jwa(fa(l<<3,j)|0)|0;c[g>>2]=k;if((k|0)==0){k=c[m>>2]|0;c[e>>2]=fa(l,j)|0;Z1(k,113872,e)}else{c[h>>2]=0;c[a+12>>2]=g;K3(3);i=d;return}}function Maa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=(b|0)==0?1:2;b=c[d+108>>2]|0;if((b|0)>0){g=c[d>>2]|0;h=0;j=f;while(1){k=((a[g+(h*112|0)+104|0]|0)==0)+j|0;l=h+1|0;if((l|0)<(b|0)){j=k;h=l}else{m=k;break}}}else{m=f}f=c[d+116>>2]|0;if((f|0)>0){h=c[d+4>>2]|0;j=0;b=m;while(1){g=((a[h+(j*60|0)+56|0]|0)==0)+b|0;k=j+1|0;if((k|0)<(f|0)){b=g;j=k}else{n=g;break}}}else{n=m}m=c[d+120>>2]|0;if((m|0)>0){j=c[d+8>>2]|0;b=0;f=n;while(1){h=((a[j+(b*48|0)+44|0]|0)==0)+f|0;g=b+1|0;if((g|0)<(m|0)){f=h;b=g}else{o=h;break}}}else{o=n}n=c[d+208>>2]|0;if((n|0)>0){b=c[d+32>>2]|0;f=0;m=o;while(1){j=((a[b+(f*52|0)+48|0]|0)==0)+m|0;h=f+1|0;if((h|0)<(n|0)){m=j;f=h}else{p=j;break}}}else{p=o}o=c[d+212>>2]|0;if((o|0)>0){f=c[d+36>>2]|0;m=0;n=p;while(1){b=((a[f+(m*52|0)+48|0]|0)==0)+n|0;j=m+1|0;if((j|0)<(o|0)){n=b;m=j}else{q=b;break}}}else{q=p}p=c[d+216>>2]|0;if((p|0)<=0){r=q;i=e;return r|0}m=c[d+40>>2]|0;d=0;n=q;while(1){q=((a[m+(d*52|0)+48|0]|0)==0)+n|0;o=d+1|0;if((o|0)<(p|0)){n=q;d=o}else{r=q;break}}i=e;return r|0}function Naa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b+12|0;s=c[r>>2]|0;t=s;H3(3);u=b;v=ic(c[u>>2]|0,113936)|0;if((v|0)==0){Oaa(t);w=c[d+536>>2]|0;x=c[u>>2]|0;y=Od(c[(Mc()|0)>>2]|0)|0;c[q>>2]=x;c[q+4>>2]=y;Z1(w,113944,q)}qc(114e3,46,1,v|0)|0;q=s+20|0;c[p>>2]=c[q>>2];pd(v|0,114048,p|0)|0;p=s+8|0;c[o>>2]=c[p>>2];pd(v|0,114072,o|0)|0;qc(114096,40,1,v|0)|0;qc(114144,11,1,v|0)|0;qc(114160,14,1,v|0)|0;if((c[p>>2]|0)>0){o=0;do{w=fa(c[q>>2]|0,o)|0;z=+h[(c[s>>2]|0)+(w<<3)>>3];Paa(v,z,z);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Kd(10,v|0)|0;if((c[b+8>>2]|0)==0){A=1}else{qc(114176,18,1,v|0)|0;if((c[p>>2]|0)>0){b=0;do{o=fa(c[q>>2]|0,b)|0;w=c[s>>2]|0;Paa(v,+h[w+(o<<3)>>3],+h[w+(o+1<<3)>>3]);b=b+1|0;}while((b|0)<(c[p>>2]|0))}Kd(10,v|0)|0;A=2}b=d+116|0;o=c[b>>2]|0;if((o|0)>0){w=d+8|0;y=o;o=0;x=A;while(1){B=c[w>>2]|0;if((a[B+(o*112|0)+104|0]|0)==0){c[n>>2]=c[B+(o*112|0)+4>>2];pd(v|0,114200,n|0)|0;if((c[p>>2]|0)>0){B=0;do{C=fa(c[q>>2]|0,B)|0;D=c[s>>2]|0;Paa(v,+h[D+(C<<3)>>3],+h[D+(C+x<<3)>>3]);B=B+1|0;}while((B|0)<(c[p>>2]|0))}Kd(10,v|0)|0;E=c[b>>2]|0;F=x+1|0}else{E=y;F=x}B=o+1|0;if((B|0)<(E|0)){y=E;o=B;x=F}else{G=F;break}}}else{G=A}A=d+124|0;F=c[A>>2]|0;if((F|0)>0){x=d+12|0;o=F;F=0;E=G;while(1){y=c[x>>2]|0;if((a[y+(F*60|0)+56|0]|0)==0){c[m>>2]=c[y+(F*60|0)+4>>2];pd(v|0,114200,m|0)|0;if((c[p>>2]|0)>0){y=0;do{b=fa(c[q>>2]|0,y)|0;n=c[s>>2]|0;Paa(v,+h[n+(b<<3)>>3],+h[n+(b+E<<3)>>3]);y=y+1|0;}while((y|0)<(c[p>>2]|0))}Kd(10,v|0)|0;H=c[A>>2]|0;I=E+1|0}else{H=o;I=E}y=F+1|0;if((y|0)<(H|0)){o=H;F=y;E=I}else{J=I;break}}}else{J=G}G=d+128|0;I=c[G>>2]|0;if((I|0)>0){E=d+16|0;F=I;I=0;H=J;while(1){o=c[E>>2]|0;if((a[o+(I*48|0)+44|0]|0)==0){c[l>>2]=c[o+(I*48|0)+4>>2];pd(v|0,114200,l|0)|0;if((c[p>>2]|0)>0){o=0;do{A=fa(c[q>>2]|0,o)|0;m=c[s>>2]|0;Paa(v,+h[m+(A<<3)>>3],+h[m+(A+H<<3)>>3]);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Kd(10,v|0)|0;K=c[G>>2]|0;L=H+1|0}else{K=F;L=H}o=I+1|0;if((o|0)<(K|0)){F=K;I=o;H=L}else{M=L;break}}}else{M=J}J=d+216|0;L=c[J>>2]|0;if((L|0)>0){H=d+40|0;I=L;L=0;K=M;while(1){F=c[H>>2]|0;if((a[F+(L*52|0)+48|0]|0)==0){c[k>>2]=c[F+(L*52|0)+16>>2];pd(v|0,114200,k|0)|0;if((c[p>>2]|0)>0){F=0;do{G=fa(c[q>>2]|0,F)|0;l=c[s>>2]|0;Paa(v,+h[l+(G<<3)>>3],+h[l+(G+K<<3)>>3]);F=F+1|0;}while((F|0)<(c[p>>2]|0))}Kd(10,v|0)|0;N=c[J>>2]|0;O=K+1|0}else{N=I;O=K}F=L+1|0;if((F|0)<(N|0)){I=N;L=F;K=O}else{P=O;break}}}else{P=M}M=d+220|0;O=c[M>>2]|0;if((O|0)>0){K=d+44|0;L=O;O=0;N=P;while(1){I=c[K>>2]|0;if((a[I+(O*52|0)+48|0]|0)==0){c[j>>2]=c[I+(O*52|0)+16>>2];pd(v|0,114200,j|0)|0;if((c[p>>2]|0)>0){I=0;do{J=fa(c[q>>2]|0,I)|0;k=c[s>>2]|0;Paa(v,+h[k+(J<<3)>>3],+h[k+(J+N<<3)>>3]);I=I+1|0;}while((I|0)<(c[p>>2]|0))}Kd(10,v|0)|0;Q=c[M>>2]|0;R=N+1|0}else{Q=L;R=N}I=O+1|0;if((I|0)<(Q|0)){L=Q;O=I;N=R}else{S=R;break}}}else{S=P}P=d+224|0;R=c[P>>2]|0;if((R|0)>0){N=d+48|0;O=R;R=0;Q=S;while(1){S=c[N>>2]|0;if((a[S+(R*52|0)+48|0]|0)==0){c[g>>2]=c[S+(R*52|0)+16>>2];pd(v|0,114200,g|0)|0;if((c[p>>2]|0)>0){S=0;do{L=fa(c[q>>2]|0,S)|0;M=c[s>>2]|0;Paa(v,+h[M+(L<<3)>>3],+h[M+(L+Q<<3)>>3]);S=S+1|0;}while((S|0)<(c[p>>2]|0))}Kd(10,v|0)|0;T=c[P>>2]|0;U=Q+1|0}else{T=O;U=Q}S=R+1|0;if((S|0)<(T|0)){O=T;R=S;Q=U}else{break}}}Oaa(t);if((Wc(v|0)|0)==0){Kwa(c[r>>2]|0);c[r>>2]=0;K3(3);i=e;return}else{e=c[d+536>>2]|0;c[f>>2]=c[u>>2];Z1(e,114216,f)}}function Oaa(a){a=a|0;var b=0,d=0;b=i;d=a;a=c[d>>2]|0;if((a|0)==0){i=b;return}Kwa(a);c[d>>2]=0;i=b;return}function Paa(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=f;h[k>>3]=b;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];pd(a|0,114264,f|0)|0;i=e;return}function Qaa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=Pwa(192)|0;pxa(m|0,0,192)|0;Raa(m);c[a+12>>2]=m;n=m;o=a;m7(n,c[o>>2]|0,36);if(pna(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){a=c[b+536>>2]|0;c[g>>2]=c[o>>2];Z1(a,114304,g)}else{g=m;Uoa(g,114280,14)|0;Voa(h,g);a=z8(h)|0;h=m+184|0;c[h>>2]=a;Uoa(g,114296,4)|0;Saa(n,b+8|0);Voa(j,g);b=z8(j)|0;j=m+188|0;c[j>>2]=b;m=c[h>>2]|0;l7(k,m,((m|0)<0)<<31>>31);h=f;a=k;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];Woa(g,f)|0;Taa(n,-4-m+b|0);b=c[j>>2]|0;l7(l,b,((b|0)<0)<<31>>31);b=e;j=l;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];Woa(g,e)|0;K3(3);i=d;return}}function Raa(a){a=a|0;var b=0;b=i;kba(a);i=b;return}function Saa(a,b){a=a|0;b=b|0;var c=0;c=i;Vaa(a,3);Waa(a,114480);Vaa(a,0);Waa(a,114488);Vaa(a,2);fba(a,b);gba(a,b);Waa(a,114496);Vaa(a,0);i=c;return}function Taa(a,b){a=a|0;b=b|0;var d=0;d=i;c[28618]=zd(b|0)|0;Uoa(a,114472,4)|0;i=d;return}function Uaa(b,d,e,f){b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=b;Voa(l,q);r=z8(l)|0;Taa(b,0);Voa(m,q);l=z8(m)|0;Vaa(b,1);Waa(b,114368);m=e+128|0;s=e+132|0;t=e+136|0;u=e+140|0;Xaa(b,(c[m>>2]|0)+1+(c[s>>2]|0)+(c[t>>2]|0)+(c[u>>2]|0)|0);Yaa(b,d);if((c[m>>2]|0)>0){e=f+176|0;v=0;do{Yaa(b,+h[(c[e>>2]|0)+(v<<3)>>3]);v=v+1|0;}while((v|0)<(c[m>>2]|0))}if((c[s>>2]|0)>0){m=f+180|0;v=0;do{Zaa(b,c[(c[m>>2]|0)+(v<<2)>>2]|0);v=v+1|0;}while((v|0)<(c[s>>2]|0))}if((c[t>>2]|0)>0){s=f+184|0;v=0;do{_aa(b,(a[(c[s>>2]|0)+v|0]|0)!=0);v=v+1|0;}while((v|0)<(c[t>>2]|0))}if((c[u>>2]|0)>0){t=f+188|0;f=0;do{Waa(b,c[(c[t>>2]|0)+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(c[u>>2]|0))}Voa(n,q);u=z8(n)|0;n=mxa(0,r|0,32)|0;l7(o,n,J);n=k;r=o;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];Woa(q,k)|0;Taa(b,u-l|0);l7(p,u,((u|0)<0)<<31>>31);u=j;l=p;c[u+0>>2]=c[l+0>>2];c[u+4>>2]=c[l+4>>2];c[u+8>>2]=c[l+8>>2];c[u+12>>2]=c[l+12>>2];Woa(q,j)|0;i=g;return}function Vaa(b,d){b=b|0;d=d|0;var e=0;e=i;a[114456]=-33;c[28616]=zd(d|0)|0;d=b;Uoa(d,114456,1)|0;Uoa(d,114464,4)|0;i=e;return}function Waa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;c[f>>2]=zd(lxa(d|0)|0)|0;a[114448]=-37;g=b;Uoa(g,114448,1)|0;Uoa(g,f,4)|0;Uoa(g,d,lxa(d|0)|0)|0;i=e;return}function Xaa(b,d){b=b|0;d=d|0;var e=0;e=i;a[114432]=-35;c[28610]=zd(d|0)|0;d=b;Uoa(d,114432,1)|0;Uoa(d,114440,4)|0;i=e;return}function Yaa(b,c){b=b|0;c=+c;var d=0,e=0;d=i;a[114416]=-53;eba(c);e=b;Uoa(e,114416,1)|0;Uoa(e,114424,8)|0;i=d;return}function Zaa(b,d){b=b|0;d=d|0;var e=0;e=i;a[114400]=-46;c[28602]=zd(d|0)|0;d=b;Uoa(d,114400,1)|0;Uoa(d,114408,4)|0;i=e;return}function _aa(b,c){b=b|0;c=c|0;var d=0;d=i;a[114392]=c?-61:-62;Uoa(b,114392,1)|0;i=d;return}function $aa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+12>>2]|0;a=b+8|0;f=b+240|0;Uaa(e,+h[f>>3],a,f);Uaa(e,+h[b+248>>3],a,f);i=d;return}function aba(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=c[b+12>>2]|0;b=o;p=o;Voa(j,p);o=z8(j)|0;Taa(b,0);Voa(k,p);j=z8(k)|0;Vaa(b,1);Waa(b,114376);k=d+116|0;q=d+124|0;r=d+128|0;s=d+132|0;Xaa(b,(c[k>>2]|0)+1+(c[q>>2]|0)+(c[r>>2]|0)+(c[s>>2]|0)|0);t=d+4|0;Yaa(b,+h[c[c[t>>2]>>2]>>3]);if((c[k>>2]|0)>0){d=0;do{Yaa(b,+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+(d<<3)>>3]);d=d+1|0;}while((d|0)<(c[k>>2]|0))}if((c[q>>2]|0)>0){k=0;do{Zaa(b,c[(c[(c[c[t>>2]>>2]|0)+12>>2]|0)+(k<<2)>>2]|0);k=k+1|0;}while((k|0)<(c[q>>2]|0))}if((c[r>>2]|0)>0){q=0;do{_aa(b,(a[(c[(c[c[t>>2]>>2]|0)+16>>2]|0)+q|0]|0)!=0);q=q+1|0;}while((q|0)<(c[r>>2]|0))}if((c[s>>2]|0)>0){r=0;do{Waa(b,c[(c[(c[c[t>>2]>>2]|0)+20>>2]|0)+(r<<2)>>2]|0);r=r+1|0;}while((r|0)<(c[s>>2]|0))}Voa(l,p);s=z8(l)|0;l=mxa(0,o|0,32)|0;l7(m,l,J);l=g;o=m;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];Woa(p,g)|0;Taa(b,s-j|0);l7(n,s,((s|0)<0)<<31>>31);s=f;j=n;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];Woa(p,f)|0;i=e;return}function bba(a,b){a=a|0;b=b|0;var d=0;b=i;d=a+12|0;a=c[d>>2]|0;f7(a);H3(3);if((a|0)!=0){cba(a);Rwa(a)}c[d>>2]=0;K3(3);i=b;return}function cba(a){a=a|0;var b=0;b=i;dba(a);i=b;return}function dba(a){a=a|0;var b=0;b=i;C8(a);i=b;return}function eba(b){b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=d;h[e>>3]=b;if((zd(1)|0)==1){f=e;g=c[f+4>>2]|0;j=114424;c[j>>2]=c[f>>2];c[j+4>>2]=g;i=d;return}h[k>>3]=b;g=c[k>>2]&255;j=0;while(1){a[114424+(7-j)|0]=g;f=j+1|0;if((f|0)>=8){break}g=a[e+f|0]|0;j=f}i=d;return}function fba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;Waa(a,114368);Vaa(a,4);Waa(a,114504);Vaa(a,0);Waa(a,114512);f=b+128|0;g=b+132|0;h=b+136|0;j=b+140|0;Xaa(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);Waa(a,114520);if((c[f>>2]|0)>0){k=b+16|0;l=0;do{Waa(a,c[(c[k>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){l=b+20|0;k=0;do{Waa(a,c[(c[l>>2]|0)+(k*60|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){k=b+24|0;l=0;do{Waa(a,c[(c[k>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)>0){l=b+28|0;k=0;do{Waa(a,c[(c[l>>2]|0)+(k*52|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[j>>2]|0))}k=e;l=114608;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];hba(a,b,e);Waa(a,114544);Vaa(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);iba(a,114520,114552);if((c[f>>2]|0)>0){e=b+16|0;l=0;do{k=c[e>>2]|0;iba(a,c[k+(l*112|0)+4>>2]|0,c[k+(l*112|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=b+20|0;l=0;do{e=c[f>>2]|0;iba(a,c[e+(l*60|0)+4>>2]|0,c[e+(l*60|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){g=b+24|0;l=0;do{f=c[g>>2]|0;iba(a,c[f+(l*48|0)+4>>2]|0,c[f+(l*48|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)<=0){i=d;return}h=b+28|0;b=0;do{l=c[h>>2]|0;iba(a,c[l+(b*52|0)+4>>2]|0,c[l+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[j>>2]|0));i=d;return}function gba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=b+108|0;g=c[f>>2]|0;h=b+116|0;j=c[h>>2]|0;k=b+120|0;l=c[k>>2]|0;m=b+124|0;n=c[m>>2]|0;Waa(a,114376);Vaa(a,4);Waa(a,114504);Vaa(a,0);Waa(a,114512);o=g+1+j+l+n|0;Xaa(a,o);Waa(a,114520);if((c[f>>2]|0)>0){n=b;l=0;do{Waa(a,c[(c[n>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){l=b+4|0;n=0;do{Waa(a,c[(c[l>>2]|0)+(n*60|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){n=b+8|0;l=0;do{Waa(a,c[(c[n>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[k>>2]|0))}if((c[m>>2]|0)>0){l=b+12|0;n=0;do{Waa(a,c[(c[l>>2]|0)+(n*52|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[m>>2]|0))}n=e;l=114528;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];hba(a,b,e);Waa(a,114544);Vaa(a,o);iba(a,114520,114552);if((c[f>>2]|0)>0){o=b;e=0;do{l=c[o>>2]|0;iba(a,c[l+(e*112|0)+4>>2]|0,c[l+(e*112|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){f=b+4|0;e=0;do{o=c[f>>2]|0;iba(a,c[o+(e*60|0)+4>>2]|0,c[o+(e*60|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){h=b+8|0;e=0;do{f=c[h>>2]|0;iba(a,c[f+(e*48|0)+4>>2]|0,c[f+(e*48|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[k>>2]|0))}if((c[m>>2]|0)<=0){i=d;return}k=b+12|0;b=0;do{e=c[k>>2]|0;iba(a,c[e+(b*52|0)+4>>2]|0,c[e+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[m>>2]|0));i=d;return}function hba(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;Waa(b,114576);g=d+208|0;h=c[g>>2]|0;if((h|0)>0){j=c[d+32>>2]|0;k=0;l=0;while(1){m=(c[e+(a[j+(k*52|0)+8|0]<<2)>>2]|0)+l|0;n=k+1|0;if((n|0)<(h|0)){l=m;k=n}else{o=m;break}}}else{o=0}k=d+212|0;l=c[k>>2]|0;if((l|0)>0){h=c[d+36>>2]|0;j=0;m=o;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{q=n;break}}}else{q=o}o=d+216|0;j=c[o>>2]|0;if((j|0)>0){m=c[d+40>>2]|0;l=0;h=q;while(1){n=(c[e+(a[m+(l*52|0)+8|0]<<2)>>2]|0)+h|0;p=l+1|0;if((p|0)<(j|0)){h=n;l=p}else{r=n;break}}}else{r=q}q=d+220|0;l=c[q>>2]|0;if((l|0)>0){h=c[d+44>>2]|0;j=0;m=r;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{s=n;break}}}else{s=r}Vaa(b,s);s=c[g>>2]|0;if((s|0)>0){r=d+32|0;j=d+16|0;m=d;l=s;s=0;h=0;while(1){n=c[r>>2]|0;p=a[n+(s*52|0)+8|0]|0;if((c[e+(p<<24>>24<<2)>>2]|0)==0){t=l;u=h}else{v=p<<24>>24==2?114520:h;if(p<<24>>24==1){w=c[(c[j>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else if(p<<24>>24==0){w=c[(c[m>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else{w=v}jba(b,c[n+(s*52|0)+16>>2]|0,w,(c[n+(s*52|0)>>2]|0)!=0);t=c[g>>2]|0;u=w}n=s+1|0;if((n|0)<(t|0)){l=t;s=n;h=u}else{x=u;break}}}else{x=0}u=c[k>>2]|0;if((u|0)>0){h=d+36|0;s=d+20|0;t=d+4|0;l=u;u=0;w=x;while(1){g=c[h>>2]|0;m=a[g+(u*52|0)+8|0]|0;if((c[e+(m<<24>>24<<2)>>2]|0)==0){y=l;z=w}else{j=m<<24>>24==2?114520:w;if(m<<24>>24==0){A=c[(c[t>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else if(m<<24>>24==1){A=c[(c[s>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else{A=j}jba(b,c[g+(u*52|0)+16>>2]|0,A,(c[g+(u*52|0)>>2]|0)!=0);y=c[k>>2]|0;z=A}g=u+1|0;if((g|0)<(y|0)){l=y;u=g;w=z}else{B=z;break}}}else{B=x}x=c[o>>2]|0;if((x|0)>0){z=d+40|0;w=d+24|0;u=d+8|0;y=x;x=0;l=B;while(1){A=c[z>>2]|0;k=a[A+(x*52|0)+8|0]|0;if((c[e+(k<<24>>24<<2)>>2]|0)==0){C=y;D=l}else{s=k<<24>>24==2?114520:l;if(k<<24>>24==0){E=c[(c[u>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else if(k<<24>>24==1){E=c[(c[w>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else{E=s}jba(b,c[A+(x*52|0)+16>>2]|0,E,(c[A+(x*52|0)>>2]|0)!=0);C=c[o>>2]|0;D=E}A=x+1|0;if((A|0)<(C|0)){y=C;x=A;l=D}else{F=D;break}}}else{F=B}B=c[q>>2]|0;if((B|0)<=0){i=f;return}D=d+44|0;l=d+28|0;x=d+12|0;d=B;B=0;C=F;while(1){F=c[D>>2]|0;y=a[F+(B*52|0)+8|0]|0;if((c[e+(y<<24>>24<<2)>>2]|0)==0){G=d;H=C}else{E=y<<24>>24==2?114520:C;if(y<<24>>24==0){I=c[(c[x>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else if(y<<24>>24==1){I=c[(c[l>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else{I=E}jba(b,c[F+(B*52|0)+16>>2]|0,I,(c[F+(B*52|0)>>2]|0)!=0);G=c[q>>2]|0;H=I}F=B+1|0;if((F|0)<(G|0)){d=G;B=F;C=H}else{break}}i=f;return}function iba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Waa(a,b);Vaa(a,1);Waa(a,114560);Waa(a,c);i=d;return}function jba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;Waa(a,b);Vaa(a,d?2:1);Waa(a,114584);Waa(a,c);if(!d){i=e;return}Waa(a,114592);Waa(a,114600);i=e;return}function kba(a){a=a|0;var b=0;b=i;saa(a);i=b;return}function lba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=i;i=i+288|0;d=c;e=c+16|0;f=c+32|0;g=c+48|0;h=c+64|0;j=c+80|0;k=c+96|0;l=c+112|0;m=c+128|0;n=c+144|0;o=c+160|0;p=c+176|0;q=c+192|0;r=c+208|0;s=c+224|0;t=c+240|0;u=c+256|0;v=c+272|0;yma(e,114624);uma(d,nba(a,e)|0);mba(d,b+4|0);Ema(d);Ema(e);yma(g,114632);uma(f,nba(a,g)|0);oba(f,b);Ema(f);Ema(g);yma(j,114648);uma(h,nba(a,j)|0);mba(h,b+8|0);Ema(h);Ema(j);yma(l,114664);uma(k,nba(a,l)|0);mba(k,b+12|0);Ema(k);Ema(l);yma(n,114680);uma(m,nba(a,n)|0);pba(m,b+16|0,0);Ema(m);Ema(n);yma(p,114696);uma(o,nba(a,p)|0);pba(o,b+20|0,0);Ema(o);Ema(p);yma(r,114712);uma(q,nba(a,r)|0);pba(q,b+24|0,0);Ema(q);Ema(r);yma(t,114720);uma(s,nba(a,t)|0);pba(s,b+28|0,0);Ema(s);Ema(t);yma(v,114736);uma(u,nba(a,v)|0);pba(u,b+32|0,0);Ema(u);Ema(v);i=c;return}function mba(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;if((b|0)==0){X1(22,0,117944,d);i=d;return}else{c[b>>2]=sd($ma(a)|0)|0;i=d;return}}function nba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=wfa(a,f,b)|0;l=c[k>>2]|0;Z7(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}yfa(j,a,b);zfa(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];xfa(g,e);Afa(j);j=c[f>>2]|0;Bfa(a,j,k,Cfa(g)|0);k=Dfa(g)|0;Afa(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function oba(a,b){a=a|0;b=b|0;var d=0;d=i;if((cna(a,114912)|0)==0){c[b>>2]=1;i=d;return}if((cna(a,114920)|0)==0){c[b>>2]=0;i=d;return}else{c[b>>2]=Ec($ma(a)|0)|0;i=d;return}}function pba(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((cna(a,114888)|0)==0){c[b>>2]=d}if((cna(a,114912)|0)==0){c[b>>2]=1;i=e;return}if((cna(a,114920)|0)==0){c[b>>2]=0;i=e;return}else{c[b>>2]=Ec($ma(a)|0)|0;i=e;return}}function qba(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;e=i;i=i+56|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;yma(j,114752);uma(g,nba(b,j)|0);y=d+48|0;rba(g,y);Ema(g);Ema(j);yma(m,114768);uma(l,nba(b,m)|0);j=d+56|0;sba(l,j,0.0);Ema(l);Ema(m);yma(o,114776);uma(n,nba(b,o)|0);m=d+32|0;rba(n,m);Ema(n);Ema(o);yma(q,114784);uma(p,nba(b,q)|0);o=d+33|0;rba(p,o);Ema(p);Ema(q);yma(s,114800);uma(r,nba(b,s)|0);q=d+40|0;sba(r,q,1.0);Ema(r);Ema(s);yma(u,114808);uma(t,nba(b,u)|0);s=d+16|0;sba(t,s,-1.7976931348623157e+308);Ema(t);Ema(u);yma(w,114816);uma(v,nba(b,w)|0);u=d+24|0;sba(v,u,1.7976931348623157e+308);Ema(v);Ema(w);yma(x,114624);w=$ma(nba(b,x)|0)|0;b=(a[y]|0)!=0;z=+h[j>>3];j=(a[m]|0)!=0?114912:114920;m=(a[o]|0)!=0;A=+h[q>>3];B=+h[s>>3];C=+h[u>>3];c[f>>2]=w;c[f+4>>2]=b?114888:114896;w=f+8|0;h[k>>3]=z;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[f+16>>2]=b?114888:114904;c[f+20>>2]=j;c[f+24>>2]=m?114888:114896;j=f+28|0;h[k>>3]=A;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[f+36>>2]=m?114888:114904;m=f+40|0;h[k>>3]=B;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=f+48|0;h[k>>3]=C;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];V1(4,0,114824,f);Ema(x);i=e;return}function rba(b,c){b=b|0;c=c|0;var d=0;d=i;a[c]=(cna(b,114912)|0)==0|0;i=d;return}function sba(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;if((cna(a,114888)|0)==0){h[b>>3]=c;i=d;return}if((cna(a,114912)|0)==0){h[b>>3]=1.0;i=d;return}if((cna(a,114920)|0)==0){h[b>>3]=0.0;i=d;return}else{h[b>>3]=+dxa($ma(a)|0);i=d;return}}function tba(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;yma(h,114752);uma(g,nba(b,h)|0);s=d+13|0;rba(g,s);Ema(g);Ema(h);yma(k,114768);uma(j,nba(b,k)|0);h=d+16|0;pba(j,h,0);Ema(j);Ema(k);yma(m,114776);uma(l,nba(b,m)|0);k=d+12|0;rba(l,k);Ema(l);Ema(m);yma(o,114808);uma(n,nba(b,o)|0);m=d+4|0;pba(n,m,-2147483648);Ema(n);Ema(o);yma(q,114816);uma(p,nba(b,q)|0);o=d+8|0;pba(p,o,2147483647);Ema(p);Ema(q);yma(r,114624);q=$ma(nba(b,r)|0)|0;b=(a[s]|0)!=0;s=c[h>>2]|0;h=(a[k]|0)!=0?114912:114920;k=c[m>>2]|0;m=c[o>>2]|0;c[f>>2]=q;c[f+4>>2]=b?114888:114896;c[f+8>>2]=s;c[f+12>>2]=b?114888:114904;c[f+16>>2]=h;c[f+20>>2]=k;c[f+24>>2]=m;V1(4,0,114928,f);Ema(r);i=e;return}function uba(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;yma(h,114752);uma(g,nba(b,h)|0);o=d+5|0;rba(g,o);Ema(g);Ema(h);yma(k,114768);uma(j,nba(b,k)|0);h=d+6|0;rba(j,h);Ema(j);Ema(k);yma(m,114776);uma(l,nba(b,m)|0);k=d+4|0;rba(l,k);Ema(l);Ema(m);yma(n,114624);m=$ma(nba(b,n)|0)|0;b=(a[o]|0)!=0;o=(a[h]|0)!=0?114912:114920;h=(a[k]|0)!=0?114912:114920;c[f>>2]=m;c[f+4>>2]=b?114888:114896;c[f+8>>2]=o;c[f+12>>2]=b?114888:114904;c[f+16>>2]=h;V1(4,0,114984,f);Ema(n);i=e;return}function vba(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;yma(h,114752);uma(g,nba(b,h)|0);m=d+4|0;rba(g,m);Ema(g);Ema(h);yma(k,114768);uma(j,nba(b,k)|0);h=d+8|0;mba(j,h);Ema(j);Ema(k);yma(l,114624);k=$ma(nba(b,l)|0)|0;b=(a[m]|0)!=0;m=c[h>>2]|0;c[f>>2]=k;c[f+4>>2]=b?114888:114896;c[f+8>>2]=m;c[f+12>>2]=b?114888:114904;V1(4,0,115024,f);Ema(l);i=e;return}function wba(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Xc=0,Yc=0,Zc=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+200|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+16|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+1024|0;Ba=i;i=i+8|0;Ca=i;i=i+16|0;Da=i;i=i+8|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;sb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+8|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+8|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+8|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+8|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+8|0;fc=i;i=i+16|0;gc=i;i=i+8|0;hc=i;i=i+8|0;jc=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+8|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+8|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+8|0;sc=i;i=i+16|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+8|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+8|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+8|0;Ec=i;i=i+16|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+8|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+8|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+8|0;Qc=i;i=i+16|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=qa;xba(qa);sma(ra);yba(sa,ta);yba(ua,va);va=b+92|0;do{if((c[va>>2]|0)==0){if((c[128008>>2]|0)==0){yma(za,c[b+80>>2]|0);zba(ya,za,115048);Fma(ra,ya)|0;Ema(ya);Ema(za)}else{Gma(ra,c[128136>>2]|0)|0}ta=ic($ma(ra)|0,115064)|0;if((ta|0)!=0){Xc=ta;break}c[pa>>2]=$ma(ra)|0;Z1(0,115072,pa)}else{Xc=0}}while(0);pa=MY(0)|0;if((pa|0)==0){Wc(Xc|0)|0;Z1(0,115176,oa)}XY(pa,Vc);YY(pa,9,60);Vc=c[va>>2]|0;do{if((Vc|0)==0){oa=Aa;pxa(oa|0,0,1024)|0;while(1){za=rb(oa|0,1,1024,Xc|0)|0;ya=za>>>0<1024;if((ZY(pa,oa,za,ya&1)|0)==0){Yc=12;break}if(ya){Yc=14;break}}if((Yc|0)==12){Wc(Xc|0)|0;oa=$ma(ra)|0;ya=fZ(cZ(pa)|0)|0;za=dZ(pa)|0;c[na>>2]=oa;c[na+4>>2]=ya;c[na+8>>2]=za;X1(1,0,115256,na);TY(pa);Z1(0,115344,ma)}else if((Yc|0)==14){Wc(Xc|0)|0;break}}else{if((ZY(pa,Vc,lxa(Vc|0)|0,1)|0)!=0){break}za=c[r>>2]|0;ya=c[va>>2]|0;oa=fZ(cZ(pa)|0)|0;ta=dZ(pa)|0;c[la>>2]=ya;c[la+4>>2]=oa;c[la+8>>2]=ta;pd(za|0,115368,la|0)|0;za=c[va>>2]|0;ta=fZ(cZ(pa)|0)|0;oa=dZ(pa)|0;c[ka>>2]=za;c[ka+4>>2]=ta;c[ka+8>>2]=oa;X1(1,0,115384,ka);TY(pa);Z1(0,115344,ja)}}while(0);ja=qa;yma(Ca,115472);Dba(Ba,ja,Ca);Eba(Da,ja);ka=Cba(Ba,Da)|0;Ema(Ca);Ca=b+88|0;Da=c[Ca>>2]|0;do{if(ka){Ba=$ma(ra)|0;c[ia>>2]=Da;c[ia+4>>2]=Ba;X1(1,0,115480,ia)}else{yma(Ea,115472);Ba=hxa(Da,$ma(nba(ja,Ea)|0)|0)|0;Ema(Ea);if((Ba|0)==0){break}TY(pa);yma(Fa,115472);Ba=$ma(nba(ja,Fa)|0)|0;va=$ma(ra)|0;la=c[Ca>>2]|0;c[ha>>2]=Ba;c[ha+4>>2]=va;c[ha+8>>2]=la;X1(1,0,115528,ha);Ema(Fa);Z1(0,115344,ga)}}while(0);Fba(qa,b,c[128220>>2]|0,c[128224>>2]|0);V1(23,1,115624,fa);fa=qa+12|0;yma(Ha,115664);uma(Ga,nba(fa,Ha)|0);ga=d;sba(Ga,ga,0.0);Ema(Ga);Ema(Ha);Ha=ea;h[k>>3]=+h[ga>>3];c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];V1(23,0,115680,ea);yma(Ja,115696);uma(Ia,nba(fa,Ja)|0);ea=d+8|0;sba(Ia,ea,1.0);Ema(Ia);Ema(Ja);Ja=da;h[k>>3]=+h[ea>>3];c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];V1(23,0,115712,da);yma(La,115728);uma(Ka,nba(fa,La)|0);da=d+24|0;sba(Ka,da,(+h[ea>>3]- +h[ga>>3])/500.0);Ema(Ka);Ema(La);La=ca;h[k>>3]=+h[da>>3];c[La>>2]=c[k>>2];c[La+4>>2]=c[k+4>>2];V1(23,0,115744,ca);yma(Na,115760);uma(Ma,nba(fa,Na)|0);ca=d+32|0;sba(Ma,ca,1.0e-5);Ema(Ma);Ema(Na);Na=ba;h[k>>3]=+h[ca>>3];c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];V1(23,0,115776,ba);yma(Pa,115792);uma(Oa,nba(fa,Pa)|0);ba=d+40|0;mba(Oa,ba);Ema(Oa);Ema(Pa);c[aa>>2]=c[ba>>2];V1(23,0,115800,aa);yma(Ra,115824);uma(Qa,nba(fa,Ra)|0);aa=d+44|0;mba(Qa,aa);Ema(Qa);Ema(Ra);c[$>>2]=c[aa>>2];V1(23,0,115840,$);yma(Ta,115864);uma(Sa,nba(fa,Ta)|0);fa=d+48|0;mba(Sa,fa);Ema(Sa);Ema(Ta);c[_>>2]=c[fa>>2];V1(23,0,115880,_);yma(Va,115904);uma(Ua,nba(ja,Va)|0);_=d+268|0;mba(Ua,_);Ema(Ua);Ema(Va);c[Z>>2]=c[_>>2];V1(23,0,115928,Z);if((c[70980>>2]|0)!=0){Zd[c[17860]&1023](23)}yma(eb,115952);uma(db,nba(ja,eb)|0);pba(db,Wa,0);Ema(db);Ema(eb);yma(gb,115984);uma(fb,nba(ja,gb)|0);pba(fb,Xa,0);Ema(fb);Ema(gb);yma(ib,116016);uma(hb,nba(ja,ib)|0);pba(hb,Ya,0);Ema(hb);Ema(ib);yma(kb,116040);uma(jb,nba(ja,kb)|0);pba(jb,_a,0);Ema(jb);Ema(kb);yma(mb,116072);uma(lb,nba(ja,mb)|0);pba(lb,Za,0);Ema(lb);Ema(mb);yma(ob,116112);uma(nb,nba(ja,ob)|0);pba(nb,ab,0);Ema(nb);Ema(ob);yma(qb,116144);uma(pb,nba(ja,qb)|0);pba(pb,$a,0);Ema(pb);Ema(qb);yma(tb,116184);uma(sb,nba(ja,tb)|0);pba(sb,cb,0);Ema(sb);Ema(tb);yma(vb,116216);uma(ub,nba(ja,vb)|0);pba(ub,bb,0);Ema(ub);Ema(vb);vb=c[Wa>>2]|0;Wa=b+104|0;do{if((vb|0)==(c[Wa>>2]|0)){ub=b+108|0;if((c[Xa>>2]|0)!=((c[ub>>2]|0)-(vb<<1)|0)){break}ja=b+128|0;if((c[Ya>>2]|0)!=(c[ja>>2]|0)){break}tb=b+132|0;if((c[_a>>2]|0)!=(c[tb>>2]|0)){break}sb=b+116|0;if((c[Za>>2]|0)!=(c[sb>>2]|0)){break}qb=b+136|0;if((c[ab>>2]|0)!=(c[qb>>2]|0)){break}pb=b+120|0;if((c[$a>>2]|0)!=(c[pb>>2]|0)){break}ob=b+140|0;if((c[cb>>2]|0)!=(c[ob>>2]|0)){break}nb=b+124|0;if((c[bb>>2]|0)!=(c[nb>>2]|0)){break}c[O>>2]=116760;V1(4,1,116736,O);if((c[Wa>>2]|0)>0){mb=b;lb=qa+24|0;kb=0;do{jb=c[mb>>2]|0;c[wb>>2]=kb;ib=Gba(lb,wb)|0;lba(ib,jb+(kb*112|0)|0);qba(ib,jb+(kb*112|0)+40|0);hb=jb+(kb*112|0)+4|0;do{if((a[c[hb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}else{if((c[128004>>2]|0)!=0){break}yma(xb,116776);jb=(cna(nba(ib,xb)|0,114912)|0)==0;Ema(xb);if(!jb){break}c[N>>2]=c[hb>>2];V1(4,0,116792,N);a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}}while(0);yma(yb,c[hb>>2]|0);c[(Hba(sa,yb)|0)>>2]=kb;Ema(yb);kb=kb+1|0;}while((kb|0)<(c[Wa>>2]|0))}if((c[70904>>2]|0)!=0){Zd[c[17860]&1023](4)}c[M>>2]=116824;V1(4,1,116736,M);kb=c[Wa>>2]|0;if((kb|0)>0){mb=b;lb=qa+36|0;ib=kb;kb=0;do{jb=ib+kb|0;gb=c[mb>>2]|0;c[zb>>2]=kb;fb=Gba(lb,zb)|0;lba(fb,gb+(jb*112|0)|0);qba(fb,gb+(jb*112|0)+40|0);eb=gb+(jb*112|0)+4|0;do{if((a[c[eb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}else{if((c[128004>>2]|0)!=0){break}yma(Ab,116776);gb=(cna(nba(fb,Ab)|0,114912)|0)==0;Ema(Ab);if(!gb){break}c[L>>2]=c[eb>>2];V1(4,0,116792,L);a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}}while(0);yma(Bb,c[eb>>2]|0);c[(Hba(sa,Bb)|0)>>2]=jb;Ema(Bb);kb=kb+1|0;ib=c[Wa>>2]|0;}while((kb|0)<(ib|0))}if((c[70904>>2]|0)!=0){Zd[c[17860]&1023](4)}c[K>>2]=116848;V1(4,1,116736,K);ib=c[Wa>>2]<<1;if(((c[ub>>2]|0)-ib|0)>0){kb=b;mb=qa+48|0;lb=ib;ib=0;do{fb=lb+ib|0;hb=c[kb>>2]|0;c[Cb>>2]=ib;gb=Gba(mb,Cb)|0;lba(gb,hb+(fb*112|0)|0);qba(gb,hb+(fb*112|0)+40|0);db=hb+(fb*112|0)+4|0;do{if((a[c[db>>2]|0]|0)==36){a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}else{if((c[128004>>2]|0)!=0){break}yma(Db,116776);hb=(cna(nba(gb,Db)|0,114912)|0)==0;Ema(Db);if(!hb){break}c[J>>2]=c[db>>2];V1(4,0,116792,J);a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}}while(0);yma(Eb,c[db>>2]|0);c[(Hba(sa,Eb)|0)>>2]=fb;Ema(Eb);ib=ib+1|0;lb=c[Wa>>2]<<1;}while((ib|0)<((c[ub>>2]|0)-lb|0))}if((c[70904>>2]|0)!=0){Zd[c[17860]&1023](4)}c[I>>2]=116864;V1(4,1,116736,I);if((c[sb>>2]|0)>0){lb=b+4|0;ub=qa+84|0;ib=0;do{kb=c[lb>>2]|0;c[Fb>>2]=ib;mb=Gba(ub,Fb)|0;lba(mb,kb+(ib*60|0)|0);tba(mb,kb+(ib*60|0)+36|0);gb=kb+(ib*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}else{if((c[128004>>2]|0)!=0){break}yma(Gb,116776);kb=(cna(nba(mb,Gb)|0,114912)|0)==0;Ema(Gb);if(!kb){break}c[H>>2]=c[gb>>2];V1(4,0,116792,H);a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}}while(0);yma(Hb,c[gb>>2]|0);c[(Hba(sa,Hb)|0)>>2]=ib;Ema(Hb);ib=ib+1|0;}while((ib|0)<(c[sb>>2]|0))}if((c[70904>>2]|0)!=0){Zd[c[17860]&1023](4)}c[G>>2]=116888;V1(4,1,116736,G);if((c[pb>>2]|0)>0){sb=b+8|0;ib=qa+120|0;lb=0;do{ub=c[sb>>2]|0;c[Ib>>2]=lb;mb=Gba(ib,Ib)|0;lba(mb,ub+(lb*48|0)|0);uba(mb,ub+(lb*48|0)+36|0);fb=ub+(lb*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[sb>>2]|0)+(lb*48|0)+44|0]=1}else{if((c[128004>>2]|0)!=0){break}yma(Jb,116776);ub=(cna(nba(mb,Jb)|0,114912)|0)==0;Ema(Jb);if(!ub){break}c[F>>2]=c[fb>>2];V1(4,0,116792,F);a[(c[sb>>2]|0)+(lb*48|0)+44|0]=1}}while(0);yma(Kb,c[fb>>2]|0);c[(Hba(sa,Kb)|0)>>2]=lb;Ema(Kb);lb=lb+1|0;}while((lb|0)<(c[pb>>2]|0))}if((c[70904>>2]|0)!=0){Zd[c[17860]&1023](4)}c[E>>2]=116912;V1(4,1,116736,E);if((c[nb>>2]|0)>0){pb=b+12|0;lb=qa+156|0;sb=0;do{ib=c[pb>>2]|0;c[Lb>>2]=sb;mb=Gba(lb,Lb)|0;lba(mb,ib+(sb*52|0)|0);vba(mb,ib+(sb*52|0)+36|0);gb=ib+(sb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[pb>>2]|0)+(sb*52|0)+48|0]=1}else{if((c[128004>>2]|0)!=0){break}yma(Mb,116776);ib=(cna(nba(mb,Mb)|0,114912)|0)==0;Ema(Mb);if(!ib){break}c[D>>2]=c[gb>>2];V1(4,0,116792,D);a[(c[pb>>2]|0)+(sb*52|0)+48|0]=1}}while(0);yma(Nb,c[gb>>2]|0);c[(Hba(sa,Nb)|0)>>2]=sb;Ema(Nb);sb=sb+1|0;}while((sb|0)<(c[nb>>2]|0))}if((c[70904>>2]|0)!=0){Zd[c[17860]&1023](4)}c[C>>2]=116936;V1(4,1,116736,C);if((c[ja>>2]|0)>0){nb=b+16|0;sb=qa+60|0;pb=0;do{lb=c[nb>>2]|0;c[Ob>>2]=pb;mb=Gba(sb,Ob)|0;lba(mb,lb+(pb*112|0)|0);qba(mb,lb+(pb*112|0)+40|0);fb=lb+(pb*112|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}else{if((c[128004>>2]|0)!=0){break}yma(Pb,116776);lb=(cna(nba(mb,Pb)|0,114912)|0)==0;Ema(Pb);if(!lb){break}c[B>>2]=c[fb>>2];V1(4,0,116792,B);a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}}while(0);yma(Qb,c[fb>>2]|0);c[(Hba(ua,Qb)|0)>>2]=pb;Ema(Qb);pb=pb+1|0;}while((pb|0)<(c[ja>>2]|0))}if((c[70904>>2]|0)!=0){Zd[c[17860]&1023](4)}c[A>>2]=116952;V1(4,1,116736,A);if((c[tb>>2]|0)>0){ja=b+20|0;pb=qa+96|0;nb=0;do{sb=c[ja>>2]|0;c[Rb>>2]=nb;mb=Gba(pb,Rb)|0;lba(mb,sb+(nb*60|0)|0);tba(mb,sb+(nb*60|0)+36|0);gb=sb+(nb*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}else{if((c[128004>>2]|0)!=0){break}yma(Sb,116776);sb=(cna(nba(mb,Sb)|0,114912)|0)==0;Ema(Sb);if(!sb){break}c[z>>2]=c[gb>>2];V1(4,0,116792,z);a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}}while(0);yma(Tb,c[gb>>2]|0);c[(Hba(ua,Tb)|0)>>2]=nb;Ema(Tb);nb=nb+1|0;}while((nb|0)<(c[tb>>2]|0))}if((c[70904>>2]|0)!=0){Zd[c[17860]&1023](4)}c[y>>2]=116976;V1(4,1,116736,y);if((c[qb>>2]|0)>0){tb=b+24|0;nb=qa+132|0;ja=0;do{pb=c[tb>>2]|0;c[Ub>>2]=ja;mb=Gba(nb,Ub)|0;lba(mb,pb+(ja*48|0)|0);uba(mb,pb+(ja*48|0)+36|0);fb=pb+(ja*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}else{if((c[128004>>2]|0)!=0){break}yma(Vb,116776);pb=(cna(nba(mb,Vb)|0,114912)|0)==0;Ema(Vb);if(!pb){break}c[x>>2]=c[fb>>2];V1(4,0,116792,x);a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}}while(0);yma(Wb,c[fb>>2]|0);c[(Hba(ua,Wb)|0)>>2]=ja;Ema(Wb);ja=ja+1|0;}while((ja|0)<(c[qb>>2]|0))}if((c[70904>>2]|0)!=0){Zd[c[17860]&1023](4)}c[w>>2]=117e3;V1(4,1,116736,w);if((c[ob>>2]|0)>0){qb=b+28|0;ja=qa+168|0;tb=0;do{nb=c[qb>>2]|0;c[Xb>>2]=tb;mb=Gba(ja,Xb)|0;lba(mb,nb+(tb*52|0)|0);vba(mb,nb+(tb*52|0)+36|0);gb=nb+(tb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}else{if((c[128004>>2]|0)!=0){break}yma(Yb,116776);nb=(cna(nba(mb,Yb)|0,114912)|0)==0;Ema(Yb);if(!nb){break}c[v>>2]=c[gb>>2];V1(4,0,116792,v);a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}}while(0);yma(Zb,c[gb>>2]|0);c[(Hba(ua,Zb)|0)>>2]=tb;Ema(Zb);tb=tb+1|0;}while((tb|0)<(c[ob>>2]|0))}if((c[70904>>2]|0)!=0){Zd[c[17860]&1023](4)}V1(4,1,117024,u);ob=b+208|0;a:do{if((c[ob>>2]|0)>0){tb=qa+72|0;qb=b+32|0;ja=0;b:while(1){c[_b>>2]=ja;mb=Gba(tb,_b)|0;lba(mb,(c[qb>>2]|0)+(ja*52|0)+12|0);sma($b);c[bc>>2]=ja;mb=Gba(tb,bc)|0;yma(cc,117064);uma(ac,nba(mb,cc)|0);Iba(ac,$b);Ema(ac);Ema(cc);mb=(cna($b,117072)|0)==0;fb=c[qb>>2]|0;nb=mb&1;c[fb+(ja*52|0)>>2]=nb;c[t>>2]=c[fb+(ja*52|0)+16>>2];c[t+4>>2]=nb;V1(4,0,117088,t);nb=c[qb>>2]|0;if((a[c[nb+(ja*52|0)+16>>2]|0]|0)==36){a[nb+(ja*52|0)+48|0]=1}c[ec>>2]=ja;nb=Gba(tb,ec)|0;yma(fc,117128);uma(dc,nba(nb,fc)|0);Iba(dc,$b);Ema(dc);Ema(fc);Jba(wa,sa,$b);Jba(xa,ua,$b);Lba(gc,sa);do{if(Kba(wa,gc)|0){nb=c[(Mba(wa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(ja*52|0)+4>>2]=nb;a[fb+(ja*52|0)+8|0]=0}else{Lba(hc,ua);if(Kba(xa,hc)|0){fb=c[(Mba(xa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=fb;a[nb+(ja*52|0)+8|0]=1;break}if((cna($b,117144)|0)!=0){break b}a[(c[qb>>2]|0)+(ja*52|0)+8|0]=2}}while(0);Ema($b);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break a}}nna(kc,117152,$b);zba(jc,kc,117176);Ema(kc);c[s>>2]=$ma(jc)|0;Z1(0,117192,s)}}while(0);if((c[70904>>2]|0)!=0){Zd[c[17860]&1023](4)}V1(4,1,117200,q);ob=b+212|0;c:do{if((c[ob>>2]|0)>0){ja=qa+108|0;qb=b+36|0;tb=0;while(1){c[lc>>2]=tb;gb=Gba(ja,lc)|0;lba(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);sma(mc);c[oc>>2]=tb;gb=Gba(ja,oc)|0;yma(pc,117064);uma(nc,nba(gb,pc)|0);Iba(nc,mc);Ema(nc);Ema(pc);gb=(cna(mc,117072)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[p>>2]=c[nb+(tb*52|0)+16>>2];c[p+4>>2]=fb;V1(4,0,117088,p);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[rc>>2]=tb;fb=Gba(ja,rc)|0;yma(sc,117128);uma(qc,nba(fb,sc)|0);Iba(qc,mc);Ema(qc);Ema(sc);Jba(wa,sa,mc);Jba(xa,ua,mc);Lba(tc,sa);if(Kba(wa,tc)|0){fb=c[(Mba(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{Lba(uc,ua);if(!(Kba(xa,uc)|0)){break}nb=c[(Mba(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}Ema(mc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break c}}nna(wc,117240,mc);zba(vc,wc,117176);Ema(wc);c[o>>2]=$ma(vc)|0;Z1(0,117192,o)}}while(0);if((c[70904>>2]|0)!=0){Zd[c[17860]&1023](4)}V1(4,1,117264,n);ob=b+216|0;d:do{if((c[ob>>2]|0)>0){tb=qa+144|0;qb=b+40|0;ja=0;while(1){c[xc>>2]=ja;fb=Gba(tb,xc)|0;lba(fb,(c[qb>>2]|0)+(ja*52|0)+12|0);sma(yc);c[Ac>>2]=ja;fb=Gba(tb,Ac)|0;yma(Bc,117064);uma(zc,nba(fb,Bc)|0);Iba(zc,yc);Ema(zc);Ema(Bc);fb=(cna(yc,117072)|0)==0;nb=c[qb>>2]|0;gb=fb&1;c[nb+(ja*52|0)>>2]=gb;c[m>>2]=c[nb+(ja*52|0)+16>>2];c[m+4>>2]=gb;V1(4,0,117088,m);gb=c[qb>>2]|0;if((a[c[gb+(ja*52|0)+16>>2]|0]|0)==36){a[gb+(ja*52|0)+48|0]=1}c[Dc>>2]=ja;gb=Gba(tb,Dc)|0;yma(Ec,117128);uma(Cc,nba(gb,Ec)|0);Iba(Cc,yc);Ema(Cc);Ema(Ec);Jba(wa,sa,yc);Jba(xa,ua,yc);Lba(Fc,sa);if(Kba(wa,Fc)|0){gb=c[(Mba(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=gb;a[nb+(ja*52|0)+8|0]=0}else{Lba(Gc,ua);if(!(Kba(xa,Gc)|0)){break}nb=c[(Mba(xa)|0)+12>>2]|0;gb=c[qb>>2]|0;c[gb+(ja*52|0)+4>>2]=nb;a[gb+(ja*52|0)+8|0]=1}Ema(yc);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break d}}nna(Ic,117304,yc);zba(Hc,Ic,117176);Ema(Ic);c[l>>2]=$ma(Hc)|0;Z1(0,117192,l)}}while(0);if((c[70904>>2]|0)!=0){Zd[c[17860]&1023](4)}V1(4,1,117328,j);ob=b+220|0;e:do{if((c[ob>>2]|0)>0){ja=qa+180|0;qb=b+44|0;tb=0;while(1){c[Jc>>2]=tb;gb=Gba(ja,Jc)|0;lba(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);sma(Kc);c[Mc>>2]=tb;gb=Gba(ja,Mc)|0;yma(Nc,117064);uma(Lc,nba(gb,Nc)|0);Iba(Lc,Kc);Ema(Lc);Ema(Nc);gb=(cna(Kc,117072)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[g>>2]=c[nb+(tb*52|0)+16>>2];c[g+4>>2]=fb;V1(4,0,117088,g);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[Pc>>2]=tb;fb=Gba(ja,Pc)|0;yma(Qc,117128);uma(Oc,nba(fb,Qc)|0);Iba(Oc,Kc);Ema(Oc);Ema(Qc);Jba(wa,sa,Kc);Jba(xa,ua,Kc);Lba(Rc,sa);if(Kba(wa,Rc)|0){fb=c[(Mba(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{Lba(Sc,ua);if(!(Kba(xa,Sc)|0)){break}nb=c[(Mba(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}Ema(Kc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break e}}nna(Uc,117368,Kc);zba(Tc,Uc,117176);Ema(Uc);c[f>>2]=$ma(Tc)|0;Z1(0,117192,f)}}while(0);if((c[70904>>2]|0)==0){TY(pa);Nba(ua);Nba(sa);Ema(ra);Oba(qa);i=e;return}Zd[c[17860]&1023](4);TY(pa);Nba(ua);Nba(sa);Ema(ra);Oba(qa);i=e;return}}while(0);if((c[70976>>2]|c[17720]|0)==0){TY(pa);Zc=nd(0)|0;ud(-1)}X1(22,1,116256,Y);Y=c[Wa>>2]|0;c[X>>2]=vb;c[X+4>>2]=Y;X1(22,0,116304,X);X=(c[b+108>>2]|0)-(c[Wa>>2]<<1)|0;c[W>>2]=c[Xa>>2];c[W+4>>2]=X;X1(22,0,116352,W);W=c[b+128>>2]|0;c[V>>2]=c[Ya>>2];c[V+4>>2]=W;X1(22,0,116400,V);V=c[b+132>>2]|0;c[U>>2]=c[_a>>2];c[U+4>>2]=V;X1(22,0,116448,U);U=c[b+116>>2]|0;c[T>>2]=c[Za>>2];c[T+4>>2]=U;X1(22,0,116496,T);T=c[b+136>>2]|0;c[S>>2]=c[ab>>2];c[S+4>>2]=T;X1(22,0,116544,S);S=c[b+120>>2]|0;c[R>>2]=c[$a>>2];c[R+4>>2]=S;X1(22,0,116592,R);R=c[b+140>>2]|0;c[Q>>2]=c[cb>>2];c[Q+4>>2]=R;X1(22,0,116640,Q);Q=c[b+124>>2]|0;c[P>>2]=c[bb>>2];c[P+4>>2]=Q;X1(22,0,116688,P);Zd[c[17860]&1023](22);TY(pa);Zc=nd(0)|0;ud(-1)}function xba(a){a=a|0;var b=0;b=i;xia(a);i=b;return}function yba(a,b){a=a|0;b=b|0;b=i;cea(a,0);i=b;return}function zba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;tma(a,d);e=Cma(b)|0;f=mca(c)|0;dna(a,Dma(b)|0,e,f+e|0);Xma(a,c,f)|0;i=d;return}function Aba(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;if((hxa(b,118e3)|0)==0){t=c[d>>2]|0;if((t|0)==0){i=e;return}u=a;v=t;t=0;do{yma(g,v);w=nba(u,g)|0;Gma(w,c[d+((t|1)<<2)>>2]|0)|0;Ema(g);t=t+2|0;v=c[d+(t<<2)>>2]|0;}while((v|0)!=0);i=e;return}if((hxa(b,118024)|0)==0){v=c[d>>2]|0;if((v|0)==0){i=e;return}t=a+12|0;g=v;v=0;do{yma(h,g);u=nba(t,h)|0;Gma(u,c[d+((v|1)<<2)>>2]|0)|0;Ema(h);v=v+2|0;g=c[d+(v<<2)>>2]|0;}while((g|0)!=0);i=e;return}if((hxa(b,118048)|0)!=0){do{if((hxa(b,118304)|0)!=0){if((hxa(b,118312)|0)==0){break}if((hxa(b,118320)|0)==0){break}if((hxa(b,118328)|0)==0){break}i=e;return}}while(0);g=(c[d>>2]|0)==0;v=a+196|0;h=a+192|0;t=Gba(c[v>>2]|0,h)|0;if(g){x=t}else{g=t;t=d;u=0;while(1){yma(r,c[t>>2]|0);w=nba(g,r)|0;Gma(w,c[d+((u|1)<<2)>>2]|0)|0;Ema(r);w=u+2|0;y=d+(w<<2)|0;z=(c[y>>2]|0)==0;A=Gba(c[v>>2]|0,h)|0;if(z){x=A;break}else{u=w;t=y;g=A}}}yma(s,118336);Gma(nba(x,s)|0,b)|0;Ema(s);i=e;return}Pba(j,k);sma(l);sma(m);k=a+192|0;s=k;c[k>>2]=-1;b=a+196|0;c[b>>2]=0;x=c[d>>2]|0;if((x|0)!=0){g=x;x=0;do{yma(n,g);t=nba(j,n)|0;Gma(t,c[d+((x|1)<<2)>>2]|0)|0;Ema(n);x=x+2|0;g=c[d+(x<<2)>>2]|0;}while((g|0)!=0)}yma(o,118064);Fma(l,nba(j,o)|0)|0;Ema(o);yma(p,118080);Fma(m,nba(j,p)|0)|0;Ema(p);c[k>>2]=Ec($ma(l)|0)|0;if((cna(m,118096)|0)==0){B=a+24|0}else{B=c[b>>2]|0}c[b>>2]=B;if((cna(m,118104)|0)==0){C=a+36|0}else{C=c[b>>2]|0}c[b>>2]=C;if((cna(m,118112)|0)==0){D=a+48|0}else{D=c[b>>2]|0}c[b>>2]=D;if((cna(m,118120)|0)==0){E=a+60|0}else{E=c[b>>2]|0}c[b>>2]=E;if((cna(m,118128)|0)==0){F=a+72|0}else{F=c[b>>2]|0}c[b>>2]=F;if((cna(m,118136)|0)==0){G=a+84|0}else{G=c[b>>2]|0}c[b>>2]=G;if((cna(m,118144)|0)==0){H=a+96|0}else{H=c[b>>2]|0}c[b>>2]=H;if((cna(m,118152)|0)==0){I=a+108|0}else{I=c[b>>2]|0}c[b>>2]=I;if((cna(m,118160)|0)==0){J=a+120|0}else{J=c[b>>2]|0}c[b>>2]=J;if((cna(m,118168)|0)==0){K=a+132|0}else{K=c[b>>2]|0}c[b>>2]=K;if((cna(m,118176)|0)==0){L=a+144|0}else{L=c[b>>2]|0}c[b>>2]=L;if((cna(m,118184)|0)==0){M=a+156|0}else{M=c[b>>2]|0}c[b>>2]=M;if((cna(m,118192)|0)==0){N=a+168|0}else{N=c[b>>2]|0}c[b>>2]=N;if((cna(m,118200)|0)==0){O=a+180|0}else{O=c[b>>2]|0}c[b>>2]=O;a=$ma(m)|0;yma(q,114624);N=$ma(nba(j,q)|0)|0;c[f>>2]=a;c[f+4>>2]=N;Y1(0,(O|0)!=0|0,118208,f);Ema(q);aha(Gba(c[b>>2]|0,s)|0,j)|0;Ema(m);Ema(l);Xba(j);i=e;return}function Bba(a,b){a=a|0;b=b|0;i=i;return}function Cba(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Nda(a,b)|0;i=c;return d|0}function Dba(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;Wda(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];Oda(a,f);i=e;return}function Eba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;Pda(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];Oda(a,e);i=d;return}



function PH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+892>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3616>>3],-+h[j+3608>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3680>>3]=l;h[e+3672>>3]=m;i=b;return}function QH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5848>>3]=+h[b+2624>>3]- +h[b+2592>>3];i=i;return}function RH(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5856>>3];e=+h[b+5848>>3];h[b+5872>>3]=+V(+(d*d+e*e));i=i;return}function SH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5864>>3]=+ba(+(+h[b+5848>>3]),+(+h[b+5856>>3]));i=i;return}function TH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6248>>3]=+h[b+2624>>3]- +h[b+2592>>3];i=i;return}function UH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4056>>3]=+h[b+2592>>3]*+h[b+4080>>3]- +h[b+2600>>3]*+h[b+4072>>3];i=i;return}function VH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4064>>3]=+h[b+2600>>3]*+h[b+4080>>3]+ +h[b+2592>>3]*+h[b+4072>>3];i=i;return}function WH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+960>>3]=+h[b+96>>3]- +h[b+912>>3];i=i;return}function XH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1512>>3]=+h[b+912>>3]- +h[b+2592>>3];i=i;return}function YH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+880>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3640>>3],-+h[j+3632>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3760>>3]=l;h[e+3752>>3]=m;i=b;return}function ZH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+880>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3640>>3],-+h[j+3632>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3744>>3]=l;h[e+3736>>3]=m;i=b;return}function _H(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+880>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3640>>3],-+h[j+3632>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3728>>3]=l;h[e+3720>>3]=m;i=b;return}function $H(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5816>>3]=+h[b+2608>>3]- +h[b+2624>>3];i=i;return}function aI(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5824>>3];e=+h[b+5816>>3];h[b+5840>>3]=+V(+(d*d+e*e));i=i;return}function bI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5832>>3]=+ba(+(+h[b+5816>>3]),+(+h[b+5824>>3]));i=i;return}function cI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5784>>3]=+h[b+2592>>3]- +h[b+2608>>3];i=i;return}function dI(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+5792>>3];e=+h[b+5784>>3];h[b+5808>>3]=+V(+(d*d+e*e));i=i;return}function eI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5800>>3]=+ba(+(+h[b+5784>>3]),+(+h[b+5792>>3]));i=i;return}function fI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6232>>3]=+h[b+2608>>3]- +h[b+2624>>3];i=i;return}function gI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6216>>3]=+h[b+2592>>3]- +h[b+2608>>3];i=i;return}function hI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4088>>3]=+h[b+2608>>3]*+h[b+4112>>3]- +h[b+2616>>3]*+h[b+4104>>3];i=i;return}function iI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4096>>3]=+h[b+2616>>3]*+h[b+4112>>3]+ +h[b+2608>>3]*+h[b+4104>>3];i=i;return}function jI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+976>>3]=+h[b+112>>3]- +h[b+928>>3];i=i;return}function kI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1528>>3]=+h[b+928>>3]- +h[b+2608>>3];i=i;return}function lI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3624>>3]=+h[b+2616>>3]*+h[b+3640>>3]+ +h[b+2608>>3]*+h[b+3632>>3];i=i;return}function mI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+868>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3664>>3],-+h[j+3656>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3808>>3]=l;h[e+3800>>3]=m;i=b;return}function nI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4e3>>3]=+h[b+3808>>3]+(+h[b+3712>>3]+ +h[b+3760>>3]);i=i;return}function oI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3592>>3]=-+h[b+4768>>3]- +h[b+4e3>>3];i=i;return}function pI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3992>>3]=+h[b+3800>>3]+(+h[b+3704>>3]+ +h[b+3752>>3]);i=i;return}function qI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3584>>3]=-+h[b+4760>>3]- +h[b+3992>>3];i=i;return}function rI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+868>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3664>>3],-+h[j+3656>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3792>>3]=l;h[e+3784>>3]=m;i=b;return}function sI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3984>>3]=+h[b+3792>>3]+(+h[b+3696>>3]+ +h[b+3744>>3]);i=i;return}function tI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3576>>3]=-+h[b+4752>>3]- +h[b+3984>>3];i=i;return}function uI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3976>>3]=+h[b+3784>>3]+(+h[b+3688>>3]+ +h[b+3736>>3]);i=i;return}function vI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3568>>3]=-+h[b+4744>>3]- +h[b+3976>>3];i=i;return}function wI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+868>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3664>>3],-+h[j+3656>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3776>>3]=l;h[e+3768>>3]=m;i=b;return}function xI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3960>>3]=+h[b+3768>>3]+(+h[b+3672>>3]+ +h[b+3720>>3]);i=i;return}function yI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3552>>3]=-+h[b+4728>>3]- +h[b+3960>>3];i=i;return}function zI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3968>>3]=+h[b+3776>>3]+(+h[b+3680>>3]+ +h[b+3728>>3]);i=i;return}function AI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3560>>3]=-+h[b+4736>>3]- +h[b+3968>>3];i=i;return}function BI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+204>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+3536>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+3536|0;h[c[g+208>>2]>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+3536>>3]);e=c[f>>2]|0;h[c[e+212>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+204>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+3544>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+3544|0;h[(c[e+208>>2]|0)+8>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+3544>>3]);j=c[f>>2]|0;h[(c[j+212>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+204>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+3504>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+3504|0;h[(c[j+208>>2]|0)+16>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+3504>>3]);g=c[f>>2]|0;h[(c[g+212>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+204>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+3520>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+3520|0;h[(c[g+208>>2]|0)+24>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+3520>>3]);e=c[f>>2]|0;h[(c[e+212>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+204>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+3512>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+3512|0;h[(c[e+208>>2]|0)+32>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+3512>>3]);j=c[f>>2]|0;h[(c[j+212>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+204>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+3528>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+3528|0;h[(c[j+208>>2]|0)+40>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+3528>>3]);h[(c[(c[f>>2]|0)+212>>2]|0)+40>>3]=k;S5(a,2)|0;g=c[(c[f>>2]|0)+204>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+3536>>3]=+h[g>>3];h[f+3544>>3]=+h[g+8>>3];h[f+3504>>3]=+h[g+16>>3];h[f+3520>>3]=+h[g+24>>3];h[f+3512>>3]=+h[g+32>>3];h[f+3528>>3]=+h[g+40>>3];Hs(a);Is(a);Js(a);Ks(a);Ls(a);Ms(a);Ns(a);Os(a);Ps(a);Qs(a);Rs(a);Ss(a);Ts(a);Us(a);Vs(a);i=b;return}function CI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9808>>3]=-+h[b+3528>>3]- +h[b+3512>>3]- +h[b+3544>>3];i=i;return}function DI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9800>>3]=-+h[b+3520>>3]- +h[b+3504>>3]- +h[b+3536>>3];i=i;return}function EI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3648>>3]=+h[b+2632>>3]*+h[b+3664>>3]+ +h[b+2624>>3]*+h[b+3656>>3];i=i;return}function FI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+992>>3]=+h[b+128>>3]- +h[b+944>>3];i=i;return}function GI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1544>>3]=+h[b+944>>3]- +h[b+2624>>3];i=i;return}function HI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2056>>3]=+h[b+1960>>3]- +h[b+160>>3];i=i;return}function II(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2520>>3]=+h[b+9352>>3]- +h[b+1968>>3];i=i;return}function JI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2064>>3]=+h[b+1968>>3]- +h[b+168>>3];i=i;return}function KI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2128>>3]=+h[b+2160>>3]*+h[b+2144>>3]+ +h[b+2152>>3]*+h[b+2136>>3];i=i;return}function LI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2168>>3]=+h[b+2200>>3]*+h[b+2184>>3]+ +h[b+2192>>3]*+h[b+2176>>3];i=i;return}function MI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2528>>3]=+h[b+9344>>3]- +h[b+1976>>3];i=i;return}function NI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2072>>3]=+h[b+1976>>3]- +h[b+176>>3];i=i;return}function OI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2088>>3]=+h[b+2120>>3]*+h[b+2104>>3]+ +h[b+2112>>3]*+h[b+2096>>3];i=i;return}function PI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9776>>3]=+h[b+2168>>3]+(+h[b+2088>>3]+ +h[b+2128>>3]);i=i;return}function QI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2504>>3]=+h[b+9368>>3]- +h[b+1952>>3];i=i;return}function RI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2048>>3]=+h[b+1952>>3]- +h[b+152>>3];i=i;return}function SI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1536>>3]=+h[b+936>>3]- +h[b+2616>>3];i=i;return}function TI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+984>>3]=+h[b+120>>3]- +h[b+936>>3];i=i;return}function UI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3600>>3]=+h[b+2600>>3]*+h[b+3616>>3]+ +h[b+2592>>3]*+h[b+3608>>3];i=i;return}function VI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4120>>3]=+h[b+2624>>3]*+h[b+4144>>3]- +h[b+2632>>3]*+h[b+4136>>3];i=i;return}function WI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4128>>3]=+h[b+2632>>3]*+h[b+4144>>3]+ +h[b+2624>>3]*+h[b+4136>>3];i=i;return}function XI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;b=i;i=i+40|0;d=b;e=b+16|0;f=b+32|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;c[o>>2]=3;b2(p,16,1,o);o=a+536|0;y=a+416|0;z=c[y>>2]|0;Wl(q,c[o>>2]|0,+h[z+192>>3],+h[z+200>>3]);z=q;q=c[y>>2]|0;Wl(r,c[o>>2]|0,+h[q+208>>3],+h[q+216>>3]);q=r;r=c[y>>2]|0;Wl(s,c[o>>2]|0,+h[r+224>>3],+h[r+232>>3]);r=s;c[n>>2]=1;s=c2(p,16,1,n)|0;c[s+0>>2]=c[z+0>>2];c[s+4>>2]=c[z+4>>2];c[s+8>>2]=c[z+8>>2];c[s+12>>2]=c[z+12>>2];c[m>>2]=2;z=c2(p,16,1,m)|0;c[z+0>>2]=c[q+0>>2];c[z+4>>2]=c[q+4>>2];c[z+8>>2]=c[q+8>>2];c[z+12>>2]=c[q+12>>2];c[l>>2]=3;q=c2(p,16,1,l)|0;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];c[k>>2]=3;b2(t,16,1,k);k=a+4|0;a=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Wl(u,c[o>>2]|0,+h[a+4128>>3],+h[a+4120>>3]);a=u;u=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Wl(v,c[o>>2]|0,+h[u+4096>>3],+h[u+4088>>3]);u=v;v=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Wl(w,c[o>>2]|0,+h[v+4064>>3],+h[v+4056>>3]);v=w;c[j>>2]=1;w=c2(t,16,1,j)|0;c[w+0>>2]=c[a+0>>2];c[w+4>>2]=c[a+4>>2];c[w+8>>2]=c[a+8>>2];c[w+12>>2]=c[a+12>>2];c[g>>2]=2;a=c2(t,16,1,g)|0;c[a+0>>2]=c[u+0>>2];c[a+4>>2]=c[u+4>>2];c[a+8>>2]=c[u+8>>2];c[a+12>>2]=c[u+12>>2];c[f>>2]=3;u=c2(t,16,1,f)|0;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];v=c[o>>2]|0;o=e;u=p;c[o+0>>2]=c[u+0>>2];c[o+4>>2]=c[u+4>>2];c[o+8>>2]=c[u+8>>2];u=d;o=t;c[u+0>>2]=c[o+0>>2];c[u+4>>2]=c[o+4>>2];c[u+8>>2]=c[o+8>>2];Sl(x,v,e,d);A=+h[x+8>>3];d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[d+11024>>3]=+h[x>>3];h[d+11016>>3]=A;i=b;return}function YI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9824>>3]=+h[b+11024>>3];i=i;return}function ZI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9816>>3]=+h[b+11016>>3];i=i;return}function _I(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4960>>3];e=+h[b+4952>>3];h[b+4912>>3]=+V(+(d*d+e*e));i=i;return}function $I(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4904>>3]=+ba(+(+h[b+4952>>3]),+(+h[b+4960>>3]));i=i;return}function aJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+388>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6704>>3]=g;h[e+6696>>3]=j;i=b;return}function bJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+388>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6720>>3]=g;h[e+6712>>3]=j;i=b;return}function cJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+388>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6736>>3]=g;h[e+6728>>3]=j;i=b;return}function dJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+376>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6752>>3]=g;h[e+6744>>3]=j;i=b;return}function eJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+376>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6768>>3]=g;h[e+6760>>3]=j;i=b;return}function fJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+376>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6784>>3]=g;h[e+6776>>3]=j;i=b;return}function gJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+364>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6800>>3]=g;h[e+6792>>3]=j;i=b;return}function hJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6648>>3]=-+h[b+6744>>3]- +h[b+6696>>3]- +h[b+6792>>3];i=i;return}function iJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6656>>3]=-+h[b+6752>>3]- +h[b+6704>>3]- +h[b+6800>>3];i=i;return}function jJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+364>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6816>>3]=g;h[e+6808>>3]=j;i=b;return}function kJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6664>>3]=-+h[b+6760>>3]- +h[b+6712>>3]- +h[b+6808>>3];i=i;return}function lJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6672>>3]=-+h[b+6768>>3]- +h[b+6720>>3]- +h[b+6816>>3];i=i;return}function mJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+364>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6832>>3]=g;h[e+6824>>3]=j;i=b;return}function nJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6688>>3]=-+h[b+6784>>3]- +h[b+6736>>3]- +h[b+6832>>3];i=i;return}function oJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6680>>3]=-+h[b+6776>>3]- +h[b+6728>>3]- +h[b+6824>>3];i=i;return}function pJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+284>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+6448>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+6448|0;h[c[g+288>>2]>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+6448>>3]);e=c[f>>2]|0;h[c[e+292>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+284>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+6416>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+6416|0;h[(c[e+288>>2]|0)+8>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+6416>>3]);j=c[f>>2]|0;h[(c[j+292>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+284>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+6440>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+6440|0;h[(c[j+288>>2]|0)+16>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+6440>>3]);g=c[f>>2]|0;h[(c[g+292>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+284>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+6408>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+6408|0;h[(c[g+288>>2]|0)+24>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+6408>>3]);e=c[f>>2]|0;h[(c[e+292>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+284>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+6424>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+6424|0;h[(c[e+288>>2]|0)+32>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+6424>>3]);j=c[f>>2]|0;h[(c[j+292>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+284>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+6432>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+6432|0;h[(c[j+288>>2]|0)+40>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+6432>>3]);h[(c[(c[f>>2]|0)+292>>2]|0)+40>>3]=k;S5(a,3)|0;g=c[(c[f>>2]|0)+284>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+6448>>3]=+h[g>>3];h[f+6416>>3]=+h[g+8>>3];h[f+6440>>3]=+h[g+16>>3];h[f+6408>>3]=+h[g+24>>3];h[f+6424>>3]=+h[g+32>>3];h[f+6432>>3]=+h[g+40>>3];Ys(a);Zs(a);_s(a);$s(a);at(a);bt(a);ct(a);dt(a);et(a);ft(a);gt(a);ht(a);it(a);jt(a);kt(a);i=b;return}function qJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+448>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+6432>>3],-+h[j+6424>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6352>>3]=l;h[e+6344>>3]=m;i=b;return}function rJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+448>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+6432>>3],-+h[j+6424>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6336>>3]=l;h[e+6328>>3]=m;i=b;return}function sJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+448>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+6432>>3],-+h[j+6424>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6320>>3]=l;h[e+6312>>3]=m;i=b;return}function tJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+436>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+6448>>3],-+h[j+6440>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6400>>3]=l;h[e+6392>>3]=m;i=b;return}function uJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+436>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+6448>>3],-+h[j+6440>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6384>>3]=l;h[e+6376>>3]=m;i=b;return}function vJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+436>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+6448>>3],-+h[j+6440>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6368>>3]=l;h[e+6360>>3]=m;i=b;return}function wJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+460>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+6416>>3],-+h[j+6408>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6304>>3]=l;h[e+6296>>3]=m;i=b;return}function xJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6640>>3]=+h[b+6400>>3]+(+h[b+6304>>3]+ +h[b+6352>>3]);i=i;return}function yJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6632>>3]=+h[b+6392>>3]+(+h[b+6296>>3]+ +h[b+6344>>3]);i=i;return}function zJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+460>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+6416>>3],-+h[j+6408>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6288>>3]=l;h[e+6280>>3]=m;i=b;return}function AJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6616>>3]=+h[b+6376>>3]+(+h[b+6280>>3]+ +h[b+6328>>3]);i=i;return}function BJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6624>>3]=+h[b+6384>>3]+(+h[b+6288>>3]+ +h[b+6336>>3]);i=i;return}function CJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+460>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+6416>>3],-+h[j+6408>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6272>>3]=l;h[e+6264>>3]=m;i=b;return}function DJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6600>>3]=+h[b+6360>>3]+(+h[b+6264>>3]+ +h[b+6312>>3]);i=i;return}function EJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6608>>3]=+h[b+6368>>3]+(+h[b+6272>>3]+ +h[b+6320>>3]);i=i;return}function FJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+352>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6848>>3]=g;h[e+6840>>3]=j;i=b;return}function GJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+352>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6864>>3]=g;h[e+6856>>3]=j;i=b;return}function HJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+352>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6880>>3]=g;h[e+6872>>3]=j;i=b;return}function IJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+340>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6896>>3]=g;h[e+6888>>3]=j;i=b;return}function JJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+340>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6912>>3]=g;h[e+6904>>3]=j;i=b;return}function KJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+340>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6928>>3]=g;h[e+6920>>3]=j;i=b;return}function LJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+328>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6944>>3]=g;h[e+6936>>3]=j;i=b;return}function MJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6984>>3]=+h[b+6936>>3]+(+h[b+6840>>3]+ +h[b+6888>>3]);i=i;return}function NJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7416>>3]=-+h[b+6600>>3]- +h[b+2640>>3]- +h[b+6984>>3];i=i;return}function OJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6992>>3]=+h[b+6944>>3]+(+h[b+6848>>3]+ +h[b+6896>>3]);i=i;return}function PJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7424>>3]=-+h[b+6608>>3]- +h[b+2648>>3]- +h[b+6992>>3];i=i;return}function QJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+328>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6960>>3]=g;h[e+6952>>3]=j;i=b;return}function RJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7008>>3]=+h[b+6960>>3]+(+h[b+6864>>3]+ +h[b+6912>>3]);i=i;return}function SJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7440>>3]=-+h[b+6624>>3]- +h[b+2664>>3]- +h[b+7008>>3];i=i;return}function TJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7e3>>3]=+h[b+6952>>3]+(+h[b+6856>>3]+ +h[b+6904>>3]);i=i;return}function UJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7432>>3]=-+h[b+6616>>3]- +h[b+2656>>3]- +h[b+7e3>>3];i=i;return}function VJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+328>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6976>>3]=g;h[e+6968>>3]=j;i=b;return}function WJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7016>>3]=+h[b+6968>>3]+(+h[b+6872>>3]+ +h[b+6920>>3]);i=i;return}function XJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7448>>3]=-+h[b+6632>>3]- +h[b+2672>>3]- +h[b+7016>>3];i=i;return}function YJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7024>>3]=+h[b+6976>>3]+(+h[b+6880>>3]+ +h[b+6928>>3]);i=i;return}function ZJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7456>>3]=-+h[b+6640>>3]- +h[b+2680>>3]- +h[b+7024>>3];i=i;return}function _J(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+364>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+7080>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+7080|0;h[c[g+368>>2]>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+7080>>3]);e=c[f>>2]|0;h[c[e+372>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+364>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+7104>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+7104|0;h[(c[e+368>>2]|0)+8>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+7104>>3]);j=c[f>>2]|0;h[(c[j+372>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+364>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+7112>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+7112|0;h[(c[j+368>>2]|0)+16>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+7112>>3]);g=c[f>>2]|0;h[(c[g+372>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+364>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+7088>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+7088|0;h[(c[g+368>>2]|0)+24>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+7088>>3]);e=c[f>>2]|0;h[(c[e+372>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+364>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+7096>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+7096|0;h[(c[e+368>>2]|0)+32>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+7096>>3]);j=c[f>>2]|0;h[(c[j+372>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+364>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+7120>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+7120|0;h[(c[j+368>>2]|0)+40>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+7120>>3]);h[(c[(c[f>>2]|0)+372>>2]|0)+40>>3]=k;S5(a,4)|0;g=c[(c[f>>2]|0)+364>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+7080>>3]=+h[g>>3];h[f+7104>>3]=+h[g+8>>3];h[f+7112>>3]=+h[g+16>>3];h[f+7088>>3]=+h[g+24>>3];h[f+7096>>3]=+h[g+32>>3];h[f+7120>>3]=+h[g+40>>3];nt(a);ot(a);pt(a);qt(a);rt(a);st(a);tt(a);ut(a);vt(a);wt(a);xt(a);yt(a);zt(a);At(a);Bt(a);i=b;return}function $J(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+7104>>3];e=+h[b+7096>>3];h[b+7056>>3]=+V(+(d*d+e*e));i=i;return}function aK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7048>>3]=+ba(+(+h[b+7096>>3]),+(+h[b+7104>>3]));i=i;return}function bK(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+7088>>3];e=+h[b+7080>>3];h[b+7040>>3]=+V(+(d*d+e*e));i=i;return}function cK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7032>>3]=+ba(+(+h[b+7080>>3]),+(+h[b+7088>>3]));i=i;return}function dK(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+7120>>3];e=+h[b+7112>>3];h[b+7072>>3]=+V(+(d*d+e*e));i=i;return}function eK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7064>>3]=+ba(+(+h[b+7112>>3]),+(+h[b+7120>>3]));i=i;return}function fK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+280>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7088>>3],+h[j+7080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7280>>3]=l;h[e+7272>>3]=m;i=b;return}function gK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+280>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7088>>3],+h[j+7080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7296>>3]=l;h[e+7288>>3]=m;i=b;return}function hK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+280>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7088>>3],+h[j+7080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7312>>3]=l;h[e+7304>>3]=m;i=b;return}function iK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+268>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7104>>3],+h[j+7096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7328>>3]=l;h[e+7320>>3]=m;i=b;return}function jK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+268>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7104>>3],+h[j+7096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7344>>3]=l;h[e+7336>>3]=m;i=b;return}function kK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+268>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7104>>3],+h[j+7096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7360>>3]=l;h[e+7352>>3]=m;i=b;return}function lK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+256>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7120>>3],+h[j+7112>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7376>>3]=l;h[e+7368>>3]=m;i=b;return}function mK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7472>>3]=+h[b+7376>>3]+(+h[b+7280>>3]+ +h[b+7328>>3]);i=i;return}function nK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7464>>3]=+h[b+7368>>3]+(+h[b+7272>>3]+ +h[b+7320>>3]);i=i;return}function oK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+256>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7120>>3],+h[j+7112>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7392>>3]=l;h[e+7384>>3]=m;i=b;return}function pK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7480>>3]=+h[b+7384>>3]+(+h[b+7288>>3]+ +h[b+7336>>3]);i=i;return}function qK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7488>>3]=+h[b+7392>>3]+(+h[b+7296>>3]+ +h[b+7344>>3]);i=i;return}function rK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+256>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7120>>3],+h[j+7112>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7408>>3]=l;h[e+7400>>3]=m;i=b;return}function sK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7504>>3]=+h[b+7408>>3]+(+h[b+7312>>3]+ +h[b+7360>>3]);i=i;return}function tK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7496>>3]=+h[b+7400>>3]+(+h[b+7304>>3]+ +h[b+7352>>3]);i=i;return}function uK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+244>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7616>>3]=g;h[e+7608>>3]=j;i=b;return}function vK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+244>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7632>>3]=g;h[e+7624>>3]=j;i=b;return}function wK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+244>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7648>>3]=g;h[e+7640>>3]=j;i=b;return}function xK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+232>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7664>>3]=g;h[e+7656>>3]=j;i=b;return}function yK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+232>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7680>>3]=g;h[e+7672>>3]=j;i=b;return}function zK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+232>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7696>>3]=g;h[e+7688>>3]=j;i=b;return}function AK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+220>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7712>>3]=g;h[e+7704>>3]=j;i=b;return}function BK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8184>>3]=+h[b+7704>>3]+(+h[b+7608>>3]+ +h[b+7656>>3]);i=i;return}function CK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8192>>3]=+h[b+7712>>3]+(+h[b+7616>>3]+ +h[b+7664>>3]);i=i;return}function DK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+220>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7728>>3]=g;h[e+7720>>3]=j;i=b;return}function EK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8208>>3]=+h[b+7728>>3]+(+h[b+7632>>3]+ +h[b+7680>>3]);i=i;return}function FK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8200>>3]=+h[b+7720>>3]+(+h[b+7624>>3]+ +h[b+7672>>3]);i=i;return}function GK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+220>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7744>>3]=g;h[e+7736>>3]=j;i=b;return}function HK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8224>>3]=+h[b+7744>>3]+(+h[b+7648>>3]+ +h[b+7696>>3]);i=i;return}function IK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8216>>3]=+h[b+7736>>3]+(+h[b+7640>>3]+ +h[b+7688>>3]);i=i;return}function JK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+444>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+7560>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+7560|0;h[c[g+448>>2]>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+7560>>3]);e=c[f>>2]|0;h[c[e+452>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+444>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+7536>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+7536|0;h[(c[e+448>>2]|0)+8>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+7536>>3]);j=c[f>>2]|0;h[(c[j+452>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+444>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+7568>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+7568|0;h[(c[j+448>>2]|0)+16>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+7568>>3]);g=c[f>>2]|0;h[(c[g+452>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+444>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+7592>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+7592|0;h[(c[g+448>>2]|0)+24>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+7592>>3]);e=c[f>>2]|0;h[(c[e+452>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+444>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+7528>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+7528|0;h[(c[e+448>>2]|0)+32>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+7528>>3]);j=c[f>>2]|0;h[(c[j+452>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+444>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+7600>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+7600|0;h[(c[j+448>>2]|0)+40>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+7600>>3]);h[(c[(c[f>>2]|0)+452>>2]|0)+40>>3]=k;S5(a,5)|0;g=c[(c[f>>2]|0)+444>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+7560>>3]=+h[g>>3];h[f+7536>>3]=+h[g+8>>3];h[f+7568>>3]=+h[g+16>>3];h[f+7592>>3]=+h[g+24>>3];h[f+7528>>3]=+h[g+32>>3];h[f+7600>>3]=+h[g+40>>3];Et(a);Ft(a);Gt(a);Ht(a);It(a);Jt(a);Kt(a);Lt(a);Mt(a);Nt(a);Ot(a);Pt(a);Qt(a);Rt(a);St(a);i=b;return}function KK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7576>>3]=+h[b+9344>>3]*+h[b+7600>>3]- +h[b+9336>>3]*+h[b+7592>>3];i=i;return}function LK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7584>>3]=+h[b+9336>>3]*+h[b+7600>>3]+ +h[b+9344>>3]*+h[b+7592>>3];i=i;return}function MK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7512>>3]=+h[b+9376>>3]*+h[b+7536>>3]- +h[b+9368>>3]*+h[b+7528>>3];i=i;return}function NK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7520>>3]=+h[b+9368>>3]*+h[b+7536>>3]+ +h[b+9376>>3]*+h[b+7528>>3];i=i;return}function OK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7544>>3]=+h[b+9360>>3]*+h[b+7568>>3]- +h[b+9352>>3]*+h[b+7560>>3];i=i;return}function PK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7552>>3]=+h[b+9352>>3]*+h[b+7568>>3]+ +h[b+9360>>3]*+h[b+7560>>3];i=i;return}function QK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;b=i;i=i+40|0;d=b;e=b+16|0;f=b+32|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;c[o>>2]=3;b2(p,16,1,o);o=a+536|0;y=a+416|0;z=c[y>>2]|0;Wl(q,c[o>>2]|0,+h[z+144>>3],+h[z+152>>3]);z=q;q=c[y>>2]|0;Wl(r,c[o>>2]|0,+h[q+160>>3],+h[q+168>>3]);q=r;r=c[y>>2]|0;Wl(s,c[o>>2]|0,+h[r+176>>3],+h[r+184>>3]);r=s;c[n>>2]=1;s=c2(p,16,1,n)|0;c[s+0>>2]=c[z+0>>2];c[s+4>>2]=c[z+4>>2];c[s+8>>2]=c[z+8>>2];c[s+12>>2]=c[z+12>>2];c[m>>2]=2;z=c2(p,16,1,m)|0;c[z+0>>2]=c[q+0>>2];c[z+4>>2]=c[q+4>>2];c[z+8>>2]=c[q+8>>2];c[z+12>>2]=c[q+12>>2];c[l>>2]=3;q=c2(p,16,1,l)|0;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];c[k>>2]=3;b2(t,16,1,k);k=a+4|0;a=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Wl(u,c[o>>2]|0,+h[a+7584>>3],+h[a+7576>>3]);a=u;u=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Wl(v,c[o>>2]|0,+h[u+7552>>3],+h[u+7544>>3]);u=v;v=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Wl(w,c[o>>2]|0,+h[v+7520>>3],+h[v+7512>>3]);v=w;c[j>>2]=1;w=c2(t,16,1,j)|0;c[w+0>>2]=c[a+0>>2];c[w+4>>2]=c[a+4>>2];c[w+8>>2]=c[a+8>>2];c[w+12>>2]=c[a+12>>2];c[g>>2]=2;a=c2(t,16,1,g)|0;c[a+0>>2]=c[u+0>>2];c[a+4>>2]=c[u+4>>2];c[a+8>>2]=c[u+8>>2];c[a+12>>2]=c[u+12>>2];c[f>>2]=3;u=c2(t,16,1,f)|0;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];v=c[o>>2]|0;o=e;u=p;c[o+0>>2]=c[u+0>>2];c[o+4>>2]=c[u+4>>2];c[o+8>>2]=c[u+8>>2];u=d;o=t;c[u+0>>2]=c[o+0>>2];c[u+4>>2]=c[o+4>>2];c[u+8>>2]=c[o+8>>2];Sl(x,v,e,d);A=+h[x+8>>3];d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[d+10864>>3]=+h[x>>3];h[d+10856>>3]=A;i=b;return}function RK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9840>>3]=+h[b+10864>>3];i=i;return}function SK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9832>>3]=+h[b+10856>>3];i=i;return}function TK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+172>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7904>>3]=g;h[e+7896>>3]=j;i=b;return}function UK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+172>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7920>>3]=g;h[e+7912>>3]=j;i=b;return}function VK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+172>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7936>>3]=g;h[e+7928>>3]=j;i=b;return}function WK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+160>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7952>>3]=g;h[e+7944>>3]=j;i=b;return}function XK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+160>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7968>>3]=g;h[e+7960>>3]=j;i=b;return}function YK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+160>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7984>>3]=g;h[e+7976>>3]=j;i=b;return}function ZK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+148>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+8e3>>3]=g;h[e+7992>>3]=j;i=b;return}function _K(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8240>>3]=+h[b+8e3>>3]+(+h[b+7904>>3]+ +h[b+7952>>3]);i=i;return}function $K(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8232>>3]=+h[b+7992>>3]+(+h[b+7896>>3]+ +h[b+7944>>3]);i=i;return}function aL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+148>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+8016>>3]=g;h[e+8008>>3]=j;i=b;return}function bL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8248>>3]=+h[b+8008>>3]+(+h[b+7912>>3]+ +h[b+7960>>3]);i=i;return}function cL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8256>>3]=+h[b+8016>>3]+(+h[b+7920>>3]+ +h[b+7968>>3]);i=i;return}function dL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+148>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+8032>>3]=g;h[e+8024>>3]=j;i=b;return}function eL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8264>>3]=+h[b+8024>>3]+(+h[b+7928>>3]+ +h[b+7976>>3]);i=i;return}function fL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8272>>3]=+h[b+8032>>3]+(+h[b+7936>>3]+ +h[b+7984>>3]);i=i;return}function gL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+136>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7536>>3],+h[j+7528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8048>>3]=l;h[e+8040>>3]=m;i=b;return}function hL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+136>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7536>>3],+h[j+7528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8064>>3]=l;h[e+8056>>3]=m;i=b;return}function iL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+136>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7536>>3],+h[j+7528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8080>>3]=l;h[e+8072>>3]=m;i=b;return}function jL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+124>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7568>>3],+h[j+7560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8096>>3]=l;h[e+8088>>3]=m;i=b;return}function kL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+124>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7568>>3],+h[j+7560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8112>>3]=l;h[e+8104>>3]=m;i=b;return}function lL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+124>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7568>>3],+h[j+7560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8128>>3]=l;h[e+8120>>3]=m;i=b;return}function mL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+112>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7600>>3],+h[j+7592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8144>>3]=l;h[e+8136>>3]=m;i=b;return}function nL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8288>>3]=+h[b+8144>>3]+(+h[b+8048>>3]+ +h[b+8096>>3]);i=i;return}function oL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8960>>3]=-+h[b+8288>>3]- +h[b+8240>>3];i=i;return}function pL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8280>>3]=+h[b+8136>>3]+(+h[b+8040>>3]+ +h[b+8088>>3]);i=i;return}function qL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8952>>3]=-+h[b+8280>>3]- +h[b+8232>>3];i=i;return}function rL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+112>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7600>>3],+h[j+7592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8160>>3]=l;h[e+8152>>3]=m;i=b;return}function sL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8296>>3]=+h[b+8152>>3]+(+h[b+8056>>3]+ +h[b+8104>>3]);i=i;return}function tL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8968>>3]=-+h[b+8296>>3]- +h[b+8248>>3];i=i;return}function uL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8304>>3]=+h[b+8160>>3]+(+h[b+8064>>3]+ +h[b+8112>>3]);i=i;return}function vL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8976>>3]=-+h[b+8304>>3]- +h[b+8256>>3];i=i;return}function wL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+112>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+7600>>3],+h[j+7592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8176>>3]=l;h[e+8168>>3]=m;i=b;return}function xL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8312>>3]=+h[b+8168>>3]+(+h[b+8072>>3]+ +h[b+8120>>3]);i=i;return}function yL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8984>>3]=-+h[b+8312>>3]- +h[b+8264>>3];i=i;return}function zL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8320>>3]=+h[b+8176>>3]+(+h[b+8080>>3]+ +h[b+8128>>3]);i=i;return}function AL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8992>>3]=-+h[b+8320>>3]- +h[b+8272>>3];i=i;return}function BL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24>>3]=+h[b+9328>>3];i=i;return}function CL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+524>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+8584>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+8584|0;h[c[g+528>>2]>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+8584>>3]);e=c[f>>2]|0;h[c[e+532>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+524>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+8576>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+8576|0;h[(c[e+528>>2]|0)+8>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+8576>>3]);j=c[f>>2]|0;h[(c[j+532>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+524>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+8568>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+8568|0;h[(c[j+528>>2]|0)+16>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+8568>>3]);g=c[f>>2]|0;h[(c[g+532>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+524>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+8608>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+8608|0;h[(c[g+528>>2]|0)+24>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+8608>>3]);e=c[f>>2]|0;h[(c[e+532>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+524>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+8592>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+8592|0;h[(c[e+528>>2]|0)+32>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+8592>>3]);j=c[f>>2]|0;h[(c[j+532>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+524>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+8600>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+8600|0;h[(c[j+528>>2]|0)+40>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+8600>>3]);h[(c[(c[f>>2]|0)+532>>2]|0)+40>>3]=k;S5(a,6)|0;g=c[(c[f>>2]|0)+524>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+8584>>3]=+h[g>>3];h[f+8576>>3]=+h[g+8>>3];h[f+8568>>3]=+h[g+16>>3];h[f+8608>>3]=+h[g+24>>3];h[f+8592>>3]=+h[g+32>>3];h[f+8600>>3]=+h[g+40>>3];Vt(a);Wt(a);Xt(a);Yt(a);Zt(a);_t(a);$t(a);au(a);bu(a);cu(a);du(a);eu(a);fu(a);gu(a);hu(a);i=b;return}function DL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+40>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8608>>3],-+h[j+8600>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8752>>3]=l;h[e+8744>>3]=m;i=b;return}function EL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+40>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8608>>3],-+h[j+8600>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8736>>3]=l;h[e+8728>>3]=m;i=b;return}function FL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+40>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8608>>3],-+h[j+8600>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8720>>3]=l;h[e+8712>>3]=m;i=b;return}function GL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+64>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8576>>3],-+h[j+8568>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8656>>3]=l;h[e+8648>>3]=m;i=b;return}function HL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+64>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8576>>3],-+h[j+8568>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8640>>3]=l;h[e+8632>>3]=m;i=b;return}function IL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+64>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8576>>3],-+h[j+8568>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8624>>3]=l;h[e+8616>>3]=m;i=b;return}function JL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+52>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8592>>3],-+h[j+8584>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8704>>3]=l;h[e+8696>>3]=m;i=b;return}function KL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8944>>3]=+h[b+8752>>3]+(+h[b+8656>>3]+ +h[b+8704>>3]);i=i;return}function LL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8560>>3]=-+h[b+8944>>3]- +h[b+8224>>3];i=i;return}function ML(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8936>>3]=+h[b+8744>>3]+(+h[b+8648>>3]+ +h[b+8696>>3]);i=i;return}function NL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8552>>3]=-+h[b+8936>>3]- +h[b+8216>>3];i=i;return}function OL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+52>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8592>>3],-+h[j+8584>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8688>>3]=l;h[e+8680>>3]=m;i=b;return}function PL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8928>>3]=+h[b+8736>>3]+(+h[b+8640>>3]+ +h[b+8688>>3]);i=i;return}function QL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8544>>3]=-+h[b+8928>>3]- +h[b+8208>>3];i=i;return}function RL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8920>>3]=+h[b+8728>>3]+(+h[b+8632>>3]+ +h[b+8680>>3]);i=i;return}function SL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8536>>3]=-+h[b+8920>>3]- +h[b+8200>>3];i=i;return}function TL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+52>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8592>>3],-+h[j+8584>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8672>>3]=l;h[e+8664>>3]=m;i=b;return}function UL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8912>>3]=+h[b+8720>>3]+(+h[b+8624>>3]+ +h[b+8672>>3]);i=i;return}function VL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8528>>3]=-+h[b+8912>>3]- +h[b+8192>>3];i=i;return}function WL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8904>>3]=+h[b+8712>>3]+(+h[b+8616>>3]+ +h[b+8664>>3]);i=i;return}function XL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8520>>3]=-+h[b+8904>>3]- +h[b+8184>>3];i=i;return}function YL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+604>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+8512>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+8512|0;h[c[g+608>>2]>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+8512>>3]);e=c[f>>2]|0;h[c[e+612>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+604>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+8504>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+8504|0;h[(c[e+608>>2]|0)+8>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+8504>>3]);j=c[f>>2]|0;h[(c[j+612>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+604>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+8480>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+8480|0;h[(c[j+608>>2]|0)+16>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+8480>>3]);g=c[f>>2]|0;h[(c[g+612>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+604>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+8472>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+8472|0;h[(c[g+608>>2]|0)+24>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+8472>>3]);e=c[f>>2]|0;h[(c[e+612>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+604>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+8496>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+8496|0;h[(c[e+608>>2]|0)+32>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+8496>>3]);j=c[f>>2]|0;h[(c[j+612>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+604>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+8488>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+8488|0;h[(c[j+608>>2]|0)+40>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+8488>>3]);h[(c[(c[f>>2]|0)+612>>2]|0)+40>>3]=k;S5(a,7)|0;g=c[(c[f>>2]|0)+604>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+8512>>3]=+h[g>>3];h[f+8504>>3]=+h[g+8>>3];h[f+8480>>3]=+h[g+16>>3];h[f+8472>>3]=+h[g+24>>3];h[f+8496>>3]=+h[g+32>>3];h[f+8488>>3]=+h[g+40>>3];ku(a);lu(a);mu(a);nu(a);ou(a);pu(a);qu(a);ru(a);su(a);tu(a);uu(a);vu(a);wu(a);xu(a);yu(a);i=b;return}function ZL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9856>>3]=-+h[b+8496>>3]- +h[b+8480>>3]- +h[b+8512>>3];i=i;return}function _L(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9848>>3]=-+h[b+8488>>3]- +h[b+8472>>3]- +h[b+8504>>3];i=i;return}function $L(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9728>>3]=-+h[b+1088>>3]- +h[b+1048>>3]- +h[b+1008>>3];i=i;return}function aM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9736>>3]=-+h[b+2168>>3]- +h[b+2128>>3]- +h[b+2088>>3];i=i;return}function bM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9720>>3]=+h[b+9736>>3]+ +h[b+9728>>3];i=i;return}function cM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9744>>3]=-(+h[b+2624>>3]*+h[b+2576>>3])- +h[b+2592>>3]*+h[b+2544>>3]- +h[b+2608>>3]*+h[b+2560>>3]- +h[b+2600>>3]*+h[b+2552>>3]- +h[b+2616>>3]*+h[b+2568>>3]- +h[b+2632>>3]*+h[b+2584>>3];i=i;return}function dM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9752>>3]=+h[b+9336>>3]*+h[b+2680>>3]+(+h[b+9352>>3]*+h[b+2664>>3]+(+h[b+9368>>3]*+h[b+2648>>3]+(+h[b+9360>>3]*+h[b+2656>>3]+(+h[b+9344>>3]*+h[b+2672>>3]+ +h[b+9376>>3]*+h[b+2640>>3]))));i=i;return}function eM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9760>>3]=+h[b+9776>>3]+ +h[b+9768>>3];i=i;return}function fM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+688>>3]=+h[b+1136>>3];i=i;return}function gM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+832>>3]=+h[b+688>>3];i=i;return}function hM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+680>>3]=+h[b+1136>>3];i=i;return}function iM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+800>>3]=+h[b+680>>3];i=i;return}function jM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+672>>3]=+h[b+1136>>3];i=i;return}function kM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+768>>3]=+h[b+672>>3];i=i;return}function lM(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+1868>>2]=c[b+1840>>2];i=i;return}function mM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+448>>3]=+h[b+1104>>3];i=i;return}function nM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+592>>3]=+h[b+448>>3];i=i;return}function oM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+440>>3]=+h[b+1104>>3];i=i;return}function pM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+560>>3]=+h[b+440>>3];i=i;return}function qM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+432>>3]=+h[b+1104>>3];i=i;return}function rM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+528>>3]=+h[b+432>>3];i=i;return}function sM(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+1808>>2]=c[b+1780>>2];i=i;return}function tM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1192>>3]=+h[b+1168>>3];i=i;return}function uM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+944>>3]=+h[b+928>>3];i=i;return}function vM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9904>>3]=+h[b+920>>3]*(+h[b+936>>3]*(+h[b+944>>3]- +h[b+928>>3])+1.0);i=i;return}function wM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+120>>3]=+h[b+912>>3];i=i;return}function xM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9056>>3]=+h[(c[a+416>>2]|0)+120>>3]*6.283185307179586;i=i;return}function yM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+32>>3]=+h[b+9056>>3];i=i;return}function zM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+96>>3]=+h[b+912>>3];i=i;return}function AM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9048>>3]=+h[(c[a+416>>2]|0)+96>>3]*6.283185307179586;i=i;return}function BM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+40>>3]=+h[b+9048>>3];i=i;return}function CM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1e4>>3]=0.0;i=i;return}function DM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9992>>3]=0.0;i=i;return}function EM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9984>>3]=0.0;i=i;return}function FM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9976>>3]=0.0;i=i;return}function GM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9968>>3]=0.0;i=i;return}function HM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9960>>3]=0.0;i=i;return}function IM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9952>>3]=0.0;i=i;return}function JM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9712>>3]=0.0;i=i;return}function KM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9704>>3]=0.0;i=i;return}function LM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9696>>3]=0.0;i=i;return}function MM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9688>>3]=0.0;i=i;return}function NM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9680>>3]=0.0;i=i;return}function OM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9672>>3]=0.0;i=i;return}function PM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9664>>3]=0.0;i=i;return}function QM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9656>>3]=0.0;i=i;return}function RM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9648>>3]=0.0;i=i;return}function SM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9640>>3]=0.0;i=i;return}function TM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9632>>3]=0.0;i=i;return}function UM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9624>>3]=0.0;i=i;return}function VM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9616>>3]=0.0;i=i;return}function WM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9608>>3]=0.0;i=i;return}function XM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9600>>3]=0.0;i=i;return}function YM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9592>>3]=0.0;i=i;return}function ZM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9584>>3]=0.0;i=i;return}function _M(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9576>>3]=0.0;i=i;return}function $M(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9568>>3]=0.0;i=i;return}function aN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9560>>3]=0.0;i=i;return}function bN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9552>>3]=0.0;i=i;return}function cN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9544>>3]=0.0;i=i;return}function dN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9536>>3]=0.0;i=i;return}function eN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9528>>3]=0.0;i=i;return}function fN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9520>>3]=0.0;i=i;return}function gN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9512>>3]=0.0;i=i;return}function hN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9504>>3]=0.0;i=i;return}function iN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9496>>3]=0.0;i=i;return}function jN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9488>>3]=0.0;i=i;return}function kN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9480>>3]=0.0;i=i;return}function lN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9472>>3]=0.0;i=i;return}function mN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9464>>3]=0.0;i=i;return}function nN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9456>>3]=0.0;i=i;return}function oN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9448>>3]=0.0;i=i;return}function pN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9440>>3]=0.0;i=i;return}function qN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9432>>3]=0.0;i=i;return}function rN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9424>>3]=0.0;i=i;return}function sN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9416>>3]=0.0;i=i;return}function tN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9408>>3]=0.0;i=i;return}function uN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9400>>3]=0.0;i=i;return}function vN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9392>>3]=0.0;i=i;return}function wN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9384>>3]=0.0;i=i;return}function xN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9944>>3]=0.0;i=i;return}function yN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9248>>3]=0.0;i=i;return}function zN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9240>>3]=0.0;i=i;return}function AN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9232>>3]=0.0;i=i;return}function BN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9224>>3]=0.0;i=i;return}function CN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9216>>3]=0.0;i=i;return}function DN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9208>>3]=0.0;i=i;return}function EN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9104>>3]=0.0;i=i;return}function FN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9096>>3]=0.0;i=i;return}function GN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9088>>3]=0.0;i=i;return}function HN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9080>>3]=0.0;i=i;return}



function Be(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function Ce(){return i|0}function De(a){a=a|0;i=a}function Ee(a,b){a=a|0;b=b|0;if((u|0)==0){u=a;v=b}}function Fe(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function Ge(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function He(a){a=a|0;J=a}function Ie(a){a=a|0;K=a}function Je(a){a=a|0;L=a}function Ke(a){a=a|0;M=a}function Le(a){a=a|0;N=a}function Me(a){a=a|0;O=a}function Ne(a){a=a|0;P=a}function Oe(a){a=a|0;Q=a}function Pe(a){a=a|0;R=a}function Qe(a){a=a|0;S=a}function Re(a){a=a|0;var b=0,d=0;b=i;A6(a)|0;d=a+540|0;ae[c[(c[d>>2]|0)+40>>2]&127](a)|0;ae[c[(c[d>>2]|0)+28>>2]&127](a)|0;ae[c[(c[d>>2]|0)+32>>2]&127](a)|0;ae[c[(c[d>>2]|0)+48>>2]&127](a)|0;ae[c[(c[d>>2]|0)+52>>2]&127](a)|0;k5(a);i=b;return}function Se(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+24|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[v>>2]=0;y=b+240|0;z=d;h[z>>3]=+h[y>>3];if((c[2]|0)==0){A=0}else{B=c[b+88>>2]|0;C=lxa(B|0)|0;D=Jwa(C+11|0)|0;wxa(D|0,B|0,C|0)|0;B=D+C+0|0;C=16|0;E=B+11|0;do{a[B]=a[C]|0;B=B+1|0;C=C+1|0}while((B|0)<(E|0));C=ic(D|0,32)|0;if((C|0)==0){B=Od(c[(Mc()|0)>>2]|0)|0;c[u>>2]=D;c[u+4>>2]=B;X1(23,0,40,u);Wc(0)|0;F=0}else{F=C}Kwa(D);A=F}F=b+248|0;D=b+536|0;C=b;u=b+4|0;B=d+36|0;E=d+16|0;G=b+256|0;H=d+8|0;I=d+24|0;J=d+32|0;K=b+540|0;L=d+48|0;M=c[t>>2]|0;N=v;O=w;P=b+64|0;Q=b+72|0;R=x;S=0;T=A;while(1){if(!(+h[z>>3]<+h[F>>3])){U=T;V=0;break}ue[c[72196>>2]&7]()|0;c[(c[D>>2]|0)+84>>2]=1;if((c[2]|0)!=0){if(((c[Q>>2]|0)+(c[P>>2]|0)|0)>0){A=0;do{I3(A+9|0);A=A+1|0;}while((A|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0))}I3(2);H3(2)}w3(c[C>>2]|0,1,c[u>>2]|0);if((c[B>>2]|0)==1){A=s;h[k>>3]=+h[z>>3]- +h[E>>3];c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];V1(23,0,104,s);W=S}else{W=S+1|0}X=+h[y>>3];h[H>>3]=X+ +(W>>>0)*(+h[F>>3]-X)/+(c[G>>2]|0)- +h[z>>3];Z4(b,d);X=+h[z>>3];Y=+h[H>>3];A=r;h[k>>3]=X;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+8|0;h[k>>3]=X+Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+16|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];V1(23,1,144,r);Z=i6(b,d)|0;if((c[I>>2]|0)==5){U=T;V=0;break}Re(b);l5(b);if((c[70980>>2]|0)!=0){Zd[c[17860]&1023](23)}if((c[2]|0)!=0){H3(4)}A=$4(b,c[J>>2]|0,z,d)|0;if((A|0)>0){c[(c[D>>2]|0)+84>>2]=4;Y=+h[z>>3];c[q>>2]=(A|0)==1?224:232;A=q+4|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];V1(7,1,200,q);if((c[128084>>2]|0)==0){_d[c[112772>>2]&127](112752,b)}b5(b,c[J>>2]|0,z,d);if((c[70916>>2]|0)!=0){Zd[c[17860]&1023](7)}c[(c[D>>2]|0)+84>>2]=1;c[B>>2]=1;p5(b)}else{h[E>>3]=+h[z>>3];c[B>>2]=0}if((c[2]|0)!=0){K3(4)}if((u6(b,1,1)|0)!=0){c[B>>2]=1;p5(b)}ae[c[(c[K>>2]|0)+88>>2]&127](b)|0;k5(b);t5(b);l5(b);do{if((T|0)==0){_=0}else{H3(7);K3(2);A=(qc(N|0,4,1,T|0)|0)==1;c[v>>2]=(c[v>>2]|0)+1;do{if(A){$=(qc(c[c[u>>2]>>2]|0,8,1,T|0)|0)==1;h[w>>3]=+C3(2);if(!$){aa=0;break}aa=(qc(O|0,8,1,T|0)|0)==1|0}else{h[w>>3]=+C3(2);aa=0}}while(0);A=c[P>>2]|0;$=c[Q>>2]|0;if(($+A|0)>0){ba=aa;ca=0;while(1){c[x>>2]=x3(ca+9|0)|0;if((ba|0)==0){da=0}else{da=(qc(R|0,4,1,T|0)|0)==1|0}ea=ca+1|0;fa=c[P>>2]|0;ga=c[Q>>2]|0;if((ea|0)<(ga+fa|0)){ba=da;ca=ea}else{ha=ga;ia=fa;ja=da;break}}}else{ha=$;ia=A;ja=aa}if((ha+ia|0)>0){ca=ja;ba=0;while(1){h[w>>3]=+C3(ba+9|0);if((ca|0)==0){ka=0}else{ka=(qc(O|0,8,1,T|0)|0)==1|0}fa=ba+1|0;if((fa|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0)){ca=ka;ba=fa}else{la=ka;break}}}else{la=ja}K3(7);if((la|0)!=0){_=T;break}c[p>>2]=Od(c[(Mc()|0)>>2]|0)|0;X1(23,0,240,p);Wc(T|0)|0;_=0}}while(0);if((c[128084>>2]|0)==0){ma=47}else{ba=c[B>>2]|0;if((ba|0)==0){ma=47}else{na=ba}}if((ma|0)==47){ma=0;_d[c[112772>>2]&127](112752,b);na=c[B>>2]|0}do{if((na|0)==1){if((c[I>>2]|0)!=3){break}ba=c[L>>2]|0;ca=c[ba+8>>2]|0;A=c[ba+4>>2]|0;c[A>>2]=(c[A>>2]|0)+(c[ca>>2]|0);ba=A+4|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+4>>2]|0);ba=A+8|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+8>>2]|0);ba=A+12|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+12>>2]|0);ba=A+16|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+16>>2]|0)}}while(0);if((c[29588]|0)!=0){ca=f;ba=118360;c[ca+0>>2]=c[ba+0>>2];c[ca+4>>2]=c[ba+4>>2];c[ca+8>>2]=c[ba+8>>2];c[ca+12>>2]=c[ba+12>>2];c[ca+16>>2]=c[ba+16>>2];c[ca+20>>2]=c[ba+20>>2];N1(M,f);Kd(10,M|0)|0;ba=c[29596]|0;ca=o;h[k>>3]=+h[c[c[u>>2]>>2]>>3];c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];c[o+8>>2]=ba;V1(1,0,320,o);h[F>>3]=+h[z>>3]}if((Z|0)!=0){ma=57;break}if((T5(b,0)|0)!=0){ma=58;break}if((L5(b,0)|0)!=0){ma=58;break}if((B5(b,0)|0)==0){S=W;T=_}else{ma=58;break}}do{if((ma|0)==57){T=n;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];V1(1,0,376,n);U=_;V=Z+ -1|0}else if((ma|0)==58){if((T5(b,0)|0)!=0){T=m;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];V1(1,0,448,m);U=_;V=-2;break}if((L5(b,0)|0)!=0){T=l;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];V1(1,0,536,l);U=_;V=-3;break}T=(B5(b,0)|0)==0;Y=+h[z>>3];if(T){T=g;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];V1(1,0,712,g);U=_;V=-1;break}else{T=j;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];V1(1,0,624,j);U=_;V=-3;break}}}while(0);if((U|0)==0){i=e;return V|0}Wc(U|0)|0;i=e;return V|0}function Te(a){a=a|0;i=i;return 0}function Ue(a){a=a|0;i=i;return 0}function Ve(a){a=a|0;i=i;return 0}function We(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24>>3]=+h[b+9328>>3];i=i;return}function Xe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+148>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+8032>>3]=g;h[e+8024>>3]=j;i=b;return}function Ye(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+148>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+8016>>3]=g;h[e+8008>>3]=j;i=b;return}function Ze(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+148>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+8e3>>3]=g;h[e+7992>>3]=j;i=b;return}function _e(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+160>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7984>>3]=g;h[e+7976>>3]=j;i=b;return}function $e(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+160>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7968>>3]=g;h[e+7960>>3]=j;i=b;return}function af(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+160>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7952>>3]=g;h[e+7944>>3]=j;i=b;return}function bf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+172>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7936>>3]=g;h[e+7928>>3]=j;i=b;return}function cf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8272>>3]=+h[b+8032>>3]+(+h[b+7936>>3]+ +h[b+7984>>3]);i=i;return}function df(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8264>>3]=+h[b+8024>>3]+(+h[b+7928>>3]+ +h[b+7976>>3]);i=i;return}function ef(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+172>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7920>>3]=g;h[e+7912>>3]=j;i=b;return}function ff(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8248>>3]=+h[b+8008>>3]+(+h[b+7912>>3]+ +h[b+7960>>3]);i=i;return}function gf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8256>>3]=+h[b+8016>>3]+(+h[b+7920>>3]+ +h[b+7968>>3]);i=i;return}function hf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+172>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7904>>3]=g;h[e+7896>>3]=j;i=b;return}function jf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8232>>3]=+h[b+7992>>3]+(+h[b+7896>>3]+ +h[b+7944>>3]);i=i;return}function kf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8240>>3]=+h[b+8e3>>3]+(+h[b+7904>>3]+ +h[b+7952>>3]);i=i;return}function lf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+220>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7744>>3]=g;h[e+7736>>3]=j;i=b;return}function mf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+220>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7728>>3]=g;h[e+7720>>3]=j;i=b;return}function nf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+220>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7712>>3]=g;h[e+7704>>3]=j;i=b;return}function of(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+232>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7696>>3]=g;h[e+7688>>3]=j;i=b;return}function pf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+232>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7680>>3]=g;h[e+7672>>3]=j;i=b;return}function qf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+232>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7664>>3]=g;h[e+7656>>3]=j;i=b;return}function rf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+244>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7648>>3]=g;h[e+7640>>3]=j;i=b;return}function sf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8216>>3]=+h[b+7736>>3]+(+h[b+7640>>3]+ +h[b+7688>>3]);i=i;return}function tf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8224>>3]=+h[b+7744>>3]+(+h[b+7648>>3]+ +h[b+7696>>3]);i=i;return}function uf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+244>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7632>>3]=g;h[e+7624>>3]=j;i=b;return}function vf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8200>>3]=+h[b+7720>>3]+(+h[b+7624>>3]+ +h[b+7672>>3]);i=i;return}function wf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8208>>3]=+h[b+7728>>3]+(+h[b+7632>>3]+ +h[b+7680>>3]);i=i;return}function xf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+244>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+7616>>3]=g;h[e+7608>>3]=j;i=b;return}function yf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8192>>3]=+h[b+7712>>3]+(+h[b+7616>>3]+ +h[b+7664>>3]);i=i;return}function zf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8184>>3]=+h[b+7704>>3]+(+h[b+7608>>3]+ +h[b+7656>>3]);i=i;return}function Af(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+328>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6976>>3]=g;h[e+6968>>3]=j;i=b;return}function Bf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+328>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6960>>3]=g;h[e+6952>>3]=j;i=b;return}function Cf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+328>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6944>>3]=g;h[e+6936>>3]=j;i=b;return}function Df(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+340>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6928>>3]=g;h[e+6920>>3]=j;i=b;return}function Ef(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+340>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6912>>3]=g;h[e+6904>>3]=j;i=b;return}function Ff(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+340>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6896>>3]=g;h[e+6888>>3]=j;i=b;return}function Gf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+352>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6880>>3]=g;h[e+6872>>3]=j;i=b;return}function Hf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7016>>3]=+h[b+6968>>3]+(+h[b+6872>>3]+ +h[b+6920>>3]);i=i;return}function If(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7024>>3]=+h[b+6976>>3]+(+h[b+6880>>3]+ +h[b+6928>>3]);i=i;return}function Jf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+352>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6864>>3]=g;h[e+6856>>3]=j;i=b;return}function Kf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7008>>3]=+h[b+6960>>3]+(+h[b+6864>>3]+ +h[b+6912>>3]);i=i;return}function Lf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7e3>>3]=+h[b+6952>>3]+(+h[b+6856>>3]+ +h[b+6904>>3]);i=i;return}function Mf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+352>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6848>>3]=g;h[e+6840>>3]=j;i=b;return}function Nf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6992>>3]=+h[b+6944>>3]+(+h[b+6848>>3]+ +h[b+6896>>3]);i=i;return}function Of(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6984>>3]=+h[b+6936>>3]+(+h[b+6840>>3]+ +h[b+6888>>3]);i=i;return}function Pf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+364>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6832>>3]=g;h[e+6824>>3]=j;i=b;return}function Qf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+364>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6816>>3]=g;h[e+6808>>3]=j;i=b;return}function Rf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+364>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6800>>3]=g;h[e+6792>>3]=j;i=b;return}function Sf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+376>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6784>>3]=g;h[e+6776>>3]=j;i=b;return}function Tf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+376>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6768>>3]=g;h[e+6760>>3]=j;i=b;return}function Uf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+376>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6752>>3]=g;h[e+6744>>3]=j;i=b;return}function Vf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+388>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6736>>3]=g;h[e+6728>>3]=j;i=b;return}function Wf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6680>>3]=-+h[b+6776>>3]- +h[b+6728>>3]- +h[b+6824>>3];i=i;return}function Xf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6688>>3]=-+h[b+6784>>3]- +h[b+6736>>3]- +h[b+6832>>3];i=i;return}function Yf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+388>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6720>>3]=g;h[e+6712>>3]=j;i=b;return}function Zf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6664>>3]=-+h[b+6760>>3]- +h[b+6712>>3]- +h[b+6808>>3];i=i;return}function _f(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6672>>3]=-+h[b+6768>>3]- +h[b+6720>>3]- +h[b+6816>>3];i=i;return}function $f(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+388>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6704>>3]=g;h[e+6696>>3]=j;i=b;return}function ag(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6648>>3]=-+h[b+6744>>3]- +h[b+6696>>3]- +h[b+6792>>3];i=i;return}function bg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6656>>3]=-+h[b+6752>>3]- +h[b+6704>>3]- +h[b+6800>>3];i=i;return}function cg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+684>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+6408>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+6408|0;h[c[g+688>>2]>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+6408>>3]);e=c[f>>2]|0;h[c[e+692>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+684>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+6448>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+6448|0;h[(c[e+688>>2]|0)+8>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+6448>>3]);j=c[f>>2]|0;h[(c[j+692>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+684>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+6432>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+6432|0;h[(c[j+688>>2]|0)+16>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+6432>>3]);g=c[f>>2]|0;h[(c[g+692>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+684>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+6424>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+6424|0;h[(c[g+688>>2]|0)+24>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+6424>>3]);e=c[f>>2]|0;h[(c[e+692>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+684>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+6416>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+6416|0;h[(c[e+688>>2]|0)+32>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+6416>>3]);j=c[f>>2]|0;h[(c[j+692>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+684>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+6440>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+6440|0;h[(c[j+688>>2]|0)+40>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+6440>>3]);h[(c[(c[f>>2]|0)+692>>2]|0)+40>>3]=k;S5(a,8)|0;g=c[(c[f>>2]|0)+684>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+6408>>3]=+h[g>>3];h[f+6448>>3]=+h[g+8>>3];h[f+6432>>3]=+h[g+16>>3];h[f+6424>>3]=+h[g+24>>3];h[f+6416>>3]=+h[g+32>>3];h[f+6440>>3]=+h[g+40>>3];Bu(a);Cu(a);Du(a);Eu(a);Fu(a);Gu(a);Hu(a);Iu(a);Ju(a);Ku(a);Lu(a);Mu(a);Nu(a);Ou(a);Pu(a);i=b;return}function dg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+448>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+6432>>3],-+h[j+6424>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6352>>3]=l;h[e+6344>>3]=m;i=b;return}function eg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+448>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+6432>>3],-+h[j+6424>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6336>>3]=l;h[e+6328>>3]=m;i=b;return}function fg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+448>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+6432>>3],-+h[j+6424>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6320>>3]=l;h[e+6312>>3]=m;i=b;return}function gg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+460>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+6416>>3],-+h[j+6408>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6304>>3]=l;h[e+6296>>3]=m;i=b;return}function hg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+460>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+6416>>3],-+h[j+6408>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6288>>3]=l;h[e+6280>>3]=m;i=b;return}function ig(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+460>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+6416>>3],-+h[j+6408>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6272>>3]=l;h[e+6264>>3]=m;i=b;return}function jg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+436>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+6448>>3],-+h[j+6440>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6400>>3]=l;h[e+6392>>3]=m;i=b;return}function kg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6632>>3]=+h[b+6392>>3]+(+h[b+6296>>3]+ +h[b+6344>>3]);i=i;return}function lg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6640>>3]=+h[b+6400>>3]+(+h[b+6304>>3]+ +h[b+6352>>3]);i=i;return}function mg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+436>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+6448>>3],-+h[j+6440>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6384>>3]=l;h[e+6376>>3]=m;i=b;return}function ng(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6624>>3]=+h[b+6384>>3]+(+h[b+6288>>3]+ +h[b+6336>>3]);i=i;return}function og(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6616>>3]=+h[b+6376>>3]+(+h[b+6280>>3]+ +h[b+6328>>3]);i=i;return}function pg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+436>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+6448>>3],-+h[j+6440>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6368>>3]=l;h[e+6360>>3]=m;i=b;return}function qg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6600>>3]=+h[b+6360>>3]+(+h[b+6264>>3]+ +h[b+6312>>3]);i=i;return}function rg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6608>>3]=+h[b+6368>>3]+(+h[b+6272>>3]+ +h[b+6320>>3]);i=i;return}function sg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+472>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6160>>3]=g;h[e+6152>>3]=j;i=b;return}function tg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+472>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6144>>3]=g;h[e+6136>>3]=j;i=b;return}function ug(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+472>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6128>>3]=g;h[e+6120>>3]=j;i=b;return}function vg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+484>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6112>>3]=g;h[e+6104>>3]=j;i=b;return}function wg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+484>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6096>>3]=g;h[e+6088>>3]=j;i=b;return}function xg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+484>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6080>>3]=g;h[e+6072>>3]=j;i=b;return}function yg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+496>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6064>>3]=g;h[e+6056>>3]=j;i=b;return}function zg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6208>>3]=+h[b+6160>>3]+(+h[b+6064>>3]+ +h[b+6112>>3]);i=i;return}function Ag(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6200>>3]=+h[b+6152>>3]+(+h[b+6056>>3]+ +h[b+6104>>3]);i=i;return}function Bg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+496>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6048>>3]=g;h[e+6040>>3]=j;i=b;return}function Cg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6192>>3]=+h[b+6144>>3]+(+h[b+6048>>3]+ +h[b+6096>>3]);i=i;return}function Dg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6184>>3]=+h[b+6136>>3]+(+h[b+6040>>3]+ +h[b+6088>>3]);i=i;return}function Eg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+496>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6032>>3]=g;h[e+6024>>3]=j;i=b;return}function Fg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6176>>3]=+h[b+6128>>3]+(+h[b+6032>>3]+ +h[b+6080>>3]);i=i;return}function Gg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6168>>3]=+h[b+6120>>3]+(+h[b+6024>>3]+ +h[b+6072>>3]);i=i;return}function Hg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+508>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6016>>3]=g;h[e+6008>>3]=j;i=b;return}function Ig(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+508>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6e3>>3]=g;h[e+5992>>3]=j;i=b;return}function Jg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+508>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+5984>>3]=g;h[e+5976>>3]=j;i=b;return}function Kg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+520>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+5968>>3]=g;h[e+5960>>3]=j;i=b;return}function Lg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+520>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+5952>>3]=g;h[e+5944>>3]=j;i=b;return}function Mg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+520>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+5936>>3]=g;h[e+5928>>3]=j;i=b;return}function Ng(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+532>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+5920>>3]=g;h[e+5912>>3]=j;i=b;return}function Og(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5768>>3]=-+h[b+5960>>3]- +h[b+5912>>3]- +h[b+6008>>3];i=i;return}function Pg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5776>>3]=-+h[b+5968>>3]- +h[b+5920>>3]- +h[b+6016>>3];i=i;return}function Qg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+532>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+5904>>3]=g;h[e+5896>>3]=j;i=b;return}function Rg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5760>>3]=-+h[b+5952>>3]- +h[b+5904>>3]- +h[b+6e3>>3];i=i;return}function Sg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5752>>3]=-+h[b+5944>>3]- +h[b+5896>>3]- +h[b+5992>>3];i=i;return}function Tg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+532>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+5888>>3]=g;h[e+5880>>3]=j;i=b;return}function Ug(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5744>>3]=-+h[b+5936>>3]- +h[b+5888>>3]- +h[b+5984>>3];i=i;return}function Vg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5736>>3]=-+h[b+5928>>3]- +h[b+5880>>3]- +h[b+5976>>3];i=i;return}function Wg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+764>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+5504>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+5504|0;h[c[g+768>>2]>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+5504>>3]);e=c[f>>2]|0;h[c[e+772>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+764>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+5528>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+5528|0;h[(c[e+768>>2]|0)+8>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+5528>>3]);j=c[f>>2]|0;h[(c[j+772>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+764>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+5520>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+5520|0;h[(c[j+768>>2]|0)+16>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+5520>>3]);g=c[f>>2]|0;h[(c[g+772>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+764>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+5496>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+5496|0;h[(c[g+768>>2]|0)+24>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+5496>>3]);e=c[f>>2]|0;h[(c[e+772>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+764>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+5512>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+5512|0;h[(c[e+768>>2]|0)+32>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+5512>>3]);j=c[f>>2]|0;h[(c[j+772>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+764>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+5536>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+5536|0;h[(c[j+768>>2]|0)+40>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+5536>>3]);h[(c[(c[f>>2]|0)+772>>2]|0)+40>>3]=k;S5(a,9)|0;g=c[(c[f>>2]|0)+764>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+5504>>3]=+h[g>>3];h[f+5528>>3]=+h[g+8>>3];h[f+5520>>3]=+h[g+16>>3];h[f+5496>>3]=+h[g+24>>3];h[f+5512>>3]=+h[g+32>>3];h[f+5536>>3]=+h[g+40>>3];Su(a);Tu(a);Uu(a);Vu(a);Wu(a);Xu(a);Yu(a);Zu(a);_u(a);$u(a);av(a);bv(a);cv(a);dv(a);ev(a);i=b;return}function Xg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+604>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+5504>>3],-+h[j+5496>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5392>>3]=l;h[e+5384>>3]=m;i=b;return}function Yg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+604>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+5504>>3],-+h[j+5496>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5376>>3]=l;h[e+5368>>3]=m;i=b;return}function Zg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+604>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+5504>>3],-+h[j+5496>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5360>>3]=l;h[e+5352>>3]=m;i=b;return}function _g(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+592>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+5520>>3],-+h[j+5512>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5440>>3]=l;h[e+5432>>3]=m;i=b;return}function $g(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+592>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+5520>>3],-+h[j+5512>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5424>>3]=l;h[e+5416>>3]=m;i=b;return}function ah(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+592>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+5520>>3],-+h[j+5512>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5408>>3]=l;h[e+5400>>3]=m;i=b;return}function bh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+580>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+5536>>3],-+h[j+5528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5488>>3]=l;h[e+5480>>3]=m;i=b;return}function ch(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5728>>3]=+h[b+5488>>3]+(+h[b+5392>>3]+ +h[b+5440>>3]);i=i;return}function dh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5720>>3]=+h[b+5480>>3]+(+h[b+5384>>3]+ +h[b+5432>>3]);i=i;return}function eh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+580>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+5536>>3],-+h[j+5528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5472>>3]=l;h[e+5464>>3]=m;i=b;return}function fh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5704>>3]=+h[b+5464>>3]+(+h[b+5368>>3]+ +h[b+5416>>3]);i=i;return}function gh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5712>>3]=+h[b+5472>>3]+(+h[b+5376>>3]+ +h[b+5424>>3]);i=i;return}function hh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+580>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+5536>>3],-+h[j+5528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5456>>3]=l;h[e+5448>>3]=m;i=b;return}function ih(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5696>>3]=+h[b+5456>>3]+(+h[b+5360>>3]+ +h[b+5408>>3]);i=i;return}function jh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5688>>3]=+h[b+5448>>3]+(+h[b+5352>>3]+ +h[b+5400>>3]);i=i;return}function kh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+724>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4576>>3]=g;h[e+4568>>3]=j;i=b;return}function lh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+724>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4560>>3]=g;h[e+4552>>3]=j;i=b;return}function mh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+724>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4544>>3]=g;h[e+4536>>3]=j;i=b;return}function nh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+736>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4528>>3]=g;h[e+4520>>3]=j;i=b;return}function oh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+736>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4512>>3]=g;h[e+4504>>3]=j;i=b;return}function ph(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+736>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4496>>3]=g;h[e+4488>>3]=j;i=b;return}function qh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+748>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4480>>3]=g;h[e+4472>>3]=j;i=b;return}function rh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4816>>3]=+h[b+4576>>3]+(+h[b+4480>>3]+ +h[b+4528>>3]);i=i;return}function sh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4808>>3]=+h[b+4568>>3]+(+h[b+4472>>3]+ +h[b+4520>>3]);i=i;return}function th(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+748>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4464>>3]=g;h[e+4456>>3]=j;i=b;return}function uh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4792>>3]=+h[b+4552>>3]+(+h[b+4456>>3]+ +h[b+4504>>3]);i=i;return}function vh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4800>>3]=+h[b+4560>>3]+(+h[b+4464>>3]+ +h[b+4512>>3]);i=i;return}function wh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+748>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4448>>3]=g;h[e+4440>>3]=j;i=b;return}function xh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4784>>3]=+h[b+4544>>3]+(+h[b+4448>>3]+ +h[b+4496>>3]);i=i;return}function yh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4776>>3]=+h[b+4536>>3]+(+h[b+4440>>3]+ +h[b+4488>>3]);i=i;return}function zh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+796>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4288>>3]=g;h[e+4280>>3]=j;i=b;return}function Ah(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+796>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4272>>3]=g;h[e+4264>>3]=j;i=b;return}function Bh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+796>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4256>>3]=g;h[e+4248>>3]=j;i=b;return}function Ch(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+808>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4240>>3]=g;h[e+4232>>3]=j;i=b;return}function Dh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+808>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4224>>3]=g;h[e+4216>>3]=j;i=b;return}function Eh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+808>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4208>>3]=g;h[e+4200>>3]=j;i=b;return}function Fh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+820>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4192>>3]=g;h[e+4184>>3]=j;i=b;return}function Gh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4768>>3]=+h[b+4288>>3]+(+h[b+4192>>3]+ +h[b+4240>>3]);i=i;return}function Hh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4760>>3]=+h[b+4280>>3]+(+h[b+4184>>3]+ +h[b+4232>>3]);i=i;return}function Ih(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+820>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4176>>3]=g;h[e+4168>>3]=j;i=b;return}function Jh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4744>>3]=+h[b+4264>>3]+(+h[b+4168>>3]+ +h[b+4216>>3]);i=i;return}function Kh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4752>>3]=+h[b+4272>>3]+(+h[b+4176>>3]+ +h[b+4224>>3]);i=i;return}function Lh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+820>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4160>>3]=g;h[e+4152>>3]=j;i=b;return}function Mh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4736>>3]=+h[b+4256>>3]+(+h[b+4160>>3]+ +h[b+4208>>3]);i=i;return}function Nh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4728>>3]=+h[b+4248>>3]+(+h[b+4152>>3]+ +h[b+4200>>3]);i=i;return}function Oh(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+232>>3]=+h[d>>3];h[f+224>>3]=e;i=b;return}function Ph(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+216>>3]=+h[d>>3];h[f+208>>3]=e;i=b;return}function Qh(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+200>>3]=+h[d>>3];h[f+192>>3]=e;i=b;return}function Rh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+844>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+296>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+296|0;h[c[g+848>>2]>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+296>>3]);e=c[f>>2]|0;h[c[e+852>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+844>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+400>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+400|0;h[(c[e+848>>2]|0)+8>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+400>>3]);j=c[f>>2]|0;h[(c[j+852>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+844>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+3272>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+3272|0;h[(c[j+848>>2]|0)+16>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+3272>>3]);g=c[f>>2]|0;h[(c[g+852>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+844>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+3288>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+3288|0;h[(c[g+848>>2]|0)+24>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+3288>>3]);e=c[f>>2]|0;h[(c[e+852>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+844>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+3264>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+3264|0;h[(c[e+848>>2]|0)+32>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+3264>>3]);j=c[f>>2]|0;h[(c[j+852>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+844>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+3296>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+3296|0;h[(c[j+848>>2]|0)+40>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+3296>>3]);g=c[f>>2]|0;h[(c[g+852>>2]|0)+40>>3]=k;e=c[d>>2]|0;h[(c[g+844>>2]|0)+48>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+3656>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+3656|0;h[(c[g+848>>2]|0)+48>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+3656>>3]);e=c[f>>2]|0;h[(c[e+852>>2]|0)+48>>3]=k;j=c[d>>2]|0;h[(c[e+844>>2]|0)+56>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+3664>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+3664|0;h[(c[e+848>>2]|0)+56>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+3664>>3]);j=c[f>>2]|0;h[(c[j+852>>2]|0)+56>>3]=k;g=c[d>>2]|0;h[(c[j+844>>2]|0)+64>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+3632>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+3632|0;h[(c[j+848>>2]|0)+64>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+3632>>3]);g=c[f>>2]|0;h[(c[g+852>>2]|0)+64>>3]=k;e=c[d>>2]|0;h[(c[g+844>>2]|0)+72>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+3608>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+3608|0;h[(c[g+848>>2]|0)+72>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+3608>>3]);e=c[f>>2]|0;h[(c[e+852>>2]|0)+72>>3]=k;j=c[d>>2]|0;h[(c[e+844>>2]|0)+80>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+2096>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+2096|0;h[(c[e+848>>2]|0)+80>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+2096>>3]);j=c[f>>2]|0;h[(c[j+852>>2]|0)+80>>3]=k;g=c[d>>2]|0;h[(c[j+844>>2]|0)+88>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+2144>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+2144|0;h[(c[j+848>>2]|0)+88>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+2144>>3]);g=c[f>>2]|0;h[(c[g+852>>2]|0)+88>>3]=k;e=c[d>>2]|0;h[(c[g+844>>2]|0)+96>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2184>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2184|0;h[(c[g+848>>2]|0)+96>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2184>>3]);e=c[f>>2]|0;h[(c[e+852>>2]|0)+96>>3]=k;j=c[d>>2]|0;h[(c[e+844>>2]|0)+104>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+2104>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+2104|0;h[(c[e+848>>2]|0)+104>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+2104>>3]);j=c[f>>2]|0;h[(c[j+852>>2]|0)+104>>3]=k;g=c[d>>2]|0;h[(c[j+844>>2]|0)+112>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+2136>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+2136|0;h[(c[j+848>>2]|0)+112>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+2136>>3]);g=c[f>>2]|0;h[(c[g+852>>2]|0)+112>>3]=k;e=c[d>>2]|0;h[(c[g+844>>2]|0)+120>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2176>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2176|0;h[(c[g+848>>2]|0)+120>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2176>>3]);e=c[f>>2]|0;h[(c[e+852>>2]|0)+120>>3]=k;j=c[d>>2]|0;h[(c[e+844>>2]|0)+128>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+3640>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+3640|0;h[(c[e+848>>2]|0)+128>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+3640>>3]);j=c[f>>2]|0;h[(c[j+852>>2]|0)+128>>3]=k;g=c[d>>2]|0;h[(c[j+844>>2]|0)+136>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+3616>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+3616|0;h[(c[j+848>>2]|0)+136>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+3616>>3]);g=c[f>>2]|0;h[(c[g+852>>2]|0)+136>>3]=k;e=c[d>>2]|0;h[(c[g+844>>2]|0)+144>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1056>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1056|0;h[(c[g+848>>2]|0)+144>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1056>>3]);e=c[f>>2]|0;h[(c[e+852>>2]|0)+144>>3]=k;j=c[d>>2]|0;h[(c[e+844>>2]|0)+152>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+568>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+568|0;h[(c[e+848>>2]|0)+152>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+568>>3]);j=c[f>>2]|0;h[(c[j+852>>2]|0)+152>>3]=k;g=c[d>>2]|0;h[(c[j+844>>2]|0)+160>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+560>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+560|0;h[(c[j+848>>2]|0)+160>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+560>>3]);g=c[f>>2]|0;h[(c[g+852>>2]|0)+160>>3]=k;e=c[d>>2]|0;h[(c[g+844>>2]|0)+168>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+536>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+536|0;h[(c[g+848>>2]|0)+168>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+536>>3]);e=c[f>>2]|0;h[(c[e+852>>2]|0)+168>>3]=k;j=c[d>>2]|0;h[(c[e+844>>2]|0)+176>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1064>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1064|0;h[(c[e+848>>2]|0)+176>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1064>>3]);j=c[f>>2]|0;h[(c[j+852>>2]|0)+176>>3]=k;g=c[d>>2]|0;h[(c[j+844>>2]|0)+184>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1024>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1024|0;h[(c[j+848>>2]|0)+184>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1024>>3]);g=c[f>>2]|0;h[(c[g+852>>2]|0)+184>>3]=k;e=c[d>>2]|0;h[(c[g+844>>2]|0)+192>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+528>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+528|0;h[(c[g+848>>2]|0)+192>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+528>>3]);e=c[f>>2]|0;h[(c[e+852>>2]|0)+192>>3]=k;j=c[d>>2]|0;h[(c[e+844>>2]|0)+200>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+600>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+600|0;h[(c[e+848>>2]|0)+200>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+600>>3]);j=c[f>>2]|0;h[(c[j+852>>2]|0)+200>>3]=k;g=c[d>>2]|0;h[(c[j+844>>2]|0)+208>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+592>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+592|0;h[(c[j+848>>2]|0)+208>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+592>>3]);g=c[f>>2]|0;h[(c[g+852>>2]|0)+208>>3]=k;e=c[d>>2]|0;h[(c[g+844>>2]|0)+216>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1096>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1096|0;h[(c[g+848>>2]|0)+216>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1096>>3]);e=c[f>>2]|0;h[(c[e+852>>2]|0)+216>>3]=k;j=c[d>>2]|0;h[(c[e+844>>2]|0)+224>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1568>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1568|0;h[(c[e+848>>2]|0)+224>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1568>>3]);j=c[f>>2]|0;h[(c[j+852>>2]|0)+224>>3]=k;g=c[d>>2]|0;h[(c[j+844>>2]|0)+232>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1632>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1632|0;h[(c[j+848>>2]|0)+232>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1632>>3]);g=c[f>>2]|0;h[(c[g+852>>2]|0)+232>>3]=k;e=c[d>>2]|0;h[(c[g+844>>2]|0)+240>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1624>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1624|0;h[(c[g+848>>2]|0)+240>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1624>>3]);e=c[f>>2]|0;h[(c[e+852>>2]|0)+240>>3]=k;j=c[d>>2]|0;h[(c[e+844>>2]|0)+248>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1560>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1560|0;h[(c[e+848>>2]|0)+248>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1560>>3]);j=c[f>>2]|0;h[(c[j+852>>2]|0)+248>>3]=k;g=c[d>>2]|0;h[(c[j+844>>2]|0)+256>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1600>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1600|0;h[(c[j+848>>2]|0)+256>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1600>>3]);g=c[f>>2]|0;h[(c[g+852>>2]|0)+256>>3]=k;e=c[d>>2]|0;h[(c[g+844>>2]|0)+264>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1592>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1592|0;h[(c[g+848>>2]|0)+264>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1592>>3]);e=c[f>>2]|0;h[(c[e+852>>2]|0)+264>>3]=k;j=c[d>>2]|0;h[(c[e+844>>2]|0)+272>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1104>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1104|0;h[(c[e+848>>2]|0)+272>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1104>>3]);j=c[f>>2]|0;h[(c[j+852>>2]|0)+272>>3]=k;g=c[d>>2]|0;h[(c[j+844>>2]|0)+280>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1016>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1016|0;h[(c[j+848>>2]|0)+280>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1016>>3]);g=c[f>>2]|0;h[(c[g+852>>2]|0)+280>>3]=k;e=c[d>>2]|0;h[(c[g+844>>2]|0)+288>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2856>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2856|0;h[(c[g+848>>2]|0)+288>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2856>>3]);e=c[f>>2]|0;h[(c[e+852>>2]|0)+288>>3]=k;j=c[d>>2]|0;h[(c[e+844>>2]|0)+296>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+2872>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+2872|0;h[(c[e+848>>2]|0)+296>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+2872>>3]);j=c[f>>2]|0;h[(c[j+852>>2]|0)+296>>3]=k;g=c[d>>2]|0;h[(c[j+844>>2]|0)+304>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+2864>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+2864|0;h[(c[j+848>>2]|0)+304>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+2864>>3]);g=c[f>>2]|0;h[(c[g+852>>2]|0)+304>>3]=k;e=c[d>>2]|0;h[(c[g+844>>2]|0)+312>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4104>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4104|0;h[(c[g+848>>2]|0)+312>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4104>>3]);e=c[f>>2]|0;h[(c[e+852>>2]|0)+312>>3]=k;j=c[d>>2]|0;h[(c[e+844>>2]|0)+320>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+4144>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+4144|0;h[(c[e+848>>2]|0)+320>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+4144>>3]);j=c[f>>2]|0;h[(c[j+852>>2]|0)+320>>3]=k;g=c[d>>2]|0;h[(c[j+844>>2]|0)+328>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+4944>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+4944|0;h[(c[j+848>>2]|0)+328>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+4944>>3]);g=c[f>>2]|0;h[(c[g+852>>2]|0)+328>>3]=k;e=c[d>>2]|0;h[(c[g+844>>2]|0)+336>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4936>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4936|0;h[(c[g+848>>2]|0)+336>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4936>>3]);e=c[f>>2]|0;h[(c[e+852>>2]|0)+336>>3]=k;j=c[d>>2]|0;h[(c[e+844>>2]|0)+344>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+4960>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+4960|0;h[(c[e+848>>2]|0)+344>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+4960>>3]);j=c[f>>2]|0;h[(c[j+852>>2]|0)+344>>3]=k;g=c[d>>2]|0;h[(c[j+844>>2]|0)+352>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+4920>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+4920|0;h[(c[j+848>>2]|0)+352>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+4920>>3]);g=c[f>>2]|0;h[(c[g+852>>2]|0)+352>>3]=k;e=c[d>>2]|0;h[(c[g+844>>2]|0)+360>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4928>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4928|0;h[(c[g+848>>2]|0)+360>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4928>>3]);e=c[f>>2]|0;h[(c[e+852>>2]|0)+360>>3]=k;j=c[d>>2]|0;h[(c[e+844>>2]|0)+368>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+4072>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+4072|0;h[(c[e+848>>2]|0)+368>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+4072>>3]);j=c[f>>2]|0;h[(c[j+852>>2]|0)+368>>3]=k;g=c[d>>2]|0;h[(c[j+844>>2]|0)+376>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+4112>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+4112|0;h[(c[j+848>>2]|0)+376>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+4112>>3]);g=c[f>>2]|0;h[(c[g+852>>2]|0)+376>>3]=k;e=c[d>>2]|0;h[(c[g+844>>2]|0)+384>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4136>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4136|0;h[(c[g+848>>2]|0)+384>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4136>>3]);e=c[f>>2]|0;h[(c[e+852>>2]|0)+384>>3]=k;j=c[d>>2]|0;h[(c[e+844>>2]|0)+392>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+4080>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+4080|0;h[(c[e+848>>2]|0)+392>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+4080>>3]);j=c[f>>2]|0;h[(c[j+852>>2]|0)+392>>3]=k;g=c[d>>2]|0;h[(c[j+844>>2]|0)+400>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+2832>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+2832|0;h[(c[j+848>>2]|0)+400>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+2832>>3]);g=c[f>>2]|0;h[(c[g+852>>2]|0)+400>>3]=k;e=c[d>>2]|0;h[(c[g+844>>2]|0)+408>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2848>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2848|0;h[(c[g+848>>2]|0)+408>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2848>>3]);e=c[f>>2]|0;h[(c[e+852>>2]|0)+408>>3]=k;j=c[d>>2]|0;h[(c[e+844>>2]|0)+416>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+4952>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+4952|0;h[(c[e+848>>2]|0)+416>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+4952>>3]);j=c[f>>2]|0;h[(c[j+852>>2]|0)+416>>3]=k;g=c[d>>2]|0;h[(c[j+844>>2]|0)+424>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+2840>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+2840|0;h[(c[j+848>>2]|0)+424>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+2840>>3]);h[(c[(c[f>>2]|0)+852>>2]|0)+424>>3]=k;S5(a,10)|0;g=c[(c[f>>2]|0)+844>>2]|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+296>>3]=+h[g>>3];h[e+400>>3]=+h[g+8>>3];h[e+3272>>3]=+h[g+16>>3];h[e+3288>>3]=+h[g+24>>3];h[e+3264>>3]=+h[g+32>>3];h[e+3296>>3]=+h[g+40>>3];h[e+3656>>3]=+h[g+48>>3];h[e+3664>>3]=+h[g+56>>3];h[e+3632>>3]=+h[g+64>>3];h[e+3608>>3]=+h[g+72>>3];h[e+2096>>3]=+h[g+80>>3];h[e+2144>>3]=+h[g+88>>3];h[e+2184>>3]=+h[g+96>>3];h[e+2104>>3]=+h[g+104>>3];h[e+2136>>3]=+h[g+112>>3];h[e+2176>>3]=+h[g+120>>3];h[e+3640>>3]=+h[g+128>>3];h[e+3616>>3]=+h[g+136>>3];h[e+1056>>3]=+h[g+144>>3];h[e+568>>3]=+h[g+152>>3];h[e+560>>3]=+h[g+160>>3];h[e+536>>3]=+h[g+168>>3];h[e+1064>>3]=+h[g+176>>3];h[e+1024>>3]=+h[g+184>>3];g=c[(c[f>>2]|0)+844>>2]|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+528>>3]=+h[g+192>>3];h[e+600>>3]=+h[g+200>>3];h[e+592>>3]=+h[g+208>>3];h[e+1096>>3]=+h[g+216>>3];h[e+1568>>3]=+h[g+224>>3];h[e+1632>>3]=+h[g+232>>3];h[e+1624>>3]=+h[g+240>>3];h[e+1560>>3]=+h[g+248>>3];h[e+1600>>3]=+h[g+256>>3];h[e+1592>>3]=+h[g+264>>3];h[e+1104>>3]=+h[g+272>>3];h[e+1016>>3]=+h[g+280>>3];h[e+2856>>3]=+h[g+288>>3];h[e+2872>>3]=+h[g+296>>3];h[e+2864>>3]=+h[g+304>>3];h[e+4104>>3]=+h[g+312>>3];h[e+4144>>3]=+h[g+320>>3];h[e+4944>>3]=+h[g+328>>3];h[e+4936>>3]=+h[g+336>>3];h[e+4960>>3]=+h[g+344>>3];h[e+4920>>3]=+h[g+352>>3];h[e+4928>>3]=+h[g+360>>3];h[e+4072>>3]=+h[g+368>>3];h[e+4112>>3]=+h[g+376>>3];g=c[(c[f>>2]|0)+844>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+4136>>3]=+h[g+384>>3];h[f+4080>>3]=+h[g+392>>3];h[f+2832>>3]=+h[g+400>>3];h[f+2848>>3]=+h[g+408>>3];h[f+4952>>3]=+h[g+416>>3];h[f+2840>>3]=+h[g+424>>3];hv(a);iv(a);jv(a);kv(a);lv(a);mv(a);nv(a);ov(a);pv(a);qv(a);rv(a);sv(a);tv(a);uv(a);vv(a);wv(a);xv(a);yv(a);zv(a);Av(a);Bv(a);Cv(a);Dv(a);Ev(a);Fv(a);Gv(a);Hv(a);Iv(a);Jv(a);Kv(a);Lv(a);Mv(a);Nv(a);Ov(a);Pv(a);Qv(a);Rv(a);Sv(a);Tv(a);Uv(a);Vv(a);Wv(a);Xv(a);Yv(a);Zv(a);_v(a);$v(a);aw(a);bw(a);cw(a);dw(a);ew(a);fw(a);gw(a);hw(a);iw(a);jw(a);kw(a);lw(a);mw(a);nw(a);ow(a);pw(a);qw(a);rw(a);sw(a);tw(a);uw(a);vw(a);ww(a);xw(a);yw(a);zw(a);Aw(a);Bw(a);Cw(a);Dw(a);Ew(a);Fw(a);Gw(a);Hw(a);Iw(a);Jw(a);Kw(a);Lw(a);Mw(a);Nw(a);Ow(a);Pw(a);Qw(a);Rw(a);Sw(a);Tw(a);Uw(a);Vw(a);Ww(a);Xw(a);Yw(a);Zw(a);_w(a);$w(a);ax(a);bx(a);cx(a);dx(a);ex(a);fx(a);gx(a);hx(a);ix(a);jx(a);kx(a);lx(a);mx(a);nx(a);ox(a);px(a);qx(a);rx(a);sx(a);tx(a);ux(a);vx(a);wx(a);xx(a);yx(a);zx(a);Ax(a);Bx(a);Cx(a);Dx(a);Ex(a);Fx(a);Gx(a);Hx(a);Ix(a);Jx(a);Kx(a);Lx(a);Mx(a);Nx(a);Ox(a);Px(a);Qx(a);Rx(a);Sx(a);Tx(a);Ux(a);Vx(a);Wx(a);Xx(a);Yx(a);Zx(a);_x(a);$x(a);ay(a);by(a);cy(a);dy(a);ey(a);fy(a);gy(a);hy(a);iy(a);jy(a);ky(a);ly(a);my(a);ny(a);oy(a);py(a);qy(a);ry(a);sy(a);ty(a);uy(a);vy(a);wy(a);xy(a);yy(a);zy(a);Ay(a);By(a);Cy(a);Dy(a);Ey(a);Fy(a);Gy(a);Hy(a);Iy(a);Jy(a);Ky(a);Ly(a);My(a);Ny(a);Oy(a);Py(a);Qy(a);Ry(a);Sy(a);Ty(a);Uy(a);Vy(a);Wy(a);Xy(a);Yy(a);Zy(a);_y(a);$y(a);az(a);bz(a);cz(a);dz(a);ez(a);fz(a);gz(a);hz(a);iz(a);jz(a);kz(a);lz(a);mz(a);nz(a);oz(a);pz(a);qz(a);rz(a);sz(a);tz(a);uz(a);vz(a);wz(a);xz(a);yz(a);zz(a);Az(a);Bz(a);Cz(a);Dz(a);Ez(a);Fz(a);Gz(a);Hz(a);Iz(a);Jz(a);Kz(a);Lz(a);Mz(a);Nz(a);Oz(a);Pz(a);Qz(a);Rz(a);Sz(a);Tz(a);Uz(a);Vz(a);Wz(a);Xz(a);Yz(a);Zz(a);_z(a);$z(a);aA(a);bA(a);cA(a);dA(a);eA(a);fA(a);gA(a);hA(a);iA(a);jA(a);kA(a);lA(a);mA(a);nA(a);oA(a);pA(a);qA(a);rA(a);sA(a);tA(a);uA(a);vA(a);wA(a);xA(a);yA(a);zA(a);AA(a);BA(a);CA(a);DA(a);EA(a);FA(a);GA(a);HA(a);IA(a);JA(a);KA(a);LA(a);MA(a);NA(a);OA(a);PA(a);QA(a);RA(a);SA(a);TA(a);UA(a);VA(a);WA(a);XA(a);YA(a);ZA(a);_A(a);$A(a);aB(a);bB(a);cB(a);dB(a);eB(a);fB(a);gB(a);hB(a);iB(a);jB(a);kB(a);lB(a);mB(a);nB(a);oB(a);pB(a);qB(a);rB(a);sB(a);tB(a);uB(a);i=b;return}function Sh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1e3>>3]=+h[b+136>>3]- +h[b+952>>3];i=i;return}function Th(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1552>>3]=+h[b+952>>3]- +h[b+2632>>3];i=i;return}function Uh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+976>>3]=+h[b+112>>3]- +h[b+928>>3];i=i;return}function Vh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1528>>3]=+h[b+928>>3]- +h[b+2608>>3];i=i;return}function Wh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2520>>3]=+h[b+9352>>3]- +h[b+1968>>3];i=i;return}function Xh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2064>>3]=+h[b+1968>>3]- +h[b+168>>3];i=i;return}function Yh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2536>>3]=+h[b+9336>>3]- +h[b+1984>>3];i=i;return}function Zh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2080>>3]=+h[b+1984>>3]- +h[b+184>>3];i=i;return}function _h(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5824>>3]=+h[b+2616>>3]- +h[b+2632>>3];i=i;return}



function JW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44296]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+372>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(44304,M2(c[(c[g>>2]|0)+372>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[44296]=1;i=d;return}function KW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44448]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+364>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+364>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(44456,M2(c[(c[g>>2]|0)+364>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[44448]=1;i=d;return}function LW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44656]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+360>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(44664,M2(c[(c[g>>2]|0)+360>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[44656]=1;i=d;return}function MW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44808]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1484>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(44816,M2(c[(c[g>>2]|0)+1484>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[44808]=1;i=d;return}function NW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44936]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+352>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+352>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(44944,M2(c[(c[g>>2]|0)+352>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[44936]=1;i=d;return}function OW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45144]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+348>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(45152,M2(c[(c[g>>2]|0)+348>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[45144]=1;i=d;return}function PW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45296]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+340>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+340>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(45304,M2(c[(c[g>>2]|0)+340>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[45296]=1;i=d;return}function QW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45504]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+336>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(45512,M2(c[(c[g>>2]|0)+336>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[45504]=1;i=d;return}function RW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45656]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+328>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+328>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(45664,M2(c[(c[g>>2]|0)+328>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[45656]=1;i=d;return}function SW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45864]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+324>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(45872,M2(c[(c[g>>2]|0)+324>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[45864]=1;i=d;return}function TW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46016]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1476>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(46024,M2(c[(c[g>>2]|0)+1476>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58112;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[46016]=1;i=d;return}function UW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46144]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1464>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(46152,M2(c[(c[g>>2]|0)+1464>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[46144]=1;i=d;return}function VW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46240]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+316>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+316>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(46248,M2(c[(c[g>>2]|0)+316>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[46240]=1;i=d;return}function WW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46448]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+312>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(46456,M2(c[(c[g>>2]|0)+312>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[46448]=1;i=d;return}function XW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46600]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+304>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+304>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(46608,M2(c[(c[g>>2]|0)+304>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[46600]=1;i=d;return}function YW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46808]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+300>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(46816,M2(c[(c[g>>2]|0)+300>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[46808]=1;i=d;return}function ZW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46960]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+292>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+292>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(46968,M2(c[(c[g>>2]|0)+292>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[46960]=1;i=d;return}function _W(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47168]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+288>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(47176,M2(c[(c[g>>2]|0)+288>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[47168]=1;i=d;return}function $W(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47320]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1456>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(47328,M2(c[(c[g>>2]|0)+1456>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[47320]=1;i=d;return}function aX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47448]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+280>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+280>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(47456,M2(c[(c[g>>2]|0)+280>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[47448]=1;i=d;return}function bX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47656]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+276>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(47664,M2(c[(c[g>>2]|0)+276>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[47656]=1;i=d;return}function cX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47808]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+268>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+268>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(47816,M2(c[(c[g>>2]|0)+268>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[47808]=1;i=d;return}function dX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48016]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+264>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(48024,M2(c[(c[g>>2]|0)+264>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[48016]=1;i=d;return}function eX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48168]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+256>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+256>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(48176,M2(c[(c[g>>2]|0)+256>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[48168]=1;i=d;return}function fX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48376]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+252>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(48384,M2(c[(c[g>>2]|0)+252>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[48376]=1;i=d;return}function gX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48528]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1448>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(48536,M2(c[(c[g>>2]|0)+1448>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58112;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[48528]=1;i=d;return}function hX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48656]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1436>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(48664,M2(c[(c[g>>2]|0)+1436>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[48656]=1;i=d;return}function iX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48752]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+244>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+244>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(48760,M2(c[(c[g>>2]|0)+244>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[48752]=1;i=d;return}function jX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49e3]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+240>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(49008,M2(c[(c[g>>2]|0)+240>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[49e3]=1;i=d;return}function kX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49184]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+232>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+232>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(49192,M2(c[(c[g>>2]|0)+232>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[49184]=1;i=d;return}function lX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49432]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+228>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(49440,M2(c[(c[g>>2]|0)+228>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[49432]=1;i=d;return}function mX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49616]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+220>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+220>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(49624,M2(c[(c[g>>2]|0)+220>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[49616]=1;i=d;return}function nX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49864]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+216>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(49872,M2(c[(c[g>>2]|0)+216>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[49864]=1;i=d;return}function oX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50048]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1424>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(50056,M2(c[(c[g>>2]|0)+1424>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[50048]=1;i=d;return}function pX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50200]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+208>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+208>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(50208,M2(c[(c[g>>2]|0)+208>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[50200]=1;i=d;return}function qX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50448]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+204>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(50456,M2(c[(c[g>>2]|0)+204>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[50448]=1;i=d;return}function rX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50632]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+196>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+196>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(50640,M2(c[(c[g>>2]|0)+196>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[50632]=1;i=d;return}function sX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50880]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+192>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(50888,M2(c[(c[g>>2]|0)+192>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[50880]=1;i=d;return}function tX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51064]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+184>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+184>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(51072,M2(c[(c[g>>2]|0)+184>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[51064]=1;i=d;return}function uX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51312]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+180>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(51320,M2(c[(c[g>>2]|0)+180>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[51312]=1;i=d;return}function vX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51496]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1416>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(51504,M2(c[(c[g>>2]|0)+1416>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[51496]=1;i=d;return}function wX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51648]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+172>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+172>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(51656,M2(c[(c[g>>2]|0)+172>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[51648]=1;i=d;return}function xX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51896]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+168>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(51904,M2(c[(c[g>>2]|0)+168>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[51896]=1;i=d;return}function yX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52080]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+160>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+160>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(52088,M2(c[(c[g>>2]|0)+160>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[52080]=1;i=d;return}function zX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52328]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+156>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(52336,M2(c[(c[g>>2]|0)+156>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[52328]=1;i=d;return}function AX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52512]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+148>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+148>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(52520,M2(c[(c[g>>2]|0)+148>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[52512]=1;i=d;return}function BX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52760]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+144>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(52768,M2(c[(c[g>>2]|0)+144>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[52760]=1;i=d;return}function CX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52944]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1408>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(52952,M2(c[(c[g>>2]|0)+1408>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58112;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[52944]=1;i=d;return}function DX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53096]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+136>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+136>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(53104,M2(c[(c[g>>2]|0)+136>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[53096]=1;i=d;return}function EX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53344]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+132>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(53352,M2(c[(c[g>>2]|0)+132>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[53344]=1;i=d;return}function FX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53528]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+124>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+124>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(53536,M2(c[(c[g>>2]|0)+124>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[53528]=1;i=d;return}function GX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53776]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+120>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(53784,M2(c[(c[g>>2]|0)+120>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[53776]=1;i=d;return}function HX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53960]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+112>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+112>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(53968,M2(c[(c[g>>2]|0)+112>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[53960]=1;i=d;return}function IX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54208]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+108>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(54216,M2(c[(c[g>>2]|0)+108>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[54208]=1;i=d;return}function JX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54392]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1400>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(54400,M2(c[(c[g>>2]|0)+1400>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58112;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[54392]=1;i=d;return}function KX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54544]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1380>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(54552,M2(c[(c[g>>2]|0)+1380>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=54656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[54544]=1;i=d;return}function LX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54680]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+100>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+100>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(54688,M2(c[(c[g>>2]|0)+100>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[54680]=1;i=d;return}function MX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54864]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+96>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(54872,M2(c[(c[g>>2]|0)+96>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[54864]=1;i=d;return}function NX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55e3]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+88>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+88>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(55008,M2(c[(c[g>>2]|0)+88>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[55e3]=1;i=d;return}function OX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55184]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+84>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(55192,M2(c[(c[g>>2]|0)+84>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[55184]=1;i=d;return}function PX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55320]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+76>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+76>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(55328,M2(c[(c[g>>2]|0)+76>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[55320]=1;i=d;return}function QX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55504]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+72>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(55512,M2(c[(c[g>>2]|0)+72>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[55504]=1;i=d;return}function RX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55640]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1372>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(55648,M2(c[(c[g>>2]|0)+1372>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58112;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[55640]=1;i=d;return}function SX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55744]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1364>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(55752,M2(c[(c[g>>2]|0)+1364>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=55824;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[55744]=1;i=d;return}function TX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55848]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+64>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+64>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(55856,M2(c[(c[g>>2]|0)+64>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[55848]=1;i=d;return}function UX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56032]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+60>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(56040,M2(c[(c[g>>2]|0)+60>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[56032]=1;i=d;return}function VX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56168]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+52>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+52>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(56176,M2(c[(c[g>>2]|0)+52>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[56168]=1;i=d;return}function WX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56352]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+48>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(56360,M2(c[(c[g>>2]|0)+48>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[56352]=1;i=d;return}function XX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56488]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+40>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+40>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(56496,M2(c[(c[g>>2]|0)+40>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[56488]=1;i=d;return}function YX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56696]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+36>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(56704,M2(c[(c[g>>2]|0)+36>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[56696]=1;i=d;return}function ZX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56856]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1356>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(56864,M2(c[(c[g>>2]|0)+1356>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=56968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[56856]=1;i=d;return}function _X(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56992]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+28>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+28>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(57e3,M2(c[(c[g>>2]|0)+28>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[56992]=1;i=d;return}function $X(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57176]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+24>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(57184,M2(c[(c[g>>2]|0)+24>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[57176]=1;i=d;return}function aY(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57312]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+16>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+16>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(57320,M2(c[(c[g>>2]|0)+16>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[57312]=1;i=d;return}function bY(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57496]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+12>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(57504,M2(c[(c[g>>2]|0)+12>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[57496]=1;i=d;return}function cY(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57632]&1){i=d;return}g=b+420|0;b=y5(+(c[(c[g>>2]|0)+4>>2]|0),1.0)|0;if(!(b<<24>>24==0|(x5(+(c[(c[g>>2]|0)+4>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=O2(57640,M2(c[(c[g>>2]|0)+4>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57816;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[57632]=1;i=d;return}function dY(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57840]&1){i=d;return}g=b+420|0;if(!((y5(+(c[c[g>>2]>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(57848,M2(c[c[g>>2]>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=57976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[57840]=1;i=d;return}function eY(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58e3]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1348>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(58008,M2(c[(c[g>>2]|0)+1348>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58112;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[58e3]=1;i=d;return}function fY(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58136]&1){i=d;return}g=b+420|0;if(!((y5(+(c[(c[g>>2]|0)+1336>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=O2(58144,M2(c[(c[g>>2]|0)+1336>>2]|0,3392)|0)|0;g=c[30094]|0;h=e;j=58216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];we[g&15](e,b,f);a[58136]=1;i=d;return}function gY(a){a=a|0;var b=0;b=i;_N(a);$N(a);aO(a);bO(a);cO(a);dO(a);eO(a);fO(a);gO(a);hO(a);iO(a);jO(a);kO(a);lO(a);mO(a);nO(a);oO(a);pO(a);qO(a);rO(a);sO(a);tO(a);uO(a);vO(a);wO(a);xO(a);yO(a);zO(a);AO(a);BO(a);CO(a);DO(a);EO(a);FO(a);GO(a);HO(a);IO(a);JO(a);KO(a);LO(a);MO(a);NO(a);OO(a);PO(a);QO(a);RO(a);SO(a);TO(a);UO(a);VO(a);WO(a);XO(a);YO(a);ZO(a);_O(a);$O(a);aP(a);bP(a);cP(a);dP(a);eP(a);fP(a);gP(a);hP(a);iP(a);jP(a);kP(a);lP(a);mP(a);nP(a);oP(a);pP(a);qP(a);rP(a);sP(a);tP(a);uP(a);vP(a);wP(a);xP(a);yP(a);zP(a);AP(a);BP(a);CP(a);DP(a);EP(a);FP(a);GP(a);HP(a);IP(a);JP(a);KP(a);LP(a);MP(a);NP(a);OP(a);PP(a);QP(a);RP(a);SP(a);TP(a);UP(a);VP(a);WP(a);XP(a);YP(a);ZP(a);_P(a);$P(a);aQ(a);bQ(a);cQ(a);dQ(a);eQ(a);fQ(a);gQ(a);hQ(a);iQ(a);jQ(a);kQ(a);lQ(a);mQ(a);nQ(a);oQ(a);pQ(a);qQ(a);rQ(a);sQ(a);tQ(a);uQ(a);vQ(a);wQ(a);xQ(a);yQ(a);zQ(a);AQ(a);BQ(a);CQ(a);DQ(a);EQ(a);FQ(a);GQ(a);HQ(a);IQ(a);JQ(a);KQ(a);LQ(a);MQ(a);NQ(a);OQ(a);PQ(a);QQ(a);RQ(a);SQ(a);TQ(a);UQ(a);VQ(a);WQ(a);XQ(a);YQ(a);ZQ(a);_Q(a);$Q(a);aR(a);bR(a);cR(a);dR(a);eR(a);fR(a);gR(a);hR(a);iR(a);jR(a);kR(a);lR(a);mR(a);nR(a);oR(a);pR(a);qR(a);rR(a);sR(a);tR(a);uR(a);vR(a);wR(a);xR(a);yR(a);zR(a);AR(a);BR(a);CR(a);DR(a);ER(a);FR(a);GR(a);HR(a);IR(a);JR(a);KR(a);LR(a);MR(a);NR(a);OR(a);PR(a);QR(a);RR(a);SR(a);TR(a);UR(a);VR(a);WR(a);XR(a);YR(a);ZR(a);_R(a);$R(a);aS(a);bS(a);cS(a);dS(a);eS(a);fS(a);gS(a);hS(a);iS(a);jS(a);kS(a);lS(a);mS(a);nS(a);oS(a);pS(a);qS(a);rS(a);sS(a);tS(a);uS(a);vS(a);wS(a);xS(a);yS(a);zS(a);AS(a);BS(a);CS(a);DS(a);ES(a);FS(a);GS(a);HS(a);IS(a);JS(a);KS(a);LS(a);MS(a);NS(a);OS(a);PS(a);QS(a);RS(a);SS(a);TS(a);US(a);VS(a);WS(a);XS(a);YS(a);ZS(a);_S(a);$S(a);aT(a);bT(a);cT(a);dT(a);eT(a);fT(a);gT(a);hT(a);iT(a);jT(a);kT(a);lT(a);mT(a);nT(a);oT(a);pT(a);qT(a);rT(a);sT(a);tT(a);uT(a);vT(a);wT(a);xT(a);yT(a);zT(a);AT(a);BT(a);CT(a);DT(a);ET(a);FT(a);GT(a);HT(a);IT(a);JT(a);KT(a);LT(a);MT(a);NT(a);OT(a);PT(a);QT(a);RT(a);ST(a);TT(a);UT(a);VT(a);WT(a);XT(a);YT(a);ZT(a);_T(a);$T(a);aU(a);bU(a);cU(a);dU(a);eU(a);fU(a);gU(a);hU(a);iU(a);jU(a);kU(a);lU(a);mU(a);nU(a);oU(a);pU(a);qU(a);rU(a);sU(a);tU(a);uU(a);vU(a);wU(a);xU(a);yU(a);zU(a);AU(a);BU(a);CU(a);DU(a);EU(a);FU(a);GU(a);HU(a);IU(a);JU(a);KU(a);LU(a);MU(a);NU(a);OU(a);PU(a);QU(a);RU(a);SU(a);TU(a);UU(a);VU(a);WU(a);XU(a);YU(a);ZU(a);_U(a);$U(a);aV(a);bV(a);cV(a);dV(a);eV(a);fV(a);gV(a);hV(a);iV(a);jV(a);kV(a);lV(a);mV(a);nV(a);oV(a);pV(a);qV(a);rV(a);sV(a);tV(a);uV(a);vV(a);wV(a);xV(a);yV(a);zV(a);AV(a);BV(a);CV(a);DV(a);EV(a);FV(a);GV(a);HV(a);IV(a);JV(a);KV(a);LV(a);MV(a);NV(a);OV(a);PV(a);QV(a);RV(a);SV(a);TV(a);UV(a);VV(a);WV(a);XV(a);YV(a);ZV(a);_V(a);$V(a);aW(a);bW(a);cW(a);dW(a);eW(a);fW(a);gW(a);hW(a);iW(a);jW(a);kW(a);lW(a);mW(a);nW(a);oW(a);pW(a);qW(a);rW(a);sW(a);tW(a);uW(a);vW(a);wW(a);xW(a);yW(a);zW(a);AW(a);BW(a);CW(a);DW(a);EW(a);FW(a);GW(a);HW(a);IW(a);JW(a);KW(a);LW(a);MW(a);NW(a);OW(a);PW(a);QW(a);RW(a);SW(a);TW(a);UW(a);VW(a);WW(a);XW(a);YW(a);ZW(a);_W(a);$W(a);aX(a);bX(a);cX(a);dX(a);eX(a);fX(a);gX(a);hX(a);iX(a);jX(a);kX(a);lX(a);mX(a);nX(a);oX(a);pX(a);qX(a);rX(a);sX(a);tX(a);uX(a);vX(a);wX(a);xX(a);yX(a);zX(a);AX(a);BX(a);CX(a);DX(a);EX(a);FX(a);GX(a);HX(a);IX(a);JX(a);KX(a);LX(a);MX(a);NX(a);OX(a);PX(a);QX(a);RX(a);SX(a);TX(a);UX(a);VX(a);WX(a);XX(a);YX(a);ZX(a);_X(a);$X(a);aY(a);bY(a);cY(a);dY(a);eY(a);fY(a);i=b;return 0}function hY(b){b=b|0;var c=0;c=i;a[b+314|0]=0;iY(b);i=c;return 0}function iY(a){a=a|0;var b=0;b=i;Xe(a);Ye(a);Ze(a);_e(a);$e(a);af(a);bf(a);cf(a);df(a);ef(a);ff(a);gf(a);hf(a);jf(a);kf(a);lf(a);mf(a);nf(a);of(a);pf(a);qf(a);rf(a);sf(a);tf(a);uf(a);vf(a);wf(a);xf(a);yf(a);zf(a);Af(a);Bf(a);Cf(a);Df(a);Ef(a);Ff(a);Gf(a);Hf(a);If(a);Jf(a);Kf(a);Lf(a);Mf(a);Nf(a);Of(a);Pf(a);Qf(a);Rf(a);Sf(a);Tf(a);Uf(a);Vf(a);Wf(a);Xf(a);Yf(a);Zf(a);_f(a);$f(a);ag(a);bg(a);cg(a);dg(a);eg(a);fg(a);gg(a);hg(a);ig(a);jg(a);kg(a);lg(a);mg(a);ng(a);og(a);pg(a);qg(a);rg(a);sg(a);tg(a);ug(a);vg(a);wg(a);xg(a);yg(a);zg(a);Ag(a);Bg(a);Cg(a);Dg(a);Eg(a);Fg(a);Gg(a);Hg(a);Ig(a);Jg(a);Kg(a);Lg(a);Mg(a);Ng(a);Og(a);Pg(a);Qg(a);Rg(a);Sg(a);Tg(a);Ug(a);Vg(a);Wg(a);Xg(a);Yg(a);Zg(a);_g(a);$g(a);ah(a);bh(a);ch(a);dh(a);eh(a);fh(a);gh(a);hh(a);ih(a);jh(a);kh(a);lh(a);mh(a);nh(a);oh(a);ph(a);qh(a);rh(a);sh(a);th(a);uh(a);vh(a);wh(a);xh(a);yh(a);zh(a);Ah(a);Bh(a);Ch(a);Dh(a);Eh(a);Fh(a);Gh(a);Hh(a);Ih(a);Jh(a);Kh(a);Lh(a);Mh(a);Nh(a);Oh(a);Ph(a);Qh(a);Rh(a);Sh(a);Th(a);Uh(a);Vh(a);Wh(a);Xh(a);Yh(a);Zh(a);_h(a);$h(a);ai(a);bi(a);ci(a);di(a);ei(a);fi(a);gi(a);hi(a);ii(a);ji(a);ki(a);li(a);mi(a);ni(a);oi(a);pi(a);qi(a);ri(a);si(a);ti(a);ui(a);vi(a);wi(a);xi(a);yi(a);zi(a);Ai(a);Bi(a);Ci(a);Di(a);Ei(a);Fi(a);Gi(a);Hi(a);Ii(a);Ji(a);Ki(a);Li(a);Mi(a);Ni(a);Oi(a);Pi(a);Qi(a);Ri(a);Si(a);Ti(a);Ui(a);Vi(a);Wi(a);Xi(a);Yi(a);Zi(a);_i(a);$i(a);aj(a);bj(a);cj(a);dj(a);ej(a);fj(a);gj(a);hj(a);ij(a);jj(a);kj(a);lj(a);mj(a);nj(a);oj(a);pj(a);qj(a);rj(a);sj(a);tj(a);uj(a);vj(a);wj(a);xj(a);yj(a);zj(a);Aj(a);Bj(a);Cj(a);Dj(a);Ej(a);Fj(a);Gj(a);Hj(a);Ij(a);Jj(a);Kj(a);Lj(a);Mj(a);Nj(a);Oj(a);Pj(a);Qj(a);Rj(a);Sj(a);Tj(a);Uj(a);Vj(a);Wj(a);Xj(a);Yj(a);Zj(a);_j(a);$j(a);ak(a);bk(a);ck(a);dk(a);ek(a);fk(a);gk(a);hk(a);ik(a);jk(a);kk(a);lk(a);mk(a);nk(a);ok(a);pk(a);qk(a);rk(a);sk(a);tk(a);uk(a);vk(a);wk(a);xk(a);yk(a);zk(a);Ak(a);Bk(a);Ck(a);Dk(a);Ek(a);Fk(a);Gk(a);Hk(a);Ik(a);Jk(a);Kk(a);Lk(a);Mk(a);Nk(a);Ok(a);Pk(a);Qk(a);Rk(a);Sk(a);Tk(a);Uk(a);Vk(a);Wk(a);Xk(a);Yk(a);Zk(a);_k(a);$k(a);al(a);bl(a);cl(a);dl(a);el(a);fl(a);gl(a);hl(a);il(a);jl(a);kl(a);ll(a);ml(a);nl(a);ol(a);pl(a);ql(a);rl(a);sl(a);tl(a);ul(a);vl(a);wl(a);xl(a);yl(a);Bl(a);Cl(a);Dl(a);El(a);Fl(a);Gl(a);Hl(a);Il(a);Jl(a);Kl(a);i=b;return}function jY(a){a=a|0;i=i;return 0}function kY(a){a=a|0;i=i;return 1}function lY(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+464|0;a=c[d>>2]|0;c[a+44>>2]=3;c[a+48>>2]=3;c[a+72>>2]=Lwa(3,8)|0;a=Lwa(3,8)|0;c[(c[d>>2]|0)+80>>2]=a;a=Lwa(0,8)|0;c[(c[d>>2]|0)+76>>2]=a;a=Jwa(12)|0;c[(c[d>>2]|0)+52>>2]=a;a=Jwa(0)|0;c[(c[d>>2]|0)+56>>2]=a;a=Jwa(12)|0;c[(c[d>>2]|0)+64>>2]=a;a=c[d>>2]|0;c[a+68>>2]=1;c[a+84>>2]=0;a=c[d>>2]|0;d=a+64|0;e=c[a+52>>2]|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;e=c[d>>2]|0;c[e+8>>2]=1;c[e+4>>2]=1;c[e>>2]=1;i=b;return 0}function mY(a){a=a|0;i=i;return 1}function nY(a){a=a|0;i=i;return 1}function oY(a){a=a|0;i=i;return 1}function pY(a){a=a|0;i=i;return 0}function qY(a){a=a|0;i=i;return 0}function rY(a){a=a|0;i=i;return 0}function sY(a){a=a|0;i=i;return 0}function tY(a){a=a|0;i=i;return 0}function uY(a,b){a=a|0;b=b|0;i=i;return-1}function vY(a,b){a=a|0;b=b|0;i=i;return-1}function wY(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i;return-1}function xY(){i=i;return 58240}function yY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}a=c[d>>2]|0;if((a|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}j=+h[b>>3];d=!(j>=0.0);if((a|0)==1){if(d){k=-j}else{k=j}if((f|0)<2){g=1;i=e;return g|0}else{l=k;m=2;n=1}while(1){k=+h[b+(m+ -1<<3)>>3];o=!(k>=0.0);if(o){p=-k}else{p=k}q=p<=l;if(q|o^1){r=q?l:k;s=q?n:m}else{r=-k;s=m}q=m+1|0;if((q|0)>(f|0)){g=s;break}else{l=r;m=q;n=s}}i=e;return g|0}if(d){t=-j}else{t=j}if((f|0)<2){g=1;i=e;return g|0}j=t;d=2;s=a+1|0;n=1;while(1){t=+h[b+(s+ -1<<3)>>3];m=!(t>=0.0);if(m){u=-t}else{u=t}q=u<=j;if(q|m^1){v=q?j:t;w=q?n:d}else{v=-t;w=d}q=d+1|0;if((q|0)>(f|0)){g=w;break}else{j=v;d=q;s=a+s|0;n=w}}i=e;return g|0}function zY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)<1){i=f;return 0}if((j|0)!=1){e=fa(j,g)|0;if((e|0)>0){k=1}else{i=f;return 0}do{l=d+(k+ -1<<3)|0;h[l>>3]=+h[b>>3]*+h[l>>3];k=k+j|0;}while((k|0)<=(e|0));i=f;return 0}e=(g|0)%5|0;do{if((e|0)==0){m=g}else{if((e|0)<1){n=g}else{k=1;do{j=d+(k+ -1<<3)|0;h[j>>3]=+h[b>>3]*+h[j>>3];k=k+1|0;}while((k|0)<=(e|0));n=c[a>>2]|0}if((n|0)>=5){m=n;break}i=f;return 0}}while(0);n=e+1|0;if((n|0)>(m|0)){i=f;return 0}else{o=n}do{n=d+(o+ -1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+2<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+3<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];o=o+5|0;}while((o|0)<=(m|0));i=f;return 0}function AY(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}k=c[d>>2]|0;do{if((k|0)==1){l=c[f>>2]|0;if((l|0)!=1){m=l;n=1;break}l=(j|0)%3|0;do{if((l|0)==0){o=j}else{if((l|0)<1){p=j}else{q=1;do{r=q+ -1|0;s=b+(r<<3)|0;t=+h[s>>3];u=e+(r<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;q=q+1|0;}while((q|0)<=(l|0));p=c[a>>2]|0}if((p|0)>=3){o=p;break}i=g;return 0}}while(0);q=l+1|0;if((q|0)>(o|0)){i=g;return 0}else{v=q}do{q=v+ -1|0;u=b+(q<<3)|0;t=+h[u>>3];s=e+(q<<3)|0;h[u>>3]=+h[s>>3];h[s>>3]=t;s=b+(v<<3)|0;t=+h[s>>3];u=e+(v<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;u=v+1|0;s=b+(u<<3)|0;t=+h[s>>3];q=e+(u<<3)|0;h[s>>3]=+h[q>>3];h[q>>3]=t;v=v+3|0;}while((v|0)<=(o|0));i=g;return 0}else{if((k|0)<0){w=(fa(1-j|0,k)|0)+1|0}else{w=1}m=c[f>>2]|0;n=w}}while(0);if((m|0)<0){x=1;y=n;z=(fa(1-j|0,m)|0)+1|0}else{x=1;y=n;z=1}while(1){n=b+(y+ -1<<3)|0;t=+h[n>>3];m=e+(z+ -1<<3)|0;h[n>>3]=+h[m>>3];h[m>>3]=t;m=x+1|0;if((m|0)>(j|0)){break}else{z=(c[f>>2]|0)+z|0;y=(c[d>>2]|0)+y|0;x=m}}i=g;return 0}function BY(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+8|0;n=m;o=c[l>>2]|0;l=~o;c[n>>2]=0;p=c[a>>2]|0;do{if((p|0)<0){c[n>>2]=1}else{q=c[b>>2]|0;if((q|0)<0){c[n>>2]=2;break}r=c[f>>2]|0;if((r|0)==0){c[n>>2]=5;break}s=c[j>>2]|0;if((s|0)==0){c[n>>2]=7;break}if((o|0)<(((p|0)>1?p:1)|0)){c[n>>2]=9;break}if((p|0)==0|(q|0)==0){i=m;return 0}if(+h[d>>3]==0.0){i=m;return 0}if((s|0)>0){t=1}else{t=1-(fa(s,q+ -1|0)|0)|0}if((r|0)==1){if((q|0)<1){i=m;return 0}else{u=s;v=1;w=t}while(1){x=+h[g+(w+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){A=u;break}B=(fa(v,o)|0)+l|0;C=1;do{D=k+(B+C<<3)|0;h[D>>3]=+h[D>>3]+y*+h[e+(C+ -1<<3)>>3];C=C+1|0;}while((C|0)<=(z|0));A=c[j>>2]|0}else{A=u}}while(0);z=v+1|0;if((z|0)>(q|0)){break}else{u=A;v=z;w=A+w|0}}i=m;return 0}if((r|0)>0){E=1}else{E=1-(fa(p+ -1|0,r)|0)|0}if((q|0)<1){i=m;return 0}else{F=s;G=1;H=t}while(1){x=+h[g+(H+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){I=F;break}C=(fa(G,o)|0)+l|0;B=1;D=E;while(1){J=k+(C+B<<3)|0;h[J>>3]=+h[J>>3]+y*+h[e+(D+ -1<<3)>>3];J=B+1|0;if((J|0)>(z|0)){break}else{D=(c[f>>2]|0)+D|0;B=J}}I=c[j>>2]|0}else{I=F}}while(0);B=G+1|0;if((B|0)>(q|0)){break}else{F=I;G=B;H=I+H|0}}i=m;return 0}}while(0);zb(59096,n|0)|0;i=m;return 0}function CY(a,b,d,e,f,g,j,k,l,m,n,o,p){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0,da=0;q=i;i=i+8|0;r=q;s=c[k>>2]|0;t=~s;u=c[m>>2]|0;v=~u;w=c[p>>2]|0;x=~w;y=t4(a,59104)|0;z=t4(b,59104)|0;A=(y|0)!=0;y=c[(A?d:f)>>2]|0;B=(z|0)!=0;z=c[(B?f:e)>>2]|0;c[r>>2]=0;do{if(A){C=5}else{if((t4(a,59112)|0)!=0){C=5;break}if((t4(a,59120)|0)!=0){C=5;break}c[r>>2]=1}}while(0);a:do{if((C|0)==5){do{if(!B){if((t4(b,59112)|0)!=0){break}if((t4(b,59120)|0)!=0){break}c[r>>2]=2;break a}}while(0);a=c[d>>2]|0;if((a|0)<0){c[r>>2]=3;break}D=c[e>>2]|0;if((D|0)<0){c[r>>2]=4;break}E=c[f>>2]|0;if((E|0)<0){c[r>>2]=5;break}if((c[k>>2]|0)<(((y|0)>1?y:1)|0)){c[r>>2]=8;break}if((c[m>>2]|0)<(((z|0)>1?z:1)|0)){c[r>>2]=10;break}if((c[p>>2]|0)<(((a|0)>1?a:1)|0)){c[r>>2]=13;break}if((c[r>>2]|0)!=0){break}if((a|0)==0|(D|0)==0){i=q;return 0}F=+h[g>>3]==0.0;do{if(F|(E|0)==0){if(+h[n>>3]==1.0){i=q;return 0}if(!F){break}G=(D|0)<1;if(+h[n>>3]==0.0){if(G){i=q;return 0}else{H=a;I=0;J=2}while(1){if((H|0)>=1){pxa(o+((fa(w,I)|0)<<3)|0,0,H<<3|0)|0}if((J|0)>(D|0)){break}H=c[d>>2]|0;I=I+1|0;J=J+1|0}i=q;return 0}if(G){i=q;return 0}else{K=a;L=1}while(1){if((K|0)>=1){M=(fa(L,w)|0)+x|0;N=1;do{O=o+(M+N<<3)|0;h[O>>3]=+h[n>>3]*+h[O>>3];N=N+1|0;}while((N|0)<=(K|0))}N=L+1|0;if((N|0)>(D|0)){break}K=c[d>>2]|0;L=N}i=q;return 0}}while(0);F=(D|0)<1;if(B){if(!A){if(F){i=q;return 0}else{P=a;Q=1}while(1){if((P|0)>=1){E=(fa(Q,w)|0)+x|0;G=(fa(Q,u)|0)+v|0;N=1;do{M=c[f>>2]|0;if((M|0)<1){R=0.0}else{O=(fa(N,s)|0)+t|0;S=1;T=0.0;while(1){U=T+ +h[j+(O+S<<3)>>3]*+h[l+(G+S<<3)>>3];V=S+1|0;if((V|0)>(M|0)){R=U;break}else{T=U;S=V}}}T=+h[n>>3];U=R*+h[g>>3];S=o+(E+N<<3)|0;if(T==0.0){W=U}else{W=U+T*+h[S>>3]}h[S>>3]=W;N=N+1|0;}while((N|0)<=(P|0))}N=Q+1|0;if((N|0)>(D|0)){break}P=c[d>>2]|0;Q=N}i=q;return 0}if(F){i=q;return 0}else{X=0;Y=1}while(1){N=o+((fa(w,X)|0)<<3)|0;T=+h[n>>3];b:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}pxa(N|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}G=(fa(Y,w)|0)+x|0;U=T;S=1;while(1){M=o+(G+S<<3)|0;h[M>>3]=U*+h[M>>3];M=S+1|0;if((M|0)>(E|0)){break b}U=+h[n>>3];S=M}}}while(0);N=c[f>>2]|0;if((N|0)>=1){S=(fa(Y,u)|0)+v|0;E=(fa(Y,w)|0)+x|0;G=1;do{T=+h[l+(S+G<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];M=c[d>>2]|0;if((M|0)<1){break}O=(fa(G,s)|0)+t|0;V=1;do{Z=o+(E+V<<3)|0;h[Z>>3]=+h[Z>>3]+U*+h[j+(O+V<<3)>>3];V=V+1|0;}while((V|0)<=(M|0))}}while(0);G=G+1|0;}while((G|0)<=(N|0))}N=Y+1|0;if((N|0)>(D|0)){break}X=X+1|0;Y=N}i=q;return 0}else{if(!A){if(F){i=q;return 0}else{_=a;$=1}while(1){if((_|0)>=1){N=(fa($,w)|0)+x|0;G=$+v|0;E=1;do{S=c[f>>2]|0;if((S|0)<1){aa=0.0}else{M=(fa(E,s)|0)+t|0;V=1;T=0.0;while(1){U=T+ +h[j+(M+V<<3)>>3]*+h[l+(G+(fa(V,u)|0)<<3)>>3];O=V+1|0;if((O|0)>(S|0)){aa=U;break}else{T=U;V=O}}}T=+h[n>>3];U=aa*+h[g>>3];V=o+(N+E<<3)|0;if(T==0.0){ba=U}else{ba=U+T*+h[V>>3]}h[V>>3]=ba;E=E+1|0;}while((E|0)<=(_|0))}E=$+1|0;if((E|0)>(D|0)){break}_=c[d>>2]|0;$=E}i=q;return 0}if(F){i=q;return 0}else{ca=0;da=1}while(1){a=o+((fa(w,ca)|0)<<3)|0;T=+h[n>>3];c:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}pxa(a|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}N=(fa(da,w)|0)+x|0;U=T;G=1;while(1){V=o+(N+G<<3)|0;h[V>>3]=U*+h[V>>3];V=G+1|0;if((V|0)>(E|0)){break c}U=+h[n>>3];G=V}}}while(0);a=c[f>>2]|0;if((a|0)>=1){G=da+v|0;E=(fa(da,w)|0)+x|0;N=1;do{T=+h[l+(G+(fa(N,u)|0)<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];V=c[d>>2]|0;if((V|0)<1){break}S=(fa(N,s)|0)+t|0;M=1;do{O=o+(E+M<<3)|0;h[O>>3]=+h[O>>3]+U*+h[j+(S+M<<3)>>3];M=M+1|0;}while((M|0)<=(V|0))}}while(0);N=N+1|0;}while((N|0)<=(a|0))}a=da+1|0;if((a|0)>(D|0)){break}ca=ca+1|0;da=a}i=q;return 0}}}while(0);zb(59128,r|0)|0;i=q;return 0}function DY(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0,X=0.0,Y=0,Z=0,_=0;o=i;i=i+8|0;p=o;q=c[l>>2]|0;r=~q;s=c[n>>2]|0;t=~s;u=(t4(a,59136)|0)!=0;v=c[(u?f:g)>>2]|0;w=t4(e,59144)|0;x=t4(b,59152)|0;c[p>>2]=0;do{if(u){y=4}else{if((t4(a,59160)|0)!=0){y=4;break}c[p>>2]=1}}while(0);a:do{if((y|0)==4){do{if((x|0)==0){if((t4(b,59136)|0)!=0){break}c[p>>2]=2;break a}}while(0);do{if((t4(d,59144)|0)==0){if((t4(d,59168)|0)!=0){break}if((t4(d,59176)|0)!=0){break}c[p>>2]=3;break a}}while(0);do{if((t4(e,59152)|0)==0){if((t4(e,59144)|0)!=0){break}c[p>>2]=4;break a}}while(0);a=c[f>>2]|0;if((a|0)<0){c[p>>2]=5;break}z=c[g>>2]|0;if((z|0)<0){c[p>>2]=6;break}if((c[l>>2]|0)<(((v|0)>1?v:1)|0)){c[p>>2]=9;break}if((c[n>>2]|0)<(((a|0)>1?a:1)|0)){c[p>>2]=11;break}if((c[p>>2]|0)!=0){break}if((a|0)==0|(z|0)==0){i=o;return 0}if(+h[j>>3]==0.0){if((z|0)<1){i=o;return 0}else{A=a;B=0;C=2}while(1){if((A|0)>=1){pxa(m+((fa(s,B)|0)<<3)|0,0,A<<3|0)|0}if((C|0)>(z|0)){break}A=c[f>>2]|0;B=B+1|0;C=C+1|0}i=o;return 0}z=(t4(d,59144)|0)!=0;a=(x|0)!=0;D=c[g>>2]|0;if(u){E=(D|0)<1;if(!z){if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{H=c[f>>2]|0;if((H|0)>=1){I=(fa(G,s)|0)+t|0;J=1;do{K=m+(I+J<<3)|0;L=+h[j>>3]*+h[K>>3];M=J+ -1|0;if((M|0)<1){N=L}else{O=(fa(J,q)|0)+r|0;P=1;Q=L;while(1){L=Q- +h[k+(O+P<<3)>>3]*+h[m+(I+P<<3)>>3];R=P+1|0;if((R|0)>(M|0)){N=L;break}else{Q=L;P=R}}}if(F){S=N}else{S=N/+h[k+(J+r+(fa(J,q)|0)<<3)>>3]}h[K>>3]=S;J=J+1|0;}while((J|0)<=(H|0))}G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{H=c[f>>2]|0;b:do{if((H|0)>0){J=(fa(F,s)|0)+t|0;I=H;P=H;while(1){M=m+(J+P<<3)|0;Q=+h[j>>3]*+h[M>>3];O=P+1|0;if((O|0)>(I|0)){T=Q}else{R=(fa(P,q)|0)+r|0;U=O;L=Q;while(1){Q=L- +h[k+(R+U<<3)>>3]*+h[m+(J+U<<3)>>3];O=U+1|0;if((O|0)>(I|0)){T=Q;break}else{L=Q;U=O}}}if(G){V=T}else{V=T/+h[k+(P+r+(fa(P,q)|0)<<3)>>3]}h[M>>3]=V;U=P+ -1|0;if((U|0)<=0){break b}I=c[f>>2]|0;P=U}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];c:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}P=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){J=m+(P+I<<3)|0;h[J>>3]=Q*+h[J>>3];J=I+1|0;if((J|0)>(H|0)){y=43;break c}Q=+h[j>>3];I=J}}else{y=43}}while(0);d:do{if((y|0)==43){y=0;I=c[f>>2]|0;if((I|0)<=0){break}H=(fa(G,s)|0)+t|0;if(F){P=I;while(1){J=m+(H+P<<3)|0;L=+h[J>>3];K=P+ -1|0;e:do{if(L!=0.0){if((K|0)<1){break d}U=(fa(P,q)|0)+r|0;Q=L;R=1;while(1){O=m+(H+R<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(U+R<<3)>>3];O=R+1|0;if((O|0)>(K|0)){break e}Q=+h[J>>3];R=O}}}while(0);if((K|0)>0){P=K}else{break d}}}else{W=I}while(1){P=m+(H+W<<3)|0;L=+h[P>>3];f:do{if(L!=0.0){Q=L/+h[k+(W+r+(fa(W,q)|0)<<3)>>3];h[P>>3]=Q;J=W+ -1|0;if((J|0)<1){break d}M=(fa(W,q)|0)+r|0;X=Q;R=1;while(1){U=m+(H+R<<3)|0;h[U>>3]=+h[U>>3]-X*+h[k+(M+R<<3)>>3];U=R+1|0;if((U|0)>(J|0)){Y=J;break f}X=+h[P>>3];R=U}}else{Y=W+ -1|0}}while(0);if((Y|0)>0){W=Y}else{break}}}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{L=+h[j>>3];g:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(F,s)|0)+t|0;X=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=X*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){y=64;break g}X=+h[j>>3];P=K}}else{y=64}}while(0);do{if((y|0)==64){y=0;P=c[f>>2]|0;if((P|0)<1){break}H=(fa(F,s)|0)+t|0;if(G){I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];h:do{if(L!=0.0){R=c[f>>2]|0;J=I+1|0;if((J|0)>(R|0)){Z=J;break}M=(fa(I,q)|0)+r|0;X=L;U=J;while(1){O=m+(H+U<<3)|0;h[O>>3]=+h[O>>3]-X*+h[k+(M+U<<3)>>3];O=U+1|0;if((O|0)>(R|0)){Z=J;break h}X=+h[K>>3];U=O}}else{Z=I+1|0}}while(0);if((Z|0)>(P|0)){break}else{I=Z}}}else{I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];i:do{if(L!=0.0){X=L/+h[k+(I+r+(fa(I,q)|0)<<3)>>3];h[K>>3]=X;U=c[f>>2]|0;J=I+1|0;if((J|0)>(U|0)){_=J;break}R=(fa(I,q)|0)+r|0;Q=X;M=J;while(1){O=m+(H+M<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(R+M<<3)>>3];O=M+1|0;if((O|0)>(U|0)){_=J;break i}Q=+h[K>>3];M=O}}else{_=I+1|0}}while(0);if((_|0)>(P|0)){break}else{I=_}}}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(!z){if(a){if((D|0)<=0){i=o;return 0}F=(w|0)==0;G=D;while(1){do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];E=c[f>>2]|0;if((E|0)<1){break}I=(fa(G,s)|0)+t|0;P=1;do{H=m+(I+P<<3)|0;h[H>>3]=L*+h[H>>3];P=P+1|0;}while((P|0)<=(E|0))}}while(0);E=G+ -1|0;if((E|0)>=1){P=(fa(G,q)|0)+r|0;I=(fa(G,s)|0)+t|0;H=1;do{L=+h[k+(P+H<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(H,s)|0)+t|0;J=1;do{U=m+(M+J<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(I+J<<3)>>3];J=J+1|0;}while((J|0)<=(K|0))}}while(0);H=H+1|0;}while((H|0)<=(E|0))}L=+h[j>>3];j:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(G,s)|0)+t|0;Q=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=Q*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){break j}Q=+h[j>>3];P=K}}}while(0);if((E|0)>0){G=E}else{break}}i=o;return 0}else{if((D|0)<1){i=o;return 0}G=(w|0)==0;F=1;while(1){do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}P=(fa(F,s)|0)+t|0;H=1;do{I=m+(P+H<<3)|0;h[I>>3]=L*+h[I>>3];H=H+1|0;}while((H|0)<=(z|0))}}while(0);E=c[g>>2]|0;z=F+1|0;if((z|0)<=(E|0)){H=(fa(F,q)|0)+r|0;P=(fa(F,s)|0)+t|0;I=z;do{L=+h[k+(H+I<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}J=(fa(I,s)|0)+t|0;M=1;do{U=m+(J+M<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(P+M<<3)>>3];M=M+1|0;}while((M|0)<=(K|0))}}while(0);I=I+1|0;}while((I|0)<=(E|0))}L=+h[j>>3];k:do{if(L!=1.0){E=c[f>>2]|0;if((E|0)<1){break}I=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){H=m+(I+P<<3)|0;h[H>>3]=Q*+h[H>>3];H=P+1|0;if((H|0)>(E|0)){break k}Q=+h[j>>3];P=H}}}while(0);if((z|0)>(D|0)){break}else{F=z}}i=o;return 0}}if(a){if((D|0)<1){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];l:do{if(L!=1.0){P=c[f>>2]|0;if((P|0)<1){break}E=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){H=m+(E+I<<3)|0;h[H>>3]=Q*+h[H>>3];H=I+1|0;if((H|0)>(P|0)){break l}Q=+h[j>>3];I=H}}}while(0);z=G+ -1|0;if((z|0)>=1){I=(fa(G,q)|0)+r|0;P=(fa(G,s)|0)+t|0;E=1;do{H=k+(I+E<<3)|0;L=+h[H>>3];m:do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(E,s)|0)+t|0;Q=L;J=1;while(1){U=m+(P+J<<3)|0;h[U>>3]=+h[U>>3]-Q*+h[m+(M+J<<3)>>3];U=J+1|0;if((U|0)>(K|0)){break m}Q=+h[H>>3];J=U}}}while(0);E=E+1|0;}while((E|0)<=(z|0))}do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}E=(fa(G,s)|0)+t|0;P=1;do{I=m+(E+P<<3)|0;h[I>>3]=L*+h[I>>3];P=P+1|0;}while((P|0)<=(z|0))}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}else{if((D|0)<=0){i=o;return 0}G=(w|0)==0;F=D;do{L=+h[j>>3];n:do{if(L!=1.0){a=c[f>>2]|0;if((a|0)<1){break}z=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){E=m+(z+P<<3)|0;h[E>>3]=Q*+h[E>>3];E=P+1|0;if((E|0)>(a|0)){break n}Q=+h[j>>3];P=E}}}while(0);P=c[g>>2]|0;a=F+1|0;if((a|0)<=(P|0)){z=(fa(F,q)|0)+r|0;E=(fa(F,s)|0)+t|0;I=a;do{a=k+(z+I<<3)|0;L=+h[a>>3];o:do{if(L!=0.0){H=c[f>>2]|0;if((H|0)<1){break}J=(fa(I,s)|0)+t|0;Q=L;K=1;while(1){M=m+(E+K<<3)|0;h[M>>3]=+h[M>>3]-Q*+h[m+(J+K<<3)>>3];M=K+1|0;if((M|0)>(H|0)){break o}Q=+h[a>>3];K=M}}}while(0);I=I+1|0;}while((I|0)<=(P|0))}do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];P=c[f>>2]|0;if((P|0)<1){break}I=(fa(F,s)|0)+t|0;E=1;do{z=m+(I+E<<3)|0;h[z>>3]=L*+h[z>>3];E=E+1|0;}while((E|0)<=(P|0))}}while(0);F=F+ -1|0;}while((F|0)>0);i=o;return 0}}}while(0);zb(59184,p|0)|0;i=o;return 0}function EY(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;i=i+8|0;l=k;c[j>>2]=0;m=c[a>>2]|0;do{if((m|0)<0){c[j>>2]=-1;n=-1}else{if((c[b>>2]|0)<0){c[j>>2]=-2;n=-2;break}o=(m|0)>1?m:1;if((c[e>>2]|0)<(o|0)){c[j>>2]=-4;n=-4;break}if((c[h>>2]|0)<(o|0)){c[j>>2]=-7;n=-7;break}GY(a,a,d,e,f,j)|0;if((c[j>>2]|0)!=0){i=k;return 0}HY(59200,a,b,d,e,f,g,h,j)|0;i=k;return 0}}while(0);c[l>>2]=0-n;zb(59192,l|0)|0;i=k;return 0}function FY(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;o=c[e>>2]|0;p=~o;c[g>>2]=0;q=c[a>>2]|0;do{if((q|0)<0){c[g>>2]=-1;r=-1}else{s=c[b>>2]|0;if((s|0)<0){c[g>>2]=-2;r=-2;break}if((c[e>>2]|0)<(((q|0)>1?q:1)|0)){c[g>>2]=-4;r=-4;break}if((q|0)==0|(s|0)==0){i=j;return 0}t=+a4(59224);s=c[a>>2]|0;u=c[b>>2]|0;v=(s|0)>(u|0)?u:s;c[k>>2]=v;if((v|0)<1){i=j;return 0}else{w=s;x=1}while(1){c[l>>2]=1-x+w;s=x+ -1|0;v=fa(x,o)|0;u=x+p|0;y=u+v|0;z=d+(y<<3)|0;A=s+(yY(l,z,59232)|0)|0;c[f+(s<<2)>>2]=A;B=v+p|0;a:do{if(+h[d+(B+A<<3)>>3]!=0.0){if((A|0)!=(x|0)){AY(b,d+(s<<3)|0,e,d+(A+ -1<<3)|0,e)|0}C=c[a>>2]|0;if((x|0)>=(C|0)){break}D=+h[z>>3];h[n>>3]=D;if(!(D>=0.0)){E=-D}else{E=D}F=C-x|0;c[l>>2]=F;if(E>=t){h[n>>3]=1.0/D;zY(l,n,d+(x-o+v<<3)|0,59232)|0;break}if((F|0)<1){break}else{G=D;H=1}while(1){C=d+(y+H<<3)|0;h[C>>3]=+h[C>>3]/G;C=H+1|0;if((C|0)>(F|0)){break a}G=+h[z>>3];H=C}}else{if((c[g>>2]|0)!=0){break}c[g>>2]=x}}while(0);z=c[a>>2]|0;y=c[b>>2]|0;if((x|0)<(((z|0)>(y|0)?y:z)|0)){c[l>>2]=z-x;c[m>>2]=y-x;y=x+1|0;z=fa(y,o)|0;BY(l,m,59240,d+(B+y<<3)|0,59232,d+(u+z<<3)|0,e,d+(y+p+z<<3)|0,e)|0;I=y}else{I=x+1|0}if((I|0)>(c[k>>2]|0)){break}w=c[a>>2]|0;x=I}i=j;return 0}}while(0);c[k>>2]=0-r;zb(59216,k|0)|0;i=j;return 0}function GY(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;i=i+48|0;j=h;k=h+8|0;l=h+16|0;m=h+24|0;n=h+32|0;o=h+40|0;p=c[e>>2]|0;q=~p;c[g>>2]=0;r=c[a>>2]|0;do{if((r|0)<0){c[g>>2]=-1;s=-1}else{t=c[b>>2]|0;if((t|0)<0){c[g>>2]=-2;s=-2;break}if((c[e>>2]|0)<(((r|0)>1?r:1)|0)){c[g>>2]=-4;s=-4;break}if((r|0)==0|(t|0)==0){i=h;return 0}t=59272;u=JY(59256,59248,59264,a,b,t,t)|0;do{if((u|0)>=2){t=c[a>>2]|0;v=c[b>>2]|0;w=(t|0)>(v|0)?v:t;if((u|0)>=(w|0)){break}c[j>>2]=w;c[m>>2]=1;if((w|0)>0){x=v;y=t;z=1}else{i=h;return 0}while(1){t=((y|0)>(x|0)?x:y)-z+1|0;c[n>>2]=(t|0)<=(u|0)?t:u;c[k>>2]=y+1-z;FY(k,n,d+(z+q+(fa(z,p)|0)<<3)|0,e,f+(z+ -1<<2)|0,o)|0;do{if((c[g>>2]|0)==0){t=c[o>>2]|0;if((t|0)<=0){break}c[g>>2]=t+ -1+(c[m>>2]|0)}}while(0);t=c[a>>2]|0;c[l>>2]=t;v=c[m>>2]|0;w=v+ -1|0;A=w+(c[n>>2]|0)|0;B=(t|0)<=(A|0)?t:A;c[k>>2]=B;if((v|0)<=(B|0)){t=v;do{v=f+(t+ -1<<2)|0;c[v>>2]=(c[v>>2]|0)+w;t=t+1|0;}while((t|0)<=(B|0))}c[k>>2]=w;c[l>>2]=A;IY(k,d,e,m,l,f,59256)|0;B=c[m>>2]|0;t=c[n>>2]|0;v=t+B|0;C=c[b>>2]|0;do{if((v|0)>(C|0)){D=B}else{c[k>>2]=1-B-t+C;c[l>>2]=v+ -1;IY(k,d+((fa(v,p)|0)-p<<3)|0,e,m,l,f,59256)|0;E=c[m>>2]|0;F=c[n>>2]|0;c[k>>2]=(c[b>>2]|0)+1-E-F;G=E+q|0;DY(59280,59288,59296,59312,n,k,59320,d+(G+(fa(E,p)|0)<<3)|0,e,d+(G+(fa(F+E|0,p)|0)<<3)|0,e)|0;E=c[m>>2]|0;F=c[n>>2]|0;G=F+E|0;H=c[a>>2]|0;if((G|0)>(H|0)){D=E;break}c[k>>2]=1-E-F+H;c[l>>2]=(c[b>>2]|0)+1-E-F;F=fa(G,p)|0;H=59296;CY(H,H,k,l,n,59328,d+((fa(E,p)|0)+q+G<<3)|0,e,d+(E+q+F<<3)|0,e,59320,d+(G+q+F<<3)|0,e)|0;D=c[m>>2]|0}}while(0);v=D+u|0;c[m>>2]=v;if((v|0)>(c[j>>2]|0)){break}x=c[b>>2]|0;y=c[a>>2]|0;z=v}i=h;return 0}}while(0);FY(a,b,d,e,f,g)|0;i=h;return 0}}while(0);c[j>>2]=0-s;zb(59248,j|0)|0;i=h;return 0}function HY(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;l=i;i=i+8|0;m=l;c[k>>2]=0;n=(t4(a,59336)|0)!=0;do{if(n){o=5}else{if((t4(a,59344)|0)!=0){o=5;break}if((t4(a,59352)|0)!=0){o=5;break}c[k>>2]=-1;p=-1}}while(0);do{if((o|0)==5){a=c[b>>2]|0;if((a|0)<0){c[k>>2]=-2;p=-2;break}q=c[d>>2]|0;if((q|0)<0){c[k>>2]=-3;p=-3;break}r=(a|0)>1?a:1;if((c[f>>2]|0)<(r|0)){c[k>>2]=-5;p=-5;break}if((c[j>>2]|0)<(r|0)){c[k>>2]=-8;p=-8;break}r=c[k>>2]|0;if((r|0)!=0){p=r;break}if((a|0)==0|(q|0)==0){i=l;return 0}if(n){q=59368;IY(d,h,j,q,b,g,q)|0;DY(59376,59384,59392,59408,b,d,59416,e,f,h,j)|0;DY(59376,59424,59392,59432,b,d,59416,e,f,h,j)|0;i=l;return 0}else{DY(59376,59424,59448,59432,b,d,59416,e,f,h,j)|0;DY(59376,59384,59448,59408,b,d,59416,e,f,h,j)|0;IY(d,h,j,59368,b,g,59464)|0;i=l;return 0}}}while(0);c[m>>2]=0-p;zb(59360,m|0)|0;i=l;return 0}function IY(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0;k=i;l=c[d>>2]|0;d=~l;m=c[j>>2]|0;do{if((m|0)>0){n=c[e>>2]|0;o=n;p=f;q=1;r=n}else{if((m|0)<0){n=c[f>>2]|0;o=n;p=e;q=-1;r=(fa(1-n|0,m)|0)+1|0;break}else{i=k;return 0}}}while(0);e=c[p>>2]|0;p=c[a>>2]|0;f=((p|0)/32|0)<<5;if((f|0)<1){s=m;t=p}else{p=(q|0)<0;n=p?(o|0)>=(e|0):(o|0)<=(e|0);u=m;m=1;while(1){if(n){v=m+31|0;if(p){w=u;x=o;y=r;while(1){z=c[g+(y+ -1<<2)>>2]|0;if((z|0)==(x|0)){A=w}else{B=x+d|0;C=z+d|0;z=m;do{D=fa(z,l)|0;E=b+(B+D<<3)|0;F=+h[E>>3];G=b+(C+D<<3)|0;h[E>>3]=+h[G>>3];h[G>>3]=F;z=z+1|0;}while((z|0)<=(v|0));A=c[j>>2]|0}z=x+q|0;if((z|0)<(e|0)){H=A;break}else{w=A;x=z;y=A+y|0}}}else{y=u;x=o;w=r;while(1){z=c[g+(w+ -1<<2)>>2]|0;if((z|0)==(x|0)){I=y}else{C=x+d|0;B=z+d|0;z=m;do{G=fa(z,l)|0;E=b+(C+G<<3)|0;F=+h[E>>3];D=b+(B+G<<3)|0;h[E>>3]=+h[D>>3];h[D>>3]=F;z=z+1|0;}while((z|0)<=(v|0));I=c[j>>2]|0}z=x+q|0;if((z|0)>(e|0)){H=I;break}else{y=I;x=z;w=I+w|0}}}}else{H=u}w=m+32|0;if((w|0)>(f|0)){break}else{u=H;m=w}}s=H;t=c[a>>2]|0}if((f|0)==(t|0)){i=k;return 0}t=f|1;f=(q|0)<0;if(!(f?(o|0)>=(e|0):(o|0)<=(e|0))){i=k;return 0}if(f){f=s;H=o;m=r;while(1){u=c[g+(m+ -1<<2)>>2]|0;do{if((u|0)==(H|0)){J=f}else{I=c[a>>2]|0;if((t|0)>(I|0)){J=f;break}A=H+d|0;p=u+d|0;n=t;do{w=fa(n,l)|0;x=b+(A+w<<3)|0;F=+h[x>>3];y=b+(p+w<<3)|0;h[x>>3]=+h[y>>3];h[y>>3]=F;n=n+1|0;}while((n|0)<=(I|0));J=c[j>>2]|0}}while(0);u=H+q|0;if((u|0)<(e|0)){break}else{f=J;H=u;m=J+m|0}}i=k;return 0}else{m=s;s=o;o=r;while(1){r=c[g+(o+ -1<<2)>>2]|0;do{if((r|0)==(s|0)){K=m}else{J=c[a>>2]|0;if((t|0)>(J|0)){K=m;break}H=s+d|0;f=r+d|0;u=t;do{I=fa(u,l)|0;n=b+(H+I<<3)|0;F=+h[n>>3];p=b+(f+I<<3)|0;h[n>>3]=+h[p>>3];h[p>>3]=F;u=u+1|0;}while((u|0)<=(J|0));K=c[j>>2]|0}}while(0);r=s+q|0;if((r|0)>(e|0)){break}else{m=K;s=r;o=K+o|0}}i=k;return 0}return 0}



function eA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1216>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1024>>3],+h[j+1016>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1296>>3]=l;h[e+1288>>3]=m;i=b;return}function fA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+976>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2840>>3],+h[j+2832>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3e3>>3]=l;h[e+2992>>3]=m;i=b;return}function gA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3040>>3]=+h[b+2800>>3]+(+h[b+2704>>3]+ +h[b+2752>>3]);i=i;return}function hA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1288>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+536>>3],+h[j+528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+792>>3]=l;h[e+784>>3]=m;i=b;return}function iA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+360>>3]=-+h[b+840>>3]- +h[b+792>>3]- +h[b+888>>3];i=i;return}function jA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+216>>3];k=b+416|0;l=c[k>>2]|0;m=+h[l+1224>>3];n=+h[g+360>>3];do{if(m!=0.0){o=l;p=g;q=n/m}else{if(n==0.0){o=l;p=g;q=n;break}r=n/+$1(c[b+536>>2]|0,m,1856,1984,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[k>>2]|0;p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+264>>3]=(j-(q+ +h[p+456>>3]))*+h[o+1232>>3];i=d;return}function kA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+352>>3]=-+h[b+832>>3]- +h[b+784>>3]- +h[b+880>>3];i=i;return}function lA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+208>>3];k=b+416|0;l=c[k>>2]|0;m=+h[l+1224>>3];n=+h[g+352>>3];do{if(m!=0.0){o=l;p=g;q=n/m}else{if(n==0.0){o=l;p=g;q=n;break}r=n/+$1(c[b+536>>2]|0,m,1856,1992,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[k>>2]|0;p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+256>>3]=(j-(q+ +h[p+448>>3]))*+h[o+1232>>3];i=d;return}function mA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1288>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+536>>3],+h[j+528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+808>>3]=l;h[e+800>>3]=m;i=b;return}function nA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1276>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+568>>3],+h[j+560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+856>>3]=l;h[e+848>>3]=m;i=b;return}function oA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+376>>3]=-+h[b+856>>3]- +h[b+808>>3]- +h[b+904>>3];i=i;return}function pA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+232>>3];k=b+416|0;l=c[k>>2]|0;m=+h[l+1224>>3];n=+h[g+376>>3];do{if(m!=0.0){o=l;p=g;q=n/m}else{if(n==0.0){o=l;p=g;q=n;break}r=n/+$1(c[b+536>>2]|0,m,1856,2e3,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[k>>2]|0;p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+280>>3]=(j-(q+ +h[p+472>>3]))*+h[o+1232>>3];i=d;return}function qA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+368>>3]=-+h[b+848>>3]- +h[b+800>>3]- +h[b+896>>3];i=i;return}function rA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+224>>3];k=b+416|0;l=c[k>>2]|0;m=+h[l+1224>>3];n=+h[g+368>>3];do{if(m!=0.0){o=l;p=g;q=n/m}else{if(n==0.0){o=l;p=g;q=n;break}r=n/+$1(c[b+536>>2]|0,m,1856,2008,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[k>>2]|0;p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+272>>3]=(j-(q+ +h[p+464>>3]))*+h[o+1232>>3];i=d;return}function sA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1312>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+568>>3],-+h[j+560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+696>>3]=l;h[e+688>>3]=m;i=b;return}function tA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1480>>3]=-+h[b+688>>3]- +h[b+640>>3]- +h[b+736>>3];i=i;return}function uA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1336>>3]=+h[b+1480>>3]- +h[b+1288>>3]- +h[b+1384>>3];i=i;return}function vA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1488>>3]=-+h[b+696>>3]- +h[b+648>>3]- +h[b+744>>3];i=i;return}function wA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1344>>3]=+h[b+1488>>3]- +h[b+1296>>3]- +h[b+1392>>3];i=i;return}function xA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1e3>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2856>>3],+h[j+2848>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2920>>3]=l;h[e+2912>>3]=m;i=b;return}function yA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1e3>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2856>>3],+h[j+2848>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2904>>3]=l;h[e+2896>>3]=m;i=b;return}function zA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3088>>3]=+h[b+2992>>3]+(+h[b+2896>>3]+ +h[b+2944>>3]);i=i;return}function AA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3096>>3]=+h[b+3e3>>3]+(+h[b+2904>>3]+ +h[b+2952>>3]);i=i;return}function BA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+616>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4960>>3],+h[j+4952>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5232>>3]=l;h[e+5224>>3]=m;i=b;return}function CA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5328>>3]=+h[b+5232>>3]+(+h[b+5136>>3]+ +h[b+5184>>3]);i=i;return}function DA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2568>>3]=-+h[b+5712>>3]- +h[b+5328>>3]- +h[b+6192>>3];i=i;return}function EA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1440>>3]=+h[b+2568>>3]- +h[b+3096>>3];i=i;return}function FA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1200>>3]=+h[b+1440>>3]- +h[b+1152>>3]- +h[b+1248>>3];i=i;return}function GA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5320>>3]=+h[b+5224>>3]+(+h[b+5128>>3]+ +h[b+5176>>3]);i=i;return}function HA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2560>>3]=-+h[b+5704>>3]- +h[b+5320>>3]- +h[b+6184>>3];i=i;return}function IA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1432>>3]=+h[b+2560>>3]- +h[b+3088>>3];i=i;return}function JA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1192>>3]=+h[b+1432>>3]- +h[b+1144>>3]- +h[b+1240>>3];i=i;return}function KA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+616>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4960>>3],+h[j+4952>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5248>>3]=l;h[e+5240>>3]=m;i=b;return}function LA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5344>>3]=+h[b+5248>>3]+(+h[b+5152>>3]+ +h[b+5200>>3]);i=i;return}function MA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2584>>3]=-+h[b+5728>>3]- +h[b+5344>>3]- +h[b+6208>>3];i=i;return}function NA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5336>>3]=+h[b+5240>>3]+(+h[b+5144>>3]+ +h[b+5192>>3]);i=i;return}function OA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2576>>3]=-+h[b+5720>>3]- +h[b+5336>>3]- +h[b+6200>>3];i=i;return}function PA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+976>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2840>>3],+h[j+2832>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3016>>3]=l;h[e+3008>>3]=m;i=b;return}function QA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3112>>3]=+h[b+3016>>3]+(+h[b+2920>>3]+ +h[b+2968>>3]);i=i;return}function RA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1456>>3]=+h[b+2584>>3]- +h[b+3112>>3];i=i;return}function SA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1216>>3]=+h[b+1456>>3]- +h[b+1168>>3]- +h[b+1264>>3];i=i;return}function TA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3104>>3]=+h[b+3008>>3]+(+h[b+2912>>3]+ +h[b+2960>>3]);i=i;return}function UA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1448>>3]=+h[b+2576>>3]- +h[b+3104>>3];i=i;return}function VA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1208>>3]=+h[b+1448>>3]- +h[b+1160>>3]- +h[b+1256>>3];i=i;return}function WA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3032>>3]=+h[b+2792>>3]+(+h[b+2696>>3]+ +h[b+2744>>3]);i=i;return}function XA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+200>>3];k=b+416|0;l=c[k>>2]|0;m=+h[l+1224>>3];n=+h[g+344>>3];do{if(m!=0.0){o=l;p=g;q=n/m}else{if(n==0.0){o=l;p=g;q=n;break}r=n/+$1(c[b+536>>2]|0,m,1856,2016,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[k>>2]|0;p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+248>>3]=(j-(q+ +h[p+440>>3]))*+h[o+1232>>3];i=d;return}function YA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0.0,r=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+192>>3];k=b+416|0;l=c[k>>2]|0;m=+h[l+1224>>3];n=+h[g+336>>3];do{if(m!=0.0){o=l;p=g;q=n/m}else{if(n==0.0){o=l;p=g;q=n;break}r=n/+$1(c[b+536>>2]|0,m,1856,2024,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[k>>2]|0;p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=r}}while(0);h[p+240>>3]=(j-(q+ +h[p+432>>3]))*+h[o+1232>>3];i=d;return}function ZA(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+10656>>3]=+h[d>>3];h[f+10648>>3]=e;i=b;return}function _A(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+832>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+3664>>3],+h[j+3656>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10640>>3]=l;h[e+10632>>3]=m;i=b;return}function $A(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+700>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4112>>3],+h[j+4104>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10624>>3]=l;h[e+10616>>3]=m;i=b;return}function aB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+700>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4112>>3],+h[j+4104>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10608>>3]=l;h[e+10600>>3]=m;i=b;return}function bB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+832>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+3664>>3],+h[j+3656>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10592>>3]=l;h[e+10584>>3]=m;i=b;return}function cB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+700>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+4112>>3],+h[j+4104>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10576>>3]=l;h[e+10568>>3]=m;i=b;return}function dB(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+10560>>3]=+h[d>>3];h[f+10552>>3]=e;i=b;return}function eB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1240>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1064>>3],-+h[j+1056>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10544>>3]=l;h[e+10536>>3]=m;i=b;return}function fB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1204>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1064>>3],+h[j+1056>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10528>>3]=l;h[e+10520>>3]=m;i=b;return}function gB(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+10512>>3]=+h[d>>3];h[f+10504>>3]=e;i=b;return}function hB(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+10496>>3]=+h[d>>3];h[f+10488>>3]=e;i=b;return}function iB(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+10480>>3]=+h[d>>3];h[f+10472>>3]=e;i=b;return}function jB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1240>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1064>>3],-+h[j+1056>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10464>>3]=l;h[e+10456>>3]=m;i=b;return}function kB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1204>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1064>>3],+h[j+1056>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10448>>3]=l;h[e+10440>>3]=m;i=b;return}function lB(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+10432>>3]=+h[d>>3];h[f+10424>>3]=e;i=b;return}function mB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1204>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1064>>3],+h[j+1056>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10416>>3]=l;h[e+10408>>3]=m;i=b;return}function nB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1240>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1064>>3],-+h[j+1056>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10400>>3]=l;h[e+10392>>3]=m;i=b;return}function oB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1108>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2104>>3],-+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10384>>3]=l;h[e+10376>>3]=m;i=b;return}function pB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1108>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2104>>3],-+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10368>>3]=l;h[e+10360>>3]=m;i=b;return}function qB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1108>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+2104>>3],-+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10352>>3]=l;h[e+10344>>3]=m;i=b;return}function rB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+832>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+3664>>3],+h[j+3656>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10336>>3]=l;h[e+10328>>3]=m;i=b;return}function sB(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+10320>>3]=+h[d>>3];h[f+10312>>3]=e;i=b;return}function tB(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+10304>>3]=+h[d>>3];h[f+10296>>3]=e;i=b;return}function uB(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+10288>>3]=+h[d>>3];h[f+10280>>3]=e;i=b;return}function vB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=a+8|0;a=c[d>>2]|0;e=b+16|0;f=c[e>>2]|0;h[f>>3]=+h[a+4224>>3];g=b+8|0;j=c[g>>2]|0;h[j>>3]=+h[a+4200>>3];k=b+12|0;b=c[k>>2]|0;h[b>>3]=+h[a+4208>>3];h[f+8>>3]=+h[a+5680>>3];h[j+8>>3]=+h[a+5656>>3];h[b+8>>3]=+h[a+5664>>3];h[f+16>>3]=+h[a+45888>>3];h[j+16>>3]=+h[a+45864>>3];h[b+16>>3]=+h[a+45872>>3];h[f+24>>3]=+h[a+46112>>3];h[j+24>>3]=+h[a+46088>>3];h[b+24>>3]=+h[a+46096>>3];h[f+32>>3]=+h[a+45776>>3];h[j+32>>3]=+h[a+45752>>3];h[b+32>>3]=+h[a+45760>>3];h[f+40>>3]=+h[a+46224>>3];h[j+40>>3]=+h[a+46200>>3];h[b+40>>3]=+h[a+46208>>3];h[f+48>>3]=+h[a+51264>>3];h[j+48>>3]=+h[a+51240>>3];h[b+48>>3]=+h[a+51248>>3];h[f+56>>3]=+h[a+51376>>3];h[j+56>>3]=+h[a+51352>>3];h[b+56>>3]=+h[a+51360>>3];a=c[d>>2]|0;j=c[e>>2]|0;h[j+64>>3]=+h[a+50928>>3];f=c[g>>2]|0;h[f+64>>3]=+h[a+50904>>3];h[b+64>>3]=+h[a+50912>>3];h[j+72>>3]=+h[a+50592>>3];h[f+72>>3]=+h[a+50568>>3];b=c[k>>2]|0;h[b+72>>3]=+h[a+50576>>3];h[j+80>>3]=+h[a+29424>>3];h[f+80>>3]=+h[a+29400>>3];h[b+80>>3]=+h[a+29408>>3];h[j+88>>3]=+h[a+30096>>3];h[f+88>>3]=+h[a+30072>>3];h[b+88>>3]=+h[a+30080>>3];h[j+96>>3]=+h[a+30656>>3];h[f+96>>3]=+h[a+30632>>3];h[b+96>>3]=+h[a+30640>>3];h[j+104>>3]=+h[a+29536>>3];h[f+104>>3]=+h[a+29512>>3];h[b+104>>3]=+h[a+29520>>3];h[j+112>>3]=+h[a+29984>>3];h[f+112>>3]=+h[a+29960>>3];h[b+112>>3]=+h[a+29968>>3];h[j+120>>3]=+h[a+30544>>3];h[f+120>>3]=+h[a+30520>>3];h[b+120>>3]=+h[a+30528>>3];a=c[d>>2]|0;f=c[e>>2]|0;h[f+128>>3]=+h[a+51040>>3];j=c[g>>2]|0;h[j+128>>3]=+h[a+51016>>3];h[b+128>>3]=+h[a+51024>>3];h[f+136>>3]=+h[a+50704>>3];h[j+136>>3]=+h[a+50680>>3];b=c[k>>2]|0;h[b+136>>3]=+h[a+50688>>3];h[f+144>>3]=+h[a+14864>>3];h[j+144>>3]=+h[a+14840>>3];h[b+144>>3]=+h[a+14848>>3];h[f+152>>3]=+h[a+8032>>3];h[j+152>>3]=+h[a+8008>>3];h[b+152>>3]=+h[a+8016>>3];h[f+160>>3]=+h[a+7920>>3];h[j+160>>3]=+h[a+7896>>3];h[b+160>>3]=+h[a+7904>>3];h[f+168>>3]=+h[a+7584>>3];h[j+168>>3]=+h[a+7560>>3];h[b+168>>3]=+h[a+7568>>3];h[f+176>>3]=+h[a+14976>>3];h[j+176>>3]=+h[a+14952>>3];h[b+176>>3]=+h[a+14960>>3];h[f+184>>3]=+h[a+14416>>3];h[j+184>>3]=+h[a+14392>>3];h[b+184>>3]=+h[a+14400>>3];a=c[d>>2]|0;j=c[e>>2]|0;h[j+192>>3]=+h[a+7472>>3];f=c[g>>2]|0;h[f+192>>3]=+h[a+7448>>3];h[b+192>>3]=+h[a+7456>>3];h[j+200>>3]=+h[a+8480>>3];h[f+200>>3]=+h[a+8456>>3];b=c[k>>2]|0;h[b+200>>3]=+h[a+8464>>3];h[j+208>>3]=+h[a+8368>>3];h[f+208>>3]=+h[a+8344>>3];h[b+208>>3]=+h[a+8352>>3];h[j+216>>3]=+h[a+15424>>3];h[f+216>>3]=+h[a+15400>>3];h[b+216>>3]=+h[a+15408>>3];h[j+224>>3]=+h[a+22032>>3];h[f+224>>3]=+h[a+22008>>3];h[b+224>>3]=+h[a+22016>>3];h[j+232>>3]=+h[a+22928>>3];h[f+232>>3]=+h[a+22904>>3];h[b+232>>3]=+h[a+22912>>3];h[j+240>>3]=+h[a+22816>>3];h[f+240>>3]=+h[a+22792>>3];h[b+240>>3]=+h[a+22800>>3];h[j+248>>3]=+h[a+21920>>3];h[f+248>>3]=+h[a+21896>>3];h[b+248>>3]=+h[a+21904>>3];a=c[d>>2]|0;f=c[e>>2]|0;h[f+256>>3]=+h[a+22480>>3];j=c[g>>2]|0;h[j+256>>3]=+h[a+22456>>3];h[b+256>>3]=+h[a+22464>>3];h[f+264>>3]=+h[a+22368>>3];h[j+264>>3]=+h[a+22344>>3];b=c[k>>2]|0;h[b+264>>3]=+h[a+22352>>3];h[f+272>>3]=+h[a+15536>>3];h[j+272>>3]=+h[a+15512>>3];h[b+272>>3]=+h[a+15520>>3];h[f+280>>3]=+h[a+14304>>3];h[j+280>>3]=+h[a+14280>>3];h[b+280>>3]=+h[a+14288>>3];h[f+288>>3]=+h[a+40064>>3];h[j+288>>3]=+h[a+40040>>3];h[b+288>>3]=+h[a+40048>>3];h[f+296>>3]=+h[a+40288>>3];h[j+296>>3]=+h[a+40264>>3];h[b+296>>3]=+h[a+40272>>3];h[f+304>>3]=+h[a+40176>>3];h[j+304>>3]=+h[a+40152>>3];h[b+304>>3]=+h[a+40160>>3];h[f+312>>3]=+h[a+57536>>3];h[j+312>>3]=+h[a+57512>>3];h[b+312>>3]=+h[a+57520>>3];a=c[d>>2]|0;j=c[e>>2]|0;h[j+320>>3]=+h[a+58096>>3];f=c[g>>2]|0;h[f+320>>3]=+h[a+58072>>3];h[b+320>>3]=+h[a+58080>>3];h[j+328>>3]=+h[a+69296>>3];h[f+328>>3]=+h[a+69272>>3];b=c[k>>2]|0;h[b+328>>3]=+h[a+69280>>3];h[j+336>>3]=+h[a+69184>>3];h[f+336>>3]=+h[a+69160>>3];h[b+336>>3]=+h[a+69168>>3];h[j+344>>3]=+h[a+69520>>3];h[f+344>>3]=+h[a+69496>>3];h[b+344>>3]=+h[a+69504>>3];h[j+352>>3]=+h[a+68960>>3];h[f+352>>3]=+h[a+68936>>3];h[b+352>>3]=+h[a+68944>>3];h[j+360>>3]=+h[a+69072>>3];h[f+360>>3]=+h[a+69048>>3];h[b+360>>3]=+h[a+69056>>3];h[j+368>>3]=+h[a+57088>>3];h[f+368>>3]=+h[a+57064>>3];h[b+368>>3]=+h[a+57072>>3];h[j+376>>3]=+h[a+57648>>3];h[f+376>>3]=+h[a+57624>>3];h[b+376>>3]=+h[a+57632>>3];a=c[d>>2]|0;d=c[e>>2]|0;h[d+384>>3]=+h[a+57984>>3];e=c[g>>2]|0;h[e+384>>3]=+h[a+57960>>3];h[b+384>>3]=+h[a+57968>>3];h[d+392>>3]=+h[a+57200>>3];h[e+392>>3]=+h[a+57176>>3];b=c[k>>2]|0;h[b+392>>3]=+h[a+57184>>3];h[d+400>>3]=+h[a+39728>>3];h[e+400>>3]=+h[a+39704>>3];h[b+400>>3]=+h[a+39712>>3];h[d+408>>3]=+h[a+39952>>3];h[e+408>>3]=+h[a+39928>>3];h[b+408>>3]=+h[a+39936>>3];h[d+416>>3]=+h[a+69408>>3];h[e+416>>3]=+h[a+69384>>3];h[b+416>>3]=+h[a+69392>>3];h[d+424>>3]=+h[a+39840>>3];h[e+424>>3]=+h[a+39816>>3];h[b+424>>3]=+h[a+39824>>3];i=i;return}function wB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0;e=i;f=a;g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[j+296>>3]=+h[b>>3];h[j+400>>3]=+h[b+8>>3];h[j+3272>>3]=+h[b+16>>3];h[j+3288>>3]=+h[b+24>>3];h[j+3264>>3]=+h[b+32>>3];h[j+3296>>3]=+h[b+40>>3];h[j+3656>>3]=+h[b+48>>3];h[j+3664>>3]=+h[b+56>>3];h[j+3632>>3]=+h[b+64>>3];h[j+3608>>3]=+h[b+72>>3];h[j+2096>>3]=+h[b+80>>3];h[j+2144>>3]=+h[b+88>>3];h[j+2184>>3]=+h[b+96>>3];h[j+2104>>3]=+h[b+104>>3];h[j+2136>>3]=+h[b+112>>3];h[j+2176>>3]=+h[b+120>>3];h[j+3640>>3]=+h[b+128>>3];h[j+3616>>3]=+h[b+136>>3];h[j+1056>>3]=+h[b+144>>3];h[j+568>>3]=+h[b+152>>3];h[j+560>>3]=+h[b+160>>3];h[j+536>>3]=+h[b+168>>3];h[j+1064>>3]=+h[b+176>>3];h[j+1024>>3]=+h[b+184>>3];j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[j+528>>3]=+h[b+192>>3];h[j+600>>3]=+h[b+200>>3];h[j+592>>3]=+h[b+208>>3];h[j+1096>>3]=+h[b+216>>3];h[j+1568>>3]=+h[b+224>>3];h[j+1632>>3]=+h[b+232>>3];h[j+1624>>3]=+h[b+240>>3];h[j+1560>>3]=+h[b+248>>3];h[j+1600>>3]=+h[b+256>>3];h[j+1592>>3]=+h[b+264>>3];h[j+1104>>3]=+h[b+272>>3];h[j+1016>>3]=+h[b+280>>3];h[j+2856>>3]=+h[b+288>>3];h[j+2872>>3]=+h[b+296>>3];h[j+2864>>3]=+h[b+304>>3];h[j+4104>>3]=+h[b+312>>3];h[j+4144>>3]=+h[b+320>>3];h[j+4944>>3]=+h[b+328>>3];h[j+4936>>3]=+h[b+336>>3];h[j+4960>>3]=+h[b+344>>3];h[j+4920>>3]=+h[b+352>>3];h[j+4928>>3]=+h[b+360>>3];h[j+4072>>3]=+h[b+368>>3];h[j+4112>>3]=+h[b+376>>3];j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[j+4136>>3]=+h[b+384>>3];h[j+4080>>3]=+h[b+392>>3];h[j+2832>>3]=+h[b+400>>3];h[j+2848>>3]=+h[b+408>>3];h[j+4952>>3]=+h[b+416>>3];h[j+2840>>3]=+h[b+424>>3];hv(f);iv(f);jv(f);kv(f);lv(f);mv(f);nv(f);ov(f);pv(f);qv(f);rv(f);sv(f);tv(f);uv(f);vv(f);wv(f);xv(f);yv(f);zv(f);Av(f);Bv(f);Cv(f);Dv(f);Ev(f);Fv(f);Gv(f);Hv(f);Iv(f);Jv(f);Kv(f);Lv(f);Mv(f);Nv(f);Ov(f);Pv(f);Qv(f);Rv(f);Sv(f);Tv(f);Uv(f);Vv(f);Wv(f);Xv(f);Yv(f);Zv(f);_v(f);$v(f);aw(f);bw(f);cw(f);dw(f);ew(f);fw(f);gw(f);hw(f);iw(f);jw(f);kw(f);lw(f);mw(f);nw(f);ow(f);pw(f);qw(f);rw(f);sw(f);tw(f);uw(f);vw(f);ww(f);xw(f);yw(f);zw(f);Aw(f);Bw(f);Cw(f);Dw(f);Ew(f);Fw(f);Gw(f);Hw(f);Iw(f);Jw(f);Kw(f);Lw(f);Mw(f);Nw(f);Ow(f);Pw(f);Qw(f);Rw(f);Sw(f);Tw(f);Uw(f);Vw(f);Ww(f);Xw(f);Yw(f);Zw(f);_w(f);$w(f);ax(f);bx(f);cx(f);dx(f);ex(f);fx(f);gx(f);hx(f);ix(f);jx(f);kx(f);lx(f);mx(f);nx(f);ox(f);px(f);qx(f);rx(f);sx(f);tx(f);ux(f);vx(f);wx(f);xx(f);yx(f);zx(f);Ax(f);Bx(f);Cx(f);Dx(f);Ex(f);Fx(f);Gx(f);Hx(f);Ix(f);Jx(f);Kx(f);Lx(f);Mx(f);Nx(f);Ox(f);Px(f);Qx(f);Rx(f);Sx(f);Tx(f);Ux(f);Vx(f);Wx(f);Xx(f);Yx(f);Zx(f);_x(f);$x(f);ay(f);by(f);cy(f);dy(f);ey(f);fy(f);gy(f);hy(f);iy(f);jy(f);ky(f);ly(f);my(f);ny(f);oy(f);py(f);qy(f);ry(f);sy(f);ty(f);uy(f);vy(f);wy(f);xy(f);yy(f);zy(f);Ay(f);By(f);Cy(f);Dy(f);Ey(f);Fy(f);Gy(f);Hy(f);Iy(f);Jy(f);Ky(f);Ly(f);My(f);Ny(f);Oy(f);Py(f);Qy(f);Ry(f);Sy(f);Ty(f);Uy(f);Vy(f);Wy(f);Xy(f);Yy(f);Zy(f);_y(f);$y(f);az(f);bz(f);cz(f);dz(f);ez(f);fz(f);gz(f);hz(f);iz(f);jz(f);kz(f);lz(f);mz(f);nz(f);oz(f);pz(f);qz(f);rz(f);sz(f);tz(f);uz(f);vz(f);wz(f);xz(f);yz(f);zz(f);Az(f);Bz(f);Cz(f);Dz(f);Ez(f);Fz(f);Gz(f);Hz(f);Iz(f);Jz(f);Kz(f);Lz(f);Mz(f);Nz(f);Oz(f);Pz(f);Qz(f);Rz(f);Sz(f);Tz(f);Uz(f);Vz(f);Wz(f);Xz(f);Yz(f);Zz(f);_z(f);$z(f);aA(f);bA(f);cA(f);dA(f);eA(f);fA(f);gA(f);hA(f);iA(f);jA(f);kA(f);lA(f);mA(f);nA(f);oA(f);pA(f);qA(f);rA(f);sA(f);tA(f);uA(f);vA(f);wA(f);xA(f);yA(f);zA(f);AA(f);BA(f);CA(f);DA(f);EA(f);FA(f);GA(f);HA(f);IA(f);JA(f);KA(f);LA(f);MA(f);NA(f);OA(f);PA(f);QA(f);RA(f);SA(f);TA(f);UA(f);VA(f);WA(f);XA(f);YA(f);ZA(f);_A(f);$A(f);aB(f);bB(f);cB(f);dB(f);eB(f);fB(f);gB(f);hB(f);iB(f);jB(f);kB(f);lB(f);mB(f);nB(f);oB(f);pB(f);qB(f);rB(f);sB(f);tB(f);uB(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+10656>>3]+(+h[f+3064>>3]- +h[f+280>>3]);h[d+8>>3]=+h[f+10648>>3]+(+h[f+3056>>3]- +h[f+272>>3]);h[d+16>>3]=+h[f+3952>>3]- +h[f+10640>>3];h[d+24>>3]=+h[f+3944>>3]- +h[f+10632>>3];h[d+32>>3]=+h[f+4640>>3]- +h[f+10624>>3];h[d+40>>3]=+h[f+4632>>3]- +h[f+10616>>3];h[d+48>>3]=+h[f+4656>>3]- +h[f+10608>>3];h[d+56>>3]=+h[f+4648>>3]- +h[f+10600>>3];h[d+64>>3]=+h[f+3936>>3]- +h[f+10592>>3];h[d+72>>3]=+h[f+3928>>3]- +h[f+10584>>3];h[d+80>>3]=+h[f+4672>>3]- +h[f+10576>>3];h[d+88>>3]=+h[f+4664>>3]- +h[f+10568>>3];h[d+96>>3]=+h[f+10560>>3]+(+h[f+3048>>3]- +h[f+264>>3]);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;b=f+256|0;h[d+104>>3]=+h[f+10552>>3]+(+h[f+3040>>3]- +h[b>>3]);h[d+112>>3]=+h[f+1216>>3]- +h[f+10544>>3];h[d+120>>3]=+h[f+1208>>3]- +h[f+10536>>3];h[d+128>>3]=+h[f+1328>>3]- +h[f+10528>>3];h[d+136>>3]=+h[f+1320>>3]- +h[f+10520>>3];h[d+144>>3]=+h[f+10512>>3]+(+h[f+280>>3]- +h[f+376>>3]);h[d+152>>3]=+h[f+10504>>3]+(+h[f+272>>3]- +h[f+368>>3]);h[d+160>>3]=+h[f+10496>>3]+(+h[f+264>>3]- +h[f+360>>3]);h[d+168>>3]=+h[f+10488>>3]+(+h[b>>3]- +h[f+352>>3]);h[d+176>>3]=+h[f+10480>>3]+(+h[f+248>>3]- +h[f+344>>3]);h[d+184>>3]=+h[f+10472>>3]+(+h[f+240>>3]- +h[f+336>>3]);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d+192>>3]=+h[f+1184>>3]- +h[f+10464>>3];h[d+200>>3]=+h[f+1176>>3]- +h[f+10456>>3];h[d+208>>3]=+h[f+1344>>3]- +h[f+10448>>3];h[d+216>>3]=+h[f+1336>>3]- +h[f+10440>>3];h[d+224>>3]=+h[f+10432>>3]+(+h[f+3032>>3]- +h[f+248>>3]);h[d+232>>3]=+h[f+10424>>3]+(+h[f+3024>>3]- +h[f+240>>3]);h[d+240>>3]=+h[f+1360>>3]- +h[f+10416>>3];h[d+248>>3]=+h[f+1352>>3]- +h[f+10408>>3];h[d+256>>3]=+h[f+1200>>3]- +h[f+10400>>3];h[d+264>>3]=+h[f+1192>>3]- +h[f+10392>>3];h[d+272>>3]=+h[f+408>>3]+(+h[f+72>>3]- +h[f+120>>3]);h[d+280>>3]=+h[f+2216>>3]- +h[f+10384>>3];h[d+288>>3]=+h[f+2208>>3]- +h[f+10376>>3];f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d+296>>3]=+h[f+2232>>3]- +h[f+10368>>3];h[d+304>>3]=+h[f+2224>>3]- +h[f+10360>>3];h[d+312>>3]=+h[f+2248>>3]- +h[f+10352>>3];h[d+320>>3]=+h[f+2240>>3]- +h[f+10344>>3];h[d+328>>3]=+h[f+288>>3]+(+h[f+2624>>3]- +h[f+48>>3]);h[d+336>>3]=+h[f+3920>>3]- +h[f+10336>>3];h[d+344>>3]=+h[f+3912>>3]- +h[f+10328>>3];h[d+352>>3]=+h[f+328>>3]+(+h[f+2616>>3]- +h[f+88>>3]);h[d+360>>3]=+h[f+320>>3]+(+h[f+2608>>3]- +h[f+80>>3]);h[d+368>>3]=+h[f+10320>>3]+(+h[f+3336>>3]- +h[f+456>>3]);h[d+376>>3]=+h[f+10312>>3]+(+h[f+3328>>3]- +h[f+448>>3]);h[d+384>>3]=+h[f+10304>>3]+(+h[f+3320>>3]- +h[f+440>>3]);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d+392>>3]=+h[f+10296>>3]+(+h[f+3312>>3]- +h[f+432>>3]);h[d+400>>3]=+h[f+10288>>3]+(+h[f+3352>>3]- +h[f+472>>3]);h[d+408>>3]=+h[f+10280>>3]+(+h[f+3344>>3]- +h[f+464>>3]);g=c[a+416>>2]|0;h[d+416>>3]=+h[f+496>>3]- +h[f+304>>3]*+h[g+1232>>3];h[d+424>>3]=+h[f+488>>3]- +h[f+392>>3]*+h[g+1224>>3];i=e;return}function xB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+304>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7104>>3],-+h[j+7096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7184>>3]=l;h[e+7176>>3]=m;i=b;return}function yB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+304>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7104>>3],-+h[j+7096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7216>>3]=l;h[e+7208>>3]=m;i=b;return}function zB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+304>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7104>>3],-+h[j+7096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7200>>3]=l;h[e+7192>>3]=m;i=b;return}function AB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+292>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7120>>3],-+h[j+7112>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7264>>3]=l;h[e+7256>>3]=m;i=b;return}function BB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7168>>3]=+h[b+7456>>3]- +h[b+7216>>3]- +h[b+7264>>3];i=i;return}function CB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7160>>3]=+h[b+7448>>3]- +h[b+7208>>3]- +h[b+7256>>3];i=i;return}function DB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+292>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7120>>3],-+h[j+7112>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7248>>3]=l;h[e+7240>>3]=m;i=b;return}function EB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7152>>3]=+h[b+7440>>3]- +h[b+7200>>3]- +h[b+7248>>3];i=i;return}function FB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7144>>3]=+h[b+7432>>3]- +h[b+7192>>3]- +h[b+7240>>3];i=i;return}function GB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+292>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7120>>3],-+h[j+7112>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7232>>3]=l;h[e+7224>>3]=m;i=b;return}function HB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7136>>3]=+h[b+7424>>3]- +h[b+7184>>3]- +h[b+7232>>3];i=i;return}function IB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7128>>3]=+h[b+7416>>3]- +h[b+7176>>3]- +h[b+7224>>3];i=i;return}function JB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+316>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7088>>3],-+h[j+7080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10272>>3]=l;h[e+10264>>3]=m;i=b;return}function KB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+316>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7088>>3],-+h[j+7080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10256>>3]=l;h[e+10248>>3]=m;i=b;return}function LB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+316>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7088>>3],-+h[j+7080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10240>>3]=l;h[e+10232>>3]=m;i=b;return}function MB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+99200>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+99176>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+99184>>3];h[a+8>>3]=+h[d+99536>>3];h[e+8>>3]=+h[d+99512>>3];h[f+8>>3]=+h[d+99520>>3];h[a+16>>3]=+h[d+99648>>3];h[e+16>>3]=+h[d+99624>>3];h[f+16>>3]=+h[d+99632>>3];h[a+24>>3]=+h[d+99312>>3];h[e+24>>3]=+h[d+99288>>3];h[f+24>>3]=+h[d+99296>>3];h[a+32>>3]=+h[d+99424>>3];h[e+32>>3]=+h[d+99400>>3];h[f+32>>3]=+h[d+99408>>3];h[a+40>>3]=+h[d+99760>>3];h[e+40>>3]=+h[d+99736>>3];h[f+40>>3]=+h[d+99744>>3];i=i;return}function NB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+7080>>3]=+h[b>>3];h[a+7104>>3]=+h[b+8>>3];h[a+7112>>3]=+h[b+16>>3];h[a+7088>>3]=+h[b+24>>3];h[a+7096>>3]=+h[b+32>>3];h[a+7120>>3]=+h[b+40>>3];xB(f);yB(f);zB(f);AB(f);BB(f);CB(f);DB(f);EB(f);FB(f);GB(f);HB(f);IB(f);JB(f);KB(f);LB(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+7152>>3]- +h[f+10272>>3];h[d+8>>3]=+h[f+7144>>3]- +h[f+10264>>3];h[d+16>>3]=+h[f+7168>>3]- +h[f+10256>>3];h[d+24>>3]=+h[f+7160>>3]- +h[f+10248>>3];h[d+32>>3]=+h[f+7136>>3]- +h[f+10240>>3];h[d+40>>3]=+h[f+7128>>3]- +h[f+10232>>3];i=e;return}function OB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+184>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7600>>3],-+h[j+7592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7856>>3]=l;h[e+7848>>3]=m;i=b;return}function PB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+196>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7568>>3],-+h[j+7560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7808>>3]=l;h[e+7800>>3]=m;i=b;return}function QB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7760>>3]=-+h[b+7808>>3]- +h[b+7472>>3]- +h[b+7856>>3];i=i;return}function RB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7752>>3]=-+h[b+7800>>3]- +h[b+7464>>3]- +h[b+7848>>3];i=i;return}function SB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+196>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7568>>3],-+h[j+7560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7824>>3]=l;h[e+7816>>3]=m;i=b;return}function TB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+184>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7600>>3],-+h[j+7592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7888>>3]=l;h[e+7880>>3]=m;i=b;return}function UB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+184>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7600>>3],-+h[j+7592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7872>>3]=l;h[e+7864>>3]=m;i=b;return}function VB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7776>>3]=-+h[b+7824>>3]- +h[b+7488>>3]- +h[b+7872>>3];i=i;return}function WB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7768>>3]=-+h[b+7816>>3]- +h[b+7480>>3]- +h[b+7864>>3];i=i;return}function XB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+196>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7568>>3],-+h[j+7560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7840>>3]=l;h[e+7832>>3]=m;i=b;return}function YB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7792>>3]=-+h[b+7840>>3]- +h[b+7504>>3]- +h[b+7888>>3];i=i;return}function ZB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7784>>3]=-+h[b+7832>>3]- +h[b+7496>>3]- +h[b+7880>>3];i=i;return}function _B(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+208>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7536>>3],-+h[j+7528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10224>>3]=l;h[e+10216>>3]=m;i=b;return}function $B(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+208>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7536>>3],-+h[j+7528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10208>>3]=l;h[e+10200>>3]=m;i=b;return}function aC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+208>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7536>>3],-+h[j+7528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10192>>3]=l;h[e+10184>>3]=m;i=b;return}function bC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+105472>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+105448>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+105456>>3];h[a+8>>3]=+h[d+106480>>3];h[e+8>>3]=+h[d+106456>>3];h[f+8>>3]=+h[d+106464>>3];h[a+16>>3]=+h[d+106032>>3];h[e+16>>3]=+h[d+106008>>3];h[f+16>>3]=+h[d+106016>>3];h[a+24>>3]=+h[d+105584>>3];h[e+24>>3]=+h[d+105560>>3];h[f+24>>3]=+h[d+105568>>3];h[a+32>>3]=+h[d+106368>>3];h[e+32>>3]=+h[d+106344>>3];h[f+32>>3]=+h[d+106352>>3];h[a+40>>3]=+h[d+105920>>3];h[e+40>>3]=+h[d+105896>>3];h[f+40>>3]=+h[d+105904>>3];i=i;return}function cC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+7528>>3]=+h[b>>3];h[a+7600>>3]=+h[b+8>>3];h[a+7568>>3]=+h[b+16>>3];h[a+7536>>3]=+h[b+24>>3];h[a+7592>>3]=+h[b+32>>3];h[a+7560>>3]=+h[b+40>>3];OB(f);PB(f);QB(f);RB(f);SB(f);TB(f);UB(f);VB(f);WB(f);XB(f);YB(f);ZB(f);_B(f);$B(f);aC(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+7792>>3]- +h[f+10224>>3];h[d+8>>3]=+h[f+7784>>3]- +h[f+10216>>3];h[d+16>>3]=+h[f+7776>>3]- +h[f+10208>>3];h[d+24>>3]=+h[f+7768>>3]- +h[f+10200>>3];h[d+32>>3]=+h[f+7760>>3]- +h[f+10192>>3];h[d+40>>3]=+h[f+7752>>3]- +h[f+10184>>3];i=e;return}function dC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+16>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+8592>>3],+h[j+8584>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8816>>3]=l;h[e+8808>>3]=m;i=b;return}function eC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+4>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+8608>>3],+h[j+8600>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8880>>3]=l;h[e+8872>>3]=m;i=b;return}function fC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+4>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+8608>>3],+h[j+8600>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8864>>3]=l;h[e+8856>>3]=m;i=b;return}function gC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8760>>3]=+h[b+8952>>3]- +h[b+8808>>3]- +h[b+8856>>3];i=i;return}function hC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8768>>3]=+h[b+8960>>3]- +h[b+8816>>3]- +h[b+8864>>3];i=i;return}function iC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+16>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+8592>>3],+h[j+8584>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8832>>3]=l;h[e+8824>>3]=m;i=b;return}function jC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8776>>3]=+h[b+8968>>3]- +h[b+8824>>3]- +h[b+8872>>3];i=i;return}function kC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+16>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+8592>>3],+h[j+8584>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8848>>3]=l;h[e+8840>>3]=m;i=b;return}function lC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8784>>3]=+h[b+8976>>3]- +h[b+8832>>3]- +h[b+8880>>3];i=i;return}function mC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+4>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+8608>>3],+h[j+8600>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8896>>3]=l;h[e+8888>>3]=m;i=b;return}function nC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8792>>3]=+h[b+8984>>3]- +h[b+8840>>3]- +h[b+8888>>3];i=i;return}function oC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8800>>3]=+h[b+8992>>3]- +h[b+8848>>3]- +h[b+8896>>3];i=i;return}function pC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+28>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+8576>>3],+h[j+8568>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10160>>3]=l;h[e+10152>>3]=m;i=b;return}function qC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+28>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+8576>>3],+h[j+8568>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10144>>3]=l;h[e+10136>>3]=m;i=b;return}function rC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+28>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+8576>>3],+h[j+8568>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10128>>3]=l;h[e+10120>>3]=m;i=b;return}function sC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+120144>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+120120>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+120128>>3];h[a+8>>3]=+h[d+120592>>3];h[e+8>>3]=+h[d+120568>>3];h[f+8>>3]=+h[d+120576>>3];h[a+16>>3]=+h[d+120368>>3];h[e+16>>3]=+h[d+120344>>3];h[f+16>>3]=+h[d+120352>>3];h[a+24>>3]=+h[d+120256>>3];h[e+24>>3]=+h[d+120232>>3];h[f+24>>3]=+h[d+120240>>3];h[a+32>>3]=+h[d+120032>>3];h[e+32>>3]=+h[d+120008>>3];h[f+32>>3]=+h[d+120016>>3];h[a+40>>3]=+h[d+120480>>3];h[e+40>>3]=+h[d+120456>>3];h[f+40>>3]=+h[d+120464>>3];i=i;return}function tC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+8576>>3]=+h[b>>3];h[a+8608>>3]=+h[b+8>>3];h[a+8592>>3]=+h[b+16>>3];h[a+8584>>3]=+h[b+24>>3];h[a+8568>>3]=+h[b+32>>3];h[a+8600>>3]=+h[b+40>>3];dC(f);eC(f);fC(f);gC(f);hC(f);iC(f);jC(f);kC(f);lC(f);mC(f);nC(f);oC(f);pC(f);qC(f);rC(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+8800>>3]- +h[f+10160>>3];h[d+8>>3]=+h[f+8792>>3]- +h[f+10152>>3];h[d+16>>3]=+h[f+8784>>3]- +h[f+10144>>3];h[d+24>>3]=+h[f+8776>>3]- +h[f+10136>>3];h[d+32>>3]=+h[f+8768>>3]- +h[f+10128>>3];h[d+40>>3]=+h[f+8760>>3]- +h[f+10120>>3];i=e;return}function uC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+88>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8496>>3],-+h[j+8488>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8384>>3]=l;h[e+8376>>3]=m;i=b;return}function vC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+88>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8496>>3],-+h[j+8488>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8400>>3]=l;h[e+8392>>3]=m;i=b;return}function wC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+76>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8512>>3],-+h[j+8504>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8432>>3]=l;h[e+8424>>3]=m;i=b;return}function xC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8328>>3]=+h[b+8520>>3]- +h[b+8376>>3]- +h[b+8424>>3];i=i;return}function yC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+76>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8512>>3],-+h[j+8504>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8464>>3]=l;h[e+8456>>3]=m;i=b;return}function zC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+88>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8496>>3],-+h[j+8488>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8416>>3]=l;h[e+8408>>3]=m;i=b;return}function AC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8360>>3]=+h[b+8552>>3]- +h[b+8408>>3]- +h[b+8456>>3];i=i;return}function BC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8368>>3]=+h[b+8560>>3]- +h[b+8416>>3]- +h[b+8464>>3];i=i;return}function CC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+76>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8512>>3],-+h[j+8504>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8448>>3]=l;h[e+8440>>3]=m;i=b;return}function DC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8352>>3]=+h[b+8544>>3]- +h[b+8400>>3]- +h[b+8448>>3];i=i;return}function EC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8344>>3]=+h[b+8536>>3]- +h[b+8392>>3]- +h[b+8440>>3];i=i;return}function FC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8336>>3]=+h[b+8528>>3]- +h[b+8384>>3]- +h[b+8432>>3];i=i;return}function GC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+100>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8480>>3],-+h[j+8472>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10112>>3]=l;h[e+10104>>3]=m;i=b;return}function HC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+100>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8480>>3],-+h[j+8472>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10096>>3]=l;h[e+10088>>3]=m;i=b;return}function IC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+100>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8480>>3],-+h[j+8472>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10080>>3]=l;h[e+10072>>3]=m;i=b;return}function JC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+118688>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+118664>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+118672>>3];h[a+8>>3]=+h[d+119024>>3];h[e+8>>3]=+h[d+119e3>>3];h[f+8>>3]=+h[d+119008>>3];h[a+16>>3]=+h[d+119248>>3];h[e+16>>3]=+h[d+119224>>3];h[f+16>>3]=+h[d+119232>>3];h[a+24>>3]=+h[d+118912>>3];h[e+24>>3]=+h[d+118888>>3];h[f+24>>3]=+h[d+118896>>3];h[a+32>>3]=+h[d+118800>>3];h[e+32>>3]=+h[d+118776>>3];h[f+32>>3]=+h[d+118784>>3];h[a+40>>3]=+h[d+119136>>3];h[e+40>>3]=+h[d+119112>>3];h[f+40>>3]=+h[d+119120>>3];i=i;return}function KC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+8472>>3]=+h[b>>3];h[a+8496>>3]=+h[b+8>>3];h[a+8512>>3]=+h[b+16>>3];h[a+8488>>3]=+h[b+24>>3];h[a+8480>>3]=+h[b+32>>3];h[a+8504>>3]=+h[b+40>>3];uC(f);vC(f);wC(f);xC(f);yC(f);zC(f);AC(f);BC(f);CC(f);DC(f);EC(f);FC(f);GC(f);HC(f);IC(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+8352>>3]- +h[f+10112>>3];h[d+8>>3]=+h[f+8344>>3]- +h[f+10104>>3];h[d+16>>3]=+h[f+8368>>3]- +h[f+10096>>3];h[d+24>>3]=+h[f+8360>>3]- +h[f+10088>>3];h[d+32>>3]=+h[f+8336>>3]- +h[f+10080>>3];h[d+40>>3]=+h[f+8328>>3]- +h[f+10072>>3];i=e;return}function LC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+928>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3512>>3],-+h[j+3504>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3368>>3]=l;h[e+3360>>3]=m;i=b;return}function MC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+904>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3544>>3],-+h[j+3536>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3480>>3]=l;h[e+3472>>3]=m;i=b;return}function NC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+904>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3544>>3],-+h[j+3536>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3464>>3]=l;h[e+3456>>3]=m;i=b;return}function OC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3416>>3]=+h[b+3560>>3]- +h[b+3368>>3]- +h[b+3464>>3];i=i;return}function PC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+904>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3544>>3],-+h[j+3536>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3496>>3]=l;h[e+3488>>3]=m;i=b;return}function QC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+928>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3512>>3],-+h[j+3504>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3384>>3]=l;h[e+3376>>3]=m;i=b;return}function RC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3432>>3]=+h[b+3576>>3]- +h[b+3384>>3]- +h[b+3480>>3];i=i;return}function SC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3424>>3]=+h[b+3568>>3]- +h[b+3376>>3]- +h[b+3472>>3];i=i;return}function TC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+928>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3512>>3],-+h[j+3504>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3400>>3]=l;h[e+3392>>3]=m;i=b;return}function UC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3448>>3]=+h[b+3592>>3]- +h[b+3400>>3]- +h[b+3496>>3];i=i;return}function VC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3440>>3]=+h[b+3584>>3]- +h[b+3392>>3]- +h[b+3488>>3];i=i;return}function WC(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3408>>3]=+h[b+3552>>3]- +h[b+3360>>3]- +h[b+3456>>3];i=i;return}function XC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+916>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3528>>3],-+h[j+3520>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10064>>3]=l;h[e+10056>>3]=m;i=b;return}function YC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+916>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3528>>3],-+h[j+3520>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10048>>3]=l;h[e+10040>>3]=m;i=b;return}function ZC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+916>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3528>>3],-+h[j+3520>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10032>>3]=l;h[e+10024>>3]=m;i=b;return}function _C(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+49472>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+49448>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+49456>>3];h[a+8>>3]=+h[d+49360>>3];h[e+8>>3]=+h[d+49336>>3];h[f+8>>3]=+h[d+49344>>3];h[a+16>>3]=+h[d+49584>>3];h[e+16>>3]=+h[d+49560>>3];h[f+16>>3]=+h[d+49568>>3];h[a+24>>3]=+h[d+49248>>3];h[e+24>>3]=+h[d+49224>>3];h[f+24>>3]=+h[d+49232>>3];h[a+32>>3]=+h[d+49136>>3];h[e+32>>3]=+h[d+49112>>3];h[f+32>>3]=+h[d+49120>>3];h[a+40>>3]=+h[d+49696>>3];h[e+40>>3]=+h[d+49672>>3];h[f+40>>3]=+h[d+49680>>3];i=i;return}function $C(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+3528>>3]=+h[b>>3];h[a+3520>>3]=+h[b+8>>3];h[a+3536>>3]=+h[b+16>>3];h[a+3512>>3]=+h[b+24>>3];h[a+3504>>3]=+h[b+32>>3];h[a+3544>>3]=+h[b+40>>3];LC(f);MC(f);NC(f);OC(f);PC(f);QC(f);RC(f);SC(f);TC(f);UC(f);VC(f);WC(f);XC(f);YC(f);ZC(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+3448>>3]- +h[f+10064>>3];h[d+8>>3]=+h[f+3440>>3]- +h[f+10056>>3];h[d+16>>3]=+h[f+3432>>3]- +h[f+10048>>3];h[d+24>>3]=+h[f+3424>>3]- +h[f+10040>>3];h[d+32>>3]=+h[f+3416>>3]- +h[f+10032>>3];h[d+40>>3]=+h[f+3408>>3]- +h[f+10024>>3];i=e;return}function aD(a){a=a|0;c[a+4>>2]=196;c[a>>2]=6;c[a+56>>2]=0;c[a+32>>2]=19;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=-1;c[a+36>>2]=43;c[a+84>>2]=625;c[a+80>>2]=64;c[a+136>>2]=0;c[a+112>>2]=20;c[a+100>>2]=0;c[a+104>>2]=0;c[a+108>>2]=-1;c[a+116>>2]=44;c[a+164>>2]=727;c[a+160>>2]=6;c[a+216>>2]=0;c[a+192>>2]=21;c[a+180>>2]=0;c[a+184>>2]=0;c[a+188>>2]=-1;c[a+196>>2]=45;c[a+244>>2]=790;c[a+240>>2]=6;c[a+296>>2]=0;c[a+272>>2]=22;c[a+260>>2]=0;c[a+264>>2]=0;c[a+268>>2]=-1;c[a+276>>2]=46;c[a+324>>2]=848;c[a+320>>2]=6;c[a+376>>2]=0;c[a+352>>2]=23;c[a+340>>2]=0;c[a+344>>2]=0;c[a+348>>2]=-1;c[a+356>>2]=47;c[a+404>>2]=906;c[a+400>>2]=6;c[a+456>>2]=0;c[a+432>>2]=24;c[a+420>>2]=0;c[a+424>>2]=0;c[a+428>>2]=-1;c[a+436>>2]=48;c[a+484>>2]=974;c[a+480>>2]=6;c[a+536>>2]=0;c[a+512>>2]=25;c[a+500>>2]=0;c[a+504>>2]=0;c[a+508>>2]=-1;c[a+516>>2]=49;c[a+564>>2]=1017;c[a+560>>2]=6;c[a+616>>2]=0;c[a+592>>2]=26;c[a+580>>2]=0;c[a+584>>2]=0;c[a+588>>2]=-1;c[a+596>>2]=50;c[a+644>>2]=1208;c[a+640>>2]=6;c[a+696>>2]=0;c[a+672>>2]=27;c[a+660>>2]=0;c[a+664>>2]=0;c[a+668>>2]=-1;c[a+676>>2]=51;c[a+724>>2]=1275;c[a+720>>2]=6;c[a+776>>2]=0;c[a+752>>2]=28;c[a+740>>2]=0;c[a+744>>2]=0;c[a+748>>2]=-1;c[a+756>>2]=52;c[a+804>>2]=1716;c[a+800>>2]=54;c[a+856>>2]=0;c[a+832>>2]=29;c[a+820>>2]=0;c[a+824>>2]=0;c[a+828>>2]=-1;c[a+836>>2]=53;c[a+884>>2]=1786;c[a+880>>2]=6;c[a+936>>2]=0;c[a+912>>2]=30;c[a+900>>2]=0;c[a+904>>2]=0;c[a+908>>2]=-1;c[a+916>>2]=54;c[a+964>>2]=1829;c[a+960>>2]=6;c[a+1016>>2]=0;c[a+992>>2]=31;c[a+980>>2]=0;c[a+984>>2]=0;c[a+988>>2]=-1;c[a+996>>2]=55;c[a+1044>>2]=1881;c[a+1040>>2]=6;c[a+1096>>2]=0;c[a+1072>>2]=32;c[a+1060>>2]=0;c[a+1064>>2]=0;c[a+1068>>2]=-1;c[a+1076>>2]=56;c[a+1124>>2]=1924;c[a+1120>>2]=6;c[a+1176>>2]=0;c[a+1152>>2]=33;c[a+1140>>2]=0;c[a+1144>>2]=0;c[a+1148>>2]=-1;c[a+1156>>2]=57;c[a+1204>>2]=1991;c[a+1200>>2]=6;c[a+1256>>2]=0;c[a+1232>>2]=34;c[a+1220>>2]=0;c[a+1224>>2]=0;c[a+1228>>2]=-1;c[a+1236>>2]=58;i=i;return}function bD(a){a=a|0;i=i;return}function cD(a,b){a=a|0;b=b|0;i=i;return}function dD(a){a=a|0;i=i;return}function eD(a,b){a=a|0;b=b|0;c[b>>2]=0;i=i;return 2032}function fD(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return 0}function gD(a){a=a|0;i=i;return 2032}function hD(a,b){a=a|0;b=b|0;i=i;return 0}function iD(a){a=a|0;a=i;i=i+8|0;V1(8,1,2040,a);if((c[70920>>2]|0)==0){i=a;return 0}Zd[c[17860]&1023](8);i=a;return 0}function jD(a){a=a|0;i=i;return c[2216+(a<<2)>>2]|0}function kD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+16|0;j=i;i=i+8|0;V1(21,1,2232,j);j=a+4|0;l=+h[c[(c[c[j>>2]>>2]|0)+8>>2]>>3];h[b>>3]=l;a=jD(0)|0;c[g>>2]=1;c[g+4>>2]=a;a=g+8|0;h[k>>3]=l;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];V1(21,0,2264,g);l=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+16>>3];h[b+8>>3]=l;g=jD(1)|0;c[f>>2]=2;c[f+4>>2]=g;g=f+8|0;h[k>>3]=l;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];V1(21,0,2264,f);l=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8>>3];h[b+16>>3]=l;b=jD(2)|0;c[e>>2]=3;c[e+4>>2]=b;b=e+8|0;h[k>>3]=l;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];V1(21,0,2264,e);if((c[70972>>2]|0)==0){i=d;return 0}Zd[c[17860]&1023](21);i=d;return 0}function lD(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1144>>3];j=g*(+h[f+1136>>3]+-293.15)+1.0;do{if(j!=0.0){k=f;l=g/j}else{if(g==0.0){k=f;l=g;break}m=g/+$1(c[b+536>>2]|0,j,2288,2280,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+760>>3]=l;i=d;return}function mD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+856>>3]=+h[b+760>>3];i=i;return}function nD(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1144>>3];j=g*(+h[f+1136>>3]+-293.15)+1.0;do{if(j!=0.0){k=f;l=g/j}else{if(g==0.0){k=f;l=g;break}m=g/+$1(c[b+536>>2]|0,j,2288,2352,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+752>>3]=l;i=d;return}function oD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+824>>3]=+h[b+752>>3];i=i;return}function pD(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1144>>3];j=g*(+h[f+1136>>3]+-293.15)+1.0;do{if(j!=0.0){k=f;l=g/j}else{if(g==0.0){k=f;l=g;break}m=g/+$1(c[b+536>>2]|0,j,2288,2360,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+744>>3]=l;i=d;return}function qD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+792>>3]=+h[b+744>>3];i=i;return}function rD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+736>>3]=+h[b+1136>>3];i=i;return}function sD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+848>>3]=+h[b+736>>3];i=i;return}function tD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+728>>3]=+h[b+1136>>3];i=i;return}function uD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+816>>3]=+h[b+728>>3];i=i;return}function vD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+720>>3]=+h[b+1136>>3];i=i;return}function wD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+784>>3]=+h[b+720>>3];i=i;return}function xD(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1112>>3];j=g*(+h[f+1104>>3]+-293.15)+1.0;do{if(j!=0.0){k=f;l=g/j}else{if(g==0.0){k=f;l=g;break}m=g/+$1(c[b+536>>2]|0,j,2376,2368,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+520>>3]=l;i=d;return}function yD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+616>>3]=+h[b+520>>3];i=i;return}function zD(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1112>>3];j=g*(+h[f+1104>>3]+-293.15)+1.0;do{if(j!=0.0){k=f;l=g/j}else{if(g==0.0){k=f;l=g;break}m=g/+$1(c[b+536>>2]|0,j,2376,2440,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+512>>3]=l;i=d;return}function AD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+584>>3]=+h[b+512>>3];i=i;return}function BD(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1112>>3];j=g*(+h[f+1104>>3]+-293.15)+1.0;do{if(j!=0.0){k=f;l=g/j}else{if(g==0.0){k=f;l=g;break}m=g/+$1(c[b+536>>2]|0,j,2376,2448,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+504>>3]=l;i=d;return}



function CD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+552>>3]=+h[b+504>>3];i=i;return}function DD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+496>>3]=+h[b+1104>>3];i=i;return}function ED(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+608>>3]=+h[b+496>>3];i=i;return}function FD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+488>>3]=+h[b+1104>>3];i=i;return}function GD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+576>>3]=+h[b+488>>3];i=i;return}function HD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+480>>3]=+h[b+1104>>3];i=i;return}function ID(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+544>>3]=+h[b+480>>3];i=i;return}function JD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1184>>3]=+h[b+1160>>3];i=i;return}function KD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1208>>3]=+h[b+1184>>3];i=i;return}function LD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1216>>3]=+h[b+1184>>3];i=i;return}function MD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1064>>3]=+h[b+992>>3]/3.0e4*.5;i=i;return}function ND(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0,w=0,x=0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+1064>>3];m=.0006250000000000001-l*l;if(!(m>=0.0)){n=c[30092]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=2624;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ae[p&63](o,e,2472,f);r=c[g>>2]|0}else{r=j}l=+h[r+952>>3]*6.283185307179586;s=+V(+m);if(l!=0.0){t=r;u=s/l;v=t;w=v+1080|0;x=w;h[x>>3]=u;i=d;return}if(s==0.0){t=r;u=s;v=t;w=v+1080|0;x=w;h[x>>3]=u;i=d;return}m=s/+$1(c[b+536>>2]|0,l,2576,2456,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);t=c[g>>2]|0;u=m;v=t;w=v+1080|0;x=w;h[x>>3]=u;i=d;return}function OD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1152>>3]=+h[b+1080>>3];i=i;return}function PD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+864>>3]=+h[b+1152>>3];i=i;return}function QD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+888>>3]=+h[b+864>>3];i=i;return}function RD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+872>>3]=+h[b+1152>>3];i=i;return}function SD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+896>>3]=+h[b+872>>3];i=i;return}function TD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+880>>3]=+h[b+1152>>3];i=i;return}function UD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+904>>3]=+h[b+880>>3];i=i;return}function VD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1128>>3]=+h[b+1064>>3];i=i;return}function WD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+696>>3]=+h[b+1128>>3];i=i;return}function XD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+776>>3]=+h[b+696>>3];i=i;return}function YD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+704>>3]=+h[b+1128>>3];i=i;return}function ZD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+808>>3]=+h[b+704>>3];i=i;return}function _D(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+712>>3]=+h[b+1128>>3];i=i;return}function $D(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+840>>3]=+h[b+712>>3];i=i;return}function aE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1048>>3]=+h[b+992>>3]/89999.99999999997*.5;i=i;return}function bE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0,w=0,x=0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+1048>>3];m=694444444444445.0e-19-l*l;if(!(m>=0.0)){n=c[30092]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=2624;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ae[p&63](o,e,2648,f);r=c[g>>2]|0}else{r=j}l=+h[r+952>>3]*6.283185307179586;s=+V(+m);if(l!=0.0){t=r;u=s/l;v=t;w=v+1072|0;x=w;h[x>>3]=u;i=d;return}if(s==0.0){t=r;u=s;v=t;w=v+1072|0;x=w;h[x>>3]=u;i=d;return}m=s/+$1(c[b+536>>2]|0,l,2576,2616,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);t=c[g>>2]|0;u=m;v=t;w=v+1072|0;x=w;h[x>>3]=u;i=d;return}function cE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1120>>3]=+h[b+1072>>3];i=i;return}function dE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+624>>3]=+h[b+1120>>3];i=i;return}function eE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+648>>3]=+h[b+624>>3];i=i;return}function fE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+632>>3]=+h[b+1120>>3];i=i;return}function gE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+656>>3]=+h[b+632>>3];i=i;return}function hE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+640>>3]=+h[b+1120>>3];i=i;return}function iE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+664>>3]=+h[b+640>>3];i=i;return}function jE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1096>>3]=+h[b+1048>>3];i=i;return}function kE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+456>>3]=+h[b+1096>>3];i=i;return}function lE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+536>>3]=+h[b+456>>3];i=i;return}function mE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+464>>3]=+h[b+1096>>3];i=i;return}function nE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+568>>3]=+h[b+464>>3];i=i;return}function oE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+472>>3]=+h[b+1096>>3];i=i;return}function pE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+600>>3]=+h[b+472>>3];i=i;return}function qE(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+968>>3];j=+h[f+960>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+$1(c[b+536>>2]|0,g,2760,2752,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1016>>3]=l;i=d;return}function rE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1088>>3]=+h[b+1016>>3];i=i;return}function sE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1176>>3]=+h[b+1088>>3]*1.154700538379252;i=i;return}function tE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1224>>3]=+h[b+1176>>3];i=i;return}function uE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1232>>3]=+h[b+1176>>3];i=i;return}function vE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+424>>3]=+h[b+328>>3];i=i;return}function wE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+416>>3]=+h[b+304>>3];i=i;return}function xE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+392>>3]=+h[b+320>>3];i=i;return}function yE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+384>>3]=+h[b+296>>3];i=i;return}function zE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+360>>3]=+h[b+312>>3];i=i;return}function AE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+352>>3]=+h[b+288>>3];i=i;return}function BE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+280>>3]=+h[b+16>>3];i=i;return}function CE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+408>>3]=+h[b+280>>3];i=i;return}function DE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+272>>3]=+h[b+8>>3];i=i;return}function EE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+376>>3]=+h[b+272>>3];i=i;return}function FE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+264>>3]=+h[b>>3];i=i;return}function GE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+344>>3]=+h[b+264>>3];i=i;return}function HE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+256>>3]=+h[b+304>>3];i=i;return}function IE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+400>>3]=+h[b+256>>3];i=i;return}function JE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+248>>3]=+h[b+296>>3];i=i;return}function KE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+368>>3]=+h[b+248>>3];i=i;return}function LE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+240>>3]=+h[b+288>>3];i=i;return}function ME(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+336>>3]=+h[b+240>>3];i=i;return}function NE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+128>>3]=+h[b+40>>3];i=i;return}function OE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+104>>3]=+h[b+32>>3];i=i;return}function PE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+80>>3]=+h[b+24>>3];i=i;return}function QE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+72>>3]=+h[b+912>>3];i=i;return}function RE(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;i=i+32|0;d=b;e=b+16|0;Yl(d,c[a+536>>2]|0,3);m3(d,e);f=+$2(e,2);h[(c[a+416>>2]|0)+64>>3]=f;i=b;return}function SE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+136>>3]=+h[b+64>>3];i=i;return}function TE(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;i=i+32|0;d=b;e=b+16|0;Yl(d,c[a+536>>2]|0,3);m3(d,e);f=+$2(e,1);h[(c[a+416>>2]|0)+56>>3]=f;i=b;return}function UE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+112>>3]=+h[b+56>>3];i=i;return}function VE(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;i=i+32|0;d=b;e=b+16|0;Yl(d,c[a+536>>2]|0,3);m3(d,e);f=+$2(e,0);h[(c[a+416>>2]|0)+48>>3]=f;i=b;return}function WE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+88>>3]=+h[b+48>>3];i=i;return}function XE(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+Y(+(+h[b+136>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9376>>3]=d*+h[b+128>>3];i=i;return}function YE(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+X(+(+h[b+136>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9368>>3]=d*+h[b+128>>3];i=i;return}function ZE(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+Y(+(+h[b+112>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9360>>3]=d*+h[b+104>>3];i=i;return}function _E(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+X(+(+h[b+112>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9352>>3]=d*+h[b+104>>3];i=i;return}function $E(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+Y(+(+h[b+88>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9344>>3]=d*+h[b+80>>3];i=i;return}function aF(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+X(+(+h[b+88>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9336>>3]=d*+h[b+80>>3];i=i;return}function bF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9328>>3]=+h[(c[a+416>>2]|0)+72>>3]*6.283185307179586;i=i;return}function cF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9320>>3]=+h[b+344>>3]*(+h[b+360>>3]*(+h[b+336>>3]- +h[b+352>>3])+1.0);i=i;return}function dF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9312>>3]=+h[b+376>>3]*(+h[b+392>>3]*(+h[b+368>>3]- +h[b+384>>3])+1.0);i=i;return}function eF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9304>>3]=+h[b+408>>3]*(+h[b+424>>3]*(+h[b+400>>3]- +h[b+416>>3])+1.0);i=i;return}function fF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9296>>3]=+h[b+536>>3]*(+h[b+552>>3]*(+h[b+1208>>3]- +h[b+544>>3])+1.0);i=i;return}function gF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9288>>3]=+h[b+568>>3]*(+h[b+584>>3]*(+h[b+1208>>3]- +h[b+576>>3])+1.0);i=i;return}function hF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9280>>3]=+h[b+600>>3]*(+h[b+616>>3]*(+h[b+1208>>3]- +h[b+608>>3])+1.0);i=i;return}function iF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9272>>3]=+h[b+776>>3]*(+h[b+792>>3]*(+h[b+1216>>3]- +h[b+784>>3])+1.0);i=i;return}function jF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9264>>3]=+h[b+808>>3]*(+h[b+824>>3]*(+h[b+1216>>3]- +h[b+816>>3])+1.0);i=i;return}function kF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9256>>3]=+h[b+840>>3]*(+h[b+856>>3]*(+h[b+1216>>3]- +h[b+848>>3])+1.0);i=i;return}function lF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9200>>3]=+h[b+9368>>3]- +h[b+9352>>3];i=i;return}function mF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9192>>3]=+h[b+9376>>3]- +h[b+9360>>3];i=i;return}function nF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9184>>3]=+h[b+9352>>3]- +h[b+9336>>3];i=i;return}function oF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9176>>3]=+h[b+9360>>3]- +h[b+9344>>3];i=i;return}function pF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9168>>3]=+h[b+9336>>3]- +h[b+9368>>3];i=i;return}function qF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9160>>3]=+h[b+9344>>3]- +h[b+9376>>3];i=i;return}function rF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9152>>3]=+h[b+9368>>3]- +h[b+9352>>3];i=i;return}function sF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9144>>3]=+h[b+9376>>3]- +h[b+9360>>3];i=i;return}function tF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9136>>3]=+h[b+9352>>3]- +h[b+9336>>3];i=i;return}function uF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9128>>3]=+h[b+9360>>3]- +h[b+9344>>3];i=i;return}function vF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9120>>3]=+h[b+9336>>3]- +h[b+9368>>3];i=i;return}function wF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9112>>3]=+h[b+9344>>3]- +h[b+9376>>3];i=i;return}function xF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9040>>3]=+ba(+(+h[b+9144>>3]),+(+h[b+9152>>3]));i=i;return}function yF(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+9152>>3];e=+h[b+9144>>3];h[b+9032>>3]=+V(+(d*d+e*e));i=i;return}function zF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9024>>3]=+ba(+(+h[b+9128>>3]),+(+h[b+9136>>3]));i=i;return}function AF(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+9136>>3];e=+h[b+9128>>3];h[b+9016>>3]=+V(+(d*d+e*e));i=i;return}function BF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9008>>3]=+ba(+(+h[b+9112>>3]),+(+h[b+9120>>3]));i=i;return}function CF(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+9120>>3];e=+h[b+9112>>3];h[b+9e3>>3]=+V(+(d*d+e*e));i=i;return}function DF(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+200>>3]=+h[d>>3];h[f+192>>3]=e;i=b;return}function EF(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+216>>3]=+h[d>>3];h[f+208>>3]=e;i=b;return}function FF(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+232>>3]=+h[d>>3];h[f+224>>3]=e;i=b;return}function GF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+820>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4160>>3]=g;h[e+4152>>3]=j;i=b;return}function HF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+820>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4176>>3]=g;h[e+4168>>3]=j;i=b;return}function IF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+820>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4192>>3]=g;h[e+4184>>3]=j;i=b;return}function JF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+808>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4208>>3]=g;h[e+4200>>3]=j;i=b;return}function KF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+808>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4224>>3]=g;h[e+4216>>3]=j;i=b;return}function LF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+808>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4240>>3]=g;h[e+4232>>3]=j;i=b;return}function MF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+796>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4256>>3]=g;h[e+4248>>3]=j;i=b;return}function NF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4736>>3]=+h[b+4256>>3]+(+h[b+4160>>3]+ +h[b+4208>>3]);i=i;return}function OF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4728>>3]=+h[b+4248>>3]+(+h[b+4152>>3]+ +h[b+4200>>3]);i=i;return}function PF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+796>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4272>>3]=g;h[e+4264>>3]=j;i=b;return}function QF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4744>>3]=+h[b+4264>>3]+(+h[b+4168>>3]+ +h[b+4216>>3]);i=i;return}function RF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4752>>3]=+h[b+4272>>3]+(+h[b+4176>>3]+ +h[b+4224>>3]);i=i;return}function SF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+796>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4288>>3]=g;h[e+4280>>3]=j;i=b;return}function TF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4760>>3]=+h[b+4280>>3]+(+h[b+4184>>3]+ +h[b+4232>>3]);i=i;return}function UF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4768>>3]=+h[b+4288>>3]+(+h[b+4192>>3]+ +h[b+4240>>3]);i=i;return}function VF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+748>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4448>>3]=g;h[e+4440>>3]=j;i=b;return}function WF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+748>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4464>>3]=g;h[e+4456>>3]=j;i=b;return}function XF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+748>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4480>>3]=g;h[e+4472>>3]=j;i=b;return}function YF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+736>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4496>>3]=g;h[e+4488>>3]=j;i=b;return}function ZF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+736>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4512>>3]=g;h[e+4504>>3]=j;i=b;return}function _F(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+736>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4528>>3]=g;h[e+4520>>3]=j;i=b;return}function $F(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+724>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4544>>3]=g;h[e+4536>>3]=j;i=b;return}function aG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4776>>3]=+h[b+4536>>3]+(+h[b+4440>>3]+ +h[b+4488>>3]);i=i;return}function bG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4784>>3]=+h[b+4544>>3]+(+h[b+4448>>3]+ +h[b+4496>>3]);i=i;return}function cG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+724>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4560>>3]=g;h[e+4552>>3]=j;i=b;return}function dG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4800>>3]=+h[b+4560>>3]+(+h[b+4464>>3]+ +h[b+4512>>3]);i=i;return}function eG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4792>>3]=+h[b+4552>>3]+(+h[b+4456>>3]+ +h[b+4504>>3]);i=i;return}function fG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+724>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+4576>>3]=g;h[e+4568>>3]=j;i=b;return}function gG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4808>>3]=+h[b+4568>>3]+(+h[b+4472>>3]+ +h[b+4520>>3]);i=i;return}function hG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4816>>3]=+h[b+4576>>3]+(+h[b+4480>>3]+ +h[b+4528>>3]);i=i;return}function iG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+532>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+5888>>3]=g;h[e+5880>>3]=j;i=b;return}function jG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+532>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+5904>>3]=g;h[e+5896>>3]=j;i=b;return}function kG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+532>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+5920>>3]=g;h[e+5912>>3]=j;i=b;return}function lG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+520>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+5936>>3]=g;h[e+5928>>3]=j;i=b;return}function mG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+520>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+5952>>3]=g;h[e+5944>>3]=j;i=b;return}function nG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+520>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+5968>>3]=g;h[e+5960>>3]=j;i=b;return}function oG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+508>>2]|0)==3){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+5984>>3]=g;h[e+5976>>3]=j;i=b;return}function pG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5736>>3]=-+h[b+5928>>3]- +h[b+5880>>3]- +h[b+5976>>3];i=i;return}function qG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5744>>3]=-+h[b+5936>>3]- +h[b+5888>>3]- +h[b+5984>>3];i=i;return}function rG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+508>>2]|0)==2){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6e3>>3]=g;h[e+5992>>3]=j;i=b;return}function sG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5760>>3]=-+h[b+5952>>3]- +h[b+5904>>3]- +h[b+6e3>>3];i=i;return}function tG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5752>>3]=-+h[b+5944>>3]- +h[b+5896>>3]- +h[b+5992>>3];i=i;return}function uG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+508>>2]|0)==1){$l(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6016>>3]=g;h[e+6008>>3]=j;i=b;return}function vG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5776>>3]=-+h[b+5968>>3]- +h[b+5920>>3]- +h[b+6016>>3];i=i;return}function wG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5768>>3]=-+h[b+5960>>3]- +h[b+5912>>3]- +h[b+6008>>3];i=i;return}function xG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+44>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+5520>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+5520|0;h[c[g+48>>2]>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+5520>>3]);e=c[f>>2]|0;h[c[e+52>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+44>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+5536>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+5536|0;h[(c[e+48>>2]|0)+8>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+5536>>3]);j=c[f>>2]|0;h[(c[j+52>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+44>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+5504>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+5504|0;h[(c[j+48>>2]|0)+16>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+5504>>3]);g=c[f>>2]|0;h[(c[g+52>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+44>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+5512>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+5512|0;h[(c[g+48>>2]|0)+24>>3]=+h[j>>3];k=+U5(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+5512>>3]);e=c[f>>2]|0;h[(c[e+52>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+44>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+5528>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+5528|0;h[(c[e+48>>2]|0)+32>>3]=+h[g>>3];k=+U5(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+5528>>3]);j=c[f>>2]|0;h[(c[j+52>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+44>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+5496>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+5496|0;h[(c[j+48>>2]|0)+40>>3]=+h[e>>3];k=+U5(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+5496>>3]);h[(c[(c[f>>2]|0)+52>>2]|0)+40>>3]=k;S5(a,0)|0;g=c[(c[f>>2]|0)+44>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+5520>>3]=+h[g>>3];h[f+5536>>3]=+h[g+8>>3];h[f+5504>>3]=+h[g+16>>3];h[f+5512>>3]=+h[g+24>>3];h[f+5528>>3]=+h[g+32>>3];h[f+5496>>3]=+h[g+40>>3];cm(a);dm(a);em(a);fm(a);gm(a);hm(a);im(a);jm(a);km(a);lm(a);mm(a);nm(a);om(a);pm(a);qm(a);i=b;return}function yG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+592>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+5520>>3],-+h[j+5512>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5440>>3]=l;h[e+5432>>3]=m;i=b;return}function zG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+592>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+5520>>3],-+h[j+5512>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5424>>3]=l;h[e+5416>>3]=m;i=b;return}function AG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+592>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+5520>>3],-+h[j+5512>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5408>>3]=l;h[e+5400>>3]=m;i=b;return}function BG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+580>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+5536>>3],-+h[j+5528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5488>>3]=l;h[e+5480>>3]=m;i=b;return}function CG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+580>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+5536>>3],-+h[j+5528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5472>>3]=l;h[e+5464>>3]=m;i=b;return}function DG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+580>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+5536>>3],-+h[j+5528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5456>>3]=l;h[e+5448>>3]=m;i=b;return}function EG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+604>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+5504>>3],-+h[j+5496>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5392>>3]=l;h[e+5384>>3]=m;i=b;return}function FG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5720>>3]=+h[b+5480>>3]+(+h[b+5384>>3]+ +h[b+5432>>3]);i=i;return}function GG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5728>>3]=+h[b+5488>>3]+(+h[b+5392>>3]+ +h[b+5440>>3]);i=i;return}function HG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+604>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+5504>>3],-+h[j+5496>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5376>>3]=l;h[e+5368>>3]=m;i=b;return}function IG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5712>>3]=+h[b+5472>>3]+(+h[b+5376>>3]+ +h[b+5424>>3]);i=i;return}function JG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5704>>3]=+h[b+5464>>3]+(+h[b+5368>>3]+ +h[b+5416>>3]);i=i;return}function KG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+604>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+5504>>3],-+h[j+5496>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+5360>>3]=l;h[e+5352>>3]=m;i=b;return}function LG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5696>>3]=+h[b+5456>>3]+(+h[b+5360>>3]+ +h[b+5408>>3]);i=i;return}function MG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5688>>3]=+h[b+5448>>3]+(+h[b+5352>>3]+ +h[b+5400>>3]);i=i;return}function NG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+496>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6032>>3]=g;h[e+6024>>3]=j;i=b;return}function OG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+496>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6048>>3]=g;h[e+6040>>3]=j;i=b;return}function PG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+496>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6064>>3]=g;h[e+6056>>3]=j;i=b;return}function QG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+484>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6080>>3]=g;h[e+6072>>3]=j;i=b;return}function RG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+484>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6096>>3]=g;h[e+6088>>3]=j;i=b;return}function SG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+484>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6112>>3]=g;h[e+6104>>3]=j;i=b;return}function TG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+472>>2]|0)==3){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6128>>3]=g;h[e+6120>>3]=j;i=b;return}function UG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6176>>3]=+h[b+6128>>3]+(+h[b+6032>>3]+ +h[b+6080>>3]);i=i;return}function VG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6168>>3]=+h[b+6120>>3]+(+h[b+6024>>3]+ +h[b+6072>>3]);i=i;return}function WG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+472>>2]|0)==2){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6144>>3]=g;h[e+6136>>3]=j;i=b;return}function XG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6192>>3]=+h[b+6144>>3]+(+h[b+6048>>3]+ +h[b+6096>>3]);i=i;return}function YG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6184>>3]=+h[b+6136>>3]+(+h[b+6040>>3]+ +h[b+6088>>3]);i=i;return}function ZG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+472>>2]|0)==1){$l(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+6160>>3]=g;h[e+6152>>3]=j;i=b;return}function _G(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6200>>3]=+h[b+6152>>3]+(+h[b+6056>>3]+ +h[b+6104>>3]);i=i;return}function $G(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6208>>3]=+h[b+6160>>3]+(+h[b+6064>>3]+ +h[b+6112>>3]);i=i;return}function aH(a){a=a|0;var b=0,d=0,e=0,f=0,j=0.0;b=i;d=c[(a+4|0)>>2]|0;e=c[(a+468|0)>>2]|0;h[c[e+124>>2]>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+328>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+328|0;h[c[e+128>>2]>>3]=+h[f>>3];j=+U5(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+328>>3]);d=c[(a+468|0)>>2]|0;h[c[d+132>>2]>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+124>>2]|0)+8>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+392>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+392|0;h[(c[d+128>>2]|0)+8>>3]=+h[e>>3];j=+U5(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+392>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+132>>2]|0)+8>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+124>>2]|0)+16>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+304>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+304|0;h[(c[f+128>>2]|0)+16>>3]=+h[d>>3];j=+U5(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+304>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+132>>2]|0)+16>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+124>>2]|0)+24>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+384>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+384|0;h[(c[e+128>>2]|0)+24>>3]=+h[f>>3];j=+U5(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+384>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+132>>2]|0)+24>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+124>>2]|0)+32>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+320>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+320|0;h[(c[d+128>>2]|0)+32>>3]=+h[e>>3];j=+U5(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+320>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+132>>2]|0)+32>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+124>>2]|0)+40>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+312>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+312|0;h[(c[f+128>>2]|0)+40>>3]=+h[d>>3];j=+U5(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+312>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+132>>2]|0)+40>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+124>>2]|0)+48>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+3288>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+3288|0;h[(c[e+128>>2]|0)+48>>3]=+h[f>>3];j=+U5(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+3288>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+132>>2]|0)+48>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+124>>2]|0)+56>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+3304>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+3304|0;h[(c[d+128>>2]|0)+56>>3]=+h[e>>3];j=+U5(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+3304>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+132>>2]|0)+56>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+124>>2]|0)+64>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+3280>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+3280|0;h[(c[f+128>>2]|0)+64>>3]=+h[d>>3];j=+U5(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+3280>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+132>>2]|0)+64>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+124>>2]|0)+72>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+3264>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+3264|0;h[(c[e+128>>2]|0)+72>>3]=+h[f>>3];j=+U5(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+3264>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+132>>2]|0)+72>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+124>>2]|0)+80>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+3656>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+3656|0;h[(c[d+128>>2]|0)+80>>3]=+h[e>>3];j=+U5(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+3656>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+132>>2]|0)+80>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+124>>2]|0)+88>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1632>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+1632|0;h[(c[f+128>>2]|0)+88>>3]=+h[d>>3];j=+U5(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1632>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+132>>2]|0)+88>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+124>>2]|0)+96>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+2104>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+2104|0;h[(c[e+128>>2]|0)+96>>3]=+h[f>>3];j=+U5(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+2104>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+132>>2]|0)+96>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+124>>2]|0)+104>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+2136>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+2136|0;h[(c[d+128>>2]|0)+104>>3]=+h[e>>3];j=+U5(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+2136>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+132>>2]|0)+104>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+124>>2]|0)+112>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2096>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+2096|0;h[(c[f+128>>2]|0)+112>>3]=+h[d>>3];j=+U5(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2096>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+132>>2]|0)+112>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+124>>2]|0)+120>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+1560>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+1560|0;h[(c[e+128>>2]|0)+120>>3]=+h[f>>3];j=+U5(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+1560>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+132>>2]|0)+120>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+124>>2]|0)+128>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+272>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+272|0;h[(c[d+128>>2]|0)+128>>3]=+h[e>>3];j=+U5(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+272>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+132>>2]|0)+128>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+124>>2]|0)+136>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+600>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+600|0;h[(c[f+128>>2]|0)+136>>3]=+h[d>>3];j=+U5(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+600>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+132>>2]|0)+136>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+124>>2]|0)+144>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+2840>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+2840|0;h[(c[e+128>>2]|0)+144>>3]=+h[f>>3];j=+U5(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+2840>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+132>>2]|0)+144>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+124>>2]|0)+152>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+240>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+240|0;h[(c[d+128>>2]|0)+152>>3]=+h[e>>3];j=+U5(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+240>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+132>>2]|0)+152>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+124>>2]|0)+160>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+256>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+256|0;h[(c[f+128>>2]|0)+160>>3]=+h[d>>3];j=+U5(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+256>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+132>>2]|0)+160>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+124>>2]|0)+168>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+2864>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+2864|0;h[(c[e+128>>2]|0)+168>>3]=+h[f>>3];j=+U5(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+2864>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+132>>2]|0)+168>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+124>>2]|0)+176>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+2856>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+2856|0;h[(c[d+128>>2]|0)+176>>3]=+h[e>>3];j=+U5(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+2856>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+132>>2]|0)+176>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+124>>2]|0)+184>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2848>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+2848|0;h[(c[f+128>>2]|0)+184>>3]=+h[d>>3];j=+U5(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2848>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+132>>2]|0)+184>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+124>>2]|0)+192>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+2872>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+2872|0;h[(c[e+128>>2]|0)+192>>3]=+h[f>>3];j=+U5(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+2872>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+132>>2]|0)+192>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+124>>2]|0)+200>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+248>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+248|0;h[(c[d+128>>2]|0)+200>>3]=+h[e>>3];j=+U5(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+248>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+132>>2]|0)+200>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+124>>2]|0)+208>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2832>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+2832|0;h[(c[f+128>>2]|0)+208>>3]=+h[d>>3];j=+U5(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2832>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+132>>2]|0)+208>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+124>>2]|0)+216>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+280>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+280|0;h[(c[e+128>>2]|0)+216>>3]=+h[f>>3];j=+U5(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+280>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+132>>2]|0)+216>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+124>>2]|0)+224>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+1592>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+1592|0;h[(c[d+128>>2]|0)+224>>3]=+h[e>>3];j=+U5(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+1592>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+132>>2]|0)+224>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+124>>2]|0)+232>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1600>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+1600|0;h[(c[f+128>>2]|0)+232>>3]=+h[d>>3];j=+U5(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1600>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+132>>2]|0)+232>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+124>>2]|0)+240>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+1568>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+1568|0;h[(c[e+128>>2]|0)+240>>3]=+h[f>>3];j=+U5(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+1568>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+132>>2]|0)+240>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+124>>2]|0)+248>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+1624>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+1624|0;h[(c[d+128>>2]|0)+248>>3]=+h[e>>3];j=+U5(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+1624>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+132>>2]|0)+248>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+124>>2]|0)+256>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+264>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+264|0;h[(c[f+128>>2]|0)+256>>3]=+h[d>>3];j=+U5(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+264>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+132>>2]|0)+256>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+124>>2]|0)+264>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+560>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+560|0;h[(c[e+128>>2]|0)+264>>3]=+h[f>>3];j=+U5(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+560>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+132>>2]|0)+264>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+124>>2]|0)+272>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+568>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+568|0;h[(c[d+128>>2]|0)+272>>3]=+h[e>>3];j=+U5(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+568>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+132>>2]|0)+272>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+124>>2]|0)+280>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+592>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+592|0;h[(c[f+128>>2]|0)+280>>3]=+h[d>>3];j=+U5(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+592>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+132>>2]|0)+280>>3]=j;d=c[(a+4|0)>>2]|0;h[(c[e+124>>2]|0)+288>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+1096>>3];f=(c[(c[d+4>>2]|0)+8>>2]|0)+1096|0;h[(c[e+128>>2]|0)+288>>3]=+h[f>>3];j=+U5(a,+h[f>>3],+h[(c[(c[d+8>>2]|0)+8>>2]|0)+1096>>3]);d=c[(a+468|0)>>2]|0;h[(c[d+132>>2]|0)+288>>3]=j;f=c[(a+4|0)>>2]|0;h[(c[d+124>>2]|0)+296>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+528>>3];e=(c[(c[f+4>>2]|0)+8>>2]|0)+528|0;h[(c[d+128>>2]|0)+296>>3]=+h[e>>3];j=+U5(a,+h[e>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+528>>3]);f=c[(a+468|0)>>2]|0;h[(c[f+132>>2]|0)+296>>3]=j;e=c[(a+4|0)>>2]|0;h[(c[f+124>>2]|0)+304>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+536>>3];d=(c[(c[e+4>>2]|0)+8>>2]|0)+536|0;h[(c[f+128>>2]|0)+304>>3]=+h[d>>3];j=+U5(a,+h[d>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+536>>3]);e=c[(a+468|0)>>2]|0;h[(c[e+132>>2]|0)+304>>3]=j;c[b+8>>2]=a;c[b+208>>2]=e;c[b+2120>>2]=0;c[b+2124>>2]=0;_Modelica_Electrical_QuasiStationary_Machines_Examples_TransformerTestbench_eqFunction_625$0(b);H=c[b+2120>>2]|0;A=c[b+2124>>2]|0;I=+g[b+2124>>2];c[b+2120>>2]=0;c[b+2124>>2]=0;if((H|0)==5){return}}function bH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5792>>3]=+h[b+2600>>3]- +h[b+2616>>3];i=i;return}function cH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6224>>3]=+h[b+2600>>3]- +h[b+2616>>3];i=i;return}function dH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1060>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2144>>3],+h[j+2136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2440>>3]=l;h[e+2432>>3]=m;i=b;return}function eH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1060>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2144>>3],+h[j+2136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2424>>3]=l;h[e+2416>>3]=m;i=b;return}function fH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1060>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2144>>3],+h[j+2136>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2408>>3]=l;h[e+2400>>3]=m;i=b;return}function gH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2512>>3]=+h[b+9360>>3]- +h[b+1960>>3];i=i;return}function hH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5856>>3]=+h[b+2632>>3]- +h[b+2600>>3];i=i;return}function iH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5824>>3]=+h[b+2616>>3]- +h[b+2632>>3];i=i;return}function jH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6256>>3]=+h[b+2632>>3]- +h[b+2600>>3];i=i;return}function kH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6240>>3]=+h[b+2616>>3]- +h[b+2632>>3];i=i;return}function lH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1072>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2104>>3],+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2392>>3]=l;h[e+2384>>3]=m;i=b;return}function mH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1072>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2104>>3],+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2376>>3]=l;h[e+2368>>3]=m;i=b;return}function nH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1072>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2104>>3],+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2360>>3]=l;h[e+2352>>3]=m;i=b;return}function oH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1048>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2184>>3],+h[j+2176>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2488>>3]=l;h[e+2480>>3]=m;i=b;return}function pH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2680>>3]=+h[b+2488>>3]+(+h[b+2392>>3]+ +h[b+2440>>3]);i=i;return}function qH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2672>>3]=+h[b+2480>>3]+(+h[b+2384>>3]+ +h[b+2432>>3]);i=i;return}function rH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1048>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2184>>3],+h[j+2176>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2472>>3]=l;h[e+2464>>3]=m;i=b;return}function sH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2656>>3]=+h[b+2464>>3]+(+h[b+2368>>3]+ +h[b+2416>>3]);i=i;return}function tH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2664>>3]=+h[b+2472>>3]+(+h[b+2376>>3]+ +h[b+2424>>3]);i=i;return}function uH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1048>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2184>>3],+h[j+2176>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2456>>3]=l;h[e+2448>>3]=m;i=b;return}function vH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2640>>3]=+h[b+2448>>3]+(+h[b+2352>>3]+ +h[b+2400>>3]);i=i;return}function wH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2648>>3]=+h[b+2456>>3]+(+h[b+2360>>3]+ +h[b+2408>>3]);i=i;return}function xH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2536>>3]=+h[b+9336>>3]- +h[b+1984>>3];i=i;return}function yH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2496>>3]=+h[b+9376>>3]- +h[b+1944>>3];i=i;return}function zH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2080>>3]=+h[b+1984>>3]- +h[b+184>>3];i=i;return}function AH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2040>>3]=+h[b+1944>>3]- +h[b+144>>3];i=i;return}function BH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1520>>3]=+h[b+920>>3]- +h[b+2600>>3];i=i;return}function CH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1552>>3]=+h[b+952>>3]- +h[b+2632>>3];i=i;return}function DH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1e3>>3]=+h[b+136>>3]- +h[b+952>>3];i=i;return}function EH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1088>>3]=+h[b+1120>>3]*+h[b+1104>>3]+ +h[b+1112>>3]*+h[b+1096>>3];i=i;return}function FH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+968>>3]=+h[b+104>>3]- +h[b+920>>3];i=i;return}function GH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1048>>3]=+h[b+1080>>3]*+h[b+1064>>3]+ +h[b+1072>>3]*+h[b+1056>>3];i=i;return}function HH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1008>>3]=+h[b+1040>>3]*+h[b+1024>>3]+ +h[b+1032>>3]*+h[b+1016>>3];i=i;return}function IH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9768>>3]=+h[b+1088>>3]+(+h[b+1008>>3]+ +h[b+1048>>3]);i=i;return}function JH(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4928>>3];e=+h[b+4920>>3];h[b+4880>>3]=+V(+(d*d+e*e));i=i;return}function KH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4872>>3]=+ba(+(+h[b+4920>>3]),+(+h[b+4928>>3]));i=i;return}function LH(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4944>>3];e=+h[b+4936>>3];h[b+4896>>3]=+V(+(d*d+e*e));i=i;return}function MH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4888>>3]=+ba(+(+h[b+4936>>3]),+(+h[b+4944>>3]));i=i;return}function NH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+892>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3616>>3],-+h[j+3608>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3712>>3]=l;h[e+3704>>3]=m;i=b;return}function OH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+892>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3616>>3],-+h[j+3608>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3696>>3]=l;h[e+3688>>3]=m;i=b;return}function _Modelica_Electrical_QuasiStationary_Machines_Examples_TransformerTestbench_eqFunction_625$0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0;b=c[a+8>>2]|0;d=c[a+208>>2]|0;a:do{e=c[(b+4|0)>>2]|0;h[(c[d+124>>2]|0)+312>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1064>>3];f=(c[(c[e+4>>2]|0)+8>>2]|0)+1064|0;h[(c[d+128>>2]|0)+312>>3]=+h[f>>3];g=+U5(b,+h[f>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1064>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+132>>2]|0)+312>>3]=g;f=c[(b+4|0)>>2]|0;h[(c[e+124>>2]|0)+320>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+1056>>3];j=(c[(c[f+4>>2]|0)+8>>2]|0)+1056|0;h[(c[e+128>>2]|0)+320>>3]=+h[j>>3];g=+U5(b,+h[j>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+1056>>3]);f=c[(b+468|0)>>2]|0;h[(c[f+132>>2]|0)+320>>3]=g;j=c[(b+4|0)>>2]|0;h[(c[f+124>>2]|0)+328>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1024>>3];e=(c[(c[j+4>>2]|0)+8>>2]|0)+1024|0;h[(c[f+128>>2]|0)+328>>3]=+h[e>>3];g=+U5(b,+h[e>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1024>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+132>>2]|0)+328>>3]=g;e=c[(b+4|0)>>2]|0;h[(c[j+124>>2]|0)+336>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1104>>3];f=(c[(c[e+4>>2]|0)+8>>2]|0)+1104|0;h[(c[j+128>>2]|0)+336>>3]=+h[f>>3];g=+U5(b,+h[f>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1104>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+132>>2]|0)+336>>3]=g;f=c[(b+4|0)>>2]|0;h[(c[e+124>>2]|0)+344>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+1016>>3];j=(c[(c[f+4>>2]|0)+8>>2]|0)+1016|0;h[(c[e+128>>2]|0)+344>>3]=+h[j>>3];g=+U5(b,+h[j>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+1016>>3]);f=c[(b+468|0)>>2]|0;h[(c[f+132>>2]|0)+344>>3]=g;j=c[(b+4|0)>>2]|0;h[(c[f+124>>2]|0)+352>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+4944>>3];e=(c[(c[j+4>>2]|0)+8>>2]|0)+4944|0;h[(c[f+128>>2]|0)+352>>3]=+h[e>>3];g=+U5(b,+h[e>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+4944>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+132>>2]|0)+352>>3]=g;e=c[(b+4|0)>>2]|0;h[(c[j+124>>2]|0)+360>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4952>>3];f=(c[(c[e+4>>2]|0)+8>>2]|0)+4952|0;h[(c[j+128>>2]|0)+360>>3]=+h[f>>3];g=+U5(b,+h[f>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4952>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+132>>2]|0)+360>>3]=g;f=c[(b+4|0)>>2]|0;h[(c[e+124>>2]|0)+368>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+4936>>3];j=(c[(c[f+4>>2]|0)+8>>2]|0)+4936|0;h[(c[e+128>>2]|0)+368>>3]=+h[j>>3];g=+U5(b,+h[j>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+4936>>3]);f=c[(b+468|0)>>2]|0;h[(c[f+132>>2]|0)+368>>3]=g;j=c[(b+4|0)>>2]|0;h[(c[f+124>>2]|0)+376>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+4928>>3];e=(c[(c[j+4>>2]|0)+8>>2]|0)+4928|0;h[(c[f+128>>2]|0)+376>>3]=+h[e>>3];g=+U5(b,+h[e>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+4928>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+132>>2]|0)+376>>3]=g;e=c[(b+4|0)>>2]|0;h[(c[j+124>>2]|0)+384>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4136>>3];f=(c[(c[e+4>>2]|0)+8>>2]|0)+4136|0;h[(c[j+128>>2]|0)+384>>3]=+h[f>>3];g=+U5(b,+h[f>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4136>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+132>>2]|0)+384>>3]=g;f=c[(b+4|0)>>2]|0;h[(c[e+124>>2]|0)+392>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+4104>>3];j=(c[(c[f+4>>2]|0)+8>>2]|0)+4104|0;h[(c[e+128>>2]|0)+392>>3]=+h[j>>3];g=+U5(b,+h[j>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+4104>>3]);f=c[(b+468|0)>>2]|0;h[(c[f+132>>2]|0)+392>>3]=g;j=c[(b+4|0)>>2]|0;h[(c[f+124>>2]|0)+400>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+4960>>3];e=(c[(c[j+4>>2]|0)+8>>2]|0)+4960|0;h[(c[f+128>>2]|0)+400>>3]=+h[e>>3];g=+U5(b,+h[e>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+4960>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+132>>2]|0)+400>>3]=g;e=c[(b+4|0)>>2]|0;h[(c[j+124>>2]|0)+408>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4920>>3];f=(c[(c[e+4>>2]|0)+8>>2]|0)+4920|0;h[(c[j+128>>2]|0)+408>>3]=+h[f>>3];g=+U5(b,+h[f>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4920>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+132>>2]|0)+408>>3]=g;f=c[(b+4|0)>>2]|0;h[(c[e+124>>2]|0)+416>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+4144>>3];j=(c[(c[f+4>>2]|0)+8>>2]|0)+4144|0;h[(c[e+128>>2]|0)+416>>3]=+h[j>>3];g=+U5(b,+h[j>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+4144>>3]);f=c[(b+468|0)>>2]|0;h[(c[f+132>>2]|0)+416>>3]=g;j=c[(b+4|0)>>2]|0;h[(c[f+124>>2]|0)+424>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+4072>>3];e=(c[(c[j+4>>2]|0)+8>>2]|0)+4072|0;h[(c[f+128>>2]|0)+424>>3]=+h[e>>3];g=+U5(b,+h[e>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+4072>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+132>>2]|0)+424>>3]=g;e=c[(b+4|0)>>2]|0;h[(c[j+124>>2]|0)+432>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+3608>>3];f=(c[(c[e+4>>2]|0)+8>>2]|0)+3608|0;h[(c[j+128>>2]|0)+432>>3]=+h[f>>3];g=+U5(b,+h[f>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+3608>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+132>>2]|0)+432>>3]=g;f=c[(b+4|0)>>2]|0;h[(c[e+124>>2]|0)+440>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+4080>>3];j=(c[(c[f+4>>2]|0)+8>>2]|0)+4080|0;h[(c[e+128>>2]|0)+440>>3]=+h[j>>3];g=+U5(b,+h[j>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+4080>>3]);f=c[(b+468|0)>>2]|0;h[(c[f+132>>2]|0)+440>>3]=g;j=c[(b+4|0)>>2]|0;h[(c[f+124>>2]|0)+448>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+3664>>3];e=(c[(c[j+4>>2]|0)+8>>2]|0)+3664|0;h[(c[f+128>>2]|0)+448>>3]=+h[e>>3];g=+U5(b,+h[e>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+3664>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+132>>2]|0)+448>>3]=g;e=c[(b+4|0)>>2]|0;h[(c[j+124>>2]|0)+456>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+3616>>3];f=(c[(c[e+4>>2]|0)+8>>2]|0)+3616|0;h[(c[j+128>>2]|0)+456>>3]=+h[f>>3];g=+U5(b,+h[f>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+3616>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+132>>2]|0)+456>>3]=g;f=c[(b+4|0)>>2]|0;h[(c[e+124>>2]|0)+464>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+4112>>3];j=(c[(c[f+4>>2]|0)+8>>2]|0)+4112|0;h[(c[e+128>>2]|0)+464>>3]=+h[j>>3];g=+U5(b,+h[j>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+4112>>3]);f=c[(b+468|0)>>2]|0;h[(c[f+132>>2]|0)+464>>3]=g;j=c[(b+4|0)>>2]|0;h[(c[f+124>>2]|0)+472>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+3640>>3];e=(c[(c[j+4>>2]|0)+8>>2]|0)+3640|0;h[(c[f+128>>2]|0)+472>>3]=+h[e>>3];g=+U5(b,+h[e>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+3640>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+132>>2]|0)+472>>3]=g;e=c[(b+4|0)>>2]|0;h[(c[j+124>>2]|0)+480>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+3632>>3];f=(c[(c[e+4>>2]|0)+8>>2]|0)+3632|0;h[(c[j+128>>2]|0)+480>>3]=+h[f>>3];g=+U5(b,+h[f>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+3632>>3]);e=c[(b+468|0)>>2]|0;h[(c[e+132>>2]|0)+480>>3]=g;f=c[(b+4|0)>>2]|0;h[(c[e+124>>2]|0)+488>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+2176>>3];j=(c[(c[f+4>>2]|0)+8>>2]|0)+2176|0;h[(c[e+128>>2]|0)+488>>3]=+h[j>>3];g=+U5(b,+h[j>>3],+h[(c[(c[f+8>>2]|0)+8>>2]|0)+2176>>3]);f=c[(b+468|0)>>2]|0;h[(c[f+132>>2]|0)+488>>3]=g;j=c[(b+4|0)>>2]|0;h[(c[f+124>>2]|0)+496>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+2184>>3];e=(c[(c[j+4>>2]|0)+8>>2]|0)+2184|0;h[(c[f+128>>2]|0)+496>>3]=+h[e>>3];g=+U5(b,+h[e>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+2184>>3]);j=c[(b+468|0)>>2]|0;h[(c[j+132>>2]|0)+496>>3]=g;e=c[(b+4|0)>>2]|0;h[(c[j+124>>2]|0)+504>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2144>>3];f=(c[(c[e+4>>2]|0)+8>>2]|0)+2144|0;h[(c[j+128>>2]|0)+504>>3]=+h[f>>3];g=+U5(b,+h[f>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2144>>3]);h[(c[(c[(b+468|0)>>2]|0)+132>>2]|0)+504>>3]=g;S5(b,1)|0;e=c[(c[(b+468|0)>>2]|0)+124>>2]|0;f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[f+328>>3]=+h[e>>3];h[f+392>>3]=+h[e+8>>3];h[f+304>>3]=+h[e+16>>3];h[f+384>>3]=+h[e+24>>3];h[f+320>>3]=+h[e+32>>3];h[f+312>>3]=+h[e+40>>3];h[f+3288>>3]=+h[e+48>>3];h[f+3304>>3]=+h[e+56>>3];h[f+3280>>3]=+h[e+64>>3];h[f+3264>>3]=+h[e+72>>3];h[f+3656>>3]=+h[e+80>>3];h[f+1632>>3]=+h[e+88>>3];h[f+2104>>3]=+h[e+96>>3];h[f+2136>>3]=+h[e+104>>3];h[f+2096>>3]=+h[e+112>>3];h[f+1560>>3]=+h[e+120>>3];h[f+272>>3]=+h[e+128>>3];h[f+600>>3]=+h[e+136>>3];h[f+2840>>3]=+h[e+144>>3];h[f+240>>3]=+h[e+152>>3];h[f+256>>3]=+h[e+160>>3];h[f+2864>>3]=+h[e+168>>3];h[f+2856>>3]=+h[e+176>>3];h[f+2848>>3]=+h[e+184>>3];e=c[(c[(b+468|0)>>2]|0)+124>>2]|0;f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[f+2872>>3]=+h[e+192>>3];h[f+248>>3]=+h[e+200>>3];h[f+2832>>3]=+h[e+208>>3];h[f+280>>3]=+h[e+216>>3];h[f+1592>>3]=+h[e+224>>3];h[f+1600>>3]=+h[e+232>>3];h[f+1568>>3]=+h[e+240>>3];h[f+1624>>3]=+h[e+248>>3];h[f+264>>3]=+h[e+256>>3];h[f+560>>3]=+h[e+264>>3];h[f+568>>3]=+h[e+272>>3];h[f+592>>3]=+h[e+280>>3];h[f+1096>>3]=+h[e+288>>3];h[f+528>>3]=+h[e+296>>3];h[f+536>>3]=+h[e+304>>3];h[f+1064>>3]=+h[e+312>>3];h[f+1056>>3]=+h[e+320>>3];h[f+1024>>3]=+h[e+328>>3];h[f+1104>>3]=+h[e+336>>3];h[f+1016>>3]=+h[e+344>>3];h[f+4944>>3]=+h[e+352>>3];h[f+4952>>3]=+h[e+360>>3];h[f+4936>>3]=+h[e+368>>3];h[f+4928>>3]=+h[e+376>>3];e=c[(c[(b+468|0)>>2]|0)+124>>2]|0;f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[f+4136>>3]=+h[e+384>>3];h[f+4104>>3]=+h[e+392>>3];h[f+4960>>3]=+h[e+400>>3];h[f+4920>>3]=+h[e+408>>3];h[f+4144>>3]=+h[e+416>>3];h[f+4072>>3]=+h[e+424>>3];h[f+3608>>3]=+h[e+432>>3];h[f+4080>>3]=+h[e+440>>3];h[f+3664>>3]=+h[e+448>>3];h[f+3616>>3]=+h[e+456>>3];h[f+4112>>3]=+h[e+464>>3];h[f+3640>>3]=+h[e+472>>3];h[f+3632>>3]=+h[e+480>>3];h[f+2176>>3]=+h[e+488>>3];h[f+2184>>3]=+h[e+496>>3];h[f+2144>>3]=+h[e+504>>3];tm(b);um(b);vm(b);wm(b);xm(b);ym(b);zm(b);Am(b);Bm(b);Cm(b);Dm(b);Em(b);Fm(b);Gm(b);Hm(b);Im(b);Jm(b);Km(b);Lm(b);Mm(b);Nm(b);Om(b);Pm(b);Qm(b);Rm(b);Sm(b);Tm(b);Um(b);Vm(b);Wm(b);Xm(b);Ym(b);Zm(b);_m(b);$m(b);an(b);bn(b);cn(b);dn(b);en(b);fn(b);gn(b);hn(b);jn(b);kn(b);ln(b);mn(b);nn(b);on(b);pn(b);qn(b);rn(b);sn(b);tn(b);un(b);vn(b);wn(b);xn(b);yn(b);zn(b);An(b);Bn(b);Cn(b);Dn(b);En(b);Fn(b);Gn(b);Hn(b);In(b);Jn(b);Kn(b);Ln(b);Mn(b);Nn(b);On(b);Pn(b);Qn(b);Rn(b);Sn(b);Tn(b);Un(b);Vn(b);Wn(b);Xn(b);Yn(b);Zn(b);_n(b);$n(b);ao(b);bo(b);co(b);eo(b);fo(b);go(b);ho(b);io(b);jo(b);ko(b);lo(b);mo(b);no(b);oo(b);po(b);qo(b);ro(b);so(b);to(b);uo(b);vo(b);wo(b);xo(b);yo(b);zo(b);Ao(b);Bo(b);Co(b);Do(b);Eo(b);Fo(b);Go(b);Ho(b);Io(b);Jo(b);Ko(b);Lo(b);Mo(b);No(b);Oo(b);Po(b);Qo(b);Ro(b);So(b);To(b);Uo(b);Vo(b);Wo(b);Xo(b);Yo(b);Zo(b);_o(b);$o(b);ap(b);bp(b);cp(b);dp(b);ep(b);fp(b);gp(b);hp(b);ip(b);jp(b);kp(b);lp(b);mp(b);np(b);op(b);pp(b);qp(b);rp(b);sp(b);tp(b);up(b);vp(b);wp(b);xp(b);yp(b);zp(b);Ap(b);Bp(b);Cp(b);Dp(b);Ep(b);Fp(b);Gp(b);Hp(b);Ip(b);Jp(b);Kp(b);Lp(b);Mp(b);Np(b);Op(b);Pp(b);Qp(b);Rp(b);Sp(b);Tp(b);Up(b);Vp(b);Wp(b);Xp(b);Yp(b);Zp(b);_p(b);$p(b);aq(b);bq(b);cq(b);dq(b);eq(b);fq(b);gq(b);hq(b);iq(b);jq(b);kq(b);lq(b);mq(b);nq(b);oq(b);pq(b);qq(b);rq(b);sq(b);tq(b);uq(b);vq(b);wq(b);xq(b);yq(b);zq(b);Aq(b);Bq(b);Cq(b);Dq(b);Eq(b);Fq(b);Gq(b);Hq(b);Iq(b);Jq(b);Kq(b);Lq(b);Mq(b);Nq(b);Oq(b);Pq(b);Qq(b);Rq(b);Sq(b);Tq(b);Uq(b);Vq(b);Wq(b);Xq(b);Yq(b);Zq(b);_q(b);$q(b);ar(b);br(b);cr(b);dr(b);er(b);fr(b);gr(b);hr(b);ir(b);jr(b);kr(b);lr(b);mr(b);nr(b);or(b);pr(b);qr(b);rr(b);sr(b);tr(b);ur(b);vr(b);wr(b);xr(b);yr(b);zr(b);Ar(b);Br(b);Cr(b);Dr(b);Er(b);Fr(b);Gr(b);Hr(b);Ir(b);Jr(b);Kr(b);Lr(b);Mr(b);Nr(b);Or(b);Pr(b);Qr(b);Rr(b);Sr(b);Tr(b);Ur(b);Vr(b);Wr(b);Xr(b);Yr(b);Zr(b);_r(b);$r(b);as(b);bs(b);cs(b);ds(b);es(b);fs(b);gs(b);hs(b);is(b);js(b);ks(b);ls(b);ms(b);ns(b);os(b);ps(b);qs(b);rs(b);ss(b);ts(b);us(b);vs(b);ws(b);xs(b);ys(b);zs(b);As(b);Bs(b);Cs(b);Ds(b);Es(b);i=a;c[a+2120>>2]=5;break a}while(0)}



function Kr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+128>>3]=+h[b+608>>3]+ +h[b+944>>3];i=i;return}function Lr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+416>>3]=+h[b+128>>3]- +h[b+80>>3];i=i;return}function Mr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2192>>3]=+h[b+2176>>3]*+h[b+9296>>3];i=i;return}function Nr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1976>>3]=+h[b+9344>>3]- +h[b+2192>>3];i=i;return}function Or(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+176>>3]=+h[b+1976>>3]- +h[b+1640>>3];i=i;return}function Pr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9784>>3]=+h[b+176>>3]- +h[b+512>>3];i=i;return}function Qr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+480>>3]=+h[b+144>>3]- +h[b+9784>>3];i=i;return}function Rr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+496>>3]=+h[b+160>>3]- +h[b+9784>>3];i=i;return}function Sr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2e3>>3]=-+h[b+2264>>3]- +h[b+2216>>3]- +h[b+2312>>3];i=i;return}function Tr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1904>>3]=+h[b+2e3>>3]- +h[b+1808>>3]- +h[b+1856>>3];i=i;return}function Ur(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2160>>3]=+h[b+2144>>3]*+h[b+9288>>3];i=i;return}function Vr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1968>>3]=+h[b+9352>>3]- +h[b+2160>>3];i=i;return}function Wr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+168>>3]=+h[b+1968>>3]- +h[b+1616>>3];i=i;return}function Xr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9792>>3]=+h[b+168>>3]- +h[b+504>>3];i=i;return}function Yr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+488>>3]=+h[b+152>>3]- +h[b+9792>>3];i=i;return}function Zr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+520>>3]=+h[b+184>>3]- +h[b+9792>>3];i=i;return}function _r(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2616>>3]=+h[b+3640>>3]*+h[b+9312>>3];i=i;return}function $r(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+936>>3]=+h[b+1080>>3]+ +h[b+2616>>3];i=i;return}function as(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+120>>3]=+h[b+584>>3]+ +h[b+936>>3];i=i;return}function bs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+408>>3]=+h[b+120>>3]- +h[b+72>>3];i=i;return}function cs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+88>>3]=+h[b+328>>3]+ +h[b+2616>>3];i=i;return}function ds(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+424>>3]=+h[b+136>>3]- +h[b+88>>3];i=i;return}function es(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+664>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4944>>3],-+h[j+4936>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11504>>3]=l;h[e+11496>>3]=m;i=b;return}function fs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+832>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+3664>>3],+h[j+3656>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11488>>3]=l;h[e+11480>>3]=m;i=b;return}function gs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+976>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2840>>3],+h[j+2832>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11472>>3]=l;h[e+11464>>3]=m;i=b;return}function hs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+832>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+3664>>3],+h[j+3656>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11456>>3]=l;h[e+11448>>3]=m;i=b;return}function is(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+664>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4944>>3],-+h[j+4936>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11440>>3]=l;h[e+11432>>3]=m;i=b;return}function js(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+664>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+4944>>3],-+h[j+4936>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11424>>3]=l;h[e+11416>>3]=m;i=b;return}function ks(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1300>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+600>>3],-+h[j+592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11408>>3]=l;h[e+11400>>3]=m;i=b;return}function ls(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1300>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+600>>3],-+h[j+592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11392>>3]=l;h[e+11384>>3]=m;i=b;return}function ms(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+11376>>3]=+h[d>>3];h[f+11368>>3]=e;i=b;return}function ns(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1300>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+600>>3],-+h[j+592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11360>>3]=l;h[e+11352>>3]=m;i=b;return}function os(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+11344>>3]=+h[d>>3];h[f+11336>>3]=e;i=b;return}function ps(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1156>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1632>>3],-+h[j+1624>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11328>>3]=l;h[e+11320>>3]=m;i=b;return}function qs(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+11312>>3]=+h[d>>3];h[f+11304>>3]=e;i=b;return}function rs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+976>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2840>>3],+h[j+2832>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11296>>3]=l;h[e+11288>>3]=m;i=b;return}function ss(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+11280>>3]=+h[d>>3];h[f+11272>>3]=e;i=b;return}function ts(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+11264>>3]=+h[d>>3];h[f+11256>>3]=e;i=b;return}function us(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+11248>>3]=+h[d>>3];h[f+11240>>3]=e;i=b;return}function vs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+976>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+2840>>3],+h[j+2832>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11232>>3]=l;h[e+11224>>3]=m;i=b;return}function ws(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1156>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1632>>3],-+h[j+1624>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11216>>3]=l;h[e+11208>>3]=m;i=b;return}function xs(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+11200>>3]=+h[d>>3];h[f+11192>>3]=e;i=b;return}function ys(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1120>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1632>>3],+h[j+1624>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11184>>3]=l;h[e+11176>>3]=m;i=b;return}function zs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1120>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1632>>3],+h[j+1624>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11168>>3]=l;h[e+11160>>3]=m;i=b;return}function As(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1120>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+1632>>3],+h[j+1624>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11152>>3]=l;h[e+11144>>3]=m;i=b;return}function Bs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+1156>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+1632>>3],-+h[j+1624>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11136>>3]=l;h[e+11128>>3]=m;i=b;return}function Cs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+832>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+3664>>3],+h[j+3656>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11120>>3]=l;h[e+11112>>3]=m;i=b;return}function Ds(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+11104>>3]=+h[d>>3];h[f+11096>>3]=e;i=b;return}function Es(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;Xl(d,c[a+536>>2]|0,0.0,0.0);e=+h[d+8>>3];f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+11088>>3]=+h[d>>3];h[f+11080>>3]=e;i=b;return}function Fs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=a+8|0;a=c[d>>2]|0;e=b+16|0;f=c[e>>2]|0;h[f>>3]=+h[a+4672>>3];g=b+8|0;j=c[g>>2]|0;h[j>>3]=+h[a+4648>>3];k=b+12|0;b=c[k>>2]|0;h[b>>3]=+h[a+4656>>3];h[f+8>>3]=+h[a+5568>>3];h[j+8>>3]=+h[a+5544>>3];h[b+8>>3]=+h[a+5552>>3];h[f+16>>3]=+h[a+4336>>3];h[j+16>>3]=+h[a+4312>>3];h[b+16>>3]=+h[a+4320>>3];h[f+24>>3]=+h[a+5456>>3];h[j+24>>3]=+h[a+5432>>3];h[b+24>>3]=+h[a+5440>>3];h[f+32>>3]=+h[a+4560>>3];h[j+32>>3]=+h[a+4536>>3];h[b+32>>3]=+h[a+4544>>3];h[f+40>>3]=+h[a+4448>>3];h[j+40>>3]=+h[a+4424>>3];h[b+40>>3]=+h[a+4432>>3];h[f+48>>3]=+h[a+46112>>3];h[j+48>>3]=+h[a+46088>>3];h[b+48>>3]=+h[a+46096>>3];h[f+56>>3]=+h[a+46336>>3];h[j+56>>3]=+h[a+46312>>3];h[b+56>>3]=+h[a+46320>>3];a=c[d>>2]|0;j=c[e>>2]|0;h[j+64>>3]=+h[a+46e3>>3];f=c[g>>2]|0;h[f+64>>3]=+h[a+45976>>3];h[b+64>>3]=+h[a+45984>>3];h[j+72>>3]=+h[a+45776>>3];h[f+72>>3]=+h[a+45752>>3];b=c[k>>2]|0;h[b+72>>3]=+h[a+45760>>3];h[j+80>>3]=+h[a+51264>>3];h[f+80>>3]=+h[a+51240>>3];h[b+80>>3]=+h[a+51248>>3];h[j+88>>3]=+h[a+22928>>3];h[f+88>>3]=+h[a+22904>>3];h[b+88>>3]=+h[a+22912>>3];h[j+96>>3]=+h[a+29536>>3];h[f+96>>3]=+h[a+29512>>3];h[b+96>>3]=+h[a+29520>>3];h[j+104>>3]=+h[a+29984>>3];h[f+104>>3]=+h[a+29960>>3];h[b+104>>3]=+h[a+29968>>3];h[j+112>>3]=+h[a+29424>>3];h[f+112>>3]=+h[a+29400>>3];h[b+112>>3]=+h[a+29408>>3];h[j+120>>3]=+h[a+21920>>3];h[f+120>>3]=+h[a+21896>>3];h[b+120>>3]=+h[a+21904>>3];a=c[d>>2]|0;f=c[e>>2]|0;h[f+128>>3]=+h[a+3888>>3];j=c[g>>2]|0;h[j+128>>3]=+h[a+3864>>3];h[b+128>>3]=+h[a+3872>>3];h[f+136>>3]=+h[a+8480>>3];h[j+136>>3]=+h[a+8456>>3];b=c[k>>2]|0;h[b+136>>3]=+h[a+8464>>3];h[f+144>>3]=+h[a+39840>>3];h[j+144>>3]=+h[a+39816>>3];h[b+144>>3]=+h[a+39824>>3];h[f+152>>3]=+h[a+3440>>3];h[j+152>>3]=+h[a+3416>>3];h[b+152>>3]=+h[a+3424>>3];h[f+160>>3]=+h[a+3664>>3];h[j+160>>3]=+h[a+3640>>3];h[b+160>>3]=+h[a+3648>>3];h[f+168>>3]=+h[a+40176>>3];h[j+168>>3]=+h[a+40152>>3];h[b+168>>3]=+h[a+40160>>3];h[f+176>>3]=+h[a+40064>>3];h[j+176>>3]=+h[a+40040>>3];h[b+176>>3]=+h[a+40048>>3];h[f+184>>3]=+h[a+39952>>3];h[j+184>>3]=+h[a+39928>>3];h[b+184>>3]=+h[a+39936>>3];a=c[d>>2]|0;j=c[e>>2]|0;h[j+192>>3]=+h[a+40288>>3];f=c[g>>2]|0;h[f+192>>3]=+h[a+40264>>3];h[b+192>>3]=+h[a+40272>>3];h[j+200>>3]=+h[a+3552>>3];h[f+200>>3]=+h[a+3528>>3];b=c[k>>2]|0;h[b+200>>3]=+h[a+3536>>3];h[j+208>>3]=+h[a+39728>>3];h[f+208>>3]=+h[a+39704>>3];h[b+208>>3]=+h[a+39712>>3];h[j+216>>3]=+h[a+4e3>>3];h[f+216>>3]=+h[a+3976>>3];h[b+216>>3]=+h[a+3984>>3];h[j+224>>3]=+h[a+22368>>3];h[f+224>>3]=+h[a+22344>>3];h[b+224>>3]=+h[a+22352>>3];h[j+232>>3]=+h[a+22480>>3];h[f+232>>3]=+h[a+22456>>3];h[b+232>>3]=+h[a+22464>>3];h[j+240>>3]=+h[a+22032>>3];h[f+240>>3]=+h[a+22008>>3];h[b+240>>3]=+h[a+22016>>3];h[j+248>>3]=+h[a+22816>>3];h[f+248>>3]=+h[a+22792>>3];h[b+248>>3]=+h[a+22800>>3];a=c[d>>2]|0;f=c[e>>2]|0;h[f+256>>3]=+h[a+3776>>3];j=c[g>>2]|0;h[j+256>>3]=+h[a+3752>>3];h[b+256>>3]=+h[a+3760>>3];h[f+264>>3]=+h[a+7920>>3];h[j+264>>3]=+h[a+7896>>3];b=c[k>>2]|0;h[b+264>>3]=+h[a+7904>>3];h[f+272>>3]=+h[a+8032>>3];h[j+272>>3]=+h[a+8008>>3];h[b+272>>3]=+h[a+8016>>3];h[f+280>>3]=+h[a+8368>>3];h[j+280>>3]=+h[a+8344>>3];h[b+280>>3]=+h[a+8352>>3];h[f+288>>3]=+h[a+15424>>3];h[j+288>>3]=+h[a+15400>>3];h[b+288>>3]=+h[a+15408>>3];h[f+296>>3]=+h[a+7472>>3];h[j+296>>3]=+h[a+7448>>3];h[b+296>>3]=+h[a+7456>>3];h[f+304>>3]=+h[a+7584>>3];h[j+304>>3]=+h[a+7560>>3];h[b+304>>3]=+h[a+7568>>3];h[f+312>>3]=+h[a+14976>>3];h[j+312>>3]=+h[a+14952>>3];h[b+312>>3]=+h[a+14960>>3];a=c[d>>2]|0;j=c[e>>2]|0;h[j+320>>3]=+h[a+14864>>3];f=c[g>>2]|0;h[f+320>>3]=+h[a+14840>>3];h[b+320>>3]=+h[a+14848>>3];h[j+328>>3]=+h[a+14416>>3];h[f+328>>3]=+h[a+14392>>3];b=c[k>>2]|0;h[b+328>>3]=+h[a+14400>>3];h[j+336>>3]=+h[a+15536>>3];h[f+336>>3]=+h[a+15512>>3];h[b+336>>3]=+h[a+15520>>3];h[j+344>>3]=+h[a+14304>>3];h[f+344>>3]=+h[a+14280>>3];h[b+344>>3]=+h[a+14288>>3];h[j+352>>3]=+h[a+69296>>3];h[f+352>>3]=+h[a+69272>>3];h[b+352>>3]=+h[a+69280>>3];h[j+360>>3]=+h[a+69408>>3];h[f+360>>3]=+h[a+69384>>3];h[b+360>>3]=+h[a+69392>>3];h[j+368>>3]=+h[a+69184>>3];h[f+368>>3]=+h[a+69160>>3];h[b+368>>3]=+h[a+69168>>3];h[j+376>>3]=+h[a+69072>>3];h[f+376>>3]=+h[a+69048>>3];h[b+376>>3]=+h[a+69056>>3];a=c[d>>2]|0;f=c[e>>2]|0;h[f+384>>3]=+h[a+57984>>3];j=c[g>>2]|0;h[j+384>>3]=+h[a+57960>>3];h[b+384>>3]=+h[a+57968>>3];h[f+392>>3]=+h[a+57536>>3];h[j+392>>3]=+h[a+57512>>3];b=c[k>>2]|0;h[b+392>>3]=+h[a+57520>>3];h[f+400>>3]=+h[a+69520>>3];h[j+400>>3]=+h[a+69496>>3];h[b+400>>3]=+h[a+69504>>3];h[f+408>>3]=+h[a+68960>>3];h[j+408>>3]=+h[a+68936>>3];h[b+408>>3]=+h[a+68944>>3];h[f+416>>3]=+h[a+58096>>3];h[j+416>>3]=+h[a+58072>>3];h[b+416>>3]=+h[a+58080>>3];h[f+424>>3]=+h[a+57088>>3];h[j+424>>3]=+h[a+57064>>3];h[b+424>>3]=+h[a+57072>>3];h[f+432>>3]=+h[a+50592>>3];h[j+432>>3]=+h[a+50568>>3];h[b+432>>3]=+h[a+50576>>3];h[f+440>>3]=+h[a+57200>>3];h[j+440>>3]=+h[a+57176>>3];h[b+440>>3]=+h[a+57184>>3];a=c[d>>2]|0;d=c[e>>2]|0;h[d+448>>3]=+h[a+51376>>3];e=c[g>>2]|0;h[e+448>>3]=+h[a+51352>>3];h[b+448>>3]=+h[a+51360>>3];h[d+456>>3]=+h[a+50704>>3];h[e+456>>3]=+h[a+50680>>3];b=c[k>>2]|0;h[b+456>>3]=+h[a+50688>>3];h[d+464>>3]=+h[a+57648>>3];h[e+464>>3]=+h[a+57624>>3];h[b+464>>3]=+h[a+57632>>3];h[d+472>>3]=+h[a+51040>>3];h[e+472>>3]=+h[a+51016>>3];h[b+472>>3]=+h[a+51024>>3];h[d+480>>3]=+h[a+50928>>3];h[e+480>>3]=+h[a+50904>>3];h[b+480>>3]=+h[a+50912>>3];h[d+488>>3]=+h[a+30544>>3];h[e+488>>3]=+h[a+30520>>3];h[b+488>>3]=+h[a+30528>>3];h[d+496>>3]=+h[a+30656>>3];h[e+496>>3]=+h[a+30632>>3];h[b+496>>3]=+h[a+30640>>3];h[d+504>>3]=+h[a+30096>>3];h[e+504>>3]=+h[a+30072>>3];h[b+504>>3]=+h[a+30080>>3];i=i;return}function Gs(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0;e=i;f=a;g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[j+328>>3]=+h[b>>3];h[j+392>>3]=+h[b+8>>3];h[j+304>>3]=+h[b+16>>3];h[j+384>>3]=+h[b+24>>3];h[j+320>>3]=+h[b+32>>3];h[j+312>>3]=+h[b+40>>3];h[j+3288>>3]=+h[b+48>>3];h[j+3304>>3]=+h[b+56>>3];h[j+3280>>3]=+h[b+64>>3];h[j+3264>>3]=+h[b+72>>3];h[j+3656>>3]=+h[b+80>>3];h[j+1632>>3]=+h[b+88>>3];h[j+2104>>3]=+h[b+96>>3];h[j+2136>>3]=+h[b+104>>3];h[j+2096>>3]=+h[b+112>>3];h[j+1560>>3]=+h[b+120>>3];h[j+272>>3]=+h[b+128>>3];h[j+600>>3]=+h[b+136>>3];h[j+2840>>3]=+h[b+144>>3];h[j+240>>3]=+h[b+152>>3];h[j+256>>3]=+h[b+160>>3];h[j+2864>>3]=+h[b+168>>3];h[j+2856>>3]=+h[b+176>>3];h[j+2848>>3]=+h[b+184>>3];j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[j+2872>>3]=+h[b+192>>3];h[j+248>>3]=+h[b+200>>3];h[j+2832>>3]=+h[b+208>>3];h[j+280>>3]=+h[b+216>>3];h[j+1592>>3]=+h[b+224>>3];h[j+1600>>3]=+h[b+232>>3];h[j+1568>>3]=+h[b+240>>3];h[j+1624>>3]=+h[b+248>>3];h[j+264>>3]=+h[b+256>>3];h[j+560>>3]=+h[b+264>>3];h[j+568>>3]=+h[b+272>>3];h[j+592>>3]=+h[b+280>>3];h[j+1096>>3]=+h[b+288>>3];h[j+528>>3]=+h[b+296>>3];h[j+536>>3]=+h[b+304>>3];h[j+1064>>3]=+h[b+312>>3];h[j+1056>>3]=+h[b+320>>3];h[j+1024>>3]=+h[b+328>>3];h[j+1104>>3]=+h[b+336>>3];h[j+1016>>3]=+h[b+344>>3];h[j+4944>>3]=+h[b+352>>3];h[j+4952>>3]=+h[b+360>>3];h[j+4936>>3]=+h[b+368>>3];h[j+4928>>3]=+h[b+376>>3];j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[j+4136>>3]=+h[b+384>>3];h[j+4104>>3]=+h[b+392>>3];h[j+4960>>3]=+h[b+400>>3];h[j+4920>>3]=+h[b+408>>3];h[j+4144>>3]=+h[b+416>>3];h[j+4072>>3]=+h[b+424>>3];h[j+3608>>3]=+h[b+432>>3];h[j+4080>>3]=+h[b+440>>3];h[j+3664>>3]=+h[b+448>>3];h[j+3616>>3]=+h[b+456>>3];h[j+4112>>3]=+h[b+464>>3];h[j+3640>>3]=+h[b+472>>3];h[j+3632>>3]=+h[b+480>>3];h[j+2176>>3]=+h[b+488>>3];h[j+2184>>3]=+h[b+496>>3];h[j+2144>>3]=+h[b+504>>3];tm(f);um(f);vm(f);wm(f);xm(f);ym(f);zm(f);Am(f);Bm(f);Cm(f);Dm(f);Em(f);Fm(f);Gm(f);Hm(f);Im(f);Jm(f);Km(f);Lm(f);Mm(f);Nm(f);Om(f);Pm(f);Qm(f);Rm(f);Sm(f);Tm(f);Um(f);Vm(f);Wm(f);Xm(f);Ym(f);Zm(f);_m(f);$m(f);an(f);bn(f);cn(f);dn(f);en(f);fn(f);gn(f);hn(f);jn(f);kn(f);ln(f);mn(f);nn(f);on(f);pn(f);qn(f);rn(f);sn(f);tn(f);un(f);vn(f);wn(f);xn(f);yn(f);zn(f);An(f);Bn(f);Cn(f);Dn(f);En(f);Fn(f);Gn(f);Hn(f);In(f);Jn(f);Kn(f);Ln(f);Mn(f);Nn(f);On(f);Pn(f);Qn(f);Rn(f);Sn(f);Tn(f);Un(f);Vn(f);Wn(f);Xn(f);Yn(f);Zn(f);_n(f);$n(f);ao(f);bo(f);co(f);eo(f);fo(f);go(f);ho(f);io(f);jo(f);ko(f);lo(f);mo(f);no(f);oo(f);po(f);qo(f);ro(f);so(f);to(f);uo(f);vo(f);wo(f);xo(f);yo(f);zo(f);Ao(f);Bo(f);Co(f);Do(f);Eo(f);Fo(f);Go(f);Ho(f);Io(f);Jo(f);Ko(f);Lo(f);Mo(f);No(f);Oo(f);Po(f);Qo(f);Ro(f);So(f);To(f);Uo(f);Vo(f);Wo(f);Xo(f);Yo(f);Zo(f);_o(f);$o(f);ap(f);bp(f);cp(f);dp(f);ep(f);fp(f);gp(f);hp(f);ip(f);jp(f);kp(f);lp(f);mp(f);np(f);op(f);pp(f);qp(f);rp(f);sp(f);tp(f);up(f);vp(f);wp(f);xp(f);yp(f);zp(f);Ap(f);Bp(f);Cp(f);Dp(f);Ep(f);Fp(f);Gp(f);Hp(f);Ip(f);Jp(f);Kp(f);Lp(f);Mp(f);Np(f);Op(f);Pp(f);Qp(f);Rp(f);Sp(f);Tp(f);Up(f);Vp(f);Wp(f);Xp(f);Yp(f);Zp(f);_p(f);$p(f);aq(f);bq(f);cq(f);dq(f);eq(f);fq(f);gq(f);hq(f);iq(f);jq(f);kq(f);lq(f);mq(f);nq(f);oq(f);pq(f);qq(f);rq(f);sq(f);tq(f);uq(f);vq(f);wq(f);xq(f);yq(f);zq(f);Aq(f);Bq(f);Cq(f);Dq(f);Eq(f);Fq(f);Gq(f);Hq(f);Iq(f);Jq(f);Kq(f);Lq(f);Mq(f);Nq(f);Oq(f);Pq(f);Qq(f);Rq(f);Sq(f);Tq(f);Uq(f);Vq(f);Wq(f);Xq(f);Yq(f);Zq(f);_q(f);$q(f);ar(f);br(f);cr(f);dr(f);er(f);fr(f);gr(f);hr(f);ir(f);jr(f);kr(f);lr(f);mr(f);nr(f);or(f);pr(f);qr(f);rr(f);sr(f);tr(f);ur(f);vr(f);wr(f);xr(f);yr(f);zr(f);Ar(f);Br(f);Cr(f);Dr(f);Er(f);Fr(f);Gr(f);Hr(f);Ir(f);Jr(f);Kr(f);Lr(f);Mr(f);Nr(f);Or(f);Pr(f);Qr(f);Rr(f);Sr(f);Tr(f);Ur(f);Vr(f);Wr(f);Xr(f);Yr(f);Zr(f);_r(f);$r(f);as(f);bs(f);cs(f);ds(f);es(f);fs(f);gs(f);hs(f);is(f);js(f);ks(f);ls(f);ms(f);ns(f);os(f);ps(f);qs(f);rs(f);ss(f);ts(f);us(f);vs(f);ws(f);xs(f);ys(f);zs(f);As(f);Bs(f);Cs(f);Ds(f);Es(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;b=a+416|0;a=c[b>>2]|0;j=a+1232|0;h[d>>3]=+h[f+480>>3]- +h[f+288>>3]*+h[j>>3];k=a+1224|0;h[d+8>>3]=+h[f+496>>3]- +h[f+400>>3]*+h[k>>3];h[d+16>>3]=+h[f+488>>3]- +h[f+296>>3]*+h[j>>3];h[d+24>>3]=+h[f+520>>3]- +h[f+424>>3]*+h[k>>3];h[d+32>>3]=+h[f+5024>>3]- +h[f+11504>>3];h[d+40>>3]=+h[f+5016>>3]- +h[f+11496>>3];h[d+48>>3]=+h[f+3952>>3]- +h[f+11488>>3];h[d+56>>3]=+h[f+3944>>3]- +h[f+11480>>3];h[d+64>>3]=+h[f+2984>>3]- +h[f+11472>>3];h[d+72>>3]=+h[f+2976>>3]- +h[f+11464>>3];h[d+80>>3]=+h[f+3920>>3]- +h[f+11456>>3];h[d+88>>3]=+h[f+3912>>3]- +h[f+11448>>3];f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d+96>>3]=+h[f+5056>>3]- +h[f+11440>>3];h[d+104>>3]=+h[f+5048>>3]- +h[f+11432>>3];h[d+112>>3]=+h[f+5040>>3]- +h[f+11424>>3];h[d+120>>3]=+h[f+5032>>3]- +h[f+11416>>3];h[d+128>>3]=+h[f+760>>3]- +h[f+11408>>3];h[d+136>>3]=+h[f+752>>3]- +h[f+11400>>3];h[d+144>>3]=+h[f+744>>3]- +h[f+11392>>3];h[d+152>>3]=+h[f+736>>3]- +h[f+11384>>3];h[d+160>>3]=+h[f+11376>>3]+(+h[f+248>>3]- +h[f+344>>3]);h[d+168>>3]=+h[f+11368>>3]+(+h[f+240>>3]- +h[f+336>>3]);h[d+176>>3]=+h[f+728>>3]- +h[f+11360>>3];h[d+184>>3]=+h[f+720>>3]- +h[f+11352>>3];h[d+192>>3]=+h[f+11344>>3]+(+h[f+264>>3]- +h[f+360>>3]);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=f+256|0;h[d+200>>3]=+h[f+11336>>3]+(+h[k>>3]- +h[f+352>>3]);h[d+208>>3]=+h[f+1792>>3]- +h[f+11328>>3];h[d+216>>3]=+h[f+1784>>3]- +h[f+11320>>3];h[d+224>>3]=+h[f+11312>>3]+(+h[f+3048>>3]- +h[f+264>>3]);h[d+232>>3]=+h[f+11304>>3]+(+h[f+3040>>3]- +h[k>>3]);h[d+240>>3]=+h[f+3e3>>3]- +h[f+11296>>3];h[d+248>>3]=+h[f+2992>>3]- +h[f+11288>>3];h[d+256>>3]=+h[f+11280>>3]+(+h[f+3064>>3]- +h[f+280>>3]);h[d+264>>3]=+h[f+11272>>3]+(+h[f+3056>>3]- +h[f+272>>3]);h[d+272>>3]=+h[f+11264>>3]+(+h[f+3336>>3]- +h[f+456>>3]);h[d+280>>3]=+h[f+11256>>3]+(+h[f+3328>>3]- +h[f+448>>3]);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d+288>>3]=+h[f+11248>>3]+(+h[f+3032>>3]- +h[f+248>>3]);h[d+296>>3]=+h[f+11240>>3]+(+h[f+3024>>3]- +h[f+240>>3]);h[d+304>>3]=+h[f+3016>>3]- +h[f+11232>>3];h[d+312>>3]=+h[f+3008>>3]- +h[f+11224>>3];h[d+320>>3]=+h[f+1760>>3]- +h[f+11216>>3];h[d+328>>3]=+h[f+1752>>3]- +h[f+11208>>3];h[d+336>>3]=+h[f+11200>>3]+(+h[f+280>>3]- +h[f+376>>3]);h[d+344>>3]=+h[f+11192>>3]+(+h[f+272>>3]- +h[f+368>>3]);h[d+352>>3]=+h[f+1920>>3]- +h[f+11184>>3];h[d+360>>3]=+h[f+1912>>3]- +h[f+11176>>3];h[d+368>>3]=+h[f+1904>>3]- +h[f+11168>>3];h[d+376>>3]=+h[f+1896>>3]- +h[f+11160>>3];f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d+384>>3]=+h[f+1936>>3]- +h[f+11152>>3];h[d+392>>3]=+h[f+1928>>3]- +h[f+11144>>3];h[d+400>>3]=+h[f+1776>>3]- +h[f+11136>>3];h[d+408>>3]=+h[f+1768>>3]- +h[f+11128>>3];h[d+416>>3]=+h[f+3936>>3]- +h[f+11120>>3];h[d+424>>3]=+h[f+3928>>3]- +h[f+11112>>3];h[d+432>>3]=+h[f+11104>>3]+(+h[f+3320>>3]- +h[f+440>>3]);h[d+440>>3]=+h[f+11096>>3]+(+h[f+3312>>3]- +h[f+432>>3]);h[d+448>>3]=+h[f+11088>>3]+(+h[f+3352>>3]- +h[f+472>>3]);h[d+456>>3]=+h[f+11080>>3]+(+h[f+3344>>3]- +h[f+464>>3]);k=c[b>>2]|0;b=k+1224|0;h[d+464>>3]=+h[f+504>>3]- +h[f+408>>3]*+h[b>>3];h[d+472>>3]=+h[f+512>>3]- +h[f+416>>3]*+h[b>>3];f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d+480>>3]=+h[f+480>>3]- +h[f+384>>3]*+h[b>>3];g=k+1232|0;h[d+488>>3]=+h[f+496>>3]- +h[f+304>>3]*+h[g>>3];h[d+496>>3]=+h[f+488>>3]- +h[f+392>>3]*+h[b>>3];h[d+504>>3]=+h[f+520>>3]- +h[f+328>>3]*+h[g>>3];i=e;return}function Hs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+928>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3512>>3],-+h[j+3504>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3384>>3]=l;h[e+3376>>3]=m;i=b;return}function Is(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+928>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3512>>3],-+h[j+3504>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3400>>3]=l;h[e+3392>>3]=m;i=b;return}function Js(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+916>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3528>>3],-+h[j+3520>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3448>>3]=l;h[e+3440>>3]=m;i=b;return}function Ks(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3488>>3]=+h[b+3584>>3]- +h[b+3392>>3]- +h[b+3440>>3];i=i;return}function Ls(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3496>>3]=+h[b+3592>>3]- +h[b+3400>>3]- +h[b+3448>>3];i=i;return}function Ms(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+916>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3528>>3],-+h[j+3520>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3432>>3]=l;h[e+3424>>3]=m;i=b;return}function Ns(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3480>>3]=+h[b+3576>>3]- +h[b+3384>>3]- +h[b+3432>>3];i=i;return}function Os(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3472>>3]=+h[b+3568>>3]- +h[b+3376>>3]- +h[b+3424>>3];i=i;return}function Ps(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+916>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3528>>3],-+h[j+3520>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3416>>3]=l;h[e+3408>>3]=m;i=b;return}function Qs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+928>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3512>>3],-+h[j+3504>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3368>>3]=l;h[e+3360>>3]=m;i=b;return}function Rs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3464>>3]=+h[b+3560>>3]- +h[b+3368>>3]- +h[b+3416>>3];i=i;return}function Ss(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3456>>3]=+h[b+3552>>3]- +h[b+3360>>3]- +h[b+3408>>3];i=i;return}function Ts(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+904>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3544>>3],-+h[j+3536>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11072>>3]=l;h[e+11064>>3]=m;i=b;return}function Us(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+904>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3544>>3],-+h[j+3536>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11056>>3]=l;h[e+11048>>3]=m;i=b;return}function Vs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+904>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+3544>>3],-+h[j+3536>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11040>>3]=l;h[e+11032>>3]=m;i=b;return}function Ws(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+49584>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+49560>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+49568>>3];h[a+8>>3]=+h[d+49696>>3];h[e+8>>3]=+h[d+49672>>3];h[f+8>>3]=+h[d+49680>>3];h[a+16>>3]=+h[d+49136>>3];h[e+16>>3]=+h[d+49112>>3];h[f+16>>3]=+h[d+49120>>3];h[a+24>>3]=+h[d+49360>>3];h[e+24>>3]=+h[d+49336>>3];h[f+24>>3]=+h[d+49344>>3];h[a+32>>3]=+h[d+49248>>3];h[e+32>>3]=+h[d+49224>>3];h[f+32>>3]=+h[d+49232>>3];h[a+40>>3]=+h[d+49472>>3];h[e+40>>3]=+h[d+49448>>3];h[f+40>>3]=+h[d+49456>>3];i=i;return}function Xs(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+3536>>3]=+h[b>>3];h[a+3544>>3]=+h[b+8>>3];h[a+3504>>3]=+h[b+16>>3];h[a+3520>>3]=+h[b+24>>3];h[a+3512>>3]=+h[b+32>>3];h[a+3528>>3]=+h[b+40>>3];Hs(f);Is(f);Js(f);Ks(f);Ls(f);Ms(f);Ns(f);Os(f);Ps(f);Qs(f);Rs(f);Ss(f);Ts(f);Us(f);Vs(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+3480>>3]- +h[f+11072>>3];h[d+8>>3]=+h[f+3472>>3]- +h[f+11064>>3];h[d+16>>3]=+h[f+3496>>3]- +h[f+11056>>3];h[d+24>>3]=+h[f+3488>>3]- +h[f+11048>>3];h[d+32>>3]=+h[f+3464>>3]- +h[f+11040>>3];h[d+40>>3]=+h[f+3456>>3]- +h[f+11032>>3];i=e;return}function Ys(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+424>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+6432>>3],+h[j+6424>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6496>>3]=l;h[e+6488>>3]=m;i=b;return}function Zs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+424>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+6432>>3],+h[j+6424>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6480>>3]=l;h[e+6472>>3]=m;i=b;return}function _s(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+400>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+6416>>3],+h[j+6408>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6592>>3]=l;h[e+6584>>3]=m;i=b;return}function $s(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+400>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+6416>>3],+h[j+6408>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6576>>3]=l;h[e+6568>>3]=m;i=b;return}function at(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6528>>3]=+h[b+6672>>3]- +h[b+6480>>3]- +h[b+6576>>3];i=i;return}function bt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6520>>3]=+h[b+6664>>3]- +h[b+6472>>3]- +h[b+6568>>3];i=i;return}function ct(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+400>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+6416>>3],+h[j+6408>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6560>>3]=l;h[e+6552>>3]=m;i=b;return}function dt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+424>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+6432>>3],+h[j+6424>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6464>>3]=l;h[e+6456>>3]=m;i=b;return}function et(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6512>>3]=+h[b+6656>>3]- +h[b+6464>>3]- +h[b+6560>>3];i=i;return}function ft(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6504>>3]=+h[b+6648>>3]- +h[b+6456>>3]- +h[b+6552>>3];i=i;return}function gt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6544>>3]=+h[b+6688>>3]- +h[b+6496>>3]- +h[b+6592>>3];i=i;return}function ht(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6536>>3]=+h[b+6680>>3]- +h[b+6488>>3]- +h[b+6584>>3];i=i;return}function it(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+412>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+6448>>3],+h[j+6440>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+11008>>3]=l;h[e+11e3>>3]=m;i=b;return}function jt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+412>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+6448>>3],+h[j+6440>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10992>>3]=l;h[e+10984>>3]=m;i=b;return}function kt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+412>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+6448>>3],+h[j+6440>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10976>>3]=l;h[e+10968>>3]=m;i=b;return}function lt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+90352>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+90328>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+90336>>3];h[a+8>>3]=+h[d+89904>>3];h[e+8>>3]=+h[d+89880>>3];h[f+8>>3]=+h[d+89888>>3];h[a+16>>3]=+h[d+90240>>3];h[e+16>>3]=+h[d+90216>>3];h[f+16>>3]=+h[d+90224>>3];h[a+24>>3]=+h[d+89792>>3];h[e+24>>3]=+h[d+89768>>3];h[f+24>>3]=+h[d+89776>>3];h[a+32>>3]=+h[d+90016>>3];h[e+32>>3]=+h[d+89992>>3];h[f+32>>3]=+h[d+9e4>>3];h[a+40>>3]=+h[d+90128>>3];h[e+40>>3]=+h[d+90104>>3];h[f+40>>3]=+h[d+90112>>3];i=i;return}function mt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+6448>>3]=+h[b>>3];h[a+6416>>3]=+h[b+8>>3];h[a+6440>>3]=+h[b+16>>3];h[a+6408>>3]=+h[b+24>>3];h[a+6424>>3]=+h[b+32>>3];h[a+6432>>3]=+h[b+40>>3];Ys(f);Zs(f);_s(f);$s(f);at(f);bt(f);ct(f);dt(f);et(f);ft(f);gt(f);ht(f);it(f);jt(f);kt(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+6512>>3]- +h[f+11008>>3];h[d+8>>3]=+h[f+6504>>3]- +h[f+11e3>>3];h[d+16>>3]=+h[f+6528>>3]- +h[f+10992>>3];h[d+24>>3]=+h[f+6520>>3]- +h[f+10984>>3];h[d+32>>3]=+h[f+6544>>3]- +h[f+10976>>3];h[d+40>>3]=+h[f+6536>>3]- +h[f+10968>>3];i=e;return}function nt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+304>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7104>>3],-+h[j+7096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7216>>3]=l;h[e+7208>>3]=m;i=b;return}function ot(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+304>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7104>>3],-+h[j+7096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7184>>3]=l;h[e+7176>>3]=m;i=b;return}function pt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+304>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7104>>3],-+h[j+7096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7200>>3]=l;h[e+7192>>3]=m;i=b;return}function qt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+292>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7120>>3],-+h[j+7112>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7264>>3]=l;h[e+7256>>3]=m;i=b;return}function rt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7168>>3]=+h[b+7456>>3]- +h[b+7216>>3]- +h[b+7264>>3];i=i;return}function st(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7160>>3]=+h[b+7448>>3]- +h[b+7208>>3]- +h[b+7256>>3];i=i;return}function tt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+292>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7120>>3],-+h[j+7112>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7232>>3]=l;h[e+7224>>3]=m;i=b;return}function ut(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7128>>3]=+h[b+7416>>3]- +h[b+7176>>3]- +h[b+7224>>3];i=i;return}function vt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+292>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7120>>3],-+h[j+7112>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7248>>3]=l;h[e+7240>>3]=m;i=b;return}function wt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7144>>3]=+h[b+7432>>3]- +h[b+7192>>3]- +h[b+7240>>3];i=i;return}function xt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7152>>3]=+h[b+7440>>3]- +h[b+7200>>3]- +h[b+7248>>3];i=i;return}function yt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7136>>3]=+h[b+7424>>3]- +h[b+7184>>3]- +h[b+7232>>3];i=i;return}function zt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+316>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7088>>3],-+h[j+7080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10960>>3]=l;h[e+10952>>3]=m;i=b;return}function At(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+316>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7088>>3],-+h[j+7080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10944>>3]=l;h[e+10936>>3]=m;i=b;return}function Bt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+316>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7088>>3],-+h[j+7080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10928>>3]=l;h[e+10920>>3]=m;i=b;return}function Ct(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+99200>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+99176>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+99184>>3];h[a+8>>3]=+h[d+99536>>3];h[e+8>>3]=+h[d+99512>>3];h[f+8>>3]=+h[d+99520>>3];h[a+16>>3]=+h[d+99648>>3];h[e+16>>3]=+h[d+99624>>3];h[f+16>>3]=+h[d+99632>>3];h[a+24>>3]=+h[d+99312>>3];h[e+24>>3]=+h[d+99288>>3];h[f+24>>3]=+h[d+99296>>3];h[a+32>>3]=+h[d+99424>>3];h[e+32>>3]=+h[d+99400>>3];h[f+32>>3]=+h[d+99408>>3];h[a+40>>3]=+h[d+99760>>3];h[e+40>>3]=+h[d+99736>>3];h[f+40>>3]=+h[d+99744>>3];i=i;return}function Dt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+7080>>3]=+h[b>>3];h[a+7104>>3]=+h[b+8>>3];h[a+7112>>3]=+h[b+16>>3];h[a+7088>>3]=+h[b+24>>3];h[a+7096>>3]=+h[b+32>>3];h[a+7120>>3]=+h[b+40>>3];nt(f);ot(f);pt(f);qt(f);rt(f);st(f);tt(f);ut(f);vt(f);wt(f);xt(f);yt(f);zt(f);At(f);Bt(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+7168>>3]- +h[f+10960>>3];h[d+8>>3]=+h[f+7160>>3]- +h[f+10952>>3];h[d+16>>3]=+h[f+7136>>3]- +h[f+10944>>3];h[d+24>>3]=+h[f+7128>>3]- +h[f+10936>>3];h[d+32>>3]=+h[f+7152>>3]- +h[f+10928>>3];h[d+40>>3]=+h[f+7144>>3]- +h[f+10920>>3];i=e;return}function Et(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+184>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7600>>3],-+h[j+7592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7888>>3]=l;h[e+7880>>3]=m;i=b;return}function Ft(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+184>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7600>>3],-+h[j+7592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7872>>3]=l;h[e+7864>>3]=m;i=b;return}function Gt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+208>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7536>>3],-+h[j+7528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7776>>3]=l;h[e+7768>>3]=m;i=b;return}function Ht(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7824>>3]=-+h[b+7776>>3]- +h[b+7488>>3]- +h[b+7872>>3];i=i;return}function It(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+208>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7536>>3],-+h[j+7528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7792>>3]=l;h[e+7784>>3]=m;i=b;return}function Jt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7840>>3]=-+h[b+7792>>3]- +h[b+7504>>3]- +h[b+7888>>3];i=i;return}function Kt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+184>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7600>>3],-+h[j+7592>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7856>>3]=l;h[e+7848>>3]=m;i=b;return}function Lt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7816>>3]=-+h[b+7768>>3]- +h[b+7480>>3]- +h[b+7864>>3];i=i;return}function Mt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+208>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7536>>3],-+h[j+7528>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+7760>>3]=l;h[e+7752>>3]=m;i=b;return}function Nt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7808>>3]=-+h[b+7760>>3]- +h[b+7472>>3]- +h[b+7856>>3];i=i;return}function Ot(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7800>>3]=-+h[b+7752>>3]- +h[b+7464>>3]- +h[b+7848>>3];i=i;return}function Pt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7832>>3]=-+h[b+7784>>3]- +h[b+7496>>3]- +h[b+7880>>3];i=i;return}function Qt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+196>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7568>>3],-+h[j+7560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10912>>3]=l;h[e+10904>>3]=m;i=b;return}function Rt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+196>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7568>>3],-+h[j+7560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10896>>3]=l;h[e+10888>>3]=m;i=b;return}function St(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+196>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+7568>>3],-+h[j+7560>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10880>>3]=l;h[e+10872>>3]=m;i=b;return}function Tt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+105920>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+105896>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+105904>>3];h[a+8>>3]=+h[d+105584>>3];h[e+8>>3]=+h[d+105560>>3];h[f+8>>3]=+h[d+105568>>3];h[a+16>>3]=+h[d+106032>>3];h[e+16>>3]=+h[d+106008>>3];h[f+16>>3]=+h[d+106016>>3];h[a+24>>3]=+h[d+106368>>3];h[e+24>>3]=+h[d+106344>>3];h[f+24>>3]=+h[d+106352>>3];h[a+32>>3]=+h[d+105472>>3];h[e+32>>3]=+h[d+105448>>3];h[f+32>>3]=+h[d+105456>>3];h[a+40>>3]=+h[d+106480>>3];h[e+40>>3]=+h[d+106456>>3];h[f+40>>3]=+h[d+106464>>3];i=i;return}function Ut(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+7560>>3]=+h[b>>3];h[a+7536>>3]=+h[b+8>>3];h[a+7568>>3]=+h[b+16>>3];h[a+7592>>3]=+h[b+24>>3];h[a+7528>>3]=+h[b+32>>3];h[a+7600>>3]=+h[b+40>>3];Et(f);Ft(f);Gt(f);Ht(f);It(f);Jt(f);Kt(f);Lt(f);Mt(f);Nt(f);Ot(f);Pt(f);Qt(f);Rt(f);St(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+7824>>3]- +h[f+10912>>3];h[d+8>>3]=+h[f+7816>>3]- +h[f+10904>>3];h[d+16>>3]=+h[f+7840>>3]- +h[f+10896>>3];h[d+24>>3]=+h[f+7832>>3]- +h[f+10888>>3];h[d+32>>3]=+h[f+7808>>3]- +h[f+10880>>3];h[d+40>>3]=+h[f+7800>>3]- +h[f+10872>>3];i=e;return}function Vt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+4>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+8608>>3],+h[j+8600>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8880>>3]=l;h[e+8872>>3]=m;i=b;return}function Wt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+28>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+8576>>3],+h[j+8568>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8784>>3]=l;h[e+8776>>3]=m;i=b;return}function Xt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8824>>3]=+h[b+8968>>3]- +h[b+8776>>3]- +h[b+8872>>3];i=i;return}function Yt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+28>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+8576>>3],+h[j+8568>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8800>>3]=l;h[e+8792>>3]=m;i=b;return}function Zt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+28>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+8576>>3],+h[j+8568>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8768>>3]=l;h[e+8760>>3]=m;i=b;return}function _t(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+4>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+8608>>3],+h[j+8600>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8864>>3]=l;h[e+8856>>3]=m;i=b;return}function $t(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8816>>3]=+h[b+8960>>3]- +h[b+8768>>3]- +h[b+8864>>3];i=i;return}function au(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8832>>3]=+h[b+8976>>3]- +h[b+8784>>3]- +h[b+8880>>3];i=i;return}function bu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8808>>3]=+h[b+8952>>3]- +h[b+8760>>3]- +h[b+8856>>3];i=i;return}function cu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+4>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+8608>>3],+h[j+8600>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8896>>3]=l;h[e+8888>>3]=m;i=b;return}function du(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8840>>3]=+h[b+8984>>3]- +h[b+8792>>3]- +h[b+8888>>3];i=i;return}function eu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8848>>3]=+h[b+8992>>3]- +h[b+8800>>3]- +h[b+8896>>3];i=i;return}function fu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+16>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+8592>>3],+h[j+8584>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10848>>3]=l;h[e+10840>>3]=m;i=b;return}function gu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+16>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+8592>>3],+h[j+8584>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10832>>3]=l;h[e+10824>>3]=m;i=b;return}function hu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+16>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+8592>>3],+h[j+8584>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10816>>3]=l;h[e+10808>>3]=m;i=b;return}function iu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+120256>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+120232>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+120240>>3];h[a+8>>3]=+h[d+120144>>3];h[e+8>>3]=+h[d+120120>>3];h[f+8>>3]=+h[d+120128>>3];h[a+16>>3]=+h[d+120032>>3];h[e+16>>3]=+h[d+120008>>3];h[f+16>>3]=+h[d+120016>>3];h[a+24>>3]=+h[d+120592>>3];h[e+24>>3]=+h[d+120568>>3];h[f+24>>3]=+h[d+120576>>3];h[a+32>>3]=+h[d+120368>>3];h[e+32>>3]=+h[d+120344>>3];h[f+32>>3]=+h[d+120352>>3];h[a+40>>3]=+h[d+120480>>3];h[e+40>>3]=+h[d+120456>>3];h[f+40>>3]=+h[d+120464>>3];i=i;return}function ju(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+8584>>3]=+h[b>>3];h[a+8576>>3]=+h[b+8>>3];h[a+8568>>3]=+h[b+16>>3];h[a+8608>>3]=+h[b+24>>3];h[a+8592>>3]=+h[b+32>>3];h[a+8600>>3]=+h[b+40>>3];Vt(f);Wt(f);Xt(f);Yt(f);Zt(f);_t(f);$t(f);au(f);bu(f);cu(f);du(f);eu(f);fu(f);gu(f);hu(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+8832>>3]- +h[f+10848>>3];h[d+8>>3]=+h[f+8824>>3]- +h[f+10840>>3];h[d+16>>3]=+h[f+8816>>3]- +h[f+10832>>3];h[d+24>>3]=+h[f+8808>>3]- +h[f+10824>>3];h[d+32>>3]=+h[f+8848>>3]- +h[f+10816>>3];h[d+40>>3]=+h[f+8840>>3]- +h[f+10808>>3];i=e;return}function ku(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+88>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8496>>3],-+h[j+8488>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8400>>3]=l;h[e+8392>>3]=m;i=b;return}function lu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+100>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8480>>3],-+h[j+8472>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8368>>3]=l;h[e+8360>>3]=m;i=b;return}function mu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+88>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8496>>3],-+h[j+8488>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8416>>3]=l;h[e+8408>>3]=m;i=b;return}function nu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8456>>3]=+h[b+8552>>3]- +h[b+8360>>3]- +h[b+8408>>3];i=i;return}function ou(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8464>>3]=+h[b+8560>>3]- +h[b+8368>>3]- +h[b+8416>>3];i=i;return}function pu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+100>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8480>>3],-+h[j+8472>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8352>>3]=l;h[e+8344>>3]=m;i=b;return}function qu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8448>>3]=+h[b+8544>>3]- +h[b+8352>>3]- +h[b+8400>>3];i=i;return}function ru(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+100>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8480>>3],-+h[j+8472>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8336>>3]=l;h[e+8328>>3]=m;i=b;return}function su(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8440>>3]=+h[b+8536>>3]- +h[b+8344>>3]- +h[b+8392>>3];i=i;return}function tu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+88>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8496>>3],-+h[j+8488>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+8384>>3]=l;h[e+8376>>3]=m;i=b;return}function uu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8424>>3]=+h[b+8520>>3]- +h[b+8328>>3]- +h[b+8376>>3];i=i;return}function vu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8432>>3]=+h[b+8528>>3]- +h[b+8336>>3]- +h[b+8384>>3];i=i;return}function wu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+76>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8512>>3],-+h[j+8504>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10800>>3]=l;h[e+10792>>3]=m;i=b;return}function xu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+76>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8512>>3],-+h[j+8504>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10784>>3]=l;h[e+10776>>3]=m;i=b;return}function yu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+76>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,-+h[j+8512>>3],-+h[j+8504>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10768>>3]=l;h[e+10760>>3]=m;i=b;return}function zu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+119248>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+119224>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+119232>>3];h[a+8>>3]=+h[d+119136>>3];h[e+8>>3]=+h[d+119112>>3];h[f+8>>3]=+h[d+119120>>3];h[a+16>>3]=+h[d+118800>>3];h[e+16>>3]=+h[d+118776>>3];h[f+16>>3]=+h[d+118784>>3];h[a+24>>3]=+h[d+118688>>3];h[e+24>>3]=+h[d+118664>>3];h[f+24>>3]=+h[d+118672>>3];h[a+32>>3]=+h[d+119024>>3];h[e+32>>3]=+h[d+119e3>>3];h[f+32>>3]=+h[d+119008>>3];h[a+40>>3]=+h[d+118912>>3];h[e+40>>3]=+h[d+118888>>3];h[f+40>>3]=+h[d+118896>>3];i=i;return}function Au(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+8512>>3]=+h[b>>3];h[a+8504>>3]=+h[b+8>>3];h[a+8480>>3]=+h[b+16>>3];h[a+8472>>3]=+h[b+24>>3];h[a+8496>>3]=+h[b+32>>3];h[a+8488>>3]=+h[b+40>>3];ku(f);lu(f);mu(f);nu(f);ou(f);pu(f);qu(f);ru(f);su(f);tu(f);uu(f);vu(f);wu(f);xu(f);yu(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+8432>>3]- +h[f+10800>>3];h[d+8>>3]=+h[f+8424>>3]- +h[f+10792>>3];h[d+16>>3]=+h[f+8464>>3]- +h[f+10784>>3];h[d+24>>3]=+h[f+8456>>3]- +h[f+10776>>3];h[d+32>>3]=+h[f+8448>>3]- +h[f+10768>>3];h[d+40>>3]=+h[f+8440>>3]- +h[f+10760>>3];i=e;return}function Bu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+424>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+6432>>3],+h[j+6424>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6464>>3]=l;h[e+6456>>3]=m;i=b;return}function Cu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+412>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+6448>>3],+h[j+6440>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6528>>3]=l;h[e+6520>>3]=m;i=b;return}function Du(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+424>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+6432>>3],+h[j+6424>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6480>>3]=l;h[e+6472>>3]=m;i=b;return}function Eu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6576>>3]=+h[b+6672>>3]- +h[b+6480>>3]- +h[b+6528>>3];i=i;return}function Fu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6568>>3]=+h[b+6664>>3]- +h[b+6472>>3]- +h[b+6520>>3];i=i;return}function Gu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+424>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+6432>>3],+h[j+6424>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6496>>3]=l;h[e+6488>>3]=m;i=b;return}function Hu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+412>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+6448>>3],+h[j+6440>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6544>>3]=l;h[e+6536>>3]=m;i=b;return}function Iu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6592>>3]=+h[b+6688>>3]- +h[b+6496>>3]- +h[b+6544>>3];i=i;return}function Ju(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6584>>3]=+h[b+6680>>3]- +h[b+6488>>3]- +h[b+6536>>3];i=i;return}function Ku(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+412>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+6448>>3],+h[j+6440>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+6512>>3]=l;h[e+6504>>3]=m;i=b;return}function Lu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6552>>3]=+h[b+6648>>3]- +h[b+6456>>3]- +h[b+6504>>3];i=i;return}function Mu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6560>>3]=+h[b+6656>>3]- +h[b+6464>>3]- +h[b+6512>>3];i=i;return}function Nu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+400>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+6416>>3],+h[j+6408>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10752>>3]=l;h[e+10744>>3]=m;i=b;return}function Ou(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+400>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+6416>>3],+h[j+6408>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10736>>3]=l;h[e+10728>>3]=m;i=b;return}function Pu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+400>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;$l(d,f,+h[j+6416>>3],+h[j+6408>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Xl(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+10720>>3]=l;h[e+10712>>3]=m;i=b;return}function Qu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+89792>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+89768>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+89776>>3];h[a+8>>3]=+h[d+90352>>3];h[e+8>>3]=+h[d+90328>>3];h[f+8>>3]=+h[d+90336>>3];h[a+16>>3]=+h[d+90128>>3];h[e+16>>3]=+h[d+90104>>3];h[f+16>>3]=+h[d+90112>>3];h[a+24>>3]=+h[d+90016>>3];h[e+24>>3]=+h[d+89992>>3];h[f+24>>3]=+h[d+9e4>>3];h[a+32>>3]=+h[d+89904>>3];h[e+32>>3]=+h[d+89880>>3];h[f+32>>3]=+h[d+89888>>3];h[a+40>>3]=+h[d+90240>>3];h[e+40>>3]=+h[d+90216>>3];h[f+40>>3]=+h[d+90224>>3];i=i;return}



function JY(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=lxa(d|0)|0;switch(c[b>>2]|0){case 3:case 2:case 1:{q=o;ska(q,d,1,p);p=a[q]|0;do{if((p+ -97<<24>>24&255)<26){r=p+ -32<<24>>24;a[q]=r;s=o+1|0;t=a[s]|0;if((t+ -97<<24>>24&255)<26){a[s]=t+ -32<<24>>24}t=o+2|0;s=a[t]|0;if((s+ -97<<24>>24&255)<26){a[t]=s+ -32<<24>>24}s=o+3|0;t=a[s]|0;if((t+ -97<<24>>24&255)<26){a[s]=t+ -32<<24>>24}t=o+4|0;s=a[t]|0;if((s+ -97<<24>>24&255)<26){a[t]=s+ -32<<24>>24}s=o+5|0;t=a[s]|0;if(!((t+ -97<<24>>24&255)<26)){u=r;break}a[s]=t+ -32<<24>>24;u=r}else{u=p}}while(0);p=u<<24>>24==83;q=u<<24>>24==68;r=p|q;if(!(u<<24>>24==67|u<<24>>24==68|u<<24>>24==83|u<<24>>24==90)){v=1;i=k;return v|0}t=l;ska(t,o+1|0,1,2);l=m;ska(l,o+3|0,1,3);o=n;ska(o,m+1|0,1,2);m=c[b>>2]|0;if((m|0)==2){if((rka(t,59472,1,2)|0)==0){if((rka(l,59488,1,3)|0)==0){v=2;i=k;return v|0}if((rka(l,59496,1,3)|0)==0){v=2;i=k;return v|0}if((rka(l,59504,1,3)|0)==0){v=2;i=k;return v|0}if((rka(l,59512,1,3)|0)==0){v=2;i=k;return v|0}if((rka(l,59520,1,3)|0)==0){v=2;i=k;return v|0}if((rka(l,59528,1,3)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}if((rka(t,59552,1,2)|0)==0){n=(rka(l,59480,1,3)|0)==0;if(n|(p|q)^1){v=n?8:2;i=k;return v|0}v=2;i=k;return v|0}if(u<<24>>24==67|u<<24>>24==90){w=91}else if(u<<24>>24==68|u<<24>>24==83){w=94}else{v=2;i=k;return v|0}do{if((w|0)==91){if((rka(t,59576,1,2)|0)==0){v=2;i=k;return v|0}else{if(u<<24>>24==68|u<<24>>24==83){w=94;break}else if(u<<24>>24==67|u<<24>>24==90){break}else{v=2}i=k;return v|0}}}while(0);do{if((w|0)==94){if((rka(t,59584,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){break}else{v=2}i=k;return v|0}n=a[l]|0;if(n<<24>>24==71){if((rka(o,59592,1,2)|0)==0){v=2;i=k;return v|0}if((rka(o,59600,1,2)|0)==0){v=2;i=k;return v|0}if((rka(o,59608,1,2)|0)==0){v=2;i=k;return v|0}if((rka(o,59616,1,2)|0)==0){v=2;i=k;return v|0}if((rka(o,59624,1,2)|0)==0){v=2;i=k;return v|0}if((rka(o,59632,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else if(n<<24>>24==77){if((rka(o,59592,1,2)|0)==0){v=2;i=k;return v|0}if((rka(o,59600,1,2)|0)==0){v=2;i=k;return v|0}if((rka(o,59608,1,2)|0)==0){v=2;i=k;return v|0}if((rka(o,59616,1,2)|0)==0){v=2;i=k;return v|0}if((rka(o,59624,1,2)|0)==0){v=2;i=k;return v|0}if((rka(o,59632,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else{v=2;i=k;return v|0}}}while(0);if((rka(t,59648,1,2)|0)!=0){v=2;i=k;return v|0}n=a[l]|0;if(n<<24>>24==77){if((rka(o,59592,1,2)|0)==0){v=2;i=k;return v|0}if((rka(o,59600,1,2)|0)==0){v=2;i=k;return v|0}if((rka(o,59608,1,2)|0)==0){v=2;i=k;return v|0}if((rka(o,59616,1,2)|0)==0){v=2;i=k;return v|0}if((rka(o,59624,1,2)|0)==0){v=2;i=k;return v|0}if((rka(o,59632,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else if(n<<24>>24==71){if((rka(o,59592,1,2)|0)==0){v=2;i=k;return v|0}if((rka(o,59600,1,2)|0)==0){v=2;i=k;return v|0}if((rka(o,59608,1,2)|0)==0){v=2;i=k;return v|0}if((rka(o,59616,1,2)|0)==0){v=2;i=k;return v|0}if((rka(o,59624,1,2)|0)==0){v=2;i=k;return v|0}if((rka(o,59632,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else{v=2;i=k;return v|0}}else if((m|0)==3){if((rka(t,59472,1,2)|0)==0){if((rka(l,59488,1,3)|0)==0){v=128;i=k;return v|0}if((rka(l,59496,1,3)|0)==0){v=128;i=k;return v|0}if((rka(l,59504,1,3)|0)==0){v=128;i=k;return v|0}if((rka(l,59512,1,3)|0)==0){v=128;i=k;return v|0}if((rka(l,59520,1,3)|0)==0){v=128;i=k;return v|0}m=(rka(l,59528,1,3)|0)==0;v=m?128:0;i=k;return v|0}if((rka(t,59552,1,2)|0)==0){if(!(u<<24>>24==68|u<<24>>24==83)){v=0;i=k;return v|0}m=(rka(l,59560,1,3)|0)==0;v=m?32:0;i=k;return v|0}if(u<<24>>24==68|u<<24>>24==83){w=141}else if(u<<24>>24==67|u<<24>>24==90){w=138}else{v=0;i=k;return v|0}do{if((w|0)==138){if((rka(t,59576,1,2)|0)==0){m=(rka(l,59560,1,3)|0)==0;v=m?32:0;i=k;return v|0}else{if(u<<24>>24==68|u<<24>>24==83){w=141;break}else if(u<<24>>24==67|u<<24>>24==90){break}else{v=0}i=k;return v|0}}}while(0);do{if((w|0)==141){if((rka(t,59584,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){break}else{v=0}i=k;return v|0}if((a[l]|0)!=71){v=0;i=k;return v|0}do{if((rka(o,59592,1,2)|0)!=0){if((rka(o,59600,1,2)|0)==0){break}if((rka(o,59608,1,2)|0)==0){break}if((rka(o,59616,1,2)|0)==0){break}if((rka(o,59624,1,2)|0)==0){break}if((rka(o,59632,1,2)|0)==0){break}if((rka(o,59640,1,2)|0)==0){break}else{v=0}i=k;return v|0}}while(0);v=128;i=k;return v|0}}while(0);if((rka(t,59648,1,2)|0)!=0){v=0;i=k;return v|0}if((a[l]|0)!=71){v=0;i=k;return v|0}do{if((rka(o,59592,1,2)|0)!=0){if((rka(o,59600,1,2)|0)==0){break}if((rka(o,59608,1,2)|0)==0){break}if((rka(o,59616,1,2)|0)==0){break}if((rka(o,59624,1,2)|0)==0){break}if((rka(o,59632,1,2)|0)==0){break}if((rka(o,59640,1,2)|0)==0){break}else{v=0}i=k;return v|0}}while(0);v=128;i=k;return v|0}else{if((rka(t,59472,1,2)|0)==0){if((rka(l,59480,1,3)|0)==0){v=64;i=k;return v|0}if((rka(l,59488,1,3)|0)==0){v=32;i=k;return v|0}if((rka(l,59496,1,3)|0)==0){v=32;i=k;return v|0}if((rka(l,59504,1,3)|0)==0){v=32;i=k;return v|0}if((rka(l,59512,1,3)|0)==0){v=32;i=k;return v|0}if((rka(l,59520,1,3)|0)==0){v=32;i=k;return v|0}if((rka(l,59528,1,3)|0)==0){v=32;i=k;return v|0}m=(rka(l,59536,1,3)|0)==0;v=m?64:1;i=k;return v|0}if((rka(t,59544,1,2)|0)==0){m=(rka(l,59480,1,3)|0)==0;v=m?64:1;i=k;return v|0}if((rka(t,59552,1,2)|0)==0){m=(rka(l,59480,1,3)|0)==0;if(m|r^1){v=m?64:1;i=k;return v|0}m=(rka(l,59560,1,3)|0)==0;if(m){v=m?32:1;i=k;return v|0}m=(rka(l,59568,1,3)|0)==0;v=m?64:1;i=k;return v|0}do{if(u<<24>>24==68|u<<24>>24==83){w=29}else if(u<<24>>24==67|u<<24>>24==90){if((rka(t,59576,1,2)|0)!=0){if(u<<24>>24==68|u<<24>>24==83){w=29;break}else if(u<<24>>24==67|u<<24>>24==90){w=48;break}else{break}}if((rka(l,59480,1,3)|0)==0){v=64;i=k;return v|0}if((rka(l,59560,1,3)|0)==0){v=32;i=k;return v|0}m=(rka(l,59568,1,3)|0)==0;v=m?64:1;i=k;return v|0}}while(0);do{if((w|0)==29){if((rka(t,59584,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){w=48;break}else{break}}m=a[l]|0;if(m<<24>>24==77){do{if((rka(o,59592,1,2)|0)!=0){if((rka(o,59600,1,2)|0)==0){break}if((rka(o,59608,1,2)|0)==0){break}if((rka(o,59616,1,2)|0)==0){break}if((rka(o,59624,1,2)|0)==0){break}if((rka(o,59632,1,2)|0)==0){break}if((rka(o,59640,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else if(m<<24>>24==71){do{if((rka(o,59592,1,2)|0)!=0){if((rka(o,59600,1,2)|0)==0){break}if((rka(o,59608,1,2)|0)==0){break}if((rka(o,59616,1,2)|0)==0){break}if((rka(o,59624,1,2)|0)==0){break}if((rka(o,59632,1,2)|0)==0){break}if((rka(o,59640,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else{v=1;i=k;return v|0}}}while(0);do{if((w|0)==48){if((rka(t,59648,1,2)|0)!=0){break}m=a[l]|0;if(m<<24>>24==77){do{if((rka(o,59592,1,2)|0)!=0){if((rka(o,59600,1,2)|0)==0){break}if((rka(o,59608,1,2)|0)==0){break}if((rka(o,59616,1,2)|0)==0){break}if((rka(o,59624,1,2)|0)==0){break}if((rka(o,59632,1,2)|0)==0){break}if((rka(o,59640,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else if(m<<24>>24==71){do{if((rka(o,59592,1,2)|0)!=0){if((rka(o,59600,1,2)|0)==0){break}if((rka(o,59608,1,2)|0)==0){break}if((rka(o,59616,1,2)|0)==0){break}if((rka(o,59624,1,2)|0)==0){break}if((rka(o,59632,1,2)|0)==0){break}if((rka(o,59640,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else{v=1;i=k;return v|0}}}while(0);if((rka(t,59656,1,2)|0)==0){if((rka(l,59480,1,3)|0)!=0){v=1;i=k;return v|0}v=(c[j>>2]|0)<65?1:32;i=k;return v|0}if((rka(t,59664,1,2)|0)==0){if((rka(l,59480,1,3)|0)!=0){v=1;i=k;return v|0}v=(c[g>>2]|0)<65?1:32;i=k;return v|0}if((rka(t,59632,1,2)|0)==0){o=(rka(l,59536,1,3)|0)==0;v=o?64:1;i=k;return v|0}if((rka(t,59672,1,2)|0)==0){o=(rka(l,59680,1,3)|0)==0;v=o?64:1;i=k;return v|0}if(!(u<<24>>24==68|u<<24>>24==83)){v=1;i=k;return v|0}if((rka(t,59688,1,2)|0)==0){i=k;return 1}else{v=1;i=k;return v|0}}break};case 8:{v=50;i=k;return v|0};case 9:{v=25;i=k;return v|0};case 10:{v=KY(59704,59712,59720)|0;i=k;return v|0};case 11:{v=KY(59728,59712,59720)|0;i=k;return v|0};case 16:case 15:case 14:case 13:case 12:{v=LY(b,d,e,f,g,h,j)|0;i=k;return v|0};case 4:{v=6;i=k;return v|0};case 5:{v=2;i=k;return v|0};case 6:{j=c[f>>2]|0;f=c[g>>2]|0;v=~~(+(((j|0)>(f|0)?f:j)|0)*1.600000023841858);i=k;return v|0};case 7:{v=1;i=k;return v|0};default:{v=-1;i=k;return v|0}}return 0}function KY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0.0,h=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=+g[d>>2];h=+g[b>>2];do{if(!(f/h<=f)){j=-f/h;if(j>=h){k=0;break}l=f/(f+j);if(l!=h){k=0;break}j=f/l;if(j>=h){k=0;break}m=h+l;if(m!=h){k=0;break}n=f/m;if(n<=f){k=0;break}m=j*n;if(m>=h){k=0;break}j=n*n;if(j<=f){k=0;break}if((c[a>>2]|0)==0){k=1;break}n=j+m;o=j/j;p=h*j;q=l*m;l=j/m;if(n==n&0.0==0.0|l==l&0.0==0.0|o==o&0.0==0.0|p==p&0.0==0.0|q==q&0.0==0.0){k=0;break}p=q*0.0;k=(p!=p|0.0!=0.0)&1}else{k=0}}while(0);i=e;return k|0}function LY(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+8|0;e=j;d=c[a>>2]|0;if((d|0)==16|(d|0)==13|(d|0)==15){b=(c[h>>2]|0)-(c[f>>2]|0)+1|0;if((b|0)>149){g[e>>2]=+da(+(+(b|0)))/.6931471805599453;f=(b|0)/(qka(e)|0)|0;k=c[a>>2]|0;l=(f|0)>10?f:10}else{k=d;l=(b|0)>59?10:(b|0)>29?4:2}f=(b|0)>5999?256:(b|0)>2999?128:(b|0)>589?64:l;l=f-((f|0)%2|0)|0;m=k;n=b;o=(l|0)>2?l:2}else{m=d;n=0;o=0}switch(m|0){case 16:{m=(o|0)>13;i=j;return(m?2:m&1)|0};case 13:{if((n|0)<501){p=o;i=j;return p|0}p=(o*3|0)/2|0;i=j;return p|0};case 14:{p=14;i=j;return p|0};case 12:{p=75;i=j;return p|0};case 15:{p=o;i=j;return p|0};default:{p=-1;i=j;return p|0}}return 0}function MY(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=NY(a,0,0)|0;i=b;return c|0}function NY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=OY(a,b,c,0)|0;i=d;return e|0}function OY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+64|0;h=b;b=d;d=e;e=f;do{if((b|0)!=0){j=ae[c[b>>2]&127](500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}else{j=Jwa(500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=29;c[f+4>>2]=48;c[f+8>>2]=941}}while(0);b=j;if((j|0)==0){k=b;l=k;i=g;return l|0}c[b+8>>2]=0;c[j+32>>2]=0;c[j+380>>2]=16;c[j+392>>2]=ae[c[j+12>>2]&127](c[j+380>>2]<<4)|0;b=j+12|0;if((c[j+392>>2]|0)==0){Zd[c[b+8>>2]&1023](j);k=0;l=k;i=g;return l|0}c[j+44>>2]=ae[c[b>>2]&127](1024)|0;b=j;if((c[j+44>>2]|0)==0){Zd[c[b+20>>2]&1023](c[j+392>>2]|0);Zd[c[j+20>>2]&1023](j);k=0;l=k;i=g;return l|0}c[j+48>>2]=(c[b+44>>2]|0)+1024;do{if((e|0)!=0){c[j+356>>2]=e}else{c[j+356>>2]=ZZ(j+12|0)|0;if((c[j+356>>2]|0)!=0){break}Zd[c[j+20>>2]&1023](c[j+44>>2]|0);Zd[c[j+20>>2]&1023](c[j+392>>2]|0);Zd[c[j+20>>2]&1023](j);k=0;l=k;i=g;return l|0}}while(0);c[j+376>>2]=0;c[j+368>>2]=0;c[j+304>>2]=0;c[j+468>>2]=0;c[j+464>>2]=0;c[j+124>>2]=0;c[j+248>>2]=0;a[j+472|0]=33;a[j+236|0]=0;a[j+237|0]=0;c[j+396>>2]=0;c[j+400>>2]=0;a[j+404|0]=0;_Z(j+416|0,j+12|0);_Z(j+440|0,j+12|0);QY(j,h);do{if((h|0)!=0){if((c[j+232>>2]|0)!=0){break}TY(j);k=0;l=k;i=g;return l|0}}while(0);if((d|0)!=0){a[j+236|0]=1;c[j+228>>2]=s_()|0;a[j+472|0]=a[d]|0}else{c[j+228>>2]=j_()|0}k=j;l=k;i=g;return l|0}function PY(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;a=c[d>>2]|0;a:do{if((c[d+4>>2]|0)!=0){e=a;while(1){if((e|0)==0){break a}f=c[e>>2]|0;c[e>>2]=c[d+4>>2];c[d+4>>2]=e;e=f}}else{c[d+4>>2]=a}}while(0);c[d>>2]=0;c[d+16>>2]=0;c[d+12>>2]=0;c[d+8>>2]=0;i=b;return}function QY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=d;c[f+280>>2]=37;B0(f+256|0);if((b|0)!=0){g=RY(f+416|0,b)|0}else{g=0}c[f+232>>2]=g;c[f+360>>2]=0;k_(f+148|0,f+144|0,0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=0;c[f+64>>2]=0;c[f+68>>2]=0;c[f+72>>2]=0;c[f+76>>2]=0;c[f+80>>2]=0;c[f+84>>2]=0;c[f+88>>2]=0;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;c[f+104>>2]=0;c[f+108>>2]=0;c[f+112>>2]=0;c[f+116>>2]=f;c[f+120>>2]=0;c[f+128>>2]=0;c[f+132>>2]=0;c[f+136>>2]=0;c[f+140>>2]=0;c[f+24>>2]=c[f+8>>2];c[f+28>>2]=c[f+8>>2];c[f+36>>2]=0;c[f+40>>2]=0;c[f+344>>2]=0;c[f+348>>2]=0;c[f+316>>2]=0;c[f+320>>2]=0;c[f+324>>2]=0;c[f+328>>2]=0;c[f+332>>2]=0;c[f+336>>2]=0;c[f+340>>2]=0;a[f+352|0]=0;a[f+353|0]=0;g=f+408|0;c[g+0>>2]=0;c[g+4>>2]=0;c[f+284>>2]=0;c[f+288>>2]=0;c[f+292>>2]=0;c[f+296>>2]=0;c[f+300>>2]=0;a[f+308|0]=1;c[f+312>>2]=0;c[f+364>>2]=0;c[f+372>>2]=0;c[f+384>>2]=0;c[f+240>>2]=0;c[f+252>>2]=0;c[f+244>>2]=0;c[f+476>>2]=0;c[f+480>>2]=0;a[f+488|0]=0;a[f+489|0]=0;c[f+492>>2]=0;c[f+496>>2]=0;i=e;return}function RY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+24|0;f=b;b=d;while(1){if((c[f+12>>2]|0)==(c[f+8>>2]|0)){if(!((gZ(f)|0)<<24>>24!=0)){g=5;break}}d=a[b]|0;h=f+12|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j]=d;d=b;b=d+1|0;if((a[d]|0)==0){g=6;break}}if((g|0)==5){k=0;l=k;i=e;return l|0}else if((g|0)==6){b=c[f+16>>2]|0;c[f+16>>2]=c[f+12>>2];k=b;l=k;i=e;return l|0}return 0}function SY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=b;a:while(1){if((a[b]|0)==0){h=45;break}do{if((a[g]|0)!=12){if((a[g]|0)==0){break}j=c[f+428>>2]|0;k=f+416|0;if((a[g]|0)!=61){if((j|0)==(c[k+8>>2]|0)){if(!((gZ(f+416|0)|0)<<24>>24!=0)){h=44;break a}}l=a[g]|0;m=f+428|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;g=g+1|0;continue a}if((j-(c[k+16>>2]|0)|0)==0){o=d+152|0}else{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((gZ(f+416|0)|0)<<24>>24!=0)){h=19;break a}}k=f+428|0;j=c[k>>2]|0;c[k>>2]=j+1;a[j]=0;o=jZ(f,d+60|0,c[f+432>>2]|0,8)|0;if((o|0)==0){h=20;break a}if((c[o>>2]|0)==(c[f+432>>2]|0)){c[o>>2]=RY(d+80|0,c[o>>2]|0)|0;if((c[o>>2]|0)==0){h=23;break a}}c[f+428>>2]=c[f+432>>2]}b=g+1|0;while(1){if((a[b]|0)!=12){p=(a[b]|0)!=0}else{p=0}q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if(!p){break}if(q){if(!((gZ(f+416|0)|0)<<24>>24!=0)){h=32;break a}}j=a[b]|0;k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=j;b=b+1|0}if(q){if(!((gZ(f+416|0)|0)<<24>>24!=0)){h=36;break a}}j=f+428|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;if((nZ(f,o,0,c[f+432>>2]|0,f+372|0)|0)!=0){h=37;break a}c[f+428>>2]=c[f+432>>2];if((a[b]|0)!=0){b=b+1|0}g=b;continue a}}while(0);if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((gZ(f+416|0)|0)<<24>>24!=0)){h=8;break}}l=f+428|0;j=c[l>>2]|0;c[l>>2]=j+1;a[j]=0;j=jZ(f,d,c[f+432>>2]|0,0)|0;if((j|0)!=0){a[j+32|0]=1}if((a[g]|0)!=0){g=g+1|0}b=g;c[f+428>>2]=c[f+432>>2]}if((h|0)==8){r=0;s=r;i=e;return s|0}else if((h|0)==19){r=0;s=r;i=e;return s|0}else if((h|0)==20){r=0;s=r;i=e;return s|0}else if((h|0)==23){r=0;s=r;i=e;return s|0}else if((h|0)==32){r=0;s=r;i=e;return s|0}else if((h|0)==36){r=0;s=r;i=e;return s|0}else if((h|0)==37){r=0;s=r;i=e;return s|0}else if((h|0)==44){r=0;s=r;i=e;return s|0}else if((h|0)==45){r=1;s=r;i=e;return s|0}return 0}function TY(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=b;if((e|0)==0){i=d;return}b=c[e+364>>2]|0;while(1){if((b|0)==0){f=e;if((c[e+368>>2]|0)==0){break}b=c[f+368>>2]|0;c[e+368>>2]=0}g=b;b=c[b>>2]|0;Zd[c[e+20>>2]&1023](c[g+36>>2]|0);UY(c[g+44>>2]|0,e);Zd[c[e+20>>2]&1023](g)}b=c[f+300>>2]|0;while(1){if((b|0)==0){h=e;if((c[e+304>>2]|0)==0){break}b=c[h+304>>2]|0;c[e+304>>2]=0}f=b;b=c[b+8>>2]|0;Zd[c[e+20>>2]&1023](f)}UY(c[h+376>>2]|0,e);UY(c[e+372>>2]|0,e);VY(e+416|0);VY(e+440|0);do{if((a[e+488|0]|0)==0){if((c[e+356>>2]|0)==0){break}WY(c[e+356>>2]|0,((c[e+476>>2]|0)!=0^1)&1,e+12|0)}}while(0);Zd[c[e+20>>2]&1023](c[e+392>>2]|0);Zd[c[e+20>>2]&1023](c[e+464>>2]|0);Zd[c[e+20>>2]&1023](c[e+8>>2]|0);Zd[c[e+20>>2]&1023](c[e+44>>2]|0);Zd[c[e+20>>2]&1023](c[e+396>>2]|0);Zd[c[e+20>>2]&1023](c[e+240>>2]|0);if((c[e+252>>2]|0)!=0){Zd[c[e+252>>2]&1023](c[e+244>>2]|0)}Zd[c[e+20>>2]&1023](e);i=d;return}function UY(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+24|0;e=a;a=b;while(1){b=e;if((b|0)==0){break}e=c[b+4>>2]|0;Zd[c[a+20>>2]&1023](c[b+16>>2]|0);Zd[c[a+20>>2]&1023](b)}i=d;return}function VY(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=a;a=c[d>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;Zd[c[(c[d+20>>2]|0)+8>>2]&1023](a);a=e}a=c[d+4>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;Zd[c[(c[d+20>>2]|0)+8>>2]&1023](a);a=e}i=b;return}function WY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+40|0;f=e+24|0;g=a;a=b;b=d;hZ(f,g+20|0);while(1){d=iZ(f)|0;if((d|0)==0){break}if((c[d+16>>2]|0)==0){continue}Zd[c[b+8>>2]&1023](c[d+20>>2]|0)}mZ(g);mZ(g+132|0);mZ(g+20|0);mZ(g+40|0);mZ(g+60|0);VY(g+80|0);VY(g+104|0);if(!(a<<24>>24!=0)){h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;Zd[m&1023](o);i=e;return}Zd[c[b+8>>2]&1023](c[g+184>>2]|0);Zd[c[b+8>>2]&1023](c[g+164>>2]|0);h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;Zd[m&1023](o);i=e;return}function XY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a;a=(c[e+4>>2]|0)==(c[e>>2]|0);f=b;c[e>>2]=f;if(!a){i=d;return}c[e+4>>2]=f;i=d;return}function YY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+24|0;f=a;c[f+52>>2]=b;c[f+56>>2]=d;i=e;return}function ZY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=d;d=e;e=f;f=c[h+480>>2]|0;do{if((f|0)==2){c[h+284>>2]=36;j=0;k=j;i=g;return k|0}else if((f|0)==3){c[h+284>>2]=33;j=0;k=j;i=g;return k|0}else if((f|0)==0){if((c[h+476>>2]|0)!=0){break}if((_Y(h)|0)<<24>>24!=0){break}c[h+284>>2]=1;j=0;k=j;i=g;return k|0}}while(0);c[h+480>>2]=1;if((d|0)!=0){f=aZ(h,d)|0;if((f|0)==0){j=0;k=j;i=g;return k|0}else{nxa(f|0,b|0,d|0)|0;j=bZ(h,d,e)|0;k=j;i=g;return k|0}}a[h+484|0]=e;if((e|0)==0){j=1;k=j;i=g;return k|0}c[h+296>>2]=c[h+24>>2];c[h+40>>2]=c[h+28>>2];c[h+284>>2]=ze[c[h+280>>2]&63](h,c[h+24>>2]|0,c[h+40>>2]|0,h+24|0)|0;e=h;if((c[h+284>>2]|0)!=0){c[h+292>>2]=c[e+288>>2];c[h+280>>2]=38;j=0;k=j;i=g;return k|0}d=c[e+480>>2]|0;if((d|0)==3){Ae[c[(c[h+144>>2]|0)+52>>2]&63](c[h+144>>2]|0,c[h+296>>2]|0,c[h+24>>2]|0,h+408|0);c[h+296>>2]=c[h+24>>2];j=2;k=j;i=g;return k|0}else if((d|0)==1|(d|0)==0){c[h+480>>2]=2}j=1;k=j;i=g;return k|0}function _Y(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=b;if((c[e+496>>2]|0)==0){c[e+496>>2]=XZ()|0}if((a[e+236|0]|0)!=0){f=SY(e,61512)|0;g=f;i=d;return g|0}else{f=1;g=f;i=d;return g|0}return 0}function $Y(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+32|0;i=e;return c[a+284>>2]|0}function aZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+72|0;e=a;a=b;b=c[e+480>>2]|0;if((b|0)==2){c[e+284>>2]=36;f=0;g=f;i=d;return g|0}else if((b|0)==3){c[e+284>>2]=33;f=0;g=f;i=d;return g|0}else{if((a|0)>((c[e+32>>2]|0)-(c[e+28>>2]|0)|0)){b=a+((c[e+28>>2]|0)-(c[e+24>>2]|0))|0;a=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;h=a;h=(h|0)>1024?1024:a;b=b+h|0;do{if((b|0)<=((c[e+32>>2]|0)-(c[e+8>>2]|0)|0)){if((h|0)>=((c[e+24>>2]|0)-(c[e+8>>2]|0)|0)){break}a=(c[e+24>>2]|0)-(c[e+8>>2]|0)-h|0;oxa(c[e+8>>2]|0,(c[e+8>>2]|0)+a|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+h|0)|0;j=e+28|0;c[j>>2]=(c[j>>2]|0)+(0-a);j=e+24|0;c[j>>2]=(c[j>>2]|0)+(0-a)}else{a=(c[e+32>>2]|0)-(c[e+24>>2]|0)|0;j=a;j=(j|0)==0?1024:a;do{j=j<<1;}while((j|0)<(b|0));a=ae[c[e+12>>2]&127](j)|0;if((a|0)==0){c[e+284>>2]=1;f=0;g=f;i=d;return g|0}c[e+32>>2]=a+j;if((c[e+24>>2]|0)!=0){k=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;l=k;l=(l|0)>1024?1024:k;nxa(a|0,(c[e+24>>2]|0)+(0-l)|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+l|0)|0;Zd[c[e+20>>2]&1023](c[e+8>>2]|0);c[e+8>>2]=a;c[e+28>>2]=(c[e+8>>2]|0)+((c[e+28>>2]|0)-(c[e+24>>2]|0))+l;c[e+24>>2]=(c[e+8>>2]|0)+l;break}else{c[e+28>>2]=a+((c[e+28>>2]|0)-(c[e+24>>2]|0));l=a;c[e+8>>2]=l;c[e+24>>2]=l;break}}}while(0);c[e+292>>2]=0;c[e+288>>2]=0;c[e+296>>2]=0}f=c[e+28>>2]|0;g=f;i=d;return g|0}return 0}function bZ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=b;b=d;d=e;e=1;h=c[g+480>>2]|0;do{if((h|0)==3){c[g+284>>2]=33;j=0;k=j;i=f;return k|0}else if((h|0)==2){c[g+284>>2]=36;j=0;k=j;i=f;return k|0}else if((h|0)==0){if((c[g+476>>2]|0)!=0){break}if((_Y(g)|0)<<24>>24!=0){break}c[g+284>>2]=1;j=0;k=j;i=f;return k|0}}while(0);c[g+480>>2]=1;h=c[g+24>>2]|0;c[g+296>>2]=h;l=g+28|0;c[l>>2]=(c[l>>2]|0)+b;c[g+40>>2]=c[g+28>>2];l=g+36|0;c[l>>2]=(c[l>>2]|0)+b;a[g+484|0]=d;c[g+284>>2]=ze[c[g+280>>2]&63](g,h,c[g+40>>2]|0,g+24|0)|0;h=g;if((c[g+284>>2]|0)!=0){c[g+292>>2]=c[h+288>>2];c[g+280>>2]=38;j=0;k=j;i=f;return k|0}b=c[h+480>>2]|0;do{if((b|0)==1|(b|0)==0){if((d|0)==0){break}c[g+480>>2]=2;j=e;k=j;i=f;return k|0}else if((b|0)==3){e=2}}while(0);Ae[c[(c[g+144>>2]|0)+52>>2]&63](c[g+144>>2]|0,c[g+296>>2]|0,c[g+24>>2]|0,g+408|0);c[g+296>>2]=c[g+24>>2];j=e;k=j;i=f;return k|0}function cZ(a){a=a|0;var b=0;b=i;i=i+8|0;i=b;return c[a+284>>2]|0}function dZ(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;do{if((c[d+288>>2]|0)!=0){if(!((c[d+288>>2]|0)>>>0>=(c[d+296>>2]|0)>>>0)){break}Ae[c[(c[d+144>>2]|0)+52>>2]&63](c[d+144>>2]|0,c[d+296>>2]|0,c[d+288>>2]|0,d+408|0);c[d+296>>2]=c[d+288>>2]}}while(0);i=b;return(c[d+408>>2]|0)+1|0}function eZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+16|0;j=g+48|0;k=b;b=d;c[h>>2]=e;e=f;if((a[b+72|0]|0)!=0){we[c[k+80>>2]&15](c[k+4>>2]|0,c[h>>2]|0,e-(c[h>>2]|0)|0);i=g;return}f=k;if((b|0)==(c[k+144>>2]|0)){l=f+288|0;m=k+292|0}else{l=c[f+300>>2]|0;m=(c[k+300>>2]|0)+4|0}do{c[j>>2]=c[k+44>>2];Wd[c[b+60>>2]&31](b,h,e,j,c[k+48>>2]|0);c[m>>2]=c[h>>2];we[c[k+80>>2]&15](c[k+4>>2]|0,c[k+44>>2]|0,(c[j>>2]|0)-(c[k+44>>2]|0)|0);c[l>>2]=c[h>>2];}while((c[h>>2]|0)!=(e|0));i=g;return}function fZ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;if(d>>>0>0&d>>>0<41){e=c[59736+(d<<2)>>2]|0;f=e;i=b;return f|0}else{e=0;f=e;i=b;return f|0}return 0}function gZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;do{if((c[d+4>>2]|0)!=0){a=d;if((c[d+16>>2]|0)==0){c[d>>2]=c[a+4>>2];c[d+4>>2]=c[c[d+4>>2]>>2];c[c[d>>2]>>2]=0;c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);c[d+12>>2]=c[d+16>>2];e=1;f=e;i=b;return f|0}if(((c[a+8>>2]|0)-(c[d+16>>2]|0)|0)>=(c[(c[d+4>>2]|0)+4>>2]|0)){break}a=c[c[d+4>>2]>>2]|0;c[c[d+4>>2]>>2]=c[d>>2];c[d>>2]=c[d+4>>2];c[d+4>>2]=a;nxa((c[d>>2]|0)+8|0,c[d+16>>2]|0,(c[d+8>>2]|0)-(c[d+16>>2]|0)|0)|0;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);e=1;f=e;i=b;return f|0}}while(0);do{if((c[d>>2]|0)!=0){if((c[d+16>>2]|0)!=((c[d>>2]|0)+8|0)){g=11;break}a=(c[d+8>>2]|0)-(c[d+16>>2]|0)<<1;h=pe[c[(c[d+20>>2]|0)+4>>2]&63](c[d>>2]|0,8+a|0)|0;if((h|0)!=0){c[d>>2]=h;c[(c[d>>2]|0)+4>>2]=a;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+a;break}e=0;f=e;i=b;return f|0}else{g=11}}while(0);if((g|0)==11){g=(c[d+8>>2]|0)-(c[d+16>>2]|0)|0;if((g|0)<1024){g=1024}else{g=g<<1}a=ae[c[c[d+20>>2]>>2]&127](8+g|0)|0;if((a|0)==0){e=0;f=e;i=b;return f|0}c[a+4>>2]=g;c[a>>2]=c[d>>2];c[d>>2]=a;if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){nxa(a+8|0,c[d+16>>2]|0,(c[d+12>>2]|0)-(c[d+16>>2]|0)|0)|0}c[d+12>>2]=a+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=a+8;c[d+8>>2]=a+8+g}e=1;f=e;i=b;return f|0}function hZ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;a=b;c[e>>2]=c[a>>2];c[e+4>>2]=(c[e>>2]|0)+(c[a+8>>2]<<2);i=d;return}function iZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+24|0;d=a;while(1){if((c[d>>2]|0)==(c[d+4>>2]|0)){e=5;break}a=d;f=c[a>>2]|0;c[a>>2]=f+4;g=c[f>>2]|0;if((g|0)!=0){e=4;break}}if((e|0)==4){h=g;j=h;i=b;return j|0}else if((e|0)==5){h=0;j=h;i=b;return j|0}return 0}function jZ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+136|0;j=b;b=e;e=f;f=g;a:do{if((c[b+8>>2]|0)==0){if((f|0)==0){k=0;l=k;i=h;return l|0}a[b+4|0]=6;c[b+8>>2]=64;g=c[b+8>>2]<<2;c[b>>2]=ae[c[c[b+16>>2]>>2]&127](g)|0;m=b;if((c[b>>2]|0)!=0){pxa(c[m>>2]|0,0,g|0)|0;g=kZ(j,e)|0;n=g&(c[b+8>>2]|0)-1;break}c[m+8>>2]=0;k=0;l=k;i=h;return l|0}else{m=kZ(j,e)|0;g=(c[b+8>>2]|0)-1|0;o=0;n=m&g;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break}if((lZ(e,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0)<<24>>24!=0){p=10;break}if(!(o<<24>>24!=0)){o=((m&~g)>>>((d[b+4|0]|0)-1|0)&g>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+((c[b+8>>2]|0)-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}if((p|0)==10){k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}if((f|0)==0){k=0;l=k;i=h;return l|0}if(((c[b+12>>2]|0)>>>((d[b+4|0]|0)-1|0)|0)==0){break}g=(d[b+4|0]|0)+1&255;q=1<<(g&255);r=q-1|0;s=q<<2;t=ae[c[c[b+16>>2]>>2]&127](s)|0;if((t|0)==0){k=0;l=k;i=h;return l|0}pxa(t|0,0,s|0)|0;n=0;while(1){if(!(n>>>0<(c[b+8>>2]|0)>>>0)){break}if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){s=kZ(j,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0;u=s&r;o=0;while(1){if((c[t+(u<<2)>>2]|0)==0){break}if(!(o<<24>>24!=0)){o=((s&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(u>>>0<(o&255)>>>0){u=u+(q-(o&255))|0;continue}else{u=u-(o&255)|0;continue}}c[t+(u<<2)>>2]=c[(c[b>>2]|0)+(n<<2)>>2]}n=n+1|0}Zd[c[(c[b+16>>2]|0)+8>>2]&1023](c[b>>2]|0);c[b>>2]=t;a[b+4|0]=g;c[b+8>>2]=q;n=m&r;o=0;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break a}if(!(o<<24>>24!=0)){o=((m&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+(q-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}}}while(0);j=ae[c[c[b+16>>2]>>2]&127](f)|0;c[(c[b>>2]|0)+(n<<2)>>2]=j;if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){pxa(c[(c[b>>2]|0)+(n<<2)>>2]|0,0,f|0)|0;c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]=e;e=b+12|0;c[e>>2]=(c[e>>2]|0)+1;k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}else{k=0;l=k;i=h;return l|0}return 0}function kZ(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+24|0;g=e;e=c[b+496>>2]|0;while(1){h=e;if((a[g]|0)==0){break}b=g;g=b+1|0;e=h*1000003^d[b]}i=f;return h|0}function lZ(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;while(1){if((a[e]|0)!=(a[b]|0)){f=6;break}if((a[e]|0)==0){f=4;break}e=e+1|0;b=b+1|0}if((f|0)==4){g=1;h=g;i=d;return h|0}else if((f|0)==6){g=0;h=g;i=d;return h|0}return 0}function mZ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;a=0;while(1){e=c[(c[d+16>>2]|0)+8>>2]|0;if(!(a>>>0<(c[d+8>>2]|0)>>>0)){break}Zd[e&1023](c[(c[d>>2]|0)+(a<<2)>>2]|0);a=a+1|0}Zd[e&1023](c[d>>2]|0);i=b;return}function nZ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+96|0;j=b;b=d;d=e;e=f;f=g;g=0;k=1;l=1;do{if((a[e]|0)==0){if((c[b>>2]|0)==0){break}m=28;n=m;i=h;return n|0}}while(0);do{if((c[b>>2]|0)!=0){if((a[c[b>>2]|0]|0)!=120){break}if((a[(c[b>>2]|0)+1|0]|0)!=109){break}if((a[(c[b>>2]|0)+2|0]|0)!=108){break}do{if((a[(c[b>>2]|0)+3|0]|0)==110){if((a[(c[b>>2]|0)+4|0]|0)!=115){break}if((a[(c[b>>2]|0)+5|0]|0)!=0){break}m=39;n=m;i=h;return n|0}}while(0);if((a[(c[b>>2]|0)+3|0]|0)!=0){break}g=1}}while(0);o=0;while(1){p=(k&255|0)!=0;if((a[e+o|0]|0)==0){break}do{if(p){if((o|0)<=36){if((a[e+o|0]|0)==(a[61320+o|0]|0)){break}}k=0}}while(0);do{if(!(g<<24>>24!=0)){if((l&255|0)==0){break}if((o|0)<=29){if((a[e+o|0]|0)==(a[61360+o|0]|0)){break}}l=0}}while(0);o=o+1|0}if(p){q=(o|0)==36}else{q=0}k=q&1;if((l&255|0)!=0){r=(o|0)==29}else{r=0}l=r&1;if((g&255|0)!=(k&255|0)){m=(g&255|0)!=0?38:40;n=m;i=h;return n|0}if(l<<24>>24!=0){m=40;n=m;i=h;return n|0}if((a[j+472|0]|0)!=0){o=o+1|0}l=j;do{if((c[j+376>>2]|0)!=0){s=c[l+376>>2]|0;do{if((o|0)>(c[s+24>>2]|0)){g=pe[c[j+16>>2]&63](c[s+16>>2]|0,o+24|0)|0;if((g|0)!=0){c[s+16>>2]=g;c[s+24>>2]=o+24;break}m=1;n=m;i=h;return n|0}}while(0);c[j+376>>2]=c[s+4>>2]}else{s=ae[c[l+12>>2]&127](28)|0;if((s|0)==0){m=1;n=m;i=h;return n|0}c[s+16>>2]=ae[c[j+12>>2]&127](o+24|0)|0;if((c[s+16>>2]|0)!=0){c[s+24>>2]=o+24;break}Zd[c[j+20>>2]&1023](s);m=1;n=m;i=h;return n|0}}while(0);c[s+20>>2]=o;nxa(c[s+16>>2]|0,e|0,o|0)|0;if((a[j+472|0]|0)!=0){a[(c[s+16>>2]|0)+(o-1)|0]=a[j+472|0]|0}c[s>>2]=b;c[s+12>>2]=d;c[s+8>>2]=c[b+4>>2];do{if((a[e]|0)==0){if((b|0)!=((c[j+356>>2]|0)+152|0)){t=52;break}c[b+4>>2]=0}else{t=52}}while(0);if((t|0)==52){c[b+4>>2]=s}c[s+4>>2]=c[f>>2];c[f>>2]=s;do{if((d|0)!=0){if((c[j+100>>2]|0)==0){break}we[c[j+100>>2]&15](c[j+4>>2]|0,c[b>>2]|0,(c[b+4>>2]|0)!=0?e:0)}}while(0);m=0;n=m;i=h;return n|0}function oZ(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=b;if((de[((a[e+236|0]&255|0)!=0?33:34)&63](e+148|0,e+144|0,c[e+232>>2]|0)|0)!=0){f=0;g=f;i=d;return g|0}else{f=WZ(e,c[e+232>>2]|0)|0;g=f;i=d;return g|0}return 0}function pZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+32|0;j=b;b=d;d=e;c[h>>2]=b;e=ze[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=qZ(j,c[j+144>>2]|0,b,d,e,c[h>>2]|0,f,((a[j+484|0]|0)!=0^1)&1)|0;i=g;return k|0}function qZ(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+368|0;n=m+48|0;o=b;b=e;e=f;f=g;g=h;c[n>>2]=j;j=k;k=l;l=c[o+356>>2]|0;h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}a:while(1){h=1;c[p>>2]=e;c[q>>2]=c[n>>2];b:do{if((g|0)<=0){if((k&255|0)!=0){if((g|0)!=0){r=7;break a}}switch(g|0){case 0:{r=9;break a;break};case-1:{r=10;break a;break};case-2:{r=11;break a;break};case-15:{g=0-g|0;break b;break};case-4:{r=13;break a;break};default:{g=0-g|0;c[n>>2]=f;break b}}}}while(0);s=qe[c[o+256>>2]&63](o+256|0,g,e,c[n>>2]|0,b)|0;c:do{switch(s|0){case 1:{t=rZ(o,0,e,c[n>>2]|0)|0;if((t|0)!=0){r=25;break a}b=c[o+144>>2]|0;h=0;break};case 6:{a[o+489|0]=0;c[o+316>>2]=jZ(o,l+132|0,61392,36)|0;if((c[o+316>>2]|0)==0){r=38;break a}a[l+129|0]=1;if((c[o+84>>2]|0)==0){r=45;break c}if((ze[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=41;break a}u=sZ(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((u|0)==0){r=43;break a}tZ(u);c[o+432>>2]=c[o+428>>2];c[o+328>>2]=u;h=0;r=47;break};case 4:{if((c[o+84>>2]|0)!=0){c[o+320>>2]=sZ(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+320>>2]|0)==0){r=29;break a}c[o+432>>2]=c[o+428>>2];c[o+328>>2]=0;h=0}c[o+324>>2]=0;break};case 7:{if((c[o+84>>2]|0)==0){break c}Wd[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,1);c[o+320>>2]=0;PY(o+416|0);h=0;break};case 57:{v=rZ(o,1,e,c[n>>2]|0)|0;if((v|0)!=0){r=35;break a}b=c[o+144>>2]|0;h=0;break};case 22:{c[o+348>>2]=wZ(o,b,e,c[n>>2]|0)|0;if((c[o+348>>2]|0)==0){r=92;break a}a[o+352|0]=0;c[o+332>>2]=0;a[o+353|0]=0;r=102;break};case 14:{r=45;break};case 8:{if((c[o+320>>2]|0)!=0){Wd[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,0);PY(o+416|0);h=0}if((c[o+324>>2]|0)!=0){r=57}else{if((d[o+489|0]|0)!=0){r=57}}if((r|0)==57){r=0;u=a[l+129|0]|0;a[l+129|0]=1;do{if((c[o+492>>2]|0)!=0){if((c[o+112>>2]|0)==0){break}w=jZ(o,l+132|0,61392,36)|0;if((w|0)==0){r=60;break a}if((a[o+489|0]|0)!=0){c[w+20>>2]=c[o+360>>2]}a[l+131|0]=0;if((qe[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)==0){r=64;break a}if((a[l+131|0]|0)==0){if((c[o+324>>2]|0)!=0){break}a[l+129|0]=u;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((ae[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=69;break a}}}while(0);a[o+489|0]=0}if((c[o+88>>2]|0)==0){break c}Zd[c[o+88>>2]&1023](c[o+4>>2]|0);h=0;break};case 2:{r=75;break a;break};case 34:{c[o+344>>2]=vZ(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)!=0){r=102}else{r=90;break a}break};case 32:case 31:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)!=0){x=61496}else{x=(s|0)==32?61480:61504}if((xZ(o+416|0,x)|0)==0){r=111;break a}if((yZ(o+416|0,b,e,c[n>>2]|0)|0)==0){r=113;break a}c[o+332>>2]=c[o+432>>2];h=0;break};case 23:{a[o+352|0]=1;c[o+332>>2]=61400;r=102;break};case 24:{a[o+353|0]=1;c[o+332>>2]=61408;r=102;break};case 25:{c[o+332>>2]=61416;r=102;break};case 26:{c[o+332>>2]=61424;r=102;break};case 27:{c[o+332>>2]=61432;r=102;break};case 28:{c[o+332>>2]=61440;r=102;break};case 29:{c[o+332>>2]=61456;r=102;break};case 30:{c[o+332>>2]=61464;r=102;break};case 36:case 35:{if((a[l+128|0]|0)==0){break c}if((zZ(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,a[o+353|0]|0,0,o)|0)==0){r=117;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=123}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=123}}}while(0);if((r|0)==123){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((gZ(o+416|0)|0)<<24>>24!=0)){r=128;break a}}u=o+428|0;w=c[u>>2]|0;c[u>>2]=w+1;a[w]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((gZ(o+416|0)|0)<<24>>24!=0)){r=128;break a}}w=o+428|0;u=c[w>>2]|0;c[w>>2]=u+1;a[u]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;je[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,0,(s|0)==36|0);PY(o+416|0);h=0;break};case 5:{a[o+489|0]=0;a[l+129|0]=1;u=o;if((c[o+84>>2]|0)!=0){c[o+324>>2]=sZ(u+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((c[o+324>>2]|0)==0){r=156;break a}c[o+432>>2]=c[o+428>>2];h=0}else{c[u+324>>2]=61392}do{if((a[l+130|0]|0)==0){if((c[o+492>>2]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((ae[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=163;break a}}}while(0);if((c[o+316>>2]|0)!=0){r=168;break c}c[o+316>>2]=jZ(o,l+132|0,61392,36)|0;if((c[o+316>>2]|0)==0){r=166;break a}c[(c[o+316>>2]|0)+24>>2]=0;r=168;break};case 38:case 37:{if((a[l+128|0]|0)==0){break c}y=AZ(o,b,a[o+352|0]|0,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0,l+80|0)|0;if((y|0)!=0){r=132;break a}u=c[l+96>>2]|0;c[l+96>>2]=c[l+92>>2];if((zZ(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,0,u,o)|0)==0){r=134;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=140}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=140}}}while(0);if((r|0)==140){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((gZ(o+416|0)|0)<<24>>24!=0)){r=145;break a}}w=o+428|0;z=c[w>>2]|0;c[w>>2]=z+1;a[z]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((gZ(o+416|0)|0)<<24>>24!=0)){r=145;break a}}z=o+428|0;w=c[z>>2]|0;c[z>>2]=w+1;a[w]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;je[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,u,(s|0)==38|0);PY(o+416|0);h=0;break};case 12:{if((a[l+128|0]|0)==0){break c}A=BZ(o,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;w=c[l+120>>2]|0;do{if((c[o+316>>2]|0)!=0){c[(c[o+316>>2]|0)+4>>2]=w;c[(c[o+316>>2]|0)+8>>2]=(c[l+116>>2]|0)-(c[l+120>>2]|0);c[l+120>>2]=c[l+116>>2];if((c[o+136>>2]|0)==0){break}c[q>>2]=e;oe[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,c[(c[o+316>>2]|0)+4>>2]|0,c[(c[o+316>>2]|0)+8>>2]|0,c[o+360>>2]|0,0,0,0);h=0}else{c[l+116>>2]=w}}while(0);if((A|0)!=0){r=153;break a}break};case 13:{r=168;break};case 15:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;oe[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,0);h=0;break};case 16:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}w=sZ(l+80|0,b,e,c[n>>2]|0)|0;c[(c[o+316>>2]|0)+28>>2]=w;if((c[(c[o+316>>2]|0)+28>>2]|0)==0){r=181;break a}c[l+96>>2]=c[l+92>>2];if((c[o+92>>2]|0)!=0){c[q>>2]=e;je[c[o+92>>2]&31](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;oe[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break};case 9:{if((de[c[b+48>>2]&63](b,e,c[n>>2]|0)|0)!=0){c[o+316>>2]=0;break c}w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=sZ(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=190;break a}c[o+316>>2]=jZ(o,l,u,36)|0;if((c[o+316>>2]|0)==0){r=192;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=0;if((c[o+476>>2]|0)!=0){B=1}else{B=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(B^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 10:{w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=sZ(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=202;break a}c[o+316>>2]=jZ(o,l+132|0,u,36)|0;if((c[o+316>>2]|0)==0){r=204;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=1;if((c[o+476>>2]|0)!=0){C=1}else{C=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(C^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 58:{if((c[o+80>>2]|0)!=0){eZ(o,b,e,c[n>>2]|0)}h=0;D=CZ(o,b,n,f,j,k)|0;if((D|0)!=0){r=239;break a}if((c[n>>2]|0)==0){r=241;break a}break};case 18:{c[o+340>>2]=0;c[o+336>>2]=0;if((c[o+96>>2]|0)==0){break c}c[o+336>>2]=sZ(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+336>>2]|0)==0){r=214;break a}c[o+432>>2]=c[o+428>>2];h=0;break};case 21:{if((ze[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=217;break a}if((c[o+336>>2]|0)==0){break c}w=sZ(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=220;break a}tZ(w);c[o+340>>2]=w;c[o+432>>2]=c[o+428>>2];h=0;break};case 19:{do{if((c[o+336>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}w=sZ(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=225;break a}c[q>>2]=e;Wd[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,w,c[o+340>>2]|0);h=0}}while(0);PY(o+416|0);break};case 20:{do{if((c[o+340>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}c[q>>2]=e;Wd[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,0,c[o+340>>2]|0);h=0}}while(0);PY(o+416|0);break};case-1:{r=232;break a;break};case 44:{do{if((c[o+260>>2]|0)>>>0>=(c[o+468>>2]|0)>>>0){w=o+12|0;if((c[o+468>>2]|0)==0){u=c[w>>2]|0;c[o+468>>2]=32;c[o+464>>2]=ae[u&127](32)|0;if((c[o+464>>2]|0)!=0){break}else{r=251;break a}}u=c[w+4>>2]|0;w=c[o+464>>2]|0;z=o+468|0;E=c[z>>2]<<1;c[z>>2]=E;z=pe[u&63](w,E)|0;if((z|0)==0){r=245;break a}c[o+464>>2]=z;if((c[l+184>>2]|0)==0){break}z=pe[c[o+16>>2]&63](c[l+184>>2]|0,c[o+468>>2]<<2)|0;if((z|0)==0){r=248;break a}c[l+184>>2]=z}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=0;if((a[l+160|0]|0)==0){break c}z=EZ(o)|0;if((z|0)<0){r=254;break a}c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]=z;E=l+180|0;c[E>>2]=(c[E>>2]|0)+1;c[(c[l+164>>2]|0)+(z*28|0)>>2]=6;if((c[o+128>>2]|0)==0){break c}h=0;break};case 50:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==124){r=258;break a}a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=44;if((d[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)==0){break c}h=0;break};case 49:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==44){r=263;break a}do{if((d[l+160|0]|0)!=0){if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)!=0){break}if((c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]|0)==3){break}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=5;if((c[o+128>>2]|0)==0){break}h=0}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=124;break};case 59:case 60:{a[l+129|0]=1;z=l;do{if((c[o+492>>2]|0)!=0){E=sZ(z+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=273;break a}w=jZ(o,l+132|0,E,0)|0;c[l+92>>2]=c[l+96>>2];do{if((c[o+272>>2]|0)!=0){if((d[l+130|0]|0)!=0){if((c[o+300>>2]|0)!=0){r=282;break}}else{if((a[l+129|0]|0)!=0){r=282;break}}if((w|0)==0){r=279;break a}if((a[w+34|0]|0)==0){r=281;break a}}else{r=282}}while(0);do{if((r|0)==282){r=0;if((w|0)!=0){break}a[l+128|0]=a[l+130|0]|0;if((s|0)!=60){break c}if((c[o+120>>2]|0)==0){break c}we[c[o+120>>2]&15](c[o+4>>2]|0,E,1);h=0;break c}}while(0);if((a[w+32|0]|0)!=0){r=287;break a}if((c[w+4>>2]|0)!=0){F=FZ(o,w,((s|0)==60?1:0)&255)|0;if((F|0)!=0){r=290;break a}h=0;break c}E=l;if((c[o+112>>2]|0)==0){a[l+128|0]=a[E+130|0]|0;break c}a[E+131|0]=0;a[w+32|0]=1;E=(qe[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)!=0;a[w+32|0]=0;if(!E){r=294;break a}h=0;if((a[l+131|0]|0)!=0){break}a[l+128|0]=a[l+130|0]|0;break c}else{a[l+128|0]=a[z+130|0]|0}}while(0);if((a[l+130|0]|0)!=0){break c}if((c[o+108>>2]|0)==0){break c}if((ae[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=301;break a}break};case 53:{G=1;r=319;break};case 52:{G=2;r=319;break};case 54:{G=3;r=319;break};case 40:{if((c[o+128>>2]|0)==0){break c}c[o+344>>2]=vZ(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)==0){r=304;break a}c[l+180>>2]=0;c[l+176>>2]=0;a[l+160|0]=1;h=0;break};case 42:case 41:{if((a[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)!=0){z=ae[c[o+12>>2]&127](20)|0;if((z|0)==0){r=309;break a}c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;c[z+16>>2]=0;c[z>>2]=(s|0)==41?2:1;c[q>>2]=e;we[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,z);h=0}a[l+160|0]=0;break};case 43:{if((a[l+160|0]|0)==0){break c}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=3;if((c[o+128>>2]|0)==0){break c}h=0;break};case 51:{G=0;r=319;break};case 47:{G=1;r=334;break};case 46:{G=2;r=334;break};case 48:{G=3;r=334;break};case 45:{G=0;r=334;break};case 56:{if((IZ(o,b,e,c[n>>2]|0)|0)==0){r=347;break a}h=0;break};case 0:{if((g|0)!=14){break c}h=0;break};case 3:{if((c[o+84>>2]|0)==0){break c}h=0;break};case 11:{if((d[l+128|0]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}h=0;break};case 55:{if((HZ(o,b,e,c[n>>2]|0)|0)==0){r=344;break a}h=0;break};case 17:{if((c[o+96>>2]|0)==0){break c}h=0;break};case 33:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}h=0;break};case 39:{if((c[o+128>>2]|0)==0){break c}h=0;break};default:{}}}while(0);do{if((r|0)==45){r=0;if((ze[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)!=0){r=47}else{r=46;break a}}else if((r|0)==102){r=0;if((d[l+128|0]|0)==0){break}if((c[o+132>>2]|0)==0){break}h=0}else if((r|0)==168){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}s=sZ(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;c[(c[o+316>>2]|0)+16>>2]=s;if((c[(c[o+316>>2]|0)+16>>2]|0)==0){r=171;break a}c[(c[o+316>>2]|0)+20>>2]=c[o+360>>2];c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}else if((r|0)==319){r=0;if((a[l+160|0]|0)==0){break}s=c[n>>2]|0;if((G|0)==0){H=s}else{H=s+(0-(c[b+68>>2]|0))|0}s=EZ(o)|0;if((s|0)<0){r=323;break a}c[(c[l+164>>2]|0)+(s*28|0)>>2]=4;c[(c[l+164>>2]|0)+(s*28|0)+4>>2]=G;z=vZ(o,b,e,H)|0;if((z|0)==0){r=325;break a}E=c[z>>2]|0;c[(c[l+164>>2]|0)+(s*28|0)+8>>2]=E;s=0;do{z=s;s=z+1|0;}while((a[E+z|0]|0)!=0);E=l+168|0;c[E>>2]=(c[E>>2]|0)+s;if((c[o+128>>2]|0)==0){break}h=0}else if((r|0)==334){r=0;if((a[l+160|0]|0)==0){break}if((c[o+128>>2]|0)!=0){h=0}E=l+180|0;c[E>>2]=(c[E>>2]|0)+ -1;c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]|0)*28|0)+4>>2]=G;if((c[l+180>>2]|0)!=0){break}if(!(h<<24>>24!=0)){E=GZ(o)|0;if((E|0)==0){r=340;break a}c[q>>2]=e;we[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,E)}a[l+160|0]=0;c[l+168>>2]=0}}while(0);do{if((r|0)==47){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}E=sZ(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=50;break a}tZ(E);c[(c[o+316>>2]|0)+24>>2]=E;c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}}while(0);do{if((h&255|0)!=0){if((c[o+80>>2]|0)==0){break}eZ(o,b,e,c[n>>2]|0)}}while(0);h=c[o+480>>2]|0;if((h|0)==3){r=367;break}else if((h|0)==2){r=368;break}e=c[n>>2]|0;g=ze[c[b>>2]&63](b,e,f,n)|0}if((r|0)==7){c[j>>2]=e;I=0;J=I;i=m;return J|0}else if((r|0)==9){c[p>>2]=c[n>>2];I=4;J=I;i=m;return J|0}else if((r|0)==10){I=5;J=I;i=m;return J|0}else if((r|0)==11){I=6;J=I;i=m;return J|0}else if((r|0)==13){do{if((b|0)!=(c[o+144>>2]|0)){if((a[(c[o+300>>2]|0)+20|0]|0)!=0){break}c[j>>2]=e;I=0;J=I;i=m;return J|0}}while(0);do{if((d[o+488|0]|0)==0){if((b|0)!=(c[o+144>>2]|0)){break}I=3;J=I;i=m;return J|0}}while(0);if((qe[c[o+256>>2]&63](o+256|0,-4,f,f,b)|0)==-1){I=29;J=I;i=m;return J|0}else{c[j>>2]=e;I=0;J=I;i=m;return J|0}}else if((r|0)==25){I=t;J=I;i=m;return J|0}else if((r|0)==29){I=1;J=I;i=m;return J|0}else if((r|0)==35){I=v;J=I;i=m;return J|0}else if((r|0)==38){I=1;J=I;i=m;return J|0}else if((r|0)==41){I=32;J=I;i=m;return J|0}else if((r|0)==43){I=1;J=I;i=m;return J|0}else if((r|0)==46){I=32;J=I;i=m;return J|0}else if((r|0)==50){I=1;J=I;i=m;return J|0}else if((r|0)==60){I=1;J=I;i=m;return J|0}else if((r|0)==64){I=21;J=I;i=m;return J|0}else if((r|0)==69){I=22;J=I;i=m;return J|0}else if((r|0)==75){do{if((a[o+489|0]|0)!=0){v=a[l+129|0]|0;a[l+129|0]=1;if((c[o+492>>2]|0)==0){break}if((c[o+112>>2]|0)==0){break}t=jZ(o,l+132|0,61392,36)|0;if((t|0)==0){I=1;J=I;i=m;return J|0}c[t+20>>2]=c[o+360>>2];a[l+131|0]=0;if((qe[c[o+112>>2]&63](c[o+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)==0){I=21;J=I;i=m;return J|0}if((a[l+131|0]|0)==0){a[l+129|0]=v;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((ae[c[o+108>>2]&127](c[o+4>>2]|0)|0)!=0){break}I=22;J=I;i=m;return J|0}}while(0);c[o+280>>2]=39;I=uZ(o,e,f,j)|0;J=I;i=m;return J|0}else if((r|0)==90){I=1;J=I;i=m;return J|0}else if((r|0)==92){I=1;J=I;i=m;return J|0}else if((r|0)==111){I=1;J=I;i=m;return J|0}else if((r|0)==113){I=1;J=I;i=m;return J|0}else if((r|0)==117){I=1;J=I;i=m;return J|0}else if((r|0)==128){I=1;J=I;i=m;return J|0}else if((r|0)==132){I=y;J=I;i=m;return J|0}else if((r|0)==134){I=1;J=I;i=m;return J|0}else if((r|0)==145){I=1;J=I;i=m;return J|0}else if((r|0)==153){I=A;J=I;i=m;return J|0}else if((r|0)==156){I=1;J=I;i=m;return J|0}else if((r|0)==163){I=22;J=I;i=m;return J|0}else if((r|0)==166){I=1;J=I;i=m;return J|0}else if((r|0)==171){I=1;J=I;i=m;return J|0}else if((r|0)==181){I=1;J=I;i=m;return J|0}else if((r|0)==190){I=1;J=I;i=m;return J|0}else if((r|0)==192){I=1;J=I;i=m;return J|0}else if((r|0)==202){I=1;J=I;i=m;return J|0}else if((r|0)==204){I=1;J=I;i=m;return J|0}else if((r|0)==214){I=1;J=I;i=m;return J|0}else if((r|0)==217){I=32;J=I;i=m;return J|0}else if((r|0)==220){I=1;J=I;i=m;return J|0}else if((r|0)==225){I=1;J=I;i=m;return J|0}else if((r|0)==232){A=g;if((A|0)==28){I=10;J=I;i=m;return J|0}else if((A|0)==12){I=17;J=I;i=m;return J|0}else{I=2;J=I;i=m;return J|0}}else if((r|0)==239){I=D;J=I;i=m;return J|0}else if((r|0)==241){c[o+280>>2]=40;I=D;J=I;i=m;return J|0}else if((r|0)==245){I=1;J=I;i=m;return J|0}else if((r|0)==248){I=1;J=I;i=m;return J|0}else if((r|0)==251){I=1;J=I;i=m;return J|0}else if((r|0)==254){I=1;J=I;i=m;return J|0}else if((r|0)==258){I=2;J=I;i=m;return J|0}else if((r|0)==263){I=2;J=I;i=m;return J|0}else if((r|0)==273){I=1;J=I;i=m;return J|0}else if((r|0)==279){I=11;J=I;i=m;return J|0}else if((r|0)==281){I=24;J=I;i=m;return J|0}else if((r|0)==287){I=12;J=I;i=m;return J|0}else if((r|0)==290){I=F;J=I;i=m;return J|0}else if((r|0)==294){I=21;J=I;i=m;return J|0}else if((r|0)==301){I=22;J=I;i=m;return J|0}else if((r|0)==304){I=1;J=I;i=m;return J|0}else if((r|0)==309){I=1;J=I;i=m;return J|0}else if((r|0)==323){I=1;J=I;i=m;return J|0}else if((r|0)==325){I=1;J=I;i=m;return J|0}else if((r|0)==340){I=1;J=I;i=m;return J|0}else if((r|0)==344){I=1;J=I;i=m;return J|0}else if((r|0)==347){I=1;J=I;i=m;return J|0}else if((r|0)==367){c[j>>2]=c[n>>2];I=0;J=I;i=m;return J|0}else if((r|0)==368){I=35;J=I;i=m;return J|0}return 0}function rZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+104|0;h=g+40|0;j=g+56|0;k=g+64|0;l=g+72|0;m=g+88|0;n=b;b=d;d=e;e=f;c[h>>2]=0;f=0;c[j>>2]=0;c[k>>2]=0;o=0;c[m>>2]=-1;p=(b|0)!=0;if(($d[((a[n+236|0]&255|0)!=0?1:2)&7](b,c[n+144>>2]|0,d,e,n+288|0,k,l,h,j,m)|0)==0){if(p){q=31;r=q;i=g;return r|0}else{q=30;r=q;i=g;return r|0}}do{if(!p){if((c[m>>2]|0)!=1){break}a[(c[n+356>>2]|0)+130|0]=1;if((c[n+492>>2]|0)!=1){break}c[n+492>>2]=0}}while(0);do{if((c[n+140>>2]|0)!=0){do{if((c[h>>2]|0)!=0){p=c[n+144>>2]|0;b=c[h>>2]|0;s=c[h>>2]|0;f=sZ(n+440|0,p,b,s+(pe[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){c[n+456>>2]=c[n+452>>2];break}q=1;r=q;i=g;return r|0}}while(0);do{if((c[k>>2]|0)!=0){o=sZ(n+440|0,c[n+144>>2]|0,c[k>>2]|0,(c[l>>2]|0)+(0-(c[(c[n+144>>2]|0)+68>>2]|0))|0)|0;if((o|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);Ae[c[n+140>>2]&63](c[n+4>>2]|0,o,f,c[m>>2]|0)}else{if((c[n+80>>2]|0)==0){break}eZ(n,c[n+144>>2]|0,d,e)}}while(0);do{if((c[n+232>>2]|0)==0){if((c[j>>2]|0)!=0){if((c[(c[j>>2]|0)+68>>2]|0)==(c[(c[n+144>>2]|0)+68>>2]|0)){c[n+144>>2]=c[j>>2];break}c[n+288>>2]=c[h>>2];q=19;r=q;i=g;return r|0}if((c[h>>2]|0)==0){break}do{if((f|0)==0){e=c[n+144>>2]|0;d=c[h>>2]|0;m=c[h>>2]|0;f=sZ(n+440|0,e,d,m+(pe[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);m=WZ(n,f)|0;PY(n+440|0);if((m|0)==18){c[n+288>>2]=c[h>>2]}q=m;r=q;i=g;return r|0}}while(0);if((f|0)!=0){t=34}else{if((o|0)!=0){t=34}}if((t|0)==34){PY(n+440|0)}q=0;r=q;i=g;return r|0}function sZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+40|0;h=b;if((yZ(h,d,e,f)|0)==0){j=0;k=j;i=g;return k|0}do{if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if((gZ(h)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);f=h+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e]=0;j=c[h+16>>2]|0;k=j;i=g;return k|0}function tZ(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;i=i+24|0;d=b;b=d;e=d;while(1){if((a[e]|0)==0){break}f=a[e]|0;do{if((f|0)==10|(f|0)==13|(f|0)==32){if((b|0)==(d|0)){break}if((a[b+ -1|0]|0)==32){break}g=b;b=g+1|0;a[g]=32}else{g=b;b=g+1|0;a[g]=a[e]|0}}while(0);e=e+1|0}if((b|0)==(d|0)){h=b;a[h]=0;i=c;return}if((a[b+ -1|0]|0)!=32){h=b;a[h]=0;i=c;return}b=b+ -1|0;h=b;a[h]=0;i=c;return}function uZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=LZ(h,0,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((TZ(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function vZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=c[g+356>>2]|0;h=sZ(a+80|0,b,d,e)|0;if((h|0)==0){j=0;k=j;i=f;return k|0}e=jZ(g,a+20|0,h,24)|0;if((e|0)==0){j=0;k=j;i=f;return k|0}d=a+80|0;do{if((c[e>>2]|0)!=(h|0)){c[a+92>>2]=c[d+16>>2]}else{c[a+96>>2]=c[d+12>>2];if((UZ(g,e)|0)!=0){break}j=0;k=j;i=f;return k|0}}while(0);j=e;k=j;i=f;return k|0}function wZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=b;b=d;d=e;e=f;f=c[h+356>>2]|0;do{if((c[f+92>>2]|0)==(c[f+88>>2]|0)){if((gZ(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m]=0;m=sZ(f+80|0,b,d,e)|0;if((m|0)==0){j=0;k=j;i=g;return k|0}m=m+1|0;e=jZ(h,f+40|0,m,12)|0;if((e|0)==0){j=0;k=j;i=g;return k|0}d=f+80|0;a:do{if((c[e>>2]|0)!=(m|0)){c[f+92>>2]=c[d+16>>2]}else{c[f+96>>2]=c[d+12>>2];if((a[h+236|0]|0)==0){break}do{if((a[m]|0)==120){if((a[m+1|0]|0)!=109){break}if((a[m+2|0]|0)!=108){break}if((a[m+3|0]|0)!=110){break}if((a[m+4|0]|0)!=115){break}if((a[m+5|0]|0)!=0){if((a[m+5|0]|0)!=58){break}}if((a[m+5|0]|0)==0){c[e+4>>2]=f+152}else{c[e+4>>2]=jZ(h,f+60|0,m+6|0,8)|0}a[e+9|0]=1;break a}}while(0);b=0;while(1){if((a[m+b|0]|0)==0){break a}if((a[m+b|0]|0)==58){break}b=b+1|0}l=0;while(1){n=(c[f+92>>2]|0)==(c[f+88>>2]|0);if((l|0)>=(b|0)){break}if(n){if(!((gZ(f+80|0)|0)<<24>>24!=0)){o=30;break}}p=a[m+l|0]|0;q=f+92|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;l=l+1|0}if((o|0)==30){j=0;k=j;i=g;return k|0}do{if(n){if((gZ(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;b=c[l>>2]|0;c[l>>2]=b+1;a[b]=0;c[e+4>>2]=jZ(h,f+60|0,c[f+96>>2]|0,8)|0;b=f+80|0;if((c[c[e+4>>2]>>2]|0)==(c[f+96>>2]|0)){c[f+96>>2]=c[b+12>>2];break}else{c[f+92>>2]=c[b+16>>2];break}}}while(0);j=e;k=j;i=g;return k|0}function xZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=b;b=d;while(1){g=f;if((a[b]|0)==0){h=7;break}if((c[g+12>>2]|0)==(c[f+8>>2]|0)){if(!((gZ(f)|0)<<24>>24!=0)){h=6;break}}d=a[b]|0;j=f+12|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k]=d;b=b+1|0}if((h|0)==6){l=0;m=l;i=e;return m|0}else if((h|0)==7){l=c[g+16>>2]|0;m=l;i=e;return m|0}return 0}function yZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=f+24|0;h=a;a=b;c[g>>2]=d;d=e;do{if((c[h+12>>2]|0)==0){if((gZ(h)|0)<<24>>24!=0){break}j=0;k=j;i=f;return k|0}}while(0);while(1){Wd[c[a+60>>2]&31](a,g,d,h+12|0,c[h+8>>2]|0);l=h;if((c[g>>2]|0)==(d|0)){m=7;break}if(!((gZ(l)|0)<<24>>24!=0)){m=6;break}}if((m|0)==6){j=0;k=j;i=f;return k|0}else if((m|0)==7){j=c[l+16>>2]|0;k=j;i=f;return k|0}return 0}function zZ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+88|0;k=b;b=d;d=e;e=f;f=g;g=h;if((f|0)!=0){l=3}else{if((e&255|0)!=0){l=3}}do{if((l|0)==3){h=0;while(1){if((h|0)>=(c[k+12>>2]|0)){break}if((b|0)==(c[(c[k+20>>2]|0)+(h*12|0)>>2]|0)){l=6;break}h=h+1|0}if((l|0)==6){m=1;n=m;i=j;return n|0}if((e&255|0)==0){break}if((c[k+8>>2]|0)!=0){break}if((a[b+9|0]|0)!=0){break}c[k+8>>2]=b}}while(0);do{if((c[k+12>>2]|0)==(c[k+16>>2]|0)){e=k+16|0;if((c[k+16>>2]|0)==0){c[e>>2]=8;c[k+20>>2]=ae[c[g+12>>2]&127]((c[k+16>>2]|0)*12|0)|0;if((c[k+20>>2]|0)!=0){break}m=0;n=m;i=j;return n|0}l=c[e>>2]<<1;e=pe[c[g+16>>2]&63](c[k+20>>2]|0,l*12|0)|0;if((e|0)!=0){c[k+16>>2]=l;c[k+20>>2]=e;break}m=0;n=m;i=j;return n|0}}while(0);g=(c[k+20>>2]|0)+((c[k+12>>2]|0)*12|0)|0;c[g>>2]=b;c[g+8>>2]=f;a[g+4|0]=d;if(!(d<<24>>24!=0)){a[b+8|0]=1}b=k+12|0;c[b>>2]=(c[b>>2]|0)+1;m=1;n=m;i=j;return n|0}function AZ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+64|0;k=e;e=h;h=VZ(b,d,k,f,g,e)|0;if((h|0)!=0){l=h;m=l;i=j;return m|0}do{if(!(k<<24>>24!=0)){if(((c[e+12>>2]|0)-(c[e+16>>2]|0)|0)==0){break}if((a[(c[e+12>>2]|0)+ -1|0]|0)!=32){break}h=e+12|0;c[h>>2]=(c[h>>2]|0)+ -1}}while(0);do{if((c[e+12>>2]|0)==(c[e+8>>2]|0)){if((gZ(e)|0)<<24>>24!=0){break}l=1;m=l;i=j;return m|0}}while(0);k=e+12|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e]=0;l=0;m=l;i=j;return m|0}function BZ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+128|0;j=h+72|0;k=h+104|0;l=b;b=e;e=f;f=g;g=c[l+356>>2]|0;m=g+104|0;n=0;o=c[l+276>>2]|0;c[l+276>>2]=1;do{if((c[m>>2]|0)==0){if((gZ(m)|0)<<24>>24!=0){break}p=1;q=p;i=h;return q|0}}while(0);a:while(1){b:do{switch(ze[c[b+20>>2]&63](b,e,f,j)|0){case 0:{r=49;break a;break};case 28:{if((d[l+488|0]|0)==0){if((b|0)==(c[l+144>>2]|0)){r=23;break a}}s=sZ(l+416|0,b,e+(c[b+68>>2]|0)|0,(c[j>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((s|0)==0){r=8;break a}t=jZ(l,g+132|0,s,0)|0;c[l+428>>2]=c[l+432>>2];if((t|0)==0){r=10;break a}if((a[t+32|0]|0)!=0){r=12;break a}if((c[t+16>>2]|0)==0){a[t+32|0]=1;n=BZ(l,c[l+228>>2]|0,c[t+4>>2]|0,(c[t+4>>2]|0)+(c[t+8>>2]|0)|0)|0;a[t+32|0]=0;if((n|0)!=0){break a}else{break b}}s=g;if((c[l+112>>2]|0)==0){a[g+128|0]=a[s+130|0]|0;break b}a[s+131|0]=0;a[t+32|0]=1;s=(qe[c[l+112>>2]&63](c[l+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)!=0;a[t+32|0]=0;if(!s){r=18;break a}if((a[g+131|0]|0)!=0){break b}a[g+128|0]=a[g+130|0]|0;break};case 6:case 9:{if((yZ(m,b,e,c[j>>2]|0)|0)==0){r=26;break a}break};case 7:{r=28;break};case-1:{r=46;break a;break};case-4:{r=24;break a;break};case 10:{s=pe[c[b+44>>2]&63](b,e)|0;if((s|0)<0){r=33;break a}s=a_(s,k)|0;if((s|0)==0){r=37;break a}t=0;while(1){if((t|0)>=(s|0)){break b}if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((gZ(m)|0)<<24>>24!=0)){r=44;break a}}u=a[k+t|0]|0;v=m+12|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=u;t=t+1|0}break};case-3:{c[j>>2]=e+(c[b+68>>2]|0);r=28;break};default:{r=52;break a}}}while(0);if((r|0)==28){r=0;if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((gZ(m)|0)<<24>>24!=0)){r=30;break}}t=m+12|0;s=c[t>>2]|0;c[t>>2]=s+1;a[s]=10}e=c[j>>2]|0}if((r|0)==8){n=1}else if((r|0)==10){a[g+128|0]=a[g+130|0]|0}else if((r|0)==12){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=12}else if((r|0)==18){n=21}else if((r|0)==23){c[l+288>>2]=e;n=10}else if((r|0)==24){n=0}else if((r|0)==26){n=1}else if((r|0)==30){n=1}else if((r|0)==33){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==37){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==44){n=1}else if((r|0)==46){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=4}else if((r|0)==49){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=c[j>>2]}n=4}else if((r|0)==52){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=23}c[l+276>>2]=o;p=n;q=p;i=h;return q|0}function CZ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+96|0;j=h+56|0;k=a;a=b;b=d;d=f;f=g;g=c[b>>2]|0;l=k;if((a|0)==(c[k+144>>2]|0)){m=l+288|0;c[m>>2]=g;n=k+292|0}else{m=c[l+300>>2]|0;n=(c[k+300>>2]|0)+4|0}c[m>>2]=g;c[b>>2]=0;l=ze[c[a+12>>2]&63](a,g,e,j)|0;c[n>>2]=c[j>>2];switch(l|0){case-4:case-1:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=2;p=o;i=h;return p|0}break};case-2:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=6;p=o;i=h;return p|0}break};case 42:{if((c[k+80>>2]|0)!=0){eZ(k,a,g,c[j>>2]|0)}c[b>>2]=c[j>>2];c[d>>2]=c[j>>2];if((c[k+480>>2]|0)==2){o=35;p=o;i=h;return p|0}else{o=0;p=o;i=h;return p|0}break};case 0:{c[m>>2]=c[j>>2];o=4;p=o;i=h;return p|0};default:{c[m>>2]=c[j>>2];o=23;p=o;i=h;return p|0}}return 0}function DZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=CZ(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)!=0){c[j+280>>2]=41;k=pZ(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{k=f;l=k;i=g;return l|0}return 0}function EZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;a=c[d+356>>2]|0;do{if((c[a+184>>2]|0)==0){c[a+184>>2]=ae[c[d+12>>2]&127](c[d+468>>2]<<2)|0;if((c[a+184>>2]|0)!=0){c[c[a+184>>2]>>2]=0;break}e=-1;f=e;i=b;return f|0}}while(0);if((c[a+176>>2]|0)>>>0>=(c[a+172>>2]|0)>>>0){g=d+12|0;do{if((c[a+164>>2]|0)!=0){h=pe[c[g+4>>2]&63](c[a+164>>2]|0,(c[a+172>>2]<<1)*28|0)|0;if((h|0)!=0){d=a+172|0;c[d>>2]=c[d>>2]<<1;break}e=-1;f=e;i=b;return f|0}else{h=ae[c[g>>2]&127](896)|0;if((h|0)!=0){c[a+172>>2]=32;break}e=-1;f=e;i=b;return f|0}}while(0);c[a+164>>2]=h}h=a+176|0;g=c[h>>2]|0;c[h>>2]=g+1;h=g;g=(c[a+164>>2]|0)+(h*28|0)|0;if((c[a+180>>2]|0)!=0){d=(c[a+164>>2]|0)+((c[(c[a+184>>2]|0)+((c[a+180>>2]|0)-1<<2)>>2]|0)*28|0)|0;if((c[d+16>>2]|0)!=0){c[(c[a+164>>2]|0)+((c[d+16>>2]|0)*28|0)+24>>2]=h}if((c[d+20>>2]|0)==0){c[d+12>>2]=h}c[d+16>>2]=h;a=d+20|0;c[a>>2]=(c[a>>2]|0)+1}c[g+24>>2]=0;c[g+20>>2]=0;c[g+16>>2]=0;c[g+12>>2]=0;e=h;f=e;i=b;return f|0}function FZ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+80|0;g=f+48|0;h=b;b=d;d=e;e=h;do{if((c[h+304>>2]|0)!=0){j=c[e+304>>2]|0;c[h+304>>2]=c[j+8>>2]}else{j=ae[c[e+12>>2]&127](24)|0;if((j|0)!=0){break}k=1;l=k;i=f;return l|0}}while(0);a[b+32|0]=1;c[b+12>>2]=0;c[j+8>>2]=c[h+300>>2];c[h+300>>2]=j;c[j+12>>2]=b;c[j+16>>2]=c[h+312>>2];a[j+20|0]=d;c[j>>2]=0;c[j+4>>2]=0;d=c[b+4>>2]|0;e=(c[b+4>>2]|0)+(c[b+8>>2]|0)|0;m=h;if((a[b+33|0]|0)!=0){n=ze[c[c[m+228>>2]>>2]&63](c[h+228>>2]|0,d,e,g)|0;o=qZ(h,c[h+228>>2]|0,d,e,n,c[g>>2]|0,g,0)|0}else{o=LZ(m,c[h+312>>2]|0,c[h+228>>2]|0,d,e,g,0)|0}a:do{if((o|0)==0){do{if((e|0)!=(c[g>>2]|0)){if((c[h+480>>2]|0)!=3){break}c[b+12>>2]=(c[g>>2]|0)-d;c[h+280>>2]=42;break a}}while(0);a[b+32|0]=0;c[h+300>>2]=c[j+8>>2];c[j+8>>2]=c[h+304>>2];c[h+304>>2]=j}}while(0);k=o;l=k;i=f;return l|0}function GZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+56|0;d=b+32|0;e=b+40|0;f=a;a=c[f+356>>2]|0;g=ae[c[f+12>>2]&127](((c[a+176>>2]|0)*20|0)+(c[a+168>>2]|0)|0)|0;if((g|0)!=0){c[e>>2]=g+((c[a+176>>2]|0)*20|0);c[d>>2]=g+20;KZ(f,0,g,d,e);h=g;j=h;i=b;return j|0}else{h=0;j=h;i=b;return j|0}return 0}function HZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=b;b=d;d=e;if((c[g+64>>2]|0)==0){if((c[g+80>>2]|0)!=0){eZ(g,a,b,d)}h=1;j=h;i=f;return j|0}b=b+(c[a+68>>2]<<1)|0;e=b+(pe[c[a+32>>2]&63](a,b)|0)|0;k=sZ(g+416|0,a,b,e)|0;if((k|0)==0){h=0;j=h;i=f;return j|0}c[g+432>>2]=c[g+428>>2];b=pe[c[a+36>>2]&63](a,e)|0;e=sZ(g+416|0,a,b,d+(0-(c[a+68>>2]<<1))|0)|0;if((e|0)!=0){JZ(e);we[c[g+64>>2]&15](c[g+4>>2]|0,k,e);PY(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function IZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=a;a=b;b=d;d=e;e=g;if((c[g+68>>2]|0)==0){if((c[e+80>>2]|0)!=0){eZ(g,a,b,d)}h=1;j=h;i=f;return j|0}k=sZ(e+416|0,a,b+(c[a+68>>2]<<2)|0,d+(0-((c[a+68>>2]|0)*3|0))|0)|0;if((k|0)!=0){JZ(k);_d[c[g+68>>2]&127](c[g+4>>2]|0,k);PY(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function JZ(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=b;while(1){if((a[d]|0)==0){e=12;break}f=d;if((a[d]|0)==13){break}d=f+1|0}if((e|0)==12){i=c;return}e=f;do{do{if((a[d]|0)==13){f=e;e=f+1|0;a[f]=10;f=d+1|0;d=f;if((a[f]|0)!=10){break}d=d+1|0}else{f=d;d=f+1|0;b=e;e=b+1|0;a[b]=a[f]|0}}while(0);}while((a[d]|0)!=0);a[e]=0;i=c;return}function KZ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+72|0;j=b;b=d;d=e;e=f;f=g;g=c[j+356>>2]|0;c[d>>2]=c[(c[g+164>>2]|0)+(b*28|0)>>2];c[d+4>>2]=c[(c[g+164>>2]|0)+(b*28|0)+4>>2];if((c[d>>2]|0)==4){c[d+8>>2]=c[f>>2];k=c[(c[g+164>>2]|0)+(b*28|0)+8>>2]|0;while(1){l=a[k]|0;m=f;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;if((a[k]|0)==0){break}k=k+1|0}c[d+12>>2]=0;c[d+16>>2]=0;i=h;return}else{c[d+12>>2]=c[(c[g+164>>2]|0)+(b*28|0)+20>>2];c[d+16>>2]=c[e>>2];k=e;c[k>>2]=(c[k>>2]|0)+((c[d+12>>2]|0)*20|0);k=0;l=c[(c[g+164>>2]|0)+(b*28|0)+12>>2]|0;while(1){if(!(k>>>0<(c[d+12>>2]|0)>>>0)){break}KZ(j,l,(c[d+16>>2]|0)+(k*20|0)|0,e,f);k=k+1|0;l=c[(c[g+164>>2]|0)+(l*28|0)+24>>2]|0}c[d+8>>2]=0;i=h;return}}



function Kwa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=i;if((a|0)==0){i=b;return}d=a+ -8|0;e=d;f=c[161168>>2]|0;if(d>>>0<f>>>0){dd()}g=c[a+ -4>>2]|0;h=g&3;if((h|0)==1){dd()}j=g&-8;k=a+(j+ -8)|0;l=k;a:do{if((g&1|0)==0){m=c[d>>2]|0;if((h|0)==0){i=b;return}n=-8-m|0;o=a+n|0;p=o;q=m+j|0;if(o>>>0<f>>>0){dd()}if((p|0)==(c[161172>>2]|0)){r=a+(j+ -4)|0;if((c[r>>2]&3|0)!=3){s=p;t=q;break}c[161160>>2]=q;c[r>>2]=c[r>>2]&-2;c[a+(n+4)>>2]=q|1;c[k>>2]=q;i=b;return}r=m>>>3;if(m>>>0<256){m=c[a+(n+8)>>2]|0;u=c[a+(n+12)>>2]|0;v=161192+(r<<1<<2)|0;do{if((m|0)!=(v|0)){if(m>>>0<f>>>0){dd()}if((c[m+12>>2]|0)==(p|0)){break}dd()}}while(0);if((u|0)==(m|0)){c[40288]=c[40288]&~(1<<r);s=p;t=q;break}do{if((u|0)==(v|0)){w=u+8|0}else{if(u>>>0<f>>>0){dd()}x=u+8|0;if((c[x>>2]|0)==(p|0)){w=x;break}dd()}}while(0);c[m+12>>2]=u;c[w>>2]=m;s=p;t=q;break}v=o;r=c[a+(n+24)>>2]|0;x=c[a+(n+12)>>2]|0;do{if((x|0)==(v|0)){y=a+(n+20)|0;z=y;A=c[y>>2]|0;if((A|0)==0){y=a+(n+16)|0;B=c[y>>2]|0;if((B|0)==0){C=0;break}else{D=B;E=y}}else{D=A;E=z}while(1){z=D+20|0;A=c[z>>2]|0;if((A|0)!=0){E=z;D=A;continue}A=D+16|0;z=c[A>>2]|0;if((z|0)==0){break}else{D=z;E=A}}if(E>>>0<f>>>0){dd()}else{c[E>>2]=0;C=D;break}}else{A=c[a+(n+8)>>2]|0;if(A>>>0<f>>>0){dd()}z=A+12|0;if((c[z>>2]|0)!=(v|0)){dd()}y=x+8|0;if((c[y>>2]|0)==(v|0)){c[z>>2]=x;c[y>>2]=A;C=x;break}else{dd()}}}while(0);if((r|0)==0){s=p;t=q;break}x=c[a+(n+28)>>2]|0;o=161456+(x<<2)|0;do{if((v|0)==(c[o>>2]|0)){c[o>>2]=C;if((C|0)!=0){break}c[161156>>2]=c[161156>>2]&~(1<<x);s=p;t=q;break a}else{if(r>>>0<(c[161168>>2]|0)>>>0){dd()}m=r+16|0;if((c[m>>2]|0)==(v|0)){c[m>>2]=C}else{c[r+20>>2]=C}if((C|0)==0){s=p;t=q;break a}}}while(0);if(C>>>0<(c[161168>>2]|0)>>>0){dd()}c[C+24>>2]=r;v=c[a+(n+16)>>2]|0;do{if((v|0)!=0){if(v>>>0<(c[161168>>2]|0)>>>0){dd()}else{c[C+16>>2]=v;c[v+24>>2]=C;break}}}while(0);v=c[a+(n+20)>>2]|0;if((v|0)==0){s=p;t=q;break}if(v>>>0<(c[161168>>2]|0)>>>0){dd()}else{c[C+20>>2]=v;c[v+24>>2]=C;s=p;t=q;break}}else{s=e;t=j}}while(0);if(!(s>>>0<k>>>0)){dd()}e=a+(j+ -4)|0;C=c[e>>2]|0;if((C&1|0)==0){dd()}do{if((C&2|0)==0){if((l|0)==(c[161176>>2]|0)){f=(c[161164>>2]|0)+t|0;c[161164>>2]=f;c[161176>>2]=s;c[s+4>>2]=f|1;if((s|0)!=(c[161172>>2]|0)){i=b;return}c[161172>>2]=0;c[161160>>2]=0;i=b;return}if((l|0)==(c[161172>>2]|0)){f=(c[161160>>2]|0)+t|0;c[161160>>2]=f;c[161172>>2]=s;c[s+4>>2]=f|1;c[s+f>>2]=f;i=b;return}f=(C&-8)+t|0;D=C>>>3;b:do{if(C>>>0<256){E=c[a+j>>2]|0;w=c[a+(j|4)>>2]|0;h=161192+(D<<1<<2)|0;do{if((E|0)!=(h|0)){if(E>>>0<(c[161168>>2]|0)>>>0){dd()}if((c[E+12>>2]|0)==(l|0)){break}dd()}}while(0);if((w|0)==(E|0)){c[40288]=c[40288]&~(1<<D);break}do{if((w|0)==(h|0)){F=w+8|0}else{if(w>>>0<(c[161168>>2]|0)>>>0){dd()}d=w+8|0;if((c[d>>2]|0)==(l|0)){F=d;break}dd()}}while(0);c[E+12>>2]=w;c[F>>2]=E}else{h=k;d=c[a+(j+16)>>2]|0;g=c[a+(j|4)>>2]|0;do{if((g|0)==(h|0)){v=a+(j+12)|0;r=v;x=c[v>>2]|0;if((x|0)==0){v=a+(j+8)|0;o=c[v>>2]|0;if((o|0)==0){G=0;break}else{H=o;I=v}}else{H=x;I=r}while(1){r=H+20|0;x=c[r>>2]|0;if((x|0)!=0){I=r;H=x;continue}x=H+16|0;r=c[x>>2]|0;if((r|0)==0){break}else{H=r;I=x}}if(I>>>0<(c[161168>>2]|0)>>>0){dd()}else{c[I>>2]=0;G=H;break}}else{x=c[a+j>>2]|0;if(x>>>0<(c[161168>>2]|0)>>>0){dd()}r=x+12|0;if((c[r>>2]|0)!=(h|0)){dd()}v=g+8|0;if((c[v>>2]|0)==(h|0)){c[r>>2]=g;c[v>>2]=x;G=g;break}else{dd()}}}while(0);if((d|0)==0){break}g=c[a+(j+20)>>2]|0;E=161456+(g<<2)|0;do{if((h|0)==(c[E>>2]|0)){c[E>>2]=G;if((G|0)!=0){break}c[161156>>2]=c[161156>>2]&~(1<<g);break b}else{if(d>>>0<(c[161168>>2]|0)>>>0){dd()}w=d+16|0;if((c[w>>2]|0)==(h|0)){c[w>>2]=G}else{c[d+20>>2]=G}if((G|0)==0){break b}}}while(0);if(G>>>0<(c[161168>>2]|0)>>>0){dd()}c[G+24>>2]=d;h=c[a+(j+8)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[161168>>2]|0)>>>0){dd()}else{c[G+16>>2]=h;c[h+24>>2]=G;break}}}while(0);h=c[a+(j+12)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[161168>>2]|0)>>>0){dd()}else{c[G+20>>2]=h;c[h+24>>2]=G;break}}}while(0);c[s+4>>2]=f|1;c[s+f>>2]=f;if((s|0)!=(c[161172>>2]|0)){J=f;break}c[161160>>2]=f;i=b;return}else{c[e>>2]=C&-2;c[s+4>>2]=t|1;c[s+t>>2]=t;J=t}}while(0);t=J>>>3;if(J>>>0<256){C=t<<1;e=161192+(C<<2)|0;G=c[40288]|0;j=1<<t;do{if((G&j|0)==0){c[40288]=G|j;K=161192+(C+2<<2)|0;L=e}else{t=161192+(C+2<<2)|0;a=c[t>>2]|0;if(!(a>>>0<(c[161168>>2]|0)>>>0)){K=t;L=a;break}dd()}}while(0);c[K>>2]=s;c[L+12>>2]=s;c[s+8>>2]=L;c[s+12>>2]=e;i=b;return}e=s;L=J>>>8;do{if((L|0)==0){M=0}else{if(J>>>0>16777215){M=31;break}K=(L+1048320|0)>>>16&8;C=L<<K;j=(C+520192|0)>>>16&4;G=C<<j;C=(G+245760|0)>>>16&2;a=14-(j|K|C)+(G<<C>>>15)|0;M=J>>>(a+7|0)&1|a<<1}}while(0);L=161456+(M<<2)|0;c[s+28>>2]=M;c[s+20>>2]=0;c[s+16>>2]=0;a=c[161156>>2]|0;C=1<<M;c:do{if((a&C|0)==0){c[161156>>2]=a|C;c[L>>2]=e;c[s+24>>2]=L;c[s+12>>2]=s;c[s+8>>2]=s}else{G=c[L>>2]|0;if((M|0)==31){N=0}else{N=25-(M>>>1)|0}d:do{if((c[G+4>>2]&-8|0)==(J|0)){O=G}else{K=J<<N;j=G;while(1){P=j+16+(K>>>31<<2)|0;t=c[P>>2]|0;if((t|0)==0){break}if((c[t+4>>2]&-8|0)==(J|0)){O=t;break d}else{K=K<<1;j=t}}if(P>>>0<(c[161168>>2]|0)>>>0){dd()}else{c[P>>2]=e;c[s+24>>2]=j;c[s+12>>2]=s;c[s+8>>2]=s;break c}}}while(0);G=O+8|0;f=c[G>>2]|0;K=c[161168>>2]|0;if(O>>>0<K>>>0){dd()}if(f>>>0<K>>>0){dd()}else{c[f+12>>2]=e;c[G>>2]=e;c[s+8>>2]=f;c[s+12>>2]=O;c[s+24>>2]=0;break}}}while(0);s=(c[161184>>2]|0)+ -1|0;c[161184>>2]=s;if((s|0)==0){Q=161608|0}else{i=b;return}while(1){s=c[Q>>2]|0;if((s|0)==0){break}else{Q=s+8|0}}c[161184>>2]=-1;i=b;return}function Lwa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{if((a|0)==0){e=0}else{f=fa(b,a)|0;if(!((b|a)>>>0>65535)){e=f;break}e=((f>>>0)/(a>>>0)|0|0)==(b|0)?f:-1}}while(0);b=Jwa(e)|0;if((b|0)==0){i=d;return b|0}if((c[b+ -4>>2]&3|0)==0){i=d;return b|0}pxa(b|0,0,e|0)|0;i=d;return b|0}function Mwa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if((a|0)==0){e=Jwa(b)|0;i=d;return e|0}if(b>>>0>4294967231){c[(Mc()|0)>>2]=12;e=0;i=d;return e|0}if(b>>>0<11){f=16}else{f=b+11&-8}g=Nwa(a+ -8|0,f)|0;if((g|0)!=0){e=g+8|0;i=d;return e|0}g=Jwa(b)|0;if((g|0)==0){e=0;i=d;return e|0}f=c[a+ -4>>2]|0;h=(f&-8)-((f&3|0)==0?8:4)|0;nxa(g|0,a|0,(h>>>0<b>>>0?h:b)|0)|0;Kwa(a);e=g;i=d;return e|0}function Nwa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a;j=a+g|0;k=j;l=c[161168>>2]|0;if(h>>>0<l>>>0){dd()}m=f&3;if(!((m|0)!=1&h>>>0<j>>>0)){dd()}h=a+(g|4)|0;n=c[h>>2]|0;if((n&1|0)==0){dd()}if((m|0)==0){if(b>>>0<256){o=0;i=d;return o|0}do{if(!(g>>>0<(b+4|0)>>>0)){if((g-b|0)>>>0>c[161632>>2]<<1>>>0){break}else{o=a}i=d;return o|0}}while(0);o=0;i=d;return o|0}if(!(g>>>0<b>>>0)){m=g-b|0;if(!(m>>>0>15)){o=a;i=d;return o|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|3;c[h>>2]=c[h>>2]|1;Owa(a+b|0,m);o=a;i=d;return o|0}if((k|0)==(c[161176>>2]|0)){m=(c[161164>>2]|0)+g|0;if(!(m>>>0>b>>>0)){o=0;i=d;return o|0}h=m-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=h|1;c[161176>>2]=a+b;c[161164>>2]=h;o=a;i=d;return o|0}if((k|0)==(c[161172>>2]|0)){h=(c[161160>>2]|0)+g|0;if(h>>>0<b>>>0){o=0;i=d;return o|0}m=h-b|0;if(m>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|1;c[a+h>>2]=m;p=a+(h+4)|0;c[p>>2]=c[p>>2]&-2;q=a+b|0;r=m}else{c[e>>2]=f&1|h|2;f=a+(h+4)|0;c[f>>2]=c[f>>2]|1;q=0;r=0}c[161160>>2]=r;c[161172>>2]=q;o=a;i=d;return o|0}if((n&2|0)!=0){o=0;i=d;return o|0}q=(n&-8)+g|0;if(q>>>0<b>>>0){o=0;i=d;return o|0}r=q-b|0;f=n>>>3;a:do{if(n>>>0<256){h=c[a+(g+8)>>2]|0;m=c[a+(g+12)>>2]|0;p=161192+(f<<1<<2)|0;do{if((h|0)!=(p|0)){if(h>>>0<l>>>0){dd()}if((c[h+12>>2]|0)==(k|0)){break}dd()}}while(0);if((m|0)==(h|0)){c[40288]=c[40288]&~(1<<f);break}do{if((m|0)==(p|0)){s=m+8|0}else{if(m>>>0<l>>>0){dd()}t=m+8|0;if((c[t>>2]|0)==(k|0)){s=t;break}dd()}}while(0);c[h+12>>2]=m;c[s>>2]=h}else{p=j;t=c[a+(g+24)>>2]|0;u=c[a+(g+12)>>2]|0;do{if((u|0)==(p|0)){v=a+(g+20)|0;w=v;x=c[v>>2]|0;if((x|0)==0){v=a+(g+16)|0;y=c[v>>2]|0;if((y|0)==0){z=0;break}else{A=y;B=v}}else{A=x;B=w}while(1){w=A+20|0;x=c[w>>2]|0;if((x|0)!=0){B=w;A=x;continue}x=A+16|0;w=c[x>>2]|0;if((w|0)==0){break}else{A=w;B=x}}if(B>>>0<l>>>0){dd()}else{c[B>>2]=0;z=A;break}}else{x=c[a+(g+8)>>2]|0;if(x>>>0<l>>>0){dd()}w=x+12|0;if((c[w>>2]|0)!=(p|0)){dd()}v=u+8|0;if((c[v>>2]|0)==(p|0)){c[w>>2]=u;c[v>>2]=x;z=u;break}else{dd()}}}while(0);if((t|0)==0){break}u=c[a+(g+28)>>2]|0;h=161456+(u<<2)|0;do{if((p|0)==(c[h>>2]|0)){c[h>>2]=z;if((z|0)!=0){break}c[161156>>2]=c[161156>>2]&~(1<<u);break a}else{if(t>>>0<(c[161168>>2]|0)>>>0){dd()}m=t+16|0;if((c[m>>2]|0)==(p|0)){c[m>>2]=z}else{c[t+20>>2]=z}if((z|0)==0){break a}}}while(0);if(z>>>0<(c[161168>>2]|0)>>>0){dd()}c[z+24>>2]=t;p=c[a+(g+16)>>2]|0;do{if((p|0)!=0){if(p>>>0<(c[161168>>2]|0)>>>0){dd()}else{c[z+16>>2]=p;c[p+24>>2]=z;break}}}while(0);p=c[a+(g+20)>>2]|0;if((p|0)==0){break}if(p>>>0<(c[161168>>2]|0)>>>0){dd()}else{c[z+20>>2]=p;c[p+24>>2]=z;break}}}while(0);if(r>>>0<16){c[e>>2]=q|c[e>>2]&1|2;z=a+(q|4)|0;c[z>>2]=c[z>>2]|1;o=a;i=d;return o|0}else{c[e>>2]=c[e>>2]&1|b|2;c[a+(b+4)>>2]=r|3;e=a+(q|4)|0;c[e>>2]=c[e>>2]|1;Owa(a+b|0,r);o=a;i=d;return o|0}return 0}function Owa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+b|0;f=e;g=c[a+4>>2]|0;a:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){i=d;return}j=a+(0-h)|0;k=j;l=h+b|0;m=c[161168>>2]|0;if(j>>>0<m>>>0){dd()}if((k|0)==(c[161172>>2]|0)){n=a+(b+4)|0;if((c[n>>2]&3|0)!=3){o=k;p=l;break}c[161160>>2]=l;c[n>>2]=c[n>>2]&-2;c[a+(4-h)>>2]=l|1;c[e>>2]=l;i=d;return}n=h>>>3;if(h>>>0<256){q=c[a+(8-h)>>2]|0;r=c[a+(12-h)>>2]|0;s=161192+(n<<1<<2)|0;do{if((q|0)!=(s|0)){if(q>>>0<m>>>0){dd()}if((c[q+12>>2]|0)==(k|0)){break}dd()}}while(0);if((r|0)==(q|0)){c[40288]=c[40288]&~(1<<n);o=k;p=l;break}do{if((r|0)==(s|0)){t=r+8|0}else{if(r>>>0<m>>>0){dd()}u=r+8|0;if((c[u>>2]|0)==(k|0)){t=u;break}dd()}}while(0);c[q+12>>2]=r;c[t>>2]=q;o=k;p=l;break}s=j;n=c[a+(24-h)>>2]|0;u=c[a+(12-h)>>2]|0;do{if((u|0)==(s|0)){v=16-h|0;w=a+(v+4)|0;x=w;y=c[w>>2]|0;if((y|0)==0){w=a+v|0;v=c[w>>2]|0;if((v|0)==0){z=0;break}else{A=v;B=w}}else{A=y;B=x}while(1){x=A+20|0;y=c[x>>2]|0;if((y|0)!=0){B=x;A=y;continue}y=A+16|0;x=c[y>>2]|0;if((x|0)==0){break}else{A=x;B=y}}if(B>>>0<m>>>0){dd()}else{c[B>>2]=0;z=A;break}}else{y=c[a+(8-h)>>2]|0;if(y>>>0<m>>>0){dd()}x=y+12|0;if((c[x>>2]|0)!=(s|0)){dd()}w=u+8|0;if((c[w>>2]|0)==(s|0)){c[x>>2]=u;c[w>>2]=y;z=u;break}else{dd()}}}while(0);if((n|0)==0){o=k;p=l;break}u=c[a+(28-h)>>2]|0;m=161456+(u<<2)|0;do{if((s|0)==(c[m>>2]|0)){c[m>>2]=z;if((z|0)!=0){break}c[161156>>2]=c[161156>>2]&~(1<<u);o=k;p=l;break a}else{if(n>>>0<(c[161168>>2]|0)>>>0){dd()}j=n+16|0;if((c[j>>2]|0)==(s|0)){c[j>>2]=z}else{c[n+20>>2]=z}if((z|0)==0){o=k;p=l;break a}}}while(0);if(z>>>0<(c[161168>>2]|0)>>>0){dd()}c[z+24>>2]=n;s=16-h|0;u=c[a+s>>2]|0;do{if((u|0)!=0){if(u>>>0<(c[161168>>2]|0)>>>0){dd()}else{c[z+16>>2]=u;c[u+24>>2]=z;break}}}while(0);u=c[a+(s+4)>>2]|0;if((u|0)==0){o=k;p=l;break}if(u>>>0<(c[161168>>2]|0)>>>0){dd()}else{c[z+20>>2]=u;c[u+24>>2]=z;o=k;p=l;break}}else{o=a;p=b}}while(0);z=c[161168>>2]|0;if(e>>>0<z>>>0){dd()}A=a+(b+4)|0;B=c[A>>2]|0;do{if((B&2|0)==0){if((f|0)==(c[161176>>2]|0)){t=(c[161164>>2]|0)+p|0;c[161164>>2]=t;c[161176>>2]=o;c[o+4>>2]=t|1;if((o|0)!=(c[161172>>2]|0)){i=d;return}c[161172>>2]=0;c[161160>>2]=0;i=d;return}if((f|0)==(c[161172>>2]|0)){t=(c[161160>>2]|0)+p|0;c[161160>>2]=t;c[161172>>2]=o;c[o+4>>2]=t|1;c[o+t>>2]=t;i=d;return}t=(B&-8)+p|0;g=B>>>3;b:do{if(B>>>0<256){u=c[a+(b+8)>>2]|0;h=c[a+(b+12)>>2]|0;n=161192+(g<<1<<2)|0;do{if((u|0)!=(n|0)){if(u>>>0<z>>>0){dd()}if((c[u+12>>2]|0)==(f|0)){break}dd()}}while(0);if((h|0)==(u|0)){c[40288]=c[40288]&~(1<<g);break}do{if((h|0)==(n|0)){C=h+8|0}else{if(h>>>0<z>>>0){dd()}m=h+8|0;if((c[m>>2]|0)==(f|0)){C=m;break}dd()}}while(0);c[u+12>>2]=h;c[C>>2]=u}else{n=e;m=c[a+(b+24)>>2]|0;j=c[a+(b+12)>>2]|0;do{if((j|0)==(n|0)){q=a+(b+20)|0;r=q;y=c[q>>2]|0;if((y|0)==0){q=a+(b+16)|0;w=c[q>>2]|0;if((w|0)==0){D=0;break}else{E=w;F=q}}else{E=y;F=r}while(1){r=E+20|0;y=c[r>>2]|0;if((y|0)!=0){F=r;E=y;continue}y=E+16|0;r=c[y>>2]|0;if((r|0)==0){break}else{E=r;F=y}}if(F>>>0<z>>>0){dd()}else{c[F>>2]=0;D=E;break}}else{y=c[a+(b+8)>>2]|0;if(y>>>0<z>>>0){dd()}r=y+12|0;if((c[r>>2]|0)!=(n|0)){dd()}q=j+8|0;if((c[q>>2]|0)==(n|0)){c[r>>2]=j;c[q>>2]=y;D=j;break}else{dd()}}}while(0);if((m|0)==0){break}j=c[a+(b+28)>>2]|0;u=161456+(j<<2)|0;do{if((n|0)==(c[u>>2]|0)){c[u>>2]=D;if((D|0)!=0){break}c[161156>>2]=c[161156>>2]&~(1<<j);break b}else{if(m>>>0<(c[161168>>2]|0)>>>0){dd()}h=m+16|0;if((c[h>>2]|0)==(n|0)){c[h>>2]=D}else{c[m+20>>2]=D}if((D|0)==0){break b}}}while(0);if(D>>>0<(c[161168>>2]|0)>>>0){dd()}c[D+24>>2]=m;n=c[a+(b+16)>>2]|0;do{if((n|0)!=0){if(n>>>0<(c[161168>>2]|0)>>>0){dd()}else{c[D+16>>2]=n;c[n+24>>2]=D;break}}}while(0);n=c[a+(b+20)>>2]|0;if((n|0)==0){break}if(n>>>0<(c[161168>>2]|0)>>>0){dd()}else{c[D+20>>2]=n;c[n+24>>2]=D;break}}}while(0);c[o+4>>2]=t|1;c[o+t>>2]=t;if((o|0)!=(c[161172>>2]|0)){G=t;break}c[161160>>2]=t;i=d;return}else{c[A>>2]=B&-2;c[o+4>>2]=p|1;c[o+p>>2]=p;G=p}}while(0);p=G>>>3;if(G>>>0<256){B=p<<1;A=161192+(B<<2)|0;D=c[40288]|0;b=1<<p;do{if((D&b|0)==0){c[40288]=D|b;H=161192+(B+2<<2)|0;I=A}else{p=161192+(B+2<<2)|0;a=c[p>>2]|0;if(!(a>>>0<(c[161168>>2]|0)>>>0)){H=p;I=a;break}dd()}}while(0);c[H>>2]=o;c[I+12>>2]=o;c[o+8>>2]=I;c[o+12>>2]=A;i=d;return}A=o;I=G>>>8;do{if((I|0)==0){J=0}else{if(G>>>0>16777215){J=31;break}H=(I+1048320|0)>>>16&8;B=I<<H;b=(B+520192|0)>>>16&4;D=B<<b;B=(D+245760|0)>>>16&2;a=14-(b|H|B)+(D<<B>>>15)|0;J=G>>>(a+7|0)&1|a<<1}}while(0);I=161456+(J<<2)|0;c[o+28>>2]=J;c[o+20>>2]=0;c[o+16>>2]=0;a=c[161156>>2]|0;B=1<<J;if((a&B|0)==0){c[161156>>2]=a|B;c[I>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}B=c[I>>2]|0;if((J|0)==31){K=0}else{K=25-(J>>>1)|0}c:do{if((c[B+4>>2]&-8|0)==(G|0)){L=B}else{J=G<<K;I=B;while(1){M=I+16+(J>>>31<<2)|0;a=c[M>>2]|0;if((a|0)==0){break}if((c[a+4>>2]&-8|0)==(G|0)){L=a;break c}else{J=J<<1;I=a}}if(M>>>0<(c[161168>>2]|0)>>>0){dd()}c[M>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}}while(0);M=L+8|0;G=c[M>>2]|0;B=c[161168>>2]|0;if(L>>>0<B>>>0){dd()}if(G>>>0<B>>>0){dd()}c[G+12>>2]=A;c[M>>2]=A;c[o+8>>2]=G;c[o+12>>2]=L;c[o+24>>2]=0;i=d;return}function Pwa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(a|0)==0?1:a;while(1){e=Jwa(d)|0;if((e|0)!=0){f=6;break}a=c[40412]|0;c[40412]=0+a;if((a|0)==0){f=5;break}xe[a&7]()}if((f|0)==5){d=Dc(4)|0;c[d>>2]=161664;Ld(d|0,161712,135)}else if((f|0)==6){i=b;return e|0}return 0}function Qwa(a){a=a|0;var b=0,c=0;b=i;c=Pwa(a)|0;i=b;return c|0}function Rwa(a){a=a|0;var b=0;b=i;if((a|0)!=0){Kwa(a)}i=b;return}function Swa(a){a=a|0;var b=0;b=i;Rwa(a);i=b;return}function Twa(a){a=a|0;var b=0;b=i;yb(a|0);Rwa(a);i=b;return}function Uwa(a){a=a|0;var b=0;b=i;yb(a|0);i=b;return}function Vwa(a){a=a|0;i=i;return 161680}function Wwa(){var a=0;a=Dc(4)|0;c[a>>2]=161664;Ld(a|0,161712,135)}function Xwa(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0.0,tc=0,uc=0,vc=0.0,wc=0.0,xc=0.0,zc=0.0,Ac=0.0,Bc=0.0,Cc=0,Dc=0,Ec=0.0,Fc=0,Gc=0.0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0;g=i;i=i+512|0;h=g;if((e|0)==2){j=53;k=-1074}else if((e|0)==0){j=24;k=-149}else if((e|0)==1){j=53;k=-1074}else{l=0.0;i=g;return+l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n]|0}else{o=_wa(b)|0}}while((fd(o|0)|0)!=0);do{if((o|0)==43|(o|0)==45){n=1-(((o|0)==45)<<1)|0;p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;q=d[p]|0;r=n;break}else{q=_wa(b)|0;r=n;break}}else{q=o;r=1}}while(0);o=q;q=0;while(1){if((o|32|0)!=(a[161728+q|0]|0)){s=o;t=q;break}do{if(q>>>0<7){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;u=d[n]|0;break}else{u=_wa(b)|0;break}}else{u=o}}while(0);n=q+1|0;if(n>>>0<8){o=u;q=n}else{s=u;t=n;break}}do{if((t|0)==3){v=23}else if((t|0)!=8){u=(f|0)==0;if(!(t>>>0<4|u)){if((t|0)==8){break}else{v=23;break}}a:do{if((t|0)==0){q=s;o=0;while(1){if((q|32|0)!=(a[161744+o|0]|0)){w=q;x=o;break a}do{if(o>>>0<2){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;A=d[n]|0;break}else{A=_wa(b)|0;break}}else{A=q}}while(0);n=o+1|0;if(n>>>0<3){q=A;o=n}else{w=A;x=n;break}}}else{w=s;x=t}}while(0);if((x|0)==0){do{if((w|0)==48){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;B=d[o]|0}else{B=_wa(b)|0}if((B|32|0)!=120){if((c[m>>2]|0)==0){C=48;break}c[e>>2]=(c[e>>2]|0)+ -1;C=48;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=0}else{D=_wa(b)|0;E=0}while(1){if((D|0)==46){v=70;break}else if((D|0)!=48){F=0;G=0;H=0;I=0;K=D;L=E;M=0;N=0;O=1.0;P=0;Q=0.0;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=1;continue}else{D=_wa(b)|0;E=1;continue}}b:do{if((v|0)==70){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;R=d[o]|0}else{R=_wa(b)|0}if((R|0)==48){S=-1;T=-1}else{F=0;G=0;H=0;I=0;K=R;L=E;M=1;N=0;O=1.0;P=0;Q=0.0;break}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;V=d[o]|0}else{V=_wa(b)|0}if((V|0)!=48){F=S;G=T;H=0;I=0;K=V;L=1;M=1;N=0;O=1.0;P=0;Q=0.0;break b}o=vxa(S|0,T|0,-1,-1)|0;S=o;T=J}}}while(0);c:while(1){o=K+ -48|0;do{if(o>>>0<10){W=o;v=84}else{q=K|32;n=(K|0)==46;if(!((q+ -97|0)>>>0<6|n)){X=K;break c}if(n){if((M|0)==0){Y=H;Z=I;_=H;$=I;aa=L;ba=1;ca=N;da=O;ea=P;ga=Q;break}else{X=46;break c}}else{W=(K|0)>57?q+ -87|0:o;v=84;break}}}while(0);if((v|0)==84){v=0;do{if((I|0)<0|(I|0)==0&H>>>0<8){ha=N;ia=O;ja=W+(P<<4)|0;ka=Q}else{if((I|0)<0|(I|0)==0&H>>>0<14){la=O*.0625;ha=N;ia=la;ja=P;ka=Q+la*+(W|0);break}if(!((W|0)!=0&(N|0)==0)){ha=N;ia=O;ja=P;ka=Q;break}ha=1;ia=O;ja=P;ka=Q+O*.5}}while(0);o=vxa(H|0,I|0,1,0)|0;Y=F;Z=G;_=o;$=J;aa=1;ba=M;ca=ha;da=ia;ea=ja;ga=ka}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;F=Y;G=Z;H=_;I=$;K=d[o]|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}else{F=Y;G=Z;H=_;I=$;K=_wa(b)|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}}if((L|0)==0){o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}do{if(u){Zwa(b,0)}else{if(o){break}q=c[e>>2]|0;c[e>>2]=q+ -1;if((M|0)==0){break}c[e>>2]=q+ -2}}while(0);l=+(r|0)*0.0;i=g;return+l}o=(M|0)==0;q=o?H:F;n=o?I:G;if((I|0)<0|(I|0)==0&H>>>0<8){o=H;p=I;ma=P;while(1){na=ma<<4;oa=vxa(o|0,p|0,1,0)|0;pa=J;if((pa|0)<0|(pa|0)==0&oa>>>0<8){ma=na;p=pa;o=oa}else{qa=na;break}}}else{qa=P}do{if((X|32|0)==112){o=Ywa(b,f)|0;p=J;if(!((o|0)==0&(p|0)==-2147483648)){ra=o;sa=p;break}if(u){Zwa(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0;break}}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0}}while(0);p=qxa(q|0,n|0,2)|0;o=vxa(p|0,J|0,-32,-1)|0;p=vxa(o|0,J|0,ra|0,sa|0)|0;o=J;if((qa|0)==0){l=+(r|0)*0.0;i=g;return+l}if((o|0)>0|(o|0)==0&p>>>0>(0-k|0)>>>0){c[(Mc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}ma=k+ -106|0;na=((ma|0)<0)<<31>>31;if((o|0)<(na|0)|(o|0)==(na|0)&p>>>0<ma>>>0){c[(Mc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((qa|0)>-1){ma=p;na=o;oa=qa;la=Q;while(1){pa=oa<<1;if(!(la>=.5)){ta=la;ua=pa}else{ta=la+-1.0;ua=pa|1}va=la+ta;pa=vxa(ma|0,na|0,-1,-1)|0;wa=J;if((ua|0)>-1){ma=pa;na=wa;oa=ua;la=va}else{xa=pa;ya=wa;za=ua;Aa=va;break}}}else{xa=p;ya=o;za=qa;Aa=Q}oa=uxa(32,0,k|0,((k|0)<0)<<31>>31|0)|0;na=vxa(xa|0,ya|0,oa|0,J|0)|0;oa=J;if(0>(oa|0)|0==(oa|0)&j>>>0>na>>>0){Ba=(na|0)<0?0:na}else{Ba=j}do{if((Ba|0)<53){la=+(r|0);va=+Jd(+(+$wa(1.0,84-Ba|0)),+la);if(!((Ba|0)<32&Aa!=0.0)){Ca=la;Da=va;Ea=za;Fa=Aa;break}na=za&1;Ca=la;Da=va;Ea=(na^1)+za|0;Fa=(na|0)==0?0.0:Aa}else{Ca=+(r|0);Da=0.0;Ea=za;Fa=Aa}}while(0);va=Ca*Fa+(Da+Ca*+(Ea>>>0))-Da;if(!(va!=0.0)){c[(Mc()|0)>>2]=34}l=+axa(va,xa);i=g;return+l}else{C=w}}while(0);o=k+j|0;p=0-o|0;na=C;oa=0;while(1){if((na|0)==46){v=139;break}else if((na|0)!=48){Ga=na;Ha=0;Ia=0;Ja=oa;Ka=0;break}ma=c[e>>2]|0;if(ma>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ma+1;na=d[ma]|0;oa=1;continue}else{na=_wa(b)|0;oa=1;continue}}d:do{if((v|0)==139){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;La=d[na]|0}else{La=_wa(b)|0}if((La|0)==48){Ma=-1;Na=-1}else{Ga=La;Ha=0;Ia=0;Ja=oa;Ka=1;break}while(1){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;Oa=d[na]|0}else{Oa=_wa(b)|0}if((Oa|0)!=48){Ga=Oa;Ha=Ma;Ia=Na;Ja=1;Ka=1;break d}na=vxa(Ma|0,Na|0,-1,-1)|0;Ma=na;Na=J}}}while(0);oa=h;c[oa>>2]=0;na=Ga+ -48|0;ma=(Ga|0)==46;e:do{if(na>>>0<10|ma){n=h+496|0;q=Ga;wa=ma;pa=na;Pa=0;Qa=0;Ra=Ha;Sa=Ia;Ta=Ja;Ua=Ka;Va=0;Wa=0;Xa=0;while(1){do{if(wa){if((Ua|0)==0){Ya=Pa;Za=Qa;_a=Pa;$a=Qa;ab=Ta;bb=1;cb=Va;db=Wa;eb=Xa}else{fb=q;gb=Pa;hb=Qa;ib=Ra;jb=Sa;kb=Ta;lb=Va;mb=Wa;nb=Xa;break e}}else{ob=vxa(Pa|0,Qa|0,1,0)|0;pb=J;qb=(q|0)!=48;if((Wa|0)>=125){if(!qb){Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}c[n>>2]=c[n>>2]|1;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}rb=h+(Wa<<2)|0;if((Va|0)==0){sb=pa}else{sb=q+ -48+((c[rb>>2]|0)*10|0)|0}c[rb>>2]=sb;rb=Va+1|0;tb=(rb|0)==9;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=1;bb=Ua;cb=tb?0:rb;db=(tb&1)+Wa|0;eb=qb?ob:Xa}}while(0);ob=c[e>>2]|0;if(ob>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ob+1;ub=d[ob]|0}else{ub=_wa(b)|0}ob=ub+ -48|0;qb=(ub|0)==46;if(ob>>>0<10|qb){q=ub;wa=qb;pa=ob;Pa=_a;Qa=$a;Ra=Ya;Sa=Za;Ta=ab;Ua=bb;Va=cb;Wa=db;Xa=eb}else{vb=ub;wb=_a;xb=$a;yb=Ya;zb=Za;Ab=ab;Bb=bb;Cb=cb;Db=db;Eb=eb;v=162;break}}}else{vb=Ga;wb=0;xb=0;yb=Ha;zb=Ia;Ab=Ja;Bb=Ka;Cb=0;Db=0;Eb=0;v=162}}while(0);if((v|0)==162){na=(Bb|0)==0;fb=vb;gb=wb;hb=xb;ib=na?wb:yb;jb=na?xb:zb;kb=Ab;lb=Cb;mb=Db;nb=Eb}na=(kb|0)!=0;do{if(na){if((fb|32|0)!=101){v=171;break}ma=Ywa(b,f)|0;Xa=J;do{if((ma|0)==0&(Xa|0)==-2147483648){if(u){Zwa(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){Fb=0;Gb=0;break}c[e>>2]=(c[e>>2]|0)+ -1;Fb=0;Gb=0;break}}else{Fb=ma;Gb=Xa}}while(0);Xa=vxa(Fb|0,Gb|0,ib|0,jb|0)|0;Hb=Xa;Ib=J}else{v=171}}while(0);do{if((v|0)==171){if(!((fb|0)>-1)){Hb=ib;Ib=jb;break}if((c[m>>2]|0)==0){Hb=ib;Ib=jb;break}c[e>>2]=(c[e>>2]|0)+ -1;Hb=ib;Ib=jb}}while(0);if(!na){c[(Mc()|0)>>2]=22;Zwa(b,0);l=0.0;i=g;return+l}Xa=c[oa>>2]|0;if((Xa|0)==0){l=+(r|0)*0.0;i=g;return+l}do{if((Hb|0)==(gb|0)&(Ib|0)==(hb|0)&((hb|0)<0|(hb|0)==0&gb>>>0<10)){if(!(j>>>0>30)){if((Xa>>>j|0)!=0){break}}l=+(r|0)*+(Xa>>>0);i=g;return+l}}while(0);Xa=(k|0)/-2|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)>(na|0)|(Ib|0)==(na|0)&Hb>>>0>Xa>>>0){c[(Mc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}Xa=k+ -106|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)<(na|0)|(Ib|0)==(na|0)&Hb>>>0<Xa>>>0){c[(Mc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((lb|0)==0){Jb=mb}else{if((lb|0)<9){Xa=h+(mb<<2)|0;na=c[Xa>>2]|0;ma=lb;do{na=na*10|0;ma=ma+1|0;}while((ma|0)<9);c[Xa>>2]=na}Jb=mb+1|0}do{if((nb|0)<9){if(!((nb|0)<=(Hb|0)&(Hb|0)<18)){break}if((Hb|0)==9){l=+(r|0)*+((c[oa>>2]|0)>>>0);i=g;return+l}if((Hb|0)<9){l=+(r|0)*+((c[oa>>2]|0)>>>0)/+(c[161760+(8-Hb<<2)>>2]|0);i=g;return+l}ma=j+27+(fa(Hb,-3)|0)|0;Wa=c[oa>>2]|0;if((ma|0)<=30){if((Wa>>>ma|0)!=0){break}}l=+(r|0)*+(Wa>>>0)*+(c[161760+(Hb+ -10<<2)>>2]|0);i=g;return+l}}while(0);oa=(Hb|0)%9|0;if((oa|0)==0){Kb=0;Lb=0;Mb=Hb;Nb=Jb}else{na=(Hb|0)>-1?oa:oa+9|0;oa=c[161760+(8-na<<2)>>2]|0;do{if((Jb|0)==0){Ob=0;Pb=Hb;Qb=0}else{Xa=1e9/(oa|0)|0;Wa=0;ma=0;Va=0;Ua=Hb;while(1){Ta=h+(Va<<2)|0;Sa=c[Ta>>2]|0;Ra=((Sa>>>0)/(oa>>>0)|0)+ma|0;c[Ta>>2]=Ra;Rb=fa((Sa>>>0)%(oa>>>0)|0,Xa)|0;Sa=Va+1|0;if((Va|0)==(Wa|0)&(Ra|0)==0){Sb=Sa&127;Tb=Ua+ -9|0}else{Sb=Wa;Tb=Ua}if((Sa|0)==(Jb|0)){break}else{Wa=Sb;Ua=Tb;Va=Sa;ma=Rb}}if((Rb|0)==0){Ob=Sb;Pb=Tb;Qb=Jb;break}c[h+(Jb<<2)>>2]=Rb;Ob=Sb;Pb=Tb;Qb=Jb+1|0}}while(0);Kb=Ob;Lb=0;Mb=9-na+Pb|0;Nb=Qb}f:while(1){oa=h+(Kb<<2)|0;if((Mb|0)<18){ma=Lb;Va=Nb;while(1){Ua=0;Wa=Va+127|0;Xa=Va;while(1){Sa=Wa&127;Ra=h+(Sa<<2)|0;Ta=qxa(c[Ra>>2]|0,0,29)|0;Qa=vxa(Ta|0,J|0,Ua|0,0)|0;Ta=J;if(Ta>>>0>0|(Ta|0)==0&Qa>>>0>1e9){Pa=Fxa(Qa|0,Ta|0,1e9,0)|0;pa=Gxa(Qa|0,Ta|0,1e9,0)|0;Ub=pa;Vb=Pa}else{Ub=Qa;Vb=0}c[Ra>>2]=Ub;Ra=(Sa|0)==(Kb|0);if((Sa|0)!=(Xa+127&127|0)|Ra){Wb=Xa}else{Wb=(Ub|0)==0?Sa:Xa}if(Ra){break}else{Ua=Vb;Wa=Sa+ -1|0;Xa=Wb}}Xa=ma+ -29|0;if((Vb|0)==0){ma=Xa;Va=Wb}else{Xb=Xa;Yb=Vb;Zb=Wb;break}}}else{if((Mb|0)==18){_b=Lb;$b=Nb}else{ac=Kb;bc=Lb;cc=Mb;dc=Nb;break}while(1){if(!((c[oa>>2]|0)>>>0<9007199)){ac=Kb;bc=_b;cc=18;dc=$b;break f}Va=0;ma=$b+127|0;Xa=$b;while(1){Wa=ma&127;Ua=h+(Wa<<2)|0;Sa=qxa(c[Ua>>2]|0,0,29)|0;Ra=vxa(Sa|0,J|0,Va|0,0)|0;Sa=J;if(Sa>>>0>0|(Sa|0)==0&Ra>>>0>1e9){Qa=Fxa(Ra|0,Sa|0,1e9,0)|0;Pa=Gxa(Ra|0,Sa|0,1e9,0)|0;ec=Pa;fc=Qa}else{ec=Ra;fc=0}c[Ua>>2]=ec;Ua=(Wa|0)==(Kb|0);if((Wa|0)!=(Xa+127&127|0)|Ua){gc=Xa}else{gc=(ec|0)==0?Wa:Xa}if(Ua){break}else{Va=fc;ma=Wa+ -1|0;Xa=gc}}Xa=_b+ -29|0;if((fc|0)==0){_b=Xa;$b=gc}else{Xb=Xa;Yb=fc;Zb=gc;break}}}oa=Kb+127&127;if((oa|0)==(Zb|0)){Xa=Zb+127&127;ma=h+((Zb+126&127)<<2)|0;c[ma>>2]=c[ma>>2]|c[h+(Xa<<2)>>2];hc=Xa}else{hc=Zb}c[h+(oa<<2)>>2]=Yb;Kb=oa;Lb=Xb;Mb=Mb+9|0;Nb=hc}g:while(1){ic=dc+1&127;na=h+((dc+127&127)<<2)|0;oa=ac;Xa=bc;ma=cc;while(1){Va=(ma|0)==18;Wa=(ma|0)>27?9:1;jc=oa;kc=Xa;while(1){Ua=0;while(1){Ra=Ua+jc&127;if((Ra|0)==(dc|0)){lc=2;break}Qa=c[h+(Ra<<2)>>2]|0;Ra=c[161752+(Ua<<2)>>2]|0;if(Qa>>>0<Ra>>>0){lc=2;break}Pa=Ua+1|0;if(Qa>>>0>Ra>>>0){lc=Ua;break}if((Pa|0)<2){Ua=Pa}else{lc=Pa;break}}if((lc|0)==2&Va){break g}mc=Wa+kc|0;if((jc|0)==(dc|0)){jc=dc;kc=mc}else{break}}Va=(1<<Wa)+ -1|0;Ua=1e9>>>Wa;nc=jc;oc=0;Pa=jc;pc=ma;do{Ra=h+(Pa<<2)|0;Qa=c[Ra>>2]|0;Sa=(Qa>>>Wa)+oc|0;c[Ra>>2]=Sa;oc=fa(Qa&Va,Ua)|0;Qa=(Pa|0)==(nc|0)&(Sa|0)==0;Pa=Pa+1&127;pc=Qa?pc+ -9|0:pc;nc=Qa?Pa:nc;}while((Pa|0)!=(dc|0));if((oc|0)==0){oa=nc;Xa=mc;ma=pc;continue}if((ic|0)!=(nc|0)){break}c[na>>2]=c[na>>2]|1;oa=nc;Xa=mc;ma=pc}c[h+(dc<<2)>>2]=oc;ac=nc;bc=mc;cc=pc;dc=ic}ma=jc&127;if((ma|0)==(dc|0)){c[h+(ic+ -1<<2)>>2]=0;qc=ic}else{qc=dc}va=+((c[h+(ma<<2)>>2]|0)>>>0);ma=jc+1&127;if((ma|0)==(qc|0)){Xa=qc+1&127;c[h+(Xa+ -1<<2)>>2]=0;rc=Xa}else{rc=qc}la=+(r|0);sc=la*(va*1.0e9+ +((c[h+(ma<<2)>>2]|0)>>>0));ma=kc+53|0;Xa=ma-k|0;if((Xa|0)<(j|0)){tc=(Xa|0)<0?0:Xa;uc=1}else{tc=j;uc=0}if((tc|0)<53){va=+Jd(+(+$wa(1.0,105-tc|0)),+sc);vc=+yc(+sc,+(+$wa(1.0,53-tc|0)));wc=va;xc=vc;zc=va+(sc-vc)}else{wc=0.0;xc=0.0;zc=sc}oa=jc+2&127;do{if((oa|0)==(rc|0)){Ac=xc}else{na=c[h+(oa<<2)>>2]|0;do{if(na>>>0<5e8){if((na|0)==0){if((jc+3&127|0)==(rc|0)){Bc=xc;break}}Bc=la*.25+xc}else{if(na>>>0>5e8){Bc=la*.75+xc;break}if((jc+3&127|0)==(rc|0)){Bc=la*.5+xc;break}else{Bc=la*.75+xc;break}}}while(0);if((53-tc|0)<=1){Ac=Bc;break}if(+yc(+Bc,1.0)!=0.0){Ac=Bc;break}Ac=Bc+1.0}}while(0);la=zc+Ac-wc;do{if((ma&2147483647|0)>(-2-o|0)){if(!(+U(+la)>=9007199254740992.0)){Cc=uc;Dc=kc;Ec=la}else{Cc=(uc|0)!=0&(tc|0)==(Xa|0)?0:uc;Dc=kc+1|0;Ec=la*.5}if((Dc+50|0)<=(p|0)){if(!((Cc|0)!=0&Ac!=0.0)){Fc=Dc;Gc=Ec;break}}c[(Mc()|0)>>2]=34;Fc=Dc;Gc=Ec}else{Fc=kc;Gc=la}}while(0);l=+axa(Gc,Fc);i=g;return+l}else if((x|0)==3){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Hc=d[p]|0}else{Hc=_wa(b)|0}if((Hc|0)==40){Ic=1}else{if((c[m>>2]|0)==0){l=+y;i=g;return+l}c[e>>2]=(c[e>>2]|0)+ -1;l=+y;i=g;return+l}while(1){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Jc=d[p]|0}else{Jc=_wa(b)|0}if(!((Jc+ -48|0)>>>0<10|(Jc+ -65|0)>>>0<26)){if(!((Jc+ -97|0)>>>0<26|(Jc|0)==95)){break}}Ic=Ic+1|0}if((Jc|0)==41){l=+y;i=g;return+l}p=(c[m>>2]|0)==0;if(!p){c[e>>2]=(c[e>>2]|0)+ -1}if(u){c[(Mc()|0)>>2]=22;Zwa(b,0);l=0.0;i=g;return+l}if((Ic|0)==0|p){l=+y;i=g;return+l}else{Kc=Ic}while(1){p=Kc+ -1|0;c[e>>2]=(c[e>>2]|0)+ -1;if((p|0)==0){l=+y;break}else{Kc=p}}i=g;return+l}else{if((c[m>>2]|0)!=0){c[e>>2]=(c[e>>2]|0)+ -1}c[(Mc()|0)>>2]=22;Zwa(b,0);l=0.0;i=g;return+l}}}while(0);do{if((v|0)==23){b=(c[m>>2]|0)==0;if(!b){c[e>>2]=(c[e>>2]|0)+ -1}if(t>>>0<4|(f|0)==0|b){break}else{Lc=t}do{c[e>>2]=(c[e>>2]|0)+ -1;Lc=Lc+ -1|0;}while(Lc>>>0>3)}}while(0);l=+(r|0)*+z;i=g;return+l}function Ywa(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g]|0}else{j=_wa(a)|0}do{if((j|0)==43|(j|0)==45){g=(j|0)==45|0;k=c[f>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[f>>2]=k+1;l=d[k]|0}else{l=_wa(a)|0}if((l+ -48|0)>>>0<10|(b|0)==0){m=l;n=g;break}if((c[h>>2]|0)==0){m=l;n=g;break}c[f>>2]=(c[f>>2]|0)+ -1;m=l;n=g}else{m=j;n=0}}while(0);if((m+ -48|0)>>>0>9){if((c[h>>2]|0)==0){o=0;p=-2147483648;J=p;i=e;return o|0}c[f>>2]=(c[f>>2]|0)+ -1;o=0;p=-2147483648;J=p;i=e;return o|0}else{q=m;r=0}while(1){s=q+ -48+r|0;m=c[f>>2]|0;if(m>>>0<(c[h>>2]|0)>>>0){c[f>>2]=m+1;t=d[m]|0}else{t=_wa(a)|0}if(!((t+ -48|0)>>>0<10&(s|0)<214748364)){break}q=t;r=s*10|0}r=((s|0)<0)<<31>>31;if((t+ -48|0)>>>0<10){q=s;m=r;j=t;while(1){l=Exa(q|0,m|0,10,0)|0;b=J;g=vxa(j|0,((j|0)<0)<<31>>31|0,-48,-1)|0;k=vxa(g|0,J|0,l|0,b|0)|0;b=J;l=c[f>>2]|0;if(l>>>0<(c[h>>2]|0)>>>0){c[f>>2]=l+1;u=d[l]|0}else{u=_wa(a)|0}if((u+ -48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&k>>>0<2061584302)){j=u;m=b;q=k}else{v=k;w=b;x=u;break}}}else{v=s;w=r;x=t}if((x+ -48|0)>>>0<10){do{x=c[f>>2]|0;if(x>>>0<(c[h>>2]|0)>>>0){c[f>>2]=x+1;y=d[x]|0}else{y=_wa(a)|0}}while((y+ -48|0)>>>0<10)}if((c[h>>2]|0)!=0){c[f>>2]=(c[f>>2]|0)+ -1}f=(n|0)!=0;n=uxa(0,0,v|0,w|0)|0;o=f?n:v;p=f?J:w;J=p;i=e;return o|0}function Zwa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if((b|0)!=0&(g|0)>(b|0)){c[a+100>>2]=f+b;i=d;return}else{c[a+100>>2]=e;i=d;return}}function _wa(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+104|0;g=c[f>>2]|0;if((g|0)==0){h=3}else{if((c[b+108>>2]|0)<(g|0)){h=3}}do{if((h|0)==3){g=cxa(b)|0;if((g|0)<0){break}j=c[f>>2]|0;k=c[b+8>>2]|0;do{if((j|0)==0){h=8}else{l=c[b+4>>2]|0;m=j-(c[b+108>>2]|0)+ -1|0;if((k-l|0)<=(m|0)){h=8;break}c[b+100>>2]=l+m}}while(0);if((h|0)==8){c[b+100>>2]=k}j=c[b+4>>2]|0;if((k|0)!=0){m=b+108|0;c[m>>2]=k+1-j+(c[m>>2]|0)}m=j+ -1|0;if((d[m]|0|0)==(g|0)){n=g;i=e;return n|0}a[m]=g;n=g;i=e;return n|0}}while(0);c[b+100>>2]=0;n=-1;i=e;return n|0}function $wa(a,b){a=+a;b=b|0;var d=0,e=0.0,f=0,g=0,j=0.0;d=i;do{if((b|0)>1023){e=a*8.98846567431158e+307;f=b+ -1023|0;if((f|0)<=1023){g=f;j=e;break}f=b+ -2046|0;g=(f|0)>1023?1023:f;j=e*8.98846567431158e+307}else{if(!((b|0)<-1022)){g=b;j=a;break}e=a*1.2882297539194267e-231;f=b+1022|0;if(!((f|0)<-1022)){g=f;j=e;break}f=b+2044|0;g=(f|0)<-1022?-1022:f;j=e*1.2882297539194267e-231}}while(0);b=qxa(g+1023|0,0,52)|0;g=J;c[k>>2]=b;c[k+4>>2]=g;a=j*+h[k>>3];i=d;return+a}function axa(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+$wa(a,b);i=c;return+d}function bxa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+74|0;f=a[e]|0;a[e]=f+ -1<<24>>24|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0){de[c[b+36>>2]&63](b,0,0)|0}c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=b;g=c[f>>2]|0;if((g&20|0)==0){h=c[e>>2]|0;c[b+8>>2]=h;c[b+4>>2]=h;j=0;i=d;return j|0}if((g&4|0)==0){j=-1;i=d;return j|0}c[f>>2]=g|32;j=-1;i=d;return j|0}function cxa(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+8|0;e=b;do{if((c[a+8>>2]|0)==0){if((bxa(a)|0)==0){break}else{f=-1}i=b;return f|0}}while(0);if((de[c[a+32>>2]&63](a,e,1)|0)!=1){f=-1;i=b;return f|0}f=d[e]|0;i=b;return f|0}function dxa(a){a=a|0;var b=0,c=0.0;b=i;c=+exa(a,0);i=b;return+c}function exa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;Zwa(e,0);h=+Xwa(e,1,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function fxa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;Zwa(e,0);h=+Xwa(e,2,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function gxa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)==0){f=0;i=e;return f|0}else{g=d;h=b;j=c}while(1){k=a[h]|0;l=a[j]|0;if(!(k<<24>>24==l<<24>>24)){break}c=g+ -1|0;if((c|0)==0){f=0;m=5;break}else{g=c;h=h+1|0;j=j+1|0}}if((m|0)==5){i=e;return f|0}f=(k&255)-(l&255)|0;i=e;return f|0}function hxa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a[b]|0;f=a[c]|0;if(e<<24>>24!=f<<24>>24|e<<24>>24==0|f<<24>>24==0){g=e;h=f;j=g&255;k=h&255;l=j-k|0;i=d;return l|0}else{m=b;n=c}while(1){c=m+1|0;b=n+1|0;f=a[c]|0;e=a[b]|0;if(f<<24>>24!=e<<24>>24|f<<24>>24==0|e<<24>>24==0){g=f;h=e;break}else{n=b;m=c}}j=g&255;k=h&255;l=j-k|0;i=d;return l|0}function ixa(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;if((e|0)==0){g=0;i=f;return g|0}h=a[b]|0;a:do{if(h<<24>>24==0){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){p=l+ -1|0;q=a[o]|0;if(!((p|0)!=0&q<<24>>24!=0&m<<24>>24==q<<24>>24)){j=m;k=o;break a}q=n+1|0;r=o+1|0;s=a[q]|0;if(s<<24>>24==0){j=0;k=r;break}else{m=s;n=q;o=r;l=p}}}}while(0);g=(j&255)-(d[k]|0)|0;i=f;return g|0}function jxa(){c[35516]=p;c[35558]=p;c[40200]=p;c[40430]=p}function kxa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;w=w+1|0;c[a>>2]=w;while((e|0)<40){if((c[d+(e<<2)>>2]|0)==0){c[d+(e<<2)>>2]=w;c[d+((e<<2)+4)>>2]=b;c[d+((e<<2)+8)>>2]=0;return 0}e=e+2|0}dc(116);dc(111);dc(111);dc(32);dc(109);dc(97);dc(110);dc(121);dc(32);dc(115);dc(101);dc(116);dc(106);dc(109);dc(112);dc(115);dc(32);dc(105);dc(110);dc(32);dc(97);dc(32);dc(102);dc(117);dc(110);dc(99);dc(116);dc(105);dc(111);dc(110);dc(32);dc(99);dc(97);dc(108);dc(108);dc(44);dc(32);dc(98);dc(117);dc(105);dc(108);dc(100);dc(32);dc(119);dc(105);dc(116);dc(104);dc(32);dc(97);dc(32);dc(104);dc(105);dc(103);dc(104);dc(101);dc(114);dc(32);dc(118);dc(97);dc(108);dc(117);dc(101);dc(32);dc(102);dc(111);dc(114);dc(32);dc(77);dc(65);dc(88);dc(95);dc(83);dc(69);dc(84);dc(74);dc(77);dc(80);dc(83);dc(10);ga(0);return 0}function lxa(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function mxa(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function nxa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return lb(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function oxa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{nxa(b,c,d)|0}return b|0}function pxa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function qxa(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function rxa(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function sxa(a){a=a|0;var b=0;b=(fa(c[a>>2]|0,31010991)|0)+1735287159&2147483647;c[a>>2]=b;return b|0}function txa(){return sxa(o)|0}function uxa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(J=e,a-c>>>0|0)|0}function vxa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function wxa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e|0]=f?0:a[c+e|0]|0;f=f?1:(a[c+e|0]|0)==0;e=e+1|0}return b|0}function xxa(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function yxa(a,b){a=a|0;b=b|0;var d=0,e=0;while((d|0)<20){e=c[b+(d<<2)>>2]|0;if((e|0)==0)break;if((e|0)==(a|0)){return c[b+((d<<2)+4)>>2]|0}d=d+2|0}return 0}function zxa(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function Axa(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function Bxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=fa(d,c)|0;f=a>>>16;a=(e>>>16)+(fa(d,f)|0)|0;d=b>>>16;b=fa(d,c)|0;return(J=(a>>>16)+(fa(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function Cxa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=uxa(e^a,f^b,e,f)|0;b=J;a=g^e;e=h^f;f=uxa((Hxa(i,b,uxa(g^c,h^d,g,h)|0,J,0)|0)^a,J^e,a,e)|0;return(J=J,f)|0}function Dxa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=uxa(h^a,j^b,h,j)|0;b=J;Hxa(m,b,uxa(k^d,l^e,k,l)|0,J,g)|0;l=uxa(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=J;i=f;return(J=j,l)|0}function Exa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=Bxa(e,a)|0;f=J;return(J=(fa(b,a)|0)+(fa(d,e)|0)+f|f&0,c|0|0)|0}function Fxa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Hxa(a,b,c,d,0)|0;return(J=J,e)|0}function Gxa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;Hxa(a,b,d,e,g)|0;i=f;return(J=c[g+4>>2]|0,c[g>>2]|0)|0}function Hxa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(J=n,o)|0}else{if(!m){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(J=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(J=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(J=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((Axa(l|0)|0)>>>0);return(J=n,o)|0}p=(zxa(l|0)|0)-(zxa(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}else{if(!m){r=(zxa(l|0)|0)-(zxa(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(zxa(j|0)|0)+33-(zxa(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(J=n,o)|0}else{p=Axa(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(J=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=vxa(g,d,-1,-1)|0;k=J;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;uxa(e,k,j,a)|0;b=J;h=b>>31|((b|0)<0?-1:0)<<1;K=h&1;L=uxa(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=J;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=K}}B=H;C=I;D=M;E=L;F=0;G=K}K=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(K|0)>>>31|(B|C)<<1|(C<<1|K>>>31)&0|F;o=(K<<1|0>>>31)&-2|G;return(J=n,o)|0}function Ixa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Vd[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function Jxa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Wd[a&31](b|0,c|0,d|0,e|0,f|0)}function Kxa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return Xd[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function Lxa(a,b){a=a|0;b=+b;Yd[a&1](+b)}function Mxa(a,b){a=a|0;b=b|0;Zd[a&1023](b|0)}function Nxa(a,b,c){a=a|0;b=b|0;c=c|0;_d[a&127](b|0,c|0)}function Oxa(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return $d[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function Pxa(a,b){a=a|0;b=b|0;return ae[a&127](b|0)|0}function Qxa(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;return be[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0)|0}function Rxa(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ce[a&1](b|0,+c,d|0,e|0)}function Sxa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return de[a&63](b|0,c|0,d|0)|0}function Txa(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;return ee[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0)|0}function Uxa(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;return fe[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0)|0}function Vxa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ge[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function Wxa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;he[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function Xxa(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;return ie[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0,x|0,y|0)|0}function Yxa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;je[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function Zxa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;ke[a&3](b|0,c|0,+d,e|0,f|0)}function _xa(a,b,c){a=a|0;b=b|0;c=+c;return le[a&1](b|0,+c)|0}function $xa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;me[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function aya(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;ne[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function bya(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;oe[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function cya(a,b,c){a=a|0;b=b|0;c=c|0;return pe[a&63](b|0,c|0)|0}function dya(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return qe[a&63](b|0,c|0,d|0,e|0,f|0)|0}function eya(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return re[a&1](b|0,c|0,d|0,e|0,+f,g|0)|0}function fya(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;return+se[a&1](b|0,+c,+d)}function gya(a,b,c){a=a|0;b=b|0;c=c|0;return+te[a&1](b|0,c|0)}function hya(a){a=a|0;return ue[a&7]()|0}function iya(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return ve[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function jya(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;we[a&15](b|0,c|0,d|0)}function kya(a){a=a|0;xe[a&7]()}function lya(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return ye[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function mya(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ze[a&63](b|0,c|0,d|0,e|0)|0}function nya(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ae[a&63](b|0,c|0,d|0,e|0)}function oya(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(0);return 0}function pya(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(1)}function qya(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ga(2);return 0}function rya(a){a=+a;ga(3)}function sya(a){a=a|0;ga(4)}function tya(a){a=a|0;ud(a|0)}function uya(a,b){a=a|0;b=b|0;ga(5)}function vya(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ga(6);return 0}function wya(a){a=a|0;ga(7);return 0}function xya(a){a=a|0;return Nc(a|0)|0}function yya(a){a=a|0;return Dd(a|0)|0}function zya(a){a=a|0;return vc(a|0)|0}function Aya(a){a=a|0;return sd(a|0)|0}function Bya(a){a=a|0;return hd(a|0)|0}function Cya(a){a=a|0;return nd(a|0)|0}function Dya(a){a=a|0;return Wc(a|0)|0}function Eya(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;ga(8);return 0}function Fya(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;ga(9)}function Gya(a,b,c){a=a|0;b=b|0;c=c|0;ga(10);return 0}function Hya(a,b,c){a=a|0;b=b|0;c=c|0;return pd(a|0,b|0,c|0)|0}function Iya(a,b,c){a=a|0;b=b|0;c=c|0;return hc(a|0,b|0,c|0)|0}function Jya(a,b,c){a=a|0;b=b|0;c=c|0;return bc(a|0,b|0,c|0)|0}function Kya(a,b,c){a=a|0;b=b|0;c=c|0;return td(a|0,b|0,c|0)|0}function Lya(a,b,c){a=a|0;b=b|0;c=c|0;return qd(a|0,b|0,c|0)|0}function Mya(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;ga(11);return 0}function Nya(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;ga(12);return 0}function Oya(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ga(13)}function Pya(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(14)}function Qya(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;ga(15);return 0}function Rya(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ga(16)}function Sya(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ga(17)}function Tya(a,b){a=a|0;b=+b;ga(18);return 0}function Uya(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(19)}function Vya(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ga(20)}function Wya(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(21)}function Xya(a,b){a=a|0;b=b|0;ga(22);return 0}function Yya(a,b){a=a|0;b=b|0;return Id(a|0,b|0)|0}function Zya(a,b){a=a|0;b=b|0;return gc(a|0,b|0)|0}function _ya(a,b){a=a|0;b=b|0;return hb(a|0,b|0)|0}function $ya(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(23);return 0}function aza(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ga(24);return 0}function bza(a,b,c){a=a|0;b=+b;c=+c;ga(25);return 0.0}function cza(a,b){a=a|0;b=b|0;ga(26);return 0.0}function dza(){ga(27);return 0}function eza(){return ib()|0}function fza(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(28);return 0}function gza(a,b,c){a=a|0;b=b|0;c=c|0;ga(29)}function hza(){ga(30)}function iza(){Tc()}function jza(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(31);return 0}function kza(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(32);return 0}function lza(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return qc(a|0,b|0,c|0,d|0)|0}function mza(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Lc(a|0,b|0,c|0,d|0)|0}function nza(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(33)}




// EMSCRIPTEN_END_FUNCS
var Vd=[oya,K4,M4,R4,Mja,oya,oya,oya];var Wd=[pya,P_,Q_,t$,u$,Y$,Z$,u0,v0,w0,Fwa,Ewa,Dwa,h_,i_,W1,U1,pya,pya,pya,pya,pya,pya,pya,pya,pya,pya,pya,pya,pya,pya,pya];var Xd=[qya,q6];var Yd=[rya,w5];var Zd=[sya,am,bm,aD,bD,XN,dD,R1,C8,F8,E8,G8,Koa,Joa,Moa,Loa,H8,J8,Vba,pca,qca,rca,voa,uoa,xoa,woa,ija,vja,wja,xja,zja,Bja,rla,sla,yla,zla,Fla,Gla,Mla,Nla,Zla,Yla,cma,bma,ema,fma,oma,nma,vna,una,Ena,Dna,goa,foa,Eoa,Doa,Goa,Foa,Yoa,Xoa,_oa,Zoa,epa,dpa,tna,fpa,cpa,gpa,ipa,hpa,qta,opa,npa,tpa,spa,Spa,Rpa,uqa,tqa,Iqa,Hqa,Wqa,Vqa,ira,hra,vra,ura,yra,xra,Cra,Bra,Nra,Mra,Yra,Xra,hsa,gsa,ssa,rsa,Csa,Bsa,Ksa,Jsa,Qsa,Psa,Wsa,Vsa,$sa,_sa,ita,hta,Gta,Fta,dta,Xta,Cua,Bua,Eua,Dua,jpa,pta,sta,Pta,dua,oua,zua,Aua,qwa,pwa,swa,vwa,twa,uwa,wwa,xwa,Uwa,Twa,Pl,tya,cm,dm,em,fm,gm,hm,im,jm,km,lm,mm,nm,om,pm,qm,tm,um,vm,wm,xm,ym,zm,Am,Bm,Cm,Dm,Em,Fm,Gm,Hm,Im,Jm,Km,Lm,Mm,Nm,Om,Pm,Qm,Rm,Sm,Tm,Um,Vm,Wm,Xm,Ym,Zm,_m,$m,an,bn,cn,dn,en,fn,gn,hn,jn,kn,ln,mn,nn,on,pn,qn,rn,sn,tn,un,vn,wn,xn,yn,zn,An,Bn,Cn,Dn,En,Fn,Gn,Hn,In,Jn,Kn,Ln,Mn,Nn,On,Pn,Qn,Rn,Sn,Tn,Un,Vn,Wn,Xn,Yn,Zn,_n,$n,ao,bo,co,eo,fo,go,ho,io,jo,ko,lo,mo,no,oo,po,qo,ro,so,to,uo,vo,wo,xo,yo,zo,Ao,Bo,Co,Do,Eo,Fo,Go,Ho,Io,Jo,Ko,Lo,Mo,No,Oo,Po,Qo,Ro,So,To,Uo,Vo,Wo,Xo,Yo,Zo,_o,$o,ap,bp,cp,dp,ep,fp,gp,hp,ip,jp,kp,lp,mp,np,op,pp,qp,rp,sp,tp,up,vp,wp,xp,yp,zp,Ap,Bp,Cp,Dp,Ep,Fp,Gp,Hp,Ip,Jp,Kp,Lp,Mp,Np,Op,Pp,Qp,Rp,Sp,Tp,Up,Vp,Wp,Xp,Yp,Zp,_p,$p,aq,bq,cq,dq,eq,fq,gq,hq,iq,jq,kq,lq,mq,nq,oq,pq,qq,rq,sq,tq,uq,vq,wq,xq,yq,zq,Aq,Bq,Cq,Dq,Eq,Fq,Gq,Hq,Iq,Jq,Kq,Lq,Mq,Nq,Oq,Pq,Qq,Rq,Sq,Tq,Uq,Vq,Wq,Xq,Yq,Zq,_q,$q,ar,br,cr,dr,er,fr,gr,hr,ir,jr,kr,lr,mr,nr,or,pr,qr,rr,sr,tr,ur,vr,wr,xr,yr,zr,Ar,Br,Cr,Dr,Er,Fr,Gr,Hr,Ir,Jr,Kr,Lr,Mr,Nr,Or,Pr,Qr,Rr,Sr,Tr,Ur,Vr,Wr,Xr,Yr,Zr,_r,$r,as,bs,cs,ds,es,fs,gs,hs,is,js,ks,ls,ms,ns,os,ps,qs,rs,ss,ts,us,vs,ws,xs,ys,zs,As,Bs,Cs,Ds,Es,Hs,Is,Js,Ks,Ls,Ms,Ns,Os,Ps,Qs,Rs,Ss,Ts,Us,Vs,Ys,Zs,_s,$s,at,bt,ct,dt,et,ft,gt,ht,it,jt,kt,nt,ot,pt,qt,rt,st,tt,ut,vt,wt,xt,yt,zt,At,Bt,Et,Ft,Gt,Ht,It,Jt,Kt,Lt,Mt,Nt,Ot,Pt,Qt,Rt,St,Vt,Wt,Xt,Yt,Zt,_t,$t,au,bu,cu,du,eu,fu,gu,hu,ku,lu,mu,nu,ou,pu,qu,ru,su,tu,uu,vu,wu,xu,yu,Xe,Ye,Ze,_e,$e,af,bf,cf,df,ef,ff,gf,hf,jf,kf,lf,mf,nf,of,pf,qf,rf,sf,tf,uf,vf,wf,xf,yf,zf,Af,Bf,Cf,Df,Ef,Ff,Gf,Hf,If,Jf,Kf,Lf,Mf,Nf,Of,Pf,Qf,Rf,Sf,Tf,Uf,Vf,Wf,Xf,Yf,Zf,_f,$f,ag,bg,cg,dg,eg,fg,gg,hg,ig,jg,kg,lg,mg,ng,og,pg,qg,rg,sg,tg,ug,vg,wg,xg,yg,zg,Ag,Bg,Cg,Dg,Eg,Fg,Gg,Hg,Ig,Jg,Kg,Lg,Mg,Ng,Og,Pg,Qg,Rg,Sg,Tg,Ug,Vg,Wg,Xg,Yg,Zg,_g,$g,ah,bh,ch,dh,eh,fh,gh,hh,ih,jh,kh,lh,mh,nh,oh,ph,qh,rh,sh,th,uh,vh,wh,xh,yh,zh,Ah,Bh,Ch,Dh,Eh,Fh,Gh,Hh,Ih,Jh,Kh,Lh,Mh,Nh,Oh,Ph,Qh,Rh,Sh,Th,Uh,Vh,Wh,Xh,Yh,Zh,_h,$h,ai,bi,ci,di,ei,fi,gi,hi,ii,ji,ki,li,mi,ni,oi,pi,qi,ri,si,ti,ui,vi,wi,xi,yi,zi,Ai,Bi,Ci,Di,Ei,Fi,Gi,Hi,Ii,Ji,Ki,Li,Mi,Ni,Oi,Pi,Qi,Ri,Si,Ti,Ui,Vi,Wi,Xi,Yi,Zi,_i,$i,aj,bj,cj,dj,ej,fj,gj,hj,ij,jj,kj,lj,mj,nj,oj,pj,qj,rj,sj,tj,uj,vj,wj,xj,yj,zj,Aj,Bj,Cj,Dj,Ej,Fj,Gj,Hj,Ij,Jj,Kj,Lj,Mj,Nj,Oj,Pj,Qj,Rj,Sj,Tj,Uj,Vj,Wj,Xj,Yj,Zj,_j,$j,ak,bk,ck,dk,ek,fk,gk,hk,ik,jk,kk,lk,mk,nk,ok,pk,qk,rk,sk,tk,uk,vk,wk,xk,yk,zk,Ak,Bk,Ck,Dk,Ek,Fk,Gk,Hk,Ik,Jk,Kk,Lk,Mk,Nk,Ok,Pk,Qk,Rk,Sk,Tk,Uk,Vk,Wk,Xk,Yk,Zk,_k,$k,al,bl,cl,dl,el,fl,gl,hl,il,jl,kl,ll,ml,nl,ol,pl,ql,rl,sl,tl,ul,vl,wl,xl,yl,Bl,Cl,Dl,El,Fl,Gl,Hl,Il,Jl,Kl,Kwa,T1,Re,g5,k5,f5,t6,m5,r6,K3,p5,n5,o5,l5,r5,s6,s5,h5,u5,Via,v5,Rka,qla,rta,kva,usa,rva,qva,pva,ova,nva,mva,Ema,gna,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya,sya];var _d=[uya,cD,_6,K8,Vna,tla,Ala,Hla,Ola,hoa,Fra,Gra,Hra,Ira,Kra,Lra,Qra,Rra,Sra,Tra,Vra,Wra,$ra,asa,bsa,csa,esa,fsa,ksa,lsa,msa,nsa,psa,qsa,Zsa,cta,Jua,Lua,Nua,Kua,Mua,Oua,Z4,rm,Fs,Ws,lt,Ct,Tt,iu,zu,Qu,fv,vB,MB,bC,sC,JC,_C,q5,Bba,a7,$6,b7,h7,t7,c7,r7,Qaa,aba,$aa,bba,Laa,Jaa,Naa,_ja,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya,uya];var $d=[vya,w_,p_,L4,N4,O4,P4,Q4];var ae=[wya,Ml,hY,Ll,Te,Ue,Ve,YN,ZN,jD,WN,gY,jY,iD,gD,kY,lY,mY,nY,oY,pY,qY,rY,sY,tY,xya,yya,zya,z2,Jwa,Aya,O8,_na,P8,boa,Zna,Eja,ula,moa,ooa,poa,loa,Bla,Cla,Ila,aoa,Pla,Qla,_la,dma,apa,Xqa,Pua,Rua,Tua,Zua,$ua,Vua,Xua,jra,Qua,Sua,Uua,_ua,ava,Wua,Yua,Dra,Era,Jra,Ora,Pra,Ura,Zra,_ra,dsa,isa,jsa,osa,$ta,aua,cua,Fua,Hua,Gua,Iua,Tta,Uta,Wta,jua,kua,nua,uua,vua,yua,rwa,Vwa,A6,Bya,Cya,y6,z6,Dya,Oia,nja,z5,H5,Q5,A5,K5,R5,ila,cxa,wya,wya,wya,wya,wya,wya,wya,wya,wya,wya,wya,wya,wya,wya,wya];var be=[Eya,u4];var ce=[Fya,p3];var de=[Gya,fD,G_,M_,k$,q$,P$,V$,L8,$na,doa,Wna,ioa,noa,vla,roa,Jla,ima,jma,mpa,rpa,Xsa,ata,Ita,Kta,Nta,tta,yta,Ata,Dta,ywa,Xia,k3,t_,k_,r_,x_,Hya,Iya,Jya,u6,Uia,Qia,Kya,ala,Lya,Gya,Gya,Gya,Gya,Gya,Gya,Gya,Gya,Gya,Gya,Gya,Gya,Gya,Gya,Gya,Gya,Gya,Gya];var ee=[Mya,y4];var fe=[Nya,S3];var ge=[Oya,Cqa,Fqa,Qqa,Sqa,Oya,Oya,Oya];var he=[Pya,wra,zra,tsa,xsa,Dsa,Fsa,Pya];var ie=[Qya,s4];var je=[Rya,O1,M8,Cja,joa,Xna,vqa,wqa,Aqa,Gqa,Jqa,Kqa,Oqa,Tqa,Ysa,bta,Iwa,Hwa,Gwa,P1,Rya,Rya,Rya,Rya,Rya,Rya,Rya,Rya,Rya,Rya,Rya,Rya];var ke=[Sya,I5,J5,Sya];var le=[Tya,Ol];var me=[Uya,upa,wpa,ypa,Apa,Cpa,Epa,Gpa,Ipa,Kpa,Mpa,Opa,Tpa,Vpa,Xpa,Zpa,$pa,bqa,dqa,fqa,hqa,jqa,lqa,zqa,Bqa,Nqa,Pqa,Yqa,Zqa,_qa,$qa,ara,kra,lra,mra,nra,ora,Osa,Usa,Uya,Uya,Uya,Uya,Uya,Uya,Uya,Uya,Uya,Uya,Uya,Uya,Uya,Uya,Uya,Uya,Uya,Uya,Uya,Uya,Uya,Uya,Uya,Uya,Uya];var ne=[Vya,Lsa,Rsa,Vya];var oe=[Wya,bra,pra,Wya];var pe=[Xya,Se,kD,hD,eD,uY,vY,I_,J_,L_,m$,n$,p$,R$,S$,U$,_$,$$,a0,b0,c0,d0,e0,f0,Q8,R8,Fja,Gja,qoa,wla,Dla,soa,coa,Kla,Rla,eoa,Hta,Jta,Lta,xta,zta,Bta,i6,T5,L5,B5,S5,Yya,Mwa,e_,f_,g_,Zya,j2,k2,P2,E5,e6,X5,G5,_ya,bwa,Xya,Xya];var qe=[$ya,kpa,ppa,Ota,_ta,bua,Eta,Sta,Vta,iua,lua,tua,wua,C0,t1,u1,H0,E0,r1,s1,I0,J0,K0,L0,M0,h1,i1,_0,T0,O0,N0,P0,Q0,S0,R0,F0,D0,U0,V0,W0,X0,Y0,Z0,$0,a1,b1,c1,g1,e1,d1,f1,n1,j1,k1,l1,m1,o1,p1,q1,v1,w1,x1,y1,xqa];var re=[aza,F6];var se=[bza,U5];var te=[cza,a4];var ue=[dza,xY,eza,A2,nla,ola,lla,dza];var ve=[fza,x4];var we=[gza,Zia,hma,bpa,b3,e2,Z1,V6,X6,Aba,Zja,gza,gza,gza,gza,gza];var xe=[hza,iza,y2,B1,Rl,hza,hza,hza];var ye=[jza,wY,Yta,Zta,Qta,Rta,eua,gua,pua,rua,Y5,jza,jza,jza,jza,jza];var ze=[kza,A_,B_,C_,D_,E_,F_,H_,K_,O_,e$,f$,g$,h$,i$,j$,l$,o$,s$,J$,K$,L$,M$,N$,O$,Q$,T$,X$,Mta,uta,vta,wta,Cta,$4,c2,lza,t4,YZ,$Y,uZ,DZ,pZ,MZ,RZ,PZ,SZ,y_,c_,m_,n_,u_,v_,Qpa,Dqa,mza,kza,kza,kza,kza,kza,kza,kza,kza,kza];var Ae=[nza,N_,r$,W$,N8,Yia,Dja,koa,Yna,lpa,qpa,zwa,Awa,Bwa,X1,V1,b5,b2,Y1,sm,Gs,Xs,mt,Dt,Ut,ju,Au,Ru,gv,wB,NB,cC,tC,KC,$C,ska,o_,_1,nza,nza,nza,nza,nza,nza,nza,nza,nza,nza,nza,nza,nza,nza,nza,nza,nza,nza,nza,nza,nza,nza,nza,nza,nza,nza];return{_testSetjmp:yxa,_saveSetjmp:kxa,_free:Kwa,_main:Ql,_rand_r:sxa,_realloc:Mwa,_i64Add:vxa,_memmove:oxa,_bitshift64Ashr:mxa,_memset:pxa,_malloc:Jwa,_strncpy:wxa,_memcpy:nxa,_strlen:lxa,_bitshift64Lshr:xxa,_bitshift64Shl:qxa,_i64Subtract:uxa,_strcpy:rxa,_calloc:Lwa,_rand:txa,__GLOBAL__I_a:Tla,runPostSets:jxa,stackAlloc:Be,stackSave:Ce,stackRestore:De,setThrew:Ee,setTempRet0:He,setTempRet1:Ie,setTempRet2:Je,setTempRet3:Ke,setTempRet4:Le,setTempRet5:Me,setTempRet6:Ne,setTempRet7:Oe,setTempRet8:Pe,setTempRet9:Qe,dynCall_iiiiiiii:Ixa,dynCall_viiiii:Jxa,dynCall_iiiiidiii:Kxa,dynCall_vd:Lxa,dynCall_vi:Mxa,dynCall_vii:Nxa,dynCall_iiiiiiiiiii:Oxa,dynCall_ii:Pxa,dynCall_iiiiiiiiiiiiii:Qxa,dynCall_vidii:Rxa,dynCall_iiii:Sxa,dynCall_iiiiiiiiiiiiiiiiiiiiiii:Txa,dynCall_iiiiiiiiiiiiiiiiiiiii:Uxa,dynCall_viiiiid:Vxa,dynCall_viiiiiiii:Wxa,dynCall_iiiiiiiiiiiiiiiiiiiiiiiii:Xxa,dynCall_viiiiii:Yxa,dynCall_viidii:Zxa,dynCall_iid:_xa,dynCall_viiiiiii:$xa,dynCall_viiiiiid:aya,dynCall_viiiiiiiii:bya,dynCall_iii:cya,dynCall_iiiiii:dya,dynCall_iiiiidi:eya,dynCall_didd:fya,dynCall_dii:gya,dynCall_i:hya,dynCall_iiiiiiiiii:iya,dynCall_viii:jya,dynCall_v:kya,dynCall_iiiiiiiii:lya,dynCall_iiiii:mya,dynCall_viiii:nya}})


// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_viiiii": invoke_viiiii, "invoke_iiiiidiii": invoke_iiiiidiii, "invoke_vd": invoke_vd, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiiiiiii": invoke_iiiiiiiiiii, "invoke_ii": invoke_ii, "invoke_iiiiiiiiiiiiii": invoke_iiiiiiiiiiiiii, "invoke_vidii": invoke_vidii, "invoke_iiii": invoke_iiii, "invoke_iiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_viidii": invoke_viidii, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_iii": invoke_iii, "invoke_iiiiii": invoke_iiiiii, "invoke_iiiiidi": invoke_iiiiidi, "invoke_didd": invoke_didd, "invoke_dii": invoke_dii, "invoke_i": invoke_i, "invoke_iiiiiiiiii": invoke_iiiiiiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_fabs": _fabs, "_strrchr": _strrchr, "_pthread_key_create": _pthread_key_create, "_vsscanf": _vsscanf, "__ZSt9terminatev": __ZSt9terminatev, "___cxa_guard_acquire": ___cxa_guard_acquire, "__reallyNegative": __reallyNegative, "_fstat": _fstat, "_pclose": _pclose, "_lis_solver_create": _lis_solver_create, "___assert_fail": ___assert_fail, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "_longjmp": _longjmp, "__isLeapYear": __isLeapYear, "_clock_gettime": _clock_gettime, "_fsync": _fsync, "_signal": _signal, "_GC_collect_a_little": _GC_collect_a_little, "_sbrk": _sbrk, "_strtoull": _strtoull, "_emscripten_memcpy_big": _emscripten_memcpy_big, "__parseInt64": __parseInt64, "_close": _close, "_rewind": _rewind, "_cos": _cos, "_fileno": _fileno, "_fread": _fread, "_puts": _puts, "_isatty": _isatty, "_lis_matrix_set_value": _lis_matrix_set_value, "_write": _write, "_isblank": _isblank, "_ftell": _ftell, "__ZNSt9exceptionD2Ev": __ZNSt9exceptionD2Ev, "_xerbla_": _xerbla_, "_round": _round, "___cxa_does_inherit": ___cxa_does_inherit, "_strtoll_l": _strtoll_l, "_strstr": _strstr, "___cxa_rethrow": ___cxa_rethrow, "_llvm_lifetime_end": _llvm_lifetime_end, "_catclose": _catclose, "_tmpnam": _tmpnam, "_lis_vector_destroy": _lis_vector_destroy, "_lis_solver_set_option": _lis_solver_set_option, "_tmpfile": _tmpfile, "_send": _send, "_pow": _pow, "_atan2": _atan2, "___cxa_is_number_type": ___cxa_is_number_type, "___cxa_free_exception": ___cxa_free_exception, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_isxdigit_l": _isxdigit_l, "___cxa_guard_release": ___cxa_guard_release, "_truncate": _truncate, "_strtol": _strtol, "_sin": _sin, "_strtok": _strtok, "___setErrNo": ___setErrNo, "_newlocale": _newlocale, "_isdigit_l": _isdigit_l, "___resumeException": ___resumeException, "_freelocale": _freelocale, "_srand": _srand, "_fscanf": _fscanf, "_qsort": _qsort, "_putchar": _putchar, "_floor": _floor, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_printf": _printf, "_sprintf": _sprintf, "_fopen": _fopen, "_vasprintf": _vasprintf, "_emscripten_get_now": _emscripten_get_now, "_stat": _stat, "_vsnprintf": _vsnprintf, "_strtoull_l": _strtoull_l, "_read": _read, "__addDays": __addDays, "_fwrite": _fwrite, "_time": _time, "_pthread_mutex_lock": _pthread_mutex_lock, "_catopen": _catopen, "_exit": _exit, "_GC_strdup": _GC_strdup, "_freopen": _freopen, "___ctype_b_loc": ___ctype_b_loc, "_fmod": _fmod, "_strtok_r": _strtok_r, "_lseek": _lseek, "_access": _access, "_vfprintf": _vfprintf, "___cxa_allocate_exception": ___cxa_allocate_exception, "_atoi": _atoi, "_strtoll": _strtoll, "_pwrite": _pwrite, "_localtime_r": _localtime_r, "_tzset": _tzset, "_open": _open, "_uselocale": _uselocale, "_snprintf": _snprintf, "___errno_location": ___errno_location, "_GC_malloc": _GC_malloc, "___cxa_end_catch": ___cxa_end_catch, "_perror": _perror, "___cxa_begin_catch": ___cxa_begin_catch, "_strftime": _strftime, "_ftruncate": _ftruncate, "_GC_init": _GC_init, "_fseek": _fseek, "_isxdigit": _isxdigit, "_fclose": _fclose, "__parseInt": __parseInt, "_log": _log, "_pthread_cond_broadcast": _pthread_cond_broadcast, "_popen": _popen, "_recv": _recv, "_fgetc": _fgetc, "_sysconf": _sysconf, "__getFloat": __getFloat, "_abort": _abort, "_ceil": _ceil, "_isspace": _isspace, "_localtime": _localtime, "_pthread_getspecific": _pthread_getspecific, "_pthread_cond_wait": _pthread_cond_wait, "_llvm_lifetime_start": _llvm_lifetime_start, "_ungetc": _ungetc, "_system": _system, "_fmax": _fmax, "_fflush": _fflush, "_strftime_l": _strftime_l, "_fprintf": _fprintf, "_sscanf": _sscanf, "_catgets": _catgets, "_strdup": _strdup, "_asprintf": _asprintf, "__exit": __exit, "___ctype_toupper_loc": ___ctype_toupper_loc, "_bsearch": _bsearch, "__arraySum": __arraySum, "__formatString": __formatString, "_htonl": _htonl, "___ctype_tolower_loc": ___ctype_tolower_loc, "_unlink": _unlink, "_fputs": _fputs, "_GC_malloc_atomic": _GC_malloc_atomic, "_pread": _pread, "_lis_vector_set_size": _lis_vector_set_size, "_mkport": _mkport, "__scanString": __scanString, "_pthread_setspecific": _pthread_setspecific, "_copysign": _copysign, "_fputc": _fputc, "___cxa_throw": ___cxa_throw, "_lis_solver_destroy": _lis_solver_destroy, "_isdigit": _isdigit, "_strerror": _strerror, "_emscripten_longjmp": _emscripten_longjmp, "_lis_vector_create": _lis_vector_create, "_atexit": _atexit, "_sqrt": _sqrt, "_strerror_r": _strerror_r, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "___rand_seed": ___rand_seed, "NaN": NaN, "Infinity": Infinity, "__ZTISt9exception": __ZTISt9exception, "___dso_handle": ___dso_handle, "_stderr": _stderr, "_stdin": _stdin, "_stdout": _stdout }, buffer);
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _rand_r = Module["_rand_r"] = asm["_rand_r"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _rand = Module["_rand"] = asm["_rand"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_iiiiidiii = Module["dynCall_iiiiidiii"] = asm["dynCall_iiiiidiii"];
var dynCall_vd = Module["dynCall_vd"] = asm["dynCall_vd"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiiiiiii = Module["dynCall_iiiiiiiiiii"] = asm["dynCall_iiiiiiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_iiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiii"];
var dynCall_vidii = Module["dynCall_vidii"] = asm["dynCall_vidii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_viidii = Module["dynCall_viidii"] = asm["dynCall_viidii"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiidi = Module["dynCall_iiiiidi"] = asm["dynCall_iiiiidi"];
var dynCall_didd = Module["dynCall_didd"] = asm["dynCall_didd"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];

Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };


// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======



// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}






